#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 19881
#define LARGE_STATE_COUNT 9618
#define SYMBOL_COUNT 217
#define ALIAS_COUNT 3
#define TOKEN_COUNT 109
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 7
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 25

enum ts_symbol_identifiers {
  sym__word_identifier = 1,
  anon_sym_EQ = 2,
  anon_sym_COMMA = 3,
  anon_sym_COLON = 4,
  anon_sym_begin = 5,
  anon_sym_module = 6,
  anon_sym_baremodule = 7,
  anon_sym_end = 8,
  anon_sym_abstract = 9,
  anon_sym_type = 10,
  anon_sym_primitive = 11,
  anon_sym_mutable = 12,
  anon_sym_struct = 13,
  anon_sym_LT_COLON = 14,
  anon_sym_function = 15,
  anon_sym_macro = 16,
  anon_sym_where = 17,
  anon_sym_quote = 18,
  anon_sym_let = 19,
  anon_sym_if = 20,
  anon_sym_elseif = 21,
  anon_sym_else = 22,
  anon_sym_try = 23,
  anon_sym_catch = 24,
  anon_sym_finally = 25,
  anon_sym_for = 26,
  anon_sym_while = 27,
  sym_break_statement = 28,
  sym_continue_statement = 29,
  anon_sym_return = 30,
  anon_sym_const = 31,
  anon_sym_global = 32,
  anon_sym_local = 33,
  anon_sym_as = 34,
  aux_sym_import_path_token1 = 35,
  anon_sym_LPAREN = 36,
  anon_sym_RPAREN = 37,
  anon_sym_COLON2 = 38,
  anon_sym_export = 39,
  anon_sym_import = 40,
  anon_sym_using = 41,
  anon_sym_LBRACK = 42,
  anon_sym_RBRACK = 43,
  anon_sym_LF = 44,
  anon_sym_outer = 45,
  anon_sym_in = 46,
  anon_sym_u2208 = 47,
  anon_sym_SEMI = 48,
  anon_sym_LBRACE = 49,
  anon_sym_RBRACE = 50,
  anon_sym_SQUOTE = 51,
  anon_sym_DOT = 52,
  anon_sym_do = 53,
  anon_sym_DOLLAR = 54,
  anon_sym_COLON_COLON = 55,
  anon_sym_COLON_EQ = 56,
  anon_sym_DOT_EQ = 57,
  aux_sym_quote_expression_token1 = 58,
  anon_sym_isa = 59,
  anon_sym_DOT_DOT_DOT = 60,
  anon_sym_QMARK = 61,
  anon_sym_DASH_GT = 62,
  anon_sym_AT = 63,
  anon_sym_true = 64,
  anon_sym_false = 65,
  aux_sym_integer_literal_token1 = 66,
  aux_sym_integer_literal_token2 = 67,
  aux_sym_integer_literal_token3 = 68,
  aux_sym_integer_literal_token4 = 69,
  aux_sym_float_literal_token1 = 70,
  aux_sym_float_literal_token2 = 71,
  aux_sym_float_literal_token3 = 72,
  aux_sym_float_literal_token4 = 73,
  sym_escape_sequence = 74,
  sym_character_literal = 75,
  sym__assignment_operator = 76,
  sym__pair_operator = 77,
  sym__arrow_operator = 78,
  sym__lazy_or_operator = 79,
  sym__lazy_and_operator = 80,
  sym__comparison_operator = 81,
  sym__pipe_right_operator = 82,
  sym__pipe_left_operator = 83,
  sym__ellipsis_operator = 84,
  sym__plus_operator = 85,
  sym__times_operator = 86,
  sym__rational_operator = 87,
  sym__bitshift_operator = 88,
  sym__power_operator = 89,
  sym__tilde_operator = 90,
  sym__type_order_operator = 91,
  sym__unary_operator = 92,
  sym__unary_plus_operator = 93,
  sym__syntactic_operator = 94,
  aux_sym__terminator_token1 = 95,
  sym_line_comment = 96,
  sym_block_comment = 97,
  sym__immediate_paren = 98,
  sym__immediate_bracket = 99,
  sym__immediate_brace = 100,
  sym__string_start = 101,
  sym__command_start = 102,
  sym__immediate_string_start = 103,
  sym__immediate_command_start = 104,
  sym__string_end = 105,
  sym__command_end = 106,
  sym__string_content = 107,
  sym__string_content_no_interp = 108,
  sym_source_file = 109,
  sym__block = 110,
  sym_assignment = 111,
  sym__closed_assignment = 112,
  sym_open_tuple = 113,
  sym__expression = 114,
  sym_module_definition = 115,
  sym_abstract_definition = 116,
  sym_primitive_definition = 117,
  sym_struct_definition = 118,
  sym_type_clause = 119,
  sym_function_definition = 120,
  sym_macro_definition = 121,
  sym_signature = 122,
  sym_where_clause = 123,
  sym_compound_statement = 124,
  sym_quote_statement = 125,
  sym_let_statement = 126,
  sym_if_statement = 127,
  sym_elseif_clause = 128,
  sym_else_clause = 129,
  sym_try_statement = 130,
  sym_catch_clause = 131,
  sym_finally_clause = 132,
  sym_for_statement = 133,
  sym_while_statement = 134,
  sym_return_statement = 135,
  sym_const_statement = 136,
  sym_global_statement = 137,
  sym_local_statement = 138,
  sym_import_alias = 139,
  sym_import_path = 140,
  sym__exportable = 141,
  sym__importable = 142,
  sym__import_list = 143,
  sym_selected_import = 144,
  sym_export_statement = 145,
  sym_import_statement = 146,
  sym__primary_expression = 147,
  sym__array = 148,
  sym_comprehension_expression = 149,
  sym__comprehension_clause = 150,
  sym_if_clause = 151,
  sym_for_clause = 152,
  sym_for_binding = 153,
  sym_matrix_expression = 154,
  sym_matrix_row = 155,
  sym_vector_expression = 156,
  sym_parenthesized_expression = 157,
  sym_tuple_expression = 158,
  sym_curly_expression = 159,
  sym_adjoint_expression = 160,
  sym_field_expression = 161,
  sym_index_expression = 162,
  sym_parametrized_type_expression = 163,
  sym_call_expression = 164,
  sym_broadcast_call_expression = 165,
  sym__closed_macrocall_expression = 166,
  sym_macrocall_expression = 167,
  sym_macro_argument_list = 168,
  sym_argument_list = 169,
  sym_do_clause = 170,
  sym__do_parameter_list = 171,
  sym_named_field = 172,
  sym_interpolation_expression = 173,
  sym_quote_expression = 174,
  sym_binary_expression = 175,
  sym_unary_expression = 176,
  sym_range_expression = 177,
  sym_splat_expression = 178,
  sym_ternary_expression = 179,
  sym_typed_expression = 180,
  sym_unary_typed_expression = 181,
  sym_function_expression = 182,
  sym_juxtaposition_expression = 183,
  sym_compound_assignment_expression = 184,
  sym_where_expression = 185,
  sym_macro_identifier = 186,
  sym_scoped_identifier = 187,
  sym_identifier = 188,
  sym_boolean_literal = 189,
  sym_integer_literal = 190,
  sym_float_literal = 191,
  sym__string = 192,
  sym_string_literal = 193,
  sym_command_literal = 194,
  sym_prefixed_string_literal = 195,
  sym_prefixed_command_literal = 196,
  sym_string_interpolation = 197,
  sym_operator = 198,
  aux_sym__block_repeat1 = 199,
  aux_sym_open_tuple_repeat1 = 200,
  aux_sym_let_statement_repeat1 = 201,
  aux_sym_if_statement_repeat1 = 202,
  aux_sym_for_statement_repeat1 = 203,
  aux_sym__import_list_repeat1 = 204,
  aux_sym_export_statement_repeat1 = 205,
  aux_sym__comprehension_clause_repeat1 = 206,
  aux_sym_matrix_expression_repeat1 = 207,
  aux_sym_matrix_row_repeat1 = 208,
  aux_sym_vector_expression_repeat1 = 209,
  aux_sym_parenthesized_expression_repeat1 = 210,
  aux_sym_tuple_expression_repeat1 = 211,
  aux_sym_macro_argument_list_repeat1 = 212,
  aux_sym_argument_list_repeat1 = 213,
  aux_sym__do_parameter_list_repeat1 = 214,
  aux_sym_string_literal_repeat1 = 215,
  aux_sym_prefixed_string_literal_repeat1 = 216,
  alias_sym_let_binding = 217,
  alias_sym_named_argument = 218,
  alias_sym_type_parameter_list = 219,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__word_identifier] = "_word_identifier",
  [anon_sym_EQ] = "=",
  [anon_sym_COMMA] = ",",
  [anon_sym_COLON] = ":",
  [anon_sym_begin] = "begin",
  [anon_sym_module] = "module",
  [anon_sym_baremodule] = "baremodule",
  [anon_sym_end] = "end",
  [anon_sym_abstract] = "abstract",
  [anon_sym_type] = "type",
  [anon_sym_primitive] = "primitive",
  [anon_sym_mutable] = "mutable",
  [anon_sym_struct] = "struct",
  [anon_sym_LT_COLON] = "operator",
  [anon_sym_function] = "function",
  [anon_sym_macro] = "macro",
  [anon_sym_where] = "where",
  [anon_sym_quote] = "quote",
  [anon_sym_let] = "let",
  [anon_sym_if] = "if",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_for] = "for",
  [anon_sym_while] = "while",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [anon_sym_return] = "return",
  [anon_sym_const] = "const",
  [anon_sym_global] = "global",
  [anon_sym_local] = "local",
  [anon_sym_as] = "as",
  [aux_sym_import_path_token1] = "import_path_token1",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COLON2] = ":",
  [anon_sym_export] = "export",
  [anon_sym_import] = "import",
  [anon_sym_using] = "using",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LF] = "\n",
  [anon_sym_outer] = "outer",
  [anon_sym_in] = "in",
  [anon_sym_u2208] = "\u2208",
  [anon_sym_SEMI] = ";",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_DOT] = ".",
  [anon_sym_do] = "do",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COLON_EQ] = "operator",
  [anon_sym_DOT_EQ] = "operator",
  [aux_sym_quote_expression_token1] = "identifier",
  [anon_sym_isa] = "operator",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "\?",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_AT] = "@",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [aux_sym_integer_literal_token1] = "integer_literal_token1",
  [aux_sym_integer_literal_token2] = "integer_literal_token2",
  [aux_sym_integer_literal_token3] = "integer_literal_token3",
  [aux_sym_integer_literal_token4] = "integer_literal_token4",
  [aux_sym_float_literal_token1] = "float_literal_token1",
  [aux_sym_float_literal_token2] = "float_literal_token2",
  [aux_sym_float_literal_token3] = "float_literal_token3",
  [aux_sym_float_literal_token4] = "float_literal_token4",
  [sym_escape_sequence] = "escape_sequence",
  [sym_character_literal] = "character_literal",
  [sym__assignment_operator] = "operator",
  [sym__pair_operator] = "_pair_operator",
  [sym__arrow_operator] = "_arrow_operator",
  [sym__lazy_or_operator] = "operator",
  [sym__lazy_and_operator] = "operator",
  [sym__comparison_operator] = "_comparison_operator",
  [sym__pipe_right_operator] = "_pipe_right_operator",
  [sym__pipe_left_operator] = "_pipe_left_operator",
  [sym__ellipsis_operator] = "_ellipsis_operator",
  [sym__plus_operator] = "_plus_operator",
  [sym__times_operator] = "_times_operator",
  [sym__rational_operator] = "_rational_operator",
  [sym__bitshift_operator] = "_bitshift_operator",
  [sym__power_operator] = "_power_operator",
  [sym__tilde_operator] = "_tilde_operator",
  [sym__type_order_operator] = "_type_order_operator",
  [sym__unary_operator] = "_unary_operator",
  [sym__unary_plus_operator] = "_unary_plus_operator",
  [sym__syntactic_operator] = "operator",
  [aux_sym__terminator_token1] = "_terminator_token1",
  [sym_line_comment] = "line_comment",
  [sym_block_comment] = "block_comment",
  [sym__immediate_paren] = "_immediate_paren",
  [sym__immediate_bracket] = "_immediate_bracket",
  [sym__immediate_brace] = "_immediate_brace",
  [sym__string_start] = "_string_start",
  [sym__command_start] = "_command_start",
  [sym__immediate_string_start] = "_immediate_string_start",
  [sym__immediate_command_start] = "_immediate_command_start",
  [sym__string_end] = "_string_end",
  [sym__command_end] = "_command_end",
  [sym__string_content] = "_string_content",
  [sym__string_content_no_interp] = "_string_content_no_interp",
  [sym_source_file] = "source_file",
  [sym__block] = "_block",
  [sym_assignment] = "assignment",
  [sym__closed_assignment] = "assignment",
  [sym_open_tuple] = "open_tuple",
  [sym__expression] = "_expression",
  [sym_module_definition] = "module_definition",
  [sym_abstract_definition] = "abstract_definition",
  [sym_primitive_definition] = "primitive_definition",
  [sym_struct_definition] = "struct_definition",
  [sym_type_clause] = "type_clause",
  [sym_function_definition] = "function_definition",
  [sym_macro_definition] = "macro_definition",
  [sym_signature] = "signature",
  [sym_where_clause] = "where_clause",
  [sym_compound_statement] = "compound_statement",
  [sym_quote_statement] = "quote_statement",
  [sym_let_statement] = "let_statement",
  [sym_if_statement] = "if_statement",
  [sym_elseif_clause] = "elseif_clause",
  [sym_else_clause] = "else_clause",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_return_statement] = "return_statement",
  [sym_const_statement] = "const_statement",
  [sym_global_statement] = "global_statement",
  [sym_local_statement] = "local_statement",
  [sym_import_alias] = "import_alias",
  [sym_import_path] = "import_path",
  [sym__exportable] = "_exportable",
  [sym__importable] = "_importable",
  [sym__import_list] = "_import_list",
  [sym_selected_import] = "selected_import",
  [sym_export_statement] = "export_statement",
  [sym_import_statement] = "import_statement",
  [sym__primary_expression] = "_primary_expression",
  [sym__array] = "_array",
  [sym_comprehension_expression] = "comprehension_expression",
  [sym__comprehension_clause] = "_comprehension_clause",
  [sym_if_clause] = "if_clause",
  [sym_for_clause] = "for_clause",
  [sym_for_binding] = "for_binding",
  [sym_matrix_expression] = "matrix_expression",
  [sym_matrix_row] = "matrix_row",
  [sym_vector_expression] = "vector_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_curly_expression] = "curly_expression",
  [sym_adjoint_expression] = "adjoint_expression",
  [sym_field_expression] = "field_expression",
  [sym_index_expression] = "index_expression",
  [sym_parametrized_type_expression] = "parametrized_type_expression",
  [sym_call_expression] = "call_expression",
  [sym_broadcast_call_expression] = "broadcast_call_expression",
  [sym__closed_macrocall_expression] = "macrocall_expression",
  [sym_macrocall_expression] = "macrocall_expression",
  [sym_macro_argument_list] = "macro_argument_list",
  [sym_argument_list] = "argument_list",
  [sym_do_clause] = "do_clause",
  [sym__do_parameter_list] = "argument_list",
  [sym_named_field] = "named_field",
  [sym_interpolation_expression] = "interpolation_expression",
  [sym_quote_expression] = "quote_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_range_expression] = "range_expression",
  [sym_splat_expression] = "splat_expression",
  [sym_ternary_expression] = "ternary_expression",
  [sym_typed_expression] = "typed_expression",
  [sym_unary_typed_expression] = "unary_typed_expression",
  [sym_function_expression] = "function_expression",
  [sym_juxtaposition_expression] = "juxtaposition_expression",
  [sym_compound_assignment_expression] = "compound_assignment_expression",
  [sym_where_expression] = "where_expression",
  [sym_macro_identifier] = "macro_identifier",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_identifier] = "identifier",
  [sym_boolean_literal] = "boolean_literal",
  [sym_integer_literal] = "integer_literal",
  [sym_float_literal] = "float_literal",
  [sym__string] = "_string",
  [sym_string_literal] = "string_literal",
  [sym_command_literal] = "command_literal",
  [sym_prefixed_string_literal] = "prefixed_string_literal",
  [sym_prefixed_command_literal] = "prefixed_command_literal",
  [sym_string_interpolation] = "string_interpolation",
  [sym_operator] = "operator",
  [aux_sym__block_repeat1] = "_block_repeat1",
  [aux_sym_open_tuple_repeat1] = "open_tuple_repeat1",
  [aux_sym_let_statement_repeat1] = "let_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym__comprehension_clause_repeat1] = "_comprehension_clause_repeat1",
  [aux_sym_matrix_expression_repeat1] = "matrix_expression_repeat1",
  [aux_sym_matrix_row_repeat1] = "matrix_row_repeat1",
  [aux_sym_vector_expression_repeat1] = "vector_expression_repeat1",
  [aux_sym_parenthesized_expression_repeat1] = "parenthesized_expression_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_macro_argument_list_repeat1] = "macro_argument_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym__do_parameter_list_repeat1] = "_do_parameter_list_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_prefixed_string_literal_repeat1] = "prefixed_string_literal_repeat1",
  [alias_sym_let_binding] = "let_binding",
  [alias_sym_named_argument] = "named_argument",
  [alias_sym_type_parameter_list] = "type_parameter_list",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__word_identifier] = sym__word_identifier,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_baremodule] = anon_sym_baremodule,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_primitive] = anon_sym_primitive,
  [anon_sym_mutable] = anon_sym_mutable,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_LT_COLON] = sym_operator,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_macro] = anon_sym_macro,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_quote] = anon_sym_quote,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_while] = anon_sym_while,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_as] = anon_sym_as,
  [aux_sym_import_path_token1] = aux_sym_import_path_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COLON2] = anon_sym_COLON,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_outer] = anon_sym_outer,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_u2208] = anon_sym_u2208,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_COLON_EQ] = sym_operator,
  [anon_sym_DOT_EQ] = sym_operator,
  [aux_sym_quote_expression_token1] = sym_identifier,
  [anon_sym_isa] = sym_operator,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [aux_sym_integer_literal_token1] = aux_sym_integer_literal_token1,
  [aux_sym_integer_literal_token2] = aux_sym_integer_literal_token2,
  [aux_sym_integer_literal_token3] = aux_sym_integer_literal_token3,
  [aux_sym_integer_literal_token4] = aux_sym_integer_literal_token4,
  [aux_sym_float_literal_token1] = aux_sym_float_literal_token1,
  [aux_sym_float_literal_token2] = aux_sym_float_literal_token2,
  [aux_sym_float_literal_token3] = aux_sym_float_literal_token3,
  [aux_sym_float_literal_token4] = aux_sym_float_literal_token4,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_character_literal] = sym_character_literal,
  [sym__assignment_operator] = sym_operator,
  [sym__pair_operator] = sym__pair_operator,
  [sym__arrow_operator] = sym__arrow_operator,
  [sym__lazy_or_operator] = sym_operator,
  [sym__lazy_and_operator] = sym_operator,
  [sym__comparison_operator] = sym__comparison_operator,
  [sym__pipe_right_operator] = sym__pipe_right_operator,
  [sym__pipe_left_operator] = sym__pipe_left_operator,
  [sym__ellipsis_operator] = sym__ellipsis_operator,
  [sym__plus_operator] = sym__plus_operator,
  [sym__times_operator] = sym__times_operator,
  [sym__rational_operator] = sym__rational_operator,
  [sym__bitshift_operator] = sym__bitshift_operator,
  [sym__power_operator] = sym__power_operator,
  [sym__tilde_operator] = sym__tilde_operator,
  [sym__type_order_operator] = sym__type_order_operator,
  [sym__unary_operator] = sym__unary_operator,
  [sym__unary_plus_operator] = sym__unary_plus_operator,
  [sym__syntactic_operator] = sym_operator,
  [aux_sym__terminator_token1] = aux_sym__terminator_token1,
  [sym_line_comment] = sym_line_comment,
  [sym_block_comment] = sym_block_comment,
  [sym__immediate_paren] = sym__immediate_paren,
  [sym__immediate_bracket] = sym__immediate_bracket,
  [sym__immediate_brace] = sym__immediate_brace,
  [sym__string_start] = sym__string_start,
  [sym__command_start] = sym__command_start,
  [sym__immediate_string_start] = sym__immediate_string_start,
  [sym__immediate_command_start] = sym__immediate_command_start,
  [sym__string_end] = sym__string_end,
  [sym__command_end] = sym__command_end,
  [sym__string_content] = sym__string_content,
  [sym__string_content_no_interp] = sym__string_content_no_interp,
  [sym_source_file] = sym_source_file,
  [sym__block] = sym__block,
  [sym_assignment] = sym_assignment,
  [sym__closed_assignment] = sym_assignment,
  [sym_open_tuple] = sym_open_tuple,
  [sym__expression] = sym__expression,
  [sym_module_definition] = sym_module_definition,
  [sym_abstract_definition] = sym_abstract_definition,
  [sym_primitive_definition] = sym_primitive_definition,
  [sym_struct_definition] = sym_struct_definition,
  [sym_type_clause] = sym_type_clause,
  [sym_function_definition] = sym_function_definition,
  [sym_macro_definition] = sym_macro_definition,
  [sym_signature] = sym_signature,
  [sym_where_clause] = sym_where_clause,
  [sym_compound_statement] = sym_compound_statement,
  [sym_quote_statement] = sym_quote_statement,
  [sym_let_statement] = sym_let_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elseif_clause] = sym_elseif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_const_statement] = sym_const_statement,
  [sym_global_statement] = sym_global_statement,
  [sym_local_statement] = sym_local_statement,
  [sym_import_alias] = sym_import_alias,
  [sym_import_path] = sym_import_path,
  [sym__exportable] = sym__exportable,
  [sym__importable] = sym__importable,
  [sym__import_list] = sym__import_list,
  [sym_selected_import] = sym_selected_import,
  [sym_export_statement] = sym_export_statement,
  [sym_import_statement] = sym_import_statement,
  [sym__primary_expression] = sym__primary_expression,
  [sym__array] = sym__array,
  [sym_comprehension_expression] = sym_comprehension_expression,
  [sym__comprehension_clause] = sym__comprehension_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_for_clause] = sym_for_clause,
  [sym_for_binding] = sym_for_binding,
  [sym_matrix_expression] = sym_matrix_expression,
  [sym_matrix_row] = sym_matrix_row,
  [sym_vector_expression] = sym_vector_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_curly_expression] = sym_curly_expression,
  [sym_adjoint_expression] = sym_adjoint_expression,
  [sym_field_expression] = sym_field_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_parametrized_type_expression] = sym_parametrized_type_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_broadcast_call_expression] = sym_broadcast_call_expression,
  [sym__closed_macrocall_expression] = sym_macrocall_expression,
  [sym_macrocall_expression] = sym_macrocall_expression,
  [sym_macro_argument_list] = sym_macro_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym_do_clause] = sym_do_clause,
  [sym__do_parameter_list] = sym_argument_list,
  [sym_named_field] = sym_named_field,
  [sym_interpolation_expression] = sym_interpolation_expression,
  [sym_quote_expression] = sym_quote_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_splat_expression] = sym_splat_expression,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_typed_expression] = sym_typed_expression,
  [sym_unary_typed_expression] = sym_unary_typed_expression,
  [sym_function_expression] = sym_function_expression,
  [sym_juxtaposition_expression] = sym_juxtaposition_expression,
  [sym_compound_assignment_expression] = sym_compound_assignment_expression,
  [sym_where_expression] = sym_where_expression,
  [sym_macro_identifier] = sym_macro_identifier,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_identifier] = sym_identifier,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_integer_literal] = sym_integer_literal,
  [sym_float_literal] = sym_float_literal,
  [sym__string] = sym__string,
  [sym_string_literal] = sym_string_literal,
  [sym_command_literal] = sym_command_literal,
  [sym_prefixed_string_literal] = sym_prefixed_string_literal,
  [sym_prefixed_command_literal] = sym_prefixed_command_literal,
  [sym_string_interpolation] = sym_string_interpolation,
  [sym_operator] = sym_operator,
  [aux_sym__block_repeat1] = aux_sym__block_repeat1,
  [aux_sym_open_tuple_repeat1] = aux_sym_open_tuple_repeat1,
  [aux_sym_let_statement_repeat1] = aux_sym_let_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym__import_list_repeat1] = aux_sym__import_list_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym__comprehension_clause_repeat1] = aux_sym__comprehension_clause_repeat1,
  [aux_sym_matrix_expression_repeat1] = aux_sym_matrix_expression_repeat1,
  [aux_sym_matrix_row_repeat1] = aux_sym_matrix_row_repeat1,
  [aux_sym_vector_expression_repeat1] = aux_sym_vector_expression_repeat1,
  [aux_sym_parenthesized_expression_repeat1] = aux_sym_parenthesized_expression_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_macro_argument_list_repeat1] = aux_sym_macro_argument_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym__do_parameter_list_repeat1] = aux_sym__do_parameter_list_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_prefixed_string_literal_repeat1] = aux_sym_prefixed_string_literal_repeat1,
  [alias_sym_let_binding] = alias_sym_let_binding,
  [alias_sym_named_argument] = alias_sym_named_argument,
  [alias_sym_type_parameter_list] = alias_sym_type_parameter_list,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__word_identifier] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_baremodule] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_primitive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_COLON] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_import_path_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_outer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2208] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_EQ] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_quote_expression_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_isa] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_integer_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_integer_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_integer_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_integer_literal_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_literal_token4] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__pair_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__arrow_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__lazy_or_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__lazy_and_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__comparison_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__pipe_right_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__pipe_left_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__ellipsis_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__plus_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__times_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__rational_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__bitshift_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__power_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__tilde_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__type_order_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_plus_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__syntactic_operator] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__terminator_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__immediate_paren] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_bracket] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_brace] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = false,
    .named = true,
  },
  [sym__command_start] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_string_start] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_command_start] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = false,
    .named = true,
  },
  [sym__command_end] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content_no_interp] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__block] = {
    .visible = false,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__closed_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_open_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_module_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_quote_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_let_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_const_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_local_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_import_path] = {
    .visible = true,
    .named = true,
  },
  [sym__exportable] = {
    .visible = false,
    .named = true,
  },
  [sym__importable] = {
    .visible = false,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_selected_import] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__array] = {
    .visible = false,
    .named = true,
  },
  [sym_comprehension_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_matrix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_matrix_row] = {
    .visible = true,
    .named = true,
  },
  [sym_vector_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_adjoint_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parametrized_type_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_broadcast_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__closed_macrocall_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_macrocall_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_do_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__do_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_named_field] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_quote_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_typed_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_juxtaposition_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_where_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_command_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_prefixed_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_prefixed_command_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_open_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_let_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_matrix_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_matrix_row_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_vector_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parenthesized_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__do_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_prefixed_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_let_binding] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_named_argument] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_condition = 2,
  field_name = 3,
  field_prefix = 4,
  field_return_type = 5,
  field_suffix = 6,
  field_value = 7,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_condition] = "condition",
  [field_name] = "name",
  [field_prefix] = "prefix",
  [field_return_type] = "return_type",
  [field_suffix] = "suffix",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 1},
  [8] = {.index = 3, .length = 1},
  [9] = {.index = 4, .length = 1},
  [10] = {.index = 5, .length = 1},
  [12] = {.index = 6, .length = 2},
  [14] = {.index = 8, .length = 2},
  [16] = {.index = 0, .length = 1},
  [17] = {.index = 10, .length = 2},
  [18] = {.index = 12, .length = 3},
  [19] = {.index = 15, .length = 2},
  [21] = {.index = 5, .length = 1},
  [22] = {.index = 17, .length = 2},
  [23] = {.index = 19, .length = 3},
  [24] = {.index = 22, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1},
  [1] =
    {field_return_type, 1},
  [2] =
    {field_condition, 1},
  [3] =
    {field_value, 0},
  [4] =
    {field_prefix, 0},
  [5] =
    {field_name, 2},
  [6] =
    {field_alternative, 2},
    {field_condition, 1},
  [8] =
    {field_prefix, 0},
    {field_suffix, 3},
  [10] =
    {field_alternative, 3},
    {field_condition, 1},
  [12] =
    {field_alternative, 2},
    {field_alternative, 3},
    {field_condition, 1},
  [15] =
    {field_prefix, 0},
    {field_suffix, 4},
  [17] =
    {field_alternative, 4},
    {field_condition, 1},
  [19] =
    {field_alternative, 3},
    {field_alternative, 4},
    {field_condition, 1},
  [22] =
    {field_alternative, 4},
    {field_alternative, 5},
    {field_condition, 1},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_operator,
  },
  [2] = {
    [0] = sym_identifier,
  },
  [6] = {
    [1] = alias_sym_named_argument,
  },
  [7] = {
    [1] = sym_operator,
  },
  [11] = {
    [1] = alias_sym_let_binding,
  },
  [13] = {
    [2] = alias_sym_named_argument,
  },
  [15] = {
    [3] = sym_operator,
  },
  [16] = {
    [3] = alias_sym_type_parameter_list,
  },
  [20] = {
    [3] = sym_assignment,
  },
  [21] = {
    [4] = alias_sym_type_parameter_list,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__closed_assignment, 3,
    sym_assignment,
    alias_sym_let_binding,
    alias_sym_named_argument,
  sym_curly_expression, 2,
    sym_curly_expression,
    alias_sym_type_parameter_list,
  sym_named_field, 2,
    sym_named_field,
    sym_assignment,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 5,
  [6] = 4,
  [7] = 5,
  [8] = 4,
  [9] = 5,
  [10] = 4,
  [11] = 5,
  [12] = 4,
  [13] = 5,
  [14] = 4,
  [15] = 5,
  [16] = 4,
  [17] = 5,
  [18] = 4,
  [19] = 5,
  [20] = 5,
  [21] = 4,
  [22] = 5,
  [23] = 4,
  [24] = 5,
  [25] = 4,
  [26] = 4,
  [27] = 5,
  [28] = 5,
  [29] = 4,
  [30] = 5,
  [31] = 4,
  [32] = 4,
  [33] = 5,
  [34] = 4,
  [35] = 5,
  [36] = 4,
  [37] = 4,
  [38] = 4,
  [39] = 5,
  [40] = 4,
  [41] = 5,
  [42] = 4,
  [43] = 5,
  [44] = 5,
  [45] = 4,
  [46] = 4,
  [47] = 5,
  [48] = 5,
  [49] = 4,
  [50] = 4,
  [51] = 5,
  [52] = 5,
  [53] = 5,
  [54] = 5,
  [55] = 4,
  [56] = 5,
  [57] = 4,
  [58] = 4,
  [59] = 5,
  [60] = 4,
  [61] = 5,
  [62] = 4,
  [63] = 5,
  [64] = 5,
  [65] = 5,
  [66] = 4,
  [67] = 4,
  [68] = 5,
  [69] = 5,
  [70] = 70,
  [71] = 4,
  [72] = 5,
  [73] = 4,
  [74] = 5,
  [75] = 75,
  [76] = 75,
  [77] = 70,
  [78] = 70,
  [79] = 4,
  [80] = 4,
  [81] = 5,
  [82] = 4,
  [83] = 5,
  [84] = 5,
  [85] = 4,
  [86] = 75,
  [87] = 4,
  [88] = 70,
  [89] = 5,
  [90] = 70,
  [91] = 4,
  [92] = 4,
  [93] = 5,
  [94] = 70,
  [95] = 70,
  [96] = 70,
  [97] = 70,
  [98] = 70,
  [99] = 70,
  [100] = 75,
  [101] = 70,
  [102] = 70,
  [103] = 5,
  [104] = 5,
  [105] = 75,
  [106] = 75,
  [107] = 107,
  [108] = 108,
  [109] = 107,
  [110] = 108,
  [111] = 75,
  [112] = 108,
  [113] = 108,
  [114] = 107,
  [115] = 75,
  [116] = 75,
  [117] = 4,
  [118] = 4,
  [119] = 5,
  [120] = 75,
  [121] = 108,
  [122] = 75,
  [123] = 4,
  [124] = 5,
  [125] = 75,
  [126] = 75,
  [127] = 4,
  [128] = 75,
  [129] = 75,
  [130] = 108,
  [131] = 108,
  [132] = 108,
  [133] = 108,
  [134] = 108,
  [135] = 135,
  [136] = 107,
  [137] = 107,
  [138] = 107,
  [139] = 108,
  [140] = 108,
  [141] = 108,
  [142] = 4,
  [143] = 5,
  [144] = 107,
  [145] = 135,
  [146] = 75,
  [147] = 4,
  [148] = 5,
  [149] = 107,
  [150] = 135,
  [151] = 135,
  [152] = 108,
  [153] = 108,
  [154] = 75,
  [155] = 107,
  [156] = 75,
  [157] = 135,
  [158] = 108,
  [159] = 159,
  [160] = 160,
  [161] = 135,
  [162] = 135,
  [163] = 135,
  [164] = 107,
  [165] = 135,
  [166] = 135,
  [167] = 108,
  [168] = 108,
  [169] = 108,
  [170] = 75,
  [171] = 108,
  [172] = 108,
  [173] = 108,
  [174] = 174,
  [175] = 108,
  [176] = 176,
  [177] = 177,
  [178] = 108,
  [179] = 108,
  [180] = 180,
  [181] = 107,
  [182] = 182,
  [183] = 108,
  [184] = 107,
  [185] = 4,
  [186] = 5,
  [187] = 135,
  [188] = 188,
  [189] = 188,
  [190] = 190,
  [191] = 135,
  [192] = 107,
  [193] = 193,
  [194] = 135,
  [195] = 195,
  [196] = 107,
  [197] = 108,
  [198] = 198,
  [199] = 135,
  [200] = 188,
  [201] = 201,
  [202] = 202,
  [203] = 135,
  [204] = 188,
  [205] = 205,
  [206] = 108,
  [207] = 108,
  [208] = 107,
  [209] = 135,
  [210] = 108,
  [211] = 188,
  [212] = 188,
  [213] = 108,
  [214] = 108,
  [215] = 135,
  [216] = 188,
  [217] = 108,
  [218] = 108,
  [219] = 108,
  [220] = 135,
  [221] = 135,
  [222] = 135,
  [223] = 107,
  [224] = 135,
  [225] = 107,
  [226] = 188,
  [227] = 108,
  [228] = 107,
  [229] = 108,
  [230] = 135,
  [231] = 188,
  [232] = 135,
  [233] = 107,
  [234] = 135,
  [235] = 188,
  [236] = 135,
  [237] = 108,
  [238] = 188,
  [239] = 135,
  [240] = 135,
  [241] = 188,
  [242] = 188,
  [243] = 108,
  [244] = 108,
  [245] = 108,
  [246] = 135,
  [247] = 188,
  [248] = 188,
  [249] = 188,
  [250] = 135,
  [251] = 135,
  [252] = 135,
  [253] = 135,
  [254] = 188,
  [255] = 188,
  [256] = 188,
  [257] = 201,
  [258] = 202,
  [259] = 259,
  [260] = 160,
  [261] = 174,
  [262] = 176,
  [263] = 177,
  [264] = 180,
  [265] = 135,
  [266] = 182,
  [267] = 159,
  [268] = 190,
  [269] = 107,
  [270] = 188,
  [271] = 193,
  [272] = 188,
  [273] = 195,
  [274] = 108,
  [275] = 198,
  [276] = 188,
  [277] = 259,
  [278] = 135,
  [279] = 135,
  [280] = 108,
  [281] = 108,
  [282] = 135,
  [283] = 135,
  [284] = 259,
  [285] = 135,
  [286] = 259,
  [287] = 188,
  [288] = 135,
  [289] = 188,
  [290] = 188,
  [291] = 259,
  [292] = 188,
  [293] = 135,
  [294] = 259,
  [295] = 259,
  [296] = 259,
  [297] = 188,
  [298] = 259,
  [299] = 259,
  [300] = 188,
  [301] = 259,
  [302] = 259,
  [303] = 259,
  [304] = 135,
  [305] = 108,
  [306] = 188,
  [307] = 188,
  [308] = 188,
  [309] = 188,
  [310] = 188,
  [311] = 188,
  [312] = 108,
  [313] = 108,
  [314] = 135,
  [315] = 135,
  [316] = 188,
  [317] = 188,
  [318] = 188,
  [319] = 188,
  [320] = 188,
  [321] = 135,
  [322] = 188,
  [323] = 188,
  [324] = 135,
  [325] = 188,
  [326] = 188,
  [327] = 135,
  [328] = 188,
  [329] = 135,
  [330] = 188,
  [331] = 188,
  [332] = 188,
  [333] = 188,
  [334] = 108,
  [335] = 188,
  [336] = 188,
  [337] = 188,
  [338] = 188,
  [339] = 339,
  [340] = 339,
  [341] = 339,
  [342] = 339,
  [343] = 339,
  [344] = 339,
  [345] = 339,
  [346] = 339,
  [347] = 339,
  [348] = 188,
  [349] = 339,
  [350] = 188,
  [351] = 339,
  [352] = 339,
  [353] = 339,
  [354] = 339,
  [355] = 339,
  [356] = 339,
  [357] = 339,
  [358] = 339,
  [359] = 339,
  [360] = 339,
  [361] = 339,
  [362] = 339,
  [363] = 339,
  [364] = 339,
  [365] = 339,
  [366] = 339,
  [367] = 339,
  [368] = 339,
  [369] = 339,
  [370] = 339,
  [371] = 339,
  [372] = 339,
  [373] = 339,
  [374] = 339,
  [375] = 339,
  [376] = 188,
  [377] = 339,
  [378] = 339,
  [379] = 339,
  [380] = 339,
  [381] = 339,
  [382] = 339,
  [383] = 339,
  [384] = 339,
  [385] = 339,
  [386] = 339,
  [387] = 339,
  [388] = 339,
  [389] = 339,
  [390] = 339,
  [391] = 339,
  [392] = 339,
  [393] = 339,
  [394] = 339,
  [395] = 339,
  [396] = 339,
  [397] = 339,
  [398] = 339,
  [399] = 339,
  [400] = 339,
  [401] = 339,
  [402] = 339,
  [403] = 339,
  [404] = 339,
  [405] = 339,
  [406] = 339,
  [407] = 135,
  [408] = 339,
  [409] = 188,
  [410] = 188,
  [411] = 188,
  [412] = 412,
  [413] = 412,
  [414] = 414,
  [415] = 412,
  [416] = 416,
  [417] = 414,
  [418] = 412,
  [419] = 412,
  [420] = 416,
  [421] = 414,
  [422] = 412,
  [423] = 414,
  [424] = 416,
  [425] = 414,
  [426] = 416,
  [427] = 414,
  [428] = 412,
  [429] = 416,
  [430] = 412,
  [431] = 416,
  [432] = 414,
  [433] = 416,
  [434] = 412,
  [435] = 416,
  [436] = 436,
  [437] = 414,
  [438] = 414,
  [439] = 412,
  [440] = 416,
  [441] = 416,
  [442] = 416,
  [443] = 414,
  [444] = 412,
  [445] = 414,
  [446] = 414,
  [447] = 416,
  [448] = 414,
  [449] = 436,
  [450] = 436,
  [451] = 412,
  [452] = 412,
  [453] = 436,
  [454] = 436,
  [455] = 436,
  [456] = 436,
  [457] = 436,
  [458] = 436,
  [459] = 436,
  [460] = 436,
  [461] = 436,
  [462] = 436,
  [463] = 416,
  [464] = 464,
  [465] = 465,
  [466] = 464,
  [467] = 465,
  [468] = 465,
  [469] = 465,
  [470] = 464,
  [471] = 471,
  [472] = 464,
  [473] = 473,
  [474] = 471,
  [475] = 473,
  [476] = 465,
  [477] = 464,
  [478] = 471,
  [479] = 464,
  [480] = 464,
  [481] = 471,
  [482] = 473,
  [483] = 473,
  [484] = 465,
  [485] = 471,
  [486] = 473,
  [487] = 465,
  [488] = 465,
  [489] = 471,
  [490] = 464,
  [491] = 464,
  [492] = 464,
  [493] = 471,
  [494] = 471,
  [495] = 471,
  [496] = 473,
  [497] = 473,
  [498] = 471,
  [499] = 473,
  [500] = 464,
  [501] = 465,
  [502] = 465,
  [503] = 473,
  [504] = 465,
  [505] = 465,
  [506] = 471,
  [507] = 473,
  [508] = 508,
  [509] = 464,
  [510] = 464,
  [511] = 473,
  [512] = 471,
  [513] = 473,
  [514] = 471,
  [515] = 473,
  [516] = 465,
  [517] = 517,
  [518] = 518,
  [519] = 517,
  [520] = 517,
  [521] = 517,
  [522] = 522,
  [523] = 517,
  [524] = 517,
  [525] = 517,
  [526] = 517,
  [527] = 517,
  [528] = 517,
  [529] = 517,
  [530] = 517,
  [531] = 517,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 532,
  [540] = 536,
  [541] = 537,
  [542] = 538,
  [543] = 543,
  [544] = 533,
  [545] = 545,
  [546] = 546,
  [547] = 534,
  [548] = 532,
  [549] = 533,
  [550] = 533,
  [551] = 534,
  [552] = 535,
  [553] = 536,
  [554] = 554,
  [555] = 537,
  [556] = 538,
  [557] = 543,
  [558] = 534,
  [559] = 537,
  [560] = 545,
  [561] = 543,
  [562] = 546,
  [563] = 563,
  [564] = 545,
  [565] = 546,
  [566] = 532,
  [567] = 532,
  [568] = 533,
  [569] = 534,
  [570] = 535,
  [571] = 536,
  [572] = 537,
  [573] = 538,
  [574] = 533,
  [575] = 534,
  [576] = 543,
  [577] = 543,
  [578] = 535,
  [579] = 508,
  [580] = 535,
  [581] = 545,
  [582] = 546,
  [583] = 532,
  [584] = 533,
  [585] = 534,
  [586] = 535,
  [587] = 536,
  [588] = 537,
  [589] = 538,
  [590] = 536,
  [591] = 535,
  [592] = 537,
  [593] = 538,
  [594] = 543,
  [595] = 545,
  [596] = 546,
  [597] = 536,
  [598] = 532,
  [599] = 522,
  [600] = 533,
  [601] = 534,
  [602] = 543,
  [603] = 545,
  [604] = 532,
  [605] = 537,
  [606] = 545,
  [607] = 532,
  [608] = 538,
  [609] = 545,
  [610] = 532,
  [611] = 545,
  [612] = 545,
  [613] = 532,
  [614] = 518,
  [615] = 545,
  [616] = 532,
  [617] = 546,
  [618] = 545,
  [619] = 532,
  [620] = 536,
  [621] = 545,
  [622] = 532,
  [623] = 532,
  [624] = 545,
  [625] = 532,
  [626] = 545,
  [627] = 532,
  [628] = 535,
  [629] = 545,
  [630] = 532,
  [631] = 533,
  [632] = 545,
  [633] = 532,
  [634] = 534,
  [635] = 545,
  [636] = 532,
  [637] = 545,
  [638] = 532,
  [639] = 545,
  [640] = 532,
  [641] = 543,
  [642] = 545,
  [643] = 532,
  [644] = 545,
  [645] = 545,
  [646] = 532,
  [647] = 535,
  [648] = 545,
  [649] = 532,
  [650] = 545,
  [651] = 532,
  [652] = 545,
  [653] = 532,
  [654] = 536,
  [655] = 545,
  [656] = 532,
  [657] = 536,
  [658] = 545,
  [659] = 532,
  [660] = 545,
  [661] = 532,
  [662] = 538,
  [663] = 545,
  [664] = 532,
  [665] = 545,
  [666] = 545,
  [667] = 532,
  [668] = 537,
  [669] = 545,
  [670] = 532,
  [671] = 546,
  [672] = 545,
  [673] = 532,
  [674] = 537,
  [675] = 545,
  [676] = 532,
  [677] = 532,
  [678] = 545,
  [679] = 532,
  [680] = 543,
  [681] = 545,
  [682] = 532,
  [683] = 545,
  [684] = 532,
  [685] = 538,
  [686] = 545,
  [687] = 532,
  [688] = 545,
  [689] = 545,
  [690] = 532,
  [691] = 546,
  [692] = 545,
  [693] = 532,
  [694] = 533,
  [695] = 545,
  [696] = 532,
  [697] = 532,
  [698] = 545,
  [699] = 532,
  [700] = 545,
  [701] = 532,
  [702] = 534,
  [703] = 545,
  [704] = 532,
  [705] = 533,
  [706] = 545,
  [707] = 532,
  [708] = 534,
  [709] = 545,
  [710] = 532,
  [711] = 538,
  [712] = 545,
  [713] = 532,
  [714] = 545,
  [715] = 532,
  [716] = 535,
  [717] = 545,
  [718] = 532,
  [719] = 545,
  [720] = 532,
  [721] = 545,
  [722] = 532,
  [723] = 536,
  [724] = 545,
  [725] = 532,
  [726] = 538,
  [727] = 545,
  [728] = 532,
  [729] = 537,
  [730] = 545,
  [731] = 532,
  [732] = 538,
  [733] = 545,
  [734] = 532,
  [735] = 545,
  [736] = 532,
  [737] = 546,
  [738] = 545,
  [739] = 532,
  [740] = 543,
  [741] = 545,
  [742] = 532,
  [743] = 545,
  [744] = 535,
  [745] = 536,
  [746] = 545,
  [747] = 532,
  [748] = 545,
  [749] = 532,
  [750] = 545,
  [751] = 532,
  [752] = 543,
  [753] = 545,
  [754] = 532,
  [755] = 545,
  [756] = 532,
  [757] = 545,
  [758] = 543,
  [759] = 545,
  [760] = 546,
  [761] = 546,
  [762] = 532,
  [763] = 763,
  [764] = 533,
  [765] = 534,
  [766] = 532,
  [767] = 535,
  [768] = 536,
  [769] = 537,
  [770] = 538,
  [771] = 533,
  [772] = 534,
  [773] = 545,
  [774] = 532,
  [775] = 543,
  [776] = 546,
  [777] = 545,
  [778] = 546,
  [779] = 535,
  [780] = 532,
  [781] = 537,
  [782] = 782,
  [783] = 783,
  [784] = 782,
  [785] = 783,
  [786] = 782,
  [787] = 782,
  [788] = 783,
  [789] = 782,
  [790] = 783,
  [791] = 791,
  [792] = 791,
  [793] = 783,
  [794] = 782,
  [795] = 783,
  [796] = 782,
  [797] = 783,
  [798] = 783,
  [799] = 782,
  [800] = 783,
  [801] = 782,
  [802] = 783,
  [803] = 782,
  [804] = 782,
  [805] = 783,
  [806] = 782,
  [807] = 783,
  [808] = 791,
  [809] = 782,
  [810] = 783,
  [811] = 791,
  [812] = 783,
  [813] = 782,
  [814] = 782,
  [815] = 783,
  [816] = 783,
  [817] = 782,
  [818] = 783,
  [819] = 782,
  [820] = 783,
  [821] = 783,
  [822] = 782,
  [823] = 783,
  [824] = 782,
  [825] = 783,
  [826] = 791,
  [827] = 827,
  [828] = 782,
  [829] = 782,
  [830] = 783,
  [831] = 831,
  [832] = 782,
  [833] = 783,
  [834] = 782,
  [835] = 783,
  [836] = 791,
  [837] = 783,
  [838] = 838,
  [839] = 782,
  [840] = 783,
  [841] = 791,
  [842] = 782,
  [843] = 783,
  [844] = 782,
  [845] = 783,
  [846] = 783,
  [847] = 783,
  [848] = 782,
  [849] = 782,
  [850] = 783,
  [851] = 791,
  [852] = 782,
  [853] = 783,
  [854] = 782,
  [855] = 783,
  [856] = 782,
  [857] = 783,
  [858] = 782,
  [859] = 782,
  [860] = 783,
  [861] = 782,
  [862] = 783,
  [863] = 783,
  [864] = 782,
  [865] = 783,
  [866] = 783,
  [867] = 782,
  [868] = 782,
  [869] = 783,
  [870] = 791,
  [871] = 783,
  [872] = 783,
  [873] = 791,
  [874] = 782,
  [875] = 783,
  [876] = 783,
  [877] = 783,
  [878] = 782,
  [879] = 782,
  [880] = 783,
  [881] = 783,
  [882] = 882,
  [883] = 791,
  [884] = 782,
  [885] = 783,
  [886] = 886,
  [887] = 782,
  [888] = 782,
  [889] = 782,
  [890] = 783,
  [891] = 783,
  [892] = 783,
  [893] = 791,
  [894] = 782,
  [895] = 783,
  [896] = 782,
  [897] = 782,
  [898] = 782,
  [899] = 783,
  [900] = 783,
  [901] = 791,
  [902] = 782,
  [903] = 783,
  [904] = 782,
  [905] = 783,
  [906] = 782,
  [907] = 782,
  [908] = 783,
  [909] = 783,
  [910] = 782,
  [911] = 782,
  [912] = 783,
  [913] = 782,
  [914] = 782,
  [915] = 783,
  [916] = 782,
  [917] = 783,
  [918] = 782,
  [919] = 791,
  [920] = 782,
  [921] = 783,
  [922] = 783,
  [923] = 782,
  [924] = 783,
  [925] = 791,
  [926] = 783,
  [927] = 782,
  [928] = 882,
  [929] = 782,
  [930] = 783,
  [931] = 783,
  [932] = 782,
  [933] = 933,
  [934] = 782,
  [935] = 933,
  [936] = 783,
  [937] = 782,
  [938] = 782,
  [939] = 782,
  [940] = 782,
  [941] = 782,
  [942] = 783,
  [943] = 782,
  [944] = 783,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 959,
  [960] = 960,
  [961] = 961,
  [962] = 962,
  [963] = 958,
  [964] = 961,
  [965] = 965,
  [966] = 966,
  [967] = 967,
  [968] = 947,
  [969] = 966,
  [970] = 967,
  [971] = 971,
  [972] = 971,
  [973] = 946,
  [974] = 948,
  [975] = 950,
  [976] = 954,
  [977] = 946,
  [978] = 978,
  [979] = 948,
  [980] = 978,
  [981] = 951,
  [982] = 950,
  [983] = 954,
  [984] = 984,
  [985] = 984,
  [986] = 956,
  [987] = 987,
  [988] = 949,
  [989] = 827,
  [990] = 990,
  [991] = 956,
  [992] = 945,
  [993] = 947,
  [994] = 990,
  [995] = 949,
  [996] = 956,
  [997] = 945,
  [998] = 951,
  [999] = 952,
  [1000] = 953,
  [1001] = 951,
  [1002] = 955,
  [1003] = 947,
  [1004] = 957,
  [1005] = 952,
  [1006] = 959,
  [1007] = 960,
  [1008] = 949,
  [1009] = 953,
  [1010] = 962,
  [1011] = 958,
  [1012] = 961,
  [1013] = 965,
  [1014] = 945,
  [1015] = 951,
  [1016] = 952,
  [1017] = 966,
  [1018] = 967,
  [1019] = 953,
  [1020] = 971,
  [1021] = 946,
  [1022] = 948,
  [1023] = 882,
  [1024] = 950,
  [1025] = 954,
  [1026] = 955,
  [1027] = 955,
  [1028] = 990,
  [1029] = 956,
  [1030] = 957,
  [1031] = 959,
  [1032] = 952,
  [1033] = 959,
  [1034] = 971,
  [1035] = 946,
  [1036] = 957,
  [1037] = 960,
  [1038] = 990,
  [1039] = 956,
  [1040] = 933,
  [1041] = 959,
  [1042] = 962,
  [1043] = 958,
  [1044] = 971,
  [1045] = 946,
  [1046] = 961,
  [1047] = 956,
  [1048] = 965,
  [1049] = 959,
  [1050] = 959,
  [1051] = 965,
  [1052] = 971,
  [1053] = 946,
  [1054] = 956,
  [1055] = 966,
  [1056] = 959,
  [1057] = 967,
  [1058] = 960,
  [1059] = 971,
  [1060] = 946,
  [1061] = 971,
  [1062] = 956,
  [1063] = 946,
  [1064] = 948,
  [1065] = 959,
  [1066] = 953,
  [1067] = 950,
  [1068] = 971,
  [1069] = 946,
  [1070] = 954,
  [1071] = 956,
  [1072] = 563,
  [1073] = 962,
  [1074] = 959,
  [1075] = 958,
  [1076] = 961,
  [1077] = 971,
  [1078] = 946,
  [1079] = 965,
  [1080] = 956,
  [1081] = 990,
  [1082] = 959,
  [1083] = 978,
  [1084] = 971,
  [1085] = 946,
  [1086] = 838,
  [1087] = 956,
  [1088] = 959,
  [1089] = 882,
  [1090] = 984,
  [1091] = 971,
  [1092] = 946,
  [1093] = 987,
  [1094] = 956,
  [1095] = 978,
  [1096] = 966,
  [1097] = 959,
  [1098] = 967,
  [1099] = 990,
  [1100] = 971,
  [1101] = 946,
  [1102] = 956,
  [1103] = 956,
  [1104] = 947,
  [1105] = 959,
  [1106] = 971,
  [1107] = 949,
  [1108] = 971,
  [1109] = 946,
  [1110] = 984,
  [1111] = 956,
  [1112] = 945,
  [1113] = 951,
  [1114] = 959,
  [1115] = 952,
  [1116] = 953,
  [1117] = 971,
  [1118] = 946,
  [1119] = 987,
  [1120] = 956,
  [1121] = 955,
  [1122] = 946,
  [1123] = 959,
  [1124] = 957,
  [1125] = 971,
  [1126] = 946,
  [1127] = 948,
  [1128] = 956,
  [1129] = 959,
  [1130] = 960,
  [1131] = 959,
  [1132] = 933,
  [1133] = 990,
  [1134] = 971,
  [1135] = 946,
  [1136] = 962,
  [1137] = 956,
  [1138] = 958,
  [1139] = 961,
  [1140] = 959,
  [1141] = 965,
  [1142] = 971,
  [1143] = 946,
  [1144] = 956,
  [1145] = 956,
  [1146] = 950,
  [1147] = 959,
  [1148] = 947,
  [1149] = 966,
  [1150] = 971,
  [1151] = 946,
  [1152] = 967,
  [1153] = 956,
  [1154] = 954,
  [1155] = 971,
  [1156] = 959,
  [1157] = 946,
  [1158] = 948,
  [1159] = 971,
  [1160] = 946,
  [1161] = 949,
  [1162] = 956,
  [1163] = 950,
  [1164] = 954,
  [1165] = 959,
  [1166] = 945,
  [1167] = 971,
  [1168] = 946,
  [1169] = 951,
  [1170] = 956,
  [1171] = 952,
  [1172] = 953,
  [1173] = 959,
  [1174] = 978,
  [1175] = 971,
  [1176] = 946,
  [1177] = 956,
  [1178] = 955,
  [1179] = 978,
  [1180] = 959,
  [1181] = 957,
  [1182] = 984,
  [1183] = 971,
  [1184] = 946,
  [1185] = 987,
  [1186] = 956,
  [1187] = 763,
  [1188] = 959,
  [1189] = 959,
  [1190] = 990,
  [1191] = 971,
  [1192] = 946,
  [1193] = 956,
  [1194] = 956,
  [1195] = 966,
  [1196] = 947,
  [1197] = 959,
  [1198] = 960,
  [1199] = 949,
  [1200] = 971,
  [1201] = 946,
  [1202] = 967,
  [1203] = 956,
  [1204] = 945,
  [1205] = 951,
  [1206] = 959,
  [1207] = 952,
  [1208] = 953,
  [1209] = 971,
  [1210] = 946,
  [1211] = 956,
  [1212] = 956,
  [1213] = 955,
  [1214] = 962,
  [1215] = 959,
  [1216] = 957,
  [1217] = 971,
  [1218] = 946,
  [1219] = 958,
  [1220] = 956,
  [1221] = 959,
  [1222] = 960,
  [1223] = 959,
  [1224] = 961,
  [1225] = 965,
  [1226] = 971,
  [1227] = 946,
  [1228] = 962,
  [1229] = 956,
  [1230] = 958,
  [1231] = 961,
  [1232] = 959,
  [1233] = 965,
  [1234] = 971,
  [1235] = 946,
  [1236] = 956,
  [1237] = 959,
  [1238] = 882,
  [1239] = 966,
  [1240] = 971,
  [1241] = 946,
  [1242] = 967,
  [1243] = 956,
  [1244] = 971,
  [1245] = 959,
  [1246] = 946,
  [1247] = 948,
  [1248] = 971,
  [1249] = 946,
  [1250] = 971,
  [1251] = 956,
  [1252] = 950,
  [1253] = 954,
  [1254] = 959,
  [1255] = 966,
  [1256] = 967,
  [1257] = 971,
  [1258] = 946,
  [1259] = 933,
  [1260] = 956,
  [1261] = 971,
  [1262] = 946,
  [1263] = 959,
  [1264] = 978,
  [1265] = 971,
  [1266] = 946,
  [1267] = 948,
  [1268] = 956,
  [1269] = 1269,
  [1270] = 950,
  [1271] = 959,
  [1272] = 954,
  [1273] = 984,
  [1274] = 971,
  [1275] = 946,
  [1276] = 987,
  [1277] = 956,
  [1278] = 946,
  [1279] = 948,
  [1280] = 955,
  [1281] = 990,
  [1282] = 971,
  [1283] = 956,
  [1284] = 956,
  [1285] = 950,
  [1286] = 947,
  [1287] = 949,
  [1288] = 971,
  [1289] = 954,
  [1290] = 956,
  [1291] = 945,
  [1292] = 951,
  [1293] = 952,
  [1294] = 953,
  [1295] = 971,
  [1296] = 956,
  [1297] = 955,
  [1298] = 957,
  [1299] = 957,
  [1300] = 971,
  [1301] = 956,
  [1302] = 959,
  [1303] = 960,
  [1304] = 978,
  [1305] = 971,
  [1306] = 962,
  [1307] = 956,
  [1308] = 958,
  [1309] = 961,
  [1310] = 965,
  [1311] = 971,
  [1312] = 984,
  [1313] = 956,
  [1314] = 947,
  [1315] = 966,
  [1316] = 971,
  [1317] = 967,
  [1318] = 956,
  [1319] = 971,
  [1320] = 946,
  [1321] = 948,
  [1322] = 971,
  [1323] = 984,
  [1324] = 956,
  [1325] = 950,
  [1326] = 954,
  [1327] = 987,
  [1328] = 971,
  [1329] = 978,
  [1330] = 956,
  [1331] = 978,
  [1332] = 959,
  [1333] = 990,
  [1334] = 971,
  [1335] = 956,
  [1336] = 956,
  [1337] = 987,
  [1338] = 984,
  [1339] = 987,
  [1340] = 947,
  [1341] = 971,
  [1342] = 949,
  [1343] = 956,
  [1344] = 990,
  [1345] = 956,
  [1346] = 949,
  [1347] = 971,
  [1348] = 947,
  [1349] = 956,
  [1350] = 978,
  [1351] = 949,
  [1352] = 960,
  [1353] = 945,
  [1354] = 971,
  [1355] = 951,
  [1356] = 956,
  [1357] = 952,
  [1358] = 953,
  [1359] = 945,
  [1360] = 955,
  [1361] = 971,
  [1362] = 951,
  [1363] = 956,
  [1364] = 957,
  [1365] = 952,
  [1366] = 959,
  [1367] = 971,
  [1368] = 960,
  [1369] = 956,
  [1370] = 984,
  [1371] = 987,
  [1372] = 962,
  [1373] = 958,
  [1374] = 971,
  [1375] = 961,
  [1376] = 956,
  [1377] = 965,
  [1378] = 953,
  [1379] = 984,
  [1380] = 971,
  [1381] = 956,
  [1382] = 955,
  [1383] = 966,
  [1384] = 967,
  [1385] = 990,
  [1386] = 971,
  [1387] = 971,
  [1388] = 956,
  [1389] = 946,
  [1390] = 948,
  [1391] = 956,
  [1392] = 950,
  [1393] = 971,
  [1394] = 954,
  [1395] = 956,
  [1396] = 987,
  [1397] = 947,
  [1398] = 957,
  [1399] = 971,
  [1400] = 978,
  [1401] = 956,
  [1402] = 949,
  [1403] = 945,
  [1404] = 951,
  [1405] = 971,
  [1406] = 984,
  [1407] = 956,
  [1408] = 987,
  [1409] = 952,
  [1410] = 953,
  [1411] = 971,
  [1412] = 990,
  [1413] = 956,
  [1414] = 956,
  [1415] = 955,
  [1416] = 947,
  [1417] = 959,
  [1418] = 971,
  [1419] = 949,
  [1420] = 956,
  [1421] = 957,
  [1422] = 945,
  [1423] = 951,
  [1424] = 971,
  [1425] = 952,
  [1426] = 956,
  [1427] = 953,
  [1428] = 955,
  [1429] = 971,
  [1430] = 945,
  [1431] = 957,
  [1432] = 956,
  [1433] = 959,
  [1434] = 959,
  [1435] = 971,
  [1436] = 960,
  [1437] = 956,
  [1438] = 960,
  [1439] = 960,
  [1440] = 962,
  [1441] = 971,
  [1442] = 958,
  [1443] = 961,
  [1444] = 965,
  [1445] = 962,
  [1446] = 990,
  [1447] = 962,
  [1448] = 966,
  [1449] = 967,
  [1450] = 958,
  [1451] = 971,
  [1452] = 946,
  [1453] = 948,
  [1454] = 961,
  [1455] = 950,
  [1456] = 954,
  [1457] = 965,
  [1458] = 962,
  [1459] = 978,
  [1460] = 958,
  [1461] = 961,
  [1462] = 966,
  [1463] = 984,
  [1464] = 987,
  [1465] = 967,
  [1466] = 965,
  [1467] = 971,
  [1468] = 990,
  [1469] = 987,
  [1470] = 1470,
  [1471] = 1470,
  [1472] = 1472,
  [1473] = 1472,
  [1474] = 1470,
  [1475] = 1475,
  [1476] = 1470,
  [1477] = 1472,
  [1478] = 1472,
  [1479] = 1470,
  [1480] = 1475,
  [1481] = 1472,
  [1482] = 1470,
  [1483] = 1470,
  [1484] = 1472,
  [1485] = 1470,
  [1486] = 1475,
  [1487] = 1470,
  [1488] = 1472,
  [1489] = 1470,
  [1490] = 1490,
  [1491] = 1470,
  [1492] = 1472,
  [1493] = 1470,
  [1494] = 1470,
  [1495] = 1470,
  [1496] = 1472,
  [1497] = 1470,
  [1498] = 1472,
  [1499] = 933,
  [1500] = 1472,
  [1501] = 1470,
  [1502] = 1470,
  [1503] = 1470,
  [1504] = 1472,
  [1505] = 1472,
  [1506] = 1475,
  [1507] = 1470,
  [1508] = 1472,
  [1509] = 1472,
  [1510] = 1472,
  [1511] = 1470,
  [1512] = 1472,
  [1513] = 1472,
  [1514] = 1470,
  [1515] = 1472,
  [1516] = 1470,
  [1517] = 1470,
  [1518] = 1518,
  [1519] = 1470,
  [1520] = 1470,
  [1521] = 1470,
  [1522] = 1470,
  [1523] = 1470,
  [1524] = 1470,
  [1525] = 1475,
  [1526] = 1475,
  [1527] = 1470,
  [1528] = 1490,
  [1529] = 1472,
  [1530] = 1472,
  [1531] = 1531,
  [1532] = 1470,
  [1533] = 1470,
  [1534] = 1490,
  [1535] = 1470,
  [1536] = 1490,
  [1537] = 1470,
  [1538] = 1490,
  [1539] = 1470,
  [1540] = 1490,
  [1541] = 1470,
  [1542] = 1470,
  [1543] = 1470,
  [1544] = 1470,
  [1545] = 1472,
  [1546] = 1490,
  [1547] = 1472,
  [1548] = 1470,
  [1549] = 1490,
  [1550] = 1472,
  [1551] = 1470,
  [1552] = 1472,
  [1553] = 1472,
  [1554] = 1470,
  [1555] = 1470,
  [1556] = 1472,
  [1557] = 1470,
  [1558] = 1472,
  [1559] = 1470,
  [1560] = 1475,
  [1561] = 1490,
  [1562] = 1470,
  [1563] = 1470,
  [1564] = 1470,
  [1565] = 1475,
  [1566] = 1470,
  [1567] = 1472,
  [1568] = 1470,
  [1569] = 1490,
  [1570] = 1475,
  [1571] = 1472,
  [1572] = 1472,
  [1573] = 1470,
  [1574] = 1470,
  [1575] = 1490,
  [1576] = 1490,
  [1577] = 933,
  [1578] = 1475,
  [1579] = 1470,
  [1580] = 1472,
  [1581] = 1470,
  [1582] = 1490,
  [1583] = 1472,
  [1584] = 1470,
  [1585] = 1470,
  [1586] = 1470,
  [1587] = 1470,
  [1588] = 1531,
  [1589] = 1472,
  [1590] = 1472,
  [1591] = 1591,
  [1592] = 882,
  [1593] = 1475,
  [1594] = 1490,
  [1595] = 1470,
  [1596] = 1472,
  [1597] = 1470,
  [1598] = 1591,
  [1599] = 1470,
  [1600] = 1531,
  [1601] = 1470,
  [1602] = 1470,
  [1603] = 1591,
  [1604] = 1531,
  [1605] = 1472,
  [1606] = 1470,
  [1607] = 1591,
  [1608] = 1531,
  [1609] = 1490,
  [1610] = 1470,
  [1611] = 1591,
  [1612] = 1531,
  [1613] = 1472,
  [1614] = 1472,
  [1615] = 1591,
  [1616] = 1531,
  [1617] = 1475,
  [1618] = 1472,
  [1619] = 1591,
  [1620] = 1531,
  [1621] = 1470,
  [1622] = 1475,
  [1623] = 1591,
  [1624] = 1531,
  [1625] = 1475,
  [1626] = 1472,
  [1627] = 1591,
  [1628] = 1531,
  [1629] = 1472,
  [1630] = 1470,
  [1631] = 1591,
  [1632] = 1531,
  [1633] = 1470,
  [1634] = 1470,
  [1635] = 1591,
  [1636] = 1531,
  [1637] = 1470,
  [1638] = 1472,
  [1639] = 1591,
  [1640] = 1531,
  [1641] = 1475,
  [1642] = 1470,
  [1643] = 1591,
  [1644] = 1591,
  [1645] = 1591,
  [1646] = 1591,
  [1647] = 1591,
  [1648] = 1591,
  [1649] = 1591,
  [1650] = 1591,
  [1651] = 1591,
  [1652] = 1591,
  [1653] = 1591,
  [1654] = 1591,
  [1655] = 1591,
  [1656] = 1591,
  [1657] = 1591,
  [1658] = 1591,
  [1659] = 1591,
  [1660] = 1591,
  [1661] = 1591,
  [1662] = 1591,
  [1663] = 1591,
  [1664] = 1591,
  [1665] = 1591,
  [1666] = 1591,
  [1667] = 1591,
  [1668] = 1591,
  [1669] = 1591,
  [1670] = 1591,
  [1671] = 1591,
  [1672] = 1591,
  [1673] = 1591,
  [1674] = 882,
  [1675] = 1675,
  [1676] = 1675,
  [1677] = 1677,
  [1678] = 1678,
  [1679] = 1678,
  [1680] = 1680,
  [1681] = 1681,
  [1682] = 1682,
  [1683] = 1675,
  [1684] = 1677,
  [1685] = 1681,
  [1686] = 1678,
  [1687] = 1682,
  [1688] = 1681,
  [1689] = 1682,
  [1690] = 1677,
  [1691] = 1678,
  [1692] = 1692,
  [1693] = 1693,
  [1694] = 1681,
  [1695] = 1682,
  [1696] = 1675,
  [1697] = 1675,
  [1698] = 1677,
  [1699] = 1699,
  [1700] = 1677,
  [1701] = 1701,
  [1702] = 1702,
  [1703] = 1703,
  [1704] = 1704,
  [1705] = 1705,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1708,
  [1709] = 1709,
  [1710] = 1710,
  [1711] = 1680,
  [1712] = 1692,
  [1713] = 1701,
  [1714] = 1708,
  [1715] = 1709,
  [1716] = 1710,
  [1717] = 1717,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1678,
  [1721] = 1721,
  [1722] = 1678,
  [1723] = 1717,
  [1724] = 1724,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1727,
  [1728] = 1681,
  [1729] = 1682,
  [1730] = 1730,
  [1731] = 1719,
  [1732] = 1681,
  [1733] = 1682,
  [1734] = 1718,
  [1735] = 1675,
  [1736] = 1677,
  [1737] = 1718,
  [1738] = 1678,
  [1739] = 1681,
  [1740] = 1682,
  [1741] = 1675,
  [1742] = 1677,
  [1743] = 1678,
  [1744] = 1681,
  [1745] = 1682,
  [1746] = 1721,
  [1747] = 1675,
  [1748] = 1677,
  [1749] = 1675,
  [1750] = 1678,
  [1751] = 1681,
  [1752] = 1682,
  [1753] = 1675,
  [1754] = 1677,
  [1755] = 1678,
  [1756] = 1681,
  [1757] = 1682,
  [1758] = 1675,
  [1759] = 1677,
  [1760] = 1721,
  [1761] = 1678,
  [1762] = 1681,
  [1763] = 1682,
  [1764] = 1675,
  [1765] = 1677,
  [1766] = 1677,
  [1767] = 1678,
  [1768] = 1678,
  [1769] = 1681,
  [1770] = 1682,
  [1771] = 1675,
  [1772] = 1677,
  [1773] = 1678,
  [1774] = 1681,
  [1775] = 1682,
  [1776] = 1675,
  [1777] = 1677,
  [1778] = 1778,
  [1779] = 1678,
  [1780] = 1681,
  [1781] = 1682,
  [1782] = 1675,
  [1783] = 1677,
  [1784] = 1678,
  [1785] = 1681,
  [1786] = 1682,
  [1787] = 1675,
  [1788] = 1677,
  [1789] = 1678,
  [1790] = 1681,
  [1791] = 1682,
  [1792] = 1675,
  [1793] = 1677,
  [1794] = 1678,
  [1795] = 1681,
  [1796] = 1682,
  [1797] = 1677,
  [1798] = 1678,
  [1799] = 1681,
  [1800] = 1682,
  [1801] = 1675,
  [1802] = 1677,
  [1803] = 1721,
  [1804] = 1678,
  [1805] = 1678,
  [1806] = 1681,
  [1807] = 1682,
  [1808] = 1675,
  [1809] = 1677,
  [1810] = 1678,
  [1811] = 1681,
  [1812] = 1682,
  [1813] = 1675,
  [1814] = 1677,
  [1815] = 1678,
  [1816] = 1681,
  [1817] = 1682,
  [1818] = 1675,
  [1819] = 1677,
  [1820] = 1678,
  [1821] = 1681,
  [1822] = 1682,
  [1823] = 1675,
  [1824] = 1677,
  [1825] = 1678,
  [1826] = 1681,
  [1827] = 1682,
  [1828] = 1675,
  [1829] = 1677,
  [1830] = 1678,
  [1831] = 1681,
  [1832] = 1682,
  [1833] = 1675,
  [1834] = 1677,
  [1835] = 1678,
  [1836] = 1681,
  [1837] = 1682,
  [1838] = 1675,
  [1839] = 1677,
  [1840] = 1678,
  [1841] = 1681,
  [1842] = 1682,
  [1843] = 1675,
  [1844] = 1677,
  [1845] = 1678,
  [1846] = 1681,
  [1847] = 1682,
  [1848] = 1677,
  [1849] = 1681,
  [1850] = 1678,
  [1851] = 1682,
  [1852] = 1693,
  [1853] = 1675,
  [1854] = 1724,
  [1855] = 1675,
  [1856] = 1699,
  [1857] = 1702,
  [1858] = 1703,
  [1859] = 1704,
  [1860] = 1705,
  [1861] = 1706,
  [1862] = 1707,
  [1863] = 1680,
  [1864] = 1692,
  [1865] = 1701,
  [1866] = 1708,
  [1867] = 1709,
  [1868] = 1710,
  [1869] = 1717,
  [1870] = 1719,
  [1871] = 1677,
  [1872] = 1725,
  [1873] = 1724,
  [1874] = 1725,
  [1875] = 1726,
  [1876] = 1727,
  [1877] = 1730,
  [1878] = 1675,
  [1879] = 1718,
  [1880] = 1681,
  [1881] = 1682,
  [1882] = 1726,
  [1883] = 1675,
  [1884] = 1677,
  [1885] = 1678,
  [1886] = 1675,
  [1887] = 1677,
  [1888] = 1678,
  [1889] = 1675,
  [1890] = 1677,
  [1891] = 1678,
  [1892] = 1677,
  [1893] = 1678,
  [1894] = 1675,
  [1895] = 1677,
  [1896] = 1678,
  [1897] = 1675,
  [1898] = 1675,
  [1899] = 1675,
  [1900] = 1677,
  [1901] = 1678,
  [1902] = 1677,
  [1903] = 1678,
  [1904] = 1693,
  [1905] = 1721,
  [1906] = 1678,
  [1907] = 1702,
  [1908] = 1703,
  [1909] = 1704,
  [1910] = 1705,
  [1911] = 1706,
  [1912] = 1707,
  [1913] = 1681,
  [1914] = 1682,
  [1915] = 1680,
  [1916] = 1727,
  [1917] = 1692,
  [1918] = 1701,
  [1919] = 1708,
  [1920] = 1709,
  [1921] = 1710,
  [1922] = 1717,
  [1923] = 1719,
  [1924] = 1724,
  [1925] = 1725,
  [1926] = 1726,
  [1927] = 1727,
  [1928] = 1730,
  [1929] = 1718,
  [1930] = 1681,
  [1931] = 1682,
  [1932] = 1675,
  [1933] = 1677,
  [1934] = 1678,
  [1935] = 1675,
  [1936] = 1675,
  [1937] = 1677,
  [1938] = 1678,
  [1939] = 1677,
  [1940] = 1678,
  [1941] = 1693,
  [1942] = 1677,
  [1943] = 1699,
  [1944] = 1730,
  [1945] = 1702,
  [1946] = 1703,
  [1947] = 1704,
  [1948] = 1705,
  [1949] = 1706,
  [1950] = 1707,
  [1951] = 1721,
  [1952] = 1678,
  [1953] = 1680,
  [1954] = 1692,
  [1955] = 1701,
  [1956] = 1708,
  [1957] = 1709,
  [1958] = 1710,
  [1959] = 1717,
  [1960] = 1719,
  [1961] = 1724,
  [1962] = 1725,
  [1963] = 1726,
  [1964] = 1727,
  [1965] = 1730,
  [1966] = 1718,
  [1967] = 1677,
  [1968] = 1678,
  [1969] = 1675,
  [1970] = 1693,
  [1971] = 1681,
  [1972] = 1682,
  [1973] = 1677,
  [1974] = 1675,
  [1975] = 1702,
  [1976] = 1703,
  [1977] = 1704,
  [1978] = 1705,
  [1979] = 1706,
  [1980] = 1707,
  [1981] = 1680,
  [1982] = 1677,
  [1983] = 1692,
  [1984] = 1701,
  [1985] = 1708,
  [1986] = 1709,
  [1987] = 1710,
  [1988] = 1717,
  [1989] = 1681,
  [1990] = 1719,
  [1991] = 1682,
  [1992] = 1724,
  [1993] = 1725,
  [1994] = 1726,
  [1995] = 1727,
  [1996] = 1702,
  [1997] = 1997,
  [1998] = 1730,
  [1999] = 1718,
  [2000] = 1677,
  [2001] = 1678,
  [2002] = 1693,
  [2003] = 1678,
  [2004] = 1681,
  [2005] = 1682,
  [2006] = 1703,
  [2007] = 1702,
  [2008] = 1703,
  [2009] = 1704,
  [2010] = 1705,
  [2011] = 1706,
  [2012] = 1707,
  [2013] = 1680,
  [2014] = 1692,
  [2015] = 1701,
  [2016] = 1708,
  [2017] = 1709,
  [2018] = 1710,
  [2019] = 1717,
  [2020] = 1719,
  [2021] = 1675,
  [2022] = 1724,
  [2023] = 1725,
  [2024] = 1726,
  [2025] = 1727,
  [2026] = 1730,
  [2027] = 1718,
  [2028] = 1693,
  [2029] = 1677,
  [2030] = 1704,
  [2031] = 1702,
  [2032] = 1703,
  [2033] = 1704,
  [2034] = 1705,
  [2035] = 1706,
  [2036] = 1707,
  [2037] = 1678,
  [2038] = 1680,
  [2039] = 1692,
  [2040] = 1701,
  [2041] = 1708,
  [2042] = 1709,
  [2043] = 1710,
  [2044] = 1717,
  [2045] = 1719,
  [2046] = 1675,
  [2047] = 1681,
  [2048] = 1724,
  [2049] = 1725,
  [2050] = 1726,
  [2051] = 1682,
  [2052] = 1727,
  [2053] = 1730,
  [2054] = 1718,
  [2055] = 1693,
  [2056] = 1675,
  [2057] = 1702,
  [2058] = 1703,
  [2059] = 1704,
  [2060] = 1705,
  [2061] = 1706,
  [2062] = 1707,
  [2063] = 1677,
  [2064] = 1680,
  [2065] = 1692,
  [2066] = 1701,
  [2067] = 1708,
  [2068] = 1709,
  [2069] = 1710,
  [2070] = 1717,
  [2071] = 1719,
  [2072] = 1724,
  [2073] = 1725,
  [2074] = 1726,
  [2075] = 1727,
  [2076] = 1730,
  [2077] = 1718,
  [2078] = 1693,
  [2079] = 1678,
  [2080] = 1702,
  [2081] = 1703,
  [2082] = 1681,
  [2083] = 1704,
  [2084] = 1705,
  [2085] = 1682,
  [2086] = 1706,
  [2087] = 1707,
  [2088] = 1680,
  [2089] = 1692,
  [2090] = 1701,
  [2091] = 1708,
  [2092] = 1709,
  [2093] = 1710,
  [2094] = 1717,
  [2095] = 1719,
  [2096] = 1724,
  [2097] = 1725,
  [2098] = 1726,
  [2099] = 1727,
  [2100] = 1675,
  [2101] = 1730,
  [2102] = 1718,
  [2103] = 1693,
  [2104] = 1677,
  [2105] = 1702,
  [2106] = 1703,
  [2107] = 1704,
  [2108] = 1705,
  [2109] = 1706,
  [2110] = 1707,
  [2111] = 1678,
  [2112] = 1680,
  [2113] = 1692,
  [2114] = 1701,
  [2115] = 1708,
  [2116] = 1709,
  [2117] = 1710,
  [2118] = 1717,
  [2119] = 1719,
  [2120] = 1724,
  [2121] = 1725,
  [2122] = 1726,
  [2123] = 1727,
  [2124] = 1681,
  [2125] = 1730,
  [2126] = 1682,
  [2127] = 1718,
  [2128] = 1693,
  [2129] = 1675,
  [2130] = 1702,
  [2131] = 1703,
  [2132] = 1704,
  [2133] = 1705,
  [2134] = 1706,
  [2135] = 1707,
  [2136] = 1677,
  [2137] = 1680,
  [2138] = 1692,
  [2139] = 1701,
  [2140] = 1708,
  [2141] = 1709,
  [2142] = 1710,
  [2143] = 1717,
  [2144] = 1719,
  [2145] = 1724,
  [2146] = 1725,
  [2147] = 1726,
  [2148] = 1727,
  [2149] = 1730,
  [2150] = 1718,
  [2151] = 1693,
  [2152] = 1678,
  [2153] = 1702,
  [2154] = 1703,
  [2155] = 1704,
  [2156] = 1705,
  [2157] = 1706,
  [2158] = 1707,
  [2159] = 1680,
  [2160] = 1692,
  [2161] = 1701,
  [2162] = 1708,
  [2163] = 1709,
  [2164] = 1710,
  [2165] = 1717,
  [2166] = 1677,
  [2167] = 1719,
  [2168] = 1681,
  [2169] = 1682,
  [2170] = 1724,
  [2171] = 1725,
  [2172] = 1726,
  [2173] = 1727,
  [2174] = 1730,
  [2175] = 1718,
  [2176] = 1693,
  [2177] = 1675,
  [2178] = 1702,
  [2179] = 1703,
  [2180] = 1704,
  [2181] = 1705,
  [2182] = 1706,
  [2183] = 1707,
  [2184] = 1680,
  [2185] = 1692,
  [2186] = 1701,
  [2187] = 1708,
  [2188] = 1709,
  [2189] = 1710,
  [2190] = 1717,
  [2191] = 1719,
  [2192] = 1724,
  [2193] = 1725,
  [2194] = 1726,
  [2195] = 1727,
  [2196] = 1730,
  [2197] = 1718,
  [2198] = 1693,
  [2199] = 1702,
  [2200] = 1704,
  [2201] = 1705,
  [2202] = 1706,
  [2203] = 1707,
  [2204] = 1680,
  [2205] = 1677,
  [2206] = 1692,
  [2207] = 1701,
  [2208] = 1708,
  [2209] = 1709,
  [2210] = 1717,
  [2211] = 1705,
  [2212] = 1719,
  [2213] = 1724,
  [2214] = 1725,
  [2215] = 1726,
  [2216] = 1727,
  [2217] = 1730,
  [2218] = 1718,
  [2219] = 1693,
  [2220] = 1702,
  [2221] = 1704,
  [2222] = 1705,
  [2223] = 1706,
  [2224] = 1707,
  [2225] = 1680,
  [2226] = 1692,
  [2227] = 1701,
  [2228] = 1708,
  [2229] = 1709,
  [2230] = 1717,
  [2231] = 1719,
  [2232] = 1724,
  [2233] = 1725,
  [2234] = 1726,
  [2235] = 1727,
  [2236] = 1730,
  [2237] = 1718,
  [2238] = 1693,
  [2239] = 1702,
  [2240] = 1704,
  [2241] = 1705,
  [2242] = 1706,
  [2243] = 1707,
  [2244] = 1680,
  [2245] = 1692,
  [2246] = 1701,
  [2247] = 1708,
  [2248] = 1709,
  [2249] = 1717,
  [2250] = 1719,
  [2251] = 1724,
  [2252] = 1725,
  [2253] = 1726,
  [2254] = 1727,
  [2255] = 1730,
  [2256] = 1718,
  [2257] = 1693,
  [2258] = 1678,
  [2259] = 1702,
  [2260] = 1704,
  [2261] = 1705,
  [2262] = 1706,
  [2263] = 1707,
  [2264] = 1680,
  [2265] = 1692,
  [2266] = 1701,
  [2267] = 1708,
  [2268] = 1709,
  [2269] = 1717,
  [2270] = 1719,
  [2271] = 1724,
  [2272] = 1725,
  [2273] = 1726,
  [2274] = 1727,
  [2275] = 1730,
  [2276] = 1718,
  [2277] = 1693,
  [2278] = 1702,
  [2279] = 1704,
  [2280] = 1705,
  [2281] = 1706,
  [2282] = 1707,
  [2283] = 1680,
  [2284] = 1692,
  [2285] = 1701,
  [2286] = 1708,
  [2287] = 1709,
  [2288] = 1717,
  [2289] = 1719,
  [2290] = 1724,
  [2291] = 1725,
  [2292] = 1726,
  [2293] = 1727,
  [2294] = 1730,
  [2295] = 1718,
  [2296] = 1693,
  [2297] = 1702,
  [2298] = 1704,
  [2299] = 1705,
  [2300] = 1706,
  [2301] = 1707,
  [2302] = 1680,
  [2303] = 1692,
  [2304] = 1701,
  [2305] = 1708,
  [2306] = 1709,
  [2307] = 1717,
  [2308] = 1719,
  [2309] = 1724,
  [2310] = 1725,
  [2311] = 1726,
  [2312] = 1727,
  [2313] = 1730,
  [2314] = 1718,
  [2315] = 1693,
  [2316] = 1702,
  [2317] = 1704,
  [2318] = 1705,
  [2319] = 1706,
  [2320] = 1707,
  [2321] = 1693,
  [2322] = 1680,
  [2323] = 1692,
  [2324] = 1701,
  [2325] = 1708,
  [2326] = 1709,
  [2327] = 1717,
  [2328] = 1681,
  [2329] = 1719,
  [2330] = 1682,
  [2331] = 1724,
  [2332] = 1725,
  [2333] = 1726,
  [2334] = 1727,
  [2335] = 1730,
  [2336] = 1718,
  [2337] = 1693,
  [2338] = 1706,
  [2339] = 1702,
  [2340] = 1704,
  [2341] = 1705,
  [2342] = 1706,
  [2343] = 1707,
  [2344] = 1680,
  [2345] = 1692,
  [2346] = 1701,
  [2347] = 1708,
  [2348] = 1709,
  [2349] = 1717,
  [2350] = 1719,
  [2351] = 1724,
  [2352] = 1725,
  [2353] = 1726,
  [2354] = 1727,
  [2355] = 1730,
  [2356] = 1718,
  [2357] = 1693,
  [2358] = 1675,
  [2359] = 1702,
  [2360] = 1704,
  [2361] = 1705,
  [2362] = 1706,
  [2363] = 1707,
  [2364] = 1680,
  [2365] = 1692,
  [2366] = 1701,
  [2367] = 1708,
  [2368] = 1709,
  [2369] = 1717,
  [2370] = 1719,
  [2371] = 1724,
  [2372] = 1725,
  [2373] = 1726,
  [2374] = 1727,
  [2375] = 1730,
  [2376] = 1718,
  [2377] = 1693,
  [2378] = 1702,
  [2379] = 1704,
  [2380] = 1705,
  [2381] = 1706,
  [2382] = 1707,
  [2383] = 1680,
  [2384] = 1692,
  [2385] = 1701,
  [2386] = 1708,
  [2387] = 1709,
  [2388] = 1717,
  [2389] = 1719,
  [2390] = 1724,
  [2391] = 1725,
  [2392] = 1726,
  [2393] = 1727,
  [2394] = 1730,
  [2395] = 1718,
  [2396] = 1693,
  [2397] = 1677,
  [2398] = 1707,
  [2399] = 1702,
  [2400] = 1704,
  [2401] = 1705,
  [2402] = 1706,
  [2403] = 1707,
  [2404] = 1680,
  [2405] = 1692,
  [2406] = 1701,
  [2407] = 1708,
  [2408] = 1709,
  [2409] = 1717,
  [2410] = 1719,
  [2411] = 1724,
  [2412] = 1725,
  [2413] = 1726,
  [2414] = 1727,
  [2415] = 1730,
  [2416] = 1718,
  [2417] = 1693,
  [2418] = 1702,
  [2419] = 1704,
  [2420] = 1705,
  [2421] = 1706,
  [2422] = 1707,
  [2423] = 1680,
  [2424] = 1692,
  [2425] = 1701,
  [2426] = 1708,
  [2427] = 1709,
  [2428] = 1717,
  [2429] = 1719,
  [2430] = 1724,
  [2431] = 1725,
  [2432] = 1726,
  [2433] = 1727,
  [2434] = 1730,
  [2435] = 1718,
  [2436] = 1693,
  [2437] = 1702,
  [2438] = 1704,
  [2439] = 1705,
  [2440] = 1706,
  [2441] = 1707,
  [2442] = 1680,
  [2443] = 1692,
  [2444] = 1701,
  [2445] = 1708,
  [2446] = 1709,
  [2447] = 1717,
  [2448] = 1719,
  [2449] = 1678,
  [2450] = 1724,
  [2451] = 1725,
  [2452] = 1726,
  [2453] = 1727,
  [2454] = 1730,
  [2455] = 1718,
  [2456] = 1693,
  [2457] = 1702,
  [2458] = 1704,
  [2459] = 1705,
  [2460] = 1706,
  [2461] = 1707,
  [2462] = 1680,
  [2463] = 1692,
  [2464] = 1701,
  [2465] = 1708,
  [2466] = 1709,
  [2467] = 1717,
  [2468] = 1719,
  [2469] = 1724,
  [2470] = 1725,
  [2471] = 1726,
  [2472] = 1727,
  [2473] = 1730,
  [2474] = 1718,
  [2475] = 1693,
  [2476] = 1702,
  [2477] = 1704,
  [2478] = 1705,
  [2479] = 1706,
  [2480] = 1707,
  [2481] = 1680,
  [2482] = 1692,
  [2483] = 1701,
  [2484] = 1708,
  [2485] = 1709,
  [2486] = 1717,
  [2487] = 1719,
  [2488] = 1724,
  [2489] = 1725,
  [2490] = 1726,
  [2491] = 1727,
  [2492] = 1730,
  [2493] = 1718,
  [2494] = 1693,
  [2495] = 1702,
  [2496] = 1704,
  [2497] = 1705,
  [2498] = 1706,
  [2499] = 1707,
  [2500] = 1680,
  [2501] = 1692,
  [2502] = 1701,
  [2503] = 1708,
  [2504] = 1709,
  [2505] = 1717,
  [2506] = 1719,
  [2507] = 1724,
  [2508] = 1725,
  [2509] = 1726,
  [2510] = 1681,
  [2511] = 1727,
  [2512] = 1682,
  [2513] = 1730,
  [2514] = 1718,
  [2515] = 1693,
  [2516] = 1681,
  [2517] = 1682,
  [2518] = 2518,
  [2519] = 1702,
  [2520] = 1704,
  [2521] = 1705,
  [2522] = 1706,
  [2523] = 1707,
  [2524] = 1680,
  [2525] = 1692,
  [2526] = 1701,
  [2527] = 1708,
  [2528] = 1709,
  [2529] = 1717,
  [2530] = 1675,
  [2531] = 1719,
  [2532] = 1724,
  [2533] = 1725,
  [2534] = 1726,
  [2535] = 1727,
  [2536] = 1730,
  [2537] = 1718,
  [2538] = 1693,
  [2539] = 1702,
  [2540] = 1704,
  [2541] = 1705,
  [2542] = 1706,
  [2543] = 1707,
  [2544] = 1680,
  [2545] = 1692,
  [2546] = 1701,
  [2547] = 1708,
  [2548] = 1709,
  [2549] = 1717,
  [2550] = 1719,
  [2551] = 1724,
  [2552] = 1725,
  [2553] = 1726,
  [2554] = 1727,
  [2555] = 1730,
  [2556] = 1718,
  [2557] = 1693,
  [2558] = 1693,
  [2559] = 1702,
  [2560] = 1704,
  [2561] = 1705,
  [2562] = 1706,
  [2563] = 1707,
  [2564] = 1680,
  [2565] = 1692,
  [2566] = 1701,
  [2567] = 1708,
  [2568] = 1709,
  [2569] = 1717,
  [2570] = 1719,
  [2571] = 1724,
  [2572] = 1725,
  [2573] = 1726,
  [2574] = 1727,
  [2575] = 1730,
  [2576] = 1718,
  [2577] = 1693,
  [2578] = 1702,
  [2579] = 1704,
  [2580] = 1705,
  [2581] = 1706,
  [2582] = 1707,
  [2583] = 1678,
  [2584] = 1680,
  [2585] = 1692,
  [2586] = 1701,
  [2587] = 1708,
  [2588] = 1709,
  [2589] = 1717,
  [2590] = 1719,
  [2591] = 1724,
  [2592] = 1725,
  [2593] = 1726,
  [2594] = 1727,
  [2595] = 1730,
  [2596] = 1718,
  [2597] = 1693,
  [2598] = 1702,
  [2599] = 1704,
  [2600] = 1705,
  [2601] = 1706,
  [2602] = 1707,
  [2603] = 1680,
  [2604] = 1692,
  [2605] = 1701,
  [2606] = 1708,
  [2607] = 1709,
  [2608] = 1717,
  [2609] = 1719,
  [2610] = 1724,
  [2611] = 1725,
  [2612] = 1726,
  [2613] = 1727,
  [2614] = 1681,
  [2615] = 1730,
  [2616] = 1718,
  [2617] = 1693,
  [2618] = 1682,
  [2619] = 1702,
  [2620] = 1704,
  [2621] = 1705,
  [2622] = 1706,
  [2623] = 1707,
  [2624] = 1680,
  [2625] = 1692,
  [2626] = 1701,
  [2627] = 1708,
  [2628] = 1709,
  [2629] = 1717,
  [2630] = 1719,
  [2631] = 1724,
  [2632] = 1725,
  [2633] = 1726,
  [2634] = 1727,
  [2635] = 1730,
  [2636] = 1718,
  [2637] = 1693,
  [2638] = 1702,
  [2639] = 1704,
  [2640] = 1705,
  [2641] = 1706,
  [2642] = 1707,
  [2643] = 1680,
  [2644] = 1692,
  [2645] = 1701,
  [2646] = 1708,
  [2647] = 1709,
  [2648] = 1717,
  [2649] = 1675,
  [2650] = 1719,
  [2651] = 1724,
  [2652] = 1725,
  [2653] = 1726,
  [2654] = 1727,
  [2655] = 1730,
  [2656] = 1718,
  [2657] = 1693,
  [2658] = 1702,
  [2659] = 1704,
  [2660] = 1705,
  [2661] = 1706,
  [2662] = 1707,
  [2663] = 1680,
  [2664] = 1692,
  [2665] = 1701,
  [2666] = 1708,
  [2667] = 1709,
  [2668] = 1717,
  [2669] = 1719,
  [2670] = 1724,
  [2671] = 1725,
  [2672] = 1726,
  [2673] = 1727,
  [2674] = 1730,
  [2675] = 1718,
  [2676] = 1693,
  [2677] = 1677,
  [2678] = 1702,
  [2679] = 1704,
  [2680] = 1705,
  [2681] = 1706,
  [2682] = 1707,
  [2683] = 1680,
  [2684] = 1692,
  [2685] = 1701,
  [2686] = 1708,
  [2687] = 1709,
  [2688] = 1717,
  [2689] = 1719,
  [2690] = 1724,
  [2691] = 1725,
  [2692] = 1726,
  [2693] = 1727,
  [2694] = 1730,
  [2695] = 1718,
  [2696] = 1693,
  [2697] = 1702,
  [2698] = 1704,
  [2699] = 1705,
  [2700] = 1706,
  [2701] = 1707,
  [2702] = 1680,
  [2703] = 1692,
  [2704] = 1701,
  [2705] = 1708,
  [2706] = 1709,
  [2707] = 1717,
  [2708] = 1719,
  [2709] = 1724,
  [2710] = 1725,
  [2711] = 1726,
  [2712] = 1727,
  [2713] = 1730,
  [2714] = 1718,
  [2715] = 1693,
  [2716] = 1702,
  [2717] = 1704,
  [2718] = 1705,
  [2719] = 1678,
  [2720] = 1706,
  [2721] = 1707,
  [2722] = 1680,
  [2723] = 1692,
  [2724] = 1701,
  [2725] = 1708,
  [2726] = 1709,
  [2727] = 1717,
  [2728] = 1719,
  [2729] = 1724,
  [2730] = 1725,
  [2731] = 1726,
  [2732] = 1727,
  [2733] = 1730,
  [2734] = 1718,
  [2735] = 1693,
  [2736] = 1702,
  [2737] = 1704,
  [2738] = 1705,
  [2739] = 1706,
  [2740] = 1707,
  [2741] = 1680,
  [2742] = 1692,
  [2743] = 1701,
  [2744] = 1708,
  [2745] = 1709,
  [2746] = 1717,
  [2747] = 1719,
  [2748] = 1724,
  [2749] = 1725,
  [2750] = 1726,
  [2751] = 1727,
  [2752] = 1730,
  [2753] = 1718,
  [2754] = 1702,
  [2755] = 1704,
  [2756] = 1705,
  [2757] = 1706,
  [2758] = 1707,
  [2759] = 1680,
  [2760] = 1692,
  [2761] = 1701,
  [2762] = 1708,
  [2763] = 1709,
  [2764] = 1717,
  [2765] = 1681,
  [2766] = 1682,
  [2767] = 1719,
  [2768] = 1724,
  [2769] = 1725,
  [2770] = 1726,
  [2771] = 1727,
  [2772] = 1730,
  [2773] = 1718,
  [2774] = 1702,
  [2775] = 1704,
  [2776] = 1705,
  [2777] = 1706,
  [2778] = 1707,
  [2779] = 1680,
  [2780] = 1692,
  [2781] = 1701,
  [2782] = 1708,
  [2783] = 1709,
  [2784] = 1717,
  [2785] = 1719,
  [2786] = 1724,
  [2787] = 1725,
  [2788] = 1726,
  [2789] = 1730,
  [2790] = 1718,
  [2791] = 1675,
  [2792] = 1702,
  [2793] = 1704,
  [2794] = 1705,
  [2795] = 1706,
  [2796] = 1707,
  [2797] = 1680,
  [2798] = 1692,
  [2799] = 1701,
  [2800] = 1708,
  [2801] = 1709,
  [2802] = 1717,
  [2803] = 1719,
  [2804] = 1724,
  [2805] = 1725,
  [2806] = 1726,
  [2807] = 1730,
  [2808] = 1718,
  [2809] = 1704,
  [2810] = 1705,
  [2811] = 1706,
  [2812] = 1707,
  [2813] = 1692,
  [2814] = 1701,
  [2815] = 1717,
  [2816] = 1719,
  [2817] = 1726,
  [2818] = 1718,
  [2819] = 1677,
  [2820] = 1704,
  [2821] = 1705,
  [2822] = 1706,
  [2823] = 1707,
  [2824] = 1692,
  [2825] = 1701,
  [2826] = 1717,
  [2827] = 1719,
  [2828] = 1726,
  [2829] = 1718,
  [2830] = 1704,
  [2831] = 1705,
  [2832] = 1678,
  [2833] = 1706,
  [2834] = 1707,
  [2835] = 1692,
  [2836] = 1701,
  [2837] = 1717,
  [2838] = 1719,
  [2839] = 1726,
  [2840] = 1718,
  [2841] = 1704,
  [2842] = 1705,
  [2843] = 1706,
  [2844] = 1707,
  [2845] = 1692,
  [2846] = 1701,
  [2847] = 1717,
  [2848] = 1719,
  [2849] = 1726,
  [2850] = 1681,
  [2851] = 1718,
  [2852] = 1682,
  [2853] = 1704,
  [2854] = 1705,
  [2855] = 1706,
  [2856] = 1707,
  [2857] = 1692,
  [2858] = 1701,
  [2859] = 1717,
  [2860] = 1719,
  [2861] = 1726,
  [2862] = 1718,
  [2863] = 1675,
  [2864] = 1704,
  [2865] = 1705,
  [2866] = 1706,
  [2867] = 1707,
  [2868] = 1692,
  [2869] = 1701,
  [2870] = 1717,
  [2871] = 1719,
  [2872] = 1726,
  [2873] = 1718,
  [2874] = 1704,
  [2875] = 1705,
  [2876] = 1706,
  [2877] = 1707,
  [2878] = 1692,
  [2879] = 1701,
  [2880] = 1717,
  [2881] = 1719,
  [2882] = 1726,
  [2883] = 1718,
  [2884] = 1704,
  [2885] = 1705,
  [2886] = 1706,
  [2887] = 1707,
  [2888] = 1692,
  [2889] = 1701,
  [2890] = 1717,
  [2891] = 1677,
  [2892] = 1719,
  [2893] = 1726,
  [2894] = 1718,
  [2895] = 1704,
  [2896] = 1705,
  [2897] = 1706,
  [2898] = 1707,
  [2899] = 1692,
  [2900] = 1701,
  [2901] = 1717,
  [2902] = 1719,
  [2903] = 1726,
  [2904] = 1718,
  [2905] = 1704,
  [2906] = 1705,
  [2907] = 1678,
  [2908] = 1706,
  [2909] = 1707,
  [2910] = 1692,
  [2911] = 1701,
  [2912] = 1717,
  [2913] = 1719,
  [2914] = 1726,
  [2915] = 1718,
  [2916] = 1704,
  [2917] = 1705,
  [2918] = 1706,
  [2919] = 1707,
  [2920] = 1692,
  [2921] = 1701,
  [2922] = 1717,
  [2923] = 1719,
  [2924] = 1726,
  [2925] = 1718,
  [2926] = 1704,
  [2927] = 1705,
  [2928] = 1706,
  [2929] = 1707,
  [2930] = 1692,
  [2931] = 1701,
  [2932] = 1717,
  [2933] = 1681,
  [2934] = 1682,
  [2935] = 1719,
  [2936] = 1726,
  [2937] = 1718,
  [2938] = 1704,
  [2939] = 1705,
  [2940] = 1706,
  [2941] = 1707,
  [2942] = 1692,
  [2943] = 1701,
  [2944] = 1717,
  [2945] = 1719,
  [2946] = 1726,
  [2947] = 1718,
  [2948] = 1675,
  [2949] = 1704,
  [2950] = 1705,
  [2951] = 1706,
  [2952] = 1707,
  [2953] = 1692,
  [2954] = 1701,
  [2955] = 1717,
  [2956] = 1719,
  [2957] = 1726,
  [2958] = 1718,
  [2959] = 1704,
  [2960] = 1705,
  [2961] = 1706,
  [2962] = 1707,
  [2963] = 1692,
  [2964] = 1701,
  [2965] = 1717,
  [2966] = 1719,
  [2967] = 1726,
  [2968] = 1718,
  [2969] = 1704,
  [2970] = 1705,
  [2971] = 1706,
  [2972] = 1707,
  [2973] = 1692,
  [2974] = 1701,
  [2975] = 1717,
  [2976] = 1677,
  [2977] = 1675,
  [2978] = 1719,
  [2979] = 1726,
  [2980] = 1718,
  [2981] = 1704,
  [2982] = 1705,
  [2983] = 1706,
  [2984] = 1707,
  [2985] = 1692,
  [2986] = 1701,
  [2987] = 1717,
  [2988] = 1719,
  [2989] = 1726,
  [2990] = 1678,
  [2991] = 1718,
  [2992] = 1704,
  [2993] = 1705,
  [2994] = 1706,
  [2995] = 1707,
  [2996] = 1692,
  [2997] = 1701,
  [2998] = 1717,
  [2999] = 1719,
  [3000] = 1726,
  [3001] = 1718,
  [3002] = 1704,
  [3003] = 1705,
  [3004] = 1706,
  [3005] = 1707,
  [3006] = 1692,
  [3007] = 1701,
  [3008] = 1717,
  [3009] = 1681,
  [3010] = 1682,
  [3011] = 1719,
  [3012] = 1726,
  [3013] = 1718,
  [3014] = 1704,
  [3015] = 1705,
  [3016] = 1706,
  [3017] = 1707,
  [3018] = 1692,
  [3019] = 1701,
  [3020] = 1717,
  [3021] = 1719,
  [3022] = 1726,
  [3023] = 1718,
  [3024] = 1675,
  [3025] = 1704,
  [3026] = 1705,
  [3027] = 1706,
  [3028] = 1707,
  [3029] = 1692,
  [3030] = 1701,
  [3031] = 1717,
  [3032] = 1719,
  [3033] = 1726,
  [3034] = 1718,
  [3035] = 1704,
  [3036] = 1705,
  [3037] = 1706,
  [3038] = 1707,
  [3039] = 1692,
  [3040] = 1701,
  [3041] = 1717,
  [3042] = 1719,
  [3043] = 1726,
  [3044] = 1718,
  [3045] = 1704,
  [3046] = 1705,
  [3047] = 1706,
  [3048] = 1707,
  [3049] = 1692,
  [3050] = 1701,
  [3051] = 1717,
  [3052] = 1719,
  [3053] = 1726,
  [3054] = 1718,
  [3055] = 1677,
  [3056] = 1704,
  [3057] = 1705,
  [3058] = 1706,
  [3059] = 1707,
  [3060] = 1692,
  [3061] = 1701,
  [3062] = 1717,
  [3063] = 1719,
  [3064] = 1726,
  [3065] = 1704,
  [3066] = 1705,
  [3067] = 1678,
  [3068] = 1706,
  [3069] = 1707,
  [3070] = 1692,
  [3071] = 1701,
  [3072] = 1717,
  [3073] = 1719,
  [3074] = 1726,
  [3075] = 1706,
  [3076] = 1692,
  [3077] = 1719,
  [3078] = 1692,
  [3079] = 1692,
  [3080] = 1692,
  [3081] = 1692,
  [3082] = 1692,
  [3083] = 1692,
  [3084] = 1692,
  [3085] = 1692,
  [3086] = 1692,
  [3087] = 1692,
  [3088] = 1692,
  [3089] = 1692,
  [3090] = 1692,
  [3091] = 1692,
  [3092] = 1692,
  [3093] = 1692,
  [3094] = 1692,
  [3095] = 1692,
  [3096] = 1692,
  [3097] = 1692,
  [3098] = 1692,
  [3099] = 1692,
  [3100] = 1692,
  [3101] = 1692,
  [3102] = 1692,
  [3103] = 1692,
  [3104] = 1692,
  [3105] = 1692,
  [3106] = 1692,
  [3107] = 1692,
  [3108] = 1692,
  [3109] = 1692,
  [3110] = 1692,
  [3111] = 1692,
  [3112] = 1692,
  [3113] = 1692,
  [3114] = 1692,
  [3115] = 1692,
  [3116] = 1692,
  [3117] = 1692,
  [3118] = 1692,
  [3119] = 1692,
  [3120] = 1692,
  [3121] = 1692,
  [3122] = 1692,
  [3123] = 1692,
  [3124] = 1692,
  [3125] = 1692,
  [3126] = 1692,
  [3127] = 1692,
  [3128] = 1692,
  [3129] = 1692,
  [3130] = 1692,
  [3131] = 1692,
  [3132] = 1692,
  [3133] = 1692,
  [3134] = 1692,
  [3135] = 1692,
  [3136] = 1692,
  [3137] = 1692,
  [3138] = 1692,
  [3139] = 1692,
  [3140] = 1692,
  [3141] = 1692,
  [3142] = 1692,
  [3143] = 1692,
  [3144] = 1692,
  [3145] = 1692,
  [3146] = 1692,
  [3147] = 2518,
  [3148] = 1778,
  [3149] = 1997,
  [3150] = 1681,
  [3151] = 1693,
  [3152] = 1682,
  [3153] = 1693,
  [3154] = 1693,
  [3155] = 2518,
  [3156] = 1778,
  [3157] = 1778,
  [3158] = 1693,
  [3159] = 2518,
  [3160] = 1778,
  [3161] = 1693,
  [3162] = 1675,
  [3163] = 2518,
  [3164] = 1778,
  [3165] = 2518,
  [3166] = 1778,
  [3167] = 2518,
  [3168] = 1778,
  [3169] = 2518,
  [3170] = 1778,
  [3171] = 2518,
  [3172] = 1778,
  [3173] = 1677,
  [3174] = 2518,
  [3175] = 1778,
  [3176] = 2518,
  [3177] = 1778,
  [3178] = 2518,
  [3179] = 1778,
  [3180] = 1678,
  [3181] = 2518,
  [3182] = 1778,
  [3183] = 1778,
  [3184] = 1778,
  [3185] = 1778,
  [3186] = 1778,
  [3187] = 1778,
  [3188] = 1778,
  [3189] = 1778,
  [3190] = 1778,
  [3191] = 1778,
  [3192] = 1778,
  [3193] = 1778,
  [3194] = 1778,
  [3195] = 1778,
  [3196] = 1778,
  [3197] = 1778,
  [3198] = 1778,
  [3199] = 1778,
  [3200] = 1718,
  [3201] = 1778,
  [3202] = 1681,
  [3203] = 1778,
  [3204] = 1682,
  [3205] = 1778,
  [3206] = 1778,
  [3207] = 1778,
  [3208] = 1778,
  [3209] = 1778,
  [3210] = 1778,
  [3211] = 1721,
  [3212] = 1778,
  [3213] = 1778,
  [3214] = 1778,
  [3215] = 1778,
  [3216] = 1778,
  [3217] = 1778,
  [3218] = 1778,
  [3219] = 1778,
  [3220] = 1778,
  [3221] = 1778,
  [3222] = 1778,
  [3223] = 1778,
  [3224] = 1778,
  [3225] = 1778,
  [3226] = 1778,
  [3227] = 1778,
  [3228] = 1778,
  [3229] = 1778,
  [3230] = 1778,
  [3231] = 1677,
  [3232] = 3232,
  [3233] = 3232,
  [3234] = 3234,
  [3235] = 3235,
  [3236] = 3236,
  [3237] = 3232,
  [3238] = 3238,
  [3239] = 3232,
  [3240] = 3232,
  [3241] = 3241,
  [3242] = 3242,
  [3243] = 3238,
  [3244] = 3235,
  [3245] = 3232,
  [3246] = 3232,
  [3247] = 3247,
  [3248] = 3248,
  [3249] = 3249,
  [3250] = 3247,
  [3251] = 3251,
  [3252] = 3252,
  [3253] = 3253,
  [3254] = 3254,
  [3255] = 3255,
  [3256] = 3256,
  [3257] = 3257,
  [3258] = 3258,
  [3259] = 3259,
  [3260] = 3260,
  [3261] = 3261,
  [3262] = 3262,
  [3263] = 3263,
  [3264] = 3248,
  [3265] = 3249,
  [3266] = 3266,
  [3267] = 3247,
  [3268] = 3252,
  [3269] = 3253,
  [3270] = 3251,
  [3271] = 3254,
  [3272] = 3247,
  [3273] = 3273,
  [3274] = 3266,
  [3275] = 3255,
  [3276] = 3256,
  [3277] = 3257,
  [3278] = 3258,
  [3279] = 3252,
  [3280] = 3251,
  [3281] = 3281,
  [3282] = 3259,
  [3283] = 3253,
  [3284] = 3260,
  [3285] = 3285,
  [3286] = 3266,
  [3287] = 3252,
  [3288] = 3253,
  [3289] = 3254,
  [3290] = 3255,
  [3291] = 3261,
  [3292] = 3262,
  [3293] = 3256,
  [3294] = 3263,
  [3295] = 3257,
  [3296] = 3258,
  [3297] = 3252,
  [3298] = 3248,
  [3299] = 3253,
  [3300] = 3249,
  [3301] = 3259,
  [3302] = 3254,
  [3303] = 3257,
  [3304] = 3247,
  [3305] = 3251,
  [3306] = 3260,
  [3307] = 3258,
  [3308] = 3251,
  [3309] = 3261,
  [3310] = 3262,
  [3311] = 3263,
  [3312] = 3248,
  [3313] = 3249,
  [3314] = 3247,
  [3315] = 3251,
  [3316] = 3254,
  [3317] = 3266,
  [3318] = 3252,
  [3319] = 3253,
  [3320] = 3254,
  [3321] = 3252,
  [3322] = 3253,
  [3323] = 3254,
  [3324] = 3255,
  [3325] = 3256,
  [3326] = 3257,
  [3327] = 3258,
  [3328] = 3259,
  [3329] = 3260,
  [3330] = 3261,
  [3331] = 3262,
  [3332] = 3263,
  [3333] = 3248,
  [3334] = 3249,
  [3335] = 3247,
  [3336] = 3251,
  [3337] = 3255,
  [3338] = 3256,
  [3339] = 3255,
  [3340] = 3252,
  [3341] = 3253,
  [3342] = 3254,
  [3343] = 3252,
  [3344] = 3253,
  [3345] = 3345,
  [3346] = 3254,
  [3347] = 3255,
  [3348] = 3256,
  [3349] = 3257,
  [3350] = 3258,
  [3351] = 3259,
  [3352] = 3260,
  [3353] = 3261,
  [3354] = 3262,
  [3355] = 3263,
  [3356] = 3248,
  [3357] = 3266,
  [3358] = 3249,
  [3359] = 3247,
  [3360] = 3251,
  [3361] = 3252,
  [3362] = 3255,
  [3363] = 3253,
  [3364] = 3254,
  [3365] = 3255,
  [3366] = 3256,
  [3367] = 3255,
  [3368] = 3257,
  [3369] = 3369,
  [3370] = 3258,
  [3371] = 3259,
  [3372] = 3260,
  [3373] = 3261,
  [3374] = 3262,
  [3375] = 3263,
  [3376] = 3248,
  [3377] = 3249,
  [3378] = 3247,
  [3379] = 3251,
  [3380] = 3256,
  [3381] = 3257,
  [3382] = 3258,
  [3383] = 3256,
  [3384] = 3259,
  [3385] = 3252,
  [3386] = 3253,
  [3387] = 3254,
  [3388] = 3255,
  [3389] = 3256,
  [3390] = 3257,
  [3391] = 3258,
  [3392] = 3259,
  [3393] = 3260,
  [3394] = 3261,
  [3395] = 3266,
  [3396] = 3262,
  [3397] = 3263,
  [3398] = 3252,
  [3399] = 3248,
  [3400] = 3253,
  [3401] = 3266,
  [3402] = 3249,
  [3403] = 3247,
  [3404] = 3254,
  [3405] = 3255,
  [3406] = 3256,
  [3407] = 3257,
  [3408] = 3251,
  [3409] = 3260,
  [3410] = 3261,
  [3411] = 3258,
  [3412] = 3262,
  [3413] = 3263,
  [3414] = 3259,
  [3415] = 3248,
  [3416] = 3252,
  [3417] = 3253,
  [3418] = 3252,
  [3419] = 3260,
  [3420] = 3261,
  [3421] = 3262,
  [3422] = 3253,
  [3423] = 3266,
  [3424] = 3252,
  [3425] = 3263,
  [3426] = 3253,
  [3427] = 3248,
  [3428] = 3254,
  [3429] = 3255,
  [3430] = 3256,
  [3431] = 3249,
  [3432] = 3247,
  [3433] = 3251,
  [3434] = 3257,
  [3435] = 3258,
  [3436] = 3259,
  [3437] = 3260,
  [3438] = 3261,
  [3439] = 3262,
  [3440] = 3263,
  [3441] = 3248,
  [3442] = 3249,
  [3443] = 3247,
  [3444] = 3254,
  [3445] = 3255,
  [3446] = 3256,
  [3447] = 3257,
  [3448] = 3251,
  [3449] = 3258,
  [3450] = 3259,
  [3451] = 3260,
  [3452] = 3254,
  [3453] = 3261,
  [3454] = 3262,
  [3455] = 3263,
  [3456] = 3248,
  [3457] = 3249,
  [3458] = 3247,
  [3459] = 3251,
  [3460] = 3249,
  [3461] = 3255,
  [3462] = 3247,
  [3463] = 3251,
  [3464] = 3256,
  [3465] = 3252,
  [3466] = 3256,
  [3467] = 3253,
  [3468] = 3254,
  [3469] = 3255,
  [3470] = 3256,
  [3471] = 3257,
  [3472] = 3258,
  [3473] = 3257,
  [3474] = 3258,
  [3475] = 3259,
  [3476] = 3260,
  [3477] = 3261,
  [3478] = 3262,
  [3479] = 3263,
  [3480] = 3248,
  [3481] = 3259,
  [3482] = 3260,
  [3483] = 3249,
  [3484] = 3247,
  [3485] = 3251,
  [3486] = 3257,
  [3487] = 3258,
  [3488] = 3259,
  [3489] = 3260,
  [3490] = 3261,
  [3491] = 3252,
  [3492] = 3253,
  [3493] = 3254,
  [3494] = 3255,
  [3495] = 3256,
  [3496] = 3266,
  [3497] = 3252,
  [3498] = 3257,
  [3499] = 3253,
  [3500] = 3258,
  [3501] = 3254,
  [3502] = 3259,
  [3503] = 3255,
  [3504] = 3256,
  [3505] = 3257,
  [3506] = 3258,
  [3507] = 3259,
  [3508] = 3260,
  [3509] = 3261,
  [3510] = 3262,
  [3511] = 3263,
  [3512] = 3248,
  [3513] = 3249,
  [3514] = 3247,
  [3515] = 3251,
  [3516] = 3260,
  [3517] = 3261,
  [3518] = 3262,
  [3519] = 3261,
  [3520] = 3262,
  [3521] = 3263,
  [3522] = 3248,
  [3523] = 3249,
  [3524] = 3247,
  [3525] = 3263,
  [3526] = 3251,
  [3527] = 3262,
  [3528] = 3263,
  [3529] = 3248,
  [3530] = 3249,
  [3531] = 3247,
  [3532] = 3251,
  [3533] = 3257,
  [3534] = 3252,
  [3535] = 3253,
  [3536] = 3254,
  [3537] = 3255,
  [3538] = 3256,
  [3539] = 3248,
  [3540] = 3249,
  [3541] = 3257,
  [3542] = 3258,
  [3543] = 3259,
  [3544] = 3260,
  [3545] = 3261,
  [3546] = 3247,
  [3547] = 3266,
  [3548] = 3252,
  [3549] = 3262,
  [3550] = 3253,
  [3551] = 3266,
  [3552] = 3252,
  [3553] = 3253,
  [3554] = 3254,
  [3555] = 3255,
  [3556] = 3256,
  [3557] = 3257,
  [3558] = 3258,
  [3559] = 3254,
  [3560] = 3255,
  [3561] = 3259,
  [3562] = 3260,
  [3563] = 3261,
  [3564] = 3263,
  [3565] = 3256,
  [3566] = 3248,
  [3567] = 3262,
  [3568] = 3257,
  [3569] = 3258,
  [3570] = 3259,
  [3571] = 3260,
  [3572] = 3249,
  [3573] = 3247,
  [3574] = 3261,
  [3575] = 3263,
  [3576] = 3251,
  [3577] = 3258,
  [3578] = 3248,
  [3579] = 3249,
  [3580] = 3262,
  [3581] = 3263,
  [3582] = 3247,
  [3583] = 3251,
  [3584] = 3248,
  [3585] = 3249,
  [3586] = 3247,
  [3587] = 3251,
  [3588] = 3251,
  [3589] = 3266,
  [3590] = 3252,
  [3591] = 3253,
  [3592] = 3254,
  [3593] = 3252,
  [3594] = 3253,
  [3595] = 3254,
  [3596] = 3255,
  [3597] = 3256,
  [3598] = 3257,
  [3599] = 3258,
  [3600] = 3259,
  [3601] = 3260,
  [3602] = 3261,
  [3603] = 3262,
  [3604] = 3263,
  [3605] = 3248,
  [3606] = 3249,
  [3607] = 3247,
  [3608] = 3251,
  [3609] = 3255,
  [3610] = 3610,
  [3611] = 3256,
  [3612] = 3281,
  [3613] = 3257,
  [3614] = 3252,
  [3615] = 3253,
  [3616] = 3254,
  [3617] = 3255,
  [3618] = 3256,
  [3619] = 3610,
  [3620] = 3257,
  [3621] = 3258,
  [3622] = 3259,
  [3623] = 3623,
  [3624] = 3260,
  [3625] = 3261,
  [3626] = 3262,
  [3627] = 3263,
  [3628] = 3248,
  [3629] = 3249,
  [3630] = 3247,
  [3631] = 3251,
  [3632] = 3258,
  [3633] = 3266,
  [3634] = 3259,
  [3635] = 3260,
  [3636] = 3252,
  [3637] = 3266,
  [3638] = 3261,
  [3639] = 3639,
  [3640] = 3253,
  [3641] = 3252,
  [3642] = 3253,
  [3643] = 3252,
  [3644] = 3253,
  [3645] = 3254,
  [3646] = 3254,
  [3647] = 3254,
  [3648] = 3255,
  [3649] = 3255,
  [3650] = 3256,
  [3651] = 3257,
  [3652] = 3258,
  [3653] = 3255,
  [3654] = 3256,
  [3655] = 3259,
  [3656] = 3257,
  [3657] = 3258,
  [3658] = 3259,
  [3659] = 3260,
  [3660] = 3256,
  [3661] = 3260,
  [3662] = 3261,
  [3663] = 3257,
  [3664] = 3261,
  [3665] = 3262,
  [3666] = 3258,
  [3667] = 3263,
  [3668] = 3248,
  [3669] = 3249,
  [3670] = 3247,
  [3671] = 3262,
  [3672] = 3263,
  [3673] = 3248,
  [3674] = 3259,
  [3675] = 3249,
  [3676] = 3260,
  [3677] = 3247,
  [3678] = 3251,
  [3679] = 3251,
  [3680] = 3262,
  [3681] = 3261,
  [3682] = 3281,
  [3683] = 3262,
  [3684] = 3263,
  [3685] = 3248,
  [3686] = 3249,
  [3687] = 3247,
  [3688] = 3263,
  [3689] = 3248,
  [3690] = 3249,
  [3691] = 3251,
  [3692] = 3247,
  [3693] = 3252,
  [3694] = 3253,
  [3695] = 3254,
  [3696] = 3255,
  [3697] = 3256,
  [3698] = 3257,
  [3699] = 3258,
  [3700] = 3259,
  [3701] = 3260,
  [3702] = 3261,
  [3703] = 3262,
  [3704] = 3263,
  [3705] = 3248,
  [3706] = 3249,
  [3707] = 3247,
  [3708] = 3251,
  [3709] = 3251,
  [3710] = 3259,
  [3711] = 3260,
  [3712] = 3261,
  [3713] = 3262,
  [3714] = 3252,
  [3715] = 3253,
  [3716] = 3716,
  [3717] = 3254,
  [3718] = 3255,
  [3719] = 3256,
  [3720] = 3257,
  [3721] = 3258,
  [3722] = 3259,
  [3723] = 3260,
  [3724] = 3261,
  [3725] = 3262,
  [3726] = 3263,
  [3727] = 3248,
  [3728] = 3249,
  [3729] = 3247,
  [3730] = 3251,
  [3731] = 3263,
  [3732] = 3248,
  [3733] = 3252,
  [3734] = 3253,
  [3735] = 3252,
  [3736] = 3253,
  [3737] = 3266,
  [3738] = 3254,
  [3739] = 3255,
  [3740] = 3252,
  [3741] = 3256,
  [3742] = 3257,
  [3743] = 3258,
  [3744] = 3259,
  [3745] = 3260,
  [3746] = 3253,
  [3747] = 3254,
  [3748] = 3261,
  [3749] = 3262,
  [3750] = 3255,
  [3751] = 3263,
  [3752] = 3256,
  [3753] = 3257,
  [3754] = 3258,
  [3755] = 3259,
  [3756] = 3248,
  [3757] = 3249,
  [3758] = 3260,
  [3759] = 3247,
  [3760] = 3251,
  [3761] = 3266,
  [3762] = 3252,
  [3763] = 3253,
  [3764] = 3261,
  [3765] = 3262,
  [3766] = 3254,
  [3767] = 3254,
  [3768] = 3263,
  [3769] = 3252,
  [3770] = 3248,
  [3771] = 3249,
  [3772] = 3247,
  [3773] = 3253,
  [3774] = 3254,
  [3775] = 3251,
  [3776] = 3255,
  [3777] = 3256,
  [3778] = 3257,
  [3779] = 3258,
  [3780] = 3259,
  [3781] = 3260,
  [3782] = 3261,
  [3783] = 3262,
  [3784] = 3263,
  [3785] = 3248,
  [3786] = 3249,
  [3787] = 3247,
  [3788] = 3251,
  [3789] = 3255,
  [3790] = 3256,
  [3791] = 3257,
  [3792] = 3257,
  [3793] = 3258,
  [3794] = 3258,
  [3795] = 3252,
  [3796] = 3253,
  [3797] = 3254,
  [3798] = 3255,
  [3799] = 3256,
  [3800] = 3257,
  [3801] = 3258,
  [3802] = 3259,
  [3803] = 3260,
  [3804] = 3261,
  [3805] = 3262,
  [3806] = 3263,
  [3807] = 3248,
  [3808] = 3249,
  [3809] = 3639,
  [3810] = 3247,
  [3811] = 3251,
  [3812] = 3259,
  [3813] = 3260,
  [3814] = 3261,
  [3815] = 3262,
  [3816] = 3259,
  [3817] = 3260,
  [3818] = 3263,
  [3819] = 3252,
  [3820] = 3253,
  [3821] = 3266,
  [3822] = 3252,
  [3823] = 3253,
  [3824] = 3254,
  [3825] = 3255,
  [3826] = 3254,
  [3827] = 3256,
  [3828] = 3257,
  [3829] = 3255,
  [3830] = 3258,
  [3831] = 3259,
  [3832] = 3832,
  [3833] = 3256,
  [3834] = 3252,
  [3835] = 3253,
  [3836] = 3257,
  [3837] = 3258,
  [3838] = 3254,
  [3839] = 3259,
  [3840] = 3255,
  [3841] = 3256,
  [3842] = 3257,
  [3843] = 3260,
  [3844] = 3261,
  [3845] = 3258,
  [3846] = 3262,
  [3847] = 3263,
  [3848] = 3248,
  [3849] = 3260,
  [3850] = 3249,
  [3851] = 3259,
  [3852] = 3260,
  [3853] = 3261,
  [3854] = 3261,
  [3855] = 3262,
  [3856] = 3262,
  [3857] = 3263,
  [3858] = 3248,
  [3859] = 3263,
  [3860] = 3249,
  [3861] = 3248,
  [3862] = 3249,
  [3863] = 3247,
  [3864] = 3247,
  [3865] = 3251,
  [3866] = 3247,
  [3867] = 3251,
  [3868] = 3248,
  [3869] = 3251,
  [3870] = 3249,
  [3871] = 3247,
  [3872] = 3266,
  [3873] = 3251,
  [3874] = 3249,
  [3875] = 3247,
  [3876] = 3252,
  [3877] = 3253,
  [3878] = 3254,
  [3879] = 3255,
  [3880] = 3256,
  [3881] = 3252,
  [3882] = 3266,
  [3883] = 3253,
  [3884] = 3254,
  [3885] = 3252,
  [3886] = 3255,
  [3887] = 3256,
  [3888] = 3257,
  [3889] = 3258,
  [3890] = 3259,
  [3891] = 3260,
  [3892] = 3253,
  [3893] = 3254,
  [3894] = 3261,
  [3895] = 3255,
  [3896] = 3262,
  [3897] = 3263,
  [3898] = 3248,
  [3899] = 3256,
  [3900] = 3249,
  [3901] = 3257,
  [3902] = 3247,
  [3903] = 3251,
  [3904] = 3257,
  [3905] = 3258,
  [3906] = 3259,
  [3907] = 3260,
  [3908] = 3261,
  [3909] = 3258,
  [3910] = 3259,
  [3911] = 3260,
  [3912] = 3262,
  [3913] = 3261,
  [3914] = 3262,
  [3915] = 3263,
  [3916] = 3263,
  [3917] = 3248,
  [3918] = 3249,
  [3919] = 3252,
  [3920] = 3253,
  [3921] = 3254,
  [3922] = 3248,
  [3923] = 3249,
  [3924] = 3257,
  [3925] = 3247,
  [3926] = 3258,
  [3927] = 3247,
  [3928] = 3251,
  [3929] = 3251,
  [3930] = 3266,
  [3931] = 3252,
  [3932] = 3253,
  [3933] = 3254,
  [3934] = 3257,
  [3935] = 3258,
  [3936] = 3251,
  [3937] = 3266,
  [3938] = 3252,
  [3939] = 3253,
  [3940] = 3261,
  [3941] = 3254,
  [3942] = 3255,
  [3943] = 3262,
  [3944] = 3252,
  [3945] = 3253,
  [3946] = 3254,
  [3947] = 3345,
  [3948] = 3257,
  [3949] = 3716,
  [3950] = 3832,
  [3951] = 3258,
  [3952] = 3251,
  [3953] = 3610,
  [3954] = 3285,
  [3955] = 3252,
  [3956] = 3253,
  [3957] = 3254,
  [3958] = 3255,
  [3959] = 3256,
  [3960] = 3257,
  [3961] = 3258,
  [3962] = 3259,
  [3963] = 3260,
  [3964] = 3261,
  [3965] = 3262,
  [3966] = 3263,
  [3967] = 3248,
  [3968] = 3249,
  [3969] = 3247,
  [3970] = 3251,
  [3971] = 3256,
  [3972] = 3252,
  [3973] = 3253,
  [3974] = 3254,
  [3975] = 3255,
  [3976] = 3256,
  [3977] = 3257,
  [3978] = 3258,
  [3979] = 3259,
  [3980] = 3260,
  [3981] = 3261,
  [3982] = 3262,
  [3983] = 3263,
  [3984] = 3248,
  [3985] = 3249,
  [3986] = 3247,
  [3987] = 3251,
  [3988] = 3255,
  [3989] = 3256,
  [3990] = 3259,
  [3991] = 3260,
  [3992] = 3261,
  [3993] = 3262,
  [3994] = 3263,
  [3995] = 3248,
  [3996] = 3249,
  [3997] = 3247,
  [3998] = 3252,
  [3999] = 3253,
  [4000] = 3254,
  [4001] = 3255,
  [4002] = 3256,
  [4003] = 3257,
  [4004] = 3258,
  [4005] = 3259,
  [4006] = 3260,
  [4007] = 3261,
  [4008] = 3262,
  [4009] = 3263,
  [4010] = 3248,
  [4011] = 3249,
  [4012] = 3247,
  [4013] = 3251,
  [4014] = 3252,
  [4015] = 3253,
  [4016] = 3254,
  [4017] = 3257,
  [4018] = 3258,
  [4019] = 3251,
  [4020] = 3252,
  [4021] = 3253,
  [4022] = 3254,
  [4023] = 3255,
  [4024] = 3256,
  [4025] = 3257,
  [4026] = 3258,
  [4027] = 3259,
  [4028] = 3260,
  [4029] = 3261,
  [4030] = 3262,
  [4031] = 3263,
  [4032] = 3248,
  [4033] = 3249,
  [4034] = 3247,
  [4035] = 3251,
  [4036] = 3639,
  [4037] = 3252,
  [4038] = 3253,
  [4039] = 3254,
  [4040] = 3255,
  [4041] = 3256,
  [4042] = 3257,
  [4043] = 3258,
  [4044] = 3259,
  [4045] = 3260,
  [4046] = 3261,
  [4047] = 3262,
  [4048] = 3263,
  [4049] = 3248,
  [4050] = 3249,
  [4051] = 3247,
  [4052] = 3251,
  [4053] = 3252,
  [4054] = 3253,
  [4055] = 3254,
  [4056] = 3255,
  [4057] = 3256,
  [4058] = 3257,
  [4059] = 3258,
  [4060] = 3259,
  [4061] = 3260,
  [4062] = 3261,
  [4063] = 3262,
  [4064] = 3263,
  [4065] = 3248,
  [4066] = 3249,
  [4067] = 3247,
  [4068] = 3251,
  [4069] = 3257,
  [4070] = 3251,
  [4071] = 3255,
  [4072] = 3256,
  [4073] = 3259,
  [4074] = 3260,
  [4075] = 3261,
  [4076] = 3262,
  [4077] = 3263,
  [4078] = 3248,
  [4079] = 3249,
  [4080] = 3247,
  [4081] = 3251,
  [4082] = 3258,
  [4083] = 3252,
  [4084] = 3253,
  [4085] = 3254,
  [4086] = 3257,
  [4087] = 3258,
  [4088] = 3251,
  [4089] = 3255,
  [4090] = 3256,
  [4091] = 3259,
  [4092] = 3260,
  [4093] = 3261,
  [4094] = 3262,
  [4095] = 3263,
  [4096] = 3248,
  [4097] = 3249,
  [4098] = 3247,
  [4099] = 3259,
  [4100] = 3345,
  [4101] = 3285,
  [4102] = 3260,
  [4103] = 3716,
  [4104] = 3832,
  [4105] = 3255,
  [4106] = 3256,
  [4107] = 3259,
  [4108] = 3260,
  [4109] = 3261,
  [4110] = 3262,
  [4111] = 3263,
  [4112] = 3248,
  [4113] = 3249,
  [4114] = 3255,
  [4115] = 3256,
  [4116] = 3259,
  [4117] = 3260,
  [4118] = 3261,
  [4119] = 3262,
  [4120] = 3263,
  [4121] = 3248,
  [4122] = 3249,
  [4123] = 3247,
  [4124] = 3345,
  [4125] = 3261,
  [4126] = 3716,
  [4127] = 3263,
  [4128] = 3255,
  [4129] = 3256,
  [4130] = 3259,
  [4131] = 3260,
  [4132] = 3261,
  [4133] = 3262,
  [4134] = 3263,
  [4135] = 3248,
  [4136] = 3249,
  [4137] = 3247,
  [4138] = 3255,
  [4139] = 3256,
  [4140] = 3259,
  [4141] = 3260,
  [4142] = 3261,
  [4143] = 3262,
  [4144] = 3263,
  [4145] = 3248,
  [4146] = 3249,
  [4147] = 3247,
  [4148] = 3262,
  [4149] = 3345,
  [4150] = 3252,
  [4151] = 3253,
  [4152] = 3716,
  [4153] = 3266,
  [4154] = 3254,
  [4155] = 3252,
  [4156] = 3253,
  [4157] = 3345,
  [4158] = 3254,
  [4159] = 3255,
  [4160] = 3716,
  [4161] = 3255,
  [4162] = 3256,
  [4163] = 3256,
  [4164] = 3257,
  [4165] = 3345,
  [4166] = 3258,
  [4167] = 3257,
  [4168] = 3716,
  [4169] = 3259,
  [4170] = 3258,
  [4171] = 3260,
  [4172] = 3261,
  [4173] = 3345,
  [4174] = 3262,
  [4175] = 3259,
  [4176] = 3716,
  [4177] = 3263,
  [4178] = 3260,
  [4179] = 3248,
  [4180] = 3249,
  [4181] = 3345,
  [4182] = 3247,
  [4183] = 3261,
  [4184] = 3716,
  [4185] = 3251,
  [4186] = 3262,
  [4187] = 3263,
  [4188] = 3345,
  [4189] = 3248,
  [4190] = 3716,
  [4191] = 3249,
  [4192] = 3345,
  [4193] = 3247,
  [4194] = 3716,
  [4195] = 3251,
  [4196] = 3345,
  [4197] = 3716,
  [4198] = 3266,
  [4199] = 3345,
  [4200] = 3252,
  [4201] = 3252,
  [4202] = 3716,
  [4203] = 3253,
  [4204] = 3253,
  [4205] = 3254,
  [4206] = 3255,
  [4207] = 3256,
  [4208] = 3254,
  [4209] = 3257,
  [4210] = 3258,
  [4211] = 3257,
  [4212] = 3259,
  [4213] = 3258,
  [4214] = 3260,
  [4215] = 3251,
  [4216] = 3261,
  [4217] = 3262,
  [4218] = 3263,
  [4219] = 3248,
  [4220] = 3249,
  [4221] = 3247,
  [4222] = 3251,
  [4223] = 3263,
  [4224] = 3248,
  [4225] = 3248,
  [4226] = 3249,
  [4227] = 3249,
  [4228] = 3247,
  [4229] = 3251,
  [4230] = 3252,
  [4231] = 3253,
  [4232] = 3254,
  [4233] = 3255,
  [4234] = 3256,
  [4235] = 3257,
  [4236] = 3258,
  [4237] = 3259,
  [4238] = 3260,
  [4239] = 3261,
  [4240] = 3262,
  [4241] = 3263,
  [4242] = 3266,
  [4243] = 4243,
  [4244] = 4243,
  [4245] = 4243,
  [4246] = 4243,
  [4247] = 4243,
  [4248] = 4243,
  [4249] = 4243,
  [4250] = 4243,
  [4251] = 4243,
  [4252] = 4252,
  [4253] = 4252,
  [4254] = 4252,
  [4255] = 4252,
  [4256] = 4252,
  [4257] = 4252,
  [4258] = 4252,
  [4259] = 4252,
  [4260] = 4252,
  [4261] = 4261,
  [4262] = 4261,
  [4263] = 4261,
  [4264] = 4261,
  [4265] = 4261,
  [4266] = 4261,
  [4267] = 4261,
  [4268] = 4261,
  [4269] = 4261,
  [4270] = 4270,
  [4271] = 4270,
  [4272] = 4272,
  [4273] = 4272,
  [4274] = 4270,
  [4275] = 4270,
  [4276] = 4272,
  [4277] = 4270,
  [4278] = 4270,
  [4279] = 4279,
  [4280] = 4279,
  [4281] = 4281,
  [4282] = 4282,
  [4283] = 4282,
  [4284] = 4284,
  [4285] = 4281,
  [4286] = 4281,
  [4287] = 4287,
  [4288] = 4287,
  [4289] = 4284,
  [4290] = 4272,
  [4291] = 4287,
  [4292] = 4272,
  [4293] = 4279,
  [4294] = 4294,
  [4295] = 4272,
  [4296] = 4294,
  [4297] = 4284,
  [4298] = 4270,
  [4299] = 4299,
  [4300] = 4299,
  [4301] = 4272,
  [4302] = 4302,
  [4303] = 4294,
  [4304] = 4284,
  [4305] = 4284,
  [4306] = 4282,
  [4307] = 4302,
  [4308] = 4302,
  [4309] = 4287,
  [4310] = 4287,
  [4311] = 4282,
  [4312] = 4284,
  [4313] = 4294,
  [4314] = 4299,
  [4315] = 4302,
  [4316] = 4282,
  [4317] = 4282,
  [4318] = 4299,
  [4319] = 4302,
  [4320] = 4272,
  [4321] = 4272,
  [4322] = 4270,
  [4323] = 4281,
  [4324] = 4272,
  [4325] = 4272,
  [4326] = 4270,
  [4327] = 4287,
  [4328] = 4272,
  [4329] = 4270,
  [4330] = 4270,
  [4331] = 4299,
  [4332] = 4294,
  [4333] = 4272,
  [4334] = 4270,
  [4335] = 4294,
  [4336] = 4281,
  [4337] = 4281,
  [4338] = 4299,
  [4339] = 4302,
  [4340] = 4340,
  [4341] = 4272,
  [4342] = 4281,
  [4343] = 4284,
  [4344] = 4299,
  [4345] = 4302,
  [4346] = 4287,
  [4347] = 4294,
  [4348] = 4279,
  [4349] = 4302,
  [4350] = 4281,
  [4351] = 4351,
  [4352] = 4352,
  [4353] = 4353,
  [4354] = 4354,
  [4355] = 4355,
  [4356] = 4340,
  [4357] = 4281,
  [4358] = 4358,
  [4359] = 4284,
  [4360] = 4351,
  [4361] = 4361,
  [4362] = 4362,
  [4363] = 4353,
  [4364] = 4299,
  [4365] = 4302,
  [4366] = 4287,
  [4367] = 4294,
  [4368] = 4270,
  [4369] = 4369,
  [4370] = 4352,
  [4371] = 4354,
  [4372] = 4358,
  [4373] = 4373,
  [4374] = 4374,
  [4375] = 4375,
  [4376] = 4376,
  [4377] = 4377,
  [4378] = 4378,
  [4379] = 4379,
  [4380] = 4380,
  [4381] = 4381,
  [4382] = 4282,
  [4383] = 4383,
  [4384] = 4369,
  [4385] = 4385,
  [4386] = 4352,
  [4387] = 4354,
  [4388] = 4388,
  [4389] = 4358,
  [4390] = 4351,
  [4391] = 4373,
  [4392] = 4392,
  [4393] = 4374,
  [4394] = 4375,
  [4395] = 4353,
  [4396] = 4376,
  [4397] = 4377,
  [4398] = 4380,
  [4399] = 4270,
  [4400] = 4272,
  [4401] = 4284,
  [4402] = 4299,
  [4403] = 4302,
  [4404] = 4287,
  [4405] = 4294,
  [4406] = 4281,
  [4407] = 4369,
  [4408] = 4378,
  [4409] = 4379,
  [4410] = 4284,
  [4411] = 4299,
  [4412] = 4302,
  [4413] = 4355,
  [4414] = 4281,
  [4415] = 4352,
  [4416] = 4354,
  [4417] = 4358,
  [4418] = 4381,
  [4419] = 4287,
  [4420] = 4361,
  [4421] = 4362,
  [4422] = 4373,
  [4423] = 4374,
  [4424] = 4375,
  [4425] = 4294,
  [4426] = 4376,
  [4427] = 4377,
  [4428] = 4380,
  [4429] = 4281,
  [4430] = 4383,
  [4431] = 4385,
  [4432] = 4284,
  [4433] = 4299,
  [4434] = 4302,
  [4435] = 4281,
  [4436] = 4388,
  [4437] = 4287,
  [4438] = 4392,
  [4439] = 4294,
  [4440] = 4281,
  [4441] = 4287,
  [4442] = 4284,
  [4443] = 4299,
  [4444] = 4302,
  [4445] = 4287,
  [4446] = 4294,
  [4447] = 4282,
  [4448] = 4355,
  [4449] = 4340,
  [4450] = 4361,
  [4451] = 4362,
  [4452] = 4272,
  [4453] = 4282,
  [4454] = 4355,
  [4455] = 4340,
  [4456] = 4361,
  [4457] = 4362,
  [4458] = 4458,
  [4459] = 4281,
  [4460] = 4458,
  [4461] = 4282,
  [4462] = 4284,
  [4463] = 4299,
  [4464] = 4294,
  [4465] = 4272,
  [4466] = 4282,
  [4467] = 4287,
  [4468] = 4294,
  [4469] = 4281,
  [4470] = 4270,
  [4471] = 4282,
  [4472] = 4458,
  [4473] = 4458,
  [4474] = 4282,
  [4475] = 4272,
  [4476] = 4282,
  [4477] = 4355,
  [4478] = 4340,
  [4479] = 4361,
  [4480] = 4362,
  [4481] = 4458,
  [4482] = 4272,
  [4483] = 4279,
  [4484] = 4369,
  [4485] = 4272,
  [4486] = 4272,
  [4487] = 4355,
  [4488] = 4340,
  [4489] = 4361,
  [4490] = 4362,
  [4491] = 4272,
  [4492] = 4272,
  [4493] = 4272,
  [4494] = 4282,
  [4495] = 4279,
  [4496] = 4272,
  [4497] = 4272,
  [4498] = 4279,
  [4499] = 4352,
  [4500] = 4354,
  [4501] = 4358,
  [4502] = 4373,
  [4503] = 4374,
  [4504] = 4375,
  [4505] = 4376,
  [4506] = 4377,
  [4507] = 4380,
  [4508] = 4373,
  [4509] = 4374,
  [4510] = 4375,
  [4511] = 4458,
  [4512] = 4294,
  [4513] = 4376,
  [4514] = 4377,
  [4515] = 4380,
  [4516] = 4369,
  [4517] = 4282,
  [4518] = 4383,
  [4519] = 4351,
  [4520] = 4282,
  [4521] = 4279,
  [4522] = 4279,
  [4523] = 4351,
  [4524] = 4353,
  [4525] = 4353,
  [4526] = 4270,
  [4527] = 4385,
  [4528] = 4378,
  [4529] = 4379,
  [4530] = 4284,
  [4531] = 4299,
  [4532] = 4302,
  [4533] = 4270,
  [4534] = 4287,
  [4535] = 4294,
  [4536] = 4270,
  [4537] = 4299,
  [4538] = 4388,
  [4539] = 4369,
  [4540] = 4284,
  [4541] = 4299,
  [4542] = 4302,
  [4543] = 4352,
  [4544] = 4354,
  [4545] = 4358,
  [4546] = 4381,
  [4547] = 4287,
  [4548] = 4373,
  [4549] = 4374,
  [4550] = 4375,
  [4551] = 4270,
  [4552] = 4294,
  [4553] = 4376,
  [4554] = 4377,
  [4555] = 4380,
  [4556] = 4281,
  [4557] = 4279,
  [4558] = 4392,
  [4559] = 4284,
  [4560] = 4351,
  [4561] = 4353,
  [4562] = 4284,
  [4563] = 4299,
  [4564] = 4302,
  [4565] = 4287,
  [4566] = 4302,
  [4567] = 4567,
  [4568] = 4568,
  [4569] = 4569,
  [4570] = 4570,
  [4571] = 4571,
  [4572] = 4567,
  [4573] = 4573,
  [4574] = 4574,
  [4575] = 4575,
  [4576] = 4576,
  [4577] = 4373,
  [4578] = 4374,
  [4579] = 4375,
  [4580] = 4376,
  [4581] = 4377,
  [4582] = 4582,
  [4583] = 4583,
  [4584] = 4584,
  [4585] = 4380,
  [4586] = 4586,
  [4587] = 4587,
  [4588] = 4272,
  [4589] = 4589,
  [4590] = 4284,
  [4591] = 4299,
  [4592] = 4302,
  [4593] = 4378,
  [4594] = 4379,
  [4595] = 4287,
  [4596] = 4596,
  [4597] = 4597,
  [4598] = 4381,
  [4599] = 4353,
  [4600] = 4600,
  [4601] = 4281,
  [4602] = 4602,
  [4603] = 4603,
  [4604] = 4604,
  [4605] = 4294,
  [4606] = 4606,
  [4607] = 4383,
  [4608] = 4608,
  [4609] = 4282,
  [4610] = 4610,
  [4611] = 4611,
  [4612] = 4612,
  [4613] = 4613,
  [4614] = 4614,
  [4615] = 4615,
  [4616] = 4597,
  [4617] = 4617,
  [4618] = 4618,
  [4619] = 4385,
  [4620] = 4378,
  [4621] = 4379,
  [4622] = 4622,
  [4623] = 4623,
  [4624] = 4388,
  [4625] = 4381,
  [4626] = 4626,
  [4627] = 4351,
  [4628] = 4573,
  [4629] = 4574,
  [4630] = 4392,
  [4631] = 4631,
  [4632] = 4632,
  [4633] = 4600,
  [4634] = 4634,
  [4635] = 4568,
  [4636] = 4569,
  [4637] = 4570,
  [4638] = 4353,
  [4639] = 4281,
  [4640] = 4576,
  [4641] = 4582,
  [4642] = 4602,
  [4643] = 4583,
  [4644] = 4584,
  [4645] = 4587,
  [4646] = 4369,
  [4647] = 4383,
  [4648] = 4648,
  [4649] = 4282,
  [4650] = 4650,
  [4651] = 4651,
  [4652] = 4652,
  [4653] = 4571,
  [4654] = 4352,
  [4655] = 4385,
  [4656] = 4354,
  [4657] = 4358,
  [4658] = 4458,
  [4659] = 4596,
  [4660] = 4660,
  [4661] = 4373,
  [4662] = 4351,
  [4663] = 4652,
  [4664] = 4374,
  [4665] = 4652,
  [4666] = 4666,
  [4667] = 4375,
  [4668] = 4369,
  [4669] = 4376,
  [4670] = 4377,
  [4671] = 4388,
  [4672] = 4380,
  [4673] = 4622,
  [4674] = 4674,
  [4675] = 4392,
  [4676] = 4282,
  [4677] = 4652,
  [4678] = 4352,
  [4679] = 4354,
  [4680] = 4358,
  [4681] = 4369,
  [4682] = 4573,
  [4683] = 4574,
  [4684] = 4684,
  [4685] = 4279,
  [4686] = 4686,
  [4687] = 4373,
  [4688] = 4374,
  [4689] = 4375,
  [4690] = 4376,
  [4691] = 4377,
  [4692] = 4692,
  [4693] = 4378,
  [4694] = 4379,
  [4695] = 4695,
  [4696] = 4380,
  [4697] = 4697,
  [4698] = 4355,
  [4699] = 4340,
  [4700] = 4700,
  [4701] = 4381,
  [4702] = 4351,
  [4703] = 4352,
  [4704] = 4282,
  [4705] = 4354,
  [4706] = 4353,
  [4707] = 4358,
  [4708] = 4284,
  [4709] = 4299,
  [4710] = 4302,
  [4711] = 4380,
  [4712] = 4383,
  [4713] = 4287,
  [4714] = 4294,
  [4715] = 4385,
  [4716] = 4281,
  [4717] = 4378,
  [4718] = 4379,
  [4719] = 4684,
  [4720] = 4720,
  [4721] = 4721,
  [4722] = 4284,
  [4723] = 4388,
  [4724] = 4381,
  [4725] = 4351,
  [4726] = 4392,
  [4727] = 4353,
  [4728] = 4373,
  [4729] = 4589,
  [4730] = 4383,
  [4731] = 4279,
  [4732] = 4374,
  [4733] = 4375,
  [4734] = 4270,
  [4735] = 4576,
  [4736] = 4369,
  [4737] = 4385,
  [4738] = 4738,
  [4739] = 4352,
  [4740] = 4354,
  [4741] = 4388,
  [4742] = 4358,
  [4743] = 4351,
  [4744] = 4299,
  [4745] = 4738,
  [4746] = 4373,
  [4747] = 4392,
  [4748] = 4374,
  [4749] = 4749,
  [4750] = 4375,
  [4751] = 4751,
  [4752] = 4281,
  [4753] = 4582,
  [4754] = 4353,
  [4755] = 4755,
  [4756] = 4376,
  [4757] = 4302,
  [4758] = 4575,
  [4759] = 4377,
  [4760] = 4376,
  [4761] = 4380,
  [4762] = 4377,
  [4763] = 4749,
  [4764] = 4603,
  [4765] = 4751,
  [4766] = 4755,
  [4767] = 4586,
  [4768] = 4380,
  [4769] = 4355,
  [4770] = 4340,
  [4771] = 4361,
  [4772] = 4362,
  [4773] = 4458,
  [4774] = 4282,
  [4775] = 4622,
  [4776] = 4573,
  [4777] = 4574,
  [4778] = 4369,
  [4779] = 4604,
  [4780] = 4352,
  [4781] = 4354,
  [4782] = 4358,
  [4783] = 4608,
  [4784] = 4610,
  [4785] = 4611,
  [4786] = 4612,
  [4787] = 4613,
  [4788] = 4614,
  [4789] = 4615,
  [4790] = 4597,
  [4791] = 4617,
  [4792] = 4618,
  [4793] = 4623,
  [4794] = 4373,
  [4795] = 4626,
  [4796] = 4631,
  [4797] = 4632,
  [4798] = 4374,
  [4799] = 4600,
  [4800] = 4634,
  [4801] = 4568,
  [4802] = 4375,
  [4803] = 4569,
  [4804] = 4570,
  [4805] = 4576,
  [4806] = 4582,
  [4807] = 4602,
  [4808] = 4583,
  [4809] = 4584,
  [4810] = 4587,
  [4811] = 4458,
  [4812] = 4684,
  [4813] = 4376,
  [4814] = 4377,
  [4815] = 4380,
  [4816] = 4648,
  [4817] = 4684,
  [4818] = 4650,
  [4819] = 4651,
  [4820] = 4279,
  [4821] = 4571,
  [4822] = 4272,
  [4823] = 4749,
  [4824] = 4751,
  [4825] = 4755,
  [4826] = 4369,
  [4827] = 4622,
  [4828] = 4352,
  [4829] = 4354,
  [4830] = 4358,
  [4831] = 4573,
  [4832] = 4574,
  [4833] = 4351,
  [4834] = 4373,
  [4835] = 4738,
  [4836] = 4374,
  [4837] = 4375,
  [4838] = 4353,
  [4839] = 4376,
  [4840] = 4377,
  [4841] = 4361,
  [4842] = 4380,
  [4843] = 4282,
  [4844] = 4749,
  [4845] = 4606,
  [4846] = 4751,
  [4847] = 4738,
  [4848] = 4755,
  [4849] = 4458,
  [4850] = 4362,
  [4851] = 4281,
  [4852] = 4282,
  [4853] = 4355,
  [4854] = 4340,
  [4855] = 4361,
  [4856] = 4362,
  [4857] = 4583,
  [4858] = 4458,
  [4859] = 4606,
  [4860] = 4272,
  [4861] = 4749,
  [4862] = 4751,
  [4863] = 4755,
  [4864] = 4287,
  [4865] = 4584,
  [4866] = 4458,
  [4867] = 4738,
  [4868] = 4458,
  [4869] = 4282,
  [4870] = 4369,
  [4871] = 4355,
  [4872] = 4272,
  [4873] = 4340,
  [4874] = 4352,
  [4875] = 4354,
  [4876] = 4358,
  [4877] = 4355,
  [4878] = 4340,
  [4879] = 4361,
  [4880] = 4362,
  [4881] = 4361,
  [4882] = 4362,
  [4883] = 4373,
  [4884] = 4374,
  [4885] = 4375,
  [4886] = 4376,
  [4887] = 4377,
  [4888] = 4380,
  [4889] = 4294,
  [4890] = 4458,
  [4891] = 4355,
  [4892] = 4340,
  [4893] = 4361,
  [4894] = 4362,
  [4895] = 4603,
  [4896] = 4586,
  [4897] = 4355,
  [4898] = 4340,
  [4899] = 4361,
  [4900] = 4362,
  [4901] = 4355,
  [4902] = 4340,
  [4903] = 4361,
  [4904] = 4362,
  [4905] = 4272,
  [4906] = 4458,
  [4907] = 4604,
  [4908] = 4351,
  [4909] = 4284,
  [4910] = 4355,
  [4911] = 4340,
  [4912] = 4361,
  [4913] = 4362,
  [4914] = 4914,
  [4915] = 4634,
  [4916] = 4340,
  [4917] = 4361,
  [4918] = 4362,
  [4919] = 4353,
  [4920] = 4281,
  [4921] = 4674,
  [4922] = 4272,
  [4923] = 4272,
  [4924] = 4272,
  [4925] = 4299,
  [4926] = 4302,
  [4927] = 4287,
  [4928] = 4458,
  [4929] = 4294,
  [4930] = 4299,
  [4931] = 4608,
  [4932] = 4610,
  [4933] = 4302,
  [4934] = 4660,
  [4935] = 4684,
  [4936] = 4720,
  [4937] = 4287,
  [4938] = 4611,
  [4939] = 4749,
  [4940] = 4648,
  [4941] = 4751,
  [4942] = 4353,
  [4943] = 4279,
  [4944] = 4294,
  [4945] = 4755,
  [4946] = 4684,
  [4947] = 4674,
  [4948] = 4660,
  [4949] = 4284,
  [4950] = 4299,
  [4951] = 4279,
  [4952] = 4281,
  [4953] = 4606,
  [4954] = 4369,
  [4955] = 4284,
  [4956] = 4352,
  [4957] = 4354,
  [4958] = 4358,
  [4959] = 4373,
  [4960] = 4374,
  [4961] = 4375,
  [4962] = 4674,
  [4963] = 4376,
  [4964] = 4377,
  [4965] = 4380,
  [4966] = 4738,
  [4967] = 4281,
  [4968] = 4666,
  [4969] = 4608,
  [4970] = 4692,
  [4971] = 4610,
  [4972] = 4660,
  [4973] = 4299,
  [4974] = 4302,
  [4975] = 4695,
  [4976] = 4697,
  [4977] = 4302,
  [4978] = 4611,
  [4979] = 4700,
  [4980] = 4376,
  [4981] = 4720,
  [4982] = 4720,
  [4983] = 4287,
  [4984] = 4721,
  [4985] = 4648,
  [4986] = 4294,
  [4987] = 4674,
  [4988] = 4652,
  [4989] = 4692,
  [4990] = 4695,
  [4991] = 4270,
  [4992] = 4697,
  [4993] = 4700,
  [4994] = 4287,
  [4995] = 4284,
  [4996] = 4721,
  [4997] = 4686,
  [4998] = 4589,
  [4999] = 4567,
  [5000] = 4602,
  [5001] = 4567,
  [5002] = 4575,
  [5003] = 4575,
  [5004] = 4377,
  [5005] = 4603,
  [5006] = 4586,
  [5007] = 4604,
  [5008] = 4612,
  [5009] = 4613,
  [5010] = 4666,
  [5011] = 4603,
  [5012] = 4660,
  [5013] = 4294,
  [5014] = 4652,
  [5015] = 4614,
  [5016] = 4615,
  [5017] = 4650,
  [5018] = 4666,
  [5019] = 4622,
  [5020] = 4612,
  [5021] = 4613,
  [5022] = 4586,
  [5023] = 4666,
  [5024] = 4596,
  [5025] = 4692,
  [5026] = 4573,
  [5027] = 4695,
  [5028] = 4697,
  [5029] = 4574,
  [5030] = 4604,
  [5031] = 4351,
  [5032] = 4686,
  [5033] = 4353,
  [5034] = 4587,
  [5035] = 4700,
  [5036] = 4614,
  [5037] = 4606,
  [5038] = 4608,
  [5039] = 4610,
  [5040] = 4611,
  [5041] = 4615,
  [5042] = 4597,
  [5043] = 4612,
  [5044] = 4613,
  [5045] = 4617,
  [5046] = 4650,
  [5047] = 4614,
  [5048] = 4615,
  [5049] = 4692,
  [5050] = 4695,
  [5051] = 4355,
  [5052] = 4340,
  [5053] = 4697,
  [5054] = 4597,
  [5055] = 4700,
  [5056] = 4617,
  [5057] = 4618,
  [5058] = 4618,
  [5059] = 4623,
  [5060] = 4626,
  [5061] = 4351,
  [5062] = 4617,
  [5063] = 4631,
  [5064] = 4361,
  [5065] = 4632,
  [5066] = 4362,
  [5067] = 4600,
  [5068] = 4634,
  [5069] = 4623,
  [5070] = 4351,
  [5071] = 4674,
  [5072] = 4626,
  [5073] = 4568,
  [5074] = 4569,
  [5075] = 4651,
  [5076] = 4570,
  [5077] = 4353,
  [5078] = 4618,
  [5079] = 4270,
  [5080] = 4623,
  [5081] = 4576,
  [5082] = 4582,
  [5083] = 4626,
  [5084] = 4651,
  [5085] = 4602,
  [5086] = 4583,
  [5087] = 4584,
  [5088] = 4587,
  [5089] = 4458,
  [5090] = 4720,
  [5091] = 4660,
  [5092] = 4608,
  [5093] = 4610,
  [5094] = 4720,
  [5095] = 4611,
  [5096] = 4369,
  [5097] = 4270,
  [5098] = 4648,
  [5099] = 4279,
  [5100] = 4612,
  [5101] = 4613,
  [5102] = 4369,
  [5103] = 4614,
  [5104] = 4615,
  [5105] = 4650,
  [5106] = 4284,
  [5107] = 4721,
  [5108] = 4299,
  [5109] = 4302,
  [5110] = 4631,
  [5111] = 4352,
  [5112] = 4354,
  [5113] = 4597,
  [5114] = 4358,
  [5115] = 4617,
  [5116] = 4618,
  [5117] = 4623,
  [5118] = 4626,
  [5119] = 4651,
  [5120] = 4287,
  [5121] = 4631,
  [5122] = 4632,
  [5123] = 4632,
  [5124] = 4686,
  [5125] = 4373,
  [5126] = 4374,
  [5127] = 4721,
  [5128] = 4600,
  [5129] = 4634,
  [5130] = 4375,
  [5131] = 4568,
  [5132] = 4569,
  [5133] = 4570,
  [5134] = 4571,
  [5135] = 4294,
  [5136] = 4576,
  [5137] = 4582,
  [5138] = 4376,
  [5139] = 4377,
  [5140] = 4602,
  [5141] = 4583,
  [5142] = 4584,
  [5143] = 4666,
  [5144] = 4600,
  [5145] = 4634,
  [5146] = 4622,
  [5147] = 4692,
  [5148] = 4695,
  [5149] = 4380,
  [5150] = 4568,
  [5151] = 4697,
  [5152] = 4587,
  [5153] = 4700,
  [5154] = 4352,
  [5155] = 4648,
  [5156] = 4721,
  [5157] = 4686,
  [5158] = 4569,
  [5159] = 4354,
  [5160] = 4570,
  [5161] = 4567,
  [5162] = 4369,
  [5163] = 4571,
  [5164] = 4575,
  [5165] = 4650,
  [5166] = 4603,
  [5167] = 4631,
  [5168] = 4586,
  [5169] = 4604,
  [5170] = 4632,
  [5171] = 4358,
  [5172] = 4352,
  [5173] = 4354,
  [5174] = 4358,
  [5175] = 4567,
  [5176] = 4606,
  [5177] = 4651,
  [5178] = 4351,
  [5179] = 4575,
  [5180] = 4686,
  [5181] = 4373,
  [5182] = 4374,
  [5183] = 4375,
  [5184] = 4571,
  [5185] = 4353,
  [5186] = 4355,
  [5187] = 4608,
  [5188] = 4651,
  [5189] = 4684,
  [5190] = 4660,
  [5191] = 4666,
  [5192] = 4284,
  [5193] = 4720,
  [5194] = 4299,
  [5195] = 4302,
  [5196] = 4381,
  [5197] = 4721,
  [5198] = 4631,
  [5199] = 4632,
  [5200] = 4355,
  [5201] = 4340,
  [5202] = 4686,
  [5203] = 4354,
  [5204] = 4674,
  [5205] = 4575,
  [5206] = 4606,
  [5207] = 4720,
  [5208] = 4660,
  [5209] = 4358,
  [5210] = 4600,
  [5211] = 4634,
  [5212] = 4700,
  [5213] = 5213,
  [5214] = 4272,
  [5215] = 4373,
  [5216] = 4287,
  [5217] = 4568,
  [5218] = 4584,
  [5219] = 4361,
  [5220] = 4569,
  [5221] = 4570,
  [5222] = 4571,
  [5223] = 4362,
  [5224] = 4374,
  [5225] = 4721,
  [5226] = 4567,
  [5227] = 4375,
  [5228] = 4351,
  [5229] = 4294,
  [5230] = 4458,
  [5231] = 4660,
  [5232] = 4602,
  [5233] = 4666,
  [5234] = 4575,
  [5235] = 4576,
  [5236] = 4622,
  [5237] = 4582,
  [5238] = 4573,
  [5239] = 4574,
  [5240] = 4376,
  [5241] = 4686,
  [5242] = 4666,
  [5243] = 4602,
  [5244] = 4583,
  [5245] = 4584,
  [5246] = 4586,
  [5247] = 4721,
  [5248] = 4377,
  [5249] = 4376,
  [5250] = 4721,
  [5251] = 4587,
  [5252] = 4596,
  [5253] = 4622,
  [5254] = 4355,
  [5255] = 4340,
  [5256] = 4377,
  [5257] = 4573,
  [5258] = 4574,
  [5259] = 4751,
  [5260] = 4361,
  [5261] = 4383,
  [5262] = 4362,
  [5263] = 4692,
  [5264] = 4695,
  [5265] = 4697,
  [5266] = 4458,
  [5267] = 4608,
  [5268] = 4610,
  [5269] = 4611,
  [5270] = 4684,
  [5271] = 4652,
  [5272] = 4612,
  [5273] = 4613,
  [5274] = 4614,
  [5275] = 4615,
  [5276] = 4597,
  [5277] = 4617,
  [5278] = 4618,
  [5279] = 4623,
  [5280] = 4626,
  [5281] = 4631,
  [5282] = 4632,
  [5283] = 4600,
  [5284] = 4634,
  [5285] = 4568,
  [5286] = 4569,
  [5287] = 4570,
  [5288] = 4576,
  [5289] = 4582,
  [5290] = 4602,
  [5291] = 4583,
  [5292] = 4584,
  [5293] = 4587,
  [5294] = 4353,
  [5295] = 4380,
  [5296] = 4281,
  [5297] = 4603,
  [5298] = 4608,
  [5299] = 4385,
  [5300] = 4700,
  [5301] = 4610,
  [5302] = 4660,
  [5303] = 4388,
  [5304] = 4597,
  [5305] = 4738,
  [5306] = 4567,
  [5307] = 4606,
  [5308] = 4611,
  [5309] = 4575,
  [5310] = 4749,
  [5311] = 4392,
  [5312] = 4751,
  [5313] = 4720,
  [5314] = 4652,
  [5315] = 4600,
  [5316] = 4648,
  [5317] = 4721,
  [5318] = 4376,
  [5319] = 4652,
  [5320] = 4612,
  [5321] = 4755,
  [5322] = 4650,
  [5323] = 4602,
  [5324] = 4603,
  [5325] = 4651,
  [5326] = 4571,
  [5327] = 4613,
  [5328] = 4666,
  [5329] = 4604,
  [5330] = 4666,
  [5331] = 4738,
  [5332] = 4614,
  [5333] = 4686,
  [5334] = 4377,
  [5335] = 4615,
  [5336] = 4674,
  [5337] = 4355,
  [5338] = 4340,
  [5339] = 4361,
  [5340] = 4362,
  [5341] = 4589,
  [5342] = 4684,
  [5343] = 4692,
  [5344] = 4272,
  [5345] = 4749,
  [5346] = 4751,
  [5347] = 4738,
  [5348] = 4567,
  [5349] = 4755,
  [5350] = 4369,
  [5351] = 4622,
  [5352] = 4573,
  [5353] = 4574,
  [5354] = 4575,
  [5355] = 4576,
  [5356] = 4610,
  [5357] = 4603,
  [5358] = 4611,
  [5359] = 4622,
  [5360] = 4612,
  [5361] = 4613,
  [5362] = 4614,
  [5363] = 4615,
  [5364] = 4597,
  [5365] = 4617,
  [5366] = 4618,
  [5367] = 4622,
  [5368] = 4380,
  [5369] = 4586,
  [5370] = 4623,
  [5371] = 4626,
  [5372] = 4631,
  [5373] = 4632,
  [5374] = 4600,
  [5375] = 4634,
  [5376] = 4568,
  [5377] = 4569,
  [5378] = 4570,
  [5379] = 4576,
  [5380] = 4582,
  [5381] = 4602,
  [5382] = 4583,
  [5383] = 4584,
  [5384] = 4587,
  [5385] = 4695,
  [5386] = 4749,
  [5387] = 4751,
  [5388] = 4573,
  [5389] = 4574,
  [5390] = 4738,
  [5391] = 4755,
  [5392] = 4749,
  [5393] = 4751,
  [5394] = 4648,
  [5395] = 4604,
  [5396] = 4684,
  [5397] = 4603,
  [5398] = 4586,
  [5399] = 4755,
  [5400] = 4650,
  [5401] = 4651,
  [5402] = 4571,
  [5403] = 4597,
  [5404] = 4617,
  [5405] = 4674,
  [5406] = 4618,
  [5407] = 4623,
  [5408] = 4608,
  [5409] = 4610,
  [5410] = 4660,
  [5411] = 4660,
  [5412] = 4582,
  [5413] = 4749,
  [5414] = 4458,
  [5415] = 4751,
  [5416] = 4755,
  [5417] = 4674,
  [5418] = 4589,
  [5419] = 4282,
  [5420] = 4604,
  [5421] = 4738,
  [5422] = 4611,
  [5423] = 4648,
  [5424] = 4626,
  [5425] = 4573,
  [5426] = 4574,
  [5427] = 4351,
  [5428] = 4749,
  [5429] = 4631,
  [5430] = 4632,
  [5431] = 4686,
  [5432] = 4600,
  [5433] = 4634,
  [5434] = 4568,
  [5435] = 4569,
  [5436] = 4570,
  [5437] = 4353,
  [5438] = 4660,
  [5439] = 4576,
  [5440] = 4582,
  [5441] = 4602,
  [5442] = 4749,
  [5443] = 4751,
  [5444] = 4755,
  [5445] = 4738,
  [5446] = 4583,
  [5447] = 4608,
  [5448] = 4584,
  [5449] = 4610,
  [5450] = 4612,
  [5451] = 4613,
  [5452] = 4611,
  [5453] = 4648,
  [5454] = 4587,
  [5455] = 4608,
  [5456] = 4610,
  [5457] = 4697,
  [5458] = 4458,
  [5459] = 4666,
  [5460] = 4355,
  [5461] = 4340,
  [5462] = 4361,
  [5463] = 4362,
  [5464] = 4738,
  [5465] = 4373,
  [5466] = 5213,
  [5467] = 4751,
  [5468] = 4648,
  [5469] = 4458,
  [5470] = 4700,
  [5471] = 4614,
  [5472] = 4615,
  [5473] = 4650,
  [5474] = 4611,
  [5475] = 4374,
  [5476] = 4652,
  [5477] = 4622,
  [5478] = 4355,
  [5479] = 4612,
  [5480] = 4613,
  [5481] = 4614,
  [5482] = 4615,
  [5483] = 4596,
  [5484] = 4587,
  [5485] = 4650,
  [5486] = 4720,
  [5487] = 4755,
  [5488] = 4692,
  [5489] = 4597,
  [5490] = 4617,
  [5491] = 4721,
  [5492] = 4618,
  [5493] = 4623,
  [5494] = 4626,
  [5495] = 4651,
  [5496] = 4695,
  [5497] = 4612,
  [5498] = 4697,
  [5499] = 4631,
  [5500] = 4613,
  [5501] = 4632,
  [5502] = 4600,
  [5503] = 4634,
  [5504] = 4568,
  [5505] = 4569,
  [5506] = 4355,
  [5507] = 4570,
  [5508] = 4340,
  [5509] = 4361,
  [5510] = 4362,
  [5511] = 4458,
  [5512] = 4571,
  [5513] = 4576,
  [5514] = 4355,
  [5515] = 4582,
  [5516] = 4340,
  [5517] = 4602,
  [5518] = 4583,
  [5519] = 4584,
  [5520] = 4587,
  [5521] = 4361,
  [5522] = 4362,
  [5523] = 4738,
  [5524] = 4755,
  [5525] = 4369,
  [5526] = 4700,
  [5527] = 4652,
  [5528] = 4617,
  [5529] = 4686,
  [5530] = 4622,
  [5531] = 4618,
  [5532] = 4684,
  [5533] = 4623,
  [5534] = 4567,
  [5535] = 4626,
  [5536] = 4355,
  [5537] = 4340,
  [5538] = 4361,
  [5539] = 4362,
  [5540] = 4666,
  [5541] = 4575,
  [5542] = 4651,
  [5543] = 4272,
  [5544] = 4352,
  [5545] = 4270,
  [5546] = 4720,
  [5547] = 4686,
  [5548] = 5213,
  [5549] = 4603,
  [5550] = 4586,
  [5551] = 4604,
  [5552] = 4749,
  [5553] = 4573,
  [5554] = 4574,
  [5555] = 4686,
  [5556] = 4351,
  [5557] = 4721,
  [5558] = 4631,
  [5559] = 4369,
  [5560] = 4751,
  [5561] = 4353,
  [5562] = 4632,
  [5563] = 4686,
  [5564] = 4354,
  [5565] = 4634,
  [5566] = 4568,
  [5567] = 4569,
  [5568] = 4383,
  [5569] = 4570,
  [5570] = 4351,
  [5571] = 4571,
  [5572] = 4358,
  [5573] = 4614,
  [5574] = 4567,
  [5575] = 4615,
  [5576] = 4340,
  [5577] = 4622,
  [5578] = 4353,
  [5579] = 4575,
  [5580] = 4576,
  [5581] = 5581,
  [5582] = 4582,
  [5583] = 4567,
  [5584] = 4583,
  [5585] = 4575,
  [5586] = 4755,
  [5587] = 4652,
  [5588] = 4603,
  [5589] = 4586,
  [5590] = 4650,
  [5591] = 4604,
  [5592] = 4584,
  [5593] = 4603,
  [5594] = 4666,
  [5595] = 4586,
  [5596] = 4684,
  [5597] = 4587,
  [5598] = 4606,
  [5599] = 4604,
  [5600] = 4597,
  [5601] = 4617,
  [5602] = 4618,
  [5603] = 4623,
  [5604] = 4626,
  [5605] = 4573,
  [5606] = 4574,
  [5607] = 4631,
  [5608] = 4608,
  [5609] = 4632,
  [5610] = 4610,
  [5611] = 4281,
  [5612] = 4573,
  [5613] = 4574,
  [5614] = 4611,
  [5615] = 4606,
  [5616] = 4600,
  [5617] = 4652,
  [5618] = 4369,
  [5619] = 4282,
  [5620] = 4648,
  [5621] = 4686,
  [5622] = 4634,
  [5623] = 4568,
  [5624] = 4569,
  [5625] = 4570,
  [5626] = 4576,
  [5627] = 4626,
  [5628] = 4602,
  [5629] = 4352,
  [5630] = 4354,
  [5631] = 4583,
  [5632] = 4584,
  [5633] = 4587,
  [5634] = 4358,
  [5635] = 4648,
  [5636] = 4684,
  [5637] = 4351,
  [5638] = 4373,
  [5639] = 4369,
  [5640] = 4650,
  [5641] = 4373,
  [5642] = 4374,
  [5643] = 4374,
  [5644] = 4279,
  [5645] = 4375,
  [5646] = 4353,
  [5647] = 4375,
  [5648] = 4376,
  [5649] = 4377,
  [5650] = 4380,
  [5651] = 4352,
  [5652] = 4684,
  [5653] = 4692,
  [5654] = 4695,
  [5655] = 4354,
  [5656] = 4358,
  [5657] = 4652,
  [5658] = 4651,
  [5659] = 4604,
  [5660] = 4351,
  [5661] = 4373,
  [5662] = 4373,
  [5663] = 4374,
  [5664] = 4612,
  [5665] = 4613,
  [5666] = 4697,
  [5667] = 4375,
  [5668] = 4376,
  [5669] = 4571,
  [5670] = 4377,
  [5671] = 4692,
  [5672] = 4614,
  [5673] = 4615,
  [5674] = 4650,
  [5675] = 4376,
  [5676] = 4377,
  [5677] = 4284,
  [5678] = 4380,
  [5679] = 4695,
  [5680] = 4666,
  [5681] = 4674,
  [5682] = 4608,
  [5683] = 4610,
  [5684] = 4299,
  [5685] = 4697,
  [5686] = 4353,
  [5687] = 4302,
  [5688] = 4700,
  [5689] = 4611,
  [5690] = 4648,
  [5691] = 4375,
  [5692] = 4586,
  [5693] = 4692,
  [5694] = 4369,
  [5695] = 4652,
  [5696] = 4352,
  [5697] = 4692,
  [5698] = 4695,
  [5699] = 4697,
  [5700] = 4597,
  [5701] = 4612,
  [5702] = 4613,
  [5703] = 4695,
  [5704] = 4700,
  [5705] = 4352,
  [5706] = 4354,
  [5707] = 4358,
  [5708] = 4614,
  [5709] = 4615,
  [5710] = 4650,
  [5711] = 4597,
  [5712] = 4617,
  [5713] = 4618,
  [5714] = 4617,
  [5715] = 4623,
  [5716] = 4589,
  [5717] = 4720,
  [5718] = 4385,
  [5719] = 4721,
  [5720] = 4618,
  [5721] = 4373,
  [5722] = 4374,
  [5723] = 4375,
  [5724] = 4626,
  [5725] = 4567,
  [5726] = 4651,
  [5727] = 4575,
  [5728] = 4631,
  [5729] = 4376,
  [5730] = 4377,
  [5731] = 4589,
  [5732] = 4354,
  [5733] = 4603,
  [5734] = 4586,
  [5735] = 4380,
  [5736] = 4604,
  [5737] = 4623,
  [5738] = 4674,
  [5739] = 4632,
  [5740] = 4626,
  [5741] = 4600,
  [5742] = 4634,
  [5743] = 4279,
  [5744] = 4568,
  [5745] = 4652,
  [5746] = 4651,
  [5747] = 4569,
  [5748] = 4570,
  [5749] = 4571,
  [5750] = 4576,
  [5751] = 4380,
  [5752] = 4582,
  [5753] = 4622,
  [5754] = 4596,
  [5755] = 4692,
  [5756] = 4695,
  [5757] = 4697,
  [5758] = 4602,
  [5759] = 4583,
  [5760] = 4700,
  [5761] = 4584,
  [5762] = 4587,
  [5763] = 4272,
  [5764] = 4358,
  [5765] = 4287,
  [5766] = 4631,
  [5767] = 4388,
  [5768] = 4697,
  [5769] = 4632,
  [5770] = 4622,
  [5771] = 4380,
  [5772] = 4604,
  [5773] = 4573,
  [5774] = 4574,
  [5775] = 4600,
  [5776] = 4720,
  [5777] = 4634,
  [5778] = 4721,
  [5779] = 4700,
  [5780] = 4692,
  [5781] = 4458,
  [5782] = 4695,
  [5783] = 4651,
  [5784] = 4684,
  [5785] = 4568,
  [5786] = 4569,
  [5787] = 4697,
  [5788] = 4570,
  [5789] = 4648,
  [5790] = 4684,
  [5791] = 4571,
  [5792] = 4374,
  [5793] = 4353,
  [5794] = 5581,
  [5795] = 4294,
  [5796] = 4576,
  [5797] = 4582,
  [5798] = 4567,
  [5799] = 4650,
  [5800] = 4575,
  [5801] = 4375,
  [5802] = 4622,
  [5803] = 4700,
  [5804] = 4369,
  [5805] = 4720,
  [5806] = 4602,
  [5807] = 4583,
  [5808] = 4603,
  [5809] = 4586,
  [5810] = 4351,
  [5811] = 4651,
  [5812] = 4604,
  [5813] = 4749,
  [5814] = 4573,
  [5815] = 4751,
  [5816] = 4584,
  [5817] = 4574,
  [5818] = 4603,
  [5819] = 4571,
  [5820] = 4660,
  [5821] = 5581,
  [5822] = 4587,
  [5823] = 4604,
  [5824] = 4361,
  [5825] = 4571,
  [5826] = 4362,
  [5827] = 4755,
  [5828] = 4596,
  [5829] = 4352,
  [5830] = 4666,
  [5831] = 4608,
  [5832] = 4610,
  [5833] = 4272,
  [5834] = 4611,
  [5835] = 4674,
  [5836] = 4603,
  [5837] = 4612,
  [5838] = 4613,
  [5839] = 4614,
  [5840] = 4615,
  [5841] = 4597,
  [5842] = 4617,
  [5843] = 4618,
  [5844] = 4608,
  [5845] = 4623,
  [5846] = 4626,
  [5847] = 4631,
  [5848] = 4632,
  [5849] = 4351,
  [5850] = 4610,
  [5851] = 4660,
  [5852] = 4600,
  [5853] = 4573,
  [5854] = 4686,
  [5855] = 4634,
  [5856] = 4568,
  [5857] = 4569,
  [5858] = 4589,
  [5859] = 4570,
  [5860] = 4576,
  [5861] = 4582,
  [5862] = 4602,
  [5863] = 4611,
  [5864] = 4648,
  [5865] = 4583,
  [5866] = 4353,
  [5867] = 4584,
  [5868] = 4587,
  [5869] = 4749,
  [5870] = 4574,
  [5871] = 4751,
  [5872] = 4738,
  [5873] = 4755,
  [5874] = 4352,
  [5875] = 4720,
  [5876] = 4354,
  [5877] = 4369,
  [5878] = 4721,
  [5879] = 4738,
  [5880] = 4648,
  [5881] = 4378,
  [5882] = 4650,
  [5883] = 4686,
  [5884] = 4651,
  [5885] = 4379,
  [5886] = 4674,
  [5887] = 4567,
  [5888] = 4352,
  [5889] = 4354,
  [5890] = 4358,
  [5891] = 4738,
  [5892] = 4608,
  [5893] = 4610,
  [5894] = 4652,
  [5895] = 4720,
  [5896] = 4611,
  [5897] = 4571,
  [5898] = 4612,
  [5899] = 4613,
  [5900] = 4373,
  [5901] = 4612,
  [5902] = 4374,
  [5903] = 4666,
  [5904] = 4375,
  [5905] = 4613,
  [5906] = 4606,
  [5907] = 4378,
  [5908] = 4379,
  [5909] = 4684,
  [5910] = 4614,
  [5911] = 4660,
  [5912] = 4614,
  [5913] = 4376,
  [5914] = 4615,
  [5915] = 4377,
  [5916] = 4615,
  [5917] = 4650,
  [5918] = 4674,
  [5919] = 4692,
  [5920] = 4692,
  [5921] = 4380,
  [5922] = 4695,
  [5923] = 4695,
  [5924] = 4697,
  [5925] = 4697,
  [5926] = 4674,
  [5927] = 4700,
  [5928] = 4749,
  [5929] = 4700,
  [5930] = 4597,
  [5931] = 4674,
  [5932] = 4567,
  [5933] = 4617,
  [5934] = 4458,
  [5935] = 4618,
  [5936] = 4623,
  [5937] = 4586,
  [5938] = 4626,
  [5939] = 4597,
  [5940] = 4575,
  [5941] = 4617,
  [5942] = 4720,
  [5943] = 4381,
  [5944] = 4606,
  [5945] = 4721,
  [5946] = 4660,
  [5947] = 4631,
  [5948] = 4632,
  [5949] = 4618,
  [5950] = 4623,
  [5951] = 4600,
  [5952] = 4634,
  [5953] = 4358,
  [5954] = 4568,
  [5955] = 4569,
  [5956] = 4570,
  [5957] = 4583,
  [5958] = 4586,
  [5959] = 4567,
  [5960] = 4392,
  [5961] = 4589,
  [5962] = 4575,
  [5963] = 4582,
  [5964] = 4749,
  [5965] = 4575,
  [5966] = 4660,
  [5967] = 4608,
  [5968] = 4610,
  [5969] = 4611,
  [5970] = 4589,
  [5971] = 4613,
  [5972] = 4612,
  [5973] = 4613,
  [5974] = 4614,
  [5975] = 4614,
  [5976] = 4615,
  [5977] = 4597,
  [5978] = 4617,
  [5979] = 4618,
  [5980] = 4623,
  [5981] = 4626,
  [5982] = 4603,
  [5983] = 4631,
  [5984] = 4632,
  [5985] = 4600,
  [5986] = 5986,
  [5987] = 4622,
  [5988] = 4634,
  [5989] = 4568,
  [5990] = 4569,
  [5991] = 4589,
  [5992] = 4570,
  [5993] = 4576,
  [5994] = 4582,
  [5995] = 4602,
  [5996] = 4583,
  [5997] = 4584,
  [5998] = 4587,
  [5999] = 4272,
  [6000] = 4614,
  [6001] = 4652,
  [6002] = 4586,
  [6003] = 4615,
  [6004] = 4604,
  [6005] = 4602,
  [6006] = 4684,
  [6007] = 4573,
  [6008] = 4574,
  [6009] = 4666,
  [6010] = 4692,
  [6011] = 4608,
  [6012] = 4610,
  [6013] = 4611,
  [6014] = 4648,
  [6015] = 4684,
  [6016] = 5213,
  [6017] = 4695,
  [6018] = 4612,
  [6019] = 4613,
  [6020] = 4614,
  [6021] = 4697,
  [6022] = 4615,
  [6023] = 4650,
  [6024] = 4597,
  [6025] = 4617,
  [6026] = 4618,
  [6027] = 4623,
  [6028] = 4626,
  [6029] = 4651,
  [6030] = 4631,
  [6031] = 4632,
  [6032] = 4600,
  [6033] = 4634,
  [6034] = 4568,
  [6035] = 4569,
  [6036] = 4570,
  [6037] = 4596,
  [6038] = 4583,
  [6039] = 4571,
  [6040] = 4576,
  [6041] = 4582,
  [6042] = 4700,
  [6043] = 4602,
  [6044] = 4583,
  [6045] = 4584,
  [6046] = 4587,
  [6047] = 4369,
  [6048] = 4584,
  [6049] = 4631,
  [6050] = 4272,
  [6051] = 4648,
  [6052] = 4650,
  [6053] = 4597,
  [6054] = 4651,
  [6055] = 4632,
  [6056] = 4571,
  [6057] = 4617,
  [6058] = 4751,
  [6059] = 4618,
  [6060] = 4623,
  [6061] = 4660,
  [6062] = 4626,
  [6063] = 4684,
  [6064] = 4755,
  [6065] = 4369,
  [6066] = 4692,
  [6067] = 4666,
  [6068] = 4720,
  [6069] = 4352,
  [6070] = 4354,
  [6071] = 4615,
  [6072] = 4358,
  [6073] = 4721,
  [6074] = 4631,
  [6075] = 4352,
  [6076] = 4632,
  [6077] = 4695,
  [6078] = 4354,
  [6079] = 4686,
  [6080] = 4697,
  [6081] = 4358,
  [6082] = 4600,
  [6083] = 4686,
  [6084] = 4634,
  [6085] = 4587,
  [6086] = 4373,
  [6087] = 4568,
  [6088] = 4374,
  [6089] = 4569,
  [6090] = 4570,
  [6091] = 4610,
  [6092] = 4375,
  [6093] = 4567,
  [6094] = 4373,
  [6095] = 4622,
  [6096] = 4374,
  [6097] = 4375,
  [6098] = 4573,
  [6099] = 4574,
  [6100] = 4376,
  [6101] = 4377,
  [6102] = 4376,
  [6103] = 4377,
  [6104] = 4380,
  [6105] = 4380,
  [6106] = 4589,
  [6107] = 4575,
  [6108] = 4608,
  [6109] = 4610,
  [6110] = 4611,
  [6111] = 5986,
  [6112] = 4576,
  [6113] = 4612,
  [6114] = 4613,
  [6115] = 4749,
  [6116] = 4751,
  [6117] = 4582,
  [6118] = 4608,
  [6119] = 4610,
  [6120] = 4611,
  [6121] = 4684,
  [6122] = 4614,
  [6123] = 4755,
  [6124] = 4612,
  [6125] = 4613,
  [6126] = 4614,
  [6127] = 4615,
  [6128] = 4622,
  [6129] = 4597,
  [6130] = 4617,
  [6131] = 4618,
  [6132] = 4623,
  [6133] = 4626,
  [6134] = 4573,
  [6135] = 4574,
  [6136] = 4631,
  [6137] = 4632,
  [6138] = 4600,
  [6139] = 4634,
  [6140] = 4568,
  [6141] = 4569,
  [6142] = 4570,
  [6143] = 4576,
  [6144] = 4582,
  [6145] = 4602,
  [6146] = 4583,
  [6147] = 4584,
  [6148] = 4587,
  [6149] = 4615,
  [6150] = 4622,
  [6151] = 4648,
  [6152] = 4602,
  [6153] = 5581,
  [6154] = 4650,
  [6155] = 4597,
  [6156] = 4583,
  [6157] = 4651,
  [6158] = 4617,
  [6159] = 4584,
  [6160] = 4571,
  [6161] = 4738,
  [6162] = 4618,
  [6163] = 4623,
  [6164] = 4749,
  [6165] = 4626,
  [6166] = 4573,
  [6167] = 4574,
  [6168] = 4751,
  [6169] = 4755,
  [6170] = 4631,
  [6171] = 4272,
  [6172] = 4666,
  [6173] = 4632,
  [6174] = 6174,
  [6175] = 4700,
  [6176] = 4660,
  [6177] = 4749,
  [6178] = 4600,
  [6179] = 4600,
  [6180] = 4738,
  [6181] = 4648,
  [6182] = 4634,
  [6183] = 4568,
  [6184] = 4569,
  [6185] = 4282,
  [6186] = 4570,
  [6187] = 4751,
  [6188] = 4755,
  [6189] = 4576,
  [6190] = 4603,
  [6191] = 4652,
  [6192] = 4582,
  [6193] = 4586,
  [6194] = 4602,
  [6195] = 4583,
  [6196] = 4272,
  [6197] = 4584,
  [6198] = 4666,
  [6199] = 4587,
  [6200] = 4272,
  [6201] = 4606,
  [6202] = 4634,
  [6203] = 4587,
  [6204] = 4604,
  [6205] = 4458,
  [6206] = 4650,
  [6207] = 4597,
  [6208] = 4720,
  [6209] = 4597,
  [6210] = 4617,
  [6211] = 4648,
  [6212] = 4684,
  [6213] = 4568,
  [6214] = 4652,
  [6215] = 4569,
  [6216] = 4652,
  [6217] = 4272,
  [6218] = 4692,
  [6219] = 4674,
  [6220] = 4606,
  [6221] = 4651,
  [6222] = 4686,
  [6223] = 4660,
  [6224] = 4570,
  [6225] = 4355,
  [6226] = 4340,
  [6227] = 4361,
  [6228] = 4362,
  [6229] = 4749,
  [6230] = 4617,
  [6231] = 4751,
  [6232] = 5581,
  [6233] = 4648,
  [6234] = 4650,
  [6235] = 4695,
  [6236] = 4282,
  [6237] = 4697,
  [6238] = 4755,
  [6239] = 4650,
  [6240] = 4700,
  [6241] = 4618,
  [6242] = 4651,
  [6243] = 4674,
  [6244] = 4721,
  [6245] = 4612,
  [6246] = 4571,
  [6247] = 4623,
  [6248] = 4666,
  [6249] = 4626,
  [6250] = 4692,
  [6251] = 4695,
  [6252] = 4697,
  [6253] = 4567,
  [6254] = 4651,
  [6255] = 4575,
  [6256] = 4603,
  [6257] = 4586,
  [6258] = 4660,
  [6259] = 4700,
  [6260] = 4604,
  [6261] = 4571,
  [6262] = 4606,
  [6263] = 4721,
  [6264] = 4600,
  [6265] = 4618,
  [6266] = 4686,
  [6267] = 4567,
  [6268] = 4575,
  [6269] = 4603,
  [6270] = 4586,
  [6271] = 4604,
  [6272] = 4720,
  [6273] = 4666,
  [6274] = 4721,
  [6275] = 4755,
  [6276] = 4738,
  [6277] = 4914,
  [6278] = 4674,
  [6279] = 4631,
  [6280] = 4612,
  [6281] = 4660,
  [6282] = 4651,
  [6283] = 4632,
  [6284] = 4622,
  [6285] = 4355,
  [6286] = 4340,
  [6287] = 4686,
  [6288] = 4634,
  [6289] = 4573,
  [6290] = 4574,
  [6291] = 4720,
  [6292] = 4361,
  [6293] = 4362,
  [6294] = 4568,
  [6295] = 4674,
  [6296] = 4569,
  [6297] = 4686,
  [6298] = 4608,
  [6299] = 4610,
  [6300] = 4660,
  [6301] = 4611,
  [6302] = 4282,
  [6303] = 4652,
  [6304] = 4612,
  [6305] = 4613,
  [6306] = 4666,
  [6307] = 4614,
  [6308] = 4615,
  [6309] = 4692,
  [6310] = 4695,
  [6311] = 4697,
  [6312] = 4700,
  [6313] = 4570,
  [6314] = 4597,
  [6315] = 4617,
  [6316] = 4618,
  [6317] = 4623,
  [6318] = 4626,
  [6319] = 4571,
  [6320] = 4652,
  [6321] = 4738,
  [6322] = 4721,
  [6323] = 4631,
  [6324] = 4632,
  [6325] = 4686,
  [6326] = 4600,
  [6327] = 4571,
  [6328] = 4623,
  [6329] = 4634,
  [6330] = 4568,
  [6331] = 4569,
  [6332] = 4570,
  [6333] = 4567,
  [6334] = 4567,
  [6335] = 4575,
  [6336] = 4576,
  [6337] = 4582,
  [6338] = 4602,
  [6339] = 4602,
  [6340] = 4583,
  [6341] = 4584,
  [6342] = 4603,
  [6343] = 4586,
  [6344] = 4587,
  [6345] = 4604,
  [6346] = 4272,
  [6347] = 4606,
  [6348] = 4648,
  [6349] = 4575,
  [6350] = 4576,
  [6351] = 4650,
  [6352] = 4603,
  [6353] = 4582,
  [6354] = 4583,
  [6355] = 4651,
  [6356] = 4604,
  [6357] = 4584,
  [6358] = 4674,
  [6359] = 4571,
  [6360] = 4458,
  [6361] = 4606,
  [6362] = 4589,
  [6363] = 4613,
  [6364] = 4586,
  [6365] = 4626,
  [6366] = 4351,
  [6367] = 4684,
  [6368] = 5213,
  [6369] = 5213,
  [6370] = 4589,
  [6371] = 4589,
  [6372] = 4666,
  [6373] = 4589,
  [6374] = 4281,
  [6375] = 4281,
  [6376] = 4596,
  [6377] = 4353,
  [6378] = 4606,
  [6379] = 4749,
  [6380] = 5581,
  [6381] = 4751,
  [6382] = 4738,
  [6383] = 4587,
  [6384] = 4576,
  [6385] = 4755,
  [6386] = 4674,
  [6387] = 4351,
  [6388] = 4608,
  [6389] = 4692,
  [6390] = 4695,
  [6391] = 4697,
  [6392] = 4674,
  [6393] = 4700,
  [6394] = 4652,
  [6395] = 5581,
  [6396] = 4622,
  [6397] = 4610,
  [6398] = 4692,
  [6399] = 4695,
  [6400] = 4697,
  [6401] = 4700,
  [6402] = 4684,
  [6403] = 4660,
  [6404] = 4573,
  [6405] = 4574,
  [6406] = 4720,
  [6407] = 4720,
  [6408] = 4614,
  [6409] = 4721,
  [6410] = 4612,
  [6411] = 4615,
  [6412] = 4353,
  [6413] = 4684,
  [6414] = 4721,
  [6415] = 4650,
  [6416] = 4692,
  [6417] = 4695,
  [6418] = 4567,
  [6419] = 4575,
  [6420] = 4697,
  [6421] = 4700,
  [6422] = 5986,
  [6423] = 4603,
  [6424] = 4749,
  [6425] = 4674,
  [6426] = 4586,
  [6427] = 4622,
  [6428] = 4751,
  [6429] = 4604,
  [6430] = 4582,
  [6431] = 4738,
  [6432] = 4755,
  [6433] = 4281,
  [6434] = 4652,
  [6435] = 5213,
  [6436] = 4611,
  [6437] = 6174,
  [6438] = 4648,
  [6439] = 4613,
  [6440] = 4608,
  [6441] = 4720,
  [6442] = 4611,
  [6443] = 4721,
  [6444] = 4610,
  [6445] = 4749,
  [6446] = 4738,
  [6447] = 4751,
  [6448] = 4738,
  [6449] = 4611,
  [6450] = 6174,
  [6451] = 4622,
  [6452] = 4567,
  [6453] = 4575,
  [6454] = 4573,
  [6455] = 4573,
  [6456] = 4574,
  [6457] = 6457,
  [6458] = 4574,
  [6459] = 4567,
  [6460] = 4603,
  [6461] = 4586,
  [6462] = 4608,
  [6463] = 4604,
  [6464] = 4720,
  [6465] = 4686,
  [6466] = 4749,
  [6467] = 4362,
  [6468] = 4617,
  [6469] = 4458,
  [6470] = 4692,
  [6471] = 4695,
  [6472] = 4355,
  [6473] = 4340,
  [6474] = 4361,
  [6475] = 4362,
  [6476] = 4697,
  [6477] = 5986,
  [6478] = 4738,
  [6479] = 4272,
  [6480] = 4660,
  [6481] = 4700,
  [6482] = 4282,
  [6483] = 4618,
  [6484] = 4623,
  [6485] = 4608,
  [6486] = 4660,
  [6487] = 4610,
  [6488] = 4272,
  [6489] = 4281,
  [6490] = 4626,
  [6491] = 4651,
  [6492] = 5986,
  [6493] = 4573,
  [6494] = 4574,
  [6495] = 4272,
  [6496] = 4631,
  [6497] = 4720,
  [6498] = 6174,
  [6499] = 4611,
  [6500] = 4632,
  [6501] = 4721,
  [6502] = 4648,
  [6503] = 4272,
  [6504] = 4272,
  [6505] = 4686,
  [6506] = 4652,
  [6507] = 4600,
  [6508] = 4634,
  [6509] = 4568,
  [6510] = 4569,
  [6511] = 4570,
  [6512] = 4608,
  [6513] = 4610,
  [6514] = 4611,
  [6515] = 4571,
  [6516] = 4576,
  [6517] = 4674,
  [6518] = 4612,
  [6519] = 4582,
  [6520] = 4613,
  [6521] = 4614,
  [6522] = 4615,
  [6523] = 4622,
  [6524] = 4652,
  [6525] = 4282,
  [6526] = 4567,
  [6527] = 4355,
  [6528] = 4340,
  [6529] = 4602,
  [6530] = 4583,
  [6531] = 4575,
  [6532] = 4584,
  [6533] = 4597,
  [6534] = 4617,
  [6535] = 4618,
  [6536] = 4587,
  [6537] = 4623,
  [6538] = 4626,
  [6539] = 4573,
  [6540] = 4574,
  [6541] = 4631,
  [6542] = 4361,
  [6543] = 4632,
  [6544] = 4362,
  [6545] = 4600,
  [6546] = 4634,
  [6547] = 4568,
  [6548] = 5986,
  [6549] = 4569,
  [6550] = 4272,
  [6551] = 4684,
  [6552] = 4570,
  [6553] = 4576,
  [6554] = 4589,
  [6555] = 4586,
  [6556] = 4602,
  [6557] = 6557,
  [6558] = 4583,
  [6559] = 4584,
  [6560] = 4587,
  [6561] = 4738,
  [6562] = 4281,
  [6563] = 5986,
  [6564] = 4281,
  [6565] = 4282,
  [6566] = 4648,
  [6567] = 4650,
  [6568] = 4651,
  [6569] = 4606,
  [6570] = 4571,
  [6571] = 5213,
  [6572] = 6174,
  [6573] = 4684,
  [6574] = 4272,
  [6575] = 4692,
  [6576] = 4695,
  [6577] = 4697,
  [6578] = 4700,
  [6579] = 5581,
  [6580] = 5213,
  [6581] = 4751,
  [6582] = 4281,
  [6583] = 4606,
  [6584] = 4589,
  [6585] = 4282,
  [6586] = 4355,
  [6587] = 4720,
  [6588] = 4589,
  [6589] = 4721,
  [6590] = 4589,
  [6591] = 4567,
  [6592] = 4575,
  [6593] = 4755,
  [6594] = 4603,
  [6595] = 4586,
  [6596] = 4281,
  [6597] = 4666,
  [6598] = 4458,
  [6599] = 4604,
  [6600] = 4612,
  [6601] = 4686,
  [6602] = 4272,
  [6603] = 6174,
  [6604] = 4458,
  [6605] = 5581,
  [6606] = 4281,
  [6607] = 4613,
  [6608] = 4614,
  [6609] = 4340,
  [6610] = 4749,
  [6611] = 4615,
  [6612] = 4272,
  [6613] = 4650,
  [6614] = 4603,
  [6615] = 4751,
  [6616] = 4755,
  [6617] = 4604,
  [6618] = 4666,
  [6619] = 4281,
  [6620] = 6557,
  [6621] = 4282,
  [6622] = 6557,
  [6623] = 4282,
  [6624] = 4597,
  [6625] = 4674,
  [6626] = 4622,
  [6627] = 4361,
  [6628] = 6174,
  [6629] = 4282,
  [6630] = 6457,
  [6631] = 4589,
  [6632] = 4582,
  [6633] = 4272,
  [6634] = 4602,
  [6635] = 4340,
  [6636] = 6557,
  [6637] = 4361,
  [6638] = 4362,
  [6639] = 4272,
  [6640] = 4749,
  [6641] = 6557,
  [6642] = 4622,
  [6643] = 4458,
  [6644] = 4272,
  [6645] = 4281,
  [6646] = 4355,
  [6647] = 4573,
  [6648] = 4574,
  [6649] = 4340,
  [6650] = 4587,
  [6651] = 4589,
  [6652] = 4751,
  [6653] = 4340,
  [6654] = 4458,
  [6655] = 4583,
  [6656] = 4576,
  [6657] = 4362,
  [6658] = 4738,
  [6659] = 4272,
  [6660] = 4272,
  [6661] = 4608,
  [6662] = 4610,
  [6663] = 4755,
  [6664] = 4611,
  [6665] = 4622,
  [6666] = 4361,
  [6667] = 4612,
  [6668] = 4613,
  [6669] = 4573,
  [6670] = 4574,
  [6671] = 4614,
  [6672] = 4615,
  [6673] = 6673,
  [6674] = 4281,
  [6675] = 4362,
  [6676] = 4651,
  [6677] = 4597,
  [6678] = 4617,
  [6679] = 4618,
  [6680] = 4623,
  [6681] = 4626,
  [6682] = 4631,
  [6683] = 4632,
  [6684] = 4684,
  [6685] = 4600,
  [6686] = 4634,
  [6687] = 4568,
  [6688] = 4569,
  [6689] = 4570,
  [6690] = 4272,
  [6691] = 4576,
  [6692] = 4582,
  [6693] = 4602,
  [6694] = 4583,
  [6695] = 6557,
  [6696] = 4584,
  [6697] = 4587,
  [6698] = 6174,
  [6699] = 4608,
  [6700] = 4648,
  [6701] = 4610,
  [6702] = 6174,
  [6703] = 4660,
  [6704] = 4611,
  [6705] = 4608,
  [6706] = 4610,
  [6707] = 4660,
  [6708] = 4650,
  [6709] = 4612,
  [6710] = 4613,
  [6711] = 4611,
  [6712] = 4666,
  [6713] = 4614,
  [6714] = 4615,
  [6715] = 4281,
  [6716] = 4597,
  [6717] = 4617,
  [6718] = 4618,
  [6719] = 4623,
  [6720] = 4626,
  [6721] = 6721,
  [6722] = 4631,
  [6723] = 4632,
  [6724] = 4651,
  [6725] = 4686,
  [6726] = 4600,
  [6727] = 4634,
  [6728] = 4568,
  [6729] = 5986,
  [6730] = 4569,
  [6731] = 4570,
  [6732] = 4576,
  [6733] = 4582,
  [6734] = 4602,
  [6735] = 4282,
  [6736] = 4583,
  [6737] = 4584,
  [6738] = 4587,
  [6739] = 4458,
  [6740] = 4571,
  [6741] = 4355,
  [6742] = 4589,
  [6743] = 5986,
  [6744] = 4612,
  [6745] = 4613,
  [6746] = 4666,
  [6747] = 4614,
  [6748] = 4615,
  [6749] = 4362,
  [6750] = 4589,
  [6751] = 4282,
  [6752] = 6752,
  [6753] = 6753,
  [6754] = 4282,
  [6755] = 4340,
  [6756] = 4755,
  [6757] = 4458,
  [6758] = 6721,
  [6759] = 4573,
  [6760] = 4597,
  [6761] = 6673,
  [6762] = 4617,
  [6763] = 4458,
  [6764] = 4618,
  [6765] = 4458,
  [6766] = 4623,
  [6767] = 4626,
  [6768] = 4574,
  [6769] = 6752,
  [6770] = 4355,
  [6771] = 6753,
  [6772] = 4361,
  [6773] = 4458,
  [6774] = 4340,
  [6775] = 4458,
  [6776] = 4631,
  [6777] = 4632,
  [6778] = 4686,
  [6779] = 4648,
  [6780] = 4650,
  [6781] = 4272,
  [6782] = 4362,
  [6783] = 6783,
  [6784] = 4600,
  [6785] = 4651,
  [6786] = 4622,
  [6787] = 4355,
  [6788] = 4738,
  [6789] = 4340,
  [6790] = 5986,
  [6791] = 4634,
  [6792] = 6174,
  [6793] = 4571,
  [6794] = 4749,
  [6795] = 4648,
  [6796] = 4684,
  [6797] = 6174,
  [6798] = 4272,
  [6799] = 6752,
  [6800] = 4749,
  [6801] = 4458,
  [6802] = 4281,
  [6803] = 4751,
  [6804] = 4568,
  [6805] = 4282,
  [6806] = 6753,
  [6807] = 4660,
  [6808] = 4569,
  [6809] = 4582,
  [6810] = 4755,
  [6811] = 5986,
  [6812] = 4570,
  [6813] = 4584,
  [6814] = 4666,
  [6815] = 4281,
  [6816] = 4650,
  [6817] = 4684,
  [6818] = 6174,
  [6819] = 6783,
  [6820] = 4361,
  [6821] = 4361,
  [6822] = 4458,
  [6823] = 5986,
  [6824] = 4281,
  [6825] = 4571,
  [6826] = 4362,
  [6827] = 4355,
  [6828] = 4738,
  [6829] = 4751,
  [6830] = 4361,
  [6831] = 4686,
  [6832] = 4272,
  [6833] = 6673,
  [6834] = 6721,
  [6835] = 4355,
  [6836] = 6557,
  [6837] = 4282,
  [6838] = 4282,
  [6839] = 4340,
  [6840] = 4361,
  [6841] = 4355,
  [6842] = 4362,
  [6843] = 6783,
  [6844] = 6844,
  [6845] = 4613,
  [6846] = 4614,
  [6847] = 4355,
  [6848] = 4608,
  [6849] = 4610,
  [6850] = 6174,
  [6851] = 4615,
  [6852] = 4597,
  [6853] = 4617,
  [6854] = 5986,
  [6855] = 4618,
  [6856] = 4623,
  [6857] = 4626,
  [6858] = 4281,
  [6859] = 4650,
  [6860] = 4340,
  [6861] = 6861,
  [6862] = 6862,
  [6863] = 4587,
  [6864] = 4631,
  [6865] = 4651,
  [6866] = 4632,
  [6867] = 4458,
  [6868] = 4600,
  [6869] = 6869,
  [6870] = 4634,
  [6871] = 4568,
  [6872] = 4571,
  [6873] = 6869,
  [6874] = 4684,
  [6875] = 4569,
  [6876] = 4570,
  [6877] = 4597,
  [6878] = 4738,
  [6879] = 4617,
  [6880] = 4243,
  [6881] = 4608,
  [6882] = 4576,
  [6883] = 4582,
  [6884] = 4597,
  [6885] = 4618,
  [6886] = 4623,
  [6887] = 4602,
  [6888] = 4583,
  [6889] = 4584,
  [6890] = 4611,
  [6891] = 4626,
  [6892] = 4587,
  [6893] = 4617,
  [6894] = 4610,
  [6895] = 4618,
  [6896] = 4660,
  [6897] = 4361,
  [6898] = 6898,
  [6899] = 4648,
  [6900] = 4612,
  [6901] = 4613,
  [6902] = 4749,
  [6903] = 4617,
  [6904] = 4684,
  [6905] = 4618,
  [6906] = 4623,
  [6907] = 6907,
  [6908] = 4648,
  [6909] = 6557,
  [6910] = 6174,
  [6911] = 4666,
  [6912] = 4650,
  [6913] = 4684,
  [6914] = 4626,
  [6915] = 4571,
  [6916] = 4666,
  [6917] = 4610,
  [6918] = 4651,
  [6919] = 4612,
  [6920] = 4272,
  [6921] = 6783,
  [6922] = 6557,
  [6923] = 4458,
  [6924] = 4650,
  [6925] = 6783,
  [6926] = 4686,
  [6927] = 4571,
  [6928] = 6783,
  [6929] = 4608,
  [6930] = 4610,
  [6931] = 6752,
  [6932] = 4611,
  [6933] = 6752,
  [6934] = 6753,
  [6935] = 6174,
  [6936] = 4612,
  [6937] = 4623,
  [6938] = 4613,
  [6939] = 4686,
  [6940] = 6940,
  [6941] = 4614,
  [6942] = 4613,
  [6943] = 6943,
  [6944] = 4615,
  [6945] = 4651,
  [6946] = 6753,
  [6947] = 6752,
  [6948] = 4597,
  [6949] = 4617,
  [6950] = 4618,
  [6951] = 4623,
  [6952] = 4626,
  [6953] = 6753,
  [6954] = 4651,
  [6955] = 4631,
  [6956] = 4614,
  [6957] = 4626,
  [6958] = 4631,
  [6959] = 4632,
  [6960] = 4615,
  [6961] = 4600,
  [6962] = 4611,
  [6963] = 4458,
  [6964] = 4634,
  [6965] = 4612,
  [6966] = 4614,
  [6967] = 4611,
  [6968] = 4571,
  [6969] = 4362,
  [6970] = 4568,
  [6971] = 4569,
  [6972] = 4570,
  [6973] = 4355,
  [6974] = 4631,
  [6975] = 4243,
  [6976] = 4576,
  [6977] = 4582,
  [6978] = 6907,
  [6979] = 6979,
  [6980] = 4632,
  [6981] = 4602,
  [6982] = 4600,
  [6983] = 4634,
  [6984] = 4568,
  [6985] = 4340,
  [6986] = 4613,
  [6987] = 6557,
  [6988] = 4583,
  [6989] = 4584,
  [6990] = 6990,
  [6991] = 4587,
  [6992] = 4632,
  [6993] = 4749,
  [6994] = 4751,
  [6995] = 6943,
  [6996] = 4597,
  [6997] = 4738,
  [6998] = 4617,
  [6999] = 4361,
  [7000] = 7000,
  [7001] = 6861,
  [7002] = 4618,
  [7003] = 4569,
  [7004] = 6862,
  [7005] = 6898,
  [7006] = 4362,
  [7007] = 4458,
  [7008] = 4570,
  [7009] = 4600,
  [7010] = 4755,
  [7011] = 4623,
  [7012] = 6861,
  [7013] = 4634,
  [7014] = 6174,
  [7015] = 6174,
  [7016] = 6907,
  [7017] = 4755,
  [7018] = 5986,
  [7019] = 4626,
  [7020] = 4568,
  [7021] = 4569,
  [7022] = 4570,
  [7023] = 4615,
  [7024] = 6721,
  [7025] = 4738,
  [7026] = 4576,
  [7027] = 4751,
  [7028] = 6940,
  [7029] = 5986,
  [7030] = 4660,
  [7031] = 4571,
  [7032] = 7032,
  [7033] = 4458,
  [7034] = 4614,
  [7035] = 4272,
  [7036] = 4751,
  [7037] = 6862,
  [7038] = 6943,
  [7039] = 4738,
  [7040] = 4648,
  [7041] = 4355,
  [7042] = 4340,
  [7043] = 4576,
  [7044] = 4458,
  [7045] = 4631,
  [7046] = 4615,
  [7047] = 4582,
  [7048] = 4632,
  [7049] = 4608,
  [7050] = 4738,
  [7051] = 4631,
  [7052] = 4632,
  [7053] = 4738,
  [7054] = 4602,
  [7055] = 4583,
  [7056] = 5986,
  [7057] = 4582,
  [7058] = 4584,
  [7059] = 6907,
  [7060] = 4243,
  [7061] = 4602,
  [7062] = 4458,
  [7063] = 4749,
  [7064] = 4583,
  [7065] = 4458,
  [7066] = 4749,
  [7067] = 7067,
  [7068] = 7068,
  [7069] = 4660,
  [7070] = 7070,
  [7071] = 4574,
  [7072] = 4648,
  [7073] = 4755,
  [7074] = 4600,
  [7075] = 6673,
  [7076] = 4584,
  [7077] = 4458,
  [7078] = 6943,
  [7079] = 4272,
  [7080] = 4587,
  [7081] = 4749,
  [7082] = 6898,
  [7083] = 4666,
  [7084] = 4666,
  [7085] = 4650,
  [7086] = 5986,
  [7087] = 4666,
  [7088] = 4738,
  [7089] = 4458,
  [7090] = 4587,
  [7091] = 4282,
  [7092] = 4622,
  [7093] = 4648,
  [7094] = 4622,
  [7095] = 4738,
  [7096] = 6979,
  [7097] = 4573,
  [7098] = 7098,
  [7099] = 4648,
  [7100] = 4574,
  [7101] = 4573,
  [7102] = 4651,
  [7103] = 4573,
  [7104] = 4574,
  [7105] = 4634,
  [7106] = 4568,
  [7107] = 4622,
  [7108] = 4282,
  [7109] = 4622,
  [7110] = 6721,
  [7111] = 4569,
  [7112] = 4660,
  [7113] = 4686,
  [7114] = 4660,
  [7115] = 4570,
  [7116] = 4272,
  [7117] = 6721,
  [7118] = 4458,
  [7119] = 4576,
  [7120] = 4582,
  [7121] = 4651,
  [7122] = 6990,
  [7123] = 4751,
  [7124] = 4571,
  [7125] = 4602,
  [7126] = 4583,
  [7127] = 4584,
  [7128] = 4751,
  [7129] = 6869,
  [7130] = 7000,
  [7131] = 4587,
  [7132] = 4686,
  [7133] = 4281,
  [7134] = 6673,
  [7135] = 4600,
  [7136] = 4634,
  [7137] = 5986,
  [7138] = 4660,
  [7139] = 7098,
  [7140] = 4568,
  [7141] = 7098,
  [7142] = 4650,
  [7143] = 7067,
  [7144] = 5986,
  [7145] = 4738,
  [7146] = 4597,
  [7147] = 4686,
  [7148] = 7070,
  [7149] = 4569,
  [7150] = 4684,
  [7151] = 4648,
  [7152] = 4650,
  [7153] = 4573,
  [7154] = 4573,
  [7155] = 4574,
  [7156] = 4570,
  [7157] = 4574,
  [7158] = 4458,
  [7159] = 4576,
  [7160] = 6907,
  [7161] = 6557,
  [7162] = 4272,
  [7163] = 6907,
  [7164] = 4666,
  [7165] = 7067,
  [7166] = 4355,
  [7167] = 4243,
  [7168] = 6174,
  [7169] = 4361,
  [7170] = 4608,
  [7171] = 4684,
  [7172] = 4582,
  [7173] = 4610,
  [7174] = 4340,
  [7175] = 4361,
  [7176] = 4272,
  [7177] = 4362,
  [7178] = 4749,
  [7179] = 4611,
  [7180] = 4622,
  [7181] = 6673,
  [7182] = 4602,
  [7183] = 6557,
  [7184] = 4751,
  [7185] = 4660,
  [7186] = 6673,
  [7187] = 4612,
  [7188] = 4613,
  [7189] = 4362,
  [7190] = 6174,
  [7191] = 4573,
  [7192] = 6943,
  [7193] = 4614,
  [7194] = 7070,
  [7195] = 4615,
  [7196] = 6721,
  [7197] = 4622,
  [7198] = 4574,
  [7199] = 4755,
  [7200] = 4597,
  [7201] = 4617,
  [7202] = 4618,
  [7203] = 4623,
  [7204] = 4355,
  [7205] = 4626,
  [7206] = 4340,
  [7207] = 4361,
  [7208] = 4583,
  [7209] = 4684,
  [7210] = 4631,
  [7211] = 6940,
  [7212] = 4632,
  [7213] = 4651,
  [7214] = 4362,
  [7215] = 4600,
  [7216] = 4458,
  [7217] = 4634,
  [7218] = 4568,
  [7219] = 4569,
  [7220] = 4570,
  [7221] = 4272,
  [7222] = 4576,
  [7223] = 4582,
  [7224] = 4602,
  [7225] = 4583,
  [7226] = 4584,
  [7227] = 4587,
  [7228] = 4684,
  [7229] = 4686,
  [7230] = 4666,
  [7231] = 4686,
  [7232] = 4749,
  [7233] = 6979,
  [7234] = 4584,
  [7235] = 4622,
  [7236] = 4751,
  [7237] = 4755,
  [7238] = 6783,
  [7239] = 4608,
  [7240] = 6752,
  [7241] = 6753,
  [7242] = 4610,
  [7243] = 6943,
  [7244] = 4755,
  [7245] = 4738,
  [7246] = 4272,
  [7247] = 7068,
  [7248] = 4608,
  [7249] = 4571,
  [7250] = 4610,
  [7251] = 4611,
  [7252] = 7000,
  [7253] = 4611,
  [7254] = 4272,
  [7255] = 7068,
  [7256] = 6990,
  [7257] = 4573,
  [7258] = 4355,
  [7259] = 4574,
  [7260] = 4340,
  [7261] = 4361,
  [7262] = 4755,
  [7263] = 4362,
  [7264] = 4612,
  [7265] = 7265,
  [7266] = 4613,
  [7267] = 4614,
  [7268] = 7268,
  [7269] = 7269,
  [7270] = 4615,
  [7271] = 7265,
  [7272] = 7272,
  [7273] = 7268,
  [7274] = 7269,
  [7275] = 6844,
  [7276] = 7265,
  [7277] = 4612,
  [7278] = 7268,
  [7279] = 7269,
  [7280] = 6844,
  [7281] = 7272,
  [7282] = 7282,
  [7283] = 7032,
  [7284] = 7282,
  [7285] = 7032,
  [7286] = 7272,
  [7287] = 7282,
  [7288] = 4650,
  [7289] = 7289,
  [7290] = 4272,
  [7291] = 6940,
  [7292] = 4458,
  [7293] = 4458,
  [7294] = 4749,
  [7295] = 4458,
  [7296] = 4751,
  [7297] = 7297,
  [7298] = 4272,
  [7299] = 4755,
  [7300] = 4355,
  [7301] = 4340,
  [7302] = 4361,
  [7303] = 4362,
  [7304] = 7304,
  [7305] = 4272,
  [7306] = 7306,
  [7307] = 7282,
  [7308] = 4243,
  [7309] = 7297,
  [7310] = 7032,
  [7311] = 7311,
  [7312] = 7312,
  [7313] = 4738,
  [7314] = 7098,
  [7315] = 6907,
  [7316] = 7067,
  [7317] = 7070,
  [7318] = 7318,
  [7319] = 7319,
  [7320] = 7320,
  [7321] = 7321,
  [7322] = 7268,
  [7323] = 7323,
  [7324] = 7324,
  [7325] = 5986,
  [7326] = 7326,
  [7327] = 7269,
  [7328] = 7328,
  [7329] = 7329,
  [7330] = 6844,
  [7331] = 7331,
  [7332] = 7332,
  [7333] = 7333,
  [7334] = 7334,
  [7335] = 7335,
  [7336] = 7336,
  [7337] = 7337,
  [7338] = 7338,
  [7339] = 7339,
  [7340] = 7340,
  [7341] = 7321,
  [7342] = 7326,
  [7343] = 7329,
  [7344] = 7344,
  [7345] = 6907,
  [7346] = 6979,
  [7347] = 4684,
  [7348] = 6990,
  [7349] = 6557,
  [7350] = 6174,
  [7351] = 7344,
  [7352] = 7340,
  [7353] = 7353,
  [7354] = 6940,
  [7355] = 6861,
  [7356] = 6862,
  [7357] = 6898,
  [7358] = 7297,
  [7359] = 6943,
  [7360] = 7344,
  [7361] = 6557,
  [7362] = 7362,
  [7363] = 4738,
  [7364] = 7297,
  [7365] = 7340,
  [7366] = 7304,
  [7367] = 7367,
  [7368] = 7368,
  [7369] = 7369,
  [7370] = 7370,
  [7371] = 7371,
  [7372] = 7372,
  [7373] = 7373,
  [7374] = 7297,
  [7375] = 7375,
  [7376] = 7068,
  [7377] = 7377,
  [7378] = 7378,
  [7379] = 7000,
  [7380] = 7318,
  [7381] = 7319,
  [7382] = 7382,
  [7383] = 7320,
  [7384] = 7268,
  [7385] = 7323,
  [7386] = 7324,
  [7387] = 7269,
  [7388] = 7328,
  [7389] = 6844,
  [7390] = 6943,
  [7391] = 6907,
  [7392] = 7331,
  [7393] = 7393,
  [7394] = 7394,
  [7395] = 7353,
  [7396] = 7344,
  [7397] = 7397,
  [7398] = 5986,
  [7399] = 7399,
  [7400] = 7400,
  [7401] = 7401,
  [7402] = 7402,
  [7403] = 7403,
  [7404] = 7404,
  [7405] = 7362,
  [7406] = 7406,
  [7407] = 7367,
  [7408] = 7368,
  [7409] = 7369,
  [7410] = 7370,
  [7411] = 7371,
  [7412] = 7372,
  [7413] = 7373,
  [7414] = 7375,
  [7415] = 7377,
  [7416] = 7378,
  [7417] = 7382,
  [7418] = 7418,
  [7419] = 7419,
  [7420] = 7420,
  [7421] = 7421,
  [7422] = 7422,
  [7423] = 7423,
  [7424] = 7272,
  [7425] = 7425,
  [7426] = 6907,
  [7427] = 7332,
  [7428] = 7428,
  [7429] = 7333,
  [7430] = 7334,
  [7431] = 7335,
  [7432] = 7336,
  [7433] = 6557,
  [7434] = 6174,
  [7435] = 7337,
  [7436] = 7338,
  [7437] = 7306,
  [7438] = 7339,
  [7439] = 7439,
  [7440] = 7440,
  [7441] = 7441,
  [7442] = 7442,
  [7443] = 7443,
  [7444] = 7394,
  [7445] = 7445,
  [7446] = 7397,
  [7447] = 7447,
  [7448] = 7399,
  [7449] = 7400,
  [7450] = 7401,
  [7451] = 7402,
  [7452] = 7403,
  [7453] = 7404,
  [7454] = 7406,
  [7455] = 7418,
  [7456] = 7419,
  [7457] = 7420,
  [7458] = 7421,
  [7459] = 7422,
  [7460] = 7423,
  [7461] = 7445,
  [7462] = 7447,
  [7463] = 7463,
  [7464] = 7464,
  [7465] = 6940,
  [7466] = 6907,
  [7467] = 7463,
  [7468] = 7468,
  [7469] = 7469,
  [7470] = 7464,
  [7471] = 7068,
  [7472] = 7468,
  [7473] = 7473,
  [7474] = 7000,
  [7475] = 7475,
  [7476] = 7476,
  [7477] = 7477,
  [7478] = 7478,
  [7479] = 7289,
  [7480] = 7480,
  [7481] = 7481,
  [7482] = 5986,
  [7483] = 7483,
  [7484] = 7484,
  [7485] = 7485,
  [7486] = 7486,
  [7487] = 7487,
  [7488] = 7488,
  [7489] = 7489,
  [7490] = 7490,
  [7491] = 7491,
  [7492] = 7469,
  [7493] = 7493,
  [7494] = 7494,
  [7495] = 7495,
  [7496] = 7496,
  [7497] = 7497,
  [7498] = 7498,
  [7499] = 7499,
  [7500] = 7500,
  [7501] = 7501,
  [7502] = 7502,
  [7503] = 7503,
  [7504] = 7504,
  [7505] = 7306,
  [7506] = 7506,
  [7507] = 7507,
  [7508] = 7508,
  [7509] = 7509,
  [7510] = 7510,
  [7511] = 7511,
  [7512] = 7512,
  [7513] = 7513,
  [7514] = 7514,
  [7515] = 7515,
  [7516] = 7516,
  [7517] = 7517,
  [7518] = 7473,
  [7519] = 7475,
  [7520] = 7476,
  [7521] = 7477,
  [7522] = 7478,
  [7523] = 7098,
  [7524] = 7321,
  [7525] = 7326,
  [7526] = 7329,
  [7527] = 7480,
  [7528] = 7067,
  [7529] = 7070,
  [7530] = 7481,
  [7531] = 7483,
  [7532] = 7484,
  [7533] = 7485,
  [7534] = 6557,
  [7535] = 7486,
  [7536] = 7487,
  [7537] = 7488,
  [7538] = 7489,
  [7539] = 7490,
  [7540] = 7491,
  [7541] = 6557,
  [7542] = 6174,
  [7543] = 7493,
  [7544] = 7494,
  [7545] = 7306,
  [7546] = 7495,
  [7547] = 7496,
  [7548] = 7497,
  [7549] = 7498,
  [7550] = 7499,
  [7551] = 7500,
  [7552] = 6979,
  [7553] = 7501,
  [7554] = 6990,
  [7555] = 7502,
  [7556] = 7556,
  [7557] = 7503,
  [7558] = 7504,
  [7559] = 7506,
  [7560] = 7282,
  [7561] = 7507,
  [7562] = 7508,
  [7563] = 7509,
  [7564] = 7510,
  [7565] = 7511,
  [7566] = 7512,
  [7567] = 7513,
  [7568] = 7306,
  [7569] = 6861,
  [7570] = 6862,
  [7571] = 6898,
  [7572] = 7514,
  [7573] = 7515,
  [7574] = 7516,
  [7575] = 7517,
  [7576] = 4738,
  [7577] = 4684,
  [7578] = 7032,
  [7579] = 7306,
  [7580] = 7306,
  [7581] = 5986,
  [7582] = 6943,
  [7583] = 6907,
  [7584] = 4622,
  [7585] = 7306,
  [7586] = 5986,
  [7587] = 4573,
  [7588] = 4574,
  [7589] = 4749,
  [7590] = 4458,
  [7591] = 4751,
  [7592] = 7067,
  [7593] = 6943,
  [7594] = 7070,
  [7595] = 6174,
  [7596] = 4755,
  [7597] = 7306,
  [7598] = 6783,
  [7599] = 6752,
  [7600] = 6753,
  [7601] = 6943,
  [7602] = 4608,
  [7603] = 4610,
  [7604] = 4611,
  [7605] = 7306,
  [7606] = 4612,
  [7607] = 4613,
  [7608] = 4614,
  [7609] = 4615,
  [7610] = 4597,
  [7611] = 4617,
  [7612] = 4618,
  [7613] = 4623,
  [7614] = 4626,
  [7615] = 6979,
  [7616] = 6990,
  [7617] = 4631,
  [7618] = 4632,
  [7619] = 4600,
  [7620] = 4634,
  [7621] = 4568,
  [7622] = 4569,
  [7623] = 4570,
  [7624] = 7344,
  [7625] = 4576,
  [7626] = 4582,
  [7627] = 4602,
  [7628] = 4583,
  [7629] = 4584,
  [7630] = 4587,
  [7631] = 4660,
  [7632] = 7306,
  [7633] = 4648,
  [7634] = 7634,
  [7635] = 4666,
  [7636] = 4650,
  [7637] = 7265,
  [7638] = 4651,
  [7639] = 6940,
  [7640] = 6861,
  [7641] = 6862,
  [7642] = 6898,
  [7643] = 4686,
  [7644] = 5986,
  [7645] = 4571,
  [7646] = 4749,
  [7647] = 4458,
  [7648] = 4751,
  [7649] = 4738,
  [7650] = 7306,
  [7651] = 4755,
  [7652] = 7306,
  [7653] = 6943,
  [7654] = 4684,
  [7655] = 4622,
  [7656] = 6673,
  [7657] = 4573,
  [7658] = 4574,
  [7659] = 7098,
  [7660] = 7272,
  [7661] = 7306,
  [7662] = 4738,
  [7663] = 7282,
  [7664] = 7306,
  [7665] = 7306,
  [7666] = 6721,
  [7667] = 4272,
  [7668] = 7306,
  [7669] = 4608,
  [7670] = 4610,
  [7671] = 4611,
  [7672] = 4612,
  [7673] = 4613,
  [7674] = 4614,
  [7675] = 4615,
  [7676] = 7306,
  [7677] = 4597,
  [7678] = 4617,
  [7679] = 4618,
  [7680] = 4623,
  [7681] = 4626,
  [7682] = 4631,
  [7683] = 4632,
  [7684] = 4600,
  [7685] = 4634,
  [7686] = 4568,
  [7687] = 4569,
  [7688] = 4570,
  [7689] = 7306,
  [7690] = 4576,
  [7691] = 4582,
  [7692] = 4602,
  [7693] = 4583,
  [7694] = 4584,
  [7695] = 4587,
  [7696] = 7306,
  [7697] = 4243,
  [7698] = 6869,
  [7699] = 7306,
  [7700] = 6783,
  [7701] = 6752,
  [7702] = 6753,
  [7703] = 7032,
  [7704] = 7306,
  [7705] = 4648,
  [7706] = 4650,
  [7707] = 7306,
  [7708] = 6673,
  [7709] = 4651,
  [7710] = 7425,
  [7711] = 7282,
  [7712] = 7306,
  [7713] = 4571,
  [7714] = 7306,
  [7715] = 6940,
  [7716] = 6721,
  [7717] = 7304,
  [7718] = 7306,
  [7719] = 7306,
  [7720] = 4243,
  [7721] = 7032,
  [7722] = 7306,
  [7723] = 7318,
  [7724] = 7319,
  [7725] = 7320,
  [7726] = 7306,
  [7727] = 7321,
  [7728] = 7268,
  [7729] = 7323,
  [7730] = 7324,
  [7731] = 7326,
  [7732] = 7269,
  [7733] = 7328,
  [7734] = 7329,
  [7735] = 6844,
  [7736] = 7306,
  [7737] = 7331,
  [7738] = 7393,
  [7739] = 4622,
  [7740] = 7306,
  [7741] = 4573,
  [7742] = 4574,
  [7743] = 7306,
  [7744] = 7353,
  [7745] = 4608,
  [7746] = 4610,
  [7747] = 7306,
  [7748] = 4611,
  [7749] = 4458,
  [7750] = 4613,
  [7751] = 4614,
  [7752] = 4615,
  [7753] = 4597,
  [7754] = 4617,
  [7755] = 4618,
  [7756] = 4623,
  [7757] = 4626,
  [7758] = 4631,
  [7759] = 7306,
  [7760] = 4632,
  [7761] = 4600,
  [7762] = 4634,
  [7763] = 4568,
  [7764] = 4569,
  [7765] = 4570,
  [7766] = 4576,
  [7767] = 4582,
  [7768] = 4602,
  [7769] = 4583,
  [7770] = 4584,
  [7771] = 4587,
  [7772] = 7306,
  [7773] = 7362,
  [7774] = 7367,
  [7775] = 7368,
  [7776] = 7369,
  [7777] = 7370,
  [7778] = 7306,
  [7779] = 7371,
  [7780] = 7372,
  [7781] = 7373,
  [7782] = 7375,
  [7783] = 7377,
  [7784] = 7378,
  [7785] = 7382,
  [7786] = 6940,
  [7787] = 4648,
  [7788] = 7306,
  [7789] = 4684,
  [7790] = 4650,
  [7791] = 7344,
  [7792] = 4651,
  [7793] = 7425,
  [7794] = 7394,
  [7795] = 4571,
  [7796] = 7306,
  [7797] = 7397,
  [7798] = 7399,
  [7799] = 7400,
  [7800] = 7401,
  [7801] = 7402,
  [7802] = 7403,
  [7803] = 7404,
  [7804] = 7406,
  [7805] = 7418,
  [7806] = 7419,
  [7807] = 7420,
  [7808] = 7421,
  [7809] = 7422,
  [7810] = 7306,
  [7811] = 7423,
  [7812] = 7445,
  [7813] = 7447,
  [7814] = 4749,
  [7815] = 4751,
  [7816] = 4738,
  [7817] = 7306,
  [7818] = 7463,
  [7819] = 4660,
  [7820] = 4749,
  [7821] = 4458,
  [7822] = 4751,
  [7823] = 4738,
  [7824] = 4755,
  [7825] = 4666,
  [7826] = 7464,
  [7827] = 6869,
  [7828] = 7306,
  [7829] = 4686,
  [7830] = 6174,
  [7831] = 4755,
  [7832] = 7468,
  [7833] = 7469,
  [7834] = 4458,
  [7835] = 7634,
  [7836] = 7265,
  [7837] = 7473,
  [7838] = 7306,
  [7839] = 4622,
  [7840] = 7475,
  [7841] = 7476,
  [7842] = 4573,
  [7843] = 4574,
  [7844] = 7477,
  [7845] = 7306,
  [7846] = 7478,
  [7847] = 7289,
  [7848] = 7480,
  [7849] = 7481,
  [7850] = 7483,
  [7851] = 7306,
  [7852] = 7484,
  [7853] = 7485,
  [7854] = 7486,
  [7855] = 7487,
  [7856] = 7488,
  [7857] = 7489,
  [7858] = 7490,
  [7859] = 4272,
  [7860] = 7491,
  [7861] = 7306,
  [7862] = 4738,
  [7863] = 4608,
  [7864] = 4610,
  [7865] = 4611,
  [7866] = 4612,
  [7867] = 4613,
  [7868] = 4614,
  [7869] = 4615,
  [7870] = 4597,
  [7871] = 4617,
  [7872] = 4618,
  [7873] = 4623,
  [7874] = 4626,
  [7875] = 7306,
  [7876] = 4631,
  [7877] = 4632,
  [7878] = 4600,
  [7879] = 4634,
  [7880] = 4568,
  [7881] = 4569,
  [7882] = 4570,
  [7883] = 4576,
  [7884] = 4582,
  [7885] = 4602,
  [7886] = 4583,
  [7887] = 7306,
  [7888] = 4584,
  [7889] = 4587,
  [7890] = 4660,
  [7891] = 7493,
  [7892] = 7306,
  [7893] = 4666,
  [7894] = 7494,
  [7895] = 7495,
  [7896] = 7496,
  [7897] = 7497,
  [7898] = 7498,
  [7899] = 7499,
  [7900] = 7297,
  [7901] = 7500,
  [7902] = 7501,
  [7903] = 7502,
  [7904] = 7306,
  [7905] = 7503,
  [7906] = 4686,
  [7907] = 7504,
  [7908] = 7506,
  [7909] = 7556,
  [7910] = 6557,
  [7911] = 7507,
  [7912] = 7508,
  [7913] = 7509,
  [7914] = 7306,
  [7915] = 7510,
  [7916] = 7511,
  [7917] = 7512,
  [7918] = 7513,
  [7919] = 4648,
  [7920] = 7514,
  [7921] = 7515,
  [7922] = 7516,
  [7923] = 7517,
  [7924] = 4650,
  [7925] = 7306,
  [7926] = 4651,
  [7927] = 7306,
  [7928] = 4571,
  [7929] = 7272,
  [7930] = 7332,
  [7931] = 7428,
  [7932] = 7333,
  [7933] = 7334,
  [7934] = 7335,
  [7935] = 7336,
  [7936] = 7337,
  [7937] = 7338,
  [7938] = 7339,
  [7939] = 7439,
  [7940] = 7306,
  [7941] = 7440,
  [7942] = 4684,
  [7943] = 7441,
  [7944] = 7442,
  [7945] = 7443,
  [7946] = 4355,
  [7947] = 4340,
  [7948] = 7306,
  [7949] = 4361,
  [7950] = 4362,
  [7951] = 7098,
  [7952] = 7306,
  [7953] = 7306,
  [7954] = 7067,
  [7955] = 7070,
  [7956] = 7306,
  [7957] = 7306,
  [7958] = 4660,
  [7959] = 4666,
  [7960] = 4622,
  [7961] = 7306,
  [7962] = 4573,
  [7963] = 4574,
  [7964] = 4686,
  [7965] = 7306,
  [7966] = 6869,
  [7967] = 4608,
  [7968] = 4610,
  [7969] = 4611,
  [7970] = 7306,
  [7971] = 4612,
  [7972] = 4613,
  [7973] = 4614,
  [7974] = 4615,
  [7975] = 4597,
  [7976] = 4617,
  [7977] = 4618,
  [7978] = 4623,
  [7979] = 4626,
  [7980] = 7306,
  [7981] = 4631,
  [7982] = 4632,
  [7983] = 4600,
  [7984] = 4634,
  [7985] = 4568,
  [7986] = 4569,
  [7987] = 4570,
  [7988] = 4576,
  [7989] = 4582,
  [7990] = 4602,
  [7991] = 4583,
  [7992] = 7306,
  [7993] = 4584,
  [7994] = 4587,
  [7995] = 7634,
  [7996] = 7265,
  [7997] = 4738,
  [7998] = 7068,
  [7999] = 7306,
  [8000] = 7306,
  [8001] = 7000,
  [8002] = 7306,
  [8003] = 4648,
  [8004] = 6940,
  [8005] = 4650,
  [8006] = 7306,
  [8007] = 4651,
  [8008] = 7306,
  [8009] = 4571,
  [8010] = 4660,
  [8011] = 7306,
  [8012] = 4666,
  [8013] = 7306,
  [8014] = 4686,
  [8015] = 4272,
  [8016] = 4660,
  [8017] = 6979,
  [8018] = 4666,
  [8019] = 6990,
  [8020] = 4686,
  [8021] = 7556,
  [8022] = 4243,
  [8023] = 7634,
  [8024] = 7321,
  [8025] = 7326,
  [8026] = 7329,
  [8027] = 7393,
  [8028] = 7634,
  [8029] = 7428,
  [8030] = 7439,
  [8031] = 7440,
  [8032] = 7441,
  [8033] = 7442,
  [8034] = 7443,
  [8035] = 4684,
  [8036] = 7634,
  [8037] = 6869,
  [8038] = 4608,
  [8039] = 4610,
  [8040] = 4611,
  [8041] = 4612,
  [8042] = 4613,
  [8043] = 4614,
  [8044] = 4615,
  [8045] = 4622,
  [8046] = 7321,
  [8047] = 7326,
  [8048] = 7329,
  [8049] = 4597,
  [8050] = 4617,
  [8051] = 4618,
  [8052] = 6869,
  [8053] = 4623,
  [8054] = 4626,
  [8055] = 4573,
  [8056] = 4574,
  [8057] = 4631,
  [8058] = 4632,
  [8059] = 4600,
  [8060] = 4634,
  [8061] = 4568,
  [8062] = 4569,
  [8063] = 4570,
  [8064] = 4576,
  [8065] = 4582,
  [8066] = 4602,
  [8067] = 4583,
  [8068] = 4584,
  [8069] = 4587,
  [8070] = 4648,
  [8071] = 4650,
  [8072] = 4651,
  [8073] = 4571,
  [8074] = 6869,
  [8075] = 6861,
  [8076] = 6862,
  [8077] = 6898,
  [8078] = 4738,
  [8079] = 6907,
  [8080] = 4749,
  [8081] = 4751,
  [8082] = 4755,
  [8083] = 6557,
  [8084] = 6174,
  [8085] = 7265,
  [8086] = 7268,
  [8087] = 7269,
  [8088] = 6844,
  [8089] = 7265,
  [8090] = 7265,
  [8091] = 7268,
  [8092] = 7269,
  [8093] = 6844,
  [8094] = 7268,
  [8095] = 7269,
  [8096] = 6844,
  [8097] = 7272,
  [8098] = 7272,
  [8099] = 7282,
  [8100] = 7032,
  [8101] = 7272,
  [8102] = 7282,
  [8103] = 7032,
  [8104] = 7282,
  [8105] = 7032,
  [8106] = 4612,
  [8107] = 7336,
  [8108] = 7393,
  [8109] = 4597,
  [8110] = 7508,
  [8111] = 4617,
  [8112] = 5986,
  [8113] = 4618,
  [8114] = 4623,
  [8115] = 4626,
  [8116] = 7509,
  [8117] = 7353,
  [8118] = 4631,
  [8119] = 4632,
  [8120] = 4600,
  [8121] = 4634,
  [8122] = 4568,
  [8123] = 4569,
  [8124] = 4570,
  [8125] = 4576,
  [8126] = 4582,
  [8127] = 7068,
  [8128] = 4602,
  [8129] = 4583,
  [8130] = 4584,
  [8131] = 4587,
  [8132] = 7362,
  [8133] = 7510,
  [8134] = 7511,
  [8135] = 7512,
  [8136] = 7367,
  [8137] = 7513,
  [8138] = 4648,
  [8139] = 7368,
  [8140] = 7441,
  [8141] = 7369,
  [8142] = 7370,
  [8143] = 7442,
  [8144] = 7514,
  [8145] = 7371,
  [8146] = 7515,
  [8147] = 7516,
  [8148] = 4650,
  [8149] = 7372,
  [8150] = 7373,
  [8151] = 7375,
  [8152] = 7377,
  [8153] = 7378,
  [8154] = 7382,
  [8155] = 7517,
  [8156] = 7344,
  [8157] = 7332,
  [8158] = 7428,
  [8159] = 7333,
  [8160] = 4651,
  [8161] = 7334,
  [8162] = 7335,
  [8163] = 7336,
  [8164] = 7337,
  [8165] = 7338,
  [8166] = 7339,
  [8167] = 7439,
  [8168] = 7440,
  [8169] = 7441,
  [8170] = 4571,
  [8171] = 7556,
  [8172] = 7442,
  [8173] = 7443,
  [8174] = 7443,
  [8175] = 7489,
  [8176] = 7304,
  [8177] = 7425,
  [8178] = 7490,
  [8179] = 7394,
  [8180] = 7000,
  [8181] = 7070,
  [8182] = 4749,
  [8183] = 4458,
  [8184] = 4751,
  [8185] = 7491,
  [8186] = 7399,
  [8187] = 7400,
  [8188] = 7401,
  [8189] = 7402,
  [8190] = 7403,
  [8191] = 4243,
  [8192] = 7404,
  [8193] = 7406,
  [8194] = 7418,
  [8195] = 7419,
  [8196] = 7420,
  [8197] = 7421,
  [8198] = 7422,
  [8199] = 7423,
  [8200] = 7445,
  [8201] = 7447,
  [8202] = 7477,
  [8203] = 6943,
  [8204] = 7463,
  [8205] = 7464,
  [8206] = 7468,
  [8207] = 7469,
  [8208] = 7473,
  [8209] = 7475,
  [8210] = 7476,
  [8211] = 7477,
  [8212] = 7478,
  [8213] = 7289,
  [8214] = 7480,
  [8215] = 7481,
  [8216] = 7483,
  [8217] = 7484,
  [8218] = 7485,
  [8219] = 7486,
  [8220] = 7487,
  [8221] = 7488,
  [8222] = 7489,
  [8223] = 7490,
  [8224] = 7491,
  [8225] = 7493,
  [8226] = 7494,
  [8227] = 7495,
  [8228] = 7496,
  [8229] = 7497,
  [8230] = 7498,
  [8231] = 7499,
  [8232] = 7500,
  [8233] = 7501,
  [8234] = 7502,
  [8235] = 7503,
  [8236] = 7504,
  [8237] = 7506,
  [8238] = 7507,
  [8239] = 7508,
  [8240] = 7509,
  [8241] = 7510,
  [8242] = 7511,
  [8243] = 7512,
  [8244] = 7513,
  [8245] = 7340,
  [8246] = 7514,
  [8247] = 7515,
  [8248] = 7516,
  [8249] = 7517,
  [8250] = 7344,
  [8251] = 6979,
  [8252] = 6990,
  [8253] = 7321,
  [8254] = 7326,
  [8255] = 7329,
  [8256] = 4272,
  [8257] = 7556,
  [8258] = 6940,
  [8259] = 6861,
  [8260] = 6862,
  [8261] = 6898,
  [8262] = 7478,
  [8263] = 7282,
  [8264] = 6907,
  [8265] = 7318,
  [8266] = 7319,
  [8267] = 7493,
  [8268] = 7320,
  [8269] = 7297,
  [8270] = 6943,
  [8271] = 7032,
  [8272] = 6943,
  [8273] = 7098,
  [8274] = 7067,
  [8275] = 7070,
  [8276] = 7340,
  [8277] = 7289,
  [8278] = 7297,
  [8279] = 7321,
  [8280] = 7268,
  [8281] = 4684,
  [8282] = 6557,
  [8283] = 6979,
  [8284] = 6990,
  [8285] = 7323,
  [8286] = 7272,
  [8287] = 7324,
  [8288] = 6557,
  [8289] = 7326,
  [8290] = 7269,
  [8291] = 7328,
  [8292] = 6861,
  [8293] = 6862,
  [8294] = 6898,
  [8295] = 7329,
  [8296] = 6844,
  [8297] = 7494,
  [8298] = 4738,
  [8299] = 7068,
  [8300] = 4243,
  [8301] = 7480,
  [8302] = 6943,
  [8303] = 6907,
  [8304] = 7331,
  [8305] = 4755,
  [8306] = 7634,
  [8307] = 7265,
  [8308] = 7393,
  [8309] = 7481,
  [8310] = 7098,
  [8311] = 7353,
  [8312] = 7282,
  [8313] = 7495,
  [8314] = 7496,
  [8315] = 7497,
  [8316] = 7483,
  [8317] = 7498,
  [8318] = 8318,
  [8319] = 8319,
  [8320] = 7499,
  [8321] = 6943,
  [8322] = 4660,
  [8323] = 4666,
  [8324] = 7500,
  [8325] = 7484,
  [8326] = 7501,
  [8327] = 7502,
  [8328] = 4686,
  [8329] = 7503,
  [8330] = 6174,
  [8331] = 7344,
  [8332] = 7344,
  [8333] = 7032,
  [8334] = 7297,
  [8335] = 7504,
  [8336] = 7634,
  [8337] = 7265,
  [8338] = 7362,
  [8339] = 7506,
  [8340] = 7485,
  [8341] = 7634,
  [8342] = 7486,
  [8343] = 7265,
  [8344] = 7272,
  [8345] = 6869,
  [8346] = 7487,
  [8347] = 7476,
  [8348] = 7425,
  [8349] = 7332,
  [8350] = 7428,
  [8351] = 7333,
  [8352] = 7507,
  [8353] = 7334,
  [8354] = 7335,
  [8355] = 7336,
  [8356] = 7337,
  [8357] = 7338,
  [8358] = 7339,
  [8359] = 7508,
  [8360] = 7439,
  [8361] = 7440,
  [8362] = 7441,
  [8363] = 7442,
  [8364] = 7443,
  [8365] = 7367,
  [8366] = 7368,
  [8367] = 7369,
  [8368] = 7370,
  [8369] = 7509,
  [8370] = 7510,
  [8371] = 7000,
  [8372] = 4243,
  [8373] = 7511,
  [8374] = 7340,
  [8375] = 7371,
  [8376] = 7372,
  [8377] = 7373,
  [8378] = 7556,
  [8379] = 7375,
  [8380] = 7377,
  [8381] = 7378,
  [8382] = 7382,
  [8383] = 7297,
  [8384] = 7512,
  [8385] = 7513,
  [8386] = 4272,
  [8387] = 7488,
  [8388] = 7514,
  [8389] = 7515,
  [8390] = 7516,
  [8391] = 7297,
  [8392] = 7344,
  [8393] = 7556,
  [8394] = 7394,
  [8395] = 7397,
  [8396] = 7399,
  [8397] = 6557,
  [8398] = 7517,
  [8399] = 7400,
  [8400] = 7401,
  [8401] = 7402,
  [8402] = 7403,
  [8403] = 7404,
  [8404] = 7406,
  [8405] = 7418,
  [8406] = 7419,
  [8407] = 7420,
  [8408] = 7421,
  [8409] = 7422,
  [8410] = 7425,
  [8411] = 7423,
  [8412] = 7445,
  [8413] = 6940,
  [8414] = 7447,
  [8415] = 7332,
  [8416] = 7333,
  [8417] = 7334,
  [8418] = 7335,
  [8419] = 7475,
  [8420] = 7337,
  [8421] = 7338,
  [8422] = 7339,
  [8423] = 6557,
  [8424] = 7332,
  [8425] = 7428,
  [8426] = 7333,
  [8427] = 7463,
  [8428] = 7334,
  [8429] = 7464,
  [8430] = 7335,
  [8431] = 7336,
  [8432] = 7304,
  [8433] = 7468,
  [8434] = 7318,
  [8435] = 7319,
  [8436] = 6869,
  [8437] = 7320,
  [8438] = 7268,
  [8439] = 7323,
  [8440] = 7324,
  [8441] = 7269,
  [8442] = 7328,
  [8443] = 6844,
  [8444] = 7469,
  [8445] = 4738,
  [8446] = 7337,
  [8447] = 7331,
  [8448] = 7338,
  [8449] = 7473,
  [8450] = 7339,
  [8451] = 7439,
  [8452] = 7475,
  [8453] = 7476,
  [8454] = 7393,
  [8455] = 7477,
  [8456] = 7478,
  [8457] = 6907,
  [8458] = 7289,
  [8459] = 7480,
  [8460] = 7353,
  [8461] = 7481,
  [8462] = 7483,
  [8463] = 7484,
  [8464] = 7485,
  [8465] = 4749,
  [8466] = 7362,
  [8467] = 4751,
  [8468] = 7486,
  [8469] = 7487,
  [8470] = 7488,
  [8471] = 7367,
  [8472] = 7368,
  [8473] = 7369,
  [8474] = 4755,
  [8475] = 7370,
  [8476] = 7371,
  [8477] = 7372,
  [8478] = 7373,
  [8479] = 7375,
  [8480] = 7377,
  [8481] = 7304,
  [8482] = 7378,
  [8483] = 7382,
  [8484] = 7489,
  [8485] = 7344,
  [8486] = 7490,
  [8487] = 7491,
  [8488] = 7493,
  [8489] = 7494,
  [8490] = 4458,
  [8491] = 7495,
  [8492] = 7496,
  [8493] = 7497,
  [8494] = 7498,
  [8495] = 7340,
  [8496] = 6940,
  [8497] = 7318,
  [8498] = 7319,
  [8499] = 7320,
  [8500] = 7323,
  [8501] = 7324,
  [8502] = 7328,
  [8503] = 7394,
  [8504] = 7499,
  [8505] = 7500,
  [8506] = 7331,
  [8507] = 7397,
  [8508] = 7501,
  [8509] = 7399,
  [8510] = 7400,
  [8511] = 7353,
  [8512] = 7401,
  [8513] = 6907,
  [8514] = 7402,
  [8515] = 7403,
  [8516] = 7404,
  [8517] = 7406,
  [8518] = 7418,
  [8519] = 7419,
  [8520] = 7420,
  [8521] = 7421,
  [8522] = 7422,
  [8523] = 7423,
  [8524] = 7445,
  [8525] = 7447,
  [8526] = 6940,
  [8527] = 7463,
  [8528] = 7464,
  [8529] = 7468,
  [8530] = 7469,
  [8531] = 7340,
  [8532] = 7473,
  [8533] = 7362,
  [8534] = 7475,
  [8535] = 7476,
  [8536] = 7367,
  [8537] = 7368,
  [8538] = 7369,
  [8539] = 7272,
  [8540] = 7332,
  [8541] = 7428,
  [8542] = 7333,
  [8543] = 7477,
  [8544] = 7334,
  [8545] = 7335,
  [8546] = 7336,
  [8547] = 7337,
  [8548] = 7338,
  [8549] = 7339,
  [8550] = 7439,
  [8551] = 7440,
  [8552] = 7441,
  [8553] = 7442,
  [8554] = 7443,
  [8555] = 7478,
  [8556] = 7289,
  [8557] = 7282,
  [8558] = 7370,
  [8559] = 7480,
  [8560] = 7371,
  [8561] = 7372,
  [8562] = 7373,
  [8563] = 7375,
  [8564] = 7481,
  [8565] = 7377,
  [8566] = 7483,
  [8567] = 7484,
  [8568] = 7485,
  [8569] = 7378,
  [8570] = 7486,
  [8571] = 7382,
  [8572] = 7487,
  [8573] = 7502,
  [8574] = 7488,
  [8575] = 7032,
  [8576] = 7489,
  [8577] = 6907,
  [8578] = 7490,
  [8579] = 7491,
  [8580] = 7503,
  [8581] = 7068,
  [8582] = 7493,
  [8583] = 4660,
  [8584] = 7504,
  [8585] = 4622,
  [8586] = 4666,
  [8587] = 6869,
  [8588] = 6557,
  [8589] = 4686,
  [8590] = 6869,
  [8591] = 7000,
  [8592] = 7506,
  [8593] = 7494,
  [8594] = 7495,
  [8595] = 7394,
  [8596] = 4684,
  [8597] = 7397,
  [8598] = 4738,
  [8599] = 4608,
  [8600] = 4610,
  [8601] = 7332,
  [8602] = 7496,
  [8603] = 7333,
  [8604] = 7334,
  [8605] = 7335,
  [8606] = 7336,
  [8607] = 7337,
  [8608] = 7338,
  [8609] = 7339,
  [8610] = 7497,
  [8611] = 7498,
  [8612] = 7499,
  [8613] = 7500,
  [8614] = 7340,
  [8615] = 4611,
  [8616] = 7501,
  [8617] = 7399,
  [8618] = 7400,
  [8619] = 4612,
  [8620] = 4613,
  [8621] = 4614,
  [8622] = 4615,
  [8623] = 7634,
  [8624] = 4622,
  [8625] = 4597,
  [8626] = 4617,
  [8627] = 4618,
  [8628] = 4623,
  [8629] = 4626,
  [8630] = 4573,
  [8631] = 4574,
  [8632] = 4631,
  [8633] = 4632,
  [8634] = 4600,
  [8635] = 4634,
  [8636] = 4568,
  [8637] = 4569,
  [8638] = 4570,
  [8639] = 7502,
  [8640] = 7401,
  [8641] = 4576,
  [8642] = 4582,
  [8643] = 7321,
  [8644] = 7326,
  [8645] = 7329,
  [8646] = 4602,
  [8647] = 4583,
  [8648] = 4584,
  [8649] = 4587,
  [8650] = 7634,
  [8651] = 7503,
  [8652] = 7393,
  [8653] = 7504,
  [8654] = 4573,
  [8655] = 4574,
  [8656] = 4648,
  [8657] = 7506,
  [8658] = 7507,
  [8659] = 7508,
  [8660] = 7509,
  [8661] = 4650,
  [8662] = 7634,
  [8663] = 7510,
  [8664] = 7511,
  [8665] = 7512,
  [8666] = 7513,
  [8667] = 7321,
  [8668] = 7326,
  [8669] = 7329,
  [8670] = 7514,
  [8671] = 7321,
  [8672] = 7326,
  [8673] = 7329,
  [8674] = 7515,
  [8675] = 6869,
  [8676] = 7516,
  [8677] = 7517,
  [8678] = 7304,
  [8679] = 6869,
  [8680] = 4651,
  [8681] = 6869,
  [8682] = 7297,
  [8683] = 7440,
  [8684] = 7402,
  [8685] = 7507,
  [8686] = 6557,
  [8687] = 6174,
  [8688] = 4571,
  [8689] = 7318,
  [8690] = 7319,
  [8691] = 7403,
  [8692] = 6940,
  [8693] = 5986,
  [8694] = 7404,
  [8695] = 7406,
  [8696] = 7418,
  [8697] = 7419,
  [8698] = 7420,
  [8699] = 7421,
  [8700] = 7422,
  [8701] = 7320,
  [8702] = 7423,
  [8703] = 7445,
  [8704] = 7447,
  [8705] = 7321,
  [8706] = 7268,
  [8707] = 6940,
  [8708] = 7463,
  [8709] = 7323,
  [8710] = 7324,
  [8711] = 7464,
  [8712] = 7326,
  [8713] = 7269,
  [8714] = 7468,
  [8715] = 7428,
  [8716] = 7439,
  [8717] = 7440,
  [8718] = 7441,
  [8719] = 7442,
  [8720] = 7443,
  [8721] = 7469,
  [8722] = 4738,
  [8723] = 7297,
  [8724] = 6943,
  [8725] = 7328,
  [8726] = 7329,
  [8727] = 6844,
  [8728] = 7265,
  [8729] = 7473,
  [8730] = 7393,
  [8731] = 7265,
  [8732] = 7268,
  [8733] = 7269,
  [8734] = 6844,
  [8735] = 7428,
  [8736] = 7439,
  [8737] = 7440,
  [8738] = 7441,
  [8739] = 7442,
  [8740] = 7443,
  [8741] = 7272,
  [8742] = 7268,
  [8743] = 7269,
  [8744] = 6844,
  [8745] = 4608,
  [8746] = 4610,
  [8747] = 7272,
  [8748] = 4611,
  [8749] = 7331,
  [8750] = 7265,
  [8751] = 7282,
  [8752] = 7032,
  [8753] = 7282,
  [8754] = 7032,
  [8755] = 7268,
  [8756] = 7269,
  [8757] = 6844,
  [8758] = 4612,
  [8759] = 4613,
  [8760] = 4614,
  [8761] = 4615,
  [8762] = 7282,
  [8763] = 7032,
  [8764] = 7272,
  [8765] = 7067,
  [8766] = 7282,
  [8767] = 7032,
  [8768] = 7393,
  [8769] = 7397,
  [8770] = 7442,
  [8771] = 7331,
  [8772] = 7373,
  [8773] = 7340,
  [8774] = 7375,
  [8775] = 7377,
  [8776] = 7378,
  [8777] = 7335,
  [8778] = 7382,
  [8779] = 7506,
  [8780] = 7336,
  [8781] = 7367,
  [8782] = 7382,
  [8783] = 7370,
  [8784] = 7556,
  [8785] = 7394,
  [8786] = 7297,
  [8787] = 7507,
  [8788] = 7508,
  [8789] = 7509,
  [8790] = 7397,
  [8791] = 7510,
  [8792] = 7332,
  [8793] = 7511,
  [8794] = 7634,
  [8795] = 7265,
  [8796] = 7032,
  [8797] = 7399,
  [8798] = 7400,
  [8799] = 7401,
  [8800] = 7402,
  [8801] = 7403,
  [8802] = 7404,
  [8803] = 7406,
  [8804] = 7418,
  [8805] = 7419,
  [8806] = 7420,
  [8807] = 7421,
  [8808] = 7422,
  [8809] = 7423,
  [8810] = 7445,
  [8811] = 7447,
  [8812] = 7512,
  [8813] = 7428,
  [8814] = 7513,
  [8815] = 7514,
  [8816] = 7333,
  [8817] = 7463,
  [8818] = 7334,
  [8819] = 7272,
  [8820] = 7464,
  [8821] = 7371,
  [8822] = 7372,
  [8823] = 7468,
  [8824] = 7373,
  [8825] = 7469,
  [8826] = 7344,
  [8827] = 7332,
  [8828] = 7428,
  [8829] = 7333,
  [8830] = 7515,
  [8831] = 7334,
  [8832] = 7335,
  [8833] = 7336,
  [8834] = 7337,
  [8835] = 7338,
  [8836] = 7339,
  [8837] = 7516,
  [8838] = 7439,
  [8839] = 7440,
  [8840] = 7441,
  [8841] = 7517,
  [8842] = 7335,
  [8843] = 7332,
  [8844] = 7442,
  [8845] = 7473,
  [8846] = 7321,
  [8847] = 7443,
  [8848] = 7268,
  [8849] = 7428,
  [8850] = 7475,
  [8851] = 7326,
  [8852] = 7269,
  [8853] = 7476,
  [8854] = 7477,
  [8855] = 7329,
  [8856] = 6844,
  [8857] = 7478,
  [8858] = 7289,
  [8859] = 7311,
  [8860] = 7480,
  [8861] = 7312,
  [8862] = 7481,
  [8863] = 7483,
  [8864] = 7332,
  [8865] = 7393,
  [8866] = 7428,
  [8867] = 7333,
  [8868] = 7484,
  [8869] = 7485,
  [8870] = 7297,
  [8871] = 7486,
  [8872] = 7333,
  [8873] = 7487,
  [8874] = 7488,
  [8875] = 7489,
  [8876] = 7490,
  [8877] = 7491,
  [8878] = 7336,
  [8879] = 7334,
  [8880] = 7297,
  [8881] = 7335,
  [8882] = 7336,
  [8883] = 7282,
  [8884] = 7493,
  [8885] = 7337,
  [8886] = 7338,
  [8887] = 7334,
  [8888] = 7335,
  [8889] = 7336,
  [8890] = 7337,
  [8891] = 7339,
  [8892] = 7338,
  [8893] = 7439,
  [8894] = 7339,
  [8895] = 7494,
  [8896] = 7439,
  [8897] = 7440,
  [8898] = 7495,
  [8899] = 7496,
  [8900] = 7441,
  [8901] = 7442,
  [8902] = 7443,
  [8903] = 7497,
  [8904] = 7032,
  [8905] = 7498,
  [8906] = 7304,
  [8907] = 7499,
  [8908] = 7500,
  [8909] = 7501,
  [8910] = 7502,
  [8911] = 7503,
  [8912] = 7504,
  [8913] = 7506,
  [8914] = 7440,
  [8915] = 7068,
  [8916] = 7441,
  [8917] = 7442,
  [8918] = 7443,
  [8919] = 7394,
  [8920] = 7507,
  [8921] = 7508,
  [8922] = 7509,
  [8923] = 7510,
  [8924] = 7511,
  [8925] = 7512,
  [8926] = 7513,
  [8927] = 7368,
  [8928] = 7337,
  [8929] = 7340,
  [8930] = 7340,
  [8931] = 7514,
  [8932] = 7515,
  [8933] = 7516,
  [8934] = 7517,
  [8935] = 7397,
  [8936] = 8936,
  [8937] = 7338,
  [8938] = 6940,
  [8939] = 7399,
  [8940] = 7339,
  [8941] = 7400,
  [8942] = 7401,
  [8943] = 6943,
  [8944] = 7402,
  [8945] = 7403,
  [8946] = 7404,
  [8947] = 7406,
  [8948] = 7321,
  [8949] = 7297,
  [8950] = 7326,
  [8951] = 7329,
  [8952] = 7369,
  [8953] = 7418,
  [8954] = 6557,
  [8955] = 7419,
  [8956] = 6557,
  [8957] = 7420,
  [8958] = 7421,
  [8959] = 7425,
  [8960] = 7344,
  [8961] = 8318,
  [8962] = 7634,
  [8963] = 7634,
  [8964] = 7321,
  [8965] = 7326,
  [8966] = 7329,
  [8967] = 7393,
  [8968] = 7282,
  [8969] = 7340,
  [8970] = 7634,
  [8971] = 7422,
  [8972] = 7344,
  [8973] = 7423,
  [8974] = 7445,
  [8975] = 7282,
  [8976] = 7447,
  [8977] = 7439,
  [8978] = 7353,
  [8979] = 7463,
  [8980] = 7464,
  [8981] = 7297,
  [8982] = 7265,
  [8983] = 7362,
  [8984] = 7468,
  [8985] = 7440,
  [8986] = 7000,
  [8987] = 7441,
  [8988] = 7469,
  [8989] = 7556,
  [8990] = 7442,
  [8991] = 7443,
  [8992] = 7337,
  [8993] = 7321,
  [8994] = 7326,
  [8995] = 7329,
  [8996] = 7338,
  [8997] = 7032,
  [8998] = 7339,
  [8999] = 7425,
  [9000] = 7439,
  [9001] = 7032,
  [9002] = 7440,
  [9003] = 7282,
  [9004] = 7032,
  [9005] = 7442,
  [9006] = 7473,
  [9007] = 7375,
  [9008] = 7428,
  [9009] = 7439,
  [9010] = 7440,
  [9011] = 7441,
  [9012] = 7372,
  [9013] = 7377,
  [9014] = 7340,
  [9015] = 7332,
  [9016] = 7340,
  [9017] = 7428,
  [9018] = 7393,
  [9019] = 7333,
  [9020] = 7334,
  [9021] = 7335,
  [9022] = 7336,
  [9023] = 7337,
  [9024] = 7338,
  [9025] = 7339,
  [9026] = 7475,
  [9027] = 7476,
  [9028] = 7272,
  [9029] = 7477,
  [9030] = 7332,
  [9031] = 7478,
  [9032] = 7634,
  [9033] = 7265,
  [9034] = 7304,
  [9035] = 7289,
  [9036] = 7480,
  [9037] = 6869,
  [9038] = 7439,
  [9039] = 7481,
  [9040] = 7393,
  [9041] = 7634,
  [9042] = 7344,
  [9043] = 7393,
  [9044] = 7483,
  [9045] = 7484,
  [9046] = 7440,
  [9047] = 6943,
  [9048] = 7332,
  [9049] = 7321,
  [9050] = 7326,
  [9051] = 7329,
  [9052] = 7333,
  [9053] = 7334,
  [9054] = 7318,
  [9055] = 7335,
  [9056] = 7336,
  [9057] = 6869,
  [9058] = 7319,
  [9059] = 6940,
  [9060] = 7337,
  [9061] = 7320,
  [9062] = 7338,
  [9063] = 7339,
  [9064] = 6907,
  [9065] = 7321,
  [9066] = 7268,
  [9067] = 7485,
  [9068] = 7340,
  [9069] = 7344,
  [9070] = 7272,
  [9071] = 7425,
  [9072] = 7486,
  [9073] = 7393,
  [9074] = 7487,
  [9075] = 7488,
  [9076] = 7318,
  [9077] = 7319,
  [9078] = 7489,
  [9079] = 7344,
  [9080] = 7441,
  [9081] = 7282,
  [9082] = 7320,
  [9083] = 7268,
  [9084] = 7323,
  [9085] = 7324,
  [9086] = 6869,
  [9087] = 7269,
  [9088] = 7328,
  [9089] = 6844,
  [9090] = 7490,
  [9091] = 6869,
  [9092] = 7442,
  [9093] = 7443,
  [9094] = 7323,
  [9095] = 8319,
  [9096] = 7428,
  [9097] = 7443,
  [9098] = 7331,
  [9099] = 7333,
  [9100] = 7441,
  [9101] = 7491,
  [9102] = 7393,
  [9103] = 7353,
  [9104] = 7493,
  [9105] = 7494,
  [9106] = 7495,
  [9107] = 7334,
  [9108] = 7496,
  [9109] = 6869,
  [9110] = 7324,
  [9111] = 7497,
  [9112] = 7498,
  [9113] = 7326,
  [9114] = 7499,
  [9115] = 7269,
  [9116] = 7500,
  [9117] = 7362,
  [9118] = 7501,
  [9119] = 7502,
  [9120] = 7378,
  [9121] = 7272,
  [9122] = 7503,
  [9123] = 7282,
  [9124] = 7032,
  [9125] = 7504,
  [9126] = 7367,
  [9127] = 7328,
  [9128] = 7329,
  [9129] = 7368,
  [9130] = 6844,
  [9131] = 7369,
  [9132] = 7370,
  [9133] = 7265,
  [9134] = 7268,
  [9135] = 7269,
  [9136] = 6844,
  [9137] = 7371,
  [9138] = 7443,
  [9139] = 7335,
  [9140] = 7297,
  [9141] = 7393,
  [9142] = 7338,
  [9143] = 7339,
  [9144] = 7439,
  [9145] = 7440,
  [9146] = 7321,
  [9147] = 7441,
  [9148] = 7442,
  [9149] = 7326,
  [9150] = 7340,
  [9151] = 7332,
  [9152] = 7634,
  [9153] = 7333,
  [9154] = 7334,
  [9155] = 7335,
  [9156] = 7336,
  [9157] = 7337,
  [9158] = 7338,
  [9159] = 7339,
  [9160] = 9160,
  [9161] = 6869,
  [9162] = 7338,
  [9163] = 7443,
  [9164] = 7340,
  [9165] = 7634,
  [9166] = 7329,
  [9167] = 7425,
  [9168] = 7339,
  [9169] = 7032,
  [9170] = 7340,
  [9171] = 7265,
  [9172] = 7332,
  [9173] = 6869,
  [9174] = 7428,
  [9175] = 7333,
  [9176] = 7321,
  [9177] = 7326,
  [9178] = 7329,
  [9179] = 7272,
  [9180] = 7332,
  [9181] = 7428,
  [9182] = 7333,
  [9183] = 7282,
  [9184] = 6869,
  [9185] = 7334,
  [9186] = 7337,
  [9187] = 7336,
  [9188] = 7337,
  [9189] = 7338,
  [9190] = 7339,
  [9191] = 7439,
  [9192] = 8936,
  [9193] = 7344,
  [9194] = 7440,
  [9195] = 7340,
  [9196] = 7442,
  [9197] = 7443,
  [9198] = 7393,
  [9199] = 7340,
  [9200] = 7334,
  [9201] = 7335,
  [9202] = 7393,
  [9203] = 7332,
  [9204] = 9204,
  [9205] = 7428,
  [9206] = 7333,
  [9207] = 7393,
  [9208] = 7428,
  [9209] = 7439,
  [9210] = 7440,
  [9211] = 7441,
  [9212] = 7442,
  [9213] = 7443,
  [9214] = 7334,
  [9215] = 7335,
  [9216] = 7336,
  [9217] = 7337,
  [9218] = 7338,
  [9219] = 7339,
  [9220] = 7439,
  [9221] = 7440,
  [9222] = 7441,
  [9223] = 7442,
  [9224] = 7443,
  [9225] = 7332,
  [9226] = 7333,
  [9227] = 7336,
  [9228] = 7334,
  [9229] = 7335,
  [9230] = 7344,
  [9231] = 7428,
  [9232] = 7336,
  [9233] = 7439,
  [9234] = 7440,
  [9235] = 7441,
  [9236] = 7442,
  [9237] = 7337,
  [9238] = 7443,
  [9239] = 7268,
  [9240] = 7269,
  [9241] = 6844,
  [9242] = 7393,
  [9243] = 9243,
  [9244] = 7441,
  [9245] = 7333,
  [9246] = 9246,
  [9247] = 4284,
  [9248] = 7337,
  [9249] = 7332,
  [9250] = 7339,
  [9251] = 7340,
  [9252] = 4294,
  [9253] = 7335,
  [9254] = 7393,
  [9255] = 4302,
  [9256] = 7428,
  [9257] = 7332,
  [9258] = 7428,
  [9259] = 4287,
  [9260] = 4299,
  [9261] = 7333,
  [9262] = 7439,
  [9263] = 7428,
  [9264] = 7439,
  [9265] = 7440,
  [9266] = 7440,
  [9267] = 7441,
  [9268] = 7340,
  [9269] = 7442,
  [9270] = 7443,
  [9271] = 9271,
  [9272] = 7334,
  [9273] = 7336,
  [9274] = 7442,
  [9275] = 7332,
  [9276] = 7333,
  [9277] = 7334,
  [9278] = 7338,
  [9279] = 9279,
  [9280] = 4272,
  [9281] = 7335,
  [9282] = 7336,
  [9283] = 7443,
  [9284] = 7336,
  [9285] = 7337,
  [9286] = 7338,
  [9287] = 4282,
  [9288] = 7393,
  [9289] = 7339,
  [9290] = 7439,
  [9291] = 7337,
  [9292] = 7338,
  [9293] = 7339,
  [9294] = 7441,
  [9295] = 7442,
  [9296] = 4279,
  [9297] = 9160,
  [9298] = 7340,
  [9299] = 7334,
  [9300] = 7335,
  [9301] = 4243,
  [9302] = 7440,
  [9303] = 4281,
  [9304] = 7443,
  [9305] = 7393,
  [9306] = 7441,
  [9307] = 4377,
  [9308] = 4375,
  [9309] = 4281,
  [9310] = 4252,
  [9311] = 4376,
  [9312] = 4284,
  [9313] = 4299,
  [9314] = 4302,
  [9315] = 4287,
  [9316] = 4294,
  [9317] = 4380,
  [9318] = 9318,
  [9319] = 4272,
  [9320] = 4351,
  [9321] = 4458,
  [9322] = 4355,
  [9323] = 4340,
  [9324] = 4361,
  [9325] = 4362,
  [9326] = 4282,
  [9327] = 4279,
  [9328] = 4369,
  [9329] = 4252,
  [9330] = 4252,
  [9331] = 4352,
  [9332] = 4354,
  [9333] = 4358,
  [9334] = 4353,
  [9335] = 4252,
  [9336] = 4373,
  [9337] = 4374,
  [9338] = 4632,
  [9339] = 4623,
  [9340] = 4749,
  [9341] = 4458,
  [9342] = 4751,
  [9343] = 4738,
  [9344] = 5213,
  [9345] = 4355,
  [9346] = 4340,
  [9347] = 4388,
  [9348] = 4674,
  [9349] = 4755,
  [9350] = 4381,
  [9351] = 4604,
  [9352] = 4660,
  [9353] = 4361,
  [9354] = 4571,
  [9355] = 4362,
  [9356] = 4720,
  [9357] = 4352,
  [9358] = 4354,
  [9359] = 4666,
  [9360] = 4376,
  [9361] = 4573,
  [9362] = 4626,
  [9363] = 4574,
  [9364] = 4252,
  [9365] = 4692,
  [9366] = 4695,
  [9367] = 4697,
  [9368] = 4700,
  [9369] = 4252,
  [9370] = 4351,
  [9371] = 4721,
  [9372] = 4686,
  [9373] = 4377,
  [9374] = 4353,
  [9375] = 4567,
  [9376] = 4575,
  [9377] = 4597,
  [9378] = 4586,
  [9379] = 4631,
  [9380] = 4252,
  [9381] = 4380,
  [9382] = 4379,
  [9383] = 4634,
  [9384] = 4568,
  [9385] = 4569,
  [9386] = 4383,
  [9387] = 4570,
  [9388] = 4392,
  [9389] = 4622,
  [9390] = 4358,
  [9391] = 4576,
  [9392] = 4608,
  [9393] = 4582,
  [9394] = 4610,
  [9395] = 4602,
  [9396] = 4583,
  [9397] = 4584,
  [9398] = 4587,
  [9399] = 4611,
  [9400] = 4648,
  [9401] = 4684,
  [9402] = 4369,
  [9403] = 4373,
  [9404] = 4617,
  [9405] = 4374,
  [9406] = 4652,
  [9407] = 4650,
  [9408] = 4651,
  [9409] = 4252,
  [9410] = 4603,
  [9411] = 4375,
  [9412] = 4612,
  [9413] = 4613,
  [9414] = 4614,
  [9415] = 4615,
  [9416] = 4618,
  [9417] = 4385,
  [9418] = 4378,
  [9419] = 4600,
  [9420] = 4610,
  [9421] = 4575,
  [9422] = 4567,
  [9423] = 4738,
  [9424] = 4603,
  [9425] = 4586,
  [9426] = 4604,
  [9427] = 4576,
  [9428] = 4608,
  [9429] = 4587,
  [9430] = 4648,
  [9431] = 4611,
  [9432] = 4755,
  [9433] = 4700,
  [9434] = 4584,
  [9435] = 4582,
  [9436] = 4602,
  [9437] = 4252,
  [9438] = 4573,
  [9439] = 4597,
  [9440] = 4574,
  [9441] = 4617,
  [9442] = 4692,
  [9443] = 4651,
  [9444] = 4618,
  [9445] = 4623,
  [9446] = 4626,
  [9447] = 4583,
  [9448] = 4686,
  [9449] = 9449,
  [9450] = 4631,
  [9451] = 4252,
  [9452] = 4571,
  [9453] = 4632,
  [9454] = 4695,
  [9455] = 4720,
  [9456] = 4697,
  [9457] = 4600,
  [9458] = 4652,
  [9459] = 4612,
  [9460] = 4613,
  [9461] = 4634,
  [9462] = 4751,
  [9463] = 4622,
  [9464] = 4650,
  [9465] = 4660,
  [9466] = 4721,
  [9467] = 4252,
  [9468] = 4614,
  [9469] = 4615,
  [9470] = 4684,
  [9471] = 4568,
  [9472] = 4749,
  [9473] = 4674,
  [9474] = 4569,
  [9475] = 4570,
  [9476] = 4666,
  [9477] = 9477,
  [9478] = 9477,
  [9479] = 9477,
  [9480] = 9477,
  [9481] = 9477,
  [9482] = 9477,
  [9483] = 9477,
  [9484] = 9477,
  [9485] = 9477,
  [9486] = 9477,
  [9487] = 9477,
  [9488] = 9477,
  [9489] = 9477,
  [9490] = 9477,
  [9491] = 9477,
  [9492] = 9477,
  [9493] = 9477,
  [9494] = 9477,
  [9495] = 9477,
  [9496] = 9477,
  [9497] = 9477,
  [9498] = 9477,
  [9499] = 9477,
  [9500] = 9477,
  [9501] = 9477,
  [9502] = 9477,
  [9503] = 9477,
  [9504] = 9477,
  [9505] = 9477,
  [9506] = 9477,
  [9507] = 9477,
  [9508] = 9477,
  [9509] = 9477,
  [9510] = 9477,
  [9511] = 9477,
  [9512] = 9477,
  [9513] = 9477,
  [9514] = 9477,
  [9515] = 9477,
  [9516] = 4282,
  [9517] = 9477,
  [9518] = 9477,
  [9519] = 9477,
  [9520] = 9477,
  [9521] = 4272,
  [9522] = 9477,
  [9523] = 9477,
  [9524] = 9477,
  [9525] = 9477,
  [9526] = 9477,
  [9527] = 9477,
  [9528] = 9477,
  [9529] = 9477,
  [9530] = 9477,
  [9531] = 9477,
  [9532] = 9477,
  [9533] = 9477,
  [9534] = 9477,
  [9535] = 9477,
  [9536] = 9477,
  [9537] = 9477,
  [9538] = 9477,
  [9539] = 9477,
  [9540] = 9477,
  [9541] = 9477,
  [9542] = 9477,
  [9543] = 9477,
  [9544] = 9477,
  [9545] = 9477,
  [9546] = 9477,
  [9547] = 9477,
  [9548] = 9477,
  [9549] = 4458,
  [9550] = 9550,
  [9551] = 4355,
  [9552] = 4361,
  [9553] = 4362,
  [9554] = 4340,
  [9555] = 4755,
  [9556] = 4749,
  [9557] = 4751,
  [9558] = 4617,
  [9559] = 4623,
  [9560] = 4622,
  [9561] = 4626,
  [9562] = 4651,
  [9563] = 4684,
  [9564] = 4272,
  [9565] = 9565,
  [9566] = 4600,
  [9567] = 4611,
  [9568] = 4648,
  [9569] = 4576,
  [9570] = 4582,
  [9571] = 4272,
  [9572] = 4634,
  [9573] = 4573,
  [9574] = 4574,
  [9575] = 4252,
  [9576] = 4602,
  [9577] = 4568,
  [9578] = 4612,
  [9579] = 4613,
  [9580] = 4583,
  [9581] = 4569,
  [9582] = 4584,
  [9583] = 4570,
  [9584] = 4614,
  [9585] = 4615,
  [9586] = 4650,
  [9587] = 9587,
  [9588] = 4618,
  [9589] = 4587,
  [9590] = 4597,
  [9591] = 4631,
  [9592] = 4571,
  [9593] = 4632,
  [9594] = 4282,
  [9595] = 4608,
  [9596] = 4610,
  [9597] = 4648,
  [9598] = 4362,
  [9599] = 4361,
  [9600] = 4352,
  [9601] = 4650,
  [9602] = 4458,
  [9603] = 4354,
  [9604] = 4651,
  [9605] = 4373,
  [9606] = 4380,
  [9607] = 4376,
  [9608] = 4377,
  [9609] = 9609,
  [9610] = 4355,
  [9611] = 4358,
  [9612] = 4374,
  [9613] = 4375,
  [9614] = 9614,
  [9615] = 4340,
  [9616] = 4369,
  [9617] = 4571,
  [9618] = 4617,
  [9619] = 4602,
  [9620] = 4608,
  [9621] = 4626,
  [9622] = 4570,
  [9623] = 9623,
  [9624] = 4613,
  [9625] = 4574,
  [9626] = 4272,
  [9627] = 4611,
  [9628] = 4600,
  [9629] = 4751,
  [9630] = 4648,
  [9631] = 4587,
  [9632] = 9632,
  [9633] = 4568,
  [9634] = 4749,
  [9635] = 4610,
  [9636] = 4614,
  [9637] = 4569,
  [9638] = 4597,
  [9639] = 4622,
  [9640] = 4615,
  [9641] = 4650,
  [9642] = 4631,
  [9643] = 4583,
  [9644] = 4632,
  [9645] = 4571,
  [9646] = 4755,
  [9647] = 4582,
  [9648] = 4584,
  [9649] = 4618,
  [9650] = 4612,
  [9651] = 4634,
  [9652] = 4573,
  [9653] = 4684,
  [9654] = 4651,
  [9655] = 4623,
  [9656] = 4576,
  [9657] = 9657,
  [9658] = 9658,
  [9659] = 9659,
  [9660] = 4261,
  [9661] = 4261,
  [9662] = 4261,
  [9663] = 4261,
  [9664] = 4261,
  [9665] = 4261,
  [9666] = 4261,
  [9667] = 4261,
  [9668] = 9668,
  [9669] = 4261,
  [9670] = 9668,
  [9671] = 4261,
  [9672] = 9668,
  [9673] = 9673,
  [9674] = 9668,
  [9675] = 9668,
  [9676] = 9673,
  [9677] = 4261,
  [9678] = 9673,
  [9679] = 9668,
  [9680] = 9673,
  [9681] = 9668,
  [9682] = 9673,
  [9683] = 9668,
  [9684] = 9673,
  [9685] = 9668,
  [9686] = 9673,
  [9687] = 9668,
  [9688] = 9673,
  [9689] = 9673,
  [9690] = 9673,
  [9691] = 9668,
  [9692] = 9673,
  [9693] = 9668,
  [9694] = 9673,
  [9695] = 9668,
  [9696] = 9673,
  [9697] = 9697,
  [9698] = 9697,
  [9699] = 9697,
  [9700] = 9697,
  [9701] = 9697,
  [9702] = 9697,
  [9703] = 9697,
  [9704] = 9697,
  [9705] = 9697,
  [9706] = 9697,
  [9707] = 9697,
  [9708] = 9697,
  [9709] = 9697,
  [9710] = 9697,
  [9711] = 9697,
  [9712] = 9697,
  [9713] = 9697,
  [9714] = 9697,
  [9715] = 9697,
  [9716] = 9697,
  [9717] = 9697,
  [9718] = 9697,
  [9719] = 9697,
  [9720] = 9697,
  [9721] = 9697,
  [9722] = 9697,
  [9723] = 9697,
  [9724] = 9697,
  [9725] = 9697,
  [9726] = 9697,
  [9727] = 9697,
  [9728] = 9697,
  [9729] = 9697,
  [9730] = 9697,
  [9731] = 9697,
  [9732] = 9697,
  [9733] = 9697,
  [9734] = 9697,
  [9735] = 9697,
  [9736] = 9697,
  [9737] = 9697,
  [9738] = 9697,
  [9739] = 9697,
  [9740] = 9697,
  [9741] = 9697,
  [9742] = 9697,
  [9743] = 9697,
  [9744] = 9697,
  [9745] = 9697,
  [9746] = 9697,
  [9747] = 9697,
  [9748] = 9697,
  [9749] = 9697,
  [9750] = 9697,
  [9751] = 9697,
  [9752] = 9697,
  [9753] = 9697,
  [9754] = 9697,
  [9755] = 9697,
  [9756] = 9697,
  [9757] = 9697,
  [9758] = 9697,
  [9759] = 9697,
  [9760] = 9697,
  [9761] = 9697,
  [9762] = 9697,
  [9763] = 9763,
  [9764] = 9764,
  [9765] = 9764,
  [9766] = 9763,
  [9767] = 9764,
  [9768] = 9763,
  [9769] = 9763,
  [9770] = 9764,
  [9771] = 9764,
  [9772] = 9764,
  [9773] = 9773,
  [9774] = 9763,
  [9775] = 9763,
  [9776] = 9764,
  [9777] = 9777,
  [9778] = 9764,
  [9779] = 9763,
  [9780] = 9763,
  [9781] = 9763,
  [9782] = 9764,
  [9783] = 9764,
  [9784] = 9763,
  [9785] = 9763,
  [9786] = 9777,
  [9787] = 9764,
  [9788] = 9773,
  [9789] = 9763,
  [9790] = 9764,
  [9791] = 9764,
  [9792] = 9764,
  [9793] = 9773,
  [9794] = 9763,
  [9795] = 9763,
  [9796] = 9764,
  [9797] = 9764,
  [9798] = 9763,
  [9799] = 9763,
  [9800] = 9764,
  [9801] = 9763,
  [9802] = 9763,
  [9803] = 9764,
  [9804] = 9763,
  [9805] = 9764,
  [9806] = 9763,
  [9807] = 9764,
  [9808] = 9763,
  [9809] = 9764,
  [9810] = 4652,
  [9811] = 4652,
  [9812] = 4652,
  [9813] = 4652,
  [9814] = 4652,
  [9815] = 4652,
  [9816] = 4652,
  [9817] = 4652,
  [9818] = 4652,
  [9819] = 4272,
  [9820] = 4272,
  [9821] = 4294,
  [9822] = 4302,
  [9823] = 4284,
  [9824] = 4287,
  [9825] = 4383,
  [9826] = 4294,
  [9827] = 4353,
  [9828] = 4352,
  [9829] = 4376,
  [9830] = 4373,
  [9831] = 4379,
  [9832] = 4302,
  [9833] = 4369,
  [9834] = 4351,
  [9835] = 4377,
  [9836] = 4380,
  [9837] = 4381,
  [9838] = 4374,
  [9839] = 4392,
  [9840] = 4385,
  [9841] = 4458,
  [9842] = 4378,
  [9843] = 4375,
  [9844] = 4287,
  [9845] = 4458,
  [9846] = 4388,
  [9847] = 4458,
  [9848] = 4272,
  [9849] = 4354,
  [9850] = 4358,
  [9851] = 4284,
  [9852] = 9852,
  [9853] = 9852,
  [9854] = 9852,
  [9855] = 9852,
  [9856] = 9852,
  [9857] = 9852,
  [9858] = 9852,
  [9859] = 9852,
  [9860] = 9852,
  [9861] = 9852,
  [9862] = 9852,
  [9863] = 9852,
  [9864] = 4648,
  [9865] = 4380,
  [9866] = 9852,
  [9867] = 9852,
  [9868] = 9852,
  [9869] = 4458,
  [9870] = 9852,
  [9871] = 4351,
  [9872] = 9852,
  [9873] = 9852,
  [9874] = 4738,
  [9875] = 9852,
  [9876] = 4666,
  [9877] = 9852,
  [9878] = 4617,
  [9879] = 9852,
  [9880] = 4597,
  [9881] = 4569,
  [9882] = 9852,
  [9883] = 4567,
  [9884] = 9852,
  [9885] = 9852,
  [9886] = 9852,
  [9887] = 4571,
  [9888] = 9852,
  [9889] = 4458,
  [9890] = 4623,
  [9891] = 9852,
  [9892] = 4458,
  [9893] = 9852,
  [9894] = 9852,
  [9895] = 4602,
  [9896] = 9852,
  [9897] = 9852,
  [9898] = 9852,
  [9899] = 9852,
  [9900] = 9852,
  [9901] = 4352,
  [9902] = 4674,
  [9903] = 9852,
  [9904] = 9852,
  [9905] = 9852,
  [9906] = 9852,
  [9907] = 9852,
  [9908] = 4749,
  [9909] = 9852,
  [9910] = 9852,
  [9911] = 9852,
  [9912] = 9852,
  [9913] = 9852,
  [9914] = 4576,
  [9915] = 9852,
  [9916] = 9852,
  [9917] = 9852,
  [9918] = 9852,
  [9919] = 4751,
  [9920] = 9852,
  [9921] = 4618,
  [9922] = 9852,
  [9923] = 9852,
  [9924] = 9852,
  [9925] = 9852,
  [9926] = 9852,
  [9927] = 4583,
  [9928] = 9852,
  [9929] = 9852,
  [9930] = 4614,
  [9931] = 9852,
  [9932] = 9852,
  [9933] = 9852,
  [9934] = 4584,
  [9935] = 9852,
  [9936] = 9852,
  [9937] = 9852,
  [9938] = 4294,
  [9939] = 4684,
  [9940] = 9852,
  [9941] = 9852,
  [9942] = 9852,
  [9943] = 9852,
  [9944] = 4272,
  [9945] = 9852,
  [9946] = 9852,
  [9947] = 9852,
  [9948] = 4612,
  [9949] = 4272,
  [9950] = 9852,
  [9951] = 9852,
  [9952] = 4377,
  [9953] = 9852,
  [9954] = 4610,
  [9955] = 9852,
  [9956] = 4573,
  [9957] = 9852,
  [9958] = 4692,
  [9959] = 9852,
  [9960] = 9852,
  [9961] = 4570,
  [9962] = 4749,
  [9963] = 9852,
  [9964] = 4603,
  [9965] = 9852,
  [9966] = 4751,
  [9967] = 4626,
  [9968] = 4458,
  [9969] = 9852,
  [9970] = 9852,
  [9971] = 4568,
  [9972] = 4284,
  [9973] = 9852,
  [9974] = 4358,
  [9975] = 4600,
  [9976] = 9852,
  [9977] = 9852,
  [9978] = 4302,
  [9979] = 4751,
  [9980] = 4721,
  [9981] = 4611,
  [9982] = 4632,
  [9983] = 9852,
  [9984] = 9852,
  [9985] = 4695,
  [9986] = 4608,
  [9987] = 9852,
  [9988] = 9852,
  [9989] = 4586,
  [9990] = 4650,
  [9991] = 9852,
  [9992] = 4651,
  [9993] = 4697,
  [9994] = 4622,
  [9995] = 9852,
  [9996] = 4749,
  [9997] = 9852,
  [9998] = 4613,
  [9999] = 9852,
  [10000] = 4615,
  [10001] = 9852,
  [10002] = 9852,
  [10003] = 4458,
  [10004] = 4373,
  [10005] = 4374,
  [10006] = 4700,
  [10007] = 4582,
  [10008] = 4720,
  [10009] = 4375,
  [10010] = 4575,
  [10011] = 9852,
  [10012] = 9852,
  [10013] = 4587,
  [10014] = 4755,
  [10015] = 4369,
  [10016] = 4686,
  [10017] = 9852,
  [10018] = 4353,
  [10019] = 9852,
  [10020] = 9852,
  [10021] = 4604,
  [10022] = 4634,
  [10023] = 4631,
  [10024] = 9852,
  [10025] = 9852,
  [10026] = 9852,
  [10027] = 9852,
  [10028] = 4755,
  [10029] = 4574,
  [10030] = 9852,
  [10031] = 9852,
  [10032] = 4287,
  [10033] = 9852,
  [10034] = 4755,
  [10035] = 9852,
  [10036] = 4660,
  [10037] = 4376,
  [10038] = 4354,
  [10039] = 4615,
  [10040] = 4458,
  [10041] = 4652,
  [10042] = 4755,
  [10043] = 4749,
  [10044] = 4751,
  [10045] = 4674,
  [10046] = 4660,
  [10047] = 4755,
  [10048] = 4369,
  [10049] = 4666,
  [10050] = 4692,
  [10051] = 4695,
  [10052] = 4697,
  [10053] = 4700,
  [10054] = 4684,
  [10055] = 4720,
  [10056] = 4721,
  [10057] = 4686,
  [10058] = 4351,
  [10059] = 4567,
  [10060] = 4597,
  [10061] = 4575,
  [10062] = 4586,
  [10063] = 4352,
  [10064] = 4354,
  [10065] = 4358,
  [10066] = 4617,
  [10067] = 4618,
  [10068] = 4353,
  [10069] = 4749,
  [10070] = 4623,
  [10071] = 4751,
  [10072] = 4626,
  [10073] = 4373,
  [10074] = 4374,
  [10075] = 4375,
  [10076] = 4651,
  [10077] = 4376,
  [10078] = 4377,
  [10079] = 4272,
  [10080] = 4603,
  [10081] = 4604,
  [10082] = 4755,
  [10083] = 4755,
  [10084] = 4631,
  [10085] = 4587,
  [10086] = 4632,
  [10087] = 4622,
  [10088] = 4612,
  [10089] = 4458,
  [10090] = 4573,
  [10091] = 4574,
  [10092] = 4600,
  [10093] = 4634,
  [10094] = 4613,
  [10095] = 4568,
  [10096] = 4569,
  [10097] = 4570,
  [10098] = 4571,
  [10099] = 4614,
  [10100] = 4458,
  [10101] = 4749,
  [10102] = 4751,
  [10103] = 4738,
  [10104] = 4755,
  [10105] = 4650,
  [10106] = 4576,
  [10107] = 4582,
  [10108] = 4458,
  [10109] = 4602,
  [10110] = 4749,
  [10111] = 4749,
  [10112] = 4751,
  [10113] = 4583,
  [10114] = 4584,
  [10115] = 4751,
  [10116] = 4608,
  [10117] = 4610,
  [10118] = 4611,
  [10119] = 4648,
  [10120] = 4380,
  [10121] = 4749,
  [10122] = 4582,
  [10123] = 4618,
  [10124] = 4626,
  [10125] = 4587,
  [10126] = 4573,
  [10127] = 4574,
  [10128] = 4684,
  [10129] = 4612,
  [10130] = 4613,
  [10131] = 4666,
  [10132] = 4651,
  [10133] = 4751,
  [10134] = 4749,
  [10135] = 4634,
  [10136] = 4751,
  [10137] = 4720,
  [10138] = 4597,
  [10139] = 4611,
  [10140] = 4600,
  [10141] = 4568,
  [10142] = 4622,
  [10143] = 4569,
  [10144] = 4570,
  [10145] = 4571,
  [10146] = 4614,
  [10147] = 4615,
  [10148] = 4650,
  [10149] = 4648,
  [10150] = 4751,
  [10151] = 4755,
  [10152] = 4721,
  [10153] = 4692,
  [10154] = 4583,
  [10155] = 4695,
  [10156] = 4697,
  [10157] = 4631,
  [10158] = 4272,
  [10159] = 4567,
  [10160] = 4700,
  [10161] = 4674,
  [10162] = 4632,
  [10163] = 4738,
  [10164] = 4749,
  [10165] = 4602,
  [10166] = 4751,
  [10167] = 4586,
  [10168] = 4603,
  [10169] = 4755,
  [10170] = 4755,
  [10171] = 4686,
  [10172] = 4575,
  [10173] = 4623,
  [10174] = 4749,
  [10175] = 4604,
  [10176] = 4652,
  [10177] = 4576,
  [10178] = 4608,
  [10179] = 4755,
  [10180] = 4610,
  [10181] = 4660,
  [10182] = 4617,
  [10183] = 4584,
  [10184] = 4272,
  [10185] = 4272,
  [10186] = 4270,
  [10187] = 4458,
  [10188] = 4294,
  [10189] = 4287,
  [10190] = 4272,
  [10191] = 4270,
  [10192] = 4284,
  [10193] = 4270,
  [10194] = 4272,
  [10195] = 4270,
  [10196] = 4270,
  [10197] = 4272,
  [10198] = 4270,
  [10199] = 4302,
  [10200] = 4270,
  [10201] = 4270,
  [10202] = 4597,
  [10203] = 4392,
  [10204] = 4381,
  [10205] = 4376,
  [10206] = 4281,
  [10207] = 4272,
  [10208] = 4617,
  [10209] = 4618,
  [10210] = 4623,
  [10211] = 4626,
  [10212] = 4651,
  [10213] = 4738,
  [10214] = 4377,
  [10215] = 4622,
  [10216] = 4270,
  [10217] = 4631,
  [10218] = 4632,
  [10219] = 4369,
  [10220] = 4600,
  [10221] = 4634,
  [10222] = 4568,
  [10223] = 4569,
  [10224] = 4660,
  [10225] = 4570,
  [10226] = 4571,
  [10227] = 4362,
  [10228] = 4576,
  [10229] = 4582,
  [10230] = 4602,
  [10231] = 4583,
  [10232] = 4584,
  [10233] = 4587,
  [10234] = 4299,
  [10235] = 4302,
  [10236] = 4666,
  [10237] = 4355,
  [10238] = 4755,
  [10239] = 4281,
  [10240] = 4340,
  [10241] = 4573,
  [10242] = 4574,
  [10243] = 4355,
  [10244] = 4351,
  [10245] = 4270,
  [10246] = 4361,
  [10247] = 4355,
  [10248] = 4362,
  [10249] = 4374,
  [10250] = 4281,
  [10251] = 4287,
  [10252] = 4375,
  [10253] = 4458,
  [10254] = 4282,
  [10255] = 4361,
  [10256] = 4362,
  [10257] = 4270,
  [10258] = 4302,
  [10259] = 4355,
  [10260] = 4749,
  [10261] = 4458,
  [10262] = 4373,
  [10263] = 4686,
  [10264] = 4340,
  [10265] = 4361,
  [10266] = 4608,
  [10267] = 4270,
  [10268] = 4353,
  [10269] = 4610,
  [10270] = 4287,
  [10271] = 4361,
  [10272] = 4362,
  [10273] = 4352,
  [10274] = 4354,
  [10275] = 4380,
  [10276] = 4611,
  [10277] = 4294,
  [10278] = 4358,
  [10279] = 4299,
  [10280] = 4378,
  [10281] = 4282,
  [10282] = 4379,
  [10283] = 4648,
  [10284] = 4340,
  [10285] = 4294,
  [10286] = 4284,
  [10287] = 4272,
  [10288] = 4751,
  [10289] = 4281,
  [10290] = 4282,
  [10291] = 5986,
  [10292] = 4299,
  [10293] = 4272,
  [10294] = 4281,
  [10295] = 4282,
  [10296] = 4340,
  [10297] = 4388,
  [10298] = 4270,
  [10299] = 4270,
  [10300] = 4272,
  [10301] = 4684,
  [10302] = 4612,
  [10303] = 4284,
  [10304] = 4299,
  [10305] = 4302,
  [10306] = 4613,
  [10307] = 4383,
  [10308] = 4362,
  [10309] = 4614,
  [10310] = 4615,
  [10311] = 4299,
  [10312] = 4650,
  [10313] = 4361,
  [10314] = 4355,
  [10315] = 4287,
  [10316] = 4340,
  [10317] = 4294,
  [10318] = 4284,
  [10319] = 4282,
  [10320] = 4385,
  [10321] = 4575,
  [10322] = 4373,
  [10323] = 4374,
  [10324] = 4375,
  [10325] = 4340,
  [10326] = 4373,
  [10327] = 4374,
  [10328] = 4375,
  [10329] = 4361,
  [10330] = 4376,
  [10331] = 4377,
  [10332] = 4362,
  [10333] = 4381,
  [10334] = 4279,
  [10335] = 4380,
  [10336] = 4294,
  [10337] = 4376,
  [10338] = 4377,
  [10339] = 4351,
  [10340] = 4755,
  [10341] = 4287,
  [10342] = 4355,
  [10343] = 4340,
  [10344] = 4380,
  [10345] = 4361,
  [10346] = 4362,
  [10347] = 4618,
  [10348] = 4383,
  [10349] = 4281,
  [10350] = 4270,
  [10351] = 4294,
  [10352] = 7098,
  [10353] = 4270,
  [10354] = 4385,
  [10355] = 4353,
  [10356] = 10356,
  [10357] = 4458,
  [10358] = 4623,
  [10359] = 4626,
  [10360] = 4388,
  [10361] = 4392,
  [10362] = 4458,
  [10363] = 4355,
  [10364] = 4651,
  [10365] = 4340,
  [10366] = 4361,
  [10367] = 4362,
  [10368] = 4272,
  [10369] = 4749,
  [10370] = 4608,
  [10371] = 4720,
  [10372] = 4610,
  [10373] = 4721,
  [10374] = 4631,
  [10375] = 4632,
  [10376] = 4686,
  [10377] = 4385,
  [10378] = 4751,
  [10379] = 4674,
  [10380] = 4738,
  [10381] = 4612,
  [10382] = 4684,
  [10383] = 4272,
  [10384] = 4279,
  [10385] = 4660,
  [10386] = 4270,
  [10387] = 6940,
  [10388] = 4613,
  [10389] = 4666,
  [10390] = 4611,
  [10391] = 4369,
  [10392] = 4388,
  [10393] = 4369,
  [10394] = 6557,
  [10395] = 4600,
  [10396] = 4648,
  [10397] = 4284,
  [10398] = 4634,
  [10399] = 4568,
  [10400] = 4569,
  [10401] = 4284,
  [10402] = 4392,
  [10403] = 4570,
  [10404] = 4622,
  [10405] = 4571,
  [10406] = 4282,
  [10407] = 4567,
  [10408] = 4281,
  [10409] = 4576,
  [10410] = 4270,
  [10411] = 10356,
  [10412] = 4582,
  [10413] = 10413,
  [10414] = 4270,
  [10415] = 4270,
  [10416] = 4302,
  [10417] = 4284,
  [10418] = 4355,
  [10419] = 4299,
  [10420] = 4302,
  [10421] = 4355,
  [10422] = 4340,
  [10423] = 4299,
  [10424] = 4340,
  [10425] = 4287,
  [10426] = 4361,
  [10427] = 4362,
  [10428] = 4294,
  [10429] = 4299,
  [10430] = 4281,
  [10431] = 4602,
  [10432] = 4583,
  [10433] = 4584,
  [10434] = 4586,
  [10435] = 4282,
  [10436] = 4355,
  [10437] = 4287,
  [10438] = 4352,
  [10439] = 4354,
  [10440] = 4358,
  [10441] = 4351,
  [10442] = 4587,
  [10443] = 4299,
  [10444] = 4302,
  [10445] = 4353,
  [10446] = 4361,
  [10447] = 4362,
  [10448] = 4378,
  [10449] = 4379,
  [10450] = 4270,
  [10451] = 6907,
  [10452] = 4373,
  [10453] = 4281,
  [10454] = 10356,
  [10455] = 4603,
  [10456] = 4282,
  [10457] = 4270,
  [10458] = 4272,
  [10459] = 4374,
  [10460] = 4375,
  [10461] = 4369,
  [10462] = 4299,
  [10463] = 4614,
  [10464] = 4352,
  [10465] = 4354,
  [10466] = 10356,
  [10467] = 4270,
  [10468] = 4458,
  [10469] = 4279,
  [10470] = 4615,
  [10471] = 4281,
  [10472] = 4299,
  [10473] = 4282,
  [10474] = 4650,
  [10475] = 4299,
  [10476] = 4279,
  [10477] = 4281,
  [10478] = 10356,
  [10479] = 4282,
  [10480] = 4358,
  [10481] = 4281,
  [10482] = 10356,
  [10483] = 4282,
  [10484] = 10356,
  [10485] = 4279,
  [10486] = 4281,
  [10487] = 4299,
  [10488] = 4282,
  [10489] = 4376,
  [10490] = 4377,
  [10491] = 4604,
  [10492] = 4381,
  [10493] = 4383,
  [10494] = 10356,
  [10495] = 10356,
  [10496] = 10356,
  [10497] = 4352,
  [10498] = 10356,
  [10499] = 4380,
  [10500] = 4692,
  [10501] = 4354,
  [10502] = 10356,
  [10503] = 10356,
  [10504] = 4695,
  [10505] = 4697,
  [10506] = 4282,
  [10507] = 4355,
  [10508] = 4340,
  [10509] = 4361,
  [10510] = 4362,
  [10511] = 4358,
  [10512] = 4573,
  [10513] = 4355,
  [10514] = 4340,
  [10515] = 4361,
  [10516] = 4362,
  [10517] = 4574,
  [10518] = 4597,
  [10519] = 4378,
  [10520] = 4700,
  [10521] = 10413,
  [10522] = 4351,
  [10523] = 4379,
  [10524] = 4617,
  [10525] = 4361,
  [10526] = 4353,
  [10527] = 4355,
  [10528] = 4272,
  [10529] = 4362,
  [10530] = 4270,
  [10531] = 4340,
  [10532] = 4684,
  [10533] = 4589,
  [10534] = 7494,
  [10535] = 4695,
  [10536] = 4608,
  [10537] = 4610,
  [10538] = 7419,
  [10539] = 4611,
  [10540] = 10540,
  [10541] = 7420,
  [10542] = 4272,
  [10543] = 4352,
  [10544] = 4354,
  [10545] = 4358,
  [10546] = 7331,
  [10547] = 4362,
  [10548] = 7496,
  [10549] = 4697,
  [10550] = 4272,
  [10551] = 4606,
  [10552] = 4361,
  [10553] = 4362,
  [10554] = 4282,
  [10555] = 4272,
  [10556] = 4373,
  [10557] = 4374,
  [10558] = 4375,
  [10559] = 7483,
  [10560] = 4720,
  [10561] = 4376,
  [10562] = 4362,
  [10563] = 7497,
  [10564] = 7498,
  [10565] = 7499,
  [10566] = 4606,
  [10567] = 7500,
  [10568] = 7501,
  [10569] = 7502,
  [10570] = 4377,
  [10571] = 4369,
  [10572] = 4606,
  [10573] = 4270,
  [10574] = 4270,
  [10575] = 4380,
  [10576] = 4721,
  [10577] = 4281,
  [10578] = 7556,
  [10579] = 4279,
  [10580] = 7484,
  [10581] = 7485,
  [10582] = 4720,
  [10583] = 4700,
  [10584] = 4281,
  [10585] = 7371,
  [10586] = 7486,
  [10587] = 7487,
  [10588] = 4458,
  [10589] = 7488,
  [10590] = 4270,
  [10591] = 4606,
  [10592] = 7489,
  [10593] = 4352,
  [10594] = 4354,
  [10595] = 7490,
  [10596] = 7491,
  [10597] = 4738,
  [10598] = 4608,
  [10599] = 4610,
  [10600] = 4611,
  [10601] = 4358,
  [10602] = 7503,
  [10603] = 4299,
  [10604] = 7504,
  [10605] = 4674,
  [10606] = 4749,
  [10607] = 4751,
  [10608] = 4755,
  [10609] = 7506,
  [10610] = 7377,
  [10611] = 4660,
  [10612] = 4287,
  [10613] = 4281,
  [10614] = 4282,
  [10615] = 4652,
  [10616] = 4612,
  [10617] = 4612,
  [10618] = 4613,
  [10619] = 4606,
  [10620] = 4281,
  [10621] = 4613,
  [10622] = 4373,
  [10623] = 4660,
  [10624] = 4614,
  [10625] = 4374,
  [10626] = 4299,
  [10627] = 4666,
  [10628] = 4375,
  [10629] = 4615,
  [10630] = 4606,
  [10631] = 4686,
  [10632] = 4666,
  [10633] = 4361,
  [10634] = 4361,
  [10635] = 4282,
  [10636] = 4597,
  [10637] = 7373,
  [10638] = 4281,
  [10639] = 4282,
  [10640] = 4614,
  [10641] = 7507,
  [10642] = 7508,
  [10643] = 4351,
  [10644] = 4362,
  [10645] = 4615,
  [10646] = 7403,
  [10647] = 4355,
  [10648] = 7509,
  [10649] = 4617,
  [10650] = 4376,
  [10651] = 7447,
  [10652] = 4377,
  [10653] = 4353,
  [10654] = 4340,
  [10655] = 4618,
  [10656] = 4623,
  [10657] = 4626,
  [10658] = 7510,
  [10659] = 7421,
  [10660] = 4380,
  [10661] = 4631,
  [10662] = 4632,
  [10663] = 4600,
  [10664] = 4634,
  [10665] = 4568,
  [10666] = 4692,
  [10667] = 4695,
  [10668] = 4697,
  [10669] = 7369,
  [10670] = 4569,
  [10671] = 4570,
  [10672] = 4281,
  [10673] = 4576,
  [10674] = 4700,
  [10675] = 4582,
  [10676] = 4355,
  [10677] = 4606,
  [10678] = 4270,
  [10679] = 4602,
  [10680] = 4597,
  [10681] = 4583,
  [10682] = 4340,
  [10683] = 4362,
  [10684] = 4674,
  [10685] = 4279,
  [10686] = 4617,
  [10687] = 4618,
  [10688] = 4623,
  [10689] = 4626,
  [10690] = 4584,
  [10691] = 4587,
  [10692] = 7320,
  [10693] = 4355,
  [10694] = 7323,
  [10695] = 4631,
  [10696] = 4270,
  [10697] = 7511,
  [10698] = 4632,
  [10699] = 7512,
  [10700] = 7513,
  [10701] = 4589,
  [10702] = 7370,
  [10703] = 4660,
  [10704] = 7514,
  [10705] = 7515,
  [10706] = 7516,
  [10707] = 7517,
  [10708] = 4600,
  [10709] = 4634,
  [10710] = 4568,
  [10711] = 4569,
  [10712] = 4570,
  [10713] = 4576,
  [10714] = 4582,
  [10715] = 4622,
  [10716] = 4567,
  [10717] = 4340,
  [10718] = 4721,
  [10719] = 4355,
  [10720] = 4340,
  [10721] = 4666,
  [10722] = 4361,
  [10723] = 4369,
  [10724] = 4686,
  [10725] = 4362,
  [10726] = 7297,
  [10727] = 4575,
  [10728] = 7463,
  [10729] = 7445,
  [10730] = 4351,
  [10731] = 4284,
  [10732] = 4361,
  [10733] = 4361,
  [10734] = 4299,
  [10735] = 4302,
  [10736] = 4567,
  [10737] = 4362,
  [10738] = 4575,
  [10739] = 4355,
  [10740] = 4352,
  [10741] = 4354,
  [10742] = 4355,
  [10743] = 4358,
  [10744] = 4602,
  [10745] = 4583,
  [10746] = 4362,
  [10747] = 7378,
  [10748] = 4584,
  [10749] = 7475,
  [10750] = 4603,
  [10751] = 4586,
  [10752] = 4361,
  [10753] = 4458,
  [10754] = 4622,
  [10755] = 4608,
  [10756] = 4610,
  [10757] = 4611,
  [10758] = 7353,
  [10759] = 4587,
  [10760] = 4684,
  [10761] = 4606,
  [10762] = 4340,
  [10763] = 4612,
  [10764] = 4613,
  [10765] = 4614,
  [10766] = 4615,
  [10767] = 4604,
  [10768] = 4622,
  [10769] = 4597,
  [10770] = 4279,
  [10771] = 4617,
  [10772] = 4618,
  [10773] = 4623,
  [10774] = 4626,
  [10775] = 4373,
  [10776] = 4573,
  [10777] = 4574,
  [10778] = 4631,
  [10779] = 4632,
  [10780] = 4374,
  [10781] = 7464,
  [10782] = 7468,
  [10783] = 4282,
  [10784] = 4270,
  [10785] = 4375,
  [10786] = 4281,
  [10787] = 4299,
  [10788] = 4282,
  [10789] = 4340,
  [10790] = 4600,
  [10791] = 7469,
  [10792] = 4362,
  [10793] = 4634,
  [10794] = 4568,
  [10795] = 4569,
  [10796] = 4570,
  [10797] = 4573,
  [10798] = 4574,
  [10799] = 4576,
  [10800] = 10413,
  [10801] = 4279,
  [10802] = 4582,
  [10803] = 4602,
  [10804] = 4583,
  [10805] = 4584,
  [10806] = 4587,
  [10807] = 4355,
  [10808] = 4648,
  [10809] = 4287,
  [10810] = 4650,
  [10811] = 4281,
  [10812] = 4299,
  [10813] = 4340,
  [10814] = 4648,
  [10815] = 7476,
  [10816] = 4376,
  [10817] = 4377,
  [10818] = 4299,
  [10819] = 4282,
  [10820] = 4686,
  [10821] = 10821,
  [10822] = 4279,
  [10823] = 4380,
  [10824] = 4361,
  [10825] = 4603,
  [10826] = 4651,
  [10827] = 4586,
  [10828] = 4279,
  [10829] = 4281,
  [10830] = 4299,
  [10831] = 4282,
  [10832] = 4674,
  [10833] = 4272,
  [10834] = 4362,
  [10835] = 7397,
  [10836] = 4294,
  [10837] = 4353,
  [10838] = 4279,
  [10839] = 4281,
  [10840] = 4299,
  [10841] = 4282,
  [10842] = 4571,
  [10843] = 4355,
  [10844] = 7367,
  [10845] = 4340,
  [10846] = 4279,
  [10847] = 4589,
  [10848] = 7368,
  [10849] = 4281,
  [10850] = 4299,
  [10851] = 4282,
  [10852] = 7404,
  [10853] = 4604,
  [10854] = 4353,
  [10855] = 4648,
  [10856] = 7304,
  [10857] = 4650,
  [10858] = 4282,
  [10859] = 4355,
  [10860] = 7399,
  [10861] = 7400,
  [10862] = 4272,
  [10863] = 4340,
  [10864] = 7401,
  [10865] = 7477,
  [10866] = 4684,
  [10867] = 4692,
  [10868] = 4695,
  [10869] = 4697,
  [10870] = 4294,
  [10871] = 7402,
  [10872] = 4700,
  [10873] = 4738,
  [10874] = 4606,
  [10875] = 7473,
  [10876] = 7375,
  [10877] = 4589,
  [10878] = 7362,
  [10879] = 4650,
  [10880] = 4355,
  [10881] = 4351,
  [10882] = 7406,
  [10883] = 7493,
  [10884] = 4340,
  [10885] = 4458,
  [10886] = 7423,
  [10887] = 4651,
  [10888] = 4361,
  [10889] = 4573,
  [10890] = 4574,
  [10891] = 4749,
  [10892] = 4720,
  [10893] = 7372,
  [10894] = 4721,
  [10895] = 7382,
  [10896] = 7324,
  [10897] = 4651,
  [10898] = 7478,
  [10899] = 4567,
  [10900] = 4369,
  [10901] = 4575,
  [10902] = 4299,
  [10903] = 7318,
  [10904] = 7328,
  [10905] = 4692,
  [10906] = 4361,
  [10907] = 4603,
  [10908] = 4586,
  [10909] = 4751,
  [10910] = 4738,
  [10911] = 4604,
  [10912] = 4749,
  [10913] = 7418,
  [10914] = 4751,
  [10915] = 4738,
  [10916] = 4606,
  [10917] = 4755,
  [10918] = 4571,
  [10919] = 7319,
  [10920] = 7422,
  [10921] = 4571,
  [10922] = 4355,
  [10923] = 4755,
  [10924] = 7289,
  [10925] = 4340,
  [10926] = 4361,
  [10927] = 4362,
  [10928] = 7480,
  [10929] = 7481,
  [10930] = 4284,
  [10931] = 4299,
  [10932] = 4302,
  [10933] = 7495,
  [10934] = 4610,
  [10935] = 4614,
  [10936] = 4567,
  [10937] = 4615,
  [10938] = 4575,
  [10939] = 4355,
  [10940] = 4340,
  [10941] = 4375,
  [10942] = 4355,
  [10943] = 4603,
  [10944] = 4281,
  [10945] = 4586,
  [10946] = 4299,
  [10947] = 4362,
  [10948] = 4604,
  [10949] = 4597,
  [10950] = 4617,
  [10951] = 4569,
  [10952] = 4618,
  [10953] = 4570,
  [10954] = 4282,
  [10955] = 4571,
  [10956] = 4623,
  [10957] = 4626,
  [10958] = 4608,
  [10959] = 4631,
  [10960] = 4632,
  [10961] = 4751,
  [10962] = 4623,
  [10963] = 4626,
  [10964] = 4600,
  [10965] = 4634,
  [10966] = 4660,
  [10967] = 4568,
  [10968] = 4660,
  [10969] = 4606,
  [10970] = 4373,
  [10971] = 4569,
  [10972] = 4570,
  [10973] = 4576,
  [10974] = 4582,
  [10975] = 4602,
  [10976] = 4270,
  [10977] = 4666,
  [10978] = 4583,
  [10979] = 4686,
  [10980] = 4351,
  [10981] = 4584,
  [10982] = 4587,
  [10983] = 4692,
  [10984] = 4355,
  [10985] = 4340,
  [10986] = 4692,
  [10987] = 4684,
  [10988] = 4352,
  [10989] = 4651,
  [10990] = 4352,
  [10991] = 4589,
  [10992] = 4361,
  [10993] = 4374,
  [10994] = 4648,
  [10995] = 4589,
  [10996] = 4375,
  [10997] = 4361,
  [10998] = 4279,
  [10999] = 4576,
  [11000] = 4376,
  [11001] = 4582,
  [11002] = 4377,
  [11003] = 4695,
  [11004] = 4586,
  [11005] = 4354,
  [11006] = 4589,
  [11007] = 4721,
  [11008] = 4279,
  [11009] = 4270,
  [11010] = 4751,
  [11011] = 4281,
  [11012] = 4299,
  [11013] = 4282,
  [11014] = 4606,
  [11015] = 4362,
  [11016] = 4458,
  [11017] = 4361,
  [11018] = 4362,
  [11019] = 4340,
  [11020] = 4354,
  [11021] = 4353,
  [11022] = 4596,
  [11023] = 4606,
  [11024] = 4279,
  [11025] = 11025,
  [11026] = 4281,
  [11027] = 4299,
  [11028] = 4282,
  [11029] = 4281,
  [11030] = 4369,
  [11031] = 4358,
  [11032] = 4299,
  [11033] = 4353,
  [11034] = 4281,
  [11035] = 4612,
  [11036] = 4299,
  [11037] = 4380,
  [11038] = 4652,
  [11039] = 4610,
  [11040] = 4631,
  [11041] = 4674,
  [11042] = 4573,
  [11043] = 4686,
  [11044] = 4755,
  [11045] = 4755,
  [11046] = 4376,
  [11047] = 4583,
  [11048] = 4272,
  [11049] = 4358,
  [11050] = 4377,
  [11051] = 4584,
  [11052] = 4355,
  [11053] = 4632,
  [11054] = 4606,
  [11055] = 4686,
  [11056] = 4613,
  [11057] = 4674,
  [11058] = 4614,
  [11059] = 4340,
  [11060] = 4575,
  [11061] = 4351,
  [11062] = 4567,
  [11063] = 4279,
  [11064] = 4603,
  [11065] = 4380,
  [11066] = 4458,
  [11067] = 4586,
  [11068] = 4282,
  [11069] = 4282,
  [11070] = 4361,
  [11071] = 4362,
  [11072] = 4720,
  [11073] = 4606,
  [11074] = 4648,
  [11075] = 4369,
  [11076] = 4608,
  [11077] = 4374,
  [11078] = 4602,
  [11079] = 4611,
  [11080] = 4684,
  [11081] = 4600,
  [11082] = 4612,
  [11083] = 4613,
  [11084] = 4614,
  [11085] = 4615,
  [11086] = 4622,
  [11087] = 4574,
  [11088] = 4355,
  [11089] = 4597,
  [11090] = 4617,
  [11091] = 4618,
  [11092] = 4623,
  [11093] = 4626,
  [11094] = 4573,
  [11095] = 4574,
  [11096] = 4631,
  [11097] = 4615,
  [11098] = 4632,
  [11099] = 4738,
  [11100] = 4600,
  [11101] = 4634,
  [11102] = 4568,
  [11103] = 4569,
  [11104] = 4570,
  [11105] = 4576,
  [11106] = 4582,
  [11107] = 4602,
  [11108] = 4583,
  [11109] = 4584,
  [11110] = 4587,
  [11111] = 4749,
  [11112] = 4695,
  [11113] = 4272,
  [11114] = 4648,
  [11115] = 4650,
  [11116] = 4651,
  [11117] = 4571,
  [11118] = 4751,
  [11119] = 4755,
  [11120] = 4652,
  [11121] = 4700,
  [11122] = 4567,
  [11123] = 4738,
  [11124] = 4721,
  [11125] = 4697,
  [11126] = 4650,
  [11127] = 4355,
  [11128] = 4340,
  [11129] = 4651,
  [11130] = 4674,
  [11131] = 4606,
  [11132] = 4611,
  [11133] = 4720,
  [11134] = 4340,
  [11135] = 4571,
  [11136] = 4660,
  [11137] = 4606,
  [11138] = 4650,
  [11139] = 4692,
  [11140] = 4695,
  [11141] = 4697,
  [11142] = 4604,
  [11143] = 4282,
  [11144] = 4589,
  [11145] = 4700,
  [11146] = 4606,
  [11147] = 4622,
  [11148] = 4589,
  [11149] = 4700,
  [11150] = 4738,
  [11151] = 4749,
  [11152] = 4281,
  [11153] = 4573,
  [11154] = 4589,
  [11155] = 4603,
  [11156] = 4575,
  [11157] = 4606,
  [11158] = 4299,
  [11159] = 4574,
  [11160] = 4622,
  [11161] = 4618,
  [11162] = 4361,
  [11163] = 4596,
  [11164] = 4697,
  [11165] = 4666,
  [11166] = 4272,
  [11167] = 10413,
  [11168] = 4666,
  [11169] = 4362,
  [11170] = 4361,
  [11171] = 4634,
  [11172] = 4279,
  [11173] = 4589,
  [11174] = 4608,
  [11175] = 4604,
  [11176] = 4610,
  [11177] = 4720,
  [11178] = 4749,
  [11179] = 4684,
  [11180] = 4597,
  [11181] = 4721,
  [11182] = 4373,
  [11183] = 4611,
  [11184] = 4652,
  [11185] = 4617,
  [11186] = 4279,
  [11187] = 4596,
  [11188] = 4362,
  [11189] = 4612,
  [11190] = 4596,
  [11191] = 4613,
  [11192] = 4568,
  [11193] = 4596,
  [11194] = 4587,
  [11195] = 4674,
  [11196] = 4355,
  [11197] = 4340,
  [11198] = 4606,
  [11199] = 4606,
  [11200] = 4606,
  [11201] = 4279,
  [11202] = 4589,
  [11203] = 4606,
  [11204] = 4279,
  [11205] = 4361,
  [11206] = 4362,
  [11207] = 4589,
  [11208] = 4589,
  [11209] = 11209,
  [11210] = 4652,
  [11211] = 4755,
  [11212] = 4686,
  [11213] = 6457,
  [11214] = 4361,
  [11215] = 4660,
  [11216] = 4362,
  [11217] = 4720,
  [11218] = 4666,
  [11219] = 4674,
  [11220] = 4606,
  [11221] = 11221,
  [11222] = 4686,
  [11223] = 5213,
  [11224] = 4281,
  [11225] = 4606,
  [11226] = 4299,
  [11227] = 4281,
  [11228] = 6457,
  [11229] = 4299,
  [11230] = 4272,
  [11231] = 4606,
  [11232] = 5581,
  [11233] = 4692,
  [11234] = 4695,
  [11235] = 4697,
  [11236] = 4299,
  [11237] = 4272,
  [11238] = 4700,
  [11239] = 4589,
  [11240] = 5213,
  [11241] = 4282,
  [11242] = 4606,
  [11243] = 4282,
  [11244] = 4720,
  [11245] = 4721,
  [11246] = 4721,
  [11247] = 4589,
  [11248] = 4608,
  [11249] = 4610,
  [11250] = 4567,
  [11251] = 4611,
  [11252] = 6457,
  [11253] = 4567,
  [11254] = 4575,
  [11255] = 4612,
  [11256] = 4613,
  [11257] = 11221,
  [11258] = 4614,
  [11259] = 4615,
  [11260] = 4622,
  [11261] = 4597,
  [11262] = 4617,
  [11263] = 4618,
  [11264] = 4623,
  [11265] = 4626,
  [11266] = 4573,
  [11267] = 4574,
  [11268] = 4631,
  [11269] = 4632,
  [11270] = 5213,
  [11271] = 4603,
  [11272] = 4586,
  [11273] = 4600,
  [11274] = 4634,
  [11275] = 4568,
  [11276] = 4569,
  [11277] = 4570,
  [11278] = 4604,
  [11279] = 4576,
  [11280] = 4582,
  [11281] = 4738,
  [11282] = 4602,
  [11283] = 4583,
  [11284] = 4584,
  [11285] = 4587,
  [11286] = 4589,
  [11287] = 5581,
  [11288] = 4606,
  [11289] = 11209,
  [11290] = 4749,
  [11291] = 4751,
  [11292] = 4608,
  [11293] = 4610,
  [11294] = 4611,
  [11295] = 4755,
  [11296] = 4612,
  [11297] = 4613,
  [11298] = 4614,
  [11299] = 4615,
  [11300] = 4622,
  [11301] = 4648,
  [11302] = 4597,
  [11303] = 4617,
  [11304] = 4618,
  [11305] = 4623,
  [11306] = 4626,
  [11307] = 4650,
  [11308] = 4573,
  [11309] = 4574,
  [11310] = 4651,
  [11311] = 4631,
  [11312] = 4632,
  [11313] = 4600,
  [11314] = 4634,
  [11315] = 4568,
  [11316] = 4569,
  [11317] = 4589,
  [11318] = 4570,
  [11319] = 4282,
  [11320] = 4576,
  [11321] = 4582,
  [11322] = 4602,
  [11323] = 4571,
  [11324] = 11221,
  [11325] = 4583,
  [11326] = 4279,
  [11327] = 4272,
  [11328] = 4584,
  [11329] = 4587,
  [11330] = 10413,
  [11331] = 4648,
  [11332] = 4684,
  [11333] = 4684,
  [11334] = 4650,
  [11335] = 4651,
  [11336] = 4272,
  [11337] = 4571,
  [11338] = 4660,
  [11339] = 4603,
  [11340] = 4606,
  [11341] = 4586,
  [11342] = 4751,
  [11343] = 4589,
  [11344] = 5581,
  [11345] = 5213,
  [11346] = 4738,
  [11347] = 4355,
  [11348] = 4340,
  [11349] = 4604,
  [11350] = 4666,
  [11351] = 4281,
  [11352] = 4361,
  [11353] = 4362,
  [11354] = 4749,
  [11355] = 11209,
  [11356] = 4355,
  [11357] = 4340,
  [11358] = 4652,
  [11359] = 5581,
  [11360] = 4589,
  [11361] = 4596,
  [11362] = 4692,
  [11363] = 5581,
  [11364] = 4695,
  [11365] = 4697,
  [11366] = 4596,
  [11367] = 5213,
  [11368] = 4596,
  [11369] = 4700,
  [11370] = 4575,
  [11371] = 4340,
  [11372] = 4355,
  [11373] = 6457,
  [11374] = 4282,
  [11375] = 6457,
  [11376] = 4361,
  [11377] = 4362,
  [11378] = 4340,
  [11379] = 4361,
  [11380] = 4458,
  [11381] = 4361,
  [11382] = 4589,
  [11383] = 4282,
  [11384] = 4272,
  [11385] = 4362,
  [11386] = 4281,
  [11387] = 4606,
  [11388] = 4281,
  [11389] = 4362,
  [11390] = 4281,
  [11391] = 4606,
  [11392] = 4282,
  [11393] = 4282,
  [11394] = 4340,
  [11395] = 6457,
  [11396] = 4589,
  [11397] = 4589,
  [11398] = 4272,
  [11399] = 4749,
  [11400] = 4282,
  [11401] = 4281,
  [11402] = 4355,
  [11403] = 4340,
  [11404] = 4361,
  [11405] = 4362,
  [11406] = 4281,
  [11407] = 4272,
  [11408] = 4606,
  [11409] = 4270,
  [11410] = 4355,
  [11411] = 4355,
  [11412] = 4340,
  [11413] = 4355,
  [11414] = 4340,
  [11415] = 4361,
  [11416] = 4362,
  [11417] = 4355,
  [11418] = 4362,
  [11419] = 4596,
  [11420] = 4589,
  [11421] = 4589,
  [11422] = 4596,
  [11423] = 4606,
  [11424] = 4270,
  [11425] = 4596,
  [11426] = 4589,
  [11427] = 4589,
  [11428] = 6457,
  [11429] = 5213,
  [11430] = 5581,
  [11431] = 4361,
  [11432] = 11432,
  [11433] = 5213,
  [11434] = 5213,
  [11435] = 5581,
  [11436] = 5581,
  [11437] = 4282,
  [11438] = 4361,
  [11439] = 4281,
  [11440] = 4282,
  [11441] = 4650,
  [11442] = 4569,
  [11443] = 4340,
  [11444] = 4282,
  [11445] = 4388,
  [11446] = 4570,
  [11447] = 4362,
  [11448] = 4287,
  [11449] = 4355,
  [11450] = 4574,
  [11451] = 4282,
  [11452] = 4355,
  [11453] = 4281,
  [11454] = 4608,
  [11455] = 4634,
  [11456] = 4272,
  [11457] = 4610,
  [11458] = 4355,
  [11459] = 4458,
  [11460] = 4458,
  [11461] = 4355,
  [11462] = 4340,
  [11463] = 4281,
  [11464] = 4340,
  [11465] = 4611,
  [11466] = 4589,
  [11467] = 4751,
  [11468] = 4282,
  [11469] = 4361,
  [11470] = 4361,
  [11471] = 11471,
  [11472] = 4282,
  [11473] = 4281,
  [11474] = 4284,
  [11475] = 4362,
  [11476] = 4282,
  [11477] = 4626,
  [11478] = 4282,
  [11479] = 4340,
  [11480] = 4383,
  [11481] = 4299,
  [11482] = 4281,
  [11483] = 4281,
  [11484] = 4606,
  [11485] = 4385,
  [11486] = 4362,
  [11487] = 4589,
  [11488] = 4355,
  [11489] = 4576,
  [11490] = 5213,
  [11491] = 5581,
  [11492] = 4568,
  [11493] = 4589,
  [11494] = 4340,
  [11495] = 4361,
  [11496] = 4606,
  [11497] = 4589,
  [11498] = 4355,
  [11499] = 4340,
  [11500] = 4361,
  [11501] = 4362,
  [11502] = 4272,
  [11503] = 4686,
  [11504] = 4587,
  [11505] = 4632,
  [11506] = 4355,
  [11507] = 4582,
  [11508] = 4281,
  [11509] = 4362,
  [11510] = 4361,
  [11511] = 5213,
  [11512] = 4597,
  [11513] = 5581,
  [11514] = 4648,
  [11515] = 4755,
  [11516] = 4361,
  [11517] = 4362,
  [11518] = 5213,
  [11519] = 5581,
  [11520] = 4660,
  [11521] = 4302,
  [11522] = 4282,
  [11523] = 4617,
  [11524] = 4618,
  [11525] = 4602,
  [11526] = 4631,
  [11527] = 4362,
  [11528] = 4392,
  [11529] = 4623,
  [11530] = 4458,
  [11531] = 4340,
  [11532] = 4583,
  [11533] = 4361,
  [11534] = 4738,
  [11535] = 4355,
  [11536] = 4584,
  [11537] = 4340,
  [11538] = 4361,
  [11539] = 4362,
  [11540] = 4573,
  [11541] = 4571,
  [11542] = 4362,
  [11543] = 4294,
  [11544] = 4606,
  [11545] = 4340,
  [11546] = 4684,
  [11547] = 4281,
  [11548] = 4282,
  [11549] = 4615,
  [11550] = 4600,
  [11551] = 4612,
  [11552] = 4651,
  [11553] = 4666,
  [11554] = 4355,
  [11555] = 4613,
  [11556] = 4279,
  [11557] = 4622,
  [11558] = 4614,
  [11559] = 5986,
  [11560] = 4281,
  [11561] = 4458,
  [11562] = 6721,
  [11563] = 4660,
  [11564] = 4571,
  [11565] = 4611,
  [11566] = 4648,
  [11567] = 4361,
  [11568] = 4281,
  [11569] = 4755,
  [11570] = 4281,
  [11571] = 4606,
  [11572] = 11572,
  [11573] = 4606,
  [11574] = 4606,
  [11575] = 4666,
  [11576] = 11576,
  [11577] = 4354,
  [11578] = 4606,
  [11579] = 4362,
  [11580] = 4751,
  [11581] = 6673,
  [11582] = 4573,
  [11583] = 4738,
  [11584] = 4686,
  [11585] = 4606,
  [11586] = 5986,
  [11587] = 4574,
  [11588] = 11588,
  [11589] = 4602,
  [11590] = 4355,
  [11591] = 4340,
  [11592] = 4355,
  [11593] = 4749,
  [11594] = 4751,
  [11595] = 4606,
  [11596] = 4606,
  [11597] = 4606,
  [11598] = 11588,
  [11599] = 11576,
  [11600] = 4340,
  [11601] = 4755,
  [11602] = 6783,
  [11603] = 4606,
  [11604] = 4684,
  [11605] = 4606,
  [11606] = 4376,
  [11607] = 4377,
  [11608] = 4281,
  [11609] = 4570,
  [11610] = 6940,
  [11611] = 4606,
  [11612] = 11572,
  [11613] = 11576,
  [11614] = 11588,
  [11615] = 11576,
  [11616] = 11588,
  [11617] = 4606,
  [11618] = 4612,
  [11619] = 4458,
  [11620] = 4600,
  [11621] = 4576,
  [11622] = 4582,
  [11623] = 4606,
  [11624] = 4606,
  [11625] = 4684,
  [11626] = 4606,
  [11627] = 4602,
  [11628] = 4576,
  [11629] = 4458,
  [11630] = 11588,
  [11631] = 4582,
  [11632] = 4361,
  [11633] = 4606,
  [11634] = 6721,
  [11635] = 4613,
  [11636] = 6783,
  [11637] = 5986,
  [11638] = 4282,
  [11639] = 4362,
  [11640] = 4282,
  [11641] = 4606,
  [11642] = 4684,
  [11643] = 11643,
  [11644] = 11643,
  [11645] = 4380,
  [11646] = 4755,
  [11647] = 11588,
  [11648] = 4597,
  [11649] = 6752,
  [11650] = 4589,
  [11651] = 4583,
  [11652] = 4282,
  [11653] = 4614,
  [11654] = 4738,
  [11655] = 4606,
  [11656] = 4738,
  [11657] = 6783,
  [11658] = 4272,
  [11659] = 6752,
  [11660] = 6752,
  [11661] = 6753,
  [11662] = 4606,
  [11663] = 6753,
  [11664] = 4615,
  [11665] = 4606,
  [11666] = 4650,
  [11667] = 6753,
  [11668] = 7098,
  [11669] = 4606,
  [11670] = 6557,
  [11671] = 4632,
  [11672] = 4648,
  [11673] = 4606,
  [11674] = 4584,
  [11675] = 4587,
  [11676] = 4583,
  [11677] = 4568,
  [11678] = 11588,
  [11679] = 4584,
  [11680] = 4606,
  [11681] = 4272,
  [11682] = 4606,
  [11683] = 11576,
  [11684] = 4660,
  [11685] = 4608,
  [11686] = 4610,
  [11687] = 4611,
  [11688] = 4281,
  [11689] = 4650,
  [11690] = 11588,
  [11691] = 6907,
  [11692] = 11588,
  [11693] = 4612,
  [11694] = 4613,
  [11695] = 4614,
  [11696] = 4615,
  [11697] = 4282,
  [11698] = 4606,
  [11699] = 4622,
  [11700] = 4587,
  [11701] = 4597,
  [11702] = 11576,
  [11703] = 4617,
  [11704] = 4618,
  [11705] = 4623,
  [11706] = 4281,
  [11707] = 4626,
  [11708] = 4272,
  [11709] = 4573,
  [11710] = 4574,
  [11711] = 4631,
  [11712] = 4632,
  [11713] = 4282,
  [11714] = 4606,
  [11715] = 4666,
  [11716] = 4600,
  [11717] = 4634,
  [11718] = 4568,
  [11719] = 4569,
  [11720] = 4570,
  [11721] = 4569,
  [11722] = 6174,
  [11723] = 4582,
  [11724] = 4281,
  [11725] = 4355,
  [11726] = 4340,
  [11727] = 4602,
  [11728] = 4583,
  [11729] = 4584,
  [11730] = 4587,
  [11731] = 4622,
  [11732] = 4606,
  [11733] = 4369,
  [11734] = 4648,
  [11735] = 4361,
  [11736] = 6673,
  [11737] = 4606,
  [11738] = 4650,
  [11739] = 4362,
  [11740] = 4686,
  [11741] = 4606,
  [11742] = 4651,
  [11743] = 4651,
  [11744] = 4606,
  [11745] = 4282,
  [11746] = 4634,
  [11747] = 4606,
  [11748] = 4571,
  [11749] = 4617,
  [11750] = 4606,
  [11751] = 6721,
  [11752] = 6673,
  [11753] = 4351,
  [11754] = 4618,
  [11755] = 4355,
  [11756] = 4606,
  [11757] = 4623,
  [11758] = 4626,
  [11759] = 4606,
  [11760] = 4651,
  [11761] = 4340,
  [11762] = 11588,
  [11763] = 11576,
  [11764] = 4606,
  [11765] = 4606,
  [11766] = 4622,
  [11767] = 11576,
  [11768] = 11576,
  [11769] = 4373,
  [11770] = 11576,
  [11771] = 4352,
  [11772] = 11588,
  [11773] = 4606,
  [11774] = 11643,
  [11775] = 4606,
  [11776] = 4631,
  [11777] = 4573,
  [11778] = 4574,
  [11779] = 4632,
  [11780] = 11588,
  [11781] = 11576,
  [11782] = 4374,
  [11783] = 4606,
  [11784] = 4355,
  [11785] = 4361,
  [11786] = 4340,
  [11787] = 11576,
  [11788] = 4606,
  [11789] = 4362,
  [11790] = 11572,
  [11791] = 4361,
  [11792] = 4749,
  [11793] = 4358,
  [11794] = 4362,
  [11795] = 4749,
  [11796] = 4606,
  [11797] = 11576,
  [11798] = 4606,
  [11799] = 4600,
  [11800] = 4375,
  [11801] = 4634,
  [11802] = 4608,
  [11803] = 4751,
  [11804] = 4610,
  [11805] = 4606,
  [11806] = 11588,
  [11807] = 4611,
  [11808] = 4612,
  [11809] = 4613,
  [11810] = 4614,
  [11811] = 4615,
  [11812] = 11576,
  [11813] = 4361,
  [11814] = 4606,
  [11815] = 4568,
  [11816] = 4597,
  [11817] = 4617,
  [11818] = 4618,
  [11819] = 11576,
  [11820] = 4355,
  [11821] = 4623,
  [11822] = 4626,
  [11823] = 4606,
  [11824] = 11576,
  [11825] = 4340,
  [11826] = 4606,
  [11827] = 4608,
  [11828] = 11576,
  [11829] = 4610,
  [11830] = 4569,
  [11831] = 6721,
  [11832] = 4570,
  [11833] = 11576,
  [11834] = 4458,
  [11835] = 4571,
  [11836] = 4362,
  [11837] = 4606,
  [11838] = 11576,
  [11839] = 11588,
  [11840] = 4353,
  [11841] = 11588,
  [11842] = 11576,
  [11843] = 4631,
  [11844] = 6721,
  [11845] = 6174,
  [11846] = 6174,
  [11847] = 6174,
  [11848] = 6783,
  [11849] = 6752,
  [11850] = 6753,
  [11851] = 6673,
  [11852] = 6783,
  [11853] = 6752,
  [11854] = 6753,
  [11855] = 6673,
  [11856] = 6174,
  [11857] = 4576,
  [11858] = 11858,
  [11859] = 4584,
  [11860] = 4648,
  [11861] = 4700,
  [11862] = 11862,
  [11863] = 11862,
  [11864] = 7496,
  [11865] = 4617,
  [11866] = 7497,
  [11867] = 7473,
  [11868] = 4582,
  [11869] = 11869,
  [11870] = 11858,
  [11871] = 7508,
  [11872] = 7098,
  [11873] = 11869,
  [11874] = 6907,
  [11875] = 11862,
  [11876] = 4570,
  [11877] = 4666,
  [11878] = 4674,
  [11879] = 4612,
  [11880] = 7498,
  [11881] = 11858,
  [11882] = 6907,
  [11883] = 7324,
  [11884] = 7328,
  [11885] = 4282,
  [11886] = 11858,
  [11887] = 11869,
  [11888] = 6907,
  [11889] = 4596,
  [11890] = 4610,
  [11891] = 4738,
  [11892] = 4282,
  [11893] = 7371,
  [11894] = 11862,
  [11895] = 11858,
  [11896] = 6869,
  [11897] = 6907,
  [11898] = 11862,
  [11899] = 11862,
  [11900] = 11858,
  [11901] = 6557,
  [11902] = 7475,
  [11903] = 4282,
  [11904] = 11862,
  [11905] = 11862,
  [11906] = 11862,
  [11907] = 4575,
  [11908] = 11862,
  [11909] = 11862,
  [11910] = 11862,
  [11911] = 6943,
  [11912] = 11862,
  [11913] = 6907,
  [11914] = 6940,
  [11915] = 11862,
  [11916] = 4613,
  [11917] = 11858,
  [11918] = 11869,
  [11919] = 7463,
  [11920] = 4589,
  [11921] = 11869,
  [11922] = 11862,
  [11923] = 4618,
  [11924] = 7068,
  [11925] = 7070,
  [11926] = 11862,
  [11927] = 11862,
  [11928] = 7067,
  [11929] = 11862,
  [11930] = 11862,
  [11931] = 6861,
  [11932] = 11932,
  [11933] = 11862,
  [11934] = 11862,
  [11935] = 11862,
  [11936] = 11858,
  [11937] = 11862,
  [11938] = 4614,
  [11939] = 11869,
  [11940] = 7499,
  [11941] = 7513,
  [11942] = 11862,
  [11943] = 7509,
  [11944] = 11862,
  [11945] = 6979,
  [11946] = 7464,
  [11947] = 11862,
  [11948] = 6943,
  [11949] = 4361,
  [11950] = 4631,
  [11951] = 7494,
  [11952] = 6557,
  [11953] = 7353,
  [11954] = 7369,
  [11955] = 6862,
  [11956] = 7397,
  [11957] = 11858,
  [11958] = 11862,
  [11959] = 6990,
  [11960] = 7362,
  [11961] = 6898,
  [11962] = 7486,
  [11963] = 4632,
  [11964] = 7468,
  [11965] = 7068,
  [11966] = 6943,
  [11967] = 11862,
  [11968] = 11862,
  [11969] = 11862,
  [11970] = 4615,
  [11971] = 7485,
  [11972] = 11862,
  [11973] = 7495,
  [11974] = 6869,
  [11975] = 7487,
  [11976] = 6943,
  [11977] = 11862,
  [11978] = 4597,
  [11979] = 11862,
  [11980] = 4362,
  [11981] = 4651,
  [11982] = 6861,
  [11983] = 4571,
  [11984] = 6862,
  [11985] = 6898,
  [11986] = 11858,
  [11987] = 7375,
  [11988] = 11869,
  [11989] = 6979,
  [11990] = 7488,
  [11991] = 7500,
  [11992] = 6990,
  [11993] = 4568,
  [11994] = 4361,
  [11995] = 11862,
  [11996] = 7000,
  [11997] = 4573,
  [11998] = 7067,
  [11999] = 11862,
  [12000] = 11862,
  [12001] = 4622,
  [12002] = 7469,
  [12003] = 7501,
  [12004] = 4738,
  [12005] = 4569,
  [12006] = 7000,
  [12007] = 4362,
  [12008] = 4355,
  [12009] = 11862,
  [12010] = 7331,
  [12011] = 11862,
  [12012] = 7367,
  [12013] = 11862,
  [12014] = 7070,
  [12015] = 7304,
  [12016] = 4603,
  [12017] = 4720,
  [12018] = 7368,
  [12019] = 4281,
  [12020] = 7502,
  [12021] = 11862,
  [12022] = 11862,
  [12023] = 11862,
  [12024] = 4340,
  [12025] = 4721,
  [12026] = 11862,
  [12027] = 4281,
  [12028] = 7403,
  [12029] = 7503,
  [12030] = 11862,
  [12031] = 7504,
  [12032] = 11858,
  [12033] = 7289,
  [12034] = 7506,
  [12035] = 11862,
  [12036] = 11862,
  [12037] = 7404,
  [12038] = 11862,
  [12039] = 7556,
  [12040] = 7489,
  [12041] = 11862,
  [12042] = 11862,
  [12043] = 11862,
  [12044] = 4650,
  [12045] = 6943,
  [12046] = 11862,
  [12047] = 11862,
  [12048] = 7000,
  [12049] = 4586,
  [12050] = 7000,
  [12051] = 7406,
  [12052] = 7490,
  [12053] = 11932,
  [12054] = 11869,
  [12055] = 4600,
  [12056] = 6990,
  [12057] = 11862,
  [12058] = 4749,
  [12059] = 11862,
  [12060] = 11869,
  [12061] = 4738,
  [12062] = 7507,
  [12063] = 6869,
  [12064] = 4634,
  [12065] = 7514,
  [12066] = 7515,
  [12067] = 7372,
  [12068] = 11858,
  [12069] = 7068,
  [12070] = 6940,
  [12071] = 7480,
  [12072] = 4355,
  [12073] = 7399,
  [12074] = 11858,
  [12075] = 4751,
  [12076] = 6861,
  [12077] = 6174,
  [12078] = 7481,
  [12079] = 4686,
  [12080] = 11862,
  [12081] = 7418,
  [12082] = 4340,
  [12083] = 4660,
  [12084] = 7491,
  [12085] = 11862,
  [12086] = 7400,
  [12087] = 7476,
  [12088] = 7477,
  [12089] = 11858,
  [12090] = 7401,
  [12091] = 7478,
  [12092] = 11862,
  [12093] = 11862,
  [12094] = 11869,
  [12095] = 6907,
  [12096] = 4281,
  [12097] = 7483,
  [12098] = 7067,
  [12099] = 7382,
  [12100] = 11862,
  [12101] = 7268,
  [12102] = 7269,
  [12103] = 6844,
  [12104] = 6862,
  [12105] = 11862,
  [12106] = 7070,
  [12107] = 4652,
  [12108] = 7419,
  [12109] = 6943,
  [12110] = 11869,
  [12111] = 4355,
  [12112] = 7268,
  [12113] = 7269,
  [12114] = 6844,
  [12115] = 7282,
  [12116] = 7032,
  [12117] = 6457,
  [12118] = 4340,
  [12119] = 7282,
  [12120] = 7032,
  [12121] = 7420,
  [12122] = 4587,
  [12123] = 6898,
  [12124] = 4755,
  [12125] = 7516,
  [12126] = 11862,
  [12127] = 6907,
  [12128] = 11869,
  [12129] = 11862,
  [12130] = 6979,
  [12131] = 4611,
  [12132] = 4361,
  [12133] = 7510,
  [12134] = 7272,
  [12135] = 7421,
  [12136] = 7272,
  [12137] = 7318,
  [12138] = 4574,
  [12139] = 7282,
  [12140] = 7032,
  [12141] = 4362,
  [12142] = 7422,
  [12143] = 7282,
  [12144] = 7032,
  [12145] = 4602,
  [12146] = 11858,
  [12147] = 11862,
  [12148] = 11862,
  [12149] = 7319,
  [12150] = 11862,
  [12151] = 6869,
  [12152] = 7272,
  [12153] = 7272,
  [12154] = 7268,
  [12155] = 7269,
  [12156] = 6844,
  [12157] = 7268,
  [12158] = 7269,
  [12159] = 6844,
  [12160] = 7484,
  [12161] = 6907,
  [12162] = 4583,
  [12163] = 7517,
  [12164] = 7068,
  [12165] = 11858,
  [12166] = 4589,
  [12167] = 6721,
  [12168] = 7423,
  [12169] = 7373,
  [12170] = 11869,
  [12171] = 7320,
  [12172] = 11862,
  [12173] = 4608,
  [12174] = 6979,
  [12175] = 6990,
  [12176] = 11858,
  [12177] = 6943,
  [12178] = 6861,
  [12179] = 6862,
  [12180] = 6898,
  [12181] = 7445,
  [12182] = 7511,
  [12183] = 6174,
  [12184] = 4623,
  [12185] = 4626,
  [12186] = 4692,
  [12187] = 11858,
  [12188] = 11858,
  [12189] = 11869,
  [12190] = 6721,
  [12191] = 4695,
  [12192] = 7377,
  [12193] = 6174,
  [12194] = 4697,
  [12195] = 4604,
  [12196] = 11858,
  [12197] = 7402,
  [12198] = 6721,
  [12199] = 7378,
  [12200] = 4567,
  [12201] = 6943,
  [12202] = 6979,
  [12203] = 6990,
  [12204] = 11862,
  [12205] = 11862,
  [12206] = 6861,
  [12207] = 6862,
  [12208] = 6898,
  [12209] = 4576,
  [12210] = 6943,
  [12211] = 7493,
  [12212] = 7512,
  [12213] = 6783,
  [12214] = 6752,
  [12215] = 6753,
  [12216] = 6673,
  [12217] = 7067,
  [12218] = 7070,
  [12219] = 7447,
  [12220] = 11862,
  [12221] = 4272,
  [12222] = 7370,
  [12223] = 6783,
  [12224] = 6752,
  [12225] = 6753,
  [12226] = 6673,
  [12227] = 6174,
  [12228] = 6783,
  [12229] = 6752,
  [12230] = 6753,
  [12231] = 6673,
  [12232] = 6174,
  [12233] = 7067,
  [12234] = 7070,
  [12235] = 4684,
  [12236] = 7323,
  [12237] = 6943,
  [12238] = 7297,
  [12239] = 11869,
  [12240] = 6174,
  [12241] = 6174,
  [12242] = 6174,
  [12243] = 11862,
  [12244] = 7098,
  [12245] = 12245,
  [12246] = 12245,
  [12247] = 7297,
  [12248] = 7367,
  [12249] = 7321,
  [12250] = 7326,
  [12251] = 7329,
  [12252] = 7368,
  [12253] = 7369,
  [12254] = 7370,
  [12255] = 7393,
  [12256] = 7371,
  [12257] = 7372,
  [12258] = 7373,
  [12259] = 7297,
  [12260] = 6943,
  [12261] = 7272,
  [12262] = 12262,
  [12263] = 7375,
  [12264] = 7377,
  [12265] = 7378,
  [12266] = 7382,
  [12267] = 7032,
  [12268] = 7344,
  [12269] = 12269,
  [12270] = 7332,
  [12271] = 7428,
  [12272] = 7333,
  [12273] = 7334,
  [12274] = 12274,
  [12275] = 7335,
  [12276] = 7336,
  [12277] = 7337,
  [12278] = 7338,
  [12279] = 7339,
  [12280] = 7439,
  [12281] = 7440,
  [12282] = 7441,
  [12283] = 7442,
  [12284] = 7443,
  [12285] = 7394,
  [12286] = 12245,
  [12287] = 7397,
  [12288] = 6783,
  [12289] = 6752,
  [12290] = 7399,
  [12291] = 7400,
  [12292] = 7401,
  [12293] = 7402,
  [12294] = 7403,
  [12295] = 7362,
  [12296] = 7406,
  [12297] = 7418,
  [12298] = 7419,
  [12299] = 7420,
  [12300] = 7421,
  [12301] = 7422,
  [12302] = 7423,
  [12303] = 7445,
  [12304] = 7297,
  [12305] = 7447,
  [12306] = 6753,
  [12307] = 7068,
  [12308] = 12262,
  [12309] = 7463,
  [12310] = 7464,
  [12311] = 12245,
  [12312] = 7468,
  [12313] = 7469,
  [12314] = 7473,
  [12315] = 12269,
  [12316] = 7068,
  [12317] = 7000,
  [12318] = 7475,
  [12319] = 12274,
  [12320] = 7476,
  [12321] = 7477,
  [12322] = 7478,
  [12323] = 7289,
  [12324] = 7480,
  [12325] = 7481,
  [12326] = 7483,
  [12327] = 12245,
  [12328] = 7000,
  [12329] = 7484,
  [12330] = 7485,
  [12331] = 7486,
  [12332] = 7487,
  [12333] = 7488,
  [12334] = 7489,
  [12335] = 7490,
  [12336] = 7491,
  [12337] = 12269,
  [12338] = 12274,
  [12339] = 12245,
  [12340] = 7493,
  [12341] = 7494,
  [12342] = 7495,
  [12343] = 7496,
  [12344] = 7497,
  [12345] = 7498,
  [12346] = 7499,
  [12347] = 12269,
  [12348] = 12274,
  [12349] = 7500,
  [12350] = 7501,
  [12351] = 7502,
  [12352] = 12245,
  [12353] = 7503,
  [12354] = 7504,
  [12355] = 7506,
  [12356] = 7507,
  [12357] = 7508,
  [12358] = 7509,
  [12359] = 7510,
  [12360] = 7511,
  [12361] = 7512,
  [12362] = 7513,
  [12363] = 12269,
  [12364] = 7514,
  [12365] = 7515,
  [12366] = 12274,
  [12367] = 7516,
  [12368] = 7517,
  [12369] = 12245,
  [12370] = 6943,
  [12371] = 7272,
  [12372] = 7425,
  [12373] = 12269,
  [12374] = 12274,
  [12375] = 12245,
  [12376] = 12376,
  [12377] = 7321,
  [12378] = 7326,
  [12379] = 7329,
  [12380] = 12269,
  [12381] = 7332,
  [12382] = 12274,
  [12383] = 7428,
  [12384] = 7333,
  [12385] = 7334,
  [12386] = 7335,
  [12387] = 7336,
  [12388] = 7337,
  [12389] = 7338,
  [12390] = 7339,
  [12391] = 12245,
  [12392] = 7439,
  [12393] = 7440,
  [12394] = 7441,
  [12395] = 7442,
  [12396] = 7443,
  [12397] = 7340,
  [12398] = 7272,
  [12399] = 7425,
  [12400] = 12269,
  [12401] = 12274,
  [12402] = 7332,
  [12403] = 7428,
  [12404] = 7333,
  [12405] = 7334,
  [12406] = 7335,
  [12407] = 7336,
  [12408] = 12245,
  [12409] = 7337,
  [12410] = 7338,
  [12411] = 7339,
  [12412] = 7439,
  [12413] = 7440,
  [12414] = 7441,
  [12415] = 7442,
  [12416] = 7443,
  [12417] = 7340,
  [12418] = 12269,
  [12419] = 12274,
  [12420] = 12245,
  [12421] = 6943,
  [12422] = 7556,
  [12423] = 7344,
  [12424] = 7297,
  [12425] = 7344,
  [12426] = 12269,
  [12427] = 12274,
  [12428] = 12245,
  [12429] = 12245,
  [12430] = 11932,
  [12431] = 6943,
  [12432] = 6907,
  [12433] = 12269,
  [12434] = 12274,
  [12435] = 12245,
  [12436] = 12269,
  [12437] = 12274,
  [12438] = 12245,
  [12439] = 12269,
  [12440] = 12274,
  [12441] = 12245,
  [12442] = 12262,
  [12443] = 12269,
  [12444] = 12274,
  [12445] = 12245,
  [12446] = 12269,
  [12447] = 12274,
  [12448] = 6721,
  [12449] = 12245,
  [12450] = 12269,
  [12451] = 12269,
  [12452] = 12274,
  [12453] = 12245,
  [12454] = 12274,
  [12455] = 12269,
  [12456] = 12274,
  [12457] = 12245,
  [12458] = 12269,
  [12459] = 12274,
  [12460] = 7068,
  [12461] = 12245,
  [12462] = 7000,
  [12463] = 12269,
  [12464] = 12274,
  [12465] = 7282,
  [12466] = 12245,
  [12467] = 7394,
  [12468] = 12269,
  [12469] = 12274,
  [12470] = 12245,
  [12471] = 7032,
  [12472] = 6869,
  [12473] = 12245,
  [12474] = 12269,
  [12475] = 7304,
  [12476] = 12274,
  [12477] = 12269,
  [12478] = 12245,
  [12479] = 12269,
  [12480] = 7321,
  [12481] = 7268,
  [12482] = 7326,
  [12483] = 12274,
  [12484] = 7269,
  [12485] = 7329,
  [12486] = 6844,
  [12487] = 12245,
  [12488] = 7393,
  [12489] = 12269,
  [12490] = 7318,
  [12491] = 12274,
  [12492] = 7319,
  [12493] = 12245,
  [12494] = 7320,
  [12495] = 7268,
  [12496] = 7323,
  [12497] = 7324,
  [12498] = 7269,
  [12499] = 7328,
  [12500] = 12269,
  [12501] = 12274,
  [12502] = 6844,
  [12503] = 12262,
  [12504] = 12245,
  [12505] = 7331,
  [12506] = 12269,
  [12507] = 12274,
  [12508] = 12245,
  [12509] = 12269,
  [12510] = 12274,
  [12511] = 12269,
  [12512] = 12245,
  [12513] = 12269,
  [12514] = 12245,
  [12515] = 12274,
  [12516] = 12274,
  [12517] = 12245,
  [12518] = 7393,
  [12519] = 12269,
  [12520] = 7272,
  [12521] = 12274,
  [12522] = 7332,
  [12523] = 12245,
  [12524] = 7428,
  [12525] = 7333,
  [12526] = 7353,
  [12527] = 7334,
  [12528] = 7335,
  [12529] = 7336,
  [12530] = 12269,
  [12531] = 12274,
  [12532] = 7337,
  [12533] = 7338,
  [12534] = 12245,
  [12535] = 7339,
  [12536] = 7439,
  [12537] = 7440,
  [12538] = 7441,
  [12539] = 7442,
  [12540] = 7443,
  [12541] = 6869,
  [12542] = 12269,
  [12543] = 12274,
  [12544] = 12245,
  [12545] = 12245,
  [12546] = 11932,
  [12547] = 7362,
  [12548] = 7297,
  [12549] = 7367,
  [12550] = 7368,
  [12551] = 12269,
  [12552] = 7369,
  [12553] = 7370,
  [12554] = 7371,
  [12555] = 7297,
  [12556] = 12274,
  [12557] = 7372,
  [12558] = 7373,
  [12559] = 7375,
  [12560] = 12245,
  [12561] = 7377,
  [12562] = 7378,
  [12563] = 12269,
  [12564] = 12274,
  [12565] = 12245,
  [12566] = 7382,
  [12567] = 6673,
  [12568] = 12262,
  [12569] = 12245,
  [12570] = 12262,
  [12571] = 12245,
  [12572] = 12245,
  [12573] = 12245,
  [12574] = 12269,
  [12575] = 12245,
  [12576] = 12376,
  [12577] = 12274,
  [12578] = 12245,
  [12579] = 12262,
  [12580] = 12245,
  [12581] = 7282,
  [12582] = 12245,
  [12583] = 7425,
  [12584] = 12245,
  [12585] = 12245,
  [12586] = 11932,
  [12587] = 6943,
  [12588] = 12245,
  [12589] = 6907,
  [12590] = 12245,
  [12591] = 12245,
  [12592] = 12245,
  [12593] = 7394,
  [12594] = 12245,
  [12595] = 12262,
  [12596] = 12245,
  [12597] = 7397,
  [12598] = 12245,
  [12599] = 7282,
  [12600] = 12269,
  [12601] = 12245,
  [12602] = 12269,
  [12603] = 7399,
  [12604] = 7400,
  [12605] = 12245,
  [12606] = 7401,
  [12607] = 12274,
  [12608] = 12245,
  [12609] = 7402,
  [12610] = 7403,
  [12611] = 12245,
  [12612] = 7404,
  [12613] = 7406,
  [12614] = 7032,
  [12615] = 12274,
  [12616] = 7418,
  [12617] = 7419,
  [12618] = 7420,
  [12619] = 12245,
  [12620] = 7421,
  [12621] = 12245,
  [12622] = 6943,
  [12623] = 6907,
  [12624] = 7422,
  [12625] = 12245,
  [12626] = 7423,
  [12627] = 7445,
  [12628] = 7321,
  [12629] = 7268,
  [12630] = 7326,
  [12631] = 7269,
  [12632] = 7329,
  [12633] = 6844,
  [12634] = 7447,
  [12635] = 12245,
  [12636] = 12245,
  [12637] = 7344,
  [12638] = 12245,
  [12639] = 7463,
  [12640] = 12262,
  [12641] = 7464,
  [12642] = 12245,
  [12643] = 7468,
  [12644] = 12245,
  [12645] = 12245,
  [12646] = 12245,
  [12647] = 12245,
  [12648] = 12245,
  [12649] = 12245,
  [12650] = 12245,
  [12651] = 12245,
  [12652] = 12245,
  [12653] = 7469,
  [12654] = 12245,
  [12655] = 12245,
  [12656] = 12245,
  [12657] = 12245,
  [12658] = 12245,
  [12659] = 12245,
  [12660] = 12245,
  [12661] = 12245,
  [12662] = 12245,
  [12663] = 12245,
  [12664] = 12245,
  [12665] = 12245,
  [12666] = 12245,
  [12667] = 12269,
  [12668] = 12274,
  [12669] = 12274,
  [12670] = 7473,
  [12671] = 6869,
  [12672] = 7282,
  [12673] = 12245,
  [12674] = 7297,
  [12675] = 7475,
  [12676] = 7476,
  [12677] = 7477,
  [12678] = 7425,
  [12679] = 7478,
  [12680] = 7289,
  [12681] = 7480,
  [12682] = 7481,
  [12683] = 7483,
  [12684] = 7484,
  [12685] = 7485,
  [12686] = 7486,
  [12687] = 7487,
  [12688] = 12262,
  [12689] = 7488,
  [12690] = 7489,
  [12691] = 7490,
  [12692] = 7491,
  [12693] = 7032,
  [12694] = 6869,
  [12695] = 7493,
  [12696] = 12269,
  [12697] = 6869,
  [12698] = 7393,
  [12699] = 7032,
  [12700] = 7321,
  [12701] = 7326,
  [12702] = 7329,
  [12703] = 7321,
  [12704] = 7326,
  [12705] = 7329,
  [12706] = 6869,
  [12707] = 7344,
  [12708] = 7344,
  [12709] = 12274,
  [12710] = 7494,
  [12711] = 7495,
  [12712] = 7496,
  [12713] = 7497,
  [12714] = 7498,
  [12715] = 7297,
  [12716] = 7499,
  [12717] = 12245,
  [12718] = 7500,
  [12719] = 7501,
  [12720] = 6943,
  [12721] = 7502,
  [12722] = 6907,
  [12723] = 7503,
  [12724] = 7504,
  [12725] = 7506,
  [12726] = 7507,
  [12727] = 7508,
  [12728] = 7509,
  [12729] = 12245,
  [12730] = 12245,
  [12731] = 12245,
  [12732] = 12245,
  [12733] = 12245,
  [12734] = 12245,
  [12735] = 12245,
  [12736] = 12245,
  [12737] = 12245,
  [12738] = 12245,
  [12739] = 7510,
  [12740] = 12245,
  [12741] = 12245,
  [12742] = 12245,
  [12743] = 12245,
  [12744] = 12245,
  [12745] = 7511,
  [12746] = 7512,
  [12747] = 7513,
  [12748] = 7344,
  [12749] = 7514,
  [12750] = 7515,
  [12751] = 7516,
  [12752] = 7517,
  [12753] = 12262,
  [12754] = 12245,
  [12755] = 12245,
  [12756] = 12245,
  [12757] = 12245,
  [12758] = 12274,
  [12759] = 7344,
  [12760] = 12269,
  [12761] = 12245,
  [12762] = 12245,
  [12763] = 12245,
  [12764] = 12245,
  [12765] = 12274,
  [12766] = 12245,
  [12767] = 12245,
  [12768] = 12245,
  [12769] = 12245,
  [12770] = 6943,
  [12771] = 6907,
  [12772] = 12245,
  [12773] = 12245,
  [12774] = 12245,
  [12775] = 7321,
  [12776] = 7326,
  [12777] = 7329,
  [12778] = 12245,
  [12779] = 12245,
  [12780] = 12245,
  [12781] = 7304,
  [12782] = 12245,
  [12783] = 12245,
  [12784] = 12245,
  [12785] = 12245,
  [12786] = 12262,
  [12787] = 12245,
  [12788] = 7318,
  [12789] = 7319,
  [12790] = 12245,
  [12791] = 12245,
  [12792] = 7272,
  [12793] = 7320,
  [12794] = 7268,
  [12795] = 7323,
  [12796] = 7324,
  [12797] = 7556,
  [12798] = 7269,
  [12799] = 7328,
  [12800] = 7282,
  [12801] = 6844,
  [12802] = 12269,
  [12803] = 6869,
  [12804] = 7331,
  [12805] = 12245,
  [12806] = 12274,
  [12807] = 12262,
  [12808] = 6721,
  [12809] = 7282,
  [12810] = 12245,
  [12811] = 7272,
  [12812] = 7282,
  [12813] = 7032,
  [12814] = 6943,
  [12815] = 6907,
  [12816] = 6174,
  [12817] = 7321,
  [12818] = 7326,
  [12819] = 7329,
  [12820] = 7340,
  [12821] = 7353,
  [12822] = 7282,
  [12823] = 7032,
  [12824] = 7282,
  [12825] = 7032,
  [12826] = 12262,
  [12827] = 7032,
  [12828] = 7272,
  [12829] = 7272,
  [12830] = 7272,
  [12831] = 7268,
  [12832] = 7269,
  [12833] = 6844,
  [12834] = 7268,
  [12835] = 7269,
  [12836] = 6844,
  [12837] = 7268,
  [12838] = 7269,
  [12839] = 6844,
  [12840] = 12245,
  [12841] = 12245,
  [12842] = 12245,
  [12843] = 6979,
  [12844] = 12262,
  [12845] = 6990,
  [12846] = 6861,
  [12847] = 6862,
  [12848] = 6898,
  [12849] = 12245,
  [12850] = 12245,
  [12851] = 12262,
  [12852] = 12245,
  [12853] = 12262,
  [12854] = 7394,
  [12855] = 12245,
  [12856] = 12245,
  [12857] = 6979,
  [12858] = 12262,
  [12859] = 6990,
  [12860] = 6861,
  [12861] = 6862,
  [12862] = 6898,
  [12863] = 12245,
  [12864] = 12245,
  [12865] = 6979,
  [12866] = 12262,
  [12867] = 6990,
  [12868] = 6861,
  [12869] = 6862,
  [12870] = 6898,
  [12871] = 12245,
  [12872] = 12245,
  [12873] = 12262,
  [12874] = 7394,
  [12875] = 12245,
  [12876] = 12245,
  [12877] = 12245,
  [12878] = 12245,
  [12879] = 12245,
  [12880] = 12245,
  [12881] = 12245,
  [12882] = 6783,
  [12883] = 6752,
  [12884] = 6753,
  [12885] = 6673,
  [12886] = 6783,
  [12887] = 6752,
  [12888] = 6753,
  [12889] = 6673,
  [12890] = 6721,
  [12891] = 7067,
  [12892] = 7070,
  [12893] = 6174,
  [12894] = 6174,
  [12895] = 6174,
  [12896] = 7067,
  [12897] = 7070,
  [12898] = 7067,
  [12899] = 7070,
  [12900] = 7340,
  [12901] = 12269,
  [12902] = 6174,
  [12903] = 6174,
  [12904] = 7404,
  [12905] = 7032,
  [12906] = 7340,
  [12907] = 7297,
  [12908] = 7068,
  [12909] = 6869,
  [12910] = 7321,
  [12911] = 7326,
  [12912] = 7329,
  [12913] = 9243,
  [12914] = 7338,
  [12915] = 6174,
  [12916] = 7272,
  [12917] = 12917,
  [12918] = 7339,
  [12919] = 7393,
  [12920] = 9204,
  [12921] = 9204,
  [12922] = 7321,
  [12923] = 7268,
  [12924] = 7326,
  [12925] = 7269,
  [12926] = 7329,
  [12927] = 6844,
  [12928] = 6943,
  [12929] = 7000,
  [12930] = 7393,
  [12931] = 7068,
  [12932] = 7439,
  [12933] = 12933,
  [12934] = 7440,
  [12935] = 12935,
  [12936] = 6943,
  [12937] = 7441,
  [12938] = 6869,
  [12939] = 7070,
  [12940] = 12933,
  [12941] = 7000,
  [12942] = 7282,
  [12943] = 7340,
  [12944] = 7297,
  [12945] = 7332,
  [12946] = 6861,
  [12947] = 6862,
  [12948] = 11932,
  [12949] = 7068,
  [12950] = 6943,
  [12951] = 6898,
  [12952] = 7428,
  [12953] = 6907,
  [12954] = 7333,
  [12955] = 7334,
  [12956] = 7335,
  [12957] = 7272,
  [12958] = 7297,
  [12959] = 7032,
  [12960] = 7393,
  [12961] = 7332,
  [12962] = 7428,
  [12963] = 7000,
  [12964] = 7336,
  [12965] = 7337,
  [12966] = 8318,
  [12967] = 7321,
  [12968] = 7326,
  [12969] = 7329,
  [12970] = 7425,
  [12971] = 7333,
  [12972] = 7334,
  [12973] = 8319,
  [12974] = 7282,
  [12975] = 7335,
  [12976] = 12376,
  [12977] = 6869,
  [12978] = 7336,
  [12979] = 7337,
  [12980] = 7338,
  [12981] = 7339,
  [12982] = 7344,
  [12983] = 7439,
  [12984] = 7440,
  [12985] = 7441,
  [12986] = 7442,
  [12987] = 7443,
  [12988] = 7272,
  [12989] = 7000,
  [12990] = 7068,
  [12991] = 7344,
  [12992] = 7442,
  [12993] = 6979,
  [12994] = 6943,
  [12995] = 7443,
  [12996] = 7425,
  [12997] = 7282,
  [12998] = 7032,
  [12999] = 6943,
  [13000] = 6907,
  [13001] = 6979,
  [13002] = 7425,
  [13003] = 6990,
  [13004] = 7282,
  [13005] = 6861,
  [13006] = 6862,
  [13007] = 6898,
  [13008] = 7344,
  [13009] = 13009,
  [13010] = 7032,
  [13011] = 7268,
  [13012] = 7269,
  [13013] = 6844,
  [13014] = 7282,
  [13015] = 7032,
  [13016] = 12376,
  [13017] = 7340,
  [13018] = 6907,
  [13019] = 6869,
  [13020] = 7067,
  [13021] = 7332,
  [13022] = 7297,
  [13023] = 7321,
  [13024] = 7272,
  [13025] = 7428,
  [13026] = 7268,
  [13027] = 7333,
  [13028] = 7334,
  [13029] = 7326,
  [13030] = 7335,
  [13031] = 7336,
  [13032] = 7282,
  [13033] = 7032,
  [13034] = 7337,
  [13035] = 7338,
  [13036] = 7339,
  [13037] = 7439,
  [13038] = 7440,
  [13039] = 7282,
  [13040] = 7032,
  [13041] = 7441,
  [13042] = 7442,
  [13043] = 7272,
  [13044] = 7269,
  [13045] = 7321,
  [13046] = 7443,
  [13047] = 7393,
  [13048] = 7326,
  [13049] = 7329,
  [13050] = 7272,
  [13051] = 6869,
  [13052] = 7393,
  [13053] = 6844,
  [13054] = 6844,
  [13055] = 7282,
  [13056] = 7329,
  [13057] = 7268,
  [13058] = 7269,
  [13059] = 6844,
  [13060] = 6907,
  [13061] = 7272,
  [13062] = 7268,
  [13063] = 7269,
  [13064] = 6844,
  [13065] = 7272,
  [13066] = 6869,
  [13067] = 7393,
  [13068] = 7393,
  [13069] = 7332,
  [13070] = 6869,
  [13071] = 7272,
  [13072] = 7340,
  [13073] = 7428,
  [13074] = 6869,
  [13075] = 6990,
  [13076] = 12376,
  [13077] = 6943,
  [13078] = 6907,
  [13079] = 7333,
  [13080] = 6943,
  [13081] = 7334,
  [13082] = 7335,
  [13083] = 7336,
  [13084] = 7032,
  [13085] = 7394,
  [13086] = 7337,
  [13087] = 6943,
  [13088] = 6907,
  [13089] = 7338,
  [13090] = 8318,
  [13091] = 8319,
  [13092] = 7344,
  [13093] = 7339,
  [13094] = 7439,
  [13095] = 6869,
  [13096] = 6943,
  [13097] = 7440,
  [13098] = 7441,
  [13099] = 7297,
  [13100] = 7394,
  [13101] = 7332,
  [13102] = 7428,
  [13103] = 7333,
  [13104] = 11932,
  [13105] = 7334,
  [13106] = 7335,
  [13107] = 7272,
  [13108] = 7336,
  [13109] = 7337,
  [13110] = 7338,
  [13111] = 7332,
  [13112] = 7428,
  [13113] = 7394,
  [13114] = 7339,
  [13115] = 7439,
  [13116] = 7440,
  [13117] = 7441,
  [13118] = 7333,
  [13119] = 7442,
  [13120] = 7443,
  [13121] = 7334,
  [13122] = 7335,
  [13123] = 7340,
  [13124] = 7344,
  [13125] = 7332,
  [13126] = 7428,
  [13127] = 7333,
  [13128] = 7334,
  [13129] = 7335,
  [13130] = 7336,
  [13131] = 7268,
  [13132] = 7269,
  [13133] = 6844,
  [13134] = 7067,
  [13135] = 7070,
  [13136] = 7337,
  [13137] = 7338,
  [13138] = 7339,
  [13139] = 7439,
  [13140] = 7067,
  [13141] = 7070,
  [13142] = 7440,
  [13143] = 7441,
  [13144] = 7442,
  [13145] = 6979,
  [13146] = 7443,
  [13147] = 6990,
  [13148] = 6861,
  [13149] = 6862,
  [13150] = 6898,
  [13151] = 7340,
  [13152] = 6174,
  [13153] = 7344,
  [13154] = 6943,
  [13155] = 7336,
  [13156] = 7340,
  [13157] = 6174,
  [13158] = 7337,
  [13159] = 7338,
  [13160] = 7442,
  [13161] = 9243,
  [13162] = 7443,
  [13163] = 7321,
  [13164] = 7339,
  [13165] = 7439,
  [13166] = 7440,
  [13167] = 7268,
  [13168] = 7326,
  [13169] = 7441,
  [13170] = 7442,
  [13171] = 7443,
  [13172] = 8318,
  [13173] = 8319,
  [13174] = 7297,
  [13175] = 7269,
  [13176] = 7329,
  [13177] = 6869,
  [13178] = 7333,
  [13179] = 8318,
  [13180] = 7329,
  [13181] = 7340,
  [13182] = 6907,
  [13183] = 12376,
  [13184] = 7272,
  [13185] = 7425,
  [13186] = 7334,
  [13187] = 7335,
  [13188] = 7336,
  [13189] = 7337,
  [13190] = 7338,
  [13191] = 7339,
  [13192] = 7332,
  [13193] = 7442,
  [13194] = 7428,
  [13195] = 7333,
  [13196] = 7334,
  [13197] = 7425,
  [13198] = 7443,
  [13199] = 7428,
  [13200] = 7333,
  [13201] = 7068,
  [13202] = 7335,
  [13203] = 7336,
  [13204] = 7272,
  [13205] = 7337,
  [13206] = 7000,
  [13207] = 7332,
  [13208] = 7297,
  [13209] = 7338,
  [13210] = 7428,
  [13211] = 7333,
  [13212] = 7339,
  [13213] = 7344,
  [13214] = 8936,
  [13215] = 7439,
  [13216] = 7321,
  [13217] = 7326,
  [13218] = 7329,
  [13219] = 7344,
  [13220] = 7340,
  [13221] = 7272,
  [13222] = 7440,
  [13223] = 6869,
  [13224] = 7393,
  [13225] = 7393,
  [13226] = 7441,
  [13227] = 7442,
  [13228] = 7425,
  [13229] = 6943,
  [13230] = 7443,
  [13231] = 7340,
  [13232] = 7332,
  [13233] = 7334,
  [13234] = 7282,
  [13235] = 8318,
  [13236] = 7282,
  [13237] = 6869,
  [13238] = 7297,
  [13239] = 7340,
  [13240] = 7428,
  [13241] = 7333,
  [13242] = 7334,
  [13243] = 7393,
  [13244] = 6869,
  [13245] = 7335,
  [13246] = 7336,
  [13247] = 7337,
  [13248] = 12376,
  [13249] = 7032,
  [13250] = 7338,
  [13251] = 7297,
  [13252] = 7339,
  [13253] = 7439,
  [13254] = 7440,
  [13255] = 7344,
  [13256] = 7340,
  [13257] = 7272,
  [13258] = 8936,
  [13259] = 7272,
  [13260] = 7425,
  [13261] = 7441,
  [13262] = 7332,
  [13263] = 7442,
  [13264] = 7321,
  [13265] = 13265,
  [13266] = 7268,
  [13267] = 7443,
  [13268] = 7326,
  [13269] = 7335,
  [13270] = 7428,
  [13271] = 7333,
  [13272] = 7269,
  [13273] = 7336,
  [13274] = 7344,
  [13275] = 7334,
  [13276] = 7337,
  [13277] = 7338,
  [13278] = 7329,
  [13279] = 7335,
  [13280] = 6844,
  [13281] = 7393,
  [13282] = 7297,
  [13283] = 7336,
  [13284] = 7337,
  [13285] = 7338,
  [13286] = 7339,
  [13287] = 7032,
  [13288] = 7339,
  [13289] = 7439,
  [13290] = 8318,
  [13291] = 8319,
  [13292] = 7340,
  [13293] = 7440,
  [13294] = 7439,
  [13295] = 6943,
  [13296] = 7441,
  [13297] = 7442,
  [13298] = 7443,
  [13299] = 7394,
  [13300] = 7332,
  [13301] = 7440,
  [13302] = 7340,
  [13303] = 7441,
  [13304] = 8318,
  [13305] = 7329,
  [13306] = 8319,
  [13307] = 7442,
  [13308] = 7443,
  [13309] = 7326,
  [13310] = 7428,
  [13311] = 6844,
  [13312] = 7333,
  [13313] = 7321,
  [13314] = 7282,
  [13315] = 7334,
  [13316] = 7334,
  [13317] = 7321,
  [13318] = 7268,
  [13319] = 7326,
  [13320] = 7335,
  [13321] = 7269,
  [13322] = 7329,
  [13323] = 6844,
  [13324] = 7394,
  [13325] = 7393,
  [13326] = 7336,
  [13327] = 7337,
  [13328] = 13009,
  [13329] = 7332,
  [13330] = 7428,
  [13331] = 7338,
  [13332] = 7335,
  [13333] = 6943,
  [13334] = 7393,
  [13335] = 7394,
  [13336] = 7282,
  [13337] = 7339,
  [13338] = 7393,
  [13339] = 7439,
  [13340] = 7282,
  [13341] = 7440,
  [13342] = 7297,
  [13343] = 6907,
  [13344] = 7441,
  [13345] = 7272,
  [13346] = 7268,
  [13347] = 7442,
  [13348] = 7443,
  [13349] = 7336,
  [13350] = 7337,
  [13351] = 7338,
  [13352] = 7340,
  [13353] = 7339,
  [13354] = 7032,
  [13355] = 7393,
  [13356] = 7272,
  [13357] = 7272,
  [13358] = 7282,
  [13359] = 7032,
  [13360] = 7282,
  [13361] = 7032,
  [13362] = 7340,
  [13363] = 7439,
  [13364] = 7297,
  [13365] = 8936,
  [13366] = 7032,
  [13367] = 7068,
  [13368] = 7440,
  [13369] = 7321,
  [13370] = 7326,
  [13371] = 7329,
  [13372] = 7321,
  [13373] = 7326,
  [13374] = 7329,
  [13375] = 7268,
  [13376] = 7269,
  [13377] = 6844,
  [13378] = 7268,
  [13379] = 7269,
  [13380] = 6844,
  [13381] = 7000,
  [13382] = 7332,
  [13383] = 7428,
  [13384] = 7333,
  [13385] = 7334,
  [13386] = 7335,
  [13387] = 7336,
  [13388] = 7337,
  [13389] = 7338,
  [13390] = 7339,
  [13391] = 7439,
  [13392] = 7440,
  [13393] = 7441,
  [13394] = 7442,
  [13395] = 7443,
  [13396] = 7333,
  [13397] = 7344,
  [13398] = 7428,
  [13399] = 7439,
  [13400] = 7440,
  [13401] = 7441,
  [13402] = 7442,
  [13403] = 7443,
  [13404] = 7032,
  [13405] = 7344,
  [13406] = 7334,
  [13407] = 7335,
  [13408] = 7336,
  [13409] = 7321,
  [13410] = 7344,
  [13411] = 6869,
  [13412] = 7268,
  [13413] = 6869,
  [13414] = 6869,
  [13415] = 7326,
  [13416] = 7269,
  [13417] = 7329,
  [13418] = 6844,
  [13419] = 7326,
  [13420] = 7337,
  [13421] = 7269,
  [13422] = 13009,
  [13423] = 7338,
  [13424] = 7339,
  [13425] = 7439,
  [13426] = 7440,
  [13427] = 7441,
  [13428] = 7393,
  [13429] = 7442,
  [13430] = 7443,
  [13431] = 7441,
  [13432] = 6943,
  [13433] = 7344,
  [13434] = 7321,
  [13435] = 7332,
  [13436] = 7332,
  [13437] = 7339,
  [13438] = 7329,
  [13439] = 7428,
  [13440] = 7332,
  [13441] = 7326,
  [13442] = 7425,
  [13443] = 7329,
  [13444] = 7439,
  [13445] = 7428,
  [13446] = 7440,
  [13447] = 7441,
  [13448] = 7333,
  [13449] = 7442,
  [13450] = 7443,
  [13451] = 7334,
  [13452] = 7335,
  [13453] = 7336,
  [13454] = 7337,
  [13455] = 7338,
  [13456] = 7339,
  [13457] = 6869,
  [13458] = 7439,
  [13459] = 7440,
  [13460] = 7441,
  [13461] = 7425,
  [13462] = 7393,
  [13463] = 7442,
  [13464] = 7443,
  [13465] = 7393,
  [13466] = 7338,
  [13467] = 7340,
  [13468] = 7339,
  [13469] = 7439,
  [13470] = 7393,
  [13471] = 6869,
  [13472] = 8936,
  [13473] = 7344,
  [13474] = 13474,
  [13475] = 7440,
  [13476] = 7344,
  [13477] = 7282,
  [13478] = 7340,
  [13479] = 7272,
  [13480] = 7393,
  [13481] = 7332,
  [13482] = 7282,
  [13483] = 7032,
  [13484] = 7428,
  [13485] = 6943,
  [13486] = 6907,
  [13487] = 7332,
  [13488] = 7321,
  [13489] = 7428,
  [13490] = 7333,
  [13491] = 7334,
  [13492] = 7272,
  [13493] = 7335,
  [13494] = 7336,
  [13495] = 7337,
  [13496] = 7326,
  [13497] = 7329,
  [13498] = 7344,
  [13499] = 7068,
  [13500] = 7333,
  [13501] = 7334,
  [13502] = 7335,
  [13503] = 7338,
  [13504] = 7268,
  [13505] = 7269,
  [13506] = 6844,
  [13507] = 8936,
  [13508] = 6869,
  [13509] = 7339,
  [13510] = 7344,
  [13511] = 7439,
  [13512] = 7332,
  [13513] = 7333,
  [13514] = 7334,
  [13515] = 6869,
  [13516] = 7000,
  [13517] = 7441,
  [13518] = 7442,
  [13519] = 7442,
  [13520] = 7340,
  [13521] = 7336,
  [13522] = 7337,
  [13523] = 7338,
  [13524] = 7269,
  [13525] = 7321,
  [13526] = 7335,
  [13527] = 7336,
  [13528] = 7440,
  [13529] = 7441,
  [13530] = 7442,
  [13531] = 7443,
  [13532] = 7332,
  [13533] = 7428,
  [13534] = 7337,
  [13535] = 7338,
  [13536] = 7443,
  [13537] = 7339,
  [13538] = 7440,
  [13539] = 7393,
  [13540] = 6943,
  [13541] = 6907,
  [13542] = 7441,
  [13543] = 7442,
  [13544] = 7032,
  [13545] = 7333,
  [13546] = 9160,
  [13547] = 7272,
  [13548] = 7393,
  [13549] = 7443,
  [13550] = 6844,
  [13551] = 7321,
  [13552] = 7326,
  [13553] = 7340,
  [13554] = 13554,
  [13555] = 7332,
  [13556] = 7428,
  [13557] = 7333,
  [13558] = 7334,
  [13559] = 7335,
  [13560] = 7336,
  [13561] = 7337,
  [13562] = 7338,
  [13563] = 7339,
  [13564] = 7439,
  [13565] = 7440,
  [13566] = 7441,
  [13567] = 7442,
  [13568] = 7443,
  [13569] = 7332,
  [13570] = 7340,
  [13571] = 7428,
  [13572] = 7032,
  [13573] = 7340,
  [13574] = 7333,
  [13575] = 7340,
  [13576] = 7334,
  [13577] = 7335,
  [13578] = 7441,
  [13579] = 7297,
  [13580] = 7443,
  [13581] = 7321,
  [13582] = 7268,
  [13583] = 7326,
  [13584] = 7269,
  [13585] = 7334,
  [13586] = 7335,
  [13587] = 7336,
  [13588] = 7337,
  [13589] = 7329,
  [13590] = 6844,
  [13591] = 7338,
  [13592] = 6943,
  [13593] = 7339,
  [13594] = 7439,
  [13595] = 7440,
  [13596] = 7393,
  [13597] = 7336,
  [13598] = 7297,
  [13599] = 7282,
  [13600] = 7337,
  [13601] = 7268,
  [13602] = 7439,
  [13603] = 13603,
  [13604] = 6907,
  [13605] = 13605,
  [13606] = 6943,
  [13607] = 6907,
  [13608] = 13603,
  [13609] = 13603,
  [13610] = 9160,
  [13611] = 13605,
  [13612] = 6907,
  [13613] = 13605,
  [13614] = 6943,
  [13615] = 13605,
  [13616] = 13616,
  [13617] = 13617,
  [13618] = 13605,
  [13619] = 13617,
  [13620] = 6943,
  [13621] = 6907,
  [13622] = 6943,
  [13623] = 7268,
  [13624] = 6907,
  [13625] = 7269,
  [13626] = 6844,
  [13627] = 13605,
  [13628] = 13605,
  [13629] = 13603,
  [13630] = 6943,
  [13631] = 6907,
  [13632] = 6943,
  [13633] = 6907,
  [13634] = 13603,
  [13635] = 13603,
  [13636] = 13617,
  [13637] = 13617,
  [13638] = 6943,
  [13639] = 6907,
  [13640] = 13605,
  [13641] = 6943,
  [13642] = 6907,
  [13643] = 13605,
  [13644] = 13603,
  [13645] = 13603,
  [13646] = 6907,
  [13647] = 13603,
  [13648] = 13617,
  [13649] = 13617,
  [13650] = 13605,
  [13651] = 7297,
  [13652] = 13605,
  [13653] = 13605,
  [13654] = 13603,
  [13655] = 13603,
  [13656] = 13617,
  [13657] = 7332,
  [13658] = 6943,
  [13659] = 13605,
  [13660] = 7428,
  [13661] = 13605,
  [13662] = 7333,
  [13663] = 13603,
  [13664] = 6943,
  [13665] = 6907,
  [13666] = 13617,
  [13667] = 13617,
  [13668] = 7334,
  [13669] = 7335,
  [13670] = 7340,
  [13671] = 6907,
  [13672] = 7332,
  [13673] = 7425,
  [13674] = 13617,
  [13675] = 13605,
  [13676] = 6943,
  [13677] = 7428,
  [13678] = 6907,
  [13679] = 7333,
  [13680] = 7336,
  [13681] = 13603,
  [13682] = 7334,
  [13683] = 7335,
  [13684] = 13617,
  [13685] = 7336,
  [13686] = 7337,
  [13687] = 7338,
  [13688] = 7339,
  [13689] = 7439,
  [13690] = 13690,
  [13691] = 7337,
  [13692] = 7440,
  [13693] = 7338,
  [13694] = 7441,
  [13695] = 7442,
  [13696] = 7443,
  [13697] = 13605,
  [13698] = 13603,
  [13699] = 13603,
  [13700] = 13617,
  [13701] = 7340,
  [13702] = 13605,
  [13703] = 13605,
  [13704] = 7339,
  [13705] = 13603,
  [13706] = 13617,
  [13707] = 7439,
  [13708] = 13617,
  [13709] = 6943,
  [13710] = 6907,
  [13711] = 7440,
  [13712] = 13605,
  [13713] = 13605,
  [13714] = 7441,
  [13715] = 7442,
  [13716] = 6943,
  [13717] = 6907,
  [13718] = 13605,
  [13719] = 6943,
  [13720] = 6907,
  [13721] = 13605,
  [13722] = 13616,
  [13723] = 13603,
  [13724] = 13603,
  [13725] = 7443,
  [13726] = 13603,
  [13727] = 13603,
  [13728] = 13617,
  [13729] = 13617,
  [13730] = 13603,
  [13731] = 13605,
  [13732] = 6943,
  [13733] = 6907,
  [13734] = 13617,
  [13735] = 13605,
  [13736] = 6943,
  [13737] = 13603,
  [13738] = 6907,
  [13739] = 13616,
  [13740] = 7344,
  [13741] = 6943,
  [13742] = 13603,
  [13743] = 13603,
  [13744] = 13617,
  [13745] = 6907,
  [13746] = 13603,
  [13747] = 13747,
  [13748] = 13605,
  [13749] = 13617,
  [13750] = 7032,
  [13751] = 6943,
  [13752] = 13605,
  [13753] = 6907,
  [13754] = 6943,
  [13755] = 13603,
  [13756] = 13605,
  [13757] = 7272,
  [13758] = 7321,
  [13759] = 7326,
  [13760] = 7329,
  [13761] = 7393,
  [13762] = 13603,
  [13763] = 6943,
  [13764] = 6907,
  [13765] = 13603,
  [13766] = 13617,
  [13767] = 13617,
  [13768] = 13605,
  [13769] = 13617,
  [13770] = 13617,
  [13771] = 7344,
  [13772] = 13772,
  [13773] = 7321,
  [13774] = 7326,
  [13775] = 7329,
  [13776] = 7340,
  [13777] = 13605,
  [13778] = 6943,
  [13779] = 6907,
  [13780] = 13605,
  [13781] = 7297,
  [13782] = 13617,
  [13783] = 6943,
  [13784] = 13603,
  [13785] = 6907,
  [13786] = 13603,
  [13787] = 6943,
  [13788] = 13617,
  [13789] = 13617,
  [13790] = 7428,
  [13791] = 7439,
  [13792] = 7440,
  [13793] = 7441,
  [13794] = 7442,
  [13795] = 7443,
  [13796] = 6907,
  [13797] = 13603,
  [13798] = 6907,
  [13799] = 7393,
  [13800] = 13605,
  [13801] = 13605,
  [13802] = 13603,
  [13803] = 13605,
  [13804] = 13617,
  [13805] = 13805,
  [13806] = 13605,
  [13807] = 6869,
  [13808] = 6943,
  [13809] = 6907,
  [13810] = 7282,
  [13811] = 6943,
  [13812] = 6907,
  [13813] = 7032,
  [13814] = 13603,
  [13815] = 13605,
  [13816] = 13617,
  [13817] = 6943,
  [13818] = 6907,
  [13819] = 13617,
  [13820] = 6943,
  [13821] = 7340,
  [13822] = 13605,
  [13823] = 13603,
  [13824] = 13617,
  [13825] = 13617,
  [13826] = 13605,
  [13827] = 13603,
  [13828] = 13603,
  [13829] = 13747,
  [13830] = 13617,
  [13831] = 13617,
  [13832] = 13605,
  [13833] = 13747,
  [13834] = 13603,
  [13835] = 13617,
  [13836] = 13617,
  [13837] = 13603,
  [13838] = 13605,
  [13839] = 6943,
  [13840] = 13603,
  [13841] = 13617,
  [13842] = 6907,
  [13843] = 13605,
  [13844] = 13603,
  [13845] = 6943,
  [13846] = 13617,
  [13847] = 6943,
  [13848] = 6943,
  [13849] = 13605,
  [13850] = 6907,
  [13851] = 6907,
  [13852] = 13603,
  [13853] = 13603,
  [13854] = 13605,
  [13855] = 13605,
  [13856] = 13617,
  [13857] = 13617,
  [13858] = 6943,
  [13859] = 6907,
  [13860] = 13603,
  [13861] = 13605,
  [13862] = 13617,
  [13863] = 13603,
  [13864] = 13603,
  [13865] = 13617,
  [13866] = 6943,
  [13867] = 13605,
  [13868] = 13617,
  [13869] = 6907,
  [13870] = 13605,
  [13871] = 9160,
  [13872] = 13617,
  [13873] = 7282,
  [13874] = 7032,
  [13875] = 13605,
  [13876] = 6943,
  [13877] = 6907,
  [13878] = 13617,
  [13879] = 13603,
  [13880] = 6943,
  [13881] = 13881,
  [13882] = 13617,
  [13883] = 13605,
  [13884] = 6943,
  [13885] = 13605,
  [13886] = 6907,
  [13887] = 6943,
  [13888] = 6907,
  [13889] = 13603,
  [13890] = 13617,
  [13891] = 13605,
  [13892] = 6943,
  [13893] = 13603,
  [13894] = 13603,
  [13895] = 7393,
  [13896] = 13617,
  [13897] = 13603,
  [13898] = 13605,
  [13899] = 13603,
  [13900] = 13603,
  [13901] = 13617,
  [13902] = 13605,
  [13903] = 9160,
  [13904] = 13603,
  [13905] = 6943,
  [13906] = 13605,
  [13907] = 6907,
  [13908] = 13617,
  [13909] = 13605,
  [13910] = 13617,
  [13911] = 13603,
  [13912] = 6907,
  [13913] = 13605,
  [13914] = 13617,
  [13915] = 13915,
  [13916] = 13605,
  [13917] = 13603,
  [13918] = 13603,
  [13919] = 13605,
  [13920] = 7282,
  [13921] = 13603,
  [13922] = 13617,
  [13923] = 13605,
  [13924] = 13605,
  [13925] = 13603,
  [13926] = 13605,
  [13927] = 6943,
  [13928] = 13603,
  [13929] = 6907,
  [13930] = 13605,
  [13931] = 13617,
  [13932] = 7393,
  [13933] = 13605,
  [13934] = 13603,
  [13935] = 7332,
  [13936] = 13603,
  [13937] = 7428,
  [13938] = 6943,
  [13939] = 7333,
  [13940] = 6907,
  [13941] = 7334,
  [13942] = 7335,
  [13943] = 13605,
  [13944] = 13617,
  [13945] = 7336,
  [13946] = 7337,
  [13947] = 7338,
  [13948] = 7339,
  [13949] = 13603,
  [13950] = 7439,
  [13951] = 13617,
  [13952] = 7440,
  [13953] = 7441,
  [13954] = 13605,
  [13955] = 7442,
  [13956] = 13603,
  [13957] = 7443,
  [13958] = 13605,
  [13959] = 6943,
  [13960] = 6907,
  [13961] = 13605,
  [13962] = 13603,
  [13963] = 13603,
  [13964] = 13605,
  [13965] = 9160,
  [13966] = 6943,
  [13967] = 13603,
  [13968] = 13605,
  [13969] = 13603,
  [13970] = 13605,
  [13971] = 13603,
  [13972] = 6943,
  [13973] = 6907,
  [13974] = 13603,
  [13975] = 7272,
  [13976] = 6943,
  [13977] = 13603,
  [13978] = 13617,
  [13979] = 13603,
  [13980] = 13617,
  [13981] = 13605,
  [13982] = 6907,
  [13983] = 6943,
  [13984] = 13617,
  [13985] = 7332,
  [13986] = 7333,
  [13987] = 7334,
  [13988] = 7335,
  [13989] = 7336,
  [13990] = 7337,
  [13991] = 7338,
  [13992] = 7339,
  [13993] = 6943,
  [13994] = 13994,
  [13995] = 13995,
  [13996] = 8319,
  [13997] = 13995,
  [13998] = 7297,
  [13999] = 7393,
  [14000] = 7297,
  [14001] = 7297,
  [14002] = 14002,
  [14003] = 14002,
  [14004] = 7297,
  [14005] = 13995,
  [14006] = 14002,
  [14007] = 7297,
  [14008] = 13994,
  [14009] = 7297,
  [14010] = 14010,
  [14011] = 13995,
  [14012] = 14010,
  [14013] = 7297,
  [14014] = 13995,
  [14015] = 7297,
  [14016] = 13995,
  [14017] = 7297,
  [14018] = 7297,
  [14019] = 13995,
  [14020] = 7297,
  [14021] = 7297,
  [14022] = 14002,
  [14023] = 13995,
  [14024] = 14010,
  [14025] = 7297,
  [14026] = 13995,
  [14027] = 13995,
  [14028] = 13994,
  [14029] = 13994,
  [14030] = 14010,
  [14031] = 13995,
  [14032] = 7297,
  [14033] = 7297,
  [14034] = 13995,
  [14035] = 13995,
  [14036] = 13995,
  [14037] = 13995,
  [14038] = 13995,
  [14039] = 14002,
  [14040] = 13995,
  [14041] = 13995,
  [14042] = 13995,
  [14043] = 13995,
  [14044] = 14010,
  [14045] = 6869,
  [14046] = 7332,
  [14047] = 7428,
  [14048] = 7333,
  [14049] = 7334,
  [14050] = 7335,
  [14051] = 7336,
  [14052] = 7337,
  [14053] = 14002,
  [14054] = 7338,
  [14055] = 7339,
  [14056] = 13994,
  [14057] = 7439,
  [14058] = 7440,
  [14059] = 14010,
  [14060] = 7441,
  [14061] = 7442,
  [14062] = 7443,
  [14063] = 7297,
  [14064] = 7297,
  [14065] = 7297,
  [14066] = 7297,
  [14067] = 7297,
  [14068] = 14002,
  [14069] = 7297,
  [14070] = 14002,
  [14071] = 7297,
  [14072] = 7297,
  [14073] = 7297,
  [14074] = 14010,
  [14075] = 7297,
  [14076] = 7297,
  [14077] = 7297,
  [14078] = 13994,
  [14079] = 14010,
  [14080] = 14002,
  [14081] = 13994,
  [14082] = 13772,
  [14083] = 14010,
  [14084] = 7297,
  [14085] = 13994,
  [14086] = 14010,
  [14087] = 7297,
  [14088] = 13995,
  [14089] = 13994,
  [14090] = 7297,
  [14091] = 14002,
  [14092] = 14010,
  [14093] = 13994,
  [14094] = 7340,
  [14095] = 14010,
  [14096] = 14002,
  [14097] = 7297,
  [14098] = 13994,
  [14099] = 14002,
  [14100] = 7297,
  [14101] = 14010,
  [14102] = 13994,
  [14103] = 7297,
  [14104] = 14010,
  [14105] = 14002,
  [14106] = 14002,
  [14107] = 13994,
  [14108] = 13994,
  [14109] = 14010,
  [14110] = 14010,
  [14111] = 14002,
  [14112] = 13994,
  [14113] = 14002,
  [14114] = 13994,
  [14115] = 14002,
  [14116] = 13994,
  [14117] = 14010,
  [14118] = 14002,
  [14119] = 14010,
  [14120] = 13994,
  [14121] = 14010,
  [14122] = 7297,
  [14123] = 14002,
  [14124] = 13915,
  [14125] = 13995,
  [14126] = 7297,
  [14127] = 7297,
  [14128] = 13994,
  [14129] = 14010,
  [14130] = 7297,
  [14131] = 7297,
  [14132] = 7297,
  [14133] = 7297,
  [14134] = 14134,
  [14135] = 7297,
  [14136] = 7297,
  [14137] = 14002,
  [14138] = 6869,
  [14139] = 7297,
  [14140] = 8318,
  [14141] = 13994,
  [14142] = 7393,
  [14143] = 7338,
  [14144] = 13915,
  [14145] = 7440,
  [14146] = 7428,
  [14147] = 7332,
  [14148] = 7428,
  [14149] = 7333,
  [14150] = 7333,
  [14151] = 7340,
  [14152] = 7440,
  [14153] = 7441,
  [14154] = 7442,
  [14155] = 7334,
  [14156] = 14156,
  [14157] = 7439,
  [14158] = 7339,
  [14159] = 7335,
  [14160] = 7334,
  [14161] = 7336,
  [14162] = 7337,
  [14163] = 7332,
  [14164] = 7442,
  [14165] = 7335,
  [14166] = 8936,
  [14167] = 7336,
  [14168] = 7443,
  [14169] = 7339,
  [14170] = 7338,
  [14171] = 7443,
  [14172] = 7340,
  [14173] = 7337,
  [14174] = 14156,
  [14175] = 7393,
  [14176] = 7439,
  [14177] = 7441,
  [14178] = 14178,
  [14179] = 14178,
  [14180] = 14178,
  [14181] = 14181,
  [14182] = 14181,
  [14183] = 14181,
  [14184] = 14181,
  [14185] = 14181,
  [14186] = 14181,
  [14187] = 14181,
  [14188] = 14181,
  [14189] = 14181,
  [14190] = 14181,
  [14191] = 14181,
  [14192] = 14181,
  [14193] = 14181,
  [14194] = 14181,
  [14195] = 14181,
  [14196] = 14181,
  [14197] = 14181,
  [14198] = 14181,
  [14199] = 14181,
  [14200] = 14181,
  [14201] = 14181,
  [14202] = 14181,
  [14203] = 14181,
  [14204] = 14181,
  [14205] = 14181,
  [14206] = 14181,
  [14207] = 14181,
  [14208] = 14181,
  [14209] = 14181,
  [14210] = 14181,
  [14211] = 14181,
  [14212] = 14181,
  [14213] = 14181,
  [14214] = 14181,
  [14215] = 14181,
  [14216] = 14181,
  [14217] = 14181,
  [14218] = 14181,
  [14219] = 14181,
  [14220] = 14181,
  [14221] = 14181,
  [14222] = 14181,
  [14223] = 14181,
  [14224] = 14181,
  [14225] = 14181,
  [14226] = 14181,
  [14227] = 14181,
  [14228] = 14181,
  [14229] = 14181,
  [14230] = 14181,
  [14231] = 14181,
  [14232] = 14232,
  [14233] = 14232,
  [14234] = 14232,
  [14235] = 14235,
  [14236] = 14235,
  [14237] = 14235,
  [14238] = 14235,
  [14239] = 14232,
  [14240] = 14235,
  [14241] = 14235,
  [14242] = 14235,
  [14243] = 14232,
  [14244] = 14232,
  [14245] = 14232,
  [14246] = 14235,
  [14247] = 14235,
  [14248] = 14235,
  [14249] = 14232,
  [14250] = 14235,
  [14251] = 14235,
  [14252] = 14235,
  [14253] = 14235,
  [14254] = 14235,
  [14255] = 14235,
  [14256] = 14235,
  [14257] = 14232,
  [14258] = 14232,
  [14259] = 14232,
  [14260] = 14232,
  [14261] = 14232,
  [14262] = 14232,
  [14263] = 14232,
  [14264] = 14232,
  [14265] = 14235,
  [14266] = 14232,
  [14267] = 14235,
  [14268] = 14235,
  [14269] = 14235,
  [14270] = 14232,
  [14271] = 14235,
  [14272] = 14235,
  [14273] = 14232,
  [14274] = 14235,
  [14275] = 14232,
  [14276] = 14235,
  [14277] = 14232,
  [14278] = 14232,
  [14279] = 14232,
  [14280] = 14232,
  [14281] = 14232,
  [14282] = 14235,
  [14283] = 14232,
  [14284] = 14235,
  [14285] = 14235,
  [14286] = 14232,
  [14287] = 14232,
  [14288] = 14235,
  [14289] = 14232,
  [14290] = 14232,
  [14291] = 14235,
  [14292] = 14232,
  [14293] = 14235,
  [14294] = 14235,
  [14295] = 14232,
  [14296] = 14232,
  [14297] = 14235,
  [14298] = 14235,
  [14299] = 14232,
  [14300] = 14235,
  [14301] = 14232,
  [14302] = 14235,
  [14303] = 14235,
  [14304] = 14235,
  [14305] = 14232,
  [14306] = 14232,
  [14307] = 14235,
  [14308] = 14235,
  [14309] = 14235,
  [14310] = 14235,
  [14311] = 14235,
  [14312] = 14235,
  [14313] = 14232,
  [14314] = 14232,
  [14315] = 14235,
  [14316] = 14232,
  [14317] = 14232,
  [14318] = 14235,
  [14319] = 14235,
  [14320] = 14232,
  [14321] = 14235,
  [14322] = 14232,
  [14323] = 14232,
  [14324] = 14232,
  [14325] = 4302,
  [14326] = 4284,
  [14327] = 4287,
  [14328] = 4272,
  [14329] = 4294,
  [14330] = 4354,
  [14331] = 4299,
  [14332] = 4281,
  [14333] = 4375,
  [14334] = 4352,
  [14335] = 4361,
  [14336] = 4374,
  [14337] = 4369,
  [14338] = 4351,
  [14339] = 4353,
  [14340] = 4279,
  [14341] = 4355,
  [14342] = 4380,
  [14343] = 4376,
  [14344] = 4373,
  [14345] = 4358,
  [14346] = 4377,
  [14347] = 4282,
  [14348] = 4458,
  [14349] = 4340,
  [14350] = 4362,
  [14351] = 4610,
  [14352] = 4652,
  [14353] = 4597,
  [14354] = 4623,
  [14355] = 4626,
  [14356] = 4570,
  [14357] = 4631,
  [14358] = 4751,
  [14359] = 4571,
  [14360] = 4600,
  [14361] = 4634,
  [14362] = 4575,
  [14363] = 4612,
  [14364] = 4686,
  [14365] = 4622,
  [14366] = 4666,
  [14367] = 4650,
  [14368] = 4648,
  [14369] = 4697,
  [14370] = 4611,
  [14371] = 4567,
  [14372] = 4603,
  [14373] = 4568,
  [14374] = 4755,
  [14375] = 4618,
  [14376] = 4684,
  [14377] = 4573,
  [14378] = 4614,
  [14379] = 4632,
  [14380] = 4608,
  [14381] = 4695,
  [14382] = 4574,
  [14383] = 4660,
  [14384] = 4586,
  [14385] = 4617,
  [14386] = 4604,
  [14387] = 4700,
  [14388] = 4720,
  [14389] = 4613,
  [14390] = 4576,
  [14391] = 4587,
  [14392] = 4615,
  [14393] = 4721,
  [14394] = 4272,
  [14395] = 4749,
  [14396] = 4738,
  [14397] = 4569,
  [14398] = 4602,
  [14399] = 4582,
  [14400] = 4584,
  [14401] = 4692,
  [14402] = 4583,
  [14403] = 4674,
  [14404] = 4651,
  [14405] = 14405,
  [14406] = 14406,
  [14407] = 14407,
  [14408] = 14408,
  [14409] = 9449,
  [14410] = 14410,
  [14411] = 4272,
  [14412] = 4279,
  [14413] = 4458,
  [14414] = 14414,
  [14415] = 4355,
  [14416] = 4340,
  [14417] = 4361,
  [14418] = 4362,
  [14419] = 14414,
  [14420] = 14414,
  [14421] = 14410,
  [14422] = 14414,
  [14423] = 7068,
  [14424] = 14414,
  [14425] = 4355,
  [14426] = 4340,
  [14427] = 4648,
  [14428] = 4650,
  [14429] = 14414,
  [14430] = 7000,
  [14431] = 4651,
  [14432] = 7068,
  [14433] = 4571,
  [14434] = 14414,
  [14435] = 14408,
  [14436] = 14407,
  [14437] = 4361,
  [14438] = 4362,
  [14439] = 14439,
  [14440] = 14439,
  [14441] = 4281,
  [14442] = 4299,
  [14443] = 4282,
  [14444] = 14414,
  [14445] = 7000,
  [14446] = 14414,
  [14447] = 14408,
  [14448] = 14407,
  [14449] = 4282,
  [14450] = 14406,
  [14451] = 14405,
  [14452] = 14414,
  [14453] = 14414,
  [14454] = 14439,
  [14455] = 14455,
  [14456] = 14410,
  [14457] = 14439,
  [14458] = 14439,
  [14459] = 14439,
  [14460] = 14439,
  [14461] = 14414,
  [14462] = 14439,
  [14463] = 14439,
  [14464] = 14439,
  [14465] = 14439,
  [14466] = 14439,
  [14467] = 14439,
  [14468] = 14406,
  [14469] = 14405,
  [14470] = 14470,
  [14471] = 14414,
  [14472] = 14414,
  [14473] = 14473,
  [14474] = 14474,
  [14475] = 4597,
  [14476] = 4617,
  [14477] = 4618,
  [14478] = 4623,
  [14479] = 4626,
  [14480] = 4651,
  [14481] = 7068,
  [14482] = 4608,
  [14483] = 4610,
  [14484] = 4631,
  [14485] = 4632,
  [14486] = 4600,
  [14487] = 4634,
  [14488] = 4568,
  [14489] = 4569,
  [14490] = 4570,
  [14491] = 4571,
  [14492] = 14473,
  [14493] = 4576,
  [14494] = 4582,
  [14495] = 14495,
  [14496] = 4602,
  [14497] = 4583,
  [14498] = 4584,
  [14499] = 4587,
  [14500] = 4611,
  [14501] = 4648,
  [14502] = 14502,
  [14503] = 4573,
  [14504] = 4272,
  [14505] = 14505,
  [14506] = 14506,
  [14507] = 7068,
  [14508] = 4612,
  [14509] = 4574,
  [14510] = 14505,
  [14511] = 14473,
  [14512] = 4613,
  [14513] = 4614,
  [14514] = 4749,
  [14515] = 4615,
  [14516] = 14505,
  [14517] = 4650,
  [14518] = 14505,
  [14519] = 14506,
  [14520] = 14505,
  [14521] = 4751,
  [14522] = 14505,
  [14523] = 4684,
  [14524] = 4755,
  [14525] = 14505,
  [14526] = 9609,
  [14527] = 14505,
  [14528] = 14502,
  [14529] = 14505,
  [14530] = 9587,
  [14531] = 14505,
  [14532] = 7068,
  [14533] = 14505,
  [14534] = 14505,
  [14535] = 14495,
  [14536] = 14505,
  [14537] = 14537,
  [14538] = 7000,
  [14539] = 14539,
  [14540] = 14540,
  [14541] = 7000,
  [14542] = 14470,
  [14543] = 14470,
  [14544] = 9587,
  [14545] = 4622,
  [14546] = 7000,
  [14547] = 14547,
  [14548] = 14548,
  [14549] = 14549,
  [14550] = 14547,
  [14551] = 14551,
  [14552] = 14547,
  [14553] = 14553,
  [14554] = 14554,
  [14555] = 14551,
  [14556] = 14556,
  [14557] = 14557,
  [14558] = 14549,
  [14559] = 14559,
  [14560] = 14548,
  [14561] = 14553,
  [14562] = 14554,
  [14563] = 14549,
  [14564] = 14559,
  [14565] = 14547,
  [14566] = 14551,
  [14567] = 14567,
  [14568] = 14553,
  [14569] = 14554,
  [14570] = 14549,
  [14571] = 14549,
  [14572] = 14559,
  [14573] = 14548,
  [14574] = 14548,
  [14575] = 14575,
  [14576] = 14548,
  [14577] = 14547,
  [14578] = 14551,
  [14579] = 14579,
  [14580] = 14553,
  [14581] = 14554,
  [14582] = 14582,
  [14583] = 14549,
  [14584] = 14559,
  [14585] = 14548,
  [14586] = 14549,
  [14587] = 14559,
  [14588] = 14547,
  [14589] = 14551,
  [14590] = 14567,
  [14591] = 14547,
  [14592] = 14551,
  [14593] = 14553,
  [14594] = 14554,
  [14595] = 14549,
  [14596] = 14559,
  [14597] = 14548,
  [14598] = 14548,
  [14599] = 14599,
  [14600] = 14559,
  [14601] = 14547,
  [14602] = 14551,
  [14603] = 14553,
  [14604] = 14554,
  [14605] = 14549,
  [14606] = 14559,
  [14607] = 14548,
  [14608] = 14579,
  [14609] = 14582,
  [14610] = 14553,
  [14611] = 14554,
  [14612] = 14547,
  [14613] = 14551,
  [14614] = 14553,
  [14615] = 14554,
  [14616] = 14549,
  [14617] = 14559,
  [14618] = 14540,
  [14619] = 14548,
  [14620] = 14547,
  [14621] = 14551,
  [14622] = 14547,
  [14623] = 14551,
  [14624] = 14553,
  [14625] = 14547,
  [14626] = 14551,
  [14627] = 14554,
  [14628] = 14553,
  [14629] = 14554,
  [14630] = 14556,
  [14631] = 14631,
  [14632] = 14549,
  [14633] = 14559,
  [14634] = 14557,
  [14635] = 14548,
  [14636] = 14547,
  [14637] = 14551,
  [14638] = 14575,
  [14639] = 14547,
  [14640] = 14551,
  [14641] = 14549,
  [14642] = 14559,
  [14643] = 14553,
  [14644] = 14554,
  [14645] = 14567,
  [14646] = 14556,
  [14647] = 14549,
  [14648] = 14559,
  [14649] = 14506,
  [14650] = 14548,
  [14651] = 14548,
  [14652] = 14553,
  [14653] = 14554,
  [14654] = 14547,
  [14655] = 14551,
  [14656] = 14553,
  [14657] = 14554,
  [14658] = 14658,
  [14659] = 14549,
  [14660] = 14559,
  [14661] = 14557,
  [14662] = 14548,
  [14663] = 14553,
  [14664] = 14547,
  [14665] = 14549,
  [14666] = 14547,
  [14667] = 14551,
  [14668] = 14553,
  [14669] = 14554,
  [14670] = 14559,
  [14671] = 14549,
  [14672] = 14559,
  [14673] = 14548,
  [14674] = 14551,
  [14675] = 14556,
  [14676] = 14557,
  [14677] = 14547,
  [14678] = 14551,
  [14679] = 14553,
  [14680] = 14554,
  [14681] = 14549,
  [14682] = 14559,
  [14683] = 14549,
  [14684] = 14548,
  [14685] = 14559,
  [14686] = 14554,
  [14687] = 14567,
  [14688] = 14567,
  [14689] = 14547,
  [14690] = 14551,
  [14691] = 14553,
  [14692] = 14554,
  [14693] = 14547,
  [14694] = 14548,
  [14695] = 14551,
  [14696] = 14549,
  [14697] = 14559,
  [14698] = 14556,
  [14699] = 14548,
  [14700] = 14557,
  [14701] = 14547,
  [14702] = 14551,
  [14703] = 14553,
  [14704] = 14554,
  [14705] = 14548,
  [14706] = 14553,
  [14707] = 14549,
  [14708] = 14559,
  [14709] = 14579,
  [14710] = 14582,
  [14711] = 14548,
  [14712] = 14554,
  [14713] = 14547,
  [14714] = 14551,
  [14715] = 14553,
  [14716] = 14554,
  [14717] = 14631,
  [14718] = 14549,
  [14719] = 14559,
  [14720] = 14553,
  [14721] = 14548,
  [14722] = 14547,
  [14723] = 14551,
  [14724] = 14553,
  [14725] = 14554,
  [14726] = 14554,
  [14727] = 14549,
  [14728] = 14549,
  [14729] = 14559,
  [14730] = 14599,
  [14731] = 14548,
  [14732] = 14559,
  [14733] = 14547,
  [14734] = 14551,
  [14735] = 14553,
  [14736] = 14554,
  [14737] = 14549,
  [14738] = 14559,
  [14739] = 14548,
  [14740] = 14567,
  [14741] = 14547,
  [14742] = 14551,
  [14743] = 14553,
  [14744] = 14554,
  [14745] = 14549,
  [14746] = 14559,
  [14747] = 14549,
  [14748] = 14559,
  [14749] = 14548,
  [14750] = 14548,
  [14751] = 14567,
  [14752] = 14547,
  [14753] = 14551,
  [14754] = 14553,
  [14755] = 14554,
  [14756] = 14548,
  [14757] = 14549,
  [14758] = 14559,
  [14759] = 14548,
  [14760] = 14599,
  [14761] = 14547,
  [14762] = 14551,
  [14763] = 14553,
  [14764] = 14554,
  [14765] = 14579,
  [14766] = 14582,
  [14767] = 14547,
  [14768] = 14549,
  [14769] = 14559,
  [14770] = 14551,
  [14771] = 14548,
  [14772] = 14567,
  [14773] = 14506,
  [14774] = 14547,
  [14775] = 14551,
  [14776] = 14553,
  [14777] = 14554,
  [14778] = 14553,
  [14779] = 14554,
  [14780] = 14549,
  [14781] = 14559,
  [14782] = 14548,
  [14783] = 14599,
  [14784] = 14549,
  [14785] = 14547,
  [14786] = 14551,
  [14787] = 14553,
  [14788] = 14554,
  [14789] = 14549,
  [14790] = 14559,
  [14791] = 14547,
  [14792] = 14551,
  [14793] = 14549,
  [14794] = 14548,
  [14795] = 14559,
  [14796] = 14567,
  [14797] = 14547,
  [14798] = 14551,
  [14799] = 14553,
  [14800] = 14554,
  [14801] = 14548,
  [14802] = 14553,
  [14803] = 14554,
  [14804] = 14549,
  [14805] = 14559,
  [14806] = 14548,
  [14807] = 14579,
  [14808] = 14582,
  [14809] = 14547,
  [14810] = 14551,
  [14811] = 14553,
  [14812] = 14554,
  [14813] = 14549,
  [14814] = 14559,
  [14815] = 14556,
  [14816] = 14557,
  [14817] = 14548,
  [14818] = 14559,
  [14819] = 14547,
  [14820] = 14551,
  [14821] = 14553,
  [14822] = 14554,
  [14823] = 14549,
  [14824] = 14549,
  [14825] = 14559,
  [14826] = 14559,
  [14827] = 14548,
  [14828] = 14567,
  [14829] = 14547,
  [14830] = 14551,
  [14831] = 14553,
  [14832] = 14554,
  [14833] = 14548,
  [14834] = 14549,
  [14835] = 14559,
  [14836] = 14548,
  [14837] = 14547,
  [14838] = 14551,
  [14839] = 14553,
  [14840] = 14554,
  [14841] = 14579,
  [14842] = 14549,
  [14843] = 14559,
  [14844] = 14582,
  [14845] = 14548,
  [14846] = 14547,
  [14847] = 14551,
  [14848] = 14549,
  [14849] = 14553,
  [14850] = 14554,
  [14851] = 14559,
  [14852] = 14549,
  [14853] = 14559,
  [14854] = 14548,
  [14855] = 14547,
  [14856] = 14551,
  [14857] = 14567,
  [14858] = 14553,
  [14859] = 14554,
  [14860] = 14549,
  [14861] = 14559,
  [14862] = 14599,
  [14863] = 14548,
  [14864] = 14547,
  [14865] = 14551,
  [14866] = 14599,
  [14867] = 14553,
  [14868] = 14554,
  [14869] = 14549,
  [14870] = 14559,
  [14871] = 14548,
  [14872] = 14548,
  [14873] = 14547,
  [14874] = 14551,
  [14875] = 14553,
  [14876] = 14554,
  [14877] = 14549,
  [14878] = 14559,
  [14879] = 14548,
  [14880] = 14551,
  [14881] = 14547,
  [14882] = 14551,
  [14883] = 14553,
  [14884] = 14554,
  [14885] = 14549,
  [14886] = 14559,
  [14887] = 14887,
  [14888] = 14548,
  [14889] = 14553,
  [14890] = 14554,
  [14891] = 14547,
  [14892] = 14551,
  [14893] = 14553,
  [14894] = 14554,
  [14895] = 14549,
  [14896] = 14559,
  [14897] = 14548,
  [14898] = 14547,
  [14899] = 14551,
  [14900] = 14547,
  [14901] = 14567,
  [14902] = 14547,
  [14903] = 14551,
  [14904] = 14553,
  [14905] = 14554,
  [14906] = 14549,
  [14907] = 14559,
  [14908] = 14551,
  [14909] = 14548,
  [14910] = 14547,
  [14911] = 14551,
  [14912] = 14599,
  [14913] = 14553,
  [14914] = 14554,
  [14915] = 14547,
  [14916] = 14549,
  [14917] = 14559,
  [14918] = 14551,
  [14919] = 14547,
  [14920] = 14548,
  [14921] = 14553,
  [14922] = 14556,
  [14923] = 14547,
  [14924] = 14547,
  [14925] = 14557,
  [14926] = 14553,
  [14927] = 14554,
  [14928] = 14553,
  [14929] = 14549,
  [14930] = 14559,
  [14931] = 14554,
  [14932] = 14548,
  [14933] = 14549,
  [14934] = 14547,
  [14935] = 14551,
  [14936] = 14559,
  [14937] = 14553,
  [14938] = 14554,
  [14939] = 14549,
  [14940] = 14559,
  [14941] = 14554,
  [14942] = 14567,
  [14943] = 14548,
  [14944] = 14537,
  [14945] = 14548,
  [14946] = 14549,
  [14947] = 14559,
  [14948] = 14567,
  [14949] = 14553,
  [14950] = 14579,
  [14951] = 14582,
  [14952] = 14548,
  [14953] = 7344,
  [14954] = 14548,
  [14955] = 14599,
  [14956] = 14554,
  [14957] = 14549,
  [14958] = 14559,
  [14959] = 14551,
  [14960] = 14547,
  [14961] = 14567,
  [14962] = 14551,
  [14963] = 14548,
  [14964] = 14547,
  [14965] = 7000,
  [14966] = 14551,
  [14967] = 14553,
  [14968] = 14547,
  [14969] = 14551,
  [14970] = 14553,
  [14971] = 14554,
  [14972] = 14549,
  [14973] = 14547,
  [14974] = 14551,
  [14975] = 14559,
  [14976] = 14547,
  [14977] = 14551,
  [14978] = 14554,
  [14979] = 14559,
  [14980] = 14506,
  [14981] = 14567,
  [14982] = 14553,
  [14983] = 14554,
  [14984] = 14549,
  [14985] = 14559,
  [14986] = 14567,
  [14987] = 14553,
  [14988] = 14554,
  [14989] = 14548,
  [14990] = 14553,
  [14991] = 7068,
  [14992] = 14553,
  [14993] = 14554,
  [14994] = 14554,
  [14995] = 14556,
  [14996] = 14556,
  [14997] = 14557,
  [14998] = 14547,
  [14999] = 14551,
  [15000] = 14549,
  [15001] = 14549,
  [15002] = 14559,
  [15003] = 14559,
  [15004] = 14567,
  [15005] = 14567,
  [15006] = 14548,
  [15007] = 14547,
  [15008] = 14551,
  [15009] = 14548,
  [15010] = 14548,
  [15011] = 14547,
  [15012] = 14551,
  [15013] = 14579,
  [15014] = 14582,
  [15015] = 9449,
  [15016] = 14658,
  [15017] = 14537,
  [15018] = 14567,
  [15019] = 14553,
  [15020] = 14554,
  [15021] = 14547,
  [15022] = 14599,
  [15023] = 14539,
  [15024] = 14551,
  [15025] = 14553,
  [15026] = 14549,
  [15027] = 14559,
  [15028] = 14567,
  [15029] = 14579,
  [15030] = 14548,
  [15031] = 15031,
  [15032] = 14547,
  [15033] = 14551,
  [15034] = 14554,
  [15035] = 14582,
  [15036] = 14553,
  [15037] = 14549,
  [15038] = 14559,
  [15039] = 14553,
  [15040] = 14554,
  [15041] = 14567,
  [15042] = 14547,
  [15043] = 14551,
  [15044] = 14553,
  [15045] = 14554,
  [15046] = 14554,
  [15047] = 14557,
  [15048] = 14549,
  [15049] = 14559,
  [15050] = 14548,
  [15051] = 14553,
  [15052] = 14556,
  [15053] = 14557,
  [15054] = 14567,
  [15055] = 14548,
  [15056] = 14554,
  [15057] = 14549,
  [15058] = 14559,
  [15059] = 14567,
  [15060] = 14540,
  [15061] = 14548,
  [15062] = 14556,
  [15063] = 14579,
  [15064] = 14582,
  [15065] = 14557,
  [15066] = 14549,
  [15067] = 14559,
  [15068] = 14548,
  [15069] = 14547,
  [15070] = 14551,
  [15071] = 14553,
  [15072] = 14553,
  [15073] = 14554,
  [15074] = 14599,
  [15075] = 14567,
  [15076] = 9614,
  [15077] = 14549,
  [15078] = 14559,
  [15079] = 14567,
  [15080] = 14547,
  [15081] = 14551,
  [15082] = 14548,
  [15083] = 14549,
  [15084] = 14548,
  [15085] = 14559,
  [15086] = 14553,
  [15087] = 14554,
  [15088] = 15031,
  [15089] = 14567,
  [15090] = 7068,
  [15091] = 14549,
  [15092] = 14559,
  [15093] = 14548,
  [15094] = 14547,
  [15095] = 14551,
  [15096] = 14556,
  [15097] = 14557,
  [15098] = 14567,
  [15099] = 14547,
  [15100] = 14549,
  [15101] = 14553,
  [15102] = 14559,
  [15103] = 14551,
  [15104] = 14554,
  [15105] = 14567,
  [15106] = 14553,
  [15107] = 14554,
  [15108] = 14548,
  [15109] = 7000,
  [15110] = 14579,
  [15111] = 14582,
  [15112] = 14554,
  [15113] = 14549,
  [15114] = 14559,
  [15115] = 14599,
  [15116] = 14567,
  [15117] = 14539,
  [15118] = 14549,
  [15119] = 14559,
  [15120] = 14887,
  [15121] = 14548,
  [15122] = 14567,
  [15123] = 14551,
  [15124] = 14548,
  [15125] = 14547,
  [15126] = 14551,
  [15127] = 14579,
  [15128] = 14582,
  [15129] = 14553,
  [15130] = 14554,
  [15131] = 14547,
  [15132] = 14551,
  [15133] = 14553,
  [15134] = 14554,
  [15135] = 14556,
  [15136] = 14557,
  [15137] = 7344,
  [15138] = 14549,
  [15139] = 14559,
  [15140] = 14567,
  [15141] = 14548,
  [15142] = 14548,
  [15143] = 14547,
  [15144] = 14551,
  [15145] = 14567,
  [15146] = 14567,
  [15147] = 14567,
  [15148] = 14549,
  [15149] = 14559,
  [15150] = 14567,
  [15151] = 14567,
  [15152] = 14567,
  [15153] = 14567,
  [15154] = 14548,
  [15155] = 14567,
  [15156] = 14553,
  [15157] = 14554,
  [15158] = 14567,
  [15159] = 14547,
  [15160] = 14551,
  [15161] = 14599,
  [15162] = 14567,
  [15163] = 14553,
  [15164] = 14554,
  [15165] = 14567,
  [15166] = 14579,
  [15167] = 14582,
  [15168] = 14567,
  [15169] = 14567,
  [15170] = 14567,
  [15171] = 14599,
  [15172] = 14567,
  [15173] = 14567,
  [15174] = 14567,
  [15175] = 14567,
  [15176] = 14549,
  [15177] = 14559,
  [15178] = 14567,
  [15179] = 14551,
  [15180] = 15180,
  [15181] = 15181,
  [15182] = 15182,
  [15183] = 15183,
  [15184] = 15181,
  [15185] = 15182,
  [15186] = 15186,
  [15187] = 15182,
  [15188] = 15183,
  [15189] = 7344,
  [15190] = 15190,
  [15191] = 15186,
  [15192] = 15190,
  [15193] = 15181,
  [15194] = 15183,
  [15195] = 15195,
  [15196] = 15181,
  [15197] = 15186,
  [15198] = 15190,
  [15199] = 15183,
  [15200] = 15181,
  [15201] = 15201,
  [15202] = 15183,
  [15203] = 15181,
  [15204] = 15201,
  [15205] = 15201,
  [15206] = 15201,
  [15207] = 15181,
  [15208] = 15183,
  [15209] = 15182,
  [15210] = 7344,
  [15211] = 15182,
  [15212] = 15181,
  [15213] = 15182,
  [15214] = 15181,
  [15215] = 15181,
  [15216] = 15190,
  [15217] = 15201,
  [15218] = 15190,
  [15219] = 15181,
  [15220] = 15201,
  [15221] = 15182,
  [15222] = 15186,
  [15223] = 15183,
  [15224] = 14887,
  [15225] = 15201,
  [15226] = 14887,
  [15227] = 15201,
  [15228] = 15183,
  [15229] = 15181,
  [15230] = 15182,
  [15231] = 15181,
  [15232] = 15201,
  [15233] = 15183,
  [15234] = 15181,
  [15235] = 15182,
  [15236] = 15190,
  [15237] = 15183,
  [15238] = 15190,
  [15239] = 15201,
  [15240] = 15181,
  [15241] = 15201,
  [15242] = 15182,
  [15243] = 15182,
  [15244] = 15201,
  [15245] = 15182,
  [15246] = 15182,
  [15247] = 15186,
  [15248] = 15181,
  [15249] = 15249,
  [15250] = 15181,
  [15251] = 15201,
  [15252] = 15252,
  [15253] = 15186,
  [15254] = 15181,
  [15255] = 15182,
  [15256] = 15180,
  [15257] = 15183,
  [15258] = 14887,
  [15259] = 15180,
  [15260] = 15181,
  [15261] = 15181,
  [15262] = 15201,
  [15263] = 15201,
  [15264] = 15182,
  [15265] = 15183,
  [15266] = 7344,
  [15267] = 15182,
  [15268] = 15183,
  [15269] = 15182,
  [15270] = 15180,
  [15271] = 15180,
  [15272] = 15201,
  [15273] = 15249,
  [15274] = 15183,
  [15275] = 15252,
  [15276] = 15186,
  [15277] = 15182,
  [15278] = 15183,
  [15279] = 15180,
  [15280] = 15181,
  [15281] = 15181,
  [15282] = 15183,
  [15283] = 15190,
  [15284] = 15181,
  [15285] = 15181,
  [15286] = 15181,
  [15287] = 15181,
  [15288] = 15182,
  [15289] = 15249,
  [15290] = 15180,
  [15291] = 15252,
  [15292] = 15201,
  [15293] = 15182,
  [15294] = 15181,
  [15295] = 15201,
  [15296] = 15201,
  [15297] = 15182,
  [15298] = 4355,
  [15299] = 15181,
  [15300] = 15249,
  [15301] = 15181,
  [15302] = 15252,
  [15303] = 15181,
  [15304] = 14506,
  [15305] = 15180,
  [15306] = 15181,
  [15307] = 15201,
  [15308] = 15181,
  [15309] = 15182,
  [15310] = 15183,
  [15311] = 15249,
  [15312] = 15190,
  [15313] = 15252,
  [15314] = 15190,
  [15315] = 15181,
  [15316] = 15201,
  [15317] = 15252,
  [15318] = 15183,
  [15319] = 15183,
  [15320] = 15249,
  [15321] = 15183,
  [15322] = 15252,
  [15323] = 15201,
  [15324] = 15182,
  [15325] = 14631,
  [15326] = 15249,
  [15327] = 14575,
  [15328] = 15252,
  [15329] = 15201,
  [15330] = 15182,
  [15331] = 15249,
  [15332] = 4282,
  [15333] = 15252,
  [15334] = 15186,
  [15335] = 15181,
  [15336] = 14631,
  [15337] = 14575,
  [15338] = 15182,
  [15339] = 15249,
  [15340] = 15182,
  [15341] = 15252,
  [15342] = 15183,
  [15343] = 14455,
  [15344] = 15181,
  [15345] = 15181,
  [15346] = 15183,
  [15347] = 15181,
  [15348] = 15249,
  [15349] = 15180,
  [15350] = 15181,
  [15351] = 15252,
  [15352] = 15249,
  [15353] = 15201,
  [15354] = 15182,
  [15355] = 15181,
  [15356] = 15201,
  [15357] = 15201,
  [15358] = 15249,
  [15359] = 15201,
  [15360] = 15252,
  [15361] = 15181,
  [15362] = 15183,
  [15363] = 15201,
  [15364] = 15182,
  [15365] = 4340,
  [15366] = 15190,
  [15367] = 15186,
  [15368] = 15252,
  [15369] = 15182,
  [15370] = 15183,
  [15371] = 15183,
  [15372] = 15181,
  [15373] = 15201,
  [15374] = 4361,
  [15375] = 15182,
  [15376] = 15186,
  [15377] = 15182,
  [15378] = 15182,
  [15379] = 15201,
  [15380] = 14631,
  [15381] = 15181,
  [15382] = 15183,
  [15383] = 4362,
  [15384] = 15183,
  [15385] = 15201,
  [15386] = 15181,
  [15387] = 15183,
  [15388] = 15186,
  [15389] = 15181,
  [15390] = 15183,
  [15391] = 15181,
  [15392] = 15249,
  [15393] = 15190,
  [15394] = 15201,
  [15395] = 15183,
  [15396] = 15183,
  [15397] = 15201,
  [15398] = 15182,
  [15399] = 15183,
  [15400] = 15201,
  [15401] = 15181,
  [15402] = 15182,
  [15403] = 15182,
  [15404] = 14506,
  [15405] = 15201,
  [15406] = 15183,
  [15407] = 15181,
  [15408] = 15180,
  [15409] = 15182,
  [15410] = 15201,
  [15411] = 15182,
  [15412] = 15181,
  [15413] = 14658,
  [15414] = 15182,
  [15415] = 15181,
  [15416] = 15416,
  [15417] = 15181,
  [15418] = 15181,
  [15419] = 14575,
  [15420] = 15183,
  [15421] = 15201,
  [15422] = 15183,
  [15423] = 15190,
  [15424] = 15183,
  [15425] = 15186,
  [15426] = 15183,
  [15427] = 15182,
  [15428] = 15201,
  [15429] = 15181,
  [15430] = 15181,
  [15431] = 14658,
  [15432] = 15201,
  [15433] = 15182,
  [15434] = 15181,
  [15435] = 15183,
  [15436] = 15181,
  [15437] = 15181,
  [15438] = 15180,
  [15439] = 15181,
  [15440] = 14658,
  [15441] = 15181,
  [15442] = 15181,
  [15443] = 15181,
  [15444] = 15180,
  [15445] = 15183,
  [15446] = 15181,
  [15447] = 15201,
  [15448] = 15182,
  [15449] = 15181,
  [15450] = 15181,
  [15451] = 15201,
  [15452] = 15181,
  [15453] = 15181,
  [15454] = 15182,
  [15455] = 15183,
  [15456] = 15183,
  [15457] = 15183,
  [15458] = 15181,
  [15459] = 15186,
  [15460] = 15201,
  [15461] = 15201,
  [15462] = 15182,
  [15463] = 15183,
  [15464] = 15180,
  [15465] = 15465,
  [15466] = 15466,
  [15467] = 15467,
  [15468] = 15468,
  [15469] = 15469,
  [15470] = 15466,
  [15471] = 15467,
  [15472] = 15472,
  [15473] = 15472,
  [15474] = 15474,
  [15475] = 15475,
  [15476] = 15476,
  [15477] = 15476,
  [15478] = 15466,
  [15479] = 15467,
  [15480] = 15476,
  [15481] = 15481,
  [15482] = 15481,
  [15483] = 15483,
  [15484] = 15483,
  [15485] = 15485,
  [15486] = 15481,
  [15487] = 15468,
  [15488] = 15469,
  [15489] = 14575,
  [15490] = 15483,
  [15491] = 15472,
  [15492] = 15483,
  [15493] = 15465,
  [15494] = 4272,
  [15495] = 15468,
  [15496] = 15469,
  [15497] = 15497,
  [15498] = 15475,
  [15499] = 15485,
  [15500] = 15466,
  [15501] = 15467,
  [15502] = 15465,
  [15503] = 15468,
  [15504] = 15469,
  [15505] = 15483,
  [15506] = 15497,
  [15507] = 15485,
  [15508] = 15465,
  [15509] = 15468,
  [15510] = 15469,
  [15511] = 15497,
  [15512] = 15468,
  [15513] = 15469,
  [15514] = 15514,
  [15515] = 15472,
  [15516] = 15476,
  [15517] = 15517,
  [15518] = 15514,
  [15519] = 15475,
  [15520] = 15466,
  [15521] = 15466,
  [15522] = 15467,
  [15523] = 15523,
  [15524] = 15467,
  [15525] = 15483,
  [15526] = 15481,
  [15527] = 15517,
  [15528] = 15468,
  [15529] = 15469,
  [15530] = 15475,
  [15531] = 15475,
  [15532] = 15475,
  [15533] = 15523,
  [15534] = 15472,
  [15535] = 15468,
  [15536] = 15467,
  [15537] = 15475,
  [15538] = 15466,
  [15539] = 15467,
  [15540] = 15466,
  [15541] = 15467,
  [15542] = 15483,
  [15543] = 15472,
  [15544] = 15468,
  [15545] = 15469,
  [15546] = 15466,
  [15547] = 15476,
  [15548] = 15467,
  [15549] = 15481,
  [15550] = 15485,
  [15551] = 15483,
  [15552] = 15465,
  [15553] = 15475,
  [15554] = 15466,
  [15555] = 15467,
  [15556] = 15497,
  [15557] = 15483,
  [15558] = 15485,
  [15559] = 15472,
  [15560] = 15468,
  [15561] = 15469,
  [15562] = 15483,
  [15563] = 15465,
  [15564] = 15468,
  [15565] = 15469,
  [15566] = 15485,
  [15567] = 15475,
  [15568] = 15476,
  [15569] = 15465,
  [15570] = 15497,
  [15571] = 15497,
  [15572] = 15476,
  [15573] = 15481,
  [15574] = 15574,
  [15575] = 15475,
  [15576] = 15523,
  [15577] = 15466,
  [15578] = 15467,
  [15579] = 15514,
  [15580] = 15476,
  [15581] = 4272,
  [15582] = 15517,
  [15583] = 15483,
  [15584] = 15466,
  [15585] = 15467,
  [15586] = 15481,
  [15587] = 15523,
  [15588] = 15468,
  [15589] = 15469,
  [15590] = 15574,
  [15591] = 15475,
  [15592] = 15483,
  [15593] = 15514,
  [15594] = 15594,
  [15595] = 15475,
  [15596] = 15596,
  [15597] = 15475,
  [15598] = 15466,
  [15599] = 15467,
  [15600] = 15483,
  [15601] = 15483,
  [15602] = 15475,
  [15603] = 15468,
  [15604] = 15469,
  [15605] = 15485,
  [15606] = 15472,
  [15607] = 15483,
  [15608] = 15465,
  [15609] = 15466,
  [15610] = 15467,
  [15611] = 15472,
  [15612] = 15475,
  [15613] = 15475,
  [15614] = 15476,
  [15615] = 15466,
  [15616] = 15467,
  [15617] = 15497,
  [15618] = 15468,
  [15619] = 15594,
  [15620] = 15476,
  [15621] = 15481,
  [15622] = 15483,
  [15623] = 15469,
  [15624] = 15468,
  [15625] = 15469,
  [15626] = 15481,
  [15627] = 15483,
  [15628] = 15594,
  [15629] = 15466,
  [15630] = 15483,
  [15631] = 15467,
  [15632] = 15468,
  [15633] = 15469,
  [15634] = 15485,
  [15635] = 15475,
  [15636] = 15485,
  [15637] = 15466,
  [15638] = 15467,
  [15639] = 15465,
  [15640] = 15483,
  [15641] = 15468,
  [15642] = 15469,
  [15643] = 15497,
  [15644] = 15468,
  [15645] = 15469,
  [15646] = 15466,
  [15647] = 15465,
  [15648] = 15481,
  [15649] = 15467,
  [15650] = 15517,
  [15651] = 15514,
  [15652] = 15517,
  [15653] = 15475,
  [15654] = 15466,
  [15655] = 15467,
  [15656] = 15468,
  [15657] = 15523,
  [15658] = 15523,
  [15659] = 15469,
  [15660] = 15483,
  [15661] = 15497,
  [15662] = 15472,
  [15663] = 15468,
  [15664] = 15469,
  [15665] = 15472,
  [15666] = 15485,
  [15667] = 15514,
  [15668] = 15465,
  [15669] = 15481,
  [15670] = 15497,
  [15671] = 14658,
  [15672] = 15672,
  [15673] = 15472,
  [15674] = 15514,
  [15675] = 15468,
  [15676] = 15475,
  [15677] = 15475,
  [15678] = 15476,
  [15679] = 15466,
  [15680] = 15467,
  [15681] = 15485,
  [15682] = 15514,
  [15683] = 15483,
  [15684] = 15469,
  [15685] = 15468,
  [15686] = 15469,
  [15687] = 15514,
  [15688] = 15481,
  [15689] = 15466,
  [15690] = 15467,
  [15691] = 15472,
  [15692] = 15465,
  [15693] = 15476,
  [15694] = 15475,
  [15695] = 15466,
  [15696] = 15467,
  [15697] = 15697,
  [15698] = 15481,
  [15699] = 15483,
  [15700] = 15483,
  [15701] = 15468,
  [15702] = 15469,
  [15703] = 15517,
  [15704] = 15514,
  [15705] = 15483,
  [15706] = 15517,
  [15707] = 15523,
  [15708] = 15497,
  [15709] = 15468,
  [15710] = 15469,
  [15711] = 15475,
  [15712] = 15466,
  [15713] = 15467,
  [15714] = 15485,
  [15715] = 15483,
  [15716] = 15465,
  [15717] = 15468,
  [15718] = 15469,
  [15719] = 15517,
  [15720] = 15497,
  [15721] = 15476,
  [15722] = 15514,
  [15723] = 15485,
  [15724] = 15468,
  [15725] = 15469,
  [15726] = 15475,
  [15727] = 15523,
  [15728] = 15466,
  [15729] = 15467,
  [15730] = 15517,
  [15731] = 15514,
  [15732] = 15485,
  [15733] = 15483,
  [15734] = 15465,
  [15735] = 15466,
  [15736] = 15497,
  [15737] = 15468,
  [15738] = 15469,
  [15739] = 15523,
  [15740] = 15523,
  [15741] = 15465,
  [15742] = 15497,
  [15743] = 15481,
  [15744] = 15481,
  [15745] = 15475,
  [15746] = 15466,
  [15747] = 15467,
  [15748] = 15483,
  [15749] = 15514,
  [15750] = 15483,
  [15751] = 15514,
  [15752] = 15468,
  [15753] = 15469,
  [15754] = 15467,
  [15755] = 15475,
  [15756] = 15517,
  [15757] = 15483,
  [15758] = 15466,
  [15759] = 15467,
  [15760] = 15472,
  [15761] = 15475,
  [15762] = 15517,
  [15763] = 15466,
  [15764] = 15467,
  [15765] = 15476,
  [15766] = 15483,
  [15767] = 15517,
  [15768] = 15468,
  [15769] = 15468,
  [15770] = 15469,
  [15771] = 15771,
  [15772] = 15481,
  [15773] = 15483,
  [15774] = 15475,
  [15775] = 15523,
  [15776] = 15574,
  [15777] = 15523,
  [15778] = 15475,
  [15779] = 15475,
  [15780] = 15466,
  [15781] = 15467,
  [15782] = 15468,
  [15783] = 15469,
  [15784] = 15485,
  [15785] = 15483,
  [15786] = 15465,
  [15787] = 15468,
  [15788] = 15469,
  [15789] = 15497,
  [15790] = 15466,
  [15791] = 15467,
  [15792] = 15514,
  [15793] = 15469,
  [15794] = 15517,
  [15795] = 15574,
  [15796] = 15475,
  [15797] = 15485,
  [15798] = 15466,
  [15799] = 15467,
  [15800] = 15465,
  [15801] = 15523,
  [15802] = 15466,
  [15803] = 15483,
  [15804] = 15467,
  [15805] = 14887,
  [15806] = 15468,
  [15807] = 15469,
  [15808] = 15472,
  [15809] = 4355,
  [15810] = 15476,
  [15811] = 15497,
  [15812] = 15481,
  [15813] = 15475,
  [15814] = 15517,
  [15815] = 15466,
  [15816] = 15467,
  [15817] = 15475,
  [15818] = 4340,
  [15819] = 15483,
  [15820] = 15472,
  [15821] = 15468,
  [15822] = 15469,
  [15823] = 15466,
  [15824] = 15467,
  [15825] = 15476,
  [15826] = 4361,
  [15827] = 15472,
  [15828] = 15594,
  [15829] = 15475,
  [15830] = 15483,
  [15831] = 15481,
  [15832] = 15475,
  [15833] = 15466,
  [15834] = 15467,
  [15835] = 15476,
  [15836] = 4362,
  [15837] = 15517,
  [15838] = 15483,
  [15839] = 15481,
  [15840] = 15475,
  [15841] = 15468,
  [15842] = 15469,
  [15843] = 15483,
  [15844] = 15483,
  [15845] = 15466,
  [15846] = 15467,
  [15847] = 15468,
  [15848] = 15469,
  [15849] = 15466,
  [15850] = 15467,
  [15851] = 15468,
  [15852] = 15469,
  [15853] = 15466,
  [15854] = 15467,
  [15855] = 15468,
  [15856] = 15469,
  [15857] = 15468,
  [15858] = 15466,
  [15859] = 15467,
  [15860] = 15468,
  [15861] = 15469,
  [15862] = 15469,
  [15863] = 15466,
  [15864] = 15466,
  [15865] = 15467,
  [15866] = 15468,
  [15867] = 15469,
  [15868] = 15467,
  [15869] = 15466,
  [15870] = 15467,
  [15871] = 15468,
  [15872] = 15469,
  [15873] = 15514,
  [15874] = 15466,
  [15875] = 15467,
  [15876] = 15468,
  [15877] = 15469,
  [15878] = 15466,
  [15879] = 15467,
  [15880] = 15468,
  [15881] = 15469,
  [15882] = 15466,
  [15883] = 15467,
  [15884] = 15468,
  [15885] = 15469,
  [15886] = 15472,
  [15887] = 15466,
  [15888] = 15467,
  [15889] = 15468,
  [15890] = 15469,
  [15891] = 15466,
  [15892] = 15467,
  [15893] = 15468,
  [15894] = 15469,
  [15895] = 15466,
  [15896] = 15467,
  [15897] = 15468,
  [15898] = 15469,
  [15899] = 15483,
  [15900] = 15468,
  [15901] = 15466,
  [15902] = 15467,
  [15903] = 15468,
  [15904] = 15469,
  [15905] = 15476,
  [15906] = 15468,
  [15907] = 15466,
  [15908] = 15467,
  [15909] = 15468,
  [15910] = 15469,
  [15911] = 15481,
  [15912] = 15466,
  [15913] = 15467,
  [15914] = 15468,
  [15915] = 15469,
  [15916] = 15485,
  [15917] = 15466,
  [15918] = 15467,
  [15919] = 15468,
  [15920] = 15469,
  [15921] = 15469,
  [15922] = 15466,
  [15923] = 15467,
  [15924] = 15468,
  [15925] = 15469,
  [15926] = 15466,
  [15927] = 15467,
  [15928] = 15468,
  [15929] = 15469,
  [15930] = 15466,
  [15931] = 15467,
  [15932] = 15468,
  [15933] = 15469,
  [15934] = 15483,
  [15935] = 15466,
  [15936] = 15467,
  [15937] = 15468,
  [15938] = 15469,
  [15939] = 15483,
  [15940] = 15466,
  [15941] = 15467,
  [15942] = 15468,
  [15943] = 15469,
  [15944] = 15485,
  [15945] = 15466,
  [15946] = 15467,
  [15947] = 15468,
  [15948] = 15469,
  [15949] = 15465,
  [15950] = 15523,
  [15951] = 15466,
  [15952] = 15467,
  [15953] = 15468,
  [15954] = 15469,
  [15955] = 15466,
  [15956] = 15467,
  [15957] = 15468,
  [15958] = 15469,
  [15959] = 15466,
  [15960] = 15467,
  [15961] = 15468,
  [15962] = 15469,
  [15963] = 15466,
  [15964] = 15467,
  [15965] = 15468,
  [15966] = 15469,
  [15967] = 15497,
  [15968] = 15466,
  [15969] = 15467,
  [15970] = 15468,
  [15971] = 15469,
  [15972] = 15466,
  [15973] = 15467,
  [15974] = 15468,
  [15975] = 15469,
  [15976] = 15466,
  [15977] = 15467,
  [15978] = 15468,
  [15979] = 15469,
  [15980] = 15466,
  [15981] = 15467,
  [15982] = 15468,
  [15983] = 15469,
  [15984] = 15466,
  [15985] = 15467,
  [15986] = 15468,
  [15987] = 15469,
  [15988] = 15466,
  [15989] = 15467,
  [15990] = 15468,
  [15991] = 15469,
  [15992] = 15466,
  [15993] = 15467,
  [15994] = 15468,
  [15995] = 15469,
  [15996] = 15466,
  [15997] = 15467,
  [15998] = 15468,
  [15999] = 15469,
  [16000] = 15485,
  [16001] = 15466,
  [16002] = 15467,
  [16003] = 15468,
  [16004] = 15469,
  [16005] = 15466,
  [16006] = 15467,
  [16007] = 15468,
  [16008] = 15469,
  [16009] = 15465,
  [16010] = 15466,
  [16011] = 15467,
  [16012] = 15468,
  [16013] = 15469,
  [16014] = 15466,
  [16015] = 15467,
  [16016] = 15468,
  [16017] = 15469,
  [16018] = 15497,
  [16019] = 15466,
  [16020] = 15467,
  [16021] = 15468,
  [16022] = 15469,
  [16023] = 15466,
  [16024] = 15467,
  [16025] = 15468,
  [16026] = 15469,
  [16027] = 15466,
  [16028] = 15467,
  [16029] = 15468,
  [16030] = 15469,
  [16031] = 15468,
  [16032] = 15466,
  [16033] = 15467,
  [16034] = 15468,
  [16035] = 15469,
  [16036] = 15468,
  [16037] = 15469,
  [16038] = 15485,
  [16039] = 15465,
  [16040] = 15514,
  [16041] = 15497,
  [16042] = 15466,
  [16043] = 15672,
  [16044] = 16044,
  [16045] = 15475,
  [16046] = 16044,
  [16047] = 15517,
  [16048] = 16048,
  [16049] = 16049,
  [16050] = 15771,
  [16051] = 15467,
  [16052] = 15474,
  [16053] = 15465,
  [16054] = 15514,
  [16055] = 15523,
  [16056] = 15514,
  [16057] = 15469,
  [16058] = 15596,
  [16059] = 16059,
  [16060] = 16060,
  [16061] = 15517,
  [16062] = 15517,
  [16063] = 15472,
  [16064] = 15485,
  [16065] = 15523,
  [16066] = 15465,
  [16067] = 15497,
  [16068] = 16068,
  [16069] = 15523,
  [16070] = 15523,
  [16071] = 15468,
  [16072] = 15469,
  [16073] = 15476,
  [16074] = 15517,
  [16075] = 15481,
  [16076] = 15523,
  [16077] = 15514,
  [16078] = 14887,
  [16079] = 15475,
  [16080] = 16080,
  [16081] = 15514,
  [16082] = 15469,
  [16083] = 15517,
  [16084] = 15523,
  [16085] = 15466,
  [16086] = 16086,
  [16087] = 15517,
  [16088] = 15467,
  [16089] = 15472,
  [16090] = 15475,
  [16091] = 15523,
  [16092] = 15476,
  [16093] = 15466,
  [16094] = 15467,
  [16095] = 16048,
  [16096] = 15481,
  [16097] = 15472,
  [16098] = 15517,
  [16099] = 15485,
  [16100] = 15483,
  [16101] = 15483,
  [16102] = 15476,
  [16103] = 15465,
  [16104] = 15481,
  [16105] = 15468,
  [16106] = 15469,
  [16107] = 15483,
  [16108] = 15485,
  [16109] = 15465,
  [16110] = 15497,
  [16111] = 15475,
  [16112] = 15468,
  [16113] = 15469,
  [16114] = 15497,
  [16115] = 15485,
  [16116] = 15465,
  [16117] = 15497,
  [16118] = 15514,
  [16119] = 15466,
  [16120] = 15467,
  [16121] = 15517,
  [16122] = 15574,
  [16123] = 15468,
  [16124] = 15517,
  [16125] = 15497,
  [16126] = 15469,
  [16127] = 15523,
  [16128] = 15485,
  [16129] = 15514,
  [16130] = 15465,
  [16131] = 15472,
  [16132] = 15466,
  [16133] = 15497,
  [16134] = 15476,
  [16135] = 15472,
  [16136] = 15594,
  [16137] = 15481,
  [16138] = 15475,
  [16139] = 15517,
  [16140] = 15475,
  [16141] = 15523,
  [16142] = 15483,
  [16143] = 16143,
  [16144] = 15475,
  [16145] = 15475,
  [16146] = 15468,
  [16147] = 15469,
  [16148] = 15475,
  [16149] = 15466,
  [16150] = 15466,
  [16151] = 15467,
  [16152] = 15467,
  [16153] = 15472,
  [16154] = 15472,
  [16155] = 15476,
  [16156] = 15481,
  [16157] = 15485,
  [16158] = 15465,
  [16159] = 15497,
  [16160] = 16160,
  [16161] = 15483,
  [16162] = 15514,
  [16163] = 15476,
  [16164] = 15468,
  [16165] = 16165,
  [16166] = 15469,
  [16167] = 15475,
  [16168] = 15485,
  [16169] = 15465,
  [16170] = 15517,
  [16171] = 15497,
  [16172] = 7068,
  [16173] = 15466,
  [16174] = 15467,
  [16175] = 15475,
  [16176] = 15523,
  [16177] = 15472,
  [16178] = 15481,
  [16179] = 15476,
  [16180] = 15523,
  [16181] = 15481,
  [16182] = 15466,
  [16183] = 15514,
  [16184] = 15467,
  [16185] = 15483,
  [16186] = 15476,
  [16187] = 15466,
  [16188] = 15472,
  [16189] = 15468,
  [16190] = 15469,
  [16191] = 15514,
  [16192] = 15517,
  [16193] = 15483,
  [16194] = 15485,
  [16195] = 15465,
  [16196] = 15497,
  [16197] = 15467,
  [16198] = 15475,
  [16199] = 7000,
  [16200] = 15523,
  [16201] = 15514,
  [16202] = 14631,
  [16203] = 15514,
  [16204] = 15517,
  [16205] = 15466,
  [16206] = 15476,
  [16207] = 15594,
  [16208] = 15523,
  [16209] = 15468,
  [16210] = 15469,
  [16211] = 15485,
  [16212] = 15466,
  [16213] = 15481,
  [16214] = 15467,
  [16215] = 15594,
  [16216] = 15475,
  [16217] = 15465,
  [16218] = 15466,
  [16219] = 15467,
  [16220] = 5986,
  [16221] = 15466,
  [16222] = 15466,
  [16223] = 15475,
  [16224] = 15472,
  [16225] = 15466,
  [16226] = 15467,
  [16227] = 15475,
  [16228] = 15476,
  [16229] = 15497,
  [16230] = 15466,
  [16231] = 15467,
  [16232] = 15481,
  [16233] = 15466,
  [16234] = 15467,
  [16235] = 16235,
  [16236] = 15483,
  [16237] = 15472,
  [16238] = 15672,
  [16239] = 16044,
  [16240] = 15574,
  [16241] = 4282,
  [16242] = 16048,
  [16243] = 16049,
  [16244] = 15771,
  [16245] = 15574,
  [16246] = 15476,
  [16247] = 15474,
  [16248] = 15467,
  [16249] = 15467,
  [16250] = 15481,
  [16251] = 15596,
  [16252] = 16059,
  [16253] = 16060,
  [16254] = 15517,
  [16255] = 15483,
  [16256] = 15467,
  [16257] = 15466,
  [16258] = 15468,
  [16259] = 15574,
  [16260] = 15469,
  [16261] = 15485,
  [16262] = 15483,
  [16263] = 15472,
  [16264] = 15465,
  [16265] = 15497,
  [16266] = 15476,
  [16267] = 15594,
  [16268] = 15574,
  [16269] = 15481,
  [16270] = 15467,
  [16271] = 15468,
  [16272] = 15469,
  [16273] = 16273,
  [16274] = 15485,
  [16275] = 15465,
  [16276] = 15497,
  [16277] = 15517,
  [16278] = 15472,
  [16279] = 15483,
  [16280] = 16068,
  [16281] = 4272,
  [16282] = 15468,
  [16283] = 15469,
  [16284] = 15481,
  [16285] = 15672,
  [16286] = 16044,
  [16287] = 14631,
  [16288] = 15514,
  [16289] = 16165,
  [16290] = 16048,
  [16291] = 16049,
  [16292] = 15771,
  [16293] = 14575,
  [16294] = 15474,
  [16295] = 15467,
  [16296] = 15574,
  [16297] = 15596,
  [16298] = 16059,
  [16299] = 16060,
  [16300] = 15517,
  [16301] = 15523,
  [16302] = 15475,
  [16303] = 15514,
  [16304] = 15466,
  [16305] = 15517,
  [16306] = 15485,
  [16307] = 15465,
  [16308] = 15497,
  [16309] = 15523,
  [16310] = 16310,
  [16311] = 15485,
  [16312] = 15468,
  [16313] = 15469,
  [16314] = 15465,
  [16315] = 15467,
  [16316] = 15472,
  [16317] = 15514,
  [16318] = 15472,
  [16319] = 15485,
  [16320] = 15497,
  [16321] = 15523,
  [16322] = 15476,
  [16323] = 15476,
  [16324] = 15481,
  [16325] = 15672,
  [16326] = 16044,
  [16327] = 15517,
  [16328] = 16048,
  [16329] = 16049,
  [16330] = 15771,
  [16331] = 15472,
  [16332] = 15475,
  [16333] = 15474,
  [16334] = 15523,
  [16335] = 15465,
  [16336] = 15596,
  [16337] = 16059,
  [16338] = 16060,
  [16339] = 15483,
  [16340] = 16340,
  [16341] = 15476,
  [16342] = 15472,
  [16343] = 15466,
  [16344] = 15467,
  [16345] = 15472,
  [16346] = 15497,
  [16347] = 15672,
  [16348] = 16044,
  [16349] = 15476,
  [16350] = 15476,
  [16351] = 15468,
  [16352] = 16352,
  [16353] = 15481,
  [16354] = 15469,
  [16355] = 16048,
  [16356] = 16049,
  [16357] = 15771,
  [16358] = 15594,
  [16359] = 15485,
  [16360] = 15474,
  [16361] = 7344,
  [16362] = 15523,
  [16363] = 15465,
  [16364] = 15596,
  [16365] = 16059,
  [16366] = 16060,
  [16367] = 15497,
  [16368] = 15481,
  [16369] = 15481,
  [16370] = 15483,
  [16371] = 15476,
  [16372] = 15594,
  [16373] = 15523,
  [16374] = 15517,
  [16375] = 15468,
  [16376] = 15469,
  [16377] = 15481,
  [16378] = 15485,
  [16379] = 15465,
  [16380] = 15672,
  [16381] = 16044,
  [16382] = 15517,
  [16383] = 15497,
  [16384] = 16048,
  [16385] = 16049,
  [16386] = 15771,
  [16387] = 15474,
  [16388] = 15483,
  [16389] = 15596,
  [16390] = 16059,
  [16391] = 16060,
  [16392] = 15483,
  [16393] = 16080,
  [16394] = 16086,
  [16395] = 16060,
  [16396] = 15514,
  [16397] = 15672,
  [16398] = 16044,
  [16399] = 15475,
  [16400] = 16048,
  [16401] = 16049,
  [16402] = 15771,
  [16403] = 15474,
  [16404] = 15475,
  [16405] = 15596,
  [16406] = 16059,
  [16407] = 16060,
  [16408] = 15475,
  [16409] = 16273,
  [16410] = 15475,
  [16411] = 15483,
  [16412] = 15672,
  [16413] = 16044,
  [16414] = 15517,
  [16415] = 15466,
  [16416] = 15467,
  [16417] = 16417,
  [16418] = 16048,
  [16419] = 16049,
  [16420] = 15771,
  [16421] = 15474,
  [16422] = 15475,
  [16423] = 15596,
  [16424] = 16059,
  [16425] = 16060,
  [16426] = 15466,
  [16427] = 15574,
  [16428] = 15467,
  [16429] = 15672,
  [16430] = 16044,
  [16431] = 15523,
  [16432] = 15468,
  [16433] = 16048,
  [16434] = 16049,
  [16435] = 15771,
  [16436] = 15474,
  [16437] = 15469,
  [16438] = 15596,
  [16439] = 16059,
  [16440] = 16060,
  [16441] = 15483,
  [16442] = 16442,
  [16443] = 15466,
  [16444] = 15483,
  [16445] = 15672,
  [16446] = 16044,
  [16447] = 15468,
  [16448] = 15467,
  [16449] = 16048,
  [16450] = 16049,
  [16451] = 15771,
  [16452] = 15474,
  [16453] = 15469,
  [16454] = 15596,
  [16455] = 16059,
  [16456] = 16060,
  [16457] = 15468,
  [16458] = 15472,
  [16459] = 15469,
  [16460] = 15472,
  [16461] = 15672,
  [16462] = 16044,
  [16463] = 15476,
  [16464] = 15594,
  [16465] = 16048,
  [16466] = 16049,
  [16467] = 15771,
  [16468] = 15481,
  [16469] = 15474,
  [16470] = 15596,
  [16471] = 16059,
  [16472] = 16060,
  [16473] = 15485,
  [16474] = 15476,
  [16475] = 15465,
  [16476] = 15481,
  [16477] = 15514,
  [16478] = 16068,
  [16479] = 15672,
  [16480] = 16044,
  [16481] = 15483,
  [16482] = 16048,
  [16483] = 16049,
  [16484] = 15771,
  [16485] = 15475,
  [16486] = 15474,
  [16487] = 15466,
  [16488] = 15596,
  [16489] = 16059,
  [16490] = 16060,
  [16491] = 15467,
  [16492] = 15468,
  [16493] = 15469,
  [16494] = 15468,
  [16495] = 15475,
  [16496] = 15483,
  [16497] = 15469,
  [16498] = 15466,
  [16499] = 16059,
  [16500] = 15483,
  [16501] = 15467,
  [16502] = 15485,
  [16503] = 15465,
  [16504] = 15497,
  [16505] = 15472,
  [16506] = 15497,
  [16507] = 15468,
  [16508] = 15476,
  [16509] = 15514,
  [16510] = 15481,
  [16511] = 15469,
  [16512] = 16049,
  [16513] = 15468,
  [16514] = 15469,
  [16515] = 15517,
  [16516] = 16352,
  [16517] = 15485,
  [16518] = 15523,
  [16519] = 15485,
  [16520] = 15483,
  [16521] = 15465,
  [16522] = 15465,
  [16523] = 15517,
  [16524] = 15468,
  [16525] = 15469,
  [16526] = 14658,
  [16527] = 15485,
  [16528] = 15465,
  [16529] = 15497,
  [16530] = 6174,
  [16531] = 15497,
  [16532] = 15497,
  [16533] = 15472,
  [16534] = 16534,
  [16535] = 15514,
  [16536] = 15517,
  [16537] = 15475,
  [16538] = 7344,
  [16539] = 15466,
  [16540] = 15523,
  [16541] = 15514,
  [16542] = 15523,
  [16543] = 15467,
  [16544] = 15485,
  [16545] = 15468,
  [16546] = 15517,
  [16547] = 15475,
  [16548] = 15483,
  [16549] = 15574,
  [16550] = 15472,
  [16551] = 15476,
  [16552] = 15514,
  [16553] = 15466,
  [16554] = 15467,
  [16555] = 15468,
  [16556] = 15574,
  [16557] = 15497,
  [16558] = 15475,
  [16559] = 15469,
  [16560] = 15514,
  [16561] = 15466,
  [16562] = 15467,
  [16563] = 15475,
  [16564] = 15472,
  [16565] = 15469,
  [16566] = 15476,
  [16567] = 15476,
  [16568] = 15481,
  [16569] = 15594,
  [16570] = 15517,
  [16571] = 15483,
  [16572] = 15472,
  [16573] = 15468,
  [16574] = 15514,
  [16575] = 15481,
  [16576] = 15523,
  [16577] = 15468,
  [16578] = 15469,
  [16579] = 15475,
  [16580] = 15485,
  [16581] = 15465,
  [16582] = 15497,
  [16583] = 15476,
  [16584] = 16352,
  [16585] = 15594,
  [16586] = 15476,
  [16587] = 15514,
  [16588] = 4281,
  [16589] = 15481,
  [16590] = 15466,
  [16591] = 15467,
  [16592] = 15514,
  [16593] = 15466,
  [16594] = 16352,
  [16595] = 15469,
  [16596] = 15523,
  [16597] = 15483,
  [16598] = 15517,
  [16599] = 15483,
  [16600] = 15467,
  [16601] = 16352,
  [16602] = 15468,
  [16603] = 15523,
  [16604] = 15475,
  [16605] = 15469,
  [16606] = 15468,
  [16607] = 16352,
  [16608] = 15469,
  [16609] = 15594,
  [16610] = 15517,
  [16611] = 15517,
  [16612] = 15481,
  [16613] = 15472,
  [16614] = 16352,
  [16615] = 15475,
  [16616] = 15523,
  [16617] = 16352,
  [16618] = 16352,
  [16619] = 16352,
  [16620] = 15475,
  [16621] = 15523,
  [16622] = 16352,
  [16623] = 16352,
  [16624] = 15475,
  [16625] = 16352,
  [16626] = 15466,
  [16627] = 15467,
  [16628] = 15466,
  [16629] = 15467,
  [16630] = 15475,
  [16631] = 15472,
  [16632] = 15517,
  [16633] = 15483,
  [16634] = 15476,
  [16635] = 16635,
  [16636] = 15481,
  [16637] = 15483,
  [16638] = 15483,
  [16639] = 15468,
  [16640] = 15469,
  [16641] = 15485,
  [16642] = 15465,
  [16643] = 15497,
  [16644] = 15523,
  [16645] = 15475,
  [16646] = 15485,
  [16647] = 15465,
  [16648] = 15497,
  [16649] = 15514,
  [16650] = 15466,
  [16651] = 15514,
  [16652] = 15468,
  [16653] = 15469,
  [16654] = 15469,
  [16655] = 16655,
  [16656] = 16656,
  [16657] = 16656,
  [16658] = 16658,
  [16659] = 16659,
  [16660] = 16659,
  [16661] = 16659,
  [16662] = 16659,
  [16663] = 16659,
  [16664] = 16664,
  [16665] = 16664,
  [16666] = 16666,
  [16667] = 16664,
  [16668] = 16668,
  [16669] = 16669,
  [16670] = 16668,
  [16671] = 16656,
  [16672] = 16669,
  [16673] = 16673,
  [16674] = 16659,
  [16675] = 16656,
  [16676] = 16676,
  [16677] = 16655,
  [16678] = 16678,
  [16679] = 4361,
  [16680] = 16656,
  [16681] = 16681,
  [16682] = 16668,
  [16683] = 4362,
  [16684] = 16684,
  [16685] = 16659,
  [16686] = 16656,
  [16687] = 16659,
  [16688] = 16688,
  [16689] = 16658,
  [16690] = 16664,
  [16691] = 16658,
  [16692] = 16669,
  [16693] = 16673,
  [16694] = 16658,
  [16695] = 16664,
  [16696] = 16658,
  [16697] = 16669,
  [16698] = 16656,
  [16699] = 16699,
  [16700] = 16669,
  [16701] = 16701,
  [16702] = 16702,
  [16703] = 16659,
  [16704] = 16659,
  [16705] = 16655,
  [16706] = 16706,
  [16707] = 16668,
  [16708] = 16676,
  [16709] = 16659,
  [16710] = 16681,
  [16711] = 16673,
  [16712] = 16664,
  [16713] = 16676,
  [16714] = 16658,
  [16715] = 16669,
  [16716] = 16659,
  [16717] = 16669,
  [16718] = 16659,
  [16719] = 16659,
  [16720] = 16720,
  [16721] = 16706,
  [16722] = 16655,
  [16723] = 16669,
  [16724] = 16673,
  [16725] = 16669,
  [16726] = 16655,
  [16727] = 16659,
  [16728] = 16684,
  [16729] = 16706,
  [16730] = 16658,
  [16731] = 16676,
  [16732] = 16669,
  [16733] = 16668,
  [16734] = 16664,
  [16735] = 16688,
  [16736] = 16669,
  [16737] = 16656,
  [16738] = 16684,
  [16739] = 16681,
  [16740] = 16658,
  [16741] = 16668,
  [16742] = 16668,
  [16743] = 16664,
  [16744] = 16688,
  [16745] = 16658,
  [16746] = 16656,
  [16747] = 16656,
  [16748] = 16664,
  [16749] = 16668,
  [16750] = 16658,
  [16751] = 16699,
  [16752] = 16658,
  [16753] = 16668,
  [16754] = 16673,
  [16755] = 16701,
  [16756] = 16699,
  [16757] = 16664,
  [16758] = 16701,
  [16759] = 16658,
  [16760] = 16656,
  [16761] = 16668,
  [16762] = 16417,
  [16763] = 16659,
  [16764] = 16658,
  [16765] = 16658,
  [16766] = 4282,
  [16767] = 16658,
  [16768] = 16659,
  [16769] = 16669,
  [16770] = 16658,
  [16771] = 16669,
  [16772] = 16676,
  [16773] = 16659,
  [16774] = 16656,
  [16775] = 16664,
  [16776] = 16658,
  [16777] = 9614,
  [16778] = 16706,
  [16779] = 16779,
  [16780] = 16656,
  [16781] = 16658,
  [16782] = 16668,
  [16783] = 16688,
  [16784] = 16669,
  [16785] = 16656,
  [16786] = 16702,
  [16787] = 16664,
  [16788] = 16669,
  [16789] = 16668,
  [16790] = 16659,
  [16791] = 16658,
  [16792] = 16658,
  [16793] = 16668,
  [16794] = 16699,
  [16795] = 16659,
  [16796] = 16701,
  [16797] = 16664,
  [16798] = 16664,
  [16799] = 16669,
  [16800] = 16668,
  [16801] = 16664,
  [16802] = 16706,
  [16803] = 16656,
  [16804] = 4458,
  [16805] = 16658,
  [16806] = 16669,
  [16807] = 16664,
  [16808] = 16656,
  [16809] = 16664,
  [16810] = 16668,
  [16811] = 16658,
  [16812] = 16664,
  [16813] = 16664,
  [16814] = 16658,
  [16815] = 16668,
  [16816] = 16669,
  [16817] = 16659,
  [16818] = 16669,
  [16819] = 16664,
  [16820] = 16659,
  [16821] = 16658,
  [16822] = 16656,
  [16823] = 16659,
  [16824] = 16688,
  [16825] = 16664,
  [16826] = 16669,
  [16827] = 16701,
  [16828] = 16681,
  [16829] = 16656,
  [16830] = 16658,
  [16831] = 16668,
  [16832] = 16699,
  [16833] = 16656,
  [16834] = 16701,
  [16835] = 16656,
  [16836] = 16664,
  [16837] = 16656,
  [16838] = 16702,
  [16839] = 16664,
  [16840] = 16669,
  [16841] = 16664,
  [16842] = 16702,
  [16843] = 16669,
  [16844] = 16664,
  [16845] = 16668,
  [16846] = 16656,
  [16847] = 16656,
  [16848] = 16720,
  [16849] = 16669,
  [16850] = 16668,
  [16851] = 16668,
  [16852] = 16656,
  [16853] = 16656,
  [16854] = 16688,
  [16855] = 16664,
  [16856] = 16706,
  [16857] = 16664,
  [16858] = 16702,
  [16859] = 16702,
  [16860] = 16656,
  [16861] = 16720,
  [16862] = 16699,
  [16863] = 16656,
  [16864] = 16701,
  [16865] = 16669,
  [16866] = 16668,
  [16867] = 16668,
  [16868] = 16658,
  [16869] = 16659,
  [16870] = 16720,
  [16871] = 16673,
  [16872] = 16668,
  [16873] = 16668,
  [16874] = 16659,
  [16875] = 16668,
  [16876] = 16669,
  [16877] = 16664,
  [16878] = 16688,
  [16879] = 16720,
  [16880] = 16669,
  [16881] = 16664,
  [16882] = 16668,
  [16883] = 16656,
  [16884] = 16659,
  [16885] = 16699,
  [16886] = 16684,
  [16887] = 16701,
  [16888] = 16676,
  [16889] = 16659,
  [16890] = 16658,
  [16891] = 16656,
  [16892] = 16669,
  [16893] = 16668,
  [16894] = 16659,
  [16895] = 16668,
  [16896] = 16664,
  [16897] = 16668,
  [16898] = 16688,
  [16899] = 16659,
  [16900] = 16656,
  [16901] = 16659,
  [16902] = 16669,
  [16903] = 16702,
  [16904] = 16656,
  [16905] = 16699,
  [16906] = 16673,
  [16907] = 16701,
  [16908] = 16676,
  [16909] = 16658,
  [16910] = 16664,
  [16911] = 16659,
  [16912] = 16656,
  [16913] = 16659,
  [16914] = 16669,
  [16915] = 16658,
  [16916] = 16673,
  [16917] = 16676,
  [16918] = 16669,
  [16919] = 16668,
  [16920] = 16658,
  [16921] = 16688,
  [16922] = 16668,
  [16923] = 16656,
  [16924] = 16684,
  [16925] = 16688,
  [16926] = 16669,
  [16927] = 16664,
  [16928] = 16699,
  [16929] = 16669,
  [16930] = 16701,
  [16931] = 16668,
  [16932] = 16658,
  [16933] = 16659,
  [16934] = 16720,
  [16935] = 16658,
  [16936] = 16656,
  [16937] = 16937,
  [16938] = 16659,
  [16939] = 16658,
  [16940] = 16702,
  [16941] = 16673,
  [16942] = 16664,
  [16943] = 16676,
  [16944] = 16664,
  [16945] = 16669,
  [16946] = 16688,
  [16947] = 16656,
  [16948] = 16656,
  [16949] = 16656,
  [16950] = 16656,
  [16951] = 16668,
  [16952] = 16668,
  [16953] = 16668,
  [16954] = 16668,
  [16955] = 16699,
  [16956] = 16658,
  [16957] = 16701,
  [16958] = 16659,
  [16959] = 16659,
  [16960] = 16702,
  [16961] = 16961,
  [16962] = 16658,
  [16963] = 16668,
  [16964] = 16659,
  [16965] = 16669,
  [16966] = 16659,
  [16967] = 16664,
  [16968] = 16673,
  [16969] = 16658,
  [16970] = 16669,
  [16971] = 7068,
  [16972] = 16706,
  [16973] = 16688,
  [16974] = 16655,
  [16975] = 16656,
  [16976] = 16681,
  [16977] = 16658,
  [16978] = 16668,
  [16979] = 16702,
  [16980] = 16668,
  [16981] = 16658,
  [16982] = 16669,
  [16983] = 16699,
  [16984] = 16659,
  [16985] = 16701,
  [16986] = 16673,
  [16987] = 16664,
  [16988] = 16658,
  [16989] = 16688,
  [16990] = 16699,
  [16991] = 16701,
  [16992] = 16658,
  [16993] = 16658,
  [16994] = 16658,
  [16995] = 16995,
  [16996] = 16688,
  [16997] = 16664,
  [16998] = 16699,
  [16999] = 16701,
  [17000] = 16688,
  [17001] = 16699,
  [17002] = 16701,
  [17003] = 16676,
  [17004] = 16688,
  [17005] = 16668,
  [17006] = 16699,
  [17007] = 16701,
  [17008] = 16688,
  [17009] = 16668,
  [17010] = 16659,
  [17011] = 16699,
  [17012] = 16701,
  [17013] = 16688,
  [17014] = 16656,
  [17015] = 16699,
  [17016] = 16701,
  [17017] = 16688,
  [17018] = 16699,
  [17019] = 16701,
  [17020] = 16688,
  [17021] = 16664,
  [17022] = 16699,
  [17023] = 16701,
  [17024] = 16688,
  [17025] = 17025,
  [17026] = 16699,
  [17027] = 16701,
  [17028] = 16656,
  [17029] = 16688,
  [17030] = 16699,
  [17031] = 16701,
  [17032] = 16668,
  [17033] = 16688,
  [17034] = 16699,
  [17035] = 16701,
  [17036] = 16656,
  [17037] = 16688,
  [17038] = 16659,
  [17039] = 16658,
  [17040] = 16701,
  [17041] = 16681,
  [17042] = 16688,
  [17043] = 16699,
  [17044] = 16701,
  [17045] = 16688,
  [17046] = 16669,
  [17047] = 16699,
  [17048] = 16701,
  [17049] = 16688,
  [17050] = 16699,
  [17051] = 16701,
  [17052] = 17052,
  [17053] = 16688,
  [17054] = 16699,
  [17055] = 16701,
  [17056] = 16720,
  [17057] = 16688,
  [17058] = 16659,
  [17059] = 16699,
  [17060] = 16701,
  [17061] = 16668,
  [17062] = 16699,
  [17063] = 7000,
  [17064] = 16699,
  [17065] = 16658,
  [17066] = 16699,
  [17067] = 16706,
  [17068] = 16699,
  [17069] = 16699,
  [17070] = 16658,
  [17071] = 16699,
  [17072] = 16664,
  [17073] = 16699,
  [17074] = 16655,
  [17075] = 16699,
  [17076] = 16658,
  [17077] = 16669,
  [17078] = 16699,
  [17079] = 16684,
  [17080] = 16699,
  [17081] = 16706,
  [17082] = 16699,
  [17083] = 16699,
  [17084] = 16699,
  [17085] = 16699,
  [17086] = 16668,
  [17087] = 16699,
  [17088] = 16699,
  [17089] = 16699,
  [17090] = 16699,
  [17091] = 16699,
  [17092] = 16658,
  [17093] = 16699,
  [17094] = 16699,
  [17095] = 16684,
  [17096] = 16699,
  [17097] = 16699,
  [17098] = 16699,
  [17099] = 16669,
  [17100] = 16699,
  [17101] = 16699,
  [17102] = 16659,
  [17103] = 16699,
  [17104] = 16699,
  [17105] = 16699,
  [17106] = 16699,
  [17107] = 16699,
  [17108] = 16699,
  [17109] = 16699,
  [17110] = 16699,
  [17111] = 16699,
  [17112] = 16699,
  [17113] = 16699,
  [17114] = 16699,
  [17115] = 16699,
  [17116] = 16699,
  [17117] = 16681,
  [17118] = 17118,
  [17119] = 16659,
  [17120] = 16664,
  [17121] = 16656,
  [17122] = 16664,
  [17123] = 16669,
  [17124] = 16720,
  [17125] = 16664,
  [17126] = 16656,
  [17127] = 16664,
  [17128] = 16656,
  [17129] = 16659,
  [17130] = 16668,
  [17131] = 16664,
  [17132] = 16658,
  [17133] = 16668,
  [17134] = 16659,
  [17135] = 16659,
  [17136] = 16659,
  [17137] = 16656,
  [17138] = 6557,
  [17139] = 16659,
  [17140] = 16659,
  [17141] = 16699,
  [17142] = 17142,
  [17143] = 16664,
  [17144] = 16668,
  [17145] = 16664,
  [17146] = 16664,
  [17147] = 16669,
  [17148] = 16658,
  [17149] = 16655,
  [17150] = 16655,
  [17151] = 16656,
  [17152] = 16668,
  [17153] = 16669,
  [17154] = 16659,
  [17155] = 16681,
  [17156] = 16669,
  [17157] = 16656,
  [17158] = 16676,
  [17159] = 16684,
  [17160] = 16669,
  [17161] = 16664,
  [17162] = 16702,
  [17163] = 16658,
  [17164] = 16669,
  [17165] = 16664,
  [17166] = 16664,
  [17167] = 16668,
  [17168] = 16664,
  [17169] = 16720,
  [17170] = 16706,
  [17171] = 16664,
  [17172] = 16668,
  [17173] = 16659,
  [17174] = 16681,
  [17175] = 16656,
  [17176] = 16656,
  [17177] = 16669,
  [17178] = 16720,
  [17179] = 16658,
  [17180] = 16659,
  [17181] = 16658,
  [17182] = 16659,
  [17183] = 16668,
  [17184] = 16664,
  [17185] = 16656,
  [17186] = 16656,
  [17187] = 16668,
  [17188] = 16664,
  [17189] = 16658,
  [17190] = 16659,
  [17191] = 16669,
  [17192] = 17192,
  [17193] = 16706,
  [17194] = 16673,
  [17195] = 16664,
  [17196] = 16658,
  [17197] = 16669,
  [17198] = 16656,
  [17199] = 16676,
  [17200] = 16655,
  [17201] = 16658,
  [17202] = 16656,
  [17203] = 16669,
  [17204] = 16656,
  [17205] = 16659,
  [17206] = 16669,
  [17207] = 16664,
  [17208] = 16720,
  [17209] = 16669,
  [17210] = 16656,
  [17211] = 16658,
  [17212] = 16659,
  [17213] = 16658,
  [17214] = 16669,
  [17215] = 17215,
  [17216] = 16681,
  [17217] = 16668,
  [17218] = 16669,
  [17219] = 16668,
  [17220] = 16668,
  [17221] = 16656,
  [17222] = 16668,
  [17223] = 16702,
  [17224] = 16656,
  [17225] = 16659,
  [17226] = 16664,
  [17227] = 16668,
  [17228] = 16669,
  [17229] = 16668,
  [17230] = 16659,
  [17231] = 16720,
  [17232] = 16658,
  [17233] = 16659,
  [17234] = 16669,
  [17235] = 16668,
  [17236] = 16669,
  [17237] = 16658,
  [17238] = 16706,
  [17239] = 16655,
  [17240] = 16659,
  [17241] = 16658,
  [17242] = 16668,
  [17243] = 16659,
  [17244] = 16664,
  [17245] = 16664,
  [17246] = 16664,
  [17247] = 16659,
  [17248] = 16656,
  [17249] = 16668,
  [17250] = 16684,
  [17251] = 16658,
  [17252] = 16658,
  [17253] = 16656,
  [17254] = 17254,
  [17255] = 16656,
  [17256] = 16702,
  [17257] = 16684,
  [17258] = 16669,
  [17259] = 16664,
  [17260] = 16655,
  [17261] = 16669,
  [17262] = 16659,
  [17263] = 16664,
  [17264] = 16656,
  [17265] = 16658,
  [17266] = 16681,
  [17267] = 16669,
  [17268] = 16681,
  [17269] = 16684,
  [17270] = 16669,
  [17271] = 16669,
  [17272] = 16684,
  [17273] = 16688,
  [17274] = 16664,
  [17275] = 16659,
  [17276] = 16658,
  [17277] = 16668,
  [17278] = 16659,
  [17279] = 16669,
  [17280] = 16658,
  [17281] = 16664,
  [17282] = 16668,
  [17283] = 16656,
  [17284] = 17284,
  [17285] = 16720,
  [17286] = 16664,
  [17287] = 16668,
  [17288] = 16669,
  [17289] = 16669,
  [17290] = 16656,
  [17291] = 16658,
  [17292] = 16699,
  [17293] = 16658,
  [17294] = 16668,
  [17295] = 16701,
  [17296] = 16668,
  [17297] = 16658,
  [17298] = 16656,
  [17299] = 16668,
  [17300] = 16669,
  [17301] = 16659,
  [17302] = 16668,
  [17303] = 16664,
  [17304] = 16664,
  [17305] = 16656,
  [17306] = 16655,
  [17307] = 16681,
  [17308] = 16720,
  [17309] = 16664,
  [17310] = 16656,
  [17311] = 16668,
  [17312] = 16656,
  [17313] = 16684,
  [17314] = 16669,
  [17315] = 16673,
  [17316] = 16676,
  [17317] = 16658,
  [17318] = 16659,
  [17319] = 16656,
  [17320] = 17142,
  [17321] = 16656,
  [17322] = 16668,
  [17323] = 16658,
  [17324] = 16659,
  [17325] = 4355,
  [17326] = 16659,
  [17327] = 16656,
  [17328] = 4340,
  [17329] = 16664,
  [17330] = 16668,
  [17331] = 16706,
  [17332] = 16664,
  [17333] = 16720,
  [17334] = 16720,
  [17335] = 16720,
  [17336] = 16720,
  [17337] = 16720,
  [17338] = 16720,
  [17339] = 16699,
  [17340] = 17340,
  [17341] = 17341,
  [17342] = 17342,
  [17343] = 17343,
  [17344] = 4600,
  [17345] = 17345,
  [17346] = 17346,
  [17347] = 17347,
  [17348] = 17348,
  [17349] = 17349,
  [17350] = 17350,
  [17351] = 17345,
  [17352] = 17352,
  [17353] = 17349,
  [17354] = 4634,
  [17355] = 17348,
  [17356] = 17349,
  [17357] = 17342,
  [17358] = 17348,
  [17359] = 17343,
  [17360] = 17345,
  [17361] = 17350,
  [17362] = 17362,
  [17363] = 17345,
  [17364] = 17345,
  [17365] = 17365,
  [17366] = 17347,
  [17367] = 17350,
  [17368] = 17343,
  [17369] = 17362,
  [17370] = 17365,
  [17371] = 17362,
  [17372] = 17349,
  [17373] = 17346,
  [17374] = 17350,
  [17375] = 17352,
  [17376] = 17365,
  [17377] = 17341,
  [17378] = 17362,
  [17379] = 17350,
  [17380] = 17348,
  [17381] = 17345,
  [17382] = 17342,
  [17383] = 6174,
  [17384] = 17350,
  [17385] = 17352,
  [17386] = 17346,
  [17387] = 17365,
  [17388] = 17347,
  [17389] = 17343,
  [17390] = 17349,
  [17391] = 17347,
  [17392] = 17350,
  [17393] = 17352,
  [17394] = 17341,
  [17395] = 17348,
  [17396] = 17342,
  [17397] = 17345,
  [17398] = 17348,
  [17399] = 17346,
  [17400] = 17350,
  [17401] = 17349,
  [17402] = 17345,
  [17403] = 7344,
  [17404] = 17349,
  [17405] = 17341,
  [17406] = 17362,
  [17407] = 17365,
  [17408] = 17342,
  [17409] = 17348,
  [17410] = 17345,
  [17411] = 4583,
  [17412] = 17350,
  [17413] = 17348,
  [17414] = 17350,
  [17415] = 17345,
  [17416] = 17350,
  [17417] = 17349,
  [17418] = 17346,
  [17419] = 17350,
  [17420] = 17346,
  [17421] = 17348,
  [17422] = 17345,
  [17423] = 17349,
  [17424] = 17350,
  [17425] = 17343,
  [17426] = 17348,
  [17427] = 17343,
  [17428] = 17349,
  [17429] = 17349,
  [17430] = 17343,
  [17431] = 17348,
  [17432] = 17345,
  [17433] = 17350,
  [17434] = 17352,
  [17435] = 17349,
  [17436] = 17341,
  [17437] = 17342,
  [17438] = 17347,
  [17439] = 17352,
  [17440] = 17343,
  [17441] = 17341,
  [17442] = 17342,
  [17443] = 17346,
  [17444] = 17346,
  [17445] = 17348,
  [17446] = 17345,
  [17447] = 17350,
  [17448] = 17350,
  [17449] = 17350,
  [17450] = 17349,
  [17451] = 17343,
  [17452] = 17343,
  [17453] = 17352,
  [17454] = 17343,
  [17455] = 17349,
  [17456] = 17341,
  [17457] = 17342,
  [17458] = 17346,
  [17459] = 17349,
  [17460] = 17349,
  [17461] = 17347,
  [17462] = 17343,
  [17463] = 17347,
  [17464] = 17349,
  [17465] = 4568,
  [17466] = 17348,
  [17467] = 17348,
  [17468] = 17345,
  [17469] = 17350,
  [17470] = 17348,
  [17471] = 17345,
  [17472] = 17352,
  [17473] = 4582,
  [17474] = 17343,
  [17475] = 17362,
  [17476] = 17341,
  [17477] = 17365,
  [17478] = 17342,
  [17479] = 17349,
  [17480] = 17346,
  [17481] = 17350,
  [17482] = 17345,
  [17483] = 4458,
  [17484] = 17345,
  [17485] = 17348,
  [17486] = 17345,
  [17487] = 17362,
  [17488] = 17350,
  [17489] = 17347,
  [17490] = 17343,
  [17491] = 17343,
  [17492] = 17343,
  [17493] = 17365,
  [17494] = 17343,
  [17495] = 17348,
  [17496] = 17349,
  [17497] = 17349,
  [17498] = 17350,
  [17499] = 17347,
  [17500] = 17362,
  [17501] = 17348,
  [17502] = 17347,
  [17503] = 17352,
  [17504] = 17345,
  [17505] = 17341,
  [17506] = 17342,
  [17507] = 17343,
  [17508] = 17345,
  [17509] = 17362,
  [17510] = 17365,
  [17511] = 17346,
  [17512] = 17348,
  [17513] = 17348,
  [17514] = 17348,
  [17515] = 17350,
  [17516] = 17345,
  [17517] = 17345,
  [17518] = 17362,
  [17519] = 17341,
  [17520] = 17340,
  [17521] = 17365,
  [17522] = 17362,
  [17523] = 17365,
  [17524] = 17350,
  [17525] = 17525,
  [17526] = 17526,
  [17527] = 17349,
  [17528] = 17528,
  [17529] = 17349,
  [17530] = 17350,
  [17531] = 17343,
  [17532] = 17348,
  [17533] = 17345,
  [17534] = 17343,
  [17535] = 17350,
  [17536] = 17365,
  [17537] = 17347,
  [17538] = 17362,
  [17539] = 17349,
  [17540] = 17347,
  [17541] = 17343,
  [17542] = 17365,
  [17543] = 17362,
  [17544] = 17352,
  [17545] = 17341,
  [17546] = 17342,
  [17547] = 17346,
  [17548] = 17347,
  [17549] = 17348,
  [17550] = 17345,
  [17551] = 17349,
  [17552] = 17350,
  [17553] = 17350,
  [17554] = 17343,
  [17555] = 17352,
  [17556] = 17350,
  [17557] = 17348,
  [17558] = 17341,
  [17559] = 17343,
  [17560] = 17365,
  [17561] = 17345,
  [17562] = 17347,
  [17563] = 17342,
  [17564] = 17352,
  [17565] = 17341,
  [17566] = 17343,
  [17567] = 17342,
  [17568] = 17350,
  [17569] = 17349,
  [17570] = 17362,
  [17571] = 17346,
  [17572] = 4686,
  [17573] = 17348,
  [17574] = 17365,
  [17575] = 17343,
  [17576] = 4587,
  [17577] = 17345,
  [17578] = 17346,
  [17579] = 17350,
  [17580] = 17347,
  [17581] = 17348,
  [17582] = 17349,
  [17583] = 17362,
  [17584] = 17345,
  [17585] = 17365,
  [17586] = 17350,
  [17587] = 17350,
  [17588] = 4749,
  [17589] = 17342,
  [17590] = 17347,
  [17591] = 17343,
  [17592] = 17349,
  [17593] = 17352,
  [17594] = 17350,
  [17595] = 17343,
  [17596] = 17352,
  [17597] = 17349,
  [17598] = 4569,
  [17599] = 17343,
  [17600] = 17348,
  [17601] = 17347,
  [17602] = 17345,
  [17603] = 17352,
  [17604] = 17343,
  [17605] = 17362,
  [17606] = 17365,
  [17607] = 17352,
  [17608] = 17608,
  [17609] = 17352,
  [17610] = 17341,
  [17611] = 17348,
  [17612] = 17341,
  [17613] = 17352,
  [17614] = 17341,
  [17615] = 17342,
  [17616] = 17342,
  [17617] = 17350,
  [17618] = 17345,
  [17619] = 17346,
  [17620] = 17346,
  [17621] = 17350,
  [17622] = 17342,
  [17623] = 17346,
  [17624] = 17349,
  [17625] = 17343,
  [17626] = 17349,
  [17627] = 17343,
  [17628] = 17347,
  [17629] = 17352,
  [17630] = 17349,
  [17631] = 17347,
  [17632] = 17348,
  [17633] = 17349,
  [17634] = 17345,
  [17635] = 17341,
  [17636] = 17341,
  [17637] = 17349,
  [17638] = 17362,
  [17639] = 17365,
  [17640] = 17346,
  [17641] = 17350,
  [17642] = 17342,
  [17643] = 17347,
  [17644] = 17352,
  [17645] = 17352,
  [17646] = 17343,
  [17647] = 17341,
  [17648] = 17341,
  [17649] = 17342,
  [17650] = 17352,
  [17651] = 17348,
  [17652] = 17342,
  [17653] = 17346,
  [17654] = 17345,
  [17655] = 17348,
  [17656] = 17350,
  [17657] = 17343,
  [17658] = 17346,
  [17659] = 17352,
  [17660] = 17348,
  [17661] = 17341,
  [17662] = 17345,
  [17663] = 17342,
  [17664] = 17346,
  [17665] = 17352,
  [17666] = 17341,
  [17667] = 17348,
  [17668] = 17342,
  [17669] = 17343,
  [17670] = 17346,
  [17671] = 17348,
  [17672] = 17342,
  [17673] = 17362,
  [17674] = 4684,
  [17675] = 17349,
  [17676] = 17345,
  [17677] = 17349,
  [17678] = 17341,
  [17679] = 17341,
  [17680] = 17345,
  [17681] = 17340,
  [17682] = 17362,
  [17683] = 17365,
  [17684] = 17525,
  [17685] = 17365,
  [17686] = 17342,
  [17687] = 17526,
  [17688] = 17349,
  [17689] = 17528,
  [17690] = 17347,
  [17691] = 17346,
  [17692] = 17350,
  [17693] = 17342,
  [17694] = 17346,
  [17695] = 17348,
  [17696] = 17350,
  [17697] = 17345,
  [17698] = 17345,
  [17699] = 17346,
  [17700] = 17350,
  [17701] = 17349,
  [17702] = 17346,
  [17703] = 17347,
  [17704] = 4738,
  [17705] = 17362,
  [17706] = 17350,
  [17707] = 17343,
  [17708] = 17343,
  [17709] = 17362,
  [17710] = 17347,
  [17711] = 17365,
  [17712] = 17348,
  [17713] = 17365,
  [17714] = 17345,
  [17715] = 17352,
  [17716] = 17349,
  [17717] = 17343,
  [17718] = 17343,
  [17719] = 17340,
  [17720] = 17525,
  [17721] = 17347,
  [17722] = 17526,
  [17723] = 17528,
  [17724] = 17348,
  [17725] = 17362,
  [17726] = 17352,
  [17727] = 17365,
  [17728] = 17345,
  [17729] = 17350,
  [17730] = 17350,
  [17731] = 17348,
  [17732] = 17348,
  [17733] = 17341,
  [17734] = 17345,
  [17735] = 17342,
  [17736] = 4570,
  [17737] = 17347,
  [17738] = 17346,
  [17739] = 17341,
  [17740] = 17362,
  [17741] = 17365,
  [17742] = 17343,
  [17743] = 17349,
  [17744] = 17349,
  [17745] = 17343,
  [17746] = 17350,
  [17747] = 17350,
  [17748] = 17342,
  [17749] = 17350,
  [17750] = 17349,
  [17751] = 5986,
  [17752] = 17340,
  [17753] = 17348,
  [17754] = 17525,
  [17755] = 17346,
  [17756] = 17345,
  [17757] = 17526,
  [17758] = 17528,
  [17759] = 17352,
  [17760] = 17341,
  [17761] = 17342,
  [17762] = 17346,
  [17763] = 17347,
  [17764] = 17349,
  [17765] = 17348,
  [17766] = 17349,
  [17767] = 17345,
  [17768] = 17350,
  [17769] = 17348,
  [17770] = 17345,
  [17771] = 17348,
  [17772] = 17340,
  [17773] = 17349,
  [17774] = 17525,
  [17775] = 17348,
  [17776] = 17526,
  [17777] = 17343,
  [17778] = 17528,
  [17779] = 17352,
  [17780] = 17341,
  [17781] = 17345,
  [17782] = 17347,
  [17783] = 17349,
  [17784] = 17342,
  [17785] = 17362,
  [17786] = 17346,
  [17787] = 17362,
  [17788] = 17365,
  [17789] = 17343,
  [17790] = 17365,
  [17791] = 17350,
  [17792] = 17340,
  [17793] = 17348,
  [17794] = 17348,
  [17795] = 17525,
  [17796] = 17352,
  [17797] = 17526,
  [17798] = 17348,
  [17799] = 17528,
  [17800] = 17345,
  [17801] = 17801,
  [17802] = 17345,
  [17803] = 17350,
  [17804] = 4272,
  [17805] = 17343,
  [17806] = 17350,
  [17807] = 17362,
  [17808] = 17340,
  [17809] = 17365,
  [17810] = 17525,
  [17811] = 17343,
  [17812] = 17526,
  [17813] = 17528,
  [17814] = 17343,
  [17815] = 17352,
  [17816] = 17341,
  [17817] = 17342,
  [17818] = 17346,
  [17819] = 17349,
  [17820] = 17343,
  [17821] = 17340,
  [17822] = 17350,
  [17823] = 17525,
  [17824] = 17526,
  [17825] = 17528,
  [17826] = 17348,
  [17827] = 17348,
  [17828] = 17340,
  [17829] = 17352,
  [17830] = 17525,
  [17831] = 17345,
  [17832] = 17526,
  [17833] = 17528,
  [17834] = 17350,
  [17835] = 17341,
  [17836] = 17342,
  [17837] = 17526,
  [17838] = 17342,
  [17839] = 17343,
  [17840] = 17346,
  [17841] = 17343,
  [17842] = 17340,
  [17843] = 17345,
  [17844] = 17525,
  [17845] = 17349,
  [17846] = 17349,
  [17847] = 17526,
  [17848] = 17528,
  [17849] = 17345,
  [17850] = 17343,
  [17851] = 17349,
  [17852] = 17349,
  [17853] = 4666,
  [17854] = 17362,
  [17855] = 17352,
  [17856] = 17341,
  [17857] = 17347,
  [17858] = 17340,
  [17859] = 17343,
  [17860] = 17525,
  [17861] = 17526,
  [17862] = 17528,
  [17863] = 17348,
  [17864] = 17347,
  [17865] = 17342,
  [17866] = 17345,
  [17867] = 17348,
  [17868] = 17350,
  [17869] = 17352,
  [17870] = 17341,
  [17871] = 17342,
  [17872] = 17340,
  [17873] = 17343,
  [17874] = 17352,
  [17875] = 17348,
  [17876] = 17525,
  [17877] = 17346,
  [17878] = 17343,
  [17879] = 17526,
  [17880] = 17528,
  [17881] = 17346,
  [17882] = 17345,
  [17883] = 17340,
  [17884] = 17362,
  [17885] = 17347,
  [17886] = 17341,
  [17887] = 4751,
  [17888] = 17340,
  [17889] = 17349,
  [17890] = 17362,
  [17891] = 17340,
  [17892] = 17347,
  [17893] = 17365,
  [17894] = 17342,
  [17895] = 17340,
  [17896] = 17365,
  [17897] = 17349,
  [17898] = 17340,
  [17899] = 17350,
  [17900] = 17340,
  [17901] = 17352,
  [17902] = 17347,
  [17903] = 17528,
  [17904] = 17340,
  [17905] = 17341,
  [17906] = 17348,
  [17907] = 17340,
  [17908] = 17342,
  [17909] = 17345,
  [17910] = 17346,
  [17911] = 17346,
  [17912] = 17350,
  [17913] = 17340,
  [17914] = 17340,
  [17915] = 17345,
  [17916] = 17352,
  [17917] = 17349,
  [17918] = 17340,
  [17919] = 17341,
  [17920] = 17349,
  [17921] = 17340,
  [17922] = 17343,
  [17923] = 17340,
  [17924] = 17342,
  [17925] = 17340,
  [17926] = 17346,
  [17927] = 17345,
  [17928] = 17340,
  [17929] = 17365,
  [17930] = 4602,
  [17931] = 17340,
  [17932] = 17349,
  [17933] = 17347,
  [17934] = 17340,
  [17935] = 17340,
  [17936] = 17348,
  [17937] = 17340,
  [17938] = 17343,
  [17939] = 17340,
  [17940] = 17349,
  [17941] = 17340,
  [17942] = 17340,
  [17943] = 17345,
  [17944] = 17340,
  [17945] = 17347,
  [17946] = 17340,
  [17947] = 17340,
  [17948] = 17362,
  [17949] = 17340,
  [17950] = 17348,
  [17951] = 17365,
  [17952] = 17340,
  [17953] = 17340,
  [17954] = 17340,
  [17955] = 17362,
  [17956] = 17340,
  [17957] = 17345,
  [17958] = 17340,
  [17959] = 17352,
  [17960] = 17340,
  [17961] = 17340,
  [17962] = 17340,
  [17963] = 17350,
  [17964] = 17340,
  [17965] = 17340,
  [17966] = 17341,
  [17967] = 17340,
  [17968] = 17342,
  [17969] = 17340,
  [17970] = 17346,
  [17971] = 17340,
  [17972] = 17340,
  [17973] = 17349,
  [17974] = 17340,
  [17975] = 17340,
  [17976] = 17347,
  [17977] = 17340,
  [17978] = 17349,
  [17979] = 17340,
  [17980] = 17365,
  [17981] = 17340,
  [17982] = 17343,
  [17983] = 17340,
  [17984] = 17362,
  [17985] = 17340,
  [17986] = 17340,
  [17987] = 17348,
  [17988] = 17340,
  [17989] = 17340,
  [17990] = 17349,
  [17991] = 17340,
  [17992] = 17340,
  [17993] = 17340,
  [17994] = 17349,
  [17995] = 17340,
  [17996] = 17365,
  [17997] = 17340,
  [17998] = 17348,
  [17999] = 17340,
  [18000] = 17350,
  [18001] = 17349,
  [18002] = 17348,
  [18003] = 17345,
  [18004] = 18004,
  [18005] = 17345,
  [18006] = 17347,
  [18007] = 17345,
  [18008] = 17349,
  [18009] = 17345,
  [18010] = 17348,
  [18011] = 17350,
  [18012] = 17348,
  [18013] = 17345,
  [18014] = 17347,
  [18015] = 17362,
  [18016] = 17345,
  [18017] = 18004,
  [18018] = 17362,
  [18019] = 17365,
  [18020] = 17365,
  [18021] = 17350,
  [18022] = 17350,
  [18023] = 17343,
  [18024] = 17362,
  [18025] = 17362,
  [18026] = 17350,
  [18027] = 17365,
  [18028] = 17343,
  [18029] = 17365,
  [18030] = 17345,
  [18031] = 4608,
  [18032] = 17352,
  [18033] = 17348,
  [18034] = 4584,
  [18035] = 17341,
  [18036] = 17342,
  [18037] = 17346,
  [18038] = 17349,
  [18039] = 17343,
  [18040] = 4610,
  [18041] = 4611,
  [18042] = 17343,
  [18043] = 17345,
  [18044] = 17352,
  [18045] = 17341,
  [18046] = 17342,
  [18047] = 17525,
  [18048] = 17350,
  [18049] = 17346,
  [18050] = 4755,
  [18051] = 17362,
  [18052] = 17348,
  [18053] = 17349,
  [18054] = 17348,
  [18055] = 4612,
  [18056] = 4613,
  [18057] = 17345,
  [18058] = 17350,
  [18059] = 17350,
  [18060] = 17365,
  [18061] = 17347,
  [18062] = 17347,
  [18063] = 17343,
  [18064] = 18064,
  [18065] = 17345,
  [18066] = 4614,
  [18067] = 4615,
  [18068] = 17349,
  [18069] = 17350,
  [18070] = 17343,
  [18071] = 17340,
  [18072] = 4660,
  [18073] = 17348,
  [18074] = 4622,
  [18075] = 18004,
  [18076] = 17362,
  [18077] = 17345,
  [18078] = 17365,
  [18079] = 4576,
  [18080] = 17362,
  [18081] = 17349,
  [18082] = 17365,
  [18083] = 4597,
  [18084] = 18004,
  [18085] = 4617,
  [18086] = 4618,
  [18087] = 4623,
  [18088] = 17350,
  [18089] = 17352,
  [18090] = 4626,
  [18091] = 17347,
  [18092] = 18004,
  [18093] = 17362,
  [18094] = 4632,
  [18095] = 17343,
  [18096] = 17348,
  [18097] = 18004,
  [18098] = 17345,
  [18099] = 17343,
  [18100] = 17347,
  [18101] = 18004,
  [18102] = 17350,
  [18103] = 17341,
  [18104] = 18004,
  [18105] = 17343,
  [18106] = 18004,
  [18107] = 17365,
  [18108] = 18004,
  [18109] = 17347,
  [18110] = 18004,
  [18111] = 17352,
  [18112] = 18004,
  [18113] = 17343,
  [18114] = 18004,
  [18115] = 17341,
  [18116] = 17342,
  [18117] = 17346,
  [18118] = 17341,
  [18119] = 17352,
  [18120] = 17341,
  [18121] = 17349,
  [18122] = 17342,
  [18123] = 17343,
  [18124] = 17349,
  [18125] = 17346,
  [18126] = 17350,
  [18127] = 17350,
  [18128] = 17362,
  [18129] = 17348,
  [18130] = 17352,
  [18131] = 17347,
  [18132] = 17349,
  [18133] = 17365,
  [18134] = 18134,
  [18135] = 17348,
  [18136] = 17348,
  [18137] = 17348,
  [18138] = 17341,
  [18139] = 17342,
  [18140] = 17345,
  [18141] = 17345,
  [18142] = 4573,
  [18143] = 4574,
  [18144] = 4631,
  [18145] = 17348,
  [18146] = 17362,
  [18147] = 17346,
  [18148] = 17362,
  [18149] = 17345,
  [18150] = 17365,
  [18151] = 17365,
  [18152] = 17350,
  [18153] = 17349,
  [18154] = 18154,
  [18155] = 18155,
  [18156] = 18156,
  [18157] = 18157,
  [18158] = 18158,
  [18159] = 18159,
  [18160] = 18160,
  [18161] = 18161,
  [18162] = 18162,
  [18163] = 18163,
  [18164] = 18164,
  [18165] = 18165,
  [18166] = 18166,
  [18167] = 18162,
  [18168] = 18168,
  [18169] = 18169,
  [18170] = 18170,
  [18171] = 18171,
  [18172] = 18172,
  [18173] = 18173,
  [18174] = 18158,
  [18175] = 18175,
  [18176] = 18176,
  [18177] = 18169,
  [18178] = 18178,
  [18179] = 18179,
  [18180] = 18180,
  [18181] = 18157,
  [18182] = 18182,
  [18183] = 18183,
  [18184] = 18176,
  [18185] = 18185,
  [18186] = 18186,
  [18187] = 18154,
  [18188] = 18157,
  [18189] = 18189,
  [18190] = 18156,
  [18191] = 18159,
  [18192] = 18175,
  [18193] = 18193,
  [18194] = 18194,
  [18195] = 18171,
  [18196] = 18196,
  [18197] = 18178,
  [18198] = 18198,
  [18199] = 18199,
  [18200] = 18200,
  [18201] = 18201,
  [18202] = 18171,
  [18203] = 18175,
  [18204] = 18157,
  [18205] = 4358,
  [18206] = 18175,
  [18207] = 18183,
  [18208] = 18157,
  [18209] = 18209,
  [18210] = 18157,
  [18211] = 18211,
  [18212] = 18154,
  [18213] = 18213,
  [18214] = 18154,
  [18215] = 18154,
  [18216] = 18193,
  [18217] = 18217,
  [18218] = 18162,
  [18219] = 18219,
  [18220] = 18200,
  [18221] = 18193,
  [18222] = 18222,
  [18223] = 18175,
  [18224] = 18224,
  [18225] = 18183,
  [18226] = 18154,
  [18227] = 18193,
  [18228] = 18176,
  [18229] = 18173,
  [18230] = 18189,
  [18231] = 18178,
  [18232] = 18179,
  [18233] = 18233,
  [18234] = 18201,
  [18235] = 18178,
  [18236] = 18175,
  [18237] = 18237,
  [18238] = 18238,
  [18239] = 18239,
  [18240] = 4373,
  [18241] = 18241,
  [18242] = 18178,
  [18243] = 18162,
  [18244] = 18168,
  [18245] = 18200,
  [18246] = 18217,
  [18247] = 18219,
  [18248] = 18222,
  [18249] = 18154,
  [18250] = 18250,
  [18251] = 18251,
  [18252] = 18176,
  [18253] = 18253,
  [18254] = 18157,
  [18255] = 18255,
  [18256] = 18256,
  [18257] = 18189,
  [18258] = 18157,
  [18259] = 18213,
  [18260] = 18260,
  [18261] = 18189,
  [18262] = 18173,
  [18263] = 7556,
  [18264] = 18250,
  [18265] = 18265,
  [18266] = 18182,
  [18267] = 18217,
  [18268] = 18183,
  [18269] = 18176,
  [18270] = 18154,
  [18271] = 18200,
  [18272] = 18189,
  [18273] = 18186,
  [18274] = 18155,
  [18275] = 18186,
  [18276] = 18200,
  [18277] = 18185,
  [18278] = 18201,
  [18279] = 18156,
  [18280] = 18159,
  [18281] = 18162,
  [18282] = 18160,
  [18283] = 18169,
  [18284] = 18219,
  [18285] = 18222,
  [18286] = 18176,
  [18287] = 18176,
  [18288] = 18173,
  [18289] = 18156,
  [18290] = 18198,
  [18291] = 18186,
  [18292] = 18157,
  [18293] = 18154,
  [18294] = 18172,
  [18295] = 18185,
  [18296] = 18256,
  [18297] = 18201,
  [18298] = 18298,
  [18299] = 18162,
  [18300] = 18178,
  [18301] = 18199,
  [18302] = 18156,
  [18303] = 18159,
  [18304] = 18175,
  [18305] = 18305,
  [18306] = 18176,
  [18307] = 18307,
  [18308] = 18308,
  [18309] = 18309,
  [18310] = 18310,
  [18311] = 18189,
  [18312] = 18312,
  [18313] = 18186,
  [18314] = 18314,
  [18315] = 18179,
  [18316] = 18198,
  [18317] = 18193,
  [18318] = 18318,
  [18319] = 18159,
  [18320] = 18156,
  [18321] = 18159,
  [18322] = 18189,
  [18323] = 18193,
  [18324] = 18178,
  [18325] = 18175,
  [18326] = 18175,
  [18327] = 18209,
  [18328] = 18157,
  [18329] = 18157,
  [18330] = 18175,
  [18331] = 18154,
  [18332] = 18200,
  [18333] = 18156,
  [18334] = 18175,
  [18335] = 18161,
  [18336] = 18156,
  [18337] = 18224,
  [18338] = 18233,
  [18339] = 18157,
  [18340] = 18251,
  [18341] = 18183,
  [18342] = 18155,
  [18343] = 18160,
  [18344] = 18173,
  [18345] = 18172,
  [18346] = 18180,
  [18347] = 18154,
  [18348] = 18154,
  [18349] = 18193,
  [18350] = 18166,
  [18351] = 18157,
  [18352] = 18237,
  [18353] = 18176,
  [18354] = 18180,
  [18355] = 18183,
  [18356] = 18238,
  [18357] = 18159,
  [18358] = 18185,
  [18359] = 18200,
  [18360] = 18239,
  [18361] = 18189,
  [18362] = 18265,
  [18363] = 18162,
  [18364] = 18158,
  [18365] = 18194,
  [18366] = 18196,
  [18367] = 18253,
  [18368] = 18199,
  [18369] = 18211,
  [18370] = 18185,
  [18371] = 18183,
  [18372] = 18173,
  [18373] = 18185,
  [18374] = 18201,
  [18375] = 18162,
  [18376] = 18201,
  [18377] = 18162,
  [18378] = 18178,
  [18379] = 18162,
  [18380] = 18173,
  [18381] = 18201,
  [18382] = 18176,
  [18383] = 18154,
  [18384] = 18241,
  [18385] = 18193,
  [18386] = 18200,
  [18387] = 18185,
  [18388] = 18186,
  [18389] = 18162,
  [18390] = 18176,
  [18391] = 18162,
  [18392] = 18194,
  [18393] = 18156,
  [18394] = 18159,
  [18395] = 18255,
  [18396] = 18193,
  [18397] = 18201,
  [18398] = 18198,
  [18399] = 18176,
  [18400] = 18196,
  [18401] = 18176,
  [18402] = 18182,
  [18403] = 18250,
  [18404] = 18176,
  [18405] = 18200,
  [18406] = 18200,
  [18407] = 18162,
  [18408] = 18178,
  [18409] = 18199,
  [18410] = 18189,
  [18411] = 18173,
  [18412] = 18175,
  [18413] = 18200,
  [18414] = 18157,
  [18415] = 18185,
  [18416] = 18162,
  [18417] = 18168,
  [18418] = 18211,
  [18419] = 4352,
  [18420] = 18200,
  [18421] = 18173,
  [18422] = 18154,
  [18423] = 18193,
  [18424] = 18183,
  [18425] = 18186,
  [18426] = 18178,
  [18427] = 18178,
  [18428] = 18189,
  [18429] = 18183,
  [18430] = 18189,
  [18431] = 18163,
  [18432] = 18432,
  [18433] = 18183,
  [18434] = 18198,
  [18435] = 18186,
  [18436] = 18213,
  [18437] = 18178,
  [18438] = 18156,
  [18439] = 18209,
  [18440] = 18308,
  [18441] = 18156,
  [18442] = 18159,
  [18443] = 18186,
  [18444] = 18186,
  [18445] = 18217,
  [18446] = 18200,
  [18447] = 18159,
  [18448] = 18185,
  [18449] = 18189,
  [18450] = 18211,
  [18451] = 18201,
  [18452] = 4375,
  [18453] = 18219,
  [18454] = 18222,
  [18455] = 18175,
  [18456] = 18162,
  [18457] = 18200,
  [18458] = 18157,
  [18459] = 18156,
  [18460] = 18176,
  [18461] = 18154,
  [18462] = 18159,
  [18463] = 18165,
  [18464] = 18186,
  [18465] = 18253,
  [18466] = 18185,
  [18467] = 18201,
  [18468] = 18173,
  [18469] = 18156,
  [18470] = 18162,
  [18471] = 18159,
  [18472] = 18250,
  [18473] = 18185,
  [18474] = 18201,
  [18475] = 18219,
  [18476] = 18176,
  [18477] = 18189,
  [18478] = 18186,
  [18479] = 18260,
  [18480] = 18480,
  [18481] = 18178,
  [18482] = 18176,
  [18483] = 18186,
  [18484] = 18161,
  [18485] = 18253,
  [18486] = 18200,
  [18487] = 18175,
  [18488] = 18173,
  [18489] = 18157,
  [18490] = 18162,
  [18491] = 18162,
  [18492] = 18253,
  [18493] = 18480,
  [18494] = 18154,
  [18495] = 18183,
  [18496] = 18156,
  [18497] = 18176,
  [18498] = 18159,
  [18499] = 18176,
  [18500] = 18500,
  [18501] = 18169,
  [18502] = 18500,
  [18503] = 4354,
  [18504] = 18158,
  [18505] = 18156,
  [18506] = 18176,
  [18507] = 18189,
  [18508] = 18159,
  [18509] = 18183,
  [18510] = 18510,
  [18511] = 18511,
  [18512] = 18161,
  [18513] = 18162,
  [18514] = 18255,
  [18515] = 18173,
  [18516] = 18164,
  [18517] = 18200,
  [18518] = 18176,
  [18519] = 18165,
  [18520] = 18166,
  [18521] = 18200,
  [18522] = 18156,
  [18523] = 18162,
  [18524] = 18173,
  [18525] = 18175,
  [18526] = 18255,
  [18527] = 18176,
  [18528] = 18159,
  [18529] = 18154,
  [18530] = 18154,
  [18531] = 18193,
  [18532] = 18178,
  [18533] = 18173,
  [18534] = 18154,
  [18535] = 18175,
  [18536] = 18536,
  [18537] = 18193,
  [18538] = 18171,
  [18539] = 18178,
  [18540] = 18157,
  [18541] = 18178,
  [18542] = 18163,
  [18543] = 18200,
  [18544] = 18185,
  [18545] = 18186,
  [18546] = 18186,
  [18547] = 18175,
  [18548] = 18193,
  [18549] = 18156,
  [18550] = 18169,
  [18551] = 18158,
  [18552] = 18179,
  [18553] = 18159,
  [18554] = 18178,
  [18555] = 18182,
  [18556] = 18183,
  [18557] = 18157,
  [18558] = 18154,
  [18559] = 18186,
  [18560] = 18193,
  [18561] = 18157,
  [18562] = 18173,
  [18563] = 18175,
  [18564] = 18186,
  [18565] = 18185,
  [18566] = 18157,
  [18567] = 18310,
  [18568] = 18161,
  [18569] = 18154,
  [18570] = 18213,
  [18571] = 18189,
  [18572] = 18193,
  [18573] = 18198,
  [18574] = 18164,
  [18575] = 18154,
  [18576] = 18198,
  [18577] = 18178,
  [18578] = 18265,
  [18579] = 18193,
  [18580] = 18260,
  [18581] = 18189,
  [18582] = 18156,
  [18583] = 18200,
  [18584] = 18159,
  [18585] = 18224,
  [18586] = 18250,
  [18587] = 18200,
  [18588] = 18201,
  [18589] = 18233,
  [18590] = 18162,
  [18591] = 18217,
  [18592] = 18312,
  [18593] = 18178,
  [18594] = 18176,
  [18595] = 18164,
  [18596] = 18173,
  [18597] = 18186,
  [18598] = 18165,
  [18599] = 18156,
  [18600] = 18162,
  [18601] = 18154,
  [18602] = 18178,
  [18603] = 18157,
  [18604] = 18165,
  [18605] = 18166,
  [18606] = 18189,
  [18607] = 18237,
  [18608] = 18238,
  [18609] = 18239,
  [18610] = 18156,
  [18611] = 18159,
  [18612] = 18183,
  [18613] = 18183,
  [18614] = 18154,
  [18615] = 18241,
  [18616] = 18166,
  [18617] = 18189,
  [18618] = 18175,
  [18619] = 18200,
  [18620] = 18163,
  [18621] = 18168,
  [18622] = 18185,
  [18623] = 18217,
  [18624] = 18219,
  [18625] = 18222,
  [18626] = 18201,
  [18627] = 18200,
  [18628] = 18162,
  [18629] = 18175,
  [18630] = 18510,
  [18631] = 18173,
  [18632] = 18250,
  [18633] = 18178,
  [18634] = 18305,
  [18635] = 18159,
  [18636] = 18171,
  [18637] = 18163,
  [18638] = 18253,
  [18639] = 18154,
  [18640] = 18176,
  [18641] = 18173,
  [18642] = 18157,
  [18643] = 18193,
  [18644] = 18194,
  [18645] = 18237,
  [18646] = 18178,
  [18647] = 18196,
  [18648] = 18237,
  [18649] = 18193,
  [18650] = 18480,
  [18651] = 18255,
  [18652] = 18238,
  [18653] = 18186,
  [18654] = 18239,
  [18655] = 18305,
  [18656] = 18156,
  [18657] = 18159,
  [18658] = 18154,
  [18659] = 18200,
  [18660] = 18238,
  [18661] = 18241,
  [18662] = 18183,
  [18663] = 18213,
  [18664] = 18209,
  [18665] = 18260,
  [18666] = 18186,
  [18667] = 18265,
  [18668] = 18265,
  [18669] = 18175,
  [18670] = 18175,
  [18671] = 18159,
  [18672] = 18157,
  [18673] = 18185,
  [18674] = 18176,
  [18675] = 18186,
  [18676] = 18157,
  [18677] = 18169,
  [18678] = 18298,
  [18679] = 18157,
  [18680] = 18201,
  [18681] = 18154,
  [18682] = 18173,
  [18683] = 18239,
  [18684] = 18156,
  [18685] = 18159,
  [18686] = 18154,
  [18687] = 18193,
  [18688] = 18156,
  [18689] = 18164,
  [18690] = 18189,
  [18691] = 18213,
  [18692] = 18196,
  [18693] = 18260,
  [18694] = 18178,
  [18695] = 18178,
  [18696] = 18168,
  [18697] = 18200,
  [18698] = 18179,
  [18699] = 18189,
  [18700] = 18198,
  [18701] = 18157,
  [18702] = 18183,
  [18703] = 18186,
  [18704] = 18193,
  [18705] = 18256,
  [18706] = 18175,
  [18707] = 18298,
  [18708] = 18175,
  [18709] = 18312,
  [18710] = 18305,
  [18711] = 18189,
  [18712] = 18307,
  [18713] = 18308,
  [18714] = 18309,
  [18715] = 18162,
  [18716] = 18189,
  [18717] = 18310,
  [18718] = 18175,
  [18719] = 18312,
  [18720] = 18185,
  [18721] = 18176,
  [18722] = 18241,
  [18723] = 18182,
  [18724] = 18159,
  [18725] = 18314,
  [18726] = 18185,
  [18727] = 18157,
  [18728] = 18185,
  [18729] = 18318,
  [18730] = 18201,
  [18731] = 18162,
  [18732] = 18179,
  [18733] = 18183,
  [18734] = 18175,
  [18735] = 18162,
  [18736] = 18157,
  [18737] = 18157,
  [18738] = 18265,
  [18739] = 18209,
  [18740] = 18510,
  [18741] = 18173,
  [18742] = 18200,
  [18743] = 18186,
  [18744] = 18176,
  [18745] = 18500,
  [18746] = 18176,
  [18747] = 18183,
  [18748] = 18200,
  [18749] = 18157,
  [18750] = 18185,
  [18751] = 18154,
  [18752] = 18173,
  [18753] = 18201,
  [18754] = 18155,
  [18755] = 18217,
  [18756] = 18173,
  [18757] = 18500,
  [18758] = 18201,
  [18759] = 18173,
  [18760] = 18224,
  [18761] = 18173,
  [18762] = 18186,
  [18763] = 18233,
  [18764] = 18156,
  [18765] = 18156,
  [18766] = 18159,
  [18767] = 18251,
  [18768] = 18159,
  [18769] = 18162,
  [18770] = 18178,
  [18771] = 18189,
  [18772] = 18219,
  [18773] = 18155,
  [18774] = 18160,
  [18775] = 18168,
  [18776] = 18172,
  [18777] = 18178,
  [18778] = 18180,
  [18779] = 18186,
  [18780] = 18233,
  [18781] = 18193,
  [18782] = 18194,
  [18783] = 18162,
  [18784] = 18196,
  [18785] = 18183,
  [18786] = 18200,
  [18787] = 18156,
  [18788] = 18159,
  [18789] = 18199,
  [18790] = 18183,
  [18791] = 18222,
  [18792] = 18159,
  [18793] = 18211,
  [18794] = 18162,
  [18795] = 18178,
  [18796] = 18176,
  [18797] = 18161,
  [18798] = 18175,
  [18799] = 18318,
  [18800] = 18157,
  [18801] = 18307,
  [18802] = 18154,
  [18803] = 18171,
  [18804] = 18510,
  [18805] = 18250,
  [18806] = 18198,
  [18807] = 18480,
  [18808] = 18185,
  [18809] = 18201,
  [18810] = 18157,
  [18811] = 18200,
  [18812] = 18500,
  [18813] = 18189,
  [18814] = 18189,
  [18815] = 18176,
  [18816] = 18154,
  [18817] = 18186,
  [18818] = 18193,
  [18819] = 18217,
  [18820] = 18173,
  [18821] = 18179,
  [18822] = 18162,
  [18823] = 18158,
  [18824] = 18162,
  [18825] = 18186,
  [18826] = 18308,
  [18827] = 18156,
  [18828] = 18176,
  [18829] = 18159,
  [18830] = 18164,
  [18831] = 18178,
  [18832] = 18161,
  [18833] = 18219,
  [18834] = 18173,
  [18835] = 18165,
  [18836] = 18189,
  [18837] = 18166,
  [18838] = 18260,
  [18839] = 18178,
  [18840] = 18164,
  [18841] = 18178,
  [18842] = 18154,
  [18843] = 18186,
  [18844] = 18183,
  [18845] = 18193,
  [18846] = 18200,
  [18847] = 18194,
  [18848] = 18186,
  [18849] = 18222,
  [18850] = 18200,
  [18851] = 18198,
  [18852] = 18237,
  [18853] = 18165,
  [18854] = 18163,
  [18855] = 18201,
  [18856] = 18198,
  [18857] = 18166,
  [18858] = 18173,
  [18859] = 18175,
  [18860] = 18510,
  [18861] = 18156,
  [18862] = 18186,
  [18863] = 18186,
  [18864] = 18157,
  [18865] = 18159,
  [18866] = 18238,
  [18867] = 18239,
  [18868] = 18178,
  [18869] = 18209,
  [18870] = 18480,
  [18871] = 18162,
  [18872] = 18186,
  [18873] = 18253,
  [18874] = 18186,
  [18875] = 18500,
  [18876] = 18241,
  [18877] = 18199,
  [18878] = 18250,
  [18879] = 18156,
  [18880] = 18173,
  [18881] = 18159,
  [18882] = 18209,
  [18883] = 18237,
  [18884] = 18309,
  [18885] = 18175,
  [18886] = 18156,
  [18887] = 18255,
  [18888] = 18159,
  [18889] = 18185,
  [18890] = 18318,
  [18891] = 18158,
  [18892] = 18201,
  [18893] = 18194,
  [18894] = 18157,
  [18895] = 18175,
  [18896] = 18156,
  [18897] = 18200,
  [18898] = 18157,
  [18899] = 18189,
  [18900] = 18154,
  [18901] = 18154,
  [18902] = 18189,
  [18903] = 18161,
  [18904] = 18162,
  [18905] = 18224,
  [18906] = 18154,
  [18907] = 18193,
  [18908] = 18176,
  [18909] = 18159,
  [18910] = 18175,
  [18911] = 18168,
  [18912] = 18189,
  [18913] = 18510,
  [18914] = 18157,
  [18915] = 18175,
  [18916] = 18233,
  [18917] = 18158,
  [18918] = 18163,
  [18919] = 18176,
  [18920] = 18169,
  [18921] = 18211,
  [18922] = 18217,
  [18923] = 18156,
  [18924] = 18164,
  [18925] = 18162,
  [18926] = 18165,
  [18927] = 18189,
  [18928] = 18166,
  [18929] = 18176,
  [18930] = 18160,
  [18931] = 18156,
  [18932] = 18176,
  [18933] = 18178,
  [18934] = 18156,
  [18935] = 18185,
  [18936] = 18213,
  [18937] = 18200,
  [18938] = 18189,
  [18939] = 18156,
  [18940] = 18260,
  [18941] = 18253,
  [18942] = 18161,
  [18943] = 18307,
  [18944] = 18219,
  [18945] = 18154,
  [18946] = 18193,
  [18947] = 18201,
  [18948] = 18185,
  [18949] = 18200,
  [18950] = 18510,
  [18951] = 18251,
  [18952] = 18480,
  [18953] = 18175,
  [18954] = 18171,
  [18955] = 18162,
  [18956] = 18222,
  [18957] = 18500,
  [18958] = 18185,
  [18959] = 18198,
  [18960] = 18201,
  [18961] = 18162,
  [18962] = 18185,
  [18963] = 18201,
  [18964] = 18176,
  [18965] = 18200,
  [18966] = 18176,
  [18967] = 18173,
  [18968] = 18162,
  [18969] = 18176,
  [18970] = 18159,
  [18971] = 18157,
  [18972] = 18251,
  [18973] = 18178,
  [18974] = 18158,
  [18975] = 18162,
  [18976] = 18171,
  [18977] = 18185,
  [18978] = 18156,
  [18979] = 18161,
  [18980] = 18169,
  [18981] = 18186,
  [18982] = 18164,
  [18983] = 18165,
  [18984] = 18265,
  [18985] = 18255,
  [18986] = 18156,
  [18987] = 18510,
  [18988] = 18159,
  [18989] = 18166,
  [18990] = 18159,
  [18991] = 18179,
  [18992] = 18189,
  [18993] = 18154,
  [18994] = 18193,
  [18995] = 18250,
  [18996] = 18201,
  [18997] = 18159,
  [18998] = 18185,
  [18999] = 18182,
  [19000] = 18183,
  [19001] = 18162,
  [19002] = 18175,
  [19003] = 18211,
  [19004] = 18201,
  [19005] = 18157,
  [19006] = 18172,
  [19007] = 18154,
  [19008] = 18175,
  [19009] = 18171,
  [19010] = 18163,
  [19011] = 18253,
  [19012] = 18200,
  [19013] = 18157,
  [19014] = 18164,
  [19015] = 18165,
  [19016] = 18156,
  [19017] = 18169,
  [19018] = 18155,
  [19019] = 18179,
  [19020] = 18166,
  [19021] = 18183,
  [19022] = 18198,
  [19023] = 18189,
  [19024] = 18510,
  [19025] = 18157,
  [19026] = 18173,
  [19027] = 18182,
  [19028] = 18183,
  [19029] = 18510,
  [19030] = 18255,
  [19031] = 18183,
  [19032] = 18162,
  [19033] = 18200,
  [19034] = 18173,
  [19035] = 18186,
  [19036] = 18173,
  [19037] = 18176,
  [19038] = 18213,
  [19039] = 18189,
  [19040] = 18154,
  [19041] = 18173,
  [19042] = 18154,
  [19043] = 18176,
  [19044] = 18185,
  [19045] = 18200,
  [19046] = 18155,
  [19047] = 18156,
  [19048] = 18193,
  [19049] = 18185,
  [19050] = 18201,
  [19051] = 18160,
  [19052] = 18260,
  [19053] = 18162,
  [19054] = 18183,
  [19055] = 18200,
  [19056] = 19056,
  [19057] = 18178,
  [19058] = 18173,
  [19059] = 18173,
  [19060] = 18176,
  [19061] = 18510,
  [19062] = 18198,
  [19063] = 18200,
  [19064] = 18176,
  [19065] = 18213,
  [19066] = 18186,
  [19067] = 18159,
  [19068] = 18198,
  [19069] = 18260,
  [19070] = 18176,
  [19071] = 18178,
  [19072] = 18480,
  [19073] = 18178,
  [19074] = 18159,
  [19075] = 18156,
  [19076] = 18186,
  [19077] = 18265,
  [19078] = 18186,
  [19079] = 18159,
  [19080] = 18156,
  [19081] = 18159,
  [19082] = 18155,
  [19083] = 18201,
  [19084] = 18265,
  [19085] = 18189,
  [19086] = 18199,
  [19087] = 18200,
  [19088] = 18200,
  [19089] = 18176,
  [19090] = 18200,
  [19091] = 18175,
  [19092] = 18154,
  [19093] = 18157,
  [19094] = 18309,
  [19095] = 18154,
  [19096] = 18185,
  [19097] = 18175,
  [19098] = 18510,
  [19099] = 18193,
  [19100] = 18186,
  [19101] = 18201,
  [19102] = 18314,
  [19103] = 18157,
  [19104] = 18480,
  [19105] = 18154,
  [19106] = 18189,
  [19107] = 18189,
  [19108] = 18173,
  [19109] = 18162,
  [19110] = 18156,
  [19111] = 18308,
  [19112] = 18178,
  [19113] = 18159,
  [19114] = 18209,
  [19115] = 18162,
  [19116] = 18179,
  [19117] = 18162,
  [19118] = 18193,
  [19119] = 18173,
  [19120] = 18185,
  [19121] = 18201,
  [19122] = 18162,
  [19123] = 18176,
  [19124] = 18510,
  [19125] = 18189,
  [19126] = 18163,
  [19127] = 18180,
  [19128] = 18173,
  [19129] = 18171,
  [19130] = 18186,
  [19131] = 18176,
  [19132] = 18178,
  [19133] = 18183,
  [19134] = 18211,
  [19135] = 18185,
  [19136] = 18510,
  [19137] = 18186,
  [19138] = 18186,
  [19139] = 18237,
  [19140] = 18162,
  [19141] = 18239,
  [19142] = 18238,
  [19143] = 18156,
  [19144] = 18510,
  [19145] = 18310,
  [19146] = 18176,
  [19147] = 18239,
  [19148] = 18183,
  [19149] = 18200,
  [19150] = 18201,
  [19151] = 18176,
  [19152] = 18510,
  [19153] = 18162,
  [19154] = 18185,
  [19155] = 18241,
  [19156] = 18183,
  [19157] = 18176,
  [19158] = 18172,
  [19159] = 18224,
  [19160] = 18510,
  [19161] = 18180,
  [19162] = 18175,
  [19163] = 18178,
  [19164] = 18256,
  [19165] = 18157,
  [19166] = 18168,
  [19167] = 18178,
  [19168] = 18510,
  [19169] = 18176,
  [19170] = 18182,
  [19171] = 18186,
  [19172] = 18176,
  [19173] = 18237,
  [19174] = 18217,
  [19175] = 18186,
  [19176] = 18510,
  [19177] = 18186,
  [19178] = 18175,
  [19179] = 18219,
  [19180] = 18238,
  [19181] = 18298,
  [19182] = 18222,
  [19183] = 18156,
  [19184] = 18510,
  [19185] = 18183,
  [19186] = 18156,
  [19187] = 18159,
  [19188] = 18239,
  [19189] = 18159,
  [19190] = 18250,
  [19191] = 18200,
  [19192] = 18510,
  [19193] = 18178,
  [19194] = 18156,
  [19195] = 18241,
  [19196] = 18200,
  [19197] = 18159,
  [19198] = 18175,
  [19199] = 18159,
  [19200] = 18510,
  [19201] = 18309,
  [19202] = 18253,
  [19203] = 18157,
  [19204] = 18168,
  [19205] = 18154,
  [19206] = 18175,
  [19207] = 18510,
  [19208] = 18157,
  [19209] = 18255,
  [19210] = 18186,
  [19211] = 18156,
  [19212] = 18159,
  [19213] = 18217,
  [19214] = 18510,
  [19215] = 18178,
  [19216] = 18219,
  [19217] = 18233,
  [19218] = 18154,
  [19219] = 18193,
  [19220] = 18183,
  [19221] = 18510,
  [19222] = 18175,
  [19223] = 18213,
  [19224] = 18200,
  [19225] = 18154,
  [19226] = 18260,
  [19227] = 18222,
  [19228] = 18510,
  [19229] = 18176,
  [19230] = 18162,
  [19231] = 18500,
  [19232] = 18250,
  [19233] = 18265,
  [19234] = 18178,
  [19235] = 18510,
  [19236] = 18175,
  [19237] = 18178,
  [19238] = 18176,
  [19239] = 18154,
  [19240] = 18173,
  [19241] = 18183,
  [19242] = 18510,
  [19243] = 18157,
  [19244] = 18201,
  [19245] = 18169,
  [19246] = 18160,
  [19247] = 18256,
  [19248] = 18189,
  [19249] = 18510,
  [19250] = 18159,
  [19251] = 18298,
  [19252] = 18251,
  [19253] = 18179,
  [19254] = 18253,
  [19255] = 18186,
  [19256] = 18183,
  [19257] = 18173,
  [19258] = 18186,
  [19259] = 18305,
  [19260] = 18200,
  [19261] = 18168,
  [19262] = 18154,
  [19263] = 18307,
  [19264] = 18255,
  [19265] = 18308,
  [19266] = 18185,
  [19267] = 18309,
  [19268] = 18310,
  [19269] = 18185,
  [19270] = 18156,
  [19271] = 18178,
  [19272] = 18159,
  [19273] = 18201,
  [19274] = 18162,
  [19275] = 18251,
  [19276] = 18180,
  [19277] = 18169,
  [19278] = 18298,
  [19279] = 18312,
  [19280] = 18198,
  [19281] = 18162,
  [19282] = 18178,
  [19283] = 18314,
  [19284] = 18201,
  [19285] = 18213,
  [19286] = 18176,
  [19287] = 18318,
  [19288] = 18260,
  [19289] = 18186,
  [19290] = 19290,
  [19291] = 18186,
  [19292] = 18183,
  [19293] = 18173,
  [19294] = 18189,
  [19295] = 18155,
  [19296] = 18156,
  [19297] = 18159,
  [19298] = 18256,
  [19299] = 18156,
  [19300] = 4376,
  [19301] = 18265,
  [19302] = 18298,
  [19303] = 18159,
  [19304] = 4377,
  [19305] = 18160,
  [19306] = 18237,
  [19307] = 18175,
  [19308] = 18305,
  [19309] = 18310,
  [19310] = 18156,
  [19311] = 18178,
  [19312] = 18159,
  [19313] = 18510,
  [19314] = 18307,
  [19315] = 18189,
  [19316] = 18183,
  [19317] = 18308,
  [19318] = 18175,
  [19319] = 18182,
  [19320] = 18309,
  [19321] = 18178,
  [19322] = 18157,
  [19323] = 18310,
  [19324] = 18157,
  [19325] = 18189,
  [19326] = 18172,
  [19327] = 18154,
  [19328] = 18480,
  [19329] = 18312,
  [19330] = 4374,
  [19331] = 18180,
  [19332] = 18182,
  [19333] = 18185,
  [19334] = 18156,
  [19335] = 18314,
  [19336] = 18175,
  [19337] = 18312,
  [19338] = 18318,
  [19339] = 18159,
  [19340] = 18237,
  [19341] = 18186,
  [19342] = 18222,
  [19343] = 18173,
  [19344] = 18162,
  [19345] = 18200,
  [19346] = 18224,
  [19347] = 18183,
  [19348] = 18175,
  [19349] = 18233,
  [19350] = 18500,
  [19351] = 18154,
  [19352] = 18238,
  [19353] = 18200,
  [19354] = 18157,
  [19355] = 18156,
  [19356] = 18162,
  [19357] = 18154,
  [19358] = 18251,
  [19359] = 18193,
  [19360] = 18183,
  [19361] = 18256,
  [19362] = 18173,
  [19363] = 18256,
  [19364] = 18176,
  [19365] = 18155,
  [19366] = 18186,
  [19367] = 18176,
  [19368] = 18178,
  [19369] = 18239,
  [19370] = 18159,
  [19371] = 18193,
  [19372] = 18160,
  [19373] = 18298,
  [19374] = 18186,
  [19375] = 18170,
  [19376] = 19290,
  [19377] = 18172,
  [19378] = 18238,
  [19379] = 18175,
  [19380] = 18200,
  [19381] = 18194,
  [19382] = 18156,
  [19383] = 18157,
  [19384] = 18176,
  [19385] = 18200,
  [19386] = 18159,
  [19387] = 18156,
  [19388] = 18159,
  [19389] = 18224,
  [19390] = 18536,
  [19391] = 18239,
  [19392] = 18200,
  [19393] = 18255,
  [19394] = 18238,
  [19395] = 19056,
  [19396] = 18241,
  [19397] = 18175,
  [19398] = 18233,
  [19399] = 18175,
  [19400] = 18480,
  [19401] = 18158,
  [19402] = 18173,
  [19403] = 18189,
  [19404] = 18241,
  [19405] = 18211,
  [19406] = 18157,
  [19407] = 18480,
  [19408] = 18189,
  [19409] = 18178,
  [19410] = 18251,
  [19411] = 18256,
  [19412] = 18155,
  [19413] = 18160,
  [19414] = 18168,
  [19415] = 18175,
  [19416] = 18194,
  [19417] = 18179,
  [19418] = 18178,
  [19419] = 18172,
  [19420] = 18180,
  [19421] = 18154,
  [19422] = 18173,
  [19423] = 18185,
  [19424] = 18217,
  [19425] = 18186,
  [19426] = 18219,
  [19427] = 18154,
  [19428] = 18193,
  [19429] = 18194,
  [19430] = 18196,
  [19431] = 18298,
  [19432] = 18199,
  [19433] = 18154,
  [19434] = 18211,
  [19435] = 18222,
  [19436] = 18196,
  [19437] = 18156,
  [19438] = 18186,
  [19439] = 18305,
  [19440] = 18159,
  [19441] = 18250,
  [19442] = 18157,
  [19443] = 18305,
  [19444] = 18156,
  [19445] = 18162,
  [19446] = 18159,
  [19447] = 18253,
  [19448] = 18200,
  [19449] = 18500,
  [19450] = 18172,
  [19451] = 18305,
  [19452] = 18307,
  [19453] = 18180,
  [19454] = 18200,
  [19455] = 18199,
  [19456] = 18255,
  [19457] = 18173,
  [19458] = 18189,
  [19459] = 18156,
  [19460] = 18175,
  [19461] = 18175,
  [19462] = 18154,
  [19463] = 18157,
  [19464] = 18154,
  [19465] = 18157,
  [19466] = 18256,
  [19467] = 18154,
  [19468] = 18193,
  [19469] = 18314,
  [19470] = 18163,
  [19471] = 18198,
  [19472] = 18213,
  [19473] = 18178,
  [19474] = 18260,
  [19475] = 18171,
  [19476] = 18154,
  [19477] = 18193,
  [19478] = 18298,
  [19479] = 18159,
  [19480] = 18209,
  [19481] = 18265,
  [19482] = 18224,
  [19483] = 18194,
  [19484] = 18154,
  [19485] = 18198,
  [19486] = 18193,
  [19487] = 18193,
  [19488] = 18211,
  [19489] = 18157,
  [19490] = 18185,
  [19491] = 18157,
  [19492] = 18158,
  [19493] = 18201,
  [19494] = 18305,
  [19495] = 18162,
  [19496] = 18193,
  [19497] = 18305,
  [19498] = 18162,
  [19499] = 18176,
  [19500] = 18200,
  [19501] = 18189,
  [19502] = 18162,
  [19503] = 18176,
  [19504] = 18176,
  [19505] = 18186,
  [19506] = 18200,
  [19507] = 18307,
  [19508] = 18196,
  [19509] = 18185,
  [19510] = 18178,
  [19511] = 18307,
  [19512] = 18199,
  [19513] = 18308,
  [19514] = 18201,
  [19515] = 18189,
  [19516] = 18308,
  [19517] = 18211,
  [19518] = 18156,
  [19519] = 18307,
  [19520] = 18159,
  [19521] = 18200,
  [19522] = 18480,
  [19523] = 18309,
  [19524] = 18500,
  [19525] = 18310,
  [19526] = 18194,
  [19527] = 18251,
  [19528] = 18158,
  [19529] = 18185,
  [19530] = 18201,
  [19531] = 18162,
  [19532] = 18200,
  [19533] = 18161,
  [19534] = 18169,
  [19535] = 18175,
  [19536] = 18176,
  [19537] = 18309,
  [19538] = 18164,
  [19539] = 18256,
  [19540] = 18186,
  [19541] = 18165,
  [19542] = 18166,
  [19543] = 18173,
  [19544] = 18237,
  [19545] = 18312,
  [19546] = 18308,
  [19547] = 18309,
  [19548] = 18189,
  [19549] = 18196,
  [19550] = 18173,
  [19551] = 18171,
  [19552] = 18163,
  [19553] = 18182,
  [19554] = 18314,
  [19555] = 18200,
  [19556] = 4380,
  [19557] = 18310,
  [19558] = 18178,
  [19559] = 18318,
  [19560] = 18310,
  [19561] = 18183,
  [19562] = 18307,
  [19563] = 18186,
  [19564] = 18169,
  [19565] = 18308,
  [19566] = 18314,
  [19567] = 18160,
  [19568] = 18201,
  [19569] = 18156,
  [19570] = 18159,
  [19571] = 18179,
  [19572] = 18312,
  [19573] = 18193,
  [19574] = 18157,
  [19575] = 18298,
  [19576] = 18182,
  [19577] = 18183,
  [19578] = 18309,
  [19579] = 18233,
  [19580] = 18200,
  [19581] = 18178,
  [19582] = 18175,
  [19583] = 18173,
  [19584] = 18156,
  [19585] = 18157,
  [19586] = 18159,
  [19587] = 18175,
  [19588] = 18238,
  [19589] = 18157,
  [19590] = 18310,
  [19591] = 18154,
  [19592] = 18173,
  [19593] = 18183,
  [19594] = 18185,
  [19595] = 18163,
  [19596] = 18173,
  [19597] = 18201,
  [19598] = 18162,
  [19599] = 18178,
  [19600] = 18239,
  [19601] = 18312,
  [19602] = 18178,
  [19603] = 18176,
  [19604] = 18175,
  [19605] = 18318,
  [19606] = 18209,
  [19607] = 18314,
  [19608] = 18157,
  [19609] = 18178,
  [19610] = 18183,
  [19611] = 18170,
  [19612] = 19290,
  [19613] = 18305,
  [19614] = 18241,
  [19615] = 18186,
  [19616] = 18312,
  [19617] = 18162,
  [19618] = 18178,
  [19619] = 18224,
  [19620] = 18233,
  [19621] = 18161,
  [19622] = 18318,
  [19623] = 18173,
  [19624] = 18176,
  [19625] = 18156,
  [19626] = 18198,
  [19627] = 18209,
  [19628] = 18161,
  [19629] = 18159,
  [19630] = 18175,
  [19631] = 18186,
  [19632] = 18185,
  [19633] = 18175,
  [19634] = 18198,
  [19635] = 18189,
  [19636] = 18154,
  [19637] = 18193,
  [19638] = 18256,
  [19639] = 18170,
  [19640] = 19290,
  [19641] = 18251,
  [19642] = 18154,
  [19643] = 18156,
  [19644] = 18154,
  [19645] = 18159,
  [19646] = 18193,
  [19647] = 18201,
  [19648] = 18199,
  [19649] = 18162,
  [19650] = 18200,
  [19651] = 18307,
  [19652] = 18314,
  [19653] = 18298,
  [19654] = 18189,
  [19655] = 18155,
  [19656] = 18200,
  [19657] = 18162,
  [19658] = 18189,
  [19659] = 18183,
  [19660] = 18160,
  [19661] = 18185,
  [19662] = 18201,
  [19663] = 18318,
  [19664] = 18318,
  [19665] = 18308,
  [19666] = 18170,
  [19667] = 19290,
  [19668] = 18175,
  [19669] = 18173,
  [19670] = 18175,
  [19671] = 18157,
  [19672] = 18175,
  [19673] = 18186,
  [19674] = 18164,
  [19675] = 18172,
  [19676] = 18189,
  [19677] = 18199,
  [19678] = 18305,
  [19679] = 18180,
  [19680] = 18189,
  [19681] = 18182,
  [19682] = 18178,
  [19683] = 18178,
  [19684] = 18307,
  [19685] = 18175,
  [19686] = 18154,
  [19687] = 18193,
  [19688] = 18157,
  [19689] = 18157,
  [19690] = 18308,
  [19691] = 18170,
  [19692] = 19290,
  [19693] = 18309,
  [19694] = 18237,
  [19695] = 18156,
  [19696] = 18238,
  [19697] = 18154,
  [19698] = 18239,
  [19699] = 18309,
  [19700] = 18241,
  [19701] = 18185,
  [19702] = 18186,
  [19703] = 18193,
  [19704] = 18310,
  [19705] = 18157,
  [19706] = 18312,
  [19707] = 18156,
  [19708] = 18201,
  [19709] = 18310,
  [19710] = 18163,
  [19711] = 18189,
  [19712] = 18159,
  [19713] = 18194,
  [19714] = 18168,
  [19715] = 18196,
  [19716] = 18170,
  [19717] = 19290,
  [19718] = 18154,
  [19719] = 18159,
  [19720] = 18165,
  [19721] = 18199,
  [19722] = 18217,
  [19723] = 18219,
  [19724] = 18185,
  [19725] = 18222,
  [19726] = 18201,
  [19727] = 18162,
  [19728] = 18314,
  [19729] = 18250,
  [19730] = 18211,
  [19731] = 18318,
  [19732] = 18175,
  [19733] = 18158,
  [19734] = 18198,
  [19735] = 18253,
  [19736] = 18157,
  [19737] = 18255,
  [19738] = 18176,
  [19739] = 18170,
  [19740] = 19290,
  [19741] = 18186,
  [19742] = 18154,
  [19743] = 18209,
  [19744] = 18314,
  [19745] = 18170,
  [19746] = 19290,
  [19747] = 18173,
  [19748] = 18180,
  [19749] = 18200,
  [19750] = 18162,
  [19751] = 18170,
  [19752] = 19290,
  [19753] = 18185,
  [19754] = 18166,
  [19755] = 19755,
  [19756] = 18201,
  [19757] = 18170,
  [19758] = 19290,
  [19759] = 18200,
  [19760] = 18162,
  [19761] = 18189,
  [19762] = 18189,
  [19763] = 18170,
  [19764] = 19290,
  [19765] = 18189,
  [19766] = 18172,
  [19767] = 18318,
  [19768] = 18178,
  [19769] = 18170,
  [19770] = 19290,
  [19771] = 18185,
  [19772] = 18176,
  [19773] = 18157,
  [19774] = 18156,
  [19775] = 18162,
  [19776] = 18511,
  [19777] = 18201,
  [19778] = 18196,
  [19779] = 18159,
  [19780] = 18178,
  [19781] = 18186,
  [19782] = 18176,
  [19783] = 18162,
  [19784] = 18183,
  [19785] = 18162,
  [19786] = 18154,
  [19787] = 18162,
  [19788] = 18162,
  [19789] = 18173,
  [19790] = 18175,
  [19791] = 18500,
  [19792] = 18224,
  [19793] = 18176,
  [19794] = 18189,
  [19795] = 18175,
  [19796] = 18200,
  [19797] = 18200,
  [19798] = 18176,
  [19799] = 18185,
  [19800] = 18176,
  [19801] = 18200,
  [19802] = 18201,
  [19803] = 18157,
  [19804] = 18157,
  [19805] = 18183,
  [19806] = 18162,
  [19807] = 18511,
  [19808] = 18175,
  [19809] = 18312,
  [19810] = 18213,
  [19811] = 18260,
  [19812] = 18173,
  [19813] = 18265,
  [19814] = 18298,
  [19815] = 18196,
  [19816] = 18178,
  [19817] = 18157,
  [19818] = 18511,
  [19819] = 18314,
  [19820] = 18233,
  [19821] = 18178,
  [19822] = 18176,
  [19823] = 18178,
  [19824] = 18256,
  [19825] = 18175,
  [19826] = 18186,
  [19827] = 18186,
  [19828] = 18186,
  [19829] = 18511,
  [19830] = 18154,
  [19831] = 18156,
  [19832] = 18224,
  [19833] = 18186,
  [19834] = 18186,
  [19835] = 18200,
  [19836] = 18233,
  [19837] = 18175,
  [19838] = 18511,
  [19839] = 18171,
  [19840] = 18251,
  [19841] = 18156,
  [19842] = 18159,
  [19843] = 18156,
  [19844] = 18159,
  [19845] = 18198,
  [19846] = 18155,
  [19847] = 18511,
  [19848] = 18241,
  [19849] = 18164,
  [19850] = 18173,
  [19851] = 18209,
  [19852] = 18165,
  [19853] = 18159,
  [19854] = 18160,
  [19855] = 18185,
  [19856] = 18511,
  [19857] = 18172,
  [19858] = 18251,
  [19859] = 18511,
  [19860] = 18186,
  [19861] = 18166,
  [19862] = 18511,
  [19863] = 18200,
  [19864] = 18156,
  [19865] = 18511,
  [19866] = 18176,
  [19867] = 18159,
  [19868] = 18511,
  [19869] = 18480,
  [19870] = 18180,
  [19871] = 18511,
  [19872] = 18200,
  [19873] = 4369,
  [19874] = 18175,
  [19875] = 18168,
  [19876] = 18157,
  [19877] = 18224,
  [19878] = 18154,
  [19879] = 18500,
  [19880] = 18173,
};

static TSCharacterRange sym__word_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xa9, 0xaa}, {0xae, 0xae}, {0xb0, 0xb0}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a},
  {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710},
  {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a},
  {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939},
  {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc},
  {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30},
  {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd},
  {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e},
  {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5},
  {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47},
  {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711},
  {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878},
  {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9},
  {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5},
  {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3},
  {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203c, 0x203c}, {0x2049, 0x2049},
  {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d},
  {0x2122, 0x2122}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e},
  {0x2160, 0x2188}, {0x2194, 0x2199}, {0x21a9, 0x21aa}, {0x2200, 0x2207}, {0x220e, 0x2211}, {0x222b, 0x2233}, {0x231a, 0x231b}, {0x2328, 0x2328},
  {0x23cf, 0x23cf}, {0x23e9, 0x23f3}, {0x23f8, 0x23fa}, {0x24c2, 0x24c2}, {0x25aa, 0x25ab}, {0x25b6, 0x25b6}, {0x25c0, 0x25c0}, {0x25fb, 0x25fe},
  {0x2600, 0x2604}, {0x260e, 0x260e}, {0x2611, 0x2611}, {0x2614, 0x2615}, {0x2618, 0x2618}, {0x261d, 0x261d}, {0x2620, 0x2620}, {0x2622, 0x2623},
  {0x2626, 0x2626}, {0x262a, 0x262a}, {0x262e, 0x262f}, {0x2638, 0x263a}, {0x2640, 0x2640}, {0x2642, 0x2642}, {0x2648, 0x2653}, {0x265f, 0x2660},
  {0x2663, 0x2663}, {0x2665, 0x2666}, {0x2668, 0x2668}, {0x267b, 0x267b}, {0x267e, 0x267f}, {0x2692, 0x2697}, {0x2699, 0x2699}, {0x269b, 0x269c},
  {0x26a0, 0x26a1}, {0x26a7, 0x26a7}, {0x26aa, 0x26ab}, {0x26b0, 0x26b1}, {0x26bd, 0x26be}, {0x26c4, 0x26c5}, {0x26c8, 0x26c8}, {0x26ce, 0x26cf},
  {0x26d1, 0x26d1}, {0x26d3, 0x26d4}, {0x26e9, 0x26ea}, {0x26f0, 0x26f5}, {0x26f7, 0x26fa}, {0x26fd, 0x26fd}, {0x2702, 0x2702}, {0x2705, 0x2705},
  {0x2708, 0x270d}, {0x270f, 0x270f}, {0x2712, 0x2712}, {0x2714, 0x2714}, {0x2716, 0x2716}, {0x271d, 0x271d}, {0x2721, 0x2721}, {0x2728, 0x2728},
  {0x2733, 0x2734}, {0x2744, 0x2744}, {0x2747, 0x2747}, {0x274c, 0x274c}, {0x274e, 0x274e}, {0x2753, 0x2755}, {0x2757, 0x2757}, {0x2763, 0x2764},
  {0x2795, 0x2797}, {0x27a1, 0x27a1}, {0x27b0, 0x27b0}, {0x27bf, 0x27bf}, {0x2934, 0x2935}, {0x2b05, 0x2b07}, {0x2b1b, 0x2b1c}, {0x2b50, 0x2b50},
  {0x2b55, 0x2b55}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67},
  {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce},
  {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3030, 0x3035}, {0x3038, 0x303d}, {0x3041, 0x3096}, {0x309d, 0x309f},
  {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3297, 0x3297}, {0x3299, 0x3299},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d},
  {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801},
  {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe},
  {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe},
  {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6},
  {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e},
  {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36},
  {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f},
  {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d},
  {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7},
  {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa},
  {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3},
  {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a},
  {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736},
  {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835},
  {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915},
  {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45},
  {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8},
  {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da},
  {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d},
  {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339},
  {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5},
  {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a},
  {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f},
  {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32},
  {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40},
  {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89},
  {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e},
  {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe},
  {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50},
  {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb},
  {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a},
  {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6},
  {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c},
  {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da},
  {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2},
  {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad},
  {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943},
  {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37},
  {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52},
  {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64},
  {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3},
  {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1f004, 0x1f004}, {0x1f0cf, 0x1f0cf}, {0x1f170, 0x1f171}, {0x1f17e, 0x1f17f}, {0x1f18e, 0x1f18e}, {0x1f191, 0x1f19a},
  {0x1f1e6, 0x1f1ff}, {0x1f201, 0x1f202}, {0x1f21a, 0x1f21a}, {0x1f22f, 0x1f22f}, {0x1f232, 0x1f23a}, {0x1f250, 0x1f251}, {0x1f300, 0x1f321}, {0x1f324, 0x1f393},
  {0x1f396, 0x1f397}, {0x1f399, 0x1f39b}, {0x1f39e, 0x1f3f0}, {0x1f3f3, 0x1f3f5}, {0x1f3f7, 0x1f4fd}, {0x1f4ff, 0x1f53d}, {0x1f549, 0x1f54e}, {0x1f550, 0x1f567},
  {0x1f56f, 0x1f570}, {0x1f573, 0x1f57a}, {0x1f587, 0x1f587}, {0x1f58a, 0x1f58d}, {0x1f590, 0x1f590}, {0x1f595, 0x1f596}, {0x1f5a4, 0x1f5a5}, {0x1f5a8, 0x1f5a8},
  {0x1f5b1, 0x1f5b2}, {0x1f5bc, 0x1f5bc}, {0x1f5c2, 0x1f5c4}, {0x1f5d1, 0x1f5d3}, {0x1f5dc, 0x1f5de}, {0x1f5e1, 0x1f5e1}, {0x1f5e3, 0x1f5e3}, {0x1f5e8, 0x1f5e8},
  {0x1f5ef, 0x1f5ef}, {0x1f5f3, 0x1f5f3}, {0x1f5fa, 0x1f64f}, {0x1f680, 0x1f6c5}, {0x1f6cb, 0x1f6d2}, {0x1f6d5, 0x1f6d7}, {0x1f6dc, 0x1f6e5}, {0x1f6e9, 0x1f6e9},
  {0x1f6eb, 0x1f6ec}, {0x1f6f0, 0x1f6f0}, {0x1f6f3, 0x1f6fc}, {0x1f7e0, 0x1f7eb}, {0x1f7f0, 0x1f7f0}, {0x1f90c, 0x1f93a}, {0x1f93c, 0x1f945}, {0x1f947, 0x1f9ff},
  {0x1fa70, 0x1fa7c}, {0x1fa80, 0x1fa88}, {0x1fa90, 0x1fabd}, {0x1fabf, 0x1fac5}, {0x1face, 0x1fadb}, {0x1fae0, 0x1fae8}, {0x1faf0, 0x1faf8}, {0x20000, 0x2a6df},
  {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym__word_identifier_character_set_2[] = {
  {0, 0x08}, {0x0e, 0x1f}, {'!', '!'}, {'0', '9'}, {'?', '?'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'},
  {0x7f, 0xa5}, {0xa7, 0xab}, {0xad, 0xb0}, {0xb2, 0xb6}, {0xb8, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2025}, {0x2027, 0x205c},
  {0x205e, 0x214a}, {0x214c, 0x218f}, {0x2195, 0x2199}, {0x219f, 0x219f}, {0x21a1, 0x21a1}, {0x21a5, 0x21a5}, {0x21a7, 0x21a8}, {0x21ad, 0x21ad},
  {0x21af, 0x21b5}, {0x21b8, 0x21b9}, {0x21be, 0x21bf}, {0x21c2, 0x21c3}, {0x21c5, 0x21c5}, {0x21c8, 0x21c8}, {0x21ca, 0x21ca}, {0x21d1, 0x21d1},
  {0x21d3, 0x21d3}, {0x21d5, 0x21d9}, {0x21de, 0x21df}, {0x21e1, 0x21e1}, {0x21e3, 0x21f3}, {0x2200, 0x2207}, {0x220e, 0x2211}, {0x2215, 0x2216},
  {0x221e, 0x2223}, {0x222b, 0x2236}, {0x2239, 0x2239}, {0x223c, 0x223c}, {0x223f, 0x223f}, {0x228c, 0x228c}, {0x229d, 0x229d}, {0x22a4, 0x22a8},
  {0x22aa, 0x22ab}, {0x22ad, 0x22ad}, {0x22af, 0x22af}, {0x22b8, 0x22ba}, {0x22be, 0x22c3}, {0x22c8, 0x22c8}, {0x22d4, 0x22d4}, {0x2300, 0x233e},
  {0x2340, 0x25b6}, {0x25b8, 0x27c1}, {0x27c3, 0x27c6}, {0x27ca, 0x27d0}, {0x27d3, 0x27d4}, {0x27d8, 0x27ef}, {0x27f2, 0x27f4}, {0x27f8, 0x27f8},
  {0x2800, 0x28ff}, {0x2919, 0x291c}, {0x2921, 0x2943}, {0x2971, 0x2976}, {0x2978, 0x2979}, {0x297b, 0x29b6}, {0x29b9, 0x29bb}, {0x29bd, 0x29bd},
  {0x29c2, 0x29e0}, {0x29e2, 0x29e2}, {0x29e6, 0x29f3}, {0x29f5, 0x29f5}, {0x29f8, 0x29f9}, {0x29fc, 0x2a06}, {0x2a09, 0x2a1c}, {0x2a1e, 0x2a1e},
  {0x2a20, 0x2a21}, {0x2a2f, 0x2a2f}, {0x2a3e, 0x2a3f}, {0x2a46, 0x2a49}, {0x2a59, 0x2a59}, {0x2a64, 0x2a65}, {0x2a68, 0x2a69}, {0x2ada, 0x2ada},
  {0x2adc, 0x2ae9}, {0x2aec, 0x2af6}, {0x2afb, 0x2b2f}, {0x2b45, 0x2b46}, {0x2b4d, 0xffe8}, {0xffed, 0x10ffff},
};

static TSCharacterRange sym__arrow_operator_character_set_2[] = {
  {'-', '-'}, {'<', '<'}, {0x2190, 0x2190}, {0x2192, 0x2192}, {0x2194, 0x2194}, {0x219a, 0x219e}, {0x21a0, 0x21a0}, {0x21a2, 0x21a4},
  {0x21a6, 0x21a6}, {0x21a9, 0x21ac}, {0x21ae, 0x21ae}, {0x21b6, 0x21b7}, {0x21ba, 0x21bd}, {0x21c0, 0x21c1}, {0x21c4, 0x21c4}, {0x21c6, 0x21c7},
  {0x21c9, 0x21c9}, {0x21cb, 0x21d0}, {0x21d2, 0x21d2}, {0x21d4, 0x21d4}, {0x21da, 0x21dd}, {0x21e0, 0x21e0}, {0x21e2, 0x21e2}, {0x21f4, 0x21f4},
  {0x21f6, 0x21ff}, {0x27f5, 0x27f7}, {0x27f9, 0x27ff}, {0x2900, 0x2907}, {0x290c, 0x2911}, {0x2914, 0x2918}, {0x291d, 0x2920}, {0x2944, 0x2948},
  {0x294a, 0x294b}, {0x294e, 0x294e}, {0x2950, 0x2950}, {0x2952, 0x2953}, {0x2956, 0x2957}, {0x295a, 0x295b}, {0x295e, 0x295f}, {0x2962, 0x2962},
  {0x2964, 0x2964}, {0x2966, 0x296d}, {0x2970, 0x2970}, {0x2977, 0x2977}, {0x297a, 0x297a}, {0x29f4, 0x29f4}, {0x2b30, 0x2b44}, {0x2b47, 0x2b4c},
  {0xffe9, 0xffe9}, {0xffeb, 0xffeb},
};

static TSCharacterRange sym__comparison_operator_character_set_2[] = {
  {'!', '!'}, {'<', '>'}, {0x2208, 0x220d}, {0x221d, 0x221d}, {0x2225, 0x2226}, {0x2237, 0x2237}, {0x223a, 0x223b}, {0x223d, 0x223e},
  {0x2241, 0x224e}, {0x2250, 0x2253}, {0x2256, 0x228b}, {0x228f, 0x2292}, {0x229c, 0x229c}, {0x22a2, 0x22a3}, {0x22a9, 0x22a9}, {0x22ac, 0x22ac},
  {0x22ae, 0x22ae}, {0x22b0, 0x22b7}, {0x22cd, 0x22cd}, {0x22d0, 0x22d1}, {0x22d5, 0x22ed}, {0x22f2, 0x22ff}, {0x27c2, 0x27c2}, {0x27c8, 0x27c9},
  {0x27d2, 0x27d2}, {0x29b7, 0x29b7}, {0x29c0, 0x29c1}, {0x29e1, 0x29e1}, {0x29e3, 0x29e5}, {0x2a66, 0x2a67}, {0x2a6a, 0x2a73}, {0x2a75, 0x2ad9},
  {0x2aea, 0x2aeb}, {0x2af7, 0x2afa},
};

static TSCharacterRange sym__plus_operator_character_set_2[] = {
  {'+', '+'}, {'|', '|'}, {0xa6, 0xa6}, {0xb1, 0xb1}, {0x2212, 0x2214}, {0x2228, 0x2228}, {0x222a, 0x222a}, {0x2238, 0x2238},
  {0x224f, 0x224f}, {0x228e, 0x228e}, {0x2294, 0x2296}, {0x229e, 0x229f}, {0x22bb, 0x22bb}, {0x22bd, 0x22bd}, {0x22ce, 0x22ce}, {0x22d3, 0x22d3},
  {0x27c7, 0x27c7}, {0x29fa, 0x29fb}, {0x2a08, 0x2a08}, {0x2a22, 0x2a2e}, {0x2a39, 0x2a3a}, {0x2a41, 0x2a42}, {0x2a45, 0x2a45}, {0x2a4a, 0x2a4a},
  {0x2a4c, 0x2a4c}, {0x2a4f, 0x2a50}, {0x2a52, 0x2a52}, {0x2a54, 0x2a54}, {0x2a56, 0x2a57}, {0x2a5b, 0x2a5b}, {0x2a5d, 0x2a5d}, {0x2a61, 0x2a63},
};

static TSCharacterRange sym__times_operator_character_set_2[] = {
  {'%', '&'}, {'*', '*'}, {'/', '/'}, {'\\', '\\'}, {0xb7, 0xb7}, {0xd7, 0xd7}, {0xf7, 0xf7}, {0x214b, 0x214b},
  {0x2217, 0x2219}, {0x2224, 0x2224}, {0x2227, 0x2227}, {0x2229, 0x2229}, {0x2240, 0x2240}, {0x228d, 0x228d}, {0x2293, 0x2293}, {0x2297, 0x229b},
  {0x22a0, 0x22a1}, {0x22bc, 0x22bc}, {0x22c4, 0x22c7}, {0x22c9, 0x22cc}, {0x22cf, 0x22cf}, {0x22d2, 0x22d2}, {0x233f, 0x233f}, {0x25b7, 0x25b7},
  {0x27d1, 0x27d1}, {0x27d5, 0x27d7}, {0x29b8, 0x29b8}, {0x29bc, 0x29bc}, {0x29be, 0x29bf}, {0x29f6, 0x29f7}, {0x2a07, 0x2a07}, {0x2a1d, 0x2a1d},
  {0x2a1f, 0x2a1f}, {0x2a30, 0x2a38}, {0x2a3b, 0x2a3d}, {0x2a40, 0x2a40}, {0x2a43, 0x2a44}, {0x2a4b, 0x2a4b}, {0x2a4d, 0x2a4e}, {0x2a51, 0x2a51},
  {0x2a53, 0x2a53}, {0x2a55, 0x2a55}, {0x2a58, 0x2a58}, {0x2a5a, 0x2a5a}, {0x2a5c, 0x2a5c}, {0x2a5e, 0x2a60}, {0x2adb, 0x2adb},
};

static TSCharacterRange sym__power_operator_character_set_2[] = {
  {'^', '^'}, {0x2191, 0x2191}, {0x2193, 0x2193}, {0x21f5, 0x21f5}, {0x27f0, 0x27f1}, {0x2908, 0x290b}, {0x2912, 0x2913}, {0x2949, 0x2949},
  {0x294c, 0x294d}, {0x294f, 0x294f}, {0x2951, 0x2951}, {0x2954, 0x2955}, {0x2958, 0x2959}, {0x295c, 0x295d}, {0x2960, 0x2961}, {0x2963, 0x2963},
  {0x2965, 0x2965}, {0x296e, 0x296f}, {0xffea, 0xffea}, {0xffec, 0xffec},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 606,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 600,
        '<', 788,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'a', 645,
        'b', 639,
        'c', 635,
        'd', 712,
        'e', 695,
        'f', 682,
        'g', 693,
        'i', 666,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2208, 598,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(555);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 606,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(39);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(40);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(42);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 606,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 606,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 606,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 606,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 606,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 606,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'd', 712,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'd', 712,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(48);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'd', 712,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(49);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'd', 712,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 24:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 25:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 26:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 27:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 28:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 608,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 608,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 30:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 608,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 695,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 608,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 32:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 608,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(60);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 33:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 608,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(61);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 34:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 35:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 36:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 37:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 701,
        'f', 688,
        'g', 693,
        'i', 666,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(38);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 38:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(38);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 39:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(39);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 40:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(40);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 41:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 42:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(42);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 43:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 44:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 45:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'd', 712,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 46:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 47:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 48:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'd', 712,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(48);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'd', 712,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(49);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 50:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'd', 712,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 52:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 53:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 54:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 55:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 56:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 359,
        '/', 808,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 57:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 359,
        '/', 808,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 58:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 359,
        '/', 808,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 695,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 59:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 359,
        '/', 808,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 60:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 359,
        '/', 808,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(60);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 61:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 359,
        '/', 808,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(61);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 62:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 635,
        'e', 701,
        'f', 682,
        'g', 693,
        'i', 666,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 63:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 635,
        'e', 700,
        'f', 688,
        'g', 693,
        'i', 666,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 64:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 695,
        'f', 688,
        'g', 693,
        'i', 666,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 65:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 700,
        'f', 682,
        'g', 693,
        'i', 666,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 66:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 700,
        'f', 688,
        'g', 693,
        'i', 666,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 702,
        'f', 682,
        'g', 693,
        'i', 666,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(73);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 68:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 70:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 71:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 72:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 73:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(73);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 74:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(118);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 75:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(119);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 76:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(119);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 77:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(124);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 78:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(125);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 79:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(125);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 80:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(138);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 81:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'd', 712,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(139);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 82:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(141);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 83:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(142);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 84:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(143);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 85:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(144);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 86:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(145);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 87:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(146);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 88:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(147);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 89:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(148);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 90:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(150);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 91:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(141);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 92:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(142);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 93:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(147);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 94:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(148);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 95:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(149);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 96:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(150);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 97:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(182);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 98:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'd', 712,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(183);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 99:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 100:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(185);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 102:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(187);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 103:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(188);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 104:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(189);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 105:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 106:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(191);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 107:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 108:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(193);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 109:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 110:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(185);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 111:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 112:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(191);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 113:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 114:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(193);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 115:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(117);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 116:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 600,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(116);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 117:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(117);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 118:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(118);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 119:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(119);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 120:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 600,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(116);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 121:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(117);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 122:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(117);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 123:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(119);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 124:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(124);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 125:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(125);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 126:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(132);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 127:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(133);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 128:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(134);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 129:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(135);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 130:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(136);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 131:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(137);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 132:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(132);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 133:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(133);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 134:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(134);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 135:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(135);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 136:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(136);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 137:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(137);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 138:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(138);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 139:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'd', 712,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(139);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 140:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(140);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 141:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(141);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 142:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(142);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 143:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(143);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 144:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(144);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 145:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(145);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 146:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(146);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 147:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(147);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 148:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(148);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 149:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(149);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 150:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(150);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 151:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(140);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 152:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(132);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 153:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(133);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 154:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(134);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 155:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(135);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 156:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(136);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 157:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(137);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 158:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(132);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 159:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(133);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 160:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(134);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 161:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(135);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 162:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(136);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 163:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'a', 729,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(137);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 164:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(141);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 165:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(142);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 166:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(147);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 167:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(148);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 168:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(149);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 169:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(150);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 170:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(176);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 171:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(177);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 172:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 695,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(178);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 173:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(179);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 174:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(180);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 175:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(181);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 176:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 361,
        '/', 809,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(176);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 177:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 361,
        '/', 809,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(177);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 178:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 361,
        '/', 809,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 695,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(178);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 179:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 361,
        '/', 809,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(179);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 180:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 361,
        '/', 809,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(180);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 181:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 361,
        '/', 809,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(181);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 182:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(182);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 183:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'd', 712,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(183);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 184:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 185:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'c', 636,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(185);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 186:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 187:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(187);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 188:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(188);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 189:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(189);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 190:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 695,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 191:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(191);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 192:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 193:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(193);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 194:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 604,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 612,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(201);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 195:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 604,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 612,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 668,
        'w', 677,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(204);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 196:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 604,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 612,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(205);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 197:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 604,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 612,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 668,
        'w', 677,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 198:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 604,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 611,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 668,
        'w', 677,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 199:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 604,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 611,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 200:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 201:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(201);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 202:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 203:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'c', 636,
        'f', 682,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(203);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 204:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 668,
        'w', 677,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(204);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 205:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'd', 712,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(205);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 206:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 682,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(206);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 207:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 668,
        'w', 677,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 208:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 209:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 699,
        'f', 682,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 210:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 789,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 211:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 764,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 212:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 764,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 789,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 213:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 701,
        'f', 688,
        'g', 693,
        'i', 666,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 214:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 430,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 215:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 635,
        'e', 701,
        'f', 683,
        'g', 693,
        'i', 669,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 216:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 635,
        'e', 700,
        'f', 689,
        'g', 693,
        'i', 669,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 217:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 695,
        'f', 689,
        'g', 693,
        'i', 669,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 218:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 700,
        'f', 689,
        'g', 693,
        'i', 669,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 219:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 700,
        'f', 683,
        'g', 693,
        'i', 669,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(224);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 220:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 702,
        'f', 683,
        'g', 693,
        'i', 669,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(226);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 221:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 222:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 223:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 695,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 224:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(224);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 225:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 226:
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(226);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 227:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(240);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 228:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(241);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 229:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'd', 461,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(242);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 230:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 613,
        '/', 808,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(243);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 231:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 232:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(245);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 233:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(246);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 234:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'd', 461,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(247);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 235:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 695,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(248);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 236:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 237:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(250);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 238:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(251);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 239:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 613,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(252);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 240:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(240);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 241:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(241);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 242:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'd', 461,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(242);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 243:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(243);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 244:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 245:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(245);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 246:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(246);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 247:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'd', 461,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(247);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 248:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 695,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(248);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 249:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 250:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(250);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 251:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(251);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 252:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(252);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 253:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(274);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 254:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 465,
        'd', 461,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(275);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 255:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 615,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 465,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(276);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 256:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(278);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 257:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'd', 461,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(279);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 258:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 615,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(280);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 259:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(294);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 260:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(295);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 261:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 695,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(296);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 262:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(297);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 263:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(298);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 264:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(299);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 265:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 615,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 465,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(287);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 266:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(301);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 267:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(302);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 268:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'd', 461,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(303);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 269:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 695,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(304);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 270:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(305);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 271:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(306);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 272:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(307);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 273:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 615,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(308);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 274:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(274);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 275:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 465,
        'd', 461,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(275);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 276:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 465,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(276);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 277:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 765,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 465,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(276);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 278:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(278);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 279:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'd', 461,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(279);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 280:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'f', 460,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(280);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 281:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(288);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 282:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(289);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 283:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'e', 695,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(290);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 284:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(291);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 285:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(292);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 286:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(293);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 287:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 465,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(287);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 288:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(288);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 289:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(289);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 290:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'e', 695,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(290);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 291:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(291);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 292:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(292);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 293:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(293);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 294:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(294);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 295:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(295);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 296:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 695,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(296);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 297:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(297);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 298:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(298);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 299:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(299);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 300:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 765,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 465,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(287);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 301:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'c', 636,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(301);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 302:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'c', 636,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(302);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 303:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'd', 461,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(303);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 304:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 695,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(304);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 305:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 705,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(305);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 306:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 705,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(306);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 307:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 699,
        'f', 684,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(307);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 308:
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'e', 456,
        'f', 451,
        'i', 458,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(308);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 309:
      if (lookahead == '\n') ADVANCE(595);
      if (lookahead == '#') ADVANCE(838);
      if (lookahead == ',') ADVANCE(560);
      if (lookahead == ';') ADVANCE(837);
      if (lookahead == '=') ADVANCE(558);
      if (lookahead == 'e') ADVANCE(453);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(309);
      END_STATE();
    case 310:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(316);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 311:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 606,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(318);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 312:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(317);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 313:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(318);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 314:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 608,
        '/', 808,
        '0', 759,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(319);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(760);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 315:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 608,
        '/', 808,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(320);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 316:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(316);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 317:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(317);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 318:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(318);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 319:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 359,
        '/', 808,
        '0', 759,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(319);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(760);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 320:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 359,
        '/', 808,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(320);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 321:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 701,
        'f', 688,
        'g', 693,
        'i', 666,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(322);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 322:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(322);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 323:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        '-', 828,
        '.', 834,
        '/', 808,
        '0', 757,
        ':', 564,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 831,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(323);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 324:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(332);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 325:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(333);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 326:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(333);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 327:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(341);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 328:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(342);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 329:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(342);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 330:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(331);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 331:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(331);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 332:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(332);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 333:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(333);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 334:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(331);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 335:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(331);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 336:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(333);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 337:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(339);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 338:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'f', 716,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(340);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 339:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 361,
        '/', 809,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(339);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 340:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 361,
        '/', 809,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'f', 716,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(340);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 341:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(341);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 342:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(342);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 343:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 561,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(343);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 344:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'c', 636,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(344);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 345:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'c', 636,
        'f', 682,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(345);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 346:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 695,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(346);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 347:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 682,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(347);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 348:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 705,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(348);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 349:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        'e', 699,
        'f', 682,
        'i', 668,
        '{', 601,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(349);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 350:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '(', 589,
        '+', 823,
        '-', 825,
        '.', 587,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(350);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 351:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 701,
        'f', 689,
        'g', 693,
        'i', 669,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(353);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 352:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 701,
        'f', 688,
        'g', 693,
        'i', 669,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(354);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 353:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'i', 706,
        'w', 677,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(353);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 354:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 430,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(354);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 355:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        '-', 828,
        '.', 833,
        '/', 808,
        '0', 757,
        ':', 432,
        '<', 790,
        '=', 434,
        '>', 792,
        '?', 831,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 701,
        'f', 689,
        'g', 693,
        'i', 670,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 678,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(356);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 356:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        '-', 828,
        '.', 833,
        '/', 808,
        '0', 757,
        ':', 432,
        '<', 790,
        '=', 434,
        '>', 792,
        '?', 831,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(356);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 357:
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '+', 823,
        '-', 830,
        '.', 835,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 803,
        '~', 819,
        '$', 831,
        '?', 831,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(357);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 358:
      ADVANCE_MAP(
        '!', 822,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 798,
        '/', 808,
        '<', 790,
        '=', 781,
        '>', 792,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(761);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 359:
      ADVANCE_MAP(
        '!', 822,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 798,
        '/', 808,
        '<', 790,
        '=', 781,
        '>', 792,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 360:
      ADVANCE_MAP(
        '!', 822,
        '&', 806,
        '+', 823,
        '-', 825,
        '.', 798,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(761);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 361:
      ADVANCE_MAP(
        '!', 822,
        '&', 806,
        '+', 823,
        '-', 825,
        '.', 798,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 362:
      ADVANCE_MAP(
        '!', 822,
        '+', 823,
        '-', 825,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == '.' ||
          lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(761);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 363:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'c', 438,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(372);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 364:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'd', 461,
        'e', 456,
        'f', 452,
        'i', 458,
        'w', 449,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(373);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 365:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'i', 706,
        'w', 677,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(375);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 366:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(376);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 367:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 613,
        '/', 808,
        ':', 592,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 460,
        'i', 458,
        'w', 449,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(374);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 368:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        '-', 827,
        '.', 614,
        '/', 808,
        ':', 592,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'i', 458,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2208, 598,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(377);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 369:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2208, 598,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(378);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 370:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'i', 458,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2208, 598,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(379);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 371:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 613,
        '/', 808,
        ':', 592,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'i', 458,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2208, 598,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(379);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 372:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 407,
        '/', 808,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'c', 438,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(372);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 373:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'd', 461,
        'e', 456,
        'f', 452,
        'i', 458,
        'w', 449,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(373);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 374:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 460,
        'i', 458,
        'w', 449,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(374);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 375:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 563,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'i', 706,
        'w', 677,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(375);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 376:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 599,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'f', 716,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(376);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 377:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 827,
        '.', 407,
        '/', 808,
        ':', 430,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'i', 458,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2208, 598,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(377);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 378:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2208, 598,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(378);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 379:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'i', 458,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2208, 598,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(379);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 380:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'd', 461,
        'e', 457,
        'f', 460,
        'i', 458,
        'w', 449,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(393);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 381:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'i', 706,
        'w', 677,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(396);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 382:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'f', 716,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(398);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 383:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 615,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'f', 460,
        'i', 458,
        'w', 449,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(394);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 384:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'd', 461,
        'f', 460,
        'i', 458,
        'w', 449,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(400);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 385:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'i', 706,
        'w', 677,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(402);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 386:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'f', 716,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(403);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 387:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 615,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'f', 460,
        'i', 458,
        'w', 449,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(401);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 388:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'd', 461,
        'i', 458,
        'w', 449,
        '|', 804,
        0x2208, 598,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(404);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 389:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'i', 706,
        'w', 677,
        '|', 804,
        0x2208, 598,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(405);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 390:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        '-', 829,
        '.', 615,
        '/', 809,
        ':', 591,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'i', 458,
        'w', 449,
        '|', 804,
        0x2208, 598,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(406);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 391:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 729,
        'i', 706,
        'w', 677,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(395);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 392:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'f', 716,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(397);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 393:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'd', 461,
        'e', 457,
        'f', 460,
        'i', 458,
        'w', 449,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(393);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 394:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'f', 460,
        'i', 458,
        'w', 449,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(394);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 395:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 729,
        'i', 706,
        'w', 677,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(395);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 396:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'i', 706,
        'w', 677,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(396);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 397:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'f', 716,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(397);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 398:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'f', 716,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(398);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 399:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 765,
        '/', 809,
        ':', 591,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'f', 460,
        'i', 458,
        'w', 449,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(394);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 400:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'd', 461,
        'f', 460,
        'i', 458,
        'w', 449,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(400);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 401:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'f', 460,
        'i', 458,
        'w', 449,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(401);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 402:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'i', 706,
        'w', 677,
        '|', 804,
        '}', 602,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(402);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 403:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 599,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'f', 716,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(403);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 404:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'd', 461,
        'i', 458,
        'w', 449,
        '|', 804,
        0x2208, 598,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(404);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 405:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'i', 706,
        'w', 677,
        '|', 804,
        0x2208, 598,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(405);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 406:
      ADVANCE_MAP(
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'i', 458,
        'w', 449,
        '|', 804,
        0x2208, 598,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(406);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 407:
      ADVANCE_MAP(
        '!', 433,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 798,
        '/', 808,
        '<', 790,
        '=', 781,
        '>', 792,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 408:
      ADVANCE_MAP(
        '!', 433,
        '&', 806,
        '+', 823,
        '-', 825,
        '.', 798,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 409:
      ADVANCE_MAP(
        '#', 838,
        '$', 620,
        '\'', 603,
        ')', 590,
        ',', 560,
        '.', 605,
        '0', 759,
        ':', 561,
        '<', 431,
        '=', 558,
        '\\', 470,
        'd', 461,
        'e', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(410);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(760);
      END_STATE();
    case 410:
      ADVANCE_MAP(
        '#', 838,
        '$', 620,
        ')', 590,
        ',', 560,
        '0', 759,
        ':', 561,
        '<', 431,
        '=', 558,
        '\\', 470,
        'd', 461,
        'e', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(410);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(760);
      END_STATE();
    case 411:
      if (lookahead == '#') ADVANCE(838);
      if (lookahead == '\'') ADVANCE(603);
      if (lookahead == ')') ADVANCE(590);
      if (lookahead == '.') ADVANCE(605);
      if (lookahead == '0') ADVANCE(759);
      if (lookahead == '<') ADVANCE(431);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(416);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(760);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 412:
      if (lookahead == '#') ADVANCE(838);
      if (lookahead == '\'') ADVANCE(603);
      if (lookahead == ')') ADVANCE(590);
      if (lookahead == '.') ADVANCE(617);
      if (lookahead == '0') ADVANCE(759);
      if (lookahead == 'e') ADVANCE(457);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(417);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(760);
      END_STATE();
    case 413:
      if (lookahead == '#') ADVANCE(838);
      if (lookahead == '\'') ADVANCE(603);
      if (lookahead == '.') ADVANCE(605);
      if (lookahead == '<') ADVANCE(431);
      if (lookahead == 'e') ADVANCE(705);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(418);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 414:
      if (lookahead == '#') ADVANCE(838);
      if (lookahead == ')') ADVANCE(590);
      if (lookahead == '.') ADVANCE(767);
      if (lookahead == '0') ADVANCE(759);
      if (lookahead == '<') ADVANCE(431);
      if (lookahead == 'e') ADVANCE(457);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(415);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(760);
      END_STATE();
    case 415:
      if (lookahead == '#') ADVANCE(838);
      if (lookahead == ')') ADVANCE(590);
      if (lookahead == '0') ADVANCE(759);
      if (lookahead == '<') ADVANCE(431);
      if (lookahead == 'e') ADVANCE(457);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(415);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(760);
      END_STATE();
    case 416:
      if (lookahead == '#') ADVANCE(838);
      if (lookahead == ')') ADVANCE(590);
      if (lookahead == '0') ADVANCE(759);
      if (lookahead == '<') ADVANCE(431);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(416);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(760);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 417:
      if (lookahead == '#') ADVANCE(838);
      if (lookahead == ')') ADVANCE(590);
      if (lookahead == '0') ADVANCE(759);
      if (lookahead == 'e') ADVANCE(457);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(417);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(760);
      END_STATE();
    case 418:
      if (lookahead == '#') ADVANCE(838);
      if (lookahead == '<') ADVANCE(431);
      if (lookahead == 'e') ADVANCE(705);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(418);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 419:
      if (lookahead == '\'') ADVANCE(779);
      END_STATE();
    case 420:
      if (lookahead == '\'') ADVANCE(779);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(419);
      END_STATE();
    case 421:
      if (lookahead == '\'') ADVANCE(779);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(420);
      END_STATE();
    case 422:
      if (lookahead == '\'') ADVANCE(779);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(419);
      END_STATE();
    case 423:
      if (lookahead == '\'') ADVANCE(779);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(422);
      END_STATE();
    case 424:
      if (lookahead == '\'') ADVANCE(779);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(423);
      END_STATE();
    case 425:
      if (lookahead == '\'') ADVANCE(779);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(424);
      END_STATE();
    case 426:
      if (lookahead == '\'') ADVANCE(779);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(425);
      END_STATE();
    case 427:
      if (lookahead == '-') ADVANCE(784);
      END_STATE();
    case 428:
      if (lookahead == '.') ADVANCE(489);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(755);
      END_STATE();
    case 429:
      if (lookahead == ':') ADVANCE(622);
      END_STATE();
    case 430:
      if (lookahead == ':') ADVANCE(622);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 431:
      if (lookahead == ':') ADVANCE(567);
      END_STATE();
    case 432:
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 433:
      if (lookahead == '=') ADVANCE(794);
      END_STATE();
    case 434:
      if (lookahead == '=') ADVANCE(794);
      if (lookahead == '>') ADVANCE(782);
      END_STATE();
    case 435:
      if (lookahead == '>') ADVANCE(783);
      END_STATE();
    case 436:
      if (lookahead == '\\') ADVANCE(469);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(419);
      END_STATE();
    case 437:
      if (lookahead == '_') ADVANCE(489);
      if (lookahead == 'p') ADVANCE(474);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(437);
      END_STATE();
    case 438:
      if (lookahead == 'a') ADVANCE(468);
      END_STATE();
    case 439:
      if (lookahead == 'a') ADVANCE(627);
      END_STATE();
    case 440:
      if (lookahead == 'a') ADVANCE(455);
      END_STATE();
    case 441:
      if (lookahead == 'c') ADVANCE(450);
      END_STATE();
    case 442:
      if (lookahead == 'd') ADVANCE(565);
      END_STATE();
    case 443:
      if (lookahead == 'e') ADVANCE(576);
      END_STATE();
    case 444:
      if (lookahead == 'e') ADVANCE(568);
      END_STATE();
    case 445:
      if (lookahead == 'e') ADVANCE(574);
      END_STATE();
    case 446:
      if (lookahead == 'e') ADVANCE(464);
      END_STATE();
    case 447:
      if (lookahead == 'f') ADVANCE(570);
      if (lookahead == 'n') ADVANCE(596);
      if (lookahead == 's') ADVANCE(439);
      END_STATE();
    case 448:
      if (lookahead == 'f') ADVANCE(572);
      END_STATE();
    case 449:
      if (lookahead == 'h') ADVANCE(446);
      END_STATE();
    case 450:
      if (lookahead == 'h') ADVANCE(579);
      END_STATE();
    case 451:
      if (lookahead == 'i') ADVANCE(459);
      END_STATE();
    case 452:
      if (lookahead == 'i') ADVANCE(459);
      if (lookahead == 'o') ADVANCE(463);
      END_STATE();
    case 453:
      if (lookahead == 'l') ADVANCE(466);
      if (lookahead == 'n') ADVANCE(442);
      END_STATE();
    case 454:
      if (lookahead == 'l') ADVANCE(471);
      END_STATE();
    case 455:
      if (lookahead == 'l') ADVANCE(454);
      END_STATE();
    case 456:
      if (lookahead == 'l') ADVANCE(467);
      if (lookahead == 'n') ADVANCE(442);
      END_STATE();
    case 457:
      if (lookahead == 'n') ADVANCE(442);
      END_STATE();
    case 458:
      if (lookahead == 'n') ADVANCE(596);
      if (lookahead == 's') ADVANCE(439);
      END_STATE();
    case 459:
      if (lookahead == 'n') ADVANCE(440);
      END_STATE();
    case 460:
      if (lookahead == 'o') ADVANCE(463);
      END_STATE();
    case 461:
      if (lookahead == 'o') ADVANCE(618);
      END_STATE();
    case 462:
      if (lookahead == 'p') ADVANCE(474);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(437);
      END_STATE();
    case 463:
      if (lookahead == 'r') ADVANCE(583);
      END_STATE();
    case 464:
      if (lookahead == 'r') ADVANCE(444);
      END_STATE();
    case 465:
      if (lookahead == 's') ADVANCE(585);
      END_STATE();
    case 466:
      if (lookahead == 's') ADVANCE(443);
      END_STATE();
    case 467:
      if (lookahead == 's') ADVANCE(445);
      END_STATE();
    case 468:
      if (lookahead == 't') ADVANCE(441);
      END_STATE();
    case 469:
      if (lookahead == 'x') ADVANCE(493);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(488);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(421);
      if (lookahead != 0) ADVANCE(419);
      END_STATE();
    case 470:
      if (lookahead == 'x') ADVANCE(494);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(492);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(773);
      if (lookahead != 0) ADVANCE(771);
      END_STATE();
    case 471:
      if (lookahead == 'y') ADVANCE(581);
      END_STATE();
    case 472:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(480);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(768);
      END_STATE();
    case 473:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(481);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(769);
      END_STATE();
    case 474:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(483);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(770);
      END_STATE();
    case 475:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(484);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(762);
      END_STATE();
    case 476:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(753);
      END_STATE();
    case 477:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(754);
      END_STATE();
    case 478:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(758);
      END_STATE();
    case 479:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      END_STATE();
    case 480:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(768);
      END_STATE();
    case 481:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(769);
      END_STATE();
    case 482:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(761);
      END_STATE();
    case 483:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(770);
      END_STATE();
    case 484:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(762);
      END_STATE();
    case 485:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(760);
      END_STATE();
    case 486:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(419);
      END_STATE();
    case 487:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(755);
      END_STATE();
    case 488:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(426);
      END_STATE();
    case 489:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(437);
      END_STATE();
    case 490:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(756);
      END_STATE();
    case 491:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(771);
      END_STATE();
    case 492:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(778);
      END_STATE();
    case 493:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(486);
      END_STATE();
    case 494:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(491);
      END_STATE();
    case 495:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(501);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 496:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 606,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(503);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 497:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(502);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 498:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(503);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 499:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 607,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(506);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 500:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 604,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 608,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(507);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 501:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(501);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 502:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(502);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 503:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(503);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 504:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 701,
        'f', 688,
        'g', 693,
        'i', 666,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(505);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 505:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(505);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 506:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'e', 699,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(506);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 507:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 359,
        '/', 808,
        ':', 563,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        '^', 818,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(507);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 508:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(517);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 509:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(518);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 510:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(519);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 511:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(519);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 512:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(523);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 513:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(524);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 514:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 604,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(524);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 515:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 610,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(516);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 516:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(516);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 517:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(517);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 518:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'e', 705,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(518);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 519:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(519);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 520:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 609,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(516);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 521:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'a', 729,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(516);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 522:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        '0', 757,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(519);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 523:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'd', 712,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(523);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 524:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 360,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(524);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 525:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 763,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(526);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 526:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 620,
        '&', 806,
        '\'', 436,
        '(', 589,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 361,
        '/', 809,
        ':', 562,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        '@', 632,
        '[', 593,
        'i', 706,
        'w', 677,
        '{', 601,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(526);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 527:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'a', 646,
        'b', 639,
        'c', 643,
        'e', 701,
        'f', 689,
        'g', 693,
        'i', 669,
        'l', 661,
        'm', 714,
        'p', 720,
        'q', 746,
        's', 740,
        't', 721,
        'u', 730,
        'w', 674,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(528);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 528:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 822,
        '#', 838,
        '$', 836,
        '%', 810,
        '&', 807,
        '\'', 436,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 828,
        '.', 832,
        '/', 808,
        '0', 757,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(528);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 529:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'c', 438,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(533);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 530:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'c', 438,
        'd', 461,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(534);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 531:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 613,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'c', 438,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(535);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 532:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '\'', 603,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 614,
        '/', 808,
        ':', 592,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(536);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 533:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'c', 438,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(533);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 534:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'c', 438,
        'd', 461,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(534);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 535:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        ']', 594,
        '^', 818,
        'c', 438,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(535);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 536:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '$', 432,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 826,
        '.', 407,
        '/', 808,
        ':', 430,
        ';', 837,
        '<', 790,
        '=', 559,
        '>', 792,
        '?', 630,
        '\\', 810,
        '^', 818,
        'i', 706,
        'w', 677,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(536);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 537:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'c', 438,
        'd', 461,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(544);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 538:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'c', 438,
        'd', 461,
        'e', 456,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(545);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 539:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 615,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'c', 438,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(546);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 540:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'c', 438,
        'd', 461,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(548);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 541:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 615,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'c', 438,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(549);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 542:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(552);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 543:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '\'', 603,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(553);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 544:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'c', 438,
        'd', 461,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(544);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 545:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'c', 438,
        'd', 461,
        'e', 456,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(545);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 546:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'c', 438,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(546);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 547:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 765,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'a', 465,
        'c', 438,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(546);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 548:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'c', 438,
        'd', 461,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(548);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 549:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        ']', 594,
        'c', 438,
        'e', 453,
        'f', 452,
        'i', 447,
        'w', 449,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(549);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 550:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 616,
        '/', 809,
        ':', 591,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(551);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 551:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'a', 729,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(551);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 552:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(552);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 553:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '!', 433,
        '#', 838,
        '&', 806,
        '+', 823,
        ',', 560,
        '-', 829,
        '.', 408,
        '/', 809,
        ':', 429,
        ';', 837,
        '<', 791,
        '=', 559,
        '>', 793,
        '?', 630,
        'i', 706,
        'w', 677,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(553);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 554:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '\n', 595,
        '#', 838,
        ',', 560,
        ';', 837,
        '=', 558,
        'c', 438,
        'e', 456,
        'f', 451,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(554);
      END_STATE();
    case 555:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 621,
        '%', 810,
        '&', 807,
        '\'', 436,
        '(', 589,
        ')', 590,
        '*', 810,
        '+', 824,
        ',', 560,
        '-', 827,
        '.', 358,
        '/', 808,
        '0', 757,
        ':', 563,
        ';', 600,
        '<', 788,
        '=', 559,
        '>', 792,
        '?', 630,
        '@', 632,
        '[', 593,
        '\\', 810,
        ']', 594,
        '^', 818,
        'a', 729,
        'c', 636,
        'd', 712,
        'e', 695,
        'f', 682,
        'i', 667,
        'w', 677,
        '{', 601,
        '|', 802,
        '}', 602,
        '~', 819,
        0xf7, 810,
        0x2208, 598,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(555);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 556:
      if (eof) ADVANCE(557);
      ADVANCE_MAP(
        '!', 822,
        '#', 838,
        '$', 620,
        '\'', 436,
        '(', 589,
        ')', 590,
        '+', 823,
        ',', 560,
        '-', 825,
        '.', 362,
        '/', 809,
        '0', 757,
        ':', 562,
        ';', 599,
        '<', 791,
        '=', 434,
        '>', 793,
        '@', 632,
        '[', 593,
        ']', 594,
        'f', 716,
        'i', 668,
        '{', 601,
        '|', 803,
        '}', 602,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        0x2194, 752,
        0x21a9, 752,
        0x21aa, 752,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(556);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(758);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(752);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(794);
      if (lookahead == '>') ADVANCE(782);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(622);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(622);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(622);
      if (lookahead == '=') ADVANCE(623);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_end);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_LT_COLON);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_where);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym_if);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(anon_sym_elseif);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(672);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(448);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(671);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_else);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym_catch);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(anon_sym_finally);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(anon_sym_for);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym_as);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(aux_sym_import_path_token1);
      ADVANCE_MAP(
        '!', 822,
        '+', 823,
        '-', 825,
        '.', 588,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(aux_sym_import_path_token1);
      if (lookahead == '.') ADVANCE(588);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(622);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(622);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(595);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym_in);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_u2208);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';') ADVANCE(837);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\\') ADVANCE(469);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(419);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 822,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 798,
        '/', 808,
        '<', 790,
        '=', 781,
        '>', 792,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        'E', 472,
        'e', 472,
        'f', 472,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 822,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 798,
        '/', 808,
        '<', 790,
        '=', 781,
        '>', 792,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(761);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 822,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 798,
        '/', 808,
        '<', 790,
        '=', 781,
        '>', 792,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 822,
        '&', 806,
        '+', 823,
        '-', 825,
        '.', 798,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        'E', 472,
        'e', 472,
        'f', 472,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 822,
        '&', 806,
        '+', 823,
        '-', 825,
        '.', 798,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(761);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 822,
        '+', 823,
        '-', 825,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        'E', 472,
        'e', 472,
        'f', 472,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == '.' ||
          lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 822,
        '+', 823,
        '-', 825,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == '.' ||
          lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(761);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 433,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 798,
        '/', 808,
        '<', 790,
        '=', 781,
        '>', 792,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        'E', 472,
        'e', 472,
        'f', 472,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 433,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 798,
        '/', 808,
        '<', 790,
        '=', 781,
        '>', 792,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 433,
        '&', 806,
        '+', 823,
        '-', 825,
        '.', 798,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        'E', 472,
        'e', 472,
        'f', 472,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 433,
        '&', 806,
        '+', 823,
        '-', 825,
        '.', 798,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(472);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(anon_sym_do);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(anon_sym_DOT_EQ);
      if (lookahead == '=') ADVANCE(794);
      if (lookahead == '>') ADVANCE(782);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(aux_sym_quote_expression_token1);
      if (lookahead == 'i') ADVANCE(671);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(aux_sym_quote_expression_token1);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(anon_sym_isa);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(anon_sym_isa);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(628);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(690);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(738);
      if (lookahead == 'o') ADVANCE(707);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(738);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(644);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(696);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(724);
      if (lookahead == 'r') ADVANCE(662);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(648);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(692);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(698);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(744);
      if (lookahead == 'o') ADVANCE(707);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'b') ADVANCE(697);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'b') ADVANCE(735);
      if (lookahead == 's') ADVANCE(586);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'b') ADVANCE(735);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'b') ADVANCE(641);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'c') ADVANCE(737);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'c') ADVANCE(676);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'c') ADVANCE(675);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'c') ADVANCE(641);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'd') ADVANCE(566);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'd') ADVANCE(626);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'd') ADVANCE(745);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(626);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(575);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(569);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(578);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(625);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(704);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(737);
      if (lookahead == 'o') ADVANCE(651);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(634);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(727);
      if (lookahead == 'i') ADVANCE(697);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(727);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(577);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(571);
      if (lookahead == 'm') ADVANCE(719);
      if (lookahead == 'n') ADVANCE(597);
      if (lookahead == 's') ADVANCE(633);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(571);
      if (lookahead == 'n') ADVANCE(597);
      if (lookahead == 's') ADVANCE(633);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(571);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(626);
      if (lookahead == 'm') ADVANCE(719);
      if (lookahead == 'n') ADVANCE(597);
      if (lookahead == 's') ADVANCE(633);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(626);
      if (lookahead == 'm') ADVANCE(719);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(626);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(573);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'g') ADVANCE(626);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'h') ADVANCE(663);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'h') ADVANCE(626);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'h') ADVANCE(580);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'h') ADVANCE(664);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'h') ADVANCE(681);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(703);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(749);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(697);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(710);
      if (lookahead == 'o') ADVANCE(722);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(710);
      if (lookahead == 'o') ADVANCE(723);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(710);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(708);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(709);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(739);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(711);
      if (lookahead == 'o') ADVANCE(722);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(711);
      if (lookahead == 'o') ADVANCE(723);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'k') ADVANCE(626);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(750);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(626);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(713);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(751);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(732);
      if (lookahead == 'n') ADVANCE(652);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(694);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(655);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(691);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(733);
      if (lookahead == 'n') ADVANCE(652);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(734);
      if (lookahead == 'n') ADVANCE(652);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(734);
      if (lookahead == 'n') ADVANCE(653);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(736);
      if (lookahead == 'n') ADVANCE(652);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'm') ADVANCE(687);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'm') ADVANCE(715);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(652);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(597);
      if (lookahead == 's') ADVANCE(633);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(731);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(673);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(748);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(638);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(642);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(619);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(647);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(654);
      if (lookahead == 'u') ADVANCE(742);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(654);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(722);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(741);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 718:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(726);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'p') ADVANCE(718);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(679);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(750);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(584);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(626);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(660);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(747);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(737);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(657);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 728:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(640);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 729:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(586);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(685);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 731:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(737);
      if (lookahead == 't') ADVANCE(686);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(656);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(658);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 734:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(659);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 735:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(743);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 736:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(665);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 737:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(626);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(649);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(680);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 740:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(725);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 741:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(655);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 742:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(637);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(728);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(650);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'u') ADVANCE(697);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 746:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'u') ADVANCE(717);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'u') ADVANCE(648);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 748:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'u') ADVANCE(655);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 749:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'v') ADVANCE(655);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 750:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'y') ADVANCE(626);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 751:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'y') ADVANCE(582);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(sym__word_identifier);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(752);
      END_STATE();
    case 753:
      ACCEPT_TOKEN(aux_sym_integer_literal_token1);
      if (lookahead == '_') ADVANCE(476);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(753);
      END_STATE();
    case 754:
      ACCEPT_TOKEN(aux_sym_integer_literal_token2);
      if (lookahead == '_') ADVANCE(477);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(754);
      END_STATE();
    case 755:
      ACCEPT_TOKEN(aux_sym_integer_literal_token3);
      if (lookahead == '.') ADVANCE(462);
      if (lookahead == '_') ADVANCE(487);
      if (lookahead == 'p') ADVANCE(474);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(755);
      END_STATE();
    case 756:
      ACCEPT_TOKEN(aux_sym_integer_literal_token3);
      if (lookahead == '_') ADVANCE(490);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(756);
      END_STATE();
    case 757:
      ACCEPT_TOKEN(aux_sym_integer_literal_token4);
      if (lookahead == '_') ADVANCE(478);
      if (lookahead == 'b') ADVANCE(476);
      if (lookahead == 'o') ADVANCE(477);
      if (lookahead == 'x') ADVANCE(428);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(473);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(758);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(aux_sym_integer_literal_token4);
      if (lookahead == '_') ADVANCE(478);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(473);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(758);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(aux_sym_integer_literal_token4);
      if (lookahead == '_') ADVANCE(485);
      if (lookahead == 'b') ADVANCE(476);
      if (lookahead == 'o') ADVANCE(477);
      if (lookahead == 'x') ADVANCE(490);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(760);
      END_STATE();
    case 760:
      ACCEPT_TOKEN(aux_sym_integer_literal_token4);
      if (lookahead == '_') ADVANCE(485);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(760);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(aux_sym_float_literal_token1);
      if (lookahead == '_') ADVANCE(482);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(475);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(761);
      END_STATE();
    case 762:
      ACCEPT_TOKEN(aux_sym_float_literal_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(762);
      END_STATE();
    case 763:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      ADVANCE_MAP(
        '!', 822,
        '&', 806,
        '+', 823,
        '-', 825,
        '.', 798,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 804,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        'E', 472,
        'e', 472,
        'f', 472,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      ADVANCE_MAP(
        '!', 822,
        '+', 823,
        '-', 825,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
        'E', 472,
        'e', 472,
        'f', 472,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == '.' ||
          lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 765:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      ADVANCE_MAP(
        '!', 433,
        '&', 806,
        '+', 823,
        '-', 825,
        '.', 798,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 804,
        0xb1, 800,
        0x2213, 800,
        'E', 472,
        'e', 472,
        'f', 472,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 766:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      if (lookahead == '_') ADVANCE(479);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(472);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      END_STATE();
    case 767:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(472);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      END_STATE();
    case 768:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(768);
      END_STATE();
    case 769:
      ACCEPT_TOKEN(aux_sym_float_literal_token3);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(769);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(aux_sym_float_literal_token4);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(770);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 772:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(771);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(772);
      END_STATE();
    case 774:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(771);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(774);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(775);
      END_STATE();
    case 777:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(776);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(777);
      END_STATE();
    case 779:
      ACCEPT_TOKEN(sym_character_literal);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(sym__assignment_operator);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(sym__assignment_operator);
      if (lookahead == '=') ADVANCE(794);
      if (lookahead == '>') ADVANCE(782);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(sym__pair_operator);
      END_STATE();
    case 783:
      ACCEPT_TOKEN(sym__arrow_operator);
      END_STATE();
    case 784:
      ACCEPT_TOKEN(sym__arrow_operator);
      if (lookahead == '>') ADVANCE(783);
      END_STATE();
    case 785:
      ACCEPT_TOKEN(sym__lazy_or_operator);
      END_STATE();
    case 786:
      ACCEPT_TOKEN(sym__lazy_and_operator);
      END_STATE();
    case 787:
      ACCEPT_TOKEN(sym__comparison_operator);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '-') ADVANCE(427);
      if (lookahead == ':') ADVANCE(567);
      if (lookahead == '<') ADVANCE(814);
      if (lookahead == '=') ADVANCE(787);
      if (lookahead == '|') ADVANCE(796);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '-') ADVANCE(427);
      if (lookahead == ':') ADVANCE(567);
      if (lookahead == '<') ADVANCE(813);
      if (lookahead == '=') ADVANCE(787);
      if (lookahead == '|') ADVANCE(796);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '-') ADVANCE(427);
      if (lookahead == ':') ADVANCE(820);
      if (lookahead == '<') ADVANCE(814);
      if (lookahead == '=') ADVANCE(787);
      if (lookahead == '|') ADVANCE(796);
      END_STATE();
    case 791:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '-') ADVANCE(427);
      if (lookahead == ':') ADVANCE(820);
      if (lookahead == '<') ADVANCE(813);
      if (lookahead == '=') ADVANCE(787);
      if (lookahead == '|') ADVANCE(796);
      END_STATE();
    case 792:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == ':') ADVANCE(820);
      if (lookahead == '=') ADVANCE(787);
      if (lookahead == '>') ADVANCE(815);
      END_STATE();
    case 793:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == ':') ADVANCE(820);
      if (lookahead == '=') ADVANCE(787);
      if (lookahead == '>') ADVANCE(816);
      END_STATE();
    case 794:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '=') ADVANCE(787);
      END_STATE();
    case 795:
      ACCEPT_TOKEN(sym__pipe_right_operator);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(sym__pipe_left_operator);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(sym__ellipsis_operator);
      END_STATE();
    case 798:
      ACCEPT_TOKEN(sym__ellipsis_operator);
      if (lookahead == '.') ADVANCE(629);
      END_STATE();
    case 799:
      ACCEPT_TOKEN(sym__ellipsis_operator);
      if (lookahead == '.') ADVANCE(831);
      END_STATE();
    case 800:
      ACCEPT_TOKEN(sym__plus_operator);
      END_STATE();
    case 801:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 802:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '=') ADVANCE(780);
      if (lookahead == '>') ADVANCE(795);
      if (lookahead == '|') ADVANCE(785);
      END_STATE();
    case 803:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '>') ADVANCE(795);
      END_STATE();
    case 804:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '>') ADVANCE(795);
      if (lookahead == '|') ADVANCE(785);
      END_STATE();
    case 805:
      ACCEPT_TOKEN(sym__times_operator);
      END_STATE();
    case 806:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '&') ADVANCE(786);
      END_STATE();
    case 807:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '&') ADVANCE(786);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 808:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '/') ADVANCE(812);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 809:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '/') ADVANCE(811);
      END_STATE();
    case 810:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 811:
      ACCEPT_TOKEN(sym__rational_operator);
      END_STATE();
    case 812:
      ACCEPT_TOKEN(sym__rational_operator);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 813:
      ACCEPT_TOKEN(sym__bitshift_operator);
      END_STATE();
    case 814:
      ACCEPT_TOKEN(sym__bitshift_operator);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 815:
      ACCEPT_TOKEN(sym__bitshift_operator);
      if (lookahead == '=') ADVANCE(780);
      if (lookahead == '>') ADVANCE(814);
      END_STATE();
    case 816:
      ACCEPT_TOKEN(sym__bitshift_operator);
      if (lookahead == '>') ADVANCE(813);
      END_STATE();
    case 817:
      ACCEPT_TOKEN(sym__power_operator);
      END_STATE();
    case 818:
      ACCEPT_TOKEN(sym__power_operator);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 819:
      ACCEPT_TOKEN(sym__tilde_operator);
      END_STATE();
    case 820:
      ACCEPT_TOKEN(sym__type_order_operator);
      END_STATE();
    case 821:
      ACCEPT_TOKEN(sym__unary_operator);
      END_STATE();
    case 822:
      ACCEPT_TOKEN(sym__unary_operator);
      if (lookahead == '=') ADVANCE(794);
      END_STATE();
    case 823:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '+') ADVANCE(800);
      END_STATE();
    case 824:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '+') ADVANCE(800);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 825:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '-') ADVANCE(435);
      END_STATE();
    case 826:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '-') ADVANCE(435);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 827:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '-') ADVANCE(435);
      if (lookahead == '=') ADVANCE(780);
      if (lookahead == '>') ADVANCE(631);
      END_STATE();
    case 828:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '-') ADVANCE(435);
      if (lookahead == '=') ADVANCE(780);
      if (lookahead == '>') ADVANCE(831);
      END_STATE();
    case 829:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '-') ADVANCE(435);
      if (lookahead == '>') ADVANCE(631);
      END_STATE();
    case 830:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '-') ADVANCE(435);
      if (lookahead == '>') ADVANCE(831);
      END_STATE();
    case 831:
      ACCEPT_TOKEN(sym__syntactic_operator);
      END_STATE();
    case 832:
      ACCEPT_TOKEN(sym__syntactic_operator);
      ADVANCE_MAP(
        '!', 822,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 798,
        '/', 808,
        '<', 790,
        '=', 781,
        '>', 792,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(761);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 833:
      ACCEPT_TOKEN(sym__syntactic_operator);
      ADVANCE_MAP(
        '!', 822,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 799,
        '/', 808,
        '<', 790,
        '=', 781,
        '>', 792,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(761);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 834:
      ACCEPT_TOKEN(sym__syntactic_operator);
      ADVANCE_MAP(
        '!', 822,
        '%', 810,
        '&', 807,
        '*', 810,
        '+', 824,
        '-', 826,
        '.', 799,
        '/', 808,
        '<', 790,
        '=', 624,
        '>', 792,
        '\\', 810,
        '^', 818,
        '|', 802,
        '~', 819,
        0xf7, 810,
        0x2212, 801,
        0x22bb, 801,
        0xb1, 800,
        0x2213, 800,
        0x2254, 780,
        0x2255, 780,
        0x2a74, 780,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(761);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 835:
      ACCEPT_TOKEN(sym__syntactic_operator);
      ADVANCE_MAP(
        '!', 822,
        '+', 823,
        '-', 825,
        '.', 799,
        '/', 809,
        '<', 791,
        '=', 434,
        '>', 793,
        '|', 803,
        '~', 819,
        0xb1, 800,
        0x2213, 800,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(821);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(797);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(817);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(800);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(805);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(783);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(787);
      END_STATE();
    case 836:
      ACCEPT_TOKEN(sym__syntactic_operator);
      if (lookahead == '=') ADVANCE(780);
      END_STATE();
    case 837:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == ';') ADVANCE(837);
      END_STATE();
    case 838:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(838);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'e', 4,
        'f', 5,
        'g', 6,
        'i', 7,
        'l', 8,
        'm', 9,
        'o', 10,
        'p', 11,
        'q', 12,
        'r', 13,
        's', 14,
        't', 15,
        'u', 16,
        'w', 17,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(18);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(19);
      if (lookahead == 'e') ADVANCE(20);
      if (lookahead == 'r') ADVANCE(21);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(22);
      END_STATE();
    case 4:
      if (lookahead == 'x') ADVANCE(23);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(24);
      if (lookahead == 'u') ADVANCE(25);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(26);
      END_STATE();
    case 7:
      if (lookahead == 'm') ADVANCE(27);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      if (lookahead == 'u') ADVANCE(32);
      END_STATE();
    case 10:
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 11:
      if (lookahead == 'r') ADVANCE(34);
      END_STATE();
    case 12:
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(36);
      END_STATE();
    case 14:
      if (lookahead == 't') ADVANCE(37);
      END_STATE();
    case 15:
      if (lookahead == 'r') ADVANCE(38);
      if (lookahead == 'y') ADVANCE(39);
      END_STATE();
    case 16:
      if (lookahead == 's') ADVANCE(40);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(41);
      END_STATE();
    case 18:
      if (lookahead == 's') ADVANCE(42);
      END_STATE();
    case 19:
      if (lookahead == 'r') ADVANCE(43);
      END_STATE();
    case 20:
      if (lookahead == 'g') ADVANCE(44);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(45);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(46);
      END_STATE();
    case 23:
      if (lookahead == 'p') ADVANCE(47);
      END_STATE();
    case 24:
      if (lookahead == 'l') ADVANCE(48);
      END_STATE();
    case 25:
      if (lookahead == 'n') ADVANCE(49);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 27:
      if (lookahead == 'p') ADVANCE(51);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 29:
      if (lookahead == 'c') ADVANCE(53);
      END_STATE();
    case 30:
      if (lookahead == 'c') ADVANCE(54);
      END_STATE();
    case 31:
      if (lookahead == 'd') ADVANCE(55);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(56);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(57);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(58);
      END_STATE();
    case 35:
      if (lookahead == 'o') ADVANCE(59);
      END_STATE();
    case 36:
      if (lookahead == 't') ADVANCE(60);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(61);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(62);
      if (lookahead == 'y') ADVANCE(63);
      END_STATE();
    case 39:
      if (lookahead == 'p') ADVANCE(64);
      END_STATE();
    case 40:
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 41:
      if (lookahead == 'i') ADVANCE(66);
      END_STATE();
    case 42:
      if (lookahead == 't') ADVANCE(67);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(68);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(70);
      END_STATE();
    case 46:
      if (lookahead == 's') ADVANCE(71);
      if (lookahead == 't') ADVANCE(72);
      END_STATE();
    case 47:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 48:
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 49:
      if (lookahead == 'c') ADVANCE(75);
      END_STATE();
    case 50:
      if (lookahead == 'b') ADVANCE(76);
      END_STATE();
    case 51:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 53:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 54:
      if (lookahead == 'r') ADVANCE(79);
      END_STATE();
    case 55:
      if (lookahead == 'u') ADVANCE(80);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(81);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(82);
      END_STATE();
    case 58:
      if (lookahead == 'm') ADVANCE(83);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(84);
      END_STATE();
    case 60:
      if (lookahead == 'u') ADVANCE(85);
      END_STATE();
    case 61:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(88);
      END_STATE();
    case 65:
      if (lookahead == 'n') ADVANCE(89);
      END_STATE();
    case 66:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(91);
      END_STATE();
    case 68:
      if (lookahead == 'm') ADVANCE(92);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 70:
      if (lookahead == 'k') ADVANCE(94);
      END_STATE();
    case 71:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 73:
      if (lookahead == 'r') ADVANCE(97);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(100);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(101);
      END_STATE();
    case 78:
      if (lookahead == 'l') ADVANCE(102);
      END_STATE();
    case 79:
      if (lookahead == 'o') ADVANCE(103);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(104);
      END_STATE();
    case 81:
      if (lookahead == 'b') ADVANCE(105);
      END_STATE();
    case 82:
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 83:
      if (lookahead == 'i') ADVANCE(107);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 85:
      if (lookahead == 'r') ADVANCE(109);
      END_STATE();
    case 86:
      if (lookahead == 'c') ADVANCE(110);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 89:
      if (lookahead == 'g') ADVANCE(111);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(112);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(113);
      END_STATE();
    case 92:
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_break_statement);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 96:
      if (lookahead == 'n') ADVANCE(115);
      END_STATE();
    case 97:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 99:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 100:
      if (lookahead == 'l') ADVANCE(118);
      END_STATE();
    case 101:
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_macro);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(120);
      END_STATE();
    case 105:
      if (lookahead == 'l') ADVANCE(121);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_outer);
      END_STATE();
    case 107:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_quote);
      END_STATE();
    case 109:
      if (lookahead == 'n') ADVANCE(123);
      END_STATE();
    case 110:
      if (lookahead == 't') ADVANCE(124);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 113:
      if (lookahead == 'c') ADVANCE(125);
      END_STATE();
    case 114:
      if (lookahead == 'd') ADVANCE(126);
      END_STATE();
    case 115:
      if (lookahead == 'u') ADVANCE(127);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 117:
      if (lookahead == 'o') ADVANCE(128);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(129);
      END_STATE();
    case 122:
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 125:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 126:
      if (lookahead == 'u') ADVANCE(132);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(133);
      END_STATE();
    case 128:
      if (lookahead == 'n') ADVANCE(134);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 130:
      if (lookahead == 'v') ADVANCE(135);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(136);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_continue_statement);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 135:
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 136:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_primitive);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_baremodule);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 556, .external_lex_state = 2},
  [2] = {.lex_state = 499, .external_lex_state = 3},
  [3] = {.lex_state = 9, .external_lex_state = 3},
  [4] = {.lex_state = 90, .external_lex_state = 4},
  [5] = {.lex_state = 90, .external_lex_state = 4},
  [6] = {.lex_state = 88, .external_lex_state = 4},
  [7] = {.lex_state = 88, .external_lex_state = 4},
  [8] = {.lex_state = 510, .external_lex_state = 4},
  [9] = {.lex_state = 510, .external_lex_state = 4},
  [10] = {.lex_state = 88, .external_lex_state = 4},
  [11] = {.lex_state = 88, .external_lex_state = 4},
  [12] = {.lex_state = 90, .external_lex_state = 4},
  [13] = {.lex_state = 90, .external_lex_state = 4},
  [14] = {.lex_state = 88, .external_lex_state = 4},
  [15] = {.lex_state = 89, .external_lex_state = 4},
  [16] = {.lex_state = 88, .external_lex_state = 4},
  [17] = {.lex_state = 88, .external_lex_state = 4},
  [18] = {.lex_state = 83, .external_lex_state = 4},
  [19] = {.lex_state = 83, .external_lex_state = 4},
  [20] = {.lex_state = 88, .external_lex_state = 4},
  [21] = {.lex_state = 82, .external_lex_state = 4},
  [22] = {.lex_state = 82, .external_lex_state = 4},
  [23] = {.lex_state = 89, .external_lex_state = 4},
  [24] = {.lex_state = 89, .external_lex_state = 4},
  [25] = {.lex_state = 90, .external_lex_state = 4},
  [26] = {.lex_state = 90, .external_lex_state = 4},
  [27] = {.lex_state = 90, .external_lex_state = 4},
  [28] = {.lex_state = 90, .external_lex_state = 4},
  [29] = {.lex_state = 83, .external_lex_state = 4},
  [30] = {.lex_state = 83, .external_lex_state = 4},
  [31] = {.lex_state = 510, .external_lex_state = 4},
  [32] = {.lex_state = 82, .external_lex_state = 4},
  [33] = {.lex_state = 82, .external_lex_state = 4},
  [34] = {.lex_state = 89, .external_lex_state = 4},
  [35] = {.lex_state = 510, .external_lex_state = 4},
  [36] = {.lex_state = 325, .external_lex_state = 4},
  [37] = {.lex_state = 510, .external_lex_state = 4},
  [38] = {.lex_state = 82, .external_lex_state = 4},
  [39] = {.lex_state = 82, .external_lex_state = 4},
  [40] = {.lex_state = 89, .external_lex_state = 4},
  [41] = {.lex_state = 89, .external_lex_state = 4},
  [42] = {.lex_state = 75, .external_lex_state = 4},
  [43] = {.lex_state = 75, .external_lex_state = 4},
  [44] = {.lex_state = 510, .external_lex_state = 4},
  [45] = {.lex_state = 82, .external_lex_state = 4},
  [46] = {.lex_state = 509, .external_lex_state = 4},
  [47] = {.lex_state = 509, .external_lex_state = 4},
  [48] = {.lex_state = 82, .external_lex_state = 4},
  [49] = {.lex_state = 89, .external_lex_state = 4},
  [50] = {.lex_state = 509, .external_lex_state = 4},
  [51] = {.lex_state = 509, .external_lex_state = 4},
  [52] = {.lex_state = 89, .external_lex_state = 4},
  [53] = {.lex_state = 83, .external_lex_state = 4},
  [54] = {.lex_state = 325, .external_lex_state = 4},
  [55] = {.lex_state = 83, .external_lex_state = 4},
  [56] = {.lex_state = 83, .external_lex_state = 4},
  [57] = {.lex_state = 83, .external_lex_state = 4},
  [58] = {.lex_state = 75, .external_lex_state = 4},
  [59] = {.lex_state = 75, .external_lex_state = 4},
  [60] = {.lex_state = 325, .external_lex_state = 4},
  [61] = {.lex_state = 325, .external_lex_state = 4},
  [62] = {.lex_state = 510, .external_lex_state = 4},
  [63] = {.lex_state = 510, .external_lex_state = 4},
  [64] = {.lex_state = 509, .external_lex_state = 4},
  [65] = {.lex_state = 325, .external_lex_state = 4},
  [66] = {.lex_state = 325, .external_lex_state = 4},
  [67] = {.lex_state = 75, .external_lex_state = 4},
  [68] = {.lex_state = 75, .external_lex_state = 4},
  [69] = {.lex_state = 325, .external_lex_state = 4},
  [70] = {.lex_state = 88, .external_lex_state = 2},
  [71] = {.lex_state = 325, .external_lex_state = 4},
  [72] = {.lex_state = 325, .external_lex_state = 4},
  [73] = {.lex_state = 75, .external_lex_state = 4},
  [74] = {.lex_state = 75, .external_lex_state = 4},
  [75] = {.lex_state = 509, .external_lex_state = 2},
  [76] = {.lex_state = 509, .external_lex_state = 2},
  [77] = {.lex_state = 88, .external_lex_state = 2},
  [78] = {.lex_state = 88, .external_lex_state = 2},
  [79] = {.lex_state = 509, .external_lex_state = 4},
  [80] = {.lex_state = 509, .external_lex_state = 4},
  [81] = {.lex_state = 509, .external_lex_state = 4},
  [82] = {.lex_state = 325, .external_lex_state = 4},
  [83] = {.lex_state = 325, .external_lex_state = 4},
  [84] = {.lex_state = 510, .external_lex_state = 4},
  [85] = {.lex_state = 510, .external_lex_state = 4},
  [86] = {.lex_state = 509, .external_lex_state = 2},
  [87] = {.lex_state = 510, .external_lex_state = 4},
  [88] = {.lex_state = 88, .external_lex_state = 2},
  [89] = {.lex_state = 510, .external_lex_state = 4},
  [90] = {.lex_state = 88, .external_lex_state = 2},
  [91] = {.lex_state = 325, .external_lex_state = 4},
  [92] = {.lex_state = 325, .external_lex_state = 4},
  [93] = {.lex_state = 325, .external_lex_state = 4},
  [94] = {.lex_state = 88, .external_lex_state = 2},
  [95] = {.lex_state = 88, .external_lex_state = 2},
  [96] = {.lex_state = 88, .external_lex_state = 2},
  [97] = {.lex_state = 88, .external_lex_state = 2},
  [98] = {.lex_state = 88, .external_lex_state = 2},
  [99] = {.lex_state = 88, .external_lex_state = 2},
  [100] = {.lex_state = 509, .external_lex_state = 2},
  [101] = {.lex_state = 88, .external_lex_state = 2},
  [102] = {.lex_state = 88, .external_lex_state = 2},
  [103] = {.lex_state = 325, .external_lex_state = 4},
  [104] = {.lex_state = 325, .external_lex_state = 4},
  [105] = {.lex_state = 120, .external_lex_state = 2},
  [106] = {.lex_state = 120, .external_lex_state = 2},
  [107] = {.lex_state = 90, .external_lex_state = 2},
  [108] = {.lex_state = 88, .external_lex_state = 2},
  [109] = {.lex_state = 510, .external_lex_state = 2},
  [110] = {.lex_state = 90, .external_lex_state = 2},
  [111] = {.lex_state = 88, .external_lex_state = 2},
  [112] = {.lex_state = 88, .external_lex_state = 2},
  [113] = {.lex_state = 90, .external_lex_state = 2},
  [114] = {.lex_state = 88, .external_lex_state = 2},
  [115] = {.lex_state = 90, .external_lex_state = 2},
  [116] = {.lex_state = 151, .external_lex_state = 2},
  [117] = {.lex_state = 325, .external_lex_state = 4},
  [118] = {.lex_state = 325, .external_lex_state = 4},
  [119] = {.lex_state = 325, .external_lex_state = 4},
  [120] = {.lex_state = 90, .external_lex_state = 2},
  [121] = {.lex_state = 510, .external_lex_state = 2},
  [122] = {.lex_state = 120, .external_lex_state = 2},
  [123] = {.lex_state = 325, .external_lex_state = 4},
  [124] = {.lex_state = 325, .external_lex_state = 4},
  [125] = {.lex_state = 120, .external_lex_state = 2},
  [126] = {.lex_state = 88, .external_lex_state = 2},
  [127] = {.lex_state = 325, .external_lex_state = 4},
  [128] = {.lex_state = 151, .external_lex_state = 2},
  [129] = {.lex_state = 89, .external_lex_state = 2},
  [130] = {.lex_state = 83, .external_lex_state = 2},
  [131] = {.lex_state = 82, .external_lex_state = 2},
  [132] = {.lex_state = 89, .external_lex_state = 2},
  [133] = {.lex_state = 89, .external_lex_state = 2},
  [134] = {.lex_state = 90, .external_lex_state = 2},
  [135] = {.lex_state = 90, .external_lex_state = 2},
  [136] = {.lex_state = 83, .external_lex_state = 2},
  [137] = {.lex_state = 89, .external_lex_state = 2},
  [138] = {.lex_state = 88, .external_lex_state = 2},
  [139] = {.lex_state = 82, .external_lex_state = 2},
  [140] = {.lex_state = 83, .external_lex_state = 2},
  [141] = {.lex_state = 510, .external_lex_state = 2},
  [142] = {.lex_state = 325, .external_lex_state = 4},
  [143] = {.lex_state = 325, .external_lex_state = 4},
  [144] = {.lex_state = 510, .external_lex_state = 2},
  [145] = {.lex_state = 88, .external_lex_state = 2},
  [146] = {.lex_state = 82, .external_lex_state = 2},
  [147] = {.lex_state = 325, .external_lex_state = 4},
  [148] = {.lex_state = 325, .external_lex_state = 4},
  [149] = {.lex_state = 82, .external_lex_state = 2},
  [150] = {.lex_state = 88, .external_lex_state = 2},
  [151] = {.lex_state = 90, .external_lex_state = 2},
  [152] = {.lex_state = 90, .external_lex_state = 2},
  [153] = {.lex_state = 88, .external_lex_state = 2},
  [154] = {.lex_state = 82, .external_lex_state = 2},
  [155] = {.lex_state = 90, .external_lex_state = 2},
  [156] = {.lex_state = 89, .external_lex_state = 2},
  [157] = {.lex_state = 510, .external_lex_state = 2},
  [158] = {.lex_state = 88, .external_lex_state = 2},
  [159] = {.lex_state = 88, .external_lex_state = 5},
  [160] = {.lex_state = 88, .external_lex_state = 5},
  [161] = {.lex_state = 90, .external_lex_state = 2},
  [162] = {.lex_state = 83, .external_lex_state = 2},
  [163] = {.lex_state = 82, .external_lex_state = 2},
  [164] = {.lex_state = 83, .external_lex_state = 2},
  [165] = {.lex_state = 89, .external_lex_state = 2},
  [166] = {.lex_state = 89, .external_lex_state = 2},
  [167] = {.lex_state = 75, .external_lex_state = 2},
  [168] = {.lex_state = 510, .external_lex_state = 2},
  [169] = {.lex_state = 75, .external_lex_state = 2},
  [170] = {.lex_state = 509, .external_lex_state = 2},
  [171] = {.lex_state = 82, .external_lex_state = 2},
  [172] = {.lex_state = 89, .external_lex_state = 2},
  [173] = {.lex_state = 89, .external_lex_state = 2},
  [174] = {.lex_state = 88, .external_lex_state = 5},
  [175] = {.lex_state = 510, .external_lex_state = 2},
  [176] = {.lex_state = 88, .external_lex_state = 5},
  [177] = {.lex_state = 88, .external_lex_state = 5},
  [178] = {.lex_state = 325, .external_lex_state = 2},
  [179] = {.lex_state = 509, .external_lex_state = 2},
  [180] = {.lex_state = 88, .external_lex_state = 5},
  [181] = {.lex_state = 509, .external_lex_state = 2},
  [182] = {.lex_state = 88, .external_lex_state = 5},
  [183] = {.lex_state = 325, .external_lex_state = 2},
  [184] = {.lex_state = 325, .external_lex_state = 2},
  [185] = {.lex_state = 325, .external_lex_state = 4},
  [186] = {.lex_state = 325, .external_lex_state = 4},
  [187] = {.lex_state = 510, .external_lex_state = 2},
  [188] = {.lex_state = 88, .external_lex_state = 5},
  [189] = {.lex_state = 510, .external_lex_state = 5},
  [190] = {.lex_state = 88, .external_lex_state = 5},
  [191] = {.lex_state = 83, .external_lex_state = 2},
  [192] = {.lex_state = 82, .external_lex_state = 2},
  [193] = {.lex_state = 88, .external_lex_state = 5},
  [194] = {.lex_state = 88, .external_lex_state = 2},
  [195] = {.lex_state = 88, .external_lex_state = 5},
  [196] = {.lex_state = 89, .external_lex_state = 2},
  [197] = {.lex_state = 509, .external_lex_state = 2},
  [198] = {.lex_state = 88, .external_lex_state = 5},
  [199] = {.lex_state = 88, .external_lex_state = 2},
  [200] = {.lex_state = 88, .external_lex_state = 5},
  [201] = {.lex_state = 88, .external_lex_state = 5},
  [202] = {.lex_state = 88, .external_lex_state = 5},
  [203] = {.lex_state = 90, .external_lex_state = 2},
  [204] = {.lex_state = 90, .external_lex_state = 5},
  [205] = {.lex_state = 88, .external_lex_state = 2},
  [206] = {.lex_state = 82, .external_lex_state = 2},
  [207] = {.lex_state = 83, .external_lex_state = 2},
  [208] = {.lex_state = 75, .external_lex_state = 2},
  [209] = {.lex_state = 82, .external_lex_state = 2},
  [210] = {.lex_state = 83, .external_lex_state = 2},
  [211] = {.lex_state = 90, .external_lex_state = 5},
  [212] = {.lex_state = 510, .external_lex_state = 5},
  [213] = {.lex_state = 509, .external_lex_state = 2},
  [214] = {.lex_state = 509, .external_lex_state = 2},
  [215] = {.lex_state = 75, .external_lex_state = 2},
  [216] = {.lex_state = 82, .external_lex_state = 5},
  [217] = {.lex_state = 325, .external_lex_state = 2},
  [218] = {.lex_state = 325, .external_lex_state = 2},
  [219] = {.lex_state = 325, .external_lex_state = 2},
  [220] = {.lex_state = 509, .external_lex_state = 2},
  [221] = {.lex_state = 509, .external_lex_state = 2},
  [222] = {.lex_state = 75, .external_lex_state = 2},
  [223] = {.lex_state = 509, .external_lex_state = 2},
  [224] = {.lex_state = 89, .external_lex_state = 2},
  [225] = {.lex_state = 325, .external_lex_state = 2},
  [226] = {.lex_state = 89, .external_lex_state = 5},
  [227] = {.lex_state = 325, .external_lex_state = 2},
  [228] = {.lex_state = 325, .external_lex_state = 2},
  [229] = {.lex_state = 510, .external_lex_state = 2},
  [230] = {.lex_state = 325, .external_lex_state = 2},
  [231] = {.lex_state = 88, .external_lex_state = 5},
  [232] = {.lex_state = 89, .external_lex_state = 2},
  [233] = {.lex_state = 75, .external_lex_state = 2},
  [234] = {.lex_state = 83, .external_lex_state = 2},
  [235] = {.lex_state = 89, .external_lex_state = 5},
  [236] = {.lex_state = 325, .external_lex_state = 2},
  [237] = {.lex_state = 325, .external_lex_state = 2},
  [238] = {.lex_state = 83, .external_lex_state = 5},
  [239] = {.lex_state = 510, .external_lex_state = 2},
  [240] = {.lex_state = 82, .external_lex_state = 2},
  [241] = {.lex_state = 88, .external_lex_state = 5},
  [242] = {.lex_state = 82, .external_lex_state = 5},
  [243] = {.lex_state = 75, .external_lex_state = 2},
  [244] = {.lex_state = 510, .external_lex_state = 2},
  [245] = {.lex_state = 75, .external_lex_state = 2},
  [246] = {.lex_state = 83, .external_lex_state = 2},
  [247] = {.lex_state = 90, .external_lex_state = 5},
  [248] = {.lex_state = 83, .external_lex_state = 5},
  [249] = {.lex_state = 90, .external_lex_state = 5},
  [250] = {.lex_state = 510, .external_lex_state = 2},
  [251] = {.lex_state = 82, .external_lex_state = 2},
  [252] = {.lex_state = 509, .external_lex_state = 2},
  [253] = {.lex_state = 325, .external_lex_state = 2},
  [254] = {.lex_state = 75, .external_lex_state = 5},
  [255] = {.lex_state = 509, .external_lex_state = 5},
  [256] = {.lex_state = 510, .external_lex_state = 5},
  [257] = {.lex_state = 509, .external_lex_state = 5},
  [258] = {.lex_state = 509, .external_lex_state = 5},
  [259] = {.lex_state = 509, .external_lex_state = 2},
  [260] = {.lex_state = 509, .external_lex_state = 5},
  [261] = {.lex_state = 509, .external_lex_state = 5},
  [262] = {.lex_state = 509, .external_lex_state = 5},
  [263] = {.lex_state = 509, .external_lex_state = 5},
  [264] = {.lex_state = 509, .external_lex_state = 5},
  [265] = {.lex_state = 509, .external_lex_state = 2},
  [266] = {.lex_state = 509, .external_lex_state = 5},
  [267] = {.lex_state = 509, .external_lex_state = 5},
  [268] = {.lex_state = 509, .external_lex_state = 5},
  [269] = {.lex_state = 325, .external_lex_state = 2},
  [270] = {.lex_state = 83, .external_lex_state = 5},
  [271] = {.lex_state = 509, .external_lex_state = 5},
  [272] = {.lex_state = 509, .external_lex_state = 5},
  [273] = {.lex_state = 509, .external_lex_state = 5},
  [274] = {.lex_state = 325, .external_lex_state = 2},
  [275] = {.lex_state = 509, .external_lex_state = 5},
  [276] = {.lex_state = 510, .external_lex_state = 5},
  [277] = {.lex_state = 509, .external_lex_state = 2},
  [278] = {.lex_state = 325, .external_lex_state = 2},
  [279] = {.lex_state = 325, .external_lex_state = 2},
  [280] = {.lex_state = 325, .external_lex_state = 2},
  [281] = {.lex_state = 325, .external_lex_state = 2},
  [282] = {.lex_state = 75, .external_lex_state = 2},
  [283] = {.lex_state = 510, .external_lex_state = 2},
  [284] = {.lex_state = 509, .external_lex_state = 2},
  [285] = {.lex_state = 75, .external_lex_state = 2},
  [286] = {.lex_state = 509, .external_lex_state = 2},
  [287] = {.lex_state = 75, .external_lex_state = 5},
  [288] = {.lex_state = 325, .external_lex_state = 2},
  [289] = {.lex_state = 325, .external_lex_state = 5},
  [290] = {.lex_state = 82, .external_lex_state = 5},
  [291] = {.lex_state = 509, .external_lex_state = 2},
  [292] = {.lex_state = 83, .external_lex_state = 5},
  [293] = {.lex_state = 325, .external_lex_state = 2},
  [294] = {.lex_state = 509, .external_lex_state = 2},
  [295] = {.lex_state = 509, .external_lex_state = 2},
  [296] = {.lex_state = 509, .external_lex_state = 2},
  [297] = {.lex_state = 82, .external_lex_state = 5},
  [298] = {.lex_state = 509, .external_lex_state = 2},
  [299] = {.lex_state = 509, .external_lex_state = 2},
  [300] = {.lex_state = 89, .external_lex_state = 5},
  [301] = {.lex_state = 509, .external_lex_state = 2},
  [302] = {.lex_state = 509, .external_lex_state = 2},
  [303] = {.lex_state = 509, .external_lex_state = 2},
  [304] = {.lex_state = 510, .external_lex_state = 2},
  [305] = {.lex_state = 325, .external_lex_state = 2},
  [306] = {.lex_state = 325, .external_lex_state = 5},
  [307] = {.lex_state = 88, .external_lex_state = 5},
  [308] = {.lex_state = 89, .external_lex_state = 5},
  [309] = {.lex_state = 75, .external_lex_state = 5},
  [310] = {.lex_state = 510, .external_lex_state = 5},
  [311] = {.lex_state = 325, .external_lex_state = 5},
  [312] = {.lex_state = 325, .external_lex_state = 2},
  [313] = {.lex_state = 325, .external_lex_state = 2},
  [314] = {.lex_state = 325, .external_lex_state = 2},
  [315] = {.lex_state = 325, .external_lex_state = 2},
  [316] = {.lex_state = 325, .external_lex_state = 5},
  [317] = {.lex_state = 325, .external_lex_state = 5},
  [318] = {.lex_state = 325, .external_lex_state = 5},
  [319] = {.lex_state = 509, .external_lex_state = 5},
  [320] = {.lex_state = 325, .external_lex_state = 5},
  [321] = {.lex_state = 325, .external_lex_state = 2},
  [322] = {.lex_state = 75, .external_lex_state = 5},
  [323] = {.lex_state = 510, .external_lex_state = 5},
  [324] = {.lex_state = 325, .external_lex_state = 2},
  [325] = {.lex_state = 509, .external_lex_state = 5},
  [326] = {.lex_state = 510, .external_lex_state = 5},
  [327] = {.lex_state = 325, .external_lex_state = 2},
  [328] = {.lex_state = 325, .external_lex_state = 5},
  [329] = {.lex_state = 325, .external_lex_state = 2},
  [330] = {.lex_state = 509, .external_lex_state = 5},
  [331] = {.lex_state = 75, .external_lex_state = 5},
  [332] = {.lex_state = 510, .external_lex_state = 5},
  [333] = {.lex_state = 325, .external_lex_state = 5},
  [334] = {.lex_state = 325, .external_lex_state = 2},
  [335] = {.lex_state = 325, .external_lex_state = 5},
  [336] = {.lex_state = 325, .external_lex_state = 5},
  [337] = {.lex_state = 325, .external_lex_state = 5},
  [338] = {.lex_state = 510, .external_lex_state = 5},
  [339] = {.lex_state = 323, .external_lex_state = 2},
  [340] = {.lex_state = 323, .external_lex_state = 2},
  [341] = {.lex_state = 323, .external_lex_state = 2},
  [342] = {.lex_state = 323, .external_lex_state = 2},
  [343] = {.lex_state = 323, .external_lex_state = 2},
  [344] = {.lex_state = 323, .external_lex_state = 2},
  [345] = {.lex_state = 323, .external_lex_state = 2},
  [346] = {.lex_state = 323, .external_lex_state = 2},
  [347] = {.lex_state = 323, .external_lex_state = 2},
  [348] = {.lex_state = 325, .external_lex_state = 5},
  [349] = {.lex_state = 323, .external_lex_state = 2},
  [350] = {.lex_state = 325, .external_lex_state = 5},
  [351] = {.lex_state = 323, .external_lex_state = 2},
  [352] = {.lex_state = 323, .external_lex_state = 2},
  [353] = {.lex_state = 323, .external_lex_state = 2},
  [354] = {.lex_state = 323, .external_lex_state = 2},
  [355] = {.lex_state = 323, .external_lex_state = 2},
  [356] = {.lex_state = 323, .external_lex_state = 2},
  [357] = {.lex_state = 323, .external_lex_state = 2},
  [358] = {.lex_state = 323, .external_lex_state = 2},
  [359] = {.lex_state = 323, .external_lex_state = 2},
  [360] = {.lex_state = 323, .external_lex_state = 2},
  [361] = {.lex_state = 323, .external_lex_state = 2},
  [362] = {.lex_state = 323, .external_lex_state = 2},
  [363] = {.lex_state = 323, .external_lex_state = 2},
  [364] = {.lex_state = 323, .external_lex_state = 2},
  [365] = {.lex_state = 323, .external_lex_state = 2},
  [366] = {.lex_state = 323, .external_lex_state = 2},
  [367] = {.lex_state = 323, .external_lex_state = 2},
  [368] = {.lex_state = 323, .external_lex_state = 2},
  [369] = {.lex_state = 323, .external_lex_state = 2},
  [370] = {.lex_state = 323, .external_lex_state = 2},
  [371] = {.lex_state = 323, .external_lex_state = 2},
  [372] = {.lex_state = 323, .external_lex_state = 2},
  [373] = {.lex_state = 323, .external_lex_state = 2},
  [374] = {.lex_state = 323, .external_lex_state = 2},
  [375] = {.lex_state = 323, .external_lex_state = 2},
  [376] = {.lex_state = 325, .external_lex_state = 5},
  [377] = {.lex_state = 323, .external_lex_state = 2},
  [378] = {.lex_state = 323, .external_lex_state = 2},
  [379] = {.lex_state = 323, .external_lex_state = 2},
  [380] = {.lex_state = 323, .external_lex_state = 2},
  [381] = {.lex_state = 323, .external_lex_state = 2},
  [382] = {.lex_state = 323, .external_lex_state = 2},
  [383] = {.lex_state = 323, .external_lex_state = 2},
  [384] = {.lex_state = 323, .external_lex_state = 2},
  [385] = {.lex_state = 323, .external_lex_state = 2},
  [386] = {.lex_state = 323, .external_lex_state = 2},
  [387] = {.lex_state = 323, .external_lex_state = 2},
  [388] = {.lex_state = 323, .external_lex_state = 2},
  [389] = {.lex_state = 323, .external_lex_state = 2},
  [390] = {.lex_state = 323, .external_lex_state = 2},
  [391] = {.lex_state = 323, .external_lex_state = 2},
  [392] = {.lex_state = 323, .external_lex_state = 2},
  [393] = {.lex_state = 323, .external_lex_state = 2},
  [394] = {.lex_state = 323, .external_lex_state = 2},
  [395] = {.lex_state = 323, .external_lex_state = 2},
  [396] = {.lex_state = 323, .external_lex_state = 2},
  [397] = {.lex_state = 323, .external_lex_state = 2},
  [398] = {.lex_state = 323, .external_lex_state = 2},
  [399] = {.lex_state = 323, .external_lex_state = 2},
  [400] = {.lex_state = 323, .external_lex_state = 2},
  [401] = {.lex_state = 323, .external_lex_state = 2},
  [402] = {.lex_state = 323, .external_lex_state = 2},
  [403] = {.lex_state = 323, .external_lex_state = 2},
  [404] = {.lex_state = 323, .external_lex_state = 2},
  [405] = {.lex_state = 323, .external_lex_state = 2},
  [406] = {.lex_state = 323, .external_lex_state = 2},
  [407] = {.lex_state = 325, .external_lex_state = 2},
  [408] = {.lex_state = 323, .external_lex_state = 2},
  [409] = {.lex_state = 325, .external_lex_state = 5},
  [410] = {.lex_state = 325, .external_lex_state = 5},
  [411] = {.lex_state = 325, .external_lex_state = 5},
  [412] = {.lex_state = 210, .external_lex_state = 6},
  [413] = {.lex_state = 210, .external_lex_state = 6},
  [414] = {.lex_state = 346, .external_lex_state = 2},
  [415] = {.lex_state = 210, .external_lex_state = 6},
  [416] = {.lex_state = 210, .external_lex_state = 6},
  [417] = {.lex_state = 346, .external_lex_state = 2},
  [418] = {.lex_state = 210, .external_lex_state = 6},
  [419] = {.lex_state = 210, .external_lex_state = 6},
  [420] = {.lex_state = 210, .external_lex_state = 6},
  [421] = {.lex_state = 346, .external_lex_state = 2},
  [422] = {.lex_state = 210, .external_lex_state = 6},
  [423] = {.lex_state = 346, .external_lex_state = 2},
  [424] = {.lex_state = 210, .external_lex_state = 6},
  [425] = {.lex_state = 346, .external_lex_state = 2},
  [426] = {.lex_state = 210, .external_lex_state = 6},
  [427] = {.lex_state = 346, .external_lex_state = 2},
  [428] = {.lex_state = 210, .external_lex_state = 6},
  [429] = {.lex_state = 210, .external_lex_state = 6},
  [430] = {.lex_state = 210, .external_lex_state = 6},
  [431] = {.lex_state = 210, .external_lex_state = 6},
  [432] = {.lex_state = 346, .external_lex_state = 2},
  [433] = {.lex_state = 210, .external_lex_state = 6},
  [434] = {.lex_state = 210, .external_lex_state = 6},
  [435] = {.lex_state = 210, .external_lex_state = 6},
  [436] = {.lex_state = 203, .external_lex_state = 2},
  [437] = {.lex_state = 346, .external_lex_state = 2},
  [438] = {.lex_state = 346, .external_lex_state = 2},
  [439] = {.lex_state = 210, .external_lex_state = 6},
  [440] = {.lex_state = 210, .external_lex_state = 6},
  [441] = {.lex_state = 210, .external_lex_state = 6},
  [442] = {.lex_state = 210, .external_lex_state = 6},
  [443] = {.lex_state = 346, .external_lex_state = 2},
  [444] = {.lex_state = 210, .external_lex_state = 6},
  [445] = {.lex_state = 346, .external_lex_state = 2},
  [446] = {.lex_state = 346, .external_lex_state = 2},
  [447] = {.lex_state = 210, .external_lex_state = 6},
  [448] = {.lex_state = 346, .external_lex_state = 2},
  [449] = {.lex_state = 203, .external_lex_state = 2},
  [450] = {.lex_state = 203, .external_lex_state = 2},
  [451] = {.lex_state = 210, .external_lex_state = 6},
  [452] = {.lex_state = 210, .external_lex_state = 6},
  [453] = {.lex_state = 203, .external_lex_state = 2},
  [454] = {.lex_state = 203, .external_lex_state = 2},
  [455] = {.lex_state = 203, .external_lex_state = 2},
  [456] = {.lex_state = 203, .external_lex_state = 2},
  [457] = {.lex_state = 203, .external_lex_state = 2},
  [458] = {.lex_state = 203, .external_lex_state = 2},
  [459] = {.lex_state = 203, .external_lex_state = 2},
  [460] = {.lex_state = 203, .external_lex_state = 2},
  [461] = {.lex_state = 203, .external_lex_state = 2},
  [462] = {.lex_state = 203, .external_lex_state = 2},
  [463] = {.lex_state = 210, .external_lex_state = 6},
  [464] = {.lex_state = 194, .external_lex_state = 2},
  [465] = {.lex_state = 210, .external_lex_state = 2},
  [466] = {.lex_state = 194, .external_lex_state = 2},
  [467] = {.lex_state = 210, .external_lex_state = 2},
  [468] = {.lex_state = 210, .external_lex_state = 2},
  [469] = {.lex_state = 210, .external_lex_state = 2},
  [470] = {.lex_state = 194, .external_lex_state = 2},
  [471] = {.lex_state = 194, .external_lex_state = 2},
  [472] = {.lex_state = 194, .external_lex_state = 2},
  [473] = {.lex_state = 210, .external_lex_state = 2},
  [474] = {.lex_state = 194, .external_lex_state = 2},
  [475] = {.lex_state = 210, .external_lex_state = 2},
  [476] = {.lex_state = 210, .external_lex_state = 2},
  [477] = {.lex_state = 194, .external_lex_state = 2},
  [478] = {.lex_state = 194, .external_lex_state = 2},
  [479] = {.lex_state = 194, .external_lex_state = 2},
  [480] = {.lex_state = 194, .external_lex_state = 2},
  [481] = {.lex_state = 194, .external_lex_state = 2},
  [482] = {.lex_state = 210, .external_lex_state = 2},
  [483] = {.lex_state = 210, .external_lex_state = 2},
  [484] = {.lex_state = 210, .external_lex_state = 2},
  [485] = {.lex_state = 194, .external_lex_state = 2},
  [486] = {.lex_state = 210, .external_lex_state = 2},
  [487] = {.lex_state = 210, .external_lex_state = 2},
  [488] = {.lex_state = 210, .external_lex_state = 2},
  [489] = {.lex_state = 194, .external_lex_state = 2},
  [490] = {.lex_state = 194, .external_lex_state = 2},
  [491] = {.lex_state = 194, .external_lex_state = 2},
  [492] = {.lex_state = 194, .external_lex_state = 2},
  [493] = {.lex_state = 194, .external_lex_state = 2},
  [494] = {.lex_state = 194, .external_lex_state = 2},
  [495] = {.lex_state = 194, .external_lex_state = 2},
  [496] = {.lex_state = 210, .external_lex_state = 2},
  [497] = {.lex_state = 210, .external_lex_state = 2},
  [498] = {.lex_state = 194, .external_lex_state = 2},
  [499] = {.lex_state = 210, .external_lex_state = 2},
  [500] = {.lex_state = 194, .external_lex_state = 2},
  [501] = {.lex_state = 210, .external_lex_state = 2},
  [502] = {.lex_state = 210, .external_lex_state = 2},
  [503] = {.lex_state = 210, .external_lex_state = 2},
  [504] = {.lex_state = 210, .external_lex_state = 2},
  [505] = {.lex_state = 210, .external_lex_state = 2},
  [506] = {.lex_state = 194, .external_lex_state = 2},
  [507] = {.lex_state = 210, .external_lex_state = 2},
  [508] = {.lex_state = 209, .external_lex_state = 2},
  [509] = {.lex_state = 194, .external_lex_state = 2},
  [510] = {.lex_state = 194, .external_lex_state = 2},
  [511] = {.lex_state = 210, .external_lex_state = 2},
  [512] = {.lex_state = 194, .external_lex_state = 2},
  [513] = {.lex_state = 210, .external_lex_state = 2},
  [514] = {.lex_state = 194, .external_lex_state = 2},
  [515] = {.lex_state = 210, .external_lex_state = 2},
  [516] = {.lex_state = 210, .external_lex_state = 2},
  [517] = {.lex_state = 345, .external_lex_state = 2},
  [518] = {.lex_state = 206, .external_lex_state = 2},
  [519] = {.lex_state = 345, .external_lex_state = 2},
  [520] = {.lex_state = 345, .external_lex_state = 2},
  [521] = {.lex_state = 345, .external_lex_state = 2},
  [522] = {.lex_state = 202, .external_lex_state = 2},
  [523] = {.lex_state = 345, .external_lex_state = 2},
  [524] = {.lex_state = 345, .external_lex_state = 2},
  [525] = {.lex_state = 345, .external_lex_state = 2},
  [526] = {.lex_state = 345, .external_lex_state = 2},
  [527] = {.lex_state = 345, .external_lex_state = 2},
  [528] = {.lex_state = 345, .external_lex_state = 2},
  [529] = {.lex_state = 345, .external_lex_state = 2},
  [530] = {.lex_state = 345, .external_lex_state = 2},
  [531] = {.lex_state = 345, .external_lex_state = 2},
  [532] = {.lex_state = 200, .external_lex_state = 2},
  [533] = {.lex_state = 194, .external_lex_state = 2},
  [534] = {.lex_state = 194, .external_lex_state = 2},
  [535] = {.lex_state = 194, .external_lex_state = 2},
  [536] = {.lex_state = 194, .external_lex_state = 2},
  [537] = {.lex_state = 194, .external_lex_state = 2},
  [538] = {.lex_state = 194, .external_lex_state = 2},
  [539] = {.lex_state = 200, .external_lex_state = 2},
  [540] = {.lex_state = 194, .external_lex_state = 2},
  [541] = {.lex_state = 194, .external_lex_state = 2},
  [542] = {.lex_state = 194, .external_lex_state = 2},
  [543] = {.lex_state = 194, .external_lex_state = 2},
  [544] = {.lex_state = 194, .external_lex_state = 2},
  [545] = {.lex_state = 200, .external_lex_state = 2},
  [546] = {.lex_state = 194, .external_lex_state = 2},
  [547] = {.lex_state = 194, .external_lex_state = 2},
  [548] = {.lex_state = 200, .external_lex_state = 2},
  [549] = {.lex_state = 194, .external_lex_state = 2},
  [550] = {.lex_state = 194, .external_lex_state = 2},
  [551] = {.lex_state = 194, .external_lex_state = 2},
  [552] = {.lex_state = 194, .external_lex_state = 2},
  [553] = {.lex_state = 194, .external_lex_state = 2},
  [554] = {.lex_state = 346, .external_lex_state = 2},
  [555] = {.lex_state = 194, .external_lex_state = 2},
  [556] = {.lex_state = 194, .external_lex_state = 2},
  [557] = {.lex_state = 194, .external_lex_state = 2},
  [558] = {.lex_state = 194, .external_lex_state = 2},
  [559] = {.lex_state = 194, .external_lex_state = 2},
  [560] = {.lex_state = 200, .external_lex_state = 2},
  [561] = {.lex_state = 194, .external_lex_state = 2},
  [562] = {.lex_state = 194, .external_lex_state = 2},
  [563] = {.lex_state = 349, .external_lex_state = 2},
  [564] = {.lex_state = 200, .external_lex_state = 2},
  [565] = {.lex_state = 194, .external_lex_state = 2},
  [566] = {.lex_state = 200, .external_lex_state = 2},
  [567] = {.lex_state = 200, .external_lex_state = 2},
  [568] = {.lex_state = 194, .external_lex_state = 2},
  [569] = {.lex_state = 194, .external_lex_state = 2},
  [570] = {.lex_state = 194, .external_lex_state = 2},
  [571] = {.lex_state = 194, .external_lex_state = 2},
  [572] = {.lex_state = 194, .external_lex_state = 2},
  [573] = {.lex_state = 194, .external_lex_state = 2},
  [574] = {.lex_state = 194, .external_lex_state = 2},
  [575] = {.lex_state = 194, .external_lex_state = 2},
  [576] = {.lex_state = 194, .external_lex_state = 2},
  [577] = {.lex_state = 194, .external_lex_state = 2},
  [578] = {.lex_state = 194, .external_lex_state = 2},
  [579] = {.lex_state = 194, .external_lex_state = 2},
  [580] = {.lex_state = 194, .external_lex_state = 2},
  [581] = {.lex_state = 200, .external_lex_state = 2},
  [582] = {.lex_state = 194, .external_lex_state = 2},
  [583] = {.lex_state = 200, .external_lex_state = 2},
  [584] = {.lex_state = 194, .external_lex_state = 2},
  [585] = {.lex_state = 194, .external_lex_state = 2},
  [586] = {.lex_state = 194, .external_lex_state = 2},
  [587] = {.lex_state = 194, .external_lex_state = 2},
  [588] = {.lex_state = 194, .external_lex_state = 2},
  [589] = {.lex_state = 194, .external_lex_state = 2},
  [590] = {.lex_state = 194, .external_lex_state = 2},
  [591] = {.lex_state = 194, .external_lex_state = 2},
  [592] = {.lex_state = 194, .external_lex_state = 2},
  [593] = {.lex_state = 194, .external_lex_state = 2},
  [594] = {.lex_state = 194, .external_lex_state = 2},
  [595] = {.lex_state = 200, .external_lex_state = 2},
  [596] = {.lex_state = 194, .external_lex_state = 2},
  [597] = {.lex_state = 194, .external_lex_state = 2},
  [598] = {.lex_state = 200, .external_lex_state = 2},
  [599] = {.lex_state = 194, .external_lex_state = 2},
  [600] = {.lex_state = 194, .external_lex_state = 2},
  [601] = {.lex_state = 194, .external_lex_state = 2},
  [602] = {.lex_state = 194, .external_lex_state = 2},
  [603] = {.lex_state = 200, .external_lex_state = 2},
  [604] = {.lex_state = 200, .external_lex_state = 2},
  [605] = {.lex_state = 194, .external_lex_state = 2},
  [606] = {.lex_state = 200, .external_lex_state = 2},
  [607] = {.lex_state = 200, .external_lex_state = 2},
  [608] = {.lex_state = 194, .external_lex_state = 2},
  [609] = {.lex_state = 200, .external_lex_state = 2},
  [610] = {.lex_state = 200, .external_lex_state = 2},
  [611] = {.lex_state = 200, .external_lex_state = 2},
  [612] = {.lex_state = 200, .external_lex_state = 2},
  [613] = {.lex_state = 200, .external_lex_state = 2},
  [614] = {.lex_state = 194, .external_lex_state = 2},
  [615] = {.lex_state = 200, .external_lex_state = 2},
  [616] = {.lex_state = 200, .external_lex_state = 2},
  [617] = {.lex_state = 194, .external_lex_state = 2},
  [618] = {.lex_state = 200, .external_lex_state = 2},
  [619] = {.lex_state = 200, .external_lex_state = 2},
  [620] = {.lex_state = 194, .external_lex_state = 2},
  [621] = {.lex_state = 200, .external_lex_state = 2},
  [622] = {.lex_state = 200, .external_lex_state = 2},
  [623] = {.lex_state = 200, .external_lex_state = 2},
  [624] = {.lex_state = 200, .external_lex_state = 2},
  [625] = {.lex_state = 200, .external_lex_state = 2},
  [626] = {.lex_state = 200, .external_lex_state = 2},
  [627] = {.lex_state = 200, .external_lex_state = 2},
  [628] = {.lex_state = 194, .external_lex_state = 2},
  [629] = {.lex_state = 200, .external_lex_state = 2},
  [630] = {.lex_state = 200, .external_lex_state = 2},
  [631] = {.lex_state = 194, .external_lex_state = 2},
  [632] = {.lex_state = 200, .external_lex_state = 2},
  [633] = {.lex_state = 200, .external_lex_state = 2},
  [634] = {.lex_state = 194, .external_lex_state = 2},
  [635] = {.lex_state = 200, .external_lex_state = 2},
  [636] = {.lex_state = 200, .external_lex_state = 2},
  [637] = {.lex_state = 200, .external_lex_state = 2},
  [638] = {.lex_state = 200, .external_lex_state = 2},
  [639] = {.lex_state = 200, .external_lex_state = 2},
  [640] = {.lex_state = 200, .external_lex_state = 2},
  [641] = {.lex_state = 194, .external_lex_state = 2},
  [642] = {.lex_state = 200, .external_lex_state = 2},
  [643] = {.lex_state = 200, .external_lex_state = 2},
  [644] = {.lex_state = 200, .external_lex_state = 2},
  [645] = {.lex_state = 200, .external_lex_state = 2},
  [646] = {.lex_state = 200, .external_lex_state = 2},
  [647] = {.lex_state = 194, .external_lex_state = 2},
  [648] = {.lex_state = 200, .external_lex_state = 2},
  [649] = {.lex_state = 200, .external_lex_state = 2},
  [650] = {.lex_state = 200, .external_lex_state = 2},
  [651] = {.lex_state = 200, .external_lex_state = 2},
  [652] = {.lex_state = 200, .external_lex_state = 2},
  [653] = {.lex_state = 200, .external_lex_state = 2},
  [654] = {.lex_state = 194, .external_lex_state = 2},
  [655] = {.lex_state = 200, .external_lex_state = 2},
  [656] = {.lex_state = 200, .external_lex_state = 2},
  [657] = {.lex_state = 194, .external_lex_state = 2},
  [658] = {.lex_state = 200, .external_lex_state = 2},
  [659] = {.lex_state = 200, .external_lex_state = 2},
  [660] = {.lex_state = 200, .external_lex_state = 2},
  [661] = {.lex_state = 200, .external_lex_state = 2},
  [662] = {.lex_state = 194, .external_lex_state = 2},
  [663] = {.lex_state = 200, .external_lex_state = 2},
  [664] = {.lex_state = 200, .external_lex_state = 2},
  [665] = {.lex_state = 200, .external_lex_state = 2},
  [666] = {.lex_state = 200, .external_lex_state = 2},
  [667] = {.lex_state = 200, .external_lex_state = 2},
  [668] = {.lex_state = 194, .external_lex_state = 2},
  [669] = {.lex_state = 200, .external_lex_state = 2},
  [670] = {.lex_state = 200, .external_lex_state = 2},
  [671] = {.lex_state = 194, .external_lex_state = 2},
  [672] = {.lex_state = 200, .external_lex_state = 2},
  [673] = {.lex_state = 200, .external_lex_state = 2},
  [674] = {.lex_state = 194, .external_lex_state = 2},
  [675] = {.lex_state = 200, .external_lex_state = 2},
  [676] = {.lex_state = 200, .external_lex_state = 2},
  [677] = {.lex_state = 200, .external_lex_state = 2},
  [678] = {.lex_state = 200, .external_lex_state = 2},
  [679] = {.lex_state = 200, .external_lex_state = 2},
  [680] = {.lex_state = 194, .external_lex_state = 2},
  [681] = {.lex_state = 200, .external_lex_state = 2},
  [682] = {.lex_state = 200, .external_lex_state = 2},
  [683] = {.lex_state = 200, .external_lex_state = 2},
  [684] = {.lex_state = 200, .external_lex_state = 2},
  [685] = {.lex_state = 194, .external_lex_state = 2},
  [686] = {.lex_state = 200, .external_lex_state = 2},
  [687] = {.lex_state = 200, .external_lex_state = 2},
  [688] = {.lex_state = 200, .external_lex_state = 2},
  [689] = {.lex_state = 200, .external_lex_state = 2},
  [690] = {.lex_state = 200, .external_lex_state = 2},
  [691] = {.lex_state = 194, .external_lex_state = 2},
  [692] = {.lex_state = 200, .external_lex_state = 2},
  [693] = {.lex_state = 200, .external_lex_state = 2},
  [694] = {.lex_state = 194, .external_lex_state = 2},
  [695] = {.lex_state = 200, .external_lex_state = 2},
  [696] = {.lex_state = 200, .external_lex_state = 2},
  [697] = {.lex_state = 200, .external_lex_state = 2},
  [698] = {.lex_state = 200, .external_lex_state = 2},
  [699] = {.lex_state = 200, .external_lex_state = 2},
  [700] = {.lex_state = 200, .external_lex_state = 2},
  [701] = {.lex_state = 200, .external_lex_state = 2},
  [702] = {.lex_state = 194, .external_lex_state = 2},
  [703] = {.lex_state = 200, .external_lex_state = 2},
  [704] = {.lex_state = 200, .external_lex_state = 2},
  [705] = {.lex_state = 194, .external_lex_state = 2},
  [706] = {.lex_state = 200, .external_lex_state = 2},
  [707] = {.lex_state = 200, .external_lex_state = 2},
  [708] = {.lex_state = 194, .external_lex_state = 2},
  [709] = {.lex_state = 200, .external_lex_state = 2},
  [710] = {.lex_state = 200, .external_lex_state = 2},
  [711] = {.lex_state = 194, .external_lex_state = 2},
  [712] = {.lex_state = 200, .external_lex_state = 2},
  [713] = {.lex_state = 200, .external_lex_state = 2},
  [714] = {.lex_state = 200, .external_lex_state = 2},
  [715] = {.lex_state = 200, .external_lex_state = 2},
  [716] = {.lex_state = 194, .external_lex_state = 2},
  [717] = {.lex_state = 200, .external_lex_state = 2},
  [718] = {.lex_state = 200, .external_lex_state = 2},
  [719] = {.lex_state = 200, .external_lex_state = 2},
  [720] = {.lex_state = 200, .external_lex_state = 2},
  [721] = {.lex_state = 200, .external_lex_state = 2},
  [722] = {.lex_state = 200, .external_lex_state = 2},
  [723] = {.lex_state = 194, .external_lex_state = 2},
  [724] = {.lex_state = 200, .external_lex_state = 2},
  [725] = {.lex_state = 200, .external_lex_state = 2},
  [726] = {.lex_state = 194, .external_lex_state = 2},
  [727] = {.lex_state = 200, .external_lex_state = 2},
  [728] = {.lex_state = 200, .external_lex_state = 2},
  [729] = {.lex_state = 194, .external_lex_state = 2},
  [730] = {.lex_state = 200, .external_lex_state = 2},
  [731] = {.lex_state = 200, .external_lex_state = 2},
  [732] = {.lex_state = 194, .external_lex_state = 2},
  [733] = {.lex_state = 200, .external_lex_state = 2},
  [734] = {.lex_state = 200, .external_lex_state = 2},
  [735] = {.lex_state = 200, .external_lex_state = 2},
  [736] = {.lex_state = 200, .external_lex_state = 2},
  [737] = {.lex_state = 194, .external_lex_state = 2},
  [738] = {.lex_state = 200, .external_lex_state = 2},
  [739] = {.lex_state = 200, .external_lex_state = 2},
  [740] = {.lex_state = 194, .external_lex_state = 2},
  [741] = {.lex_state = 200, .external_lex_state = 2},
  [742] = {.lex_state = 200, .external_lex_state = 2},
  [743] = {.lex_state = 200, .external_lex_state = 2},
  [744] = {.lex_state = 194, .external_lex_state = 2},
  [745] = {.lex_state = 194, .external_lex_state = 2},
  [746] = {.lex_state = 200, .external_lex_state = 2},
  [747] = {.lex_state = 200, .external_lex_state = 2},
  [748] = {.lex_state = 200, .external_lex_state = 2},
  [749] = {.lex_state = 200, .external_lex_state = 2},
  [750] = {.lex_state = 200, .external_lex_state = 2},
  [751] = {.lex_state = 200, .external_lex_state = 2},
  [752] = {.lex_state = 194, .external_lex_state = 2},
  [753] = {.lex_state = 200, .external_lex_state = 2},
  [754] = {.lex_state = 200, .external_lex_state = 2},
  [755] = {.lex_state = 200, .external_lex_state = 2},
  [756] = {.lex_state = 200, .external_lex_state = 2},
  [757] = {.lex_state = 200, .external_lex_state = 2},
  [758] = {.lex_state = 194, .external_lex_state = 2},
  [759] = {.lex_state = 200, .external_lex_state = 2},
  [760] = {.lex_state = 194, .external_lex_state = 2},
  [761] = {.lex_state = 194, .external_lex_state = 2},
  [762] = {.lex_state = 200, .external_lex_state = 2},
  [763] = {.lex_state = 349, .external_lex_state = 2},
  [764] = {.lex_state = 194, .external_lex_state = 2},
  [765] = {.lex_state = 194, .external_lex_state = 2},
  [766] = {.lex_state = 200, .external_lex_state = 2},
  [767] = {.lex_state = 194, .external_lex_state = 2},
  [768] = {.lex_state = 194, .external_lex_state = 2},
  [769] = {.lex_state = 194, .external_lex_state = 2},
  [770] = {.lex_state = 194, .external_lex_state = 2},
  [771] = {.lex_state = 194, .external_lex_state = 2},
  [772] = {.lex_state = 194, .external_lex_state = 2},
  [773] = {.lex_state = 200, .external_lex_state = 2},
  [774] = {.lex_state = 200, .external_lex_state = 2},
  [775] = {.lex_state = 194, .external_lex_state = 2},
  [776] = {.lex_state = 194, .external_lex_state = 2},
  [777] = {.lex_state = 200, .external_lex_state = 2},
  [778] = {.lex_state = 194, .external_lex_state = 2},
  [779] = {.lex_state = 194, .external_lex_state = 2},
  [780] = {.lex_state = 200, .external_lex_state = 2},
  [781] = {.lex_state = 194, .external_lex_state = 2},
  [782] = {.lex_state = 200, .external_lex_state = 2},
  [783] = {.lex_state = 556, .external_lex_state = 2},
  [784] = {.lex_state = 200, .external_lex_state = 2},
  [785] = {.lex_state = 556, .external_lex_state = 2},
  [786] = {.lex_state = 200, .external_lex_state = 2},
  [787] = {.lex_state = 200, .external_lex_state = 2},
  [788] = {.lex_state = 556, .external_lex_state = 2},
  [789] = {.lex_state = 200, .external_lex_state = 2},
  [790] = {.lex_state = 556, .external_lex_state = 2},
  [791] = {.lex_state = 556, .external_lex_state = 2},
  [792] = {.lex_state = 556, .external_lex_state = 2},
  [793] = {.lex_state = 556, .external_lex_state = 2},
  [794] = {.lex_state = 200, .external_lex_state = 2},
  [795] = {.lex_state = 556, .external_lex_state = 2},
  [796] = {.lex_state = 200, .external_lex_state = 2},
  [797] = {.lex_state = 556, .external_lex_state = 2},
  [798] = {.lex_state = 556, .external_lex_state = 2},
  [799] = {.lex_state = 200, .external_lex_state = 2},
  [800] = {.lex_state = 556, .external_lex_state = 2},
  [801] = {.lex_state = 200, .external_lex_state = 2},
  [802] = {.lex_state = 556, .external_lex_state = 2},
  [803] = {.lex_state = 200, .external_lex_state = 2},
  [804] = {.lex_state = 200, .external_lex_state = 2},
  [805] = {.lex_state = 556, .external_lex_state = 2},
  [806] = {.lex_state = 200, .external_lex_state = 2},
  [807] = {.lex_state = 556, .external_lex_state = 2},
  [808] = {.lex_state = 556, .external_lex_state = 2},
  [809] = {.lex_state = 200, .external_lex_state = 2},
  [810] = {.lex_state = 556, .external_lex_state = 2},
  [811] = {.lex_state = 556, .external_lex_state = 2},
  [812] = {.lex_state = 556, .external_lex_state = 2},
  [813] = {.lex_state = 200, .external_lex_state = 2},
  [814] = {.lex_state = 200, .external_lex_state = 2},
  [815] = {.lex_state = 556, .external_lex_state = 2},
  [816] = {.lex_state = 556, .external_lex_state = 2},
  [817] = {.lex_state = 200, .external_lex_state = 2},
  [818] = {.lex_state = 556, .external_lex_state = 2},
  [819] = {.lex_state = 200, .external_lex_state = 2},
  [820] = {.lex_state = 556, .external_lex_state = 2},
  [821] = {.lex_state = 556, .external_lex_state = 2},
  [822] = {.lex_state = 200, .external_lex_state = 2},
  [823] = {.lex_state = 556, .external_lex_state = 2},
  [824] = {.lex_state = 200, .external_lex_state = 2},
  [825] = {.lex_state = 556, .external_lex_state = 2},
  [826] = {.lex_state = 556, .external_lex_state = 2},
  [827] = {.lex_state = 347, .external_lex_state = 2},
  [828] = {.lex_state = 200, .external_lex_state = 2},
  [829] = {.lex_state = 200, .external_lex_state = 2},
  [830] = {.lex_state = 556, .external_lex_state = 2},
  [831] = {.lex_state = 200, .external_lex_state = 2},
  [832] = {.lex_state = 200, .external_lex_state = 2},
  [833] = {.lex_state = 556, .external_lex_state = 2},
  [834] = {.lex_state = 200, .external_lex_state = 2},
  [835] = {.lex_state = 556, .external_lex_state = 2},
  [836] = {.lex_state = 556, .external_lex_state = 2},
  [837] = {.lex_state = 556, .external_lex_state = 2},
  [838] = {.lex_state = 344, .external_lex_state = 2},
  [839] = {.lex_state = 200, .external_lex_state = 2},
  [840] = {.lex_state = 556, .external_lex_state = 2},
  [841] = {.lex_state = 556, .external_lex_state = 2},
  [842] = {.lex_state = 200, .external_lex_state = 2},
  [843] = {.lex_state = 556, .external_lex_state = 2},
  [844] = {.lex_state = 200, .external_lex_state = 2},
  [845] = {.lex_state = 556, .external_lex_state = 2},
  [846] = {.lex_state = 556, .external_lex_state = 2},
  [847] = {.lex_state = 556, .external_lex_state = 2},
  [848] = {.lex_state = 200, .external_lex_state = 2},
  [849] = {.lex_state = 200, .external_lex_state = 2},
  [850] = {.lex_state = 556, .external_lex_state = 2},
  [851] = {.lex_state = 556, .external_lex_state = 2},
  [852] = {.lex_state = 200, .external_lex_state = 2},
  [853] = {.lex_state = 556, .external_lex_state = 2},
  [854] = {.lex_state = 200, .external_lex_state = 2},
  [855] = {.lex_state = 556, .external_lex_state = 2},
  [856] = {.lex_state = 200, .external_lex_state = 2},
  [857] = {.lex_state = 556, .external_lex_state = 2},
  [858] = {.lex_state = 200, .external_lex_state = 2},
  [859] = {.lex_state = 200, .external_lex_state = 2},
  [860] = {.lex_state = 556, .external_lex_state = 2},
  [861] = {.lex_state = 200, .external_lex_state = 2},
  [862] = {.lex_state = 556, .external_lex_state = 2},
  [863] = {.lex_state = 556, .external_lex_state = 2},
  [864] = {.lex_state = 200, .external_lex_state = 2},
  [865] = {.lex_state = 556, .external_lex_state = 2},
  [866] = {.lex_state = 556, .external_lex_state = 2},
  [867] = {.lex_state = 200, .external_lex_state = 2},
  [868] = {.lex_state = 200, .external_lex_state = 2},
  [869] = {.lex_state = 556, .external_lex_state = 2},
  [870] = {.lex_state = 556, .external_lex_state = 2},
  [871] = {.lex_state = 556, .external_lex_state = 2},
  [872] = {.lex_state = 556, .external_lex_state = 2},
  [873] = {.lex_state = 556, .external_lex_state = 2},
  [874] = {.lex_state = 200, .external_lex_state = 2},
  [875] = {.lex_state = 556, .external_lex_state = 2},
  [876] = {.lex_state = 556, .external_lex_state = 2},
  [877] = {.lex_state = 556, .external_lex_state = 2},
  [878] = {.lex_state = 200, .external_lex_state = 2},
  [879] = {.lex_state = 200, .external_lex_state = 2},
  [880] = {.lex_state = 556, .external_lex_state = 2},
  [881] = {.lex_state = 556, .external_lex_state = 2},
  [882] = {.lex_state = 349, .external_lex_state = 2},
  [883] = {.lex_state = 556, .external_lex_state = 2},
  [884] = {.lex_state = 200, .external_lex_state = 2},
  [885] = {.lex_state = 556, .external_lex_state = 2},
  [886] = {.lex_state = 200, .external_lex_state = 2},
  [887] = {.lex_state = 200, .external_lex_state = 2},
  [888] = {.lex_state = 200, .external_lex_state = 2},
  [889] = {.lex_state = 200, .external_lex_state = 2},
  [890] = {.lex_state = 556, .external_lex_state = 2},
  [891] = {.lex_state = 556, .external_lex_state = 2},
  [892] = {.lex_state = 556, .external_lex_state = 2},
  [893] = {.lex_state = 556, .external_lex_state = 2},
  [894] = {.lex_state = 200, .external_lex_state = 2},
  [895] = {.lex_state = 556, .external_lex_state = 2},
  [896] = {.lex_state = 200, .external_lex_state = 2},
  [897] = {.lex_state = 200, .external_lex_state = 2},
  [898] = {.lex_state = 200, .external_lex_state = 2},
  [899] = {.lex_state = 556, .external_lex_state = 2},
  [900] = {.lex_state = 556, .external_lex_state = 2},
  [901] = {.lex_state = 556, .external_lex_state = 2},
  [902] = {.lex_state = 200, .external_lex_state = 2},
  [903] = {.lex_state = 556, .external_lex_state = 2},
  [904] = {.lex_state = 200, .external_lex_state = 2},
  [905] = {.lex_state = 556, .external_lex_state = 2},
  [906] = {.lex_state = 200, .external_lex_state = 2},
  [907] = {.lex_state = 200, .external_lex_state = 2},
  [908] = {.lex_state = 556, .external_lex_state = 2},
  [909] = {.lex_state = 556, .external_lex_state = 2},
  [910] = {.lex_state = 200, .external_lex_state = 2},
  [911] = {.lex_state = 200, .external_lex_state = 2},
  [912] = {.lex_state = 556, .external_lex_state = 2},
  [913] = {.lex_state = 200, .external_lex_state = 2},
  [914] = {.lex_state = 200, .external_lex_state = 2},
  [915] = {.lex_state = 556, .external_lex_state = 2},
  [916] = {.lex_state = 200, .external_lex_state = 2},
  [917] = {.lex_state = 556, .external_lex_state = 2},
  [918] = {.lex_state = 200, .external_lex_state = 2},
  [919] = {.lex_state = 556, .external_lex_state = 2},
  [920] = {.lex_state = 200, .external_lex_state = 2},
  [921] = {.lex_state = 556, .external_lex_state = 2},
  [922] = {.lex_state = 556, .external_lex_state = 2},
  [923] = {.lex_state = 200, .external_lex_state = 2},
  [924] = {.lex_state = 556, .external_lex_state = 2},
  [925] = {.lex_state = 556, .external_lex_state = 2},
  [926] = {.lex_state = 556, .external_lex_state = 2},
  [927] = {.lex_state = 200, .external_lex_state = 2},
  [928] = {.lex_state = 346, .external_lex_state = 2},
  [929] = {.lex_state = 200, .external_lex_state = 2},
  [930] = {.lex_state = 556, .external_lex_state = 2},
  [931] = {.lex_state = 556, .external_lex_state = 2},
  [932] = {.lex_state = 200, .external_lex_state = 2},
  [933] = {.lex_state = 349, .external_lex_state = 2},
  [934] = {.lex_state = 200, .external_lex_state = 2},
  [935] = {.lex_state = 346, .external_lex_state = 2},
  [936] = {.lex_state = 556, .external_lex_state = 2},
  [937] = {.lex_state = 200, .external_lex_state = 2},
  [938] = {.lex_state = 200, .external_lex_state = 2},
  [939] = {.lex_state = 200, .external_lex_state = 2},
  [940] = {.lex_state = 200, .external_lex_state = 2},
  [941] = {.lex_state = 200, .external_lex_state = 2},
  [942] = {.lex_state = 556, .external_lex_state = 2},
  [943] = {.lex_state = 200, .external_lex_state = 2},
  [944] = {.lex_state = 556, .external_lex_state = 2},
  [945] = {.lex_state = 348, .external_lex_state = 2},
  [946] = {.lex_state = 348, .external_lex_state = 2},
  [947] = {.lex_state = 348, .external_lex_state = 2},
  [948] = {.lex_state = 348, .external_lex_state = 2},
  [949] = {.lex_state = 348, .external_lex_state = 2},
  [950] = {.lex_state = 348, .external_lex_state = 2},
  [951] = {.lex_state = 348, .external_lex_state = 2},
  [952] = {.lex_state = 348, .external_lex_state = 2},
  [953] = {.lex_state = 348, .external_lex_state = 2},
  [954] = {.lex_state = 348, .external_lex_state = 2},
  [955] = {.lex_state = 348, .external_lex_state = 2},
  [956] = {.lex_state = 556, .external_lex_state = 2},
  [957] = {.lex_state = 348, .external_lex_state = 2},
  [958] = {.lex_state = 348, .external_lex_state = 2},
  [959] = {.lex_state = 556, .external_lex_state = 2},
  [960] = {.lex_state = 348, .external_lex_state = 2},
  [961] = {.lex_state = 348, .external_lex_state = 2},
  [962] = {.lex_state = 348, .external_lex_state = 2},
  [963] = {.lex_state = 348, .external_lex_state = 2},
  [964] = {.lex_state = 348, .external_lex_state = 2},
  [965] = {.lex_state = 348, .external_lex_state = 2},
  [966] = {.lex_state = 348, .external_lex_state = 2},
  [967] = {.lex_state = 348, .external_lex_state = 2},
  [968] = {.lex_state = 348, .external_lex_state = 2},
  [969] = {.lex_state = 348, .external_lex_state = 2},
  [970] = {.lex_state = 348, .external_lex_state = 2},
  [971] = {.lex_state = 556, .external_lex_state = 2},
  [972] = {.lex_state = 556, .external_lex_state = 2},
  [973] = {.lex_state = 348, .external_lex_state = 2},
  [974] = {.lex_state = 348, .external_lex_state = 2},
  [975] = {.lex_state = 348, .external_lex_state = 2},
  [976] = {.lex_state = 348, .external_lex_state = 2},
  [977] = {.lex_state = 348, .external_lex_state = 2},
  [978] = {.lex_state = 348, .external_lex_state = 2},
  [979] = {.lex_state = 348, .external_lex_state = 2},
  [980] = {.lex_state = 348, .external_lex_state = 2},
  [981] = {.lex_state = 348, .external_lex_state = 2},
  [982] = {.lex_state = 348, .external_lex_state = 2},
  [983] = {.lex_state = 348, .external_lex_state = 2},
  [984] = {.lex_state = 348, .external_lex_state = 2},
  [985] = {.lex_state = 348, .external_lex_state = 2},
  [986] = {.lex_state = 556, .external_lex_state = 2},
  [987] = {.lex_state = 348, .external_lex_state = 2},
  [988] = {.lex_state = 348, .external_lex_state = 2},
  [989] = {.lex_state = 348, .external_lex_state = 2},
  [990] = {.lex_state = 556, .external_lex_state = 2},
  [991] = {.lex_state = 556, .external_lex_state = 2},
  [992] = {.lex_state = 348, .external_lex_state = 2},
  [993] = {.lex_state = 348, .external_lex_state = 2},
  [994] = {.lex_state = 556, .external_lex_state = 2},
  [995] = {.lex_state = 348, .external_lex_state = 2},
  [996] = {.lex_state = 556, .external_lex_state = 2},
  [997] = {.lex_state = 348, .external_lex_state = 2},
  [998] = {.lex_state = 348, .external_lex_state = 2},
  [999] = {.lex_state = 348, .external_lex_state = 2},
  [1000] = {.lex_state = 348, .external_lex_state = 2},
  [1001] = {.lex_state = 348, .external_lex_state = 2},
  [1002] = {.lex_state = 348, .external_lex_state = 2},
  [1003] = {.lex_state = 348, .external_lex_state = 2},
  [1004] = {.lex_state = 348, .external_lex_state = 2},
  [1005] = {.lex_state = 348, .external_lex_state = 2},
  [1006] = {.lex_state = 556, .external_lex_state = 2},
  [1007] = {.lex_state = 348, .external_lex_state = 2},
  [1008] = {.lex_state = 348, .external_lex_state = 2},
  [1009] = {.lex_state = 348, .external_lex_state = 2},
  [1010] = {.lex_state = 348, .external_lex_state = 2},
  [1011] = {.lex_state = 348, .external_lex_state = 2},
  [1012] = {.lex_state = 348, .external_lex_state = 2},
  [1013] = {.lex_state = 348, .external_lex_state = 2},
  [1014] = {.lex_state = 348, .external_lex_state = 2},
  [1015] = {.lex_state = 348, .external_lex_state = 2},
  [1016] = {.lex_state = 348, .external_lex_state = 2},
  [1017] = {.lex_state = 348, .external_lex_state = 2},
  [1018] = {.lex_state = 348, .external_lex_state = 2},
  [1019] = {.lex_state = 348, .external_lex_state = 2},
  [1020] = {.lex_state = 556, .external_lex_state = 2},
  [1021] = {.lex_state = 348, .external_lex_state = 2},
  [1022] = {.lex_state = 348, .external_lex_state = 2},
  [1023] = {.lex_state = 344, .external_lex_state = 2},
  [1024] = {.lex_state = 348, .external_lex_state = 2},
  [1025] = {.lex_state = 348, .external_lex_state = 2},
  [1026] = {.lex_state = 348, .external_lex_state = 2},
  [1027] = {.lex_state = 348, .external_lex_state = 2},
  [1028] = {.lex_state = 556, .external_lex_state = 2},
  [1029] = {.lex_state = 556, .external_lex_state = 2},
  [1030] = {.lex_state = 348, .external_lex_state = 2},
  [1031] = {.lex_state = 556, .external_lex_state = 2},
  [1032] = {.lex_state = 348, .external_lex_state = 2},
  [1033] = {.lex_state = 556, .external_lex_state = 2},
  [1034] = {.lex_state = 556, .external_lex_state = 2},
  [1035] = {.lex_state = 348, .external_lex_state = 2},
  [1036] = {.lex_state = 348, .external_lex_state = 2},
  [1037] = {.lex_state = 348, .external_lex_state = 2},
  [1038] = {.lex_state = 556, .external_lex_state = 2},
  [1039] = {.lex_state = 556, .external_lex_state = 2},
  [1040] = {.lex_state = 344, .external_lex_state = 2},
  [1041] = {.lex_state = 556, .external_lex_state = 2},
  [1042] = {.lex_state = 348, .external_lex_state = 2},
  [1043] = {.lex_state = 348, .external_lex_state = 2},
  [1044] = {.lex_state = 556, .external_lex_state = 2},
  [1045] = {.lex_state = 348, .external_lex_state = 2},
  [1046] = {.lex_state = 348, .external_lex_state = 2},
  [1047] = {.lex_state = 556, .external_lex_state = 2},
  [1048] = {.lex_state = 348, .external_lex_state = 2},
  [1049] = {.lex_state = 556, .external_lex_state = 2},
  [1050] = {.lex_state = 556, .external_lex_state = 2},
  [1051] = {.lex_state = 348, .external_lex_state = 2},
  [1052] = {.lex_state = 556, .external_lex_state = 2},
  [1053] = {.lex_state = 348, .external_lex_state = 2},
  [1054] = {.lex_state = 556, .external_lex_state = 2},
  [1055] = {.lex_state = 348, .external_lex_state = 2},
  [1056] = {.lex_state = 556, .external_lex_state = 2},
  [1057] = {.lex_state = 348, .external_lex_state = 2},
  [1058] = {.lex_state = 348, .external_lex_state = 2},
  [1059] = {.lex_state = 556, .external_lex_state = 2},
  [1060] = {.lex_state = 348, .external_lex_state = 2},
  [1061] = {.lex_state = 556, .external_lex_state = 2},
  [1062] = {.lex_state = 556, .external_lex_state = 2},
  [1063] = {.lex_state = 348, .external_lex_state = 2},
  [1064] = {.lex_state = 348, .external_lex_state = 2},
  [1065] = {.lex_state = 556, .external_lex_state = 2},
  [1066] = {.lex_state = 348, .external_lex_state = 2},
  [1067] = {.lex_state = 348, .external_lex_state = 2},
  [1068] = {.lex_state = 556, .external_lex_state = 2},
  [1069] = {.lex_state = 348, .external_lex_state = 2},
  [1070] = {.lex_state = 348, .external_lex_state = 2},
  [1071] = {.lex_state = 556, .external_lex_state = 2},
  [1072] = {.lex_state = 348, .external_lex_state = 2},
  [1073] = {.lex_state = 348, .external_lex_state = 2},
  [1074] = {.lex_state = 556, .external_lex_state = 2},
  [1075] = {.lex_state = 348, .external_lex_state = 2},
  [1076] = {.lex_state = 348, .external_lex_state = 2},
  [1077] = {.lex_state = 556, .external_lex_state = 2},
  [1078] = {.lex_state = 348, .external_lex_state = 2},
  [1079] = {.lex_state = 348, .external_lex_state = 2},
  [1080] = {.lex_state = 556, .external_lex_state = 2},
  [1081] = {.lex_state = 556, .external_lex_state = 2},
  [1082] = {.lex_state = 556, .external_lex_state = 2},
  [1083] = {.lex_state = 348, .external_lex_state = 2},
  [1084] = {.lex_state = 556, .external_lex_state = 2},
  [1085] = {.lex_state = 348, .external_lex_state = 2},
  [1086] = {.lex_state = 348, .external_lex_state = 2},
  [1087] = {.lex_state = 556, .external_lex_state = 2},
  [1088] = {.lex_state = 556, .external_lex_state = 2},
  [1089] = {.lex_state = 347, .external_lex_state = 2},
  [1090] = {.lex_state = 348, .external_lex_state = 2},
  [1091] = {.lex_state = 556, .external_lex_state = 2},
  [1092] = {.lex_state = 348, .external_lex_state = 2},
  [1093] = {.lex_state = 348, .external_lex_state = 2},
  [1094] = {.lex_state = 556, .external_lex_state = 2},
  [1095] = {.lex_state = 348, .external_lex_state = 2},
  [1096] = {.lex_state = 348, .external_lex_state = 2},
  [1097] = {.lex_state = 556, .external_lex_state = 2},
  [1098] = {.lex_state = 348, .external_lex_state = 2},
  [1099] = {.lex_state = 556, .external_lex_state = 2},
  [1100] = {.lex_state = 556, .external_lex_state = 2},
  [1101] = {.lex_state = 348, .external_lex_state = 2},
  [1102] = {.lex_state = 556, .external_lex_state = 2},
  [1103] = {.lex_state = 556, .external_lex_state = 2},
  [1104] = {.lex_state = 348, .external_lex_state = 2},
  [1105] = {.lex_state = 556, .external_lex_state = 2},
  [1106] = {.lex_state = 556, .external_lex_state = 2},
  [1107] = {.lex_state = 348, .external_lex_state = 2},
  [1108] = {.lex_state = 556, .external_lex_state = 2},
  [1109] = {.lex_state = 348, .external_lex_state = 2},
  [1110] = {.lex_state = 348, .external_lex_state = 2},
  [1111] = {.lex_state = 556, .external_lex_state = 2},
  [1112] = {.lex_state = 348, .external_lex_state = 2},
  [1113] = {.lex_state = 348, .external_lex_state = 2},
  [1114] = {.lex_state = 556, .external_lex_state = 2},
  [1115] = {.lex_state = 348, .external_lex_state = 2},
  [1116] = {.lex_state = 348, .external_lex_state = 2},
  [1117] = {.lex_state = 556, .external_lex_state = 2},
  [1118] = {.lex_state = 348, .external_lex_state = 2},
  [1119] = {.lex_state = 348, .external_lex_state = 2},
  [1120] = {.lex_state = 556, .external_lex_state = 2},
  [1121] = {.lex_state = 348, .external_lex_state = 2},
  [1122] = {.lex_state = 348, .external_lex_state = 2},
  [1123] = {.lex_state = 556, .external_lex_state = 2},
  [1124] = {.lex_state = 348, .external_lex_state = 2},
  [1125] = {.lex_state = 556, .external_lex_state = 2},
  [1126] = {.lex_state = 348, .external_lex_state = 2},
  [1127] = {.lex_state = 348, .external_lex_state = 2},
  [1128] = {.lex_state = 556, .external_lex_state = 2},
  [1129] = {.lex_state = 556, .external_lex_state = 2},
  [1130] = {.lex_state = 348, .external_lex_state = 2},
  [1131] = {.lex_state = 556, .external_lex_state = 2},
  [1132] = {.lex_state = 347, .external_lex_state = 2},
  [1133] = {.lex_state = 556, .external_lex_state = 2},
  [1134] = {.lex_state = 556, .external_lex_state = 2},
  [1135] = {.lex_state = 348, .external_lex_state = 2},
  [1136] = {.lex_state = 348, .external_lex_state = 2},
  [1137] = {.lex_state = 556, .external_lex_state = 2},
  [1138] = {.lex_state = 348, .external_lex_state = 2},
  [1139] = {.lex_state = 348, .external_lex_state = 2},
  [1140] = {.lex_state = 556, .external_lex_state = 2},
  [1141] = {.lex_state = 348, .external_lex_state = 2},
  [1142] = {.lex_state = 556, .external_lex_state = 2},
  [1143] = {.lex_state = 348, .external_lex_state = 2},
  [1144] = {.lex_state = 556, .external_lex_state = 2},
  [1145] = {.lex_state = 556, .external_lex_state = 2},
  [1146] = {.lex_state = 348, .external_lex_state = 2},
  [1147] = {.lex_state = 556, .external_lex_state = 2},
  [1148] = {.lex_state = 348, .external_lex_state = 2},
  [1149] = {.lex_state = 348, .external_lex_state = 2},
  [1150] = {.lex_state = 556, .external_lex_state = 2},
  [1151] = {.lex_state = 348, .external_lex_state = 2},
  [1152] = {.lex_state = 348, .external_lex_state = 2},
  [1153] = {.lex_state = 556, .external_lex_state = 2},
  [1154] = {.lex_state = 348, .external_lex_state = 2},
  [1155] = {.lex_state = 556, .external_lex_state = 2},
  [1156] = {.lex_state = 556, .external_lex_state = 2},
  [1157] = {.lex_state = 348, .external_lex_state = 2},
  [1158] = {.lex_state = 348, .external_lex_state = 2},
  [1159] = {.lex_state = 556, .external_lex_state = 2},
  [1160] = {.lex_state = 348, .external_lex_state = 2},
  [1161] = {.lex_state = 348, .external_lex_state = 2},
  [1162] = {.lex_state = 556, .external_lex_state = 2},
  [1163] = {.lex_state = 348, .external_lex_state = 2},
  [1164] = {.lex_state = 348, .external_lex_state = 2},
  [1165] = {.lex_state = 556, .external_lex_state = 2},
  [1166] = {.lex_state = 348, .external_lex_state = 2},
  [1167] = {.lex_state = 556, .external_lex_state = 2},
  [1168] = {.lex_state = 348, .external_lex_state = 2},
  [1169] = {.lex_state = 348, .external_lex_state = 2},
  [1170] = {.lex_state = 556, .external_lex_state = 2},
  [1171] = {.lex_state = 348, .external_lex_state = 2},
  [1172] = {.lex_state = 348, .external_lex_state = 2},
  [1173] = {.lex_state = 556, .external_lex_state = 2},
  [1174] = {.lex_state = 348, .external_lex_state = 2},
  [1175] = {.lex_state = 556, .external_lex_state = 2},
  [1176] = {.lex_state = 348, .external_lex_state = 2},
  [1177] = {.lex_state = 556, .external_lex_state = 2},
  [1178] = {.lex_state = 348, .external_lex_state = 2},
  [1179] = {.lex_state = 348, .external_lex_state = 2},
  [1180] = {.lex_state = 556, .external_lex_state = 2},
  [1181] = {.lex_state = 348, .external_lex_state = 2},
  [1182] = {.lex_state = 348, .external_lex_state = 2},
  [1183] = {.lex_state = 556, .external_lex_state = 2},
  [1184] = {.lex_state = 348, .external_lex_state = 2},
  [1185] = {.lex_state = 348, .external_lex_state = 2},
  [1186] = {.lex_state = 556, .external_lex_state = 2},
  [1187] = {.lex_state = 348, .external_lex_state = 2},
  [1188] = {.lex_state = 556, .external_lex_state = 2},
  [1189] = {.lex_state = 556, .external_lex_state = 2},
  [1190] = {.lex_state = 556, .external_lex_state = 2},
  [1191] = {.lex_state = 556, .external_lex_state = 2},
  [1192] = {.lex_state = 348, .external_lex_state = 2},
  [1193] = {.lex_state = 556, .external_lex_state = 2},
  [1194] = {.lex_state = 556, .external_lex_state = 2},
  [1195] = {.lex_state = 348, .external_lex_state = 2},
  [1196] = {.lex_state = 348, .external_lex_state = 2},
  [1197] = {.lex_state = 556, .external_lex_state = 2},
  [1198] = {.lex_state = 348, .external_lex_state = 2},
  [1199] = {.lex_state = 348, .external_lex_state = 2},
  [1200] = {.lex_state = 556, .external_lex_state = 2},
  [1201] = {.lex_state = 348, .external_lex_state = 2},
  [1202] = {.lex_state = 348, .external_lex_state = 2},
  [1203] = {.lex_state = 556, .external_lex_state = 2},
  [1204] = {.lex_state = 348, .external_lex_state = 2},
  [1205] = {.lex_state = 348, .external_lex_state = 2},
  [1206] = {.lex_state = 556, .external_lex_state = 2},
  [1207] = {.lex_state = 348, .external_lex_state = 2},
  [1208] = {.lex_state = 348, .external_lex_state = 2},
  [1209] = {.lex_state = 556, .external_lex_state = 2},
  [1210] = {.lex_state = 348, .external_lex_state = 2},
  [1211] = {.lex_state = 556, .external_lex_state = 2},
  [1212] = {.lex_state = 556, .external_lex_state = 2},
  [1213] = {.lex_state = 348, .external_lex_state = 2},
  [1214] = {.lex_state = 348, .external_lex_state = 2},
  [1215] = {.lex_state = 556, .external_lex_state = 2},
  [1216] = {.lex_state = 348, .external_lex_state = 2},
  [1217] = {.lex_state = 556, .external_lex_state = 2},
  [1218] = {.lex_state = 348, .external_lex_state = 2},
  [1219] = {.lex_state = 348, .external_lex_state = 2},
  [1220] = {.lex_state = 556, .external_lex_state = 2},
  [1221] = {.lex_state = 556, .external_lex_state = 2},
  [1222] = {.lex_state = 348, .external_lex_state = 2},
  [1223] = {.lex_state = 556, .external_lex_state = 2},
  [1224] = {.lex_state = 348, .external_lex_state = 2},
  [1225] = {.lex_state = 348, .external_lex_state = 2},
  [1226] = {.lex_state = 556, .external_lex_state = 2},
  [1227] = {.lex_state = 348, .external_lex_state = 2},
  [1228] = {.lex_state = 348, .external_lex_state = 2},
  [1229] = {.lex_state = 556, .external_lex_state = 2},
  [1230] = {.lex_state = 348, .external_lex_state = 2},
  [1231] = {.lex_state = 348, .external_lex_state = 2},
  [1232] = {.lex_state = 556, .external_lex_state = 2},
  [1233] = {.lex_state = 348, .external_lex_state = 2},
  [1234] = {.lex_state = 556, .external_lex_state = 2},
  [1235] = {.lex_state = 348, .external_lex_state = 2},
  [1236] = {.lex_state = 556, .external_lex_state = 2},
  [1237] = {.lex_state = 556, .external_lex_state = 2},
  [1238] = {.lex_state = 345, .external_lex_state = 2},
  [1239] = {.lex_state = 348, .external_lex_state = 2},
  [1240] = {.lex_state = 556, .external_lex_state = 2},
  [1241] = {.lex_state = 348, .external_lex_state = 2},
  [1242] = {.lex_state = 348, .external_lex_state = 2},
  [1243] = {.lex_state = 556, .external_lex_state = 2},
  [1244] = {.lex_state = 556, .external_lex_state = 2},
  [1245] = {.lex_state = 556, .external_lex_state = 2},
  [1246] = {.lex_state = 348, .external_lex_state = 2},
  [1247] = {.lex_state = 348, .external_lex_state = 2},
  [1248] = {.lex_state = 556, .external_lex_state = 2},
  [1249] = {.lex_state = 348, .external_lex_state = 2},
  [1250] = {.lex_state = 556, .external_lex_state = 2},
  [1251] = {.lex_state = 556, .external_lex_state = 2},
  [1252] = {.lex_state = 348, .external_lex_state = 2},
  [1253] = {.lex_state = 348, .external_lex_state = 2},
  [1254] = {.lex_state = 556, .external_lex_state = 2},
  [1255] = {.lex_state = 348, .external_lex_state = 2},
  [1256] = {.lex_state = 348, .external_lex_state = 2},
  [1257] = {.lex_state = 556, .external_lex_state = 2},
  [1258] = {.lex_state = 348, .external_lex_state = 2},
  [1259] = {.lex_state = 345, .external_lex_state = 2},
  [1260] = {.lex_state = 556, .external_lex_state = 2},
  [1261] = {.lex_state = 556, .external_lex_state = 2},
  [1262] = {.lex_state = 348, .external_lex_state = 2},
  [1263] = {.lex_state = 556, .external_lex_state = 2},
  [1264] = {.lex_state = 348, .external_lex_state = 2},
  [1265] = {.lex_state = 556, .external_lex_state = 2},
  [1266] = {.lex_state = 348, .external_lex_state = 2},
  [1267] = {.lex_state = 348, .external_lex_state = 2},
  [1268] = {.lex_state = 556, .external_lex_state = 2},
  [1269] = {.lex_state = 200, .external_lex_state = 2},
  [1270] = {.lex_state = 348, .external_lex_state = 2},
  [1271] = {.lex_state = 556, .external_lex_state = 2},
  [1272] = {.lex_state = 348, .external_lex_state = 2},
  [1273] = {.lex_state = 348, .external_lex_state = 2},
  [1274] = {.lex_state = 556, .external_lex_state = 2},
  [1275] = {.lex_state = 348, .external_lex_state = 2},
  [1276] = {.lex_state = 348, .external_lex_state = 2},
  [1277] = {.lex_state = 556, .external_lex_state = 2},
  [1278] = {.lex_state = 348, .external_lex_state = 2},
  [1279] = {.lex_state = 348, .external_lex_state = 2},
  [1280] = {.lex_state = 348, .external_lex_state = 2},
  [1281] = {.lex_state = 556, .external_lex_state = 2},
  [1282] = {.lex_state = 556, .external_lex_state = 2},
  [1283] = {.lex_state = 556, .external_lex_state = 2},
  [1284] = {.lex_state = 556, .external_lex_state = 2},
  [1285] = {.lex_state = 348, .external_lex_state = 2},
  [1286] = {.lex_state = 348, .external_lex_state = 2},
  [1287] = {.lex_state = 348, .external_lex_state = 2},
  [1288] = {.lex_state = 556, .external_lex_state = 2},
  [1289] = {.lex_state = 348, .external_lex_state = 2},
  [1290] = {.lex_state = 556, .external_lex_state = 2},
  [1291] = {.lex_state = 348, .external_lex_state = 2},
  [1292] = {.lex_state = 348, .external_lex_state = 2},
  [1293] = {.lex_state = 348, .external_lex_state = 2},
  [1294] = {.lex_state = 348, .external_lex_state = 2},
  [1295] = {.lex_state = 556, .external_lex_state = 2},
  [1296] = {.lex_state = 556, .external_lex_state = 2},
  [1297] = {.lex_state = 348, .external_lex_state = 2},
  [1298] = {.lex_state = 348, .external_lex_state = 2},
  [1299] = {.lex_state = 348, .external_lex_state = 2},
  [1300] = {.lex_state = 556, .external_lex_state = 2},
  [1301] = {.lex_state = 556, .external_lex_state = 2},
  [1302] = {.lex_state = 556, .external_lex_state = 2},
  [1303] = {.lex_state = 348, .external_lex_state = 2},
  [1304] = {.lex_state = 348, .external_lex_state = 2},
  [1305] = {.lex_state = 556, .external_lex_state = 2},
  [1306] = {.lex_state = 348, .external_lex_state = 2},
  [1307] = {.lex_state = 556, .external_lex_state = 2},
  [1308] = {.lex_state = 348, .external_lex_state = 2},
  [1309] = {.lex_state = 348, .external_lex_state = 2},
  [1310] = {.lex_state = 348, .external_lex_state = 2},
  [1311] = {.lex_state = 556, .external_lex_state = 2},
  [1312] = {.lex_state = 348, .external_lex_state = 2},
  [1313] = {.lex_state = 556, .external_lex_state = 2},
  [1314] = {.lex_state = 348, .external_lex_state = 2},
  [1315] = {.lex_state = 348, .external_lex_state = 2},
  [1316] = {.lex_state = 556, .external_lex_state = 2},
  [1317] = {.lex_state = 348, .external_lex_state = 2},
  [1318] = {.lex_state = 556, .external_lex_state = 2},
  [1319] = {.lex_state = 556, .external_lex_state = 2},
  [1320] = {.lex_state = 348, .external_lex_state = 2},
  [1321] = {.lex_state = 348, .external_lex_state = 2},
  [1322] = {.lex_state = 556, .external_lex_state = 2},
  [1323] = {.lex_state = 348, .external_lex_state = 2},
  [1324] = {.lex_state = 556, .external_lex_state = 2},
  [1325] = {.lex_state = 348, .external_lex_state = 2},
  [1326] = {.lex_state = 348, .external_lex_state = 2},
  [1327] = {.lex_state = 348, .external_lex_state = 2},
  [1328] = {.lex_state = 556, .external_lex_state = 2},
  [1329] = {.lex_state = 348, .external_lex_state = 2},
  [1330] = {.lex_state = 556, .external_lex_state = 2},
  [1331] = {.lex_state = 348, .external_lex_state = 2},
  [1332] = {.lex_state = 556, .external_lex_state = 2},
  [1333] = {.lex_state = 556, .external_lex_state = 2},
  [1334] = {.lex_state = 556, .external_lex_state = 2},
  [1335] = {.lex_state = 556, .external_lex_state = 2},
  [1336] = {.lex_state = 556, .external_lex_state = 2},
  [1337] = {.lex_state = 348, .external_lex_state = 2},
  [1338] = {.lex_state = 348, .external_lex_state = 2},
  [1339] = {.lex_state = 348, .external_lex_state = 2},
  [1340] = {.lex_state = 348, .external_lex_state = 2},
  [1341] = {.lex_state = 556, .external_lex_state = 2},
  [1342] = {.lex_state = 348, .external_lex_state = 2},
  [1343] = {.lex_state = 556, .external_lex_state = 2},
  [1344] = {.lex_state = 556, .external_lex_state = 2},
  [1345] = {.lex_state = 556, .external_lex_state = 2},
  [1346] = {.lex_state = 348, .external_lex_state = 2},
  [1347] = {.lex_state = 556, .external_lex_state = 2},
  [1348] = {.lex_state = 348, .external_lex_state = 2},
  [1349] = {.lex_state = 556, .external_lex_state = 2},
  [1350] = {.lex_state = 348, .external_lex_state = 2},
  [1351] = {.lex_state = 348, .external_lex_state = 2},
  [1352] = {.lex_state = 348, .external_lex_state = 2},
  [1353] = {.lex_state = 348, .external_lex_state = 2},
  [1354] = {.lex_state = 556, .external_lex_state = 2},
  [1355] = {.lex_state = 348, .external_lex_state = 2},
  [1356] = {.lex_state = 556, .external_lex_state = 2},
  [1357] = {.lex_state = 348, .external_lex_state = 2},
  [1358] = {.lex_state = 348, .external_lex_state = 2},
  [1359] = {.lex_state = 348, .external_lex_state = 2},
  [1360] = {.lex_state = 348, .external_lex_state = 2},
  [1361] = {.lex_state = 556, .external_lex_state = 2},
  [1362] = {.lex_state = 348, .external_lex_state = 2},
  [1363] = {.lex_state = 556, .external_lex_state = 2},
  [1364] = {.lex_state = 348, .external_lex_state = 2},
  [1365] = {.lex_state = 348, .external_lex_state = 2},
  [1366] = {.lex_state = 556, .external_lex_state = 2},
  [1367] = {.lex_state = 556, .external_lex_state = 2},
  [1368] = {.lex_state = 348, .external_lex_state = 2},
  [1369] = {.lex_state = 556, .external_lex_state = 2},
  [1370] = {.lex_state = 348, .external_lex_state = 2},
  [1371] = {.lex_state = 348, .external_lex_state = 2},
  [1372] = {.lex_state = 348, .external_lex_state = 2},
  [1373] = {.lex_state = 348, .external_lex_state = 2},
  [1374] = {.lex_state = 556, .external_lex_state = 2},
  [1375] = {.lex_state = 348, .external_lex_state = 2},
  [1376] = {.lex_state = 556, .external_lex_state = 2},
  [1377] = {.lex_state = 348, .external_lex_state = 2},
  [1378] = {.lex_state = 348, .external_lex_state = 2},
  [1379] = {.lex_state = 348, .external_lex_state = 2},
  [1380] = {.lex_state = 556, .external_lex_state = 2},
  [1381] = {.lex_state = 556, .external_lex_state = 2},
  [1382] = {.lex_state = 348, .external_lex_state = 2},
  [1383] = {.lex_state = 348, .external_lex_state = 2},
  [1384] = {.lex_state = 348, .external_lex_state = 2},
  [1385] = {.lex_state = 556, .external_lex_state = 2},
  [1386] = {.lex_state = 556, .external_lex_state = 2},
  [1387] = {.lex_state = 556, .external_lex_state = 2},
  [1388] = {.lex_state = 556, .external_lex_state = 2},
  [1389] = {.lex_state = 348, .external_lex_state = 2},
  [1390] = {.lex_state = 348, .external_lex_state = 2},
  [1391] = {.lex_state = 556, .external_lex_state = 2},
  [1392] = {.lex_state = 348, .external_lex_state = 2},
  [1393] = {.lex_state = 556, .external_lex_state = 2},
  [1394] = {.lex_state = 348, .external_lex_state = 2},
  [1395] = {.lex_state = 556, .external_lex_state = 2},
  [1396] = {.lex_state = 348, .external_lex_state = 2},
  [1397] = {.lex_state = 348, .external_lex_state = 2},
  [1398] = {.lex_state = 348, .external_lex_state = 2},
  [1399] = {.lex_state = 556, .external_lex_state = 2},
  [1400] = {.lex_state = 348, .external_lex_state = 2},
  [1401] = {.lex_state = 556, .external_lex_state = 2},
  [1402] = {.lex_state = 348, .external_lex_state = 2},
  [1403] = {.lex_state = 348, .external_lex_state = 2},
  [1404] = {.lex_state = 348, .external_lex_state = 2},
  [1405] = {.lex_state = 556, .external_lex_state = 2},
  [1406] = {.lex_state = 348, .external_lex_state = 2},
  [1407] = {.lex_state = 556, .external_lex_state = 2},
  [1408] = {.lex_state = 348, .external_lex_state = 2},
  [1409] = {.lex_state = 348, .external_lex_state = 2},
  [1410] = {.lex_state = 348, .external_lex_state = 2},
  [1411] = {.lex_state = 556, .external_lex_state = 2},
  [1412] = {.lex_state = 556, .external_lex_state = 2},
  [1413] = {.lex_state = 556, .external_lex_state = 2},
  [1414] = {.lex_state = 556, .external_lex_state = 2},
  [1415] = {.lex_state = 348, .external_lex_state = 2},
  [1416] = {.lex_state = 348, .external_lex_state = 2},
  [1417] = {.lex_state = 556, .external_lex_state = 2},
  [1418] = {.lex_state = 556, .external_lex_state = 2},
  [1419] = {.lex_state = 348, .external_lex_state = 2},
  [1420] = {.lex_state = 556, .external_lex_state = 2},
  [1421] = {.lex_state = 348, .external_lex_state = 2},
  [1422] = {.lex_state = 348, .external_lex_state = 2},
  [1423] = {.lex_state = 348, .external_lex_state = 2},
  [1424] = {.lex_state = 556, .external_lex_state = 2},
  [1425] = {.lex_state = 348, .external_lex_state = 2},
  [1426] = {.lex_state = 556, .external_lex_state = 2},
  [1427] = {.lex_state = 348, .external_lex_state = 2},
  [1428] = {.lex_state = 348, .external_lex_state = 2},
  [1429] = {.lex_state = 556, .external_lex_state = 2},
  [1430] = {.lex_state = 348, .external_lex_state = 2},
  [1431] = {.lex_state = 348, .external_lex_state = 2},
  [1432] = {.lex_state = 556, .external_lex_state = 2},
  [1433] = {.lex_state = 556, .external_lex_state = 2},
  [1434] = {.lex_state = 556, .external_lex_state = 2},
  [1435] = {.lex_state = 556, .external_lex_state = 2},
  [1436] = {.lex_state = 348, .external_lex_state = 2},
  [1437] = {.lex_state = 556, .external_lex_state = 2},
  [1438] = {.lex_state = 348, .external_lex_state = 2},
  [1439] = {.lex_state = 348, .external_lex_state = 2},
  [1440] = {.lex_state = 348, .external_lex_state = 2},
  [1441] = {.lex_state = 556, .external_lex_state = 2},
  [1442] = {.lex_state = 348, .external_lex_state = 2},
  [1443] = {.lex_state = 348, .external_lex_state = 2},
  [1444] = {.lex_state = 348, .external_lex_state = 2},
  [1445] = {.lex_state = 348, .external_lex_state = 2},
  [1446] = {.lex_state = 556, .external_lex_state = 2},
  [1447] = {.lex_state = 348, .external_lex_state = 2},
  [1448] = {.lex_state = 348, .external_lex_state = 2},
  [1449] = {.lex_state = 348, .external_lex_state = 2},
  [1450] = {.lex_state = 348, .external_lex_state = 2},
  [1451] = {.lex_state = 556, .external_lex_state = 2},
  [1452] = {.lex_state = 348, .external_lex_state = 2},
  [1453] = {.lex_state = 348, .external_lex_state = 2},
  [1454] = {.lex_state = 348, .external_lex_state = 2},
  [1455] = {.lex_state = 348, .external_lex_state = 2},
  [1456] = {.lex_state = 348, .external_lex_state = 2},
  [1457] = {.lex_state = 348, .external_lex_state = 2},
  [1458] = {.lex_state = 348, .external_lex_state = 2},
  [1459] = {.lex_state = 348, .external_lex_state = 2},
  [1460] = {.lex_state = 348, .external_lex_state = 2},
  [1461] = {.lex_state = 348, .external_lex_state = 2},
  [1462] = {.lex_state = 348, .external_lex_state = 2},
  [1463] = {.lex_state = 348, .external_lex_state = 2},
  [1464] = {.lex_state = 348, .external_lex_state = 2},
  [1465] = {.lex_state = 348, .external_lex_state = 2},
  [1466] = {.lex_state = 348, .external_lex_state = 2},
  [1467] = {.lex_state = 556, .external_lex_state = 2},
  [1468] = {.lex_state = 556, .external_lex_state = 2},
  [1469] = {.lex_state = 348, .external_lex_state = 2},
  [1470] = {.lex_state = 556, .external_lex_state = 2},
  [1471] = {.lex_state = 556, .external_lex_state = 2},
  [1472] = {.lex_state = 556, .external_lex_state = 2},
  [1473] = {.lex_state = 556, .external_lex_state = 2},
  [1474] = {.lex_state = 556, .external_lex_state = 2},
  [1475] = {.lex_state = 556, .external_lex_state = 2},
  [1476] = {.lex_state = 556, .external_lex_state = 2},
  [1477] = {.lex_state = 556, .external_lex_state = 2},
  [1478] = {.lex_state = 556, .external_lex_state = 2},
  [1479] = {.lex_state = 556, .external_lex_state = 2},
  [1480] = {.lex_state = 556, .external_lex_state = 2},
  [1481] = {.lex_state = 556, .external_lex_state = 2},
  [1482] = {.lex_state = 556, .external_lex_state = 2},
  [1483] = {.lex_state = 556, .external_lex_state = 2},
  [1484] = {.lex_state = 556, .external_lex_state = 2},
  [1485] = {.lex_state = 556, .external_lex_state = 2},
  [1486] = {.lex_state = 556, .external_lex_state = 2},
  [1487] = {.lex_state = 556, .external_lex_state = 2},
  [1488] = {.lex_state = 556, .external_lex_state = 2},
  [1489] = {.lex_state = 556, .external_lex_state = 2},
  [1490] = {.lex_state = 556, .external_lex_state = 2},
  [1491] = {.lex_state = 556, .external_lex_state = 2},
  [1492] = {.lex_state = 556, .external_lex_state = 2},
  [1493] = {.lex_state = 556, .external_lex_state = 2},
  [1494] = {.lex_state = 556, .external_lex_state = 2},
  [1495] = {.lex_state = 556, .external_lex_state = 2},
  [1496] = {.lex_state = 556, .external_lex_state = 2},
  [1497] = {.lex_state = 556, .external_lex_state = 2},
  [1498] = {.lex_state = 556, .external_lex_state = 2},
  [1499] = {.lex_state = 348, .external_lex_state = 2},
  [1500] = {.lex_state = 556, .external_lex_state = 2},
  [1501] = {.lex_state = 556, .external_lex_state = 2},
  [1502] = {.lex_state = 556, .external_lex_state = 2},
  [1503] = {.lex_state = 556, .external_lex_state = 2},
  [1504] = {.lex_state = 556, .external_lex_state = 2},
  [1505] = {.lex_state = 556, .external_lex_state = 2},
  [1506] = {.lex_state = 556, .external_lex_state = 2},
  [1507] = {.lex_state = 556, .external_lex_state = 2},
  [1508] = {.lex_state = 556, .external_lex_state = 2},
  [1509] = {.lex_state = 556, .external_lex_state = 2},
  [1510] = {.lex_state = 556, .external_lex_state = 2},
  [1511] = {.lex_state = 556, .external_lex_state = 2},
  [1512] = {.lex_state = 556, .external_lex_state = 2},
  [1513] = {.lex_state = 556, .external_lex_state = 2},
  [1514] = {.lex_state = 556, .external_lex_state = 2},
  [1515] = {.lex_state = 556, .external_lex_state = 2},
  [1516] = {.lex_state = 556, .external_lex_state = 2},
  [1517] = {.lex_state = 556, .external_lex_state = 2},
  [1518] = {.lex_state = 556, .external_lex_state = 2},
  [1519] = {.lex_state = 556, .external_lex_state = 2},
  [1520] = {.lex_state = 556, .external_lex_state = 2},
  [1521] = {.lex_state = 556, .external_lex_state = 2},
  [1522] = {.lex_state = 556, .external_lex_state = 2},
  [1523] = {.lex_state = 556, .external_lex_state = 2},
  [1524] = {.lex_state = 556, .external_lex_state = 2},
  [1525] = {.lex_state = 556, .external_lex_state = 2},
  [1526] = {.lex_state = 556, .external_lex_state = 2},
  [1527] = {.lex_state = 556, .external_lex_state = 2},
  [1528] = {.lex_state = 556, .external_lex_state = 2},
  [1529] = {.lex_state = 556, .external_lex_state = 2},
  [1530] = {.lex_state = 556, .external_lex_state = 2},
  [1531] = {.lex_state = 200, .external_lex_state = 2},
  [1532] = {.lex_state = 556, .external_lex_state = 2},
  [1533] = {.lex_state = 556, .external_lex_state = 2},
  [1534] = {.lex_state = 556, .external_lex_state = 2},
  [1535] = {.lex_state = 556, .external_lex_state = 2},
  [1536] = {.lex_state = 556, .external_lex_state = 2},
  [1537] = {.lex_state = 556, .external_lex_state = 2},
  [1538] = {.lex_state = 556, .external_lex_state = 2},
  [1539] = {.lex_state = 556, .external_lex_state = 2},
  [1540] = {.lex_state = 556, .external_lex_state = 2},
  [1541] = {.lex_state = 556, .external_lex_state = 2},
  [1542] = {.lex_state = 556, .external_lex_state = 2},
  [1543] = {.lex_state = 556, .external_lex_state = 2},
  [1544] = {.lex_state = 556, .external_lex_state = 2},
  [1545] = {.lex_state = 556, .external_lex_state = 2},
  [1546] = {.lex_state = 556, .external_lex_state = 2},
  [1547] = {.lex_state = 556, .external_lex_state = 2},
  [1548] = {.lex_state = 556, .external_lex_state = 2},
  [1549] = {.lex_state = 556, .external_lex_state = 2},
  [1550] = {.lex_state = 556, .external_lex_state = 2},
  [1551] = {.lex_state = 556, .external_lex_state = 2},
  [1552] = {.lex_state = 556, .external_lex_state = 2},
  [1553] = {.lex_state = 556, .external_lex_state = 2},
  [1554] = {.lex_state = 556, .external_lex_state = 2},
  [1555] = {.lex_state = 556, .external_lex_state = 2},
  [1556] = {.lex_state = 556, .external_lex_state = 2},
  [1557] = {.lex_state = 556, .external_lex_state = 2},
  [1558] = {.lex_state = 556, .external_lex_state = 2},
  [1559] = {.lex_state = 556, .external_lex_state = 2},
  [1560] = {.lex_state = 556, .external_lex_state = 2},
  [1561] = {.lex_state = 556, .external_lex_state = 2},
  [1562] = {.lex_state = 556, .external_lex_state = 2},
  [1563] = {.lex_state = 556, .external_lex_state = 2},
  [1564] = {.lex_state = 556, .external_lex_state = 2},
  [1565] = {.lex_state = 556, .external_lex_state = 2},
  [1566] = {.lex_state = 556, .external_lex_state = 2},
  [1567] = {.lex_state = 556, .external_lex_state = 2},
  [1568] = {.lex_state = 556, .external_lex_state = 2},
  [1569] = {.lex_state = 556, .external_lex_state = 2},
  [1570] = {.lex_state = 556, .external_lex_state = 2},
  [1571] = {.lex_state = 556, .external_lex_state = 2},
  [1572] = {.lex_state = 556, .external_lex_state = 2},
  [1573] = {.lex_state = 556, .external_lex_state = 2},
  [1574] = {.lex_state = 556, .external_lex_state = 2},
  [1575] = {.lex_state = 556, .external_lex_state = 2},
  [1576] = {.lex_state = 556, .external_lex_state = 2},
  [1577] = {.lex_state = 556, .external_lex_state = 2},
  [1578] = {.lex_state = 556, .external_lex_state = 2},
  [1579] = {.lex_state = 556, .external_lex_state = 2},
  [1580] = {.lex_state = 556, .external_lex_state = 2},
  [1581] = {.lex_state = 556, .external_lex_state = 2},
  [1582] = {.lex_state = 556, .external_lex_state = 2},
  [1583] = {.lex_state = 556, .external_lex_state = 2},
  [1584] = {.lex_state = 556, .external_lex_state = 2},
  [1585] = {.lex_state = 556, .external_lex_state = 2},
  [1586] = {.lex_state = 556, .external_lex_state = 2},
  [1587] = {.lex_state = 556, .external_lex_state = 2},
  [1588] = {.lex_state = 200, .external_lex_state = 2},
  [1589] = {.lex_state = 556, .external_lex_state = 2},
  [1590] = {.lex_state = 556, .external_lex_state = 2},
  [1591] = {.lex_state = 200, .external_lex_state = 2},
  [1592] = {.lex_state = 348, .external_lex_state = 2},
  [1593] = {.lex_state = 556, .external_lex_state = 2},
  [1594] = {.lex_state = 556, .external_lex_state = 2},
  [1595] = {.lex_state = 556, .external_lex_state = 2},
  [1596] = {.lex_state = 556, .external_lex_state = 2},
  [1597] = {.lex_state = 556, .external_lex_state = 2},
  [1598] = {.lex_state = 200, .external_lex_state = 2},
  [1599] = {.lex_state = 556, .external_lex_state = 2},
  [1600] = {.lex_state = 200, .external_lex_state = 2},
  [1601] = {.lex_state = 556, .external_lex_state = 2},
  [1602] = {.lex_state = 556, .external_lex_state = 2},
  [1603] = {.lex_state = 200, .external_lex_state = 2},
  [1604] = {.lex_state = 200, .external_lex_state = 2},
  [1605] = {.lex_state = 556, .external_lex_state = 2},
  [1606] = {.lex_state = 556, .external_lex_state = 2},
  [1607] = {.lex_state = 200, .external_lex_state = 2},
  [1608] = {.lex_state = 200, .external_lex_state = 2},
  [1609] = {.lex_state = 556, .external_lex_state = 2},
  [1610] = {.lex_state = 556, .external_lex_state = 2},
  [1611] = {.lex_state = 200, .external_lex_state = 2},
  [1612] = {.lex_state = 200, .external_lex_state = 2},
  [1613] = {.lex_state = 556, .external_lex_state = 2},
  [1614] = {.lex_state = 556, .external_lex_state = 2},
  [1615] = {.lex_state = 200, .external_lex_state = 2},
  [1616] = {.lex_state = 200, .external_lex_state = 2},
  [1617] = {.lex_state = 556, .external_lex_state = 2},
  [1618] = {.lex_state = 556, .external_lex_state = 2},
  [1619] = {.lex_state = 200, .external_lex_state = 2},
  [1620] = {.lex_state = 200, .external_lex_state = 2},
  [1621] = {.lex_state = 556, .external_lex_state = 2},
  [1622] = {.lex_state = 556, .external_lex_state = 2},
  [1623] = {.lex_state = 200, .external_lex_state = 2},
  [1624] = {.lex_state = 200, .external_lex_state = 2},
  [1625] = {.lex_state = 556, .external_lex_state = 2},
  [1626] = {.lex_state = 556, .external_lex_state = 2},
  [1627] = {.lex_state = 200, .external_lex_state = 2},
  [1628] = {.lex_state = 200, .external_lex_state = 2},
  [1629] = {.lex_state = 556, .external_lex_state = 2},
  [1630] = {.lex_state = 556, .external_lex_state = 2},
  [1631] = {.lex_state = 200, .external_lex_state = 2},
  [1632] = {.lex_state = 200, .external_lex_state = 2},
  [1633] = {.lex_state = 556, .external_lex_state = 2},
  [1634] = {.lex_state = 556, .external_lex_state = 2},
  [1635] = {.lex_state = 200, .external_lex_state = 2},
  [1636] = {.lex_state = 200, .external_lex_state = 2},
  [1637] = {.lex_state = 556, .external_lex_state = 2},
  [1638] = {.lex_state = 556, .external_lex_state = 2},
  [1639] = {.lex_state = 200, .external_lex_state = 2},
  [1640] = {.lex_state = 200, .external_lex_state = 2},
  [1641] = {.lex_state = 556, .external_lex_state = 2},
  [1642] = {.lex_state = 556, .external_lex_state = 2},
  [1643] = {.lex_state = 200, .external_lex_state = 2},
  [1644] = {.lex_state = 200, .external_lex_state = 2},
  [1645] = {.lex_state = 200, .external_lex_state = 2},
  [1646] = {.lex_state = 200, .external_lex_state = 2},
  [1647] = {.lex_state = 200, .external_lex_state = 2},
  [1648] = {.lex_state = 200, .external_lex_state = 2},
  [1649] = {.lex_state = 200, .external_lex_state = 2},
  [1650] = {.lex_state = 200, .external_lex_state = 2},
  [1651] = {.lex_state = 200, .external_lex_state = 2},
  [1652] = {.lex_state = 200, .external_lex_state = 2},
  [1653] = {.lex_state = 200, .external_lex_state = 2},
  [1654] = {.lex_state = 200, .external_lex_state = 2},
  [1655] = {.lex_state = 200, .external_lex_state = 2},
  [1656] = {.lex_state = 200, .external_lex_state = 2},
  [1657] = {.lex_state = 200, .external_lex_state = 2},
  [1658] = {.lex_state = 200, .external_lex_state = 2},
  [1659] = {.lex_state = 200, .external_lex_state = 2},
  [1660] = {.lex_state = 200, .external_lex_state = 2},
  [1661] = {.lex_state = 200, .external_lex_state = 2},
  [1662] = {.lex_state = 200, .external_lex_state = 2},
  [1663] = {.lex_state = 200, .external_lex_state = 2},
  [1664] = {.lex_state = 200, .external_lex_state = 2},
  [1665] = {.lex_state = 200, .external_lex_state = 2},
  [1666] = {.lex_state = 200, .external_lex_state = 2},
  [1667] = {.lex_state = 200, .external_lex_state = 2},
  [1668] = {.lex_state = 200, .external_lex_state = 2},
  [1669] = {.lex_state = 200, .external_lex_state = 2},
  [1670] = {.lex_state = 200, .external_lex_state = 2},
  [1671] = {.lex_state = 200, .external_lex_state = 2},
  [1672] = {.lex_state = 200, .external_lex_state = 2},
  [1673] = {.lex_state = 200, .external_lex_state = 2},
  [1674] = {.lex_state = 556, .external_lex_state = 2},
  [1675] = {.lex_state = 556, .external_lex_state = 2},
  [1676] = {.lex_state = 556, .external_lex_state = 2},
  [1677] = {.lex_state = 556, .external_lex_state = 2},
  [1678] = {.lex_state = 556, .external_lex_state = 2},
  [1679] = {.lex_state = 556, .external_lex_state = 2},
  [1680] = {.lex_state = 556, .external_lex_state = 2},
  [1681] = {.lex_state = 556, .external_lex_state = 2},
  [1682] = {.lex_state = 556, .external_lex_state = 2},
  [1683] = {.lex_state = 556, .external_lex_state = 2},
  [1684] = {.lex_state = 556, .external_lex_state = 2},
  [1685] = {.lex_state = 556, .external_lex_state = 2},
  [1686] = {.lex_state = 556, .external_lex_state = 2},
  [1687] = {.lex_state = 556, .external_lex_state = 2},
  [1688] = {.lex_state = 556, .external_lex_state = 2},
  [1689] = {.lex_state = 556, .external_lex_state = 2},
  [1690] = {.lex_state = 556, .external_lex_state = 2},
  [1691] = {.lex_state = 556, .external_lex_state = 2},
  [1692] = {.lex_state = 556, .external_lex_state = 2},
  [1693] = {.lex_state = 556, .external_lex_state = 2},
  [1694] = {.lex_state = 556, .external_lex_state = 2},
  [1695] = {.lex_state = 556, .external_lex_state = 2},
  [1696] = {.lex_state = 556, .external_lex_state = 2},
  [1697] = {.lex_state = 556, .external_lex_state = 2},
  [1698] = {.lex_state = 556, .external_lex_state = 2},
  [1699] = {.lex_state = 556, .external_lex_state = 2},
  [1700] = {.lex_state = 556, .external_lex_state = 2},
  [1701] = {.lex_state = 556, .external_lex_state = 2},
  [1702] = {.lex_state = 556, .external_lex_state = 2},
  [1703] = {.lex_state = 556, .external_lex_state = 2},
  [1704] = {.lex_state = 556, .external_lex_state = 2},
  [1705] = {.lex_state = 556, .external_lex_state = 2},
  [1706] = {.lex_state = 556, .external_lex_state = 2},
  [1707] = {.lex_state = 556, .external_lex_state = 2},
  [1708] = {.lex_state = 556, .external_lex_state = 2},
  [1709] = {.lex_state = 556, .external_lex_state = 2},
  [1710] = {.lex_state = 556, .external_lex_state = 2},
  [1711] = {.lex_state = 556, .external_lex_state = 2},
  [1712] = {.lex_state = 556, .external_lex_state = 2},
  [1713] = {.lex_state = 556, .external_lex_state = 2},
  [1714] = {.lex_state = 556, .external_lex_state = 2},
  [1715] = {.lex_state = 556, .external_lex_state = 2},
  [1716] = {.lex_state = 556, .external_lex_state = 2},
  [1717] = {.lex_state = 556, .external_lex_state = 2},
  [1718] = {.lex_state = 556, .external_lex_state = 2},
  [1719] = {.lex_state = 556, .external_lex_state = 2},
  [1720] = {.lex_state = 556, .external_lex_state = 2},
  [1721] = {.lex_state = 556, .external_lex_state = 2},
  [1722] = {.lex_state = 556, .external_lex_state = 2},
  [1723] = {.lex_state = 556, .external_lex_state = 2},
  [1724] = {.lex_state = 556, .external_lex_state = 2},
  [1725] = {.lex_state = 556, .external_lex_state = 2},
  [1726] = {.lex_state = 556, .external_lex_state = 2},
  [1727] = {.lex_state = 556, .external_lex_state = 2},
  [1728] = {.lex_state = 556, .external_lex_state = 2},
  [1729] = {.lex_state = 556, .external_lex_state = 2},
  [1730] = {.lex_state = 556, .external_lex_state = 2},
  [1731] = {.lex_state = 556, .external_lex_state = 2},
  [1732] = {.lex_state = 556, .external_lex_state = 2},
  [1733] = {.lex_state = 556, .external_lex_state = 2},
  [1734] = {.lex_state = 556, .external_lex_state = 2},
  [1735] = {.lex_state = 556, .external_lex_state = 2},
  [1736] = {.lex_state = 556, .external_lex_state = 2},
  [1737] = {.lex_state = 556, .external_lex_state = 2},
  [1738] = {.lex_state = 556, .external_lex_state = 2},
  [1739] = {.lex_state = 556, .external_lex_state = 2},
  [1740] = {.lex_state = 556, .external_lex_state = 2},
  [1741] = {.lex_state = 556, .external_lex_state = 2},
  [1742] = {.lex_state = 556, .external_lex_state = 2},
  [1743] = {.lex_state = 556, .external_lex_state = 2},
  [1744] = {.lex_state = 556, .external_lex_state = 2},
  [1745] = {.lex_state = 556, .external_lex_state = 2},
  [1746] = {.lex_state = 556, .external_lex_state = 2},
  [1747] = {.lex_state = 556, .external_lex_state = 2},
  [1748] = {.lex_state = 556, .external_lex_state = 2},
  [1749] = {.lex_state = 556, .external_lex_state = 2},
  [1750] = {.lex_state = 556, .external_lex_state = 2},
  [1751] = {.lex_state = 556, .external_lex_state = 2},
  [1752] = {.lex_state = 556, .external_lex_state = 2},
  [1753] = {.lex_state = 556, .external_lex_state = 2},
  [1754] = {.lex_state = 556, .external_lex_state = 2},
  [1755] = {.lex_state = 556, .external_lex_state = 2},
  [1756] = {.lex_state = 556, .external_lex_state = 2},
  [1757] = {.lex_state = 556, .external_lex_state = 2},
  [1758] = {.lex_state = 556, .external_lex_state = 2},
  [1759] = {.lex_state = 556, .external_lex_state = 2},
  [1760] = {.lex_state = 556, .external_lex_state = 2},
  [1761] = {.lex_state = 556, .external_lex_state = 2},
  [1762] = {.lex_state = 556, .external_lex_state = 2},
  [1763] = {.lex_state = 556, .external_lex_state = 2},
  [1764] = {.lex_state = 556, .external_lex_state = 2},
  [1765] = {.lex_state = 556, .external_lex_state = 2},
  [1766] = {.lex_state = 556, .external_lex_state = 2},
  [1767] = {.lex_state = 556, .external_lex_state = 2},
  [1768] = {.lex_state = 556, .external_lex_state = 2},
  [1769] = {.lex_state = 556, .external_lex_state = 2},
  [1770] = {.lex_state = 556, .external_lex_state = 2},
  [1771] = {.lex_state = 556, .external_lex_state = 2},
  [1772] = {.lex_state = 556, .external_lex_state = 2},
  [1773] = {.lex_state = 556, .external_lex_state = 2},
  [1774] = {.lex_state = 556, .external_lex_state = 2},
  [1775] = {.lex_state = 556, .external_lex_state = 2},
  [1776] = {.lex_state = 556, .external_lex_state = 2},
  [1777] = {.lex_state = 556, .external_lex_state = 2},
  [1778] = {.lex_state = 556, .external_lex_state = 2},
  [1779] = {.lex_state = 556, .external_lex_state = 2},
  [1780] = {.lex_state = 556, .external_lex_state = 2},
  [1781] = {.lex_state = 556, .external_lex_state = 2},
  [1782] = {.lex_state = 556, .external_lex_state = 2},
  [1783] = {.lex_state = 556, .external_lex_state = 2},
  [1784] = {.lex_state = 556, .external_lex_state = 2},
  [1785] = {.lex_state = 556, .external_lex_state = 2},
  [1786] = {.lex_state = 556, .external_lex_state = 2},
  [1787] = {.lex_state = 556, .external_lex_state = 2},
  [1788] = {.lex_state = 556, .external_lex_state = 2},
  [1789] = {.lex_state = 556, .external_lex_state = 2},
  [1790] = {.lex_state = 556, .external_lex_state = 2},
  [1791] = {.lex_state = 556, .external_lex_state = 2},
  [1792] = {.lex_state = 556, .external_lex_state = 2},
  [1793] = {.lex_state = 556, .external_lex_state = 2},
  [1794] = {.lex_state = 556, .external_lex_state = 2},
  [1795] = {.lex_state = 556, .external_lex_state = 2},
  [1796] = {.lex_state = 556, .external_lex_state = 2},
  [1797] = {.lex_state = 556, .external_lex_state = 2},
  [1798] = {.lex_state = 556, .external_lex_state = 2},
  [1799] = {.lex_state = 556, .external_lex_state = 2},
  [1800] = {.lex_state = 556, .external_lex_state = 2},
  [1801] = {.lex_state = 556, .external_lex_state = 2},
  [1802] = {.lex_state = 556, .external_lex_state = 2},
  [1803] = {.lex_state = 556, .external_lex_state = 2},
  [1804] = {.lex_state = 556, .external_lex_state = 2},
  [1805] = {.lex_state = 556, .external_lex_state = 2},
  [1806] = {.lex_state = 556, .external_lex_state = 2},
  [1807] = {.lex_state = 556, .external_lex_state = 2},
  [1808] = {.lex_state = 556, .external_lex_state = 2},
  [1809] = {.lex_state = 556, .external_lex_state = 2},
  [1810] = {.lex_state = 556, .external_lex_state = 2},
  [1811] = {.lex_state = 556, .external_lex_state = 2},
  [1812] = {.lex_state = 556, .external_lex_state = 2},
  [1813] = {.lex_state = 556, .external_lex_state = 2},
  [1814] = {.lex_state = 556, .external_lex_state = 2},
  [1815] = {.lex_state = 556, .external_lex_state = 2},
  [1816] = {.lex_state = 556, .external_lex_state = 2},
  [1817] = {.lex_state = 556, .external_lex_state = 2},
  [1818] = {.lex_state = 556, .external_lex_state = 2},
  [1819] = {.lex_state = 556, .external_lex_state = 2},
  [1820] = {.lex_state = 556, .external_lex_state = 2},
  [1821] = {.lex_state = 556, .external_lex_state = 2},
  [1822] = {.lex_state = 556, .external_lex_state = 2},
  [1823] = {.lex_state = 556, .external_lex_state = 2},
  [1824] = {.lex_state = 556, .external_lex_state = 2},
  [1825] = {.lex_state = 556, .external_lex_state = 2},
  [1826] = {.lex_state = 556, .external_lex_state = 2},
  [1827] = {.lex_state = 556, .external_lex_state = 2},
  [1828] = {.lex_state = 556, .external_lex_state = 2},
  [1829] = {.lex_state = 556, .external_lex_state = 2},
  [1830] = {.lex_state = 556, .external_lex_state = 2},
  [1831] = {.lex_state = 556, .external_lex_state = 2},
  [1832] = {.lex_state = 556, .external_lex_state = 2},
  [1833] = {.lex_state = 556, .external_lex_state = 2},
  [1834] = {.lex_state = 556, .external_lex_state = 2},
  [1835] = {.lex_state = 556, .external_lex_state = 2},
  [1836] = {.lex_state = 556, .external_lex_state = 2},
  [1837] = {.lex_state = 556, .external_lex_state = 2},
  [1838] = {.lex_state = 556, .external_lex_state = 2},
  [1839] = {.lex_state = 556, .external_lex_state = 2},
  [1840] = {.lex_state = 556, .external_lex_state = 2},
  [1841] = {.lex_state = 556, .external_lex_state = 2},
  [1842] = {.lex_state = 556, .external_lex_state = 2},
  [1843] = {.lex_state = 556, .external_lex_state = 2},
  [1844] = {.lex_state = 556, .external_lex_state = 2},
  [1845] = {.lex_state = 556, .external_lex_state = 2},
  [1846] = {.lex_state = 556, .external_lex_state = 2},
  [1847] = {.lex_state = 556, .external_lex_state = 2},
  [1848] = {.lex_state = 556, .external_lex_state = 2},
  [1849] = {.lex_state = 556, .external_lex_state = 2},
  [1850] = {.lex_state = 556, .external_lex_state = 2},
  [1851] = {.lex_state = 556, .external_lex_state = 2},
  [1852] = {.lex_state = 556, .external_lex_state = 2},
  [1853] = {.lex_state = 556, .external_lex_state = 2},
  [1854] = {.lex_state = 556, .external_lex_state = 2},
  [1855] = {.lex_state = 556, .external_lex_state = 2},
  [1856] = {.lex_state = 556, .external_lex_state = 2},
  [1857] = {.lex_state = 556, .external_lex_state = 2},
  [1858] = {.lex_state = 556, .external_lex_state = 2},
  [1859] = {.lex_state = 556, .external_lex_state = 2},
  [1860] = {.lex_state = 556, .external_lex_state = 2},
  [1861] = {.lex_state = 556, .external_lex_state = 2},
  [1862] = {.lex_state = 556, .external_lex_state = 2},
  [1863] = {.lex_state = 556, .external_lex_state = 2},
  [1864] = {.lex_state = 556, .external_lex_state = 2},
  [1865] = {.lex_state = 556, .external_lex_state = 2},
  [1866] = {.lex_state = 556, .external_lex_state = 2},
  [1867] = {.lex_state = 556, .external_lex_state = 2},
  [1868] = {.lex_state = 556, .external_lex_state = 2},
  [1869] = {.lex_state = 556, .external_lex_state = 2},
  [1870] = {.lex_state = 556, .external_lex_state = 2},
  [1871] = {.lex_state = 556, .external_lex_state = 2},
  [1872] = {.lex_state = 556, .external_lex_state = 2},
  [1873] = {.lex_state = 556, .external_lex_state = 2},
  [1874] = {.lex_state = 556, .external_lex_state = 2},
  [1875] = {.lex_state = 556, .external_lex_state = 2},
  [1876] = {.lex_state = 556, .external_lex_state = 2},
  [1877] = {.lex_state = 556, .external_lex_state = 2},
  [1878] = {.lex_state = 556, .external_lex_state = 2},
  [1879] = {.lex_state = 556, .external_lex_state = 2},
  [1880] = {.lex_state = 556, .external_lex_state = 2},
  [1881] = {.lex_state = 556, .external_lex_state = 2},
  [1882] = {.lex_state = 556, .external_lex_state = 2},
  [1883] = {.lex_state = 556, .external_lex_state = 2},
  [1884] = {.lex_state = 556, .external_lex_state = 2},
  [1885] = {.lex_state = 556, .external_lex_state = 2},
  [1886] = {.lex_state = 556, .external_lex_state = 2},
  [1887] = {.lex_state = 556, .external_lex_state = 2},
  [1888] = {.lex_state = 556, .external_lex_state = 2},
  [1889] = {.lex_state = 556, .external_lex_state = 2},
  [1890] = {.lex_state = 556, .external_lex_state = 2},
  [1891] = {.lex_state = 556, .external_lex_state = 2},
  [1892] = {.lex_state = 556, .external_lex_state = 2},
  [1893] = {.lex_state = 556, .external_lex_state = 2},
  [1894] = {.lex_state = 556, .external_lex_state = 2},
  [1895] = {.lex_state = 556, .external_lex_state = 2},
  [1896] = {.lex_state = 556, .external_lex_state = 2},
  [1897] = {.lex_state = 556, .external_lex_state = 2},
  [1898] = {.lex_state = 556, .external_lex_state = 2},
  [1899] = {.lex_state = 556, .external_lex_state = 2},
  [1900] = {.lex_state = 556, .external_lex_state = 2},
  [1901] = {.lex_state = 556, .external_lex_state = 2},
  [1902] = {.lex_state = 556, .external_lex_state = 2},
  [1903] = {.lex_state = 556, .external_lex_state = 2},
  [1904] = {.lex_state = 556, .external_lex_state = 2},
  [1905] = {.lex_state = 556, .external_lex_state = 2},
  [1906] = {.lex_state = 556, .external_lex_state = 2},
  [1907] = {.lex_state = 556, .external_lex_state = 2},
  [1908] = {.lex_state = 556, .external_lex_state = 2},
  [1909] = {.lex_state = 556, .external_lex_state = 2},
  [1910] = {.lex_state = 556, .external_lex_state = 2},
  [1911] = {.lex_state = 556, .external_lex_state = 2},
  [1912] = {.lex_state = 556, .external_lex_state = 2},
  [1913] = {.lex_state = 556, .external_lex_state = 2},
  [1914] = {.lex_state = 556, .external_lex_state = 2},
  [1915] = {.lex_state = 556, .external_lex_state = 2},
  [1916] = {.lex_state = 556, .external_lex_state = 2},
  [1917] = {.lex_state = 556, .external_lex_state = 2},
  [1918] = {.lex_state = 556, .external_lex_state = 2},
  [1919] = {.lex_state = 556, .external_lex_state = 2},
  [1920] = {.lex_state = 556, .external_lex_state = 2},
  [1921] = {.lex_state = 556, .external_lex_state = 2},
  [1922] = {.lex_state = 556, .external_lex_state = 2},
  [1923] = {.lex_state = 556, .external_lex_state = 2},
  [1924] = {.lex_state = 556, .external_lex_state = 2},
  [1925] = {.lex_state = 556, .external_lex_state = 2},
  [1926] = {.lex_state = 556, .external_lex_state = 2},
  [1927] = {.lex_state = 556, .external_lex_state = 2},
  [1928] = {.lex_state = 556, .external_lex_state = 2},
  [1929] = {.lex_state = 556, .external_lex_state = 2},
  [1930] = {.lex_state = 556, .external_lex_state = 2},
  [1931] = {.lex_state = 556, .external_lex_state = 2},
  [1932] = {.lex_state = 556, .external_lex_state = 2},
  [1933] = {.lex_state = 556, .external_lex_state = 2},
  [1934] = {.lex_state = 556, .external_lex_state = 2},
  [1935] = {.lex_state = 556, .external_lex_state = 2},
  [1936] = {.lex_state = 556, .external_lex_state = 2},
  [1937] = {.lex_state = 556, .external_lex_state = 2},
  [1938] = {.lex_state = 556, .external_lex_state = 2},
  [1939] = {.lex_state = 556, .external_lex_state = 2},
  [1940] = {.lex_state = 556, .external_lex_state = 2},
  [1941] = {.lex_state = 556, .external_lex_state = 2},
  [1942] = {.lex_state = 556, .external_lex_state = 2},
  [1943] = {.lex_state = 556, .external_lex_state = 2},
  [1944] = {.lex_state = 556, .external_lex_state = 2},
  [1945] = {.lex_state = 556, .external_lex_state = 2},
  [1946] = {.lex_state = 556, .external_lex_state = 2},
  [1947] = {.lex_state = 556, .external_lex_state = 2},
  [1948] = {.lex_state = 556, .external_lex_state = 2},
  [1949] = {.lex_state = 556, .external_lex_state = 2},
  [1950] = {.lex_state = 556, .external_lex_state = 2},
  [1951] = {.lex_state = 556, .external_lex_state = 2},
  [1952] = {.lex_state = 556, .external_lex_state = 2},
  [1953] = {.lex_state = 556, .external_lex_state = 2},
  [1954] = {.lex_state = 556, .external_lex_state = 2},
  [1955] = {.lex_state = 556, .external_lex_state = 2},
  [1956] = {.lex_state = 556, .external_lex_state = 2},
  [1957] = {.lex_state = 556, .external_lex_state = 2},
  [1958] = {.lex_state = 556, .external_lex_state = 2},
  [1959] = {.lex_state = 556, .external_lex_state = 2},
  [1960] = {.lex_state = 556, .external_lex_state = 2},
  [1961] = {.lex_state = 556, .external_lex_state = 2},
  [1962] = {.lex_state = 556, .external_lex_state = 2},
  [1963] = {.lex_state = 556, .external_lex_state = 2},
  [1964] = {.lex_state = 556, .external_lex_state = 2},
  [1965] = {.lex_state = 556, .external_lex_state = 2},
  [1966] = {.lex_state = 556, .external_lex_state = 2},
  [1967] = {.lex_state = 556, .external_lex_state = 2},
  [1968] = {.lex_state = 556, .external_lex_state = 2},
  [1969] = {.lex_state = 556, .external_lex_state = 2},
  [1970] = {.lex_state = 556, .external_lex_state = 2},
  [1971] = {.lex_state = 556, .external_lex_state = 2},
  [1972] = {.lex_state = 556, .external_lex_state = 2},
  [1973] = {.lex_state = 556, .external_lex_state = 2},
  [1974] = {.lex_state = 556, .external_lex_state = 2},
  [1975] = {.lex_state = 556, .external_lex_state = 2},
  [1976] = {.lex_state = 556, .external_lex_state = 2},
  [1977] = {.lex_state = 556, .external_lex_state = 2},
  [1978] = {.lex_state = 556, .external_lex_state = 2},
  [1979] = {.lex_state = 556, .external_lex_state = 2},
  [1980] = {.lex_state = 556, .external_lex_state = 2},
  [1981] = {.lex_state = 556, .external_lex_state = 2},
  [1982] = {.lex_state = 556, .external_lex_state = 2},
  [1983] = {.lex_state = 556, .external_lex_state = 2},
  [1984] = {.lex_state = 556, .external_lex_state = 2},
  [1985] = {.lex_state = 556, .external_lex_state = 2},
  [1986] = {.lex_state = 556, .external_lex_state = 2},
  [1987] = {.lex_state = 556, .external_lex_state = 2},
  [1988] = {.lex_state = 556, .external_lex_state = 2},
  [1989] = {.lex_state = 556, .external_lex_state = 2},
  [1990] = {.lex_state = 556, .external_lex_state = 2},
  [1991] = {.lex_state = 556, .external_lex_state = 2},
  [1992] = {.lex_state = 556, .external_lex_state = 2},
  [1993] = {.lex_state = 556, .external_lex_state = 2},
  [1994] = {.lex_state = 556, .external_lex_state = 2},
  [1995] = {.lex_state = 556, .external_lex_state = 2},
  [1996] = {.lex_state = 556, .external_lex_state = 2},
  [1997] = {.lex_state = 556, .external_lex_state = 2},
  [1998] = {.lex_state = 556, .external_lex_state = 2},
  [1999] = {.lex_state = 556, .external_lex_state = 2},
  [2000] = {.lex_state = 556, .external_lex_state = 2},
  [2001] = {.lex_state = 556, .external_lex_state = 2},
  [2002] = {.lex_state = 556, .external_lex_state = 2},
  [2003] = {.lex_state = 556, .external_lex_state = 2},
  [2004] = {.lex_state = 556, .external_lex_state = 2},
  [2005] = {.lex_state = 556, .external_lex_state = 2},
  [2006] = {.lex_state = 556, .external_lex_state = 2},
  [2007] = {.lex_state = 556, .external_lex_state = 2},
  [2008] = {.lex_state = 556, .external_lex_state = 2},
  [2009] = {.lex_state = 556, .external_lex_state = 2},
  [2010] = {.lex_state = 556, .external_lex_state = 2},
  [2011] = {.lex_state = 556, .external_lex_state = 2},
  [2012] = {.lex_state = 556, .external_lex_state = 2},
  [2013] = {.lex_state = 556, .external_lex_state = 2},
  [2014] = {.lex_state = 556, .external_lex_state = 2},
  [2015] = {.lex_state = 556, .external_lex_state = 2},
  [2016] = {.lex_state = 556, .external_lex_state = 2},
  [2017] = {.lex_state = 556, .external_lex_state = 2},
  [2018] = {.lex_state = 556, .external_lex_state = 2},
  [2019] = {.lex_state = 556, .external_lex_state = 2},
  [2020] = {.lex_state = 556, .external_lex_state = 2},
  [2021] = {.lex_state = 556, .external_lex_state = 2},
  [2022] = {.lex_state = 556, .external_lex_state = 2},
  [2023] = {.lex_state = 556, .external_lex_state = 2},
  [2024] = {.lex_state = 556, .external_lex_state = 2},
  [2025] = {.lex_state = 556, .external_lex_state = 2},
  [2026] = {.lex_state = 556, .external_lex_state = 2},
  [2027] = {.lex_state = 556, .external_lex_state = 2},
  [2028] = {.lex_state = 556, .external_lex_state = 2},
  [2029] = {.lex_state = 556, .external_lex_state = 2},
  [2030] = {.lex_state = 556, .external_lex_state = 2},
  [2031] = {.lex_state = 556, .external_lex_state = 2},
  [2032] = {.lex_state = 556, .external_lex_state = 2},
  [2033] = {.lex_state = 556, .external_lex_state = 2},
  [2034] = {.lex_state = 556, .external_lex_state = 2},
  [2035] = {.lex_state = 556, .external_lex_state = 2},
  [2036] = {.lex_state = 556, .external_lex_state = 2},
  [2037] = {.lex_state = 556, .external_lex_state = 2},
  [2038] = {.lex_state = 556, .external_lex_state = 2},
  [2039] = {.lex_state = 556, .external_lex_state = 2},
  [2040] = {.lex_state = 556, .external_lex_state = 2},
  [2041] = {.lex_state = 556, .external_lex_state = 2},
  [2042] = {.lex_state = 556, .external_lex_state = 2},
  [2043] = {.lex_state = 556, .external_lex_state = 2},
  [2044] = {.lex_state = 556, .external_lex_state = 2},
  [2045] = {.lex_state = 556, .external_lex_state = 2},
  [2046] = {.lex_state = 556, .external_lex_state = 2},
  [2047] = {.lex_state = 556, .external_lex_state = 2},
  [2048] = {.lex_state = 556, .external_lex_state = 2},
  [2049] = {.lex_state = 556, .external_lex_state = 2},
  [2050] = {.lex_state = 556, .external_lex_state = 2},
  [2051] = {.lex_state = 556, .external_lex_state = 2},
  [2052] = {.lex_state = 556, .external_lex_state = 2},
  [2053] = {.lex_state = 556, .external_lex_state = 2},
  [2054] = {.lex_state = 556, .external_lex_state = 2},
  [2055] = {.lex_state = 556, .external_lex_state = 2},
  [2056] = {.lex_state = 556, .external_lex_state = 2},
  [2057] = {.lex_state = 556, .external_lex_state = 2},
  [2058] = {.lex_state = 556, .external_lex_state = 2},
  [2059] = {.lex_state = 556, .external_lex_state = 2},
  [2060] = {.lex_state = 556, .external_lex_state = 2},
  [2061] = {.lex_state = 556, .external_lex_state = 2},
  [2062] = {.lex_state = 556, .external_lex_state = 2},
  [2063] = {.lex_state = 556, .external_lex_state = 2},
  [2064] = {.lex_state = 556, .external_lex_state = 2},
  [2065] = {.lex_state = 556, .external_lex_state = 2},
  [2066] = {.lex_state = 556, .external_lex_state = 2},
  [2067] = {.lex_state = 556, .external_lex_state = 2},
  [2068] = {.lex_state = 556, .external_lex_state = 2},
  [2069] = {.lex_state = 556, .external_lex_state = 2},
  [2070] = {.lex_state = 556, .external_lex_state = 2},
  [2071] = {.lex_state = 556, .external_lex_state = 2},
  [2072] = {.lex_state = 556, .external_lex_state = 2},
  [2073] = {.lex_state = 556, .external_lex_state = 2},
  [2074] = {.lex_state = 556, .external_lex_state = 2},
  [2075] = {.lex_state = 556, .external_lex_state = 2},
  [2076] = {.lex_state = 556, .external_lex_state = 2},
  [2077] = {.lex_state = 556, .external_lex_state = 2},
  [2078] = {.lex_state = 556, .external_lex_state = 2},
  [2079] = {.lex_state = 556, .external_lex_state = 2},
  [2080] = {.lex_state = 556, .external_lex_state = 2},
  [2081] = {.lex_state = 556, .external_lex_state = 2},
  [2082] = {.lex_state = 556, .external_lex_state = 2},
  [2083] = {.lex_state = 556, .external_lex_state = 2},
  [2084] = {.lex_state = 556, .external_lex_state = 2},
  [2085] = {.lex_state = 556, .external_lex_state = 2},
  [2086] = {.lex_state = 556, .external_lex_state = 2},
  [2087] = {.lex_state = 556, .external_lex_state = 2},
  [2088] = {.lex_state = 556, .external_lex_state = 2},
  [2089] = {.lex_state = 556, .external_lex_state = 2},
  [2090] = {.lex_state = 556, .external_lex_state = 2},
  [2091] = {.lex_state = 556, .external_lex_state = 2},
  [2092] = {.lex_state = 556, .external_lex_state = 2},
  [2093] = {.lex_state = 556, .external_lex_state = 2},
  [2094] = {.lex_state = 556, .external_lex_state = 2},
  [2095] = {.lex_state = 556, .external_lex_state = 2},
  [2096] = {.lex_state = 556, .external_lex_state = 2},
  [2097] = {.lex_state = 556, .external_lex_state = 2},
  [2098] = {.lex_state = 556, .external_lex_state = 2},
  [2099] = {.lex_state = 556, .external_lex_state = 2},
  [2100] = {.lex_state = 556, .external_lex_state = 2},
  [2101] = {.lex_state = 556, .external_lex_state = 2},
  [2102] = {.lex_state = 556, .external_lex_state = 2},
  [2103] = {.lex_state = 556, .external_lex_state = 2},
  [2104] = {.lex_state = 556, .external_lex_state = 2},
  [2105] = {.lex_state = 556, .external_lex_state = 2},
  [2106] = {.lex_state = 556, .external_lex_state = 2},
  [2107] = {.lex_state = 556, .external_lex_state = 2},
  [2108] = {.lex_state = 556, .external_lex_state = 2},
  [2109] = {.lex_state = 556, .external_lex_state = 2},
  [2110] = {.lex_state = 556, .external_lex_state = 2},
  [2111] = {.lex_state = 556, .external_lex_state = 2},
  [2112] = {.lex_state = 556, .external_lex_state = 2},
  [2113] = {.lex_state = 556, .external_lex_state = 2},
  [2114] = {.lex_state = 556, .external_lex_state = 2},
  [2115] = {.lex_state = 556, .external_lex_state = 2},
  [2116] = {.lex_state = 556, .external_lex_state = 2},
  [2117] = {.lex_state = 556, .external_lex_state = 2},
  [2118] = {.lex_state = 556, .external_lex_state = 2},
  [2119] = {.lex_state = 556, .external_lex_state = 2},
  [2120] = {.lex_state = 556, .external_lex_state = 2},
  [2121] = {.lex_state = 556, .external_lex_state = 2},
  [2122] = {.lex_state = 556, .external_lex_state = 2},
  [2123] = {.lex_state = 556, .external_lex_state = 2},
  [2124] = {.lex_state = 556, .external_lex_state = 2},
  [2125] = {.lex_state = 556, .external_lex_state = 2},
  [2126] = {.lex_state = 556, .external_lex_state = 2},
  [2127] = {.lex_state = 556, .external_lex_state = 2},
  [2128] = {.lex_state = 556, .external_lex_state = 2},
  [2129] = {.lex_state = 556, .external_lex_state = 2},
  [2130] = {.lex_state = 556, .external_lex_state = 2},
  [2131] = {.lex_state = 556, .external_lex_state = 2},
  [2132] = {.lex_state = 556, .external_lex_state = 2},
  [2133] = {.lex_state = 556, .external_lex_state = 2},
  [2134] = {.lex_state = 556, .external_lex_state = 2},
  [2135] = {.lex_state = 556, .external_lex_state = 2},
  [2136] = {.lex_state = 556, .external_lex_state = 2},
  [2137] = {.lex_state = 556, .external_lex_state = 2},
  [2138] = {.lex_state = 556, .external_lex_state = 2},
  [2139] = {.lex_state = 556, .external_lex_state = 2},
  [2140] = {.lex_state = 556, .external_lex_state = 2},
  [2141] = {.lex_state = 556, .external_lex_state = 2},
  [2142] = {.lex_state = 556, .external_lex_state = 2},
  [2143] = {.lex_state = 556, .external_lex_state = 2},
  [2144] = {.lex_state = 556, .external_lex_state = 2},
  [2145] = {.lex_state = 556, .external_lex_state = 2},
  [2146] = {.lex_state = 556, .external_lex_state = 2},
  [2147] = {.lex_state = 556, .external_lex_state = 2},
  [2148] = {.lex_state = 556, .external_lex_state = 2},
  [2149] = {.lex_state = 556, .external_lex_state = 2},
  [2150] = {.lex_state = 556, .external_lex_state = 2},
  [2151] = {.lex_state = 556, .external_lex_state = 2},
  [2152] = {.lex_state = 556, .external_lex_state = 2},
  [2153] = {.lex_state = 556, .external_lex_state = 2},
  [2154] = {.lex_state = 556, .external_lex_state = 2},
  [2155] = {.lex_state = 556, .external_lex_state = 2},
  [2156] = {.lex_state = 556, .external_lex_state = 2},
  [2157] = {.lex_state = 556, .external_lex_state = 2},
  [2158] = {.lex_state = 556, .external_lex_state = 2},
  [2159] = {.lex_state = 556, .external_lex_state = 2},
  [2160] = {.lex_state = 556, .external_lex_state = 2},
  [2161] = {.lex_state = 556, .external_lex_state = 2},
  [2162] = {.lex_state = 556, .external_lex_state = 2},
  [2163] = {.lex_state = 556, .external_lex_state = 2},
  [2164] = {.lex_state = 556, .external_lex_state = 2},
  [2165] = {.lex_state = 556, .external_lex_state = 2},
  [2166] = {.lex_state = 556, .external_lex_state = 2},
  [2167] = {.lex_state = 556, .external_lex_state = 2},
  [2168] = {.lex_state = 556, .external_lex_state = 2},
  [2169] = {.lex_state = 556, .external_lex_state = 2},
  [2170] = {.lex_state = 556, .external_lex_state = 2},
  [2171] = {.lex_state = 556, .external_lex_state = 2},
  [2172] = {.lex_state = 556, .external_lex_state = 2},
  [2173] = {.lex_state = 556, .external_lex_state = 2},
  [2174] = {.lex_state = 556, .external_lex_state = 2},
  [2175] = {.lex_state = 556, .external_lex_state = 2},
  [2176] = {.lex_state = 556, .external_lex_state = 2},
  [2177] = {.lex_state = 556, .external_lex_state = 2},
  [2178] = {.lex_state = 556, .external_lex_state = 2},
  [2179] = {.lex_state = 556, .external_lex_state = 2},
  [2180] = {.lex_state = 556, .external_lex_state = 2},
  [2181] = {.lex_state = 556, .external_lex_state = 2},
  [2182] = {.lex_state = 556, .external_lex_state = 2},
  [2183] = {.lex_state = 556, .external_lex_state = 2},
  [2184] = {.lex_state = 556, .external_lex_state = 2},
  [2185] = {.lex_state = 556, .external_lex_state = 2},
  [2186] = {.lex_state = 556, .external_lex_state = 2},
  [2187] = {.lex_state = 556, .external_lex_state = 2},
  [2188] = {.lex_state = 556, .external_lex_state = 2},
  [2189] = {.lex_state = 556, .external_lex_state = 2},
  [2190] = {.lex_state = 556, .external_lex_state = 2},
  [2191] = {.lex_state = 556, .external_lex_state = 2},
  [2192] = {.lex_state = 556, .external_lex_state = 2},
  [2193] = {.lex_state = 556, .external_lex_state = 2},
  [2194] = {.lex_state = 556, .external_lex_state = 2},
  [2195] = {.lex_state = 556, .external_lex_state = 2},
  [2196] = {.lex_state = 556, .external_lex_state = 2},
  [2197] = {.lex_state = 556, .external_lex_state = 2},
  [2198] = {.lex_state = 556, .external_lex_state = 2},
  [2199] = {.lex_state = 556, .external_lex_state = 2},
  [2200] = {.lex_state = 556, .external_lex_state = 2},
  [2201] = {.lex_state = 556, .external_lex_state = 2},
  [2202] = {.lex_state = 556, .external_lex_state = 2},
  [2203] = {.lex_state = 556, .external_lex_state = 2},
  [2204] = {.lex_state = 556, .external_lex_state = 2},
  [2205] = {.lex_state = 556, .external_lex_state = 2},
  [2206] = {.lex_state = 556, .external_lex_state = 2},
  [2207] = {.lex_state = 556, .external_lex_state = 2},
  [2208] = {.lex_state = 556, .external_lex_state = 2},
  [2209] = {.lex_state = 556, .external_lex_state = 2},
  [2210] = {.lex_state = 556, .external_lex_state = 2},
  [2211] = {.lex_state = 556, .external_lex_state = 2},
  [2212] = {.lex_state = 556, .external_lex_state = 2},
  [2213] = {.lex_state = 556, .external_lex_state = 2},
  [2214] = {.lex_state = 556, .external_lex_state = 2},
  [2215] = {.lex_state = 556, .external_lex_state = 2},
  [2216] = {.lex_state = 556, .external_lex_state = 2},
  [2217] = {.lex_state = 556, .external_lex_state = 2},
  [2218] = {.lex_state = 556, .external_lex_state = 2},
  [2219] = {.lex_state = 556, .external_lex_state = 2},
  [2220] = {.lex_state = 556, .external_lex_state = 2},
  [2221] = {.lex_state = 556, .external_lex_state = 2},
  [2222] = {.lex_state = 556, .external_lex_state = 2},
  [2223] = {.lex_state = 556, .external_lex_state = 2},
  [2224] = {.lex_state = 556, .external_lex_state = 2},
  [2225] = {.lex_state = 556, .external_lex_state = 2},
  [2226] = {.lex_state = 556, .external_lex_state = 2},
  [2227] = {.lex_state = 556, .external_lex_state = 2},
  [2228] = {.lex_state = 556, .external_lex_state = 2},
  [2229] = {.lex_state = 556, .external_lex_state = 2},
  [2230] = {.lex_state = 556, .external_lex_state = 2},
  [2231] = {.lex_state = 556, .external_lex_state = 2},
  [2232] = {.lex_state = 556, .external_lex_state = 2},
  [2233] = {.lex_state = 556, .external_lex_state = 2},
  [2234] = {.lex_state = 556, .external_lex_state = 2},
  [2235] = {.lex_state = 556, .external_lex_state = 2},
  [2236] = {.lex_state = 556, .external_lex_state = 2},
  [2237] = {.lex_state = 556, .external_lex_state = 2},
  [2238] = {.lex_state = 556, .external_lex_state = 2},
  [2239] = {.lex_state = 556, .external_lex_state = 2},
  [2240] = {.lex_state = 556, .external_lex_state = 2},
  [2241] = {.lex_state = 556, .external_lex_state = 2},
  [2242] = {.lex_state = 556, .external_lex_state = 2},
  [2243] = {.lex_state = 556, .external_lex_state = 2},
  [2244] = {.lex_state = 556, .external_lex_state = 2},
  [2245] = {.lex_state = 556, .external_lex_state = 2},
  [2246] = {.lex_state = 556, .external_lex_state = 2},
  [2247] = {.lex_state = 556, .external_lex_state = 2},
  [2248] = {.lex_state = 556, .external_lex_state = 2},
  [2249] = {.lex_state = 556, .external_lex_state = 2},
  [2250] = {.lex_state = 556, .external_lex_state = 2},
  [2251] = {.lex_state = 556, .external_lex_state = 2},
  [2252] = {.lex_state = 556, .external_lex_state = 2},
  [2253] = {.lex_state = 556, .external_lex_state = 2},
  [2254] = {.lex_state = 556, .external_lex_state = 2},
  [2255] = {.lex_state = 556, .external_lex_state = 2},
  [2256] = {.lex_state = 556, .external_lex_state = 2},
  [2257] = {.lex_state = 556, .external_lex_state = 2},
  [2258] = {.lex_state = 556, .external_lex_state = 2},
  [2259] = {.lex_state = 556, .external_lex_state = 2},
  [2260] = {.lex_state = 556, .external_lex_state = 2},
  [2261] = {.lex_state = 556, .external_lex_state = 2},
  [2262] = {.lex_state = 556, .external_lex_state = 2},
  [2263] = {.lex_state = 556, .external_lex_state = 2},
  [2264] = {.lex_state = 556, .external_lex_state = 2},
  [2265] = {.lex_state = 556, .external_lex_state = 2},
  [2266] = {.lex_state = 556, .external_lex_state = 2},
  [2267] = {.lex_state = 556, .external_lex_state = 2},
  [2268] = {.lex_state = 556, .external_lex_state = 2},
  [2269] = {.lex_state = 556, .external_lex_state = 2},
  [2270] = {.lex_state = 556, .external_lex_state = 2},
  [2271] = {.lex_state = 556, .external_lex_state = 2},
  [2272] = {.lex_state = 556, .external_lex_state = 2},
  [2273] = {.lex_state = 556, .external_lex_state = 2},
  [2274] = {.lex_state = 556, .external_lex_state = 2},
  [2275] = {.lex_state = 556, .external_lex_state = 2},
  [2276] = {.lex_state = 556, .external_lex_state = 2},
  [2277] = {.lex_state = 556, .external_lex_state = 2},
  [2278] = {.lex_state = 556, .external_lex_state = 2},
  [2279] = {.lex_state = 556, .external_lex_state = 2},
  [2280] = {.lex_state = 556, .external_lex_state = 2},
  [2281] = {.lex_state = 556, .external_lex_state = 2},
  [2282] = {.lex_state = 556, .external_lex_state = 2},
  [2283] = {.lex_state = 556, .external_lex_state = 2},
  [2284] = {.lex_state = 556, .external_lex_state = 2},
  [2285] = {.lex_state = 556, .external_lex_state = 2},
  [2286] = {.lex_state = 556, .external_lex_state = 2},
  [2287] = {.lex_state = 556, .external_lex_state = 2},
  [2288] = {.lex_state = 556, .external_lex_state = 2},
  [2289] = {.lex_state = 556, .external_lex_state = 2},
  [2290] = {.lex_state = 556, .external_lex_state = 2},
  [2291] = {.lex_state = 556, .external_lex_state = 2},
  [2292] = {.lex_state = 556, .external_lex_state = 2},
  [2293] = {.lex_state = 556, .external_lex_state = 2},
  [2294] = {.lex_state = 556, .external_lex_state = 2},
  [2295] = {.lex_state = 556, .external_lex_state = 2},
  [2296] = {.lex_state = 556, .external_lex_state = 2},
  [2297] = {.lex_state = 556, .external_lex_state = 2},
  [2298] = {.lex_state = 556, .external_lex_state = 2},
  [2299] = {.lex_state = 556, .external_lex_state = 2},
  [2300] = {.lex_state = 556, .external_lex_state = 2},
  [2301] = {.lex_state = 556, .external_lex_state = 2},
  [2302] = {.lex_state = 556, .external_lex_state = 2},
  [2303] = {.lex_state = 556, .external_lex_state = 2},
  [2304] = {.lex_state = 556, .external_lex_state = 2},
  [2305] = {.lex_state = 556, .external_lex_state = 2},
  [2306] = {.lex_state = 556, .external_lex_state = 2},
  [2307] = {.lex_state = 556, .external_lex_state = 2},
  [2308] = {.lex_state = 556, .external_lex_state = 2},
  [2309] = {.lex_state = 556, .external_lex_state = 2},
  [2310] = {.lex_state = 556, .external_lex_state = 2},
  [2311] = {.lex_state = 556, .external_lex_state = 2},
  [2312] = {.lex_state = 556, .external_lex_state = 2},
  [2313] = {.lex_state = 556, .external_lex_state = 2},
  [2314] = {.lex_state = 556, .external_lex_state = 2},
  [2315] = {.lex_state = 556, .external_lex_state = 2},
  [2316] = {.lex_state = 556, .external_lex_state = 2},
  [2317] = {.lex_state = 556, .external_lex_state = 2},
  [2318] = {.lex_state = 556, .external_lex_state = 2},
  [2319] = {.lex_state = 556, .external_lex_state = 2},
  [2320] = {.lex_state = 556, .external_lex_state = 2},
  [2321] = {.lex_state = 556, .external_lex_state = 2},
  [2322] = {.lex_state = 556, .external_lex_state = 2},
  [2323] = {.lex_state = 556, .external_lex_state = 2},
  [2324] = {.lex_state = 556, .external_lex_state = 2},
  [2325] = {.lex_state = 556, .external_lex_state = 2},
  [2326] = {.lex_state = 556, .external_lex_state = 2},
  [2327] = {.lex_state = 556, .external_lex_state = 2},
  [2328] = {.lex_state = 556, .external_lex_state = 2},
  [2329] = {.lex_state = 556, .external_lex_state = 2},
  [2330] = {.lex_state = 556, .external_lex_state = 2},
  [2331] = {.lex_state = 556, .external_lex_state = 2},
  [2332] = {.lex_state = 556, .external_lex_state = 2},
  [2333] = {.lex_state = 556, .external_lex_state = 2},
  [2334] = {.lex_state = 556, .external_lex_state = 2},
  [2335] = {.lex_state = 556, .external_lex_state = 2},
  [2336] = {.lex_state = 556, .external_lex_state = 2},
  [2337] = {.lex_state = 556, .external_lex_state = 2},
  [2338] = {.lex_state = 556, .external_lex_state = 2},
  [2339] = {.lex_state = 556, .external_lex_state = 2},
  [2340] = {.lex_state = 556, .external_lex_state = 2},
  [2341] = {.lex_state = 556, .external_lex_state = 2},
  [2342] = {.lex_state = 556, .external_lex_state = 2},
  [2343] = {.lex_state = 556, .external_lex_state = 2},
  [2344] = {.lex_state = 556, .external_lex_state = 2},
  [2345] = {.lex_state = 556, .external_lex_state = 2},
  [2346] = {.lex_state = 556, .external_lex_state = 2},
  [2347] = {.lex_state = 556, .external_lex_state = 2},
  [2348] = {.lex_state = 556, .external_lex_state = 2},
  [2349] = {.lex_state = 556, .external_lex_state = 2},
  [2350] = {.lex_state = 556, .external_lex_state = 2},
  [2351] = {.lex_state = 556, .external_lex_state = 2},
  [2352] = {.lex_state = 556, .external_lex_state = 2},
  [2353] = {.lex_state = 556, .external_lex_state = 2},
  [2354] = {.lex_state = 556, .external_lex_state = 2},
  [2355] = {.lex_state = 556, .external_lex_state = 2},
  [2356] = {.lex_state = 556, .external_lex_state = 2},
  [2357] = {.lex_state = 556, .external_lex_state = 2},
  [2358] = {.lex_state = 556, .external_lex_state = 2},
  [2359] = {.lex_state = 556, .external_lex_state = 2},
  [2360] = {.lex_state = 556, .external_lex_state = 2},
  [2361] = {.lex_state = 556, .external_lex_state = 2},
  [2362] = {.lex_state = 556, .external_lex_state = 2},
  [2363] = {.lex_state = 556, .external_lex_state = 2},
  [2364] = {.lex_state = 556, .external_lex_state = 2},
  [2365] = {.lex_state = 556, .external_lex_state = 2},
  [2366] = {.lex_state = 556, .external_lex_state = 2},
  [2367] = {.lex_state = 556, .external_lex_state = 2},
  [2368] = {.lex_state = 556, .external_lex_state = 2},
  [2369] = {.lex_state = 556, .external_lex_state = 2},
  [2370] = {.lex_state = 556, .external_lex_state = 2},
  [2371] = {.lex_state = 556, .external_lex_state = 2},
  [2372] = {.lex_state = 556, .external_lex_state = 2},
  [2373] = {.lex_state = 556, .external_lex_state = 2},
  [2374] = {.lex_state = 556, .external_lex_state = 2},
  [2375] = {.lex_state = 556, .external_lex_state = 2},
  [2376] = {.lex_state = 556, .external_lex_state = 2},
  [2377] = {.lex_state = 556, .external_lex_state = 2},
  [2378] = {.lex_state = 556, .external_lex_state = 2},
  [2379] = {.lex_state = 556, .external_lex_state = 2},
  [2380] = {.lex_state = 556, .external_lex_state = 2},
  [2381] = {.lex_state = 556, .external_lex_state = 2},
  [2382] = {.lex_state = 556, .external_lex_state = 2},
  [2383] = {.lex_state = 556, .external_lex_state = 2},
  [2384] = {.lex_state = 556, .external_lex_state = 2},
  [2385] = {.lex_state = 556, .external_lex_state = 2},
  [2386] = {.lex_state = 556, .external_lex_state = 2},
  [2387] = {.lex_state = 556, .external_lex_state = 2},
  [2388] = {.lex_state = 556, .external_lex_state = 2},
  [2389] = {.lex_state = 556, .external_lex_state = 2},
  [2390] = {.lex_state = 556, .external_lex_state = 2},
  [2391] = {.lex_state = 556, .external_lex_state = 2},
  [2392] = {.lex_state = 556, .external_lex_state = 2},
  [2393] = {.lex_state = 556, .external_lex_state = 2},
  [2394] = {.lex_state = 556, .external_lex_state = 2},
  [2395] = {.lex_state = 556, .external_lex_state = 2},
  [2396] = {.lex_state = 556, .external_lex_state = 2},
  [2397] = {.lex_state = 556, .external_lex_state = 2},
  [2398] = {.lex_state = 556, .external_lex_state = 2},
  [2399] = {.lex_state = 556, .external_lex_state = 2},
  [2400] = {.lex_state = 556, .external_lex_state = 2},
  [2401] = {.lex_state = 556, .external_lex_state = 2},
  [2402] = {.lex_state = 556, .external_lex_state = 2},
  [2403] = {.lex_state = 556, .external_lex_state = 2},
  [2404] = {.lex_state = 556, .external_lex_state = 2},
  [2405] = {.lex_state = 556, .external_lex_state = 2},
  [2406] = {.lex_state = 556, .external_lex_state = 2},
  [2407] = {.lex_state = 556, .external_lex_state = 2},
  [2408] = {.lex_state = 556, .external_lex_state = 2},
  [2409] = {.lex_state = 556, .external_lex_state = 2},
  [2410] = {.lex_state = 556, .external_lex_state = 2},
  [2411] = {.lex_state = 556, .external_lex_state = 2},
  [2412] = {.lex_state = 556, .external_lex_state = 2},
  [2413] = {.lex_state = 556, .external_lex_state = 2},
  [2414] = {.lex_state = 556, .external_lex_state = 2},
  [2415] = {.lex_state = 556, .external_lex_state = 2},
  [2416] = {.lex_state = 556, .external_lex_state = 2},
  [2417] = {.lex_state = 556, .external_lex_state = 2},
  [2418] = {.lex_state = 556, .external_lex_state = 2},
  [2419] = {.lex_state = 556, .external_lex_state = 2},
  [2420] = {.lex_state = 556, .external_lex_state = 2},
  [2421] = {.lex_state = 556, .external_lex_state = 2},
  [2422] = {.lex_state = 556, .external_lex_state = 2},
  [2423] = {.lex_state = 556, .external_lex_state = 2},
  [2424] = {.lex_state = 556, .external_lex_state = 2},
  [2425] = {.lex_state = 556, .external_lex_state = 2},
  [2426] = {.lex_state = 556, .external_lex_state = 2},
  [2427] = {.lex_state = 556, .external_lex_state = 2},
  [2428] = {.lex_state = 556, .external_lex_state = 2},
  [2429] = {.lex_state = 556, .external_lex_state = 2},
  [2430] = {.lex_state = 556, .external_lex_state = 2},
  [2431] = {.lex_state = 556, .external_lex_state = 2},
  [2432] = {.lex_state = 556, .external_lex_state = 2},
  [2433] = {.lex_state = 556, .external_lex_state = 2},
  [2434] = {.lex_state = 556, .external_lex_state = 2},
  [2435] = {.lex_state = 556, .external_lex_state = 2},
  [2436] = {.lex_state = 556, .external_lex_state = 2},
  [2437] = {.lex_state = 556, .external_lex_state = 2},
  [2438] = {.lex_state = 556, .external_lex_state = 2},
  [2439] = {.lex_state = 556, .external_lex_state = 2},
  [2440] = {.lex_state = 556, .external_lex_state = 2},
  [2441] = {.lex_state = 556, .external_lex_state = 2},
  [2442] = {.lex_state = 556, .external_lex_state = 2},
  [2443] = {.lex_state = 556, .external_lex_state = 2},
  [2444] = {.lex_state = 556, .external_lex_state = 2},
  [2445] = {.lex_state = 556, .external_lex_state = 2},
  [2446] = {.lex_state = 556, .external_lex_state = 2},
  [2447] = {.lex_state = 556, .external_lex_state = 2},
  [2448] = {.lex_state = 556, .external_lex_state = 2},
  [2449] = {.lex_state = 556, .external_lex_state = 2},
  [2450] = {.lex_state = 556, .external_lex_state = 2},
  [2451] = {.lex_state = 556, .external_lex_state = 2},
  [2452] = {.lex_state = 556, .external_lex_state = 2},
  [2453] = {.lex_state = 556, .external_lex_state = 2},
  [2454] = {.lex_state = 556, .external_lex_state = 2},
  [2455] = {.lex_state = 556, .external_lex_state = 2},
  [2456] = {.lex_state = 556, .external_lex_state = 2},
  [2457] = {.lex_state = 556, .external_lex_state = 2},
  [2458] = {.lex_state = 556, .external_lex_state = 2},
  [2459] = {.lex_state = 556, .external_lex_state = 2},
  [2460] = {.lex_state = 556, .external_lex_state = 2},
  [2461] = {.lex_state = 556, .external_lex_state = 2},
  [2462] = {.lex_state = 556, .external_lex_state = 2},
  [2463] = {.lex_state = 556, .external_lex_state = 2},
  [2464] = {.lex_state = 556, .external_lex_state = 2},
  [2465] = {.lex_state = 556, .external_lex_state = 2},
  [2466] = {.lex_state = 556, .external_lex_state = 2},
  [2467] = {.lex_state = 556, .external_lex_state = 2},
  [2468] = {.lex_state = 556, .external_lex_state = 2},
  [2469] = {.lex_state = 556, .external_lex_state = 2},
  [2470] = {.lex_state = 556, .external_lex_state = 2},
  [2471] = {.lex_state = 556, .external_lex_state = 2},
  [2472] = {.lex_state = 556, .external_lex_state = 2},
  [2473] = {.lex_state = 556, .external_lex_state = 2},
  [2474] = {.lex_state = 556, .external_lex_state = 2},
  [2475] = {.lex_state = 556, .external_lex_state = 2},
  [2476] = {.lex_state = 556, .external_lex_state = 2},
  [2477] = {.lex_state = 556, .external_lex_state = 2},
  [2478] = {.lex_state = 556, .external_lex_state = 2},
  [2479] = {.lex_state = 556, .external_lex_state = 2},
  [2480] = {.lex_state = 556, .external_lex_state = 2},
  [2481] = {.lex_state = 556, .external_lex_state = 2},
  [2482] = {.lex_state = 556, .external_lex_state = 2},
  [2483] = {.lex_state = 556, .external_lex_state = 2},
  [2484] = {.lex_state = 556, .external_lex_state = 2},
  [2485] = {.lex_state = 556, .external_lex_state = 2},
  [2486] = {.lex_state = 556, .external_lex_state = 2},
  [2487] = {.lex_state = 556, .external_lex_state = 2},
  [2488] = {.lex_state = 556, .external_lex_state = 2},
  [2489] = {.lex_state = 556, .external_lex_state = 2},
  [2490] = {.lex_state = 556, .external_lex_state = 2},
  [2491] = {.lex_state = 556, .external_lex_state = 2},
  [2492] = {.lex_state = 556, .external_lex_state = 2},
  [2493] = {.lex_state = 556, .external_lex_state = 2},
  [2494] = {.lex_state = 556, .external_lex_state = 2},
  [2495] = {.lex_state = 556, .external_lex_state = 2},
  [2496] = {.lex_state = 556, .external_lex_state = 2},
  [2497] = {.lex_state = 556, .external_lex_state = 2},
  [2498] = {.lex_state = 556, .external_lex_state = 2},
  [2499] = {.lex_state = 556, .external_lex_state = 2},
  [2500] = {.lex_state = 556, .external_lex_state = 2},
  [2501] = {.lex_state = 556, .external_lex_state = 2},
  [2502] = {.lex_state = 556, .external_lex_state = 2},
  [2503] = {.lex_state = 556, .external_lex_state = 2},
  [2504] = {.lex_state = 556, .external_lex_state = 2},
  [2505] = {.lex_state = 556, .external_lex_state = 2},
  [2506] = {.lex_state = 556, .external_lex_state = 2},
  [2507] = {.lex_state = 556, .external_lex_state = 2},
  [2508] = {.lex_state = 556, .external_lex_state = 2},
  [2509] = {.lex_state = 556, .external_lex_state = 2},
  [2510] = {.lex_state = 556, .external_lex_state = 2},
  [2511] = {.lex_state = 556, .external_lex_state = 2},
  [2512] = {.lex_state = 556, .external_lex_state = 2},
  [2513] = {.lex_state = 556, .external_lex_state = 2},
  [2514] = {.lex_state = 556, .external_lex_state = 2},
  [2515] = {.lex_state = 556, .external_lex_state = 2},
  [2516] = {.lex_state = 556, .external_lex_state = 2},
  [2517] = {.lex_state = 556, .external_lex_state = 2},
  [2518] = {.lex_state = 556, .external_lex_state = 2},
  [2519] = {.lex_state = 556, .external_lex_state = 2},
  [2520] = {.lex_state = 556, .external_lex_state = 2},
  [2521] = {.lex_state = 556, .external_lex_state = 2},
  [2522] = {.lex_state = 556, .external_lex_state = 2},
  [2523] = {.lex_state = 556, .external_lex_state = 2},
  [2524] = {.lex_state = 556, .external_lex_state = 2},
  [2525] = {.lex_state = 556, .external_lex_state = 2},
  [2526] = {.lex_state = 556, .external_lex_state = 2},
  [2527] = {.lex_state = 556, .external_lex_state = 2},
  [2528] = {.lex_state = 556, .external_lex_state = 2},
  [2529] = {.lex_state = 556, .external_lex_state = 2},
  [2530] = {.lex_state = 556, .external_lex_state = 2},
  [2531] = {.lex_state = 556, .external_lex_state = 2},
  [2532] = {.lex_state = 556, .external_lex_state = 2},
  [2533] = {.lex_state = 556, .external_lex_state = 2},
  [2534] = {.lex_state = 556, .external_lex_state = 2},
  [2535] = {.lex_state = 556, .external_lex_state = 2},
  [2536] = {.lex_state = 556, .external_lex_state = 2},
  [2537] = {.lex_state = 556, .external_lex_state = 2},
  [2538] = {.lex_state = 556, .external_lex_state = 2},
  [2539] = {.lex_state = 556, .external_lex_state = 2},
  [2540] = {.lex_state = 556, .external_lex_state = 2},
  [2541] = {.lex_state = 556, .external_lex_state = 2},
  [2542] = {.lex_state = 556, .external_lex_state = 2},
  [2543] = {.lex_state = 556, .external_lex_state = 2},
  [2544] = {.lex_state = 556, .external_lex_state = 2},
  [2545] = {.lex_state = 556, .external_lex_state = 2},
  [2546] = {.lex_state = 556, .external_lex_state = 2},
  [2547] = {.lex_state = 556, .external_lex_state = 2},
  [2548] = {.lex_state = 556, .external_lex_state = 2},
  [2549] = {.lex_state = 556, .external_lex_state = 2},
  [2550] = {.lex_state = 556, .external_lex_state = 2},
  [2551] = {.lex_state = 556, .external_lex_state = 2},
  [2552] = {.lex_state = 556, .external_lex_state = 2},
  [2553] = {.lex_state = 556, .external_lex_state = 2},
  [2554] = {.lex_state = 556, .external_lex_state = 2},
  [2555] = {.lex_state = 556, .external_lex_state = 2},
  [2556] = {.lex_state = 556, .external_lex_state = 2},
  [2557] = {.lex_state = 556, .external_lex_state = 2},
  [2558] = {.lex_state = 556, .external_lex_state = 2},
  [2559] = {.lex_state = 556, .external_lex_state = 2},
  [2560] = {.lex_state = 556, .external_lex_state = 2},
  [2561] = {.lex_state = 556, .external_lex_state = 2},
  [2562] = {.lex_state = 556, .external_lex_state = 2},
  [2563] = {.lex_state = 556, .external_lex_state = 2},
  [2564] = {.lex_state = 556, .external_lex_state = 2},
  [2565] = {.lex_state = 556, .external_lex_state = 2},
  [2566] = {.lex_state = 556, .external_lex_state = 2},
  [2567] = {.lex_state = 556, .external_lex_state = 2},
  [2568] = {.lex_state = 556, .external_lex_state = 2},
  [2569] = {.lex_state = 556, .external_lex_state = 2},
  [2570] = {.lex_state = 556, .external_lex_state = 2},
  [2571] = {.lex_state = 556, .external_lex_state = 2},
  [2572] = {.lex_state = 556, .external_lex_state = 2},
  [2573] = {.lex_state = 556, .external_lex_state = 2},
  [2574] = {.lex_state = 556, .external_lex_state = 2},
  [2575] = {.lex_state = 556, .external_lex_state = 2},
  [2576] = {.lex_state = 556, .external_lex_state = 2},
  [2577] = {.lex_state = 556, .external_lex_state = 2},
  [2578] = {.lex_state = 556, .external_lex_state = 2},
  [2579] = {.lex_state = 556, .external_lex_state = 2},
  [2580] = {.lex_state = 556, .external_lex_state = 2},
  [2581] = {.lex_state = 556, .external_lex_state = 2},
  [2582] = {.lex_state = 556, .external_lex_state = 2},
  [2583] = {.lex_state = 556, .external_lex_state = 2},
  [2584] = {.lex_state = 556, .external_lex_state = 2},
  [2585] = {.lex_state = 556, .external_lex_state = 2},
  [2586] = {.lex_state = 556, .external_lex_state = 2},
  [2587] = {.lex_state = 556, .external_lex_state = 2},
  [2588] = {.lex_state = 556, .external_lex_state = 2},
  [2589] = {.lex_state = 556, .external_lex_state = 2},
  [2590] = {.lex_state = 556, .external_lex_state = 2},
  [2591] = {.lex_state = 556, .external_lex_state = 2},
  [2592] = {.lex_state = 556, .external_lex_state = 2},
  [2593] = {.lex_state = 556, .external_lex_state = 2},
  [2594] = {.lex_state = 556, .external_lex_state = 2},
  [2595] = {.lex_state = 556, .external_lex_state = 2},
  [2596] = {.lex_state = 556, .external_lex_state = 2},
  [2597] = {.lex_state = 556, .external_lex_state = 2},
  [2598] = {.lex_state = 556, .external_lex_state = 2},
  [2599] = {.lex_state = 556, .external_lex_state = 2},
  [2600] = {.lex_state = 556, .external_lex_state = 2},
  [2601] = {.lex_state = 556, .external_lex_state = 2},
  [2602] = {.lex_state = 556, .external_lex_state = 2},
  [2603] = {.lex_state = 556, .external_lex_state = 2},
  [2604] = {.lex_state = 556, .external_lex_state = 2},
  [2605] = {.lex_state = 556, .external_lex_state = 2},
  [2606] = {.lex_state = 556, .external_lex_state = 2},
  [2607] = {.lex_state = 556, .external_lex_state = 2},
  [2608] = {.lex_state = 556, .external_lex_state = 2},
  [2609] = {.lex_state = 556, .external_lex_state = 2},
  [2610] = {.lex_state = 556, .external_lex_state = 2},
  [2611] = {.lex_state = 556, .external_lex_state = 2},
  [2612] = {.lex_state = 556, .external_lex_state = 2},
  [2613] = {.lex_state = 556, .external_lex_state = 2},
  [2614] = {.lex_state = 556, .external_lex_state = 2},
  [2615] = {.lex_state = 556, .external_lex_state = 2},
  [2616] = {.lex_state = 556, .external_lex_state = 2},
  [2617] = {.lex_state = 556, .external_lex_state = 2},
  [2618] = {.lex_state = 556, .external_lex_state = 2},
  [2619] = {.lex_state = 556, .external_lex_state = 2},
  [2620] = {.lex_state = 556, .external_lex_state = 2},
  [2621] = {.lex_state = 556, .external_lex_state = 2},
  [2622] = {.lex_state = 556, .external_lex_state = 2},
  [2623] = {.lex_state = 556, .external_lex_state = 2},
  [2624] = {.lex_state = 556, .external_lex_state = 2},
  [2625] = {.lex_state = 556, .external_lex_state = 2},
  [2626] = {.lex_state = 556, .external_lex_state = 2},
  [2627] = {.lex_state = 556, .external_lex_state = 2},
  [2628] = {.lex_state = 556, .external_lex_state = 2},
  [2629] = {.lex_state = 556, .external_lex_state = 2},
  [2630] = {.lex_state = 556, .external_lex_state = 2},
  [2631] = {.lex_state = 556, .external_lex_state = 2},
  [2632] = {.lex_state = 556, .external_lex_state = 2},
  [2633] = {.lex_state = 556, .external_lex_state = 2},
  [2634] = {.lex_state = 556, .external_lex_state = 2},
  [2635] = {.lex_state = 556, .external_lex_state = 2},
  [2636] = {.lex_state = 556, .external_lex_state = 2},
  [2637] = {.lex_state = 556, .external_lex_state = 2},
  [2638] = {.lex_state = 556, .external_lex_state = 2},
  [2639] = {.lex_state = 556, .external_lex_state = 2},
  [2640] = {.lex_state = 556, .external_lex_state = 2},
  [2641] = {.lex_state = 556, .external_lex_state = 2},
  [2642] = {.lex_state = 556, .external_lex_state = 2},
  [2643] = {.lex_state = 556, .external_lex_state = 2},
  [2644] = {.lex_state = 556, .external_lex_state = 2},
  [2645] = {.lex_state = 556, .external_lex_state = 2},
  [2646] = {.lex_state = 556, .external_lex_state = 2},
  [2647] = {.lex_state = 556, .external_lex_state = 2},
  [2648] = {.lex_state = 556, .external_lex_state = 2},
  [2649] = {.lex_state = 556, .external_lex_state = 2},
  [2650] = {.lex_state = 556, .external_lex_state = 2},
  [2651] = {.lex_state = 556, .external_lex_state = 2},
  [2652] = {.lex_state = 556, .external_lex_state = 2},
  [2653] = {.lex_state = 556, .external_lex_state = 2},
  [2654] = {.lex_state = 556, .external_lex_state = 2},
  [2655] = {.lex_state = 556, .external_lex_state = 2},
  [2656] = {.lex_state = 556, .external_lex_state = 2},
  [2657] = {.lex_state = 556, .external_lex_state = 2},
  [2658] = {.lex_state = 556, .external_lex_state = 2},
  [2659] = {.lex_state = 556, .external_lex_state = 2},
  [2660] = {.lex_state = 556, .external_lex_state = 2},
  [2661] = {.lex_state = 556, .external_lex_state = 2},
  [2662] = {.lex_state = 556, .external_lex_state = 2},
  [2663] = {.lex_state = 556, .external_lex_state = 2},
  [2664] = {.lex_state = 556, .external_lex_state = 2},
  [2665] = {.lex_state = 556, .external_lex_state = 2},
  [2666] = {.lex_state = 556, .external_lex_state = 2},
  [2667] = {.lex_state = 556, .external_lex_state = 2},
  [2668] = {.lex_state = 556, .external_lex_state = 2},
  [2669] = {.lex_state = 556, .external_lex_state = 2},
  [2670] = {.lex_state = 556, .external_lex_state = 2},
  [2671] = {.lex_state = 556, .external_lex_state = 2},
  [2672] = {.lex_state = 556, .external_lex_state = 2},
  [2673] = {.lex_state = 556, .external_lex_state = 2},
  [2674] = {.lex_state = 556, .external_lex_state = 2},
  [2675] = {.lex_state = 556, .external_lex_state = 2},
  [2676] = {.lex_state = 556, .external_lex_state = 2},
  [2677] = {.lex_state = 556, .external_lex_state = 2},
  [2678] = {.lex_state = 556, .external_lex_state = 2},
  [2679] = {.lex_state = 556, .external_lex_state = 2},
  [2680] = {.lex_state = 556, .external_lex_state = 2},
  [2681] = {.lex_state = 556, .external_lex_state = 2},
  [2682] = {.lex_state = 556, .external_lex_state = 2},
  [2683] = {.lex_state = 556, .external_lex_state = 2},
  [2684] = {.lex_state = 556, .external_lex_state = 2},
  [2685] = {.lex_state = 556, .external_lex_state = 2},
  [2686] = {.lex_state = 556, .external_lex_state = 2},
  [2687] = {.lex_state = 556, .external_lex_state = 2},
  [2688] = {.lex_state = 556, .external_lex_state = 2},
  [2689] = {.lex_state = 556, .external_lex_state = 2},
  [2690] = {.lex_state = 556, .external_lex_state = 2},
  [2691] = {.lex_state = 556, .external_lex_state = 2},
  [2692] = {.lex_state = 556, .external_lex_state = 2},
  [2693] = {.lex_state = 556, .external_lex_state = 2},
  [2694] = {.lex_state = 556, .external_lex_state = 2},
  [2695] = {.lex_state = 556, .external_lex_state = 2},
  [2696] = {.lex_state = 556, .external_lex_state = 2},
  [2697] = {.lex_state = 556, .external_lex_state = 2},
  [2698] = {.lex_state = 556, .external_lex_state = 2},
  [2699] = {.lex_state = 556, .external_lex_state = 2},
  [2700] = {.lex_state = 556, .external_lex_state = 2},
  [2701] = {.lex_state = 556, .external_lex_state = 2},
  [2702] = {.lex_state = 556, .external_lex_state = 2},
  [2703] = {.lex_state = 556, .external_lex_state = 2},
  [2704] = {.lex_state = 556, .external_lex_state = 2},
  [2705] = {.lex_state = 556, .external_lex_state = 2},
  [2706] = {.lex_state = 556, .external_lex_state = 2},
  [2707] = {.lex_state = 556, .external_lex_state = 2},
  [2708] = {.lex_state = 556, .external_lex_state = 2},
  [2709] = {.lex_state = 556, .external_lex_state = 2},
  [2710] = {.lex_state = 556, .external_lex_state = 2},
  [2711] = {.lex_state = 556, .external_lex_state = 2},
  [2712] = {.lex_state = 556, .external_lex_state = 2},
  [2713] = {.lex_state = 556, .external_lex_state = 2},
  [2714] = {.lex_state = 556, .external_lex_state = 2},
  [2715] = {.lex_state = 556, .external_lex_state = 2},
  [2716] = {.lex_state = 556, .external_lex_state = 2},
  [2717] = {.lex_state = 556, .external_lex_state = 2},
  [2718] = {.lex_state = 556, .external_lex_state = 2},
  [2719] = {.lex_state = 556, .external_lex_state = 2},
  [2720] = {.lex_state = 556, .external_lex_state = 2},
  [2721] = {.lex_state = 556, .external_lex_state = 2},
  [2722] = {.lex_state = 556, .external_lex_state = 2},
  [2723] = {.lex_state = 556, .external_lex_state = 2},
  [2724] = {.lex_state = 556, .external_lex_state = 2},
  [2725] = {.lex_state = 556, .external_lex_state = 2},
  [2726] = {.lex_state = 556, .external_lex_state = 2},
  [2727] = {.lex_state = 556, .external_lex_state = 2},
  [2728] = {.lex_state = 556, .external_lex_state = 2},
  [2729] = {.lex_state = 556, .external_lex_state = 2},
  [2730] = {.lex_state = 556, .external_lex_state = 2},
  [2731] = {.lex_state = 556, .external_lex_state = 2},
  [2732] = {.lex_state = 556, .external_lex_state = 2},
  [2733] = {.lex_state = 556, .external_lex_state = 2},
  [2734] = {.lex_state = 556, .external_lex_state = 2},
  [2735] = {.lex_state = 556, .external_lex_state = 2},
  [2736] = {.lex_state = 556, .external_lex_state = 2},
  [2737] = {.lex_state = 556, .external_lex_state = 2},
  [2738] = {.lex_state = 556, .external_lex_state = 2},
  [2739] = {.lex_state = 556, .external_lex_state = 2},
  [2740] = {.lex_state = 556, .external_lex_state = 2},
  [2741] = {.lex_state = 556, .external_lex_state = 2},
  [2742] = {.lex_state = 556, .external_lex_state = 2},
  [2743] = {.lex_state = 556, .external_lex_state = 2},
  [2744] = {.lex_state = 556, .external_lex_state = 2},
  [2745] = {.lex_state = 556, .external_lex_state = 2},
  [2746] = {.lex_state = 556, .external_lex_state = 2},
  [2747] = {.lex_state = 556, .external_lex_state = 2},
  [2748] = {.lex_state = 556, .external_lex_state = 2},
  [2749] = {.lex_state = 556, .external_lex_state = 2},
  [2750] = {.lex_state = 556, .external_lex_state = 2},
  [2751] = {.lex_state = 556, .external_lex_state = 2},
  [2752] = {.lex_state = 556, .external_lex_state = 2},
  [2753] = {.lex_state = 556, .external_lex_state = 2},
  [2754] = {.lex_state = 556, .external_lex_state = 2},
  [2755] = {.lex_state = 556, .external_lex_state = 2},
  [2756] = {.lex_state = 556, .external_lex_state = 2},
  [2757] = {.lex_state = 556, .external_lex_state = 2},
  [2758] = {.lex_state = 556, .external_lex_state = 2},
  [2759] = {.lex_state = 556, .external_lex_state = 2},
  [2760] = {.lex_state = 556, .external_lex_state = 2},
  [2761] = {.lex_state = 556, .external_lex_state = 2},
  [2762] = {.lex_state = 556, .external_lex_state = 2},
  [2763] = {.lex_state = 556, .external_lex_state = 2},
  [2764] = {.lex_state = 556, .external_lex_state = 2},
  [2765] = {.lex_state = 556, .external_lex_state = 2},
  [2766] = {.lex_state = 556, .external_lex_state = 2},
  [2767] = {.lex_state = 556, .external_lex_state = 2},
  [2768] = {.lex_state = 556, .external_lex_state = 2},
  [2769] = {.lex_state = 556, .external_lex_state = 2},
  [2770] = {.lex_state = 556, .external_lex_state = 2},
  [2771] = {.lex_state = 556, .external_lex_state = 2},
  [2772] = {.lex_state = 556, .external_lex_state = 2},
  [2773] = {.lex_state = 556, .external_lex_state = 2},
  [2774] = {.lex_state = 556, .external_lex_state = 2},
  [2775] = {.lex_state = 556, .external_lex_state = 2},
  [2776] = {.lex_state = 556, .external_lex_state = 2},
  [2777] = {.lex_state = 556, .external_lex_state = 2},
  [2778] = {.lex_state = 556, .external_lex_state = 2},
  [2779] = {.lex_state = 556, .external_lex_state = 2},
  [2780] = {.lex_state = 556, .external_lex_state = 2},
  [2781] = {.lex_state = 556, .external_lex_state = 2},
  [2782] = {.lex_state = 556, .external_lex_state = 2},
  [2783] = {.lex_state = 556, .external_lex_state = 2},
  [2784] = {.lex_state = 556, .external_lex_state = 2},
  [2785] = {.lex_state = 556, .external_lex_state = 2},
  [2786] = {.lex_state = 556, .external_lex_state = 2},
  [2787] = {.lex_state = 556, .external_lex_state = 2},
  [2788] = {.lex_state = 556, .external_lex_state = 2},
  [2789] = {.lex_state = 556, .external_lex_state = 2},
  [2790] = {.lex_state = 556, .external_lex_state = 2},
  [2791] = {.lex_state = 556, .external_lex_state = 2},
  [2792] = {.lex_state = 556, .external_lex_state = 2},
  [2793] = {.lex_state = 556, .external_lex_state = 2},
  [2794] = {.lex_state = 556, .external_lex_state = 2},
  [2795] = {.lex_state = 556, .external_lex_state = 2},
  [2796] = {.lex_state = 556, .external_lex_state = 2},
  [2797] = {.lex_state = 556, .external_lex_state = 2},
  [2798] = {.lex_state = 556, .external_lex_state = 2},
  [2799] = {.lex_state = 556, .external_lex_state = 2},
  [2800] = {.lex_state = 556, .external_lex_state = 2},
  [2801] = {.lex_state = 556, .external_lex_state = 2},
  [2802] = {.lex_state = 556, .external_lex_state = 2},
  [2803] = {.lex_state = 556, .external_lex_state = 2},
  [2804] = {.lex_state = 556, .external_lex_state = 2},
  [2805] = {.lex_state = 556, .external_lex_state = 2},
  [2806] = {.lex_state = 556, .external_lex_state = 2},
  [2807] = {.lex_state = 556, .external_lex_state = 2},
  [2808] = {.lex_state = 556, .external_lex_state = 2},
  [2809] = {.lex_state = 556, .external_lex_state = 2},
  [2810] = {.lex_state = 556, .external_lex_state = 2},
  [2811] = {.lex_state = 556, .external_lex_state = 2},
  [2812] = {.lex_state = 556, .external_lex_state = 2},
  [2813] = {.lex_state = 556, .external_lex_state = 2},
  [2814] = {.lex_state = 556, .external_lex_state = 2},
  [2815] = {.lex_state = 556, .external_lex_state = 2},
  [2816] = {.lex_state = 556, .external_lex_state = 2},
  [2817] = {.lex_state = 556, .external_lex_state = 2},
  [2818] = {.lex_state = 556, .external_lex_state = 2},
  [2819] = {.lex_state = 556, .external_lex_state = 2},
  [2820] = {.lex_state = 556, .external_lex_state = 2},
  [2821] = {.lex_state = 556, .external_lex_state = 2},
  [2822] = {.lex_state = 556, .external_lex_state = 2},
  [2823] = {.lex_state = 556, .external_lex_state = 2},
  [2824] = {.lex_state = 556, .external_lex_state = 2},
  [2825] = {.lex_state = 556, .external_lex_state = 2},
  [2826] = {.lex_state = 556, .external_lex_state = 2},
  [2827] = {.lex_state = 556, .external_lex_state = 2},
  [2828] = {.lex_state = 556, .external_lex_state = 2},
  [2829] = {.lex_state = 556, .external_lex_state = 2},
  [2830] = {.lex_state = 556, .external_lex_state = 2},
  [2831] = {.lex_state = 556, .external_lex_state = 2},
  [2832] = {.lex_state = 556, .external_lex_state = 2},
  [2833] = {.lex_state = 556, .external_lex_state = 2},
  [2834] = {.lex_state = 556, .external_lex_state = 2},
  [2835] = {.lex_state = 556, .external_lex_state = 2},
  [2836] = {.lex_state = 556, .external_lex_state = 2},
  [2837] = {.lex_state = 556, .external_lex_state = 2},
  [2838] = {.lex_state = 556, .external_lex_state = 2},
  [2839] = {.lex_state = 556, .external_lex_state = 2},
  [2840] = {.lex_state = 556, .external_lex_state = 2},
  [2841] = {.lex_state = 556, .external_lex_state = 2},
  [2842] = {.lex_state = 556, .external_lex_state = 2},
  [2843] = {.lex_state = 556, .external_lex_state = 2},
  [2844] = {.lex_state = 556, .external_lex_state = 2},
  [2845] = {.lex_state = 556, .external_lex_state = 2},
  [2846] = {.lex_state = 556, .external_lex_state = 2},
  [2847] = {.lex_state = 556, .external_lex_state = 2},
  [2848] = {.lex_state = 556, .external_lex_state = 2},
  [2849] = {.lex_state = 556, .external_lex_state = 2},
  [2850] = {.lex_state = 556, .external_lex_state = 2},
  [2851] = {.lex_state = 556, .external_lex_state = 2},
  [2852] = {.lex_state = 556, .external_lex_state = 2},
  [2853] = {.lex_state = 556, .external_lex_state = 2},
  [2854] = {.lex_state = 556, .external_lex_state = 2},
  [2855] = {.lex_state = 556, .external_lex_state = 2},
  [2856] = {.lex_state = 556, .external_lex_state = 2},
  [2857] = {.lex_state = 556, .external_lex_state = 2},
  [2858] = {.lex_state = 556, .external_lex_state = 2},
  [2859] = {.lex_state = 556, .external_lex_state = 2},
  [2860] = {.lex_state = 556, .external_lex_state = 2},
  [2861] = {.lex_state = 556, .external_lex_state = 2},
  [2862] = {.lex_state = 556, .external_lex_state = 2},
  [2863] = {.lex_state = 556, .external_lex_state = 2},
  [2864] = {.lex_state = 556, .external_lex_state = 2},
  [2865] = {.lex_state = 556, .external_lex_state = 2},
  [2866] = {.lex_state = 556, .external_lex_state = 2},
  [2867] = {.lex_state = 556, .external_lex_state = 2},
  [2868] = {.lex_state = 556, .external_lex_state = 2},
  [2869] = {.lex_state = 556, .external_lex_state = 2},
  [2870] = {.lex_state = 556, .external_lex_state = 2},
  [2871] = {.lex_state = 556, .external_lex_state = 2},
  [2872] = {.lex_state = 556, .external_lex_state = 2},
  [2873] = {.lex_state = 556, .external_lex_state = 2},
  [2874] = {.lex_state = 556, .external_lex_state = 2},
  [2875] = {.lex_state = 556, .external_lex_state = 2},
  [2876] = {.lex_state = 556, .external_lex_state = 2},
  [2877] = {.lex_state = 556, .external_lex_state = 2},
  [2878] = {.lex_state = 556, .external_lex_state = 2},
  [2879] = {.lex_state = 556, .external_lex_state = 2},
  [2880] = {.lex_state = 556, .external_lex_state = 2},
  [2881] = {.lex_state = 556, .external_lex_state = 2},
  [2882] = {.lex_state = 556, .external_lex_state = 2},
  [2883] = {.lex_state = 556, .external_lex_state = 2},
  [2884] = {.lex_state = 556, .external_lex_state = 2},
  [2885] = {.lex_state = 556, .external_lex_state = 2},
  [2886] = {.lex_state = 556, .external_lex_state = 2},
  [2887] = {.lex_state = 556, .external_lex_state = 2},
  [2888] = {.lex_state = 556, .external_lex_state = 2},
  [2889] = {.lex_state = 556, .external_lex_state = 2},
  [2890] = {.lex_state = 556, .external_lex_state = 2},
  [2891] = {.lex_state = 556, .external_lex_state = 2},
  [2892] = {.lex_state = 556, .external_lex_state = 2},
  [2893] = {.lex_state = 556, .external_lex_state = 2},
  [2894] = {.lex_state = 556, .external_lex_state = 2},
  [2895] = {.lex_state = 556, .external_lex_state = 2},
  [2896] = {.lex_state = 556, .external_lex_state = 2},
  [2897] = {.lex_state = 556, .external_lex_state = 2},
  [2898] = {.lex_state = 556, .external_lex_state = 2},
  [2899] = {.lex_state = 556, .external_lex_state = 2},
  [2900] = {.lex_state = 556, .external_lex_state = 2},
  [2901] = {.lex_state = 556, .external_lex_state = 2},
  [2902] = {.lex_state = 556, .external_lex_state = 2},
  [2903] = {.lex_state = 556, .external_lex_state = 2},
  [2904] = {.lex_state = 556, .external_lex_state = 2},
  [2905] = {.lex_state = 556, .external_lex_state = 2},
  [2906] = {.lex_state = 556, .external_lex_state = 2},
  [2907] = {.lex_state = 556, .external_lex_state = 2},
  [2908] = {.lex_state = 556, .external_lex_state = 2},
  [2909] = {.lex_state = 556, .external_lex_state = 2},
  [2910] = {.lex_state = 556, .external_lex_state = 2},
  [2911] = {.lex_state = 556, .external_lex_state = 2},
  [2912] = {.lex_state = 556, .external_lex_state = 2},
  [2913] = {.lex_state = 556, .external_lex_state = 2},
  [2914] = {.lex_state = 556, .external_lex_state = 2},
  [2915] = {.lex_state = 556, .external_lex_state = 2},
  [2916] = {.lex_state = 556, .external_lex_state = 2},
  [2917] = {.lex_state = 556, .external_lex_state = 2},
  [2918] = {.lex_state = 556, .external_lex_state = 2},
  [2919] = {.lex_state = 556, .external_lex_state = 2},
  [2920] = {.lex_state = 556, .external_lex_state = 2},
  [2921] = {.lex_state = 556, .external_lex_state = 2},
  [2922] = {.lex_state = 556, .external_lex_state = 2},
  [2923] = {.lex_state = 556, .external_lex_state = 2},
  [2924] = {.lex_state = 556, .external_lex_state = 2},
  [2925] = {.lex_state = 556, .external_lex_state = 2},
  [2926] = {.lex_state = 556, .external_lex_state = 2},
  [2927] = {.lex_state = 556, .external_lex_state = 2},
  [2928] = {.lex_state = 556, .external_lex_state = 2},
  [2929] = {.lex_state = 556, .external_lex_state = 2},
  [2930] = {.lex_state = 556, .external_lex_state = 2},
  [2931] = {.lex_state = 556, .external_lex_state = 2},
  [2932] = {.lex_state = 556, .external_lex_state = 2},
  [2933] = {.lex_state = 556, .external_lex_state = 2},
  [2934] = {.lex_state = 556, .external_lex_state = 2},
  [2935] = {.lex_state = 556, .external_lex_state = 2},
  [2936] = {.lex_state = 556, .external_lex_state = 2},
  [2937] = {.lex_state = 556, .external_lex_state = 2},
  [2938] = {.lex_state = 556, .external_lex_state = 2},
  [2939] = {.lex_state = 556, .external_lex_state = 2},
  [2940] = {.lex_state = 556, .external_lex_state = 2},
  [2941] = {.lex_state = 556, .external_lex_state = 2},
  [2942] = {.lex_state = 556, .external_lex_state = 2},
  [2943] = {.lex_state = 556, .external_lex_state = 2},
  [2944] = {.lex_state = 556, .external_lex_state = 2},
  [2945] = {.lex_state = 556, .external_lex_state = 2},
  [2946] = {.lex_state = 556, .external_lex_state = 2},
  [2947] = {.lex_state = 556, .external_lex_state = 2},
  [2948] = {.lex_state = 556, .external_lex_state = 2},
  [2949] = {.lex_state = 556, .external_lex_state = 2},
  [2950] = {.lex_state = 556, .external_lex_state = 2},
  [2951] = {.lex_state = 556, .external_lex_state = 2},
  [2952] = {.lex_state = 556, .external_lex_state = 2},
  [2953] = {.lex_state = 556, .external_lex_state = 2},
  [2954] = {.lex_state = 556, .external_lex_state = 2},
  [2955] = {.lex_state = 556, .external_lex_state = 2},
  [2956] = {.lex_state = 556, .external_lex_state = 2},
  [2957] = {.lex_state = 556, .external_lex_state = 2},
  [2958] = {.lex_state = 556, .external_lex_state = 2},
  [2959] = {.lex_state = 556, .external_lex_state = 2},
  [2960] = {.lex_state = 556, .external_lex_state = 2},
  [2961] = {.lex_state = 556, .external_lex_state = 2},
  [2962] = {.lex_state = 556, .external_lex_state = 2},
  [2963] = {.lex_state = 556, .external_lex_state = 2},
  [2964] = {.lex_state = 556, .external_lex_state = 2},
  [2965] = {.lex_state = 556, .external_lex_state = 2},
  [2966] = {.lex_state = 556, .external_lex_state = 2},
  [2967] = {.lex_state = 556, .external_lex_state = 2},
  [2968] = {.lex_state = 556, .external_lex_state = 2},
  [2969] = {.lex_state = 556, .external_lex_state = 2},
  [2970] = {.lex_state = 556, .external_lex_state = 2},
  [2971] = {.lex_state = 556, .external_lex_state = 2},
  [2972] = {.lex_state = 556, .external_lex_state = 2},
  [2973] = {.lex_state = 556, .external_lex_state = 2},
  [2974] = {.lex_state = 556, .external_lex_state = 2},
  [2975] = {.lex_state = 556, .external_lex_state = 2},
  [2976] = {.lex_state = 556, .external_lex_state = 2},
  [2977] = {.lex_state = 556, .external_lex_state = 2},
  [2978] = {.lex_state = 556, .external_lex_state = 2},
  [2979] = {.lex_state = 556, .external_lex_state = 2},
  [2980] = {.lex_state = 556, .external_lex_state = 2},
  [2981] = {.lex_state = 556, .external_lex_state = 2},
  [2982] = {.lex_state = 556, .external_lex_state = 2},
  [2983] = {.lex_state = 556, .external_lex_state = 2},
  [2984] = {.lex_state = 556, .external_lex_state = 2},
  [2985] = {.lex_state = 556, .external_lex_state = 2},
  [2986] = {.lex_state = 556, .external_lex_state = 2},
  [2987] = {.lex_state = 556, .external_lex_state = 2},
  [2988] = {.lex_state = 556, .external_lex_state = 2},
  [2989] = {.lex_state = 556, .external_lex_state = 2},
  [2990] = {.lex_state = 556, .external_lex_state = 2},
  [2991] = {.lex_state = 556, .external_lex_state = 2},
  [2992] = {.lex_state = 556, .external_lex_state = 2},
  [2993] = {.lex_state = 556, .external_lex_state = 2},
  [2994] = {.lex_state = 556, .external_lex_state = 2},
  [2995] = {.lex_state = 556, .external_lex_state = 2},
  [2996] = {.lex_state = 556, .external_lex_state = 2},
  [2997] = {.lex_state = 556, .external_lex_state = 2},
  [2998] = {.lex_state = 556, .external_lex_state = 2},
  [2999] = {.lex_state = 556, .external_lex_state = 2},
  [3000] = {.lex_state = 556, .external_lex_state = 2},
  [3001] = {.lex_state = 556, .external_lex_state = 2},
  [3002] = {.lex_state = 556, .external_lex_state = 2},
  [3003] = {.lex_state = 556, .external_lex_state = 2},
  [3004] = {.lex_state = 556, .external_lex_state = 2},
  [3005] = {.lex_state = 556, .external_lex_state = 2},
  [3006] = {.lex_state = 556, .external_lex_state = 2},
  [3007] = {.lex_state = 556, .external_lex_state = 2},
  [3008] = {.lex_state = 556, .external_lex_state = 2},
  [3009] = {.lex_state = 556, .external_lex_state = 2},
  [3010] = {.lex_state = 556, .external_lex_state = 2},
  [3011] = {.lex_state = 556, .external_lex_state = 2},
  [3012] = {.lex_state = 556, .external_lex_state = 2},
  [3013] = {.lex_state = 556, .external_lex_state = 2},
  [3014] = {.lex_state = 556, .external_lex_state = 2},
  [3015] = {.lex_state = 556, .external_lex_state = 2},
  [3016] = {.lex_state = 556, .external_lex_state = 2},
  [3017] = {.lex_state = 556, .external_lex_state = 2},
  [3018] = {.lex_state = 556, .external_lex_state = 2},
  [3019] = {.lex_state = 556, .external_lex_state = 2},
  [3020] = {.lex_state = 556, .external_lex_state = 2},
  [3021] = {.lex_state = 556, .external_lex_state = 2},
  [3022] = {.lex_state = 556, .external_lex_state = 2},
  [3023] = {.lex_state = 556, .external_lex_state = 2},
  [3024] = {.lex_state = 556, .external_lex_state = 2},
  [3025] = {.lex_state = 556, .external_lex_state = 2},
  [3026] = {.lex_state = 556, .external_lex_state = 2},
  [3027] = {.lex_state = 556, .external_lex_state = 2},
  [3028] = {.lex_state = 556, .external_lex_state = 2},
  [3029] = {.lex_state = 556, .external_lex_state = 2},
  [3030] = {.lex_state = 556, .external_lex_state = 2},
  [3031] = {.lex_state = 556, .external_lex_state = 2},
  [3032] = {.lex_state = 556, .external_lex_state = 2},
  [3033] = {.lex_state = 556, .external_lex_state = 2},
  [3034] = {.lex_state = 556, .external_lex_state = 2},
  [3035] = {.lex_state = 556, .external_lex_state = 2},
  [3036] = {.lex_state = 556, .external_lex_state = 2},
  [3037] = {.lex_state = 556, .external_lex_state = 2},
  [3038] = {.lex_state = 556, .external_lex_state = 2},
  [3039] = {.lex_state = 556, .external_lex_state = 2},
  [3040] = {.lex_state = 556, .external_lex_state = 2},
  [3041] = {.lex_state = 556, .external_lex_state = 2},
  [3042] = {.lex_state = 556, .external_lex_state = 2},
  [3043] = {.lex_state = 556, .external_lex_state = 2},
  [3044] = {.lex_state = 556, .external_lex_state = 2},
  [3045] = {.lex_state = 556, .external_lex_state = 2},
  [3046] = {.lex_state = 556, .external_lex_state = 2},
  [3047] = {.lex_state = 556, .external_lex_state = 2},
  [3048] = {.lex_state = 556, .external_lex_state = 2},
  [3049] = {.lex_state = 556, .external_lex_state = 2},
  [3050] = {.lex_state = 556, .external_lex_state = 2},
  [3051] = {.lex_state = 556, .external_lex_state = 2},
  [3052] = {.lex_state = 556, .external_lex_state = 2},
  [3053] = {.lex_state = 556, .external_lex_state = 2},
  [3054] = {.lex_state = 556, .external_lex_state = 2},
  [3055] = {.lex_state = 556, .external_lex_state = 2},
  [3056] = {.lex_state = 556, .external_lex_state = 2},
  [3057] = {.lex_state = 556, .external_lex_state = 2},
  [3058] = {.lex_state = 556, .external_lex_state = 2},
  [3059] = {.lex_state = 556, .external_lex_state = 2},
  [3060] = {.lex_state = 556, .external_lex_state = 2},
  [3061] = {.lex_state = 556, .external_lex_state = 2},
  [3062] = {.lex_state = 556, .external_lex_state = 2},
  [3063] = {.lex_state = 556, .external_lex_state = 2},
  [3064] = {.lex_state = 556, .external_lex_state = 2},
  [3065] = {.lex_state = 556, .external_lex_state = 2},
  [3066] = {.lex_state = 556, .external_lex_state = 2},
  [3067] = {.lex_state = 556, .external_lex_state = 2},
  [3068] = {.lex_state = 556, .external_lex_state = 2},
  [3069] = {.lex_state = 556, .external_lex_state = 2},
  [3070] = {.lex_state = 556, .external_lex_state = 2},
  [3071] = {.lex_state = 556, .external_lex_state = 2},
  [3072] = {.lex_state = 556, .external_lex_state = 2},
  [3073] = {.lex_state = 556, .external_lex_state = 2},
  [3074] = {.lex_state = 556, .external_lex_state = 2},
  [3075] = {.lex_state = 556, .external_lex_state = 2},
  [3076] = {.lex_state = 556, .external_lex_state = 2},
  [3077] = {.lex_state = 556, .external_lex_state = 2},
  [3078] = {.lex_state = 556, .external_lex_state = 2},
  [3079] = {.lex_state = 556, .external_lex_state = 2},
  [3080] = {.lex_state = 556, .external_lex_state = 2},
  [3081] = {.lex_state = 556, .external_lex_state = 2},
  [3082] = {.lex_state = 556, .external_lex_state = 2},
  [3083] = {.lex_state = 556, .external_lex_state = 2},
  [3084] = {.lex_state = 556, .external_lex_state = 2},
  [3085] = {.lex_state = 556, .external_lex_state = 2},
  [3086] = {.lex_state = 556, .external_lex_state = 2},
  [3087] = {.lex_state = 556, .external_lex_state = 2},
  [3088] = {.lex_state = 556, .external_lex_state = 2},
  [3089] = {.lex_state = 556, .external_lex_state = 2},
  [3090] = {.lex_state = 556, .external_lex_state = 2},
  [3091] = {.lex_state = 556, .external_lex_state = 2},
  [3092] = {.lex_state = 556, .external_lex_state = 2},
  [3093] = {.lex_state = 556, .external_lex_state = 2},
  [3094] = {.lex_state = 556, .external_lex_state = 2},
  [3095] = {.lex_state = 556, .external_lex_state = 2},
  [3096] = {.lex_state = 556, .external_lex_state = 2},
  [3097] = {.lex_state = 556, .external_lex_state = 2},
  [3098] = {.lex_state = 556, .external_lex_state = 2},
  [3099] = {.lex_state = 556, .external_lex_state = 2},
  [3100] = {.lex_state = 556, .external_lex_state = 2},
  [3101] = {.lex_state = 556, .external_lex_state = 2},
  [3102] = {.lex_state = 556, .external_lex_state = 2},
  [3103] = {.lex_state = 556, .external_lex_state = 2},
  [3104] = {.lex_state = 556, .external_lex_state = 2},
  [3105] = {.lex_state = 556, .external_lex_state = 2},
  [3106] = {.lex_state = 556, .external_lex_state = 2},
  [3107] = {.lex_state = 556, .external_lex_state = 2},
  [3108] = {.lex_state = 556, .external_lex_state = 2},
  [3109] = {.lex_state = 556, .external_lex_state = 2},
  [3110] = {.lex_state = 556, .external_lex_state = 2},
  [3111] = {.lex_state = 556, .external_lex_state = 2},
  [3112] = {.lex_state = 556, .external_lex_state = 2},
  [3113] = {.lex_state = 556, .external_lex_state = 2},
  [3114] = {.lex_state = 556, .external_lex_state = 2},
  [3115] = {.lex_state = 556, .external_lex_state = 2},
  [3116] = {.lex_state = 556, .external_lex_state = 2},
  [3117] = {.lex_state = 556, .external_lex_state = 2},
  [3118] = {.lex_state = 556, .external_lex_state = 2},
  [3119] = {.lex_state = 556, .external_lex_state = 2},
  [3120] = {.lex_state = 556, .external_lex_state = 2},
  [3121] = {.lex_state = 556, .external_lex_state = 2},
  [3122] = {.lex_state = 556, .external_lex_state = 2},
  [3123] = {.lex_state = 556, .external_lex_state = 2},
  [3124] = {.lex_state = 556, .external_lex_state = 2},
  [3125] = {.lex_state = 556, .external_lex_state = 2},
  [3126] = {.lex_state = 556, .external_lex_state = 2},
  [3127] = {.lex_state = 556, .external_lex_state = 2},
  [3128] = {.lex_state = 556, .external_lex_state = 2},
  [3129] = {.lex_state = 556, .external_lex_state = 2},
  [3130] = {.lex_state = 556, .external_lex_state = 2},
  [3131] = {.lex_state = 556, .external_lex_state = 2},
  [3132] = {.lex_state = 556, .external_lex_state = 2},
  [3133] = {.lex_state = 556, .external_lex_state = 2},
  [3134] = {.lex_state = 556, .external_lex_state = 2},
  [3135] = {.lex_state = 556, .external_lex_state = 2},
  [3136] = {.lex_state = 556, .external_lex_state = 2},
  [3137] = {.lex_state = 556, .external_lex_state = 2},
  [3138] = {.lex_state = 556, .external_lex_state = 2},
  [3139] = {.lex_state = 556, .external_lex_state = 2},
  [3140] = {.lex_state = 556, .external_lex_state = 2},
  [3141] = {.lex_state = 556, .external_lex_state = 2},
  [3142] = {.lex_state = 556, .external_lex_state = 2},
  [3143] = {.lex_state = 556, .external_lex_state = 2},
  [3144] = {.lex_state = 556, .external_lex_state = 2},
  [3145] = {.lex_state = 556, .external_lex_state = 2},
  [3146] = {.lex_state = 556, .external_lex_state = 2},
  [3147] = {.lex_state = 556, .external_lex_state = 2},
  [3148] = {.lex_state = 556, .external_lex_state = 2},
  [3149] = {.lex_state = 556, .external_lex_state = 2},
  [3150] = {.lex_state = 556, .external_lex_state = 2},
  [3151] = {.lex_state = 556, .external_lex_state = 2},
  [3152] = {.lex_state = 556, .external_lex_state = 2},
  [3153] = {.lex_state = 556, .external_lex_state = 2},
  [3154] = {.lex_state = 556, .external_lex_state = 2},
  [3155] = {.lex_state = 556, .external_lex_state = 2},
  [3156] = {.lex_state = 556, .external_lex_state = 2},
  [3157] = {.lex_state = 556, .external_lex_state = 2},
  [3158] = {.lex_state = 556, .external_lex_state = 2},
  [3159] = {.lex_state = 556, .external_lex_state = 2},
  [3160] = {.lex_state = 556, .external_lex_state = 2},
  [3161] = {.lex_state = 556, .external_lex_state = 2},
  [3162] = {.lex_state = 556, .external_lex_state = 2},
  [3163] = {.lex_state = 556, .external_lex_state = 2},
  [3164] = {.lex_state = 556, .external_lex_state = 2},
  [3165] = {.lex_state = 556, .external_lex_state = 2},
  [3166] = {.lex_state = 556, .external_lex_state = 2},
  [3167] = {.lex_state = 556, .external_lex_state = 2},
  [3168] = {.lex_state = 556, .external_lex_state = 2},
  [3169] = {.lex_state = 556, .external_lex_state = 2},
  [3170] = {.lex_state = 556, .external_lex_state = 2},
  [3171] = {.lex_state = 556, .external_lex_state = 2},
  [3172] = {.lex_state = 556, .external_lex_state = 2},
  [3173] = {.lex_state = 556, .external_lex_state = 2},
  [3174] = {.lex_state = 556, .external_lex_state = 2},
  [3175] = {.lex_state = 556, .external_lex_state = 2},
  [3176] = {.lex_state = 556, .external_lex_state = 2},
  [3177] = {.lex_state = 556, .external_lex_state = 2},
  [3178] = {.lex_state = 556, .external_lex_state = 2},
  [3179] = {.lex_state = 556, .external_lex_state = 2},
  [3180] = {.lex_state = 556, .external_lex_state = 2},
  [3181] = {.lex_state = 556, .external_lex_state = 2},
  [3182] = {.lex_state = 556, .external_lex_state = 2},
  [3183] = {.lex_state = 556, .external_lex_state = 2},
  [3184] = {.lex_state = 556, .external_lex_state = 2},
  [3185] = {.lex_state = 556, .external_lex_state = 2},
  [3186] = {.lex_state = 556, .external_lex_state = 2},
  [3187] = {.lex_state = 556, .external_lex_state = 2},
  [3188] = {.lex_state = 556, .external_lex_state = 2},
  [3189] = {.lex_state = 556, .external_lex_state = 2},
  [3190] = {.lex_state = 556, .external_lex_state = 2},
  [3191] = {.lex_state = 556, .external_lex_state = 2},
  [3192] = {.lex_state = 556, .external_lex_state = 2},
  [3193] = {.lex_state = 556, .external_lex_state = 2},
  [3194] = {.lex_state = 556, .external_lex_state = 2},
  [3195] = {.lex_state = 556, .external_lex_state = 2},
  [3196] = {.lex_state = 556, .external_lex_state = 2},
  [3197] = {.lex_state = 556, .external_lex_state = 2},
  [3198] = {.lex_state = 556, .external_lex_state = 2},
  [3199] = {.lex_state = 556, .external_lex_state = 2},
  [3200] = {.lex_state = 556, .external_lex_state = 2},
  [3201] = {.lex_state = 556, .external_lex_state = 2},
  [3202] = {.lex_state = 556, .external_lex_state = 2},
  [3203] = {.lex_state = 556, .external_lex_state = 2},
  [3204] = {.lex_state = 556, .external_lex_state = 2},
  [3205] = {.lex_state = 556, .external_lex_state = 2},
  [3206] = {.lex_state = 556, .external_lex_state = 2},
  [3207] = {.lex_state = 556, .external_lex_state = 2},
  [3208] = {.lex_state = 556, .external_lex_state = 2},
  [3209] = {.lex_state = 556, .external_lex_state = 2},
  [3210] = {.lex_state = 556, .external_lex_state = 2},
  [3211] = {.lex_state = 556, .external_lex_state = 2},
  [3212] = {.lex_state = 556, .external_lex_state = 2},
  [3213] = {.lex_state = 556, .external_lex_state = 2},
  [3214] = {.lex_state = 556, .external_lex_state = 2},
  [3215] = {.lex_state = 556, .external_lex_state = 2},
  [3216] = {.lex_state = 556, .external_lex_state = 2},
  [3217] = {.lex_state = 556, .external_lex_state = 2},
  [3218] = {.lex_state = 556, .external_lex_state = 2},
  [3219] = {.lex_state = 556, .external_lex_state = 2},
  [3220] = {.lex_state = 556, .external_lex_state = 2},
  [3221] = {.lex_state = 556, .external_lex_state = 2},
  [3222] = {.lex_state = 556, .external_lex_state = 2},
  [3223] = {.lex_state = 556, .external_lex_state = 2},
  [3224] = {.lex_state = 556, .external_lex_state = 2},
  [3225] = {.lex_state = 556, .external_lex_state = 2},
  [3226] = {.lex_state = 556, .external_lex_state = 2},
  [3227] = {.lex_state = 556, .external_lex_state = 2},
  [3228] = {.lex_state = 556, .external_lex_state = 2},
  [3229] = {.lex_state = 556, .external_lex_state = 2},
  [3230] = {.lex_state = 556, .external_lex_state = 2},
  [3231] = {.lex_state = 556, .external_lex_state = 2},
  [3232] = {.lex_state = 556, .external_lex_state = 2},
  [3233] = {.lex_state = 556, .external_lex_state = 2},
  [3234] = {.lex_state = 556, .external_lex_state = 2},
  [3235] = {.lex_state = 556, .external_lex_state = 2},
  [3236] = {.lex_state = 556, .external_lex_state = 2},
  [3237] = {.lex_state = 556, .external_lex_state = 2},
  [3238] = {.lex_state = 556, .external_lex_state = 2},
  [3239] = {.lex_state = 556, .external_lex_state = 2},
  [3240] = {.lex_state = 556, .external_lex_state = 2},
  [3241] = {.lex_state = 556, .external_lex_state = 2},
  [3242] = {.lex_state = 556, .external_lex_state = 2},
  [3243] = {.lex_state = 556, .external_lex_state = 2},
  [3244] = {.lex_state = 556, .external_lex_state = 2},
  [3245] = {.lex_state = 556, .external_lex_state = 2},
  [3246] = {.lex_state = 556, .external_lex_state = 2},
  [3247] = {.lex_state = 556, .external_lex_state = 2},
  [3248] = {.lex_state = 556, .external_lex_state = 2},
  [3249] = {.lex_state = 556, .external_lex_state = 2},
  [3250] = {.lex_state = 556, .external_lex_state = 2},
  [3251] = {.lex_state = 556, .external_lex_state = 2},
  [3252] = {.lex_state = 556, .external_lex_state = 2},
  [3253] = {.lex_state = 556, .external_lex_state = 2},
  [3254] = {.lex_state = 556, .external_lex_state = 2},
  [3255] = {.lex_state = 556, .external_lex_state = 2},
  [3256] = {.lex_state = 556, .external_lex_state = 2},
  [3257] = {.lex_state = 556, .external_lex_state = 2},
  [3258] = {.lex_state = 556, .external_lex_state = 2},
  [3259] = {.lex_state = 556, .external_lex_state = 2},
  [3260] = {.lex_state = 556, .external_lex_state = 2},
  [3261] = {.lex_state = 556, .external_lex_state = 2},
  [3262] = {.lex_state = 556, .external_lex_state = 2},
  [3263] = {.lex_state = 556, .external_lex_state = 2},
  [3264] = {.lex_state = 556, .external_lex_state = 2},
  [3265] = {.lex_state = 556, .external_lex_state = 2},
  [3266] = {.lex_state = 556, .external_lex_state = 2},
  [3267] = {.lex_state = 556, .external_lex_state = 2},
  [3268] = {.lex_state = 556, .external_lex_state = 2},
  [3269] = {.lex_state = 556, .external_lex_state = 2},
  [3270] = {.lex_state = 556, .external_lex_state = 2},
  [3271] = {.lex_state = 556, .external_lex_state = 2},
  [3272] = {.lex_state = 556, .external_lex_state = 2},
  [3273] = {.lex_state = 556, .external_lex_state = 2},
  [3274] = {.lex_state = 556, .external_lex_state = 2},
  [3275] = {.lex_state = 556, .external_lex_state = 2},
  [3276] = {.lex_state = 556, .external_lex_state = 2},
  [3277] = {.lex_state = 556, .external_lex_state = 2},
  [3278] = {.lex_state = 556, .external_lex_state = 2},
  [3279] = {.lex_state = 556, .external_lex_state = 2},
  [3280] = {.lex_state = 556, .external_lex_state = 2},
  [3281] = {.lex_state = 556, .external_lex_state = 2},
  [3282] = {.lex_state = 556, .external_lex_state = 2},
  [3283] = {.lex_state = 556, .external_lex_state = 2},
  [3284] = {.lex_state = 556, .external_lex_state = 2},
  [3285] = {.lex_state = 556, .external_lex_state = 2},
  [3286] = {.lex_state = 556, .external_lex_state = 2},
  [3287] = {.lex_state = 556, .external_lex_state = 2},
  [3288] = {.lex_state = 556, .external_lex_state = 2},
  [3289] = {.lex_state = 556, .external_lex_state = 2},
  [3290] = {.lex_state = 556, .external_lex_state = 2},
  [3291] = {.lex_state = 556, .external_lex_state = 2},
  [3292] = {.lex_state = 556, .external_lex_state = 2},
  [3293] = {.lex_state = 556, .external_lex_state = 2},
  [3294] = {.lex_state = 556, .external_lex_state = 2},
  [3295] = {.lex_state = 556, .external_lex_state = 2},
  [3296] = {.lex_state = 556, .external_lex_state = 2},
  [3297] = {.lex_state = 556, .external_lex_state = 2},
  [3298] = {.lex_state = 556, .external_lex_state = 2},
  [3299] = {.lex_state = 556, .external_lex_state = 2},
  [3300] = {.lex_state = 556, .external_lex_state = 2},
  [3301] = {.lex_state = 556, .external_lex_state = 2},
  [3302] = {.lex_state = 556, .external_lex_state = 2},
  [3303] = {.lex_state = 556, .external_lex_state = 2},
  [3304] = {.lex_state = 556, .external_lex_state = 2},
  [3305] = {.lex_state = 556, .external_lex_state = 2},
  [3306] = {.lex_state = 556, .external_lex_state = 2},
  [3307] = {.lex_state = 556, .external_lex_state = 2},
  [3308] = {.lex_state = 556, .external_lex_state = 2},
  [3309] = {.lex_state = 556, .external_lex_state = 2},
  [3310] = {.lex_state = 556, .external_lex_state = 2},
  [3311] = {.lex_state = 556, .external_lex_state = 2},
  [3312] = {.lex_state = 556, .external_lex_state = 2},
  [3313] = {.lex_state = 556, .external_lex_state = 2},
  [3314] = {.lex_state = 556, .external_lex_state = 2},
  [3315] = {.lex_state = 556, .external_lex_state = 2},
  [3316] = {.lex_state = 556, .external_lex_state = 2},
  [3317] = {.lex_state = 556, .external_lex_state = 2},
  [3318] = {.lex_state = 556, .external_lex_state = 2},
  [3319] = {.lex_state = 556, .external_lex_state = 2},
  [3320] = {.lex_state = 556, .external_lex_state = 2},
  [3321] = {.lex_state = 556, .external_lex_state = 2},
  [3322] = {.lex_state = 556, .external_lex_state = 2},
  [3323] = {.lex_state = 556, .external_lex_state = 2},
  [3324] = {.lex_state = 556, .external_lex_state = 2},
  [3325] = {.lex_state = 556, .external_lex_state = 2},
  [3326] = {.lex_state = 556, .external_lex_state = 2},
  [3327] = {.lex_state = 556, .external_lex_state = 2},
  [3328] = {.lex_state = 556, .external_lex_state = 2},
  [3329] = {.lex_state = 556, .external_lex_state = 2},
  [3330] = {.lex_state = 556, .external_lex_state = 2},
  [3331] = {.lex_state = 556, .external_lex_state = 2},
  [3332] = {.lex_state = 556, .external_lex_state = 2},
  [3333] = {.lex_state = 556, .external_lex_state = 2},
  [3334] = {.lex_state = 556, .external_lex_state = 2},
  [3335] = {.lex_state = 556, .external_lex_state = 2},
  [3336] = {.lex_state = 556, .external_lex_state = 2},
  [3337] = {.lex_state = 556, .external_lex_state = 2},
  [3338] = {.lex_state = 556, .external_lex_state = 2},
  [3339] = {.lex_state = 556, .external_lex_state = 2},
  [3340] = {.lex_state = 556, .external_lex_state = 2},
  [3341] = {.lex_state = 556, .external_lex_state = 2},
  [3342] = {.lex_state = 556, .external_lex_state = 2},
  [3343] = {.lex_state = 556, .external_lex_state = 2},
  [3344] = {.lex_state = 556, .external_lex_state = 2},
  [3345] = {.lex_state = 556, .external_lex_state = 2},
  [3346] = {.lex_state = 556, .external_lex_state = 2},
  [3347] = {.lex_state = 556, .external_lex_state = 2},
  [3348] = {.lex_state = 556, .external_lex_state = 2},
  [3349] = {.lex_state = 556, .external_lex_state = 2},
  [3350] = {.lex_state = 556, .external_lex_state = 2},
  [3351] = {.lex_state = 556, .external_lex_state = 2},
  [3352] = {.lex_state = 556, .external_lex_state = 2},
  [3353] = {.lex_state = 556, .external_lex_state = 2},
  [3354] = {.lex_state = 556, .external_lex_state = 2},
  [3355] = {.lex_state = 556, .external_lex_state = 2},
  [3356] = {.lex_state = 556, .external_lex_state = 2},
  [3357] = {.lex_state = 556, .external_lex_state = 2},
  [3358] = {.lex_state = 556, .external_lex_state = 2},
  [3359] = {.lex_state = 556, .external_lex_state = 2},
  [3360] = {.lex_state = 556, .external_lex_state = 2},
  [3361] = {.lex_state = 556, .external_lex_state = 2},
  [3362] = {.lex_state = 556, .external_lex_state = 2},
  [3363] = {.lex_state = 556, .external_lex_state = 2},
  [3364] = {.lex_state = 556, .external_lex_state = 2},
  [3365] = {.lex_state = 556, .external_lex_state = 2},
  [3366] = {.lex_state = 556, .external_lex_state = 2},
  [3367] = {.lex_state = 556, .external_lex_state = 2},
  [3368] = {.lex_state = 556, .external_lex_state = 2},
  [3369] = {.lex_state = 556, .external_lex_state = 2},
  [3370] = {.lex_state = 556, .external_lex_state = 2},
  [3371] = {.lex_state = 556, .external_lex_state = 2},
  [3372] = {.lex_state = 556, .external_lex_state = 2},
  [3373] = {.lex_state = 556, .external_lex_state = 2},
  [3374] = {.lex_state = 556, .external_lex_state = 2},
  [3375] = {.lex_state = 556, .external_lex_state = 2},
  [3376] = {.lex_state = 556, .external_lex_state = 2},
  [3377] = {.lex_state = 556, .external_lex_state = 2},
  [3378] = {.lex_state = 556, .external_lex_state = 2},
  [3379] = {.lex_state = 556, .external_lex_state = 2},
  [3380] = {.lex_state = 556, .external_lex_state = 2},
  [3381] = {.lex_state = 556, .external_lex_state = 2},
  [3382] = {.lex_state = 556, .external_lex_state = 2},
  [3383] = {.lex_state = 556, .external_lex_state = 2},
  [3384] = {.lex_state = 556, .external_lex_state = 2},
  [3385] = {.lex_state = 556, .external_lex_state = 2},
  [3386] = {.lex_state = 556, .external_lex_state = 2},
  [3387] = {.lex_state = 556, .external_lex_state = 2},
  [3388] = {.lex_state = 556, .external_lex_state = 2},
  [3389] = {.lex_state = 556, .external_lex_state = 2},
  [3390] = {.lex_state = 556, .external_lex_state = 2},
  [3391] = {.lex_state = 556, .external_lex_state = 2},
  [3392] = {.lex_state = 556, .external_lex_state = 2},
  [3393] = {.lex_state = 556, .external_lex_state = 2},
  [3394] = {.lex_state = 556, .external_lex_state = 2},
  [3395] = {.lex_state = 556, .external_lex_state = 2},
  [3396] = {.lex_state = 556, .external_lex_state = 2},
  [3397] = {.lex_state = 556, .external_lex_state = 2},
  [3398] = {.lex_state = 556, .external_lex_state = 2},
  [3399] = {.lex_state = 556, .external_lex_state = 2},
  [3400] = {.lex_state = 556, .external_lex_state = 2},
  [3401] = {.lex_state = 556, .external_lex_state = 2},
  [3402] = {.lex_state = 556, .external_lex_state = 2},
  [3403] = {.lex_state = 556, .external_lex_state = 2},
  [3404] = {.lex_state = 556, .external_lex_state = 2},
  [3405] = {.lex_state = 556, .external_lex_state = 2},
  [3406] = {.lex_state = 556, .external_lex_state = 2},
  [3407] = {.lex_state = 556, .external_lex_state = 2},
  [3408] = {.lex_state = 556, .external_lex_state = 2},
  [3409] = {.lex_state = 556, .external_lex_state = 2},
  [3410] = {.lex_state = 556, .external_lex_state = 2},
  [3411] = {.lex_state = 556, .external_lex_state = 2},
  [3412] = {.lex_state = 556, .external_lex_state = 2},
  [3413] = {.lex_state = 556, .external_lex_state = 2},
  [3414] = {.lex_state = 556, .external_lex_state = 2},
  [3415] = {.lex_state = 556, .external_lex_state = 2},
  [3416] = {.lex_state = 556, .external_lex_state = 2},
  [3417] = {.lex_state = 556, .external_lex_state = 2},
  [3418] = {.lex_state = 556, .external_lex_state = 2},
  [3419] = {.lex_state = 556, .external_lex_state = 2},
  [3420] = {.lex_state = 556, .external_lex_state = 2},
  [3421] = {.lex_state = 556, .external_lex_state = 2},
  [3422] = {.lex_state = 556, .external_lex_state = 2},
  [3423] = {.lex_state = 556, .external_lex_state = 2},
  [3424] = {.lex_state = 556, .external_lex_state = 2},
  [3425] = {.lex_state = 556, .external_lex_state = 2},
  [3426] = {.lex_state = 556, .external_lex_state = 2},
  [3427] = {.lex_state = 556, .external_lex_state = 2},
  [3428] = {.lex_state = 556, .external_lex_state = 2},
  [3429] = {.lex_state = 556, .external_lex_state = 2},
  [3430] = {.lex_state = 556, .external_lex_state = 2},
  [3431] = {.lex_state = 556, .external_lex_state = 2},
  [3432] = {.lex_state = 556, .external_lex_state = 2},
  [3433] = {.lex_state = 556, .external_lex_state = 2},
  [3434] = {.lex_state = 556, .external_lex_state = 2},
  [3435] = {.lex_state = 556, .external_lex_state = 2},
  [3436] = {.lex_state = 556, .external_lex_state = 2},
  [3437] = {.lex_state = 556, .external_lex_state = 2},
  [3438] = {.lex_state = 556, .external_lex_state = 2},
  [3439] = {.lex_state = 556, .external_lex_state = 2},
  [3440] = {.lex_state = 556, .external_lex_state = 2},
  [3441] = {.lex_state = 556, .external_lex_state = 2},
  [3442] = {.lex_state = 556, .external_lex_state = 2},
  [3443] = {.lex_state = 556, .external_lex_state = 2},
  [3444] = {.lex_state = 556, .external_lex_state = 2},
  [3445] = {.lex_state = 556, .external_lex_state = 2},
  [3446] = {.lex_state = 556, .external_lex_state = 2},
  [3447] = {.lex_state = 556, .external_lex_state = 2},
  [3448] = {.lex_state = 556, .external_lex_state = 2},
  [3449] = {.lex_state = 556, .external_lex_state = 2},
  [3450] = {.lex_state = 556, .external_lex_state = 2},
  [3451] = {.lex_state = 556, .external_lex_state = 2},
  [3452] = {.lex_state = 556, .external_lex_state = 2},
  [3453] = {.lex_state = 556, .external_lex_state = 2},
  [3454] = {.lex_state = 556, .external_lex_state = 2},
  [3455] = {.lex_state = 556, .external_lex_state = 2},
  [3456] = {.lex_state = 556, .external_lex_state = 2},
  [3457] = {.lex_state = 556, .external_lex_state = 2},
  [3458] = {.lex_state = 556, .external_lex_state = 2},
  [3459] = {.lex_state = 556, .external_lex_state = 2},
  [3460] = {.lex_state = 556, .external_lex_state = 2},
  [3461] = {.lex_state = 556, .external_lex_state = 2},
  [3462] = {.lex_state = 556, .external_lex_state = 2},
  [3463] = {.lex_state = 556, .external_lex_state = 2},
  [3464] = {.lex_state = 556, .external_lex_state = 2},
  [3465] = {.lex_state = 556, .external_lex_state = 2},
  [3466] = {.lex_state = 556, .external_lex_state = 2},
  [3467] = {.lex_state = 556, .external_lex_state = 2},
  [3468] = {.lex_state = 556, .external_lex_state = 2},
  [3469] = {.lex_state = 556, .external_lex_state = 2},
  [3470] = {.lex_state = 556, .external_lex_state = 2},
  [3471] = {.lex_state = 556, .external_lex_state = 2},
  [3472] = {.lex_state = 556, .external_lex_state = 2},
  [3473] = {.lex_state = 556, .external_lex_state = 2},
  [3474] = {.lex_state = 556, .external_lex_state = 2},
  [3475] = {.lex_state = 556, .external_lex_state = 2},
  [3476] = {.lex_state = 556, .external_lex_state = 2},
  [3477] = {.lex_state = 556, .external_lex_state = 2},
  [3478] = {.lex_state = 556, .external_lex_state = 2},
  [3479] = {.lex_state = 556, .external_lex_state = 2},
  [3480] = {.lex_state = 556, .external_lex_state = 2},
  [3481] = {.lex_state = 556, .external_lex_state = 2},
  [3482] = {.lex_state = 556, .external_lex_state = 2},
  [3483] = {.lex_state = 556, .external_lex_state = 2},
  [3484] = {.lex_state = 556, .external_lex_state = 2},
  [3485] = {.lex_state = 556, .external_lex_state = 2},
  [3486] = {.lex_state = 556, .external_lex_state = 2},
  [3487] = {.lex_state = 556, .external_lex_state = 2},
  [3488] = {.lex_state = 556, .external_lex_state = 2},
  [3489] = {.lex_state = 556, .external_lex_state = 2},
  [3490] = {.lex_state = 556, .external_lex_state = 2},
  [3491] = {.lex_state = 556, .external_lex_state = 2},
  [3492] = {.lex_state = 556, .external_lex_state = 2},
  [3493] = {.lex_state = 556, .external_lex_state = 2},
  [3494] = {.lex_state = 556, .external_lex_state = 2},
  [3495] = {.lex_state = 556, .external_lex_state = 2},
  [3496] = {.lex_state = 556, .external_lex_state = 2},
  [3497] = {.lex_state = 556, .external_lex_state = 2},
  [3498] = {.lex_state = 556, .external_lex_state = 2},
  [3499] = {.lex_state = 556, .external_lex_state = 2},
  [3500] = {.lex_state = 556, .external_lex_state = 2},
  [3501] = {.lex_state = 556, .external_lex_state = 2},
  [3502] = {.lex_state = 556, .external_lex_state = 2},
  [3503] = {.lex_state = 556, .external_lex_state = 2},
  [3504] = {.lex_state = 556, .external_lex_state = 2},
  [3505] = {.lex_state = 556, .external_lex_state = 2},
  [3506] = {.lex_state = 556, .external_lex_state = 2},
  [3507] = {.lex_state = 556, .external_lex_state = 2},
  [3508] = {.lex_state = 556, .external_lex_state = 2},
  [3509] = {.lex_state = 556, .external_lex_state = 2},
  [3510] = {.lex_state = 556, .external_lex_state = 2},
  [3511] = {.lex_state = 556, .external_lex_state = 2},
  [3512] = {.lex_state = 556, .external_lex_state = 2},
  [3513] = {.lex_state = 556, .external_lex_state = 2},
  [3514] = {.lex_state = 556, .external_lex_state = 2},
  [3515] = {.lex_state = 556, .external_lex_state = 2},
  [3516] = {.lex_state = 556, .external_lex_state = 2},
  [3517] = {.lex_state = 556, .external_lex_state = 2},
  [3518] = {.lex_state = 556, .external_lex_state = 2},
  [3519] = {.lex_state = 556, .external_lex_state = 2},
  [3520] = {.lex_state = 556, .external_lex_state = 2},
  [3521] = {.lex_state = 556, .external_lex_state = 2},
  [3522] = {.lex_state = 556, .external_lex_state = 2},
  [3523] = {.lex_state = 556, .external_lex_state = 2},
  [3524] = {.lex_state = 556, .external_lex_state = 2},
  [3525] = {.lex_state = 556, .external_lex_state = 2},
  [3526] = {.lex_state = 556, .external_lex_state = 2},
  [3527] = {.lex_state = 556, .external_lex_state = 2},
  [3528] = {.lex_state = 556, .external_lex_state = 2},
  [3529] = {.lex_state = 556, .external_lex_state = 2},
  [3530] = {.lex_state = 556, .external_lex_state = 2},
  [3531] = {.lex_state = 556, .external_lex_state = 2},
  [3532] = {.lex_state = 556, .external_lex_state = 2},
  [3533] = {.lex_state = 556, .external_lex_state = 2},
  [3534] = {.lex_state = 556, .external_lex_state = 2},
  [3535] = {.lex_state = 556, .external_lex_state = 2},
  [3536] = {.lex_state = 556, .external_lex_state = 2},
  [3537] = {.lex_state = 556, .external_lex_state = 2},
  [3538] = {.lex_state = 556, .external_lex_state = 2},
  [3539] = {.lex_state = 556, .external_lex_state = 2},
  [3540] = {.lex_state = 556, .external_lex_state = 2},
  [3541] = {.lex_state = 556, .external_lex_state = 2},
  [3542] = {.lex_state = 556, .external_lex_state = 2},
  [3543] = {.lex_state = 556, .external_lex_state = 2},
  [3544] = {.lex_state = 556, .external_lex_state = 2},
  [3545] = {.lex_state = 556, .external_lex_state = 2},
  [3546] = {.lex_state = 556, .external_lex_state = 2},
  [3547] = {.lex_state = 556, .external_lex_state = 2},
  [3548] = {.lex_state = 556, .external_lex_state = 2},
  [3549] = {.lex_state = 556, .external_lex_state = 2},
  [3550] = {.lex_state = 556, .external_lex_state = 2},
  [3551] = {.lex_state = 556, .external_lex_state = 2},
  [3552] = {.lex_state = 556, .external_lex_state = 2},
  [3553] = {.lex_state = 556, .external_lex_state = 2},
  [3554] = {.lex_state = 556, .external_lex_state = 2},
  [3555] = {.lex_state = 556, .external_lex_state = 2},
  [3556] = {.lex_state = 556, .external_lex_state = 2},
  [3557] = {.lex_state = 556, .external_lex_state = 2},
  [3558] = {.lex_state = 556, .external_lex_state = 2},
  [3559] = {.lex_state = 556, .external_lex_state = 2},
  [3560] = {.lex_state = 556, .external_lex_state = 2},
  [3561] = {.lex_state = 556, .external_lex_state = 2},
  [3562] = {.lex_state = 556, .external_lex_state = 2},
  [3563] = {.lex_state = 556, .external_lex_state = 2},
  [3564] = {.lex_state = 556, .external_lex_state = 2},
  [3565] = {.lex_state = 556, .external_lex_state = 2},
  [3566] = {.lex_state = 556, .external_lex_state = 2},
  [3567] = {.lex_state = 556, .external_lex_state = 2},
  [3568] = {.lex_state = 556, .external_lex_state = 2},
  [3569] = {.lex_state = 556, .external_lex_state = 2},
  [3570] = {.lex_state = 556, .external_lex_state = 2},
  [3571] = {.lex_state = 556, .external_lex_state = 2},
  [3572] = {.lex_state = 556, .external_lex_state = 2},
  [3573] = {.lex_state = 556, .external_lex_state = 2},
  [3574] = {.lex_state = 556, .external_lex_state = 2},
  [3575] = {.lex_state = 556, .external_lex_state = 2},
  [3576] = {.lex_state = 556, .external_lex_state = 2},
  [3577] = {.lex_state = 556, .external_lex_state = 2},
  [3578] = {.lex_state = 556, .external_lex_state = 2},
  [3579] = {.lex_state = 556, .external_lex_state = 2},
  [3580] = {.lex_state = 556, .external_lex_state = 2},
  [3581] = {.lex_state = 556, .external_lex_state = 2},
  [3582] = {.lex_state = 556, .external_lex_state = 2},
  [3583] = {.lex_state = 556, .external_lex_state = 2},
  [3584] = {.lex_state = 556, .external_lex_state = 2},
  [3585] = {.lex_state = 556, .external_lex_state = 2},
  [3586] = {.lex_state = 556, .external_lex_state = 2},
  [3587] = {.lex_state = 556, .external_lex_state = 2},
  [3588] = {.lex_state = 556, .external_lex_state = 2},
  [3589] = {.lex_state = 556, .external_lex_state = 2},
  [3590] = {.lex_state = 556, .external_lex_state = 2},
  [3591] = {.lex_state = 556, .external_lex_state = 2},
  [3592] = {.lex_state = 556, .external_lex_state = 2},
  [3593] = {.lex_state = 556, .external_lex_state = 2},
  [3594] = {.lex_state = 556, .external_lex_state = 2},
  [3595] = {.lex_state = 556, .external_lex_state = 2},
  [3596] = {.lex_state = 556, .external_lex_state = 2},
  [3597] = {.lex_state = 556, .external_lex_state = 2},
  [3598] = {.lex_state = 556, .external_lex_state = 2},
  [3599] = {.lex_state = 556, .external_lex_state = 2},
  [3600] = {.lex_state = 556, .external_lex_state = 2},
  [3601] = {.lex_state = 556, .external_lex_state = 2},
  [3602] = {.lex_state = 556, .external_lex_state = 2},
  [3603] = {.lex_state = 556, .external_lex_state = 2},
  [3604] = {.lex_state = 556, .external_lex_state = 2},
  [3605] = {.lex_state = 556, .external_lex_state = 2},
  [3606] = {.lex_state = 556, .external_lex_state = 2},
  [3607] = {.lex_state = 556, .external_lex_state = 2},
  [3608] = {.lex_state = 556, .external_lex_state = 2},
  [3609] = {.lex_state = 556, .external_lex_state = 2},
  [3610] = {.lex_state = 556, .external_lex_state = 2},
  [3611] = {.lex_state = 556, .external_lex_state = 2},
  [3612] = {.lex_state = 556, .external_lex_state = 2},
  [3613] = {.lex_state = 556, .external_lex_state = 2},
  [3614] = {.lex_state = 556, .external_lex_state = 2},
  [3615] = {.lex_state = 556, .external_lex_state = 2},
  [3616] = {.lex_state = 556, .external_lex_state = 2},
  [3617] = {.lex_state = 556, .external_lex_state = 2},
  [3618] = {.lex_state = 556, .external_lex_state = 2},
  [3619] = {.lex_state = 556, .external_lex_state = 2},
  [3620] = {.lex_state = 556, .external_lex_state = 2},
  [3621] = {.lex_state = 556, .external_lex_state = 2},
  [3622] = {.lex_state = 556, .external_lex_state = 2},
  [3623] = {.lex_state = 556, .external_lex_state = 2},
  [3624] = {.lex_state = 556, .external_lex_state = 2},
  [3625] = {.lex_state = 556, .external_lex_state = 2},
  [3626] = {.lex_state = 556, .external_lex_state = 2},
  [3627] = {.lex_state = 556, .external_lex_state = 2},
  [3628] = {.lex_state = 556, .external_lex_state = 2},
  [3629] = {.lex_state = 556, .external_lex_state = 2},
  [3630] = {.lex_state = 556, .external_lex_state = 2},
  [3631] = {.lex_state = 556, .external_lex_state = 2},
  [3632] = {.lex_state = 556, .external_lex_state = 2},
  [3633] = {.lex_state = 556, .external_lex_state = 2},
  [3634] = {.lex_state = 556, .external_lex_state = 2},
  [3635] = {.lex_state = 556, .external_lex_state = 2},
  [3636] = {.lex_state = 556, .external_lex_state = 2},
  [3637] = {.lex_state = 556, .external_lex_state = 2},
  [3638] = {.lex_state = 556, .external_lex_state = 2},
  [3639] = {.lex_state = 556, .external_lex_state = 2},
  [3640] = {.lex_state = 556, .external_lex_state = 2},
  [3641] = {.lex_state = 556, .external_lex_state = 2},
  [3642] = {.lex_state = 556, .external_lex_state = 2},
  [3643] = {.lex_state = 556, .external_lex_state = 2},
  [3644] = {.lex_state = 556, .external_lex_state = 2},
  [3645] = {.lex_state = 556, .external_lex_state = 2},
  [3646] = {.lex_state = 556, .external_lex_state = 2},
  [3647] = {.lex_state = 556, .external_lex_state = 2},
  [3648] = {.lex_state = 556, .external_lex_state = 2},
  [3649] = {.lex_state = 556, .external_lex_state = 2},
  [3650] = {.lex_state = 556, .external_lex_state = 2},
  [3651] = {.lex_state = 556, .external_lex_state = 2},
  [3652] = {.lex_state = 556, .external_lex_state = 2},
  [3653] = {.lex_state = 556, .external_lex_state = 2},
  [3654] = {.lex_state = 556, .external_lex_state = 2},
  [3655] = {.lex_state = 556, .external_lex_state = 2},
  [3656] = {.lex_state = 556, .external_lex_state = 2},
  [3657] = {.lex_state = 556, .external_lex_state = 2},
  [3658] = {.lex_state = 556, .external_lex_state = 2},
  [3659] = {.lex_state = 556, .external_lex_state = 2},
  [3660] = {.lex_state = 556, .external_lex_state = 2},
  [3661] = {.lex_state = 556, .external_lex_state = 2},
  [3662] = {.lex_state = 556, .external_lex_state = 2},
  [3663] = {.lex_state = 556, .external_lex_state = 2},
  [3664] = {.lex_state = 556, .external_lex_state = 2},
  [3665] = {.lex_state = 556, .external_lex_state = 2},
  [3666] = {.lex_state = 556, .external_lex_state = 2},
  [3667] = {.lex_state = 556, .external_lex_state = 2},
  [3668] = {.lex_state = 556, .external_lex_state = 2},
  [3669] = {.lex_state = 556, .external_lex_state = 2},
  [3670] = {.lex_state = 556, .external_lex_state = 2},
  [3671] = {.lex_state = 556, .external_lex_state = 2},
  [3672] = {.lex_state = 556, .external_lex_state = 2},
  [3673] = {.lex_state = 556, .external_lex_state = 2},
  [3674] = {.lex_state = 556, .external_lex_state = 2},
  [3675] = {.lex_state = 556, .external_lex_state = 2},
  [3676] = {.lex_state = 556, .external_lex_state = 2},
  [3677] = {.lex_state = 556, .external_lex_state = 2},
  [3678] = {.lex_state = 556, .external_lex_state = 2},
  [3679] = {.lex_state = 556, .external_lex_state = 2},
  [3680] = {.lex_state = 556, .external_lex_state = 2},
  [3681] = {.lex_state = 556, .external_lex_state = 2},
  [3682] = {.lex_state = 556, .external_lex_state = 2},
  [3683] = {.lex_state = 556, .external_lex_state = 2},
  [3684] = {.lex_state = 556, .external_lex_state = 2},
  [3685] = {.lex_state = 556, .external_lex_state = 2},
  [3686] = {.lex_state = 556, .external_lex_state = 2},
  [3687] = {.lex_state = 556, .external_lex_state = 2},
  [3688] = {.lex_state = 556, .external_lex_state = 2},
  [3689] = {.lex_state = 556, .external_lex_state = 2},
  [3690] = {.lex_state = 556, .external_lex_state = 2},
  [3691] = {.lex_state = 556, .external_lex_state = 2},
  [3692] = {.lex_state = 556, .external_lex_state = 2},
  [3693] = {.lex_state = 556, .external_lex_state = 2},
  [3694] = {.lex_state = 556, .external_lex_state = 2},
  [3695] = {.lex_state = 556, .external_lex_state = 2},
  [3696] = {.lex_state = 556, .external_lex_state = 2},
  [3697] = {.lex_state = 556, .external_lex_state = 2},
  [3698] = {.lex_state = 556, .external_lex_state = 2},
  [3699] = {.lex_state = 556, .external_lex_state = 2},
  [3700] = {.lex_state = 556, .external_lex_state = 2},
  [3701] = {.lex_state = 556, .external_lex_state = 2},
  [3702] = {.lex_state = 556, .external_lex_state = 2},
  [3703] = {.lex_state = 556, .external_lex_state = 2},
  [3704] = {.lex_state = 556, .external_lex_state = 2},
  [3705] = {.lex_state = 556, .external_lex_state = 2},
  [3706] = {.lex_state = 556, .external_lex_state = 2},
  [3707] = {.lex_state = 556, .external_lex_state = 2},
  [3708] = {.lex_state = 556, .external_lex_state = 2},
  [3709] = {.lex_state = 556, .external_lex_state = 2},
  [3710] = {.lex_state = 556, .external_lex_state = 2},
  [3711] = {.lex_state = 556, .external_lex_state = 2},
  [3712] = {.lex_state = 556, .external_lex_state = 2},
  [3713] = {.lex_state = 556, .external_lex_state = 2},
  [3714] = {.lex_state = 556, .external_lex_state = 2},
  [3715] = {.lex_state = 556, .external_lex_state = 2},
  [3716] = {.lex_state = 556, .external_lex_state = 2},
  [3717] = {.lex_state = 556, .external_lex_state = 2},
  [3718] = {.lex_state = 556, .external_lex_state = 2},
  [3719] = {.lex_state = 556, .external_lex_state = 2},
  [3720] = {.lex_state = 556, .external_lex_state = 2},
  [3721] = {.lex_state = 556, .external_lex_state = 2},
  [3722] = {.lex_state = 556, .external_lex_state = 2},
  [3723] = {.lex_state = 556, .external_lex_state = 2},
  [3724] = {.lex_state = 556, .external_lex_state = 2},
  [3725] = {.lex_state = 556, .external_lex_state = 2},
  [3726] = {.lex_state = 556, .external_lex_state = 2},
  [3727] = {.lex_state = 556, .external_lex_state = 2},
  [3728] = {.lex_state = 556, .external_lex_state = 2},
  [3729] = {.lex_state = 556, .external_lex_state = 2},
  [3730] = {.lex_state = 556, .external_lex_state = 2},
  [3731] = {.lex_state = 556, .external_lex_state = 2},
  [3732] = {.lex_state = 556, .external_lex_state = 2},
  [3733] = {.lex_state = 556, .external_lex_state = 2},
  [3734] = {.lex_state = 556, .external_lex_state = 2},
  [3735] = {.lex_state = 556, .external_lex_state = 2},
  [3736] = {.lex_state = 556, .external_lex_state = 2},
  [3737] = {.lex_state = 556, .external_lex_state = 2},
  [3738] = {.lex_state = 556, .external_lex_state = 2},
  [3739] = {.lex_state = 556, .external_lex_state = 2},
  [3740] = {.lex_state = 556, .external_lex_state = 2},
  [3741] = {.lex_state = 556, .external_lex_state = 2},
  [3742] = {.lex_state = 556, .external_lex_state = 2},
  [3743] = {.lex_state = 556, .external_lex_state = 2},
  [3744] = {.lex_state = 556, .external_lex_state = 2},
  [3745] = {.lex_state = 556, .external_lex_state = 2},
  [3746] = {.lex_state = 556, .external_lex_state = 2},
  [3747] = {.lex_state = 556, .external_lex_state = 2},
  [3748] = {.lex_state = 556, .external_lex_state = 2},
  [3749] = {.lex_state = 556, .external_lex_state = 2},
  [3750] = {.lex_state = 556, .external_lex_state = 2},
  [3751] = {.lex_state = 556, .external_lex_state = 2},
  [3752] = {.lex_state = 556, .external_lex_state = 2},
  [3753] = {.lex_state = 556, .external_lex_state = 2},
  [3754] = {.lex_state = 556, .external_lex_state = 2},
  [3755] = {.lex_state = 556, .external_lex_state = 2},
  [3756] = {.lex_state = 556, .external_lex_state = 2},
  [3757] = {.lex_state = 556, .external_lex_state = 2},
  [3758] = {.lex_state = 556, .external_lex_state = 2},
  [3759] = {.lex_state = 556, .external_lex_state = 2},
  [3760] = {.lex_state = 556, .external_lex_state = 2},
  [3761] = {.lex_state = 556, .external_lex_state = 2},
  [3762] = {.lex_state = 556, .external_lex_state = 2},
  [3763] = {.lex_state = 556, .external_lex_state = 2},
  [3764] = {.lex_state = 556, .external_lex_state = 2},
  [3765] = {.lex_state = 556, .external_lex_state = 2},
  [3766] = {.lex_state = 556, .external_lex_state = 2},
  [3767] = {.lex_state = 556, .external_lex_state = 2},
  [3768] = {.lex_state = 556, .external_lex_state = 2},
  [3769] = {.lex_state = 556, .external_lex_state = 2},
  [3770] = {.lex_state = 556, .external_lex_state = 2},
  [3771] = {.lex_state = 556, .external_lex_state = 2},
  [3772] = {.lex_state = 556, .external_lex_state = 2},
  [3773] = {.lex_state = 556, .external_lex_state = 2},
  [3774] = {.lex_state = 556, .external_lex_state = 2},
  [3775] = {.lex_state = 556, .external_lex_state = 2},
  [3776] = {.lex_state = 556, .external_lex_state = 2},
  [3777] = {.lex_state = 556, .external_lex_state = 2},
  [3778] = {.lex_state = 556, .external_lex_state = 2},
  [3779] = {.lex_state = 556, .external_lex_state = 2},
  [3780] = {.lex_state = 556, .external_lex_state = 2},
  [3781] = {.lex_state = 556, .external_lex_state = 2},
  [3782] = {.lex_state = 556, .external_lex_state = 2},
  [3783] = {.lex_state = 556, .external_lex_state = 2},
  [3784] = {.lex_state = 556, .external_lex_state = 2},
  [3785] = {.lex_state = 556, .external_lex_state = 2},
  [3786] = {.lex_state = 556, .external_lex_state = 2},
  [3787] = {.lex_state = 556, .external_lex_state = 2},
  [3788] = {.lex_state = 556, .external_lex_state = 2},
  [3789] = {.lex_state = 556, .external_lex_state = 2},
  [3790] = {.lex_state = 556, .external_lex_state = 2},
  [3791] = {.lex_state = 556, .external_lex_state = 2},
  [3792] = {.lex_state = 556, .external_lex_state = 2},
  [3793] = {.lex_state = 556, .external_lex_state = 2},
  [3794] = {.lex_state = 556, .external_lex_state = 2},
  [3795] = {.lex_state = 556, .external_lex_state = 2},
  [3796] = {.lex_state = 556, .external_lex_state = 2},
  [3797] = {.lex_state = 556, .external_lex_state = 2},
  [3798] = {.lex_state = 556, .external_lex_state = 2},
  [3799] = {.lex_state = 556, .external_lex_state = 2},
  [3800] = {.lex_state = 556, .external_lex_state = 2},
  [3801] = {.lex_state = 556, .external_lex_state = 2},
  [3802] = {.lex_state = 556, .external_lex_state = 2},
  [3803] = {.lex_state = 556, .external_lex_state = 2},
  [3804] = {.lex_state = 556, .external_lex_state = 2},
  [3805] = {.lex_state = 556, .external_lex_state = 2},
  [3806] = {.lex_state = 556, .external_lex_state = 2},
  [3807] = {.lex_state = 556, .external_lex_state = 2},
  [3808] = {.lex_state = 556, .external_lex_state = 2},
  [3809] = {.lex_state = 556, .external_lex_state = 2},
  [3810] = {.lex_state = 556, .external_lex_state = 2},
  [3811] = {.lex_state = 556, .external_lex_state = 2},
  [3812] = {.lex_state = 556, .external_lex_state = 2},
  [3813] = {.lex_state = 556, .external_lex_state = 2},
  [3814] = {.lex_state = 556, .external_lex_state = 2},
  [3815] = {.lex_state = 556, .external_lex_state = 2},
  [3816] = {.lex_state = 556, .external_lex_state = 2},
  [3817] = {.lex_state = 556, .external_lex_state = 2},
  [3818] = {.lex_state = 556, .external_lex_state = 2},
  [3819] = {.lex_state = 556, .external_lex_state = 2},
  [3820] = {.lex_state = 556, .external_lex_state = 2},
  [3821] = {.lex_state = 556, .external_lex_state = 2},
  [3822] = {.lex_state = 556, .external_lex_state = 2},
  [3823] = {.lex_state = 556, .external_lex_state = 2},
  [3824] = {.lex_state = 556, .external_lex_state = 2},
  [3825] = {.lex_state = 556, .external_lex_state = 2},
  [3826] = {.lex_state = 556, .external_lex_state = 2},
  [3827] = {.lex_state = 556, .external_lex_state = 2},
  [3828] = {.lex_state = 556, .external_lex_state = 2},
  [3829] = {.lex_state = 556, .external_lex_state = 2},
  [3830] = {.lex_state = 556, .external_lex_state = 2},
  [3831] = {.lex_state = 556, .external_lex_state = 2},
  [3832] = {.lex_state = 556, .external_lex_state = 2},
  [3833] = {.lex_state = 556, .external_lex_state = 2},
  [3834] = {.lex_state = 556, .external_lex_state = 2},
  [3835] = {.lex_state = 556, .external_lex_state = 2},
  [3836] = {.lex_state = 556, .external_lex_state = 2},
  [3837] = {.lex_state = 556, .external_lex_state = 2},
  [3838] = {.lex_state = 556, .external_lex_state = 2},
  [3839] = {.lex_state = 556, .external_lex_state = 2},
  [3840] = {.lex_state = 556, .external_lex_state = 2},
  [3841] = {.lex_state = 556, .external_lex_state = 2},
  [3842] = {.lex_state = 556, .external_lex_state = 2},
  [3843] = {.lex_state = 556, .external_lex_state = 2},
  [3844] = {.lex_state = 556, .external_lex_state = 2},
  [3845] = {.lex_state = 556, .external_lex_state = 2},
  [3846] = {.lex_state = 556, .external_lex_state = 2},
  [3847] = {.lex_state = 556, .external_lex_state = 2},
  [3848] = {.lex_state = 556, .external_lex_state = 2},
  [3849] = {.lex_state = 556, .external_lex_state = 2},
  [3850] = {.lex_state = 556, .external_lex_state = 2},
  [3851] = {.lex_state = 556, .external_lex_state = 2},
  [3852] = {.lex_state = 556, .external_lex_state = 2},
  [3853] = {.lex_state = 556, .external_lex_state = 2},
  [3854] = {.lex_state = 556, .external_lex_state = 2},
  [3855] = {.lex_state = 556, .external_lex_state = 2},
  [3856] = {.lex_state = 556, .external_lex_state = 2},
  [3857] = {.lex_state = 556, .external_lex_state = 2},
  [3858] = {.lex_state = 556, .external_lex_state = 2},
  [3859] = {.lex_state = 556, .external_lex_state = 2},
  [3860] = {.lex_state = 556, .external_lex_state = 2},
  [3861] = {.lex_state = 556, .external_lex_state = 2},
  [3862] = {.lex_state = 556, .external_lex_state = 2},
  [3863] = {.lex_state = 556, .external_lex_state = 2},
  [3864] = {.lex_state = 556, .external_lex_state = 2},
  [3865] = {.lex_state = 556, .external_lex_state = 2},
  [3866] = {.lex_state = 556, .external_lex_state = 2},
  [3867] = {.lex_state = 556, .external_lex_state = 2},
  [3868] = {.lex_state = 556, .external_lex_state = 2},
  [3869] = {.lex_state = 556, .external_lex_state = 2},
  [3870] = {.lex_state = 556, .external_lex_state = 2},
  [3871] = {.lex_state = 556, .external_lex_state = 2},
  [3872] = {.lex_state = 556, .external_lex_state = 2},
  [3873] = {.lex_state = 556, .external_lex_state = 2},
  [3874] = {.lex_state = 556, .external_lex_state = 2},
  [3875] = {.lex_state = 556, .external_lex_state = 2},
  [3876] = {.lex_state = 556, .external_lex_state = 2},
  [3877] = {.lex_state = 556, .external_lex_state = 2},
  [3878] = {.lex_state = 556, .external_lex_state = 2},
  [3879] = {.lex_state = 556, .external_lex_state = 2},
  [3880] = {.lex_state = 556, .external_lex_state = 2},
  [3881] = {.lex_state = 556, .external_lex_state = 2},
  [3882] = {.lex_state = 556, .external_lex_state = 2},
  [3883] = {.lex_state = 556, .external_lex_state = 2},
  [3884] = {.lex_state = 556, .external_lex_state = 2},
  [3885] = {.lex_state = 556, .external_lex_state = 2},
  [3886] = {.lex_state = 556, .external_lex_state = 2},
  [3887] = {.lex_state = 556, .external_lex_state = 2},
  [3888] = {.lex_state = 556, .external_lex_state = 2},
  [3889] = {.lex_state = 556, .external_lex_state = 2},
  [3890] = {.lex_state = 556, .external_lex_state = 2},
  [3891] = {.lex_state = 556, .external_lex_state = 2},
  [3892] = {.lex_state = 556, .external_lex_state = 2},
  [3893] = {.lex_state = 556, .external_lex_state = 2},
  [3894] = {.lex_state = 556, .external_lex_state = 2},
  [3895] = {.lex_state = 556, .external_lex_state = 2},
  [3896] = {.lex_state = 556, .external_lex_state = 2},
  [3897] = {.lex_state = 556, .external_lex_state = 2},
  [3898] = {.lex_state = 556, .external_lex_state = 2},
  [3899] = {.lex_state = 556, .external_lex_state = 2},
  [3900] = {.lex_state = 556, .external_lex_state = 2},
  [3901] = {.lex_state = 556, .external_lex_state = 2},
  [3902] = {.lex_state = 556, .external_lex_state = 2},
  [3903] = {.lex_state = 556, .external_lex_state = 2},
  [3904] = {.lex_state = 556, .external_lex_state = 2},
  [3905] = {.lex_state = 556, .external_lex_state = 2},
  [3906] = {.lex_state = 556, .external_lex_state = 2},
  [3907] = {.lex_state = 556, .external_lex_state = 2},
  [3908] = {.lex_state = 556, .external_lex_state = 2},
  [3909] = {.lex_state = 556, .external_lex_state = 2},
  [3910] = {.lex_state = 556, .external_lex_state = 2},
  [3911] = {.lex_state = 556, .external_lex_state = 2},
  [3912] = {.lex_state = 556, .external_lex_state = 2},
  [3913] = {.lex_state = 556, .external_lex_state = 2},
  [3914] = {.lex_state = 556, .external_lex_state = 2},
  [3915] = {.lex_state = 556, .external_lex_state = 2},
  [3916] = {.lex_state = 556, .external_lex_state = 2},
  [3917] = {.lex_state = 556, .external_lex_state = 2},
  [3918] = {.lex_state = 556, .external_lex_state = 2},
  [3919] = {.lex_state = 556, .external_lex_state = 2},
  [3920] = {.lex_state = 556, .external_lex_state = 2},
  [3921] = {.lex_state = 556, .external_lex_state = 2},
  [3922] = {.lex_state = 556, .external_lex_state = 2},
  [3923] = {.lex_state = 556, .external_lex_state = 2},
  [3924] = {.lex_state = 556, .external_lex_state = 2},
  [3925] = {.lex_state = 556, .external_lex_state = 2},
  [3926] = {.lex_state = 556, .external_lex_state = 2},
  [3927] = {.lex_state = 556, .external_lex_state = 2},
  [3928] = {.lex_state = 556, .external_lex_state = 2},
  [3929] = {.lex_state = 556, .external_lex_state = 2},
  [3930] = {.lex_state = 556, .external_lex_state = 2},
  [3931] = {.lex_state = 556, .external_lex_state = 2},
  [3932] = {.lex_state = 556, .external_lex_state = 2},
  [3933] = {.lex_state = 556, .external_lex_state = 2},
  [3934] = {.lex_state = 556, .external_lex_state = 2},
  [3935] = {.lex_state = 556, .external_lex_state = 2},
  [3936] = {.lex_state = 556, .external_lex_state = 2},
  [3937] = {.lex_state = 556, .external_lex_state = 2},
  [3938] = {.lex_state = 556, .external_lex_state = 2},
  [3939] = {.lex_state = 556, .external_lex_state = 2},
  [3940] = {.lex_state = 556, .external_lex_state = 2},
  [3941] = {.lex_state = 556, .external_lex_state = 2},
  [3942] = {.lex_state = 556, .external_lex_state = 2},
  [3943] = {.lex_state = 556, .external_lex_state = 2},
  [3944] = {.lex_state = 556, .external_lex_state = 2},
  [3945] = {.lex_state = 556, .external_lex_state = 2},
  [3946] = {.lex_state = 556, .external_lex_state = 2},
  [3947] = {.lex_state = 556, .external_lex_state = 2},
  [3948] = {.lex_state = 556, .external_lex_state = 2},
  [3949] = {.lex_state = 556, .external_lex_state = 2},
  [3950] = {.lex_state = 556, .external_lex_state = 2},
  [3951] = {.lex_state = 556, .external_lex_state = 2},
  [3952] = {.lex_state = 556, .external_lex_state = 2},
  [3953] = {.lex_state = 556, .external_lex_state = 2},
  [3954] = {.lex_state = 556, .external_lex_state = 2},
  [3955] = {.lex_state = 556, .external_lex_state = 2},
  [3956] = {.lex_state = 556, .external_lex_state = 2},
  [3957] = {.lex_state = 556, .external_lex_state = 2},
  [3958] = {.lex_state = 556, .external_lex_state = 2},
  [3959] = {.lex_state = 556, .external_lex_state = 2},
  [3960] = {.lex_state = 556, .external_lex_state = 2},
  [3961] = {.lex_state = 556, .external_lex_state = 2},
  [3962] = {.lex_state = 556, .external_lex_state = 2},
  [3963] = {.lex_state = 556, .external_lex_state = 2},
  [3964] = {.lex_state = 556, .external_lex_state = 2},
  [3965] = {.lex_state = 556, .external_lex_state = 2},
  [3966] = {.lex_state = 556, .external_lex_state = 2},
  [3967] = {.lex_state = 556, .external_lex_state = 2},
  [3968] = {.lex_state = 556, .external_lex_state = 2},
  [3969] = {.lex_state = 556, .external_lex_state = 2},
  [3970] = {.lex_state = 556, .external_lex_state = 2},
  [3971] = {.lex_state = 556, .external_lex_state = 2},
  [3972] = {.lex_state = 556, .external_lex_state = 2},
  [3973] = {.lex_state = 556, .external_lex_state = 2},
  [3974] = {.lex_state = 556, .external_lex_state = 2},
  [3975] = {.lex_state = 556, .external_lex_state = 2},
  [3976] = {.lex_state = 556, .external_lex_state = 2},
  [3977] = {.lex_state = 556, .external_lex_state = 2},
  [3978] = {.lex_state = 556, .external_lex_state = 2},
  [3979] = {.lex_state = 556, .external_lex_state = 2},
  [3980] = {.lex_state = 556, .external_lex_state = 2},
  [3981] = {.lex_state = 556, .external_lex_state = 2},
  [3982] = {.lex_state = 556, .external_lex_state = 2},
  [3983] = {.lex_state = 556, .external_lex_state = 2},
  [3984] = {.lex_state = 556, .external_lex_state = 2},
  [3985] = {.lex_state = 556, .external_lex_state = 2},
  [3986] = {.lex_state = 556, .external_lex_state = 2},
  [3987] = {.lex_state = 556, .external_lex_state = 2},
  [3988] = {.lex_state = 556, .external_lex_state = 2},
  [3989] = {.lex_state = 556, .external_lex_state = 2},
  [3990] = {.lex_state = 556, .external_lex_state = 2},
  [3991] = {.lex_state = 556, .external_lex_state = 2},
  [3992] = {.lex_state = 556, .external_lex_state = 2},
  [3993] = {.lex_state = 556, .external_lex_state = 2},
  [3994] = {.lex_state = 556, .external_lex_state = 2},
  [3995] = {.lex_state = 556, .external_lex_state = 2},
  [3996] = {.lex_state = 556, .external_lex_state = 2},
  [3997] = {.lex_state = 556, .external_lex_state = 2},
  [3998] = {.lex_state = 556, .external_lex_state = 2},
  [3999] = {.lex_state = 556, .external_lex_state = 2},
  [4000] = {.lex_state = 556, .external_lex_state = 2},
  [4001] = {.lex_state = 556, .external_lex_state = 2},
  [4002] = {.lex_state = 556, .external_lex_state = 2},
  [4003] = {.lex_state = 556, .external_lex_state = 2},
  [4004] = {.lex_state = 556, .external_lex_state = 2},
  [4005] = {.lex_state = 556, .external_lex_state = 2},
  [4006] = {.lex_state = 556, .external_lex_state = 2},
  [4007] = {.lex_state = 556, .external_lex_state = 2},
  [4008] = {.lex_state = 556, .external_lex_state = 2},
  [4009] = {.lex_state = 556, .external_lex_state = 2},
  [4010] = {.lex_state = 556, .external_lex_state = 2},
  [4011] = {.lex_state = 556, .external_lex_state = 2},
  [4012] = {.lex_state = 556, .external_lex_state = 2},
  [4013] = {.lex_state = 556, .external_lex_state = 2},
  [4014] = {.lex_state = 556, .external_lex_state = 2},
  [4015] = {.lex_state = 556, .external_lex_state = 2},
  [4016] = {.lex_state = 556, .external_lex_state = 2},
  [4017] = {.lex_state = 556, .external_lex_state = 2},
  [4018] = {.lex_state = 556, .external_lex_state = 2},
  [4019] = {.lex_state = 556, .external_lex_state = 2},
  [4020] = {.lex_state = 556, .external_lex_state = 2},
  [4021] = {.lex_state = 556, .external_lex_state = 2},
  [4022] = {.lex_state = 556, .external_lex_state = 2},
  [4023] = {.lex_state = 556, .external_lex_state = 2},
  [4024] = {.lex_state = 556, .external_lex_state = 2},
  [4025] = {.lex_state = 556, .external_lex_state = 2},
  [4026] = {.lex_state = 556, .external_lex_state = 2},
  [4027] = {.lex_state = 556, .external_lex_state = 2},
  [4028] = {.lex_state = 556, .external_lex_state = 2},
  [4029] = {.lex_state = 556, .external_lex_state = 2},
  [4030] = {.lex_state = 556, .external_lex_state = 2},
  [4031] = {.lex_state = 556, .external_lex_state = 2},
  [4032] = {.lex_state = 556, .external_lex_state = 2},
  [4033] = {.lex_state = 556, .external_lex_state = 2},
  [4034] = {.lex_state = 556, .external_lex_state = 2},
  [4035] = {.lex_state = 556, .external_lex_state = 2},
  [4036] = {.lex_state = 556, .external_lex_state = 2},
  [4037] = {.lex_state = 556, .external_lex_state = 2},
  [4038] = {.lex_state = 556, .external_lex_state = 2},
  [4039] = {.lex_state = 556, .external_lex_state = 2},
  [4040] = {.lex_state = 556, .external_lex_state = 2},
  [4041] = {.lex_state = 556, .external_lex_state = 2},
  [4042] = {.lex_state = 556, .external_lex_state = 2},
  [4043] = {.lex_state = 556, .external_lex_state = 2},
  [4044] = {.lex_state = 556, .external_lex_state = 2},
  [4045] = {.lex_state = 556, .external_lex_state = 2},
  [4046] = {.lex_state = 556, .external_lex_state = 2},
  [4047] = {.lex_state = 556, .external_lex_state = 2},
  [4048] = {.lex_state = 556, .external_lex_state = 2},
  [4049] = {.lex_state = 556, .external_lex_state = 2},
  [4050] = {.lex_state = 556, .external_lex_state = 2},
  [4051] = {.lex_state = 556, .external_lex_state = 2},
  [4052] = {.lex_state = 556, .external_lex_state = 2},
  [4053] = {.lex_state = 556, .external_lex_state = 2},
  [4054] = {.lex_state = 556, .external_lex_state = 2},
  [4055] = {.lex_state = 556, .external_lex_state = 2},
  [4056] = {.lex_state = 556, .external_lex_state = 2},
  [4057] = {.lex_state = 556, .external_lex_state = 2},
  [4058] = {.lex_state = 556, .external_lex_state = 2},
  [4059] = {.lex_state = 556, .external_lex_state = 2},
  [4060] = {.lex_state = 556, .external_lex_state = 2},
  [4061] = {.lex_state = 556, .external_lex_state = 2},
  [4062] = {.lex_state = 556, .external_lex_state = 2},
  [4063] = {.lex_state = 556, .external_lex_state = 2},
  [4064] = {.lex_state = 556, .external_lex_state = 2},
  [4065] = {.lex_state = 556, .external_lex_state = 2},
  [4066] = {.lex_state = 556, .external_lex_state = 2},
  [4067] = {.lex_state = 556, .external_lex_state = 2},
  [4068] = {.lex_state = 556, .external_lex_state = 2},
  [4069] = {.lex_state = 556, .external_lex_state = 2},
  [4070] = {.lex_state = 556, .external_lex_state = 2},
  [4071] = {.lex_state = 556, .external_lex_state = 2},
  [4072] = {.lex_state = 556, .external_lex_state = 2},
  [4073] = {.lex_state = 556, .external_lex_state = 2},
  [4074] = {.lex_state = 556, .external_lex_state = 2},
  [4075] = {.lex_state = 556, .external_lex_state = 2},
  [4076] = {.lex_state = 556, .external_lex_state = 2},
  [4077] = {.lex_state = 556, .external_lex_state = 2},
  [4078] = {.lex_state = 556, .external_lex_state = 2},
  [4079] = {.lex_state = 556, .external_lex_state = 2},
  [4080] = {.lex_state = 556, .external_lex_state = 2},
  [4081] = {.lex_state = 556, .external_lex_state = 2},
  [4082] = {.lex_state = 556, .external_lex_state = 2},
  [4083] = {.lex_state = 556, .external_lex_state = 2},
  [4084] = {.lex_state = 556, .external_lex_state = 2},
  [4085] = {.lex_state = 556, .external_lex_state = 2},
  [4086] = {.lex_state = 556, .external_lex_state = 2},
  [4087] = {.lex_state = 556, .external_lex_state = 2},
  [4088] = {.lex_state = 556, .external_lex_state = 2},
  [4089] = {.lex_state = 556, .external_lex_state = 2},
  [4090] = {.lex_state = 556, .external_lex_state = 2},
  [4091] = {.lex_state = 556, .external_lex_state = 2},
  [4092] = {.lex_state = 556, .external_lex_state = 2},
  [4093] = {.lex_state = 556, .external_lex_state = 2},
  [4094] = {.lex_state = 556, .external_lex_state = 2},
  [4095] = {.lex_state = 556, .external_lex_state = 2},
  [4096] = {.lex_state = 556, .external_lex_state = 2},
  [4097] = {.lex_state = 556, .external_lex_state = 2},
  [4098] = {.lex_state = 556, .external_lex_state = 2},
  [4099] = {.lex_state = 556, .external_lex_state = 2},
  [4100] = {.lex_state = 556, .external_lex_state = 2},
  [4101] = {.lex_state = 556, .external_lex_state = 2},
  [4102] = {.lex_state = 556, .external_lex_state = 2},
  [4103] = {.lex_state = 556, .external_lex_state = 2},
  [4104] = {.lex_state = 556, .external_lex_state = 2},
  [4105] = {.lex_state = 556, .external_lex_state = 2},
  [4106] = {.lex_state = 556, .external_lex_state = 2},
  [4107] = {.lex_state = 556, .external_lex_state = 2},
  [4108] = {.lex_state = 556, .external_lex_state = 2},
  [4109] = {.lex_state = 556, .external_lex_state = 2},
  [4110] = {.lex_state = 556, .external_lex_state = 2},
  [4111] = {.lex_state = 556, .external_lex_state = 2},
  [4112] = {.lex_state = 556, .external_lex_state = 2},
  [4113] = {.lex_state = 556, .external_lex_state = 2},
  [4114] = {.lex_state = 556, .external_lex_state = 2},
  [4115] = {.lex_state = 556, .external_lex_state = 2},
  [4116] = {.lex_state = 556, .external_lex_state = 2},
  [4117] = {.lex_state = 556, .external_lex_state = 2},
  [4118] = {.lex_state = 556, .external_lex_state = 2},
  [4119] = {.lex_state = 556, .external_lex_state = 2},
  [4120] = {.lex_state = 556, .external_lex_state = 2},
  [4121] = {.lex_state = 556, .external_lex_state = 2},
  [4122] = {.lex_state = 556, .external_lex_state = 2},
  [4123] = {.lex_state = 556, .external_lex_state = 2},
  [4124] = {.lex_state = 556, .external_lex_state = 2},
  [4125] = {.lex_state = 556, .external_lex_state = 2},
  [4126] = {.lex_state = 556, .external_lex_state = 2},
  [4127] = {.lex_state = 556, .external_lex_state = 2},
  [4128] = {.lex_state = 556, .external_lex_state = 2},
  [4129] = {.lex_state = 556, .external_lex_state = 2},
  [4130] = {.lex_state = 556, .external_lex_state = 2},
  [4131] = {.lex_state = 556, .external_lex_state = 2},
  [4132] = {.lex_state = 556, .external_lex_state = 2},
  [4133] = {.lex_state = 556, .external_lex_state = 2},
  [4134] = {.lex_state = 556, .external_lex_state = 2},
  [4135] = {.lex_state = 556, .external_lex_state = 2},
  [4136] = {.lex_state = 556, .external_lex_state = 2},
  [4137] = {.lex_state = 556, .external_lex_state = 2},
  [4138] = {.lex_state = 556, .external_lex_state = 2},
  [4139] = {.lex_state = 556, .external_lex_state = 2},
  [4140] = {.lex_state = 556, .external_lex_state = 2},
  [4141] = {.lex_state = 556, .external_lex_state = 2},
  [4142] = {.lex_state = 556, .external_lex_state = 2},
  [4143] = {.lex_state = 556, .external_lex_state = 2},
  [4144] = {.lex_state = 556, .external_lex_state = 2},
  [4145] = {.lex_state = 556, .external_lex_state = 2},
  [4146] = {.lex_state = 556, .external_lex_state = 2},
  [4147] = {.lex_state = 556, .external_lex_state = 2},
  [4148] = {.lex_state = 556, .external_lex_state = 2},
  [4149] = {.lex_state = 556, .external_lex_state = 2},
  [4150] = {.lex_state = 556, .external_lex_state = 2},
  [4151] = {.lex_state = 556, .external_lex_state = 2},
  [4152] = {.lex_state = 556, .external_lex_state = 2},
  [4153] = {.lex_state = 556, .external_lex_state = 2},
  [4154] = {.lex_state = 556, .external_lex_state = 2},
  [4155] = {.lex_state = 556, .external_lex_state = 2},
  [4156] = {.lex_state = 556, .external_lex_state = 2},
  [4157] = {.lex_state = 556, .external_lex_state = 2},
  [4158] = {.lex_state = 556, .external_lex_state = 2},
  [4159] = {.lex_state = 556, .external_lex_state = 2},
  [4160] = {.lex_state = 556, .external_lex_state = 2},
  [4161] = {.lex_state = 556, .external_lex_state = 2},
  [4162] = {.lex_state = 556, .external_lex_state = 2},
  [4163] = {.lex_state = 556, .external_lex_state = 2},
  [4164] = {.lex_state = 556, .external_lex_state = 2},
  [4165] = {.lex_state = 556, .external_lex_state = 2},
  [4166] = {.lex_state = 556, .external_lex_state = 2},
  [4167] = {.lex_state = 556, .external_lex_state = 2},
  [4168] = {.lex_state = 556, .external_lex_state = 2},
  [4169] = {.lex_state = 556, .external_lex_state = 2},
  [4170] = {.lex_state = 556, .external_lex_state = 2},
  [4171] = {.lex_state = 556, .external_lex_state = 2},
  [4172] = {.lex_state = 556, .external_lex_state = 2},
  [4173] = {.lex_state = 556, .external_lex_state = 2},
  [4174] = {.lex_state = 556, .external_lex_state = 2},
  [4175] = {.lex_state = 556, .external_lex_state = 2},
  [4176] = {.lex_state = 556, .external_lex_state = 2},
  [4177] = {.lex_state = 556, .external_lex_state = 2},
  [4178] = {.lex_state = 556, .external_lex_state = 2},
  [4179] = {.lex_state = 556, .external_lex_state = 2},
  [4180] = {.lex_state = 556, .external_lex_state = 2},
  [4181] = {.lex_state = 556, .external_lex_state = 2},
  [4182] = {.lex_state = 556, .external_lex_state = 2},
  [4183] = {.lex_state = 556, .external_lex_state = 2},
  [4184] = {.lex_state = 556, .external_lex_state = 2},
  [4185] = {.lex_state = 556, .external_lex_state = 2},
  [4186] = {.lex_state = 556, .external_lex_state = 2},
  [4187] = {.lex_state = 556, .external_lex_state = 2},
  [4188] = {.lex_state = 556, .external_lex_state = 2},
  [4189] = {.lex_state = 556, .external_lex_state = 2},
  [4190] = {.lex_state = 556, .external_lex_state = 2},
  [4191] = {.lex_state = 556, .external_lex_state = 2},
  [4192] = {.lex_state = 556, .external_lex_state = 2},
  [4193] = {.lex_state = 556, .external_lex_state = 2},
  [4194] = {.lex_state = 556, .external_lex_state = 2},
  [4195] = {.lex_state = 556, .external_lex_state = 2},
  [4196] = {.lex_state = 556, .external_lex_state = 2},
  [4197] = {.lex_state = 556, .external_lex_state = 2},
  [4198] = {.lex_state = 556, .external_lex_state = 2},
  [4199] = {.lex_state = 556, .external_lex_state = 2},
  [4200] = {.lex_state = 556, .external_lex_state = 2},
  [4201] = {.lex_state = 556, .external_lex_state = 2},
  [4202] = {.lex_state = 556, .external_lex_state = 2},
  [4203] = {.lex_state = 556, .external_lex_state = 2},
  [4204] = {.lex_state = 556, .external_lex_state = 2},
  [4205] = {.lex_state = 556, .external_lex_state = 2},
  [4206] = {.lex_state = 556, .external_lex_state = 2},
  [4207] = {.lex_state = 556, .external_lex_state = 2},
  [4208] = {.lex_state = 556, .external_lex_state = 2},
  [4209] = {.lex_state = 556, .external_lex_state = 2},
  [4210] = {.lex_state = 556, .external_lex_state = 2},
  [4211] = {.lex_state = 556, .external_lex_state = 2},
  [4212] = {.lex_state = 556, .external_lex_state = 2},
  [4213] = {.lex_state = 556, .external_lex_state = 2},
  [4214] = {.lex_state = 556, .external_lex_state = 2},
  [4215] = {.lex_state = 556, .external_lex_state = 2},
  [4216] = {.lex_state = 556, .external_lex_state = 2},
  [4217] = {.lex_state = 556, .external_lex_state = 2},
  [4218] = {.lex_state = 556, .external_lex_state = 2},
  [4219] = {.lex_state = 556, .external_lex_state = 2},
  [4220] = {.lex_state = 556, .external_lex_state = 2},
  [4221] = {.lex_state = 556, .external_lex_state = 2},
  [4222] = {.lex_state = 556, .external_lex_state = 2},
  [4223] = {.lex_state = 556, .external_lex_state = 2},
  [4224] = {.lex_state = 556, .external_lex_state = 2},
  [4225] = {.lex_state = 556, .external_lex_state = 2},
  [4226] = {.lex_state = 556, .external_lex_state = 2},
  [4227] = {.lex_state = 556, .external_lex_state = 2},
  [4228] = {.lex_state = 556, .external_lex_state = 2},
  [4229] = {.lex_state = 556, .external_lex_state = 2},
  [4230] = {.lex_state = 556, .external_lex_state = 2},
  [4231] = {.lex_state = 556, .external_lex_state = 2},
  [4232] = {.lex_state = 556, .external_lex_state = 2},
  [4233] = {.lex_state = 556, .external_lex_state = 2},
  [4234] = {.lex_state = 556, .external_lex_state = 2},
  [4235] = {.lex_state = 556, .external_lex_state = 2},
  [4236] = {.lex_state = 556, .external_lex_state = 2},
  [4237] = {.lex_state = 556, .external_lex_state = 2},
  [4238] = {.lex_state = 556, .external_lex_state = 2},
  [4239] = {.lex_state = 556, .external_lex_state = 2},
  [4240] = {.lex_state = 556, .external_lex_state = 2},
  [4241] = {.lex_state = 556, .external_lex_state = 2},
  [4242] = {.lex_state = 556, .external_lex_state = 2},
  [4243] = {.lex_state = 27, .external_lex_state = 4},
  [4244] = {.lex_state = 24, .external_lex_state = 4},
  [4245] = {.lex_state = 498, .external_lex_state = 4},
  [4246] = {.lex_state = 18, .external_lex_state = 4},
  [4247] = {.lex_state = 313, .external_lex_state = 4},
  [4248] = {.lex_state = 19, .external_lex_state = 4},
  [4249] = {.lex_state = 25, .external_lex_state = 4},
  [4250] = {.lex_state = 26, .external_lex_state = 4},
  [4251] = {.lex_state = 4, .external_lex_state = 4},
  [4252] = {.lex_state = 90, .external_lex_state = 2},
  [4253] = {.lex_state = 88, .external_lex_state = 2},
  [4254] = {.lex_state = 510, .external_lex_state = 2},
  [4255] = {.lex_state = 82, .external_lex_state = 2},
  [4256] = {.lex_state = 83, .external_lex_state = 2},
  [4257] = {.lex_state = 325, .external_lex_state = 2},
  [4258] = {.lex_state = 89, .external_lex_state = 2},
  [4259] = {.lex_state = 509, .external_lex_state = 2},
  [4260] = {.lex_state = 75, .external_lex_state = 2},
  [4261] = {.lex_state = 504, .external_lex_state = 4},
  [4262] = {.lex_state = 64, .external_lex_state = 4},
  [4263] = {.lex_state = 67, .external_lex_state = 4},
  [4264] = {.lex_state = 321, .external_lex_state = 4},
  [4265] = {.lex_state = 65, .external_lex_state = 4},
  [4266] = {.lex_state = 63, .external_lex_state = 4},
  [4267] = {.lex_state = 62, .external_lex_state = 4},
  [4268] = {.lex_state = 37, .external_lex_state = 4},
  [4269] = {.lex_state = 66, .external_lex_state = 4},
  [4270] = {.lex_state = 495, .external_lex_state = 3},
  [4271] = {.lex_state = 499, .external_lex_state = 3},
  [4272] = {.lex_state = 495, .external_lex_state = 3},
  [4273] = {.lex_state = 499, .external_lex_state = 3},
  [4274] = {.lex_state = 495, .external_lex_state = 3},
  [4275] = {.lex_state = 7, .external_lex_state = 3},
  [4276] = {.lex_state = 7, .external_lex_state = 3},
  [4277] = {.lex_state = 499, .external_lex_state = 3},
  [4278] = {.lex_state = 7, .external_lex_state = 3},
  [4279] = {.lex_state = 105, .external_lex_state = 3},
  [4280] = {.lex_state = 513, .external_lex_state = 3},
  [4281] = {.lex_state = 24, .external_lex_state = 3},
  [4282] = {.lex_state = 105, .external_lex_state = 3},
  [4283] = {.lex_state = 27, .external_lex_state = 3},
  [4284] = {.lex_state = 20, .external_lex_state = 4},
  [4285] = {.lex_state = 27, .external_lex_state = 3},
  [4286] = {.lex_state = 498, .external_lex_state = 3},
  [4287] = {.lex_state = 23, .external_lex_state = 4},
  [4288] = {.lex_state = 20, .external_lex_state = 4},
  [4289] = {.lex_state = 23, .external_lex_state = 4},
  [4290] = {.lex_state = 108, .external_lex_state = 3},
  [4291] = {.lex_state = 101, .external_lex_state = 4},
  [4292] = {.lex_state = 24, .external_lex_state = 3},
  [4293] = {.lex_state = 108, .external_lex_state = 3},
  [4294] = {.lex_state = 497, .external_lex_state = 4},
  [4295] = {.lex_state = 6, .external_lex_state = 3},
  [4296] = {.lex_state = 23, .external_lex_state = 4},
  [4297] = {.lex_state = 104, .external_lex_state = 4},
  [4298] = {.lex_state = 8, .external_lex_state = 3},
  [4299] = {.lex_state = 108, .external_lex_state = 3},
  [4300] = {.lex_state = 513, .external_lex_state = 3},
  [4301] = {.lex_state = 498, .external_lex_state = 3},
  [4302] = {.lex_state = 104, .external_lex_state = 4},
  [4303] = {.lex_state = 20, .external_lex_state = 4},
  [4304] = {.lex_state = 101, .external_lex_state = 4},
  [4305] = {.lex_state = 512, .external_lex_state = 4},
  [4306] = {.lex_state = 498, .external_lex_state = 3},
  [4307] = {.lex_state = 101, .external_lex_state = 4},
  [4308] = {.lex_state = 20, .external_lex_state = 4},
  [4309] = {.lex_state = 104, .external_lex_state = 4},
  [4310] = {.lex_state = 512, .external_lex_state = 4},
  [4311] = {.lex_state = 24, .external_lex_state = 3},
  [4312] = {.lex_state = 497, .external_lex_state = 4},
  [4313] = {.lex_state = 512, .external_lex_state = 4},
  [4314] = {.lex_state = 498, .external_lex_state = 3},
  [4315] = {.lex_state = 497, .external_lex_state = 4},
  [4316] = {.lex_state = 513, .external_lex_state = 3},
  [4317] = {.lex_state = 108, .external_lex_state = 3},
  [4318] = {.lex_state = 27, .external_lex_state = 3},
  [4319] = {.lex_state = 23, .external_lex_state = 4},
  [4320] = {.lex_state = 105, .external_lex_state = 3},
  [4321] = {.lex_state = 5, .external_lex_state = 3},
  [4322] = {.lex_state = 5, .external_lex_state = 3},
  [4323] = {.lex_state = 105, .external_lex_state = 3},
  [4324] = {.lex_state = 513, .external_lex_state = 3},
  [4325] = {.lex_state = 27, .external_lex_state = 3},
  [4326] = {.lex_state = 8, .external_lex_state = 3},
  [4327] = {.lex_state = 497, .external_lex_state = 4},
  [4328] = {.lex_state = 310, .external_lex_state = 3},
  [4329] = {.lex_state = 6, .external_lex_state = 3},
  [4330] = {.lex_state = 6, .external_lex_state = 3},
  [4331] = {.lex_state = 24, .external_lex_state = 3},
  [4332] = {.lex_state = 104, .external_lex_state = 4},
  [4333] = {.lex_state = 8, .external_lex_state = 3},
  [4334] = {.lex_state = 5, .external_lex_state = 3},
  [4335] = {.lex_state = 101, .external_lex_state = 4},
  [4336] = {.lex_state = 108, .external_lex_state = 3},
  [4337] = {.lex_state = 513, .external_lex_state = 3},
  [4338] = {.lex_state = 105, .external_lex_state = 3},
  [4339] = {.lex_state = 512, .external_lex_state = 4},
  [4340] = {.lex_state = 498, .external_lex_state = 4},
  [4341] = {.lex_state = 88, .external_lex_state = 3},
  [4342] = {.lex_state = 90, .external_lex_state = 3},
  [4343] = {.lex_state = 98, .external_lex_state = 4},
  [4344] = {.lex_state = 100, .external_lex_state = 3},
  [4345] = {.lex_state = 98, .external_lex_state = 4},
  [4346] = {.lex_state = 98, .external_lex_state = 4},
  [4347] = {.lex_state = 98, .external_lex_state = 4},
  [4348] = {.lex_state = 510, .external_lex_state = 3},
  [4349] = {.lex_state = 16, .external_lex_state = 4},
  [4350] = {.lex_state = 25, .external_lex_state = 3},
  [4351] = {.lex_state = 104, .external_lex_state = 4},
  [4352] = {.lex_state = 101, .external_lex_state = 4},
  [4353] = {.lex_state = 104, .external_lex_state = 4},
  [4354] = {.lex_state = 101, .external_lex_state = 4},
  [4355] = {.lex_state = 24, .external_lex_state = 4},
  [4356] = {.lex_state = 24, .external_lex_state = 4},
  [4357] = {.lex_state = 100, .external_lex_state = 3},
  [4358] = {.lex_state = 101, .external_lex_state = 4},
  [4359] = {.lex_state = 97, .external_lex_state = 4},
  [4360] = {.lex_state = 20, .external_lex_state = 4},
  [4361] = {.lex_state = 24, .external_lex_state = 4},
  [4362] = {.lex_state = 24, .external_lex_state = 4},
  [4363] = {.lex_state = 20, .external_lex_state = 4},
  [4364] = {.lex_state = 99, .external_lex_state = 3},
  [4365] = {.lex_state = 97, .external_lex_state = 4},
  [4366] = {.lex_state = 97, .external_lex_state = 4},
  [4367] = {.lex_state = 97, .external_lex_state = 4},
  [4368] = {.lex_state = 310, .external_lex_state = 3},
  [4369] = {.lex_state = 104, .external_lex_state = 4},
  [4370] = {.lex_state = 104, .external_lex_state = 4},
  [4371] = {.lex_state = 104, .external_lex_state = 4},
  [4372] = {.lex_state = 104, .external_lex_state = 4},
  [4373] = {.lex_state = 104, .external_lex_state = 4},
  [4374] = {.lex_state = 104, .external_lex_state = 4},
  [4375] = {.lex_state = 104, .external_lex_state = 4},
  [4376] = {.lex_state = 104, .external_lex_state = 4},
  [4377] = {.lex_state = 104, .external_lex_state = 4},
  [4378] = {.lex_state = 495, .external_lex_state = 4},
  [4379] = {.lex_state = 495, .external_lex_state = 4},
  [4380] = {.lex_state = 104, .external_lex_state = 4},
  [4381] = {.lex_state = 495, .external_lex_state = 4},
  [4382] = {.lex_state = 18, .external_lex_state = 3},
  [4383] = {.lex_state = 495, .external_lex_state = 4},
  [4384] = {.lex_state = 20, .external_lex_state = 4},
  [4385] = {.lex_state = 495, .external_lex_state = 4},
  [4386] = {.lex_state = 20, .external_lex_state = 4},
  [4387] = {.lex_state = 20, .external_lex_state = 4},
  [4388] = {.lex_state = 495, .external_lex_state = 4},
  [4389] = {.lex_state = 20, .external_lex_state = 4},
  [4390] = {.lex_state = 497, .external_lex_state = 4},
  [4391] = {.lex_state = 20, .external_lex_state = 4},
  [4392] = {.lex_state = 495, .external_lex_state = 4},
  [4393] = {.lex_state = 20, .external_lex_state = 4},
  [4394] = {.lex_state = 20, .external_lex_state = 4},
  [4395] = {.lex_state = 497, .external_lex_state = 4},
  [4396] = {.lex_state = 20, .external_lex_state = 4},
  [4397] = {.lex_state = 20, .external_lex_state = 4},
  [4398] = {.lex_state = 20, .external_lex_state = 4},
  [4399] = {.lex_state = 7, .external_lex_state = 3},
  [4400] = {.lex_state = 9, .external_lex_state = 3},
  [4401] = {.lex_state = 102, .external_lex_state = 4},
  [4402] = {.lex_state = 106, .external_lex_state = 3},
  [4403] = {.lex_state = 102, .external_lex_state = 4},
  [4404] = {.lex_state = 102, .external_lex_state = 4},
  [4405] = {.lex_state = 102, .external_lex_state = 4},
  [4406] = {.lex_state = 313, .external_lex_state = 3},
  [4407] = {.lex_state = 497, .external_lex_state = 4},
  [4408] = {.lex_state = 499, .external_lex_state = 4},
  [4409] = {.lex_state = 499, .external_lex_state = 4},
  [4410] = {.lex_state = 312, .external_lex_state = 4},
  [4411] = {.lex_state = 313, .external_lex_state = 3},
  [4412] = {.lex_state = 312, .external_lex_state = 4},
  [4413] = {.lex_state = 498, .external_lex_state = 4},
  [4414] = {.lex_state = 18, .external_lex_state = 3},
  [4415] = {.lex_state = 497, .external_lex_state = 4},
  [4416] = {.lex_state = 497, .external_lex_state = 4},
  [4417] = {.lex_state = 497, .external_lex_state = 4},
  [4418] = {.lex_state = 499, .external_lex_state = 4},
  [4419] = {.lex_state = 312, .external_lex_state = 4},
  [4420] = {.lex_state = 498, .external_lex_state = 4},
  [4421] = {.lex_state = 498, .external_lex_state = 4},
  [4422] = {.lex_state = 497, .external_lex_state = 4},
  [4423] = {.lex_state = 497, .external_lex_state = 4},
  [4424] = {.lex_state = 497, .external_lex_state = 4},
  [4425] = {.lex_state = 312, .external_lex_state = 4},
  [4426] = {.lex_state = 497, .external_lex_state = 4},
  [4427] = {.lex_state = 497, .external_lex_state = 4},
  [4428] = {.lex_state = 497, .external_lex_state = 4},
  [4429] = {.lex_state = 88, .external_lex_state = 3},
  [4430] = {.lex_state = 499, .external_lex_state = 4},
  [4431] = {.lex_state = 499, .external_lex_state = 4},
  [4432] = {.lex_state = 84, .external_lex_state = 4},
  [4433] = {.lex_state = 88, .external_lex_state = 3},
  [4434] = {.lex_state = 84, .external_lex_state = 4},
  [4435] = {.lex_state = 99, .external_lex_state = 3},
  [4436] = {.lex_state = 499, .external_lex_state = 4},
  [4437] = {.lex_state = 84, .external_lex_state = 4},
  [4438] = {.lex_state = 499, .external_lex_state = 4},
  [4439] = {.lex_state = 84, .external_lex_state = 4},
  [4440] = {.lex_state = 19, .external_lex_state = 3},
  [4441] = {.lex_state = 16, .external_lex_state = 4},
  [4442] = {.lex_state = 17, .external_lex_state = 4},
  [4443] = {.lex_state = 19, .external_lex_state = 3},
  [4444] = {.lex_state = 17, .external_lex_state = 4},
  [4445] = {.lex_state = 17, .external_lex_state = 4},
  [4446] = {.lex_state = 17, .external_lex_state = 4},
  [4447] = {.lex_state = 328, .external_lex_state = 3},
  [4448] = {.lex_state = 105, .external_lex_state = 4},
  [4449] = {.lex_state = 105, .external_lex_state = 4},
  [4450] = {.lex_state = 105, .external_lex_state = 4},
  [4451] = {.lex_state = 105, .external_lex_state = 4},
  [4452] = {.lex_state = 510, .external_lex_state = 3},
  [4453] = {.lex_state = 90, .external_lex_state = 3},
  [4454] = {.lex_state = 27, .external_lex_state = 4},
  [4455] = {.lex_state = 27, .external_lex_state = 4},
  [4456] = {.lex_state = 27, .external_lex_state = 4},
  [4457] = {.lex_state = 27, .external_lex_state = 4},
  [4458] = {.lex_state = 111, .external_lex_state = 4},
  [4459] = {.lex_state = 510, .external_lex_state = 3},
  [4460] = {.lex_state = 15, .external_lex_state = 4},
  [4461] = {.lex_state = 25, .external_lex_state = 3},
  [4462] = {.lex_state = 508, .external_lex_state = 4},
  [4463] = {.lex_state = 510, .external_lex_state = 3},
  [4464] = {.lex_state = 21, .external_lex_state = 4},
  [4465] = {.lex_state = 313, .external_lex_state = 3},
  [4466] = {.lex_state = 100, .external_lex_state = 3},
  [4467] = {.lex_state = 508, .external_lex_state = 4},
  [4468] = {.lex_state = 508, .external_lex_state = 4},
  [4469] = {.lex_state = 106, .external_lex_state = 3},
  [4470] = {.lex_state = 1, .external_lex_state = 3},
  [4471] = {.lex_state = 99, .external_lex_state = 3},
  [4472] = {.lex_state = 514, .external_lex_state = 4},
  [4473] = {.lex_state = 12, .external_lex_state = 4},
  [4474] = {.lex_state = 313, .external_lex_state = 3},
  [4475] = {.lex_state = 19, .external_lex_state = 3},
  [4476] = {.lex_state = 106, .external_lex_state = 3},
  [4477] = {.lex_state = 513, .external_lex_state = 4},
  [4478] = {.lex_state = 513, .external_lex_state = 4},
  [4479] = {.lex_state = 513, .external_lex_state = 4},
  [4480] = {.lex_state = 513, .external_lex_state = 4},
  [4481] = {.lex_state = 114, .external_lex_state = 4},
  [4482] = {.lex_state = 328, .external_lex_state = 3},
  [4483] = {.lex_state = 328, .external_lex_state = 3},
  [4484] = {.lex_state = 23, .external_lex_state = 4},
  [4485] = {.lex_state = 90, .external_lex_state = 3},
  [4486] = {.lex_state = 18, .external_lex_state = 3},
  [4487] = {.lex_state = 108, .external_lex_state = 4},
  [4488] = {.lex_state = 108, .external_lex_state = 4},
  [4489] = {.lex_state = 108, .external_lex_state = 4},
  [4490] = {.lex_state = 108, .external_lex_state = 4},
  [4491] = {.lex_state = 100, .external_lex_state = 3},
  [4492] = {.lex_state = 99, .external_lex_state = 3},
  [4493] = {.lex_state = 25, .external_lex_state = 3},
  [4494] = {.lex_state = 88, .external_lex_state = 3},
  [4495] = {.lex_state = 90, .external_lex_state = 3},
  [4496] = {.lex_state = 1, .external_lex_state = 3},
  [4497] = {.lex_state = 106, .external_lex_state = 3},
  [4498] = {.lex_state = 88, .external_lex_state = 3},
  [4499] = {.lex_state = 23, .external_lex_state = 4},
  [4500] = {.lex_state = 23, .external_lex_state = 4},
  [4501] = {.lex_state = 23, .external_lex_state = 4},
  [4502] = {.lex_state = 23, .external_lex_state = 4},
  [4503] = {.lex_state = 23, .external_lex_state = 4},
  [4504] = {.lex_state = 23, .external_lex_state = 4},
  [4505] = {.lex_state = 23, .external_lex_state = 4},
  [4506] = {.lex_state = 23, .external_lex_state = 4},
  [4507] = {.lex_state = 23, .external_lex_state = 4},
  [4508] = {.lex_state = 101, .external_lex_state = 4},
  [4509] = {.lex_state = 101, .external_lex_state = 4},
  [4510] = {.lex_state = 101, .external_lex_state = 4},
  [4511] = {.lex_state = 496, .external_lex_state = 4},
  [4512] = {.lex_state = 16, .external_lex_state = 4},
  [4513] = {.lex_state = 101, .external_lex_state = 4},
  [4514] = {.lex_state = 101, .external_lex_state = 4},
  [4515] = {.lex_state = 101, .external_lex_state = 4},
  [4516] = {.lex_state = 101, .external_lex_state = 4},
  [4517] = {.lex_state = 19, .external_lex_state = 3},
  [4518] = {.lex_state = 7, .external_lex_state = 4},
  [4519] = {.lex_state = 101, .external_lex_state = 4},
  [4520] = {.lex_state = 510, .external_lex_state = 3},
  [4521] = {.lex_state = 106, .external_lex_state = 3},
  [4522] = {.lex_state = 99, .external_lex_state = 3},
  [4523] = {.lex_state = 512, .external_lex_state = 4},
  [4524] = {.lex_state = 101, .external_lex_state = 4},
  [4525] = {.lex_state = 512, .external_lex_state = 4},
  [4526] = {.lex_state = 9, .external_lex_state = 3},
  [4527] = {.lex_state = 7, .external_lex_state = 4},
  [4528] = {.lex_state = 7, .external_lex_state = 4},
  [4529] = {.lex_state = 7, .external_lex_state = 4},
  [4530] = {.lex_state = 327, .external_lex_state = 4},
  [4531] = {.lex_state = 328, .external_lex_state = 3},
  [4532] = {.lex_state = 327, .external_lex_state = 4},
  [4533] = {.lex_state = 310, .external_lex_state = 3},
  [4534] = {.lex_state = 327, .external_lex_state = 4},
  [4535] = {.lex_state = 327, .external_lex_state = 4},
  [4536] = {.lex_state = 1, .external_lex_state = 3},
  [4537] = {.lex_state = 18, .external_lex_state = 3},
  [4538] = {.lex_state = 7, .external_lex_state = 4},
  [4539] = {.lex_state = 512, .external_lex_state = 4},
  [4540] = {.lex_state = 87, .external_lex_state = 4},
  [4541] = {.lex_state = 90, .external_lex_state = 3},
  [4542] = {.lex_state = 87, .external_lex_state = 4},
  [4543] = {.lex_state = 512, .external_lex_state = 4},
  [4544] = {.lex_state = 512, .external_lex_state = 4},
  [4545] = {.lex_state = 512, .external_lex_state = 4},
  [4546] = {.lex_state = 7, .external_lex_state = 4},
  [4547] = {.lex_state = 87, .external_lex_state = 4},
  [4548] = {.lex_state = 512, .external_lex_state = 4},
  [4549] = {.lex_state = 512, .external_lex_state = 4},
  [4550] = {.lex_state = 512, .external_lex_state = 4},
  [4551] = {.lex_state = 9, .external_lex_state = 3},
  [4552] = {.lex_state = 87, .external_lex_state = 4},
  [4553] = {.lex_state = 512, .external_lex_state = 4},
  [4554] = {.lex_state = 512, .external_lex_state = 4},
  [4555] = {.lex_state = 512, .external_lex_state = 4},
  [4556] = {.lex_state = 328, .external_lex_state = 3},
  [4557] = {.lex_state = 100, .external_lex_state = 3},
  [4558] = {.lex_state = 7, .external_lex_state = 4},
  [4559] = {.lex_state = 16, .external_lex_state = 4},
  [4560] = {.lex_state = 23, .external_lex_state = 4},
  [4561] = {.lex_state = 23, .external_lex_state = 4},
  [4562] = {.lex_state = 21, .external_lex_state = 4},
  [4563] = {.lex_state = 25, .external_lex_state = 3},
  [4564] = {.lex_state = 21, .external_lex_state = 4},
  [4565] = {.lex_state = 21, .external_lex_state = 4},
  [4566] = {.lex_state = 508, .external_lex_state = 4},
  [4567] = {.lex_state = 108, .external_lex_state = 4},
  [4568] = {.lex_state = 498, .external_lex_state = 4},
  [4569] = {.lex_state = 498, .external_lex_state = 4},
  [4570] = {.lex_state = 498, .external_lex_state = 4},
  [4571] = {.lex_state = 498, .external_lex_state = 4},
  [4572] = {.lex_state = 498, .external_lex_state = 4},
  [4573] = {.lex_state = 513, .external_lex_state = 4},
  [4574] = {.lex_state = 513, .external_lex_state = 4},
  [4575] = {.lex_state = 498, .external_lex_state = 4},
  [4576] = {.lex_state = 498, .external_lex_state = 4},
  [4577] = {.lex_state = 97, .external_lex_state = 4},
  [4578] = {.lex_state = 97, .external_lex_state = 4},
  [4579] = {.lex_state = 97, .external_lex_state = 4},
  [4580] = {.lex_state = 97, .external_lex_state = 4},
  [4581] = {.lex_state = 97, .external_lex_state = 4},
  [4582] = {.lex_state = 498, .external_lex_state = 4},
  [4583] = {.lex_state = 498, .external_lex_state = 4},
  [4584] = {.lex_state = 498, .external_lex_state = 4},
  [4585] = {.lex_state = 97, .external_lex_state = 4},
  [4586] = {.lex_state = 498, .external_lex_state = 4},
  [4587] = {.lex_state = 498, .external_lex_state = 4},
  [4588] = {.lex_state = 26, .external_lex_state = 3},
  [4589] = {.lex_state = 498, .external_lex_state = 4},
  [4590] = {.lex_state = 3, .external_lex_state = 4},
  [4591] = {.lex_state = 4, .external_lex_state = 3},
  [4592] = {.lex_state = 3, .external_lex_state = 4},
  [4593] = {.lex_state = 310, .external_lex_state = 4},
  [4594] = {.lex_state = 310, .external_lex_state = 4},
  [4595] = {.lex_state = 3, .external_lex_state = 4},
  [4596] = {.lex_state = 105, .external_lex_state = 4},
  [4597] = {.lex_state = 498, .external_lex_state = 4},
  [4598] = {.lex_state = 310, .external_lex_state = 4},
  [4599] = {.lex_state = 98, .external_lex_state = 4},
  [4600] = {.lex_state = 498, .external_lex_state = 4},
  [4601] = {.lex_state = 26, .external_lex_state = 3},
  [4602] = {.lex_state = 498, .external_lex_state = 4},
  [4603] = {.lex_state = 498, .external_lex_state = 4},
  [4604] = {.lex_state = 498, .external_lex_state = 4},
  [4605] = {.lex_state = 3, .external_lex_state = 4},
  [4606] = {.lex_state = 24, .external_lex_state = 4},
  [4607] = {.lex_state = 310, .external_lex_state = 4},
  [4608] = {.lex_state = 513, .external_lex_state = 4},
  [4609] = {.lex_state = 26, .external_lex_state = 3},
  [4610] = {.lex_state = 513, .external_lex_state = 4},
  [4611] = {.lex_state = 513, .external_lex_state = 4},
  [4612] = {.lex_state = 513, .external_lex_state = 4},
  [4613] = {.lex_state = 513, .external_lex_state = 4},
  [4614] = {.lex_state = 513, .external_lex_state = 4},
  [4615] = {.lex_state = 513, .external_lex_state = 4},
  [4616] = {.lex_state = 513, .external_lex_state = 4},
  [4617] = {.lex_state = 513, .external_lex_state = 4},
  [4618] = {.lex_state = 513, .external_lex_state = 4},
  [4619] = {.lex_state = 310, .external_lex_state = 4},
  [4620] = {.lex_state = 6, .external_lex_state = 4},
  [4621] = {.lex_state = 6, .external_lex_state = 4},
  [4622] = {.lex_state = 24, .external_lex_state = 4},
  [4623] = {.lex_state = 513, .external_lex_state = 4},
  [4624] = {.lex_state = 310, .external_lex_state = 4},
  [4625] = {.lex_state = 6, .external_lex_state = 4},
  [4626] = {.lex_state = 513, .external_lex_state = 4},
  [4627] = {.lex_state = 102, .external_lex_state = 4},
  [4628] = {.lex_state = 24, .external_lex_state = 4},
  [4629] = {.lex_state = 24, .external_lex_state = 4},
  [4630] = {.lex_state = 310, .external_lex_state = 4},
  [4631] = {.lex_state = 513, .external_lex_state = 4},
  [4632] = {.lex_state = 513, .external_lex_state = 4},
  [4633] = {.lex_state = 513, .external_lex_state = 4},
  [4634] = {.lex_state = 513, .external_lex_state = 4},
  [4635] = {.lex_state = 513, .external_lex_state = 4},
  [4636] = {.lex_state = 513, .external_lex_state = 4},
  [4637] = {.lex_state = 513, .external_lex_state = 4},
  [4638] = {.lex_state = 102, .external_lex_state = 4},
  [4639] = {.lex_state = 82, .external_lex_state = 3},
  [4640] = {.lex_state = 513, .external_lex_state = 4},
  [4641] = {.lex_state = 513, .external_lex_state = 4},
  [4642] = {.lex_state = 513, .external_lex_state = 4},
  [4643] = {.lex_state = 513, .external_lex_state = 4},
  [4644] = {.lex_state = 513, .external_lex_state = 4},
  [4645] = {.lex_state = 513, .external_lex_state = 4},
  [4646] = {.lex_state = 21, .external_lex_state = 4},
  [4647] = {.lex_state = 6, .external_lex_state = 4},
  [4648] = {.lex_state = 513, .external_lex_state = 4},
  [4649] = {.lex_state = 83, .external_lex_state = 3},
  [4650] = {.lex_state = 513, .external_lex_state = 4},
  [4651] = {.lex_state = 513, .external_lex_state = 4},
  [4652] = {.lex_state = 498, .external_lex_state = 4},
  [4653] = {.lex_state = 513, .external_lex_state = 4},
  [4654] = {.lex_state = 21, .external_lex_state = 4},
  [4655] = {.lex_state = 6, .external_lex_state = 4},
  [4656] = {.lex_state = 21, .external_lex_state = 4},
  [4657] = {.lex_state = 21, .external_lex_state = 4},
  [4658] = {.lex_state = 511, .external_lex_state = 4},
  [4659] = {.lex_state = 108, .external_lex_state = 4},
  [4660] = {.lex_state = 108, .external_lex_state = 4},
  [4661] = {.lex_state = 21, .external_lex_state = 4},
  [4662] = {.lex_state = 16, .external_lex_state = 4},
  [4663] = {.lex_state = 108, .external_lex_state = 4},
  [4664] = {.lex_state = 21, .external_lex_state = 4},
  [4665] = {.lex_state = 24, .external_lex_state = 4},
  [4666] = {.lex_state = 108, .external_lex_state = 4},
  [4667] = {.lex_state = 21, .external_lex_state = 4},
  [4668] = {.lex_state = 102, .external_lex_state = 4},
  [4669] = {.lex_state = 21, .external_lex_state = 4},
  [4670] = {.lex_state = 21, .external_lex_state = 4},
  [4671] = {.lex_state = 6, .external_lex_state = 4},
  [4672] = {.lex_state = 21, .external_lex_state = 4},
  [4673] = {.lex_state = 27, .external_lex_state = 4},
  [4674] = {.lex_state = 108, .external_lex_state = 4},
  [4675] = {.lex_state = 6, .external_lex_state = 4},
  [4676] = {.lex_state = 325, .external_lex_state = 3},
  [4677] = {.lex_state = 513, .external_lex_state = 4},
  [4678] = {.lex_state = 102, .external_lex_state = 4},
  [4679] = {.lex_state = 102, .external_lex_state = 4},
  [4680] = {.lex_state = 102, .external_lex_state = 4},
  [4681] = {.lex_state = 98, .external_lex_state = 4},
  [4682] = {.lex_state = 27, .external_lex_state = 4},
  [4683] = {.lex_state = 27, .external_lex_state = 4},
  [4684] = {.lex_state = 498, .external_lex_state = 4},
  [4685] = {.lex_state = 325, .external_lex_state = 3},
  [4686] = {.lex_state = 108, .external_lex_state = 4},
  [4687] = {.lex_state = 102, .external_lex_state = 4},
  [4688] = {.lex_state = 102, .external_lex_state = 4},
  [4689] = {.lex_state = 102, .external_lex_state = 4},
  [4690] = {.lex_state = 102, .external_lex_state = 4},
  [4691] = {.lex_state = 102, .external_lex_state = 4},
  [4692] = {.lex_state = 108, .external_lex_state = 4},
  [4693] = {.lex_state = 5, .external_lex_state = 4},
  [4694] = {.lex_state = 5, .external_lex_state = 4},
  [4695] = {.lex_state = 108, .external_lex_state = 4},
  [4696] = {.lex_state = 102, .external_lex_state = 4},
  [4697] = {.lex_state = 108, .external_lex_state = 4},
  [4698] = {.lex_state = 19, .external_lex_state = 4},
  [4699] = {.lex_state = 19, .external_lex_state = 4},
  [4700] = {.lex_state = 108, .external_lex_state = 4},
  [4701] = {.lex_state = 5, .external_lex_state = 4},
  [4702] = {.lex_state = 312, .external_lex_state = 4},
  [4703] = {.lex_state = 98, .external_lex_state = 4},
  [4704] = {.lex_state = 107, .external_lex_state = 3},
  [4705] = {.lex_state = 98, .external_lex_state = 4},
  [4706] = {.lex_state = 312, .external_lex_state = 4},
  [4707] = {.lex_state = 98, .external_lex_state = 4},
  [4708] = {.lex_state = 77, .external_lex_state = 4},
  [4709] = {.lex_state = 78, .external_lex_state = 3},
  [4710] = {.lex_state = 77, .external_lex_state = 4},
  [4711] = {.lex_state = 87, .external_lex_state = 4},
  [4712] = {.lex_state = 5, .external_lex_state = 4},
  [4713] = {.lex_state = 77, .external_lex_state = 4},
  [4714] = {.lex_state = 77, .external_lex_state = 4},
  [4715] = {.lex_state = 5, .external_lex_state = 4},
  [4716] = {.lex_state = 89, .external_lex_state = 3},
  [4717] = {.lex_state = 8, .external_lex_state = 4},
  [4718] = {.lex_state = 8, .external_lex_state = 4},
  [4719] = {.lex_state = 513, .external_lex_state = 4},
  [4720] = {.lex_state = 108, .external_lex_state = 4},
  [4721] = {.lex_state = 108, .external_lex_state = 4},
  [4722] = {.lex_state = 22, .external_lex_state = 4},
  [4723] = {.lex_state = 5, .external_lex_state = 4},
  [4724] = {.lex_state = 8, .external_lex_state = 4},
  [4725] = {.lex_state = 84, .external_lex_state = 4},
  [4726] = {.lex_state = 5, .external_lex_state = 4},
  [4727] = {.lex_state = 84, .external_lex_state = 4},
  [4728] = {.lex_state = 98, .external_lex_state = 4},
  [4729] = {.lex_state = 27, .external_lex_state = 4},
  [4730] = {.lex_state = 8, .external_lex_state = 4},
  [4731] = {.lex_state = 83, .external_lex_state = 3},
  [4732] = {.lex_state = 98, .external_lex_state = 4},
  [4733] = {.lex_state = 98, .external_lex_state = 4},
  [4734] = {.lex_state = 310, .external_lex_state = 3},
  [4735] = {.lex_state = 24, .external_lex_state = 4},
  [4736] = {.lex_state = 312, .external_lex_state = 4},
  [4737] = {.lex_state = 8, .external_lex_state = 4},
  [4738] = {.lex_state = 105, .external_lex_state = 4},
  [4739] = {.lex_state = 312, .external_lex_state = 4},
  [4740] = {.lex_state = 312, .external_lex_state = 4},
  [4741] = {.lex_state = 8, .external_lex_state = 4},
  [4742] = {.lex_state = 312, .external_lex_state = 4},
  [4743] = {.lex_state = 17, .external_lex_state = 4},
  [4744] = {.lex_state = 26, .external_lex_state = 3},
  [4745] = {.lex_state = 27, .external_lex_state = 4},
  [4746] = {.lex_state = 312, .external_lex_state = 4},
  [4747] = {.lex_state = 8, .external_lex_state = 4},
  [4748] = {.lex_state = 312, .external_lex_state = 4},
  [4749] = {.lex_state = 105, .external_lex_state = 4},
  [4750] = {.lex_state = 312, .external_lex_state = 4},
  [4751] = {.lex_state = 105, .external_lex_state = 4},
  [4752] = {.lex_state = 4, .external_lex_state = 3},
  [4753] = {.lex_state = 24, .external_lex_state = 4},
  [4754] = {.lex_state = 17, .external_lex_state = 4},
  [4755] = {.lex_state = 105, .external_lex_state = 4},
  [4756] = {.lex_state = 312, .external_lex_state = 4},
  [4757] = {.lex_state = 22, .external_lex_state = 4},
  [4758] = {.lex_state = 108, .external_lex_state = 4},
  [4759] = {.lex_state = 312, .external_lex_state = 4},
  [4760] = {.lex_state = 98, .external_lex_state = 4},
  [4761] = {.lex_state = 312, .external_lex_state = 4},
  [4762] = {.lex_state = 98, .external_lex_state = 4},
  [4763] = {.lex_state = 27, .external_lex_state = 4},
  [4764] = {.lex_state = 108, .external_lex_state = 4},
  [4765] = {.lex_state = 27, .external_lex_state = 4},
  [4766] = {.lex_state = 27, .external_lex_state = 4},
  [4767] = {.lex_state = 108, .external_lex_state = 4},
  [4768] = {.lex_state = 98, .external_lex_state = 4},
  [4769] = {.lex_state = 18, .external_lex_state = 4},
  [4770] = {.lex_state = 18, .external_lex_state = 4},
  [4771] = {.lex_state = 18, .external_lex_state = 4},
  [4772] = {.lex_state = 18, .external_lex_state = 4},
  [4773] = {.lex_state = 10, .external_lex_state = 4},
  [4774] = {.lex_state = 82, .external_lex_state = 3},
  [4775] = {.lex_state = 108, .external_lex_state = 4},
  [4776] = {.lex_state = 108, .external_lex_state = 4},
  [4777] = {.lex_state = 108, .external_lex_state = 4},
  [4778] = {.lex_state = 84, .external_lex_state = 4},
  [4779] = {.lex_state = 108, .external_lex_state = 4},
  [4780] = {.lex_state = 84, .external_lex_state = 4},
  [4781] = {.lex_state = 84, .external_lex_state = 4},
  [4782] = {.lex_state = 84, .external_lex_state = 4},
  [4783] = {.lex_state = 108, .external_lex_state = 4},
  [4784] = {.lex_state = 108, .external_lex_state = 4},
  [4785] = {.lex_state = 108, .external_lex_state = 4},
  [4786] = {.lex_state = 108, .external_lex_state = 4},
  [4787] = {.lex_state = 108, .external_lex_state = 4},
  [4788] = {.lex_state = 108, .external_lex_state = 4},
  [4789] = {.lex_state = 108, .external_lex_state = 4},
  [4790] = {.lex_state = 108, .external_lex_state = 4},
  [4791] = {.lex_state = 108, .external_lex_state = 4},
  [4792] = {.lex_state = 108, .external_lex_state = 4},
  [4793] = {.lex_state = 108, .external_lex_state = 4},
  [4794] = {.lex_state = 84, .external_lex_state = 4},
  [4795] = {.lex_state = 108, .external_lex_state = 4},
  [4796] = {.lex_state = 108, .external_lex_state = 4},
  [4797] = {.lex_state = 108, .external_lex_state = 4},
  [4798] = {.lex_state = 84, .external_lex_state = 4},
  [4799] = {.lex_state = 108, .external_lex_state = 4},
  [4800] = {.lex_state = 108, .external_lex_state = 4},
  [4801] = {.lex_state = 108, .external_lex_state = 4},
  [4802] = {.lex_state = 84, .external_lex_state = 4},
  [4803] = {.lex_state = 108, .external_lex_state = 4},
  [4804] = {.lex_state = 108, .external_lex_state = 4},
  [4805] = {.lex_state = 108, .external_lex_state = 4},
  [4806] = {.lex_state = 108, .external_lex_state = 4},
  [4807] = {.lex_state = 108, .external_lex_state = 4},
  [4808] = {.lex_state = 108, .external_lex_state = 4},
  [4809] = {.lex_state = 108, .external_lex_state = 4},
  [4810] = {.lex_state = 108, .external_lex_state = 4},
  [4811] = {.lex_state = 93, .external_lex_state = 4},
  [4812] = {.lex_state = 105, .external_lex_state = 4},
  [4813] = {.lex_state = 84, .external_lex_state = 4},
  [4814] = {.lex_state = 84, .external_lex_state = 4},
  [4815] = {.lex_state = 84, .external_lex_state = 4},
  [4816] = {.lex_state = 108, .external_lex_state = 4},
  [4817] = {.lex_state = 108, .external_lex_state = 4},
  [4818] = {.lex_state = 108, .external_lex_state = 4},
  [4819] = {.lex_state = 108, .external_lex_state = 4},
  [4820] = {.lex_state = 107, .external_lex_state = 3},
  [4821] = {.lex_state = 108, .external_lex_state = 4},
  [4822] = {.lex_state = 325, .external_lex_state = 3},
  [4823] = {.lex_state = 513, .external_lex_state = 4},
  [4824] = {.lex_state = 513, .external_lex_state = 4},
  [4825] = {.lex_state = 513, .external_lex_state = 4},
  [4826] = {.lex_state = 17, .external_lex_state = 4},
  [4827] = {.lex_state = 498, .external_lex_state = 4},
  [4828] = {.lex_state = 17, .external_lex_state = 4},
  [4829] = {.lex_state = 17, .external_lex_state = 4},
  [4830] = {.lex_state = 17, .external_lex_state = 4},
  [4831] = {.lex_state = 498, .external_lex_state = 4},
  [4832] = {.lex_state = 498, .external_lex_state = 4},
  [4833] = {.lex_state = 508, .external_lex_state = 4},
  [4834] = {.lex_state = 17, .external_lex_state = 4},
  [4835] = {.lex_state = 513, .external_lex_state = 4},
  [4836] = {.lex_state = 17, .external_lex_state = 4},
  [4837] = {.lex_state = 17, .external_lex_state = 4},
  [4838] = {.lex_state = 508, .external_lex_state = 4},
  [4839] = {.lex_state = 17, .external_lex_state = 4},
  [4840] = {.lex_state = 17, .external_lex_state = 4},
  [4841] = {.lex_state = 19, .external_lex_state = 4},
  [4842] = {.lex_state = 17, .external_lex_state = 4},
  [4843] = {.lex_state = 89, .external_lex_state = 3},
  [4844] = {.lex_state = 24, .external_lex_state = 4},
  [4845] = {.lex_state = 27, .external_lex_state = 4},
  [4846] = {.lex_state = 24, .external_lex_state = 4},
  [4847] = {.lex_state = 24, .external_lex_state = 4},
  [4848] = {.lex_state = 24, .external_lex_state = 4},
  [4849] = {.lex_state = 329, .external_lex_state = 4},
  [4850] = {.lex_state = 19, .external_lex_state = 4},
  [4851] = {.lex_state = 78, .external_lex_state = 3},
  [4852] = {.lex_state = 4, .external_lex_state = 3},
  [4853] = {.lex_state = 313, .external_lex_state = 4},
  [4854] = {.lex_state = 313, .external_lex_state = 4},
  [4855] = {.lex_state = 313, .external_lex_state = 4},
  [4856] = {.lex_state = 313, .external_lex_state = 4},
  [4857] = {.lex_state = 24, .external_lex_state = 4},
  [4858] = {.lex_state = 96, .external_lex_state = 4},
  [4859] = {.lex_state = 498, .external_lex_state = 4},
  [4860] = {.lex_state = 83, .external_lex_state = 3},
  [4861] = {.lex_state = 108, .external_lex_state = 4},
  [4862] = {.lex_state = 108, .external_lex_state = 4},
  [4863] = {.lex_state = 108, .external_lex_state = 4},
  [4864] = {.lex_state = 22, .external_lex_state = 4},
  [4865] = {.lex_state = 24, .external_lex_state = 4},
  [4866] = {.lex_state = 13, .external_lex_state = 4},
  [4867] = {.lex_state = 108, .external_lex_state = 4},
  [4868] = {.lex_state = 110, .external_lex_state = 4},
  [4869] = {.lex_state = 78, .external_lex_state = 3},
  [4870] = {.lex_state = 508, .external_lex_state = 4},
  [4871] = {.lex_state = 88, .external_lex_state = 4},
  [4872] = {.lex_state = 107, .external_lex_state = 3},
  [4873] = {.lex_state = 88, .external_lex_state = 4},
  [4874] = {.lex_state = 508, .external_lex_state = 4},
  [4875] = {.lex_state = 508, .external_lex_state = 4},
  [4876] = {.lex_state = 508, .external_lex_state = 4},
  [4877] = {.lex_state = 328, .external_lex_state = 4},
  [4878] = {.lex_state = 328, .external_lex_state = 4},
  [4879] = {.lex_state = 328, .external_lex_state = 4},
  [4880] = {.lex_state = 328, .external_lex_state = 4},
  [4881] = {.lex_state = 88, .external_lex_state = 4},
  [4882] = {.lex_state = 88, .external_lex_state = 4},
  [4883] = {.lex_state = 508, .external_lex_state = 4},
  [4884] = {.lex_state = 508, .external_lex_state = 4},
  [4885] = {.lex_state = 508, .external_lex_state = 4},
  [4886] = {.lex_state = 508, .external_lex_state = 4},
  [4887] = {.lex_state = 508, .external_lex_state = 4},
  [4888] = {.lex_state = 508, .external_lex_state = 4},
  [4889] = {.lex_state = 22, .external_lex_state = 4},
  [4890] = {.lex_state = 109, .external_lex_state = 4},
  [4891] = {.lex_state = 90, .external_lex_state = 4},
  [4892] = {.lex_state = 90, .external_lex_state = 4},
  [4893] = {.lex_state = 90, .external_lex_state = 4},
  [4894] = {.lex_state = 90, .external_lex_state = 4},
  [4895] = {.lex_state = 24, .external_lex_state = 4},
  [4896] = {.lex_state = 24, .external_lex_state = 4},
  [4897] = {.lex_state = 25, .external_lex_state = 4},
  [4898] = {.lex_state = 25, .external_lex_state = 4},
  [4899] = {.lex_state = 25, .external_lex_state = 4},
  [4900] = {.lex_state = 25, .external_lex_state = 4},
  [4901] = {.lex_state = 100, .external_lex_state = 4},
  [4902] = {.lex_state = 100, .external_lex_state = 4},
  [4903] = {.lex_state = 100, .external_lex_state = 4},
  [4904] = {.lex_state = 100, .external_lex_state = 4},
  [4905] = {.lex_state = 82, .external_lex_state = 3},
  [4906] = {.lex_state = 112, .external_lex_state = 4},
  [4907] = {.lex_state = 24, .external_lex_state = 4},
  [4908] = {.lex_state = 97, .external_lex_state = 4},
  [4909] = {.lex_state = 324, .external_lex_state = 4},
  [4910] = {.lex_state = 99, .external_lex_state = 4},
  [4911] = {.lex_state = 99, .external_lex_state = 4},
  [4912] = {.lex_state = 99, .external_lex_state = 4},
  [4913] = {.lex_state = 99, .external_lex_state = 4},
  [4914] = {.lex_state = 105, .external_lex_state = 4},
  [4915] = {.lex_state = 498, .external_lex_state = 4},
  [4916] = {.lex_state = 106, .external_lex_state = 4},
  [4917] = {.lex_state = 106, .external_lex_state = 4},
  [4918] = {.lex_state = 106, .external_lex_state = 4},
  [4919] = {.lex_state = 97, .external_lex_state = 4},
  [4920] = {.lex_state = 325, .external_lex_state = 3},
  [4921] = {.lex_state = 498, .external_lex_state = 4},
  [4922] = {.lex_state = 89, .external_lex_state = 3},
  [4923] = {.lex_state = 4, .external_lex_state = 3},
  [4924] = {.lex_state = 78, .external_lex_state = 3},
  [4925] = {.lex_state = 83, .external_lex_state = 3},
  [4926] = {.lex_state = 81, .external_lex_state = 4},
  [4927] = {.lex_state = 81, .external_lex_state = 4},
  [4928] = {.lex_state = 11, .external_lex_state = 4},
  [4929] = {.lex_state = 81, .external_lex_state = 4},
  [4930] = {.lex_state = 325, .external_lex_state = 3},
  [4931] = {.lex_state = 498, .external_lex_state = 4},
  [4932] = {.lex_state = 498, .external_lex_state = 4},
  [4933] = {.lex_state = 324, .external_lex_state = 4},
  [4934] = {.lex_state = 498, .external_lex_state = 4},
  [4935] = {.lex_state = 27, .external_lex_state = 4},
  [4936] = {.lex_state = 105, .external_lex_state = 4},
  [4937] = {.lex_state = 324, .external_lex_state = 4},
  [4938] = {.lex_state = 498, .external_lex_state = 4},
  [4939] = {.lex_state = 498, .external_lex_state = 4},
  [4940] = {.lex_state = 498, .external_lex_state = 4},
  [4941] = {.lex_state = 498, .external_lex_state = 4},
  [4942] = {.lex_state = 16, .external_lex_state = 4},
  [4943] = {.lex_state = 89, .external_lex_state = 3},
  [4944] = {.lex_state = 324, .external_lex_state = 4},
  [4945] = {.lex_state = 498, .external_lex_state = 4},
  [4946] = {.lex_state = 24, .external_lex_state = 4},
  [4947] = {.lex_state = 105, .external_lex_state = 4},
  [4948] = {.lex_state = 105, .external_lex_state = 4},
  [4949] = {.lex_state = 85, .external_lex_state = 4},
  [4950] = {.lex_state = 89, .external_lex_state = 3},
  [4951] = {.lex_state = 82, .external_lex_state = 3},
  [4952] = {.lex_state = 83, .external_lex_state = 3},
  [4953] = {.lex_state = 498, .external_lex_state = 4},
  [4954] = {.lex_state = 16, .external_lex_state = 4},
  [4955] = {.lex_state = 103, .external_lex_state = 4},
  [4956] = {.lex_state = 16, .external_lex_state = 4},
  [4957] = {.lex_state = 16, .external_lex_state = 4},
  [4958] = {.lex_state = 16, .external_lex_state = 4},
  [4959] = {.lex_state = 16, .external_lex_state = 4},
  [4960] = {.lex_state = 16, .external_lex_state = 4},
  [4961] = {.lex_state = 16, .external_lex_state = 4},
  [4962] = {.lex_state = 24, .external_lex_state = 4},
  [4963] = {.lex_state = 16, .external_lex_state = 4},
  [4964] = {.lex_state = 16, .external_lex_state = 4},
  [4965] = {.lex_state = 16, .external_lex_state = 4},
  [4966] = {.lex_state = 498, .external_lex_state = 4},
  [4967] = {.lex_state = 107, .external_lex_state = 3},
  [4968] = {.lex_state = 105, .external_lex_state = 4},
  [4969] = {.lex_state = 24, .external_lex_state = 4},
  [4970] = {.lex_state = 105, .external_lex_state = 4},
  [4971] = {.lex_state = 24, .external_lex_state = 4},
  [4972] = {.lex_state = 24, .external_lex_state = 4},
  [4973] = {.lex_state = 107, .external_lex_state = 3},
  [4974] = {.lex_state = 103, .external_lex_state = 4},
  [4975] = {.lex_state = 105, .external_lex_state = 4},
  [4976] = {.lex_state = 105, .external_lex_state = 4},
  [4977] = {.lex_state = 85, .external_lex_state = 4},
  [4978] = {.lex_state = 24, .external_lex_state = 4},
  [4979] = {.lex_state = 105, .external_lex_state = 4},
  [4980] = {.lex_state = 87, .external_lex_state = 4},
  [4981] = {.lex_state = 27, .external_lex_state = 4},
  [4982] = {.lex_state = 513, .external_lex_state = 4},
  [4983] = {.lex_state = 103, .external_lex_state = 4},
  [4984] = {.lex_state = 105, .external_lex_state = 4},
  [4985] = {.lex_state = 24, .external_lex_state = 4},
  [4986] = {.lex_state = 103, .external_lex_state = 4},
  [4987] = {.lex_state = 513, .external_lex_state = 4},
  [4988] = {.lex_state = 105, .external_lex_state = 4},
  [4989] = {.lex_state = 513, .external_lex_state = 4},
  [4990] = {.lex_state = 513, .external_lex_state = 4},
  [4991] = {.lex_state = 310, .external_lex_state = 3},
  [4992] = {.lex_state = 513, .external_lex_state = 4},
  [4993] = {.lex_state = 513, .external_lex_state = 4},
  [4994] = {.lex_state = 85, .external_lex_state = 4},
  [4995] = {.lex_state = 81, .external_lex_state = 4},
  [4996] = {.lex_state = 513, .external_lex_state = 4},
  [4997] = {.lex_state = 105, .external_lex_state = 4},
  [4998] = {.lex_state = 24, .external_lex_state = 4},
  [4999] = {.lex_state = 105, .external_lex_state = 4},
  [5000] = {.lex_state = 24, .external_lex_state = 4},
  [5001] = {.lex_state = 513, .external_lex_state = 4},
  [5002] = {.lex_state = 513, .external_lex_state = 4},
  [5003] = {.lex_state = 105, .external_lex_state = 4},
  [5004] = {.lex_state = 87, .external_lex_state = 4},
  [5005] = {.lex_state = 513, .external_lex_state = 4},
  [5006] = {.lex_state = 513, .external_lex_state = 4},
  [5007] = {.lex_state = 513, .external_lex_state = 4},
  [5008] = {.lex_state = 24, .external_lex_state = 4},
  [5009] = {.lex_state = 24, .external_lex_state = 4},
  [5010] = {.lex_state = 24, .external_lex_state = 4},
  [5011] = {.lex_state = 105, .external_lex_state = 4},
  [5012] = {.lex_state = 513, .external_lex_state = 4},
  [5013] = {.lex_state = 85, .external_lex_state = 4},
  [5014] = {.lex_state = 27, .external_lex_state = 4},
  [5015] = {.lex_state = 24, .external_lex_state = 4},
  [5016] = {.lex_state = 24, .external_lex_state = 4},
  [5017] = {.lex_state = 24, .external_lex_state = 4},
  [5018] = {.lex_state = 513, .external_lex_state = 4},
  [5019] = {.lex_state = 105, .external_lex_state = 4},
  [5020] = {.lex_state = 498, .external_lex_state = 4},
  [5021] = {.lex_state = 498, .external_lex_state = 4},
  [5022] = {.lex_state = 105, .external_lex_state = 4},
  [5023] = {.lex_state = 498, .external_lex_state = 4},
  [5024] = {.lex_state = 513, .external_lex_state = 4},
  [5025] = {.lex_state = 24, .external_lex_state = 4},
  [5026] = {.lex_state = 105, .external_lex_state = 4},
  [5027] = {.lex_state = 24, .external_lex_state = 4},
  [5028] = {.lex_state = 24, .external_lex_state = 4},
  [5029] = {.lex_state = 105, .external_lex_state = 4},
  [5030] = {.lex_state = 105, .external_lex_state = 4},
  [5031] = {.lex_state = 327, .external_lex_state = 4},
  [5032] = {.lex_state = 513, .external_lex_state = 4},
  [5033] = {.lex_state = 327, .external_lex_state = 4},
  [5034] = {.lex_state = 24, .external_lex_state = 4},
  [5035] = {.lex_state = 24, .external_lex_state = 4},
  [5036] = {.lex_state = 498, .external_lex_state = 4},
  [5037] = {.lex_state = 24, .external_lex_state = 4},
  [5038] = {.lex_state = 105, .external_lex_state = 4},
  [5039] = {.lex_state = 105, .external_lex_state = 4},
  [5040] = {.lex_state = 105, .external_lex_state = 4},
  [5041] = {.lex_state = 498, .external_lex_state = 4},
  [5042] = {.lex_state = 24, .external_lex_state = 4},
  [5043] = {.lex_state = 105, .external_lex_state = 4},
  [5044] = {.lex_state = 105, .external_lex_state = 4},
  [5045] = {.lex_state = 24, .external_lex_state = 4},
  [5046] = {.lex_state = 498, .external_lex_state = 4},
  [5047] = {.lex_state = 105, .external_lex_state = 4},
  [5048] = {.lex_state = 105, .external_lex_state = 4},
  [5049] = {.lex_state = 498, .external_lex_state = 4},
  [5050] = {.lex_state = 498, .external_lex_state = 4},
  [5051] = {.lex_state = 510, .external_lex_state = 4},
  [5052] = {.lex_state = 510, .external_lex_state = 4},
  [5053] = {.lex_state = 498, .external_lex_state = 4},
  [5054] = {.lex_state = 105, .external_lex_state = 4},
  [5055] = {.lex_state = 498, .external_lex_state = 4},
  [5056] = {.lex_state = 105, .external_lex_state = 4},
  [5057] = {.lex_state = 105, .external_lex_state = 4},
  [5058] = {.lex_state = 24, .external_lex_state = 4},
  [5059] = {.lex_state = 105, .external_lex_state = 4},
  [5060] = {.lex_state = 105, .external_lex_state = 4},
  [5061] = {.lex_state = 87, .external_lex_state = 4},
  [5062] = {.lex_state = 498, .external_lex_state = 4},
  [5063] = {.lex_state = 105, .external_lex_state = 4},
  [5064] = {.lex_state = 510, .external_lex_state = 4},
  [5065] = {.lex_state = 105, .external_lex_state = 4},
  [5066] = {.lex_state = 510, .external_lex_state = 4},
  [5067] = {.lex_state = 105, .external_lex_state = 4},
  [5068] = {.lex_state = 105, .external_lex_state = 4},
  [5069] = {.lex_state = 24, .external_lex_state = 4},
  [5070] = {.lex_state = 98, .external_lex_state = 4},
  [5071] = {.lex_state = 27, .external_lex_state = 4},
  [5072] = {.lex_state = 24, .external_lex_state = 4},
  [5073] = {.lex_state = 105, .external_lex_state = 4},
  [5074] = {.lex_state = 105, .external_lex_state = 4},
  [5075] = {.lex_state = 24, .external_lex_state = 4},
  [5076] = {.lex_state = 105, .external_lex_state = 4},
  [5077] = {.lex_state = 87, .external_lex_state = 4},
  [5078] = {.lex_state = 498, .external_lex_state = 4},
  [5079] = {.lex_state = 495, .external_lex_state = 3},
  [5080] = {.lex_state = 498, .external_lex_state = 4},
  [5081] = {.lex_state = 105, .external_lex_state = 4},
  [5082] = {.lex_state = 105, .external_lex_state = 4},
  [5083] = {.lex_state = 498, .external_lex_state = 4},
  [5084] = {.lex_state = 498, .external_lex_state = 4},
  [5085] = {.lex_state = 105, .external_lex_state = 4},
  [5086] = {.lex_state = 105, .external_lex_state = 4},
  [5087] = {.lex_state = 105, .external_lex_state = 4},
  [5088] = {.lex_state = 105, .external_lex_state = 4},
  [5089] = {.lex_state = 311, .external_lex_state = 4},
  [5090] = {.lex_state = 24, .external_lex_state = 4},
  [5091] = {.lex_state = 27, .external_lex_state = 4},
  [5092] = {.lex_state = 27, .external_lex_state = 4},
  [5093] = {.lex_state = 27, .external_lex_state = 4},
  [5094] = {.lex_state = 498, .external_lex_state = 4},
  [5095] = {.lex_state = 27, .external_lex_state = 4},
  [5096] = {.lex_state = 97, .external_lex_state = 4},
  [5097] = {.lex_state = 495, .external_lex_state = 3},
  [5098] = {.lex_state = 105, .external_lex_state = 4},
  [5099] = {.lex_state = 78, .external_lex_state = 3},
  [5100] = {.lex_state = 27, .external_lex_state = 4},
  [5101] = {.lex_state = 27, .external_lex_state = 4},
  [5102] = {.lex_state = 327, .external_lex_state = 4},
  [5103] = {.lex_state = 27, .external_lex_state = 4},
  [5104] = {.lex_state = 27, .external_lex_state = 4},
  [5105] = {.lex_state = 105, .external_lex_state = 4},
  [5106] = {.lex_state = 80, .external_lex_state = 4},
  [5107] = {.lex_state = 24, .external_lex_state = 4},
  [5108] = {.lex_state = 82, .external_lex_state = 3},
  [5109] = {.lex_state = 80, .external_lex_state = 4},
  [5110] = {.lex_state = 24, .external_lex_state = 4},
  [5111] = {.lex_state = 327, .external_lex_state = 4},
  [5112] = {.lex_state = 327, .external_lex_state = 4},
  [5113] = {.lex_state = 27, .external_lex_state = 4},
  [5114] = {.lex_state = 327, .external_lex_state = 4},
  [5115] = {.lex_state = 27, .external_lex_state = 4},
  [5116] = {.lex_state = 27, .external_lex_state = 4},
  [5117] = {.lex_state = 27, .external_lex_state = 4},
  [5118] = {.lex_state = 27, .external_lex_state = 4},
  [5119] = {.lex_state = 105, .external_lex_state = 4},
  [5120] = {.lex_state = 80, .external_lex_state = 4},
  [5121] = {.lex_state = 27, .external_lex_state = 4},
  [5122] = {.lex_state = 27, .external_lex_state = 4},
  [5123] = {.lex_state = 24, .external_lex_state = 4},
  [5124] = {.lex_state = 24, .external_lex_state = 4},
  [5125] = {.lex_state = 327, .external_lex_state = 4},
  [5126] = {.lex_state = 327, .external_lex_state = 4},
  [5127] = {.lex_state = 498, .external_lex_state = 4},
  [5128] = {.lex_state = 27, .external_lex_state = 4},
  [5129] = {.lex_state = 27, .external_lex_state = 4},
  [5130] = {.lex_state = 327, .external_lex_state = 4},
  [5131] = {.lex_state = 27, .external_lex_state = 4},
  [5132] = {.lex_state = 27, .external_lex_state = 4},
  [5133] = {.lex_state = 27, .external_lex_state = 4},
  [5134] = {.lex_state = 105, .external_lex_state = 4},
  [5135] = {.lex_state = 80, .external_lex_state = 4},
  [5136] = {.lex_state = 27, .external_lex_state = 4},
  [5137] = {.lex_state = 27, .external_lex_state = 4},
  [5138] = {.lex_state = 327, .external_lex_state = 4},
  [5139] = {.lex_state = 327, .external_lex_state = 4},
  [5140] = {.lex_state = 27, .external_lex_state = 4},
  [5141] = {.lex_state = 27, .external_lex_state = 4},
  [5142] = {.lex_state = 27, .external_lex_state = 4},
  [5143] = {.lex_state = 27, .external_lex_state = 4},
  [5144] = {.lex_state = 24, .external_lex_state = 4},
  [5145] = {.lex_state = 24, .external_lex_state = 4},
  [5146] = {.lex_state = 513, .external_lex_state = 4},
  [5147] = {.lex_state = 27, .external_lex_state = 4},
  [5148] = {.lex_state = 27, .external_lex_state = 4},
  [5149] = {.lex_state = 327, .external_lex_state = 4},
  [5150] = {.lex_state = 24, .external_lex_state = 4},
  [5151] = {.lex_state = 27, .external_lex_state = 4},
  [5152] = {.lex_state = 27, .external_lex_state = 4},
  [5153] = {.lex_state = 27, .external_lex_state = 4},
  [5154] = {.lex_state = 97, .external_lex_state = 4},
  [5155] = {.lex_state = 27, .external_lex_state = 4},
  [5156] = {.lex_state = 27, .external_lex_state = 4},
  [5157] = {.lex_state = 27, .external_lex_state = 4},
  [5158] = {.lex_state = 24, .external_lex_state = 4},
  [5159] = {.lex_state = 97, .external_lex_state = 4},
  [5160] = {.lex_state = 24, .external_lex_state = 4},
  [5161] = {.lex_state = 27, .external_lex_state = 4},
  [5162] = {.lex_state = 87, .external_lex_state = 4},
  [5163] = {.lex_state = 24, .external_lex_state = 4},
  [5164] = {.lex_state = 27, .external_lex_state = 4},
  [5165] = {.lex_state = 27, .external_lex_state = 4},
  [5166] = {.lex_state = 27, .external_lex_state = 4},
  [5167] = {.lex_state = 498, .external_lex_state = 4},
  [5168] = {.lex_state = 27, .external_lex_state = 4},
  [5169] = {.lex_state = 27, .external_lex_state = 4},
  [5170] = {.lex_state = 498, .external_lex_state = 4},
  [5171] = {.lex_state = 97, .external_lex_state = 4},
  [5172] = {.lex_state = 87, .external_lex_state = 4},
  [5173] = {.lex_state = 87, .external_lex_state = 4},
  [5174] = {.lex_state = 87, .external_lex_state = 4},
  [5175] = {.lex_state = 24, .external_lex_state = 4},
  [5176] = {.lex_state = 27, .external_lex_state = 4},
  [5177] = {.lex_state = 27, .external_lex_state = 4},
  [5178] = {.lex_state = 21, .external_lex_state = 4},
  [5179] = {.lex_state = 24, .external_lex_state = 4},
  [5180] = {.lex_state = 498, .external_lex_state = 4},
  [5181] = {.lex_state = 87, .external_lex_state = 4},
  [5182] = {.lex_state = 87, .external_lex_state = 4},
  [5183] = {.lex_state = 87, .external_lex_state = 4},
  [5184] = {.lex_state = 27, .external_lex_state = 4},
  [5185] = {.lex_state = 21, .external_lex_state = 4},
  [5186] = {.lex_state = 106, .external_lex_state = 4},
  [5187] = {.lex_state = 106, .external_lex_state = 4},
  [5188] = {.lex_state = 19, .external_lex_state = 4},
  [5189] = {.lex_state = 100, .external_lex_state = 4},
  [5190] = {.lex_state = 100, .external_lex_state = 4},
  [5191] = {.lex_state = 25, .external_lex_state = 4},
  [5192] = {.lex_state = 74, .external_lex_state = 4},
  [5193] = {.lex_state = 510, .external_lex_state = 4},
  [5194] = {.lex_state = 75, .external_lex_state = 3},
  [5195] = {.lex_state = 74, .external_lex_state = 4},
  [5196] = {.lex_state = 9, .external_lex_state = 4},
  [5197] = {.lex_state = 510, .external_lex_state = 4},
  [5198] = {.lex_state = 19, .external_lex_state = 4},
  [5199] = {.lex_state = 19, .external_lex_state = 4},
  [5200] = {.lex_state = 325, .external_lex_state = 4},
  [5201] = {.lex_state = 325, .external_lex_state = 4},
  [5202] = {.lex_state = 510, .external_lex_state = 4},
  [5203] = {.lex_state = 85, .external_lex_state = 4},
  [5204] = {.lex_state = 88, .external_lex_state = 4},
  [5205] = {.lex_state = 100, .external_lex_state = 4},
  [5206] = {.lex_state = 19, .external_lex_state = 4},
  [5207] = {.lex_state = 106, .external_lex_state = 4},
  [5208] = {.lex_state = 88, .external_lex_state = 4},
  [5209] = {.lex_state = 85, .external_lex_state = 4},
  [5210] = {.lex_state = 88, .external_lex_state = 4},
  [5211] = {.lex_state = 19, .external_lex_state = 4},
  [5212] = {.lex_state = 18, .external_lex_state = 4},
  [5213] = {.lex_state = 510, .external_lex_state = 4},
  [5214] = {.lex_state = 88, .external_lex_state = 4},
  [5215] = {.lex_state = 22, .external_lex_state = 4},
  [5216] = {.lex_state = 74, .external_lex_state = 4},
  [5217] = {.lex_state = 19, .external_lex_state = 4},
  [5218] = {.lex_state = 18, .external_lex_state = 4},
  [5219] = {.lex_state = 325, .external_lex_state = 4},
  [5220] = {.lex_state = 19, .external_lex_state = 4},
  [5221] = {.lex_state = 19, .external_lex_state = 4},
  [5222] = {.lex_state = 19, .external_lex_state = 4},
  [5223] = {.lex_state = 325, .external_lex_state = 4},
  [5224] = {.lex_state = 22, .external_lex_state = 4},
  [5225] = {.lex_state = 106, .external_lex_state = 4},
  [5226] = {.lex_state = 510, .external_lex_state = 4},
  [5227] = {.lex_state = 22, .external_lex_state = 4},
  [5228] = {.lex_state = 3, .external_lex_state = 4},
  [5229] = {.lex_state = 74, .external_lex_state = 4},
  [5230] = {.lex_state = 92, .external_lex_state = 4},
  [5231] = {.lex_state = 106, .external_lex_state = 4},
  [5232] = {.lex_state = 18, .external_lex_state = 4},
  [5233] = {.lex_state = 106, .external_lex_state = 4},
  [5234] = {.lex_state = 510, .external_lex_state = 4},
  [5235] = {.lex_state = 19, .external_lex_state = 4},
  [5236] = {.lex_state = 99, .external_lex_state = 4},
  [5237] = {.lex_state = 19, .external_lex_state = 4},
  [5238] = {.lex_state = 99, .external_lex_state = 4},
  [5239] = {.lex_state = 99, .external_lex_state = 4},
  [5240] = {.lex_state = 80, .external_lex_state = 4},
  [5241] = {.lex_state = 106, .external_lex_state = 4},
  [5242] = {.lex_state = 88, .external_lex_state = 4},
  [5243] = {.lex_state = 88, .external_lex_state = 4},
  [5244] = {.lex_state = 19, .external_lex_state = 4},
  [5245] = {.lex_state = 19, .external_lex_state = 4},
  [5246] = {.lex_state = 510, .external_lex_state = 4},
  [5247] = {.lex_state = 100, .external_lex_state = 4},
  [5248] = {.lex_state = 80, .external_lex_state = 4},
  [5249] = {.lex_state = 22, .external_lex_state = 4},
  [5250] = {.lex_state = 18, .external_lex_state = 4},
  [5251] = {.lex_state = 19, .external_lex_state = 4},
  [5252] = {.lex_state = 99, .external_lex_state = 4},
  [5253] = {.lex_state = 25, .external_lex_state = 4},
  [5254] = {.lex_state = 83, .external_lex_state = 4},
  [5255] = {.lex_state = 83, .external_lex_state = 4},
  [5256] = {.lex_state = 22, .external_lex_state = 4},
  [5257] = {.lex_state = 25, .external_lex_state = 4},
  [5258] = {.lex_state = 25, .external_lex_state = 4},
  [5259] = {.lex_state = 88, .external_lex_state = 4},
  [5260] = {.lex_state = 83, .external_lex_state = 4},
  [5261] = {.lex_state = 1, .external_lex_state = 4},
  [5262] = {.lex_state = 83, .external_lex_state = 4},
  [5263] = {.lex_state = 88, .external_lex_state = 4},
  [5264] = {.lex_state = 88, .external_lex_state = 4},
  [5265] = {.lex_state = 88, .external_lex_state = 4},
  [5266] = {.lex_state = 113, .external_lex_state = 4},
  [5267] = {.lex_state = 99, .external_lex_state = 4},
  [5268] = {.lex_state = 99, .external_lex_state = 4},
  [5269] = {.lex_state = 99, .external_lex_state = 4},
  [5270] = {.lex_state = 99, .external_lex_state = 4},
  [5271] = {.lex_state = 328, .external_lex_state = 4},
  [5272] = {.lex_state = 99, .external_lex_state = 4},
  [5273] = {.lex_state = 99, .external_lex_state = 4},
  [5274] = {.lex_state = 99, .external_lex_state = 4},
  [5275] = {.lex_state = 99, .external_lex_state = 4},
  [5276] = {.lex_state = 99, .external_lex_state = 4},
  [5277] = {.lex_state = 99, .external_lex_state = 4},
  [5278] = {.lex_state = 99, .external_lex_state = 4},
  [5279] = {.lex_state = 99, .external_lex_state = 4},
  [5280] = {.lex_state = 99, .external_lex_state = 4},
  [5281] = {.lex_state = 99, .external_lex_state = 4},
  [5282] = {.lex_state = 99, .external_lex_state = 4},
  [5283] = {.lex_state = 99, .external_lex_state = 4},
  [5284] = {.lex_state = 99, .external_lex_state = 4},
  [5285] = {.lex_state = 99, .external_lex_state = 4},
  [5286] = {.lex_state = 99, .external_lex_state = 4},
  [5287] = {.lex_state = 99, .external_lex_state = 4},
  [5288] = {.lex_state = 99, .external_lex_state = 4},
  [5289] = {.lex_state = 99, .external_lex_state = 4},
  [5290] = {.lex_state = 99, .external_lex_state = 4},
  [5291] = {.lex_state = 99, .external_lex_state = 4},
  [5292] = {.lex_state = 99, .external_lex_state = 4},
  [5293] = {.lex_state = 99, .external_lex_state = 4},
  [5294] = {.lex_state = 3, .external_lex_state = 4},
  [5295] = {.lex_state = 22, .external_lex_state = 4},
  [5296] = {.lex_state = 75, .external_lex_state = 3},
  [5297] = {.lex_state = 100, .external_lex_state = 4},
  [5298] = {.lex_state = 328, .external_lex_state = 4},
  [5299] = {.lex_state = 1, .external_lex_state = 4},
  [5300] = {.lex_state = 88, .external_lex_state = 4},
  [5301] = {.lex_state = 328, .external_lex_state = 4},
  [5302] = {.lex_state = 99, .external_lex_state = 4},
  [5303] = {.lex_state = 1, .external_lex_state = 4},
  [5304] = {.lex_state = 19, .external_lex_state = 4},
  [5305] = {.lex_state = 510, .external_lex_state = 4},
  [5306] = {.lex_state = 106, .external_lex_state = 4},
  [5307] = {.lex_state = 25, .external_lex_state = 4},
  [5308] = {.lex_state = 328, .external_lex_state = 4},
  [5309] = {.lex_state = 106, .external_lex_state = 4},
  [5310] = {.lex_state = 328, .external_lex_state = 4},
  [5311] = {.lex_state = 1, .external_lex_state = 4},
  [5312] = {.lex_state = 328, .external_lex_state = 4},
  [5313] = {.lex_state = 88, .external_lex_state = 4},
  [5314] = {.lex_state = 25, .external_lex_state = 4},
  [5315] = {.lex_state = 19, .external_lex_state = 4},
  [5316] = {.lex_state = 99, .external_lex_state = 4},
  [5317] = {.lex_state = 88, .external_lex_state = 4},
  [5318] = {.lex_state = 85, .external_lex_state = 4},
  [5319] = {.lex_state = 99, .external_lex_state = 4},
  [5320] = {.lex_state = 328, .external_lex_state = 4},
  [5321] = {.lex_state = 328, .external_lex_state = 4},
  [5322] = {.lex_state = 99, .external_lex_state = 4},
  [5323] = {.lex_state = 19, .external_lex_state = 4},
  [5324] = {.lex_state = 510, .external_lex_state = 4},
  [5325] = {.lex_state = 99, .external_lex_state = 4},
  [5326] = {.lex_state = 99, .external_lex_state = 4},
  [5327] = {.lex_state = 328, .external_lex_state = 4},
  [5328] = {.lex_state = 99, .external_lex_state = 4},
  [5329] = {.lex_state = 510, .external_lex_state = 4},
  [5330] = {.lex_state = 100, .external_lex_state = 4},
  [5331] = {.lex_state = 328, .external_lex_state = 4},
  [5332] = {.lex_state = 328, .external_lex_state = 4},
  [5333] = {.lex_state = 88, .external_lex_state = 4},
  [5334] = {.lex_state = 85, .external_lex_state = 4},
  [5335] = {.lex_state = 328, .external_lex_state = 4},
  [5336] = {.lex_state = 313, .external_lex_state = 4},
  [5337] = {.lex_state = 107, .external_lex_state = 4},
  [5338] = {.lex_state = 107, .external_lex_state = 4},
  [5339] = {.lex_state = 107, .external_lex_state = 4},
  [5340] = {.lex_state = 107, .external_lex_state = 4},
  [5341] = {.lex_state = 25, .external_lex_state = 4},
  [5342] = {.lex_state = 313, .external_lex_state = 4},
  [5343] = {.lex_state = 99, .external_lex_state = 4},
  [5344] = {.lex_state = 90, .external_lex_state = 4},
  [5345] = {.lex_state = 90, .external_lex_state = 4},
  [5346] = {.lex_state = 90, .external_lex_state = 4},
  [5347] = {.lex_state = 25, .external_lex_state = 4},
  [5348] = {.lex_state = 88, .external_lex_state = 4},
  [5349] = {.lex_state = 90, .external_lex_state = 4},
  [5350] = {.lex_state = 85, .external_lex_state = 4},
  [5351] = {.lex_state = 106, .external_lex_state = 4},
  [5352] = {.lex_state = 106, .external_lex_state = 4},
  [5353] = {.lex_state = 106, .external_lex_state = 4},
  [5354] = {.lex_state = 88, .external_lex_state = 4},
  [5355] = {.lex_state = 18, .external_lex_state = 4},
  [5356] = {.lex_state = 106, .external_lex_state = 4},
  [5357] = {.lex_state = 313, .external_lex_state = 4},
  [5358] = {.lex_state = 106, .external_lex_state = 4},
  [5359] = {.lex_state = 90, .external_lex_state = 4},
  [5360] = {.lex_state = 106, .external_lex_state = 4},
  [5361] = {.lex_state = 106, .external_lex_state = 4},
  [5362] = {.lex_state = 106, .external_lex_state = 4},
  [5363] = {.lex_state = 106, .external_lex_state = 4},
  [5364] = {.lex_state = 106, .external_lex_state = 4},
  [5365] = {.lex_state = 106, .external_lex_state = 4},
  [5366] = {.lex_state = 106, .external_lex_state = 4},
  [5367] = {.lex_state = 510, .external_lex_state = 4},
  [5368] = {.lex_state = 85, .external_lex_state = 4},
  [5369] = {.lex_state = 88, .external_lex_state = 4},
  [5370] = {.lex_state = 106, .external_lex_state = 4},
  [5371] = {.lex_state = 106, .external_lex_state = 4},
  [5372] = {.lex_state = 106, .external_lex_state = 4},
  [5373] = {.lex_state = 106, .external_lex_state = 4},
  [5374] = {.lex_state = 106, .external_lex_state = 4},
  [5375] = {.lex_state = 106, .external_lex_state = 4},
  [5376] = {.lex_state = 106, .external_lex_state = 4},
  [5377] = {.lex_state = 106, .external_lex_state = 4},
  [5378] = {.lex_state = 106, .external_lex_state = 4},
  [5379] = {.lex_state = 106, .external_lex_state = 4},
  [5380] = {.lex_state = 106, .external_lex_state = 4},
  [5381] = {.lex_state = 106, .external_lex_state = 4},
  [5382] = {.lex_state = 106, .external_lex_state = 4},
  [5383] = {.lex_state = 106, .external_lex_state = 4},
  [5384] = {.lex_state = 106, .external_lex_state = 4},
  [5385] = {.lex_state = 99, .external_lex_state = 4},
  [5386] = {.lex_state = 25, .external_lex_state = 4},
  [5387] = {.lex_state = 25, .external_lex_state = 4},
  [5388] = {.lex_state = 510, .external_lex_state = 4},
  [5389] = {.lex_state = 510, .external_lex_state = 4},
  [5390] = {.lex_state = 100, .external_lex_state = 4},
  [5391] = {.lex_state = 25, .external_lex_state = 4},
  [5392] = {.lex_state = 100, .external_lex_state = 4},
  [5393] = {.lex_state = 100, .external_lex_state = 4},
  [5394] = {.lex_state = 106, .external_lex_state = 4},
  [5395] = {.lex_state = 313, .external_lex_state = 4},
  [5396] = {.lex_state = 106, .external_lex_state = 4},
  [5397] = {.lex_state = 106, .external_lex_state = 4},
  [5398] = {.lex_state = 106, .external_lex_state = 4},
  [5399] = {.lex_state = 100, .external_lex_state = 4},
  [5400] = {.lex_state = 106, .external_lex_state = 4},
  [5401] = {.lex_state = 106, .external_lex_state = 4},
  [5402] = {.lex_state = 106, .external_lex_state = 4},
  [5403] = {.lex_state = 328, .external_lex_state = 4},
  [5404] = {.lex_state = 328, .external_lex_state = 4},
  [5405] = {.lex_state = 19, .external_lex_state = 4},
  [5406] = {.lex_state = 328, .external_lex_state = 4},
  [5407] = {.lex_state = 328, .external_lex_state = 4},
  [5408] = {.lex_state = 313, .external_lex_state = 4},
  [5409] = {.lex_state = 313, .external_lex_state = 4},
  [5410] = {.lex_state = 90, .external_lex_state = 4},
  [5411] = {.lex_state = 19, .external_lex_state = 4},
  [5412] = {.lex_state = 18, .external_lex_state = 4},
  [5413] = {.lex_state = 99, .external_lex_state = 4},
  [5414] = {.lex_state = 91, .external_lex_state = 4},
  [5415] = {.lex_state = 99, .external_lex_state = 4},
  [5416] = {.lex_state = 99, .external_lex_state = 4},
  [5417] = {.lex_state = 106, .external_lex_state = 4},
  [5418] = {.lex_state = 19, .external_lex_state = 4},
  [5419] = {.lex_state = 75, .external_lex_state = 3},
  [5420] = {.lex_state = 106, .external_lex_state = 4},
  [5421] = {.lex_state = 99, .external_lex_state = 4},
  [5422] = {.lex_state = 313, .external_lex_state = 4},
  [5423] = {.lex_state = 313, .external_lex_state = 4},
  [5424] = {.lex_state = 328, .external_lex_state = 4},
  [5425] = {.lex_state = 90, .external_lex_state = 4},
  [5426] = {.lex_state = 90, .external_lex_state = 4},
  [5427] = {.lex_state = 77, .external_lex_state = 4},
  [5428] = {.lex_state = 510, .external_lex_state = 4},
  [5429] = {.lex_state = 328, .external_lex_state = 4},
  [5430] = {.lex_state = 328, .external_lex_state = 4},
  [5431] = {.lex_state = 99, .external_lex_state = 4},
  [5432] = {.lex_state = 328, .external_lex_state = 4},
  [5433] = {.lex_state = 328, .external_lex_state = 4},
  [5434] = {.lex_state = 328, .external_lex_state = 4},
  [5435] = {.lex_state = 328, .external_lex_state = 4},
  [5436] = {.lex_state = 328, .external_lex_state = 4},
  [5437] = {.lex_state = 77, .external_lex_state = 4},
  [5438] = {.lex_state = 313, .external_lex_state = 4},
  [5439] = {.lex_state = 328, .external_lex_state = 4},
  [5440] = {.lex_state = 328, .external_lex_state = 4},
  [5441] = {.lex_state = 328, .external_lex_state = 4},
  [5442] = {.lex_state = 106, .external_lex_state = 4},
  [5443] = {.lex_state = 106, .external_lex_state = 4},
  [5444] = {.lex_state = 106, .external_lex_state = 4},
  [5445] = {.lex_state = 106, .external_lex_state = 4},
  [5446] = {.lex_state = 328, .external_lex_state = 4},
  [5447] = {.lex_state = 510, .external_lex_state = 4},
  [5448] = {.lex_state = 328, .external_lex_state = 4},
  [5449] = {.lex_state = 510, .external_lex_state = 4},
  [5450] = {.lex_state = 313, .external_lex_state = 4},
  [5451] = {.lex_state = 313, .external_lex_state = 4},
  [5452] = {.lex_state = 510, .external_lex_state = 4},
  [5453] = {.lex_state = 510, .external_lex_state = 4},
  [5454] = {.lex_state = 328, .external_lex_state = 4},
  [5455] = {.lex_state = 90, .external_lex_state = 4},
  [5456] = {.lex_state = 90, .external_lex_state = 4},
  [5457] = {.lex_state = 99, .external_lex_state = 4},
  [5458] = {.lex_state = 94, .external_lex_state = 4},
  [5459] = {.lex_state = 19, .external_lex_state = 4},
  [5460] = {.lex_state = 82, .external_lex_state = 4},
  [5461] = {.lex_state = 82, .external_lex_state = 4},
  [5462] = {.lex_state = 82, .external_lex_state = 4},
  [5463] = {.lex_state = 82, .external_lex_state = 4},
  [5464] = {.lex_state = 19, .external_lex_state = 4},
  [5465] = {.lex_state = 85, .external_lex_state = 4},
  [5466] = {.lex_state = 90, .external_lex_state = 4},
  [5467] = {.lex_state = 510, .external_lex_state = 4},
  [5468] = {.lex_state = 18, .external_lex_state = 4},
  [5469] = {.lex_state = 2, .external_lex_state = 4},
  [5470] = {.lex_state = 99, .external_lex_state = 4},
  [5471] = {.lex_state = 313, .external_lex_state = 4},
  [5472] = {.lex_state = 313, .external_lex_state = 4},
  [5473] = {.lex_state = 313, .external_lex_state = 4},
  [5474] = {.lex_state = 90, .external_lex_state = 4},
  [5475] = {.lex_state = 85, .external_lex_state = 4},
  [5476] = {.lex_state = 19, .external_lex_state = 4},
  [5477] = {.lex_state = 313, .external_lex_state = 4},
  [5478] = {.lex_state = 26, .external_lex_state = 4},
  [5479] = {.lex_state = 510, .external_lex_state = 4},
  [5480] = {.lex_state = 510, .external_lex_state = 4},
  [5481] = {.lex_state = 510, .external_lex_state = 4},
  [5482] = {.lex_state = 510, .external_lex_state = 4},
  [5483] = {.lex_state = 106, .external_lex_state = 4},
  [5484] = {.lex_state = 18, .external_lex_state = 4},
  [5485] = {.lex_state = 510, .external_lex_state = 4},
  [5486] = {.lex_state = 99, .external_lex_state = 4},
  [5487] = {.lex_state = 88, .external_lex_state = 4},
  [5488] = {.lex_state = 19, .external_lex_state = 4},
  [5489] = {.lex_state = 510, .external_lex_state = 4},
  [5490] = {.lex_state = 510, .external_lex_state = 4},
  [5491] = {.lex_state = 99, .external_lex_state = 4},
  [5492] = {.lex_state = 510, .external_lex_state = 4},
  [5493] = {.lex_state = 510, .external_lex_state = 4},
  [5494] = {.lex_state = 510, .external_lex_state = 4},
  [5495] = {.lex_state = 510, .external_lex_state = 4},
  [5496] = {.lex_state = 19, .external_lex_state = 4},
  [5497] = {.lex_state = 90, .external_lex_state = 4},
  [5498] = {.lex_state = 19, .external_lex_state = 4},
  [5499] = {.lex_state = 510, .external_lex_state = 4},
  [5500] = {.lex_state = 90, .external_lex_state = 4},
  [5501] = {.lex_state = 510, .external_lex_state = 4},
  [5502] = {.lex_state = 510, .external_lex_state = 4},
  [5503] = {.lex_state = 510, .external_lex_state = 4},
  [5504] = {.lex_state = 510, .external_lex_state = 4},
  [5505] = {.lex_state = 510, .external_lex_state = 4},
  [5506] = {.lex_state = 89, .external_lex_state = 4},
  [5507] = {.lex_state = 510, .external_lex_state = 4},
  [5508] = {.lex_state = 89, .external_lex_state = 4},
  [5509] = {.lex_state = 89, .external_lex_state = 4},
  [5510] = {.lex_state = 89, .external_lex_state = 4},
  [5511] = {.lex_state = 79, .external_lex_state = 4},
  [5512] = {.lex_state = 510, .external_lex_state = 4},
  [5513] = {.lex_state = 510, .external_lex_state = 4},
  [5514] = {.lex_state = 4, .external_lex_state = 4},
  [5515] = {.lex_state = 510, .external_lex_state = 4},
  [5516] = {.lex_state = 4, .external_lex_state = 4},
  [5517] = {.lex_state = 510, .external_lex_state = 4},
  [5518] = {.lex_state = 510, .external_lex_state = 4},
  [5519] = {.lex_state = 510, .external_lex_state = 4},
  [5520] = {.lex_state = 510, .external_lex_state = 4},
  [5521] = {.lex_state = 4, .external_lex_state = 4},
  [5522] = {.lex_state = 4, .external_lex_state = 4},
  [5523] = {.lex_state = 88, .external_lex_state = 4},
  [5524] = {.lex_state = 510, .external_lex_state = 4},
  [5525] = {.lex_state = 3, .external_lex_state = 4},
  [5526] = {.lex_state = 19, .external_lex_state = 4},
  [5527] = {.lex_state = 100, .external_lex_state = 4},
  [5528] = {.lex_state = 313, .external_lex_state = 4},
  [5529] = {.lex_state = 100, .external_lex_state = 4},
  [5530] = {.lex_state = 328, .external_lex_state = 4},
  [5531] = {.lex_state = 313, .external_lex_state = 4},
  [5532] = {.lex_state = 88, .external_lex_state = 4},
  [5533] = {.lex_state = 313, .external_lex_state = 4},
  [5534] = {.lex_state = 99, .external_lex_state = 4},
  [5535] = {.lex_state = 313, .external_lex_state = 4},
  [5536] = {.lex_state = 78, .external_lex_state = 4},
  [5537] = {.lex_state = 78, .external_lex_state = 4},
  [5538] = {.lex_state = 78, .external_lex_state = 4},
  [5539] = {.lex_state = 78, .external_lex_state = 4},
  [5540] = {.lex_state = 90, .external_lex_state = 4},
  [5541] = {.lex_state = 99, .external_lex_state = 4},
  [5542] = {.lex_state = 313, .external_lex_state = 4},
  [5543] = {.lex_state = 75, .external_lex_state = 3},
  [5544] = {.lex_state = 3, .external_lex_state = 4},
  [5545] = {.lex_state = 9, .external_lex_state = 3},
  [5546] = {.lex_state = 19, .external_lex_state = 4},
  [5547] = {.lex_state = 25, .external_lex_state = 4},
  [5548] = {.lex_state = 88, .external_lex_state = 4},
  [5549] = {.lex_state = 99, .external_lex_state = 4},
  [5550] = {.lex_state = 99, .external_lex_state = 4},
  [5551] = {.lex_state = 99, .external_lex_state = 4},
  [5552] = {.lex_state = 19, .external_lex_state = 4},
  [5553] = {.lex_state = 313, .external_lex_state = 4},
  [5554] = {.lex_state = 313, .external_lex_state = 4},
  [5555] = {.lex_state = 18, .external_lex_state = 4},
  [5556] = {.lex_state = 81, .external_lex_state = 4},
  [5557] = {.lex_state = 19, .external_lex_state = 4},
  [5558] = {.lex_state = 313, .external_lex_state = 4},
  [5559] = {.lex_state = 80, .external_lex_state = 4},
  [5560] = {.lex_state = 19, .external_lex_state = 4},
  [5561] = {.lex_state = 81, .external_lex_state = 4},
  [5562] = {.lex_state = 313, .external_lex_state = 4},
  [5563] = {.lex_state = 19, .external_lex_state = 4},
  [5564] = {.lex_state = 3, .external_lex_state = 4},
  [5565] = {.lex_state = 313, .external_lex_state = 4},
  [5566] = {.lex_state = 313, .external_lex_state = 4},
  [5567] = {.lex_state = 313, .external_lex_state = 4},
  [5568] = {.lex_state = 9, .external_lex_state = 4},
  [5569] = {.lex_state = 313, .external_lex_state = 4},
  [5570] = {.lex_state = 324, .external_lex_state = 4},
  [5571] = {.lex_state = 313, .external_lex_state = 4},
  [5572] = {.lex_state = 3, .external_lex_state = 4},
  [5573] = {.lex_state = 90, .external_lex_state = 4},
  [5574] = {.lex_state = 19, .external_lex_state = 4},
  [5575] = {.lex_state = 90, .external_lex_state = 4},
  [5576] = {.lex_state = 26, .external_lex_state = 4},
  [5577] = {.lex_state = 18, .external_lex_state = 4},
  [5578] = {.lex_state = 324, .external_lex_state = 4},
  [5579] = {.lex_state = 19, .external_lex_state = 4},
  [5580] = {.lex_state = 313, .external_lex_state = 4},
  [5581] = {.lex_state = 88, .external_lex_state = 4},
  [5582] = {.lex_state = 313, .external_lex_state = 4},
  [5583] = {.lex_state = 18, .external_lex_state = 4},
  [5584] = {.lex_state = 313, .external_lex_state = 4},
  [5585] = {.lex_state = 18, .external_lex_state = 4},
  [5586] = {.lex_state = 19, .external_lex_state = 4},
  [5587] = {.lex_state = 90, .external_lex_state = 4},
  [5588] = {.lex_state = 18, .external_lex_state = 4},
  [5589] = {.lex_state = 18, .external_lex_state = 4},
  [5590] = {.lex_state = 18, .external_lex_state = 4},
  [5591] = {.lex_state = 18, .external_lex_state = 4},
  [5592] = {.lex_state = 313, .external_lex_state = 4},
  [5593] = {.lex_state = 88, .external_lex_state = 4},
  [5594] = {.lex_state = 18, .external_lex_state = 4},
  [5595] = {.lex_state = 19, .external_lex_state = 4},
  [5596] = {.lex_state = 19, .external_lex_state = 4},
  [5597] = {.lex_state = 313, .external_lex_state = 4},
  [5598] = {.lex_state = 18, .external_lex_state = 4},
  [5599] = {.lex_state = 88, .external_lex_state = 4},
  [5600] = {.lex_state = 90, .external_lex_state = 4},
  [5601] = {.lex_state = 90, .external_lex_state = 4},
  [5602] = {.lex_state = 90, .external_lex_state = 4},
  [5603] = {.lex_state = 90, .external_lex_state = 4},
  [5604] = {.lex_state = 90, .external_lex_state = 4},
  [5605] = {.lex_state = 18, .external_lex_state = 4},
  [5606] = {.lex_state = 18, .external_lex_state = 4},
  [5607] = {.lex_state = 90, .external_lex_state = 4},
  [5608] = {.lex_state = 88, .external_lex_state = 4},
  [5609] = {.lex_state = 90, .external_lex_state = 4},
  [5610] = {.lex_state = 88, .external_lex_state = 4},
  [5611] = {.lex_state = 509, .external_lex_state = 3},
  [5612] = {.lex_state = 328, .external_lex_state = 4},
  [5613] = {.lex_state = 328, .external_lex_state = 4},
  [5614] = {.lex_state = 88, .external_lex_state = 4},
  [5615] = {.lex_state = 19, .external_lex_state = 4},
  [5616] = {.lex_state = 90, .external_lex_state = 4},
  [5617] = {.lex_state = 510, .external_lex_state = 4},
  [5618] = {.lex_state = 81, .external_lex_state = 4},
  [5619] = {.lex_state = 509, .external_lex_state = 3},
  [5620] = {.lex_state = 88, .external_lex_state = 4},
  [5621] = {.lex_state = 90, .external_lex_state = 4},
  [5622] = {.lex_state = 90, .external_lex_state = 4},
  [5623] = {.lex_state = 90, .external_lex_state = 4},
  [5624] = {.lex_state = 90, .external_lex_state = 4},
  [5625] = {.lex_state = 90, .external_lex_state = 4},
  [5626] = {.lex_state = 90, .external_lex_state = 4},
  [5627] = {.lex_state = 19, .external_lex_state = 4},
  [5628] = {.lex_state = 90, .external_lex_state = 4},
  [5629] = {.lex_state = 81, .external_lex_state = 4},
  [5630] = {.lex_state = 81, .external_lex_state = 4},
  [5631] = {.lex_state = 90, .external_lex_state = 4},
  [5632] = {.lex_state = 90, .external_lex_state = 4},
  [5633] = {.lex_state = 90, .external_lex_state = 4},
  [5634] = {.lex_state = 81, .external_lex_state = 4},
  [5635] = {.lex_state = 328, .external_lex_state = 4},
  [5636] = {.lex_state = 328, .external_lex_state = 4},
  [5637] = {.lex_state = 103, .external_lex_state = 4},
  [5638] = {.lex_state = 3, .external_lex_state = 4},
  [5639] = {.lex_state = 77, .external_lex_state = 4},
  [5640] = {.lex_state = 328, .external_lex_state = 4},
  [5641] = {.lex_state = 81, .external_lex_state = 4},
  [5642] = {.lex_state = 81, .external_lex_state = 4},
  [5643] = {.lex_state = 3, .external_lex_state = 4},
  [5644] = {.lex_state = 509, .external_lex_state = 3},
  [5645] = {.lex_state = 81, .external_lex_state = 4},
  [5646] = {.lex_state = 103, .external_lex_state = 4},
  [5647] = {.lex_state = 3, .external_lex_state = 4},
  [5648] = {.lex_state = 81, .external_lex_state = 4},
  [5649] = {.lex_state = 81, .external_lex_state = 4},
  [5650] = {.lex_state = 81, .external_lex_state = 4},
  [5651] = {.lex_state = 77, .external_lex_state = 4},
  [5652] = {.lex_state = 510, .external_lex_state = 4},
  [5653] = {.lex_state = 100, .external_lex_state = 4},
  [5654] = {.lex_state = 100, .external_lex_state = 4},
  [5655] = {.lex_state = 77, .external_lex_state = 4},
  [5656] = {.lex_state = 77, .external_lex_state = 4},
  [5657] = {.lex_state = 313, .external_lex_state = 4},
  [5658] = {.lex_state = 328, .external_lex_state = 4},
  [5659] = {.lex_state = 25, .external_lex_state = 4},
  [5660] = {.lex_state = 85, .external_lex_state = 4},
  [5661] = {.lex_state = 80, .external_lex_state = 4},
  [5662] = {.lex_state = 77, .external_lex_state = 4},
  [5663] = {.lex_state = 77, .external_lex_state = 4},
  [5664] = {.lex_state = 88, .external_lex_state = 4},
  [5665] = {.lex_state = 88, .external_lex_state = 4},
  [5666] = {.lex_state = 100, .external_lex_state = 4},
  [5667] = {.lex_state = 77, .external_lex_state = 4},
  [5668] = {.lex_state = 3, .external_lex_state = 4},
  [5669] = {.lex_state = 328, .external_lex_state = 4},
  [5670] = {.lex_state = 3, .external_lex_state = 4},
  [5671] = {.lex_state = 18, .external_lex_state = 4},
  [5672] = {.lex_state = 88, .external_lex_state = 4},
  [5673] = {.lex_state = 88, .external_lex_state = 4},
  [5674] = {.lex_state = 88, .external_lex_state = 4},
  [5675] = {.lex_state = 77, .external_lex_state = 4},
  [5676] = {.lex_state = 77, .external_lex_state = 4},
  [5677] = {.lex_state = 86, .external_lex_state = 4},
  [5678] = {.lex_state = 77, .external_lex_state = 4},
  [5679] = {.lex_state = 18, .external_lex_state = 4},
  [5680] = {.lex_state = 313, .external_lex_state = 4},
  [5681] = {.lex_state = 328, .external_lex_state = 4},
  [5682] = {.lex_state = 25, .external_lex_state = 4},
  [5683] = {.lex_state = 25, .external_lex_state = 4},
  [5684] = {.lex_state = 509, .external_lex_state = 3},
  [5685] = {.lex_state = 18, .external_lex_state = 4},
  [5686] = {.lex_state = 85, .external_lex_state = 4},
  [5687] = {.lex_state = 86, .external_lex_state = 4},
  [5688] = {.lex_state = 100, .external_lex_state = 4},
  [5689] = {.lex_state = 25, .external_lex_state = 4},
  [5690] = {.lex_state = 90, .external_lex_state = 4},
  [5691] = {.lex_state = 85, .external_lex_state = 4},
  [5692] = {.lex_state = 100, .external_lex_state = 4},
  [5693] = {.lex_state = 106, .external_lex_state = 4},
  [5694] = {.lex_state = 103, .external_lex_state = 4},
  [5695] = {.lex_state = 106, .external_lex_state = 4},
  [5696] = {.lex_state = 80, .external_lex_state = 4},
  [5697] = {.lex_state = 328, .external_lex_state = 4},
  [5698] = {.lex_state = 328, .external_lex_state = 4},
  [5699] = {.lex_state = 328, .external_lex_state = 4},
  [5700] = {.lex_state = 313, .external_lex_state = 4},
  [5701] = {.lex_state = 25, .external_lex_state = 4},
  [5702] = {.lex_state = 25, .external_lex_state = 4},
  [5703] = {.lex_state = 106, .external_lex_state = 4},
  [5704] = {.lex_state = 328, .external_lex_state = 4},
  [5705] = {.lex_state = 103, .external_lex_state = 4},
  [5706] = {.lex_state = 103, .external_lex_state = 4},
  [5707] = {.lex_state = 103, .external_lex_state = 4},
  [5708] = {.lex_state = 25, .external_lex_state = 4},
  [5709] = {.lex_state = 25, .external_lex_state = 4},
  [5710] = {.lex_state = 90, .external_lex_state = 4},
  [5711] = {.lex_state = 25, .external_lex_state = 4},
  [5712] = {.lex_state = 25, .external_lex_state = 4},
  [5713] = {.lex_state = 25, .external_lex_state = 4},
  [5714] = {.lex_state = 88, .external_lex_state = 4},
  [5715] = {.lex_state = 25, .external_lex_state = 4},
  [5716] = {.lex_state = 498, .external_lex_state = 4},
  [5717] = {.lex_state = 328, .external_lex_state = 4},
  [5718] = {.lex_state = 9, .external_lex_state = 4},
  [5719] = {.lex_state = 328, .external_lex_state = 4},
  [5720] = {.lex_state = 88, .external_lex_state = 4},
  [5721] = {.lex_state = 103, .external_lex_state = 4},
  [5722] = {.lex_state = 103, .external_lex_state = 4},
  [5723] = {.lex_state = 103, .external_lex_state = 4},
  [5724] = {.lex_state = 25, .external_lex_state = 4},
  [5725] = {.lex_state = 328, .external_lex_state = 4},
  [5726] = {.lex_state = 90, .external_lex_state = 4},
  [5727] = {.lex_state = 328, .external_lex_state = 4},
  [5728] = {.lex_state = 25, .external_lex_state = 4},
  [5729] = {.lex_state = 103, .external_lex_state = 4},
  [5730] = {.lex_state = 103, .external_lex_state = 4},
  [5731] = {.lex_state = 27, .external_lex_state = 4},
  [5732] = {.lex_state = 80, .external_lex_state = 4},
  [5733] = {.lex_state = 328, .external_lex_state = 4},
  [5734] = {.lex_state = 328, .external_lex_state = 4},
  [5735] = {.lex_state = 103, .external_lex_state = 4},
  [5736] = {.lex_state = 328, .external_lex_state = 4},
  [5737] = {.lex_state = 88, .external_lex_state = 4},
  [5738] = {.lex_state = 90, .external_lex_state = 4},
  [5739] = {.lex_state = 25, .external_lex_state = 4},
  [5740] = {.lex_state = 88, .external_lex_state = 4},
  [5741] = {.lex_state = 25, .external_lex_state = 4},
  [5742] = {.lex_state = 25, .external_lex_state = 4},
  [5743] = {.lex_state = 75, .external_lex_state = 3},
  [5744] = {.lex_state = 25, .external_lex_state = 4},
  [5745] = {.lex_state = 18, .external_lex_state = 4},
  [5746] = {.lex_state = 88, .external_lex_state = 4},
  [5747] = {.lex_state = 25, .external_lex_state = 4},
  [5748] = {.lex_state = 25, .external_lex_state = 4},
  [5749] = {.lex_state = 90, .external_lex_state = 4},
  [5750] = {.lex_state = 25, .external_lex_state = 4},
  [5751] = {.lex_state = 3, .external_lex_state = 4},
  [5752] = {.lex_state = 25, .external_lex_state = 4},
  [5753] = {.lex_state = 19, .external_lex_state = 4},
  [5754] = {.lex_state = 328, .external_lex_state = 4},
  [5755] = {.lex_state = 90, .external_lex_state = 4},
  [5756] = {.lex_state = 90, .external_lex_state = 4},
  [5757] = {.lex_state = 90, .external_lex_state = 4},
  [5758] = {.lex_state = 25, .external_lex_state = 4},
  [5759] = {.lex_state = 25, .external_lex_state = 4},
  [5760] = {.lex_state = 90, .external_lex_state = 4},
  [5761] = {.lex_state = 25, .external_lex_state = 4},
  [5762] = {.lex_state = 25, .external_lex_state = 4},
  [5763] = {.lex_state = 509, .external_lex_state = 3},
  [5764] = {.lex_state = 80, .external_lex_state = 4},
  [5765] = {.lex_state = 86, .external_lex_state = 4},
  [5766] = {.lex_state = 88, .external_lex_state = 4},
  [5767] = {.lex_state = 9, .external_lex_state = 4},
  [5768] = {.lex_state = 106, .external_lex_state = 4},
  [5769] = {.lex_state = 88, .external_lex_state = 4},
  [5770] = {.lex_state = 88, .external_lex_state = 4},
  [5771] = {.lex_state = 80, .external_lex_state = 4},
  [5772] = {.lex_state = 100, .external_lex_state = 4},
  [5773] = {.lex_state = 19, .external_lex_state = 4},
  [5774] = {.lex_state = 19, .external_lex_state = 4},
  [5775] = {.lex_state = 313, .external_lex_state = 4},
  [5776] = {.lex_state = 90, .external_lex_state = 4},
  [5777] = {.lex_state = 88, .external_lex_state = 4},
  [5778] = {.lex_state = 90, .external_lex_state = 4},
  [5779] = {.lex_state = 106, .external_lex_state = 4},
  [5780] = {.lex_state = 313, .external_lex_state = 4},
  [5781] = {.lex_state = 326, .external_lex_state = 4},
  [5782] = {.lex_state = 313, .external_lex_state = 4},
  [5783] = {.lex_state = 18, .external_lex_state = 4},
  [5784] = {.lex_state = 18, .external_lex_state = 4},
  [5785] = {.lex_state = 88, .external_lex_state = 4},
  [5786] = {.lex_state = 88, .external_lex_state = 4},
  [5787] = {.lex_state = 313, .external_lex_state = 4},
  [5788] = {.lex_state = 88, .external_lex_state = 4},
  [5789] = {.lex_state = 25, .external_lex_state = 4},
  [5790] = {.lex_state = 90, .external_lex_state = 4},
  [5791] = {.lex_state = 88, .external_lex_state = 4},
  [5792] = {.lex_state = 80, .external_lex_state = 4},
  [5793] = {.lex_state = 22, .external_lex_state = 4},
  [5794] = {.lex_state = 90, .external_lex_state = 4},
  [5795] = {.lex_state = 86, .external_lex_state = 4},
  [5796] = {.lex_state = 88, .external_lex_state = 4},
  [5797] = {.lex_state = 88, .external_lex_state = 4},
  [5798] = {.lex_state = 90, .external_lex_state = 4},
  [5799] = {.lex_state = 25, .external_lex_state = 4},
  [5800] = {.lex_state = 90, .external_lex_state = 4},
  [5801] = {.lex_state = 80, .external_lex_state = 4},
  [5802] = {.lex_state = 100, .external_lex_state = 4},
  [5803] = {.lex_state = 313, .external_lex_state = 4},
  [5804] = {.lex_state = 22, .external_lex_state = 4},
  [5805] = {.lex_state = 100, .external_lex_state = 4},
  [5806] = {.lex_state = 313, .external_lex_state = 4},
  [5807] = {.lex_state = 88, .external_lex_state = 4},
  [5808] = {.lex_state = 90, .external_lex_state = 4},
  [5809] = {.lex_state = 90, .external_lex_state = 4},
  [5810] = {.lex_state = 22, .external_lex_state = 4},
  [5811] = {.lex_state = 25, .external_lex_state = 4},
  [5812] = {.lex_state = 90, .external_lex_state = 4},
  [5813] = {.lex_state = 313, .external_lex_state = 4},
  [5814] = {.lex_state = 100, .external_lex_state = 4},
  [5815] = {.lex_state = 313, .external_lex_state = 4},
  [5816] = {.lex_state = 88, .external_lex_state = 4},
  [5817] = {.lex_state = 100, .external_lex_state = 4},
  [5818] = {.lex_state = 19, .external_lex_state = 4},
  [5819] = {.lex_state = 18, .external_lex_state = 4},
  [5820] = {.lex_state = 328, .external_lex_state = 4},
  [5821] = {.lex_state = 510, .external_lex_state = 4},
  [5822] = {.lex_state = 88, .external_lex_state = 4},
  [5823] = {.lex_state = 19, .external_lex_state = 4},
  [5824] = {.lex_state = 26, .external_lex_state = 4},
  [5825] = {.lex_state = 25, .external_lex_state = 4},
  [5826] = {.lex_state = 26, .external_lex_state = 4},
  [5827] = {.lex_state = 313, .external_lex_state = 4},
  [5828] = {.lex_state = 100, .external_lex_state = 4},
  [5829] = {.lex_state = 85, .external_lex_state = 4},
  [5830] = {.lex_state = 328, .external_lex_state = 4},
  [5831] = {.lex_state = 100, .external_lex_state = 4},
  [5832] = {.lex_state = 100, .external_lex_state = 4},
  [5833] = {.lex_state = 510, .external_lex_state = 4},
  [5834] = {.lex_state = 100, .external_lex_state = 4},
  [5835] = {.lex_state = 510, .external_lex_state = 4},
  [5836] = {.lex_state = 25, .external_lex_state = 4},
  [5837] = {.lex_state = 100, .external_lex_state = 4},
  [5838] = {.lex_state = 100, .external_lex_state = 4},
  [5839] = {.lex_state = 100, .external_lex_state = 4},
  [5840] = {.lex_state = 100, .external_lex_state = 4},
  [5841] = {.lex_state = 100, .external_lex_state = 4},
  [5842] = {.lex_state = 100, .external_lex_state = 4},
  [5843] = {.lex_state = 100, .external_lex_state = 4},
  [5844] = {.lex_state = 19, .external_lex_state = 4},
  [5845] = {.lex_state = 100, .external_lex_state = 4},
  [5846] = {.lex_state = 100, .external_lex_state = 4},
  [5847] = {.lex_state = 100, .external_lex_state = 4},
  [5848] = {.lex_state = 100, .external_lex_state = 4},
  [5849] = {.lex_state = 80, .external_lex_state = 4},
  [5850] = {.lex_state = 19, .external_lex_state = 4},
  [5851] = {.lex_state = 510, .external_lex_state = 4},
  [5852] = {.lex_state = 100, .external_lex_state = 4},
  [5853] = {.lex_state = 88, .external_lex_state = 4},
  [5854] = {.lex_state = 328, .external_lex_state = 4},
  [5855] = {.lex_state = 100, .external_lex_state = 4},
  [5856] = {.lex_state = 100, .external_lex_state = 4},
  [5857] = {.lex_state = 100, .external_lex_state = 4},
  [5858] = {.lex_state = 18, .external_lex_state = 4},
  [5859] = {.lex_state = 100, .external_lex_state = 4},
  [5860] = {.lex_state = 100, .external_lex_state = 4},
  [5861] = {.lex_state = 100, .external_lex_state = 4},
  [5862] = {.lex_state = 100, .external_lex_state = 4},
  [5863] = {.lex_state = 19, .external_lex_state = 4},
  [5864] = {.lex_state = 19, .external_lex_state = 4},
  [5865] = {.lex_state = 100, .external_lex_state = 4},
  [5866] = {.lex_state = 80, .external_lex_state = 4},
  [5867] = {.lex_state = 100, .external_lex_state = 4},
  [5868] = {.lex_state = 100, .external_lex_state = 4},
  [5869] = {.lex_state = 18, .external_lex_state = 4},
  [5870] = {.lex_state = 88, .external_lex_state = 4},
  [5871] = {.lex_state = 18, .external_lex_state = 4},
  [5872] = {.lex_state = 18, .external_lex_state = 4},
  [5873] = {.lex_state = 18, .external_lex_state = 4},
  [5874] = {.lex_state = 22, .external_lex_state = 4},
  [5875] = {.lex_state = 313, .external_lex_state = 4},
  [5876] = {.lex_state = 22, .external_lex_state = 4},
  [5877] = {.lex_state = 324, .external_lex_state = 4},
  [5878] = {.lex_state = 313, .external_lex_state = 4},
  [5879] = {.lex_state = 90, .external_lex_state = 4},
  [5880] = {.lex_state = 100, .external_lex_state = 4},
  [5881] = {.lex_state = 9, .external_lex_state = 4},
  [5882] = {.lex_state = 100, .external_lex_state = 4},
  [5883] = {.lex_state = 313, .external_lex_state = 4},
  [5884] = {.lex_state = 100, .external_lex_state = 4},
  [5885] = {.lex_state = 9, .external_lex_state = 4},
  [5886] = {.lex_state = 25, .external_lex_state = 4},
  [5887] = {.lex_state = 100, .external_lex_state = 4},
  [5888] = {.lex_state = 324, .external_lex_state = 4},
  [5889] = {.lex_state = 324, .external_lex_state = 4},
  [5890] = {.lex_state = 324, .external_lex_state = 4},
  [5891] = {.lex_state = 313, .external_lex_state = 4},
  [5892] = {.lex_state = 18, .external_lex_state = 4},
  [5893] = {.lex_state = 18, .external_lex_state = 4},
  [5894] = {.lex_state = 88, .external_lex_state = 4},
  [5895] = {.lex_state = 18, .external_lex_state = 4},
  [5896] = {.lex_state = 18, .external_lex_state = 4},
  [5897] = {.lex_state = 100, .external_lex_state = 4},
  [5898] = {.lex_state = 19, .external_lex_state = 4},
  [5899] = {.lex_state = 19, .external_lex_state = 4},
  [5900] = {.lex_state = 324, .external_lex_state = 4},
  [5901] = {.lex_state = 18, .external_lex_state = 4},
  [5902] = {.lex_state = 324, .external_lex_state = 4},
  [5903] = {.lex_state = 510, .external_lex_state = 4},
  [5904] = {.lex_state = 324, .external_lex_state = 4},
  [5905] = {.lex_state = 18, .external_lex_state = 4},
  [5906] = {.lex_state = 18, .external_lex_state = 4},
  [5907] = {.lex_state = 1, .external_lex_state = 4},
  [5908] = {.lex_state = 1, .external_lex_state = 4},
  [5909] = {.lex_state = 25, .external_lex_state = 4},
  [5910] = {.lex_state = 19, .external_lex_state = 4},
  [5911] = {.lex_state = 25, .external_lex_state = 4},
  [5912] = {.lex_state = 18, .external_lex_state = 4},
  [5913] = {.lex_state = 324, .external_lex_state = 4},
  [5914] = {.lex_state = 18, .external_lex_state = 4},
  [5915] = {.lex_state = 324, .external_lex_state = 4},
  [5916] = {.lex_state = 19, .external_lex_state = 4},
  [5917] = {.lex_state = 19, .external_lex_state = 4},
  [5918] = {.lex_state = 100, .external_lex_state = 4},
  [5919] = {.lex_state = 510, .external_lex_state = 4},
  [5920] = {.lex_state = 25, .external_lex_state = 4},
  [5921] = {.lex_state = 324, .external_lex_state = 4},
  [5922] = {.lex_state = 25, .external_lex_state = 4},
  [5923] = {.lex_state = 510, .external_lex_state = 4},
  [5924] = {.lex_state = 25, .external_lex_state = 4},
  [5925] = {.lex_state = 510, .external_lex_state = 4},
  [5926] = {.lex_state = 99, .external_lex_state = 4},
  [5927] = {.lex_state = 25, .external_lex_state = 4},
  [5928] = {.lex_state = 88, .external_lex_state = 4},
  [5929] = {.lex_state = 510, .external_lex_state = 4},
  [5930] = {.lex_state = 18, .external_lex_state = 4},
  [5931] = {.lex_state = 18, .external_lex_state = 4},
  [5932] = {.lex_state = 313, .external_lex_state = 4},
  [5933] = {.lex_state = 18, .external_lex_state = 4},
  [5934] = {.lex_state = 14, .external_lex_state = 4},
  [5935] = {.lex_state = 18, .external_lex_state = 4},
  [5936] = {.lex_state = 18, .external_lex_state = 4},
  [5937] = {.lex_state = 25, .external_lex_state = 4},
  [5938] = {.lex_state = 18, .external_lex_state = 4},
  [5939] = {.lex_state = 88, .external_lex_state = 4},
  [5940] = {.lex_state = 313, .external_lex_state = 4},
  [5941] = {.lex_state = 19, .external_lex_state = 4},
  [5942] = {.lex_state = 25, .external_lex_state = 4},
  [5943] = {.lex_state = 1, .external_lex_state = 4},
  [5944] = {.lex_state = 25, .external_lex_state = 4},
  [5945] = {.lex_state = 25, .external_lex_state = 4},
  [5946] = {.lex_state = 18, .external_lex_state = 4},
  [5947] = {.lex_state = 18, .external_lex_state = 4},
  [5948] = {.lex_state = 18, .external_lex_state = 4},
  [5949] = {.lex_state = 19, .external_lex_state = 4},
  [5950] = {.lex_state = 19, .external_lex_state = 4},
  [5951] = {.lex_state = 18, .external_lex_state = 4},
  [5952] = {.lex_state = 18, .external_lex_state = 4},
  [5953] = {.lex_state = 22, .external_lex_state = 4},
  [5954] = {.lex_state = 18, .external_lex_state = 4},
  [5955] = {.lex_state = 18, .external_lex_state = 4},
  [5956] = {.lex_state = 18, .external_lex_state = 4},
  [5957] = {.lex_state = 18, .external_lex_state = 4},
  [5958] = {.lex_state = 313, .external_lex_state = 4},
  [5959] = {.lex_state = 25, .external_lex_state = 4},
  [5960] = {.lex_state = 9, .external_lex_state = 4},
  [5961] = {.lex_state = 24, .external_lex_state = 4},
  [5962] = {.lex_state = 25, .external_lex_state = 4},
  [5963] = {.lex_state = 90, .external_lex_state = 4},
  [5964] = {.lex_state = 82, .external_lex_state = 4},
  [5965] = {.lex_state = 4, .external_lex_state = 4},
  [5966] = {.lex_state = 89, .external_lex_state = 4},
  [5967] = {.lex_state = 89, .external_lex_state = 4},
  [5968] = {.lex_state = 89, .external_lex_state = 4},
  [5969] = {.lex_state = 89, .external_lex_state = 4},
  [5970] = {.lex_state = 24, .external_lex_state = 4},
  [5971] = {.lex_state = 107, .external_lex_state = 4},
  [5972] = {.lex_state = 89, .external_lex_state = 4},
  [5973] = {.lex_state = 89, .external_lex_state = 4},
  [5974] = {.lex_state = 83, .external_lex_state = 4},
  [5975] = {.lex_state = 89, .external_lex_state = 4},
  [5976] = {.lex_state = 89, .external_lex_state = 4},
  [5977] = {.lex_state = 89, .external_lex_state = 4},
  [5978] = {.lex_state = 89, .external_lex_state = 4},
  [5979] = {.lex_state = 89, .external_lex_state = 4},
  [5980] = {.lex_state = 89, .external_lex_state = 4},
  [5981] = {.lex_state = 89, .external_lex_state = 4},
  [5982] = {.lex_state = 4, .external_lex_state = 4},
  [5983] = {.lex_state = 89, .external_lex_state = 4},
  [5984] = {.lex_state = 89, .external_lex_state = 4},
  [5985] = {.lex_state = 89, .external_lex_state = 4},
  [5986] = {.lex_state = 90, .external_lex_state = 4},
  [5987] = {.lex_state = 26, .external_lex_state = 4},
  [5988] = {.lex_state = 89, .external_lex_state = 4},
  [5989] = {.lex_state = 89, .external_lex_state = 4},
  [5990] = {.lex_state = 89, .external_lex_state = 4},
  [5991] = {.lex_state = 313, .external_lex_state = 4},
  [5992] = {.lex_state = 89, .external_lex_state = 4},
  [5993] = {.lex_state = 89, .external_lex_state = 4},
  [5994] = {.lex_state = 89, .external_lex_state = 4},
  [5995] = {.lex_state = 89, .external_lex_state = 4},
  [5996] = {.lex_state = 89, .external_lex_state = 4},
  [5997] = {.lex_state = 89, .external_lex_state = 4},
  [5998] = {.lex_state = 89, .external_lex_state = 4},
  [5999] = {.lex_state = 128, .external_lex_state = 7},
  [6000] = {.lex_state = 107, .external_lex_state = 4},
  [6001] = {.lex_state = 89, .external_lex_state = 4},
  [6002] = {.lex_state = 4, .external_lex_state = 4},
  [6003] = {.lex_state = 107, .external_lex_state = 4},
  [6004] = {.lex_state = 4, .external_lex_state = 4},
  [6005] = {.lex_state = 83, .external_lex_state = 4},
  [6006] = {.lex_state = 26, .external_lex_state = 4},
  [6007] = {.lex_state = 26, .external_lex_state = 4},
  [6008] = {.lex_state = 26, .external_lex_state = 4},
  [6009] = {.lex_state = 89, .external_lex_state = 4},
  [6010] = {.lex_state = 89, .external_lex_state = 4},
  [6011] = {.lex_state = 4, .external_lex_state = 4},
  [6012] = {.lex_state = 4, .external_lex_state = 4},
  [6013] = {.lex_state = 4, .external_lex_state = 4},
  [6014] = {.lex_state = 89, .external_lex_state = 4},
  [6015] = {.lex_state = 89, .external_lex_state = 4},
  [6016] = {.lex_state = 83, .external_lex_state = 4},
  [6017] = {.lex_state = 89, .external_lex_state = 4},
  [6018] = {.lex_state = 4, .external_lex_state = 4},
  [6019] = {.lex_state = 4, .external_lex_state = 4},
  [6020] = {.lex_state = 4, .external_lex_state = 4},
  [6021] = {.lex_state = 89, .external_lex_state = 4},
  [6022] = {.lex_state = 4, .external_lex_state = 4},
  [6023] = {.lex_state = 89, .external_lex_state = 4},
  [6024] = {.lex_state = 4, .external_lex_state = 4},
  [6025] = {.lex_state = 4, .external_lex_state = 4},
  [6026] = {.lex_state = 4, .external_lex_state = 4},
  [6027] = {.lex_state = 4, .external_lex_state = 4},
  [6028] = {.lex_state = 4, .external_lex_state = 4},
  [6029] = {.lex_state = 89, .external_lex_state = 4},
  [6030] = {.lex_state = 4, .external_lex_state = 4},
  [6031] = {.lex_state = 4, .external_lex_state = 4},
  [6032] = {.lex_state = 4, .external_lex_state = 4},
  [6033] = {.lex_state = 4, .external_lex_state = 4},
  [6034] = {.lex_state = 4, .external_lex_state = 4},
  [6035] = {.lex_state = 4, .external_lex_state = 4},
  [6036] = {.lex_state = 4, .external_lex_state = 4},
  [6037] = {.lex_state = 107, .external_lex_state = 4},
  [6038] = {.lex_state = 83, .external_lex_state = 4},
  [6039] = {.lex_state = 89, .external_lex_state = 4},
  [6040] = {.lex_state = 4, .external_lex_state = 4},
  [6041] = {.lex_state = 4, .external_lex_state = 4},
  [6042] = {.lex_state = 89, .external_lex_state = 4},
  [6043] = {.lex_state = 4, .external_lex_state = 4},
  [6044] = {.lex_state = 4, .external_lex_state = 4},
  [6045] = {.lex_state = 4, .external_lex_state = 4},
  [6046] = {.lex_state = 4, .external_lex_state = 4},
  [6047] = {.lex_state = 74, .external_lex_state = 4},
  [6048] = {.lex_state = 83, .external_lex_state = 4},
  [6049] = {.lex_state = 83, .external_lex_state = 4},
  [6050] = {.lex_state = 82, .external_lex_state = 4},
  [6051] = {.lex_state = 4, .external_lex_state = 4},
  [6052] = {.lex_state = 4, .external_lex_state = 4},
  [6053] = {.lex_state = 107, .external_lex_state = 4},
  [6054] = {.lex_state = 4, .external_lex_state = 4},
  [6055] = {.lex_state = 83, .external_lex_state = 4},
  [6056] = {.lex_state = 4, .external_lex_state = 4},
  [6057] = {.lex_state = 107, .external_lex_state = 4},
  [6058] = {.lex_state = 82, .external_lex_state = 4},
  [6059] = {.lex_state = 107, .external_lex_state = 4},
  [6060] = {.lex_state = 107, .external_lex_state = 4},
  [6061] = {.lex_state = 78, .external_lex_state = 4},
  [6062] = {.lex_state = 107, .external_lex_state = 4},
  [6063] = {.lex_state = 4, .external_lex_state = 4},
  [6064] = {.lex_state = 82, .external_lex_state = 4},
  [6065] = {.lex_state = 86, .external_lex_state = 4},
  [6066] = {.lex_state = 26, .external_lex_state = 4},
  [6067] = {.lex_state = 78, .external_lex_state = 4},
  [6068] = {.lex_state = 89, .external_lex_state = 4},
  [6069] = {.lex_state = 74, .external_lex_state = 4},
  [6070] = {.lex_state = 74, .external_lex_state = 4},
  [6071] = {.lex_state = 83, .external_lex_state = 4},
  [6072] = {.lex_state = 74, .external_lex_state = 4},
  [6073] = {.lex_state = 89, .external_lex_state = 4},
  [6074] = {.lex_state = 107, .external_lex_state = 4},
  [6075] = {.lex_state = 86, .external_lex_state = 4},
  [6076] = {.lex_state = 107, .external_lex_state = 4},
  [6077] = {.lex_state = 26, .external_lex_state = 4},
  [6078] = {.lex_state = 86, .external_lex_state = 4},
  [6079] = {.lex_state = 78, .external_lex_state = 4},
  [6080] = {.lex_state = 26, .external_lex_state = 4},
  [6081] = {.lex_state = 86, .external_lex_state = 4},
  [6082] = {.lex_state = 107, .external_lex_state = 4},
  [6083] = {.lex_state = 89, .external_lex_state = 4},
  [6084] = {.lex_state = 107, .external_lex_state = 4},
  [6085] = {.lex_state = 83, .external_lex_state = 4},
  [6086] = {.lex_state = 74, .external_lex_state = 4},
  [6087] = {.lex_state = 107, .external_lex_state = 4},
  [6088] = {.lex_state = 74, .external_lex_state = 4},
  [6089] = {.lex_state = 107, .external_lex_state = 4},
  [6090] = {.lex_state = 107, .external_lex_state = 4},
  [6091] = {.lex_state = 83, .external_lex_state = 4},
  [6092] = {.lex_state = 74, .external_lex_state = 4},
  [6093] = {.lex_state = 89, .external_lex_state = 4},
  [6094] = {.lex_state = 86, .external_lex_state = 4},
  [6095] = {.lex_state = 4, .external_lex_state = 4},
  [6096] = {.lex_state = 86, .external_lex_state = 4},
  [6097] = {.lex_state = 86, .external_lex_state = 4},
  [6098] = {.lex_state = 4, .external_lex_state = 4},
  [6099] = {.lex_state = 4, .external_lex_state = 4},
  [6100] = {.lex_state = 74, .external_lex_state = 4},
  [6101] = {.lex_state = 74, .external_lex_state = 4},
  [6102] = {.lex_state = 86, .external_lex_state = 4},
  [6103] = {.lex_state = 86, .external_lex_state = 4},
  [6104] = {.lex_state = 86, .external_lex_state = 4},
  [6105] = {.lex_state = 74, .external_lex_state = 4},
  [6106] = {.lex_state = 4, .external_lex_state = 4},
  [6107] = {.lex_state = 89, .external_lex_state = 4},
  [6108] = {.lex_state = 82, .external_lex_state = 4},
  [6109] = {.lex_state = 82, .external_lex_state = 4},
  [6110] = {.lex_state = 82, .external_lex_state = 4},
  [6111] = {.lex_state = 88, .external_lex_state = 4},
  [6112] = {.lex_state = 107, .external_lex_state = 4},
  [6113] = {.lex_state = 82, .external_lex_state = 4},
  [6114] = {.lex_state = 82, .external_lex_state = 4},
  [6115] = {.lex_state = 89, .external_lex_state = 4},
  [6116] = {.lex_state = 89, .external_lex_state = 4},
  [6117] = {.lex_state = 107, .external_lex_state = 4},
  [6118] = {.lex_state = 78, .external_lex_state = 4},
  [6119] = {.lex_state = 78, .external_lex_state = 4},
  [6120] = {.lex_state = 78, .external_lex_state = 4},
  [6121] = {.lex_state = 78, .external_lex_state = 4},
  [6122] = {.lex_state = 82, .external_lex_state = 4},
  [6123] = {.lex_state = 89, .external_lex_state = 4},
  [6124] = {.lex_state = 78, .external_lex_state = 4},
  [6125] = {.lex_state = 78, .external_lex_state = 4},
  [6126] = {.lex_state = 78, .external_lex_state = 4},
  [6127] = {.lex_state = 78, .external_lex_state = 4},
  [6128] = {.lex_state = 78, .external_lex_state = 4},
  [6129] = {.lex_state = 78, .external_lex_state = 4},
  [6130] = {.lex_state = 78, .external_lex_state = 4},
  [6131] = {.lex_state = 78, .external_lex_state = 4},
  [6132] = {.lex_state = 78, .external_lex_state = 4},
  [6133] = {.lex_state = 78, .external_lex_state = 4},
  [6134] = {.lex_state = 78, .external_lex_state = 4},
  [6135] = {.lex_state = 78, .external_lex_state = 4},
  [6136] = {.lex_state = 78, .external_lex_state = 4},
  [6137] = {.lex_state = 78, .external_lex_state = 4},
  [6138] = {.lex_state = 78, .external_lex_state = 4},
  [6139] = {.lex_state = 78, .external_lex_state = 4},
  [6140] = {.lex_state = 78, .external_lex_state = 4},
  [6141] = {.lex_state = 78, .external_lex_state = 4},
  [6142] = {.lex_state = 78, .external_lex_state = 4},
  [6143] = {.lex_state = 78, .external_lex_state = 4},
  [6144] = {.lex_state = 78, .external_lex_state = 4},
  [6145] = {.lex_state = 78, .external_lex_state = 4},
  [6146] = {.lex_state = 78, .external_lex_state = 4},
  [6147] = {.lex_state = 78, .external_lex_state = 4},
  [6148] = {.lex_state = 78, .external_lex_state = 4},
  [6149] = {.lex_state = 82, .external_lex_state = 4},
  [6150] = {.lex_state = 82, .external_lex_state = 4},
  [6151] = {.lex_state = 78, .external_lex_state = 4},
  [6152] = {.lex_state = 107, .external_lex_state = 4},
  [6153] = {.lex_state = 325, .external_lex_state = 4},
  [6154] = {.lex_state = 78, .external_lex_state = 4},
  [6155] = {.lex_state = 82, .external_lex_state = 4},
  [6156] = {.lex_state = 107, .external_lex_state = 4},
  [6157] = {.lex_state = 78, .external_lex_state = 4},
  [6158] = {.lex_state = 82, .external_lex_state = 4},
  [6159] = {.lex_state = 107, .external_lex_state = 4},
  [6160] = {.lex_state = 78, .external_lex_state = 4},
  [6161] = {.lex_state = 4, .external_lex_state = 4},
  [6162] = {.lex_state = 82, .external_lex_state = 4},
  [6163] = {.lex_state = 82, .external_lex_state = 4},
  [6164] = {.lex_state = 4, .external_lex_state = 4},
  [6165] = {.lex_state = 82, .external_lex_state = 4},
  [6166] = {.lex_state = 82, .external_lex_state = 4},
  [6167] = {.lex_state = 82, .external_lex_state = 4},
  [6168] = {.lex_state = 4, .external_lex_state = 4},
  [6169] = {.lex_state = 4, .external_lex_state = 4},
  [6170] = {.lex_state = 82, .external_lex_state = 4},
  [6171] = {.lex_state = 515, .external_lex_state = 7},
  [6172] = {.lex_state = 83, .external_lex_state = 4},
  [6173] = {.lex_state = 82, .external_lex_state = 4},
  [6174] = {.lex_state = 510, .external_lex_state = 4},
  [6175] = {.lex_state = 26, .external_lex_state = 4},
  [6176] = {.lex_state = 82, .external_lex_state = 4},
  [6177] = {.lex_state = 78, .external_lex_state = 4},
  [6178] = {.lex_state = 83, .external_lex_state = 4},
  [6179] = {.lex_state = 82, .external_lex_state = 4},
  [6180] = {.lex_state = 78, .external_lex_state = 4},
  [6181] = {.lex_state = 83, .external_lex_state = 4},
  [6182] = {.lex_state = 82, .external_lex_state = 4},
  [6183] = {.lex_state = 82, .external_lex_state = 4},
  [6184] = {.lex_state = 82, .external_lex_state = 4},
  [6185] = {.lex_state = 128, .external_lex_state = 7},
  [6186] = {.lex_state = 82, .external_lex_state = 4},
  [6187] = {.lex_state = 78, .external_lex_state = 4},
  [6188] = {.lex_state = 78, .external_lex_state = 4},
  [6189] = {.lex_state = 82, .external_lex_state = 4},
  [6190] = {.lex_state = 89, .external_lex_state = 4},
  [6191] = {.lex_state = 107, .external_lex_state = 4},
  [6192] = {.lex_state = 82, .external_lex_state = 4},
  [6193] = {.lex_state = 89, .external_lex_state = 4},
  [6194] = {.lex_state = 82, .external_lex_state = 4},
  [6195] = {.lex_state = 82, .external_lex_state = 4},
  [6196] = {.lex_state = 83, .external_lex_state = 4},
  [6197] = {.lex_state = 82, .external_lex_state = 4},
  [6198] = {.lex_state = 82, .external_lex_state = 4},
  [6199] = {.lex_state = 82, .external_lex_state = 4},
  [6200] = {.lex_state = 89, .external_lex_state = 4},
  [6201] = {.lex_state = 4, .external_lex_state = 4},
  [6202] = {.lex_state = 83, .external_lex_state = 4},
  [6203] = {.lex_state = 107, .external_lex_state = 4},
  [6204] = {.lex_state = 89, .external_lex_state = 4},
  [6205] = {.lex_state = 76, .external_lex_state = 4},
  [6206] = {.lex_state = 83, .external_lex_state = 4},
  [6207] = {.lex_state = 26, .external_lex_state = 4},
  [6208] = {.lex_state = 325, .external_lex_state = 4},
  [6209] = {.lex_state = 83, .external_lex_state = 4},
  [6210] = {.lex_state = 26, .external_lex_state = 4},
  [6211] = {.lex_state = 107, .external_lex_state = 4},
  [6212] = {.lex_state = 83, .external_lex_state = 4},
  [6213] = {.lex_state = 83, .external_lex_state = 4},
  [6214] = {.lex_state = 4, .external_lex_state = 4},
  [6215] = {.lex_state = 83, .external_lex_state = 4},
  [6216] = {.lex_state = 82, .external_lex_state = 4},
  [6217] = {.lex_state = 131, .external_lex_state = 7},
  [6218] = {.lex_state = 83, .external_lex_state = 4},
  [6219] = {.lex_state = 325, .external_lex_state = 4},
  [6220] = {.lex_state = 26, .external_lex_state = 4},
  [6221] = {.lex_state = 83, .external_lex_state = 4},
  [6222] = {.lex_state = 82, .external_lex_state = 4},
  [6223] = {.lex_state = 325, .external_lex_state = 4},
  [6224] = {.lex_state = 83, .external_lex_state = 4},
  [6225] = {.lex_state = 75, .external_lex_state = 4},
  [6226] = {.lex_state = 75, .external_lex_state = 4},
  [6227] = {.lex_state = 75, .external_lex_state = 4},
  [6228] = {.lex_state = 75, .external_lex_state = 4},
  [6229] = {.lex_state = 325, .external_lex_state = 4},
  [6230] = {.lex_state = 83, .external_lex_state = 4},
  [6231] = {.lex_state = 325, .external_lex_state = 4},
  [6232] = {.lex_state = 82, .external_lex_state = 4},
  [6233] = {.lex_state = 82, .external_lex_state = 4},
  [6234] = {.lex_state = 107, .external_lex_state = 4},
  [6235] = {.lex_state = 83, .external_lex_state = 4},
  [6236] = {.lex_state = 131, .external_lex_state = 7},
  [6237] = {.lex_state = 83, .external_lex_state = 4},
  [6238] = {.lex_state = 325, .external_lex_state = 4},
  [6239] = {.lex_state = 82, .external_lex_state = 4},
  [6240] = {.lex_state = 83, .external_lex_state = 4},
  [6241] = {.lex_state = 26, .external_lex_state = 4},
  [6242] = {.lex_state = 82, .external_lex_state = 4},
  [6243] = {.lex_state = 26, .external_lex_state = 4},
  [6244] = {.lex_state = 83, .external_lex_state = 4},
  [6245] = {.lex_state = 107, .external_lex_state = 4},
  [6246] = {.lex_state = 82, .external_lex_state = 4},
  [6247] = {.lex_state = 26, .external_lex_state = 4},
  [6248] = {.lex_state = 325, .external_lex_state = 4},
  [6249] = {.lex_state = 26, .external_lex_state = 4},
  [6250] = {.lex_state = 325, .external_lex_state = 4},
  [6251] = {.lex_state = 325, .external_lex_state = 4},
  [6252] = {.lex_state = 325, .external_lex_state = 4},
  [6253] = {.lex_state = 83, .external_lex_state = 4},
  [6254] = {.lex_state = 26, .external_lex_state = 4},
  [6255] = {.lex_state = 83, .external_lex_state = 4},
  [6256] = {.lex_state = 83, .external_lex_state = 4},
  [6257] = {.lex_state = 83, .external_lex_state = 4},
  [6258] = {.lex_state = 4, .external_lex_state = 4},
  [6259] = {.lex_state = 325, .external_lex_state = 4},
  [6260] = {.lex_state = 83, .external_lex_state = 4},
  [6261] = {.lex_state = 83, .external_lex_state = 4},
  [6262] = {.lex_state = 4, .external_lex_state = 4},
  [6263] = {.lex_state = 325, .external_lex_state = 4},
  [6264] = {.lex_state = 26, .external_lex_state = 4},
  [6265] = {.lex_state = 83, .external_lex_state = 4},
  [6266] = {.lex_state = 325, .external_lex_state = 4},
  [6267] = {.lex_state = 325, .external_lex_state = 4},
  [6268] = {.lex_state = 325, .external_lex_state = 4},
  [6269] = {.lex_state = 325, .external_lex_state = 4},
  [6270] = {.lex_state = 325, .external_lex_state = 4},
  [6271] = {.lex_state = 325, .external_lex_state = 4},
  [6272] = {.lex_state = 26, .external_lex_state = 4},
  [6273] = {.lex_state = 4, .external_lex_state = 4},
  [6274] = {.lex_state = 26, .external_lex_state = 4},
  [6275] = {.lex_state = 26, .external_lex_state = 4},
  [6276] = {.lex_state = 83, .external_lex_state = 4},
  [6277] = {.lex_state = 107, .external_lex_state = 4},
  [6278] = {.lex_state = 83, .external_lex_state = 4},
  [6279] = {.lex_state = 26, .external_lex_state = 4},
  [6280] = {.lex_state = 26, .external_lex_state = 4},
  [6281] = {.lex_state = 83, .external_lex_state = 4},
  [6282] = {.lex_state = 107, .external_lex_state = 4},
  [6283] = {.lex_state = 26, .external_lex_state = 4},
  [6284] = {.lex_state = 325, .external_lex_state = 4},
  [6285] = {.lex_state = 509, .external_lex_state = 4},
  [6286] = {.lex_state = 509, .external_lex_state = 4},
  [6287] = {.lex_state = 26, .external_lex_state = 4},
  [6288] = {.lex_state = 26, .external_lex_state = 4},
  [6289] = {.lex_state = 325, .external_lex_state = 4},
  [6290] = {.lex_state = 325, .external_lex_state = 4},
  [6291] = {.lex_state = 107, .external_lex_state = 4},
  [6292] = {.lex_state = 509, .external_lex_state = 4},
  [6293] = {.lex_state = 509, .external_lex_state = 4},
  [6294] = {.lex_state = 26, .external_lex_state = 4},
  [6295] = {.lex_state = 107, .external_lex_state = 4},
  [6296] = {.lex_state = 26, .external_lex_state = 4},
  [6297] = {.lex_state = 4, .external_lex_state = 4},
  [6298] = {.lex_state = 325, .external_lex_state = 4},
  [6299] = {.lex_state = 325, .external_lex_state = 4},
  [6300] = {.lex_state = 107, .external_lex_state = 4},
  [6301] = {.lex_state = 325, .external_lex_state = 4},
  [6302] = {.lex_state = 515, .external_lex_state = 7},
  [6303] = {.lex_state = 325, .external_lex_state = 4},
  [6304] = {.lex_state = 325, .external_lex_state = 4},
  [6305] = {.lex_state = 325, .external_lex_state = 4},
  [6306] = {.lex_state = 107, .external_lex_state = 4},
  [6307] = {.lex_state = 325, .external_lex_state = 4},
  [6308] = {.lex_state = 325, .external_lex_state = 4},
  [6309] = {.lex_state = 107, .external_lex_state = 4},
  [6310] = {.lex_state = 107, .external_lex_state = 4},
  [6311] = {.lex_state = 107, .external_lex_state = 4},
  [6312] = {.lex_state = 107, .external_lex_state = 4},
  [6313] = {.lex_state = 26, .external_lex_state = 4},
  [6314] = {.lex_state = 325, .external_lex_state = 4},
  [6315] = {.lex_state = 325, .external_lex_state = 4},
  [6316] = {.lex_state = 325, .external_lex_state = 4},
  [6317] = {.lex_state = 325, .external_lex_state = 4},
  [6318] = {.lex_state = 325, .external_lex_state = 4},
  [6319] = {.lex_state = 107, .external_lex_state = 4},
  [6320] = {.lex_state = 78, .external_lex_state = 4},
  [6321] = {.lex_state = 325, .external_lex_state = 4},
  [6322] = {.lex_state = 107, .external_lex_state = 4},
  [6323] = {.lex_state = 325, .external_lex_state = 4},
  [6324] = {.lex_state = 325, .external_lex_state = 4},
  [6325] = {.lex_state = 107, .external_lex_state = 4},
  [6326] = {.lex_state = 325, .external_lex_state = 4},
  [6327] = {.lex_state = 26, .external_lex_state = 4},
  [6328] = {.lex_state = 83, .external_lex_state = 4},
  [6329] = {.lex_state = 325, .external_lex_state = 4},
  [6330] = {.lex_state = 325, .external_lex_state = 4},
  [6331] = {.lex_state = 325, .external_lex_state = 4},
  [6332] = {.lex_state = 325, .external_lex_state = 4},
  [6333] = {.lex_state = 107, .external_lex_state = 4},
  [6334] = {.lex_state = 26, .external_lex_state = 4},
  [6335] = {.lex_state = 107, .external_lex_state = 4},
  [6336] = {.lex_state = 325, .external_lex_state = 4},
  [6337] = {.lex_state = 325, .external_lex_state = 4},
  [6338] = {.lex_state = 26, .external_lex_state = 4},
  [6339] = {.lex_state = 325, .external_lex_state = 4},
  [6340] = {.lex_state = 325, .external_lex_state = 4},
  [6341] = {.lex_state = 325, .external_lex_state = 4},
  [6342] = {.lex_state = 107, .external_lex_state = 4},
  [6343] = {.lex_state = 107, .external_lex_state = 4},
  [6344] = {.lex_state = 325, .external_lex_state = 4},
  [6345] = {.lex_state = 107, .external_lex_state = 4},
  [6346] = {.lex_state = 325, .external_lex_state = 4},
  [6347] = {.lex_state = 26, .external_lex_state = 4},
  [6348] = {.lex_state = 325, .external_lex_state = 4},
  [6349] = {.lex_state = 26, .external_lex_state = 4},
  [6350] = {.lex_state = 26, .external_lex_state = 4},
  [6351] = {.lex_state = 325, .external_lex_state = 4},
  [6352] = {.lex_state = 26, .external_lex_state = 4},
  [6353] = {.lex_state = 26, .external_lex_state = 4},
  [6354] = {.lex_state = 26, .external_lex_state = 4},
  [6355] = {.lex_state = 325, .external_lex_state = 4},
  [6356] = {.lex_state = 26, .external_lex_state = 4},
  [6357] = {.lex_state = 26, .external_lex_state = 4},
  [6358] = {.lex_state = 4, .external_lex_state = 4},
  [6359] = {.lex_state = 325, .external_lex_state = 4},
  [6360] = {.lex_state = 95, .external_lex_state = 4},
  [6361] = {.lex_state = 313, .external_lex_state = 4},
  [6362] = {.lex_state = 26, .external_lex_state = 4},
  [6363] = {.lex_state = 26, .external_lex_state = 4},
  [6364] = {.lex_state = 26, .external_lex_state = 4},
  [6365] = {.lex_state = 83, .external_lex_state = 4},
  [6366] = {.lex_state = 74, .external_lex_state = 4},
  [6367] = {.lex_state = 82, .external_lex_state = 4},
  [6368] = {.lex_state = 82, .external_lex_state = 4},
  [6369] = {.lex_state = 325, .external_lex_state = 4},
  [6370] = {.lex_state = 19, .external_lex_state = 4},
  [6371] = {.lex_state = 18, .external_lex_state = 4},
  [6372] = {.lex_state = 26, .external_lex_state = 4},
  [6373] = {.lex_state = 25, .external_lex_state = 4},
  [6374] = {.lex_state = 131, .external_lex_state = 7},
  [6375] = {.lex_state = 515, .external_lex_state = 7},
  [6376] = {.lex_state = 78, .external_lex_state = 4},
  [6377] = {.lex_state = 74, .external_lex_state = 4},
  [6378] = {.lex_state = 313, .external_lex_state = 4},
  [6379] = {.lex_state = 83, .external_lex_state = 4},
  [6380] = {.lex_state = 89, .external_lex_state = 4},
  [6381] = {.lex_state = 83, .external_lex_state = 4},
  [6382] = {.lex_state = 89, .external_lex_state = 4},
  [6383] = {.lex_state = 26, .external_lex_state = 4},
  [6384] = {.lex_state = 83, .external_lex_state = 4},
  [6385] = {.lex_state = 83, .external_lex_state = 4},
  [6386] = {.lex_state = 82, .external_lex_state = 4},
  [6387] = {.lex_state = 86, .external_lex_state = 4},
  [6388] = {.lex_state = 26, .external_lex_state = 4},
  [6389] = {.lex_state = 4, .external_lex_state = 4},
  [6390] = {.lex_state = 4, .external_lex_state = 4},
  [6391] = {.lex_state = 4, .external_lex_state = 4},
  [6392] = {.lex_state = 78, .external_lex_state = 4},
  [6393] = {.lex_state = 4, .external_lex_state = 4},
  [6394] = {.lex_state = 26, .external_lex_state = 4},
  [6395] = {.lex_state = 83, .external_lex_state = 4},
  [6396] = {.lex_state = 83, .external_lex_state = 4},
  [6397] = {.lex_state = 26, .external_lex_state = 4},
  [6398] = {.lex_state = 82, .external_lex_state = 4},
  [6399] = {.lex_state = 82, .external_lex_state = 4},
  [6400] = {.lex_state = 82, .external_lex_state = 4},
  [6401] = {.lex_state = 82, .external_lex_state = 4},
  [6402] = {.lex_state = 107, .external_lex_state = 4},
  [6403] = {.lex_state = 26, .external_lex_state = 4},
  [6404] = {.lex_state = 83, .external_lex_state = 4},
  [6405] = {.lex_state = 83, .external_lex_state = 4},
  [6406] = {.lex_state = 4, .external_lex_state = 4},
  [6407] = {.lex_state = 82, .external_lex_state = 4},
  [6408] = {.lex_state = 26, .external_lex_state = 4},
  [6409] = {.lex_state = 82, .external_lex_state = 4},
  [6410] = {.lex_state = 83, .external_lex_state = 4},
  [6411] = {.lex_state = 26, .external_lex_state = 4},
  [6412] = {.lex_state = 86, .external_lex_state = 4},
  [6413] = {.lex_state = 325, .external_lex_state = 4},
  [6414] = {.lex_state = 4, .external_lex_state = 4},
  [6415] = {.lex_state = 26, .external_lex_state = 4},
  [6416] = {.lex_state = 78, .external_lex_state = 4},
  [6417] = {.lex_state = 78, .external_lex_state = 4},
  [6418] = {.lex_state = 82, .external_lex_state = 4},
  [6419] = {.lex_state = 82, .external_lex_state = 4},
  [6420] = {.lex_state = 78, .external_lex_state = 4},
  [6421] = {.lex_state = 78, .external_lex_state = 4},
  [6422] = {.lex_state = 510, .external_lex_state = 4},
  [6423] = {.lex_state = 82, .external_lex_state = 4},
  [6424] = {.lex_state = 107, .external_lex_state = 4},
  [6425] = {.lex_state = 89, .external_lex_state = 4},
  [6426] = {.lex_state = 82, .external_lex_state = 4},
  [6427] = {.lex_state = 107, .external_lex_state = 4},
  [6428] = {.lex_state = 107, .external_lex_state = 4},
  [6429] = {.lex_state = 82, .external_lex_state = 4},
  [6430] = {.lex_state = 83, .external_lex_state = 4},
  [6431] = {.lex_state = 82, .external_lex_state = 4},
  [6432] = {.lex_state = 107, .external_lex_state = 4},
  [6433] = {.lex_state = 128, .external_lex_state = 7},
  [6434] = {.lex_state = 83, .external_lex_state = 4},
  [6435] = {.lex_state = 89, .external_lex_state = 4},
  [6436] = {.lex_state = 26, .external_lex_state = 4},
  [6437] = {.lex_state = 90, .external_lex_state = 4},
  [6438] = {.lex_state = 26, .external_lex_state = 4},
  [6439] = {.lex_state = 83, .external_lex_state = 4},
  [6440] = {.lex_state = 107, .external_lex_state = 4},
  [6441] = {.lex_state = 78, .external_lex_state = 4},
  [6442] = {.lex_state = 83, .external_lex_state = 4},
  [6443] = {.lex_state = 78, .external_lex_state = 4},
  [6444] = {.lex_state = 107, .external_lex_state = 4},
  [6445] = {.lex_state = 26, .external_lex_state = 4},
  [6446] = {.lex_state = 107, .external_lex_state = 4},
  [6447] = {.lex_state = 26, .external_lex_state = 4},
  [6448] = {.lex_state = 26, .external_lex_state = 4},
  [6449] = {.lex_state = 107, .external_lex_state = 4},
  [6450] = {.lex_state = 88, .external_lex_state = 4},
  [6451] = {.lex_state = 89, .external_lex_state = 4},
  [6452] = {.lex_state = 78, .external_lex_state = 4},
  [6453] = {.lex_state = 78, .external_lex_state = 4},
  [6454] = {.lex_state = 107, .external_lex_state = 4},
  [6455] = {.lex_state = 89, .external_lex_state = 4},
  [6456] = {.lex_state = 89, .external_lex_state = 4},
  [6457] = {.lex_state = 498, .external_lex_state = 4},
  [6458] = {.lex_state = 107, .external_lex_state = 4},
  [6459] = {.lex_state = 4, .external_lex_state = 4},
  [6460] = {.lex_state = 78, .external_lex_state = 4},
  [6461] = {.lex_state = 78, .external_lex_state = 4},
  [6462] = {.lex_state = 83, .external_lex_state = 4},
  [6463] = {.lex_state = 78, .external_lex_state = 4},
  [6464] = {.lex_state = 83, .external_lex_state = 4},
  [6465] = {.lex_state = 83, .external_lex_state = 4},
  [6466] = {.lex_state = 509, .external_lex_state = 4},
  [6467] = {.lex_state = 128, .external_lex_state = 2},
  [6468] = {.lex_state = 509, .external_lex_state = 4},
  [6469] = {.lex_state = 157, .external_lex_state = 2},
  [6470] = {.lex_state = 509, .external_lex_state = 4},
  [6471] = {.lex_state = 509, .external_lex_state = 4},
  [6472] = {.lex_state = 131, .external_lex_state = 2},
  [6473] = {.lex_state = 131, .external_lex_state = 2},
  [6474] = {.lex_state = 131, .external_lex_state = 2},
  [6475] = {.lex_state = 131, .external_lex_state = 2},
  [6476] = {.lex_state = 509, .external_lex_state = 4},
  [6477] = {.lex_state = 82, .external_lex_state = 4},
  [6478] = {.lex_state = 509, .external_lex_state = 4},
  [6479] = {.lex_state = 127, .external_lex_state = 7},
  [6480] = {.lex_state = 509, .external_lex_state = 4},
  [6481] = {.lex_state = 509, .external_lex_state = 4},
  [6482] = {.lex_state = 90, .external_lex_state = 7},
  [6483] = {.lex_state = 509, .external_lex_state = 4},
  [6484] = {.lex_state = 509, .external_lex_state = 4},
  [6485] = {.lex_state = 509, .external_lex_state = 4},
  [6486] = {.lex_state = 75, .external_lex_state = 4},
  [6487] = {.lex_state = 509, .external_lex_state = 4},
  [6488] = {.lex_state = 90, .external_lex_state = 7},
  [6489] = {.lex_state = 88, .external_lex_state = 7},
  [6490] = {.lex_state = 509, .external_lex_state = 4},
  [6491] = {.lex_state = 509, .external_lex_state = 4},
  [6492] = {.lex_state = 325, .external_lex_state = 4},
  [6493] = {.lex_state = 509, .external_lex_state = 4},
  [6494] = {.lex_state = 509, .external_lex_state = 4},
  [6495] = {.lex_state = 126, .external_lex_state = 7},
  [6496] = {.lex_state = 509, .external_lex_state = 4},
  [6497] = {.lex_state = 509, .external_lex_state = 4},
  [6498] = {.lex_state = 82, .external_lex_state = 4},
  [6499] = {.lex_state = 509, .external_lex_state = 4},
  [6500] = {.lex_state = 509, .external_lex_state = 4},
  [6501] = {.lex_state = 509, .external_lex_state = 4},
  [6502] = {.lex_state = 509, .external_lex_state = 4},
  [6503] = {.lex_state = 75, .external_lex_state = 4},
  [6504] = {.lex_state = 129, .external_lex_state = 7},
  [6505] = {.lex_state = 509, .external_lex_state = 4},
  [6506] = {.lex_state = 509, .external_lex_state = 4},
  [6507] = {.lex_state = 509, .external_lex_state = 4},
  [6508] = {.lex_state = 509, .external_lex_state = 4},
  [6509] = {.lex_state = 509, .external_lex_state = 4},
  [6510] = {.lex_state = 509, .external_lex_state = 4},
  [6511] = {.lex_state = 509, .external_lex_state = 4},
  [6512] = {.lex_state = 75, .external_lex_state = 4},
  [6513] = {.lex_state = 75, .external_lex_state = 4},
  [6514] = {.lex_state = 75, .external_lex_state = 4},
  [6515] = {.lex_state = 509, .external_lex_state = 4},
  [6516] = {.lex_state = 509, .external_lex_state = 4},
  [6517] = {.lex_state = 75, .external_lex_state = 4},
  [6518] = {.lex_state = 75, .external_lex_state = 4},
  [6519] = {.lex_state = 509, .external_lex_state = 4},
  [6520] = {.lex_state = 75, .external_lex_state = 4},
  [6521] = {.lex_state = 75, .external_lex_state = 4},
  [6522] = {.lex_state = 75, .external_lex_state = 4},
  [6523] = {.lex_state = 75, .external_lex_state = 4},
  [6524] = {.lex_state = 75, .external_lex_state = 4},
  [6525] = {.lex_state = 510, .external_lex_state = 7},
  [6526] = {.lex_state = 509, .external_lex_state = 4},
  [6527] = {.lex_state = 515, .external_lex_state = 2},
  [6528] = {.lex_state = 515, .external_lex_state = 2},
  [6529] = {.lex_state = 509, .external_lex_state = 4},
  [6530] = {.lex_state = 509, .external_lex_state = 4},
  [6531] = {.lex_state = 509, .external_lex_state = 4},
  [6532] = {.lex_state = 509, .external_lex_state = 4},
  [6533] = {.lex_state = 75, .external_lex_state = 4},
  [6534] = {.lex_state = 75, .external_lex_state = 4},
  [6535] = {.lex_state = 75, .external_lex_state = 4},
  [6536] = {.lex_state = 509, .external_lex_state = 4},
  [6537] = {.lex_state = 75, .external_lex_state = 4},
  [6538] = {.lex_state = 75, .external_lex_state = 4},
  [6539] = {.lex_state = 75, .external_lex_state = 4},
  [6540] = {.lex_state = 75, .external_lex_state = 4},
  [6541] = {.lex_state = 75, .external_lex_state = 4},
  [6542] = {.lex_state = 515, .external_lex_state = 2},
  [6543] = {.lex_state = 75, .external_lex_state = 4},
  [6544] = {.lex_state = 515, .external_lex_state = 2},
  [6545] = {.lex_state = 75, .external_lex_state = 4},
  [6546] = {.lex_state = 75, .external_lex_state = 4},
  [6547] = {.lex_state = 75, .external_lex_state = 4},
  [6548] = {.lex_state = 89, .external_lex_state = 4},
  [6549] = {.lex_state = 75, .external_lex_state = 4},
  [6550] = {.lex_state = 509, .external_lex_state = 4},
  [6551] = {.lex_state = 509, .external_lex_state = 4},
  [6552] = {.lex_state = 75, .external_lex_state = 4},
  [6553] = {.lex_state = 75, .external_lex_state = 4},
  [6554] = {.lex_state = 498, .external_lex_state = 4},
  [6555] = {.lex_state = 509, .external_lex_state = 4},
  [6556] = {.lex_state = 75, .external_lex_state = 4},
  [6557] = {.lex_state = 510, .external_lex_state = 4},
  [6558] = {.lex_state = 75, .external_lex_state = 4},
  [6559] = {.lex_state = 75, .external_lex_state = 4},
  [6560] = {.lex_state = 75, .external_lex_state = 4},
  [6561] = {.lex_state = 75, .external_lex_state = 4},
  [6562] = {.lex_state = 129, .external_lex_state = 7},
  [6563] = {.lex_state = 83, .external_lex_state = 4},
  [6564] = {.lex_state = 127, .external_lex_state = 7},
  [6565] = {.lex_state = 88, .external_lex_state = 7},
  [6566] = {.lex_state = 75, .external_lex_state = 4},
  [6567] = {.lex_state = 75, .external_lex_state = 4},
  [6568] = {.lex_state = 75, .external_lex_state = 4},
  [6569] = {.lex_state = 313, .external_lex_state = 4},
  [6570] = {.lex_state = 75, .external_lex_state = 4},
  [6571] = {.lex_state = 509, .external_lex_state = 4},
  [6572] = {.lex_state = 325, .external_lex_state = 4},
  [6573] = {.lex_state = 75, .external_lex_state = 4},
  [6574] = {.lex_state = 88, .external_lex_state = 7},
  [6575] = {.lex_state = 75, .external_lex_state = 4},
  [6576] = {.lex_state = 75, .external_lex_state = 4},
  [6577] = {.lex_state = 75, .external_lex_state = 4},
  [6578] = {.lex_state = 75, .external_lex_state = 4},
  [6579] = {.lex_state = 509, .external_lex_state = 4},
  [6580] = {.lex_state = 75, .external_lex_state = 4},
  [6581] = {.lex_state = 509, .external_lex_state = 4},
  [6582] = {.lex_state = 510, .external_lex_state = 7},
  [6583] = {.lex_state = 313, .external_lex_state = 4},
  [6584] = {.lex_state = 313, .external_lex_state = 4},
  [6585] = {.lex_state = 126, .external_lex_state = 7},
  [6586] = {.lex_state = 128, .external_lex_state = 2},
  [6587] = {.lex_state = 75, .external_lex_state = 4},
  [6588] = {.lex_state = 313, .external_lex_state = 4},
  [6589] = {.lex_state = 75, .external_lex_state = 4},
  [6590] = {.lex_state = 4, .external_lex_state = 4},
  [6591] = {.lex_state = 75, .external_lex_state = 4},
  [6592] = {.lex_state = 75, .external_lex_state = 4},
  [6593] = {.lex_state = 509, .external_lex_state = 4},
  [6594] = {.lex_state = 75, .external_lex_state = 4},
  [6595] = {.lex_state = 75, .external_lex_state = 4},
  [6596] = {.lex_state = 126, .external_lex_state = 7},
  [6597] = {.lex_state = 75, .external_lex_state = 4},
  [6598] = {.lex_state = 154, .external_lex_state = 2},
  [6599] = {.lex_state = 75, .external_lex_state = 4},
  [6600] = {.lex_state = 509, .external_lex_state = 4},
  [6601] = {.lex_state = 75, .external_lex_state = 4},
  [6602] = {.lex_state = 510, .external_lex_state = 7},
  [6603] = {.lex_state = 89, .external_lex_state = 4},
  [6604] = {.lex_state = 520, .external_lex_state = 2},
  [6605] = {.lex_state = 75, .external_lex_state = 4},
  [6606] = {.lex_state = 330, .external_lex_state = 7},
  [6607] = {.lex_state = 509, .external_lex_state = 4},
  [6608] = {.lex_state = 509, .external_lex_state = 4},
  [6609] = {.lex_state = 128, .external_lex_state = 2},
  [6610] = {.lex_state = 75, .external_lex_state = 4},
  [6611] = {.lex_state = 509, .external_lex_state = 4},
  [6612] = {.lex_state = 330, .external_lex_state = 7},
  [6613] = {.lex_state = 509, .external_lex_state = 4},
  [6614] = {.lex_state = 509, .external_lex_state = 4},
  [6615] = {.lex_state = 75, .external_lex_state = 4},
  [6616] = {.lex_state = 75, .external_lex_state = 4},
  [6617] = {.lex_state = 509, .external_lex_state = 4},
  [6618] = {.lex_state = 509, .external_lex_state = 4},
  [6619] = {.lex_state = 90, .external_lex_state = 7},
  [6620] = {.lex_state = 90, .external_lex_state = 4},
  [6621] = {.lex_state = 330, .external_lex_state = 7},
  [6622] = {.lex_state = 88, .external_lex_state = 4},
  [6623] = {.lex_state = 129, .external_lex_state = 7},
  [6624] = {.lex_state = 509, .external_lex_state = 4},
  [6625] = {.lex_state = 509, .external_lex_state = 4},
  [6626] = {.lex_state = 509, .external_lex_state = 4},
  [6627] = {.lex_state = 128, .external_lex_state = 2},
  [6628] = {.lex_state = 83, .external_lex_state = 4},
  [6629] = {.lex_state = 127, .external_lex_state = 7},
  [6630] = {.lex_state = 498, .external_lex_state = 4},
  [6631] = {.lex_state = 26, .external_lex_state = 4},
  [6632] = {.lex_state = 75, .external_lex_state = 4},
  [6633] = {.lex_state = 131, .external_lex_state = 2},
  [6634] = {.lex_state = 515, .external_lex_state = 2},
  [6635] = {.lex_state = 126, .external_lex_state = 2},
  [6636] = {.lex_state = 325, .external_lex_state = 4},
  [6637] = {.lex_state = 126, .external_lex_state = 2},
  [6638] = {.lex_state = 126, .external_lex_state = 2},
  [6639] = {.lex_state = 130, .external_lex_state = 7},
  [6640] = {.lex_state = 131, .external_lex_state = 2},
  [6641] = {.lex_state = 82, .external_lex_state = 4},
  [6642] = {.lex_state = 128, .external_lex_state = 2},
  [6643] = {.lex_state = 163, .external_lex_state = 2},
  [6644] = {.lex_state = 83, .external_lex_state = 7},
  [6645] = {.lex_state = 115, .external_lex_state = 7},
  [6646] = {.lex_state = 330, .external_lex_state = 2},
  [6647] = {.lex_state = 128, .external_lex_state = 2},
  [6648] = {.lex_state = 128, .external_lex_state = 2},
  [6649] = {.lex_state = 330, .external_lex_state = 2},
  [6650] = {.lex_state = 515, .external_lex_state = 2},
  [6651] = {.lex_state = 313, .external_lex_state = 4},
  [6652] = {.lex_state = 131, .external_lex_state = 2},
  [6653] = {.lex_state = 127, .external_lex_state = 2},
  [6654] = {.lex_state = 521, .external_lex_state = 2},
  [6655] = {.lex_state = 515, .external_lex_state = 2},
  [6656] = {.lex_state = 515, .external_lex_state = 2},
  [6657] = {.lex_state = 90, .external_lex_state = 2},
  [6658] = {.lex_state = 515, .external_lex_state = 2},
  [6659] = {.lex_state = 515, .external_lex_state = 2},
  [6660] = {.lex_state = 89, .external_lex_state = 7},
  [6661] = {.lex_state = 128, .external_lex_state = 2},
  [6662] = {.lex_state = 128, .external_lex_state = 2},
  [6663] = {.lex_state = 515, .external_lex_state = 2},
  [6664] = {.lex_state = 128, .external_lex_state = 2},
  [6665] = {.lex_state = 131, .external_lex_state = 2},
  [6666] = {.lex_state = 330, .external_lex_state = 2},
  [6667] = {.lex_state = 128, .external_lex_state = 2},
  [6668] = {.lex_state = 128, .external_lex_state = 2},
  [6669] = {.lex_state = 131, .external_lex_state = 2},
  [6670] = {.lex_state = 131, .external_lex_state = 2},
  [6671] = {.lex_state = 128, .external_lex_state = 2},
  [6672] = {.lex_state = 128, .external_lex_state = 2},
  [6673] = {.lex_state = 128, .external_lex_state = 2},
  [6674] = {.lex_state = 325, .external_lex_state = 7},
  [6675] = {.lex_state = 330, .external_lex_state = 2},
  [6676] = {.lex_state = 515, .external_lex_state = 2},
  [6677] = {.lex_state = 128, .external_lex_state = 2},
  [6678] = {.lex_state = 128, .external_lex_state = 2},
  [6679] = {.lex_state = 128, .external_lex_state = 2},
  [6680] = {.lex_state = 128, .external_lex_state = 2},
  [6681] = {.lex_state = 128, .external_lex_state = 2},
  [6682] = {.lex_state = 128, .external_lex_state = 2},
  [6683] = {.lex_state = 128, .external_lex_state = 2},
  [6684] = {.lex_state = 131, .external_lex_state = 2},
  [6685] = {.lex_state = 128, .external_lex_state = 2},
  [6686] = {.lex_state = 128, .external_lex_state = 2},
  [6687] = {.lex_state = 128, .external_lex_state = 2},
  [6688] = {.lex_state = 128, .external_lex_state = 2},
  [6689] = {.lex_state = 128, .external_lex_state = 2},
  [6690] = {.lex_state = 115, .external_lex_state = 7},
  [6691] = {.lex_state = 128, .external_lex_state = 2},
  [6692] = {.lex_state = 128, .external_lex_state = 2},
  [6693] = {.lex_state = 128, .external_lex_state = 2},
  [6694] = {.lex_state = 128, .external_lex_state = 2},
  [6695] = {.lex_state = 89, .external_lex_state = 4},
  [6696] = {.lex_state = 128, .external_lex_state = 2},
  [6697] = {.lex_state = 128, .external_lex_state = 2},
  [6698] = {.lex_state = 128, .external_lex_state = 2},
  [6699] = {.lex_state = 131, .external_lex_state = 2},
  [6700] = {.lex_state = 128, .external_lex_state = 2},
  [6701] = {.lex_state = 131, .external_lex_state = 2},
  [6702] = {.lex_state = 75, .external_lex_state = 4},
  [6703] = {.lex_state = 131, .external_lex_state = 2},
  [6704] = {.lex_state = 131, .external_lex_state = 2},
  [6705] = {.lex_state = 515, .external_lex_state = 2},
  [6706] = {.lex_state = 515, .external_lex_state = 2},
  [6707] = {.lex_state = 515, .external_lex_state = 2},
  [6708] = {.lex_state = 128, .external_lex_state = 2},
  [6709] = {.lex_state = 131, .external_lex_state = 2},
  [6710] = {.lex_state = 131, .external_lex_state = 2},
  [6711] = {.lex_state = 515, .external_lex_state = 2},
  [6712] = {.lex_state = 131, .external_lex_state = 2},
  [6713] = {.lex_state = 131, .external_lex_state = 2},
  [6714] = {.lex_state = 131, .external_lex_state = 2},
  [6715] = {.lex_state = 82, .external_lex_state = 7},
  [6716] = {.lex_state = 131, .external_lex_state = 2},
  [6717] = {.lex_state = 131, .external_lex_state = 2},
  [6718] = {.lex_state = 131, .external_lex_state = 2},
  [6719] = {.lex_state = 131, .external_lex_state = 2},
  [6720] = {.lex_state = 131, .external_lex_state = 2},
  [6721] = {.lex_state = 128, .external_lex_state = 2},
  [6722] = {.lex_state = 131, .external_lex_state = 2},
  [6723] = {.lex_state = 131, .external_lex_state = 2},
  [6724] = {.lex_state = 128, .external_lex_state = 2},
  [6725] = {.lex_state = 131, .external_lex_state = 2},
  [6726] = {.lex_state = 131, .external_lex_state = 2},
  [6727] = {.lex_state = 131, .external_lex_state = 2},
  [6728] = {.lex_state = 131, .external_lex_state = 2},
  [6729] = {.lex_state = 515, .external_lex_state = 2},
  [6730] = {.lex_state = 131, .external_lex_state = 2},
  [6731] = {.lex_state = 131, .external_lex_state = 2},
  [6732] = {.lex_state = 131, .external_lex_state = 2},
  [6733] = {.lex_state = 131, .external_lex_state = 2},
  [6734] = {.lex_state = 131, .external_lex_state = 2},
  [6735] = {.lex_state = 83, .external_lex_state = 7},
  [6736] = {.lex_state = 131, .external_lex_state = 2},
  [6737] = {.lex_state = 131, .external_lex_state = 2},
  [6738] = {.lex_state = 131, .external_lex_state = 2},
  [6739] = {.lex_state = 96, .external_lex_state = 2},
  [6740] = {.lex_state = 128, .external_lex_state = 2},
  [6741] = {.lex_state = 510, .external_lex_state = 2},
  [6742] = {.lex_state = 26, .external_lex_state = 4},
  [6743] = {.lex_state = 509, .external_lex_state = 4},
  [6744] = {.lex_state = 515, .external_lex_state = 2},
  [6745] = {.lex_state = 515, .external_lex_state = 2},
  [6746] = {.lex_state = 515, .external_lex_state = 2},
  [6747] = {.lex_state = 515, .external_lex_state = 2},
  [6748] = {.lex_state = 515, .external_lex_state = 2},
  [6749] = {.lex_state = 127, .external_lex_state = 2},
  [6750] = {.lex_state = 498, .external_lex_state = 4},
  [6751] = {.lex_state = 130, .external_lex_state = 7},
  [6752] = {.lex_state = 128, .external_lex_state = 2},
  [6753] = {.lex_state = 128, .external_lex_state = 2},
  [6754] = {.lex_state = 89, .external_lex_state = 7},
  [6755] = {.lex_state = 510, .external_lex_state = 2},
  [6756] = {.lex_state = 131, .external_lex_state = 2},
  [6757] = {.lex_state = 155, .external_lex_state = 2},
  [6758] = {.lex_state = 515, .external_lex_state = 2},
  [6759] = {.lex_state = 515, .external_lex_state = 2},
  [6760] = {.lex_state = 515, .external_lex_state = 2},
  [6761] = {.lex_state = 515, .external_lex_state = 2},
  [6762] = {.lex_state = 515, .external_lex_state = 2},
  [6763] = {.lex_state = 511, .external_lex_state = 2},
  [6764] = {.lex_state = 515, .external_lex_state = 2},
  [6765] = {.lex_state = 152, .external_lex_state = 2},
  [6766] = {.lex_state = 515, .external_lex_state = 2},
  [6767] = {.lex_state = 515, .external_lex_state = 2},
  [6768] = {.lex_state = 515, .external_lex_state = 2},
  [6769] = {.lex_state = 131, .external_lex_state = 2},
  [6770] = {.lex_state = 90, .external_lex_state = 2},
  [6771] = {.lex_state = 131, .external_lex_state = 2},
  [6772] = {.lex_state = 510, .external_lex_state = 2},
  [6773] = {.lex_state = 334, .external_lex_state = 2},
  [6774] = {.lex_state = 90, .external_lex_state = 2},
  [6775] = {.lex_state = 93, .external_lex_state = 2},
  [6776] = {.lex_state = 515, .external_lex_state = 2},
  [6777] = {.lex_state = 515, .external_lex_state = 2},
  [6778] = {.lex_state = 515, .external_lex_state = 2},
  [6779] = {.lex_state = 131, .external_lex_state = 2},
  [6780] = {.lex_state = 131, .external_lex_state = 2},
  [6781] = {.lex_state = 325, .external_lex_state = 7},
  [6782] = {.lex_state = 510, .external_lex_state = 2},
  [6783] = {.lex_state = 515, .external_lex_state = 2},
  [6784] = {.lex_state = 515, .external_lex_state = 2},
  [6785] = {.lex_state = 131, .external_lex_state = 2},
  [6786] = {.lex_state = 515, .external_lex_state = 2},
  [6787] = {.lex_state = 88, .external_lex_state = 2},
  [6788] = {.lex_state = 128, .external_lex_state = 2},
  [6789] = {.lex_state = 88, .external_lex_state = 2},
  [6790] = {.lex_state = 131, .external_lex_state = 2},
  [6791] = {.lex_state = 515, .external_lex_state = 2},
  [6792] = {.lex_state = 509, .external_lex_state = 4},
  [6793] = {.lex_state = 131, .external_lex_state = 2},
  [6794] = {.lex_state = 515, .external_lex_state = 2},
  [6795] = {.lex_state = 515, .external_lex_state = 2},
  [6796] = {.lex_state = 515, .external_lex_state = 2},
  [6797] = {.lex_state = 131, .external_lex_state = 2},
  [6798] = {.lex_state = 128, .external_lex_state = 2},
  [6799] = {.lex_state = 515, .external_lex_state = 2},
  [6800] = {.lex_state = 128, .external_lex_state = 2},
  [6801] = {.lex_state = 160, .external_lex_state = 2},
  [6802] = {.lex_state = 83, .external_lex_state = 7},
  [6803] = {.lex_state = 128, .external_lex_state = 2},
  [6804] = {.lex_state = 515, .external_lex_state = 2},
  [6805] = {.lex_state = 325, .external_lex_state = 7},
  [6806] = {.lex_state = 515, .external_lex_state = 2},
  [6807] = {.lex_state = 128, .external_lex_state = 2},
  [6808] = {.lex_state = 515, .external_lex_state = 2},
  [6809] = {.lex_state = 515, .external_lex_state = 2},
  [6810] = {.lex_state = 128, .external_lex_state = 2},
  [6811] = {.lex_state = 128, .external_lex_state = 2},
  [6812] = {.lex_state = 515, .external_lex_state = 2},
  [6813] = {.lex_state = 515, .external_lex_state = 2},
  [6814] = {.lex_state = 128, .external_lex_state = 2},
  [6815] = {.lex_state = 89, .external_lex_state = 7},
  [6816] = {.lex_state = 515, .external_lex_state = 2},
  [6817] = {.lex_state = 128, .external_lex_state = 2},
  [6818] = {.lex_state = 515, .external_lex_state = 2},
  [6819] = {.lex_state = 131, .external_lex_state = 2},
  [6820] = {.lex_state = 90, .external_lex_state = 2},
  [6821] = {.lex_state = 88, .external_lex_state = 2},
  [6822] = {.lex_state = 153, .external_lex_state = 2},
  [6823] = {.lex_state = 75, .external_lex_state = 4},
  [6824] = {.lex_state = 130, .external_lex_state = 7},
  [6825] = {.lex_state = 515, .external_lex_state = 2},
  [6826] = {.lex_state = 88, .external_lex_state = 2},
  [6827] = {.lex_state = 126, .external_lex_state = 2},
  [6828] = {.lex_state = 131, .external_lex_state = 2},
  [6829] = {.lex_state = 515, .external_lex_state = 2},
  [6830] = {.lex_state = 127, .external_lex_state = 2},
  [6831] = {.lex_state = 128, .external_lex_state = 2},
  [6832] = {.lex_state = 82, .external_lex_state = 7},
  [6833] = {.lex_state = 131, .external_lex_state = 2},
  [6834] = {.lex_state = 131, .external_lex_state = 2},
  [6835] = {.lex_state = 129, .external_lex_state = 2},
  [6836] = {.lex_state = 83, .external_lex_state = 4},
  [6837] = {.lex_state = 82, .external_lex_state = 7},
  [6838] = {.lex_state = 115, .external_lex_state = 7},
  [6839] = {.lex_state = 129, .external_lex_state = 2},
  [6840] = {.lex_state = 129, .external_lex_state = 2},
  [6841] = {.lex_state = 127, .external_lex_state = 2},
  [6842] = {.lex_state = 129, .external_lex_state = 2},
  [6843] = {.lex_state = 128, .external_lex_state = 2},
  [6844] = {.lex_state = 88, .external_lex_state = 2},
  [6845] = {.lex_state = 129, .external_lex_state = 2},
  [6846] = {.lex_state = 129, .external_lex_state = 2},
  [6847] = {.lex_state = 82, .external_lex_state = 2},
  [6848] = {.lex_state = 127, .external_lex_state = 2},
  [6849] = {.lex_state = 127, .external_lex_state = 2},
  [6850] = {.lex_state = 127, .external_lex_state = 2},
  [6851] = {.lex_state = 129, .external_lex_state = 2},
  [6852] = {.lex_state = 88, .external_lex_state = 2},
  [6853] = {.lex_state = 88, .external_lex_state = 2},
  [6854] = {.lex_state = 90, .external_lex_state = 2},
  [6855] = {.lex_state = 88, .external_lex_state = 2},
  [6856] = {.lex_state = 88, .external_lex_state = 2},
  [6857] = {.lex_state = 88, .external_lex_state = 2},
  [6858] = {.lex_state = 75, .external_lex_state = 7},
  [6859] = {.lex_state = 129, .external_lex_state = 2},
  [6860] = {.lex_state = 82, .external_lex_state = 2},
  [6861] = {.lex_state = 510, .external_lex_state = 2},
  [6862] = {.lex_state = 515, .external_lex_state = 2},
  [6863] = {.lex_state = 510, .external_lex_state = 2},
  [6864] = {.lex_state = 88, .external_lex_state = 2},
  [6865] = {.lex_state = 129, .external_lex_state = 2},
  [6866] = {.lex_state = 88, .external_lex_state = 2},
  [6867] = {.lex_state = 92, .external_lex_state = 2},
  [6868] = {.lex_state = 88, .external_lex_state = 2},
  [6869] = {.lex_state = 108, .external_lex_state = 2},
  [6870] = {.lex_state = 88, .external_lex_state = 2},
  [6871] = {.lex_state = 88, .external_lex_state = 2},
  [6872] = {.lex_state = 126, .external_lex_state = 2},
  [6873] = {.lex_state = 105, .external_lex_state = 2},
  [6874] = {.lex_state = 90, .external_lex_state = 2},
  [6875] = {.lex_state = 88, .external_lex_state = 2},
  [6876] = {.lex_state = 88, .external_lex_state = 2},
  [6877] = {.lex_state = 129, .external_lex_state = 2},
  [6878] = {.lex_state = 510, .external_lex_state = 5},
  [6879] = {.lex_state = 129, .external_lex_state = 2},
  [6880] = {.lex_state = 30, .external_lex_state = 4},
  [6881] = {.lex_state = 330, .external_lex_state = 2},
  [6882] = {.lex_state = 88, .external_lex_state = 2},
  [6883] = {.lex_state = 88, .external_lex_state = 2},
  [6884] = {.lex_state = 330, .external_lex_state = 2},
  [6885] = {.lex_state = 129, .external_lex_state = 2},
  [6886] = {.lex_state = 129, .external_lex_state = 2},
  [6887] = {.lex_state = 88, .external_lex_state = 2},
  [6888] = {.lex_state = 88, .external_lex_state = 2},
  [6889] = {.lex_state = 88, .external_lex_state = 2},
  [6890] = {.lex_state = 127, .external_lex_state = 2},
  [6891] = {.lex_state = 129, .external_lex_state = 2},
  [6892] = {.lex_state = 88, .external_lex_state = 2},
  [6893] = {.lex_state = 330, .external_lex_state = 2},
  [6894] = {.lex_state = 330, .external_lex_state = 2},
  [6895] = {.lex_state = 330, .external_lex_state = 2},
  [6896] = {.lex_state = 510, .external_lex_state = 2},
  [6897] = {.lex_state = 82, .external_lex_state = 2},
  [6898] = {.lex_state = 510, .external_lex_state = 2},
  [6899] = {.lex_state = 127, .external_lex_state = 2},
  [6900] = {.lex_state = 510, .external_lex_state = 2},
  [6901] = {.lex_state = 510, .external_lex_state = 2},
  [6902] = {.lex_state = 88, .external_lex_state = 2},
  [6903] = {.lex_state = 510, .external_lex_state = 2},
  [6904] = {.lex_state = 126, .external_lex_state = 2},
  [6905] = {.lex_state = 510, .external_lex_state = 2},
  [6906] = {.lex_state = 330, .external_lex_state = 2},
  [6907] = {.lex_state = 90, .external_lex_state = 5},
  [6908] = {.lex_state = 88, .external_lex_state = 2},
  [6909] = {.lex_state = 75, .external_lex_state = 4},
  [6910] = {.lex_state = 126, .external_lex_state = 2},
  [6911] = {.lex_state = 510, .external_lex_state = 2},
  [6912] = {.lex_state = 127, .external_lex_state = 2},
  [6913] = {.lex_state = 510, .external_lex_state = 2},
  [6914] = {.lex_state = 330, .external_lex_state = 2},
  [6915] = {.lex_state = 129, .external_lex_state = 2},
  [6916] = {.lex_state = 330, .external_lex_state = 2},
  [6917] = {.lex_state = 510, .external_lex_state = 2},
  [6918] = {.lex_state = 127, .external_lex_state = 2},
  [6919] = {.lex_state = 127, .external_lex_state = 2},
  [6920] = {.lex_state = 129, .external_lex_state = 2},
  [6921] = {.lex_state = 127, .external_lex_state = 2},
  [6922] = {.lex_state = 131, .external_lex_state = 2},
  [6923] = {.lex_state = 91, .external_lex_state = 2},
  [6924] = {.lex_state = 88, .external_lex_state = 2},
  [6925] = {.lex_state = 126, .external_lex_state = 2},
  [6926] = {.lex_state = 510, .external_lex_state = 2},
  [6927] = {.lex_state = 127, .external_lex_state = 2},
  [6928] = {.lex_state = 129, .external_lex_state = 2},
  [6929] = {.lex_state = 90, .external_lex_state = 2},
  [6930] = {.lex_state = 90, .external_lex_state = 2},
  [6931] = {.lex_state = 126, .external_lex_state = 2},
  [6932] = {.lex_state = 90, .external_lex_state = 2},
  [6933] = {.lex_state = 129, .external_lex_state = 2},
  [6934] = {.lex_state = 126, .external_lex_state = 2},
  [6935] = {.lex_state = 90, .external_lex_state = 2},
  [6936] = {.lex_state = 90, .external_lex_state = 2},
  [6937] = {.lex_state = 510, .external_lex_state = 2},
  [6938] = {.lex_state = 90, .external_lex_state = 2},
  [6939] = {.lex_state = 88, .external_lex_state = 2},
  [6940] = {.lex_state = 515, .external_lex_state = 2},
  [6941] = {.lex_state = 90, .external_lex_state = 2},
  [6942] = {.lex_state = 127, .external_lex_state = 2},
  [6943] = {.lex_state = 108, .external_lex_state = 2},
  [6944] = {.lex_state = 90, .external_lex_state = 2},
  [6945] = {.lex_state = 88, .external_lex_state = 2},
  [6946] = {.lex_state = 129, .external_lex_state = 2},
  [6947] = {.lex_state = 127, .external_lex_state = 2},
  [6948] = {.lex_state = 90, .external_lex_state = 2},
  [6949] = {.lex_state = 90, .external_lex_state = 2},
  [6950] = {.lex_state = 90, .external_lex_state = 2},
  [6951] = {.lex_state = 90, .external_lex_state = 2},
  [6952] = {.lex_state = 90, .external_lex_state = 2},
  [6953] = {.lex_state = 127, .external_lex_state = 2},
  [6954] = {.lex_state = 126, .external_lex_state = 2},
  [6955] = {.lex_state = 129, .external_lex_state = 2},
  [6956] = {.lex_state = 127, .external_lex_state = 2},
  [6957] = {.lex_state = 510, .external_lex_state = 2},
  [6958] = {.lex_state = 90, .external_lex_state = 2},
  [6959] = {.lex_state = 90, .external_lex_state = 2},
  [6960] = {.lex_state = 127, .external_lex_state = 2},
  [6961] = {.lex_state = 90, .external_lex_state = 2},
  [6962] = {.lex_state = 330, .external_lex_state = 2},
  [6963] = {.lex_state = 166, .external_lex_state = 2},
  [6964] = {.lex_state = 90, .external_lex_state = 2},
  [6965] = {.lex_state = 330, .external_lex_state = 2},
  [6966] = {.lex_state = 510, .external_lex_state = 2},
  [6967] = {.lex_state = 510, .external_lex_state = 2},
  [6968] = {.lex_state = 88, .external_lex_state = 2},
  [6969] = {.lex_state = 82, .external_lex_state = 2},
  [6970] = {.lex_state = 90, .external_lex_state = 2},
  [6971] = {.lex_state = 90, .external_lex_state = 2},
  [6972] = {.lex_state = 90, .external_lex_state = 2},
  [6973] = {.lex_state = 115, .external_lex_state = 2},
  [6974] = {.lex_state = 330, .external_lex_state = 2},
  [6975] = {.lex_state = 4, .external_lex_state = 4},
  [6976] = {.lex_state = 90, .external_lex_state = 2},
  [6977] = {.lex_state = 90, .external_lex_state = 2},
  [6978] = {.lex_state = 90, .external_lex_state = 5},
  [6979] = {.lex_state = 88, .external_lex_state = 2},
  [6980] = {.lex_state = 129, .external_lex_state = 2},
  [6981] = {.lex_state = 90, .external_lex_state = 2},
  [6982] = {.lex_state = 129, .external_lex_state = 2},
  [6983] = {.lex_state = 129, .external_lex_state = 2},
  [6984] = {.lex_state = 129, .external_lex_state = 2},
  [6985] = {.lex_state = 115, .external_lex_state = 2},
  [6986] = {.lex_state = 330, .external_lex_state = 2},
  [6987] = {.lex_state = 128, .external_lex_state = 2},
  [6988] = {.lex_state = 90, .external_lex_state = 2},
  [6989] = {.lex_state = 90, .external_lex_state = 2},
  [6990] = {.lex_state = 88, .external_lex_state = 2},
  [6991] = {.lex_state = 90, .external_lex_state = 2},
  [6992] = {.lex_state = 330, .external_lex_state = 2},
  [6993] = {.lex_state = 127, .external_lex_state = 2},
  [6994] = {.lex_state = 127, .external_lex_state = 2},
  [6995] = {.lex_state = 105, .external_lex_state = 2},
  [6996] = {.lex_state = 127, .external_lex_state = 2},
  [6997] = {.lex_state = 126, .external_lex_state = 2},
  [6998] = {.lex_state = 127, .external_lex_state = 2},
  [6999] = {.lex_state = 115, .external_lex_state = 2},
  [7000] = {.lex_state = 90, .external_lex_state = 2},
  [7001] = {.lex_state = 88, .external_lex_state = 2},
  [7002] = {.lex_state = 127, .external_lex_state = 2},
  [7003] = {.lex_state = 129, .external_lex_state = 2},
  [7004] = {.lex_state = 128, .external_lex_state = 2},
  [7005] = {.lex_state = 88, .external_lex_state = 2},
  [7006] = {.lex_state = 115, .external_lex_state = 2},
  [7007] = {.lex_state = 335, .external_lex_state = 2},
  [7008] = {.lex_state = 129, .external_lex_state = 2},
  [7009] = {.lex_state = 330, .external_lex_state = 2},
  [7010] = {.lex_state = 127, .external_lex_state = 2},
  [7011] = {.lex_state = 127, .external_lex_state = 2},
  [7012] = {.lex_state = 90, .external_lex_state = 2},
  [7013] = {.lex_state = 330, .external_lex_state = 2},
  [7014] = {.lex_state = 330, .external_lex_state = 2},
  [7015] = {.lex_state = 88, .external_lex_state = 2},
  [7016] = {.lex_state = 88, .external_lex_state = 5},
  [7017] = {.lex_state = 510, .external_lex_state = 2},
  [7018] = {.lex_state = 330, .external_lex_state = 2},
  [7019] = {.lex_state = 127, .external_lex_state = 2},
  [7020] = {.lex_state = 330, .external_lex_state = 2},
  [7021] = {.lex_state = 330, .external_lex_state = 2},
  [7022] = {.lex_state = 330, .external_lex_state = 2},
  [7023] = {.lex_state = 510, .external_lex_state = 2},
  [7024] = {.lex_state = 330, .external_lex_state = 2},
  [7025] = {.lex_state = 127, .external_lex_state = 2},
  [7026] = {.lex_state = 129, .external_lex_state = 2},
  [7027] = {.lex_state = 88, .external_lex_state = 2},
  [7028] = {.lex_state = 128, .external_lex_state = 2},
  [7029] = {.lex_state = 129, .external_lex_state = 2},
  [7030] = {.lex_state = 88, .external_lex_state = 2},
  [7031] = {.lex_state = 330, .external_lex_state = 2},
  [7032] = {.lex_state = 90, .external_lex_state = 2},
  [7033] = {.lex_state = 326, .external_lex_state = 2},
  [7034] = {.lex_state = 330, .external_lex_state = 2},
  [7035] = {.lex_state = 75, .external_lex_state = 7},
  [7036] = {.lex_state = 330, .external_lex_state = 2},
  [7037] = {.lex_state = 131, .external_lex_state = 2},
  [7038] = {.lex_state = 513, .external_lex_state = 2},
  [7039] = {.lex_state = 90, .external_lex_state = 5},
  [7040] = {.lex_state = 510, .external_lex_state = 2},
  [7041] = {.lex_state = 130, .external_lex_state = 2},
  [7042] = {.lex_state = 130, .external_lex_state = 2},
  [7043] = {.lex_state = 330, .external_lex_state = 2},
  [7044] = {.lex_state = 94, .external_lex_state = 2},
  [7045] = {.lex_state = 127, .external_lex_state = 2},
  [7046] = {.lex_state = 330, .external_lex_state = 2},
  [7047] = {.lex_state = 330, .external_lex_state = 2},
  [7048] = {.lex_state = 127, .external_lex_state = 2},
  [7049] = {.lex_state = 510, .external_lex_state = 2},
  [7050] = {.lex_state = 88, .external_lex_state = 5},
  [7051] = {.lex_state = 510, .external_lex_state = 2},
  [7052] = {.lex_state = 510, .external_lex_state = 2},
  [7053] = {.lex_state = 88, .external_lex_state = 2},
  [7054] = {.lex_state = 330, .external_lex_state = 2},
  [7055] = {.lex_state = 330, .external_lex_state = 2},
  [7056] = {.lex_state = 88, .external_lex_state = 2},
  [7057] = {.lex_state = 129, .external_lex_state = 2},
  [7058] = {.lex_state = 330, .external_lex_state = 2},
  [7059] = {.lex_state = 510, .external_lex_state = 5},
  [7060] = {.lex_state = 498, .external_lex_state = 4},
  [7061] = {.lex_state = 129, .external_lex_state = 2},
  [7062] = {.lex_state = 159, .external_lex_state = 2},
  [7063] = {.lex_state = 90, .external_lex_state = 2},
  [7064] = {.lex_state = 129, .external_lex_state = 2},
  [7065] = {.lex_state = 156, .external_lex_state = 2},
  [7066] = {.lex_state = 330, .external_lex_state = 2},
  [7067] = {.lex_state = 88, .external_lex_state = 2},
  [7068] = {.lex_state = 510, .external_lex_state = 2},
  [7069] = {.lex_state = 126, .external_lex_state = 2},
  [7070] = {.lex_state = 88, .external_lex_state = 2},
  [7071] = {.lex_state = 330, .external_lex_state = 2},
  [7072] = {.lex_state = 90, .external_lex_state = 2},
  [7073] = {.lex_state = 330, .external_lex_state = 2},
  [7074] = {.lex_state = 127, .external_lex_state = 2},
  [7075] = {.lex_state = 129, .external_lex_state = 2},
  [7076] = {.lex_state = 129, .external_lex_state = 2},
  [7077] = {.lex_state = 169, .external_lex_state = 2},
  [7078] = {.lex_state = 513, .external_lex_state = 2},
  [7079] = {.lex_state = 88, .external_lex_state = 2},
  [7080] = {.lex_state = 129, .external_lex_state = 2},
  [7081] = {.lex_state = 510, .external_lex_state = 2},
  [7082] = {.lex_state = 90, .external_lex_state = 2},
  [7083] = {.lex_state = 126, .external_lex_state = 2},
  [7084] = {.lex_state = 88, .external_lex_state = 2},
  [7085] = {.lex_state = 510, .external_lex_state = 2},
  [7086] = {.lex_state = 127, .external_lex_state = 2},
  [7087] = {.lex_state = 90, .external_lex_state = 2},
  [7088] = {.lex_state = 90, .external_lex_state = 2},
  [7089] = {.lex_state = 158, .external_lex_state = 2},
  [7090] = {.lex_state = 330, .external_lex_state = 2},
  [7091] = {.lex_state = 509, .external_lex_state = 7},
  [7092] = {.lex_state = 127, .external_lex_state = 2},
  [7093] = {.lex_state = 126, .external_lex_state = 2},
  [7094] = {.lex_state = 126, .external_lex_state = 2},
  [7095] = {.lex_state = 129, .external_lex_state = 2},
  [7096] = {.lex_state = 510, .external_lex_state = 2},
  [7097] = {.lex_state = 510, .external_lex_state = 2},
  [7098] = {.lex_state = 88, .external_lex_state = 5},
  [7099] = {.lex_state = 330, .external_lex_state = 2},
  [7100] = {.lex_state = 510, .external_lex_state = 2},
  [7101] = {.lex_state = 330, .external_lex_state = 2},
  [7102] = {.lex_state = 90, .external_lex_state = 2},
  [7103] = {.lex_state = 126, .external_lex_state = 2},
  [7104] = {.lex_state = 126, .external_lex_state = 2},
  [7105] = {.lex_state = 127, .external_lex_state = 2},
  [7106] = {.lex_state = 127, .external_lex_state = 2},
  [7107] = {.lex_state = 510, .external_lex_state = 2},
  [7108] = {.lex_state = 75, .external_lex_state = 7},
  [7109] = {.lex_state = 88, .external_lex_state = 2},
  [7110] = {.lex_state = 129, .external_lex_state = 2},
  [7111] = {.lex_state = 127, .external_lex_state = 2},
  [7112] = {.lex_state = 129, .external_lex_state = 2},
  [7113] = {.lex_state = 126, .external_lex_state = 2},
  [7114] = {.lex_state = 330, .external_lex_state = 2},
  [7115] = {.lex_state = 127, .external_lex_state = 2},
  [7116] = {.lex_state = 510, .external_lex_state = 2},
  [7117] = {.lex_state = 126, .external_lex_state = 2},
  [7118] = {.lex_state = 522, .external_lex_state = 2},
  [7119] = {.lex_state = 127, .external_lex_state = 2},
  [7120] = {.lex_state = 127, .external_lex_state = 2},
  [7121] = {.lex_state = 510, .external_lex_state = 2},
  [7122] = {.lex_state = 510, .external_lex_state = 2},
  [7123] = {.lex_state = 90, .external_lex_state = 2},
  [7124] = {.lex_state = 90, .external_lex_state = 2},
  [7125] = {.lex_state = 127, .external_lex_state = 2},
  [7126] = {.lex_state = 127, .external_lex_state = 2},
  [7127] = {.lex_state = 127, .external_lex_state = 2},
  [7128] = {.lex_state = 510, .external_lex_state = 2},
  [7129] = {.lex_state = 513, .external_lex_state = 2},
  [7130] = {.lex_state = 88, .external_lex_state = 2},
  [7131] = {.lex_state = 127, .external_lex_state = 2},
  [7132] = {.lex_state = 330, .external_lex_state = 2},
  [7133] = {.lex_state = 509, .external_lex_state = 7},
  [7134] = {.lex_state = 127, .external_lex_state = 2},
  [7135] = {.lex_state = 510, .external_lex_state = 2},
  [7136] = {.lex_state = 510, .external_lex_state = 2},
  [7137] = {.lex_state = 126, .external_lex_state = 2},
  [7138] = {.lex_state = 127, .external_lex_state = 2},
  [7139] = {.lex_state = 510, .external_lex_state = 5},
  [7140] = {.lex_state = 510, .external_lex_state = 2},
  [7141] = {.lex_state = 90, .external_lex_state = 5},
  [7142] = {.lex_state = 126, .external_lex_state = 2},
  [7143] = {.lex_state = 510, .external_lex_state = 2},
  [7144] = {.lex_state = 510, .external_lex_state = 2},
  [7145] = {.lex_state = 330, .external_lex_state = 2},
  [7146] = {.lex_state = 510, .external_lex_state = 2},
  [7147] = {.lex_state = 127, .external_lex_state = 2},
  [7148] = {.lex_state = 510, .external_lex_state = 2},
  [7149] = {.lex_state = 510, .external_lex_state = 2},
  [7150] = {.lex_state = 88, .external_lex_state = 2},
  [7151] = {.lex_state = 129, .external_lex_state = 2},
  [7152] = {.lex_state = 330, .external_lex_state = 2},
  [7153] = {.lex_state = 127, .external_lex_state = 2},
  [7154] = {.lex_state = 88, .external_lex_state = 2},
  [7155] = {.lex_state = 88, .external_lex_state = 2},
  [7156] = {.lex_state = 510, .external_lex_state = 2},
  [7157] = {.lex_state = 127, .external_lex_state = 2},
  [7158] = {.lex_state = 121, .external_lex_state = 2},
  [7159] = {.lex_state = 510, .external_lex_state = 2},
  [7160] = {.lex_state = 510, .external_lex_state = 5},
  [7161] = {.lex_state = 515, .external_lex_state = 2},
  [7162] = {.lex_state = 330, .external_lex_state = 2},
  [7163] = {.lex_state = 88, .external_lex_state = 5},
  [7164] = {.lex_state = 129, .external_lex_state = 2},
  [7165] = {.lex_state = 90, .external_lex_state = 2},
  [7166] = {.lex_state = 89, .external_lex_state = 2},
  [7167] = {.lex_state = 33, .external_lex_state = 4},
  [7168] = {.lex_state = 510, .external_lex_state = 2},
  [7169] = {.lex_state = 130, .external_lex_state = 2},
  [7170] = {.lex_state = 126, .external_lex_state = 2},
  [7171] = {.lex_state = 127, .external_lex_state = 2},
  [7172] = {.lex_state = 510, .external_lex_state = 2},
  [7173] = {.lex_state = 126, .external_lex_state = 2},
  [7174] = {.lex_state = 89, .external_lex_state = 2},
  [7175] = {.lex_state = 89, .external_lex_state = 2},
  [7176] = {.lex_state = 509, .external_lex_state = 7},
  [7177] = {.lex_state = 89, .external_lex_state = 2},
  [7178] = {.lex_state = 129, .external_lex_state = 2},
  [7179] = {.lex_state = 126, .external_lex_state = 2},
  [7180] = {.lex_state = 129, .external_lex_state = 2},
  [7181] = {.lex_state = 126, .external_lex_state = 2},
  [7182] = {.lex_state = 510, .external_lex_state = 2},
  [7183] = {.lex_state = 509, .external_lex_state = 4},
  [7184] = {.lex_state = 129, .external_lex_state = 2},
  [7185] = {.lex_state = 90, .external_lex_state = 2},
  [7186] = {.lex_state = 330, .external_lex_state = 2},
  [7187] = {.lex_state = 126, .external_lex_state = 2},
  [7188] = {.lex_state = 126, .external_lex_state = 2},
  [7189] = {.lex_state = 130, .external_lex_state = 2},
  [7190] = {.lex_state = 129, .external_lex_state = 2},
  [7191] = {.lex_state = 129, .external_lex_state = 2},
  [7192] = {.lex_state = 105, .external_lex_state = 2},
  [7193] = {.lex_state = 126, .external_lex_state = 2},
  [7194] = {.lex_state = 90, .external_lex_state = 2},
  [7195] = {.lex_state = 126, .external_lex_state = 2},
  [7196] = {.lex_state = 127, .external_lex_state = 2},
  [7197] = {.lex_state = 90, .external_lex_state = 2},
  [7198] = {.lex_state = 129, .external_lex_state = 2},
  [7199] = {.lex_state = 129, .external_lex_state = 2},
  [7200] = {.lex_state = 126, .external_lex_state = 2},
  [7201] = {.lex_state = 126, .external_lex_state = 2},
  [7202] = {.lex_state = 126, .external_lex_state = 2},
  [7203] = {.lex_state = 126, .external_lex_state = 2},
  [7204] = {.lex_state = 325, .external_lex_state = 2},
  [7205] = {.lex_state = 126, .external_lex_state = 2},
  [7206] = {.lex_state = 325, .external_lex_state = 2},
  [7207] = {.lex_state = 325, .external_lex_state = 2},
  [7208] = {.lex_state = 510, .external_lex_state = 2},
  [7209] = {.lex_state = 330, .external_lex_state = 2},
  [7210] = {.lex_state = 126, .external_lex_state = 2},
  [7211] = {.lex_state = 131, .external_lex_state = 2},
  [7212] = {.lex_state = 126, .external_lex_state = 2},
  [7213] = {.lex_state = 330, .external_lex_state = 2},
  [7214] = {.lex_state = 325, .external_lex_state = 2},
  [7215] = {.lex_state = 126, .external_lex_state = 2},
  [7216] = {.lex_state = 161, .external_lex_state = 2},
  [7217] = {.lex_state = 126, .external_lex_state = 2},
  [7218] = {.lex_state = 126, .external_lex_state = 2},
  [7219] = {.lex_state = 126, .external_lex_state = 2},
  [7220] = {.lex_state = 126, .external_lex_state = 2},
  [7221] = {.lex_state = 127, .external_lex_state = 2},
  [7222] = {.lex_state = 126, .external_lex_state = 2},
  [7223] = {.lex_state = 126, .external_lex_state = 2},
  [7224] = {.lex_state = 126, .external_lex_state = 2},
  [7225] = {.lex_state = 126, .external_lex_state = 2},
  [7226] = {.lex_state = 126, .external_lex_state = 2},
  [7227] = {.lex_state = 126, .external_lex_state = 2},
  [7228] = {.lex_state = 129, .external_lex_state = 2},
  [7229] = {.lex_state = 129, .external_lex_state = 2},
  [7230] = {.lex_state = 127, .external_lex_state = 2},
  [7231] = {.lex_state = 90, .external_lex_state = 2},
  [7232] = {.lex_state = 126, .external_lex_state = 2},
  [7233] = {.lex_state = 90, .external_lex_state = 2},
  [7234] = {.lex_state = 510, .external_lex_state = 2},
  [7235] = {.lex_state = 330, .external_lex_state = 2},
  [7236] = {.lex_state = 126, .external_lex_state = 2},
  [7237] = {.lex_state = 90, .external_lex_state = 2},
  [7238] = {.lex_state = 330, .external_lex_state = 2},
  [7239] = {.lex_state = 129, .external_lex_state = 2},
  [7240] = {.lex_state = 330, .external_lex_state = 2},
  [7241] = {.lex_state = 330, .external_lex_state = 2},
  [7242] = {.lex_state = 129, .external_lex_state = 2},
  [7243] = {.lex_state = 108, .external_lex_state = 2},
  [7244] = {.lex_state = 88, .external_lex_state = 2},
  [7245] = {.lex_state = 510, .external_lex_state = 2},
  [7246] = {.lex_state = 90, .external_lex_state = 2},
  [7247] = {.lex_state = 90, .external_lex_state = 2},
  [7248] = {.lex_state = 88, .external_lex_state = 2},
  [7249] = {.lex_state = 510, .external_lex_state = 2},
  [7250] = {.lex_state = 88, .external_lex_state = 2},
  [7251] = {.lex_state = 88, .external_lex_state = 2},
  [7252] = {.lex_state = 510, .external_lex_state = 2},
  [7253] = {.lex_state = 129, .external_lex_state = 2},
  [7254] = {.lex_state = 126, .external_lex_state = 2},
  [7255] = {.lex_state = 88, .external_lex_state = 2},
  [7256] = {.lex_state = 90, .external_lex_state = 2},
  [7257] = {.lex_state = 90, .external_lex_state = 2},
  [7258] = {.lex_state = 83, .external_lex_state = 2},
  [7259] = {.lex_state = 90, .external_lex_state = 2},
  [7260] = {.lex_state = 83, .external_lex_state = 2},
  [7261] = {.lex_state = 83, .external_lex_state = 2},
  [7262] = {.lex_state = 126, .external_lex_state = 2},
  [7263] = {.lex_state = 83, .external_lex_state = 2},
  [7264] = {.lex_state = 88, .external_lex_state = 2},
  [7265] = {.lex_state = 510, .external_lex_state = 2},
  [7266] = {.lex_state = 88, .external_lex_state = 2},
  [7267] = {.lex_state = 88, .external_lex_state = 2},
  [7268] = {.lex_state = 88, .external_lex_state = 2},
  [7269] = {.lex_state = 88, .external_lex_state = 2},
  [7270] = {.lex_state = 88, .external_lex_state = 2},
  [7271] = {.lex_state = 88, .external_lex_state = 2},
  [7272] = {.lex_state = 510, .external_lex_state = 2},
  [7273] = {.lex_state = 510, .external_lex_state = 2},
  [7274] = {.lex_state = 510, .external_lex_state = 2},
  [7275] = {.lex_state = 510, .external_lex_state = 2},
  [7276] = {.lex_state = 90, .external_lex_state = 2},
  [7277] = {.lex_state = 129, .external_lex_state = 2},
  [7278] = {.lex_state = 90, .external_lex_state = 2},
  [7279] = {.lex_state = 90, .external_lex_state = 2},
  [7280] = {.lex_state = 90, .external_lex_state = 2},
  [7281] = {.lex_state = 88, .external_lex_state = 2},
  [7282] = {.lex_state = 510, .external_lex_state = 2},
  [7283] = {.lex_state = 510, .external_lex_state = 2},
  [7284] = {.lex_state = 88, .external_lex_state = 2},
  [7285] = {.lex_state = 88, .external_lex_state = 2},
  [7286] = {.lex_state = 90, .external_lex_state = 2},
  [7287] = {.lex_state = 90, .external_lex_state = 2},
  [7288] = {.lex_state = 90, .external_lex_state = 2},
  [7289] = {.lex_state = 88, .external_lex_state = 2},
  [7290] = {.lex_state = 82, .external_lex_state = 2},
  [7291] = {.lex_state = 129, .external_lex_state = 2},
  [7292] = {.lex_state = 122, .external_lex_state = 2},
  [7293] = {.lex_state = 76, .external_lex_state = 2},
  [7294] = {.lex_state = 83, .external_lex_state = 2},
  [7295] = {.lex_state = 165, .external_lex_state = 2},
  [7296] = {.lex_state = 83, .external_lex_state = 2},
  [7297] = {.lex_state = 90, .external_lex_state = 2},
  [7298] = {.lex_state = 89, .external_lex_state = 2},
  [7299] = {.lex_state = 83, .external_lex_state = 2},
  [7300] = {.lex_state = 75, .external_lex_state = 2},
  [7301] = {.lex_state = 75, .external_lex_state = 2},
  [7302] = {.lex_state = 75, .external_lex_state = 2},
  [7303] = {.lex_state = 75, .external_lex_state = 2},
  [7304] = {.lex_state = 88, .external_lex_state = 2},
  [7305] = {.lex_state = 115, .external_lex_state = 2},
  [7306] = {.lex_state = 510, .external_lex_state = 2},
  [7307] = {.lex_state = 90, .external_lex_state = 2},
  [7308] = {.lex_state = 314, .external_lex_state = 4},
  [7309] = {.lex_state = 510, .external_lex_state = 2},
  [7310] = {.lex_state = 90, .external_lex_state = 2},
  [7311] = {.lex_state = 88, .external_lex_state = 2},
  [7312] = {.lex_state = 88, .external_lex_state = 2},
  [7313] = {.lex_state = 83, .external_lex_state = 5},
  [7314] = {.lex_state = 83, .external_lex_state = 5},
  [7315] = {.lex_state = 82, .external_lex_state = 5},
  [7316] = {.lex_state = 83, .external_lex_state = 2},
  [7317] = {.lex_state = 83, .external_lex_state = 2},
  [7318] = {.lex_state = 88, .external_lex_state = 2},
  [7319] = {.lex_state = 88, .external_lex_state = 2},
  [7320] = {.lex_state = 88, .external_lex_state = 2},
  [7321] = {.lex_state = 88, .external_lex_state = 2},
  [7322] = {.lex_state = 88, .external_lex_state = 2},
  [7323] = {.lex_state = 88, .external_lex_state = 2},
  [7324] = {.lex_state = 88, .external_lex_state = 2},
  [7325] = {.lex_state = 325, .external_lex_state = 2},
  [7326] = {.lex_state = 88, .external_lex_state = 2},
  [7327] = {.lex_state = 88, .external_lex_state = 2},
  [7328] = {.lex_state = 88, .external_lex_state = 2},
  [7329] = {.lex_state = 88, .external_lex_state = 2},
  [7330] = {.lex_state = 88, .external_lex_state = 2},
  [7331] = {.lex_state = 88, .external_lex_state = 2},
  [7332] = {.lex_state = 88, .external_lex_state = 2},
  [7333] = {.lex_state = 88, .external_lex_state = 2},
  [7334] = {.lex_state = 88, .external_lex_state = 2},
  [7335] = {.lex_state = 88, .external_lex_state = 2},
  [7336] = {.lex_state = 88, .external_lex_state = 2},
  [7337] = {.lex_state = 88, .external_lex_state = 2},
  [7338] = {.lex_state = 88, .external_lex_state = 2},
  [7339] = {.lex_state = 88, .external_lex_state = 2},
  [7340] = {.lex_state = 88, .external_lex_state = 2},
  [7341] = {.lex_state = 510, .external_lex_state = 2},
  [7342] = {.lex_state = 510, .external_lex_state = 2},
  [7343] = {.lex_state = 510, .external_lex_state = 2},
  [7344] = {.lex_state = 510, .external_lex_state = 2},
  [7345] = {.lex_state = 83, .external_lex_state = 5},
  [7346] = {.lex_state = 83, .external_lex_state = 2},
  [7347] = {.lex_state = 130, .external_lex_state = 2},
  [7348] = {.lex_state = 83, .external_lex_state = 2},
  [7349] = {.lex_state = 127, .external_lex_state = 2},
  [7350] = {.lex_state = 83, .external_lex_state = 2},
  [7351] = {.lex_state = 90, .external_lex_state = 2},
  [7352] = {.lex_state = 510, .external_lex_state = 2},
  [7353] = {.lex_state = 88, .external_lex_state = 2},
  [7354] = {.lex_state = 510, .external_lex_state = 2},
  [7355] = {.lex_state = 83, .external_lex_state = 2},
  [7356] = {.lex_state = 127, .external_lex_state = 2},
  [7357] = {.lex_state = 83, .external_lex_state = 2},
  [7358] = {.lex_state = 88, .external_lex_state = 2},
  [7359] = {.lex_state = 99, .external_lex_state = 2},
  [7360] = {.lex_state = 88, .external_lex_state = 2},
  [7361] = {.lex_state = 90, .external_lex_state = 2},
  [7362] = {.lex_state = 88, .external_lex_state = 2},
  [7363] = {.lex_state = 130, .external_lex_state = 2},
  [7364] = {.lex_state = 90, .external_lex_state = 2},
  [7365] = {.lex_state = 90, .external_lex_state = 2},
  [7366] = {.lex_state = 90, .external_lex_state = 2},
  [7367] = {.lex_state = 88, .external_lex_state = 2},
  [7368] = {.lex_state = 88, .external_lex_state = 2},
  [7369] = {.lex_state = 88, .external_lex_state = 2},
  [7370] = {.lex_state = 88, .external_lex_state = 2},
  [7371] = {.lex_state = 88, .external_lex_state = 2},
  [7372] = {.lex_state = 88, .external_lex_state = 2},
  [7373] = {.lex_state = 88, .external_lex_state = 2},
  [7374] = {.lex_state = 88, .external_lex_state = 2},
  [7375] = {.lex_state = 88, .external_lex_state = 2},
  [7376] = {.lex_state = 82, .external_lex_state = 2},
  [7377] = {.lex_state = 88, .external_lex_state = 2},
  [7378] = {.lex_state = 88, .external_lex_state = 2},
  [7379] = {.lex_state = 82, .external_lex_state = 2},
  [7380] = {.lex_state = 90, .external_lex_state = 2},
  [7381] = {.lex_state = 90, .external_lex_state = 2},
  [7382] = {.lex_state = 88, .external_lex_state = 2},
  [7383] = {.lex_state = 90, .external_lex_state = 2},
  [7384] = {.lex_state = 90, .external_lex_state = 2},
  [7385] = {.lex_state = 90, .external_lex_state = 2},
  [7386] = {.lex_state = 90, .external_lex_state = 2},
  [7387] = {.lex_state = 90, .external_lex_state = 2},
  [7388] = {.lex_state = 90, .external_lex_state = 2},
  [7389] = {.lex_state = 90, .external_lex_state = 2},
  [7390] = {.lex_state = 100, .external_lex_state = 2},
  [7391] = {.lex_state = 82, .external_lex_state = 5},
  [7392] = {.lex_state = 90, .external_lex_state = 2},
  [7393] = {.lex_state = 90, .external_lex_state = 2},
  [7394] = {.lex_state = 88, .external_lex_state = 2},
  [7395] = {.lex_state = 90, .external_lex_state = 2},
  [7396] = {.lex_state = 90, .external_lex_state = 2},
  [7397] = {.lex_state = 88, .external_lex_state = 2},
  [7398] = {.lex_state = 83, .external_lex_state = 2},
  [7399] = {.lex_state = 88, .external_lex_state = 2},
  [7400] = {.lex_state = 88, .external_lex_state = 2},
  [7401] = {.lex_state = 88, .external_lex_state = 2},
  [7402] = {.lex_state = 88, .external_lex_state = 2},
  [7403] = {.lex_state = 88, .external_lex_state = 2},
  [7404] = {.lex_state = 88, .external_lex_state = 2},
  [7405] = {.lex_state = 90, .external_lex_state = 2},
  [7406] = {.lex_state = 88, .external_lex_state = 2},
  [7407] = {.lex_state = 90, .external_lex_state = 2},
  [7408] = {.lex_state = 90, .external_lex_state = 2},
  [7409] = {.lex_state = 90, .external_lex_state = 2},
  [7410] = {.lex_state = 90, .external_lex_state = 2},
  [7411] = {.lex_state = 90, .external_lex_state = 2},
  [7412] = {.lex_state = 90, .external_lex_state = 2},
  [7413] = {.lex_state = 90, .external_lex_state = 2},
  [7414] = {.lex_state = 90, .external_lex_state = 2},
  [7415] = {.lex_state = 90, .external_lex_state = 2},
  [7416] = {.lex_state = 90, .external_lex_state = 2},
  [7417] = {.lex_state = 90, .external_lex_state = 2},
  [7418] = {.lex_state = 88, .external_lex_state = 2},
  [7419] = {.lex_state = 88, .external_lex_state = 2},
  [7420] = {.lex_state = 88, .external_lex_state = 2},
  [7421] = {.lex_state = 88, .external_lex_state = 2},
  [7422] = {.lex_state = 88, .external_lex_state = 2},
  [7423] = {.lex_state = 88, .external_lex_state = 2},
  [7424] = {.lex_state = 88, .external_lex_state = 2},
  [7425] = {.lex_state = 88, .external_lex_state = 2},
  [7426] = {.lex_state = 89, .external_lex_state = 5},
  [7427] = {.lex_state = 510, .external_lex_state = 2},
  [7428] = {.lex_state = 510, .external_lex_state = 2},
  [7429] = {.lex_state = 510, .external_lex_state = 2},
  [7430] = {.lex_state = 510, .external_lex_state = 2},
  [7431] = {.lex_state = 510, .external_lex_state = 2},
  [7432] = {.lex_state = 510, .external_lex_state = 2},
  [7433] = {.lex_state = 126, .external_lex_state = 2},
  [7434] = {.lex_state = 82, .external_lex_state = 2},
  [7435] = {.lex_state = 510, .external_lex_state = 2},
  [7436] = {.lex_state = 510, .external_lex_state = 2},
  [7437] = {.lex_state = 510, .external_lex_state = 2},
  [7438] = {.lex_state = 510, .external_lex_state = 2},
  [7439] = {.lex_state = 510, .external_lex_state = 2},
  [7440] = {.lex_state = 510, .external_lex_state = 2},
  [7441] = {.lex_state = 510, .external_lex_state = 2},
  [7442] = {.lex_state = 510, .external_lex_state = 2},
  [7443] = {.lex_state = 510, .external_lex_state = 2},
  [7444] = {.lex_state = 90, .external_lex_state = 2},
  [7445] = {.lex_state = 88, .external_lex_state = 2},
  [7446] = {.lex_state = 90, .external_lex_state = 2},
  [7447] = {.lex_state = 88, .external_lex_state = 2},
  [7448] = {.lex_state = 90, .external_lex_state = 2},
  [7449] = {.lex_state = 90, .external_lex_state = 2},
  [7450] = {.lex_state = 90, .external_lex_state = 2},
  [7451] = {.lex_state = 90, .external_lex_state = 2},
  [7452] = {.lex_state = 90, .external_lex_state = 2},
  [7453] = {.lex_state = 90, .external_lex_state = 2},
  [7454] = {.lex_state = 90, .external_lex_state = 2},
  [7455] = {.lex_state = 90, .external_lex_state = 2},
  [7456] = {.lex_state = 90, .external_lex_state = 2},
  [7457] = {.lex_state = 90, .external_lex_state = 2},
  [7458] = {.lex_state = 90, .external_lex_state = 2},
  [7459] = {.lex_state = 90, .external_lex_state = 2},
  [7460] = {.lex_state = 90, .external_lex_state = 2},
  [7461] = {.lex_state = 90, .external_lex_state = 2},
  [7462] = {.lex_state = 90, .external_lex_state = 2},
  [7463] = {.lex_state = 90, .external_lex_state = 2},
  [7464] = {.lex_state = 90, .external_lex_state = 2},
  [7465] = {.lex_state = 88, .external_lex_state = 2},
  [7466] = {.lex_state = 89, .external_lex_state = 5},
  [7467] = {.lex_state = 88, .external_lex_state = 2},
  [7468] = {.lex_state = 90, .external_lex_state = 2},
  [7469] = {.lex_state = 90, .external_lex_state = 2},
  [7470] = {.lex_state = 88, .external_lex_state = 2},
  [7471] = {.lex_state = 89, .external_lex_state = 2},
  [7472] = {.lex_state = 88, .external_lex_state = 2},
  [7473] = {.lex_state = 90, .external_lex_state = 2},
  [7474] = {.lex_state = 89, .external_lex_state = 2},
  [7475] = {.lex_state = 90, .external_lex_state = 2},
  [7476] = {.lex_state = 90, .external_lex_state = 2},
  [7477] = {.lex_state = 90, .external_lex_state = 2},
  [7478] = {.lex_state = 90, .external_lex_state = 2},
  [7479] = {.lex_state = 90, .external_lex_state = 2},
  [7480] = {.lex_state = 90, .external_lex_state = 2},
  [7481] = {.lex_state = 90, .external_lex_state = 2},
  [7482] = {.lex_state = 82, .external_lex_state = 2},
  [7483] = {.lex_state = 90, .external_lex_state = 2},
  [7484] = {.lex_state = 90, .external_lex_state = 2},
  [7485] = {.lex_state = 90, .external_lex_state = 2},
  [7486] = {.lex_state = 90, .external_lex_state = 2},
  [7487] = {.lex_state = 90, .external_lex_state = 2},
  [7488] = {.lex_state = 90, .external_lex_state = 2},
  [7489] = {.lex_state = 90, .external_lex_state = 2},
  [7490] = {.lex_state = 90, .external_lex_state = 2},
  [7491] = {.lex_state = 90, .external_lex_state = 2},
  [7492] = {.lex_state = 88, .external_lex_state = 2},
  [7493] = {.lex_state = 90, .external_lex_state = 2},
  [7494] = {.lex_state = 90, .external_lex_state = 2},
  [7495] = {.lex_state = 90, .external_lex_state = 2},
  [7496] = {.lex_state = 90, .external_lex_state = 2},
  [7497] = {.lex_state = 90, .external_lex_state = 2},
  [7498] = {.lex_state = 90, .external_lex_state = 2},
  [7499] = {.lex_state = 90, .external_lex_state = 2},
  [7500] = {.lex_state = 90, .external_lex_state = 2},
  [7501] = {.lex_state = 90, .external_lex_state = 2},
  [7502] = {.lex_state = 90, .external_lex_state = 2},
  [7503] = {.lex_state = 90, .external_lex_state = 2},
  [7504] = {.lex_state = 90, .external_lex_state = 2},
  [7505] = {.lex_state = 510, .external_lex_state = 2},
  [7506] = {.lex_state = 90, .external_lex_state = 2},
  [7507] = {.lex_state = 90, .external_lex_state = 2},
  [7508] = {.lex_state = 90, .external_lex_state = 2},
  [7509] = {.lex_state = 90, .external_lex_state = 2},
  [7510] = {.lex_state = 90, .external_lex_state = 2},
  [7511] = {.lex_state = 90, .external_lex_state = 2},
  [7512] = {.lex_state = 90, .external_lex_state = 2},
  [7513] = {.lex_state = 90, .external_lex_state = 2},
  [7514] = {.lex_state = 90, .external_lex_state = 2},
  [7515] = {.lex_state = 90, .external_lex_state = 2},
  [7516] = {.lex_state = 90, .external_lex_state = 2},
  [7517] = {.lex_state = 90, .external_lex_state = 2},
  [7518] = {.lex_state = 88, .external_lex_state = 2},
  [7519] = {.lex_state = 88, .external_lex_state = 2},
  [7520] = {.lex_state = 88, .external_lex_state = 2},
  [7521] = {.lex_state = 88, .external_lex_state = 2},
  [7522] = {.lex_state = 88, .external_lex_state = 2},
  [7523] = {.lex_state = 82, .external_lex_state = 5},
  [7524] = {.lex_state = 90, .external_lex_state = 2},
  [7525] = {.lex_state = 90, .external_lex_state = 2},
  [7526] = {.lex_state = 90, .external_lex_state = 2},
  [7527] = {.lex_state = 88, .external_lex_state = 2},
  [7528] = {.lex_state = 82, .external_lex_state = 2},
  [7529] = {.lex_state = 82, .external_lex_state = 2},
  [7530] = {.lex_state = 88, .external_lex_state = 2},
  [7531] = {.lex_state = 88, .external_lex_state = 2},
  [7532] = {.lex_state = 88, .external_lex_state = 2},
  [7533] = {.lex_state = 88, .external_lex_state = 2},
  [7534] = {.lex_state = 88, .external_lex_state = 2},
  [7535] = {.lex_state = 88, .external_lex_state = 2},
  [7536] = {.lex_state = 88, .external_lex_state = 2},
  [7537] = {.lex_state = 88, .external_lex_state = 2},
  [7538] = {.lex_state = 88, .external_lex_state = 2},
  [7539] = {.lex_state = 88, .external_lex_state = 2},
  [7540] = {.lex_state = 88, .external_lex_state = 2},
  [7541] = {.lex_state = 129, .external_lex_state = 2},
  [7542] = {.lex_state = 89, .external_lex_state = 2},
  [7543] = {.lex_state = 88, .external_lex_state = 2},
  [7544] = {.lex_state = 88, .external_lex_state = 2},
  [7545] = {.lex_state = 510, .external_lex_state = 2},
  [7546] = {.lex_state = 88, .external_lex_state = 2},
  [7547] = {.lex_state = 88, .external_lex_state = 2},
  [7548] = {.lex_state = 88, .external_lex_state = 2},
  [7549] = {.lex_state = 88, .external_lex_state = 2},
  [7550] = {.lex_state = 88, .external_lex_state = 2},
  [7551] = {.lex_state = 88, .external_lex_state = 2},
  [7552] = {.lex_state = 82, .external_lex_state = 2},
  [7553] = {.lex_state = 88, .external_lex_state = 2},
  [7554] = {.lex_state = 82, .external_lex_state = 2},
  [7555] = {.lex_state = 88, .external_lex_state = 2},
  [7556] = {.lex_state = 90, .external_lex_state = 2},
  [7557] = {.lex_state = 88, .external_lex_state = 2},
  [7558] = {.lex_state = 88, .external_lex_state = 2},
  [7559] = {.lex_state = 88, .external_lex_state = 2},
  [7560] = {.lex_state = 510, .external_lex_state = 2},
  [7561] = {.lex_state = 88, .external_lex_state = 2},
  [7562] = {.lex_state = 88, .external_lex_state = 2},
  [7563] = {.lex_state = 88, .external_lex_state = 2},
  [7564] = {.lex_state = 88, .external_lex_state = 2},
  [7565] = {.lex_state = 88, .external_lex_state = 2},
  [7566] = {.lex_state = 88, .external_lex_state = 2},
  [7567] = {.lex_state = 88, .external_lex_state = 2},
  [7568] = {.lex_state = 510, .external_lex_state = 2},
  [7569] = {.lex_state = 82, .external_lex_state = 2},
  [7570] = {.lex_state = 126, .external_lex_state = 2},
  [7571] = {.lex_state = 82, .external_lex_state = 2},
  [7572] = {.lex_state = 88, .external_lex_state = 2},
  [7573] = {.lex_state = 88, .external_lex_state = 2},
  [7574] = {.lex_state = 88, .external_lex_state = 2},
  [7575] = {.lex_state = 88, .external_lex_state = 2},
  [7576] = {.lex_state = 325, .external_lex_state = 2},
  [7577] = {.lex_state = 325, .external_lex_state = 2},
  [7578] = {.lex_state = 510, .external_lex_state = 2},
  [7579] = {.lex_state = 510, .external_lex_state = 2},
  [7580] = {.lex_state = 510, .external_lex_state = 2},
  [7581] = {.lex_state = 89, .external_lex_state = 2},
  [7582] = {.lex_state = 100, .external_lex_state = 2},
  [7583] = {.lex_state = 83, .external_lex_state = 5},
  [7584] = {.lex_state = 130, .external_lex_state = 2},
  [7585] = {.lex_state = 510, .external_lex_state = 2},
  [7586] = {.lex_state = 115, .external_lex_state = 2},
  [7587] = {.lex_state = 130, .external_lex_state = 2},
  [7588] = {.lex_state = 130, .external_lex_state = 2},
  [7589] = {.lex_state = 82, .external_lex_state = 2},
  [7590] = {.lex_state = 164, .external_lex_state = 2},
  [7591] = {.lex_state = 82, .external_lex_state = 2},
  [7592] = {.lex_state = 89, .external_lex_state = 2},
  [7593] = {.lex_state = 99, .external_lex_state = 2},
  [7594] = {.lex_state = 89, .external_lex_state = 2},
  [7595] = {.lex_state = 115, .external_lex_state = 2},
  [7596] = {.lex_state = 82, .external_lex_state = 2},
  [7597] = {.lex_state = 510, .external_lex_state = 2},
  [7598] = {.lex_state = 130, .external_lex_state = 2},
  [7599] = {.lex_state = 130, .external_lex_state = 2},
  [7600] = {.lex_state = 130, .external_lex_state = 2},
  [7601] = {.lex_state = 106, .external_lex_state = 2},
  [7602] = {.lex_state = 130, .external_lex_state = 2},
  [7603] = {.lex_state = 130, .external_lex_state = 2},
  [7604] = {.lex_state = 130, .external_lex_state = 2},
  [7605] = {.lex_state = 510, .external_lex_state = 2},
  [7606] = {.lex_state = 130, .external_lex_state = 2},
  [7607] = {.lex_state = 130, .external_lex_state = 2},
  [7608] = {.lex_state = 130, .external_lex_state = 2},
  [7609] = {.lex_state = 130, .external_lex_state = 2},
  [7610] = {.lex_state = 130, .external_lex_state = 2},
  [7611] = {.lex_state = 130, .external_lex_state = 2},
  [7612] = {.lex_state = 130, .external_lex_state = 2},
  [7613] = {.lex_state = 130, .external_lex_state = 2},
  [7614] = {.lex_state = 130, .external_lex_state = 2},
  [7615] = {.lex_state = 89, .external_lex_state = 2},
  [7616] = {.lex_state = 89, .external_lex_state = 2},
  [7617] = {.lex_state = 130, .external_lex_state = 2},
  [7618] = {.lex_state = 130, .external_lex_state = 2},
  [7619] = {.lex_state = 130, .external_lex_state = 2},
  [7620] = {.lex_state = 130, .external_lex_state = 2},
  [7621] = {.lex_state = 130, .external_lex_state = 2},
  [7622] = {.lex_state = 130, .external_lex_state = 2},
  [7623] = {.lex_state = 130, .external_lex_state = 2},
  [7624] = {.lex_state = 88, .external_lex_state = 2},
  [7625] = {.lex_state = 130, .external_lex_state = 2},
  [7626] = {.lex_state = 130, .external_lex_state = 2},
  [7627] = {.lex_state = 130, .external_lex_state = 2},
  [7628] = {.lex_state = 130, .external_lex_state = 2},
  [7629] = {.lex_state = 130, .external_lex_state = 2},
  [7630] = {.lex_state = 130, .external_lex_state = 2},
  [7631] = {.lex_state = 130, .external_lex_state = 2},
  [7632] = {.lex_state = 510, .external_lex_state = 2},
  [7633] = {.lex_state = 130, .external_lex_state = 2},
  [7634] = {.lex_state = 88, .external_lex_state = 2},
  [7635] = {.lex_state = 130, .external_lex_state = 2},
  [7636] = {.lex_state = 130, .external_lex_state = 2},
  [7637] = {.lex_state = 88, .external_lex_state = 2},
  [7638] = {.lex_state = 130, .external_lex_state = 2},
  [7639] = {.lex_state = 330, .external_lex_state = 2},
  [7640] = {.lex_state = 89, .external_lex_state = 2},
  [7641] = {.lex_state = 129, .external_lex_state = 2},
  [7642] = {.lex_state = 89, .external_lex_state = 2},
  [7643] = {.lex_state = 130, .external_lex_state = 2},
  [7644] = {.lex_state = 130, .external_lex_state = 2},
  [7645] = {.lex_state = 130, .external_lex_state = 2},
  [7646] = {.lex_state = 130, .external_lex_state = 2},
  [7647] = {.lex_state = 162, .external_lex_state = 2},
  [7648] = {.lex_state = 130, .external_lex_state = 2},
  [7649] = {.lex_state = 82, .external_lex_state = 5},
  [7650] = {.lex_state = 510, .external_lex_state = 2},
  [7651] = {.lex_state = 130, .external_lex_state = 2},
  [7652] = {.lex_state = 510, .external_lex_state = 2},
  [7653] = {.lex_state = 106, .external_lex_state = 2},
  [7654] = {.lex_state = 83, .external_lex_state = 2},
  [7655] = {.lex_state = 325, .external_lex_state = 2},
  [7656] = {.lex_state = 130, .external_lex_state = 2},
  [7657] = {.lex_state = 325, .external_lex_state = 2},
  [7658] = {.lex_state = 325, .external_lex_state = 2},
  [7659] = {.lex_state = 89, .external_lex_state = 5},
  [7660] = {.lex_state = 510, .external_lex_state = 2},
  [7661] = {.lex_state = 510, .external_lex_state = 2},
  [7662] = {.lex_state = 83, .external_lex_state = 2},
  [7663] = {.lex_state = 88, .external_lex_state = 2},
  [7664] = {.lex_state = 510, .external_lex_state = 2},
  [7665] = {.lex_state = 510, .external_lex_state = 2},
  [7666] = {.lex_state = 130, .external_lex_state = 2},
  [7667] = {.lex_state = 130, .external_lex_state = 2},
  [7668] = {.lex_state = 510, .external_lex_state = 2},
  [7669] = {.lex_state = 325, .external_lex_state = 2},
  [7670] = {.lex_state = 325, .external_lex_state = 2},
  [7671] = {.lex_state = 325, .external_lex_state = 2},
  [7672] = {.lex_state = 325, .external_lex_state = 2},
  [7673] = {.lex_state = 325, .external_lex_state = 2},
  [7674] = {.lex_state = 325, .external_lex_state = 2},
  [7675] = {.lex_state = 325, .external_lex_state = 2},
  [7676] = {.lex_state = 510, .external_lex_state = 2},
  [7677] = {.lex_state = 325, .external_lex_state = 2},
  [7678] = {.lex_state = 325, .external_lex_state = 2},
  [7679] = {.lex_state = 325, .external_lex_state = 2},
  [7680] = {.lex_state = 325, .external_lex_state = 2},
  [7681] = {.lex_state = 325, .external_lex_state = 2},
  [7682] = {.lex_state = 325, .external_lex_state = 2},
  [7683] = {.lex_state = 325, .external_lex_state = 2},
  [7684] = {.lex_state = 325, .external_lex_state = 2},
  [7685] = {.lex_state = 325, .external_lex_state = 2},
  [7686] = {.lex_state = 325, .external_lex_state = 2},
  [7687] = {.lex_state = 325, .external_lex_state = 2},
  [7688] = {.lex_state = 325, .external_lex_state = 2},
  [7689] = {.lex_state = 510, .external_lex_state = 2},
  [7690] = {.lex_state = 325, .external_lex_state = 2},
  [7691] = {.lex_state = 325, .external_lex_state = 2},
  [7692] = {.lex_state = 325, .external_lex_state = 2},
  [7693] = {.lex_state = 325, .external_lex_state = 2},
  [7694] = {.lex_state = 325, .external_lex_state = 2},
  [7695] = {.lex_state = 325, .external_lex_state = 2},
  [7696] = {.lex_state = 510, .external_lex_state = 2},
  [7697] = {.lex_state = 28, .external_lex_state = 4},
  [7698] = {.lex_state = 100, .external_lex_state = 2},
  [7699] = {.lex_state = 510, .external_lex_state = 2},
  [7700] = {.lex_state = 115, .external_lex_state = 2},
  [7701] = {.lex_state = 115, .external_lex_state = 2},
  [7702] = {.lex_state = 115, .external_lex_state = 2},
  [7703] = {.lex_state = 88, .external_lex_state = 2},
  [7704] = {.lex_state = 510, .external_lex_state = 2},
  [7705] = {.lex_state = 325, .external_lex_state = 2},
  [7706] = {.lex_state = 325, .external_lex_state = 2},
  [7707] = {.lex_state = 510, .external_lex_state = 2},
  [7708] = {.lex_state = 115, .external_lex_state = 2},
  [7709] = {.lex_state = 325, .external_lex_state = 2},
  [7710] = {.lex_state = 90, .external_lex_state = 2},
  [7711] = {.lex_state = 88, .external_lex_state = 2},
  [7712] = {.lex_state = 510, .external_lex_state = 2},
  [7713] = {.lex_state = 325, .external_lex_state = 2},
  [7714] = {.lex_state = 510, .external_lex_state = 2},
  [7715] = {.lex_state = 127, .external_lex_state = 2},
  [7716] = {.lex_state = 115, .external_lex_state = 2},
  [7717] = {.lex_state = 510, .external_lex_state = 2},
  [7718] = {.lex_state = 510, .external_lex_state = 2},
  [7719] = {.lex_state = 510, .external_lex_state = 2},
  [7720] = {.lex_state = 29, .external_lex_state = 4},
  [7721] = {.lex_state = 88, .external_lex_state = 2},
  [7722] = {.lex_state = 510, .external_lex_state = 2},
  [7723] = {.lex_state = 510, .external_lex_state = 2},
  [7724] = {.lex_state = 510, .external_lex_state = 2},
  [7725] = {.lex_state = 510, .external_lex_state = 2},
  [7726] = {.lex_state = 510, .external_lex_state = 2},
  [7727] = {.lex_state = 510, .external_lex_state = 2},
  [7728] = {.lex_state = 510, .external_lex_state = 2},
  [7729] = {.lex_state = 510, .external_lex_state = 2},
  [7730] = {.lex_state = 510, .external_lex_state = 2},
  [7731] = {.lex_state = 510, .external_lex_state = 2},
  [7732] = {.lex_state = 510, .external_lex_state = 2},
  [7733] = {.lex_state = 510, .external_lex_state = 2},
  [7734] = {.lex_state = 510, .external_lex_state = 2},
  [7735] = {.lex_state = 510, .external_lex_state = 2},
  [7736] = {.lex_state = 510, .external_lex_state = 2},
  [7737] = {.lex_state = 510, .external_lex_state = 2},
  [7738] = {.lex_state = 510, .external_lex_state = 2},
  [7739] = {.lex_state = 83, .external_lex_state = 2},
  [7740] = {.lex_state = 510, .external_lex_state = 2},
  [7741] = {.lex_state = 83, .external_lex_state = 2},
  [7742] = {.lex_state = 83, .external_lex_state = 2},
  [7743] = {.lex_state = 510, .external_lex_state = 2},
  [7744] = {.lex_state = 510, .external_lex_state = 2},
  [7745] = {.lex_state = 83, .external_lex_state = 2},
  [7746] = {.lex_state = 83, .external_lex_state = 2},
  [7747] = {.lex_state = 510, .external_lex_state = 2},
  [7748] = {.lex_state = 83, .external_lex_state = 2},
  [7749] = {.lex_state = 95, .external_lex_state = 2},
  [7750] = {.lex_state = 83, .external_lex_state = 2},
  [7751] = {.lex_state = 83, .external_lex_state = 2},
  [7752] = {.lex_state = 83, .external_lex_state = 2},
  [7753] = {.lex_state = 83, .external_lex_state = 2},
  [7754] = {.lex_state = 83, .external_lex_state = 2},
  [7755] = {.lex_state = 83, .external_lex_state = 2},
  [7756] = {.lex_state = 83, .external_lex_state = 2},
  [7757] = {.lex_state = 83, .external_lex_state = 2},
  [7758] = {.lex_state = 83, .external_lex_state = 2},
  [7759] = {.lex_state = 510, .external_lex_state = 2},
  [7760] = {.lex_state = 83, .external_lex_state = 2},
  [7761] = {.lex_state = 83, .external_lex_state = 2},
  [7762] = {.lex_state = 83, .external_lex_state = 2},
  [7763] = {.lex_state = 83, .external_lex_state = 2},
  [7764] = {.lex_state = 83, .external_lex_state = 2},
  [7765] = {.lex_state = 83, .external_lex_state = 2},
  [7766] = {.lex_state = 83, .external_lex_state = 2},
  [7767] = {.lex_state = 83, .external_lex_state = 2},
  [7768] = {.lex_state = 83, .external_lex_state = 2},
  [7769] = {.lex_state = 83, .external_lex_state = 2},
  [7770] = {.lex_state = 83, .external_lex_state = 2},
  [7771] = {.lex_state = 83, .external_lex_state = 2},
  [7772] = {.lex_state = 510, .external_lex_state = 2},
  [7773] = {.lex_state = 510, .external_lex_state = 2},
  [7774] = {.lex_state = 510, .external_lex_state = 2},
  [7775] = {.lex_state = 510, .external_lex_state = 2},
  [7776] = {.lex_state = 510, .external_lex_state = 2},
  [7777] = {.lex_state = 510, .external_lex_state = 2},
  [7778] = {.lex_state = 510, .external_lex_state = 2},
  [7779] = {.lex_state = 510, .external_lex_state = 2},
  [7780] = {.lex_state = 510, .external_lex_state = 2},
  [7781] = {.lex_state = 510, .external_lex_state = 2},
  [7782] = {.lex_state = 510, .external_lex_state = 2},
  [7783] = {.lex_state = 510, .external_lex_state = 2},
  [7784] = {.lex_state = 510, .external_lex_state = 2},
  [7785] = {.lex_state = 510, .external_lex_state = 2},
  [7786] = {.lex_state = 90, .external_lex_state = 2},
  [7787] = {.lex_state = 83, .external_lex_state = 2},
  [7788] = {.lex_state = 510, .external_lex_state = 2},
  [7789] = {.lex_state = 82, .external_lex_state = 2},
  [7790] = {.lex_state = 83, .external_lex_state = 2},
  [7791] = {.lex_state = 510, .external_lex_state = 2},
  [7792] = {.lex_state = 83, .external_lex_state = 2},
  [7793] = {.lex_state = 510, .external_lex_state = 2},
  [7794] = {.lex_state = 510, .external_lex_state = 2},
  [7795] = {.lex_state = 83, .external_lex_state = 2},
  [7796] = {.lex_state = 510, .external_lex_state = 2},
  [7797] = {.lex_state = 510, .external_lex_state = 2},
  [7798] = {.lex_state = 510, .external_lex_state = 2},
  [7799] = {.lex_state = 510, .external_lex_state = 2},
  [7800] = {.lex_state = 510, .external_lex_state = 2},
  [7801] = {.lex_state = 510, .external_lex_state = 2},
  [7802] = {.lex_state = 510, .external_lex_state = 2},
  [7803] = {.lex_state = 510, .external_lex_state = 2},
  [7804] = {.lex_state = 510, .external_lex_state = 2},
  [7805] = {.lex_state = 510, .external_lex_state = 2},
  [7806] = {.lex_state = 510, .external_lex_state = 2},
  [7807] = {.lex_state = 510, .external_lex_state = 2},
  [7808] = {.lex_state = 510, .external_lex_state = 2},
  [7809] = {.lex_state = 510, .external_lex_state = 2},
  [7810] = {.lex_state = 510, .external_lex_state = 2},
  [7811] = {.lex_state = 510, .external_lex_state = 2},
  [7812] = {.lex_state = 510, .external_lex_state = 2},
  [7813] = {.lex_state = 510, .external_lex_state = 2},
  [7814] = {.lex_state = 89, .external_lex_state = 2},
  [7815] = {.lex_state = 89, .external_lex_state = 2},
  [7816] = {.lex_state = 82, .external_lex_state = 2},
  [7817] = {.lex_state = 510, .external_lex_state = 2},
  [7818] = {.lex_state = 510, .external_lex_state = 2},
  [7819] = {.lex_state = 325, .external_lex_state = 2},
  [7820] = {.lex_state = 325, .external_lex_state = 2},
  [7821] = {.lex_state = 336, .external_lex_state = 2},
  [7822] = {.lex_state = 325, .external_lex_state = 2},
  [7823] = {.lex_state = 325, .external_lex_state = 5},
  [7824] = {.lex_state = 89, .external_lex_state = 2},
  [7825] = {.lex_state = 325, .external_lex_state = 2},
  [7826] = {.lex_state = 510, .external_lex_state = 2},
  [7827] = {.lex_state = 99, .external_lex_state = 2},
  [7828] = {.lex_state = 510, .external_lex_state = 2},
  [7829] = {.lex_state = 325, .external_lex_state = 2},
  [7830] = {.lex_state = 130, .external_lex_state = 2},
  [7831] = {.lex_state = 325, .external_lex_state = 2},
  [7832] = {.lex_state = 510, .external_lex_state = 2},
  [7833] = {.lex_state = 510, .external_lex_state = 2},
  [7834] = {.lex_state = 167, .external_lex_state = 2},
  [7835] = {.lex_state = 510, .external_lex_state = 2},
  [7836] = {.lex_state = 510, .external_lex_state = 2},
  [7837] = {.lex_state = 510, .external_lex_state = 2},
  [7838] = {.lex_state = 510, .external_lex_state = 2},
  [7839] = {.lex_state = 82, .external_lex_state = 2},
  [7840] = {.lex_state = 510, .external_lex_state = 2},
  [7841] = {.lex_state = 510, .external_lex_state = 2},
  [7842] = {.lex_state = 82, .external_lex_state = 2},
  [7843] = {.lex_state = 82, .external_lex_state = 2},
  [7844] = {.lex_state = 510, .external_lex_state = 2},
  [7845] = {.lex_state = 510, .external_lex_state = 2},
  [7846] = {.lex_state = 510, .external_lex_state = 2},
  [7847] = {.lex_state = 510, .external_lex_state = 2},
  [7848] = {.lex_state = 510, .external_lex_state = 2},
  [7849] = {.lex_state = 510, .external_lex_state = 2},
  [7850] = {.lex_state = 510, .external_lex_state = 2},
  [7851] = {.lex_state = 510, .external_lex_state = 2},
  [7852] = {.lex_state = 510, .external_lex_state = 2},
  [7853] = {.lex_state = 510, .external_lex_state = 2},
  [7854] = {.lex_state = 510, .external_lex_state = 2},
  [7855] = {.lex_state = 510, .external_lex_state = 2},
  [7856] = {.lex_state = 510, .external_lex_state = 2},
  [7857] = {.lex_state = 510, .external_lex_state = 2},
  [7858] = {.lex_state = 510, .external_lex_state = 2},
  [7859] = {.lex_state = 325, .external_lex_state = 2},
  [7860] = {.lex_state = 510, .external_lex_state = 2},
  [7861] = {.lex_state = 510, .external_lex_state = 2},
  [7862] = {.lex_state = 89, .external_lex_state = 5},
  [7863] = {.lex_state = 82, .external_lex_state = 2},
  [7864] = {.lex_state = 82, .external_lex_state = 2},
  [7865] = {.lex_state = 82, .external_lex_state = 2},
  [7866] = {.lex_state = 82, .external_lex_state = 2},
  [7867] = {.lex_state = 82, .external_lex_state = 2},
  [7868] = {.lex_state = 82, .external_lex_state = 2},
  [7869] = {.lex_state = 82, .external_lex_state = 2},
  [7870] = {.lex_state = 82, .external_lex_state = 2},
  [7871] = {.lex_state = 82, .external_lex_state = 2},
  [7872] = {.lex_state = 82, .external_lex_state = 2},
  [7873] = {.lex_state = 82, .external_lex_state = 2},
  [7874] = {.lex_state = 82, .external_lex_state = 2},
  [7875] = {.lex_state = 510, .external_lex_state = 2},
  [7876] = {.lex_state = 82, .external_lex_state = 2},
  [7877] = {.lex_state = 82, .external_lex_state = 2},
  [7878] = {.lex_state = 82, .external_lex_state = 2},
  [7879] = {.lex_state = 82, .external_lex_state = 2},
  [7880] = {.lex_state = 82, .external_lex_state = 2},
  [7881] = {.lex_state = 82, .external_lex_state = 2},
  [7882] = {.lex_state = 82, .external_lex_state = 2},
  [7883] = {.lex_state = 82, .external_lex_state = 2},
  [7884] = {.lex_state = 82, .external_lex_state = 2},
  [7885] = {.lex_state = 82, .external_lex_state = 2},
  [7886] = {.lex_state = 82, .external_lex_state = 2},
  [7887] = {.lex_state = 510, .external_lex_state = 2},
  [7888] = {.lex_state = 82, .external_lex_state = 2},
  [7889] = {.lex_state = 82, .external_lex_state = 2},
  [7890] = {.lex_state = 83, .external_lex_state = 2},
  [7891] = {.lex_state = 510, .external_lex_state = 2},
  [7892] = {.lex_state = 510, .external_lex_state = 2},
  [7893] = {.lex_state = 83, .external_lex_state = 2},
  [7894] = {.lex_state = 510, .external_lex_state = 2},
  [7895] = {.lex_state = 510, .external_lex_state = 2},
  [7896] = {.lex_state = 510, .external_lex_state = 2},
  [7897] = {.lex_state = 510, .external_lex_state = 2},
  [7898] = {.lex_state = 510, .external_lex_state = 2},
  [7899] = {.lex_state = 510, .external_lex_state = 2},
  [7900] = {.lex_state = 510, .external_lex_state = 2},
  [7901] = {.lex_state = 510, .external_lex_state = 2},
  [7902] = {.lex_state = 510, .external_lex_state = 2},
  [7903] = {.lex_state = 510, .external_lex_state = 2},
  [7904] = {.lex_state = 510, .external_lex_state = 2},
  [7905] = {.lex_state = 510, .external_lex_state = 2},
  [7906] = {.lex_state = 83, .external_lex_state = 2},
  [7907] = {.lex_state = 510, .external_lex_state = 2},
  [7908] = {.lex_state = 510, .external_lex_state = 2},
  [7909] = {.lex_state = 510, .external_lex_state = 2},
  [7910] = {.lex_state = 510, .external_lex_state = 2},
  [7911] = {.lex_state = 510, .external_lex_state = 2},
  [7912] = {.lex_state = 510, .external_lex_state = 2},
  [7913] = {.lex_state = 510, .external_lex_state = 2},
  [7914] = {.lex_state = 510, .external_lex_state = 2},
  [7915] = {.lex_state = 510, .external_lex_state = 2},
  [7916] = {.lex_state = 510, .external_lex_state = 2},
  [7917] = {.lex_state = 510, .external_lex_state = 2},
  [7918] = {.lex_state = 510, .external_lex_state = 2},
  [7919] = {.lex_state = 82, .external_lex_state = 2},
  [7920] = {.lex_state = 510, .external_lex_state = 2},
  [7921] = {.lex_state = 510, .external_lex_state = 2},
  [7922] = {.lex_state = 510, .external_lex_state = 2},
  [7923] = {.lex_state = 510, .external_lex_state = 2},
  [7924] = {.lex_state = 82, .external_lex_state = 2},
  [7925] = {.lex_state = 510, .external_lex_state = 2},
  [7926] = {.lex_state = 82, .external_lex_state = 2},
  [7927] = {.lex_state = 510, .external_lex_state = 2},
  [7928] = {.lex_state = 82, .external_lex_state = 2},
  [7929] = {.lex_state = 90, .external_lex_state = 2},
  [7930] = {.lex_state = 90, .external_lex_state = 2},
  [7931] = {.lex_state = 90, .external_lex_state = 2},
  [7932] = {.lex_state = 90, .external_lex_state = 2},
  [7933] = {.lex_state = 90, .external_lex_state = 2},
  [7934] = {.lex_state = 90, .external_lex_state = 2},
  [7935] = {.lex_state = 90, .external_lex_state = 2},
  [7936] = {.lex_state = 90, .external_lex_state = 2},
  [7937] = {.lex_state = 90, .external_lex_state = 2},
  [7938] = {.lex_state = 90, .external_lex_state = 2},
  [7939] = {.lex_state = 90, .external_lex_state = 2},
  [7940] = {.lex_state = 510, .external_lex_state = 2},
  [7941] = {.lex_state = 90, .external_lex_state = 2},
  [7942] = {.lex_state = 89, .external_lex_state = 2},
  [7943] = {.lex_state = 90, .external_lex_state = 2},
  [7944] = {.lex_state = 90, .external_lex_state = 2},
  [7945] = {.lex_state = 90, .external_lex_state = 2},
  [7946] = {.lex_state = 509, .external_lex_state = 2},
  [7947] = {.lex_state = 509, .external_lex_state = 2},
  [7948] = {.lex_state = 510, .external_lex_state = 2},
  [7949] = {.lex_state = 509, .external_lex_state = 2},
  [7950] = {.lex_state = 509, .external_lex_state = 2},
  [7951] = {.lex_state = 325, .external_lex_state = 5},
  [7952] = {.lex_state = 510, .external_lex_state = 2},
  [7953] = {.lex_state = 510, .external_lex_state = 2},
  [7954] = {.lex_state = 325, .external_lex_state = 2},
  [7955] = {.lex_state = 325, .external_lex_state = 2},
  [7956] = {.lex_state = 510, .external_lex_state = 2},
  [7957] = {.lex_state = 510, .external_lex_state = 2},
  [7958] = {.lex_state = 82, .external_lex_state = 2},
  [7959] = {.lex_state = 82, .external_lex_state = 2},
  [7960] = {.lex_state = 89, .external_lex_state = 2},
  [7961] = {.lex_state = 510, .external_lex_state = 2},
  [7962] = {.lex_state = 89, .external_lex_state = 2},
  [7963] = {.lex_state = 89, .external_lex_state = 2},
  [7964] = {.lex_state = 82, .external_lex_state = 2},
  [7965] = {.lex_state = 510, .external_lex_state = 2},
  [7966] = {.lex_state = 106, .external_lex_state = 2},
  [7967] = {.lex_state = 89, .external_lex_state = 2},
  [7968] = {.lex_state = 89, .external_lex_state = 2},
  [7969] = {.lex_state = 89, .external_lex_state = 2},
  [7970] = {.lex_state = 510, .external_lex_state = 2},
  [7971] = {.lex_state = 89, .external_lex_state = 2},
  [7972] = {.lex_state = 89, .external_lex_state = 2},
  [7973] = {.lex_state = 89, .external_lex_state = 2},
  [7974] = {.lex_state = 89, .external_lex_state = 2},
  [7975] = {.lex_state = 89, .external_lex_state = 2},
  [7976] = {.lex_state = 89, .external_lex_state = 2},
  [7977] = {.lex_state = 89, .external_lex_state = 2},
  [7978] = {.lex_state = 89, .external_lex_state = 2},
  [7979] = {.lex_state = 89, .external_lex_state = 2},
  [7980] = {.lex_state = 510, .external_lex_state = 2},
  [7981] = {.lex_state = 89, .external_lex_state = 2},
  [7982] = {.lex_state = 89, .external_lex_state = 2},
  [7983] = {.lex_state = 89, .external_lex_state = 2},
  [7984] = {.lex_state = 89, .external_lex_state = 2},
  [7985] = {.lex_state = 89, .external_lex_state = 2},
  [7986] = {.lex_state = 89, .external_lex_state = 2},
  [7987] = {.lex_state = 89, .external_lex_state = 2},
  [7988] = {.lex_state = 89, .external_lex_state = 2},
  [7989] = {.lex_state = 89, .external_lex_state = 2},
  [7990] = {.lex_state = 89, .external_lex_state = 2},
  [7991] = {.lex_state = 89, .external_lex_state = 2},
  [7992] = {.lex_state = 510, .external_lex_state = 2},
  [7993] = {.lex_state = 89, .external_lex_state = 2},
  [7994] = {.lex_state = 89, .external_lex_state = 2},
  [7995] = {.lex_state = 90, .external_lex_state = 2},
  [7996] = {.lex_state = 90, .external_lex_state = 2},
  [7997] = {.lex_state = 89, .external_lex_state = 2},
  [7998] = {.lex_state = 83, .external_lex_state = 2},
  [7999] = {.lex_state = 510, .external_lex_state = 2},
  [8000] = {.lex_state = 510, .external_lex_state = 2},
  [8001] = {.lex_state = 83, .external_lex_state = 2},
  [8002] = {.lex_state = 510, .external_lex_state = 2},
  [8003] = {.lex_state = 89, .external_lex_state = 2},
  [8004] = {.lex_state = 126, .external_lex_state = 2},
  [8005] = {.lex_state = 89, .external_lex_state = 2},
  [8006] = {.lex_state = 510, .external_lex_state = 2},
  [8007] = {.lex_state = 89, .external_lex_state = 2},
  [8008] = {.lex_state = 510, .external_lex_state = 2},
  [8009] = {.lex_state = 89, .external_lex_state = 2},
  [8010] = {.lex_state = 89, .external_lex_state = 2},
  [8011] = {.lex_state = 510, .external_lex_state = 2},
  [8012] = {.lex_state = 89, .external_lex_state = 2},
  [8013] = {.lex_state = 510, .external_lex_state = 2},
  [8014] = {.lex_state = 89, .external_lex_state = 2},
  [8015] = {.lex_state = 83, .external_lex_state = 2},
  [8016] = {.lex_state = 115, .external_lex_state = 2},
  [8017] = {.lex_state = 325, .external_lex_state = 2},
  [8018] = {.lex_state = 115, .external_lex_state = 2},
  [8019] = {.lex_state = 325, .external_lex_state = 2},
  [8020] = {.lex_state = 115, .external_lex_state = 2},
  [8021] = {.lex_state = 88, .external_lex_state = 2},
  [8022] = {.lex_state = 31, .external_lex_state = 4},
  [8023] = {.lex_state = 510, .external_lex_state = 2},
  [8024] = {.lex_state = 88, .external_lex_state = 2},
  [8025] = {.lex_state = 88, .external_lex_state = 2},
  [8026] = {.lex_state = 88, .external_lex_state = 2},
  [8027] = {.lex_state = 88, .external_lex_state = 2},
  [8028] = {.lex_state = 88, .external_lex_state = 2},
  [8029] = {.lex_state = 88, .external_lex_state = 2},
  [8030] = {.lex_state = 88, .external_lex_state = 2},
  [8031] = {.lex_state = 88, .external_lex_state = 2},
  [8032] = {.lex_state = 88, .external_lex_state = 2},
  [8033] = {.lex_state = 88, .external_lex_state = 2},
  [8034] = {.lex_state = 88, .external_lex_state = 2},
  [8035] = {.lex_state = 115, .external_lex_state = 2},
  [8036] = {.lex_state = 90, .external_lex_state = 2},
  [8037] = {.lex_state = 513, .external_lex_state = 2},
  [8038] = {.lex_state = 115, .external_lex_state = 2},
  [8039] = {.lex_state = 115, .external_lex_state = 2},
  [8040] = {.lex_state = 115, .external_lex_state = 2},
  [8041] = {.lex_state = 115, .external_lex_state = 2},
  [8042] = {.lex_state = 115, .external_lex_state = 2},
  [8043] = {.lex_state = 115, .external_lex_state = 2},
  [8044] = {.lex_state = 115, .external_lex_state = 2},
  [8045] = {.lex_state = 115, .external_lex_state = 2},
  [8046] = {.lex_state = 90, .external_lex_state = 2},
  [8047] = {.lex_state = 90, .external_lex_state = 2},
  [8048] = {.lex_state = 90, .external_lex_state = 2},
  [8049] = {.lex_state = 115, .external_lex_state = 2},
  [8050] = {.lex_state = 115, .external_lex_state = 2},
  [8051] = {.lex_state = 115, .external_lex_state = 2},
  [8052] = {.lex_state = 108, .external_lex_state = 2},
  [8053] = {.lex_state = 115, .external_lex_state = 2},
  [8054] = {.lex_state = 115, .external_lex_state = 2},
  [8055] = {.lex_state = 115, .external_lex_state = 2},
  [8056] = {.lex_state = 115, .external_lex_state = 2},
  [8057] = {.lex_state = 115, .external_lex_state = 2},
  [8058] = {.lex_state = 115, .external_lex_state = 2},
  [8059] = {.lex_state = 115, .external_lex_state = 2},
  [8060] = {.lex_state = 115, .external_lex_state = 2},
  [8061] = {.lex_state = 115, .external_lex_state = 2},
  [8062] = {.lex_state = 115, .external_lex_state = 2},
  [8063] = {.lex_state = 115, .external_lex_state = 2},
  [8064] = {.lex_state = 115, .external_lex_state = 2},
  [8065] = {.lex_state = 115, .external_lex_state = 2},
  [8066] = {.lex_state = 115, .external_lex_state = 2},
  [8067] = {.lex_state = 115, .external_lex_state = 2},
  [8068] = {.lex_state = 115, .external_lex_state = 2},
  [8069] = {.lex_state = 115, .external_lex_state = 2},
  [8070] = {.lex_state = 115, .external_lex_state = 2},
  [8071] = {.lex_state = 115, .external_lex_state = 2},
  [8072] = {.lex_state = 115, .external_lex_state = 2},
  [8073] = {.lex_state = 115, .external_lex_state = 2},
  [8074] = {.lex_state = 105, .external_lex_state = 2},
  [8075] = {.lex_state = 325, .external_lex_state = 2},
  [8076] = {.lex_state = 330, .external_lex_state = 2},
  [8077] = {.lex_state = 325, .external_lex_state = 2},
  [8078] = {.lex_state = 115, .external_lex_state = 2},
  [8079] = {.lex_state = 325, .external_lex_state = 5},
  [8080] = {.lex_state = 115, .external_lex_state = 2},
  [8081] = {.lex_state = 115, .external_lex_state = 2},
  [8082] = {.lex_state = 115, .external_lex_state = 2},
  [8083] = {.lex_state = 330, .external_lex_state = 2},
  [8084] = {.lex_state = 325, .external_lex_state = 2},
  [8085] = {.lex_state = 83, .external_lex_state = 2},
  [8086] = {.lex_state = 83, .external_lex_state = 2},
  [8087] = {.lex_state = 83, .external_lex_state = 2},
  [8088] = {.lex_state = 83, .external_lex_state = 2},
  [8089] = {.lex_state = 82, .external_lex_state = 2},
  [8090] = {.lex_state = 89, .external_lex_state = 2},
  [8091] = {.lex_state = 82, .external_lex_state = 2},
  [8092] = {.lex_state = 82, .external_lex_state = 2},
  [8093] = {.lex_state = 82, .external_lex_state = 2},
  [8094] = {.lex_state = 89, .external_lex_state = 2},
  [8095] = {.lex_state = 89, .external_lex_state = 2},
  [8096] = {.lex_state = 89, .external_lex_state = 2},
  [8097] = {.lex_state = 83, .external_lex_state = 2},
  [8098] = {.lex_state = 82, .external_lex_state = 2},
  [8099] = {.lex_state = 83, .external_lex_state = 2},
  [8100] = {.lex_state = 83, .external_lex_state = 2},
  [8101] = {.lex_state = 89, .external_lex_state = 2},
  [8102] = {.lex_state = 82, .external_lex_state = 2},
  [8103] = {.lex_state = 82, .external_lex_state = 2},
  [8104] = {.lex_state = 89, .external_lex_state = 2},
  [8105] = {.lex_state = 89, .external_lex_state = 2},
  [8106] = {.lex_state = 83, .external_lex_state = 2},
  [8107] = {.lex_state = 510, .external_lex_state = 2},
  [8108] = {.lex_state = 89, .external_lex_state = 2},
  [8109] = {.lex_state = 509, .external_lex_state = 2},
  [8110] = {.lex_state = 83, .external_lex_state = 2},
  [8111] = {.lex_state = 509, .external_lex_state = 2},
  [8112] = {.lex_state = 75, .external_lex_state = 2},
  [8113] = {.lex_state = 509, .external_lex_state = 2},
  [8114] = {.lex_state = 509, .external_lex_state = 2},
  [8115] = {.lex_state = 509, .external_lex_state = 2},
  [8116] = {.lex_state = 83, .external_lex_state = 2},
  [8117] = {.lex_state = 89, .external_lex_state = 2},
  [8118] = {.lex_state = 509, .external_lex_state = 2},
  [8119] = {.lex_state = 509, .external_lex_state = 2},
  [8120] = {.lex_state = 509, .external_lex_state = 2},
  [8121] = {.lex_state = 509, .external_lex_state = 2},
  [8122] = {.lex_state = 509, .external_lex_state = 2},
  [8123] = {.lex_state = 509, .external_lex_state = 2},
  [8124] = {.lex_state = 509, .external_lex_state = 2},
  [8125] = {.lex_state = 509, .external_lex_state = 2},
  [8126] = {.lex_state = 509, .external_lex_state = 2},
  [8127] = {.lex_state = 325, .external_lex_state = 2},
  [8128] = {.lex_state = 509, .external_lex_state = 2},
  [8129] = {.lex_state = 509, .external_lex_state = 2},
  [8130] = {.lex_state = 509, .external_lex_state = 2},
  [8131] = {.lex_state = 509, .external_lex_state = 2},
  [8132] = {.lex_state = 89, .external_lex_state = 2},
  [8133] = {.lex_state = 83, .external_lex_state = 2},
  [8134] = {.lex_state = 83, .external_lex_state = 2},
  [8135] = {.lex_state = 83, .external_lex_state = 2},
  [8136] = {.lex_state = 89, .external_lex_state = 2},
  [8137] = {.lex_state = 83, .external_lex_state = 2},
  [8138] = {.lex_state = 509, .external_lex_state = 2},
  [8139] = {.lex_state = 89, .external_lex_state = 2},
  [8140] = {.lex_state = 89, .external_lex_state = 2},
  [8141] = {.lex_state = 89, .external_lex_state = 2},
  [8142] = {.lex_state = 89, .external_lex_state = 2},
  [8143] = {.lex_state = 89, .external_lex_state = 2},
  [8144] = {.lex_state = 83, .external_lex_state = 2},
  [8145] = {.lex_state = 89, .external_lex_state = 2},
  [8146] = {.lex_state = 83, .external_lex_state = 2},
  [8147] = {.lex_state = 83, .external_lex_state = 2},
  [8148] = {.lex_state = 509, .external_lex_state = 2},
  [8149] = {.lex_state = 89, .external_lex_state = 2},
  [8150] = {.lex_state = 89, .external_lex_state = 2},
  [8151] = {.lex_state = 89, .external_lex_state = 2},
  [8152] = {.lex_state = 89, .external_lex_state = 2},
  [8153] = {.lex_state = 89, .external_lex_state = 2},
  [8154] = {.lex_state = 89, .external_lex_state = 2},
  [8155] = {.lex_state = 83, .external_lex_state = 2},
  [8156] = {.lex_state = 83, .external_lex_state = 2},
  [8157] = {.lex_state = 90, .external_lex_state = 2},
  [8158] = {.lex_state = 90, .external_lex_state = 2},
  [8159] = {.lex_state = 90, .external_lex_state = 2},
  [8160] = {.lex_state = 509, .external_lex_state = 2},
  [8161] = {.lex_state = 90, .external_lex_state = 2},
  [8162] = {.lex_state = 90, .external_lex_state = 2},
  [8163] = {.lex_state = 90, .external_lex_state = 2},
  [8164] = {.lex_state = 90, .external_lex_state = 2},
  [8165] = {.lex_state = 90, .external_lex_state = 2},
  [8166] = {.lex_state = 90, .external_lex_state = 2},
  [8167] = {.lex_state = 90, .external_lex_state = 2},
  [8168] = {.lex_state = 90, .external_lex_state = 2},
  [8169] = {.lex_state = 90, .external_lex_state = 2},
  [8170] = {.lex_state = 509, .external_lex_state = 2},
  [8171] = {.lex_state = 82, .external_lex_state = 2},
  [8172] = {.lex_state = 90, .external_lex_state = 2},
  [8173] = {.lex_state = 90, .external_lex_state = 2},
  [8174] = {.lex_state = 89, .external_lex_state = 2},
  [8175] = {.lex_state = 325, .external_lex_state = 2},
  [8176] = {.lex_state = 83, .external_lex_state = 2},
  [8177] = {.lex_state = 83, .external_lex_state = 2},
  [8178] = {.lex_state = 325, .external_lex_state = 2},
  [8179] = {.lex_state = 89, .external_lex_state = 2},
  [8180] = {.lex_state = 325, .external_lex_state = 2},
  [8181] = {.lex_state = 509, .external_lex_state = 2},
  [8182] = {.lex_state = 509, .external_lex_state = 2},
  [8183] = {.lex_state = 168, .external_lex_state = 2},
  [8184] = {.lex_state = 509, .external_lex_state = 2},
  [8185] = {.lex_state = 325, .external_lex_state = 2},
  [8186] = {.lex_state = 89, .external_lex_state = 2},
  [8187] = {.lex_state = 89, .external_lex_state = 2},
  [8188] = {.lex_state = 89, .external_lex_state = 2},
  [8189] = {.lex_state = 89, .external_lex_state = 2},
  [8190] = {.lex_state = 89, .external_lex_state = 2},
  [8191] = {.lex_state = 315, .external_lex_state = 4},
  [8192] = {.lex_state = 89, .external_lex_state = 2},
  [8193] = {.lex_state = 89, .external_lex_state = 2},
  [8194] = {.lex_state = 89, .external_lex_state = 2},
  [8195] = {.lex_state = 89, .external_lex_state = 2},
  [8196] = {.lex_state = 89, .external_lex_state = 2},
  [8197] = {.lex_state = 89, .external_lex_state = 2},
  [8198] = {.lex_state = 89, .external_lex_state = 2},
  [8199] = {.lex_state = 89, .external_lex_state = 2},
  [8200] = {.lex_state = 89, .external_lex_state = 2},
  [8201] = {.lex_state = 89, .external_lex_state = 2},
  [8202] = {.lex_state = 325, .external_lex_state = 2},
  [8203] = {.lex_state = 328, .external_lex_state = 2},
  [8204] = {.lex_state = 89, .external_lex_state = 2},
  [8205] = {.lex_state = 89, .external_lex_state = 2},
  [8206] = {.lex_state = 89, .external_lex_state = 2},
  [8207] = {.lex_state = 89, .external_lex_state = 2},
  [8208] = {.lex_state = 89, .external_lex_state = 2},
  [8209] = {.lex_state = 89, .external_lex_state = 2},
  [8210] = {.lex_state = 89, .external_lex_state = 2},
  [8211] = {.lex_state = 89, .external_lex_state = 2},
  [8212] = {.lex_state = 89, .external_lex_state = 2},
  [8213] = {.lex_state = 89, .external_lex_state = 2},
  [8214] = {.lex_state = 89, .external_lex_state = 2},
  [8215] = {.lex_state = 89, .external_lex_state = 2},
  [8216] = {.lex_state = 89, .external_lex_state = 2},
  [8217] = {.lex_state = 89, .external_lex_state = 2},
  [8218] = {.lex_state = 89, .external_lex_state = 2},
  [8219] = {.lex_state = 89, .external_lex_state = 2},
  [8220] = {.lex_state = 89, .external_lex_state = 2},
  [8221] = {.lex_state = 89, .external_lex_state = 2},
  [8222] = {.lex_state = 89, .external_lex_state = 2},
  [8223] = {.lex_state = 89, .external_lex_state = 2},
  [8224] = {.lex_state = 89, .external_lex_state = 2},
  [8225] = {.lex_state = 89, .external_lex_state = 2},
  [8226] = {.lex_state = 89, .external_lex_state = 2},
  [8227] = {.lex_state = 89, .external_lex_state = 2},
  [8228] = {.lex_state = 89, .external_lex_state = 2},
  [8229] = {.lex_state = 89, .external_lex_state = 2},
  [8230] = {.lex_state = 89, .external_lex_state = 2},
  [8231] = {.lex_state = 89, .external_lex_state = 2},
  [8232] = {.lex_state = 89, .external_lex_state = 2},
  [8233] = {.lex_state = 89, .external_lex_state = 2},
  [8234] = {.lex_state = 89, .external_lex_state = 2},
  [8235] = {.lex_state = 89, .external_lex_state = 2},
  [8236] = {.lex_state = 89, .external_lex_state = 2},
  [8237] = {.lex_state = 89, .external_lex_state = 2},
  [8238] = {.lex_state = 89, .external_lex_state = 2},
  [8239] = {.lex_state = 89, .external_lex_state = 2},
  [8240] = {.lex_state = 89, .external_lex_state = 2},
  [8241] = {.lex_state = 89, .external_lex_state = 2},
  [8242] = {.lex_state = 89, .external_lex_state = 2},
  [8243] = {.lex_state = 89, .external_lex_state = 2},
  [8244] = {.lex_state = 89, .external_lex_state = 2},
  [8245] = {.lex_state = 82, .external_lex_state = 2},
  [8246] = {.lex_state = 89, .external_lex_state = 2},
  [8247] = {.lex_state = 89, .external_lex_state = 2},
  [8248] = {.lex_state = 89, .external_lex_state = 2},
  [8249] = {.lex_state = 89, .external_lex_state = 2},
  [8250] = {.lex_state = 82, .external_lex_state = 2},
  [8251] = {.lex_state = 509, .external_lex_state = 2},
  [8252] = {.lex_state = 509, .external_lex_state = 2},
  [8253] = {.lex_state = 89, .external_lex_state = 2},
  [8254] = {.lex_state = 89, .external_lex_state = 2},
  [8255] = {.lex_state = 89, .external_lex_state = 2},
  [8256] = {.lex_state = 509, .external_lex_state = 2},
  [8257] = {.lex_state = 89, .external_lex_state = 2},
  [8258] = {.lex_state = 83, .external_lex_state = 2},
  [8259] = {.lex_state = 509, .external_lex_state = 2},
  [8260] = {.lex_state = 130, .external_lex_state = 2},
  [8261] = {.lex_state = 509, .external_lex_state = 2},
  [8262] = {.lex_state = 325, .external_lex_state = 2},
  [8263] = {.lex_state = 89, .external_lex_state = 2},
  [8264] = {.lex_state = 325, .external_lex_state = 5},
  [8265] = {.lex_state = 83, .external_lex_state = 2},
  [8266] = {.lex_state = 83, .external_lex_state = 2},
  [8267] = {.lex_state = 325, .external_lex_state = 2},
  [8268] = {.lex_state = 83, .external_lex_state = 2},
  [8269] = {.lex_state = 82, .external_lex_state = 2},
  [8270] = {.lex_state = 328, .external_lex_state = 2},
  [8271] = {.lex_state = 89, .external_lex_state = 2},
  [8272] = {.lex_state = 78, .external_lex_state = 2},
  [8273] = {.lex_state = 75, .external_lex_state = 5},
  [8274] = {.lex_state = 75, .external_lex_state = 2},
  [8275] = {.lex_state = 75, .external_lex_state = 2},
  [8276] = {.lex_state = 89, .external_lex_state = 2},
  [8277] = {.lex_state = 325, .external_lex_state = 2},
  [8278] = {.lex_state = 82, .external_lex_state = 2},
  [8279] = {.lex_state = 83, .external_lex_state = 2},
  [8280] = {.lex_state = 83, .external_lex_state = 2},
  [8281] = {.lex_state = 509, .external_lex_state = 2},
  [8282] = {.lex_state = 82, .external_lex_state = 2},
  [8283] = {.lex_state = 75, .external_lex_state = 2},
  [8284] = {.lex_state = 75, .external_lex_state = 2},
  [8285] = {.lex_state = 83, .external_lex_state = 2},
  [8286] = {.lex_state = 83, .external_lex_state = 2},
  [8287] = {.lex_state = 83, .external_lex_state = 2},
  [8288] = {.lex_state = 83, .external_lex_state = 2},
  [8289] = {.lex_state = 83, .external_lex_state = 2},
  [8290] = {.lex_state = 83, .external_lex_state = 2},
  [8291] = {.lex_state = 83, .external_lex_state = 2},
  [8292] = {.lex_state = 75, .external_lex_state = 2},
  [8293] = {.lex_state = 115, .external_lex_state = 2},
  [8294] = {.lex_state = 75, .external_lex_state = 2},
  [8295] = {.lex_state = 83, .external_lex_state = 2},
  [8296] = {.lex_state = 83, .external_lex_state = 2},
  [8297] = {.lex_state = 325, .external_lex_state = 2},
  [8298] = {.lex_state = 509, .external_lex_state = 5},
  [8299] = {.lex_state = 509, .external_lex_state = 2},
  [8300] = {.lex_state = 32, .external_lex_state = 4},
  [8301] = {.lex_state = 325, .external_lex_state = 2},
  [8302] = {.lex_state = 107, .external_lex_state = 2},
  [8303] = {.lex_state = 509, .external_lex_state = 5},
  [8304] = {.lex_state = 83, .external_lex_state = 2},
  [8305] = {.lex_state = 509, .external_lex_state = 2},
  [8306] = {.lex_state = 89, .external_lex_state = 2},
  [8307] = {.lex_state = 89, .external_lex_state = 2},
  [8308] = {.lex_state = 83, .external_lex_state = 2},
  [8309] = {.lex_state = 325, .external_lex_state = 2},
  [8310] = {.lex_state = 509, .external_lex_state = 5},
  [8311] = {.lex_state = 83, .external_lex_state = 2},
  [8312] = {.lex_state = 82, .external_lex_state = 2},
  [8313] = {.lex_state = 325, .external_lex_state = 2},
  [8314] = {.lex_state = 325, .external_lex_state = 2},
  [8315] = {.lex_state = 325, .external_lex_state = 2},
  [8316] = {.lex_state = 325, .external_lex_state = 2},
  [8317] = {.lex_state = 325, .external_lex_state = 2},
  [8318] = {.lex_state = 513, .external_lex_state = 2},
  [8319] = {.lex_state = 510, .external_lex_state = 5},
  [8320] = {.lex_state = 325, .external_lex_state = 2},
  [8321] = {.lex_state = 78, .external_lex_state = 2},
  [8322] = {.lex_state = 509, .external_lex_state = 2},
  [8323] = {.lex_state = 509, .external_lex_state = 2},
  [8324] = {.lex_state = 325, .external_lex_state = 2},
  [8325] = {.lex_state = 325, .external_lex_state = 2},
  [8326] = {.lex_state = 325, .external_lex_state = 2},
  [8327] = {.lex_state = 325, .external_lex_state = 2},
  [8328] = {.lex_state = 509, .external_lex_state = 2},
  [8329] = {.lex_state = 325, .external_lex_state = 2},
  [8330] = {.lex_state = 509, .external_lex_state = 2},
  [8331] = {.lex_state = 82, .external_lex_state = 2},
  [8332] = {.lex_state = 89, .external_lex_state = 2},
  [8333] = {.lex_state = 82, .external_lex_state = 2},
  [8334] = {.lex_state = 89, .external_lex_state = 2},
  [8335] = {.lex_state = 325, .external_lex_state = 2},
  [8336] = {.lex_state = 82, .external_lex_state = 2},
  [8337] = {.lex_state = 82, .external_lex_state = 2},
  [8338] = {.lex_state = 83, .external_lex_state = 2},
  [8339] = {.lex_state = 325, .external_lex_state = 2},
  [8340] = {.lex_state = 325, .external_lex_state = 2},
  [8341] = {.lex_state = 83, .external_lex_state = 2},
  [8342] = {.lex_state = 325, .external_lex_state = 2},
  [8343] = {.lex_state = 83, .external_lex_state = 2},
  [8344] = {.lex_state = 89, .external_lex_state = 2},
  [8345] = {.lex_state = 105, .external_lex_state = 2},
  [8346] = {.lex_state = 325, .external_lex_state = 2},
  [8347] = {.lex_state = 325, .external_lex_state = 2},
  [8348] = {.lex_state = 82, .external_lex_state = 2},
  [8349] = {.lex_state = 83, .external_lex_state = 2},
  [8350] = {.lex_state = 83, .external_lex_state = 2},
  [8351] = {.lex_state = 83, .external_lex_state = 2},
  [8352] = {.lex_state = 325, .external_lex_state = 2},
  [8353] = {.lex_state = 83, .external_lex_state = 2},
  [8354] = {.lex_state = 83, .external_lex_state = 2},
  [8355] = {.lex_state = 83, .external_lex_state = 2},
  [8356] = {.lex_state = 83, .external_lex_state = 2},
  [8357] = {.lex_state = 83, .external_lex_state = 2},
  [8358] = {.lex_state = 83, .external_lex_state = 2},
  [8359] = {.lex_state = 325, .external_lex_state = 2},
  [8360] = {.lex_state = 83, .external_lex_state = 2},
  [8361] = {.lex_state = 83, .external_lex_state = 2},
  [8362] = {.lex_state = 83, .external_lex_state = 2},
  [8363] = {.lex_state = 83, .external_lex_state = 2},
  [8364] = {.lex_state = 83, .external_lex_state = 2},
  [8365] = {.lex_state = 83, .external_lex_state = 2},
  [8366] = {.lex_state = 83, .external_lex_state = 2},
  [8367] = {.lex_state = 83, .external_lex_state = 2},
  [8368] = {.lex_state = 83, .external_lex_state = 2},
  [8369] = {.lex_state = 325, .external_lex_state = 2},
  [8370] = {.lex_state = 325, .external_lex_state = 2},
  [8371] = {.lex_state = 509, .external_lex_state = 2},
  [8372] = {.lex_state = 500, .external_lex_state = 4},
  [8373] = {.lex_state = 325, .external_lex_state = 2},
  [8374] = {.lex_state = 510, .external_lex_state = 2},
  [8375] = {.lex_state = 83, .external_lex_state = 2},
  [8376] = {.lex_state = 83, .external_lex_state = 2},
  [8377] = {.lex_state = 83, .external_lex_state = 2},
  [8378] = {.lex_state = 325, .external_lex_state = 2},
  [8379] = {.lex_state = 83, .external_lex_state = 2},
  [8380] = {.lex_state = 83, .external_lex_state = 2},
  [8381] = {.lex_state = 83, .external_lex_state = 2},
  [8382] = {.lex_state = 83, .external_lex_state = 2},
  [8383] = {.lex_state = 83, .external_lex_state = 2},
  [8384] = {.lex_state = 325, .external_lex_state = 2},
  [8385] = {.lex_state = 325, .external_lex_state = 2},
  [8386] = {.lex_state = 75, .external_lex_state = 2},
  [8387] = {.lex_state = 325, .external_lex_state = 2},
  [8388] = {.lex_state = 325, .external_lex_state = 2},
  [8389] = {.lex_state = 325, .external_lex_state = 2},
  [8390] = {.lex_state = 325, .external_lex_state = 2},
  [8391] = {.lex_state = 89, .external_lex_state = 2},
  [8392] = {.lex_state = 89, .external_lex_state = 2},
  [8393] = {.lex_state = 83, .external_lex_state = 2},
  [8394] = {.lex_state = 83, .external_lex_state = 2},
  [8395] = {.lex_state = 83, .external_lex_state = 2},
  [8396] = {.lex_state = 83, .external_lex_state = 2},
  [8397] = {.lex_state = 130, .external_lex_state = 2},
  [8398] = {.lex_state = 325, .external_lex_state = 2},
  [8399] = {.lex_state = 83, .external_lex_state = 2},
  [8400] = {.lex_state = 83, .external_lex_state = 2},
  [8401] = {.lex_state = 83, .external_lex_state = 2},
  [8402] = {.lex_state = 83, .external_lex_state = 2},
  [8403] = {.lex_state = 83, .external_lex_state = 2},
  [8404] = {.lex_state = 83, .external_lex_state = 2},
  [8405] = {.lex_state = 83, .external_lex_state = 2},
  [8406] = {.lex_state = 83, .external_lex_state = 2},
  [8407] = {.lex_state = 83, .external_lex_state = 2},
  [8408] = {.lex_state = 83, .external_lex_state = 2},
  [8409] = {.lex_state = 83, .external_lex_state = 2},
  [8410] = {.lex_state = 89, .external_lex_state = 2},
  [8411] = {.lex_state = 83, .external_lex_state = 2},
  [8412] = {.lex_state = 83, .external_lex_state = 2},
  [8413] = {.lex_state = 115, .external_lex_state = 2},
  [8414] = {.lex_state = 83, .external_lex_state = 2},
  [8415] = {.lex_state = 510, .external_lex_state = 2},
  [8416] = {.lex_state = 510, .external_lex_state = 2},
  [8417] = {.lex_state = 510, .external_lex_state = 2},
  [8418] = {.lex_state = 510, .external_lex_state = 2},
  [8419] = {.lex_state = 325, .external_lex_state = 2},
  [8420] = {.lex_state = 510, .external_lex_state = 2},
  [8421] = {.lex_state = 510, .external_lex_state = 2},
  [8422] = {.lex_state = 510, .external_lex_state = 2},
  [8423] = {.lex_state = 89, .external_lex_state = 2},
  [8424] = {.lex_state = 89, .external_lex_state = 2},
  [8425] = {.lex_state = 89, .external_lex_state = 2},
  [8426] = {.lex_state = 89, .external_lex_state = 2},
  [8427] = {.lex_state = 83, .external_lex_state = 2},
  [8428] = {.lex_state = 89, .external_lex_state = 2},
  [8429] = {.lex_state = 83, .external_lex_state = 2},
  [8430] = {.lex_state = 89, .external_lex_state = 2},
  [8431] = {.lex_state = 89, .external_lex_state = 2},
  [8432] = {.lex_state = 82, .external_lex_state = 2},
  [8433] = {.lex_state = 83, .external_lex_state = 2},
  [8434] = {.lex_state = 82, .external_lex_state = 2},
  [8435] = {.lex_state = 82, .external_lex_state = 2},
  [8436] = {.lex_state = 328, .external_lex_state = 2},
  [8437] = {.lex_state = 82, .external_lex_state = 2},
  [8438] = {.lex_state = 82, .external_lex_state = 2},
  [8439] = {.lex_state = 82, .external_lex_state = 2},
  [8440] = {.lex_state = 82, .external_lex_state = 2},
  [8441] = {.lex_state = 82, .external_lex_state = 2},
  [8442] = {.lex_state = 82, .external_lex_state = 2},
  [8443] = {.lex_state = 82, .external_lex_state = 2},
  [8444] = {.lex_state = 83, .external_lex_state = 2},
  [8445] = {.lex_state = 509, .external_lex_state = 2},
  [8446] = {.lex_state = 89, .external_lex_state = 2},
  [8447] = {.lex_state = 82, .external_lex_state = 2},
  [8448] = {.lex_state = 89, .external_lex_state = 2},
  [8449] = {.lex_state = 83, .external_lex_state = 2},
  [8450] = {.lex_state = 89, .external_lex_state = 2},
  [8451] = {.lex_state = 89, .external_lex_state = 2},
  [8452] = {.lex_state = 83, .external_lex_state = 2},
  [8453] = {.lex_state = 83, .external_lex_state = 2},
  [8454] = {.lex_state = 82, .external_lex_state = 2},
  [8455] = {.lex_state = 83, .external_lex_state = 2},
  [8456] = {.lex_state = 83, .external_lex_state = 2},
  [8457] = {.lex_state = 75, .external_lex_state = 5},
  [8458] = {.lex_state = 83, .external_lex_state = 2},
  [8459] = {.lex_state = 83, .external_lex_state = 2},
  [8460] = {.lex_state = 82, .external_lex_state = 2},
  [8461] = {.lex_state = 83, .external_lex_state = 2},
  [8462] = {.lex_state = 83, .external_lex_state = 2},
  [8463] = {.lex_state = 83, .external_lex_state = 2},
  [8464] = {.lex_state = 83, .external_lex_state = 2},
  [8465] = {.lex_state = 75, .external_lex_state = 2},
  [8466] = {.lex_state = 82, .external_lex_state = 2},
  [8467] = {.lex_state = 75, .external_lex_state = 2},
  [8468] = {.lex_state = 83, .external_lex_state = 2},
  [8469] = {.lex_state = 83, .external_lex_state = 2},
  [8470] = {.lex_state = 83, .external_lex_state = 2},
  [8471] = {.lex_state = 82, .external_lex_state = 2},
  [8472] = {.lex_state = 82, .external_lex_state = 2},
  [8473] = {.lex_state = 82, .external_lex_state = 2},
  [8474] = {.lex_state = 75, .external_lex_state = 2},
  [8475] = {.lex_state = 82, .external_lex_state = 2},
  [8476] = {.lex_state = 82, .external_lex_state = 2},
  [8477] = {.lex_state = 82, .external_lex_state = 2},
  [8478] = {.lex_state = 82, .external_lex_state = 2},
  [8479] = {.lex_state = 82, .external_lex_state = 2},
  [8480] = {.lex_state = 82, .external_lex_state = 2},
  [8481] = {.lex_state = 325, .external_lex_state = 2},
  [8482] = {.lex_state = 82, .external_lex_state = 2},
  [8483] = {.lex_state = 82, .external_lex_state = 2},
  [8484] = {.lex_state = 83, .external_lex_state = 2},
  [8485] = {.lex_state = 83, .external_lex_state = 2},
  [8486] = {.lex_state = 83, .external_lex_state = 2},
  [8487] = {.lex_state = 83, .external_lex_state = 2},
  [8488] = {.lex_state = 83, .external_lex_state = 2},
  [8489] = {.lex_state = 83, .external_lex_state = 2},
  [8490] = {.lex_state = 123, .external_lex_state = 2},
  [8491] = {.lex_state = 83, .external_lex_state = 2},
  [8492] = {.lex_state = 83, .external_lex_state = 2},
  [8493] = {.lex_state = 83, .external_lex_state = 2},
  [8494] = {.lex_state = 83, .external_lex_state = 2},
  [8495] = {.lex_state = 90, .external_lex_state = 2},
  [8496] = {.lex_state = 82, .external_lex_state = 2},
  [8497] = {.lex_state = 325, .external_lex_state = 2},
  [8498] = {.lex_state = 325, .external_lex_state = 2},
  [8499] = {.lex_state = 325, .external_lex_state = 2},
  [8500] = {.lex_state = 325, .external_lex_state = 2},
  [8501] = {.lex_state = 325, .external_lex_state = 2},
  [8502] = {.lex_state = 325, .external_lex_state = 2},
  [8503] = {.lex_state = 82, .external_lex_state = 2},
  [8504] = {.lex_state = 83, .external_lex_state = 2},
  [8505] = {.lex_state = 83, .external_lex_state = 2},
  [8506] = {.lex_state = 325, .external_lex_state = 2},
  [8507] = {.lex_state = 82, .external_lex_state = 2},
  [8508] = {.lex_state = 83, .external_lex_state = 2},
  [8509] = {.lex_state = 82, .external_lex_state = 2},
  [8510] = {.lex_state = 82, .external_lex_state = 2},
  [8511] = {.lex_state = 325, .external_lex_state = 2},
  [8512] = {.lex_state = 82, .external_lex_state = 2},
  [8513] = {.lex_state = 509, .external_lex_state = 5},
  [8514] = {.lex_state = 82, .external_lex_state = 2},
  [8515] = {.lex_state = 82, .external_lex_state = 2},
  [8516] = {.lex_state = 82, .external_lex_state = 2},
  [8517] = {.lex_state = 82, .external_lex_state = 2},
  [8518] = {.lex_state = 82, .external_lex_state = 2},
  [8519] = {.lex_state = 82, .external_lex_state = 2},
  [8520] = {.lex_state = 82, .external_lex_state = 2},
  [8521] = {.lex_state = 82, .external_lex_state = 2},
  [8522] = {.lex_state = 82, .external_lex_state = 2},
  [8523] = {.lex_state = 82, .external_lex_state = 2},
  [8524] = {.lex_state = 82, .external_lex_state = 2},
  [8525] = {.lex_state = 82, .external_lex_state = 2},
  [8526] = {.lex_state = 325, .external_lex_state = 2},
  [8527] = {.lex_state = 82, .external_lex_state = 2},
  [8528] = {.lex_state = 82, .external_lex_state = 2},
  [8529] = {.lex_state = 82, .external_lex_state = 2},
  [8530] = {.lex_state = 82, .external_lex_state = 2},
  [8531] = {.lex_state = 83, .external_lex_state = 2},
  [8532] = {.lex_state = 82, .external_lex_state = 2},
  [8533] = {.lex_state = 325, .external_lex_state = 2},
  [8534] = {.lex_state = 82, .external_lex_state = 2},
  [8535] = {.lex_state = 82, .external_lex_state = 2},
  [8536] = {.lex_state = 325, .external_lex_state = 2},
  [8537] = {.lex_state = 325, .external_lex_state = 2},
  [8538] = {.lex_state = 325, .external_lex_state = 2},
  [8539] = {.lex_state = 82, .external_lex_state = 2},
  [8540] = {.lex_state = 82, .external_lex_state = 2},
  [8541] = {.lex_state = 82, .external_lex_state = 2},
  [8542] = {.lex_state = 82, .external_lex_state = 2},
  [8543] = {.lex_state = 82, .external_lex_state = 2},
  [8544] = {.lex_state = 82, .external_lex_state = 2},
  [8545] = {.lex_state = 82, .external_lex_state = 2},
  [8546] = {.lex_state = 82, .external_lex_state = 2},
  [8547] = {.lex_state = 82, .external_lex_state = 2},
  [8548] = {.lex_state = 82, .external_lex_state = 2},
  [8549] = {.lex_state = 82, .external_lex_state = 2},
  [8550] = {.lex_state = 82, .external_lex_state = 2},
  [8551] = {.lex_state = 82, .external_lex_state = 2},
  [8552] = {.lex_state = 82, .external_lex_state = 2},
  [8553] = {.lex_state = 82, .external_lex_state = 2},
  [8554] = {.lex_state = 82, .external_lex_state = 2},
  [8555] = {.lex_state = 82, .external_lex_state = 2},
  [8556] = {.lex_state = 82, .external_lex_state = 2},
  [8557] = {.lex_state = 83, .external_lex_state = 2},
  [8558] = {.lex_state = 325, .external_lex_state = 2},
  [8559] = {.lex_state = 82, .external_lex_state = 2},
  [8560] = {.lex_state = 325, .external_lex_state = 2},
  [8561] = {.lex_state = 325, .external_lex_state = 2},
  [8562] = {.lex_state = 325, .external_lex_state = 2},
  [8563] = {.lex_state = 325, .external_lex_state = 2},
  [8564] = {.lex_state = 82, .external_lex_state = 2},
  [8565] = {.lex_state = 325, .external_lex_state = 2},
  [8566] = {.lex_state = 82, .external_lex_state = 2},
  [8567] = {.lex_state = 82, .external_lex_state = 2},
  [8568] = {.lex_state = 82, .external_lex_state = 2},
  [8569] = {.lex_state = 325, .external_lex_state = 2},
  [8570] = {.lex_state = 82, .external_lex_state = 2},
  [8571] = {.lex_state = 325, .external_lex_state = 2},
  [8572] = {.lex_state = 82, .external_lex_state = 2},
  [8573] = {.lex_state = 83, .external_lex_state = 2},
  [8574] = {.lex_state = 82, .external_lex_state = 2},
  [8575] = {.lex_state = 83, .external_lex_state = 2},
  [8576] = {.lex_state = 82, .external_lex_state = 2},
  [8577] = {.lex_state = 75, .external_lex_state = 5},
  [8578] = {.lex_state = 82, .external_lex_state = 2},
  [8579] = {.lex_state = 82, .external_lex_state = 2},
  [8580] = {.lex_state = 83, .external_lex_state = 2},
  [8581] = {.lex_state = 75, .external_lex_state = 2},
  [8582] = {.lex_state = 82, .external_lex_state = 2},
  [8583] = {.lex_state = 75, .external_lex_state = 2},
  [8584] = {.lex_state = 83, .external_lex_state = 2},
  [8585] = {.lex_state = 509, .external_lex_state = 2},
  [8586] = {.lex_state = 75, .external_lex_state = 2},
  [8587] = {.lex_state = 78, .external_lex_state = 2},
  [8588] = {.lex_state = 325, .external_lex_state = 2},
  [8589] = {.lex_state = 75, .external_lex_state = 2},
  [8590] = {.lex_state = 107, .external_lex_state = 2},
  [8591] = {.lex_state = 75, .external_lex_state = 2},
  [8592] = {.lex_state = 83, .external_lex_state = 2},
  [8593] = {.lex_state = 82, .external_lex_state = 2},
  [8594] = {.lex_state = 82, .external_lex_state = 2},
  [8595] = {.lex_state = 325, .external_lex_state = 2},
  [8596] = {.lex_state = 75, .external_lex_state = 2},
  [8597] = {.lex_state = 325, .external_lex_state = 2},
  [8598] = {.lex_state = 75, .external_lex_state = 5},
  [8599] = {.lex_state = 75, .external_lex_state = 2},
  [8600] = {.lex_state = 75, .external_lex_state = 2},
  [8601] = {.lex_state = 88, .external_lex_state = 2},
  [8602] = {.lex_state = 82, .external_lex_state = 2},
  [8603] = {.lex_state = 88, .external_lex_state = 2},
  [8604] = {.lex_state = 88, .external_lex_state = 2},
  [8605] = {.lex_state = 88, .external_lex_state = 2},
  [8606] = {.lex_state = 88, .external_lex_state = 2},
  [8607] = {.lex_state = 88, .external_lex_state = 2},
  [8608] = {.lex_state = 88, .external_lex_state = 2},
  [8609] = {.lex_state = 88, .external_lex_state = 2},
  [8610] = {.lex_state = 82, .external_lex_state = 2},
  [8611] = {.lex_state = 82, .external_lex_state = 2},
  [8612] = {.lex_state = 82, .external_lex_state = 2},
  [8613] = {.lex_state = 82, .external_lex_state = 2},
  [8614] = {.lex_state = 88, .external_lex_state = 2},
  [8615] = {.lex_state = 75, .external_lex_state = 2},
  [8616] = {.lex_state = 82, .external_lex_state = 2},
  [8617] = {.lex_state = 325, .external_lex_state = 2},
  [8618] = {.lex_state = 325, .external_lex_state = 2},
  [8619] = {.lex_state = 75, .external_lex_state = 2},
  [8620] = {.lex_state = 75, .external_lex_state = 2},
  [8621] = {.lex_state = 75, .external_lex_state = 2},
  [8622] = {.lex_state = 75, .external_lex_state = 2},
  [8623] = {.lex_state = 83, .external_lex_state = 2},
  [8624] = {.lex_state = 75, .external_lex_state = 2},
  [8625] = {.lex_state = 75, .external_lex_state = 2},
  [8626] = {.lex_state = 75, .external_lex_state = 2},
  [8627] = {.lex_state = 75, .external_lex_state = 2},
  [8628] = {.lex_state = 75, .external_lex_state = 2},
  [8629] = {.lex_state = 75, .external_lex_state = 2},
  [8630] = {.lex_state = 75, .external_lex_state = 2},
  [8631] = {.lex_state = 75, .external_lex_state = 2},
  [8632] = {.lex_state = 75, .external_lex_state = 2},
  [8633] = {.lex_state = 75, .external_lex_state = 2},
  [8634] = {.lex_state = 75, .external_lex_state = 2},
  [8635] = {.lex_state = 75, .external_lex_state = 2},
  [8636] = {.lex_state = 75, .external_lex_state = 2},
  [8637] = {.lex_state = 75, .external_lex_state = 2},
  [8638] = {.lex_state = 75, .external_lex_state = 2},
  [8639] = {.lex_state = 82, .external_lex_state = 2},
  [8640] = {.lex_state = 325, .external_lex_state = 2},
  [8641] = {.lex_state = 75, .external_lex_state = 2},
  [8642] = {.lex_state = 75, .external_lex_state = 2},
  [8643] = {.lex_state = 83, .external_lex_state = 2},
  [8644] = {.lex_state = 83, .external_lex_state = 2},
  [8645] = {.lex_state = 83, .external_lex_state = 2},
  [8646] = {.lex_state = 75, .external_lex_state = 2},
  [8647] = {.lex_state = 75, .external_lex_state = 2},
  [8648] = {.lex_state = 75, .external_lex_state = 2},
  [8649] = {.lex_state = 75, .external_lex_state = 2},
  [8650] = {.lex_state = 82, .external_lex_state = 2},
  [8651] = {.lex_state = 82, .external_lex_state = 2},
  [8652] = {.lex_state = 90, .external_lex_state = 2},
  [8653] = {.lex_state = 82, .external_lex_state = 2},
  [8654] = {.lex_state = 509, .external_lex_state = 2},
  [8655] = {.lex_state = 509, .external_lex_state = 2},
  [8656] = {.lex_state = 75, .external_lex_state = 2},
  [8657] = {.lex_state = 82, .external_lex_state = 2},
  [8658] = {.lex_state = 82, .external_lex_state = 2},
  [8659] = {.lex_state = 82, .external_lex_state = 2},
  [8660] = {.lex_state = 82, .external_lex_state = 2},
  [8661] = {.lex_state = 75, .external_lex_state = 2},
  [8662] = {.lex_state = 89, .external_lex_state = 2},
  [8663] = {.lex_state = 82, .external_lex_state = 2},
  [8664] = {.lex_state = 82, .external_lex_state = 2},
  [8665] = {.lex_state = 82, .external_lex_state = 2},
  [8666] = {.lex_state = 82, .external_lex_state = 2},
  [8667] = {.lex_state = 82, .external_lex_state = 2},
  [8668] = {.lex_state = 82, .external_lex_state = 2},
  [8669] = {.lex_state = 82, .external_lex_state = 2},
  [8670] = {.lex_state = 82, .external_lex_state = 2},
  [8671] = {.lex_state = 89, .external_lex_state = 2},
  [8672] = {.lex_state = 89, .external_lex_state = 2},
  [8673] = {.lex_state = 89, .external_lex_state = 2},
  [8674] = {.lex_state = 82, .external_lex_state = 2},
  [8675] = {.lex_state = 100, .external_lex_state = 2},
  [8676] = {.lex_state = 82, .external_lex_state = 2},
  [8677] = {.lex_state = 82, .external_lex_state = 2},
  [8678] = {.lex_state = 89, .external_lex_state = 2},
  [8679] = {.lex_state = 99, .external_lex_state = 2},
  [8680] = {.lex_state = 75, .external_lex_state = 2},
  [8681] = {.lex_state = 106, .external_lex_state = 2},
  [8682] = {.lex_state = 83, .external_lex_state = 2},
  [8683] = {.lex_state = 89, .external_lex_state = 2},
  [8684] = {.lex_state = 325, .external_lex_state = 2},
  [8685] = {.lex_state = 83, .external_lex_state = 2},
  [8686] = {.lex_state = 115, .external_lex_state = 2},
  [8687] = {.lex_state = 75, .external_lex_state = 2},
  [8688] = {.lex_state = 75, .external_lex_state = 2},
  [8689] = {.lex_state = 89, .external_lex_state = 2},
  [8690] = {.lex_state = 89, .external_lex_state = 2},
  [8691] = {.lex_state = 325, .external_lex_state = 2},
  [8692] = {.lex_state = 89, .external_lex_state = 2},
  [8693] = {.lex_state = 509, .external_lex_state = 2},
  [8694] = {.lex_state = 325, .external_lex_state = 2},
  [8695] = {.lex_state = 325, .external_lex_state = 2},
  [8696] = {.lex_state = 325, .external_lex_state = 2},
  [8697] = {.lex_state = 325, .external_lex_state = 2},
  [8698] = {.lex_state = 325, .external_lex_state = 2},
  [8699] = {.lex_state = 325, .external_lex_state = 2},
  [8700] = {.lex_state = 325, .external_lex_state = 2},
  [8701] = {.lex_state = 89, .external_lex_state = 2},
  [8702] = {.lex_state = 325, .external_lex_state = 2},
  [8703] = {.lex_state = 325, .external_lex_state = 2},
  [8704] = {.lex_state = 325, .external_lex_state = 2},
  [8705] = {.lex_state = 82, .external_lex_state = 2},
  [8706] = {.lex_state = 89, .external_lex_state = 2},
  [8707] = {.lex_state = 130, .external_lex_state = 2},
  [8708] = {.lex_state = 325, .external_lex_state = 2},
  [8709] = {.lex_state = 89, .external_lex_state = 2},
  [8710] = {.lex_state = 89, .external_lex_state = 2},
  [8711] = {.lex_state = 325, .external_lex_state = 2},
  [8712] = {.lex_state = 82, .external_lex_state = 2},
  [8713] = {.lex_state = 89, .external_lex_state = 2},
  [8714] = {.lex_state = 325, .external_lex_state = 2},
  [8715] = {.lex_state = 510, .external_lex_state = 2},
  [8716] = {.lex_state = 510, .external_lex_state = 2},
  [8717] = {.lex_state = 510, .external_lex_state = 2},
  [8718] = {.lex_state = 510, .external_lex_state = 2},
  [8719] = {.lex_state = 510, .external_lex_state = 2},
  [8720] = {.lex_state = 510, .external_lex_state = 2},
  [8721] = {.lex_state = 325, .external_lex_state = 2},
  [8722] = {.lex_state = 75, .external_lex_state = 2},
  [8723] = {.lex_state = 325, .external_lex_state = 2},
  [8724] = {.lex_state = 107, .external_lex_state = 2},
  [8725] = {.lex_state = 89, .external_lex_state = 2},
  [8726] = {.lex_state = 82, .external_lex_state = 2},
  [8727] = {.lex_state = 89, .external_lex_state = 2},
  [8728] = {.lex_state = 509, .external_lex_state = 2},
  [8729] = {.lex_state = 325, .external_lex_state = 2},
  [8730] = {.lex_state = 88, .external_lex_state = 2},
  [8731] = {.lex_state = 325, .external_lex_state = 2},
  [8732] = {.lex_state = 509, .external_lex_state = 2},
  [8733] = {.lex_state = 509, .external_lex_state = 2},
  [8734] = {.lex_state = 509, .external_lex_state = 2},
  [8735] = {.lex_state = 88, .external_lex_state = 2},
  [8736] = {.lex_state = 88, .external_lex_state = 2},
  [8737] = {.lex_state = 88, .external_lex_state = 2},
  [8738] = {.lex_state = 88, .external_lex_state = 2},
  [8739] = {.lex_state = 88, .external_lex_state = 2},
  [8740] = {.lex_state = 88, .external_lex_state = 2},
  [8741] = {.lex_state = 509, .external_lex_state = 2},
  [8742] = {.lex_state = 325, .external_lex_state = 2},
  [8743] = {.lex_state = 325, .external_lex_state = 2},
  [8744] = {.lex_state = 325, .external_lex_state = 2},
  [8745] = {.lex_state = 509, .external_lex_state = 2},
  [8746] = {.lex_state = 509, .external_lex_state = 2},
  [8747] = {.lex_state = 325, .external_lex_state = 2},
  [8748] = {.lex_state = 509, .external_lex_state = 2},
  [8749] = {.lex_state = 89, .external_lex_state = 2},
  [8750] = {.lex_state = 75, .external_lex_state = 2},
  [8751] = {.lex_state = 509, .external_lex_state = 2},
  [8752] = {.lex_state = 509, .external_lex_state = 2},
  [8753] = {.lex_state = 325, .external_lex_state = 2},
  [8754] = {.lex_state = 325, .external_lex_state = 2},
  [8755] = {.lex_state = 75, .external_lex_state = 2},
  [8756] = {.lex_state = 75, .external_lex_state = 2},
  [8757] = {.lex_state = 75, .external_lex_state = 2},
  [8758] = {.lex_state = 509, .external_lex_state = 2},
  [8759] = {.lex_state = 509, .external_lex_state = 2},
  [8760] = {.lex_state = 509, .external_lex_state = 2},
  [8761] = {.lex_state = 509, .external_lex_state = 2},
  [8762] = {.lex_state = 510, .external_lex_state = 2},
  [8763] = {.lex_state = 510, .external_lex_state = 2},
  [8764] = {.lex_state = 75, .external_lex_state = 2},
  [8765] = {.lex_state = 509, .external_lex_state = 2},
  [8766] = {.lex_state = 75, .external_lex_state = 2},
  [8767] = {.lex_state = 75, .external_lex_state = 2},
  [8768] = {.lex_state = 510, .external_lex_state = 2},
  [8769] = {.lex_state = 89, .external_lex_state = 2},
  [8770] = {.lex_state = 509, .external_lex_state = 2},
  [8771] = {.lex_state = 509, .external_lex_state = 2},
  [8772] = {.lex_state = 75, .external_lex_state = 2},
  [8773] = {.lex_state = 325, .external_lex_state = 2},
  [8774] = {.lex_state = 75, .external_lex_state = 2},
  [8775] = {.lex_state = 75, .external_lex_state = 2},
  [8776] = {.lex_state = 75, .external_lex_state = 2},
  [8777] = {.lex_state = 82, .external_lex_state = 2},
  [8778] = {.lex_state = 75, .external_lex_state = 2},
  [8779] = {.lex_state = 509, .external_lex_state = 2},
  [8780] = {.lex_state = 82, .external_lex_state = 2},
  [8781] = {.lex_state = 509, .external_lex_state = 2},
  [8782] = {.lex_state = 509, .external_lex_state = 2},
  [8783] = {.lex_state = 509, .external_lex_state = 2},
  [8784] = {.lex_state = 509, .external_lex_state = 2},
  [8785] = {.lex_state = 75, .external_lex_state = 2},
  [8786] = {.lex_state = 75, .external_lex_state = 2},
  [8787] = {.lex_state = 509, .external_lex_state = 2},
  [8788] = {.lex_state = 509, .external_lex_state = 2},
  [8789] = {.lex_state = 509, .external_lex_state = 2},
  [8790] = {.lex_state = 75, .external_lex_state = 2},
  [8791] = {.lex_state = 509, .external_lex_state = 2},
  [8792] = {.lex_state = 75, .external_lex_state = 2},
  [8793] = {.lex_state = 509, .external_lex_state = 2},
  [8794] = {.lex_state = 75, .external_lex_state = 2},
  [8795] = {.lex_state = 75, .external_lex_state = 2},
  [8796] = {.lex_state = 509, .external_lex_state = 2},
  [8797] = {.lex_state = 75, .external_lex_state = 2},
  [8798] = {.lex_state = 75, .external_lex_state = 2},
  [8799] = {.lex_state = 75, .external_lex_state = 2},
  [8800] = {.lex_state = 75, .external_lex_state = 2},
  [8801] = {.lex_state = 75, .external_lex_state = 2},
  [8802] = {.lex_state = 75, .external_lex_state = 2},
  [8803] = {.lex_state = 75, .external_lex_state = 2},
  [8804] = {.lex_state = 75, .external_lex_state = 2},
  [8805] = {.lex_state = 75, .external_lex_state = 2},
  [8806] = {.lex_state = 75, .external_lex_state = 2},
  [8807] = {.lex_state = 75, .external_lex_state = 2},
  [8808] = {.lex_state = 75, .external_lex_state = 2},
  [8809] = {.lex_state = 75, .external_lex_state = 2},
  [8810] = {.lex_state = 75, .external_lex_state = 2},
  [8811] = {.lex_state = 75, .external_lex_state = 2},
  [8812] = {.lex_state = 509, .external_lex_state = 2},
  [8813] = {.lex_state = 75, .external_lex_state = 2},
  [8814] = {.lex_state = 509, .external_lex_state = 2},
  [8815] = {.lex_state = 509, .external_lex_state = 2},
  [8816] = {.lex_state = 75, .external_lex_state = 2},
  [8817] = {.lex_state = 75, .external_lex_state = 2},
  [8818] = {.lex_state = 75, .external_lex_state = 2},
  [8819] = {.lex_state = 75, .external_lex_state = 2},
  [8820] = {.lex_state = 75, .external_lex_state = 2},
  [8821] = {.lex_state = 509, .external_lex_state = 2},
  [8822] = {.lex_state = 509, .external_lex_state = 2},
  [8823] = {.lex_state = 75, .external_lex_state = 2},
  [8824] = {.lex_state = 509, .external_lex_state = 2},
  [8825] = {.lex_state = 75, .external_lex_state = 2},
  [8826] = {.lex_state = 325, .external_lex_state = 2},
  [8827] = {.lex_state = 325, .external_lex_state = 2},
  [8828] = {.lex_state = 325, .external_lex_state = 2},
  [8829] = {.lex_state = 325, .external_lex_state = 2},
  [8830] = {.lex_state = 509, .external_lex_state = 2},
  [8831] = {.lex_state = 325, .external_lex_state = 2},
  [8832] = {.lex_state = 325, .external_lex_state = 2},
  [8833] = {.lex_state = 325, .external_lex_state = 2},
  [8834] = {.lex_state = 325, .external_lex_state = 2},
  [8835] = {.lex_state = 325, .external_lex_state = 2},
  [8836] = {.lex_state = 325, .external_lex_state = 2},
  [8837] = {.lex_state = 509, .external_lex_state = 2},
  [8838] = {.lex_state = 325, .external_lex_state = 2},
  [8839] = {.lex_state = 325, .external_lex_state = 2},
  [8840] = {.lex_state = 325, .external_lex_state = 2},
  [8841] = {.lex_state = 509, .external_lex_state = 2},
  [8842] = {.lex_state = 75, .external_lex_state = 2},
  [8843] = {.lex_state = 88, .external_lex_state = 2},
  [8844] = {.lex_state = 325, .external_lex_state = 2},
  [8845] = {.lex_state = 75, .external_lex_state = 2},
  [8846] = {.lex_state = 325, .external_lex_state = 2},
  [8847] = {.lex_state = 325, .external_lex_state = 2},
  [8848] = {.lex_state = 325, .external_lex_state = 2},
  [8849] = {.lex_state = 88, .external_lex_state = 2},
  [8850] = {.lex_state = 75, .external_lex_state = 2},
  [8851] = {.lex_state = 325, .external_lex_state = 2},
  [8852] = {.lex_state = 325, .external_lex_state = 2},
  [8853] = {.lex_state = 75, .external_lex_state = 2},
  [8854] = {.lex_state = 75, .external_lex_state = 2},
  [8855] = {.lex_state = 325, .external_lex_state = 2},
  [8856] = {.lex_state = 325, .external_lex_state = 2},
  [8857] = {.lex_state = 75, .external_lex_state = 2},
  [8858] = {.lex_state = 75, .external_lex_state = 2},
  [8859] = {.lex_state = 509, .external_lex_state = 2},
  [8860] = {.lex_state = 75, .external_lex_state = 2},
  [8861] = {.lex_state = 509, .external_lex_state = 2},
  [8862] = {.lex_state = 75, .external_lex_state = 2},
  [8863] = {.lex_state = 75, .external_lex_state = 2},
  [8864] = {.lex_state = 83, .external_lex_state = 2},
  [8865] = {.lex_state = 325, .external_lex_state = 2},
  [8866] = {.lex_state = 83, .external_lex_state = 2},
  [8867] = {.lex_state = 83, .external_lex_state = 2},
  [8868] = {.lex_state = 75, .external_lex_state = 2},
  [8869] = {.lex_state = 75, .external_lex_state = 2},
  [8870] = {.lex_state = 509, .external_lex_state = 2},
  [8871] = {.lex_state = 75, .external_lex_state = 2},
  [8872] = {.lex_state = 88, .external_lex_state = 2},
  [8873] = {.lex_state = 75, .external_lex_state = 2},
  [8874] = {.lex_state = 75, .external_lex_state = 2},
  [8875] = {.lex_state = 75, .external_lex_state = 2},
  [8876] = {.lex_state = 75, .external_lex_state = 2},
  [8877] = {.lex_state = 75, .external_lex_state = 2},
  [8878] = {.lex_state = 75, .external_lex_state = 2},
  [8879] = {.lex_state = 88, .external_lex_state = 2},
  [8880] = {.lex_state = 509, .external_lex_state = 2},
  [8881] = {.lex_state = 88, .external_lex_state = 2},
  [8882] = {.lex_state = 88, .external_lex_state = 2},
  [8883] = {.lex_state = 75, .external_lex_state = 2},
  [8884] = {.lex_state = 75, .external_lex_state = 2},
  [8885] = {.lex_state = 88, .external_lex_state = 2},
  [8886] = {.lex_state = 88, .external_lex_state = 2},
  [8887] = {.lex_state = 83, .external_lex_state = 2},
  [8888] = {.lex_state = 83, .external_lex_state = 2},
  [8889] = {.lex_state = 83, .external_lex_state = 2},
  [8890] = {.lex_state = 83, .external_lex_state = 2},
  [8891] = {.lex_state = 88, .external_lex_state = 2},
  [8892] = {.lex_state = 83, .external_lex_state = 2},
  [8893] = {.lex_state = 88, .external_lex_state = 2},
  [8894] = {.lex_state = 83, .external_lex_state = 2},
  [8895] = {.lex_state = 75, .external_lex_state = 2},
  [8896] = {.lex_state = 83, .external_lex_state = 2},
  [8897] = {.lex_state = 83, .external_lex_state = 2},
  [8898] = {.lex_state = 75, .external_lex_state = 2},
  [8899] = {.lex_state = 75, .external_lex_state = 2},
  [8900] = {.lex_state = 83, .external_lex_state = 2},
  [8901] = {.lex_state = 83, .external_lex_state = 2},
  [8902] = {.lex_state = 83, .external_lex_state = 2},
  [8903] = {.lex_state = 75, .external_lex_state = 2},
  [8904] = {.lex_state = 75, .external_lex_state = 2},
  [8905] = {.lex_state = 75, .external_lex_state = 2},
  [8906] = {.lex_state = 509, .external_lex_state = 2},
  [8907] = {.lex_state = 75, .external_lex_state = 2},
  [8908] = {.lex_state = 75, .external_lex_state = 2},
  [8909] = {.lex_state = 75, .external_lex_state = 2},
  [8910] = {.lex_state = 75, .external_lex_state = 2},
  [8911] = {.lex_state = 75, .external_lex_state = 2},
  [8912] = {.lex_state = 75, .external_lex_state = 2},
  [8913] = {.lex_state = 75, .external_lex_state = 2},
  [8914] = {.lex_state = 88, .external_lex_state = 2},
  [8915] = {.lex_state = 325, .external_lex_state = 2},
  [8916] = {.lex_state = 88, .external_lex_state = 2},
  [8917] = {.lex_state = 88, .external_lex_state = 2},
  [8918] = {.lex_state = 88, .external_lex_state = 2},
  [8919] = {.lex_state = 509, .external_lex_state = 2},
  [8920] = {.lex_state = 75, .external_lex_state = 2},
  [8921] = {.lex_state = 75, .external_lex_state = 2},
  [8922] = {.lex_state = 75, .external_lex_state = 2},
  [8923] = {.lex_state = 75, .external_lex_state = 2},
  [8924] = {.lex_state = 75, .external_lex_state = 2},
  [8925] = {.lex_state = 75, .external_lex_state = 2},
  [8926] = {.lex_state = 75, .external_lex_state = 2},
  [8927] = {.lex_state = 509, .external_lex_state = 2},
  [8928] = {.lex_state = 75, .external_lex_state = 2},
  [8929] = {.lex_state = 88, .external_lex_state = 2},
  [8930] = {.lex_state = 82, .external_lex_state = 2},
  [8931] = {.lex_state = 75, .external_lex_state = 2},
  [8932] = {.lex_state = 75, .external_lex_state = 2},
  [8933] = {.lex_state = 75, .external_lex_state = 2},
  [8934] = {.lex_state = 75, .external_lex_state = 2},
  [8935] = {.lex_state = 509, .external_lex_state = 2},
  [8936] = {.lex_state = 510, .external_lex_state = 2},
  [8937] = {.lex_state = 75, .external_lex_state = 2},
  [8938] = {.lex_state = 75, .external_lex_state = 2},
  [8939] = {.lex_state = 509, .external_lex_state = 2},
  [8940] = {.lex_state = 75, .external_lex_state = 2},
  [8941] = {.lex_state = 509, .external_lex_state = 2},
  [8942] = {.lex_state = 509, .external_lex_state = 2},
  [8943] = {.lex_state = 328, .external_lex_state = 2},
  [8944] = {.lex_state = 509, .external_lex_state = 2},
  [8945] = {.lex_state = 509, .external_lex_state = 2},
  [8946] = {.lex_state = 509, .external_lex_state = 2},
  [8947] = {.lex_state = 509, .external_lex_state = 2},
  [8948] = {.lex_state = 75, .external_lex_state = 2},
  [8949] = {.lex_state = 75, .external_lex_state = 2},
  [8950] = {.lex_state = 75, .external_lex_state = 2},
  [8951] = {.lex_state = 75, .external_lex_state = 2},
  [8952] = {.lex_state = 509, .external_lex_state = 2},
  [8953] = {.lex_state = 509, .external_lex_state = 2},
  [8954] = {.lex_state = 75, .external_lex_state = 2},
  [8955] = {.lex_state = 509, .external_lex_state = 2},
  [8956] = {.lex_state = 509, .external_lex_state = 2},
  [8957] = {.lex_state = 509, .external_lex_state = 2},
  [8958] = {.lex_state = 509, .external_lex_state = 2},
  [8959] = {.lex_state = 509, .external_lex_state = 2},
  [8960] = {.lex_state = 75, .external_lex_state = 2},
  [8961] = {.lex_state = 513, .external_lex_state = 2},
  [8962] = {.lex_state = 509, .external_lex_state = 2},
  [8963] = {.lex_state = 325, .external_lex_state = 2},
  [8964] = {.lex_state = 509, .external_lex_state = 2},
  [8965] = {.lex_state = 509, .external_lex_state = 2},
  [8966] = {.lex_state = 509, .external_lex_state = 2},
  [8967] = {.lex_state = 509, .external_lex_state = 2},
  [8968] = {.lex_state = 509, .external_lex_state = 2},
  [8969] = {.lex_state = 75, .external_lex_state = 2},
  [8970] = {.lex_state = 325, .external_lex_state = 2},
  [8971] = {.lex_state = 509, .external_lex_state = 2},
  [8972] = {.lex_state = 75, .external_lex_state = 2},
  [8973] = {.lex_state = 509, .external_lex_state = 2},
  [8974] = {.lex_state = 509, .external_lex_state = 2},
  [8975] = {.lex_state = 325, .external_lex_state = 2},
  [8976] = {.lex_state = 509, .external_lex_state = 2},
  [8977] = {.lex_state = 75, .external_lex_state = 2},
  [8978] = {.lex_state = 509, .external_lex_state = 2},
  [8979] = {.lex_state = 509, .external_lex_state = 2},
  [8980] = {.lex_state = 509, .external_lex_state = 2},
  [8981] = {.lex_state = 325, .external_lex_state = 2},
  [8982] = {.lex_state = 325, .external_lex_state = 2},
  [8983] = {.lex_state = 509, .external_lex_state = 2},
  [8984] = {.lex_state = 509, .external_lex_state = 2},
  [8985] = {.lex_state = 75, .external_lex_state = 2},
  [8986] = {.lex_state = 325, .external_lex_state = 2},
  [8987] = {.lex_state = 75, .external_lex_state = 2},
  [8988] = {.lex_state = 509, .external_lex_state = 2},
  [8989] = {.lex_state = 75, .external_lex_state = 2},
  [8990] = {.lex_state = 75, .external_lex_state = 2},
  [8991] = {.lex_state = 75, .external_lex_state = 2},
  [8992] = {.lex_state = 82, .external_lex_state = 2},
  [8993] = {.lex_state = 325, .external_lex_state = 2},
  [8994] = {.lex_state = 325, .external_lex_state = 2},
  [8995] = {.lex_state = 325, .external_lex_state = 2},
  [8996] = {.lex_state = 82, .external_lex_state = 2},
  [8997] = {.lex_state = 510, .external_lex_state = 2},
  [8998] = {.lex_state = 82, .external_lex_state = 2},
  [8999] = {.lex_state = 75, .external_lex_state = 2},
  [9000] = {.lex_state = 82, .external_lex_state = 2},
  [9001] = {.lex_state = 325, .external_lex_state = 2},
  [9002] = {.lex_state = 82, .external_lex_state = 2},
  [9003] = {.lex_state = 510, .external_lex_state = 2},
  [9004] = {.lex_state = 509, .external_lex_state = 2},
  [9005] = {.lex_state = 82, .external_lex_state = 2},
  [9006] = {.lex_state = 509, .external_lex_state = 2},
  [9007] = {.lex_state = 509, .external_lex_state = 2},
  [9008] = {.lex_state = 509, .external_lex_state = 2},
  [9009] = {.lex_state = 509, .external_lex_state = 2},
  [9010] = {.lex_state = 509, .external_lex_state = 2},
  [9011] = {.lex_state = 509, .external_lex_state = 2},
  [9012] = {.lex_state = 75, .external_lex_state = 2},
  [9013] = {.lex_state = 509, .external_lex_state = 2},
  [9014] = {.lex_state = 89, .external_lex_state = 2},
  [9015] = {.lex_state = 89, .external_lex_state = 2},
  [9016] = {.lex_state = 83, .external_lex_state = 2},
  [9017] = {.lex_state = 89, .external_lex_state = 2},
  [9018] = {.lex_state = 83, .external_lex_state = 2},
  [9019] = {.lex_state = 89, .external_lex_state = 2},
  [9020] = {.lex_state = 89, .external_lex_state = 2},
  [9021] = {.lex_state = 89, .external_lex_state = 2},
  [9022] = {.lex_state = 89, .external_lex_state = 2},
  [9023] = {.lex_state = 89, .external_lex_state = 2},
  [9024] = {.lex_state = 89, .external_lex_state = 2},
  [9025] = {.lex_state = 89, .external_lex_state = 2},
  [9026] = {.lex_state = 509, .external_lex_state = 2},
  [9027] = {.lex_state = 509, .external_lex_state = 2},
  [9028] = {.lex_state = 509, .external_lex_state = 2},
  [9029] = {.lex_state = 509, .external_lex_state = 2},
  [9030] = {.lex_state = 82, .external_lex_state = 2},
  [9031] = {.lex_state = 509, .external_lex_state = 2},
  [9032] = {.lex_state = 509, .external_lex_state = 2},
  [9033] = {.lex_state = 509, .external_lex_state = 2},
  [9034] = {.lex_state = 75, .external_lex_state = 2},
  [9035] = {.lex_state = 509, .external_lex_state = 2},
  [9036] = {.lex_state = 509, .external_lex_state = 2},
  [9037] = {.lex_state = 328, .external_lex_state = 2},
  [9038] = {.lex_state = 89, .external_lex_state = 2},
  [9039] = {.lex_state = 509, .external_lex_state = 2},
  [9040] = {.lex_state = 82, .external_lex_state = 2},
  [9041] = {.lex_state = 75, .external_lex_state = 2},
  [9042] = {.lex_state = 325, .external_lex_state = 2},
  [9043] = {.lex_state = 89, .external_lex_state = 2},
  [9044] = {.lex_state = 509, .external_lex_state = 2},
  [9045] = {.lex_state = 509, .external_lex_state = 2},
  [9046] = {.lex_state = 89, .external_lex_state = 2},
  [9047] = {.lex_state = 328, .external_lex_state = 2},
  [9048] = {.lex_state = 509, .external_lex_state = 2},
  [9049] = {.lex_state = 75, .external_lex_state = 2},
  [9050] = {.lex_state = 75, .external_lex_state = 2},
  [9051] = {.lex_state = 75, .external_lex_state = 2},
  [9052] = {.lex_state = 509, .external_lex_state = 2},
  [9053] = {.lex_state = 509, .external_lex_state = 2},
  [9054] = {.lex_state = 509, .external_lex_state = 2},
  [9055] = {.lex_state = 509, .external_lex_state = 2},
  [9056] = {.lex_state = 509, .external_lex_state = 2},
  [9057] = {.lex_state = 78, .external_lex_state = 2},
  [9058] = {.lex_state = 509, .external_lex_state = 2},
  [9059] = {.lex_state = 509, .external_lex_state = 2},
  [9060] = {.lex_state = 509, .external_lex_state = 2},
  [9061] = {.lex_state = 509, .external_lex_state = 2},
  [9062] = {.lex_state = 509, .external_lex_state = 2},
  [9063] = {.lex_state = 509, .external_lex_state = 2},
  [9064] = {.lex_state = 325, .external_lex_state = 5},
  [9065] = {.lex_state = 509, .external_lex_state = 2},
  [9066] = {.lex_state = 509, .external_lex_state = 2},
  [9067] = {.lex_state = 509, .external_lex_state = 2},
  [9068] = {.lex_state = 509, .external_lex_state = 2},
  [9069] = {.lex_state = 509, .external_lex_state = 2},
  [9070] = {.lex_state = 325, .external_lex_state = 2},
  [9071] = {.lex_state = 325, .external_lex_state = 2},
  [9072] = {.lex_state = 509, .external_lex_state = 2},
  [9073] = {.lex_state = 88, .external_lex_state = 2},
  [9074] = {.lex_state = 509, .external_lex_state = 2},
  [9075] = {.lex_state = 509, .external_lex_state = 2},
  [9076] = {.lex_state = 75, .external_lex_state = 2},
  [9077] = {.lex_state = 75, .external_lex_state = 2},
  [9078] = {.lex_state = 509, .external_lex_state = 2},
  [9079] = {.lex_state = 509, .external_lex_state = 2},
  [9080] = {.lex_state = 89, .external_lex_state = 2},
  [9081] = {.lex_state = 509, .external_lex_state = 2},
  [9082] = {.lex_state = 75, .external_lex_state = 2},
  [9083] = {.lex_state = 75, .external_lex_state = 2},
  [9084] = {.lex_state = 75, .external_lex_state = 2},
  [9085] = {.lex_state = 75, .external_lex_state = 2},
  [9086] = {.lex_state = 107, .external_lex_state = 2},
  [9087] = {.lex_state = 75, .external_lex_state = 2},
  [9088] = {.lex_state = 75, .external_lex_state = 2},
  [9089] = {.lex_state = 75, .external_lex_state = 2},
  [9090] = {.lex_state = 509, .external_lex_state = 2},
  [9091] = {.lex_state = 513, .external_lex_state = 2},
  [9092] = {.lex_state = 89, .external_lex_state = 2},
  [9093] = {.lex_state = 82, .external_lex_state = 2},
  [9094] = {.lex_state = 509, .external_lex_state = 2},
  [9095] = {.lex_state = 510, .external_lex_state = 5},
  [9096] = {.lex_state = 82, .external_lex_state = 2},
  [9097] = {.lex_state = 89, .external_lex_state = 2},
  [9098] = {.lex_state = 75, .external_lex_state = 2},
  [9099] = {.lex_state = 82, .external_lex_state = 2},
  [9100] = {.lex_state = 82, .external_lex_state = 2},
  [9101] = {.lex_state = 509, .external_lex_state = 2},
  [9102] = {.lex_state = 75, .external_lex_state = 2},
  [9103] = {.lex_state = 75, .external_lex_state = 2},
  [9104] = {.lex_state = 509, .external_lex_state = 2},
  [9105] = {.lex_state = 509, .external_lex_state = 2},
  [9106] = {.lex_state = 509, .external_lex_state = 2},
  [9107] = {.lex_state = 82, .external_lex_state = 2},
  [9108] = {.lex_state = 509, .external_lex_state = 2},
  [9109] = {.lex_state = 328, .external_lex_state = 2},
  [9110] = {.lex_state = 509, .external_lex_state = 2},
  [9111] = {.lex_state = 509, .external_lex_state = 2},
  [9112] = {.lex_state = 509, .external_lex_state = 2},
  [9113] = {.lex_state = 509, .external_lex_state = 2},
  [9114] = {.lex_state = 509, .external_lex_state = 2},
  [9115] = {.lex_state = 509, .external_lex_state = 2},
  [9116] = {.lex_state = 509, .external_lex_state = 2},
  [9117] = {.lex_state = 75, .external_lex_state = 2},
  [9118] = {.lex_state = 509, .external_lex_state = 2},
  [9119] = {.lex_state = 509, .external_lex_state = 2},
  [9120] = {.lex_state = 509, .external_lex_state = 2},
  [9121] = {.lex_state = 325, .external_lex_state = 2},
  [9122] = {.lex_state = 509, .external_lex_state = 2},
  [9123] = {.lex_state = 325, .external_lex_state = 2},
  [9124] = {.lex_state = 325, .external_lex_state = 2},
  [9125] = {.lex_state = 509, .external_lex_state = 2},
  [9126] = {.lex_state = 75, .external_lex_state = 2},
  [9127] = {.lex_state = 509, .external_lex_state = 2},
  [9128] = {.lex_state = 509, .external_lex_state = 2},
  [9129] = {.lex_state = 75, .external_lex_state = 2},
  [9130] = {.lex_state = 509, .external_lex_state = 2},
  [9131] = {.lex_state = 75, .external_lex_state = 2},
  [9132] = {.lex_state = 75, .external_lex_state = 2},
  [9133] = {.lex_state = 325, .external_lex_state = 2},
  [9134] = {.lex_state = 325, .external_lex_state = 2},
  [9135] = {.lex_state = 325, .external_lex_state = 2},
  [9136] = {.lex_state = 325, .external_lex_state = 2},
  [9137] = {.lex_state = 75, .external_lex_state = 2},
  [9138] = {.lex_state = 509, .external_lex_state = 2},
  [9139] = {.lex_state = 325, .external_lex_state = 2},
  [9140] = {.lex_state = 325, .external_lex_state = 2},
  [9141] = {.lex_state = 75, .external_lex_state = 2},
  [9142] = {.lex_state = 75, .external_lex_state = 2},
  [9143] = {.lex_state = 75, .external_lex_state = 2},
  [9144] = {.lex_state = 75, .external_lex_state = 2},
  [9145] = {.lex_state = 75, .external_lex_state = 2},
  [9146] = {.lex_state = 325, .external_lex_state = 2},
  [9147] = {.lex_state = 75, .external_lex_state = 2},
  [9148] = {.lex_state = 75, .external_lex_state = 2},
  [9149] = {.lex_state = 325, .external_lex_state = 2},
  [9150] = {.lex_state = 325, .external_lex_state = 2},
  [9151] = {.lex_state = 509, .external_lex_state = 2},
  [9152] = {.lex_state = 325, .external_lex_state = 2},
  [9153] = {.lex_state = 509, .external_lex_state = 2},
  [9154] = {.lex_state = 509, .external_lex_state = 2},
  [9155] = {.lex_state = 509, .external_lex_state = 2},
  [9156] = {.lex_state = 509, .external_lex_state = 2},
  [9157] = {.lex_state = 509, .external_lex_state = 2},
  [9158] = {.lex_state = 509, .external_lex_state = 2},
  [9159] = {.lex_state = 509, .external_lex_state = 2},
  [9160] = {.lex_state = 510, .external_lex_state = 2},
  [9161] = {.lex_state = 107, .external_lex_state = 2},
  [9162] = {.lex_state = 325, .external_lex_state = 2},
  [9163] = {.lex_state = 75, .external_lex_state = 2},
  [9164] = {.lex_state = 509, .external_lex_state = 2},
  [9165] = {.lex_state = 325, .external_lex_state = 2},
  [9166] = {.lex_state = 325, .external_lex_state = 2},
  [9167] = {.lex_state = 325, .external_lex_state = 2},
  [9168] = {.lex_state = 325, .external_lex_state = 2},
  [9169] = {.lex_state = 325, .external_lex_state = 2},
  [9170] = {.lex_state = 510, .external_lex_state = 2},
  [9171] = {.lex_state = 325, .external_lex_state = 2},
  [9172] = {.lex_state = 75, .external_lex_state = 2},
  [9173] = {.lex_state = 328, .external_lex_state = 2},
  [9174] = {.lex_state = 75, .external_lex_state = 2},
  [9175] = {.lex_state = 75, .external_lex_state = 2},
  [9176] = {.lex_state = 325, .external_lex_state = 2},
  [9177] = {.lex_state = 325, .external_lex_state = 2},
  [9178] = {.lex_state = 325, .external_lex_state = 2},
  [9179] = {.lex_state = 325, .external_lex_state = 2},
  [9180] = {.lex_state = 325, .external_lex_state = 2},
  [9181] = {.lex_state = 325, .external_lex_state = 2},
  [9182] = {.lex_state = 325, .external_lex_state = 2},
  [9183] = {.lex_state = 325, .external_lex_state = 2},
  [9184] = {.lex_state = 513, .external_lex_state = 2},
  [9185] = {.lex_state = 325, .external_lex_state = 2},
  [9186] = {.lex_state = 75, .external_lex_state = 2},
  [9187] = {.lex_state = 325, .external_lex_state = 2},
  [9188] = {.lex_state = 325, .external_lex_state = 2},
  [9189] = {.lex_state = 325, .external_lex_state = 2},
  [9190] = {.lex_state = 325, .external_lex_state = 2},
  [9191] = {.lex_state = 325, .external_lex_state = 2},
  [9192] = {.lex_state = 510, .external_lex_state = 2},
  [9193] = {.lex_state = 325, .external_lex_state = 2},
  [9194] = {.lex_state = 325, .external_lex_state = 2},
  [9195] = {.lex_state = 75, .external_lex_state = 2},
  [9196] = {.lex_state = 325, .external_lex_state = 2},
  [9197] = {.lex_state = 325, .external_lex_state = 2},
  [9198] = {.lex_state = 509, .external_lex_state = 2},
  [9199] = {.lex_state = 325, .external_lex_state = 2},
  [9200] = {.lex_state = 75, .external_lex_state = 2},
  [9201] = {.lex_state = 75, .external_lex_state = 2},
  [9202] = {.lex_state = 510, .external_lex_state = 2},
  [9203] = {.lex_state = 510, .external_lex_state = 2},
  [9204] = {.lex_state = 509, .external_lex_state = 2},
  [9205] = {.lex_state = 510, .external_lex_state = 2},
  [9206] = {.lex_state = 510, .external_lex_state = 2},
  [9207] = {.lex_state = 325, .external_lex_state = 2},
  [9208] = {.lex_state = 509, .external_lex_state = 2},
  [9209] = {.lex_state = 509, .external_lex_state = 2},
  [9210] = {.lex_state = 509, .external_lex_state = 2},
  [9211] = {.lex_state = 509, .external_lex_state = 2},
  [9212] = {.lex_state = 509, .external_lex_state = 2},
  [9213] = {.lex_state = 509, .external_lex_state = 2},
  [9214] = {.lex_state = 510, .external_lex_state = 2},
  [9215] = {.lex_state = 510, .external_lex_state = 2},
  [9216] = {.lex_state = 510, .external_lex_state = 2},
  [9217] = {.lex_state = 510, .external_lex_state = 2},
  [9218] = {.lex_state = 510, .external_lex_state = 2},
  [9219] = {.lex_state = 510, .external_lex_state = 2},
  [9220] = {.lex_state = 510, .external_lex_state = 2},
  [9221] = {.lex_state = 510, .external_lex_state = 2},
  [9222] = {.lex_state = 510, .external_lex_state = 2},
  [9223] = {.lex_state = 510, .external_lex_state = 2},
  [9224] = {.lex_state = 510, .external_lex_state = 2},
  [9225] = {.lex_state = 325, .external_lex_state = 2},
  [9226] = {.lex_state = 325, .external_lex_state = 2},
  [9227] = {.lex_state = 75, .external_lex_state = 2},
  [9228] = {.lex_state = 325, .external_lex_state = 2},
  [9229] = {.lex_state = 325, .external_lex_state = 2},
  [9230] = {.lex_state = 325, .external_lex_state = 2},
  [9231] = {.lex_state = 325, .external_lex_state = 2},
  [9232] = {.lex_state = 325, .external_lex_state = 2},
  [9233] = {.lex_state = 325, .external_lex_state = 2},
  [9234] = {.lex_state = 325, .external_lex_state = 2},
  [9235] = {.lex_state = 325, .external_lex_state = 2},
  [9236] = {.lex_state = 325, .external_lex_state = 2},
  [9237] = {.lex_state = 325, .external_lex_state = 2},
  [9238] = {.lex_state = 325, .external_lex_state = 2},
  [9239] = {.lex_state = 325, .external_lex_state = 2},
  [9240] = {.lex_state = 325, .external_lex_state = 2},
  [9241] = {.lex_state = 325, .external_lex_state = 2},
  [9242] = {.lex_state = 325, .external_lex_state = 2},
  [9243] = {.lex_state = 509, .external_lex_state = 2},
  [9244] = {.lex_state = 325, .external_lex_state = 2},
  [9245] = {.lex_state = 509, .external_lex_state = 2},
  [9246] = {.lex_state = 510, .external_lex_state = 2},
  [9247] = {.lex_state = 195, .external_lex_state = 4},
  [9248] = {.lex_state = 509, .external_lex_state = 2},
  [9249] = {.lex_state = 509, .external_lex_state = 2},
  [9250] = {.lex_state = 325, .external_lex_state = 2},
  [9251] = {.lex_state = 509, .external_lex_state = 2},
  [9252] = {.lex_state = 195, .external_lex_state = 4},
  [9253] = {.lex_state = 325, .external_lex_state = 2},
  [9254] = {.lex_state = 325, .external_lex_state = 2},
  [9255] = {.lex_state = 195, .external_lex_state = 4},
  [9256] = {.lex_state = 509, .external_lex_state = 2},
  [9257] = {.lex_state = 325, .external_lex_state = 2},
  [9258] = {.lex_state = 325, .external_lex_state = 2},
  [9259] = {.lex_state = 195, .external_lex_state = 4},
  [9260] = {.lex_state = 197, .external_lex_state = 3},
  [9261] = {.lex_state = 325, .external_lex_state = 2},
  [9262] = {.lex_state = 325, .external_lex_state = 2},
  [9263] = {.lex_state = 510, .external_lex_state = 2},
  [9264] = {.lex_state = 510, .external_lex_state = 2},
  [9265] = {.lex_state = 325, .external_lex_state = 2},
  [9266] = {.lex_state = 510, .external_lex_state = 2},
  [9267] = {.lex_state = 510, .external_lex_state = 2},
  [9268] = {.lex_state = 510, .external_lex_state = 2},
  [9269] = {.lex_state = 510, .external_lex_state = 2},
  [9270] = {.lex_state = 510, .external_lex_state = 2},
  [9271] = {.lex_state = 509, .external_lex_state = 2},
  [9272] = {.lex_state = 325, .external_lex_state = 2},
  [9273] = {.lex_state = 509, .external_lex_state = 2},
  [9274] = {.lex_state = 325, .external_lex_state = 2},
  [9275] = {.lex_state = 510, .external_lex_state = 2},
  [9276] = {.lex_state = 510, .external_lex_state = 2},
  [9277] = {.lex_state = 510, .external_lex_state = 2},
  [9278] = {.lex_state = 509, .external_lex_state = 2},
  [9279] = {.lex_state = 197, .external_lex_state = 4},
  [9280] = {.lex_state = 197, .external_lex_state = 3},
  [9281] = {.lex_state = 510, .external_lex_state = 2},
  [9282] = {.lex_state = 510, .external_lex_state = 2},
  [9283] = {.lex_state = 325, .external_lex_state = 2},
  [9284] = {.lex_state = 325, .external_lex_state = 2},
  [9285] = {.lex_state = 325, .external_lex_state = 2},
  [9286] = {.lex_state = 325, .external_lex_state = 2},
  [9287] = {.lex_state = 197, .external_lex_state = 3},
  [9288] = {.lex_state = 509, .external_lex_state = 2},
  [9289] = {.lex_state = 509, .external_lex_state = 2},
  [9290] = {.lex_state = 509, .external_lex_state = 2},
  [9291] = {.lex_state = 510, .external_lex_state = 2},
  [9292] = {.lex_state = 510, .external_lex_state = 2},
  [9293] = {.lex_state = 510, .external_lex_state = 2},
  [9294] = {.lex_state = 509, .external_lex_state = 2},
  [9295] = {.lex_state = 509, .external_lex_state = 2},
  [9296] = {.lex_state = 197, .external_lex_state = 3},
  [9297] = {.lex_state = 510, .external_lex_state = 2},
  [9298] = {.lex_state = 325, .external_lex_state = 2},
  [9299] = {.lex_state = 509, .external_lex_state = 2},
  [9300] = {.lex_state = 509, .external_lex_state = 2},
  [9301] = {.lex_state = 314, .external_lex_state = 4},
  [9302] = {.lex_state = 509, .external_lex_state = 2},
  [9303] = {.lex_state = 197, .external_lex_state = 3},
  [9304] = {.lex_state = 509, .external_lex_state = 2},
  [9305] = {.lex_state = 510, .external_lex_state = 2},
  [9306] = {.lex_state = 325, .external_lex_state = 2},
  [9307] = {.lex_state = 195, .external_lex_state = 4},
  [9308] = {.lex_state = 195, .external_lex_state = 4},
  [9309] = {.lex_state = 194, .external_lex_state = 3},
  [9310] = {.lex_state = 75, .external_lex_state = 2},
  [9311] = {.lex_state = 195, .external_lex_state = 4},
  [9312] = {.lex_state = 196, .external_lex_state = 4},
  [9313] = {.lex_state = 194, .external_lex_state = 3},
  [9314] = {.lex_state = 196, .external_lex_state = 4},
  [9315] = {.lex_state = 196, .external_lex_state = 4},
  [9316] = {.lex_state = 196, .external_lex_state = 4},
  [9317] = {.lex_state = 195, .external_lex_state = 4},
  [9318] = {.lex_state = 194, .external_lex_state = 3},
  [9319] = {.lex_state = 194, .external_lex_state = 3},
  [9320] = {.lex_state = 195, .external_lex_state = 4},
  [9321] = {.lex_state = 198, .external_lex_state = 4},
  [9322] = {.lex_state = 197, .external_lex_state = 4},
  [9323] = {.lex_state = 197, .external_lex_state = 4},
  [9324] = {.lex_state = 197, .external_lex_state = 4},
  [9325] = {.lex_state = 197, .external_lex_state = 4},
  [9326] = {.lex_state = 194, .external_lex_state = 3},
  [9327] = {.lex_state = 194, .external_lex_state = 3},
  [9328] = {.lex_state = 195, .external_lex_state = 4},
  [9329] = {.lex_state = 175, .external_lex_state = 2},
  [9330] = {.lex_state = 172, .external_lex_state = 2},
  [9331] = {.lex_state = 195, .external_lex_state = 4},
  [9332] = {.lex_state = 195, .external_lex_state = 4},
  [9333] = {.lex_state = 195, .external_lex_state = 4},
  [9334] = {.lex_state = 195, .external_lex_state = 4},
  [9335] = {.lex_state = 510, .external_lex_state = 2},
  [9336] = {.lex_state = 195, .external_lex_state = 4},
  [9337] = {.lex_state = 195, .external_lex_state = 4},
  [9338] = {.lex_state = 197, .external_lex_state = 4},
  [9339] = {.lex_state = 197, .external_lex_state = 4},
  [9340] = {.lex_state = 197, .external_lex_state = 4},
  [9341] = {.lex_state = 199, .external_lex_state = 4},
  [9342] = {.lex_state = 197, .external_lex_state = 4},
  [9343] = {.lex_state = 197, .external_lex_state = 4},
  [9344] = {.lex_state = 197, .external_lex_state = 4},
  [9345] = {.lex_state = 194, .external_lex_state = 4},
  [9346] = {.lex_state = 194, .external_lex_state = 4},
  [9347] = {.lex_state = 197, .external_lex_state = 4},
  [9348] = {.lex_state = 197, .external_lex_state = 4},
  [9349] = {.lex_state = 197, .external_lex_state = 4},
  [9350] = {.lex_state = 197, .external_lex_state = 4},
  [9351] = {.lex_state = 197, .external_lex_state = 4},
  [9352] = {.lex_state = 197, .external_lex_state = 4},
  [9353] = {.lex_state = 194, .external_lex_state = 4},
  [9354] = {.lex_state = 197, .external_lex_state = 4},
  [9355] = {.lex_state = 194, .external_lex_state = 4},
  [9356] = {.lex_state = 197, .external_lex_state = 4},
  [9357] = {.lex_state = 196, .external_lex_state = 4},
  [9358] = {.lex_state = 196, .external_lex_state = 4},
  [9359] = {.lex_state = 197, .external_lex_state = 4},
  [9360] = {.lex_state = 196, .external_lex_state = 4},
  [9361] = {.lex_state = 197, .external_lex_state = 4},
  [9362] = {.lex_state = 197, .external_lex_state = 4},
  [9363] = {.lex_state = 197, .external_lex_state = 4},
  [9364] = {.lex_state = 171, .external_lex_state = 2},
  [9365] = {.lex_state = 197, .external_lex_state = 4},
  [9366] = {.lex_state = 197, .external_lex_state = 4},
  [9367] = {.lex_state = 197, .external_lex_state = 4},
  [9368] = {.lex_state = 197, .external_lex_state = 4},
  [9369] = {.lex_state = 337, .external_lex_state = 2},
  [9370] = {.lex_state = 196, .external_lex_state = 4},
  [9371] = {.lex_state = 197, .external_lex_state = 4},
  [9372] = {.lex_state = 197, .external_lex_state = 4},
  [9373] = {.lex_state = 196, .external_lex_state = 4},
  [9374] = {.lex_state = 196, .external_lex_state = 4},
  [9375] = {.lex_state = 197, .external_lex_state = 4},
  [9376] = {.lex_state = 197, .external_lex_state = 4},
  [9377] = {.lex_state = 197, .external_lex_state = 4},
  [9378] = {.lex_state = 197, .external_lex_state = 4},
  [9379] = {.lex_state = 197, .external_lex_state = 4},
  [9380] = {.lex_state = 173, .external_lex_state = 2},
  [9381] = {.lex_state = 196, .external_lex_state = 4},
  [9382] = {.lex_state = 197, .external_lex_state = 4},
  [9383] = {.lex_state = 197, .external_lex_state = 4},
  [9384] = {.lex_state = 197, .external_lex_state = 4},
  [9385] = {.lex_state = 197, .external_lex_state = 4},
  [9386] = {.lex_state = 197, .external_lex_state = 4},
  [9387] = {.lex_state = 197, .external_lex_state = 4},
  [9388] = {.lex_state = 197, .external_lex_state = 4},
  [9389] = {.lex_state = 197, .external_lex_state = 4},
  [9390] = {.lex_state = 196, .external_lex_state = 4},
  [9391] = {.lex_state = 197, .external_lex_state = 4},
  [9392] = {.lex_state = 197, .external_lex_state = 4},
  [9393] = {.lex_state = 197, .external_lex_state = 4},
  [9394] = {.lex_state = 197, .external_lex_state = 4},
  [9395] = {.lex_state = 197, .external_lex_state = 4},
  [9396] = {.lex_state = 197, .external_lex_state = 4},
  [9397] = {.lex_state = 197, .external_lex_state = 4},
  [9398] = {.lex_state = 197, .external_lex_state = 4},
  [9399] = {.lex_state = 197, .external_lex_state = 4},
  [9400] = {.lex_state = 197, .external_lex_state = 4},
  [9401] = {.lex_state = 197, .external_lex_state = 4},
  [9402] = {.lex_state = 196, .external_lex_state = 4},
  [9403] = {.lex_state = 196, .external_lex_state = 4},
  [9404] = {.lex_state = 197, .external_lex_state = 4},
  [9405] = {.lex_state = 196, .external_lex_state = 4},
  [9406] = {.lex_state = 197, .external_lex_state = 4},
  [9407] = {.lex_state = 197, .external_lex_state = 4},
  [9408] = {.lex_state = 197, .external_lex_state = 4},
  [9409] = {.lex_state = 170, .external_lex_state = 2},
  [9410] = {.lex_state = 197, .external_lex_state = 4},
  [9411] = {.lex_state = 196, .external_lex_state = 4},
  [9412] = {.lex_state = 197, .external_lex_state = 4},
  [9413] = {.lex_state = 197, .external_lex_state = 4},
  [9414] = {.lex_state = 197, .external_lex_state = 4},
  [9415] = {.lex_state = 197, .external_lex_state = 4},
  [9416] = {.lex_state = 197, .external_lex_state = 4},
  [9417] = {.lex_state = 197, .external_lex_state = 4},
  [9418] = {.lex_state = 197, .external_lex_state = 4},
  [9419] = {.lex_state = 197, .external_lex_state = 4},
  [9420] = {.lex_state = 194, .external_lex_state = 4},
  [9421] = {.lex_state = 194, .external_lex_state = 4},
  [9422] = {.lex_state = 194, .external_lex_state = 4},
  [9423] = {.lex_state = 194, .external_lex_state = 4},
  [9424] = {.lex_state = 194, .external_lex_state = 4},
  [9425] = {.lex_state = 194, .external_lex_state = 4},
  [9426] = {.lex_state = 194, .external_lex_state = 4},
  [9427] = {.lex_state = 194, .external_lex_state = 4},
  [9428] = {.lex_state = 194, .external_lex_state = 4},
  [9429] = {.lex_state = 194, .external_lex_state = 4},
  [9430] = {.lex_state = 194, .external_lex_state = 4},
  [9431] = {.lex_state = 194, .external_lex_state = 4},
  [9432] = {.lex_state = 194, .external_lex_state = 4},
  [9433] = {.lex_state = 194, .external_lex_state = 4},
  [9434] = {.lex_state = 194, .external_lex_state = 4},
  [9435] = {.lex_state = 194, .external_lex_state = 4},
  [9436] = {.lex_state = 194, .external_lex_state = 4},
  [9437] = {.lex_state = 338, .external_lex_state = 2},
  [9438] = {.lex_state = 194, .external_lex_state = 4},
  [9439] = {.lex_state = 194, .external_lex_state = 4},
  [9440] = {.lex_state = 194, .external_lex_state = 4},
  [9441] = {.lex_state = 194, .external_lex_state = 4},
  [9442] = {.lex_state = 194, .external_lex_state = 4},
  [9443] = {.lex_state = 194, .external_lex_state = 4},
  [9444] = {.lex_state = 194, .external_lex_state = 4},
  [9445] = {.lex_state = 194, .external_lex_state = 4},
  [9446] = {.lex_state = 194, .external_lex_state = 4},
  [9447] = {.lex_state = 194, .external_lex_state = 4},
  [9448] = {.lex_state = 194, .external_lex_state = 4},
  [9449] = {.lex_state = 194, .external_lex_state = 4},
  [9450] = {.lex_state = 194, .external_lex_state = 4},
  [9451] = {.lex_state = 174, .external_lex_state = 2},
  [9452] = {.lex_state = 194, .external_lex_state = 4},
  [9453] = {.lex_state = 194, .external_lex_state = 4},
  [9454] = {.lex_state = 194, .external_lex_state = 4},
  [9455] = {.lex_state = 194, .external_lex_state = 4},
  [9456] = {.lex_state = 194, .external_lex_state = 4},
  [9457] = {.lex_state = 194, .external_lex_state = 4},
  [9458] = {.lex_state = 194, .external_lex_state = 4},
  [9459] = {.lex_state = 194, .external_lex_state = 4},
  [9460] = {.lex_state = 194, .external_lex_state = 4},
  [9461] = {.lex_state = 194, .external_lex_state = 4},
  [9462] = {.lex_state = 194, .external_lex_state = 4},
  [9463] = {.lex_state = 194, .external_lex_state = 4},
  [9464] = {.lex_state = 194, .external_lex_state = 4},
  [9465] = {.lex_state = 194, .external_lex_state = 4},
  [9466] = {.lex_state = 194, .external_lex_state = 4},
  [9467] = {.lex_state = 525, .external_lex_state = 2},
  [9468] = {.lex_state = 194, .external_lex_state = 4},
  [9469] = {.lex_state = 194, .external_lex_state = 4},
  [9470] = {.lex_state = 194, .external_lex_state = 4},
  [9471] = {.lex_state = 194, .external_lex_state = 4},
  [9472] = {.lex_state = 194, .external_lex_state = 4},
  [9473] = {.lex_state = 194, .external_lex_state = 4},
  [9474] = {.lex_state = 194, .external_lex_state = 4},
  [9475] = {.lex_state = 194, .external_lex_state = 4},
  [9476] = {.lex_state = 194, .external_lex_state = 4},
  [9477] = {.lex_state = 200, .external_lex_state = 2},
  [9478] = {.lex_state = 200, .external_lex_state = 2},
  [9479] = {.lex_state = 200, .external_lex_state = 2},
  [9480] = {.lex_state = 200, .external_lex_state = 2},
  [9481] = {.lex_state = 200, .external_lex_state = 2},
  [9482] = {.lex_state = 200, .external_lex_state = 2},
  [9483] = {.lex_state = 200, .external_lex_state = 2},
  [9484] = {.lex_state = 200, .external_lex_state = 2},
  [9485] = {.lex_state = 200, .external_lex_state = 2},
  [9486] = {.lex_state = 200, .external_lex_state = 2},
  [9487] = {.lex_state = 200, .external_lex_state = 2},
  [9488] = {.lex_state = 200, .external_lex_state = 2},
  [9489] = {.lex_state = 200, .external_lex_state = 2},
  [9490] = {.lex_state = 200, .external_lex_state = 2},
  [9491] = {.lex_state = 200, .external_lex_state = 2},
  [9492] = {.lex_state = 200, .external_lex_state = 2},
  [9493] = {.lex_state = 200, .external_lex_state = 2},
  [9494] = {.lex_state = 200, .external_lex_state = 2},
  [9495] = {.lex_state = 200, .external_lex_state = 2},
  [9496] = {.lex_state = 200, .external_lex_state = 2},
  [9497] = {.lex_state = 200, .external_lex_state = 2},
  [9498] = {.lex_state = 200, .external_lex_state = 2},
  [9499] = {.lex_state = 200, .external_lex_state = 2},
  [9500] = {.lex_state = 200, .external_lex_state = 2},
  [9501] = {.lex_state = 200, .external_lex_state = 2},
  [9502] = {.lex_state = 200, .external_lex_state = 2},
  [9503] = {.lex_state = 200, .external_lex_state = 2},
  [9504] = {.lex_state = 200, .external_lex_state = 2},
  [9505] = {.lex_state = 200, .external_lex_state = 2},
  [9506] = {.lex_state = 200, .external_lex_state = 2},
  [9507] = {.lex_state = 200, .external_lex_state = 2},
  [9508] = {.lex_state = 200, .external_lex_state = 2},
  [9509] = {.lex_state = 200, .external_lex_state = 2},
  [9510] = {.lex_state = 200, .external_lex_state = 2},
  [9511] = {.lex_state = 200, .external_lex_state = 2},
  [9512] = {.lex_state = 200, .external_lex_state = 2},
  [9513] = {.lex_state = 200, .external_lex_state = 2},
  [9514] = {.lex_state = 200, .external_lex_state = 2},
  [9515] = {.lex_state = 200, .external_lex_state = 2},
  [9516] = {.lex_state = 210, .external_lex_state = 8},
  [9517] = {.lex_state = 200, .external_lex_state = 2},
  [9518] = {.lex_state = 200, .external_lex_state = 2},
  [9519] = {.lex_state = 200, .external_lex_state = 2},
  [9520] = {.lex_state = 200, .external_lex_state = 2},
  [9521] = {.lex_state = 210, .external_lex_state = 8},
  [9522] = {.lex_state = 200, .external_lex_state = 2},
  [9523] = {.lex_state = 200, .external_lex_state = 2},
  [9524] = {.lex_state = 200, .external_lex_state = 2},
  [9525] = {.lex_state = 200, .external_lex_state = 2},
  [9526] = {.lex_state = 200, .external_lex_state = 2},
  [9527] = {.lex_state = 200, .external_lex_state = 2},
  [9528] = {.lex_state = 200, .external_lex_state = 2},
  [9529] = {.lex_state = 200, .external_lex_state = 2},
  [9530] = {.lex_state = 200, .external_lex_state = 2},
  [9531] = {.lex_state = 200, .external_lex_state = 2},
  [9532] = {.lex_state = 200, .external_lex_state = 2},
  [9533] = {.lex_state = 200, .external_lex_state = 2},
  [9534] = {.lex_state = 200, .external_lex_state = 2},
  [9535] = {.lex_state = 200, .external_lex_state = 2},
  [9536] = {.lex_state = 200, .external_lex_state = 2},
  [9537] = {.lex_state = 200, .external_lex_state = 2},
  [9538] = {.lex_state = 200, .external_lex_state = 2},
  [9539] = {.lex_state = 200, .external_lex_state = 2},
  [9540] = {.lex_state = 200, .external_lex_state = 2},
  [9541] = {.lex_state = 200, .external_lex_state = 2},
  [9542] = {.lex_state = 200, .external_lex_state = 2},
  [9543] = {.lex_state = 200, .external_lex_state = 2},
  [9544] = {.lex_state = 200, .external_lex_state = 2},
  [9545] = {.lex_state = 200, .external_lex_state = 2},
  [9546] = {.lex_state = 200, .external_lex_state = 2},
  [9547] = {.lex_state = 200, .external_lex_state = 2},
  [9548] = {.lex_state = 200, .external_lex_state = 2},
  [9549] = {.lex_state = 212, .external_lex_state = 6},
  [9550] = {.lex_state = 197, .external_lex_state = 2},
  [9551] = {.lex_state = 210, .external_lex_state = 6},
  [9552] = {.lex_state = 210, .external_lex_state = 6},
  [9553] = {.lex_state = 210, .external_lex_state = 6},
  [9554] = {.lex_state = 210, .external_lex_state = 6},
  [9555] = {.lex_state = 210, .external_lex_state = 6},
  [9556] = {.lex_state = 210, .external_lex_state = 6},
  [9557] = {.lex_state = 210, .external_lex_state = 6},
  [9558] = {.lex_state = 210, .external_lex_state = 6},
  [9559] = {.lex_state = 210, .external_lex_state = 6},
  [9560] = {.lex_state = 210, .external_lex_state = 6},
  [9561] = {.lex_state = 210, .external_lex_state = 6},
  [9562] = {.lex_state = 210, .external_lex_state = 6},
  [9563] = {.lex_state = 210, .external_lex_state = 6},
  [9564] = {.lex_state = 210, .external_lex_state = 6},
  [9565] = {.lex_state = 197, .external_lex_state = 2},
  [9566] = {.lex_state = 210, .external_lex_state = 6},
  [9567] = {.lex_state = 210, .external_lex_state = 6},
  [9568] = {.lex_state = 210, .external_lex_state = 6},
  [9569] = {.lex_state = 210, .external_lex_state = 6},
  [9570] = {.lex_state = 210, .external_lex_state = 6},
  [9571] = {.lex_state = 194, .external_lex_state = 7},
  [9572] = {.lex_state = 210, .external_lex_state = 6},
  [9573] = {.lex_state = 210, .external_lex_state = 6},
  [9574] = {.lex_state = 210, .external_lex_state = 6},
  [9575] = {.lex_state = 337, .external_lex_state = 2},
  [9576] = {.lex_state = 210, .external_lex_state = 6},
  [9577] = {.lex_state = 210, .external_lex_state = 6},
  [9578] = {.lex_state = 210, .external_lex_state = 6},
  [9579] = {.lex_state = 210, .external_lex_state = 6},
  [9580] = {.lex_state = 210, .external_lex_state = 6},
  [9581] = {.lex_state = 210, .external_lex_state = 6},
  [9582] = {.lex_state = 210, .external_lex_state = 6},
  [9583] = {.lex_state = 210, .external_lex_state = 6},
  [9584] = {.lex_state = 210, .external_lex_state = 6},
  [9585] = {.lex_state = 210, .external_lex_state = 6},
  [9586] = {.lex_state = 210, .external_lex_state = 6},
  [9587] = {.lex_state = 194, .external_lex_state = 2},
  [9588] = {.lex_state = 210, .external_lex_state = 6},
  [9589] = {.lex_state = 210, .external_lex_state = 6},
  [9590] = {.lex_state = 210, .external_lex_state = 6},
  [9591] = {.lex_state = 210, .external_lex_state = 6},
  [9592] = {.lex_state = 210, .external_lex_state = 6},
  [9593] = {.lex_state = 210, .external_lex_state = 6},
  [9594] = {.lex_state = 194, .external_lex_state = 7},
  [9595] = {.lex_state = 210, .external_lex_state = 6},
  [9596] = {.lex_state = 210, .external_lex_state = 6},
  [9597] = {.lex_state = 210, .external_lex_state = 2},
  [9598] = {.lex_state = 194, .external_lex_state = 2},
  [9599] = {.lex_state = 194, .external_lex_state = 2},
  [9600] = {.lex_state = 197, .external_lex_state = 2},
  [9601] = {.lex_state = 210, .external_lex_state = 2},
  [9602] = {.lex_state = 211, .external_lex_state = 2},
  [9603] = {.lex_state = 197, .external_lex_state = 2},
  [9604] = {.lex_state = 210, .external_lex_state = 2},
  [9605] = {.lex_state = 197, .external_lex_state = 2},
  [9606] = {.lex_state = 197, .external_lex_state = 2},
  [9607] = {.lex_state = 197, .external_lex_state = 2},
  [9608] = {.lex_state = 197, .external_lex_state = 2},
  [9609] = {.lex_state = 194, .external_lex_state = 2},
  [9610] = {.lex_state = 194, .external_lex_state = 2},
  [9611] = {.lex_state = 197, .external_lex_state = 2},
  [9612] = {.lex_state = 197, .external_lex_state = 2},
  [9613] = {.lex_state = 197, .external_lex_state = 2},
  [9614] = {.lex_state = 200, .external_lex_state = 2},
  [9615] = {.lex_state = 194, .external_lex_state = 2},
  [9616] = {.lex_state = 197, .external_lex_state = 2},
  [9617] = {.lex_state = 210, .external_lex_state = 2},
  [9618] = {.lex_state = 194, .external_lex_state = 2},
  [9619] = {.lex_state = 194, .external_lex_state = 2},
  [9620] = {.lex_state = 194, .external_lex_state = 2},
  [9621] = {.lex_state = 194, .external_lex_state = 2},
  [9622] = {.lex_state = 194, .external_lex_state = 2},
  [9623] = {.lex_state = 194, .external_lex_state = 2},
  [9624] = {.lex_state = 194, .external_lex_state = 2},
  [9625] = {.lex_state = 194, .external_lex_state = 2},
  [9626] = {.lex_state = 194, .external_lex_state = 2},
  [9627] = {.lex_state = 194, .external_lex_state = 2},
  [9628] = {.lex_state = 194, .external_lex_state = 2},
  [9629] = {.lex_state = 194, .external_lex_state = 2},
  [9630] = {.lex_state = 194, .external_lex_state = 2},
  [9631] = {.lex_state = 194, .external_lex_state = 2},
  [9632] = {.lex_state = 194, .external_lex_state = 2},
  [9633] = {.lex_state = 194, .external_lex_state = 2},
  [9634] = {.lex_state = 194, .external_lex_state = 2},
  [9635] = {.lex_state = 194, .external_lex_state = 2},
  [9636] = {.lex_state = 194, .external_lex_state = 2},
  [9637] = {.lex_state = 194, .external_lex_state = 2},
  [9638] = {.lex_state = 194, .external_lex_state = 2},
  [9639] = {.lex_state = 194, .external_lex_state = 2},
  [9640] = {.lex_state = 194, .external_lex_state = 2},
  [9641] = {.lex_state = 194, .external_lex_state = 2},
  [9642] = {.lex_state = 194, .external_lex_state = 2},
  [9643] = {.lex_state = 194, .external_lex_state = 2},
  [9644] = {.lex_state = 194, .external_lex_state = 2},
  [9645] = {.lex_state = 194, .external_lex_state = 2},
  [9646] = {.lex_state = 194, .external_lex_state = 2},
  [9647] = {.lex_state = 194, .external_lex_state = 2},
  [9648] = {.lex_state = 194, .external_lex_state = 2},
  [9649] = {.lex_state = 194, .external_lex_state = 2},
  [9650] = {.lex_state = 194, .external_lex_state = 2},
  [9651] = {.lex_state = 194, .external_lex_state = 2},
  [9652] = {.lex_state = 194, .external_lex_state = 2},
  [9653] = {.lex_state = 194, .external_lex_state = 2},
  [9654] = {.lex_state = 194, .external_lex_state = 2},
  [9655] = {.lex_state = 194, .external_lex_state = 2},
  [9656] = {.lex_state = 194, .external_lex_state = 2},
  [9657] = {.lex_state = 348, .external_lex_state = 2},
  [9658] = {.lex_state = 348, .external_lex_state = 2},
  [9659] = {.lex_state = 348, .external_lex_state = 2},
  [9660] = {.lex_state = 351, .external_lex_state = 4},
  [9661] = {.lex_state = 220, .external_lex_state = 4},
  [9662] = {.lex_state = 217, .external_lex_state = 4},
  [9663] = {.lex_state = 213, .external_lex_state = 4},
  [9664] = {.lex_state = 213, .external_lex_state = 4},
  [9665] = {.lex_state = 219, .external_lex_state = 4},
  [9666] = {.lex_state = 215, .external_lex_state = 4},
  [9667] = {.lex_state = 216, .external_lex_state = 4},
  [9668] = {.lex_state = 343, .external_lex_state = 2},
  [9669] = {.lex_state = 352, .external_lex_state = 4},
  [9670] = {.lex_state = 343, .external_lex_state = 2},
  [9671] = {.lex_state = 218, .external_lex_state = 4},
  [9672] = {.lex_state = 343, .external_lex_state = 2},
  [9673] = {.lex_state = 343, .external_lex_state = 2},
  [9674] = {.lex_state = 343, .external_lex_state = 2},
  [9675] = {.lex_state = 343, .external_lex_state = 2},
  [9676] = {.lex_state = 343, .external_lex_state = 2},
  [9677] = {.lex_state = 527, .external_lex_state = 4},
  [9678] = {.lex_state = 343, .external_lex_state = 2},
  [9679] = {.lex_state = 343, .external_lex_state = 2},
  [9680] = {.lex_state = 343, .external_lex_state = 2},
  [9681] = {.lex_state = 343, .external_lex_state = 2},
  [9682] = {.lex_state = 343, .external_lex_state = 2},
  [9683] = {.lex_state = 343, .external_lex_state = 2},
  [9684] = {.lex_state = 343, .external_lex_state = 2},
  [9685] = {.lex_state = 343, .external_lex_state = 2},
  [9686] = {.lex_state = 343, .external_lex_state = 2},
  [9687] = {.lex_state = 343, .external_lex_state = 2},
  [9688] = {.lex_state = 343, .external_lex_state = 2},
  [9689] = {.lex_state = 343, .external_lex_state = 2},
  [9690] = {.lex_state = 343, .external_lex_state = 2},
  [9691] = {.lex_state = 343, .external_lex_state = 2},
  [9692] = {.lex_state = 343, .external_lex_state = 2},
  [9693] = {.lex_state = 343, .external_lex_state = 2},
  [9694] = {.lex_state = 343, .external_lex_state = 2},
  [9695] = {.lex_state = 343, .external_lex_state = 2},
  [9696] = {.lex_state = 343, .external_lex_state = 2},
  [9697] = {.lex_state = 343, .external_lex_state = 2},
  [9698] = {.lex_state = 343, .external_lex_state = 2},
  [9699] = {.lex_state = 343, .external_lex_state = 2},
  [9700] = {.lex_state = 343, .external_lex_state = 2},
  [9701] = {.lex_state = 343, .external_lex_state = 2},
  [9702] = {.lex_state = 343, .external_lex_state = 2},
  [9703] = {.lex_state = 343, .external_lex_state = 2},
  [9704] = {.lex_state = 343, .external_lex_state = 2},
  [9705] = {.lex_state = 343, .external_lex_state = 2},
  [9706] = {.lex_state = 343, .external_lex_state = 2},
  [9707] = {.lex_state = 343, .external_lex_state = 2},
  [9708] = {.lex_state = 343, .external_lex_state = 2},
  [9709] = {.lex_state = 343, .external_lex_state = 2},
  [9710] = {.lex_state = 343, .external_lex_state = 2},
  [9711] = {.lex_state = 343, .external_lex_state = 2},
  [9712] = {.lex_state = 343, .external_lex_state = 2},
  [9713] = {.lex_state = 343, .external_lex_state = 2},
  [9714] = {.lex_state = 343, .external_lex_state = 2},
  [9715] = {.lex_state = 343, .external_lex_state = 2},
  [9716] = {.lex_state = 343, .external_lex_state = 2},
  [9717] = {.lex_state = 343, .external_lex_state = 2},
  [9718] = {.lex_state = 343, .external_lex_state = 2},
  [9719] = {.lex_state = 343, .external_lex_state = 2},
  [9720] = {.lex_state = 343, .external_lex_state = 2},
  [9721] = {.lex_state = 343, .external_lex_state = 2},
  [9722] = {.lex_state = 343, .external_lex_state = 2},
  [9723] = {.lex_state = 343, .external_lex_state = 2},
  [9724] = {.lex_state = 343, .external_lex_state = 2},
  [9725] = {.lex_state = 343, .external_lex_state = 2},
  [9726] = {.lex_state = 343, .external_lex_state = 2},
  [9727] = {.lex_state = 343, .external_lex_state = 2},
  [9728] = {.lex_state = 343, .external_lex_state = 2},
  [9729] = {.lex_state = 343, .external_lex_state = 2},
  [9730] = {.lex_state = 343, .external_lex_state = 2},
  [9731] = {.lex_state = 343, .external_lex_state = 2},
  [9732] = {.lex_state = 343, .external_lex_state = 2},
  [9733] = {.lex_state = 343, .external_lex_state = 2},
  [9734] = {.lex_state = 343, .external_lex_state = 2},
  [9735] = {.lex_state = 343, .external_lex_state = 2},
  [9736] = {.lex_state = 343, .external_lex_state = 2},
  [9737] = {.lex_state = 343, .external_lex_state = 2},
  [9738] = {.lex_state = 343, .external_lex_state = 2},
  [9739] = {.lex_state = 343, .external_lex_state = 2},
  [9740] = {.lex_state = 343, .external_lex_state = 2},
  [9741] = {.lex_state = 343, .external_lex_state = 2},
  [9742] = {.lex_state = 343, .external_lex_state = 2},
  [9743] = {.lex_state = 343, .external_lex_state = 2},
  [9744] = {.lex_state = 343, .external_lex_state = 2},
  [9745] = {.lex_state = 343, .external_lex_state = 2},
  [9746] = {.lex_state = 343, .external_lex_state = 2},
  [9747] = {.lex_state = 343, .external_lex_state = 2},
  [9748] = {.lex_state = 343, .external_lex_state = 2},
  [9749] = {.lex_state = 343, .external_lex_state = 2},
  [9750] = {.lex_state = 343, .external_lex_state = 2},
  [9751] = {.lex_state = 343, .external_lex_state = 2},
  [9752] = {.lex_state = 343, .external_lex_state = 2},
  [9753] = {.lex_state = 343, .external_lex_state = 2},
  [9754] = {.lex_state = 343, .external_lex_state = 2},
  [9755] = {.lex_state = 343, .external_lex_state = 2},
  [9756] = {.lex_state = 343, .external_lex_state = 2},
  [9757] = {.lex_state = 343, .external_lex_state = 2},
  [9758] = {.lex_state = 343, .external_lex_state = 2},
  [9759] = {.lex_state = 343, .external_lex_state = 2},
  [9760] = {.lex_state = 343, .external_lex_state = 2},
  [9761] = {.lex_state = 343, .external_lex_state = 2},
  [9762] = {.lex_state = 343, .external_lex_state = 2},
  [9763] = {.lex_state = 343, .external_lex_state = 2},
  [9764] = {.lex_state = 343, .external_lex_state = 2},
  [9765] = {.lex_state = 343, .external_lex_state = 2},
  [9766] = {.lex_state = 343, .external_lex_state = 2},
  [9767] = {.lex_state = 343, .external_lex_state = 2},
  [9768] = {.lex_state = 343, .external_lex_state = 2},
  [9769] = {.lex_state = 343, .external_lex_state = 2},
  [9770] = {.lex_state = 343, .external_lex_state = 2},
  [9771] = {.lex_state = 343, .external_lex_state = 2},
  [9772] = {.lex_state = 343, .external_lex_state = 2},
  [9773] = {.lex_state = 343, .external_lex_state = 2},
  [9774] = {.lex_state = 343, .external_lex_state = 2},
  [9775] = {.lex_state = 343, .external_lex_state = 2},
  [9776] = {.lex_state = 343, .external_lex_state = 2},
  [9777] = {.lex_state = 343, .external_lex_state = 2},
  [9778] = {.lex_state = 343, .external_lex_state = 2},
  [9779] = {.lex_state = 343, .external_lex_state = 2},
  [9780] = {.lex_state = 343, .external_lex_state = 2},
  [9781] = {.lex_state = 343, .external_lex_state = 2},
  [9782] = {.lex_state = 343, .external_lex_state = 2},
  [9783] = {.lex_state = 343, .external_lex_state = 2},
  [9784] = {.lex_state = 343, .external_lex_state = 2},
  [9785] = {.lex_state = 343, .external_lex_state = 2},
  [9786] = {.lex_state = 343, .external_lex_state = 2},
  [9787] = {.lex_state = 343, .external_lex_state = 2},
  [9788] = {.lex_state = 343, .external_lex_state = 2},
  [9789] = {.lex_state = 343, .external_lex_state = 2},
  [9790] = {.lex_state = 343, .external_lex_state = 2},
  [9791] = {.lex_state = 343, .external_lex_state = 2},
  [9792] = {.lex_state = 343, .external_lex_state = 2},
  [9793] = {.lex_state = 343, .external_lex_state = 2},
  [9794] = {.lex_state = 343, .external_lex_state = 2},
  [9795] = {.lex_state = 343, .external_lex_state = 2},
  [9796] = {.lex_state = 343, .external_lex_state = 2},
  [9797] = {.lex_state = 343, .external_lex_state = 2},
  [9798] = {.lex_state = 343, .external_lex_state = 2},
  [9799] = {.lex_state = 343, .external_lex_state = 2},
  [9800] = {.lex_state = 343, .external_lex_state = 2},
  [9801] = {.lex_state = 343, .external_lex_state = 2},
  [9802] = {.lex_state = 343, .external_lex_state = 2},
  [9803] = {.lex_state = 343, .external_lex_state = 2},
  [9804] = {.lex_state = 343, .external_lex_state = 2},
  [9805] = {.lex_state = 343, .external_lex_state = 2},
  [9806] = {.lex_state = 343, .external_lex_state = 2},
  [9807] = {.lex_state = 343, .external_lex_state = 2},
  [9808] = {.lex_state = 343, .external_lex_state = 2},
  [9809] = {.lex_state = 343, .external_lex_state = 2},
  [9810] = {.lex_state = 33, .external_lex_state = 4},
  [9811] = {.lex_state = 30, .external_lex_state = 4},
  [9812] = {.lex_state = 31, .external_lex_state = 4},
  [9813] = {.lex_state = 314, .external_lex_state = 4},
  [9814] = {.lex_state = 29, .external_lex_state = 4},
  [9815] = {.lex_state = 28, .external_lex_state = 4},
  [9816] = {.lex_state = 315, .external_lex_state = 4},
  [9817] = {.lex_state = 500, .external_lex_state = 4},
  [9818] = {.lex_state = 32, .external_lex_state = 4},
  [9819] = {.lex_state = 529, .external_lex_state = 9},
  [9820] = {.lex_state = 530, .external_lex_state = 9},
  [9821] = {.lex_state = 530, .external_lex_state = 10},
  [9822] = {.lex_state = 530, .external_lex_state = 10},
  [9823] = {.lex_state = 530, .external_lex_state = 10},
  [9824] = {.lex_state = 530, .external_lex_state = 10},
  [9825] = {.lex_state = 529, .external_lex_state = 10},
  [9826] = {.lex_state = 540, .external_lex_state = 10},
  [9827] = {.lex_state = 530, .external_lex_state = 10},
  [9828] = {.lex_state = 530, .external_lex_state = 10},
  [9829] = {.lex_state = 530, .external_lex_state = 10},
  [9830] = {.lex_state = 530, .external_lex_state = 10},
  [9831] = {.lex_state = 529, .external_lex_state = 10},
  [9832] = {.lex_state = 540, .external_lex_state = 10},
  [9833] = {.lex_state = 530, .external_lex_state = 10},
  [9834] = {.lex_state = 530, .external_lex_state = 10},
  [9835] = {.lex_state = 530, .external_lex_state = 10},
  [9836] = {.lex_state = 530, .external_lex_state = 10},
  [9837] = {.lex_state = 529, .external_lex_state = 10},
  [9838] = {.lex_state = 530, .external_lex_state = 10},
  [9839] = {.lex_state = 529, .external_lex_state = 10},
  [9840] = {.lex_state = 529, .external_lex_state = 10},
  [9841] = {.lex_state = 531, .external_lex_state = 10},
  [9842] = {.lex_state = 529, .external_lex_state = 10},
  [9843] = {.lex_state = 530, .external_lex_state = 10},
  [9844] = {.lex_state = 540, .external_lex_state = 10},
  [9845] = {.lex_state = 172, .external_lex_state = 2},
  [9846] = {.lex_state = 529, .external_lex_state = 10},
  [9847] = {.lex_state = 175, .external_lex_state = 2},
  [9848] = {.lex_state = 540, .external_lex_state = 9},
  [9849] = {.lex_state = 530, .external_lex_state = 10},
  [9850] = {.lex_state = 530, .external_lex_state = 10},
  [9851] = {.lex_state = 540, .external_lex_state = 10},
  [9852] = {.lex_state = 355, .external_lex_state = 4},
  [9853] = {.lex_state = 355, .external_lex_state = 4},
  [9854] = {.lex_state = 355, .external_lex_state = 4},
  [9855] = {.lex_state = 355, .external_lex_state = 4},
  [9856] = {.lex_state = 355, .external_lex_state = 4},
  [9857] = {.lex_state = 355, .external_lex_state = 4},
  [9858] = {.lex_state = 355, .external_lex_state = 4},
  [9859] = {.lex_state = 355, .external_lex_state = 4},
  [9860] = {.lex_state = 355, .external_lex_state = 4},
  [9861] = {.lex_state = 355, .external_lex_state = 4},
  [9862] = {.lex_state = 355, .external_lex_state = 4},
  [9863] = {.lex_state = 355, .external_lex_state = 4},
  [9864] = {.lex_state = 530, .external_lex_state = 10},
  [9865] = {.lex_state = 540, .external_lex_state = 10},
  [9866] = {.lex_state = 355, .external_lex_state = 4},
  [9867] = {.lex_state = 355, .external_lex_state = 4},
  [9868] = {.lex_state = 355, .external_lex_state = 4},
  [9869] = {.lex_state = 171, .external_lex_state = 2},
  [9870] = {.lex_state = 355, .external_lex_state = 4},
  [9871] = {.lex_state = 540, .external_lex_state = 10},
  [9872] = {.lex_state = 355, .external_lex_state = 4},
  [9873] = {.lex_state = 355, .external_lex_state = 4},
  [9874] = {.lex_state = 530, .external_lex_state = 10},
  [9875] = {.lex_state = 355, .external_lex_state = 4},
  [9876] = {.lex_state = 530, .external_lex_state = 10},
  [9877] = {.lex_state = 355, .external_lex_state = 4},
  [9878] = {.lex_state = 530, .external_lex_state = 10},
  [9879] = {.lex_state = 355, .external_lex_state = 4},
  [9880] = {.lex_state = 530, .external_lex_state = 10},
  [9881] = {.lex_state = 530, .external_lex_state = 10},
  [9882] = {.lex_state = 355, .external_lex_state = 4},
  [9883] = {.lex_state = 530, .external_lex_state = 10},
  [9884] = {.lex_state = 355, .external_lex_state = 4},
  [9885] = {.lex_state = 355, .external_lex_state = 4},
  [9886] = {.lex_state = 355, .external_lex_state = 4},
  [9887] = {.lex_state = 530, .external_lex_state = 10},
  [9888] = {.lex_state = 355, .external_lex_state = 4},
  [9889] = {.lex_state = 170, .external_lex_state = 2},
  [9890] = {.lex_state = 530, .external_lex_state = 10},
  [9891] = {.lex_state = 355, .external_lex_state = 4},
  [9892] = {.lex_state = 337, .external_lex_state = 2},
  [9893] = {.lex_state = 355, .external_lex_state = 4},
  [9894] = {.lex_state = 355, .external_lex_state = 4},
  [9895] = {.lex_state = 530, .external_lex_state = 10},
  [9896] = {.lex_state = 355, .external_lex_state = 4},
  [9897] = {.lex_state = 355, .external_lex_state = 4},
  [9898] = {.lex_state = 355, .external_lex_state = 4},
  [9899] = {.lex_state = 355, .external_lex_state = 4},
  [9900] = {.lex_state = 355, .external_lex_state = 4},
  [9901] = {.lex_state = 540, .external_lex_state = 10},
  [9902] = {.lex_state = 530, .external_lex_state = 10},
  [9903] = {.lex_state = 355, .external_lex_state = 4},
  [9904] = {.lex_state = 355, .external_lex_state = 4},
  [9905] = {.lex_state = 355, .external_lex_state = 4},
  [9906] = {.lex_state = 355, .external_lex_state = 4},
  [9907] = {.lex_state = 355, .external_lex_state = 4},
  [9908] = {.lex_state = 175, .external_lex_state = 2},
  [9909] = {.lex_state = 355, .external_lex_state = 4},
  [9910] = {.lex_state = 355, .external_lex_state = 4},
  [9911] = {.lex_state = 355, .external_lex_state = 4},
  [9912] = {.lex_state = 355, .external_lex_state = 4},
  [9913] = {.lex_state = 355, .external_lex_state = 4},
  [9914] = {.lex_state = 530, .external_lex_state = 10},
  [9915] = {.lex_state = 355, .external_lex_state = 4},
  [9916] = {.lex_state = 355, .external_lex_state = 4},
  [9917] = {.lex_state = 355, .external_lex_state = 4},
  [9918] = {.lex_state = 355, .external_lex_state = 4},
  [9919] = {.lex_state = 175, .external_lex_state = 2},
  [9920] = {.lex_state = 355, .external_lex_state = 4},
  [9921] = {.lex_state = 530, .external_lex_state = 10},
  [9922] = {.lex_state = 355, .external_lex_state = 4},
  [9923] = {.lex_state = 355, .external_lex_state = 4},
  [9924] = {.lex_state = 355, .external_lex_state = 4},
  [9925] = {.lex_state = 355, .external_lex_state = 4},
  [9926] = {.lex_state = 355, .external_lex_state = 4},
  [9927] = {.lex_state = 530, .external_lex_state = 10},
  [9928] = {.lex_state = 355, .external_lex_state = 4},
  [9929] = {.lex_state = 355, .external_lex_state = 4},
  [9930] = {.lex_state = 530, .external_lex_state = 10},
  [9931] = {.lex_state = 355, .external_lex_state = 4},
  [9932] = {.lex_state = 355, .external_lex_state = 4},
  [9933] = {.lex_state = 355, .external_lex_state = 4},
  [9934] = {.lex_state = 530, .external_lex_state = 10},
  [9935] = {.lex_state = 355, .external_lex_state = 4},
  [9936] = {.lex_state = 355, .external_lex_state = 4},
  [9937] = {.lex_state = 355, .external_lex_state = 4},
  [9938] = {.lex_state = 537, .external_lex_state = 10},
  [9939] = {.lex_state = 530, .external_lex_state = 10},
  [9940] = {.lex_state = 355, .external_lex_state = 4},
  [9941] = {.lex_state = 355, .external_lex_state = 4},
  [9942] = {.lex_state = 355, .external_lex_state = 4},
  [9943] = {.lex_state = 355, .external_lex_state = 4},
  [9944] = {.lex_state = 530, .external_lex_state = 10},
  [9945] = {.lex_state = 355, .external_lex_state = 4},
  [9946] = {.lex_state = 355, .external_lex_state = 4},
  [9947] = {.lex_state = 355, .external_lex_state = 4},
  [9948] = {.lex_state = 530, .external_lex_state = 10},
  [9949] = {.lex_state = 537, .external_lex_state = 9},
  [9950] = {.lex_state = 355, .external_lex_state = 4},
  [9951] = {.lex_state = 355, .external_lex_state = 4},
  [9952] = {.lex_state = 540, .external_lex_state = 10},
  [9953] = {.lex_state = 355, .external_lex_state = 4},
  [9954] = {.lex_state = 530, .external_lex_state = 10},
  [9955] = {.lex_state = 355, .external_lex_state = 4},
  [9956] = {.lex_state = 530, .external_lex_state = 10},
  [9957] = {.lex_state = 355, .external_lex_state = 4},
  [9958] = {.lex_state = 530, .external_lex_state = 10},
  [9959] = {.lex_state = 355, .external_lex_state = 4},
  [9960] = {.lex_state = 355, .external_lex_state = 4},
  [9961] = {.lex_state = 530, .external_lex_state = 10},
  [9962] = {.lex_state = 172, .external_lex_state = 2},
  [9963] = {.lex_state = 355, .external_lex_state = 4},
  [9964] = {.lex_state = 530, .external_lex_state = 10},
  [9965] = {.lex_state = 355, .external_lex_state = 4},
  [9966] = {.lex_state = 172, .external_lex_state = 2},
  [9967] = {.lex_state = 530, .external_lex_state = 10},
  [9968] = {.lex_state = 173, .external_lex_state = 2},
  [9969] = {.lex_state = 355, .external_lex_state = 4},
  [9970] = {.lex_state = 355, .external_lex_state = 4},
  [9971] = {.lex_state = 530, .external_lex_state = 10},
  [9972] = {.lex_state = 537, .external_lex_state = 10},
  [9973] = {.lex_state = 355, .external_lex_state = 4},
  [9974] = {.lex_state = 540, .external_lex_state = 10},
  [9975] = {.lex_state = 530, .external_lex_state = 10},
  [9976] = {.lex_state = 355, .external_lex_state = 4},
  [9977] = {.lex_state = 355, .external_lex_state = 4},
  [9978] = {.lex_state = 537, .external_lex_state = 10},
  [9979] = {.lex_state = 530, .external_lex_state = 10},
  [9980] = {.lex_state = 530, .external_lex_state = 10},
  [9981] = {.lex_state = 530, .external_lex_state = 10},
  [9982] = {.lex_state = 530, .external_lex_state = 10},
  [9983] = {.lex_state = 355, .external_lex_state = 4},
  [9984] = {.lex_state = 355, .external_lex_state = 4},
  [9985] = {.lex_state = 530, .external_lex_state = 10},
  [9986] = {.lex_state = 530, .external_lex_state = 10},
  [9987] = {.lex_state = 355, .external_lex_state = 4},
  [9988] = {.lex_state = 355, .external_lex_state = 4},
  [9989] = {.lex_state = 530, .external_lex_state = 10},
  [9990] = {.lex_state = 530, .external_lex_state = 10},
  [9991] = {.lex_state = 355, .external_lex_state = 4},
  [9992] = {.lex_state = 530, .external_lex_state = 10},
  [9993] = {.lex_state = 530, .external_lex_state = 10},
  [9994] = {.lex_state = 530, .external_lex_state = 10},
  [9995] = {.lex_state = 355, .external_lex_state = 4},
  [9996] = {.lex_state = 530, .external_lex_state = 10},
  [9997] = {.lex_state = 355, .external_lex_state = 4},
  [9998] = {.lex_state = 530, .external_lex_state = 10},
  [9999] = {.lex_state = 355, .external_lex_state = 4},
  [10000] = {.lex_state = 530, .external_lex_state = 10},
  [10001] = {.lex_state = 355, .external_lex_state = 4},
  [10002] = {.lex_state = 355, .external_lex_state = 4},
  [10003] = {.lex_state = 541, .external_lex_state = 10},
  [10004] = {.lex_state = 540, .external_lex_state = 10},
  [10005] = {.lex_state = 540, .external_lex_state = 10},
  [10006] = {.lex_state = 530, .external_lex_state = 10},
  [10007] = {.lex_state = 530, .external_lex_state = 10},
  [10008] = {.lex_state = 530, .external_lex_state = 10},
  [10009] = {.lex_state = 540, .external_lex_state = 10},
  [10010] = {.lex_state = 530, .external_lex_state = 10},
  [10011] = {.lex_state = 355, .external_lex_state = 4},
  [10012] = {.lex_state = 355, .external_lex_state = 4},
  [10013] = {.lex_state = 530, .external_lex_state = 10},
  [10014] = {.lex_state = 172, .external_lex_state = 2},
  [10015] = {.lex_state = 540, .external_lex_state = 10},
  [10016] = {.lex_state = 530, .external_lex_state = 10},
  [10017] = {.lex_state = 355, .external_lex_state = 4},
  [10018] = {.lex_state = 540, .external_lex_state = 10},
  [10019] = {.lex_state = 355, .external_lex_state = 4},
  [10020] = {.lex_state = 355, .external_lex_state = 4},
  [10021] = {.lex_state = 530, .external_lex_state = 10},
  [10022] = {.lex_state = 530, .external_lex_state = 10},
  [10023] = {.lex_state = 530, .external_lex_state = 10},
  [10024] = {.lex_state = 355, .external_lex_state = 4},
  [10025] = {.lex_state = 355, .external_lex_state = 4},
  [10026] = {.lex_state = 355, .external_lex_state = 4},
  [10027] = {.lex_state = 355, .external_lex_state = 4},
  [10028] = {.lex_state = 175, .external_lex_state = 2},
  [10029] = {.lex_state = 530, .external_lex_state = 10},
  [10030] = {.lex_state = 355, .external_lex_state = 4},
  [10031] = {.lex_state = 355, .external_lex_state = 4},
  [10032] = {.lex_state = 537, .external_lex_state = 10},
  [10033] = {.lex_state = 355, .external_lex_state = 4},
  [10034] = {.lex_state = 530, .external_lex_state = 10},
  [10035] = {.lex_state = 355, .external_lex_state = 4},
  [10036] = {.lex_state = 530, .external_lex_state = 10},
  [10037] = {.lex_state = 540, .external_lex_state = 10},
  [10038] = {.lex_state = 540, .external_lex_state = 10},
  [10039] = {.lex_state = 540, .external_lex_state = 10},
  [10040] = {.lex_state = 525, .external_lex_state = 2},
  [10041] = {.lex_state = 540, .external_lex_state = 10},
  [10042] = {.lex_state = 337, .external_lex_state = 2},
  [10043] = {.lex_state = 173, .external_lex_state = 2},
  [10044] = {.lex_state = 173, .external_lex_state = 2},
  [10045] = {.lex_state = 540, .external_lex_state = 10},
  [10046] = {.lex_state = 540, .external_lex_state = 10},
  [10047] = {.lex_state = 173, .external_lex_state = 2},
  [10048] = {.lex_state = 537, .external_lex_state = 10},
  [10049] = {.lex_state = 540, .external_lex_state = 10},
  [10050] = {.lex_state = 540, .external_lex_state = 10},
  [10051] = {.lex_state = 540, .external_lex_state = 10},
  [10052] = {.lex_state = 540, .external_lex_state = 10},
  [10053] = {.lex_state = 540, .external_lex_state = 10},
  [10054] = {.lex_state = 540, .external_lex_state = 10},
  [10055] = {.lex_state = 540, .external_lex_state = 10},
  [10056] = {.lex_state = 540, .external_lex_state = 10},
  [10057] = {.lex_state = 540, .external_lex_state = 10},
  [10058] = {.lex_state = 537, .external_lex_state = 10},
  [10059] = {.lex_state = 540, .external_lex_state = 10},
  [10060] = {.lex_state = 540, .external_lex_state = 10},
  [10061] = {.lex_state = 540, .external_lex_state = 10},
  [10062] = {.lex_state = 540, .external_lex_state = 10},
  [10063] = {.lex_state = 537, .external_lex_state = 10},
  [10064] = {.lex_state = 537, .external_lex_state = 10},
  [10065] = {.lex_state = 537, .external_lex_state = 10},
  [10066] = {.lex_state = 540, .external_lex_state = 10},
  [10067] = {.lex_state = 540, .external_lex_state = 10},
  [10068] = {.lex_state = 537, .external_lex_state = 10},
  [10069] = {.lex_state = 171, .external_lex_state = 2},
  [10070] = {.lex_state = 540, .external_lex_state = 10},
  [10071] = {.lex_state = 171, .external_lex_state = 2},
  [10072] = {.lex_state = 540, .external_lex_state = 10},
  [10073] = {.lex_state = 537, .external_lex_state = 10},
  [10074] = {.lex_state = 537, .external_lex_state = 10},
  [10075] = {.lex_state = 537, .external_lex_state = 10},
  [10076] = {.lex_state = 540, .external_lex_state = 10},
  [10077] = {.lex_state = 537, .external_lex_state = 10},
  [10078] = {.lex_state = 537, .external_lex_state = 10},
  [10079] = {.lex_state = 540, .external_lex_state = 10},
  [10080] = {.lex_state = 540, .external_lex_state = 10},
  [10081] = {.lex_state = 540, .external_lex_state = 10},
  [10082] = {.lex_state = 171, .external_lex_state = 2},
  [10083] = {.lex_state = 170, .external_lex_state = 2},
  [10084] = {.lex_state = 540, .external_lex_state = 10},
  [10085] = {.lex_state = 540, .external_lex_state = 10},
  [10086] = {.lex_state = 540, .external_lex_state = 10},
  [10087] = {.lex_state = 540, .external_lex_state = 10},
  [10088] = {.lex_state = 540, .external_lex_state = 10},
  [10089] = {.lex_state = 338, .external_lex_state = 2},
  [10090] = {.lex_state = 540, .external_lex_state = 10},
  [10091] = {.lex_state = 540, .external_lex_state = 10},
  [10092] = {.lex_state = 540, .external_lex_state = 10},
  [10093] = {.lex_state = 540, .external_lex_state = 10},
  [10094] = {.lex_state = 540, .external_lex_state = 10},
  [10095] = {.lex_state = 540, .external_lex_state = 10},
  [10096] = {.lex_state = 540, .external_lex_state = 10},
  [10097] = {.lex_state = 540, .external_lex_state = 10},
  [10098] = {.lex_state = 540, .external_lex_state = 10},
  [10099] = {.lex_state = 540, .external_lex_state = 10},
  [10100] = {.lex_state = 174, .external_lex_state = 2},
  [10101] = {.lex_state = 540, .external_lex_state = 10},
  [10102] = {.lex_state = 540, .external_lex_state = 10},
  [10103] = {.lex_state = 540, .external_lex_state = 10},
  [10104] = {.lex_state = 540, .external_lex_state = 10},
  [10105] = {.lex_state = 540, .external_lex_state = 10},
  [10106] = {.lex_state = 540, .external_lex_state = 10},
  [10107] = {.lex_state = 540, .external_lex_state = 10},
  [10108] = {.lex_state = 539, .external_lex_state = 10},
  [10109] = {.lex_state = 540, .external_lex_state = 10},
  [10110] = {.lex_state = 170, .external_lex_state = 2},
  [10111] = {.lex_state = 337, .external_lex_state = 2},
  [10112] = {.lex_state = 170, .external_lex_state = 2},
  [10113] = {.lex_state = 540, .external_lex_state = 10},
  [10114] = {.lex_state = 540, .external_lex_state = 10},
  [10115] = {.lex_state = 337, .external_lex_state = 2},
  [10116] = {.lex_state = 540, .external_lex_state = 10},
  [10117] = {.lex_state = 540, .external_lex_state = 10},
  [10118] = {.lex_state = 540, .external_lex_state = 10},
  [10119] = {.lex_state = 540, .external_lex_state = 10},
  [10120] = {.lex_state = 537, .external_lex_state = 10},
  [10121] = {.lex_state = 174, .external_lex_state = 2},
  [10122] = {.lex_state = 537, .external_lex_state = 10},
  [10123] = {.lex_state = 537, .external_lex_state = 10},
  [10124] = {.lex_state = 537, .external_lex_state = 10},
  [10125] = {.lex_state = 537, .external_lex_state = 10},
  [10126] = {.lex_state = 537, .external_lex_state = 10},
  [10127] = {.lex_state = 537, .external_lex_state = 10},
  [10128] = {.lex_state = 537, .external_lex_state = 10},
  [10129] = {.lex_state = 537, .external_lex_state = 10},
  [10130] = {.lex_state = 537, .external_lex_state = 10},
  [10131] = {.lex_state = 537, .external_lex_state = 10},
  [10132] = {.lex_state = 537, .external_lex_state = 10},
  [10133] = {.lex_state = 525, .external_lex_state = 2},
  [10134] = {.lex_state = 338, .external_lex_state = 2},
  [10135] = {.lex_state = 537, .external_lex_state = 10},
  [10136] = {.lex_state = 338, .external_lex_state = 2},
  [10137] = {.lex_state = 537, .external_lex_state = 10},
  [10138] = {.lex_state = 537, .external_lex_state = 10},
  [10139] = {.lex_state = 537, .external_lex_state = 10},
  [10140] = {.lex_state = 537, .external_lex_state = 10},
  [10141] = {.lex_state = 537, .external_lex_state = 10},
  [10142] = {.lex_state = 537, .external_lex_state = 10},
  [10143] = {.lex_state = 537, .external_lex_state = 10},
  [10144] = {.lex_state = 537, .external_lex_state = 10},
  [10145] = {.lex_state = 537, .external_lex_state = 10},
  [10146] = {.lex_state = 537, .external_lex_state = 10},
  [10147] = {.lex_state = 537, .external_lex_state = 10},
  [10148] = {.lex_state = 537, .external_lex_state = 10},
  [10149] = {.lex_state = 537, .external_lex_state = 10},
  [10150] = {.lex_state = 174, .external_lex_state = 2},
  [10151] = {.lex_state = 174, .external_lex_state = 2},
  [10152] = {.lex_state = 537, .external_lex_state = 10},
  [10153] = {.lex_state = 537, .external_lex_state = 10},
  [10154] = {.lex_state = 537, .external_lex_state = 10},
  [10155] = {.lex_state = 537, .external_lex_state = 10},
  [10156] = {.lex_state = 537, .external_lex_state = 10},
  [10157] = {.lex_state = 537, .external_lex_state = 10},
  [10158] = {.lex_state = 537, .external_lex_state = 10},
  [10159] = {.lex_state = 537, .external_lex_state = 10},
  [10160] = {.lex_state = 537, .external_lex_state = 10},
  [10161] = {.lex_state = 537, .external_lex_state = 10},
  [10162] = {.lex_state = 537, .external_lex_state = 10},
  [10163] = {.lex_state = 537, .external_lex_state = 10},
  [10164] = {.lex_state = 537, .external_lex_state = 10},
  [10165] = {.lex_state = 537, .external_lex_state = 10},
  [10166] = {.lex_state = 537, .external_lex_state = 10},
  [10167] = {.lex_state = 537, .external_lex_state = 10},
  [10168] = {.lex_state = 537, .external_lex_state = 10},
  [10169] = {.lex_state = 537, .external_lex_state = 10},
  [10170] = {.lex_state = 338, .external_lex_state = 2},
  [10171] = {.lex_state = 537, .external_lex_state = 10},
  [10172] = {.lex_state = 537, .external_lex_state = 10},
  [10173] = {.lex_state = 537, .external_lex_state = 10},
  [10174] = {.lex_state = 525, .external_lex_state = 2},
  [10175] = {.lex_state = 537, .external_lex_state = 10},
  [10176] = {.lex_state = 537, .external_lex_state = 10},
  [10177] = {.lex_state = 537, .external_lex_state = 10},
  [10178] = {.lex_state = 537, .external_lex_state = 10},
  [10179] = {.lex_state = 525, .external_lex_state = 2},
  [10180] = {.lex_state = 537, .external_lex_state = 10},
  [10181] = {.lex_state = 537, .external_lex_state = 10},
  [10182] = {.lex_state = 537, .external_lex_state = 10},
  [10183] = {.lex_state = 537, .external_lex_state = 10},
  [10184] = {.lex_state = 537, .external_lex_state = 11},
  [10185] = {.lex_state = 363, .external_lex_state = 9},
  [10186] = {.lex_state = 529, .external_lex_state = 9},
  [10187] = {.lex_state = 539, .external_lex_state = 12},
  [10188] = {.lex_state = 364, .external_lex_state = 10},
  [10189] = {.lex_state = 364, .external_lex_state = 10},
  [10190] = {.lex_state = 231, .external_lex_state = 9},
  [10191] = {.lex_state = 227, .external_lex_state = 9},
  [10192] = {.lex_state = 364, .external_lex_state = 10},
  [10193] = {.lex_state = 529, .external_lex_state = 9},
  [10194] = {.lex_state = 364, .external_lex_state = 9},
  [10195] = {.lex_state = 231, .external_lex_state = 9},
  [10196] = {.lex_state = 529, .external_lex_state = 9},
  [10197] = {.lex_state = 227, .external_lex_state = 9},
  [10198] = {.lex_state = 227, .external_lex_state = 9},
  [10199] = {.lex_state = 364, .external_lex_state = 10},
  [10200] = {.lex_state = 231, .external_lex_state = 9},
  [10201] = {.lex_state = 529, .external_lex_state = 9},
  [10202] = {.lex_state = 537, .external_lex_state = 12},
  [10203] = {.lex_state = 363, .external_lex_state = 10},
  [10204] = {.lex_state = 363, .external_lex_state = 10},
  [10205] = {.lex_state = 364, .external_lex_state = 10},
  [10206] = {.lex_state = 229, .external_lex_state = 9},
  [10207] = {.lex_state = 537, .external_lex_state = 12},
  [10208] = {.lex_state = 537, .external_lex_state = 12},
  [10209] = {.lex_state = 537, .external_lex_state = 12},
  [10210] = {.lex_state = 537, .external_lex_state = 12},
  [10211] = {.lex_state = 537, .external_lex_state = 12},
  [10212] = {.lex_state = 537, .external_lex_state = 12},
  [10213] = {.lex_state = 537, .external_lex_state = 12},
  [10214] = {.lex_state = 364, .external_lex_state = 10},
  [10215] = {.lex_state = 537, .external_lex_state = 12},
  [10216] = {.lex_state = 529, .external_lex_state = 9},
  [10217] = {.lex_state = 537, .external_lex_state = 12},
  [10218] = {.lex_state = 537, .external_lex_state = 12},
  [10219] = {.lex_state = 364, .external_lex_state = 10},
  [10220] = {.lex_state = 537, .external_lex_state = 12},
  [10221] = {.lex_state = 537, .external_lex_state = 12},
  [10222] = {.lex_state = 537, .external_lex_state = 12},
  [10223] = {.lex_state = 537, .external_lex_state = 12},
  [10224] = {.lex_state = 537, .external_lex_state = 12},
  [10225] = {.lex_state = 537, .external_lex_state = 12},
  [10226] = {.lex_state = 537, .external_lex_state = 12},
  [10227] = {.lex_state = 228, .external_lex_state = 10},
  [10228] = {.lex_state = 537, .external_lex_state = 12},
  [10229] = {.lex_state = 537, .external_lex_state = 12},
  [10230] = {.lex_state = 537, .external_lex_state = 12},
  [10231] = {.lex_state = 537, .external_lex_state = 12},
  [10232] = {.lex_state = 537, .external_lex_state = 12},
  [10233] = {.lex_state = 537, .external_lex_state = 12},
  [10234] = {.lex_state = 229, .external_lex_state = 9},
  [10235] = {.lex_state = 229, .external_lex_state = 10},
  [10236] = {.lex_state = 537, .external_lex_state = 12},
  [10237] = {.lex_state = 238, .external_lex_state = 10},
  [10238] = {.lex_state = 537, .external_lex_state = 12},
  [10239] = {.lex_state = 234, .external_lex_state = 9},
  [10240] = {.lex_state = 238, .external_lex_state = 10},
  [10241] = {.lex_state = 537, .external_lex_state = 12},
  [10242] = {.lex_state = 537, .external_lex_state = 12},
  [10243] = {.lex_state = 228, .external_lex_state = 10},
  [10244] = {.lex_state = 364, .external_lex_state = 10},
  [10245] = {.lex_state = 529, .external_lex_state = 9},
  [10246] = {.lex_state = 365, .external_lex_state = 10},
  [10247] = {.lex_state = 228, .external_lex_state = 10},
  [10248] = {.lex_state = 365, .external_lex_state = 10},
  [10249] = {.lex_state = 364, .external_lex_state = 10},
  [10250] = {.lex_state = 364, .external_lex_state = 9},
  [10251] = {.lex_state = 229, .external_lex_state = 10},
  [10252] = {.lex_state = 364, .external_lex_state = 10},
  [10253] = {.lex_state = 367, .external_lex_state = 10},
  [10254] = {.lex_state = 229, .external_lex_state = 9},
  [10255] = {.lex_state = 228, .external_lex_state = 10},
  [10256] = {.lex_state = 228, .external_lex_state = 10},
  [10257] = {.lex_state = 529, .external_lex_state = 9},
  [10258] = {.lex_state = 384, .external_lex_state = 10},
  [10259] = {.lex_state = 235, .external_lex_state = 10},
  [10260] = {.lex_state = 537, .external_lex_state = 12},
  [10261] = {.lex_state = 547, .external_lex_state = 12},
  [10262] = {.lex_state = 364, .external_lex_state = 10},
  [10263] = {.lex_state = 537, .external_lex_state = 12},
  [10264] = {.lex_state = 235, .external_lex_state = 10},
  [10265] = {.lex_state = 238, .external_lex_state = 10},
  [10266] = {.lex_state = 537, .external_lex_state = 12},
  [10267] = {.lex_state = 529, .external_lex_state = 9},
  [10268] = {.lex_state = 364, .external_lex_state = 10},
  [10269] = {.lex_state = 537, .external_lex_state = 12},
  [10270] = {.lex_state = 384, .external_lex_state = 10},
  [10271] = {.lex_state = 235, .external_lex_state = 10},
  [10272] = {.lex_state = 235, .external_lex_state = 10},
  [10273] = {.lex_state = 364, .external_lex_state = 10},
  [10274] = {.lex_state = 364, .external_lex_state = 10},
  [10275] = {.lex_state = 364, .external_lex_state = 10},
  [10276] = {.lex_state = 537, .external_lex_state = 12},
  [10277] = {.lex_state = 384, .external_lex_state = 10},
  [10278] = {.lex_state = 364, .external_lex_state = 10},
  [10279] = {.lex_state = 530, .external_lex_state = 9},
  [10280] = {.lex_state = 363, .external_lex_state = 10},
  [10281] = {.lex_state = 234, .external_lex_state = 9},
  [10282] = {.lex_state = 363, .external_lex_state = 10},
  [10283] = {.lex_state = 537, .external_lex_state = 12},
  [10284] = {.lex_state = 228, .external_lex_state = 10},
  [10285] = {.lex_state = 229, .external_lex_state = 10},
  [10286] = {.lex_state = 229, .external_lex_state = 10},
  [10287] = {.lex_state = 229, .external_lex_state = 9},
  [10288] = {.lex_state = 537, .external_lex_state = 12},
  [10289] = {.lex_state = 530, .external_lex_state = 9},
  [10290] = {.lex_state = 530, .external_lex_state = 9},
  [10291] = {.lex_state = 537, .external_lex_state = 12},
  [10292] = {.lex_state = 530, .external_lex_state = 9},
  [10293] = {.lex_state = 384, .external_lex_state = 9},
  [10294] = {.lex_state = 530, .external_lex_state = 9},
  [10295] = {.lex_state = 530, .external_lex_state = 9},
  [10296] = {.lex_state = 228, .external_lex_state = 10},
  [10297] = {.lex_state = 363, .external_lex_state = 10},
  [10298] = {.lex_state = 529, .external_lex_state = 9},
  [10299] = {.lex_state = 529, .external_lex_state = 9},
  [10300] = {.lex_state = 234, .external_lex_state = 9},
  [10301] = {.lex_state = 537, .external_lex_state = 12},
  [10302] = {.lex_state = 537, .external_lex_state = 12},
  [10303] = {.lex_state = 234, .external_lex_state = 10},
  [10304] = {.lex_state = 234, .external_lex_state = 9},
  [10305] = {.lex_state = 234, .external_lex_state = 10},
  [10306] = {.lex_state = 537, .external_lex_state = 12},
  [10307] = {.lex_state = 363, .external_lex_state = 10},
  [10308] = {.lex_state = 238, .external_lex_state = 10},
  [10309] = {.lex_state = 537, .external_lex_state = 12},
  [10310] = {.lex_state = 537, .external_lex_state = 12},
  [10311] = {.lex_state = 364, .external_lex_state = 9},
  [10312] = {.lex_state = 537, .external_lex_state = 12},
  [10313] = {.lex_state = 228, .external_lex_state = 10},
  [10314] = {.lex_state = 365, .external_lex_state = 10},
  [10315] = {.lex_state = 234, .external_lex_state = 10},
  [10316] = {.lex_state = 365, .external_lex_state = 10},
  [10317] = {.lex_state = 234, .external_lex_state = 10},
  [10318] = {.lex_state = 384, .external_lex_state = 10},
  [10319] = {.lex_state = 364, .external_lex_state = 9},
  [10320] = {.lex_state = 363, .external_lex_state = 10},
  [10321] = {.lex_state = 364, .external_lex_state = 10},
  [10322] = {.lex_state = 229, .external_lex_state = 10},
  [10323] = {.lex_state = 229, .external_lex_state = 10},
  [10324] = {.lex_state = 229, .external_lex_state = 10},
  [10325] = {.lex_state = 256, .external_lex_state = 10},
  [10326] = {.lex_state = 234, .external_lex_state = 10},
  [10327] = {.lex_state = 234, .external_lex_state = 10},
  [10328] = {.lex_state = 234, .external_lex_state = 10},
  [10329] = {.lex_state = 256, .external_lex_state = 10},
  [10330] = {.lex_state = 229, .external_lex_state = 10},
  [10331] = {.lex_state = 229, .external_lex_state = 10},
  [10332] = {.lex_state = 256, .external_lex_state = 10},
  [10333] = {.lex_state = 231, .external_lex_state = 10},
  [10334] = {.lex_state = 257, .external_lex_state = 9},
  [10335] = {.lex_state = 229, .external_lex_state = 10},
  [10336] = {.lex_state = 268, .external_lex_state = 10},
  [10337] = {.lex_state = 234, .external_lex_state = 10},
  [10338] = {.lex_state = 234, .external_lex_state = 10},
  [10339] = {.lex_state = 229, .external_lex_state = 10},
  [10340] = {.lex_state = 364, .external_lex_state = 10},
  [10341] = {.lex_state = 380, .external_lex_state = 10},
  [10342] = {.lex_state = 236, .external_lex_state = 10},
  [10343] = {.lex_state = 236, .external_lex_state = 10},
  [10344] = {.lex_state = 234, .external_lex_state = 10},
  [10345] = {.lex_state = 236, .external_lex_state = 10},
  [10346] = {.lex_state = 236, .external_lex_state = 10},
  [10347] = {.lex_state = 364, .external_lex_state = 10},
  [10348] = {.lex_state = 231, .external_lex_state = 10},
  [10349] = {.lex_state = 257, .external_lex_state = 9},
  [10350] = {.lex_state = 529, .external_lex_state = 9},
  [10351] = {.lex_state = 380, .external_lex_state = 10},
  [10352] = {.lex_state = 537, .external_lex_state = 13},
  [10353] = {.lex_state = 529, .external_lex_state = 9},
  [10354] = {.lex_state = 231, .external_lex_state = 10},
  [10355] = {.lex_state = 229, .external_lex_state = 10},
  [10356] = {.lex_state = 529, .external_lex_state = 9},
  [10357] = {.lex_state = 239, .external_lex_state = 10},
  [10358] = {.lex_state = 364, .external_lex_state = 10},
  [10359] = {.lex_state = 364, .external_lex_state = 10},
  [10360] = {.lex_state = 231, .external_lex_state = 10},
  [10361] = {.lex_state = 231, .external_lex_state = 10},
  [10362] = {.lex_state = 387, .external_lex_state = 10},
  [10363] = {.lex_state = 256, .external_lex_state = 10},
  [10364] = {.lex_state = 364, .external_lex_state = 10},
  [10365] = {.lex_state = 256, .external_lex_state = 10},
  [10366] = {.lex_state = 256, .external_lex_state = 10},
  [10367] = {.lex_state = 256, .external_lex_state = 10},
  [10368] = {.lex_state = 257, .external_lex_state = 9},
  [10369] = {.lex_state = 364, .external_lex_state = 10},
  [10370] = {.lex_state = 364, .external_lex_state = 10},
  [10371] = {.lex_state = 364, .external_lex_state = 10},
  [10372] = {.lex_state = 364, .external_lex_state = 10},
  [10373] = {.lex_state = 364, .external_lex_state = 10},
  [10374] = {.lex_state = 364, .external_lex_state = 10},
  [10375] = {.lex_state = 364, .external_lex_state = 10},
  [10376] = {.lex_state = 364, .external_lex_state = 10},
  [10377] = {.lex_state = 227, .external_lex_state = 10},
  [10378] = {.lex_state = 364, .external_lex_state = 10},
  [10379] = {.lex_state = 364, .external_lex_state = 10},
  [10380] = {.lex_state = 364, .external_lex_state = 10},
  [10381] = {.lex_state = 364, .external_lex_state = 10},
  [10382] = {.lex_state = 364, .external_lex_state = 10},
  [10383] = {.lex_state = 268, .external_lex_state = 9},
  [10384] = {.lex_state = 384, .external_lex_state = 9},
  [10385] = {.lex_state = 364, .external_lex_state = 10},
  [10386] = {.lex_state = 227, .external_lex_state = 9},
  [10387] = {.lex_state = 537, .external_lex_state = 12},
  [10388] = {.lex_state = 364, .external_lex_state = 10},
  [10389] = {.lex_state = 364, .external_lex_state = 10},
  [10390] = {.lex_state = 364, .external_lex_state = 10},
  [10391] = {.lex_state = 384, .external_lex_state = 10},
  [10392] = {.lex_state = 227, .external_lex_state = 10},
  [10393] = {.lex_state = 234, .external_lex_state = 10},
  [10394] = {.lex_state = 537, .external_lex_state = 12},
  [10395] = {.lex_state = 364, .external_lex_state = 10},
  [10396] = {.lex_state = 364, .external_lex_state = 10},
  [10397] = {.lex_state = 380, .external_lex_state = 10},
  [10398] = {.lex_state = 364, .external_lex_state = 10},
  [10399] = {.lex_state = 364, .external_lex_state = 10},
  [10400] = {.lex_state = 364, .external_lex_state = 10},
  [10401] = {.lex_state = 268, .external_lex_state = 10},
  [10402] = {.lex_state = 227, .external_lex_state = 10},
  [10403] = {.lex_state = 364, .external_lex_state = 10},
  [10404] = {.lex_state = 364, .external_lex_state = 10},
  [10405] = {.lex_state = 364, .external_lex_state = 10},
  [10406] = {.lex_state = 257, .external_lex_state = 9},
  [10407] = {.lex_state = 364, .external_lex_state = 10},
  [10408] = {.lex_state = 384, .external_lex_state = 9},
  [10409] = {.lex_state = 364, .external_lex_state = 10},
  [10410] = {.lex_state = 529, .external_lex_state = 9},
  [10411] = {.lex_state = 529, .external_lex_state = 9},
  [10412] = {.lex_state = 364, .external_lex_state = 10},
  [10413] = {.lex_state = 363, .external_lex_state = 9},
  [10414] = {.lex_state = 363, .external_lex_state = 9},
  [10415] = {.lex_state = 529, .external_lex_state = 9},
  [10416] = {.lex_state = 380, .external_lex_state = 10},
  [10417] = {.lex_state = 257, .external_lex_state = 10},
  [10418] = {.lex_state = 233, .external_lex_state = 10},
  [10419] = {.lex_state = 257, .external_lex_state = 9},
  [10420] = {.lex_state = 257, .external_lex_state = 10},
  [10421] = {.lex_state = 385, .external_lex_state = 10},
  [10422] = {.lex_state = 385, .external_lex_state = 10},
  [10423] = {.lex_state = 530, .external_lex_state = 9},
  [10424] = {.lex_state = 233, .external_lex_state = 10},
  [10425] = {.lex_state = 257, .external_lex_state = 10},
  [10426] = {.lex_state = 385, .external_lex_state = 10},
  [10427] = {.lex_state = 385, .external_lex_state = 10},
  [10428] = {.lex_state = 257, .external_lex_state = 10},
  [10429] = {.lex_state = 384, .external_lex_state = 9},
  [10430] = {.lex_state = 268, .external_lex_state = 9},
  [10431] = {.lex_state = 364, .external_lex_state = 10},
  [10432] = {.lex_state = 364, .external_lex_state = 10},
  [10433] = {.lex_state = 364, .external_lex_state = 10},
  [10434] = {.lex_state = 364, .external_lex_state = 10},
  [10435] = {.lex_state = 384, .external_lex_state = 9},
  [10436] = {.lex_state = 232, .external_lex_state = 10},
  [10437] = {.lex_state = 268, .external_lex_state = 10},
  [10438] = {.lex_state = 384, .external_lex_state = 10},
  [10439] = {.lex_state = 384, .external_lex_state = 10},
  [10440] = {.lex_state = 384, .external_lex_state = 10},
  [10441] = {.lex_state = 384, .external_lex_state = 10},
  [10442] = {.lex_state = 364, .external_lex_state = 10},
  [10443] = {.lex_state = 268, .external_lex_state = 9},
  [10444] = {.lex_state = 268, .external_lex_state = 10},
  [10445] = {.lex_state = 384, .external_lex_state = 10},
  [10446] = {.lex_state = 232, .external_lex_state = 10},
  [10447] = {.lex_state = 232, .external_lex_state = 10},
  [10448] = {.lex_state = 227, .external_lex_state = 10},
  [10449] = {.lex_state = 227, .external_lex_state = 10},
  [10450] = {.lex_state = 363, .external_lex_state = 9},
  [10451] = {.lex_state = 537, .external_lex_state = 13},
  [10452] = {.lex_state = 384, .external_lex_state = 10},
  [10453] = {.lex_state = 530, .external_lex_state = 9},
  [10454] = {.lex_state = 529, .external_lex_state = 9},
  [10455] = {.lex_state = 364, .external_lex_state = 10},
  [10456] = {.lex_state = 530, .external_lex_state = 9},
  [10457] = {.lex_state = 363, .external_lex_state = 9},
  [10458] = {.lex_state = 380, .external_lex_state = 9},
  [10459] = {.lex_state = 384, .external_lex_state = 10},
  [10460] = {.lex_state = 384, .external_lex_state = 10},
  [10461] = {.lex_state = 229, .external_lex_state = 10},
  [10462] = {.lex_state = 530, .external_lex_state = 9},
  [10463] = {.lex_state = 364, .external_lex_state = 10},
  [10464] = {.lex_state = 234, .external_lex_state = 10},
  [10465] = {.lex_state = 234, .external_lex_state = 10},
  [10466] = {.lex_state = 529, .external_lex_state = 9},
  [10467] = {.lex_state = 529, .external_lex_state = 9},
  [10468] = {.lex_state = 230, .external_lex_state = 10},
  [10469] = {.lex_state = 540, .external_lex_state = 9},
  [10470] = {.lex_state = 364, .external_lex_state = 10},
  [10471] = {.lex_state = 540, .external_lex_state = 9},
  [10472] = {.lex_state = 540, .external_lex_state = 9},
  [10473] = {.lex_state = 540, .external_lex_state = 9},
  [10474] = {.lex_state = 364, .external_lex_state = 10},
  [10475] = {.lex_state = 530, .external_lex_state = 9},
  [10476] = {.lex_state = 268, .external_lex_state = 9},
  [10477] = {.lex_state = 530, .external_lex_state = 9},
  [10478] = {.lex_state = 529, .external_lex_state = 9},
  [10479] = {.lex_state = 530, .external_lex_state = 9},
  [10480] = {.lex_state = 234, .external_lex_state = 10},
  [10481] = {.lex_state = 530, .external_lex_state = 9},
  [10482] = {.lex_state = 529, .external_lex_state = 9},
  [10483] = {.lex_state = 530, .external_lex_state = 9},
  [10484] = {.lex_state = 529, .external_lex_state = 9},
  [10485] = {.lex_state = 540, .external_lex_state = 9},
  [10486] = {.lex_state = 540, .external_lex_state = 9},
  [10487] = {.lex_state = 540, .external_lex_state = 9},
  [10488] = {.lex_state = 540, .external_lex_state = 9},
  [10489] = {.lex_state = 384, .external_lex_state = 10},
  [10490] = {.lex_state = 384, .external_lex_state = 10},
  [10491] = {.lex_state = 364, .external_lex_state = 10},
  [10492] = {.lex_state = 227, .external_lex_state = 10},
  [10493] = {.lex_state = 227, .external_lex_state = 10},
  [10494] = {.lex_state = 529, .external_lex_state = 9},
  [10495] = {.lex_state = 529, .external_lex_state = 9},
  [10496] = {.lex_state = 529, .external_lex_state = 9},
  [10497] = {.lex_state = 229, .external_lex_state = 10},
  [10498] = {.lex_state = 529, .external_lex_state = 9},
  [10499] = {.lex_state = 384, .external_lex_state = 10},
  [10500] = {.lex_state = 364, .external_lex_state = 10},
  [10501] = {.lex_state = 229, .external_lex_state = 10},
  [10502] = {.lex_state = 529, .external_lex_state = 9},
  [10503] = {.lex_state = 529, .external_lex_state = 9},
  [10504] = {.lex_state = 364, .external_lex_state = 10},
  [10505] = {.lex_state = 364, .external_lex_state = 10},
  [10506] = {.lex_state = 268, .external_lex_state = 9},
  [10507] = {.lex_state = 269, .external_lex_state = 10},
  [10508] = {.lex_state = 269, .external_lex_state = 10},
  [10509] = {.lex_state = 269, .external_lex_state = 10},
  [10510] = {.lex_state = 269, .external_lex_state = 10},
  [10511] = {.lex_state = 229, .external_lex_state = 10},
  [10512] = {.lex_state = 364, .external_lex_state = 10},
  [10513] = {.lex_state = 272, .external_lex_state = 10},
  [10514] = {.lex_state = 272, .external_lex_state = 10},
  [10515] = {.lex_state = 272, .external_lex_state = 10},
  [10516] = {.lex_state = 272, .external_lex_state = 10},
  [10517] = {.lex_state = 364, .external_lex_state = 10},
  [10518] = {.lex_state = 364, .external_lex_state = 10},
  [10519] = {.lex_state = 231, .external_lex_state = 10},
  [10520] = {.lex_state = 364, .external_lex_state = 10},
  [10521] = {.lex_state = 363, .external_lex_state = 9},
  [10522] = {.lex_state = 234, .external_lex_state = 10},
  [10523] = {.lex_state = 231, .external_lex_state = 10},
  [10524] = {.lex_state = 364, .external_lex_state = 10},
  [10525] = {.lex_state = 233, .external_lex_state = 10},
  [10526] = {.lex_state = 234, .external_lex_state = 10},
  [10527] = {.lex_state = 256, .external_lex_state = 10},
  [10528] = {.lex_state = 364, .external_lex_state = 10},
  [10529] = {.lex_state = 233, .external_lex_state = 10},
  [10530] = {.lex_state = 363, .external_lex_state = 9},
  [10531] = {.lex_state = 232, .external_lex_state = 10},
  [10532] = {.lex_state = 384, .external_lex_state = 10},
  [10533] = {.lex_state = 530, .external_lex_state = 10},
  [10534] = {.lex_state = 537, .external_lex_state = 12},
  [10535] = {.lex_state = 229, .external_lex_state = 10},
  [10536] = {.lex_state = 384, .external_lex_state = 10},
  [10537] = {.lex_state = 384, .external_lex_state = 10},
  [10538] = {.lex_state = 537, .external_lex_state = 12},
  [10539] = {.lex_state = 384, .external_lex_state = 10},
  [10540] = {.lex_state = 529, .external_lex_state = 9},
  [10541] = {.lex_state = 537, .external_lex_state = 12},
  [10542] = {.lex_state = 229, .external_lex_state = 10},
  [10543] = {.lex_state = 268, .external_lex_state = 10},
  [10544] = {.lex_state = 268, .external_lex_state = 10},
  [10545] = {.lex_state = 268, .external_lex_state = 10},
  [10546] = {.lex_state = 537, .external_lex_state = 12},
  [10547] = {.lex_state = 366, .external_lex_state = 10},
  [10548] = {.lex_state = 537, .external_lex_state = 12},
  [10549] = {.lex_state = 229, .external_lex_state = 10},
  [10550] = {.lex_state = 538, .external_lex_state = 9},
  [10551] = {.lex_state = 530, .external_lex_state = 10},
  [10552] = {.lex_state = 237, .external_lex_state = 10},
  [10553] = {.lex_state = 237, .external_lex_state = 10},
  [10554] = {.lex_state = 254, .external_lex_state = 9},
  [10555] = {.lex_state = 234, .external_lex_state = 10},
  [10556] = {.lex_state = 268, .external_lex_state = 10},
  [10557] = {.lex_state = 268, .external_lex_state = 10},
  [10558] = {.lex_state = 268, .external_lex_state = 10},
  [10559] = {.lex_state = 537, .external_lex_state = 12},
  [10560] = {.lex_state = 229, .external_lex_state = 10},
  [10561] = {.lex_state = 268, .external_lex_state = 10},
  [10562] = {.lex_state = 266, .external_lex_state = 10},
  [10563] = {.lex_state = 537, .external_lex_state = 12},
  [10564] = {.lex_state = 537, .external_lex_state = 12},
  [10565] = {.lex_state = 537, .external_lex_state = 12},
  [10566] = {.lex_state = 530, .external_lex_state = 10},
  [10567] = {.lex_state = 537, .external_lex_state = 12},
  [10568] = {.lex_state = 537, .external_lex_state = 12},
  [10569] = {.lex_state = 537, .external_lex_state = 12},
  [10570] = {.lex_state = 268, .external_lex_state = 10},
  [10571] = {.lex_state = 380, .external_lex_state = 10},
  [10572] = {.lex_state = 530, .external_lex_state = 10},
  [10573] = {.lex_state = 363, .external_lex_state = 9},
  [10574] = {.lex_state = 363, .external_lex_state = 9},
  [10575] = {.lex_state = 268, .external_lex_state = 10},
  [10576] = {.lex_state = 229, .external_lex_state = 10},
  [10577] = {.lex_state = 254, .external_lex_state = 9},
  [10578] = {.lex_state = 537, .external_lex_state = 12},
  [10579] = {.lex_state = 380, .external_lex_state = 9},
  [10580] = {.lex_state = 537, .external_lex_state = 12},
  [10581] = {.lex_state = 537, .external_lex_state = 12},
  [10582] = {.lex_state = 384, .external_lex_state = 10},
  [10583] = {.lex_state = 229, .external_lex_state = 10},
  [10584] = {.lex_state = 530, .external_lex_state = 9},
  [10585] = {.lex_state = 537, .external_lex_state = 12},
  [10586] = {.lex_state = 537, .external_lex_state = 12},
  [10587] = {.lex_state = 537, .external_lex_state = 12},
  [10588] = {.lex_state = 273, .external_lex_state = 10},
  [10589] = {.lex_state = 537, .external_lex_state = 12},
  [10590] = {.lex_state = 363, .external_lex_state = 9},
  [10591] = {.lex_state = 530, .external_lex_state = 10},
  [10592] = {.lex_state = 537, .external_lex_state = 12},
  [10593] = {.lex_state = 380, .external_lex_state = 10},
  [10594] = {.lex_state = 380, .external_lex_state = 10},
  [10595] = {.lex_state = 537, .external_lex_state = 12},
  [10596] = {.lex_state = 537, .external_lex_state = 12},
  [10597] = {.lex_state = 229, .external_lex_state = 10},
  [10598] = {.lex_state = 229, .external_lex_state = 10},
  [10599] = {.lex_state = 229, .external_lex_state = 10},
  [10600] = {.lex_state = 229, .external_lex_state = 10},
  [10601] = {.lex_state = 380, .external_lex_state = 10},
  [10602] = {.lex_state = 537, .external_lex_state = 12},
  [10603] = {.lex_state = 380, .external_lex_state = 9},
  [10604] = {.lex_state = 537, .external_lex_state = 12},
  [10605] = {.lex_state = 384, .external_lex_state = 10},
  [10606] = {.lex_state = 229, .external_lex_state = 10},
  [10607] = {.lex_state = 229, .external_lex_state = 10},
  [10608] = {.lex_state = 229, .external_lex_state = 10},
  [10609] = {.lex_state = 537, .external_lex_state = 12},
  [10610] = {.lex_state = 537, .external_lex_state = 12},
  [10611] = {.lex_state = 384, .external_lex_state = 10},
  [10612] = {.lex_state = 538, .external_lex_state = 10},
  [10613] = {.lex_state = 530, .external_lex_state = 9},
  [10614] = {.lex_state = 530, .external_lex_state = 9},
  [10615] = {.lex_state = 384, .external_lex_state = 10},
  [10616] = {.lex_state = 229, .external_lex_state = 10},
  [10617] = {.lex_state = 384, .external_lex_state = 10},
  [10618] = {.lex_state = 384, .external_lex_state = 10},
  [10619] = {.lex_state = 229, .external_lex_state = 10},
  [10620] = {.lex_state = 364, .external_lex_state = 9},
  [10621] = {.lex_state = 229, .external_lex_state = 10},
  [10622] = {.lex_state = 380, .external_lex_state = 10},
  [10623] = {.lex_state = 234, .external_lex_state = 10},
  [10624] = {.lex_state = 229, .external_lex_state = 10},
  [10625] = {.lex_state = 380, .external_lex_state = 10},
  [10626] = {.lex_state = 364, .external_lex_state = 9},
  [10627] = {.lex_state = 234, .external_lex_state = 10},
  [10628] = {.lex_state = 380, .external_lex_state = 10},
  [10629] = {.lex_state = 229, .external_lex_state = 10},
  [10630] = {.lex_state = 530, .external_lex_state = 10},
  [10631] = {.lex_state = 234, .external_lex_state = 10},
  [10632] = {.lex_state = 384, .external_lex_state = 10},
  [10633] = {.lex_state = 261, .external_lex_state = 10},
  [10634] = {.lex_state = 267, .external_lex_state = 10},
  [10635] = {.lex_state = 530, .external_lex_state = 9},
  [10636] = {.lex_state = 229, .external_lex_state = 10},
  [10637] = {.lex_state = 537, .external_lex_state = 12},
  [10638] = {.lex_state = 538, .external_lex_state = 9},
  [10639] = {.lex_state = 364, .external_lex_state = 9},
  [10640] = {.lex_state = 384, .external_lex_state = 10},
  [10641] = {.lex_state = 537, .external_lex_state = 12},
  [10642] = {.lex_state = 537, .external_lex_state = 12},
  [10643] = {.lex_state = 257, .external_lex_state = 10},
  [10644] = {.lex_state = 267, .external_lex_state = 10},
  [10645] = {.lex_state = 384, .external_lex_state = 10},
  [10646] = {.lex_state = 537, .external_lex_state = 12},
  [10647] = {.lex_state = 237, .external_lex_state = 10},
  [10648] = {.lex_state = 537, .external_lex_state = 12},
  [10649] = {.lex_state = 229, .external_lex_state = 10},
  [10650] = {.lex_state = 380, .external_lex_state = 10},
  [10651] = {.lex_state = 537, .external_lex_state = 12},
  [10652] = {.lex_state = 380, .external_lex_state = 10},
  [10653] = {.lex_state = 257, .external_lex_state = 10},
  [10654] = {.lex_state = 237, .external_lex_state = 10},
  [10655] = {.lex_state = 229, .external_lex_state = 10},
  [10656] = {.lex_state = 229, .external_lex_state = 10},
  [10657] = {.lex_state = 229, .external_lex_state = 10},
  [10658] = {.lex_state = 537, .external_lex_state = 12},
  [10659] = {.lex_state = 537, .external_lex_state = 12},
  [10660] = {.lex_state = 380, .external_lex_state = 10},
  [10661] = {.lex_state = 229, .external_lex_state = 10},
  [10662] = {.lex_state = 229, .external_lex_state = 10},
  [10663] = {.lex_state = 229, .external_lex_state = 10},
  [10664] = {.lex_state = 229, .external_lex_state = 10},
  [10665] = {.lex_state = 229, .external_lex_state = 10},
  [10666] = {.lex_state = 384, .external_lex_state = 10},
  [10667] = {.lex_state = 384, .external_lex_state = 10},
  [10668] = {.lex_state = 384, .external_lex_state = 10},
  [10669] = {.lex_state = 537, .external_lex_state = 12},
  [10670] = {.lex_state = 229, .external_lex_state = 10},
  [10671] = {.lex_state = 229, .external_lex_state = 10},
  [10672] = {.lex_state = 380, .external_lex_state = 9},
  [10673] = {.lex_state = 229, .external_lex_state = 10},
  [10674] = {.lex_state = 384, .external_lex_state = 10},
  [10675] = {.lex_state = 229, .external_lex_state = 10},
  [10676] = {.lex_state = 264, .external_lex_state = 10},
  [10677] = {.lex_state = 234, .external_lex_state = 10},
  [10678] = {.lex_state = 363, .external_lex_state = 9},
  [10679] = {.lex_state = 229, .external_lex_state = 10},
  [10680] = {.lex_state = 384, .external_lex_state = 10},
  [10681] = {.lex_state = 229, .external_lex_state = 10},
  [10682] = {.lex_state = 264, .external_lex_state = 10},
  [10683] = {.lex_state = 261, .external_lex_state = 10},
  [10684] = {.lex_state = 229, .external_lex_state = 10},
  [10685] = {.lex_state = 538, .external_lex_state = 9},
  [10686] = {.lex_state = 384, .external_lex_state = 10},
  [10687] = {.lex_state = 384, .external_lex_state = 10},
  [10688] = {.lex_state = 384, .external_lex_state = 10},
  [10689] = {.lex_state = 384, .external_lex_state = 10},
  [10690] = {.lex_state = 229, .external_lex_state = 10},
  [10691] = {.lex_state = 229, .external_lex_state = 10},
  [10692] = {.lex_state = 537, .external_lex_state = 12},
  [10693] = {.lex_state = 366, .external_lex_state = 10},
  [10694] = {.lex_state = 537, .external_lex_state = 12},
  [10695] = {.lex_state = 384, .external_lex_state = 10},
  [10696] = {.lex_state = 363, .external_lex_state = 9},
  [10697] = {.lex_state = 537, .external_lex_state = 12},
  [10698] = {.lex_state = 384, .external_lex_state = 10},
  [10699] = {.lex_state = 537, .external_lex_state = 12},
  [10700] = {.lex_state = 537, .external_lex_state = 12},
  [10701] = {.lex_state = 229, .external_lex_state = 10},
  [10702] = {.lex_state = 537, .external_lex_state = 12},
  [10703] = {.lex_state = 229, .external_lex_state = 10},
  [10704] = {.lex_state = 537, .external_lex_state = 12},
  [10705] = {.lex_state = 537, .external_lex_state = 12},
  [10706] = {.lex_state = 537, .external_lex_state = 12},
  [10707] = {.lex_state = 537, .external_lex_state = 12},
  [10708] = {.lex_state = 384, .external_lex_state = 10},
  [10709] = {.lex_state = 384, .external_lex_state = 10},
  [10710] = {.lex_state = 384, .external_lex_state = 10},
  [10711] = {.lex_state = 384, .external_lex_state = 10},
  [10712] = {.lex_state = 384, .external_lex_state = 10},
  [10713] = {.lex_state = 384, .external_lex_state = 10},
  [10714] = {.lex_state = 384, .external_lex_state = 10},
  [10715] = {.lex_state = 384, .external_lex_state = 10},
  [10716] = {.lex_state = 229, .external_lex_state = 10},
  [10717] = {.lex_state = 366, .external_lex_state = 10},
  [10718] = {.lex_state = 384, .external_lex_state = 10},
  [10719] = {.lex_state = 270, .external_lex_state = 10},
  [10720] = {.lex_state = 270, .external_lex_state = 10},
  [10721] = {.lex_state = 229, .external_lex_state = 10},
  [10722] = {.lex_state = 270, .external_lex_state = 10},
  [10723] = {.lex_state = 257, .external_lex_state = 10},
  [10724] = {.lex_state = 384, .external_lex_state = 10},
  [10725] = {.lex_state = 270, .external_lex_state = 10},
  [10726] = {.lex_state = 537, .external_lex_state = 12},
  [10727] = {.lex_state = 229, .external_lex_state = 10},
  [10728] = {.lex_state = 537, .external_lex_state = 12},
  [10729] = {.lex_state = 537, .external_lex_state = 12},
  [10730] = {.lex_state = 380, .external_lex_state = 10},
  [10731] = {.lex_state = 254, .external_lex_state = 10},
  [10732] = {.lex_state = 532, .external_lex_state = 10},
  [10733] = {.lex_state = 381, .external_lex_state = 10},
  [10734] = {.lex_state = 254, .external_lex_state = 9},
  [10735] = {.lex_state = 254, .external_lex_state = 10},
  [10736] = {.lex_state = 384, .external_lex_state = 10},
  [10737] = {.lex_state = 381, .external_lex_state = 10},
  [10738] = {.lex_state = 384, .external_lex_state = 10},
  [10739] = {.lex_state = 261, .external_lex_state = 10},
  [10740] = {.lex_state = 257, .external_lex_state = 10},
  [10741] = {.lex_state = 257, .external_lex_state = 10},
  [10742] = {.lex_state = 266, .external_lex_state = 10},
  [10743] = {.lex_state = 257, .external_lex_state = 10},
  [10744] = {.lex_state = 384, .external_lex_state = 10},
  [10745] = {.lex_state = 384, .external_lex_state = 10},
  [10746] = {.lex_state = 532, .external_lex_state = 10},
  [10747] = {.lex_state = 537, .external_lex_state = 12},
  [10748] = {.lex_state = 384, .external_lex_state = 10},
  [10749] = {.lex_state = 537, .external_lex_state = 12},
  [10750] = {.lex_state = 384, .external_lex_state = 10},
  [10751] = {.lex_state = 384, .external_lex_state = 10},
  [10752] = {.lex_state = 264, .external_lex_state = 10},
  [10753] = {.lex_state = 383, .external_lex_state = 10},
  [10754] = {.lex_state = 229, .external_lex_state = 10},
  [10755] = {.lex_state = 234, .external_lex_state = 10},
  [10756] = {.lex_state = 234, .external_lex_state = 10},
  [10757] = {.lex_state = 234, .external_lex_state = 10},
  [10758] = {.lex_state = 537, .external_lex_state = 12},
  [10759] = {.lex_state = 384, .external_lex_state = 10},
  [10760] = {.lex_state = 234, .external_lex_state = 10},
  [10761] = {.lex_state = 234, .external_lex_state = 10},
  [10762] = {.lex_state = 261, .external_lex_state = 10},
  [10763] = {.lex_state = 234, .external_lex_state = 10},
  [10764] = {.lex_state = 234, .external_lex_state = 10},
  [10765] = {.lex_state = 234, .external_lex_state = 10},
  [10766] = {.lex_state = 234, .external_lex_state = 10},
  [10767] = {.lex_state = 384, .external_lex_state = 10},
  [10768] = {.lex_state = 234, .external_lex_state = 10},
  [10769] = {.lex_state = 234, .external_lex_state = 10},
  [10770] = {.lex_state = 540, .external_lex_state = 9},
  [10771] = {.lex_state = 234, .external_lex_state = 10},
  [10772] = {.lex_state = 234, .external_lex_state = 10},
  [10773] = {.lex_state = 234, .external_lex_state = 10},
  [10774] = {.lex_state = 234, .external_lex_state = 10},
  [10775] = {.lex_state = 257, .external_lex_state = 10},
  [10776] = {.lex_state = 234, .external_lex_state = 10},
  [10777] = {.lex_state = 234, .external_lex_state = 10},
  [10778] = {.lex_state = 234, .external_lex_state = 10},
  [10779] = {.lex_state = 234, .external_lex_state = 10},
  [10780] = {.lex_state = 257, .external_lex_state = 10},
  [10781] = {.lex_state = 537, .external_lex_state = 12},
  [10782] = {.lex_state = 537, .external_lex_state = 12},
  [10783] = {.lex_state = 380, .external_lex_state = 9},
  [10784] = {.lex_state = 363, .external_lex_state = 9},
  [10785] = {.lex_state = 257, .external_lex_state = 10},
  [10786] = {.lex_state = 540, .external_lex_state = 9},
  [10787] = {.lex_state = 540, .external_lex_state = 9},
  [10788] = {.lex_state = 540, .external_lex_state = 9},
  [10789] = {.lex_state = 266, .external_lex_state = 10},
  [10790] = {.lex_state = 234, .external_lex_state = 10},
  [10791] = {.lex_state = 537, .external_lex_state = 12},
  [10792] = {.lex_state = 264, .external_lex_state = 10},
  [10793] = {.lex_state = 234, .external_lex_state = 10},
  [10794] = {.lex_state = 234, .external_lex_state = 10},
  [10795] = {.lex_state = 234, .external_lex_state = 10},
  [10796] = {.lex_state = 234, .external_lex_state = 10},
  [10797] = {.lex_state = 229, .external_lex_state = 10},
  [10798] = {.lex_state = 229, .external_lex_state = 10},
  [10799] = {.lex_state = 234, .external_lex_state = 10},
  [10800] = {.lex_state = 363, .external_lex_state = 9},
  [10801] = {.lex_state = 537, .external_lex_state = 9},
  [10802] = {.lex_state = 234, .external_lex_state = 10},
  [10803] = {.lex_state = 234, .external_lex_state = 10},
  [10804] = {.lex_state = 234, .external_lex_state = 10},
  [10805] = {.lex_state = 234, .external_lex_state = 10},
  [10806] = {.lex_state = 234, .external_lex_state = 10},
  [10807] = {.lex_state = 253, .external_lex_state = 10},
  [10808] = {.lex_state = 234, .external_lex_state = 10},
  [10809] = {.lex_state = 254, .external_lex_state = 10},
  [10810] = {.lex_state = 234, .external_lex_state = 10},
  [10811] = {.lex_state = 537, .external_lex_state = 9},
  [10812] = {.lex_state = 537, .external_lex_state = 9},
  [10813] = {.lex_state = 253, .external_lex_state = 10},
  [10814] = {.lex_state = 384, .external_lex_state = 10},
  [10815] = {.lex_state = 537, .external_lex_state = 12},
  [10816] = {.lex_state = 257, .external_lex_state = 10},
  [10817] = {.lex_state = 257, .external_lex_state = 10},
  [10818] = {.lex_state = 530, .external_lex_state = 9},
  [10819] = {.lex_state = 537, .external_lex_state = 9},
  [10820] = {.lex_state = 229, .external_lex_state = 10},
  [10821] = {.lex_state = 529, .external_lex_state = 9},
  [10822] = {.lex_state = 254, .external_lex_state = 9},
  [10823] = {.lex_state = 257, .external_lex_state = 10},
  [10824] = {.lex_state = 253, .external_lex_state = 10},
  [10825] = {.lex_state = 229, .external_lex_state = 10},
  [10826] = {.lex_state = 234, .external_lex_state = 10},
  [10827] = {.lex_state = 229, .external_lex_state = 10},
  [10828] = {.lex_state = 540, .external_lex_state = 9},
  [10829] = {.lex_state = 540, .external_lex_state = 9},
  [10830] = {.lex_state = 540, .external_lex_state = 9},
  [10831] = {.lex_state = 540, .external_lex_state = 9},
  [10832] = {.lex_state = 234, .external_lex_state = 10},
  [10833] = {.lex_state = 254, .external_lex_state = 9},
  [10834] = {.lex_state = 253, .external_lex_state = 10},
  [10835] = {.lex_state = 537, .external_lex_state = 12},
  [10836] = {.lex_state = 254, .external_lex_state = 10},
  [10837] = {.lex_state = 268, .external_lex_state = 10},
  [10838] = {.lex_state = 540, .external_lex_state = 9},
  [10839] = {.lex_state = 540, .external_lex_state = 9},
  [10840] = {.lex_state = 540, .external_lex_state = 9},
  [10841] = {.lex_state = 540, .external_lex_state = 9},
  [10842] = {.lex_state = 234, .external_lex_state = 10},
  [10843] = {.lex_state = 532, .external_lex_state = 10},
  [10844] = {.lex_state = 537, .external_lex_state = 12},
  [10845] = {.lex_state = 532, .external_lex_state = 10},
  [10846] = {.lex_state = 537, .external_lex_state = 9},
  [10847] = {.lex_state = 234, .external_lex_state = 10},
  [10848] = {.lex_state = 537, .external_lex_state = 12},
  [10849] = {.lex_state = 537, .external_lex_state = 9},
  [10850] = {.lex_state = 537, .external_lex_state = 9},
  [10851] = {.lex_state = 537, .external_lex_state = 9},
  [10852] = {.lex_state = 537, .external_lex_state = 12},
  [10853] = {.lex_state = 229, .external_lex_state = 10},
  [10854] = {.lex_state = 380, .external_lex_state = 10},
  [10855] = {.lex_state = 229, .external_lex_state = 10},
  [10856] = {.lex_state = 537, .external_lex_state = 12},
  [10857] = {.lex_state = 384, .external_lex_state = 10},
  [10858] = {.lex_state = 538, .external_lex_state = 9},
  [10859] = {.lex_state = 381, .external_lex_state = 10},
  [10860] = {.lex_state = 537, .external_lex_state = 12},
  [10861] = {.lex_state = 537, .external_lex_state = 12},
  [10862] = {.lex_state = 384, .external_lex_state = 10},
  [10863] = {.lex_state = 381, .external_lex_state = 10},
  [10864] = {.lex_state = 537, .external_lex_state = 12},
  [10865] = {.lex_state = 537, .external_lex_state = 12},
  [10866] = {.lex_state = 229, .external_lex_state = 10},
  [10867] = {.lex_state = 234, .external_lex_state = 10},
  [10868] = {.lex_state = 234, .external_lex_state = 10},
  [10869] = {.lex_state = 234, .external_lex_state = 10},
  [10870] = {.lex_state = 538, .external_lex_state = 10},
  [10871] = {.lex_state = 537, .external_lex_state = 12},
  [10872] = {.lex_state = 234, .external_lex_state = 10},
  [10873] = {.lex_state = 538, .external_lex_state = 13},
  [10874] = {.lex_state = 234, .external_lex_state = 10},
  [10875] = {.lex_state = 537, .external_lex_state = 12},
  [10876] = {.lex_state = 537, .external_lex_state = 12},
  [10877] = {.lex_state = 530, .external_lex_state = 10},
  [10878] = {.lex_state = 537, .external_lex_state = 12},
  [10879] = {.lex_state = 229, .external_lex_state = 10},
  [10880] = {.lex_state = 267, .external_lex_state = 10},
  [10881] = {.lex_state = 268, .external_lex_state = 10},
  [10882] = {.lex_state = 537, .external_lex_state = 12},
  [10883] = {.lex_state = 537, .external_lex_state = 12},
  [10884] = {.lex_state = 267, .external_lex_state = 10},
  [10885] = {.lex_state = 258, .external_lex_state = 10},
  [10886] = {.lex_state = 537, .external_lex_state = 12},
  [10887] = {.lex_state = 229, .external_lex_state = 10},
  [10888] = {.lex_state = 366, .external_lex_state = 10},
  [10889] = {.lex_state = 384, .external_lex_state = 10},
  [10890] = {.lex_state = 384, .external_lex_state = 10},
  [10891] = {.lex_state = 234, .external_lex_state = 10},
  [10892] = {.lex_state = 234, .external_lex_state = 10},
  [10893] = {.lex_state = 537, .external_lex_state = 12},
  [10894] = {.lex_state = 234, .external_lex_state = 10},
  [10895] = {.lex_state = 537, .external_lex_state = 12},
  [10896] = {.lex_state = 537, .external_lex_state = 12},
  [10897] = {.lex_state = 384, .external_lex_state = 10},
  [10898] = {.lex_state = 537, .external_lex_state = 12},
  [10899] = {.lex_state = 234, .external_lex_state = 10},
  [10900] = {.lex_state = 268, .external_lex_state = 10},
  [10901] = {.lex_state = 234, .external_lex_state = 10},
  [10902] = {.lex_state = 530, .external_lex_state = 9},
  [10903] = {.lex_state = 537, .external_lex_state = 12},
  [10904] = {.lex_state = 537, .external_lex_state = 12},
  [10905] = {.lex_state = 229, .external_lex_state = 10},
  [10906] = {.lex_state = 266, .external_lex_state = 10},
  [10907] = {.lex_state = 234, .external_lex_state = 10},
  [10908] = {.lex_state = 234, .external_lex_state = 10},
  [10909] = {.lex_state = 234, .external_lex_state = 10},
  [10910] = {.lex_state = 234, .external_lex_state = 10},
  [10911] = {.lex_state = 234, .external_lex_state = 10},
  [10912] = {.lex_state = 384, .external_lex_state = 10},
  [10913] = {.lex_state = 537, .external_lex_state = 12},
  [10914] = {.lex_state = 384, .external_lex_state = 10},
  [10915] = {.lex_state = 384, .external_lex_state = 10},
  [10916] = {.lex_state = 229, .external_lex_state = 10},
  [10917] = {.lex_state = 234, .external_lex_state = 10},
  [10918] = {.lex_state = 229, .external_lex_state = 10},
  [10919] = {.lex_state = 537, .external_lex_state = 12},
  [10920] = {.lex_state = 537, .external_lex_state = 12},
  [10921] = {.lex_state = 384, .external_lex_state = 10},
  [10922] = {.lex_state = 253, .external_lex_state = 10},
  [10923] = {.lex_state = 384, .external_lex_state = 10},
  [10924] = {.lex_state = 537, .external_lex_state = 12},
  [10925] = {.lex_state = 253, .external_lex_state = 10},
  [10926] = {.lex_state = 253, .external_lex_state = 10},
  [10927] = {.lex_state = 253, .external_lex_state = 10},
  [10928] = {.lex_state = 537, .external_lex_state = 12},
  [10929] = {.lex_state = 537, .external_lex_state = 12},
  [10930] = {.lex_state = 538, .external_lex_state = 10},
  [10931] = {.lex_state = 538, .external_lex_state = 9},
  [10932] = {.lex_state = 538, .external_lex_state = 10},
  [10933] = {.lex_state = 537, .external_lex_state = 12},
  [10934] = {.lex_state = 268, .external_lex_state = 10},
  [10935] = {.lex_state = 257, .external_lex_state = 10},
  [10936] = {.lex_state = 257, .external_lex_state = 10},
  [10937] = {.lex_state = 257, .external_lex_state = 10},
  [10938] = {.lex_state = 257, .external_lex_state = 10},
  [10939] = {.lex_state = 386, .external_lex_state = 10},
  [10940] = {.lex_state = 386, .external_lex_state = 10},
  [10941] = {.lex_state = 254, .external_lex_state = 10},
  [10942] = {.lex_state = 271, .external_lex_state = 10},
  [10943] = {.lex_state = 257, .external_lex_state = 10},
  [10944] = {.lex_state = 537, .external_lex_state = 9},
  [10945] = {.lex_state = 257, .external_lex_state = 10},
  [10946] = {.lex_state = 537, .external_lex_state = 9},
  [10947] = {.lex_state = 262, .external_lex_state = 10},
  [10948] = {.lex_state = 257, .external_lex_state = 10},
  [10949] = {.lex_state = 257, .external_lex_state = 10},
  [10950] = {.lex_state = 257, .external_lex_state = 10},
  [10951] = {.lex_state = 380, .external_lex_state = 10},
  [10952] = {.lex_state = 257, .external_lex_state = 10},
  [10953] = {.lex_state = 380, .external_lex_state = 10},
  [10954] = {.lex_state = 537, .external_lex_state = 9},
  [10955] = {.lex_state = 380, .external_lex_state = 10},
  [10956] = {.lex_state = 257, .external_lex_state = 10},
  [10957] = {.lex_state = 257, .external_lex_state = 10},
  [10958] = {.lex_state = 380, .external_lex_state = 10},
  [10959] = {.lex_state = 257, .external_lex_state = 10},
  [10960] = {.lex_state = 257, .external_lex_state = 10},
  [10961] = {.lex_state = 380, .external_lex_state = 10},
  [10962] = {.lex_state = 380, .external_lex_state = 10},
  [10963] = {.lex_state = 380, .external_lex_state = 10},
  [10964] = {.lex_state = 257, .external_lex_state = 10},
  [10965] = {.lex_state = 257, .external_lex_state = 10},
  [10966] = {.lex_state = 380, .external_lex_state = 10},
  [10967] = {.lex_state = 257, .external_lex_state = 10},
  [10968] = {.lex_state = 268, .external_lex_state = 10},
  [10969] = {.lex_state = 530, .external_lex_state = 10},
  [10970] = {.lex_state = 538, .external_lex_state = 10},
  [10971] = {.lex_state = 257, .external_lex_state = 10},
  [10972] = {.lex_state = 257, .external_lex_state = 10},
  [10973] = {.lex_state = 257, .external_lex_state = 10},
  [10974] = {.lex_state = 257, .external_lex_state = 10},
  [10975] = {.lex_state = 257, .external_lex_state = 10},
  [10976] = {.lex_state = 363, .external_lex_state = 9},
  [10977] = {.lex_state = 268, .external_lex_state = 10},
  [10978] = {.lex_state = 257, .external_lex_state = 10},
  [10979] = {.lex_state = 257, .external_lex_state = 10},
  [10980] = {.lex_state = 254, .external_lex_state = 10},
  [10981] = {.lex_state = 257, .external_lex_state = 10},
  [10982] = {.lex_state = 257, .external_lex_state = 10},
  [10983] = {.lex_state = 380, .external_lex_state = 10},
  [10984] = {.lex_state = 259, .external_lex_state = 10},
  [10985] = {.lex_state = 259, .external_lex_state = 10},
  [10986] = {.lex_state = 268, .external_lex_state = 10},
  [10987] = {.lex_state = 257, .external_lex_state = 10},
  [10988] = {.lex_state = 538, .external_lex_state = 10},
  [10989] = {.lex_state = 380, .external_lex_state = 10},
  [10990] = {.lex_state = 254, .external_lex_state = 10},
  [10991] = {.lex_state = 530, .external_lex_state = 10},
  [10992] = {.lex_state = 260, .external_lex_state = 10},
  [10993] = {.lex_state = 538, .external_lex_state = 10},
  [10994] = {.lex_state = 380, .external_lex_state = 10},
  [10995] = {.lex_state = 530, .external_lex_state = 10},
  [10996] = {.lex_state = 538, .external_lex_state = 10},
  [10997] = {.lex_state = 386, .external_lex_state = 10},
  [10998] = {.lex_state = 384, .external_lex_state = 9},
  [10999] = {.lex_state = 380, .external_lex_state = 10},
  [11000] = {.lex_state = 254, .external_lex_state = 10},
  [11001] = {.lex_state = 380, .external_lex_state = 10},
  [11002] = {.lex_state = 254, .external_lex_state = 10},
  [11003] = {.lex_state = 268, .external_lex_state = 10},
  [11004] = {.lex_state = 380, .external_lex_state = 10},
  [11005] = {.lex_state = 254, .external_lex_state = 10},
  [11006] = {.lex_state = 234, .external_lex_state = 10},
  [11007] = {.lex_state = 268, .external_lex_state = 10},
  [11008] = {.lex_state = 537, .external_lex_state = 9},
  [11009] = {.lex_state = 363, .external_lex_state = 9},
  [11010] = {.lex_state = 268, .external_lex_state = 10},
  [11011] = {.lex_state = 537, .external_lex_state = 9},
  [11012] = {.lex_state = 537, .external_lex_state = 9},
  [11013] = {.lex_state = 537, .external_lex_state = 9},
  [11014] = {.lex_state = 530, .external_lex_state = 10},
  [11015] = {.lex_state = 386, .external_lex_state = 10},
  [11016] = {.lex_state = 265, .external_lex_state = 10},
  [11017] = {.lex_state = 262, .external_lex_state = 10},
  [11018] = {.lex_state = 260, .external_lex_state = 10},
  [11019] = {.lex_state = 271, .external_lex_state = 10},
  [11020] = {.lex_state = 538, .external_lex_state = 10},
  [11021] = {.lex_state = 254, .external_lex_state = 10},
  [11022] = {.lex_state = 384, .external_lex_state = 10},
  [11023] = {.lex_state = 530, .external_lex_state = 10},
  [11024] = {.lex_state = 537, .external_lex_state = 9},
  [11025] = {.lex_state = 529, .external_lex_state = 9},
  [11026] = {.lex_state = 537, .external_lex_state = 9},
  [11027] = {.lex_state = 537, .external_lex_state = 9},
  [11028] = {.lex_state = 537, .external_lex_state = 9},
  [11029] = {.lex_state = 540, .external_lex_state = 9},
  [11030] = {.lex_state = 538, .external_lex_state = 10},
  [11031] = {.lex_state = 254, .external_lex_state = 10},
  [11032] = {.lex_state = 540, .external_lex_state = 9},
  [11033] = {.lex_state = 538, .external_lex_state = 10},
  [11034] = {.lex_state = 384, .external_lex_state = 9},
  [11035] = {.lex_state = 380, .external_lex_state = 10},
  [11036] = {.lex_state = 384, .external_lex_state = 9},
  [11037] = {.lex_state = 254, .external_lex_state = 10},
  [11038] = {.lex_state = 257, .external_lex_state = 10},
  [11039] = {.lex_state = 380, .external_lex_state = 10},
  [11040] = {.lex_state = 380, .external_lex_state = 10},
  [11041] = {.lex_state = 257, .external_lex_state = 10},
  [11042] = {.lex_state = 380, .external_lex_state = 10},
  [11043] = {.lex_state = 268, .external_lex_state = 10},
  [11044] = {.lex_state = 380, .external_lex_state = 10},
  [11045] = {.lex_state = 268, .external_lex_state = 10},
  [11046] = {.lex_state = 538, .external_lex_state = 10},
  [11047] = {.lex_state = 380, .external_lex_state = 10},
  [11048] = {.lex_state = 268, .external_lex_state = 10},
  [11049] = {.lex_state = 538, .external_lex_state = 10},
  [11050] = {.lex_state = 538, .external_lex_state = 10},
  [11051] = {.lex_state = 380, .external_lex_state = 10},
  [11052] = {.lex_state = 543, .external_lex_state = 10},
  [11053] = {.lex_state = 380, .external_lex_state = 10},
  [11054] = {.lex_state = 530, .external_lex_state = 10},
  [11055] = {.lex_state = 380, .external_lex_state = 10},
  [11056] = {.lex_state = 380, .external_lex_state = 10},
  [11057] = {.lex_state = 268, .external_lex_state = 10},
  [11058] = {.lex_state = 380, .external_lex_state = 10},
  [11059] = {.lex_state = 543, .external_lex_state = 10},
  [11060] = {.lex_state = 268, .external_lex_state = 10},
  [11061] = {.lex_state = 538, .external_lex_state = 10},
  [11062] = {.lex_state = 380, .external_lex_state = 10},
  [11063] = {.lex_state = 540, .external_lex_state = 9},
  [11064] = {.lex_state = 268, .external_lex_state = 10},
  [11065] = {.lex_state = 538, .external_lex_state = 10},
  [11066] = {.lex_state = 255, .external_lex_state = 10},
  [11067] = {.lex_state = 268, .external_lex_state = 10},
  [11068] = {.lex_state = 540, .external_lex_state = 9},
  [11069] = {.lex_state = 384, .external_lex_state = 9},
  [11070] = {.lex_state = 259, .external_lex_state = 10},
  [11071] = {.lex_state = 259, .external_lex_state = 10},
  [11072] = {.lex_state = 380, .external_lex_state = 10},
  [11073] = {.lex_state = 530, .external_lex_state = 10},
  [11074] = {.lex_state = 257, .external_lex_state = 10},
  [11075] = {.lex_state = 254, .external_lex_state = 10},
  [11076] = {.lex_state = 268, .external_lex_state = 10},
  [11077] = {.lex_state = 254, .external_lex_state = 10},
  [11078] = {.lex_state = 380, .external_lex_state = 10},
  [11079] = {.lex_state = 268, .external_lex_state = 10},
  [11080] = {.lex_state = 268, .external_lex_state = 10},
  [11081] = {.lex_state = 380, .external_lex_state = 10},
  [11082] = {.lex_state = 268, .external_lex_state = 10},
  [11083] = {.lex_state = 268, .external_lex_state = 10},
  [11084] = {.lex_state = 268, .external_lex_state = 10},
  [11085] = {.lex_state = 268, .external_lex_state = 10},
  [11086] = {.lex_state = 268, .external_lex_state = 10},
  [11087] = {.lex_state = 380, .external_lex_state = 10},
  [11088] = {.lex_state = 262, .external_lex_state = 10},
  [11089] = {.lex_state = 268, .external_lex_state = 10},
  [11090] = {.lex_state = 268, .external_lex_state = 10},
  [11091] = {.lex_state = 268, .external_lex_state = 10},
  [11092] = {.lex_state = 268, .external_lex_state = 10},
  [11093] = {.lex_state = 268, .external_lex_state = 10},
  [11094] = {.lex_state = 268, .external_lex_state = 10},
  [11095] = {.lex_state = 268, .external_lex_state = 10},
  [11096] = {.lex_state = 268, .external_lex_state = 10},
  [11097] = {.lex_state = 380, .external_lex_state = 10},
  [11098] = {.lex_state = 268, .external_lex_state = 10},
  [11099] = {.lex_state = 380, .external_lex_state = 10},
  [11100] = {.lex_state = 268, .external_lex_state = 10},
  [11101] = {.lex_state = 268, .external_lex_state = 10},
  [11102] = {.lex_state = 268, .external_lex_state = 10},
  [11103] = {.lex_state = 268, .external_lex_state = 10},
  [11104] = {.lex_state = 268, .external_lex_state = 10},
  [11105] = {.lex_state = 268, .external_lex_state = 10},
  [11106] = {.lex_state = 268, .external_lex_state = 10},
  [11107] = {.lex_state = 268, .external_lex_state = 10},
  [11108] = {.lex_state = 268, .external_lex_state = 10},
  [11109] = {.lex_state = 268, .external_lex_state = 10},
  [11110] = {.lex_state = 268, .external_lex_state = 10},
  [11111] = {.lex_state = 257, .external_lex_state = 10},
  [11112] = {.lex_state = 380, .external_lex_state = 10},
  [11113] = {.lex_state = 380, .external_lex_state = 10},
  [11114] = {.lex_state = 268, .external_lex_state = 10},
  [11115] = {.lex_state = 268, .external_lex_state = 10},
  [11116] = {.lex_state = 268, .external_lex_state = 10},
  [11117] = {.lex_state = 268, .external_lex_state = 10},
  [11118] = {.lex_state = 257, .external_lex_state = 10},
  [11119] = {.lex_state = 257, .external_lex_state = 10},
  [11120] = {.lex_state = 268, .external_lex_state = 10},
  [11121] = {.lex_state = 268, .external_lex_state = 10},
  [11122] = {.lex_state = 268, .external_lex_state = 10},
  [11123] = {.lex_state = 257, .external_lex_state = 10},
  [11124] = {.lex_state = 380, .external_lex_state = 10},
  [11125] = {.lex_state = 268, .external_lex_state = 10},
  [11126] = {.lex_state = 257, .external_lex_state = 10},
  [11127] = {.lex_state = 260, .external_lex_state = 10},
  [11128] = {.lex_state = 260, .external_lex_state = 10},
  [11129] = {.lex_state = 257, .external_lex_state = 10},
  [11130] = {.lex_state = 380, .external_lex_state = 10},
  [11131] = {.lex_state = 530, .external_lex_state = 10},
  [11132] = {.lex_state = 380, .external_lex_state = 10},
  [11133] = {.lex_state = 268, .external_lex_state = 10},
  [11134] = {.lex_state = 262, .external_lex_state = 10},
  [11135] = {.lex_state = 257, .external_lex_state = 10},
  [11136] = {.lex_state = 257, .external_lex_state = 10},
  [11137] = {.lex_state = 530, .external_lex_state = 10},
  [11138] = {.lex_state = 380, .external_lex_state = 10},
  [11139] = {.lex_state = 257, .external_lex_state = 10},
  [11140] = {.lex_state = 257, .external_lex_state = 10},
  [11141] = {.lex_state = 257, .external_lex_state = 10},
  [11142] = {.lex_state = 268, .external_lex_state = 10},
  [11143] = {.lex_state = 540, .external_lex_state = 9},
  [11144] = {.lex_state = 530, .external_lex_state = 10},
  [11145] = {.lex_state = 257, .external_lex_state = 10},
  [11146] = {.lex_state = 530, .external_lex_state = 10},
  [11147] = {.lex_state = 257, .external_lex_state = 10},
  [11148] = {.lex_state = 530, .external_lex_state = 10},
  [11149] = {.lex_state = 380, .external_lex_state = 10},
  [11150] = {.lex_state = 268, .external_lex_state = 10},
  [11151] = {.lex_state = 380, .external_lex_state = 10},
  [11152] = {.lex_state = 540, .external_lex_state = 9},
  [11153] = {.lex_state = 257, .external_lex_state = 10},
  [11154] = {.lex_state = 530, .external_lex_state = 10},
  [11155] = {.lex_state = 380, .external_lex_state = 10},
  [11156] = {.lex_state = 380, .external_lex_state = 10},
  [11157] = {.lex_state = 530, .external_lex_state = 10},
  [11158] = {.lex_state = 540, .external_lex_state = 9},
  [11159] = {.lex_state = 257, .external_lex_state = 10},
  [11160] = {.lex_state = 380, .external_lex_state = 10},
  [11161] = {.lex_state = 380, .external_lex_state = 10},
  [11162] = {.lex_state = 543, .external_lex_state = 10},
  [11163] = {.lex_state = 257, .external_lex_state = 10},
  [11164] = {.lex_state = 380, .external_lex_state = 10},
  [11165] = {.lex_state = 380, .external_lex_state = 10},
  [11166] = {.lex_state = 257, .external_lex_state = 10},
  [11167] = {.lex_state = 363, .external_lex_state = 9},
  [11168] = {.lex_state = 257, .external_lex_state = 10},
  [11169] = {.lex_state = 543, .external_lex_state = 10},
  [11170] = {.lex_state = 271, .external_lex_state = 10},
  [11171] = {.lex_state = 380, .external_lex_state = 10},
  [11172] = {.lex_state = 537, .external_lex_state = 9},
  [11173] = {.lex_state = 229, .external_lex_state = 10},
  [11174] = {.lex_state = 257, .external_lex_state = 10},
  [11175] = {.lex_state = 380, .external_lex_state = 10},
  [11176] = {.lex_state = 257, .external_lex_state = 10},
  [11177] = {.lex_state = 257, .external_lex_state = 10},
  [11178] = {.lex_state = 268, .external_lex_state = 10},
  [11179] = {.lex_state = 380, .external_lex_state = 10},
  [11180] = {.lex_state = 380, .external_lex_state = 10},
  [11181] = {.lex_state = 257, .external_lex_state = 10},
  [11182] = {.lex_state = 254, .external_lex_state = 10},
  [11183] = {.lex_state = 257, .external_lex_state = 10},
  [11184] = {.lex_state = 380, .external_lex_state = 10},
  [11185] = {.lex_state = 380, .external_lex_state = 10},
  [11186] = {.lex_state = 540, .external_lex_state = 9},
  [11187] = {.lex_state = 268, .external_lex_state = 10},
  [11188] = {.lex_state = 271, .external_lex_state = 10},
  [11189] = {.lex_state = 257, .external_lex_state = 10},
  [11190] = {.lex_state = 540, .external_lex_state = 10},
  [11191] = {.lex_state = 257, .external_lex_state = 10},
  [11192] = {.lex_state = 380, .external_lex_state = 10},
  [11193] = {.lex_state = 540, .external_lex_state = 10},
  [11194] = {.lex_state = 380, .external_lex_state = 10},
  [11195] = {.lex_state = 538, .external_lex_state = 10},
  [11196] = {.lex_state = 542, .external_lex_state = 10},
  [11197] = {.lex_state = 542, .external_lex_state = 10},
  [11198] = {.lex_state = 530, .external_lex_state = 10},
  [11199] = {.lex_state = 530, .external_lex_state = 10},
  [11200] = {.lex_state = 530, .external_lex_state = 10},
  [11201] = {.lex_state = 537, .external_lex_state = 9},
  [11202] = {.lex_state = 530, .external_lex_state = 10},
  [11203] = {.lex_state = 530, .external_lex_state = 10},
  [11204] = {.lex_state = 380, .external_lex_state = 9},
  [11205] = {.lex_state = 263, .external_lex_state = 10},
  [11206] = {.lex_state = 263, .external_lex_state = 10},
  [11207] = {.lex_state = 530, .external_lex_state = 10},
  [11208] = {.lex_state = 530, .external_lex_state = 10},
  [11209] = {.lex_state = 368, .external_lex_state = 9},
  [11210] = {.lex_state = 538, .external_lex_state = 10},
  [11211] = {.lex_state = 538, .external_lex_state = 10},
  [11212] = {.lex_state = 254, .external_lex_state = 10},
  [11213] = {.lex_state = 364, .external_lex_state = 10},
  [11214] = {.lex_state = 542, .external_lex_state = 10},
  [11215] = {.lex_state = 538, .external_lex_state = 10},
  [11216] = {.lex_state = 542, .external_lex_state = 10},
  [11217] = {.lex_state = 538, .external_lex_state = 10},
  [11218] = {.lex_state = 538, .external_lex_state = 10},
  [11219] = {.lex_state = 254, .external_lex_state = 10},
  [11220] = {.lex_state = 530, .external_lex_state = 10},
  [11221] = {.lex_state = 368, .external_lex_state = 9},
  [11222] = {.lex_state = 538, .external_lex_state = 10},
  [11223] = {.lex_state = 538, .external_lex_state = 10},
  [11224] = {.lex_state = 537, .external_lex_state = 9},
  [11225] = {.lex_state = 364, .external_lex_state = 10},
  [11226] = {.lex_state = 537, .external_lex_state = 9},
  [11227] = {.lex_state = 380, .external_lex_state = 9},
  [11228] = {.lex_state = 364, .external_lex_state = 10},
  [11229] = {.lex_state = 537, .external_lex_state = 9},
  [11230] = {.lex_state = 380, .external_lex_state = 11},
  [11231] = {.lex_state = 364, .external_lex_state = 10},
  [11232] = {.lex_state = 538, .external_lex_state = 10},
  [11233] = {.lex_state = 254, .external_lex_state = 10},
  [11234] = {.lex_state = 254, .external_lex_state = 10},
  [11235] = {.lex_state = 254, .external_lex_state = 10},
  [11236] = {.lex_state = 380, .external_lex_state = 9},
  [11237] = {.lex_state = 368, .external_lex_state = 9},
  [11238] = {.lex_state = 254, .external_lex_state = 10},
  [11239] = {.lex_state = 530, .external_lex_state = 10},
  [11240] = {.lex_state = 254, .external_lex_state = 10},
  [11241] = {.lex_state = 537, .external_lex_state = 9},
  [11242] = {.lex_state = 364, .external_lex_state = 10},
  [11243] = {.lex_state = 380, .external_lex_state = 9},
  [11244] = {.lex_state = 254, .external_lex_state = 10},
  [11245] = {.lex_state = 254, .external_lex_state = 10},
  [11246] = {.lex_state = 538, .external_lex_state = 10},
  [11247] = {.lex_state = 229, .external_lex_state = 10},
  [11248] = {.lex_state = 254, .external_lex_state = 10},
  [11249] = {.lex_state = 254, .external_lex_state = 10},
  [11250] = {.lex_state = 254, .external_lex_state = 10},
  [11251] = {.lex_state = 254, .external_lex_state = 10},
  [11252] = {.lex_state = 364, .external_lex_state = 10},
  [11253] = {.lex_state = 538, .external_lex_state = 10},
  [11254] = {.lex_state = 254, .external_lex_state = 10},
  [11255] = {.lex_state = 254, .external_lex_state = 10},
  [11256] = {.lex_state = 254, .external_lex_state = 10},
  [11257] = {.lex_state = 368, .external_lex_state = 9},
  [11258] = {.lex_state = 254, .external_lex_state = 10},
  [11259] = {.lex_state = 254, .external_lex_state = 10},
  [11260] = {.lex_state = 254, .external_lex_state = 10},
  [11261] = {.lex_state = 254, .external_lex_state = 10},
  [11262] = {.lex_state = 254, .external_lex_state = 10},
  [11263] = {.lex_state = 254, .external_lex_state = 10},
  [11264] = {.lex_state = 254, .external_lex_state = 10},
  [11265] = {.lex_state = 254, .external_lex_state = 10},
  [11266] = {.lex_state = 254, .external_lex_state = 10},
  [11267] = {.lex_state = 254, .external_lex_state = 10},
  [11268] = {.lex_state = 254, .external_lex_state = 10},
  [11269] = {.lex_state = 254, .external_lex_state = 10},
  [11270] = {.lex_state = 537, .external_lex_state = 10},
  [11271] = {.lex_state = 254, .external_lex_state = 10},
  [11272] = {.lex_state = 254, .external_lex_state = 10},
  [11273] = {.lex_state = 254, .external_lex_state = 10},
  [11274] = {.lex_state = 254, .external_lex_state = 10},
  [11275] = {.lex_state = 254, .external_lex_state = 10},
  [11276] = {.lex_state = 254, .external_lex_state = 10},
  [11277] = {.lex_state = 254, .external_lex_state = 10},
  [11278] = {.lex_state = 254, .external_lex_state = 10},
  [11279] = {.lex_state = 254, .external_lex_state = 10},
  [11280] = {.lex_state = 254, .external_lex_state = 10},
  [11281] = {.lex_state = 254, .external_lex_state = 10},
  [11282] = {.lex_state = 254, .external_lex_state = 10},
  [11283] = {.lex_state = 254, .external_lex_state = 10},
  [11284] = {.lex_state = 254, .external_lex_state = 10},
  [11285] = {.lex_state = 254, .external_lex_state = 10},
  [11286] = {.lex_state = 364, .external_lex_state = 10},
  [11287] = {.lex_state = 537, .external_lex_state = 10},
  [11288] = {.lex_state = 364, .external_lex_state = 10},
  [11289] = {.lex_state = 368, .external_lex_state = 9},
  [11290] = {.lex_state = 254, .external_lex_state = 10},
  [11291] = {.lex_state = 254, .external_lex_state = 10},
  [11292] = {.lex_state = 538, .external_lex_state = 10},
  [11293] = {.lex_state = 538, .external_lex_state = 10},
  [11294] = {.lex_state = 538, .external_lex_state = 10},
  [11295] = {.lex_state = 254, .external_lex_state = 10},
  [11296] = {.lex_state = 538, .external_lex_state = 10},
  [11297] = {.lex_state = 538, .external_lex_state = 10},
  [11298] = {.lex_state = 538, .external_lex_state = 10},
  [11299] = {.lex_state = 538, .external_lex_state = 10},
  [11300] = {.lex_state = 538, .external_lex_state = 10},
  [11301] = {.lex_state = 254, .external_lex_state = 10},
  [11302] = {.lex_state = 538, .external_lex_state = 10},
  [11303] = {.lex_state = 538, .external_lex_state = 10},
  [11304] = {.lex_state = 538, .external_lex_state = 10},
  [11305] = {.lex_state = 538, .external_lex_state = 10},
  [11306] = {.lex_state = 538, .external_lex_state = 10},
  [11307] = {.lex_state = 254, .external_lex_state = 10},
  [11308] = {.lex_state = 538, .external_lex_state = 10},
  [11309] = {.lex_state = 538, .external_lex_state = 10},
  [11310] = {.lex_state = 254, .external_lex_state = 10},
  [11311] = {.lex_state = 538, .external_lex_state = 10},
  [11312] = {.lex_state = 538, .external_lex_state = 10},
  [11313] = {.lex_state = 538, .external_lex_state = 10},
  [11314] = {.lex_state = 538, .external_lex_state = 10},
  [11315] = {.lex_state = 538, .external_lex_state = 10},
  [11316] = {.lex_state = 538, .external_lex_state = 10},
  [11317] = {.lex_state = 530, .external_lex_state = 10},
  [11318] = {.lex_state = 538, .external_lex_state = 10},
  [11319] = {.lex_state = 537, .external_lex_state = 9},
  [11320] = {.lex_state = 538, .external_lex_state = 10},
  [11321] = {.lex_state = 538, .external_lex_state = 10},
  [11322] = {.lex_state = 538, .external_lex_state = 10},
  [11323] = {.lex_state = 254, .external_lex_state = 10},
  [11324] = {.lex_state = 368, .external_lex_state = 9},
  [11325] = {.lex_state = 538, .external_lex_state = 10},
  [11326] = {.lex_state = 537, .external_lex_state = 9},
  [11327] = {.lex_state = 254, .external_lex_state = 10},
  [11328] = {.lex_state = 538, .external_lex_state = 10},
  [11329] = {.lex_state = 538, .external_lex_state = 10},
  [11330] = {.lex_state = 363, .external_lex_state = 9},
  [11331] = {.lex_state = 538, .external_lex_state = 10},
  [11332] = {.lex_state = 538, .external_lex_state = 10},
  [11333] = {.lex_state = 254, .external_lex_state = 10},
  [11334] = {.lex_state = 538, .external_lex_state = 10},
  [11335] = {.lex_state = 538, .external_lex_state = 10},
  [11336] = {.lex_state = 538, .external_lex_state = 10},
  [11337] = {.lex_state = 538, .external_lex_state = 10},
  [11338] = {.lex_state = 254, .external_lex_state = 10},
  [11339] = {.lex_state = 538, .external_lex_state = 10},
  [11340] = {.lex_state = 530, .external_lex_state = 10},
  [11341] = {.lex_state = 538, .external_lex_state = 10},
  [11342] = {.lex_state = 538, .external_lex_state = 10},
  [11343] = {.lex_state = 364, .external_lex_state = 10},
  [11344] = {.lex_state = 254, .external_lex_state = 10},
  [11345] = {.lex_state = 380, .external_lex_state = 10},
  [11346] = {.lex_state = 538, .external_lex_state = 10},
  [11347] = {.lex_state = 382, .external_lex_state = 10},
  [11348] = {.lex_state = 382, .external_lex_state = 10},
  [11349] = {.lex_state = 538, .external_lex_state = 10},
  [11350] = {.lex_state = 254, .external_lex_state = 10},
  [11351] = {.lex_state = 537, .external_lex_state = 9},
  [11352] = {.lex_state = 382, .external_lex_state = 10},
  [11353] = {.lex_state = 382, .external_lex_state = 10},
  [11354] = {.lex_state = 538, .external_lex_state = 10},
  [11355] = {.lex_state = 368, .external_lex_state = 9},
  [11356] = {.lex_state = 263, .external_lex_state = 10},
  [11357] = {.lex_state = 263, .external_lex_state = 10},
  [11358] = {.lex_state = 254, .external_lex_state = 10},
  [11359] = {.lex_state = 380, .external_lex_state = 10},
  [11360] = {.lex_state = 530, .external_lex_state = 10},
  [11361] = {.lex_state = 540, .external_lex_state = 10},
  [11362] = {.lex_state = 538, .external_lex_state = 10},
  [11363] = {.lex_state = 537, .external_lex_state = 10},
  [11364] = {.lex_state = 538, .external_lex_state = 10},
  [11365] = {.lex_state = 538, .external_lex_state = 10},
  [11366] = {.lex_state = 540, .external_lex_state = 10},
  [11367] = {.lex_state = 537, .external_lex_state = 10},
  [11368] = {.lex_state = 540, .external_lex_state = 10},
  [11369] = {.lex_state = 538, .external_lex_state = 10},
  [11370] = {.lex_state = 538, .external_lex_state = 10},
  [11371] = {.lex_state = 391, .external_lex_state = 12},
  [11372] = {.lex_state = 115, .external_lex_state = 12},
  [11373] = {.lex_state = 364, .external_lex_state = 10},
  [11374] = {.lex_state = 370, .external_lex_state = 9},
  [11375] = {.lex_state = 364, .external_lex_state = 10},
  [11376] = {.lex_state = 115, .external_lex_state = 12},
  [11377] = {.lex_state = 115, .external_lex_state = 12},
  [11378] = {.lex_state = 515, .external_lex_state = 12},
  [11379] = {.lex_state = 369, .external_lex_state = 10},
  [11380] = {.lex_state = 383, .external_lex_state = 12},
  [11381] = {.lex_state = 515, .external_lex_state = 12},
  [11382] = {.lex_state = 364, .external_lex_state = 10},
  [11383] = {.lex_state = 380, .external_lex_state = 11},
  [11384] = {.lex_state = 370, .external_lex_state = 9},
  [11385] = {.lex_state = 515, .external_lex_state = 12},
  [11386] = {.lex_state = 380, .external_lex_state = 11},
  [11387] = {.lex_state = 364, .external_lex_state = 10},
  [11388] = {.lex_state = 538, .external_lex_state = 11},
  [11389] = {.lex_state = 369, .external_lex_state = 10},
  [11390] = {.lex_state = 537, .external_lex_state = 11},
  [11391] = {.lex_state = 364, .external_lex_state = 10},
  [11392] = {.lex_state = 254, .external_lex_state = 11},
  [11393] = {.lex_state = 538, .external_lex_state = 11},
  [11394] = {.lex_state = 115, .external_lex_state = 12},
  [11395] = {.lex_state = 530, .external_lex_state = 10},
  [11396] = {.lex_state = 364, .external_lex_state = 10},
  [11397] = {.lex_state = 530, .external_lex_state = 10},
  [11398] = {.lex_state = 538, .external_lex_state = 11},
  [11399] = {.lex_state = 380, .external_lex_state = 12},
  [11400] = {.lex_state = 537, .external_lex_state = 11},
  [11401] = {.lex_state = 254, .external_lex_state = 11},
  [11402] = {.lex_state = 283, .external_lex_state = 12},
  [11403] = {.lex_state = 283, .external_lex_state = 12},
  [11404] = {.lex_state = 283, .external_lex_state = 12},
  [11405] = {.lex_state = 283, .external_lex_state = 12},
  [11406] = {.lex_state = 537, .external_lex_state = 11},
  [11407] = {.lex_state = 254, .external_lex_state = 11},
  [11408] = {.lex_state = 364, .external_lex_state = 10},
  [11409] = {.lex_state = 363, .external_lex_state = 9},
  [11410] = {.lex_state = 369, .external_lex_state = 10},
  [11411] = {.lex_state = 515, .external_lex_state = 12},
  [11412] = {.lex_state = 369, .external_lex_state = 10},
  [11413] = {.lex_state = 286, .external_lex_state = 12},
  [11414] = {.lex_state = 286, .external_lex_state = 12},
  [11415] = {.lex_state = 286, .external_lex_state = 12},
  [11416] = {.lex_state = 286, .external_lex_state = 12},
  [11417] = {.lex_state = 391, .external_lex_state = 12},
  [11418] = {.lex_state = 391, .external_lex_state = 12},
  [11419] = {.lex_state = 540, .external_lex_state = 10},
  [11420] = {.lex_state = 530, .external_lex_state = 10},
  [11421] = {.lex_state = 364, .external_lex_state = 10},
  [11422] = {.lex_state = 384, .external_lex_state = 10},
  [11423] = {.lex_state = 364, .external_lex_state = 10},
  [11424] = {.lex_state = 363, .external_lex_state = 9},
  [11425] = {.lex_state = 540, .external_lex_state = 10},
  [11426] = {.lex_state = 364, .external_lex_state = 10},
  [11427] = {.lex_state = 364, .external_lex_state = 10},
  [11428] = {.lex_state = 364, .external_lex_state = 10},
  [11429] = {.lex_state = 537, .external_lex_state = 10},
  [11430] = {.lex_state = 537, .external_lex_state = 10},
  [11431] = {.lex_state = 391, .external_lex_state = 12},
  [11432] = {.lex_state = 530, .external_lex_state = 10},
  [11433] = {.lex_state = 537, .external_lex_state = 10},
  [11434] = {.lex_state = 537, .external_lex_state = 10},
  [11435] = {.lex_state = 537, .external_lex_state = 10},
  [11436] = {.lex_state = 537, .external_lex_state = 10},
  [11437] = {.lex_state = 537, .external_lex_state = 11},
  [11438] = {.lex_state = 510, .external_lex_state = 12},
  [11439] = {.lex_state = 538, .external_lex_state = 11},
  [11440] = {.lex_state = 538, .external_lex_state = 11},
  [11441] = {.lex_state = 380, .external_lex_state = 12},
  [11442] = {.lex_state = 380, .external_lex_state = 12},
  [11443] = {.lex_state = 389, .external_lex_state = 10},
  [11444] = {.lex_state = 380, .external_lex_state = 11},
  [11445] = {.lex_state = 368, .external_lex_state = 10},
  [11446] = {.lex_state = 380, .external_lex_state = 12},
  [11447] = {.lex_state = 75, .external_lex_state = 12},
  [11448] = {.lex_state = 388, .external_lex_state = 10},
  [11449] = {.lex_state = 75, .external_lex_state = 12},
  [11450] = {.lex_state = 380, .external_lex_state = 12},
  [11451] = {.lex_state = 537, .external_lex_state = 11},
  [11452] = {.lex_state = 510, .external_lex_state = 12},
  [11453] = {.lex_state = 537, .external_lex_state = 11},
  [11454] = {.lex_state = 380, .external_lex_state = 12},
  [11455] = {.lex_state = 380, .external_lex_state = 12},
  [11456] = {.lex_state = 380, .external_lex_state = 12},
  [11457] = {.lex_state = 380, .external_lex_state = 12},
  [11458] = {.lex_state = 261, .external_lex_state = 12},
  [11459] = {.lex_state = 399, .external_lex_state = 12},
  [11460] = {.lex_state = 255, .external_lex_state = 12},
  [11461] = {.lex_state = 284, .external_lex_state = 12},
  [11462] = {.lex_state = 284, .external_lex_state = 12},
  [11463] = {.lex_state = 537, .external_lex_state = 11},
  [11464] = {.lex_state = 510, .external_lex_state = 12},
  [11465] = {.lex_state = 380, .external_lex_state = 12},
  [11466] = {.lex_state = 364, .external_lex_state = 10},
  [11467] = {.lex_state = 380, .external_lex_state = 12},
  [11468] = {.lex_state = 537, .external_lex_state = 11},
  [11469] = {.lex_state = 284, .external_lex_state = 12},
  [11470] = {.lex_state = 389, .external_lex_state = 10},
  [11471] = {.lex_state = 530, .external_lex_state = 10},
  [11472] = {.lex_state = 254, .external_lex_state = 11},
  [11473] = {.lex_state = 537, .external_lex_state = 11},
  [11474] = {.lex_state = 388, .external_lex_state = 10},
  [11475] = {.lex_state = 389, .external_lex_state = 10},
  [11476] = {.lex_state = 537, .external_lex_state = 11},
  [11477] = {.lex_state = 380, .external_lex_state = 12},
  [11478] = {.lex_state = 537, .external_lex_state = 11},
  [11479] = {.lex_state = 261, .external_lex_state = 12},
  [11480] = {.lex_state = 368, .external_lex_state = 10},
  [11481] = {.lex_state = 388, .external_lex_state = 9},
  [11482] = {.lex_state = 537, .external_lex_state = 11},
  [11483] = {.lex_state = 537, .external_lex_state = 11},
  [11484] = {.lex_state = 364, .external_lex_state = 10},
  [11485] = {.lex_state = 368, .external_lex_state = 10},
  [11486] = {.lex_state = 510, .external_lex_state = 12},
  [11487] = {.lex_state = 364, .external_lex_state = 10},
  [11488] = {.lex_state = 381, .external_lex_state = 12},
  [11489] = {.lex_state = 380, .external_lex_state = 12},
  [11490] = {.lex_state = 537, .external_lex_state = 10},
  [11491] = {.lex_state = 537, .external_lex_state = 10},
  [11492] = {.lex_state = 380, .external_lex_state = 12},
  [11493] = {.lex_state = 364, .external_lex_state = 10},
  [11494] = {.lex_state = 75, .external_lex_state = 12},
  [11495] = {.lex_state = 75, .external_lex_state = 12},
  [11496] = {.lex_state = 364, .external_lex_state = 10},
  [11497] = {.lex_state = 364, .external_lex_state = 10},
  [11498] = {.lex_state = 264, .external_lex_state = 12},
  [11499] = {.lex_state = 264, .external_lex_state = 12},
  [11500] = {.lex_state = 264, .external_lex_state = 12},
  [11501] = {.lex_state = 264, .external_lex_state = 12},
  [11502] = {.lex_state = 388, .external_lex_state = 9},
  [11503] = {.lex_state = 380, .external_lex_state = 12},
  [11504] = {.lex_state = 380, .external_lex_state = 12},
  [11505] = {.lex_state = 380, .external_lex_state = 12},
  [11506] = {.lex_state = 282, .external_lex_state = 12},
  [11507] = {.lex_state = 380, .external_lex_state = 12},
  [11508] = {.lex_state = 388, .external_lex_state = 9},
  [11509] = {.lex_state = 284, .external_lex_state = 12},
  [11510] = {.lex_state = 282, .external_lex_state = 12},
  [11511] = {.lex_state = 537, .external_lex_state = 10},
  [11512] = {.lex_state = 380, .external_lex_state = 12},
  [11513] = {.lex_state = 537, .external_lex_state = 10},
  [11514] = {.lex_state = 380, .external_lex_state = 12},
  [11515] = {.lex_state = 380, .external_lex_state = 12},
  [11516] = {.lex_state = 381, .external_lex_state = 12},
  [11517] = {.lex_state = 381, .external_lex_state = 12},
  [11518] = {.lex_state = 380, .external_lex_state = 10},
  [11519] = {.lex_state = 380, .external_lex_state = 10},
  [11520] = {.lex_state = 380, .external_lex_state = 12},
  [11521] = {.lex_state = 388, .external_lex_state = 10},
  [11522] = {.lex_state = 388, .external_lex_state = 9},
  [11523] = {.lex_state = 380, .external_lex_state = 12},
  [11524] = {.lex_state = 380, .external_lex_state = 12},
  [11525] = {.lex_state = 380, .external_lex_state = 12},
  [11526] = {.lex_state = 380, .external_lex_state = 12},
  [11527] = {.lex_state = 282, .external_lex_state = 12},
  [11528] = {.lex_state = 368, .external_lex_state = 10},
  [11529] = {.lex_state = 380, .external_lex_state = 12},
  [11530] = {.lex_state = 371, .external_lex_state = 10},
  [11531] = {.lex_state = 282, .external_lex_state = 12},
  [11532] = {.lex_state = 380, .external_lex_state = 12},
  [11533] = {.lex_state = 261, .external_lex_state = 12},
  [11534] = {.lex_state = 380, .external_lex_state = 12},
  [11535] = {.lex_state = 281, .external_lex_state = 12},
  [11536] = {.lex_state = 380, .external_lex_state = 12},
  [11537] = {.lex_state = 281, .external_lex_state = 12},
  [11538] = {.lex_state = 281, .external_lex_state = 12},
  [11539] = {.lex_state = 281, .external_lex_state = 12},
  [11540] = {.lex_state = 380, .external_lex_state = 12},
  [11541] = {.lex_state = 380, .external_lex_state = 12},
  [11542] = {.lex_state = 261, .external_lex_state = 12},
  [11543] = {.lex_state = 388, .external_lex_state = 10},
  [11544] = {.lex_state = 364, .external_lex_state = 10},
  [11545] = {.lex_state = 381, .external_lex_state = 12},
  [11546] = {.lex_state = 380, .external_lex_state = 12},
  [11547] = {.lex_state = 380, .external_lex_state = 11},
  [11548] = {.lex_state = 537, .external_lex_state = 11},
  [11549] = {.lex_state = 380, .external_lex_state = 12},
  [11550] = {.lex_state = 380, .external_lex_state = 12},
  [11551] = {.lex_state = 380, .external_lex_state = 12},
  [11552] = {.lex_state = 380, .external_lex_state = 12},
  [11553] = {.lex_state = 380, .external_lex_state = 12},
  [11554] = {.lex_state = 389, .external_lex_state = 10},
  [11555] = {.lex_state = 380, .external_lex_state = 12},
  [11556] = {.lex_state = 388, .external_lex_state = 9},
  [11557] = {.lex_state = 380, .external_lex_state = 12},
  [11558] = {.lex_state = 380, .external_lex_state = 12},
  [11559] = {.lex_state = 380, .external_lex_state = 12},
  [11560] = {.lex_state = 254, .external_lex_state = 11},
  [11561] = {.lex_state = 265, .external_lex_state = 12},
  [11562] = {.lex_state = 254, .external_lex_state = 12},
  [11563] = {.lex_state = 538, .external_lex_state = 12},
  [11564] = {.lex_state = 254, .external_lex_state = 12},
  [11565] = {.lex_state = 370, .external_lex_state = 10},
  [11566] = {.lex_state = 370, .external_lex_state = 10},
  [11567] = {.lex_state = 260, .external_lex_state = 12},
  [11568] = {.lex_state = 537, .external_lex_state = 11},
  [11569] = {.lex_state = 370, .external_lex_state = 10},
  [11570] = {.lex_state = 380, .external_lex_state = 11},
  [11571] = {.lex_state = 364, .external_lex_state = 10},
  [11572] = {.lex_state = 370, .external_lex_state = 10},
  [11573] = {.lex_state = 364, .external_lex_state = 10},
  [11574] = {.lex_state = 364, .external_lex_state = 10},
  [11575] = {.lex_state = 538, .external_lex_state = 12},
  [11576] = {.lex_state = 350, .external_lex_state = 12},
  [11577] = {.lex_state = 388, .external_lex_state = 10},
  [11578] = {.lex_state = 364, .external_lex_state = 10},
  [11579] = {.lex_state = 260, .external_lex_state = 12},
  [11580] = {.lex_state = 538, .external_lex_state = 12},
  [11581] = {.lex_state = 538, .external_lex_state = 12},
  [11582] = {.lex_state = 370, .external_lex_state = 10},
  [11583] = {.lex_state = 538, .external_lex_state = 12},
  [11584] = {.lex_state = 538, .external_lex_state = 12},
  [11585] = {.lex_state = 364, .external_lex_state = 10},
  [11586] = {.lex_state = 254, .external_lex_state = 12},
  [11587] = {.lex_state = 370, .external_lex_state = 10},
  [11588] = {.lex_state = 380, .external_lex_state = 12},
  [11589] = {.lex_state = 370, .external_lex_state = 10},
  [11590] = {.lex_state = 262, .external_lex_state = 12},
  [11591] = {.lex_state = 262, .external_lex_state = 12},
  [11592] = {.lex_state = 550, .external_lex_state = 12},
  [11593] = {.lex_state = 254, .external_lex_state = 12},
  [11594] = {.lex_state = 254, .external_lex_state = 12},
  [11595] = {.lex_state = 364, .external_lex_state = 10},
  [11596] = {.lex_state = 364, .external_lex_state = 10},
  [11597] = {.lex_state = 364, .external_lex_state = 10},
  [11598] = {.lex_state = 380, .external_lex_state = 12},
  [11599] = {.lex_state = 350, .external_lex_state = 12},
  [11600] = {.lex_state = 550, .external_lex_state = 12},
  [11601] = {.lex_state = 254, .external_lex_state = 12},
  [11602] = {.lex_state = 538, .external_lex_state = 12},
  [11603] = {.lex_state = 364, .external_lex_state = 10},
  [11604] = {.lex_state = 370, .external_lex_state = 10},
  [11605] = {.lex_state = 364, .external_lex_state = 10},
  [11606] = {.lex_state = 388, .external_lex_state = 10},
  [11607] = {.lex_state = 388, .external_lex_state = 10},
  [11608] = {.lex_state = 537, .external_lex_state = 11},
  [11609] = {.lex_state = 254, .external_lex_state = 12},
  [11610] = {.lex_state = 380, .external_lex_state = 12},
  [11611] = {.lex_state = 364, .external_lex_state = 10},
  [11612] = {.lex_state = 370, .external_lex_state = 10},
  [11613] = {.lex_state = 350, .external_lex_state = 12},
  [11614] = {.lex_state = 380, .external_lex_state = 12},
  [11615] = {.lex_state = 350, .external_lex_state = 12},
  [11616] = {.lex_state = 380, .external_lex_state = 12},
  [11617] = {.lex_state = 364, .external_lex_state = 10},
  [11618] = {.lex_state = 370, .external_lex_state = 10},
  [11619] = {.lex_state = 300, .external_lex_state = 12},
  [11620] = {.lex_state = 254, .external_lex_state = 12},
  [11621] = {.lex_state = 254, .external_lex_state = 12},
  [11622] = {.lex_state = 254, .external_lex_state = 12},
  [11623] = {.lex_state = 364, .external_lex_state = 10},
  [11624] = {.lex_state = 364, .external_lex_state = 10},
  [11625] = {.lex_state = 538, .external_lex_state = 12},
  [11626] = {.lex_state = 364, .external_lex_state = 10},
  [11627] = {.lex_state = 254, .external_lex_state = 12},
  [11628] = {.lex_state = 370, .external_lex_state = 10},
  [11629] = {.lex_state = 390, .external_lex_state = 10},
  [11630] = {.lex_state = 380, .external_lex_state = 12},
  [11631] = {.lex_state = 370, .external_lex_state = 10},
  [11632] = {.lex_state = 262, .external_lex_state = 12},
  [11633] = {.lex_state = 364, .external_lex_state = 10},
  [11634] = {.lex_state = 380, .external_lex_state = 12},
  [11635] = {.lex_state = 370, .external_lex_state = 10},
  [11636] = {.lex_state = 380, .external_lex_state = 12},
  [11637] = {.lex_state = 538, .external_lex_state = 12},
  [11638] = {.lex_state = 537, .external_lex_state = 11},
  [11639] = {.lex_state = 262, .external_lex_state = 12},
  [11640] = {.lex_state = 380, .external_lex_state = 11},
  [11641] = {.lex_state = 364, .external_lex_state = 10},
  [11642] = {.lex_state = 254, .external_lex_state = 12},
  [11643] = {.lex_state = 370, .external_lex_state = 10},
  [11644] = {.lex_state = 370, .external_lex_state = 10},
  [11645] = {.lex_state = 388, .external_lex_state = 10},
  [11646] = {.lex_state = 538, .external_lex_state = 12},
  [11647] = {.lex_state = 380, .external_lex_state = 12},
  [11648] = {.lex_state = 370, .external_lex_state = 10},
  [11649] = {.lex_state = 380, .external_lex_state = 12},
  [11650] = {.lex_state = 364, .external_lex_state = 10},
  [11651] = {.lex_state = 254, .external_lex_state = 12},
  [11652] = {.lex_state = 537, .external_lex_state = 11},
  [11653] = {.lex_state = 370, .external_lex_state = 10},
  [11654] = {.lex_state = 254, .external_lex_state = 12},
  [11655] = {.lex_state = 364, .external_lex_state = 10},
  [11656] = {.lex_state = 380, .external_lex_state = 13},
  [11657] = {.lex_state = 254, .external_lex_state = 12},
  [11658] = {.lex_state = 254, .external_lex_state = 12},
  [11659] = {.lex_state = 254, .external_lex_state = 12},
  [11660] = {.lex_state = 538, .external_lex_state = 12},
  [11661] = {.lex_state = 538, .external_lex_state = 12},
  [11662] = {.lex_state = 364, .external_lex_state = 10},
  [11663] = {.lex_state = 254, .external_lex_state = 12},
  [11664] = {.lex_state = 370, .external_lex_state = 10},
  [11665] = {.lex_state = 364, .external_lex_state = 10},
  [11666] = {.lex_state = 370, .external_lex_state = 10},
  [11667] = {.lex_state = 380, .external_lex_state = 12},
  [11668] = {.lex_state = 380, .external_lex_state = 13},
  [11669] = {.lex_state = 364, .external_lex_state = 10},
  [11670] = {.lex_state = 380, .external_lex_state = 12},
  [11671] = {.lex_state = 254, .external_lex_state = 12},
  [11672] = {.lex_state = 254, .external_lex_state = 12},
  [11673] = {.lex_state = 364, .external_lex_state = 10},
  [11674] = {.lex_state = 254, .external_lex_state = 12},
  [11675] = {.lex_state = 254, .external_lex_state = 12},
  [11676] = {.lex_state = 370, .external_lex_state = 10},
  [11677] = {.lex_state = 370, .external_lex_state = 10},
  [11678] = {.lex_state = 380, .external_lex_state = 12},
  [11679] = {.lex_state = 370, .external_lex_state = 10},
  [11680] = {.lex_state = 364, .external_lex_state = 10},
  [11681] = {.lex_state = 538, .external_lex_state = 12},
  [11682] = {.lex_state = 364, .external_lex_state = 10},
  [11683] = {.lex_state = 350, .external_lex_state = 12},
  [11684] = {.lex_state = 254, .external_lex_state = 12},
  [11685] = {.lex_state = 538, .external_lex_state = 12},
  [11686] = {.lex_state = 538, .external_lex_state = 12},
  [11687] = {.lex_state = 538, .external_lex_state = 12},
  [11688] = {.lex_state = 537, .external_lex_state = 11},
  [11689] = {.lex_state = 254, .external_lex_state = 12},
  [11690] = {.lex_state = 380, .external_lex_state = 12},
  [11691] = {.lex_state = 380, .external_lex_state = 13},
  [11692] = {.lex_state = 380, .external_lex_state = 12},
  [11693] = {.lex_state = 538, .external_lex_state = 12},
  [11694] = {.lex_state = 538, .external_lex_state = 12},
  [11695] = {.lex_state = 538, .external_lex_state = 12},
  [11696] = {.lex_state = 538, .external_lex_state = 12},
  [11697] = {.lex_state = 537, .external_lex_state = 11},
  [11698] = {.lex_state = 364, .external_lex_state = 10},
  [11699] = {.lex_state = 538, .external_lex_state = 12},
  [11700] = {.lex_state = 370, .external_lex_state = 10},
  [11701] = {.lex_state = 538, .external_lex_state = 12},
  [11702] = {.lex_state = 350, .external_lex_state = 12},
  [11703] = {.lex_state = 538, .external_lex_state = 12},
  [11704] = {.lex_state = 538, .external_lex_state = 12},
  [11705] = {.lex_state = 538, .external_lex_state = 12},
  [11706] = {.lex_state = 537, .external_lex_state = 11},
  [11707] = {.lex_state = 538, .external_lex_state = 12},
  [11708] = {.lex_state = 370, .external_lex_state = 10},
  [11709] = {.lex_state = 538, .external_lex_state = 12},
  [11710] = {.lex_state = 538, .external_lex_state = 12},
  [11711] = {.lex_state = 538, .external_lex_state = 12},
  [11712] = {.lex_state = 538, .external_lex_state = 12},
  [11713] = {.lex_state = 537, .external_lex_state = 11},
  [11714] = {.lex_state = 364, .external_lex_state = 10},
  [11715] = {.lex_state = 254, .external_lex_state = 12},
  [11716] = {.lex_state = 538, .external_lex_state = 12},
  [11717] = {.lex_state = 538, .external_lex_state = 12},
  [11718] = {.lex_state = 538, .external_lex_state = 12},
  [11719] = {.lex_state = 538, .external_lex_state = 12},
  [11720] = {.lex_state = 538, .external_lex_state = 12},
  [11721] = {.lex_state = 370, .external_lex_state = 10},
  [11722] = {.lex_state = 537, .external_lex_state = 12},
  [11723] = {.lex_state = 538, .external_lex_state = 12},
  [11724] = {.lex_state = 537, .external_lex_state = 11},
  [11725] = {.lex_state = 392, .external_lex_state = 12},
  [11726] = {.lex_state = 392, .external_lex_state = 12},
  [11727] = {.lex_state = 538, .external_lex_state = 12},
  [11728] = {.lex_state = 538, .external_lex_state = 12},
  [11729] = {.lex_state = 538, .external_lex_state = 12},
  [11730] = {.lex_state = 538, .external_lex_state = 12},
  [11731] = {.lex_state = 370, .external_lex_state = 10},
  [11732] = {.lex_state = 364, .external_lex_state = 10},
  [11733] = {.lex_state = 388, .external_lex_state = 10},
  [11734] = {.lex_state = 538, .external_lex_state = 12},
  [11735] = {.lex_state = 392, .external_lex_state = 12},
  [11736] = {.lex_state = 380, .external_lex_state = 12},
  [11737] = {.lex_state = 364, .external_lex_state = 10},
  [11738] = {.lex_state = 538, .external_lex_state = 12},
  [11739] = {.lex_state = 392, .external_lex_state = 12},
  [11740] = {.lex_state = 254, .external_lex_state = 12},
  [11741] = {.lex_state = 364, .external_lex_state = 10},
  [11742] = {.lex_state = 254, .external_lex_state = 12},
  [11743] = {.lex_state = 538, .external_lex_state = 12},
  [11744] = {.lex_state = 364, .external_lex_state = 10},
  [11745] = {.lex_state = 537, .external_lex_state = 11},
  [11746] = {.lex_state = 254, .external_lex_state = 12},
  [11747] = {.lex_state = 364, .external_lex_state = 10},
  [11748] = {.lex_state = 538, .external_lex_state = 12},
  [11749] = {.lex_state = 370, .external_lex_state = 10},
  [11750] = {.lex_state = 364, .external_lex_state = 10},
  [11751] = {.lex_state = 538, .external_lex_state = 12},
  [11752] = {.lex_state = 254, .external_lex_state = 12},
  [11753] = {.lex_state = 388, .external_lex_state = 10},
  [11754] = {.lex_state = 370, .external_lex_state = 10},
  [11755] = {.lex_state = 285, .external_lex_state = 12},
  [11756] = {.lex_state = 364, .external_lex_state = 10},
  [11757] = {.lex_state = 370, .external_lex_state = 10},
  [11758] = {.lex_state = 370, .external_lex_state = 10},
  [11759] = {.lex_state = 364, .external_lex_state = 10},
  [11760] = {.lex_state = 370, .external_lex_state = 10},
  [11761] = {.lex_state = 285, .external_lex_state = 12},
  [11762] = {.lex_state = 380, .external_lex_state = 12},
  [11763] = {.lex_state = 350, .external_lex_state = 12},
  [11764] = {.lex_state = 364, .external_lex_state = 10},
  [11765] = {.lex_state = 364, .external_lex_state = 10},
  [11766] = {.lex_state = 254, .external_lex_state = 12},
  [11767] = {.lex_state = 350, .external_lex_state = 12},
  [11768] = {.lex_state = 350, .external_lex_state = 12},
  [11769] = {.lex_state = 388, .external_lex_state = 10},
  [11770] = {.lex_state = 350, .external_lex_state = 12},
  [11771] = {.lex_state = 388, .external_lex_state = 10},
  [11772] = {.lex_state = 380, .external_lex_state = 12},
  [11773] = {.lex_state = 364, .external_lex_state = 10},
  [11774] = {.lex_state = 370, .external_lex_state = 10},
  [11775] = {.lex_state = 364, .external_lex_state = 10},
  [11776] = {.lex_state = 370, .external_lex_state = 10},
  [11777] = {.lex_state = 254, .external_lex_state = 12},
  [11778] = {.lex_state = 254, .external_lex_state = 12},
  [11779] = {.lex_state = 370, .external_lex_state = 10},
  [11780] = {.lex_state = 380, .external_lex_state = 12},
  [11781] = {.lex_state = 350, .external_lex_state = 12},
  [11782] = {.lex_state = 388, .external_lex_state = 10},
  [11783] = {.lex_state = 364, .external_lex_state = 10},
  [11784] = {.lex_state = 259, .external_lex_state = 12},
  [11785] = {.lex_state = 285, .external_lex_state = 12},
  [11786] = {.lex_state = 259, .external_lex_state = 12},
  [11787] = {.lex_state = 350, .external_lex_state = 12},
  [11788] = {.lex_state = 364, .external_lex_state = 10},
  [11789] = {.lex_state = 285, .external_lex_state = 12},
  [11790] = {.lex_state = 370, .external_lex_state = 10},
  [11791] = {.lex_state = 259, .external_lex_state = 12},
  [11792] = {.lex_state = 370, .external_lex_state = 10},
  [11793] = {.lex_state = 388, .external_lex_state = 10},
  [11794] = {.lex_state = 259, .external_lex_state = 12},
  [11795] = {.lex_state = 538, .external_lex_state = 12},
  [11796] = {.lex_state = 364, .external_lex_state = 10},
  [11797] = {.lex_state = 350, .external_lex_state = 12},
  [11798] = {.lex_state = 364, .external_lex_state = 10},
  [11799] = {.lex_state = 370, .external_lex_state = 10},
  [11800] = {.lex_state = 388, .external_lex_state = 10},
  [11801] = {.lex_state = 370, .external_lex_state = 10},
  [11802] = {.lex_state = 254, .external_lex_state = 12},
  [11803] = {.lex_state = 370, .external_lex_state = 10},
  [11804] = {.lex_state = 254, .external_lex_state = 12},
  [11805] = {.lex_state = 364, .external_lex_state = 10},
  [11806] = {.lex_state = 380, .external_lex_state = 12},
  [11807] = {.lex_state = 254, .external_lex_state = 12},
  [11808] = {.lex_state = 254, .external_lex_state = 12},
  [11809] = {.lex_state = 254, .external_lex_state = 12},
  [11810] = {.lex_state = 254, .external_lex_state = 12},
  [11811] = {.lex_state = 254, .external_lex_state = 12},
  [11812] = {.lex_state = 350, .external_lex_state = 12},
  [11813] = {.lex_state = 550, .external_lex_state = 12},
  [11814] = {.lex_state = 364, .external_lex_state = 10},
  [11815] = {.lex_state = 254, .external_lex_state = 12},
  [11816] = {.lex_state = 254, .external_lex_state = 12},
  [11817] = {.lex_state = 254, .external_lex_state = 12},
  [11818] = {.lex_state = 254, .external_lex_state = 12},
  [11819] = {.lex_state = 350, .external_lex_state = 12},
  [11820] = {.lex_state = 260, .external_lex_state = 12},
  [11821] = {.lex_state = 254, .external_lex_state = 12},
  [11822] = {.lex_state = 254, .external_lex_state = 12},
  [11823] = {.lex_state = 364, .external_lex_state = 10},
  [11824] = {.lex_state = 350, .external_lex_state = 12},
  [11825] = {.lex_state = 260, .external_lex_state = 12},
  [11826] = {.lex_state = 364, .external_lex_state = 10},
  [11827] = {.lex_state = 370, .external_lex_state = 10},
  [11828] = {.lex_state = 350, .external_lex_state = 12},
  [11829] = {.lex_state = 370, .external_lex_state = 10},
  [11830] = {.lex_state = 254, .external_lex_state = 12},
  [11831] = {.lex_state = 537, .external_lex_state = 12},
  [11832] = {.lex_state = 370, .external_lex_state = 10},
  [11833] = {.lex_state = 350, .external_lex_state = 12},
  [11834] = {.lex_state = 277, .external_lex_state = 12},
  [11835] = {.lex_state = 370, .external_lex_state = 10},
  [11836] = {.lex_state = 550, .external_lex_state = 12},
  [11837] = {.lex_state = 364, .external_lex_state = 10},
  [11838] = {.lex_state = 350, .external_lex_state = 12},
  [11839] = {.lex_state = 380, .external_lex_state = 12},
  [11840] = {.lex_state = 388, .external_lex_state = 10},
  [11841] = {.lex_state = 380, .external_lex_state = 12},
  [11842] = {.lex_state = 350, .external_lex_state = 12},
  [11843] = {.lex_state = 254, .external_lex_state = 12},
  [11844] = {.lex_state = 537, .external_lex_state = 12},
  [11845] = {.lex_state = 380, .external_lex_state = 12},
  [11846] = {.lex_state = 254, .external_lex_state = 12},
  [11847] = {.lex_state = 538, .external_lex_state = 12},
  [11848] = {.lex_state = 537, .external_lex_state = 12},
  [11849] = {.lex_state = 537, .external_lex_state = 12},
  [11850] = {.lex_state = 537, .external_lex_state = 12},
  [11851] = {.lex_state = 537, .external_lex_state = 12},
  [11852] = {.lex_state = 537, .external_lex_state = 12},
  [11853] = {.lex_state = 537, .external_lex_state = 12},
  [11854] = {.lex_state = 537, .external_lex_state = 12},
  [11855] = {.lex_state = 537, .external_lex_state = 12},
  [11856] = {.lex_state = 537, .external_lex_state = 12},
  [11857] = {.lex_state = 538, .external_lex_state = 12},
  [11858] = {.lex_state = 350, .external_lex_state = 12},
  [11859] = {.lex_state = 388, .external_lex_state = 10},
  [11860] = {.lex_state = 388, .external_lex_state = 10},
  [11861] = {.lex_state = 388, .external_lex_state = 10},
  [11862] = {.lex_state = 380, .external_lex_state = 12},
  [11863] = {.lex_state = 380, .external_lex_state = 12},
  [11864] = {.lex_state = 380, .external_lex_state = 12},
  [11865] = {.lex_state = 388, .external_lex_state = 10},
  [11866] = {.lex_state = 380, .external_lex_state = 12},
  [11867] = {.lex_state = 380, .external_lex_state = 12},
  [11868] = {.lex_state = 388, .external_lex_state = 10},
  [11869] = {.lex_state = 380, .external_lex_state = 12},
  [11870] = {.lex_state = 350, .external_lex_state = 12},
  [11871] = {.lex_state = 380, .external_lex_state = 12},
  [11872] = {.lex_state = 254, .external_lex_state = 13},
  [11873] = {.lex_state = 380, .external_lex_state = 12},
  [11874] = {.lex_state = 537, .external_lex_state = 13},
  [11875] = {.lex_state = 380, .external_lex_state = 12},
  [11876] = {.lex_state = 388, .external_lex_state = 10},
  [11877] = {.lex_state = 388, .external_lex_state = 10},
  [11878] = {.lex_state = 388, .external_lex_state = 10},
  [11879] = {.lex_state = 388, .external_lex_state = 10},
  [11880] = {.lex_state = 380, .external_lex_state = 12},
  [11881] = {.lex_state = 350, .external_lex_state = 12},
  [11882] = {.lex_state = 537, .external_lex_state = 13},
  [11883] = {.lex_state = 380, .external_lex_state = 12},
  [11884] = {.lex_state = 380, .external_lex_state = 12},
  [11885] = {.lex_state = 537, .external_lex_state = 11},
  [11886] = {.lex_state = 350, .external_lex_state = 12},
  [11887] = {.lex_state = 380, .external_lex_state = 12},
  [11888] = {.lex_state = 538, .external_lex_state = 13},
  [11889] = {.lex_state = 388, .external_lex_state = 10},
  [11890] = {.lex_state = 388, .external_lex_state = 10},
  [11891] = {.lex_state = 254, .external_lex_state = 13},
  [11892] = {.lex_state = 380, .external_lex_state = 11},
  [11893] = {.lex_state = 380, .external_lex_state = 12},
  [11894] = {.lex_state = 380, .external_lex_state = 12},
  [11895] = {.lex_state = 350, .external_lex_state = 12},
  [11896] = {.lex_state = 257, .external_lex_state = 12},
  [11897] = {.lex_state = 537, .external_lex_state = 13},
  [11898] = {.lex_state = 380, .external_lex_state = 12},
  [11899] = {.lex_state = 380, .external_lex_state = 12},
  [11900] = {.lex_state = 350, .external_lex_state = 12},
  [11901] = {.lex_state = 538, .external_lex_state = 12},
  [11902] = {.lex_state = 380, .external_lex_state = 12},
  [11903] = {.lex_state = 537, .external_lex_state = 11},
  [11904] = {.lex_state = 380, .external_lex_state = 12},
  [11905] = {.lex_state = 380, .external_lex_state = 12},
  [11906] = {.lex_state = 380, .external_lex_state = 12},
  [11907] = {.lex_state = 388, .external_lex_state = 10},
  [11908] = {.lex_state = 380, .external_lex_state = 12},
  [11909] = {.lex_state = 380, .external_lex_state = 12},
  [11910] = {.lex_state = 380, .external_lex_state = 12},
  [11911] = {.lex_state = 268, .external_lex_state = 12},
  [11912] = {.lex_state = 380, .external_lex_state = 12},
  [11913] = {.lex_state = 254, .external_lex_state = 13},
  [11914] = {.lex_state = 254, .external_lex_state = 12},
  [11915] = {.lex_state = 380, .external_lex_state = 12},
  [11916] = {.lex_state = 388, .external_lex_state = 10},
  [11917] = {.lex_state = 350, .external_lex_state = 12},
  [11918] = {.lex_state = 380, .external_lex_state = 12},
  [11919] = {.lex_state = 380, .external_lex_state = 12},
  [11920] = {.lex_state = 364, .external_lex_state = 10},
  [11921] = {.lex_state = 380, .external_lex_state = 12},
  [11922] = {.lex_state = 380, .external_lex_state = 12},
  [11923] = {.lex_state = 388, .external_lex_state = 10},
  [11924] = {.lex_state = 538, .external_lex_state = 12},
  [11925] = {.lex_state = 380, .external_lex_state = 12},
  [11926] = {.lex_state = 380, .external_lex_state = 12},
  [11927] = {.lex_state = 380, .external_lex_state = 12},
  [11928] = {.lex_state = 538, .external_lex_state = 12},
  [11929] = {.lex_state = 380, .external_lex_state = 12},
  [11930] = {.lex_state = 380, .external_lex_state = 12},
  [11931] = {.lex_state = 380, .external_lex_state = 12},
  [11932] = {.lex_state = 537, .external_lex_state = 12},
  [11933] = {.lex_state = 380, .external_lex_state = 12},
  [11934] = {.lex_state = 380, .external_lex_state = 12},
  [11935] = {.lex_state = 380, .external_lex_state = 12},
  [11936] = {.lex_state = 350, .external_lex_state = 12},
  [11937] = {.lex_state = 380, .external_lex_state = 12},
  [11938] = {.lex_state = 388, .external_lex_state = 10},
  [11939] = {.lex_state = 380, .external_lex_state = 12},
  [11940] = {.lex_state = 380, .external_lex_state = 12},
  [11941] = {.lex_state = 380, .external_lex_state = 12},
  [11942] = {.lex_state = 380, .external_lex_state = 12},
  [11943] = {.lex_state = 380, .external_lex_state = 12},
  [11944] = {.lex_state = 380, .external_lex_state = 12},
  [11945] = {.lex_state = 380, .external_lex_state = 12},
  [11946] = {.lex_state = 380, .external_lex_state = 12},
  [11947] = {.lex_state = 380, .external_lex_state = 12},
  [11948] = {.lex_state = 268, .external_lex_state = 12},
  [11949] = {.lex_state = 263, .external_lex_state = 12},
  [11950] = {.lex_state = 388, .external_lex_state = 10},
  [11951] = {.lex_state = 380, .external_lex_state = 12},
  [11952] = {.lex_state = 254, .external_lex_state = 12},
  [11953] = {.lex_state = 380, .external_lex_state = 12},
  [11954] = {.lex_state = 380, .external_lex_state = 12},
  [11955] = {.lex_state = 380, .external_lex_state = 12},
  [11956] = {.lex_state = 380, .external_lex_state = 12},
  [11957] = {.lex_state = 350, .external_lex_state = 12},
  [11958] = {.lex_state = 380, .external_lex_state = 12},
  [11959] = {.lex_state = 380, .external_lex_state = 12},
  [11960] = {.lex_state = 380, .external_lex_state = 12},
  [11961] = {.lex_state = 380, .external_lex_state = 12},
  [11962] = {.lex_state = 380, .external_lex_state = 12},
  [11963] = {.lex_state = 388, .external_lex_state = 10},
  [11964] = {.lex_state = 380, .external_lex_state = 12},
  [11965] = {.lex_state = 254, .external_lex_state = 12},
  [11966] = {.lex_state = 540, .external_lex_state = 12},
  [11967] = {.lex_state = 380, .external_lex_state = 12},
  [11968] = {.lex_state = 380, .external_lex_state = 12},
  [11969] = {.lex_state = 380, .external_lex_state = 12},
  [11970] = {.lex_state = 388, .external_lex_state = 10},
  [11971] = {.lex_state = 380, .external_lex_state = 12},
  [11972] = {.lex_state = 380, .external_lex_state = 12},
  [11973] = {.lex_state = 380, .external_lex_state = 12},
  [11974] = {.lex_state = 540, .external_lex_state = 12},
  [11975] = {.lex_state = 380, .external_lex_state = 12},
  [11976] = {.lex_state = 268, .external_lex_state = 12},
  [11977] = {.lex_state = 380, .external_lex_state = 12},
  [11978] = {.lex_state = 388, .external_lex_state = 10},
  [11979] = {.lex_state = 380, .external_lex_state = 12},
  [11980] = {.lex_state = 263, .external_lex_state = 12},
  [11981] = {.lex_state = 388, .external_lex_state = 10},
  [11982] = {.lex_state = 538, .external_lex_state = 12},
  [11983] = {.lex_state = 388, .external_lex_state = 10},
  [11984] = {.lex_state = 538, .external_lex_state = 12},
  [11985] = {.lex_state = 538, .external_lex_state = 12},
  [11986] = {.lex_state = 350, .external_lex_state = 12},
  [11987] = {.lex_state = 380, .external_lex_state = 12},
  [11988] = {.lex_state = 380, .external_lex_state = 12},
  [11989] = {.lex_state = 254, .external_lex_state = 12},
  [11990] = {.lex_state = 380, .external_lex_state = 12},
  [11991] = {.lex_state = 380, .external_lex_state = 12},
  [11992] = {.lex_state = 254, .external_lex_state = 12},
  [11993] = {.lex_state = 388, .external_lex_state = 10},
  [11994] = {.lex_state = 542, .external_lex_state = 12},
  [11995] = {.lex_state = 380, .external_lex_state = 12},
  [11996] = {.lex_state = 538, .external_lex_state = 12},
  [11997] = {.lex_state = 388, .external_lex_state = 10},
  [11998] = {.lex_state = 380, .external_lex_state = 12},
  [11999] = {.lex_state = 380, .external_lex_state = 12},
  [12000] = {.lex_state = 380, .external_lex_state = 12},
  [12001] = {.lex_state = 388, .external_lex_state = 10},
  [12002] = {.lex_state = 380, .external_lex_state = 12},
  [12003] = {.lex_state = 380, .external_lex_state = 12},
  [12004] = {.lex_state = 388, .external_lex_state = 10},
  [12005] = {.lex_state = 388, .external_lex_state = 10},
  [12006] = {.lex_state = 254, .external_lex_state = 12},
  [12007] = {.lex_state = 542, .external_lex_state = 12},
  [12008] = {.lex_state = 542, .external_lex_state = 12},
  [12009] = {.lex_state = 380, .external_lex_state = 12},
  [12010] = {.lex_state = 380, .external_lex_state = 12},
  [12011] = {.lex_state = 380, .external_lex_state = 12},
  [12012] = {.lex_state = 380, .external_lex_state = 12},
  [12013] = {.lex_state = 380, .external_lex_state = 12},
  [12014] = {.lex_state = 538, .external_lex_state = 12},
  [12015] = {.lex_state = 380, .external_lex_state = 12},
  [12016] = {.lex_state = 388, .external_lex_state = 10},
  [12017] = {.lex_state = 388, .external_lex_state = 10},
  [12018] = {.lex_state = 380, .external_lex_state = 12},
  [12019] = {.lex_state = 537, .external_lex_state = 11},
  [12020] = {.lex_state = 380, .external_lex_state = 12},
  [12021] = {.lex_state = 380, .external_lex_state = 12},
  [12022] = {.lex_state = 380, .external_lex_state = 12},
  [12023] = {.lex_state = 380, .external_lex_state = 12},
  [12024] = {.lex_state = 542, .external_lex_state = 12},
  [12025] = {.lex_state = 388, .external_lex_state = 10},
  [12026] = {.lex_state = 380, .external_lex_state = 12},
  [12027] = {.lex_state = 380, .external_lex_state = 11},
  [12028] = {.lex_state = 380, .external_lex_state = 12},
  [12029] = {.lex_state = 380, .external_lex_state = 12},
  [12030] = {.lex_state = 380, .external_lex_state = 12},
  [12031] = {.lex_state = 380, .external_lex_state = 12},
  [12032] = {.lex_state = 350, .external_lex_state = 12},
  [12033] = {.lex_state = 380, .external_lex_state = 12},
  [12034] = {.lex_state = 380, .external_lex_state = 12},
  [12035] = {.lex_state = 380, .external_lex_state = 12},
  [12036] = {.lex_state = 380, .external_lex_state = 12},
  [12037] = {.lex_state = 380, .external_lex_state = 12},
  [12038] = {.lex_state = 380, .external_lex_state = 12},
  [12039] = {.lex_state = 380, .external_lex_state = 12},
  [12040] = {.lex_state = 380, .external_lex_state = 12},
  [12041] = {.lex_state = 380, .external_lex_state = 12},
  [12042] = {.lex_state = 380, .external_lex_state = 12},
  [12043] = {.lex_state = 380, .external_lex_state = 12},
  [12044] = {.lex_state = 388, .external_lex_state = 10},
  [12045] = {.lex_state = 540, .external_lex_state = 12},
  [12046] = {.lex_state = 380, .external_lex_state = 12},
  [12047] = {.lex_state = 380, .external_lex_state = 12},
  [12048] = {.lex_state = 537, .external_lex_state = 12},
  [12049] = {.lex_state = 388, .external_lex_state = 10},
  [12050] = {.lex_state = 537, .external_lex_state = 12},
  [12051] = {.lex_state = 380, .external_lex_state = 12},
  [12052] = {.lex_state = 380, .external_lex_state = 12},
  [12053] = {.lex_state = 538, .external_lex_state = 12},
  [12054] = {.lex_state = 380, .external_lex_state = 12},
  [12055] = {.lex_state = 388, .external_lex_state = 10},
  [12056] = {.lex_state = 538, .external_lex_state = 12},
  [12057] = {.lex_state = 380, .external_lex_state = 12},
  [12058] = {.lex_state = 388, .external_lex_state = 10},
  [12059] = {.lex_state = 380, .external_lex_state = 12},
  [12060] = {.lex_state = 380, .external_lex_state = 12},
  [12061] = {.lex_state = 537, .external_lex_state = 13},
  [12062] = {.lex_state = 380, .external_lex_state = 12},
  [12063] = {.lex_state = 268, .external_lex_state = 12},
  [12064] = {.lex_state = 388, .external_lex_state = 10},
  [12065] = {.lex_state = 380, .external_lex_state = 12},
  [12066] = {.lex_state = 380, .external_lex_state = 12},
  [12067] = {.lex_state = 380, .external_lex_state = 12},
  [12068] = {.lex_state = 350, .external_lex_state = 12},
  [12069] = {.lex_state = 537, .external_lex_state = 12},
  [12070] = {.lex_state = 538, .external_lex_state = 12},
  [12071] = {.lex_state = 380, .external_lex_state = 12},
  [12072] = {.lex_state = 382, .external_lex_state = 12},
  [12073] = {.lex_state = 380, .external_lex_state = 12},
  [12074] = {.lex_state = 350, .external_lex_state = 12},
  [12075] = {.lex_state = 388, .external_lex_state = 10},
  [12076] = {.lex_state = 254, .external_lex_state = 12},
  [12077] = {.lex_state = 254, .external_lex_state = 12},
  [12078] = {.lex_state = 380, .external_lex_state = 12},
  [12079] = {.lex_state = 388, .external_lex_state = 10},
  [12080] = {.lex_state = 380, .external_lex_state = 12},
  [12081] = {.lex_state = 380, .external_lex_state = 12},
  [12082] = {.lex_state = 382, .external_lex_state = 12},
  [12083] = {.lex_state = 388, .external_lex_state = 10},
  [12084] = {.lex_state = 380, .external_lex_state = 12},
  [12085] = {.lex_state = 380, .external_lex_state = 12},
  [12086] = {.lex_state = 380, .external_lex_state = 12},
  [12087] = {.lex_state = 380, .external_lex_state = 12},
  [12088] = {.lex_state = 380, .external_lex_state = 12},
  [12089] = {.lex_state = 350, .external_lex_state = 12},
  [12090] = {.lex_state = 380, .external_lex_state = 12},
  [12091] = {.lex_state = 380, .external_lex_state = 12},
  [12092] = {.lex_state = 380, .external_lex_state = 12},
  [12093] = {.lex_state = 380, .external_lex_state = 12},
  [12094] = {.lex_state = 380, .external_lex_state = 12},
  [12095] = {.lex_state = 538, .external_lex_state = 13},
  [12096] = {.lex_state = 537, .external_lex_state = 11},
  [12097] = {.lex_state = 380, .external_lex_state = 12},
  [12098] = {.lex_state = 254, .external_lex_state = 12},
  [12099] = {.lex_state = 380, .external_lex_state = 12},
  [12100] = {.lex_state = 380, .external_lex_state = 12},
  [12101] = {.lex_state = 254, .external_lex_state = 12},
  [12102] = {.lex_state = 254, .external_lex_state = 12},
  [12103] = {.lex_state = 254, .external_lex_state = 12},
  [12104] = {.lex_state = 254, .external_lex_state = 12},
  [12105] = {.lex_state = 380, .external_lex_state = 12},
  [12106] = {.lex_state = 254, .external_lex_state = 12},
  [12107] = {.lex_state = 388, .external_lex_state = 10},
  [12108] = {.lex_state = 380, .external_lex_state = 12},
  [12109] = {.lex_state = 257, .external_lex_state = 12},
  [12110] = {.lex_state = 380, .external_lex_state = 12},
  [12111] = {.lex_state = 263, .external_lex_state = 12},
  [12112] = {.lex_state = 538, .external_lex_state = 12},
  [12113] = {.lex_state = 538, .external_lex_state = 12},
  [12114] = {.lex_state = 538, .external_lex_state = 12},
  [12115] = {.lex_state = 537, .external_lex_state = 12},
  [12116] = {.lex_state = 537, .external_lex_state = 12},
  [12117] = {.lex_state = 364, .external_lex_state = 10},
  [12118] = {.lex_state = 263, .external_lex_state = 12},
  [12119] = {.lex_state = 538, .external_lex_state = 12},
  [12120] = {.lex_state = 538, .external_lex_state = 12},
  [12121] = {.lex_state = 380, .external_lex_state = 12},
  [12122] = {.lex_state = 388, .external_lex_state = 10},
  [12123] = {.lex_state = 254, .external_lex_state = 12},
  [12124] = {.lex_state = 388, .external_lex_state = 10},
  [12125] = {.lex_state = 380, .external_lex_state = 12},
  [12126] = {.lex_state = 380, .external_lex_state = 12},
  [12127] = {.lex_state = 538, .external_lex_state = 13},
  [12128] = {.lex_state = 380, .external_lex_state = 12},
  [12129] = {.lex_state = 380, .external_lex_state = 12},
  [12130] = {.lex_state = 538, .external_lex_state = 12},
  [12131] = {.lex_state = 388, .external_lex_state = 10},
  [12132] = {.lex_state = 382, .external_lex_state = 12},
  [12133] = {.lex_state = 380, .external_lex_state = 12},
  [12134] = {.lex_state = 254, .external_lex_state = 12},
  [12135] = {.lex_state = 380, .external_lex_state = 12},
  [12136] = {.lex_state = 537, .external_lex_state = 12},
  [12137] = {.lex_state = 380, .external_lex_state = 12},
  [12138] = {.lex_state = 388, .external_lex_state = 10},
  [12139] = {.lex_state = 254, .external_lex_state = 12},
  [12140] = {.lex_state = 254, .external_lex_state = 12},
  [12141] = {.lex_state = 382, .external_lex_state = 12},
  [12142] = {.lex_state = 380, .external_lex_state = 12},
  [12143] = {.lex_state = 537, .external_lex_state = 12},
  [12144] = {.lex_state = 537, .external_lex_state = 12},
  [12145] = {.lex_state = 388, .external_lex_state = 10},
  [12146] = {.lex_state = 350, .external_lex_state = 12},
  [12147] = {.lex_state = 380, .external_lex_state = 12},
  [12148] = {.lex_state = 380, .external_lex_state = 12},
  [12149] = {.lex_state = 380, .external_lex_state = 12},
  [12150] = {.lex_state = 380, .external_lex_state = 12},
  [12151] = {.lex_state = 540, .external_lex_state = 12},
  [12152] = {.lex_state = 537, .external_lex_state = 12},
  [12153] = {.lex_state = 538, .external_lex_state = 12},
  [12154] = {.lex_state = 537, .external_lex_state = 12},
  [12155] = {.lex_state = 537, .external_lex_state = 12},
  [12156] = {.lex_state = 537, .external_lex_state = 12},
  [12157] = {.lex_state = 537, .external_lex_state = 12},
  [12158] = {.lex_state = 537, .external_lex_state = 12},
  [12159] = {.lex_state = 537, .external_lex_state = 12},
  [12160] = {.lex_state = 380, .external_lex_state = 12},
  [12161] = {.lex_state = 254, .external_lex_state = 13},
  [12162] = {.lex_state = 388, .external_lex_state = 10},
  [12163] = {.lex_state = 380, .external_lex_state = 12},
  [12164] = {.lex_state = 537, .external_lex_state = 12},
  [12165] = {.lex_state = 350, .external_lex_state = 12},
  [12166] = {.lex_state = 364, .external_lex_state = 10},
  [12167] = {.lex_state = 537, .external_lex_state = 12},
  [12168] = {.lex_state = 380, .external_lex_state = 12},
  [12169] = {.lex_state = 380, .external_lex_state = 12},
  [12170] = {.lex_state = 380, .external_lex_state = 12},
  [12171] = {.lex_state = 380, .external_lex_state = 12},
  [12172] = {.lex_state = 380, .external_lex_state = 12},
  [12173] = {.lex_state = 388, .external_lex_state = 10},
  [12174] = {.lex_state = 537, .external_lex_state = 12},
  [12175] = {.lex_state = 537, .external_lex_state = 12},
  [12176] = {.lex_state = 350, .external_lex_state = 12},
  [12177] = {.lex_state = 540, .external_lex_state = 12},
  [12178] = {.lex_state = 537, .external_lex_state = 12},
  [12179] = {.lex_state = 537, .external_lex_state = 12},
  [12180] = {.lex_state = 537, .external_lex_state = 12},
  [12181] = {.lex_state = 380, .external_lex_state = 12},
  [12182] = {.lex_state = 380, .external_lex_state = 12},
  [12183] = {.lex_state = 380, .external_lex_state = 12},
  [12184] = {.lex_state = 388, .external_lex_state = 10},
  [12185] = {.lex_state = 388, .external_lex_state = 10},
  [12186] = {.lex_state = 388, .external_lex_state = 10},
  [12187] = {.lex_state = 350, .external_lex_state = 12},
  [12188] = {.lex_state = 350, .external_lex_state = 12},
  [12189] = {.lex_state = 380, .external_lex_state = 12},
  [12190] = {.lex_state = 537, .external_lex_state = 12},
  [12191] = {.lex_state = 388, .external_lex_state = 10},
  [12192] = {.lex_state = 380, .external_lex_state = 12},
  [12193] = {.lex_state = 538, .external_lex_state = 12},
  [12194] = {.lex_state = 388, .external_lex_state = 10},
  [12195] = {.lex_state = 388, .external_lex_state = 10},
  [12196] = {.lex_state = 350, .external_lex_state = 12},
  [12197] = {.lex_state = 380, .external_lex_state = 12},
  [12198] = {.lex_state = 537, .external_lex_state = 12},
  [12199] = {.lex_state = 380, .external_lex_state = 12},
  [12200] = {.lex_state = 388, .external_lex_state = 10},
  [12201] = {.lex_state = 257, .external_lex_state = 12},
  [12202] = {.lex_state = 537, .external_lex_state = 12},
  [12203] = {.lex_state = 537, .external_lex_state = 12},
  [12204] = {.lex_state = 380, .external_lex_state = 12},
  [12205] = {.lex_state = 380, .external_lex_state = 12},
  [12206] = {.lex_state = 537, .external_lex_state = 12},
  [12207] = {.lex_state = 537, .external_lex_state = 12},
  [12208] = {.lex_state = 537, .external_lex_state = 12},
  [12209] = {.lex_state = 388, .external_lex_state = 10},
  [12210] = {.lex_state = 540, .external_lex_state = 12},
  [12211] = {.lex_state = 380, .external_lex_state = 12},
  [12212] = {.lex_state = 380, .external_lex_state = 12},
  [12213] = {.lex_state = 537, .external_lex_state = 12},
  [12214] = {.lex_state = 537, .external_lex_state = 12},
  [12215] = {.lex_state = 537, .external_lex_state = 12},
  [12216] = {.lex_state = 537, .external_lex_state = 12},
  [12217] = {.lex_state = 537, .external_lex_state = 12},
  [12218] = {.lex_state = 537, .external_lex_state = 12},
  [12219] = {.lex_state = 380, .external_lex_state = 12},
  [12220] = {.lex_state = 380, .external_lex_state = 12},
  [12221] = {.lex_state = 388, .external_lex_state = 10},
  [12222] = {.lex_state = 380, .external_lex_state = 12},
  [12223] = {.lex_state = 537, .external_lex_state = 12},
  [12224] = {.lex_state = 537, .external_lex_state = 12},
  [12225] = {.lex_state = 537, .external_lex_state = 12},
  [12226] = {.lex_state = 537, .external_lex_state = 12},
  [12227] = {.lex_state = 537, .external_lex_state = 12},
  [12228] = {.lex_state = 537, .external_lex_state = 12},
  [12229] = {.lex_state = 537, .external_lex_state = 12},
  [12230] = {.lex_state = 537, .external_lex_state = 12},
  [12231] = {.lex_state = 537, .external_lex_state = 12},
  [12232] = {.lex_state = 537, .external_lex_state = 12},
  [12233] = {.lex_state = 537, .external_lex_state = 12},
  [12234] = {.lex_state = 537, .external_lex_state = 12},
  [12235] = {.lex_state = 388, .external_lex_state = 10},
  [12236] = {.lex_state = 380, .external_lex_state = 12},
  [12237] = {.lex_state = 540, .external_lex_state = 12},
  [12238] = {.lex_state = 380, .external_lex_state = 12},
  [12239] = {.lex_state = 380, .external_lex_state = 12},
  [12240] = {.lex_state = 537, .external_lex_state = 12},
  [12241] = {.lex_state = 537, .external_lex_state = 12},
  [12242] = {.lex_state = 537, .external_lex_state = 12},
  [12243] = {.lex_state = 380, .external_lex_state = 12},
  [12244] = {.lex_state = 538, .external_lex_state = 13},
  [12245] = {.lex_state = 343, .external_lex_state = 2},
  [12246] = {.lex_state = 343, .external_lex_state = 2},
  [12247] = {.lex_state = 537, .external_lex_state = 12},
  [12248] = {.lex_state = 254, .external_lex_state = 12},
  [12249] = {.lex_state = 537, .external_lex_state = 12},
  [12250] = {.lex_state = 537, .external_lex_state = 12},
  [12251] = {.lex_state = 537, .external_lex_state = 12},
  [12252] = {.lex_state = 254, .external_lex_state = 12},
  [12253] = {.lex_state = 254, .external_lex_state = 12},
  [12254] = {.lex_state = 254, .external_lex_state = 12},
  [12255] = {.lex_state = 537, .external_lex_state = 12},
  [12256] = {.lex_state = 254, .external_lex_state = 12},
  [12257] = {.lex_state = 254, .external_lex_state = 12},
  [12258] = {.lex_state = 254, .external_lex_state = 12},
  [12259] = {.lex_state = 538, .external_lex_state = 12},
  [12260] = {.lex_state = 540, .external_lex_state = 12},
  [12261] = {.lex_state = 254, .external_lex_state = 12},
  [12262] = {.lex_state = 350, .external_lex_state = 12},
  [12263] = {.lex_state = 254, .external_lex_state = 12},
  [12264] = {.lex_state = 254, .external_lex_state = 12},
  [12265] = {.lex_state = 254, .external_lex_state = 12},
  [12266] = {.lex_state = 254, .external_lex_state = 12},
  [12267] = {.lex_state = 538, .external_lex_state = 12},
  [12268] = {.lex_state = 537, .external_lex_state = 12},
  [12269] = {.lex_state = 380, .external_lex_state = 12},
  [12270] = {.lex_state = 538, .external_lex_state = 12},
  [12271] = {.lex_state = 538, .external_lex_state = 12},
  [12272] = {.lex_state = 538, .external_lex_state = 12},
  [12273] = {.lex_state = 538, .external_lex_state = 12},
  [12274] = {.lex_state = 380, .external_lex_state = 12},
  [12275] = {.lex_state = 538, .external_lex_state = 12},
  [12276] = {.lex_state = 538, .external_lex_state = 12},
  [12277] = {.lex_state = 538, .external_lex_state = 12},
  [12278] = {.lex_state = 538, .external_lex_state = 12},
  [12279] = {.lex_state = 538, .external_lex_state = 12},
  [12280] = {.lex_state = 538, .external_lex_state = 12},
  [12281] = {.lex_state = 538, .external_lex_state = 12},
  [12282] = {.lex_state = 538, .external_lex_state = 12},
  [12283] = {.lex_state = 538, .external_lex_state = 12},
  [12284] = {.lex_state = 538, .external_lex_state = 12},
  [12285] = {.lex_state = 254, .external_lex_state = 12},
  [12286] = {.lex_state = 343, .external_lex_state = 2},
  [12287] = {.lex_state = 254, .external_lex_state = 12},
  [12288] = {.lex_state = 537, .external_lex_state = 12},
  [12289] = {.lex_state = 537, .external_lex_state = 12},
  [12290] = {.lex_state = 254, .external_lex_state = 12},
  [12291] = {.lex_state = 254, .external_lex_state = 12},
  [12292] = {.lex_state = 254, .external_lex_state = 12},
  [12293] = {.lex_state = 254, .external_lex_state = 12},
  [12294] = {.lex_state = 254, .external_lex_state = 12},
  [12295] = {.lex_state = 254, .external_lex_state = 12},
  [12296] = {.lex_state = 254, .external_lex_state = 12},
  [12297] = {.lex_state = 254, .external_lex_state = 12},
  [12298] = {.lex_state = 254, .external_lex_state = 12},
  [12299] = {.lex_state = 254, .external_lex_state = 12},
  [12300] = {.lex_state = 254, .external_lex_state = 12},
  [12301] = {.lex_state = 254, .external_lex_state = 12},
  [12302] = {.lex_state = 254, .external_lex_state = 12},
  [12303] = {.lex_state = 254, .external_lex_state = 12},
  [12304] = {.lex_state = 538, .external_lex_state = 12},
  [12305] = {.lex_state = 254, .external_lex_state = 12},
  [12306] = {.lex_state = 537, .external_lex_state = 12},
  [12307] = {.lex_state = 537, .external_lex_state = 12},
  [12308] = {.lex_state = 350, .external_lex_state = 12},
  [12309] = {.lex_state = 254, .external_lex_state = 12},
  [12310] = {.lex_state = 254, .external_lex_state = 12},
  [12311] = {.lex_state = 343, .external_lex_state = 2},
  [12312] = {.lex_state = 254, .external_lex_state = 12},
  [12313] = {.lex_state = 254, .external_lex_state = 12},
  [12314] = {.lex_state = 254, .external_lex_state = 12},
  [12315] = {.lex_state = 380, .external_lex_state = 12},
  [12316] = {.lex_state = 537, .external_lex_state = 12},
  [12317] = {.lex_state = 537, .external_lex_state = 12},
  [12318] = {.lex_state = 254, .external_lex_state = 12},
  [12319] = {.lex_state = 380, .external_lex_state = 12},
  [12320] = {.lex_state = 254, .external_lex_state = 12},
  [12321] = {.lex_state = 254, .external_lex_state = 12},
  [12322] = {.lex_state = 254, .external_lex_state = 12},
  [12323] = {.lex_state = 254, .external_lex_state = 12},
  [12324] = {.lex_state = 254, .external_lex_state = 12},
  [12325] = {.lex_state = 254, .external_lex_state = 12},
  [12326] = {.lex_state = 254, .external_lex_state = 12},
  [12327] = {.lex_state = 343, .external_lex_state = 2},
  [12328] = {.lex_state = 537, .external_lex_state = 12},
  [12329] = {.lex_state = 254, .external_lex_state = 12},
  [12330] = {.lex_state = 254, .external_lex_state = 12},
  [12331] = {.lex_state = 254, .external_lex_state = 12},
  [12332] = {.lex_state = 254, .external_lex_state = 12},
  [12333] = {.lex_state = 254, .external_lex_state = 12},
  [12334] = {.lex_state = 254, .external_lex_state = 12},
  [12335] = {.lex_state = 254, .external_lex_state = 12},
  [12336] = {.lex_state = 254, .external_lex_state = 12},
  [12337] = {.lex_state = 380, .external_lex_state = 12},
  [12338] = {.lex_state = 380, .external_lex_state = 12},
  [12339] = {.lex_state = 343, .external_lex_state = 2},
  [12340] = {.lex_state = 254, .external_lex_state = 12},
  [12341] = {.lex_state = 254, .external_lex_state = 12},
  [12342] = {.lex_state = 254, .external_lex_state = 12},
  [12343] = {.lex_state = 254, .external_lex_state = 12},
  [12344] = {.lex_state = 254, .external_lex_state = 12},
  [12345] = {.lex_state = 254, .external_lex_state = 12},
  [12346] = {.lex_state = 254, .external_lex_state = 12},
  [12347] = {.lex_state = 380, .external_lex_state = 12},
  [12348] = {.lex_state = 380, .external_lex_state = 12},
  [12349] = {.lex_state = 254, .external_lex_state = 12},
  [12350] = {.lex_state = 254, .external_lex_state = 12},
  [12351] = {.lex_state = 254, .external_lex_state = 12},
  [12352] = {.lex_state = 343, .external_lex_state = 2},
  [12353] = {.lex_state = 254, .external_lex_state = 12},
  [12354] = {.lex_state = 254, .external_lex_state = 12},
  [12355] = {.lex_state = 254, .external_lex_state = 12},
  [12356] = {.lex_state = 254, .external_lex_state = 12},
  [12357] = {.lex_state = 254, .external_lex_state = 12},
  [12358] = {.lex_state = 254, .external_lex_state = 12},
  [12359] = {.lex_state = 254, .external_lex_state = 12},
  [12360] = {.lex_state = 254, .external_lex_state = 12},
  [12361] = {.lex_state = 254, .external_lex_state = 12},
  [12362] = {.lex_state = 254, .external_lex_state = 12},
  [12363] = {.lex_state = 380, .external_lex_state = 12},
  [12364] = {.lex_state = 254, .external_lex_state = 12},
  [12365] = {.lex_state = 254, .external_lex_state = 12},
  [12366] = {.lex_state = 380, .external_lex_state = 12},
  [12367] = {.lex_state = 254, .external_lex_state = 12},
  [12368] = {.lex_state = 254, .external_lex_state = 12},
  [12369] = {.lex_state = 343, .external_lex_state = 2},
  [12370] = {.lex_state = 540, .external_lex_state = 12},
  [12371] = {.lex_state = 537, .external_lex_state = 12},
  [12372] = {.lex_state = 538, .external_lex_state = 12},
  [12373] = {.lex_state = 380, .external_lex_state = 12},
  [12374] = {.lex_state = 380, .external_lex_state = 12},
  [12375] = {.lex_state = 343, .external_lex_state = 2},
  [12376] = {.lex_state = 538, .external_lex_state = 12},
  [12377] = {.lex_state = 254, .external_lex_state = 12},
  [12378] = {.lex_state = 254, .external_lex_state = 12},
  [12379] = {.lex_state = 254, .external_lex_state = 12},
  [12380] = {.lex_state = 380, .external_lex_state = 12},
  [12381] = {.lex_state = 254, .external_lex_state = 12},
  [12382] = {.lex_state = 380, .external_lex_state = 12},
  [12383] = {.lex_state = 254, .external_lex_state = 12},
  [12384] = {.lex_state = 254, .external_lex_state = 12},
  [12385] = {.lex_state = 254, .external_lex_state = 12},
  [12386] = {.lex_state = 254, .external_lex_state = 12},
  [12387] = {.lex_state = 254, .external_lex_state = 12},
  [12388] = {.lex_state = 254, .external_lex_state = 12},
  [12389] = {.lex_state = 254, .external_lex_state = 12},
  [12390] = {.lex_state = 254, .external_lex_state = 12},
  [12391] = {.lex_state = 343, .external_lex_state = 2},
  [12392] = {.lex_state = 254, .external_lex_state = 12},
  [12393] = {.lex_state = 254, .external_lex_state = 12},
  [12394] = {.lex_state = 254, .external_lex_state = 12},
  [12395] = {.lex_state = 254, .external_lex_state = 12},
  [12396] = {.lex_state = 254, .external_lex_state = 12},
  [12397] = {.lex_state = 254, .external_lex_state = 12},
  [12398] = {.lex_state = 537, .external_lex_state = 12},
  [12399] = {.lex_state = 254, .external_lex_state = 12},
  [12400] = {.lex_state = 380, .external_lex_state = 12},
  [12401] = {.lex_state = 380, .external_lex_state = 12},
  [12402] = {.lex_state = 537, .external_lex_state = 12},
  [12403] = {.lex_state = 537, .external_lex_state = 12},
  [12404] = {.lex_state = 537, .external_lex_state = 12},
  [12405] = {.lex_state = 537, .external_lex_state = 12},
  [12406] = {.lex_state = 537, .external_lex_state = 12},
  [12407] = {.lex_state = 537, .external_lex_state = 12},
  [12408] = {.lex_state = 343, .external_lex_state = 2},
  [12409] = {.lex_state = 537, .external_lex_state = 12},
  [12410] = {.lex_state = 537, .external_lex_state = 12},
  [12411] = {.lex_state = 537, .external_lex_state = 12},
  [12412] = {.lex_state = 537, .external_lex_state = 12},
  [12413] = {.lex_state = 537, .external_lex_state = 12},
  [12414] = {.lex_state = 537, .external_lex_state = 12},
  [12415] = {.lex_state = 537, .external_lex_state = 12},
  [12416] = {.lex_state = 537, .external_lex_state = 12},
  [12417] = {.lex_state = 537, .external_lex_state = 12},
  [12418] = {.lex_state = 380, .external_lex_state = 12},
  [12419] = {.lex_state = 380, .external_lex_state = 12},
  [12420] = {.lex_state = 343, .external_lex_state = 2},
  [12421] = {.lex_state = 540, .external_lex_state = 12},
  [12422] = {.lex_state = 254, .external_lex_state = 12},
  [12423] = {.lex_state = 254, .external_lex_state = 12},
  [12424] = {.lex_state = 538, .external_lex_state = 12},
  [12425] = {.lex_state = 537, .external_lex_state = 12},
  [12426] = {.lex_state = 380, .external_lex_state = 12},
  [12427] = {.lex_state = 380, .external_lex_state = 12},
  [12428] = {.lex_state = 343, .external_lex_state = 2},
  [12429] = {.lex_state = 343, .external_lex_state = 2},
  [12430] = {.lex_state = 537, .external_lex_state = 12},
  [12431] = {.lex_state = 540, .external_lex_state = 12},
  [12432] = {.lex_state = 537, .external_lex_state = 13},
  [12433] = {.lex_state = 380, .external_lex_state = 12},
  [12434] = {.lex_state = 380, .external_lex_state = 12},
  [12435] = {.lex_state = 343, .external_lex_state = 2},
  [12436] = {.lex_state = 380, .external_lex_state = 12},
  [12437] = {.lex_state = 380, .external_lex_state = 12},
  [12438] = {.lex_state = 343, .external_lex_state = 2},
  [12439] = {.lex_state = 380, .external_lex_state = 12},
  [12440] = {.lex_state = 380, .external_lex_state = 12},
  [12441] = {.lex_state = 343, .external_lex_state = 2},
  [12442] = {.lex_state = 350, .external_lex_state = 12},
  [12443] = {.lex_state = 380, .external_lex_state = 12},
  [12444] = {.lex_state = 380, .external_lex_state = 12},
  [12445] = {.lex_state = 343, .external_lex_state = 2},
  [12446] = {.lex_state = 380, .external_lex_state = 12},
  [12447] = {.lex_state = 380, .external_lex_state = 12},
  [12448] = {.lex_state = 537, .external_lex_state = 12},
  [12449] = {.lex_state = 343, .external_lex_state = 2},
  [12450] = {.lex_state = 380, .external_lex_state = 12},
  [12451] = {.lex_state = 380, .external_lex_state = 12},
  [12452] = {.lex_state = 380, .external_lex_state = 12},
  [12453] = {.lex_state = 343, .external_lex_state = 2},
  [12454] = {.lex_state = 380, .external_lex_state = 12},
  [12455] = {.lex_state = 380, .external_lex_state = 12},
  [12456] = {.lex_state = 380, .external_lex_state = 12},
  [12457] = {.lex_state = 343, .external_lex_state = 2},
  [12458] = {.lex_state = 380, .external_lex_state = 12},
  [12459] = {.lex_state = 380, .external_lex_state = 12},
  [12460] = {.lex_state = 537, .external_lex_state = 12},
  [12461] = {.lex_state = 343, .external_lex_state = 2},
  [12462] = {.lex_state = 537, .external_lex_state = 12},
  [12463] = {.lex_state = 380, .external_lex_state = 12},
  [12464] = {.lex_state = 380, .external_lex_state = 12},
  [12465] = {.lex_state = 254, .external_lex_state = 12},
  [12466] = {.lex_state = 343, .external_lex_state = 2},
  [12467] = {.lex_state = 380, .external_lex_state = 12},
  [12468] = {.lex_state = 380, .external_lex_state = 12},
  [12469] = {.lex_state = 380, .external_lex_state = 12},
  [12470] = {.lex_state = 343, .external_lex_state = 2},
  [12471] = {.lex_state = 254, .external_lex_state = 12},
  [12472] = {.lex_state = 540, .external_lex_state = 12},
  [12473] = {.lex_state = 343, .external_lex_state = 2},
  [12474] = {.lex_state = 380, .external_lex_state = 12},
  [12475] = {.lex_state = 538, .external_lex_state = 12},
  [12476] = {.lex_state = 380, .external_lex_state = 12},
  [12477] = {.lex_state = 380, .external_lex_state = 12},
  [12478] = {.lex_state = 343, .external_lex_state = 2},
  [12479] = {.lex_state = 380, .external_lex_state = 12},
  [12480] = {.lex_state = 537, .external_lex_state = 12},
  [12481] = {.lex_state = 537, .external_lex_state = 12},
  [12482] = {.lex_state = 537, .external_lex_state = 12},
  [12483] = {.lex_state = 380, .external_lex_state = 12},
  [12484] = {.lex_state = 537, .external_lex_state = 12},
  [12485] = {.lex_state = 537, .external_lex_state = 12},
  [12486] = {.lex_state = 537, .external_lex_state = 12},
  [12487] = {.lex_state = 343, .external_lex_state = 2},
  [12488] = {.lex_state = 537, .external_lex_state = 12},
  [12489] = {.lex_state = 380, .external_lex_state = 12},
  [12490] = {.lex_state = 538, .external_lex_state = 12},
  [12491] = {.lex_state = 380, .external_lex_state = 12},
  [12492] = {.lex_state = 538, .external_lex_state = 12},
  [12493] = {.lex_state = 343, .external_lex_state = 2},
  [12494] = {.lex_state = 538, .external_lex_state = 12},
  [12495] = {.lex_state = 538, .external_lex_state = 12},
  [12496] = {.lex_state = 538, .external_lex_state = 12},
  [12497] = {.lex_state = 538, .external_lex_state = 12},
  [12498] = {.lex_state = 538, .external_lex_state = 12},
  [12499] = {.lex_state = 538, .external_lex_state = 12},
  [12500] = {.lex_state = 380, .external_lex_state = 12},
  [12501] = {.lex_state = 380, .external_lex_state = 12},
  [12502] = {.lex_state = 538, .external_lex_state = 12},
  [12503] = {.lex_state = 350, .external_lex_state = 12},
  [12504] = {.lex_state = 343, .external_lex_state = 2},
  [12505] = {.lex_state = 538, .external_lex_state = 12},
  [12506] = {.lex_state = 380, .external_lex_state = 12},
  [12507] = {.lex_state = 380, .external_lex_state = 12},
  [12508] = {.lex_state = 343, .external_lex_state = 2},
  [12509] = {.lex_state = 380, .external_lex_state = 12},
  [12510] = {.lex_state = 380, .external_lex_state = 12},
  [12511] = {.lex_state = 380, .external_lex_state = 12},
  [12512] = {.lex_state = 343, .external_lex_state = 2},
  [12513] = {.lex_state = 380, .external_lex_state = 12},
  [12514] = {.lex_state = 343, .external_lex_state = 2},
  [12515] = {.lex_state = 380, .external_lex_state = 12},
  [12516] = {.lex_state = 380, .external_lex_state = 12},
  [12517] = {.lex_state = 343, .external_lex_state = 2},
  [12518] = {.lex_state = 538, .external_lex_state = 12},
  [12519] = {.lex_state = 380, .external_lex_state = 12},
  [12520] = {.lex_state = 538, .external_lex_state = 12},
  [12521] = {.lex_state = 380, .external_lex_state = 12},
  [12522] = {.lex_state = 537, .external_lex_state = 12},
  [12523] = {.lex_state = 343, .external_lex_state = 2},
  [12524] = {.lex_state = 537, .external_lex_state = 12},
  [12525] = {.lex_state = 537, .external_lex_state = 12},
  [12526] = {.lex_state = 538, .external_lex_state = 12},
  [12527] = {.lex_state = 537, .external_lex_state = 12},
  [12528] = {.lex_state = 537, .external_lex_state = 12},
  [12529] = {.lex_state = 537, .external_lex_state = 12},
  [12530] = {.lex_state = 380, .external_lex_state = 12},
  [12531] = {.lex_state = 380, .external_lex_state = 12},
  [12532] = {.lex_state = 537, .external_lex_state = 12},
  [12533] = {.lex_state = 537, .external_lex_state = 12},
  [12534] = {.lex_state = 343, .external_lex_state = 2},
  [12535] = {.lex_state = 537, .external_lex_state = 12},
  [12536] = {.lex_state = 537, .external_lex_state = 12},
  [12537] = {.lex_state = 537, .external_lex_state = 12},
  [12538] = {.lex_state = 537, .external_lex_state = 12},
  [12539] = {.lex_state = 537, .external_lex_state = 12},
  [12540] = {.lex_state = 537, .external_lex_state = 12},
  [12541] = {.lex_state = 540, .external_lex_state = 12},
  [12542] = {.lex_state = 380, .external_lex_state = 12},
  [12543] = {.lex_state = 380, .external_lex_state = 12},
  [12544] = {.lex_state = 343, .external_lex_state = 2},
  [12545] = {.lex_state = 343, .external_lex_state = 2},
  [12546] = {.lex_state = 537, .external_lex_state = 12},
  [12547] = {.lex_state = 538, .external_lex_state = 12},
  [12548] = {.lex_state = 537, .external_lex_state = 12},
  [12549] = {.lex_state = 538, .external_lex_state = 12},
  [12550] = {.lex_state = 538, .external_lex_state = 12},
  [12551] = {.lex_state = 380, .external_lex_state = 12},
  [12552] = {.lex_state = 538, .external_lex_state = 12},
  [12553] = {.lex_state = 538, .external_lex_state = 12},
  [12554] = {.lex_state = 538, .external_lex_state = 12},
  [12555] = {.lex_state = 254, .external_lex_state = 12},
  [12556] = {.lex_state = 380, .external_lex_state = 12},
  [12557] = {.lex_state = 538, .external_lex_state = 12},
  [12558] = {.lex_state = 538, .external_lex_state = 12},
  [12559] = {.lex_state = 538, .external_lex_state = 12},
  [12560] = {.lex_state = 343, .external_lex_state = 2},
  [12561] = {.lex_state = 538, .external_lex_state = 12},
  [12562] = {.lex_state = 538, .external_lex_state = 12},
  [12563] = {.lex_state = 380, .external_lex_state = 12},
  [12564] = {.lex_state = 380, .external_lex_state = 12},
  [12565] = {.lex_state = 343, .external_lex_state = 2},
  [12566] = {.lex_state = 538, .external_lex_state = 12},
  [12567] = {.lex_state = 537, .external_lex_state = 12},
  [12568] = {.lex_state = 350, .external_lex_state = 12},
  [12569] = {.lex_state = 343, .external_lex_state = 2},
  [12570] = {.lex_state = 350, .external_lex_state = 12},
  [12571] = {.lex_state = 343, .external_lex_state = 2},
  [12572] = {.lex_state = 343, .external_lex_state = 2},
  [12573] = {.lex_state = 343, .external_lex_state = 2},
  [12574] = {.lex_state = 380, .external_lex_state = 12},
  [12575] = {.lex_state = 343, .external_lex_state = 2},
  [12576] = {.lex_state = 537, .external_lex_state = 12},
  [12577] = {.lex_state = 380, .external_lex_state = 12},
  [12578] = {.lex_state = 343, .external_lex_state = 2},
  [12579] = {.lex_state = 350, .external_lex_state = 12},
  [12580] = {.lex_state = 343, .external_lex_state = 2},
  [12581] = {.lex_state = 254, .external_lex_state = 12},
  [12582] = {.lex_state = 343, .external_lex_state = 2},
  [12583] = {.lex_state = 537, .external_lex_state = 12},
  [12584] = {.lex_state = 343, .external_lex_state = 2},
  [12585] = {.lex_state = 343, .external_lex_state = 2},
  [12586] = {.lex_state = 537, .external_lex_state = 12},
  [12587] = {.lex_state = 540, .external_lex_state = 12},
  [12588] = {.lex_state = 343, .external_lex_state = 2},
  [12589] = {.lex_state = 537, .external_lex_state = 13},
  [12590] = {.lex_state = 343, .external_lex_state = 2},
  [12591] = {.lex_state = 343, .external_lex_state = 2},
  [12592] = {.lex_state = 343, .external_lex_state = 2},
  [12593] = {.lex_state = 538, .external_lex_state = 12},
  [12594] = {.lex_state = 343, .external_lex_state = 2},
  [12595] = {.lex_state = 350, .external_lex_state = 12},
  [12596] = {.lex_state = 343, .external_lex_state = 2},
  [12597] = {.lex_state = 538, .external_lex_state = 12},
  [12598] = {.lex_state = 343, .external_lex_state = 2},
  [12599] = {.lex_state = 537, .external_lex_state = 12},
  [12600] = {.lex_state = 380, .external_lex_state = 12},
  [12601] = {.lex_state = 343, .external_lex_state = 2},
  [12602] = {.lex_state = 380, .external_lex_state = 12},
  [12603] = {.lex_state = 538, .external_lex_state = 12},
  [12604] = {.lex_state = 538, .external_lex_state = 12},
  [12605] = {.lex_state = 343, .external_lex_state = 2},
  [12606] = {.lex_state = 538, .external_lex_state = 12},
  [12607] = {.lex_state = 380, .external_lex_state = 12},
  [12608] = {.lex_state = 343, .external_lex_state = 2},
  [12609] = {.lex_state = 538, .external_lex_state = 12},
  [12610] = {.lex_state = 538, .external_lex_state = 12},
  [12611] = {.lex_state = 343, .external_lex_state = 2},
  [12612] = {.lex_state = 538, .external_lex_state = 12},
  [12613] = {.lex_state = 538, .external_lex_state = 12},
  [12614] = {.lex_state = 254, .external_lex_state = 12},
  [12615] = {.lex_state = 380, .external_lex_state = 12},
  [12616] = {.lex_state = 538, .external_lex_state = 12},
  [12617] = {.lex_state = 538, .external_lex_state = 12},
  [12618] = {.lex_state = 538, .external_lex_state = 12},
  [12619] = {.lex_state = 343, .external_lex_state = 2},
  [12620] = {.lex_state = 538, .external_lex_state = 12},
  [12621] = {.lex_state = 343, .external_lex_state = 2},
  [12622] = {.lex_state = 540, .external_lex_state = 12},
  [12623] = {.lex_state = 537, .external_lex_state = 13},
  [12624] = {.lex_state = 538, .external_lex_state = 12},
  [12625] = {.lex_state = 343, .external_lex_state = 2},
  [12626] = {.lex_state = 538, .external_lex_state = 12},
  [12627] = {.lex_state = 538, .external_lex_state = 12},
  [12628] = {.lex_state = 537, .external_lex_state = 12},
  [12629] = {.lex_state = 537, .external_lex_state = 12},
  [12630] = {.lex_state = 537, .external_lex_state = 12},
  [12631] = {.lex_state = 537, .external_lex_state = 12},
  [12632] = {.lex_state = 537, .external_lex_state = 12},
  [12633] = {.lex_state = 537, .external_lex_state = 12},
  [12634] = {.lex_state = 538, .external_lex_state = 12},
  [12635] = {.lex_state = 343, .external_lex_state = 2},
  [12636] = {.lex_state = 343, .external_lex_state = 2},
  [12637] = {.lex_state = 537, .external_lex_state = 12},
  [12638] = {.lex_state = 343, .external_lex_state = 2},
  [12639] = {.lex_state = 538, .external_lex_state = 12},
  [12640] = {.lex_state = 350, .external_lex_state = 12},
  [12641] = {.lex_state = 538, .external_lex_state = 12},
  [12642] = {.lex_state = 343, .external_lex_state = 2},
  [12643] = {.lex_state = 538, .external_lex_state = 12},
  [12644] = {.lex_state = 343, .external_lex_state = 2},
  [12645] = {.lex_state = 343, .external_lex_state = 2},
  [12646] = {.lex_state = 343, .external_lex_state = 2},
  [12647] = {.lex_state = 343, .external_lex_state = 2},
  [12648] = {.lex_state = 343, .external_lex_state = 2},
  [12649] = {.lex_state = 343, .external_lex_state = 2},
  [12650] = {.lex_state = 343, .external_lex_state = 2},
  [12651] = {.lex_state = 343, .external_lex_state = 2},
  [12652] = {.lex_state = 343, .external_lex_state = 2},
  [12653] = {.lex_state = 538, .external_lex_state = 12},
  [12654] = {.lex_state = 343, .external_lex_state = 2},
  [12655] = {.lex_state = 343, .external_lex_state = 2},
  [12656] = {.lex_state = 343, .external_lex_state = 2},
  [12657] = {.lex_state = 343, .external_lex_state = 2},
  [12658] = {.lex_state = 343, .external_lex_state = 2},
  [12659] = {.lex_state = 343, .external_lex_state = 2},
  [12660] = {.lex_state = 343, .external_lex_state = 2},
  [12661] = {.lex_state = 343, .external_lex_state = 2},
  [12662] = {.lex_state = 343, .external_lex_state = 2},
  [12663] = {.lex_state = 343, .external_lex_state = 2},
  [12664] = {.lex_state = 343, .external_lex_state = 2},
  [12665] = {.lex_state = 343, .external_lex_state = 2},
  [12666] = {.lex_state = 343, .external_lex_state = 2},
  [12667] = {.lex_state = 380, .external_lex_state = 12},
  [12668] = {.lex_state = 380, .external_lex_state = 12},
  [12669] = {.lex_state = 380, .external_lex_state = 12},
  [12670] = {.lex_state = 538, .external_lex_state = 12},
  [12671] = {.lex_state = 540, .external_lex_state = 12},
  [12672] = {.lex_state = 537, .external_lex_state = 12},
  [12673] = {.lex_state = 343, .external_lex_state = 2},
  [12674] = {.lex_state = 537, .external_lex_state = 12},
  [12675] = {.lex_state = 538, .external_lex_state = 12},
  [12676] = {.lex_state = 538, .external_lex_state = 12},
  [12677] = {.lex_state = 538, .external_lex_state = 12},
  [12678] = {.lex_state = 537, .external_lex_state = 12},
  [12679] = {.lex_state = 538, .external_lex_state = 12},
  [12680] = {.lex_state = 538, .external_lex_state = 12},
  [12681] = {.lex_state = 538, .external_lex_state = 12},
  [12682] = {.lex_state = 538, .external_lex_state = 12},
  [12683] = {.lex_state = 538, .external_lex_state = 12},
  [12684] = {.lex_state = 538, .external_lex_state = 12},
  [12685] = {.lex_state = 538, .external_lex_state = 12},
  [12686] = {.lex_state = 538, .external_lex_state = 12},
  [12687] = {.lex_state = 538, .external_lex_state = 12},
  [12688] = {.lex_state = 350, .external_lex_state = 12},
  [12689] = {.lex_state = 538, .external_lex_state = 12},
  [12690] = {.lex_state = 538, .external_lex_state = 12},
  [12691] = {.lex_state = 538, .external_lex_state = 12},
  [12692] = {.lex_state = 538, .external_lex_state = 12},
  [12693] = {.lex_state = 537, .external_lex_state = 12},
  [12694] = {.lex_state = 540, .external_lex_state = 12},
  [12695] = {.lex_state = 538, .external_lex_state = 12},
  [12696] = {.lex_state = 380, .external_lex_state = 12},
  [12697] = {.lex_state = 268, .external_lex_state = 12},
  [12698] = {.lex_state = 254, .external_lex_state = 12},
  [12699] = {.lex_state = 537, .external_lex_state = 12},
  [12700] = {.lex_state = 254, .external_lex_state = 12},
  [12701] = {.lex_state = 254, .external_lex_state = 12},
  [12702] = {.lex_state = 254, .external_lex_state = 12},
  [12703] = {.lex_state = 538, .external_lex_state = 12},
  [12704] = {.lex_state = 538, .external_lex_state = 12},
  [12705] = {.lex_state = 538, .external_lex_state = 12},
  [12706] = {.lex_state = 257, .external_lex_state = 12},
  [12707] = {.lex_state = 537, .external_lex_state = 12},
  [12708] = {.lex_state = 538, .external_lex_state = 12},
  [12709] = {.lex_state = 380, .external_lex_state = 12},
  [12710] = {.lex_state = 538, .external_lex_state = 12},
  [12711] = {.lex_state = 538, .external_lex_state = 12},
  [12712] = {.lex_state = 538, .external_lex_state = 12},
  [12713] = {.lex_state = 538, .external_lex_state = 12},
  [12714] = {.lex_state = 538, .external_lex_state = 12},
  [12715] = {.lex_state = 254, .external_lex_state = 12},
  [12716] = {.lex_state = 538, .external_lex_state = 12},
  [12717] = {.lex_state = 343, .external_lex_state = 2},
  [12718] = {.lex_state = 538, .external_lex_state = 12},
  [12719] = {.lex_state = 538, .external_lex_state = 12},
  [12720] = {.lex_state = 540, .external_lex_state = 12},
  [12721] = {.lex_state = 538, .external_lex_state = 12},
  [12722] = {.lex_state = 537, .external_lex_state = 13},
  [12723] = {.lex_state = 538, .external_lex_state = 12},
  [12724] = {.lex_state = 538, .external_lex_state = 12},
  [12725] = {.lex_state = 538, .external_lex_state = 12},
  [12726] = {.lex_state = 538, .external_lex_state = 12},
  [12727] = {.lex_state = 538, .external_lex_state = 12},
  [12728] = {.lex_state = 538, .external_lex_state = 12},
  [12729] = {.lex_state = 343, .external_lex_state = 2},
  [12730] = {.lex_state = 343, .external_lex_state = 2},
  [12731] = {.lex_state = 343, .external_lex_state = 2},
  [12732] = {.lex_state = 343, .external_lex_state = 2},
  [12733] = {.lex_state = 343, .external_lex_state = 2},
  [12734] = {.lex_state = 343, .external_lex_state = 2},
  [12735] = {.lex_state = 343, .external_lex_state = 2},
  [12736] = {.lex_state = 343, .external_lex_state = 2},
  [12737] = {.lex_state = 343, .external_lex_state = 2},
  [12738] = {.lex_state = 343, .external_lex_state = 2},
  [12739] = {.lex_state = 538, .external_lex_state = 12},
  [12740] = {.lex_state = 343, .external_lex_state = 2},
  [12741] = {.lex_state = 343, .external_lex_state = 2},
  [12742] = {.lex_state = 343, .external_lex_state = 2},
  [12743] = {.lex_state = 343, .external_lex_state = 2},
  [12744] = {.lex_state = 343, .external_lex_state = 2},
  [12745] = {.lex_state = 538, .external_lex_state = 12},
  [12746] = {.lex_state = 538, .external_lex_state = 12},
  [12747] = {.lex_state = 538, .external_lex_state = 12},
  [12748] = {.lex_state = 254, .external_lex_state = 12},
  [12749] = {.lex_state = 538, .external_lex_state = 12},
  [12750] = {.lex_state = 538, .external_lex_state = 12},
  [12751] = {.lex_state = 538, .external_lex_state = 12},
  [12752] = {.lex_state = 538, .external_lex_state = 12},
  [12753] = {.lex_state = 350, .external_lex_state = 12},
  [12754] = {.lex_state = 343, .external_lex_state = 2},
  [12755] = {.lex_state = 343, .external_lex_state = 2},
  [12756] = {.lex_state = 343, .external_lex_state = 2},
  [12757] = {.lex_state = 343, .external_lex_state = 2},
  [12758] = {.lex_state = 380, .external_lex_state = 12},
  [12759] = {.lex_state = 538, .external_lex_state = 12},
  [12760] = {.lex_state = 380, .external_lex_state = 12},
  [12761] = {.lex_state = 343, .external_lex_state = 2},
  [12762] = {.lex_state = 343, .external_lex_state = 2},
  [12763] = {.lex_state = 343, .external_lex_state = 2},
  [12764] = {.lex_state = 343, .external_lex_state = 2},
  [12765] = {.lex_state = 380, .external_lex_state = 12},
  [12766] = {.lex_state = 343, .external_lex_state = 2},
  [12767] = {.lex_state = 343, .external_lex_state = 2},
  [12768] = {.lex_state = 343, .external_lex_state = 2},
  [12769] = {.lex_state = 343, .external_lex_state = 2},
  [12770] = {.lex_state = 540, .external_lex_state = 12},
  [12771] = {.lex_state = 537, .external_lex_state = 13},
  [12772] = {.lex_state = 343, .external_lex_state = 2},
  [12773] = {.lex_state = 343, .external_lex_state = 2},
  [12774] = {.lex_state = 343, .external_lex_state = 2},
  [12775] = {.lex_state = 538, .external_lex_state = 12},
  [12776] = {.lex_state = 538, .external_lex_state = 12},
  [12777] = {.lex_state = 538, .external_lex_state = 12},
  [12778] = {.lex_state = 343, .external_lex_state = 2},
  [12779] = {.lex_state = 343, .external_lex_state = 2},
  [12780] = {.lex_state = 343, .external_lex_state = 2},
  [12781] = {.lex_state = 254, .external_lex_state = 12},
  [12782] = {.lex_state = 343, .external_lex_state = 2},
  [12783] = {.lex_state = 343, .external_lex_state = 2},
  [12784] = {.lex_state = 343, .external_lex_state = 2},
  [12785] = {.lex_state = 343, .external_lex_state = 2},
  [12786] = {.lex_state = 350, .external_lex_state = 12},
  [12787] = {.lex_state = 343, .external_lex_state = 2},
  [12788] = {.lex_state = 254, .external_lex_state = 12},
  [12789] = {.lex_state = 254, .external_lex_state = 12},
  [12790] = {.lex_state = 343, .external_lex_state = 2},
  [12791] = {.lex_state = 343, .external_lex_state = 2},
  [12792] = {.lex_state = 537, .external_lex_state = 12},
  [12793] = {.lex_state = 254, .external_lex_state = 12},
  [12794] = {.lex_state = 254, .external_lex_state = 12},
  [12795] = {.lex_state = 254, .external_lex_state = 12},
  [12796] = {.lex_state = 254, .external_lex_state = 12},
  [12797] = {.lex_state = 538, .external_lex_state = 12},
  [12798] = {.lex_state = 254, .external_lex_state = 12},
  [12799] = {.lex_state = 254, .external_lex_state = 12},
  [12800] = {.lex_state = 537, .external_lex_state = 12},
  [12801] = {.lex_state = 254, .external_lex_state = 12},
  [12802] = {.lex_state = 380, .external_lex_state = 12},
  [12803] = {.lex_state = 540, .external_lex_state = 12},
  [12804] = {.lex_state = 254, .external_lex_state = 12},
  [12805] = {.lex_state = 343, .external_lex_state = 2},
  [12806] = {.lex_state = 380, .external_lex_state = 12},
  [12807] = {.lex_state = 350, .external_lex_state = 12},
  [12808] = {.lex_state = 537, .external_lex_state = 12},
  [12809] = {.lex_state = 538, .external_lex_state = 12},
  [12810] = {.lex_state = 343, .external_lex_state = 2},
  [12811] = {.lex_state = 538, .external_lex_state = 12},
  [12812] = {.lex_state = 537, .external_lex_state = 12},
  [12813] = {.lex_state = 537, .external_lex_state = 12},
  [12814] = {.lex_state = 540, .external_lex_state = 12},
  [12815] = {.lex_state = 537, .external_lex_state = 13},
  [12816] = {.lex_state = 537, .external_lex_state = 12},
  [12817] = {.lex_state = 537, .external_lex_state = 12},
  [12818] = {.lex_state = 537, .external_lex_state = 12},
  [12819] = {.lex_state = 537, .external_lex_state = 12},
  [12820] = {.lex_state = 537, .external_lex_state = 12},
  [12821] = {.lex_state = 254, .external_lex_state = 12},
  [12822] = {.lex_state = 537, .external_lex_state = 12},
  [12823] = {.lex_state = 537, .external_lex_state = 12},
  [12824] = {.lex_state = 537, .external_lex_state = 12},
  [12825] = {.lex_state = 537, .external_lex_state = 12},
  [12826] = {.lex_state = 350, .external_lex_state = 12},
  [12827] = {.lex_state = 537, .external_lex_state = 12},
  [12828] = {.lex_state = 537, .external_lex_state = 12},
  [12829] = {.lex_state = 537, .external_lex_state = 12},
  [12830] = {.lex_state = 537, .external_lex_state = 12},
  [12831] = {.lex_state = 537, .external_lex_state = 12},
  [12832] = {.lex_state = 537, .external_lex_state = 12},
  [12833] = {.lex_state = 537, .external_lex_state = 12},
  [12834] = {.lex_state = 537, .external_lex_state = 12},
  [12835] = {.lex_state = 537, .external_lex_state = 12},
  [12836] = {.lex_state = 537, .external_lex_state = 12},
  [12837] = {.lex_state = 537, .external_lex_state = 12},
  [12838] = {.lex_state = 537, .external_lex_state = 12},
  [12839] = {.lex_state = 537, .external_lex_state = 12},
  [12840] = {.lex_state = 343, .external_lex_state = 2},
  [12841] = {.lex_state = 343, .external_lex_state = 2},
  [12842] = {.lex_state = 343, .external_lex_state = 2},
  [12843] = {.lex_state = 537, .external_lex_state = 12},
  [12844] = {.lex_state = 350, .external_lex_state = 12},
  [12845] = {.lex_state = 537, .external_lex_state = 12},
  [12846] = {.lex_state = 537, .external_lex_state = 12},
  [12847] = {.lex_state = 537, .external_lex_state = 12},
  [12848] = {.lex_state = 537, .external_lex_state = 12},
  [12849] = {.lex_state = 343, .external_lex_state = 2},
  [12850] = {.lex_state = 343, .external_lex_state = 2},
  [12851] = {.lex_state = 350, .external_lex_state = 12},
  [12852] = {.lex_state = 343, .external_lex_state = 2},
  [12853] = {.lex_state = 350, .external_lex_state = 12},
  [12854] = {.lex_state = 537, .external_lex_state = 12},
  [12855] = {.lex_state = 343, .external_lex_state = 2},
  [12856] = {.lex_state = 343, .external_lex_state = 2},
  [12857] = {.lex_state = 537, .external_lex_state = 12},
  [12858] = {.lex_state = 350, .external_lex_state = 12},
  [12859] = {.lex_state = 537, .external_lex_state = 12},
  [12860] = {.lex_state = 537, .external_lex_state = 12},
  [12861] = {.lex_state = 537, .external_lex_state = 12},
  [12862] = {.lex_state = 537, .external_lex_state = 12},
  [12863] = {.lex_state = 343, .external_lex_state = 2},
  [12864] = {.lex_state = 343, .external_lex_state = 2},
  [12865] = {.lex_state = 537, .external_lex_state = 12},
  [12866] = {.lex_state = 350, .external_lex_state = 12},
  [12867] = {.lex_state = 537, .external_lex_state = 12},
  [12868] = {.lex_state = 537, .external_lex_state = 12},
  [12869] = {.lex_state = 537, .external_lex_state = 12},
  [12870] = {.lex_state = 537, .external_lex_state = 12},
  [12871] = {.lex_state = 343, .external_lex_state = 2},
  [12872] = {.lex_state = 343, .external_lex_state = 2},
  [12873] = {.lex_state = 350, .external_lex_state = 12},
  [12874] = {.lex_state = 537, .external_lex_state = 12},
  [12875] = {.lex_state = 343, .external_lex_state = 2},
  [12876] = {.lex_state = 343, .external_lex_state = 2},
  [12877] = {.lex_state = 343, .external_lex_state = 2},
  [12878] = {.lex_state = 343, .external_lex_state = 2},
  [12879] = {.lex_state = 343, .external_lex_state = 2},
  [12880] = {.lex_state = 343, .external_lex_state = 2},
  [12881] = {.lex_state = 343, .external_lex_state = 2},
  [12882] = {.lex_state = 537, .external_lex_state = 12},
  [12883] = {.lex_state = 537, .external_lex_state = 12},
  [12884] = {.lex_state = 537, .external_lex_state = 12},
  [12885] = {.lex_state = 537, .external_lex_state = 12},
  [12886] = {.lex_state = 380, .external_lex_state = 12},
  [12887] = {.lex_state = 380, .external_lex_state = 12},
  [12888] = {.lex_state = 380, .external_lex_state = 12},
  [12889] = {.lex_state = 380, .external_lex_state = 12},
  [12890] = {.lex_state = 380, .external_lex_state = 12},
  [12891] = {.lex_state = 537, .external_lex_state = 12},
  [12892] = {.lex_state = 537, .external_lex_state = 12},
  [12893] = {.lex_state = 537, .external_lex_state = 12},
  [12894] = {.lex_state = 537, .external_lex_state = 12},
  [12895] = {.lex_state = 380, .external_lex_state = 12},
  [12896] = {.lex_state = 537, .external_lex_state = 12},
  [12897] = {.lex_state = 537, .external_lex_state = 12},
  [12898] = {.lex_state = 537, .external_lex_state = 12},
  [12899] = {.lex_state = 537, .external_lex_state = 12},
  [12900] = {.lex_state = 538, .external_lex_state = 12},
  [12901] = {.lex_state = 380, .external_lex_state = 12},
  [12902] = {.lex_state = 537, .external_lex_state = 12},
  [12903] = {.lex_state = 537, .external_lex_state = 12},
  [12904] = {.lex_state = 254, .external_lex_state = 12},
  [12905] = {.lex_state = 380, .external_lex_state = 12},
  [12906] = {.lex_state = 537, .external_lex_state = 12},
  [12907] = {.lex_state = 537, .external_lex_state = 12},
  [12908] = {.lex_state = 380, .external_lex_state = 12},
  [12909] = {.lex_state = 540, .external_lex_state = 12},
  [12910] = {.lex_state = 537, .external_lex_state = 12},
  [12911] = {.lex_state = 537, .external_lex_state = 12},
  [12912] = {.lex_state = 537, .external_lex_state = 12},
  [12913] = {.lex_state = 254, .external_lex_state = 12},
  [12914] = {.lex_state = 537, .external_lex_state = 12},
  [12915] = {.lex_state = 537, .external_lex_state = 12},
  [12916] = {.lex_state = 537, .external_lex_state = 12},
  [12917] = {.lex_state = 380, .external_lex_state = 12},
  [12918] = {.lex_state = 537, .external_lex_state = 12},
  [12919] = {.lex_state = 537, .external_lex_state = 12},
  [12920] = {.lex_state = 254, .external_lex_state = 12},
  [12921] = {.lex_state = 537, .external_lex_state = 12},
  [12922] = {.lex_state = 537, .external_lex_state = 12},
  [12923] = {.lex_state = 537, .external_lex_state = 12},
  [12924] = {.lex_state = 537, .external_lex_state = 12},
  [12925] = {.lex_state = 537, .external_lex_state = 12},
  [12926] = {.lex_state = 537, .external_lex_state = 12},
  [12927] = {.lex_state = 537, .external_lex_state = 12},
  [12928] = {.lex_state = 540, .external_lex_state = 12},
  [12929] = {.lex_state = 537, .external_lex_state = 12},
  [12930] = {.lex_state = 537, .external_lex_state = 12},
  [12931] = {.lex_state = 537, .external_lex_state = 12},
  [12932] = {.lex_state = 537, .external_lex_state = 12},
  [12933] = {.lex_state = 380, .external_lex_state = 12},
  [12934] = {.lex_state = 537, .external_lex_state = 12},
  [12935] = {.lex_state = 380, .external_lex_state = 12},
  [12936] = {.lex_state = 540, .external_lex_state = 12},
  [12937] = {.lex_state = 537, .external_lex_state = 12},
  [12938] = {.lex_state = 540, .external_lex_state = 12},
  [12939] = {.lex_state = 537, .external_lex_state = 12},
  [12940] = {.lex_state = 380, .external_lex_state = 12},
  [12941] = {.lex_state = 380, .external_lex_state = 12},
  [12942] = {.lex_state = 537, .external_lex_state = 12},
  [12943] = {.lex_state = 537, .external_lex_state = 12},
  [12944] = {.lex_state = 537, .external_lex_state = 12},
  [12945] = {.lex_state = 537, .external_lex_state = 12},
  [12946] = {.lex_state = 537, .external_lex_state = 12},
  [12947] = {.lex_state = 537, .external_lex_state = 12},
  [12948] = {.lex_state = 537, .external_lex_state = 12},
  [12949] = {.lex_state = 380, .external_lex_state = 12},
  [12950] = {.lex_state = 540, .external_lex_state = 12},
  [12951] = {.lex_state = 537, .external_lex_state = 12},
  [12952] = {.lex_state = 537, .external_lex_state = 12},
  [12953] = {.lex_state = 537, .external_lex_state = 13},
  [12954] = {.lex_state = 537, .external_lex_state = 12},
  [12955] = {.lex_state = 537, .external_lex_state = 12},
  [12956] = {.lex_state = 537, .external_lex_state = 12},
  [12957] = {.lex_state = 537, .external_lex_state = 12},
  [12958] = {.lex_state = 537, .external_lex_state = 12},
  [12959] = {.lex_state = 537, .external_lex_state = 12},
  [12960] = {.lex_state = 537, .external_lex_state = 12},
  [12961] = {.lex_state = 537, .external_lex_state = 12},
  [12962] = {.lex_state = 537, .external_lex_state = 12},
  [12963] = {.lex_state = 537, .external_lex_state = 12},
  [12964] = {.lex_state = 537, .external_lex_state = 12},
  [12965] = {.lex_state = 537, .external_lex_state = 12},
  [12966] = {.lex_state = 384, .external_lex_state = 12},
  [12967] = {.lex_state = 537, .external_lex_state = 12},
  [12968] = {.lex_state = 537, .external_lex_state = 12},
  [12969] = {.lex_state = 537, .external_lex_state = 12},
  [12970] = {.lex_state = 537, .external_lex_state = 12},
  [12971] = {.lex_state = 537, .external_lex_state = 12},
  [12972] = {.lex_state = 537, .external_lex_state = 12},
  [12973] = {.lex_state = 380, .external_lex_state = 13},
  [12974] = {.lex_state = 537, .external_lex_state = 12},
  [12975] = {.lex_state = 537, .external_lex_state = 12},
  [12976] = {.lex_state = 537, .external_lex_state = 12},
  [12977] = {.lex_state = 540, .external_lex_state = 12},
  [12978] = {.lex_state = 537, .external_lex_state = 12},
  [12979] = {.lex_state = 537, .external_lex_state = 12},
  [12980] = {.lex_state = 537, .external_lex_state = 12},
  [12981] = {.lex_state = 537, .external_lex_state = 12},
  [12982] = {.lex_state = 537, .external_lex_state = 12},
  [12983] = {.lex_state = 537, .external_lex_state = 12},
  [12984] = {.lex_state = 537, .external_lex_state = 12},
  [12985] = {.lex_state = 537, .external_lex_state = 12},
  [12986] = {.lex_state = 537, .external_lex_state = 12},
  [12987] = {.lex_state = 537, .external_lex_state = 12},
  [12988] = {.lex_state = 537, .external_lex_state = 12},
  [12989] = {.lex_state = 380, .external_lex_state = 12},
  [12990] = {.lex_state = 537, .external_lex_state = 12},
  [12991] = {.lex_state = 537, .external_lex_state = 12},
  [12992] = {.lex_state = 537, .external_lex_state = 12},
  [12993] = {.lex_state = 537, .external_lex_state = 12},
  [12994] = {.lex_state = 384, .external_lex_state = 12},
  [12995] = {.lex_state = 537, .external_lex_state = 12},
  [12996] = {.lex_state = 537, .external_lex_state = 12},
  [12997] = {.lex_state = 537, .external_lex_state = 12},
  [12998] = {.lex_state = 537, .external_lex_state = 12},
  [12999] = {.lex_state = 540, .external_lex_state = 12},
  [13000] = {.lex_state = 537, .external_lex_state = 13},
  [13001] = {.lex_state = 537, .external_lex_state = 12},
  [13002] = {.lex_state = 537, .external_lex_state = 12},
  [13003] = {.lex_state = 537, .external_lex_state = 12},
  [13004] = {.lex_state = 537, .external_lex_state = 12},
  [13005] = {.lex_state = 537, .external_lex_state = 12},
  [13006] = {.lex_state = 537, .external_lex_state = 12},
  [13007] = {.lex_state = 537, .external_lex_state = 12},
  [13008] = {.lex_state = 537, .external_lex_state = 12},
  [13009] = {.lex_state = 254, .external_lex_state = 12},
  [13010] = {.lex_state = 537, .external_lex_state = 12},
  [13011] = {.lex_state = 380, .external_lex_state = 12},
  [13012] = {.lex_state = 380, .external_lex_state = 12},
  [13013] = {.lex_state = 380, .external_lex_state = 12},
  [13014] = {.lex_state = 537, .external_lex_state = 12},
  [13015] = {.lex_state = 537, .external_lex_state = 12},
  [13016] = {.lex_state = 537, .external_lex_state = 12},
  [13017] = {.lex_state = 538, .external_lex_state = 12},
  [13018] = {.lex_state = 537, .external_lex_state = 13},
  [13019] = {.lex_state = 257, .external_lex_state = 12},
  [13020] = {.lex_state = 537, .external_lex_state = 12},
  [13021] = {.lex_state = 537, .external_lex_state = 12},
  [13022] = {.lex_state = 537, .external_lex_state = 12},
  [13023] = {.lex_state = 537, .external_lex_state = 12},
  [13024] = {.lex_state = 380, .external_lex_state = 12},
  [13025] = {.lex_state = 537, .external_lex_state = 12},
  [13026] = {.lex_state = 537, .external_lex_state = 12},
  [13027] = {.lex_state = 537, .external_lex_state = 12},
  [13028] = {.lex_state = 537, .external_lex_state = 12},
  [13029] = {.lex_state = 537, .external_lex_state = 12},
  [13030] = {.lex_state = 537, .external_lex_state = 12},
  [13031] = {.lex_state = 537, .external_lex_state = 12},
  [13032] = {.lex_state = 380, .external_lex_state = 12},
  [13033] = {.lex_state = 380, .external_lex_state = 12},
  [13034] = {.lex_state = 537, .external_lex_state = 12},
  [13035] = {.lex_state = 537, .external_lex_state = 12},
  [13036] = {.lex_state = 537, .external_lex_state = 12},
  [13037] = {.lex_state = 537, .external_lex_state = 12},
  [13038] = {.lex_state = 537, .external_lex_state = 12},
  [13039] = {.lex_state = 380, .external_lex_state = 12},
  [13040] = {.lex_state = 380, .external_lex_state = 12},
  [13041] = {.lex_state = 537, .external_lex_state = 12},
  [13042] = {.lex_state = 537, .external_lex_state = 12},
  [13043] = {.lex_state = 537, .external_lex_state = 12},
  [13044] = {.lex_state = 537, .external_lex_state = 12},
  [13045] = {.lex_state = 537, .external_lex_state = 12},
  [13046] = {.lex_state = 537, .external_lex_state = 12},
  [13047] = {.lex_state = 254, .external_lex_state = 12},
  [13048] = {.lex_state = 537, .external_lex_state = 12},
  [13049] = {.lex_state = 537, .external_lex_state = 12},
  [13050] = {.lex_state = 380, .external_lex_state = 12},
  [13051] = {.lex_state = 384, .external_lex_state = 12},
  [13052] = {.lex_state = 537, .external_lex_state = 12},
  [13053] = {.lex_state = 537, .external_lex_state = 12},
  [13054] = {.lex_state = 537, .external_lex_state = 12},
  [13055] = {.lex_state = 380, .external_lex_state = 12},
  [13056] = {.lex_state = 537, .external_lex_state = 12},
  [13057] = {.lex_state = 537, .external_lex_state = 12},
  [13058] = {.lex_state = 537, .external_lex_state = 12},
  [13059] = {.lex_state = 537, .external_lex_state = 12},
  [13060] = {.lex_state = 380, .external_lex_state = 13},
  [13061] = {.lex_state = 537, .external_lex_state = 12},
  [13062] = {.lex_state = 380, .external_lex_state = 12},
  [13063] = {.lex_state = 380, .external_lex_state = 12},
  [13064] = {.lex_state = 380, .external_lex_state = 12},
  [13065] = {.lex_state = 537, .external_lex_state = 12},
  [13066] = {.lex_state = 384, .external_lex_state = 12},
  [13067] = {.lex_state = 538, .external_lex_state = 12},
  [13068] = {.lex_state = 537, .external_lex_state = 12},
  [13069] = {.lex_state = 537, .external_lex_state = 12},
  [13070] = {.lex_state = 540, .external_lex_state = 12},
  [13071] = {.lex_state = 537, .external_lex_state = 12},
  [13072] = {.lex_state = 537, .external_lex_state = 12},
  [13073] = {.lex_state = 537, .external_lex_state = 12},
  [13074] = {.lex_state = 540, .external_lex_state = 12},
  [13075] = {.lex_state = 537, .external_lex_state = 12},
  [13076] = {.lex_state = 537, .external_lex_state = 12},
  [13077] = {.lex_state = 384, .external_lex_state = 12},
  [13078] = {.lex_state = 380, .external_lex_state = 13},
  [13079] = {.lex_state = 537, .external_lex_state = 12},
  [13080] = {.lex_state = 540, .external_lex_state = 12},
  [13081] = {.lex_state = 537, .external_lex_state = 12},
  [13082] = {.lex_state = 537, .external_lex_state = 12},
  [13083] = {.lex_state = 537, .external_lex_state = 12},
  [13084] = {.lex_state = 537, .external_lex_state = 12},
  [13085] = {.lex_state = 537, .external_lex_state = 12},
  [13086] = {.lex_state = 537, .external_lex_state = 12},
  [13087] = {.lex_state = 540, .external_lex_state = 12},
  [13088] = {.lex_state = 537, .external_lex_state = 13},
  [13089] = {.lex_state = 537, .external_lex_state = 12},
  [13090] = {.lex_state = 384, .external_lex_state = 12},
  [13091] = {.lex_state = 380, .external_lex_state = 13},
  [13092] = {.lex_state = 537, .external_lex_state = 12},
  [13093] = {.lex_state = 537, .external_lex_state = 12},
  [13094] = {.lex_state = 537, .external_lex_state = 12},
  [13095] = {.lex_state = 540, .external_lex_state = 12},
  [13096] = {.lex_state = 384, .external_lex_state = 12},
  [13097] = {.lex_state = 537, .external_lex_state = 12},
  [13098] = {.lex_state = 537, .external_lex_state = 12},
  [13099] = {.lex_state = 537, .external_lex_state = 12},
  [13100] = {.lex_state = 537, .external_lex_state = 12},
  [13101] = {.lex_state = 254, .external_lex_state = 12},
  [13102] = {.lex_state = 254, .external_lex_state = 12},
  [13103] = {.lex_state = 254, .external_lex_state = 12},
  [13104] = {.lex_state = 537, .external_lex_state = 12},
  [13105] = {.lex_state = 254, .external_lex_state = 12},
  [13106] = {.lex_state = 254, .external_lex_state = 12},
  [13107] = {.lex_state = 537, .external_lex_state = 12},
  [13108] = {.lex_state = 254, .external_lex_state = 12},
  [13109] = {.lex_state = 254, .external_lex_state = 12},
  [13110] = {.lex_state = 254, .external_lex_state = 12},
  [13111] = {.lex_state = 538, .external_lex_state = 12},
  [13112] = {.lex_state = 538, .external_lex_state = 12},
  [13113] = {.lex_state = 537, .external_lex_state = 12},
  [13114] = {.lex_state = 254, .external_lex_state = 12},
  [13115] = {.lex_state = 254, .external_lex_state = 12},
  [13116] = {.lex_state = 254, .external_lex_state = 12},
  [13117] = {.lex_state = 254, .external_lex_state = 12},
  [13118] = {.lex_state = 538, .external_lex_state = 12},
  [13119] = {.lex_state = 254, .external_lex_state = 12},
  [13120] = {.lex_state = 254, .external_lex_state = 12},
  [13121] = {.lex_state = 538, .external_lex_state = 12},
  [13122] = {.lex_state = 538, .external_lex_state = 12},
  [13123] = {.lex_state = 254, .external_lex_state = 12},
  [13124] = {.lex_state = 537, .external_lex_state = 12},
  [13125] = {.lex_state = 537, .external_lex_state = 12},
  [13126] = {.lex_state = 537, .external_lex_state = 12},
  [13127] = {.lex_state = 537, .external_lex_state = 12},
  [13128] = {.lex_state = 537, .external_lex_state = 12},
  [13129] = {.lex_state = 537, .external_lex_state = 12},
  [13130] = {.lex_state = 537, .external_lex_state = 12},
  [13131] = {.lex_state = 537, .external_lex_state = 12},
  [13132] = {.lex_state = 537, .external_lex_state = 12},
  [13133] = {.lex_state = 537, .external_lex_state = 12},
  [13134] = {.lex_state = 537, .external_lex_state = 12},
  [13135] = {.lex_state = 537, .external_lex_state = 12},
  [13136] = {.lex_state = 537, .external_lex_state = 12},
  [13137] = {.lex_state = 537, .external_lex_state = 12},
  [13138] = {.lex_state = 537, .external_lex_state = 12},
  [13139] = {.lex_state = 537, .external_lex_state = 12},
  [13140] = {.lex_state = 380, .external_lex_state = 12},
  [13141] = {.lex_state = 380, .external_lex_state = 12},
  [13142] = {.lex_state = 537, .external_lex_state = 12},
  [13143] = {.lex_state = 537, .external_lex_state = 12},
  [13144] = {.lex_state = 537, .external_lex_state = 12},
  [13145] = {.lex_state = 380, .external_lex_state = 12},
  [13146] = {.lex_state = 537, .external_lex_state = 12},
  [13147] = {.lex_state = 380, .external_lex_state = 12},
  [13148] = {.lex_state = 380, .external_lex_state = 12},
  [13149] = {.lex_state = 380, .external_lex_state = 12},
  [13150] = {.lex_state = 380, .external_lex_state = 12},
  [13151] = {.lex_state = 537, .external_lex_state = 12},
  [13152] = {.lex_state = 537, .external_lex_state = 12},
  [13153] = {.lex_state = 537, .external_lex_state = 12},
  [13154] = {.lex_state = 384, .external_lex_state = 12},
  [13155] = {.lex_state = 538, .external_lex_state = 12},
  [13156] = {.lex_state = 537, .external_lex_state = 12},
  [13157] = {.lex_state = 380, .external_lex_state = 12},
  [13158] = {.lex_state = 538, .external_lex_state = 12},
  [13159] = {.lex_state = 538, .external_lex_state = 12},
  [13160] = {.lex_state = 537, .external_lex_state = 12},
  [13161] = {.lex_state = 537, .external_lex_state = 12},
  [13162] = {.lex_state = 537, .external_lex_state = 12},
  [13163] = {.lex_state = 537, .external_lex_state = 12},
  [13164] = {.lex_state = 538, .external_lex_state = 12},
  [13165] = {.lex_state = 538, .external_lex_state = 12},
  [13166] = {.lex_state = 538, .external_lex_state = 12},
  [13167] = {.lex_state = 537, .external_lex_state = 12},
  [13168] = {.lex_state = 537, .external_lex_state = 12},
  [13169] = {.lex_state = 538, .external_lex_state = 12},
  [13170] = {.lex_state = 538, .external_lex_state = 12},
  [13171] = {.lex_state = 538, .external_lex_state = 12},
  [13172] = {.lex_state = 384, .external_lex_state = 12},
  [13173] = {.lex_state = 380, .external_lex_state = 13},
  [13174] = {.lex_state = 537, .external_lex_state = 12},
  [13175] = {.lex_state = 537, .external_lex_state = 12},
  [13176] = {.lex_state = 537, .external_lex_state = 12},
  [13177] = {.lex_state = 540, .external_lex_state = 12},
  [13178] = {.lex_state = 537, .external_lex_state = 12},
  [13179] = {.lex_state = 384, .external_lex_state = 12},
  [13180] = {.lex_state = 380, .external_lex_state = 12},
  [13181] = {.lex_state = 537, .external_lex_state = 12},
  [13182] = {.lex_state = 380, .external_lex_state = 13},
  [13183] = {.lex_state = 537, .external_lex_state = 12},
  [13184] = {.lex_state = 537, .external_lex_state = 12},
  [13185] = {.lex_state = 537, .external_lex_state = 12},
  [13186] = {.lex_state = 537, .external_lex_state = 12},
  [13187] = {.lex_state = 537, .external_lex_state = 12},
  [13188] = {.lex_state = 537, .external_lex_state = 12},
  [13189] = {.lex_state = 537, .external_lex_state = 12},
  [13190] = {.lex_state = 537, .external_lex_state = 12},
  [13191] = {.lex_state = 537, .external_lex_state = 12},
  [13192] = {.lex_state = 537, .external_lex_state = 12},
  [13193] = {.lex_state = 537, .external_lex_state = 12},
  [13194] = {.lex_state = 537, .external_lex_state = 12},
  [13195] = {.lex_state = 537, .external_lex_state = 12},
  [13196] = {.lex_state = 537, .external_lex_state = 12},
  [13197] = {.lex_state = 380, .external_lex_state = 12},
  [13198] = {.lex_state = 537, .external_lex_state = 12},
  [13199] = {.lex_state = 537, .external_lex_state = 12},
  [13200] = {.lex_state = 537, .external_lex_state = 12},
  [13201] = {.lex_state = 380, .external_lex_state = 12},
  [13202] = {.lex_state = 537, .external_lex_state = 12},
  [13203] = {.lex_state = 537, .external_lex_state = 12},
  [13204] = {.lex_state = 380, .external_lex_state = 12},
  [13205] = {.lex_state = 537, .external_lex_state = 12},
  [13206] = {.lex_state = 380, .external_lex_state = 12},
  [13207] = {.lex_state = 254, .external_lex_state = 12},
  [13208] = {.lex_state = 380, .external_lex_state = 12},
  [13209] = {.lex_state = 537, .external_lex_state = 12},
  [13210] = {.lex_state = 254, .external_lex_state = 12},
  [13211] = {.lex_state = 254, .external_lex_state = 12},
  [13212] = {.lex_state = 537, .external_lex_state = 12},
  [13213] = {.lex_state = 537, .external_lex_state = 12},
  [13214] = {.lex_state = 380, .external_lex_state = 12},
  [13215] = {.lex_state = 537, .external_lex_state = 12},
  [13216] = {.lex_state = 537, .external_lex_state = 12},
  [13217] = {.lex_state = 537, .external_lex_state = 12},
  [13218] = {.lex_state = 537, .external_lex_state = 12},
  [13219] = {.lex_state = 380, .external_lex_state = 12},
  [13220] = {.lex_state = 380, .external_lex_state = 12},
  [13221] = {.lex_state = 537, .external_lex_state = 12},
  [13222] = {.lex_state = 537, .external_lex_state = 12},
  [13223] = {.lex_state = 384, .external_lex_state = 12},
  [13224] = {.lex_state = 537, .external_lex_state = 12},
  [13225] = {.lex_state = 537, .external_lex_state = 12},
  [13226] = {.lex_state = 537, .external_lex_state = 12},
  [13227] = {.lex_state = 537, .external_lex_state = 12},
  [13228] = {.lex_state = 380, .external_lex_state = 12},
  [13229] = {.lex_state = 384, .external_lex_state = 12},
  [13230] = {.lex_state = 537, .external_lex_state = 12},
  [13231] = {.lex_state = 537, .external_lex_state = 12},
  [13232] = {.lex_state = 537, .external_lex_state = 12},
  [13233] = {.lex_state = 254, .external_lex_state = 12},
  [13234] = {.lex_state = 380, .external_lex_state = 12},
  [13235] = {.lex_state = 384, .external_lex_state = 12},
  [13236] = {.lex_state = 537, .external_lex_state = 12},
  [13237] = {.lex_state = 384, .external_lex_state = 12},
  [13238] = {.lex_state = 380, .external_lex_state = 12},
  [13239] = {.lex_state = 537, .external_lex_state = 12},
  [13240] = {.lex_state = 537, .external_lex_state = 12},
  [13241] = {.lex_state = 537, .external_lex_state = 12},
  [13242] = {.lex_state = 537, .external_lex_state = 12},
  [13243] = {.lex_state = 537, .external_lex_state = 12},
  [13244] = {.lex_state = 384, .external_lex_state = 12},
  [13245] = {.lex_state = 537, .external_lex_state = 12},
  [13246] = {.lex_state = 537, .external_lex_state = 12},
  [13247] = {.lex_state = 537, .external_lex_state = 12},
  [13248] = {.lex_state = 537, .external_lex_state = 12},
  [13249] = {.lex_state = 537, .external_lex_state = 12},
  [13250] = {.lex_state = 537, .external_lex_state = 12},
  [13251] = {.lex_state = 537, .external_lex_state = 12},
  [13252] = {.lex_state = 537, .external_lex_state = 12},
  [13253] = {.lex_state = 537, .external_lex_state = 12},
  [13254] = {.lex_state = 537, .external_lex_state = 12},
  [13255] = {.lex_state = 537, .external_lex_state = 12},
  [13256] = {.lex_state = 380, .external_lex_state = 12},
  [13257] = {.lex_state = 380, .external_lex_state = 12},
  [13258] = {.lex_state = 380, .external_lex_state = 12},
  [13259] = {.lex_state = 537, .external_lex_state = 12},
  [13260] = {.lex_state = 537, .external_lex_state = 12},
  [13261] = {.lex_state = 537, .external_lex_state = 12},
  [13262] = {.lex_state = 537, .external_lex_state = 12},
  [13263] = {.lex_state = 537, .external_lex_state = 12},
  [13264] = {.lex_state = 380, .external_lex_state = 12},
  [13265] = {.lex_state = 540, .external_lex_state = 12},
  [13266] = {.lex_state = 380, .external_lex_state = 12},
  [13267] = {.lex_state = 537, .external_lex_state = 12},
  [13268] = {.lex_state = 380, .external_lex_state = 12},
  [13269] = {.lex_state = 254, .external_lex_state = 12},
  [13270] = {.lex_state = 537, .external_lex_state = 12},
  [13271] = {.lex_state = 537, .external_lex_state = 12},
  [13272] = {.lex_state = 380, .external_lex_state = 12},
  [13273] = {.lex_state = 254, .external_lex_state = 12},
  [13274] = {.lex_state = 380, .external_lex_state = 12},
  [13275] = {.lex_state = 537, .external_lex_state = 12},
  [13276] = {.lex_state = 254, .external_lex_state = 12},
  [13277] = {.lex_state = 254, .external_lex_state = 12},
  [13278] = {.lex_state = 380, .external_lex_state = 12},
  [13279] = {.lex_state = 537, .external_lex_state = 12},
  [13280] = {.lex_state = 380, .external_lex_state = 12},
  [13281] = {.lex_state = 537, .external_lex_state = 12},
  [13282] = {.lex_state = 537, .external_lex_state = 12},
  [13283] = {.lex_state = 537, .external_lex_state = 12},
  [13284] = {.lex_state = 537, .external_lex_state = 12},
  [13285] = {.lex_state = 537, .external_lex_state = 12},
  [13286] = {.lex_state = 254, .external_lex_state = 12},
  [13287] = {.lex_state = 380, .external_lex_state = 12},
  [13288] = {.lex_state = 537, .external_lex_state = 12},
  [13289] = {.lex_state = 537, .external_lex_state = 12},
  [13290] = {.lex_state = 540, .external_lex_state = 12},
  [13291] = {.lex_state = 537, .external_lex_state = 13},
  [13292] = {.lex_state = 537, .external_lex_state = 12},
  [13293] = {.lex_state = 537, .external_lex_state = 12},
  [13294] = {.lex_state = 254, .external_lex_state = 12},
  [13295] = {.lex_state = 384, .external_lex_state = 12},
  [13296] = {.lex_state = 537, .external_lex_state = 12},
  [13297] = {.lex_state = 537, .external_lex_state = 12},
  [13298] = {.lex_state = 537, .external_lex_state = 12},
  [13299] = {.lex_state = 537, .external_lex_state = 12},
  [13300] = {.lex_state = 537, .external_lex_state = 12},
  [13301] = {.lex_state = 254, .external_lex_state = 12},
  [13302] = {.lex_state = 537, .external_lex_state = 12},
  [13303] = {.lex_state = 254, .external_lex_state = 12},
  [13304] = {.lex_state = 384, .external_lex_state = 12},
  [13305] = {.lex_state = 537, .external_lex_state = 12},
  [13306] = {.lex_state = 380, .external_lex_state = 13},
  [13307] = {.lex_state = 254, .external_lex_state = 12},
  [13308] = {.lex_state = 254, .external_lex_state = 12},
  [13309] = {.lex_state = 380, .external_lex_state = 12},
  [13310] = {.lex_state = 537, .external_lex_state = 12},
  [13311] = {.lex_state = 537, .external_lex_state = 12},
  [13312] = {.lex_state = 537, .external_lex_state = 12},
  [13313] = {.lex_state = 537, .external_lex_state = 12},
  [13314] = {.lex_state = 380, .external_lex_state = 12},
  [13315] = {.lex_state = 537, .external_lex_state = 12},
  [13316] = {.lex_state = 537, .external_lex_state = 12},
  [13317] = {.lex_state = 380, .external_lex_state = 12},
  [13318] = {.lex_state = 380, .external_lex_state = 12},
  [13319] = {.lex_state = 380, .external_lex_state = 12},
  [13320] = {.lex_state = 537, .external_lex_state = 12},
  [13321] = {.lex_state = 380, .external_lex_state = 12},
  [13322] = {.lex_state = 380, .external_lex_state = 12},
  [13323] = {.lex_state = 380, .external_lex_state = 12},
  [13324] = {.lex_state = 537, .external_lex_state = 12},
  [13325] = {.lex_state = 380, .external_lex_state = 12},
  [13326] = {.lex_state = 537, .external_lex_state = 12},
  [13327] = {.lex_state = 537, .external_lex_state = 12},
  [13328] = {.lex_state = 537, .external_lex_state = 12},
  [13329] = {.lex_state = 380, .external_lex_state = 12},
  [13330] = {.lex_state = 380, .external_lex_state = 12},
  [13331] = {.lex_state = 537, .external_lex_state = 12},
  [13332] = {.lex_state = 537, .external_lex_state = 12},
  [13333] = {.lex_state = 384, .external_lex_state = 12},
  [13334] = {.lex_state = 380, .external_lex_state = 12},
  [13335] = {.lex_state = 380, .external_lex_state = 12},
  [13336] = {.lex_state = 380, .external_lex_state = 12},
  [13337] = {.lex_state = 537, .external_lex_state = 12},
  [13338] = {.lex_state = 254, .external_lex_state = 12},
  [13339] = {.lex_state = 537, .external_lex_state = 12},
  [13340] = {.lex_state = 537, .external_lex_state = 12},
  [13341] = {.lex_state = 537, .external_lex_state = 12},
  [13342] = {.lex_state = 537, .external_lex_state = 12},
  [13343] = {.lex_state = 380, .external_lex_state = 13},
  [13344] = {.lex_state = 537, .external_lex_state = 12},
  [13345] = {.lex_state = 537, .external_lex_state = 12},
  [13346] = {.lex_state = 537, .external_lex_state = 12},
  [13347] = {.lex_state = 537, .external_lex_state = 12},
  [13348] = {.lex_state = 537, .external_lex_state = 12},
  [13349] = {.lex_state = 537, .external_lex_state = 12},
  [13350] = {.lex_state = 537, .external_lex_state = 12},
  [13351] = {.lex_state = 537, .external_lex_state = 12},
  [13352] = {.lex_state = 254, .external_lex_state = 12},
  [13353] = {.lex_state = 537, .external_lex_state = 12},
  [13354] = {.lex_state = 380, .external_lex_state = 12},
  [13355] = {.lex_state = 537, .external_lex_state = 12},
  [13356] = {.lex_state = 380, .external_lex_state = 12},
  [13357] = {.lex_state = 380, .external_lex_state = 12},
  [13358] = {.lex_state = 380, .external_lex_state = 12},
  [13359] = {.lex_state = 380, .external_lex_state = 12},
  [13360] = {.lex_state = 380, .external_lex_state = 12},
  [13361] = {.lex_state = 380, .external_lex_state = 12},
  [13362] = {.lex_state = 537, .external_lex_state = 12},
  [13363] = {.lex_state = 537, .external_lex_state = 12},
  [13364] = {.lex_state = 537, .external_lex_state = 12},
  [13365] = {.lex_state = 380, .external_lex_state = 12},
  [13366] = {.lex_state = 537, .external_lex_state = 12},
  [13367] = {.lex_state = 380, .external_lex_state = 12},
  [13368] = {.lex_state = 537, .external_lex_state = 12},
  [13369] = {.lex_state = 537, .external_lex_state = 12},
  [13370] = {.lex_state = 537, .external_lex_state = 12},
  [13371] = {.lex_state = 537, .external_lex_state = 12},
  [13372] = {.lex_state = 380, .external_lex_state = 12},
  [13373] = {.lex_state = 380, .external_lex_state = 12},
  [13374] = {.lex_state = 380, .external_lex_state = 12},
  [13375] = {.lex_state = 380, .external_lex_state = 12},
  [13376] = {.lex_state = 380, .external_lex_state = 12},
  [13377] = {.lex_state = 380, .external_lex_state = 12},
  [13378] = {.lex_state = 380, .external_lex_state = 12},
  [13379] = {.lex_state = 380, .external_lex_state = 12},
  [13380] = {.lex_state = 380, .external_lex_state = 12},
  [13381] = {.lex_state = 380, .external_lex_state = 12},
  [13382] = {.lex_state = 380, .external_lex_state = 12},
  [13383] = {.lex_state = 380, .external_lex_state = 12},
  [13384] = {.lex_state = 380, .external_lex_state = 12},
  [13385] = {.lex_state = 380, .external_lex_state = 12},
  [13386] = {.lex_state = 380, .external_lex_state = 12},
  [13387] = {.lex_state = 380, .external_lex_state = 12},
  [13388] = {.lex_state = 380, .external_lex_state = 12},
  [13389] = {.lex_state = 380, .external_lex_state = 12},
  [13390] = {.lex_state = 380, .external_lex_state = 12},
  [13391] = {.lex_state = 380, .external_lex_state = 12},
  [13392] = {.lex_state = 380, .external_lex_state = 12},
  [13393] = {.lex_state = 380, .external_lex_state = 12},
  [13394] = {.lex_state = 380, .external_lex_state = 12},
  [13395] = {.lex_state = 380, .external_lex_state = 12},
  [13396] = {.lex_state = 380, .external_lex_state = 12},
  [13397] = {.lex_state = 537, .external_lex_state = 12},
  [13398] = {.lex_state = 537, .external_lex_state = 12},
  [13399] = {.lex_state = 537, .external_lex_state = 12},
  [13400] = {.lex_state = 537, .external_lex_state = 12},
  [13401] = {.lex_state = 537, .external_lex_state = 12},
  [13402] = {.lex_state = 537, .external_lex_state = 12},
  [13403] = {.lex_state = 537, .external_lex_state = 12},
  [13404] = {.lex_state = 380, .external_lex_state = 12},
  [13405] = {.lex_state = 380, .external_lex_state = 12},
  [13406] = {.lex_state = 380, .external_lex_state = 12},
  [13407] = {.lex_state = 380, .external_lex_state = 12},
  [13408] = {.lex_state = 380, .external_lex_state = 12},
  [13409] = {.lex_state = 537, .external_lex_state = 12},
  [13410] = {.lex_state = 537, .external_lex_state = 12},
  [13411] = {.lex_state = 540, .external_lex_state = 12},
  [13412] = {.lex_state = 537, .external_lex_state = 12},
  [13413] = {.lex_state = 384, .external_lex_state = 12},
  [13414] = {.lex_state = 384, .external_lex_state = 12},
  [13415] = {.lex_state = 537, .external_lex_state = 12},
  [13416] = {.lex_state = 537, .external_lex_state = 12},
  [13417] = {.lex_state = 537, .external_lex_state = 12},
  [13418] = {.lex_state = 537, .external_lex_state = 12},
  [13419] = {.lex_state = 537, .external_lex_state = 12},
  [13420] = {.lex_state = 380, .external_lex_state = 12},
  [13421] = {.lex_state = 537, .external_lex_state = 12},
  [13422] = {.lex_state = 254, .external_lex_state = 12},
  [13423] = {.lex_state = 380, .external_lex_state = 12},
  [13424] = {.lex_state = 380, .external_lex_state = 12},
  [13425] = {.lex_state = 380, .external_lex_state = 12},
  [13426] = {.lex_state = 380, .external_lex_state = 12},
  [13427] = {.lex_state = 380, .external_lex_state = 12},
  [13428] = {.lex_state = 537, .external_lex_state = 12},
  [13429] = {.lex_state = 380, .external_lex_state = 12},
  [13430] = {.lex_state = 380, .external_lex_state = 12},
  [13431] = {.lex_state = 537, .external_lex_state = 12},
  [13432] = {.lex_state = 384, .external_lex_state = 12},
  [13433] = {.lex_state = 380, .external_lex_state = 12},
  [13434] = {.lex_state = 380, .external_lex_state = 12},
  [13435] = {.lex_state = 537, .external_lex_state = 12},
  [13436] = {.lex_state = 537, .external_lex_state = 12},
  [13437] = {.lex_state = 380, .external_lex_state = 12},
  [13438] = {.lex_state = 380, .external_lex_state = 12},
  [13439] = {.lex_state = 380, .external_lex_state = 12},
  [13440] = {.lex_state = 537, .external_lex_state = 12},
  [13441] = {.lex_state = 380, .external_lex_state = 12},
  [13442] = {.lex_state = 380, .external_lex_state = 12},
  [13443] = {.lex_state = 380, .external_lex_state = 12},
  [13444] = {.lex_state = 380, .external_lex_state = 12},
  [13445] = {.lex_state = 537, .external_lex_state = 12},
  [13446] = {.lex_state = 380, .external_lex_state = 12},
  [13447] = {.lex_state = 380, .external_lex_state = 12},
  [13448] = {.lex_state = 537, .external_lex_state = 12},
  [13449] = {.lex_state = 380, .external_lex_state = 12},
  [13450] = {.lex_state = 380, .external_lex_state = 12},
  [13451] = {.lex_state = 537, .external_lex_state = 12},
  [13452] = {.lex_state = 537, .external_lex_state = 12},
  [13453] = {.lex_state = 537, .external_lex_state = 12},
  [13454] = {.lex_state = 537, .external_lex_state = 12},
  [13455] = {.lex_state = 537, .external_lex_state = 12},
  [13456] = {.lex_state = 537, .external_lex_state = 12},
  [13457] = {.lex_state = 384, .external_lex_state = 12},
  [13458] = {.lex_state = 537, .external_lex_state = 12},
  [13459] = {.lex_state = 537, .external_lex_state = 12},
  [13460] = {.lex_state = 537, .external_lex_state = 12},
  [13461] = {.lex_state = 380, .external_lex_state = 12},
  [13462] = {.lex_state = 380, .external_lex_state = 12},
  [13463] = {.lex_state = 537, .external_lex_state = 12},
  [13464] = {.lex_state = 537, .external_lex_state = 12},
  [13465] = {.lex_state = 537, .external_lex_state = 12},
  [13466] = {.lex_state = 537, .external_lex_state = 12},
  [13467] = {.lex_state = 380, .external_lex_state = 12},
  [13468] = {.lex_state = 537, .external_lex_state = 12},
  [13469] = {.lex_state = 537, .external_lex_state = 12},
  [13470] = {.lex_state = 380, .external_lex_state = 12},
  [13471] = {.lex_state = 384, .external_lex_state = 12},
  [13472] = {.lex_state = 537, .external_lex_state = 12},
  [13473] = {.lex_state = 380, .external_lex_state = 12},
  [13474] = {.lex_state = 540, .external_lex_state = 12},
  [13475] = {.lex_state = 537, .external_lex_state = 12},
  [13476] = {.lex_state = 380, .external_lex_state = 12},
  [13477] = {.lex_state = 380, .external_lex_state = 12},
  [13478] = {.lex_state = 380, .external_lex_state = 12},
  [13479] = {.lex_state = 380, .external_lex_state = 12},
  [13480] = {.lex_state = 537, .external_lex_state = 12},
  [13481] = {.lex_state = 380, .external_lex_state = 12},
  [13482] = {.lex_state = 380, .external_lex_state = 12},
  [13483] = {.lex_state = 380, .external_lex_state = 12},
  [13484] = {.lex_state = 380, .external_lex_state = 12},
  [13485] = {.lex_state = 384, .external_lex_state = 12},
  [13486] = {.lex_state = 380, .external_lex_state = 13},
  [13487] = {.lex_state = 380, .external_lex_state = 12},
  [13488] = {.lex_state = 380, .external_lex_state = 12},
  [13489] = {.lex_state = 380, .external_lex_state = 12},
  [13490] = {.lex_state = 380, .external_lex_state = 12},
  [13491] = {.lex_state = 380, .external_lex_state = 12},
  [13492] = {.lex_state = 380, .external_lex_state = 12},
  [13493] = {.lex_state = 380, .external_lex_state = 12},
  [13494] = {.lex_state = 380, .external_lex_state = 12},
  [13495] = {.lex_state = 380, .external_lex_state = 12},
  [13496] = {.lex_state = 380, .external_lex_state = 12},
  [13497] = {.lex_state = 380, .external_lex_state = 12},
  [13498] = {.lex_state = 380, .external_lex_state = 12},
  [13499] = {.lex_state = 380, .external_lex_state = 12},
  [13500] = {.lex_state = 380, .external_lex_state = 12},
  [13501] = {.lex_state = 380, .external_lex_state = 12},
  [13502] = {.lex_state = 380, .external_lex_state = 12},
  [13503] = {.lex_state = 380, .external_lex_state = 12},
  [13504] = {.lex_state = 380, .external_lex_state = 12},
  [13505] = {.lex_state = 380, .external_lex_state = 12},
  [13506] = {.lex_state = 380, .external_lex_state = 12},
  [13507] = {.lex_state = 380, .external_lex_state = 12},
  [13508] = {.lex_state = 384, .external_lex_state = 12},
  [13509] = {.lex_state = 380, .external_lex_state = 12},
  [13510] = {.lex_state = 380, .external_lex_state = 12},
  [13511] = {.lex_state = 380, .external_lex_state = 12},
  [13512] = {.lex_state = 380, .external_lex_state = 12},
  [13513] = {.lex_state = 380, .external_lex_state = 12},
  [13514] = {.lex_state = 380, .external_lex_state = 12},
  [13515] = {.lex_state = 384, .external_lex_state = 12},
  [13516] = {.lex_state = 380, .external_lex_state = 12},
  [13517] = {.lex_state = 537, .external_lex_state = 12},
  [13518] = {.lex_state = 380, .external_lex_state = 12},
  [13519] = {.lex_state = 537, .external_lex_state = 12},
  [13520] = {.lex_state = 380, .external_lex_state = 12},
  [13521] = {.lex_state = 380, .external_lex_state = 12},
  [13522] = {.lex_state = 380, .external_lex_state = 12},
  [13523] = {.lex_state = 380, .external_lex_state = 12},
  [13524] = {.lex_state = 380, .external_lex_state = 12},
  [13525] = {.lex_state = 380, .external_lex_state = 12},
  [13526] = {.lex_state = 380, .external_lex_state = 12},
  [13527] = {.lex_state = 380, .external_lex_state = 12},
  [13528] = {.lex_state = 380, .external_lex_state = 12},
  [13529] = {.lex_state = 380, .external_lex_state = 12},
  [13530] = {.lex_state = 380, .external_lex_state = 12},
  [13531] = {.lex_state = 380, .external_lex_state = 12},
  [13532] = {.lex_state = 380, .external_lex_state = 12},
  [13533] = {.lex_state = 380, .external_lex_state = 12},
  [13534] = {.lex_state = 380, .external_lex_state = 12},
  [13535] = {.lex_state = 380, .external_lex_state = 12},
  [13536] = {.lex_state = 537, .external_lex_state = 12},
  [13537] = {.lex_state = 380, .external_lex_state = 12},
  [13538] = {.lex_state = 380, .external_lex_state = 12},
  [13539] = {.lex_state = 380, .external_lex_state = 12},
  [13540] = {.lex_state = 384, .external_lex_state = 12},
  [13541] = {.lex_state = 380, .external_lex_state = 13},
  [13542] = {.lex_state = 380, .external_lex_state = 12},
  [13543] = {.lex_state = 380, .external_lex_state = 12},
  [13544] = {.lex_state = 380, .external_lex_state = 12},
  [13545] = {.lex_state = 380, .external_lex_state = 12},
  [13546] = {.lex_state = 380, .external_lex_state = 12},
  [13547] = {.lex_state = 380, .external_lex_state = 12},
  [13548] = {.lex_state = 380, .external_lex_state = 12},
  [13549] = {.lex_state = 380, .external_lex_state = 12},
  [13550] = {.lex_state = 380, .external_lex_state = 12},
  [13551] = {.lex_state = 380, .external_lex_state = 12},
  [13552] = {.lex_state = 380, .external_lex_state = 12},
  [13553] = {.lex_state = 380, .external_lex_state = 12},
  [13554] = {.lex_state = 537, .external_lex_state = 12},
  [13555] = {.lex_state = 380, .external_lex_state = 12},
  [13556] = {.lex_state = 380, .external_lex_state = 12},
  [13557] = {.lex_state = 380, .external_lex_state = 12},
  [13558] = {.lex_state = 380, .external_lex_state = 12},
  [13559] = {.lex_state = 380, .external_lex_state = 12},
  [13560] = {.lex_state = 380, .external_lex_state = 12},
  [13561] = {.lex_state = 380, .external_lex_state = 12},
  [13562] = {.lex_state = 380, .external_lex_state = 12},
  [13563] = {.lex_state = 380, .external_lex_state = 12},
  [13564] = {.lex_state = 380, .external_lex_state = 12},
  [13565] = {.lex_state = 380, .external_lex_state = 12},
  [13566] = {.lex_state = 380, .external_lex_state = 12},
  [13567] = {.lex_state = 380, .external_lex_state = 12},
  [13568] = {.lex_state = 380, .external_lex_state = 12},
  [13569] = {.lex_state = 537, .external_lex_state = 12},
  [13570] = {.lex_state = 537, .external_lex_state = 12},
  [13571] = {.lex_state = 537, .external_lex_state = 12},
  [13572] = {.lex_state = 380, .external_lex_state = 12},
  [13573] = {.lex_state = 380, .external_lex_state = 12},
  [13574] = {.lex_state = 537, .external_lex_state = 12},
  [13575] = {.lex_state = 537, .external_lex_state = 12},
  [13576] = {.lex_state = 537, .external_lex_state = 12},
  [13577] = {.lex_state = 537, .external_lex_state = 12},
  [13578] = {.lex_state = 380, .external_lex_state = 12},
  [13579] = {.lex_state = 380, .external_lex_state = 12},
  [13580] = {.lex_state = 380, .external_lex_state = 12},
  [13581] = {.lex_state = 380, .external_lex_state = 12},
  [13582] = {.lex_state = 380, .external_lex_state = 12},
  [13583] = {.lex_state = 380, .external_lex_state = 12},
  [13584] = {.lex_state = 380, .external_lex_state = 12},
  [13585] = {.lex_state = 380, .external_lex_state = 12},
  [13586] = {.lex_state = 380, .external_lex_state = 12},
  [13587] = {.lex_state = 380, .external_lex_state = 12},
  [13588] = {.lex_state = 380, .external_lex_state = 12},
  [13589] = {.lex_state = 380, .external_lex_state = 12},
  [13590] = {.lex_state = 380, .external_lex_state = 12},
  [13591] = {.lex_state = 380, .external_lex_state = 12},
  [13592] = {.lex_state = 384, .external_lex_state = 12},
  [13593] = {.lex_state = 380, .external_lex_state = 12},
  [13594] = {.lex_state = 380, .external_lex_state = 12},
  [13595] = {.lex_state = 380, .external_lex_state = 12},
  [13596] = {.lex_state = 380, .external_lex_state = 12},
  [13597] = {.lex_state = 537, .external_lex_state = 12},
  [13598] = {.lex_state = 380, .external_lex_state = 12},
  [13599] = {.lex_state = 380, .external_lex_state = 12},
  [13600] = {.lex_state = 537, .external_lex_state = 12},
  [13601] = {.lex_state = 380, .external_lex_state = 12},
  [13602] = {.lex_state = 380, .external_lex_state = 12},
  [13603] = {.lex_state = 380, .external_lex_state = 12},
  [13604] = {.lex_state = 380, .external_lex_state = 13},
  [13605] = {.lex_state = 380, .external_lex_state = 12},
  [13606] = {.lex_state = 384, .external_lex_state = 12},
  [13607] = {.lex_state = 380, .external_lex_state = 13},
  [13608] = {.lex_state = 380, .external_lex_state = 12},
  [13609] = {.lex_state = 380, .external_lex_state = 12},
  [13610] = {.lex_state = 380, .external_lex_state = 12},
  [13611] = {.lex_state = 380, .external_lex_state = 12},
  [13612] = {.lex_state = 380, .external_lex_state = 13},
  [13613] = {.lex_state = 380, .external_lex_state = 12},
  [13614] = {.lex_state = 384, .external_lex_state = 12},
  [13615] = {.lex_state = 380, .external_lex_state = 12},
  [13616] = {.lex_state = 388, .external_lex_state = 12},
  [13617] = {.lex_state = 380, .external_lex_state = 12},
  [13618] = {.lex_state = 380, .external_lex_state = 12},
  [13619] = {.lex_state = 380, .external_lex_state = 12},
  [13620] = {.lex_state = 384, .external_lex_state = 12},
  [13621] = {.lex_state = 380, .external_lex_state = 13},
  [13622] = {.lex_state = 384, .external_lex_state = 12},
  [13623] = {.lex_state = 380, .external_lex_state = 12},
  [13624] = {.lex_state = 380, .external_lex_state = 13},
  [13625] = {.lex_state = 380, .external_lex_state = 12},
  [13626] = {.lex_state = 380, .external_lex_state = 12},
  [13627] = {.lex_state = 380, .external_lex_state = 12},
  [13628] = {.lex_state = 380, .external_lex_state = 12},
  [13629] = {.lex_state = 380, .external_lex_state = 12},
  [13630] = {.lex_state = 384, .external_lex_state = 12},
  [13631] = {.lex_state = 380, .external_lex_state = 13},
  [13632] = {.lex_state = 384, .external_lex_state = 12},
  [13633] = {.lex_state = 380, .external_lex_state = 13},
  [13634] = {.lex_state = 380, .external_lex_state = 12},
  [13635] = {.lex_state = 380, .external_lex_state = 12},
  [13636] = {.lex_state = 380, .external_lex_state = 12},
  [13637] = {.lex_state = 380, .external_lex_state = 12},
  [13638] = {.lex_state = 384, .external_lex_state = 12},
  [13639] = {.lex_state = 380, .external_lex_state = 13},
  [13640] = {.lex_state = 380, .external_lex_state = 12},
  [13641] = {.lex_state = 384, .external_lex_state = 12},
  [13642] = {.lex_state = 380, .external_lex_state = 13},
  [13643] = {.lex_state = 380, .external_lex_state = 12},
  [13644] = {.lex_state = 380, .external_lex_state = 12},
  [13645] = {.lex_state = 380, .external_lex_state = 12},
  [13646] = {.lex_state = 380, .external_lex_state = 13},
  [13647] = {.lex_state = 380, .external_lex_state = 12},
  [13648] = {.lex_state = 380, .external_lex_state = 12},
  [13649] = {.lex_state = 380, .external_lex_state = 12},
  [13650] = {.lex_state = 380, .external_lex_state = 12},
  [13651] = {.lex_state = 380, .external_lex_state = 12},
  [13652] = {.lex_state = 380, .external_lex_state = 12},
  [13653] = {.lex_state = 380, .external_lex_state = 12},
  [13654] = {.lex_state = 380, .external_lex_state = 12},
  [13655] = {.lex_state = 380, .external_lex_state = 12},
  [13656] = {.lex_state = 380, .external_lex_state = 12},
  [13657] = {.lex_state = 380, .external_lex_state = 12},
  [13658] = {.lex_state = 384, .external_lex_state = 12},
  [13659] = {.lex_state = 380, .external_lex_state = 12},
  [13660] = {.lex_state = 380, .external_lex_state = 12},
  [13661] = {.lex_state = 380, .external_lex_state = 12},
  [13662] = {.lex_state = 380, .external_lex_state = 12},
  [13663] = {.lex_state = 380, .external_lex_state = 12},
  [13664] = {.lex_state = 384, .external_lex_state = 12},
  [13665] = {.lex_state = 380, .external_lex_state = 13},
  [13666] = {.lex_state = 380, .external_lex_state = 12},
  [13667] = {.lex_state = 380, .external_lex_state = 12},
  [13668] = {.lex_state = 380, .external_lex_state = 12},
  [13669] = {.lex_state = 380, .external_lex_state = 12},
  [13670] = {.lex_state = 380, .external_lex_state = 12},
  [13671] = {.lex_state = 380, .external_lex_state = 13},
  [13672] = {.lex_state = 380, .external_lex_state = 12},
  [13673] = {.lex_state = 380, .external_lex_state = 12},
  [13674] = {.lex_state = 380, .external_lex_state = 12},
  [13675] = {.lex_state = 380, .external_lex_state = 12},
  [13676] = {.lex_state = 384, .external_lex_state = 12},
  [13677] = {.lex_state = 380, .external_lex_state = 12},
  [13678] = {.lex_state = 380, .external_lex_state = 13},
  [13679] = {.lex_state = 380, .external_lex_state = 12},
  [13680] = {.lex_state = 380, .external_lex_state = 12},
  [13681] = {.lex_state = 380, .external_lex_state = 12},
  [13682] = {.lex_state = 380, .external_lex_state = 12},
  [13683] = {.lex_state = 380, .external_lex_state = 12},
  [13684] = {.lex_state = 380, .external_lex_state = 12},
  [13685] = {.lex_state = 380, .external_lex_state = 12},
  [13686] = {.lex_state = 380, .external_lex_state = 12},
  [13687] = {.lex_state = 380, .external_lex_state = 12},
  [13688] = {.lex_state = 380, .external_lex_state = 12},
  [13689] = {.lex_state = 380, .external_lex_state = 12},
  [13690] = {.lex_state = 380, .external_lex_state = 12},
  [13691] = {.lex_state = 380, .external_lex_state = 12},
  [13692] = {.lex_state = 380, .external_lex_state = 12},
  [13693] = {.lex_state = 380, .external_lex_state = 12},
  [13694] = {.lex_state = 380, .external_lex_state = 12},
  [13695] = {.lex_state = 380, .external_lex_state = 12},
  [13696] = {.lex_state = 380, .external_lex_state = 12},
  [13697] = {.lex_state = 380, .external_lex_state = 12},
  [13698] = {.lex_state = 380, .external_lex_state = 12},
  [13699] = {.lex_state = 380, .external_lex_state = 12},
  [13700] = {.lex_state = 380, .external_lex_state = 12},
  [13701] = {.lex_state = 380, .external_lex_state = 12},
  [13702] = {.lex_state = 380, .external_lex_state = 12},
  [13703] = {.lex_state = 380, .external_lex_state = 12},
  [13704] = {.lex_state = 380, .external_lex_state = 12},
  [13705] = {.lex_state = 380, .external_lex_state = 12},
  [13706] = {.lex_state = 380, .external_lex_state = 12},
  [13707] = {.lex_state = 380, .external_lex_state = 12},
  [13708] = {.lex_state = 380, .external_lex_state = 12},
  [13709] = {.lex_state = 384, .external_lex_state = 12},
  [13710] = {.lex_state = 380, .external_lex_state = 13},
  [13711] = {.lex_state = 380, .external_lex_state = 12},
  [13712] = {.lex_state = 380, .external_lex_state = 12},
  [13713] = {.lex_state = 380, .external_lex_state = 12},
  [13714] = {.lex_state = 380, .external_lex_state = 12},
  [13715] = {.lex_state = 380, .external_lex_state = 12},
  [13716] = {.lex_state = 384, .external_lex_state = 12},
  [13717] = {.lex_state = 380, .external_lex_state = 13},
  [13718] = {.lex_state = 380, .external_lex_state = 12},
  [13719] = {.lex_state = 384, .external_lex_state = 12},
  [13720] = {.lex_state = 380, .external_lex_state = 13},
  [13721] = {.lex_state = 380, .external_lex_state = 12},
  [13722] = {.lex_state = 388, .external_lex_state = 12},
  [13723] = {.lex_state = 380, .external_lex_state = 12},
  [13724] = {.lex_state = 380, .external_lex_state = 12},
  [13725] = {.lex_state = 380, .external_lex_state = 12},
  [13726] = {.lex_state = 380, .external_lex_state = 12},
  [13727] = {.lex_state = 380, .external_lex_state = 12},
  [13728] = {.lex_state = 380, .external_lex_state = 12},
  [13729] = {.lex_state = 380, .external_lex_state = 12},
  [13730] = {.lex_state = 380, .external_lex_state = 12},
  [13731] = {.lex_state = 380, .external_lex_state = 12},
  [13732] = {.lex_state = 384, .external_lex_state = 12},
  [13733] = {.lex_state = 380, .external_lex_state = 13},
  [13734] = {.lex_state = 380, .external_lex_state = 12},
  [13735] = {.lex_state = 380, .external_lex_state = 12},
  [13736] = {.lex_state = 384, .external_lex_state = 12},
  [13737] = {.lex_state = 380, .external_lex_state = 12},
  [13738] = {.lex_state = 380, .external_lex_state = 13},
  [13739] = {.lex_state = 388, .external_lex_state = 12},
  [13740] = {.lex_state = 380, .external_lex_state = 12},
  [13741] = {.lex_state = 384, .external_lex_state = 12},
  [13742] = {.lex_state = 380, .external_lex_state = 12},
  [13743] = {.lex_state = 380, .external_lex_state = 12},
  [13744] = {.lex_state = 380, .external_lex_state = 12},
  [13745] = {.lex_state = 380, .external_lex_state = 13},
  [13746] = {.lex_state = 380, .external_lex_state = 12},
  [13747] = {.lex_state = 388, .external_lex_state = 12},
  [13748] = {.lex_state = 380, .external_lex_state = 12},
  [13749] = {.lex_state = 380, .external_lex_state = 12},
  [13750] = {.lex_state = 380, .external_lex_state = 12},
  [13751] = {.lex_state = 384, .external_lex_state = 12},
  [13752] = {.lex_state = 380, .external_lex_state = 12},
  [13753] = {.lex_state = 380, .external_lex_state = 13},
  [13754] = {.lex_state = 384, .external_lex_state = 12},
  [13755] = {.lex_state = 380, .external_lex_state = 12},
  [13756] = {.lex_state = 380, .external_lex_state = 12},
  [13757] = {.lex_state = 380, .external_lex_state = 12},
  [13758] = {.lex_state = 380, .external_lex_state = 12},
  [13759] = {.lex_state = 380, .external_lex_state = 12},
  [13760] = {.lex_state = 380, .external_lex_state = 12},
  [13761] = {.lex_state = 380, .external_lex_state = 12},
  [13762] = {.lex_state = 380, .external_lex_state = 12},
  [13763] = {.lex_state = 384, .external_lex_state = 12},
  [13764] = {.lex_state = 380, .external_lex_state = 13},
  [13765] = {.lex_state = 380, .external_lex_state = 12},
  [13766] = {.lex_state = 380, .external_lex_state = 12},
  [13767] = {.lex_state = 380, .external_lex_state = 12},
  [13768] = {.lex_state = 380, .external_lex_state = 12},
  [13769] = {.lex_state = 380, .external_lex_state = 12},
  [13770] = {.lex_state = 380, .external_lex_state = 12},
  [13771] = {.lex_state = 380, .external_lex_state = 12},
  [13772] = {.lex_state = 380, .external_lex_state = 12},
  [13773] = {.lex_state = 380, .external_lex_state = 12},
  [13774] = {.lex_state = 380, .external_lex_state = 12},
  [13775] = {.lex_state = 380, .external_lex_state = 12},
  [13776] = {.lex_state = 380, .external_lex_state = 12},
  [13777] = {.lex_state = 380, .external_lex_state = 12},
  [13778] = {.lex_state = 384, .external_lex_state = 12},
  [13779] = {.lex_state = 380, .external_lex_state = 13},
  [13780] = {.lex_state = 380, .external_lex_state = 12},
  [13781] = {.lex_state = 380, .external_lex_state = 12},
  [13782] = {.lex_state = 380, .external_lex_state = 12},
  [13783] = {.lex_state = 384, .external_lex_state = 12},
  [13784] = {.lex_state = 380, .external_lex_state = 12},
  [13785] = {.lex_state = 380, .external_lex_state = 13},
  [13786] = {.lex_state = 380, .external_lex_state = 12},
  [13787] = {.lex_state = 384, .external_lex_state = 12},
  [13788] = {.lex_state = 380, .external_lex_state = 12},
  [13789] = {.lex_state = 380, .external_lex_state = 12},
  [13790] = {.lex_state = 380, .external_lex_state = 12},
  [13791] = {.lex_state = 380, .external_lex_state = 12},
  [13792] = {.lex_state = 380, .external_lex_state = 12},
  [13793] = {.lex_state = 380, .external_lex_state = 12},
  [13794] = {.lex_state = 380, .external_lex_state = 12},
  [13795] = {.lex_state = 380, .external_lex_state = 12},
  [13796] = {.lex_state = 380, .external_lex_state = 13},
  [13797] = {.lex_state = 380, .external_lex_state = 12},
  [13798] = {.lex_state = 380, .external_lex_state = 13},
  [13799] = {.lex_state = 380, .external_lex_state = 12},
  [13800] = {.lex_state = 380, .external_lex_state = 12},
  [13801] = {.lex_state = 380, .external_lex_state = 12},
  [13802] = {.lex_state = 380, .external_lex_state = 12},
  [13803] = {.lex_state = 380, .external_lex_state = 12},
  [13804] = {.lex_state = 380, .external_lex_state = 12},
  [13805] = {.lex_state = 537, .external_lex_state = 12},
  [13806] = {.lex_state = 380, .external_lex_state = 12},
  [13807] = {.lex_state = 384, .external_lex_state = 12},
  [13808] = {.lex_state = 384, .external_lex_state = 12},
  [13809] = {.lex_state = 380, .external_lex_state = 13},
  [13810] = {.lex_state = 380, .external_lex_state = 12},
  [13811] = {.lex_state = 384, .external_lex_state = 12},
  [13812] = {.lex_state = 380, .external_lex_state = 13},
  [13813] = {.lex_state = 380, .external_lex_state = 12},
  [13814] = {.lex_state = 380, .external_lex_state = 12},
  [13815] = {.lex_state = 380, .external_lex_state = 12},
  [13816] = {.lex_state = 380, .external_lex_state = 12},
  [13817] = {.lex_state = 384, .external_lex_state = 12},
  [13818] = {.lex_state = 380, .external_lex_state = 13},
  [13819] = {.lex_state = 380, .external_lex_state = 12},
  [13820] = {.lex_state = 384, .external_lex_state = 12},
  [13821] = {.lex_state = 380, .external_lex_state = 12},
  [13822] = {.lex_state = 380, .external_lex_state = 12},
  [13823] = {.lex_state = 380, .external_lex_state = 12},
  [13824] = {.lex_state = 380, .external_lex_state = 12},
  [13825] = {.lex_state = 380, .external_lex_state = 12},
  [13826] = {.lex_state = 380, .external_lex_state = 12},
  [13827] = {.lex_state = 380, .external_lex_state = 12},
  [13828] = {.lex_state = 380, .external_lex_state = 12},
  [13829] = {.lex_state = 388, .external_lex_state = 12},
  [13830] = {.lex_state = 380, .external_lex_state = 12},
  [13831] = {.lex_state = 380, .external_lex_state = 12},
  [13832] = {.lex_state = 380, .external_lex_state = 12},
  [13833] = {.lex_state = 388, .external_lex_state = 12},
  [13834] = {.lex_state = 380, .external_lex_state = 12},
  [13835] = {.lex_state = 380, .external_lex_state = 12},
  [13836] = {.lex_state = 380, .external_lex_state = 12},
  [13837] = {.lex_state = 380, .external_lex_state = 12},
  [13838] = {.lex_state = 380, .external_lex_state = 12},
  [13839] = {.lex_state = 384, .external_lex_state = 12},
  [13840] = {.lex_state = 380, .external_lex_state = 12},
  [13841] = {.lex_state = 380, .external_lex_state = 12},
  [13842] = {.lex_state = 380, .external_lex_state = 13},
  [13843] = {.lex_state = 380, .external_lex_state = 12},
  [13844] = {.lex_state = 380, .external_lex_state = 12},
  [13845] = {.lex_state = 384, .external_lex_state = 12},
  [13846] = {.lex_state = 380, .external_lex_state = 12},
  [13847] = {.lex_state = 384, .external_lex_state = 12},
  [13848] = {.lex_state = 384, .external_lex_state = 12},
  [13849] = {.lex_state = 380, .external_lex_state = 12},
  [13850] = {.lex_state = 380, .external_lex_state = 13},
  [13851] = {.lex_state = 380, .external_lex_state = 13},
  [13852] = {.lex_state = 380, .external_lex_state = 12},
  [13853] = {.lex_state = 380, .external_lex_state = 12},
  [13854] = {.lex_state = 380, .external_lex_state = 12},
  [13855] = {.lex_state = 380, .external_lex_state = 12},
  [13856] = {.lex_state = 380, .external_lex_state = 12},
  [13857] = {.lex_state = 380, .external_lex_state = 12},
  [13858] = {.lex_state = 384, .external_lex_state = 12},
  [13859] = {.lex_state = 380, .external_lex_state = 13},
  [13860] = {.lex_state = 380, .external_lex_state = 12},
  [13861] = {.lex_state = 380, .external_lex_state = 12},
  [13862] = {.lex_state = 380, .external_lex_state = 12},
  [13863] = {.lex_state = 380, .external_lex_state = 12},
  [13864] = {.lex_state = 380, .external_lex_state = 12},
  [13865] = {.lex_state = 380, .external_lex_state = 12},
  [13866] = {.lex_state = 384, .external_lex_state = 12},
  [13867] = {.lex_state = 380, .external_lex_state = 12},
  [13868] = {.lex_state = 380, .external_lex_state = 12},
  [13869] = {.lex_state = 380, .external_lex_state = 13},
  [13870] = {.lex_state = 380, .external_lex_state = 12},
  [13871] = {.lex_state = 380, .external_lex_state = 12},
  [13872] = {.lex_state = 380, .external_lex_state = 12},
  [13873] = {.lex_state = 380, .external_lex_state = 12},
  [13874] = {.lex_state = 380, .external_lex_state = 12},
  [13875] = {.lex_state = 380, .external_lex_state = 12},
  [13876] = {.lex_state = 384, .external_lex_state = 12},
  [13877] = {.lex_state = 380, .external_lex_state = 13},
  [13878] = {.lex_state = 380, .external_lex_state = 12},
  [13879] = {.lex_state = 380, .external_lex_state = 12},
  [13880] = {.lex_state = 384, .external_lex_state = 12},
  [13881] = {.lex_state = 380, .external_lex_state = 12},
  [13882] = {.lex_state = 380, .external_lex_state = 12},
  [13883] = {.lex_state = 380, .external_lex_state = 12},
  [13884] = {.lex_state = 384, .external_lex_state = 12},
  [13885] = {.lex_state = 380, .external_lex_state = 12},
  [13886] = {.lex_state = 380, .external_lex_state = 13},
  [13887] = {.lex_state = 384, .external_lex_state = 12},
  [13888] = {.lex_state = 380, .external_lex_state = 13},
  [13889] = {.lex_state = 380, .external_lex_state = 12},
  [13890] = {.lex_state = 380, .external_lex_state = 12},
  [13891] = {.lex_state = 380, .external_lex_state = 12},
  [13892] = {.lex_state = 384, .external_lex_state = 12},
  [13893] = {.lex_state = 380, .external_lex_state = 12},
  [13894] = {.lex_state = 380, .external_lex_state = 12},
  [13895] = {.lex_state = 380, .external_lex_state = 12},
  [13896] = {.lex_state = 380, .external_lex_state = 12},
  [13897] = {.lex_state = 380, .external_lex_state = 12},
  [13898] = {.lex_state = 380, .external_lex_state = 12},
  [13899] = {.lex_state = 380, .external_lex_state = 12},
  [13900] = {.lex_state = 380, .external_lex_state = 12},
  [13901] = {.lex_state = 380, .external_lex_state = 12},
  [13902] = {.lex_state = 380, .external_lex_state = 12},
  [13903] = {.lex_state = 380, .external_lex_state = 12},
  [13904] = {.lex_state = 380, .external_lex_state = 12},
  [13905] = {.lex_state = 384, .external_lex_state = 12},
  [13906] = {.lex_state = 380, .external_lex_state = 12},
  [13907] = {.lex_state = 380, .external_lex_state = 13},
  [13908] = {.lex_state = 380, .external_lex_state = 12},
  [13909] = {.lex_state = 380, .external_lex_state = 12},
  [13910] = {.lex_state = 380, .external_lex_state = 12},
  [13911] = {.lex_state = 380, .external_lex_state = 12},
  [13912] = {.lex_state = 380, .external_lex_state = 13},
  [13913] = {.lex_state = 380, .external_lex_state = 12},
  [13914] = {.lex_state = 380, .external_lex_state = 12},
  [13915] = {.lex_state = 380, .external_lex_state = 12},
  [13916] = {.lex_state = 380, .external_lex_state = 12},
  [13917] = {.lex_state = 380, .external_lex_state = 12},
  [13918] = {.lex_state = 380, .external_lex_state = 12},
  [13919] = {.lex_state = 380, .external_lex_state = 12},
  [13920] = {.lex_state = 380, .external_lex_state = 12},
  [13921] = {.lex_state = 380, .external_lex_state = 12},
  [13922] = {.lex_state = 380, .external_lex_state = 12},
  [13923] = {.lex_state = 380, .external_lex_state = 12},
  [13924] = {.lex_state = 380, .external_lex_state = 12},
  [13925] = {.lex_state = 380, .external_lex_state = 12},
  [13926] = {.lex_state = 380, .external_lex_state = 12},
  [13927] = {.lex_state = 384, .external_lex_state = 12},
  [13928] = {.lex_state = 380, .external_lex_state = 12},
  [13929] = {.lex_state = 380, .external_lex_state = 13},
  [13930] = {.lex_state = 380, .external_lex_state = 12},
  [13931] = {.lex_state = 380, .external_lex_state = 12},
  [13932] = {.lex_state = 380, .external_lex_state = 12},
  [13933] = {.lex_state = 380, .external_lex_state = 12},
  [13934] = {.lex_state = 380, .external_lex_state = 12},
  [13935] = {.lex_state = 380, .external_lex_state = 12},
  [13936] = {.lex_state = 380, .external_lex_state = 12},
  [13937] = {.lex_state = 380, .external_lex_state = 12},
  [13938] = {.lex_state = 384, .external_lex_state = 12},
  [13939] = {.lex_state = 380, .external_lex_state = 12},
  [13940] = {.lex_state = 380, .external_lex_state = 13},
  [13941] = {.lex_state = 380, .external_lex_state = 12},
  [13942] = {.lex_state = 380, .external_lex_state = 12},
  [13943] = {.lex_state = 380, .external_lex_state = 12},
  [13944] = {.lex_state = 380, .external_lex_state = 12},
  [13945] = {.lex_state = 380, .external_lex_state = 12},
  [13946] = {.lex_state = 380, .external_lex_state = 12},
  [13947] = {.lex_state = 380, .external_lex_state = 12},
  [13948] = {.lex_state = 380, .external_lex_state = 12},
  [13949] = {.lex_state = 380, .external_lex_state = 12},
  [13950] = {.lex_state = 380, .external_lex_state = 12},
  [13951] = {.lex_state = 380, .external_lex_state = 12},
  [13952] = {.lex_state = 380, .external_lex_state = 12},
  [13953] = {.lex_state = 380, .external_lex_state = 12},
  [13954] = {.lex_state = 380, .external_lex_state = 12},
  [13955] = {.lex_state = 380, .external_lex_state = 12},
  [13956] = {.lex_state = 380, .external_lex_state = 12},
  [13957] = {.lex_state = 380, .external_lex_state = 12},
  [13958] = {.lex_state = 380, .external_lex_state = 12},
  [13959] = {.lex_state = 384, .external_lex_state = 12},
  [13960] = {.lex_state = 380, .external_lex_state = 13},
  [13961] = {.lex_state = 380, .external_lex_state = 12},
  [13962] = {.lex_state = 380, .external_lex_state = 12},
  [13963] = {.lex_state = 380, .external_lex_state = 12},
  [13964] = {.lex_state = 380, .external_lex_state = 12},
  [13965] = {.lex_state = 537, .external_lex_state = 12},
  [13966] = {.lex_state = 384, .external_lex_state = 12},
  [13967] = {.lex_state = 380, .external_lex_state = 12},
  [13968] = {.lex_state = 380, .external_lex_state = 12},
  [13969] = {.lex_state = 380, .external_lex_state = 12},
  [13970] = {.lex_state = 380, .external_lex_state = 12},
  [13971] = {.lex_state = 380, .external_lex_state = 12},
  [13972] = {.lex_state = 384, .external_lex_state = 12},
  [13973] = {.lex_state = 380, .external_lex_state = 13},
  [13974] = {.lex_state = 380, .external_lex_state = 12},
  [13975] = {.lex_state = 380, .external_lex_state = 12},
  [13976] = {.lex_state = 384, .external_lex_state = 12},
  [13977] = {.lex_state = 380, .external_lex_state = 12},
  [13978] = {.lex_state = 380, .external_lex_state = 12},
  [13979] = {.lex_state = 380, .external_lex_state = 12},
  [13980] = {.lex_state = 380, .external_lex_state = 12},
  [13981] = {.lex_state = 380, .external_lex_state = 12},
  [13982] = {.lex_state = 380, .external_lex_state = 13},
  [13983] = {.lex_state = 384, .external_lex_state = 12},
  [13984] = {.lex_state = 380, .external_lex_state = 12},
  [13985] = {.lex_state = 380, .external_lex_state = 12},
  [13986] = {.lex_state = 380, .external_lex_state = 12},
  [13987] = {.lex_state = 380, .external_lex_state = 12},
  [13988] = {.lex_state = 380, .external_lex_state = 12},
  [13989] = {.lex_state = 380, .external_lex_state = 12},
  [13990] = {.lex_state = 380, .external_lex_state = 12},
  [13991] = {.lex_state = 380, .external_lex_state = 12},
  [13992] = {.lex_state = 380, .external_lex_state = 12},
  [13993] = {.lex_state = 384, .external_lex_state = 12},
  [13994] = {.lex_state = 343, .external_lex_state = 12},
  [13995] = {.lex_state = 343, .external_lex_state = 12},
  [13996] = {.lex_state = 380, .external_lex_state = 13},
  [13997] = {.lex_state = 343, .external_lex_state = 12},
  [13998] = {.lex_state = 380, .external_lex_state = 12},
  [13999] = {.lex_state = 380, .external_lex_state = 12},
  [14000] = {.lex_state = 380, .external_lex_state = 12},
  [14001] = {.lex_state = 380, .external_lex_state = 12},
  [14002] = {.lex_state = 343, .external_lex_state = 12},
  [14003] = {.lex_state = 343, .external_lex_state = 12},
  [14004] = {.lex_state = 380, .external_lex_state = 12},
  [14005] = {.lex_state = 343, .external_lex_state = 12},
  [14006] = {.lex_state = 343, .external_lex_state = 12},
  [14007] = {.lex_state = 380, .external_lex_state = 12},
  [14008] = {.lex_state = 343, .external_lex_state = 12},
  [14009] = {.lex_state = 380, .external_lex_state = 12},
  [14010] = {.lex_state = 343, .external_lex_state = 12},
  [14011] = {.lex_state = 343, .external_lex_state = 12},
  [14012] = {.lex_state = 343, .external_lex_state = 12},
  [14013] = {.lex_state = 380, .external_lex_state = 12},
  [14014] = {.lex_state = 343, .external_lex_state = 12},
  [14015] = {.lex_state = 380, .external_lex_state = 12},
  [14016] = {.lex_state = 343, .external_lex_state = 12},
  [14017] = {.lex_state = 380, .external_lex_state = 12},
  [14018] = {.lex_state = 380, .external_lex_state = 12},
  [14019] = {.lex_state = 343, .external_lex_state = 12},
  [14020] = {.lex_state = 380, .external_lex_state = 12},
  [14021] = {.lex_state = 380, .external_lex_state = 12},
  [14022] = {.lex_state = 343, .external_lex_state = 12},
  [14023] = {.lex_state = 343, .external_lex_state = 12},
  [14024] = {.lex_state = 343, .external_lex_state = 12},
  [14025] = {.lex_state = 380, .external_lex_state = 12},
  [14026] = {.lex_state = 343, .external_lex_state = 12},
  [14027] = {.lex_state = 343, .external_lex_state = 12},
  [14028] = {.lex_state = 343, .external_lex_state = 12},
  [14029] = {.lex_state = 343, .external_lex_state = 12},
  [14030] = {.lex_state = 343, .external_lex_state = 12},
  [14031] = {.lex_state = 343, .external_lex_state = 12},
  [14032] = {.lex_state = 380, .external_lex_state = 12},
  [14033] = {.lex_state = 380, .external_lex_state = 12},
  [14034] = {.lex_state = 343, .external_lex_state = 12},
  [14035] = {.lex_state = 343, .external_lex_state = 12},
  [14036] = {.lex_state = 343, .external_lex_state = 12},
  [14037] = {.lex_state = 343, .external_lex_state = 12},
  [14038] = {.lex_state = 343, .external_lex_state = 12},
  [14039] = {.lex_state = 343, .external_lex_state = 12},
  [14040] = {.lex_state = 343, .external_lex_state = 12},
  [14041] = {.lex_state = 343, .external_lex_state = 12},
  [14042] = {.lex_state = 343, .external_lex_state = 12},
  [14043] = {.lex_state = 343, .external_lex_state = 12},
  [14044] = {.lex_state = 343, .external_lex_state = 12},
  [14045] = {.lex_state = 384, .external_lex_state = 12},
  [14046] = {.lex_state = 380, .external_lex_state = 12},
  [14047] = {.lex_state = 380, .external_lex_state = 12},
  [14048] = {.lex_state = 380, .external_lex_state = 12},
  [14049] = {.lex_state = 380, .external_lex_state = 12},
  [14050] = {.lex_state = 380, .external_lex_state = 12},
  [14051] = {.lex_state = 380, .external_lex_state = 12},
  [14052] = {.lex_state = 380, .external_lex_state = 12},
  [14053] = {.lex_state = 343, .external_lex_state = 12},
  [14054] = {.lex_state = 380, .external_lex_state = 12},
  [14055] = {.lex_state = 380, .external_lex_state = 12},
  [14056] = {.lex_state = 343, .external_lex_state = 12},
  [14057] = {.lex_state = 380, .external_lex_state = 12},
  [14058] = {.lex_state = 380, .external_lex_state = 12},
  [14059] = {.lex_state = 343, .external_lex_state = 12},
  [14060] = {.lex_state = 380, .external_lex_state = 12},
  [14061] = {.lex_state = 380, .external_lex_state = 12},
  [14062] = {.lex_state = 380, .external_lex_state = 12},
  [14063] = {.lex_state = 380, .external_lex_state = 12},
  [14064] = {.lex_state = 380, .external_lex_state = 12},
  [14065] = {.lex_state = 380, .external_lex_state = 12},
  [14066] = {.lex_state = 380, .external_lex_state = 12},
  [14067] = {.lex_state = 380, .external_lex_state = 12},
  [14068] = {.lex_state = 343, .external_lex_state = 12},
  [14069] = {.lex_state = 380, .external_lex_state = 12},
  [14070] = {.lex_state = 343, .external_lex_state = 12},
  [14071] = {.lex_state = 380, .external_lex_state = 12},
  [14072] = {.lex_state = 380, .external_lex_state = 12},
  [14073] = {.lex_state = 380, .external_lex_state = 12},
  [14074] = {.lex_state = 343, .external_lex_state = 12},
  [14075] = {.lex_state = 380, .external_lex_state = 12},
  [14076] = {.lex_state = 380, .external_lex_state = 12},
  [14077] = {.lex_state = 380, .external_lex_state = 12},
  [14078] = {.lex_state = 343, .external_lex_state = 12},
  [14079] = {.lex_state = 343, .external_lex_state = 12},
  [14080] = {.lex_state = 343, .external_lex_state = 12},
  [14081] = {.lex_state = 343, .external_lex_state = 12},
  [14082] = {.lex_state = 380, .external_lex_state = 12},
  [14083] = {.lex_state = 343, .external_lex_state = 12},
  [14084] = {.lex_state = 380, .external_lex_state = 12},
  [14085] = {.lex_state = 343, .external_lex_state = 12},
  [14086] = {.lex_state = 343, .external_lex_state = 12},
  [14087] = {.lex_state = 380, .external_lex_state = 12},
  [14088] = {.lex_state = 343, .external_lex_state = 12},
  [14089] = {.lex_state = 343, .external_lex_state = 12},
  [14090] = {.lex_state = 380, .external_lex_state = 12},
  [14091] = {.lex_state = 343, .external_lex_state = 12},
  [14092] = {.lex_state = 343, .external_lex_state = 12},
  [14093] = {.lex_state = 343, .external_lex_state = 12},
  [14094] = {.lex_state = 380, .external_lex_state = 12},
  [14095] = {.lex_state = 343, .external_lex_state = 12},
  [14096] = {.lex_state = 343, .external_lex_state = 12},
  [14097] = {.lex_state = 380, .external_lex_state = 12},
  [14098] = {.lex_state = 343, .external_lex_state = 12},
  [14099] = {.lex_state = 343, .external_lex_state = 12},
  [14100] = {.lex_state = 380, .external_lex_state = 12},
  [14101] = {.lex_state = 343, .external_lex_state = 12},
  [14102] = {.lex_state = 343, .external_lex_state = 12},
  [14103] = {.lex_state = 380, .external_lex_state = 12},
  [14104] = {.lex_state = 343, .external_lex_state = 12},
  [14105] = {.lex_state = 343, .external_lex_state = 12},
  [14106] = {.lex_state = 343, .external_lex_state = 12},
  [14107] = {.lex_state = 343, .external_lex_state = 12},
  [14108] = {.lex_state = 343, .external_lex_state = 12},
  [14109] = {.lex_state = 343, .external_lex_state = 12},
  [14110] = {.lex_state = 343, .external_lex_state = 12},
  [14111] = {.lex_state = 343, .external_lex_state = 12},
  [14112] = {.lex_state = 343, .external_lex_state = 12},
  [14113] = {.lex_state = 343, .external_lex_state = 12},
  [14114] = {.lex_state = 343, .external_lex_state = 12},
  [14115] = {.lex_state = 343, .external_lex_state = 12},
  [14116] = {.lex_state = 343, .external_lex_state = 12},
  [14117] = {.lex_state = 343, .external_lex_state = 12},
  [14118] = {.lex_state = 343, .external_lex_state = 12},
  [14119] = {.lex_state = 343, .external_lex_state = 12},
  [14120] = {.lex_state = 343, .external_lex_state = 12},
  [14121] = {.lex_state = 343, .external_lex_state = 12},
  [14122] = {.lex_state = 380, .external_lex_state = 12},
  [14123] = {.lex_state = 343, .external_lex_state = 12},
  [14124] = {.lex_state = 380, .external_lex_state = 12},
  [14125] = {.lex_state = 343, .external_lex_state = 12},
  [14126] = {.lex_state = 380, .external_lex_state = 12},
  [14127] = {.lex_state = 380, .external_lex_state = 12},
  [14128] = {.lex_state = 343, .external_lex_state = 12},
  [14129] = {.lex_state = 343, .external_lex_state = 12},
  [14130] = {.lex_state = 380, .external_lex_state = 12},
  [14131] = {.lex_state = 380, .external_lex_state = 12},
  [14132] = {.lex_state = 380, .external_lex_state = 12},
  [14133] = {.lex_state = 380, .external_lex_state = 12},
  [14134] = {.lex_state = 380, .external_lex_state = 12},
  [14135] = {.lex_state = 380, .external_lex_state = 12},
  [14136] = {.lex_state = 380, .external_lex_state = 12},
  [14137] = {.lex_state = 343, .external_lex_state = 12},
  [14138] = {.lex_state = 384, .external_lex_state = 12},
  [14139] = {.lex_state = 380, .external_lex_state = 12},
  [14140] = {.lex_state = 384, .external_lex_state = 12},
  [14141] = {.lex_state = 343, .external_lex_state = 12},
  [14142] = {.lex_state = 380, .external_lex_state = 12},
  [14143] = {.lex_state = 380, .external_lex_state = 12},
  [14144] = {.lex_state = 380, .external_lex_state = 12},
  [14145] = {.lex_state = 380, .external_lex_state = 12},
  [14146] = {.lex_state = 380, .external_lex_state = 12},
  [14147] = {.lex_state = 380, .external_lex_state = 12},
  [14148] = {.lex_state = 380, .external_lex_state = 12},
  [14149] = {.lex_state = 380, .external_lex_state = 12},
  [14150] = {.lex_state = 380, .external_lex_state = 12},
  [14151] = {.lex_state = 380, .external_lex_state = 12},
  [14152] = {.lex_state = 380, .external_lex_state = 12},
  [14153] = {.lex_state = 380, .external_lex_state = 12},
  [14154] = {.lex_state = 380, .external_lex_state = 12},
  [14155] = {.lex_state = 380, .external_lex_state = 12},
  [14156] = {.lex_state = 380, .external_lex_state = 12},
  [14157] = {.lex_state = 380, .external_lex_state = 12},
  [14158] = {.lex_state = 380, .external_lex_state = 12},
  [14159] = {.lex_state = 380, .external_lex_state = 12},
  [14160] = {.lex_state = 380, .external_lex_state = 12},
  [14161] = {.lex_state = 380, .external_lex_state = 12},
  [14162] = {.lex_state = 380, .external_lex_state = 12},
  [14163] = {.lex_state = 380, .external_lex_state = 12},
  [14164] = {.lex_state = 380, .external_lex_state = 12},
  [14165] = {.lex_state = 380, .external_lex_state = 12},
  [14166] = {.lex_state = 380, .external_lex_state = 12},
  [14167] = {.lex_state = 380, .external_lex_state = 12},
  [14168] = {.lex_state = 380, .external_lex_state = 12},
  [14169] = {.lex_state = 380, .external_lex_state = 12},
  [14170] = {.lex_state = 380, .external_lex_state = 12},
  [14171] = {.lex_state = 380, .external_lex_state = 12},
  [14172] = {.lex_state = 380, .external_lex_state = 12},
  [14173] = {.lex_state = 380, .external_lex_state = 12},
  [14174] = {.lex_state = 380, .external_lex_state = 12},
  [14175] = {.lex_state = 380, .external_lex_state = 12},
  [14176] = {.lex_state = 380, .external_lex_state = 12},
  [14177] = {.lex_state = 380, .external_lex_state = 12},
  [14178] = {.lex_state = 380, .external_lex_state = 12},
  [14179] = {.lex_state = 380, .external_lex_state = 12},
  [14180] = {.lex_state = 380, .external_lex_state = 12},
  [14181] = {.lex_state = 357, .external_lex_state = 12},
  [14182] = {.lex_state = 357, .external_lex_state = 12},
  [14183] = {.lex_state = 357, .external_lex_state = 12},
  [14184] = {.lex_state = 357, .external_lex_state = 12},
  [14185] = {.lex_state = 357, .external_lex_state = 12},
  [14186] = {.lex_state = 357, .external_lex_state = 12},
  [14187] = {.lex_state = 357, .external_lex_state = 12},
  [14188] = {.lex_state = 357, .external_lex_state = 12},
  [14189] = {.lex_state = 357, .external_lex_state = 12},
  [14190] = {.lex_state = 357, .external_lex_state = 12},
  [14191] = {.lex_state = 357, .external_lex_state = 12},
  [14192] = {.lex_state = 357, .external_lex_state = 12},
  [14193] = {.lex_state = 357, .external_lex_state = 12},
  [14194] = {.lex_state = 357, .external_lex_state = 12},
  [14195] = {.lex_state = 357, .external_lex_state = 12},
  [14196] = {.lex_state = 357, .external_lex_state = 12},
  [14197] = {.lex_state = 357, .external_lex_state = 12},
  [14198] = {.lex_state = 357, .external_lex_state = 12},
  [14199] = {.lex_state = 357, .external_lex_state = 12},
  [14200] = {.lex_state = 357, .external_lex_state = 12},
  [14201] = {.lex_state = 357, .external_lex_state = 12},
  [14202] = {.lex_state = 357, .external_lex_state = 12},
  [14203] = {.lex_state = 357, .external_lex_state = 12},
  [14204] = {.lex_state = 357, .external_lex_state = 12},
  [14205] = {.lex_state = 357, .external_lex_state = 12},
  [14206] = {.lex_state = 357, .external_lex_state = 12},
  [14207] = {.lex_state = 357, .external_lex_state = 12},
  [14208] = {.lex_state = 357, .external_lex_state = 12},
  [14209] = {.lex_state = 357, .external_lex_state = 12},
  [14210] = {.lex_state = 357, .external_lex_state = 12},
  [14211] = {.lex_state = 357, .external_lex_state = 12},
  [14212] = {.lex_state = 357, .external_lex_state = 12},
  [14213] = {.lex_state = 357, .external_lex_state = 12},
  [14214] = {.lex_state = 357, .external_lex_state = 12},
  [14215] = {.lex_state = 357, .external_lex_state = 12},
  [14216] = {.lex_state = 357, .external_lex_state = 12},
  [14217] = {.lex_state = 357, .external_lex_state = 12},
  [14218] = {.lex_state = 357, .external_lex_state = 12},
  [14219] = {.lex_state = 357, .external_lex_state = 12},
  [14220] = {.lex_state = 357, .external_lex_state = 12},
  [14221] = {.lex_state = 357, .external_lex_state = 12},
  [14222] = {.lex_state = 357, .external_lex_state = 12},
  [14223] = {.lex_state = 357, .external_lex_state = 12},
  [14224] = {.lex_state = 357, .external_lex_state = 12},
  [14225] = {.lex_state = 357, .external_lex_state = 12},
  [14226] = {.lex_state = 357, .external_lex_state = 12},
  [14227] = {.lex_state = 357, .external_lex_state = 12},
  [14228] = {.lex_state = 357, .external_lex_state = 12},
  [14229] = {.lex_state = 357, .external_lex_state = 12},
  [14230] = {.lex_state = 357, .external_lex_state = 12},
  [14231] = {.lex_state = 357, .external_lex_state = 12},
  [14232] = {.lex_state = 343, .external_lex_state = 5},
  [14233] = {.lex_state = 343, .external_lex_state = 5},
  [14234] = {.lex_state = 343, .external_lex_state = 5},
  [14235] = {.lex_state = 343, .external_lex_state = 5},
  [14236] = {.lex_state = 343, .external_lex_state = 5},
  [14237] = {.lex_state = 343, .external_lex_state = 5},
  [14238] = {.lex_state = 343, .external_lex_state = 5},
  [14239] = {.lex_state = 343, .external_lex_state = 5},
  [14240] = {.lex_state = 343, .external_lex_state = 5},
  [14241] = {.lex_state = 343, .external_lex_state = 5},
  [14242] = {.lex_state = 343, .external_lex_state = 5},
  [14243] = {.lex_state = 343, .external_lex_state = 5},
  [14244] = {.lex_state = 343, .external_lex_state = 5},
  [14245] = {.lex_state = 343, .external_lex_state = 5},
  [14246] = {.lex_state = 343, .external_lex_state = 5},
  [14247] = {.lex_state = 343, .external_lex_state = 5},
  [14248] = {.lex_state = 343, .external_lex_state = 5},
  [14249] = {.lex_state = 343, .external_lex_state = 5},
  [14250] = {.lex_state = 343, .external_lex_state = 5},
  [14251] = {.lex_state = 343, .external_lex_state = 5},
  [14252] = {.lex_state = 343, .external_lex_state = 5},
  [14253] = {.lex_state = 343, .external_lex_state = 5},
  [14254] = {.lex_state = 343, .external_lex_state = 5},
  [14255] = {.lex_state = 343, .external_lex_state = 5},
  [14256] = {.lex_state = 343, .external_lex_state = 5},
  [14257] = {.lex_state = 343, .external_lex_state = 5},
  [14258] = {.lex_state = 343, .external_lex_state = 5},
  [14259] = {.lex_state = 343, .external_lex_state = 5},
  [14260] = {.lex_state = 343, .external_lex_state = 5},
  [14261] = {.lex_state = 343, .external_lex_state = 5},
  [14262] = {.lex_state = 343, .external_lex_state = 5},
  [14263] = {.lex_state = 343, .external_lex_state = 5},
  [14264] = {.lex_state = 343, .external_lex_state = 5},
  [14265] = {.lex_state = 343, .external_lex_state = 5},
  [14266] = {.lex_state = 343, .external_lex_state = 5},
  [14267] = {.lex_state = 343, .external_lex_state = 5},
  [14268] = {.lex_state = 343, .external_lex_state = 5},
  [14269] = {.lex_state = 343, .external_lex_state = 5},
  [14270] = {.lex_state = 343, .external_lex_state = 5},
  [14271] = {.lex_state = 343, .external_lex_state = 5},
  [14272] = {.lex_state = 343, .external_lex_state = 5},
  [14273] = {.lex_state = 343, .external_lex_state = 5},
  [14274] = {.lex_state = 343, .external_lex_state = 5},
  [14275] = {.lex_state = 343, .external_lex_state = 5},
  [14276] = {.lex_state = 343, .external_lex_state = 5},
  [14277] = {.lex_state = 343, .external_lex_state = 5},
  [14278] = {.lex_state = 343, .external_lex_state = 5},
  [14279] = {.lex_state = 343, .external_lex_state = 5},
  [14280] = {.lex_state = 343, .external_lex_state = 5},
  [14281] = {.lex_state = 343, .external_lex_state = 5},
  [14282] = {.lex_state = 343, .external_lex_state = 5},
  [14283] = {.lex_state = 343, .external_lex_state = 5},
  [14284] = {.lex_state = 343, .external_lex_state = 5},
  [14285] = {.lex_state = 343, .external_lex_state = 5},
  [14286] = {.lex_state = 343, .external_lex_state = 5},
  [14287] = {.lex_state = 343, .external_lex_state = 5},
  [14288] = {.lex_state = 343, .external_lex_state = 5},
  [14289] = {.lex_state = 343, .external_lex_state = 5},
  [14290] = {.lex_state = 343, .external_lex_state = 5},
  [14291] = {.lex_state = 343, .external_lex_state = 5},
  [14292] = {.lex_state = 343, .external_lex_state = 5},
  [14293] = {.lex_state = 343, .external_lex_state = 5},
  [14294] = {.lex_state = 343, .external_lex_state = 5},
  [14295] = {.lex_state = 343, .external_lex_state = 5},
  [14296] = {.lex_state = 343, .external_lex_state = 5},
  [14297] = {.lex_state = 343, .external_lex_state = 5},
  [14298] = {.lex_state = 343, .external_lex_state = 5},
  [14299] = {.lex_state = 343, .external_lex_state = 5},
  [14300] = {.lex_state = 343, .external_lex_state = 5},
  [14301] = {.lex_state = 343, .external_lex_state = 5},
  [14302] = {.lex_state = 343, .external_lex_state = 5},
  [14303] = {.lex_state = 343, .external_lex_state = 5},
  [14304] = {.lex_state = 343, .external_lex_state = 5},
  [14305] = {.lex_state = 343, .external_lex_state = 5},
  [14306] = {.lex_state = 343, .external_lex_state = 5},
  [14307] = {.lex_state = 343, .external_lex_state = 5},
  [14308] = {.lex_state = 343, .external_lex_state = 5},
  [14309] = {.lex_state = 343, .external_lex_state = 5},
  [14310] = {.lex_state = 343, .external_lex_state = 5},
  [14311] = {.lex_state = 343, .external_lex_state = 5},
  [14312] = {.lex_state = 343, .external_lex_state = 5},
  [14313] = {.lex_state = 343, .external_lex_state = 5},
  [14314] = {.lex_state = 343, .external_lex_state = 5},
  [14315] = {.lex_state = 343, .external_lex_state = 5},
  [14316] = {.lex_state = 343, .external_lex_state = 5},
  [14317] = {.lex_state = 343, .external_lex_state = 5},
  [14318] = {.lex_state = 343, .external_lex_state = 5},
  [14319] = {.lex_state = 343, .external_lex_state = 5},
  [14320] = {.lex_state = 343, .external_lex_state = 5},
  [14321] = {.lex_state = 343, .external_lex_state = 5},
  [14322] = {.lex_state = 343, .external_lex_state = 5},
  [14323] = {.lex_state = 343, .external_lex_state = 5},
  [14324] = {.lex_state = 343, .external_lex_state = 5},
  [14325] = {.lex_state = 409, .external_lex_state = 10},
  [14326] = {.lex_state = 409, .external_lex_state = 10},
  [14327] = {.lex_state = 409, .external_lex_state = 10},
  [14328] = {.lex_state = 409, .external_lex_state = 9},
  [14329] = {.lex_state = 409, .external_lex_state = 10},
  [14330] = {.lex_state = 409, .external_lex_state = 10},
  [14331] = {.lex_state = 409, .external_lex_state = 9},
  [14332] = {.lex_state = 409, .external_lex_state = 9},
  [14333] = {.lex_state = 409, .external_lex_state = 10},
  [14334] = {.lex_state = 409, .external_lex_state = 10},
  [14335] = {.lex_state = 411, .external_lex_state = 10},
  [14336] = {.lex_state = 409, .external_lex_state = 10},
  [14337] = {.lex_state = 409, .external_lex_state = 10},
  [14338] = {.lex_state = 409, .external_lex_state = 10},
  [14339] = {.lex_state = 409, .external_lex_state = 10},
  [14340] = {.lex_state = 409, .external_lex_state = 9},
  [14341] = {.lex_state = 411, .external_lex_state = 10},
  [14342] = {.lex_state = 409, .external_lex_state = 10},
  [14343] = {.lex_state = 409, .external_lex_state = 10},
  [14344] = {.lex_state = 409, .external_lex_state = 10},
  [14345] = {.lex_state = 409, .external_lex_state = 10},
  [14346] = {.lex_state = 409, .external_lex_state = 10},
  [14347] = {.lex_state = 409, .external_lex_state = 9},
  [14348] = {.lex_state = 412, .external_lex_state = 10},
  [14349] = {.lex_state = 411, .external_lex_state = 10},
  [14350] = {.lex_state = 411, .external_lex_state = 10},
  [14351] = {.lex_state = 409, .external_lex_state = 10},
  [14352] = {.lex_state = 409, .external_lex_state = 10},
  [14353] = {.lex_state = 409, .external_lex_state = 10},
  [14354] = {.lex_state = 409, .external_lex_state = 10},
  [14355] = {.lex_state = 409, .external_lex_state = 10},
  [14356] = {.lex_state = 409, .external_lex_state = 10},
  [14357] = {.lex_state = 409, .external_lex_state = 10},
  [14358] = {.lex_state = 409, .external_lex_state = 10},
  [14359] = {.lex_state = 409, .external_lex_state = 10},
  [14360] = {.lex_state = 409, .external_lex_state = 10},
  [14361] = {.lex_state = 409, .external_lex_state = 10},
  [14362] = {.lex_state = 409, .external_lex_state = 10},
  [14363] = {.lex_state = 409, .external_lex_state = 10},
  [14364] = {.lex_state = 409, .external_lex_state = 10},
  [14365] = {.lex_state = 409, .external_lex_state = 10},
  [14366] = {.lex_state = 409, .external_lex_state = 10},
  [14367] = {.lex_state = 409, .external_lex_state = 10},
  [14368] = {.lex_state = 409, .external_lex_state = 10},
  [14369] = {.lex_state = 409, .external_lex_state = 10},
  [14370] = {.lex_state = 409, .external_lex_state = 10},
  [14371] = {.lex_state = 409, .external_lex_state = 10},
  [14372] = {.lex_state = 409, .external_lex_state = 10},
  [14373] = {.lex_state = 409, .external_lex_state = 10},
  [14374] = {.lex_state = 409, .external_lex_state = 10},
  [14375] = {.lex_state = 409, .external_lex_state = 10},
  [14376] = {.lex_state = 409, .external_lex_state = 10},
  [14377] = {.lex_state = 409, .external_lex_state = 10},
  [14378] = {.lex_state = 409, .external_lex_state = 10},
  [14379] = {.lex_state = 409, .external_lex_state = 10},
  [14380] = {.lex_state = 409, .external_lex_state = 10},
  [14381] = {.lex_state = 409, .external_lex_state = 10},
  [14382] = {.lex_state = 409, .external_lex_state = 10},
  [14383] = {.lex_state = 409, .external_lex_state = 10},
  [14384] = {.lex_state = 409, .external_lex_state = 10},
  [14385] = {.lex_state = 409, .external_lex_state = 10},
  [14386] = {.lex_state = 409, .external_lex_state = 10},
  [14387] = {.lex_state = 409, .external_lex_state = 10},
  [14388] = {.lex_state = 409, .external_lex_state = 10},
  [14389] = {.lex_state = 409, .external_lex_state = 10},
  [14390] = {.lex_state = 409, .external_lex_state = 10},
  [14391] = {.lex_state = 409, .external_lex_state = 10},
  [14392] = {.lex_state = 409, .external_lex_state = 10},
  [14393] = {.lex_state = 409, .external_lex_state = 10},
  [14394] = {.lex_state = 409, .external_lex_state = 10},
  [14395] = {.lex_state = 409, .external_lex_state = 10},
  [14396] = {.lex_state = 409, .external_lex_state = 10},
  [14397] = {.lex_state = 409, .external_lex_state = 10},
  [14398] = {.lex_state = 409, .external_lex_state = 10},
  [14399] = {.lex_state = 409, .external_lex_state = 10},
  [14400] = {.lex_state = 409, .external_lex_state = 10},
  [14401] = {.lex_state = 409, .external_lex_state = 10},
  [14402] = {.lex_state = 409, .external_lex_state = 10},
  [14403] = {.lex_state = 409, .external_lex_state = 10},
  [14404] = {.lex_state = 409, .external_lex_state = 10},
  [14405] = {.lex_state = 227, .external_lex_state = 12},
  [14406] = {.lex_state = 227, .external_lex_state = 12},
  [14407] = {.lex_state = 227, .external_lex_state = 12},
  [14408] = {.lex_state = 227, .external_lex_state = 12},
  [14409] = {.lex_state = 409, .external_lex_state = 10},
  [14410] = {.lex_state = 227, .external_lex_state = 12},
  [14411] = {.lex_state = 409, .external_lex_state = 14},
  [14412] = {.lex_state = 409, .external_lex_state = 9},
  [14413] = {.lex_state = 414, .external_lex_state = 15},
  [14414] = {.lex_state = 363, .external_lex_state = 12},
  [14415] = {.lex_state = 411, .external_lex_state = 15},
  [14416] = {.lex_state = 411, .external_lex_state = 15},
  [14417] = {.lex_state = 411, .external_lex_state = 15},
  [14418] = {.lex_state = 411, .external_lex_state = 15},
  [14419] = {.lex_state = 363, .external_lex_state = 12},
  [14420] = {.lex_state = 363, .external_lex_state = 12},
  [14421] = {.lex_state = 529, .external_lex_state = 12},
  [14422] = {.lex_state = 363, .external_lex_state = 12},
  [14423] = {.lex_state = 554, .external_lex_state = 12},
  [14424] = {.lex_state = 363, .external_lex_state = 12},
  [14425] = {.lex_state = 413, .external_lex_state = 10},
  [14426] = {.lex_state = 413, .external_lex_state = 10},
  [14427] = {.lex_state = 409, .external_lex_state = 12},
  [14428] = {.lex_state = 409, .external_lex_state = 12},
  [14429] = {.lex_state = 363, .external_lex_state = 12},
  [14430] = {.lex_state = 554, .external_lex_state = 12},
  [14431] = {.lex_state = 409, .external_lex_state = 12},
  [14432] = {.lex_state = 309, .external_lex_state = 12},
  [14433] = {.lex_state = 409, .external_lex_state = 12},
  [14434] = {.lex_state = 363, .external_lex_state = 12},
  [14435] = {.lex_state = 529, .external_lex_state = 12},
  [14436] = {.lex_state = 529, .external_lex_state = 12},
  [14437] = {.lex_state = 413, .external_lex_state = 10},
  [14438] = {.lex_state = 413, .external_lex_state = 10},
  [14439] = {.lex_state = 409, .external_lex_state = 15},
  [14440] = {.lex_state = 409, .external_lex_state = 15},
  [14441] = {.lex_state = 409, .external_lex_state = 9},
  [14442] = {.lex_state = 409, .external_lex_state = 9},
  [14443] = {.lex_state = 409, .external_lex_state = 9},
  [14444] = {.lex_state = 363, .external_lex_state = 12},
  [14445] = {.lex_state = 309, .external_lex_state = 12},
  [14446] = {.lex_state = 363, .external_lex_state = 12},
  [14447] = {.lex_state = 227, .external_lex_state = 12},
  [14448] = {.lex_state = 227, .external_lex_state = 12},
  [14449] = {.lex_state = 409, .external_lex_state = 14},
  [14450] = {.lex_state = 529, .external_lex_state = 12},
  [14451] = {.lex_state = 529, .external_lex_state = 12},
  [14452] = {.lex_state = 363, .external_lex_state = 12},
  [14453] = {.lex_state = 363, .external_lex_state = 12},
  [14454] = {.lex_state = 409, .external_lex_state = 15},
  [14455] = {.lex_state = 529, .external_lex_state = 12},
  [14456] = {.lex_state = 227, .external_lex_state = 12},
  [14457] = {.lex_state = 409, .external_lex_state = 15},
  [14458] = {.lex_state = 409, .external_lex_state = 15},
  [14459] = {.lex_state = 409, .external_lex_state = 15},
  [14460] = {.lex_state = 409, .external_lex_state = 15},
  [14461] = {.lex_state = 363, .external_lex_state = 12},
  [14462] = {.lex_state = 409, .external_lex_state = 15},
  [14463] = {.lex_state = 409, .external_lex_state = 15},
  [14464] = {.lex_state = 409, .external_lex_state = 15},
  [14465] = {.lex_state = 409, .external_lex_state = 15},
  [14466] = {.lex_state = 409, .external_lex_state = 15},
  [14467] = {.lex_state = 409, .external_lex_state = 15},
  [14468] = {.lex_state = 227, .external_lex_state = 12},
  [14469] = {.lex_state = 227, .external_lex_state = 12},
  [14470] = {.lex_state = 227, .external_lex_state = 12},
  [14471] = {.lex_state = 363, .external_lex_state = 12},
  [14472] = {.lex_state = 363, .external_lex_state = 12},
  [14473] = {.lex_state = 227, .external_lex_state = 12},
  [14474] = {.lex_state = 227, .external_lex_state = 12},
  [14475] = {.lex_state = 409, .external_lex_state = 15},
  [14476] = {.lex_state = 409, .external_lex_state = 15},
  [14477] = {.lex_state = 409, .external_lex_state = 15},
  [14478] = {.lex_state = 409, .external_lex_state = 15},
  [14479] = {.lex_state = 409, .external_lex_state = 15},
  [14480] = {.lex_state = 409, .external_lex_state = 15},
  [14481] = {.lex_state = 554, .external_lex_state = 12},
  [14482] = {.lex_state = 409, .external_lex_state = 15},
  [14483] = {.lex_state = 409, .external_lex_state = 15},
  [14484] = {.lex_state = 409, .external_lex_state = 15},
  [14485] = {.lex_state = 409, .external_lex_state = 15},
  [14486] = {.lex_state = 409, .external_lex_state = 15},
  [14487] = {.lex_state = 409, .external_lex_state = 15},
  [14488] = {.lex_state = 409, .external_lex_state = 15},
  [14489] = {.lex_state = 409, .external_lex_state = 15},
  [14490] = {.lex_state = 409, .external_lex_state = 15},
  [14491] = {.lex_state = 409, .external_lex_state = 15},
  [14492] = {.lex_state = 529, .external_lex_state = 12},
  [14493] = {.lex_state = 409, .external_lex_state = 15},
  [14494] = {.lex_state = 409, .external_lex_state = 15},
  [14495] = {.lex_state = 227, .external_lex_state = 12},
  [14496] = {.lex_state = 409, .external_lex_state = 15},
  [14497] = {.lex_state = 409, .external_lex_state = 15},
  [14498] = {.lex_state = 409, .external_lex_state = 15},
  [14499] = {.lex_state = 409, .external_lex_state = 15},
  [14500] = {.lex_state = 409, .external_lex_state = 15},
  [14501] = {.lex_state = 409, .external_lex_state = 15},
  [14502] = {.lex_state = 227, .external_lex_state = 12},
  [14503] = {.lex_state = 409, .external_lex_state = 15},
  [14504] = {.lex_state = 409, .external_lex_state = 15},
  [14505] = {.lex_state = 409, .external_lex_state = 12},
  [14506] = {.lex_state = 309, .external_lex_state = 12},
  [14507] = {.lex_state = 554, .external_lex_state = 12},
  [14508] = {.lex_state = 409, .external_lex_state = 15},
  [14509] = {.lex_state = 409, .external_lex_state = 15},
  [14510] = {.lex_state = 409, .external_lex_state = 12},
  [14511] = {.lex_state = 227, .external_lex_state = 12},
  [14512] = {.lex_state = 409, .external_lex_state = 15},
  [14513] = {.lex_state = 409, .external_lex_state = 15},
  [14514] = {.lex_state = 409, .external_lex_state = 15},
  [14515] = {.lex_state = 409, .external_lex_state = 15},
  [14516] = {.lex_state = 409, .external_lex_state = 12},
  [14517] = {.lex_state = 409, .external_lex_state = 15},
  [14518] = {.lex_state = 409, .external_lex_state = 12},
  [14519] = {.lex_state = 554, .external_lex_state = 12},
  [14520] = {.lex_state = 409, .external_lex_state = 12},
  [14521] = {.lex_state = 409, .external_lex_state = 15},
  [14522] = {.lex_state = 409, .external_lex_state = 12},
  [14523] = {.lex_state = 409, .external_lex_state = 15},
  [14524] = {.lex_state = 409, .external_lex_state = 15},
  [14525] = {.lex_state = 409, .external_lex_state = 12},
  [14526] = {.lex_state = 227, .external_lex_state = 12},
  [14527] = {.lex_state = 409, .external_lex_state = 12},
  [14528] = {.lex_state = 529, .external_lex_state = 12},
  [14529] = {.lex_state = 409, .external_lex_state = 12},
  [14530] = {.lex_state = 227, .external_lex_state = 12},
  [14531] = {.lex_state = 409, .external_lex_state = 12},
  [14532] = {.lex_state = 554, .external_lex_state = 12},
  [14533] = {.lex_state = 409, .external_lex_state = 12},
  [14534] = {.lex_state = 409, .external_lex_state = 12},
  [14535] = {.lex_state = 529, .external_lex_state = 12},
  [14536] = {.lex_state = 409, .external_lex_state = 12},
  [14537] = {.lex_state = 363, .external_lex_state = 12},
  [14538] = {.lex_state = 554, .external_lex_state = 12},
  [14539] = {.lex_state = 363, .external_lex_state = 12},
  [14540] = {.lex_state = 363, .external_lex_state = 12},
  [14541] = {.lex_state = 554, .external_lex_state = 12},
  [14542] = {.lex_state = 529, .external_lex_state = 12},
  [14543] = {.lex_state = 227, .external_lex_state = 12},
  [14544] = {.lex_state = 529, .external_lex_state = 12},
  [14545] = {.lex_state = 409, .external_lex_state = 15},
  [14546] = {.lex_state = 554, .external_lex_state = 12},
  [14547] = {.lex_state = 409, .external_lex_state = 16},
  [14548] = {.lex_state = 363, .external_lex_state = 12},
  [14549] = {.lex_state = 363, .external_lex_state = 12},
  [14550] = {.lex_state = 409, .external_lex_state = 16},
  [14551] = {.lex_state = 409, .external_lex_state = 17},
  [14552] = {.lex_state = 409, .external_lex_state = 16},
  [14553] = {.lex_state = 409, .external_lex_state = 16},
  [14554] = {.lex_state = 409, .external_lex_state = 17},
  [14555] = {.lex_state = 409, .external_lex_state = 17},
  [14556] = {.lex_state = 363, .external_lex_state = 12},
  [14557] = {.lex_state = 363, .external_lex_state = 12},
  [14558] = {.lex_state = 363, .external_lex_state = 12},
  [14559] = {.lex_state = 363, .external_lex_state = 12},
  [14560] = {.lex_state = 363, .external_lex_state = 12},
  [14561] = {.lex_state = 409, .external_lex_state = 16},
  [14562] = {.lex_state = 409, .external_lex_state = 17},
  [14563] = {.lex_state = 363, .external_lex_state = 12},
  [14564] = {.lex_state = 363, .external_lex_state = 12},
  [14565] = {.lex_state = 409, .external_lex_state = 16},
  [14566] = {.lex_state = 409, .external_lex_state = 17},
  [14567] = {.lex_state = 343, .external_lex_state = 12},
  [14568] = {.lex_state = 409, .external_lex_state = 16},
  [14569] = {.lex_state = 409, .external_lex_state = 17},
  [14570] = {.lex_state = 363, .external_lex_state = 12},
  [14571] = {.lex_state = 363, .external_lex_state = 12},
  [14572] = {.lex_state = 363, .external_lex_state = 12},
  [14573] = {.lex_state = 363, .external_lex_state = 12},
  [14574] = {.lex_state = 363, .external_lex_state = 12},
  [14575] = {.lex_state = 529, .external_lex_state = 12},
  [14576] = {.lex_state = 363, .external_lex_state = 12},
  [14577] = {.lex_state = 409, .external_lex_state = 16},
  [14578] = {.lex_state = 409, .external_lex_state = 17},
  [14579] = {.lex_state = 363, .external_lex_state = 12},
  [14580] = {.lex_state = 409, .external_lex_state = 16},
  [14581] = {.lex_state = 409, .external_lex_state = 17},
  [14582] = {.lex_state = 363, .external_lex_state = 12},
  [14583] = {.lex_state = 363, .external_lex_state = 12},
  [14584] = {.lex_state = 363, .external_lex_state = 12},
  [14585] = {.lex_state = 363, .external_lex_state = 12},
  [14586] = {.lex_state = 363, .external_lex_state = 12},
  [14587] = {.lex_state = 363, .external_lex_state = 12},
  [14588] = {.lex_state = 409, .external_lex_state = 16},
  [14589] = {.lex_state = 409, .external_lex_state = 17},
  [14590] = {.lex_state = 343, .external_lex_state = 12},
  [14591] = {.lex_state = 409, .external_lex_state = 16},
  [14592] = {.lex_state = 409, .external_lex_state = 17},
  [14593] = {.lex_state = 409, .external_lex_state = 16},
  [14594] = {.lex_state = 409, .external_lex_state = 17},
  [14595] = {.lex_state = 363, .external_lex_state = 12},
  [14596] = {.lex_state = 363, .external_lex_state = 12},
  [14597] = {.lex_state = 363, .external_lex_state = 12},
  [14598] = {.lex_state = 363, .external_lex_state = 12},
  [14599] = {.lex_state = 363, .external_lex_state = 12},
  [14600] = {.lex_state = 363, .external_lex_state = 12},
  [14601] = {.lex_state = 409, .external_lex_state = 16},
  [14602] = {.lex_state = 409, .external_lex_state = 17},
  [14603] = {.lex_state = 409, .external_lex_state = 16},
  [14604] = {.lex_state = 409, .external_lex_state = 17},
  [14605] = {.lex_state = 363, .external_lex_state = 12},
  [14606] = {.lex_state = 363, .external_lex_state = 12},
  [14607] = {.lex_state = 363, .external_lex_state = 12},
  [14608] = {.lex_state = 363, .external_lex_state = 12},
  [14609] = {.lex_state = 363, .external_lex_state = 12},
  [14610] = {.lex_state = 409, .external_lex_state = 16},
  [14611] = {.lex_state = 409, .external_lex_state = 17},
  [14612] = {.lex_state = 409, .external_lex_state = 16},
  [14613] = {.lex_state = 409, .external_lex_state = 17},
  [14614] = {.lex_state = 409, .external_lex_state = 16},
  [14615] = {.lex_state = 409, .external_lex_state = 17},
  [14616] = {.lex_state = 363, .external_lex_state = 12},
  [14617] = {.lex_state = 363, .external_lex_state = 12},
  [14618] = {.lex_state = 363, .external_lex_state = 12},
  [14619] = {.lex_state = 363, .external_lex_state = 12},
  [14620] = {.lex_state = 409, .external_lex_state = 16},
  [14621] = {.lex_state = 409, .external_lex_state = 17},
  [14622] = {.lex_state = 409, .external_lex_state = 16},
  [14623] = {.lex_state = 409, .external_lex_state = 17},
  [14624] = {.lex_state = 409, .external_lex_state = 16},
  [14625] = {.lex_state = 409, .external_lex_state = 16},
  [14626] = {.lex_state = 409, .external_lex_state = 17},
  [14627] = {.lex_state = 409, .external_lex_state = 17},
  [14628] = {.lex_state = 409, .external_lex_state = 16},
  [14629] = {.lex_state = 409, .external_lex_state = 17},
  [14630] = {.lex_state = 363, .external_lex_state = 12},
  [14631] = {.lex_state = 554, .external_lex_state = 12},
  [14632] = {.lex_state = 363, .external_lex_state = 12},
  [14633] = {.lex_state = 363, .external_lex_state = 12},
  [14634] = {.lex_state = 363, .external_lex_state = 12},
  [14635] = {.lex_state = 363, .external_lex_state = 12},
  [14636] = {.lex_state = 409, .external_lex_state = 16},
  [14637] = {.lex_state = 409, .external_lex_state = 17},
  [14638] = {.lex_state = 231, .external_lex_state = 12},
  [14639] = {.lex_state = 409, .external_lex_state = 16},
  [14640] = {.lex_state = 409, .external_lex_state = 17},
  [14641] = {.lex_state = 363, .external_lex_state = 12},
  [14642] = {.lex_state = 363, .external_lex_state = 12},
  [14643] = {.lex_state = 409, .external_lex_state = 16},
  [14644] = {.lex_state = 409, .external_lex_state = 17},
  [14645] = {.lex_state = 343, .external_lex_state = 12},
  [14646] = {.lex_state = 363, .external_lex_state = 12},
  [14647] = {.lex_state = 363, .external_lex_state = 12},
  [14648] = {.lex_state = 363, .external_lex_state = 12},
  [14649] = {.lex_state = 554, .external_lex_state = 12},
  [14650] = {.lex_state = 363, .external_lex_state = 12},
  [14651] = {.lex_state = 363, .external_lex_state = 12},
  [14652] = {.lex_state = 409, .external_lex_state = 16},
  [14653] = {.lex_state = 409, .external_lex_state = 17},
  [14654] = {.lex_state = 409, .external_lex_state = 16},
  [14655] = {.lex_state = 409, .external_lex_state = 17},
  [14656] = {.lex_state = 409, .external_lex_state = 16},
  [14657] = {.lex_state = 409, .external_lex_state = 17},
  [14658] = {.lex_state = 231, .external_lex_state = 12},
  [14659] = {.lex_state = 363, .external_lex_state = 12},
  [14660] = {.lex_state = 363, .external_lex_state = 12},
  [14661] = {.lex_state = 363, .external_lex_state = 12},
  [14662] = {.lex_state = 363, .external_lex_state = 12},
  [14663] = {.lex_state = 409, .external_lex_state = 16},
  [14664] = {.lex_state = 409, .external_lex_state = 16},
  [14665] = {.lex_state = 363, .external_lex_state = 12},
  [14666] = {.lex_state = 409, .external_lex_state = 16},
  [14667] = {.lex_state = 409, .external_lex_state = 17},
  [14668] = {.lex_state = 409, .external_lex_state = 16},
  [14669] = {.lex_state = 409, .external_lex_state = 17},
  [14670] = {.lex_state = 363, .external_lex_state = 12},
  [14671] = {.lex_state = 363, .external_lex_state = 12},
  [14672] = {.lex_state = 363, .external_lex_state = 12},
  [14673] = {.lex_state = 363, .external_lex_state = 12},
  [14674] = {.lex_state = 409, .external_lex_state = 17},
  [14675] = {.lex_state = 363, .external_lex_state = 12},
  [14676] = {.lex_state = 363, .external_lex_state = 12},
  [14677] = {.lex_state = 409, .external_lex_state = 16},
  [14678] = {.lex_state = 409, .external_lex_state = 17},
  [14679] = {.lex_state = 409, .external_lex_state = 16},
  [14680] = {.lex_state = 409, .external_lex_state = 17},
  [14681] = {.lex_state = 363, .external_lex_state = 12},
  [14682] = {.lex_state = 363, .external_lex_state = 12},
  [14683] = {.lex_state = 363, .external_lex_state = 12},
  [14684] = {.lex_state = 363, .external_lex_state = 12},
  [14685] = {.lex_state = 363, .external_lex_state = 12},
  [14686] = {.lex_state = 409, .external_lex_state = 17},
  [14687] = {.lex_state = 343, .external_lex_state = 12},
  [14688] = {.lex_state = 343, .external_lex_state = 12},
  [14689] = {.lex_state = 409, .external_lex_state = 16},
  [14690] = {.lex_state = 409, .external_lex_state = 17},
  [14691] = {.lex_state = 409, .external_lex_state = 16},
  [14692] = {.lex_state = 409, .external_lex_state = 17},
  [14693] = {.lex_state = 409, .external_lex_state = 16},
  [14694] = {.lex_state = 363, .external_lex_state = 12},
  [14695] = {.lex_state = 409, .external_lex_state = 17},
  [14696] = {.lex_state = 363, .external_lex_state = 12},
  [14697] = {.lex_state = 363, .external_lex_state = 12},
  [14698] = {.lex_state = 363, .external_lex_state = 12},
  [14699] = {.lex_state = 363, .external_lex_state = 12},
  [14700] = {.lex_state = 363, .external_lex_state = 12},
  [14701] = {.lex_state = 409, .external_lex_state = 16},
  [14702] = {.lex_state = 409, .external_lex_state = 17},
  [14703] = {.lex_state = 409, .external_lex_state = 16},
  [14704] = {.lex_state = 409, .external_lex_state = 17},
  [14705] = {.lex_state = 363, .external_lex_state = 12},
  [14706] = {.lex_state = 409, .external_lex_state = 16},
  [14707] = {.lex_state = 363, .external_lex_state = 12},
  [14708] = {.lex_state = 363, .external_lex_state = 12},
  [14709] = {.lex_state = 363, .external_lex_state = 12},
  [14710] = {.lex_state = 363, .external_lex_state = 12},
  [14711] = {.lex_state = 363, .external_lex_state = 12},
  [14712] = {.lex_state = 409, .external_lex_state = 17},
  [14713] = {.lex_state = 409, .external_lex_state = 16},
  [14714] = {.lex_state = 409, .external_lex_state = 17},
  [14715] = {.lex_state = 409, .external_lex_state = 16},
  [14716] = {.lex_state = 409, .external_lex_state = 17},
  [14717] = {.lex_state = 309, .external_lex_state = 12},
  [14718] = {.lex_state = 363, .external_lex_state = 12},
  [14719] = {.lex_state = 363, .external_lex_state = 12},
  [14720] = {.lex_state = 409, .external_lex_state = 16},
  [14721] = {.lex_state = 363, .external_lex_state = 12},
  [14722] = {.lex_state = 409, .external_lex_state = 16},
  [14723] = {.lex_state = 409, .external_lex_state = 17},
  [14724] = {.lex_state = 409, .external_lex_state = 16},
  [14725] = {.lex_state = 409, .external_lex_state = 17},
  [14726] = {.lex_state = 409, .external_lex_state = 17},
  [14727] = {.lex_state = 363, .external_lex_state = 12},
  [14728] = {.lex_state = 363, .external_lex_state = 12},
  [14729] = {.lex_state = 363, .external_lex_state = 12},
  [14730] = {.lex_state = 363, .external_lex_state = 12},
  [14731] = {.lex_state = 363, .external_lex_state = 12},
  [14732] = {.lex_state = 363, .external_lex_state = 12},
  [14733] = {.lex_state = 409, .external_lex_state = 16},
  [14734] = {.lex_state = 409, .external_lex_state = 17},
  [14735] = {.lex_state = 409, .external_lex_state = 16},
  [14736] = {.lex_state = 409, .external_lex_state = 17},
  [14737] = {.lex_state = 363, .external_lex_state = 12},
  [14738] = {.lex_state = 363, .external_lex_state = 12},
  [14739] = {.lex_state = 363, .external_lex_state = 12},
  [14740] = {.lex_state = 343, .external_lex_state = 12},
  [14741] = {.lex_state = 409, .external_lex_state = 16},
  [14742] = {.lex_state = 409, .external_lex_state = 17},
  [14743] = {.lex_state = 409, .external_lex_state = 16},
  [14744] = {.lex_state = 409, .external_lex_state = 17},
  [14745] = {.lex_state = 363, .external_lex_state = 12},
  [14746] = {.lex_state = 363, .external_lex_state = 12},
  [14747] = {.lex_state = 363, .external_lex_state = 12},
  [14748] = {.lex_state = 363, .external_lex_state = 12},
  [14749] = {.lex_state = 363, .external_lex_state = 12},
  [14750] = {.lex_state = 363, .external_lex_state = 12},
  [14751] = {.lex_state = 343, .external_lex_state = 12},
  [14752] = {.lex_state = 409, .external_lex_state = 16},
  [14753] = {.lex_state = 409, .external_lex_state = 17},
  [14754] = {.lex_state = 409, .external_lex_state = 16},
  [14755] = {.lex_state = 409, .external_lex_state = 17},
  [14756] = {.lex_state = 363, .external_lex_state = 12},
  [14757] = {.lex_state = 363, .external_lex_state = 12},
  [14758] = {.lex_state = 363, .external_lex_state = 12},
  [14759] = {.lex_state = 363, .external_lex_state = 12},
  [14760] = {.lex_state = 363, .external_lex_state = 12},
  [14761] = {.lex_state = 409, .external_lex_state = 16},
  [14762] = {.lex_state = 409, .external_lex_state = 17},
  [14763] = {.lex_state = 409, .external_lex_state = 16},
  [14764] = {.lex_state = 409, .external_lex_state = 17},
  [14765] = {.lex_state = 363, .external_lex_state = 12},
  [14766] = {.lex_state = 363, .external_lex_state = 12},
  [14767] = {.lex_state = 409, .external_lex_state = 16},
  [14768] = {.lex_state = 363, .external_lex_state = 12},
  [14769] = {.lex_state = 363, .external_lex_state = 12},
  [14770] = {.lex_state = 409, .external_lex_state = 17},
  [14771] = {.lex_state = 363, .external_lex_state = 12},
  [14772] = {.lex_state = 343, .external_lex_state = 12},
  [14773] = {.lex_state = 554, .external_lex_state = 12},
  [14774] = {.lex_state = 409, .external_lex_state = 16},
  [14775] = {.lex_state = 409, .external_lex_state = 17},
  [14776] = {.lex_state = 409, .external_lex_state = 16},
  [14777] = {.lex_state = 409, .external_lex_state = 17},
  [14778] = {.lex_state = 409, .external_lex_state = 16},
  [14779] = {.lex_state = 409, .external_lex_state = 17},
  [14780] = {.lex_state = 363, .external_lex_state = 12},
  [14781] = {.lex_state = 363, .external_lex_state = 12},
  [14782] = {.lex_state = 363, .external_lex_state = 12},
  [14783] = {.lex_state = 363, .external_lex_state = 12},
  [14784] = {.lex_state = 363, .external_lex_state = 12},
  [14785] = {.lex_state = 409, .external_lex_state = 16},
  [14786] = {.lex_state = 409, .external_lex_state = 17},
  [14787] = {.lex_state = 409, .external_lex_state = 16},
  [14788] = {.lex_state = 409, .external_lex_state = 17},
  [14789] = {.lex_state = 363, .external_lex_state = 12},
  [14790] = {.lex_state = 363, .external_lex_state = 12},
  [14791] = {.lex_state = 409, .external_lex_state = 16},
  [14792] = {.lex_state = 409, .external_lex_state = 17},
  [14793] = {.lex_state = 363, .external_lex_state = 12},
  [14794] = {.lex_state = 363, .external_lex_state = 12},
  [14795] = {.lex_state = 363, .external_lex_state = 12},
  [14796] = {.lex_state = 343, .external_lex_state = 12},
  [14797] = {.lex_state = 409, .external_lex_state = 16},
  [14798] = {.lex_state = 409, .external_lex_state = 17},
  [14799] = {.lex_state = 409, .external_lex_state = 16},
  [14800] = {.lex_state = 409, .external_lex_state = 17},
  [14801] = {.lex_state = 363, .external_lex_state = 12},
  [14802] = {.lex_state = 409, .external_lex_state = 16},
  [14803] = {.lex_state = 409, .external_lex_state = 17},
  [14804] = {.lex_state = 363, .external_lex_state = 12},
  [14805] = {.lex_state = 363, .external_lex_state = 12},
  [14806] = {.lex_state = 363, .external_lex_state = 12},
  [14807] = {.lex_state = 363, .external_lex_state = 12},
  [14808] = {.lex_state = 363, .external_lex_state = 12},
  [14809] = {.lex_state = 409, .external_lex_state = 16},
  [14810] = {.lex_state = 409, .external_lex_state = 17},
  [14811] = {.lex_state = 409, .external_lex_state = 16},
  [14812] = {.lex_state = 409, .external_lex_state = 17},
  [14813] = {.lex_state = 363, .external_lex_state = 12},
  [14814] = {.lex_state = 363, .external_lex_state = 12},
  [14815] = {.lex_state = 363, .external_lex_state = 12},
  [14816] = {.lex_state = 363, .external_lex_state = 12},
  [14817] = {.lex_state = 363, .external_lex_state = 12},
  [14818] = {.lex_state = 363, .external_lex_state = 12},
  [14819] = {.lex_state = 409, .external_lex_state = 16},
  [14820] = {.lex_state = 409, .external_lex_state = 17},
  [14821] = {.lex_state = 409, .external_lex_state = 16},
  [14822] = {.lex_state = 409, .external_lex_state = 17},
  [14823] = {.lex_state = 363, .external_lex_state = 12},
  [14824] = {.lex_state = 363, .external_lex_state = 12},
  [14825] = {.lex_state = 363, .external_lex_state = 12},
  [14826] = {.lex_state = 363, .external_lex_state = 12},
  [14827] = {.lex_state = 363, .external_lex_state = 12},
  [14828] = {.lex_state = 343, .external_lex_state = 12},
  [14829] = {.lex_state = 409, .external_lex_state = 16},
  [14830] = {.lex_state = 409, .external_lex_state = 17},
  [14831] = {.lex_state = 409, .external_lex_state = 16},
  [14832] = {.lex_state = 409, .external_lex_state = 17},
  [14833] = {.lex_state = 363, .external_lex_state = 12},
  [14834] = {.lex_state = 363, .external_lex_state = 12},
  [14835] = {.lex_state = 363, .external_lex_state = 12},
  [14836] = {.lex_state = 363, .external_lex_state = 12},
  [14837] = {.lex_state = 409, .external_lex_state = 16},
  [14838] = {.lex_state = 409, .external_lex_state = 17},
  [14839] = {.lex_state = 409, .external_lex_state = 16},
  [14840] = {.lex_state = 409, .external_lex_state = 17},
  [14841] = {.lex_state = 363, .external_lex_state = 12},
  [14842] = {.lex_state = 363, .external_lex_state = 12},
  [14843] = {.lex_state = 363, .external_lex_state = 12},
  [14844] = {.lex_state = 363, .external_lex_state = 12},
  [14845] = {.lex_state = 363, .external_lex_state = 12},
  [14846] = {.lex_state = 409, .external_lex_state = 16},
  [14847] = {.lex_state = 409, .external_lex_state = 17},
  [14848] = {.lex_state = 363, .external_lex_state = 12},
  [14849] = {.lex_state = 409, .external_lex_state = 16},
  [14850] = {.lex_state = 409, .external_lex_state = 17},
  [14851] = {.lex_state = 363, .external_lex_state = 12},
  [14852] = {.lex_state = 363, .external_lex_state = 12},
  [14853] = {.lex_state = 363, .external_lex_state = 12},
  [14854] = {.lex_state = 363, .external_lex_state = 12},
  [14855] = {.lex_state = 409, .external_lex_state = 16},
  [14856] = {.lex_state = 409, .external_lex_state = 17},
  [14857] = {.lex_state = 343, .external_lex_state = 12},
  [14858] = {.lex_state = 409, .external_lex_state = 16},
  [14859] = {.lex_state = 409, .external_lex_state = 17},
  [14860] = {.lex_state = 363, .external_lex_state = 12},
  [14861] = {.lex_state = 363, .external_lex_state = 12},
  [14862] = {.lex_state = 363, .external_lex_state = 12},
  [14863] = {.lex_state = 363, .external_lex_state = 12},
  [14864] = {.lex_state = 409, .external_lex_state = 16},
  [14865] = {.lex_state = 409, .external_lex_state = 17},
  [14866] = {.lex_state = 363, .external_lex_state = 12},
  [14867] = {.lex_state = 409, .external_lex_state = 16},
  [14868] = {.lex_state = 409, .external_lex_state = 17},
  [14869] = {.lex_state = 363, .external_lex_state = 12},
  [14870] = {.lex_state = 363, .external_lex_state = 12},
  [14871] = {.lex_state = 363, .external_lex_state = 12},
  [14872] = {.lex_state = 363, .external_lex_state = 12},
  [14873] = {.lex_state = 409, .external_lex_state = 16},
  [14874] = {.lex_state = 409, .external_lex_state = 17},
  [14875] = {.lex_state = 409, .external_lex_state = 16},
  [14876] = {.lex_state = 409, .external_lex_state = 17},
  [14877] = {.lex_state = 363, .external_lex_state = 12},
  [14878] = {.lex_state = 363, .external_lex_state = 12},
  [14879] = {.lex_state = 363, .external_lex_state = 12},
  [14880] = {.lex_state = 409, .external_lex_state = 17},
  [14881] = {.lex_state = 409, .external_lex_state = 16},
  [14882] = {.lex_state = 409, .external_lex_state = 17},
  [14883] = {.lex_state = 409, .external_lex_state = 16},
  [14884] = {.lex_state = 409, .external_lex_state = 17},
  [14885] = {.lex_state = 363, .external_lex_state = 12},
  [14886] = {.lex_state = 363, .external_lex_state = 12},
  [14887] = {.lex_state = 231, .external_lex_state = 12},
  [14888] = {.lex_state = 363, .external_lex_state = 12},
  [14889] = {.lex_state = 409, .external_lex_state = 16},
  [14890] = {.lex_state = 409, .external_lex_state = 17},
  [14891] = {.lex_state = 409, .external_lex_state = 16},
  [14892] = {.lex_state = 409, .external_lex_state = 17},
  [14893] = {.lex_state = 409, .external_lex_state = 16},
  [14894] = {.lex_state = 409, .external_lex_state = 17},
  [14895] = {.lex_state = 363, .external_lex_state = 12},
  [14896] = {.lex_state = 363, .external_lex_state = 12},
  [14897] = {.lex_state = 363, .external_lex_state = 12},
  [14898] = {.lex_state = 409, .external_lex_state = 16},
  [14899] = {.lex_state = 409, .external_lex_state = 17},
  [14900] = {.lex_state = 409, .external_lex_state = 16},
  [14901] = {.lex_state = 343, .external_lex_state = 12},
  [14902] = {.lex_state = 409, .external_lex_state = 16},
  [14903] = {.lex_state = 409, .external_lex_state = 17},
  [14904] = {.lex_state = 409, .external_lex_state = 16},
  [14905] = {.lex_state = 409, .external_lex_state = 17},
  [14906] = {.lex_state = 363, .external_lex_state = 12},
  [14907] = {.lex_state = 363, .external_lex_state = 12},
  [14908] = {.lex_state = 409, .external_lex_state = 17},
  [14909] = {.lex_state = 363, .external_lex_state = 12},
  [14910] = {.lex_state = 409, .external_lex_state = 16},
  [14911] = {.lex_state = 409, .external_lex_state = 17},
  [14912] = {.lex_state = 363, .external_lex_state = 12},
  [14913] = {.lex_state = 409, .external_lex_state = 16},
  [14914] = {.lex_state = 409, .external_lex_state = 17},
  [14915] = {.lex_state = 409, .external_lex_state = 16},
  [14916] = {.lex_state = 363, .external_lex_state = 12},
  [14917] = {.lex_state = 363, .external_lex_state = 12},
  [14918] = {.lex_state = 409, .external_lex_state = 17},
  [14919] = {.lex_state = 409, .external_lex_state = 16},
  [14920] = {.lex_state = 363, .external_lex_state = 12},
  [14921] = {.lex_state = 409, .external_lex_state = 16},
  [14922] = {.lex_state = 363, .external_lex_state = 12},
  [14923] = {.lex_state = 409, .external_lex_state = 16},
  [14924] = {.lex_state = 409, .external_lex_state = 16},
  [14925] = {.lex_state = 363, .external_lex_state = 12},
  [14926] = {.lex_state = 409, .external_lex_state = 16},
  [14927] = {.lex_state = 409, .external_lex_state = 17},
  [14928] = {.lex_state = 409, .external_lex_state = 16},
  [14929] = {.lex_state = 363, .external_lex_state = 12},
  [14930] = {.lex_state = 363, .external_lex_state = 12},
  [14931] = {.lex_state = 409, .external_lex_state = 17},
  [14932] = {.lex_state = 363, .external_lex_state = 12},
  [14933] = {.lex_state = 363, .external_lex_state = 12},
  [14934] = {.lex_state = 409, .external_lex_state = 16},
  [14935] = {.lex_state = 409, .external_lex_state = 17},
  [14936] = {.lex_state = 363, .external_lex_state = 12},
  [14937] = {.lex_state = 409, .external_lex_state = 16},
  [14938] = {.lex_state = 409, .external_lex_state = 17},
  [14939] = {.lex_state = 363, .external_lex_state = 12},
  [14940] = {.lex_state = 363, .external_lex_state = 12},
  [14941] = {.lex_state = 409, .external_lex_state = 17},
  [14942] = {.lex_state = 343, .external_lex_state = 12},
  [14943] = {.lex_state = 363, .external_lex_state = 12},
  [14944] = {.lex_state = 363, .external_lex_state = 12},
  [14945] = {.lex_state = 363, .external_lex_state = 12},
  [14946] = {.lex_state = 363, .external_lex_state = 12},
  [14947] = {.lex_state = 363, .external_lex_state = 12},
  [14948] = {.lex_state = 343, .external_lex_state = 12},
  [14949] = {.lex_state = 409, .external_lex_state = 16},
  [14950] = {.lex_state = 363, .external_lex_state = 12},
  [14951] = {.lex_state = 363, .external_lex_state = 12},
  [14952] = {.lex_state = 363, .external_lex_state = 12},
  [14953] = {.lex_state = 554, .external_lex_state = 12},
  [14954] = {.lex_state = 363, .external_lex_state = 12},
  [14955] = {.lex_state = 363, .external_lex_state = 12},
  [14956] = {.lex_state = 409, .external_lex_state = 17},
  [14957] = {.lex_state = 363, .external_lex_state = 12},
  [14958] = {.lex_state = 363, .external_lex_state = 12},
  [14959] = {.lex_state = 409, .external_lex_state = 17},
  [14960] = {.lex_state = 409, .external_lex_state = 16},
  [14961] = {.lex_state = 343, .external_lex_state = 12},
  [14962] = {.lex_state = 409, .external_lex_state = 17},
  [14963] = {.lex_state = 363, .external_lex_state = 12},
  [14964] = {.lex_state = 409, .external_lex_state = 16},
  [14965] = {.lex_state = 554, .external_lex_state = 12},
  [14966] = {.lex_state = 409, .external_lex_state = 17},
  [14967] = {.lex_state = 409, .external_lex_state = 16},
  [14968] = {.lex_state = 409, .external_lex_state = 16},
  [14969] = {.lex_state = 409, .external_lex_state = 17},
  [14970] = {.lex_state = 409, .external_lex_state = 16},
  [14971] = {.lex_state = 409, .external_lex_state = 17},
  [14972] = {.lex_state = 363, .external_lex_state = 12},
  [14973] = {.lex_state = 409, .external_lex_state = 16},
  [14974] = {.lex_state = 409, .external_lex_state = 17},
  [14975] = {.lex_state = 363, .external_lex_state = 12},
  [14976] = {.lex_state = 409, .external_lex_state = 16},
  [14977] = {.lex_state = 409, .external_lex_state = 17},
  [14978] = {.lex_state = 409, .external_lex_state = 17},
  [14979] = {.lex_state = 363, .external_lex_state = 12},
  [14980] = {.lex_state = 554, .external_lex_state = 12},
  [14981] = {.lex_state = 343, .external_lex_state = 12},
  [14982] = {.lex_state = 409, .external_lex_state = 16},
  [14983] = {.lex_state = 409, .external_lex_state = 17},
  [14984] = {.lex_state = 363, .external_lex_state = 12},
  [14985] = {.lex_state = 363, .external_lex_state = 12},
  [14986] = {.lex_state = 343, .external_lex_state = 12},
  [14987] = {.lex_state = 409, .external_lex_state = 16},
  [14988] = {.lex_state = 409, .external_lex_state = 17},
  [14989] = {.lex_state = 363, .external_lex_state = 12},
  [14990] = {.lex_state = 409, .external_lex_state = 16},
  [14991] = {.lex_state = 554, .external_lex_state = 12},
  [14992] = {.lex_state = 409, .external_lex_state = 16},
  [14993] = {.lex_state = 409, .external_lex_state = 17},
  [14994] = {.lex_state = 409, .external_lex_state = 17},
  [14995] = {.lex_state = 363, .external_lex_state = 12},
  [14996] = {.lex_state = 363, .external_lex_state = 12},
  [14997] = {.lex_state = 363, .external_lex_state = 12},
  [14998] = {.lex_state = 409, .external_lex_state = 16},
  [14999] = {.lex_state = 409, .external_lex_state = 17},
  [15000] = {.lex_state = 363, .external_lex_state = 12},
  [15001] = {.lex_state = 363, .external_lex_state = 12},
  [15002] = {.lex_state = 363, .external_lex_state = 12},
  [15003] = {.lex_state = 363, .external_lex_state = 12},
  [15004] = {.lex_state = 343, .external_lex_state = 12},
  [15005] = {.lex_state = 343, .external_lex_state = 12},
  [15006] = {.lex_state = 363, .external_lex_state = 12},
  [15007] = {.lex_state = 409, .external_lex_state = 16},
  [15008] = {.lex_state = 409, .external_lex_state = 17},
  [15009] = {.lex_state = 363, .external_lex_state = 12},
  [15010] = {.lex_state = 363, .external_lex_state = 12},
  [15011] = {.lex_state = 409, .external_lex_state = 16},
  [15012] = {.lex_state = 409, .external_lex_state = 17},
  [15013] = {.lex_state = 363, .external_lex_state = 12},
  [15014] = {.lex_state = 363, .external_lex_state = 12},
  [15015] = {.lex_state = 409, .external_lex_state = 10},
  [15016] = {.lex_state = 529, .external_lex_state = 12},
  [15017] = {.lex_state = 363, .external_lex_state = 12},
  [15018] = {.lex_state = 343, .external_lex_state = 12},
  [15019] = {.lex_state = 409, .external_lex_state = 16},
  [15020] = {.lex_state = 409, .external_lex_state = 17},
  [15021] = {.lex_state = 409, .external_lex_state = 16},
  [15022] = {.lex_state = 363, .external_lex_state = 12},
  [15023] = {.lex_state = 363, .external_lex_state = 12},
  [15024] = {.lex_state = 409, .external_lex_state = 17},
  [15025] = {.lex_state = 409, .external_lex_state = 16},
  [15026] = {.lex_state = 363, .external_lex_state = 12},
  [15027] = {.lex_state = 363, .external_lex_state = 12},
  [15028] = {.lex_state = 343, .external_lex_state = 12},
  [15029] = {.lex_state = 363, .external_lex_state = 12},
  [15030] = {.lex_state = 363, .external_lex_state = 12},
  [15031] = {.lex_state = 409, .external_lex_state = 17},
  [15032] = {.lex_state = 409, .external_lex_state = 16},
  [15033] = {.lex_state = 409, .external_lex_state = 17},
  [15034] = {.lex_state = 409, .external_lex_state = 17},
  [15035] = {.lex_state = 363, .external_lex_state = 12},
  [15036] = {.lex_state = 409, .external_lex_state = 16},
  [15037] = {.lex_state = 363, .external_lex_state = 12},
  [15038] = {.lex_state = 363, .external_lex_state = 12},
  [15039] = {.lex_state = 409, .external_lex_state = 16},
  [15040] = {.lex_state = 409, .external_lex_state = 17},
  [15041] = {.lex_state = 343, .external_lex_state = 12},
  [15042] = {.lex_state = 409, .external_lex_state = 16},
  [15043] = {.lex_state = 409, .external_lex_state = 17},
  [15044] = {.lex_state = 409, .external_lex_state = 16},
  [15045] = {.lex_state = 409, .external_lex_state = 17},
  [15046] = {.lex_state = 409, .external_lex_state = 17},
  [15047] = {.lex_state = 363, .external_lex_state = 12},
  [15048] = {.lex_state = 363, .external_lex_state = 12},
  [15049] = {.lex_state = 363, .external_lex_state = 12},
  [15050] = {.lex_state = 363, .external_lex_state = 12},
  [15051] = {.lex_state = 409, .external_lex_state = 16},
  [15052] = {.lex_state = 363, .external_lex_state = 12},
  [15053] = {.lex_state = 363, .external_lex_state = 12},
  [15054] = {.lex_state = 343, .external_lex_state = 12},
  [15055] = {.lex_state = 363, .external_lex_state = 12},
  [15056] = {.lex_state = 409, .external_lex_state = 17},
  [15057] = {.lex_state = 363, .external_lex_state = 12},
  [15058] = {.lex_state = 363, .external_lex_state = 12},
  [15059] = {.lex_state = 343, .external_lex_state = 12},
  [15060] = {.lex_state = 363, .external_lex_state = 12},
  [15061] = {.lex_state = 363, .external_lex_state = 12},
  [15062] = {.lex_state = 363, .external_lex_state = 12},
  [15063] = {.lex_state = 363, .external_lex_state = 12},
  [15064] = {.lex_state = 363, .external_lex_state = 12},
  [15065] = {.lex_state = 363, .external_lex_state = 12},
  [15066] = {.lex_state = 363, .external_lex_state = 12},
  [15067] = {.lex_state = 363, .external_lex_state = 12},
  [15068] = {.lex_state = 363, .external_lex_state = 12},
  [15069] = {.lex_state = 409, .external_lex_state = 16},
  [15070] = {.lex_state = 409, .external_lex_state = 17},
  [15071] = {.lex_state = 409, .external_lex_state = 16},
  [15072] = {.lex_state = 409, .external_lex_state = 16},
  [15073] = {.lex_state = 409, .external_lex_state = 17},
  [15074] = {.lex_state = 363, .external_lex_state = 12},
  [15075] = {.lex_state = 343, .external_lex_state = 12},
  [15076] = {.lex_state = 363, .external_lex_state = 12},
  [15077] = {.lex_state = 363, .external_lex_state = 12},
  [15078] = {.lex_state = 363, .external_lex_state = 12},
  [15079] = {.lex_state = 343, .external_lex_state = 12},
  [15080] = {.lex_state = 409, .external_lex_state = 16},
  [15081] = {.lex_state = 409, .external_lex_state = 17},
  [15082] = {.lex_state = 363, .external_lex_state = 12},
  [15083] = {.lex_state = 363, .external_lex_state = 12},
  [15084] = {.lex_state = 363, .external_lex_state = 12},
  [15085] = {.lex_state = 363, .external_lex_state = 12},
  [15086] = {.lex_state = 409, .external_lex_state = 16},
  [15087] = {.lex_state = 409, .external_lex_state = 17},
  [15088] = {.lex_state = 409, .external_lex_state = 16},
  [15089] = {.lex_state = 343, .external_lex_state = 12},
  [15090] = {.lex_state = 554, .external_lex_state = 12},
  [15091] = {.lex_state = 363, .external_lex_state = 12},
  [15092] = {.lex_state = 363, .external_lex_state = 12},
  [15093] = {.lex_state = 363, .external_lex_state = 12},
  [15094] = {.lex_state = 409, .external_lex_state = 16},
  [15095] = {.lex_state = 409, .external_lex_state = 17},
  [15096] = {.lex_state = 363, .external_lex_state = 12},
  [15097] = {.lex_state = 363, .external_lex_state = 12},
  [15098] = {.lex_state = 343, .external_lex_state = 12},
  [15099] = {.lex_state = 409, .external_lex_state = 16},
  [15100] = {.lex_state = 363, .external_lex_state = 12},
  [15101] = {.lex_state = 409, .external_lex_state = 16},
  [15102] = {.lex_state = 363, .external_lex_state = 12},
  [15103] = {.lex_state = 409, .external_lex_state = 17},
  [15104] = {.lex_state = 409, .external_lex_state = 17},
  [15105] = {.lex_state = 343, .external_lex_state = 12},
  [15106] = {.lex_state = 409, .external_lex_state = 16},
  [15107] = {.lex_state = 409, .external_lex_state = 17},
  [15108] = {.lex_state = 363, .external_lex_state = 12},
  [15109] = {.lex_state = 554, .external_lex_state = 12},
  [15110] = {.lex_state = 363, .external_lex_state = 12},
  [15111] = {.lex_state = 363, .external_lex_state = 12},
  [15112] = {.lex_state = 409, .external_lex_state = 17},
  [15113] = {.lex_state = 363, .external_lex_state = 12},
  [15114] = {.lex_state = 363, .external_lex_state = 12},
  [15115] = {.lex_state = 363, .external_lex_state = 12},
  [15116] = {.lex_state = 343, .external_lex_state = 12},
  [15117] = {.lex_state = 363, .external_lex_state = 12},
  [15118] = {.lex_state = 363, .external_lex_state = 12},
  [15119] = {.lex_state = 363, .external_lex_state = 12},
  [15120] = {.lex_state = 529, .external_lex_state = 12},
  [15121] = {.lex_state = 363, .external_lex_state = 12},
  [15122] = {.lex_state = 343, .external_lex_state = 12},
  [15123] = {.lex_state = 409, .external_lex_state = 17},
  [15124] = {.lex_state = 363, .external_lex_state = 12},
  [15125] = {.lex_state = 409, .external_lex_state = 16},
  [15126] = {.lex_state = 409, .external_lex_state = 17},
  [15127] = {.lex_state = 363, .external_lex_state = 12},
  [15128] = {.lex_state = 363, .external_lex_state = 12},
  [15129] = {.lex_state = 409, .external_lex_state = 16},
  [15130] = {.lex_state = 409, .external_lex_state = 17},
  [15131] = {.lex_state = 409, .external_lex_state = 16},
  [15132] = {.lex_state = 409, .external_lex_state = 17},
  [15133] = {.lex_state = 409, .external_lex_state = 16},
  [15134] = {.lex_state = 409, .external_lex_state = 17},
  [15135] = {.lex_state = 363, .external_lex_state = 12},
  [15136] = {.lex_state = 363, .external_lex_state = 12},
  [15137] = {.lex_state = 309, .external_lex_state = 12},
  [15138] = {.lex_state = 363, .external_lex_state = 12},
  [15139] = {.lex_state = 363, .external_lex_state = 12},
  [15140] = {.lex_state = 343, .external_lex_state = 12},
  [15141] = {.lex_state = 363, .external_lex_state = 12},
  [15142] = {.lex_state = 363, .external_lex_state = 12},
  [15143] = {.lex_state = 409, .external_lex_state = 16},
  [15144] = {.lex_state = 409, .external_lex_state = 17},
  [15145] = {.lex_state = 343, .external_lex_state = 12},
  [15146] = {.lex_state = 343, .external_lex_state = 12},
  [15147] = {.lex_state = 343, .external_lex_state = 12},
  [15148] = {.lex_state = 363, .external_lex_state = 12},
  [15149] = {.lex_state = 363, .external_lex_state = 12},
  [15150] = {.lex_state = 343, .external_lex_state = 12},
  [15151] = {.lex_state = 343, .external_lex_state = 12},
  [15152] = {.lex_state = 343, .external_lex_state = 12},
  [15153] = {.lex_state = 343, .external_lex_state = 12},
  [15154] = {.lex_state = 363, .external_lex_state = 12},
  [15155] = {.lex_state = 343, .external_lex_state = 12},
  [15156] = {.lex_state = 409, .external_lex_state = 16},
  [15157] = {.lex_state = 409, .external_lex_state = 17},
  [15158] = {.lex_state = 343, .external_lex_state = 12},
  [15159] = {.lex_state = 409, .external_lex_state = 16},
  [15160] = {.lex_state = 409, .external_lex_state = 17},
  [15161] = {.lex_state = 363, .external_lex_state = 12},
  [15162] = {.lex_state = 343, .external_lex_state = 12},
  [15163] = {.lex_state = 409, .external_lex_state = 16},
  [15164] = {.lex_state = 409, .external_lex_state = 17},
  [15165] = {.lex_state = 343, .external_lex_state = 12},
  [15166] = {.lex_state = 363, .external_lex_state = 12},
  [15167] = {.lex_state = 363, .external_lex_state = 12},
  [15168] = {.lex_state = 343, .external_lex_state = 12},
  [15169] = {.lex_state = 343, .external_lex_state = 12},
  [15170] = {.lex_state = 343, .external_lex_state = 12},
  [15171] = {.lex_state = 363, .external_lex_state = 12},
  [15172] = {.lex_state = 343, .external_lex_state = 12},
  [15173] = {.lex_state = 343, .external_lex_state = 12},
  [15174] = {.lex_state = 343, .external_lex_state = 12},
  [15175] = {.lex_state = 343, .external_lex_state = 12},
  [15176] = {.lex_state = 363, .external_lex_state = 12},
  [15177] = {.lex_state = 363, .external_lex_state = 12},
  [15178] = {.lex_state = 343, .external_lex_state = 12},
  [15179] = {.lex_state = 409, .external_lex_state = 17},
  [15180] = {.lex_state = 364, .external_lex_state = 12},
  [15181] = {.lex_state = 0, .external_lex_state = 12},
  [15182] = {.lex_state = 0, .external_lex_state = 12},
  [15183] = {.lex_state = 0, .external_lex_state = 12},
  [15184] = {.lex_state = 0, .external_lex_state = 12},
  [15185] = {.lex_state = 0, .external_lex_state = 12},
  [15186] = {.lex_state = 364, .external_lex_state = 12},
  [15187] = {.lex_state = 0, .external_lex_state = 12},
  [15188] = {.lex_state = 0, .external_lex_state = 12},
  [15189] = {.lex_state = 554, .external_lex_state = 12},
  [15190] = {.lex_state = 364, .external_lex_state = 12},
  [15191] = {.lex_state = 364, .external_lex_state = 12},
  [15192] = {.lex_state = 364, .external_lex_state = 12},
  [15193] = {.lex_state = 0, .external_lex_state = 12},
  [15194] = {.lex_state = 0, .external_lex_state = 12},
  [15195] = {.lex_state = 363, .external_lex_state = 12},
  [15196] = {.lex_state = 0, .external_lex_state = 12},
  [15197] = {.lex_state = 364, .external_lex_state = 12},
  [15198] = {.lex_state = 364, .external_lex_state = 12},
  [15199] = {.lex_state = 0, .external_lex_state = 12},
  [15200] = {.lex_state = 0, .external_lex_state = 12},
  [15201] = {.lex_state = 0, .external_lex_state = 12},
  [15202] = {.lex_state = 0, .external_lex_state = 12},
  [15203] = {.lex_state = 0, .external_lex_state = 12},
  [15204] = {.lex_state = 0, .external_lex_state = 12},
  [15205] = {.lex_state = 0, .external_lex_state = 12},
  [15206] = {.lex_state = 0, .external_lex_state = 12},
  [15207] = {.lex_state = 0, .external_lex_state = 12},
  [15208] = {.lex_state = 0, .external_lex_state = 12},
  [15209] = {.lex_state = 0, .external_lex_state = 12},
  [15210] = {.lex_state = 554, .external_lex_state = 12},
  [15211] = {.lex_state = 0, .external_lex_state = 12},
  [15212] = {.lex_state = 0, .external_lex_state = 12},
  [15213] = {.lex_state = 0, .external_lex_state = 12},
  [15214] = {.lex_state = 0, .external_lex_state = 12},
  [15215] = {.lex_state = 0, .external_lex_state = 12},
  [15216] = {.lex_state = 364, .external_lex_state = 12},
  [15217] = {.lex_state = 0, .external_lex_state = 12},
  [15218] = {.lex_state = 364, .external_lex_state = 12},
  [15219] = {.lex_state = 0, .external_lex_state = 12},
  [15220] = {.lex_state = 0, .external_lex_state = 12},
  [15221] = {.lex_state = 0, .external_lex_state = 12},
  [15222] = {.lex_state = 364, .external_lex_state = 12},
  [15223] = {.lex_state = 0, .external_lex_state = 12},
  [15224] = {.lex_state = 529, .external_lex_state = 12},
  [15225] = {.lex_state = 0, .external_lex_state = 12},
  [15226] = {.lex_state = 529, .external_lex_state = 12},
  [15227] = {.lex_state = 0, .external_lex_state = 12},
  [15228] = {.lex_state = 0, .external_lex_state = 12},
  [15229] = {.lex_state = 0, .external_lex_state = 12},
  [15230] = {.lex_state = 0, .external_lex_state = 12},
  [15231] = {.lex_state = 0, .external_lex_state = 12},
  [15232] = {.lex_state = 0, .external_lex_state = 12},
  [15233] = {.lex_state = 0, .external_lex_state = 12},
  [15234] = {.lex_state = 0, .external_lex_state = 12},
  [15235] = {.lex_state = 0, .external_lex_state = 12},
  [15236] = {.lex_state = 364, .external_lex_state = 12},
  [15237] = {.lex_state = 0, .external_lex_state = 12},
  [15238] = {.lex_state = 364, .external_lex_state = 12},
  [15239] = {.lex_state = 0, .external_lex_state = 12},
  [15240] = {.lex_state = 0, .external_lex_state = 12},
  [15241] = {.lex_state = 0, .external_lex_state = 12},
  [15242] = {.lex_state = 0, .external_lex_state = 12},
  [15243] = {.lex_state = 0, .external_lex_state = 12},
  [15244] = {.lex_state = 0, .external_lex_state = 12},
  [15245] = {.lex_state = 0, .external_lex_state = 12},
  [15246] = {.lex_state = 0, .external_lex_state = 12},
  [15247] = {.lex_state = 364, .external_lex_state = 12},
  [15248] = {.lex_state = 0, .external_lex_state = 12},
  [15249] = {.lex_state = 314, .external_lex_state = 12},
  [15250] = {.lex_state = 0, .external_lex_state = 12},
  [15251] = {.lex_state = 0, .external_lex_state = 12},
  [15252] = {.lex_state = 314, .external_lex_state = 12},
  [15253] = {.lex_state = 364, .external_lex_state = 12},
  [15254] = {.lex_state = 0, .external_lex_state = 12},
  [15255] = {.lex_state = 0, .external_lex_state = 12},
  [15256] = {.lex_state = 364, .external_lex_state = 12},
  [15257] = {.lex_state = 0, .external_lex_state = 12},
  [15258] = {.lex_state = 529, .external_lex_state = 12},
  [15259] = {.lex_state = 364, .external_lex_state = 12},
  [15260] = {.lex_state = 0, .external_lex_state = 12},
  [15261] = {.lex_state = 0, .external_lex_state = 12},
  [15262] = {.lex_state = 0, .external_lex_state = 12},
  [15263] = {.lex_state = 0, .external_lex_state = 12},
  [15264] = {.lex_state = 0, .external_lex_state = 12},
  [15265] = {.lex_state = 0, .external_lex_state = 12},
  [15266] = {.lex_state = 554, .external_lex_state = 12},
  [15267] = {.lex_state = 0, .external_lex_state = 12},
  [15268] = {.lex_state = 0, .external_lex_state = 12},
  [15269] = {.lex_state = 0, .external_lex_state = 12},
  [15270] = {.lex_state = 364, .external_lex_state = 12},
  [15271] = {.lex_state = 364, .external_lex_state = 12},
  [15272] = {.lex_state = 0, .external_lex_state = 12},
  [15273] = {.lex_state = 314, .external_lex_state = 12},
  [15274] = {.lex_state = 0, .external_lex_state = 12},
  [15275] = {.lex_state = 314, .external_lex_state = 12},
  [15276] = {.lex_state = 364, .external_lex_state = 12},
  [15277] = {.lex_state = 0, .external_lex_state = 12},
  [15278] = {.lex_state = 0, .external_lex_state = 12},
  [15279] = {.lex_state = 364, .external_lex_state = 12},
  [15280] = {.lex_state = 0, .external_lex_state = 12},
  [15281] = {.lex_state = 0, .external_lex_state = 12},
  [15282] = {.lex_state = 0, .external_lex_state = 12},
  [15283] = {.lex_state = 364, .external_lex_state = 12},
  [15284] = {.lex_state = 0, .external_lex_state = 12},
  [15285] = {.lex_state = 0, .external_lex_state = 12},
  [15286] = {.lex_state = 0, .external_lex_state = 12},
  [15287] = {.lex_state = 0, .external_lex_state = 12},
  [15288] = {.lex_state = 0, .external_lex_state = 12},
  [15289] = {.lex_state = 314, .external_lex_state = 12},
  [15290] = {.lex_state = 364, .external_lex_state = 12},
  [15291] = {.lex_state = 314, .external_lex_state = 12},
  [15292] = {.lex_state = 0, .external_lex_state = 12},
  [15293] = {.lex_state = 0, .external_lex_state = 12},
  [15294] = {.lex_state = 0, .external_lex_state = 12},
  [15295] = {.lex_state = 0, .external_lex_state = 12},
  [15296] = {.lex_state = 0, .external_lex_state = 12},
  [15297] = {.lex_state = 0, .external_lex_state = 12},
  [15298] = {.lex_state = 413, .external_lex_state = 15},
  [15299] = {.lex_state = 0, .external_lex_state = 12},
  [15300] = {.lex_state = 314, .external_lex_state = 12},
  [15301] = {.lex_state = 0, .external_lex_state = 12},
  [15302] = {.lex_state = 314, .external_lex_state = 12},
  [15303] = {.lex_state = 0, .external_lex_state = 12},
  [15304] = {.lex_state = 554, .external_lex_state = 12},
  [15305] = {.lex_state = 364, .external_lex_state = 12},
  [15306] = {.lex_state = 0, .external_lex_state = 12},
  [15307] = {.lex_state = 0, .external_lex_state = 12},
  [15308] = {.lex_state = 0, .external_lex_state = 12},
  [15309] = {.lex_state = 0, .external_lex_state = 12},
  [15310] = {.lex_state = 0, .external_lex_state = 12},
  [15311] = {.lex_state = 314, .external_lex_state = 12},
  [15312] = {.lex_state = 364, .external_lex_state = 12},
  [15313] = {.lex_state = 314, .external_lex_state = 12},
  [15314] = {.lex_state = 364, .external_lex_state = 12},
  [15315] = {.lex_state = 0, .external_lex_state = 12},
  [15316] = {.lex_state = 0, .external_lex_state = 12},
  [15317] = {.lex_state = 314, .external_lex_state = 12},
  [15318] = {.lex_state = 0, .external_lex_state = 12},
  [15319] = {.lex_state = 0, .external_lex_state = 12},
  [15320] = {.lex_state = 314, .external_lex_state = 12},
  [15321] = {.lex_state = 0, .external_lex_state = 12},
  [15322] = {.lex_state = 314, .external_lex_state = 12},
  [15323] = {.lex_state = 0, .external_lex_state = 12},
  [15324] = {.lex_state = 0, .external_lex_state = 12},
  [15325] = {.lex_state = 554, .external_lex_state = 12},
  [15326] = {.lex_state = 314, .external_lex_state = 12},
  [15327] = {.lex_state = 529, .external_lex_state = 12},
  [15328] = {.lex_state = 314, .external_lex_state = 12},
  [15329] = {.lex_state = 0, .external_lex_state = 12},
  [15330] = {.lex_state = 0, .external_lex_state = 12},
  [15331] = {.lex_state = 314, .external_lex_state = 12},
  [15332] = {.lex_state = 409, .external_lex_state = 14},
  [15333] = {.lex_state = 314, .external_lex_state = 12},
  [15334] = {.lex_state = 364, .external_lex_state = 12},
  [15335] = {.lex_state = 0, .external_lex_state = 12},
  [15336] = {.lex_state = 554, .external_lex_state = 12},
  [15337] = {.lex_state = 529, .external_lex_state = 12},
  [15338] = {.lex_state = 0, .external_lex_state = 12},
  [15339] = {.lex_state = 314, .external_lex_state = 12},
  [15340] = {.lex_state = 0, .external_lex_state = 12},
  [15341] = {.lex_state = 314, .external_lex_state = 12},
  [15342] = {.lex_state = 0, .external_lex_state = 12},
  [15343] = {.lex_state = 231, .external_lex_state = 12},
  [15344] = {.lex_state = 0, .external_lex_state = 12},
  [15345] = {.lex_state = 0, .external_lex_state = 12},
  [15346] = {.lex_state = 0, .external_lex_state = 12},
  [15347] = {.lex_state = 0, .external_lex_state = 12},
  [15348] = {.lex_state = 314, .external_lex_state = 12},
  [15349] = {.lex_state = 364, .external_lex_state = 12},
  [15350] = {.lex_state = 0, .external_lex_state = 12},
  [15351] = {.lex_state = 314, .external_lex_state = 12},
  [15352] = {.lex_state = 314, .external_lex_state = 12},
  [15353] = {.lex_state = 0, .external_lex_state = 12},
  [15354] = {.lex_state = 0, .external_lex_state = 12},
  [15355] = {.lex_state = 0, .external_lex_state = 12},
  [15356] = {.lex_state = 0, .external_lex_state = 12},
  [15357] = {.lex_state = 0, .external_lex_state = 12},
  [15358] = {.lex_state = 314, .external_lex_state = 12},
  [15359] = {.lex_state = 0, .external_lex_state = 12},
  [15360] = {.lex_state = 314, .external_lex_state = 12},
  [15361] = {.lex_state = 0, .external_lex_state = 12},
  [15362] = {.lex_state = 0, .external_lex_state = 12},
  [15363] = {.lex_state = 0, .external_lex_state = 12},
  [15364] = {.lex_state = 0, .external_lex_state = 12},
  [15365] = {.lex_state = 413, .external_lex_state = 15},
  [15366] = {.lex_state = 364, .external_lex_state = 12},
  [15367] = {.lex_state = 364, .external_lex_state = 12},
  [15368] = {.lex_state = 314, .external_lex_state = 12},
  [15369] = {.lex_state = 0, .external_lex_state = 12},
  [15370] = {.lex_state = 0, .external_lex_state = 12},
  [15371] = {.lex_state = 0, .external_lex_state = 12},
  [15372] = {.lex_state = 0, .external_lex_state = 12},
  [15373] = {.lex_state = 0, .external_lex_state = 12},
  [15374] = {.lex_state = 413, .external_lex_state = 15},
  [15375] = {.lex_state = 0, .external_lex_state = 12},
  [15376] = {.lex_state = 364, .external_lex_state = 12},
  [15377] = {.lex_state = 0, .external_lex_state = 12},
  [15378] = {.lex_state = 0, .external_lex_state = 12},
  [15379] = {.lex_state = 0, .external_lex_state = 12},
  [15380] = {.lex_state = 554, .external_lex_state = 12},
  [15381] = {.lex_state = 0, .external_lex_state = 12},
  [15382] = {.lex_state = 0, .external_lex_state = 12},
  [15383] = {.lex_state = 413, .external_lex_state = 15},
  [15384] = {.lex_state = 0, .external_lex_state = 12},
  [15385] = {.lex_state = 0, .external_lex_state = 12},
  [15386] = {.lex_state = 0, .external_lex_state = 12},
  [15387] = {.lex_state = 0, .external_lex_state = 12},
  [15388] = {.lex_state = 364, .external_lex_state = 12},
  [15389] = {.lex_state = 0, .external_lex_state = 12},
  [15390] = {.lex_state = 0, .external_lex_state = 12},
  [15391] = {.lex_state = 0, .external_lex_state = 12},
  [15392] = {.lex_state = 314, .external_lex_state = 12},
  [15393] = {.lex_state = 364, .external_lex_state = 12},
  [15394] = {.lex_state = 0, .external_lex_state = 12},
  [15395] = {.lex_state = 0, .external_lex_state = 12},
  [15396] = {.lex_state = 0, .external_lex_state = 12},
  [15397] = {.lex_state = 0, .external_lex_state = 12},
  [15398] = {.lex_state = 0, .external_lex_state = 12},
  [15399] = {.lex_state = 0, .external_lex_state = 12},
  [15400] = {.lex_state = 0, .external_lex_state = 12},
  [15401] = {.lex_state = 0, .external_lex_state = 12},
  [15402] = {.lex_state = 0, .external_lex_state = 12},
  [15403] = {.lex_state = 0, .external_lex_state = 12},
  [15404] = {.lex_state = 554, .external_lex_state = 12},
  [15405] = {.lex_state = 0, .external_lex_state = 12},
  [15406] = {.lex_state = 0, .external_lex_state = 12},
  [15407] = {.lex_state = 0, .external_lex_state = 12},
  [15408] = {.lex_state = 364, .external_lex_state = 12},
  [15409] = {.lex_state = 0, .external_lex_state = 12},
  [15410] = {.lex_state = 0, .external_lex_state = 12},
  [15411] = {.lex_state = 0, .external_lex_state = 12},
  [15412] = {.lex_state = 0, .external_lex_state = 12},
  [15413] = {.lex_state = 529, .external_lex_state = 12},
  [15414] = {.lex_state = 0, .external_lex_state = 12},
  [15415] = {.lex_state = 0, .external_lex_state = 12},
  [15416] = {.lex_state = 409, .external_lex_state = 10},
  [15417] = {.lex_state = 0, .external_lex_state = 12},
  [15418] = {.lex_state = 0, .external_lex_state = 12},
  [15419] = {.lex_state = 529, .external_lex_state = 12},
  [15420] = {.lex_state = 0, .external_lex_state = 12},
  [15421] = {.lex_state = 0, .external_lex_state = 12},
  [15422] = {.lex_state = 0, .external_lex_state = 12},
  [15423] = {.lex_state = 364, .external_lex_state = 12},
  [15424] = {.lex_state = 0, .external_lex_state = 12},
  [15425] = {.lex_state = 364, .external_lex_state = 12},
  [15426] = {.lex_state = 0, .external_lex_state = 12},
  [15427] = {.lex_state = 0, .external_lex_state = 12},
  [15428] = {.lex_state = 0, .external_lex_state = 12},
  [15429] = {.lex_state = 0, .external_lex_state = 12},
  [15430] = {.lex_state = 0, .external_lex_state = 12},
  [15431] = {.lex_state = 529, .external_lex_state = 12},
  [15432] = {.lex_state = 0, .external_lex_state = 12},
  [15433] = {.lex_state = 0, .external_lex_state = 12},
  [15434] = {.lex_state = 0, .external_lex_state = 12},
  [15435] = {.lex_state = 0, .external_lex_state = 12},
  [15436] = {.lex_state = 0, .external_lex_state = 12},
  [15437] = {.lex_state = 0, .external_lex_state = 12},
  [15438] = {.lex_state = 364, .external_lex_state = 12},
  [15439] = {.lex_state = 0, .external_lex_state = 12},
  [15440] = {.lex_state = 529, .external_lex_state = 12},
  [15441] = {.lex_state = 0, .external_lex_state = 12},
  [15442] = {.lex_state = 0, .external_lex_state = 12},
  [15443] = {.lex_state = 0, .external_lex_state = 12},
  [15444] = {.lex_state = 364, .external_lex_state = 12},
  [15445] = {.lex_state = 0, .external_lex_state = 12},
  [15446] = {.lex_state = 0, .external_lex_state = 12},
  [15447] = {.lex_state = 0, .external_lex_state = 12},
  [15448] = {.lex_state = 0, .external_lex_state = 12},
  [15449] = {.lex_state = 0, .external_lex_state = 12},
  [15450] = {.lex_state = 0, .external_lex_state = 12},
  [15451] = {.lex_state = 0, .external_lex_state = 12},
  [15452] = {.lex_state = 0, .external_lex_state = 12},
  [15453] = {.lex_state = 0, .external_lex_state = 12},
  [15454] = {.lex_state = 0, .external_lex_state = 12},
  [15455] = {.lex_state = 0, .external_lex_state = 12},
  [15456] = {.lex_state = 0, .external_lex_state = 12},
  [15457] = {.lex_state = 0, .external_lex_state = 12},
  [15458] = {.lex_state = 0, .external_lex_state = 12},
  [15459] = {.lex_state = 364, .external_lex_state = 12},
  [15460] = {.lex_state = 0, .external_lex_state = 12},
  [15461] = {.lex_state = 0, .external_lex_state = 12},
  [15462] = {.lex_state = 0, .external_lex_state = 12},
  [15463] = {.lex_state = 0, .external_lex_state = 12},
  [15464] = {.lex_state = 364, .external_lex_state = 12},
  [15465] = {.lex_state = 0, .external_lex_state = 12},
  [15466] = {.lex_state = 409, .external_lex_state = 18},
  [15467] = {.lex_state = 409, .external_lex_state = 19},
  [15468] = {.lex_state = 409, .external_lex_state = 18},
  [15469] = {.lex_state = 409, .external_lex_state = 19},
  [15470] = {.lex_state = 409, .external_lex_state = 18},
  [15471] = {.lex_state = 409, .external_lex_state = 19},
  [15472] = {.lex_state = 0, .external_lex_state = 12},
  [15473] = {.lex_state = 0, .external_lex_state = 12},
  [15474] = {.lex_state = 363, .external_lex_state = 12},
  [15475] = {.lex_state = 499, .external_lex_state = 12},
  [15476] = {.lex_state = 0, .external_lex_state = 12},
  [15477] = {.lex_state = 0, .external_lex_state = 12},
  [15478] = {.lex_state = 409, .external_lex_state = 18},
  [15479] = {.lex_state = 409, .external_lex_state = 19},
  [15480] = {.lex_state = 0, .external_lex_state = 12},
  [15481] = {.lex_state = 0, .external_lex_state = 12},
  [15482] = {.lex_state = 0, .external_lex_state = 12},
  [15483] = {.lex_state = 499, .external_lex_state = 12},
  [15484] = {.lex_state = 499, .external_lex_state = 12},
  [15485] = {.lex_state = 0, .external_lex_state = 12},
  [15486] = {.lex_state = 0, .external_lex_state = 12},
  [15487] = {.lex_state = 409, .external_lex_state = 18},
  [15488] = {.lex_state = 409, .external_lex_state = 19},
  [15489] = {.lex_state = 529, .external_lex_state = 12},
  [15490] = {.lex_state = 499, .external_lex_state = 12},
  [15491] = {.lex_state = 0, .external_lex_state = 12},
  [15492] = {.lex_state = 499, .external_lex_state = 12},
  [15493] = {.lex_state = 0, .external_lex_state = 12},
  [15494] = {.lex_state = 409, .external_lex_state = 11},
  [15495] = {.lex_state = 409, .external_lex_state = 18},
  [15496] = {.lex_state = 409, .external_lex_state = 19},
  [15497] = {.lex_state = 0, .external_lex_state = 12},
  [15498] = {.lex_state = 499, .external_lex_state = 12},
  [15499] = {.lex_state = 0, .external_lex_state = 12},
  [15500] = {.lex_state = 409, .external_lex_state = 18},
  [15501] = {.lex_state = 409, .external_lex_state = 19},
  [15502] = {.lex_state = 0, .external_lex_state = 12},
  [15503] = {.lex_state = 409, .external_lex_state = 18},
  [15504] = {.lex_state = 409, .external_lex_state = 19},
  [15505] = {.lex_state = 499, .external_lex_state = 12},
  [15506] = {.lex_state = 0, .external_lex_state = 12},
  [15507] = {.lex_state = 0, .external_lex_state = 12},
  [15508] = {.lex_state = 0, .external_lex_state = 12},
  [15509] = {.lex_state = 409, .external_lex_state = 18},
  [15510] = {.lex_state = 409, .external_lex_state = 19},
  [15511] = {.lex_state = 0, .external_lex_state = 12},
  [15512] = {.lex_state = 409, .external_lex_state = 18},
  [15513] = {.lex_state = 409, .external_lex_state = 19},
  [15514] = {.lex_state = 0, .external_lex_state = 12},
  [15515] = {.lex_state = 0, .external_lex_state = 12},
  [15516] = {.lex_state = 0, .external_lex_state = 12},
  [15517] = {.lex_state = 0, .external_lex_state = 12},
  [15518] = {.lex_state = 0, .external_lex_state = 12},
  [15519] = {.lex_state = 499, .external_lex_state = 12},
  [15520] = {.lex_state = 409, .external_lex_state = 18},
  [15521] = {.lex_state = 409, .external_lex_state = 18},
  [15522] = {.lex_state = 409, .external_lex_state = 19},
  [15523] = {.lex_state = 0, .external_lex_state = 12},
  [15524] = {.lex_state = 409, .external_lex_state = 19},
  [15525] = {.lex_state = 499, .external_lex_state = 12},
  [15526] = {.lex_state = 0, .external_lex_state = 12},
  [15527] = {.lex_state = 0, .external_lex_state = 12},
  [15528] = {.lex_state = 409, .external_lex_state = 18},
  [15529] = {.lex_state = 409, .external_lex_state = 19},
  [15530] = {.lex_state = 499, .external_lex_state = 12},
  [15531] = {.lex_state = 499, .external_lex_state = 12},
  [15532] = {.lex_state = 499, .external_lex_state = 12},
  [15533] = {.lex_state = 0, .external_lex_state = 12},
  [15534] = {.lex_state = 0, .external_lex_state = 12},
  [15535] = {.lex_state = 409, .external_lex_state = 18},
  [15536] = {.lex_state = 409, .external_lex_state = 19},
  [15537] = {.lex_state = 499, .external_lex_state = 12},
  [15538] = {.lex_state = 409, .external_lex_state = 18},
  [15539] = {.lex_state = 409, .external_lex_state = 19},
  [15540] = {.lex_state = 409, .external_lex_state = 18},
  [15541] = {.lex_state = 409, .external_lex_state = 19},
  [15542] = {.lex_state = 499, .external_lex_state = 12},
  [15543] = {.lex_state = 0, .external_lex_state = 12},
  [15544] = {.lex_state = 409, .external_lex_state = 18},
  [15545] = {.lex_state = 409, .external_lex_state = 19},
  [15546] = {.lex_state = 409, .external_lex_state = 18},
  [15547] = {.lex_state = 0, .external_lex_state = 12},
  [15548] = {.lex_state = 409, .external_lex_state = 19},
  [15549] = {.lex_state = 0, .external_lex_state = 12},
  [15550] = {.lex_state = 0, .external_lex_state = 12},
  [15551] = {.lex_state = 499, .external_lex_state = 12},
  [15552] = {.lex_state = 0, .external_lex_state = 12},
  [15553] = {.lex_state = 499, .external_lex_state = 12},
  [15554] = {.lex_state = 409, .external_lex_state = 18},
  [15555] = {.lex_state = 409, .external_lex_state = 19},
  [15556] = {.lex_state = 0, .external_lex_state = 12},
  [15557] = {.lex_state = 499, .external_lex_state = 12},
  [15558] = {.lex_state = 0, .external_lex_state = 12},
  [15559] = {.lex_state = 0, .external_lex_state = 12},
  [15560] = {.lex_state = 409, .external_lex_state = 18},
  [15561] = {.lex_state = 409, .external_lex_state = 19},
  [15562] = {.lex_state = 499, .external_lex_state = 12},
  [15563] = {.lex_state = 0, .external_lex_state = 12},
  [15564] = {.lex_state = 409, .external_lex_state = 18},
  [15565] = {.lex_state = 409, .external_lex_state = 19},
  [15566] = {.lex_state = 0, .external_lex_state = 12},
  [15567] = {.lex_state = 499, .external_lex_state = 12},
  [15568] = {.lex_state = 0, .external_lex_state = 12},
  [15569] = {.lex_state = 0, .external_lex_state = 12},
  [15570] = {.lex_state = 0, .external_lex_state = 12},
  [15571] = {.lex_state = 0, .external_lex_state = 12},
  [15572] = {.lex_state = 0, .external_lex_state = 12},
  [15573] = {.lex_state = 0, .external_lex_state = 12},
  [15574] = {.lex_state = 409, .external_lex_state = 15},
  [15575] = {.lex_state = 499, .external_lex_state = 12},
  [15576] = {.lex_state = 0, .external_lex_state = 12},
  [15577] = {.lex_state = 409, .external_lex_state = 18},
  [15578] = {.lex_state = 409, .external_lex_state = 19},
  [15579] = {.lex_state = 0, .external_lex_state = 12},
  [15580] = {.lex_state = 0, .external_lex_state = 12},
  [15581] = {.lex_state = 409, .external_lex_state = 17},
  [15582] = {.lex_state = 0, .external_lex_state = 12},
  [15583] = {.lex_state = 499, .external_lex_state = 12},
  [15584] = {.lex_state = 409, .external_lex_state = 18},
  [15585] = {.lex_state = 409, .external_lex_state = 19},
  [15586] = {.lex_state = 0, .external_lex_state = 12},
  [15587] = {.lex_state = 0, .external_lex_state = 12},
  [15588] = {.lex_state = 409, .external_lex_state = 18},
  [15589] = {.lex_state = 409, .external_lex_state = 19},
  [15590] = {.lex_state = 409, .external_lex_state = 15},
  [15591] = {.lex_state = 499, .external_lex_state = 12},
  [15592] = {.lex_state = 499, .external_lex_state = 12},
  [15593] = {.lex_state = 0, .external_lex_state = 12},
  [15594] = {.lex_state = 0, .external_lex_state = 12},
  [15595] = {.lex_state = 499, .external_lex_state = 12},
  [15596] = {.lex_state = 499, .external_lex_state = 12},
  [15597] = {.lex_state = 499, .external_lex_state = 12},
  [15598] = {.lex_state = 409, .external_lex_state = 18},
  [15599] = {.lex_state = 409, .external_lex_state = 19},
  [15600] = {.lex_state = 499, .external_lex_state = 12},
  [15601] = {.lex_state = 499, .external_lex_state = 12},
  [15602] = {.lex_state = 499, .external_lex_state = 12},
  [15603] = {.lex_state = 409, .external_lex_state = 18},
  [15604] = {.lex_state = 409, .external_lex_state = 19},
  [15605] = {.lex_state = 0, .external_lex_state = 12},
  [15606] = {.lex_state = 0, .external_lex_state = 12},
  [15607] = {.lex_state = 499, .external_lex_state = 12},
  [15608] = {.lex_state = 0, .external_lex_state = 12},
  [15609] = {.lex_state = 409, .external_lex_state = 18},
  [15610] = {.lex_state = 409, .external_lex_state = 19},
  [15611] = {.lex_state = 0, .external_lex_state = 12},
  [15612] = {.lex_state = 499, .external_lex_state = 12},
  [15613] = {.lex_state = 499, .external_lex_state = 12},
  [15614] = {.lex_state = 0, .external_lex_state = 12},
  [15615] = {.lex_state = 409, .external_lex_state = 18},
  [15616] = {.lex_state = 409, .external_lex_state = 19},
  [15617] = {.lex_state = 0, .external_lex_state = 12},
  [15618] = {.lex_state = 409, .external_lex_state = 18},
  [15619] = {.lex_state = 0, .external_lex_state = 12},
  [15620] = {.lex_state = 0, .external_lex_state = 12},
  [15621] = {.lex_state = 0, .external_lex_state = 12},
  [15622] = {.lex_state = 499, .external_lex_state = 12},
  [15623] = {.lex_state = 409, .external_lex_state = 19},
  [15624] = {.lex_state = 409, .external_lex_state = 18},
  [15625] = {.lex_state = 409, .external_lex_state = 19},
  [15626] = {.lex_state = 0, .external_lex_state = 12},
  [15627] = {.lex_state = 499, .external_lex_state = 12},
  [15628] = {.lex_state = 0, .external_lex_state = 12},
  [15629] = {.lex_state = 409, .external_lex_state = 18},
  [15630] = {.lex_state = 499, .external_lex_state = 12},
  [15631] = {.lex_state = 409, .external_lex_state = 19},
  [15632] = {.lex_state = 409, .external_lex_state = 18},
  [15633] = {.lex_state = 409, .external_lex_state = 19},
  [15634] = {.lex_state = 0, .external_lex_state = 12},
  [15635] = {.lex_state = 499, .external_lex_state = 12},
  [15636] = {.lex_state = 0, .external_lex_state = 12},
  [15637] = {.lex_state = 409, .external_lex_state = 18},
  [15638] = {.lex_state = 409, .external_lex_state = 19},
  [15639] = {.lex_state = 0, .external_lex_state = 12},
  [15640] = {.lex_state = 499, .external_lex_state = 12},
  [15641] = {.lex_state = 409, .external_lex_state = 18},
  [15642] = {.lex_state = 409, .external_lex_state = 19},
  [15643] = {.lex_state = 0, .external_lex_state = 12},
  [15644] = {.lex_state = 409, .external_lex_state = 18},
  [15645] = {.lex_state = 409, .external_lex_state = 19},
  [15646] = {.lex_state = 409, .external_lex_state = 18},
  [15647] = {.lex_state = 0, .external_lex_state = 12},
  [15648] = {.lex_state = 0, .external_lex_state = 12},
  [15649] = {.lex_state = 409, .external_lex_state = 19},
  [15650] = {.lex_state = 0, .external_lex_state = 12},
  [15651] = {.lex_state = 0, .external_lex_state = 12},
  [15652] = {.lex_state = 0, .external_lex_state = 12},
  [15653] = {.lex_state = 499, .external_lex_state = 12},
  [15654] = {.lex_state = 409, .external_lex_state = 18},
  [15655] = {.lex_state = 409, .external_lex_state = 19},
  [15656] = {.lex_state = 409, .external_lex_state = 18},
  [15657] = {.lex_state = 0, .external_lex_state = 12},
  [15658] = {.lex_state = 0, .external_lex_state = 12},
  [15659] = {.lex_state = 409, .external_lex_state = 19},
  [15660] = {.lex_state = 499, .external_lex_state = 12},
  [15661] = {.lex_state = 0, .external_lex_state = 12},
  [15662] = {.lex_state = 0, .external_lex_state = 12},
  [15663] = {.lex_state = 409, .external_lex_state = 18},
  [15664] = {.lex_state = 409, .external_lex_state = 19},
  [15665] = {.lex_state = 0, .external_lex_state = 12},
  [15666] = {.lex_state = 0, .external_lex_state = 12},
  [15667] = {.lex_state = 0, .external_lex_state = 12},
  [15668] = {.lex_state = 0, .external_lex_state = 12},
  [15669] = {.lex_state = 0, .external_lex_state = 12},
  [15670] = {.lex_state = 0, .external_lex_state = 12},
  [15671] = {.lex_state = 529, .external_lex_state = 12},
  [15672] = {.lex_state = 343, .external_lex_state = 12},
  [15673] = {.lex_state = 0, .external_lex_state = 12},
  [15674] = {.lex_state = 0, .external_lex_state = 12},
  [15675] = {.lex_state = 409, .external_lex_state = 18},
  [15676] = {.lex_state = 499, .external_lex_state = 12},
  [15677] = {.lex_state = 499, .external_lex_state = 12},
  [15678] = {.lex_state = 0, .external_lex_state = 12},
  [15679] = {.lex_state = 409, .external_lex_state = 18},
  [15680] = {.lex_state = 409, .external_lex_state = 19},
  [15681] = {.lex_state = 0, .external_lex_state = 12},
  [15682] = {.lex_state = 0, .external_lex_state = 12},
  [15683] = {.lex_state = 499, .external_lex_state = 12},
  [15684] = {.lex_state = 409, .external_lex_state = 19},
  [15685] = {.lex_state = 409, .external_lex_state = 18},
  [15686] = {.lex_state = 409, .external_lex_state = 19},
  [15687] = {.lex_state = 0, .external_lex_state = 12},
  [15688] = {.lex_state = 0, .external_lex_state = 12},
  [15689] = {.lex_state = 409, .external_lex_state = 18},
  [15690] = {.lex_state = 409, .external_lex_state = 19},
  [15691] = {.lex_state = 0, .external_lex_state = 12},
  [15692] = {.lex_state = 0, .external_lex_state = 12},
  [15693] = {.lex_state = 0, .external_lex_state = 12},
  [15694] = {.lex_state = 499, .external_lex_state = 12},
  [15695] = {.lex_state = 409, .external_lex_state = 18},
  [15696] = {.lex_state = 409, .external_lex_state = 19},
  [15697] = {.lex_state = 499, .external_lex_state = 12},
  [15698] = {.lex_state = 0, .external_lex_state = 12},
  [15699] = {.lex_state = 499, .external_lex_state = 12},
  [15700] = {.lex_state = 499, .external_lex_state = 12},
  [15701] = {.lex_state = 409, .external_lex_state = 18},
  [15702] = {.lex_state = 409, .external_lex_state = 19},
  [15703] = {.lex_state = 0, .external_lex_state = 12},
  [15704] = {.lex_state = 0, .external_lex_state = 12},
  [15705] = {.lex_state = 499, .external_lex_state = 12},
  [15706] = {.lex_state = 0, .external_lex_state = 12},
  [15707] = {.lex_state = 0, .external_lex_state = 12},
  [15708] = {.lex_state = 0, .external_lex_state = 12},
  [15709] = {.lex_state = 409, .external_lex_state = 18},
  [15710] = {.lex_state = 409, .external_lex_state = 19},
  [15711] = {.lex_state = 499, .external_lex_state = 12},
  [15712] = {.lex_state = 409, .external_lex_state = 18},
  [15713] = {.lex_state = 409, .external_lex_state = 19},
  [15714] = {.lex_state = 0, .external_lex_state = 12},
  [15715] = {.lex_state = 499, .external_lex_state = 12},
  [15716] = {.lex_state = 0, .external_lex_state = 12},
  [15717] = {.lex_state = 409, .external_lex_state = 18},
  [15718] = {.lex_state = 409, .external_lex_state = 19},
  [15719] = {.lex_state = 0, .external_lex_state = 12},
  [15720] = {.lex_state = 0, .external_lex_state = 12},
  [15721] = {.lex_state = 0, .external_lex_state = 12},
  [15722] = {.lex_state = 0, .external_lex_state = 12},
  [15723] = {.lex_state = 0, .external_lex_state = 12},
  [15724] = {.lex_state = 409, .external_lex_state = 18},
  [15725] = {.lex_state = 409, .external_lex_state = 19},
  [15726] = {.lex_state = 499, .external_lex_state = 12},
  [15727] = {.lex_state = 0, .external_lex_state = 12},
  [15728] = {.lex_state = 409, .external_lex_state = 18},
  [15729] = {.lex_state = 409, .external_lex_state = 19},
  [15730] = {.lex_state = 0, .external_lex_state = 12},
  [15731] = {.lex_state = 0, .external_lex_state = 12},
  [15732] = {.lex_state = 0, .external_lex_state = 12},
  [15733] = {.lex_state = 499, .external_lex_state = 12},
  [15734] = {.lex_state = 0, .external_lex_state = 12},
  [15735] = {.lex_state = 409, .external_lex_state = 18},
  [15736] = {.lex_state = 0, .external_lex_state = 12},
  [15737] = {.lex_state = 409, .external_lex_state = 18},
  [15738] = {.lex_state = 409, .external_lex_state = 19},
  [15739] = {.lex_state = 0, .external_lex_state = 12},
  [15740] = {.lex_state = 0, .external_lex_state = 12},
  [15741] = {.lex_state = 0, .external_lex_state = 12},
  [15742] = {.lex_state = 0, .external_lex_state = 12},
  [15743] = {.lex_state = 0, .external_lex_state = 12},
  [15744] = {.lex_state = 0, .external_lex_state = 12},
  [15745] = {.lex_state = 499, .external_lex_state = 12},
  [15746] = {.lex_state = 409, .external_lex_state = 18},
  [15747] = {.lex_state = 409, .external_lex_state = 19},
  [15748] = {.lex_state = 499, .external_lex_state = 12},
  [15749] = {.lex_state = 0, .external_lex_state = 12},
  [15750] = {.lex_state = 499, .external_lex_state = 12},
  [15751] = {.lex_state = 0, .external_lex_state = 12},
  [15752] = {.lex_state = 409, .external_lex_state = 18},
  [15753] = {.lex_state = 409, .external_lex_state = 19},
  [15754] = {.lex_state = 409, .external_lex_state = 19},
  [15755] = {.lex_state = 499, .external_lex_state = 12},
  [15756] = {.lex_state = 0, .external_lex_state = 12},
  [15757] = {.lex_state = 499, .external_lex_state = 12},
  [15758] = {.lex_state = 409, .external_lex_state = 18},
  [15759] = {.lex_state = 409, .external_lex_state = 19},
  [15760] = {.lex_state = 0, .external_lex_state = 12},
  [15761] = {.lex_state = 499, .external_lex_state = 12},
  [15762] = {.lex_state = 0, .external_lex_state = 12},
  [15763] = {.lex_state = 409, .external_lex_state = 18},
  [15764] = {.lex_state = 409, .external_lex_state = 19},
  [15765] = {.lex_state = 0, .external_lex_state = 12},
  [15766] = {.lex_state = 499, .external_lex_state = 12},
  [15767] = {.lex_state = 0, .external_lex_state = 12},
  [15768] = {.lex_state = 409, .external_lex_state = 18},
  [15769] = {.lex_state = 409, .external_lex_state = 18},
  [15770] = {.lex_state = 409, .external_lex_state = 19},
  [15771] = {.lex_state = 499, .external_lex_state = 12},
  [15772] = {.lex_state = 0, .external_lex_state = 12},
  [15773] = {.lex_state = 499, .external_lex_state = 12},
  [15774] = {.lex_state = 499, .external_lex_state = 12},
  [15775] = {.lex_state = 0, .external_lex_state = 12},
  [15776] = {.lex_state = 409, .external_lex_state = 15},
  [15777] = {.lex_state = 0, .external_lex_state = 12},
  [15778] = {.lex_state = 499, .external_lex_state = 12},
  [15779] = {.lex_state = 499, .external_lex_state = 12},
  [15780] = {.lex_state = 409, .external_lex_state = 18},
  [15781] = {.lex_state = 409, .external_lex_state = 19},
  [15782] = {.lex_state = 409, .external_lex_state = 18},
  [15783] = {.lex_state = 409, .external_lex_state = 19},
  [15784] = {.lex_state = 0, .external_lex_state = 12},
  [15785] = {.lex_state = 499, .external_lex_state = 12},
  [15786] = {.lex_state = 0, .external_lex_state = 12},
  [15787] = {.lex_state = 409, .external_lex_state = 18},
  [15788] = {.lex_state = 409, .external_lex_state = 19},
  [15789] = {.lex_state = 0, .external_lex_state = 12},
  [15790] = {.lex_state = 409, .external_lex_state = 18},
  [15791] = {.lex_state = 409, .external_lex_state = 19},
  [15792] = {.lex_state = 0, .external_lex_state = 12},
  [15793] = {.lex_state = 409, .external_lex_state = 19},
  [15794] = {.lex_state = 0, .external_lex_state = 12},
  [15795] = {.lex_state = 409, .external_lex_state = 15},
  [15796] = {.lex_state = 499, .external_lex_state = 12},
  [15797] = {.lex_state = 0, .external_lex_state = 12},
  [15798] = {.lex_state = 409, .external_lex_state = 18},
  [15799] = {.lex_state = 409, .external_lex_state = 19},
  [15800] = {.lex_state = 0, .external_lex_state = 12},
  [15801] = {.lex_state = 0, .external_lex_state = 12},
  [15802] = {.lex_state = 409, .external_lex_state = 18},
  [15803] = {.lex_state = 499, .external_lex_state = 12},
  [15804] = {.lex_state = 409, .external_lex_state = 19},
  [15805] = {.lex_state = 499, .external_lex_state = 12},
  [15806] = {.lex_state = 409, .external_lex_state = 18},
  [15807] = {.lex_state = 409, .external_lex_state = 19},
  [15808] = {.lex_state = 0, .external_lex_state = 12},
  [15809] = {.lex_state = 411, .external_lex_state = 12},
  [15810] = {.lex_state = 0, .external_lex_state = 12},
  [15811] = {.lex_state = 0, .external_lex_state = 12},
  [15812] = {.lex_state = 0, .external_lex_state = 12},
  [15813] = {.lex_state = 499, .external_lex_state = 12},
  [15814] = {.lex_state = 0, .external_lex_state = 12},
  [15815] = {.lex_state = 409, .external_lex_state = 18},
  [15816] = {.lex_state = 409, .external_lex_state = 19},
  [15817] = {.lex_state = 499, .external_lex_state = 12},
  [15818] = {.lex_state = 411, .external_lex_state = 12},
  [15819] = {.lex_state = 499, .external_lex_state = 12},
  [15820] = {.lex_state = 0, .external_lex_state = 12},
  [15821] = {.lex_state = 409, .external_lex_state = 18},
  [15822] = {.lex_state = 409, .external_lex_state = 19},
  [15823] = {.lex_state = 409, .external_lex_state = 18},
  [15824] = {.lex_state = 409, .external_lex_state = 19},
  [15825] = {.lex_state = 0, .external_lex_state = 12},
  [15826] = {.lex_state = 411, .external_lex_state = 12},
  [15827] = {.lex_state = 0, .external_lex_state = 12},
  [15828] = {.lex_state = 0, .external_lex_state = 12},
  [15829] = {.lex_state = 499, .external_lex_state = 12},
  [15830] = {.lex_state = 499, .external_lex_state = 12},
  [15831] = {.lex_state = 0, .external_lex_state = 12},
  [15832] = {.lex_state = 499, .external_lex_state = 12},
  [15833] = {.lex_state = 409, .external_lex_state = 18},
  [15834] = {.lex_state = 409, .external_lex_state = 19},
  [15835] = {.lex_state = 0, .external_lex_state = 12},
  [15836] = {.lex_state = 411, .external_lex_state = 12},
  [15837] = {.lex_state = 0, .external_lex_state = 12},
  [15838] = {.lex_state = 499, .external_lex_state = 12},
  [15839] = {.lex_state = 0, .external_lex_state = 12},
  [15840] = {.lex_state = 499, .external_lex_state = 12},
  [15841] = {.lex_state = 409, .external_lex_state = 18},
  [15842] = {.lex_state = 409, .external_lex_state = 19},
  [15843] = {.lex_state = 499, .external_lex_state = 12},
  [15844] = {.lex_state = 499, .external_lex_state = 12},
  [15845] = {.lex_state = 409, .external_lex_state = 18},
  [15846] = {.lex_state = 409, .external_lex_state = 19},
  [15847] = {.lex_state = 409, .external_lex_state = 18},
  [15848] = {.lex_state = 409, .external_lex_state = 19},
  [15849] = {.lex_state = 409, .external_lex_state = 18},
  [15850] = {.lex_state = 409, .external_lex_state = 19},
  [15851] = {.lex_state = 409, .external_lex_state = 18},
  [15852] = {.lex_state = 409, .external_lex_state = 19},
  [15853] = {.lex_state = 409, .external_lex_state = 18},
  [15854] = {.lex_state = 409, .external_lex_state = 19},
  [15855] = {.lex_state = 409, .external_lex_state = 18},
  [15856] = {.lex_state = 409, .external_lex_state = 19},
  [15857] = {.lex_state = 409, .external_lex_state = 18},
  [15858] = {.lex_state = 409, .external_lex_state = 18},
  [15859] = {.lex_state = 409, .external_lex_state = 19},
  [15860] = {.lex_state = 409, .external_lex_state = 18},
  [15861] = {.lex_state = 409, .external_lex_state = 19},
  [15862] = {.lex_state = 409, .external_lex_state = 19},
  [15863] = {.lex_state = 409, .external_lex_state = 18},
  [15864] = {.lex_state = 409, .external_lex_state = 18},
  [15865] = {.lex_state = 409, .external_lex_state = 19},
  [15866] = {.lex_state = 409, .external_lex_state = 18},
  [15867] = {.lex_state = 409, .external_lex_state = 19},
  [15868] = {.lex_state = 409, .external_lex_state = 19},
  [15869] = {.lex_state = 409, .external_lex_state = 18},
  [15870] = {.lex_state = 409, .external_lex_state = 19},
  [15871] = {.lex_state = 409, .external_lex_state = 18},
  [15872] = {.lex_state = 409, .external_lex_state = 19},
  [15873] = {.lex_state = 0, .external_lex_state = 12},
  [15874] = {.lex_state = 409, .external_lex_state = 18},
  [15875] = {.lex_state = 409, .external_lex_state = 19},
  [15876] = {.lex_state = 409, .external_lex_state = 18},
  [15877] = {.lex_state = 409, .external_lex_state = 19},
  [15878] = {.lex_state = 409, .external_lex_state = 18},
  [15879] = {.lex_state = 409, .external_lex_state = 19},
  [15880] = {.lex_state = 409, .external_lex_state = 18},
  [15881] = {.lex_state = 409, .external_lex_state = 19},
  [15882] = {.lex_state = 409, .external_lex_state = 18},
  [15883] = {.lex_state = 409, .external_lex_state = 19},
  [15884] = {.lex_state = 409, .external_lex_state = 18},
  [15885] = {.lex_state = 409, .external_lex_state = 19},
  [15886] = {.lex_state = 0, .external_lex_state = 12},
  [15887] = {.lex_state = 409, .external_lex_state = 18},
  [15888] = {.lex_state = 409, .external_lex_state = 19},
  [15889] = {.lex_state = 409, .external_lex_state = 18},
  [15890] = {.lex_state = 409, .external_lex_state = 19},
  [15891] = {.lex_state = 409, .external_lex_state = 18},
  [15892] = {.lex_state = 409, .external_lex_state = 19},
  [15893] = {.lex_state = 409, .external_lex_state = 18},
  [15894] = {.lex_state = 409, .external_lex_state = 19},
  [15895] = {.lex_state = 409, .external_lex_state = 18},
  [15896] = {.lex_state = 409, .external_lex_state = 19},
  [15897] = {.lex_state = 409, .external_lex_state = 18},
  [15898] = {.lex_state = 409, .external_lex_state = 19},
  [15899] = {.lex_state = 499, .external_lex_state = 12},
  [15900] = {.lex_state = 409, .external_lex_state = 18},
  [15901] = {.lex_state = 409, .external_lex_state = 18},
  [15902] = {.lex_state = 409, .external_lex_state = 19},
  [15903] = {.lex_state = 409, .external_lex_state = 18},
  [15904] = {.lex_state = 409, .external_lex_state = 19},
  [15905] = {.lex_state = 0, .external_lex_state = 12},
  [15906] = {.lex_state = 409, .external_lex_state = 18},
  [15907] = {.lex_state = 409, .external_lex_state = 18},
  [15908] = {.lex_state = 409, .external_lex_state = 19},
  [15909] = {.lex_state = 409, .external_lex_state = 18},
  [15910] = {.lex_state = 409, .external_lex_state = 19},
  [15911] = {.lex_state = 0, .external_lex_state = 12},
  [15912] = {.lex_state = 409, .external_lex_state = 18},
  [15913] = {.lex_state = 409, .external_lex_state = 19},
  [15914] = {.lex_state = 409, .external_lex_state = 18},
  [15915] = {.lex_state = 409, .external_lex_state = 19},
  [15916] = {.lex_state = 0, .external_lex_state = 12},
  [15917] = {.lex_state = 409, .external_lex_state = 18},
  [15918] = {.lex_state = 409, .external_lex_state = 19},
  [15919] = {.lex_state = 409, .external_lex_state = 18},
  [15920] = {.lex_state = 409, .external_lex_state = 19},
  [15921] = {.lex_state = 409, .external_lex_state = 19},
  [15922] = {.lex_state = 409, .external_lex_state = 18},
  [15923] = {.lex_state = 409, .external_lex_state = 19},
  [15924] = {.lex_state = 409, .external_lex_state = 18},
  [15925] = {.lex_state = 409, .external_lex_state = 19},
  [15926] = {.lex_state = 409, .external_lex_state = 18},
  [15927] = {.lex_state = 409, .external_lex_state = 19},
  [15928] = {.lex_state = 409, .external_lex_state = 18},
  [15929] = {.lex_state = 409, .external_lex_state = 19},
  [15930] = {.lex_state = 409, .external_lex_state = 18},
  [15931] = {.lex_state = 409, .external_lex_state = 19},
  [15932] = {.lex_state = 409, .external_lex_state = 18},
  [15933] = {.lex_state = 409, .external_lex_state = 19},
  [15934] = {.lex_state = 499, .external_lex_state = 12},
  [15935] = {.lex_state = 409, .external_lex_state = 18},
  [15936] = {.lex_state = 409, .external_lex_state = 19},
  [15937] = {.lex_state = 409, .external_lex_state = 18},
  [15938] = {.lex_state = 409, .external_lex_state = 19},
  [15939] = {.lex_state = 499, .external_lex_state = 12},
  [15940] = {.lex_state = 409, .external_lex_state = 18},
  [15941] = {.lex_state = 409, .external_lex_state = 19},
  [15942] = {.lex_state = 409, .external_lex_state = 18},
  [15943] = {.lex_state = 409, .external_lex_state = 19},
  [15944] = {.lex_state = 0, .external_lex_state = 12},
  [15945] = {.lex_state = 409, .external_lex_state = 18},
  [15946] = {.lex_state = 409, .external_lex_state = 19},
  [15947] = {.lex_state = 409, .external_lex_state = 18},
  [15948] = {.lex_state = 409, .external_lex_state = 19},
  [15949] = {.lex_state = 0, .external_lex_state = 12},
  [15950] = {.lex_state = 0, .external_lex_state = 12},
  [15951] = {.lex_state = 409, .external_lex_state = 18},
  [15952] = {.lex_state = 409, .external_lex_state = 19},
  [15953] = {.lex_state = 409, .external_lex_state = 18},
  [15954] = {.lex_state = 409, .external_lex_state = 19},
  [15955] = {.lex_state = 409, .external_lex_state = 18},
  [15956] = {.lex_state = 409, .external_lex_state = 19},
  [15957] = {.lex_state = 409, .external_lex_state = 18},
  [15958] = {.lex_state = 409, .external_lex_state = 19},
  [15959] = {.lex_state = 409, .external_lex_state = 18},
  [15960] = {.lex_state = 409, .external_lex_state = 19},
  [15961] = {.lex_state = 409, .external_lex_state = 18},
  [15962] = {.lex_state = 409, .external_lex_state = 19},
  [15963] = {.lex_state = 409, .external_lex_state = 18},
  [15964] = {.lex_state = 409, .external_lex_state = 19},
  [15965] = {.lex_state = 409, .external_lex_state = 18},
  [15966] = {.lex_state = 409, .external_lex_state = 19},
  [15967] = {.lex_state = 0, .external_lex_state = 12},
  [15968] = {.lex_state = 409, .external_lex_state = 18},
  [15969] = {.lex_state = 409, .external_lex_state = 19},
  [15970] = {.lex_state = 409, .external_lex_state = 18},
  [15971] = {.lex_state = 409, .external_lex_state = 19},
  [15972] = {.lex_state = 409, .external_lex_state = 18},
  [15973] = {.lex_state = 409, .external_lex_state = 19},
  [15974] = {.lex_state = 409, .external_lex_state = 18},
  [15975] = {.lex_state = 409, .external_lex_state = 19},
  [15976] = {.lex_state = 409, .external_lex_state = 18},
  [15977] = {.lex_state = 409, .external_lex_state = 19},
  [15978] = {.lex_state = 409, .external_lex_state = 18},
  [15979] = {.lex_state = 409, .external_lex_state = 19},
  [15980] = {.lex_state = 409, .external_lex_state = 18},
  [15981] = {.lex_state = 409, .external_lex_state = 19},
  [15982] = {.lex_state = 409, .external_lex_state = 18},
  [15983] = {.lex_state = 409, .external_lex_state = 19},
  [15984] = {.lex_state = 409, .external_lex_state = 18},
  [15985] = {.lex_state = 409, .external_lex_state = 19},
  [15986] = {.lex_state = 409, .external_lex_state = 18},
  [15987] = {.lex_state = 409, .external_lex_state = 19},
  [15988] = {.lex_state = 409, .external_lex_state = 18},
  [15989] = {.lex_state = 409, .external_lex_state = 19},
  [15990] = {.lex_state = 409, .external_lex_state = 18},
  [15991] = {.lex_state = 409, .external_lex_state = 19},
  [15992] = {.lex_state = 409, .external_lex_state = 18},
  [15993] = {.lex_state = 409, .external_lex_state = 19},
  [15994] = {.lex_state = 409, .external_lex_state = 18},
  [15995] = {.lex_state = 409, .external_lex_state = 19},
  [15996] = {.lex_state = 409, .external_lex_state = 18},
  [15997] = {.lex_state = 409, .external_lex_state = 19},
  [15998] = {.lex_state = 409, .external_lex_state = 18},
  [15999] = {.lex_state = 409, .external_lex_state = 19},
  [16000] = {.lex_state = 0, .external_lex_state = 12},
  [16001] = {.lex_state = 409, .external_lex_state = 18},
  [16002] = {.lex_state = 409, .external_lex_state = 19},
  [16003] = {.lex_state = 409, .external_lex_state = 18},
  [16004] = {.lex_state = 409, .external_lex_state = 19},
  [16005] = {.lex_state = 409, .external_lex_state = 18},
  [16006] = {.lex_state = 409, .external_lex_state = 19},
  [16007] = {.lex_state = 409, .external_lex_state = 18},
  [16008] = {.lex_state = 409, .external_lex_state = 19},
  [16009] = {.lex_state = 0, .external_lex_state = 12},
  [16010] = {.lex_state = 409, .external_lex_state = 18},
  [16011] = {.lex_state = 409, .external_lex_state = 19},
  [16012] = {.lex_state = 409, .external_lex_state = 18},
  [16013] = {.lex_state = 409, .external_lex_state = 19},
  [16014] = {.lex_state = 409, .external_lex_state = 18},
  [16015] = {.lex_state = 409, .external_lex_state = 19},
  [16016] = {.lex_state = 409, .external_lex_state = 18},
  [16017] = {.lex_state = 409, .external_lex_state = 19},
  [16018] = {.lex_state = 0, .external_lex_state = 12},
  [16019] = {.lex_state = 409, .external_lex_state = 18},
  [16020] = {.lex_state = 409, .external_lex_state = 19},
  [16021] = {.lex_state = 409, .external_lex_state = 18},
  [16022] = {.lex_state = 409, .external_lex_state = 19},
  [16023] = {.lex_state = 409, .external_lex_state = 18},
  [16024] = {.lex_state = 409, .external_lex_state = 19},
  [16025] = {.lex_state = 409, .external_lex_state = 18},
  [16026] = {.lex_state = 409, .external_lex_state = 19},
  [16027] = {.lex_state = 409, .external_lex_state = 18},
  [16028] = {.lex_state = 409, .external_lex_state = 19},
  [16029] = {.lex_state = 409, .external_lex_state = 18},
  [16030] = {.lex_state = 409, .external_lex_state = 19},
  [16031] = {.lex_state = 409, .external_lex_state = 18},
  [16032] = {.lex_state = 409, .external_lex_state = 18},
  [16033] = {.lex_state = 409, .external_lex_state = 19},
  [16034] = {.lex_state = 409, .external_lex_state = 18},
  [16035] = {.lex_state = 409, .external_lex_state = 19},
  [16036] = {.lex_state = 409, .external_lex_state = 18},
  [16037] = {.lex_state = 409, .external_lex_state = 19},
  [16038] = {.lex_state = 0, .external_lex_state = 12},
  [16039] = {.lex_state = 0, .external_lex_state = 12},
  [16040] = {.lex_state = 0, .external_lex_state = 12},
  [16041] = {.lex_state = 0, .external_lex_state = 12},
  [16042] = {.lex_state = 409, .external_lex_state = 18},
  [16043] = {.lex_state = 343, .external_lex_state = 12},
  [16044] = {.lex_state = 343, .external_lex_state = 12},
  [16045] = {.lex_state = 499, .external_lex_state = 12},
  [16046] = {.lex_state = 343, .external_lex_state = 12},
  [16047] = {.lex_state = 0, .external_lex_state = 12},
  [16048] = {.lex_state = 343, .external_lex_state = 12},
  [16049] = {.lex_state = 343, .external_lex_state = 12},
  [16050] = {.lex_state = 499, .external_lex_state = 12},
  [16051] = {.lex_state = 409, .external_lex_state = 19},
  [16052] = {.lex_state = 363, .external_lex_state = 12},
  [16053] = {.lex_state = 0, .external_lex_state = 12},
  [16054] = {.lex_state = 0, .external_lex_state = 12},
  [16055] = {.lex_state = 0, .external_lex_state = 12},
  [16056] = {.lex_state = 0, .external_lex_state = 12},
  [16057] = {.lex_state = 409, .external_lex_state = 19},
  [16058] = {.lex_state = 499, .external_lex_state = 12},
  [16059] = {.lex_state = 499, .external_lex_state = 12},
  [16060] = {.lex_state = 363, .external_lex_state = 12},
  [16061] = {.lex_state = 0, .external_lex_state = 12},
  [16062] = {.lex_state = 0, .external_lex_state = 12},
  [16063] = {.lex_state = 0, .external_lex_state = 12},
  [16064] = {.lex_state = 0, .external_lex_state = 12},
  [16065] = {.lex_state = 0, .external_lex_state = 12},
  [16066] = {.lex_state = 0, .external_lex_state = 12},
  [16067] = {.lex_state = 0, .external_lex_state = 12},
  [16068] = {.lex_state = 363, .external_lex_state = 12},
  [16069] = {.lex_state = 0, .external_lex_state = 12},
  [16070] = {.lex_state = 0, .external_lex_state = 12},
  [16071] = {.lex_state = 409, .external_lex_state = 18},
  [16072] = {.lex_state = 409, .external_lex_state = 19},
  [16073] = {.lex_state = 0, .external_lex_state = 12},
  [16074] = {.lex_state = 0, .external_lex_state = 12},
  [16075] = {.lex_state = 0, .external_lex_state = 12},
  [16076] = {.lex_state = 0, .external_lex_state = 12},
  [16077] = {.lex_state = 0, .external_lex_state = 12},
  [16078] = {.lex_state = 529, .external_lex_state = 12},
  [16079] = {.lex_state = 499, .external_lex_state = 12},
  [16080] = {.lex_state = 409, .external_lex_state = 17},
  [16081] = {.lex_state = 0, .external_lex_state = 12},
  [16082] = {.lex_state = 409, .external_lex_state = 19},
  [16083] = {.lex_state = 0, .external_lex_state = 12},
  [16084] = {.lex_state = 0, .external_lex_state = 12},
  [16085] = {.lex_state = 409, .external_lex_state = 18},
  [16086] = {.lex_state = 409, .external_lex_state = 17},
  [16087] = {.lex_state = 0, .external_lex_state = 12},
  [16088] = {.lex_state = 409, .external_lex_state = 19},
  [16089] = {.lex_state = 0, .external_lex_state = 12},
  [16090] = {.lex_state = 499, .external_lex_state = 12},
  [16091] = {.lex_state = 0, .external_lex_state = 12},
  [16092] = {.lex_state = 0, .external_lex_state = 12},
  [16093] = {.lex_state = 409, .external_lex_state = 18},
  [16094] = {.lex_state = 409, .external_lex_state = 19},
  [16095] = {.lex_state = 343, .external_lex_state = 12},
  [16096] = {.lex_state = 0, .external_lex_state = 12},
  [16097] = {.lex_state = 0, .external_lex_state = 12},
  [16098] = {.lex_state = 0, .external_lex_state = 12},
  [16099] = {.lex_state = 0, .external_lex_state = 12},
  [16100] = {.lex_state = 499, .external_lex_state = 12},
  [16101] = {.lex_state = 499, .external_lex_state = 12},
  [16102] = {.lex_state = 0, .external_lex_state = 12},
  [16103] = {.lex_state = 0, .external_lex_state = 12},
  [16104] = {.lex_state = 0, .external_lex_state = 12},
  [16105] = {.lex_state = 409, .external_lex_state = 18},
  [16106] = {.lex_state = 409, .external_lex_state = 19},
  [16107] = {.lex_state = 499, .external_lex_state = 12},
  [16108] = {.lex_state = 0, .external_lex_state = 12},
  [16109] = {.lex_state = 0, .external_lex_state = 12},
  [16110] = {.lex_state = 0, .external_lex_state = 12},
  [16111] = {.lex_state = 499, .external_lex_state = 12},
  [16112] = {.lex_state = 409, .external_lex_state = 18},
  [16113] = {.lex_state = 409, .external_lex_state = 19},
  [16114] = {.lex_state = 0, .external_lex_state = 12},
  [16115] = {.lex_state = 0, .external_lex_state = 12},
  [16116] = {.lex_state = 0, .external_lex_state = 12},
  [16117] = {.lex_state = 0, .external_lex_state = 12},
  [16118] = {.lex_state = 0, .external_lex_state = 12},
  [16119] = {.lex_state = 409, .external_lex_state = 18},
  [16120] = {.lex_state = 409, .external_lex_state = 19},
  [16121] = {.lex_state = 0, .external_lex_state = 12},
  [16122] = {.lex_state = 409, .external_lex_state = 15},
  [16123] = {.lex_state = 409, .external_lex_state = 18},
  [16124] = {.lex_state = 0, .external_lex_state = 12},
  [16125] = {.lex_state = 0, .external_lex_state = 12},
  [16126] = {.lex_state = 409, .external_lex_state = 19},
  [16127] = {.lex_state = 0, .external_lex_state = 12},
  [16128] = {.lex_state = 0, .external_lex_state = 12},
  [16129] = {.lex_state = 0, .external_lex_state = 12},
  [16130] = {.lex_state = 0, .external_lex_state = 12},
  [16131] = {.lex_state = 0, .external_lex_state = 12},
  [16132] = {.lex_state = 409, .external_lex_state = 18},
  [16133] = {.lex_state = 0, .external_lex_state = 12},
  [16134] = {.lex_state = 0, .external_lex_state = 12},
  [16135] = {.lex_state = 0, .external_lex_state = 12},
  [16136] = {.lex_state = 0, .external_lex_state = 12},
  [16137] = {.lex_state = 0, .external_lex_state = 12},
  [16138] = {.lex_state = 499, .external_lex_state = 12},
  [16139] = {.lex_state = 0, .external_lex_state = 12},
  [16140] = {.lex_state = 499, .external_lex_state = 12},
  [16141] = {.lex_state = 0, .external_lex_state = 12},
  [16142] = {.lex_state = 499, .external_lex_state = 12},
  [16143] = {.lex_state = 0, .external_lex_state = 12},
  [16144] = {.lex_state = 499, .external_lex_state = 12},
  [16145] = {.lex_state = 499, .external_lex_state = 12},
  [16146] = {.lex_state = 409, .external_lex_state = 18},
  [16147] = {.lex_state = 409, .external_lex_state = 19},
  [16148] = {.lex_state = 499, .external_lex_state = 12},
  [16149] = {.lex_state = 409, .external_lex_state = 18},
  [16150] = {.lex_state = 409, .external_lex_state = 18},
  [16151] = {.lex_state = 409, .external_lex_state = 19},
  [16152] = {.lex_state = 409, .external_lex_state = 19},
  [16153] = {.lex_state = 0, .external_lex_state = 12},
  [16154] = {.lex_state = 0, .external_lex_state = 12},
  [16155] = {.lex_state = 0, .external_lex_state = 12},
  [16156] = {.lex_state = 0, .external_lex_state = 12},
  [16157] = {.lex_state = 0, .external_lex_state = 12},
  [16158] = {.lex_state = 0, .external_lex_state = 12},
  [16159] = {.lex_state = 0, .external_lex_state = 12},
  [16160] = {.lex_state = 0, .external_lex_state = 12},
  [16161] = {.lex_state = 499, .external_lex_state = 12},
  [16162] = {.lex_state = 0, .external_lex_state = 12},
  [16163] = {.lex_state = 0, .external_lex_state = 12},
  [16164] = {.lex_state = 409, .external_lex_state = 18},
  [16165] = {.lex_state = 409, .external_lex_state = 17},
  [16166] = {.lex_state = 409, .external_lex_state = 19},
  [16167] = {.lex_state = 499, .external_lex_state = 12},
  [16168] = {.lex_state = 0, .external_lex_state = 12},
  [16169] = {.lex_state = 0, .external_lex_state = 12},
  [16170] = {.lex_state = 0, .external_lex_state = 12},
  [16171] = {.lex_state = 0, .external_lex_state = 12},
  [16172] = {.lex_state = 409, .external_lex_state = 12},
  [16173] = {.lex_state = 409, .external_lex_state = 18},
  [16174] = {.lex_state = 409, .external_lex_state = 19},
  [16175] = {.lex_state = 499, .external_lex_state = 12},
  [16176] = {.lex_state = 0, .external_lex_state = 12},
  [16177] = {.lex_state = 0, .external_lex_state = 12},
  [16178] = {.lex_state = 0, .external_lex_state = 12},
  [16179] = {.lex_state = 0, .external_lex_state = 12},
  [16180] = {.lex_state = 0, .external_lex_state = 12},
  [16181] = {.lex_state = 0, .external_lex_state = 12},
  [16182] = {.lex_state = 409, .external_lex_state = 18},
  [16183] = {.lex_state = 0, .external_lex_state = 12},
  [16184] = {.lex_state = 409, .external_lex_state = 19},
  [16185] = {.lex_state = 499, .external_lex_state = 12},
  [16186] = {.lex_state = 0, .external_lex_state = 12},
  [16187] = {.lex_state = 409, .external_lex_state = 18},
  [16188] = {.lex_state = 0, .external_lex_state = 12},
  [16189] = {.lex_state = 409, .external_lex_state = 18},
  [16190] = {.lex_state = 409, .external_lex_state = 19},
  [16191] = {.lex_state = 0, .external_lex_state = 12},
  [16192] = {.lex_state = 0, .external_lex_state = 12},
  [16193] = {.lex_state = 499, .external_lex_state = 12},
  [16194] = {.lex_state = 0, .external_lex_state = 12},
  [16195] = {.lex_state = 0, .external_lex_state = 12},
  [16196] = {.lex_state = 0, .external_lex_state = 12},
  [16197] = {.lex_state = 409, .external_lex_state = 19},
  [16198] = {.lex_state = 499, .external_lex_state = 12},
  [16199] = {.lex_state = 409, .external_lex_state = 12},
  [16200] = {.lex_state = 0, .external_lex_state = 12},
  [16201] = {.lex_state = 0, .external_lex_state = 12},
  [16202] = {.lex_state = 554, .external_lex_state = 12},
  [16203] = {.lex_state = 0, .external_lex_state = 12},
  [16204] = {.lex_state = 0, .external_lex_state = 12},
  [16205] = {.lex_state = 409, .external_lex_state = 18},
  [16206] = {.lex_state = 0, .external_lex_state = 12},
  [16207] = {.lex_state = 0, .external_lex_state = 12},
  [16208] = {.lex_state = 0, .external_lex_state = 12},
  [16209] = {.lex_state = 409, .external_lex_state = 18},
  [16210] = {.lex_state = 409, .external_lex_state = 19},
  [16211] = {.lex_state = 0, .external_lex_state = 12},
  [16212] = {.lex_state = 409, .external_lex_state = 18},
  [16213] = {.lex_state = 0, .external_lex_state = 12},
  [16214] = {.lex_state = 409, .external_lex_state = 19},
  [16215] = {.lex_state = 0, .external_lex_state = 12},
  [16216] = {.lex_state = 499, .external_lex_state = 12},
  [16217] = {.lex_state = 0, .external_lex_state = 12},
  [16218] = {.lex_state = 409, .external_lex_state = 18},
  [16219] = {.lex_state = 409, .external_lex_state = 19},
  [16220] = {.lex_state = 409, .external_lex_state = 10},
  [16221] = {.lex_state = 409, .external_lex_state = 18},
  [16222] = {.lex_state = 409, .external_lex_state = 18},
  [16223] = {.lex_state = 499, .external_lex_state = 12},
  [16224] = {.lex_state = 0, .external_lex_state = 12},
  [16225] = {.lex_state = 409, .external_lex_state = 18},
  [16226] = {.lex_state = 409, .external_lex_state = 19},
  [16227] = {.lex_state = 499, .external_lex_state = 12},
  [16228] = {.lex_state = 0, .external_lex_state = 12},
  [16229] = {.lex_state = 0, .external_lex_state = 12},
  [16230] = {.lex_state = 409, .external_lex_state = 18},
  [16231] = {.lex_state = 409, .external_lex_state = 19},
  [16232] = {.lex_state = 0, .external_lex_state = 12},
  [16233] = {.lex_state = 409, .external_lex_state = 18},
  [16234] = {.lex_state = 409, .external_lex_state = 19},
  [16235] = {.lex_state = 363, .external_lex_state = 12},
  [16236] = {.lex_state = 499, .external_lex_state = 12},
  [16237] = {.lex_state = 0, .external_lex_state = 12},
  [16238] = {.lex_state = 343, .external_lex_state = 12},
  [16239] = {.lex_state = 343, .external_lex_state = 12},
  [16240] = {.lex_state = 409, .external_lex_state = 15},
  [16241] = {.lex_state = 409, .external_lex_state = 11},
  [16242] = {.lex_state = 343, .external_lex_state = 12},
  [16243] = {.lex_state = 343, .external_lex_state = 12},
  [16244] = {.lex_state = 499, .external_lex_state = 12},
  [16245] = {.lex_state = 409, .external_lex_state = 15},
  [16246] = {.lex_state = 0, .external_lex_state = 12},
  [16247] = {.lex_state = 363, .external_lex_state = 12},
  [16248] = {.lex_state = 409, .external_lex_state = 19},
  [16249] = {.lex_state = 409, .external_lex_state = 19},
  [16250] = {.lex_state = 0, .external_lex_state = 12},
  [16251] = {.lex_state = 499, .external_lex_state = 12},
  [16252] = {.lex_state = 499, .external_lex_state = 12},
  [16253] = {.lex_state = 363, .external_lex_state = 12},
  [16254] = {.lex_state = 0, .external_lex_state = 12},
  [16255] = {.lex_state = 499, .external_lex_state = 12},
  [16256] = {.lex_state = 409, .external_lex_state = 19},
  [16257] = {.lex_state = 409, .external_lex_state = 18},
  [16258] = {.lex_state = 409, .external_lex_state = 18},
  [16259] = {.lex_state = 409, .external_lex_state = 15},
  [16260] = {.lex_state = 409, .external_lex_state = 19},
  [16261] = {.lex_state = 0, .external_lex_state = 12},
  [16262] = {.lex_state = 499, .external_lex_state = 12},
  [16263] = {.lex_state = 0, .external_lex_state = 12},
  [16264] = {.lex_state = 0, .external_lex_state = 12},
  [16265] = {.lex_state = 0, .external_lex_state = 12},
  [16266] = {.lex_state = 0, .external_lex_state = 12},
  [16267] = {.lex_state = 0, .external_lex_state = 12},
  [16268] = {.lex_state = 409, .external_lex_state = 15},
  [16269] = {.lex_state = 0, .external_lex_state = 12},
  [16270] = {.lex_state = 409, .external_lex_state = 19},
  [16271] = {.lex_state = 409, .external_lex_state = 18},
  [16272] = {.lex_state = 409, .external_lex_state = 19},
  [16273] = {.lex_state = 409, .external_lex_state = 18},
  [16274] = {.lex_state = 0, .external_lex_state = 12},
  [16275] = {.lex_state = 0, .external_lex_state = 12},
  [16276] = {.lex_state = 0, .external_lex_state = 12},
  [16277] = {.lex_state = 0, .external_lex_state = 12},
  [16278] = {.lex_state = 0, .external_lex_state = 12},
  [16279] = {.lex_state = 499, .external_lex_state = 12},
  [16280] = {.lex_state = 363, .external_lex_state = 12},
  [16281] = {.lex_state = 409, .external_lex_state = 16},
  [16282] = {.lex_state = 409, .external_lex_state = 18},
  [16283] = {.lex_state = 409, .external_lex_state = 19},
  [16284] = {.lex_state = 0, .external_lex_state = 12},
  [16285] = {.lex_state = 343, .external_lex_state = 12},
  [16286] = {.lex_state = 343, .external_lex_state = 12},
  [16287] = {.lex_state = 554, .external_lex_state = 12},
  [16288] = {.lex_state = 0, .external_lex_state = 12},
  [16289] = {.lex_state = 409, .external_lex_state = 16},
  [16290] = {.lex_state = 343, .external_lex_state = 12},
  [16291] = {.lex_state = 343, .external_lex_state = 12},
  [16292] = {.lex_state = 499, .external_lex_state = 12},
  [16293] = {.lex_state = 499, .external_lex_state = 12},
  [16294] = {.lex_state = 363, .external_lex_state = 12},
  [16295] = {.lex_state = 409, .external_lex_state = 19},
  [16296] = {.lex_state = 409, .external_lex_state = 15},
  [16297] = {.lex_state = 499, .external_lex_state = 12},
  [16298] = {.lex_state = 499, .external_lex_state = 12},
  [16299] = {.lex_state = 363, .external_lex_state = 12},
  [16300] = {.lex_state = 0, .external_lex_state = 12},
  [16301] = {.lex_state = 0, .external_lex_state = 12},
  [16302] = {.lex_state = 499, .external_lex_state = 12},
  [16303] = {.lex_state = 0, .external_lex_state = 12},
  [16304] = {.lex_state = 409, .external_lex_state = 18},
  [16305] = {.lex_state = 0, .external_lex_state = 12},
  [16306] = {.lex_state = 0, .external_lex_state = 12},
  [16307] = {.lex_state = 0, .external_lex_state = 12},
  [16308] = {.lex_state = 0, .external_lex_state = 12},
  [16309] = {.lex_state = 0, .external_lex_state = 12},
  [16310] = {.lex_state = 363, .external_lex_state = 12},
  [16311] = {.lex_state = 0, .external_lex_state = 12},
  [16312] = {.lex_state = 409, .external_lex_state = 18},
  [16313] = {.lex_state = 409, .external_lex_state = 19},
  [16314] = {.lex_state = 0, .external_lex_state = 12},
  [16315] = {.lex_state = 409, .external_lex_state = 19},
  [16316] = {.lex_state = 0, .external_lex_state = 12},
  [16317] = {.lex_state = 0, .external_lex_state = 12},
  [16318] = {.lex_state = 0, .external_lex_state = 12},
  [16319] = {.lex_state = 0, .external_lex_state = 12},
  [16320] = {.lex_state = 0, .external_lex_state = 12},
  [16321] = {.lex_state = 0, .external_lex_state = 12},
  [16322] = {.lex_state = 0, .external_lex_state = 12},
  [16323] = {.lex_state = 0, .external_lex_state = 12},
  [16324] = {.lex_state = 0, .external_lex_state = 12},
  [16325] = {.lex_state = 343, .external_lex_state = 12},
  [16326] = {.lex_state = 343, .external_lex_state = 12},
  [16327] = {.lex_state = 0, .external_lex_state = 12},
  [16328] = {.lex_state = 343, .external_lex_state = 12},
  [16329] = {.lex_state = 343, .external_lex_state = 12},
  [16330] = {.lex_state = 499, .external_lex_state = 12},
  [16331] = {.lex_state = 0, .external_lex_state = 12},
  [16332] = {.lex_state = 499, .external_lex_state = 12},
  [16333] = {.lex_state = 363, .external_lex_state = 12},
  [16334] = {.lex_state = 0, .external_lex_state = 12},
  [16335] = {.lex_state = 0, .external_lex_state = 12},
  [16336] = {.lex_state = 499, .external_lex_state = 12},
  [16337] = {.lex_state = 499, .external_lex_state = 12},
  [16338] = {.lex_state = 363, .external_lex_state = 12},
  [16339] = {.lex_state = 499, .external_lex_state = 12},
  [16340] = {.lex_state = 0, .external_lex_state = 12},
  [16341] = {.lex_state = 0, .external_lex_state = 12},
  [16342] = {.lex_state = 0, .external_lex_state = 12},
  [16343] = {.lex_state = 409, .external_lex_state = 18},
  [16344] = {.lex_state = 409, .external_lex_state = 19},
  [16345] = {.lex_state = 0, .external_lex_state = 12},
  [16346] = {.lex_state = 0, .external_lex_state = 12},
  [16347] = {.lex_state = 343, .external_lex_state = 12},
  [16348] = {.lex_state = 343, .external_lex_state = 12},
  [16349] = {.lex_state = 0, .external_lex_state = 12},
  [16350] = {.lex_state = 0, .external_lex_state = 12},
  [16351] = {.lex_state = 409, .external_lex_state = 18},
  [16352] = {.lex_state = 343, .external_lex_state = 12},
  [16353] = {.lex_state = 0, .external_lex_state = 12},
  [16354] = {.lex_state = 409, .external_lex_state = 19},
  [16355] = {.lex_state = 343, .external_lex_state = 12},
  [16356] = {.lex_state = 343, .external_lex_state = 12},
  [16357] = {.lex_state = 499, .external_lex_state = 12},
  [16358] = {.lex_state = 0, .external_lex_state = 12},
  [16359] = {.lex_state = 0, .external_lex_state = 12},
  [16360] = {.lex_state = 363, .external_lex_state = 12},
  [16361] = {.lex_state = 554, .external_lex_state = 12},
  [16362] = {.lex_state = 0, .external_lex_state = 12},
  [16363] = {.lex_state = 0, .external_lex_state = 12},
  [16364] = {.lex_state = 499, .external_lex_state = 12},
  [16365] = {.lex_state = 499, .external_lex_state = 12},
  [16366] = {.lex_state = 363, .external_lex_state = 12},
  [16367] = {.lex_state = 0, .external_lex_state = 12},
  [16368] = {.lex_state = 0, .external_lex_state = 12},
  [16369] = {.lex_state = 0, .external_lex_state = 12},
  [16370] = {.lex_state = 499, .external_lex_state = 12},
  [16371] = {.lex_state = 0, .external_lex_state = 12},
  [16372] = {.lex_state = 0, .external_lex_state = 12},
  [16373] = {.lex_state = 0, .external_lex_state = 12},
  [16374] = {.lex_state = 0, .external_lex_state = 12},
  [16375] = {.lex_state = 409, .external_lex_state = 18},
  [16376] = {.lex_state = 409, .external_lex_state = 19},
  [16377] = {.lex_state = 0, .external_lex_state = 12},
  [16378] = {.lex_state = 0, .external_lex_state = 12},
  [16379] = {.lex_state = 0, .external_lex_state = 12},
  [16380] = {.lex_state = 343, .external_lex_state = 12},
  [16381] = {.lex_state = 343, .external_lex_state = 12},
  [16382] = {.lex_state = 0, .external_lex_state = 12},
  [16383] = {.lex_state = 0, .external_lex_state = 12},
  [16384] = {.lex_state = 343, .external_lex_state = 12},
  [16385] = {.lex_state = 343, .external_lex_state = 12},
  [16386] = {.lex_state = 499, .external_lex_state = 12},
  [16387] = {.lex_state = 363, .external_lex_state = 12},
  [16388] = {.lex_state = 499, .external_lex_state = 12},
  [16389] = {.lex_state = 499, .external_lex_state = 12},
  [16390] = {.lex_state = 499, .external_lex_state = 12},
  [16391] = {.lex_state = 363, .external_lex_state = 12},
  [16392] = {.lex_state = 499, .external_lex_state = 12},
  [16393] = {.lex_state = 409, .external_lex_state = 16},
  [16394] = {.lex_state = 409, .external_lex_state = 16},
  [16395] = {.lex_state = 363, .external_lex_state = 12},
  [16396] = {.lex_state = 0, .external_lex_state = 12},
  [16397] = {.lex_state = 343, .external_lex_state = 12},
  [16398] = {.lex_state = 343, .external_lex_state = 12},
  [16399] = {.lex_state = 499, .external_lex_state = 12},
  [16400] = {.lex_state = 343, .external_lex_state = 12},
  [16401] = {.lex_state = 343, .external_lex_state = 12},
  [16402] = {.lex_state = 499, .external_lex_state = 12},
  [16403] = {.lex_state = 363, .external_lex_state = 12},
  [16404] = {.lex_state = 499, .external_lex_state = 12},
  [16405] = {.lex_state = 499, .external_lex_state = 12},
  [16406] = {.lex_state = 499, .external_lex_state = 12},
  [16407] = {.lex_state = 363, .external_lex_state = 12},
  [16408] = {.lex_state = 499, .external_lex_state = 12},
  [16409] = {.lex_state = 409, .external_lex_state = 19},
  [16410] = {.lex_state = 499, .external_lex_state = 12},
  [16411] = {.lex_state = 499, .external_lex_state = 12},
  [16412] = {.lex_state = 343, .external_lex_state = 12},
  [16413] = {.lex_state = 343, .external_lex_state = 12},
  [16414] = {.lex_state = 0, .external_lex_state = 12},
  [16415] = {.lex_state = 409, .external_lex_state = 18},
  [16416] = {.lex_state = 409, .external_lex_state = 19},
  [16417] = {.lex_state = 363, .external_lex_state = 12},
  [16418] = {.lex_state = 343, .external_lex_state = 12},
  [16419] = {.lex_state = 343, .external_lex_state = 12},
  [16420] = {.lex_state = 499, .external_lex_state = 12},
  [16421] = {.lex_state = 363, .external_lex_state = 12},
  [16422] = {.lex_state = 499, .external_lex_state = 12},
  [16423] = {.lex_state = 499, .external_lex_state = 12},
  [16424] = {.lex_state = 499, .external_lex_state = 12},
  [16425] = {.lex_state = 363, .external_lex_state = 12},
  [16426] = {.lex_state = 409, .external_lex_state = 18},
  [16427] = {.lex_state = 409, .external_lex_state = 15},
  [16428] = {.lex_state = 409, .external_lex_state = 19},
  [16429] = {.lex_state = 343, .external_lex_state = 12},
  [16430] = {.lex_state = 343, .external_lex_state = 12},
  [16431] = {.lex_state = 0, .external_lex_state = 12},
  [16432] = {.lex_state = 409, .external_lex_state = 18},
  [16433] = {.lex_state = 343, .external_lex_state = 12},
  [16434] = {.lex_state = 343, .external_lex_state = 12},
  [16435] = {.lex_state = 499, .external_lex_state = 12},
  [16436] = {.lex_state = 363, .external_lex_state = 12},
  [16437] = {.lex_state = 409, .external_lex_state = 19},
  [16438] = {.lex_state = 499, .external_lex_state = 12},
  [16439] = {.lex_state = 499, .external_lex_state = 12},
  [16440] = {.lex_state = 363, .external_lex_state = 12},
  [16441] = {.lex_state = 499, .external_lex_state = 12},
  [16442] = {.lex_state = 499, .external_lex_state = 12},
  [16443] = {.lex_state = 409, .external_lex_state = 18},
  [16444] = {.lex_state = 499, .external_lex_state = 12},
  [16445] = {.lex_state = 343, .external_lex_state = 12},
  [16446] = {.lex_state = 343, .external_lex_state = 12},
  [16447] = {.lex_state = 409, .external_lex_state = 18},
  [16448] = {.lex_state = 409, .external_lex_state = 19},
  [16449] = {.lex_state = 343, .external_lex_state = 12},
  [16450] = {.lex_state = 343, .external_lex_state = 12},
  [16451] = {.lex_state = 499, .external_lex_state = 12},
  [16452] = {.lex_state = 363, .external_lex_state = 12},
  [16453] = {.lex_state = 409, .external_lex_state = 19},
  [16454] = {.lex_state = 499, .external_lex_state = 12},
  [16455] = {.lex_state = 499, .external_lex_state = 12},
  [16456] = {.lex_state = 363, .external_lex_state = 12},
  [16457] = {.lex_state = 409, .external_lex_state = 18},
  [16458] = {.lex_state = 0, .external_lex_state = 12},
  [16459] = {.lex_state = 409, .external_lex_state = 19},
  [16460] = {.lex_state = 0, .external_lex_state = 12},
  [16461] = {.lex_state = 343, .external_lex_state = 12},
  [16462] = {.lex_state = 343, .external_lex_state = 12},
  [16463] = {.lex_state = 0, .external_lex_state = 12},
  [16464] = {.lex_state = 0, .external_lex_state = 12},
  [16465] = {.lex_state = 343, .external_lex_state = 12},
  [16466] = {.lex_state = 343, .external_lex_state = 12},
  [16467] = {.lex_state = 499, .external_lex_state = 12},
  [16468] = {.lex_state = 0, .external_lex_state = 12},
  [16469] = {.lex_state = 363, .external_lex_state = 12},
  [16470] = {.lex_state = 499, .external_lex_state = 12},
  [16471] = {.lex_state = 499, .external_lex_state = 12},
  [16472] = {.lex_state = 363, .external_lex_state = 12},
  [16473] = {.lex_state = 0, .external_lex_state = 12},
  [16474] = {.lex_state = 0, .external_lex_state = 12},
  [16475] = {.lex_state = 0, .external_lex_state = 12},
  [16476] = {.lex_state = 0, .external_lex_state = 12},
  [16477] = {.lex_state = 0, .external_lex_state = 12},
  [16478] = {.lex_state = 363, .external_lex_state = 12},
  [16479] = {.lex_state = 343, .external_lex_state = 12},
  [16480] = {.lex_state = 343, .external_lex_state = 12},
  [16481] = {.lex_state = 499, .external_lex_state = 12},
  [16482] = {.lex_state = 343, .external_lex_state = 12},
  [16483] = {.lex_state = 343, .external_lex_state = 12},
  [16484] = {.lex_state = 499, .external_lex_state = 12},
  [16485] = {.lex_state = 499, .external_lex_state = 12},
  [16486] = {.lex_state = 363, .external_lex_state = 12},
  [16487] = {.lex_state = 409, .external_lex_state = 18},
  [16488] = {.lex_state = 499, .external_lex_state = 12},
  [16489] = {.lex_state = 499, .external_lex_state = 12},
  [16490] = {.lex_state = 363, .external_lex_state = 12},
  [16491] = {.lex_state = 409, .external_lex_state = 19},
  [16492] = {.lex_state = 409, .external_lex_state = 18},
  [16493] = {.lex_state = 409, .external_lex_state = 19},
  [16494] = {.lex_state = 409, .external_lex_state = 18},
  [16495] = {.lex_state = 499, .external_lex_state = 12},
  [16496] = {.lex_state = 499, .external_lex_state = 12},
  [16497] = {.lex_state = 409, .external_lex_state = 19},
  [16498] = {.lex_state = 409, .external_lex_state = 18},
  [16499] = {.lex_state = 499, .external_lex_state = 12},
  [16500] = {.lex_state = 499, .external_lex_state = 12},
  [16501] = {.lex_state = 409, .external_lex_state = 19},
  [16502] = {.lex_state = 0, .external_lex_state = 12},
  [16503] = {.lex_state = 0, .external_lex_state = 12},
  [16504] = {.lex_state = 0, .external_lex_state = 12},
  [16505] = {.lex_state = 0, .external_lex_state = 12},
  [16506] = {.lex_state = 0, .external_lex_state = 12},
  [16507] = {.lex_state = 409, .external_lex_state = 18},
  [16508] = {.lex_state = 0, .external_lex_state = 12},
  [16509] = {.lex_state = 0, .external_lex_state = 12},
  [16510] = {.lex_state = 0, .external_lex_state = 12},
  [16511] = {.lex_state = 409, .external_lex_state = 19},
  [16512] = {.lex_state = 343, .external_lex_state = 12},
  [16513] = {.lex_state = 409, .external_lex_state = 18},
  [16514] = {.lex_state = 409, .external_lex_state = 19},
  [16515] = {.lex_state = 0, .external_lex_state = 12},
  [16516] = {.lex_state = 343, .external_lex_state = 12},
  [16517] = {.lex_state = 0, .external_lex_state = 12},
  [16518] = {.lex_state = 0, .external_lex_state = 12},
  [16519] = {.lex_state = 0, .external_lex_state = 12},
  [16520] = {.lex_state = 499, .external_lex_state = 12},
  [16521] = {.lex_state = 0, .external_lex_state = 12},
  [16522] = {.lex_state = 0, .external_lex_state = 12},
  [16523] = {.lex_state = 0, .external_lex_state = 12},
  [16524] = {.lex_state = 409, .external_lex_state = 18},
  [16525] = {.lex_state = 409, .external_lex_state = 19},
  [16526] = {.lex_state = 499, .external_lex_state = 12},
  [16527] = {.lex_state = 0, .external_lex_state = 12},
  [16528] = {.lex_state = 0, .external_lex_state = 12},
  [16529] = {.lex_state = 0, .external_lex_state = 12},
  [16530] = {.lex_state = 409, .external_lex_state = 10},
  [16531] = {.lex_state = 0, .external_lex_state = 12},
  [16532] = {.lex_state = 0, .external_lex_state = 12},
  [16533] = {.lex_state = 0, .external_lex_state = 12},
  [16534] = {.lex_state = 499, .external_lex_state = 12},
  [16535] = {.lex_state = 0, .external_lex_state = 12},
  [16536] = {.lex_state = 0, .external_lex_state = 12},
  [16537] = {.lex_state = 499, .external_lex_state = 12},
  [16538] = {.lex_state = 554, .external_lex_state = 12},
  [16539] = {.lex_state = 409, .external_lex_state = 18},
  [16540] = {.lex_state = 0, .external_lex_state = 12},
  [16541] = {.lex_state = 0, .external_lex_state = 12},
  [16542] = {.lex_state = 0, .external_lex_state = 12},
  [16543] = {.lex_state = 409, .external_lex_state = 19},
  [16544] = {.lex_state = 0, .external_lex_state = 12},
  [16545] = {.lex_state = 409, .external_lex_state = 18},
  [16546] = {.lex_state = 0, .external_lex_state = 12},
  [16547] = {.lex_state = 499, .external_lex_state = 12},
  [16548] = {.lex_state = 499, .external_lex_state = 12},
  [16549] = {.lex_state = 409, .external_lex_state = 15},
  [16550] = {.lex_state = 0, .external_lex_state = 12},
  [16551] = {.lex_state = 0, .external_lex_state = 12},
  [16552] = {.lex_state = 0, .external_lex_state = 12},
  [16553] = {.lex_state = 409, .external_lex_state = 18},
  [16554] = {.lex_state = 409, .external_lex_state = 19},
  [16555] = {.lex_state = 409, .external_lex_state = 18},
  [16556] = {.lex_state = 409, .external_lex_state = 15},
  [16557] = {.lex_state = 0, .external_lex_state = 12},
  [16558] = {.lex_state = 499, .external_lex_state = 12},
  [16559] = {.lex_state = 409, .external_lex_state = 19},
  [16560] = {.lex_state = 0, .external_lex_state = 12},
  [16561] = {.lex_state = 409, .external_lex_state = 18},
  [16562] = {.lex_state = 409, .external_lex_state = 19},
  [16563] = {.lex_state = 499, .external_lex_state = 12},
  [16564] = {.lex_state = 0, .external_lex_state = 12},
  [16565] = {.lex_state = 409, .external_lex_state = 19},
  [16566] = {.lex_state = 0, .external_lex_state = 12},
  [16567] = {.lex_state = 0, .external_lex_state = 12},
  [16568] = {.lex_state = 0, .external_lex_state = 12},
  [16569] = {.lex_state = 0, .external_lex_state = 12},
  [16570] = {.lex_state = 0, .external_lex_state = 12},
  [16571] = {.lex_state = 499, .external_lex_state = 12},
  [16572] = {.lex_state = 0, .external_lex_state = 12},
  [16573] = {.lex_state = 409, .external_lex_state = 18},
  [16574] = {.lex_state = 0, .external_lex_state = 12},
  [16575] = {.lex_state = 0, .external_lex_state = 12},
  [16576] = {.lex_state = 0, .external_lex_state = 12},
  [16577] = {.lex_state = 409, .external_lex_state = 18},
  [16578] = {.lex_state = 409, .external_lex_state = 19},
  [16579] = {.lex_state = 499, .external_lex_state = 12},
  [16580] = {.lex_state = 0, .external_lex_state = 12},
  [16581] = {.lex_state = 0, .external_lex_state = 12},
  [16582] = {.lex_state = 0, .external_lex_state = 12},
  [16583] = {.lex_state = 0, .external_lex_state = 12},
  [16584] = {.lex_state = 343, .external_lex_state = 12},
  [16585] = {.lex_state = 0, .external_lex_state = 12},
  [16586] = {.lex_state = 0, .external_lex_state = 12},
  [16587] = {.lex_state = 0, .external_lex_state = 12},
  [16588] = {.lex_state = 409, .external_lex_state = 11},
  [16589] = {.lex_state = 0, .external_lex_state = 12},
  [16590] = {.lex_state = 409, .external_lex_state = 18},
  [16591] = {.lex_state = 409, .external_lex_state = 19},
  [16592] = {.lex_state = 0, .external_lex_state = 12},
  [16593] = {.lex_state = 409, .external_lex_state = 18},
  [16594] = {.lex_state = 343, .external_lex_state = 12},
  [16595] = {.lex_state = 409, .external_lex_state = 19},
  [16596] = {.lex_state = 0, .external_lex_state = 12},
  [16597] = {.lex_state = 499, .external_lex_state = 12},
  [16598] = {.lex_state = 0, .external_lex_state = 12},
  [16599] = {.lex_state = 499, .external_lex_state = 12},
  [16600] = {.lex_state = 409, .external_lex_state = 19},
  [16601] = {.lex_state = 343, .external_lex_state = 12},
  [16602] = {.lex_state = 409, .external_lex_state = 18},
  [16603] = {.lex_state = 0, .external_lex_state = 12},
  [16604] = {.lex_state = 499, .external_lex_state = 12},
  [16605] = {.lex_state = 409, .external_lex_state = 19},
  [16606] = {.lex_state = 409, .external_lex_state = 18},
  [16607] = {.lex_state = 343, .external_lex_state = 12},
  [16608] = {.lex_state = 409, .external_lex_state = 19},
  [16609] = {.lex_state = 0, .external_lex_state = 12},
  [16610] = {.lex_state = 0, .external_lex_state = 12},
  [16611] = {.lex_state = 0, .external_lex_state = 12},
  [16612] = {.lex_state = 0, .external_lex_state = 12},
  [16613] = {.lex_state = 0, .external_lex_state = 12},
  [16614] = {.lex_state = 343, .external_lex_state = 12},
  [16615] = {.lex_state = 499, .external_lex_state = 12},
  [16616] = {.lex_state = 0, .external_lex_state = 12},
  [16617] = {.lex_state = 343, .external_lex_state = 12},
  [16618] = {.lex_state = 343, .external_lex_state = 12},
  [16619] = {.lex_state = 343, .external_lex_state = 12},
  [16620] = {.lex_state = 499, .external_lex_state = 12},
  [16621] = {.lex_state = 0, .external_lex_state = 12},
  [16622] = {.lex_state = 343, .external_lex_state = 12},
  [16623] = {.lex_state = 343, .external_lex_state = 12},
  [16624] = {.lex_state = 499, .external_lex_state = 12},
  [16625] = {.lex_state = 343, .external_lex_state = 12},
  [16626] = {.lex_state = 409, .external_lex_state = 18},
  [16627] = {.lex_state = 409, .external_lex_state = 19},
  [16628] = {.lex_state = 409, .external_lex_state = 18},
  [16629] = {.lex_state = 409, .external_lex_state = 19},
  [16630] = {.lex_state = 499, .external_lex_state = 12},
  [16631] = {.lex_state = 0, .external_lex_state = 12},
  [16632] = {.lex_state = 0, .external_lex_state = 12},
  [16633] = {.lex_state = 499, .external_lex_state = 12},
  [16634] = {.lex_state = 0, .external_lex_state = 12},
  [16635] = {.lex_state = 499, .external_lex_state = 12},
  [16636] = {.lex_state = 0, .external_lex_state = 12},
  [16637] = {.lex_state = 499, .external_lex_state = 12},
  [16638] = {.lex_state = 499, .external_lex_state = 12},
  [16639] = {.lex_state = 409, .external_lex_state = 18},
  [16640] = {.lex_state = 409, .external_lex_state = 19},
  [16641] = {.lex_state = 0, .external_lex_state = 12},
  [16642] = {.lex_state = 0, .external_lex_state = 12},
  [16643] = {.lex_state = 0, .external_lex_state = 12},
  [16644] = {.lex_state = 0, .external_lex_state = 12},
  [16645] = {.lex_state = 499, .external_lex_state = 12},
  [16646] = {.lex_state = 0, .external_lex_state = 12},
  [16647] = {.lex_state = 0, .external_lex_state = 12},
  [16648] = {.lex_state = 0, .external_lex_state = 12},
  [16649] = {.lex_state = 0, .external_lex_state = 12},
  [16650] = {.lex_state = 409, .external_lex_state = 18},
  [16651] = {.lex_state = 0, .external_lex_state = 12},
  [16652] = {.lex_state = 409, .external_lex_state = 18},
  [16653] = {.lex_state = 409, .external_lex_state = 19},
  [16654] = {.lex_state = 409, .external_lex_state = 19},
  [16655] = {.lex_state = 363, .external_lex_state = 12},
  [16656] = {.lex_state = 0, .external_lex_state = 12},
  [16657] = {.lex_state = 0, .external_lex_state = 12},
  [16658] = {.lex_state = 0, .external_lex_state = 12},
  [16659] = {.lex_state = 0, .external_lex_state = 12},
  [16660] = {.lex_state = 0, .external_lex_state = 12},
  [16661] = {.lex_state = 0, .external_lex_state = 12},
  [16662] = {.lex_state = 0, .external_lex_state = 12},
  [16663] = {.lex_state = 0, .external_lex_state = 12},
  [16664] = {.lex_state = 0, .external_lex_state = 12},
  [16665] = {.lex_state = 0, .external_lex_state = 12},
  [16666] = {.lex_state = 499, .external_lex_state = 12},
  [16667] = {.lex_state = 0, .external_lex_state = 12},
  [16668] = {.lex_state = 0, .external_lex_state = 12},
  [16669] = {.lex_state = 0, .external_lex_state = 12},
  [16670] = {.lex_state = 0, .external_lex_state = 12},
  [16671] = {.lex_state = 0, .external_lex_state = 12},
  [16672] = {.lex_state = 0, .external_lex_state = 12},
  [16673] = {.lex_state = 363, .external_lex_state = 12},
  [16674] = {.lex_state = 0, .external_lex_state = 12},
  [16675] = {.lex_state = 0, .external_lex_state = 12},
  [16676] = {.lex_state = 363, .external_lex_state = 12},
  [16677] = {.lex_state = 363, .external_lex_state = 12},
  [16678] = {.lex_state = 364, .external_lex_state = 12},
  [16679] = {.lex_state = 343, .external_lex_state = 12},
  [16680] = {.lex_state = 0, .external_lex_state = 12},
  [16681] = {.lex_state = 363, .external_lex_state = 12},
  [16682] = {.lex_state = 0, .external_lex_state = 12},
  [16683] = {.lex_state = 343, .external_lex_state = 12},
  [16684] = {.lex_state = 363, .external_lex_state = 12},
  [16685] = {.lex_state = 0, .external_lex_state = 12},
  [16686] = {.lex_state = 0, .external_lex_state = 12},
  [16687] = {.lex_state = 0, .external_lex_state = 12},
  [16688] = {.lex_state = 0, .external_lex_state = 10},
  [16689] = {.lex_state = 0, .external_lex_state = 12},
  [16690] = {.lex_state = 0, .external_lex_state = 12},
  [16691] = {.lex_state = 0, .external_lex_state = 12},
  [16692] = {.lex_state = 0, .external_lex_state = 12},
  [16693] = {.lex_state = 363, .external_lex_state = 12},
  [16694] = {.lex_state = 0, .external_lex_state = 12},
  [16695] = {.lex_state = 0, .external_lex_state = 12},
  [16696] = {.lex_state = 0, .external_lex_state = 12},
  [16697] = {.lex_state = 0, .external_lex_state = 12},
  [16698] = {.lex_state = 0, .external_lex_state = 12},
  [16699] = {.lex_state = 363, .external_lex_state = 12},
  [16700] = {.lex_state = 0, .external_lex_state = 12},
  [16701] = {.lex_state = 0, .external_lex_state = 10},
  [16702] = {.lex_state = 363, .external_lex_state = 12},
  [16703] = {.lex_state = 0, .external_lex_state = 12},
  [16704] = {.lex_state = 0, .external_lex_state = 12},
  [16705] = {.lex_state = 363, .external_lex_state = 12},
  [16706] = {.lex_state = 409, .external_lex_state = 12},
  [16707] = {.lex_state = 0, .external_lex_state = 12},
  [16708] = {.lex_state = 363, .external_lex_state = 12},
  [16709] = {.lex_state = 0, .external_lex_state = 12},
  [16710] = {.lex_state = 363, .external_lex_state = 12},
  [16711] = {.lex_state = 363, .external_lex_state = 12},
  [16712] = {.lex_state = 0, .external_lex_state = 12},
  [16713] = {.lex_state = 363, .external_lex_state = 12},
  [16714] = {.lex_state = 0, .external_lex_state = 12},
  [16715] = {.lex_state = 0, .external_lex_state = 12},
  [16716] = {.lex_state = 0, .external_lex_state = 12},
  [16717] = {.lex_state = 0, .external_lex_state = 12},
  [16718] = {.lex_state = 0, .external_lex_state = 12},
  [16719] = {.lex_state = 0, .external_lex_state = 12},
  [16720] = {.lex_state = 343, .external_lex_state = 12},
  [16721] = {.lex_state = 409, .external_lex_state = 12},
  [16722] = {.lex_state = 363, .external_lex_state = 12},
  [16723] = {.lex_state = 0, .external_lex_state = 12},
  [16724] = {.lex_state = 363, .external_lex_state = 12},
  [16725] = {.lex_state = 0, .external_lex_state = 12},
  [16726] = {.lex_state = 363, .external_lex_state = 12},
  [16727] = {.lex_state = 0, .external_lex_state = 12},
  [16728] = {.lex_state = 363, .external_lex_state = 12},
  [16729] = {.lex_state = 409, .external_lex_state = 12},
  [16730] = {.lex_state = 0, .external_lex_state = 12},
  [16731] = {.lex_state = 363, .external_lex_state = 12},
  [16732] = {.lex_state = 0, .external_lex_state = 12},
  [16733] = {.lex_state = 0, .external_lex_state = 12},
  [16734] = {.lex_state = 0, .external_lex_state = 12},
  [16735] = {.lex_state = 0, .external_lex_state = 10},
  [16736] = {.lex_state = 0, .external_lex_state = 12},
  [16737] = {.lex_state = 0, .external_lex_state = 12},
  [16738] = {.lex_state = 363, .external_lex_state = 12},
  [16739] = {.lex_state = 363, .external_lex_state = 12},
  [16740] = {.lex_state = 0, .external_lex_state = 12},
  [16741] = {.lex_state = 0, .external_lex_state = 12},
  [16742] = {.lex_state = 0, .external_lex_state = 12},
  [16743] = {.lex_state = 0, .external_lex_state = 12},
  [16744] = {.lex_state = 0, .external_lex_state = 10},
  [16745] = {.lex_state = 0, .external_lex_state = 12},
  [16746] = {.lex_state = 0, .external_lex_state = 12},
  [16747] = {.lex_state = 0, .external_lex_state = 12},
  [16748] = {.lex_state = 0, .external_lex_state = 12},
  [16749] = {.lex_state = 0, .external_lex_state = 12},
  [16750] = {.lex_state = 0, .external_lex_state = 12},
  [16751] = {.lex_state = 363, .external_lex_state = 12},
  [16752] = {.lex_state = 0, .external_lex_state = 12},
  [16753] = {.lex_state = 0, .external_lex_state = 12},
  [16754] = {.lex_state = 363, .external_lex_state = 12},
  [16755] = {.lex_state = 0, .external_lex_state = 10},
  [16756] = {.lex_state = 363, .external_lex_state = 12},
  [16757] = {.lex_state = 0, .external_lex_state = 12},
  [16758] = {.lex_state = 0, .external_lex_state = 10},
  [16759] = {.lex_state = 0, .external_lex_state = 12},
  [16760] = {.lex_state = 0, .external_lex_state = 12},
  [16761] = {.lex_state = 0, .external_lex_state = 12},
  [16762] = {.lex_state = 0, .external_lex_state = 12},
  [16763] = {.lex_state = 0, .external_lex_state = 12},
  [16764] = {.lex_state = 0, .external_lex_state = 12},
  [16765] = {.lex_state = 0, .external_lex_state = 12},
  [16766] = {.lex_state = 0, .external_lex_state = 11},
  [16767] = {.lex_state = 0, .external_lex_state = 12},
  [16768] = {.lex_state = 0, .external_lex_state = 12},
  [16769] = {.lex_state = 0, .external_lex_state = 12},
  [16770] = {.lex_state = 0, .external_lex_state = 12},
  [16771] = {.lex_state = 0, .external_lex_state = 12},
  [16772] = {.lex_state = 363, .external_lex_state = 12},
  [16773] = {.lex_state = 0, .external_lex_state = 12},
  [16774] = {.lex_state = 0, .external_lex_state = 12},
  [16775] = {.lex_state = 0, .external_lex_state = 12},
  [16776] = {.lex_state = 0, .external_lex_state = 12},
  [16777] = {.lex_state = 499, .external_lex_state = 12},
  [16778] = {.lex_state = 409, .external_lex_state = 12},
  [16779] = {.lex_state = 363, .external_lex_state = 12},
  [16780] = {.lex_state = 0, .external_lex_state = 12},
  [16781] = {.lex_state = 0, .external_lex_state = 12},
  [16782] = {.lex_state = 0, .external_lex_state = 12},
  [16783] = {.lex_state = 0, .external_lex_state = 10},
  [16784] = {.lex_state = 0, .external_lex_state = 12},
  [16785] = {.lex_state = 0, .external_lex_state = 12},
  [16786] = {.lex_state = 363, .external_lex_state = 12},
  [16787] = {.lex_state = 0, .external_lex_state = 12},
  [16788] = {.lex_state = 0, .external_lex_state = 12},
  [16789] = {.lex_state = 0, .external_lex_state = 12},
  [16790] = {.lex_state = 0, .external_lex_state = 12},
  [16791] = {.lex_state = 0, .external_lex_state = 12},
  [16792] = {.lex_state = 0, .external_lex_state = 12},
  [16793] = {.lex_state = 0, .external_lex_state = 12},
  [16794] = {.lex_state = 363, .external_lex_state = 12},
  [16795] = {.lex_state = 0, .external_lex_state = 12},
  [16796] = {.lex_state = 0, .external_lex_state = 10},
  [16797] = {.lex_state = 0, .external_lex_state = 12},
  [16798] = {.lex_state = 0, .external_lex_state = 12},
  [16799] = {.lex_state = 0, .external_lex_state = 12},
  [16800] = {.lex_state = 0, .external_lex_state = 12},
  [16801] = {.lex_state = 0, .external_lex_state = 12},
  [16802] = {.lex_state = 409, .external_lex_state = 12},
  [16803] = {.lex_state = 0, .external_lex_state = 12},
  [16804] = {.lex_state = 412, .external_lex_state = 12},
  [16805] = {.lex_state = 0, .external_lex_state = 12},
  [16806] = {.lex_state = 0, .external_lex_state = 12},
  [16807] = {.lex_state = 0, .external_lex_state = 12},
  [16808] = {.lex_state = 0, .external_lex_state = 12},
  [16809] = {.lex_state = 0, .external_lex_state = 12},
  [16810] = {.lex_state = 0, .external_lex_state = 12},
  [16811] = {.lex_state = 0, .external_lex_state = 12},
  [16812] = {.lex_state = 0, .external_lex_state = 12},
  [16813] = {.lex_state = 0, .external_lex_state = 12},
  [16814] = {.lex_state = 0, .external_lex_state = 12},
  [16815] = {.lex_state = 0, .external_lex_state = 12},
  [16816] = {.lex_state = 0, .external_lex_state = 12},
  [16817] = {.lex_state = 0, .external_lex_state = 12},
  [16818] = {.lex_state = 0, .external_lex_state = 12},
  [16819] = {.lex_state = 0, .external_lex_state = 12},
  [16820] = {.lex_state = 0, .external_lex_state = 12},
  [16821] = {.lex_state = 0, .external_lex_state = 12},
  [16822] = {.lex_state = 0, .external_lex_state = 12},
  [16823] = {.lex_state = 0, .external_lex_state = 12},
  [16824] = {.lex_state = 0, .external_lex_state = 10},
  [16825] = {.lex_state = 0, .external_lex_state = 12},
  [16826] = {.lex_state = 0, .external_lex_state = 12},
  [16827] = {.lex_state = 0, .external_lex_state = 10},
  [16828] = {.lex_state = 363, .external_lex_state = 12},
  [16829] = {.lex_state = 0, .external_lex_state = 12},
  [16830] = {.lex_state = 0, .external_lex_state = 12},
  [16831] = {.lex_state = 0, .external_lex_state = 12},
  [16832] = {.lex_state = 363, .external_lex_state = 12},
  [16833] = {.lex_state = 0, .external_lex_state = 12},
  [16834] = {.lex_state = 0, .external_lex_state = 10},
  [16835] = {.lex_state = 0, .external_lex_state = 12},
  [16836] = {.lex_state = 0, .external_lex_state = 12},
  [16837] = {.lex_state = 0, .external_lex_state = 12},
  [16838] = {.lex_state = 363, .external_lex_state = 12},
  [16839] = {.lex_state = 0, .external_lex_state = 12},
  [16840] = {.lex_state = 0, .external_lex_state = 12},
  [16841] = {.lex_state = 0, .external_lex_state = 12},
  [16842] = {.lex_state = 363, .external_lex_state = 12},
  [16843] = {.lex_state = 0, .external_lex_state = 12},
  [16844] = {.lex_state = 0, .external_lex_state = 12},
  [16845] = {.lex_state = 0, .external_lex_state = 12},
  [16846] = {.lex_state = 0, .external_lex_state = 12},
  [16847] = {.lex_state = 0, .external_lex_state = 12},
  [16848] = {.lex_state = 343, .external_lex_state = 12},
  [16849] = {.lex_state = 0, .external_lex_state = 12},
  [16850] = {.lex_state = 0, .external_lex_state = 12},
  [16851] = {.lex_state = 0, .external_lex_state = 12},
  [16852] = {.lex_state = 0, .external_lex_state = 12},
  [16853] = {.lex_state = 0, .external_lex_state = 12},
  [16854] = {.lex_state = 0, .external_lex_state = 10},
  [16855] = {.lex_state = 0, .external_lex_state = 12},
  [16856] = {.lex_state = 409, .external_lex_state = 12},
  [16857] = {.lex_state = 0, .external_lex_state = 12},
  [16858] = {.lex_state = 363, .external_lex_state = 12},
  [16859] = {.lex_state = 363, .external_lex_state = 12},
  [16860] = {.lex_state = 0, .external_lex_state = 12},
  [16861] = {.lex_state = 343, .external_lex_state = 12},
  [16862] = {.lex_state = 363, .external_lex_state = 12},
  [16863] = {.lex_state = 0, .external_lex_state = 12},
  [16864] = {.lex_state = 0, .external_lex_state = 10},
  [16865] = {.lex_state = 0, .external_lex_state = 12},
  [16866] = {.lex_state = 0, .external_lex_state = 12},
  [16867] = {.lex_state = 0, .external_lex_state = 12},
  [16868] = {.lex_state = 0, .external_lex_state = 12},
  [16869] = {.lex_state = 0, .external_lex_state = 12},
  [16870] = {.lex_state = 343, .external_lex_state = 12},
  [16871] = {.lex_state = 363, .external_lex_state = 12},
  [16872] = {.lex_state = 0, .external_lex_state = 12},
  [16873] = {.lex_state = 0, .external_lex_state = 12},
  [16874] = {.lex_state = 0, .external_lex_state = 12},
  [16875] = {.lex_state = 0, .external_lex_state = 12},
  [16876] = {.lex_state = 0, .external_lex_state = 12},
  [16877] = {.lex_state = 0, .external_lex_state = 12},
  [16878] = {.lex_state = 0, .external_lex_state = 10},
  [16879] = {.lex_state = 343, .external_lex_state = 12},
  [16880] = {.lex_state = 0, .external_lex_state = 12},
  [16881] = {.lex_state = 0, .external_lex_state = 12},
  [16882] = {.lex_state = 0, .external_lex_state = 12},
  [16883] = {.lex_state = 0, .external_lex_state = 12},
  [16884] = {.lex_state = 0, .external_lex_state = 12},
  [16885] = {.lex_state = 363, .external_lex_state = 12},
  [16886] = {.lex_state = 363, .external_lex_state = 12},
  [16887] = {.lex_state = 0, .external_lex_state = 10},
  [16888] = {.lex_state = 363, .external_lex_state = 12},
  [16889] = {.lex_state = 0, .external_lex_state = 12},
  [16890] = {.lex_state = 0, .external_lex_state = 12},
  [16891] = {.lex_state = 0, .external_lex_state = 12},
  [16892] = {.lex_state = 0, .external_lex_state = 12},
  [16893] = {.lex_state = 0, .external_lex_state = 12},
  [16894] = {.lex_state = 0, .external_lex_state = 12},
  [16895] = {.lex_state = 0, .external_lex_state = 12},
  [16896] = {.lex_state = 0, .external_lex_state = 12},
  [16897] = {.lex_state = 0, .external_lex_state = 12},
  [16898] = {.lex_state = 0, .external_lex_state = 10},
  [16899] = {.lex_state = 0, .external_lex_state = 12},
  [16900] = {.lex_state = 0, .external_lex_state = 12},
  [16901] = {.lex_state = 0, .external_lex_state = 12},
  [16902] = {.lex_state = 0, .external_lex_state = 12},
  [16903] = {.lex_state = 363, .external_lex_state = 12},
  [16904] = {.lex_state = 0, .external_lex_state = 12},
  [16905] = {.lex_state = 363, .external_lex_state = 12},
  [16906] = {.lex_state = 363, .external_lex_state = 12},
  [16907] = {.lex_state = 0, .external_lex_state = 10},
  [16908] = {.lex_state = 363, .external_lex_state = 12},
  [16909] = {.lex_state = 0, .external_lex_state = 12},
  [16910] = {.lex_state = 0, .external_lex_state = 12},
  [16911] = {.lex_state = 0, .external_lex_state = 12},
  [16912] = {.lex_state = 0, .external_lex_state = 12},
  [16913] = {.lex_state = 0, .external_lex_state = 12},
  [16914] = {.lex_state = 0, .external_lex_state = 12},
  [16915] = {.lex_state = 0, .external_lex_state = 12},
  [16916] = {.lex_state = 363, .external_lex_state = 12},
  [16917] = {.lex_state = 363, .external_lex_state = 12},
  [16918] = {.lex_state = 0, .external_lex_state = 12},
  [16919] = {.lex_state = 0, .external_lex_state = 12},
  [16920] = {.lex_state = 0, .external_lex_state = 12},
  [16921] = {.lex_state = 0, .external_lex_state = 10},
  [16922] = {.lex_state = 0, .external_lex_state = 12},
  [16923] = {.lex_state = 0, .external_lex_state = 12},
  [16924] = {.lex_state = 363, .external_lex_state = 12},
  [16925] = {.lex_state = 0, .external_lex_state = 10},
  [16926] = {.lex_state = 0, .external_lex_state = 12},
  [16927] = {.lex_state = 0, .external_lex_state = 12},
  [16928] = {.lex_state = 363, .external_lex_state = 12},
  [16929] = {.lex_state = 0, .external_lex_state = 12},
  [16930] = {.lex_state = 0, .external_lex_state = 10},
  [16931] = {.lex_state = 0, .external_lex_state = 12},
  [16932] = {.lex_state = 0, .external_lex_state = 12},
  [16933] = {.lex_state = 0, .external_lex_state = 12},
  [16934] = {.lex_state = 343, .external_lex_state = 12},
  [16935] = {.lex_state = 0, .external_lex_state = 12},
  [16936] = {.lex_state = 0, .external_lex_state = 12},
  [16937] = {.lex_state = 0, .external_lex_state = 12},
  [16938] = {.lex_state = 0, .external_lex_state = 12},
  [16939] = {.lex_state = 0, .external_lex_state = 12},
  [16940] = {.lex_state = 363, .external_lex_state = 12},
  [16941] = {.lex_state = 363, .external_lex_state = 12},
  [16942] = {.lex_state = 0, .external_lex_state = 12},
  [16943] = {.lex_state = 363, .external_lex_state = 12},
  [16944] = {.lex_state = 0, .external_lex_state = 12},
  [16945] = {.lex_state = 0, .external_lex_state = 12},
  [16946] = {.lex_state = 0, .external_lex_state = 10},
  [16947] = {.lex_state = 0, .external_lex_state = 12},
  [16948] = {.lex_state = 0, .external_lex_state = 12},
  [16949] = {.lex_state = 0, .external_lex_state = 12},
  [16950] = {.lex_state = 0, .external_lex_state = 12},
  [16951] = {.lex_state = 0, .external_lex_state = 12},
  [16952] = {.lex_state = 0, .external_lex_state = 12},
  [16953] = {.lex_state = 0, .external_lex_state = 12},
  [16954] = {.lex_state = 0, .external_lex_state = 12},
  [16955] = {.lex_state = 363, .external_lex_state = 12},
  [16956] = {.lex_state = 0, .external_lex_state = 12},
  [16957] = {.lex_state = 0, .external_lex_state = 10},
  [16958] = {.lex_state = 0, .external_lex_state = 12},
  [16959] = {.lex_state = 0, .external_lex_state = 12},
  [16960] = {.lex_state = 363, .external_lex_state = 12},
  [16961] = {.lex_state = 0, .external_lex_state = 12},
  [16962] = {.lex_state = 0, .external_lex_state = 12},
  [16963] = {.lex_state = 0, .external_lex_state = 12},
  [16964] = {.lex_state = 0, .external_lex_state = 12},
  [16965] = {.lex_state = 0, .external_lex_state = 12},
  [16966] = {.lex_state = 0, .external_lex_state = 12},
  [16967] = {.lex_state = 0, .external_lex_state = 12},
  [16968] = {.lex_state = 363, .external_lex_state = 12},
  [16969] = {.lex_state = 0, .external_lex_state = 12},
  [16970] = {.lex_state = 0, .external_lex_state = 12},
  [16971] = {.lex_state = 409, .external_lex_state = 12},
  [16972] = {.lex_state = 409, .external_lex_state = 12},
  [16973] = {.lex_state = 0, .external_lex_state = 10},
  [16974] = {.lex_state = 363, .external_lex_state = 12},
  [16975] = {.lex_state = 0, .external_lex_state = 12},
  [16976] = {.lex_state = 363, .external_lex_state = 12},
  [16977] = {.lex_state = 0, .external_lex_state = 12},
  [16978] = {.lex_state = 0, .external_lex_state = 12},
  [16979] = {.lex_state = 363, .external_lex_state = 12},
  [16980] = {.lex_state = 0, .external_lex_state = 12},
  [16981] = {.lex_state = 0, .external_lex_state = 12},
  [16982] = {.lex_state = 0, .external_lex_state = 12},
  [16983] = {.lex_state = 363, .external_lex_state = 12},
  [16984] = {.lex_state = 0, .external_lex_state = 12},
  [16985] = {.lex_state = 0, .external_lex_state = 10},
  [16986] = {.lex_state = 363, .external_lex_state = 12},
  [16987] = {.lex_state = 0, .external_lex_state = 12},
  [16988] = {.lex_state = 0, .external_lex_state = 12},
  [16989] = {.lex_state = 0, .external_lex_state = 10},
  [16990] = {.lex_state = 363, .external_lex_state = 12},
  [16991] = {.lex_state = 0, .external_lex_state = 10},
  [16992] = {.lex_state = 0, .external_lex_state = 12},
  [16993] = {.lex_state = 0, .external_lex_state = 12},
  [16994] = {.lex_state = 0, .external_lex_state = 12},
  [16995] = {.lex_state = 363, .external_lex_state = 12},
  [16996] = {.lex_state = 0, .external_lex_state = 10},
  [16997] = {.lex_state = 0, .external_lex_state = 12},
  [16998] = {.lex_state = 363, .external_lex_state = 12},
  [16999] = {.lex_state = 0, .external_lex_state = 10},
  [17000] = {.lex_state = 0, .external_lex_state = 10},
  [17001] = {.lex_state = 363, .external_lex_state = 12},
  [17002] = {.lex_state = 0, .external_lex_state = 10},
  [17003] = {.lex_state = 363, .external_lex_state = 12},
  [17004] = {.lex_state = 0, .external_lex_state = 10},
  [17005] = {.lex_state = 0, .external_lex_state = 12},
  [17006] = {.lex_state = 363, .external_lex_state = 12},
  [17007] = {.lex_state = 0, .external_lex_state = 10},
  [17008] = {.lex_state = 0, .external_lex_state = 10},
  [17009] = {.lex_state = 0, .external_lex_state = 12},
  [17010] = {.lex_state = 0, .external_lex_state = 12},
  [17011] = {.lex_state = 363, .external_lex_state = 12},
  [17012] = {.lex_state = 0, .external_lex_state = 10},
  [17013] = {.lex_state = 0, .external_lex_state = 10},
  [17014] = {.lex_state = 0, .external_lex_state = 12},
  [17015] = {.lex_state = 363, .external_lex_state = 12},
  [17016] = {.lex_state = 0, .external_lex_state = 10},
  [17017] = {.lex_state = 0, .external_lex_state = 10},
  [17018] = {.lex_state = 363, .external_lex_state = 12},
  [17019] = {.lex_state = 0, .external_lex_state = 10},
  [17020] = {.lex_state = 0, .external_lex_state = 10},
  [17021] = {.lex_state = 0, .external_lex_state = 12},
  [17022] = {.lex_state = 363, .external_lex_state = 12},
  [17023] = {.lex_state = 0, .external_lex_state = 10},
  [17024] = {.lex_state = 0, .external_lex_state = 10},
  [17025] = {.lex_state = 363, .external_lex_state = 12},
  [17026] = {.lex_state = 363, .external_lex_state = 12},
  [17027] = {.lex_state = 0, .external_lex_state = 10},
  [17028] = {.lex_state = 0, .external_lex_state = 12},
  [17029] = {.lex_state = 0, .external_lex_state = 10},
  [17030] = {.lex_state = 363, .external_lex_state = 12},
  [17031] = {.lex_state = 0, .external_lex_state = 10},
  [17032] = {.lex_state = 0, .external_lex_state = 12},
  [17033] = {.lex_state = 0, .external_lex_state = 10},
  [17034] = {.lex_state = 363, .external_lex_state = 12},
  [17035] = {.lex_state = 0, .external_lex_state = 10},
  [17036] = {.lex_state = 0, .external_lex_state = 12},
  [17037] = {.lex_state = 0, .external_lex_state = 10},
  [17038] = {.lex_state = 0, .external_lex_state = 12},
  [17039] = {.lex_state = 0, .external_lex_state = 12},
  [17040] = {.lex_state = 0, .external_lex_state = 10},
  [17041] = {.lex_state = 363, .external_lex_state = 12},
  [17042] = {.lex_state = 0, .external_lex_state = 10},
  [17043] = {.lex_state = 363, .external_lex_state = 12},
  [17044] = {.lex_state = 0, .external_lex_state = 10},
  [17045] = {.lex_state = 0, .external_lex_state = 10},
  [17046] = {.lex_state = 0, .external_lex_state = 12},
  [17047] = {.lex_state = 363, .external_lex_state = 12},
  [17048] = {.lex_state = 0, .external_lex_state = 10},
  [17049] = {.lex_state = 0, .external_lex_state = 10},
  [17050] = {.lex_state = 363, .external_lex_state = 12},
  [17051] = {.lex_state = 0, .external_lex_state = 10},
  [17052] = {.lex_state = 364, .external_lex_state = 12},
  [17053] = {.lex_state = 0, .external_lex_state = 10},
  [17054] = {.lex_state = 363, .external_lex_state = 12},
  [17055] = {.lex_state = 0, .external_lex_state = 10},
  [17056] = {.lex_state = 343, .external_lex_state = 12},
  [17057] = {.lex_state = 0, .external_lex_state = 10},
  [17058] = {.lex_state = 0, .external_lex_state = 12},
  [17059] = {.lex_state = 363, .external_lex_state = 12},
  [17060] = {.lex_state = 0, .external_lex_state = 10},
  [17061] = {.lex_state = 0, .external_lex_state = 12},
  [17062] = {.lex_state = 363, .external_lex_state = 12},
  [17063] = {.lex_state = 409, .external_lex_state = 12},
  [17064] = {.lex_state = 363, .external_lex_state = 12},
  [17065] = {.lex_state = 0, .external_lex_state = 12},
  [17066] = {.lex_state = 363, .external_lex_state = 12},
  [17067] = {.lex_state = 409, .external_lex_state = 12},
  [17068] = {.lex_state = 363, .external_lex_state = 12},
  [17069] = {.lex_state = 363, .external_lex_state = 12},
  [17070] = {.lex_state = 0, .external_lex_state = 12},
  [17071] = {.lex_state = 363, .external_lex_state = 12},
  [17072] = {.lex_state = 0, .external_lex_state = 12},
  [17073] = {.lex_state = 363, .external_lex_state = 12},
  [17074] = {.lex_state = 363, .external_lex_state = 12},
  [17075] = {.lex_state = 363, .external_lex_state = 12},
  [17076] = {.lex_state = 0, .external_lex_state = 12},
  [17077] = {.lex_state = 0, .external_lex_state = 12},
  [17078] = {.lex_state = 363, .external_lex_state = 12},
  [17079] = {.lex_state = 363, .external_lex_state = 12},
  [17080] = {.lex_state = 363, .external_lex_state = 12},
  [17081] = {.lex_state = 409, .external_lex_state = 12},
  [17082] = {.lex_state = 363, .external_lex_state = 12},
  [17083] = {.lex_state = 363, .external_lex_state = 12},
  [17084] = {.lex_state = 363, .external_lex_state = 12},
  [17085] = {.lex_state = 363, .external_lex_state = 12},
  [17086] = {.lex_state = 0, .external_lex_state = 12},
  [17087] = {.lex_state = 363, .external_lex_state = 12},
  [17088] = {.lex_state = 363, .external_lex_state = 12},
  [17089] = {.lex_state = 363, .external_lex_state = 12},
  [17090] = {.lex_state = 363, .external_lex_state = 12},
  [17091] = {.lex_state = 363, .external_lex_state = 12},
  [17092] = {.lex_state = 0, .external_lex_state = 12},
  [17093] = {.lex_state = 363, .external_lex_state = 12},
  [17094] = {.lex_state = 363, .external_lex_state = 12},
  [17095] = {.lex_state = 363, .external_lex_state = 12},
  [17096] = {.lex_state = 363, .external_lex_state = 12},
  [17097] = {.lex_state = 363, .external_lex_state = 12},
  [17098] = {.lex_state = 363, .external_lex_state = 12},
  [17099] = {.lex_state = 0, .external_lex_state = 12},
  [17100] = {.lex_state = 363, .external_lex_state = 12},
  [17101] = {.lex_state = 363, .external_lex_state = 12},
  [17102] = {.lex_state = 0, .external_lex_state = 12},
  [17103] = {.lex_state = 363, .external_lex_state = 12},
  [17104] = {.lex_state = 363, .external_lex_state = 12},
  [17105] = {.lex_state = 363, .external_lex_state = 12},
  [17106] = {.lex_state = 363, .external_lex_state = 12},
  [17107] = {.lex_state = 363, .external_lex_state = 12},
  [17108] = {.lex_state = 363, .external_lex_state = 12},
  [17109] = {.lex_state = 363, .external_lex_state = 12},
  [17110] = {.lex_state = 363, .external_lex_state = 12},
  [17111] = {.lex_state = 363, .external_lex_state = 12},
  [17112] = {.lex_state = 363, .external_lex_state = 12},
  [17113] = {.lex_state = 363, .external_lex_state = 12},
  [17114] = {.lex_state = 363, .external_lex_state = 12},
  [17115] = {.lex_state = 363, .external_lex_state = 12},
  [17116] = {.lex_state = 363, .external_lex_state = 12},
  [17117] = {.lex_state = 363, .external_lex_state = 12},
  [17118] = {.lex_state = 364, .external_lex_state = 12},
  [17119] = {.lex_state = 0, .external_lex_state = 12},
  [17120] = {.lex_state = 0, .external_lex_state = 12},
  [17121] = {.lex_state = 0, .external_lex_state = 12},
  [17122] = {.lex_state = 0, .external_lex_state = 12},
  [17123] = {.lex_state = 0, .external_lex_state = 12},
  [17124] = {.lex_state = 343, .external_lex_state = 12},
  [17125] = {.lex_state = 0, .external_lex_state = 12},
  [17126] = {.lex_state = 0, .external_lex_state = 12},
  [17127] = {.lex_state = 0, .external_lex_state = 12},
  [17128] = {.lex_state = 0, .external_lex_state = 12},
  [17129] = {.lex_state = 0, .external_lex_state = 12},
  [17130] = {.lex_state = 0, .external_lex_state = 12},
  [17131] = {.lex_state = 0, .external_lex_state = 12},
  [17132] = {.lex_state = 0, .external_lex_state = 12},
  [17133] = {.lex_state = 0, .external_lex_state = 12},
  [17134] = {.lex_state = 0, .external_lex_state = 12},
  [17135] = {.lex_state = 0, .external_lex_state = 12},
  [17136] = {.lex_state = 0, .external_lex_state = 12},
  [17137] = {.lex_state = 0, .external_lex_state = 12},
  [17138] = {.lex_state = 0, .external_lex_state = 10},
  [17139] = {.lex_state = 0, .external_lex_state = 12},
  [17140] = {.lex_state = 0, .external_lex_state = 12},
  [17141] = {.lex_state = 363, .external_lex_state = 12},
  [17142] = {.lex_state = 343, .external_lex_state = 13},
  [17143] = {.lex_state = 0, .external_lex_state = 12},
  [17144] = {.lex_state = 0, .external_lex_state = 12},
  [17145] = {.lex_state = 0, .external_lex_state = 12},
  [17146] = {.lex_state = 0, .external_lex_state = 12},
  [17147] = {.lex_state = 0, .external_lex_state = 12},
  [17148] = {.lex_state = 0, .external_lex_state = 12},
  [17149] = {.lex_state = 363, .external_lex_state = 12},
  [17150] = {.lex_state = 363, .external_lex_state = 12},
  [17151] = {.lex_state = 0, .external_lex_state = 12},
  [17152] = {.lex_state = 0, .external_lex_state = 12},
  [17153] = {.lex_state = 0, .external_lex_state = 12},
  [17154] = {.lex_state = 0, .external_lex_state = 12},
  [17155] = {.lex_state = 363, .external_lex_state = 12},
  [17156] = {.lex_state = 0, .external_lex_state = 12},
  [17157] = {.lex_state = 0, .external_lex_state = 12},
  [17158] = {.lex_state = 363, .external_lex_state = 12},
  [17159] = {.lex_state = 363, .external_lex_state = 12},
  [17160] = {.lex_state = 0, .external_lex_state = 12},
  [17161] = {.lex_state = 0, .external_lex_state = 12},
  [17162] = {.lex_state = 363, .external_lex_state = 12},
  [17163] = {.lex_state = 0, .external_lex_state = 12},
  [17164] = {.lex_state = 0, .external_lex_state = 12},
  [17165] = {.lex_state = 0, .external_lex_state = 12},
  [17166] = {.lex_state = 0, .external_lex_state = 12},
  [17167] = {.lex_state = 0, .external_lex_state = 12},
  [17168] = {.lex_state = 0, .external_lex_state = 12},
  [17169] = {.lex_state = 343, .external_lex_state = 12},
  [17170] = {.lex_state = 409, .external_lex_state = 12},
  [17171] = {.lex_state = 0, .external_lex_state = 12},
  [17172] = {.lex_state = 0, .external_lex_state = 12},
  [17173] = {.lex_state = 0, .external_lex_state = 12},
  [17174] = {.lex_state = 363, .external_lex_state = 12},
  [17175] = {.lex_state = 0, .external_lex_state = 12},
  [17176] = {.lex_state = 0, .external_lex_state = 12},
  [17177] = {.lex_state = 0, .external_lex_state = 12},
  [17178] = {.lex_state = 343, .external_lex_state = 12},
  [17179] = {.lex_state = 0, .external_lex_state = 12},
  [17180] = {.lex_state = 0, .external_lex_state = 12},
  [17181] = {.lex_state = 0, .external_lex_state = 12},
  [17182] = {.lex_state = 0, .external_lex_state = 12},
  [17183] = {.lex_state = 0, .external_lex_state = 12},
  [17184] = {.lex_state = 0, .external_lex_state = 12},
  [17185] = {.lex_state = 0, .external_lex_state = 12},
  [17186] = {.lex_state = 0, .external_lex_state = 12},
  [17187] = {.lex_state = 0, .external_lex_state = 12},
  [17188] = {.lex_state = 0, .external_lex_state = 12},
  [17189] = {.lex_state = 0, .external_lex_state = 12},
  [17190] = {.lex_state = 0, .external_lex_state = 12},
  [17191] = {.lex_state = 0, .external_lex_state = 12},
  [17192] = {.lex_state = 499, .external_lex_state = 12},
  [17193] = {.lex_state = 409, .external_lex_state = 12},
  [17194] = {.lex_state = 363, .external_lex_state = 12},
  [17195] = {.lex_state = 0, .external_lex_state = 12},
  [17196] = {.lex_state = 0, .external_lex_state = 12},
  [17197] = {.lex_state = 0, .external_lex_state = 12},
  [17198] = {.lex_state = 0, .external_lex_state = 12},
  [17199] = {.lex_state = 363, .external_lex_state = 12},
  [17200] = {.lex_state = 363, .external_lex_state = 12},
  [17201] = {.lex_state = 0, .external_lex_state = 12},
  [17202] = {.lex_state = 0, .external_lex_state = 12},
  [17203] = {.lex_state = 0, .external_lex_state = 12},
  [17204] = {.lex_state = 0, .external_lex_state = 12},
  [17205] = {.lex_state = 0, .external_lex_state = 12},
  [17206] = {.lex_state = 0, .external_lex_state = 12},
  [17207] = {.lex_state = 0, .external_lex_state = 12},
  [17208] = {.lex_state = 343, .external_lex_state = 12},
  [17209] = {.lex_state = 0, .external_lex_state = 12},
  [17210] = {.lex_state = 0, .external_lex_state = 12},
  [17211] = {.lex_state = 0, .external_lex_state = 12},
  [17212] = {.lex_state = 0, .external_lex_state = 12},
  [17213] = {.lex_state = 0, .external_lex_state = 12},
  [17214] = {.lex_state = 0, .external_lex_state = 12},
  [17215] = {.lex_state = 0, .external_lex_state = 12},
  [17216] = {.lex_state = 363, .external_lex_state = 12},
  [17217] = {.lex_state = 0, .external_lex_state = 12},
  [17218] = {.lex_state = 0, .external_lex_state = 12},
  [17219] = {.lex_state = 0, .external_lex_state = 12},
  [17220] = {.lex_state = 0, .external_lex_state = 12},
  [17221] = {.lex_state = 0, .external_lex_state = 12},
  [17222] = {.lex_state = 0, .external_lex_state = 12},
  [17223] = {.lex_state = 363, .external_lex_state = 12},
  [17224] = {.lex_state = 0, .external_lex_state = 12},
  [17225] = {.lex_state = 0, .external_lex_state = 12},
  [17226] = {.lex_state = 0, .external_lex_state = 12},
  [17227] = {.lex_state = 0, .external_lex_state = 12},
  [17228] = {.lex_state = 0, .external_lex_state = 12},
  [17229] = {.lex_state = 0, .external_lex_state = 12},
  [17230] = {.lex_state = 0, .external_lex_state = 12},
  [17231] = {.lex_state = 343, .external_lex_state = 12},
  [17232] = {.lex_state = 0, .external_lex_state = 12},
  [17233] = {.lex_state = 0, .external_lex_state = 12},
  [17234] = {.lex_state = 0, .external_lex_state = 12},
  [17235] = {.lex_state = 0, .external_lex_state = 12},
  [17236] = {.lex_state = 0, .external_lex_state = 12},
  [17237] = {.lex_state = 0, .external_lex_state = 12},
  [17238] = {.lex_state = 409, .external_lex_state = 12},
  [17239] = {.lex_state = 363, .external_lex_state = 12},
  [17240] = {.lex_state = 0, .external_lex_state = 12},
  [17241] = {.lex_state = 0, .external_lex_state = 12},
  [17242] = {.lex_state = 0, .external_lex_state = 12},
  [17243] = {.lex_state = 0, .external_lex_state = 12},
  [17244] = {.lex_state = 0, .external_lex_state = 12},
  [17245] = {.lex_state = 0, .external_lex_state = 12},
  [17246] = {.lex_state = 0, .external_lex_state = 12},
  [17247] = {.lex_state = 0, .external_lex_state = 12},
  [17248] = {.lex_state = 0, .external_lex_state = 12},
  [17249] = {.lex_state = 0, .external_lex_state = 12},
  [17250] = {.lex_state = 363, .external_lex_state = 12},
  [17251] = {.lex_state = 0, .external_lex_state = 12},
  [17252] = {.lex_state = 0, .external_lex_state = 12},
  [17253] = {.lex_state = 0, .external_lex_state = 12},
  [17254] = {.lex_state = 499, .external_lex_state = 12},
  [17255] = {.lex_state = 0, .external_lex_state = 12},
  [17256] = {.lex_state = 363, .external_lex_state = 12},
  [17257] = {.lex_state = 363, .external_lex_state = 12},
  [17258] = {.lex_state = 0, .external_lex_state = 12},
  [17259] = {.lex_state = 0, .external_lex_state = 12},
  [17260] = {.lex_state = 363, .external_lex_state = 12},
  [17261] = {.lex_state = 0, .external_lex_state = 12},
  [17262] = {.lex_state = 0, .external_lex_state = 12},
  [17263] = {.lex_state = 0, .external_lex_state = 12},
  [17264] = {.lex_state = 0, .external_lex_state = 12},
  [17265] = {.lex_state = 0, .external_lex_state = 12},
  [17266] = {.lex_state = 363, .external_lex_state = 12},
  [17267] = {.lex_state = 0, .external_lex_state = 12},
  [17268] = {.lex_state = 363, .external_lex_state = 12},
  [17269] = {.lex_state = 363, .external_lex_state = 12},
  [17270] = {.lex_state = 0, .external_lex_state = 12},
  [17271] = {.lex_state = 0, .external_lex_state = 12},
  [17272] = {.lex_state = 363, .external_lex_state = 12},
  [17273] = {.lex_state = 0, .external_lex_state = 10},
  [17274] = {.lex_state = 0, .external_lex_state = 12},
  [17275] = {.lex_state = 0, .external_lex_state = 12},
  [17276] = {.lex_state = 0, .external_lex_state = 12},
  [17277] = {.lex_state = 0, .external_lex_state = 12},
  [17278] = {.lex_state = 0, .external_lex_state = 12},
  [17279] = {.lex_state = 0, .external_lex_state = 12},
  [17280] = {.lex_state = 0, .external_lex_state = 12},
  [17281] = {.lex_state = 0, .external_lex_state = 12},
  [17282] = {.lex_state = 0, .external_lex_state = 12},
  [17283] = {.lex_state = 0, .external_lex_state = 12},
  [17284] = {.lex_state = 363, .external_lex_state = 12},
  [17285] = {.lex_state = 343, .external_lex_state = 12},
  [17286] = {.lex_state = 0, .external_lex_state = 12},
  [17287] = {.lex_state = 0, .external_lex_state = 12},
  [17288] = {.lex_state = 0, .external_lex_state = 12},
  [17289] = {.lex_state = 0, .external_lex_state = 12},
  [17290] = {.lex_state = 0, .external_lex_state = 12},
  [17291] = {.lex_state = 0, .external_lex_state = 12},
  [17292] = {.lex_state = 363, .external_lex_state = 12},
  [17293] = {.lex_state = 0, .external_lex_state = 12},
  [17294] = {.lex_state = 0, .external_lex_state = 12},
  [17295] = {.lex_state = 0, .external_lex_state = 10},
  [17296] = {.lex_state = 0, .external_lex_state = 12},
  [17297] = {.lex_state = 0, .external_lex_state = 12},
  [17298] = {.lex_state = 0, .external_lex_state = 12},
  [17299] = {.lex_state = 0, .external_lex_state = 12},
  [17300] = {.lex_state = 0, .external_lex_state = 12},
  [17301] = {.lex_state = 0, .external_lex_state = 12},
  [17302] = {.lex_state = 0, .external_lex_state = 12},
  [17303] = {.lex_state = 0, .external_lex_state = 12},
  [17304] = {.lex_state = 0, .external_lex_state = 12},
  [17305] = {.lex_state = 0, .external_lex_state = 12},
  [17306] = {.lex_state = 363, .external_lex_state = 12},
  [17307] = {.lex_state = 363, .external_lex_state = 12},
  [17308] = {.lex_state = 343, .external_lex_state = 12},
  [17309] = {.lex_state = 0, .external_lex_state = 12},
  [17310] = {.lex_state = 0, .external_lex_state = 12},
  [17311] = {.lex_state = 0, .external_lex_state = 12},
  [17312] = {.lex_state = 0, .external_lex_state = 12},
  [17313] = {.lex_state = 363, .external_lex_state = 12},
  [17314] = {.lex_state = 0, .external_lex_state = 12},
  [17315] = {.lex_state = 363, .external_lex_state = 12},
  [17316] = {.lex_state = 363, .external_lex_state = 12},
  [17317] = {.lex_state = 0, .external_lex_state = 12},
  [17318] = {.lex_state = 0, .external_lex_state = 12},
  [17319] = {.lex_state = 0, .external_lex_state = 12},
  [17320] = {.lex_state = 343, .external_lex_state = 13},
  [17321] = {.lex_state = 0, .external_lex_state = 12},
  [17322] = {.lex_state = 0, .external_lex_state = 12},
  [17323] = {.lex_state = 0, .external_lex_state = 12},
  [17324] = {.lex_state = 0, .external_lex_state = 12},
  [17325] = {.lex_state = 343, .external_lex_state = 12},
  [17326] = {.lex_state = 0, .external_lex_state = 12},
  [17327] = {.lex_state = 0, .external_lex_state = 12},
  [17328] = {.lex_state = 343, .external_lex_state = 12},
  [17329] = {.lex_state = 0, .external_lex_state = 12},
  [17330] = {.lex_state = 0, .external_lex_state = 12},
  [17331] = {.lex_state = 409, .external_lex_state = 12},
  [17332] = {.lex_state = 0, .external_lex_state = 12},
  [17333] = {.lex_state = 343, .external_lex_state = 12},
  [17334] = {.lex_state = 343, .external_lex_state = 12},
  [17335] = {.lex_state = 343, .external_lex_state = 12},
  [17336] = {.lex_state = 343, .external_lex_state = 12},
  [17337] = {.lex_state = 343, .external_lex_state = 12},
  [17338] = {.lex_state = 343, .external_lex_state = 12},
  [17339] = {.lex_state = 363, .external_lex_state = 12},
  [17340] = {.lex_state = 0, .external_lex_state = 12},
  [17341] = {.lex_state = 0, .external_lex_state = 12},
  [17342] = {.lex_state = 0, .external_lex_state = 12},
  [17343] = {.lex_state = 0, .external_lex_state = 12},
  [17344] = {.lex_state = 409, .external_lex_state = 12},
  [17345] = {.lex_state = 499, .external_lex_state = 12},
  [17346] = {.lex_state = 0, .external_lex_state = 12},
  [17347] = {.lex_state = 0, .external_lex_state = 12},
  [17348] = {.lex_state = 0, .external_lex_state = 12},
  [17349] = {.lex_state = 0, .external_lex_state = 12},
  [17350] = {.lex_state = 499, .external_lex_state = 12},
  [17351] = {.lex_state = 499, .external_lex_state = 12},
  [17352] = {.lex_state = 0, .external_lex_state = 12},
  [17353] = {.lex_state = 0, .external_lex_state = 12},
  [17354] = {.lex_state = 409, .external_lex_state = 12},
  [17355] = {.lex_state = 0, .external_lex_state = 12},
  [17356] = {.lex_state = 0, .external_lex_state = 12},
  [17357] = {.lex_state = 0, .external_lex_state = 12},
  [17358] = {.lex_state = 0, .external_lex_state = 12},
  [17359] = {.lex_state = 0, .external_lex_state = 12},
  [17360] = {.lex_state = 499, .external_lex_state = 12},
  [17361] = {.lex_state = 499, .external_lex_state = 12},
  [17362] = {.lex_state = 0, .external_lex_state = 12},
  [17363] = {.lex_state = 499, .external_lex_state = 12},
  [17364] = {.lex_state = 499, .external_lex_state = 12},
  [17365] = {.lex_state = 0, .external_lex_state = 12},
  [17366] = {.lex_state = 0, .external_lex_state = 12},
  [17367] = {.lex_state = 499, .external_lex_state = 12},
  [17368] = {.lex_state = 0, .external_lex_state = 12},
  [17369] = {.lex_state = 0, .external_lex_state = 12},
  [17370] = {.lex_state = 0, .external_lex_state = 12},
  [17371] = {.lex_state = 0, .external_lex_state = 12},
  [17372] = {.lex_state = 0, .external_lex_state = 12},
  [17373] = {.lex_state = 0, .external_lex_state = 12},
  [17374] = {.lex_state = 499, .external_lex_state = 12},
  [17375] = {.lex_state = 0, .external_lex_state = 12},
  [17376] = {.lex_state = 0, .external_lex_state = 12},
  [17377] = {.lex_state = 0, .external_lex_state = 12},
  [17378] = {.lex_state = 0, .external_lex_state = 12},
  [17379] = {.lex_state = 499, .external_lex_state = 12},
  [17380] = {.lex_state = 0, .external_lex_state = 12},
  [17381] = {.lex_state = 499, .external_lex_state = 12},
  [17382] = {.lex_state = 0, .external_lex_state = 12},
  [17383] = {.lex_state = 409, .external_lex_state = 12},
  [17384] = {.lex_state = 499, .external_lex_state = 12},
  [17385] = {.lex_state = 0, .external_lex_state = 12},
  [17386] = {.lex_state = 0, .external_lex_state = 12},
  [17387] = {.lex_state = 0, .external_lex_state = 12},
  [17388] = {.lex_state = 0, .external_lex_state = 12},
  [17389] = {.lex_state = 0, .external_lex_state = 12},
  [17390] = {.lex_state = 0, .external_lex_state = 12},
  [17391] = {.lex_state = 0, .external_lex_state = 12},
  [17392] = {.lex_state = 499, .external_lex_state = 12},
  [17393] = {.lex_state = 0, .external_lex_state = 12},
  [17394] = {.lex_state = 0, .external_lex_state = 12},
  [17395] = {.lex_state = 0, .external_lex_state = 12},
  [17396] = {.lex_state = 0, .external_lex_state = 12},
  [17397] = {.lex_state = 499, .external_lex_state = 12},
  [17398] = {.lex_state = 0, .external_lex_state = 12},
  [17399] = {.lex_state = 0, .external_lex_state = 12},
  [17400] = {.lex_state = 499, .external_lex_state = 12},
  [17401] = {.lex_state = 0, .external_lex_state = 12},
  [17402] = {.lex_state = 499, .external_lex_state = 12},
  [17403] = {.lex_state = 409, .external_lex_state = 12},
  [17404] = {.lex_state = 0, .external_lex_state = 12},
  [17405] = {.lex_state = 0, .external_lex_state = 12},
  [17406] = {.lex_state = 0, .external_lex_state = 12},
  [17407] = {.lex_state = 0, .external_lex_state = 12},
  [17408] = {.lex_state = 0, .external_lex_state = 12},
  [17409] = {.lex_state = 0, .external_lex_state = 12},
  [17410] = {.lex_state = 499, .external_lex_state = 12},
  [17411] = {.lex_state = 409, .external_lex_state = 12},
  [17412] = {.lex_state = 499, .external_lex_state = 12},
  [17413] = {.lex_state = 0, .external_lex_state = 12},
  [17414] = {.lex_state = 499, .external_lex_state = 12},
  [17415] = {.lex_state = 499, .external_lex_state = 12},
  [17416] = {.lex_state = 499, .external_lex_state = 12},
  [17417] = {.lex_state = 0, .external_lex_state = 12},
  [17418] = {.lex_state = 0, .external_lex_state = 12},
  [17419] = {.lex_state = 499, .external_lex_state = 12},
  [17420] = {.lex_state = 0, .external_lex_state = 12},
  [17421] = {.lex_state = 0, .external_lex_state = 12},
  [17422] = {.lex_state = 499, .external_lex_state = 12},
  [17423] = {.lex_state = 0, .external_lex_state = 12},
  [17424] = {.lex_state = 499, .external_lex_state = 12},
  [17425] = {.lex_state = 0, .external_lex_state = 12},
  [17426] = {.lex_state = 0, .external_lex_state = 12},
  [17427] = {.lex_state = 0, .external_lex_state = 12},
  [17428] = {.lex_state = 0, .external_lex_state = 12},
  [17429] = {.lex_state = 0, .external_lex_state = 12},
  [17430] = {.lex_state = 0, .external_lex_state = 12},
  [17431] = {.lex_state = 0, .external_lex_state = 12},
  [17432] = {.lex_state = 499, .external_lex_state = 12},
  [17433] = {.lex_state = 499, .external_lex_state = 12},
  [17434] = {.lex_state = 0, .external_lex_state = 12},
  [17435] = {.lex_state = 0, .external_lex_state = 12},
  [17436] = {.lex_state = 0, .external_lex_state = 12},
  [17437] = {.lex_state = 0, .external_lex_state = 12},
  [17438] = {.lex_state = 0, .external_lex_state = 12},
  [17439] = {.lex_state = 0, .external_lex_state = 12},
  [17440] = {.lex_state = 0, .external_lex_state = 12},
  [17441] = {.lex_state = 0, .external_lex_state = 12},
  [17442] = {.lex_state = 0, .external_lex_state = 12},
  [17443] = {.lex_state = 0, .external_lex_state = 12},
  [17444] = {.lex_state = 0, .external_lex_state = 12},
  [17445] = {.lex_state = 0, .external_lex_state = 12},
  [17446] = {.lex_state = 499, .external_lex_state = 12},
  [17447] = {.lex_state = 499, .external_lex_state = 12},
  [17448] = {.lex_state = 499, .external_lex_state = 12},
  [17449] = {.lex_state = 499, .external_lex_state = 12},
  [17450] = {.lex_state = 0, .external_lex_state = 12},
  [17451] = {.lex_state = 0, .external_lex_state = 12},
  [17452] = {.lex_state = 0, .external_lex_state = 12},
  [17453] = {.lex_state = 0, .external_lex_state = 12},
  [17454] = {.lex_state = 0, .external_lex_state = 12},
  [17455] = {.lex_state = 0, .external_lex_state = 12},
  [17456] = {.lex_state = 0, .external_lex_state = 12},
  [17457] = {.lex_state = 0, .external_lex_state = 12},
  [17458] = {.lex_state = 0, .external_lex_state = 12},
  [17459] = {.lex_state = 0, .external_lex_state = 12},
  [17460] = {.lex_state = 0, .external_lex_state = 12},
  [17461] = {.lex_state = 0, .external_lex_state = 12},
  [17462] = {.lex_state = 0, .external_lex_state = 12},
  [17463] = {.lex_state = 0, .external_lex_state = 12},
  [17464] = {.lex_state = 0, .external_lex_state = 12},
  [17465] = {.lex_state = 409, .external_lex_state = 12},
  [17466] = {.lex_state = 0, .external_lex_state = 12},
  [17467] = {.lex_state = 0, .external_lex_state = 12},
  [17468] = {.lex_state = 499, .external_lex_state = 12},
  [17469] = {.lex_state = 499, .external_lex_state = 12},
  [17470] = {.lex_state = 0, .external_lex_state = 12},
  [17471] = {.lex_state = 499, .external_lex_state = 12},
  [17472] = {.lex_state = 0, .external_lex_state = 12},
  [17473] = {.lex_state = 409, .external_lex_state = 12},
  [17474] = {.lex_state = 0, .external_lex_state = 12},
  [17475] = {.lex_state = 0, .external_lex_state = 12},
  [17476] = {.lex_state = 0, .external_lex_state = 12},
  [17477] = {.lex_state = 0, .external_lex_state = 12},
  [17478] = {.lex_state = 0, .external_lex_state = 12},
  [17479] = {.lex_state = 0, .external_lex_state = 12},
  [17480] = {.lex_state = 0, .external_lex_state = 12},
  [17481] = {.lex_state = 499, .external_lex_state = 12},
  [17482] = {.lex_state = 499, .external_lex_state = 12},
  [17483] = {.lex_state = 414, .external_lex_state = 12},
  [17484] = {.lex_state = 499, .external_lex_state = 12},
  [17485] = {.lex_state = 0, .external_lex_state = 12},
  [17486] = {.lex_state = 499, .external_lex_state = 12},
  [17487] = {.lex_state = 0, .external_lex_state = 12},
  [17488] = {.lex_state = 499, .external_lex_state = 12},
  [17489] = {.lex_state = 0, .external_lex_state = 12},
  [17490] = {.lex_state = 0, .external_lex_state = 12},
  [17491] = {.lex_state = 0, .external_lex_state = 12},
  [17492] = {.lex_state = 0, .external_lex_state = 12},
  [17493] = {.lex_state = 0, .external_lex_state = 12},
  [17494] = {.lex_state = 0, .external_lex_state = 12},
  [17495] = {.lex_state = 0, .external_lex_state = 12},
  [17496] = {.lex_state = 0, .external_lex_state = 12},
  [17497] = {.lex_state = 0, .external_lex_state = 12},
  [17498] = {.lex_state = 499, .external_lex_state = 12},
  [17499] = {.lex_state = 0, .external_lex_state = 12},
  [17500] = {.lex_state = 0, .external_lex_state = 12},
  [17501] = {.lex_state = 0, .external_lex_state = 12},
  [17502] = {.lex_state = 0, .external_lex_state = 12},
  [17503] = {.lex_state = 0, .external_lex_state = 12},
  [17504] = {.lex_state = 499, .external_lex_state = 12},
  [17505] = {.lex_state = 0, .external_lex_state = 12},
  [17506] = {.lex_state = 0, .external_lex_state = 12},
  [17507] = {.lex_state = 0, .external_lex_state = 12},
  [17508] = {.lex_state = 499, .external_lex_state = 12},
  [17509] = {.lex_state = 0, .external_lex_state = 12},
  [17510] = {.lex_state = 0, .external_lex_state = 12},
  [17511] = {.lex_state = 0, .external_lex_state = 12},
  [17512] = {.lex_state = 0, .external_lex_state = 12},
  [17513] = {.lex_state = 0, .external_lex_state = 12},
  [17514] = {.lex_state = 0, .external_lex_state = 12},
  [17515] = {.lex_state = 499, .external_lex_state = 12},
  [17516] = {.lex_state = 499, .external_lex_state = 12},
  [17517] = {.lex_state = 499, .external_lex_state = 12},
  [17518] = {.lex_state = 0, .external_lex_state = 12},
  [17519] = {.lex_state = 0, .external_lex_state = 12},
  [17520] = {.lex_state = 0, .external_lex_state = 12},
  [17521] = {.lex_state = 0, .external_lex_state = 12},
  [17522] = {.lex_state = 0, .external_lex_state = 12},
  [17523] = {.lex_state = 0, .external_lex_state = 12},
  [17524] = {.lex_state = 499, .external_lex_state = 12},
  [17525] = {.lex_state = 0, .external_lex_state = 12},
  [17526] = {.lex_state = 0, .external_lex_state = 12},
  [17527] = {.lex_state = 0, .external_lex_state = 12},
  [17528] = {.lex_state = 0, .external_lex_state = 12},
  [17529] = {.lex_state = 0, .external_lex_state = 12},
  [17530] = {.lex_state = 499, .external_lex_state = 12},
  [17531] = {.lex_state = 0, .external_lex_state = 12},
  [17532] = {.lex_state = 0, .external_lex_state = 12},
  [17533] = {.lex_state = 499, .external_lex_state = 12},
  [17534] = {.lex_state = 0, .external_lex_state = 12},
  [17535] = {.lex_state = 499, .external_lex_state = 12},
  [17536] = {.lex_state = 0, .external_lex_state = 12},
  [17537] = {.lex_state = 0, .external_lex_state = 12},
  [17538] = {.lex_state = 0, .external_lex_state = 12},
  [17539] = {.lex_state = 0, .external_lex_state = 12},
  [17540] = {.lex_state = 0, .external_lex_state = 12},
  [17541] = {.lex_state = 0, .external_lex_state = 12},
  [17542] = {.lex_state = 0, .external_lex_state = 12},
  [17543] = {.lex_state = 0, .external_lex_state = 12},
  [17544] = {.lex_state = 0, .external_lex_state = 12},
  [17545] = {.lex_state = 0, .external_lex_state = 12},
  [17546] = {.lex_state = 0, .external_lex_state = 12},
  [17547] = {.lex_state = 0, .external_lex_state = 12},
  [17548] = {.lex_state = 0, .external_lex_state = 12},
  [17549] = {.lex_state = 0, .external_lex_state = 12},
  [17550] = {.lex_state = 499, .external_lex_state = 12},
  [17551] = {.lex_state = 0, .external_lex_state = 12},
  [17552] = {.lex_state = 499, .external_lex_state = 12},
  [17553] = {.lex_state = 499, .external_lex_state = 12},
  [17554] = {.lex_state = 0, .external_lex_state = 12},
  [17555] = {.lex_state = 0, .external_lex_state = 12},
  [17556] = {.lex_state = 499, .external_lex_state = 12},
  [17557] = {.lex_state = 0, .external_lex_state = 12},
  [17558] = {.lex_state = 0, .external_lex_state = 12},
  [17559] = {.lex_state = 0, .external_lex_state = 12},
  [17560] = {.lex_state = 0, .external_lex_state = 12},
  [17561] = {.lex_state = 499, .external_lex_state = 12},
  [17562] = {.lex_state = 0, .external_lex_state = 12},
  [17563] = {.lex_state = 0, .external_lex_state = 12},
  [17564] = {.lex_state = 0, .external_lex_state = 12},
  [17565] = {.lex_state = 0, .external_lex_state = 12},
  [17566] = {.lex_state = 0, .external_lex_state = 12},
  [17567] = {.lex_state = 0, .external_lex_state = 12},
  [17568] = {.lex_state = 499, .external_lex_state = 12},
  [17569] = {.lex_state = 0, .external_lex_state = 12},
  [17570] = {.lex_state = 0, .external_lex_state = 12},
  [17571] = {.lex_state = 0, .external_lex_state = 12},
  [17572] = {.lex_state = 409, .external_lex_state = 12},
  [17573] = {.lex_state = 0, .external_lex_state = 12},
  [17574] = {.lex_state = 0, .external_lex_state = 12},
  [17575] = {.lex_state = 0, .external_lex_state = 12},
  [17576] = {.lex_state = 409, .external_lex_state = 12},
  [17577] = {.lex_state = 499, .external_lex_state = 12},
  [17578] = {.lex_state = 0, .external_lex_state = 12},
  [17579] = {.lex_state = 499, .external_lex_state = 12},
  [17580] = {.lex_state = 0, .external_lex_state = 12},
  [17581] = {.lex_state = 0, .external_lex_state = 12},
  [17582] = {.lex_state = 0, .external_lex_state = 12},
  [17583] = {.lex_state = 0, .external_lex_state = 12},
  [17584] = {.lex_state = 499, .external_lex_state = 12},
  [17585] = {.lex_state = 0, .external_lex_state = 12},
  [17586] = {.lex_state = 499, .external_lex_state = 12},
  [17587] = {.lex_state = 499, .external_lex_state = 12},
  [17588] = {.lex_state = 409, .external_lex_state = 12},
  [17589] = {.lex_state = 0, .external_lex_state = 12},
  [17590] = {.lex_state = 0, .external_lex_state = 12},
  [17591] = {.lex_state = 0, .external_lex_state = 12},
  [17592] = {.lex_state = 0, .external_lex_state = 12},
  [17593] = {.lex_state = 0, .external_lex_state = 12},
  [17594] = {.lex_state = 499, .external_lex_state = 12},
  [17595] = {.lex_state = 0, .external_lex_state = 12},
  [17596] = {.lex_state = 0, .external_lex_state = 12},
  [17597] = {.lex_state = 0, .external_lex_state = 12},
  [17598] = {.lex_state = 409, .external_lex_state = 12},
  [17599] = {.lex_state = 0, .external_lex_state = 12},
  [17600] = {.lex_state = 0, .external_lex_state = 12},
  [17601] = {.lex_state = 0, .external_lex_state = 12},
  [17602] = {.lex_state = 499, .external_lex_state = 12},
  [17603] = {.lex_state = 0, .external_lex_state = 12},
  [17604] = {.lex_state = 0, .external_lex_state = 12},
  [17605] = {.lex_state = 0, .external_lex_state = 12},
  [17606] = {.lex_state = 0, .external_lex_state = 12},
  [17607] = {.lex_state = 0, .external_lex_state = 12},
  [17608] = {.lex_state = 363, .external_lex_state = 12},
  [17609] = {.lex_state = 0, .external_lex_state = 12},
  [17610] = {.lex_state = 0, .external_lex_state = 12},
  [17611] = {.lex_state = 0, .external_lex_state = 12},
  [17612] = {.lex_state = 0, .external_lex_state = 12},
  [17613] = {.lex_state = 0, .external_lex_state = 12},
  [17614] = {.lex_state = 0, .external_lex_state = 12},
  [17615] = {.lex_state = 0, .external_lex_state = 12},
  [17616] = {.lex_state = 0, .external_lex_state = 12},
  [17617] = {.lex_state = 499, .external_lex_state = 12},
  [17618] = {.lex_state = 499, .external_lex_state = 12},
  [17619] = {.lex_state = 0, .external_lex_state = 12},
  [17620] = {.lex_state = 0, .external_lex_state = 12},
  [17621] = {.lex_state = 499, .external_lex_state = 12},
  [17622] = {.lex_state = 0, .external_lex_state = 12},
  [17623] = {.lex_state = 0, .external_lex_state = 12},
  [17624] = {.lex_state = 0, .external_lex_state = 12},
  [17625] = {.lex_state = 0, .external_lex_state = 12},
  [17626] = {.lex_state = 0, .external_lex_state = 12},
  [17627] = {.lex_state = 0, .external_lex_state = 12},
  [17628] = {.lex_state = 0, .external_lex_state = 12},
  [17629] = {.lex_state = 0, .external_lex_state = 12},
  [17630] = {.lex_state = 0, .external_lex_state = 12},
  [17631] = {.lex_state = 0, .external_lex_state = 12},
  [17632] = {.lex_state = 0, .external_lex_state = 12},
  [17633] = {.lex_state = 0, .external_lex_state = 12},
  [17634] = {.lex_state = 499, .external_lex_state = 12},
  [17635] = {.lex_state = 0, .external_lex_state = 12},
  [17636] = {.lex_state = 0, .external_lex_state = 12},
  [17637] = {.lex_state = 0, .external_lex_state = 12},
  [17638] = {.lex_state = 0, .external_lex_state = 12},
  [17639] = {.lex_state = 0, .external_lex_state = 12},
  [17640] = {.lex_state = 0, .external_lex_state = 12},
  [17641] = {.lex_state = 499, .external_lex_state = 12},
  [17642] = {.lex_state = 0, .external_lex_state = 12},
  [17643] = {.lex_state = 0, .external_lex_state = 12},
  [17644] = {.lex_state = 0, .external_lex_state = 12},
  [17645] = {.lex_state = 0, .external_lex_state = 12},
  [17646] = {.lex_state = 0, .external_lex_state = 12},
  [17647] = {.lex_state = 0, .external_lex_state = 12},
  [17648] = {.lex_state = 0, .external_lex_state = 12},
  [17649] = {.lex_state = 0, .external_lex_state = 12},
  [17650] = {.lex_state = 0, .external_lex_state = 12},
  [17651] = {.lex_state = 0, .external_lex_state = 12},
  [17652] = {.lex_state = 0, .external_lex_state = 12},
  [17653] = {.lex_state = 0, .external_lex_state = 12},
  [17654] = {.lex_state = 499, .external_lex_state = 12},
  [17655] = {.lex_state = 0, .external_lex_state = 12},
  [17656] = {.lex_state = 499, .external_lex_state = 12},
  [17657] = {.lex_state = 0, .external_lex_state = 12},
  [17658] = {.lex_state = 0, .external_lex_state = 12},
  [17659] = {.lex_state = 0, .external_lex_state = 12},
  [17660] = {.lex_state = 0, .external_lex_state = 12},
  [17661] = {.lex_state = 0, .external_lex_state = 12},
  [17662] = {.lex_state = 499, .external_lex_state = 12},
  [17663] = {.lex_state = 0, .external_lex_state = 12},
  [17664] = {.lex_state = 0, .external_lex_state = 12},
  [17665] = {.lex_state = 0, .external_lex_state = 12},
  [17666] = {.lex_state = 0, .external_lex_state = 12},
  [17667] = {.lex_state = 0, .external_lex_state = 12},
  [17668] = {.lex_state = 0, .external_lex_state = 12},
  [17669] = {.lex_state = 0, .external_lex_state = 12},
  [17670] = {.lex_state = 0, .external_lex_state = 12},
  [17671] = {.lex_state = 0, .external_lex_state = 12},
  [17672] = {.lex_state = 0, .external_lex_state = 12},
  [17673] = {.lex_state = 0, .external_lex_state = 12},
  [17674] = {.lex_state = 409, .external_lex_state = 12},
  [17675] = {.lex_state = 0, .external_lex_state = 12},
  [17676] = {.lex_state = 499, .external_lex_state = 12},
  [17677] = {.lex_state = 0, .external_lex_state = 12},
  [17678] = {.lex_state = 0, .external_lex_state = 12},
  [17679] = {.lex_state = 0, .external_lex_state = 12},
  [17680] = {.lex_state = 499, .external_lex_state = 12},
  [17681] = {.lex_state = 0, .external_lex_state = 12},
  [17682] = {.lex_state = 0, .external_lex_state = 12},
  [17683] = {.lex_state = 0, .external_lex_state = 12},
  [17684] = {.lex_state = 0, .external_lex_state = 12},
  [17685] = {.lex_state = 0, .external_lex_state = 12},
  [17686] = {.lex_state = 0, .external_lex_state = 12},
  [17687] = {.lex_state = 0, .external_lex_state = 12},
  [17688] = {.lex_state = 0, .external_lex_state = 12},
  [17689] = {.lex_state = 0, .external_lex_state = 12},
  [17690] = {.lex_state = 0, .external_lex_state = 12},
  [17691] = {.lex_state = 0, .external_lex_state = 12},
  [17692] = {.lex_state = 499, .external_lex_state = 12},
  [17693] = {.lex_state = 0, .external_lex_state = 12},
  [17694] = {.lex_state = 0, .external_lex_state = 12},
  [17695] = {.lex_state = 0, .external_lex_state = 12},
  [17696] = {.lex_state = 499, .external_lex_state = 12},
  [17697] = {.lex_state = 499, .external_lex_state = 12},
  [17698] = {.lex_state = 499, .external_lex_state = 12},
  [17699] = {.lex_state = 0, .external_lex_state = 12},
  [17700] = {.lex_state = 499, .external_lex_state = 12},
  [17701] = {.lex_state = 0, .external_lex_state = 12},
  [17702] = {.lex_state = 0, .external_lex_state = 12},
  [17703] = {.lex_state = 0, .external_lex_state = 12},
  [17704] = {.lex_state = 409, .external_lex_state = 12},
  [17705] = {.lex_state = 0, .external_lex_state = 12},
  [17706] = {.lex_state = 499, .external_lex_state = 12},
  [17707] = {.lex_state = 0, .external_lex_state = 12},
  [17708] = {.lex_state = 0, .external_lex_state = 12},
  [17709] = {.lex_state = 0, .external_lex_state = 12},
  [17710] = {.lex_state = 0, .external_lex_state = 12},
  [17711] = {.lex_state = 0, .external_lex_state = 12},
  [17712] = {.lex_state = 0, .external_lex_state = 12},
  [17713] = {.lex_state = 0, .external_lex_state = 12},
  [17714] = {.lex_state = 499, .external_lex_state = 12},
  [17715] = {.lex_state = 0, .external_lex_state = 12},
  [17716] = {.lex_state = 0, .external_lex_state = 12},
  [17717] = {.lex_state = 0, .external_lex_state = 12},
  [17718] = {.lex_state = 0, .external_lex_state = 12},
  [17719] = {.lex_state = 0, .external_lex_state = 12},
  [17720] = {.lex_state = 0, .external_lex_state = 12},
  [17721] = {.lex_state = 0, .external_lex_state = 12},
  [17722] = {.lex_state = 0, .external_lex_state = 12},
  [17723] = {.lex_state = 0, .external_lex_state = 12},
  [17724] = {.lex_state = 0, .external_lex_state = 12},
  [17725] = {.lex_state = 0, .external_lex_state = 12},
  [17726] = {.lex_state = 0, .external_lex_state = 12},
  [17727] = {.lex_state = 0, .external_lex_state = 12},
  [17728] = {.lex_state = 499, .external_lex_state = 12},
  [17729] = {.lex_state = 499, .external_lex_state = 12},
  [17730] = {.lex_state = 499, .external_lex_state = 12},
  [17731] = {.lex_state = 0, .external_lex_state = 12},
  [17732] = {.lex_state = 0, .external_lex_state = 12},
  [17733] = {.lex_state = 0, .external_lex_state = 12},
  [17734] = {.lex_state = 499, .external_lex_state = 12},
  [17735] = {.lex_state = 0, .external_lex_state = 12},
  [17736] = {.lex_state = 409, .external_lex_state = 12},
  [17737] = {.lex_state = 0, .external_lex_state = 12},
  [17738] = {.lex_state = 0, .external_lex_state = 12},
  [17739] = {.lex_state = 0, .external_lex_state = 12},
  [17740] = {.lex_state = 0, .external_lex_state = 12},
  [17741] = {.lex_state = 0, .external_lex_state = 12},
  [17742] = {.lex_state = 0, .external_lex_state = 12},
  [17743] = {.lex_state = 0, .external_lex_state = 12},
  [17744] = {.lex_state = 0, .external_lex_state = 12},
  [17745] = {.lex_state = 0, .external_lex_state = 12},
  [17746] = {.lex_state = 499, .external_lex_state = 12},
  [17747] = {.lex_state = 499, .external_lex_state = 12},
  [17748] = {.lex_state = 0, .external_lex_state = 12},
  [17749] = {.lex_state = 499, .external_lex_state = 12},
  [17750] = {.lex_state = 0, .external_lex_state = 12},
  [17751] = {.lex_state = 409, .external_lex_state = 12},
  [17752] = {.lex_state = 0, .external_lex_state = 12},
  [17753] = {.lex_state = 0, .external_lex_state = 12},
  [17754] = {.lex_state = 0, .external_lex_state = 12},
  [17755] = {.lex_state = 0, .external_lex_state = 12},
  [17756] = {.lex_state = 499, .external_lex_state = 12},
  [17757] = {.lex_state = 0, .external_lex_state = 12},
  [17758] = {.lex_state = 0, .external_lex_state = 12},
  [17759] = {.lex_state = 0, .external_lex_state = 12},
  [17760] = {.lex_state = 0, .external_lex_state = 12},
  [17761] = {.lex_state = 0, .external_lex_state = 12},
  [17762] = {.lex_state = 0, .external_lex_state = 12},
  [17763] = {.lex_state = 0, .external_lex_state = 12},
  [17764] = {.lex_state = 0, .external_lex_state = 12},
  [17765] = {.lex_state = 0, .external_lex_state = 12},
  [17766] = {.lex_state = 0, .external_lex_state = 12},
  [17767] = {.lex_state = 499, .external_lex_state = 12},
  [17768] = {.lex_state = 499, .external_lex_state = 12},
  [17769] = {.lex_state = 0, .external_lex_state = 12},
  [17770] = {.lex_state = 499, .external_lex_state = 12},
  [17771] = {.lex_state = 0, .external_lex_state = 12},
  [17772] = {.lex_state = 0, .external_lex_state = 12},
  [17773] = {.lex_state = 0, .external_lex_state = 12},
  [17774] = {.lex_state = 0, .external_lex_state = 12},
  [17775] = {.lex_state = 0, .external_lex_state = 12},
  [17776] = {.lex_state = 0, .external_lex_state = 12},
  [17777] = {.lex_state = 0, .external_lex_state = 12},
  [17778] = {.lex_state = 0, .external_lex_state = 12},
  [17779] = {.lex_state = 0, .external_lex_state = 12},
  [17780] = {.lex_state = 0, .external_lex_state = 12},
  [17781] = {.lex_state = 499, .external_lex_state = 12},
  [17782] = {.lex_state = 0, .external_lex_state = 12},
  [17783] = {.lex_state = 0, .external_lex_state = 12},
  [17784] = {.lex_state = 0, .external_lex_state = 12},
  [17785] = {.lex_state = 0, .external_lex_state = 12},
  [17786] = {.lex_state = 0, .external_lex_state = 12},
  [17787] = {.lex_state = 0, .external_lex_state = 12},
  [17788] = {.lex_state = 0, .external_lex_state = 12},
  [17789] = {.lex_state = 0, .external_lex_state = 12},
  [17790] = {.lex_state = 0, .external_lex_state = 12},
  [17791] = {.lex_state = 499, .external_lex_state = 12},
  [17792] = {.lex_state = 0, .external_lex_state = 12},
  [17793] = {.lex_state = 0, .external_lex_state = 12},
  [17794] = {.lex_state = 0, .external_lex_state = 12},
  [17795] = {.lex_state = 0, .external_lex_state = 12},
  [17796] = {.lex_state = 0, .external_lex_state = 12},
  [17797] = {.lex_state = 0, .external_lex_state = 12},
  [17798] = {.lex_state = 0, .external_lex_state = 12},
  [17799] = {.lex_state = 0, .external_lex_state = 12},
  [17800] = {.lex_state = 499, .external_lex_state = 12},
  [17801] = {.lex_state = 363, .external_lex_state = 12},
  [17802] = {.lex_state = 499, .external_lex_state = 12},
  [17803] = {.lex_state = 499, .external_lex_state = 12},
  [17804] = {.lex_state = 409, .external_lex_state = 12},
  [17805] = {.lex_state = 0, .external_lex_state = 12},
  [17806] = {.lex_state = 499, .external_lex_state = 12},
  [17807] = {.lex_state = 0, .external_lex_state = 12},
  [17808] = {.lex_state = 0, .external_lex_state = 12},
  [17809] = {.lex_state = 0, .external_lex_state = 12},
  [17810] = {.lex_state = 0, .external_lex_state = 12},
  [17811] = {.lex_state = 0, .external_lex_state = 12},
  [17812] = {.lex_state = 0, .external_lex_state = 12},
  [17813] = {.lex_state = 0, .external_lex_state = 12},
  [17814] = {.lex_state = 0, .external_lex_state = 12},
  [17815] = {.lex_state = 0, .external_lex_state = 12},
  [17816] = {.lex_state = 0, .external_lex_state = 12},
  [17817] = {.lex_state = 0, .external_lex_state = 12},
  [17818] = {.lex_state = 0, .external_lex_state = 12},
  [17819] = {.lex_state = 0, .external_lex_state = 12},
  [17820] = {.lex_state = 0, .external_lex_state = 12},
  [17821] = {.lex_state = 0, .external_lex_state = 12},
  [17822] = {.lex_state = 499, .external_lex_state = 12},
  [17823] = {.lex_state = 0, .external_lex_state = 12},
  [17824] = {.lex_state = 0, .external_lex_state = 12},
  [17825] = {.lex_state = 0, .external_lex_state = 12},
  [17826] = {.lex_state = 0, .external_lex_state = 12},
  [17827] = {.lex_state = 0, .external_lex_state = 12},
  [17828] = {.lex_state = 0, .external_lex_state = 12},
  [17829] = {.lex_state = 0, .external_lex_state = 12},
  [17830] = {.lex_state = 0, .external_lex_state = 12},
  [17831] = {.lex_state = 499, .external_lex_state = 12},
  [17832] = {.lex_state = 0, .external_lex_state = 12},
  [17833] = {.lex_state = 0, .external_lex_state = 12},
  [17834] = {.lex_state = 499, .external_lex_state = 12},
  [17835] = {.lex_state = 0, .external_lex_state = 12},
  [17836] = {.lex_state = 0, .external_lex_state = 12},
  [17837] = {.lex_state = 0, .external_lex_state = 12},
  [17838] = {.lex_state = 0, .external_lex_state = 12},
  [17839] = {.lex_state = 0, .external_lex_state = 12},
  [17840] = {.lex_state = 0, .external_lex_state = 12},
  [17841] = {.lex_state = 0, .external_lex_state = 12},
  [17842] = {.lex_state = 0, .external_lex_state = 12},
  [17843] = {.lex_state = 499, .external_lex_state = 12},
  [17844] = {.lex_state = 0, .external_lex_state = 12},
  [17845] = {.lex_state = 0, .external_lex_state = 12},
  [17846] = {.lex_state = 0, .external_lex_state = 12},
  [17847] = {.lex_state = 0, .external_lex_state = 12},
  [17848] = {.lex_state = 0, .external_lex_state = 12},
  [17849] = {.lex_state = 499, .external_lex_state = 12},
  [17850] = {.lex_state = 0, .external_lex_state = 12},
  [17851] = {.lex_state = 0, .external_lex_state = 12},
  [17852] = {.lex_state = 0, .external_lex_state = 12},
  [17853] = {.lex_state = 409, .external_lex_state = 12},
  [17854] = {.lex_state = 0, .external_lex_state = 12},
  [17855] = {.lex_state = 0, .external_lex_state = 12},
  [17856] = {.lex_state = 0, .external_lex_state = 12},
  [17857] = {.lex_state = 0, .external_lex_state = 12},
  [17858] = {.lex_state = 0, .external_lex_state = 12},
  [17859] = {.lex_state = 0, .external_lex_state = 12},
  [17860] = {.lex_state = 0, .external_lex_state = 12},
  [17861] = {.lex_state = 0, .external_lex_state = 12},
  [17862] = {.lex_state = 0, .external_lex_state = 12},
  [17863] = {.lex_state = 0, .external_lex_state = 12},
  [17864] = {.lex_state = 0, .external_lex_state = 12},
  [17865] = {.lex_state = 0, .external_lex_state = 12},
  [17866] = {.lex_state = 499, .external_lex_state = 12},
  [17867] = {.lex_state = 0, .external_lex_state = 12},
  [17868] = {.lex_state = 499, .external_lex_state = 12},
  [17869] = {.lex_state = 0, .external_lex_state = 12},
  [17870] = {.lex_state = 0, .external_lex_state = 12},
  [17871] = {.lex_state = 0, .external_lex_state = 12},
  [17872] = {.lex_state = 0, .external_lex_state = 12},
  [17873] = {.lex_state = 0, .external_lex_state = 12},
  [17874] = {.lex_state = 0, .external_lex_state = 12},
  [17875] = {.lex_state = 0, .external_lex_state = 12},
  [17876] = {.lex_state = 0, .external_lex_state = 12},
  [17877] = {.lex_state = 0, .external_lex_state = 12},
  [17878] = {.lex_state = 0, .external_lex_state = 12},
  [17879] = {.lex_state = 0, .external_lex_state = 12},
  [17880] = {.lex_state = 0, .external_lex_state = 12},
  [17881] = {.lex_state = 0, .external_lex_state = 12},
  [17882] = {.lex_state = 499, .external_lex_state = 12},
  [17883] = {.lex_state = 0, .external_lex_state = 12},
  [17884] = {.lex_state = 0, .external_lex_state = 12},
  [17885] = {.lex_state = 0, .external_lex_state = 12},
  [17886] = {.lex_state = 0, .external_lex_state = 12},
  [17887] = {.lex_state = 409, .external_lex_state = 12},
  [17888] = {.lex_state = 0, .external_lex_state = 12},
  [17889] = {.lex_state = 0, .external_lex_state = 12},
  [17890] = {.lex_state = 0, .external_lex_state = 12},
  [17891] = {.lex_state = 0, .external_lex_state = 12},
  [17892] = {.lex_state = 0, .external_lex_state = 12},
  [17893] = {.lex_state = 0, .external_lex_state = 12},
  [17894] = {.lex_state = 0, .external_lex_state = 12},
  [17895] = {.lex_state = 0, .external_lex_state = 12},
  [17896] = {.lex_state = 0, .external_lex_state = 12},
  [17897] = {.lex_state = 0, .external_lex_state = 12},
  [17898] = {.lex_state = 0, .external_lex_state = 12},
  [17899] = {.lex_state = 499, .external_lex_state = 12},
  [17900] = {.lex_state = 0, .external_lex_state = 12},
  [17901] = {.lex_state = 0, .external_lex_state = 12},
  [17902] = {.lex_state = 0, .external_lex_state = 12},
  [17903] = {.lex_state = 0, .external_lex_state = 12},
  [17904] = {.lex_state = 0, .external_lex_state = 12},
  [17905] = {.lex_state = 0, .external_lex_state = 12},
  [17906] = {.lex_state = 0, .external_lex_state = 12},
  [17907] = {.lex_state = 0, .external_lex_state = 12},
  [17908] = {.lex_state = 0, .external_lex_state = 12},
  [17909] = {.lex_state = 499, .external_lex_state = 12},
  [17910] = {.lex_state = 0, .external_lex_state = 12},
  [17911] = {.lex_state = 0, .external_lex_state = 12},
  [17912] = {.lex_state = 499, .external_lex_state = 12},
  [17913] = {.lex_state = 0, .external_lex_state = 12},
  [17914] = {.lex_state = 0, .external_lex_state = 12},
  [17915] = {.lex_state = 499, .external_lex_state = 12},
  [17916] = {.lex_state = 0, .external_lex_state = 12},
  [17917] = {.lex_state = 0, .external_lex_state = 12},
  [17918] = {.lex_state = 0, .external_lex_state = 12},
  [17919] = {.lex_state = 0, .external_lex_state = 12},
  [17920] = {.lex_state = 0, .external_lex_state = 12},
  [17921] = {.lex_state = 0, .external_lex_state = 12},
  [17922] = {.lex_state = 0, .external_lex_state = 12},
  [17923] = {.lex_state = 0, .external_lex_state = 12},
  [17924] = {.lex_state = 0, .external_lex_state = 12},
  [17925] = {.lex_state = 0, .external_lex_state = 12},
  [17926] = {.lex_state = 0, .external_lex_state = 12},
  [17927] = {.lex_state = 499, .external_lex_state = 12},
  [17928] = {.lex_state = 0, .external_lex_state = 12},
  [17929] = {.lex_state = 0, .external_lex_state = 12},
  [17930] = {.lex_state = 409, .external_lex_state = 12},
  [17931] = {.lex_state = 0, .external_lex_state = 12},
  [17932] = {.lex_state = 0, .external_lex_state = 12},
  [17933] = {.lex_state = 0, .external_lex_state = 12},
  [17934] = {.lex_state = 0, .external_lex_state = 12},
  [17935] = {.lex_state = 0, .external_lex_state = 12},
  [17936] = {.lex_state = 0, .external_lex_state = 12},
  [17937] = {.lex_state = 0, .external_lex_state = 12},
  [17938] = {.lex_state = 0, .external_lex_state = 12},
  [17939] = {.lex_state = 0, .external_lex_state = 12},
  [17940] = {.lex_state = 0, .external_lex_state = 12},
  [17941] = {.lex_state = 0, .external_lex_state = 12},
  [17942] = {.lex_state = 0, .external_lex_state = 12},
  [17943] = {.lex_state = 499, .external_lex_state = 12},
  [17944] = {.lex_state = 0, .external_lex_state = 12},
  [17945] = {.lex_state = 0, .external_lex_state = 12},
  [17946] = {.lex_state = 0, .external_lex_state = 12},
  [17947] = {.lex_state = 0, .external_lex_state = 12},
  [17948] = {.lex_state = 0, .external_lex_state = 12},
  [17949] = {.lex_state = 0, .external_lex_state = 12},
  [17950] = {.lex_state = 0, .external_lex_state = 12},
  [17951] = {.lex_state = 0, .external_lex_state = 12},
  [17952] = {.lex_state = 0, .external_lex_state = 12},
  [17953] = {.lex_state = 0, .external_lex_state = 12},
  [17954] = {.lex_state = 0, .external_lex_state = 12},
  [17955] = {.lex_state = 0, .external_lex_state = 12},
  [17956] = {.lex_state = 0, .external_lex_state = 12},
  [17957] = {.lex_state = 499, .external_lex_state = 12},
  [17958] = {.lex_state = 0, .external_lex_state = 12},
  [17959] = {.lex_state = 0, .external_lex_state = 12},
  [17960] = {.lex_state = 0, .external_lex_state = 12},
  [17961] = {.lex_state = 0, .external_lex_state = 12},
  [17962] = {.lex_state = 0, .external_lex_state = 12},
  [17963] = {.lex_state = 499, .external_lex_state = 12},
  [17964] = {.lex_state = 0, .external_lex_state = 12},
  [17965] = {.lex_state = 0, .external_lex_state = 12},
  [17966] = {.lex_state = 0, .external_lex_state = 12},
  [17967] = {.lex_state = 0, .external_lex_state = 12},
  [17968] = {.lex_state = 0, .external_lex_state = 12},
  [17969] = {.lex_state = 0, .external_lex_state = 12},
  [17970] = {.lex_state = 0, .external_lex_state = 12},
  [17971] = {.lex_state = 0, .external_lex_state = 12},
  [17972] = {.lex_state = 0, .external_lex_state = 12},
  [17973] = {.lex_state = 0, .external_lex_state = 12},
  [17974] = {.lex_state = 0, .external_lex_state = 12},
  [17975] = {.lex_state = 0, .external_lex_state = 12},
  [17976] = {.lex_state = 0, .external_lex_state = 12},
  [17977] = {.lex_state = 0, .external_lex_state = 12},
  [17978] = {.lex_state = 0, .external_lex_state = 12},
  [17979] = {.lex_state = 0, .external_lex_state = 12},
  [17980] = {.lex_state = 0, .external_lex_state = 12},
  [17981] = {.lex_state = 0, .external_lex_state = 12},
  [17982] = {.lex_state = 0, .external_lex_state = 12},
  [17983] = {.lex_state = 0, .external_lex_state = 12},
  [17984] = {.lex_state = 0, .external_lex_state = 12},
  [17985] = {.lex_state = 0, .external_lex_state = 12},
  [17986] = {.lex_state = 0, .external_lex_state = 12},
  [17987] = {.lex_state = 0, .external_lex_state = 12},
  [17988] = {.lex_state = 0, .external_lex_state = 12},
  [17989] = {.lex_state = 0, .external_lex_state = 12},
  [17990] = {.lex_state = 0, .external_lex_state = 12},
  [17991] = {.lex_state = 0, .external_lex_state = 12},
  [17992] = {.lex_state = 0, .external_lex_state = 12},
  [17993] = {.lex_state = 0, .external_lex_state = 12},
  [17994] = {.lex_state = 0, .external_lex_state = 12},
  [17995] = {.lex_state = 0, .external_lex_state = 12},
  [17996] = {.lex_state = 0, .external_lex_state = 12},
  [17997] = {.lex_state = 0, .external_lex_state = 12},
  [17998] = {.lex_state = 0, .external_lex_state = 12},
  [17999] = {.lex_state = 0, .external_lex_state = 12},
  [18000] = {.lex_state = 499, .external_lex_state = 12},
  [18001] = {.lex_state = 0, .external_lex_state = 12},
  [18002] = {.lex_state = 0, .external_lex_state = 12},
  [18003] = {.lex_state = 499, .external_lex_state = 12},
  [18004] = {.lex_state = 0, .external_lex_state = 12},
  [18005] = {.lex_state = 499, .external_lex_state = 12},
  [18006] = {.lex_state = 0, .external_lex_state = 12},
  [18007] = {.lex_state = 499, .external_lex_state = 12},
  [18008] = {.lex_state = 0, .external_lex_state = 12},
  [18009] = {.lex_state = 499, .external_lex_state = 12},
  [18010] = {.lex_state = 0, .external_lex_state = 12},
  [18011] = {.lex_state = 499, .external_lex_state = 12},
  [18012] = {.lex_state = 0, .external_lex_state = 12},
  [18013] = {.lex_state = 499, .external_lex_state = 12},
  [18014] = {.lex_state = 0, .external_lex_state = 12},
  [18015] = {.lex_state = 0, .external_lex_state = 12},
  [18016] = {.lex_state = 499, .external_lex_state = 12},
  [18017] = {.lex_state = 0, .external_lex_state = 12},
  [18018] = {.lex_state = 0, .external_lex_state = 12},
  [18019] = {.lex_state = 0, .external_lex_state = 12},
  [18020] = {.lex_state = 0, .external_lex_state = 12},
  [18021] = {.lex_state = 499, .external_lex_state = 12},
  [18022] = {.lex_state = 499, .external_lex_state = 12},
  [18023] = {.lex_state = 0, .external_lex_state = 12},
  [18024] = {.lex_state = 0, .external_lex_state = 12},
  [18025] = {.lex_state = 0, .external_lex_state = 12},
  [18026] = {.lex_state = 499, .external_lex_state = 12},
  [18027] = {.lex_state = 0, .external_lex_state = 12},
  [18028] = {.lex_state = 0, .external_lex_state = 12},
  [18029] = {.lex_state = 0, .external_lex_state = 12},
  [18030] = {.lex_state = 499, .external_lex_state = 12},
  [18031] = {.lex_state = 409, .external_lex_state = 12},
  [18032] = {.lex_state = 0, .external_lex_state = 12},
  [18033] = {.lex_state = 0, .external_lex_state = 12},
  [18034] = {.lex_state = 409, .external_lex_state = 12},
  [18035] = {.lex_state = 0, .external_lex_state = 12},
  [18036] = {.lex_state = 0, .external_lex_state = 12},
  [18037] = {.lex_state = 0, .external_lex_state = 12},
  [18038] = {.lex_state = 0, .external_lex_state = 12},
  [18039] = {.lex_state = 0, .external_lex_state = 12},
  [18040] = {.lex_state = 409, .external_lex_state = 12},
  [18041] = {.lex_state = 409, .external_lex_state = 12},
  [18042] = {.lex_state = 0, .external_lex_state = 12},
  [18043] = {.lex_state = 499, .external_lex_state = 12},
  [18044] = {.lex_state = 0, .external_lex_state = 12},
  [18045] = {.lex_state = 0, .external_lex_state = 12},
  [18046] = {.lex_state = 0, .external_lex_state = 12},
  [18047] = {.lex_state = 0, .external_lex_state = 12},
  [18048] = {.lex_state = 499, .external_lex_state = 12},
  [18049] = {.lex_state = 0, .external_lex_state = 12},
  [18050] = {.lex_state = 409, .external_lex_state = 12},
  [18051] = {.lex_state = 0, .external_lex_state = 12},
  [18052] = {.lex_state = 0, .external_lex_state = 12},
  [18053] = {.lex_state = 0, .external_lex_state = 12},
  [18054] = {.lex_state = 0, .external_lex_state = 12},
  [18055] = {.lex_state = 409, .external_lex_state = 12},
  [18056] = {.lex_state = 409, .external_lex_state = 12},
  [18057] = {.lex_state = 499, .external_lex_state = 12},
  [18058] = {.lex_state = 499, .external_lex_state = 12},
  [18059] = {.lex_state = 499, .external_lex_state = 12},
  [18060] = {.lex_state = 0, .external_lex_state = 12},
  [18061] = {.lex_state = 0, .external_lex_state = 12},
  [18062] = {.lex_state = 0, .external_lex_state = 12},
  [18063] = {.lex_state = 0, .external_lex_state = 12},
  [18064] = {.lex_state = 363, .external_lex_state = 12},
  [18065] = {.lex_state = 499, .external_lex_state = 12},
  [18066] = {.lex_state = 409, .external_lex_state = 12},
  [18067] = {.lex_state = 409, .external_lex_state = 12},
  [18068] = {.lex_state = 0, .external_lex_state = 12},
  [18069] = {.lex_state = 499, .external_lex_state = 12},
  [18070] = {.lex_state = 0, .external_lex_state = 12},
  [18071] = {.lex_state = 0, .external_lex_state = 12},
  [18072] = {.lex_state = 409, .external_lex_state = 12},
  [18073] = {.lex_state = 0, .external_lex_state = 12},
  [18074] = {.lex_state = 409, .external_lex_state = 12},
  [18075] = {.lex_state = 0, .external_lex_state = 12},
  [18076] = {.lex_state = 0, .external_lex_state = 12},
  [18077] = {.lex_state = 499, .external_lex_state = 12},
  [18078] = {.lex_state = 0, .external_lex_state = 12},
  [18079] = {.lex_state = 409, .external_lex_state = 12},
  [18080] = {.lex_state = 0, .external_lex_state = 12},
  [18081] = {.lex_state = 0, .external_lex_state = 12},
  [18082] = {.lex_state = 0, .external_lex_state = 12},
  [18083] = {.lex_state = 409, .external_lex_state = 12},
  [18084] = {.lex_state = 0, .external_lex_state = 12},
  [18085] = {.lex_state = 409, .external_lex_state = 12},
  [18086] = {.lex_state = 409, .external_lex_state = 12},
  [18087] = {.lex_state = 409, .external_lex_state = 12},
  [18088] = {.lex_state = 499, .external_lex_state = 12},
  [18089] = {.lex_state = 0, .external_lex_state = 12},
  [18090] = {.lex_state = 409, .external_lex_state = 12},
  [18091] = {.lex_state = 0, .external_lex_state = 12},
  [18092] = {.lex_state = 0, .external_lex_state = 12},
  [18093] = {.lex_state = 0, .external_lex_state = 12},
  [18094] = {.lex_state = 409, .external_lex_state = 12},
  [18095] = {.lex_state = 0, .external_lex_state = 12},
  [18096] = {.lex_state = 0, .external_lex_state = 12},
  [18097] = {.lex_state = 0, .external_lex_state = 12},
  [18098] = {.lex_state = 499, .external_lex_state = 12},
  [18099] = {.lex_state = 0, .external_lex_state = 12},
  [18100] = {.lex_state = 0, .external_lex_state = 12},
  [18101] = {.lex_state = 0, .external_lex_state = 12},
  [18102] = {.lex_state = 499, .external_lex_state = 12},
  [18103] = {.lex_state = 0, .external_lex_state = 12},
  [18104] = {.lex_state = 0, .external_lex_state = 12},
  [18105] = {.lex_state = 0, .external_lex_state = 12},
  [18106] = {.lex_state = 0, .external_lex_state = 12},
  [18107] = {.lex_state = 0, .external_lex_state = 12},
  [18108] = {.lex_state = 0, .external_lex_state = 12},
  [18109] = {.lex_state = 0, .external_lex_state = 12},
  [18110] = {.lex_state = 0, .external_lex_state = 12},
  [18111] = {.lex_state = 0, .external_lex_state = 12},
  [18112] = {.lex_state = 0, .external_lex_state = 12},
  [18113] = {.lex_state = 0, .external_lex_state = 12},
  [18114] = {.lex_state = 0, .external_lex_state = 12},
  [18115] = {.lex_state = 0, .external_lex_state = 12},
  [18116] = {.lex_state = 0, .external_lex_state = 12},
  [18117] = {.lex_state = 0, .external_lex_state = 12},
  [18118] = {.lex_state = 0, .external_lex_state = 12},
  [18119] = {.lex_state = 0, .external_lex_state = 12},
  [18120] = {.lex_state = 0, .external_lex_state = 12},
  [18121] = {.lex_state = 0, .external_lex_state = 12},
  [18122] = {.lex_state = 0, .external_lex_state = 12},
  [18123] = {.lex_state = 0, .external_lex_state = 12},
  [18124] = {.lex_state = 0, .external_lex_state = 12},
  [18125] = {.lex_state = 0, .external_lex_state = 12},
  [18126] = {.lex_state = 499, .external_lex_state = 12},
  [18127] = {.lex_state = 499, .external_lex_state = 12},
  [18128] = {.lex_state = 0, .external_lex_state = 12},
  [18129] = {.lex_state = 0, .external_lex_state = 12},
  [18130] = {.lex_state = 0, .external_lex_state = 12},
  [18131] = {.lex_state = 0, .external_lex_state = 12},
  [18132] = {.lex_state = 0, .external_lex_state = 12},
  [18133] = {.lex_state = 0, .external_lex_state = 12},
  [18134] = {.lex_state = 363, .external_lex_state = 12},
  [18135] = {.lex_state = 0, .external_lex_state = 12},
  [18136] = {.lex_state = 0, .external_lex_state = 12},
  [18137] = {.lex_state = 0, .external_lex_state = 12},
  [18138] = {.lex_state = 0, .external_lex_state = 12},
  [18139] = {.lex_state = 0, .external_lex_state = 12},
  [18140] = {.lex_state = 499, .external_lex_state = 12},
  [18141] = {.lex_state = 499, .external_lex_state = 12},
  [18142] = {.lex_state = 409, .external_lex_state = 12},
  [18143] = {.lex_state = 409, .external_lex_state = 12},
  [18144] = {.lex_state = 409, .external_lex_state = 12},
  [18145] = {.lex_state = 0, .external_lex_state = 12},
  [18146] = {.lex_state = 0, .external_lex_state = 12},
  [18147] = {.lex_state = 0, .external_lex_state = 12},
  [18148] = {.lex_state = 0, .external_lex_state = 12},
  [18149] = {.lex_state = 499, .external_lex_state = 12},
  [18150] = {.lex_state = 0, .external_lex_state = 12},
  [18151] = {.lex_state = 0, .external_lex_state = 12},
  [18152] = {.lex_state = 499, .external_lex_state = 12},
  [18153] = {.lex_state = 0, .external_lex_state = 12},
  [18154] = {.lex_state = 0, .external_lex_state = 12},
  [18155] = {.lex_state = 363, .external_lex_state = 12},
  [18156] = {.lex_state = 0, .external_lex_state = 12},
  [18157] = {.lex_state = 0, .external_lex_state = 12},
  [18158] = {.lex_state = 363, .external_lex_state = 12},
  [18159] = {.lex_state = 0, .external_lex_state = 12},
  [18160] = {.lex_state = 363, .external_lex_state = 12},
  [18161] = {.lex_state = 363, .external_lex_state = 12},
  [18162] = {.lex_state = 0, .external_lex_state = 12},
  [18163] = {.lex_state = 363, .external_lex_state = 12},
  [18164] = {.lex_state = 363, .external_lex_state = 12},
  [18165] = {.lex_state = 363, .external_lex_state = 12},
  [18166] = {.lex_state = 363, .external_lex_state = 12},
  [18167] = {.lex_state = 0, .external_lex_state = 12},
  [18168] = {.lex_state = 363, .external_lex_state = 12},
  [18169] = {.lex_state = 363, .external_lex_state = 12},
  [18170] = {.lex_state = 343, .external_lex_state = 12},
  [18171] = {.lex_state = 363, .external_lex_state = 12},
  [18172] = {.lex_state = 363, .external_lex_state = 12},
  [18173] = {.lex_state = 343, .external_lex_state = 12},
  [18174] = {.lex_state = 363, .external_lex_state = 12},
  [18175] = {.lex_state = 0, .external_lex_state = 12},
  [18176] = {.lex_state = 0, .external_lex_state = 12},
  [18177] = {.lex_state = 363, .external_lex_state = 12},
  [18178] = {.lex_state = 0, .external_lex_state = 12},
  [18179] = {.lex_state = 363, .external_lex_state = 12},
  [18180] = {.lex_state = 363, .external_lex_state = 12},
  [18181] = {.lex_state = 0, .external_lex_state = 12},
  [18182] = {.lex_state = 363, .external_lex_state = 12},
  [18183] = {.lex_state = 0, .external_lex_state = 12},
  [18184] = {.lex_state = 0, .external_lex_state = 12},
  [18185] = {.lex_state = 409, .external_lex_state = 12},
  [18186] = {.lex_state = 0, .external_lex_state = 12},
  [18187] = {.lex_state = 0, .external_lex_state = 12},
  [18188] = {.lex_state = 0, .external_lex_state = 12},
  [18189] = {.lex_state = 0, .external_lex_state = 12},
  [18190] = {.lex_state = 0, .external_lex_state = 12},
  [18191] = {.lex_state = 0, .external_lex_state = 12},
  [18192] = {.lex_state = 0, .external_lex_state = 12},
  [18193] = {.lex_state = 363, .external_lex_state = 12},
  [18194] = {.lex_state = 363, .external_lex_state = 12},
  [18195] = {.lex_state = 363, .external_lex_state = 12},
  [18196] = {.lex_state = 363, .external_lex_state = 12},
  [18197] = {.lex_state = 0, .external_lex_state = 12},
  [18198] = {.lex_state = 0, .external_lex_state = 12},
  [18199] = {.lex_state = 363, .external_lex_state = 12},
  [18200] = {.lex_state = 0, .external_lex_state = 12},
  [18201] = {.lex_state = 0, .external_lex_state = 12},
  [18202] = {.lex_state = 363, .external_lex_state = 12},
  [18203] = {.lex_state = 0, .external_lex_state = 12},
  [18204] = {.lex_state = 0, .external_lex_state = 12},
  [18205] = {.lex_state = 0, .external_lex_state = 12},
  [18206] = {.lex_state = 0, .external_lex_state = 12},
  [18207] = {.lex_state = 0, .external_lex_state = 12},
  [18208] = {.lex_state = 0, .external_lex_state = 12},
  [18209] = {.lex_state = 363, .external_lex_state = 12},
  [18210] = {.lex_state = 0, .external_lex_state = 12},
  [18211] = {.lex_state = 363, .external_lex_state = 12},
  [18212] = {.lex_state = 0, .external_lex_state = 12},
  [18213] = {.lex_state = 363, .external_lex_state = 12},
  [18214] = {.lex_state = 0, .external_lex_state = 12},
  [18215] = {.lex_state = 0, .external_lex_state = 12},
  [18216] = {.lex_state = 363, .external_lex_state = 12},
  [18217] = {.lex_state = 363, .external_lex_state = 12},
  [18218] = {.lex_state = 0, .external_lex_state = 12},
  [18219] = {.lex_state = 363, .external_lex_state = 12},
  [18220] = {.lex_state = 0, .external_lex_state = 12},
  [18221] = {.lex_state = 363, .external_lex_state = 12},
  [18222] = {.lex_state = 363, .external_lex_state = 12},
  [18223] = {.lex_state = 0, .external_lex_state = 12},
  [18224] = {.lex_state = 363, .external_lex_state = 12},
  [18225] = {.lex_state = 0, .external_lex_state = 12},
  [18226] = {.lex_state = 0, .external_lex_state = 12},
  [18227] = {.lex_state = 363, .external_lex_state = 12},
  [18228] = {.lex_state = 0, .external_lex_state = 12},
  [18229] = {.lex_state = 343, .external_lex_state = 12},
  [18230] = {.lex_state = 0, .external_lex_state = 12},
  [18231] = {.lex_state = 0, .external_lex_state = 12},
  [18232] = {.lex_state = 363, .external_lex_state = 12},
  [18233] = {.lex_state = 363, .external_lex_state = 12},
  [18234] = {.lex_state = 0, .external_lex_state = 12},
  [18235] = {.lex_state = 0, .external_lex_state = 12},
  [18236] = {.lex_state = 0, .external_lex_state = 12},
  [18237] = {.lex_state = 363, .external_lex_state = 12},
  [18238] = {.lex_state = 363, .external_lex_state = 12},
  [18239] = {.lex_state = 363, .external_lex_state = 12},
  [18240] = {.lex_state = 0, .external_lex_state = 12},
  [18241] = {.lex_state = 363, .external_lex_state = 12},
  [18242] = {.lex_state = 0, .external_lex_state = 12},
  [18243] = {.lex_state = 0, .external_lex_state = 12},
  [18244] = {.lex_state = 363, .external_lex_state = 12},
  [18245] = {.lex_state = 0, .external_lex_state = 12},
  [18246] = {.lex_state = 363, .external_lex_state = 12},
  [18247] = {.lex_state = 363, .external_lex_state = 12},
  [18248] = {.lex_state = 363, .external_lex_state = 12},
  [18249] = {.lex_state = 0, .external_lex_state = 12},
  [18250] = {.lex_state = 363, .external_lex_state = 12},
  [18251] = {.lex_state = 363, .external_lex_state = 12},
  [18252] = {.lex_state = 0, .external_lex_state = 12},
  [18253] = {.lex_state = 363, .external_lex_state = 12},
  [18254] = {.lex_state = 0, .external_lex_state = 12},
  [18255] = {.lex_state = 363, .external_lex_state = 12},
  [18256] = {.lex_state = 363, .external_lex_state = 12},
  [18257] = {.lex_state = 0, .external_lex_state = 12},
  [18258] = {.lex_state = 0, .external_lex_state = 12},
  [18259] = {.lex_state = 363, .external_lex_state = 12},
  [18260] = {.lex_state = 363, .external_lex_state = 12},
  [18261] = {.lex_state = 0, .external_lex_state = 12},
  [18262] = {.lex_state = 343, .external_lex_state = 12},
  [18263] = {.lex_state = 343, .external_lex_state = 12},
  [18264] = {.lex_state = 363, .external_lex_state = 12},
  [18265] = {.lex_state = 363, .external_lex_state = 12},
  [18266] = {.lex_state = 363, .external_lex_state = 12},
  [18267] = {.lex_state = 363, .external_lex_state = 12},
  [18268] = {.lex_state = 0, .external_lex_state = 12},
  [18269] = {.lex_state = 0, .external_lex_state = 12},
  [18270] = {.lex_state = 0, .external_lex_state = 12},
  [18271] = {.lex_state = 0, .external_lex_state = 12},
  [18272] = {.lex_state = 0, .external_lex_state = 12},
  [18273] = {.lex_state = 0, .external_lex_state = 12},
  [18274] = {.lex_state = 363, .external_lex_state = 12},
  [18275] = {.lex_state = 0, .external_lex_state = 12},
  [18276] = {.lex_state = 0, .external_lex_state = 12},
  [18277] = {.lex_state = 409, .external_lex_state = 12},
  [18278] = {.lex_state = 0, .external_lex_state = 12},
  [18279] = {.lex_state = 0, .external_lex_state = 12},
  [18280] = {.lex_state = 0, .external_lex_state = 12},
  [18281] = {.lex_state = 0, .external_lex_state = 12},
  [18282] = {.lex_state = 363, .external_lex_state = 12},
  [18283] = {.lex_state = 363, .external_lex_state = 12},
  [18284] = {.lex_state = 363, .external_lex_state = 12},
  [18285] = {.lex_state = 363, .external_lex_state = 12},
  [18286] = {.lex_state = 0, .external_lex_state = 12},
  [18287] = {.lex_state = 0, .external_lex_state = 12},
  [18288] = {.lex_state = 343, .external_lex_state = 12},
  [18289] = {.lex_state = 0, .external_lex_state = 12},
  [18290] = {.lex_state = 0, .external_lex_state = 12},
  [18291] = {.lex_state = 0, .external_lex_state = 12},
  [18292] = {.lex_state = 0, .external_lex_state = 12},
  [18293] = {.lex_state = 0, .external_lex_state = 12},
  [18294] = {.lex_state = 363, .external_lex_state = 12},
  [18295] = {.lex_state = 409, .external_lex_state = 12},
  [18296] = {.lex_state = 363, .external_lex_state = 12},
  [18297] = {.lex_state = 0, .external_lex_state = 12},
  [18298] = {.lex_state = 363, .external_lex_state = 12},
  [18299] = {.lex_state = 0, .external_lex_state = 12},
  [18300] = {.lex_state = 0, .external_lex_state = 12},
  [18301] = {.lex_state = 363, .external_lex_state = 12},
  [18302] = {.lex_state = 0, .external_lex_state = 12},
  [18303] = {.lex_state = 0, .external_lex_state = 12},
  [18304] = {.lex_state = 0, .external_lex_state = 12},
  [18305] = {.lex_state = 363, .external_lex_state = 12},
  [18306] = {.lex_state = 0, .external_lex_state = 12},
  [18307] = {.lex_state = 363, .external_lex_state = 12},
  [18308] = {.lex_state = 363, .external_lex_state = 12},
  [18309] = {.lex_state = 363, .external_lex_state = 12},
  [18310] = {.lex_state = 363, .external_lex_state = 12},
  [18311] = {.lex_state = 0, .external_lex_state = 12},
  [18312] = {.lex_state = 363, .external_lex_state = 12},
  [18313] = {.lex_state = 0, .external_lex_state = 12},
  [18314] = {.lex_state = 363, .external_lex_state = 12},
  [18315] = {.lex_state = 363, .external_lex_state = 12},
  [18316] = {.lex_state = 0, .external_lex_state = 12},
  [18317] = {.lex_state = 363, .external_lex_state = 12},
  [18318] = {.lex_state = 363, .external_lex_state = 12},
  [18319] = {.lex_state = 0, .external_lex_state = 12},
  [18320] = {.lex_state = 0, .external_lex_state = 12},
  [18321] = {.lex_state = 0, .external_lex_state = 12},
  [18322] = {.lex_state = 0, .external_lex_state = 12},
  [18323] = {.lex_state = 363, .external_lex_state = 12},
  [18324] = {.lex_state = 0, .external_lex_state = 12},
  [18325] = {.lex_state = 0, .external_lex_state = 12},
  [18326] = {.lex_state = 0, .external_lex_state = 12},
  [18327] = {.lex_state = 363, .external_lex_state = 12},
  [18328] = {.lex_state = 0, .external_lex_state = 12},
  [18329] = {.lex_state = 0, .external_lex_state = 12},
  [18330] = {.lex_state = 0, .external_lex_state = 12},
  [18331] = {.lex_state = 0, .external_lex_state = 12},
  [18332] = {.lex_state = 0, .external_lex_state = 12},
  [18333] = {.lex_state = 0, .external_lex_state = 12},
  [18334] = {.lex_state = 0, .external_lex_state = 12},
  [18335] = {.lex_state = 363, .external_lex_state = 12},
  [18336] = {.lex_state = 0, .external_lex_state = 12},
  [18337] = {.lex_state = 363, .external_lex_state = 12},
  [18338] = {.lex_state = 363, .external_lex_state = 12},
  [18339] = {.lex_state = 0, .external_lex_state = 12},
  [18340] = {.lex_state = 363, .external_lex_state = 12},
  [18341] = {.lex_state = 0, .external_lex_state = 12},
  [18342] = {.lex_state = 363, .external_lex_state = 12},
  [18343] = {.lex_state = 363, .external_lex_state = 12},
  [18344] = {.lex_state = 343, .external_lex_state = 12},
  [18345] = {.lex_state = 363, .external_lex_state = 12},
  [18346] = {.lex_state = 363, .external_lex_state = 12},
  [18347] = {.lex_state = 0, .external_lex_state = 12},
  [18348] = {.lex_state = 0, .external_lex_state = 12},
  [18349] = {.lex_state = 363, .external_lex_state = 12},
  [18350] = {.lex_state = 363, .external_lex_state = 12},
  [18351] = {.lex_state = 0, .external_lex_state = 12},
  [18352] = {.lex_state = 363, .external_lex_state = 12},
  [18353] = {.lex_state = 0, .external_lex_state = 12},
  [18354] = {.lex_state = 363, .external_lex_state = 12},
  [18355] = {.lex_state = 0, .external_lex_state = 12},
  [18356] = {.lex_state = 363, .external_lex_state = 12},
  [18357] = {.lex_state = 0, .external_lex_state = 12},
  [18358] = {.lex_state = 409, .external_lex_state = 12},
  [18359] = {.lex_state = 0, .external_lex_state = 12},
  [18360] = {.lex_state = 363, .external_lex_state = 12},
  [18361] = {.lex_state = 0, .external_lex_state = 12},
  [18362] = {.lex_state = 363, .external_lex_state = 12},
  [18363] = {.lex_state = 0, .external_lex_state = 12},
  [18364] = {.lex_state = 363, .external_lex_state = 12},
  [18365] = {.lex_state = 363, .external_lex_state = 12},
  [18366] = {.lex_state = 363, .external_lex_state = 12},
  [18367] = {.lex_state = 363, .external_lex_state = 12},
  [18368] = {.lex_state = 363, .external_lex_state = 12},
  [18369] = {.lex_state = 363, .external_lex_state = 12},
  [18370] = {.lex_state = 409, .external_lex_state = 12},
  [18371] = {.lex_state = 0, .external_lex_state = 12},
  [18372] = {.lex_state = 343, .external_lex_state = 12},
  [18373] = {.lex_state = 409, .external_lex_state = 12},
  [18374] = {.lex_state = 0, .external_lex_state = 12},
  [18375] = {.lex_state = 0, .external_lex_state = 12},
  [18376] = {.lex_state = 0, .external_lex_state = 12},
  [18377] = {.lex_state = 0, .external_lex_state = 12},
  [18378] = {.lex_state = 0, .external_lex_state = 12},
  [18379] = {.lex_state = 0, .external_lex_state = 12},
  [18380] = {.lex_state = 343, .external_lex_state = 12},
  [18381] = {.lex_state = 0, .external_lex_state = 12},
  [18382] = {.lex_state = 0, .external_lex_state = 12},
  [18383] = {.lex_state = 0, .external_lex_state = 12},
  [18384] = {.lex_state = 363, .external_lex_state = 12},
  [18385] = {.lex_state = 363, .external_lex_state = 12},
  [18386] = {.lex_state = 0, .external_lex_state = 12},
  [18387] = {.lex_state = 409, .external_lex_state = 12},
  [18388] = {.lex_state = 0, .external_lex_state = 12},
  [18389] = {.lex_state = 0, .external_lex_state = 12},
  [18390] = {.lex_state = 0, .external_lex_state = 12},
  [18391] = {.lex_state = 0, .external_lex_state = 12},
  [18392] = {.lex_state = 363, .external_lex_state = 12},
  [18393] = {.lex_state = 0, .external_lex_state = 12},
  [18394] = {.lex_state = 0, .external_lex_state = 12},
  [18395] = {.lex_state = 363, .external_lex_state = 12},
  [18396] = {.lex_state = 363, .external_lex_state = 12},
  [18397] = {.lex_state = 0, .external_lex_state = 12},
  [18398] = {.lex_state = 0, .external_lex_state = 12},
  [18399] = {.lex_state = 0, .external_lex_state = 12},
  [18400] = {.lex_state = 363, .external_lex_state = 12},
  [18401] = {.lex_state = 0, .external_lex_state = 12},
  [18402] = {.lex_state = 363, .external_lex_state = 12},
  [18403] = {.lex_state = 363, .external_lex_state = 12},
  [18404] = {.lex_state = 0, .external_lex_state = 12},
  [18405] = {.lex_state = 0, .external_lex_state = 12},
  [18406] = {.lex_state = 0, .external_lex_state = 12},
  [18407] = {.lex_state = 0, .external_lex_state = 12},
  [18408] = {.lex_state = 0, .external_lex_state = 12},
  [18409] = {.lex_state = 363, .external_lex_state = 12},
  [18410] = {.lex_state = 0, .external_lex_state = 12},
  [18411] = {.lex_state = 343, .external_lex_state = 12},
  [18412] = {.lex_state = 0, .external_lex_state = 12},
  [18413] = {.lex_state = 0, .external_lex_state = 12},
  [18414] = {.lex_state = 0, .external_lex_state = 12},
  [18415] = {.lex_state = 409, .external_lex_state = 12},
  [18416] = {.lex_state = 0, .external_lex_state = 12},
  [18417] = {.lex_state = 363, .external_lex_state = 12},
  [18418] = {.lex_state = 363, .external_lex_state = 12},
  [18419] = {.lex_state = 0, .external_lex_state = 12},
  [18420] = {.lex_state = 0, .external_lex_state = 12},
  [18421] = {.lex_state = 343, .external_lex_state = 12},
  [18422] = {.lex_state = 0, .external_lex_state = 12},
  [18423] = {.lex_state = 363, .external_lex_state = 12},
  [18424] = {.lex_state = 0, .external_lex_state = 12},
  [18425] = {.lex_state = 0, .external_lex_state = 12},
  [18426] = {.lex_state = 0, .external_lex_state = 12},
  [18427] = {.lex_state = 0, .external_lex_state = 12},
  [18428] = {.lex_state = 0, .external_lex_state = 12},
  [18429] = {.lex_state = 0, .external_lex_state = 12},
  [18430] = {.lex_state = 0, .external_lex_state = 12},
  [18431] = {.lex_state = 363, .external_lex_state = 12},
  [18432] = {.lex_state = 0, .external_lex_state = 12},
  [18433] = {.lex_state = 0, .external_lex_state = 12},
  [18434] = {.lex_state = 0, .external_lex_state = 12},
  [18435] = {.lex_state = 0, .external_lex_state = 12},
  [18436] = {.lex_state = 363, .external_lex_state = 12},
  [18437] = {.lex_state = 0, .external_lex_state = 12},
  [18438] = {.lex_state = 0, .external_lex_state = 12},
  [18439] = {.lex_state = 363, .external_lex_state = 12},
  [18440] = {.lex_state = 363, .external_lex_state = 12},
  [18441] = {.lex_state = 0, .external_lex_state = 12},
  [18442] = {.lex_state = 0, .external_lex_state = 12},
  [18443] = {.lex_state = 0, .external_lex_state = 12},
  [18444] = {.lex_state = 0, .external_lex_state = 12},
  [18445] = {.lex_state = 363, .external_lex_state = 12},
  [18446] = {.lex_state = 0, .external_lex_state = 12},
  [18447] = {.lex_state = 0, .external_lex_state = 12},
  [18448] = {.lex_state = 409, .external_lex_state = 12},
  [18449] = {.lex_state = 0, .external_lex_state = 12},
  [18450] = {.lex_state = 363, .external_lex_state = 12},
  [18451] = {.lex_state = 0, .external_lex_state = 12},
  [18452] = {.lex_state = 0, .external_lex_state = 12},
  [18453] = {.lex_state = 363, .external_lex_state = 12},
  [18454] = {.lex_state = 363, .external_lex_state = 12},
  [18455] = {.lex_state = 0, .external_lex_state = 12},
  [18456] = {.lex_state = 0, .external_lex_state = 12},
  [18457] = {.lex_state = 0, .external_lex_state = 12},
  [18458] = {.lex_state = 0, .external_lex_state = 12},
  [18459] = {.lex_state = 0, .external_lex_state = 12},
  [18460] = {.lex_state = 0, .external_lex_state = 12},
  [18461] = {.lex_state = 0, .external_lex_state = 12},
  [18462] = {.lex_state = 0, .external_lex_state = 12},
  [18463] = {.lex_state = 363, .external_lex_state = 12},
  [18464] = {.lex_state = 0, .external_lex_state = 12},
  [18465] = {.lex_state = 363, .external_lex_state = 12},
  [18466] = {.lex_state = 409, .external_lex_state = 12},
  [18467] = {.lex_state = 0, .external_lex_state = 12},
  [18468] = {.lex_state = 343, .external_lex_state = 12},
  [18469] = {.lex_state = 0, .external_lex_state = 12},
  [18470] = {.lex_state = 0, .external_lex_state = 12},
  [18471] = {.lex_state = 0, .external_lex_state = 12},
  [18472] = {.lex_state = 363, .external_lex_state = 12},
  [18473] = {.lex_state = 409, .external_lex_state = 12},
  [18474] = {.lex_state = 0, .external_lex_state = 12},
  [18475] = {.lex_state = 363, .external_lex_state = 12},
  [18476] = {.lex_state = 0, .external_lex_state = 12},
  [18477] = {.lex_state = 0, .external_lex_state = 12},
  [18478] = {.lex_state = 0, .external_lex_state = 12},
  [18479] = {.lex_state = 363, .external_lex_state = 12},
  [18480] = {.lex_state = 363, .external_lex_state = 12},
  [18481] = {.lex_state = 0, .external_lex_state = 12},
  [18482] = {.lex_state = 0, .external_lex_state = 12},
  [18483] = {.lex_state = 0, .external_lex_state = 12},
  [18484] = {.lex_state = 363, .external_lex_state = 12},
  [18485] = {.lex_state = 363, .external_lex_state = 12},
  [18486] = {.lex_state = 0, .external_lex_state = 12},
  [18487] = {.lex_state = 0, .external_lex_state = 12},
  [18488] = {.lex_state = 343, .external_lex_state = 12},
  [18489] = {.lex_state = 0, .external_lex_state = 12},
  [18490] = {.lex_state = 0, .external_lex_state = 12},
  [18491] = {.lex_state = 0, .external_lex_state = 12},
  [18492] = {.lex_state = 363, .external_lex_state = 12},
  [18493] = {.lex_state = 363, .external_lex_state = 12},
  [18494] = {.lex_state = 0, .external_lex_state = 12},
  [18495] = {.lex_state = 0, .external_lex_state = 12},
  [18496] = {.lex_state = 0, .external_lex_state = 12},
  [18497] = {.lex_state = 0, .external_lex_state = 12},
  [18498] = {.lex_state = 0, .external_lex_state = 12},
  [18499] = {.lex_state = 0, .external_lex_state = 12},
  [18500] = {.lex_state = 363, .external_lex_state = 12},
  [18501] = {.lex_state = 363, .external_lex_state = 12},
  [18502] = {.lex_state = 363, .external_lex_state = 12},
  [18503] = {.lex_state = 0, .external_lex_state = 12},
  [18504] = {.lex_state = 363, .external_lex_state = 12},
  [18505] = {.lex_state = 0, .external_lex_state = 12},
  [18506] = {.lex_state = 0, .external_lex_state = 12},
  [18507] = {.lex_state = 0, .external_lex_state = 12},
  [18508] = {.lex_state = 0, .external_lex_state = 12},
  [18509] = {.lex_state = 0, .external_lex_state = 12},
  [18510] = {.lex_state = 0, .external_lex_state = 13},
  [18511] = {.lex_state = 343, .external_lex_state = 12},
  [18512] = {.lex_state = 363, .external_lex_state = 12},
  [18513] = {.lex_state = 0, .external_lex_state = 12},
  [18514] = {.lex_state = 363, .external_lex_state = 12},
  [18515] = {.lex_state = 343, .external_lex_state = 12},
  [18516] = {.lex_state = 363, .external_lex_state = 12},
  [18517] = {.lex_state = 0, .external_lex_state = 12},
  [18518] = {.lex_state = 0, .external_lex_state = 12},
  [18519] = {.lex_state = 363, .external_lex_state = 12},
  [18520] = {.lex_state = 363, .external_lex_state = 12},
  [18521] = {.lex_state = 0, .external_lex_state = 12},
  [18522] = {.lex_state = 0, .external_lex_state = 12},
  [18523] = {.lex_state = 0, .external_lex_state = 12},
  [18524] = {.lex_state = 343, .external_lex_state = 12},
  [18525] = {.lex_state = 0, .external_lex_state = 12},
  [18526] = {.lex_state = 363, .external_lex_state = 12},
  [18527] = {.lex_state = 0, .external_lex_state = 12},
  [18528] = {.lex_state = 0, .external_lex_state = 12},
  [18529] = {.lex_state = 0, .external_lex_state = 12},
  [18530] = {.lex_state = 0, .external_lex_state = 12},
  [18531] = {.lex_state = 363, .external_lex_state = 12},
  [18532] = {.lex_state = 0, .external_lex_state = 12},
  [18533] = {.lex_state = 343, .external_lex_state = 12},
  [18534] = {.lex_state = 0, .external_lex_state = 12},
  [18535] = {.lex_state = 0, .external_lex_state = 12},
  [18536] = {.lex_state = 0, .external_lex_state = 12},
  [18537] = {.lex_state = 363, .external_lex_state = 12},
  [18538] = {.lex_state = 363, .external_lex_state = 12},
  [18539] = {.lex_state = 0, .external_lex_state = 12},
  [18540] = {.lex_state = 0, .external_lex_state = 12},
  [18541] = {.lex_state = 0, .external_lex_state = 12},
  [18542] = {.lex_state = 363, .external_lex_state = 12},
  [18543] = {.lex_state = 0, .external_lex_state = 12},
  [18544] = {.lex_state = 409, .external_lex_state = 12},
  [18545] = {.lex_state = 0, .external_lex_state = 12},
  [18546] = {.lex_state = 0, .external_lex_state = 12},
  [18547] = {.lex_state = 0, .external_lex_state = 12},
  [18548] = {.lex_state = 363, .external_lex_state = 12},
  [18549] = {.lex_state = 0, .external_lex_state = 12},
  [18550] = {.lex_state = 363, .external_lex_state = 12},
  [18551] = {.lex_state = 363, .external_lex_state = 12},
  [18552] = {.lex_state = 363, .external_lex_state = 12},
  [18553] = {.lex_state = 0, .external_lex_state = 12},
  [18554] = {.lex_state = 0, .external_lex_state = 12},
  [18555] = {.lex_state = 363, .external_lex_state = 12},
  [18556] = {.lex_state = 0, .external_lex_state = 12},
  [18557] = {.lex_state = 0, .external_lex_state = 12},
  [18558] = {.lex_state = 0, .external_lex_state = 12},
  [18559] = {.lex_state = 0, .external_lex_state = 12},
  [18560] = {.lex_state = 363, .external_lex_state = 12},
  [18561] = {.lex_state = 0, .external_lex_state = 12},
  [18562] = {.lex_state = 343, .external_lex_state = 12},
  [18563] = {.lex_state = 0, .external_lex_state = 12},
  [18564] = {.lex_state = 0, .external_lex_state = 12},
  [18565] = {.lex_state = 409, .external_lex_state = 12},
  [18566] = {.lex_state = 0, .external_lex_state = 12},
  [18567] = {.lex_state = 363, .external_lex_state = 12},
  [18568] = {.lex_state = 363, .external_lex_state = 12},
  [18569] = {.lex_state = 0, .external_lex_state = 12},
  [18570] = {.lex_state = 363, .external_lex_state = 12},
  [18571] = {.lex_state = 0, .external_lex_state = 12},
  [18572] = {.lex_state = 363, .external_lex_state = 12},
  [18573] = {.lex_state = 0, .external_lex_state = 12},
  [18574] = {.lex_state = 363, .external_lex_state = 12},
  [18575] = {.lex_state = 0, .external_lex_state = 12},
  [18576] = {.lex_state = 0, .external_lex_state = 12},
  [18577] = {.lex_state = 0, .external_lex_state = 12},
  [18578] = {.lex_state = 363, .external_lex_state = 12},
  [18579] = {.lex_state = 363, .external_lex_state = 12},
  [18580] = {.lex_state = 363, .external_lex_state = 12},
  [18581] = {.lex_state = 0, .external_lex_state = 12},
  [18582] = {.lex_state = 0, .external_lex_state = 12},
  [18583] = {.lex_state = 0, .external_lex_state = 12},
  [18584] = {.lex_state = 0, .external_lex_state = 12},
  [18585] = {.lex_state = 363, .external_lex_state = 12},
  [18586] = {.lex_state = 363, .external_lex_state = 12},
  [18587] = {.lex_state = 0, .external_lex_state = 12},
  [18588] = {.lex_state = 0, .external_lex_state = 12},
  [18589] = {.lex_state = 363, .external_lex_state = 12},
  [18590] = {.lex_state = 0, .external_lex_state = 12},
  [18591] = {.lex_state = 363, .external_lex_state = 12},
  [18592] = {.lex_state = 363, .external_lex_state = 12},
  [18593] = {.lex_state = 0, .external_lex_state = 12},
  [18594] = {.lex_state = 0, .external_lex_state = 12},
  [18595] = {.lex_state = 363, .external_lex_state = 12},
  [18596] = {.lex_state = 343, .external_lex_state = 12},
  [18597] = {.lex_state = 0, .external_lex_state = 12},
  [18598] = {.lex_state = 363, .external_lex_state = 12},
  [18599] = {.lex_state = 0, .external_lex_state = 12},
  [18600] = {.lex_state = 0, .external_lex_state = 12},
  [18601] = {.lex_state = 0, .external_lex_state = 12},
  [18602] = {.lex_state = 0, .external_lex_state = 12},
  [18603] = {.lex_state = 0, .external_lex_state = 12},
  [18604] = {.lex_state = 363, .external_lex_state = 12},
  [18605] = {.lex_state = 363, .external_lex_state = 12},
  [18606] = {.lex_state = 0, .external_lex_state = 12},
  [18607] = {.lex_state = 363, .external_lex_state = 12},
  [18608] = {.lex_state = 363, .external_lex_state = 12},
  [18609] = {.lex_state = 363, .external_lex_state = 12},
  [18610] = {.lex_state = 0, .external_lex_state = 12},
  [18611] = {.lex_state = 0, .external_lex_state = 12},
  [18612] = {.lex_state = 0, .external_lex_state = 12},
  [18613] = {.lex_state = 0, .external_lex_state = 12},
  [18614] = {.lex_state = 0, .external_lex_state = 12},
  [18615] = {.lex_state = 363, .external_lex_state = 12},
  [18616] = {.lex_state = 363, .external_lex_state = 12},
  [18617] = {.lex_state = 0, .external_lex_state = 12},
  [18618] = {.lex_state = 0, .external_lex_state = 12},
  [18619] = {.lex_state = 0, .external_lex_state = 12},
  [18620] = {.lex_state = 363, .external_lex_state = 12},
  [18621] = {.lex_state = 363, .external_lex_state = 12},
  [18622] = {.lex_state = 409, .external_lex_state = 12},
  [18623] = {.lex_state = 363, .external_lex_state = 12},
  [18624] = {.lex_state = 363, .external_lex_state = 12},
  [18625] = {.lex_state = 363, .external_lex_state = 12},
  [18626] = {.lex_state = 0, .external_lex_state = 12},
  [18627] = {.lex_state = 0, .external_lex_state = 12},
  [18628] = {.lex_state = 0, .external_lex_state = 12},
  [18629] = {.lex_state = 0, .external_lex_state = 12},
  [18630] = {.lex_state = 0, .external_lex_state = 13},
  [18631] = {.lex_state = 343, .external_lex_state = 12},
  [18632] = {.lex_state = 363, .external_lex_state = 12},
  [18633] = {.lex_state = 0, .external_lex_state = 12},
  [18634] = {.lex_state = 363, .external_lex_state = 12},
  [18635] = {.lex_state = 0, .external_lex_state = 12},
  [18636] = {.lex_state = 363, .external_lex_state = 12},
  [18637] = {.lex_state = 363, .external_lex_state = 12},
  [18638] = {.lex_state = 363, .external_lex_state = 12},
  [18639] = {.lex_state = 0, .external_lex_state = 12},
  [18640] = {.lex_state = 0, .external_lex_state = 12},
  [18641] = {.lex_state = 343, .external_lex_state = 12},
  [18642] = {.lex_state = 0, .external_lex_state = 12},
  [18643] = {.lex_state = 363, .external_lex_state = 12},
  [18644] = {.lex_state = 363, .external_lex_state = 12},
  [18645] = {.lex_state = 363, .external_lex_state = 12},
  [18646] = {.lex_state = 0, .external_lex_state = 12},
  [18647] = {.lex_state = 363, .external_lex_state = 12},
  [18648] = {.lex_state = 363, .external_lex_state = 12},
  [18649] = {.lex_state = 363, .external_lex_state = 12},
  [18650] = {.lex_state = 363, .external_lex_state = 12},
  [18651] = {.lex_state = 363, .external_lex_state = 12},
  [18652] = {.lex_state = 363, .external_lex_state = 12},
  [18653] = {.lex_state = 0, .external_lex_state = 12},
  [18654] = {.lex_state = 363, .external_lex_state = 12},
  [18655] = {.lex_state = 363, .external_lex_state = 12},
  [18656] = {.lex_state = 0, .external_lex_state = 12},
  [18657] = {.lex_state = 0, .external_lex_state = 12},
  [18658] = {.lex_state = 0, .external_lex_state = 12},
  [18659] = {.lex_state = 0, .external_lex_state = 12},
  [18660] = {.lex_state = 363, .external_lex_state = 12},
  [18661] = {.lex_state = 363, .external_lex_state = 12},
  [18662] = {.lex_state = 0, .external_lex_state = 12},
  [18663] = {.lex_state = 363, .external_lex_state = 12},
  [18664] = {.lex_state = 363, .external_lex_state = 12},
  [18665] = {.lex_state = 363, .external_lex_state = 12},
  [18666] = {.lex_state = 0, .external_lex_state = 12},
  [18667] = {.lex_state = 363, .external_lex_state = 12},
  [18668] = {.lex_state = 363, .external_lex_state = 12},
  [18669] = {.lex_state = 0, .external_lex_state = 12},
  [18670] = {.lex_state = 0, .external_lex_state = 12},
  [18671] = {.lex_state = 0, .external_lex_state = 12},
  [18672] = {.lex_state = 0, .external_lex_state = 12},
  [18673] = {.lex_state = 409, .external_lex_state = 12},
  [18674] = {.lex_state = 0, .external_lex_state = 12},
  [18675] = {.lex_state = 0, .external_lex_state = 12},
  [18676] = {.lex_state = 0, .external_lex_state = 12},
  [18677] = {.lex_state = 363, .external_lex_state = 12},
  [18678] = {.lex_state = 363, .external_lex_state = 12},
  [18679] = {.lex_state = 0, .external_lex_state = 12},
  [18680] = {.lex_state = 0, .external_lex_state = 12},
  [18681] = {.lex_state = 0, .external_lex_state = 12},
  [18682] = {.lex_state = 343, .external_lex_state = 12},
  [18683] = {.lex_state = 363, .external_lex_state = 12},
  [18684] = {.lex_state = 0, .external_lex_state = 12},
  [18685] = {.lex_state = 0, .external_lex_state = 12},
  [18686] = {.lex_state = 0, .external_lex_state = 12},
  [18687] = {.lex_state = 363, .external_lex_state = 12},
  [18688] = {.lex_state = 0, .external_lex_state = 12},
  [18689] = {.lex_state = 363, .external_lex_state = 12},
  [18690] = {.lex_state = 0, .external_lex_state = 12},
  [18691] = {.lex_state = 363, .external_lex_state = 12},
  [18692] = {.lex_state = 363, .external_lex_state = 12},
  [18693] = {.lex_state = 363, .external_lex_state = 12},
  [18694] = {.lex_state = 0, .external_lex_state = 12},
  [18695] = {.lex_state = 0, .external_lex_state = 12},
  [18696] = {.lex_state = 363, .external_lex_state = 12},
  [18697] = {.lex_state = 0, .external_lex_state = 12},
  [18698] = {.lex_state = 363, .external_lex_state = 12},
  [18699] = {.lex_state = 0, .external_lex_state = 12},
  [18700] = {.lex_state = 0, .external_lex_state = 12},
  [18701] = {.lex_state = 0, .external_lex_state = 12},
  [18702] = {.lex_state = 0, .external_lex_state = 12},
  [18703] = {.lex_state = 0, .external_lex_state = 12},
  [18704] = {.lex_state = 363, .external_lex_state = 12},
  [18705] = {.lex_state = 363, .external_lex_state = 12},
  [18706] = {.lex_state = 0, .external_lex_state = 12},
  [18707] = {.lex_state = 363, .external_lex_state = 12},
  [18708] = {.lex_state = 0, .external_lex_state = 12},
  [18709] = {.lex_state = 363, .external_lex_state = 12},
  [18710] = {.lex_state = 363, .external_lex_state = 12},
  [18711] = {.lex_state = 0, .external_lex_state = 12},
  [18712] = {.lex_state = 363, .external_lex_state = 12},
  [18713] = {.lex_state = 363, .external_lex_state = 12},
  [18714] = {.lex_state = 363, .external_lex_state = 12},
  [18715] = {.lex_state = 0, .external_lex_state = 12},
  [18716] = {.lex_state = 0, .external_lex_state = 12},
  [18717] = {.lex_state = 363, .external_lex_state = 12},
  [18718] = {.lex_state = 0, .external_lex_state = 12},
  [18719] = {.lex_state = 363, .external_lex_state = 12},
  [18720] = {.lex_state = 409, .external_lex_state = 12},
  [18721] = {.lex_state = 0, .external_lex_state = 12},
  [18722] = {.lex_state = 363, .external_lex_state = 12},
  [18723] = {.lex_state = 363, .external_lex_state = 12},
  [18724] = {.lex_state = 0, .external_lex_state = 12},
  [18725] = {.lex_state = 363, .external_lex_state = 12},
  [18726] = {.lex_state = 409, .external_lex_state = 12},
  [18727] = {.lex_state = 0, .external_lex_state = 12},
  [18728] = {.lex_state = 409, .external_lex_state = 12},
  [18729] = {.lex_state = 363, .external_lex_state = 12},
  [18730] = {.lex_state = 0, .external_lex_state = 12},
  [18731] = {.lex_state = 0, .external_lex_state = 12},
  [18732] = {.lex_state = 363, .external_lex_state = 12},
  [18733] = {.lex_state = 0, .external_lex_state = 12},
  [18734] = {.lex_state = 0, .external_lex_state = 12},
  [18735] = {.lex_state = 0, .external_lex_state = 12},
  [18736] = {.lex_state = 0, .external_lex_state = 12},
  [18737] = {.lex_state = 0, .external_lex_state = 12},
  [18738] = {.lex_state = 363, .external_lex_state = 12},
  [18739] = {.lex_state = 363, .external_lex_state = 12},
  [18740] = {.lex_state = 0, .external_lex_state = 13},
  [18741] = {.lex_state = 343, .external_lex_state = 12},
  [18742] = {.lex_state = 0, .external_lex_state = 12},
  [18743] = {.lex_state = 0, .external_lex_state = 12},
  [18744] = {.lex_state = 0, .external_lex_state = 12},
  [18745] = {.lex_state = 363, .external_lex_state = 12},
  [18746] = {.lex_state = 0, .external_lex_state = 12},
  [18747] = {.lex_state = 0, .external_lex_state = 12},
  [18748] = {.lex_state = 0, .external_lex_state = 12},
  [18749] = {.lex_state = 0, .external_lex_state = 12},
  [18750] = {.lex_state = 409, .external_lex_state = 12},
  [18751] = {.lex_state = 0, .external_lex_state = 12},
  [18752] = {.lex_state = 343, .external_lex_state = 12},
  [18753] = {.lex_state = 0, .external_lex_state = 12},
  [18754] = {.lex_state = 363, .external_lex_state = 12},
  [18755] = {.lex_state = 363, .external_lex_state = 12},
  [18756] = {.lex_state = 343, .external_lex_state = 12},
  [18757] = {.lex_state = 363, .external_lex_state = 12},
  [18758] = {.lex_state = 0, .external_lex_state = 12},
  [18759] = {.lex_state = 343, .external_lex_state = 12},
  [18760] = {.lex_state = 363, .external_lex_state = 12},
  [18761] = {.lex_state = 343, .external_lex_state = 12},
  [18762] = {.lex_state = 0, .external_lex_state = 12},
  [18763] = {.lex_state = 363, .external_lex_state = 12},
  [18764] = {.lex_state = 0, .external_lex_state = 12},
  [18765] = {.lex_state = 0, .external_lex_state = 12},
  [18766] = {.lex_state = 0, .external_lex_state = 12},
  [18767] = {.lex_state = 363, .external_lex_state = 12},
  [18768] = {.lex_state = 0, .external_lex_state = 12},
  [18769] = {.lex_state = 0, .external_lex_state = 12},
  [18770] = {.lex_state = 0, .external_lex_state = 12},
  [18771] = {.lex_state = 0, .external_lex_state = 12},
  [18772] = {.lex_state = 363, .external_lex_state = 12},
  [18773] = {.lex_state = 363, .external_lex_state = 12},
  [18774] = {.lex_state = 363, .external_lex_state = 12},
  [18775] = {.lex_state = 363, .external_lex_state = 12},
  [18776] = {.lex_state = 363, .external_lex_state = 12},
  [18777] = {.lex_state = 0, .external_lex_state = 12},
  [18778] = {.lex_state = 363, .external_lex_state = 12},
  [18779] = {.lex_state = 0, .external_lex_state = 12},
  [18780] = {.lex_state = 363, .external_lex_state = 12},
  [18781] = {.lex_state = 363, .external_lex_state = 12},
  [18782] = {.lex_state = 363, .external_lex_state = 12},
  [18783] = {.lex_state = 0, .external_lex_state = 12},
  [18784] = {.lex_state = 363, .external_lex_state = 12},
  [18785] = {.lex_state = 0, .external_lex_state = 12},
  [18786] = {.lex_state = 0, .external_lex_state = 12},
  [18787] = {.lex_state = 0, .external_lex_state = 12},
  [18788] = {.lex_state = 0, .external_lex_state = 12},
  [18789] = {.lex_state = 363, .external_lex_state = 12},
  [18790] = {.lex_state = 0, .external_lex_state = 12},
  [18791] = {.lex_state = 363, .external_lex_state = 12},
  [18792] = {.lex_state = 0, .external_lex_state = 12},
  [18793] = {.lex_state = 363, .external_lex_state = 12},
  [18794] = {.lex_state = 0, .external_lex_state = 12},
  [18795] = {.lex_state = 0, .external_lex_state = 12},
  [18796] = {.lex_state = 0, .external_lex_state = 12},
  [18797] = {.lex_state = 363, .external_lex_state = 12},
  [18798] = {.lex_state = 0, .external_lex_state = 12},
  [18799] = {.lex_state = 363, .external_lex_state = 12},
  [18800] = {.lex_state = 0, .external_lex_state = 12},
  [18801] = {.lex_state = 363, .external_lex_state = 12},
  [18802] = {.lex_state = 0, .external_lex_state = 12},
  [18803] = {.lex_state = 363, .external_lex_state = 12},
  [18804] = {.lex_state = 0, .external_lex_state = 13},
  [18805] = {.lex_state = 363, .external_lex_state = 12},
  [18806] = {.lex_state = 0, .external_lex_state = 12},
  [18807] = {.lex_state = 363, .external_lex_state = 12},
  [18808] = {.lex_state = 409, .external_lex_state = 12},
  [18809] = {.lex_state = 0, .external_lex_state = 12},
  [18810] = {.lex_state = 0, .external_lex_state = 12},
  [18811] = {.lex_state = 0, .external_lex_state = 12},
  [18812] = {.lex_state = 363, .external_lex_state = 12},
  [18813] = {.lex_state = 0, .external_lex_state = 12},
  [18814] = {.lex_state = 0, .external_lex_state = 12},
  [18815] = {.lex_state = 0, .external_lex_state = 12},
  [18816] = {.lex_state = 0, .external_lex_state = 12},
  [18817] = {.lex_state = 0, .external_lex_state = 12},
  [18818] = {.lex_state = 363, .external_lex_state = 12},
  [18819] = {.lex_state = 363, .external_lex_state = 12},
  [18820] = {.lex_state = 343, .external_lex_state = 12},
  [18821] = {.lex_state = 363, .external_lex_state = 12},
  [18822] = {.lex_state = 0, .external_lex_state = 12},
  [18823] = {.lex_state = 363, .external_lex_state = 12},
  [18824] = {.lex_state = 0, .external_lex_state = 12},
  [18825] = {.lex_state = 0, .external_lex_state = 12},
  [18826] = {.lex_state = 363, .external_lex_state = 12},
  [18827] = {.lex_state = 0, .external_lex_state = 12},
  [18828] = {.lex_state = 0, .external_lex_state = 12},
  [18829] = {.lex_state = 0, .external_lex_state = 12},
  [18830] = {.lex_state = 363, .external_lex_state = 12},
  [18831] = {.lex_state = 0, .external_lex_state = 12},
  [18832] = {.lex_state = 363, .external_lex_state = 12},
  [18833] = {.lex_state = 363, .external_lex_state = 12},
  [18834] = {.lex_state = 343, .external_lex_state = 12},
  [18835] = {.lex_state = 363, .external_lex_state = 12},
  [18836] = {.lex_state = 0, .external_lex_state = 12},
  [18837] = {.lex_state = 363, .external_lex_state = 12},
  [18838] = {.lex_state = 363, .external_lex_state = 12},
  [18839] = {.lex_state = 0, .external_lex_state = 12},
  [18840] = {.lex_state = 363, .external_lex_state = 12},
  [18841] = {.lex_state = 0, .external_lex_state = 12},
  [18842] = {.lex_state = 0, .external_lex_state = 12},
  [18843] = {.lex_state = 0, .external_lex_state = 12},
  [18844] = {.lex_state = 0, .external_lex_state = 12},
  [18845] = {.lex_state = 363, .external_lex_state = 12},
  [18846] = {.lex_state = 0, .external_lex_state = 12},
  [18847] = {.lex_state = 363, .external_lex_state = 12},
  [18848] = {.lex_state = 0, .external_lex_state = 12},
  [18849] = {.lex_state = 363, .external_lex_state = 12},
  [18850] = {.lex_state = 0, .external_lex_state = 12},
  [18851] = {.lex_state = 0, .external_lex_state = 12},
  [18852] = {.lex_state = 363, .external_lex_state = 12},
  [18853] = {.lex_state = 363, .external_lex_state = 12},
  [18854] = {.lex_state = 363, .external_lex_state = 12},
  [18855] = {.lex_state = 0, .external_lex_state = 12},
  [18856] = {.lex_state = 0, .external_lex_state = 12},
  [18857] = {.lex_state = 363, .external_lex_state = 12},
  [18858] = {.lex_state = 343, .external_lex_state = 12},
  [18859] = {.lex_state = 0, .external_lex_state = 12},
  [18860] = {.lex_state = 0, .external_lex_state = 13},
  [18861] = {.lex_state = 0, .external_lex_state = 12},
  [18862] = {.lex_state = 0, .external_lex_state = 12},
  [18863] = {.lex_state = 0, .external_lex_state = 12},
  [18864] = {.lex_state = 0, .external_lex_state = 12},
  [18865] = {.lex_state = 0, .external_lex_state = 12},
  [18866] = {.lex_state = 363, .external_lex_state = 12},
  [18867] = {.lex_state = 363, .external_lex_state = 12},
  [18868] = {.lex_state = 0, .external_lex_state = 12},
  [18869] = {.lex_state = 363, .external_lex_state = 12},
  [18870] = {.lex_state = 363, .external_lex_state = 12},
  [18871] = {.lex_state = 0, .external_lex_state = 12},
  [18872] = {.lex_state = 0, .external_lex_state = 12},
  [18873] = {.lex_state = 363, .external_lex_state = 12},
  [18874] = {.lex_state = 0, .external_lex_state = 12},
  [18875] = {.lex_state = 363, .external_lex_state = 12},
  [18876] = {.lex_state = 363, .external_lex_state = 12},
  [18877] = {.lex_state = 363, .external_lex_state = 12},
  [18878] = {.lex_state = 363, .external_lex_state = 12},
  [18879] = {.lex_state = 0, .external_lex_state = 12},
  [18880] = {.lex_state = 343, .external_lex_state = 12},
  [18881] = {.lex_state = 0, .external_lex_state = 12},
  [18882] = {.lex_state = 363, .external_lex_state = 12},
  [18883] = {.lex_state = 363, .external_lex_state = 12},
  [18884] = {.lex_state = 363, .external_lex_state = 12},
  [18885] = {.lex_state = 0, .external_lex_state = 12},
  [18886] = {.lex_state = 0, .external_lex_state = 12},
  [18887] = {.lex_state = 363, .external_lex_state = 12},
  [18888] = {.lex_state = 0, .external_lex_state = 12},
  [18889] = {.lex_state = 409, .external_lex_state = 12},
  [18890] = {.lex_state = 363, .external_lex_state = 12},
  [18891] = {.lex_state = 363, .external_lex_state = 12},
  [18892] = {.lex_state = 0, .external_lex_state = 12},
  [18893] = {.lex_state = 363, .external_lex_state = 12},
  [18894] = {.lex_state = 0, .external_lex_state = 12},
  [18895] = {.lex_state = 0, .external_lex_state = 12},
  [18896] = {.lex_state = 0, .external_lex_state = 12},
  [18897] = {.lex_state = 0, .external_lex_state = 12},
  [18898] = {.lex_state = 0, .external_lex_state = 12},
  [18899] = {.lex_state = 0, .external_lex_state = 12},
  [18900] = {.lex_state = 0, .external_lex_state = 12},
  [18901] = {.lex_state = 0, .external_lex_state = 12},
  [18902] = {.lex_state = 0, .external_lex_state = 12},
  [18903] = {.lex_state = 363, .external_lex_state = 12},
  [18904] = {.lex_state = 0, .external_lex_state = 12},
  [18905] = {.lex_state = 363, .external_lex_state = 12},
  [18906] = {.lex_state = 0, .external_lex_state = 12},
  [18907] = {.lex_state = 363, .external_lex_state = 12},
  [18908] = {.lex_state = 0, .external_lex_state = 12},
  [18909] = {.lex_state = 0, .external_lex_state = 12},
  [18910] = {.lex_state = 0, .external_lex_state = 12},
  [18911] = {.lex_state = 363, .external_lex_state = 12},
  [18912] = {.lex_state = 0, .external_lex_state = 12},
  [18913] = {.lex_state = 0, .external_lex_state = 13},
  [18914] = {.lex_state = 0, .external_lex_state = 12},
  [18915] = {.lex_state = 0, .external_lex_state = 12},
  [18916] = {.lex_state = 363, .external_lex_state = 12},
  [18917] = {.lex_state = 363, .external_lex_state = 12},
  [18918] = {.lex_state = 363, .external_lex_state = 12},
  [18919] = {.lex_state = 0, .external_lex_state = 12},
  [18920] = {.lex_state = 363, .external_lex_state = 12},
  [18921] = {.lex_state = 363, .external_lex_state = 12},
  [18922] = {.lex_state = 363, .external_lex_state = 12},
  [18923] = {.lex_state = 0, .external_lex_state = 12},
  [18924] = {.lex_state = 363, .external_lex_state = 12},
  [18925] = {.lex_state = 0, .external_lex_state = 12},
  [18926] = {.lex_state = 363, .external_lex_state = 12},
  [18927] = {.lex_state = 0, .external_lex_state = 12},
  [18928] = {.lex_state = 363, .external_lex_state = 12},
  [18929] = {.lex_state = 0, .external_lex_state = 12},
  [18930] = {.lex_state = 363, .external_lex_state = 12},
  [18931] = {.lex_state = 0, .external_lex_state = 12},
  [18932] = {.lex_state = 0, .external_lex_state = 12},
  [18933] = {.lex_state = 0, .external_lex_state = 12},
  [18934] = {.lex_state = 0, .external_lex_state = 12},
  [18935] = {.lex_state = 409, .external_lex_state = 12},
  [18936] = {.lex_state = 363, .external_lex_state = 12},
  [18937] = {.lex_state = 0, .external_lex_state = 12},
  [18938] = {.lex_state = 0, .external_lex_state = 12},
  [18939] = {.lex_state = 0, .external_lex_state = 12},
  [18940] = {.lex_state = 363, .external_lex_state = 12},
  [18941] = {.lex_state = 363, .external_lex_state = 12},
  [18942] = {.lex_state = 363, .external_lex_state = 12},
  [18943] = {.lex_state = 363, .external_lex_state = 12},
  [18944] = {.lex_state = 363, .external_lex_state = 12},
  [18945] = {.lex_state = 0, .external_lex_state = 12},
  [18946] = {.lex_state = 363, .external_lex_state = 12},
  [18947] = {.lex_state = 0, .external_lex_state = 12},
  [18948] = {.lex_state = 409, .external_lex_state = 12},
  [18949] = {.lex_state = 0, .external_lex_state = 12},
  [18950] = {.lex_state = 0, .external_lex_state = 13},
  [18951] = {.lex_state = 363, .external_lex_state = 12},
  [18952] = {.lex_state = 363, .external_lex_state = 12},
  [18953] = {.lex_state = 0, .external_lex_state = 12},
  [18954] = {.lex_state = 363, .external_lex_state = 12},
  [18955] = {.lex_state = 0, .external_lex_state = 12},
  [18956] = {.lex_state = 363, .external_lex_state = 12},
  [18957] = {.lex_state = 363, .external_lex_state = 12},
  [18958] = {.lex_state = 409, .external_lex_state = 12},
  [18959] = {.lex_state = 0, .external_lex_state = 12},
  [18960] = {.lex_state = 0, .external_lex_state = 12},
  [18961] = {.lex_state = 0, .external_lex_state = 12},
  [18962] = {.lex_state = 409, .external_lex_state = 12},
  [18963] = {.lex_state = 0, .external_lex_state = 12},
  [18964] = {.lex_state = 0, .external_lex_state = 12},
  [18965] = {.lex_state = 0, .external_lex_state = 12},
  [18966] = {.lex_state = 0, .external_lex_state = 12},
  [18967] = {.lex_state = 343, .external_lex_state = 12},
  [18968] = {.lex_state = 0, .external_lex_state = 12},
  [18969] = {.lex_state = 0, .external_lex_state = 12},
  [18970] = {.lex_state = 0, .external_lex_state = 12},
  [18971] = {.lex_state = 0, .external_lex_state = 12},
  [18972] = {.lex_state = 363, .external_lex_state = 12},
  [18973] = {.lex_state = 0, .external_lex_state = 12},
  [18974] = {.lex_state = 363, .external_lex_state = 12},
  [18975] = {.lex_state = 0, .external_lex_state = 12},
  [18976] = {.lex_state = 363, .external_lex_state = 12},
  [18977] = {.lex_state = 409, .external_lex_state = 12},
  [18978] = {.lex_state = 0, .external_lex_state = 12},
  [18979] = {.lex_state = 363, .external_lex_state = 12},
  [18980] = {.lex_state = 363, .external_lex_state = 12},
  [18981] = {.lex_state = 0, .external_lex_state = 12},
  [18982] = {.lex_state = 363, .external_lex_state = 12},
  [18983] = {.lex_state = 363, .external_lex_state = 12},
  [18984] = {.lex_state = 363, .external_lex_state = 12},
  [18985] = {.lex_state = 363, .external_lex_state = 12},
  [18986] = {.lex_state = 0, .external_lex_state = 12},
  [18987] = {.lex_state = 0, .external_lex_state = 13},
  [18988] = {.lex_state = 0, .external_lex_state = 12},
  [18989] = {.lex_state = 363, .external_lex_state = 12},
  [18990] = {.lex_state = 0, .external_lex_state = 12},
  [18991] = {.lex_state = 363, .external_lex_state = 12},
  [18992] = {.lex_state = 0, .external_lex_state = 12},
  [18993] = {.lex_state = 0, .external_lex_state = 12},
  [18994] = {.lex_state = 363, .external_lex_state = 12},
  [18995] = {.lex_state = 363, .external_lex_state = 12},
  [18996] = {.lex_state = 0, .external_lex_state = 12},
  [18997] = {.lex_state = 0, .external_lex_state = 12},
  [18998] = {.lex_state = 409, .external_lex_state = 12},
  [18999] = {.lex_state = 363, .external_lex_state = 12},
  [19000] = {.lex_state = 0, .external_lex_state = 12},
  [19001] = {.lex_state = 0, .external_lex_state = 12},
  [19002] = {.lex_state = 0, .external_lex_state = 12},
  [19003] = {.lex_state = 363, .external_lex_state = 12},
  [19004] = {.lex_state = 0, .external_lex_state = 12},
  [19005] = {.lex_state = 0, .external_lex_state = 12},
  [19006] = {.lex_state = 363, .external_lex_state = 12},
  [19007] = {.lex_state = 0, .external_lex_state = 12},
  [19008] = {.lex_state = 0, .external_lex_state = 12},
  [19009] = {.lex_state = 363, .external_lex_state = 12},
  [19010] = {.lex_state = 363, .external_lex_state = 12},
  [19011] = {.lex_state = 363, .external_lex_state = 12},
  [19012] = {.lex_state = 0, .external_lex_state = 12},
  [19013] = {.lex_state = 0, .external_lex_state = 12},
  [19014] = {.lex_state = 363, .external_lex_state = 12},
  [19015] = {.lex_state = 363, .external_lex_state = 12},
  [19016] = {.lex_state = 0, .external_lex_state = 12},
  [19017] = {.lex_state = 363, .external_lex_state = 12},
  [19018] = {.lex_state = 363, .external_lex_state = 12},
  [19019] = {.lex_state = 363, .external_lex_state = 12},
  [19020] = {.lex_state = 363, .external_lex_state = 12},
  [19021] = {.lex_state = 0, .external_lex_state = 12},
  [19022] = {.lex_state = 0, .external_lex_state = 12},
  [19023] = {.lex_state = 0, .external_lex_state = 12},
  [19024] = {.lex_state = 0, .external_lex_state = 13},
  [19025] = {.lex_state = 0, .external_lex_state = 12},
  [19026] = {.lex_state = 343, .external_lex_state = 12},
  [19027] = {.lex_state = 363, .external_lex_state = 12},
  [19028] = {.lex_state = 0, .external_lex_state = 12},
  [19029] = {.lex_state = 0, .external_lex_state = 13},
  [19030] = {.lex_state = 363, .external_lex_state = 12},
  [19031] = {.lex_state = 0, .external_lex_state = 12},
  [19032] = {.lex_state = 0, .external_lex_state = 12},
  [19033] = {.lex_state = 0, .external_lex_state = 12},
  [19034] = {.lex_state = 343, .external_lex_state = 12},
  [19035] = {.lex_state = 0, .external_lex_state = 12},
  [19036] = {.lex_state = 343, .external_lex_state = 12},
  [19037] = {.lex_state = 0, .external_lex_state = 12},
  [19038] = {.lex_state = 363, .external_lex_state = 12},
  [19039] = {.lex_state = 0, .external_lex_state = 12},
  [19040] = {.lex_state = 0, .external_lex_state = 12},
  [19041] = {.lex_state = 343, .external_lex_state = 12},
  [19042] = {.lex_state = 0, .external_lex_state = 12},
  [19043] = {.lex_state = 0, .external_lex_state = 12},
  [19044] = {.lex_state = 409, .external_lex_state = 12},
  [19045] = {.lex_state = 0, .external_lex_state = 12},
  [19046] = {.lex_state = 363, .external_lex_state = 12},
  [19047] = {.lex_state = 0, .external_lex_state = 12},
  [19048] = {.lex_state = 363, .external_lex_state = 12},
  [19049] = {.lex_state = 409, .external_lex_state = 12},
  [19050] = {.lex_state = 0, .external_lex_state = 12},
  [19051] = {.lex_state = 363, .external_lex_state = 12},
  [19052] = {.lex_state = 363, .external_lex_state = 12},
  [19053] = {.lex_state = 0, .external_lex_state = 12},
  [19054] = {.lex_state = 0, .external_lex_state = 12},
  [19055] = {.lex_state = 0, .external_lex_state = 12},
  [19056] = {.lex_state = 0, .external_lex_state = 12},
  [19057] = {.lex_state = 0, .external_lex_state = 12},
  [19058] = {.lex_state = 343, .external_lex_state = 12},
  [19059] = {.lex_state = 343, .external_lex_state = 12},
  [19060] = {.lex_state = 0, .external_lex_state = 12},
  [19061] = {.lex_state = 0, .external_lex_state = 13},
  [19062] = {.lex_state = 0, .external_lex_state = 12},
  [19063] = {.lex_state = 0, .external_lex_state = 12},
  [19064] = {.lex_state = 0, .external_lex_state = 12},
  [19065] = {.lex_state = 363, .external_lex_state = 12},
  [19066] = {.lex_state = 0, .external_lex_state = 12},
  [19067] = {.lex_state = 0, .external_lex_state = 12},
  [19068] = {.lex_state = 0, .external_lex_state = 12},
  [19069] = {.lex_state = 363, .external_lex_state = 12},
  [19070] = {.lex_state = 0, .external_lex_state = 12},
  [19071] = {.lex_state = 0, .external_lex_state = 12},
  [19072] = {.lex_state = 363, .external_lex_state = 12},
  [19073] = {.lex_state = 0, .external_lex_state = 12},
  [19074] = {.lex_state = 0, .external_lex_state = 12},
  [19075] = {.lex_state = 0, .external_lex_state = 12},
  [19076] = {.lex_state = 0, .external_lex_state = 12},
  [19077] = {.lex_state = 363, .external_lex_state = 12},
  [19078] = {.lex_state = 0, .external_lex_state = 12},
  [19079] = {.lex_state = 0, .external_lex_state = 12},
  [19080] = {.lex_state = 0, .external_lex_state = 12},
  [19081] = {.lex_state = 0, .external_lex_state = 12},
  [19082] = {.lex_state = 363, .external_lex_state = 12},
  [19083] = {.lex_state = 0, .external_lex_state = 12},
  [19084] = {.lex_state = 363, .external_lex_state = 12},
  [19085] = {.lex_state = 0, .external_lex_state = 12},
  [19086] = {.lex_state = 363, .external_lex_state = 12},
  [19087] = {.lex_state = 0, .external_lex_state = 12},
  [19088] = {.lex_state = 0, .external_lex_state = 12},
  [19089] = {.lex_state = 0, .external_lex_state = 12},
  [19090] = {.lex_state = 0, .external_lex_state = 12},
  [19091] = {.lex_state = 0, .external_lex_state = 12},
  [19092] = {.lex_state = 0, .external_lex_state = 12},
  [19093] = {.lex_state = 0, .external_lex_state = 12},
  [19094] = {.lex_state = 363, .external_lex_state = 12},
  [19095] = {.lex_state = 0, .external_lex_state = 12},
  [19096] = {.lex_state = 409, .external_lex_state = 12},
  [19097] = {.lex_state = 0, .external_lex_state = 12},
  [19098] = {.lex_state = 0, .external_lex_state = 13},
  [19099] = {.lex_state = 363, .external_lex_state = 12},
  [19100] = {.lex_state = 0, .external_lex_state = 12},
  [19101] = {.lex_state = 0, .external_lex_state = 12},
  [19102] = {.lex_state = 363, .external_lex_state = 12},
  [19103] = {.lex_state = 0, .external_lex_state = 12},
  [19104] = {.lex_state = 363, .external_lex_state = 12},
  [19105] = {.lex_state = 0, .external_lex_state = 12},
  [19106] = {.lex_state = 0, .external_lex_state = 12},
  [19107] = {.lex_state = 0, .external_lex_state = 12},
  [19108] = {.lex_state = 343, .external_lex_state = 12},
  [19109] = {.lex_state = 0, .external_lex_state = 12},
  [19110] = {.lex_state = 0, .external_lex_state = 12},
  [19111] = {.lex_state = 363, .external_lex_state = 12},
  [19112] = {.lex_state = 0, .external_lex_state = 12},
  [19113] = {.lex_state = 0, .external_lex_state = 12},
  [19114] = {.lex_state = 363, .external_lex_state = 12},
  [19115] = {.lex_state = 0, .external_lex_state = 12},
  [19116] = {.lex_state = 363, .external_lex_state = 12},
  [19117] = {.lex_state = 0, .external_lex_state = 12},
  [19118] = {.lex_state = 363, .external_lex_state = 12},
  [19119] = {.lex_state = 343, .external_lex_state = 12},
  [19120] = {.lex_state = 409, .external_lex_state = 12},
  [19121] = {.lex_state = 0, .external_lex_state = 12},
  [19122] = {.lex_state = 0, .external_lex_state = 12},
  [19123] = {.lex_state = 0, .external_lex_state = 12},
  [19124] = {.lex_state = 0, .external_lex_state = 13},
  [19125] = {.lex_state = 0, .external_lex_state = 12},
  [19126] = {.lex_state = 363, .external_lex_state = 12},
  [19127] = {.lex_state = 363, .external_lex_state = 12},
  [19128] = {.lex_state = 343, .external_lex_state = 12},
  [19129] = {.lex_state = 363, .external_lex_state = 12},
  [19130] = {.lex_state = 0, .external_lex_state = 12},
  [19131] = {.lex_state = 0, .external_lex_state = 12},
  [19132] = {.lex_state = 0, .external_lex_state = 12},
  [19133] = {.lex_state = 0, .external_lex_state = 12},
  [19134] = {.lex_state = 363, .external_lex_state = 12},
  [19135] = {.lex_state = 409, .external_lex_state = 12},
  [19136] = {.lex_state = 0, .external_lex_state = 13},
  [19137] = {.lex_state = 0, .external_lex_state = 12},
  [19138] = {.lex_state = 0, .external_lex_state = 12},
  [19139] = {.lex_state = 363, .external_lex_state = 12},
  [19140] = {.lex_state = 0, .external_lex_state = 12},
  [19141] = {.lex_state = 363, .external_lex_state = 12},
  [19142] = {.lex_state = 363, .external_lex_state = 12},
  [19143] = {.lex_state = 0, .external_lex_state = 12},
  [19144] = {.lex_state = 0, .external_lex_state = 13},
  [19145] = {.lex_state = 363, .external_lex_state = 12},
  [19146] = {.lex_state = 0, .external_lex_state = 12},
  [19147] = {.lex_state = 363, .external_lex_state = 12},
  [19148] = {.lex_state = 0, .external_lex_state = 12},
  [19149] = {.lex_state = 0, .external_lex_state = 12},
  [19150] = {.lex_state = 0, .external_lex_state = 12},
  [19151] = {.lex_state = 0, .external_lex_state = 12},
  [19152] = {.lex_state = 0, .external_lex_state = 13},
  [19153] = {.lex_state = 0, .external_lex_state = 12},
  [19154] = {.lex_state = 409, .external_lex_state = 12},
  [19155] = {.lex_state = 363, .external_lex_state = 12},
  [19156] = {.lex_state = 0, .external_lex_state = 12},
  [19157] = {.lex_state = 0, .external_lex_state = 12},
  [19158] = {.lex_state = 363, .external_lex_state = 12},
  [19159] = {.lex_state = 363, .external_lex_state = 12},
  [19160] = {.lex_state = 0, .external_lex_state = 13},
  [19161] = {.lex_state = 363, .external_lex_state = 12},
  [19162] = {.lex_state = 0, .external_lex_state = 12},
  [19163] = {.lex_state = 0, .external_lex_state = 12},
  [19164] = {.lex_state = 363, .external_lex_state = 12},
  [19165] = {.lex_state = 0, .external_lex_state = 12},
  [19166] = {.lex_state = 363, .external_lex_state = 12},
  [19167] = {.lex_state = 0, .external_lex_state = 12},
  [19168] = {.lex_state = 0, .external_lex_state = 13},
  [19169] = {.lex_state = 0, .external_lex_state = 12},
  [19170] = {.lex_state = 363, .external_lex_state = 12},
  [19171] = {.lex_state = 0, .external_lex_state = 12},
  [19172] = {.lex_state = 0, .external_lex_state = 12},
  [19173] = {.lex_state = 363, .external_lex_state = 12},
  [19174] = {.lex_state = 363, .external_lex_state = 12},
  [19175] = {.lex_state = 0, .external_lex_state = 12},
  [19176] = {.lex_state = 0, .external_lex_state = 13},
  [19177] = {.lex_state = 0, .external_lex_state = 12},
  [19178] = {.lex_state = 0, .external_lex_state = 12},
  [19179] = {.lex_state = 363, .external_lex_state = 12},
  [19180] = {.lex_state = 363, .external_lex_state = 12},
  [19181] = {.lex_state = 363, .external_lex_state = 12},
  [19182] = {.lex_state = 363, .external_lex_state = 12},
  [19183] = {.lex_state = 0, .external_lex_state = 12},
  [19184] = {.lex_state = 0, .external_lex_state = 13},
  [19185] = {.lex_state = 0, .external_lex_state = 12},
  [19186] = {.lex_state = 0, .external_lex_state = 12},
  [19187] = {.lex_state = 0, .external_lex_state = 12},
  [19188] = {.lex_state = 363, .external_lex_state = 12},
  [19189] = {.lex_state = 0, .external_lex_state = 12},
  [19190] = {.lex_state = 363, .external_lex_state = 12},
  [19191] = {.lex_state = 0, .external_lex_state = 12},
  [19192] = {.lex_state = 0, .external_lex_state = 13},
  [19193] = {.lex_state = 0, .external_lex_state = 12},
  [19194] = {.lex_state = 0, .external_lex_state = 12},
  [19195] = {.lex_state = 363, .external_lex_state = 12},
  [19196] = {.lex_state = 0, .external_lex_state = 12},
  [19197] = {.lex_state = 0, .external_lex_state = 12},
  [19198] = {.lex_state = 0, .external_lex_state = 12},
  [19199] = {.lex_state = 0, .external_lex_state = 12},
  [19200] = {.lex_state = 0, .external_lex_state = 13},
  [19201] = {.lex_state = 363, .external_lex_state = 12},
  [19202] = {.lex_state = 363, .external_lex_state = 12},
  [19203] = {.lex_state = 0, .external_lex_state = 12},
  [19204] = {.lex_state = 363, .external_lex_state = 12},
  [19205] = {.lex_state = 0, .external_lex_state = 12},
  [19206] = {.lex_state = 0, .external_lex_state = 12},
  [19207] = {.lex_state = 0, .external_lex_state = 13},
  [19208] = {.lex_state = 0, .external_lex_state = 12},
  [19209] = {.lex_state = 363, .external_lex_state = 12},
  [19210] = {.lex_state = 0, .external_lex_state = 12},
  [19211] = {.lex_state = 0, .external_lex_state = 12},
  [19212] = {.lex_state = 0, .external_lex_state = 12},
  [19213] = {.lex_state = 363, .external_lex_state = 12},
  [19214] = {.lex_state = 0, .external_lex_state = 13},
  [19215] = {.lex_state = 0, .external_lex_state = 12},
  [19216] = {.lex_state = 363, .external_lex_state = 12},
  [19217] = {.lex_state = 363, .external_lex_state = 12},
  [19218] = {.lex_state = 0, .external_lex_state = 12},
  [19219] = {.lex_state = 363, .external_lex_state = 12},
  [19220] = {.lex_state = 0, .external_lex_state = 12},
  [19221] = {.lex_state = 0, .external_lex_state = 13},
  [19222] = {.lex_state = 0, .external_lex_state = 12},
  [19223] = {.lex_state = 363, .external_lex_state = 12},
  [19224] = {.lex_state = 0, .external_lex_state = 12},
  [19225] = {.lex_state = 0, .external_lex_state = 12},
  [19226] = {.lex_state = 363, .external_lex_state = 12},
  [19227] = {.lex_state = 363, .external_lex_state = 12},
  [19228] = {.lex_state = 0, .external_lex_state = 13},
  [19229] = {.lex_state = 0, .external_lex_state = 12},
  [19230] = {.lex_state = 0, .external_lex_state = 12},
  [19231] = {.lex_state = 363, .external_lex_state = 12},
  [19232] = {.lex_state = 363, .external_lex_state = 12},
  [19233] = {.lex_state = 363, .external_lex_state = 12},
  [19234] = {.lex_state = 0, .external_lex_state = 12},
  [19235] = {.lex_state = 0, .external_lex_state = 13},
  [19236] = {.lex_state = 0, .external_lex_state = 12},
  [19237] = {.lex_state = 0, .external_lex_state = 12},
  [19238] = {.lex_state = 0, .external_lex_state = 12},
  [19239] = {.lex_state = 0, .external_lex_state = 12},
  [19240] = {.lex_state = 343, .external_lex_state = 12},
  [19241] = {.lex_state = 0, .external_lex_state = 12},
  [19242] = {.lex_state = 0, .external_lex_state = 13},
  [19243] = {.lex_state = 0, .external_lex_state = 12},
  [19244] = {.lex_state = 0, .external_lex_state = 12},
  [19245] = {.lex_state = 363, .external_lex_state = 12},
  [19246] = {.lex_state = 363, .external_lex_state = 12},
  [19247] = {.lex_state = 363, .external_lex_state = 12},
  [19248] = {.lex_state = 0, .external_lex_state = 12},
  [19249] = {.lex_state = 0, .external_lex_state = 13},
  [19250] = {.lex_state = 0, .external_lex_state = 12},
  [19251] = {.lex_state = 363, .external_lex_state = 12},
  [19252] = {.lex_state = 363, .external_lex_state = 12},
  [19253] = {.lex_state = 363, .external_lex_state = 12},
  [19254] = {.lex_state = 363, .external_lex_state = 12},
  [19255] = {.lex_state = 0, .external_lex_state = 12},
  [19256] = {.lex_state = 0, .external_lex_state = 12},
  [19257] = {.lex_state = 343, .external_lex_state = 12},
  [19258] = {.lex_state = 0, .external_lex_state = 12},
  [19259] = {.lex_state = 363, .external_lex_state = 12},
  [19260] = {.lex_state = 0, .external_lex_state = 12},
  [19261] = {.lex_state = 363, .external_lex_state = 12},
  [19262] = {.lex_state = 0, .external_lex_state = 12},
  [19263] = {.lex_state = 363, .external_lex_state = 12},
  [19264] = {.lex_state = 363, .external_lex_state = 12},
  [19265] = {.lex_state = 363, .external_lex_state = 12},
  [19266] = {.lex_state = 409, .external_lex_state = 12},
  [19267] = {.lex_state = 363, .external_lex_state = 12},
  [19268] = {.lex_state = 363, .external_lex_state = 12},
  [19269] = {.lex_state = 409, .external_lex_state = 12},
  [19270] = {.lex_state = 0, .external_lex_state = 12},
  [19271] = {.lex_state = 0, .external_lex_state = 12},
  [19272] = {.lex_state = 0, .external_lex_state = 12},
  [19273] = {.lex_state = 0, .external_lex_state = 12},
  [19274] = {.lex_state = 0, .external_lex_state = 12},
  [19275] = {.lex_state = 363, .external_lex_state = 12},
  [19276] = {.lex_state = 363, .external_lex_state = 12},
  [19277] = {.lex_state = 363, .external_lex_state = 12},
  [19278] = {.lex_state = 363, .external_lex_state = 12},
  [19279] = {.lex_state = 363, .external_lex_state = 12},
  [19280] = {.lex_state = 0, .external_lex_state = 12},
  [19281] = {.lex_state = 0, .external_lex_state = 12},
  [19282] = {.lex_state = 0, .external_lex_state = 12},
  [19283] = {.lex_state = 363, .external_lex_state = 12},
  [19284] = {.lex_state = 0, .external_lex_state = 12},
  [19285] = {.lex_state = 363, .external_lex_state = 12},
  [19286] = {.lex_state = 0, .external_lex_state = 12},
  [19287] = {.lex_state = 363, .external_lex_state = 12},
  [19288] = {.lex_state = 363, .external_lex_state = 12},
  [19289] = {.lex_state = 0, .external_lex_state = 12},
  [19290] = {.lex_state = 343, .external_lex_state = 12},
  [19291] = {.lex_state = 0, .external_lex_state = 12},
  [19292] = {.lex_state = 0, .external_lex_state = 12},
  [19293] = {.lex_state = 343, .external_lex_state = 12},
  [19294] = {.lex_state = 0, .external_lex_state = 12},
  [19295] = {.lex_state = 363, .external_lex_state = 12},
  [19296] = {.lex_state = 0, .external_lex_state = 12},
  [19297] = {.lex_state = 0, .external_lex_state = 12},
  [19298] = {.lex_state = 363, .external_lex_state = 12},
  [19299] = {.lex_state = 0, .external_lex_state = 12},
  [19300] = {.lex_state = 0, .external_lex_state = 12},
  [19301] = {.lex_state = 363, .external_lex_state = 12},
  [19302] = {.lex_state = 363, .external_lex_state = 12},
  [19303] = {.lex_state = 0, .external_lex_state = 12},
  [19304] = {.lex_state = 0, .external_lex_state = 12},
  [19305] = {.lex_state = 363, .external_lex_state = 12},
  [19306] = {.lex_state = 363, .external_lex_state = 12},
  [19307] = {.lex_state = 0, .external_lex_state = 12},
  [19308] = {.lex_state = 363, .external_lex_state = 12},
  [19309] = {.lex_state = 363, .external_lex_state = 12},
  [19310] = {.lex_state = 0, .external_lex_state = 12},
  [19311] = {.lex_state = 0, .external_lex_state = 12},
  [19312] = {.lex_state = 0, .external_lex_state = 12},
  [19313] = {.lex_state = 0, .external_lex_state = 13},
  [19314] = {.lex_state = 363, .external_lex_state = 12},
  [19315] = {.lex_state = 0, .external_lex_state = 12},
  [19316] = {.lex_state = 0, .external_lex_state = 12},
  [19317] = {.lex_state = 363, .external_lex_state = 12},
  [19318] = {.lex_state = 0, .external_lex_state = 12},
  [19319] = {.lex_state = 363, .external_lex_state = 12},
  [19320] = {.lex_state = 363, .external_lex_state = 12},
  [19321] = {.lex_state = 0, .external_lex_state = 12},
  [19322] = {.lex_state = 0, .external_lex_state = 12},
  [19323] = {.lex_state = 363, .external_lex_state = 12},
  [19324] = {.lex_state = 0, .external_lex_state = 12},
  [19325] = {.lex_state = 0, .external_lex_state = 12},
  [19326] = {.lex_state = 363, .external_lex_state = 12},
  [19327] = {.lex_state = 0, .external_lex_state = 12},
  [19328] = {.lex_state = 363, .external_lex_state = 12},
  [19329] = {.lex_state = 363, .external_lex_state = 12},
  [19330] = {.lex_state = 0, .external_lex_state = 12},
  [19331] = {.lex_state = 363, .external_lex_state = 12},
  [19332] = {.lex_state = 363, .external_lex_state = 12},
  [19333] = {.lex_state = 409, .external_lex_state = 12},
  [19334] = {.lex_state = 0, .external_lex_state = 12},
  [19335] = {.lex_state = 363, .external_lex_state = 12},
  [19336] = {.lex_state = 0, .external_lex_state = 12},
  [19337] = {.lex_state = 363, .external_lex_state = 12},
  [19338] = {.lex_state = 363, .external_lex_state = 12},
  [19339] = {.lex_state = 0, .external_lex_state = 12},
  [19340] = {.lex_state = 363, .external_lex_state = 12},
  [19341] = {.lex_state = 0, .external_lex_state = 12},
  [19342] = {.lex_state = 363, .external_lex_state = 12},
  [19343] = {.lex_state = 343, .external_lex_state = 12},
  [19344] = {.lex_state = 0, .external_lex_state = 12},
  [19345] = {.lex_state = 0, .external_lex_state = 12},
  [19346] = {.lex_state = 363, .external_lex_state = 12},
  [19347] = {.lex_state = 0, .external_lex_state = 12},
  [19348] = {.lex_state = 0, .external_lex_state = 12},
  [19349] = {.lex_state = 363, .external_lex_state = 12},
  [19350] = {.lex_state = 363, .external_lex_state = 12},
  [19351] = {.lex_state = 0, .external_lex_state = 12},
  [19352] = {.lex_state = 363, .external_lex_state = 12},
  [19353] = {.lex_state = 0, .external_lex_state = 12},
  [19354] = {.lex_state = 0, .external_lex_state = 12},
  [19355] = {.lex_state = 0, .external_lex_state = 12},
  [19356] = {.lex_state = 0, .external_lex_state = 12},
  [19357] = {.lex_state = 0, .external_lex_state = 12},
  [19358] = {.lex_state = 363, .external_lex_state = 12},
  [19359] = {.lex_state = 363, .external_lex_state = 12},
  [19360] = {.lex_state = 0, .external_lex_state = 12},
  [19361] = {.lex_state = 363, .external_lex_state = 12},
  [19362] = {.lex_state = 343, .external_lex_state = 12},
  [19363] = {.lex_state = 363, .external_lex_state = 12},
  [19364] = {.lex_state = 0, .external_lex_state = 12},
  [19365] = {.lex_state = 363, .external_lex_state = 12},
  [19366] = {.lex_state = 0, .external_lex_state = 12},
  [19367] = {.lex_state = 0, .external_lex_state = 12},
  [19368] = {.lex_state = 0, .external_lex_state = 12},
  [19369] = {.lex_state = 363, .external_lex_state = 12},
  [19370] = {.lex_state = 0, .external_lex_state = 12},
  [19371] = {.lex_state = 363, .external_lex_state = 12},
  [19372] = {.lex_state = 363, .external_lex_state = 12},
  [19373] = {.lex_state = 363, .external_lex_state = 12},
  [19374] = {.lex_state = 0, .external_lex_state = 12},
  [19375] = {.lex_state = 343, .external_lex_state = 12},
  [19376] = {.lex_state = 343, .external_lex_state = 12},
  [19377] = {.lex_state = 363, .external_lex_state = 12},
  [19378] = {.lex_state = 363, .external_lex_state = 12},
  [19379] = {.lex_state = 0, .external_lex_state = 12},
  [19380] = {.lex_state = 0, .external_lex_state = 12},
  [19381] = {.lex_state = 363, .external_lex_state = 12},
  [19382] = {.lex_state = 0, .external_lex_state = 12},
  [19383] = {.lex_state = 0, .external_lex_state = 12},
  [19384] = {.lex_state = 0, .external_lex_state = 12},
  [19385] = {.lex_state = 0, .external_lex_state = 12},
  [19386] = {.lex_state = 0, .external_lex_state = 12},
  [19387] = {.lex_state = 0, .external_lex_state = 12},
  [19388] = {.lex_state = 0, .external_lex_state = 12},
  [19389] = {.lex_state = 363, .external_lex_state = 12},
  [19390] = {.lex_state = 0, .external_lex_state = 12},
  [19391] = {.lex_state = 363, .external_lex_state = 12},
  [19392] = {.lex_state = 0, .external_lex_state = 12},
  [19393] = {.lex_state = 363, .external_lex_state = 12},
  [19394] = {.lex_state = 363, .external_lex_state = 12},
  [19395] = {.lex_state = 0, .external_lex_state = 12},
  [19396] = {.lex_state = 363, .external_lex_state = 12},
  [19397] = {.lex_state = 0, .external_lex_state = 12},
  [19398] = {.lex_state = 363, .external_lex_state = 12},
  [19399] = {.lex_state = 0, .external_lex_state = 12},
  [19400] = {.lex_state = 363, .external_lex_state = 12},
  [19401] = {.lex_state = 363, .external_lex_state = 12},
  [19402] = {.lex_state = 343, .external_lex_state = 12},
  [19403] = {.lex_state = 0, .external_lex_state = 12},
  [19404] = {.lex_state = 363, .external_lex_state = 12},
  [19405] = {.lex_state = 363, .external_lex_state = 12},
  [19406] = {.lex_state = 0, .external_lex_state = 12},
  [19407] = {.lex_state = 363, .external_lex_state = 12},
  [19408] = {.lex_state = 0, .external_lex_state = 12},
  [19409] = {.lex_state = 0, .external_lex_state = 12},
  [19410] = {.lex_state = 363, .external_lex_state = 12},
  [19411] = {.lex_state = 363, .external_lex_state = 12},
  [19412] = {.lex_state = 363, .external_lex_state = 12},
  [19413] = {.lex_state = 363, .external_lex_state = 12},
  [19414] = {.lex_state = 363, .external_lex_state = 12},
  [19415] = {.lex_state = 0, .external_lex_state = 12},
  [19416] = {.lex_state = 363, .external_lex_state = 12},
  [19417] = {.lex_state = 363, .external_lex_state = 12},
  [19418] = {.lex_state = 0, .external_lex_state = 12},
  [19419] = {.lex_state = 363, .external_lex_state = 12},
  [19420] = {.lex_state = 363, .external_lex_state = 12},
  [19421] = {.lex_state = 0, .external_lex_state = 12},
  [19422] = {.lex_state = 343, .external_lex_state = 12},
  [19423] = {.lex_state = 409, .external_lex_state = 12},
  [19424] = {.lex_state = 363, .external_lex_state = 12},
  [19425] = {.lex_state = 0, .external_lex_state = 12},
  [19426] = {.lex_state = 363, .external_lex_state = 12},
  [19427] = {.lex_state = 0, .external_lex_state = 12},
  [19428] = {.lex_state = 363, .external_lex_state = 12},
  [19429] = {.lex_state = 363, .external_lex_state = 12},
  [19430] = {.lex_state = 363, .external_lex_state = 12},
  [19431] = {.lex_state = 363, .external_lex_state = 12},
  [19432] = {.lex_state = 363, .external_lex_state = 12},
  [19433] = {.lex_state = 0, .external_lex_state = 12},
  [19434] = {.lex_state = 363, .external_lex_state = 12},
  [19435] = {.lex_state = 363, .external_lex_state = 12},
  [19436] = {.lex_state = 363, .external_lex_state = 12},
  [19437] = {.lex_state = 0, .external_lex_state = 12},
  [19438] = {.lex_state = 0, .external_lex_state = 12},
  [19439] = {.lex_state = 363, .external_lex_state = 12},
  [19440] = {.lex_state = 0, .external_lex_state = 12},
  [19441] = {.lex_state = 363, .external_lex_state = 12},
  [19442] = {.lex_state = 0, .external_lex_state = 12},
  [19443] = {.lex_state = 363, .external_lex_state = 12},
  [19444] = {.lex_state = 0, .external_lex_state = 12},
  [19445] = {.lex_state = 0, .external_lex_state = 12},
  [19446] = {.lex_state = 0, .external_lex_state = 12},
  [19447] = {.lex_state = 363, .external_lex_state = 12},
  [19448] = {.lex_state = 0, .external_lex_state = 12},
  [19449] = {.lex_state = 363, .external_lex_state = 12},
  [19450] = {.lex_state = 363, .external_lex_state = 12},
  [19451] = {.lex_state = 363, .external_lex_state = 12},
  [19452] = {.lex_state = 363, .external_lex_state = 12},
  [19453] = {.lex_state = 363, .external_lex_state = 12},
  [19454] = {.lex_state = 0, .external_lex_state = 12},
  [19455] = {.lex_state = 363, .external_lex_state = 12},
  [19456] = {.lex_state = 363, .external_lex_state = 12},
  [19457] = {.lex_state = 343, .external_lex_state = 12},
  [19458] = {.lex_state = 0, .external_lex_state = 12},
  [19459] = {.lex_state = 0, .external_lex_state = 12},
  [19460] = {.lex_state = 0, .external_lex_state = 12},
  [19461] = {.lex_state = 0, .external_lex_state = 12},
  [19462] = {.lex_state = 0, .external_lex_state = 12},
  [19463] = {.lex_state = 0, .external_lex_state = 12},
  [19464] = {.lex_state = 0, .external_lex_state = 12},
  [19465] = {.lex_state = 0, .external_lex_state = 12},
  [19466] = {.lex_state = 363, .external_lex_state = 12},
  [19467] = {.lex_state = 0, .external_lex_state = 12},
  [19468] = {.lex_state = 363, .external_lex_state = 12},
  [19469] = {.lex_state = 363, .external_lex_state = 12},
  [19470] = {.lex_state = 363, .external_lex_state = 12},
  [19471] = {.lex_state = 0, .external_lex_state = 12},
  [19472] = {.lex_state = 363, .external_lex_state = 12},
  [19473] = {.lex_state = 0, .external_lex_state = 12},
  [19474] = {.lex_state = 363, .external_lex_state = 12},
  [19475] = {.lex_state = 363, .external_lex_state = 12},
  [19476] = {.lex_state = 0, .external_lex_state = 12},
  [19477] = {.lex_state = 363, .external_lex_state = 12},
  [19478] = {.lex_state = 363, .external_lex_state = 12},
  [19479] = {.lex_state = 0, .external_lex_state = 12},
  [19480] = {.lex_state = 363, .external_lex_state = 12},
  [19481] = {.lex_state = 363, .external_lex_state = 12},
  [19482] = {.lex_state = 363, .external_lex_state = 12},
  [19483] = {.lex_state = 363, .external_lex_state = 12},
  [19484] = {.lex_state = 0, .external_lex_state = 12},
  [19485] = {.lex_state = 0, .external_lex_state = 12},
  [19486] = {.lex_state = 363, .external_lex_state = 12},
  [19487] = {.lex_state = 363, .external_lex_state = 12},
  [19488] = {.lex_state = 363, .external_lex_state = 12},
  [19489] = {.lex_state = 0, .external_lex_state = 12},
  [19490] = {.lex_state = 409, .external_lex_state = 12},
  [19491] = {.lex_state = 0, .external_lex_state = 12},
  [19492] = {.lex_state = 363, .external_lex_state = 12},
  [19493] = {.lex_state = 0, .external_lex_state = 12},
  [19494] = {.lex_state = 363, .external_lex_state = 12},
  [19495] = {.lex_state = 0, .external_lex_state = 12},
  [19496] = {.lex_state = 363, .external_lex_state = 12},
  [19497] = {.lex_state = 363, .external_lex_state = 12},
  [19498] = {.lex_state = 0, .external_lex_state = 12},
  [19499] = {.lex_state = 0, .external_lex_state = 12},
  [19500] = {.lex_state = 0, .external_lex_state = 12},
  [19501] = {.lex_state = 0, .external_lex_state = 12},
  [19502] = {.lex_state = 0, .external_lex_state = 12},
  [19503] = {.lex_state = 0, .external_lex_state = 12},
  [19504] = {.lex_state = 0, .external_lex_state = 12},
  [19505] = {.lex_state = 0, .external_lex_state = 12},
  [19506] = {.lex_state = 0, .external_lex_state = 12},
  [19507] = {.lex_state = 363, .external_lex_state = 12},
  [19508] = {.lex_state = 363, .external_lex_state = 12},
  [19509] = {.lex_state = 409, .external_lex_state = 12},
  [19510] = {.lex_state = 0, .external_lex_state = 12},
  [19511] = {.lex_state = 363, .external_lex_state = 12},
  [19512] = {.lex_state = 363, .external_lex_state = 12},
  [19513] = {.lex_state = 363, .external_lex_state = 12},
  [19514] = {.lex_state = 0, .external_lex_state = 12},
  [19515] = {.lex_state = 0, .external_lex_state = 12},
  [19516] = {.lex_state = 363, .external_lex_state = 12},
  [19517] = {.lex_state = 363, .external_lex_state = 12},
  [19518] = {.lex_state = 0, .external_lex_state = 12},
  [19519] = {.lex_state = 363, .external_lex_state = 12},
  [19520] = {.lex_state = 0, .external_lex_state = 12},
  [19521] = {.lex_state = 0, .external_lex_state = 12},
  [19522] = {.lex_state = 363, .external_lex_state = 12},
  [19523] = {.lex_state = 363, .external_lex_state = 12},
  [19524] = {.lex_state = 363, .external_lex_state = 12},
  [19525] = {.lex_state = 363, .external_lex_state = 12},
  [19526] = {.lex_state = 363, .external_lex_state = 12},
  [19527] = {.lex_state = 363, .external_lex_state = 12},
  [19528] = {.lex_state = 363, .external_lex_state = 12},
  [19529] = {.lex_state = 409, .external_lex_state = 12},
  [19530] = {.lex_state = 0, .external_lex_state = 12},
  [19531] = {.lex_state = 0, .external_lex_state = 12},
  [19532] = {.lex_state = 0, .external_lex_state = 12},
  [19533] = {.lex_state = 363, .external_lex_state = 12},
  [19534] = {.lex_state = 363, .external_lex_state = 12},
  [19535] = {.lex_state = 0, .external_lex_state = 12},
  [19536] = {.lex_state = 0, .external_lex_state = 12},
  [19537] = {.lex_state = 363, .external_lex_state = 12},
  [19538] = {.lex_state = 363, .external_lex_state = 12},
  [19539] = {.lex_state = 363, .external_lex_state = 12},
  [19540] = {.lex_state = 0, .external_lex_state = 12},
  [19541] = {.lex_state = 363, .external_lex_state = 12},
  [19542] = {.lex_state = 363, .external_lex_state = 12},
  [19543] = {.lex_state = 343, .external_lex_state = 12},
  [19544] = {.lex_state = 363, .external_lex_state = 12},
  [19545] = {.lex_state = 363, .external_lex_state = 12},
  [19546] = {.lex_state = 363, .external_lex_state = 12},
  [19547] = {.lex_state = 363, .external_lex_state = 12},
  [19548] = {.lex_state = 0, .external_lex_state = 12},
  [19549] = {.lex_state = 363, .external_lex_state = 12},
  [19550] = {.lex_state = 343, .external_lex_state = 12},
  [19551] = {.lex_state = 363, .external_lex_state = 12},
  [19552] = {.lex_state = 363, .external_lex_state = 12},
  [19553] = {.lex_state = 363, .external_lex_state = 12},
  [19554] = {.lex_state = 363, .external_lex_state = 12},
  [19555] = {.lex_state = 0, .external_lex_state = 12},
  [19556] = {.lex_state = 0, .external_lex_state = 12},
  [19557] = {.lex_state = 363, .external_lex_state = 12},
  [19558] = {.lex_state = 0, .external_lex_state = 12},
  [19559] = {.lex_state = 363, .external_lex_state = 12},
  [19560] = {.lex_state = 363, .external_lex_state = 12},
  [19561] = {.lex_state = 0, .external_lex_state = 12},
  [19562] = {.lex_state = 363, .external_lex_state = 12},
  [19563] = {.lex_state = 0, .external_lex_state = 12},
  [19564] = {.lex_state = 363, .external_lex_state = 12},
  [19565] = {.lex_state = 363, .external_lex_state = 12},
  [19566] = {.lex_state = 363, .external_lex_state = 12},
  [19567] = {.lex_state = 363, .external_lex_state = 12},
  [19568] = {.lex_state = 0, .external_lex_state = 12},
  [19569] = {.lex_state = 0, .external_lex_state = 12},
  [19570] = {.lex_state = 0, .external_lex_state = 12},
  [19571] = {.lex_state = 363, .external_lex_state = 12},
  [19572] = {.lex_state = 363, .external_lex_state = 12},
  [19573] = {.lex_state = 363, .external_lex_state = 12},
  [19574] = {.lex_state = 0, .external_lex_state = 12},
  [19575] = {.lex_state = 363, .external_lex_state = 12},
  [19576] = {.lex_state = 363, .external_lex_state = 12},
  [19577] = {.lex_state = 0, .external_lex_state = 12},
  [19578] = {.lex_state = 363, .external_lex_state = 12},
  [19579] = {.lex_state = 363, .external_lex_state = 12},
  [19580] = {.lex_state = 0, .external_lex_state = 12},
  [19581] = {.lex_state = 0, .external_lex_state = 12},
  [19582] = {.lex_state = 0, .external_lex_state = 12},
  [19583] = {.lex_state = 343, .external_lex_state = 12},
  [19584] = {.lex_state = 0, .external_lex_state = 12},
  [19585] = {.lex_state = 0, .external_lex_state = 12},
  [19586] = {.lex_state = 0, .external_lex_state = 12},
  [19587] = {.lex_state = 0, .external_lex_state = 12},
  [19588] = {.lex_state = 363, .external_lex_state = 12},
  [19589] = {.lex_state = 0, .external_lex_state = 12},
  [19590] = {.lex_state = 363, .external_lex_state = 12},
  [19591] = {.lex_state = 0, .external_lex_state = 12},
  [19592] = {.lex_state = 343, .external_lex_state = 12},
  [19593] = {.lex_state = 0, .external_lex_state = 12},
  [19594] = {.lex_state = 409, .external_lex_state = 12},
  [19595] = {.lex_state = 363, .external_lex_state = 12},
  [19596] = {.lex_state = 343, .external_lex_state = 12},
  [19597] = {.lex_state = 0, .external_lex_state = 12},
  [19598] = {.lex_state = 0, .external_lex_state = 12},
  [19599] = {.lex_state = 0, .external_lex_state = 12},
  [19600] = {.lex_state = 363, .external_lex_state = 12},
  [19601] = {.lex_state = 363, .external_lex_state = 12},
  [19602] = {.lex_state = 0, .external_lex_state = 12},
  [19603] = {.lex_state = 0, .external_lex_state = 12},
  [19604] = {.lex_state = 0, .external_lex_state = 12},
  [19605] = {.lex_state = 363, .external_lex_state = 12},
  [19606] = {.lex_state = 363, .external_lex_state = 12},
  [19607] = {.lex_state = 363, .external_lex_state = 12},
  [19608] = {.lex_state = 0, .external_lex_state = 12},
  [19609] = {.lex_state = 0, .external_lex_state = 12},
  [19610] = {.lex_state = 0, .external_lex_state = 12},
  [19611] = {.lex_state = 343, .external_lex_state = 12},
  [19612] = {.lex_state = 343, .external_lex_state = 12},
  [19613] = {.lex_state = 363, .external_lex_state = 12},
  [19614] = {.lex_state = 363, .external_lex_state = 12},
  [19615] = {.lex_state = 0, .external_lex_state = 12},
  [19616] = {.lex_state = 363, .external_lex_state = 12},
  [19617] = {.lex_state = 0, .external_lex_state = 12},
  [19618] = {.lex_state = 0, .external_lex_state = 12},
  [19619] = {.lex_state = 363, .external_lex_state = 12},
  [19620] = {.lex_state = 363, .external_lex_state = 12},
  [19621] = {.lex_state = 363, .external_lex_state = 12},
  [19622] = {.lex_state = 363, .external_lex_state = 12},
  [19623] = {.lex_state = 343, .external_lex_state = 12},
  [19624] = {.lex_state = 0, .external_lex_state = 12},
  [19625] = {.lex_state = 0, .external_lex_state = 12},
  [19626] = {.lex_state = 0, .external_lex_state = 12},
  [19627] = {.lex_state = 363, .external_lex_state = 12},
  [19628] = {.lex_state = 363, .external_lex_state = 12},
  [19629] = {.lex_state = 0, .external_lex_state = 12},
  [19630] = {.lex_state = 0, .external_lex_state = 12},
  [19631] = {.lex_state = 0, .external_lex_state = 12},
  [19632] = {.lex_state = 409, .external_lex_state = 12},
  [19633] = {.lex_state = 0, .external_lex_state = 12},
  [19634] = {.lex_state = 0, .external_lex_state = 12},
  [19635] = {.lex_state = 0, .external_lex_state = 12},
  [19636] = {.lex_state = 0, .external_lex_state = 12},
  [19637] = {.lex_state = 363, .external_lex_state = 12},
  [19638] = {.lex_state = 363, .external_lex_state = 12},
  [19639] = {.lex_state = 343, .external_lex_state = 12},
  [19640] = {.lex_state = 343, .external_lex_state = 12},
  [19641] = {.lex_state = 363, .external_lex_state = 12},
  [19642] = {.lex_state = 0, .external_lex_state = 12},
  [19643] = {.lex_state = 0, .external_lex_state = 12},
  [19644] = {.lex_state = 0, .external_lex_state = 12},
  [19645] = {.lex_state = 0, .external_lex_state = 12},
  [19646] = {.lex_state = 363, .external_lex_state = 12},
  [19647] = {.lex_state = 0, .external_lex_state = 12},
  [19648] = {.lex_state = 363, .external_lex_state = 12},
  [19649] = {.lex_state = 0, .external_lex_state = 12},
  [19650] = {.lex_state = 0, .external_lex_state = 12},
  [19651] = {.lex_state = 363, .external_lex_state = 12},
  [19652] = {.lex_state = 363, .external_lex_state = 12},
  [19653] = {.lex_state = 363, .external_lex_state = 12},
  [19654] = {.lex_state = 0, .external_lex_state = 12},
  [19655] = {.lex_state = 363, .external_lex_state = 12},
  [19656] = {.lex_state = 0, .external_lex_state = 12},
  [19657] = {.lex_state = 0, .external_lex_state = 12},
  [19658] = {.lex_state = 0, .external_lex_state = 12},
  [19659] = {.lex_state = 0, .external_lex_state = 12},
  [19660] = {.lex_state = 363, .external_lex_state = 12},
  [19661] = {.lex_state = 409, .external_lex_state = 12},
  [19662] = {.lex_state = 0, .external_lex_state = 12},
  [19663] = {.lex_state = 363, .external_lex_state = 12},
  [19664] = {.lex_state = 363, .external_lex_state = 12},
  [19665] = {.lex_state = 363, .external_lex_state = 12},
  [19666] = {.lex_state = 343, .external_lex_state = 12},
  [19667] = {.lex_state = 343, .external_lex_state = 12},
  [19668] = {.lex_state = 0, .external_lex_state = 12},
  [19669] = {.lex_state = 343, .external_lex_state = 12},
  [19670] = {.lex_state = 0, .external_lex_state = 12},
  [19671] = {.lex_state = 0, .external_lex_state = 12},
  [19672] = {.lex_state = 0, .external_lex_state = 12},
  [19673] = {.lex_state = 0, .external_lex_state = 12},
  [19674] = {.lex_state = 363, .external_lex_state = 12},
  [19675] = {.lex_state = 363, .external_lex_state = 12},
  [19676] = {.lex_state = 0, .external_lex_state = 12},
  [19677] = {.lex_state = 363, .external_lex_state = 12},
  [19678] = {.lex_state = 363, .external_lex_state = 12},
  [19679] = {.lex_state = 363, .external_lex_state = 12},
  [19680] = {.lex_state = 0, .external_lex_state = 12},
  [19681] = {.lex_state = 363, .external_lex_state = 12},
  [19682] = {.lex_state = 0, .external_lex_state = 12},
  [19683] = {.lex_state = 0, .external_lex_state = 12},
  [19684] = {.lex_state = 363, .external_lex_state = 12},
  [19685] = {.lex_state = 0, .external_lex_state = 12},
  [19686] = {.lex_state = 0, .external_lex_state = 12},
  [19687] = {.lex_state = 363, .external_lex_state = 12},
  [19688] = {.lex_state = 0, .external_lex_state = 12},
  [19689] = {.lex_state = 0, .external_lex_state = 12},
  [19690] = {.lex_state = 363, .external_lex_state = 12},
  [19691] = {.lex_state = 343, .external_lex_state = 12},
  [19692] = {.lex_state = 343, .external_lex_state = 12},
  [19693] = {.lex_state = 363, .external_lex_state = 12},
  [19694] = {.lex_state = 363, .external_lex_state = 12},
  [19695] = {.lex_state = 0, .external_lex_state = 12},
  [19696] = {.lex_state = 363, .external_lex_state = 12},
  [19697] = {.lex_state = 0, .external_lex_state = 12},
  [19698] = {.lex_state = 363, .external_lex_state = 12},
  [19699] = {.lex_state = 363, .external_lex_state = 12},
  [19700] = {.lex_state = 363, .external_lex_state = 12},
  [19701] = {.lex_state = 409, .external_lex_state = 12},
  [19702] = {.lex_state = 0, .external_lex_state = 12},
  [19703] = {.lex_state = 363, .external_lex_state = 12},
  [19704] = {.lex_state = 363, .external_lex_state = 12},
  [19705] = {.lex_state = 0, .external_lex_state = 12},
  [19706] = {.lex_state = 363, .external_lex_state = 12},
  [19707] = {.lex_state = 0, .external_lex_state = 12},
  [19708] = {.lex_state = 0, .external_lex_state = 12},
  [19709] = {.lex_state = 363, .external_lex_state = 12},
  [19710] = {.lex_state = 363, .external_lex_state = 12},
  [19711] = {.lex_state = 0, .external_lex_state = 12},
  [19712] = {.lex_state = 0, .external_lex_state = 12},
  [19713] = {.lex_state = 363, .external_lex_state = 12},
  [19714] = {.lex_state = 363, .external_lex_state = 12},
  [19715] = {.lex_state = 363, .external_lex_state = 12},
  [19716] = {.lex_state = 343, .external_lex_state = 12},
  [19717] = {.lex_state = 343, .external_lex_state = 12},
  [19718] = {.lex_state = 0, .external_lex_state = 12},
  [19719] = {.lex_state = 0, .external_lex_state = 12},
  [19720] = {.lex_state = 363, .external_lex_state = 12},
  [19721] = {.lex_state = 363, .external_lex_state = 12},
  [19722] = {.lex_state = 363, .external_lex_state = 12},
  [19723] = {.lex_state = 363, .external_lex_state = 12},
  [19724] = {.lex_state = 409, .external_lex_state = 12},
  [19725] = {.lex_state = 363, .external_lex_state = 12},
  [19726] = {.lex_state = 0, .external_lex_state = 12},
  [19727] = {.lex_state = 0, .external_lex_state = 12},
  [19728] = {.lex_state = 363, .external_lex_state = 12},
  [19729] = {.lex_state = 363, .external_lex_state = 12},
  [19730] = {.lex_state = 363, .external_lex_state = 12},
  [19731] = {.lex_state = 363, .external_lex_state = 12},
  [19732] = {.lex_state = 0, .external_lex_state = 12},
  [19733] = {.lex_state = 363, .external_lex_state = 12},
  [19734] = {.lex_state = 0, .external_lex_state = 12},
  [19735] = {.lex_state = 363, .external_lex_state = 12},
  [19736] = {.lex_state = 0, .external_lex_state = 12},
  [19737] = {.lex_state = 363, .external_lex_state = 12},
  [19738] = {.lex_state = 0, .external_lex_state = 12},
  [19739] = {.lex_state = 343, .external_lex_state = 12},
  [19740] = {.lex_state = 343, .external_lex_state = 12},
  [19741] = {.lex_state = 0, .external_lex_state = 12},
  [19742] = {.lex_state = 0, .external_lex_state = 12},
  [19743] = {.lex_state = 363, .external_lex_state = 12},
  [19744] = {.lex_state = 363, .external_lex_state = 12},
  [19745] = {.lex_state = 343, .external_lex_state = 12},
  [19746] = {.lex_state = 343, .external_lex_state = 12},
  [19747] = {.lex_state = 343, .external_lex_state = 12},
  [19748] = {.lex_state = 363, .external_lex_state = 12},
  [19749] = {.lex_state = 0, .external_lex_state = 12},
  [19750] = {.lex_state = 0, .external_lex_state = 12},
  [19751] = {.lex_state = 343, .external_lex_state = 12},
  [19752] = {.lex_state = 343, .external_lex_state = 12},
  [19753] = {.lex_state = 409, .external_lex_state = 12},
  [19754] = {.lex_state = 363, .external_lex_state = 12},
  [19755] = {.lex_state = 0, .external_lex_state = 12},
  [19756] = {.lex_state = 0, .external_lex_state = 12},
  [19757] = {.lex_state = 343, .external_lex_state = 12},
  [19758] = {.lex_state = 343, .external_lex_state = 12},
  [19759] = {.lex_state = 0, .external_lex_state = 12},
  [19760] = {.lex_state = 0, .external_lex_state = 12},
  [19761] = {.lex_state = 0, .external_lex_state = 12},
  [19762] = {.lex_state = 0, .external_lex_state = 12},
  [19763] = {.lex_state = 343, .external_lex_state = 12},
  [19764] = {.lex_state = 343, .external_lex_state = 12},
  [19765] = {.lex_state = 0, .external_lex_state = 12},
  [19766] = {.lex_state = 363, .external_lex_state = 12},
  [19767] = {.lex_state = 363, .external_lex_state = 12},
  [19768] = {.lex_state = 0, .external_lex_state = 12},
  [19769] = {.lex_state = 343, .external_lex_state = 12},
  [19770] = {.lex_state = 343, .external_lex_state = 12},
  [19771] = {.lex_state = 409, .external_lex_state = 12},
  [19772] = {.lex_state = 0, .external_lex_state = 12},
  [19773] = {.lex_state = 0, .external_lex_state = 12},
  [19774] = {.lex_state = 0, .external_lex_state = 12},
  [19775] = {.lex_state = 0, .external_lex_state = 12},
  [19776] = {.lex_state = 343, .external_lex_state = 12},
  [19777] = {.lex_state = 0, .external_lex_state = 12},
  [19778] = {.lex_state = 363, .external_lex_state = 12},
  [19779] = {.lex_state = 0, .external_lex_state = 12},
  [19780] = {.lex_state = 0, .external_lex_state = 12},
  [19781] = {.lex_state = 0, .external_lex_state = 12},
  [19782] = {.lex_state = 0, .external_lex_state = 12},
  [19783] = {.lex_state = 0, .external_lex_state = 12},
  [19784] = {.lex_state = 0, .external_lex_state = 12},
  [19785] = {.lex_state = 0, .external_lex_state = 12},
  [19786] = {.lex_state = 0, .external_lex_state = 12},
  [19787] = {.lex_state = 0, .external_lex_state = 12},
  [19788] = {.lex_state = 0, .external_lex_state = 12},
  [19789] = {.lex_state = 343, .external_lex_state = 12},
  [19790] = {.lex_state = 0, .external_lex_state = 12},
  [19791] = {.lex_state = 363, .external_lex_state = 12},
  [19792] = {.lex_state = 363, .external_lex_state = 12},
  [19793] = {.lex_state = 0, .external_lex_state = 12},
  [19794] = {.lex_state = 0, .external_lex_state = 12},
  [19795] = {.lex_state = 0, .external_lex_state = 12},
  [19796] = {.lex_state = 0, .external_lex_state = 12},
  [19797] = {.lex_state = 0, .external_lex_state = 12},
  [19798] = {.lex_state = 0, .external_lex_state = 12},
  [19799] = {.lex_state = 409, .external_lex_state = 12},
  [19800] = {.lex_state = 0, .external_lex_state = 12},
  [19801] = {.lex_state = 0, .external_lex_state = 12},
  [19802] = {.lex_state = 0, .external_lex_state = 12},
  [19803] = {.lex_state = 0, .external_lex_state = 12},
  [19804] = {.lex_state = 0, .external_lex_state = 12},
  [19805] = {.lex_state = 0, .external_lex_state = 12},
  [19806] = {.lex_state = 0, .external_lex_state = 12},
  [19807] = {.lex_state = 343, .external_lex_state = 12},
  [19808] = {.lex_state = 0, .external_lex_state = 12},
  [19809] = {.lex_state = 363, .external_lex_state = 12},
  [19810] = {.lex_state = 363, .external_lex_state = 12},
  [19811] = {.lex_state = 363, .external_lex_state = 12},
  [19812] = {.lex_state = 343, .external_lex_state = 12},
  [19813] = {.lex_state = 363, .external_lex_state = 12},
  [19814] = {.lex_state = 363, .external_lex_state = 12},
  [19815] = {.lex_state = 363, .external_lex_state = 12},
  [19816] = {.lex_state = 0, .external_lex_state = 12},
  [19817] = {.lex_state = 0, .external_lex_state = 12},
  [19818] = {.lex_state = 343, .external_lex_state = 12},
  [19819] = {.lex_state = 363, .external_lex_state = 12},
  [19820] = {.lex_state = 363, .external_lex_state = 12},
  [19821] = {.lex_state = 0, .external_lex_state = 12},
  [19822] = {.lex_state = 0, .external_lex_state = 12},
  [19823] = {.lex_state = 0, .external_lex_state = 12},
  [19824] = {.lex_state = 363, .external_lex_state = 12},
  [19825] = {.lex_state = 0, .external_lex_state = 12},
  [19826] = {.lex_state = 0, .external_lex_state = 12},
  [19827] = {.lex_state = 0, .external_lex_state = 12},
  [19828] = {.lex_state = 0, .external_lex_state = 12},
  [19829] = {.lex_state = 343, .external_lex_state = 12},
  [19830] = {.lex_state = 0, .external_lex_state = 12},
  [19831] = {.lex_state = 0, .external_lex_state = 12},
  [19832] = {.lex_state = 363, .external_lex_state = 12},
  [19833] = {.lex_state = 0, .external_lex_state = 12},
  [19834] = {.lex_state = 0, .external_lex_state = 12},
  [19835] = {.lex_state = 0, .external_lex_state = 12},
  [19836] = {.lex_state = 363, .external_lex_state = 12},
  [19837] = {.lex_state = 0, .external_lex_state = 12},
  [19838] = {.lex_state = 343, .external_lex_state = 12},
  [19839] = {.lex_state = 363, .external_lex_state = 12},
  [19840] = {.lex_state = 363, .external_lex_state = 12},
  [19841] = {.lex_state = 0, .external_lex_state = 12},
  [19842] = {.lex_state = 0, .external_lex_state = 12},
  [19843] = {.lex_state = 0, .external_lex_state = 12},
  [19844] = {.lex_state = 0, .external_lex_state = 12},
  [19845] = {.lex_state = 0, .external_lex_state = 12},
  [19846] = {.lex_state = 363, .external_lex_state = 12},
  [19847] = {.lex_state = 343, .external_lex_state = 12},
  [19848] = {.lex_state = 363, .external_lex_state = 12},
  [19849] = {.lex_state = 363, .external_lex_state = 12},
  [19850] = {.lex_state = 343, .external_lex_state = 12},
  [19851] = {.lex_state = 363, .external_lex_state = 12},
  [19852] = {.lex_state = 363, .external_lex_state = 12},
  [19853] = {.lex_state = 0, .external_lex_state = 12},
  [19854] = {.lex_state = 363, .external_lex_state = 12},
  [19855] = {.lex_state = 409, .external_lex_state = 12},
  [19856] = {.lex_state = 343, .external_lex_state = 12},
  [19857] = {.lex_state = 363, .external_lex_state = 12},
  [19858] = {.lex_state = 363, .external_lex_state = 12},
  [19859] = {.lex_state = 343, .external_lex_state = 12},
  [19860] = {.lex_state = 0, .external_lex_state = 12},
  [19861] = {.lex_state = 363, .external_lex_state = 12},
  [19862] = {.lex_state = 343, .external_lex_state = 12},
  [19863] = {.lex_state = 0, .external_lex_state = 12},
  [19864] = {.lex_state = 0, .external_lex_state = 12},
  [19865] = {.lex_state = 343, .external_lex_state = 12},
  [19866] = {.lex_state = 0, .external_lex_state = 12},
  [19867] = {.lex_state = 0, .external_lex_state = 12},
  [19868] = {.lex_state = 343, .external_lex_state = 12},
  [19869] = {.lex_state = 363, .external_lex_state = 12},
  [19870] = {.lex_state = 363, .external_lex_state = 12},
  [19871] = {.lex_state = 343, .external_lex_state = 12},
  [19872] = {.lex_state = 0, .external_lex_state = 12},
  [19873] = {.lex_state = 0, .external_lex_state = 12},
  [19874] = {.lex_state = 0, .external_lex_state = 12},
  [19875] = {.lex_state = 363, .external_lex_state = 12},
  [19876] = {.lex_state = 0, .external_lex_state = 12},
  [19877] = {.lex_state = 363, .external_lex_state = 12},
  [19878] = {.lex_state = 0, .external_lex_state = 12},
  [19879] = {.lex_state = 363, .external_lex_state = 12},
  [19880] = {.lex_state = 343, .external_lex_state = 12},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__word_identifier] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_baremodule] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_primitive] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_LT_COLON] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_macro] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_quote] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [sym_break_statement] = ACTIONS(1),
    [sym_continue_statement] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COLON2] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_outer] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_u2208] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [aux_sym_quote_expression_token1] = ACTIONS(1),
    [anon_sym_isa] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [aux_sym_integer_literal_token1] = ACTIONS(1),
    [aux_sym_integer_literal_token2] = ACTIONS(1),
    [aux_sym_integer_literal_token3] = ACTIONS(1),
    [aux_sym_integer_literal_token4] = ACTIONS(1),
    [aux_sym_float_literal_token1] = ACTIONS(1),
    [aux_sym_float_literal_token2] = ACTIONS(1),
    [aux_sym_float_literal_token3] = ACTIONS(1),
    [aux_sym_float_literal_token4] = ACTIONS(1),
    [sym_character_literal] = ACTIONS(1),
    [sym__assignment_operator] = ACTIONS(1),
    [sym__pair_operator] = ACTIONS(1),
    [sym__arrow_operator] = ACTIONS(1),
    [sym__lazy_or_operator] = ACTIONS(1),
    [sym__lazy_and_operator] = ACTIONS(1),
    [sym__comparison_operator] = ACTIONS(1),
    [sym__pipe_right_operator] = ACTIONS(1),
    [sym__pipe_left_operator] = ACTIONS(1),
    [sym__ellipsis_operator] = ACTIONS(1),
    [sym__plus_operator] = ACTIONS(1),
    [sym__times_operator] = ACTIONS(1),
    [sym__rational_operator] = ACTIONS(1),
    [sym__bitshift_operator] = ACTIONS(1),
    [sym__power_operator] = ACTIONS(1),
    [sym__tilde_operator] = ACTIONS(1),
    [sym__type_order_operator] = ACTIONS(1),
    [sym__unary_operator] = ACTIONS(1),
    [sym__unary_plus_operator] = ACTIONS(1),
    [aux_sym__terminator_token1] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1),
    [sym__immediate_bracket] = ACTIONS(1),
    [sym__immediate_brace] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__command_start] = ACTIONS(1),
    [sym__immediate_string_start] = ACTIONS(1),
    [sym__immediate_command_start] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [sym__command_end] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_content_no_interp] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(18432),
    [sym__block] = STATE(19755),
    [sym_assignment] = STATE(16526),
    [sym_open_tuple] = STATE(15404),
    [sym__expression] = STATE(13104),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11340),
    [sym__array] = STATE(11340),
    [sym_comprehension_expression] = STATE(11340),
    [sym_matrix_expression] = STATE(11340),
    [sym_vector_expression] = STATE(11340),
    [sym_parenthesized_expression] = STATE(11340),
    [sym_tuple_expression] = STATE(11340),
    [sym_curly_expression] = STATE(11340),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11340),
    [sym_index_expression] = STATE(11340),
    [sym_parametrized_type_expression] = STATE(11340),
    [sym_call_expression] = STATE(11340),
    [sym_broadcast_call_expression] = STATE(11340),
    [sym__closed_macrocall_expression] = STATE(11340),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11340),
    [sym_quote_expression] = STATE(11340),
    [sym_binary_expression] = STATE(13282),
    [sym_unary_expression] = STATE(13282),
    [sym_range_expression] = STATE(13282),
    [sym_splat_expression] = STATE(13282),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12936),
    [sym_unary_typed_expression] = STATE(13282),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13282),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11340),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11340),
    [sym_string_literal] = STATE(11340),
    [sym_command_literal] = STATE(11340),
    [sym_prefixed_string_literal] = STATE(11340),
    [sym_prefixed_command_literal] = STATE(11340),
    [sym_operator] = STATE(13018),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(75),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2] = {
    [sym__block] = STATE(17052),
    [sym_assignment] = STATE(14658),
    [sym_open_tuple] = STATE(14519),
    [sym__expression] = STATE(12053),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10874),
    [sym__array] = STATE(10874),
    [sym_comprehension_expression] = STATE(10874),
    [sym_matrix_expression] = STATE(10874),
    [sym_vector_expression] = STATE(10874),
    [sym_parenthesized_expression] = STATE(10874),
    [sym_tuple_expression] = STATE(10874),
    [sym_curly_expression] = STATE(10874),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10874),
    [sym_index_expression] = STATE(10874),
    [sym_parametrized_type_expression] = STATE(10874),
    [sym_call_expression] = STATE(10874),
    [sym_broadcast_call_expression] = STATE(10874),
    [sym__closed_macrocall_expression] = STATE(10874),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10874),
    [sym_quote_expression] = STATE(10874),
    [sym_binary_expression] = STATE(12259),
    [sym_unary_expression] = STATE(12259),
    [sym_range_expression] = STATE(12259),
    [sym_splat_expression] = STATE(12259),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11948),
    [sym_unary_typed_expression] = STATE(12259),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12259),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10874),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10874),
    [sym_string_literal] = STATE(10874),
    [sym_command_literal] = STATE(10874),
    [sym_prefixed_string_literal] = STATE(10874),
    [sym_prefixed_command_literal] = STATE(10874),
    [sym_operator] = STATE(12127),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_end] = ACTIONS(99),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_else] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_finally] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LF] = ACTIONS(143),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(145),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [anon_sym_COLON_COLON] = ACTIONS(149),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(157),
    [aux_sym_integer_literal_token2] = ACTIONS(157),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(161),
    [aux_sym_float_literal_token3] = ACTIONS(161),
    [aux_sym_float_literal_token4] = ACTIONS(161),
    [sym_character_literal] = ACTIONS(163),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(165),
    [sym__type_order_operator] = ACTIONS(165),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [aux_sym__terminator_token1] = ACTIONS(167),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
    [sym__immediate_string_start] = ACTIONS(177),
    [sym__immediate_command_start] = ACTIONS(179),
  },
  [3] = {
    [sym__block] = STATE(17052),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(99),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(199),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(207),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(221),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
    [sym__immediate_string_start] = ACTIONS(223),
    [sym__immediate_command_start] = ACTIONS(225),
  },
  [4] = {
    [sym_assignment] = STATE(110),
    [sym_open_tuple] = STATE(8036),
    [sym__expression] = STATE(7276),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_macro_argument_list] = STATE(12547),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [aux_sym_macro_argument_list_repeat1] = STATE(110),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(295),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(299),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(301),
    [sym__immediate_bracket] = ACTIONS(303),
    [sym__immediate_brace] = ACTIONS(305),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [5] = {
    [sym_assignment] = STATE(110),
    [sym_open_tuple] = STATE(8036),
    [sym__expression] = STATE(7276),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_macro_argument_list] = STATE(12670),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [aux_sym_macro_argument_list_repeat1] = STATE(110),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(311),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(295),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(299),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(315),
    [sym__immediate_bracket] = ACTIONS(317),
    [sym__immediate_brace] = ACTIONS(319),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [6] = {
    [sym_assignment] = STATE(112),
    [sym_open_tuple] = STATE(8028),
    [sym__expression] = STATE(7271),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_macro_argument_list] = STATE(7362),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [aux_sym_macro_argument_list_repeat1] = STATE(112),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(229),
    [anon_sym_else] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(387),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(393),
    [sym__immediate_bracket] = ACTIONS(395),
    [sym__immediate_brace] = ACTIONS(397),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [7] = {
    [sym_assignment] = STATE(112),
    [sym_open_tuple] = STATE(8028),
    [sym__expression] = STATE(7271),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_macro_argument_list] = STATE(7518),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [aux_sym_macro_argument_list_repeat1] = STATE(112),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(311),
    [anon_sym_else] = ACTIONS(311),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(387),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(403),
    [sym__immediate_bracket] = ACTIONS(405),
    [sym__immediate_brace] = ACTIONS(407),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [8] = {
    [sym_assignment] = STATE(121),
    [sym_open_tuple] = STATE(8023),
    [sym__expression] = STATE(7265),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(7773),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [aux_sym_macro_argument_list_repeat1] = STATE(121),
    [ts_builtin_sym_end] = ACTIONS(279),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(229),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(229),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(475),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(481),
    [sym__immediate_bracket] = ACTIONS(483),
    [sym__immediate_brace] = ACTIONS(485),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [9] = {
    [sym_assignment] = STATE(121),
    [sym_open_tuple] = STATE(8023),
    [sym__expression] = STATE(7265),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(7837),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [aux_sym_macro_argument_list_repeat1] = STATE(121),
    [ts_builtin_sym_end] = ACTIONS(313),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(475),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(491),
    [sym__immediate_bracket] = ACTIONS(493),
    [sym__immediate_brace] = ACTIONS(495),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [10] = {
    [sym_assignment] = STATE(108),
    [sym_open_tuple] = STATE(8028),
    [sym__expression] = STATE(7271),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [aux_sym_macro_argument_list_repeat1] = STATE(108),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(229),
    [anon_sym_else] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(387),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [11] = {
    [sym_assignment] = STATE(108),
    [sym_open_tuple] = STATE(8028),
    [sym__expression] = STATE(7271),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [aux_sym_macro_argument_list_repeat1] = STATE(108),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(311),
    [anon_sym_else] = ACTIONS(311),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(387),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [12] = {
    [sym_assignment] = STATE(113),
    [sym_open_tuple] = STATE(8036),
    [sym__expression] = STATE(7276),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_macro_argument_list] = STATE(7405),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [aux_sym_macro_argument_list_repeat1] = STATE(113),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(295),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(299),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(509),
    [sym__immediate_bracket] = ACTIONS(511),
    [sym__immediate_brace] = ACTIONS(513),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [13] = {
    [sym_assignment] = STATE(113),
    [sym_open_tuple] = STATE(8036),
    [sym__expression] = STATE(7276),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_macro_argument_list] = STATE(7473),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [aux_sym_macro_argument_list_repeat1] = STATE(113),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(311),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(295),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(299),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(515),
    [sym__immediate_bracket] = ACTIONS(517),
    [sym__immediate_brace] = ACTIONS(519),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [14] = {
    [sym_assignment] = STATE(153),
    [sym_open_tuple] = STATE(7634),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_macro_argument_list] = STATE(7362),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [aux_sym_macro_argument_list_repeat1] = STATE(153),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(229),
    [anon_sym_else] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(529),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(393),
    [sym__immediate_bracket] = ACTIONS(395),
    [sym__immediate_brace] = ACTIONS(397),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [15] = {
    [sym_assignment] = STATE(133),
    [sym_open_tuple] = STATE(8662),
    [sym__expression] = STATE(8090),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_macro_argument_list] = STATE(8208),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [aux_sym_macro_argument_list_repeat1] = STATE(133),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(597),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(601),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(603),
    [sym__immediate_bracket] = ACTIONS(605),
    [sym__immediate_brace] = ACTIONS(607),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [16] = {
    [sym_assignment] = STATE(158),
    [sym_open_tuple] = STATE(7634),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [aux_sym_macro_argument_list_repeat1] = STATE(158),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(229),
    [anon_sym_else] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(529),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [17] = {
    [sym_assignment] = STATE(158),
    [sym_open_tuple] = STATE(7634),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [aux_sym_macro_argument_list_repeat1] = STATE(158),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(311),
    [anon_sym_else] = ACTIONS(311),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(529),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [18] = {
    [sym_assignment] = STATE(130),
    [sym_open_tuple] = STATE(8623),
    [sym__expression] = STATE(8085),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [aux_sym_macro_argument_list_repeat1] = STATE(130),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(229),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(679),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(683),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [19] = {
    [sym_assignment] = STATE(130),
    [sym_open_tuple] = STATE(8623),
    [sym__expression] = STATE(8085),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [aux_sym_macro_argument_list_repeat1] = STATE(130),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(311),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(679),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(683),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [20] = {
    [sym_assignment] = STATE(153),
    [sym_open_tuple] = STATE(7634),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_macro_argument_list] = STATE(7518),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [aux_sym_macro_argument_list_repeat1] = STATE(153),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(311),
    [anon_sym_else] = ACTIONS(311),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(529),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(403),
    [sym__immediate_bracket] = ACTIONS(405),
    [sym__immediate_brace] = ACTIONS(407),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [21] = {
    [sym_assignment] = STATE(139),
    [sym_open_tuple] = STATE(8650),
    [sym__expression] = STATE(8089),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [aux_sym_macro_argument_list_repeat1] = STATE(139),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(755),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(759),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [22] = {
    [sym_assignment] = STATE(139),
    [sym_open_tuple] = STATE(8650),
    [sym__expression] = STATE(8089),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [aux_sym_macro_argument_list_repeat1] = STATE(139),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(755),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(759),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [23] = {
    [sym_assignment] = STATE(132),
    [sym_open_tuple] = STATE(8662),
    [sym__expression] = STATE(8090),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [aux_sym_macro_argument_list_repeat1] = STATE(132),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(597),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(601),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [24] = {
    [sym_assignment] = STATE(132),
    [sym_open_tuple] = STATE(8662),
    [sym__expression] = STATE(8090),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [aux_sym_macro_argument_list_repeat1] = STATE(132),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(597),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(601),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [25] = {
    [sym_assignment] = STATE(152),
    [sym_open_tuple] = STATE(7995),
    [sym__expression] = STATE(7996),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_macro_argument_list] = STATE(12547),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [aux_sym_macro_argument_list_repeat1] = STATE(152),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(773),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(299),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(301),
    [sym__immediate_bracket] = ACTIONS(303),
    [sym__immediate_brace] = ACTIONS(305),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [26] = {
    [sym_assignment] = STATE(134),
    [sym_open_tuple] = STATE(7995),
    [sym__expression] = STATE(7996),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_macro_argument_list] = STATE(7405),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [aux_sym_macro_argument_list_repeat1] = STATE(134),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(229),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(773),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(299),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(509),
    [sym__immediate_bracket] = ACTIONS(511),
    [sym__immediate_brace] = ACTIONS(513),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [27] = {
    [sym_assignment] = STATE(134),
    [sym_open_tuple] = STATE(7995),
    [sym__expression] = STATE(7996),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_macro_argument_list] = STATE(7473),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [aux_sym_macro_argument_list_repeat1] = STATE(134),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(311),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(773),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(299),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(515),
    [sym__immediate_bracket] = ACTIONS(517),
    [sym__immediate_brace] = ACTIONS(519),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [28] = {
    [sym_assignment] = STATE(152),
    [sym_open_tuple] = STATE(7995),
    [sym__expression] = STATE(7996),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_macro_argument_list] = STATE(12670),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [aux_sym_macro_argument_list_repeat1] = STATE(152),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(311),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(773),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(299),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(315),
    [sym__immediate_bracket] = ACTIONS(317),
    [sym__immediate_brace] = ACTIONS(319),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [29] = {
    [sym_assignment] = STATE(140),
    [sym_open_tuple] = STATE(8623),
    [sym__expression] = STATE(8085),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_macro_argument_list] = STATE(8338),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [aux_sym_macro_argument_list_repeat1] = STATE(140),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(229),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(679),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(683),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(775),
    [sym__immediate_bracket] = ACTIONS(777),
    [sym__immediate_brace] = ACTIONS(779),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [30] = {
    [sym_assignment] = STATE(140),
    [sym_open_tuple] = STATE(8623),
    [sym__expression] = STATE(8085),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_macro_argument_list] = STATE(8449),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [aux_sym_macro_argument_list_repeat1] = STATE(140),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(311),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(679),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(683),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(781),
    [sym__immediate_bracket] = ACTIONS(783),
    [sym__immediate_brace] = ACTIONS(785),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [31] = {
    [sym_assignment] = STATE(141),
    [sym_open_tuple] = STATE(7835),
    [sym__expression] = STATE(7836),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(7773),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [aux_sym_macro_argument_list_repeat1] = STATE(141),
    [ts_builtin_sym_end] = ACTIONS(279),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(229),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(229),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(795),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(481),
    [sym__immediate_bracket] = ACTIONS(483),
    [sym__immediate_brace] = ACTIONS(485),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [32] = {
    [sym_assignment] = STATE(131),
    [sym_open_tuple] = STATE(8650),
    [sym__expression] = STATE(8089),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_macro_argument_list] = STATE(8466),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [aux_sym_macro_argument_list_repeat1] = STATE(131),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(755),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(759),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(797),
    [sym__immediate_bracket] = ACTIONS(799),
    [sym__immediate_brace] = ACTIONS(801),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [33] = {
    [sym_assignment] = STATE(131),
    [sym_open_tuple] = STATE(8650),
    [sym__expression] = STATE(8089),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_macro_argument_list] = STATE(8532),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [aux_sym_macro_argument_list_repeat1] = STATE(131),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(755),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(759),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(803),
    [sym__immediate_bracket] = ACTIONS(805),
    [sym__immediate_brace] = ACTIONS(807),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [34] = {
    [sym_assignment] = STATE(133),
    [sym_open_tuple] = STATE(8662),
    [sym__expression] = STATE(8090),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_macro_argument_list] = STATE(8132),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [aux_sym_macro_argument_list_repeat1] = STATE(133),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(597),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(601),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(809),
    [sym__immediate_bracket] = ACTIONS(811),
    [sym__immediate_brace] = ACTIONS(813),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [35] = {
    [sym_assignment] = STATE(141),
    [sym_open_tuple] = STATE(7835),
    [sym__expression] = STATE(7836),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(7837),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [aux_sym_macro_argument_list_repeat1] = STATE(141),
    [ts_builtin_sym_end] = ACTIONS(313),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(795),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(491),
    [sym__immediate_bracket] = ACTIONS(493),
    [sym__immediate_brace] = ACTIONS(495),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [36] = {
    [sym_assignment] = STATE(183),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11960),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(183),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(893),
    [sym__immediate_bracket] = ACTIONS(895),
    [sym__immediate_brace] = ACTIONS(897),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [37] = {
    [sym_assignment] = STATE(175),
    [sym_open_tuple] = STATE(8023),
    [sym__expression] = STATE(7265),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [aux_sym_macro_argument_list_repeat1] = STATE(175),
    [ts_builtin_sym_end] = ACTIONS(279),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(475),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [38] = {
    [sym_assignment] = STATE(171),
    [sym_open_tuple] = STATE(8336),
    [sym__expression] = STATE(8337),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_macro_argument_list] = STATE(8466),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [aux_sym_macro_argument_list_repeat1] = STATE(171),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(911),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(759),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(797),
    [sym__immediate_bracket] = ACTIONS(799),
    [sym__immediate_brace] = ACTIONS(801),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [39] = {
    [sym_assignment] = STATE(171),
    [sym_open_tuple] = STATE(8336),
    [sym__expression] = STATE(8337),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_macro_argument_list] = STATE(8532),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [aux_sym_macro_argument_list_repeat1] = STATE(171),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(911),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(759),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(803),
    [sym__immediate_bracket] = ACTIONS(805),
    [sym__immediate_brace] = ACTIONS(807),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [40] = {
    [sym_assignment] = STATE(173),
    [sym_open_tuple] = STATE(8306),
    [sym__expression] = STATE(8307),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_macro_argument_list] = STATE(8132),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [aux_sym_macro_argument_list_repeat1] = STATE(173),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(921),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(601),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(809),
    [sym__immediate_bracket] = ACTIONS(811),
    [sym__immediate_brace] = ACTIONS(813),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [41] = {
    [sym_assignment] = STATE(173),
    [sym_open_tuple] = STATE(8306),
    [sym__expression] = STATE(8307),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_macro_argument_list] = STATE(8208),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [aux_sym_macro_argument_list_repeat1] = STATE(173),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(921),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(601),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(603),
    [sym__immediate_bracket] = ACTIONS(605),
    [sym__immediate_brace] = ACTIONS(607),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [42] = {
    [sym_assignment] = STATE(167),
    [sym_open_tuple] = STATE(9041),
    [sym__expression] = STATE(8750),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_macro_argument_list] = STATE(12295),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [aux_sym_macro_argument_list_repeat1] = STATE(167),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(229),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [43] = {
    [sym_assignment] = STATE(167),
    [sym_open_tuple] = STATE(9041),
    [sym__expression] = STATE(8750),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_macro_argument_list] = STATE(12314),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [aux_sym_macro_argument_list_repeat1] = STATE(167),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1005),
    [sym__immediate_bracket] = ACTIONS(1007),
    [sym__immediate_brace] = ACTIONS(1009),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [44] = {
    [sym_assignment] = STATE(175),
    [sym_open_tuple] = STATE(8023),
    [sym__expression] = STATE(7265),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [aux_sym_macro_argument_list_repeat1] = STATE(175),
    [ts_builtin_sym_end] = ACTIONS(313),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(475),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [45] = {
    [sym_assignment] = STATE(206),
    [sym_open_tuple] = STATE(8336),
    [sym__expression] = STATE(8337),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [aux_sym_macro_argument_list_repeat1] = STATE(206),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(911),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(759),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [46] = {
    [sym_assignment] = STATE(197),
    [sym_open_tuple] = STATE(8962),
    [sym__expression] = STATE(8728),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_macro_argument_list] = STATE(8983),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [aux_sym_macro_argument_list_repeat1] = STATE(197),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1075),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1081),
    [sym__immediate_bracket] = ACTIONS(1083),
    [sym__immediate_brace] = ACTIONS(1085),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [47] = {
    [sym_assignment] = STATE(197),
    [sym_open_tuple] = STATE(8962),
    [sym__expression] = STATE(8728),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_macro_argument_list] = STATE(9006),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [aux_sym_macro_argument_list_repeat1] = STATE(197),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1075),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1091),
    [sym__immediate_bracket] = ACTIONS(1093),
    [sym__immediate_brace] = ACTIONS(1095),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [48] = {
    [sym_assignment] = STATE(206),
    [sym_open_tuple] = STATE(8336),
    [sym__expression] = STATE(8337),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [aux_sym_macro_argument_list_repeat1] = STATE(206),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(911),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(759),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [49] = {
    [sym_assignment] = STATE(172),
    [sym_open_tuple] = STATE(8306),
    [sym__expression] = STATE(8307),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [aux_sym_macro_argument_list_repeat1] = STATE(172),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(921),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(601),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [50] = {
    [sym_assignment] = STATE(179),
    [sym_open_tuple] = STATE(8962),
    [sym__expression] = STATE(8728),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [aux_sym_macro_argument_list_repeat1] = STATE(179),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1075),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [51] = {
    [sym_assignment] = STATE(179),
    [sym_open_tuple] = STATE(8962),
    [sym__expression] = STATE(8728),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [aux_sym_macro_argument_list_repeat1] = STATE(179),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1075),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [52] = {
    [sym_assignment] = STATE(172),
    [sym_open_tuple] = STATE(8306),
    [sym__expression] = STATE(8307),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [aux_sym_macro_argument_list_repeat1] = STATE(172),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(921),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(601),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [53] = {
    [sym_assignment] = STATE(207),
    [sym_open_tuple] = STATE(8341),
    [sym__expression] = STATE(8343),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [aux_sym_macro_argument_list_repeat1] = STATE(207),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(311),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(1105),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(683),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [54] = {
    [sym_assignment] = STATE(183),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11867),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(183),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(313),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1107),
    [sym__immediate_bracket] = ACTIONS(1109),
    [sym__immediate_brace] = ACTIONS(1111),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [55] = {
    [sym_assignment] = STATE(210),
    [sym_open_tuple] = STATE(8341),
    [sym__expression] = STATE(8343),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_macro_argument_list] = STATE(8338),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [aux_sym_macro_argument_list_repeat1] = STATE(210),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(229),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(1105),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(683),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(775),
    [sym__immediate_bracket] = ACTIONS(777),
    [sym__immediate_brace] = ACTIONS(779),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [56] = {
    [sym_assignment] = STATE(210),
    [sym_open_tuple] = STATE(8341),
    [sym__expression] = STATE(8343),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_macro_argument_list] = STATE(8449),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [aux_sym_macro_argument_list_repeat1] = STATE(210),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(311),
    [anon_sym_finally] = ACTIONS(311),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(1105),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(683),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(781),
    [sym__immediate_bracket] = ACTIONS(783),
    [sym__immediate_brace] = ACTIONS(785),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [57] = {
    [sym_assignment] = STATE(207),
    [sym_open_tuple] = STATE(8341),
    [sym__expression] = STATE(8343),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [aux_sym_macro_argument_list_repeat1] = STATE(207),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(229),
    [anon_sym_finally] = ACTIONS(229),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(1105),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(683),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [58] = {
    [sym_assignment] = STATE(169),
    [sym_open_tuple] = STATE(9041),
    [sym__expression] = STATE(8750),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_macro_argument_list] = STATE(9117),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [aux_sym_macro_argument_list_repeat1] = STATE(169),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(229),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1113),
    [sym__immediate_bracket] = ACTIONS(1115),
    [sym__immediate_brace] = ACTIONS(1117),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [59] = {
    [sym_assignment] = STATE(169),
    [sym_open_tuple] = STATE(9041),
    [sym__expression] = STATE(8750),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_macro_argument_list] = STATE(8845),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [aux_sym_macro_argument_list_repeat1] = STATE(169),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1119),
    [sym__immediate_bracket] = ACTIONS(1121),
    [sym__immediate_brace] = ACTIONS(1123),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [60] = {
    [sym_assignment] = STATE(178),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(8533),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(178),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1125),
    [sym__immediate_bracket] = ACTIONS(1127),
    [sym__immediate_brace] = ACTIONS(1129),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [61] = {
    [sym_assignment] = STATE(178),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(8729),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(178),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(313),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1131),
    [sym__immediate_bracket] = ACTIONS(1133),
    [sym__immediate_brace] = ACTIONS(1135),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [62] = {
    [sym_assignment] = STATE(168),
    [sym_open_tuple] = STATE(8023),
    [sym__expression] = STATE(7265),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [aux_sym_macro_argument_list_repeat1] = STATE(168),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(229),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(229),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(475),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [63] = {
    [sym_assignment] = STATE(168),
    [sym_open_tuple] = STATE(8023),
    [sym__expression] = STATE(7265),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [aux_sym_macro_argument_list_repeat1] = STATE(168),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(475),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [64] = {
    [sym_assignment] = STATE(213),
    [sym_open_tuple] = STATE(9032),
    [sym__expression] = STATE(9033),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [aux_sym_macro_argument_list_repeat1] = STATE(213),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1145),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [65] = {
    [sym_assignment] = STATE(227),
    [sym_open_tuple] = STATE(9152),
    [sym__expression] = STATE(9133),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11867),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(227),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1107),
    [sym__immediate_bracket] = ACTIONS(1109),
    [sym__immediate_brace] = ACTIONS(1111),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [66] = {
    [sym_assignment] = STATE(237),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11960),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(237),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(893),
    [sym__immediate_bracket] = ACTIONS(895),
    [sym__immediate_brace] = ACTIONS(897),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [67] = {
    [sym_assignment] = STATE(245),
    [sym_open_tuple] = STATE(8794),
    [sym__expression] = STATE(8795),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_macro_argument_list] = STATE(9117),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [aux_sym_macro_argument_list_repeat1] = STATE(245),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(229),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(1181),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1113),
    [sym__immediate_bracket] = ACTIONS(1115),
    [sym__immediate_brace] = ACTIONS(1117),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [68] = {
    [sym_assignment] = STATE(245),
    [sym_open_tuple] = STATE(8794),
    [sym__expression] = STATE(8795),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_macro_argument_list] = STATE(8845),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [aux_sym_macro_argument_list_repeat1] = STATE(245),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(1181),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1119),
    [sym__immediate_bracket] = ACTIONS(1121),
    [sym__immediate_brace] = ACTIONS(1123),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [69] = {
    [sym_assignment] = STATE(237),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11867),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(237),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(313),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1107),
    [sym__immediate_bracket] = ACTIONS(1109),
    [sym__immediate_brace] = ACTIONS(1111),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [70] = {
    [sym__block] = STATE(15062),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(15065),
    [sym_else_clause] = STATE(18636),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(15065),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1187),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1261),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [71] = {
    [sym_assignment] = STATE(218),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(8533),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(218),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1125),
    [sym__immediate_bracket] = ACTIONS(1127),
    [sym__immediate_brace] = ACTIONS(1129),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [72] = {
    [sym_assignment] = STATE(218),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(8729),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(218),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(313),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1131),
    [sym__immediate_bracket] = ACTIONS(1133),
    [sym__immediate_brace] = ACTIONS(1135),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [73] = {
    [sym_assignment] = STATE(243),
    [sym_open_tuple] = STATE(8794),
    [sym__expression] = STATE(8795),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_macro_argument_list] = STATE(12295),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [aux_sym_macro_argument_list_repeat1] = STATE(243),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(229),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(1181),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [74] = {
    [sym_assignment] = STATE(243),
    [sym_open_tuple] = STATE(8794),
    [sym__expression] = STATE(8795),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_macro_argument_list] = STATE(12314),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [aux_sym_macro_argument_list_repeat1] = STATE(243),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(1181),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1005),
    [sym__immediate_bracket] = ACTIONS(1007),
    [sym__immediate_brace] = ACTIONS(1009),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [75] = {
    [sym__block] = STATE(19552),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1267),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1271),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [76] = {
    [sym__block] = STATE(18620),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1273),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1277),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [77] = {
    [sym__block] = STATE(14996),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(15047),
    [sym_else_clause] = STATE(18202),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(15047),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1279),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1281),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1283),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [78] = {
    [sym__block] = STATE(14698),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14700),
    [sym_else_clause] = STATE(18803),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14700),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1285),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1289),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [79] = {
    [sym_assignment] = STATE(213),
    [sym_open_tuple] = STATE(9032),
    [sym__expression] = STATE(9033),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [aux_sym_macro_argument_list_repeat1] = STATE(213),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1145),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [80] = {
    [sym_assignment] = STATE(214),
    [sym_open_tuple] = STATE(9032),
    [sym__expression] = STATE(9033),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_macro_argument_list] = STATE(8983),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [aux_sym_macro_argument_list_repeat1] = STATE(214),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(229),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1145),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1081),
    [sym__immediate_bracket] = ACTIONS(1083),
    [sym__immediate_brace] = ACTIONS(1085),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [81] = {
    [sym_assignment] = STATE(214),
    [sym_open_tuple] = STATE(9032),
    [sym__expression] = STATE(9033),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_macro_argument_list] = STATE(9006),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [aux_sym_macro_argument_list_repeat1] = STATE(214),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(311),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1145),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1091),
    [sym__immediate_bracket] = ACTIONS(1093),
    [sym__immediate_brace] = ACTIONS(1095),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [82] = {
    [sym_assignment] = STATE(219),
    [sym_open_tuple] = STATE(9152),
    [sym__expression] = STATE(9133),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(8533),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(219),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1125),
    [sym__immediate_bracket] = ACTIONS(1127),
    [sym__immediate_brace] = ACTIONS(1129),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [83] = {
    [sym_assignment] = STATE(219),
    [sym_open_tuple] = STATE(9152),
    [sym__expression] = STATE(9133),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(8729),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(219),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1131),
    [sym__immediate_bracket] = ACTIONS(1133),
    [sym__immediate_brace] = ACTIONS(1135),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [84] = {
    [sym_assignment] = STATE(229),
    [sym_open_tuple] = STATE(7835),
    [sym__expression] = STATE(7836),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [aux_sym_macro_argument_list_repeat1] = STATE(229),
    [ts_builtin_sym_end] = ACTIONS(313),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(795),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [aux_sym__terminator_token1] = ACTIONS(311),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [85] = {
    [sym_assignment] = STATE(229),
    [sym_open_tuple] = STATE(7835),
    [sym__expression] = STATE(7836),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [aux_sym_macro_argument_list_repeat1] = STATE(229),
    [ts_builtin_sym_end] = ACTIONS(279),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(795),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [aux_sym__terminator_token1] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [86] = {
    [sym__block] = STATE(18637),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1291),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1293),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1295),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [87] = {
    [sym_assignment] = STATE(244),
    [sym_open_tuple] = STATE(7835),
    [sym__expression] = STATE(7836),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(10878),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [aux_sym_macro_argument_list_repeat1] = STATE(244),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(229),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(229),
    [anon_sym_LF] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_QMARK] = ACTIONS(229),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(795),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(229),
    [sym__lazy_and_operator] = ACTIONS(229),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(497),
    [sym__immediate_bracket] = ACTIONS(499),
    [sym__immediate_brace] = ACTIONS(501),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [88] = {
    [sym__block] = STATE(14675),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14676),
    [sym_else_clause] = STATE(18195),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14676),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1297),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1299),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1301),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [89] = {
    [sym_assignment] = STATE(244),
    [sym_open_tuple] = STATE(7835),
    [sym__expression] = STATE(7836),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_macro_argument_list] = STATE(10875),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [aux_sym_macro_argument_list_repeat1] = STATE(244),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(311),
    [anon_sym_QMARK] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(795),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(311),
    [sym__lazy_and_operator] = ACTIONS(311),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(503),
    [sym__immediate_bracket] = ACTIONS(505),
    [sym__immediate_brace] = ACTIONS(507),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [90] = {
    [sym__block] = STATE(14815),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14816),
    [sym_else_clause] = STATE(18954),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14816),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1303),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1307),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [91] = {
    [sym_assignment] = STATE(227),
    [sym_open_tuple] = STATE(9152),
    [sym__expression] = STATE(9133),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11960),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(227),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(893),
    [sym__immediate_bracket] = ACTIONS(895),
    [sym__immediate_brace] = ACTIONS(897),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [92] = {
    [sym_assignment] = STATE(217),
    [sym_open_tuple] = STATE(9152),
    [sym__expression] = STATE(9133),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11960),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(217),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(893),
    [sym__immediate_bracket] = ACTIONS(895),
    [sym__immediate_brace] = ACTIONS(897),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [93] = {
    [sym_assignment] = STATE(217),
    [sym_open_tuple] = STATE(9152),
    [sym__expression] = STATE(9133),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11867),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(217),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1107),
    [sym__immediate_bracket] = ACTIONS(1109),
    [sym__immediate_brace] = ACTIONS(1111),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [94] = {
    [sym__block] = STATE(14922),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14925),
    [sym_else_clause] = STATE(19839),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14925),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1309),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1311),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1313),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [95] = {
    [sym__block] = STATE(14995),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14997),
    [sym_else_clause] = STATE(18171),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14997),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1315),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1317),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1319),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [96] = {
    [sym__block] = STATE(15052),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(15053),
    [sym_else_clause] = STATE(18538),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(15053),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1321),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1323),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1325),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [97] = {
    [sym__block] = STATE(15096),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(15097),
    [sym_else_clause] = STATE(19009),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(15097),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1327),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1329),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1331),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [98] = {
    [sym__block] = STATE(15135),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(15136),
    [sym_else_clause] = STATE(19551),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(15136),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1333),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1337),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [99] = {
    [sym__block] = STATE(14646),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14661),
    [sym_else_clause] = STATE(19475),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14661),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1339),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1341),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1343),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [100] = {
    [sym__block] = STATE(19126),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(1265),
    [anon_sym_LF] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1349),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [101] = {
    [sym__block] = STATE(14630),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14634),
    [sym_else_clause] = STATE(18976),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14634),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1355),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [102] = {
    [sym__block] = STATE(14556),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14557),
    [sym_else_clause] = STATE(19129),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14557),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1357),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1359),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(1361),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [103] = {
    [sym_assignment] = STATE(274),
    [sym_open_tuple] = STATE(9165),
    [sym__expression] = STATE(9171),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11867),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [aux_sym_macro_argument_list_repeat1] = STATE(274),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1107),
    [sym__immediate_bracket] = ACTIONS(1109),
    [sym__immediate_brace] = ACTIONS(1111),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [104] = {
    [sym_assignment] = STATE(281),
    [sym_open_tuple] = STATE(9165),
    [sym__expression] = STATE(9171),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(8729),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [aux_sym_macro_argument_list_repeat1] = STATE(281),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1131),
    [sym__immediate_bracket] = ACTIONS(1133),
    [sym__immediate_brace] = ACTIONS(1135),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [105] = {
    [sym__block] = STATE(18542),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1373),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1375),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1377),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [106] = {
    [sym__block] = STATE(19595),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1379),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1381),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1383),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [107] = {
    [sym_assignment] = STATE(107),
    [sym_open_tuple] = STATE(8036),
    [sym__expression] = STATE(7276),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [aux_sym_macro_argument_list_repeat1] = STATE(107),
    [sym__word_identifier] = ACTIONS(1385),
    [anon_sym_EQ] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1390),
    [anon_sym_begin] = ACTIONS(1393),
    [anon_sym_module] = ACTIONS(1396),
    [anon_sym_baremodule] = ACTIONS(1396),
    [anon_sym_end] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(1399),
    [anon_sym_primitive] = ACTIONS(1402),
    [anon_sym_mutable] = ACTIONS(1405),
    [anon_sym_struct] = ACTIONS(1408),
    [anon_sym_function] = ACTIONS(1411),
    [anon_sym_macro] = ACTIONS(1414),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(1417),
    [anon_sym_let] = ACTIONS(1420),
    [anon_sym_if] = ACTIONS(1423),
    [anon_sym_else] = ACTIONS(1388),
    [anon_sym_try] = ACTIONS(1426),
    [anon_sym_finally] = ACTIONS(1388),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1432),
    [sym_break_statement] = ACTIONS(1435),
    [sym_continue_statement] = ACTIONS(1435),
    [anon_sym_return] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1441),
    [anon_sym_global] = ACTIONS(1444),
    [anon_sym_local] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1453),
    [anon_sym_import] = ACTIONS(1456),
    [anon_sym_using] = ACTIONS(1456),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_DOLLAR] = ACTIONS(1467),
    [anon_sym_COLON_COLON] = ACTIONS(1470),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1473),
    [anon_sym_true] = ACTIONS(1476),
    [anon_sym_false] = ACTIONS(1476),
    [aux_sym_integer_literal_token1] = ACTIONS(1479),
    [aux_sym_integer_literal_token2] = ACTIONS(1479),
    [aux_sym_integer_literal_token3] = ACTIONS(1479),
    [aux_sym_integer_literal_token4] = ACTIONS(1482),
    [aux_sym_float_literal_token1] = ACTIONS(1485),
    [aux_sym_float_literal_token3] = ACTIONS(1485),
    [aux_sym_float_literal_token4] = ACTIONS(1485),
    [sym_character_literal] = ACTIONS(1488),
    [sym__pair_operator] = ACTIONS(1491),
    [sym__arrow_operator] = ACTIONS(1491),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(1491),
    [sym__pipe_right_operator] = ACTIONS(1491),
    [sym__pipe_left_operator] = ACTIONS(1491),
    [sym__ellipsis_operator] = ACTIONS(1491),
    [sym__plus_operator] = ACTIONS(1491),
    [sym__times_operator] = ACTIONS(1491),
    [sym__rational_operator] = ACTIONS(1491),
    [sym__bitshift_operator] = ACTIONS(1491),
    [sym__power_operator] = ACTIONS(1491),
    [sym__tilde_operator] = ACTIONS(1494),
    [sym__type_order_operator] = ACTIONS(1494),
    [sym__unary_operator] = ACTIONS(1494),
    [sym__unary_plus_operator] = ACTIONS(1494),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1497),
    [sym__command_start] = ACTIONS(1500),
  },
  [108] = {
    [sym_assignment] = STATE(114),
    [sym_open_tuple] = STATE(8028),
    [sym__expression] = STATE(7271),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [aux_sym_macro_argument_list_repeat1] = STATE(114),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(1503),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(387),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [109] = {
    [sym_assignment] = STATE(109),
    [sym_open_tuple] = STATE(8023),
    [sym__expression] = STATE(7265),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [aux_sym_macro_argument_list_repeat1] = STATE(109),
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym__word_identifier] = ACTIONS(1507),
    [anon_sym_EQ] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1510),
    [anon_sym_begin] = ACTIONS(1513),
    [anon_sym_module] = ACTIONS(1516),
    [anon_sym_baremodule] = ACTIONS(1516),
    [anon_sym_abstract] = ACTIONS(1519),
    [anon_sym_primitive] = ACTIONS(1522),
    [anon_sym_mutable] = ACTIONS(1525),
    [anon_sym_struct] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1531),
    [anon_sym_macro] = ACTIONS(1534),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(1537),
    [anon_sym_let] = ACTIONS(1540),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_try] = ACTIONS(1546),
    [anon_sym_for] = ACTIONS(1549),
    [anon_sym_while] = ACTIONS(1552),
    [sym_break_statement] = ACTIONS(1555),
    [sym_continue_statement] = ACTIONS(1555),
    [anon_sym_return] = ACTIONS(1558),
    [anon_sym_const] = ACTIONS(1561),
    [anon_sym_global] = ACTIONS(1564),
    [anon_sym_local] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1388),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_import] = ACTIONS(1576),
    [anon_sym_using] = ACTIONS(1576),
    [anon_sym_LBRACK] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(1388),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_DOLLAR] = ACTIONS(1585),
    [anon_sym_COLON_COLON] = ACTIONS(1588),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1591),
    [anon_sym_true] = ACTIONS(1594),
    [anon_sym_false] = ACTIONS(1594),
    [aux_sym_integer_literal_token1] = ACTIONS(1597),
    [aux_sym_integer_literal_token2] = ACTIONS(1597),
    [aux_sym_integer_literal_token3] = ACTIONS(1597),
    [aux_sym_integer_literal_token4] = ACTIONS(1600),
    [aux_sym_float_literal_token1] = ACTIONS(1603),
    [aux_sym_float_literal_token3] = ACTIONS(1603),
    [aux_sym_float_literal_token4] = ACTIONS(1603),
    [sym_character_literal] = ACTIONS(1606),
    [sym__pair_operator] = ACTIONS(1609),
    [sym__arrow_operator] = ACTIONS(1609),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(1609),
    [sym__pipe_right_operator] = ACTIONS(1609),
    [sym__pipe_left_operator] = ACTIONS(1609),
    [sym__ellipsis_operator] = ACTIONS(1609),
    [sym__plus_operator] = ACTIONS(1609),
    [sym__times_operator] = ACTIONS(1609),
    [sym__rational_operator] = ACTIONS(1609),
    [sym__bitshift_operator] = ACTIONS(1609),
    [sym__power_operator] = ACTIONS(1609),
    [sym__tilde_operator] = ACTIONS(1612),
    [sym__type_order_operator] = ACTIONS(1612),
    [sym__unary_operator] = ACTIONS(1612),
    [sym__unary_plus_operator] = ACTIONS(1612),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1615),
    [sym__command_start] = ACTIONS(1618),
  },
  [110] = {
    [sym_assignment] = STATE(107),
    [sym_open_tuple] = STATE(8036),
    [sym__expression] = STATE(7276),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [aux_sym_macro_argument_list_repeat1] = STATE(107),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(295),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [111] = {
    [sym__block] = STATE(19126),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1349),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [112] = {
    [sym_assignment] = STATE(114),
    [sym_open_tuple] = STATE(8028),
    [sym__expression] = STATE(7271),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [aux_sym_macro_argument_list_repeat1] = STATE(114),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_elseif] = ACTIONS(1503),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [113] = {
    [sym_assignment] = STATE(107),
    [sym_open_tuple] = STATE(8036),
    [sym__expression] = STATE(7276),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [aux_sym_macro_argument_list_repeat1] = STATE(107),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [114] = {
    [sym_assignment] = STATE(114),
    [sym_open_tuple] = STATE(8028),
    [sym__expression] = STATE(7271),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [aux_sym_macro_argument_list_repeat1] = STATE(114),
    [sym__word_identifier] = ACTIONS(1621),
    [anon_sym_EQ] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1624),
    [anon_sym_begin] = ACTIONS(1627),
    [anon_sym_module] = ACTIONS(1630),
    [anon_sym_baremodule] = ACTIONS(1630),
    [anon_sym_end] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(1633),
    [anon_sym_primitive] = ACTIONS(1636),
    [anon_sym_mutable] = ACTIONS(1639),
    [anon_sym_struct] = ACTIONS(1642),
    [anon_sym_function] = ACTIONS(1645),
    [anon_sym_macro] = ACTIONS(1648),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(1651),
    [anon_sym_let] = ACTIONS(1654),
    [anon_sym_if] = ACTIONS(1657),
    [anon_sym_elseif] = ACTIONS(1388),
    [anon_sym_else] = ACTIONS(1388),
    [anon_sym_try] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1663),
    [anon_sym_while] = ACTIONS(1666),
    [sym_break_statement] = ACTIONS(1669),
    [sym_continue_statement] = ACTIONS(1669),
    [anon_sym_return] = ACTIONS(1672),
    [anon_sym_const] = ACTIONS(1675),
    [anon_sym_global] = ACTIONS(1678),
    [anon_sym_local] = ACTIONS(1681),
    [anon_sym_LPAREN] = ACTIONS(1684),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1687),
    [anon_sym_import] = ACTIONS(1690),
    [anon_sym_using] = ACTIONS(1690),
    [anon_sym_LBRACK] = ACTIONS(1693),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1696),
    [anon_sym_DOLLAR] = ACTIONS(1699),
    [anon_sym_COLON_COLON] = ACTIONS(1702),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1705),
    [anon_sym_true] = ACTIONS(1708),
    [anon_sym_false] = ACTIONS(1708),
    [aux_sym_integer_literal_token1] = ACTIONS(1711),
    [aux_sym_integer_literal_token2] = ACTIONS(1711),
    [aux_sym_integer_literal_token3] = ACTIONS(1711),
    [aux_sym_integer_literal_token4] = ACTIONS(1714),
    [aux_sym_float_literal_token1] = ACTIONS(1717),
    [aux_sym_float_literal_token3] = ACTIONS(1717),
    [aux_sym_float_literal_token4] = ACTIONS(1717),
    [sym_character_literal] = ACTIONS(1720),
    [sym__pair_operator] = ACTIONS(1723),
    [sym__arrow_operator] = ACTIONS(1723),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(1723),
    [sym__pipe_right_operator] = ACTIONS(1723),
    [sym__pipe_left_operator] = ACTIONS(1723),
    [sym__ellipsis_operator] = ACTIONS(1723),
    [sym__plus_operator] = ACTIONS(1723),
    [sym__times_operator] = ACTIONS(1723),
    [sym__rational_operator] = ACTIONS(1723),
    [sym__bitshift_operator] = ACTIONS(1723),
    [sym__power_operator] = ACTIONS(1723),
    [sym__tilde_operator] = ACTIONS(1726),
    [sym__type_order_operator] = ACTIONS(1726),
    [sym__unary_operator] = ACTIONS(1726),
    [sym__unary_plus_operator] = ACTIONS(1726),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1729),
    [sym__command_start] = ACTIONS(1732),
  },
  [115] = {
    [sym__block] = STATE(19010),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1735),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1737),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1739),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [116] = {
    [sym__block] = STATE(19126),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1265),
    [anon_sym_finally] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1349),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [117] = {
    [sym_assignment] = STATE(274),
    [sym_open_tuple] = STATE(9165),
    [sym__expression] = STATE(9171),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11960),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [aux_sym_macro_argument_list_repeat1] = STATE(274),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(893),
    [sym__immediate_bracket] = ACTIONS(895),
    [sym__immediate_brace] = ACTIONS(897),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [118] = {
    [sym_assignment] = STATE(280),
    [sym_open_tuple] = STATE(9165),
    [sym__expression] = STATE(9171),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11960),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [aux_sym_macro_argument_list_repeat1] = STATE(280),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(893),
    [sym__immediate_bracket] = ACTIONS(895),
    [sym__immediate_brace] = ACTIONS(897),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [119] = {
    [sym_assignment] = STATE(280),
    [sym_open_tuple] = STATE(9165),
    [sym__expression] = STATE(9171),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11867),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [aux_sym_macro_argument_list_repeat1] = STATE(280),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_SEMI] = ACTIONS(313),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1107),
    [sym__immediate_bracket] = ACTIONS(1109),
    [sym__immediate_brace] = ACTIONS(1111),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [120] = {
    [sym__block] = STATE(18431),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1741),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1743),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1745),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [121] = {
    [sym_assignment] = STATE(109),
    [sym_open_tuple] = STATE(8023),
    [sym__expression] = STATE(7265),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [aux_sym_macro_argument_list_repeat1] = STATE(109),
    [ts_builtin_sym_end] = ACTIONS(1505),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_RBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [122] = {
    [sym__block] = STATE(18637),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1291),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1293),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1295),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [123] = {
    [sym_assignment] = STATE(305),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11960),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(305),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(893),
    [sym__immediate_bracket] = ACTIONS(895),
    [sym__immediate_brace] = ACTIONS(897),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [124] = {
    [sym_assignment] = STATE(305),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11867),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(305),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1107),
    [sym__immediate_bracket] = ACTIONS(1109),
    [sym__immediate_brace] = ACTIONS(1111),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [125] = {
    [sym__block] = STATE(18620),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1273),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1277),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [126] = {
    [sym__block] = STATE(18163),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1747),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1749),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1751),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [127] = {
    [sym_assignment] = STATE(281),
    [sym_open_tuple] = STATE(9165),
    [sym__expression] = STATE(9171),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(8533),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [aux_sym_macro_argument_list_repeat1] = STATE(281),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_SEMI] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1125),
    [sym__immediate_bracket] = ACTIONS(1127),
    [sym__immediate_brace] = ACTIONS(1129),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [128] = {
    [sym__block] = STATE(19710),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1753),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1265),
    [anon_sym_finally] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1755),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1757),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [129] = {
    [sym__block] = STATE(19126),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1349),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [130] = {
    [sym_assignment] = STATE(136),
    [sym_open_tuple] = STATE(8623),
    [sym__expression] = STATE(8085),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [aux_sym_macro_argument_list_repeat1] = STATE(136),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(1503),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(679),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [131] = {
    [sym_assignment] = STATE(149),
    [sym_open_tuple] = STATE(8650),
    [sym__expression] = STATE(8089),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [aux_sym_macro_argument_list_repeat1] = STATE(149),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_catch] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [132] = {
    [sym_assignment] = STATE(137),
    [sym_open_tuple] = STATE(8662),
    [sym__expression] = STATE(8090),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [aux_sym_macro_argument_list_repeat1] = STATE(137),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(597),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [133] = {
    [sym_assignment] = STATE(137),
    [sym_open_tuple] = STATE(8662),
    [sym__expression] = STATE(8090),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [aux_sym_macro_argument_list_repeat1] = STATE(137),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [134] = {
    [sym_assignment] = STATE(155),
    [sym_open_tuple] = STATE(7995),
    [sym__expression] = STATE(7996),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [aux_sym_macro_argument_list_repeat1] = STATE(155),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [135] = {
    [sym_assignment] = STATE(12494),
    [sym_open_tuple] = STATE(12703),
    [sym__expression] = STATE(12112),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10677),
    [sym__array] = STATE(10677),
    [sym_comprehension_expression] = STATE(10677),
    [sym_matrix_expression] = STATE(10677),
    [sym_vector_expression] = STATE(10677),
    [sym_parenthesized_expression] = STATE(10677),
    [sym_tuple_expression] = STATE(10677),
    [sym_curly_expression] = STATE(10677),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10677),
    [sym_index_expression] = STATE(10677),
    [sym_parametrized_type_expression] = STATE(10677),
    [sym_call_expression] = STATE(10677),
    [sym_broadcast_call_expression] = STATE(10677),
    [sym__closed_macrocall_expression] = STATE(10677),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10677),
    [sym_quote_expression] = STATE(10677),
    [sym_binary_expression] = STATE(12304),
    [sym_unary_expression] = STATE(12304),
    [sym_range_expression] = STATE(12304),
    [sym_splat_expression] = STATE(12304),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11911),
    [sym_unary_typed_expression] = STATE(12304),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12304),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10677),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10677),
    [sym_string_literal] = STATE(10677),
    [sym_command_literal] = STATE(10677),
    [sym_prefixed_string_literal] = STATE(10677),
    [sym_prefixed_command_literal] = STATE(10677),
    [sym_operator] = STATE(12095),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_else] = ACTIONS(1759),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [anon_sym_COLON_COLON] = ACTIONS(149),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(157),
    [aux_sym_integer_literal_token2] = ACTIONS(157),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(161),
    [aux_sym_float_literal_token3] = ACTIONS(161),
    [aux_sym_float_literal_token4] = ACTIONS(161),
    [sym_character_literal] = ACTIONS(1771),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(165),
    [sym__type_order_operator] = ACTIONS(165),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [136] = {
    [sym_assignment] = STATE(136),
    [sym_open_tuple] = STATE(8623),
    [sym__expression] = STATE(8085),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [aux_sym_macro_argument_list_repeat1] = STATE(136),
    [sym__word_identifier] = ACTIONS(1773),
    [anon_sym_EQ] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1776),
    [anon_sym_begin] = ACTIONS(1779),
    [anon_sym_module] = ACTIONS(1782),
    [anon_sym_baremodule] = ACTIONS(1782),
    [anon_sym_abstract] = ACTIONS(1785),
    [anon_sym_primitive] = ACTIONS(1788),
    [anon_sym_mutable] = ACTIONS(1791),
    [anon_sym_struct] = ACTIONS(1794),
    [anon_sym_function] = ACTIONS(1797),
    [anon_sym_macro] = ACTIONS(1800),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(1803),
    [anon_sym_let] = ACTIONS(1806),
    [anon_sym_if] = ACTIONS(1809),
    [anon_sym_try] = ACTIONS(1812),
    [anon_sym_catch] = ACTIONS(1388),
    [anon_sym_finally] = ACTIONS(1388),
    [anon_sym_for] = ACTIONS(1815),
    [anon_sym_while] = ACTIONS(1818),
    [sym_break_statement] = ACTIONS(1821),
    [sym_continue_statement] = ACTIONS(1821),
    [anon_sym_return] = ACTIONS(1824),
    [anon_sym_const] = ACTIONS(1827),
    [anon_sym_global] = ACTIONS(1830),
    [anon_sym_local] = ACTIONS(1833),
    [anon_sym_LPAREN] = ACTIONS(1836),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1839),
    [anon_sym_import] = ACTIONS(1842),
    [anon_sym_using] = ACTIONS(1842),
    [anon_sym_LBRACK] = ACTIONS(1845),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1848),
    [anon_sym_DOLLAR] = ACTIONS(1851),
    [anon_sym_COLON_COLON] = ACTIONS(1854),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1860),
    [anon_sym_false] = ACTIONS(1860),
    [aux_sym_integer_literal_token1] = ACTIONS(1863),
    [aux_sym_integer_literal_token2] = ACTIONS(1863),
    [aux_sym_integer_literal_token3] = ACTIONS(1863),
    [aux_sym_integer_literal_token4] = ACTIONS(1866),
    [aux_sym_float_literal_token1] = ACTIONS(1869),
    [aux_sym_float_literal_token3] = ACTIONS(1869),
    [aux_sym_float_literal_token4] = ACTIONS(1869),
    [sym_character_literal] = ACTIONS(1872),
    [sym__pair_operator] = ACTIONS(1875),
    [sym__arrow_operator] = ACTIONS(1875),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(1875),
    [sym__pipe_right_operator] = ACTIONS(1875),
    [sym__pipe_left_operator] = ACTIONS(1875),
    [sym__ellipsis_operator] = ACTIONS(1875),
    [sym__plus_operator] = ACTIONS(1875),
    [sym__times_operator] = ACTIONS(1875),
    [sym__rational_operator] = ACTIONS(1875),
    [sym__bitshift_operator] = ACTIONS(1875),
    [sym__power_operator] = ACTIONS(1875),
    [sym__tilde_operator] = ACTIONS(1878),
    [sym__type_order_operator] = ACTIONS(1878),
    [sym__unary_operator] = ACTIONS(1878),
    [sym__unary_plus_operator] = ACTIONS(1878),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1881),
    [sym__command_start] = ACTIONS(1884),
  },
  [137] = {
    [sym_assignment] = STATE(137),
    [sym_open_tuple] = STATE(8662),
    [sym__expression] = STATE(8090),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [aux_sym_macro_argument_list_repeat1] = STATE(137),
    [sym__word_identifier] = ACTIONS(1887),
    [anon_sym_EQ] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1890),
    [anon_sym_begin] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1896),
    [anon_sym_baremodule] = ACTIONS(1896),
    [anon_sym_end] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(1899),
    [anon_sym_primitive] = ACTIONS(1902),
    [anon_sym_mutable] = ACTIONS(1905),
    [anon_sym_struct] = ACTIONS(1908),
    [anon_sym_function] = ACTIONS(1911),
    [anon_sym_macro] = ACTIONS(1914),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(1917),
    [anon_sym_let] = ACTIONS(1920),
    [anon_sym_if] = ACTIONS(1923),
    [anon_sym_try] = ACTIONS(1926),
    [anon_sym_finally] = ACTIONS(1388),
    [anon_sym_for] = ACTIONS(1929),
    [anon_sym_while] = ACTIONS(1932),
    [sym_break_statement] = ACTIONS(1935),
    [sym_continue_statement] = ACTIONS(1935),
    [anon_sym_return] = ACTIONS(1938),
    [anon_sym_const] = ACTIONS(1941),
    [anon_sym_global] = ACTIONS(1944),
    [anon_sym_local] = ACTIONS(1947),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1953),
    [anon_sym_import] = ACTIONS(1956),
    [anon_sym_using] = ACTIONS(1956),
    [anon_sym_LBRACK] = ACTIONS(1959),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR] = ACTIONS(1965),
    [anon_sym_COLON_COLON] = ACTIONS(1968),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1971),
    [anon_sym_true] = ACTIONS(1974),
    [anon_sym_false] = ACTIONS(1974),
    [aux_sym_integer_literal_token1] = ACTIONS(1977),
    [aux_sym_integer_literal_token2] = ACTIONS(1977),
    [aux_sym_integer_literal_token3] = ACTIONS(1977),
    [aux_sym_integer_literal_token4] = ACTIONS(1980),
    [aux_sym_float_literal_token1] = ACTIONS(1983),
    [aux_sym_float_literal_token3] = ACTIONS(1983),
    [aux_sym_float_literal_token4] = ACTIONS(1983),
    [sym_character_literal] = ACTIONS(1986),
    [sym__pair_operator] = ACTIONS(1989),
    [sym__arrow_operator] = ACTIONS(1989),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(1989),
    [sym__pipe_right_operator] = ACTIONS(1989),
    [sym__pipe_left_operator] = ACTIONS(1989),
    [sym__ellipsis_operator] = ACTIONS(1989),
    [sym__plus_operator] = ACTIONS(1989),
    [sym__times_operator] = ACTIONS(1989),
    [sym__rational_operator] = ACTIONS(1989),
    [sym__bitshift_operator] = ACTIONS(1989),
    [sym__power_operator] = ACTIONS(1989),
    [sym__tilde_operator] = ACTIONS(1992),
    [sym__type_order_operator] = ACTIONS(1992),
    [sym__unary_operator] = ACTIONS(1992),
    [sym__unary_plus_operator] = ACTIONS(1992),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1995),
    [sym__command_start] = ACTIONS(1998),
  },
  [138] = {
    [sym_assignment] = STATE(138),
    [sym_open_tuple] = STATE(7634),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [aux_sym_macro_argument_list_repeat1] = STATE(138),
    [sym__word_identifier] = ACTIONS(1621),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1624),
    [anon_sym_begin] = ACTIONS(1627),
    [anon_sym_module] = ACTIONS(1630),
    [anon_sym_baremodule] = ACTIONS(1630),
    [anon_sym_end] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(1633),
    [anon_sym_primitive] = ACTIONS(1636),
    [anon_sym_mutable] = ACTIONS(1639),
    [anon_sym_struct] = ACTIONS(1642),
    [anon_sym_function] = ACTIONS(1645),
    [anon_sym_macro] = ACTIONS(1648),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(1651),
    [anon_sym_let] = ACTIONS(1654),
    [anon_sym_if] = ACTIONS(1657),
    [anon_sym_elseif] = ACTIONS(1388),
    [anon_sym_else] = ACTIONS(1388),
    [anon_sym_try] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1663),
    [anon_sym_while] = ACTIONS(1666),
    [sym_break_statement] = ACTIONS(1669),
    [sym_continue_statement] = ACTIONS(1669),
    [anon_sym_return] = ACTIONS(2001),
    [anon_sym_const] = ACTIONS(2004),
    [anon_sym_global] = ACTIONS(2007),
    [anon_sym_local] = ACTIONS(2010),
    [anon_sym_LPAREN] = ACTIONS(1684),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1687),
    [anon_sym_import] = ACTIONS(1690),
    [anon_sym_using] = ACTIONS(1690),
    [anon_sym_LBRACK] = ACTIONS(1693),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1696),
    [anon_sym_DOLLAR] = ACTIONS(1699),
    [anon_sym_COLON_COLON] = ACTIONS(1702),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1705),
    [anon_sym_true] = ACTIONS(1708),
    [anon_sym_false] = ACTIONS(1708),
    [aux_sym_integer_literal_token1] = ACTIONS(1711),
    [aux_sym_integer_literal_token2] = ACTIONS(1711),
    [aux_sym_integer_literal_token3] = ACTIONS(1711),
    [aux_sym_integer_literal_token4] = ACTIONS(1714),
    [aux_sym_float_literal_token1] = ACTIONS(1717),
    [aux_sym_float_literal_token3] = ACTIONS(1717),
    [aux_sym_float_literal_token4] = ACTIONS(1717),
    [sym_character_literal] = ACTIONS(2013),
    [sym__pair_operator] = ACTIONS(1723),
    [sym__arrow_operator] = ACTIONS(1723),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(1723),
    [sym__pipe_right_operator] = ACTIONS(1723),
    [sym__pipe_left_operator] = ACTIONS(1723),
    [sym__ellipsis_operator] = ACTIONS(1723),
    [sym__plus_operator] = ACTIONS(1723),
    [sym__times_operator] = ACTIONS(1723),
    [sym__rational_operator] = ACTIONS(1723),
    [sym__bitshift_operator] = ACTIONS(1723),
    [sym__power_operator] = ACTIONS(1723),
    [sym__tilde_operator] = ACTIONS(1726),
    [sym__type_order_operator] = ACTIONS(1726),
    [sym__unary_operator] = ACTIONS(1726),
    [sym__unary_plus_operator] = ACTIONS(1726),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1729),
    [sym__command_start] = ACTIONS(1732),
  },
  [139] = {
    [sym_assignment] = STATE(149),
    [sym_open_tuple] = STATE(8650),
    [sym__expression] = STATE(8089),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [aux_sym_macro_argument_list_repeat1] = STATE(149),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(755),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [140] = {
    [sym_assignment] = STATE(136),
    [sym_open_tuple] = STATE(8623),
    [sym__expression] = STATE(8085),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [aux_sym_macro_argument_list_repeat1] = STATE(136),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_catch] = ACTIONS(1503),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [141] = {
    [sym_assignment] = STATE(144),
    [sym_open_tuple] = STATE(7835),
    [sym__expression] = STATE(7836),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [aux_sym_macro_argument_list_repeat1] = STATE(144),
    [ts_builtin_sym_end] = ACTIONS(1505),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_RBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [142] = {
    [sym_assignment] = STATE(313),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11960),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(313),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(893),
    [sym__immediate_bracket] = ACTIONS(895),
    [sym__immediate_brace] = ACTIONS(897),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [143] = {
    [sym_assignment] = STATE(313),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11867),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(313),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1107),
    [sym__immediate_bracket] = ACTIONS(1109),
    [sym__immediate_brace] = ACTIONS(1111),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [144] = {
    [sym_assignment] = STATE(144),
    [sym_open_tuple] = STATE(7835),
    [sym__expression] = STATE(7836),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [aux_sym_macro_argument_list_repeat1] = STATE(144),
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym__word_identifier] = ACTIONS(1507),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1510),
    [anon_sym_begin] = ACTIONS(1513),
    [anon_sym_module] = ACTIONS(1516),
    [anon_sym_baremodule] = ACTIONS(1516),
    [anon_sym_abstract] = ACTIONS(1519),
    [anon_sym_primitive] = ACTIONS(1522),
    [anon_sym_mutable] = ACTIONS(1525),
    [anon_sym_struct] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1531),
    [anon_sym_macro] = ACTIONS(1534),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(1537),
    [anon_sym_let] = ACTIONS(1540),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_try] = ACTIONS(1546),
    [anon_sym_for] = ACTIONS(1549),
    [anon_sym_while] = ACTIONS(1552),
    [sym_break_statement] = ACTIONS(1555),
    [sym_continue_statement] = ACTIONS(1555),
    [anon_sym_return] = ACTIONS(2016),
    [anon_sym_const] = ACTIONS(2019),
    [anon_sym_global] = ACTIONS(2022),
    [anon_sym_local] = ACTIONS(2025),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_RPAREN] = ACTIONS(1388),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1573),
    [anon_sym_import] = ACTIONS(1576),
    [anon_sym_using] = ACTIONS(1576),
    [anon_sym_LBRACK] = ACTIONS(1579),
    [anon_sym_RBRACK] = ACTIONS(1388),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1582),
    [anon_sym_DOLLAR] = ACTIONS(1585),
    [anon_sym_COLON_COLON] = ACTIONS(1588),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1591),
    [anon_sym_true] = ACTIONS(1594),
    [anon_sym_false] = ACTIONS(1594),
    [aux_sym_integer_literal_token1] = ACTIONS(1597),
    [aux_sym_integer_literal_token2] = ACTIONS(1597),
    [aux_sym_integer_literal_token3] = ACTIONS(1597),
    [aux_sym_integer_literal_token4] = ACTIONS(1600),
    [aux_sym_float_literal_token1] = ACTIONS(1603),
    [aux_sym_float_literal_token3] = ACTIONS(1603),
    [aux_sym_float_literal_token4] = ACTIONS(1603),
    [sym_character_literal] = ACTIONS(2028),
    [sym__pair_operator] = ACTIONS(1609),
    [sym__arrow_operator] = ACTIONS(1609),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(1609),
    [sym__pipe_right_operator] = ACTIONS(1609),
    [sym__pipe_left_operator] = ACTIONS(1609),
    [sym__ellipsis_operator] = ACTIONS(1609),
    [sym__plus_operator] = ACTIONS(1609),
    [sym__times_operator] = ACTIONS(1609),
    [sym__rational_operator] = ACTIONS(1609),
    [sym__bitshift_operator] = ACTIONS(1609),
    [sym__power_operator] = ACTIONS(1609),
    [sym__tilde_operator] = ACTIONS(1612),
    [sym__type_order_operator] = ACTIONS(1612),
    [sym__unary_operator] = ACTIONS(1612),
    [sym__unary_plus_operator] = ACTIONS(1612),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1615),
    [sym__command_start] = ACTIONS(1618),
  },
  [145] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(12628),
    [sym__expression] = STATE(12154),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(10566),
    [sym_comprehension_expression] = STATE(10566),
    [sym_matrix_expression] = STATE(10566),
    [sym_vector_expression] = STATE(10566),
    [sym_parenthesized_expression] = STATE(10566),
    [sym_tuple_expression] = STATE(10566),
    [sym_curly_expression] = STATE(10566),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10566),
    [sym_index_expression] = STATE(10566),
    [sym_parametrized_type_expression] = STATE(10566),
    [sym_call_expression] = STATE(10566),
    [sym_broadcast_call_expression] = STATE(10566),
    [sym__closed_macrocall_expression] = STATE(10566),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10566),
    [sym_quote_expression] = STATE(10566),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11966),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10566),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10566),
    [sym_string_literal] = STATE(10566),
    [sym_command_literal] = STATE(10566),
    [sym_prefixed_string_literal] = STATE(10566),
    [sym_prefixed_command_literal] = STATE(10566),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1759),
    [anon_sym_else] = ACTIONS(1759),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(2039),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(2041),
    [sym__pair_operator] = ACTIONS(2043),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(2043),
    [sym__pipe_left_operator] = ACTIONS(2043),
    [sym__ellipsis_operator] = ACTIONS(2043),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(2043),
    [sym__bitshift_operator] = ACTIONS(2043),
    [sym__power_operator] = ACTIONS(2043),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1255),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [146] = {
    [sym__block] = STATE(19126),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1345),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1349),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [147] = {
    [sym_assignment] = STATE(312),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11960),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(312),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(229),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(893),
    [sym__immediate_bracket] = ACTIONS(895),
    [sym__immediate_brace] = ACTIONS(897),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [148] = {
    [sym_assignment] = STATE(312),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11867),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(312),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1107),
    [sym__immediate_bracket] = ACTIONS(1109),
    [sym__immediate_brace] = ACTIONS(1111),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [149] = {
    [sym_assignment] = STATE(149),
    [sym_open_tuple] = STATE(8650),
    [sym__expression] = STATE(8089),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [aux_sym_macro_argument_list_repeat1] = STATE(149),
    [sym__word_identifier] = ACTIONS(2045),
    [anon_sym_EQ] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(2048),
    [anon_sym_begin] = ACTIONS(2051),
    [anon_sym_module] = ACTIONS(2054),
    [anon_sym_baremodule] = ACTIONS(2054),
    [anon_sym_end] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_primitive] = ACTIONS(2060),
    [anon_sym_mutable] = ACTIONS(2063),
    [anon_sym_struct] = ACTIONS(2066),
    [anon_sym_function] = ACTIONS(2069),
    [anon_sym_macro] = ACTIONS(2072),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(2075),
    [anon_sym_let] = ACTIONS(2078),
    [anon_sym_if] = ACTIONS(2081),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_catch] = ACTIONS(1388),
    [anon_sym_for] = ACTIONS(2087),
    [anon_sym_while] = ACTIONS(2090),
    [sym_break_statement] = ACTIONS(2093),
    [sym_continue_statement] = ACTIONS(2093),
    [anon_sym_return] = ACTIONS(2096),
    [anon_sym_const] = ACTIONS(2099),
    [anon_sym_global] = ACTIONS(2102),
    [anon_sym_local] = ACTIONS(2105),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2114),
    [anon_sym_using] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(2120),
    [anon_sym_DOLLAR] = ACTIONS(2123),
    [anon_sym_COLON_COLON] = ACTIONS(2126),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(2132),
    [anon_sym_false] = ACTIONS(2132),
    [aux_sym_integer_literal_token1] = ACTIONS(2135),
    [aux_sym_integer_literal_token2] = ACTIONS(2135),
    [aux_sym_integer_literal_token3] = ACTIONS(2135),
    [aux_sym_integer_literal_token4] = ACTIONS(2138),
    [aux_sym_float_literal_token1] = ACTIONS(2141),
    [aux_sym_float_literal_token3] = ACTIONS(2141),
    [aux_sym_float_literal_token4] = ACTIONS(2141),
    [sym_character_literal] = ACTIONS(2144),
    [sym__pair_operator] = ACTIONS(2147),
    [sym__arrow_operator] = ACTIONS(2147),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(2147),
    [sym__pipe_right_operator] = ACTIONS(2147),
    [sym__pipe_left_operator] = ACTIONS(2147),
    [sym__ellipsis_operator] = ACTIONS(2147),
    [sym__plus_operator] = ACTIONS(2147),
    [sym__times_operator] = ACTIONS(2147),
    [sym__rational_operator] = ACTIONS(2147),
    [sym__bitshift_operator] = ACTIONS(2147),
    [sym__power_operator] = ACTIONS(2147),
    [sym__tilde_operator] = ACTIONS(2150),
    [sym__type_order_operator] = ACTIONS(2150),
    [sym__unary_operator] = ACTIONS(2150),
    [sym__unary_plus_operator] = ACTIONS(2150),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2153),
    [sym__command_start] = ACTIONS(2156),
  },
  [150] = {
    [sym_assignment] = STATE(7320),
    [sym_open_tuple] = STATE(8024),
    [sym__expression] = STATE(7268),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(1759),
    [anon_sym_else] = ACTIONS(1759),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(387),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [151] = {
    [sym_assignment] = STATE(7383),
    [sym_open_tuple] = STATE(8046),
    [sym__expression] = STATE(7278),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(1759),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(295),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(299),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [152] = {
    [sym_assignment] = STATE(155),
    [sym_open_tuple] = STATE(7995),
    [sym__expression] = STATE(7996),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [aux_sym_macro_argument_list_repeat1] = STATE(155),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(773),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [153] = {
    [sym_assignment] = STATE(138),
    [sym_open_tuple] = STATE(7634),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [aux_sym_macro_argument_list_repeat1] = STATE(138),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_elseif] = ACTIONS(1503),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [154] = {
    [sym__block] = STATE(18854),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2159),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2161),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(2163),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [155] = {
    [sym_assignment] = STATE(155),
    [sym_open_tuple] = STATE(7995),
    [sym__expression] = STATE(7996),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [aux_sym_macro_argument_list_repeat1] = STATE(155),
    [sym__word_identifier] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1390),
    [anon_sym_begin] = ACTIONS(1393),
    [anon_sym_module] = ACTIONS(1396),
    [anon_sym_baremodule] = ACTIONS(1396),
    [anon_sym_end] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(1399),
    [anon_sym_primitive] = ACTIONS(1402),
    [anon_sym_mutable] = ACTIONS(1405),
    [anon_sym_struct] = ACTIONS(1408),
    [anon_sym_function] = ACTIONS(1411),
    [anon_sym_macro] = ACTIONS(1414),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(1417),
    [anon_sym_let] = ACTIONS(1420),
    [anon_sym_if] = ACTIONS(1423),
    [anon_sym_else] = ACTIONS(1388),
    [anon_sym_try] = ACTIONS(1426),
    [anon_sym_finally] = ACTIONS(1388),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1432),
    [sym_break_statement] = ACTIONS(1435),
    [sym_continue_statement] = ACTIONS(1435),
    [anon_sym_return] = ACTIONS(2165),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_global] = ACTIONS(2171),
    [anon_sym_local] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1453),
    [anon_sym_import] = ACTIONS(1456),
    [anon_sym_using] = ACTIONS(1456),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_DOLLAR] = ACTIONS(1467),
    [anon_sym_COLON_COLON] = ACTIONS(1470),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1473),
    [anon_sym_true] = ACTIONS(1476),
    [anon_sym_false] = ACTIONS(1476),
    [aux_sym_integer_literal_token1] = ACTIONS(1479),
    [aux_sym_integer_literal_token2] = ACTIONS(1479),
    [aux_sym_integer_literal_token3] = ACTIONS(1479),
    [aux_sym_integer_literal_token4] = ACTIONS(1482),
    [aux_sym_float_literal_token1] = ACTIONS(1485),
    [aux_sym_float_literal_token3] = ACTIONS(1485),
    [aux_sym_float_literal_token4] = ACTIONS(1485),
    [sym_character_literal] = ACTIONS(2177),
    [sym__pair_operator] = ACTIONS(1491),
    [sym__arrow_operator] = ACTIONS(1491),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(1491),
    [sym__pipe_right_operator] = ACTIONS(1491),
    [sym__pipe_left_operator] = ACTIONS(1491),
    [sym__ellipsis_operator] = ACTIONS(1491),
    [sym__plus_operator] = ACTIONS(1491),
    [sym__times_operator] = ACTIONS(1491),
    [sym__rational_operator] = ACTIONS(1491),
    [sym__bitshift_operator] = ACTIONS(1491),
    [sym__power_operator] = ACTIONS(1491),
    [sym__tilde_operator] = ACTIONS(1494),
    [sym__type_order_operator] = ACTIONS(1494),
    [sym__unary_operator] = ACTIONS(1494),
    [sym__unary_plus_operator] = ACTIONS(1494),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1497),
    [sym__command_start] = ACTIONS(1500),
  },
  [156] = {
    [sym__block] = STATE(19470),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2180),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2182),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(2184),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [157] = {
    [sym_assignment] = STATE(7725),
    [sym_open_tuple] = STATE(7341),
    [sym__expression] = STATE(7273),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [ts_builtin_sym_end] = ACTIONS(1769),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(1759),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(475),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [158] = {
    [sym_assignment] = STATE(138),
    [sym_open_tuple] = STATE(7634),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [aux_sym_macro_argument_list_repeat1] = STATE(138),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(1503),
    [anon_sym_else] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(529),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [159] = {
    [sym__expression] = STATE(8917),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [160] = {
    [sym__expression] = STATE(8872),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [161] = {
    [sym_assignment] = STATE(7383),
    [sym_open_tuple] = STATE(7524),
    [sym__expression] = STATE(7384),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(1759),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(773),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(299),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [162] = {
    [sym_assignment] = STATE(8268),
    [sym_open_tuple] = STATE(8643),
    [sym__expression] = STATE(8086),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(1759),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(679),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(683),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [163] = {
    [sym_assignment] = STATE(8437),
    [sym_open_tuple] = STATE(8667),
    [sym__expression] = STATE(8091),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(755),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(759),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [164] = {
    [sym_assignment] = STATE(164),
    [sym_open_tuple] = STATE(8341),
    [sym__expression] = STATE(8343),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [aux_sym_macro_argument_list_repeat1] = STATE(164),
    [sym__word_identifier] = ACTIONS(1773),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1776),
    [anon_sym_begin] = ACTIONS(1779),
    [anon_sym_module] = ACTIONS(1782),
    [anon_sym_baremodule] = ACTIONS(1782),
    [anon_sym_abstract] = ACTIONS(1785),
    [anon_sym_primitive] = ACTIONS(1788),
    [anon_sym_mutable] = ACTIONS(1791),
    [anon_sym_struct] = ACTIONS(1794),
    [anon_sym_function] = ACTIONS(1797),
    [anon_sym_macro] = ACTIONS(1800),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(1803),
    [anon_sym_let] = ACTIONS(1806),
    [anon_sym_if] = ACTIONS(1809),
    [anon_sym_try] = ACTIONS(1812),
    [anon_sym_catch] = ACTIONS(1388),
    [anon_sym_finally] = ACTIONS(1388),
    [anon_sym_for] = ACTIONS(1815),
    [anon_sym_while] = ACTIONS(1818),
    [sym_break_statement] = ACTIONS(1821),
    [sym_continue_statement] = ACTIONS(1821),
    [anon_sym_return] = ACTIONS(2194),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_global] = ACTIONS(2200),
    [anon_sym_local] = ACTIONS(2203),
    [anon_sym_LPAREN] = ACTIONS(1836),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1839),
    [anon_sym_import] = ACTIONS(1842),
    [anon_sym_using] = ACTIONS(1842),
    [anon_sym_LBRACK] = ACTIONS(1845),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1848),
    [anon_sym_DOLLAR] = ACTIONS(1851),
    [anon_sym_COLON_COLON] = ACTIONS(1854),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1857),
    [anon_sym_true] = ACTIONS(1860),
    [anon_sym_false] = ACTIONS(1860),
    [aux_sym_integer_literal_token1] = ACTIONS(1863),
    [aux_sym_integer_literal_token2] = ACTIONS(1863),
    [aux_sym_integer_literal_token3] = ACTIONS(1863),
    [aux_sym_integer_literal_token4] = ACTIONS(1866),
    [aux_sym_float_literal_token1] = ACTIONS(1869),
    [aux_sym_float_literal_token3] = ACTIONS(1869),
    [aux_sym_float_literal_token4] = ACTIONS(1869),
    [sym_character_literal] = ACTIONS(2206),
    [sym__pair_operator] = ACTIONS(1875),
    [sym__arrow_operator] = ACTIONS(1875),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(1875),
    [sym__pipe_right_operator] = ACTIONS(1875),
    [sym__pipe_left_operator] = ACTIONS(1875),
    [sym__ellipsis_operator] = ACTIONS(1875),
    [sym__plus_operator] = ACTIONS(1875),
    [sym__times_operator] = ACTIONS(1875),
    [sym__rational_operator] = ACTIONS(1875),
    [sym__bitshift_operator] = ACTIONS(1875),
    [sym__power_operator] = ACTIONS(1875),
    [sym__tilde_operator] = ACTIONS(1878),
    [sym__type_order_operator] = ACTIONS(1878),
    [sym__unary_operator] = ACTIONS(1878),
    [sym__unary_plus_operator] = ACTIONS(1878),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1881),
    [sym__command_start] = ACTIONS(1884),
  },
  [165] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(12967),
    [sym__expression] = STATE(12837),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10969),
    [sym__array] = STATE(10969),
    [sym_comprehension_expression] = STATE(10969),
    [sym_matrix_expression] = STATE(10969),
    [sym_vector_expression] = STATE(10969),
    [sym_parenthesized_expression] = STATE(10969),
    [sym_tuple_expression] = STATE(10969),
    [sym_curly_expression] = STATE(10969),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(10969),
    [sym_index_expression] = STATE(10969),
    [sym_parametrized_type_expression] = STATE(10969),
    [sym_call_expression] = STATE(10969),
    [sym_broadcast_call_expression] = STATE(10969),
    [sym__closed_macrocall_expression] = STATE(10969),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(10969),
    [sym_quote_expression] = STATE(10969),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(10969),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(10969),
    [sym_string_literal] = STATE(10969),
    [sym_command_literal] = STATE(10969),
    [sym_prefixed_string_literal] = STATE(10969),
    [sym_prefixed_command_literal] = STATE(10969),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2225),
    [anon_sym_COLON_COLON] = ACTIONS(2227),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2229),
    [aux_sym_integer_literal_token2] = ACTIONS(2229),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(2233),
    [aux_sym_float_literal_token3] = ACTIONS(2233),
    [aux_sym_float_literal_token4] = ACTIONS(2233),
    [sym_character_literal] = ACTIONS(2235),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2237),
    [sym__type_order_operator] = ACTIONS(2237),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [166] = {
    [sym_assignment] = STATE(8701),
    [sym_open_tuple] = STATE(8671),
    [sym__expression] = STATE(8094),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(597),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(601),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [167] = {
    [sym_assignment] = STATE(208),
    [sym_open_tuple] = STATE(9041),
    [sym__expression] = STATE(8750),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [aux_sym_macro_argument_list_repeat1] = STATE(208),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [168] = {
    [sym_assignment] = STATE(109),
    [sym_open_tuple] = STATE(8023),
    [sym__expression] = STATE(7265),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [aux_sym_macro_argument_list_repeat1] = STATE(109),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(475),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [169] = {
    [sym_assignment] = STATE(208),
    [sym_open_tuple] = STATE(9041),
    [sym__expression] = STATE(8750),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [aux_sym_macro_argument_list_repeat1] = STATE(208),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [170] = {
    [sym__block] = STATE(18918),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2239),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1265),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2241),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1265),
    [sym__lazy_and_operator] = ACTIONS(1265),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(2243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [171] = {
    [sym_assignment] = STATE(192),
    [sym_open_tuple] = STATE(8336),
    [sym__expression] = STATE(8337),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [aux_sym_macro_argument_list_repeat1] = STATE(192),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_catch] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [172] = {
    [sym_assignment] = STATE(196),
    [sym_open_tuple] = STATE(8306),
    [sym__expression] = STATE(8307),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [aux_sym_macro_argument_list_repeat1] = STATE(196),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(921),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [173] = {
    [sym_assignment] = STATE(196),
    [sym_open_tuple] = STATE(8306),
    [sym__expression] = STATE(8307),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [aux_sym_macro_argument_list_repeat1] = STATE(196),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [174] = {
    [sym__expression] = STATE(8886),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [175] = {
    [sym_assignment] = STATE(109),
    [sym_open_tuple] = STATE(8023),
    [sym__expression] = STATE(7265),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [aux_sym_macro_argument_list_repeat1] = STATE(109),
    [ts_builtin_sym_end] = ACTIONS(1505),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(475),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [176] = {
    [sym__expression] = STATE(8891),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [177] = {
    [sym__expression] = STATE(8893),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [178] = {
    [sym_assignment] = STATE(184),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(184),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1505),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1505),
    [anon_sym_RBRACK] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_RBRACE] = ACTIONS(1505),
    [anon_sym_DOLLAR] = ACTIONS(1505),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(1505),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1505),
    [aux_sym_integer_literal_token2] = ACTIONS(1505),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1505),
    [aux_sym_float_literal_token3] = ACTIONS(1505),
    [aux_sym_float_literal_token4] = ACTIONS(1505),
    [sym_character_literal] = ACTIONS(1505),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(1505),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [179] = {
    [sym_assignment] = STATE(181),
    [sym_open_tuple] = STATE(8962),
    [sym__expression] = STATE(8728),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [aux_sym_macro_argument_list_repeat1] = STATE(181),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1075),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [180] = {
    [sym__expression] = STATE(8914),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [181] = {
    [sym_assignment] = STATE(181),
    [sym_open_tuple] = STATE(8962),
    [sym__expression] = STATE(8728),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [aux_sym_macro_argument_list_repeat1] = STATE(181),
    [sym__word_identifier] = ACTIONS(2245),
    [anon_sym_EQ] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2254),
    [anon_sym_baremodule] = ACTIONS(2254),
    [anon_sym_end] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(2257),
    [anon_sym_primitive] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2263),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_function] = ACTIONS(2269),
    [anon_sym_macro] = ACTIONS(2272),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(2275),
    [anon_sym_let] = ACTIONS(2278),
    [anon_sym_if] = ACTIONS(2281),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2287),
    [anon_sym_while] = ACTIONS(2290),
    [sym_break_statement] = ACTIONS(2293),
    [sym_continue_statement] = ACTIONS(2293),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2299),
    [anon_sym_global] = ACTIONS(2302),
    [anon_sym_local] = ACTIONS(2305),
    [anon_sym_LPAREN] = ACTIONS(2308),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(2311),
    [anon_sym_import] = ACTIONS(2314),
    [anon_sym_using] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2317),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(2320),
    [anon_sym_DOLLAR] = ACTIONS(2323),
    [anon_sym_COLON_COLON] = ACTIONS(2326),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(2329),
    [anon_sym_true] = ACTIONS(2332),
    [anon_sym_false] = ACTIONS(2332),
    [aux_sym_integer_literal_token1] = ACTIONS(2335),
    [aux_sym_integer_literal_token2] = ACTIONS(2335),
    [aux_sym_integer_literal_token3] = ACTIONS(2335),
    [aux_sym_integer_literal_token4] = ACTIONS(2338),
    [aux_sym_float_literal_token1] = ACTIONS(2341),
    [aux_sym_float_literal_token3] = ACTIONS(2341),
    [aux_sym_float_literal_token4] = ACTIONS(2341),
    [sym_character_literal] = ACTIONS(2344),
    [sym__pair_operator] = ACTIONS(2347),
    [sym__arrow_operator] = ACTIONS(2347),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(2347),
    [sym__pipe_right_operator] = ACTIONS(2347),
    [sym__pipe_left_operator] = ACTIONS(2347),
    [sym__ellipsis_operator] = ACTIONS(2347),
    [sym__plus_operator] = ACTIONS(2347),
    [sym__times_operator] = ACTIONS(2347),
    [sym__rational_operator] = ACTIONS(2347),
    [sym__bitshift_operator] = ACTIONS(2347),
    [sym__power_operator] = ACTIONS(2347),
    [sym__tilde_operator] = ACTIONS(2350),
    [sym__type_order_operator] = ACTIONS(2350),
    [sym__unary_operator] = ACTIONS(2350),
    [sym__unary_plus_operator] = ACTIONS(2350),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2353),
    [sym__command_start] = ACTIONS(2356),
  },
  [182] = {
    [sym__expression] = STATE(8916),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [183] = {
    [sym_assignment] = STATE(184),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(184),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(1505),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [184] = {
    [sym_assignment] = STATE(184),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(184),
    [sym__word_identifier] = ACTIONS(2359),
    [anon_sym_EQ] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1462),
    [anon_sym_COLON] = ACTIONS(2362),
    [anon_sym_begin] = ACTIONS(2365),
    [anon_sym_module] = ACTIONS(2368),
    [anon_sym_baremodule] = ACTIONS(2368),
    [anon_sym_abstract] = ACTIONS(2371),
    [anon_sym_primitive] = ACTIONS(2374),
    [anon_sym_mutable] = ACTIONS(2377),
    [anon_sym_struct] = ACTIONS(2380),
    [anon_sym_function] = ACTIONS(2383),
    [anon_sym_macro] = ACTIONS(2386),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(2389),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2395),
    [anon_sym_try] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(2404),
    [sym_break_statement] = ACTIONS(2407),
    [sym_continue_statement] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2413),
    [anon_sym_global] = ACTIONS(2416),
    [anon_sym_local] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_RPAREN] = ACTIONS(1462),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(2425),
    [anon_sym_import] = ACTIONS(2428),
    [anon_sym_using] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2431),
    [anon_sym_RBRACK] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_DOLLAR] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2440),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1462),
    [anon_sym_QMARK] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(2443),
    [anon_sym_true] = ACTIONS(2446),
    [anon_sym_false] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2449),
    [aux_sym_integer_literal_token2] = ACTIONS(2449),
    [aux_sym_integer_literal_token3] = ACTIONS(2452),
    [aux_sym_integer_literal_token4] = ACTIONS(2455),
    [aux_sym_float_literal_token1] = ACTIONS(2458),
    [aux_sym_float_literal_token3] = ACTIONS(2458),
    [aux_sym_float_literal_token4] = ACTIONS(2458),
    [sym_character_literal] = ACTIONS(2461),
    [sym__pair_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2467),
    [sym__lazy_or_operator] = ACTIONS(1462),
    [sym__lazy_and_operator] = ACTIONS(1462),
    [sym__comparison_operator] = ACTIONS(2467),
    [sym__pipe_right_operator] = ACTIONS(2464),
    [sym__pipe_left_operator] = ACTIONS(2464),
    [sym__ellipsis_operator] = ACTIONS(2467),
    [sym__plus_operator] = ACTIONS(2467),
    [sym__times_operator] = ACTIONS(2467),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__tilde_operator] = ACTIONS(2470),
    [sym__type_order_operator] = ACTIONS(2470),
    [sym__unary_operator] = ACTIONS(2473),
    [sym__unary_plus_operator] = ACTIONS(2473),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2476),
    [sym__command_start] = ACTIONS(2479),
  },
  [185] = {
    [sym_assignment] = STATE(334),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11960),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(334),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(229),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_COLON2] = ACTIONS(229),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(279),
    [sym__lazy_and_operator] = ACTIONS(279),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(893),
    [sym__immediate_bracket] = ACTIONS(895),
    [sym__immediate_brace] = ACTIONS(897),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [186] = {
    [sym_assignment] = STATE(334),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_macro_argument_list] = STATE(11867),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(334),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(313),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(311),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_COLON2] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(313),
    [anon_sym_QMARK] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(313),
    [sym__lazy_and_operator] = ACTIONS(313),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1107),
    [sym__immediate_bracket] = ACTIONS(1109),
    [sym__immediate_brace] = ACTIONS(1111),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [187] = {
    [sym_assignment] = STATE(7725),
    [sym_open_tuple] = STATE(7727),
    [sym__expression] = STATE(7728),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [ts_builtin_sym_end] = ACTIONS(1769),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(1759),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(795),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [188] = {
    [sym__expression] = STATE(8027),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2482),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [189] = {
    [sym__expression] = STATE(7738),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(2484),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(479),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [190] = {
    [sym__expression] = STATE(8918),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [191] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(13163),
    [sym__expression] = STATE(12831),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11146),
    [sym__array] = STATE(11146),
    [sym_comprehension_expression] = STATE(11146),
    [sym_matrix_expression] = STATE(11146),
    [sym_vector_expression] = STATE(11146),
    [sym_parenthesized_expression] = STATE(11146),
    [sym_tuple_expression] = STATE(11146),
    [sym_curly_expression] = STATE(11146),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11146),
    [sym_index_expression] = STATE(11146),
    [sym_parametrized_type_expression] = STATE(11146),
    [sym_call_expression] = STATE(11146),
    [sym_broadcast_call_expression] = STATE(11146),
    [sym__closed_macrocall_expression] = STATE(11146),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(11146),
    [sym_quote_expression] = STATE(11146),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12370),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(11146),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11146),
    [sym_string_literal] = STATE(11146),
    [sym_command_literal] = STATE(11146),
    [sym_prefixed_string_literal] = STATE(11146),
    [sym_prefixed_command_literal] = STATE(11146),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1759),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(2512),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [192] = {
    [sym_assignment] = STATE(192),
    [sym_open_tuple] = STATE(8336),
    [sym__expression] = STATE(8337),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [aux_sym_macro_argument_list_repeat1] = STATE(192),
    [sym__word_identifier] = ACTIONS(2045),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(2048),
    [anon_sym_begin] = ACTIONS(2051),
    [anon_sym_module] = ACTIONS(2054),
    [anon_sym_baremodule] = ACTIONS(2054),
    [anon_sym_end] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(2057),
    [anon_sym_primitive] = ACTIONS(2060),
    [anon_sym_mutable] = ACTIONS(2063),
    [anon_sym_struct] = ACTIONS(2066),
    [anon_sym_function] = ACTIONS(2069),
    [anon_sym_macro] = ACTIONS(2072),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(2075),
    [anon_sym_let] = ACTIONS(2078),
    [anon_sym_if] = ACTIONS(2081),
    [anon_sym_try] = ACTIONS(2084),
    [anon_sym_catch] = ACTIONS(1388),
    [anon_sym_for] = ACTIONS(2087),
    [anon_sym_while] = ACTIONS(2090),
    [sym_break_statement] = ACTIONS(2093),
    [sym_continue_statement] = ACTIONS(2093),
    [anon_sym_return] = ACTIONS(2516),
    [anon_sym_const] = ACTIONS(2519),
    [anon_sym_global] = ACTIONS(2522),
    [anon_sym_local] = ACTIONS(2525),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_import] = ACTIONS(2114),
    [anon_sym_using] = ACTIONS(2114),
    [anon_sym_LBRACK] = ACTIONS(2117),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(2120),
    [anon_sym_DOLLAR] = ACTIONS(2123),
    [anon_sym_COLON_COLON] = ACTIONS(2126),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(2129),
    [anon_sym_true] = ACTIONS(2132),
    [anon_sym_false] = ACTIONS(2132),
    [aux_sym_integer_literal_token1] = ACTIONS(2135),
    [aux_sym_integer_literal_token2] = ACTIONS(2135),
    [aux_sym_integer_literal_token3] = ACTIONS(2135),
    [aux_sym_integer_literal_token4] = ACTIONS(2138),
    [aux_sym_float_literal_token1] = ACTIONS(2141),
    [aux_sym_float_literal_token3] = ACTIONS(2141),
    [aux_sym_float_literal_token4] = ACTIONS(2141),
    [sym_character_literal] = ACTIONS(2528),
    [sym__pair_operator] = ACTIONS(2147),
    [sym__arrow_operator] = ACTIONS(2147),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(2147),
    [sym__pipe_right_operator] = ACTIONS(2147),
    [sym__pipe_left_operator] = ACTIONS(2147),
    [sym__ellipsis_operator] = ACTIONS(2147),
    [sym__plus_operator] = ACTIONS(2147),
    [sym__times_operator] = ACTIONS(2147),
    [sym__rational_operator] = ACTIONS(2147),
    [sym__bitshift_operator] = ACTIONS(2147),
    [sym__power_operator] = ACTIONS(2147),
    [sym__tilde_operator] = ACTIONS(2150),
    [sym__type_order_operator] = ACTIONS(2150),
    [sym__unary_operator] = ACTIONS(2150),
    [sym__unary_plus_operator] = ACTIONS(2150),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2153),
    [sym__command_start] = ACTIONS(2156),
  },
  [193] = {
    [sym__expression] = STATE(7394),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [194] = {
    [sym_assignment] = STATE(7320),
    [sym_open_tuple] = STATE(7321),
    [sym__expression] = STATE(7322),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(1759),
    [anon_sym_else] = ACTIONS(1759),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(529),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [195] = {
    [sym__expression] = STATE(7311),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2482),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [196] = {
    [sym_assignment] = STATE(196),
    [sym_open_tuple] = STATE(8306),
    [sym__expression] = STATE(8307),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [aux_sym_macro_argument_list_repeat1] = STATE(196),
    [sym__word_identifier] = ACTIONS(1887),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1890),
    [anon_sym_begin] = ACTIONS(1893),
    [anon_sym_module] = ACTIONS(1896),
    [anon_sym_baremodule] = ACTIONS(1896),
    [anon_sym_end] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(1899),
    [anon_sym_primitive] = ACTIONS(1902),
    [anon_sym_mutable] = ACTIONS(1905),
    [anon_sym_struct] = ACTIONS(1908),
    [anon_sym_function] = ACTIONS(1911),
    [anon_sym_macro] = ACTIONS(1914),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(1917),
    [anon_sym_let] = ACTIONS(1920),
    [anon_sym_if] = ACTIONS(1923),
    [anon_sym_try] = ACTIONS(1926),
    [anon_sym_finally] = ACTIONS(1388),
    [anon_sym_for] = ACTIONS(1929),
    [anon_sym_while] = ACTIONS(1932),
    [sym_break_statement] = ACTIONS(1935),
    [sym_continue_statement] = ACTIONS(1935),
    [anon_sym_return] = ACTIONS(2531),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_global] = ACTIONS(2537),
    [anon_sym_local] = ACTIONS(2540),
    [anon_sym_LPAREN] = ACTIONS(1950),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1953),
    [anon_sym_import] = ACTIONS(1956),
    [anon_sym_using] = ACTIONS(1956),
    [anon_sym_LBRACK] = ACTIONS(1959),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR] = ACTIONS(1965),
    [anon_sym_COLON_COLON] = ACTIONS(1968),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1971),
    [anon_sym_true] = ACTIONS(1974),
    [anon_sym_false] = ACTIONS(1974),
    [aux_sym_integer_literal_token1] = ACTIONS(1977),
    [aux_sym_integer_literal_token2] = ACTIONS(1977),
    [aux_sym_integer_literal_token3] = ACTIONS(1977),
    [aux_sym_integer_literal_token4] = ACTIONS(1980),
    [aux_sym_float_literal_token1] = ACTIONS(1983),
    [aux_sym_float_literal_token3] = ACTIONS(1983),
    [aux_sym_float_literal_token4] = ACTIONS(1983),
    [sym_character_literal] = ACTIONS(2543),
    [sym__pair_operator] = ACTIONS(1989),
    [sym__arrow_operator] = ACTIONS(1989),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(1989),
    [sym__pipe_right_operator] = ACTIONS(1989),
    [sym__pipe_left_operator] = ACTIONS(1989),
    [sym__ellipsis_operator] = ACTIONS(1989),
    [sym__plus_operator] = ACTIONS(1989),
    [sym__times_operator] = ACTIONS(1989),
    [sym__rational_operator] = ACTIONS(1989),
    [sym__bitshift_operator] = ACTIONS(1989),
    [sym__power_operator] = ACTIONS(1989),
    [sym__tilde_operator] = ACTIONS(1992),
    [sym__type_order_operator] = ACTIONS(1992),
    [sym__unary_operator] = ACTIONS(1992),
    [sym__unary_plus_operator] = ACTIONS(1992),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1995),
    [sym__command_start] = ACTIONS(1998),
  },
  [197] = {
    [sym_assignment] = STATE(181),
    [sym_open_tuple] = STATE(8962),
    [sym__expression] = STATE(8728),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [aux_sym_macro_argument_list_repeat1] = STATE(181),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [198] = {
    [sym__expression] = STATE(7312),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2482),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(391),
    [sym__type_order_operator] = ACTIONS(391),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [199] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(12480),
    [sym__expression] = STATE(12481),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10572),
    [sym__array] = STATE(10572),
    [sym_comprehension_expression] = STATE(10572),
    [sym_matrix_expression] = STATE(10572),
    [sym_vector_expression] = STATE(10572),
    [sym_parenthesized_expression] = STATE(10572),
    [sym_tuple_expression] = STATE(10572),
    [sym_curly_expression] = STATE(10572),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10572),
    [sym_index_expression] = STATE(10572),
    [sym_parametrized_type_expression] = STATE(10572),
    [sym_call_expression] = STATE(10572),
    [sym_broadcast_call_expression] = STATE(10572),
    [sym__closed_macrocall_expression] = STATE(10572),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10572),
    [sym_quote_expression] = STATE(10572),
    [sym_binary_expression] = STATE(12674),
    [sym_unary_expression] = STATE(12674),
    [sym_range_expression] = STATE(12674),
    [sym_splat_expression] = STATE(12674),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12045),
    [sym_unary_typed_expression] = STATE(12674),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12674),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10572),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10572),
    [sym_string_literal] = STATE(10572),
    [sym_command_literal] = STATE(10572),
    [sym_prefixed_string_literal] = STATE(10572),
    [sym_prefixed_command_literal] = STATE(10572),
    [sym_operator] = STATE(11874),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1759),
    [anon_sym_else] = ACTIONS(1759),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(2039),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(2546),
    [sym__pair_operator] = ACTIONS(2043),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(2043),
    [sym__pipe_left_operator] = ACTIONS(2043),
    [sym__ellipsis_operator] = ACTIONS(2043),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(2043),
    [sym__bitshift_operator] = ACTIONS(2043),
    [sym__power_operator] = ACTIONS(2043),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1255),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [200] = {
    [sym__expression] = STATE(12488),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(2039),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(2548),
    [sym__pair_operator] = ACTIONS(2043),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(2043),
    [sym__pipe_left_operator] = ACTIONS(2043),
    [sym__ellipsis_operator] = ACTIONS(2043),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(2043),
    [sym__bitshift_operator] = ACTIONS(2043),
    [sym__power_operator] = ACTIONS(2043),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1255),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [201] = {
    [sym__expression] = STATE(8879),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [202] = {
    [sym__expression] = STATE(8881),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [203] = {
    [sym_assignment] = STATE(12494),
    [sym_open_tuple] = STATE(12775),
    [sym__expression] = STATE(12495),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10761),
    [sym__array] = STATE(10761),
    [sym_comprehension_expression] = STATE(10761),
    [sym_matrix_expression] = STATE(10761),
    [sym_vector_expression] = STATE(10761),
    [sym_parenthesized_expression] = STATE(10761),
    [sym_tuple_expression] = STATE(10761),
    [sym_curly_expression] = STATE(10761),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10761),
    [sym_index_expression] = STATE(10761),
    [sym_parametrized_type_expression] = STATE(10761),
    [sym_call_expression] = STATE(10761),
    [sym_broadcast_call_expression] = STATE(10761),
    [sym__closed_macrocall_expression] = STATE(10761),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10761),
    [sym_quote_expression] = STATE(10761),
    [sym_binary_expression] = STATE(12424),
    [sym_unary_expression] = STATE(12424),
    [sym_range_expression] = STATE(12424),
    [sym_splat_expression] = STATE(12424),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11976),
    [sym_unary_typed_expression] = STATE(12424),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12424),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10761),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10761),
    [sym_string_literal] = STATE(10761),
    [sym_command_literal] = STATE(10761),
    [sym_prefixed_string_literal] = STATE(10761),
    [sym_prefixed_command_literal] = STATE(10761),
    [sym_operator] = STATE(11888),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_else] = ACTIONS(1759),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [anon_sym_COLON_COLON] = ACTIONS(149),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(157),
    [aux_sym_integer_literal_token2] = ACTIONS(157),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(161),
    [aux_sym_float_literal_token3] = ACTIONS(161),
    [aux_sym_float_literal_token4] = ACTIONS(161),
    [sym_character_literal] = ACTIONS(2550),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(165),
    [sym__type_order_operator] = ACTIONS(165),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [204] = {
    [sym__expression] = STATE(12518),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [anon_sym_COLON_COLON] = ACTIONS(149),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(157),
    [aux_sym_integer_literal_token2] = ACTIONS(157),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(161),
    [aux_sym_float_literal_token3] = ACTIONS(161),
    [aux_sym_float_literal_token4] = ACTIONS(161),
    [sym_character_literal] = ACTIONS(2552),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(165),
    [sym__type_order_operator] = ACTIONS(165),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [205] = {
    [sym__block] = STATE(17284),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2554),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(2554),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(1215),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(1227),
    [sym__pair_operator] = ACTIONS(1229),
    [sym__arrow_operator] = ACTIONS(1231),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1237),
    [sym__pipe_right_operator] = ACTIONS(1239),
    [sym__pipe_left_operator] = ACTIONS(1241),
    [sym__ellipsis_operator] = ACTIONS(1243),
    [sym__plus_operator] = ACTIONS(1245),
    [sym__times_operator] = ACTIONS(1247),
    [sym__rational_operator] = ACTIONS(1249),
    [sym__bitshift_operator] = ACTIONS(1251),
    [sym__power_operator] = ACTIONS(1253),
    [sym__tilde_operator] = ACTIONS(1255),
    [sym__type_order_operator] = ACTIONS(1257),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1259),
    [aux_sym__terminator_token1] = ACTIONS(2558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [206] = {
    [sym_assignment] = STATE(192),
    [sym_open_tuple] = STATE(8336),
    [sym__expression] = STATE(8337),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [aux_sym_macro_argument_list_repeat1] = STATE(192),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(911),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [207] = {
    [sym_assignment] = STATE(164),
    [sym_open_tuple] = STATE(8341),
    [sym__expression] = STATE(8343),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [aux_sym_macro_argument_list_repeat1] = STATE(164),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(1503),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(1105),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [208] = {
    [sym_assignment] = STATE(208),
    [sym_open_tuple] = STATE(9041),
    [sym__expression] = STATE(8750),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [aux_sym_macro_argument_list_repeat1] = STATE(208),
    [sym__word_identifier] = ACTIONS(2560),
    [anon_sym_EQ] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2569),
    [anon_sym_baremodule] = ACTIONS(2569),
    [anon_sym_abstract] = ACTIONS(2572),
    [anon_sym_primitive] = ACTIONS(2575),
    [anon_sym_mutable] = ACTIONS(2578),
    [anon_sym_struct] = ACTIONS(2581),
    [anon_sym_function] = ACTIONS(2584),
    [anon_sym_macro] = ACTIONS(2587),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(2590),
    [anon_sym_let] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2599),
    [anon_sym_for] = ACTIONS(2602),
    [anon_sym_while] = ACTIONS(2605),
    [sym_break_statement] = ACTIONS(2608),
    [sym_continue_statement] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2611),
    [anon_sym_const] = ACTIONS(2614),
    [anon_sym_global] = ACTIONS(2617),
    [anon_sym_local] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2623),
    [anon_sym_RPAREN] = ACTIONS(1388),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(2626),
    [anon_sym_import] = ACTIONS(2629),
    [anon_sym_using] = ACTIONS(2629),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(2644),
    [anon_sym_true] = ACTIONS(2647),
    [anon_sym_false] = ACTIONS(2647),
    [aux_sym_integer_literal_token1] = ACTIONS(2650),
    [aux_sym_integer_literal_token2] = ACTIONS(2650),
    [aux_sym_integer_literal_token3] = ACTIONS(2650),
    [aux_sym_integer_literal_token4] = ACTIONS(2653),
    [aux_sym_float_literal_token1] = ACTIONS(2656),
    [aux_sym_float_literal_token3] = ACTIONS(2656),
    [aux_sym_float_literal_token4] = ACTIONS(2656),
    [sym_character_literal] = ACTIONS(2659),
    [sym__pair_operator] = ACTIONS(2662),
    [sym__arrow_operator] = ACTIONS(2662),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(2662),
    [sym__pipe_right_operator] = ACTIONS(2662),
    [sym__pipe_left_operator] = ACTIONS(2662),
    [sym__ellipsis_operator] = ACTIONS(2662),
    [sym__plus_operator] = ACTIONS(2662),
    [sym__times_operator] = ACTIONS(2662),
    [sym__rational_operator] = ACTIONS(2662),
    [sym__bitshift_operator] = ACTIONS(2662),
    [sym__power_operator] = ACTIONS(2662),
    [sym__tilde_operator] = ACTIONS(2665),
    [sym__type_order_operator] = ACTIONS(2665),
    [sym__unary_operator] = ACTIONS(2665),
    [sym__unary_plus_operator] = ACTIONS(2665),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2668),
    [sym__command_start] = ACTIONS(2671),
  },
  [209] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(13045),
    [sym__expression] = STATE(12834),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11137),
    [sym__array] = STATE(11137),
    [sym_comprehension_expression] = STATE(11137),
    [sym_matrix_expression] = STATE(11137),
    [sym_vector_expression] = STATE(11137),
    [sym_parenthesized_expression] = STATE(11137),
    [sym_tuple_expression] = STATE(11137),
    [sym_curly_expression] = STATE(11137),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11137),
    [sym_index_expression] = STATE(11137),
    [sym_parametrized_type_expression] = STATE(11137),
    [sym_call_expression] = STATE(11137),
    [sym_broadcast_call_expression] = STATE(11137),
    [sym__closed_macrocall_expression] = STATE(11137),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11137),
    [sym_quote_expression] = STATE(11137),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12260),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11137),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11137),
    [sym_string_literal] = STATE(11137),
    [sym_command_literal] = STATE(11137),
    [sym_prefixed_string_literal] = STATE(11137),
    [sym_prefixed_command_literal] = STATE(11137),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_COLON_COLON] = ACTIONS(2692),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2694),
    [aux_sym_integer_literal_token2] = ACTIONS(2694),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(2698),
    [aux_sym_float_literal_token3] = ACTIONS(2698),
    [aux_sym_float_literal_token4] = ACTIONS(2698),
    [sym_character_literal] = ACTIONS(2700),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2702),
    [sym__type_order_operator] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [210] = {
    [sym_assignment] = STATE(164),
    [sym_open_tuple] = STATE(8341),
    [sym__expression] = STATE(8343),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [aux_sym_macro_argument_list_repeat1] = STATE(164),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_catch] = ACTIONS(1503),
    [anon_sym_finally] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [211] = {
    [sym__expression] = STATE(7393),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(2704),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(299),
    [sym__type_order_operator] = ACTIONS(299),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [212] = {
    [sym__expression] = STATE(8768),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(2706),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(2708),
    [sym__type_order_operator] = ACTIONS(2708),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [213] = {
    [sym_assignment] = STATE(223),
    [sym_open_tuple] = STATE(9032),
    [sym__expression] = STATE(9033),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [aux_sym_macro_argument_list_repeat1] = STATE(223),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1145),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [214] = {
    [sym_assignment] = STATE(223),
    [sym_open_tuple] = STATE(9032),
    [sym__expression] = STATE(9033),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [aux_sym_macro_argument_list_repeat1] = STATE(223),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [215] = {
    [sym_assignment] = STATE(9082),
    [sym_open_tuple] = STATE(9049),
    [sym__expression] = STATE(8755),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [216] = {
    [sym__expression] = STATE(8454),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(2710),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(759),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [217] = {
    [sym_assignment] = STATE(225),
    [sym_open_tuple] = STATE(9152),
    [sym__expression] = STATE(9133),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(225),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [218] = {
    [sym_assignment] = STATE(228),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(228),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1505),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1505),
    [anon_sym_RBRACK] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_RBRACE] = ACTIONS(1505),
    [anon_sym_DOLLAR] = ACTIONS(1505),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(1505),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1505),
    [aux_sym_integer_literal_token2] = ACTIONS(1505),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1505),
    [aux_sym_float_literal_token3] = ACTIONS(1505),
    [aux_sym_float_literal_token4] = ACTIONS(1505),
    [sym_character_literal] = ACTIONS(1505),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(1505),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [219] = {
    [sym_assignment] = STATE(225),
    [sym_open_tuple] = STATE(9152),
    [sym__expression] = STATE(9133),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(225),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1505),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_DOLLAR] = ACTIONS(1505),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(1505),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1505),
    [aux_sym_integer_literal_token2] = ACTIONS(1505),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1505),
    [aux_sym_float_literal_token3] = ACTIONS(1505),
    [aux_sym_float_literal_token4] = ACTIONS(1505),
    [sym_character_literal] = ACTIONS(1505),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(1505),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [220] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(13216),
    [sym__expression] = STATE(13057),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11198),
    [sym__array] = STATE(11198),
    [sym_comprehension_expression] = STATE(11198),
    [sym_matrix_expression] = STATE(11198),
    [sym_vector_expression] = STATE(11198),
    [sym_parenthesized_expression] = STATE(11198),
    [sym_tuple_expression] = STATE(11198),
    [sym_curly_expression] = STATE(11198),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11198),
    [sym_index_expression] = STATE(11198),
    [sym_parametrized_type_expression] = STATE(11198),
    [sym_call_expression] = STATE(11198),
    [sym_broadcast_call_expression] = STATE(11198),
    [sym__closed_macrocall_expression] = STATE(11198),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11198),
    [sym_quote_expression] = STATE(11198),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12928),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11198),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11198),
    [sym_string_literal] = STATE(11198),
    [sym_command_literal] = STATE(11198),
    [sym_prefixed_string_literal] = STATE(11198),
    [sym_prefixed_command_literal] = STATE(11198),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(2720),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [221] = {
    [sym_assignment] = STATE(9061),
    [sym_open_tuple] = STATE(8964),
    [sym__expression] = STATE(8732),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1075),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [222] = {
    [sym_assignment] = STATE(12793),
    [sym_open_tuple] = STATE(12700),
    [sym__expression] = STATE(12101),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10916),
    [sym__array] = STATE(10916),
    [sym_comprehension_expression] = STATE(10916),
    [sym_matrix_expression] = STATE(10916),
    [sym_vector_expression] = STATE(10916),
    [sym_parenthesized_expression] = STATE(10916),
    [sym_tuple_expression] = STATE(10916),
    [sym_curly_expression] = STATE(10916),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10916),
    [sym_index_expression] = STATE(10916),
    [sym_parametrized_type_expression] = STATE(10916),
    [sym_call_expression] = STATE(10916),
    [sym_broadcast_call_expression] = STATE(10916),
    [sym__closed_macrocall_expression] = STATE(10916),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10916),
    [sym_quote_expression] = STATE(10916),
    [sym_binary_expression] = STATE(12715),
    [sym_unary_expression] = STATE(12715),
    [sym_range_expression] = STATE(12715),
    [sym_splat_expression] = STATE(12715),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12109),
    [sym_unary_typed_expression] = STATE(12715),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12715),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10916),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10916),
    [sym_string_literal] = STATE(10916),
    [sym_command_literal] = STATE(10916),
    [sym_prefixed_string_literal] = STATE(10916),
    [sym_prefixed_command_literal] = STATE(10916),
    [sym_operator] = STATE(11913),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2764),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2774),
    [anon_sym_COLON_COLON] = ACTIONS(2776),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(2780),
    [sym__pair_operator] = ACTIONS(2782),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(2782),
    [sym__pipe_left_operator] = ACTIONS(2782),
    [sym__ellipsis_operator] = ACTIONS(2782),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(2782),
    [sym__bitshift_operator] = ACTIONS(2782),
    [sym__power_operator] = ACTIONS(2782),
    [sym__tilde_operator] = ACTIONS(2784),
    [sym__type_order_operator] = ACTIONS(2784),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [223] = {
    [sym_assignment] = STATE(223),
    [sym_open_tuple] = STATE(9032),
    [sym__expression] = STATE(9033),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [aux_sym_macro_argument_list_repeat1] = STATE(223),
    [sym__word_identifier] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2251),
    [anon_sym_module] = ACTIONS(2254),
    [anon_sym_baremodule] = ACTIONS(2254),
    [anon_sym_end] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(2257),
    [anon_sym_primitive] = ACTIONS(2260),
    [anon_sym_mutable] = ACTIONS(2263),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_function] = ACTIONS(2269),
    [anon_sym_macro] = ACTIONS(2272),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(2275),
    [anon_sym_let] = ACTIONS(2278),
    [anon_sym_if] = ACTIONS(2281),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2287),
    [anon_sym_while] = ACTIONS(2290),
    [sym_break_statement] = ACTIONS(2293),
    [sym_continue_statement] = ACTIONS(2293),
    [anon_sym_return] = ACTIONS(2790),
    [anon_sym_const] = ACTIONS(2793),
    [anon_sym_global] = ACTIONS(2796),
    [anon_sym_local] = ACTIONS(2799),
    [anon_sym_LPAREN] = ACTIONS(2308),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(2311),
    [anon_sym_import] = ACTIONS(2314),
    [anon_sym_using] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2317),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(2320),
    [anon_sym_DOLLAR] = ACTIONS(2323),
    [anon_sym_COLON_COLON] = ACTIONS(2326),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(2329),
    [anon_sym_true] = ACTIONS(2332),
    [anon_sym_false] = ACTIONS(2332),
    [aux_sym_integer_literal_token1] = ACTIONS(2335),
    [aux_sym_integer_literal_token2] = ACTIONS(2335),
    [aux_sym_integer_literal_token3] = ACTIONS(2335),
    [aux_sym_integer_literal_token4] = ACTIONS(2338),
    [aux_sym_float_literal_token1] = ACTIONS(2341),
    [aux_sym_float_literal_token3] = ACTIONS(2341),
    [aux_sym_float_literal_token4] = ACTIONS(2341),
    [sym_character_literal] = ACTIONS(2802),
    [sym__pair_operator] = ACTIONS(2347),
    [sym__arrow_operator] = ACTIONS(2347),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(2347),
    [sym__pipe_right_operator] = ACTIONS(2347),
    [sym__pipe_left_operator] = ACTIONS(2347),
    [sym__ellipsis_operator] = ACTIONS(2347),
    [sym__plus_operator] = ACTIONS(2347),
    [sym__times_operator] = ACTIONS(2347),
    [sym__rational_operator] = ACTIONS(2347),
    [sym__bitshift_operator] = ACTIONS(2347),
    [sym__power_operator] = ACTIONS(2347),
    [sym__tilde_operator] = ACTIONS(2350),
    [sym__type_order_operator] = ACTIONS(2350),
    [sym__unary_operator] = ACTIONS(2350),
    [sym__unary_plus_operator] = ACTIONS(2350),
    [aux_sym__terminator_token1] = ACTIONS(1388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2353),
    [sym__command_start] = ACTIONS(2356),
  },
  [224] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(12910),
    [sym__expression] = STATE(13167),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11073),
    [sym__array] = STATE(11073),
    [sym_comprehension_expression] = STATE(11073),
    [sym_matrix_expression] = STATE(11073),
    [sym_vector_expression] = STATE(11073),
    [sym_parenthesized_expression] = STATE(11073),
    [sym_tuple_expression] = STATE(11073),
    [sym_curly_expression] = STATE(11073),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11073),
    [sym_index_expression] = STATE(11073),
    [sym_parametrized_type_expression] = STATE(11073),
    [sym_call_expression] = STATE(11073),
    [sym_broadcast_call_expression] = STATE(11073),
    [sym__closed_macrocall_expression] = STATE(11073),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11073),
    [sym_quote_expression] = STATE(11073),
    [sym_binary_expression] = STATE(13022),
    [sym_unary_expression] = STATE(13022),
    [sym_range_expression] = STATE(13022),
    [sym_splat_expression] = STATE(13022),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12814),
    [sym_unary_typed_expression] = STATE(13022),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13022),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11073),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11073),
    [sym_string_literal] = STATE(11073),
    [sym_command_literal] = STATE(11073),
    [sym_prefixed_string_literal] = STATE(11073),
    [sym_prefixed_command_literal] = STATE(11073),
    [sym_operator] = STATE(12815),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2225),
    [anon_sym_COLON_COLON] = ACTIONS(2227),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2229),
    [aux_sym_integer_literal_token2] = ACTIONS(2229),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(2233),
    [aux_sym_float_literal_token3] = ACTIONS(2233),
    [aux_sym_float_literal_token4] = ACTIONS(2233),
    [sym_character_literal] = ACTIONS(2813),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2237),
    [sym__type_order_operator] = ACTIONS(2237),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [225] = {
    [sym_assignment] = STATE(225),
    [sym_open_tuple] = STATE(9152),
    [sym__expression] = STATE(9133),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(225),
    [sym__word_identifier] = ACTIONS(2359),
    [anon_sym_EQ] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1462),
    [anon_sym_COLON] = ACTIONS(2362),
    [anon_sym_begin] = ACTIONS(2815),
    [anon_sym_module] = ACTIONS(2368),
    [anon_sym_baremodule] = ACTIONS(2368),
    [anon_sym_abstract] = ACTIONS(2371),
    [anon_sym_primitive] = ACTIONS(2374),
    [anon_sym_mutable] = ACTIONS(2377),
    [anon_sym_struct] = ACTIONS(2380),
    [anon_sym_function] = ACTIONS(2383),
    [anon_sym_macro] = ACTIONS(2386),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(2389),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2395),
    [anon_sym_try] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(2404),
    [sym_break_statement] = ACTIONS(2407),
    [sym_continue_statement] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2818),
    [anon_sym_const] = ACTIONS(2821),
    [anon_sym_global] = ACTIONS(2824),
    [anon_sym_local] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_RPAREN] = ACTIONS(1462),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(2425),
    [anon_sym_import] = ACTIONS(2428),
    [anon_sym_using] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2431),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_DOLLAR] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2440),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1462),
    [anon_sym_QMARK] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(2443),
    [anon_sym_true] = ACTIONS(2446),
    [anon_sym_false] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2449),
    [aux_sym_integer_literal_token2] = ACTIONS(2449),
    [aux_sym_integer_literal_token3] = ACTIONS(2452),
    [aux_sym_integer_literal_token4] = ACTIONS(2455),
    [aux_sym_float_literal_token1] = ACTIONS(2458),
    [aux_sym_float_literal_token3] = ACTIONS(2458),
    [aux_sym_float_literal_token4] = ACTIONS(2458),
    [sym_character_literal] = ACTIONS(2830),
    [sym__pair_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2467),
    [sym__lazy_or_operator] = ACTIONS(1462),
    [sym__lazy_and_operator] = ACTIONS(1462),
    [sym__comparison_operator] = ACTIONS(2467),
    [sym__pipe_right_operator] = ACTIONS(2464),
    [sym__pipe_left_operator] = ACTIONS(2464),
    [sym__ellipsis_operator] = ACTIONS(2467),
    [sym__plus_operator] = ACTIONS(2467),
    [sym__times_operator] = ACTIONS(2467),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__tilde_operator] = ACTIONS(2833),
    [sym__type_order_operator] = ACTIONS(2833),
    [sym__unary_operator] = ACTIONS(2836),
    [sym__unary_plus_operator] = ACTIONS(2836),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2476),
    [sym__command_start] = ACTIONS(2479),
  },
  [226] = {
    [sym__expression] = STATE(12960),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2225),
    [anon_sym_COLON_COLON] = ACTIONS(2227),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2229),
    [aux_sym_integer_literal_token2] = ACTIONS(2229),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(2233),
    [aux_sym_float_literal_token3] = ACTIONS(2233),
    [aux_sym_float_literal_token4] = ACTIONS(2233),
    [sym_character_literal] = ACTIONS(2839),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2237),
    [sym__type_order_operator] = ACTIONS(2237),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [227] = {
    [sym_assignment] = STATE(225),
    [sym_open_tuple] = STATE(9152),
    [sym__expression] = STATE(9133),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(225),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [228] = {
    [sym_assignment] = STATE(228),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(228),
    [sym__word_identifier] = ACTIONS(2359),
    [anon_sym_COMMA] = ACTIONS(1462),
    [anon_sym_COLON] = ACTIONS(2362),
    [anon_sym_begin] = ACTIONS(2365),
    [anon_sym_module] = ACTIONS(2368),
    [anon_sym_baremodule] = ACTIONS(2368),
    [anon_sym_abstract] = ACTIONS(2371),
    [anon_sym_primitive] = ACTIONS(2374),
    [anon_sym_mutable] = ACTIONS(2377),
    [anon_sym_struct] = ACTIONS(2380),
    [anon_sym_function] = ACTIONS(2383),
    [anon_sym_macro] = ACTIONS(2386),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(2389),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2395),
    [anon_sym_try] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(2404),
    [sym_break_statement] = ACTIONS(2407),
    [sym_continue_statement] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2844),
    [anon_sym_global] = ACTIONS(2847),
    [anon_sym_local] = ACTIONS(2850),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_RPAREN] = ACTIONS(1462),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(2425),
    [anon_sym_import] = ACTIONS(2428),
    [anon_sym_using] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2431),
    [anon_sym_RBRACK] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_DOLLAR] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2440),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1462),
    [anon_sym_QMARK] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(2443),
    [anon_sym_true] = ACTIONS(2446),
    [anon_sym_false] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2449),
    [aux_sym_integer_literal_token2] = ACTIONS(2449),
    [aux_sym_integer_literal_token3] = ACTIONS(2452),
    [aux_sym_integer_literal_token4] = ACTIONS(2455),
    [aux_sym_float_literal_token1] = ACTIONS(2458),
    [aux_sym_float_literal_token3] = ACTIONS(2458),
    [aux_sym_float_literal_token4] = ACTIONS(2458),
    [sym_character_literal] = ACTIONS(2853),
    [sym__pair_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2467),
    [sym__lazy_or_operator] = ACTIONS(1462),
    [sym__lazy_and_operator] = ACTIONS(1462),
    [sym__comparison_operator] = ACTIONS(2467),
    [sym__pipe_right_operator] = ACTIONS(2464),
    [sym__pipe_left_operator] = ACTIONS(2464),
    [sym__ellipsis_operator] = ACTIONS(2467),
    [sym__plus_operator] = ACTIONS(2467),
    [sym__times_operator] = ACTIONS(2467),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__tilde_operator] = ACTIONS(2470),
    [sym__type_order_operator] = ACTIONS(2470),
    [sym__unary_operator] = ACTIONS(2473),
    [sym__unary_plus_operator] = ACTIONS(2473),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2476),
    [sym__command_start] = ACTIONS(2479),
  },
  [229] = {
    [sym_assignment] = STATE(144),
    [sym_open_tuple] = STATE(7835),
    [sym__expression] = STATE(7836),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [aux_sym_macro_argument_list_repeat1] = STATE(144),
    [ts_builtin_sym_end] = ACTIONS(1505),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(795),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [aux_sym__terminator_token1] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [230] = {
    [sym_assignment] = STATE(12171),
    [sym_open_tuple] = STATE(13372),
    [sym__expression] = STATE(13011),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11288),
    [sym__array] = STATE(11288),
    [sym_comprehension_expression] = STATE(11288),
    [sym_matrix_expression] = STATE(11288),
    [sym_vector_expression] = STATE(11288),
    [sym_parenthesized_expression] = STATE(11288),
    [sym_tuple_expression] = STATE(11288),
    [sym_curly_expression] = STATE(11288),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11288),
    [sym_index_expression] = STATE(11288),
    [sym_parametrized_type_expression] = STATE(11288),
    [sym_call_expression] = STATE(11288),
    [sym_broadcast_call_expression] = STATE(11288),
    [sym__closed_macrocall_expression] = STATE(11288),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11288),
    [sym_quote_expression] = STATE(11288),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13096),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11288),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11288),
    [sym_string_literal] = STATE(11288),
    [sym_command_literal] = STATE(11288),
    [sym_prefixed_string_literal] = STATE(11288),
    [sym_prefixed_command_literal] = STATE(11288),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(2922),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [231] = {
    [sym__expression] = STATE(8730),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2936),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2938),
    [sym__type_order_operator] = ACTIONS(2938),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [232] = {
    [sym_assignment] = STATE(8701),
    [sym_open_tuple] = STATE(8253),
    [sym__expression] = STATE(8706),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(921),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(601),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [233] = {
    [sym_assignment] = STATE(233),
    [sym_open_tuple] = STATE(8794),
    [sym__expression] = STATE(8795),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [aux_sym_macro_argument_list_repeat1] = STATE(233),
    [sym__word_identifier] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2569),
    [anon_sym_baremodule] = ACTIONS(2569),
    [anon_sym_abstract] = ACTIONS(2572),
    [anon_sym_primitive] = ACTIONS(2575),
    [anon_sym_mutable] = ACTIONS(2578),
    [anon_sym_struct] = ACTIONS(2581),
    [anon_sym_function] = ACTIONS(2584),
    [anon_sym_macro] = ACTIONS(2587),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(2590),
    [anon_sym_let] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2599),
    [anon_sym_for] = ACTIONS(2602),
    [anon_sym_while] = ACTIONS(2605),
    [sym_break_statement] = ACTIONS(2608),
    [sym_continue_statement] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2940),
    [anon_sym_const] = ACTIONS(2943),
    [anon_sym_global] = ACTIONS(2946),
    [anon_sym_local] = ACTIONS(2949),
    [anon_sym_LPAREN] = ACTIONS(2623),
    [anon_sym_RPAREN] = ACTIONS(1388),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(2626),
    [anon_sym_import] = ACTIONS(2629),
    [anon_sym_using] = ACTIONS(2629),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_LF] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2641),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1388),
    [anon_sym_QMARK] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(2644),
    [anon_sym_true] = ACTIONS(2647),
    [anon_sym_false] = ACTIONS(2647),
    [aux_sym_integer_literal_token1] = ACTIONS(2650),
    [aux_sym_integer_literal_token2] = ACTIONS(2650),
    [aux_sym_integer_literal_token3] = ACTIONS(2650),
    [aux_sym_integer_literal_token4] = ACTIONS(2653),
    [aux_sym_float_literal_token1] = ACTIONS(2656),
    [aux_sym_float_literal_token3] = ACTIONS(2656),
    [aux_sym_float_literal_token4] = ACTIONS(2656),
    [sym_character_literal] = ACTIONS(2952),
    [sym__pair_operator] = ACTIONS(2662),
    [sym__arrow_operator] = ACTIONS(2662),
    [sym__lazy_or_operator] = ACTIONS(1388),
    [sym__lazy_and_operator] = ACTIONS(1388),
    [sym__comparison_operator] = ACTIONS(2662),
    [sym__pipe_right_operator] = ACTIONS(2662),
    [sym__pipe_left_operator] = ACTIONS(2662),
    [sym__ellipsis_operator] = ACTIONS(2662),
    [sym__plus_operator] = ACTIONS(2662),
    [sym__times_operator] = ACTIONS(2662),
    [sym__rational_operator] = ACTIONS(2662),
    [sym__bitshift_operator] = ACTIONS(2662),
    [sym__power_operator] = ACTIONS(2662),
    [sym__tilde_operator] = ACTIONS(2665),
    [sym__type_order_operator] = ACTIONS(2665),
    [sym__unary_operator] = ACTIONS(2665),
    [sym__unary_plus_operator] = ACTIONS(2665),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2668),
    [sym__command_start] = ACTIONS(2671),
  },
  [234] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(12922),
    [sym__expression] = STATE(12923),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11054),
    [sym__array] = STATE(11054),
    [sym_comprehension_expression] = STATE(11054),
    [sym_matrix_expression] = STATE(11054),
    [sym_vector_expression] = STATE(11054),
    [sym_parenthesized_expression] = STATE(11054),
    [sym_tuple_expression] = STATE(11054),
    [sym_curly_expression] = STATE(11054),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11054),
    [sym_index_expression] = STATE(11054),
    [sym_parametrized_type_expression] = STATE(11054),
    [sym_call_expression] = STATE(11054),
    [sym_broadcast_call_expression] = STATE(11054),
    [sym__closed_macrocall_expression] = STATE(11054),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11054),
    [sym_quote_expression] = STATE(11054),
    [sym_binary_expression] = STATE(12944),
    [sym_unary_expression] = STATE(12944),
    [sym_range_expression] = STATE(12944),
    [sym_splat_expression] = STATE(12944),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12622),
    [sym_unary_typed_expression] = STATE(12944),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12944),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11054),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11054),
    [sym_string_literal] = STATE(11054),
    [sym_command_literal] = STATE(11054),
    [sym_prefixed_string_literal] = STATE(11054),
    [sym_prefixed_command_literal] = STATE(11054),
    [sym_operator] = STATE(12623),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1759),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(2963),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [235] = {
    [sym__expression] = STATE(8108),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(2965),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(601),
    [sym__type_order_operator] = ACTIONS(601),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [236] = {
    [sym_assignment] = STATE(8499),
    [sym_open_tuple] = STATE(8993),
    [sym__expression] = STATE(8742),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [237] = {
    [sym_assignment] = STATE(228),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(228),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(1505),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [238] = {
    [sym__expression] = STATE(12930),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(2967),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [239] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(12249),
    [sym__expression] = STATE(12157),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10551),
    [sym__array] = STATE(10551),
    [sym_comprehension_expression] = STATE(10551),
    [sym_matrix_expression] = STATE(10551),
    [sym_vector_expression] = STATE(10551),
    [sym_parenthesized_expression] = STATE(10551),
    [sym_tuple_expression] = STATE(10551),
    [sym_curly_expression] = STATE(10551),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10551),
    [sym_index_expression] = STATE(10551),
    [sym_parametrized_type_expression] = STATE(10551),
    [sym_call_expression] = STATE(10551),
    [sym_broadcast_call_expression] = STATE(10551),
    [sym__closed_macrocall_expression] = STATE(10551),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10551),
    [sym_quote_expression] = STATE(10551),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12237),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10551),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10551),
    [sym_string_literal] = STATE(10551),
    [sym_command_literal] = STATE(10551),
    [sym_prefixed_string_literal] = STATE(10551),
    [sym_prefixed_command_literal] = STATE(10551),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(1759),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_COLON_COLON] = ACTIONS(2985),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(2987),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2989),
    [sym__type_order_operator] = ACTIONS(2989),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [240] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(13023),
    [sym__expression] = STATE(13026),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11131),
    [sym__array] = STATE(11131),
    [sym_comprehension_expression] = STATE(11131),
    [sym_matrix_expression] = STATE(11131),
    [sym_vector_expression] = STATE(11131),
    [sym_parenthesized_expression] = STATE(11131),
    [sym_tuple_expression] = STATE(11131),
    [sym_curly_expression] = STATE(11131),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11131),
    [sym_index_expression] = STATE(11131),
    [sym_parametrized_type_expression] = STATE(11131),
    [sym_call_expression] = STATE(11131),
    [sym_broadcast_call_expression] = STATE(11131),
    [sym__closed_macrocall_expression] = STATE(11131),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11131),
    [sym_quote_expression] = STATE(11131),
    [sym_binary_expression] = STATE(13174),
    [sym_unary_expression] = STATE(13174),
    [sym_range_expression] = STATE(13174),
    [sym_splat_expression] = STATE(13174),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12720),
    [sym_unary_typed_expression] = STATE(13174),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13174),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11131),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11131),
    [sym_string_literal] = STATE(11131),
    [sym_command_literal] = STATE(11131),
    [sym_prefixed_string_literal] = STATE(11131),
    [sym_prefixed_command_literal] = STATE(11131),
    [sym_operator] = STATE(12722),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_COLON_COLON] = ACTIONS(2692),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2694),
    [aux_sym_integer_literal_token2] = ACTIONS(2694),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(2698),
    [aux_sym_float_literal_token3] = ACTIONS(2698),
    [aux_sym_float_literal_token4] = ACTIONS(2698),
    [sym_character_literal] = ACTIONS(2999),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2702),
    [sym__type_order_operator] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [241] = {
    [sym__expression] = STATE(13052),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(1213),
    [anon_sym_COLON_COLON] = ACTIONS(2039),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(1221),
    [aux_sym_integer_literal_token2] = ACTIONS(1221),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(1225),
    [aux_sym_float_literal_token3] = ACTIONS(1225),
    [aux_sym_float_literal_token4] = ACTIONS(1225),
    [sym_character_literal] = ACTIONS(3001),
    [sym__pair_operator] = ACTIONS(2043),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(2043),
    [sym__pipe_left_operator] = ACTIONS(2043),
    [sym__ellipsis_operator] = ACTIONS(2043),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(2043),
    [sym__bitshift_operator] = ACTIONS(2043),
    [sym__power_operator] = ACTIONS(2043),
    [sym__tilde_operator] = ACTIONS(3003),
    [sym__type_order_operator] = ACTIONS(3003),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [242] = {
    [sym__expression] = STATE(13068),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_COLON_COLON] = ACTIONS(2692),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2694),
    [aux_sym_integer_literal_token2] = ACTIONS(2694),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(2698),
    [aux_sym_float_literal_token3] = ACTIONS(2698),
    [aux_sym_float_literal_token4] = ACTIONS(2698),
    [sym_character_literal] = ACTIONS(3005),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2702),
    [sym__type_order_operator] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [243] = {
    [sym_assignment] = STATE(233),
    [sym_open_tuple] = STATE(8794),
    [sym__expression] = STATE(8795),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [aux_sym_macro_argument_list_repeat1] = STATE(233),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(1181),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [244] = {
    [sym_assignment] = STATE(144),
    [sym_open_tuple] = STATE(7835),
    [sym__expression] = STATE(7836),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [aux_sym_macro_argument_list_repeat1] = STATE(144),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(795),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(479),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [245] = {
    [sym_assignment] = STATE(233),
    [sym_open_tuple] = STATE(8794),
    [sym__expression] = STATE(8795),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [aux_sym_macro_argument_list_repeat1] = STATE(233),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_LF] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_DOLLAR] = ACTIONS(1503),
    [anon_sym_COLON_COLON] = ACTIONS(1503),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AT] = ACTIONS(1503),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1503),
    [aux_sym_integer_literal_token2] = ACTIONS(1503),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1503),
    [aux_sym_float_literal_token3] = ACTIONS(1503),
    [aux_sym_float_literal_token4] = ACTIONS(1503),
    [sym_character_literal] = ACTIONS(1503),
    [sym__pair_operator] = ACTIONS(1503),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1503),
    [sym__lazy_and_operator] = ACTIONS(1503),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1503),
    [sym__pipe_left_operator] = ACTIONS(1503),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1503),
    [sym__bitshift_operator] = ACTIONS(1503),
    [sym__power_operator] = ACTIONS(1503),
    [sym__tilde_operator] = ACTIONS(1503),
    [sym__type_order_operator] = ACTIONS(1503),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [246] = {
    [sym_assignment] = STATE(8268),
    [sym_open_tuple] = STATE(8279),
    [sym__expression] = STATE(8280),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(1759),
    [anon_sym_finally] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(1105),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(683),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [247] = {
    [sym__expression] = STATE(13067),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [anon_sym_COLON_COLON] = ACTIONS(149),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(157),
    [aux_sym_integer_literal_token2] = ACTIONS(157),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(161),
    [aux_sym_float_literal_token3] = ACTIONS(161),
    [aux_sym_float_literal_token4] = ACTIONS(161),
    [sym_character_literal] = ACTIONS(3007),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(3009),
    [sym__type_order_operator] = ACTIONS(3009),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [248] = {
    [sym__expression] = STATE(8308),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(3011),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(683),
    [sym__type_order_operator] = ACTIONS(683),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [249] = {
    [sym__expression] = STATE(8652),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(271),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_COLON_COLON] = ACTIONS(285),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(289),
    [aux_sym_integer_literal_token2] = ACTIONS(289),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(293),
    [aux_sym_float_literal_token3] = ACTIONS(293),
    [aux_sym_float_literal_token4] = ACTIONS(293),
    [sym_character_literal] = ACTIONS(3013),
    [sym__pair_operator] = ACTIONS(297),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(297),
    [sym__pipe_left_operator] = ACTIONS(297),
    [sym__ellipsis_operator] = ACTIONS(297),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(297),
    [sym__bitshift_operator] = ACTIONS(297),
    [sym__power_operator] = ACTIONS(297),
    [sym__tilde_operator] = ACTIONS(3015),
    [sym__type_order_operator] = ACTIONS(3015),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [250] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(13369),
    [sym__expression] = STATE(13131),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11203),
    [sym__array] = STATE(11203),
    [sym_comprehension_expression] = STATE(11203),
    [sym_matrix_expression] = STATE(11203),
    [sym_vector_expression] = STATE(11203),
    [sym_parenthesized_expression] = STATE(11203),
    [sym_tuple_expression] = STATE(11203),
    [sym_curly_expression] = STATE(11203),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11203),
    [sym_index_expression] = STATE(11203),
    [sym_parametrized_type_expression] = STATE(11203),
    [sym_call_expression] = STATE(11203),
    [sym_broadcast_call_expression] = STATE(11203),
    [sym__closed_macrocall_expression] = STATE(11203),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11203),
    [sym_quote_expression] = STATE(11203),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13080),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11203),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11203),
    [sym_string_literal] = STATE(11203),
    [sym_command_literal] = STATE(11203),
    [sym_prefixed_string_literal] = STATE(11203),
    [sym_prefixed_command_literal] = STATE(11203),
    [sym_operator] = STATE(10451),
    [ts_builtin_sym_end] = ACTIONS(1769),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(3025),
    [anon_sym_COLON_COLON] = ACTIONS(3027),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(69),
    [aux_sym_integer_literal_token2] = ACTIONS(69),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(3029),
    [aux_sym_float_literal_token3] = ACTIONS(3029),
    [aux_sym_float_literal_token4] = ACTIONS(3029),
    [sym_character_literal] = ACTIONS(3031),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(83),
    [sym__type_order_operator] = ACTIONS(83),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [251] = {
    [sym_assignment] = STATE(8437),
    [sym_open_tuple] = STATE(8705),
    [sym__expression] = STATE(8438),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(1759),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(911),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(759),
    [sym__type_order_operator] = ACTIONS(759),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [252] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(13409),
    [sym__expression] = STATE(13412),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11220),
    [sym__array] = STATE(11220),
    [sym_comprehension_expression] = STATE(11220),
    [sym_matrix_expression] = STATE(11220),
    [sym_vector_expression] = STATE(11220),
    [sym_parenthesized_expression] = STATE(11220),
    [sym_tuple_expression] = STATE(11220),
    [sym_curly_expression] = STATE(11220),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11220),
    [sym_index_expression] = STATE(11220),
    [sym_parametrized_type_expression] = STATE(11220),
    [sym_call_expression] = STATE(11220),
    [sym_broadcast_call_expression] = STATE(11220),
    [sym__closed_macrocall_expression] = STATE(11220),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11220),
    [sym_quote_expression] = STATE(11220),
    [sym_binary_expression] = STATE(13251),
    [sym_unary_expression] = STATE(13251),
    [sym_range_expression] = STATE(13251),
    [sym_splat_expression] = STATE(13251),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13087),
    [sym_unary_typed_expression] = STATE(13251),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13251),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11220),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11220),
    [sym_string_literal] = STATE(11220),
    [sym_command_literal] = STATE(11220),
    [sym_prefixed_string_literal] = STATE(11220),
    [sym_prefixed_command_literal] = STATE(11220),
    [sym_operator] = STATE(13088),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(3033),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [253] = {
    [sym_assignment] = STATE(12171),
    [sym_open_tuple] = STATE(13525),
    [sym__expression] = STATE(13378),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11387),
    [sym__array] = STATE(11387),
    [sym_comprehension_expression] = STATE(11387),
    [sym_matrix_expression] = STATE(11387),
    [sym_vector_expression] = STATE(11387),
    [sym_parenthesized_expression] = STATE(11387),
    [sym_tuple_expression] = STATE(11387),
    [sym_curly_expression] = STATE(11387),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11387),
    [sym_index_expression] = STATE(11387),
    [sym_parametrized_type_expression] = STATE(11387),
    [sym_call_expression] = STATE(11387),
    [sym_broadcast_call_expression] = STATE(11387),
    [sym__closed_macrocall_expression] = STATE(11387),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11387),
    [sym_quote_expression] = STATE(11387),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13333),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11387),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11387),
    [sym_string_literal] = STATE(11387),
    [sym_command_literal] = STATE(11387),
    [sym_prefixed_string_literal] = STATE(11387),
    [sym_prefixed_command_literal] = STATE(11387),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3045),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [254] = {
    [sym__expression] = STATE(12698),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2764),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2774),
    [anon_sym_COLON_COLON] = ACTIONS(2776),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(3051),
    [sym__pair_operator] = ACTIONS(2782),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(2782),
    [sym__pipe_left_operator] = ACTIONS(2782),
    [sym__ellipsis_operator] = ACTIONS(2782),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(2782),
    [sym__bitshift_operator] = ACTIONS(2782),
    [sym__power_operator] = ACTIONS(2782),
    [sym__tilde_operator] = ACTIONS(2784),
    [sym__type_order_operator] = ACTIONS(2784),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [255] = {
    [sym__expression] = STATE(13428),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(3053),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [256] = {
    [sym__expression] = STATE(12255),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_COLON_COLON] = ACTIONS(2985),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(3055),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2989),
    [sym__type_order_operator] = ACTIONS(2989),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [257] = {
    [sym__expression] = STATE(9299),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [258] = {
    [sym__expression] = STATE(9300),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [259] = {
    [sym__block] = STATE(18723),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3061),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3067),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3107),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [260] = {
    [sym__expression] = STATE(9245),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [261] = {
    [sym__expression] = STATE(9278),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [262] = {
    [sym__expression] = STATE(9289),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [263] = {
    [sym__expression] = STATE(9290),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [264] = {
    [sym__expression] = STATE(9302),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [265] = {
    [sym_assignment] = STATE(9061),
    [sym_open_tuple] = STATE(9065),
    [sym__expression] = STATE(9066),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(1759),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(1145),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [266] = {
    [sym__expression] = STATE(9294),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [267] = {
    [sym__expression] = STATE(9295),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [268] = {
    [sym__expression] = STATE(9304),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [269] = {
    [sym_assignment] = STATE(269),
    [sym_open_tuple] = STATE(9165),
    [sym__expression] = STATE(9171),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [aux_sym_macro_argument_list_repeat1] = STATE(269),
    [sym__word_identifier] = ACTIONS(2359),
    [anon_sym_COMMA] = ACTIONS(1462),
    [anon_sym_COLON] = ACTIONS(2362),
    [anon_sym_begin] = ACTIONS(2815),
    [anon_sym_module] = ACTIONS(2368),
    [anon_sym_baremodule] = ACTIONS(2368),
    [anon_sym_abstract] = ACTIONS(2371),
    [anon_sym_primitive] = ACTIONS(2374),
    [anon_sym_mutable] = ACTIONS(2377),
    [anon_sym_struct] = ACTIONS(2380),
    [anon_sym_function] = ACTIONS(2383),
    [anon_sym_macro] = ACTIONS(2386),
    [anon_sym_where] = ACTIONS(1388),
    [anon_sym_quote] = ACTIONS(2389),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2395),
    [anon_sym_try] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(2404),
    [sym_break_statement] = ACTIONS(2407),
    [sym_continue_statement] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(3109),
    [anon_sym_const] = ACTIONS(3112),
    [anon_sym_global] = ACTIONS(3115),
    [anon_sym_local] = ACTIONS(3118),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_RPAREN] = ACTIONS(1462),
    [anon_sym_COLON2] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(2425),
    [anon_sym_import] = ACTIONS(2428),
    [anon_sym_using] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2431),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_DOLLAR] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2440),
    [anon_sym_isa] = ACTIONS(1388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1462),
    [anon_sym_QMARK] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(2443),
    [anon_sym_true] = ACTIONS(2446),
    [anon_sym_false] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2449),
    [aux_sym_integer_literal_token2] = ACTIONS(2449),
    [aux_sym_integer_literal_token3] = ACTIONS(2452),
    [aux_sym_integer_literal_token4] = ACTIONS(2455),
    [aux_sym_float_literal_token1] = ACTIONS(2458),
    [aux_sym_float_literal_token3] = ACTIONS(2458),
    [aux_sym_float_literal_token4] = ACTIONS(2458),
    [sym_character_literal] = ACTIONS(3121),
    [sym__pair_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2467),
    [sym__lazy_or_operator] = ACTIONS(1462),
    [sym__lazy_and_operator] = ACTIONS(1462),
    [sym__comparison_operator] = ACTIONS(2467),
    [sym__pipe_right_operator] = ACTIONS(2464),
    [sym__pipe_left_operator] = ACTIONS(2464),
    [sym__ellipsis_operator] = ACTIONS(2467),
    [sym__plus_operator] = ACTIONS(2467),
    [sym__times_operator] = ACTIONS(2467),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__tilde_operator] = ACTIONS(2833),
    [sym__type_order_operator] = ACTIONS(2833),
    [sym__unary_operator] = ACTIONS(2836),
    [sym__unary_plus_operator] = ACTIONS(2836),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2476),
    [sym__command_start] = ACTIONS(2479),
  },
  [270] = {
    [sym__expression] = STATE(13225),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(3124),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(3126),
    [sym__type_order_operator] = ACTIONS(3126),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [271] = {
    [sym__expression] = STATE(8919),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [272] = {
    [sym__expression] = STATE(8967),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3128),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [273] = {
    [sym__expression] = STATE(8859),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3128),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [274] = {
    [sym_assignment] = STATE(269),
    [sym_open_tuple] = STATE(9165),
    [sym__expression] = STATE(9171),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [aux_sym_macro_argument_list_repeat1] = STATE(269),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [275] = {
    [sym__expression] = STATE(8861),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3128),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(1079),
    [sym__type_order_operator] = ACTIONS(1079),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [276] = {
    [sym__expression] = STATE(13243),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(3025),
    [anon_sym_COLON_COLON] = ACTIONS(3027),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(69),
    [aux_sym_integer_literal_token2] = ACTIONS(69),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(3029),
    [aux_sym_float_literal_token3] = ACTIONS(3029),
    [aux_sym_float_literal_token4] = ACTIONS(3029),
    [sym_character_literal] = ACTIONS(3130),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(83),
    [sym__type_order_operator] = ACTIONS(83),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [277] = {
    [sym__block] = STATE(19332),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3132),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3134),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [278] = {
    [sym_assignment] = STATE(12171),
    [sym_open_tuple] = STATE(13434),
    [sym__expression] = STATE(13062),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11242),
    [sym__array] = STATE(11242),
    [sym_comprehension_expression] = STATE(11242),
    [sym_matrix_expression] = STATE(11242),
    [sym_vector_expression] = STATE(11242),
    [sym_parenthesized_expression] = STATE(11242),
    [sym_tuple_expression] = STATE(11242),
    [sym_curly_expression] = STATE(11242),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11242),
    [sym_index_expression] = STATE(11242),
    [sym_parametrized_type_expression] = STATE(11242),
    [sym_call_expression] = STATE(11242),
    [sym_broadcast_call_expression] = STATE(11242),
    [sym__closed_macrocall_expression] = STATE(11242),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11242),
    [sym_quote_expression] = STATE(11242),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12994),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11242),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11242),
    [sym_string_literal] = STATE(11242),
    [sym_command_literal] = STATE(11242),
    [sym_prefixed_string_literal] = STATE(11242),
    [sym_prefixed_command_literal] = STATE(11242),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3164),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [279] = {
    [sym_assignment] = STATE(12171),
    [sym_open_tuple] = STATE(13264),
    [sym__expression] = STATE(13266),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11225),
    [sym__array] = STATE(11225),
    [sym_comprehension_expression] = STATE(11225),
    [sym_matrix_expression] = STATE(11225),
    [sym_vector_expression] = STATE(11225),
    [sym_parenthesized_expression] = STATE(11225),
    [sym_tuple_expression] = STATE(11225),
    [sym_curly_expression] = STATE(11225),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11225),
    [sym_index_expression] = STATE(11225),
    [sym_parametrized_type_expression] = STATE(11225),
    [sym_call_expression] = STATE(11225),
    [sym_broadcast_call_expression] = STATE(11225),
    [sym__closed_macrocall_expression] = STATE(11225),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11225),
    [sym_quote_expression] = STATE(11225),
    [sym_binary_expression] = STATE(13238),
    [sym_unary_expression] = STATE(13238),
    [sym_range_expression] = STATE(13238),
    [sym_splat_expression] = STATE(13238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13077),
    [sym_unary_typed_expression] = STATE(13238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13238),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11225),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11225),
    [sym_string_literal] = STATE(11225),
    [sym_command_literal] = STATE(11225),
    [sym_prefixed_string_literal] = STATE(11225),
    [sym_prefixed_command_literal] = STATE(11225),
    [sym_operator] = STATE(13078),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3178),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [280] = {
    [sym_assignment] = STATE(269),
    [sym_open_tuple] = STATE(9165),
    [sym__expression] = STATE(9171),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [aux_sym_macro_argument_list_repeat1] = STATE(269),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [281] = {
    [sym_assignment] = STATE(269),
    [sym_open_tuple] = STATE(9165),
    [sym__expression] = STATE(9171),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [aux_sym_macro_argument_list_repeat1] = STATE(269),
    [sym__word_identifier] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(1503),
    [anon_sym_module] = ACTIONS(1503),
    [anon_sym_baremodule] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(1503),
    [anon_sym_primitive] = ACTIONS(1503),
    [anon_sym_mutable] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_function] = ACTIONS(1503),
    [anon_sym_macro] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_try] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [sym_break_statement] = ACTIONS(1503),
    [sym_continue_statement] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_global] = ACTIONS(1503),
    [anon_sym_local] = ACTIONS(1503),
    [anon_sym_LPAREN] = ACTIONS(1505),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(1503),
    [anon_sym_import] = ACTIONS(1503),
    [anon_sym_using] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_DOLLAR] = ACTIONS(1505),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(1505),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [aux_sym_integer_literal_token1] = ACTIONS(1505),
    [aux_sym_integer_literal_token2] = ACTIONS(1505),
    [aux_sym_integer_literal_token3] = ACTIONS(1503),
    [aux_sym_integer_literal_token4] = ACTIONS(1503),
    [aux_sym_float_literal_token1] = ACTIONS(1505),
    [aux_sym_float_literal_token3] = ACTIONS(1505),
    [aux_sym_float_literal_token4] = ACTIONS(1505),
    [sym_character_literal] = ACTIONS(1505),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(1505),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(1503),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1505),
    [sym__command_start] = ACTIONS(1505),
  },
  [282] = {
    [sym_assignment] = STATE(12793),
    [sym_open_tuple] = STATE(12377),
    [sym__expression] = STATE(12794),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10619),
    [sym__array] = STATE(10619),
    [sym_comprehension_expression] = STATE(10619),
    [sym_matrix_expression] = STATE(10619),
    [sym_vector_expression] = STATE(10619),
    [sym_parenthesized_expression] = STATE(10619),
    [sym_tuple_expression] = STATE(10619),
    [sym_curly_expression] = STATE(10619),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10619),
    [sym_index_expression] = STATE(10619),
    [sym_parametrized_type_expression] = STATE(10619),
    [sym_call_expression] = STATE(10619),
    [sym_broadcast_call_expression] = STATE(10619),
    [sym__closed_macrocall_expression] = STATE(10619),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(10619),
    [sym_quote_expression] = STATE(10619),
    [sym_binary_expression] = STATE(12555),
    [sym_unary_expression] = STATE(12555),
    [sym_range_expression] = STATE(12555),
    [sym_splat_expression] = STATE(12555),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12201),
    [sym_unary_typed_expression] = STATE(12555),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12555),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(10619),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10619),
    [sym_string_literal] = STATE(10619),
    [sym_command_literal] = STATE(10619),
    [sym_prefixed_string_literal] = STATE(10619),
    [sym_prefixed_command_literal] = STATE(10619),
    [sym_operator] = STATE(12161),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(2764),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2774),
    [anon_sym_COLON_COLON] = ACTIONS(2776),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(3188),
    [sym__pair_operator] = ACTIONS(2782),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(2782),
    [sym__pipe_left_operator] = ACTIONS(2782),
    [sym__ellipsis_operator] = ACTIONS(2782),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(2782),
    [sym__bitshift_operator] = ACTIONS(2782),
    [sym__power_operator] = ACTIONS(2782),
    [sym__tilde_operator] = ACTIONS(2784),
    [sym__type_order_operator] = ACTIONS(2784),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [283] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(12817),
    [sym__expression] = STATE(12629),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10630),
    [sym__array] = STATE(10630),
    [sym_comprehension_expression] = STATE(10630),
    [sym_matrix_expression] = STATE(10630),
    [sym_vector_expression] = STATE(10630),
    [sym_parenthesized_expression] = STATE(10630),
    [sym_tuple_expression] = STATE(10630),
    [sym_curly_expression] = STATE(10630),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10630),
    [sym_index_expression] = STATE(10630),
    [sym_parametrized_type_expression] = STATE(10630),
    [sym_call_expression] = STATE(10630),
    [sym_broadcast_call_expression] = STATE(10630),
    [sym__closed_macrocall_expression] = STATE(10630),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(10630),
    [sym_quote_expression] = STATE(10630),
    [sym_binary_expression] = STATE(12247),
    [sym_unary_expression] = STATE(12247),
    [sym_range_expression] = STATE(12247),
    [sym_splat_expression] = STATE(12247),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12247),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12247),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(10630),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10630),
    [sym_string_literal] = STATE(10630),
    [sym_command_literal] = STATE(10630),
    [sym_prefixed_string_literal] = STATE(10630),
    [sym_prefixed_command_literal] = STATE(10630),
    [sym_operator] = STATE(11897),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(1759),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_COLON_COLON] = ACTIONS(2985),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(3198),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2989),
    [sym__type_order_operator] = ACTIONS(2989),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [284] = {
    [sym__block] = STATE(19681),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3200),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3202),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3204),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [285] = {
    [sym_assignment] = STATE(9082),
    [sym_open_tuple] = STATE(8948),
    [sym__expression] = STATE(9083),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(1181),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [286] = {
    [sym__block] = STATE(18402),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3206),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3208),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [287] = {
    [sym__expression] = STATE(9102),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(3212),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [288] = {
    [sym_assignment] = STATE(8499),
    [sym_open_tuple] = STATE(8846),
    [sym__expression] = STATE(8848),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(1769),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [289] = {
    [sym__expression] = STATE(8865),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [290] = {
    [sym__expression] = STATE(13224),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_COLON_COLON] = ACTIONS(2692),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2694),
    [aux_sym_integer_literal_token2] = ACTIONS(2694),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(2698),
    [aux_sym_float_literal_token3] = ACTIONS(2698),
    [aux_sym_float_literal_token4] = ACTIONS(2698),
    [sym_character_literal] = ACTIONS(3216),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(3218),
    [sym__type_order_operator] = ACTIONS(3218),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [291] = {
    [sym__block] = STATE(18999),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3220),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3222),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3224),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [292] = {
    [sym__expression] = STATE(9018),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_DOLLAR] = ACTIONS(665),
    [anon_sym_COLON_COLON] = ACTIONS(667),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(673),
    [aux_sym_integer_literal_token2] = ACTIONS(673),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(677),
    [aux_sym_float_literal_token3] = ACTIONS(677),
    [aux_sym_float_literal_token4] = ACTIONS(677),
    [sym_character_literal] = ACTIONS(3226),
    [sym__pair_operator] = ACTIONS(681),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(681),
    [sym__pipe_left_operator] = ACTIONS(681),
    [sym__ellipsis_operator] = ACTIONS(681),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(681),
    [sym__bitshift_operator] = ACTIONS(681),
    [sym__power_operator] = ACTIONS(681),
    [sym__tilde_operator] = ACTIONS(3228),
    [sym__type_order_operator] = ACTIONS(3228),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [293] = {
    [sym_assignment] = STATE(8499),
    [sym_open_tuple] = STATE(9176),
    [sym__expression] = STATE(9134),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [294] = {
    [sym__block] = STATE(18266),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3230),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3232),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3234),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [295] = {
    [sym__block] = STATE(19170),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3236),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3238),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [296] = {
    [sym__block] = STATE(18182),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3242),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3244),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3246),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [297] = {
    [sym__expression] = STATE(9040),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_COLON_COLON] = ACTIONS(743),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(749),
    [aux_sym_integer_literal_token2] = ACTIONS(749),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(753),
    [aux_sym_float_literal_token3] = ACTIONS(753),
    [aux_sym_float_literal_token4] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(3248),
    [sym__pair_operator] = ACTIONS(757),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(757),
    [sym__pipe_left_operator] = ACTIONS(757),
    [sym__ellipsis_operator] = ACTIONS(757),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(757),
    [sym__bitshift_operator] = ACTIONS(757),
    [sym__power_operator] = ACTIONS(757),
    [sym__tilde_operator] = ACTIONS(3250),
    [sym__type_order_operator] = ACTIONS(3250),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [298] = {
    [sym__block] = STATE(18555),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3252),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3254),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [299] = {
    [sym__block] = STATE(19027),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3258),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3260),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3262),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [300] = {
    [sym__expression] = STATE(13355),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2225),
    [anon_sym_COLON_COLON] = ACTIONS(2227),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2229),
    [aux_sym_integer_literal_token2] = ACTIONS(2229),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(2233),
    [aux_sym_float_literal_token3] = ACTIONS(2233),
    [aux_sym_float_literal_token4] = ACTIONS(2233),
    [sym_character_literal] = ACTIONS(3264),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(3266),
    [sym__type_order_operator] = ACTIONS(3266),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [301] = {
    [sym__block] = STATE(19576),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3270),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [302] = {
    [sym__block] = STATE(19319),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3274),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3276),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3278),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [303] = {
    [sym__block] = STATE(19553),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3280),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(3282),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(3077),
    [sym__arrow_operator] = ACTIONS(3079),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__pipe_right_operator] = ACTIONS(3087),
    [sym__pipe_left_operator] = ACTIONS(3089),
    [sym__ellipsis_operator] = ACTIONS(3091),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3095),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3099),
    [sym__power_operator] = ACTIONS(3101),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(3103),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(3105),
    [aux_sym__terminator_token1] = ACTIONS(3284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [304] = {
    [sym_assignment] = STATE(10692),
    [sym_open_tuple] = STATE(13313),
    [sym__expression] = STATE(13346),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11200),
    [sym__array] = STATE(11200),
    [sym_comprehension_expression] = STATE(11200),
    [sym_matrix_expression] = STATE(11200),
    [sym_vector_expression] = STATE(11200),
    [sym_parenthesized_expression] = STATE(11200),
    [sym_tuple_expression] = STATE(11200),
    [sym_curly_expression] = STATE(11200),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11200),
    [sym_index_expression] = STATE(11200),
    [sym_parametrized_type_expression] = STATE(11200),
    [sym_call_expression] = STATE(11200),
    [sym_broadcast_call_expression] = STATE(11200),
    [sym__closed_macrocall_expression] = STATE(11200),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11200),
    [sym_quote_expression] = STATE(11200),
    [sym_binary_expression] = STATE(13364),
    [sym_unary_expression] = STATE(13364),
    [sym_range_expression] = STATE(13364),
    [sym_splat_expression] = STATE(13364),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12999),
    [sym_unary_typed_expression] = STATE(13364),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13364),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11200),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11200),
    [sym_string_literal] = STATE(11200),
    [sym_command_literal] = STATE(11200),
    [sym_prefixed_string_literal] = STATE(11200),
    [sym_prefixed_command_literal] = STATE(11200),
    [sym_operator] = STATE(13000),
    [ts_builtin_sym_end] = ACTIONS(1769),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(3025),
    [anon_sym_COLON_COLON] = ACTIONS(3027),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(69),
    [aux_sym_integer_literal_token2] = ACTIONS(69),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(3029),
    [aux_sym_float_literal_token3] = ACTIONS(3029),
    [aux_sym_float_literal_token4] = ACTIONS(3029),
    [sym_character_literal] = ACTIONS(3286),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(1759),
    [sym__lazy_and_operator] = ACTIONS(1759),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(83),
    [sym__type_order_operator] = ACTIONS(83),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [aux_sym__terminator_token1] = ACTIONS(1759),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [305] = {
    [sym_assignment] = STATE(184),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(184),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [306] = {
    [sym__expression] = STATE(13334),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [307] = {
    [sym__expression] = STATE(9073),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(373),
    [anon_sym_COLON_COLON] = ACTIONS(375),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(381),
    [aux_sym_integer_literal_token2] = ACTIONS(381),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(385),
    [aux_sym_float_literal_token3] = ACTIONS(385),
    [aux_sym_float_literal_token4] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(2190),
    [sym__pair_operator] = ACTIONS(389),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(389),
    [sym__pipe_left_operator] = ACTIONS(389),
    [sym__ellipsis_operator] = ACTIONS(389),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(389),
    [sym__bitshift_operator] = ACTIONS(389),
    [sym__power_operator] = ACTIONS(389),
    [sym__tilde_operator] = ACTIONS(2192),
    [sym__type_order_operator] = ACTIONS(2192),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [308] = {
    [sym__expression] = STATE(9043),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_COLON_COLON] = ACTIONS(585),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(591),
    [aux_sym_integer_literal_token2] = ACTIONS(591),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(595),
    [aux_sym_float_literal_token3] = ACTIONS(595),
    [aux_sym_float_literal_token4] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(3290),
    [sym__pair_operator] = ACTIONS(599),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(599),
    [sym__pipe_left_operator] = ACTIONS(599),
    [sym__ellipsis_operator] = ACTIONS(599),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(599),
    [sym__bitshift_operator] = ACTIONS(599),
    [sym__power_operator] = ACTIONS(599),
    [sym__tilde_operator] = ACTIONS(3292),
    [sym__type_order_operator] = ACTIONS(3292),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [309] = {
    [sym__expression] = STATE(9141),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON_COLON] = ACTIONS(977),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(3294),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3296),
    [sym__type_order_operator] = ACTIONS(3296),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [310] = {
    [sym__expression] = STATE(13480),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(3025),
    [anon_sym_COLON_COLON] = ACTIONS(3027),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(69),
    [aux_sym_integer_literal_token2] = ACTIONS(69),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(3029),
    [aux_sym_float_literal_token3] = ACTIONS(3029),
    [aux_sym_float_literal_token4] = ACTIONS(3029),
    [sym_character_literal] = ACTIONS(3298),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(3300),
    [sym__type_order_operator] = ACTIONS(3300),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [311] = {
    [sym__expression] = STATE(13470),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [312] = {
    [sym_assignment] = STATE(184),
    [sym_open_tuple] = STATE(8963),
    [sym__expression] = STATE(8731),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [aux_sym_macro_argument_list_repeat1] = STATE(184),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [313] = {
    [sym_assignment] = STATE(228),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(228),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1505),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [314] = {
    [sym_assignment] = STATE(12171),
    [sym_open_tuple] = STATE(13317),
    [sym__expression] = STATE(13318),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11231),
    [sym__array] = STATE(11231),
    [sym_comprehension_expression] = STATE(11231),
    [sym_matrix_expression] = STATE(11231),
    [sym_vector_expression] = STATE(11231),
    [sym_parenthesized_expression] = STATE(11231),
    [sym_tuple_expression] = STATE(11231),
    [sym_curly_expression] = STATE(11231),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11231),
    [sym_index_expression] = STATE(11231),
    [sym_parametrized_type_expression] = STATE(11231),
    [sym_call_expression] = STATE(11231),
    [sym_broadcast_call_expression] = STATE(11231),
    [sym__closed_macrocall_expression] = STATE(11231),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11231),
    [sym_quote_expression] = STATE(11231),
    [sym_binary_expression] = STATE(13208),
    [sym_unary_expression] = STATE(13208),
    [sym_range_expression] = STATE(13208),
    [sym_splat_expression] = STATE(13208),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13154),
    [sym_unary_typed_expression] = STATE(13208),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13208),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11231),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11231),
    [sym_string_literal] = STATE(11231),
    [sym_command_literal] = STATE(11231),
    [sym_prefixed_string_literal] = STATE(11231),
    [sym_prefixed_command_literal] = STATE(11231),
    [sym_operator] = STATE(13060),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3316),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [315] = {
    [sym_assignment] = STATE(12171),
    [sym_open_tuple] = STATE(13551),
    [sym__expression] = STATE(13582),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11408),
    [sym__array] = STATE(11408),
    [sym_comprehension_expression] = STATE(11408),
    [sym_matrix_expression] = STATE(11408),
    [sym_vector_expression] = STATE(11408),
    [sym_parenthesized_expression] = STATE(11408),
    [sym_tuple_expression] = STATE(11408),
    [sym_curly_expression] = STATE(11408),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11408),
    [sym_index_expression] = STATE(11408),
    [sym_parametrized_type_expression] = STATE(11408),
    [sym_call_expression] = STATE(11408),
    [sym_broadcast_call_expression] = STATE(11408),
    [sym__closed_macrocall_expression] = STATE(11408),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11408),
    [sym_quote_expression] = STATE(11408),
    [sym_binary_expression] = STATE(13579),
    [sym_unary_expression] = STATE(13579),
    [sym_range_expression] = STATE(13579),
    [sym_splat_expression] = STATE(13579),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13229),
    [sym_unary_typed_expression] = STATE(13579),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13579),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11408),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11408),
    [sym_string_literal] = STATE(11408),
    [sym_command_literal] = STATE(11408),
    [sym_prefixed_string_literal] = STATE(11408),
    [sym_prefixed_command_literal] = STATE(11408),
    [sym_operator] = STATE(13343),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3326),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [316] = {
    [sym__expression] = STATE(13596),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [317] = {
    [sym__expression] = STATE(9207),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [318] = {
    [sym__expression] = STATE(13325),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [319] = {
    [sym__expression] = STATE(13465),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(3338),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(3340),
    [sym__type_order_operator] = ACTIONS(3340),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [320] = {
    [sym__expression] = STATE(9242),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [321] = {
    [sym_assignment] = STATE(12171),
    [sym_open_tuple] = STATE(13488),
    [sym__expression] = STATE(13375),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11391),
    [sym__array] = STATE(11391),
    [sym_comprehension_expression] = STATE(11391),
    [sym_matrix_expression] = STATE(11391),
    [sym_vector_expression] = STATE(11391),
    [sym_parenthesized_expression] = STATE(11391),
    [sym_tuple_expression] = STATE(11391),
    [sym_curly_expression] = STATE(11391),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11391),
    [sym_index_expression] = STATE(11391),
    [sym_parametrized_type_expression] = STATE(11391),
    [sym_call_expression] = STATE(11391),
    [sym_broadcast_call_expression] = STATE(11391),
    [sym__closed_macrocall_expression] = STATE(11391),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11391),
    [sym_quote_expression] = STATE(11391),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13432),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11391),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11391),
    [sym_string_literal] = STATE(11391),
    [sym_command_literal] = STATE(11391),
    [sym_prefixed_string_literal] = STATE(11391),
    [sym_prefixed_command_literal] = STATE(11391),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3352),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [322] = {
    [sym__expression] = STATE(13047),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(2764),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2774),
    [anon_sym_COLON_COLON] = ACTIONS(2776),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(3358),
    [sym__pair_operator] = ACTIONS(2782),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(2782),
    [sym__pipe_left_operator] = ACTIONS(2782),
    [sym__ellipsis_operator] = ACTIONS(2782),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(2782),
    [sym__bitshift_operator] = ACTIONS(2782),
    [sym__power_operator] = ACTIONS(2782),
    [sym__tilde_operator] = ACTIONS(3360),
    [sym__type_order_operator] = ACTIONS(3360),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [323] = {
    [sym__expression] = STATE(9202),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(3362),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [324] = {
    [sym_assignment] = STATE(8499),
    [sym_open_tuple] = STATE(9146),
    [sym__expression] = STATE(9239),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [325] = {
    [sym__expression] = STATE(9198),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3366),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3368),
    [sym__type_order_operator] = ACTIONS(3368),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [326] = {
    [sym__expression] = STATE(12919),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_COLON_COLON] = ACTIONS(2985),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(3370),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(3372),
    [sym__type_order_operator] = ACTIONS(3372),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [327] = {
    [sym_assignment] = STATE(12171),
    [sym_open_tuple] = STATE(13581),
    [sym__expression] = STATE(13601),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11423),
    [sym__array] = STATE(11423),
    [sym_comprehension_expression] = STATE(11423),
    [sym_matrix_expression] = STATE(11423),
    [sym_vector_expression] = STATE(11423),
    [sym_parenthesized_expression] = STATE(11423),
    [sym_tuple_expression] = STATE(11423),
    [sym_curly_expression] = STATE(11423),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11423),
    [sym_index_expression] = STATE(11423),
    [sym_parametrized_type_expression] = STATE(11423),
    [sym_call_expression] = STATE(11423),
    [sym_broadcast_call_expression] = STATE(11423),
    [sym__closed_macrocall_expression] = STATE(11423),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11423),
    [sym_quote_expression] = STATE(11423),
    [sym_binary_expression] = STATE(13598),
    [sym_unary_expression] = STATE(13598),
    [sym_range_expression] = STATE(13598),
    [sym_splat_expression] = STATE(13598),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13295),
    [sym_unary_typed_expression] = STATE(13598),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13598),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11423),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11423),
    [sym_string_literal] = STATE(11423),
    [sym_command_literal] = STATE(11423),
    [sym_prefixed_string_literal] = STATE(11423),
    [sym_prefixed_command_literal] = STATE(11423),
    [sym_operator] = STATE(13182),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(1769),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3382),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [328] = {
    [sym__expression] = STATE(9254),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(887),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [329] = {
    [sym_assignment] = STATE(12171),
    [sym_open_tuple] = STATE(13773),
    [sym__expression] = STATE(13504),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11496),
    [sym__array] = STATE(11496),
    [sym_comprehension_expression] = STATE(11496),
    [sym_matrix_expression] = STATE(11496),
    [sym_vector_expression] = STATE(11496),
    [sym_parenthesized_expression] = STATE(11496),
    [sym_tuple_expression] = STATE(11496),
    [sym_curly_expression] = STATE(11496),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11496),
    [sym_index_expression] = STATE(11496),
    [sym_parametrized_type_expression] = STATE(11496),
    [sym_call_expression] = STATE(11496),
    [sym_broadcast_call_expression] = STATE(11496),
    [sym__closed_macrocall_expression] = STATE(11496),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11496),
    [sym_quote_expression] = STATE(11496),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13592),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11496),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11496),
    [sym_string_literal] = STATE(11496),
    [sym_command_literal] = STATE(11496),
    [sym_prefixed_string_literal] = STATE(11496),
    [sym_prefixed_command_literal] = STATE(11496),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3398),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [330] = {
    [sym__expression] = STATE(9288),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_DOLLAR] = ACTIONS(1063),
    [anon_sym_COLON_COLON] = ACTIONS(1065),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(1069),
    [aux_sym_integer_literal_token2] = ACTIONS(1069),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(1073),
    [aux_sym_float_literal_token3] = ACTIONS(1073),
    [aux_sym_float_literal_token4] = ACTIONS(1073),
    [sym_character_literal] = ACTIONS(3057),
    [sym__pair_operator] = ACTIONS(1077),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(1077),
    [sym__pipe_left_operator] = ACTIONS(1077),
    [sym__ellipsis_operator] = ACTIONS(1077),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(1077),
    [sym__bitshift_operator] = ACTIONS(1077),
    [sym__power_operator] = ACTIONS(1077),
    [sym__tilde_operator] = ACTIONS(3059),
    [sym__type_order_operator] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [331] = {
    [sym__expression] = STATE(13338),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(2764),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2774),
    [anon_sym_COLON_COLON] = ACTIONS(2776),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(3404),
    [sym__pair_operator] = ACTIONS(2782),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(2782),
    [sym__pipe_left_operator] = ACTIONS(2782),
    [sym__ellipsis_operator] = ACTIONS(2782),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(2782),
    [sym__bitshift_operator] = ACTIONS(2782),
    [sym__power_operator] = ACTIONS(2782),
    [sym__tilde_operator] = ACTIONS(3406),
    [sym__type_order_operator] = ACTIONS(3406),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [332] = {
    [sym__expression] = STATE(13281),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_COLON_COLON] = ACTIONS(2985),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(3408),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(3410),
    [sym__type_order_operator] = ACTIONS(3410),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [333] = {
    [sym__expression] = STATE(13539),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [334] = {
    [sym_assignment] = STATE(228),
    [sym_open_tuple] = STATE(8970),
    [sym__expression] = STATE(8982),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [aux_sym_macro_argument_list_repeat1] = STATE(228),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(1505),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_where] = ACTIONS(1503),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_COLON2] = ACTIONS(1503),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_isa] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1505),
    [anon_sym_QMARK] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(1505),
    [sym__arrow_operator] = ACTIONS(1503),
    [sym__lazy_or_operator] = ACTIONS(1505),
    [sym__lazy_and_operator] = ACTIONS(1505),
    [sym__comparison_operator] = ACTIONS(1503),
    [sym__pipe_right_operator] = ACTIONS(1505),
    [sym__pipe_left_operator] = ACTIONS(1505),
    [sym__ellipsis_operator] = ACTIONS(1503),
    [sym__plus_operator] = ACTIONS(1503),
    [sym__times_operator] = ACTIONS(1503),
    [sym__rational_operator] = ACTIONS(1505),
    [sym__bitshift_operator] = ACTIONS(1505),
    [sym__power_operator] = ACTIONS(1505),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(1505),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [335] = {
    [sym__expression] = STATE(13462),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [336] = {
    [sym__expression] = STATE(13548),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [337] = {
    [sym__expression] = STATE(13932),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [338] = {
    [sym__expression] = STATE(9305),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(3432),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3434),
    [sym__type_order_operator] = ACTIONS(3434),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [339] = {
    [sym__closed_assignment] = STATE(14739),
    [sym__expression] = STATE(11899),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17969),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3436),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3438),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3444),
    [anon_sym_COLON_EQ] = ACTIONS(3446),
    [anon_sym_DOT_EQ] = ACTIONS(3436),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3436),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3446),
    [sym__lazy_and_operator] = ACTIONS(3446),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3436),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [340] = {
    [sym__closed_assignment] = STATE(15154),
    [sym__expression] = STATE(12046),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17772),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3450),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3452),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3454),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3456),
    [anon_sym_COLON_EQ] = ACTIONS(3458),
    [anon_sym_DOT_EQ] = ACTIONS(3450),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3450),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3458),
    [sym__lazy_and_operator] = ACTIONS(3458),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3450),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [341] = {
    [sym__closed_assignment] = STATE(15006),
    [sym__expression] = STATE(12035),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17719),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3460),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3462),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3464),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3466),
    [anon_sym_COLON_EQ] = ACTIONS(3468),
    [anon_sym_DOT_EQ] = ACTIONS(3460),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3460),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3468),
    [sym__lazy_and_operator] = ACTIONS(3468),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3460),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [342] = {
    [sym__closed_assignment] = STATE(15068),
    [sym__expression] = STATE(11904),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17792),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3472),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3476),
    [anon_sym_COLON_EQ] = ACTIONS(3478),
    [anon_sym_DOT_EQ] = ACTIONS(3470),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3470),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3478),
    [sym__lazy_and_operator] = ACTIONS(3478),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3470),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [343] = {
    [sym__closed_assignment] = STATE(14833),
    [sym__expression] = STATE(11909),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17681),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3480),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3482),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3484),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3486),
    [anon_sym_COLON_EQ] = ACTIONS(3488),
    [anon_sym_DOT_EQ] = ACTIONS(3480),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3480),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3488),
    [sym__lazy_and_operator] = ACTIONS(3488),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [344] = {
    [sym__closed_assignment] = STATE(14750),
    [sym__expression] = STATE(12057),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17808),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3490),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3492),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3496),
    [anon_sym_COLON_EQ] = ACTIONS(3498),
    [anon_sym_DOT_EQ] = ACTIONS(3490),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3490),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3498),
    [sym__lazy_and_operator] = ACTIONS(3498),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3490),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [345] = {
    [sym__closed_assignment] = STATE(15050),
    [sym__expression] = STATE(12009),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(18071),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3500),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3502),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3506),
    [anon_sym_COLON_EQ] = ACTIONS(3508),
    [anon_sym_DOT_EQ] = ACTIONS(3500),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3500),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3508),
    [sym__lazy_and_operator] = ACTIONS(3508),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3500),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [346] = {
    [sym__closed_assignment] = STATE(14945),
    [sym__expression] = STATE(12080),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17842),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3510),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3512),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3514),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3516),
    [anon_sym_COLON_EQ] = ACTIONS(3518),
    [anon_sym_DOT_EQ] = ACTIONS(3510),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3510),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3518),
    [sym__lazy_and_operator] = ACTIONS(3518),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3510),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [347] = {
    [sym__closed_assignment] = STATE(14694),
    [sym__expression] = STATE(11934),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17520),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3520),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3522),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3526),
    [anon_sym_COLON_EQ] = ACTIONS(3528),
    [anon_sym_DOT_EQ] = ACTIONS(3520),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3520),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3528),
    [sym__lazy_and_operator] = ACTIONS(3528),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3520),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [348] = {
    [sym__expression] = STATE(13799),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [349] = {
    [sym__closed_assignment] = STATE(14989),
    [sym__expression] = STATE(12204),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17858),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3536),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3538),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3542),
    [anon_sym_COLON_EQ] = ACTIONS(3544),
    [anon_sym_DOT_EQ] = ACTIONS(3536),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3536),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3544),
    [sym__lazy_and_operator] = ACTIONS(3544),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [350] = {
    [sym__expression] = STATE(13895),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [351] = {
    [sym__closed_assignment] = STATE(15061),
    [sym__expression] = STATE(11972),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17872),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3552),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3554),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3558),
    [anon_sym_COLON_EQ] = ACTIONS(3560),
    [anon_sym_DOT_EQ] = ACTIONS(3552),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3552),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3560),
    [sym__lazy_and_operator] = ACTIONS(3560),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3552),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [352] = {
    [sym__closed_assignment] = STATE(15142),
    [sym__expression] = STATE(12093),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17883),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3562),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3564),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3566),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3568),
    [anon_sym_COLON_EQ] = ACTIONS(3570),
    [anon_sym_DOT_EQ] = ACTIONS(3562),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3562),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3570),
    [sym__lazy_and_operator] = ACTIONS(3570),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3562),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [353] = {
    [sym__closed_assignment] = STATE(15141),
    [sym__expression] = STATE(11926),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17888),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3572),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3574),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3578),
    [anon_sym_COLON_EQ] = ACTIONS(3580),
    [anon_sym_DOT_EQ] = ACTIONS(3572),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3572),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3580),
    [sym__lazy_and_operator] = ACTIONS(3580),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3572),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [354] = {
    [sym__closed_assignment] = STATE(14954),
    [sym__expression] = STATE(11944),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17891),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3582),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3584),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3586),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3588),
    [anon_sym_COLON_EQ] = ACTIONS(3590),
    [anon_sym_DOT_EQ] = ACTIONS(3582),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3582),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3590),
    [sym__lazy_and_operator] = ACTIONS(3590),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3582),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [355] = {
    [sym__closed_assignment] = STATE(14573),
    [sym__expression] = STATE(12011),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17898),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3592),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3594),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3596),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3598),
    [anon_sym_COLON_EQ] = ACTIONS(3600),
    [anon_sym_DOT_EQ] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3592),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3600),
    [sym__lazy_and_operator] = ACTIONS(3600),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3592),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [356] = {
    [sym__closed_assignment] = STATE(15009),
    [sym__expression] = STATE(11958),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17900),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3604),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3606),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_COLON_EQ] = ACTIONS(3610),
    [anon_sym_DOT_EQ] = ACTIONS(3602),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3602),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3610),
    [sym__lazy_and_operator] = ACTIONS(3610),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [357] = {
    [sym__closed_assignment] = STATE(14651),
    [sym__expression] = STATE(11905),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17907),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3612),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3614),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3618),
    [anon_sym_COLON_EQ] = ACTIONS(3620),
    [anon_sym_DOT_EQ] = ACTIONS(3612),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3612),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3620),
    [sym__lazy_and_operator] = ACTIONS(3620),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3612),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [358] = {
    [sym__closed_assignment] = STATE(14756),
    [sym__expression] = STATE(12092),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17340),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3622),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3624),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3628),
    [anon_sym_COLON_EQ] = ACTIONS(3630),
    [anon_sym_DOT_EQ] = ACTIONS(3622),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3622),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3630),
    [sym__lazy_and_operator] = ACTIONS(3630),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3622),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [359] = {
    [sym__closed_assignment] = STATE(14952),
    [sym__expression] = STATE(12030),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17914),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3632),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3634),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3636),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3638),
    [anon_sym_COLON_EQ] = ACTIONS(3640),
    [anon_sym_DOT_EQ] = ACTIONS(3632),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3632),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3640),
    [sym__lazy_and_operator] = ACTIONS(3640),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3632),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [360] = {
    [sym__closed_assignment] = STATE(15030),
    [sym__expression] = STATE(11967),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17918),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3642),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3644),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3648),
    [anon_sym_COLON_EQ] = ACTIONS(3650),
    [anon_sym_DOT_EQ] = ACTIONS(3642),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3642),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3650),
    [sym__lazy_and_operator] = ACTIONS(3650),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3642),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [361] = {
    [sym__closed_assignment] = STATE(15121),
    [sym__expression] = STATE(12047),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17925),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3652),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3654),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3656),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3658),
    [anon_sym_COLON_EQ] = ACTIONS(3660),
    [anon_sym_DOT_EQ] = ACTIONS(3652),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3652),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3660),
    [sym__lazy_and_operator] = ACTIONS(3660),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3652),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [362] = {
    [sym__closed_assignment] = STATE(14548),
    [sym__expression] = STATE(12172),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17928),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3662),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3666),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3668),
    [anon_sym_COLON_EQ] = ACTIONS(3670),
    [anon_sym_DOT_EQ] = ACTIONS(3662),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3662),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3670),
    [sym__lazy_and_operator] = ACTIONS(3670),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3662),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [363] = {
    [sym__closed_assignment] = STATE(14662),
    [sym__expression] = STATE(11930),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17931),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3672),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3674),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3678),
    [anon_sym_COLON_EQ] = ACTIONS(3680),
    [anon_sym_DOT_EQ] = ACTIONS(3672),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3672),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3680),
    [sym__lazy_and_operator] = ACTIONS(3680),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3672),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [364] = {
    [sym__closed_assignment] = STATE(14684),
    [sym__expression] = STATE(12105),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17934),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3682),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3684),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3686),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3688),
    [anon_sym_COLON_EQ] = ACTIONS(3690),
    [anon_sym_DOT_EQ] = ACTIONS(3682),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3682),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3690),
    [sym__lazy_and_operator] = ACTIONS(3690),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3682),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [365] = {
    [sym__closed_assignment] = STATE(14801),
    [sym__expression] = STATE(11927),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17935),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3692),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3694),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3696),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3698),
    [anon_sym_COLON_EQ] = ACTIONS(3700),
    [anon_sym_DOT_EQ] = ACTIONS(3692),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3692),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3700),
    [sym__lazy_and_operator] = ACTIONS(3700),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3692),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [366] = {
    [sym__closed_assignment] = STATE(14963),
    [sym__expression] = STATE(12129),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17937),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3702),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3704),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3708),
    [anon_sym_COLON_EQ] = ACTIONS(3710),
    [anon_sym_DOT_EQ] = ACTIONS(3702),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3710),
    [sym__lazy_and_operator] = ACTIONS(3710),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [367] = {
    [sym__closed_assignment] = STATE(15124),
    [sym__expression] = STATE(12243),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17942),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3712),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3714),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3716),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3718),
    [anon_sym_COLON_EQ] = ACTIONS(3720),
    [anon_sym_DOT_EQ] = ACTIONS(3712),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3712),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3720),
    [sym__lazy_and_operator] = ACTIONS(3720),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3712),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [368] = {
    [sym__closed_assignment] = STATE(14705),
    [sym__expression] = STATE(11898),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17895),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3722),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3724),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3728),
    [anon_sym_COLON_EQ] = ACTIONS(3730),
    [anon_sym_DOT_EQ] = ACTIONS(3722),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3722),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3730),
    [sym__lazy_and_operator] = ACTIONS(3730),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3722),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [369] = {
    [sym__closed_assignment] = STATE(14585),
    [sym__expression] = STATE(12026),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17947),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3734),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3738),
    [anon_sym_COLON_EQ] = ACTIONS(3740),
    [anon_sym_DOT_EQ] = ACTIONS(3732),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3732),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3740),
    [sym__lazy_and_operator] = ACTIONS(3740),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [370] = {
    [sym__closed_assignment] = STATE(14872),
    [sym__expression] = STATE(11910),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17913),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3742),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3746),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3748),
    [anon_sym_COLON_EQ] = ACTIONS(3750),
    [anon_sym_DOT_EQ] = ACTIONS(3742),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3742),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3750),
    [sym__lazy_and_operator] = ACTIONS(3750),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [371] = {
    [sym__closed_assignment] = STATE(14619),
    [sym__expression] = STATE(12021),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17953),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3752),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3754),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3758),
    [anon_sym_COLON_EQ] = ACTIONS(3760),
    [anon_sym_DOT_EQ] = ACTIONS(3752),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3752),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3760),
    [sym__lazy_and_operator] = ACTIONS(3760),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3752),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [372] = {
    [sym__closed_assignment] = STATE(15084),
    [sym__expression] = STATE(11875),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17923),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3762),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3768),
    [anon_sym_COLON_EQ] = ACTIONS(3770),
    [anon_sym_DOT_EQ] = ACTIONS(3762),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3762),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3770),
    [sym__lazy_and_operator] = ACTIONS(3770),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3762),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [373] = {
    [sym__closed_assignment] = STATE(14650),
    [sym__expression] = STATE(12000),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17956),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3774),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3778),
    [anon_sym_COLON_EQ] = ACTIONS(3780),
    [anon_sym_DOT_EQ] = ACTIONS(3772),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3772),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3780),
    [sym__lazy_and_operator] = ACTIONS(3780),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3772),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [374] = {
    [sym__closed_assignment] = STATE(14673),
    [sym__expression] = STATE(12013),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17958),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3782),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3784),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3788),
    [anon_sym_COLON_EQ] = ACTIONS(3790),
    [anon_sym_DOT_EQ] = ACTIONS(3782),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3782),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3790),
    [sym__lazy_and_operator] = ACTIONS(3790),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3782),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [375] = {
    [sym__closed_assignment] = STATE(14699),
    [sym__expression] = STATE(11915),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17960),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3794),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3798),
    [anon_sym_COLON_EQ] = ACTIONS(3800),
    [anon_sym_DOT_EQ] = ACTIONS(3792),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3792),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3800),
    [sym__lazy_and_operator] = ACTIONS(3800),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3792),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [376] = {
    [sym__expression] = STATE(13761),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [377] = {
    [sym__closed_assignment] = STATE(14731),
    [sym__expression] = STATE(11979),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17965),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3806),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3808),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_COLON_EQ] = ACTIONS(3812),
    [anon_sym_DOT_EQ] = ACTIONS(3804),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3804),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3812),
    [sym__lazy_and_operator] = ACTIONS(3812),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3804),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [378] = {
    [sym__closed_assignment] = STATE(15082),
    [sym__expression] = STATE(12042),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17941),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3814),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3816),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_COLON_EQ] = ACTIONS(3822),
    [anon_sym_DOT_EQ] = ACTIONS(3814),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3814),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3822),
    [sym__lazy_and_operator] = ACTIONS(3822),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3814),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [379] = {
    [sym__closed_assignment] = STATE(14827),
    [sym__expression] = STATE(12205),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17967),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3824),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3826),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3830),
    [anon_sym_COLON_EQ] = ACTIONS(3832),
    [anon_sym_DOT_EQ] = ACTIONS(3824),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3824),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3832),
    [sym__lazy_and_operator] = ACTIONS(3832),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3824),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [380] = {
    [sym__closed_assignment] = STATE(14576),
    [sym__expression] = STATE(12220),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17946),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3834),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3836),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3840),
    [anon_sym_COLON_EQ] = ACTIONS(3842),
    [anon_sym_DOT_EQ] = ACTIONS(3834),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3834),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3842),
    [sym__lazy_and_operator] = ACTIONS(3842),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3834),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [381] = {
    [sym__closed_assignment] = STATE(14607),
    [sym__expression] = STATE(11935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17952),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3844),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3848),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3850),
    [anon_sym_COLON_EQ] = ACTIONS(3852),
    [anon_sym_DOT_EQ] = ACTIONS(3844),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3844),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3852),
    [sym__lazy_and_operator] = ACTIONS(3852),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3844),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [382] = {
    [sym__closed_assignment] = STATE(15055),
    [sym__expression] = STATE(11933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17921),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3854),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3856),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3860),
    [anon_sym_COLON_EQ] = ACTIONS(3862),
    [anon_sym_DOT_EQ] = ACTIONS(3854),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3854),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3862),
    [sym__lazy_and_operator] = ACTIONS(3862),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3854),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [383] = {
    [sym__closed_assignment] = STATE(14635),
    [sym__expression] = STATE(12150),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17954),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3864),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3866),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3870),
    [anon_sym_COLON_EQ] = ACTIONS(3872),
    [anon_sym_DOT_EQ] = ACTIONS(3864),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3864),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3872),
    [sym__lazy_and_operator] = ACTIONS(3872),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3864),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [384] = {
    [sym__closed_assignment] = STATE(14759),
    [sym__expression] = STATE(11863),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17972),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3874),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3876),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3878),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_COLON_EQ] = ACTIONS(3882),
    [anon_sym_DOT_EQ] = ACTIONS(3874),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3874),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3882),
    [sym__lazy_and_operator] = ACTIONS(3882),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3874),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [385] = {
    [sym__closed_assignment] = STATE(14794),
    [sym__expression] = STATE(12147),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17977),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3884),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3886),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_COLON_EQ] = ACTIONS(3892),
    [anon_sym_DOT_EQ] = ACTIONS(3884),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3884),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3892),
    [sym__lazy_and_operator] = ACTIONS(3892),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3884),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [386] = {
    [sym__closed_assignment] = STATE(14817),
    [sym__expression] = STATE(12023),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17979),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3894),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3896),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3900),
    [anon_sym_COLON_EQ] = ACTIONS(3902),
    [anon_sym_DOT_EQ] = ACTIONS(3894),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3894),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3902),
    [sym__lazy_and_operator] = ACTIONS(3902),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3894),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [387] = {
    [sym__closed_assignment] = STATE(14721),
    [sym__expression] = STATE(12022),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17964),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3904),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3906),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3910),
    [anon_sym_COLON_EQ] = ACTIONS(3912),
    [anon_sym_DOT_EQ] = ACTIONS(3904),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3904),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3912),
    [sym__lazy_and_operator] = ACTIONS(3912),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3904),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [388] = {
    [sym__closed_assignment] = STATE(15010),
    [sym__expression] = STATE(12038),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17939),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3914),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3916),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3918),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3920),
    [anon_sym_COLON_EQ] = ACTIONS(3922),
    [anon_sym_DOT_EQ] = ACTIONS(3914),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3914),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3922),
    [sym__lazy_and_operator] = ACTIONS(3922),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3914),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [389] = {
    [sym__closed_assignment] = STATE(14836),
    [sym__expression] = STATE(11894),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17981),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3924),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3926),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3930),
    [anon_sym_COLON_EQ] = ACTIONS(3932),
    [anon_sym_DOT_EQ] = ACTIONS(3924),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3924),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3932),
    [sym__lazy_and_operator] = ACTIONS(3932),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3924),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [390] = {
    [sym__closed_assignment] = STATE(14888),
    [sym__expression] = STATE(11968),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17983),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3934),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3936),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3940),
    [anon_sym_COLON_EQ] = ACTIONS(3942),
    [anon_sym_DOT_EQ] = ACTIONS(3934),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3934),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3942),
    [sym__lazy_and_operator] = ACTIONS(3942),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3934),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [391] = {
    [sym__closed_assignment] = STATE(14909),
    [sym__expression] = STATE(12043),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17993),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3950),
    [anon_sym_COLON_EQ] = ACTIONS(3952),
    [anon_sym_DOT_EQ] = ACTIONS(3944),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3952),
    [sym__lazy_and_operator] = ACTIONS(3952),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3944),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [392] = {
    [sym__closed_assignment] = STATE(14560),
    [sym__expression] = STATE(11906),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17944),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3954),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3960),
    [anon_sym_COLON_EQ] = ACTIONS(3962),
    [anon_sym_DOT_EQ] = ACTIONS(3954),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3954),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3962),
    [sym__lazy_and_operator] = ACTIONS(3962),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3954),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [393] = {
    [sym__closed_assignment] = STATE(14598),
    [sym__expression] = STATE(11977),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17949),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3966),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3968),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3970),
    [anon_sym_COLON_EQ] = ACTIONS(3972),
    [anon_sym_DOT_EQ] = ACTIONS(3964),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3964),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3972),
    [sym__lazy_and_operator] = ACTIONS(3972),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3964),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [394] = {
    [sym__closed_assignment] = STATE(14749),
    [sym__expression] = STATE(12059),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17971),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3974),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3976),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3980),
    [anon_sym_COLON_EQ] = ACTIONS(3982),
    [anon_sym_DOT_EQ] = ACTIONS(3974),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3974),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3982),
    [sym__lazy_and_operator] = ACTIONS(3982),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3974),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [395] = {
    [sym__closed_assignment] = STATE(14782),
    [sym__expression] = STATE(12100),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17975),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3984),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3986),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3988),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_COLON_EQ] = ACTIONS(3992),
    [anon_sym_DOT_EQ] = ACTIONS(3984),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3984),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(3992),
    [sym__lazy_and_operator] = ACTIONS(3992),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3984),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [396] = {
    [sym__closed_assignment] = STATE(14863),
    [sym__expression] = STATE(12148),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17988),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3996),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4000),
    [anon_sym_COLON_EQ] = ACTIONS(4002),
    [anon_sym_DOT_EQ] = ACTIONS(3994),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(3994),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4002),
    [sym__lazy_and_operator] = ACTIONS(4002),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(3994),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [397] = {
    [sym__closed_assignment] = STATE(14711),
    [sym__expression] = STATE(12036),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17962),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(4004),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4006),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4010),
    [anon_sym_COLON_EQ] = ACTIONS(4012),
    [anon_sym_DOT_EQ] = ACTIONS(4004),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(4004),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4012),
    [sym__lazy_and_operator] = ACTIONS(4012),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(4004),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [398] = {
    [sym__closed_assignment] = STATE(14879),
    [sym__expression] = STATE(11937),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17991),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(4014),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4020),
    [anon_sym_COLON_EQ] = ACTIONS(4022),
    [anon_sym_DOT_EQ] = ACTIONS(4014),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(4014),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4022),
    [sym__lazy_and_operator] = ACTIONS(4022),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(4014),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [399] = {
    [sym__closed_assignment] = STATE(14897),
    [sym__expression] = STATE(11995),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17992),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(4024),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4030),
    [anon_sym_COLON_EQ] = ACTIONS(4032),
    [anon_sym_DOT_EQ] = ACTIONS(4024),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(4024),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4032),
    [sym__lazy_and_operator] = ACTIONS(4032),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(4024),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [400] = {
    [sym__closed_assignment] = STATE(14771),
    [sym__expression] = STATE(11969),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17974),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(4034),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4040),
    [anon_sym_COLON_EQ] = ACTIONS(4042),
    [anon_sym_DOT_EQ] = ACTIONS(4034),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(4034),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4042),
    [sym__lazy_and_operator] = ACTIONS(4042),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(4034),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [401] = {
    [sym__closed_assignment] = STATE(14854),
    [sym__expression] = STATE(12041),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17986),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(4044),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4046),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4048),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4050),
    [anon_sym_COLON_EQ] = ACTIONS(4052),
    [anon_sym_DOT_EQ] = ACTIONS(4044),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(4044),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4052),
    [sym__lazy_and_operator] = ACTIONS(4052),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(4044),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [402] = {
    [sym__closed_assignment] = STATE(14871),
    [sym__expression] = STATE(11862),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17989),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(4054),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4060),
    [anon_sym_COLON_EQ] = ACTIONS(4062),
    [anon_sym_DOT_EQ] = ACTIONS(4054),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(4054),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4062),
    [sym__lazy_and_operator] = ACTIONS(4062),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(4054),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [403] = {
    [sym__closed_assignment] = STATE(14943),
    [sym__expression] = STATE(11942),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17999),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(4064),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4066),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4070),
    [anon_sym_COLON_EQ] = ACTIONS(4072),
    [anon_sym_DOT_EQ] = ACTIONS(4064),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(4064),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4072),
    [sym__lazy_and_operator] = ACTIONS(4072),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(4064),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [404] = {
    [sym__closed_assignment] = STATE(14845),
    [sym__expression] = STATE(11947),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17985),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(4074),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4078),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4080),
    [anon_sym_COLON_EQ] = ACTIONS(4082),
    [anon_sym_DOT_EQ] = ACTIONS(4074),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(4074),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4082),
    [sym__lazy_and_operator] = ACTIONS(4082),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(4074),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [405] = {
    [sym__closed_assignment] = STATE(14932),
    [sym__expression] = STATE(12126),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17997),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4088),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4090),
    [anon_sym_COLON_EQ] = ACTIONS(4092),
    [anon_sym_DOT_EQ] = ACTIONS(4084),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(4084),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4092),
    [sym__lazy_and_operator] = ACTIONS(4092),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(4084),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [406] = {
    [sym__closed_assignment] = STATE(14920),
    [sym__expression] = STATE(12085),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17995),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(4094),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4096),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4100),
    [anon_sym_COLON_EQ] = ACTIONS(4102),
    [anon_sym_DOT_EQ] = ACTIONS(4094),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(4094),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4102),
    [sym__lazy_and_operator] = ACTIONS(4102),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(4094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [407] = {
    [sym_assignment] = STATE(12171),
    [sym_open_tuple] = STATE(13758),
    [sym__expression] = STATE(13623),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11544),
    [sym__array] = STATE(11544),
    [sym_comprehension_expression] = STATE(11544),
    [sym_matrix_expression] = STATE(11544),
    [sym_vector_expression] = STATE(11544),
    [sym_parenthesized_expression] = STATE(11544),
    [sym_tuple_expression] = STATE(11544),
    [sym_curly_expression] = STATE(11544),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11544),
    [sym_index_expression] = STATE(11544),
    [sym_parametrized_type_expression] = STATE(11544),
    [sym_call_expression] = STATE(11544),
    [sym_broadcast_call_expression] = STATE(11544),
    [sym__closed_macrocall_expression] = STATE(11544),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11544),
    [sym_quote_expression] = STATE(11544),
    [sym_binary_expression] = STATE(13781),
    [sym_unary_expression] = STATE(13781),
    [sym_range_expression] = STATE(13781),
    [sym_splat_expression] = STATE(13781),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13485),
    [sym_unary_typed_expression] = STATE(13781),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13781),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11544),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11544),
    [sym_string_literal] = STATE(11544),
    [sym_command_literal] = STATE(11544),
    [sym_prefixed_string_literal] = STATE(11544),
    [sym_prefixed_command_literal] = STATE(11544),
    [sym_operator] = STATE(13486),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(1759),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_COLON2] = ACTIONS(1759),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4112),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(1769),
    [sym__lazy_and_operator] = ACTIONS(1769),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [408] = {
    [sym__closed_assignment] = STATE(14806),
    [sym__expression] = STATE(11908),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17961),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4116),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4118),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3442),
    [anon_sym_COLON_COLON] = ACTIONS(4120),
    [anon_sym_COLON_EQ] = ACTIONS(4122),
    [anon_sym_DOT_EQ] = ACTIONS(4114),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__assignment_operator] = ACTIONS(4114),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(4122),
    [sym__lazy_and_operator] = ACTIONS(4122),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym__syntactic_operator] = ACTIONS(4114),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [409] = {
    [sym__expression] = STATE(13999),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [410] = {
    [sym__expression] = STATE(14142),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [411] = {
    [sym__expression] = STATE(14175),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [412] = {
    [sym__block] = STATE(18917),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(641),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4142),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4146),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4148),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4150),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [413] = {
    [sym__block] = STATE(19528),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(561),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4152),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4154),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4156),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4158),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [414] = {
    [sym__block] = STATE(15127),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(15128),
    [sym_else_clause] = STATE(19447),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(15128),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4160),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [415] = {
    [sym__block] = STATE(18891),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(602),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4178),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4180),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4182),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4184),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [416] = {
    [sym__block] = STATE(19700),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(565),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4186),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4188),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4190),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4192),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [417] = {
    [sym__block] = STATE(15166),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(15167),
    [sym_else_clause] = STATE(19735),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(15167),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4194),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [418] = {
    [sym__block] = STATE(18174),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(577),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4196),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4198),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4200),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4202),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [419] = {
    [sym__block] = STATE(19733),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(576),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4206),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4208),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4210),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [420] = {
    [sym__block] = STATE(19614),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(582),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4212),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4214),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4216),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4218),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [421] = {
    [sym__block] = STATE(15029),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(15035),
    [sym_else_clause] = STATE(18367),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(15035),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4220),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [422] = {
    [sym__block] = STATE(18823),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(594),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4222),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4224),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4226),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4228),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [423] = {
    [sym__block] = STATE(14608),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14609),
    [sym_else_clause] = STATE(18485),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14609),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4230),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [424] = {
    [sym__block] = STATE(18384),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(596),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4232),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4234),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4238),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [425] = {
    [sym__block] = STATE(14765),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14766),
    [sym_else_clause] = STATE(18492),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14766),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4240),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [426] = {
    [sym__block] = STATE(19195),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(617),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4242),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4244),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4246),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4248),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [427] = {
    [sym__block] = STATE(14841),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14844),
    [sym_else_clause] = STATE(19254),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14844),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4250),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [428] = {
    [sym__block] = STATE(18364),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(758),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4252),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4258),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [429] = {
    [sym__block] = STATE(19848),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(737),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4260),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4262),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4266),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [430] = {
    [sym__block] = STATE(19492),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(680),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4268),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4270),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4274),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [431] = {
    [sym__block] = STATE(18722),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(691),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4276),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4278),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4282),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [432] = {
    [sym__block] = STATE(14950),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14951),
    [sym_else_clause] = STATE(18941),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14951),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4284),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [433] = {
    [sym__block] = STATE(19396),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(761),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4286),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4288),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4290),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4292),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [434] = {
    [sym__block] = STATE(18158),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(752),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4294),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4296),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4298),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4300),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [435] = {
    [sym__block] = STATE(18876),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(562),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4302),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4304),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4308),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [436] = {
    [sym__block] = STATE(16486),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15283),
    [sym_finally_clause] = STATE(16858),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4314),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4318),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [437] = {
    [sym__block] = STATE(15013),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(15014),
    [sym_else_clause] = STATE(18253),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(15014),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4320),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [438] = {
    [sym__block] = STATE(14709),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14710),
    [sym_else_clause] = STATE(19011),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14710),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4322),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [439] = {
    [sym__block] = STATE(18504),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(775),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4324),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4326),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4328),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4330),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [440] = {
    [sym__block] = STATE(18661),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(776),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4332),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4334),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4336),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4338),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [441] = {
    [sym__block] = STATE(19404),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(671),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4340),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4342),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4344),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4346),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [442] = {
    [sym__block] = STATE(18615),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(778),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4348),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4350),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4352),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4354),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [443] = {
    [sym__block] = STATE(15063),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(15064),
    [sym_else_clause] = STATE(18638),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(15064),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4356),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [444] = {
    [sym__block] = STATE(18974),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(543),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4358),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4360),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4362),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4364),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [445] = {
    [sym__block] = STATE(14807),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14808),
    [sym_else_clause] = STATE(18873),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14808),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4366),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [446] = {
    [sym__block] = STATE(14579),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(14582),
    [sym_else_clause] = STATE(18465),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(14582),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4368),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [447] = {
    [sym__block] = STATE(19155),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(546),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4370),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4374),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4376),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [448] = {
    [sym__block] = STATE(15110),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_elseif_clause] = STATE(15111),
    [sym_else_clause] = STATE(19202),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [aux_sym_if_statement_repeat1] = STATE(15111),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4378),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [449] = {
    [sym__block] = STATE(16052),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15238),
    [sym_finally_clause] = STATE(16702),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4380),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [450] = {
    [sym__block] = STATE(15474),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15366),
    [sym_finally_clause] = STATE(16842),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4384),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4386),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [451] = {
    [sym__block] = STATE(18551),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(740),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4388),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4390),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4392),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4394),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [452] = {
    [sym__block] = STATE(19401),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(557),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4396),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4398),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4400),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4402),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [453] = {
    [sym__block] = STATE(16247),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15192),
    [sym_finally_clause] = STATE(16979),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4404),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4406),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [454] = {
    [sym__block] = STATE(16294),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15312),
    [sym_finally_clause] = STATE(16786),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4410),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [455] = {
    [sym__block] = STATE(16333),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15216),
    [sym_finally_clause] = STATE(16940),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4412),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4414),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [456] = {
    [sym__block] = STATE(16360),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15190),
    [sym_finally_clause] = STATE(16903),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4416),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4418),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [457] = {
    [sym__block] = STATE(16387),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15218),
    [sym_finally_clause] = STATE(17256),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4420),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4422),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [458] = {
    [sym__block] = STATE(16403),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15423),
    [sym_finally_clause] = STATE(16859),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4424),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4426),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [459] = {
    [sym__block] = STATE(16421),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15236),
    [sym_finally_clause] = STATE(17223),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4430),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [460] = {
    [sym__block] = STATE(16436),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15314),
    [sym_finally_clause] = STATE(16838),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4432),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4434),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [461] = {
    [sym__block] = STATE(16452),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15393),
    [sym_finally_clause] = STATE(17162),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4436),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4438),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [462] = {
    [sym__block] = STATE(16469),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15198),
    [sym_finally_clause] = STATE(16960),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(2510),
    [aux_sym_float_literal_token3] = ACTIONS(2510),
    [aux_sym_float_literal_token4] = ACTIONS(2510),
    [sym_character_literal] = ACTIONS(4316),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2514),
    [sym__type_order_operator] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [aux_sym__terminator_token1] = ACTIONS(4442),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [463] = {
    [sym__block] = STATE(18241),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(760),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4444),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4448),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(4450),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [464] = {
    [sym__block] = STATE(19571),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(495),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4454),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4456),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4458),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [465] = {
    [sym__block] = STATE(19358),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(708),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4460),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4462),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4464),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [466] = {
    [sym__block] = STATE(19116),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(478),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4466),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4468),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4470),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [467] = {
    [sym__block] = STATE(18951),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(585),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4472),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4474),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4476),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [468] = {
    [sym__block] = STATE(19275),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(569),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4478),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4480),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4482),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [469] = {
    [sym__block] = STATE(19858),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(575),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4484),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4486),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4488),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [470] = {
    [sym__block] = STATE(18179),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(474),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4490),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4494),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [471] = {
    [sym__block] = STATE(19474),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4496),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4498),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4500),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [472] = {
    [sym__block] = STATE(19417),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(481),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4502),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4506),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [473] = {
    [sym__block] = STATE(19678),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(771),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4508),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4510),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4512),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [474] = {
    [sym__block] = STATE(18260),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4514),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4516),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4518),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [475] = {
    [sym__block] = STATE(18305),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(764),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4520),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4522),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4524),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [476] = {
    [sym__block] = STATE(18340),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(765),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4526),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4528),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4530),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [477] = {
    [sym__block] = STATE(18698),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(471),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4532),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4534),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4536),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [478] = {
    [sym__block] = STATE(18940),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4538),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4542),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [479] = {
    [sym__block] = STATE(18821),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(512),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4544),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4546),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4548),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [480] = {
    [sym__block] = STATE(18552),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(485),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4550),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4552),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4554),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [481] = {
    [sym__block] = STATE(18580),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4556),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4560),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [482] = {
    [sym__block] = STATE(19439),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(549),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4562),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4564),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4566),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [483] = {
    [sym__block] = STATE(18655),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(600),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4568),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4570),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4572),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [484] = {
    [sym__block] = STATE(19252),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(601),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4574),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4578),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [485] = {
    [sym__block] = STATE(18665),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4580),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4582),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4584),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [486] = {
    [sym__block] = STATE(18710),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(533),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4586),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4588),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4590),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [487] = {
    [sym__block] = STATE(18767),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(534),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4592),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4594),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4596),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [488] = {
    [sym__block] = STATE(19840),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(772),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4598),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4600),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4602),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [489] = {
    [sym__block] = STATE(19069),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4604),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4606),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4608),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [490] = {
    [sym__block] = STATE(18315),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(489),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4610),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4612),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4614),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [491] = {
    [sym__block] = STATE(19019),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(498),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4616),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4618),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4620),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [492] = {
    [sym__block] = STATE(18991),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(494),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4622),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4624),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4626),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [493] = {
    [sym__block] = STATE(18693),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4628),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4630),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4632),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [494] = {
    [sym__block] = STATE(19288),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4634),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4636),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4638),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [495] = {
    [sym__block] = STATE(19811),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4640),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4642),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4644),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [496] = {
    [sym__block] = STATE(19494),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(544),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4646),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4648),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4650),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [497] = {
    [sym__block] = STATE(19497),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(631),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4652),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4656),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [498] = {
    [sym__block] = STATE(19226),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4658),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4660),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4662),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [499] = {
    [sym__block] = STATE(19308),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(550),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4664),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4666),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4668),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [500] = {
    [sym__block] = STATE(18732),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(506),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4670),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4674),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [501] = {
    [sym__block] = STATE(19527),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(547),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4676),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4680),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [502] = {
    [sym__block] = STATE(19641),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(634),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4682),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4684),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4686),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [503] = {
    [sym__block] = STATE(19443),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(694),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4688),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4690),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4692),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [504] = {
    [sym__block] = STATE(18972),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(558),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4694),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4696),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4698),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [505] = {
    [sym__block] = STATE(18251),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(702),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4700),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4702),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4704),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [506] = {
    [sym__block] = STATE(18838),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4706),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4710),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [507] = {
    [sym__block] = STATE(18634),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(568),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4712),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4714),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4716),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [508] = {
    [sym__block] = STATE(16678),
    [sym_assignment] = STATE(14658),
    [sym_open_tuple] = STATE(14519),
    [sym__expression] = STATE(12053),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10874),
    [sym__array] = STATE(10874),
    [sym_comprehension_expression] = STATE(10874),
    [sym_matrix_expression] = STATE(10874),
    [sym_vector_expression] = STATE(10874),
    [sym_parenthesized_expression] = STATE(10874),
    [sym_tuple_expression] = STATE(10874),
    [sym_curly_expression] = STATE(10874),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10874),
    [sym_index_expression] = STATE(10874),
    [sym_parametrized_type_expression] = STATE(10874),
    [sym_call_expression] = STATE(10874),
    [sym_broadcast_call_expression] = STATE(10874),
    [sym__closed_macrocall_expression] = STATE(10874),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10874),
    [sym_quote_expression] = STATE(10874),
    [sym_binary_expression] = STATE(12259),
    [sym_unary_expression] = STATE(12259),
    [sym_range_expression] = STATE(12259),
    [sym_splat_expression] = STATE(12259),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11948),
    [sym_unary_typed_expression] = STATE(12259),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12259),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(2),
    [sym_boolean_literal] = STATE(10874),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10874),
    [sym_string_literal] = STATE(10874),
    [sym_command_literal] = STATE(10874),
    [sym_prefixed_string_literal] = STATE(10874),
    [sym_prefixed_command_literal] = STATE(10874),
    [sym_operator] = STATE(12127),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_end] = ACTIONS(4718),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_else] = ACTIONS(4718),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_finally] = ACTIONS(4718),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_LF] = ACTIONS(4720),
    [anon_sym_LBRACE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [anon_sym_COLON_COLON] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(153),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(157),
    [aux_sym_integer_literal_token2] = ACTIONS(157),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(161),
    [aux_sym_float_literal_token3] = ACTIONS(161),
    [aux_sym_float_literal_token4] = ACTIONS(161),
    [sym_character_literal] = ACTIONS(163),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(165),
    [sym__type_order_operator] = ACTIONS(165),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [aux_sym__terminator_token1] = ACTIONS(4722),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [509] = {
    [sym__block] = STATE(18232),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(514),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4724),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4726),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4728),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [510] = {
    [sym__block] = STATE(19253),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(493),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4730),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4732),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4734),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [511] = {
    [sym__block] = STATE(19451),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(574),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4736),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4738),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4740),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [512] = {
    [sym__block] = STATE(18479),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4742),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4746),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [513] = {
    [sym__block] = STATE(19613),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(584),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4748),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4750),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4752),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [514] = {
    [sym__block] = STATE(19052),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(4452),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4754),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4758),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [515] = {
    [sym__block] = STATE(19259),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(705),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4760),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4762),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4764),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [516] = {
    [sym__block] = STATE(19410),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_type_clause] = STATE(551),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4766),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LT_COLON] = ACTIONS(4144),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4768),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [517] = {
    [sym__block] = STATE(16366),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15270),
    [sym_finally_clause] = STATE(16871),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [518] = {
    [sym__block] = STATE(18064),
    [sym_assignment] = STATE(15431),
    [sym_open_tuple] = STATE(14773),
    [sym__expression] = STATE(12586),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11014),
    [sym__array] = STATE(11014),
    [sym_comprehension_expression] = STATE(11014),
    [sym_matrix_expression] = STATE(11014),
    [sym_vector_expression] = STATE(11014),
    [sym_parenthesized_expression] = STATE(11014),
    [sym_tuple_expression] = STATE(11014),
    [sym_curly_expression] = STATE(11014),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11014),
    [sym_index_expression] = STATE(11014),
    [sym_parametrized_type_expression] = STATE(11014),
    [sym_call_expression] = STATE(11014),
    [sym_broadcast_call_expression] = STATE(11014),
    [sym__closed_macrocall_expression] = STATE(11014),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11014),
    [sym_quote_expression] = STATE(11014),
    [sym_binary_expression] = STATE(12958),
    [sym_unary_expression] = STATE(12958),
    [sym_range_expression] = STATE(12958),
    [sym_splat_expression] = STATE(12958),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(12958),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12958),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11014),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11014),
    [sym_string_literal] = STATE(11014),
    [sym_command_literal] = STATE(11014),
    [sym_prefixed_string_literal] = STATE(11014),
    [sym_prefixed_command_literal] = STATE(11014),
    [sym_operator] = STATE(12771),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4786),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(4786),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4788),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2225),
    [anon_sym_COLON_COLON] = ACTIONS(2227),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2229),
    [aux_sym_integer_literal_token2] = ACTIONS(2229),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(2233),
    [aux_sym_float_literal_token3] = ACTIONS(2233),
    [aux_sym_float_literal_token4] = ACTIONS(2233),
    [sym_character_literal] = ACTIONS(4790),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2237),
    [sym__type_order_operator] = ACTIONS(2237),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [aux_sym__terminator_token1] = ACTIONS(4792),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [519] = {
    [sym__block] = STATE(16391),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15271),
    [sym_finally_clause] = STATE(16724),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [520] = {
    [sym__block] = STATE(16253),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15279),
    [sym_finally_clause] = STATE(16711),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [521] = {
    [sym__block] = STATE(16407),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15444),
    [sym_finally_clause] = STATE(16906),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [522] = {
    [sym__block] = STATE(17801),
    [sym_assignment] = STATE(15440),
    [sym_open_tuple] = STATE(14649),
    [sym__expression] = STATE(12546),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11023),
    [sym__array] = STATE(11023),
    [sym_comprehension_expression] = STATE(11023),
    [sym_matrix_expression] = STATE(11023),
    [sym_vector_expression] = STATE(11023),
    [sym_parenthesized_expression] = STATE(11023),
    [sym_tuple_expression] = STATE(11023),
    [sym_curly_expression] = STATE(11023),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11023),
    [sym_index_expression] = STATE(11023),
    [sym_parametrized_type_expression] = STATE(11023),
    [sym_call_expression] = STATE(11023),
    [sym_broadcast_call_expression] = STATE(11023),
    [sym__closed_macrocall_expression] = STATE(11023),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11023),
    [sym_quote_expression] = STATE(11023),
    [sym_binary_expression] = STATE(13099),
    [sym_unary_expression] = STATE(13099),
    [sym_range_expression] = STATE(13099),
    [sym_splat_expression] = STATE(13099),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12587),
    [sym_unary_typed_expression] = STATE(13099),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13099),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11023),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11023),
    [sym_string_literal] = STATE(11023),
    [sym_command_literal] = STATE(11023),
    [sym_prefixed_string_literal] = STATE(11023),
    [sym_prefixed_command_literal] = STATE(11023),
    [sym_operator] = STATE(12589),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4794),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4794),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4796),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_COLON_COLON] = ACTIONS(2692),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(2694),
    [aux_sym_integer_literal_token2] = ACTIONS(2694),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(2698),
    [aux_sym_float_literal_token3] = ACTIONS(2698),
    [aux_sym_float_literal_token4] = ACTIONS(2698),
    [sym_character_literal] = ACTIONS(4798),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(2702),
    [sym__type_order_operator] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [aux_sym__terminator_token1] = ACTIONS(4800),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [523] = {
    [sym__block] = STATE(16425),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15256),
    [sym_finally_clause] = STATE(17315),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [524] = {
    [sym__block] = STATE(16299),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15290),
    [sym_finally_clause] = STATE(16968),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [525] = {
    [sym__block] = STATE(16440),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15464),
    [sym_finally_clause] = STATE(16916),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [526] = {
    [sym__block] = STATE(16395),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15349),
    [sym_finally_clause] = STATE(16986),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [527] = {
    [sym__block] = STATE(16456),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15408),
    [sym_finally_clause] = STATE(17194),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [528] = {
    [sym__block] = STATE(16338),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15305),
    [sym_finally_clause] = STATE(16673),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [529] = {
    [sym__block] = STATE(16472),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15259),
    [sym_finally_clause] = STATE(16693),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [530] = {
    [sym__block] = STATE(16060),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15438),
    [sym_finally_clause] = STATE(16941),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [531] = {
    [sym__block] = STATE(16490),
    [sym_assignment] = STATE(15413),
    [sym_open_tuple] = STATE(14980),
    [sym__expression] = STATE(12430),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_catch_clause] = STATE(15180),
    [sym_finally_clause] = STATE(16754),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4310),
    [anon_sym_finally] = ACTIONS(4312),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [532] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(4802),
    [anon_sym_LF] = ACTIONS(4804),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(4808),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [533] = {
    [sym__block] = STATE(18774),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4810),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4812),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4814),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [534] = {
    [sym__block] = STATE(18784),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4816),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4818),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4820),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [535] = {
    [sym__block] = STATE(18869),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4822),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4824),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4826),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [536] = {
    [sym__block] = STATE(18957),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4832),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [537] = {
    [sym__block] = STATE(18979),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4834),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4836),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4838),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [538] = {
    [sym__block] = STATE(18982),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4840),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4842),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4844),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [539] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(4846),
    [anon_sym_LF] = ACTIONS(4848),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(4850),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [540] = {
    [sym__block] = STATE(19231),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4852),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4854),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4856),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [541] = {
    [sym__block] = STATE(19628),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4858),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4860),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [542] = {
    [sym__block] = STATE(19849),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4864),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4868),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [543] = {
    [sym__block] = STATE(19166),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4870),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4872),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4874),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [544] = {
    [sym__block] = STATE(19567),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4876),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4878),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4880),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [545] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(4882),
    [anon_sym_LF] = ACTIONS(4884),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(4886),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [546] = {
    [sym__block] = STATE(19302),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4888),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4890),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [547] = {
    [sym__block] = STATE(19815),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4894),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4896),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4898),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [548] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(4900),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(4904),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [549] = {
    [sym__block] = STATE(19051),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4906),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4908),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4910),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [550] = {
    [sym__block] = STATE(19413),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4912),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [551] = {
    [sym__block] = STATE(19430),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4918),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4922),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [552] = {
    [sym__block] = STATE(19480),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4924),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4926),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [553] = {
    [sym__block] = STATE(19524),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4930),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4932),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4934),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [554] = {
    [sym__block] = STATE(16995),
    [sym_assignment] = STATE(15016),
    [sym_open_tuple] = STATE(14506),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4936),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(4936),
    [anon_sym_else] = ACTIONS(4936),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [555] = {
    [sym__block] = STATE(19533),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4938),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4940),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4942),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [556] = {
    [sym__block] = STATE(19538),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4944),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4946),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4948),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [557] = {
    [sym__block] = STATE(18911),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4950),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4952),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4954),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [558] = {
    [sym__block] = STATE(19549),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4956),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4958),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4960),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [559] = {
    [sym__block] = STATE(18335),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4962),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4964),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4966),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [560] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(4968),
    [anon_sym_LF] = ACTIONS(4970),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(4972),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [561] = {
    [sym__block] = STATE(19714),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4974),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4976),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4978),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [562] = {
    [sym__block] = STATE(19373),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4980),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(4982),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(4984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [563] = {
    [sym__block] = STATE(17052),
    [sym_assignment] = STATE(14658),
    [sym_open_tuple] = STATE(14519),
    [sym__expression] = STATE(12053),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10874),
    [sym__array] = STATE(10874),
    [sym_comprehension_expression] = STATE(10874),
    [sym_matrix_expression] = STATE(10874),
    [sym_vector_expression] = STATE(10874),
    [sym_parenthesized_expression] = STATE(10874),
    [sym_tuple_expression] = STATE(10874),
    [sym_curly_expression] = STATE(10874),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10874),
    [sym_index_expression] = STATE(10874),
    [sym_parametrized_type_expression] = STATE(10874),
    [sym_call_expression] = STATE(10874),
    [sym_broadcast_call_expression] = STATE(10874),
    [sym__closed_macrocall_expression] = STATE(10874),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10874),
    [sym_quote_expression] = STATE(10874),
    [sym_binary_expression] = STATE(12259),
    [sym_unary_expression] = STATE(12259),
    [sym_range_expression] = STATE(12259),
    [sym_splat_expression] = STATE(12259),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11948),
    [sym_unary_typed_expression] = STATE(12259),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12259),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10874),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10874),
    [sym_string_literal] = STATE(10874),
    [sym_command_literal] = STATE(10874),
    [sym_prefixed_string_literal] = STATE(10874),
    [sym_prefixed_command_literal] = STATE(10874),
    [sym_operator] = STATE(12127),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_end] = ACTIONS(99),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_else] = ACTIONS(99),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_finally] = ACTIONS(99),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(5002),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [564] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5006),
    [anon_sym_LF] = ACTIONS(5008),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5010),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [565] = {
    [sym__block] = STATE(18678),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5012),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5014),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5016),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [566] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5018),
    [anon_sym_LF] = ACTIONS(5020),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5022),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [567] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5024),
    [anon_sym_LF] = ACTIONS(5026),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [568] = {
    [sym__block] = STATE(18930),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5030),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5032),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5034),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [569] = {
    [sym__block] = STATE(18692),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5036),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5038),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [570] = {
    [sym__block] = STATE(19606),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5042),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5044),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [571] = {
    [sym__block] = STATE(18745),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5048),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5050),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5052),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [572] = {
    [sym__block] = STATE(18797),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5054),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5056),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [573] = {
    [sym__block] = STATE(18830),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5060),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5062),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5064),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [574] = {
    [sym__block] = STATE(18160),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5066),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5068),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [575] = {
    [sym__block] = STATE(18196),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5072),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5076),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [576] = {
    [sym__block] = STATE(19261),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5078),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5082),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [577] = {
    [sym__block] = STATE(18168),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5084),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5086),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5088),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [578] = {
    [sym__block] = STATE(18739),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5090),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5092),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [579] = {
    [sym__block] = STATE(16678),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(3),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4718),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5096),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5098),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [580] = {
    [sym__block] = STATE(18664),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5100),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5102),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5104),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [581] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5106),
    [anon_sym_LF] = ACTIONS(5108),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5110),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [582] = {
    [sym__block] = STATE(19575),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5112),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5116),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [583] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5118),
    [anon_sym_LF] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5122),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [584] = {
    [sym__block] = STATE(19246),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5124),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5126),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5128),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [585] = {
    [sym__block] = STATE(18647),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5130),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5132),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5134),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [586] = {
    [sym__block] = STATE(18882),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5136),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5138),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5140),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [587] = {
    [sym__block] = STATE(18757),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5142),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5144),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [588] = {
    [sym__block] = STATE(18832),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5148),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5150),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5152),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [589] = {
    [sym__block] = STATE(18840),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5154),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5156),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [590] = {
    [sym__block] = STATE(18875),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5160),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5162),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5164),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [591] = {
    [sym__block] = STATE(19114),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5166),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5168),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [592] = {
    [sym__block] = STATE(18903),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5172),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5174),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5176),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [593] = {
    [sym__block] = STATE(18924),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5178),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5180),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5182),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [594] = {
    [sym__block] = STATE(18417),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5184),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5188),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [595] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5190),
    [anon_sym_LF] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5194),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [596] = {
    [sym__block] = STATE(19181),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5196),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5198),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5200),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [597] = {
    [sym__block] = STATE(18812),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5202),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5204),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5206),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [598] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5208),
    [anon_sym_LF] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5212),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [599] = {
    [sym__block] = STATE(17801),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4794),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5214),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5216),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [600] = {
    [sym__block] = STATE(19305),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5218),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5220),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5222),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [601] = {
    [sym__block] = STATE(19436),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5224),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5226),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5228),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [602] = {
    [sym__block] = STATE(19204),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5230),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5234),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [603] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5236),
    [anon_sym_LF] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [604] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5242),
    [anon_sym_LF] = ACTIONS(5244),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5246),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [605] = {
    [sym__block] = STATE(18942),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5248),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5250),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [606] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5254),
    [anon_sym_LF] = ACTIONS(5256),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5258),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [607] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5260),
    [anon_sym_LF] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [608] = {
    [sym__block] = STATE(19014),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5266),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5268),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5270),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [609] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5272),
    [anon_sym_LF] = ACTIONS(5274),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [610] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5278),
    [anon_sym_LF] = ACTIONS(5280),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5282),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [611] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5284),
    [anon_sym_LF] = ACTIONS(5286),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5288),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [612] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5290),
    [anon_sym_LF] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5294),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [613] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5296),
    [anon_sym_LF] = ACTIONS(5298),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [614] = {
    [sym__block] = STATE(18064),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4786),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [615] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5306),
    [anon_sym_LF] = ACTIONS(5308),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5310),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [616] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5312),
    [anon_sym_LF] = ACTIONS(5314),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5316),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [617] = {
    [sym__block] = STATE(19478),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5318),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5320),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [618] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5324),
    [anon_sym_LF] = ACTIONS(5326),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5328),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [619] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5330),
    [anon_sym_LF] = ACTIONS(5332),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [620] = {
    [sym__block] = STATE(19791),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5336),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5338),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5340),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [621] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5342),
    [anon_sym_LF] = ACTIONS(5344),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5346),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [622] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5348),
    [anon_sym_LF] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5352),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [623] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5354),
    [anon_sym_LF] = ACTIONS(5356),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5358),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [624] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5360),
    [anon_sym_LF] = ACTIONS(5362),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [625] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5366),
    [anon_sym_LF] = ACTIONS(5368),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5370),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [626] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5372),
    [anon_sym_LF] = ACTIONS(5374),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5376),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [627] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5378),
    [anon_sym_LF] = ACTIONS(5380),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [628] = {
    [sym__block] = STATE(18209),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5384),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5386),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [629] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5390),
    [anon_sym_LF] = ACTIONS(5392),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5394),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [630] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5396),
    [anon_sym_LF] = ACTIONS(5398),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5400),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [631] = {
    [sym__block] = STATE(19660),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5402),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5404),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5406),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [632] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5408),
    [anon_sym_LF] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5412),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [633] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5414),
    [anon_sym_LF] = ACTIONS(5416),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5418),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [634] = {
    [sym__block] = STATE(19715),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5420),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5422),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5424),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [635] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5426),
    [anon_sym_LF] = ACTIONS(5428),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5430),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [636] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5432),
    [anon_sym_LF] = ACTIONS(5434),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5436),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [637] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5438),
    [anon_sym_LF] = ACTIONS(5440),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5442),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [638] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5444),
    [anon_sym_LF] = ACTIONS(5446),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5448),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [639] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5450),
    [anon_sym_LF] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5454),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [640] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5456),
    [anon_sym_LF] = ACTIONS(5458),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5460),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [641] = {
    [sym__block] = STATE(19875),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5462),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5464),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5466),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [642] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5468),
    [anon_sym_LF] = ACTIONS(5470),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5472),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [643] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5474),
    [anon_sym_LF] = ACTIONS(5476),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5478),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [644] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5480),
    [anon_sym_LF] = ACTIONS(5482),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5484),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [645] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5486),
    [anon_sym_LF] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5490),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [646] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5492),
    [anon_sym_LF] = ACTIONS(5494),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5496),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [647] = {
    [sym__block] = STATE(19851),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5498),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5500),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5502),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [648] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5504),
    [anon_sym_LF] = ACTIONS(5506),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5508),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [649] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5510),
    [anon_sym_LF] = ACTIONS(5512),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5514),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [650] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5516),
    [anon_sym_LF] = ACTIONS(5518),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5520),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [651] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5522),
    [anon_sym_LF] = ACTIONS(5524),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5526),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [652] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5528),
    [anon_sym_LF] = ACTIONS(5530),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5532),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [653] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(5536),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5538),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [654] = {
    [sym__block] = STATE(19350),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5540),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5542),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5544),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [655] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5546),
    [anon_sym_LF] = ACTIONS(5548),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5550),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [656] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5552),
    [anon_sym_LF] = ACTIONS(5554),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5556),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [657] = {
    [sym__block] = STATE(18502),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5558),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5560),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5562),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [658] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5564),
    [anon_sym_LF] = ACTIONS(5566),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5568),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [659] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5570),
    [anon_sym_LF] = ACTIONS(5572),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5574),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [660] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5576),
    [anon_sym_LF] = ACTIONS(5578),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5580),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [661] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_LF] = ACTIONS(5584),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5586),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [662] = {
    [sym__block] = STATE(19674),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5588),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5590),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5592),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [663] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_LF] = ACTIONS(5596),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5598),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [664] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5602),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5604),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [665] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5606),
    [anon_sym_LF] = ACTIONS(5608),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5610),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [666] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5612),
    [anon_sym_LF] = ACTIONS(5614),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5616),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [667] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5618),
    [anon_sym_LF] = ACTIONS(5620),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5622),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [668] = {
    [sym__block] = STATE(18484),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5624),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5626),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5628),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [669] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5630),
    [anon_sym_LF] = ACTIONS(5632),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5634),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [670] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5636),
    [anon_sym_LF] = ACTIONS(5638),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5640),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [671] = {
    [sym__block] = STATE(19278),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5642),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5644),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5646),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [672] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5648),
    [anon_sym_LF] = ACTIONS(5650),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5652),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [673] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5654),
    [anon_sym_LF] = ACTIONS(5656),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5658),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [674] = {
    [sym__block] = STATE(18568),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5660),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5662),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5664),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [675] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5666),
    [anon_sym_LF] = ACTIONS(5668),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5670),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [676] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5672),
    [anon_sym_LF] = ACTIONS(5674),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5676),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [677] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5678),
    [anon_sym_LF] = ACTIONS(5680),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5682),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [678] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5684),
    [anon_sym_LF] = ACTIONS(5686),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5688),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [679] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5690),
    [anon_sym_LF] = ACTIONS(5692),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5694),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [680] = {
    [sym__block] = STATE(18775),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5698),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5700),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [681] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5702),
    [anon_sym_LF] = ACTIONS(5704),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5706),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [682] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5708),
    [anon_sym_LF] = ACTIONS(5710),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5712),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [683] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5714),
    [anon_sym_LF] = ACTIONS(5716),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5718),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [684] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5720),
    [anon_sym_LF] = ACTIONS(5722),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5724),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [685] = {
    [sym__block] = STATE(18595),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5726),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5728),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5730),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [686] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5732),
    [anon_sym_LF] = ACTIONS(5734),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5736),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [687] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_LF] = ACTIONS(5740),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5742),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [688] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5744),
    [anon_sym_LF] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5748),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [689] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5750),
    [anon_sym_LF] = ACTIONS(5752),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5754),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [690] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5756),
    [anon_sym_LF] = ACTIONS(5758),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5760),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [691] = {
    [sym__block] = STATE(19251),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5762),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5764),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5766),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [692] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5768),
    [anon_sym_LF] = ACTIONS(5770),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5772),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [693] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5774),
    [anon_sym_LF] = ACTIONS(5776),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5778),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [694] = {
    [sym__block] = STATE(18282),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5780),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5782),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5784),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [695] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5786),
    [anon_sym_LF] = ACTIONS(5788),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5790),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [696] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5792),
    [anon_sym_LF] = ACTIONS(5794),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5796),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [697] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5798),
    [anon_sym_LF] = ACTIONS(5800),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5802),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [698] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5804),
    [anon_sym_LF] = ACTIONS(5806),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5808),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [699] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_LF] = ACTIONS(5812),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5814),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [700] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5816),
    [anon_sym_LF] = ACTIONS(5818),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5820),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [701] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5822),
    [anon_sym_LF] = ACTIONS(5824),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5826),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [702] = {
    [sym__block] = STATE(18400),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5828),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5830),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5832),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [703] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5834),
    [anon_sym_LF] = ACTIONS(5836),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5838),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [704] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5840),
    [anon_sym_LF] = ACTIONS(5842),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5844),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [705] = {
    [sym__block] = STATE(19372),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5846),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5848),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5850),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [706] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5852),
    [anon_sym_LF] = ACTIONS(5854),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5856),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [707] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5858),
    [anon_sym_LF] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [708] = {
    [sym__block] = STATE(19508),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5864),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5868),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [709] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5870),
    [anon_sym_LF] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5874),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [710] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5876),
    [anon_sym_LF] = ACTIONS(5878),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5880),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [711] = {
    [sym__block] = STATE(18574),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5882),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5884),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5886),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [712] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5888),
    [anon_sym_LF] = ACTIONS(5890),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [713] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5894),
    [anon_sym_LF] = ACTIONS(5896),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5898),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [714] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5900),
    [anon_sym_LF] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5904),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [715] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5906),
    [anon_sym_LF] = ACTIONS(5908),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5910),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [716] = {
    [sym__block] = STATE(19743),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5912),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5914),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [717] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5918),
    [anon_sym_LF] = ACTIONS(5920),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5922),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [718] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5924),
    [anon_sym_LF] = ACTIONS(5926),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [719] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5930),
    [anon_sym_LF] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5934),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [720] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5936),
    [anon_sym_LF] = ACTIONS(5938),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5940),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [721] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5942),
    [anon_sym_LF] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5946),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [722] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5948),
    [anon_sym_LF] = ACTIONS(5950),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5952),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [723] = {
    [sym__block] = STATE(19879),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5954),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5956),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [724] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5960),
    [anon_sym_LF] = ACTIONS(5962),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5964),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [725] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5966),
    [anon_sym_LF] = ACTIONS(5968),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5970),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [726] = {
    [sym__block] = STATE(18689),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5972),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [727] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5978),
    [anon_sym_LF] = ACTIONS(5980),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5982),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [728] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5984),
    [anon_sym_LF] = ACTIONS(5986),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(5988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [729] = {
    [sym__block] = STATE(18161),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5990),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(5992),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(5994),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [730] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5996),
    [anon_sym_LF] = ACTIONS(5998),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6000),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [731] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6002),
    [anon_sym_LF] = ACTIONS(6004),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [732] = {
    [sym__block] = STATE(18164),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6008),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6010),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6012),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [733] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6014),
    [anon_sym_LF] = ACTIONS(6016),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6018),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [734] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6020),
    [anon_sym_LF] = ACTIONS(6022),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [735] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6026),
    [anon_sym_LF] = ACTIONS(6028),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6030),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [736] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6032),
    [anon_sym_LF] = ACTIONS(6034),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [737] = {
    [sym__block] = STATE(19814),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6038),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6040),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6042),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [738] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6044),
    [anon_sym_LF] = ACTIONS(6046),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [739] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6050),
    [anon_sym_LF] = ACTIONS(6052),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [740] = {
    [sym__block] = STATE(19414),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6056),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6058),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6060),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [741] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6062),
    [anon_sym_LF] = ACTIONS(6064),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [742] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6068),
    [anon_sym_LF] = ACTIONS(6070),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6072),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [743] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6074),
    [anon_sym_LF] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6078),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [744] = {
    [sym__block] = STATE(18327),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6080),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6082),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6084),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [745] = {
    [sym__block] = STATE(19449),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6086),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6088),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6090),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [746] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6092),
    [anon_sym_LF] = ACTIONS(6094),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6096),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [747] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6098),
    [anon_sym_LF] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6102),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [748] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6104),
    [anon_sym_LF] = ACTIONS(6106),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6108),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [749] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6110),
    [anon_sym_LF] = ACTIONS(6112),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6114),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [750] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6116),
    [anon_sym_LF] = ACTIONS(6118),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6120),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [751] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6122),
    [anon_sym_LF] = ACTIONS(6124),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6126),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [752] = {
    [sym__block] = STATE(18244),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6128),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6130),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6132),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [753] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6134),
    [anon_sym_LF] = ACTIONS(6136),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6138),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [754] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6140),
    [anon_sym_LF] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6144),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [755] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_LF] = ACTIONS(6148),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [756] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6152),
    [anon_sym_LF] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6156),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [757] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6158),
    [anon_sym_LF] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [758] = {
    [sym__block] = STATE(18696),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6164),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6166),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6168),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [759] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6170),
    [anon_sym_LF] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [760] = {
    [sym__block] = STATE(18298),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6176),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6178),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6180),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [761] = {
    [sym__block] = STATE(19653),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6182),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6184),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [762] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6188),
    [anon_sym_LF] = ACTIONS(6190),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6192),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [763] = {
    [sym__block] = STATE(17118),
    [sym_assignment] = STATE(14658),
    [sym_open_tuple] = STATE(14519),
    [sym__expression] = STATE(12053),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10874),
    [sym__array] = STATE(10874),
    [sym_comprehension_expression] = STATE(10874),
    [sym_matrix_expression] = STATE(10874),
    [sym_vector_expression] = STATE(10874),
    [sym_parenthesized_expression] = STATE(10874),
    [sym_tuple_expression] = STATE(10874),
    [sym_curly_expression] = STATE(10874),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10874),
    [sym_index_expression] = STATE(10874),
    [sym_parametrized_type_expression] = STATE(10874),
    [sym_call_expression] = STATE(10874),
    [sym_broadcast_call_expression] = STATE(10874),
    [sym__closed_macrocall_expression] = STATE(10874),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10874),
    [sym_quote_expression] = STATE(10874),
    [sym_binary_expression] = STATE(12259),
    [sym_unary_expression] = STATE(12259),
    [sym_range_expression] = STATE(12259),
    [sym_splat_expression] = STATE(12259),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11948),
    [sym_unary_typed_expression] = STATE(12259),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12259),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10874),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10874),
    [sym_string_literal] = STATE(10874),
    [sym_command_literal] = STATE(10874),
    [sym_prefixed_string_literal] = STATE(10874),
    [sym_prefixed_command_literal] = STATE(10874),
    [sym_operator] = STATE(12127),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_end] = ACTIONS(6194),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_else] = ACTIONS(6194),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_finally] = ACTIONS(6194),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(5002),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [764] = {
    [sym__block] = STATE(18343),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6196),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6198),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6200),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [765] = {
    [sym__block] = STATE(18366),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6202),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6204),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6206),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [766] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6208),
    [anon_sym_LF] = ACTIONS(6210),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6212),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [767] = {
    [sym__block] = STATE(18439),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6214),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6216),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [768] = {
    [sym__block] = STATE(18500),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6220),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6222),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6224),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [769] = {
    [sym__block] = STATE(18512),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6226),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6228),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6230),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [770] = {
    [sym__block] = STATE(18516),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6232),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6234),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [771] = {
    [sym__block] = STATE(19854),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6238),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6240),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6242),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [772] = {
    [sym__block] = STATE(19778),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6244),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6246),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [773] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6250),
    [anon_sym_LF] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6254),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [774] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6256),
    [anon_sym_LF] = ACTIONS(6258),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [775] = {
    [sym__block] = STATE(18621),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6262),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6264),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6266),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [776] = {
    [sym__block] = STATE(19431),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6268),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6270),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [777] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6274),
    [anon_sym_LF] = ACTIONS(6276),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6278),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [778] = {
    [sym__block] = STATE(18707),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6280),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6282),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [779] = {
    [sym__block] = STATE(19627),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6286),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6288),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6290),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [780] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6292),
    [anon_sym_LF] = ACTIONS(6294),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6296),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [781] = {
    [sym__block] = STATE(19621),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6298),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LF] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(205),
    [anon_sym_AT] = ACTIONS(209),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(211),
    [aux_sym_integer_literal_token2] = ACTIONS(211),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(215),
    [aux_sym_float_literal_token3] = ACTIONS(215),
    [aux_sym_float_literal_token4] = ACTIONS(215),
    [sym_character_literal] = ACTIONS(217),
    [sym__pair_operator] = ACTIONS(79),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(79),
    [sym__pipe_left_operator] = ACTIONS(79),
    [sym__ellipsis_operator] = ACTIONS(79),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(79),
    [sym__bitshift_operator] = ACTIONS(79),
    [sym__power_operator] = ACTIONS(79),
    [sym__tilde_operator] = ACTIONS(219),
    [sym__type_order_operator] = ACTIONS(219),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [aux_sym__terminator_token1] = ACTIONS(6302),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [782] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6020),
    [anon_sym_LF] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [783] = {
    [sym__closed_assignment] = STATE(9513),
    [sym__expression] = STATE(7664),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16630),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [784] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_LF] = ACTIONS(6330),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [785] = {
    [sym__closed_assignment] = STATE(9539),
    [sym__expression] = STATE(7861),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16302),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6332),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6334),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [786] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(4846),
    [anon_sym_LF] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [787] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5432),
    [anon_sym_LF] = ACTIONS(6338),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [788] = {
    [sym__closed_assignment] = STATE(9478),
    [sym__expression] = STATE(7718),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16495),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6340),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6342),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [789] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5756),
    [anon_sym_LF] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [790] = {
    [sym__closed_assignment] = STATE(9541),
    [sym__expression] = STATE(7875),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16410),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6346),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [791] = {
    [sym__closed_assignment] = STATE(14452),
    [sym__expression] = STATE(11692),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17681),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6354),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [792] = {
    [sym__closed_assignment] = STATE(14414),
    [sym__expression] = STATE(11630),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17961),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6358),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6360),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [793] = {
    [sym__closed_assignment] = STATE(9502),
    [sym__expression] = STATE(7652),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15591),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6362),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6364),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [794] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5774),
    [anon_sym_LF] = ACTIONS(6366),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [795] = {
    [sym__closed_assignment] = STATE(9543),
    [sym__expression] = STATE(7887),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16485),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6368),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6370),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [796] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5444),
    [anon_sym_LF] = ACTIONS(6372),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [797] = {
    [sym__closed_assignment] = STATE(9482),
    [sym__expression] = STATE(7719),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16558),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6374),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [798] = {
    [sym__closed_assignment] = STATE(9532),
    [sym__expression] = STATE(7437),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16198),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6378),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6380),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [799] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5792),
    [anon_sym_LF] = ACTIONS(6382),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [800] = {
    [sym__closed_assignment] = STATE(9545),
    [sym__expression] = STATE(7892),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16537),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6384),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6386),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [801] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5260),
    [anon_sym_LF] = ACTIONS(6388),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [802] = {
    [sym__closed_assignment] = STATE(9519),
    [sym__expression] = STATE(7665),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16422),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6390),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6392),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [803] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5456),
    [anon_sym_LF] = ACTIONS(6394),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [804] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_LF] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [805] = {
    [sym__closed_assignment] = STATE(9481),
    [sym__expression] = STATE(7904),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16579),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [806] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5798),
    [anon_sym_LF] = ACTIONS(6402),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [807] = {
    [sym__closed_assignment] = STATE(9489),
    [sym__expression] = STATE(7722),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16615),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6406),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [808] = {
    [sym__closed_assignment] = STATE(14453),
    [sym__expression] = STATE(11616),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17888),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6408),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6410),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [809] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5822),
    [anon_sym_LF] = ACTIONS(6412),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [810] = {
    [sym__closed_assignment] = STATE(9533),
    [sym__expression] = STATE(7914),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16624),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6414),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6416),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [811] = {
    [sym__closed_assignment] = STATE(14422),
    [sym__expression] = STATE(11647),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17520),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6418),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6420),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6422),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [812] = {
    [sym__closed_assignment] = STATE(9529),
    [sym__expression] = STATE(7545),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16175),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6426),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [813] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5474),
    [anon_sym_LF] = ACTIONS(6428),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [814] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5840),
    [anon_sym_LF] = ACTIONS(6430),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [815] = {
    [sym__closed_assignment] = STATE(9510),
    [sym__expression] = STATE(7925),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15475),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6434),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [816] = {
    [sym__closed_assignment] = STATE(9494),
    [sym__expression] = STATE(7726),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15530),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6436),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6438),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [817] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5278),
    [anon_sym_LF] = ACTIONS(6440),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [818] = {
    [sym__closed_assignment] = STATE(9523),
    [sym__expression] = STATE(7668),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16604),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6442),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [819] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5858),
    [anon_sym_LF] = ACTIONS(6446),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [820] = {
    [sym__closed_assignment] = STATE(9528),
    [sym__expression] = STATE(7927),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15498),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6448),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6450),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [821] = {
    [sym__closed_assignment] = STATE(9540),
    [sym__expression] = STATE(7605),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16399),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6452),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6454),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [822] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5492),
    [anon_sym_LF] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [823] = {
    [sym__closed_assignment] = STATE(9501),
    [sym__expression] = STATE(7736),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15595),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6460),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [824] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5876),
    [anon_sym_LF] = ACTIONS(6462),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [825] = {
    [sym__closed_assignment] = STATE(9483),
    [sym__expression] = STATE(7940),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15519),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6466),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [826] = {
    [sym__closed_assignment] = STATE(14461),
    [sym__expression] = STATE(11772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17931),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6470),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [827] = {
    [sym__block] = STATE(17608),
    [sym_assignment] = STATE(15431),
    [sym_open_tuple] = STATE(14773),
    [sym__expression] = STATE(12586),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11014),
    [sym__array] = STATE(11014),
    [sym_comprehension_expression] = STATE(11014),
    [sym_matrix_expression] = STATE(11014),
    [sym_vector_expression] = STATE(11014),
    [sym_parenthesized_expression] = STATE(11014),
    [sym_tuple_expression] = STATE(11014),
    [sym_curly_expression] = STATE(11014),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11014),
    [sym_index_expression] = STATE(11014),
    [sym_parametrized_type_expression] = STATE(11014),
    [sym_call_expression] = STATE(11014),
    [sym_broadcast_call_expression] = STATE(11014),
    [sym__closed_macrocall_expression] = STATE(11014),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11014),
    [sym_quote_expression] = STATE(11014),
    [sym_binary_expression] = STATE(12958),
    [sym_unary_expression] = STATE(12958),
    [sym_range_expression] = STATE(12958),
    [sym_splat_expression] = STATE(12958),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(12958),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12958),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11014),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11014),
    [sym_string_literal] = STATE(11014),
    [sym_command_literal] = STATE(11014),
    [sym_prefixed_string_literal] = STATE(11014),
    [sym_prefixed_command_literal] = STATE(11014),
    [sym_operator] = STATE(12771),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6472),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(6472),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(6484),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [828] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5296),
    [anon_sym_LF] = ACTIONS(6488),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [829] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5894),
    [anon_sym_LF] = ACTIONS(6490),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [830] = {
    [sym__closed_assignment] = STATE(9495),
    [sym__expression] = STATE(7948),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15537),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6492),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6494),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [831] = {
    [sym__closed_assignment] = STATE(831),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(831),
    [sym__word_identifier] = ACTIONS(6496),
    [anon_sym_COLON] = ACTIONS(6499),
    [anon_sym_begin] = ACTIONS(6502),
    [anon_sym_module] = ACTIONS(6505),
    [anon_sym_baremodule] = ACTIONS(6505),
    [anon_sym_abstract] = ACTIONS(6508),
    [anon_sym_primitive] = ACTIONS(6511),
    [anon_sym_mutable] = ACTIONS(6514),
    [anon_sym_struct] = ACTIONS(6517),
    [anon_sym_function] = ACTIONS(6520),
    [anon_sym_macro] = ACTIONS(6523),
    [anon_sym_quote] = ACTIONS(6526),
    [anon_sym_let] = ACTIONS(6529),
    [anon_sym_if] = ACTIONS(6532),
    [anon_sym_try] = ACTIONS(6535),
    [anon_sym_for] = ACTIONS(6538),
    [anon_sym_while] = ACTIONS(6541),
    [sym_break_statement] = ACTIONS(6544),
    [sym_continue_statement] = ACTIONS(6544),
    [anon_sym_return] = ACTIONS(6547),
    [anon_sym_const] = ACTIONS(6550),
    [anon_sym_global] = ACTIONS(6553),
    [anon_sym_local] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6559),
    [anon_sym_export] = ACTIONS(6562),
    [anon_sym_import] = ACTIONS(6565),
    [anon_sym_using] = ACTIONS(6565),
    [anon_sym_LBRACK] = ACTIONS(6568),
    [anon_sym_RBRACK] = ACTIONS(6571),
    [anon_sym_LF] = ACTIONS(6573),
    [anon_sym_LBRACE] = ACTIONS(6575),
    [anon_sym_DOLLAR] = ACTIONS(6578),
    [anon_sym_COLON_COLON] = ACTIONS(6581),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(6587),
    [anon_sym_false] = ACTIONS(6587),
    [aux_sym_integer_literal_token1] = ACTIONS(6590),
    [aux_sym_integer_literal_token2] = ACTIONS(6590),
    [aux_sym_integer_literal_token3] = ACTIONS(6590),
    [aux_sym_integer_literal_token4] = ACTIONS(6593),
    [aux_sym_float_literal_token1] = ACTIONS(6596),
    [aux_sym_float_literal_token3] = ACTIONS(6596),
    [aux_sym_float_literal_token4] = ACTIONS(6596),
    [sym_character_literal] = ACTIONS(6599),
    [sym__pair_operator] = ACTIONS(6602),
    [sym__arrow_operator] = ACTIONS(6602),
    [sym__comparison_operator] = ACTIONS(6602),
    [sym__pipe_right_operator] = ACTIONS(6602),
    [sym__pipe_left_operator] = ACTIONS(6602),
    [sym__ellipsis_operator] = ACTIONS(6602),
    [sym__plus_operator] = ACTIONS(6602),
    [sym__times_operator] = ACTIONS(6602),
    [sym__rational_operator] = ACTIONS(6602),
    [sym__bitshift_operator] = ACTIONS(6602),
    [sym__power_operator] = ACTIONS(6602),
    [sym__tilde_operator] = ACTIONS(6605),
    [sym__type_order_operator] = ACTIONS(6605),
    [sym__unary_operator] = ACTIONS(6605),
    [sym__unary_plus_operator] = ACTIONS(6605),
    [aux_sym__terminator_token1] = ACTIONS(6571),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(6608),
    [sym__command_start] = ACTIONS(6611),
  },
  [832] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5510),
    [anon_sym_LF] = ACTIONS(6614),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [833] = {
    [sym__closed_assignment] = STATE(9503),
    [sym__expression] = STATE(7740),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16148),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6616),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6618),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [834] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5906),
    [anon_sym_LF] = ACTIONS(6620),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [835] = {
    [sym__closed_assignment] = STATE(9499),
    [sym__expression] = STATE(7952),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15553),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6622),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [836] = {
    [sym__closed_assignment] = STATE(14429),
    [sym__expression] = STATE(11841),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17792),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6626),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6628),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [837] = {
    [sym__closed_assignment] = STATE(9527),
    [sym__expression] = STATE(7676),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15829),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6630),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [838] = {
    [sym__block] = STATE(18134),
    [sym_assignment] = STATE(15440),
    [sym_open_tuple] = STATE(14649),
    [sym__expression] = STATE(12546),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11023),
    [sym__array] = STATE(11023),
    [sym_comprehension_expression] = STATE(11023),
    [sym_matrix_expression] = STATE(11023),
    [sym_vector_expression] = STATE(11023),
    [sym_parenthesized_expression] = STATE(11023),
    [sym_tuple_expression] = STATE(11023),
    [sym_curly_expression] = STATE(11023),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11023),
    [sym_index_expression] = STATE(11023),
    [sym_parametrized_type_expression] = STATE(11023),
    [sym_call_expression] = STATE(11023),
    [sym_broadcast_call_expression] = STATE(11023),
    [sym__closed_macrocall_expression] = STATE(11023),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11023),
    [sym_quote_expression] = STATE(11023),
    [sym_binary_expression] = STATE(13099),
    [sym_unary_expression] = STATE(13099),
    [sym_range_expression] = STATE(13099),
    [sym_splat_expression] = STATE(13099),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12587),
    [sym_unary_typed_expression] = STATE(13099),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13099),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11023),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11023),
    [sym_string_literal] = STATE(11023),
    [sym_command_literal] = STATE(11023),
    [sym_prefixed_string_literal] = STATE(11023),
    [sym_prefixed_command_literal] = STATE(11023),
    [sym_operator] = STATE(12589),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6634),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(6634),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(6646),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [839] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5924),
    [anon_sym_LF] = ACTIONS(6650),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [840] = {
    [sym__closed_assignment] = STATE(9509),
    [sym__expression] = STATE(7953),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15575),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6652),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6654),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [841] = {
    [sym__closed_assignment] = STATE(14434),
    [sym__expression] = STATE(11762),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17858),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6656),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6658),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [842] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5522),
    [anon_sym_LF] = ACTIONS(6660),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [843] = {
    [sym__closed_assignment] = STATE(9504),
    [sym__expression] = STATE(7743),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15531),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6662),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6664),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [844] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5936),
    [anon_sym_LF] = ACTIONS(6666),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [845] = {
    [sym__closed_assignment] = STATE(9512),
    [sym__expression] = STATE(7956),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15597),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6668),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6670),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [846] = {
    [sym__closed_assignment] = STATE(9477),
    [sym__expression] = STATE(7585),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16111),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6672),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6674),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [847] = {
    [sym__closed_assignment] = STATE(9498),
    [sym__expression] = STATE(7580),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15778),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6676),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6678),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [848] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5024),
    [anon_sym_LF] = ACTIONS(6680),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [849] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5948),
    [anon_sym_LF] = ACTIONS(6682),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [850] = {
    [sym__closed_assignment] = STATE(9518),
    [sym__expression] = STATE(7957),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15612),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6684),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6686),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [851] = {
    [sym__closed_assignment] = STATE(14419),
    [sym__expression] = STATE(11690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17719),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6688),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6690),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [852] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5534),
    [anon_sym_LF] = ACTIONS(6692),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [853] = {
    [sym__closed_assignment] = STATE(9505),
    [sym__expression] = STATE(7747),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15774),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6694),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6696),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [854] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5966),
    [anon_sym_LF] = ACTIONS(6698),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [855] = {
    [sym__closed_assignment] = STATE(9536),
    [sym__expression] = STATE(7961),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15635),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6700),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6702),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [856] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5312),
    [anon_sym_LF] = ACTIONS(6704),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [857] = {
    [sym__closed_assignment] = STATE(9534),
    [sym__expression] = STATE(7689),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16563),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6706),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6708),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [858] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5018),
    [anon_sym_LF] = ACTIONS(6710),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [859] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5984),
    [anon_sym_LF] = ACTIONS(6712),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [860] = {
    [sym__closed_assignment] = STATE(9544),
    [sym__expression] = STATE(7965),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15653),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6714),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [861] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5552),
    [anon_sym_LF] = ACTIONS(6718),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [862] = {
    [sym__closed_assignment] = STATE(9506),
    [sym__expression] = STATE(7759),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16138),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6720),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6722),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [863] = {
    [sym__closed_assignment] = STATE(9490),
    [sym__expression] = STATE(7505),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16140),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6724),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6726),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [864] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6002),
    [anon_sym_LF] = ACTIONS(6728),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [865] = {
    [sym__closed_assignment] = STATE(9547),
    [sym__expression] = STATE(7970),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15677),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6730),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6732),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [866] = {
    [sym__closed_assignment] = STATE(9500),
    [sym__expression] = STATE(7306),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16045),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6734),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6736),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [867] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5330),
    [anon_sym_LF] = ACTIONS(6738),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [868] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5570),
    [anon_sym_LF] = ACTIONS(6740),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [869] = {
    [sym__closed_assignment] = STATE(9520),
    [sym__expression] = STATE(7714),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16332),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6742),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6744),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [870] = {
    [sym__closed_assignment] = STATE(14446),
    [sym__expression] = STATE(11678),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17983),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6746),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6748),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [871] = {
    [sym__closed_assignment] = STATE(9514),
    [sym__expression] = STATE(7579),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16645),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6750),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6752),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [872] = {
    [sym__closed_assignment] = STATE(9507),
    [sym__expression] = STATE(7772),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16408),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6754),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6756),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [873] = {
    [sym__closed_assignment] = STATE(14452),
    [sym__expression] = STATE(11588),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17752),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6758),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6760),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [874] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6032),
    [anon_sym_LF] = ACTIONS(6762),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [875] = {
    [sym__closed_assignment] = STATE(9480),
    [sym__expression] = STATE(7992),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15711),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6764),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6766),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [876] = {
    [sym__closed_assignment] = STATE(9537),
    [sym__expression] = STATE(7696),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15613),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6768),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6770),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [877] = {
    [sym__closed_assignment] = STATE(9486),
    [sym__expression] = STATE(7632),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16547),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6772),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6774),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [878] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_LF] = ACTIONS(6776),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [879] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6050),
    [anon_sym_LF] = ACTIONS(6778),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [880] = {
    [sym__closed_assignment] = STATE(9548),
    [sym__expression] = STATE(7999),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15726),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6780),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6782),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [881] = {
    [sym__closed_assignment] = STATE(9511),
    [sym__expression] = STATE(7778),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16620),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6784),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6786),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [882] = {
    [sym_assignment] = STATE(15343),
    [sym_open_tuple] = STATE(14631),
    [sym__expression] = STATE(12376),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10874),
    [sym__array] = STATE(10874),
    [sym_comprehension_expression] = STATE(10874),
    [sym_matrix_expression] = STATE(10874),
    [sym_vector_expression] = STATE(10874),
    [sym_parenthesized_expression] = STATE(10874),
    [sym_tuple_expression] = STATE(10874),
    [sym_curly_expression] = STATE(10874),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10874),
    [sym_index_expression] = STATE(10874),
    [sym_parametrized_type_expression] = STATE(10874),
    [sym_call_expression] = STATE(10874),
    [sym_broadcast_call_expression] = STATE(10874),
    [sym__closed_macrocall_expression] = STATE(10874),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10874),
    [sym_quote_expression] = STATE(10874),
    [sym_binary_expression] = STATE(12259),
    [sym_unary_expression] = STATE(12259),
    [sym_range_expression] = STATE(12259),
    [sym_splat_expression] = STATE(12259),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11948),
    [sym_unary_typed_expression] = STATE(12259),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12259),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10874),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10874),
    [sym_string_literal] = STATE(10874),
    [sym_command_literal] = STATE(10874),
    [sym_prefixed_string_literal] = STATE(10874),
    [sym_prefixed_command_literal] = STATE(10874),
    [sym_operator] = STATE(12127),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_end] = ACTIONS(6788),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_else] = ACTIONS(6788),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_finally] = ACTIONS(6788),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(5002),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [883] = {
    [sym__closed_assignment] = STATE(14471),
    [sym__expression] = STATE(11614),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(18071),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6790),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6792),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [884] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6068),
    [anon_sym_LF] = ACTIONS(6794),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [885] = {
    [sym__closed_assignment] = STATE(9484),
    [sym__expression] = STATE(8000),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15745),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6796),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6798),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [886] = {
    [sym__closed_assignment] = STATE(831),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(831),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6800),
    [anon_sym_LF] = ACTIONS(6802),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [aux_sym__terminator_token1] = ACTIONS(6800),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [887] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5348),
    [anon_sym_LF] = ACTIONS(6804),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [888] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(6806),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [889] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(4802),
    [anon_sym_LF] = ACTIONS(6808),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [890] = {
    [sym__closed_assignment] = STATE(9488),
    [sym__expression] = STATE(8002),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15761),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6810),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6812),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [891] = {
    [sym__closed_assignment] = STATE(9515),
    [sym__expression] = STATE(7788),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15532),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6814),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6816),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [892] = {
    [sym__closed_assignment] = STATE(9542),
    [sym__expression] = STATE(7699),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15840),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6818),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6820),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [893] = {
    [sym__closed_assignment] = STATE(14472),
    [sym__expression] = STATE(11839),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17934),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6822),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6824),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [894] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6098),
    [anon_sym_LF] = ACTIONS(6826),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [895] = {
    [sym__closed_assignment] = STATE(9492),
    [sym__expression] = STATE(8006),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15779),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6828),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6830),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [896] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5208),
    [anon_sym_LF] = ACTIONS(6832),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [897] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5618),
    [anon_sym_LF] = ACTIONS(6834),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [898] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6110),
    [anon_sym_LF] = ACTIONS(6836),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [899] = {
    [sym__closed_assignment] = STATE(9493),
    [sym__expression] = STATE(8008),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15796),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6838),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6840),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [900] = {
    [sym__closed_assignment] = STATE(9517),
    [sym__expression] = STATE(7796),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15602),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6842),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6844),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [901] = {
    [sym__closed_assignment] = STATE(14424),
    [sym__expression] = STATE(11806),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17772),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6846),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6848),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [902] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6122),
    [anon_sym_LF] = ACTIONS(6850),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [903] = {
    [sym__closed_assignment] = STATE(9496),
    [sym__expression] = STATE(8011),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15813),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6852),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6854),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [904] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5366),
    [anon_sym_LF] = ACTIONS(6856),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [905] = {
    [sym__closed_assignment] = STATE(9546),
    [sym__expression] = STATE(7704),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16090),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6858),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6860),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [906] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5636),
    [anon_sym_LF] = ACTIONS(6862),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [907] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6140),
    [anon_sym_LF] = ACTIONS(6864),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [908] = {
    [sym__closed_assignment] = STATE(9497),
    [sym__expression] = STATE(8013),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15832),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6866),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6868),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [909] = {
    [sym__closed_assignment] = STATE(9522),
    [sym__expression] = STATE(7810),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15676),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6870),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6872),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [910] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5354),
    [anon_sym_LF] = ACTIONS(6874),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [911] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6152),
    [anon_sym_LF] = ACTIONS(6876),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [912] = {
    [sym__closed_assignment] = STATE(9487),
    [sym__expression] = STATE(7650),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16404),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6878),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6880),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [913] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5118),
    [anon_sym_LF] = ACTIONS(6882),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [914] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5654),
    [anon_sym_LF] = ACTIONS(6884),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [915] = {
    [sym__closed_assignment] = STATE(9525),
    [sym__expression] = STATE(7817),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15755),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6886),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [916] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5378),
    [anon_sym_LF] = ACTIONS(6890),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [917] = {
    [sym__closed_assignment] = STATE(9530),
    [sym__expression] = STATE(7707),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16167),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6892),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6894),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [918] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6188),
    [anon_sym_LF] = ACTIONS(6896),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [919] = {
    [sym__closed_assignment] = STATE(14420),
    [sym__expression] = STATE(11598),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17967),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6900),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [920] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5672),
    [anon_sym_LF] = ACTIONS(6902),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [921] = {
    [sym__closed_assignment] = STATE(9526),
    [sym__expression] = STATE(7828),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15817),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6904),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [922] = {
    [sym__closed_assignment] = STATE(9508),
    [sym__expression] = STATE(7661),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16144),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6908),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6910),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [923] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6208),
    [anon_sym_LF] = ACTIONS(6912),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [924] = {
    [sym__closed_assignment] = STATE(9485),
    [sym__expression] = STATE(7568),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15567),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6914),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6916),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [925] = {
    [sym__closed_assignment] = STATE(14444),
    [sym__expression] = STATE(11780),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17883),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(6918),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(6920),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [926] = {
    [sym__closed_assignment] = STATE(9524),
    [sym__expression] = STATE(7597),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16223),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6922),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6924),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [927] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5396),
    [anon_sym_LF] = ACTIONS(6926),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [928] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(14717),
    [sym__expression] = STATE(12576),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6788),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(6788),
    [anon_sym_else] = ACTIONS(6788),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [929] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5690),
    [anon_sym_LF] = ACTIONS(6928),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [930] = {
    [sym__closed_assignment] = STATE(9531),
    [sym__expression] = STATE(7838),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16079),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6930),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6932),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [931] = {
    [sym__closed_assignment] = STATE(9491),
    [sym__expression] = STATE(7712),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16227),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6934),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6936),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [932] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(4900),
    [anon_sym_LF] = ACTIONS(6938),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [933] = {
    [sym_assignment] = STATE(15343),
    [sym_open_tuple] = STATE(14631),
    [sym__expression] = STATE(12376),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10874),
    [sym__array] = STATE(10874),
    [sym_comprehension_expression] = STATE(10874),
    [sym_matrix_expression] = STATE(10874),
    [sym_vector_expression] = STATE(10874),
    [sym_parenthesized_expression] = STATE(10874),
    [sym_tuple_expression] = STATE(10874),
    [sym_curly_expression] = STATE(10874),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10874),
    [sym_index_expression] = STATE(10874),
    [sym_parametrized_type_expression] = STATE(10874),
    [sym_call_expression] = STATE(10874),
    [sym_broadcast_call_expression] = STATE(10874),
    [sym__closed_macrocall_expression] = STATE(10874),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10874),
    [sym_quote_expression] = STATE(10874),
    [sym_binary_expression] = STATE(12259),
    [sym_unary_expression] = STATE(12259),
    [sym_range_expression] = STATE(12259),
    [sym_splat_expression] = STATE(12259),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11948),
    [sym_unary_typed_expression] = STATE(12259),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12259),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10874),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10874),
    [sym_string_literal] = STATE(10874),
    [sym_command_literal] = STATE(10874),
    [sym_prefixed_string_literal] = STATE(10874),
    [sym_prefixed_command_literal] = STATE(10874),
    [sym_operator] = STATE(12127),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_end] = ACTIONS(6940),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_else] = ACTIONS(6940),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_finally] = ACTIONS(6940),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(5002),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [934] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5708),
    [anon_sym_LF] = ACTIONS(6942),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [935] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(14717),
    [sym__expression] = STATE(12576),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6940),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(6940),
    [anon_sym_else] = ACTIONS(6940),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [936] = {
    [sym__closed_assignment] = STATE(9535),
    [sym__expression] = STATE(7845),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16145),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6944),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6946),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [937] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5678),
    [anon_sym_LF] = ACTIONS(6948),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [938] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6256),
    [anon_sym_LF] = ACTIONS(6950),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [939] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5242),
    [anon_sym_LF] = ACTIONS(6952),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [940] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5414),
    [anon_sym_LF] = ACTIONS(6954),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [941] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(5720),
    [anon_sym_LF] = ACTIONS(6956),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [942] = {
    [sym__closed_assignment] = STATE(9538),
    [sym__expression] = STATE(7851),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(16216),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6958),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [943] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_RBRACK] = ACTIONS(6292),
    [anon_sym_LF] = ACTIONS(6962),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [944] = {
    [sym__closed_assignment] = STATE(9479),
    [sym__expression] = STATE(7980),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_matrix_row] = STATE(15694),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COMMA] = ACTIONS(6964),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6966),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [945] = {
    [sym__block] = STATE(18217),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6968),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [946] = {
    [sym__block] = STATE(18193),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6984),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [947] = {
    [sym__block] = STATE(19544),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6986),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [948] = {
    [sym__block] = STATE(18196),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5072),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [949] = {
    [sym__block] = STATE(18168),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5084),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [950] = {
    [sym__block] = STATE(18199),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6988),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [951] = {
    [sym__block] = STATE(18219),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6990),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [952] = {
    [sym__block] = STATE(18222),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6992),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [953] = {
    [sym__block] = STATE(18264),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6994),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [954] = {
    [sym__block] = STATE(18211),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6996),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [955] = {
    [sym__block] = STATE(18479),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4742),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [956] = {
    [sym__closed_assignment] = STATE(14750),
    [sym__expression] = STATE(12057),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17808),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3492),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [957] = {
    [sym__block] = STATE(18578),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6998),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [958] = {
    [sym__block] = STATE(18440),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7000),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [959] = {
    [sym__closed_assignment] = STATE(16541),
    [sym__expression] = STATE(12269),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7002),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7004),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7006),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [960] = {
    [sym__block] = STATE(19575),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5112),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [961] = {
    [sym__block] = STATE(19094),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7010),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [962] = {
    [sym__block] = STATE(19651),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7012),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [963] = {
    [sym__block] = STATE(19665),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7014),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [964] = {
    [sym__block] = STATE(19699),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7016),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [965] = {
    [sym__block] = STATE(18799),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7018),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [966] = {
    [sym__block] = STATE(19846),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7020),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [967] = {
    [sym__block] = STATE(19854),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6238),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [968] = {
    [sym__block] = STATE(18648),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7022),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [969] = {
    [sym__block] = STATE(19046),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7024),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [970] = {
    [sym__block] = STATE(19246),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5124),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [971] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7026),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [972] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7032),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [973] = {
    [sym__block] = STATE(18572),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7034),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [974] = {
    [sym__block] = STATE(18647),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5130),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [975] = {
    [sym__block] = STATE(19086),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7036),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [976] = {
    [sym__block] = STATE(19134),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7038),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [977] = {
    [sym__block] = STATE(18560),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7040),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [978] = {
    [sym__block] = STATE(18870),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7042),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [979] = {
    [sym__block] = STATE(19778),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6244),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [980] = {
    [sym__block] = STATE(18650),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7044),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [981] = {
    [sym__block] = STATE(18475),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7046),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [982] = {
    [sym__block] = STATE(18877),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7048),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [983] = {
    [sym__block] = STATE(19003),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7050),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [984] = {
    [sym__block] = STATE(18926),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7052),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [985] = {
    [sym__block] = STATE(18853),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7054),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [986] = {
    [sym__closed_assignment] = STATE(14954),
    [sym__expression] = STATE(11944),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17891),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3584),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3586),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [987] = {
    [sym__block] = STATE(18928),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7056),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [988] = {
    [sym__block] = STATE(18696),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6164),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [989] = {
    [sym__block] = STATE(17608),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6472),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [990] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(11873),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16988),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7060),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [991] = {
    [sym__closed_assignment] = STATE(14705),
    [sym__expression] = STATE(11898),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17895),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3724),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3726),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [992] = {
    [sym__block] = STATE(18755),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7062),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [993] = {
    [sym__block] = STATE(18352),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7064),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [994] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(12128),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16909),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7066),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [995] = {
    [sym__block] = STATE(18417),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5184),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [996] = {
    [sym__closed_assignment] = STATE(14833),
    [sym__expression] = STATE(11909),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17681),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3482),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3484),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [997] = {
    [sym__block] = STATE(18445),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7068),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [998] = {
    [sym__block] = STATE(18453),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7070),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [999] = {
    [sym__block] = STATE(18454),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7072),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1000] = {
    [sym__block] = STATE(18472),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7074),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1001] = {
    [sym__block] = STATE(18772),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7076),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1002] = {
    [sym__block] = STATE(18580),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4556),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1003] = {
    [sym__block] = STATE(19173),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7078),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1004] = {
    [sym__block] = STATE(18668),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7080),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1005] = {
    [sym__block] = STATE(18791),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7082),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1006] = {
    [sym__closed_assignment] = STATE(15704),
    [sym__expression] = STATE(12315),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7084),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7086),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7088),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1007] = {
    [sym__block] = STATE(19181),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5196),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1008] = {
    [sym__block] = STATE(19204),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5230),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1009] = {
    [sym__block] = STATE(18805),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7090),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1010] = {
    [sym__block] = STATE(18943),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7092),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1011] = {
    [sym__block] = STATE(19111),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7094),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1012] = {
    [sym__block] = STATE(19201),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7096),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1013] = {
    [sym__block] = STATE(19663),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7098),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1014] = {
    [sym__block] = STATE(19213),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7100),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1015] = {
    [sym__block] = STATE(19216),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7102),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1016] = {
    [sym__block] = STATE(19227),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7104),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1017] = {
    [sym__block] = STATE(19295),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7106),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1018] = {
    [sym__block] = STATE(19305),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5218),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1019] = {
    [sym__block] = STATE(19232),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7108),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1020] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1021] = {
    [sym__block] = STATE(19359),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7112),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1022] = {
    [sym__block] = STATE(19436),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5224),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1023] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(15336),
    [sym__expression] = STATE(13076),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11023),
    [sym__array] = STATE(11023),
    [sym_comprehension_expression] = STATE(11023),
    [sym_matrix_expression] = STATE(11023),
    [sym_vector_expression] = STATE(11023),
    [sym_parenthesized_expression] = STATE(11023),
    [sym_tuple_expression] = STATE(11023),
    [sym_curly_expression] = STATE(11023),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11023),
    [sym_index_expression] = STATE(11023),
    [sym_parametrized_type_expression] = STATE(11023),
    [sym_call_expression] = STATE(11023),
    [sym_broadcast_call_expression] = STATE(11023),
    [sym__closed_macrocall_expression] = STATE(11023),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11023),
    [sym_quote_expression] = STATE(11023),
    [sym_binary_expression] = STATE(13099),
    [sym_unary_expression] = STATE(13099),
    [sym_range_expression] = STATE(13099),
    [sym_splat_expression] = STATE(13099),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12587),
    [sym_unary_typed_expression] = STATE(13099),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13099),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11023),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11023),
    [sym_string_literal] = STATE(11023),
    [sym_command_literal] = STATE(11023),
    [sym_prefixed_string_literal] = STATE(11023),
    [sym_prefixed_command_literal] = STATE(11023),
    [sym_operator] = STATE(12589),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6788),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(6788),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(6646),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1024] = {
    [sym__block] = STATE(19455),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7114),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1025] = {
    [sym__block] = STATE(19488),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7116),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1026] = {
    [sym__block] = STATE(19288),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4634),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1027] = {
    [sym__block] = STATE(18940),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4538),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1028] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(12239),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16750),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7118),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1029] = {
    [sym__closed_assignment] = STATE(15068),
    [sym__expression] = STATE(11904),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17792),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3472),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3474),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1030] = {
    [sym__block] = STATE(19301),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7120),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1031] = {
    [sym__closed_assignment] = STATE(16477),
    [sym__expression] = STATE(12337),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7122),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7124),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7126),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1032] = {
    [sym__block] = STATE(19342),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7128),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1033] = {
    [sym__closed_assignment] = STATE(15687),
    [sym__expression] = STATE(12602),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7130),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7132),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7134),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1034] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7136),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1035] = {
    [sym__block] = STATE(19487),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7138),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1036] = {
    [sym__block] = STATE(18984),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7140),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1037] = {
    [sym__block] = STATE(19478),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5318),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1038] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(11988),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7142),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1039] = {
    [sym__closed_assignment] = STATE(14573),
    [sym__expression] = STATE(12011),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17898),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3594),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3596),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1040] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(15336),
    [sym__expression] = STATE(13076),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11023),
    [sym__array] = STATE(11023),
    [sym_comprehension_expression] = STATE(11023),
    [sym_matrix_expression] = STATE(11023),
    [sym_vector_expression] = STATE(11023),
    [sym_parenthesized_expression] = STATE(11023),
    [sym_tuple_expression] = STATE(11023),
    [sym_curly_expression] = STATE(11023),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11023),
    [sym_index_expression] = STATE(11023),
    [sym_parametrized_type_expression] = STATE(11023),
    [sym_call_expression] = STATE(11023),
    [sym_broadcast_call_expression] = STATE(11023),
    [sym__closed_macrocall_expression] = STATE(11023),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11023),
    [sym_quote_expression] = STATE(11023),
    [sym_binary_expression] = STATE(13099),
    [sym_unary_expression] = STATE(13099),
    [sym_range_expression] = STATE(13099),
    [sym_splat_expression] = STATE(13099),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12587),
    [sym_unary_typed_expression] = STATE(13099),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13099),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11023),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11023),
    [sym_string_literal] = STATE(11023),
    [sym_command_literal] = STATE(11023),
    [sym_prefixed_string_literal] = STATE(11023),
    [sym_prefixed_command_literal] = STATE(11023),
    [sym_operator] = STATE(12589),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6940),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(6940),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(6646),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1041] = {
    [sym__closed_assignment] = STATE(15749),
    [sym__expression] = STATE(12347),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7144),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7146),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7148),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1042] = {
    [sym__block] = STATE(19507),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7150),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1043] = {
    [sym__block] = STATE(19513),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7152),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1044] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7154),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1045] = {
    [sym__block] = STATE(18317),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7156),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1046] = {
    [sym__block] = STATE(19523),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7158),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1047] = {
    [sym__closed_assignment] = STATE(15009),
    [sym__expression] = STATE(11958),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17900),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3604),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3606),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1048] = {
    [sym__block] = STATE(19559),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7160),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1049] = {
    [sym__closed_assignment] = STATE(16081),
    [sym__expression] = STATE(12363),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7162),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7164),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7166),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1050] = {
    [sym__closed_assignment] = STATE(15667),
    [sym__expression] = STATE(12600),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7168),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7170),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7172),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1051] = {
    [sym__block] = STATE(18890),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7174),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1052] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7176),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1053] = {
    [sym__block] = STATE(18704),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7178),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1054] = {
    [sym__closed_assignment] = STATE(14597),
    [sym__expression] = STATE(11912),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17904),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7180),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7182),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1055] = {
    [sym__block] = STATE(19655),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7184),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1056] = {
    [sym__closed_assignment] = STATE(15731),
    [sym__expression] = STATE(12373),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7186),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7188),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7190),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1057] = {
    [sym__block] = STATE(19660),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5402),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1058] = {
    [sym__block] = STATE(19431),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6268),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1059] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7192),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1060] = {
    [sym__block] = STATE(18818),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7194),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1061] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7196),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1062] = {
    [sym__closed_assignment] = STATE(14651),
    [sym__expression] = STATE(11905),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17907),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3614),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1063] = {
    [sym__block] = STATE(19703),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7198),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1064] = {
    [sym__block] = STATE(19715),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5420),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1065] = {
    [sym__closed_assignment] = STATE(16191),
    [sym__expression] = STATE(12380),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7200),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7202),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7204),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1066] = {
    [sym__block] = STATE(18586),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7206),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1067] = {
    [sym__block] = STATE(19721),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7208),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1068] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7210),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1069] = {
    [sym__block] = STATE(18537),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7212),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1070] = {
    [sym__block] = STATE(19730),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7214),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1071] = {
    [sym__closed_assignment] = STATE(14756),
    [sym__expression] = STATE(12092),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17340),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3624),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3626),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1072] = {
    [sym__block] = STATE(17052),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(99),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1073] = {
    [sym__block] = STATE(19562),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7216),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1074] = {
    [sym__closed_assignment] = STATE(15518),
    [sym__expression] = STATE(12400),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7218),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7220),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7222),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1075] = {
    [sym__block] = STATE(19565),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7224),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1076] = {
    [sym__block] = STATE(19578),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7226),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1077] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7228),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1078] = {
    [sym__block] = STATE(18643),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7230),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1079] = {
    [sym__block] = STATE(19664),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7232),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1080] = {
    [sym__closed_assignment] = STATE(14872),
    [sym__expression] = STATE(11910),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17913),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3746),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1081] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(12054),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17293),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7234),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1082] = {
    [sym__closed_assignment] = STATE(15751),
    [sym__expression] = STATE(12418),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7236),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7238),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1083] = {
    [sym__block] = STATE(19328),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7242),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1084] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7244),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1085] = {
    [sym__block] = STATE(19099),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7246),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1086] = {
    [sym__block] = STATE(18134),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6634),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1087] = {
    [sym__closed_assignment] = STATE(14952),
    [sym__expression] = STATE(12030),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17914),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3634),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3636),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1088] = {
    [sym__closed_assignment] = STATE(16054),
    [sym__expression] = STATE(12426),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7248),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7250),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7252),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1089] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(15325),
    [sym__expression] = STATE(13016),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11014),
    [sym__array] = STATE(11014),
    [sym_comprehension_expression] = STATE(11014),
    [sym_matrix_expression] = STATE(11014),
    [sym_vector_expression] = STATE(11014),
    [sym_parenthesized_expression] = STATE(11014),
    [sym_tuple_expression] = STATE(11014),
    [sym_curly_expression] = STATE(11014),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11014),
    [sym_index_expression] = STATE(11014),
    [sym_parametrized_type_expression] = STATE(11014),
    [sym_call_expression] = STATE(11014),
    [sym_broadcast_call_expression] = STATE(11014),
    [sym__closed_macrocall_expression] = STATE(11014),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11014),
    [sym_quote_expression] = STATE(11014),
    [sym_binary_expression] = STATE(12958),
    [sym_unary_expression] = STATE(12958),
    [sym_range_expression] = STATE(12958),
    [sym_splat_expression] = STATE(12958),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(12958),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12958),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11014),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11014),
    [sym_string_literal] = STATE(11014),
    [sym_command_literal] = STATE(11014),
    [sym_prefixed_string_literal] = STATE(11014),
    [sym_prefixed_command_literal] = STATE(11014),
    [sym_operator] = STATE(12771),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6788),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(6788),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(6484),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1090] = {
    [sym__block] = STATE(19720),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7254),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1091] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7256),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1092] = {
    [sym__block] = STATE(19486),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7258),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1093] = {
    [sym__block] = STATE(19754),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7260),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1094] = {
    [sym__closed_assignment] = STATE(14989),
    [sym__expression] = STATE(12204),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17858),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3538),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3540),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1095] = {
    [sym__block] = STATE(18807),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7262),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1096] = {
    [sym__block] = STATE(18754),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7264),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1097] = {
    [sym__closed_assignment] = STATE(16129),
    [sym__expression] = STATE(12433),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7266),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7268),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7270),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1098] = {
    [sym__block] = STATE(19567),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4876),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1099] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(12060),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16765),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7272),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1100] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7274),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1101] = {
    [sym__block] = STATE(18216),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7276),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1102] = {
    [sym__closed_assignment] = STATE(14945),
    [sym__expression] = STATE(12080),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17842),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3512),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3514),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1103] = {
    [sym__closed_assignment] = STATE(15030),
    [sym__expression] = STATE(11967),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17918),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3644),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3646),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1104] = {
    [sym__block] = STATE(18645),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7278),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1105] = {
    [sym__closed_assignment] = STATE(16201),
    [sym__expression] = STATE(12436),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7280),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7282),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7284),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1106] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7286),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1107] = {
    [sym__block] = STATE(18775),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1108] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7288),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1109] = {
    [sym__block] = STATE(18423),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7290),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1110] = {
    [sym__block] = STATE(19015),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7292),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1111] = {
    [sym__closed_assignment] = STATE(15055),
    [sym__expression] = STATE(11933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17921),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3856),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1112] = {
    [sym__block] = STATE(18819),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7294),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1113] = {
    [sym__block] = STATE(18833),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7296),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1114] = {
    [sym__closed_assignment] = STATE(16303),
    [sym__expression] = STATE(12439),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7298),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7300),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7302),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1115] = {
    [sym__block] = STATE(18849),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7304),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1116] = {
    [sym__block] = STATE(18878),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7306),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1117] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7308),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1118] = {
    [sym__block] = STATE(18687),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7310),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1119] = {
    [sym__block] = STATE(19020),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7312),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1120] = {
    [sym__closed_assignment] = STATE(15084),
    [sym__expression] = STATE(11875),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17923),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1121] = {
    [sym__block] = STATE(19052),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4754),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1122] = {
    [sym__block] = STATE(19371),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7314),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1123] = {
    [sym__closed_assignment] = STATE(16396),
    [sym__expression] = STATE(12443),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7316),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7318),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7320),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1124] = {
    [sym__block] = STATE(19077),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7322),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1125] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7324),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1126] = {
    [sym__block] = STATE(18994),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7326),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1127] = {
    [sym__block] = STATE(19815),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4894),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1128] = {
    [sym__closed_assignment] = STATE(15121),
    [sym__expression] = STATE(12047),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17925),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3654),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3656),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1129] = {
    [sym__closed_assignment] = STATE(16040),
    [sym__expression] = STATE(12667),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7328),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7332),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1130] = {
    [sym__block] = STATE(19251),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5762),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1131] = {
    [sym__closed_assignment] = STATE(16535),
    [sym__expression] = STATE(12446),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7334),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7336),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7338),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1132] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(15325),
    [sym__expression] = STATE(13016),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11014),
    [sym__array] = STATE(11014),
    [sym_comprehension_expression] = STATE(11014),
    [sym_matrix_expression] = STATE(11014),
    [sym_vector_expression] = STATE(11014),
    [sym_parenthesized_expression] = STATE(11014),
    [sym_tuple_expression] = STATE(11014),
    [sym_curly_expression] = STATE(11014),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11014),
    [sym_index_expression] = STATE(11014),
    [sym_parametrized_type_expression] = STATE(11014),
    [sym_call_expression] = STATE(11014),
    [sym_broadcast_call_expression] = STATE(11014),
    [sym__closed_macrocall_expression] = STATE(11014),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11014),
    [sym_quote_expression] = STATE(11014),
    [sym_binary_expression] = STATE(12958),
    [sym_unary_expression] = STATE(12958),
    [sym_range_expression] = STATE(12958),
    [sym_splat_expression] = STATE(12958),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(12958),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12958),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11014),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11014),
    [sym_string_literal] = STATE(11014),
    [sym_command_literal] = STATE(11014),
    [sym_prefixed_string_literal] = STATE(11014),
    [sym_prefixed_command_literal] = STATE(11014),
    [sym_operator] = STATE(12771),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6940),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(6940),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(6484),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1133] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(12189),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17148),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7340),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1134] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7342),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1135] = {
    [sym__block] = STATE(19477),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7344),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1136] = {
    [sym__block] = STATE(19263),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7346),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1137] = {
    [sym__closed_assignment] = STATE(15142),
    [sym__expression] = STATE(12093),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17883),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3564),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3566),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1138] = {
    [sym__block] = STATE(19265),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7348),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1139] = {
    [sym__block] = STATE(19267),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7350),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1140] = {
    [sym__closed_assignment] = STATE(16592),
    [sym__expression] = STATE(12451),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7352),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7354),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7356),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1141] = {
    [sym__block] = STATE(19287),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7358),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1142] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7360),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1143] = {
    [sym__block] = STATE(19687),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7362),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1144] = {
    [sym__closed_assignment] = STATE(14574),
    [sym__expression] = STATE(11929),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17828),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7364),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7366),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1145] = {
    [sym__closed_assignment] = STATE(14548),
    [sym__expression] = STATE(12172),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17928),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3664),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3666),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1146] = {
    [sym__block] = STATE(18301),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7368),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1147] = {
    [sym__closed_assignment] = STATE(16651),
    [sym__expression] = STATE(12455),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7370),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7372),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7374),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1148] = {
    [sym__block] = STATE(19340),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7376),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1149] = {
    [sym__block] = STATE(19365),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7378),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1150] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7380),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1151] = {
    [sym__block] = STATE(18396),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7382),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1152] = {
    [sym__block] = STATE(19372),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5846),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1153] = {
    [sym__closed_assignment] = STATE(15141),
    [sym__expression] = STATE(11926),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17888),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3574),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1154] = {
    [sym__block] = STATE(18450),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7384),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1155] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7386),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1156] = {
    [sym__closed_assignment] = STATE(16203),
    [sym__expression] = STATE(12458),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7388),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7390),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7392),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1157] = {
    [sym__block] = STATE(19468),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7394),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1158] = {
    [sym__block] = STATE(19508),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5864),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1159] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7396),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1160] = {
    [sym__block] = STATE(18649),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7398),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1161] = {
    [sym__block] = STATE(19875),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5462),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1162] = {
    [sym__closed_assignment] = STATE(14801),
    [sym__expression] = STATE(11927),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17935),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3694),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3696),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1163] = {
    [sym__block] = STATE(19512),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7400),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1164] = {
    [sym__block] = STATE(19517),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7402),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1165] = {
    [sym__closed_assignment] = STATE(15873),
    [sym__expression] = STATE(12463),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7404),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7406),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7408),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1166] = {
    [sym__block] = STATE(18267),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7410),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1167] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7412),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1168] = {
    [sym__block] = STATE(19118),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7414),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1169] = {
    [sym__block] = STATE(18284),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7416),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1170] = {
    [sym__closed_assignment] = STATE(14963),
    [sym__expression] = STATE(12129),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17937),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3704),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1171] = {
    [sym__block] = STATE(18285),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7418),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1172] = {
    [sym__block] = STATE(18403),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7420),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1173] = {
    [sym__closed_assignment] = STATE(16574),
    [sym__expression] = STATE(12468),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7422),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7424),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7426),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1174] = {
    [sym__block] = STATE(19869),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7428),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1175] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7430),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1176] = {
    [sym__block] = STATE(18845),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7432),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1177] = {
    [sym__closed_assignment] = STATE(15010),
    [sym__expression] = STATE(12038),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17939),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3916),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3918),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1178] = {
    [sym__block] = STATE(18693),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4628),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1179] = {
    [sym__block] = STATE(19400),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7434),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1180] = {
    [sym__closed_assignment] = STATE(15682),
    [sym__expression] = STATE(12474),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7436),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7438),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7440),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1181] = {
    [sym__block] = STATE(18738),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7442),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1182] = {
    [sym__block] = STATE(18165),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7444),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1183] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7446),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1184] = {
    [sym__block] = STATE(19573),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7448),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1185] = {
    [sym__block] = STATE(18166),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7450),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1186] = {
    [sym__closed_assignment] = STATE(15082),
    [sym__expression] = STATE(12042),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17941),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3816),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1187] = {
    [sym__block] = STATE(17118),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6194),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1188] = {
    [sym__closed_assignment] = STATE(16077),
    [sym__expression] = STATE(12479),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7452),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7454),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7456),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1189] = {
    [sym__closed_assignment] = STATE(15593),
    [sym__expression] = STATE(12511),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7458),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7460),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7462),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1190] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(11939),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17211),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7464),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1191] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7466),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1192] = {
    [sym__block] = STATE(18221),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7468),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1193] = {
    [sym__closed_assignment] = STATE(15006),
    [sym__expression] = STATE(12035),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17719),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3462),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3464),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1194] = {
    [sym__closed_assignment] = STATE(15124),
    [sym__expression] = STATE(12243),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17942),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3714),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3716),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1195] = {
    [sym__block] = STATE(19018),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7470),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1196] = {
    [sym__block] = STATE(18237),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7472),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1197] = {
    [sym__closed_assignment] = STATE(16288),
    [sym__expression] = STATE(12489),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7474),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7476),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7478),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1198] = {
    [sym__block] = STATE(19278),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5642),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1199] = {
    [sym__block] = STATE(18244),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6128),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1200] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7480),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1201] = {
    [sym__block] = STATE(18946),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7482),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1202] = {
    [sym__block] = STATE(19051),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4906),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1203] = {
    [sym__closed_assignment] = STATE(14560),
    [sym__expression] = STATE(11906),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17944),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3958),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1204] = {
    [sym__block] = STATE(18246),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7484),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1205] = {
    [sym__block] = STATE(18247),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7486),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1206] = {
    [sym__closed_assignment] = STATE(16552),
    [sym__expression] = STATE(12500),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7488),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7490),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7492),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1207] = {
    [sym__block] = STATE(18248),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7494),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1208] = {
    [sym__block] = STATE(18250),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7496),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1209] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7498),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1210] = {
    [sym__block] = STATE(19646),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7500),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1211] = {
    [sym__closed_assignment] = STATE(15050),
    [sym__expression] = STATE(12009),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(18071),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3502),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1212] = {
    [sym__closed_assignment] = STATE(14576),
    [sym__expression] = STATE(12220),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17946),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3836),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1213] = {
    [sym__block] = STATE(18260),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4514),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1214] = {
    [sym__block] = STATE(19511),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7502),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1215] = {
    [sym__closed_assignment] = STATE(15514),
    [sym__expression] = STATE(12506),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7504),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7506),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7508),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1216] = {
    [sym__block] = STATE(18265),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7510),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1217] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7512),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1218] = {
    [sym__block] = STATE(18323),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7514),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1219] = {
    [sym__block] = STATE(19516),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7516),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1220] = {
    [sym__closed_assignment] = STATE(14585),
    [sym__expression] = STATE(12026),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17947),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3734),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1221] = {
    [sym__closed_assignment] = STATE(16162),
    [sym__expression] = STATE(12696),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7518),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7520),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7522),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1222] = {
    [sym__block] = STATE(18298),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6176),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1223] = {
    [sym__closed_assignment] = STATE(15579),
    [sym__expression] = STATE(12509),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7524),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7526),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7528),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1224] = {
    [sym__block] = STATE(19537),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7530),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1225] = {
    [sym__block] = STATE(19767),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7532),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1226] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7534),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1227] = {
    [sym__block] = STATE(19048),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7536),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1228] = {
    [sym__block] = STATE(18307),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7538),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1229] = {
    [sym__closed_assignment] = STATE(14598),
    [sym__expression] = STATE(11977),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17949),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3966),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3968),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1230] = {
    [sym__block] = STATE(18308),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7540),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1231] = {
    [sym__block] = STATE(18309),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7542),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1232] = {
    [sym__closed_assignment] = STATE(15651),
    [sym__expression] = STATE(12513),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7544),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7546),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7548),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1233] = {
    [sym__block] = STATE(18318),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7550),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1234] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7552),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1235] = {
    [sym__block] = STATE(18227),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7554),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1236] = {
    [sym__closed_assignment] = STATE(14607),
    [sym__expression] = STATE(11935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17952),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3848),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1237] = {
    [sym__closed_assignment] = STATE(15722),
    [sym__expression] = STATE(12519),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7556),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7558),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7560),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1238] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(15380),
    [sym__expression] = STATE(12976),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(6788),
    [anon_sym_finally] = ACTIONS(6788),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1239] = {
    [sym__block] = STATE(18342),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7562),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1240] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7564),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1241] = {
    [sym__block] = STATE(18579),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7566),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1242] = {
    [sym__block] = STATE(18343),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6196),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1243] = {
    [sym__closed_assignment] = STATE(14619),
    [sym__expression] = STATE(12021),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17953),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3754),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1244] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7568),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1245] = {
    [sym__closed_assignment] = STATE(15792),
    [sym__expression] = STATE(12530),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7570),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7572),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7574),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1246] = {
    [sym__block] = STATE(18349),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7576),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1247] = {
    [sym__block] = STATE(18366),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6202),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1248] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7578),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1249] = {
    [sym__block] = STATE(18907),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7580),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1250] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7582),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1251] = {
    [sym__closed_assignment] = STATE(14635),
    [sym__expression] = STATE(12150),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17954),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3866),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1252] = {
    [sym__block] = STATE(18368),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7584),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1253] = {
    [sym__block] = STATE(18369),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7586),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1254] = {
    [sym__closed_assignment] = STATE(16056),
    [sym__expression] = STATE(12542),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7588),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7590),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7592),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1255] = {
    [sym__block] = STATE(18274),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7594),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1256] = {
    [sym__block] = STATE(18282),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5780),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1257] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7596),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1258] = {
    [sym__block] = STATE(19219),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7598),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1259] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(15380),
    [sym__expression] = STATE(12976),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(6940),
    [anon_sym_finally] = ACTIONS(6940),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1260] = {
    [sym__closed_assignment] = STATE(14650),
    [sym__expression] = STATE(12000),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17956),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3774),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1261] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7600),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1262] = {
    [sym__block] = STATE(18385),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7602),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1263] = {
    [sym__closed_assignment] = STATE(16118),
    [sym__expression] = STATE(12551),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7604),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7606),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1264] = {
    [sym__block] = STATE(18493),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7610),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1265] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7612),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1266] = {
    [sym__block] = STATE(19637),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7614),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1267] = {
    [sym__block] = STATE(18400),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5828),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1268] = {
    [sym__closed_assignment] = STATE(14662),
    [sym__expression] = STATE(11930),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17931),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3674),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1269] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(17192),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(7616),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(465),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(469),
    [aux_sym_integer_literal_token2] = ACTIONS(469),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(473),
    [aux_sym_float_literal_token3] = ACTIONS(473),
    [aux_sym_float_literal_token4] = ACTIONS(473),
    [sym_character_literal] = ACTIONS(4806),
    [sym__pair_operator] = ACTIONS(477),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(477),
    [sym__pipe_left_operator] = ACTIONS(477),
    [sym__ellipsis_operator] = ACTIONS(477),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(477),
    [sym__bitshift_operator] = ACTIONS(477),
    [sym__power_operator] = ACTIONS(477),
    [sym__tilde_operator] = ACTIONS(3364),
    [sym__type_order_operator] = ACTIONS(3364),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1270] = {
    [sym__block] = STATE(18409),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7618),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1271] = {
    [sym__closed_assignment] = STATE(16183),
    [sym__expression] = STATE(12563),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7620),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7622),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7624),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1272] = {
    [sym__block] = STATE(18418),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7626),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1273] = {
    [sym__block] = STATE(18519),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7628),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1274] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7630),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1275] = {
    [sym__block] = STATE(18548),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7632),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1276] = {
    [sym__block] = STATE(18520),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7634),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1277] = {
    [sym__closed_assignment] = STATE(14673),
    [sym__expression] = STATE(12013),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17958),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3784),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1278] = {
    [sym__block] = STATE(19496),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7636),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1279] = {
    [sym__block] = STATE(19549),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4956),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1280] = {
    [sym__block] = STATE(18838),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4706),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1281] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(11918),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17179),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7638),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1282] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7640),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1283] = {
    [sym__closed_assignment] = STATE(15061),
    [sym__expression] = STATE(11972),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17872),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3554),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1284] = {
    [sym__closed_assignment] = STATE(14684),
    [sym__expression] = STATE(12105),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17934),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3684),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3686),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1285] = {
    [sym__block] = STATE(19648),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7642),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1286] = {
    [sym__block] = STATE(18607),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7644),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1287] = {
    [sym__block] = STATE(18621),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6262),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1288] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1289] = {
    [sym__block] = STATE(19405),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7648),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1290] = {
    [sym__closed_assignment] = STATE(14699),
    [sym__expression] = STATE(11915),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17960),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3794),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3796),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1291] = {
    [sym__block] = STATE(18623),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7650),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1292] = {
    [sym__block] = STATE(18624),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7652),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1293] = {
    [sym__block] = STATE(18625),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7654),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1294] = {
    [sym__block] = STATE(18632),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7656),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1295] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7658),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1296] = {
    [sym__closed_assignment] = STATE(14711),
    [sym__expression] = STATE(12036),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17962),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4006),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4008),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1297] = {
    [sym__block] = STATE(18665),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4580),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1298] = {
    [sym__block] = STATE(18362),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7660),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1299] = {
    [sym__block] = STATE(18667),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7662),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1300] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7664),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1301] = {
    [sym__closed_assignment] = STATE(14721),
    [sym__expression] = STATE(12022),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17964),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3906),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1302] = {
    [sym__closed_assignment] = STATE(16317),
    [sym__expression] = STATE(12760),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7666),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7668),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7670),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1303] = {
    [sym__block] = STATE(18707),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6280),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1304] = {
    [sym__block] = STATE(18480),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7672),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1305] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7674),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1306] = {
    [sym__block] = STATE(18712),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7676),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1307] = {
    [sym__closed_assignment] = STATE(14731),
    [sym__expression] = STATE(11979),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17965),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3806),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3808),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1308] = {
    [sym__block] = STATE(18713),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7678),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1309] = {
    [sym__block] = STATE(18714),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7680),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1310] = {
    [sym__block] = STATE(18729),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7682),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1311] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7684),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1312] = {
    [sym__block] = STATE(18463),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7686),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1313] = {
    [sym__closed_assignment] = STATE(14739),
    [sym__expression] = STATE(11899),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17969),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3438),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1314] = {
    [sym__block] = STATE(18883),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7688),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1315] = {
    [sym__block] = STATE(18773),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7690),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1316] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7692),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1317] = {
    [sym__block] = STATE(18774),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4810),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1318] = {
    [sym__closed_assignment] = STATE(14749),
    [sym__expression] = STATE(12059),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17971),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3976),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3978),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1319] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7694),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1320] = {
    [sym__block] = STATE(18781),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7696),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1321] = {
    [sym__block] = STATE(18784),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4816),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1322] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7698),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1323] = {
    [sym__block] = STATE(18598),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7700),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1324] = {
    [sym__closed_assignment] = STATE(14759),
    [sym__expression] = STATE(11863),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17972),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3876),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3878),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1325] = {
    [sym__block] = STATE(18789),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7702),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1326] = {
    [sym__block] = STATE(18793),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7704),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1327] = {
    [sym__block] = STATE(18605),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7706),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1328] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7708),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1329] = {
    [sym__block] = STATE(19407),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7710),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1330] = {
    [sym__closed_assignment] = STATE(14771),
    [sym__expression] = STATE(11969),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17974),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1331] = {
    [sym__block] = STATE(18952),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7712),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1332] = {
    [sym__closed_assignment] = STATE(15674),
    [sym__expression] = STATE(12477),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7714),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7716),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7718),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1333] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(11921),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16767),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7720),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1334] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7722),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1335] = {
    [sym__closed_assignment] = STATE(15093),
    [sym__expression] = STATE(11999),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17821),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7724),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7726),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1336] = {
    [sym__closed_assignment] = STATE(14782),
    [sym__expression] = STATE(12100),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17975),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3986),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3988),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1337] = {
    [sym__block] = STATE(18350),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7728),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1338] = {
    [sym__block] = STATE(18983),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7730),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1339] = {
    [sym__block] = STATE(18989),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7732),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1340] = {
    [sym__block] = STATE(19306),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7734),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1341] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7736),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1342] = {
    [sym__block] = STATE(19261),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5078),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1343] = {
    [sym__closed_assignment] = STATE(14794),
    [sym__expression] = STATE(12147),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17977),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3886),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1344] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(11869),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17076),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7738),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1345] = {
    [sym__closed_assignment] = STATE(15108),
    [sym__expression] = STATE(11922),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17752),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7740),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7742),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1346] = {
    [sym__block] = STATE(19414),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6056),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1347] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1348] = {
    [sym__block] = STATE(19139),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7746),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1349] = {
    [sym__closed_assignment] = STATE(14806),
    [sym__expression] = STATE(11908),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17961),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4116),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4118),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1350] = {
    [sym__block] = STATE(19104),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7748),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1351] = {
    [sym__block] = STATE(19166),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4870),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1352] = {
    [sym__block] = STATE(19814),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6038),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1353] = {
    [sym__block] = STATE(19174),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7750),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1354] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7752),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1355] = {
    [sym__block] = STATE(19179),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7754),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1356] = {
    [sym__closed_assignment] = STATE(14817),
    [sym__expression] = STATE(12023),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17979),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3896),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3898),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1357] = {
    [sym__block] = STATE(19182),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7756),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1358] = {
    [sym__block] = STATE(19190),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7758),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1359] = {
    [sym__block] = STATE(19424),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7760),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1360] = {
    [sym__block] = STATE(19226),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4658),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1361] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7762),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1362] = {
    [sym__block] = STATE(19426),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7764),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1363] = {
    [sym__closed_assignment] = STATE(14827),
    [sym__expression] = STATE(12205),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17967),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3826),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1364] = {
    [sym__block] = STATE(19233),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7766),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1365] = {
    [sym__block] = STATE(19435),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7768),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1366] = {
    [sym__closed_assignment] = STATE(16509),
    [sym__expression] = STATE(12802),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7770),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7772),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7774),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1367] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7776),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1368] = {
    [sym__block] = STATE(19302),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4888),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1369] = {
    [sym__closed_assignment] = STATE(14836),
    [sym__expression] = STATE(11894),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17981),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3926),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1370] = {
    [sym__block] = STATE(19852),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7778),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1371] = {
    [sym__block] = STATE(19861),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7780),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1372] = {
    [sym__block] = STATE(19314),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7782),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1373] = {
    [sym__block] = STATE(19317),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7784),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1374] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7786),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1375] = {
    [sym__block] = STATE(19320),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7788),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1376] = {
    [sym__closed_assignment] = STATE(14845),
    [sym__expression] = STATE(11947),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17985),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4078),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1377] = {
    [sym__block] = STATE(19338),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7790),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1378] = {
    [sym__block] = STATE(19441),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7792),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1379] = {
    [sym__block] = STATE(18604),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7794),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1380] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7796),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1381] = {
    [sym__closed_assignment] = STATE(14854),
    [sym__expression] = STATE(12041),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17986),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4046),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4048),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1382] = {
    [sym__block] = STATE(19474),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4496),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1383] = {
    [sym__block] = STATE(19412),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7798),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1384] = {
    [sym__block] = STATE(19413),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4912),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1385] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(12170),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16752),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7800),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1386] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7802),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1387] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7804),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1388] = {
    [sym__closed_assignment] = STATE(14863),
    [sym__expression] = STATE(12148),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17988),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3996),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1389] = {
    [sym__block] = STATE(19428),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7806),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1390] = {
    [sym__block] = STATE(19430),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4918),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1391] = {
    [sym__closed_assignment] = STATE(14694),
    [sym__expression] = STATE(11934),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17520),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3522),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1392] = {
    [sym__block] = STATE(19432),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7808),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1393] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7810),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1394] = {
    [sym__block] = STATE(19434),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7812),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1395] = {
    [sym__closed_assignment] = STATE(14871),
    [sym__expression] = STATE(11862),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17989),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4056),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1396] = {
    [sym__block] = STATE(18616),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7814),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1397] = {
    [sym__block] = STATE(18852),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7816),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1398] = {
    [sym__block] = STATE(19481),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7818),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1399] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7820),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1400] = {
    [sym__block] = STATE(19522),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7822),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1401] = {
    [sym__closed_assignment] = STATE(14879),
    [sym__expression] = STATE(11937),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17991),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4016),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1402] = {
    [sym__block] = STATE(18911),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4950),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1403] = {
    [sym__block] = STATE(18922),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7824),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1404] = {
    [sym__block] = STATE(18944),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7826),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1405] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7828),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1406] = {
    [sym__block] = STATE(19541),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7830),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1407] = {
    [sym__closed_assignment] = STATE(14888),
    [sym__expression] = STATE(11968),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17983),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3936),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1408] = {
    [sym__block] = STATE(19542),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7832),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1409] = {
    [sym__block] = STATE(18956),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7834),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1410] = {
    [sym__block] = STATE(18995),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7836),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1411] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7838),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1412] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(12094),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16821),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7840),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1413] = {
    [sym__closed_assignment] = STATE(14897),
    [sym__expression] = STATE(11995),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17992),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4026),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1414] = {
    [sym__closed_assignment] = STATE(15154),
    [sym__expression] = STATE(12046),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17772),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3452),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3454),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1415] = {
    [sym__block] = STATE(19069),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4604),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1416] = {
    [sym__block] = STATE(19694),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7842),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1417] = {
    [sym__closed_assignment] = STATE(16587),
    [sym__expression] = STATE(12450),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7844),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7846),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7848),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1418] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1419] = {
    [sym__block] = STATE(19714),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4974),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1420] = {
    [sym__closed_assignment] = STATE(14909),
    [sym__expression] = STATE(12043),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17993),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1421] = {
    [sym__block] = STATE(19084),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7852),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1422] = {
    [sym__block] = STATE(19722),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7854),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1423] = {
    [sym__block] = STATE(19723),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7856),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1424] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7858),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1425] = {
    [sym__block] = STATE(19725),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7860),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1426] = {
    [sym__closed_assignment] = STATE(14920),
    [sym__expression] = STATE(12085),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17995),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4096),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4098),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1427] = {
    [sym__block] = STATE(19729),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7862),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1428] = {
    [sym__block] = STATE(19811),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4640),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1429] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7864),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1430] = {
    [sym__block] = STATE(18591),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7866),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1431] = {
    [sym__block] = STATE(19813),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7868),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1432] = {
    [sym__closed_assignment] = STATE(14932),
    [sym__expression] = STATE(12126),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17997),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4088),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1433] = {
    [sym__closed_assignment] = STATE(16560),
    [sym__expression] = STATE(12574),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7870),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7872),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7874),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1434] = {
    [sym__closed_assignment] = STATE(16649),
    [sym__expression] = STATE(12901),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7876),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(7880),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1435] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7882),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1436] = {
    [sym__block] = STATE(18678),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5012),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1437] = {
    [sym__closed_assignment] = STATE(14943),
    [sym__expression] = STATE(11942),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11252),
    [sym__array] = STATE(11252),
    [sym_comprehension_expression] = STATE(11252),
    [sym_matrix_expression] = STATE(11252),
    [sym_vector_expression] = STATE(11252),
    [sym_parenthesized_expression] = STATE(11252),
    [sym_tuple_expression] = STATE(11252),
    [sym_curly_expression] = STATE(11252),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11252),
    [sym_index_expression] = STATE(11252),
    [sym_parametrized_type_expression] = STATE(11252),
    [sym_call_expression] = STATE(11252),
    [sym_broadcast_call_expression] = STATE(11252),
    [sym__closed_macrocall_expression] = STATE(11252),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17999),
    [sym_interpolation_expression] = STATE(11252),
    [sym_quote_expression] = STATE(11252),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13172),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11252),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11252),
    [sym_string_literal] = STATE(11252),
    [sym_command_literal] = STATE(11252),
    [sym_prefixed_string_literal] = STATE(11252),
    [sym_prefixed_command_literal] = STATE(11252),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(4066),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1438] = {
    [sym__block] = STATE(19653),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6182),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1439] = {
    [sym__block] = STATE(19373),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4980),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1440] = {
    [sym__block] = STATE(18801),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7884),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1441] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7886),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1442] = {
    [sym__block] = STATE(18826),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1443] = {
    [sym__block] = STATE(18884),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7890),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1444] = {
    [sym__block] = STATE(19605),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7892),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1445] = {
    [sym__block] = STATE(19452),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7894),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1446] = {
    [sym__closed_assignment] = STATE(16550),
    [sym__expression] = STATE(12110),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(17189),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7896),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1447] = {
    [sym__block] = STATE(19519),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7900),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1448] = {
    [sym__block] = STATE(19082),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7902),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1449] = {
    [sym__block] = STATE(18930),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5030),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1450] = {
    [sym__block] = STATE(19546),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7904),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1451] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7906),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1452] = {
    [sym__block] = STATE(18531),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7908),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1453] = {
    [sym__block] = STATE(18692),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5036),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1454] = {
    [sym__block] = STATE(19547),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7910),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1455] = {
    [sym__block] = STATE(19677),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7912),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1456] = {
    [sym__block] = STATE(18921),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7914),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1457] = {
    [sym__block] = STATE(19622),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7916),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1458] = {
    [sym__block] = STATE(19684),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7918),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1459] = {
    [sym__block] = STATE(19072),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7920),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1460] = {
    [sym__block] = STATE(19690),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7922),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1461] = {
    [sym__block] = STATE(19693),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7924),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1462] = {
    [sym__block] = STATE(18155),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7926),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1463] = {
    [sym__block] = STATE(18835),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7928),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1464] = {
    [sym__block] = STATE(18837),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7930),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1465] = {
    [sym__block] = STATE(18160),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5066),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1466] = {
    [sym__block] = STATE(19731),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7932),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1467] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(7934),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1468] = {
    [sym__closed_assignment] = STATE(15673),
    [sym__expression] = STATE(11887),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16694),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7936),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1469] = {
    [sym__block] = STATE(18857),
    [sym_assignment] = STATE(15671),
    [sym_open_tuple] = STATE(15304),
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(7938),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1470] = {
    [sym__closed_assignment] = STATE(16789),
    [sym__expression] = STATE(13974),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7940),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(7942),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1471] = {
    [sym__closed_assignment] = STATE(17296),
    [sym__expression] = STATE(13899),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7946),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(7948),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1472] = {
    [sym__closed_assignment] = STATE(16153),
    [sym__expression] = STATE(12543),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7950),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7952),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1473] = {
    [sym__closed_assignment] = STATE(15665),
    [sym__expression] = STATE(12382),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7954),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1474] = {
    [sym__closed_assignment] = STATE(17187),
    [sym__expression] = STATE(13827),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7958),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1475] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7962),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1476] = {
    [sym__closed_assignment] = STATE(16793),
    [sym__expression] = STATE(13765),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7964),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(7966),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1477] = {
    [sym__closed_assignment] = STATE(16613),
    [sym__expression] = STATE(12338),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7968),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7970),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1478] = {
    [sym__closed_assignment] = STATE(16460),
    [sym__expression] = STATE(12483),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7972),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7974),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1479] = {
    [sym__closed_assignment] = STATE(16782),
    [sym__expression] = STATE(13904),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7976),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(7978),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1480] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7980),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1481] = {
    [sym__closed_assignment] = STATE(16237),
    [sym__expression] = STATE(12434),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7982),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7984),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1482] = {
    [sym__closed_assignment] = STATE(17235),
    [sym__expression] = STATE(13742),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7986),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(7988),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1483] = {
    [sym__closed_assignment] = STATE(17227),
    [sym__expression] = STATE(13860),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7990),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(7992),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1484] = {
    [sym__closed_assignment] = STATE(16224),
    [sym__expression] = STATE(12556),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7994),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(7996),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1485] = {
    [sym__closed_assignment] = STATE(16931),
    [sym__expression] = STATE(13644),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(7998),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8000),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1486] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8002),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1487] = {
    [sym__closed_assignment] = STATE(16954),
    [sym__expression] = STATE(13911),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8004),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8006),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1488] = {
    [sym__closed_assignment] = STATE(16342),
    [sym__expression] = STATE(12452),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8008),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8010),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1489] = {
    [sym__closed_assignment] = STATE(16953),
    [sym__expression] = STATE(13784),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8012),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8014),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1490] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8016),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1491] = {
    [sym__closed_assignment] = STATE(16897),
    [sym__expression] = STATE(13608),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8018),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8020),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1492] = {
    [sym__closed_assignment] = STATE(15515),
    [sym__expression] = STATE(12319),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8022),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8024),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1493] = {
    [sym__closed_assignment] = STATE(17086),
    [sym__expression] = STATE(13723),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8026),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8028),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1494] = {
    [sym__closed_assignment] = STATE(17277),
    [sym__expression] = STATE(13863),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8030),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8032),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1495] = {
    [sym__closed_assignment] = STATE(17217),
    [sym__expression] = STATE(13603),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8034),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8036),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1496] = {
    [sym__closed_assignment] = STATE(15473),
    [sym__expression] = STATE(12491),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8038),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8040),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1497] = {
    [sym__closed_assignment] = STATE(17229),
    [sym__expression] = STATE(13897),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8042),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8044),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1498] = {
    [sym__closed_assignment] = STATE(16318),
    [sym__expression] = STATE(12564),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8046),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8048),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1499] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(16202),
    [sym__expression] = STATE(13183),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6940),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1500] = {
    [sym__closed_assignment] = STATE(16263),
    [sym__expression] = STATE(12668),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8050),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8052),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1501] = {
    [sym__closed_assignment] = STATE(16872),
    [sym__expression] = STATE(13654),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8054),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8056),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1502] = {
    [sym__closed_assignment] = STATE(17220),
    [sym__expression] = STATE(13802),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8058),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8060),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1503] = {
    [sym__closed_assignment] = STATE(17322),
    [sym__expression] = STATE(13917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8062),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8064),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1504] = {
    [sym__closed_assignment] = STATE(16063),
    [sym__expression] = STATE(12366),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8066),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8068),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1505] = {
    [sym__closed_assignment] = STATE(16316),
    [sym__expression] = STATE(12454),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8070),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1506] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8074),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1507] = {
    [sym__closed_assignment] = STATE(17311),
    [sym__expression] = STATE(13746),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8076),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8078),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1508] = {
    [sym__closed_assignment] = STATE(15662),
    [sym__expression] = STATE(12456),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8080),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8082),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1509] = {
    [sym__closed_assignment] = STATE(15886),
    [sym__expression] = STATE(12401),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8084),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1510] = {
    [sym__closed_assignment] = STATE(15491),
    [sym__expression] = STATE(12806),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8088),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8090),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1511] = {
    [sym__closed_assignment] = STATE(16741),
    [sym__expression] = STATE(13921),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8092),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8094),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1512] = {
    [sym__closed_assignment] = STATE(16345),
    [sym__expression] = STATE(12437),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8096),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8098),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1513] = {
    [sym__closed_assignment] = STATE(15543),
    [sym__expression] = STATE(12501),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8100),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8102),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1514] = {
    [sym__closed_assignment] = STATE(16707),
    [sym__expression] = STATE(13814),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8104),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8106),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1515] = {
    [sym__closed_assignment] = STATE(16131),
    [sym__expression] = STATE(12607),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8108),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8110),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1516] = {
    [sym__closed_assignment] = STATE(16919),
    [sym__expression] = STATE(13893),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8112),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8114),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1517] = {
    [sym__closed_assignment] = STATE(16866),
    [sym__expression] = STATE(13629),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8116),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8118),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1518] = {
    [sym__closed_assignment] = STATE(886),
    [sym__expression] = STATE(9246),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_matrix_row] = STATE(16666),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [aux_sym_matrix_row_repeat1] = STATE(886),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1519] = {
    [sym__closed_assignment] = STATE(16850),
    [sym__expression] = STATE(13925),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8120),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8122),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1520] = {
    [sym__closed_assignment] = STATE(17294),
    [sym__expression] = STATE(13663),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8124),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8126),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1521] = {
    [sym__closed_assignment] = STATE(16952),
    [sym__expression] = STATE(13852),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8128),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8130),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1522] = {
    [sym__closed_assignment] = STATE(17249),
    [sym__expression] = STATE(13737),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8132),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8134),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1523] = {
    [sym__closed_assignment] = STATE(16867),
    [sym__expression] = STATE(13823),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8136),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8138),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1524] = {
    [sym__closed_assignment] = STATE(17133),
    [sym__expression] = STATE(13969),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8140),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8142),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1525] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1526] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8146),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1527] = {
    [sym__closed_assignment] = STATE(16922),
    [sym__expression] = STATE(13928),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8150),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1528] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8152),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1529] = {
    [sym__closed_assignment] = STATE(15611),
    [sym__expression] = STATE(12507),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8154),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8156),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1530] = {
    [sym__closed_assignment] = STATE(16278),
    [sym__expression] = STATE(12459),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8158),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8160),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1531] = {
    [sym__closed_assignment] = STATE(15771),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10356),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8180),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1532] = {
    [sym__closed_assignment] = STATE(17172),
    [sym__expression] = STATE(13900),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8182),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8184),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1533] = {
    [sym__closed_assignment] = STATE(16978),
    [sym__expression] = STATE(13828),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8186),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8188),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1534] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8190),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1535] = {
    [sym__closed_assignment] = STATE(17061),
    [sym__expression] = STATE(13934),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8192),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8194),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1536] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8196),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1537] = {
    [sym__closed_assignment] = STATE(17299),
    [sym__expression] = STATE(13681),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8198),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8200),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1538] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8202),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1539] = {
    [sym__closed_assignment] = STATE(17330),
    [sym__expression] = STATE(13963),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8204),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8206),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1540] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8208),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1541] = {
    [sym__closed_assignment] = STATE(16800),
    [sym__expression] = STATE(13936),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8210),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8212),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1542] = {
    [sym__closed_assignment] = STATE(17183),
    [sym__expression] = STATE(13730),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8214),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8216),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1543] = {
    [sym__closed_assignment] = STATE(17167),
    [sym__expression] = STATE(13949),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8218),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8220),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1544] = {
    [sym__closed_assignment] = STATE(17152),
    [sym__expression] = STATE(13834),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8222),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8224),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1545] = {
    [sym__closed_assignment] = STATE(16505),
    [sym__expression] = STATE(12440),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8226),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8228),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1546] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1547] = {
    [sym__closed_assignment] = STATE(16097),
    [sym__expression] = STATE(12419),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8232),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8234),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1548] = {
    [sym__closed_assignment] = STATE(16980),
    [sym__expression] = STATE(13655),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8236),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8238),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1549] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8240),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1550] = {
    [sym__closed_assignment] = STATE(16188),
    [sym__expression] = STATE(12274),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8242),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8244),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1551] = {
    [sym__closed_assignment] = STATE(17242),
    [sym__expression] = STATE(13956),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8246),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8248),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1552] = {
    [sym__closed_assignment] = STATE(15691),
    [sym__expression] = STATE(12510),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8250),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8252),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1553] = {
    [sym__closed_assignment] = STATE(16331),
    [sym__expression] = STATE(12758),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8254),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8256),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1554] = {
    [sym__closed_assignment] = STATE(17222),
    [sym__expression] = STATE(13840),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8258),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8260),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1555] = {
    [sym__closed_assignment] = STATE(16749),
    [sym__expression] = STATE(13762),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8262),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8264),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1556] = {
    [sym__closed_assignment] = STATE(15559),
    [sym__expression] = STATE(12464),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8266),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8268),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1557] = {
    [sym__closed_assignment] = STATE(16893),
    [sym__expression] = STATE(13699),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8270),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8272),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1558] = {
    [sym__closed_assignment] = STATE(15472),
    [sym__expression] = STATE(12374),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8274),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8276),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1559] = {
    [sym__closed_assignment] = STATE(17302),
    [sym__expression] = STATE(13962),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8278),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8280),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1560] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8282),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1561] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8284),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1562] = {
    [sym__closed_assignment] = STATE(16831),
    [sym__expression] = STATE(13635),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8286),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8288),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1563] = {
    [sym__closed_assignment] = STATE(17287),
    [sym__expression] = STATE(13844),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8290),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1564] = {
    [sym__closed_assignment] = STATE(17032),
    [sym__expression] = STATE(13979),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8294),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8296),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1565] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8298),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1566] = {
    [sym__closed_assignment] = STATE(16682),
    [sym__expression] = STATE(13967),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8300),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8302),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1567] = {
    [sym__closed_assignment] = STATE(16572),
    [sym__expression] = STATE(12765),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8304),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8306),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1568] = {
    [sym__closed_assignment] = STATE(16761),
    [sym__expression] = STATE(13755),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8308),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8310),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1569] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8312),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1570] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8314),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1571] = {
    [sym__closed_assignment] = STATE(15760),
    [sym__expression] = STATE(12516),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8316),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8318),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1572] = {
    [sym__closed_assignment] = STATE(16533),
    [sym__expression] = STATE(12615),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8320),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8322),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1573] = {
    [sym__closed_assignment] = STATE(16733),
    [sym__expression] = STATE(13971),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8324),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8326),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1574] = {
    [sym__closed_assignment] = STATE(16882),
    [sym__expression] = STATE(13853),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8328),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8330),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1575] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8332),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1576] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8334),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1577] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(16287),
    [sym__expression] = STATE(13248),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11340),
    [sym__array] = STATE(11340),
    [sym_comprehension_expression] = STATE(11340),
    [sym_matrix_expression] = STATE(11340),
    [sym_vector_expression] = STATE(11340),
    [sym_parenthesized_expression] = STATE(11340),
    [sym_tuple_expression] = STATE(11340),
    [sym_curly_expression] = STATE(11340),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11340),
    [sym_index_expression] = STATE(11340),
    [sym_parametrized_type_expression] = STATE(11340),
    [sym_call_expression] = STATE(11340),
    [sym_broadcast_call_expression] = STATE(11340),
    [sym__closed_macrocall_expression] = STATE(11340),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11340),
    [sym_quote_expression] = STATE(11340),
    [sym_binary_expression] = STATE(13282),
    [sym_unary_expression] = STATE(13282),
    [sym_range_expression] = STATE(13282),
    [sym_splat_expression] = STATE(13282),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12936),
    [sym_unary_typed_expression] = STATE(13282),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13282),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11340),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11340),
    [sym_string_literal] = STATE(11340),
    [sym_command_literal] = STATE(11340),
    [sym_prefixed_string_literal] = STATE(11340),
    [sym_prefixed_command_literal] = STATE(11340),
    [sym_operator] = STATE(13018),
    [ts_builtin_sym_end] = ACTIONS(8336),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(75),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1578] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8338),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1579] = {
    [sym__closed_assignment] = STATE(16753),
    [sym__expression] = STATE(13705),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8340),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8342),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1580] = {
    [sym__closed_assignment] = STATE(16564),
    [sym__expression] = STATE(12444),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8344),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8346),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1581] = {
    [sym__closed_assignment] = STATE(16951),
    [sym__expression] = STATE(13918),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8348),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8350),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1582] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1583] = {
    [sym__closed_assignment] = STATE(16458),
    [sym__expression] = STATE(12709),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8354),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8356),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1584] = {
    [sym__closed_assignment] = STATE(16873),
    [sym__expression] = STATE(13864),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8358),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8360),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1585] = {
    [sym__closed_assignment] = STATE(16875),
    [sym__expression] = STATE(13647),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8362),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8364),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1586] = {
    [sym__closed_assignment] = STATE(17009),
    [sym__expression] = STATE(13645),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8366),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8368),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1587] = {
    [sym__closed_assignment] = STATE(16845),
    [sym__expression] = STATE(13977),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8370),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8372),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1588] = {
    [sym__closed_assignment] = STATE(16050),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10411),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8374),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8376),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1589] = {
    [sym__closed_assignment] = STATE(15808),
    [sym__expression] = STATE(12469),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8378),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8380),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1590] = {
    [sym__closed_assignment] = STATE(15827),
    [sym__expression] = STATE(12521),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8382),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8384),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1591] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1122),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1592] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(16202),
    [sym__expression] = STATE(13183),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6788),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1593] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8392),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1594] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8394),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1595] = {
    [sym__closed_assignment] = STATE(16810),
    [sym__expression] = STATE(13727),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8396),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8398),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1596] = {
    [sym__closed_assignment] = STATE(16135),
    [sym__expression] = STATE(12669),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8400),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8402),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1597] = {
    [sym__closed_assignment] = STATE(16895),
    [sym__expression] = STATE(13879),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8404),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8406),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1598] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1278),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1599] = {
    [sym__closed_assignment] = STATE(16851),
    [sym__expression] = STATE(13837),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8408),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8410),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1600] = {
    [sym__closed_assignment] = STATE(16244),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10454),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8412),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8414),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1601] = {
    [sym__closed_assignment] = STATE(17219),
    [sym__expression] = STATE(13724),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8416),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8418),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1602] = {
    [sym__closed_assignment] = STATE(17282),
    [sym__expression] = STATE(13609),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8420),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8422),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1603] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(977),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1604] = {
    [sym__closed_assignment] = STATE(16292),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10466),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8424),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8426),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1605] = {
    [sym__closed_assignment] = STATE(15606),
    [sym__expression] = STATE(12515),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8428),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8430),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1606] = {
    [sym__closed_assignment] = STATE(17005),
    [sym__expression] = STATE(13786),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8432),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8434),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1607] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1262),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1608] = {
    [sym__closed_assignment] = STATE(16330),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10478),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8436),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8438),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1609] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12940),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10413),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8440),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1610] = {
    [sym__closed_assignment] = STATE(16668),
    [sym__expression] = STATE(13889),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8442),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8444),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1611] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(946),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1612] = {
    [sym__closed_assignment] = STATE(16357),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10482),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8446),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8448),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1613] = {
    [sym__closed_assignment] = STATE(16177),
    [sym__expression] = STATE(12427),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8450),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8452),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1614] = {
    [sym__closed_assignment] = STATE(15534),
    [sym__expression] = STATE(12348),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8454),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8456),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1615] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1063),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1616] = {
    [sym__closed_assignment] = STATE(16386),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10484),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8458),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8460),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1617] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8462),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1618] = {
    [sym__closed_assignment] = STATE(16089),
    [sym__expression] = STATE(12531),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8464),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8466),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1619] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1157),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1620] = {
    [sym__closed_assignment] = STATE(16402),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10494),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8468),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8470),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1621] = {
    [sym__closed_assignment] = STATE(17144),
    [sym__expression] = STATE(13726),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8472),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8474),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1622] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8476),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1623] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1246),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1624] = {
    [sym__closed_assignment] = STATE(16420),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10495),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8478),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8480),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1625] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1626] = {
    [sym__closed_assignment] = STATE(15820),
    [sym__expression] = STATE(12577),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8484),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8486),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1627] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1320),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1628] = {
    [sym__closed_assignment] = STATE(16435),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10496),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8488),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8490),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1629] = {
    [sym__closed_assignment] = STATE(16154),
    [sym__expression] = STATE(12476),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8492),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8494),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1630] = {
    [sym__closed_assignment] = STATE(16742),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8496),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8498),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1631] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1389),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1632] = {
    [sym__closed_assignment] = STATE(16451),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10498),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8500),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8502),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1633] = {
    [sym__closed_assignment] = STATE(16963),
    [sym__expression] = STATE(13894),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8504),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8506),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1634] = {
    [sym__closed_assignment] = STATE(16815),
    [sym__expression] = STATE(13698),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8508),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8510),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1635] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1452),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1636] = {
    [sym__closed_assignment] = STATE(16467),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8512),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8514),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1637] = {
    [sym__closed_assignment] = STATE(17130),
    [sym__expression] = STATE(13797),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8516),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8518),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1638] = {
    [sym__closed_assignment] = STATE(16631),
    [sym__expression] = STATE(12447),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8520),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8522),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1639] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(973),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1640] = {
    [sym__closed_assignment] = STATE(16484),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10503),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8524),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8178),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4134),
    [sym__type_order_operator] = ACTIONS(4134),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym__terminator_token1] = ACTIONS(8526),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1641] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10521),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8528),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1642] = {
    [sym__closed_assignment] = STATE(16670),
    [sym__expression] = STATE(13634),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(8530),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8532),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1643] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1021),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1644] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1035),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1645] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1045),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1646] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1053),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1647] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1060),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1648] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1069),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1649] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1078),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1650] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1085),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1651] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1092),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1652] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1101),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1653] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1109),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1654] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1118),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1655] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1126),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1656] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1135),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1657] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1143),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1658] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1151),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1659] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1160),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1660] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1168),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1661] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1176),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1662] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1184),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1663] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1192),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1664] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1201),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1665] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1210),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1666] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1218),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1667] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1227),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1668] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1235),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1669] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1241),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1670] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1249),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1671] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1258),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1672] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1266),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1673] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11432),
    [sym_tuple_expression] = STATE(11432),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym__do_parameter_list] = STATE(1275),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13554),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13265),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10821),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(191),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(8164),
    [anon_sym_LF] = ACTIONS(8386),
    [anon_sym_LBRACE] = ACTIONS(8168),
    [anon_sym_DOLLAR] = ACTIONS(8170),
    [anon_sym_COLON_COLON] = ACTIONS(8172),
    [anon_sym_AT] = ACTIONS(8174),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(8176),
    [aux_sym_float_literal_token3] = ACTIONS(8176),
    [aux_sym_float_literal_token4] = ACTIONS(8176),
    [sym_character_literal] = ACTIONS(8388),
    [sym__pair_operator] = ACTIONS(2926),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2926),
    [sym__pipe_left_operator] = ACTIONS(2926),
    [sym__ellipsis_operator] = ACTIONS(2926),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2926),
    [sym__bitshift_operator] = ACTIONS(2926),
    [sym__power_operator] = ACTIONS(2926),
    [sym__tilde_operator] = ACTIONS(4140),
    [sym__type_order_operator] = ACTIONS(4140),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [aux_sym__terminator_token1] = ACTIONS(8390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1674] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(16287),
    [sym__expression] = STATE(13248),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11340),
    [sym__array] = STATE(11340),
    [sym_comprehension_expression] = STATE(11340),
    [sym_matrix_expression] = STATE(11340),
    [sym_vector_expression] = STATE(11340),
    [sym_parenthesized_expression] = STATE(11340),
    [sym_tuple_expression] = STATE(11340),
    [sym_curly_expression] = STATE(11340),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11340),
    [sym_index_expression] = STATE(11340),
    [sym_parametrized_type_expression] = STATE(11340),
    [sym_call_expression] = STATE(11340),
    [sym_broadcast_call_expression] = STATE(11340),
    [sym__closed_macrocall_expression] = STATE(11340),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11340),
    [sym_quote_expression] = STATE(11340),
    [sym_binary_expression] = STATE(13282),
    [sym_unary_expression] = STATE(13282),
    [sym_range_expression] = STATE(13282),
    [sym_splat_expression] = STATE(13282),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12936),
    [sym_unary_typed_expression] = STATE(13282),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13282),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11340),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11340),
    [sym_string_literal] = STATE(11340),
    [sym_command_literal] = STATE(11340),
    [sym_prefixed_string_literal] = STATE(11340),
    [sym_prefixed_command_literal] = STATE(11340),
    [sym_operator] = STATE(13018),
    [ts_builtin_sym_end] = ACTIONS(8534),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(75),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1675] = {
    [sym_assignment] = STATE(8378),
    [sym_open_tuple] = STATE(9193),
    [sym__expression] = STATE(9121),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [1676] = {
    [sym_assignment] = STATE(8989),
    [sym_open_tuple] = STATE(8960),
    [sym__expression] = STATE(8819),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8552),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [1677] = {
    [sym_assignment] = STATE(12287),
    [sym_open_tuple] = STATE(18277),
    [sym__expression] = STATE(12465),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10619),
    [sym__array] = STATE(10619),
    [sym_comprehension_expression] = STATE(10619),
    [sym_matrix_expression] = STATE(10619),
    [sym_vector_expression] = STATE(10619),
    [sym_parenthesized_expression] = STATE(10619),
    [sym_tuple_expression] = STATE(10619),
    [sym_curly_expression] = STATE(10619),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10619),
    [sym_index_expression] = STATE(10619),
    [sym_parametrized_type_expression] = STATE(10619),
    [sym_call_expression] = STATE(10619),
    [sym_broadcast_call_expression] = STATE(10619),
    [sym__closed_macrocall_expression] = STATE(10619),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(10619),
    [sym_quote_expression] = STATE(10619),
    [sym_binary_expression] = STATE(12555),
    [sym_unary_expression] = STATE(12555),
    [sym_range_expression] = STATE(12555),
    [sym_splat_expression] = STATE(12555),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12201),
    [sym_unary_typed_expression] = STATE(12555),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12555),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(10619),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10619),
    [sym_string_literal] = STATE(10619),
    [sym_command_literal] = STATE(10619),
    [sym_prefixed_string_literal] = STATE(10619),
    [sym_prefixed_command_literal] = STATE(10619),
    [sym_operator] = STATE(12161),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8568),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [1678] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(19044),
    [sym__expression] = STATE(13366),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11220),
    [sym__array] = STATE(11220),
    [sym_comprehension_expression] = STATE(11220),
    [sym_matrix_expression] = STATE(11220),
    [sym_vector_expression] = STATE(11220),
    [sym_parenthesized_expression] = STATE(11220),
    [sym_tuple_expression] = STATE(11220),
    [sym_curly_expression] = STATE(11220),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11220),
    [sym_index_expression] = STATE(11220),
    [sym_parametrized_type_expression] = STATE(11220),
    [sym_call_expression] = STATE(11220),
    [sym_broadcast_call_expression] = STATE(11220),
    [sym__closed_macrocall_expression] = STATE(11220),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11220),
    [sym_quote_expression] = STATE(11220),
    [sym_binary_expression] = STATE(13251),
    [sym_unary_expression] = STATE(13251),
    [sym_range_expression] = STATE(13251),
    [sym_splat_expression] = STATE(13251),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13087),
    [sym_unary_typed_expression] = STATE(13251),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13251),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11220),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11220),
    [sym_string_literal] = STATE(11220),
    [sym_command_literal] = STATE(11220),
    [sym_prefixed_string_literal] = STATE(11220),
    [sym_prefixed_command_literal] = STATE(11220),
    [sym_operator] = STATE(13088),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(8574),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1679] = {
    [sym_assignment] = STATE(12340),
    [sym_open_tuple] = STATE(18277),
    [sym__expression] = STATE(12471),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10619),
    [sym__array] = STATE(10619),
    [sym_comprehension_expression] = STATE(10619),
    [sym_matrix_expression] = STATE(10619),
    [sym_vector_expression] = STATE(10619),
    [sym_parenthesized_expression] = STATE(10619),
    [sym_tuple_expression] = STATE(10619),
    [sym_curly_expression] = STATE(10619),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10619),
    [sym_index_expression] = STATE(10619),
    [sym_parametrized_type_expression] = STATE(10619),
    [sym_call_expression] = STATE(10619),
    [sym_broadcast_call_expression] = STATE(10619),
    [sym__closed_macrocall_expression] = STATE(10619),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(10619),
    [sym_quote_expression] = STATE(10619),
    [sym_binary_expression] = STATE(12555),
    [sym_unary_expression] = STATE(12555),
    [sym_range_expression] = STATE(12555),
    [sym_splat_expression] = STATE(12555),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12201),
    [sym_unary_typed_expression] = STATE(12555),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12555),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(10619),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10619),
    [sym_string_literal] = STATE(10619),
    [sym_command_literal] = STATE(10619),
    [sym_prefixed_string_literal] = STATE(10619),
    [sym_prefixed_command_literal] = STATE(10619),
    [sym_operator] = STATE(12161),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8568),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [1680] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8576),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1681] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(12818),
    [sym__expression] = STATE(12631),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10630),
    [sym__array] = STATE(10630),
    [sym_comprehension_expression] = STATE(10630),
    [sym_matrix_expression] = STATE(10630),
    [sym_vector_expression] = STATE(10630),
    [sym_parenthesized_expression] = STATE(10630),
    [sym_tuple_expression] = STATE(10630),
    [sym_curly_expression] = STATE(10630),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10630),
    [sym_index_expression] = STATE(10630),
    [sym_parametrized_type_expression] = STATE(10630),
    [sym_call_expression] = STATE(10630),
    [sym_broadcast_call_expression] = STATE(10630),
    [sym__closed_macrocall_expression] = STATE(10630),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(10630),
    [sym_quote_expression] = STATE(10630),
    [sym_binary_expression] = STATE(12247),
    [sym_unary_expression] = STATE(12247),
    [sym_range_expression] = STATE(12247),
    [sym_splat_expression] = STATE(12247),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12247),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12247),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(10630),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10630),
    [sym_string_literal] = STATE(10630),
    [sym_command_literal] = STATE(10630),
    [sym_prefixed_string_literal] = STATE(10630),
    [sym_prefixed_command_literal] = STATE(10630),
    [sym_operator] = STATE(11897),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8582),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1682] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(12819),
    [sym__expression] = STATE(12633),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10630),
    [sym__array] = STATE(10630),
    [sym_comprehension_expression] = STATE(10630),
    [sym_matrix_expression] = STATE(10630),
    [sym_vector_expression] = STATE(10630),
    [sym_parenthesized_expression] = STATE(10630),
    [sym_tuple_expression] = STATE(10630),
    [sym_curly_expression] = STATE(10630),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10630),
    [sym_index_expression] = STATE(10630),
    [sym_parametrized_type_expression] = STATE(10630),
    [sym_call_expression] = STATE(10630),
    [sym_broadcast_call_expression] = STATE(10630),
    [sym__closed_macrocall_expression] = STATE(10630),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(10630),
    [sym_quote_expression] = STATE(10630),
    [sym_binary_expression] = STATE(12247),
    [sym_unary_expression] = STATE(12247),
    [sym_range_expression] = STATE(12247),
    [sym_splat_expression] = STATE(12247),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12247),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12247),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(10630),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10630),
    [sym_string_literal] = STATE(10630),
    [sym_command_literal] = STATE(10630),
    [sym_prefixed_string_literal] = STATE(10630),
    [sym_prefixed_command_literal] = STATE(10630),
    [sym_operator] = STATE(11897),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8582),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1683] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(12268),
    [sym__expression] = STATE(12398),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10630),
    [sym__array] = STATE(10630),
    [sym_comprehension_expression] = STATE(10630),
    [sym_matrix_expression] = STATE(10630),
    [sym_vector_expression] = STATE(10630),
    [sym_parenthesized_expression] = STATE(10630),
    [sym_tuple_expression] = STATE(10630),
    [sym_curly_expression] = STATE(10630),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10630),
    [sym_index_expression] = STATE(10630),
    [sym_parametrized_type_expression] = STATE(10630),
    [sym_call_expression] = STATE(10630),
    [sym_broadcast_call_expression] = STATE(10630),
    [sym__closed_macrocall_expression] = STATE(10630),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(10630),
    [sym_quote_expression] = STATE(10630),
    [sym_binary_expression] = STATE(12247),
    [sym_unary_expression] = STATE(12247),
    [sym_range_expression] = STATE(12247),
    [sym_splat_expression] = STATE(12247),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12247),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12247),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(10630),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10630),
    [sym_string_literal] = STATE(10630),
    [sym_command_literal] = STATE(10630),
    [sym_prefixed_string_literal] = STATE(10630),
    [sym_prefixed_command_literal] = STATE(10630),
    [sym_operator] = STATE(11897),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8582),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1684] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(18622),
    [sym__expression] = STATE(12672),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10630),
    [sym__array] = STATE(10630),
    [sym_comprehension_expression] = STATE(10630),
    [sym_matrix_expression] = STATE(10630),
    [sym_vector_expression] = STATE(10630),
    [sym_parenthesized_expression] = STATE(10630),
    [sym_tuple_expression] = STATE(10630),
    [sym_curly_expression] = STATE(10630),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10630),
    [sym_index_expression] = STATE(10630),
    [sym_parametrized_type_expression] = STATE(10630),
    [sym_call_expression] = STATE(10630),
    [sym_broadcast_call_expression] = STATE(10630),
    [sym__closed_macrocall_expression] = STATE(10630),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(10630),
    [sym_quote_expression] = STATE(10630),
    [sym_binary_expression] = STATE(12247),
    [sym_unary_expression] = STATE(12247),
    [sym_range_expression] = STATE(12247),
    [sym_splat_expression] = STATE(12247),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12247),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12247),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(10630),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10630),
    [sym_string_literal] = STATE(10630),
    [sym_command_literal] = STATE(10630),
    [sym_prefixed_string_literal] = STATE(10630),
    [sym_prefixed_command_literal] = STATE(10630),
    [sym_operator] = STATE(11897),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8582),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1685] = {
    [sym_assignment] = STATE(11883),
    [sym_open_tuple] = STATE(13268),
    [sym__expression] = STATE(13272),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11225),
    [sym__array] = STATE(11225),
    [sym_comprehension_expression] = STATE(11225),
    [sym_matrix_expression] = STATE(11225),
    [sym_vector_expression] = STATE(11225),
    [sym_parenthesized_expression] = STATE(11225),
    [sym_tuple_expression] = STATE(11225),
    [sym_curly_expression] = STATE(11225),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11225),
    [sym_index_expression] = STATE(11225),
    [sym_parametrized_type_expression] = STATE(11225),
    [sym_call_expression] = STATE(11225),
    [sym_broadcast_call_expression] = STATE(11225),
    [sym__closed_macrocall_expression] = STATE(11225),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11225),
    [sym_quote_expression] = STATE(11225),
    [sym_binary_expression] = STATE(13238),
    [sym_unary_expression] = STATE(13238),
    [sym_range_expression] = STATE(13238),
    [sym_splat_expression] = STATE(13238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13077),
    [sym_unary_typed_expression] = STATE(13238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13238),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11225),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11225),
    [sym_string_literal] = STATE(11225),
    [sym_command_literal] = STATE(11225),
    [sym_prefixed_string_literal] = STATE(11225),
    [sym_prefixed_command_literal] = STATE(11225),
    [sym_operator] = STATE(13078),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3178),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1686] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(18622),
    [sym__expression] = STATE(12693),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10630),
    [sym__array] = STATE(10630),
    [sym_comprehension_expression] = STATE(10630),
    [sym_matrix_expression] = STATE(10630),
    [sym_vector_expression] = STATE(10630),
    [sym_parenthesized_expression] = STATE(10630),
    [sym_tuple_expression] = STATE(10630),
    [sym_curly_expression] = STATE(10630),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10630),
    [sym_index_expression] = STATE(10630),
    [sym_parametrized_type_expression] = STATE(10630),
    [sym_call_expression] = STATE(10630),
    [sym_broadcast_call_expression] = STATE(10630),
    [sym__closed_macrocall_expression] = STATE(10630),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(10630),
    [sym_quote_expression] = STATE(10630),
    [sym_binary_expression] = STATE(12247),
    [sym_unary_expression] = STATE(12247),
    [sym_range_expression] = STATE(12247),
    [sym_splat_expression] = STATE(12247),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12247),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12247),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(10630),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10630),
    [sym_string_literal] = STATE(10630),
    [sym_command_literal] = STATE(10630),
    [sym_prefixed_string_literal] = STATE(10630),
    [sym_prefixed_command_literal] = STATE(10630),
    [sym_operator] = STATE(11897),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8582),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1687] = {
    [sym_assignment] = STATE(11884),
    [sym_open_tuple] = STATE(13278),
    [sym__expression] = STATE(13280),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11225),
    [sym__array] = STATE(11225),
    [sym_comprehension_expression] = STATE(11225),
    [sym_matrix_expression] = STATE(11225),
    [sym_vector_expression] = STATE(11225),
    [sym_parenthesized_expression] = STATE(11225),
    [sym_tuple_expression] = STATE(11225),
    [sym_curly_expression] = STATE(11225),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11225),
    [sym_index_expression] = STATE(11225),
    [sym_parametrized_type_expression] = STATE(11225),
    [sym_call_expression] = STATE(11225),
    [sym_broadcast_call_expression] = STATE(11225),
    [sym__closed_macrocall_expression] = STATE(11225),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11225),
    [sym_quote_expression] = STATE(11225),
    [sym_binary_expression] = STATE(13238),
    [sym_unary_expression] = STATE(13238),
    [sym_range_expression] = STATE(13238),
    [sym_splat_expression] = STATE(13238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13077),
    [sym_unary_typed_expression] = STATE(13238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13238),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11225),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11225),
    [sym_string_literal] = STATE(11225),
    [sym_command_literal] = STATE(11225),
    [sym_prefixed_string_literal] = STATE(11225),
    [sym_prefixed_command_literal] = STATE(11225),
    [sym_operator] = STATE(13078),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3178),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1688] = {
    [sym_assignment] = STATE(9085),
    [sym_open_tuple] = STATE(8950),
    [sym__expression] = STATE(9087),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8552),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [1689] = {
    [sym_assignment] = STATE(9088),
    [sym_open_tuple] = STATE(8951),
    [sym__expression] = STATE(9089),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8552),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [1690] = {
    [sym_assignment] = STATE(8790),
    [sym_open_tuple] = STATE(19753),
    [sym__expression] = STATE(8883),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8552),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [1691] = {
    [sym_assignment] = STATE(8884),
    [sym_open_tuple] = STATE(19753),
    [sym__expression] = STATE(8904),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6262),
    [sym__array] = STATE(6262),
    [sym_comprehension_expression] = STATE(6262),
    [sym_matrix_expression] = STATE(6262),
    [sym_vector_expression] = STATE(6262),
    [sym_parenthesized_expression] = STATE(6262),
    [sym_tuple_expression] = STATE(6262),
    [sym_curly_expression] = STATE(6262),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6262),
    [sym_index_expression] = STATE(6262),
    [sym_parametrized_type_expression] = STATE(6262),
    [sym_call_expression] = STATE(6262),
    [sym_broadcast_call_expression] = STATE(6262),
    [sym__closed_macrocall_expression] = STATE(6262),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6262),
    [sym_quote_expression] = STATE(6262),
    [sym_binary_expression] = STATE(8786),
    [sym_unary_expression] = STATE(8786),
    [sym_range_expression] = STATE(8786),
    [sym_splat_expression] = STATE(8786),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8272),
    [sym_unary_typed_expression] = STATE(8786),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8786),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6262),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6262),
    [sym_string_literal] = STATE(6262),
    [sym_command_literal] = STATE(6262),
    [sym_prefixed_string_literal] = STATE(6262),
    [sym_prefixed_command_literal] = STATE(6262),
    [sym_operator] = STATE(8457),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8552),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [1692] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8586),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1693] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(19044),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11783),
    [sym__array] = STATE(11783),
    [sym_comprehension_expression] = STATE(11783),
    [sym_matrix_expression] = STATE(11783),
    [sym_vector_expression] = STATE(11783),
    [sym_parenthesized_expression] = STATE(11783),
    [sym_tuple_expression] = STATE(11783),
    [sym_curly_expression] = STATE(11783),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11783),
    [sym_index_expression] = STATE(11783),
    [sym_parametrized_type_expression] = STATE(11783),
    [sym_call_expression] = STATE(11783),
    [sym_broadcast_call_expression] = STATE(11783),
    [sym__closed_macrocall_expression] = STATE(11783),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11783),
    [sym_quote_expression] = STATE(11783),
    [sym_binary_expression] = STATE(14127),
    [sym_unary_expression] = STATE(14127),
    [sym_range_expression] = STATE(14127),
    [sym_splat_expression] = STATE(14127),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13976),
    [sym_unary_typed_expression] = STATE(14127),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14127),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11783),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11783),
    [sym_string_literal] = STATE(11783),
    [sym_command_literal] = STATE(11783),
    [sym_prefixed_string_literal] = STATE(11783),
    [sym_prefixed_command_literal] = STATE(11783),
    [sym_operator] = STATE(13982),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8588),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1694] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(13370),
    [sym__expression] = STATE(13132),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11203),
    [sym__array] = STATE(11203),
    [sym_comprehension_expression] = STATE(11203),
    [sym_matrix_expression] = STATE(11203),
    [sym_vector_expression] = STATE(11203),
    [sym_parenthesized_expression] = STATE(11203),
    [sym_tuple_expression] = STATE(11203),
    [sym_curly_expression] = STATE(11203),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11203),
    [sym_index_expression] = STATE(11203),
    [sym_parametrized_type_expression] = STATE(11203),
    [sym_call_expression] = STATE(11203),
    [sym_broadcast_call_expression] = STATE(11203),
    [sym__closed_macrocall_expression] = STATE(11203),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11203),
    [sym_quote_expression] = STATE(11203),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13080),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11203),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11203),
    [sym_string_literal] = STATE(11203),
    [sym_command_literal] = STATE(11203),
    [sym_prefixed_string_literal] = STATE(11203),
    [sym_prefixed_command_literal] = STATE(11203),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(8590),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1695] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(13371),
    [sym__expression] = STATE(13133),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11203),
    [sym__array] = STATE(11203),
    [sym_comprehension_expression] = STATE(11203),
    [sym_matrix_expression] = STATE(11203),
    [sym_vector_expression] = STATE(11203),
    [sym_parenthesized_expression] = STATE(11203),
    [sym_tuple_expression] = STATE(11203),
    [sym_curly_expression] = STATE(11203),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11203),
    [sym_index_expression] = STATE(11203),
    [sym_parametrized_type_expression] = STATE(11203),
    [sym_call_expression] = STATE(11203),
    [sym_broadcast_call_expression] = STATE(11203),
    [sym__closed_macrocall_expression] = STATE(11203),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11203),
    [sym_quote_expression] = STATE(11203),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13080),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11203),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11203),
    [sym_string_literal] = STATE(11203),
    [sym_command_literal] = STATE(11203),
    [sym_prefixed_string_literal] = STATE(11203),
    [sym_prefixed_command_literal] = STATE(11203),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(8590),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1696] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(15189),
    [sym__expression] = STATE(12988),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1697] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(13213),
    [sym__expression] = STATE(13221),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11200),
    [sym__array] = STATE(11200),
    [sym_comprehension_expression] = STATE(11200),
    [sym_matrix_expression] = STATE(11200),
    [sym_vector_expression] = STATE(11200),
    [sym_parenthesized_expression] = STATE(11200),
    [sym_tuple_expression] = STATE(11200),
    [sym_curly_expression] = STATE(11200),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11200),
    [sym_index_expression] = STATE(11200),
    [sym_parametrized_type_expression] = STATE(11200),
    [sym_call_expression] = STATE(11200),
    [sym_broadcast_call_expression] = STATE(11200),
    [sym__closed_macrocall_expression] = STATE(11200),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11200),
    [sym_quote_expression] = STATE(11200),
    [sym_binary_expression] = STATE(13364),
    [sym_unary_expression] = STATE(13364),
    [sym_range_expression] = STATE(13364),
    [sym_splat_expression] = STATE(13364),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12999),
    [sym_unary_typed_expression] = STATE(13364),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13364),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11200),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11200),
    [sym_string_literal] = STATE(11200),
    [sym_command_literal] = STATE(11200),
    [sym_prefixed_string_literal] = STATE(11200),
    [sym_prefixed_command_literal] = STATE(11200),
    [sym_operator] = STATE(13000),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(8592),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1698] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(19333),
    [sym__expression] = STATE(13004),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11203),
    [sym__array] = STATE(11203),
    [sym_comprehension_expression] = STATE(11203),
    [sym_matrix_expression] = STATE(11203),
    [sym_vector_expression] = STATE(11203),
    [sym_parenthesized_expression] = STATE(11203),
    [sym_tuple_expression] = STATE(11203),
    [sym_curly_expression] = STATE(11203),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11203),
    [sym_index_expression] = STATE(11203),
    [sym_parametrized_type_expression] = STATE(11203),
    [sym_call_expression] = STATE(11203),
    [sym_broadcast_call_expression] = STATE(11203),
    [sym__closed_macrocall_expression] = STATE(11203),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11203),
    [sym_quote_expression] = STATE(11203),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13080),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11203),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11203),
    [sym_string_literal] = STATE(11203),
    [sym_command_literal] = STATE(11203),
    [sym_prefixed_string_literal] = STATE(11203),
    [sym_prefixed_command_literal] = STATE(11203),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(8590),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1699] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(14526),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11643),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11643),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13739),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11221),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8598),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1700] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(18358),
    [sym__expression] = STATE(13920),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11225),
    [sym__array] = STATE(11225),
    [sym_comprehension_expression] = STATE(11225),
    [sym_matrix_expression] = STATE(11225),
    [sym_vector_expression] = STATE(11225),
    [sym_parenthesized_expression] = STATE(11225),
    [sym_tuple_expression] = STATE(11225),
    [sym_curly_expression] = STATE(11225),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11225),
    [sym_index_expression] = STATE(11225),
    [sym_parametrized_type_expression] = STATE(11225),
    [sym_call_expression] = STATE(11225),
    [sym_broadcast_call_expression] = STATE(11225),
    [sym__closed_macrocall_expression] = STATE(11225),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11225),
    [sym_quote_expression] = STATE(11225),
    [sym_binary_expression] = STATE(13238),
    [sym_unary_expression] = STATE(13238),
    [sym_range_expression] = STATE(13238),
    [sym_splat_expression] = STATE(13238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13077),
    [sym_unary_typed_expression] = STATE(13238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13238),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11225),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11225),
    [sym_string_literal] = STATE(11225),
    [sym_command_literal] = STATE(11225),
    [sym_prefixed_string_literal] = STATE(11225),
    [sym_prefixed_command_literal] = STATE(11225),
    [sym_operator] = STATE(13078),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3178),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1701] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8602),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1702] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8606),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1703] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8608),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1704] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8610),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1705] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8612),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1706] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8614),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1707] = {
    [sym__expression] = STATE(13768),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16915),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8616),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1708] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8618),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1709] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8620),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1710] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8602),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1711] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8622),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1712] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8586),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1713] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8624),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1714] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8626),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1715] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8628),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1716] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8624),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1717] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8630),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1718] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8608),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1719] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8632),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1720] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(19333),
    [sym__expression] = STATE(13010),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11203),
    [sym__array] = STATE(11203),
    [sym_comprehension_expression] = STATE(11203),
    [sym_matrix_expression] = STATE(11203),
    [sym_vector_expression] = STATE(11203),
    [sym_parenthesized_expression] = STATE(11203),
    [sym_tuple_expression] = STATE(11203),
    [sym_curly_expression] = STATE(11203),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11203),
    [sym_index_expression] = STATE(11203),
    [sym_parametrized_type_expression] = STATE(11203),
    [sym_call_expression] = STATE(11203),
    [sym_broadcast_call_expression] = STATE(11203),
    [sym__closed_macrocall_expression] = STATE(11203),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11203),
    [sym_quote_expression] = STATE(11203),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13080),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11203),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11203),
    [sym_string_literal] = STATE(11203),
    [sym_command_literal] = STATE(11203),
    [sym_prefixed_string_literal] = STATE(11203),
    [sym_prefixed_command_literal] = STATE(11203),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(8590),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1721] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(15380),
    [sym__expression] = STATE(12976),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11157),
    [sym__array] = STATE(11157),
    [sym_comprehension_expression] = STATE(11157),
    [sym_matrix_expression] = STATE(11157),
    [sym_vector_expression] = STATE(11157),
    [sym_parenthesized_expression] = STATE(11157),
    [sym_tuple_expression] = STATE(11157),
    [sym_curly_expression] = STATE(11157),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11157),
    [sym_index_expression] = STATE(11157),
    [sym_parametrized_type_expression] = STATE(11157),
    [sym_call_expression] = STATE(11157),
    [sym_broadcast_call_expression] = STATE(11157),
    [sym__closed_macrocall_expression] = STATE(11157),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11157),
    [sym_quote_expression] = STATE(11157),
    [sym_binary_expression] = STATE(12907),
    [sym_unary_expression] = STATE(12907),
    [sym_range_expression] = STATE(12907),
    [sym_splat_expression] = STATE(12907),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12431),
    [sym_unary_typed_expression] = STATE(12907),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12907),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11157),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11157),
    [sym_string_literal] = STATE(11157),
    [sym_command_literal] = STATE(11157),
    [sym_prefixed_string_literal] = STATE(11157),
    [sym_prefixed_command_literal] = STATE(11157),
    [sym_operator] = STATE(12432),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(4782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1722] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(18358),
    [sym__expression] = STATE(13750),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11225),
    [sym__array] = STATE(11225),
    [sym_comprehension_expression] = STATE(11225),
    [sym_matrix_expression] = STATE(11225),
    [sym_vector_expression] = STATE(11225),
    [sym_parenthesized_expression] = STATE(11225),
    [sym_tuple_expression] = STATE(11225),
    [sym_curly_expression] = STATE(11225),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11225),
    [sym_index_expression] = STATE(11225),
    [sym_parametrized_type_expression] = STATE(11225),
    [sym_call_expression] = STATE(11225),
    [sym_broadcast_call_expression] = STATE(11225),
    [sym__closed_macrocall_expression] = STATE(11225),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11225),
    [sym_quote_expression] = STATE(11225),
    [sym_binary_expression] = STATE(13238),
    [sym_unary_expression] = STATE(13238),
    [sym_range_expression] = STATE(13238),
    [sym_splat_expression] = STATE(13238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13077),
    [sym_unary_typed_expression] = STATE(13238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13238),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11225),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11225),
    [sym_string_literal] = STATE(11225),
    [sym_command_literal] = STATE(11225),
    [sym_prefixed_string_literal] = STATE(11225),
    [sym_prefixed_command_literal] = STATE(11225),
    [sym_operator] = STATE(13078),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3178),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1723] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8634),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1724] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8636),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1725] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8638),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1726] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8640),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1727] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8642),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1728] = {
    [sym_assignment] = STATE(7324),
    [sym_open_tuple] = STATE(7326),
    [sym__expression] = STATE(7327),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8658),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1729] = {
    [sym_assignment] = STATE(7328),
    [sym_open_tuple] = STATE(7329),
    [sym__expression] = STATE(7330),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8658),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1730] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8664),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1731] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8666),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1732] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(13217),
    [sym__expression] = STATE(13058),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11198),
    [sym__array] = STATE(11198),
    [sym_comprehension_expression] = STATE(11198),
    [sym_matrix_expression] = STATE(11198),
    [sym_vector_expression] = STATE(11198),
    [sym_parenthesized_expression] = STATE(11198),
    [sym_tuple_expression] = STATE(11198),
    [sym_curly_expression] = STATE(11198),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11198),
    [sym_index_expression] = STATE(11198),
    [sym_parametrized_type_expression] = STATE(11198),
    [sym_call_expression] = STATE(11198),
    [sym_broadcast_call_expression] = STATE(11198),
    [sym__closed_macrocall_expression] = STATE(11198),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11198),
    [sym_quote_expression] = STATE(11198),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12928),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11198),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11198),
    [sym_string_literal] = STATE(11198),
    [sym_command_literal] = STATE(11198),
    [sym_prefixed_string_literal] = STATE(11198),
    [sym_prefixed_command_literal] = STATE(11198),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(8668),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1733] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(13218),
    [sym__expression] = STATE(13059),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11198),
    [sym__array] = STATE(11198),
    [sym_comprehension_expression] = STATE(11198),
    [sym_matrix_expression] = STATE(11198),
    [sym_vector_expression] = STATE(11198),
    [sym_parenthesized_expression] = STATE(11198),
    [sym_tuple_expression] = STATE(11198),
    [sym_curly_expression] = STATE(11198),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11198),
    [sym_index_expression] = STATE(11198),
    [sym_parametrized_type_expression] = STATE(11198),
    [sym_call_expression] = STATE(11198),
    [sym_broadcast_call_expression] = STATE(11198),
    [sym__closed_macrocall_expression] = STATE(11198),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11198),
    [sym_quote_expression] = STATE(11198),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12928),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11198),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11198),
    [sym_string_literal] = STATE(11198),
    [sym_command_literal] = STATE(11198),
    [sym_prefixed_string_literal] = STATE(11198),
    [sym_prefixed_command_literal] = STATE(11198),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(8668),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1734] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8670),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1735] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(13255),
    [sym__expression] = STATE(13345),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11220),
    [sym__array] = STATE(11220),
    [sym_comprehension_expression] = STATE(11220),
    [sym_matrix_expression] = STATE(11220),
    [sym_vector_expression] = STATE(11220),
    [sym_parenthesized_expression] = STATE(11220),
    [sym_tuple_expression] = STATE(11220),
    [sym_curly_expression] = STATE(11220),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11220),
    [sym_index_expression] = STATE(11220),
    [sym_parametrized_type_expression] = STATE(11220),
    [sym_call_expression] = STATE(11220),
    [sym_broadcast_call_expression] = STATE(11220),
    [sym__closed_macrocall_expression] = STATE(11220),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11220),
    [sym_quote_expression] = STATE(11220),
    [sym_binary_expression] = STATE(13251),
    [sym_unary_expression] = STATE(13251),
    [sym_range_expression] = STATE(13251),
    [sym_splat_expression] = STATE(13251),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13087),
    [sym_unary_typed_expression] = STATE(13251),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13251),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11220),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11220),
    [sym_string_literal] = STATE(11220),
    [sym_command_literal] = STATE(11220),
    [sym_prefixed_string_literal] = STATE(11220),
    [sym_prefixed_command_literal] = STATE(11220),
    [sym_operator] = STATE(13088),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(8574),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1736] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(18415),
    [sym__expression] = STATE(13014),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11198),
    [sym__array] = STATE(11198),
    [sym_comprehension_expression] = STATE(11198),
    [sym_matrix_expression] = STATE(11198),
    [sym_vector_expression] = STATE(11198),
    [sym_parenthesized_expression] = STATE(11198),
    [sym_tuple_expression] = STATE(11198),
    [sym_curly_expression] = STATE(11198),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11198),
    [sym_index_expression] = STATE(11198),
    [sym_parametrized_type_expression] = STATE(11198),
    [sym_call_expression] = STATE(11198),
    [sym_broadcast_call_expression] = STATE(11198),
    [sym__closed_macrocall_expression] = STATE(11198),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11198),
    [sym_quote_expression] = STATE(11198),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12928),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11198),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11198),
    [sym_string_literal] = STATE(11198),
    [sym_command_literal] = STATE(11198),
    [sym_prefixed_string_literal] = STATE(11198),
    [sym_prefixed_command_literal] = STATE(11198),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(8668),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1737] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8672),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1738] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(18415),
    [sym__expression] = STATE(13015),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11198),
    [sym__array] = STATE(11198),
    [sym_comprehension_expression] = STATE(11198),
    [sym_matrix_expression] = STATE(11198),
    [sym_vector_expression] = STATE(11198),
    [sym_parenthesized_expression] = STATE(11198),
    [sym_tuple_expression] = STATE(11198),
    [sym_curly_expression] = STATE(11198),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11198),
    [sym_index_expression] = STATE(11198),
    [sym_parametrized_type_expression] = STATE(11198),
    [sym_call_expression] = STATE(11198),
    [sym_broadcast_call_expression] = STATE(11198),
    [sym__closed_macrocall_expression] = STATE(11198),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11198),
    [sym_quote_expression] = STATE(11198),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12928),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11198),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11198),
    [sym_string_literal] = STATE(11198),
    [sym_command_literal] = STATE(11198),
    [sym_prefixed_string_literal] = STATE(11198),
    [sym_prefixed_command_literal] = STATE(11198),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(8668),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1739] = {
    [sym_assignment] = STATE(11883),
    [sym_open_tuple] = STATE(13373),
    [sym__expression] = STATE(13012),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11288),
    [sym__array] = STATE(11288),
    [sym_comprehension_expression] = STATE(11288),
    [sym_matrix_expression] = STATE(11288),
    [sym_vector_expression] = STATE(11288),
    [sym_parenthesized_expression] = STATE(11288),
    [sym_tuple_expression] = STATE(11288),
    [sym_curly_expression] = STATE(11288),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11288),
    [sym_index_expression] = STATE(11288),
    [sym_parametrized_type_expression] = STATE(11288),
    [sym_call_expression] = STATE(11288),
    [sym_broadcast_call_expression] = STATE(11288),
    [sym__closed_macrocall_expression] = STATE(11288),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11288),
    [sym_quote_expression] = STATE(11288),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13096),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11288),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11288),
    [sym_string_literal] = STATE(11288),
    [sym_command_literal] = STATE(11288),
    [sym_prefixed_string_literal] = STATE(11288),
    [sym_prefixed_command_literal] = STATE(11288),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(2922),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1740] = {
    [sym_assignment] = STATE(11884),
    [sym_open_tuple] = STATE(13374),
    [sym__expression] = STATE(13013),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11288),
    [sym__array] = STATE(11288),
    [sym_comprehension_expression] = STATE(11288),
    [sym_matrix_expression] = STATE(11288),
    [sym_vector_expression] = STATE(11288),
    [sym_parenthesized_expression] = STATE(11288),
    [sym_tuple_expression] = STATE(11288),
    [sym_curly_expression] = STATE(11288),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11288),
    [sym_index_expression] = STATE(11288),
    [sym_parametrized_type_expression] = STATE(11288),
    [sym_call_expression] = STATE(11288),
    [sym_broadcast_call_expression] = STATE(11288),
    [sym__closed_macrocall_expression] = STATE(11288),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11288),
    [sym_quote_expression] = STATE(11288),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13096),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11288),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11288),
    [sym_string_literal] = STATE(11288),
    [sym_command_literal] = STATE(11288),
    [sym_prefixed_string_literal] = STATE(11288),
    [sym_prefixed_command_literal] = STATE(11288),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(2922),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1741] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(12991),
    [sym__expression] = STATE(13043),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11054),
    [sym__array] = STATE(11054),
    [sym_comprehension_expression] = STATE(11054),
    [sym_matrix_expression] = STATE(11054),
    [sym_vector_expression] = STATE(11054),
    [sym_parenthesized_expression] = STATE(11054),
    [sym_tuple_expression] = STATE(11054),
    [sym_curly_expression] = STATE(11054),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11054),
    [sym_index_expression] = STATE(11054),
    [sym_parametrized_type_expression] = STATE(11054),
    [sym_call_expression] = STATE(11054),
    [sym_broadcast_call_expression] = STATE(11054),
    [sym__closed_macrocall_expression] = STATE(11054),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11054),
    [sym_quote_expression] = STATE(11054),
    [sym_binary_expression] = STATE(12944),
    [sym_unary_expression] = STATE(12944),
    [sym_range_expression] = STATE(12944),
    [sym_splat_expression] = STATE(12944),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12622),
    [sym_unary_typed_expression] = STATE(12944),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12944),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11054),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11054),
    [sym_string_literal] = STATE(11054),
    [sym_command_literal] = STATE(11054),
    [sym_prefixed_string_literal] = STATE(11054),
    [sym_prefixed_command_literal] = STATE(11054),
    [sym_operator] = STATE(12623),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(8674),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1742] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(18358),
    [sym__expression] = STATE(13234),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11225),
    [sym__array] = STATE(11225),
    [sym_comprehension_expression] = STATE(11225),
    [sym_matrix_expression] = STATE(11225),
    [sym_vector_expression] = STATE(11225),
    [sym_parenthesized_expression] = STATE(11225),
    [sym_tuple_expression] = STATE(11225),
    [sym_curly_expression] = STATE(11225),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11225),
    [sym_index_expression] = STATE(11225),
    [sym_parametrized_type_expression] = STATE(11225),
    [sym_call_expression] = STATE(11225),
    [sym_broadcast_call_expression] = STATE(11225),
    [sym__closed_macrocall_expression] = STATE(11225),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11225),
    [sym_quote_expression] = STATE(11225),
    [sym_binary_expression] = STATE(13238),
    [sym_unary_expression] = STATE(13238),
    [sym_range_expression] = STATE(13238),
    [sym_splat_expression] = STATE(13238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13077),
    [sym_unary_typed_expression] = STATE(13238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13238),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11225),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11225),
    [sym_string_literal] = STATE(11225),
    [sym_command_literal] = STATE(11225),
    [sym_prefixed_string_literal] = STATE(11225),
    [sym_prefixed_command_literal] = STATE(11225),
    [sym_operator] = STATE(13078),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3178),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1743] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(18358),
    [sym__expression] = STATE(13354),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11225),
    [sym__array] = STATE(11225),
    [sym_comprehension_expression] = STATE(11225),
    [sym_matrix_expression] = STATE(11225),
    [sym_vector_expression] = STATE(11225),
    [sym_parenthesized_expression] = STATE(11225),
    [sym_tuple_expression] = STATE(11225),
    [sym_curly_expression] = STATE(11225),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11225),
    [sym_index_expression] = STATE(11225),
    [sym_parametrized_type_expression] = STATE(11225),
    [sym_call_expression] = STATE(11225),
    [sym_broadcast_call_expression] = STATE(11225),
    [sym__closed_macrocall_expression] = STATE(11225),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11225),
    [sym_quote_expression] = STATE(11225),
    [sym_binary_expression] = STATE(13238),
    [sym_unary_expression] = STATE(13238),
    [sym_range_expression] = STATE(13238),
    [sym_splat_expression] = STATE(13238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13077),
    [sym_unary_typed_expression] = STATE(13238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13238),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11225),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11225),
    [sym_string_literal] = STATE(11225),
    [sym_command_literal] = STATE(11225),
    [sym_prefixed_string_literal] = STATE(11225),
    [sym_prefixed_command_literal] = STATE(11225),
    [sym_operator] = STATE(13078),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3178),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1744] = {
    [sym_assignment] = STATE(7324),
    [sym_open_tuple] = STATE(8025),
    [sym__expression] = STATE(7269),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8676),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1745] = {
    [sym_assignment] = STATE(7328),
    [sym_open_tuple] = STATE(8026),
    [sym__expression] = STATE(6844),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8676),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1746] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(16287),
    [sym__expression] = STATE(13248),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11340),
    [sym__array] = STATE(11340),
    [sym_comprehension_expression] = STATE(11340),
    [sym_matrix_expression] = STATE(11340),
    [sym_vector_expression] = STATE(11340),
    [sym_parenthesized_expression] = STATE(11340),
    [sym_tuple_expression] = STATE(11340),
    [sym_curly_expression] = STATE(11340),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11340),
    [sym_index_expression] = STATE(11340),
    [sym_parametrized_type_expression] = STATE(11340),
    [sym_call_expression] = STATE(11340),
    [sym_broadcast_call_expression] = STATE(11340),
    [sym__closed_macrocall_expression] = STATE(11340),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11340),
    [sym_quote_expression] = STATE(11340),
    [sym_binary_expression] = STATE(13282),
    [sym_unary_expression] = STATE(13282),
    [sym_range_expression] = STATE(13282),
    [sym_splat_expression] = STATE(13282),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12936),
    [sym_unary_typed_expression] = STATE(13282),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13282),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11340),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11340),
    [sym_string_literal] = STATE(11340),
    [sym_command_literal] = STATE(11340),
    [sym_prefixed_string_literal] = STATE(11340),
    [sym_prefixed_command_literal] = STATE(11340),
    [sym_operator] = STATE(13018),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(75),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1747] = {
    [sym_assignment] = STATE(8378),
    [sym_open_tuple] = STATE(8826),
    [sym__expression] = STATE(9070),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [1748] = {
    [sym_assignment] = STATE(7397),
    [sym_open_tuple] = STATE(19661),
    [sym__expression] = STATE(7711),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8658),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1749] = {
    [sym_assignment] = STATE(7909),
    [sym_open_tuple] = STATE(7791),
    [sym__expression] = STATE(7660),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8678),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1750] = {
    [sym_assignment] = STATE(7543),
    [sym_open_tuple] = STATE(19661),
    [sym__expression] = STATE(7721),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8658),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1751] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(13168),
    [sym__expression] = STATE(12832),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11146),
    [sym__array] = STATE(11146),
    [sym_comprehension_expression] = STATE(11146),
    [sym_matrix_expression] = STATE(11146),
    [sym_vector_expression] = STATE(11146),
    [sym_parenthesized_expression] = STATE(11146),
    [sym_tuple_expression] = STATE(11146),
    [sym_curly_expression] = STATE(11146),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11146),
    [sym_index_expression] = STATE(11146),
    [sym_parametrized_type_expression] = STATE(11146),
    [sym_call_expression] = STATE(11146),
    [sym_broadcast_call_expression] = STATE(11146),
    [sym__closed_macrocall_expression] = STATE(11146),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(11146),
    [sym_quote_expression] = STATE(11146),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12370),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(11146),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11146),
    [sym_string_literal] = STATE(11146),
    [sym_command_literal] = STATE(11146),
    [sym_prefixed_string_literal] = STATE(11146),
    [sym_prefixed_command_literal] = STATE(11146),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(8680),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1752] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(13056),
    [sym__expression] = STATE(12833),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11146),
    [sym__array] = STATE(11146),
    [sym_comprehension_expression] = STATE(11146),
    [sym_matrix_expression] = STATE(11146),
    [sym_vector_expression] = STATE(11146),
    [sym_parenthesized_expression] = STATE(11146),
    [sym_tuple_expression] = STATE(11146),
    [sym_curly_expression] = STATE(11146),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11146),
    [sym_index_expression] = STATE(11146),
    [sym_parametrized_type_expression] = STATE(11146),
    [sym_call_expression] = STATE(11146),
    [sym_broadcast_call_expression] = STATE(11146),
    [sym__closed_macrocall_expression] = STATE(11146),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(11146),
    [sym_quote_expression] = STATE(11146),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12370),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(11146),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11146),
    [sym_string_literal] = STATE(11146),
    [sym_command_literal] = STATE(11146),
    [sym_prefixed_string_literal] = STATE(11146),
    [sym_prefixed_command_literal] = STATE(11146),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(8680),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1753] = {
    [sym_assignment] = STATE(8784),
    [sym_open_tuple] = STATE(9079),
    [sym__expression] = STATE(8741),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8696),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1754] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(19701),
    [sym__expression] = STATE(12812),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11146),
    [sym__array] = STATE(11146),
    [sym_comprehension_expression] = STATE(11146),
    [sym_matrix_expression] = STATE(11146),
    [sym_vector_expression] = STATE(11146),
    [sym_parenthesized_expression] = STATE(11146),
    [sym_tuple_expression] = STATE(11146),
    [sym_curly_expression] = STATE(11146),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11146),
    [sym_index_expression] = STATE(11146),
    [sym_parametrized_type_expression] = STATE(11146),
    [sym_call_expression] = STATE(11146),
    [sym_broadcast_call_expression] = STATE(11146),
    [sym__closed_macrocall_expression] = STATE(11146),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(11146),
    [sym_quote_expression] = STATE(11146),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12370),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(11146),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11146),
    [sym_string_literal] = STATE(11146),
    [sym_command_literal] = STATE(11146),
    [sym_prefixed_string_literal] = STATE(11146),
    [sym_prefixed_command_literal] = STATE(11146),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(8680),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1755] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(19701),
    [sym__expression] = STATE(12813),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11146),
    [sym__array] = STATE(11146),
    [sym_comprehension_expression] = STATE(11146),
    [sym_matrix_expression] = STATE(11146),
    [sym_vector_expression] = STATE(11146),
    [sym_parenthesized_expression] = STATE(11146),
    [sym_tuple_expression] = STATE(11146),
    [sym_curly_expression] = STATE(11146),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11146),
    [sym_index_expression] = STATE(11146),
    [sym_parametrized_type_expression] = STATE(11146),
    [sym_call_expression] = STATE(11146),
    [sym_broadcast_call_expression] = STATE(11146),
    [sym__closed_macrocall_expression] = STATE(11146),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(11146),
    [sym_quote_expression] = STATE(11146),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12370),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(11146),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11146),
    [sym_string_literal] = STATE(11146),
    [sym_command_literal] = STATE(11146),
    [sym_prefixed_string_literal] = STATE(11146),
    [sym_prefixed_command_literal] = STATE(11146),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(8680),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1756] = {
    [sym_assignment] = STATE(9110),
    [sym_open_tuple] = STATE(8965),
    [sym__expression] = STATE(8733),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8696),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1757] = {
    [sym_assignment] = STATE(9127),
    [sym_open_tuple] = STATE(8966),
    [sym__expression] = STATE(8734),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8696),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1758] = {
    [sym_assignment] = STATE(18263),
    [sym_open_tuple] = STATE(17403),
    [sym__expression] = STATE(13757),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1759] = {
    [sym_assignment] = STATE(8935),
    [sym_open_tuple] = STATE(18728),
    [sym__expression] = STATE(9081),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8704),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1760] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(15325),
    [sym__expression] = STATE(13016),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11014),
    [sym__array] = STATE(11014),
    [sym_comprehension_expression] = STATE(11014),
    [sym_matrix_expression] = STATE(11014),
    [sym_vector_expression] = STATE(11014),
    [sym_parenthesized_expression] = STATE(11014),
    [sym_tuple_expression] = STATE(11014),
    [sym_curly_expression] = STATE(11014),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11014),
    [sym_index_expression] = STATE(11014),
    [sym_parametrized_type_expression] = STATE(11014),
    [sym_call_expression] = STATE(11014),
    [sym_broadcast_call_expression] = STATE(11014),
    [sym__closed_macrocall_expression] = STATE(11014),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11014),
    [sym_quote_expression] = STATE(11014),
    [sym_binary_expression] = STATE(12958),
    [sym_unary_expression] = STATE(12958),
    [sym_range_expression] = STATE(12958),
    [sym_splat_expression] = STATE(12958),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(12958),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12958),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11014),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11014),
    [sym_string_literal] = STATE(11014),
    [sym_command_literal] = STATE(11014),
    [sym_prefixed_string_literal] = STATE(11014),
    [sym_prefixed_command_literal] = STATE(11014),
    [sym_operator] = STATE(12771),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(6484),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1761] = {
    [sym_assignment] = STATE(9104),
    [sym_open_tuple] = STATE(18728),
    [sym__expression] = STATE(8796),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8704),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1762] = {
    [sym_assignment] = STATE(11883),
    [sym_open_tuple] = STATE(13309),
    [sym__expression] = STATE(13063),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11242),
    [sym__array] = STATE(11242),
    [sym_comprehension_expression] = STATE(11242),
    [sym_matrix_expression] = STATE(11242),
    [sym_vector_expression] = STATE(11242),
    [sym_parenthesized_expression] = STATE(11242),
    [sym_tuple_expression] = STATE(11242),
    [sym_curly_expression] = STATE(11242),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11242),
    [sym_index_expression] = STATE(11242),
    [sym_parametrized_type_expression] = STATE(11242),
    [sym_call_expression] = STATE(11242),
    [sym_broadcast_call_expression] = STATE(11242),
    [sym__closed_macrocall_expression] = STATE(11242),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11242),
    [sym_quote_expression] = STATE(11242),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12994),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11242),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11242),
    [sym_string_literal] = STATE(11242),
    [sym_command_literal] = STATE(11242),
    [sym_prefixed_string_literal] = STATE(11242),
    [sym_prefixed_command_literal] = STATE(11242),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3164),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1763] = {
    [sym_assignment] = STATE(11884),
    [sym_open_tuple] = STATE(13180),
    [sym__expression] = STATE(13064),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11242),
    [sym__array] = STATE(11242),
    [sym_comprehension_expression] = STATE(11242),
    [sym_matrix_expression] = STATE(11242),
    [sym_vector_expression] = STATE(11242),
    [sym_parenthesized_expression] = STATE(11242),
    [sym_tuple_expression] = STATE(11242),
    [sym_curly_expression] = STATE(11242),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11242),
    [sym_index_expression] = STATE(11242),
    [sym_parametrized_type_expression] = STATE(11242),
    [sym_call_expression] = STATE(11242),
    [sym_broadcast_call_expression] = STATE(11242),
    [sym__closed_macrocall_expression] = STATE(11242),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11242),
    [sym_quote_expression] = STATE(11242),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12994),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11242),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11242),
    [sym_string_literal] = STATE(11242),
    [sym_command_literal] = STATE(11242),
    [sym_prefixed_string_literal] = STATE(11242),
    [sym_prefixed_command_literal] = STATE(11242),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3164),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1764] = {
    [sym_assignment] = STATE(8021),
    [sym_open_tuple] = STATE(7360),
    [sym__expression] = STATE(7281),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8676),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1765] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(19632),
    [sym__expression] = STATE(13039),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11242),
    [sym__array] = STATE(11242),
    [sym_comprehension_expression] = STATE(11242),
    [sym_matrix_expression] = STATE(11242),
    [sym_vector_expression] = STATE(11242),
    [sym_parenthesized_expression] = STATE(11242),
    [sym_tuple_expression] = STATE(11242),
    [sym_curly_expression] = STATE(11242),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11242),
    [sym_index_expression] = STATE(11242),
    [sym_parametrized_type_expression] = STATE(11242),
    [sym_call_expression] = STATE(11242),
    [sym_broadcast_call_expression] = STATE(11242),
    [sym__closed_macrocall_expression] = STATE(11242),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11242),
    [sym_quote_expression] = STATE(11242),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12994),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11242),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11242),
    [sym_string_literal] = STATE(11242),
    [sym_command_literal] = STATE(11242),
    [sym_prefixed_string_literal] = STATE(11242),
    [sym_prefixed_command_literal] = STATE(11242),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3164),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1766] = {
    [sym_assignment] = STATE(7397),
    [sym_open_tuple] = STATE(19661),
    [sym__expression] = STATE(7663),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8658),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1767] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(18673),
    [sym__expression] = STATE(13249),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11200),
    [sym__array] = STATE(11200),
    [sym_comprehension_expression] = STATE(11200),
    [sym_matrix_expression] = STATE(11200),
    [sym_vector_expression] = STATE(11200),
    [sym_parenthesized_expression] = STATE(11200),
    [sym_tuple_expression] = STATE(11200),
    [sym_curly_expression] = STATE(11200),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11200),
    [sym_index_expression] = STATE(11200),
    [sym_parametrized_type_expression] = STATE(11200),
    [sym_call_expression] = STATE(11200),
    [sym_broadcast_call_expression] = STATE(11200),
    [sym__closed_macrocall_expression] = STATE(11200),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11200),
    [sym_quote_expression] = STATE(11200),
    [sym_binary_expression] = STATE(13364),
    [sym_unary_expression] = STATE(13364),
    [sym_range_expression] = STATE(13364),
    [sym_splat_expression] = STATE(13364),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12999),
    [sym_unary_typed_expression] = STATE(13364),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13364),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11200),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11200),
    [sym_string_literal] = STATE(11200),
    [sym_command_literal] = STATE(11200),
    [sym_prefixed_string_literal] = STATE(11200),
    [sym_prefixed_command_literal] = STATE(11200),
    [sym_operator] = STATE(13000),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(8592),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1768] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(19632),
    [sym__expression] = STATE(13040),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11242),
    [sym__array] = STATE(11242),
    [sym_comprehension_expression] = STATE(11242),
    [sym_matrix_expression] = STATE(11242),
    [sym_vector_expression] = STATE(11242),
    [sym_parenthesized_expression] = STATE(11242),
    [sym_tuple_expression] = STATE(11242),
    [sym_curly_expression] = STATE(11242),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11242),
    [sym_index_expression] = STATE(11242),
    [sym_parametrized_type_expression] = STATE(11242),
    [sym_call_expression] = STATE(11242),
    [sym_broadcast_call_expression] = STATE(11242),
    [sym__closed_macrocall_expression] = STATE(11242),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11242),
    [sym_quote_expression] = STATE(11242),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12994),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11242),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11242),
    [sym_string_literal] = STATE(11242),
    [sym_command_literal] = STATE(11242),
    [sym_prefixed_string_literal] = STATE(11242),
    [sym_prefixed_command_literal] = STATE(11242),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3164),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1769] = {
    [sym_assignment] = STATE(7730),
    [sym_open_tuple] = STATE(7342),
    [sym__expression] = STATE(7274),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8706),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1770] = {
    [sym_assignment] = STATE(7733),
    [sym_open_tuple] = STATE(7343),
    [sym__expression] = STATE(7275),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8706),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1771] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(12637),
    [sym__expression] = STATE(12792),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10572),
    [sym__array] = STATE(10572),
    [sym_comprehension_expression] = STATE(10572),
    [sym_matrix_expression] = STATE(10572),
    [sym_vector_expression] = STATE(10572),
    [sym_parenthesized_expression] = STATE(10572),
    [sym_tuple_expression] = STATE(10572),
    [sym_curly_expression] = STATE(10572),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10572),
    [sym_index_expression] = STATE(10572),
    [sym_parametrized_type_expression] = STATE(10572),
    [sym_call_expression] = STATE(10572),
    [sym_broadcast_call_expression] = STATE(10572),
    [sym__closed_macrocall_expression] = STATE(10572),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10572),
    [sym_quote_expression] = STATE(10572),
    [sym_binary_expression] = STATE(12674),
    [sym_unary_expression] = STATE(12674),
    [sym_range_expression] = STATE(12674),
    [sym_splat_expression] = STATE(12674),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12045),
    [sym_unary_typed_expression] = STATE(12674),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12674),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10572),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10572),
    [sym_string_literal] = STATE(10572),
    [sym_command_literal] = STATE(10572),
    [sym_prefixed_string_literal] = STATE(10572),
    [sym_prefixed_command_literal] = STATE(10572),
    [sym_operator] = STATE(11874),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(8708),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1772] = {
    [sym_assignment] = STATE(7797),
    [sym_open_tuple] = STATE(19154),
    [sym__expression] = STATE(7282),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8706),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1773] = {
    [sym_assignment] = STATE(7891),
    [sym_open_tuple] = STATE(19154),
    [sym__expression] = STATE(7283),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8706),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1774] = {
    [sym_assignment] = STATE(8501),
    [sym_open_tuple] = STATE(8994),
    [sym__expression] = STATE(8743),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [1775] = {
    [sym_assignment] = STATE(8502),
    [sym_open_tuple] = STATE(8995),
    [sym__expression] = STATE(8744),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [1776] = {
    [sym_assignment] = STATE(12797),
    [sym_open_tuple] = STATE(12759),
    [sym__expression] = STATE(12811),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10761),
    [sym__array] = STATE(10761),
    [sym_comprehension_expression] = STATE(10761),
    [sym_matrix_expression] = STATE(10761),
    [sym_vector_expression] = STATE(10761),
    [sym_parenthesized_expression] = STATE(10761),
    [sym_tuple_expression] = STATE(10761),
    [sym_curly_expression] = STATE(10761),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10761),
    [sym_index_expression] = STATE(10761),
    [sym_parametrized_type_expression] = STATE(10761),
    [sym_call_expression] = STATE(10761),
    [sym_broadcast_call_expression] = STATE(10761),
    [sym__closed_macrocall_expression] = STATE(10761),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10761),
    [sym_quote_expression] = STATE(10761),
    [sym_binary_expression] = STATE(12424),
    [sym_unary_expression] = STATE(12424),
    [sym_range_expression] = STATE(12424),
    [sym_splat_expression] = STATE(12424),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11976),
    [sym_unary_typed_expression] = STATE(12424),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12424),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10761),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10761),
    [sym_string_literal] = STATE(10761),
    [sym_command_literal] = STATE(10761),
    [sym_prefixed_string_literal] = STATE(10761),
    [sym_prefixed_command_literal] = STATE(10761),
    [sym_operator] = STATE(11888),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(8710),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [1777] = {
    [sym_assignment] = STATE(8597),
    [sym_open_tuple] = STATE(19594),
    [sym__expression] = STATE(8753),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [1778] = {
    [sym_assignment] = STATE(18880),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13831),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1779] = {
    [sym_assignment] = STATE(8267),
    [sym_open_tuple] = STATE(19594),
    [sym__expression] = STATE(8754),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [1780] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(12630),
    [sym__expression] = STATE(12155),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(10566),
    [sym_comprehension_expression] = STATE(10566),
    [sym_matrix_expression] = STATE(10566),
    [sym_vector_expression] = STATE(10566),
    [sym_parenthesized_expression] = STATE(10566),
    [sym_tuple_expression] = STATE(10566),
    [sym_curly_expression] = STATE(10566),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10566),
    [sym_index_expression] = STATE(10566),
    [sym_parametrized_type_expression] = STATE(10566),
    [sym_call_expression] = STATE(10566),
    [sym_broadcast_call_expression] = STATE(10566),
    [sym__closed_macrocall_expression] = STATE(10566),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10566),
    [sym_quote_expression] = STATE(10566),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11966),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10566),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10566),
    [sym_string_literal] = STATE(10566),
    [sym_command_literal] = STATE(10566),
    [sym_prefixed_string_literal] = STATE(10566),
    [sym_prefixed_command_literal] = STATE(10566),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(8712),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1781] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(12632),
    [sym__expression] = STATE(12156),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(10566),
    [sym_comprehension_expression] = STATE(10566),
    [sym_matrix_expression] = STATE(10566),
    [sym_vector_expression] = STATE(10566),
    [sym_parenthesized_expression] = STATE(10566),
    [sym_tuple_expression] = STATE(10566),
    [sym_curly_expression] = STATE(10566),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10566),
    [sym_index_expression] = STATE(10566),
    [sym_parametrized_type_expression] = STATE(10566),
    [sym_call_expression] = STATE(10566),
    [sym_broadcast_call_expression] = STATE(10566),
    [sym__closed_macrocall_expression] = STATE(10566),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10566),
    [sym_quote_expression] = STATE(10566),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11966),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10566),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10566),
    [sym_string_literal] = STATE(10566),
    [sym_command_literal] = STATE(10566),
    [sym_prefixed_string_literal] = STATE(10566),
    [sym_prefixed_command_literal] = STATE(10566),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(8712),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1782] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(12982),
    [sym__expression] = STATE(13107),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11131),
    [sym__array] = STATE(11131),
    [sym_comprehension_expression] = STATE(11131),
    [sym_matrix_expression] = STATE(11131),
    [sym_vector_expression] = STATE(11131),
    [sym_parenthesized_expression] = STATE(11131),
    [sym_tuple_expression] = STATE(11131),
    [sym_curly_expression] = STATE(11131),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11131),
    [sym_index_expression] = STATE(11131),
    [sym_parametrized_type_expression] = STATE(11131),
    [sym_call_expression] = STATE(11131),
    [sym_broadcast_call_expression] = STATE(11131),
    [sym__closed_macrocall_expression] = STATE(11131),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11131),
    [sym_quote_expression] = STATE(11131),
    [sym_binary_expression] = STATE(13174),
    [sym_unary_expression] = STATE(13174),
    [sym_range_expression] = STATE(13174),
    [sym_splat_expression] = STATE(13174),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12720),
    [sym_unary_typed_expression] = STATE(13174),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13174),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11131),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11131),
    [sym_string_literal] = STATE(11131),
    [sym_command_literal] = STATE(11131),
    [sym_prefixed_string_literal] = STATE(11131),
    [sym_prefixed_command_literal] = STATE(11131),
    [sym_operator] = STATE(12722),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(8714),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1783] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(18466),
    [sym__expression] = STATE(12115),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(10566),
    [sym_comprehension_expression] = STATE(10566),
    [sym_matrix_expression] = STATE(10566),
    [sym_vector_expression] = STATE(10566),
    [sym_parenthesized_expression] = STATE(10566),
    [sym_tuple_expression] = STATE(10566),
    [sym_curly_expression] = STATE(10566),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10566),
    [sym_index_expression] = STATE(10566),
    [sym_parametrized_type_expression] = STATE(10566),
    [sym_call_expression] = STATE(10566),
    [sym_broadcast_call_expression] = STATE(10566),
    [sym__closed_macrocall_expression] = STATE(10566),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10566),
    [sym_quote_expression] = STATE(10566),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11966),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10566),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10566),
    [sym_string_literal] = STATE(10566),
    [sym_command_literal] = STATE(10566),
    [sym_prefixed_string_literal] = STATE(10566),
    [sym_prefixed_command_literal] = STATE(10566),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(8712),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1784] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(18466),
    [sym__expression] = STATE(12116),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(10566),
    [sym_comprehension_expression] = STATE(10566),
    [sym_matrix_expression] = STATE(10566),
    [sym_vector_expression] = STATE(10566),
    [sym_parenthesized_expression] = STATE(10566),
    [sym_tuple_expression] = STATE(10566),
    [sym_curly_expression] = STATE(10566),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10566),
    [sym_index_expression] = STATE(10566),
    [sym_parametrized_type_expression] = STATE(10566),
    [sym_call_expression] = STATE(10566),
    [sym_broadcast_call_expression] = STATE(10566),
    [sym__closed_macrocall_expression] = STATE(10566),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10566),
    [sym_quote_expression] = STATE(10566),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11966),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10566),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10566),
    [sym_string_literal] = STATE(10566),
    [sym_command_literal] = STATE(10566),
    [sym_prefixed_string_literal] = STATE(10566),
    [sym_prefixed_command_literal] = STATE(10566),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(8712),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1785] = {
    [sym_assignment] = STATE(12497),
    [sym_open_tuple] = STATE(12704),
    [sym__expression] = STATE(12113),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10677),
    [sym__array] = STATE(10677),
    [sym_comprehension_expression] = STATE(10677),
    [sym_matrix_expression] = STATE(10677),
    [sym_vector_expression] = STATE(10677),
    [sym_parenthesized_expression] = STATE(10677),
    [sym_tuple_expression] = STATE(10677),
    [sym_curly_expression] = STATE(10677),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10677),
    [sym_index_expression] = STATE(10677),
    [sym_parametrized_type_expression] = STATE(10677),
    [sym_call_expression] = STATE(10677),
    [sym_broadcast_call_expression] = STATE(10677),
    [sym__closed_macrocall_expression] = STATE(10677),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10677),
    [sym_quote_expression] = STATE(10677),
    [sym_binary_expression] = STATE(12304),
    [sym_unary_expression] = STATE(12304),
    [sym_range_expression] = STATE(12304),
    [sym_splat_expression] = STATE(12304),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11911),
    [sym_unary_typed_expression] = STATE(12304),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12304),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10677),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10677),
    [sym_string_literal] = STATE(10677),
    [sym_command_literal] = STATE(10677),
    [sym_prefixed_string_literal] = STATE(10677),
    [sym_prefixed_command_literal] = STATE(10677),
    [sym_operator] = STATE(12095),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(8716),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [1786] = {
    [sym_assignment] = STATE(12499),
    [sym_open_tuple] = STATE(12705),
    [sym__expression] = STATE(12114),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10677),
    [sym__array] = STATE(10677),
    [sym_comprehension_expression] = STATE(10677),
    [sym_matrix_expression] = STATE(10677),
    [sym_vector_expression] = STATE(10677),
    [sym_parenthesized_expression] = STATE(10677),
    [sym_tuple_expression] = STATE(10677),
    [sym_curly_expression] = STATE(10677),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10677),
    [sym_index_expression] = STATE(10677),
    [sym_parametrized_type_expression] = STATE(10677),
    [sym_call_expression] = STATE(10677),
    [sym_broadcast_call_expression] = STATE(10677),
    [sym__closed_macrocall_expression] = STATE(10677),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10677),
    [sym_quote_expression] = STATE(10677),
    [sym_binary_expression] = STATE(12304),
    [sym_unary_expression] = STATE(12304),
    [sym_range_expression] = STATE(12304),
    [sym_splat_expression] = STATE(12304),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11911),
    [sym_unary_typed_expression] = STATE(12304),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12304),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10677),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10677),
    [sym_string_literal] = STATE(10677),
    [sym_command_literal] = STATE(10677),
    [sym_prefixed_string_literal] = STATE(10677),
    [sym_prefixed_command_literal] = STATE(10677),
    [sym_operator] = STATE(12095),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(8716),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [1787] = {
    [sym_assignment] = STATE(8393),
    [sym_open_tuple] = STATE(8156),
    [sym__expression] = STATE(8097),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(8732),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [1788] = {
    [sym_assignment] = STATE(12597),
    [sym_open_tuple] = STATE(18726),
    [sym__expression] = STATE(12119),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10677),
    [sym__array] = STATE(10677),
    [sym_comprehension_expression] = STATE(10677),
    [sym_matrix_expression] = STATE(10677),
    [sym_vector_expression] = STATE(10677),
    [sym_parenthesized_expression] = STATE(10677),
    [sym_tuple_expression] = STATE(10677),
    [sym_curly_expression] = STATE(10677),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10677),
    [sym_index_expression] = STATE(10677),
    [sym_parametrized_type_expression] = STATE(10677),
    [sym_call_expression] = STATE(10677),
    [sym_broadcast_call_expression] = STATE(10677),
    [sym__closed_macrocall_expression] = STATE(10677),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10677),
    [sym_quote_expression] = STATE(10677),
    [sym_binary_expression] = STATE(12304),
    [sym_unary_expression] = STATE(12304),
    [sym_range_expression] = STATE(12304),
    [sym_splat_expression] = STATE(12304),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11911),
    [sym_unary_typed_expression] = STATE(12304),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12304),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10677),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10677),
    [sym_string_literal] = STATE(10677),
    [sym_command_literal] = STATE(10677),
    [sym_prefixed_string_literal] = STATE(10677),
    [sym_prefixed_command_literal] = STATE(10677),
    [sym_operator] = STATE(12095),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(8716),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [1789] = {
    [sym_assignment] = STATE(12695),
    [sym_open_tuple] = STATE(18726),
    [sym__expression] = STATE(12120),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10677),
    [sym__array] = STATE(10677),
    [sym_comprehension_expression] = STATE(10677),
    [sym_matrix_expression] = STATE(10677),
    [sym_vector_expression] = STATE(10677),
    [sym_parenthesized_expression] = STATE(10677),
    [sym_tuple_expression] = STATE(10677),
    [sym_curly_expression] = STATE(10677),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10677),
    [sym_index_expression] = STATE(10677),
    [sym_parametrized_type_expression] = STATE(10677),
    [sym_call_expression] = STATE(10677),
    [sym_broadcast_call_expression] = STATE(10677),
    [sym__closed_macrocall_expression] = STATE(10677),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10677),
    [sym_quote_expression] = STATE(10677),
    [sym_binary_expression] = STATE(12304),
    [sym_unary_expression] = STATE(12304),
    [sym_range_expression] = STATE(12304),
    [sym_splat_expression] = STATE(12304),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11911),
    [sym_unary_typed_expression] = STATE(12304),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12304),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10677),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10677),
    [sym_string_literal] = STATE(10677),
    [sym_command_literal] = STATE(10677),
    [sym_prefixed_string_literal] = STATE(10677),
    [sym_prefixed_command_literal] = STATE(10677),
    [sym_operator] = STATE(12095),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(8716),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [1790] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(13048),
    [sym__expression] = STATE(12835),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11137),
    [sym__array] = STATE(11137),
    [sym_comprehension_expression] = STATE(11137),
    [sym_matrix_expression] = STATE(11137),
    [sym_vector_expression] = STATE(11137),
    [sym_parenthesized_expression] = STATE(11137),
    [sym_tuple_expression] = STATE(11137),
    [sym_curly_expression] = STATE(11137),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11137),
    [sym_index_expression] = STATE(11137),
    [sym_parametrized_type_expression] = STATE(11137),
    [sym_call_expression] = STATE(11137),
    [sym_broadcast_call_expression] = STATE(11137),
    [sym__closed_macrocall_expression] = STATE(11137),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11137),
    [sym_quote_expression] = STATE(11137),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12260),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11137),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11137),
    [sym_string_literal] = STATE(11137),
    [sym_command_literal] = STATE(11137),
    [sym_prefixed_string_literal] = STATE(11137),
    [sym_prefixed_command_literal] = STATE(11137),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(8738),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1791] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(13049),
    [sym__expression] = STATE(12836),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11137),
    [sym__array] = STATE(11137),
    [sym_comprehension_expression] = STATE(11137),
    [sym_matrix_expression] = STATE(11137),
    [sym_vector_expression] = STATE(11137),
    [sym_parenthesized_expression] = STATE(11137),
    [sym_tuple_expression] = STATE(11137),
    [sym_curly_expression] = STATE(11137),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11137),
    [sym_index_expression] = STATE(11137),
    [sym_parametrized_type_expression] = STATE(11137),
    [sym_call_expression] = STATE(11137),
    [sym_broadcast_call_expression] = STATE(11137),
    [sym__closed_macrocall_expression] = STATE(11137),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11137),
    [sym_quote_expression] = STATE(11137),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12260),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11137),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11137),
    [sym_string_literal] = STATE(11137),
    [sym_command_literal] = STATE(11137),
    [sym_prefixed_string_literal] = STATE(11137),
    [sym_prefixed_command_literal] = STATE(11137),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(8738),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1792] = {
    [sym_assignment] = STATE(12039),
    [sym_open_tuple] = STATE(13433),
    [sym__expression] = STATE(13050),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11242),
    [sym__array] = STATE(11242),
    [sym_comprehension_expression] = STATE(11242),
    [sym_matrix_expression] = STATE(11242),
    [sym_vector_expression] = STATE(11242),
    [sym_parenthesized_expression] = STATE(11242),
    [sym_tuple_expression] = STATE(11242),
    [sym_curly_expression] = STATE(11242),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11242),
    [sym_index_expression] = STATE(11242),
    [sym_parametrized_type_expression] = STATE(11242),
    [sym_call_expression] = STATE(11242),
    [sym_broadcast_call_expression] = STATE(11242),
    [sym__closed_macrocall_expression] = STATE(11242),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11242),
    [sym_quote_expression] = STATE(11242),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12994),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11242),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11242),
    [sym_string_literal] = STATE(11242),
    [sym_command_literal] = STATE(11242),
    [sym_prefixed_string_literal] = STATE(11242),
    [sym_prefixed_command_literal] = STATE(11242),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3164),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1793] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(19529),
    [sym__expression] = STATE(12822),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11137),
    [sym__array] = STATE(11137),
    [sym_comprehension_expression] = STATE(11137),
    [sym_matrix_expression] = STATE(11137),
    [sym_vector_expression] = STATE(11137),
    [sym_parenthesized_expression] = STATE(11137),
    [sym_tuple_expression] = STATE(11137),
    [sym_curly_expression] = STATE(11137),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11137),
    [sym_index_expression] = STATE(11137),
    [sym_parametrized_type_expression] = STATE(11137),
    [sym_call_expression] = STATE(11137),
    [sym_broadcast_call_expression] = STATE(11137),
    [sym__closed_macrocall_expression] = STATE(11137),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11137),
    [sym_quote_expression] = STATE(11137),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12260),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11137),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11137),
    [sym_string_literal] = STATE(11137),
    [sym_command_literal] = STATE(11137),
    [sym_prefixed_string_literal] = STATE(11137),
    [sym_prefixed_command_literal] = STATE(11137),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(8738),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1794] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(19529),
    [sym__expression] = STATE(12823),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11137),
    [sym__array] = STATE(11137),
    [sym_comprehension_expression] = STATE(11137),
    [sym_matrix_expression] = STATE(11137),
    [sym_vector_expression] = STATE(11137),
    [sym_parenthesized_expression] = STATE(11137),
    [sym_tuple_expression] = STATE(11137),
    [sym_curly_expression] = STATE(11137),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11137),
    [sym_index_expression] = STATE(11137),
    [sym_parametrized_type_expression] = STATE(11137),
    [sym_call_expression] = STATE(11137),
    [sym_broadcast_call_expression] = STATE(11137),
    [sym__closed_macrocall_expression] = STATE(11137),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11137),
    [sym_quote_expression] = STATE(11137),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12260),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11137),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11137),
    [sym_string_literal] = STATE(11137),
    [sym_command_literal] = STATE(11137),
    [sym_prefixed_string_literal] = STATE(11137),
    [sym_prefixed_command_literal] = STATE(11137),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(8738),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1795] = {
    [sym_assignment] = STATE(8287),
    [sym_open_tuple] = STATE(8644),
    [sym__expression] = STATE(8087),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(8732),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [1796] = {
    [sym_assignment] = STATE(8291),
    [sym_open_tuple] = STATE(8645),
    [sym__expression] = STATE(8088),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(8732),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [1797] = {
    [sym_assignment] = STATE(8395),
    [sym_open_tuple] = STATE(18808),
    [sym__expression] = STATE(8099),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(8732),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [1798] = {
    [sym_assignment] = STATE(8488),
    [sym_open_tuple] = STATE(18808),
    [sym__expression] = STATE(8100),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5615),
    [sym__array] = STATE(5615),
    [sym_comprehension_expression] = STATE(5615),
    [sym_matrix_expression] = STATE(5615),
    [sym_vector_expression] = STATE(5615),
    [sym_parenthesized_expression] = STATE(5615),
    [sym_tuple_expression] = STATE(5615),
    [sym_curly_expression] = STATE(5615),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5615),
    [sym_index_expression] = STATE(5615),
    [sym_parametrized_type_expression] = STATE(5615),
    [sym_call_expression] = STATE(5615),
    [sym_broadcast_call_expression] = STATE(5615),
    [sym__closed_macrocall_expression] = STATE(5615),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5615),
    [sym_quote_expression] = STATE(5615),
    [sym_binary_expression] = STATE(8383),
    [sym_unary_expression] = STATE(8383),
    [sym_range_expression] = STATE(8383),
    [sym_splat_expression] = STATE(8383),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7390),
    [sym_unary_typed_expression] = STATE(8383),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8383),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5615),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5615),
    [sym_string_literal] = STATE(5615),
    [sym_command_literal] = STATE(5615),
    [sym_prefixed_string_literal] = STATE(5615),
    [sym_prefixed_command_literal] = STATE(5615),
    [sym_operator] = STATE(7345),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(8732),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [1799] = {
    [sym_assignment] = STATE(8501),
    [sym_open_tuple] = STATE(9177),
    [sym__expression] = STATE(9135),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [1800] = {
    [sym_assignment] = STATE(8502),
    [sym_open_tuple] = STATE(9178),
    [sym__expression] = STATE(9136),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [1801] = {
    [sym_assignment] = STATE(7556),
    [sym_open_tuple] = STATE(7396),
    [sym__expression] = STATE(7286),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(8754),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [1802] = {
    [sym_assignment] = STATE(8597),
    [sym_open_tuple] = STATE(18750),
    [sym__expression] = STATE(9123),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [1803] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(14717),
    [sym__expression] = STATE(12576),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1804] = {
    [sym_assignment] = STATE(8267),
    [sym_open_tuple] = STATE(18750),
    [sym__expression] = STATE(9124),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6583),
    [sym__array] = STATE(6583),
    [sym_comprehension_expression] = STATE(6583),
    [sym_matrix_expression] = STATE(6583),
    [sym_vector_expression] = STATE(6583),
    [sym_parenthesized_expression] = STATE(6583),
    [sym_tuple_expression] = STATE(6583),
    [sym_curly_expression] = STATE(6583),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6583),
    [sym_index_expression] = STATE(6583),
    [sym_parametrized_type_expression] = STATE(6583),
    [sym_call_expression] = STATE(6583),
    [sym_broadcast_call_expression] = STATE(6583),
    [sym__closed_macrocall_expression] = STATE(6583),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6583),
    [sym_quote_expression] = STATE(6583),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9047),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6583),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6583),
    [sym_string_literal] = STATE(6583),
    [sym_command_literal] = STATE(6583),
    [sym_prefixed_string_literal] = STATE(6583),
    [sym_prefixed_command_literal] = STATE(6583),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1157),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [1805] = {
    [sym_assignment] = STATE(7543),
    [sym_open_tuple] = STATE(19661),
    [sym__expression] = STATE(7703),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8658),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1806] = {
    [sym_assignment] = STATE(7386),
    [sym_open_tuple] = STATE(8047),
    [sym__expression] = STATE(7279),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(8754),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [1807] = {
    [sym_assignment] = STATE(7388),
    [sym_open_tuple] = STATE(8048),
    [sym__expression] = STATE(7280),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(8754),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [1808] = {
    [sym_assignment] = STATE(8171),
    [sym_open_tuple] = STATE(8331),
    [sym__expression] = STATE(8098),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(8774),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [1809] = {
    [sym_assignment] = STATE(7446),
    [sym_open_tuple] = STATE(18370),
    [sym__expression] = STATE(7287),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(8754),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [1810] = {
    [sym_assignment] = STATE(7493),
    [sym_open_tuple] = STATE(18370),
    [sym__expression] = STATE(7032),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4845),
    [sym__array] = STATE(4845),
    [sym_comprehension_expression] = STATE(4845),
    [sym_matrix_expression] = STATE(4845),
    [sym_vector_expression] = STATE(4845),
    [sym_parenthesized_expression] = STATE(4845),
    [sym_tuple_expression] = STATE(4845),
    [sym_curly_expression] = STATE(4845),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4845),
    [sym_index_expression] = STATE(4845),
    [sym_parametrized_type_expression] = STATE(4845),
    [sym_call_expression] = STATE(4845),
    [sym_broadcast_call_expression] = STATE(4845),
    [sym__closed_macrocall_expression] = STATE(4845),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4845),
    [sym_quote_expression] = STATE(4845),
    [sym_binary_expression] = STATE(7364),
    [sym_unary_expression] = STATE(7364),
    [sym_range_expression] = STATE(7364),
    [sym_splat_expression] = STATE(7364),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6943),
    [sym_unary_typed_expression] = STATE(7364),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7364),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4845),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4845),
    [sym_string_literal] = STATE(4845),
    [sym_command_literal] = STATE(4845),
    [sym_prefixed_string_literal] = STATE(4845),
    [sym_prefixed_command_literal] = STATE(4845),
    [sym_operator] = STATE(6907),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(8754),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [1811] = {
    [sym_assignment] = STATE(8440),
    [sym_open_tuple] = STATE(8668),
    [sym__expression] = STATE(8092),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(8774),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [1812] = {
    [sym_assignment] = STATE(8442),
    [sym_open_tuple] = STATE(8669),
    [sym__expression] = STATE(8093),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(8774),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [1813] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(13008),
    [sym__expression] = STATE(12916),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11073),
    [sym__array] = STATE(11073),
    [sym_comprehension_expression] = STATE(11073),
    [sym_matrix_expression] = STATE(11073),
    [sym_vector_expression] = STATE(11073),
    [sym_parenthesized_expression] = STATE(11073),
    [sym_tuple_expression] = STATE(11073),
    [sym_curly_expression] = STATE(11073),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11073),
    [sym_index_expression] = STATE(11073),
    [sym_parametrized_type_expression] = STATE(11073),
    [sym_call_expression] = STATE(11073),
    [sym_broadcast_call_expression] = STATE(11073),
    [sym__closed_macrocall_expression] = STATE(11073),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11073),
    [sym_quote_expression] = STATE(11073),
    [sym_binary_expression] = STATE(13022),
    [sym_unary_expression] = STATE(13022),
    [sym_range_expression] = STATE(13022),
    [sym_splat_expression] = STATE(13022),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12814),
    [sym_unary_typed_expression] = STATE(13022),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13022),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11073),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11073),
    [sym_string_literal] = STATE(11073),
    [sym_command_literal] = STATE(11073),
    [sym_prefixed_string_literal] = STATE(11073),
    [sym_prefixed_command_literal] = STATE(11073),
    [sym_operator] = STATE(12815),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(8780),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1814] = {
    [sym_assignment] = STATE(8507),
    [sym_open_tuple] = STATE(19049),
    [sym__expression] = STATE(8102),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(8774),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [1815] = {
    [sym_assignment] = STATE(8582),
    [sym_open_tuple] = STATE(19049),
    [sym__expression] = STATE(8103),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5906),
    [sym__array] = STATE(5906),
    [sym_comprehension_expression] = STATE(5906),
    [sym_matrix_expression] = STATE(5906),
    [sym_vector_expression] = STATE(5906),
    [sym_parenthesized_expression] = STATE(5906),
    [sym_tuple_expression] = STATE(5906),
    [sym_curly_expression] = STATE(5906),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5906),
    [sym_index_expression] = STATE(5906),
    [sym_parametrized_type_expression] = STATE(5906),
    [sym_call_expression] = STATE(5906),
    [sym_broadcast_call_expression] = STATE(5906),
    [sym__closed_macrocall_expression] = STATE(5906),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5906),
    [sym_quote_expression] = STATE(5906),
    [sym_binary_expression] = STATE(8278),
    [sym_unary_expression] = STATE(8278),
    [sym_range_expression] = STATE(8278),
    [sym_splat_expression] = STATE(8278),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7593),
    [sym_unary_typed_expression] = STATE(8278),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8278),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5906),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5906),
    [sym_string_literal] = STATE(5906),
    [sym_command_literal] = STATE(5906),
    [sym_prefixed_string_literal] = STATE(5906),
    [sym_prefixed_command_literal] = STATE(5906),
    [sym_operator] = STATE(7391),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(8774),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [1816] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(12968),
    [sym__expression] = STATE(12838),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10969),
    [sym__array] = STATE(10969),
    [sym_comprehension_expression] = STATE(10969),
    [sym_matrix_expression] = STATE(10969),
    [sym_vector_expression] = STATE(10969),
    [sym_parenthesized_expression] = STATE(10969),
    [sym_tuple_expression] = STATE(10969),
    [sym_curly_expression] = STATE(10969),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(10969),
    [sym_index_expression] = STATE(10969),
    [sym_parametrized_type_expression] = STATE(10969),
    [sym_call_expression] = STATE(10969),
    [sym_broadcast_call_expression] = STATE(10969),
    [sym__closed_macrocall_expression] = STATE(10969),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(10969),
    [sym_quote_expression] = STATE(10969),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(10969),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(10969),
    [sym_string_literal] = STATE(10969),
    [sym_command_literal] = STATE(10969),
    [sym_prefixed_string_literal] = STATE(10969),
    [sym_prefixed_command_literal] = STATE(10969),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(8782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1817] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(12969),
    [sym__expression] = STATE(12839),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10969),
    [sym__array] = STATE(10969),
    [sym_comprehension_expression] = STATE(10969),
    [sym_matrix_expression] = STATE(10969),
    [sym_vector_expression] = STATE(10969),
    [sym_parenthesized_expression] = STATE(10969),
    [sym_tuple_expression] = STATE(10969),
    [sym_curly_expression] = STATE(10969),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(10969),
    [sym_index_expression] = STATE(10969),
    [sym_parametrized_type_expression] = STATE(10969),
    [sym_call_expression] = STATE(10969),
    [sym_broadcast_call_expression] = STATE(10969),
    [sym__closed_macrocall_expression] = STATE(10969),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(10969),
    [sym_quote_expression] = STATE(10969),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(10969),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(10969),
    [sym_string_literal] = STATE(10969),
    [sym_command_literal] = STATE(10969),
    [sym_prefixed_string_literal] = STATE(10969),
    [sym_prefixed_command_literal] = STATE(10969),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(8782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1818] = {
    [sym_assignment] = STATE(8257),
    [sym_open_tuple] = STATE(8332),
    [sym__expression] = STATE(8101),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(8798),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [1819] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(19799),
    [sym__expression] = STATE(12824),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10969),
    [sym__array] = STATE(10969),
    [sym_comprehension_expression] = STATE(10969),
    [sym_matrix_expression] = STATE(10969),
    [sym_vector_expression] = STATE(10969),
    [sym_parenthesized_expression] = STATE(10969),
    [sym_tuple_expression] = STATE(10969),
    [sym_curly_expression] = STATE(10969),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(10969),
    [sym_index_expression] = STATE(10969),
    [sym_parametrized_type_expression] = STATE(10969),
    [sym_call_expression] = STATE(10969),
    [sym_broadcast_call_expression] = STATE(10969),
    [sym__closed_macrocall_expression] = STATE(10969),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(10969),
    [sym_quote_expression] = STATE(10969),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(10969),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(10969),
    [sym_string_literal] = STATE(10969),
    [sym_command_literal] = STATE(10969),
    [sym_prefixed_string_literal] = STATE(10969),
    [sym_prefixed_command_literal] = STATE(10969),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(8782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1820] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(19799),
    [sym__expression] = STATE(12825),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10969),
    [sym__array] = STATE(10969),
    [sym_comprehension_expression] = STATE(10969),
    [sym_matrix_expression] = STATE(10969),
    [sym_vector_expression] = STATE(10969),
    [sym_parenthesized_expression] = STATE(10969),
    [sym_tuple_expression] = STATE(10969),
    [sym_curly_expression] = STATE(10969),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(10969),
    [sym_index_expression] = STATE(10969),
    [sym_parametrized_type_expression] = STATE(10969),
    [sym_call_expression] = STATE(10969),
    [sym_broadcast_call_expression] = STATE(10969),
    [sym__closed_macrocall_expression] = STATE(10969),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(10969),
    [sym_quote_expression] = STATE(10969),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(10969),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(10969),
    [sym_string_literal] = STATE(10969),
    [sym_command_literal] = STATE(10969),
    [sym_prefixed_string_literal] = STATE(10969),
    [sym_prefixed_command_literal] = STATE(10969),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(8782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1821] = {
    [sym_assignment] = STATE(11883),
    [sym_open_tuple] = STATE(13496),
    [sym__expression] = STATE(13376),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11391),
    [sym__array] = STATE(11391),
    [sym_comprehension_expression] = STATE(11391),
    [sym_matrix_expression] = STATE(11391),
    [sym_vector_expression] = STATE(11391),
    [sym_parenthesized_expression] = STATE(11391),
    [sym_tuple_expression] = STATE(11391),
    [sym_curly_expression] = STATE(11391),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11391),
    [sym_index_expression] = STATE(11391),
    [sym_parametrized_type_expression] = STATE(11391),
    [sym_call_expression] = STATE(11391),
    [sym_broadcast_call_expression] = STATE(11391),
    [sym__closed_macrocall_expression] = STATE(11391),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11391),
    [sym_quote_expression] = STATE(11391),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13432),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11391),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11391),
    [sym_string_literal] = STATE(11391),
    [sym_command_literal] = STATE(11391),
    [sym_prefixed_string_literal] = STATE(11391),
    [sym_prefixed_command_literal] = STATE(11391),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3352),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1822] = {
    [sym_assignment] = STATE(11884),
    [sym_open_tuple] = STATE(13497),
    [sym__expression] = STATE(13377),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11391),
    [sym__array] = STATE(11391),
    [sym_comprehension_expression] = STATE(11391),
    [sym_matrix_expression] = STATE(11391),
    [sym_vector_expression] = STATE(11391),
    [sym_parenthesized_expression] = STATE(11391),
    [sym_tuple_expression] = STATE(11391),
    [sym_curly_expression] = STATE(11391),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11391),
    [sym_index_expression] = STATE(11391),
    [sym_parametrized_type_expression] = STATE(11391),
    [sym_call_expression] = STATE(11391),
    [sym_broadcast_call_expression] = STATE(11391),
    [sym__closed_macrocall_expression] = STATE(11391),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11391),
    [sym_quote_expression] = STATE(11391),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13432),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11391),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11391),
    [sym_string_literal] = STATE(11391),
    [sym_command_literal] = STATE(11391),
    [sym_prefixed_string_literal] = STATE(11391),
    [sym_prefixed_command_literal] = STATE(11391),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3352),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1823] = {
    [sym_assignment] = STATE(12039),
    [sym_open_tuple] = STATE(13476),
    [sym__expression] = STATE(13356),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11391),
    [sym__array] = STATE(11391),
    [sym_comprehension_expression] = STATE(11391),
    [sym_matrix_expression] = STATE(11391),
    [sym_vector_expression] = STATE(11391),
    [sym_parenthesized_expression] = STATE(11391),
    [sym_tuple_expression] = STATE(11391),
    [sym_curly_expression] = STATE(11391),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11391),
    [sym_index_expression] = STATE(11391),
    [sym_parametrized_type_expression] = STATE(11391),
    [sym_call_expression] = STATE(11391),
    [sym_broadcast_call_expression] = STATE(11391),
    [sym__closed_macrocall_expression] = STATE(11391),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11391),
    [sym_quote_expression] = STATE(11391),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13432),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11391),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11391),
    [sym_string_literal] = STATE(11391),
    [sym_command_literal] = STATE(11391),
    [sym_prefixed_string_literal] = STATE(11391),
    [sym_prefixed_command_literal] = STATE(11391),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3352),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1824] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(18977),
    [sym__expression] = STATE(13358),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11391),
    [sym__array] = STATE(11391),
    [sym_comprehension_expression] = STATE(11391),
    [sym_matrix_expression] = STATE(11391),
    [sym_vector_expression] = STATE(11391),
    [sym_parenthesized_expression] = STATE(11391),
    [sym_tuple_expression] = STATE(11391),
    [sym_curly_expression] = STATE(11391),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11391),
    [sym_index_expression] = STATE(11391),
    [sym_parametrized_type_expression] = STATE(11391),
    [sym_call_expression] = STATE(11391),
    [sym_broadcast_call_expression] = STATE(11391),
    [sym__closed_macrocall_expression] = STATE(11391),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11391),
    [sym_quote_expression] = STATE(11391),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13432),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11391),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11391),
    [sym_string_literal] = STATE(11391),
    [sym_command_literal] = STATE(11391),
    [sym_prefixed_string_literal] = STATE(11391),
    [sym_prefixed_command_literal] = STATE(11391),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3352),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1825] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(18977),
    [sym__expression] = STATE(13359),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11391),
    [sym__array] = STATE(11391),
    [sym_comprehension_expression] = STATE(11391),
    [sym_matrix_expression] = STATE(11391),
    [sym_vector_expression] = STATE(11391),
    [sym_parenthesized_expression] = STATE(11391),
    [sym_tuple_expression] = STATE(11391),
    [sym_curly_expression] = STATE(11391),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11391),
    [sym_index_expression] = STATE(11391),
    [sym_parametrized_type_expression] = STATE(11391),
    [sym_call_expression] = STATE(11391),
    [sym_broadcast_call_expression] = STATE(11391),
    [sym__closed_macrocall_expression] = STATE(11391),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11391),
    [sym_quote_expression] = STATE(11391),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13432),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11391),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11391),
    [sym_string_literal] = STATE(11391),
    [sym_command_literal] = STATE(11391),
    [sym_prefixed_string_literal] = STATE(11391),
    [sym_prefixed_command_literal] = STATE(11391),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3352),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1826] = {
    [sym_assignment] = STATE(8710),
    [sym_open_tuple] = STATE(8672),
    [sym__expression] = STATE(8095),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(8798),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [1827] = {
    [sym_assignment] = STATE(8725),
    [sym_open_tuple] = STATE(8673),
    [sym__expression] = STATE(8096),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(8798),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [1828] = {
    [sym_assignment] = STATE(12039),
    [sym_open_tuple] = STATE(13510),
    [sym__expression] = STATE(13357),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11387),
    [sym__array] = STATE(11387),
    [sym_comprehension_expression] = STATE(11387),
    [sym_matrix_expression] = STATE(11387),
    [sym_vector_expression] = STATE(11387),
    [sym_parenthesized_expression] = STATE(11387),
    [sym_tuple_expression] = STATE(11387),
    [sym_curly_expression] = STATE(11387),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11387),
    [sym_index_expression] = STATE(11387),
    [sym_parametrized_type_expression] = STATE(11387),
    [sym_call_expression] = STATE(11387),
    [sym_broadcast_call_expression] = STATE(11387),
    [sym__closed_macrocall_expression] = STATE(11387),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11387),
    [sym_quote_expression] = STATE(11387),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13333),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11387),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11387),
    [sym_string_literal] = STATE(11387),
    [sym_command_literal] = STATE(11387),
    [sym_prefixed_string_literal] = STATE(11387),
    [sym_prefixed_command_literal] = STATE(11387),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3045),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1829] = {
    [sym_assignment] = STATE(8769),
    [sym_open_tuple] = STATE(18958),
    [sym__expression] = STATE(8104),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(8798),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [1830] = {
    [sym_assignment] = STATE(8225),
    [sym_open_tuple] = STATE(18958),
    [sym__expression] = STATE(8105),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5307),
    [sym__array] = STATE(5307),
    [sym_comprehension_expression] = STATE(5307),
    [sym_matrix_expression] = STATE(5307),
    [sym_vector_expression] = STATE(5307),
    [sym_parenthesized_expression] = STATE(5307),
    [sym_tuple_expression] = STATE(5307),
    [sym_curly_expression] = STATE(5307),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5307),
    [sym_index_expression] = STATE(5307),
    [sym_parametrized_type_expression] = STATE(5307),
    [sym_call_expression] = STATE(5307),
    [sym_broadcast_call_expression] = STATE(5307),
    [sym__closed_macrocall_expression] = STATE(5307),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5307),
    [sym_quote_expression] = STATE(5307),
    [sym_binary_expression] = STATE(8391),
    [sym_unary_expression] = STATE(8391),
    [sym_range_expression] = STATE(8391),
    [sym_splat_expression] = STATE(8391),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7653),
    [sym_unary_typed_expression] = STATE(8391),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8391),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5307),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5307),
    [sym_string_literal] = STATE(5307),
    [sym_command_literal] = STATE(5307),
    [sym_prefixed_string_literal] = STATE(5307),
    [sym_prefixed_command_literal] = STATE(5307),
    [sym_operator] = STATE(7466),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(8798),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [1831] = {
    [sym_assignment] = STATE(11883),
    [sym_open_tuple] = STATE(13441),
    [sym__expression] = STATE(13379),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11387),
    [sym__array] = STATE(11387),
    [sym_comprehension_expression] = STATE(11387),
    [sym_matrix_expression] = STATE(11387),
    [sym_vector_expression] = STATE(11387),
    [sym_parenthesized_expression] = STATE(11387),
    [sym_tuple_expression] = STATE(11387),
    [sym_curly_expression] = STATE(11387),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11387),
    [sym_index_expression] = STATE(11387),
    [sym_parametrized_type_expression] = STATE(11387),
    [sym_call_expression] = STATE(11387),
    [sym_broadcast_call_expression] = STATE(11387),
    [sym__closed_macrocall_expression] = STATE(11387),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11387),
    [sym_quote_expression] = STATE(11387),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13333),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11387),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11387),
    [sym_string_literal] = STATE(11387),
    [sym_command_literal] = STATE(11387),
    [sym_prefixed_string_literal] = STATE(11387),
    [sym_prefixed_command_literal] = STATE(11387),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3045),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1832] = {
    [sym_assignment] = STATE(11884),
    [sym_open_tuple] = STATE(13443),
    [sym__expression] = STATE(13380),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11387),
    [sym__array] = STATE(11387),
    [sym_comprehension_expression] = STATE(11387),
    [sym_matrix_expression] = STATE(11387),
    [sym_vector_expression] = STATE(11387),
    [sym_parenthesized_expression] = STATE(11387),
    [sym_tuple_expression] = STATE(11387),
    [sym_curly_expression] = STATE(11387),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11387),
    [sym_index_expression] = STATE(11387),
    [sym_parametrized_type_expression] = STATE(11387),
    [sym_call_expression] = STATE(11387),
    [sym_broadcast_call_expression] = STATE(11387),
    [sym__closed_macrocall_expression] = STATE(11387),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11387),
    [sym_quote_expression] = STATE(11387),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13333),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11387),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11387),
    [sym_string_literal] = STATE(11387),
    [sym_command_literal] = STATE(11387),
    [sym_prefixed_string_literal] = STATE(11387),
    [sym_prefixed_command_literal] = STATE(11387),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3045),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1833] = {
    [sym_assignment] = STATE(12422),
    [sym_open_tuple] = STATE(12423),
    [sym__expression] = STATE(12134),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10916),
    [sym__array] = STATE(10916),
    [sym_comprehension_expression] = STATE(10916),
    [sym_matrix_expression] = STATE(10916),
    [sym_vector_expression] = STATE(10916),
    [sym_parenthesized_expression] = STATE(10916),
    [sym_tuple_expression] = STATE(10916),
    [sym_curly_expression] = STATE(10916),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10916),
    [sym_index_expression] = STATE(10916),
    [sym_parametrized_type_expression] = STATE(10916),
    [sym_call_expression] = STATE(10916),
    [sym_broadcast_call_expression] = STATE(10916),
    [sym__closed_macrocall_expression] = STATE(10916),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10916),
    [sym_quote_expression] = STATE(10916),
    [sym_binary_expression] = STATE(12715),
    [sym_unary_expression] = STATE(12715),
    [sym_range_expression] = STATE(12715),
    [sym_splat_expression] = STATE(12715),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12109),
    [sym_unary_typed_expression] = STATE(12715),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12715),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10916),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10916),
    [sym_string_literal] = STATE(10916),
    [sym_command_literal] = STATE(10916),
    [sym_prefixed_string_literal] = STATE(10916),
    [sym_prefixed_command_literal] = STATE(10916),
    [sym_operator] = STATE(11913),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8804),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [1834] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(19269),
    [sym__expression] = STATE(13360),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11387),
    [sym__array] = STATE(11387),
    [sym_comprehension_expression] = STATE(11387),
    [sym_matrix_expression] = STATE(11387),
    [sym_vector_expression] = STATE(11387),
    [sym_parenthesized_expression] = STATE(11387),
    [sym_tuple_expression] = STATE(11387),
    [sym_curly_expression] = STATE(11387),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11387),
    [sym_index_expression] = STATE(11387),
    [sym_parametrized_type_expression] = STATE(11387),
    [sym_call_expression] = STATE(11387),
    [sym_broadcast_call_expression] = STATE(11387),
    [sym__closed_macrocall_expression] = STATE(11387),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11387),
    [sym_quote_expression] = STATE(11387),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13333),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11387),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11387),
    [sym_string_literal] = STATE(11387),
    [sym_command_literal] = STATE(11387),
    [sym_prefixed_string_literal] = STATE(11387),
    [sym_prefixed_command_literal] = STATE(11387),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3045),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1835] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(19269),
    [sym__expression] = STATE(13361),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11387),
    [sym__array] = STATE(11387),
    [sym_comprehension_expression] = STATE(11387),
    [sym_matrix_expression] = STATE(11387),
    [sym_vector_expression] = STATE(11387),
    [sym_parenthesized_expression] = STATE(11387),
    [sym_tuple_expression] = STATE(11387),
    [sym_curly_expression] = STATE(11387),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11387),
    [sym_index_expression] = STATE(11387),
    [sym_parametrized_type_expression] = STATE(11387),
    [sym_call_expression] = STATE(11387),
    [sym_broadcast_call_expression] = STATE(11387),
    [sym__closed_macrocall_expression] = STATE(11387),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11387),
    [sym_quote_expression] = STATE(11387),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13333),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11387),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11387),
    [sym_string_literal] = STATE(11387),
    [sym_command_literal] = STATE(11387),
    [sym_prefixed_string_literal] = STATE(11387),
    [sym_prefixed_command_literal] = STATE(11387),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3045),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1836] = {
    [sym_assignment] = STATE(12796),
    [sym_open_tuple] = STATE(12701),
    [sym__expression] = STATE(12102),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10916),
    [sym__array] = STATE(10916),
    [sym_comprehension_expression] = STATE(10916),
    [sym_matrix_expression] = STATE(10916),
    [sym_vector_expression] = STATE(10916),
    [sym_parenthesized_expression] = STATE(10916),
    [sym_tuple_expression] = STATE(10916),
    [sym_curly_expression] = STATE(10916),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10916),
    [sym_index_expression] = STATE(10916),
    [sym_parametrized_type_expression] = STATE(10916),
    [sym_call_expression] = STATE(10916),
    [sym_broadcast_call_expression] = STATE(10916),
    [sym__closed_macrocall_expression] = STATE(10916),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10916),
    [sym_quote_expression] = STATE(10916),
    [sym_binary_expression] = STATE(12715),
    [sym_unary_expression] = STATE(12715),
    [sym_range_expression] = STATE(12715),
    [sym_splat_expression] = STATE(12715),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12109),
    [sym_unary_typed_expression] = STATE(12715),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12715),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10916),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10916),
    [sym_string_literal] = STATE(10916),
    [sym_command_literal] = STATE(10916),
    [sym_prefixed_string_literal] = STATE(10916),
    [sym_prefixed_command_literal] = STATE(10916),
    [sym_operator] = STATE(11913),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8804),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [1837] = {
    [sym_assignment] = STATE(12799),
    [sym_open_tuple] = STATE(12702),
    [sym__expression] = STATE(12103),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10916),
    [sym__array] = STATE(10916),
    [sym_comprehension_expression] = STATE(10916),
    [sym_matrix_expression] = STATE(10916),
    [sym_vector_expression] = STATE(10916),
    [sym_parenthesized_expression] = STATE(10916),
    [sym_tuple_expression] = STATE(10916),
    [sym_curly_expression] = STATE(10916),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10916),
    [sym_index_expression] = STATE(10916),
    [sym_parametrized_type_expression] = STATE(10916),
    [sym_call_expression] = STATE(10916),
    [sym_broadcast_call_expression] = STATE(10916),
    [sym__closed_macrocall_expression] = STATE(10916),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10916),
    [sym_quote_expression] = STATE(10916),
    [sym_binary_expression] = STATE(12715),
    [sym_unary_expression] = STATE(12715),
    [sym_range_expression] = STATE(12715),
    [sym_splat_expression] = STATE(12715),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12109),
    [sym_unary_typed_expression] = STATE(12715),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12715),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10916),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10916),
    [sym_string_literal] = STATE(10916),
    [sym_command_literal] = STATE(10916),
    [sym_prefixed_string_literal] = STATE(10916),
    [sym_prefixed_command_literal] = STATE(10916),
    [sym_operator] = STATE(11913),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8804),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [1838] = {
    [sym_assignment] = STATE(8989),
    [sym_open_tuple] = STATE(8972),
    [sym__expression] = STATE(8764),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8806),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [1839] = {
    [sym_assignment] = STATE(12287),
    [sym_open_tuple] = STATE(18277),
    [sym__expression] = STATE(12581),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10619),
    [sym__array] = STATE(10619),
    [sym_comprehension_expression] = STATE(10619),
    [sym_matrix_expression] = STATE(10619),
    [sym_vector_expression] = STATE(10619),
    [sym_parenthesized_expression] = STATE(10619),
    [sym_tuple_expression] = STATE(10619),
    [sym_curly_expression] = STATE(10619),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10619),
    [sym_index_expression] = STATE(10619),
    [sym_parametrized_type_expression] = STATE(10619),
    [sym_call_expression] = STATE(10619),
    [sym_broadcast_call_expression] = STATE(10619),
    [sym__closed_macrocall_expression] = STATE(10619),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(10619),
    [sym_quote_expression] = STATE(10619),
    [sym_binary_expression] = STATE(12555),
    [sym_unary_expression] = STATE(12555),
    [sym_range_expression] = STATE(12555),
    [sym_splat_expression] = STATE(12555),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12201),
    [sym_unary_typed_expression] = STATE(12555),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12555),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(10619),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10619),
    [sym_string_literal] = STATE(10619),
    [sym_command_literal] = STATE(10619),
    [sym_prefixed_string_literal] = STATE(10619),
    [sym_prefixed_command_literal] = STATE(10619),
    [sym_operator] = STATE(12161),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8568),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [1840] = {
    [sym_assignment] = STATE(12340),
    [sym_open_tuple] = STATE(18277),
    [sym__expression] = STATE(12614),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10619),
    [sym__array] = STATE(10619),
    [sym_comprehension_expression] = STATE(10619),
    [sym_matrix_expression] = STATE(10619),
    [sym_vector_expression] = STATE(10619),
    [sym_parenthesized_expression] = STATE(10619),
    [sym_tuple_expression] = STATE(10619),
    [sym_curly_expression] = STATE(10619),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10619),
    [sym_index_expression] = STATE(10619),
    [sym_parametrized_type_expression] = STATE(10619),
    [sym_call_expression] = STATE(10619),
    [sym_broadcast_call_expression] = STATE(10619),
    [sym__closed_macrocall_expression] = STATE(10619),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(10619),
    [sym_quote_expression] = STATE(10619),
    [sym_binary_expression] = STATE(12555),
    [sym_unary_expression] = STATE(12555),
    [sym_range_expression] = STATE(12555),
    [sym_splat_expression] = STATE(12555),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12201),
    [sym_unary_typed_expression] = STATE(12555),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12555),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(10619),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10619),
    [sym_string_literal] = STATE(10619),
    [sym_command_literal] = STATE(10619),
    [sym_prefixed_string_literal] = STATE(10619),
    [sym_prefixed_command_literal] = STATE(10619),
    [sym_operator] = STATE(12161),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8568),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [1841] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(12250),
    [sym__expression] = STATE(12158),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10551),
    [sym__array] = STATE(10551),
    [sym_comprehension_expression] = STATE(10551),
    [sym_matrix_expression] = STATE(10551),
    [sym_vector_expression] = STATE(10551),
    [sym_parenthesized_expression] = STATE(10551),
    [sym_tuple_expression] = STATE(10551),
    [sym_curly_expression] = STATE(10551),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10551),
    [sym_index_expression] = STATE(10551),
    [sym_parametrized_type_expression] = STATE(10551),
    [sym_call_expression] = STATE(10551),
    [sym_broadcast_call_expression] = STATE(10551),
    [sym__closed_macrocall_expression] = STATE(10551),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10551),
    [sym_quote_expression] = STATE(10551),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12237),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10551),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10551),
    [sym_string_literal] = STATE(10551),
    [sym_command_literal] = STATE(10551),
    [sym_prefixed_string_literal] = STATE(10551),
    [sym_prefixed_command_literal] = STATE(10551),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8808),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1842] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(12251),
    [sym__expression] = STATE(12159),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10551),
    [sym__array] = STATE(10551),
    [sym_comprehension_expression] = STATE(10551),
    [sym_matrix_expression] = STATE(10551),
    [sym_vector_expression] = STATE(10551),
    [sym_parenthesized_expression] = STATE(10551),
    [sym_tuple_expression] = STATE(10551),
    [sym_curly_expression] = STATE(10551),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10551),
    [sym_index_expression] = STATE(10551),
    [sym_parametrized_type_expression] = STATE(10551),
    [sym_call_expression] = STATE(10551),
    [sym_broadcast_call_expression] = STATE(10551),
    [sym__closed_macrocall_expression] = STATE(10551),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10551),
    [sym_quote_expression] = STATE(10551),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12237),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10551),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10551),
    [sym_string_literal] = STATE(10551),
    [sym_command_literal] = STATE(10551),
    [sym_prefixed_string_literal] = STATE(10551),
    [sym_prefixed_command_literal] = STATE(10551),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8808),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1843] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(12425),
    [sym__expression] = STATE(12136),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10551),
    [sym__array] = STATE(10551),
    [sym_comprehension_expression] = STATE(10551),
    [sym_matrix_expression] = STATE(10551),
    [sym_vector_expression] = STATE(10551),
    [sym_parenthesized_expression] = STATE(10551),
    [sym_tuple_expression] = STATE(10551),
    [sym_curly_expression] = STATE(10551),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10551),
    [sym_index_expression] = STATE(10551),
    [sym_parametrized_type_expression] = STATE(10551),
    [sym_call_expression] = STATE(10551),
    [sym_broadcast_call_expression] = STATE(10551),
    [sym__closed_macrocall_expression] = STATE(10551),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10551),
    [sym_quote_expression] = STATE(10551),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12237),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10551),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10551),
    [sym_string_literal] = STATE(10551),
    [sym_command_literal] = STATE(10551),
    [sym_prefixed_string_literal] = STATE(10551),
    [sym_prefixed_command_literal] = STATE(10551),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8808),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1844] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(18622),
    [sym__expression] = STATE(12800),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10630),
    [sym__array] = STATE(10630),
    [sym_comprehension_expression] = STATE(10630),
    [sym_matrix_expression] = STATE(10630),
    [sym_vector_expression] = STATE(10630),
    [sym_parenthesized_expression] = STATE(10630),
    [sym_tuple_expression] = STATE(10630),
    [sym_curly_expression] = STATE(10630),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10630),
    [sym_index_expression] = STATE(10630),
    [sym_parametrized_type_expression] = STATE(10630),
    [sym_call_expression] = STATE(10630),
    [sym_broadcast_call_expression] = STATE(10630),
    [sym__closed_macrocall_expression] = STATE(10630),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(10630),
    [sym_quote_expression] = STATE(10630),
    [sym_binary_expression] = STATE(12247),
    [sym_unary_expression] = STATE(12247),
    [sym_range_expression] = STATE(12247),
    [sym_splat_expression] = STATE(12247),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12247),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12247),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(10630),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10630),
    [sym_string_literal] = STATE(10630),
    [sym_command_literal] = STATE(10630),
    [sym_prefixed_string_literal] = STATE(10630),
    [sym_prefixed_command_literal] = STATE(10630),
    [sym_operator] = STATE(11897),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8582),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1845] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(18622),
    [sym__expression] = STATE(12827),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10630),
    [sym__array] = STATE(10630),
    [sym_comprehension_expression] = STATE(10630),
    [sym_matrix_expression] = STATE(10630),
    [sym_vector_expression] = STATE(10630),
    [sym_parenthesized_expression] = STATE(10630),
    [sym_tuple_expression] = STATE(10630),
    [sym_curly_expression] = STATE(10630),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10630),
    [sym_index_expression] = STATE(10630),
    [sym_parametrized_type_expression] = STATE(10630),
    [sym_call_expression] = STATE(10630),
    [sym_broadcast_call_expression] = STATE(10630),
    [sym__closed_macrocall_expression] = STATE(10630),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(10630),
    [sym_quote_expression] = STATE(10630),
    [sym_binary_expression] = STATE(12247),
    [sym_unary_expression] = STATE(12247),
    [sym_range_expression] = STATE(12247),
    [sym_splat_expression] = STATE(12247),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12247),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12247),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(10630),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10630),
    [sym_string_literal] = STATE(10630),
    [sym_command_literal] = STATE(10630),
    [sym_prefixed_string_literal] = STATE(10630),
    [sym_prefixed_command_literal] = STATE(10630),
    [sym_operator] = STATE(11897),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8582),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1846] = {
    [sym_assignment] = STATE(9085),
    [sym_open_tuple] = STATE(9050),
    [sym__expression] = STATE(8756),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8806),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [1847] = {
    [sym_assignment] = STATE(9088),
    [sym_open_tuple] = STATE(9051),
    [sym__expression] = STATE(8757),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8806),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [1848] = {
    [sym_assignment] = STATE(8790),
    [sym_open_tuple] = STATE(18720),
    [sym__expression] = STATE(8766),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8806),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [1849] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(12924),
    [sym__expression] = STATE(12925),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11054),
    [sym__array] = STATE(11054),
    [sym_comprehension_expression] = STATE(11054),
    [sym_matrix_expression] = STATE(11054),
    [sym_vector_expression] = STATE(11054),
    [sym_parenthesized_expression] = STATE(11054),
    [sym_tuple_expression] = STATE(11054),
    [sym_curly_expression] = STATE(11054),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11054),
    [sym_index_expression] = STATE(11054),
    [sym_parametrized_type_expression] = STATE(11054),
    [sym_call_expression] = STATE(11054),
    [sym_broadcast_call_expression] = STATE(11054),
    [sym__closed_macrocall_expression] = STATE(11054),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11054),
    [sym_quote_expression] = STATE(11054),
    [sym_binary_expression] = STATE(12944),
    [sym_unary_expression] = STATE(12944),
    [sym_range_expression] = STATE(12944),
    [sym_splat_expression] = STATE(12944),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12622),
    [sym_unary_typed_expression] = STATE(12944),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12944),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11054),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11054),
    [sym_string_literal] = STATE(11054),
    [sym_command_literal] = STATE(11054),
    [sym_prefixed_string_literal] = STATE(11054),
    [sym_prefixed_command_literal] = STATE(11054),
    [sym_operator] = STATE(12623),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(8674),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1850] = {
    [sym_assignment] = STATE(8884),
    [sym_open_tuple] = STATE(18720),
    [sym__expression] = STATE(8767),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6201),
    [sym__array] = STATE(6201),
    [sym_comprehension_expression] = STATE(6201),
    [sym_matrix_expression] = STATE(6201),
    [sym_vector_expression] = STATE(6201),
    [sym_parenthesized_expression] = STATE(6201),
    [sym_tuple_expression] = STATE(6201),
    [sym_curly_expression] = STATE(6201),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6201),
    [sym_index_expression] = STATE(6201),
    [sym_parametrized_type_expression] = STATE(6201),
    [sym_call_expression] = STATE(6201),
    [sym_broadcast_call_expression] = STATE(6201),
    [sym__closed_macrocall_expression] = STATE(6201),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6201),
    [sym_quote_expression] = STATE(6201),
    [sym_binary_expression] = STATE(8949),
    [sym_unary_expression] = STATE(8949),
    [sym_range_expression] = STATE(8949),
    [sym_splat_expression] = STATE(8949),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8321),
    [sym_unary_typed_expression] = STATE(8949),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(8949),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6201),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6201),
    [sym_string_literal] = STATE(6201),
    [sym_command_literal] = STATE(6201),
    [sym_prefixed_string_literal] = STATE(6201),
    [sym_prefixed_command_literal] = STATE(6201),
    [sym_operator] = STATE(8577),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8806),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [1851] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(12926),
    [sym__expression] = STATE(12927),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11054),
    [sym__array] = STATE(11054),
    [sym_comprehension_expression] = STATE(11054),
    [sym_matrix_expression] = STATE(11054),
    [sym_vector_expression] = STATE(11054),
    [sym_parenthesized_expression] = STATE(11054),
    [sym_tuple_expression] = STATE(11054),
    [sym_curly_expression] = STATE(11054),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11054),
    [sym_index_expression] = STATE(11054),
    [sym_parametrized_type_expression] = STATE(11054),
    [sym_call_expression] = STATE(11054),
    [sym_broadcast_call_expression] = STATE(11054),
    [sym__closed_macrocall_expression] = STATE(11054),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11054),
    [sym_quote_expression] = STATE(11054),
    [sym_binary_expression] = STATE(12944),
    [sym_unary_expression] = STATE(12944),
    [sym_range_expression] = STATE(12944),
    [sym_splat_expression] = STATE(12944),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12622),
    [sym_unary_typed_expression] = STATE(12944),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12944),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11054),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11054),
    [sym_string_literal] = STATE(11054),
    [sym_command_literal] = STATE(11054),
    [sym_prefixed_string_literal] = STATE(11054),
    [sym_prefixed_command_literal] = STATE(11054),
    [sym_operator] = STATE(12623),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(8674),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1852] = {
    [sym_assignment] = STATE(12236),
    [sym_open_tuple] = STATE(18358),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11225),
    [sym__array] = STATE(11225),
    [sym_comprehension_expression] = STATE(11225),
    [sym_matrix_expression] = STATE(11225),
    [sym_vector_expression] = STATE(11225),
    [sym_parenthesized_expression] = STATE(11225),
    [sym_tuple_expression] = STATE(11225),
    [sym_curly_expression] = STATE(11225),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11225),
    [sym_index_expression] = STATE(11225),
    [sym_parametrized_type_expression] = STATE(11225),
    [sym_call_expression] = STATE(11225),
    [sym_broadcast_call_expression] = STATE(11225),
    [sym__closed_macrocall_expression] = STATE(11225),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11225),
    [sym_quote_expression] = STATE(11225),
    [sym_binary_expression] = STATE(13238),
    [sym_unary_expression] = STATE(13238),
    [sym_range_expression] = STATE(13238),
    [sym_splat_expression] = STATE(13238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13077),
    [sym_unary_typed_expression] = STATE(13238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13238),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11225),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11225),
    [sym_string_literal] = STATE(11225),
    [sym_command_literal] = STATE(11225),
    [sym_prefixed_string_literal] = STATE(11225),
    [sym_prefixed_command_literal] = STATE(11225),
    [sym_operator] = STATE(13078),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3178),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1853] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(13397),
    [sym__expression] = STATE(13061),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11203),
    [sym__array] = STATE(11203),
    [sym_comprehension_expression] = STATE(11203),
    [sym_matrix_expression] = STATE(11203),
    [sym_vector_expression] = STATE(11203),
    [sym_parenthesized_expression] = STATE(11203),
    [sym_tuple_expression] = STATE(11203),
    [sym_curly_expression] = STATE(11203),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11203),
    [sym_index_expression] = STATE(11203),
    [sym_parametrized_type_expression] = STATE(11203),
    [sym_call_expression] = STATE(11203),
    [sym_broadcast_call_expression] = STATE(11203),
    [sym__closed_macrocall_expression] = STATE(11203),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11203),
    [sym_quote_expression] = STATE(11203),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13080),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11203),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11203),
    [sym_string_literal] = STATE(11203),
    [sym_command_literal] = STATE(11203),
    [sym_prefixed_string_literal] = STATE(11203),
    [sym_prefixed_command_literal] = STATE(11203),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(8590),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1854] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8810),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1855] = {
    [sym_assignment] = STATE(8784),
    [sym_open_tuple] = STATE(9069),
    [sym__expression] = STATE(9028),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8704),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1856] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(14526),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11644),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11644),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13722),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11324),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8812),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1857] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8814),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1858] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8816),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1859] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8818),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1860] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8820),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1861] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8822),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1862] = {
    [sym__expression] = STATE(13611),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17323),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8824),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1863] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8826),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1864] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8828),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1865] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8830),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1866] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8832),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1867] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8834),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1868] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8830),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1869] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8836),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1870] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8838),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1871] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(19855),
    [sym__expression] = STATE(12997),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11054),
    [sym__array] = STATE(11054),
    [sym_comprehension_expression] = STATE(11054),
    [sym_matrix_expression] = STATE(11054),
    [sym_vector_expression] = STATE(11054),
    [sym_parenthesized_expression] = STATE(11054),
    [sym_tuple_expression] = STATE(11054),
    [sym_curly_expression] = STATE(11054),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11054),
    [sym_index_expression] = STATE(11054),
    [sym_parametrized_type_expression] = STATE(11054),
    [sym_call_expression] = STATE(11054),
    [sym_broadcast_call_expression] = STATE(11054),
    [sym__closed_macrocall_expression] = STATE(11054),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11054),
    [sym_quote_expression] = STATE(11054),
    [sym_binary_expression] = STATE(12944),
    [sym_unary_expression] = STATE(12944),
    [sym_range_expression] = STATE(12944),
    [sym_splat_expression] = STATE(12944),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12622),
    [sym_unary_typed_expression] = STATE(12944),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12944),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11054),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11054),
    [sym_string_literal] = STATE(11054),
    [sym_command_literal] = STATE(11054),
    [sym_prefixed_string_literal] = STATE(11054),
    [sym_prefixed_command_literal] = STATE(11054),
    [sym_operator] = STATE(12623),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(8674),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1872] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8840),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1873] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8842),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1874] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8844),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1875] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8846),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1876] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8848),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1877] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8850),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1878] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(13410),
    [sym__expression] = STATE(13065),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11198),
    [sym__array] = STATE(11198),
    [sym_comprehension_expression] = STATE(11198),
    [sym_matrix_expression] = STATE(11198),
    [sym_vector_expression] = STATE(11198),
    [sym_parenthesized_expression] = STATE(11198),
    [sym_tuple_expression] = STATE(11198),
    [sym_curly_expression] = STATE(11198),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11198),
    [sym_index_expression] = STATE(11198),
    [sym_parametrized_type_expression] = STATE(11198),
    [sym_call_expression] = STATE(11198),
    [sym_broadcast_call_expression] = STATE(11198),
    [sym__closed_macrocall_expression] = STATE(11198),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11198),
    [sym_quote_expression] = STATE(11198),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12928),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11198),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11198),
    [sym_string_literal] = STATE(11198),
    [sym_command_literal] = STATE(11198),
    [sym_prefixed_string_literal] = STATE(11198),
    [sym_prefixed_command_literal] = STATE(11198),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(8668),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1879] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8852),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1880] = {
    [sym_assignment] = STATE(11883),
    [sym_open_tuple] = STATE(13759),
    [sym__expression] = STATE(13625),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11544),
    [sym__array] = STATE(11544),
    [sym_comprehension_expression] = STATE(11544),
    [sym_matrix_expression] = STATE(11544),
    [sym_vector_expression] = STATE(11544),
    [sym_parenthesized_expression] = STATE(11544),
    [sym_tuple_expression] = STATE(11544),
    [sym_curly_expression] = STATE(11544),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11544),
    [sym_index_expression] = STATE(11544),
    [sym_parametrized_type_expression] = STATE(11544),
    [sym_call_expression] = STATE(11544),
    [sym_broadcast_call_expression] = STATE(11544),
    [sym__closed_macrocall_expression] = STATE(11544),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11544),
    [sym_quote_expression] = STATE(11544),
    [sym_binary_expression] = STATE(13781),
    [sym_unary_expression] = STATE(13781),
    [sym_range_expression] = STATE(13781),
    [sym_splat_expression] = STATE(13781),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13485),
    [sym_unary_typed_expression] = STATE(13781),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13781),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11544),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11544),
    [sym_string_literal] = STATE(11544),
    [sym_command_literal] = STATE(11544),
    [sym_prefixed_string_literal] = STATE(11544),
    [sym_prefixed_command_literal] = STATE(11544),
    [sym_operator] = STATE(13486),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4112),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1881] = {
    [sym_assignment] = STATE(11884),
    [sym_open_tuple] = STATE(13760),
    [sym__expression] = STATE(13626),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11544),
    [sym__array] = STATE(11544),
    [sym_comprehension_expression] = STATE(11544),
    [sym_matrix_expression] = STATE(11544),
    [sym_vector_expression] = STATE(11544),
    [sym_parenthesized_expression] = STATE(11544),
    [sym_tuple_expression] = STATE(11544),
    [sym_curly_expression] = STATE(11544),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11544),
    [sym_index_expression] = STATE(11544),
    [sym_parametrized_type_expression] = STATE(11544),
    [sym_call_expression] = STATE(11544),
    [sym_broadcast_call_expression] = STATE(11544),
    [sym__closed_macrocall_expression] = STATE(11544),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11544),
    [sym_quote_expression] = STATE(11544),
    [sym_binary_expression] = STATE(13781),
    [sym_unary_expression] = STATE(13781),
    [sym_range_expression] = STATE(13781),
    [sym_splat_expression] = STATE(13781),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13485),
    [sym_unary_typed_expression] = STATE(13781),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13781),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11544),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11544),
    [sym_string_literal] = STATE(11544),
    [sym_command_literal] = STATE(11544),
    [sym_prefixed_string_literal] = STATE(11544),
    [sym_prefixed_command_literal] = STATE(11544),
    [sym_operator] = STATE(13486),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4112),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1882] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8854),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1883] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(13092),
    [sym__expression] = STATE(12828),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11146),
    [sym__array] = STATE(11146),
    [sym_comprehension_expression] = STATE(11146),
    [sym_matrix_expression] = STATE(11146),
    [sym_vector_expression] = STATE(11146),
    [sym_parenthesized_expression] = STATE(11146),
    [sym_tuple_expression] = STATE(11146),
    [sym_curly_expression] = STATE(11146),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11146),
    [sym_index_expression] = STATE(11146),
    [sym_parametrized_type_expression] = STATE(11146),
    [sym_call_expression] = STATE(11146),
    [sym_broadcast_call_expression] = STATE(11146),
    [sym__closed_macrocall_expression] = STATE(11146),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(11146),
    [sym_quote_expression] = STATE(11146),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12370),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(11146),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11146),
    [sym_string_literal] = STATE(11146),
    [sym_command_literal] = STATE(11146),
    [sym_prefixed_string_literal] = STATE(11146),
    [sym_prefixed_command_literal] = STATE(11146),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(8680),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1884] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(18889),
    [sym__expression] = STATE(13873),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11288),
    [sym__array] = STATE(11288),
    [sym_comprehension_expression] = STATE(11288),
    [sym_matrix_expression] = STATE(11288),
    [sym_vector_expression] = STATE(11288),
    [sym_parenthesized_expression] = STATE(11288),
    [sym_tuple_expression] = STATE(11288),
    [sym_curly_expression] = STATE(11288),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11288),
    [sym_index_expression] = STATE(11288),
    [sym_parametrized_type_expression] = STATE(11288),
    [sym_call_expression] = STATE(11288),
    [sym_broadcast_call_expression] = STATE(11288),
    [sym__closed_macrocall_expression] = STATE(11288),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11288),
    [sym_quote_expression] = STATE(11288),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13096),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11288),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11288),
    [sym_string_literal] = STATE(11288),
    [sym_command_literal] = STATE(11288),
    [sym_prefixed_string_literal] = STATE(11288),
    [sym_prefixed_command_literal] = STATE(11288),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(2922),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1885] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(18889),
    [sym__expression] = STATE(13874),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11288),
    [sym__array] = STATE(11288),
    [sym_comprehension_expression] = STATE(11288),
    [sym_matrix_expression] = STATE(11288),
    [sym_vector_expression] = STATE(11288),
    [sym_parenthesized_expression] = STATE(11288),
    [sym_tuple_expression] = STATE(11288),
    [sym_curly_expression] = STATE(11288),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11288),
    [sym_index_expression] = STATE(11288),
    [sym_parametrized_type_expression] = STATE(11288),
    [sym_call_expression] = STATE(11288),
    [sym_broadcast_call_expression] = STATE(11288),
    [sym__closed_macrocall_expression] = STATE(11288),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11288),
    [sym_quote_expression] = STATE(11288),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13096),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11288),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11288),
    [sym_string_literal] = STATE(11288),
    [sym_command_literal] = STATE(11288),
    [sym_prefixed_string_literal] = STATE(11288),
    [sym_prefixed_command_literal] = STATE(11288),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(2922),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1886] = {
    [sym_assignment] = STATE(7909),
    [sym_open_tuple] = STATE(7344),
    [sym__expression] = STATE(7272),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8706),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1887] = {
    [sym_assignment] = STATE(7397),
    [sym_open_tuple] = STATE(18295),
    [sym__expression] = STATE(7284),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8676),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1888] = {
    [sym_assignment] = STATE(7543),
    [sym_open_tuple] = STATE(18295),
    [sym__expression] = STATE(7285),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(5037),
    [sym_comprehension_expression] = STATE(5037),
    [sym_matrix_expression] = STATE(5037),
    [sym_vector_expression] = STATE(5037),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_tuple_expression] = STATE(5037),
    [sym_curly_expression] = STATE(5037),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5037),
    [sym_index_expression] = STATE(5037),
    [sym_parametrized_type_expression] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_broadcast_call_expression] = STATE(5037),
    [sym__closed_macrocall_expression] = STATE(5037),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(5037),
    [sym_quote_expression] = STATE(5037),
    [sym_binary_expression] = STATE(7358),
    [sym_unary_expression] = STATE(7358),
    [sym_range_expression] = STATE(7358),
    [sym_splat_expression] = STATE(7358),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6995),
    [sym_unary_typed_expression] = STATE(7358),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7358),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(5037),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5037),
    [sym_string_literal] = STATE(5037),
    [sym_command_literal] = STATE(5037),
    [sym_prefixed_string_literal] = STATE(5037),
    [sym_prefixed_command_literal] = STATE(5037),
    [sym_operator] = STATE(7016),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8676),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1889] = {
    [sym_assignment] = STATE(12039),
    [sym_open_tuple] = STATE(13274),
    [sym__expression] = STATE(13024),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11288),
    [sym__array] = STATE(11288),
    [sym_comprehension_expression] = STATE(11288),
    [sym_matrix_expression] = STATE(11288),
    [sym_vector_expression] = STATE(11288),
    [sym_parenthesized_expression] = STATE(11288),
    [sym_tuple_expression] = STATE(11288),
    [sym_curly_expression] = STATE(11288),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11288),
    [sym_index_expression] = STATE(11288),
    [sym_parametrized_type_expression] = STATE(11288),
    [sym_call_expression] = STATE(11288),
    [sym_broadcast_call_expression] = STATE(11288),
    [sym__closed_macrocall_expression] = STATE(11288),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11288),
    [sym_quote_expression] = STATE(11288),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13096),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11288),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11288),
    [sym_string_literal] = STATE(11288),
    [sym_command_literal] = STATE(11288),
    [sym_prefixed_string_literal] = STATE(11288),
    [sym_prefixed_command_literal] = STATE(11288),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(2922),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1890] = {
    [sym_assignment] = STATE(8935),
    [sym_open_tuple] = STATE(18387),
    [sym__expression] = STATE(8751),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8696),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1891] = {
    [sym_assignment] = STATE(9104),
    [sym_open_tuple] = STATE(18387),
    [sym__expression] = STATE(8752),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6220),
    [sym__array] = STATE(6220),
    [sym_comprehension_expression] = STATE(6220),
    [sym_matrix_expression] = STATE(6220),
    [sym_vector_expression] = STATE(6220),
    [sym_parenthesized_expression] = STATE(6220),
    [sym_tuple_expression] = STATE(6220),
    [sym_curly_expression] = STATE(6220),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6220),
    [sym_index_expression] = STATE(6220),
    [sym_parametrized_type_expression] = STATE(6220),
    [sym_call_expression] = STATE(6220),
    [sym_broadcast_call_expression] = STATE(6220),
    [sym__closed_macrocall_expression] = STATE(6220),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6220),
    [sym_quote_expression] = STATE(6220),
    [sym_binary_expression] = STATE(8870),
    [sym_unary_expression] = STATE(8870),
    [sym_range_expression] = STATE(8870),
    [sym_splat_expression] = STATE(8870),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8724),
    [sym_unary_typed_expression] = STATE(8870),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8870),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6220),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6220),
    [sym_string_literal] = STATE(6220),
    [sym_command_literal] = STATE(6220),
    [sym_prefixed_string_literal] = STATE(6220),
    [sym_prefixed_command_literal] = STATE(6220),
    [sym_operator] = STATE(8513),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8696),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1892] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(18544),
    [sym__expression] = STATE(13314),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11231),
    [sym__array] = STATE(11231),
    [sym_comprehension_expression] = STATE(11231),
    [sym_matrix_expression] = STATE(11231),
    [sym_vector_expression] = STATE(11231),
    [sym_parenthesized_expression] = STATE(11231),
    [sym_tuple_expression] = STATE(11231),
    [sym_curly_expression] = STATE(11231),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11231),
    [sym_index_expression] = STATE(11231),
    [sym_parametrized_type_expression] = STATE(11231),
    [sym_call_expression] = STATE(11231),
    [sym_broadcast_call_expression] = STATE(11231),
    [sym__closed_macrocall_expression] = STATE(11231),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11231),
    [sym_quote_expression] = STATE(11231),
    [sym_binary_expression] = STATE(13208),
    [sym_unary_expression] = STATE(13208),
    [sym_range_expression] = STATE(13208),
    [sym_splat_expression] = STATE(13208),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13154),
    [sym_unary_typed_expression] = STATE(13208),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13208),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11231),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11231),
    [sym_string_literal] = STATE(11231),
    [sym_command_literal] = STATE(11231),
    [sym_prefixed_string_literal] = STATE(11231),
    [sym_prefixed_command_literal] = STATE(11231),
    [sym_operator] = STATE(13060),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3316),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1893] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(18544),
    [sym__expression] = STATE(13404),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11231),
    [sym__array] = STATE(11231),
    [sym_comprehension_expression] = STATE(11231),
    [sym_matrix_expression] = STATE(11231),
    [sym_vector_expression] = STATE(11231),
    [sym_parenthesized_expression] = STATE(11231),
    [sym_tuple_expression] = STATE(11231),
    [sym_curly_expression] = STATE(11231),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11231),
    [sym_index_expression] = STATE(11231),
    [sym_parametrized_type_expression] = STATE(11231),
    [sym_call_expression] = STATE(11231),
    [sym_broadcast_call_expression] = STATE(11231),
    [sym__closed_macrocall_expression] = STATE(11231),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11231),
    [sym_quote_expression] = STATE(11231),
    [sym_binary_expression] = STATE(13208),
    [sym_unary_expression] = STATE(13208),
    [sym_range_expression] = STATE(13208),
    [sym_splat_expression] = STATE(13208),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13154),
    [sym_unary_typed_expression] = STATE(13208),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13208),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11231),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11231),
    [sym_string_literal] = STATE(11231),
    [sym_command_literal] = STATE(11231),
    [sym_prefixed_string_literal] = STATE(11231),
    [sym_prefixed_command_literal] = STATE(11231),
    [sym_operator] = STATE(13060),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3316),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1894] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(12707),
    [sym__expression] = STATE(12152),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(10566),
    [sym_comprehension_expression] = STATE(10566),
    [sym_matrix_expression] = STATE(10566),
    [sym_vector_expression] = STATE(10566),
    [sym_parenthesized_expression] = STATE(10566),
    [sym_tuple_expression] = STATE(10566),
    [sym_curly_expression] = STATE(10566),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10566),
    [sym_index_expression] = STATE(10566),
    [sym_parametrized_type_expression] = STATE(10566),
    [sym_call_expression] = STATE(10566),
    [sym_broadcast_call_expression] = STATE(10566),
    [sym__closed_macrocall_expression] = STATE(10566),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10566),
    [sym_quote_expression] = STATE(10566),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11966),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10566),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10566),
    [sym_string_literal] = STATE(10566),
    [sym_command_literal] = STATE(10566),
    [sym_prefixed_string_literal] = STATE(10566),
    [sym_prefixed_command_literal] = STATE(10566),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(8712),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1895] = {
    [sym_assignment] = STATE(7797),
    [sym_open_tuple] = STATE(19771),
    [sym__expression] = STATE(9003),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8678),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1896] = {
    [sym_assignment] = STATE(7891),
    [sym_open_tuple] = STATE(19771),
    [sym__expression] = STATE(8997),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8678),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1897] = {
    [sym_assignment] = STATE(12797),
    [sym_open_tuple] = STATE(12708),
    [sym__expression] = STATE(12153),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10677),
    [sym__array] = STATE(10677),
    [sym_comprehension_expression] = STATE(10677),
    [sym_matrix_expression] = STATE(10677),
    [sym_vector_expression] = STATE(10677),
    [sym_parenthesized_expression] = STATE(10677),
    [sym_tuple_expression] = STATE(10677),
    [sym_curly_expression] = STATE(10677),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10677),
    [sym_index_expression] = STATE(10677),
    [sym_parametrized_type_expression] = STATE(10677),
    [sym_call_expression] = STATE(10677),
    [sym_broadcast_call_expression] = STATE(10677),
    [sym__closed_macrocall_expression] = STATE(10677),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10677),
    [sym_quote_expression] = STATE(10677),
    [sym_binary_expression] = STATE(12304),
    [sym_unary_expression] = STATE(12304),
    [sym_range_expression] = STATE(12304),
    [sym_splat_expression] = STATE(12304),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11911),
    [sym_unary_typed_expression] = STATE(12304),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12304),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10677),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10677),
    [sym_string_literal] = STATE(10677),
    [sym_command_literal] = STATE(10677),
    [sym_prefixed_string_literal] = STATE(10677),
    [sym_prefixed_command_literal] = STATE(10677),
    [sym_operator] = STATE(12095),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(8716),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [1898] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(13124),
    [sym__expression] = STATE(12829),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11137),
    [sym__array] = STATE(11137),
    [sym_comprehension_expression] = STATE(11137),
    [sym_matrix_expression] = STATE(11137),
    [sym_vector_expression] = STATE(11137),
    [sym_parenthesized_expression] = STATE(11137),
    [sym_tuple_expression] = STATE(11137),
    [sym_curly_expression] = STATE(11137),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11137),
    [sym_index_expression] = STATE(11137),
    [sym_parametrized_type_expression] = STATE(11137),
    [sym_call_expression] = STATE(11137),
    [sym_broadcast_call_expression] = STATE(11137),
    [sym__closed_macrocall_expression] = STATE(11137),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11137),
    [sym_quote_expression] = STATE(11137),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12260),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11137),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11137),
    [sym_string_literal] = STATE(11137),
    [sym_command_literal] = STATE(11137),
    [sym_prefixed_string_literal] = STATE(11137),
    [sym_prefixed_command_literal] = STATE(11137),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(8738),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1899] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(13153),
    [sym__expression] = STATE(12830),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10969),
    [sym__array] = STATE(10969),
    [sym_comprehension_expression] = STATE(10969),
    [sym_matrix_expression] = STATE(10969),
    [sym_vector_expression] = STATE(10969),
    [sym_parenthesized_expression] = STATE(10969),
    [sym_tuple_expression] = STATE(10969),
    [sym_curly_expression] = STATE(10969),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(10969),
    [sym_index_expression] = STATE(10969),
    [sym_parametrized_type_expression] = STATE(10969),
    [sym_call_expression] = STATE(10969),
    [sym_broadcast_call_expression] = STATE(10969),
    [sym__closed_macrocall_expression] = STATE(10969),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(10969),
    [sym_quote_expression] = STATE(10969),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(10969),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(10969),
    [sym_string_literal] = STATE(10969),
    [sym_command_literal] = STATE(10969),
    [sym_prefixed_string_literal] = STATE(10969),
    [sym_prefixed_command_literal] = STATE(10969),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(8782),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1900] = {
    [sym_assignment] = STATE(12287),
    [sym_open_tuple] = STATE(18373),
    [sym__expression] = STATE(12139),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10916),
    [sym__array] = STATE(10916),
    [sym_comprehension_expression] = STATE(10916),
    [sym_matrix_expression] = STATE(10916),
    [sym_vector_expression] = STATE(10916),
    [sym_parenthesized_expression] = STATE(10916),
    [sym_tuple_expression] = STATE(10916),
    [sym_curly_expression] = STATE(10916),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10916),
    [sym_index_expression] = STATE(10916),
    [sym_parametrized_type_expression] = STATE(10916),
    [sym_call_expression] = STATE(10916),
    [sym_broadcast_call_expression] = STATE(10916),
    [sym__closed_macrocall_expression] = STATE(10916),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10916),
    [sym_quote_expression] = STATE(10916),
    [sym_binary_expression] = STATE(12715),
    [sym_unary_expression] = STATE(12715),
    [sym_range_expression] = STATE(12715),
    [sym_splat_expression] = STATE(12715),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12109),
    [sym_unary_typed_expression] = STATE(12715),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12715),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10916),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10916),
    [sym_string_literal] = STATE(10916),
    [sym_command_literal] = STATE(10916),
    [sym_prefixed_string_literal] = STATE(10916),
    [sym_prefixed_command_literal] = STATE(10916),
    [sym_operator] = STATE(11913),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8804),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [1901] = {
    [sym_assignment] = STATE(12340),
    [sym_open_tuple] = STATE(18373),
    [sym__expression] = STATE(12140),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10916),
    [sym__array] = STATE(10916),
    [sym_comprehension_expression] = STATE(10916),
    [sym_matrix_expression] = STATE(10916),
    [sym_vector_expression] = STATE(10916),
    [sym_parenthesized_expression] = STATE(10916),
    [sym_tuple_expression] = STATE(10916),
    [sym_curly_expression] = STATE(10916),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10916),
    [sym_index_expression] = STATE(10916),
    [sym_parametrized_type_expression] = STATE(10916),
    [sym_call_expression] = STATE(10916),
    [sym_broadcast_call_expression] = STATE(10916),
    [sym__closed_macrocall_expression] = STATE(10916),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10916),
    [sym_quote_expression] = STATE(10916),
    [sym_binary_expression] = STATE(12715),
    [sym_unary_expression] = STATE(12715),
    [sym_range_expression] = STATE(12715),
    [sym_splat_expression] = STATE(12715),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12109),
    [sym_unary_typed_expression] = STATE(12715),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12715),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10916),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10916),
    [sym_string_literal] = STATE(10916),
    [sym_command_literal] = STATE(10916),
    [sym_prefixed_string_literal] = STATE(10916),
    [sym_prefixed_command_literal] = STATE(10916),
    [sym_operator] = STATE(11913),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8804),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [1902] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(18948),
    [sym__expression] = STATE(12143),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10551),
    [sym__array] = STATE(10551),
    [sym_comprehension_expression] = STATE(10551),
    [sym_matrix_expression] = STATE(10551),
    [sym_vector_expression] = STATE(10551),
    [sym_parenthesized_expression] = STATE(10551),
    [sym_tuple_expression] = STATE(10551),
    [sym_curly_expression] = STATE(10551),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10551),
    [sym_index_expression] = STATE(10551),
    [sym_parametrized_type_expression] = STATE(10551),
    [sym_call_expression] = STATE(10551),
    [sym_broadcast_call_expression] = STATE(10551),
    [sym__closed_macrocall_expression] = STATE(10551),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10551),
    [sym_quote_expression] = STATE(10551),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12237),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10551),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10551),
    [sym_string_literal] = STATE(10551),
    [sym_command_literal] = STATE(10551),
    [sym_prefixed_string_literal] = STATE(10551),
    [sym_prefixed_command_literal] = STATE(10551),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8808),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1903] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(18948),
    [sym__expression] = STATE(12144),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10551),
    [sym__array] = STATE(10551),
    [sym_comprehension_expression] = STATE(10551),
    [sym_matrix_expression] = STATE(10551),
    [sym_vector_expression] = STATE(10551),
    [sym_parenthesized_expression] = STATE(10551),
    [sym_tuple_expression] = STATE(10551),
    [sym_curly_expression] = STATE(10551),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10551),
    [sym_index_expression] = STATE(10551),
    [sym_parametrized_type_expression] = STATE(10551),
    [sym_call_expression] = STATE(10551),
    [sym_broadcast_call_expression] = STATE(10551),
    [sym__closed_macrocall_expression] = STATE(10551),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10551),
    [sym_quote_expression] = STATE(10551),
    [sym_binary_expression] = STATE(10726),
    [sym_unary_expression] = STATE(10726),
    [sym_range_expression] = STATE(10726),
    [sym_splat_expression] = STATE(10726),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12237),
    [sym_unary_typed_expression] = STATE(10726),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10726),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10551),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10551),
    [sym_string_literal] = STATE(10551),
    [sym_command_literal] = STATE(10551),
    [sym_prefixed_string_literal] = STATE(10551),
    [sym_prefixed_command_literal] = STATE(10551),
    [sym_operator] = STATE(10451),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8808),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1904] = {
    [sym_assignment] = STATE(7323),
    [sym_open_tuple] = STATE(19661),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11796),
    [sym__array] = STATE(11796),
    [sym_comprehension_expression] = STATE(11796),
    [sym_matrix_expression] = STATE(11796),
    [sym_vector_expression] = STATE(11796),
    [sym_parenthesized_expression] = STATE(11796),
    [sym_tuple_expression] = STATE(11796),
    [sym_curly_expression] = STATE(11796),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11796),
    [sym_index_expression] = STATE(11796),
    [sym_parametrized_type_expression] = STATE(11796),
    [sym_call_expression] = STATE(11796),
    [sym_broadcast_call_expression] = STATE(11796),
    [sym__closed_macrocall_expression] = STATE(11796),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11796),
    [sym_quote_expression] = STATE(11796),
    [sym_binary_expression] = STATE(14071),
    [sym_unary_expression] = STATE(14071),
    [sym_range_expression] = STATE(14071),
    [sym_splat_expression] = STATE(14071),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13736),
    [sym_unary_typed_expression] = STATE(14071),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14071),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11796),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11796),
    [sym_string_literal] = STATE(11796),
    [sym_command_literal] = STATE(11796),
    [sym_prefixed_string_literal] = STATE(11796),
    [sym_prefixed_command_literal] = STATE(11796),
    [sym_operator] = STATE(13738),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8856),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1905] = {
    [sym_assignment] = STATE(15343),
    [sym_open_tuple] = STATE(14631),
    [sym__expression] = STATE(12376),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10874),
    [sym__array] = STATE(10874),
    [sym_comprehension_expression] = STATE(10874),
    [sym_matrix_expression] = STATE(10874),
    [sym_vector_expression] = STATE(10874),
    [sym_parenthesized_expression] = STATE(10874),
    [sym_tuple_expression] = STATE(10874),
    [sym_curly_expression] = STATE(10874),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10874),
    [sym_index_expression] = STATE(10874),
    [sym_parametrized_type_expression] = STATE(10874),
    [sym_call_expression] = STATE(10874),
    [sym_broadcast_call_expression] = STATE(10874),
    [sym__closed_macrocall_expression] = STATE(10874),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10874),
    [sym_quote_expression] = STATE(10874),
    [sym_binary_expression] = STATE(12259),
    [sym_unary_expression] = STATE(12259),
    [sym_range_expression] = STATE(12259),
    [sym_splat_expression] = STATE(12259),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11948),
    [sym_unary_typed_expression] = STATE(12259),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12259),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10874),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10874),
    [sym_string_literal] = STATE(10874),
    [sym_command_literal] = STATE(10874),
    [sym_prefixed_string_literal] = STATE(10874),
    [sym_prefixed_command_literal] = STATE(10874),
    [sym_operator] = STATE(12127),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(5002),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [1906] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(19855),
    [sym__expression] = STATE(12959),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11054),
    [sym__array] = STATE(11054),
    [sym_comprehension_expression] = STATE(11054),
    [sym_matrix_expression] = STATE(11054),
    [sym_vector_expression] = STATE(11054),
    [sym_parenthesized_expression] = STATE(11054),
    [sym_tuple_expression] = STATE(11054),
    [sym_curly_expression] = STATE(11054),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11054),
    [sym_index_expression] = STATE(11054),
    [sym_parametrized_type_expression] = STATE(11054),
    [sym_call_expression] = STATE(11054),
    [sym_broadcast_call_expression] = STATE(11054),
    [sym__closed_macrocall_expression] = STATE(11054),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11054),
    [sym_quote_expression] = STATE(11054),
    [sym_binary_expression] = STATE(12944),
    [sym_unary_expression] = STATE(12944),
    [sym_range_expression] = STATE(12944),
    [sym_splat_expression] = STATE(12944),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12622),
    [sym_unary_typed_expression] = STATE(12944),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12944),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11054),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11054),
    [sym_string_literal] = STATE(11054),
    [sym_command_literal] = STATE(11054),
    [sym_prefixed_string_literal] = STATE(11054),
    [sym_prefixed_command_literal] = STATE(11054),
    [sym_operator] = STATE(12623),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(8674),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1907] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8858),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1908] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8860),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1909] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8862),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1910] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8864),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1911] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8866),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1912] = {
    [sym__expression] = STATE(13906),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16935),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8868),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1913] = {
    [sym_assignment] = STATE(9110),
    [sym_open_tuple] = STATE(9113),
    [sym__expression] = STATE(9115),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8704),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1914] = {
    [sym_assignment] = STATE(9127),
    [sym_open_tuple] = STATE(9128),
    [sym__expression] = STATE(9130),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8704),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1915] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8870),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1916] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8872),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1917] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8828),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1918] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8874),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1919] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8876),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1920] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8878),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1921] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8874),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1922] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8880),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1923] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8882),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1924] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8884),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1925] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8886),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1926] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8888),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1927] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8890),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1928] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8892),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1929] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8816),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1930] = {
    [sym_assignment] = STATE(11883),
    [sym_open_tuple] = STATE(13774),
    [sym__expression] = STATE(13505),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11496),
    [sym__array] = STATE(11496),
    [sym_comprehension_expression] = STATE(11496),
    [sym_matrix_expression] = STATE(11496),
    [sym_vector_expression] = STATE(11496),
    [sym_parenthesized_expression] = STATE(11496),
    [sym_tuple_expression] = STATE(11496),
    [sym_curly_expression] = STATE(11496),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11496),
    [sym_index_expression] = STATE(11496),
    [sym_parametrized_type_expression] = STATE(11496),
    [sym_call_expression] = STATE(11496),
    [sym_broadcast_call_expression] = STATE(11496),
    [sym__closed_macrocall_expression] = STATE(11496),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11496),
    [sym_quote_expression] = STATE(11496),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13592),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11496),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11496),
    [sym_string_literal] = STATE(11496),
    [sym_command_literal] = STATE(11496),
    [sym_prefixed_string_literal] = STATE(11496),
    [sym_prefixed_command_literal] = STATE(11496),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3398),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1931] = {
    [sym_assignment] = STATE(11884),
    [sym_open_tuple] = STATE(13775),
    [sym__expression] = STATE(13506),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11496),
    [sym__array] = STATE(11496),
    [sym_comprehension_expression] = STATE(11496),
    [sym_matrix_expression] = STATE(11496),
    [sym_vector_expression] = STATE(11496),
    [sym_parenthesized_expression] = STATE(11496),
    [sym_tuple_expression] = STATE(11496),
    [sym_curly_expression] = STATE(11496),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11496),
    [sym_index_expression] = STATE(11496),
    [sym_parametrized_type_expression] = STATE(11496),
    [sym_call_expression] = STATE(11496),
    [sym_broadcast_call_expression] = STATE(11496),
    [sym__closed_macrocall_expression] = STATE(11496),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11496),
    [sym_quote_expression] = STATE(11496),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13592),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11496),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11496),
    [sym_string_literal] = STATE(11496),
    [sym_command_literal] = STATE(11496),
    [sym_prefixed_string_literal] = STATE(11496),
    [sym_prefixed_command_literal] = STATE(11496),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3398),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1932] = {
    [sym_assignment] = STATE(12039),
    [sym_open_tuple] = STATE(13219),
    [sym__expression] = STATE(13257),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11225),
    [sym__array] = STATE(11225),
    [sym_comprehension_expression] = STATE(11225),
    [sym_matrix_expression] = STATE(11225),
    [sym_vector_expression] = STATE(11225),
    [sym_parenthesized_expression] = STATE(11225),
    [sym_tuple_expression] = STATE(11225),
    [sym_curly_expression] = STATE(11225),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11225),
    [sym_index_expression] = STATE(11225),
    [sym_parametrized_type_expression] = STATE(11225),
    [sym_call_expression] = STATE(11225),
    [sym_broadcast_call_expression] = STATE(11225),
    [sym__closed_macrocall_expression] = STATE(11225),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11225),
    [sym_quote_expression] = STATE(11225),
    [sym_binary_expression] = STATE(13238),
    [sym_unary_expression] = STATE(13238),
    [sym_range_expression] = STATE(13238),
    [sym_splat_expression] = STATE(13238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13077),
    [sym_unary_typed_expression] = STATE(13238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13238),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11225),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11225),
    [sym_string_literal] = STATE(11225),
    [sym_command_literal] = STATE(11225),
    [sym_prefixed_string_literal] = STATE(11225),
    [sym_prefixed_command_literal] = STATE(11225),
    [sym_operator] = STATE(13078),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3178),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1933] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(18889),
    [sym__expression] = STATE(13032),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11288),
    [sym__array] = STATE(11288),
    [sym_comprehension_expression] = STATE(11288),
    [sym_matrix_expression] = STATE(11288),
    [sym_vector_expression] = STATE(11288),
    [sym_parenthesized_expression] = STATE(11288),
    [sym_tuple_expression] = STATE(11288),
    [sym_curly_expression] = STATE(11288),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11288),
    [sym_index_expression] = STATE(11288),
    [sym_parametrized_type_expression] = STATE(11288),
    [sym_call_expression] = STATE(11288),
    [sym_broadcast_call_expression] = STATE(11288),
    [sym__closed_macrocall_expression] = STATE(11288),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11288),
    [sym_quote_expression] = STATE(11288),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13096),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11288),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11288),
    [sym_string_literal] = STATE(11288),
    [sym_command_literal] = STATE(11288),
    [sym_prefixed_string_literal] = STATE(11288),
    [sym_prefixed_command_literal] = STATE(11288),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(2922),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1934] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(18889),
    [sym__expression] = STATE(13033),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11288),
    [sym__array] = STATE(11288),
    [sym_comprehension_expression] = STATE(11288),
    [sym_matrix_expression] = STATE(11288),
    [sym_vector_expression] = STATE(11288),
    [sym_parenthesized_expression] = STATE(11288),
    [sym_tuple_expression] = STATE(11288),
    [sym_curly_expression] = STATE(11288),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11288),
    [sym_index_expression] = STATE(11288),
    [sym_parametrized_type_expression] = STATE(11288),
    [sym_call_expression] = STATE(11288),
    [sym_broadcast_call_expression] = STATE(11288),
    [sym__closed_macrocall_expression] = STATE(11288),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11288),
    [sym_quote_expression] = STATE(11288),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13096),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11288),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11288),
    [sym_string_literal] = STATE(11288),
    [sym_command_literal] = STATE(11288),
    [sym_prefixed_string_literal] = STATE(11288),
    [sym_prefixed_command_literal] = STATE(11288),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(2922),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1935] = {
    [sym_assignment] = STATE(8378),
    [sym_open_tuple] = STATE(9042),
    [sym__expression] = STATE(8747),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6378),
    [sym__array] = STATE(6378),
    [sym_comprehension_expression] = STATE(6378),
    [sym_matrix_expression] = STATE(6378),
    [sym_vector_expression] = STATE(6378),
    [sym_parenthesized_expression] = STATE(6378),
    [sym_tuple_expression] = STATE(6378),
    [sym_curly_expression] = STATE(6378),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6378),
    [sym_index_expression] = STATE(6378),
    [sym_parametrized_type_expression] = STATE(6378),
    [sym_call_expression] = STATE(6378),
    [sym_broadcast_call_expression] = STATE(6378),
    [sym__closed_macrocall_expression] = STATE(6378),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(6378),
    [sym_quote_expression] = STATE(6378),
    [sym_binary_expression] = STATE(8723),
    [sym_unary_expression] = STATE(8723),
    [sym_range_expression] = STATE(8723),
    [sym_splat_expression] = STATE(8723),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8270),
    [sym_unary_typed_expression] = STATE(8723),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8723),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(6378),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6378),
    [sym_string_literal] = STATE(6378),
    [sym_command_literal] = STATE(6378),
    [sym_prefixed_string_literal] = STATE(6378),
    [sym_prefixed_command_literal] = STATE(6378),
    [sym_operator] = STATE(8079),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(883),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [1936] = {
    [sym_assignment] = STATE(12039),
    [sym_open_tuple] = STATE(13740),
    [sym__expression] = STATE(13975),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11544),
    [sym__array] = STATE(11544),
    [sym_comprehension_expression] = STATE(11544),
    [sym_matrix_expression] = STATE(11544),
    [sym_vector_expression] = STATE(11544),
    [sym_parenthesized_expression] = STATE(11544),
    [sym_tuple_expression] = STATE(11544),
    [sym_curly_expression] = STATE(11544),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11544),
    [sym_index_expression] = STATE(11544),
    [sym_parametrized_type_expression] = STATE(11544),
    [sym_call_expression] = STATE(11544),
    [sym_broadcast_call_expression] = STATE(11544),
    [sym__closed_macrocall_expression] = STATE(11544),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11544),
    [sym_quote_expression] = STATE(11544),
    [sym_binary_expression] = STATE(13781),
    [sym_unary_expression] = STATE(13781),
    [sym_range_expression] = STATE(13781),
    [sym_splat_expression] = STATE(13781),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13485),
    [sym_unary_typed_expression] = STATE(13781),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13781),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11544),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11544),
    [sym_string_literal] = STATE(11544),
    [sym_command_literal] = STATE(11544),
    [sym_prefixed_string_literal] = STATE(11544),
    [sym_prefixed_command_literal] = STATE(11544),
    [sym_operator] = STATE(13486),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4112),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1937] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(19632),
    [sym__expression] = STATE(13055),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11242),
    [sym__array] = STATE(11242),
    [sym_comprehension_expression] = STATE(11242),
    [sym_matrix_expression] = STATE(11242),
    [sym_vector_expression] = STATE(11242),
    [sym_parenthesized_expression] = STATE(11242),
    [sym_tuple_expression] = STATE(11242),
    [sym_curly_expression] = STATE(11242),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11242),
    [sym_index_expression] = STATE(11242),
    [sym_parametrized_type_expression] = STATE(11242),
    [sym_call_expression] = STATE(11242),
    [sym_broadcast_call_expression] = STATE(11242),
    [sym__closed_macrocall_expression] = STATE(11242),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11242),
    [sym_quote_expression] = STATE(11242),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12994),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11242),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11242),
    [sym_string_literal] = STATE(11242),
    [sym_command_literal] = STATE(11242),
    [sym_prefixed_string_literal] = STATE(11242),
    [sym_prefixed_command_literal] = STATE(11242),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3164),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1938] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(19632),
    [sym__expression] = STATE(12905),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11242),
    [sym__array] = STATE(11242),
    [sym_comprehension_expression] = STATE(11242),
    [sym_matrix_expression] = STATE(11242),
    [sym_vector_expression] = STATE(11242),
    [sym_parenthesized_expression] = STATE(11242),
    [sym_tuple_expression] = STATE(11242),
    [sym_curly_expression] = STATE(11242),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11242),
    [sym_index_expression] = STATE(11242),
    [sym_parametrized_type_expression] = STATE(11242),
    [sym_call_expression] = STATE(11242),
    [sym_broadcast_call_expression] = STATE(11242),
    [sym__closed_macrocall_expression] = STATE(11242),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11242),
    [sym_quote_expression] = STATE(11242),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12994),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11242),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11242),
    [sym_string_literal] = STATE(11242),
    [sym_command_literal] = STATE(11242),
    [sym_prefixed_string_literal] = STATE(11242),
    [sym_prefixed_command_literal] = STATE(11242),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3164),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1939] = {
    [sym_assignment] = STATE(7797),
    [sym_open_tuple] = STATE(19154),
    [sym__expression] = STATE(8762),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8706),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1940] = {
    [sym_assignment] = STATE(7891),
    [sym_open_tuple] = STATE(19154),
    [sym__expression] = STATE(8763),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4859),
    [sym_comprehension_expression] = STATE(4859),
    [sym_matrix_expression] = STATE(4859),
    [sym_vector_expression] = STATE(4859),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_tuple_expression] = STATE(4859),
    [sym_curly_expression] = STATE(4859),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4859),
    [sym_index_expression] = STATE(4859),
    [sym_parametrized_type_expression] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_broadcast_call_expression] = STATE(4859),
    [sym__closed_macrocall_expression] = STATE(4859),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4859),
    [sym_quote_expression] = STATE(4859),
    [sym_binary_expression] = STATE(7900),
    [sym_unary_expression] = STATE(7900),
    [sym_range_expression] = STATE(7900),
    [sym_splat_expression] = STATE(7900),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7078),
    [sym_unary_typed_expression] = STATE(7900),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7900),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4859),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4859),
    [sym_string_literal] = STATE(4859),
    [sym_command_literal] = STATE(4859),
    [sym_prefixed_string_literal] = STATE(4859),
    [sym_prefixed_command_literal] = STATE(4859),
    [sym_operator] = STATE(7160),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8706),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [1941] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(19855),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11611),
    [sym__array] = STATE(11611),
    [sym_comprehension_expression] = STATE(11611),
    [sym_matrix_expression] = STATE(11611),
    [sym_vector_expression] = STATE(11611),
    [sym_parenthesized_expression] = STATE(11611),
    [sym_tuple_expression] = STATE(11611),
    [sym_curly_expression] = STATE(11611),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11611),
    [sym_index_expression] = STATE(11611),
    [sym_parametrized_type_expression] = STATE(11611),
    [sym_call_expression] = STATE(11611),
    [sym_broadcast_call_expression] = STATE(11611),
    [sym__closed_macrocall_expression] = STATE(11611),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11611),
    [sym_quote_expression] = STATE(11611),
    [sym_binary_expression] = STATE(14033),
    [sym_unary_expression] = STATE(14033),
    [sym_range_expression] = STATE(14033),
    [sym_splat_expression] = STATE(14033),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13892),
    [sym_unary_typed_expression] = STATE(14033),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14033),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11611),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11611),
    [sym_string_literal] = STATE(11611),
    [sym_command_literal] = STATE(11611),
    [sym_prefixed_string_literal] = STATE(11611),
    [sym_prefixed_command_literal] = STATE(11611),
    [sym_operator] = STATE(13912),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8894),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1942] = {
    [sym_assignment] = STATE(8935),
    [sym_open_tuple] = STATE(18728),
    [sym__expression] = STATE(8968),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8704),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1943] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(9609),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1944] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1945] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8900),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1946] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8902),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1947] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8904),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1948] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8906),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1949] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8908),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1950] = {
    [sym__expression] = STATE(13615),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17189),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8910),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1951] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(15336),
    [sym__expression] = STATE(13076),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11023),
    [sym__array] = STATE(11023),
    [sym_comprehension_expression] = STATE(11023),
    [sym_matrix_expression] = STATE(11023),
    [sym_vector_expression] = STATE(11023),
    [sym_parenthesized_expression] = STATE(11023),
    [sym_tuple_expression] = STATE(11023),
    [sym_curly_expression] = STATE(11023),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11023),
    [sym_index_expression] = STATE(11023),
    [sym_parametrized_type_expression] = STATE(11023),
    [sym_call_expression] = STATE(11023),
    [sym_broadcast_call_expression] = STATE(11023),
    [sym__closed_macrocall_expression] = STATE(11023),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11023),
    [sym_quote_expression] = STATE(11023),
    [sym_binary_expression] = STATE(13099),
    [sym_unary_expression] = STATE(13099),
    [sym_range_expression] = STATE(13099),
    [sym_splat_expression] = STATE(13099),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12587),
    [sym_unary_typed_expression] = STATE(13099),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13099),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11023),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11023),
    [sym_string_literal] = STATE(11023),
    [sym_command_literal] = STATE(11023),
    [sym_prefixed_string_literal] = STATE(11023),
    [sym_prefixed_command_literal] = STATE(11023),
    [sym_operator] = STATE(12589),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(6646),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1952] = {
    [sym_assignment] = STATE(9104),
    [sym_open_tuple] = STATE(18728),
    [sym__expression] = STATE(9004),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6347),
    [sym__array] = STATE(6347),
    [sym_comprehension_expression] = STATE(6347),
    [sym_matrix_expression] = STATE(6347),
    [sym_vector_expression] = STATE(6347),
    [sym_parenthesized_expression] = STATE(6347),
    [sym_tuple_expression] = STATE(6347),
    [sym_curly_expression] = STATE(6347),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6347),
    [sym_index_expression] = STATE(6347),
    [sym_parametrized_type_expression] = STATE(6347),
    [sym_call_expression] = STATE(6347),
    [sym_broadcast_call_expression] = STATE(6347),
    [sym__closed_macrocall_expression] = STATE(6347),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6347),
    [sym_quote_expression] = STATE(6347),
    [sym_binary_expression] = STATE(8880),
    [sym_unary_expression] = STATE(8880),
    [sym_range_expression] = STATE(8880),
    [sym_splat_expression] = STATE(8880),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8302),
    [sym_unary_typed_expression] = STATE(8880),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8880),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6347),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6347),
    [sym_string_literal] = STATE(6347),
    [sym_command_literal] = STATE(6347),
    [sym_prefixed_string_literal] = STATE(6347),
    [sym_prefixed_command_literal] = STATE(6347),
    [sym_operator] = STATE(8303),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(8704),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [1953] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8912),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1954] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8914),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1955] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8916),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1956] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8918),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1957] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8920),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1958] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8916),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1959] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8922),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1960] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8924),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1961] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8926),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1962] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8928),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1963] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8930),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1964] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8932),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1965] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8934),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1966] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8936),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1967] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(18935),
    [sym__expression] = STATE(13810),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11544),
    [sym__array] = STATE(11544),
    [sym_comprehension_expression] = STATE(11544),
    [sym_matrix_expression] = STATE(11544),
    [sym_vector_expression] = STATE(11544),
    [sym_parenthesized_expression] = STATE(11544),
    [sym_tuple_expression] = STATE(11544),
    [sym_curly_expression] = STATE(11544),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11544),
    [sym_index_expression] = STATE(11544),
    [sym_parametrized_type_expression] = STATE(11544),
    [sym_call_expression] = STATE(11544),
    [sym_broadcast_call_expression] = STATE(11544),
    [sym__closed_macrocall_expression] = STATE(11544),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11544),
    [sym_quote_expression] = STATE(11544),
    [sym_binary_expression] = STATE(13781),
    [sym_unary_expression] = STATE(13781),
    [sym_range_expression] = STATE(13781),
    [sym_splat_expression] = STATE(13781),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13485),
    [sym_unary_typed_expression] = STATE(13781),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13781),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11544),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11544),
    [sym_string_literal] = STATE(11544),
    [sym_command_literal] = STATE(11544),
    [sym_prefixed_string_literal] = STATE(11544),
    [sym_prefixed_command_literal] = STATE(11544),
    [sym_operator] = STATE(13486),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4112),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1968] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(18935),
    [sym__expression] = STATE(13813),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11544),
    [sym__array] = STATE(11544),
    [sym_comprehension_expression] = STATE(11544),
    [sym_matrix_expression] = STATE(11544),
    [sym_vector_expression] = STATE(11544),
    [sym_parenthesized_expression] = STATE(11544),
    [sym_tuple_expression] = STATE(11544),
    [sym_curly_expression] = STATE(11544),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11544),
    [sym_index_expression] = STATE(11544),
    [sym_parametrized_type_expression] = STATE(11544),
    [sym_call_expression] = STATE(11544),
    [sym_broadcast_call_expression] = STATE(11544),
    [sym__closed_macrocall_expression] = STATE(11544),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11544),
    [sym_quote_expression] = STATE(11544),
    [sym_binary_expression] = STATE(13781),
    [sym_unary_expression] = STATE(13781),
    [sym_range_expression] = STATE(13781),
    [sym_splat_expression] = STATE(13781),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13485),
    [sym_unary_typed_expression] = STATE(13781),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13781),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11544),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11544),
    [sym_string_literal] = STATE(11544),
    [sym_command_literal] = STATE(11544),
    [sym_prefixed_string_literal] = STATE(11544),
    [sym_prefixed_command_literal] = STATE(11544),
    [sym_operator] = STATE(13486),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4112),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1969] = {
    [sym_assignment] = STATE(12039),
    [sym_open_tuple] = STATE(13771),
    [sym__expression] = STATE(13492),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11496),
    [sym__array] = STATE(11496),
    [sym_comprehension_expression] = STATE(11496),
    [sym_matrix_expression] = STATE(11496),
    [sym_vector_expression] = STATE(11496),
    [sym_parenthesized_expression] = STATE(11496),
    [sym_tuple_expression] = STATE(11496),
    [sym_curly_expression] = STATE(11496),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11496),
    [sym_index_expression] = STATE(11496),
    [sym_parametrized_type_expression] = STATE(11496),
    [sym_call_expression] = STATE(11496),
    [sym_broadcast_call_expression] = STATE(11496),
    [sym__closed_macrocall_expression] = STATE(11496),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11496),
    [sym_quote_expression] = STATE(11496),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13592),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11496),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11496),
    [sym_string_literal] = STATE(11496),
    [sym_command_literal] = STATE(11496),
    [sym_prefixed_string_literal] = STATE(11496),
    [sym_prefixed_command_literal] = STATE(11496),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3398),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1970] = {
    [sym_assignment] = STATE(9094),
    [sym_open_tuple] = STATE(18728),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11633),
    [sym__array] = STATE(11633),
    [sym_comprehension_expression] = STATE(11633),
    [sym_matrix_expression] = STATE(11633),
    [sym_vector_expression] = STATE(11633),
    [sym_parenthesized_expression] = STATE(11633),
    [sym_tuple_expression] = STATE(11633),
    [sym_curly_expression] = STATE(11633),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11633),
    [sym_index_expression] = STATE(11633),
    [sym_parametrized_type_expression] = STATE(11633),
    [sym_call_expression] = STATE(11633),
    [sym_broadcast_call_expression] = STATE(11633),
    [sym__closed_macrocall_expression] = STATE(11633),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11633),
    [sym_quote_expression] = STATE(11633),
    [sym_binary_expression] = STATE(14025),
    [sym_unary_expression] = STATE(14025),
    [sym_range_expression] = STATE(14025),
    [sym_splat_expression] = STATE(14025),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13848),
    [sym_unary_typed_expression] = STATE(14025),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14025),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11633),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11633),
    [sym_string_literal] = STATE(11633),
    [sym_command_literal] = STATE(11633),
    [sym_prefixed_string_literal] = STATE(11633),
    [sym_prefixed_command_literal] = STATE(11633),
    [sym_operator] = STATE(13850),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8938),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1971] = {
    [sym_assignment] = STATE(11883),
    [sym_open_tuple] = STATE(13319),
    [sym__expression] = STATE(13321),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11231),
    [sym__array] = STATE(11231),
    [sym_comprehension_expression] = STATE(11231),
    [sym_matrix_expression] = STATE(11231),
    [sym_vector_expression] = STATE(11231),
    [sym_parenthesized_expression] = STATE(11231),
    [sym_tuple_expression] = STATE(11231),
    [sym_curly_expression] = STATE(11231),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11231),
    [sym_index_expression] = STATE(11231),
    [sym_parametrized_type_expression] = STATE(11231),
    [sym_call_expression] = STATE(11231),
    [sym_broadcast_call_expression] = STATE(11231),
    [sym__closed_macrocall_expression] = STATE(11231),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11231),
    [sym_quote_expression] = STATE(11231),
    [sym_binary_expression] = STATE(13208),
    [sym_unary_expression] = STATE(13208),
    [sym_range_expression] = STATE(13208),
    [sym_splat_expression] = STATE(13208),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13154),
    [sym_unary_typed_expression] = STATE(13208),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13208),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11231),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11231),
    [sym_string_literal] = STATE(11231),
    [sym_command_literal] = STATE(11231),
    [sym_prefixed_string_literal] = STATE(11231),
    [sym_prefixed_command_literal] = STATE(11231),
    [sym_operator] = STATE(13060),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3316),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1972] = {
    [sym_assignment] = STATE(11884),
    [sym_open_tuple] = STATE(13322),
    [sym__expression] = STATE(13323),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11231),
    [sym__array] = STATE(11231),
    [sym_comprehension_expression] = STATE(11231),
    [sym_matrix_expression] = STATE(11231),
    [sym_vector_expression] = STATE(11231),
    [sym_parenthesized_expression] = STATE(11231),
    [sym_tuple_expression] = STATE(11231),
    [sym_curly_expression] = STATE(11231),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11231),
    [sym_index_expression] = STATE(11231),
    [sym_parametrized_type_expression] = STATE(11231),
    [sym_call_expression] = STATE(11231),
    [sym_broadcast_call_expression] = STATE(11231),
    [sym__closed_macrocall_expression] = STATE(11231),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11231),
    [sym_quote_expression] = STATE(11231),
    [sym_binary_expression] = STATE(13208),
    [sym_unary_expression] = STATE(13208),
    [sym_range_expression] = STATE(13208),
    [sym_splat_expression] = STATE(13208),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13154),
    [sym_unary_typed_expression] = STATE(13208),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13208),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11231),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11231),
    [sym_string_literal] = STATE(11231),
    [sym_command_literal] = STATE(11231),
    [sym_prefixed_string_literal] = STATE(11231),
    [sym_prefixed_command_literal] = STATE(11231),
    [sym_operator] = STATE(13060),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3316),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1973] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(18673),
    [sym__expression] = STATE(13340),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11200),
    [sym__array] = STATE(11200),
    [sym_comprehension_expression] = STATE(11200),
    [sym_matrix_expression] = STATE(11200),
    [sym_vector_expression] = STATE(11200),
    [sym_parenthesized_expression] = STATE(11200),
    [sym_tuple_expression] = STATE(11200),
    [sym_curly_expression] = STATE(11200),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11200),
    [sym_index_expression] = STATE(11200),
    [sym_parametrized_type_expression] = STATE(11200),
    [sym_call_expression] = STATE(11200),
    [sym_broadcast_call_expression] = STATE(11200),
    [sym__closed_macrocall_expression] = STATE(11200),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11200),
    [sym_quote_expression] = STATE(11200),
    [sym_binary_expression] = STATE(13364),
    [sym_unary_expression] = STATE(13364),
    [sym_range_expression] = STATE(13364),
    [sym_splat_expression] = STATE(13364),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12999),
    [sym_unary_typed_expression] = STATE(13364),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13364),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11200),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11200),
    [sym_string_literal] = STATE(11200),
    [sym_command_literal] = STATE(11200),
    [sym_prefixed_string_literal] = STATE(11200),
    [sym_prefixed_command_literal] = STATE(11200),
    [sym_operator] = STATE(13000),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(8592),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1974] = {
    [sym_assignment] = STATE(8021),
    [sym_open_tuple] = STATE(7624),
    [sym__expression] = STATE(7424),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4606),
    [sym__array] = STATE(4606),
    [sym_comprehension_expression] = STATE(4606),
    [sym_matrix_expression] = STATE(4606),
    [sym_vector_expression] = STATE(4606),
    [sym_parenthesized_expression] = STATE(4606),
    [sym_tuple_expression] = STATE(4606),
    [sym_curly_expression] = STATE(4606),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4606),
    [sym_index_expression] = STATE(4606),
    [sym_parametrized_type_expression] = STATE(4606),
    [sym_call_expression] = STATE(4606),
    [sym_broadcast_call_expression] = STATE(4606),
    [sym__closed_macrocall_expression] = STATE(4606),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(4606),
    [sym_quote_expression] = STATE(4606),
    [sym_binary_expression] = STATE(7374),
    [sym_unary_expression] = STATE(7374),
    [sym_range_expression] = STATE(7374),
    [sym_splat_expression] = STATE(7374),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(7192),
    [sym_unary_typed_expression] = STATE(7374),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7374),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(4606),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4606),
    [sym_string_literal] = STATE(4606),
    [sym_command_literal] = STATE(4606),
    [sym_prefixed_string_literal] = STATE(4606),
    [sym_prefixed_command_literal] = STATE(4606),
    [sym_operator] = STATE(7163),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(8658),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [1975] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8940),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1976] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8942),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1977] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8944),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1978] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8946),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1979] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8948),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1980] = {
    [sym__expression] = STATE(13718),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16767),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8950),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1981] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8952),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1982] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(18544),
    [sym__expression] = STATE(13336),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11231),
    [sym__array] = STATE(11231),
    [sym_comprehension_expression] = STATE(11231),
    [sym_matrix_expression] = STATE(11231),
    [sym_vector_expression] = STATE(11231),
    [sym_parenthesized_expression] = STATE(11231),
    [sym_tuple_expression] = STATE(11231),
    [sym_curly_expression] = STATE(11231),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11231),
    [sym_index_expression] = STATE(11231),
    [sym_parametrized_type_expression] = STATE(11231),
    [sym_call_expression] = STATE(11231),
    [sym_broadcast_call_expression] = STATE(11231),
    [sym__closed_macrocall_expression] = STATE(11231),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11231),
    [sym_quote_expression] = STATE(11231),
    [sym_binary_expression] = STATE(13208),
    [sym_unary_expression] = STATE(13208),
    [sym_range_expression] = STATE(13208),
    [sym_splat_expression] = STATE(13208),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13154),
    [sym_unary_typed_expression] = STATE(13208),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13208),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11231),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11231),
    [sym_string_literal] = STATE(11231),
    [sym_command_literal] = STATE(11231),
    [sym_prefixed_string_literal] = STATE(11231),
    [sym_prefixed_command_literal] = STATE(11231),
    [sym_operator] = STATE(13060),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3316),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1983] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8914),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1984] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8954),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1985] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8956),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1986] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8958),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1987] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8954),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1988] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8960),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1989] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(13415),
    [sym__expression] = STATE(13416),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11220),
    [sym__array] = STATE(11220),
    [sym_comprehension_expression] = STATE(11220),
    [sym_matrix_expression] = STATE(11220),
    [sym_vector_expression] = STATE(11220),
    [sym_parenthesized_expression] = STATE(11220),
    [sym_tuple_expression] = STATE(11220),
    [sym_curly_expression] = STATE(11220),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11220),
    [sym_index_expression] = STATE(11220),
    [sym_parametrized_type_expression] = STATE(11220),
    [sym_call_expression] = STATE(11220),
    [sym_broadcast_call_expression] = STATE(11220),
    [sym__closed_macrocall_expression] = STATE(11220),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11220),
    [sym_quote_expression] = STATE(11220),
    [sym_binary_expression] = STATE(13251),
    [sym_unary_expression] = STATE(13251),
    [sym_range_expression] = STATE(13251),
    [sym_splat_expression] = STATE(13251),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13087),
    [sym_unary_typed_expression] = STATE(13251),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13251),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11220),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11220),
    [sym_string_literal] = STATE(11220),
    [sym_command_literal] = STATE(11220),
    [sym_prefixed_string_literal] = STATE(11220),
    [sym_prefixed_command_literal] = STATE(11220),
    [sym_operator] = STATE(13088),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(8574),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1990] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8962),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1991] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(13417),
    [sym__expression] = STATE(13418),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11220),
    [sym__array] = STATE(11220),
    [sym_comprehension_expression] = STATE(11220),
    [sym_matrix_expression] = STATE(11220),
    [sym_vector_expression] = STATE(11220),
    [sym_parenthesized_expression] = STATE(11220),
    [sym_tuple_expression] = STATE(11220),
    [sym_curly_expression] = STATE(11220),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11220),
    [sym_index_expression] = STATE(11220),
    [sym_parametrized_type_expression] = STATE(11220),
    [sym_call_expression] = STATE(11220),
    [sym_broadcast_call_expression] = STATE(11220),
    [sym__closed_macrocall_expression] = STATE(11220),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11220),
    [sym_quote_expression] = STATE(11220),
    [sym_binary_expression] = STATE(13251),
    [sym_unary_expression] = STATE(13251),
    [sym_range_expression] = STATE(13251),
    [sym_splat_expression] = STATE(13251),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13087),
    [sym_unary_typed_expression] = STATE(13251),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13251),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11220),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11220),
    [sym_string_literal] = STATE(11220),
    [sym_command_literal] = STATE(11220),
    [sym_prefixed_string_literal] = STATE(11220),
    [sym_prefixed_command_literal] = STATE(11220),
    [sym_operator] = STATE(13088),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(8574),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [1992] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8964),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1993] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8966),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1994] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8968),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1995] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8970),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1996] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8972),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1997] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(14502),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11643),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11643),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13739),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11221),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8598),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1998] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8974),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [1999] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8860),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2000] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(18565),
    [sym__expression] = STATE(13482),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11496),
    [sym__array] = STATE(11496),
    [sym_comprehension_expression] = STATE(11496),
    [sym_matrix_expression] = STATE(11496),
    [sym_vector_expression] = STATE(11496),
    [sym_parenthesized_expression] = STATE(11496),
    [sym_tuple_expression] = STATE(11496),
    [sym_curly_expression] = STATE(11496),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11496),
    [sym_index_expression] = STATE(11496),
    [sym_parametrized_type_expression] = STATE(11496),
    [sym_call_expression] = STATE(11496),
    [sym_broadcast_call_expression] = STATE(11496),
    [sym__closed_macrocall_expression] = STATE(11496),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11496),
    [sym_quote_expression] = STATE(11496),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13592),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11496),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11496),
    [sym_string_literal] = STATE(11496),
    [sym_command_literal] = STATE(11496),
    [sym_prefixed_string_literal] = STATE(11496),
    [sym_prefixed_command_literal] = STATE(11496),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3398),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2001] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(18565),
    [sym__expression] = STATE(13483),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11496),
    [sym__array] = STATE(11496),
    [sym_comprehension_expression] = STATE(11496),
    [sym_matrix_expression] = STATE(11496),
    [sym_vector_expression] = STATE(11496),
    [sym_parenthesized_expression] = STATE(11496),
    [sym_tuple_expression] = STATE(11496),
    [sym_curly_expression] = STATE(11496),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11496),
    [sym_index_expression] = STATE(11496),
    [sym_parametrized_type_expression] = STATE(11496),
    [sym_call_expression] = STATE(11496),
    [sym_broadcast_call_expression] = STATE(11496),
    [sym__closed_macrocall_expression] = STATE(11496),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11496),
    [sym_quote_expression] = STATE(11496),
    [sym_binary_expression] = STATE(12238),
    [sym_unary_expression] = STATE(12238),
    [sym_range_expression] = STATE(12238),
    [sym_splat_expression] = STATE(12238),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13592),
    [sym_unary_typed_expression] = STATE(12238),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12238),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11496),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11496),
    [sym_string_literal] = STATE(11496),
    [sym_command_literal] = STATE(11496),
    [sym_prefixed_string_literal] = STATE(11496),
    [sym_prefixed_command_literal] = STATE(11496),
    [sym_operator] = STATE(11691),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3398),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2002] = {
    [sym_assignment] = STATE(12236),
    [sym_open_tuple] = STATE(18544),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11573),
    [sym__array] = STATE(11573),
    [sym_comprehension_expression] = STATE(11573),
    [sym_matrix_expression] = STATE(11573),
    [sym_vector_expression] = STATE(11573),
    [sym_parenthesized_expression] = STATE(11573),
    [sym_tuple_expression] = STATE(11573),
    [sym_curly_expression] = STATE(11573),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11573),
    [sym_index_expression] = STATE(11573),
    [sym_parametrized_type_expression] = STATE(11573),
    [sym_call_expression] = STATE(11573),
    [sym_broadcast_call_expression] = STATE(11573),
    [sym__closed_macrocall_expression] = STATE(11573),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11573),
    [sym_quote_expression] = STATE(11573),
    [sym_binary_expression] = STATE(13208),
    [sym_unary_expression] = STATE(13208),
    [sym_range_expression] = STATE(13208),
    [sym_splat_expression] = STATE(13208),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13966),
    [sym_unary_typed_expression] = STATE(13208),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13208),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11573),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11573),
    [sym_string_literal] = STATE(11573),
    [sym_command_literal] = STATE(11573),
    [sym_prefixed_string_literal] = STATE(11573),
    [sym_prefixed_command_literal] = STATE(11573),
    [sym_operator] = STATE(13060),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8976),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2003] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(18544),
    [sym__expression] = STATE(13287),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11231),
    [sym__array] = STATE(11231),
    [sym_comprehension_expression] = STATE(11231),
    [sym_matrix_expression] = STATE(11231),
    [sym_vector_expression] = STATE(11231),
    [sym_parenthesized_expression] = STATE(11231),
    [sym_tuple_expression] = STATE(11231),
    [sym_curly_expression] = STATE(11231),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11231),
    [sym_index_expression] = STATE(11231),
    [sym_parametrized_type_expression] = STATE(11231),
    [sym_call_expression] = STATE(11231),
    [sym_broadcast_call_expression] = STATE(11231),
    [sym__closed_macrocall_expression] = STATE(11231),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11231),
    [sym_quote_expression] = STATE(11231),
    [sym_binary_expression] = STATE(13208),
    [sym_unary_expression] = STATE(13208),
    [sym_range_expression] = STATE(13208),
    [sym_splat_expression] = STATE(13208),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13154),
    [sym_unary_typed_expression] = STATE(13208),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13208),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11231),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11231),
    [sym_string_literal] = STATE(11231),
    [sym_command_literal] = STATE(11231),
    [sym_prefixed_string_literal] = STATE(11231),
    [sym_prefixed_command_literal] = STATE(11231),
    [sym_operator] = STATE(13060),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3316),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2004] = {
    [sym_assignment] = STATE(7730),
    [sym_open_tuple] = STATE(7731),
    [sym__expression] = STATE(7732),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8678),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [2005] = {
    [sym_assignment] = STATE(7733),
    [sym_open_tuple] = STATE(7734),
    [sym__expression] = STATE(7735),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8678),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [2006] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8670),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2007] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8978),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2008] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8980),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2009] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8982),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2010] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(8984),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2011] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(8986),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2012] = {
    [sym__expression] = STATE(13854),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17213),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8988),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2013] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8990),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2014] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8992),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2015] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8994),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2016] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8996),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2017] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8998),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2018] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9000),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2019] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9002),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2020] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9004),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2021] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(15137),
    [sym__expression] = STATE(12371),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10591),
    [sym__array] = STATE(10591),
    [sym_comprehension_expression] = STATE(10591),
    [sym_matrix_expression] = STATE(10591),
    [sym_vector_expression] = STATE(10591),
    [sym_parenthesized_expression] = STATE(10591),
    [sym_tuple_expression] = STATE(10591),
    [sym_curly_expression] = STATE(10591),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10591),
    [sym_index_expression] = STATE(10591),
    [sym_parametrized_type_expression] = STATE(10591),
    [sym_call_expression] = STATE(10591),
    [sym_broadcast_call_expression] = STATE(10591),
    [sym__closed_macrocall_expression] = STATE(10591),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10591),
    [sym_quote_expression] = STATE(10591),
    [sym_binary_expression] = STATE(12548),
    [sym_unary_expression] = STATE(12548),
    [sym_range_expression] = STATE(12548),
    [sym_splat_expression] = STATE(12548),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12177),
    [sym_unary_typed_expression] = STATE(12548),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12548),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10591),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10591),
    [sym_string_literal] = STATE(10591),
    [sym_command_literal] = STATE(10591),
    [sym_prefixed_string_literal] = STATE(10591),
    [sym_prefixed_command_literal] = STATE(10591),
    [sym_operator] = STATE(11882),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(4172),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2022] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9006),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2023] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9008),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2024] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9010),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2025] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9012),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2026] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9014),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2027] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9016),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2028] = {
    [sym_assignment] = STATE(7729),
    [sym_open_tuple] = STATE(19771),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11775),
    [sym__array] = STATE(11775),
    [sym_comprehension_expression] = STATE(11775),
    [sym_matrix_expression] = STATE(11775),
    [sym_vector_expression] = STATE(11775),
    [sym_parenthesized_expression] = STATE(11775),
    [sym_tuple_expression] = STATE(11775),
    [sym_curly_expression] = STATE(11775),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11775),
    [sym_index_expression] = STATE(11775),
    [sym_parametrized_type_expression] = STATE(11775),
    [sym_call_expression] = STATE(11775),
    [sym_broadcast_call_expression] = STATE(11775),
    [sym__closed_macrocall_expression] = STATE(11775),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11775),
    [sym_quote_expression] = STATE(11775),
    [sym_binary_expression] = STATE(14007),
    [sym_unary_expression] = STATE(14007),
    [sym_range_expression] = STATE(14007),
    [sym_splat_expression] = STATE(14007),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13993),
    [sym_unary_typed_expression] = STATE(14007),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14007),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11775),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11775),
    [sym_string_literal] = STATE(11775),
    [sym_command_literal] = STATE(11775),
    [sym_prefixed_string_literal] = STATE(11775),
    [sym_prefixed_command_literal] = STATE(11775),
    [sym_operator] = STATE(13646),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9018),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2029] = {
    [sym_assignment] = STATE(7797),
    [sym_open_tuple] = STATE(19771),
    [sym__expression] = STATE(7560),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8678),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [2030] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9020),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2031] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9022),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2032] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9024),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2033] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9026),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2034] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9028),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2035] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9030),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2036] = {
    [sym__expression] = STATE(13933),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17148),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9032),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2037] = {
    [sym_assignment] = STATE(7891),
    [sym_open_tuple] = STATE(19771),
    [sym__expression] = STATE(7578),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4953),
    [sym__array] = STATE(4953),
    [sym_comprehension_expression] = STATE(4953),
    [sym_matrix_expression] = STATE(4953),
    [sym_vector_expression] = STATE(4953),
    [sym_parenthesized_expression] = STATE(4953),
    [sym_tuple_expression] = STATE(4953),
    [sym_curly_expression] = STATE(4953),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4953),
    [sym_index_expression] = STATE(4953),
    [sym_parametrized_type_expression] = STATE(4953),
    [sym_call_expression] = STATE(4953),
    [sym_broadcast_call_expression] = STATE(4953),
    [sym__closed_macrocall_expression] = STATE(4953),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(4953),
    [sym_quote_expression] = STATE(4953),
    [sym_binary_expression] = STATE(7309),
    [sym_unary_expression] = STATE(7309),
    [sym_range_expression] = STATE(7309),
    [sym_splat_expression] = STATE(7309),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7038),
    [sym_unary_typed_expression] = STATE(7309),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7309),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(4953),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4953),
    [sym_string_literal] = STATE(4953),
    [sym_command_literal] = STATE(4953),
    [sym_prefixed_string_literal] = STATE(4953),
    [sym_prefixed_command_literal] = STATE(4953),
    [sym_operator] = STATE(7059),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(8678),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [2038] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9034),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2039] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8992),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2040] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9036),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2041] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9038),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2042] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9040),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2043] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9042),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2044] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9044),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2045] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9046),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2046] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(16538),
    [sym__expression] = STATE(13184),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2047] = {
    [sym_assignment] = STATE(8501),
    [sym_open_tuple] = STATE(8851),
    [sym__expression] = STATE(8852),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [2048] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9048),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2049] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9050),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2050] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9052),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2051] = {
    [sym_assignment] = STATE(8502),
    [sym_open_tuple] = STATE(8855),
    [sym__expression] = STATE(8856),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [2052] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9054),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2053] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9056),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2054] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9058),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2055] = {
    [sym_assignment] = STATE(8500),
    [sym_open_tuple] = STATE(19490),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11626),
    [sym__array] = STATE(11626),
    [sym_comprehension_expression] = STATE(11626),
    [sym_matrix_expression] = STATE(11626),
    [sym_vector_expression] = STATE(11626),
    [sym_parenthesized_expression] = STATE(11626),
    [sym_tuple_expression] = STATE(11626),
    [sym_curly_expression] = STATE(11626),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11626),
    [sym_index_expression] = STATE(11626),
    [sym_parametrized_type_expression] = STATE(11626),
    [sym_call_expression] = STATE(11626),
    [sym_broadcast_call_expression] = STATE(11626),
    [sym__closed_macrocall_expression] = STATE(11626),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11626),
    [sym_quote_expression] = STATE(11626),
    [sym_binary_expression] = STATE(14021),
    [sym_unary_expression] = STATE(14021),
    [sym_range_expression] = STATE(14021),
    [sym_splat_expression] = STATE(14021),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13847),
    [sym_unary_typed_expression] = STATE(14021),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14021),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11626),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11626),
    [sym_string_literal] = STATE(11626),
    [sym_command_literal] = STATE(11626),
    [sym_prefixed_string_literal] = STATE(11626),
    [sym_prefixed_command_literal] = STATE(11626),
    [sym_operator] = STATE(13798),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9060),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2056] = {
    [sym_assignment] = STATE(12797),
    [sym_open_tuple] = STATE(14953),
    [sym__expression] = STATE(12520),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10874),
    [sym__array] = STATE(10874),
    [sym_comprehension_expression] = STATE(10874),
    [sym_matrix_expression] = STATE(10874),
    [sym_vector_expression] = STATE(10874),
    [sym_parenthesized_expression] = STATE(10874),
    [sym_tuple_expression] = STATE(10874),
    [sym_curly_expression] = STATE(10874),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10874),
    [sym_index_expression] = STATE(10874),
    [sym_parametrized_type_expression] = STATE(10874),
    [sym_call_expression] = STATE(10874),
    [sym_broadcast_call_expression] = STATE(10874),
    [sym__closed_macrocall_expression] = STATE(10874),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10874),
    [sym_quote_expression] = STATE(10874),
    [sym_binary_expression] = STATE(12259),
    [sym_unary_expression] = STATE(12259),
    [sym_range_expression] = STATE(12259),
    [sym_splat_expression] = STATE(12259),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11948),
    [sym_unary_typed_expression] = STATE(12259),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12259),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10874),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10874),
    [sym_string_literal] = STATE(10874),
    [sym_command_literal] = STATE(10874),
    [sym_prefixed_string_literal] = STATE(10874),
    [sym_prefixed_command_literal] = STATE(10874),
    [sym_operator] = STATE(12127),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(5002),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [2057] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9062),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2058] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9064),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2059] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9066),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2060] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9068),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2061] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9070),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2062] = {
    [sym__expression] = STATE(13628),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16994),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9072),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2063] = {
    [sym_assignment] = STATE(8597),
    [sym_open_tuple] = STATE(19490),
    [sym__expression] = STATE(8975),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [2064] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9074),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2065] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9076),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2066] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9078),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2067] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9080),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2068] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9082),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2069] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9084),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2070] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9086),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2071] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9088),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2072] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9090),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2073] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9092),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2074] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9094),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2075] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9096),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2076] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9098),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2077] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8902),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2078] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(18998),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11759),
    [sym__array] = STATE(11759),
    [sym_comprehension_expression] = STATE(11759),
    [sym_matrix_expression] = STATE(11759),
    [sym_vector_expression] = STATE(11759),
    [sym_parenthesized_expression] = STATE(11759),
    [sym_tuple_expression] = STATE(11759),
    [sym_curly_expression] = STATE(11759),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11759),
    [sym_index_expression] = STATE(11759),
    [sym_parametrized_type_expression] = STATE(11759),
    [sym_call_expression] = STATE(11759),
    [sym_broadcast_call_expression] = STATE(11759),
    [sym__closed_macrocall_expression] = STATE(11759),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11759),
    [sym_quote_expression] = STATE(11759),
    [sym_binary_expression] = STATE(14073),
    [sym_unary_expression] = STATE(14073),
    [sym_range_expression] = STATE(14073),
    [sym_splat_expression] = STATE(14073),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13741),
    [sym_unary_typed_expression] = STATE(14073),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14073),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11759),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11759),
    [sym_string_literal] = STATE(11759),
    [sym_command_literal] = STATE(11759),
    [sym_prefixed_string_literal] = STATE(11759),
    [sym_prefixed_command_literal] = STATE(11759),
    [sym_operator] = STATE(13745),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9100),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2079] = {
    [sym_assignment] = STATE(8267),
    [sym_open_tuple] = STATE(19490),
    [sym__expression] = STATE(9001),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6361),
    [sym__array] = STATE(6361),
    [sym_comprehension_expression] = STATE(6361),
    [sym_matrix_expression] = STATE(6361),
    [sym_vector_expression] = STATE(6361),
    [sym_parenthesized_expression] = STATE(6361),
    [sym_tuple_expression] = STATE(6361),
    [sym_curly_expression] = STATE(6361),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6361),
    [sym_index_expression] = STATE(6361),
    [sym_parametrized_type_expression] = STATE(6361),
    [sym_call_expression] = STATE(6361),
    [sym_broadcast_call_expression] = STATE(6361),
    [sym__closed_macrocall_expression] = STATE(6361),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6361),
    [sym_quote_expression] = STATE(6361),
    [sym_binary_expression] = STATE(8981),
    [sym_unary_expression] = STATE(8981),
    [sym_range_expression] = STATE(8981),
    [sym_splat_expression] = STATE(8981),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8203),
    [sym_unary_typed_expression] = STATE(8981),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8981),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6361),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6361),
    [sym_string_literal] = STATE(6361),
    [sym_command_literal] = STATE(6361),
    [sym_prefixed_string_literal] = STATE(6361),
    [sym_prefixed_command_literal] = STATE(6361),
    [sym_operator] = STATE(8264),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1171),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [2080] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9102),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2081] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9104),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2082] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(12482),
    [sym__expression] = STATE(12484),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10572),
    [sym__array] = STATE(10572),
    [sym_comprehension_expression] = STATE(10572),
    [sym_matrix_expression] = STATE(10572),
    [sym_vector_expression] = STATE(10572),
    [sym_parenthesized_expression] = STATE(10572),
    [sym_tuple_expression] = STATE(10572),
    [sym_curly_expression] = STATE(10572),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10572),
    [sym_index_expression] = STATE(10572),
    [sym_parametrized_type_expression] = STATE(10572),
    [sym_call_expression] = STATE(10572),
    [sym_broadcast_call_expression] = STATE(10572),
    [sym__closed_macrocall_expression] = STATE(10572),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10572),
    [sym_quote_expression] = STATE(10572),
    [sym_binary_expression] = STATE(12674),
    [sym_unary_expression] = STATE(12674),
    [sym_range_expression] = STATE(12674),
    [sym_splat_expression] = STATE(12674),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12045),
    [sym_unary_typed_expression] = STATE(12674),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12674),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10572),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10572),
    [sym_string_literal] = STATE(10572),
    [sym_command_literal] = STATE(10572),
    [sym_prefixed_string_literal] = STATE(10572),
    [sym_prefixed_command_literal] = STATE(10572),
    [sym_operator] = STATE(11874),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(8708),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2083] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9106),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2084] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9108),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2085] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(12485),
    [sym__expression] = STATE(12486),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10572),
    [sym__array] = STATE(10572),
    [sym_comprehension_expression] = STATE(10572),
    [sym_matrix_expression] = STATE(10572),
    [sym_vector_expression] = STATE(10572),
    [sym_parenthesized_expression] = STATE(10572),
    [sym_tuple_expression] = STATE(10572),
    [sym_curly_expression] = STATE(10572),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10572),
    [sym_index_expression] = STATE(10572),
    [sym_parametrized_type_expression] = STATE(10572),
    [sym_call_expression] = STATE(10572),
    [sym_broadcast_call_expression] = STATE(10572),
    [sym__closed_macrocall_expression] = STATE(10572),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10572),
    [sym_quote_expression] = STATE(10572),
    [sym_binary_expression] = STATE(12674),
    [sym_unary_expression] = STATE(12674),
    [sym_range_expression] = STATE(12674),
    [sym_splat_expression] = STATE(12674),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12045),
    [sym_unary_typed_expression] = STATE(12674),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12674),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10572),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10572),
    [sym_string_literal] = STATE(10572),
    [sym_command_literal] = STATE(10572),
    [sym_prefixed_string_literal] = STATE(10572),
    [sym_prefixed_command_literal] = STATE(10572),
    [sym_operator] = STATE(11874),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(8708),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2086] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9110),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2087] = {
    [sym__expression] = STATE(13712),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16752),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9112),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2088] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9114),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2089] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9076),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2090] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9116),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2091] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9118),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2092] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9120),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2093] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9122),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2094] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9124),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2095] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9126),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2096] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9128),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2097] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9130),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2098] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9132),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2099] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9134),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2100] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(15210),
    [sym__expression] = STATE(13071),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11023),
    [sym__array] = STATE(11023),
    [sym_comprehension_expression] = STATE(11023),
    [sym_matrix_expression] = STATE(11023),
    [sym_vector_expression] = STATE(11023),
    [sym_parenthesized_expression] = STATE(11023),
    [sym_tuple_expression] = STATE(11023),
    [sym_curly_expression] = STATE(11023),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11023),
    [sym_index_expression] = STATE(11023),
    [sym_parametrized_type_expression] = STATE(11023),
    [sym_call_expression] = STATE(11023),
    [sym_broadcast_call_expression] = STATE(11023),
    [sym__closed_macrocall_expression] = STATE(11023),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11023),
    [sym_quote_expression] = STATE(11023),
    [sym_binary_expression] = STATE(13099),
    [sym_unary_expression] = STATE(13099),
    [sym_range_expression] = STATE(13099),
    [sym_splat_expression] = STATE(13099),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12587),
    [sym_unary_typed_expression] = STATE(13099),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13099),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11023),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11023),
    [sym_string_literal] = STATE(11023),
    [sym_command_literal] = STATE(11023),
    [sym_prefixed_string_literal] = STATE(11023),
    [sym_prefixed_command_literal] = STATE(11023),
    [sym_operator] = STATE(12589),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(6646),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2101] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9136),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2102] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9138),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2103] = {
    [sym_assignment] = STATE(12496),
    [sym_open_tuple] = STATE(19266),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11669),
    [sym__array] = STATE(11669),
    [sym_comprehension_expression] = STATE(11669),
    [sym_matrix_expression] = STATE(11669),
    [sym_vector_expression] = STATE(11669),
    [sym_parenthesized_expression] = STATE(11669),
    [sym_tuple_expression] = STATE(11669),
    [sym_curly_expression] = STATE(11669),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11669),
    [sym_index_expression] = STATE(11669),
    [sym_parametrized_type_expression] = STATE(11669),
    [sym_call_expression] = STATE(11669),
    [sym_broadcast_call_expression] = STATE(11669),
    [sym__closed_macrocall_expression] = STATE(11669),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11669),
    [sym_quote_expression] = STATE(11669),
    [sym_binary_expression] = STATE(14064),
    [sym_unary_expression] = STATE(14064),
    [sym_range_expression] = STATE(14064),
    [sym_splat_expression] = STATE(14064),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13866),
    [sym_unary_typed_expression] = STATE(14064),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14064),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11669),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11669),
    [sym_string_literal] = STATE(11669),
    [sym_command_literal] = STATE(11669),
    [sym_prefixed_string_literal] = STATE(11669),
    [sym_prefixed_command_literal] = STATE(11669),
    [sym_operator] = STATE(13869),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9140),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2104] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(18998),
    [sym__expression] = STATE(12599),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10572),
    [sym__array] = STATE(10572),
    [sym_comprehension_expression] = STATE(10572),
    [sym_matrix_expression] = STATE(10572),
    [sym_vector_expression] = STATE(10572),
    [sym_parenthesized_expression] = STATE(10572),
    [sym_tuple_expression] = STATE(10572),
    [sym_curly_expression] = STATE(10572),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10572),
    [sym_index_expression] = STATE(10572),
    [sym_parametrized_type_expression] = STATE(10572),
    [sym_call_expression] = STATE(10572),
    [sym_broadcast_call_expression] = STATE(10572),
    [sym__closed_macrocall_expression] = STATE(10572),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10572),
    [sym_quote_expression] = STATE(10572),
    [sym_binary_expression] = STATE(12674),
    [sym_unary_expression] = STATE(12674),
    [sym_range_expression] = STATE(12674),
    [sym_splat_expression] = STATE(12674),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12045),
    [sym_unary_typed_expression] = STATE(12674),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12674),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10572),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10572),
    [sym_string_literal] = STATE(10572),
    [sym_command_literal] = STATE(10572),
    [sym_prefixed_string_literal] = STATE(10572),
    [sym_prefixed_command_literal] = STATE(10572),
    [sym_operator] = STATE(11874),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(8708),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2105] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9142),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2106] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9144),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2107] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9146),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2108] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9148),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2109] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9150),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2110] = {
    [sym__expression] = STATE(13815),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16909),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9152),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2111] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(18998),
    [sym__expression] = STATE(12699),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10572),
    [sym__array] = STATE(10572),
    [sym_comprehension_expression] = STATE(10572),
    [sym_matrix_expression] = STATE(10572),
    [sym_vector_expression] = STATE(10572),
    [sym_parenthesized_expression] = STATE(10572),
    [sym_tuple_expression] = STATE(10572),
    [sym_curly_expression] = STATE(10572),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10572),
    [sym_index_expression] = STATE(10572),
    [sym_parametrized_type_expression] = STATE(10572),
    [sym_call_expression] = STATE(10572),
    [sym_broadcast_call_expression] = STATE(10572),
    [sym__closed_macrocall_expression] = STATE(10572),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10572),
    [sym_quote_expression] = STATE(10572),
    [sym_binary_expression] = STATE(12674),
    [sym_unary_expression] = STATE(12674),
    [sym_range_expression] = STATE(12674),
    [sym_splat_expression] = STATE(12674),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12045),
    [sym_unary_typed_expression] = STATE(12674),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12674),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10572),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10572),
    [sym_string_literal] = STATE(10572),
    [sym_command_literal] = STATE(10572),
    [sym_prefixed_string_literal] = STATE(10572),
    [sym_prefixed_command_literal] = STATE(10572),
    [sym_operator] = STATE(11874),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(8708),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2112] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9154),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2113] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9156),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2114] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9000),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2115] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9158),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2116] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9160),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2117] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9162),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2118] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9164),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2119] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9166),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2120] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9168),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2121] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9170),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2122] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2123] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9174),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2124] = {
    [sym_assignment] = STATE(12497),
    [sym_open_tuple] = STATE(12776),
    [sym__expression] = STATE(12498),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10761),
    [sym__array] = STATE(10761),
    [sym_comprehension_expression] = STATE(10761),
    [sym_matrix_expression] = STATE(10761),
    [sym_vector_expression] = STATE(10761),
    [sym_parenthesized_expression] = STATE(10761),
    [sym_tuple_expression] = STATE(10761),
    [sym_curly_expression] = STATE(10761),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10761),
    [sym_index_expression] = STATE(10761),
    [sym_parametrized_type_expression] = STATE(10761),
    [sym_call_expression] = STATE(10761),
    [sym_broadcast_call_expression] = STATE(10761),
    [sym__closed_macrocall_expression] = STATE(10761),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10761),
    [sym_quote_expression] = STATE(10761),
    [sym_binary_expression] = STATE(12424),
    [sym_unary_expression] = STATE(12424),
    [sym_range_expression] = STATE(12424),
    [sym_splat_expression] = STATE(12424),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11976),
    [sym_unary_typed_expression] = STATE(12424),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12424),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10761),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10761),
    [sym_string_literal] = STATE(10761),
    [sym_command_literal] = STATE(10761),
    [sym_prefixed_string_literal] = STATE(10761),
    [sym_prefixed_command_literal] = STATE(10761),
    [sym_operator] = STATE(11888),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(8710),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [2125] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9176),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2126] = {
    [sym_assignment] = STATE(12499),
    [sym_open_tuple] = STATE(12777),
    [sym__expression] = STATE(12502),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10761),
    [sym__array] = STATE(10761),
    [sym_comprehension_expression] = STATE(10761),
    [sym_matrix_expression] = STATE(10761),
    [sym_vector_expression] = STATE(10761),
    [sym_parenthesized_expression] = STATE(10761),
    [sym_tuple_expression] = STATE(10761),
    [sym_curly_expression] = STATE(10761),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10761),
    [sym_index_expression] = STATE(10761),
    [sym_parametrized_type_expression] = STATE(10761),
    [sym_call_expression] = STATE(10761),
    [sym_broadcast_call_expression] = STATE(10761),
    [sym__closed_macrocall_expression] = STATE(10761),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10761),
    [sym_quote_expression] = STATE(10761),
    [sym_binary_expression] = STATE(12424),
    [sym_unary_expression] = STATE(12424),
    [sym_range_expression] = STATE(12424),
    [sym_splat_expression] = STATE(12424),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11976),
    [sym_unary_typed_expression] = STATE(12424),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12424),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10761),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10761),
    [sym_string_literal] = STATE(10761),
    [sym_command_literal] = STATE(10761),
    [sym_prefixed_string_literal] = STATE(10761),
    [sym_prefixed_command_literal] = STATE(10761),
    [sym_operator] = STATE(11888),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(8710),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [2127] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9178),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2128] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(18185),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11764),
    [sym__array] = STATE(11764),
    [sym_comprehension_expression] = STATE(11764),
    [sym_matrix_expression] = STATE(11764),
    [sym_vector_expression] = STATE(11764),
    [sym_parenthesized_expression] = STATE(11764),
    [sym_tuple_expression] = STATE(11764),
    [sym_curly_expression] = STATE(11764),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11764),
    [sym_index_expression] = STATE(11764),
    [sym_parametrized_type_expression] = STATE(11764),
    [sym_call_expression] = STATE(11764),
    [sym_broadcast_call_expression] = STATE(11764),
    [sym__closed_macrocall_expression] = STATE(11764),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11764),
    [sym_quote_expression] = STATE(11764),
    [sym_binary_expression] = STATE(14097),
    [sym_unary_expression] = STATE(14097),
    [sym_range_expression] = STATE(14097),
    [sym_splat_expression] = STATE(14097),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13938),
    [sym_unary_typed_expression] = STATE(14097),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14097),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11764),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11764),
    [sym_string_literal] = STATE(11764),
    [sym_command_literal] = STATE(11764),
    [sym_prefixed_string_literal] = STATE(11764),
    [sym_prefixed_command_literal] = STATE(11764),
    [sym_operator] = STATE(13940),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9180),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2129] = {
    [sym_assignment] = STATE(8393),
    [sym_open_tuple] = STATE(8485),
    [sym__expression] = STATE(8286),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(9182),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [2130] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9184),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2131] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9186),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2132] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9188),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2133] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9190),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2134] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9192),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2135] = {
    [sym__expression] = STATE(13875),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17276),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9194),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2136] = {
    [sym_assignment] = STATE(12597),
    [sym_open_tuple] = STATE(19266),
    [sym__expression] = STATE(12809),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10761),
    [sym__array] = STATE(10761),
    [sym_comprehension_expression] = STATE(10761),
    [sym_matrix_expression] = STATE(10761),
    [sym_vector_expression] = STATE(10761),
    [sym_parenthesized_expression] = STATE(10761),
    [sym_tuple_expression] = STATE(10761),
    [sym_curly_expression] = STATE(10761),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10761),
    [sym_index_expression] = STATE(10761),
    [sym_parametrized_type_expression] = STATE(10761),
    [sym_call_expression] = STATE(10761),
    [sym_broadcast_call_expression] = STATE(10761),
    [sym__closed_macrocall_expression] = STATE(10761),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10761),
    [sym_quote_expression] = STATE(10761),
    [sym_binary_expression] = STATE(12424),
    [sym_unary_expression] = STATE(12424),
    [sym_range_expression] = STATE(12424),
    [sym_splat_expression] = STATE(12424),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11976),
    [sym_unary_typed_expression] = STATE(12424),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12424),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10761),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10761),
    [sym_string_literal] = STATE(10761),
    [sym_command_literal] = STATE(10761),
    [sym_prefixed_string_literal] = STATE(10761),
    [sym_prefixed_command_literal] = STATE(10761),
    [sym_operator] = STATE(11888),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(8710),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [2137] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9196),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2138] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9156),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2139] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9198),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2140] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9200),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2141] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9202),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2142] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9204),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2143] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9206),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2144] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9208),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2145] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9210),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2146] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2147] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9214),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2148] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9216),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2149] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9218),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2150] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8942),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2151] = {
    [sym_assignment] = STATE(8285),
    [sym_open_tuple] = STATE(19423),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11714),
    [sym__array] = STATE(11714),
    [sym_comprehension_expression] = STATE(11714),
    [sym_matrix_expression] = STATE(11714),
    [sym_vector_expression] = STATE(11714),
    [sym_parenthesized_expression] = STATE(11714),
    [sym_tuple_expression] = STATE(11714),
    [sym_curly_expression] = STATE(11714),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11714),
    [sym_index_expression] = STATE(11714),
    [sym_parametrized_type_expression] = STATE(11714),
    [sym_call_expression] = STATE(11714),
    [sym_broadcast_call_expression] = STATE(11714),
    [sym__closed_macrocall_expression] = STATE(11714),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11714),
    [sym_quote_expression] = STATE(11714),
    [sym_binary_expression] = STATE(14133),
    [sym_unary_expression] = STATE(14133),
    [sym_range_expression] = STATE(14133),
    [sym_splat_expression] = STATE(14133),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13630),
    [sym_unary_typed_expression] = STATE(14133),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14133),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11714),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11714),
    [sym_string_literal] = STATE(11714),
    [sym_command_literal] = STATE(11714),
    [sym_prefixed_string_literal] = STATE(11714),
    [sym_prefixed_command_literal] = STATE(11714),
    [sym_operator] = STATE(13631),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9220),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2152] = {
    [sym_assignment] = STATE(12695),
    [sym_open_tuple] = STATE(19266),
    [sym__expression] = STATE(12267),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10761),
    [sym__array] = STATE(10761),
    [sym_comprehension_expression] = STATE(10761),
    [sym_matrix_expression] = STATE(10761),
    [sym_vector_expression] = STATE(10761),
    [sym_parenthesized_expression] = STATE(10761),
    [sym_tuple_expression] = STATE(10761),
    [sym_curly_expression] = STATE(10761),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10761),
    [sym_index_expression] = STATE(10761),
    [sym_parametrized_type_expression] = STATE(10761),
    [sym_call_expression] = STATE(10761),
    [sym_broadcast_call_expression] = STATE(10761),
    [sym__closed_macrocall_expression] = STATE(10761),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(10761),
    [sym_quote_expression] = STATE(10761),
    [sym_binary_expression] = STATE(12424),
    [sym_unary_expression] = STATE(12424),
    [sym_range_expression] = STATE(12424),
    [sym_splat_expression] = STATE(12424),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(11976),
    [sym_unary_typed_expression] = STATE(12424),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12424),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(10761),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10761),
    [sym_string_literal] = STATE(10761),
    [sym_command_literal] = STATE(10761),
    [sym_prefixed_string_literal] = STATE(10761),
    [sym_prefixed_command_literal] = STATE(10761),
    [sym_operator] = STATE(11888),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(8710),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [2153] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9222),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2154] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9224),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2155] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9226),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2156] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9228),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2157] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9230),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2158] = {
    [sym__expression] = STATE(13643),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16920),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9232),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2159] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9234),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2160] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9236),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2161] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9042),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2162] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9238),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2163] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9240),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2164] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9242),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2165] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9244),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2166] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(19044),
    [sym__expression] = STATE(13236),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11220),
    [sym__array] = STATE(11220),
    [sym_comprehension_expression] = STATE(11220),
    [sym_matrix_expression] = STATE(11220),
    [sym_vector_expression] = STATE(11220),
    [sym_parenthesized_expression] = STATE(11220),
    [sym_tuple_expression] = STATE(11220),
    [sym_curly_expression] = STATE(11220),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11220),
    [sym_index_expression] = STATE(11220),
    [sym_parametrized_type_expression] = STATE(11220),
    [sym_call_expression] = STATE(11220),
    [sym_broadcast_call_expression] = STATE(11220),
    [sym__closed_macrocall_expression] = STATE(11220),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11220),
    [sym_quote_expression] = STATE(11220),
    [sym_binary_expression] = STATE(13251),
    [sym_unary_expression] = STATE(13251),
    [sym_range_expression] = STATE(13251),
    [sym_splat_expression] = STATE(13251),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13087),
    [sym_unary_typed_expression] = STATE(13251),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13251),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11220),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11220),
    [sym_string_literal] = STATE(11220),
    [sym_command_literal] = STATE(11220),
    [sym_prefixed_string_literal] = STATE(11220),
    [sym_prefixed_command_literal] = STATE(11220),
    [sym_operator] = STATE(13088),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(8574),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2167] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9246),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2168] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(13029),
    [sym__expression] = STATE(13044),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11131),
    [sym__array] = STATE(11131),
    [sym_comprehension_expression] = STATE(11131),
    [sym_matrix_expression] = STATE(11131),
    [sym_vector_expression] = STATE(11131),
    [sym_parenthesized_expression] = STATE(11131),
    [sym_tuple_expression] = STATE(11131),
    [sym_curly_expression] = STATE(11131),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11131),
    [sym_index_expression] = STATE(11131),
    [sym_parametrized_type_expression] = STATE(11131),
    [sym_call_expression] = STATE(11131),
    [sym_broadcast_call_expression] = STATE(11131),
    [sym__closed_macrocall_expression] = STATE(11131),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11131),
    [sym_quote_expression] = STATE(11131),
    [sym_binary_expression] = STATE(13174),
    [sym_unary_expression] = STATE(13174),
    [sym_range_expression] = STATE(13174),
    [sym_splat_expression] = STATE(13174),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12720),
    [sym_unary_typed_expression] = STATE(13174),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13174),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11131),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11131),
    [sym_string_literal] = STATE(11131),
    [sym_command_literal] = STATE(11131),
    [sym_prefixed_string_literal] = STATE(11131),
    [sym_prefixed_command_literal] = STATE(11131),
    [sym_operator] = STATE(12722),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(8714),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2169] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(13176),
    [sym__expression] = STATE(13054),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11131),
    [sym__array] = STATE(11131),
    [sym_comprehension_expression] = STATE(11131),
    [sym_matrix_expression] = STATE(11131),
    [sym_vector_expression] = STATE(11131),
    [sym_parenthesized_expression] = STATE(11131),
    [sym_tuple_expression] = STATE(11131),
    [sym_curly_expression] = STATE(11131),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11131),
    [sym_index_expression] = STATE(11131),
    [sym_parametrized_type_expression] = STATE(11131),
    [sym_call_expression] = STATE(11131),
    [sym_broadcast_call_expression] = STATE(11131),
    [sym__closed_macrocall_expression] = STATE(11131),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11131),
    [sym_quote_expression] = STATE(11131),
    [sym_binary_expression] = STATE(13174),
    [sym_unary_expression] = STATE(13174),
    [sym_range_expression] = STATE(13174),
    [sym_splat_expression] = STATE(13174),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12720),
    [sym_unary_typed_expression] = STATE(13174),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13174),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11131),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11131),
    [sym_string_literal] = STATE(11131),
    [sym_command_literal] = STATE(11131),
    [sym_prefixed_string_literal] = STATE(11131),
    [sym_prefixed_command_literal] = STATE(11131),
    [sym_operator] = STATE(12722),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(8714),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2170] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9248),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2171] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9250),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2172] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9252),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2173] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9254),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2174] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9256),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2175] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9258),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2176] = {
    [sym_assignment] = STATE(12236),
    [sym_open_tuple] = STATE(19632),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11595),
    [sym__array] = STATE(11595),
    [sym_comprehension_expression] = STATE(11595),
    [sym_matrix_expression] = STATE(11595),
    [sym_vector_expression] = STATE(11595),
    [sym_parenthesized_expression] = STATE(11595),
    [sym_tuple_expression] = STATE(11595),
    [sym_curly_expression] = STATE(11595),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11595),
    [sym_index_expression] = STATE(11595),
    [sym_parametrized_type_expression] = STATE(11595),
    [sym_call_expression] = STATE(11595),
    [sym_broadcast_call_expression] = STATE(11595),
    [sym__closed_macrocall_expression] = STATE(11595),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11595),
    [sym_quote_expression] = STATE(11595),
    [sym_binary_expression] = STATE(14015),
    [sym_unary_expression] = STATE(14015),
    [sym_range_expression] = STATE(14015),
    [sym_splat_expression] = STATE(14015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13716),
    [sym_unary_typed_expression] = STATE(14015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11595),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11595),
    [sym_string_literal] = STATE(11595),
    [sym_command_literal] = STATE(11595),
    [sym_prefixed_string_literal] = STATE(11595),
    [sym_prefixed_command_literal] = STATE(11595),
    [sym_operator] = STATE(13717),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9260),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2177] = {
    [sym_assignment] = STATE(12039),
    [sym_open_tuple] = STATE(13405),
    [sym__expression] = STATE(13204),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11231),
    [sym__array] = STATE(11231),
    [sym_comprehension_expression] = STATE(11231),
    [sym_matrix_expression] = STATE(11231),
    [sym_vector_expression] = STATE(11231),
    [sym_parenthesized_expression] = STATE(11231),
    [sym_tuple_expression] = STATE(11231),
    [sym_curly_expression] = STATE(11231),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11231),
    [sym_index_expression] = STATE(11231),
    [sym_parametrized_type_expression] = STATE(11231),
    [sym_call_expression] = STATE(11231),
    [sym_broadcast_call_expression] = STATE(11231),
    [sym__closed_macrocall_expression] = STATE(11231),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11231),
    [sym_quote_expression] = STATE(11231),
    [sym_binary_expression] = STATE(13208),
    [sym_unary_expression] = STATE(13208),
    [sym_range_expression] = STATE(13208),
    [sym_splat_expression] = STATE(13208),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13154),
    [sym_unary_typed_expression] = STATE(13208),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13208),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11231),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11231),
    [sym_string_literal] = STATE(11231),
    [sym_command_literal] = STATE(11231),
    [sym_prefixed_string_literal] = STATE(11231),
    [sym_prefixed_command_literal] = STATE(11231),
    [sym_operator] = STATE(13060),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3316),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2178] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9262),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2179] = {
    [sym__closed_assignment] = STATE(16235),
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9264),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2180] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9266),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2181] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9268),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2182] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9270),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2183] = {
    [sym__expression] = STATE(13653),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16765),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9272),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2184] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9274),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2185] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9236),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2186] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9084),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2187] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9276),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2188] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9278),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2189] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9280),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2190] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9282),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2191] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9284),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2192] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9286),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2193] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9288),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2194] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9290),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2195] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9292),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2196] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9294),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2197] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9296),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2198] = {
    [sym_assignment] = STATE(8500),
    [sym_open_tuple] = STATE(18962),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11750),
    [sym__array] = STATE(11750),
    [sym_comprehension_expression] = STATE(11750),
    [sym_matrix_expression] = STATE(11750),
    [sym_vector_expression] = STATE(11750),
    [sym_parenthesized_expression] = STATE(11750),
    [sym_tuple_expression] = STATE(11750),
    [sym_curly_expression] = STATE(11750),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11750),
    [sym_index_expression] = STATE(11750),
    [sym_parametrized_type_expression] = STATE(11750),
    [sym_call_expression] = STATE(11750),
    [sym_broadcast_call_expression] = STATE(11750),
    [sym__closed_macrocall_expression] = STATE(11750),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11750),
    [sym_quote_expression] = STATE(11750),
    [sym_binary_expression] = STATE(14004),
    [sym_unary_expression] = STATE(14004),
    [sym_range_expression] = STATE(14004),
    [sym_splat_expression] = STATE(14004),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13817),
    [sym_unary_typed_expression] = STATE(14004),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14004),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11750),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11750),
    [sym_string_literal] = STATE(11750),
    [sym_command_literal] = STATE(11750),
    [sym_prefixed_string_literal] = STATE(11750),
    [sym_prefixed_command_literal] = STATE(11750),
    [sym_operator] = STATE(13818),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9298),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2199] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9300),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2200] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9302),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2201] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9304),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2202] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9306),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2203] = {
    [sym__expression] = STATE(13752),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16764),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9308),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2204] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9310),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2205] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(18185),
    [sym__expression] = STATE(12942),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11131),
    [sym__array] = STATE(11131),
    [sym_comprehension_expression] = STATE(11131),
    [sym_matrix_expression] = STATE(11131),
    [sym_vector_expression] = STATE(11131),
    [sym_parenthesized_expression] = STATE(11131),
    [sym_tuple_expression] = STATE(11131),
    [sym_curly_expression] = STATE(11131),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11131),
    [sym_index_expression] = STATE(11131),
    [sym_parametrized_type_expression] = STATE(11131),
    [sym_call_expression] = STATE(11131),
    [sym_broadcast_call_expression] = STATE(11131),
    [sym__closed_macrocall_expression] = STATE(11131),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11131),
    [sym_quote_expression] = STATE(11131),
    [sym_binary_expression] = STATE(13174),
    [sym_unary_expression] = STATE(13174),
    [sym_range_expression] = STATE(13174),
    [sym_splat_expression] = STATE(13174),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12720),
    [sym_unary_typed_expression] = STATE(13174),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13174),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11131),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11131),
    [sym_string_literal] = STATE(11131),
    [sym_command_literal] = STATE(11131),
    [sym_prefixed_string_literal] = STATE(11131),
    [sym_prefixed_command_literal] = STATE(11131),
    [sym_operator] = STATE(12722),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(8714),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2206] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9312),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2207] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9314),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2208] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9316),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2209] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9318),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2210] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9320),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2211] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9322),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2212] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9324),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2213] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9326),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2214] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9328),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2215] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9330),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2216] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9332),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2217] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9334),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2218] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9336),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2219] = {
    [sym_assignment] = STATE(7729),
    [sym_open_tuple] = STATE(19154),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11574),
    [sym__array] = STATE(11574),
    [sym_comprehension_expression] = STATE(11574),
    [sym_matrix_expression] = STATE(11574),
    [sym_vector_expression] = STATE(11574),
    [sym_parenthesized_expression] = STATE(11574),
    [sym_tuple_expression] = STATE(11574),
    [sym_curly_expression] = STATE(11574),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11574),
    [sym_index_expression] = STATE(11574),
    [sym_parametrized_type_expression] = STATE(11574),
    [sym_call_expression] = STATE(11574),
    [sym_broadcast_call_expression] = STATE(11574),
    [sym__closed_macrocall_expression] = STATE(11574),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11574),
    [sym_quote_expression] = STATE(11574),
    [sym_binary_expression] = STATE(14090),
    [sym_unary_expression] = STATE(14090),
    [sym_range_expression] = STATE(14090),
    [sym_splat_expression] = STATE(14090),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13614),
    [sym_unary_typed_expression] = STATE(14090),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14090),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11574),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11574),
    [sym_string_literal] = STATE(11574),
    [sym_command_literal] = STATE(11574),
    [sym_prefixed_string_literal] = STATE(11574),
    [sym_prefixed_command_literal] = STATE(11574),
    [sym_operator] = STATE(13612),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9338),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2220] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9340),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2221] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9342),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2222] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9344),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2223] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9346),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2224] = {
    [sym__expression] = STATE(13650),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16745),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9348),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2225] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9350),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2226] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9312),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2227] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9352),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2228] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9354),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2229] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9356),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2230] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9358),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2231] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9360),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2232] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9362),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2233] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9364),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2234] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9366),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2235] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9368),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2236] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9370),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2237] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9372),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2238] = {
    [sym_assignment] = STATE(9094),
    [sym_open_tuple] = STATE(18387),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11698),
    [sym__array] = STATE(11698),
    [sym_comprehension_expression] = STATE(11698),
    [sym_matrix_expression] = STATE(11698),
    [sym_vector_expression] = STATE(11698),
    [sym_parenthesized_expression] = STATE(11698),
    [sym_tuple_expression] = STATE(11698),
    [sym_curly_expression] = STATE(11698),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11698),
    [sym_index_expression] = STATE(11698),
    [sym_parametrized_type_expression] = STATE(11698),
    [sym_call_expression] = STATE(11698),
    [sym_broadcast_call_expression] = STATE(11698),
    [sym__closed_macrocall_expression] = STATE(11698),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11698),
    [sym_quote_expression] = STATE(11698),
    [sym_binary_expression] = STATE(14076),
    [sym_unary_expression] = STATE(14076),
    [sym_range_expression] = STATE(14076),
    [sym_splat_expression] = STATE(14076),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13905),
    [sym_unary_typed_expression] = STATE(14076),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14076),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11698),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11698),
    [sym_string_literal] = STATE(11698),
    [sym_command_literal] = STATE(11698),
    [sym_prefixed_string_literal] = STATE(11698),
    [sym_prefixed_command_literal] = STATE(11698),
    [sym_operator] = STATE(13907),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9374),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2239] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9376),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2240] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9378),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2241] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9380),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2242] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9382),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2243] = {
    [sym__expression] = STATE(13870),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16691),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9384),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2244] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9386),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2245] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9388),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2246] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9390),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2247] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9392),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2248] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9394),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2249] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9396),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2250] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9398),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2251] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9400),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2252] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9402),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2253] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9404),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2254] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9406),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2255] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9408),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2256] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9410),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2257] = {
    [sym_assignment] = STATE(8500),
    [sym_open_tuple] = STATE(19594),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11765),
    [sym__array] = STATE(11765),
    [sym_comprehension_expression] = STATE(11765),
    [sym_matrix_expression] = STATE(11765),
    [sym_vector_expression] = STATE(11765),
    [sym_parenthesized_expression] = STATE(11765),
    [sym_tuple_expression] = STATE(11765),
    [sym_curly_expression] = STATE(11765),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11765),
    [sym_index_expression] = STATE(11765),
    [sym_parametrized_type_expression] = STATE(11765),
    [sym_call_expression] = STATE(11765),
    [sym_broadcast_call_expression] = STATE(11765),
    [sym__closed_macrocall_expression] = STATE(11765),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11765),
    [sym_quote_expression] = STATE(11765),
    [sym_binary_expression] = STATE(14084),
    [sym_unary_expression] = STATE(14084),
    [sym_range_expression] = STATE(14084),
    [sym_splat_expression] = STATE(14084),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13754),
    [sym_unary_typed_expression] = STATE(14084),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14084),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11765),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11765),
    [sym_string_literal] = STATE(11765),
    [sym_command_literal] = STATE(11765),
    [sym_prefixed_string_literal] = STATE(11765),
    [sym_prefixed_command_literal] = STATE(11765),
    [sym_operator] = STATE(13753),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2258] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(18185),
    [sym__expression] = STATE(13084),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11131),
    [sym__array] = STATE(11131),
    [sym_comprehension_expression] = STATE(11131),
    [sym_matrix_expression] = STATE(11131),
    [sym_vector_expression] = STATE(11131),
    [sym_parenthesized_expression] = STATE(11131),
    [sym_tuple_expression] = STATE(11131),
    [sym_curly_expression] = STATE(11131),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11131),
    [sym_index_expression] = STATE(11131),
    [sym_parametrized_type_expression] = STATE(11131),
    [sym_call_expression] = STATE(11131),
    [sym_broadcast_call_expression] = STATE(11131),
    [sym__closed_macrocall_expression] = STATE(11131),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11131),
    [sym_quote_expression] = STATE(11131),
    [sym_binary_expression] = STATE(13174),
    [sym_unary_expression] = STATE(13174),
    [sym_range_expression] = STATE(13174),
    [sym_splat_expression] = STATE(13174),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12720),
    [sym_unary_typed_expression] = STATE(13174),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13174),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11131),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11131),
    [sym_string_literal] = STATE(11131),
    [sym_command_literal] = STATE(11131),
    [sym_prefixed_string_literal] = STATE(11131),
    [sym_prefixed_command_literal] = STATE(11131),
    [sym_operator] = STATE(12722),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(8714),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2259] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9414),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2260] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9416),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2261] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9418),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2262] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9420),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2263] = {
    [sym__expression] = STATE(13981),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16962),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9422),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2264] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9424),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2265] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9388),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2266] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9426),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2267] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9428),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2268] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9430),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2269] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9432),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2270] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9434),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2271] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9436),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2272] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9438),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2273] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9440),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2274] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9442),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2275] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9444),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2276] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9446),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2277] = {
    [sym_assignment] = STATE(7323),
    [sym_open_tuple] = STATE(18295),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11571),
    [sym__array] = STATE(11571),
    [sym_comprehension_expression] = STATE(11571),
    [sym_matrix_expression] = STATE(11571),
    [sym_vector_expression] = STATE(11571),
    [sym_parenthesized_expression] = STATE(11571),
    [sym_tuple_expression] = STATE(11571),
    [sym_curly_expression] = STATE(11571),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11571),
    [sym_index_expression] = STATE(11571),
    [sym_parametrized_type_expression] = STATE(11571),
    [sym_call_expression] = STATE(11571),
    [sym_broadcast_call_expression] = STATE(11571),
    [sym__closed_macrocall_expression] = STATE(11571),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11571),
    [sym_quote_expression] = STATE(11571),
    [sym_binary_expression] = STATE(14065),
    [sym_unary_expression] = STATE(14065),
    [sym_range_expression] = STATE(14065),
    [sym_splat_expression] = STATE(14065),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13876),
    [sym_unary_typed_expression] = STATE(14065),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14065),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11571),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11571),
    [sym_string_literal] = STATE(11571),
    [sym_command_literal] = STATE(11571),
    [sym_prefixed_string_literal] = STATE(11571),
    [sym_prefixed_command_literal] = STATE(11571),
    [sym_operator] = STATE(13877),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9448),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2278] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9450),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2279] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9452),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2280] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9454),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2281] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9456),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2282] = {
    [sym__expression] = STATE(13702),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16830),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9458),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2283] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9460),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2284] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9462),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2285] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9464),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2286] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9466),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2287] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9468),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2288] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9470),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2289] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9472),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2290] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9474),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2291] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9476),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2292] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9478),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2293] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9480),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2294] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9482),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2295] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9484),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2296] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(18466),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11665),
    [sym__array] = STATE(11665),
    [sym_comprehension_expression] = STATE(11665),
    [sym_matrix_expression] = STATE(11665),
    [sym_vector_expression] = STATE(11665),
    [sym_parenthesized_expression] = STATE(11665),
    [sym_tuple_expression] = STATE(11665),
    [sym_curly_expression] = STATE(11665),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11665),
    [sym_index_expression] = STATE(11665),
    [sym_parametrized_type_expression] = STATE(11665),
    [sym_call_expression] = STATE(11665),
    [sym_broadcast_call_expression] = STATE(11665),
    [sym__closed_macrocall_expression] = STATE(11665),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11665),
    [sym_quote_expression] = STATE(11665),
    [sym_binary_expression] = STATE(14067),
    [sym_unary_expression] = STATE(14067),
    [sym_range_expression] = STATE(14067),
    [sym_splat_expression] = STATE(14067),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(14067),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14067),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11665),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11665),
    [sym_string_literal] = STATE(11665),
    [sym_command_literal] = STATE(11665),
    [sym_prefixed_string_literal] = STATE(11665),
    [sym_prefixed_command_literal] = STATE(11665),
    [sym_operator] = STATE(13851),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9486),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2297] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9488),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2298] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9490),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2299] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9492),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2300] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9494),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2301] = {
    [sym__expression] = STATE(13801),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17132),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9496),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2302] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9498),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2303] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9462),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2304] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9500),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2305] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9502),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2306] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9504),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2307] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9506),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2308] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9508),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2309] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9510),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2310] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9512),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2311] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9514),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2312] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9516),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2313] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9518),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2314] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(8980),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2315] = {
    [sym_assignment] = STATE(12496),
    [sym_open_tuple] = STATE(18726),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11744),
    [sym__array] = STATE(11744),
    [sym_comprehension_expression] = STATE(11744),
    [sym_matrix_expression] = STATE(11744),
    [sym_vector_expression] = STATE(11744),
    [sym_parenthesized_expression] = STATE(11744),
    [sym_tuple_expression] = STATE(11744),
    [sym_curly_expression] = STATE(11744),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11744),
    [sym_index_expression] = STATE(11744),
    [sym_parametrized_type_expression] = STATE(11744),
    [sym_call_expression] = STATE(11744),
    [sym_broadcast_call_expression] = STATE(11744),
    [sym__closed_macrocall_expression] = STATE(11744),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11744),
    [sym_quote_expression] = STATE(11744),
    [sym_binary_expression] = STATE(14139),
    [sym_unary_expression] = STATE(14139),
    [sym_range_expression] = STATE(14139),
    [sym_splat_expression] = STATE(14139),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13787),
    [sym_unary_typed_expression] = STATE(14139),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14139),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11744),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11744),
    [sym_string_literal] = STATE(11744),
    [sym_command_literal] = STATE(11744),
    [sym_prefixed_string_literal] = STATE(11744),
    [sym_prefixed_command_literal] = STATE(11744),
    [sym_operator] = STATE(13796),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9520),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2316] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9522),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2317] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9524),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2318] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9526),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2319] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9528),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2320] = {
    [sym__expression] = STATE(13958),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17265),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9530),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2321] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(18673),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11798),
    [sym__array] = STATE(11798),
    [sym_comprehension_expression] = STATE(11798),
    [sym_matrix_expression] = STATE(11798),
    [sym_vector_expression] = STATE(11798),
    [sym_parenthesized_expression] = STATE(11798),
    [sym_tuple_expression] = STATE(11798),
    [sym_curly_expression] = STATE(11798),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11798),
    [sym_index_expression] = STATE(11798),
    [sym_parametrized_type_expression] = STATE(11798),
    [sym_call_expression] = STATE(11798),
    [sym_broadcast_call_expression] = STATE(11798),
    [sym__closed_macrocall_expression] = STATE(11798),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11798),
    [sym_quote_expression] = STATE(11798),
    [sym_binary_expression] = STATE(14063),
    [sym_unary_expression] = STATE(14063),
    [sym_range_expression] = STATE(14063),
    [sym_splat_expression] = STATE(14063),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13880),
    [sym_unary_typed_expression] = STATE(14063),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14063),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11798),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11798),
    [sym_string_literal] = STATE(11798),
    [sym_command_literal] = STATE(11798),
    [sym_prefixed_string_literal] = STATE(11798),
    [sym_prefixed_command_literal] = STATE(11798),
    [sym_operator] = STATE(13960),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9532),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2322] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9534),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2323] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9536),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2324] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9538),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2325] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9540),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2326] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9542),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2327] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9544),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2328] = {
    [sym_assignment] = STATE(8287),
    [sym_open_tuple] = STATE(8289),
    [sym__expression] = STATE(8290),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(9182),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [2329] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9546),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2330] = {
    [sym_assignment] = STATE(8291),
    [sym_open_tuple] = STATE(8295),
    [sym__expression] = STATE(8296),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(9182),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [2331] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9548),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2332] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9550),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2333] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9552),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2334] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9554),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2335] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9556),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2336] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9558),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2337] = {
    [sym_assignment] = STATE(7385),
    [sym_open_tuple] = STATE(19120),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11823),
    [sym__array] = STATE(11823),
    [sym_comprehension_expression] = STATE(11823),
    [sym_matrix_expression] = STATE(11823),
    [sym_vector_expression] = STATE(11823),
    [sym_parenthesized_expression] = STATE(11823),
    [sym_tuple_expression] = STATE(11823),
    [sym_curly_expression] = STATE(11823),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11823),
    [sym_index_expression] = STATE(11823),
    [sym_parametrized_type_expression] = STATE(11823),
    [sym_call_expression] = STATE(11823),
    [sym_broadcast_call_expression] = STATE(11823),
    [sym__closed_macrocall_expression] = STATE(11823),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11823),
    [sym_quote_expression] = STATE(11823),
    [sym_binary_expression] = STATE(14122),
    [sym_unary_expression] = STATE(14122),
    [sym_range_expression] = STATE(14122),
    [sym_splat_expression] = STATE(14122),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13783),
    [sym_unary_typed_expression] = STATE(14122),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14122),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11823),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11823),
    [sym_string_literal] = STATE(11823),
    [sym_command_literal] = STATE(11823),
    [sym_prefixed_string_literal] = STATE(11823),
    [sym_prefixed_command_literal] = STATE(11823),
    [sym_operator] = STATE(13785),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9560),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2338] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9562),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2339] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9564),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2340] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9566),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2341] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9568),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2342] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9570),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2343] = {
    [sym__expression] = STATE(13618),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17211),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9572),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2344] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9574),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2345] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9536),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2346] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9576),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2347] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9578),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2348] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9580),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2349] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9582),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2350] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9584),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2351] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9586),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2352] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9588),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2353] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9590),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2354] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9592),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2355] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9594),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2356] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9596),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2357] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(19529),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11773),
    [sym__array] = STATE(11773),
    [sym_comprehension_expression] = STATE(11773),
    [sym_matrix_expression] = STATE(11773),
    [sym_vector_expression] = STATE(11773),
    [sym_parenthesized_expression] = STATE(11773),
    [sym_tuple_expression] = STATE(11773),
    [sym_curly_expression] = STATE(11773),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11773),
    [sym_index_expression] = STATE(11773),
    [sym_parametrized_type_expression] = STATE(11773),
    [sym_call_expression] = STATE(11773),
    [sym_broadcast_call_expression] = STATE(11773),
    [sym__closed_macrocall_expression] = STATE(11773),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11773),
    [sym_quote_expression] = STATE(11773),
    [sym_binary_expression] = STATE(14077),
    [sym_unary_expression] = STATE(14077),
    [sym_range_expression] = STATE(14077),
    [sym_splat_expression] = STATE(14077),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13658),
    [sym_unary_typed_expression] = STATE(14077),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14077),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11773),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11773),
    [sym_string_literal] = STATE(11773),
    [sym_command_literal] = STATE(11773),
    [sym_prefixed_string_literal] = STATE(11773),
    [sym_prefixed_command_literal] = STATE(11773),
    [sym_operator] = STATE(13671),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9598),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2358] = {
    [sym_assignment] = STATE(8378),
    [sym_open_tuple] = STATE(9230),
    [sym__expression] = STATE(9179),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [2359] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9600),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2360] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2361] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9604),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2362] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9606),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2363] = {
    [sym__expression] = STATE(13659),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16770),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9608),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2364] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9610),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2365] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9612),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2366] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9614),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2367] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9616),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2368] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9618),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2369] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9620),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2370] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9622),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2371] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9624),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2372] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9626),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2373] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9628),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2374] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9630),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2375] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9632),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2376] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9634),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2377] = {
    [sym_assignment] = STATE(8439),
    [sym_open_tuple] = STATE(19724),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11597),
    [sym__array] = STATE(11597),
    [sym_comprehension_expression] = STATE(11597),
    [sym_matrix_expression] = STATE(11597),
    [sym_vector_expression] = STATE(11597),
    [sym_parenthesized_expression] = STATE(11597),
    [sym_tuple_expression] = STATE(11597),
    [sym_curly_expression] = STATE(11597),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11597),
    [sym_index_expression] = STATE(11597),
    [sym_parametrized_type_expression] = STATE(11597),
    [sym_call_expression] = STATE(11597),
    [sym_broadcast_call_expression] = STATE(11597),
    [sym__closed_macrocall_expression] = STATE(11597),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11597),
    [sym_quote_expression] = STATE(11597),
    [sym_binary_expression] = STATE(14069),
    [sym_unary_expression] = STATE(14069),
    [sym_range_expression] = STATE(14069),
    [sym_splat_expression] = STATE(14069),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13887),
    [sym_unary_typed_expression] = STATE(14069),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14069),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11597),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11597),
    [sym_string_literal] = STATE(11597),
    [sym_command_literal] = STATE(11597),
    [sym_prefixed_string_literal] = STATE(11597),
    [sym_prefixed_command_literal] = STATE(11597),
    [sym_operator] = STATE(13888),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9636),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2378] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9638),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2379] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9640),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2380] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2381] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9644),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2382] = {
    [sym__expression] = STATE(13713),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17065),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9646),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2383] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9648),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2384] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9612),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2385] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9650),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2386] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9652),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2387] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9654),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2388] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9656),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2389] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9658),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2390] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9660),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2391] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2392] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2393] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9666),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2394] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9668),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2395] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9670),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2396] = {
    [sym_assignment] = STATE(8285),
    [sym_open_tuple] = STATE(18808),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11641),
    [sym__array] = STATE(11641),
    [sym_comprehension_expression] = STATE(11641),
    [sym_matrix_expression] = STATE(11641),
    [sym_vector_expression] = STATE(11641),
    [sym_parenthesized_expression] = STATE(11641),
    [sym_tuple_expression] = STATE(11641),
    [sym_curly_expression] = STATE(11641),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11641),
    [sym_index_expression] = STATE(11641),
    [sym_parametrized_type_expression] = STATE(11641),
    [sym_call_expression] = STATE(11641),
    [sym_broadcast_call_expression] = STATE(11641),
    [sym__closed_macrocall_expression] = STATE(11641),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11641),
    [sym_quote_expression] = STATE(11641),
    [sym_binary_expression] = STATE(14136),
    [sym_unary_expression] = STATE(14136),
    [sym_range_expression] = STATE(14136),
    [sym_splat_expression] = STATE(14136),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13983),
    [sym_unary_typed_expression] = STATE(14136),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14136),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11641),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11641),
    [sym_string_literal] = STATE(11641),
    [sym_command_literal] = STATE(11641),
    [sym_prefixed_string_literal] = STATE(11641),
    [sym_prefixed_command_literal] = STATE(11641),
    [sym_operator] = STATE(13604),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9672),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2397] = {
    [sym_assignment] = STATE(8395),
    [sym_open_tuple] = STATE(19423),
    [sym__expression] = STATE(8557),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(9182),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [2398] = {
    [sym__expression] = STATE(13613),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17293),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9674),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2399] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9676),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2400] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9678),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2401] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2402] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9682),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2403] = {
    [sym__expression] = STATE(13731),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17201),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9684),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2404] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9686),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2405] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9688),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2406] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9690),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2407] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9692),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2408] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9694),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2409] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2410] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9698),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2411] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9700),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2412] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2413] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9704),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2414] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2415] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9708),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2416] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9024),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2417] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(19509),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11673),
    [sym__array] = STATE(11673),
    [sym_comprehension_expression] = STATE(11673),
    [sym_matrix_expression] = STATE(11673),
    [sym_vector_expression] = STATE(11673),
    [sym_parenthesized_expression] = STATE(11673),
    [sym_tuple_expression] = STATE(11673),
    [sym_curly_expression] = STATE(11673),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11673),
    [sym_index_expression] = STATE(11673),
    [sym_parametrized_type_expression] = STATE(11673),
    [sym_call_expression] = STATE(11673),
    [sym_broadcast_call_expression] = STATE(11673),
    [sym__closed_macrocall_expression] = STATE(11673),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11673),
    [sym_quote_expression] = STATE(11673),
    [sym_binary_expression] = STATE(14013),
    [sym_unary_expression] = STATE(14013),
    [sym_range_expression] = STATE(14013),
    [sym_splat_expression] = STATE(14013),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13709),
    [sym_unary_typed_expression] = STATE(14013),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14013),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11673),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11673),
    [sym_string_literal] = STATE(11673),
    [sym_command_literal] = STATE(11673),
    [sym_prefixed_string_literal] = STATE(11673),
    [sym_prefixed_command_literal] = STATE(11673),
    [sym_operator] = STATE(13710),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2418] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9712),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2419] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2420] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9716),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2421] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9718),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2422] = {
    [sym__expression] = STATE(13748),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17297),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9720),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2423] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9722),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2424] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9688),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2425] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2426] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2427] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9728),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2428] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2429] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9732),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2430] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2431] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2432] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2433] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9740),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2434] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2435] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2436] = {
    [sym_assignment] = STATE(8500),
    [sym_open_tuple] = STATE(18750),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11747),
    [sym__array] = STATE(11747),
    [sym_comprehension_expression] = STATE(11747),
    [sym_matrix_expression] = STATE(11747),
    [sym_vector_expression] = STATE(11747),
    [sym_parenthesized_expression] = STATE(11747),
    [sym_tuple_expression] = STATE(11747),
    [sym_curly_expression] = STATE(11747),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11747),
    [sym_index_expression] = STATE(11747),
    [sym_parametrized_type_expression] = STATE(11747),
    [sym_call_expression] = STATE(11747),
    [sym_broadcast_call_expression] = STATE(11747),
    [sym__closed_macrocall_expression] = STATE(11747),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11747),
    [sym_quote_expression] = STATE(11747),
    [sym_binary_expression] = STATE(14017),
    [sym_unary_expression] = STATE(14017),
    [sym_range_expression] = STATE(14017),
    [sym_splat_expression] = STATE(14017),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13839),
    [sym_unary_typed_expression] = STATE(14017),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14017),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11747),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11747),
    [sym_string_literal] = STATE(11747),
    [sym_command_literal] = STATE(11747),
    [sym_prefixed_string_literal] = STATE(11747),
    [sym_prefixed_command_literal] = STATE(11747),
    [sym_operator] = STATE(13842),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2437] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9748),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2438] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2439] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2440] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9754),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2441] = {
    [sym__expression] = STATE(13777),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17179),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9756),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2442] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9758),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2443] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2444] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9762),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2445] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9764),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2446] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9766),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2447] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9768),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2448] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9770),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2449] = {
    [sym_assignment] = STATE(8488),
    [sym_open_tuple] = STATE(19423),
    [sym__expression] = STATE(8575),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5206),
    [sym__array] = STATE(5206),
    [sym_comprehension_expression] = STATE(5206),
    [sym_matrix_expression] = STATE(5206),
    [sym_vector_expression] = STATE(5206),
    [sym_parenthesized_expression] = STATE(5206),
    [sym_tuple_expression] = STATE(5206),
    [sym_curly_expression] = STATE(5206),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5206),
    [sym_index_expression] = STATE(5206),
    [sym_parametrized_type_expression] = STATE(5206),
    [sym_call_expression] = STATE(5206),
    [sym_broadcast_call_expression] = STATE(5206),
    [sym__closed_macrocall_expression] = STATE(5206),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(5206),
    [sym_quote_expression] = STATE(5206),
    [sym_binary_expression] = STATE(8682),
    [sym_unary_expression] = STATE(8682),
    [sym_range_expression] = STATE(8682),
    [sym_splat_expression] = STATE(8682),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7582),
    [sym_unary_typed_expression] = STATE(8682),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8682),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(5206),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5206),
    [sym_string_literal] = STATE(5206),
    [sym_command_literal] = STATE(5206),
    [sym_prefixed_string_literal] = STATE(5206),
    [sym_prefixed_command_literal] = STATE(5206),
    [sym_operator] = STATE(7583),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(9182),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [2450] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9772),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2451] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9774),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2452] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9776),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2453] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9778),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2454] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2455] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9064),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2456] = {
    [sym_assignment] = STATE(12236),
    [sym_open_tuple] = STATE(19096),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11826),
    [sym__array] = STATE(11826),
    [sym_comprehension_expression] = STATE(11826),
    [sym_matrix_expression] = STATE(11826),
    [sym_vector_expression] = STATE(11826),
    [sym_parenthesized_expression] = STATE(11826),
    [sym_tuple_expression] = STATE(11826),
    [sym_curly_expression] = STATE(11826),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11826),
    [sym_index_expression] = STATE(11826),
    [sym_parametrized_type_expression] = STATE(11826),
    [sym_call_expression] = STATE(11826),
    [sym_broadcast_call_expression] = STATE(11826),
    [sym__closed_macrocall_expression] = STATE(11826),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11826),
    [sym_quote_expression] = STATE(11826),
    [sym_binary_expression] = STATE(13598),
    [sym_unary_expression] = STATE(13598),
    [sym_range_expression] = STATE(13598),
    [sym_splat_expression] = STATE(13598),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13959),
    [sym_unary_typed_expression] = STATE(13598),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13598),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11826),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11826),
    [sym_string_literal] = STATE(11826),
    [sym_command_literal] = STATE(11826),
    [sym_prefixed_string_literal] = STATE(11826),
    [sym_prefixed_command_literal] = STATE(11826),
    [sym_operator] = STATE(13182),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9782),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2457] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2458] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9786),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2459] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2460] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2461] = {
    [sym__expression] = STATE(13803),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16805),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9792),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2462] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9794),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2463] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2464] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2465] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9798),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2466] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2467] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9802),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2468] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9804),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2469] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9806),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2470] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9808),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2471] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2472] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9812),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2473] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2474] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9816),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2475] = {
    [sym_assignment] = STATE(7385),
    [sym_open_tuple] = STATE(18370),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11578),
    [sym__array] = STATE(11578),
    [sym_comprehension_expression] = STATE(11578),
    [sym_matrix_expression] = STATE(11578),
    [sym_vector_expression] = STATE(11578),
    [sym_parenthesized_expression] = STATE(11578),
    [sym_tuple_expression] = STATE(11578),
    [sym_curly_expression] = STATE(11578),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11578),
    [sym_index_expression] = STATE(11578),
    [sym_parametrized_type_expression] = STATE(11578),
    [sym_call_expression] = STATE(11578),
    [sym_broadcast_call_expression] = STATE(11578),
    [sym__closed_macrocall_expression] = STATE(11578),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11578),
    [sym_quote_expression] = STATE(11578),
    [sym_binary_expression] = STATE(14020),
    [sym_unary_expression] = STATE(14020),
    [sym_range_expression] = STATE(14020),
    [sym_splat_expression] = STATE(14020),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13622),
    [sym_unary_typed_expression] = STATE(14020),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14020),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11578),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11578),
    [sym_string_literal] = STATE(11578),
    [sym_command_literal] = STATE(11578),
    [sym_prefixed_string_literal] = STATE(11578),
    [sym_prefixed_command_literal] = STATE(11578),
    [sym_operator] = STATE(13624),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2476] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9820),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2477] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9822),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2478] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2479] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9826),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2480] = {
    [sym__expression] = STATE(13855),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17076),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2481] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9830),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2482] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2483] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9834),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2484] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2485] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9838),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2486] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9840),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2487] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9842),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2488] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9844),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2489] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9846),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2490] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9848),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2491] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9850),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2492] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9852),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2493] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9854),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2494] = {
    [sym_assignment] = STATE(8439),
    [sym_open_tuple] = STATE(19049),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11605),
    [sym__array] = STATE(11605),
    [sym_comprehension_expression] = STATE(11605),
    [sym_matrix_expression] = STATE(11605),
    [sym_vector_expression] = STATE(11605),
    [sym_parenthesized_expression] = STATE(11605),
    [sym_tuple_expression] = STATE(11605),
    [sym_curly_expression] = STATE(11605),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11605),
    [sym_index_expression] = STATE(11605),
    [sym_parametrized_type_expression] = STATE(11605),
    [sym_call_expression] = STATE(11605),
    [sym_broadcast_call_expression] = STATE(11605),
    [sym__closed_macrocall_expression] = STATE(11605),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11605),
    [sym_quote_expression] = STATE(11605),
    [sym_binary_expression] = STATE(14103),
    [sym_unary_expression] = STATE(14103),
    [sym_range_expression] = STATE(14103),
    [sym_splat_expression] = STATE(14103),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13664),
    [sym_unary_typed_expression] = STATE(14103),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14103),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11605),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11605),
    [sym_string_literal] = STATE(11605),
    [sym_command_literal] = STATE(11605),
    [sym_prefixed_string_literal] = STATE(11605),
    [sym_prefixed_command_literal] = STATE(11605),
    [sym_operator] = STATE(13665),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9856),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2495] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9858),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2496] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9860),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2497] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2498] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9864),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2499] = {
    [sym__expression] = STATE(13883),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17280),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9866),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2500] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9868),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2501] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2502] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9122),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2503] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9870),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2504] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9872),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2505] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9874),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2506] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9876),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2507] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9878),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2508] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9880),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2509] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9882),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2510] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(13419),
    [sym__expression] = STATE(13421),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11200),
    [sym__array] = STATE(11200),
    [sym_comprehension_expression] = STATE(11200),
    [sym_matrix_expression] = STATE(11200),
    [sym_vector_expression] = STATE(11200),
    [sym_parenthesized_expression] = STATE(11200),
    [sym_tuple_expression] = STATE(11200),
    [sym_curly_expression] = STATE(11200),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11200),
    [sym_index_expression] = STATE(11200),
    [sym_parametrized_type_expression] = STATE(11200),
    [sym_call_expression] = STATE(11200),
    [sym_broadcast_call_expression] = STATE(11200),
    [sym__closed_macrocall_expression] = STATE(11200),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11200),
    [sym_quote_expression] = STATE(11200),
    [sym_binary_expression] = STATE(13364),
    [sym_unary_expression] = STATE(13364),
    [sym_range_expression] = STATE(13364),
    [sym_splat_expression] = STATE(13364),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12999),
    [sym_unary_typed_expression] = STATE(13364),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13364),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11200),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11200),
    [sym_string_literal] = STATE(11200),
    [sym_command_literal] = STATE(11200),
    [sym_prefixed_string_literal] = STATE(11200),
    [sym_prefixed_command_literal] = STATE(11200),
    [sym_operator] = STATE(13000),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(8592),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2511] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9884),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2512] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(13305),
    [sym__expression] = STATE(13311),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11200),
    [sym__array] = STATE(11200),
    [sym_comprehension_expression] = STATE(11200),
    [sym_matrix_expression] = STATE(11200),
    [sym_vector_expression] = STATE(11200),
    [sym_parenthesized_expression] = STATE(11200),
    [sym_tuple_expression] = STATE(11200),
    [sym_curly_expression] = STATE(11200),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11200),
    [sym_index_expression] = STATE(11200),
    [sym_parametrized_type_expression] = STATE(11200),
    [sym_call_expression] = STATE(11200),
    [sym_broadcast_call_expression] = STATE(11200),
    [sym__closed_macrocall_expression] = STATE(11200),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11200),
    [sym_quote_expression] = STATE(11200),
    [sym_binary_expression] = STATE(13364),
    [sym_unary_expression] = STATE(13364),
    [sym_range_expression] = STATE(13364),
    [sym_splat_expression] = STATE(13364),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12999),
    [sym_unary_typed_expression] = STATE(13364),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13364),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11200),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11200),
    [sym_string_literal] = STATE(11200),
    [sym_command_literal] = STATE(11200),
    [sym_prefixed_string_literal] = STATE(11200),
    [sym_prefixed_command_literal] = STATE(11200),
    [sym_operator] = STATE(13000),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(8592),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2513] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9886),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2514] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9888),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2515] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(19799),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11662),
    [sym__array] = STATE(11662),
    [sym_comprehension_expression] = STATE(11662),
    [sym_matrix_expression] = STATE(11662),
    [sym_vector_expression] = STATE(11662),
    [sym_parenthesized_expression] = STATE(11662),
    [sym_tuple_expression] = STATE(11662),
    [sym_curly_expression] = STATE(11662),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11662),
    [sym_index_expression] = STATE(11662),
    [sym_parametrized_type_expression] = STATE(11662),
    [sym_call_expression] = STATE(11662),
    [sym_broadcast_call_expression] = STATE(11662),
    [sym__closed_macrocall_expression] = STATE(11662),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11662),
    [sym_quote_expression] = STATE(11662),
    [sym_binary_expression] = STATE(14018),
    [sym_unary_expression] = STATE(14018),
    [sym_range_expression] = STATE(14018),
    [sym_splat_expression] = STATE(14018),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13719),
    [sym_unary_typed_expression] = STATE(14018),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14018),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11662),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11662),
    [sym_string_literal] = STATE(11662),
    [sym_command_literal] = STATE(11662),
    [sym_prefixed_string_literal] = STATE(11662),
    [sym_prefixed_command_literal] = STATE(11662),
    [sym_operator] = STATE(13720),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9890),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2516] = {
    [sym_assignment] = STATE(8501),
    [sym_open_tuple] = STATE(9149),
    [sym__expression] = STATE(9240),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [2517] = {
    [sym_assignment] = STATE(8502),
    [sym_open_tuple] = STATE(9166),
    [sym__expression] = STATE(9241),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [2518] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(500),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2519] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9892),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2520] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9894),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2521] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2522] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2523] = {
    [sym__expression] = STATE(13924),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16714),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2524] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9902),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2525] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9904),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2526] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9162),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2527] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9906),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2528] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9908),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2529] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9910),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2530] = {
    [sym_assignment] = STATE(7556),
    [sym_open_tuple] = STATE(7351),
    [sym__expression] = STATE(7929),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [2531] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9914),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2532] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2533] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9918),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2534] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2535] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9922),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2536] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9924),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2537] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2538] = {
    [sym_assignment] = STATE(8709),
    [sym_open_tuple] = STATE(18473),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11756),
    [sym__array] = STATE(11756),
    [sym_comprehension_expression] = STATE(11756),
    [sym_matrix_expression] = STATE(11756),
    [sym_vector_expression] = STATE(11756),
    [sym_parenthesized_expression] = STATE(11756),
    [sym_tuple_expression] = STATE(11756),
    [sym_curly_expression] = STATE(11756),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11756),
    [sym_index_expression] = STATE(11756),
    [sym_parametrized_type_expression] = STATE(11756),
    [sym_call_expression] = STATE(11756),
    [sym_broadcast_call_expression] = STATE(11756),
    [sym__closed_macrocall_expression] = STATE(11756),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11756),
    [sym_quote_expression] = STATE(11756),
    [sym_binary_expression] = STATE(14066),
    [sym_unary_expression] = STATE(14066),
    [sym_range_expression] = STATE(14066),
    [sym_splat_expression] = STATE(14066),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13732),
    [sym_unary_typed_expression] = STATE(14066),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14066),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11756),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11756),
    [sym_string_literal] = STATE(11756),
    [sym_command_literal] = STATE(11756),
    [sym_prefixed_string_literal] = STATE(11756),
    [sym_prefixed_command_literal] = STATE(11756),
    [sym_operator] = STATE(13733),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9928),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2539] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9930),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2540] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9932),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2541] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9934),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2542] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9936),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2543] = {
    [sym__expression] = STATE(13968),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16977),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9938),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2544] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9940),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2545] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9904),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2546] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9942),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2547] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9944),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2548] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9946),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2549] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9948),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2550] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9950),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2551] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9952),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2552] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2553] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9956),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2554] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2555] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9960),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2556] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2557] = {
    [sym_assignment] = STATE(12236),
    [sym_open_tuple] = STATE(19135),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11788),
    [sym__array] = STATE(11788),
    [sym_comprehension_expression] = STATE(11788),
    [sym_matrix_expression] = STATE(11788),
    [sym_vector_expression] = STATE(11788),
    [sym_parenthesized_expression] = STATE(11788),
    [sym_tuple_expression] = STATE(11788),
    [sym_curly_expression] = STATE(11788),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11788),
    [sym_index_expression] = STATE(11788),
    [sym_parametrized_type_expression] = STATE(11788),
    [sym_call_expression] = STATE(11788),
    [sym_broadcast_call_expression] = STATE(11788),
    [sym__closed_macrocall_expression] = STATE(11788),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11788),
    [sym_quote_expression] = STATE(11788),
    [sym_binary_expression] = STATE(13579),
    [sym_unary_expression] = STATE(13579),
    [sym_range_expression] = STATE(13579),
    [sym_splat_expression] = STATE(13579),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13751),
    [sym_unary_typed_expression] = STATE(13579),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13579),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11788),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11788),
    [sym_string_literal] = STATE(11788),
    [sym_command_literal] = STATE(11788),
    [sym_prefixed_string_literal] = STATE(11788),
    [sym_prefixed_command_literal] = STATE(11788),
    [sym_operator] = STATE(13343),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9964),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2558] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(19333),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11805),
    [sym__array] = STATE(11805),
    [sym_comprehension_expression] = STATE(11805),
    [sym_matrix_expression] = STATE(11805),
    [sym_vector_expression] = STATE(11805),
    [sym_parenthesized_expression] = STATE(11805),
    [sym_tuple_expression] = STATE(11805),
    [sym_curly_expression] = STATE(11805),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11805),
    [sym_index_expression] = STATE(11805),
    [sym_parametrized_type_expression] = STATE(11805),
    [sym_call_expression] = STATE(11805),
    [sym_broadcast_call_expression] = STATE(11805),
    [sym__closed_macrocall_expression] = STATE(11805),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11805),
    [sym_quote_expression] = STATE(11805),
    [sym_binary_expression] = STATE(14075),
    [sym_unary_expression] = STATE(14075),
    [sym_range_expression] = STATE(14075),
    [sym_splat_expression] = STATE(14075),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13620),
    [sym_unary_typed_expression] = STATE(14075),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14075),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11805),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11805),
    [sym_string_literal] = STATE(11805),
    [sym_command_literal] = STATE(11805),
    [sym_prefixed_string_literal] = STATE(11805),
    [sym_prefixed_command_literal] = STATE(11805),
    [sym_operator] = STATE(13621),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(9966),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2559] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9968),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2560] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9970),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2561] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9972),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2562] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9974),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2563] = {
    [sym__expression] = STATE(13605),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16939),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9976),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2564] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2565] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9980),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2566] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2567] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9984),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2568] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2569] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(9988),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2570] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2571] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9992),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2572] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2573] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9996),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2574] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9998),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2575] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2576] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10002),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2577] = {
    [sym_assignment] = STATE(12795),
    [sym_open_tuple] = STATE(18277),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11814),
    [sym__array] = STATE(11814),
    [sym_comprehension_expression] = STATE(11814),
    [sym_matrix_expression] = STATE(11814),
    [sym_vector_expression] = STATE(11814),
    [sym_parenthesized_expression] = STATE(11814),
    [sym_tuple_expression] = STATE(11814),
    [sym_curly_expression] = STATE(11814),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11814),
    [sym_index_expression] = STATE(11814),
    [sym_parametrized_type_expression] = STATE(11814),
    [sym_call_expression] = STATE(11814),
    [sym_broadcast_call_expression] = STATE(11814),
    [sym__closed_macrocall_expression] = STATE(11814),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11814),
    [sym_quote_expression] = STATE(11814),
    [sym_binary_expression] = STATE(14130),
    [sym_unary_expression] = STATE(14130),
    [sym_range_expression] = STATE(14130),
    [sym_splat_expression] = STATE(14130),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13778),
    [sym_unary_typed_expression] = STATE(14130),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14130),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11814),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11814),
    [sym_string_literal] = STATE(11814),
    [sym_command_literal] = STATE(11814),
    [sym_prefixed_string_literal] = STATE(11814),
    [sym_prefixed_command_literal] = STATE(11814),
    [sym_operator] = STATE(13779),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2578] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10006),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2579] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10008),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2580] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2581] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10012),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2582] = {
    [sym__expression] = STATE(13627),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17196),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2583] = {
    [sym_assignment] = STATE(8267),
    [sym_open_tuple] = STATE(18962),
    [sym__expression] = STATE(9169),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [2584] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10016),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2585] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9980),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2586] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2587] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10020),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2588] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10022),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2589] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10024),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2590] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10026),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2591] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2592] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10030),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2593] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2594] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10034),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2595] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2596] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10038),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2597] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(18622),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11596),
    [sym__array] = STATE(11596),
    [sym_comprehension_expression] = STATE(11596),
    [sym_matrix_expression] = STATE(11596),
    [sym_vector_expression] = STATE(11596),
    [sym_parenthesized_expression] = STATE(11596),
    [sym_tuple_expression] = STATE(11596),
    [sym_curly_expression] = STATE(11596),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11596),
    [sym_index_expression] = STATE(11596),
    [sym_parametrized_type_expression] = STATE(11596),
    [sym_call_expression] = STATE(11596),
    [sym_broadcast_call_expression] = STATE(11596),
    [sym__closed_macrocall_expression] = STATE(11596),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11596),
    [sym_quote_expression] = STATE(11596),
    [sym_binary_expression] = STATE(13998),
    [sym_unary_expression] = STATE(13998),
    [sym_range_expression] = STATE(13998),
    [sym_splat_expression] = STATE(13998),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13811),
    [sym_unary_typed_expression] = STATE(13998),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13998),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11596),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11596),
    [sym_string_literal] = STATE(11596),
    [sym_command_literal] = STATE(11596),
    [sym_prefixed_string_literal] = STATE(11596),
    [sym_prefixed_command_literal] = STATE(11596),
    [sym_operator] = STATE(13812),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2598] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10042),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2599] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2600] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10046),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2601] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2602] = {
    [sym__expression] = STATE(13640),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16776),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10050),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2603] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2604] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10054),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2605] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2606] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10058),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2607] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2608] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10062),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2609] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2610] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10066),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2611] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2612] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10070),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2613] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2614] = {
    [sym_assignment] = STATE(7386),
    [sym_open_tuple] = STATE(7525),
    [sym__expression] = STATE(7387),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [2615] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10074),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2616] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2617] = {
    [sym_assignment] = STATE(8709),
    [sym_open_tuple] = STATE(18958),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11741),
    [sym__array] = STATE(11741),
    [sym_comprehension_expression] = STATE(11741),
    [sym_matrix_expression] = STATE(11741),
    [sym_vector_expression] = STATE(11741),
    [sym_parenthesized_expression] = STATE(11741),
    [sym_tuple_expression] = STATE(11741),
    [sym_curly_expression] = STATE(11741),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11741),
    [sym_index_expression] = STATE(11741),
    [sym_parametrized_type_expression] = STATE(11741),
    [sym_call_expression] = STATE(11741),
    [sym_broadcast_call_expression] = STATE(11741),
    [sym__closed_macrocall_expression] = STATE(11741),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11741),
    [sym_quote_expression] = STATE(11741),
    [sym_binary_expression] = STATE(14032),
    [sym_unary_expression] = STATE(14032),
    [sym_range_expression] = STATE(14032),
    [sym_splat_expression] = STATE(14032),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13858),
    [sym_unary_typed_expression] = STATE(14032),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14032),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11741),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11741),
    [sym_string_literal] = STATE(11741),
    [sym_command_literal] = STATE(11741),
    [sym_prefixed_string_literal] = STATE(11741),
    [sym_prefixed_command_literal] = STATE(11741),
    [sym_operator] = STATE(13859),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10078),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2618] = {
    [sym_assignment] = STATE(7388),
    [sym_open_tuple] = STATE(7526),
    [sym__expression] = STATE(7389),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [2619] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2620] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10082),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2621] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10084),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2622] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2623] = {
    [sym__expression] = STATE(13652),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16993),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10088),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2624] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10090),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2625] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10054),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2626] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10092),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2627] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10094),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2628] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10096),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2629] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10098),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2630] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10100),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2631] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2632] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10104),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2633] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2634] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10108),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2635] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10110),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2636] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10112),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2637] = {
    [sym_assignment] = STATE(12236),
    [sym_open_tuple] = STATE(19269),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11680),
    [sym__array] = STATE(11680),
    [sym_comprehension_expression] = STATE(11680),
    [sym_matrix_expression] = STATE(11680),
    [sym_vector_expression] = STATE(11680),
    [sym_parenthesized_expression] = STATE(11680),
    [sym_tuple_expression] = STATE(11680),
    [sym_curly_expression] = STATE(11680),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11680),
    [sym_index_expression] = STATE(11680),
    [sym_parametrized_type_expression] = STATE(11680),
    [sym_call_expression] = STATE(11680),
    [sym_broadcast_call_expression] = STATE(11680),
    [sym__closed_macrocall_expression] = STATE(11680),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11680),
    [sym_quote_expression] = STATE(11680),
    [sym_binary_expression] = STATE(14072),
    [sym_unary_expression] = STATE(14072),
    [sym_range_expression] = STATE(14072),
    [sym_splat_expression] = STATE(14072),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13884),
    [sym_unary_typed_expression] = STATE(14072),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14072),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11680),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11680),
    [sym_string_literal] = STATE(11680),
    [sym_command_literal] = STATE(11680),
    [sym_prefixed_string_literal] = STATE(11680),
    [sym_prefixed_command_literal] = STATE(11680),
    [sym_operator] = STATE(13886),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10114),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2638] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2639] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10118),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2640] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10120),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2641] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2642] = {
    [sym__expression] = STATE(13661),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16814),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10124),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2643] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10126),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2644] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2645] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10130),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2646] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10132),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2647] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2648] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10136),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2649] = {
    [sym_assignment] = STATE(8171),
    [sym_open_tuple] = STATE(8250),
    [sym__expression] = STATE(8539),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [2650] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10140),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2651] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2652] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10144),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2653] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10146),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2654] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10148),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2655] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10150),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2656] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2657] = {
    [sym_assignment] = STATE(9084),
    [sym_open_tuple] = STATE(19753),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11655),
    [sym__array] = STATE(11655),
    [sym_comprehension_expression] = STATE(11655),
    [sym_matrix_expression] = STATE(11655),
    [sym_vector_expression] = STATE(11655),
    [sym_parenthesized_expression] = STATE(11655),
    [sym_tuple_expression] = STATE(11655),
    [sym_curly_expression] = STATE(11655),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11655),
    [sym_index_expression] = STATE(11655),
    [sym_parametrized_type_expression] = STATE(11655),
    [sym_call_expression] = STATE(11655),
    [sym_broadcast_call_expression] = STATE(11655),
    [sym__closed_macrocall_expression] = STATE(11655),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11655),
    [sym_quote_expression] = STATE(11655),
    [sym_binary_expression] = STATE(14087),
    [sym_unary_expression] = STATE(14087),
    [sym_range_expression] = STATE(14087),
    [sym_splat_expression] = STATE(14087),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13927),
    [sym_unary_typed_expression] = STATE(14087),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14087),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11655),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11655),
    [sym_string_literal] = STATE(11655),
    [sym_command_literal] = STATE(11655),
    [sym_prefixed_string_literal] = STATE(11655),
    [sym_prefixed_command_literal] = STATE(11655),
    [sym_operator] = STATE(13929),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2658] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10156),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2659] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10158),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2660] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10160),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2661] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10162),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2662] = {
    [sym__expression] = STATE(13675),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17252),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10164),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2663] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10166),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2664] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2665] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10168),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2666] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10170),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2667] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10172),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2668] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10174),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2669] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10176),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2670] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10178),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2671] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10180),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2672] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10182),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2673] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10184),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2674] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10186),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2675] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10188),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2676] = {
    [sym_assignment] = STATE(12236),
    [sym_open_tuple] = STATE(18977),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11682),
    [sym__array] = STATE(11682),
    [sym_comprehension_expression] = STATE(11682),
    [sym_matrix_expression] = STATE(11682),
    [sym_vector_expression] = STATE(11682),
    [sym_parenthesized_expression] = STATE(11682),
    [sym_tuple_expression] = STATE(11682),
    [sym_curly_expression] = STATE(11682),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11682),
    [sym_index_expression] = STATE(11682),
    [sym_parametrized_type_expression] = STATE(11682),
    [sym_call_expression] = STATE(11682),
    [sym_broadcast_call_expression] = STATE(11682),
    [sym__closed_macrocall_expression] = STATE(11682),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11682),
    [sym_quote_expression] = STATE(11682),
    [sym_binary_expression] = STATE(14126),
    [sym_unary_expression] = STATE(14126),
    [sym_range_expression] = STATE(14126),
    [sym_splat_expression] = STATE(14126),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13972),
    [sym_unary_typed_expression] = STATE(14126),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14126),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11682),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11682),
    [sym_string_literal] = STATE(11682),
    [sym_command_literal] = STATE(11682),
    [sym_prefixed_string_literal] = STATE(11682),
    [sym_prefixed_command_literal] = STATE(11682),
    [sym_operator] = STATE(13973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10190),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2677] = {
    [sym_assignment] = STATE(7446),
    [sym_open_tuple] = STATE(19120),
    [sym__expression] = STATE(7307),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [2678] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10192),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2679] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10194),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2680] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10196),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2681] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10198),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2682] = {
    [sym__expression] = STATE(13697),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16781),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10200),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2683] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10202),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2684] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10204),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2685] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10206),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2686] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10208),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2687] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10210),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2688] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10212),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2689] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10214),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2690] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10216),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2691] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10218),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2692] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10220),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2693] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10222),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2694] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10224),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2695] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10226),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2696] = {
    [sym_assignment] = STATE(12795),
    [sym_open_tuple] = STATE(18373),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11837),
    [sym__array] = STATE(11837),
    [sym_comprehension_expression] = STATE(11837),
    [sym_matrix_expression] = STATE(11837),
    [sym_vector_expression] = STATE(11837),
    [sym_parenthesized_expression] = STATE(11837),
    [sym_tuple_expression] = STATE(11837),
    [sym_curly_expression] = STATE(11837),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11837),
    [sym_index_expression] = STATE(11837),
    [sym_parametrized_type_expression] = STATE(11837),
    [sym_call_expression] = STATE(11837),
    [sym_broadcast_call_expression] = STATE(11837),
    [sym__closed_macrocall_expression] = STATE(11837),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11837),
    [sym_quote_expression] = STATE(11837),
    [sym_binary_expression] = STATE(14135),
    [sym_unary_expression] = STATE(14135),
    [sym_range_expression] = STATE(14135),
    [sym_splat_expression] = STATE(14135),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13606),
    [sym_unary_typed_expression] = STATE(14135),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14135),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11837),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11837),
    [sym_string_literal] = STATE(11837),
    [sym_command_literal] = STATE(11837),
    [sym_prefixed_string_literal] = STATE(11837),
    [sym_prefixed_command_literal] = STATE(11837),
    [sym_operator] = STATE(13607),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10228),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2697] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10230),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2698] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10232),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2699] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10234),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2700] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10236),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2701] = {
    [sym__expression] = STATE(13703),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16811),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10238),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2702] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10240),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2703] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10204),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2704] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10242),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2705] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10244),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2706] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10246),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2707] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10248),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2708] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10250),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2709] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10252),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2710] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10254),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2711] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10256),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2712] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10258),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2713] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10260),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2714] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10262),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2715] = {
    [sym_assignment] = STATE(9084),
    [sym_open_tuple] = STATE(18720),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11732),
    [sym__array] = STATE(11732),
    [sym_comprehension_expression] = STATE(11732),
    [sym_matrix_expression] = STATE(11732),
    [sym_vector_expression] = STATE(11732),
    [sym_parenthesized_expression] = STATE(11732),
    [sym_tuple_expression] = STATE(11732),
    [sym_curly_expression] = STATE(11732),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11732),
    [sym_index_expression] = STATE(11732),
    [sym_parametrized_type_expression] = STATE(11732),
    [sym_call_expression] = STATE(11732),
    [sym_broadcast_call_expression] = STATE(11732),
    [sym__closed_macrocall_expression] = STATE(11732),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11732),
    [sym_quote_expression] = STATE(11732),
    [sym_binary_expression] = STATE(14131),
    [sym_unary_expression] = STATE(14131),
    [sym_range_expression] = STATE(14131),
    [sym_splat_expression] = STATE(14131),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13632),
    [sym_unary_typed_expression] = STATE(14131),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14131),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11732),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11732),
    [sym_string_literal] = STATE(11732),
    [sym_command_literal] = STATE(11732),
    [sym_prefixed_string_literal] = STATE(11732),
    [sym_prefixed_command_literal] = STATE(11732),
    [sym_operator] = STATE(13633),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10264),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2716] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10266),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2717] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10268),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2718] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10270),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2719] = {
    [sym_assignment] = STATE(7493),
    [sym_open_tuple] = STATE(19120),
    [sym__expression] = STATE(7310),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5176),
    [sym__array] = STATE(5176),
    [sym_comprehension_expression] = STATE(5176),
    [sym_matrix_expression] = STATE(5176),
    [sym_vector_expression] = STATE(5176),
    [sym_parenthesized_expression] = STATE(5176),
    [sym_tuple_expression] = STATE(5176),
    [sym_curly_expression] = STATE(5176),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5176),
    [sym_index_expression] = STATE(5176),
    [sym_parametrized_type_expression] = STATE(5176),
    [sym_call_expression] = STATE(5176),
    [sym_broadcast_call_expression] = STATE(5176),
    [sym__closed_macrocall_expression] = STATE(5176),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5176),
    [sym_quote_expression] = STATE(5176),
    [sym_binary_expression] = STATE(7297),
    [sym_unary_expression] = STATE(7297),
    [sym_range_expression] = STATE(7297),
    [sym_splat_expression] = STATE(7297),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(7243),
    [sym_unary_typed_expression] = STATE(7297),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7297),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5176),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5176),
    [sym_string_literal] = STATE(5176),
    [sym_command_literal] = STATE(5176),
    [sym_prefixed_string_literal] = STATE(5176),
    [sym_prefixed_command_literal] = STATE(5176),
    [sym_operator] = STATE(6978),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [2720] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10272),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2721] = {
    [sym__expression] = STATE(13721),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16969),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10274),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2722] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10276),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2723] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10278),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2724] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10280),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2725] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10282),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2726] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10284),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2727] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10286),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2728] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10288),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2729] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10290),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2730] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10292),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2731] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10294),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2732] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10296),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2733] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10298),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2734] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9104),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2735] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(18948),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11617),
    [sym__array] = STATE(11617),
    [sym_comprehension_expression] = STATE(11617),
    [sym_matrix_expression] = STATE(11617),
    [sym_vector_expression] = STATE(11617),
    [sym_parenthesized_expression] = STATE(11617),
    [sym_tuple_expression] = STATE(11617),
    [sym_curly_expression] = STATE(11617),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11617),
    [sym_index_expression] = STATE(11617),
    [sym_parametrized_type_expression] = STATE(11617),
    [sym_call_expression] = STATE(11617),
    [sym_broadcast_call_expression] = STATE(11617),
    [sym__closed_macrocall_expression] = STATE(11617),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11617),
    [sym_quote_expression] = STATE(11617),
    [sym_binary_expression] = STATE(14009),
    [sym_unary_expression] = STATE(14009),
    [sym_range_expression] = STATE(14009),
    [sym_splat_expression] = STATE(14009),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13641),
    [sym_unary_typed_expression] = STATE(14009),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14009),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11617),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11617),
    [sym_string_literal] = STATE(11617),
    [sym_command_literal] = STATE(11617),
    [sym_prefixed_string_literal] = STATE(11617),
    [sym_prefixed_command_literal] = STATE(11617),
    [sym_operator] = STATE(13642),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10300),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2736] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10302),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2737] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10304),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2738] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10306),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2739] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10308),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2740] = {
    [sym__expression] = STATE(13735),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17241),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10310),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2741] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10312),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2742] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10278),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2743] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10314),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2744] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10316),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2745] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10318),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2746] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10320),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2747] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10322),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2748] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10324),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2749] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10326),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2750] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10328),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2751] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10330),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2752] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10332),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2753] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10334),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2754] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10336),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2755] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10338),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2756] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10340),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2757] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10342),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2758] = {
    [sym__expression] = STATE(13756),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16821),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10344),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2759] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10346),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2760] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10348),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2761] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10350),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2762] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10352),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2763] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10354),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2764] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10356),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2765] = {
    [sym_assignment] = STATE(8440),
    [sym_open_tuple] = STATE(8712),
    [sym__expression] = STATE(8441),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [2766] = {
    [sym_assignment] = STATE(8442),
    [sym_open_tuple] = STATE(8726),
    [sym__expression] = STATE(8443),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [2767] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10358),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2768] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10360),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2769] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10362),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2770] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10364),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2771] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10366),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2772] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10368),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2773] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9144),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2774] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10370),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2775] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10372),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2776] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10374),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2777] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10376),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2778] = {
    [sym__expression] = STATE(13780),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16730),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10378),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2779] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10380),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2780] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10348),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2781] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10382),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2782] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10384),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2783] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10386),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2784] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10388),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2785] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10390),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2786] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10392),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2787] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10394),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2788] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10396),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2789] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10398),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2790] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10400),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2791] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(15266),
    [sym__expression] = STATE(12957),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11014),
    [sym__array] = STATE(11014),
    [sym_comprehension_expression] = STATE(11014),
    [sym_matrix_expression] = STATE(11014),
    [sym_vector_expression] = STATE(11014),
    [sym_parenthesized_expression] = STATE(11014),
    [sym_tuple_expression] = STATE(11014),
    [sym_curly_expression] = STATE(11014),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11014),
    [sym_index_expression] = STATE(11014),
    [sym_parametrized_type_expression] = STATE(11014),
    [sym_call_expression] = STATE(11014),
    [sym_broadcast_call_expression] = STATE(11014),
    [sym__closed_macrocall_expression] = STATE(11014),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11014),
    [sym_quote_expression] = STATE(11014),
    [sym_binary_expression] = STATE(12958),
    [sym_unary_expression] = STATE(12958),
    [sym_range_expression] = STATE(12958),
    [sym_splat_expression] = STATE(12958),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(12958),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(12958),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11014),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11014),
    [sym_string_literal] = STATE(11014),
    [sym_command_literal] = STATE(11014),
    [sym_prefixed_string_literal] = STATE(11014),
    [sym_prefixed_command_literal] = STATE(11014),
    [sym_operator] = STATE(12771),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(6484),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2792] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10402),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2793] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10404),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2794] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10406),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2795] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10408),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2796] = {
    [sym__expression] = STATE(13800),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16694),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10410),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2797] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10412),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2798] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10414),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2799] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10416),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2800] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10418),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2801] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10420),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2802] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10422),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2803] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10424),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2804] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10426),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2805] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10428),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2806] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10430),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2807] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10432),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2808] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10434),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2809] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10436),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2810] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10438),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2811] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10440),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2812] = {
    [sym__expression] = STATE(13806),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16890),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10442),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2813] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10414),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2814] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10444),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2815] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10446),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2816] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10448),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2817] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10450),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2818] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10452),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2819] = {
    [sym_assignment] = STATE(8507),
    [sym_open_tuple] = STATE(19724),
    [sym__expression] = STATE(8312),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [2820] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10454),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2821] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10456),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2822] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10458),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2823] = {
    [sym__expression] = STATE(13822),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17163),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10460),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2824] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10462),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2825] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9204),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2826] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10464),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2827] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10466),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2828] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10468),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2829] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10470),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2830] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10472),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2831] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10474),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2832] = {
    [sym_assignment] = STATE(8582),
    [sym_open_tuple] = STATE(19724),
    [sym__expression] = STATE(8333),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5598),
    [sym__array] = STATE(5598),
    [sym_comprehension_expression] = STATE(5598),
    [sym_matrix_expression] = STATE(5598),
    [sym_vector_expression] = STATE(5598),
    [sym_parenthesized_expression] = STATE(5598),
    [sym_tuple_expression] = STATE(5598),
    [sym_curly_expression] = STATE(5598),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5598),
    [sym_index_expression] = STATE(5598),
    [sym_parametrized_type_expression] = STATE(5598),
    [sym_call_expression] = STATE(5598),
    [sym_broadcast_call_expression] = STATE(5598),
    [sym__closed_macrocall_expression] = STATE(5598),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(5598),
    [sym_quote_expression] = STATE(5598),
    [sym_binary_expression] = STATE(8269),
    [sym_unary_expression] = STATE(8269),
    [sym_range_expression] = STATE(8269),
    [sym_splat_expression] = STATE(8269),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7359),
    [sym_unary_typed_expression] = STATE(8269),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8269),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(5598),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5598),
    [sym_string_literal] = STATE(5598),
    [sym_command_literal] = STATE(5598),
    [sym_prefixed_string_literal] = STATE(5598),
    [sym_prefixed_command_literal] = STATE(5598),
    [sym_operator] = STATE(7315),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [2833] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10476),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2834] = {
    [sym__expression] = STATE(13826),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17237),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10478),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2835] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10462),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2836] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10480),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2837] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10482),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2838] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10484),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2839] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10486),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2840] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10488),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2841] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10490),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2842] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10492),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2843] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10494),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2844] = {
    [sym__expression] = STATE(13832),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17291),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10496),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2845] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10498),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2846] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10500),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2847] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10502),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2848] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10504),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2849] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10506),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2850] = {
    [sym_assignment] = STATE(10896),
    [sym_open_tuple] = STATE(12911),
    [sym__expression] = STATE(13175),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11073),
    [sym__array] = STATE(11073),
    [sym_comprehension_expression] = STATE(11073),
    [sym_matrix_expression] = STATE(11073),
    [sym_vector_expression] = STATE(11073),
    [sym_parenthesized_expression] = STATE(11073),
    [sym_tuple_expression] = STATE(11073),
    [sym_curly_expression] = STATE(11073),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11073),
    [sym_index_expression] = STATE(11073),
    [sym_parametrized_type_expression] = STATE(11073),
    [sym_call_expression] = STATE(11073),
    [sym_broadcast_call_expression] = STATE(11073),
    [sym__closed_macrocall_expression] = STATE(11073),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11073),
    [sym_quote_expression] = STATE(11073),
    [sym_binary_expression] = STATE(13022),
    [sym_unary_expression] = STATE(13022),
    [sym_range_expression] = STATE(13022),
    [sym_splat_expression] = STATE(13022),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12814),
    [sym_unary_typed_expression] = STATE(13022),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13022),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11073),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11073),
    [sym_string_literal] = STATE(11073),
    [sym_command_literal] = STATE(11073),
    [sym_prefixed_string_literal] = STATE(11073),
    [sym_prefixed_command_literal] = STATE(11073),
    [sym_operator] = STATE(12815),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(8780),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2851] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10508),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2852] = {
    [sym_assignment] = STATE(10904),
    [sym_open_tuple] = STATE(12912),
    [sym__expression] = STATE(13053),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11073),
    [sym__array] = STATE(11073),
    [sym_comprehension_expression] = STATE(11073),
    [sym_matrix_expression] = STATE(11073),
    [sym_vector_expression] = STATE(11073),
    [sym_parenthesized_expression] = STATE(11073),
    [sym_tuple_expression] = STATE(11073),
    [sym_curly_expression] = STATE(11073),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11073),
    [sym_index_expression] = STATE(11073),
    [sym_parametrized_type_expression] = STATE(11073),
    [sym_call_expression] = STATE(11073),
    [sym_broadcast_call_expression] = STATE(11073),
    [sym__closed_macrocall_expression] = STATE(11073),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11073),
    [sym_quote_expression] = STATE(11073),
    [sym_binary_expression] = STATE(13022),
    [sym_unary_expression] = STATE(13022),
    [sym_range_expression] = STATE(13022),
    [sym_splat_expression] = STATE(13022),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12814),
    [sym_unary_typed_expression] = STATE(13022),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13022),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11073),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11073),
    [sym_string_literal] = STATE(11073),
    [sym_command_literal] = STATE(11073),
    [sym_prefixed_string_literal] = STATE(11073),
    [sym_prefixed_command_literal] = STATE(11073),
    [sym_operator] = STATE(12815),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(8780),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2853] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10510),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2854] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10512),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2855] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10514),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2856] = {
    [sym__expression] = STATE(13838),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16956),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10516),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2857] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10498),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2858] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10518),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2859] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10520),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2860] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10522),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2861] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10524),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2862] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10526),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2863] = {
    [sym_assignment] = STATE(8257),
    [sym_open_tuple] = STATE(8392),
    [sym__expression] = STATE(8344),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(10528),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [2864] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10530),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2865] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10532),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2866] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10534),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2867] = {
    [sym__expression] = STATE(13843),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16981),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10536),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2868] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10538),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2869] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9242),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2870] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10540),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2871] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10542),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2872] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10544),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2873] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10546),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2874] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10548),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2875] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10550),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2876] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10552),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2877] = {
    [sym__expression] = STATE(13849),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16696),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10554),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2878] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10538),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2879] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10556),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2880] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10558),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2881] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10560),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2882] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10562),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2883] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10564),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2884] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10566),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2885] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2886] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10570),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2887] = {
    [sym__expression] = STATE(13861),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17070),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10572),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2888] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10574),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2889] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10576),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2890] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10578),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2891] = {
    [sym_assignment] = STATE(10835),
    [sym_open_tuple] = STATE(19509),
    [sym__expression] = STATE(12974),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11073),
    [sym__array] = STATE(11073),
    [sym_comprehension_expression] = STATE(11073),
    [sym_matrix_expression] = STATE(11073),
    [sym_vector_expression] = STATE(11073),
    [sym_parenthesized_expression] = STATE(11073),
    [sym_tuple_expression] = STATE(11073),
    [sym_curly_expression] = STATE(11073),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11073),
    [sym_index_expression] = STATE(11073),
    [sym_parametrized_type_expression] = STATE(11073),
    [sym_call_expression] = STATE(11073),
    [sym_broadcast_call_expression] = STATE(11073),
    [sym__closed_macrocall_expression] = STATE(11073),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11073),
    [sym_quote_expression] = STATE(11073),
    [sym_binary_expression] = STATE(13022),
    [sym_unary_expression] = STATE(13022),
    [sym_range_expression] = STATE(13022),
    [sym_splat_expression] = STATE(13022),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12814),
    [sym_unary_typed_expression] = STATE(13022),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13022),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11073),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11073),
    [sym_string_literal] = STATE(11073),
    [sym_command_literal] = STATE(11073),
    [sym_prefixed_string_literal] = STATE(11073),
    [sym_prefixed_command_literal] = STATE(11073),
    [sym_operator] = STATE(12815),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(8780),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2892] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10580),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2893] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10582),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2894] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10584),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2895] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10586),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2896] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10588),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2897] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10590),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2898] = {
    [sym__expression] = STATE(13867),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17039),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10592),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2899] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10574),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2900] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10594),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2901] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10596),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2902] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10598),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2903] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10600),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2904] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9186),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2905] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10602),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2906] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10604),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2907] = {
    [sym_assignment] = STATE(10883),
    [sym_open_tuple] = STATE(19509),
    [sym__expression] = STATE(12998),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11073),
    [sym__array] = STATE(11073),
    [sym_comprehension_expression] = STATE(11073),
    [sym_matrix_expression] = STATE(11073),
    [sym_vector_expression] = STATE(11073),
    [sym_parenthesized_expression] = STATE(11073),
    [sym_tuple_expression] = STATE(11073),
    [sym_curly_expression] = STATE(11073),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11073),
    [sym_index_expression] = STATE(11073),
    [sym_parametrized_type_expression] = STATE(11073),
    [sym_call_expression] = STATE(11073),
    [sym_broadcast_call_expression] = STATE(11073),
    [sym__closed_macrocall_expression] = STATE(11073),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11073),
    [sym_quote_expression] = STATE(11073),
    [sym_binary_expression] = STATE(13022),
    [sym_unary_expression] = STATE(13022),
    [sym_range_expression] = STATE(13022),
    [sym_splat_expression] = STATE(13022),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12814),
    [sym_unary_typed_expression] = STATE(13022),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13022),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11073),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11073),
    [sym_string_literal] = STATE(11073),
    [sym_command_literal] = STATE(11073),
    [sym_prefixed_string_literal] = STATE(11073),
    [sym_prefixed_command_literal] = STATE(11073),
    [sym_operator] = STATE(12815),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(8780),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2908] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10606),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2909] = {
    [sym__expression] = STATE(13885),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16791),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10608),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2910] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10610),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2911] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10612),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2912] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10614),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2913] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10616),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2914] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10618),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2915] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10620),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2916] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10622),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2917] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10624),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2918] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10626),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2919] = {
    [sym__expression] = STATE(13891),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16988),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10628),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2920] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10610),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2921] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10630),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2922] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10632),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2923] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10634),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2924] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10636),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2925] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9224),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2926] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10638),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2927] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10640),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2928] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10642),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2929] = {
    [sym__expression] = STATE(13898),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16992),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10644),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2930] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10646),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2931] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10648),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2932] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10650),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2933] = {
    [sym_assignment] = STATE(11883),
    [sym_open_tuple] = STATE(13583),
    [sym__expression] = STATE(13524),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11423),
    [sym__array] = STATE(11423),
    [sym_comprehension_expression] = STATE(11423),
    [sym_matrix_expression] = STATE(11423),
    [sym_vector_expression] = STATE(11423),
    [sym_parenthesized_expression] = STATE(11423),
    [sym_tuple_expression] = STATE(11423),
    [sym_curly_expression] = STATE(11423),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11423),
    [sym_index_expression] = STATE(11423),
    [sym_parametrized_type_expression] = STATE(11423),
    [sym_call_expression] = STATE(11423),
    [sym_broadcast_call_expression] = STATE(11423),
    [sym__closed_macrocall_expression] = STATE(11423),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11423),
    [sym_quote_expression] = STATE(11423),
    [sym_binary_expression] = STATE(13598),
    [sym_unary_expression] = STATE(13598),
    [sym_range_expression] = STATE(13598),
    [sym_splat_expression] = STATE(13598),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13295),
    [sym_unary_typed_expression] = STATE(13598),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13598),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11423),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11423),
    [sym_string_literal] = STATE(11423),
    [sym_command_literal] = STATE(11423),
    [sym_prefixed_string_literal] = STATE(11423),
    [sym_prefixed_command_literal] = STATE(11423),
    [sym_operator] = STATE(13182),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3382),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2934] = {
    [sym_assignment] = STATE(11884),
    [sym_open_tuple] = STATE(13589),
    [sym__expression] = STATE(13550),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11423),
    [sym__array] = STATE(11423),
    [sym_comprehension_expression] = STATE(11423),
    [sym_matrix_expression] = STATE(11423),
    [sym_vector_expression] = STATE(11423),
    [sym_parenthesized_expression] = STATE(11423),
    [sym_tuple_expression] = STATE(11423),
    [sym_curly_expression] = STATE(11423),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11423),
    [sym_index_expression] = STATE(11423),
    [sym_parametrized_type_expression] = STATE(11423),
    [sym_call_expression] = STATE(11423),
    [sym_broadcast_call_expression] = STATE(11423),
    [sym__closed_macrocall_expression] = STATE(11423),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11423),
    [sym_quote_expression] = STATE(11423),
    [sym_binary_expression] = STATE(13598),
    [sym_unary_expression] = STATE(13598),
    [sym_range_expression] = STATE(13598),
    [sym_splat_expression] = STATE(13598),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13295),
    [sym_unary_typed_expression] = STATE(13598),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13598),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11423),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11423),
    [sym_string_literal] = STATE(11423),
    [sym_command_literal] = STATE(11423),
    [sym_prefixed_string_literal] = STATE(11423),
    [sym_prefixed_command_literal] = STATE(11423),
    [sym_operator] = STATE(13182),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3382),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2935] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10652),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2936] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10654),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2937] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10656),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2938] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10658),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2939] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10660),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2940] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10662),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2941] = {
    [sym__expression] = STATE(13902),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16750),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10664),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2942] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10646),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2943] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10666),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2944] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10668),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2945] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10670),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2946] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10672),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2947] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10674),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2948] = {
    [sym_assignment] = STATE(12039),
    [sym_open_tuple] = STATE(13473),
    [sym__expression] = STATE(13547),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11423),
    [sym__array] = STATE(11423),
    [sym_comprehension_expression] = STATE(11423),
    [sym_matrix_expression] = STATE(11423),
    [sym_vector_expression] = STATE(11423),
    [sym_parenthesized_expression] = STATE(11423),
    [sym_tuple_expression] = STATE(11423),
    [sym_curly_expression] = STATE(11423),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11423),
    [sym_index_expression] = STATE(11423),
    [sym_parametrized_type_expression] = STATE(11423),
    [sym_call_expression] = STATE(11423),
    [sym_broadcast_call_expression] = STATE(11423),
    [sym__closed_macrocall_expression] = STATE(11423),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11423),
    [sym_quote_expression] = STATE(11423),
    [sym_binary_expression] = STATE(13598),
    [sym_unary_expression] = STATE(13598),
    [sym_range_expression] = STATE(13598),
    [sym_splat_expression] = STATE(13598),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13295),
    [sym_unary_typed_expression] = STATE(13598),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13598),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11423),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11423),
    [sym_string_literal] = STATE(11423),
    [sym_command_literal] = STATE(11423),
    [sym_prefixed_string_literal] = STATE(11423),
    [sym_prefixed_command_literal] = STATE(11423),
    [sym_operator] = STATE(13182),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3382),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2949] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10676),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2950] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10678),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2951] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10680),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2952] = {
    [sym__expression] = STATE(13909),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17232),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10682),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2953] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10684),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2954] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10686),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2955] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10688),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2956] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10690),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2957] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10692),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2958] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10694),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2959] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10696),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2960] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10698),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2961] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10700),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2962] = {
    [sym__expression] = STATE(13913),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16759),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10702),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2963] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10684),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2964] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9280),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2965] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10704),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2966] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10706),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2967] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10708),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2968] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10710),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2969] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10712),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2970] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10714),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2971] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10716),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2972] = {
    [sym__expression] = STATE(13916),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16868),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10718),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2973] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10720),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2974] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10722),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2975] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10724),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2976] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(19096),
    [sym__expression] = STATE(13477),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11423),
    [sym__array] = STATE(11423),
    [sym_comprehension_expression] = STATE(11423),
    [sym_matrix_expression] = STATE(11423),
    [sym_vector_expression] = STATE(11423),
    [sym_parenthesized_expression] = STATE(11423),
    [sym_tuple_expression] = STATE(11423),
    [sym_curly_expression] = STATE(11423),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11423),
    [sym_index_expression] = STATE(11423),
    [sym_parametrized_type_expression] = STATE(11423),
    [sym_call_expression] = STATE(11423),
    [sym_broadcast_call_expression] = STATE(11423),
    [sym__closed_macrocall_expression] = STATE(11423),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11423),
    [sym_quote_expression] = STATE(11423),
    [sym_binary_expression] = STATE(13598),
    [sym_unary_expression] = STATE(13598),
    [sym_range_expression] = STATE(13598),
    [sym_splat_expression] = STATE(13598),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13295),
    [sym_unary_typed_expression] = STATE(13598),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13598),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11423),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11423),
    [sym_string_literal] = STATE(11423),
    [sym_command_literal] = STATE(11423),
    [sym_prefixed_string_literal] = STATE(11423),
    [sym_prefixed_command_literal] = STATE(11423),
    [sym_operator] = STATE(13182),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3382),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2977] = {
    [sym_assignment] = STATE(10578),
    [sym_open_tuple] = STATE(16361),
    [sym__expression] = STATE(13259),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11340),
    [sym__array] = STATE(11340),
    [sym_comprehension_expression] = STATE(11340),
    [sym_matrix_expression] = STATE(11340),
    [sym_vector_expression] = STATE(11340),
    [sym_parenthesized_expression] = STATE(11340),
    [sym_tuple_expression] = STATE(11340),
    [sym_curly_expression] = STATE(11340),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11340),
    [sym_index_expression] = STATE(11340),
    [sym_parametrized_type_expression] = STATE(11340),
    [sym_call_expression] = STATE(11340),
    [sym_broadcast_call_expression] = STATE(11340),
    [sym__closed_macrocall_expression] = STATE(11340),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11340),
    [sym_quote_expression] = STATE(11340),
    [sym_binary_expression] = STATE(13282),
    [sym_unary_expression] = STATE(13282),
    [sym_range_expression] = STATE(13282),
    [sym_splat_expression] = STATE(13282),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12936),
    [sym_unary_typed_expression] = STATE(13282),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13282),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11340),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11340),
    [sym_string_literal] = STATE(11340),
    [sym_command_literal] = STATE(11340),
    [sym_prefixed_string_literal] = STATE(11340),
    [sym_prefixed_command_literal] = STATE(11340),
    [sym_operator] = STATE(13018),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(75),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [2978] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10726),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2979] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10728),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2980] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10730),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2981] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10732),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2982] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10734),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2983] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10736),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2984] = {
    [sym__expression] = STATE(13919),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16932),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10738),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2985] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10720),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2986] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10740),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2987] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10742),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2988] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10744),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2989] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10746),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2990] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(19096),
    [sym__expression] = STATE(13544),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11423),
    [sym__array] = STATE(11423),
    [sym_comprehension_expression] = STATE(11423),
    [sym_matrix_expression] = STATE(11423),
    [sym_vector_expression] = STATE(11423),
    [sym_parenthesized_expression] = STATE(11423),
    [sym_tuple_expression] = STATE(11423),
    [sym_curly_expression] = STATE(11423),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11423),
    [sym_index_expression] = STATE(11423),
    [sym_parametrized_type_expression] = STATE(11423),
    [sym_call_expression] = STATE(11423),
    [sym_broadcast_call_expression] = STATE(11423),
    [sym__closed_macrocall_expression] = STATE(11423),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11423),
    [sym_quote_expression] = STATE(11423),
    [sym_binary_expression] = STATE(13598),
    [sym_unary_expression] = STATE(13598),
    [sym_range_expression] = STATE(13598),
    [sym_splat_expression] = STATE(13598),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13295),
    [sym_unary_typed_expression] = STATE(13598),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13598),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11423),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11423),
    [sym_string_literal] = STATE(11423),
    [sym_command_literal] = STATE(11423),
    [sym_prefixed_string_literal] = STATE(11423),
    [sym_prefixed_command_literal] = STATE(11423),
    [sym_operator] = STATE(13182),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3382),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2991] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10748),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2992] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10750),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2993] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10752),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2994] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10754),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2995] = {
    [sym__expression] = STATE(13923),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17092),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10756),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2996] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10758),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2997] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10760),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2998] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10762),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [2999] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10764),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3000] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10766),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3001] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(9264),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3002] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10768),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3003] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10770),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3004] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10772),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3005] = {
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17181),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10774),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3006] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10758),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3007] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10776),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3008] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10778),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3009] = {
    [sym_assignment] = STATE(8710),
    [sym_open_tuple] = STATE(8254),
    [sym__expression] = STATE(8713),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(10528),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3010] = {
    [sym_assignment] = STATE(8725),
    [sym_open_tuple] = STATE(8255),
    [sym__expression] = STATE(8727),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(10528),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3011] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10780),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3012] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10782),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3013] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10784),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3014] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10786),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3015] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10788),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3016] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10790),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3017] = {
    [sym__expression] = STATE(13930),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16658),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10792),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3018] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10794),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3019] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10796),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3020] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10798),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3021] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10800),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3022] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10802),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3023] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10804),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3024] = {
    [sym_assignment] = STATE(12039),
    [sym_open_tuple] = STATE(13498),
    [sym__expression] = STATE(13479),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11408),
    [sym__array] = STATE(11408),
    [sym_comprehension_expression] = STATE(11408),
    [sym_matrix_expression] = STATE(11408),
    [sym_vector_expression] = STATE(11408),
    [sym_parenthesized_expression] = STATE(11408),
    [sym_tuple_expression] = STATE(11408),
    [sym_curly_expression] = STATE(11408),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11408),
    [sym_index_expression] = STATE(11408),
    [sym_parametrized_type_expression] = STATE(11408),
    [sym_call_expression] = STATE(11408),
    [sym_broadcast_call_expression] = STATE(11408),
    [sym__closed_macrocall_expression] = STATE(11408),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11408),
    [sym_quote_expression] = STATE(11408),
    [sym_binary_expression] = STATE(13579),
    [sym_unary_expression] = STATE(13579),
    [sym_range_expression] = STATE(13579),
    [sym_splat_expression] = STATE(13579),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13229),
    [sym_unary_typed_expression] = STATE(13579),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13579),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11408),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11408),
    [sym_string_literal] = STATE(11408),
    [sym_command_literal] = STATE(11408),
    [sym_prefixed_string_literal] = STATE(11408),
    [sym_prefixed_command_literal] = STATE(11408),
    [sym_operator] = STATE(13343),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3326),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3025] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10806),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3026] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10808),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3027] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10810),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3028] = {
    [sym__expression] = STATE(13943),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17251),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10812),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3029] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10794),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3030] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10814),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3031] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10816),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3032] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10818),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3033] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10820),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3034] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10822),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3035] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10824),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3036] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10826),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3037] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10828),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3038] = {
    [sym__expression] = STATE(13954),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(17317),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10830),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3039] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10832),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3040] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10834),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3041] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10836),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3042] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10838),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3043] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10840),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3044] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10842),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3045] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10844),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3046] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10846),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3047] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10848),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3048] = {
    [sym__expression] = STATE(13961),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16689),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3049] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10832),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3050] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10852),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3051] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10854),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3052] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10856),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3053] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10858),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3054] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10860),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3055] = {
    [sym_assignment] = STATE(8769),
    [sym_open_tuple] = STATE(18473),
    [sym__expression] = STATE(8263),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(10528),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3056] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10862),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3057] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3058] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10866),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3059] = {
    [sym__expression] = STATE(13964),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16740),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10868),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3060] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10870),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3061] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10872),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3062] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10874),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3063] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10876),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3064] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10878),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3065] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10880),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3066] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10882),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3067] = {
    [sym_assignment] = STATE(8225),
    [sym_open_tuple] = STATE(18473),
    [sym__expression] = STATE(8271),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5944),
    [sym__array] = STATE(5944),
    [sym_comprehension_expression] = STATE(5944),
    [sym_matrix_expression] = STATE(5944),
    [sym_vector_expression] = STATE(5944),
    [sym_parenthesized_expression] = STATE(5944),
    [sym_tuple_expression] = STATE(5944),
    [sym_curly_expression] = STATE(5944),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5944),
    [sym_index_expression] = STATE(5944),
    [sym_parametrized_type_expression] = STATE(5944),
    [sym_call_expression] = STATE(5944),
    [sym_broadcast_call_expression] = STATE(5944),
    [sym__closed_macrocall_expression] = STATE(5944),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(5944),
    [sym_quote_expression] = STATE(5944),
    [sym_binary_expression] = STATE(8334),
    [sym_unary_expression] = STATE(8334),
    [sym_range_expression] = STATE(8334),
    [sym_splat_expression] = STATE(8334),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7601),
    [sym_unary_typed_expression] = STATE(8334),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8334),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(5944),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5944),
    [sym_string_literal] = STATE(5944),
    [sym_command_literal] = STATE(5944),
    [sym_prefixed_string_literal] = STATE(5944),
    [sym_prefixed_command_literal] = STATE(5944),
    [sym_operator] = STATE(7426),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(10528),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3068] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10884),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3069] = {
    [sym__expression] = STATE(13970),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16792),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10886),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3070] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10870),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3071] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10888),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3072] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_RBRACK] = ACTIONS(10890),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3073] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10892),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3074] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10894),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3075] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10896),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3076] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3077] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(10900),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3078] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3079] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10902),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3080] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10902),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3081] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10904),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3082] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10904),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3083] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10906),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3084] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10906),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3085] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3086] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3087] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10910),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3088] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10910),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3089] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10912),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3090] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10912),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3091] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10914),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3092] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10914),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3093] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10916),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3094] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10916),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3095] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10918),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3096] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10918),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3097] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10920),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3098] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10920),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3099] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10922),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3100] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10922),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3101] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10924),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3102] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10924),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3103] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10926),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3104] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10926),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3105] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3106] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3107] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3108] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3109] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10932),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3110] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10932),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3111] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3112] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3113] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10936),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3114] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10936),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3115] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10938),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3116] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10938),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3117] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10940),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3118] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10940),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3119] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10942),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3120] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10942),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3121] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10944),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3122] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10944),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3123] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10946),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3124] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10946),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3125] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10948),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3126] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10948),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3127] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10950),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3128] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10950),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3129] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10952),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3130] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10952),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3131] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10954),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3132] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10954),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3133] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10956),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3134] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10956),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3135] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10958),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3136] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10958),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3137] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10960),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3138] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10960),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3139] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3140] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3141] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10964),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3142] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10964),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3143] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3144] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3145] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10968),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3146] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10968),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3147] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(466),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3148] = {
    [sym_assignment] = STATE(18344),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13862),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3149] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(14528),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11644),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11644),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13722),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11324),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8812),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3150] = {
    [sym_assignment] = STATE(11883),
    [sym_open_tuple] = STATE(13552),
    [sym__expression] = STATE(13584),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11408),
    [sym__array] = STATE(11408),
    [sym_comprehension_expression] = STATE(11408),
    [sym_matrix_expression] = STATE(11408),
    [sym_vector_expression] = STATE(11408),
    [sym_parenthesized_expression] = STATE(11408),
    [sym_tuple_expression] = STATE(11408),
    [sym_curly_expression] = STATE(11408),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11408),
    [sym_index_expression] = STATE(11408),
    [sym_parametrized_type_expression] = STATE(11408),
    [sym_call_expression] = STATE(11408),
    [sym_broadcast_call_expression] = STATE(11408),
    [sym__closed_macrocall_expression] = STATE(11408),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11408),
    [sym_quote_expression] = STATE(11408),
    [sym_binary_expression] = STATE(13579),
    [sym_unary_expression] = STATE(13579),
    [sym_range_expression] = STATE(13579),
    [sym_splat_expression] = STATE(13579),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13229),
    [sym_unary_typed_expression] = STATE(13579),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13579),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11408),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11408),
    [sym_string_literal] = STATE(11408),
    [sym_command_literal] = STATE(11408),
    [sym_prefixed_string_literal] = STATE(11408),
    [sym_prefixed_command_literal] = STATE(11408),
    [sym_operator] = STATE(13343),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3326),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3151] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(18415),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11585),
    [sym__array] = STATE(11585),
    [sym_comprehension_expression] = STATE(11585),
    [sym_matrix_expression] = STATE(11585),
    [sym_vector_expression] = STATE(11585),
    [sym_parenthesized_expression] = STATE(11585),
    [sym_tuple_expression] = STATE(11585),
    [sym_curly_expression] = STATE(11585),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11585),
    [sym_index_expression] = STATE(11585),
    [sym_parametrized_type_expression] = STATE(11585),
    [sym_call_expression] = STATE(11585),
    [sym_broadcast_call_expression] = STATE(11585),
    [sym__closed_macrocall_expression] = STATE(11585),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11585),
    [sym_quote_expression] = STATE(11585),
    [sym_binary_expression] = STATE(14001),
    [sym_unary_expression] = STATE(14001),
    [sym_range_expression] = STATE(14001),
    [sym_splat_expression] = STATE(14001),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13638),
    [sym_unary_typed_expression] = STATE(14001),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14001),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11585),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11585),
    [sym_string_literal] = STATE(11585),
    [sym_command_literal] = STATE(11585),
    [sym_prefixed_string_literal] = STATE(11585),
    [sym_prefixed_command_literal] = STATE(11585),
    [sym_operator] = STATE(13639),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3152] = {
    [sym_assignment] = STATE(11884),
    [sym_open_tuple] = STATE(13438),
    [sym__expression] = STATE(13590),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11408),
    [sym__array] = STATE(11408),
    [sym_comprehension_expression] = STATE(11408),
    [sym_matrix_expression] = STATE(11408),
    [sym_vector_expression] = STATE(11408),
    [sym_parenthesized_expression] = STATE(11408),
    [sym_tuple_expression] = STATE(11408),
    [sym_curly_expression] = STATE(11408),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11408),
    [sym_index_expression] = STATE(11408),
    [sym_parametrized_type_expression] = STATE(11408),
    [sym_call_expression] = STATE(11408),
    [sym_broadcast_call_expression] = STATE(11408),
    [sym__closed_macrocall_expression] = STATE(11408),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11408),
    [sym_quote_expression] = STATE(11408),
    [sym_binary_expression] = STATE(13579),
    [sym_unary_expression] = STATE(13579),
    [sym_range_expression] = STATE(13579),
    [sym_splat_expression] = STATE(13579),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13229),
    [sym_unary_typed_expression] = STATE(13579),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13579),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11408),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11408),
    [sym_string_literal] = STATE(11408),
    [sym_command_literal] = STATE(11408),
    [sym_prefixed_string_literal] = STATE(11408),
    [sym_prefixed_command_literal] = STATE(11408),
    [sym_operator] = STATE(13343),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3326),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3153] = {
    [sym_assignment] = STATE(12236),
    [sym_open_tuple] = STATE(18889),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11623),
    [sym__array] = STATE(11623),
    [sym_comprehension_expression] = STATE(11623),
    [sym_matrix_expression] = STATE(11623),
    [sym_vector_expression] = STATE(11623),
    [sym_parenthesized_expression] = STATE(11623),
    [sym_tuple_expression] = STATE(11623),
    [sym_curly_expression] = STATE(11623),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11623),
    [sym_index_expression] = STATE(11623),
    [sym_parametrized_type_expression] = STATE(11623),
    [sym_call_expression] = STATE(11623),
    [sym_broadcast_call_expression] = STATE(11623),
    [sym__closed_macrocall_expression] = STATE(11623),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11623),
    [sym_quote_expression] = STATE(11623),
    [sym_binary_expression] = STATE(14100),
    [sym_unary_expression] = STATE(14100),
    [sym_range_expression] = STATE(14100),
    [sym_splat_expression] = STATE(14100),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13763),
    [sym_unary_typed_expression] = STATE(14100),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14100),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11623),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11623),
    [sym_string_literal] = STATE(11623),
    [sym_command_literal] = STATE(11623),
    [sym_prefixed_string_literal] = STATE(11623),
    [sym_prefixed_command_literal] = STATE(11623),
    [sym_operator] = STATE(13764),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3154] = {
    [sym_assignment] = STATE(10694),
    [sym_open_tuple] = STATE(19701),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11737),
    [sym__array] = STATE(11737),
    [sym_comprehension_expression] = STATE(11737),
    [sym_matrix_expression] = STATE(11737),
    [sym_vector_expression] = STATE(11737),
    [sym_parenthesized_expression] = STATE(11737),
    [sym_tuple_expression] = STATE(11737),
    [sym_curly_expression] = STATE(11737),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11737),
    [sym_index_expression] = STATE(11737),
    [sym_parametrized_type_expression] = STATE(11737),
    [sym_call_expression] = STATE(11737),
    [sym_broadcast_call_expression] = STATE(11737),
    [sym__closed_macrocall_expression] = STATE(11737),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11737),
    [sym_quote_expression] = STATE(11737),
    [sym_binary_expression] = STATE(14132),
    [sym_unary_expression] = STATE(14132),
    [sym_range_expression] = STATE(14132),
    [sym_splat_expression] = STATE(14132),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13676),
    [sym_unary_typed_expression] = STATE(14132),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14132),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11737),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11737),
    [sym_string_literal] = STATE(11737),
    [sym_command_literal] = STATE(11737),
    [sym_prefixed_string_literal] = STATE(11737),
    [sym_prefixed_command_literal] = STATE(11737),
    [sym_operator] = STATE(13678),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3155] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(477),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3156] = {
    [sym_assignment] = STATE(19026),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13782),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3157] = {
    [sym_assignment] = STATE(19362),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13619),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3158] = {
    [sym_assignment] = STATE(12236),
    [sym_open_tuple] = STATE(18935),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11603),
    [sym__array] = STATE(11603),
    [sym_comprehension_expression] = STATE(11603),
    [sym_matrix_expression] = STATE(11603),
    [sym_vector_expression] = STATE(11603),
    [sym_parenthesized_expression] = STATE(11603),
    [sym_tuple_expression] = STATE(11603),
    [sym_curly_expression] = STATE(11603),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11603),
    [sym_index_expression] = STATE(11603),
    [sym_parametrized_type_expression] = STATE(11603),
    [sym_call_expression] = STATE(11603),
    [sym_broadcast_call_expression] = STATE(11603),
    [sym__closed_macrocall_expression] = STATE(11603),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11603),
    [sym_quote_expression] = STATE(11603),
    [sym_binary_expression] = STATE(13781),
    [sym_unary_expression] = STATE(13781),
    [sym_range_expression] = STATE(13781),
    [sym_splat_expression] = STATE(13781),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13808),
    [sym_unary_typed_expression] = STATE(13781),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13781),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11603),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11603),
    [sym_string_literal] = STATE(11603),
    [sym_command_literal] = STATE(11603),
    [sym_prefixed_string_literal] = STATE(11603),
    [sym_prefixed_command_literal] = STATE(11603),
    [sym_operator] = STATE(13486),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3159] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(510),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3160] = {
    [sym_assignment] = STATE(18488),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13666),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3161] = {
    [sym_assignment] = STATE(12236),
    [sym_open_tuple] = STATE(18565),
    [sym__expression] = STATE(14134),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11624),
    [sym__array] = STATE(11624),
    [sym_comprehension_expression] = STATE(11624),
    [sym_matrix_expression] = STATE(11624),
    [sym_vector_expression] = STATE(11624),
    [sym_parenthesized_expression] = STATE(11624),
    [sym_tuple_expression] = STATE(11624),
    [sym_curly_expression] = STATE(11624),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11624),
    [sym_index_expression] = STATE(11624),
    [sym_parametrized_type_expression] = STATE(11624),
    [sym_call_expression] = STATE(11624),
    [sym_broadcast_call_expression] = STATE(11624),
    [sym__closed_macrocall_expression] = STATE(11624),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11624),
    [sym_quote_expression] = STATE(11624),
    [sym_binary_expression] = STATE(14000),
    [sym_unary_expression] = STATE(14000),
    [sym_range_expression] = STATE(14000),
    [sym_splat_expression] = STATE(14000),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13820),
    [sym_unary_typed_expression] = STATE(14000),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14000),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11624),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11624),
    [sym_string_literal] = STATE(11624),
    [sym_command_literal] = STATE(11624),
    [sym_prefixed_string_literal] = STATE(11624),
    [sym_prefixed_command_literal] = STATE(11624),
    [sym_operator] = STATE(13809),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3162] = {
    [sym_assignment] = STATE(12422),
    [sym_open_tuple] = STATE(12748),
    [sym__expression] = STATE(12261),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10619),
    [sym__array] = STATE(10619),
    [sym_comprehension_expression] = STATE(10619),
    [sym_matrix_expression] = STATE(10619),
    [sym_vector_expression] = STATE(10619),
    [sym_parenthesized_expression] = STATE(10619),
    [sym_tuple_expression] = STATE(10619),
    [sym_curly_expression] = STATE(10619),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10619),
    [sym_index_expression] = STATE(10619),
    [sym_parametrized_type_expression] = STATE(10619),
    [sym_call_expression] = STATE(10619),
    [sym_broadcast_call_expression] = STATE(10619),
    [sym__closed_macrocall_expression] = STATE(10619),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(10619),
    [sym_quote_expression] = STATE(10619),
    [sym_binary_expression] = STATE(12555),
    [sym_unary_expression] = STATE(12555),
    [sym_range_expression] = STATE(12555),
    [sym_splat_expression] = STATE(12555),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12201),
    [sym_unary_typed_expression] = STATE(12555),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12555),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(10619),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10619),
    [sym_string_literal] = STATE(10619),
    [sym_command_literal] = STATE(10619),
    [sym_prefixed_string_literal] = STATE(10619),
    [sym_prefixed_command_literal] = STATE(10619),
    [sym_operator] = STATE(12161),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8568),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3163] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(490),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3164] = {
    [sym_assignment] = STATE(18756),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13824),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3165] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(492),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3166] = {
    [sym_assignment] = STATE(19880),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13914),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3167] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(509),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3168] = {
    [sym_assignment] = STATE(18515),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3169] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(470),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3170] = {
    [sym_assignment] = STATE(18229),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13674),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3171] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(480),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3172] = {
    [sym_assignment] = STATE(18596),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13769),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3173] = {
    [sym_assignment] = STATE(11956),
    [sym_open_tuple] = STATE(19135),
    [sym__expression] = STATE(13599),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11408),
    [sym__array] = STATE(11408),
    [sym_comprehension_expression] = STATE(11408),
    [sym_matrix_expression] = STATE(11408),
    [sym_vector_expression] = STATE(11408),
    [sym_parenthesized_expression] = STATE(11408),
    [sym_tuple_expression] = STATE(11408),
    [sym_curly_expression] = STATE(11408),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11408),
    [sym_index_expression] = STATE(11408),
    [sym_parametrized_type_expression] = STATE(11408),
    [sym_call_expression] = STATE(11408),
    [sym_broadcast_call_expression] = STATE(11408),
    [sym__closed_macrocall_expression] = STATE(11408),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11408),
    [sym_quote_expression] = STATE(11408),
    [sym_binary_expression] = STATE(13579),
    [sym_unary_expression] = STATE(13579),
    [sym_range_expression] = STATE(13579),
    [sym_splat_expression] = STATE(13579),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13229),
    [sym_unary_typed_expression] = STATE(13579),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13579),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11408),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11408),
    [sym_string_literal] = STATE(11408),
    [sym_command_literal] = STATE(11408),
    [sym_prefixed_string_literal] = STATE(11408),
    [sym_prefixed_command_literal] = STATE(11408),
    [sym_operator] = STATE(13343),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3326),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3174] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(491),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3175] = {
    [sym_assignment] = STATE(19119),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13856),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3176] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(464),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3177] = {
    [sym_assignment] = STATE(19669),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13944),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3178] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(479),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3179] = {
    [sym_assignment] = STATE(19343),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13980),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3180] = {
    [sym_assignment] = STATE(12211),
    [sym_open_tuple] = STATE(19135),
    [sym__expression] = STATE(13572),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11408),
    [sym__array] = STATE(11408),
    [sym_comprehension_expression] = STATE(11408),
    [sym_matrix_expression] = STATE(11408),
    [sym_vector_expression] = STATE(11408),
    [sym_parenthesized_expression] = STATE(11408),
    [sym_tuple_expression] = STATE(11408),
    [sym_curly_expression] = STATE(11408),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11408),
    [sym_index_expression] = STATE(11408),
    [sym_parametrized_type_expression] = STATE(11408),
    [sym_call_expression] = STATE(11408),
    [sym_broadcast_call_expression] = STATE(11408),
    [sym__closed_macrocall_expression] = STATE(11408),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11408),
    [sym_quote_expression] = STATE(11408),
    [sym_binary_expression] = STATE(13579),
    [sym_unary_expression] = STATE(13579),
    [sym_range_expression] = STATE(13579),
    [sym_splat_expression] = STATE(13579),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13229),
    [sym_unary_typed_expression] = STATE(13579),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13579),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11408),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11408),
    [sym_string_literal] = STATE(11408),
    [sym_command_literal] = STATE(11408),
    [sym_prefixed_string_literal] = STATE(11408),
    [sym_prefixed_command_literal] = STATE(11408),
    [sym_operator] = STATE(13343),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3326),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3181] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_for_binding] = STATE(472),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11774),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11774),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13616),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11257),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_outer] = ACTIONS(8896),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3182] = {
    [sym_assignment] = STATE(19293),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3183] = {
    [sym_assignment] = STATE(18682),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13922),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3184] = {
    [sym_assignment] = STATE(19036),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13770),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3185] = {
    [sym_assignment] = STATE(19596),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13931),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3186] = {
    [sym_assignment] = STATE(19850),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13649),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3187] = {
    [sym_assignment] = STATE(19550),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13734),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3188] = {
    [sym_assignment] = STATE(18380),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13878),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3189] = {
    [sym_assignment] = STATE(19747),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13819),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3190] = {
    [sym_assignment] = STATE(19108),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13637),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3191] = {
    [sym_assignment] = STATE(19789),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13706),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3192] = {
    [sym_assignment] = STATE(18372),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13729),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3193] = {
    [sym_assignment] = STATE(18562),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13744),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3194] = {
    [sym_assignment] = STATE(18834),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13766),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3195] = {
    [sym_assignment] = STATE(19402),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13788),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3196] = {
    [sym_assignment] = STATE(19592),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13836),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3197] = {
    [sym_assignment] = STATE(19812),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13868),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3198] = {
    [sym_assignment] = STATE(19034),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13910),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3199] = {
    [sym_assignment] = STATE(19128),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13951),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3200] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(10980),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3201] = {
    [sym_assignment] = STATE(18262),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13984),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3202] = {
    [sym_assignment] = STATE(12796),
    [sym_open_tuple] = STATE(12378),
    [sym__expression] = STATE(12798),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10619),
    [sym__array] = STATE(10619),
    [sym_comprehension_expression] = STATE(10619),
    [sym_matrix_expression] = STATE(10619),
    [sym_vector_expression] = STATE(10619),
    [sym_parenthesized_expression] = STATE(10619),
    [sym_tuple_expression] = STATE(10619),
    [sym_curly_expression] = STATE(10619),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10619),
    [sym_index_expression] = STATE(10619),
    [sym_parametrized_type_expression] = STATE(10619),
    [sym_call_expression] = STATE(10619),
    [sym_broadcast_call_expression] = STATE(10619),
    [sym__closed_macrocall_expression] = STATE(10619),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(10619),
    [sym_quote_expression] = STATE(10619),
    [sym_binary_expression] = STATE(12555),
    [sym_unary_expression] = STATE(12555),
    [sym_range_expression] = STATE(12555),
    [sym_splat_expression] = STATE(12555),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12201),
    [sym_unary_typed_expression] = STATE(12555),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12555),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(10619),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10619),
    [sym_string_literal] = STATE(10619),
    [sym_command_literal] = STATE(10619),
    [sym_prefixed_string_literal] = STATE(10619),
    [sym_prefixed_command_literal] = STATE(10619),
    [sym_operator] = STATE(12161),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8568),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3203] = {
    [sym_assignment] = STATE(19623),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13617),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3204] = {
    [sym_assignment] = STATE(12799),
    [sym_open_tuple] = STATE(12379),
    [sym__expression] = STATE(12801),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10619),
    [sym__array] = STATE(10619),
    [sym_comprehension_expression] = STATE(10619),
    [sym_matrix_expression] = STATE(10619),
    [sym_vector_expression] = STATE(10619),
    [sym_parenthesized_expression] = STATE(10619),
    [sym_tuple_expression] = STATE(10619),
    [sym_curly_expression] = STATE(10619),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10619),
    [sym_index_expression] = STATE(10619),
    [sym_parametrized_type_expression] = STATE(10619),
    [sym_call_expression] = STATE(10619),
    [sym_broadcast_call_expression] = STATE(10619),
    [sym__closed_macrocall_expression] = STATE(10619),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(10619),
    [sym_quote_expression] = STATE(10619),
    [sym_binary_expression] = STATE(12555),
    [sym_unary_expression] = STATE(12555),
    [sym_range_expression] = STATE(12555),
    [sym_splat_expression] = STATE(12555),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12201),
    [sym_unary_typed_expression] = STATE(12555),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12555),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(10619),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10619),
    [sym_string_literal] = STATE(10619),
    [sym_command_literal] = STATE(10619),
    [sym_prefixed_string_literal] = STATE(10619),
    [sym_prefixed_command_literal] = STATE(10619),
    [sym_operator] = STATE(12161),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(8568),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3205] = {
    [sym_assignment] = STATE(19058),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13636),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3206] = {
    [sym_assignment] = STATE(18631),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13648),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3207] = {
    [sym_assignment] = STATE(19257),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13656),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3208] = {
    [sym_assignment] = STATE(18741),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13667),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3209] = {
    [sym_assignment] = STATE(18752),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13684),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3210] = {
    [sym_assignment] = STATE(19543),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13700),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3211] = {
    [sym_assignment] = STATE(14455),
    [sym_open_tuple] = STATE(16202),
    [sym__expression] = STATE(13183),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11199),
    [sym__array] = STATE(11199),
    [sym_comprehension_expression] = STATE(11199),
    [sym_matrix_expression] = STATE(11199),
    [sym_vector_expression] = STATE(11199),
    [sym_parenthesized_expression] = STATE(11199),
    [sym_tuple_expression] = STATE(11199),
    [sym_curly_expression] = STATE(11199),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11199),
    [sym_index_expression] = STATE(11199),
    [sym_parametrized_type_expression] = STATE(11199),
    [sym_call_expression] = STATE(11199),
    [sym_broadcast_call_expression] = STATE(11199),
    [sym__closed_macrocall_expression] = STATE(11199),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11199),
    [sym_quote_expression] = STATE(11199),
    [sym_binary_expression] = STATE(13342),
    [sym_unary_expression] = STATE(13342),
    [sym_range_expression] = STATE(13342),
    [sym_splat_expression] = STATE(13342),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12950),
    [sym_unary_typed_expression] = STATE(13342),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13342),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11199),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11199),
    [sym_string_literal] = STATE(11199),
    [sym_command_literal] = STATE(11199),
    [sym_prefixed_string_literal] = STATE(11199),
    [sym_prefixed_command_literal] = STATE(11199),
    [sym_operator] = STATE(12953),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(6980),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3212] = {
    [sym_assignment] = STATE(18411),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13708),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3213] = {
    [sym_assignment] = STATE(18759),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13728),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3214] = {
    [sym_assignment] = STATE(19059),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13749),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3215] = {
    [sym_assignment] = STATE(19422),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13767),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3216] = {
    [sym_assignment] = STATE(18468),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13789),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3217] = {
    [sym_assignment] = STATE(19457),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13804),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3218] = {
    [sym_assignment] = STATE(18524),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13816),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3219] = {
    [sym_assignment] = STATE(18820),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13825),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3220] = {
    [sym_assignment] = STATE(19041),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13830),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3221] = {
    [sym_assignment] = STATE(19240),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13835),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3222] = {
    [sym_assignment] = STATE(19583),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13841),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3223] = {
    [sym_assignment] = STATE(18173),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13846),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3224] = {
    [sym_assignment] = STATE(18288),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13857),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3225] = {
    [sym_assignment] = STATE(18421),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13865),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3226] = {
    [sym_assignment] = STATE(18533),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13882),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3227] = {
    [sym_assignment] = STATE(18641),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13890),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3228] = {
    [sym_assignment] = STATE(18761),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13896),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3229] = {
    [sym_assignment] = STATE(18858),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13901),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3230] = {
    [sym_assignment] = STATE(18967),
    [sym_open_tuple] = STATE(18448),
    [sym__expression] = STATE(13908),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11484),
    [sym__array] = STATE(11484),
    [sym_comprehension_expression] = STATE(11484),
    [sym_matrix_expression] = STATE(11484),
    [sym_vector_expression] = STATE(11484),
    [sym_parenthesized_expression] = STATE(11484),
    [sym_tuple_expression] = STATE(11484),
    [sym_curly_expression] = STATE(11484),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11484),
    [sym_index_expression] = STATE(11484),
    [sym_parametrized_type_expression] = STATE(11484),
    [sym_call_expression] = STATE(11484),
    [sym_broadcast_call_expression] = STATE(11484),
    [sym__closed_macrocall_expression] = STATE(11484),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11484),
    [sym_quote_expression] = STATE(11484),
    [sym_binary_expression] = STATE(13651),
    [sym_unary_expression] = STATE(13651),
    [sym_range_expression] = STATE(13651),
    [sym_splat_expression] = STATE(13651),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13540),
    [sym_unary_typed_expression] = STATE(13651),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13651),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11484),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11484),
    [sym_string_literal] = STATE(11484),
    [sym_command_literal] = STATE(11484),
    [sym_prefixed_string_literal] = STATE(11484),
    [sym_prefixed_command_literal] = STATE(11484),
    [sym_operator] = STATE(13541),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(8702),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3231] = {
    [sym_assignment] = STATE(8597),
    [sym_open_tuple] = STATE(18962),
    [sym__expression] = STATE(9183),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6569),
    [sym__array] = STATE(6569),
    [sym_comprehension_expression] = STATE(6569),
    [sym_matrix_expression] = STATE(6569),
    [sym_vector_expression] = STATE(6569),
    [sym_parenthesized_expression] = STATE(6569),
    [sym_tuple_expression] = STATE(6569),
    [sym_curly_expression] = STATE(6569),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6569),
    [sym_index_expression] = STATE(6569),
    [sym_parametrized_type_expression] = STATE(6569),
    [sym_call_expression] = STATE(6569),
    [sym_broadcast_call_expression] = STATE(6569),
    [sym__closed_macrocall_expression] = STATE(6569),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6569),
    [sym_quote_expression] = STATE(6569),
    [sym_binary_expression] = STATE(9140),
    [sym_unary_expression] = STATE(9140),
    [sym_range_expression] = STATE(9140),
    [sym_splat_expression] = STATE(9140),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8943),
    [sym_unary_typed_expression] = STATE(9140),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(9140),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6569),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6569),
    [sym_string_literal] = STATE(6569),
    [sym_command_literal] = STATE(6569),
    [sym_prefixed_string_literal] = STATE(6569),
    [sym_prefixed_command_literal] = STATE(6569),
    [sym_operator] = STATE(9064),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(1371),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3232] = {
    [sym__closed_assignment] = STATE(15076),
    [sym__expression] = STATE(13903),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11428),
    [sym__array] = STATE(11428),
    [sym_comprehension_expression] = STATE(11428),
    [sym_matrix_expression] = STATE(11428),
    [sym_vector_expression] = STATE(11428),
    [sym_parenthesized_expression] = STATE(11428),
    [sym_tuple_expression] = STATE(11428),
    [sym_curly_expression] = STATE(11428),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11428),
    [sym_index_expression] = STATE(11428),
    [sym_parametrized_type_expression] = STATE(11428),
    [sym_call_expression] = STATE(11428),
    [sym_broadcast_call_expression] = STATE(11428),
    [sym__closed_macrocall_expression] = STATE(11428),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11428),
    [sym_quote_expression] = STATE(11428),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13179),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11428),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11428),
    [sym_string_literal] = STATE(11428),
    [sym_command_literal] = STATE(11428),
    [sym_prefixed_string_literal] = STATE(11428),
    [sym_prefixed_command_literal] = STATE(11428),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10982),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3233] = {
    [sym__closed_assignment] = STATE(16777),
    [sym__expression] = STATE(13965),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11395),
    [sym__array] = STATE(11395),
    [sym_comprehension_expression] = STATE(11395),
    [sym_matrix_expression] = STATE(11395),
    [sym_vector_expression] = STATE(11395),
    [sym_parenthesized_expression] = STATE(11395),
    [sym_tuple_expression] = STATE(11395),
    [sym_curly_expression] = STATE(11395),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11395),
    [sym_index_expression] = STATE(11395),
    [sym_parametrized_type_expression] = STATE(11395),
    [sym_call_expression] = STATE(11395),
    [sym_broadcast_call_expression] = STATE(11395),
    [sym__closed_macrocall_expression] = STATE(11395),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11395),
    [sym_quote_expression] = STATE(11395),
    [sym_binary_expression] = STATE(13472),
    [sym_unary_expression] = STATE(13472),
    [sym_range_expression] = STATE(13472),
    [sym_splat_expression] = STATE(13472),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13290),
    [sym_unary_typed_expression] = STATE(13472),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(13472),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11395),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11395),
    [sym_string_literal] = STATE(11395),
    [sym_command_literal] = STATE(11395),
    [sym_prefixed_string_literal] = STATE(11395),
    [sym_prefixed_command_literal] = STATE(11395),
    [sym_operator] = STATE(13291),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10984),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3234] = {
    [sym__closed_assignment] = STATE(17215),
    [sym__expression] = STATE(13881),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3235] = {
    [sym__expression] = STATE(13772),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10800),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3236] = {
    [sym__closed_assignment] = STATE(17254),
    [sym__expression] = STATE(14180),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12117),
    [sym__array] = STATE(12117),
    [sym_comprehension_expression] = STATE(12117),
    [sym_matrix_expression] = STATE(12117),
    [sym_vector_expression] = STATE(12117),
    [sym_parenthesized_expression] = STATE(12117),
    [sym_tuple_expression] = STATE(12117),
    [sym_curly_expression] = STATE(12117),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12117),
    [sym_index_expression] = STATE(12117),
    [sym_parametrized_type_expression] = STATE(12117),
    [sym_call_expression] = STATE(12117),
    [sym_broadcast_call_expression] = STATE(12117),
    [sym__closed_macrocall_expression] = STATE(12117),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(12117),
    [sym_quote_expression] = STATE(12117),
    [sym_binary_expression] = STATE(14166),
    [sym_unary_expression] = STATE(14166),
    [sym_range_expression] = STATE(14166),
    [sym_splat_expression] = STATE(14166),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14140),
    [sym_unary_typed_expression] = STATE(14166),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(14166),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10540),
    [sym_boolean_literal] = STATE(12117),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12117),
    [sym_string_literal] = STATE(12117),
    [sym_command_literal] = STATE(12117),
    [sym_prefixed_string_literal] = STATE(12117),
    [sym_prefixed_command_literal] = STATE(12117),
    [sym_operator] = STATE(13996),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(10986),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3237] = {
    [sym__closed_assignment] = STATE(15076),
    [sym__expression] = STATE(13546),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11213),
    [sym__array] = STATE(11213),
    [sym_comprehension_expression] = STATE(11213),
    [sym_matrix_expression] = STATE(11213),
    [sym_vector_expression] = STATE(11213),
    [sym_parenthesized_expression] = STATE(11213),
    [sym_tuple_expression] = STATE(11213),
    [sym_curly_expression] = STATE(11213),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11213),
    [sym_index_expression] = STATE(11213),
    [sym_parametrized_type_expression] = STATE(11213),
    [sym_call_expression] = STATE(11213),
    [sym_broadcast_call_expression] = STATE(11213),
    [sym__closed_macrocall_expression] = STATE(11213),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11213),
    [sym_quote_expression] = STATE(11213),
    [sym_binary_expression] = STATE(13365),
    [sym_unary_expression] = STATE(13365),
    [sym_range_expression] = STATE(13365),
    [sym_splat_expression] = STATE(13365),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(12966),
    [sym_unary_typed_expression] = STATE(13365),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13365),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11213),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11213),
    [sym_string_literal] = STATE(11213),
    [sym_command_literal] = STATE(11213),
    [sym_prefixed_string_literal] = STATE(11213),
    [sym_prefixed_command_literal] = STATE(11213),
    [sym_operator] = STATE(12973),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(6356),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3238] = {
    [sym__expression] = STATE(14174),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_named_field] = STATE(19395),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11330),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3239] = {
    [sym__closed_assignment] = STATE(15076),
    [sym__expression] = STATE(13871),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3240] = {
    [sym__closed_assignment] = STATE(9614),
    [sym__expression] = STATE(9297),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6630),
    [sym__array] = STATE(6630),
    [sym_comprehension_expression] = STATE(6630),
    [sym_matrix_expression] = STATE(6630),
    [sym_vector_expression] = STATE(6630),
    [sym_parenthesized_expression] = STATE(6630),
    [sym_tuple_expression] = STATE(6630),
    [sym_curly_expression] = STATE(6630),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6630),
    [sym_index_expression] = STATE(6630),
    [sym_parametrized_type_expression] = STATE(6630),
    [sym_call_expression] = STATE(6630),
    [sym_broadcast_call_expression] = STATE(6630),
    [sym__closed_macrocall_expression] = STATE(6630),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6630),
    [sym_quote_expression] = STATE(6630),
    [sym_binary_expression] = STATE(9192),
    [sym_unary_expression] = STATE(9192),
    [sym_range_expression] = STATE(9192),
    [sym_splat_expression] = STATE(9192),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8961),
    [sym_unary_typed_expression] = STATE(9192),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(9192),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6630),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6630),
    [sym_string_literal] = STATE(6630),
    [sym_command_literal] = STATE(6630),
    [sym_prefixed_string_literal] = STATE(6630),
    [sym_prefixed_command_literal] = STATE(6630),
    [sym_operator] = STATE(9095),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(7028),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3241] = {
    [sym__closed_assignment] = STATE(16937),
    [sym__expression] = STATE(12917),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11228),
    [sym__array] = STATE(11228),
    [sym_comprehension_expression] = STATE(11228),
    [sym_matrix_expression] = STATE(11228),
    [sym_vector_expression] = STATE(11228),
    [sym_parenthesized_expression] = STATE(11228),
    [sym_tuple_expression] = STATE(11228),
    [sym_curly_expression] = STATE(11228),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11228),
    [sym_index_expression] = STATE(11228),
    [sym_parametrized_type_expression] = STATE(11228),
    [sym_call_expression] = STATE(11228),
    [sym_broadcast_call_expression] = STATE(11228),
    [sym__closed_macrocall_expression] = STATE(11228),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11228),
    [sym_quote_expression] = STATE(11228),
    [sym_binary_expression] = STATE(13258),
    [sym_unary_expression] = STATE(13258),
    [sym_range_expression] = STATE(13258),
    [sym_splat_expression] = STATE(13258),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13090),
    [sym_unary_typed_expression] = STATE(13258),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13258),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11228),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11228),
    [sym_string_literal] = STATE(11228),
    [sym_command_literal] = STATE(11228),
    [sym_prefixed_string_literal] = STATE(11228),
    [sym_prefixed_command_literal] = STATE(11228),
    [sym_operator] = STATE(13091),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(7008),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3242] = {
    [sym__closed_assignment] = STATE(17025),
    [sym__expression] = STATE(13690),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11373),
    [sym__array] = STATE(11373),
    [sym_comprehension_expression] = STATE(11373),
    [sym_matrix_expression] = STATE(11373),
    [sym_vector_expression] = STATE(11373),
    [sym_parenthesized_expression] = STATE(11373),
    [sym_tuple_expression] = STATE(11373),
    [sym_curly_expression] = STATE(11373),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11373),
    [sym_index_expression] = STATE(11373),
    [sym_parametrized_type_expression] = STATE(11373),
    [sym_call_expression] = STATE(11373),
    [sym_broadcast_call_expression] = STATE(11373),
    [sym__closed_macrocall_expression] = STATE(11373),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11373),
    [sym_quote_expression] = STATE(11373),
    [sym_binary_expression] = STATE(13214),
    [sym_unary_expression] = STATE(13214),
    [sym_range_expression] = STATE(13214),
    [sym_splat_expression] = STATE(13214),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13235),
    [sym_unary_typed_expression] = STATE(13214),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13214),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11373),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11373),
    [sym_string_literal] = STATE(11373),
    [sym_command_literal] = STATE(11373),
    [sym_prefixed_string_literal] = STATE(11373),
    [sym_prefixed_command_literal] = STATE(11373),
    [sym_operator] = STATE(13173),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(8604),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3243] = {
    [sym__expression] = STATE(14156),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_named_field] = STATE(19056),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11330),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3244] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_named_field] = STATE(16779),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11167),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3245] = {
    [sym__closed_assignment] = STATE(15076),
    [sym__expression] = STATE(13610),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11375),
    [sym__array] = STATE(11375),
    [sym_comprehension_expression] = STATE(11375),
    [sym_matrix_expression] = STATE(11375),
    [sym_vector_expression] = STATE(11375),
    [sym_parenthesized_expression] = STATE(11375),
    [sym_tuple_expression] = STATE(11375),
    [sym_curly_expression] = STATE(11375),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11375),
    [sym_index_expression] = STATE(11375),
    [sym_parametrized_type_expression] = STATE(11375),
    [sym_call_expression] = STATE(11375),
    [sym_broadcast_call_expression] = STATE(11375),
    [sym__closed_macrocall_expression] = STATE(11375),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11375),
    [sym_quote_expression] = STATE(11375),
    [sym_binary_expression] = STATE(13507),
    [sym_unary_expression] = STATE(13507),
    [sym_range_expression] = STATE(13507),
    [sym_splat_expression] = STATE(13507),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13304),
    [sym_unary_typed_expression] = STATE(13507),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(13507),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11375),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11375),
    [sym_string_literal] = STATE(11375),
    [sym_command_literal] = STATE(11375),
    [sym_prefixed_string_literal] = STATE(11375),
    [sym_prefixed_command_literal] = STATE(11375),
    [sym_operator] = STATE(13306),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(7944),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3246] = {
    [sym__closed_assignment] = STATE(9614),
    [sym__expression] = STATE(9160),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6457),
    [sym__array] = STATE(6457),
    [sym_comprehension_expression] = STATE(6457),
    [sym_matrix_expression] = STATE(6457),
    [sym_vector_expression] = STATE(6457),
    [sym_parenthesized_expression] = STATE(6457),
    [sym_tuple_expression] = STATE(6457),
    [sym_curly_expression] = STATE(6457),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6457),
    [sym_index_expression] = STATE(6457),
    [sym_parametrized_type_expression] = STATE(6457),
    [sym_call_expression] = STATE(6457),
    [sym_broadcast_call_expression] = STATE(6457),
    [sym__closed_macrocall_expression] = STATE(6457),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(6457),
    [sym_quote_expression] = STATE(6457),
    [sym_binary_expression] = STATE(8936),
    [sym_unary_expression] = STATE(8936),
    [sym_range_expression] = STATE(8936),
    [sym_splat_expression] = STATE(8936),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8318),
    [sym_unary_typed_expression] = STATE(8936),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(8936),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(6457),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6457),
    [sym_string_literal] = STATE(6457),
    [sym_command_literal] = STATE(6457),
    [sym_prefixed_string_literal] = STATE(6457),
    [sym_prefixed_command_literal] = STATE(6457),
    [sym_operator] = STATE(8319),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(6324),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3247] = {
    [sym__expression] = STATE(13335),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3248] = {
    [sym__expression] = STATE(9295),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3249] = {
    [sym__expression] = STATE(9304),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3250] = {
    [sym__expression] = STATE(8919),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3251] = {
    [sym__expression] = STATE(13256),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3252] = {
    [sym__expression] = STATE(14046),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3253] = {
    [sym__expression] = STATE(14047),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3254] = {
    [sym__expression] = STATE(14048),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3255] = {
    [sym__expression] = STATE(14049),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3256] = {
    [sym__expression] = STATE(14050),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3257] = {
    [sym__expression] = STATE(14051),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3258] = {
    [sym__expression] = STATE(14052),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3259] = {
    [sym__expression] = STATE(14054),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3260] = {
    [sym__expression] = STATE(14055),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3261] = {
    [sym__expression] = STATE(14057),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3262] = {
    [sym__expression] = STATE(14058),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3263] = {
    [sym__expression] = STATE(14060),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3264] = {
    [sym__expression] = STATE(14061),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3265] = {
    [sym__expression] = STATE(14062),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3266] = {
    [sym__expression] = STATE(9167),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3267] = {
    [sym__expression] = STATE(12467),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3268] = {
    [sym__expression] = STATE(9180),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3269] = {
    [sym__expression] = STATE(9181),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3270] = {
    [sym__expression] = STATE(13352),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3271] = {
    [sym__expression] = STATE(9182),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3272] = {
    [sym__expression] = STATE(13299),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3273] = {
    [sym__expression] = STATE(14179),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11471),
    [sym_tuple_expression] = STATE(11471),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(13805),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13474),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11025),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3274] = {
    [sym__expression] = STATE(12399),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3275] = {
    [sym__expression] = STATE(9185),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3276] = {
    [sym__expression] = STATE(9139),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3277] = {
    [sym__expression] = STATE(9187),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3278] = {
    [sym__expression] = STATE(9188),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3279] = {
    [sym__expression] = STATE(13207),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3280] = {
    [sym__expression] = STATE(13575),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3281] = {
    [sym__expression] = STATE(9243),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3282] = {
    [sym__expression] = STATE(9189),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3283] = {
    [sym__expression] = STATE(13210),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3284] = {
    [sym__expression] = STATE(9190),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3285] = {
    [sym__expression] = STATE(13422),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3286] = {
    [sym__expression] = STATE(9071),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3287] = {
    [sym__expression] = STATE(13329),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3288] = {
    [sym__expression] = STATE(13330),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3289] = {
    [sym__expression] = STATE(13396),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3290] = {
    [sym__expression] = STATE(9053),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3291] = {
    [sym__expression] = STATE(9191),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3292] = {
    [sym__expression] = STATE(9194),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3293] = {
    [sym__expression] = STATE(9055),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3294] = {
    [sym__expression] = STATE(9244),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3295] = {
    [sym__expression] = STATE(13408),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3296] = {
    [sym__expression] = STATE(13420),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3297] = {
    [sym__expression] = STATE(8415),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3298] = {
    [sym__expression] = STATE(9196),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3299] = {
    [sym__expression] = STATE(8715),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3300] = {
    [sym__expression] = STATE(9197),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3301] = {
    [sym__expression] = STATE(9062),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3302] = {
    [sym__expression] = STATE(8416),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3303] = {
    [sym__expression] = STATE(8107),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3304] = {
    [sym__expression] = STATE(8595),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3305] = {
    [sym__expression] = STATE(9298),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3306] = {
    [sym__expression] = STATE(9063),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3307] = {
    [sym__expression] = STATE(8420),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3308] = {
    [sym__expression] = STATE(7352),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3309] = {
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3310] = {
    [sym__expression] = STATE(9010),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3311] = {
    [sym__expression] = STATE(9011),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3312] = {
    [sym__expression] = STATE(8770),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3313] = {
    [sym__expression] = STATE(9138),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3314] = {
    [sym__expression] = STATE(8919),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3315] = {
    [sym__expression] = STATE(13553),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3316] = {
    [sym__expression] = STATE(13211),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3317] = {
    [sym__expression] = STATE(12996),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3318] = {
    [sym__expression] = STATE(14147),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3319] = {
    [sym__expression] = STATE(14148),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3320] = {
    [sym__expression] = STATE(14149),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3321] = {
    [sym__expression] = STATE(9225),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3322] = {
    [sym__expression] = STATE(9231),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3323] = {
    [sym__expression] = STATE(9226),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3324] = {
    [sym__expression] = STATE(8879),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3325] = {
    [sym__expression] = STATE(8881),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3326] = {
    [sym__expression] = STATE(9232),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3327] = {
    [sym__expression] = STATE(9237),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3328] = {
    [sym__expression] = STATE(8886),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3329] = {
    [sym__expression] = STATE(8891),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3330] = {
    [sym__expression] = STATE(8893),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3331] = {
    [sym__expression] = STATE(8914),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3332] = {
    [sym__expression] = STATE(8916),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3333] = {
    [sym__expression] = STATE(8917),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3334] = {
    [sym__expression] = STATE(8918),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3335] = {
    [sym__expression] = STATE(7394),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3336] = {
    [sym__expression] = STATE(8773),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3337] = {
    [sym__expression] = STATE(14155),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3338] = {
    [sym__expression] = STATE(14159),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3339] = {
    [sym__expression] = STATE(13233),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3340] = {
    [sym__expression] = STATE(13569),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3341] = {
    [sym__expression] = STATE(13571),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3342] = {
    [sym__expression] = STATE(13574),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3343] = {
    [sym__expression] = STATE(13021),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3344] = {
    [sym__expression] = STATE(13025),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3345] = {
    [sym__expression] = STATE(77),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3346] = {
    [sym__expression] = STATE(13027),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3347] = {
    [sym__expression] = STATE(13028),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3348] = {
    [sym__expression] = STATE(13030),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3349] = {
    [sym__expression] = STATE(13031),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3350] = {
    [sym__expression] = STATE(13034),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3351] = {
    [sym__expression] = STATE(13035),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3352] = {
    [sym__expression] = STATE(13036),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3353] = {
    [sym__expression] = STATE(13037),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3354] = {
    [sym__expression] = STATE(13038),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3355] = {
    [sym__expression] = STATE(13041),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3356] = {
    [sym__expression] = STATE(13042),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3357] = {
    [sym__expression] = STATE(7425),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3358] = {
    [sym__expression] = STATE(13046),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3359] = {
    [sym__expression] = STATE(12854),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3360] = {
    [sym__expression] = STATE(12820),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3361] = {
    [sym__expression] = STATE(7427),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3362] = {
    [sym__expression] = STATE(13576),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3363] = {
    [sym__expression] = STATE(7428),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3364] = {
    [sym__expression] = STATE(7429),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3365] = {
    [sym__expression] = STATE(8831),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3366] = {
    [sym__expression] = STATE(8832),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3367] = {
    [sym__expression] = STATE(13275),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3368] = {
    [sym__expression] = STATE(7432),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3369] = {
    [sym__expression] = STATE(9271),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3370] = {
    [sym__expression] = STATE(7435),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3371] = {
    [sym__expression] = STATE(8835),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3372] = {
    [sym__expression] = STATE(8836),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3373] = {
    [sym__expression] = STATE(8838),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3374] = {
    [sym__expression] = STATE(8839),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3375] = {
    [sym__expression] = STATE(8840),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3376] = {
    [sym__expression] = STATE(8844),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3377] = {
    [sym__expression] = STATE(8847),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3378] = {
    [sym__expression] = STATE(8595),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3379] = {
    [sym__expression] = STATE(8374),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3380] = {
    [sym__expression] = STATE(13577),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3381] = {
    [sym__expression] = STATE(13597),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3382] = {
    [sym__expression] = STATE(13600),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3383] = {
    [sym__expression] = STATE(13279),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3384] = {
    [sym__expression] = STATE(13466),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3385] = {
    [sym__expression] = STATE(13111),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3386] = {
    [sym__expression] = STATE(13112),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3387] = {
    [sym__expression] = STATE(13118),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3388] = {
    [sym__expression] = STATE(13121),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3389] = {
    [sym__expression] = STATE(13122),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3390] = {
    [sym__expression] = STATE(13155),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3391] = {
    [sym__expression] = STATE(13158),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3392] = {
    [sym__expression] = STATE(13159),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3393] = {
    [sym__expression] = STATE(13164),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3394] = {
    [sym__expression] = STATE(13165),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3395] = {
    [sym__expression] = STATE(7710),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3396] = {
    [sym__expression] = STATE(13166),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3397] = {
    [sym__expression] = STATE(13169),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3398] = {
    [sym__expression] = STATE(7930),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3399] = {
    [sym__expression] = STATE(13170),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3400] = {
    [sym__expression] = STATE(7931),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3401] = {
    [sym__expression] = STATE(13185),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3402] = {
    [sym__expression] = STATE(13171),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3403] = {
    [sym__expression] = STATE(12593),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3404] = {
    [sym__expression] = STATE(7932),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3405] = {
    [sym__expression] = STATE(7933),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3406] = {
    [sym__expression] = STATE(7934),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3407] = {
    [sym__expression] = STATE(7935),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3408] = {
    [sym__expression] = STATE(12900),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3409] = {
    [sym__expression] = STATE(13468),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3410] = {
    [sym__expression] = STATE(13469),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3411] = {
    [sym__expression] = STATE(7936),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3412] = {
    [sym__expression] = STATE(13475),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3413] = {
    [sym__expression] = STATE(13517),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3414] = {
    [sym__expression] = STATE(7937),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3415] = {
    [sym__expression] = STATE(13519),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3416] = {
    [sym__expression] = STATE(13192),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3417] = {
    [sym__expression] = STATE(13194),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3418] = {
    [sym__expression] = STATE(13300),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3419] = {
    [sym__expression] = STATE(7938),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3420] = {
    [sym__expression] = STATE(7939),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3421] = {
    [sym__expression] = STATE(7941),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3422] = {
    [sym__expression] = STATE(13199),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3423] = {
    [sym__expression] = STATE(12678),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3424] = {
    [sym__expression] = STATE(8827),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3425] = {
    [sym__expression] = STATE(7943),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3426] = {
    [sym__expression] = STATE(8828),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3427] = {
    [sym__expression] = STATE(7944),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3428] = {
    [sym__expression] = STATE(8829),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3429] = {
    [sym__expression] = STATE(7334),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3430] = {
    [sym__expression] = STATE(7335),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3431] = {
    [sym__expression] = STATE(7945),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3432] = {
    [sym__expression] = STATE(7444),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3433] = {
    [sym__expression] = STATE(8495),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3434] = {
    [sym__expression] = STATE(8833),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3435] = {
    [sym__expression] = STATE(8834),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(5991),
    [sym__array] = STATE(5991),
    [sym_comprehension_expression] = STATE(5991),
    [sym_matrix_expression] = STATE(5991),
    [sym_vector_expression] = STATE(5991),
    [sym_parenthesized_expression] = STATE(5991),
    [sym_tuple_expression] = STATE(5991),
    [sym_curly_expression] = STATE(5991),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(5991),
    [sym_index_expression] = STATE(5991),
    [sym_parametrized_type_expression] = STATE(5991),
    [sym_call_expression] = STATE(5991),
    [sym_broadcast_call_expression] = STATE(5991),
    [sym__closed_macrocall_expression] = STATE(5991),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19501),
    [sym_interpolation_expression] = STATE(5991),
    [sym_quote_expression] = STATE(5991),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(60),
    [sym_identifier] = STATE(4533),
    [sym_boolean_literal] = STATE(5991),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(5991),
    [sym_string_literal] = STATE(5991),
    [sym_command_literal] = STATE(5991),
    [sym_prefixed_string_literal] = STATE(5991),
    [sym_prefixed_command_literal] = STATE(5991),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(853),
    [anon_sym_local] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3214),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(889),
    [sym__type_order_operator] = ACTIONS(889),
    [sym__unary_operator] = ACTIONS(891),
    [sym__unary_plus_operator] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3436] = {
    [sym__expression] = STATE(7338),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3437] = {
    [sym__expression] = STATE(7339),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3438] = {
    [sym__expression] = STATE(8030),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3439] = {
    [sym__expression] = STATE(8031),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3440] = {
    [sym__expression] = STATE(8032),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3441] = {
    [sym__expression] = STATE(8033),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3442] = {
    [sym__expression] = STATE(8034),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3443] = {
    [sym__expression] = STATE(7394),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3444] = {
    [sym__expression] = STATE(13200),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3445] = {
    [sym__expression] = STATE(13316),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3446] = {
    [sym__expression] = STATE(13332),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3447] = {
    [sym__expression] = STATE(13349),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3448] = {
    [sym__expression] = STATE(9199),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3449] = {
    [sym__expression] = STATE(13350),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3450] = {
    [sym__expression] = STATE(13351),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3451] = {
    [sym__expression] = STATE(13353),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3452] = {
    [sym__expression] = STATE(13195),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3453] = {
    [sym__expression] = STATE(13363),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3454] = {
    [sym__expression] = STATE(13368),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3455] = {
    [sym__expression] = STATE(13431),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3456] = {
    [sym__expression] = STATE(13193),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3457] = {
    [sym__expression] = STATE(13198),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3458] = {
    [sym__expression] = STATE(13100),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3459] = {
    [sym__expression] = STATE(12906),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3460] = {
    [sym__expression] = STATE(13536),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3461] = {
    [sym__expression] = STATE(13196),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3462] = {
    [sym__expression] = STATE(13299),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11420),
    [sym__array] = STATE(11420),
    [sym_comprehension_expression] = STATE(11420),
    [sym_matrix_expression] = STATE(11420),
    [sym_vector_expression] = STATE(11420),
    [sym_parenthesized_expression] = STATE(11420),
    [sym_tuple_expression] = STATE(11420),
    [sym_curly_expression] = STATE(11420),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11420),
    [sym_index_expression] = STATE(11420),
    [sym_parametrized_type_expression] = STATE(11420),
    [sym_call_expression] = STATE(11420),
    [sym_broadcast_call_expression] = STATE(11420),
    [sym__closed_macrocall_expression] = STATE(11420),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18902),
    [sym_interpolation_expression] = STATE(11420),
    [sym_quote_expression] = STATE(11420),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10467),
    [sym_boolean_literal] = STATE(11420),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11420),
    [sym_string_literal] = STATE(11420),
    [sym_command_literal] = STATE(11420),
    [sym_prefixed_string_literal] = STATE(11420),
    [sym_prefixed_command_literal] = STATE(11420),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(11000),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11002),
    [sym__type_order_operator] = ACTIONS(11002),
    [sym__unary_operator] = ACTIONS(3300),
    [sym__unary_plus_operator] = ACTIONS(3300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3463] = {
    [sym__expression] = STATE(13231),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3464] = {
    [sym__expression] = STATE(13269),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3465] = {
    [sym__expression] = STATE(8864),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3466] = {
    [sym__expression] = STATE(13202),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3467] = {
    [sym__expression] = STATE(8866),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3468] = {
    [sym__expression] = STATE(8867),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3469] = {
    [sym__expression] = STATE(8887),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3470] = {
    [sym__expression] = STATE(8888),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3471] = {
    [sym__expression] = STATE(13203),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3472] = {
    [sym__expression] = STATE(13205),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3473] = {
    [sym__expression] = STATE(8889),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3474] = {
    [sym__expression] = STATE(8890),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3475] = {
    [sym__expression] = STATE(8892),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3476] = {
    [sym__expression] = STATE(8894),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3477] = {
    [sym__expression] = STATE(8896),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3478] = {
    [sym__expression] = STATE(8897),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3479] = {
    [sym__expression] = STATE(8900),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3480] = {
    [sym__expression] = STATE(8901),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3481] = {
    [sym__expression] = STATE(13209),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3482] = {
    [sym__expression] = STATE(13212),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3483] = {
    [sym__expression] = STATE(8902),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3484] = {
    [sym__expression] = STATE(8394),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3485] = {
    [sym__expression] = STATE(8531),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3486] = {
    [sym__expression] = STATE(14161),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3487] = {
    [sym__expression] = STATE(14162),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3488] = {
    [sym__expression] = STATE(14170),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3489] = {
    [sym__expression] = STATE(14169),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3490] = {
    [sym__expression] = STATE(14176),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3491] = {
    [sym__expression] = STATE(9257),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3492] = {
    [sym__expression] = STATE(9258),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3493] = {
    [sym__expression] = STATE(9261),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3494] = {
    [sym__expression] = STATE(9272),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3495] = {
    [sym__expression] = STATE(9253),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3496] = {
    [sym__expression] = STATE(12372),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3497] = {
    [sym__expression] = STATE(12522),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3498] = {
    [sym__expression] = STATE(9284),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3499] = {
    [sym__expression] = STATE(12524),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3500] = {
    [sym__expression] = STATE(9285),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3501] = {
    [sym__expression] = STATE(12525),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3502] = {
    [sym__expression] = STATE(9286),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3503] = {
    [sym__expression] = STATE(12527),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3504] = {
    [sym__expression] = STATE(12528),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3505] = {
    [sym__expression] = STATE(12529),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3506] = {
    [sym__expression] = STATE(12532),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3507] = {
    [sym__expression] = STATE(12533),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3508] = {
    [sym__expression] = STATE(12535),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3509] = {
    [sym__expression] = STATE(12536),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3510] = {
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3511] = {
    [sym__expression] = STATE(12538),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3512] = {
    [sym__expression] = STATE(12539),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3513] = {
    [sym__expression] = STATE(12540),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3514] = {
    [sym__expression] = STATE(12854),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(10533),
    [sym_comprehension_expression] = STATE(10533),
    [sym_matrix_expression] = STATE(10533),
    [sym_vector_expression] = STATE(10533),
    [sym_parenthesized_expression] = STATE(10533),
    [sym_tuple_expression] = STATE(10533),
    [sym_curly_expression] = STATE(10533),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10533),
    [sym_index_expression] = STATE(10533),
    [sym_parametrized_type_expression] = STATE(10533),
    [sym_call_expression] = STATE(10533),
    [sym_broadcast_call_expression] = STATE(10533),
    [sym__closed_macrocall_expression] = STATE(10533),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19515),
    [sym_interpolation_expression] = STATE(10533),
    [sym_quote_expression] = STATE(10533),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12151),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(10533),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10533),
    [sym_string_literal] = STATE(10533),
    [sym_command_literal] = STATE(10533),
    [sym_prefixed_string_literal] = STATE(10533),
    [sym_prefixed_command_literal] = STATE(10533),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(2035),
    [anon_sym_local] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11028),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(1255),
    [sym__unary_plus_operator] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3515] = {
    [sym__expression] = STATE(13072),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10991),
    [sym__array] = STATE(10991),
    [sym_comprehension_expression] = STATE(10991),
    [sym_matrix_expression] = STATE(10991),
    [sym_vector_expression] = STATE(10991),
    [sym_parenthesized_expression] = STATE(10991),
    [sym_tuple_expression] = STATE(10991),
    [sym_curly_expression] = STATE(10991),
    [sym_adjoint_expression] = STATE(6880),
    [sym_field_expression] = STATE(10991),
    [sym_index_expression] = STATE(10991),
    [sym_parametrized_type_expression] = STATE(10991),
    [sym_call_expression] = STATE(10991),
    [sym_broadcast_call_expression] = STATE(10991),
    [sym__closed_macrocall_expression] = STATE(10991),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19676),
    [sym_interpolation_expression] = STATE(10991),
    [sym_quote_expression] = STATE(10991),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12694),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(16),
    [sym_identifier] = STATE(10186),
    [sym_boolean_literal] = STATE(10991),
    [sym_integer_literal] = STATE(9330),
    [sym_float_literal] = STATE(9330),
    [sym__string] = STATE(10991),
    [sym_string_literal] = STATE(10991),
    [sym_command_literal] = STATE(10991),
    [sym_prefixed_string_literal] = STATE(10991),
    [sym_prefixed_command_literal] = STATE(10991),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_begin] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_global] = ACTIONS(1199),
    [anon_sym_local] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1205),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_using] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4162),
    [anon_sym_COLON_COLON] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4168),
    [aux_sym_integer_literal_token2] = ACTIONS(4168),
    [aux_sym_integer_literal_token3] = ACTIONS(1221),
    [aux_sym_integer_literal_token4] = ACTIONS(1223),
    [aux_sym_float_literal_token1] = ACTIONS(4170),
    [aux_sym_float_literal_token3] = ACTIONS(4170),
    [aux_sym_float_literal_token4] = ACTIONS(4170),
    [sym_character_literal] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(4174),
    [sym__arrow_operator] = ACTIONS(2043),
    [sym__comparison_operator] = ACTIONS(2043),
    [sym__pipe_right_operator] = ACTIONS(4174),
    [sym__pipe_left_operator] = ACTIONS(4174),
    [sym__ellipsis_operator] = ACTIONS(4174),
    [sym__plus_operator] = ACTIONS(2043),
    [sym__times_operator] = ACTIONS(2043),
    [sym__rational_operator] = ACTIONS(4174),
    [sym__bitshift_operator] = ACTIONS(4174),
    [sym__power_operator] = ACTIONS(4174),
    [sym__tilde_operator] = ACTIONS(11024),
    [sym__type_order_operator] = ACTIONS(11024),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__unary_plus_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3516] = {
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3517] = {
    [sym__expression] = STATE(13215),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3518] = {
    [sym__expression] = STATE(13222),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3519] = {
    [sym__expression] = STATE(9262),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3520] = {
    [sym__expression] = STATE(9265),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3521] = {
    [sym__expression] = STATE(9306),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3522] = {
    [sym__expression] = STATE(9274),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3523] = {
    [sym__expression] = STATE(9283),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3524] = {
    [sym__expression] = STATE(8595),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6651),
    [sym__array] = STATE(6651),
    [sym_comprehension_expression] = STATE(6651),
    [sym_matrix_expression] = STATE(6651),
    [sym_vector_expression] = STATE(6651),
    [sym_parenthesized_expression] = STATE(6651),
    [sym_tuple_expression] = STATE(6651),
    [sym_curly_expression] = STATE(6651),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6651),
    [sym_index_expression] = STATE(6651),
    [sym_parametrized_type_expression] = STATE(6651),
    [sym_call_expression] = STATE(6651),
    [sym_broadcast_call_expression] = STATE(6651),
    [sym__closed_macrocall_expression] = STATE(6651),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19548),
    [sym_interpolation_expression] = STATE(6651),
    [sym_quote_expression] = STATE(6651),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9173),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(127),
    [sym_identifier] = STATE(4991),
    [sym_boolean_literal] = STATE(6651),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6651),
    [sym_string_literal] = STATE(6651),
    [sym_command_literal] = STATE(6651),
    [sym_prefixed_string_literal] = STATE(6651),
    [sym_prefixed_command_literal] = STATE(6651),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3384),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3386),
    [sym__type_order_operator] = ACTIONS(3386),
    [sym__unary_operator] = ACTIONS(3388),
    [sym__unary_plus_operator] = ACTIONS(3388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3525] = {
    [sym__expression] = STATE(13226),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3526] = {
    [sym__expression] = STATE(9150),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6584),
    [sym__array] = STATE(6584),
    [sym_comprehension_expression] = STATE(6584),
    [sym_matrix_expression] = STATE(6584),
    [sym_vector_expression] = STATE(6584),
    [sym_parenthesized_expression] = STATE(6584),
    [sym_tuple_expression] = STATE(6584),
    [sym_curly_expression] = STATE(6584),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6584),
    [sym_index_expression] = STATE(6584),
    [sym_parametrized_type_expression] = STATE(6584),
    [sym_call_expression] = STATE(6584),
    [sym_broadcast_call_expression] = STATE(6584),
    [sym__closed_macrocall_expression] = STATE(6584),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(19765),
    [sym_interpolation_expression] = STATE(6584),
    [sym_quote_expression] = STATE(6584),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9109),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(82),
    [sym_identifier] = STATE(4734),
    [sym_boolean_literal] = STATE(6584),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6584),
    [sym_string_literal] = STATE(6584),
    [sym_command_literal] = STATE(6584),
    [sym_prefixed_string_literal] = STATE(6584),
    [sym_prefixed_command_literal] = STATE(6584),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(1147),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_global] = ACTIONS(1153),
    [anon_sym_local] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3342),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(1159),
    [sym__type_order_operator] = ACTIONS(1159),
    [sym__unary_operator] = ACTIONS(1161),
    [sym__unary_plus_operator] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [3527] = {
    [sym__expression] = STATE(14152),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3528] = {
    [sym__expression] = STATE(14177),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3529] = {
    [sym__expression] = STATE(14164),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3530] = {
    [sym__expression] = STATE(14168),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3531] = {
    [sym__expression] = STATE(12467),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3532] = {
    [sym__expression] = STATE(14172),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3533] = {
    [sym__expression] = STATE(13273),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3534] = {
    [sym__expression] = STATE(8157),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3535] = {
    [sym__expression] = STATE(8158),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3536] = {
    [sym__expression] = STATE(8159),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3537] = {
    [sym__expression] = STATE(8161),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3538] = {
    [sym__expression] = STATE(8162),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3539] = {
    [sym__expression] = STATE(13227),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3540] = {
    [sym__expression] = STATE(13230),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3541] = {
    [sym__expression] = STATE(8163),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3542] = {
    [sym__expression] = STATE(8164),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3543] = {
    [sym__expression] = STATE(8165),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3544] = {
    [sym__expression] = STATE(8166),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3545] = {
    [sym__expression] = STATE(8167),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3546] = {
    [sym__expression] = STATE(13324),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3547] = {
    [sym__expression] = STATE(8348),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3548] = {
    [sym__expression] = STATE(8540),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3549] = {
    [sym__expression] = STATE(8168),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3550] = {
    [sym__expression] = STATE(8541),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3551] = {
    [sym__expression] = STATE(13002),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3552] = {
    [sym__expression] = STATE(12270),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3553] = {
    [sym__expression] = STATE(12271),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3554] = {
    [sym__expression] = STATE(12272),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3555] = {
    [sym__expression] = STATE(12273),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3556] = {
    [sym__expression] = STATE(12275),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3557] = {
    [sym__expression] = STATE(12276),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3558] = {
    [sym__expression] = STATE(12277),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3559] = {
    [sym__expression] = STATE(8542),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3560] = {
    [sym__expression] = STATE(8544),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3561] = {
    [sym__expression] = STATE(12278),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3562] = {
    [sym__expression] = STATE(12279),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3563] = {
    [sym__expression] = STATE(12280),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3564] = {
    [sym__expression] = STATE(8169),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3565] = {
    [sym__expression] = STATE(8545),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3566] = {
    [sym__expression] = STATE(8172),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3567] = {
    [sym__expression] = STATE(12281),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3568] = {
    [sym__expression] = STATE(8546),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3569] = {
    [sym__expression] = STATE(8547),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3570] = {
    [sym__expression] = STATE(8548),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3571] = {
    [sym__expression] = STATE(8549),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3572] = {
    [sym__expression] = STATE(8173),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3573] = {
    [sym__expression] = STATE(7444),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(5731),
    [sym__array] = STATE(5731),
    [sym_comprehension_expression] = STATE(5731),
    [sym_matrix_expression] = STATE(5731),
    [sym_vector_expression] = STATE(5731),
    [sym_parenthesized_expression] = STATE(5731),
    [sym_tuple_expression] = STATE(5731),
    [sym_curly_expression] = STATE(5731),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(5731),
    [sym_index_expression] = STATE(5731),
    [sym_parametrized_type_expression] = STATE(5731),
    [sym_call_expression] = STATE(5731),
    [sym_broadcast_call_expression] = STATE(5731),
    [sym__closed_macrocall_expression] = STATE(5731),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18617),
    [sym_interpolation_expression] = STATE(5731),
    [sym_quote_expression] = STATE(5731),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(8052),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(4271),
    [sym_boolean_literal] = STATE(5731),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(5731),
    [sym_string_literal] = STATE(5731),
    [sym_command_literal] = STATE(5731),
    [sym_prefixed_string_literal] = STATE(5731),
    [sym_prefixed_command_literal] = STATE(5731),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(769),
    [anon_sym_local] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11044),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(11046),
    [sym__type_order_operator] = ACTIONS(11046),
    [sym__unary_operator] = ACTIONS(3015),
    [sym__unary_plus_operator] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3574] = {
    [sym__expression] = STATE(8550),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3575] = {
    [sym__expression] = STATE(12282),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3576] = {
    [sym__expression] = STATE(7365),
    [sym_module_definition] = STATE(7366),
    [sym_abstract_definition] = STATE(7366),
    [sym_primitive_definition] = STATE(7366),
    [sym_struct_definition] = STATE(7366),
    [sym_function_definition] = STATE(7366),
    [sym_macro_definition] = STATE(7366),
    [sym_compound_statement] = STATE(7366),
    [sym_quote_statement] = STATE(7366),
    [sym_let_statement] = STATE(7366),
    [sym_if_statement] = STATE(7366),
    [sym_try_statement] = STATE(7366),
    [sym_for_statement] = STATE(7366),
    [sym_while_statement] = STATE(7366),
    [sym_return_statement] = STATE(7366),
    [sym_const_statement] = STATE(7366),
    [sym_global_statement] = STATE(7366),
    [sym_local_statement] = STATE(7366),
    [sym_export_statement] = STATE(7366),
    [sym_import_statement] = STATE(7366),
    [sym__primary_expression] = STATE(4729),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4729),
    [sym_matrix_expression] = STATE(4729),
    [sym_vector_expression] = STATE(4729),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4243),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(7366),
    [sym_argument_list] = STATE(18606),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7366),
    [sym_unary_expression] = STATE(7366),
    [sym_range_expression] = STATE(7366),
    [sym_splat_expression] = STATE(7366),
    [sym_ternary_expression] = STATE(7366),
    [sym_typed_expression] = STATE(6869),
    [sym_unary_typed_expression] = STATE(7366),
    [sym_function_expression] = STATE(7366),
    [sym_juxtaposition_expression] = STATE(7366),
    [sym_compound_assignment_expression] = STATE(7366),
    [sym_where_expression] = STATE(7366),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(4277),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4252),
    [sym_float_literal] = STATE(4252),
    [sym__string] = STATE(4729),
    [sym_string_literal] = STATE(4729),
    [sym_command_literal] = STATE(4729),
    [sym_prefixed_string_literal] = STATE(4729),
    [sym_prefixed_command_literal] = STATE(4729),
    [sym_operator] = STATE(7141),
    [sym__word_identifier] = ACTIONS(227),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_begin] = ACTIONS(233),
    [anon_sym_module] = ACTIONS(235),
    [anon_sym_baremodule] = ACTIONS(235),
    [anon_sym_abstract] = ACTIONS(237),
    [anon_sym_primitive] = ACTIONS(239),
    [anon_sym_mutable] = ACTIONS(241),
    [anon_sym_struct] = ACTIONS(243),
    [anon_sym_function] = ACTIONS(245),
    [anon_sym_macro] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(249),
    [anon_sym_let] = ACTIONS(251),
    [anon_sym_if] = ACTIONS(253),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_for] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(259),
    [sym_break_statement] = ACTIONS(261),
    [sym_continue_statement] = ACTIONS(261),
    [anon_sym_return] = ACTIONS(263),
    [anon_sym_const] = ACTIONS(265),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_local] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(273),
    [anon_sym_import] = ACTIONS(275),
    [anon_sym_using] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(8742),
    [anon_sym_LBRACE] = ACTIONS(8744),
    [anon_sym_DOLLAR] = ACTIONS(8746),
    [anon_sym_COLON_COLON] = ACTIONS(8748),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(287),
    [anon_sym_false] = ACTIONS(287),
    [aux_sym_integer_literal_token1] = ACTIONS(8750),
    [aux_sym_integer_literal_token2] = ACTIONS(8750),
    [aux_sym_integer_literal_token3] = ACTIONS(289),
    [aux_sym_integer_literal_token4] = ACTIONS(291),
    [aux_sym_float_literal_token1] = ACTIONS(8752),
    [aux_sym_float_literal_token3] = ACTIONS(8752),
    [aux_sym_float_literal_token4] = ACTIONS(8752),
    [sym_character_literal] = ACTIONS(11034),
    [sym__pair_operator] = ACTIONS(8756),
    [sym__arrow_operator] = ACTIONS(297),
    [sym__comparison_operator] = ACTIONS(297),
    [sym__pipe_right_operator] = ACTIONS(8756),
    [sym__pipe_left_operator] = ACTIONS(8756),
    [sym__ellipsis_operator] = ACTIONS(8756),
    [sym__plus_operator] = ACTIONS(297),
    [sym__times_operator] = ACTIONS(297),
    [sym__rational_operator] = ACTIONS(8756),
    [sym__bitshift_operator] = ACTIONS(8756),
    [sym__power_operator] = ACTIONS(8756),
    [sym__tilde_operator] = ACTIONS(8758),
    [sym__type_order_operator] = ACTIONS(8758),
    [sym__unary_operator] = ACTIONS(299),
    [sym__unary_plus_operator] = ACTIONS(299),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [3577] = {
    [sym__expression] = STATE(13276),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3578] = {
    [sym__expression] = STATE(12283),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3579] = {
    [sym__expression] = STATE(12284),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3580] = {
    [sym__expression] = STATE(8551),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3581] = {
    [sym__expression] = STATE(8552),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3582] = {
    [sym__expression] = STATE(12593),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(10847),
    [sym__array] = STATE(10847),
    [sym_comprehension_expression] = STATE(10847),
    [sym_matrix_expression] = STATE(10847),
    [sym_vector_expression] = STATE(10847),
    [sym_parenthesized_expression] = STATE(10847),
    [sym_tuple_expression] = STATE(10847),
    [sym_curly_expression] = STATE(10847),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(10847),
    [sym_index_expression] = STATE(10847),
    [sym_parametrized_type_expression] = STATE(10847),
    [sym_call_expression] = STATE(10847),
    [sym_broadcast_call_expression] = STATE(10847),
    [sym__closed_macrocall_expression] = STATE(10847),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(19106),
    [sym_interpolation_expression] = STATE(10847),
    [sym_quote_expression] = STATE(10847),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12063),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(10847),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(10847),
    [sym_string_literal] = STATE(10847),
    [sym_command_literal] = STATE(10847),
    [sym_prefixed_string_literal] = STATE(10847),
    [sym_prefixed_command_literal] = STATE(10847),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1763),
    [anon_sym_global] = ACTIONS(1765),
    [anon_sym_local] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11038),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(5004),
    [sym__type_order_operator] = ACTIONS(5004),
    [sym__unary_operator] = ACTIONS(165),
    [sym__unary_plus_operator] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3583] = {
    [sym__expression] = STATE(13017),
    [sym_module_definition] = STATE(12475),
    [sym_abstract_definition] = STATE(12475),
    [sym_primitive_definition] = STATE(12475),
    [sym_struct_definition] = STATE(12475),
    [sym_function_definition] = STATE(12475),
    [sym_macro_definition] = STATE(12475),
    [sym_compound_statement] = STATE(12475),
    [sym_quote_statement] = STATE(12475),
    [sym_let_statement] = STATE(12475),
    [sym_if_statement] = STATE(12475),
    [sym_try_statement] = STATE(12475),
    [sym_for_statement] = STATE(12475),
    [sym_while_statement] = STATE(12475),
    [sym_return_statement] = STATE(12475),
    [sym_const_statement] = STATE(12475),
    [sym_global_statement] = STATE(12475),
    [sym_local_statement] = STATE(12475),
    [sym_export_statement] = STATE(12475),
    [sym_import_statement] = STATE(12475),
    [sym__primary_expression] = STATE(11006),
    [sym__array] = STATE(11006),
    [sym_comprehension_expression] = STATE(11006),
    [sym_matrix_expression] = STATE(11006),
    [sym_vector_expression] = STATE(11006),
    [sym_parenthesized_expression] = STATE(11006),
    [sym_tuple_expression] = STATE(11006),
    [sym_curly_expression] = STATE(11006),
    [sym_adjoint_expression] = STATE(7167),
    [sym_field_expression] = STATE(11006),
    [sym_index_expression] = STATE(11006),
    [sym_parametrized_type_expression] = STATE(11006),
    [sym_call_expression] = STATE(11006),
    [sym_broadcast_call_expression] = STATE(11006),
    [sym__closed_macrocall_expression] = STATE(11006),
    [sym_macrocall_expression] = STATE(12475),
    [sym_argument_list] = STATE(18716),
    [sym_interpolation_expression] = STATE(11006),
    [sym_quote_expression] = STATE(11006),
    [sym_binary_expression] = STATE(12475),
    [sym_unary_expression] = STATE(12475),
    [sym_range_expression] = STATE(12475),
    [sym_splat_expression] = STATE(12475),
    [sym_ternary_expression] = STATE(12475),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12475),
    [sym_function_expression] = STATE(12475),
    [sym_juxtaposition_expression] = STATE(12475),
    [sym_compound_assignment_expression] = STATE(12475),
    [sym_where_expression] = STATE(12475),
    [sym_macro_identifier] = STATE(25),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(11006),
    [sym_integer_literal] = STATE(9329),
    [sym_float_literal] = STATE(9329),
    [sym__string] = STATE(11006),
    [sym_string_literal] = STATE(11006),
    [sym_command_literal] = STATE(11006),
    [sym_prefixed_string_literal] = STATE(11006),
    [sym_prefixed_command_literal] = STATE(11006),
    [sym_operator] = STATE(12244),
    [sym__word_identifier] = ACTIONS(89),
    [anon_sym_COLON] = ACTIONS(93),
    [anon_sym_begin] = ACTIONS(95),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_baremodule] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(103),
    [anon_sym_mutable] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_macro] = ACTIONS(111),
    [anon_sym_quote] = ACTIONS(113),
    [anon_sym_let] = ACTIONS(115),
    [anon_sym_if] = ACTIONS(117),
    [anon_sym_try] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(121),
    [anon_sym_while] = ACTIONS(123),
    [sym_break_statement] = ACTIONS(125),
    [sym_continue_statement] = ACTIONS(125),
    [anon_sym_return] = ACTIONS(127),
    [anon_sym_const] = ACTIONS(129),
    [anon_sym_global] = ACTIONS(131),
    [anon_sym_local] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(4986),
    [anon_sym_export] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4990),
    [anon_sym_DOLLAR] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4994),
    [anon_sym_AT] = ACTIONS(4996),
    [anon_sym_true] = ACTIONS(155),
    [anon_sym_false] = ACTIONS(155),
    [aux_sym_integer_literal_token1] = ACTIONS(4998),
    [aux_sym_integer_literal_token2] = ACTIONS(4998),
    [aux_sym_integer_literal_token3] = ACTIONS(157),
    [aux_sym_integer_literal_token4] = ACTIONS(159),
    [aux_sym_float_literal_token1] = ACTIONS(5000),
    [aux_sym_float_literal_token3] = ACTIONS(5000),
    [aux_sym_float_literal_token4] = ACTIONS(5000),
    [sym_character_literal] = ACTIONS(11030),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11032),
    [sym__type_order_operator] = ACTIONS(11032),
    [sym__unary_operator] = ACTIONS(3009),
    [sym__unary_plus_operator] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(173),
    [sym__command_start] = ACTIONS(175),
  },
  [3584] = {
    [sym__expression] = STATE(8553),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3585] = {
    [sym__expression] = STATE(8554),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3586] = {
    [sym__expression] = STATE(8503),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3587] = {
    [sym__expression] = STATE(8930),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3588] = {
    [sym__expression] = STATE(13570),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3589] = {
    [sym__expression] = STATE(8999),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3590] = {
    [sym__expression] = STATE(13232),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3591] = {
    [sym__expression] = STATE(13240),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3592] = {
    [sym__expression] = STATE(13241),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3593] = {
    [sym__expression] = STATE(9030),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3594] = {
    [sym__expression] = STATE(9096),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3595] = {
    [sym__expression] = STATE(9099),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3596] = {
    [sym__expression] = STATE(9107),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3597] = {
    [sym__expression] = STATE(8777),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3598] = {
    [sym__expression] = STATE(8780),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3599] = {
    [sym__expression] = STATE(8992),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3600] = {
    [sym__expression] = STATE(8996),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3601] = {
    [sym__expression] = STATE(8998),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3602] = {
    [sym__expression] = STATE(9000),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3603] = {
    [sym__expression] = STATE(9002),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3604] = {
    [sym__expression] = STATE(9100),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3605] = {
    [sym__expression] = STATE(9005),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3606] = {
    [sym__expression] = STATE(9093),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3607] = {
    [sym__expression] = STATE(8503),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(6371),
    [sym__array] = STATE(6371),
    [sym_comprehension_expression] = STATE(6371),
    [sym_matrix_expression] = STATE(6371),
    [sym_vector_expression] = STATE(6371),
    [sym_parenthesized_expression] = STATE(6371),
    [sym_tuple_expression] = STATE(6371),
    [sym_curly_expression] = STATE(6371),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(6371),
    [sym_index_expression] = STATE(6371),
    [sym_parametrized_type_expression] = STATE(6371),
    [sym_call_expression] = STATE(6371),
    [sym_broadcast_call_expression] = STATE(6371),
    [sym__closed_macrocall_expression] = STATE(6371),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18507),
    [sym_interpolation_expression] = STATE(6371),
    [sym_quote_expression] = STATE(6371),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(8679),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(4334),
    [sym_boolean_literal] = STATE(6371),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(6371),
    [sym_string_literal] = STATE(6371),
    [sym_command_literal] = STATE(6371),
    [sym_prefixed_string_literal] = STATE(6371),
    [sym_prefixed_command_literal] = STATE(6371),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_local] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11058),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(11060),
    [sym__type_order_operator] = ACTIONS(11060),
    [sym__unary_operator] = ACTIONS(3250),
    [sym__unary_plus_operator] = ACTIONS(3250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3608] = {
    [sym__expression] = STATE(8245),
    [sym_module_definition] = STATE(8432),
    [sym_abstract_definition] = STATE(8432),
    [sym_primitive_definition] = STATE(8432),
    [sym_struct_definition] = STATE(8432),
    [sym_function_definition] = STATE(8432),
    [sym_macro_definition] = STATE(8432),
    [sym_compound_statement] = STATE(8432),
    [sym_quote_statement] = STATE(8432),
    [sym_let_statement] = STATE(8432),
    [sym_if_statement] = STATE(8432),
    [sym_try_statement] = STATE(8432),
    [sym_for_statement] = STATE(8432),
    [sym_while_statement] = STATE(8432),
    [sym_return_statement] = STATE(8432),
    [sym_const_statement] = STATE(8432),
    [sym_global_statement] = STATE(8432),
    [sym_local_statement] = STATE(8432),
    [sym_export_statement] = STATE(8432),
    [sym_import_statement] = STATE(8432),
    [sym__primary_expression] = STATE(5858),
    [sym__array] = STATE(5858),
    [sym_comprehension_expression] = STATE(5858),
    [sym_matrix_expression] = STATE(5858),
    [sym_vector_expression] = STATE(5858),
    [sym_parenthesized_expression] = STATE(5858),
    [sym_tuple_expression] = STATE(5858),
    [sym_curly_expression] = STATE(5858),
    [sym_adjoint_expression] = STATE(4246),
    [sym_field_expression] = STATE(5858),
    [sym_index_expression] = STATE(5858),
    [sym_parametrized_type_expression] = STATE(5858),
    [sym_call_expression] = STATE(5858),
    [sym_broadcast_call_expression] = STATE(5858),
    [sym__closed_macrocall_expression] = STATE(5858),
    [sym_macrocall_expression] = STATE(8432),
    [sym_argument_list] = STATE(18938),
    [sym_interpolation_expression] = STATE(5858),
    [sym_quote_expression] = STATE(5858),
    [sym_binary_expression] = STATE(8432),
    [sym_unary_expression] = STATE(8432),
    [sym_range_expression] = STATE(8432),
    [sym_splat_expression] = STATE(8432),
    [sym_ternary_expression] = STATE(8432),
    [sym_typed_expression] = STATE(7827),
    [sym_unary_typed_expression] = STATE(8432),
    [sym_function_expression] = STATE(8432),
    [sym_juxtaposition_expression] = STATE(8432),
    [sym_compound_assignment_expression] = STATE(8432),
    [sym_where_expression] = STATE(8432),
    [sym_macro_identifier] = STATE(32),
    [sym_identifier] = STATE(4322),
    [sym_boolean_literal] = STATE(5858),
    [sym_integer_literal] = STATE(4255),
    [sym_float_literal] = STATE(4255),
    [sym__string] = STATE(5858),
    [sym_string_literal] = STATE(5858),
    [sym_command_literal] = STATE(5858),
    [sym_prefixed_string_literal] = STATE(5858),
    [sym_prefixed_command_literal] = STATE(5858),
    [sym_operator] = STATE(7523),
    [sym__word_identifier] = ACTIONS(689),
    [anon_sym_COLON] = ACTIONS(691),
    [anon_sym_begin] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_baremodule] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(697),
    [anon_sym_primitive] = ACTIONS(699),
    [anon_sym_mutable] = ACTIONS(701),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_macro] = ACTIONS(707),
    [anon_sym_quote] = ACTIONS(709),
    [anon_sym_let] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(715),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(719),
    [sym_break_statement] = ACTIONS(721),
    [sym_continue_statement] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(723),
    [anon_sym_const] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_local] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(8760),
    [anon_sym_export] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(735),
    [anon_sym_using] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(8762),
    [anon_sym_LBRACE] = ACTIONS(8764),
    [anon_sym_DOLLAR] = ACTIONS(8766),
    [anon_sym_COLON_COLON] = ACTIONS(8768),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(747),
    [anon_sym_false] = ACTIONS(747),
    [aux_sym_integer_literal_token1] = ACTIONS(8770),
    [aux_sym_integer_literal_token2] = ACTIONS(8770),
    [aux_sym_integer_literal_token3] = ACTIONS(749),
    [aux_sym_integer_literal_token4] = ACTIONS(751),
    [aux_sym_float_literal_token1] = ACTIONS(8772),
    [aux_sym_float_literal_token3] = ACTIONS(8772),
    [aux_sym_float_literal_token4] = ACTIONS(8772),
    [sym_character_literal] = ACTIONS(11056),
    [sym__pair_operator] = ACTIONS(8776),
    [sym__arrow_operator] = ACTIONS(757),
    [sym__comparison_operator] = ACTIONS(757),
    [sym__pipe_right_operator] = ACTIONS(8776),
    [sym__pipe_left_operator] = ACTIONS(8776),
    [sym__ellipsis_operator] = ACTIONS(8776),
    [sym__plus_operator] = ACTIONS(757),
    [sym__times_operator] = ACTIONS(757),
    [sym__rational_operator] = ACTIONS(8776),
    [sym__bitshift_operator] = ACTIONS(8776),
    [sym__power_operator] = ACTIONS(8776),
    [sym__tilde_operator] = ACTIONS(8778),
    [sym__type_order_operator] = ACTIONS(8778),
    [sym__unary_operator] = ACTIONS(759),
    [sym__unary_plus_operator] = ACTIONS(759),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [3609] = {
    [sym__expression] = STATE(13242),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3610] = {
    [sym__expression] = STATE(13915),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3611] = {
    [sym__expression] = STATE(13245),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3612] = {
    [sym__expression] = STATE(13161),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3613] = {
    [sym__expression] = STATE(13246),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3614] = {
    [sym__expression] = STATE(13436),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3615] = {
    [sym__expression] = STATE(13310),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3616] = {
    [sym__expression] = STATE(13312),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3617] = {
    [sym__expression] = STATE(13315),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3618] = {
    [sym__expression] = STATE(13320),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3619] = {
    [sym__expression] = STATE(14124),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3620] = {
    [sym__expression] = STATE(13326),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3621] = {
    [sym__expression] = STATE(13327),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3622] = {
    [sym__expression] = STATE(13331),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3623] = {
    [sym__expression] = STATE(205),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3624] = {
    [sym__expression] = STATE(13337),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3625] = {
    [sym__expression] = STATE(13339),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3626] = {
    [sym__expression] = STATE(13341),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3627] = {
    [sym__expression] = STATE(13344),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3628] = {
    [sym__expression] = STATE(13347),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3629] = {
    [sym__expression] = STATE(13348),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3630] = {
    [sym__expression] = STATE(13113),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3631] = {
    [sym__expression] = STATE(12943),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3632] = {
    [sym__expression] = STATE(13247),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3633] = {
    [sym__expression] = STATE(8177),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3634] = {
    [sym__expression] = STATE(13250),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3635] = {
    [sym__expression] = STATE(13252),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3636] = {
    [sym__expression] = STATE(13069),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3637] = {
    [sym__expression] = STATE(12970),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3638] = {
    [sym__expression] = STATE(13253),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3639] = {
    [sym__expression] = STATE(12921),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3640] = {
    [sym__expression] = STATE(13073),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3641] = {
    [sym__expression] = STATE(13532),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3642] = {
    [sym__expression] = STATE(13533),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3643] = {
    [sym__expression] = STATE(12961),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3644] = {
    [sym__expression] = STATE(12962),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3645] = {
    [sym__expression] = STATE(13079),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3646] = {
    [sym__expression] = STATE(13545),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3647] = {
    [sym__expression] = STATE(12971),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3648] = {
    [sym__expression] = STATE(13081),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3649] = {
    [sym__expression] = STATE(12972),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3650] = {
    [sym__expression] = STATE(12975),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3651] = {
    [sym__expression] = STATE(12978),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3652] = {
    [sym__expression] = STATE(12979),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3653] = {
    [sym__expression] = STATE(13585),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3654] = {
    [sym__expression] = STATE(13586),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3655] = {
    [sym__expression] = STATE(12980),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3656] = {
    [sym__expression] = STATE(13587),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3657] = {
    [sym__expression] = STATE(13588),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3658] = {
    [sym__expression] = STATE(13591),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3659] = {
    [sym__expression] = STATE(13593),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3660] = {
    [sym__expression] = STATE(13082),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3661] = {
    [sym__expression] = STATE(12981),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3662] = {
    [sym__expression] = STATE(12983),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3663] = {
    [sym__expression] = STATE(13083),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3664] = {
    [sym__expression] = STATE(13594),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3665] = {
    [sym__expression] = STATE(12984),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3666] = {
    [sym__expression] = STATE(13086),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3667] = {
    [sym__expression] = STATE(12985),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3668] = {
    [sym__expression] = STATE(12986),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3669] = {
    [sym__expression] = STATE(12987),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3670] = {
    [sym__expression] = STATE(13113),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11144),
    [sym__array] = STATE(11144),
    [sym_comprehension_expression] = STATE(11144),
    [sym_matrix_expression] = STATE(11144),
    [sym_vector_expression] = STATE(11144),
    [sym_parenthesized_expression] = STATE(11144),
    [sym_tuple_expression] = STATE(11144),
    [sym_curly_expression] = STATE(11144),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11144),
    [sym_index_expression] = STATE(11144),
    [sym_parametrized_type_expression] = STATE(11144),
    [sym_call_expression] = STATE(11144),
    [sym_broadcast_call_expression] = STATE(11144),
    [sym__closed_macrocall_expression] = STATE(11144),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19248),
    [sym_interpolation_expression] = STATE(11144),
    [sym_quote_expression] = STATE(11144),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12541),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(10245),
    [sym_boolean_literal] = STATE(11144),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11144),
    [sym_string_literal] = STATE(11144),
    [sym_command_literal] = STATE(11144),
    [sym_prefixed_string_literal] = STATE(11144),
    [sym_prefixed_command_literal] = STATE(11144),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2213),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_global] = ACTIONS(2217),
    [anon_sym_local] = ACTIONS(2219),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11080),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6486),
    [sym__type_order_operator] = ACTIONS(6486),
    [sym__unary_operator] = ACTIONS(2237),
    [sym__unary_plus_operator] = ACTIONS(2237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3671] = {
    [sym__expression] = STATE(13595),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3672] = {
    [sym__expression] = STATE(13578),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3673] = {
    [sym__expression] = STATE(13518),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3674] = {
    [sym__expression] = STATE(13089),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3675] = {
    [sym__expression] = STATE(13580),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3676] = {
    [sym__expression] = STATE(13093),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3677] = {
    [sym__expression] = STATE(13335),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3678] = {
    [sym__expression] = STATE(13181),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11317),
    [sym__array] = STATE(11317),
    [sym_comprehension_expression] = STATE(11317),
    [sym_matrix_expression] = STATE(11317),
    [sym_vector_expression] = STATE(11317),
    [sym_parenthesized_expression] = STATE(11317),
    [sym_tuple_expression] = STATE(11317),
    [sym_curly_expression] = STATE(11317),
    [sym_adjoint_expression] = STATE(8022),
    [sym_field_expression] = STATE(11317),
    [sym_index_expression] = STATE(11317),
    [sym_parametrized_type_expression] = STATE(11317),
    [sym_call_expression] = STATE(11317),
    [sym_broadcast_call_expression] = STATE(11317),
    [sym__closed_macrocall_expression] = STATE(11317),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19023),
    [sym_interpolation_expression] = STATE(11317),
    [sym_quote_expression] = STATE(11317),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12938),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(10257),
    [sym_boolean_literal] = STATE(11317),
    [sym_integer_literal] = STATE(9380),
    [sym_float_literal] = STATE(9380),
    [sym__string] = STATE(11317),
    [sym_string_literal] = STATE(11317),
    [sym_command_literal] = STATE(11317),
    [sym_prefixed_string_literal] = STATE(11317),
    [sym_prefixed_command_literal] = STATE(11317),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2209),
    [anon_sym_begin] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2809),
    [anon_sym_local] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2221),
    [anon_sym_import] = ACTIONS(2223),
    [anon_sym_using] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_COLON_COLON] = ACTIONS(6476),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6480),
    [aux_sym_integer_literal_token2] = ACTIONS(6480),
    [aux_sym_integer_literal_token3] = ACTIONS(2229),
    [aux_sym_integer_literal_token4] = ACTIONS(2231),
    [aux_sym_float_literal_token1] = ACTIONS(6482),
    [aux_sym_float_literal_token3] = ACTIONS(6482),
    [aux_sym_float_literal_token4] = ACTIONS(6482),
    [sym_character_literal] = ACTIONS(11076),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11078),
    [sym__type_order_operator] = ACTIONS(11078),
    [sym__unary_operator] = ACTIONS(3266),
    [sym__unary_plus_operator] = ACTIONS(3266),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3679] = {
    [sym__expression] = STATE(13467),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3680] = {
    [sym__expression] = STATE(13254),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3681] = {
    [sym__expression] = STATE(13094),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3682] = {
    [sym__expression] = STATE(12913),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3683] = {
    [sym__expression] = STATE(13097),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3684] = {
    [sym__expression] = STATE(13098),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3685] = {
    [sym__expression] = STATE(13160),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3686] = {
    [sym__expression] = STATE(13162),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3687] = {
    [sym__expression] = STATE(13100),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11148),
    [sym__array] = STATE(11148),
    [sym_comprehension_expression] = STATE(11148),
    [sym_matrix_expression] = STATE(11148),
    [sym_vector_expression] = STATE(11148),
    [sym_parenthesized_expression] = STATE(11148),
    [sym_tuple_expression] = STATE(11148),
    [sym_curly_expression] = STATE(11148),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11148),
    [sym_index_expression] = STATE(11148),
    [sym_parametrized_type_expression] = STATE(11148),
    [sym_call_expression] = STATE(11148),
    [sym_broadcast_call_expression] = STATE(11148),
    [sym__closed_macrocall_expression] = STATE(11148),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19039),
    [sym_interpolation_expression] = STATE(11148),
    [sym_quote_expression] = STATE(11148),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12803),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(10298),
    [sym_boolean_literal] = STATE(11148),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11148),
    [sym_string_literal] = STATE(11148),
    [sym_command_literal] = STATE(11148),
    [sym_prefixed_string_literal] = STATE(11148),
    [sym_prefixed_command_literal] = STATE(11148),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_global] = ACTIONS(2682),
    [anon_sym_local] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11048),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6648),
    [sym__type_order_operator] = ACTIONS(6648),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__unary_plus_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3688] = {
    [sym__expression] = STATE(13261),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3689] = {
    [sym__expression] = STATE(13263),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3690] = {
    [sym__expression] = STATE(13267),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3691] = {
    [sym__expression] = STATE(13302),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11202),
    [sym__array] = STATE(11202),
    [sym_comprehension_expression] = STATE(11202),
    [sym_matrix_expression] = STATE(11202),
    [sym_vector_expression] = STATE(11202),
    [sym_parenthesized_expression] = STATE(11202),
    [sym_tuple_expression] = STATE(11202),
    [sym_curly_expression] = STATE(11202),
    [sym_adjoint_expression] = STATE(7697),
    [sym_field_expression] = STATE(11202),
    [sym_index_expression] = STATE(11202),
    [sym_parametrized_type_expression] = STATE(11202),
    [sym_call_expression] = STATE(11202),
    [sym_broadcast_call_expression] = STATE(11202),
    [sym__closed_macrocall_expression] = STATE(11202),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19315),
    [sym_interpolation_expression] = STATE(11202),
    [sym_quote_expression] = STATE(11202),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13074),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10267),
    [sym_boolean_literal] = STATE(11202),
    [sym_integer_literal] = STATE(9409),
    [sym_float_literal] = STATE(9409),
    [sym__string] = STATE(11202),
    [sym_string_literal] = STATE(11202),
    [sym_command_literal] = STATE(11202),
    [sym_prefixed_string_literal] = STATE(11202),
    [sym_prefixed_command_literal] = STATE(11202),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2674),
    [anon_sym_begin] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2995),
    [anon_sym_local] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6636),
    [anon_sym_COLON_COLON] = ACTIONS(6638),
    [anon_sym_AT] = ACTIONS(6640),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6642),
    [aux_sym_integer_literal_token2] = ACTIONS(6642),
    [aux_sym_integer_literal_token3] = ACTIONS(2694),
    [aux_sym_integer_literal_token4] = ACTIONS(2696),
    [aux_sym_float_literal_token1] = ACTIONS(6644),
    [aux_sym_float_literal_token3] = ACTIONS(6644),
    [aux_sym_float_literal_token4] = ACTIONS(6644),
    [sym_character_literal] = ACTIONS(11040),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11042),
    [sym__type_order_operator] = ACTIONS(11042),
    [sym__unary_operator] = ACTIONS(3218),
    [sym__unary_plus_operator] = ACTIONS(3218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3692] = {
    [sym__expression] = STATE(12874),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3693] = {
    [sym__expression] = STATE(9015),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3694] = {
    [sym__expression] = STATE(9017),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3695] = {
    [sym__expression] = STATE(9019),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3696] = {
    [sym__expression] = STATE(9020),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3697] = {
    [sym__expression] = STATE(9021),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3698] = {
    [sym__expression] = STATE(9022),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3699] = {
    [sym__expression] = STATE(9023),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3700] = {
    [sym__expression] = STATE(9024),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3701] = {
    [sym__expression] = STATE(9025),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3702] = {
    [sym__expression] = STATE(9038),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3703] = {
    [sym__expression] = STATE(9046),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3704] = {
    [sym__expression] = STATE(9080),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3705] = {
    [sym__expression] = STATE(9092),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3706] = {
    [sym__expression] = STATE(9097),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3707] = {
    [sym__expression] = STATE(8179),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3708] = {
    [sym__expression] = STATE(8276),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3709] = {
    [sym__expression] = STATE(13292),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3710] = {
    [sym__expression] = STATE(13277),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3711] = {
    [sym__expression] = STATE(13286),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3712] = {
    [sym__expression] = STATE(13294),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3713] = {
    [sym__expression] = STATE(13301),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3714] = {
    [sym__expression] = STATE(13657),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3715] = {
    [sym__expression] = STATE(13660),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3716] = {
    [sym__expression] = STATE(284),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3717] = {
    [sym__expression] = STATE(13662),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3718] = {
    [sym__expression] = STATE(13668),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3719] = {
    [sym__expression] = STATE(13669),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3720] = {
    [sym__expression] = STATE(13680),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3721] = {
    [sym__expression] = STATE(13691),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3722] = {
    [sym__expression] = STATE(13693),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3723] = {
    [sym__expression] = STATE(13704),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3724] = {
    [sym__expression] = STATE(13707),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3725] = {
    [sym__expression] = STATE(13711),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3726] = {
    [sym__expression] = STATE(13714),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3727] = {
    [sym__expression] = STATE(13715),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3728] = {
    [sym__expression] = STATE(13725),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3729] = {
    [sym__expression] = STATE(12467),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3730] = {
    [sym__expression] = STATE(13478),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3731] = {
    [sym__expression] = STATE(13303),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3732] = {
    [sym__expression] = STATE(13307),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3733] = {
    [sym__expression] = STATE(13262),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3734] = {
    [sym__expression] = STATE(13270),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3735] = {
    [sym__expression] = STATE(12381),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3736] = {
    [sym__expression] = STATE(12383),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3737] = {
    [sym__expression] = STATE(8410),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3738] = {
    [sym__expression] = STATE(12384),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3739] = {
    [sym__expression] = STATE(12385),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3740] = {
    [sym__expression] = STATE(13672),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3741] = {
    [sym__expression] = STATE(12386),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3742] = {
    [sym__expression] = STATE(12387),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3743] = {
    [sym__expression] = STATE(12388),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3744] = {
    [sym__expression] = STATE(12389),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3745] = {
    [sym__expression] = STATE(12390),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3746] = {
    [sym__expression] = STATE(13677),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3747] = {
    [sym__expression] = STATE(13679),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3748] = {
    [sym__expression] = STATE(12392),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3749] = {
    [sym__expression] = STATE(12393),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3750] = {
    [sym__expression] = STATE(13682),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3751] = {
    [sym__expression] = STATE(12394),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3752] = {
    [sym__expression] = STATE(13683),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3753] = {
    [sym__expression] = STATE(13685),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3754] = {
    [sym__expression] = STATE(13686),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3755] = {
    [sym__expression] = STATE(13687),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3756] = {
    [sym__expression] = STATE(12395),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3757] = {
    [sym__expression] = STATE(12396),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3758] = {
    [sym__expression] = STATE(13688),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3759] = {
    [sym__expression] = STATE(12285),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3760] = {
    [sym__expression] = STATE(12397),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(10701),
    [sym_comprehension_expression] = STATE(10701),
    [sym_matrix_expression] = STATE(10701),
    [sym_vector_expression] = STATE(10701),
    [sym_parenthesized_expression] = STATE(10701),
    [sym_tuple_expression] = STATE(10701),
    [sym_curly_expression] = STATE(10701),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(10701),
    [sym_index_expression] = STATE(10701),
    [sym_parametrized_type_expression] = STATE(10701),
    [sym_call_expression] = STATE(10701),
    [sym_broadcast_call_expression] = STATE(10701),
    [sym__closed_macrocall_expression] = STATE(10701),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18699),
    [sym_interpolation_expression] = STATE(10701),
    [sym_quote_expression] = STATE(10701),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(11896),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(42),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(10701),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(10701),
    [sym_string_literal] = STATE(10701),
    [sym_command_literal] = STATE(10701),
    [sym_prefixed_string_literal] = STATE(10701),
    [sym_prefixed_command_literal] = STATE(10701),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_global] = ACTIONS(2760),
    [anon_sym_local] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10998),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(8572),
    [sym__type_order_operator] = ACTIONS(8572),
    [sym__unary_operator] = ACTIONS(2784),
    [sym__unary_plus_operator] = ACTIONS(2784),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3761] = {
    [sym__expression] = STATE(12583),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3762] = {
    [sym__expression] = STATE(8792),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3763] = {
    [sym__expression] = STATE(8813),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3764] = {
    [sym__expression] = STATE(13689),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3765] = {
    [sym__expression] = STATE(13692),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3766] = {
    [sym__expression] = STATE(8816),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3767] = {
    [sym__expression] = STATE(13271),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3768] = {
    [sym__expression] = STATE(13694),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3769] = {
    [sym__expression] = STATE(12402),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3770] = {
    [sym__expression] = STATE(13695),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3771] = {
    [sym__expression] = STATE(13696),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3772] = {
    [sym__expression] = STATE(13335),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3773] = {
    [sym__expression] = STATE(12403),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3774] = {
    [sym__expression] = STATE(12404),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3775] = {
    [sym__expression] = STATE(13701),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11466),
    [sym__array] = STATE(11466),
    [sym_comprehension_expression] = STATE(11466),
    [sym_matrix_expression] = STATE(11466),
    [sym_vector_expression] = STATE(11466),
    [sym_parenthesized_expression] = STATE(11466),
    [sym_tuple_expression] = STATE(11466),
    [sym_curly_expression] = STATE(11466),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11466),
    [sym_index_expression] = STATE(11466),
    [sym_parametrized_type_expression] = STATE(11466),
    [sym_call_expression] = STATE(11466),
    [sym_broadcast_call_expression] = STATE(11466),
    [sym__closed_macrocall_expression] = STATE(11466),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18430),
    [sym_interpolation_expression] = STATE(11466),
    [sym_quote_expression] = STATE(11466),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13457),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(142),
    [sym_identifier] = STATE(10784),
    [sym_boolean_literal] = STATE(11466),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11466),
    [sym_string_literal] = STATE(11466),
    [sym_command_literal] = STATE(11466),
    [sym_prefixed_string_literal] = STATE(11466),
    [sym_prefixed_command_literal] = STATE(11466),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3376),
    [anon_sym_global] = ACTIONS(3378),
    [anon_sym_local] = ACTIONS(3380),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3546),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3548),
    [sym__type_order_operator] = ACTIONS(3548),
    [sym__unary_operator] = ACTIONS(3550),
    [sym__unary_plus_operator] = ACTIONS(3550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3776] = {
    [sym__expression] = STATE(12405),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3777] = {
    [sym__expression] = STATE(12406),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3778] = {
    [sym__expression] = STATE(12407),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3779] = {
    [sym__expression] = STATE(12409),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3780] = {
    [sym__expression] = STATE(12410),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3781] = {
    [sym__expression] = STATE(12411),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3782] = {
    [sym__expression] = STATE(12412),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3783] = {
    [sym__expression] = STATE(12413),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3784] = {
    [sym__expression] = STATE(12414),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3785] = {
    [sym__expression] = STATE(12415),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3786] = {
    [sym__expression] = STATE(12416),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3787] = {
    [sym__expression] = STATE(12874),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3788] = {
    [sym__expression] = STATE(12417),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(10877),
    [sym_comprehension_expression] = STATE(10877),
    [sym_matrix_expression] = STATE(10877),
    [sym_vector_expression] = STATE(10877),
    [sym_parenthesized_expression] = STATE(10877),
    [sym_tuple_expression] = STATE(10877),
    [sym_curly_expression] = STATE(10877),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(10877),
    [sym_index_expression] = STATE(10877),
    [sym_parametrized_type_expression] = STATE(10877),
    [sym_call_expression] = STATE(10877),
    [sym_broadcast_call_expression] = STATE(10877),
    [sym__closed_macrocall_expression] = STATE(10877),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18912),
    [sym_interpolation_expression] = STATE(10877),
    [sym_quote_expression] = STATE(10877),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(11974),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(62),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(10877),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(10877),
    [sym_string_literal] = STATE(10877),
    [sym_command_literal] = STATE(10877),
    [sym_prefixed_string_literal] = STATE(10877),
    [sym_prefixed_command_literal] = STATE(10877),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2975),
    [anon_sym_local] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11092),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(8584),
    [sym__type_order_operator] = ACTIONS(8584),
    [sym__unary_operator] = ACTIONS(2989),
    [sym__unary_plus_operator] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3789] = {
    [sym__expression] = STATE(8818),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3790] = {
    [sym__expression] = STATE(8842),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3791] = {
    [sym__expression] = STATE(13283),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3792] = {
    [sym__expression] = STATE(8878),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3793] = {
    [sym__expression] = STATE(8928),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3794] = {
    [sym__expression] = STATE(13284),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3795] = {
    [sym__expression] = STATE(9172),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3796] = {
    [sym__expression] = STATE(9174),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3797] = {
    [sym__expression] = STATE(9175),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3798] = {
    [sym__expression] = STATE(9200),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3799] = {
    [sym__expression] = STATE(9201),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3800] = {
    [sym__expression] = STATE(9227),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3801] = {
    [sym__expression] = STATE(9186),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3802] = {
    [sym__expression] = STATE(9142),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3803] = {
    [sym__expression] = STATE(9143),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3804] = {
    [sym__expression] = STATE(9144),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3805] = {
    [sym__expression] = STATE(9145),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3806] = {
    [sym__expression] = STATE(9147),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3807] = {
    [sym__expression] = STATE(9148),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3808] = {
    [sym__expression] = STATE(9163),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3809] = {
    [sym__expression] = STATE(9204),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3810] = {
    [sym__expression] = STATE(8785),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3811] = {
    [sym__expression] = STATE(8969),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3812] = {
    [sym__expression] = STATE(8937),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3813] = {
    [sym__expression] = STATE(8940),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3814] = {
    [sym__expression] = STATE(8977),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3815] = {
    [sym__expression] = STATE(8985),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3816] = {
    [sym__expression] = STATE(13285),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3817] = {
    [sym__expression] = STATE(13288),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3818] = {
    [sym__expression] = STATE(8987),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3819] = {
    [sym__expression] = STATE(13440),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3820] = {
    [sym__expression] = STATE(13445),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3821] = {
    [sym__expression] = STATE(7793),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [3822] = {
    [sym__expression] = STATE(12945),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3823] = {
    [sym__expression] = STATE(12952),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3824] = {
    [sym__expression] = STATE(13448),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3825] = {
    [sym__expression] = STATE(13451),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3826] = {
    [sym__expression] = STATE(12954),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3827] = {
    [sym__expression] = STATE(13452),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3828] = {
    [sym__expression] = STATE(13453),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3829] = {
    [sym__expression] = STATE(13406),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3830] = {
    [sym__expression] = STATE(13454),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3831] = {
    [sym__expression] = STATE(13455),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3832] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11572),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11572),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13833),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11209),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3833] = {
    [sym__expression] = STATE(13407),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3834] = {
    [sym__expression] = STATE(8424),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3835] = {
    [sym__expression] = STATE(8425),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3836] = {
    [sym__expression] = STATE(12964),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3837] = {
    [sym__expression] = STATE(12965),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3838] = {
    [sym__expression] = STATE(8426),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3839] = {
    [sym__expression] = STATE(13423),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3840] = {
    [sym__expression] = STATE(8428),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3841] = {
    [sym__expression] = STATE(8430),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3842] = {
    [sym__expression] = STATE(8431),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3843] = {
    [sym__expression] = STATE(13424),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3844] = {
    [sym__expression] = STATE(13425),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3845] = {
    [sym__expression] = STATE(8446),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3846] = {
    [sym__expression] = STATE(13426),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3847] = {
    [sym__expression] = STATE(13427),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3848] = {
    [sym__expression] = STATE(13429),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3849] = {
    [sym__expression] = STATE(13456),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3850] = {
    [sym__expression] = STATE(13430),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3851] = {
    [sym__expression] = STATE(8448),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3852] = {
    [sym__expression] = STATE(8450),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3853] = {
    [sym__expression] = STATE(13458),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3854] = {
    [sym__expression] = STATE(8451),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3855] = {
    [sym__expression] = STATE(13459),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3856] = {
    [sym__expression] = STATE(8683),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3857] = {
    [sym__expression] = STATE(8140),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3858] = {
    [sym__expression] = STATE(8143),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3859] = {
    [sym__expression] = STATE(13460),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3860] = {
    [sym__expression] = STATE(8174),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3861] = {
    [sym__expression] = STATE(13463),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3862] = {
    [sym__expression] = STATE(13464),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3863] = {
    [sym__expression] = STATE(13324),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11397),
    [sym__array] = STATE(11397),
    [sym_comprehension_expression] = STATE(11397),
    [sym_matrix_expression] = STATE(11397),
    [sym_vector_expression] = STATE(11397),
    [sym_parenthesized_expression] = STATE(11397),
    [sym_tuple_expression] = STATE(11397),
    [sym_curly_expression] = STATE(11397),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11397),
    [sym_index_expression] = STATE(11397),
    [sym_parametrized_type_expression] = STATE(11397),
    [sym_call_expression] = STATE(11397),
    [sym_broadcast_call_expression] = STATE(11397),
    [sym__closed_macrocall_expression] = STATE(11397),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18428),
    [sym_interpolation_expression] = STATE(11397),
    [sym_quote_expression] = STATE(11397),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13411),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(79),
    [sym_identifier] = STATE(10415),
    [sym_boolean_literal] = STATE(11397),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11397),
    [sym_string_literal] = STATE(11397),
    [sym_command_literal] = STATE(11397),
    [sym_prefixed_string_literal] = STATE(11397),
    [sym_prefixed_command_literal] = STATE(11397),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_const] = ACTIONS(185),
    [anon_sym_global] = ACTIONS(187),
    [anon_sym_local] = ACTIONS(189),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11062),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11064),
    [sym__type_order_operator] = ACTIONS(11064),
    [sym__unary_operator] = ACTIONS(3340),
    [sym__unary_plus_operator] = ACTIONS(3340),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3864] = {
    [sym__expression] = STATE(13335),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3865] = {
    [sym__expression] = STATE(13362),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11360),
    [sym__array] = STATE(11360),
    [sym_comprehension_expression] = STATE(11360),
    [sym_matrix_expression] = STATE(11360),
    [sym_vector_expression] = STATE(11360),
    [sym_parenthesized_expression] = STATE(11360),
    [sym_tuple_expression] = STATE(11360),
    [sym_curly_expression] = STATE(11360),
    [sym_adjoint_expression] = STATE(8300),
    [sym_field_expression] = STATE(11360),
    [sym_index_expression] = STATE(11360),
    [sym_parametrized_type_expression] = STATE(11360),
    [sym_call_expression] = STATE(11360),
    [sym_broadcast_call_expression] = STATE(11360),
    [sym__closed_macrocall_expression] = STATE(11360),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18836),
    [sym_interpolation_expression] = STATE(11360),
    [sym_quote_expression] = STATE(11360),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13070),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(50),
    [sym_identifier] = STATE(10353),
    [sym_boolean_literal] = STATE(11360),
    [sym_integer_literal] = STATE(9451),
    [sym_float_literal] = STATE(9451),
    [sym__string] = STATE(11360),
    [sym_string_literal] = STATE(11360),
    [sym_command_literal] = STATE(11360),
    [sym_prefixed_string_literal] = STATE(11360),
    [sym_prefixed_command_literal] = STATE(11360),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_global] = ACTIONS(2716),
    [anon_sym_local] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(193),
    [anon_sym_import] = ACTIONS(195),
    [anon_sym_using] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(6970),
    [anon_sym_COLON_COLON] = ACTIONS(6972),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6976),
    [aux_sym_integer_literal_token2] = ACTIONS(6976),
    [aux_sym_integer_literal_token3] = ACTIONS(211),
    [aux_sym_integer_literal_token4] = ACTIONS(213),
    [aux_sym_float_literal_token1] = ACTIONS(6978),
    [aux_sym_float_literal_token3] = ACTIONS(6978),
    [aux_sym_float_literal_token4] = ACTIONS(6978),
    [sym_character_literal] = ACTIONS(11036),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(6982),
    [sym__type_order_operator] = ACTIONS(6982),
    [sym__unary_operator] = ACTIONS(219),
    [sym__unary_plus_operator] = ACTIONS(219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3866] = {
    [sym__expression] = STATE(8179),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(5341),
    [sym__array] = STATE(5341),
    [sym_comprehension_expression] = STATE(5341),
    [sym_matrix_expression] = STATE(5341),
    [sym_vector_expression] = STATE(5341),
    [sym_parenthesized_expression] = STATE(5341),
    [sym_tuple_expression] = STATE(5341),
    [sym_curly_expression] = STATE(5341),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(5341),
    [sym_index_expression] = STATE(5341),
    [sym_parametrized_type_expression] = STATE(5341),
    [sym_call_expression] = STATE(5341),
    [sym_broadcast_call_expression] = STATE(5341),
    [sym__closed_macrocall_expression] = STATE(5341),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19403),
    [sym_interpolation_expression] = STATE(5341),
    [sym_quote_expression] = STATE(5341),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(7966),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(4326),
    [sym_boolean_literal] = STATE(5341),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(5341),
    [sym_string_literal] = STATE(5341),
    [sym_command_literal] = STATE(5341),
    [sym_prefixed_string_literal] = STATE(5341),
    [sym_prefixed_command_literal] = STATE(5341),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(565),
    [anon_sym_const] = ACTIONS(567),
    [anon_sym_global] = ACTIONS(569),
    [anon_sym_local] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11090),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(8802),
    [sym__type_order_operator] = ACTIONS(8802),
    [sym__unary_operator] = ACTIONS(601),
    [sym__unary_plus_operator] = ACTIONS(601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3867] = {
    [sym__expression] = STATE(13239),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3868] = {
    [sym__expression] = STATE(8990),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3869] = {
    [sym__expression] = STATE(9014),
    [sym_module_definition] = STATE(8678),
    [sym_abstract_definition] = STATE(8678),
    [sym_primitive_definition] = STATE(8678),
    [sym_struct_definition] = STATE(8678),
    [sym_function_definition] = STATE(8678),
    [sym_macro_definition] = STATE(8678),
    [sym_compound_statement] = STATE(8678),
    [sym_quote_statement] = STATE(8678),
    [sym_let_statement] = STATE(8678),
    [sym_if_statement] = STATE(8678),
    [sym_try_statement] = STATE(8678),
    [sym_for_statement] = STATE(8678),
    [sym_while_statement] = STATE(8678),
    [sym_return_statement] = STATE(8678),
    [sym_const_statement] = STATE(8678),
    [sym_global_statement] = STATE(8678),
    [sym_local_statement] = STATE(8678),
    [sym_export_statement] = STATE(8678),
    [sym_import_statement] = STATE(8678),
    [sym__primary_expression] = STATE(6373),
    [sym__array] = STATE(6373),
    [sym_comprehension_expression] = STATE(6373),
    [sym_matrix_expression] = STATE(6373),
    [sym_vector_expression] = STATE(6373),
    [sym_parenthesized_expression] = STATE(6373),
    [sym_tuple_expression] = STATE(6373),
    [sym_curly_expression] = STATE(6373),
    [sym_adjoint_expression] = STATE(4249),
    [sym_field_expression] = STATE(6373),
    [sym_index_expression] = STATE(6373),
    [sym_parametrized_type_expression] = STATE(6373),
    [sym_call_expression] = STATE(6373),
    [sym_broadcast_call_expression] = STATE(6373),
    [sym__closed_macrocall_expression] = STATE(6373),
    [sym_macrocall_expression] = STATE(8678),
    [sym_argument_list] = STATE(19680),
    [sym_interpolation_expression] = STATE(6373),
    [sym_quote_expression] = STATE(6373),
    [sym_binary_expression] = STATE(8678),
    [sym_unary_expression] = STATE(8678),
    [sym_range_expression] = STATE(8678),
    [sym_splat_expression] = STATE(8678),
    [sym_ternary_expression] = STATE(8678),
    [sym_typed_expression] = STATE(8681),
    [sym_unary_typed_expression] = STATE(8678),
    [sym_function_expression] = STATE(8678),
    [sym_juxtaposition_expression] = STATE(8678),
    [sym_compound_assignment_expression] = STATE(8678),
    [sym_where_expression] = STATE(8678),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(4298),
    [sym_boolean_literal] = STATE(6373),
    [sym_integer_literal] = STATE(4258),
    [sym_float_literal] = STATE(4258),
    [sym__string] = STATE(6373),
    [sym_string_literal] = STATE(6373),
    [sym_command_literal] = STATE(6373),
    [sym_prefixed_string_literal] = STATE(6373),
    [sym_prefixed_command_literal] = STATE(6373),
    [sym_operator] = STATE(7659),
    [sym__word_identifier] = ACTIONS(531),
    [anon_sym_COLON] = ACTIONS(533),
    [anon_sym_begin] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_baremodule] = ACTIONS(537),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_primitive] = ACTIONS(541),
    [anon_sym_mutable] = ACTIONS(543),
    [anon_sym_struct] = ACTIONS(545),
    [anon_sym_function] = ACTIONS(547),
    [anon_sym_macro] = ACTIONS(549),
    [anon_sym_quote] = ACTIONS(551),
    [anon_sym_let] = ACTIONS(553),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(557),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(561),
    [sym_break_statement] = ACTIONS(563),
    [sym_continue_statement] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(577),
    [anon_sym_using] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(8786),
    [anon_sym_LBRACE] = ACTIONS(8788),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_COLON_COLON] = ACTIONS(8792),
    [anon_sym_AT] = ACTIONS(6478),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [aux_sym_integer_literal_token1] = ACTIONS(8794),
    [aux_sym_integer_literal_token2] = ACTIONS(8794),
    [aux_sym_integer_literal_token3] = ACTIONS(591),
    [aux_sym_integer_literal_token4] = ACTIONS(593),
    [aux_sym_float_literal_token1] = ACTIONS(8796),
    [aux_sym_float_literal_token3] = ACTIONS(8796),
    [aux_sym_float_literal_token4] = ACTIONS(8796),
    [sym_character_literal] = ACTIONS(11086),
    [sym__pair_operator] = ACTIONS(8800),
    [sym__arrow_operator] = ACTIONS(599),
    [sym__comparison_operator] = ACTIONS(599),
    [sym__pipe_right_operator] = ACTIONS(8800),
    [sym__pipe_left_operator] = ACTIONS(8800),
    [sym__ellipsis_operator] = ACTIONS(8800),
    [sym__plus_operator] = ACTIONS(599),
    [sym__times_operator] = ACTIONS(599),
    [sym__rational_operator] = ACTIONS(8800),
    [sym__bitshift_operator] = ACTIONS(8800),
    [sym__power_operator] = ACTIONS(8800),
    [sym__tilde_operator] = ACTIONS(11088),
    [sym__type_order_operator] = ACTIONS(11088),
    [sym__unary_operator] = ACTIONS(3292),
    [sym__unary_plus_operator] = ACTIONS(3292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [3870] = {
    [sym__expression] = STATE(8991),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3871] = {
    [sym__expression] = STATE(8785),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6106),
    [sym__array] = STATE(6106),
    [sym_comprehension_expression] = STATE(6106),
    [sym_matrix_expression] = STATE(6106),
    [sym_vector_expression] = STATE(6106),
    [sym_parenthesized_expression] = STATE(6106),
    [sym_tuple_expression] = STATE(6106),
    [sym_curly_expression] = STATE(6106),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6106),
    [sym_index_expression] = STATE(6106),
    [sym_parametrized_type_expression] = STATE(6106),
    [sym_call_expression] = STATE(6106),
    [sym_broadcast_call_expression] = STATE(6106),
    [sym__closed_macrocall_expression] = STATE(6106),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18814),
    [sym_interpolation_expression] = STATE(6106),
    [sym_quote_expression] = STATE(6106),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(8587),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(58),
    [sym_identifier] = STATE(4536),
    [sym_boolean_literal] = STATE(6106),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6106),
    [sym_string_literal] = STATE(6106),
    [sym_command_literal] = STATE(6106),
    [sym_prefixed_string_literal] = STATE(6106),
    [sym_prefixed_command_literal] = STATE(6106),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(961),
    [anon_sym_local] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11066),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(8556),
    [sym__type_order_operator] = ACTIONS(8556),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3872] = {
    [sym__expression] = STATE(13260),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3873] = {
    [sym__expression] = STATE(9195),
    [sym_module_definition] = STATE(9034),
    [sym_abstract_definition] = STATE(9034),
    [sym_primitive_definition] = STATE(9034),
    [sym_struct_definition] = STATE(9034),
    [sym_function_definition] = STATE(9034),
    [sym_macro_definition] = STATE(9034),
    [sym_compound_statement] = STATE(9034),
    [sym_quote_statement] = STATE(9034),
    [sym_let_statement] = STATE(9034),
    [sym_if_statement] = STATE(9034),
    [sym_try_statement] = STATE(9034),
    [sym_for_statement] = STATE(9034),
    [sym_while_statement] = STATE(9034),
    [sym_return_statement] = STATE(9034),
    [sym_const_statement] = STATE(9034),
    [sym_global_statement] = STATE(9034),
    [sym_local_statement] = STATE(9034),
    [sym_export_statement] = STATE(9034),
    [sym_import_statement] = STATE(9034),
    [sym__primary_expression] = STATE(6590),
    [sym__array] = STATE(6590),
    [sym_comprehension_expression] = STATE(6590),
    [sym_matrix_expression] = STATE(6590),
    [sym_vector_expression] = STATE(6590),
    [sym_parenthesized_expression] = STATE(6590),
    [sym_tuple_expression] = STATE(6590),
    [sym_curly_expression] = STATE(6590),
    [sym_adjoint_expression] = STATE(4251),
    [sym_field_expression] = STATE(6590),
    [sym_index_expression] = STATE(6590),
    [sym_parametrized_type_expression] = STATE(6590),
    [sym_call_expression] = STATE(6590),
    [sym_broadcast_call_expression] = STATE(6590),
    [sym__closed_macrocall_expression] = STATE(6590),
    [sym_macrocall_expression] = STATE(9034),
    [sym_argument_list] = STATE(18230),
    [sym_interpolation_expression] = STATE(6590),
    [sym_quote_expression] = STATE(6590),
    [sym_binary_expression] = STATE(9034),
    [sym_unary_expression] = STATE(9034),
    [sym_range_expression] = STATE(9034),
    [sym_splat_expression] = STATE(9034),
    [sym_ternary_expression] = STATE(9034),
    [sym_typed_expression] = STATE(9057),
    [sym_unary_typed_expression] = STATE(9034),
    [sym_function_expression] = STATE(9034),
    [sym_juxtaposition_expression] = STATE(9034),
    [sym_compound_assignment_expression] = STATE(9034),
    [sym_where_expression] = STATE(9034),
    [sym_macro_identifier] = STATE(67),
    [sym_identifier] = STATE(4470),
    [sym_boolean_literal] = STATE(6590),
    [sym_integer_literal] = STATE(4260),
    [sym_float_literal] = STATE(4260),
    [sym__string] = STATE(6590),
    [sym_string_literal] = STATE(6590),
    [sym_command_literal] = STATE(6590),
    [sym_prefixed_string_literal] = STATE(6590),
    [sym_prefixed_command_literal] = STATE(6590),
    [sym_operator] = STATE(8273),
    [sym__word_identifier] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(925),
    [anon_sym_begin] = ACTIONS(927),
    [anon_sym_module] = ACTIONS(929),
    [anon_sym_baremodule] = ACTIONS(929),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_primitive] = ACTIONS(933),
    [anon_sym_mutable] = ACTIONS(935),
    [anon_sym_struct] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_macro] = ACTIONS(941),
    [anon_sym_quote] = ACTIONS(943),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(949),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(953),
    [sym_break_statement] = ACTIONS(955),
    [sym_continue_statement] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1175),
    [anon_sym_global] = ACTIONS(1177),
    [anon_sym_local] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(967),
    [anon_sym_import] = ACTIONS(969),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(8542),
    [anon_sym_COLON_COLON] = ACTIONS(8544),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11094),
    [sym__pair_operator] = ACTIONS(8554),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(8554),
    [sym__pipe_left_operator] = ACTIONS(8554),
    [sym__ellipsis_operator] = ACTIONS(8554),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(8554),
    [sym__bitshift_operator] = ACTIONS(8554),
    [sym__power_operator] = ACTIONS(8554),
    [sym__tilde_operator] = ACTIONS(11096),
    [sym__type_order_operator] = ACTIONS(11096),
    [sym__unary_operator] = ACTIONS(3296),
    [sym__unary_plus_operator] = ACTIONS(3296),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [3874] = {
    [sym__expression] = STATE(13308),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3875] = {
    [sym__expression] = STATE(12285),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11247),
    [sym__array] = STATE(11247),
    [sym_comprehension_expression] = STATE(11247),
    [sym_matrix_expression] = STATE(11247),
    [sym_vector_expression] = STATE(11247),
    [sym_parenthesized_expression] = STATE(11247),
    [sym_tuple_expression] = STATE(11247),
    [sym_curly_expression] = STATE(11247),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11247),
    [sym_index_expression] = STATE(11247),
    [sym_parametrized_type_expression] = STATE(11247),
    [sym_call_expression] = STATE(11247),
    [sym_broadcast_call_expression] = STATE(11247),
    [sym__closed_macrocall_expression] = STATE(11247),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18322),
    [sym_interpolation_expression] = STATE(11247),
    [sym_quote_expression] = STATE(11247),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(13019),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10386),
    [sym_boolean_literal] = STATE(11247),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11247),
    [sym_string_literal] = STATE(11247),
    [sym_command_literal] = STATE(11247),
    [sym_prefixed_string_literal] = STATE(11247),
    [sym_prefixed_command_literal] = STATE(11247),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(10992),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(10994),
    [sym__type_order_operator] = ACTIONS(10994),
    [sym__unary_operator] = ACTIONS(3406),
    [sym__unary_plus_operator] = ACTIONS(3406),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3876] = {
    [sym__expression] = STATE(14163),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3877] = {
    [sym__expression] = STATE(14146),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3878] = {
    [sym__expression] = STATE(14150),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3879] = {
    [sym__expression] = STATE(14160),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3880] = {
    [sym__expression] = STATE(14165),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3881] = {
    [sym__expression] = STATE(13935),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3882] = {
    [sym__expression] = STATE(13197),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11343),
    [sym__array] = STATE(11343),
    [sym_comprehension_expression] = STATE(11343),
    [sym_matrix_expression] = STATE(11343),
    [sym_vector_expression] = STATE(11343),
    [sym_parenthesized_expression] = STATE(11343),
    [sym_tuple_expression] = STATE(11343),
    [sym_curly_expression] = STATE(11343),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11343),
    [sym_index_expression] = STATE(11343),
    [sym_parametrized_type_expression] = STATE(11343),
    [sym_call_expression] = STATE(11343),
    [sym_broadcast_call_expression] = STATE(11343),
    [sym__closed_macrocall_expression] = STATE(11343),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18189),
    [sym_interpolation_expression] = STATE(11343),
    [sym_quote_expression] = STATE(11343),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13066),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10450),
    [sym_boolean_literal] = STATE(11343),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11343),
    [sym_string_literal] = STATE(11343),
    [sym_command_literal] = STATE(11343),
    [sym_prefixed_string_literal] = STATE(11343),
    [sym_prefixed_command_literal] = STATE(11343),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3336),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3166),
    [sym__type_order_operator] = ACTIONS(3166),
    [sym__unary_operator] = ACTIONS(3168),
    [sym__unary_plus_operator] = ACTIONS(3168),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3883] = {
    [sym__expression] = STATE(13937),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3884] = {
    [sym__expression] = STATE(13939),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3885] = {
    [sym__expression] = STATE(8349),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3886] = {
    [sym__expression] = STATE(13941),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3887] = {
    [sym__expression] = STATE(13942),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3888] = {
    [sym__expression] = STATE(13945),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3889] = {
    [sym__expression] = STATE(13946),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3890] = {
    [sym__expression] = STATE(13947),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3891] = {
    [sym__expression] = STATE(13948),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3892] = {
    [sym__expression] = STATE(8350),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3893] = {
    [sym__expression] = STATE(8351),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3894] = {
    [sym__expression] = STATE(13950),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3895] = {
    [sym__expression] = STATE(8353),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3896] = {
    [sym__expression] = STATE(13952),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3897] = {
    [sym__expression] = STATE(13953),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3898] = {
    [sym__expression] = STATE(13955),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3899] = {
    [sym__expression] = STATE(8354),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3900] = {
    [sym__expression] = STATE(13957),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3901] = {
    [sym__expression] = STATE(8355),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3902] = {
    [sym__expression] = STATE(12467),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3903] = {
    [sym__expression] = STATE(14094),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11650),
    [sym__array] = STATE(11650),
    [sym_comprehension_expression] = STATE(11650),
    [sym_matrix_expression] = STATE(11650),
    [sym_vector_expression] = STATE(11650),
    [sym_parenthesized_expression] = STATE(11650),
    [sym_tuple_expression] = STATE(11650),
    [sym_curly_expression] = STATE(11650),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11650),
    [sym_index_expression] = STATE(11650),
    [sym_parametrized_type_expression] = STATE(11650),
    [sym_call_expression] = STATE(11650),
    [sym_broadcast_call_expression] = STATE(11650),
    [sym__closed_macrocall_expression] = STATE(11650),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18711),
    [sym_interpolation_expression] = STATE(11650),
    [sym_quote_expression] = STATE(11650),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13807),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(185),
    [sym_identifier] = STATE(10976),
    [sym_boolean_literal] = STATE(11650),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11650),
    [sym_string_literal] = STATE(11650),
    [sym_command_literal] = STATE(11650),
    [sym_prefixed_string_literal] = STATE(11650),
    [sym_prefixed_command_literal] = STATE(11650),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4106),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_local] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4124),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4126),
    [sym__type_order_operator] = ACTIONS(4126),
    [sym__unary_operator] = ACTIONS(4128),
    [sym__unary_plus_operator] = ACTIONS(4128),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3904] = {
    [sym__expression] = STATE(14167),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3905] = {
    [sym__expression] = STATE(8356),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3906] = {
    [sym__expression] = STATE(8357),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3907] = {
    [sym__expression] = STATE(8358),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3908] = {
    [sym__expression] = STATE(8360),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3909] = {
    [sym__expression] = STATE(14173),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3910] = {
    [sym__expression] = STATE(14143),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3911] = {
    [sym__expression] = STATE(14158),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3912] = {
    [sym__expression] = STATE(8361),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3913] = {
    [sym__expression] = STATE(14157),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3914] = {
    [sym__expression] = STATE(14145),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3915] = {
    [sym__expression] = STATE(8362),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3916] = {
    [sym__expression] = STATE(14153),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3917] = {
    [sym__expression] = STATE(14154),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3918] = {
    [sym__expression] = STATE(14171),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3919] = {
    [sym__expression] = STATE(13985),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3920] = {
    [sym__expression] = STATE(13790),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3921] = {
    [sym__expression] = STATE(13986),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3922] = {
    [sym__expression] = STATE(8363),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3923] = {
    [sym__expression] = STATE(8364),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3924] = {
    [sym__expression] = STATE(13989),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3925] = {
    [sym__expression] = STATE(8394),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(5418),
    [sym__array] = STATE(5418),
    [sym_comprehension_expression] = STATE(5418),
    [sym_matrix_expression] = STATE(5418),
    [sym_vector_expression] = STATE(5418),
    [sym_parenthesized_expression] = STATE(5418),
    [sym_tuple_expression] = STATE(5418),
    [sym_curly_expression] = STATE(5418),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(5418),
    [sym_index_expression] = STATE(5418),
    [sym_parametrized_type_expression] = STATE(5418),
    [sym_call_expression] = STATE(5418),
    [sym_broadcast_call_expression] = STATE(5418),
    [sym__closed_macrocall_expression] = STATE(5418),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(5418),
    [sym_quote_expression] = STATE(5418),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(7698),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(29),
    [sym_identifier] = STATE(4329),
    [sym_boolean_literal] = STATE(5418),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(5418),
    [sym_string_literal] = STATE(5418),
    [sym_command_literal] = STATE(5418),
    [sym_prefixed_string_literal] = STATE(5418),
    [sym_prefixed_command_literal] = STATE(5418),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_const] = ACTIONS(649),
    [anon_sym_global] = ACTIONS(651),
    [anon_sym_local] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11054),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(8736),
    [sym__type_order_operator] = ACTIONS(8736),
    [sym__unary_operator] = ACTIONS(683),
    [sym__unary_plus_operator] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3926] = {
    [sym__expression] = STATE(13990),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3927] = {
    [sym__expression] = STATE(12467),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3928] = {
    [sym__expression] = STATE(14151),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(12166),
    [sym__array] = STATE(12166),
    [sym_comprehension_expression] = STATE(12166),
    [sym_matrix_expression] = STATE(12166),
    [sym_vector_expression] = STATE(12166),
    [sym_parenthesized_expression] = STATE(12166),
    [sym_tuple_expression] = STATE(12166),
    [sym_curly_expression] = STATE(12166),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(12166),
    [sym_index_expression] = STATE(12166),
    [sym_parametrized_type_expression] = STATE(12166),
    [sym_call_expression] = STATE(12166),
    [sym_broadcast_call_expression] = STATE(12166),
    [sym__closed_macrocall_expression] = STATE(12166),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19794),
    [sym_interpolation_expression] = STATE(12166),
    [sym_quote_expression] = STATE(12166),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14045),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(11424),
    [sym_boolean_literal] = STATE(12166),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(12166),
    [sym_string_literal] = STATE(12166),
    [sym_command_literal] = STATE(12166),
    [sym_prefixed_string_literal] = STATE(12166),
    [sym_prefixed_command_literal] = STATE(12166),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4130),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3929] = {
    [sym__expression] = STATE(9016),
    [sym_module_definition] = STATE(8176),
    [sym_abstract_definition] = STATE(8176),
    [sym_primitive_definition] = STATE(8176),
    [sym_struct_definition] = STATE(8176),
    [sym_function_definition] = STATE(8176),
    [sym_macro_definition] = STATE(8176),
    [sym_compound_statement] = STATE(8176),
    [sym_quote_statement] = STATE(8176),
    [sym_let_statement] = STATE(8176),
    [sym_if_statement] = STATE(8176),
    [sym_try_statement] = STATE(8176),
    [sym_for_statement] = STATE(8176),
    [sym_while_statement] = STATE(8176),
    [sym_return_statement] = STATE(8176),
    [sym_const_statement] = STATE(8176),
    [sym_global_statement] = STATE(8176),
    [sym_local_statement] = STATE(8176),
    [sym_export_statement] = STATE(8176),
    [sym_import_statement] = STATE(8176),
    [sym__primary_expression] = STATE(6370),
    [sym__array] = STATE(6370),
    [sym_comprehension_expression] = STATE(6370),
    [sym_matrix_expression] = STATE(6370),
    [sym_vector_expression] = STATE(6370),
    [sym_parenthesized_expression] = STATE(6370),
    [sym_tuple_expression] = STATE(6370),
    [sym_curly_expression] = STATE(6370),
    [sym_adjoint_expression] = STATE(4248),
    [sym_field_expression] = STATE(6370),
    [sym_index_expression] = STATE(6370),
    [sym_parametrized_type_expression] = STATE(6370),
    [sym_call_expression] = STATE(6370),
    [sym_broadcast_call_expression] = STATE(6370),
    [sym__closed_macrocall_expression] = STATE(6370),
    [sym_macrocall_expression] = STATE(8176),
    [sym_argument_list] = STATE(18992),
    [sym_interpolation_expression] = STATE(6370),
    [sym_quote_expression] = STATE(6370),
    [sym_binary_expression] = STATE(8176),
    [sym_unary_expression] = STATE(8176),
    [sym_range_expression] = STATE(8176),
    [sym_splat_expression] = STATE(8176),
    [sym_ternary_expression] = STATE(8176),
    [sym_typed_expression] = STATE(8675),
    [sym_unary_typed_expression] = STATE(8176),
    [sym_function_expression] = STATE(8176),
    [sym_juxtaposition_expression] = STATE(8176),
    [sym_compound_assignment_expression] = STATE(8176),
    [sym_where_expression] = STATE(8176),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4330),
    [sym_boolean_literal] = STATE(6370),
    [sym_integer_literal] = STATE(4256),
    [sym_float_literal] = STATE(4256),
    [sym__string] = STATE(6370),
    [sym_string_literal] = STATE(6370),
    [sym_command_literal] = STATE(6370),
    [sym_prefixed_string_literal] = STATE(6370),
    [sym_prefixed_command_literal] = STATE(6370),
    [sym_operator] = STATE(7314),
    [sym__word_identifier] = ACTIONS(613),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_begin] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_baremodule] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(621),
    [anon_sym_primitive] = ACTIONS(623),
    [anon_sym_mutable] = ACTIONS(625),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(629),
    [anon_sym_macro] = ACTIONS(631),
    [anon_sym_quote] = ACTIONS(633),
    [anon_sym_let] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(643),
    [sym_break_statement] = ACTIONS(645),
    [sym_continue_statement] = ACTIONS(645),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1101),
    [anon_sym_local] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(657),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_using] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(8720),
    [anon_sym_LBRACE] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [anon_sym_COLON_COLON] = ACTIONS(8726),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [aux_sym_integer_literal_token1] = ACTIONS(8728),
    [aux_sym_integer_literal_token2] = ACTIONS(8728),
    [aux_sym_integer_literal_token3] = ACTIONS(673),
    [aux_sym_integer_literal_token4] = ACTIONS(675),
    [aux_sym_float_literal_token1] = ACTIONS(8730),
    [aux_sym_float_literal_token3] = ACTIONS(8730),
    [aux_sym_float_literal_token4] = ACTIONS(8730),
    [sym_character_literal] = ACTIONS(11050),
    [sym__pair_operator] = ACTIONS(8734),
    [sym__arrow_operator] = ACTIONS(681),
    [sym__comparison_operator] = ACTIONS(681),
    [sym__pipe_right_operator] = ACTIONS(8734),
    [sym__pipe_left_operator] = ACTIONS(8734),
    [sym__ellipsis_operator] = ACTIONS(8734),
    [sym__plus_operator] = ACTIONS(681),
    [sym__times_operator] = ACTIONS(681),
    [sym__rational_operator] = ACTIONS(8734),
    [sym__bitshift_operator] = ACTIONS(8734),
    [sym__power_operator] = ACTIONS(8734),
    [sym__tilde_operator] = ACTIONS(11052),
    [sym__type_order_operator] = ACTIONS(11052),
    [sym__unary_operator] = ACTIONS(3228),
    [sym__unary_plus_operator] = ACTIONS(3228),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [3930] = {
    [sym__expression] = STATE(13673),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3931] = {
    [sym__expression] = STATE(7332),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3932] = {
    [sym__expression] = STATE(8029),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3933] = {
    [sym__expression] = STATE(7333),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3934] = {
    [sym__expression] = STATE(7336),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3935] = {
    [sym__expression] = STATE(7337),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3936] = {
    [sym__expression] = STATE(7340),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(4998),
    [sym__array] = STATE(4998),
    [sym_comprehension_expression] = STATE(4998),
    [sym_matrix_expression] = STATE(4998),
    [sym_vector_expression] = STATE(4998),
    [sym_parenthesized_expression] = STATE(4998),
    [sym_tuple_expression] = STATE(4998),
    [sym_curly_expression] = STATE(4998),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(4998),
    [sym_index_expression] = STATE(4998),
    [sym_parametrized_type_expression] = STATE(4998),
    [sym_call_expression] = STATE(4998),
    [sym_broadcast_call_expression] = STATE(4998),
    [sym__closed_macrocall_expression] = STATE(4998),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19711),
    [sym_interpolation_expression] = STATE(4998),
    [sym_quote_expression] = STATE(4998),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(6873),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4275),
    [sym_boolean_literal] = STATE(4998),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(4998),
    [sym_string_literal] = STATE(4998),
    [sym_command_literal] = STATE(4998),
    [sym_prefixed_string_literal] = STATE(4998),
    [sym_prefixed_command_literal] = STATE(4998),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(355),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_global] = ACTIONS(359),
    [anon_sym_local] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11026),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(8662),
    [sym__type_order_operator] = ACTIONS(8662),
    [sym__unary_operator] = ACTIONS(391),
    [sym__unary_plus_operator] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3937] = {
    [sym__expression] = STATE(13228),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3938] = {
    [sym__expression] = STATE(8843),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3939] = {
    [sym__expression] = STATE(8849),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3940] = {
    [sym__expression] = STATE(13289),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3941] = {
    [sym__expression] = STATE(8872),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3942] = {
    [sym__expression] = STATE(12955),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3943] = {
    [sym__expression] = STATE(13293),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3944] = {
    [sym__expression] = STATE(13435),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3945] = {
    [sym__expression] = STATE(13398),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3946] = {
    [sym__expression] = STATE(13178),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3947] = {
    [sym__expression] = STATE(78),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3948] = {
    [sym__expression] = STATE(13188),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3949] = {
    [sym__expression] = STATE(295),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3950] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11612),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11612),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13829),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11289),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3951] = {
    [sym__expression] = STATE(13189),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3952] = {
    [sym__expression] = STATE(13156),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3953] = {
    [sym__expression] = STATE(14144),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11920),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11920),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(14138),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11409),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3954] = {
    [sym__expression] = STATE(13009),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [3955] = {
    [sym__expression] = STATE(13382),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3956] = {
    [sym__expression] = STATE(13383),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3957] = {
    [sym__expression] = STATE(13384),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3958] = {
    [sym__expression] = STATE(13385),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3959] = {
    [sym__expression] = STATE(13386),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3960] = {
    [sym__expression] = STATE(13387),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3961] = {
    [sym__expression] = STATE(13388),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3962] = {
    [sym__expression] = STATE(13389),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3963] = {
    [sym__expression] = STATE(13390),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3964] = {
    [sym__expression] = STATE(13391),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3965] = {
    [sym__expression] = STATE(13392),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3966] = {
    [sym__expression] = STATE(13393),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3967] = {
    [sym__expression] = STATE(13394),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3968] = {
    [sym__expression] = STATE(13395),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3969] = {
    [sym__expression] = STATE(12467),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3970] = {
    [sym__expression] = STATE(13520),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3971] = {
    [sym__expression] = STATE(12956),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3972] = {
    [sym__expression] = STATE(8601),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3973] = {
    [sym__expression] = STATE(8735),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3974] = {
    [sym__expression] = STATE(8603),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3975] = {
    [sym__expression] = STATE(13186),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3976] = {
    [sym__expression] = STATE(13187),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3977] = {
    [sym__expression] = STATE(8606),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3978] = {
    [sym__expression] = STATE(8607),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3979] = {
    [sym__expression] = STATE(13190),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3980] = {
    [sym__expression] = STATE(13191),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3981] = {
    [sym__expression] = STATE(13399),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3982] = {
    [sym__expression] = STATE(13400),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3983] = {
    [sym__expression] = STATE(13401),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3984] = {
    [sym__expression] = STATE(13402),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3985] = {
    [sym__expression] = STATE(13403),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3986] = {
    [sym__expression] = STATE(13085),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11207),
    [sym__array] = STATE(11207),
    [sym_comprehension_expression] = STATE(11207),
    [sym_matrix_expression] = STATE(11207),
    [sym_vector_expression] = STATE(11207),
    [sym_parenthesized_expression] = STATE(11207),
    [sym_tuple_expression] = STATE(11207),
    [sym_curly_expression] = STATE(11207),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(11207),
    [sym_index_expression] = STATE(11207),
    [sym_parametrized_type_expression] = STATE(11207),
    [sym_call_expression] = STATE(11207),
    [sym_broadcast_call_expression] = STATE(11207),
    [sym__closed_macrocall_expression] = STATE(11207),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19408),
    [sym_interpolation_expression] = STATE(11207),
    [sym_quote_expression] = STATE(11207),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12909),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(10216),
    [sym_boolean_literal] = STATE(11207),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(11207),
    [sym_string_literal] = STATE(11207),
    [sym_command_literal] = STATE(11207),
    [sym_prefixed_string_literal] = STATE(11207),
    [sym_prefixed_command_literal] = STATE(11207),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_global] = ACTIONS(2959),
    [anon_sym_local] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11098),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11100),
    [sym__type_order_operator] = ACTIONS(11100),
    [sym__unary_operator] = ACTIONS(3126),
    [sym__unary_plus_operator] = ACTIONS(3126),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [3987] = {
    [sym__expression] = STATE(8614),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [3988] = {
    [sym__expression] = STATE(13514),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3989] = {
    [sym__expression] = STATE(13526),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3990] = {
    [sym__expression] = STATE(13535),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3991] = {
    [sym__expression] = STATE(13537),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3992] = {
    [sym__expression] = STATE(13564),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3993] = {
    [sym__expression] = STATE(13565),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3994] = {
    [sym__expression] = STATE(13566),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3995] = {
    [sym__expression] = STATE(13567),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3996] = {
    [sym__expression] = STATE(13568),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3997] = {
    [sym__expression] = STATE(13335),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [3998] = {
    [sym__expression] = STATE(9151),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [3999] = {
    [sym__expression] = STATE(9208),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4000] = {
    [sym__expression] = STATE(9153),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4001] = {
    [sym__expression] = STATE(9214),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4002] = {
    [sym__expression] = STATE(9215),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4003] = {
    [sym__expression] = STATE(9156),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4004] = {
    [sym__expression] = STATE(9157),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4005] = {
    [sym__expression] = STATE(9218),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4006] = {
    [sym__expression] = STATE(9219),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4007] = {
    [sym__expression] = STATE(9220),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4008] = {
    [sym__expression] = STATE(9221),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4009] = {
    [sym__expression] = STATE(9222),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4010] = {
    [sym__expression] = STATE(9223),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4011] = {
    [sym__expression] = STATE(9224),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4012] = {
    [sym__expression] = STATE(7794),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4013] = {
    [sym__expression] = STATE(9164),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4014] = {
    [sym__expression] = STATE(13555),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4015] = {
    [sym__expression] = STATE(13439),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4016] = {
    [sym__expression] = STATE(13557),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4017] = {
    [sym__expression] = STATE(13560),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4018] = {
    [sym__expression] = STATE(13561),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4019] = {
    [sym__expression] = STATE(13670),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4020] = {
    [sym__expression] = STATE(9203),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4021] = {
    [sym__expression] = STATE(9205),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4022] = {
    [sym__expression] = STATE(9206),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4023] = {
    [sym__expression] = STATE(9228),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [4024] = {
    [sym__expression] = STATE(9229),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [4025] = {
    [sym__expression] = STATE(9216),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4026] = {
    [sym__expression] = STATE(9217),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4027] = {
    [sym__expression] = STATE(9162),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [4028] = {
    [sym__expression] = STATE(9168),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [4029] = {
    [sym__expression] = STATE(9233),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [4030] = {
    [sym__expression] = STATE(9234),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [4031] = {
    [sym__expression] = STATE(9235),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [4032] = {
    [sym__expression] = STATE(9236),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [4033] = {
    [sym__expression] = STATE(9238),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [4034] = {
    [sym__expression] = STATE(8595),
    [sym_module_definition] = STATE(8481),
    [sym_abstract_definition] = STATE(8481),
    [sym_primitive_definition] = STATE(8481),
    [sym_struct_definition] = STATE(8481),
    [sym_function_definition] = STATE(8481),
    [sym_macro_definition] = STATE(8481),
    [sym_compound_statement] = STATE(8481),
    [sym_quote_statement] = STATE(8481),
    [sym_let_statement] = STATE(8481),
    [sym_if_statement] = STATE(8481),
    [sym_try_statement] = STATE(8481),
    [sym_for_statement] = STATE(8481),
    [sym_while_statement] = STATE(8481),
    [sym_return_statement] = STATE(8481),
    [sym_const_statement] = STATE(8481),
    [sym_global_statement] = STATE(8481),
    [sym_local_statement] = STATE(8481),
    [sym_export_statement] = STATE(8481),
    [sym_import_statement] = STATE(8481),
    [sym__primary_expression] = STATE(6588),
    [sym__array] = STATE(6588),
    [sym_comprehension_expression] = STATE(6588),
    [sym_matrix_expression] = STATE(6588),
    [sym_vector_expression] = STATE(6588),
    [sym_parenthesized_expression] = STATE(6588),
    [sym_tuple_expression] = STATE(6588),
    [sym_curly_expression] = STATE(6588),
    [sym_adjoint_expression] = STATE(4247),
    [sym_field_expression] = STATE(6588),
    [sym_index_expression] = STATE(6588),
    [sym_parametrized_type_expression] = STATE(6588),
    [sym_call_expression] = STATE(6588),
    [sym_broadcast_call_expression] = STATE(6588),
    [sym__closed_macrocall_expression] = STATE(6588),
    [sym_macrocall_expression] = STATE(8481),
    [sym_argument_list] = STATE(18261),
    [sym_interpolation_expression] = STATE(6588),
    [sym_quote_expression] = STATE(6588),
    [sym_binary_expression] = STATE(8481),
    [sym_unary_expression] = STATE(8481),
    [sym_range_expression] = STATE(8481),
    [sym_splat_expression] = STATE(8481),
    [sym_ternary_expression] = STATE(8481),
    [sym_typed_expression] = STATE(9037),
    [sym_unary_typed_expression] = STATE(8481),
    [sym_function_expression] = STATE(8481),
    [sym_juxtaposition_expression] = STATE(8481),
    [sym_compound_assignment_expression] = STATE(8481),
    [sym_where_expression] = STATE(8481),
    [sym_macro_identifier] = STATE(71),
    [sym_identifier] = STATE(4368),
    [sym_boolean_literal] = STATE(6588),
    [sym_integer_literal] = STATE(4257),
    [sym_float_literal] = STATE(4257),
    [sym__string] = STATE(6588),
    [sym_string_literal] = STATE(6588),
    [sym_command_literal] = STATE(6588),
    [sym_prefixed_string_literal] = STATE(6588),
    [sym_prefixed_command_literal] = STATE(6588),
    [sym_operator] = STATE(7951),
    [sym__word_identifier] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(817),
    [anon_sym_begin] = ACTIONS(819),
    [anon_sym_module] = ACTIONS(821),
    [anon_sym_baremodule] = ACTIONS(821),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_primitive] = ACTIONS(825),
    [anon_sym_mutable] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_macro] = ACTIONS(833),
    [anon_sym_quote] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(841),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(845),
    [sym_break_statement] = ACTIONS(847),
    [sym_continue_statement] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_global] = ACTIONS(1167),
    [anon_sym_local] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_export] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(867),
    [anon_sym_COLON_COLON] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(873),
    [anon_sym_false] = ACTIONS(873),
    [aux_sym_integer_literal_token1] = ACTIONS(875),
    [aux_sym_integer_literal_token2] = ACTIONS(875),
    [aux_sym_integer_literal_token3] = ACTIONS(877),
    [aux_sym_integer_literal_token4] = ACTIONS(879),
    [aux_sym_float_literal_token1] = ACTIONS(881),
    [aux_sym_float_literal_token3] = ACTIONS(881),
    [aux_sym_float_literal_token4] = ACTIONS(881),
    [sym_character_literal] = ACTIONS(3330),
    [sym__pair_operator] = ACTIONS(885),
    [sym__arrow_operator] = ACTIONS(887),
    [sym__comparison_operator] = ACTIONS(887),
    [sym__pipe_right_operator] = ACTIONS(885),
    [sym__pipe_left_operator] = ACTIONS(885),
    [sym__ellipsis_operator] = ACTIONS(885),
    [sym__plus_operator] = ACTIONS(887),
    [sym__times_operator] = ACTIONS(887),
    [sym__rational_operator] = ACTIONS(885),
    [sym__bitshift_operator] = ACTIONS(885),
    [sym__power_operator] = ACTIONS(885),
    [sym__tilde_operator] = ACTIONS(3332),
    [sym__type_order_operator] = ACTIONS(3332),
    [sym__unary_operator] = ACTIONS(3334),
    [sym__unary_plus_operator] = ACTIONS(3334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [4035] = {
    [sym__expression] = STATE(9268),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4036] = {
    [sym__expression] = STATE(12920),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4037] = {
    [sym__expression] = STATE(13101),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4038] = {
    [sym__expression] = STATE(13102),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4039] = {
    [sym__expression] = STATE(13103),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4040] = {
    [sym__expression] = STATE(13105),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4041] = {
    [sym__expression] = STATE(13106),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4042] = {
    [sym__expression] = STATE(13108),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4043] = {
    [sym__expression] = STATE(13109),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4044] = {
    [sym__expression] = STATE(13110),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4045] = {
    [sym__expression] = STATE(13114),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4046] = {
    [sym__expression] = STATE(13115),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4047] = {
    [sym__expression] = STATE(13116),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4048] = {
    [sym__expression] = STATE(13117),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4049] = {
    [sym__expression] = STATE(13119),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4050] = {
    [sym__expression] = STATE(13120),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4051] = {
    [sym__expression] = STATE(12285),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4052] = {
    [sym__expression] = STATE(13123),
    [sym_module_definition] = STATE(12781),
    [sym_abstract_definition] = STATE(12781),
    [sym_primitive_definition] = STATE(12781),
    [sym_struct_definition] = STATE(12781),
    [sym_function_definition] = STATE(12781),
    [sym_macro_definition] = STATE(12781),
    [sym_compound_statement] = STATE(12781),
    [sym_quote_statement] = STATE(12781),
    [sym_let_statement] = STATE(12781),
    [sym_if_statement] = STATE(12781),
    [sym_try_statement] = STATE(12781),
    [sym_for_statement] = STATE(12781),
    [sym_while_statement] = STATE(12781),
    [sym_return_statement] = STATE(12781),
    [sym_const_statement] = STATE(12781),
    [sym_global_statement] = STATE(12781),
    [sym_local_statement] = STATE(12781),
    [sym_export_statement] = STATE(12781),
    [sym_import_statement] = STATE(12781),
    [sym__primary_expression] = STATE(11173),
    [sym__array] = STATE(11173),
    [sym_comprehension_expression] = STATE(11173),
    [sym_matrix_expression] = STATE(11173),
    [sym_vector_expression] = STATE(11173),
    [sym_parenthesized_expression] = STATE(11173),
    [sym_tuple_expression] = STATE(11173),
    [sym_curly_expression] = STATE(11173),
    [sym_adjoint_expression] = STATE(6975),
    [sym_field_expression] = STATE(11173),
    [sym_index_expression] = STATE(11173),
    [sym_parametrized_type_expression] = STATE(11173),
    [sym_call_expression] = STATE(11173),
    [sym_broadcast_call_expression] = STATE(11173),
    [sym__closed_macrocall_expression] = STATE(11173),
    [sym_macrocall_expression] = STATE(12781),
    [sym_argument_list] = STATE(18927),
    [sym_interpolation_expression] = STATE(11173),
    [sym_quote_expression] = STATE(11173),
    [sym_binary_expression] = STATE(12781),
    [sym_unary_expression] = STATE(12781),
    [sym_range_expression] = STATE(12781),
    [sym_splat_expression] = STATE(12781),
    [sym_ternary_expression] = STATE(12781),
    [sym_typed_expression] = STATE(12706),
    [sym_unary_typed_expression] = STATE(12781),
    [sym_function_expression] = STATE(12781),
    [sym_juxtaposition_expression] = STATE(12781),
    [sym_compound_assignment_expression] = STATE(12781),
    [sym_where_expression] = STATE(12781),
    [sym_macro_identifier] = STATE(73),
    [sym_identifier] = STATE(10191),
    [sym_boolean_literal] = STATE(11173),
    [sym_integer_literal] = STATE(9310),
    [sym_float_literal] = STATE(9310),
    [sym__string] = STATE(11173),
    [sym_string_literal] = STATE(11173),
    [sym_command_literal] = STATE(11173),
    [sym_prefixed_string_literal] = STATE(11173),
    [sym_prefixed_command_literal] = STATE(11173),
    [sym_operator] = STATE(11872),
    [sym__word_identifier] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2724),
    [anon_sym_begin] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_baremodule] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_primitive] = ACTIONS(2732),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2740),
    [anon_sym_quote] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2752),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(3180),
    [anon_sym_const] = ACTIONS(3182),
    [anon_sym_global] = ACTIONS(3184),
    [anon_sym_local] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(8558),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_using] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(8560),
    [anon_sym_LBRACE] = ACTIONS(8562),
    [anon_sym_DOLLAR] = ACTIONS(8564),
    [anon_sym_COLON_COLON] = ACTIONS(8566),
    [anon_sym_AT] = ACTIONS(8546),
    [anon_sym_true] = ACTIONS(2778),
    [anon_sym_false] = ACTIONS(2778),
    [aux_sym_integer_literal_token1] = ACTIONS(8548),
    [aux_sym_integer_literal_token2] = ACTIONS(8548),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(8550),
    [aux_sym_float_literal_token3] = ACTIONS(8550),
    [aux_sym_float_literal_token4] = ACTIONS(8550),
    [sym_character_literal] = ACTIONS(11082),
    [sym__pair_operator] = ACTIONS(8570),
    [sym__arrow_operator] = ACTIONS(2782),
    [sym__comparison_operator] = ACTIONS(2782),
    [sym__pipe_right_operator] = ACTIONS(8570),
    [sym__pipe_left_operator] = ACTIONS(8570),
    [sym__ellipsis_operator] = ACTIONS(8570),
    [sym__plus_operator] = ACTIONS(2782),
    [sym__times_operator] = ACTIONS(2782),
    [sym__rational_operator] = ACTIONS(8570),
    [sym__bitshift_operator] = ACTIONS(8570),
    [sym__power_operator] = ACTIONS(8570),
    [sym__tilde_operator] = ACTIONS(11084),
    [sym__type_order_operator] = ACTIONS(11084),
    [sym__unary_operator] = ACTIONS(3360),
    [sym__unary_plus_operator] = ACTIONS(3360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2786),
    [sym__command_start] = ACTIONS(2788),
  },
  [4053] = {
    [sym__expression] = STATE(13125),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4054] = {
    [sym__expression] = STATE(13126),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4055] = {
    [sym__expression] = STATE(13127),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4056] = {
    [sym__expression] = STATE(13128),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4057] = {
    [sym__expression] = STATE(13129),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4058] = {
    [sym__expression] = STATE(13130),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4059] = {
    [sym__expression] = STATE(13136),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4060] = {
    [sym__expression] = STATE(13137),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4061] = {
    [sym__expression] = STATE(13138),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4062] = {
    [sym__expression] = STATE(13139),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4063] = {
    [sym__expression] = STATE(13142),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4064] = {
    [sym__expression] = STATE(13143),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4065] = {
    [sym__expression] = STATE(13144),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4066] = {
    [sym__expression] = STATE(13146),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4067] = {
    [sym__expression] = STATE(12874),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4068] = {
    [sym__expression] = STATE(13151),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11154),
    [sym__array] = STATE(11154),
    [sym_comprehension_expression] = STATE(11154),
    [sym_matrix_expression] = STATE(11154),
    [sym_vector_expression] = STATE(11154),
    [sym_parenthesized_expression] = STATE(11154),
    [sym_tuple_expression] = STATE(11154),
    [sym_curly_expression] = STATE(11154),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11154),
    [sym_index_expression] = STATE(11154),
    [sym_parametrized_type_expression] = STATE(11154),
    [sym_call_expression] = STATE(11154),
    [sym_broadcast_call_expression] = STATE(11154),
    [sym__closed_macrocall_expression] = STATE(11154),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18581),
    [sym_interpolation_expression] = STATE(11154),
    [sym_quote_expression] = STATE(11154),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12671),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(11154),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11154),
    [sym_string_literal] = STATE(11154),
    [sym_command_literal] = STATE(11154),
    [sym_prefixed_string_literal] = STATE(11154),
    [sym_prefixed_command_literal] = STATE(11154),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11072),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11074),
    [sym__type_order_operator] = ACTIONS(11074),
    [sym__unary_operator] = ACTIONS(3372),
    [sym__unary_plus_operator] = ACTIONS(3372),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4069] = {
    [sym__expression] = STATE(8882),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4070] = {
    [sym__expression] = STATE(13220),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11286),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11286),
    [sym_matrix_expression] = STATE(11286),
    [sym_vector_expression] = STATE(11286),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18813),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13051),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10457),
    [sym_boolean_literal] = STATE(11286),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11286),
    [sym_string_literal] = STATE(11286),
    [sym_command_literal] = STATE(11286),
    [sym_prefixed_string_literal] = STATE(11286),
    [sym_prefixed_command_literal] = STATE(11286),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2894),
    [anon_sym_local] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3288),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(2928),
    [sym__type_order_operator] = ACTIONS(2928),
    [sym__unary_operator] = ACTIONS(2930),
    [sym__unary_plus_operator] = ACTIONS(2930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4071] = {
    [sym__expression] = STATE(9154),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4072] = {
    [sym__expression] = STATE(9155),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4073] = {
    [sym__expression] = STATE(9158),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4074] = {
    [sym__expression] = STATE(9159),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4075] = {
    [sym__expression] = STATE(9209),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4076] = {
    [sym__expression] = STATE(9210),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4077] = {
    [sym__expression] = STATE(9211),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4078] = {
    [sym__expression] = STATE(9212),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4079] = {
    [sym__expression] = STATE(9213),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4080] = {
    [sym__expression] = STATE(8919),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6631),
    [sym__array] = STATE(6631),
    [sym_comprehension_expression] = STATE(6631),
    [sym_matrix_expression] = STATE(6631),
    [sym_vector_expression] = STATE(6631),
    [sym_parenthesized_expression] = STATE(6631),
    [sym_tuple_expression] = STATE(6631),
    [sym_curly_expression] = STATE(6631),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6631),
    [sym_index_expression] = STATE(6631),
    [sym_parametrized_type_expression] = STATE(6631),
    [sym_call_expression] = STATE(6631),
    [sym_broadcast_call_expression] = STATE(6631),
    [sym__closed_macrocall_expression] = STATE(6631),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19458),
    [sym_interpolation_expression] = STATE(6631),
    [sym_quote_expression] = STATE(6631),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9086),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(4526),
    [sym_boolean_literal] = STATE(6631),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6631),
    [sym_string_literal] = STATE(6631),
    [sym_command_literal] = STATE(6631),
    [sym_prefixed_string_literal] = STATE(6631),
    [sym_prefixed_command_literal] = STATE(6631),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11004),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(11006),
    [sym__type_order_operator] = ACTIONS(11006),
    [sym__unary_operator] = ACTIONS(3368),
    [sym__unary_plus_operator] = ACTIONS(3368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4081] = {
    [sym__expression] = STATE(13573),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4082] = {
    [sym__expression] = STATE(8885),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4083] = {
    [sym__expression] = STATE(9275),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4084] = {
    [sym__expression] = STATE(9263),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4085] = {
    [sym__expression] = STATE(9276),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4086] = {
    [sym__expression] = STATE(9282),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4087] = {
    [sym__expression] = STATE(9291),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4088] = {
    [sym__expression] = STATE(9170),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6554),
    [sym__array] = STATE(6554),
    [sym_comprehension_expression] = STATE(6554),
    [sym_matrix_expression] = STATE(6554),
    [sym_vector_expression] = STATE(6554),
    [sym_parenthesized_expression] = STATE(6554),
    [sym_tuple_expression] = STATE(6554),
    [sym_curly_expression] = STATE(6554),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6554),
    [sym_index_expression] = STATE(6554),
    [sym_parametrized_type_expression] = STATE(6554),
    [sym_call_expression] = STATE(6554),
    [sym_broadcast_call_expression] = STATE(6554),
    [sym__closed_macrocall_expression] = STATE(6554),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(19107),
    [sym_interpolation_expression] = STATE(6554),
    [sym_quote_expression] = STATE(6554),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9091),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(5097),
    [sym_boolean_literal] = STATE(6554),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6554),
    [sym_string_literal] = STATE(6554),
    [sym_command_literal] = STATE(6554),
    [sym_prefixed_string_literal] = STATE(6554),
    [sym_prefixed_command_literal] = STATE(6554),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11106),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(7030),
    [sym__type_order_operator] = ACTIONS(7030),
    [sym__unary_operator] = ACTIONS(3364),
    [sym__unary_plus_operator] = ACTIONS(3364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4089] = {
    [sym__expression] = STATE(8604),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4090] = {
    [sym__expression] = STATE(8605),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4091] = {
    [sym__expression] = STATE(8608),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4092] = {
    [sym__expression] = STATE(8609),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4093] = {
    [sym__expression] = STATE(8736),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4094] = {
    [sym__expression] = STATE(8737),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4095] = {
    [sym__expression] = STATE(8738),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4096] = {
    [sym__expression] = STATE(8739),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4097] = {
    [sym__expression] = STATE(8740),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4098] = {
    [sym__expression] = STATE(7394),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5961),
    [sym__array] = STATE(5961),
    [sym_comprehension_expression] = STATE(5961),
    [sym_matrix_expression] = STATE(5961),
    [sym_vector_expression] = STATE(5961),
    [sym_parenthesized_expression] = STATE(5961),
    [sym_tuple_expression] = STATE(5961),
    [sym_curly_expression] = STATE(5961),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5961),
    [sym_index_expression] = STATE(5961),
    [sym_parametrized_type_expression] = STATE(5961),
    [sym_call_expression] = STATE(5961),
    [sym_broadcast_call_expression] = STATE(5961),
    [sym__closed_macrocall_expression] = STATE(5961),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19654),
    [sym_interpolation_expression] = STATE(5961),
    [sym_quote_expression] = STATE(5961),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8074),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4278),
    [sym_boolean_literal] = STATE(5961),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5961),
    [sym_string_literal] = STATE(5961),
    [sym_command_literal] = STATE(5961),
    [sym_prefixed_string_literal] = STATE(5961),
    [sym_prefixed_command_literal] = STATE(5961),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11102),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11104),
    [sym__type_order_operator] = ACTIONS(11104),
    [sym__unary_operator] = ACTIONS(2938),
    [sym__unary_plus_operator] = ACTIONS(2938),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4099] = {
    [sym__expression] = STATE(12914),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4100] = {
    [sym__expression] = STATE(70),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4101] = {
    [sym__expression] = STATE(13328),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11239),
    [sym__array] = STATE(11239),
    [sym_comprehension_expression] = STATE(11239),
    [sym_matrix_expression] = STATE(11239),
    [sym_vector_expression] = STATE(11239),
    [sym_parenthesized_expression] = STATE(11239),
    [sym_tuple_expression] = STATE(11239),
    [sym_curly_expression] = STATE(11239),
    [sym_adjoint_expression] = STATE(7060),
    [sym_field_expression] = STATE(11239),
    [sym_index_expression] = STATE(11239),
    [sym_parametrized_type_expression] = STATE(11239),
    [sym_call_expression] = STATE(11239),
    [sym_broadcast_call_expression] = STATE(11239),
    [sym__closed_macrocall_expression] = STATE(11239),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19125),
    [sym_interpolation_expression] = STATE(11239),
    [sym_quote_expression] = STATE(11239),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(13095),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(87),
    [sym_identifier] = STATE(10350),
    [sym_boolean_literal] = STATE(11239),
    [sym_integer_literal] = STATE(9335),
    [sym_float_literal] = STATE(9335),
    [sym__string] = STATE(11239),
    [sym_string_literal] = STATE(11239),
    [sym_command_literal] = STATE(11239),
    [sym_prefixed_string_literal] = STATE(11239),
    [sym_prefixed_command_literal] = STATE(11239),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3190),
    [anon_sym_const] = ACTIONS(3192),
    [anon_sym_global] = ACTIONS(3194),
    [anon_sym_local] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_using] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(8578),
    [anon_sym_COLON_COLON] = ACTIONS(8580),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11068),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(11070),
    [sym__type_order_operator] = ACTIONS(11070),
    [sym__unary_operator] = ACTIONS(3410),
    [sym__unary_plus_operator] = ACTIONS(3410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4102] = {
    [sym__expression] = STATE(12918),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4103] = {
    [sym__expression] = STATE(259),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4104] = {
    [sym__expression] = STATE(14178),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11920),
    [sym__array] = STATE(11920),
    [sym_comprehension_expression] = STATE(11920),
    [sym_matrix_expression] = STATE(11920),
    [sym_vector_expression] = STATE(11920),
    [sym_parenthesized_expression] = STATE(11920),
    [sym_tuple_expression] = STATE(11790),
    [sym_curly_expression] = STATE(11920),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11920),
    [sym_index_expression] = STATE(11920),
    [sym_parametrized_type_expression] = STATE(11920),
    [sym_call_expression] = STATE(11920),
    [sym_broadcast_call_expression] = STATE(11920),
    [sym__closed_macrocall_expression] = STATE(11920),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19761),
    [sym_interpolation_expression] = STATE(11790),
    [sym_quote_expression] = STATE(11920),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13747),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(11355),
    [sym_boolean_literal] = STATE(11920),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11920),
    [sym_string_literal] = STATE(11920),
    [sym_command_literal] = STATE(11920),
    [sym_prefixed_string_literal] = STATE(11920),
    [sym_prefixed_command_literal] = STATE(11920),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(8594),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(8596),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(8600),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(4136),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(4138),
    [sym__type_order_operator] = ACTIONS(4138),
    [sym__unary_operator] = ACTIONS(4140),
    [sym__unary_plus_operator] = ACTIONS(4140),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4105] = {
    [sym__expression] = STATE(13558),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4106] = {
    [sym__expression] = STATE(13559),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4107] = {
    [sym__expression] = STATE(13562),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4108] = {
    [sym__expression] = STATE(13563),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4109] = {
    [sym__expression] = STATE(13444),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4110] = {
    [sym__expression] = STATE(13446),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4111] = {
    [sym__expression] = STATE(13447),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4112] = {
    [sym__expression] = STATE(13449),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4113] = {
    [sym__expression] = STATE(13450),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11427),
    [sym__array] = STATE(11427),
    [sym_comprehension_expression] = STATE(11427),
    [sym_matrix_expression] = STATE(11427),
    [sym_vector_expression] = STATE(11427),
    [sym_parenthesized_expression] = STATE(11427),
    [sym_tuple_expression] = STATE(11427),
    [sym_curly_expression] = STATE(11427),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11427),
    [sym_index_expression] = STATE(11427),
    [sym_parametrized_type_expression] = STATE(11427),
    [sym_call_expression] = STATE(11427),
    [sym_broadcast_call_expression] = STATE(11427),
    [sym__closed_macrocall_expression] = STATE(11427),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18361),
    [sym_interpolation_expression] = STATE(11427),
    [sym_quote_expression] = STATE(11427),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13244),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(91),
    [sym_identifier] = STATE(10574),
    [sym_boolean_literal] = STATE(11427),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11427),
    [sym_string_literal] = STATE(11427),
    [sym_command_literal] = STATE(11427),
    [sym_prefixed_string_literal] = STATE(11427),
    [sym_prefixed_command_literal] = STATE(11427),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3144),
    [anon_sym_local] = ACTIONS(3146),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3414),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3416),
    [sym__type_order_operator] = ACTIONS(3416),
    [sym__unary_operator] = ACTIONS(3418),
    [sym__unary_plus_operator] = ACTIONS(3418),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4114] = {
    [sym__expression] = STATE(8417),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4115] = {
    [sym__expression] = STATE(8418),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4116] = {
    [sym__expression] = STATE(8421),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4117] = {
    [sym__expression] = STATE(8422),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4118] = {
    [sym__expression] = STATE(8716),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4119] = {
    [sym__expression] = STATE(8717),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4120] = {
    [sym__expression] = STATE(8718),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4121] = {
    [sym__expression] = STATE(8719),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4122] = {
    [sym__expression] = STATE(8720),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4123] = {
    [sym__expression] = STATE(7794),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(5716),
    [sym__array] = STATE(5716),
    [sym_comprehension_expression] = STATE(5716),
    [sym_matrix_expression] = STATE(5716),
    [sym_vector_expression] = STATE(5716),
    [sym_parenthesized_expression] = STATE(5716),
    [sym_tuple_expression] = STATE(5716),
    [sym_curly_expression] = STATE(5716),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(5716),
    [sym_index_expression] = STATE(5716),
    [sym_parametrized_type_expression] = STATE(5716),
    [sym_call_expression] = STATE(5716),
    [sym_broadcast_call_expression] = STATE(5716),
    [sym__closed_macrocall_expression] = STATE(5716),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18410),
    [sym_interpolation_expression] = STATE(5716),
    [sym_quote_expression] = STATE(5716),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(8037),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4270),
    [sym_boolean_literal] = STATE(5716),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(5716),
    [sym_string_literal] = STATE(5716),
    [sym_command_literal] = STATE(5716),
    [sym_prefixed_string_literal] = STATE(5716),
    [sym_prefixed_command_literal] = STATE(5716),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11010),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11012),
    [sym__type_order_operator] = ACTIONS(11012),
    [sym__unary_operator] = ACTIONS(2708),
    [sym__unary_plus_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4124] = {
    [sym__expression] = STATE(102),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4125] = {
    [sym__expression] = STATE(12932),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4126] = {
    [sym__expression] = STATE(277),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4127] = {
    [sym__expression] = STATE(13296),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4128] = {
    [sym__expression] = STATE(13987),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4129] = {
    [sym__expression] = STATE(13988),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4130] = {
    [sym__expression] = STATE(13991),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4131] = {
    [sym__expression] = STATE(13992),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4132] = {
    [sym__expression] = STATE(13791),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4133] = {
    [sym__expression] = STATE(13792),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4134] = {
    [sym__expression] = STATE(13793),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4135] = {
    [sym__expression] = STATE(13794),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4136] = {
    [sym__expression] = STATE(13795),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4137] = {
    [sym__expression] = STATE(13335),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11497),
    [sym__array] = STATE(11497),
    [sym_comprehension_expression] = STATE(11497),
    [sym_matrix_expression] = STATE(11497),
    [sym_vector_expression] = STATE(11497),
    [sym_parenthesized_expression] = STATE(11497),
    [sym_tuple_expression] = STATE(11497),
    [sym_curly_expression] = STATE(11497),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11497),
    [sym_index_expression] = STATE(11497),
    [sym_parametrized_type_expression] = STATE(11497),
    [sym_call_expression] = STATE(11497),
    [sym_broadcast_call_expression] = STATE(11497),
    [sym__closed_macrocall_expression] = STATE(11497),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18690),
    [sym_interpolation_expression] = STATE(11497),
    [sym_quote_expression] = STATE(11497),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13508),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10573),
    [sym_boolean_literal] = STATE(11497),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11497),
    [sym_string_literal] = STATE(11497),
    [sym_command_literal] = STATE(11497),
    [sym_prefixed_string_literal] = STATE(11497),
    [sym_prefixed_command_literal] = STATE(11497),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3530),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3532),
    [sym__type_order_operator] = ACTIONS(3532),
    [sym__unary_operator] = ACTIONS(3534),
    [sym__unary_plus_operator] = ACTIONS(3534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4138] = {
    [sym__expression] = STATE(9277),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4139] = {
    [sym__expression] = STATE(9281),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4140] = {
    [sym__expression] = STATE(9292),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4141] = {
    [sym__expression] = STATE(9293),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4142] = {
    [sym__expression] = STATE(9264),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4143] = {
    [sym__expression] = STATE(9266),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4144] = {
    [sym__expression] = STATE(9267),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4145] = {
    [sym__expression] = STATE(9269),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4146] = {
    [sym__expression] = STATE(9270),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4147] = {
    [sym__expression] = STATE(7794),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(6750),
    [sym__array] = STATE(6750),
    [sym_comprehension_expression] = STATE(6750),
    [sym_matrix_expression] = STATE(6750),
    [sym_vector_expression] = STATE(6750),
    [sym_parenthesized_expression] = STATE(6750),
    [sym_tuple_expression] = STATE(6750),
    [sym_curly_expression] = STATE(6750),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(6750),
    [sym_index_expression] = STATE(6750),
    [sym_parametrized_type_expression] = STATE(6750),
    [sym_call_expression] = STATE(6750),
    [sym_broadcast_call_expression] = STATE(6750),
    [sym__closed_macrocall_expression] = STATE(6750),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18449),
    [sym_interpolation_expression] = STATE(6750),
    [sym_quote_expression] = STATE(6750),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(9184),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(5079),
    [sym_boolean_literal] = STATE(6750),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(6750),
    [sym_string_literal] = STATE(6750),
    [sym_command_literal] = STATE(6750),
    [sym_prefixed_string_literal] = STATE(6750),
    [sym_prefixed_command_literal] = STATE(6750),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(789),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_local] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(3434),
    [sym__unary_plus_operator] = ACTIONS(3434),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4148] = {
    [sym__expression] = STATE(12934),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4149] = {
    [sym__expression] = STATE(88),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4150] = {
    [sym__expression] = STATE(13481),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4151] = {
    [sym__expression] = STATE(13484),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4152] = {
    [sym__expression] = STATE(286),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4153] = {
    [sym__expression] = STATE(13461),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4154] = {
    [sym__expression] = STATE(13500),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4155] = {
    [sym__expression] = STATE(13487),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4156] = {
    [sym__expression] = STATE(13489),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4157] = {
    [sym__expression] = STATE(90),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4158] = {
    [sym__expression] = STATE(13490),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4159] = {
    [sym__expression] = STATE(13501),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4160] = {
    [sym__expression] = STATE(291),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4161] = {
    [sym__expression] = STATE(13491),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4162] = {
    [sym__expression] = STATE(13502),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4163] = {
    [sym__expression] = STATE(13493),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4164] = {
    [sym__expression] = STATE(13494),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4165] = {
    [sym__expression] = STATE(94),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4166] = {
    [sym__expression] = STATE(13495),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4167] = {
    [sym__expression] = STATE(13521),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4168] = {
    [sym__expression] = STATE(294),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4169] = {
    [sym__expression] = STATE(13503),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4170] = {
    [sym__expression] = STATE(13522),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4171] = {
    [sym__expression] = STATE(13509),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4172] = {
    [sym__expression] = STATE(13511),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4173] = {
    [sym__expression] = STATE(95),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4174] = {
    [sym__expression] = STATE(13538),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4175] = {
    [sym__expression] = STATE(13523),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4176] = {
    [sym__expression] = STATE(296),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4177] = {
    [sym__expression] = STATE(13542),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4178] = {
    [sym__expression] = STATE(13437),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4179] = {
    [sym__expression] = STATE(13543),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4180] = {
    [sym__expression] = STATE(13549),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4181] = {
    [sym__expression] = STATE(96),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4182] = {
    [sym__expression] = STATE(12467),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11426),
    [sym__array] = STATE(11426),
    [sym_comprehension_expression] = STATE(11426),
    [sym_matrix_expression] = STATE(11426),
    [sym_vector_expression] = STATE(11426),
    [sym_parenthesized_expression] = STATE(11426),
    [sym_tuple_expression] = STATE(11426),
    [sym_curly_expression] = STATE(11426),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11426),
    [sym_index_expression] = STATE(11426),
    [sym_parametrized_type_expression] = STATE(11426),
    [sym_call_expression] = STATE(11426),
    [sym_broadcast_call_expression] = STATE(11426),
    [sym__closed_macrocall_expression] = STATE(11426),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19762),
    [sym_interpolation_expression] = STATE(11426),
    [sym_quote_expression] = STATE(11426),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13223),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(92),
    [sym_identifier] = STATE(10696),
    [sym_boolean_literal] = STATE(11426),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11426),
    [sym_string_literal] = STATE(11426),
    [sym_command_literal] = STATE(11426),
    [sym_prefixed_string_literal] = STATE(11426),
    [sym_prefixed_command_literal] = STATE(11426),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3039),
    [anon_sym_global] = ACTIONS(3041),
    [anon_sym_local] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3328),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3047),
    [sym__type_order_operator] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3049),
    [sym__unary_plus_operator] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4183] = {
    [sym__expression] = STATE(13602),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4184] = {
    [sym__expression] = STATE(298),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4185] = {
    [sym__expression] = STATE(13821),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11487),
    [sym__array] = STATE(11487),
    [sym_comprehension_expression] = STATE(11487),
    [sym_matrix_expression] = STATE(11487),
    [sym_vector_expression] = STATE(11487),
    [sym_parenthesized_expression] = STATE(11487),
    [sym_tuple_expression] = STATE(11487),
    [sym_curly_expression] = STATE(11487),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11487),
    [sym_index_expression] = STATE(11487),
    [sym_parametrized_type_expression] = STATE(11487),
    [sym_call_expression] = STATE(11487),
    [sym_broadcast_call_expression] = STATE(11487),
    [sym__closed_macrocall_expression] = STATE(11487),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18771),
    [sym_interpolation_expression] = STATE(11487),
    [sym_quote_expression] = STATE(11487),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13515),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(118),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(11487),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11487),
    [sym_string_literal] = STATE(11487),
    [sym_command_literal] = STATE(11487),
    [sym_prefixed_string_literal] = STATE(11487),
    [sym_prefixed_command_literal] = STATE(11487),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3318),
    [anon_sym_const] = ACTIONS(3320),
    [anon_sym_global] = ACTIONS(3322),
    [anon_sym_local] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3426),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3428),
    [sym__type_order_operator] = ACTIONS(3428),
    [sym__unary_operator] = ACTIONS(3430),
    [sym__unary_plus_operator] = ACTIONS(3430),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4186] = {
    [sym__expression] = STATE(13528),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4187] = {
    [sym__expression] = STATE(13529),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4188] = {
    [sym__expression] = STATE(97),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4189] = {
    [sym__expression] = STATE(13530),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4190] = {
    [sym__expression] = STATE(299),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4191] = {
    [sym__expression] = STATE(13531),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4192] = {
    [sym__expression] = STATE(98),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4193] = {
    [sym__expression] = STATE(12467),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(11421),
    [sym_comprehension_expression] = STATE(11421),
    [sym_matrix_expression] = STATE(11421),
    [sym_vector_expression] = STATE(11421),
    [sym_parenthesized_expression] = STATE(11421),
    [sym_tuple_expression] = STATE(11421),
    [sym_curly_expression] = STATE(11421),
    [sym_adjoint_expression] = STATE(7308),
    [sym_field_expression] = STATE(11421),
    [sym_index_expression] = STATE(11421),
    [sym_parametrized_type_expression] = STATE(11421),
    [sym_call_expression] = STATE(11421),
    [sym_broadcast_call_expression] = STATE(11421),
    [sym__closed_macrocall_expression] = STATE(11421),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19635),
    [sym_interpolation_expression] = STATE(11421),
    [sym_quote_expression] = STATE(11421),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13237),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(66),
    [sym_identifier] = STATE(10530),
    [sym_boolean_literal] = STATE(11421),
    [sym_integer_literal] = STATE(9369),
    [sym_float_literal] = STATE(9369),
    [sym__string] = STATE(11421),
    [sym_string_literal] = STATE(11421),
    [sym_command_literal] = STATE(11421),
    [sym_prefixed_string_literal] = STATE(11421),
    [sym_prefixed_command_literal] = STATE(11421),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3172),
    [anon_sym_global] = ACTIONS(3174),
    [anon_sym_local] = ACTIONS(3176),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3302),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3304),
    [sym__type_order_operator] = ACTIONS(3304),
    [sym__unary_operator] = ACTIONS(3306),
    [sym__unary_plus_operator] = ACTIONS(3306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4194] = {
    [sym__expression] = STATE(301),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4195] = {
    [sym__expression] = STATE(13776),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11493),
    [sym__array] = STATE(11493),
    [sym_comprehension_expression] = STATE(11493),
    [sym_matrix_expression] = STATE(11493),
    [sym_vector_expression] = STATE(11493),
    [sym_parenthesized_expression] = STATE(11493),
    [sym_tuple_expression] = STATE(11493),
    [sym_curly_expression] = STATE(11493),
    [sym_adjoint_expression] = STATE(9301),
    [sym_field_expression] = STATE(11493),
    [sym_index_expression] = STATE(11493),
    [sym_parametrized_type_expression] = STATE(11493),
    [sym_call_expression] = STATE(11493),
    [sym_broadcast_call_expression] = STATE(11493),
    [sym__closed_macrocall_expression] = STATE(11493),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18257),
    [sym_interpolation_expression] = STATE(11493),
    [sym_quote_expression] = STATE(11493),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13471),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(147),
    [sym_identifier] = STATE(11009),
    [sym_boolean_literal] = STATE(11493),
    [sym_integer_literal] = STATE(9575),
    [sym_float_literal] = STATE(9575),
    [sym__string] = STATE(11493),
    [sym_string_literal] = STATE(11493),
    [sym_command_literal] = STATE(11493),
    [sym_prefixed_string_literal] = STATE(11493),
    [sym_prefixed_command_literal] = STATE(11493),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3390),
    [anon_sym_const] = ACTIONS(3392),
    [anon_sym_global] = ACTIONS(3394),
    [anon_sym_local] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2902),
    [anon_sym_using] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [aux_sym_integer_literal_token4] = ACTIONS(2918),
    [aux_sym_float_literal_token1] = ACTIONS(2920),
    [aux_sym_float_literal_token3] = ACTIONS(2920),
    [aux_sym_float_literal_token4] = ACTIONS(2920),
    [sym_character_literal] = ACTIONS(3802),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3400),
    [sym__type_order_operator] = ACTIONS(3400),
    [sym__unary_operator] = ACTIONS(3402),
    [sym__unary_plus_operator] = ACTIONS(3402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4196] = {
    [sym__expression] = STATE(99),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4197] = {
    [sym__expression] = STATE(302),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4198] = {
    [sym__expression] = STATE(8959),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4199] = {
    [sym__expression] = STATE(101),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4200] = {
    [sym__expression] = STATE(9048),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4201] = {
    [sym__expression] = STATE(9249),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4202] = {
    [sym__expression] = STATE(303),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4203] = {
    [sym__expression] = STATE(9008),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4204] = {
    [sym__expression] = STATE(9256),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4205] = {
    [sym__expression] = STATE(9245),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4206] = {
    [sym__expression] = STATE(7430),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4207] = {
    [sym__expression] = STATE(7431),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4208] = {
    [sym__expression] = STATE(9052),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4209] = {
    [sym__expression] = STATE(9273),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4210] = {
    [sym__expression] = STATE(9248),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4211] = {
    [sym__expression] = STATE(9056),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4212] = {
    [sym__expression] = STATE(7436),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4213] = {
    [sym__expression] = STATE(9060),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4214] = {
    [sym__expression] = STATE(7438),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4215] = {
    [sym__expression] = STATE(9068),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6362),
    [sym__array] = STATE(6362),
    [sym_comprehension_expression] = STATE(6362),
    [sym_matrix_expression] = STATE(6362),
    [sym_vector_expression] = STATE(6362),
    [sym_parenthesized_expression] = STATE(6362),
    [sym_tuple_expression] = STATE(6362),
    [sym_curly_expression] = STATE(6362),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6362),
    [sym_index_expression] = STATE(6362),
    [sym_parametrized_type_expression] = STATE(6362),
    [sym_call_expression] = STATE(6362),
    [sym_broadcast_call_expression] = STATE(6362),
    [sym__closed_macrocall_expression] = STATE(6362),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(19085),
    [sym_interpolation_expression] = STATE(6362),
    [sym_quote_expression] = STATE(6362),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(8590),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(46),
    [sym_identifier] = STATE(4551),
    [sym_boolean_literal] = STATE(6362),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6362),
    [sym_string_literal] = STATE(6362),
    [sym_command_literal] = STATE(6362),
    [sym_prefixed_string_literal] = STATE(6362),
    [sym_prefixed_command_literal] = STATE(6362),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1047),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(11008),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(8700),
    [sym__type_order_operator] = ACTIONS(8700),
    [sym__unary_operator] = ACTIONS(1079),
    [sym__unary_plus_operator] = ACTIONS(1079),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4216] = {
    [sym__expression] = STATE(7439),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4217] = {
    [sym__expression] = STATE(7440),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4218] = {
    [sym__expression] = STATE(7441),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4219] = {
    [sym__expression] = STATE(7442),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4220] = {
    [sym__expression] = STATE(7443),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4221] = {
    [sym__expression] = STATE(7794),
    [sym_module_definition] = STATE(7717),
    [sym_abstract_definition] = STATE(7717),
    [sym_primitive_definition] = STATE(7717),
    [sym_struct_definition] = STATE(7717),
    [sym_function_definition] = STATE(7717),
    [sym_macro_definition] = STATE(7717),
    [sym_compound_statement] = STATE(7717),
    [sym_quote_statement] = STATE(7717),
    [sym_let_statement] = STATE(7717),
    [sym_if_statement] = STATE(7717),
    [sym_try_statement] = STATE(7717),
    [sym_for_statement] = STATE(7717),
    [sym_while_statement] = STATE(7717),
    [sym_return_statement] = STATE(7717),
    [sym_const_statement] = STATE(7717),
    [sym_global_statement] = STATE(7717),
    [sym_local_statement] = STATE(7717),
    [sym_export_statement] = STATE(7717),
    [sym_import_statement] = STATE(7717),
    [sym__primary_expression] = STATE(4589),
    [sym__array] = STATE(4589),
    [sym_comprehension_expression] = STATE(4589),
    [sym_matrix_expression] = STATE(4589),
    [sym_vector_expression] = STATE(4589),
    [sym_parenthesized_expression] = STATE(4589),
    [sym_tuple_expression] = STATE(4589),
    [sym_curly_expression] = STATE(4589),
    [sym_adjoint_expression] = STATE(4245),
    [sym_field_expression] = STATE(4589),
    [sym_index_expression] = STATE(4589),
    [sym_parametrized_type_expression] = STATE(4589),
    [sym_call_expression] = STATE(4589),
    [sym_broadcast_call_expression] = STATE(4589),
    [sym__closed_macrocall_expression] = STATE(4589),
    [sym_macrocall_expression] = STATE(7717),
    [sym_argument_list] = STATE(18272),
    [sym_interpolation_expression] = STATE(4589),
    [sym_quote_expression] = STATE(4589),
    [sym_binary_expression] = STATE(7717),
    [sym_unary_expression] = STATE(7717),
    [sym_range_expression] = STATE(7717),
    [sym_splat_expression] = STATE(7717),
    [sym_ternary_expression] = STATE(7717),
    [sym_typed_expression] = STATE(7129),
    [sym_unary_typed_expression] = STATE(7717),
    [sym_function_expression] = STATE(7717),
    [sym_juxtaposition_expression] = STATE(7717),
    [sym_compound_assignment_expression] = STATE(7717),
    [sym_where_expression] = STATE(7717),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(4274),
    [sym_boolean_literal] = STATE(4589),
    [sym_integer_literal] = STATE(4254),
    [sym_float_literal] = STATE(4254),
    [sym__string] = STATE(4589),
    [sym_string_literal] = STATE(4589),
    [sym_command_literal] = STATE(4589),
    [sym_prefixed_string_literal] = STATE(4589),
    [sym_prefixed_command_literal] = STATE(4589),
    [sym_operator] = STATE(7139),
    [sym__word_identifier] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_baremodule] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_primitive] = ACTIONS(419),
    [anon_sym_mutable] = ACTIONS(421),
    [anon_sym_struct] = ACTIONS(423),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_macro] = ACTIONS(427),
    [anon_sym_quote] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(439),
    [sym_break_statement] = ACTIONS(441),
    [sym_continue_statement] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_global] = ACTIONS(447),
    [anon_sym_local] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_export] = ACTIONS(453),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_using] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(6310),
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_DOLLAR] = ACTIONS(6316),
    [anon_sym_COLON_COLON] = ACTIONS(6318),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(467),
    [anon_sym_false] = ACTIONS(467),
    [aux_sym_integer_literal_token1] = ACTIONS(6320),
    [aux_sym_integer_literal_token2] = ACTIONS(6320),
    [aux_sym_integer_literal_token3] = ACTIONS(469),
    [aux_sym_integer_literal_token4] = ACTIONS(471),
    [aux_sym_float_literal_token1] = ACTIONS(6322),
    [aux_sym_float_literal_token3] = ACTIONS(6322),
    [aux_sym_float_literal_token4] = ACTIONS(6322),
    [sym_character_literal] = ACTIONS(11014),
    [sym__pair_operator] = ACTIONS(6326),
    [sym__arrow_operator] = ACTIONS(477),
    [sym__comparison_operator] = ACTIONS(477),
    [sym__pipe_right_operator] = ACTIONS(6326),
    [sym__pipe_left_operator] = ACTIONS(6326),
    [sym__ellipsis_operator] = ACTIONS(6326),
    [sym__plus_operator] = ACTIONS(477),
    [sym__times_operator] = ACTIONS(477),
    [sym__rational_operator] = ACTIONS(6326),
    [sym__bitshift_operator] = ACTIONS(6326),
    [sym__power_operator] = ACTIONS(6326),
    [sym__tilde_operator] = ACTIONS(6328),
    [sym__type_order_operator] = ACTIONS(6328),
    [sym__unary_operator] = ACTIONS(479),
    [sym__unary_plus_operator] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4222] = {
    [sym__expression] = STATE(9251),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4223] = {
    [sym__expression] = STATE(12937),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4224] = {
    [sym__expression] = STATE(12992),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4225] = {
    [sym__expression] = STATE(13297),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4226] = {
    [sym__expression] = STATE(13298),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(11208),
    [sym__array] = STATE(11208),
    [sym_comprehension_expression] = STATE(11208),
    [sym_matrix_expression] = STATE(11208),
    [sym_vector_expression] = STATE(11208),
    [sym_parenthesized_expression] = STATE(11208),
    [sym_tuple_expression] = STATE(11208),
    [sym_curly_expression] = STATE(11208),
    [sym_adjoint_expression] = STATE(8372),
    [sym_field_expression] = STATE(11208),
    [sym_index_expression] = STATE(11208),
    [sym_parametrized_type_expression] = STATE(11208),
    [sym_call_expression] = STATE(11208),
    [sym_broadcast_call_expression] = STATE(11208),
    [sym__closed_macrocall_expression] = STATE(11208),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(19294),
    [sym_interpolation_expression] = STATE(11208),
    [sym_quote_expression] = STATE(11208),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12977),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(37),
    [sym_identifier] = STATE(10410),
    [sym_boolean_literal] = STATE(11208),
    [sym_integer_literal] = STATE(9467),
    [sym_float_literal] = STATE(9467),
    [sym__string] = STATE(11208),
    [sym_string_literal] = STATE(11208),
    [sym_command_literal] = STATE(11208),
    [sym_prefixed_string_literal] = STATE(11208),
    [sym_prefixed_command_literal] = STATE(11208),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3019),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_local] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_import] = ACTIONS(53),
    [anon_sym_using] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(59),
    [anon_sym_COLON_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(67),
    [aux_sym_integer_literal_token2] = ACTIONS(67),
    [aux_sym_integer_literal_token3] = ACTIONS(69),
    [aux_sym_integer_literal_token4] = ACTIONS(71),
    [aux_sym_float_literal_token1] = ACTIONS(73),
    [aux_sym_float_literal_token3] = ACTIONS(73),
    [aux_sym_float_literal_token4] = ACTIONS(73),
    [sym_character_literal] = ACTIONS(10996),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(81),
    [sym__type_order_operator] = ACTIONS(81),
    [sym__unary_operator] = ACTIONS(83),
    [sym__unary_plus_operator] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4227] = {
    [sym__expression] = STATE(12995),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4228] = {
    [sym__expression] = STATE(13085),
    [sym_module_definition] = STATE(10856),
    [sym_abstract_definition] = STATE(10856),
    [sym_primitive_definition] = STATE(10856),
    [sym_struct_definition] = STATE(10856),
    [sym_function_definition] = STATE(10856),
    [sym_macro_definition] = STATE(10856),
    [sym_compound_statement] = STATE(10856),
    [sym_quote_statement] = STATE(10856),
    [sym_let_statement] = STATE(10856),
    [sym_if_statement] = STATE(10856),
    [sym_try_statement] = STATE(10856),
    [sym_for_statement] = STATE(10856),
    [sym_while_statement] = STATE(10856),
    [sym_return_statement] = STATE(10856),
    [sym_const_statement] = STATE(10856),
    [sym_global_statement] = STATE(10856),
    [sym_local_statement] = STATE(10856),
    [sym_export_statement] = STATE(10856),
    [sym_import_statement] = STATE(10856),
    [sym__primary_expression] = STATE(10995),
    [sym__array] = STATE(10995),
    [sym_comprehension_expression] = STATE(10995),
    [sym_matrix_expression] = STATE(10995),
    [sym_vector_expression] = STATE(10995),
    [sym_parenthesized_expression] = STATE(10995),
    [sym_tuple_expression] = STATE(10995),
    [sym_curly_expression] = STATE(10995),
    [sym_adjoint_expression] = STATE(7720),
    [sym_field_expression] = STATE(10995),
    [sym_index_expression] = STATE(10995),
    [sym_parametrized_type_expression] = STATE(10995),
    [sym_call_expression] = STATE(10995),
    [sym_broadcast_call_expression] = STATE(10995),
    [sym__closed_macrocall_expression] = STATE(10995),
    [sym_macrocall_expression] = STATE(10856),
    [sym_argument_list] = STATE(18899),
    [sym_interpolation_expression] = STATE(10995),
    [sym_quote_expression] = STATE(10995),
    [sym_binary_expression] = STATE(10856),
    [sym_unary_expression] = STATE(10856),
    [sym_range_expression] = STATE(10856),
    [sym_splat_expression] = STATE(10856),
    [sym_ternary_expression] = STATE(10856),
    [sym_typed_expression] = STATE(12472),
    [sym_unary_typed_expression] = STATE(10856),
    [sym_function_expression] = STATE(10856),
    [sym_juxtaposition_expression] = STATE(10856),
    [sym_compound_assignment_expression] = STATE(10856),
    [sym_where_expression] = STATE(10856),
    [sym_macro_identifier] = STATE(18),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(10995),
    [sym_integer_literal] = STATE(9364),
    [sym_float_literal] = STATE(9364),
    [sym__string] = STATE(10995),
    [sym_string_literal] = STATE(10995),
    [sym_command_literal] = STATE(10995),
    [sym_prefixed_string_literal] = STATE(10995),
    [sym_prefixed_command_literal] = STATE(10995),
    [sym_operator] = STATE(10352),
    [sym__word_identifier] = ACTIONS(7),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_begin] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_local] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_DOLLAR] = ACTIONS(4772),
    [anon_sym_COLON_COLON] = ACTIONS(4774),
    [anon_sym_AT] = ACTIONS(4776),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [aux_sym_integer_literal_token1] = ACTIONS(4778),
    [aux_sym_integer_literal_token2] = ACTIONS(4778),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [aux_sym_integer_literal_token4] = ACTIONS(2508),
    [aux_sym_float_literal_token1] = ACTIONS(4780),
    [aux_sym_float_literal_token3] = ACTIONS(4780),
    [aux_sym_float_literal_token4] = ACTIONS(4780),
    [sym_character_literal] = ACTIONS(11016),
    [sym__pair_operator] = ACTIONS(77),
    [sym__arrow_operator] = ACTIONS(79),
    [sym__comparison_operator] = ACTIONS(79),
    [sym__pipe_right_operator] = ACTIONS(77),
    [sym__pipe_left_operator] = ACTIONS(77),
    [sym__ellipsis_operator] = ACTIONS(77),
    [sym__plus_operator] = ACTIONS(79),
    [sym__times_operator] = ACTIONS(79),
    [sym__rational_operator] = ACTIONS(77),
    [sym__bitshift_operator] = ACTIONS(77),
    [sym__power_operator] = ACTIONS(77),
    [sym__tilde_operator] = ACTIONS(4784),
    [sym__type_order_operator] = ACTIONS(4784),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__unary_plus_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(85),
    [sym__command_start] = ACTIONS(87),
  },
  [4229] = {
    [sym__expression] = STATE(8929),
    [sym_module_definition] = STATE(7304),
    [sym_abstract_definition] = STATE(7304),
    [sym_primitive_definition] = STATE(7304),
    [sym_struct_definition] = STATE(7304),
    [sym_function_definition] = STATE(7304),
    [sym_macro_definition] = STATE(7304),
    [sym_compound_statement] = STATE(7304),
    [sym_quote_statement] = STATE(7304),
    [sym_let_statement] = STATE(7304),
    [sym_if_statement] = STATE(7304),
    [sym_try_statement] = STATE(7304),
    [sym_for_statement] = STATE(7304),
    [sym_while_statement] = STATE(7304),
    [sym_return_statement] = STATE(7304),
    [sym_const_statement] = STATE(7304),
    [sym_global_statement] = STATE(7304),
    [sym_local_statement] = STATE(7304),
    [sym_export_statement] = STATE(7304),
    [sym_import_statement] = STATE(7304),
    [sym__primary_expression] = STATE(5970),
    [sym__array] = STATE(5970),
    [sym_comprehension_expression] = STATE(5970),
    [sym_matrix_expression] = STATE(5970),
    [sym_vector_expression] = STATE(5970),
    [sym_parenthesized_expression] = STATE(5970),
    [sym_tuple_expression] = STATE(5970),
    [sym_curly_expression] = STATE(5970),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(5970),
    [sym_index_expression] = STATE(5970),
    [sym_parametrized_type_expression] = STATE(5970),
    [sym_call_expression] = STATE(5970),
    [sym_broadcast_call_expression] = STATE(5970),
    [sym__closed_macrocall_expression] = STATE(5970),
    [sym_macrocall_expression] = STATE(7304),
    [sym_argument_list] = STATE(19325),
    [sym_interpolation_expression] = STATE(5970),
    [sym_quote_expression] = STATE(5970),
    [sym_binary_expression] = STATE(7304),
    [sym_unary_expression] = STATE(7304),
    [sym_range_expression] = STATE(7304),
    [sym_splat_expression] = STATE(7304),
    [sym_ternary_expression] = STATE(7304),
    [sym_typed_expression] = STATE(8345),
    [sym_unary_typed_expression] = STATE(7304),
    [sym_function_expression] = STATE(7304),
    [sym_juxtaposition_expression] = STATE(7304),
    [sym_compound_assignment_expression] = STATE(7304),
    [sym_where_expression] = STATE(7304),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(4399),
    [sym_boolean_literal] = STATE(5970),
    [sym_integer_literal] = STATE(4253),
    [sym_float_literal] = STATE(4253),
    [sym__string] = STATE(5970),
    [sym_string_literal] = STATE(5970),
    [sym_command_literal] = STATE(5970),
    [sym_prefixed_string_literal] = STATE(5970),
    [sym_prefixed_command_literal] = STATE(5970),
    [sym_operator] = STATE(7098),
    [sym__word_identifier] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(323),
    [anon_sym_begin] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_baremodule] = ACTIONS(327),
    [anon_sym_abstract] = ACTIONS(329),
    [anon_sym_primitive] = ACTIONS(331),
    [anon_sym_mutable] = ACTIONS(333),
    [anon_sym_struct] = ACTIONS(335),
    [anon_sym_function] = ACTIONS(337),
    [anon_sym_macro] = ACTIONS(339),
    [anon_sym_quote] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(347),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(351),
    [sym_break_statement] = ACTIONS(353),
    [sym_continue_statement] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(523),
    [anon_sym_global] = ACTIONS(525),
    [anon_sym_local] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(367),
    [anon_sym_using] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(8648),
    [anon_sym_DOLLAR] = ACTIONS(8650),
    [anon_sym_COLON_COLON] = ACTIONS(8652),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [aux_sym_integer_literal_token1] = ACTIONS(8654),
    [aux_sym_integer_literal_token2] = ACTIONS(8654),
    [aux_sym_integer_literal_token3] = ACTIONS(381),
    [aux_sym_integer_literal_token4] = ACTIONS(383),
    [aux_sym_float_literal_token1] = ACTIONS(8656),
    [aux_sym_float_literal_token3] = ACTIONS(8656),
    [aux_sym_float_literal_token4] = ACTIONS(8656),
    [sym_character_literal] = ACTIONS(11018),
    [sym__pair_operator] = ACTIONS(8660),
    [sym__arrow_operator] = ACTIONS(389),
    [sym__comparison_operator] = ACTIONS(389),
    [sym__pipe_right_operator] = ACTIONS(8660),
    [sym__pipe_left_operator] = ACTIONS(8660),
    [sym__ellipsis_operator] = ACTIONS(8660),
    [sym__plus_operator] = ACTIONS(389),
    [sym__times_operator] = ACTIONS(389),
    [sym__rational_operator] = ACTIONS(8660),
    [sym__bitshift_operator] = ACTIONS(8660),
    [sym__power_operator] = ACTIONS(8660),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(2192),
    [sym__unary_plus_operator] = ACTIONS(2192),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4230] = {
    [sym__expression] = STATE(13512),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4231] = {
    [sym__expression] = STATE(13556),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4232] = {
    [sym__expression] = STATE(13513),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4233] = {
    [sym__expression] = STATE(9299),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4234] = {
    [sym__expression] = STATE(9300),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4235] = {
    [sym__expression] = STATE(13527),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4236] = {
    [sym__expression] = STATE(13534),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11396),
    [sym__array] = STATE(11396),
    [sym_comprehension_expression] = STATE(11396),
    [sym_matrix_expression] = STATE(11396),
    [sym_vector_expression] = STATE(11396),
    [sym_parenthesized_expression] = STATE(11396),
    [sym_tuple_expression] = STATE(11396),
    [sym_curly_expression] = STATE(11396),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11396),
    [sym_index_expression] = STATE(11396),
    [sym_parametrized_type_expression] = STATE(11396),
    [sym_call_expression] = STATE(11396),
    [sym_broadcast_call_expression] = STATE(11396),
    [sym__closed_macrocall_expression] = STATE(11396),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(19658),
    [sym_interpolation_expression] = STATE(11396),
    [sym_quote_expression] = STATE(11396),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13413),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(117),
    [sym_identifier] = STATE(10414),
    [sym_boolean_literal] = STATE(11396),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11396),
    [sym_string_literal] = STATE(11396),
    [sym_command_literal] = STATE(11396),
    [sym_prefixed_string_literal] = STATE(11396),
    [sym_prefixed_command_literal] = STATE(11396),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3308),
    [anon_sym_const] = ACTIONS(3310),
    [anon_sym_global] = ACTIONS(3312),
    [anon_sym_local] = ACTIONS(3314),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3420),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3422),
    [sym__type_order_operator] = ACTIONS(3422),
    [sym__unary_operator] = ACTIONS(3424),
    [sym__unary_plus_operator] = ACTIONS(3424),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4237] = {
    [sym__expression] = STATE(9278),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4238] = {
    [sym__expression] = STATE(9289),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4239] = {
    [sym__expression] = STATE(9290),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4240] = {
    [sym__expression] = STATE(9302),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4241] = {
    [sym__expression] = STATE(9294),
    [sym_module_definition] = STATE(8906),
    [sym_abstract_definition] = STATE(8906),
    [sym_primitive_definition] = STATE(8906),
    [sym_struct_definition] = STATE(8906),
    [sym_function_definition] = STATE(8906),
    [sym_macro_definition] = STATE(8906),
    [sym_compound_statement] = STATE(8906),
    [sym_quote_statement] = STATE(8906),
    [sym_let_statement] = STATE(8906),
    [sym_if_statement] = STATE(8906),
    [sym_try_statement] = STATE(8906),
    [sym_for_statement] = STATE(8906),
    [sym_while_statement] = STATE(8906),
    [sym_return_statement] = STATE(8906),
    [sym_const_statement] = STATE(8906),
    [sym_global_statement] = STATE(8906),
    [sym_local_statement] = STATE(8906),
    [sym_export_statement] = STATE(8906),
    [sym_import_statement] = STATE(8906),
    [sym__primary_expression] = STATE(6742),
    [sym__array] = STATE(6742),
    [sym_comprehension_expression] = STATE(6742),
    [sym_matrix_expression] = STATE(6742),
    [sym_vector_expression] = STATE(6742),
    [sym_parenthesized_expression] = STATE(6742),
    [sym_tuple_expression] = STATE(6742),
    [sym_curly_expression] = STATE(6742),
    [sym_adjoint_expression] = STATE(4250),
    [sym_field_expression] = STATE(6742),
    [sym_index_expression] = STATE(6742),
    [sym_parametrized_type_expression] = STATE(6742),
    [sym_call_expression] = STATE(6742),
    [sym_broadcast_call_expression] = STATE(6742),
    [sym__closed_macrocall_expression] = STATE(6742),
    [sym_macrocall_expression] = STATE(8906),
    [sym_argument_list] = STATE(18571),
    [sym_interpolation_expression] = STATE(6742),
    [sym_quote_expression] = STATE(6742),
    [sym_binary_expression] = STATE(8906),
    [sym_unary_expression] = STATE(8906),
    [sym_range_expression] = STATE(8906),
    [sym_splat_expression] = STATE(8906),
    [sym_ternary_expression] = STATE(8906),
    [sym_typed_expression] = STATE(9161),
    [sym_unary_typed_expression] = STATE(8906),
    [sym_function_expression] = STATE(8906),
    [sym_juxtaposition_expression] = STATE(8906),
    [sym_compound_assignment_expression] = STATE(8906),
    [sym_where_expression] = STATE(8906),
    [sym_macro_identifier] = STATE(80),
    [sym_identifier] = STATE(5545),
    [sym_boolean_literal] = STATE(6742),
    [sym_integer_literal] = STATE(4259),
    [sym_float_literal] = STATE(4259),
    [sym__string] = STATE(6742),
    [sym_string_literal] = STATE(6742),
    [sym_command_literal] = STATE(6742),
    [sym_prefixed_string_literal] = STATE(6742),
    [sym_prefixed_command_literal] = STATE(6742),
    [sym_operator] = STATE(8310),
    [sym__word_identifier] = ACTIONS(1011),
    [anon_sym_COLON] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(1015),
    [anon_sym_module] = ACTIONS(1017),
    [anon_sym_baremodule] = ACTIONS(1017),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_primitive] = ACTIONS(1021),
    [anon_sym_mutable] = ACTIONS(1023),
    [anon_sym_struct] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_macro] = ACTIONS(1029),
    [anon_sym_quote] = ACTIONS(1031),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1037),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1041),
    [sym_break_statement] = ACTIONS(1043),
    [sym_continue_statement] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1139),
    [anon_sym_global] = ACTIONS(1141),
    [anon_sym_local] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(8682),
    [anon_sym_export] = ACTIONS(1055),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_using] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(8684),
    [anon_sym_LBRACE] = ACTIONS(8686),
    [anon_sym_DOLLAR] = ACTIONS(8688),
    [anon_sym_COLON_COLON] = ACTIONS(8690),
    [anon_sym_AT] = ACTIONS(6974),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [aux_sym_integer_literal_token1] = ACTIONS(8692),
    [aux_sym_integer_literal_token2] = ACTIONS(8692),
    [aux_sym_integer_literal_token3] = ACTIONS(1069),
    [aux_sym_integer_literal_token4] = ACTIONS(1071),
    [aux_sym_float_literal_token1] = ACTIONS(8694),
    [aux_sym_float_literal_token3] = ACTIONS(8694),
    [aux_sym_float_literal_token4] = ACTIONS(8694),
    [sym_character_literal] = ACTIONS(10988),
    [sym__pair_operator] = ACTIONS(8698),
    [sym__arrow_operator] = ACTIONS(1077),
    [sym__comparison_operator] = ACTIONS(1077),
    [sym__pipe_right_operator] = ACTIONS(8698),
    [sym__pipe_left_operator] = ACTIONS(8698),
    [sym__ellipsis_operator] = ACTIONS(8698),
    [sym__plus_operator] = ACTIONS(1077),
    [sym__times_operator] = ACTIONS(1077),
    [sym__rational_operator] = ACTIONS(8698),
    [sym__bitshift_operator] = ACTIONS(8698),
    [sym__power_operator] = ACTIONS(8698),
    [sym__tilde_operator] = ACTIONS(10990),
    [sym__type_order_operator] = ACTIONS(10990),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__unary_plus_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4242] = {
    [sym__expression] = STATE(13442),
    [sym_module_definition] = STATE(12015),
    [sym_abstract_definition] = STATE(12015),
    [sym_primitive_definition] = STATE(12015),
    [sym_struct_definition] = STATE(12015),
    [sym_function_definition] = STATE(12015),
    [sym_macro_definition] = STATE(12015),
    [sym_compound_statement] = STATE(12015),
    [sym_quote_statement] = STATE(12015),
    [sym_let_statement] = STATE(12015),
    [sym_if_statement] = STATE(12015),
    [sym_try_statement] = STATE(12015),
    [sym_for_statement] = STATE(12015),
    [sym_while_statement] = STATE(12015),
    [sym_return_statement] = STATE(12015),
    [sym_const_statement] = STATE(12015),
    [sym_global_statement] = STATE(12015),
    [sym_local_statement] = STATE(12015),
    [sym_export_statement] = STATE(12015),
    [sym_import_statement] = STATE(12015),
    [sym__primary_expression] = STATE(11382),
    [sym__array] = STATE(11382),
    [sym_comprehension_expression] = STATE(11382),
    [sym_matrix_expression] = STATE(11382),
    [sym_vector_expression] = STATE(11382),
    [sym_parenthesized_expression] = STATE(11382),
    [sym_tuple_expression] = STATE(11382),
    [sym_curly_expression] = STATE(11382),
    [sym_adjoint_expression] = STATE(8191),
    [sym_field_expression] = STATE(11382),
    [sym_index_expression] = STATE(11382),
    [sym_parametrized_type_expression] = STATE(11382),
    [sym_call_expression] = STATE(11382),
    [sym_broadcast_call_expression] = STATE(11382),
    [sym__closed_macrocall_expression] = STATE(11382),
    [sym_macrocall_expression] = STATE(12015),
    [sym_argument_list] = STATE(18477),
    [sym_interpolation_expression] = STATE(11382),
    [sym_quote_expression] = STATE(11382),
    [sym_binary_expression] = STATE(12015),
    [sym_unary_expression] = STATE(12015),
    [sym_range_expression] = STATE(12015),
    [sym_splat_expression] = STATE(12015),
    [sym_ternary_expression] = STATE(12015),
    [sym_typed_expression] = STATE(13414),
    [sym_unary_typed_expression] = STATE(12015),
    [sym_function_expression] = STATE(12015),
    [sym_juxtaposition_expression] = STATE(12015),
    [sym_compound_assignment_expression] = STATE(12015),
    [sym_where_expression] = STATE(12015),
    [sym_macro_identifier] = STATE(123),
    [sym_identifier] = STATE(10590),
    [sym_boolean_literal] = STATE(11382),
    [sym_integer_literal] = STATE(9437),
    [sym_float_literal] = STATE(9437),
    [sym__string] = STATE(11382),
    [sym_string_literal] = STATE(11382),
    [sym_command_literal] = STATE(11382),
    [sym_prefixed_string_literal] = STATE(11382),
    [sym_prefixed_command_literal] = STATE(11382),
    [sym_operator] = STATE(11668),
    [sym__word_identifier] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(3138),
    [anon_sym_begin] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_baremodule] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_primitive] = ACTIONS(2866),
    [anon_sym_mutable] = ACTIONS(2868),
    [anon_sym_struct] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_macro] = ACTIONS(2874),
    [anon_sym_quote] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2886),
    [sym_break_statement] = ACTIONS(2888),
    [sym_continue_statement] = ACTIONS(2888),
    [anon_sym_return] = ACTIONS(3344),
    [anon_sym_const] = ACTIONS(3346),
    [anon_sym_global] = ACTIONS(3348),
    [anon_sym_local] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_DOLLAR] = ACTIONS(3152),
    [anon_sym_COLON_COLON] = ACTIONS(3154),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(2912),
    [anon_sym_false] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(3156),
    [aux_sym_integer_literal_token2] = ACTIONS(3156),
    [aux_sym_integer_literal_token3] = ACTIONS(3158),
    [aux_sym_integer_literal_token4] = ACTIONS(3160),
    [aux_sym_float_literal_token1] = ACTIONS(3162),
    [aux_sym_float_literal_token3] = ACTIONS(3162),
    [aux_sym_float_literal_token4] = ACTIONS(3162),
    [sym_character_literal] = ACTIONS(3412),
    [sym__pair_operator] = ACTIONS(2924),
    [sym__arrow_operator] = ACTIONS(2926),
    [sym__comparison_operator] = ACTIONS(2926),
    [sym__pipe_right_operator] = ACTIONS(2924),
    [sym__pipe_left_operator] = ACTIONS(2924),
    [sym__ellipsis_operator] = ACTIONS(2924),
    [sym__plus_operator] = ACTIONS(2926),
    [sym__times_operator] = ACTIONS(2926),
    [sym__rational_operator] = ACTIONS(2924),
    [sym__bitshift_operator] = ACTIONS(2924),
    [sym__power_operator] = ACTIONS(2924),
    [sym__tilde_operator] = ACTIONS(3354),
    [sym__type_order_operator] = ACTIONS(3354),
    [sym__unary_operator] = ACTIONS(3356),
    [sym__unary_plus_operator] = ACTIONS(3356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2932),
    [sym__command_start] = ACTIONS(2934),
  },
  [4243] = {
    [sym__primary_expression] = STATE(5794),
    [sym__array] = STATE(5794),
    [sym_comprehension_expression] = STATE(5794),
    [sym_matrix_expression] = STATE(5794),
    [sym_vector_expression] = STATE(5794),
    [sym_parenthesized_expression] = STATE(5794),
    [sym_tuple_expression] = STATE(5794),
    [sym_curly_expression] = STATE(5794),
    [sym_adjoint_expression] = STATE(5794),
    [sym_field_expression] = STATE(5794),
    [sym_index_expression] = STATE(5794),
    [sym_parametrized_type_expression] = STATE(5794),
    [sym_call_expression] = STATE(5794),
    [sym_broadcast_call_expression] = STATE(5794),
    [sym__closed_macrocall_expression] = STATE(5794),
    [sym_interpolation_expression] = STATE(5794),
    [sym_quote_expression] = STATE(5794),
    [sym_macro_identifier] = STATE(17017),
    [sym_identifier] = STATE(4495),
    [sym_boolean_literal] = STATE(5794),
    [sym__string] = STATE(5794),
    [sym_string_literal] = STATE(5794),
    [sym_command_literal] = STATE(5794),
    [sym_prefixed_string_literal] = STATE(5794),
    [sym_prefixed_command_literal] = STATE(5794),
    [sym_operator] = STATE(19176),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(11115),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11118),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(11121),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(11124),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(11127),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(11130),
    [anon_sym_true] = ACTIONS(11133),
    [anon_sym_false] = ACTIONS(11133),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(11136),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(11139),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(11142),
    [sym__command_start] = ACTIONS(11145),
  },
  [4244] = {
    [sym__primary_expression] = STATE(5581),
    [sym__array] = STATE(5581),
    [sym_comprehension_expression] = STATE(5581),
    [sym_matrix_expression] = STATE(5581),
    [sym_vector_expression] = STATE(5581),
    [sym_parenthesized_expression] = STATE(5581),
    [sym_tuple_expression] = STATE(5581),
    [sym_curly_expression] = STATE(5581),
    [sym_adjoint_expression] = STATE(5581),
    [sym_field_expression] = STATE(5581),
    [sym_index_expression] = STATE(5581),
    [sym_parametrized_type_expression] = STATE(5581),
    [sym_call_expression] = STATE(5581),
    [sym_broadcast_call_expression] = STATE(5581),
    [sym__closed_macrocall_expression] = STATE(5581),
    [sym_interpolation_expression] = STATE(5581),
    [sym_quote_expression] = STATE(5581),
    [sym_macro_identifier] = STATE(16688),
    [sym_identifier] = STATE(4498),
    [sym_boolean_literal] = STATE(5581),
    [sym__string] = STATE(5581),
    [sym_string_literal] = STATE(5581),
    [sym_command_literal] = STATE(5581),
    [sym_prefixed_string_literal] = STATE(5581),
    [sym_prefixed_command_literal] = STATE(5581),
    [sym_operator] = STATE(18630),
    [sym__word_identifier] = ACTIONS(11148),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(11151),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_elseif] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11154),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(11157),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(11160),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(11163),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(11130),
    [anon_sym_true] = ACTIONS(11166),
    [anon_sym_false] = ACTIONS(11166),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(11169),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(11139),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(11172),
    [sym__command_start] = ACTIONS(11175),
  },
  [4245] = {
    [sym__primary_expression] = STATE(5821),
    [sym__array] = STATE(5821),
    [sym_comprehension_expression] = STATE(5821),
    [sym_matrix_expression] = STATE(5821),
    [sym_vector_expression] = STATE(5821),
    [sym_parenthesized_expression] = STATE(5821),
    [sym_tuple_expression] = STATE(5821),
    [sym_curly_expression] = STATE(5821),
    [sym_adjoint_expression] = STATE(5821),
    [sym_field_expression] = STATE(5821),
    [sym_index_expression] = STATE(5821),
    [sym_parametrized_type_expression] = STATE(5821),
    [sym_call_expression] = STATE(5821),
    [sym_broadcast_call_expression] = STATE(5821),
    [sym__closed_macrocall_expression] = STATE(5821),
    [sym_interpolation_expression] = STATE(5821),
    [sym_quote_expression] = STATE(5821),
    [sym_macro_identifier] = STATE(16783),
    [sym_identifier] = STATE(4348),
    [sym_boolean_literal] = STATE(5821),
    [sym__string] = STATE(5821),
    [sym_string_literal] = STATE(5821),
    [sym_command_literal] = STATE(5821),
    [sym_prefixed_string_literal] = STATE(5821),
    [sym_prefixed_command_literal] = STATE(5821),
    [sym_operator] = STATE(18804),
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym__word_identifier] = ACTIONS(11178),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(11181),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11184),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(11187),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(11190),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(11193),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(11130),
    [anon_sym_true] = ACTIONS(11196),
    [anon_sym_false] = ACTIONS(11196),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(11199),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(11139),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(11202),
    [sym__command_start] = ACTIONS(11205),
  },
  [4246] = {
    [sym__primary_expression] = STATE(6232),
    [sym__array] = STATE(6232),
    [sym_comprehension_expression] = STATE(6232),
    [sym_matrix_expression] = STATE(6232),
    [sym_vector_expression] = STATE(6232),
    [sym_parenthesized_expression] = STATE(6232),
    [sym_tuple_expression] = STATE(6232),
    [sym_curly_expression] = STATE(6232),
    [sym_adjoint_expression] = STATE(6232),
    [sym_field_expression] = STATE(6232),
    [sym_index_expression] = STATE(6232),
    [sym_parametrized_type_expression] = STATE(6232),
    [sym_call_expression] = STATE(6232),
    [sym_broadcast_call_expression] = STATE(6232),
    [sym__closed_macrocall_expression] = STATE(6232),
    [sym_interpolation_expression] = STATE(6232),
    [sym_quote_expression] = STATE(6232),
    [sym_macro_identifier] = STATE(17020),
    [sym_identifier] = STATE(4951),
    [sym_boolean_literal] = STATE(6232),
    [sym__string] = STATE(6232),
    [sym_string_literal] = STATE(6232),
    [sym_command_literal] = STATE(6232),
    [sym_prefixed_string_literal] = STATE(6232),
    [sym_prefixed_command_literal] = STATE(6232),
    [sym_operator] = STATE(19184),
    [sym__word_identifier] = ACTIONS(11208),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(11211),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11214),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(11217),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(11220),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(11223),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(11130),
    [anon_sym_true] = ACTIONS(11226),
    [anon_sym_false] = ACTIONS(11226),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(11229),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(11139),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(11232),
    [sym__command_start] = ACTIONS(11235),
  },
  [4247] = {
    [sym__primary_expression] = STATE(6153),
    [sym__array] = STATE(6153),
    [sym_comprehension_expression] = STATE(6153),
    [sym_matrix_expression] = STATE(6153),
    [sym_vector_expression] = STATE(6153),
    [sym_parenthesized_expression] = STATE(6153),
    [sym_tuple_expression] = STATE(6153),
    [sym_curly_expression] = STATE(6153),
    [sym_adjoint_expression] = STATE(6153),
    [sym_field_expression] = STATE(6153),
    [sym_index_expression] = STATE(6153),
    [sym_parametrized_type_expression] = STATE(6153),
    [sym_call_expression] = STATE(6153),
    [sym_broadcast_call_expression] = STATE(6153),
    [sym__closed_macrocall_expression] = STATE(6153),
    [sym_interpolation_expression] = STATE(6153),
    [sym_quote_expression] = STATE(6153),
    [sym_macro_identifier] = STATE(16921),
    [sym_identifier] = STATE(4685),
    [sym_boolean_literal] = STATE(6153),
    [sym__string] = STATE(6153),
    [sym_string_literal] = STATE(6153),
    [sym_command_literal] = STATE(6153),
    [sym_prefixed_string_literal] = STATE(6153),
    [sym_prefixed_command_literal] = STATE(6153),
    [sym_operator] = STATE(18987),
    [sym__word_identifier] = ACTIONS(11238),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(11241),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11244),
    [anon_sym_RPAREN] = ACTIONS(171),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_RBRACK] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(171),
    [anon_sym_LBRACE] = ACTIONS(11250),
    [anon_sym_RBRACE] = ACTIONS(171),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(11253),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(171),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_AT] = ACTIONS(11256),
    [anon_sym_true] = ACTIONS(11259),
    [anon_sym_false] = ACTIONS(11259),
    [aux_sym_integer_literal_token1] = ACTIONS(171),
    [aux_sym_integer_literal_token2] = ACTIONS(171),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(171),
    [aux_sym_float_literal_token3] = ACTIONS(171),
    [aux_sym_float_literal_token4] = ACTIONS(171),
    [sym_character_literal] = ACTIONS(11262),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(171),
    [sym__lazy_and_operator] = ACTIONS(171),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11139),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(11268),
    [sym__command_start] = ACTIONS(11271),
  },
  [4248] = {
    [sym__primary_expression] = STATE(6395),
    [sym__array] = STATE(6395),
    [sym_comprehension_expression] = STATE(6395),
    [sym_matrix_expression] = STATE(6395),
    [sym_vector_expression] = STATE(6395),
    [sym_parenthesized_expression] = STATE(6395),
    [sym_tuple_expression] = STATE(6395),
    [sym_curly_expression] = STATE(6395),
    [sym_adjoint_expression] = STATE(6395),
    [sym_field_expression] = STATE(6395),
    [sym_index_expression] = STATE(6395),
    [sym_parametrized_type_expression] = STATE(6395),
    [sym_call_expression] = STATE(6395),
    [sym_broadcast_call_expression] = STATE(6395),
    [sym__closed_macrocall_expression] = STATE(6395),
    [sym_interpolation_expression] = STATE(6395),
    [sym_quote_expression] = STATE(6395),
    [sym_macro_identifier] = STATE(16989),
    [sym_identifier] = STATE(4731),
    [sym_boolean_literal] = STATE(6395),
    [sym__string] = STATE(6395),
    [sym_string_literal] = STATE(6395),
    [sym_command_literal] = STATE(6395),
    [sym_prefixed_string_literal] = STATE(6395),
    [sym_prefixed_command_literal] = STATE(6395),
    [sym_operator] = STATE(19098),
    [sym__word_identifier] = ACTIONS(11274),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(11277),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11280),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(11283),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(11286),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(11289),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(11130),
    [anon_sym_true] = ACTIONS(11292),
    [anon_sym_false] = ACTIONS(11292),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(11295),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(11139),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(11298),
    [sym__command_start] = ACTIONS(11301),
  },
  [4249] = {
    [sym__primary_expression] = STATE(6380),
    [sym__array] = STATE(6380),
    [sym_comprehension_expression] = STATE(6380),
    [sym_matrix_expression] = STATE(6380),
    [sym_vector_expression] = STATE(6380),
    [sym_parenthesized_expression] = STATE(6380),
    [sym_tuple_expression] = STATE(6380),
    [sym_curly_expression] = STATE(6380),
    [sym_adjoint_expression] = STATE(6380),
    [sym_field_expression] = STATE(6380),
    [sym_index_expression] = STATE(6380),
    [sym_parametrized_type_expression] = STATE(6380),
    [sym_call_expression] = STATE(6380),
    [sym_broadcast_call_expression] = STATE(6380),
    [sym__closed_macrocall_expression] = STATE(6380),
    [sym_interpolation_expression] = STATE(6380),
    [sym_quote_expression] = STATE(6380),
    [sym_macro_identifier] = STATE(17037),
    [sym_identifier] = STATE(4943),
    [sym_boolean_literal] = STATE(6380),
    [sym__string] = STATE(6380),
    [sym_string_literal] = STATE(6380),
    [sym_command_literal] = STATE(6380),
    [sym_prefixed_string_literal] = STATE(6380),
    [sym_prefixed_command_literal] = STATE(6380),
    [sym_operator] = STATE(19214),
    [sym__word_identifier] = ACTIONS(11304),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(11307),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11310),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(11313),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(11316),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(11319),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(11130),
    [anon_sym_true] = ACTIONS(11322),
    [anon_sym_false] = ACTIONS(11322),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(11325),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(11139),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(11328),
    [sym__command_start] = ACTIONS(11331),
  },
  [4250] = {
    [sym__primary_expression] = STATE(6579),
    [sym__array] = STATE(6579),
    [sym_comprehension_expression] = STATE(6579),
    [sym_matrix_expression] = STATE(6579),
    [sym_vector_expression] = STATE(6579),
    [sym_parenthesized_expression] = STATE(6579),
    [sym_tuple_expression] = STATE(6579),
    [sym_curly_expression] = STATE(6579),
    [sym_adjoint_expression] = STATE(6579),
    [sym_field_expression] = STATE(6579),
    [sym_index_expression] = STATE(6579),
    [sym_parametrized_type_expression] = STATE(6579),
    [sym_call_expression] = STATE(6579),
    [sym_broadcast_call_expression] = STATE(6579),
    [sym__closed_macrocall_expression] = STATE(6579),
    [sym_interpolation_expression] = STATE(6579),
    [sym_quote_expression] = STATE(6579),
    [sym_macro_identifier] = STATE(16744),
    [sym_identifier] = STATE(5644),
    [sym_boolean_literal] = STATE(6579),
    [sym__string] = STATE(6579),
    [sym_string_literal] = STATE(6579),
    [sym_command_literal] = STATE(6579),
    [sym_prefixed_string_literal] = STATE(6579),
    [sym_prefixed_command_literal] = STATE(6579),
    [sym_operator] = STATE(18740),
    [sym__word_identifier] = ACTIONS(11334),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(11337),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11340),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(11343),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(11346),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(11349),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(11130),
    [anon_sym_true] = ACTIONS(11352),
    [anon_sym_false] = ACTIONS(11352),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(11355),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(11139),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(11358),
    [sym__command_start] = ACTIONS(11361),
  },
  [4251] = {
    [sym__primary_expression] = STATE(6605),
    [sym__array] = STATE(6605),
    [sym_comprehension_expression] = STATE(6605),
    [sym_matrix_expression] = STATE(6605),
    [sym_vector_expression] = STATE(6605),
    [sym_parenthesized_expression] = STATE(6605),
    [sym_tuple_expression] = STATE(6605),
    [sym_curly_expression] = STATE(6605),
    [sym_adjoint_expression] = STATE(6605),
    [sym_field_expression] = STATE(6605),
    [sym_index_expression] = STATE(6605),
    [sym_parametrized_type_expression] = STATE(6605),
    [sym_call_expression] = STATE(6605),
    [sym_broadcast_call_expression] = STATE(6605),
    [sym__closed_macrocall_expression] = STATE(6605),
    [sym_interpolation_expression] = STATE(6605),
    [sym_quote_expression] = STATE(6605),
    [sym_macro_identifier] = STATE(17053),
    [sym_identifier] = STATE(5743),
    [sym_boolean_literal] = STATE(6605),
    [sym__string] = STATE(6605),
    [sym_string_literal] = STATE(6605),
    [sym_command_literal] = STATE(6605),
    [sym_prefixed_string_literal] = STATE(6605),
    [sym_prefixed_command_literal] = STATE(6605),
    [sym_operator] = STATE(19242),
    [sym__word_identifier] = ACTIONS(11364),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(11367),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11370),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(11373),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(11376),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(11379),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(11130),
    [anon_sym_true] = ACTIONS(11382),
    [anon_sym_false] = ACTIONS(11382),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(11385),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(11139),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(11388),
    [sym__command_start] = ACTIONS(11391),
  },
  [4252] = {
    [sym__primary_expression] = STATE(5794),
    [sym__array] = STATE(5794),
    [sym_comprehension_expression] = STATE(5794),
    [sym_matrix_expression] = STATE(5794),
    [sym_vector_expression] = STATE(5794),
    [sym_parenthesized_expression] = STATE(5794),
    [sym_tuple_expression] = STATE(5794),
    [sym_curly_expression] = STATE(5794),
    [sym_adjoint_expression] = STATE(5794),
    [sym_field_expression] = STATE(5794),
    [sym_index_expression] = STATE(5794),
    [sym_parametrized_type_expression] = STATE(5794),
    [sym_call_expression] = STATE(5794),
    [sym_broadcast_call_expression] = STATE(5794),
    [sym__closed_macrocall_expression] = STATE(5794),
    [sym_interpolation_expression] = STATE(5794),
    [sym_quote_expression] = STATE(5794),
    [sym_macro_identifier] = STATE(17017),
    [sym_identifier] = STATE(4495),
    [sym_boolean_literal] = STATE(5794),
    [sym__string] = STATE(5794),
    [sym_string_literal] = STATE(5794),
    [sym_command_literal] = STATE(5794),
    [sym_prefixed_string_literal] = STATE(5794),
    [sym_prefixed_command_literal] = STATE(5794),
    [sym_operator] = STATE(19176),
    [sym__word_identifier] = ACTIONS(11394),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11399),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11402),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11405),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11410),
    [anon_sym_DOLLAR] = ACTIONS(11413),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11416),
    [anon_sym_true] = ACTIONS(11419),
    [anon_sym_false] = ACTIONS(11419),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11422),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(11425),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(11425),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11428),
    [sym__command_start] = ACTIONS(11431),
  },
  [4253] = {
    [sym__primary_expression] = STATE(5581),
    [sym__array] = STATE(5581),
    [sym_comprehension_expression] = STATE(5581),
    [sym_matrix_expression] = STATE(5581),
    [sym_vector_expression] = STATE(5581),
    [sym_parenthesized_expression] = STATE(5581),
    [sym_tuple_expression] = STATE(5581),
    [sym_curly_expression] = STATE(5581),
    [sym_adjoint_expression] = STATE(5581),
    [sym_field_expression] = STATE(5581),
    [sym_index_expression] = STATE(5581),
    [sym_parametrized_type_expression] = STATE(5581),
    [sym_call_expression] = STATE(5581),
    [sym_broadcast_call_expression] = STATE(5581),
    [sym__closed_macrocall_expression] = STATE(5581),
    [sym_interpolation_expression] = STATE(5581),
    [sym_quote_expression] = STATE(5581),
    [sym_macro_identifier] = STATE(16688),
    [sym_identifier] = STATE(4498),
    [sym_boolean_literal] = STATE(5581),
    [sym__string] = STATE(5581),
    [sym_string_literal] = STATE(5581),
    [sym_command_literal] = STATE(5581),
    [sym_prefixed_string_literal] = STATE(5581),
    [sym_prefixed_command_literal] = STATE(5581),
    [sym_operator] = STATE(18630),
    [sym__word_identifier] = ACTIONS(11434),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11437),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11440),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11443),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11446),
    [anon_sym_DOLLAR] = ACTIONS(11449),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11416),
    [anon_sym_true] = ACTIONS(11452),
    [anon_sym_false] = ACTIONS(11452),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11455),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(11425),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(11425),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11458),
    [sym__command_start] = ACTIONS(11461),
  },
  [4254] = {
    [sym__primary_expression] = STATE(5821),
    [sym__array] = STATE(5821),
    [sym_comprehension_expression] = STATE(5821),
    [sym_matrix_expression] = STATE(5821),
    [sym_vector_expression] = STATE(5821),
    [sym_parenthesized_expression] = STATE(5821),
    [sym_tuple_expression] = STATE(5821),
    [sym_curly_expression] = STATE(5821),
    [sym_adjoint_expression] = STATE(5821),
    [sym_field_expression] = STATE(5821),
    [sym_index_expression] = STATE(5821),
    [sym_parametrized_type_expression] = STATE(5821),
    [sym_call_expression] = STATE(5821),
    [sym_broadcast_call_expression] = STATE(5821),
    [sym__closed_macrocall_expression] = STATE(5821),
    [sym_interpolation_expression] = STATE(5821),
    [sym_quote_expression] = STATE(5821),
    [sym_macro_identifier] = STATE(16783),
    [sym_identifier] = STATE(4348),
    [sym_boolean_literal] = STATE(5821),
    [sym__string] = STATE(5821),
    [sym_string_literal] = STATE(5821),
    [sym_command_literal] = STATE(5821),
    [sym_prefixed_string_literal] = STATE(5821),
    [sym_prefixed_command_literal] = STATE(5821),
    [sym_operator] = STATE(18804),
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11464),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11467),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11470),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11473),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11476),
    [anon_sym_DOLLAR] = ACTIONS(11479),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11416),
    [anon_sym_true] = ACTIONS(11482),
    [anon_sym_false] = ACTIONS(11482),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11485),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(11425),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(11425),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11488),
    [sym__command_start] = ACTIONS(11491),
  },
  [4255] = {
    [sym__primary_expression] = STATE(6232),
    [sym__array] = STATE(6232),
    [sym_comprehension_expression] = STATE(6232),
    [sym_matrix_expression] = STATE(6232),
    [sym_vector_expression] = STATE(6232),
    [sym_parenthesized_expression] = STATE(6232),
    [sym_tuple_expression] = STATE(6232),
    [sym_curly_expression] = STATE(6232),
    [sym_adjoint_expression] = STATE(6232),
    [sym_field_expression] = STATE(6232),
    [sym_index_expression] = STATE(6232),
    [sym_parametrized_type_expression] = STATE(6232),
    [sym_call_expression] = STATE(6232),
    [sym_broadcast_call_expression] = STATE(6232),
    [sym__closed_macrocall_expression] = STATE(6232),
    [sym_interpolation_expression] = STATE(6232),
    [sym_quote_expression] = STATE(6232),
    [sym_macro_identifier] = STATE(17020),
    [sym_identifier] = STATE(4951),
    [sym_boolean_literal] = STATE(6232),
    [sym__string] = STATE(6232),
    [sym_string_literal] = STATE(6232),
    [sym_command_literal] = STATE(6232),
    [sym_prefixed_string_literal] = STATE(6232),
    [sym_prefixed_command_literal] = STATE(6232),
    [sym_operator] = STATE(19184),
    [sym__word_identifier] = ACTIONS(11494),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11497),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11500),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11503),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11506),
    [anon_sym_DOLLAR] = ACTIONS(11509),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11416),
    [anon_sym_true] = ACTIONS(11512),
    [anon_sym_false] = ACTIONS(11512),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11515),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(11425),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(11425),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11518),
    [sym__command_start] = ACTIONS(11521),
  },
  [4256] = {
    [sym__primary_expression] = STATE(6395),
    [sym__array] = STATE(6395),
    [sym_comprehension_expression] = STATE(6395),
    [sym_matrix_expression] = STATE(6395),
    [sym_vector_expression] = STATE(6395),
    [sym_parenthesized_expression] = STATE(6395),
    [sym_tuple_expression] = STATE(6395),
    [sym_curly_expression] = STATE(6395),
    [sym_adjoint_expression] = STATE(6395),
    [sym_field_expression] = STATE(6395),
    [sym_index_expression] = STATE(6395),
    [sym_parametrized_type_expression] = STATE(6395),
    [sym_call_expression] = STATE(6395),
    [sym_broadcast_call_expression] = STATE(6395),
    [sym__closed_macrocall_expression] = STATE(6395),
    [sym_interpolation_expression] = STATE(6395),
    [sym_quote_expression] = STATE(6395),
    [sym_macro_identifier] = STATE(16989),
    [sym_identifier] = STATE(4731),
    [sym_boolean_literal] = STATE(6395),
    [sym__string] = STATE(6395),
    [sym_string_literal] = STATE(6395),
    [sym_command_literal] = STATE(6395),
    [sym_prefixed_string_literal] = STATE(6395),
    [sym_prefixed_command_literal] = STATE(6395),
    [sym_operator] = STATE(19098),
    [sym__word_identifier] = ACTIONS(11524),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11527),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11530),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11533),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11536),
    [anon_sym_DOLLAR] = ACTIONS(11539),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11416),
    [anon_sym_true] = ACTIONS(11542),
    [anon_sym_false] = ACTIONS(11542),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11545),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(11425),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(11425),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11548),
    [sym__command_start] = ACTIONS(11551),
  },
  [4257] = {
    [sym__primary_expression] = STATE(6153),
    [sym__array] = STATE(6153),
    [sym_comprehension_expression] = STATE(6153),
    [sym_matrix_expression] = STATE(6153),
    [sym_vector_expression] = STATE(6153),
    [sym_parenthesized_expression] = STATE(6153),
    [sym_tuple_expression] = STATE(6153),
    [sym_curly_expression] = STATE(6153),
    [sym_adjoint_expression] = STATE(6153),
    [sym_field_expression] = STATE(6153),
    [sym_index_expression] = STATE(6153),
    [sym_parametrized_type_expression] = STATE(6153),
    [sym_call_expression] = STATE(6153),
    [sym_broadcast_call_expression] = STATE(6153),
    [sym__closed_macrocall_expression] = STATE(6153),
    [sym_interpolation_expression] = STATE(6153),
    [sym_quote_expression] = STATE(6153),
    [sym_macro_identifier] = STATE(16921),
    [sym_identifier] = STATE(4685),
    [sym_boolean_literal] = STATE(6153),
    [sym__string] = STATE(6153),
    [sym_string_literal] = STATE(6153),
    [sym_command_literal] = STATE(6153),
    [sym_prefixed_string_literal] = STATE(6153),
    [sym_prefixed_command_literal] = STATE(6153),
    [sym_operator] = STATE(18987),
    [sym__word_identifier] = ACTIONS(11554),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11557),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11560),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11563),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11566),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11569),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11572),
    [anon_sym_true] = ACTIONS(11575),
    [anon_sym_false] = ACTIONS(11575),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11578),
    [sym__pair_operator] = ACTIONS(11581),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11581),
    [sym__pipe_left_operator] = ACTIONS(11581),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11581),
    [sym__bitshift_operator] = ACTIONS(11581),
    [sym__power_operator] = ACTIONS(11581),
    [sym__tilde_operator] = ACTIONS(11581),
    [sym__type_order_operator] = ACTIONS(11581),
    [sym__unary_operator] = ACTIONS(11425),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11584),
    [sym__command_start] = ACTIONS(11587),
  },
  [4258] = {
    [sym__primary_expression] = STATE(6380),
    [sym__array] = STATE(6380),
    [sym_comprehension_expression] = STATE(6380),
    [sym_matrix_expression] = STATE(6380),
    [sym_vector_expression] = STATE(6380),
    [sym_parenthesized_expression] = STATE(6380),
    [sym_tuple_expression] = STATE(6380),
    [sym_curly_expression] = STATE(6380),
    [sym_adjoint_expression] = STATE(6380),
    [sym_field_expression] = STATE(6380),
    [sym_index_expression] = STATE(6380),
    [sym_parametrized_type_expression] = STATE(6380),
    [sym_call_expression] = STATE(6380),
    [sym_broadcast_call_expression] = STATE(6380),
    [sym__closed_macrocall_expression] = STATE(6380),
    [sym_interpolation_expression] = STATE(6380),
    [sym_quote_expression] = STATE(6380),
    [sym_macro_identifier] = STATE(17037),
    [sym_identifier] = STATE(4943),
    [sym_boolean_literal] = STATE(6380),
    [sym__string] = STATE(6380),
    [sym_string_literal] = STATE(6380),
    [sym_command_literal] = STATE(6380),
    [sym_prefixed_string_literal] = STATE(6380),
    [sym_prefixed_command_literal] = STATE(6380),
    [sym_operator] = STATE(19214),
    [sym__word_identifier] = ACTIONS(11590),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11593),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11596),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11599),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11602),
    [anon_sym_DOLLAR] = ACTIONS(11605),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11416),
    [anon_sym_true] = ACTIONS(11608),
    [anon_sym_false] = ACTIONS(11608),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11611),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(11425),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(11425),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11614),
    [sym__command_start] = ACTIONS(11617),
  },
  [4259] = {
    [sym__primary_expression] = STATE(6579),
    [sym__array] = STATE(6579),
    [sym_comprehension_expression] = STATE(6579),
    [sym_matrix_expression] = STATE(6579),
    [sym_vector_expression] = STATE(6579),
    [sym_parenthesized_expression] = STATE(6579),
    [sym_tuple_expression] = STATE(6579),
    [sym_curly_expression] = STATE(6579),
    [sym_adjoint_expression] = STATE(6579),
    [sym_field_expression] = STATE(6579),
    [sym_index_expression] = STATE(6579),
    [sym_parametrized_type_expression] = STATE(6579),
    [sym_call_expression] = STATE(6579),
    [sym_broadcast_call_expression] = STATE(6579),
    [sym__closed_macrocall_expression] = STATE(6579),
    [sym_interpolation_expression] = STATE(6579),
    [sym_quote_expression] = STATE(6579),
    [sym_macro_identifier] = STATE(16744),
    [sym_identifier] = STATE(5644),
    [sym_boolean_literal] = STATE(6579),
    [sym__string] = STATE(6579),
    [sym_string_literal] = STATE(6579),
    [sym_command_literal] = STATE(6579),
    [sym_prefixed_string_literal] = STATE(6579),
    [sym_prefixed_command_literal] = STATE(6579),
    [sym_operator] = STATE(18740),
    [sym__word_identifier] = ACTIONS(11620),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11623),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11626),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11629),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11632),
    [anon_sym_DOLLAR] = ACTIONS(11635),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11416),
    [anon_sym_true] = ACTIONS(11638),
    [anon_sym_false] = ACTIONS(11638),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11641),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(11425),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(11425),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11644),
    [sym__command_start] = ACTIONS(11647),
  },
  [4260] = {
    [sym__primary_expression] = STATE(6605),
    [sym__array] = STATE(6605),
    [sym_comprehension_expression] = STATE(6605),
    [sym_matrix_expression] = STATE(6605),
    [sym_vector_expression] = STATE(6605),
    [sym_parenthesized_expression] = STATE(6605),
    [sym_tuple_expression] = STATE(6605),
    [sym_curly_expression] = STATE(6605),
    [sym_adjoint_expression] = STATE(6605),
    [sym_field_expression] = STATE(6605),
    [sym_index_expression] = STATE(6605),
    [sym_parametrized_type_expression] = STATE(6605),
    [sym_call_expression] = STATE(6605),
    [sym_broadcast_call_expression] = STATE(6605),
    [sym__closed_macrocall_expression] = STATE(6605),
    [sym_interpolation_expression] = STATE(6605),
    [sym_quote_expression] = STATE(6605),
    [sym_macro_identifier] = STATE(17053),
    [sym_identifier] = STATE(5743),
    [sym_boolean_literal] = STATE(6605),
    [sym__string] = STATE(6605),
    [sym_string_literal] = STATE(6605),
    [sym_command_literal] = STATE(6605),
    [sym_prefixed_string_literal] = STATE(6605),
    [sym_prefixed_command_literal] = STATE(6605),
    [sym_operator] = STATE(19242),
    [sym__word_identifier] = ACTIONS(11650),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11653),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11656),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11659),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11662),
    [anon_sym_DOLLAR] = ACTIONS(11665),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11416),
    [anon_sym_true] = ACTIONS(11668),
    [anon_sym_false] = ACTIONS(11668),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11671),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(11425),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(11425),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11674),
    [sym__command_start] = ACTIONS(11677),
  },
  [4261] = {
    [sym_identifier] = STATE(4286),
    [sym_integer_literal] = STATE(4934),
    [sym_float_literal] = STATE(4934),
    [sym__string] = STATE(4934),
    [sym_string_literal] = STATE(4934),
    [sym_command_literal] = STATE(4934),
    [sym_prefixed_string_literal] = STATE(4934),
    [sym_prefixed_command_literal] = STATE(4934),
    [sym_operator] = STATE(4934),
    [ts_builtin_sym_end] = ACTIONS(11680),
    [sym__word_identifier] = ACTIONS(11682),
    [anon_sym_EQ] = ACTIONS(11684),
    [anon_sym_COMMA] = ACTIONS(11684),
    [anon_sym_COLON] = ACTIONS(11684),
    [anon_sym_begin] = ACTIONS(11684),
    [anon_sym_module] = ACTIONS(11684),
    [anon_sym_baremodule] = ACTIONS(11684),
    [anon_sym_abstract] = ACTIONS(11684),
    [anon_sym_primitive] = ACTIONS(11684),
    [anon_sym_mutable] = ACTIONS(11684),
    [anon_sym_struct] = ACTIONS(11684),
    [anon_sym_function] = ACTIONS(11684),
    [anon_sym_macro] = ACTIONS(11684),
    [anon_sym_where] = ACTIONS(11684),
    [anon_sym_quote] = ACTIONS(11684),
    [anon_sym_let] = ACTIONS(11684),
    [anon_sym_if] = ACTIONS(11684),
    [anon_sym_try] = ACTIONS(11684),
    [anon_sym_for] = ACTIONS(11684),
    [anon_sym_while] = ACTIONS(11684),
    [sym_break_statement] = ACTIONS(11684),
    [sym_continue_statement] = ACTIONS(11684),
    [anon_sym_return] = ACTIONS(11684),
    [anon_sym_const] = ACTIONS(11684),
    [anon_sym_global] = ACTIONS(11684),
    [anon_sym_local] = ACTIONS(11684),
    [anon_sym_LPAREN] = ACTIONS(11684),
    [anon_sym_RPAREN] = ACTIONS(11684),
    [anon_sym_COLON2] = ACTIONS(11684),
    [anon_sym_export] = ACTIONS(11684),
    [anon_sym_import] = ACTIONS(11684),
    [anon_sym_using] = ACTIONS(11684),
    [anon_sym_LBRACK] = ACTIONS(11684),
    [anon_sym_RBRACK] = ACTIONS(11684),
    [anon_sym_LF] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11684),
    [anon_sym_LBRACE] = ACTIONS(11684),
    [anon_sym_DOLLAR] = ACTIONS(11684),
    [anon_sym_COLON_COLON] = ACTIONS(11684),
    [aux_sym_quote_expression_token1] = ACTIONS(11686),
    [anon_sym_isa] = ACTIONS(11684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11684),
    [anon_sym_QMARK] = ACTIONS(11684),
    [anon_sym_AT] = ACTIONS(11684),
    [anon_sym_true] = ACTIONS(11684),
    [anon_sym_false] = ACTIONS(11684),
    [aux_sym_integer_literal_token1] = ACTIONS(11688),
    [aux_sym_integer_literal_token2] = ACTIONS(11688),
    [aux_sym_integer_literal_token3] = ACTIONS(11688),
    [aux_sym_integer_literal_token4] = ACTIONS(11690),
    [aux_sym_float_literal_token1] = ACTIONS(11692),
    [aux_sym_float_literal_token3] = ACTIONS(11692),
    [aux_sym_float_literal_token4] = ACTIONS(11692),
    [sym_character_literal] = ACTIONS(11686),
    [sym__assignment_operator] = ACTIONS(11686),
    [sym__pair_operator] = ACTIONS(11694),
    [sym__arrow_operator] = ACTIONS(11694),
    [sym__lazy_or_operator] = ACTIONS(11686),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11694),
    [sym__pipe_right_operator] = ACTIONS(11694),
    [sym__pipe_left_operator] = ACTIONS(11694),
    [sym__ellipsis_operator] = ACTIONS(11694),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11694),
    [sym__rational_operator] = ACTIONS(11694),
    [sym__bitshift_operator] = ACTIONS(11694),
    [sym__power_operator] = ACTIONS(11694),
    [sym__tilde_operator] = ACTIONS(11694),
    [sym__type_order_operator] = ACTIONS(11694),
    [sym__unary_operator] = ACTIONS(11694),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [sym__syntactic_operator] = ACTIONS(11686),
    [aux_sym__terminator_token1] = ACTIONS(11684),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11696),
    [sym__immediate_bracket] = ACTIONS(11698),
    [sym__immediate_brace] = ACTIONS(11700),
    [sym__string_start] = ACTIONS(487),
    [sym__command_start] = ACTIONS(489),
  },
  [4262] = {
    [sym_identifier] = STATE(4281),
    [sym_integer_literal] = STATE(4972),
    [sym_float_literal] = STATE(4972),
    [sym__string] = STATE(4972),
    [sym_string_literal] = STATE(4972),
    [sym_command_literal] = STATE(4972),
    [sym_prefixed_string_literal] = STATE(4972),
    [sym_prefixed_command_literal] = STATE(4972),
    [sym_operator] = STATE(4972),
    [sym__word_identifier] = ACTIONS(11702),
    [anon_sym_EQ] = ACTIONS(11684),
    [anon_sym_COMMA] = ACTIONS(11684),
    [anon_sym_COLON] = ACTIONS(11684),
    [anon_sym_begin] = ACTIONS(11684),
    [anon_sym_module] = ACTIONS(11684),
    [anon_sym_baremodule] = ACTIONS(11684),
    [anon_sym_end] = ACTIONS(11684),
    [anon_sym_abstract] = ACTIONS(11684),
    [anon_sym_primitive] = ACTIONS(11684),
    [anon_sym_mutable] = ACTIONS(11684),
    [anon_sym_struct] = ACTIONS(11684),
    [anon_sym_function] = ACTIONS(11684),
    [anon_sym_macro] = ACTIONS(11684),
    [anon_sym_where] = ACTIONS(11684),
    [anon_sym_quote] = ACTIONS(11684),
    [anon_sym_let] = ACTIONS(11684),
    [anon_sym_if] = ACTIONS(11684),
    [anon_sym_elseif] = ACTIONS(11684),
    [anon_sym_else] = ACTIONS(11684),
    [anon_sym_try] = ACTIONS(11684),
    [anon_sym_for] = ACTIONS(11684),
    [anon_sym_while] = ACTIONS(11684),
    [sym_break_statement] = ACTIONS(11684),
    [sym_continue_statement] = ACTIONS(11684),
    [anon_sym_return] = ACTIONS(11684),
    [anon_sym_const] = ACTIONS(11684),
    [anon_sym_global] = ACTIONS(11684),
    [anon_sym_local] = ACTIONS(11684),
    [anon_sym_LPAREN] = ACTIONS(11684),
    [anon_sym_COLON2] = ACTIONS(11684),
    [anon_sym_export] = ACTIONS(11684),
    [anon_sym_import] = ACTIONS(11684),
    [anon_sym_using] = ACTIONS(11684),
    [anon_sym_LBRACK] = ACTIONS(11684),
    [anon_sym_LF] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11684),
    [anon_sym_LBRACE] = ACTIONS(11684),
    [anon_sym_DOLLAR] = ACTIONS(11684),
    [anon_sym_COLON_COLON] = ACTIONS(11684),
    [aux_sym_quote_expression_token1] = ACTIONS(11704),
    [anon_sym_isa] = ACTIONS(11684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11684),
    [anon_sym_QMARK] = ACTIONS(11684),
    [anon_sym_AT] = ACTIONS(11684),
    [anon_sym_true] = ACTIONS(11684),
    [anon_sym_false] = ACTIONS(11684),
    [aux_sym_integer_literal_token1] = ACTIONS(11706),
    [aux_sym_integer_literal_token2] = ACTIONS(11706),
    [aux_sym_integer_literal_token3] = ACTIONS(11706),
    [aux_sym_integer_literal_token4] = ACTIONS(11708),
    [aux_sym_float_literal_token1] = ACTIONS(11710),
    [aux_sym_float_literal_token3] = ACTIONS(11710),
    [aux_sym_float_literal_token4] = ACTIONS(11710),
    [sym_character_literal] = ACTIONS(11704),
    [sym__assignment_operator] = ACTIONS(11704),
    [sym__pair_operator] = ACTIONS(11712),
    [sym__arrow_operator] = ACTIONS(11712),
    [sym__lazy_or_operator] = ACTIONS(11704),
    [sym__lazy_and_operator] = ACTIONS(11704),
    [sym__comparison_operator] = ACTIONS(11712),
    [sym__pipe_right_operator] = ACTIONS(11712),
    [sym__pipe_left_operator] = ACTIONS(11712),
    [sym__ellipsis_operator] = ACTIONS(11712),
    [sym__plus_operator] = ACTIONS(11712),
    [sym__times_operator] = ACTIONS(11712),
    [sym__rational_operator] = ACTIONS(11712),
    [sym__bitshift_operator] = ACTIONS(11712),
    [sym__power_operator] = ACTIONS(11712),
    [sym__tilde_operator] = ACTIONS(11712),
    [sym__type_order_operator] = ACTIONS(11712),
    [sym__unary_operator] = ACTIONS(11712),
    [sym__unary_plus_operator] = ACTIONS(11712),
    [sym__syntactic_operator] = ACTIONS(11704),
    [aux_sym__terminator_token1] = ACTIONS(11684),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11714),
    [sym__immediate_bracket] = ACTIONS(11716),
    [sym__immediate_brace] = ACTIONS(11718),
    [sym__string_start] = ACTIONS(399),
    [sym__command_start] = ACTIONS(401),
  },
  [4263] = {
    [sym_identifier] = STATE(4285),
    [sym_integer_literal] = STATE(5091),
    [sym_float_literal] = STATE(5091),
    [sym__string] = STATE(5091),
    [sym_string_literal] = STATE(5091),
    [sym_command_literal] = STATE(5091),
    [sym_prefixed_string_literal] = STATE(5091),
    [sym_prefixed_command_literal] = STATE(5091),
    [sym_operator] = STATE(5091),
    [sym__word_identifier] = ACTIONS(11720),
    [anon_sym_EQ] = ACTIONS(11684),
    [anon_sym_COMMA] = ACTIONS(11684),
    [anon_sym_COLON] = ACTIONS(11684),
    [anon_sym_begin] = ACTIONS(11684),
    [anon_sym_module] = ACTIONS(11684),
    [anon_sym_baremodule] = ACTIONS(11684),
    [anon_sym_end] = ACTIONS(11684),
    [anon_sym_abstract] = ACTIONS(11684),
    [anon_sym_primitive] = ACTIONS(11684),
    [anon_sym_mutable] = ACTIONS(11684),
    [anon_sym_struct] = ACTIONS(11684),
    [anon_sym_function] = ACTIONS(11684),
    [anon_sym_macro] = ACTIONS(11684),
    [anon_sym_where] = ACTIONS(11684),
    [anon_sym_quote] = ACTIONS(11684),
    [anon_sym_let] = ACTIONS(11684),
    [anon_sym_if] = ACTIONS(11684),
    [anon_sym_else] = ACTIONS(11684),
    [anon_sym_try] = ACTIONS(11684),
    [anon_sym_finally] = ACTIONS(11684),
    [anon_sym_for] = ACTIONS(11684),
    [anon_sym_while] = ACTIONS(11684),
    [sym_break_statement] = ACTIONS(11684),
    [sym_continue_statement] = ACTIONS(11684),
    [anon_sym_return] = ACTIONS(11684),
    [anon_sym_const] = ACTIONS(11684),
    [anon_sym_global] = ACTIONS(11684),
    [anon_sym_local] = ACTIONS(11684),
    [anon_sym_LPAREN] = ACTIONS(11684),
    [anon_sym_COLON2] = ACTIONS(11684),
    [anon_sym_export] = ACTIONS(11684),
    [anon_sym_import] = ACTIONS(11684),
    [anon_sym_using] = ACTIONS(11684),
    [anon_sym_LBRACK] = ACTIONS(11684),
    [anon_sym_LF] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11684),
    [anon_sym_LBRACE] = ACTIONS(11684),
    [anon_sym_DOLLAR] = ACTIONS(11684),
    [anon_sym_COLON_COLON] = ACTIONS(11684),
    [aux_sym_quote_expression_token1] = ACTIONS(11722),
    [anon_sym_isa] = ACTIONS(11684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11684),
    [anon_sym_QMARK] = ACTIONS(11684),
    [anon_sym_AT] = ACTIONS(11684),
    [anon_sym_true] = ACTIONS(11684),
    [anon_sym_false] = ACTIONS(11684),
    [aux_sym_integer_literal_token1] = ACTIONS(11724),
    [aux_sym_integer_literal_token2] = ACTIONS(11724),
    [aux_sym_integer_literal_token3] = ACTIONS(11724),
    [aux_sym_integer_literal_token4] = ACTIONS(11726),
    [aux_sym_float_literal_token1] = ACTIONS(11728),
    [aux_sym_float_literal_token3] = ACTIONS(11728),
    [aux_sym_float_literal_token4] = ACTIONS(11728),
    [sym_character_literal] = ACTIONS(11722),
    [sym__assignment_operator] = ACTIONS(11722),
    [sym__pair_operator] = ACTIONS(11730),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11722),
    [sym__lazy_and_operator] = ACTIONS(11722),
    [sym__comparison_operator] = ACTIONS(11730),
    [sym__pipe_right_operator] = ACTIONS(11730),
    [sym__pipe_left_operator] = ACTIONS(11730),
    [sym__ellipsis_operator] = ACTIONS(11730),
    [sym__plus_operator] = ACTIONS(11730),
    [sym__times_operator] = ACTIONS(11730),
    [sym__rational_operator] = ACTIONS(11730),
    [sym__bitshift_operator] = ACTIONS(11730),
    [sym__power_operator] = ACTIONS(11730),
    [sym__tilde_operator] = ACTIONS(11730),
    [sym__type_order_operator] = ACTIONS(11730),
    [sym__unary_operator] = ACTIONS(11730),
    [sym__unary_plus_operator] = ACTIONS(11730),
    [sym__syntactic_operator] = ACTIONS(11722),
    [aux_sym__terminator_token1] = ACTIONS(11684),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11732),
    [sym__immediate_bracket] = ACTIONS(11734),
    [sym__immediate_brace] = ACTIONS(11736),
    [sym__string_start] = ACTIONS(307),
    [sym__command_start] = ACTIONS(309),
  },
  [4264] = {
    [sym_identifier] = STATE(4406),
    [sym_integer_literal] = STATE(5438),
    [sym_float_literal] = STATE(5438),
    [sym__string] = STATE(5438),
    [sym_string_literal] = STATE(5438),
    [sym_command_literal] = STATE(5438),
    [sym_prefixed_string_literal] = STATE(5438),
    [sym_prefixed_command_literal] = STATE(5438),
    [sym_operator] = STATE(5438),
    [sym__word_identifier] = ACTIONS(11738),
    [anon_sym_EQ] = ACTIONS(11684),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_COLON] = ACTIONS(11684),
    [anon_sym_begin] = ACTIONS(11684),
    [anon_sym_module] = ACTIONS(11684),
    [anon_sym_baremodule] = ACTIONS(11684),
    [anon_sym_abstract] = ACTIONS(11684),
    [anon_sym_primitive] = ACTIONS(11684),
    [anon_sym_mutable] = ACTIONS(11684),
    [anon_sym_struct] = ACTIONS(11684),
    [anon_sym_function] = ACTIONS(11684),
    [anon_sym_macro] = ACTIONS(11684),
    [anon_sym_where] = ACTIONS(11684),
    [anon_sym_quote] = ACTIONS(11684),
    [anon_sym_let] = ACTIONS(11684),
    [anon_sym_if] = ACTIONS(11684),
    [anon_sym_try] = ACTIONS(11684),
    [anon_sym_for] = ACTIONS(11684),
    [anon_sym_while] = ACTIONS(11684),
    [sym_break_statement] = ACTIONS(11684),
    [sym_continue_statement] = ACTIONS(11684),
    [anon_sym_return] = ACTIONS(11684),
    [anon_sym_const] = ACTIONS(11684),
    [anon_sym_global] = ACTIONS(11684),
    [anon_sym_local] = ACTIONS(11684),
    [anon_sym_LPAREN] = ACTIONS(11680),
    [anon_sym_RPAREN] = ACTIONS(11680),
    [anon_sym_COLON2] = ACTIONS(11684),
    [anon_sym_export] = ACTIONS(11684),
    [anon_sym_import] = ACTIONS(11684),
    [anon_sym_using] = ACTIONS(11684),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_RBRACK] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11684),
    [anon_sym_SEMI] = ACTIONS(11680),
    [anon_sym_LBRACE] = ACTIONS(11680),
    [anon_sym_RBRACE] = ACTIONS(11680),
    [anon_sym_DOLLAR] = ACTIONS(11684),
    [anon_sym_COLON_COLON] = ACTIONS(11680),
    [aux_sym_quote_expression_token1] = ACTIONS(11740),
    [anon_sym_isa] = ACTIONS(11684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11680),
    [anon_sym_QMARK] = ACTIONS(11680),
    [anon_sym_AT] = ACTIONS(11680),
    [anon_sym_true] = ACTIONS(11684),
    [anon_sym_false] = ACTIONS(11684),
    [aux_sym_integer_literal_token1] = ACTIONS(11742),
    [aux_sym_integer_literal_token2] = ACTIONS(11742),
    [aux_sym_integer_literal_token3] = ACTIONS(11744),
    [aux_sym_integer_literal_token4] = ACTIONS(11746),
    [aux_sym_float_literal_token1] = ACTIONS(11748),
    [aux_sym_float_literal_token3] = ACTIONS(11748),
    [aux_sym_float_literal_token4] = ACTIONS(11748),
    [sym_character_literal] = ACTIONS(11750),
    [sym__assignment_operator] = ACTIONS(11740),
    [sym__pair_operator] = ACTIONS(11752),
    [sym__arrow_operator] = ACTIONS(11754),
    [sym__lazy_or_operator] = ACTIONS(11750),
    [sym__lazy_and_operator] = ACTIONS(11750),
    [sym__comparison_operator] = ACTIONS(11754),
    [sym__pipe_right_operator] = ACTIONS(11752),
    [sym__pipe_left_operator] = ACTIONS(11752),
    [sym__ellipsis_operator] = ACTIONS(11754),
    [sym__plus_operator] = ACTIONS(11754),
    [sym__times_operator] = ACTIONS(11754),
    [sym__rational_operator] = ACTIONS(11754),
    [sym__bitshift_operator] = ACTIONS(11754),
    [sym__power_operator] = ACTIONS(11754),
    [sym__tilde_operator] = ACTIONS(11752),
    [sym__type_order_operator] = ACTIONS(11752),
    [sym__unary_operator] = ACTIONS(11754),
    [sym__unary_plus_operator] = ACTIONS(11754),
    [sym__syntactic_operator] = ACTIONS(11740),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11756),
    [sym__immediate_bracket] = ACTIONS(11758),
    [sym__immediate_brace] = ACTIONS(11760),
    [sym__string_start] = ACTIONS(899),
    [sym__command_start] = ACTIONS(901),
  },
  [4265] = {
    [sym_identifier] = STATE(4350),
    [sym_integer_literal] = STATE(5911),
    [sym_float_literal] = STATE(5911),
    [sym__string] = STATE(5911),
    [sym_string_literal] = STATE(5911),
    [sym_command_literal] = STATE(5911),
    [sym_prefixed_string_literal] = STATE(5911),
    [sym_prefixed_command_literal] = STATE(5911),
    [sym_operator] = STATE(5911),
    [sym__word_identifier] = ACTIONS(11762),
    [anon_sym_EQ] = ACTIONS(11684),
    [anon_sym_COMMA] = ACTIONS(11684),
    [anon_sym_COLON] = ACTIONS(11684),
    [anon_sym_begin] = ACTIONS(11684),
    [anon_sym_module] = ACTIONS(11684),
    [anon_sym_baremodule] = ACTIONS(11684),
    [anon_sym_end] = ACTIONS(11684),
    [anon_sym_abstract] = ACTIONS(11684),
    [anon_sym_primitive] = ACTIONS(11684),
    [anon_sym_mutable] = ACTIONS(11684),
    [anon_sym_struct] = ACTIONS(11684),
    [anon_sym_function] = ACTIONS(11684),
    [anon_sym_macro] = ACTIONS(11684),
    [anon_sym_where] = ACTIONS(11684),
    [anon_sym_quote] = ACTIONS(11684),
    [anon_sym_let] = ACTIONS(11684),
    [anon_sym_if] = ACTIONS(11684),
    [anon_sym_try] = ACTIONS(11684),
    [anon_sym_finally] = ACTIONS(11684),
    [anon_sym_for] = ACTIONS(11684),
    [anon_sym_while] = ACTIONS(11684),
    [sym_break_statement] = ACTIONS(11684),
    [sym_continue_statement] = ACTIONS(11684),
    [anon_sym_return] = ACTIONS(11684),
    [anon_sym_const] = ACTIONS(11684),
    [anon_sym_global] = ACTIONS(11684),
    [anon_sym_local] = ACTIONS(11684),
    [anon_sym_LPAREN] = ACTIONS(11684),
    [anon_sym_COLON2] = ACTIONS(11684),
    [anon_sym_export] = ACTIONS(11684),
    [anon_sym_import] = ACTIONS(11684),
    [anon_sym_using] = ACTIONS(11684),
    [anon_sym_LBRACK] = ACTIONS(11684),
    [anon_sym_LF] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11684),
    [anon_sym_LBRACE] = ACTIONS(11684),
    [anon_sym_DOLLAR] = ACTIONS(11684),
    [anon_sym_COLON_COLON] = ACTIONS(11684),
    [aux_sym_quote_expression_token1] = ACTIONS(11764),
    [anon_sym_isa] = ACTIONS(11684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11684),
    [anon_sym_QMARK] = ACTIONS(11684),
    [anon_sym_AT] = ACTIONS(11684),
    [anon_sym_true] = ACTIONS(11684),
    [anon_sym_false] = ACTIONS(11684),
    [aux_sym_integer_literal_token1] = ACTIONS(11766),
    [aux_sym_integer_literal_token2] = ACTIONS(11766),
    [aux_sym_integer_literal_token3] = ACTIONS(11766),
    [aux_sym_integer_literal_token4] = ACTIONS(11768),
    [aux_sym_float_literal_token1] = ACTIONS(11770),
    [aux_sym_float_literal_token3] = ACTIONS(11770),
    [aux_sym_float_literal_token4] = ACTIONS(11770),
    [sym_character_literal] = ACTIONS(11764),
    [sym__assignment_operator] = ACTIONS(11764),
    [sym__pair_operator] = ACTIONS(11772),
    [sym__arrow_operator] = ACTIONS(11772),
    [sym__lazy_or_operator] = ACTIONS(11764),
    [sym__lazy_and_operator] = ACTIONS(11764),
    [sym__comparison_operator] = ACTIONS(11772),
    [sym__pipe_right_operator] = ACTIONS(11772),
    [sym__pipe_left_operator] = ACTIONS(11772),
    [sym__ellipsis_operator] = ACTIONS(11772),
    [sym__plus_operator] = ACTIONS(11772),
    [sym__times_operator] = ACTIONS(11772),
    [sym__rational_operator] = ACTIONS(11772),
    [sym__bitshift_operator] = ACTIONS(11772),
    [sym__power_operator] = ACTIONS(11772),
    [sym__tilde_operator] = ACTIONS(11772),
    [sym__type_order_operator] = ACTIONS(11772),
    [sym__unary_operator] = ACTIONS(11772),
    [sym__unary_plus_operator] = ACTIONS(11772),
    [sym__syntactic_operator] = ACTIONS(11764),
    [aux_sym__terminator_token1] = ACTIONS(11684),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11774),
    [sym__immediate_bracket] = ACTIONS(11776),
    [sym__immediate_brace] = ACTIONS(11778),
    [sym__string_start] = ACTIONS(609),
    [sym__command_start] = ACTIONS(611),
  },
  [4266] = {
    [sym_identifier] = STATE(4414),
    [sym_integer_literal] = STATE(5946),
    [sym_float_literal] = STATE(5946),
    [sym__string] = STATE(5946),
    [sym_string_literal] = STATE(5946),
    [sym_command_literal] = STATE(5946),
    [sym_prefixed_string_literal] = STATE(5946),
    [sym_prefixed_command_literal] = STATE(5946),
    [sym_operator] = STATE(5946),
    [sym__word_identifier] = ACTIONS(11780),
    [anon_sym_EQ] = ACTIONS(11684),
    [anon_sym_COMMA] = ACTIONS(11684),
    [anon_sym_COLON] = ACTIONS(11684),
    [anon_sym_begin] = ACTIONS(11684),
    [anon_sym_module] = ACTIONS(11684),
    [anon_sym_baremodule] = ACTIONS(11684),
    [anon_sym_end] = ACTIONS(11684),
    [anon_sym_abstract] = ACTIONS(11684),
    [anon_sym_primitive] = ACTIONS(11684),
    [anon_sym_mutable] = ACTIONS(11684),
    [anon_sym_struct] = ACTIONS(11684),
    [anon_sym_function] = ACTIONS(11684),
    [anon_sym_macro] = ACTIONS(11684),
    [anon_sym_where] = ACTIONS(11684),
    [anon_sym_quote] = ACTIONS(11684),
    [anon_sym_let] = ACTIONS(11684),
    [anon_sym_if] = ACTIONS(11684),
    [anon_sym_try] = ACTIONS(11684),
    [anon_sym_catch] = ACTIONS(11684),
    [anon_sym_for] = ACTIONS(11684),
    [anon_sym_while] = ACTIONS(11684),
    [sym_break_statement] = ACTIONS(11684),
    [sym_continue_statement] = ACTIONS(11684),
    [anon_sym_return] = ACTIONS(11684),
    [anon_sym_const] = ACTIONS(11684),
    [anon_sym_global] = ACTIONS(11684),
    [anon_sym_local] = ACTIONS(11684),
    [anon_sym_LPAREN] = ACTIONS(11684),
    [anon_sym_COLON2] = ACTIONS(11684),
    [anon_sym_export] = ACTIONS(11684),
    [anon_sym_import] = ACTIONS(11684),
    [anon_sym_using] = ACTIONS(11684),
    [anon_sym_LBRACK] = ACTIONS(11684),
    [anon_sym_LF] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11684),
    [anon_sym_LBRACE] = ACTIONS(11684),
    [anon_sym_DOLLAR] = ACTIONS(11684),
    [anon_sym_COLON_COLON] = ACTIONS(11684),
    [aux_sym_quote_expression_token1] = ACTIONS(11782),
    [anon_sym_isa] = ACTIONS(11684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11684),
    [anon_sym_QMARK] = ACTIONS(11684),
    [anon_sym_AT] = ACTIONS(11684),
    [anon_sym_true] = ACTIONS(11684),
    [anon_sym_false] = ACTIONS(11684),
    [aux_sym_integer_literal_token1] = ACTIONS(11784),
    [aux_sym_integer_literal_token2] = ACTIONS(11784),
    [aux_sym_integer_literal_token3] = ACTIONS(11784),
    [aux_sym_integer_literal_token4] = ACTIONS(11786),
    [aux_sym_float_literal_token1] = ACTIONS(11788),
    [aux_sym_float_literal_token3] = ACTIONS(11788),
    [aux_sym_float_literal_token4] = ACTIONS(11788),
    [sym_character_literal] = ACTIONS(11782),
    [sym__assignment_operator] = ACTIONS(11782),
    [sym__pair_operator] = ACTIONS(11790),
    [sym__arrow_operator] = ACTIONS(11790),
    [sym__lazy_or_operator] = ACTIONS(11782),
    [sym__lazy_and_operator] = ACTIONS(11782),
    [sym__comparison_operator] = ACTIONS(11790),
    [sym__pipe_right_operator] = ACTIONS(11790),
    [sym__pipe_left_operator] = ACTIONS(11790),
    [sym__ellipsis_operator] = ACTIONS(11790),
    [sym__plus_operator] = ACTIONS(11790),
    [sym__times_operator] = ACTIONS(11790),
    [sym__rational_operator] = ACTIONS(11790),
    [sym__bitshift_operator] = ACTIONS(11790),
    [sym__power_operator] = ACTIONS(11790),
    [sym__tilde_operator] = ACTIONS(11790),
    [sym__type_order_operator] = ACTIONS(11790),
    [sym__unary_operator] = ACTIONS(11790),
    [sym__unary_plus_operator] = ACTIONS(11790),
    [sym__syntactic_operator] = ACTIONS(11782),
    [aux_sym__terminator_token1] = ACTIONS(11684),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11792),
    [sym__immediate_bracket] = ACTIONS(11794),
    [sym__immediate_brace] = ACTIONS(11796),
    [sym__string_start] = ACTIONS(761),
    [sym__command_start] = ACTIONS(763),
  },
  [4267] = {
    [sym_identifier] = STATE(4440),
    [sym_integer_literal] = STATE(5411),
    [sym_float_literal] = STATE(5411),
    [sym__string] = STATE(5411),
    [sym_string_literal] = STATE(5411),
    [sym_command_literal] = STATE(5411),
    [sym_prefixed_string_literal] = STATE(5411),
    [sym_prefixed_command_literal] = STATE(5411),
    [sym_operator] = STATE(5411),
    [sym__word_identifier] = ACTIONS(11798),
    [anon_sym_EQ] = ACTIONS(11684),
    [anon_sym_COMMA] = ACTIONS(11684),
    [anon_sym_COLON] = ACTIONS(11684),
    [anon_sym_begin] = ACTIONS(11684),
    [anon_sym_module] = ACTIONS(11684),
    [anon_sym_baremodule] = ACTIONS(11684),
    [anon_sym_abstract] = ACTIONS(11684),
    [anon_sym_primitive] = ACTIONS(11684),
    [anon_sym_mutable] = ACTIONS(11684),
    [anon_sym_struct] = ACTIONS(11684),
    [anon_sym_function] = ACTIONS(11684),
    [anon_sym_macro] = ACTIONS(11684),
    [anon_sym_where] = ACTIONS(11684),
    [anon_sym_quote] = ACTIONS(11684),
    [anon_sym_let] = ACTIONS(11684),
    [anon_sym_if] = ACTIONS(11684),
    [anon_sym_try] = ACTIONS(11684),
    [anon_sym_catch] = ACTIONS(11684),
    [anon_sym_finally] = ACTIONS(11684),
    [anon_sym_for] = ACTIONS(11684),
    [anon_sym_while] = ACTIONS(11684),
    [sym_break_statement] = ACTIONS(11684),
    [sym_continue_statement] = ACTIONS(11684),
    [anon_sym_return] = ACTIONS(11684),
    [anon_sym_const] = ACTIONS(11684),
    [anon_sym_global] = ACTIONS(11684),
    [anon_sym_local] = ACTIONS(11684),
    [anon_sym_LPAREN] = ACTIONS(11684),
    [anon_sym_COLON2] = ACTIONS(11684),
    [anon_sym_export] = ACTIONS(11684),
    [anon_sym_import] = ACTIONS(11684),
    [anon_sym_using] = ACTIONS(11684),
    [anon_sym_LBRACK] = ACTIONS(11684),
    [anon_sym_LF] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11684),
    [anon_sym_LBRACE] = ACTIONS(11684),
    [anon_sym_DOLLAR] = ACTIONS(11684),
    [anon_sym_COLON_COLON] = ACTIONS(11684),
    [aux_sym_quote_expression_token1] = ACTIONS(11800),
    [anon_sym_isa] = ACTIONS(11684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11684),
    [anon_sym_QMARK] = ACTIONS(11684),
    [anon_sym_AT] = ACTIONS(11684),
    [anon_sym_true] = ACTIONS(11684),
    [anon_sym_false] = ACTIONS(11684),
    [aux_sym_integer_literal_token1] = ACTIONS(11802),
    [aux_sym_integer_literal_token2] = ACTIONS(11802),
    [aux_sym_integer_literal_token3] = ACTIONS(11802),
    [aux_sym_integer_literal_token4] = ACTIONS(11804),
    [aux_sym_float_literal_token1] = ACTIONS(11806),
    [aux_sym_float_literal_token3] = ACTIONS(11806),
    [aux_sym_float_literal_token4] = ACTIONS(11806),
    [sym_character_literal] = ACTIONS(11800),
    [sym__assignment_operator] = ACTIONS(11800),
    [sym__pair_operator] = ACTIONS(11808),
    [sym__arrow_operator] = ACTIONS(11808),
    [sym__lazy_or_operator] = ACTIONS(11800),
    [sym__lazy_and_operator] = ACTIONS(11800),
    [sym__comparison_operator] = ACTIONS(11808),
    [sym__pipe_right_operator] = ACTIONS(11808),
    [sym__pipe_left_operator] = ACTIONS(11808),
    [sym__ellipsis_operator] = ACTIONS(11808),
    [sym__plus_operator] = ACTIONS(11808),
    [sym__times_operator] = ACTIONS(11808),
    [sym__rational_operator] = ACTIONS(11808),
    [sym__bitshift_operator] = ACTIONS(11808),
    [sym__power_operator] = ACTIONS(11808),
    [sym__tilde_operator] = ACTIONS(11808),
    [sym__type_order_operator] = ACTIONS(11808),
    [sym__unary_operator] = ACTIONS(11808),
    [sym__unary_plus_operator] = ACTIONS(11808),
    [sym__syntactic_operator] = ACTIONS(11800),
    [aux_sym__terminator_token1] = ACTIONS(11684),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11810),
    [sym__immediate_bracket] = ACTIONS(11812),
    [sym__immediate_brace] = ACTIONS(11814),
    [sym__string_start] = ACTIONS(685),
    [sym__command_start] = ACTIONS(687),
  },
  [4268] = {
    [sym_identifier] = STATE(4752),
    [sym_integer_literal] = STATE(6258),
    [sym_float_literal] = STATE(6258),
    [sym__string] = STATE(6258),
    [sym_string_literal] = STATE(6258),
    [sym_command_literal] = STATE(6258),
    [sym_prefixed_string_literal] = STATE(6258),
    [sym_prefixed_command_literal] = STATE(6258),
    [sym_operator] = STATE(6258),
    [sym__word_identifier] = ACTIONS(11816),
    [anon_sym_EQ] = ACTIONS(11684),
    [anon_sym_COMMA] = ACTIONS(11684),
    [anon_sym_COLON] = ACTIONS(11684),
    [anon_sym_begin] = ACTIONS(11684),
    [anon_sym_module] = ACTIONS(11684),
    [anon_sym_baremodule] = ACTIONS(11684),
    [anon_sym_abstract] = ACTIONS(11684),
    [anon_sym_primitive] = ACTIONS(11684),
    [anon_sym_mutable] = ACTIONS(11684),
    [anon_sym_struct] = ACTIONS(11684),
    [anon_sym_function] = ACTIONS(11684),
    [anon_sym_macro] = ACTIONS(11684),
    [anon_sym_where] = ACTIONS(11684),
    [anon_sym_quote] = ACTIONS(11684),
    [anon_sym_let] = ACTIONS(11684),
    [anon_sym_if] = ACTIONS(11684),
    [anon_sym_try] = ACTIONS(11684),
    [anon_sym_for] = ACTIONS(11684),
    [anon_sym_while] = ACTIONS(11684),
    [sym_break_statement] = ACTIONS(11684),
    [sym_continue_statement] = ACTIONS(11684),
    [anon_sym_return] = ACTIONS(11684),
    [anon_sym_const] = ACTIONS(11684),
    [anon_sym_global] = ACTIONS(11684),
    [anon_sym_local] = ACTIONS(11684),
    [anon_sym_LPAREN] = ACTIONS(11684),
    [anon_sym_RPAREN] = ACTIONS(11684),
    [anon_sym_COLON2] = ACTIONS(11684),
    [anon_sym_export] = ACTIONS(11684),
    [anon_sym_import] = ACTIONS(11684),
    [anon_sym_using] = ACTIONS(11684),
    [anon_sym_LBRACK] = ACTIONS(11684),
    [anon_sym_LF] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11684),
    [anon_sym_SEMI] = ACTIONS(11684),
    [anon_sym_LBRACE] = ACTIONS(11684),
    [anon_sym_DOLLAR] = ACTIONS(11684),
    [anon_sym_COLON_COLON] = ACTIONS(11684),
    [aux_sym_quote_expression_token1] = ACTIONS(11818),
    [anon_sym_isa] = ACTIONS(11684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11684),
    [anon_sym_QMARK] = ACTIONS(11684),
    [anon_sym_AT] = ACTIONS(11684),
    [anon_sym_true] = ACTIONS(11684),
    [anon_sym_false] = ACTIONS(11684),
    [aux_sym_integer_literal_token1] = ACTIONS(11820),
    [aux_sym_integer_literal_token2] = ACTIONS(11820),
    [aux_sym_integer_literal_token3] = ACTIONS(11820),
    [aux_sym_integer_literal_token4] = ACTIONS(11822),
    [aux_sym_float_literal_token1] = ACTIONS(11824),
    [aux_sym_float_literal_token3] = ACTIONS(11824),
    [aux_sym_float_literal_token4] = ACTIONS(11824),
    [sym_character_literal] = ACTIONS(11818),
    [sym__assignment_operator] = ACTIONS(11818),
    [sym__pair_operator] = ACTIONS(11826),
    [sym__arrow_operator] = ACTIONS(11826),
    [sym__lazy_or_operator] = ACTIONS(11818),
    [sym__lazy_and_operator] = ACTIONS(11818),
    [sym__comparison_operator] = ACTIONS(11826),
    [sym__pipe_right_operator] = ACTIONS(11826),
    [sym__pipe_left_operator] = ACTIONS(11826),
    [sym__ellipsis_operator] = ACTIONS(11826),
    [sym__plus_operator] = ACTIONS(11826),
    [sym__times_operator] = ACTIONS(11826),
    [sym__rational_operator] = ACTIONS(11826),
    [sym__bitshift_operator] = ACTIONS(11826),
    [sym__power_operator] = ACTIONS(11826),
    [sym__tilde_operator] = ACTIONS(11826),
    [sym__type_order_operator] = ACTIONS(11826),
    [sym__unary_operator] = ACTIONS(11826),
    [sym__unary_plus_operator] = ACTIONS(11826),
    [sym__syntactic_operator] = ACTIONS(11818),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11828),
    [sym__immediate_bracket] = ACTIONS(11830),
    [sym__immediate_brace] = ACTIONS(11832),
    [sym__string_start] = ACTIONS(1001),
    [sym__command_start] = ACTIONS(1003),
  },
  [4269] = {
    [sym_identifier] = STATE(4601),
    [sym_integer_literal] = STATE(6403),
    [sym_float_literal] = STATE(6403),
    [sym__string] = STATE(6403),
    [sym_string_literal] = STATE(6403),
    [sym_command_literal] = STATE(6403),
    [sym_prefixed_string_literal] = STATE(6403),
    [sym_prefixed_command_literal] = STATE(6403),
    [sym_operator] = STATE(6403),
    [sym__word_identifier] = ACTIONS(11834),
    [anon_sym_EQ] = ACTIONS(11684),
    [anon_sym_COMMA] = ACTIONS(11684),
    [anon_sym_COLON] = ACTIONS(11684),
    [anon_sym_begin] = ACTIONS(11684),
    [anon_sym_module] = ACTIONS(11684),
    [anon_sym_baremodule] = ACTIONS(11684),
    [anon_sym_end] = ACTIONS(11684),
    [anon_sym_abstract] = ACTIONS(11684),
    [anon_sym_primitive] = ACTIONS(11684),
    [anon_sym_mutable] = ACTIONS(11684),
    [anon_sym_struct] = ACTIONS(11684),
    [anon_sym_function] = ACTIONS(11684),
    [anon_sym_macro] = ACTIONS(11684),
    [anon_sym_where] = ACTIONS(11684),
    [anon_sym_quote] = ACTIONS(11684),
    [anon_sym_let] = ACTIONS(11684),
    [anon_sym_if] = ACTIONS(11684),
    [anon_sym_try] = ACTIONS(11684),
    [anon_sym_for] = ACTIONS(11684),
    [anon_sym_while] = ACTIONS(11684),
    [sym_break_statement] = ACTIONS(11684),
    [sym_continue_statement] = ACTIONS(11684),
    [anon_sym_return] = ACTIONS(11684),
    [anon_sym_const] = ACTIONS(11684),
    [anon_sym_global] = ACTIONS(11684),
    [anon_sym_local] = ACTIONS(11684),
    [anon_sym_LPAREN] = ACTIONS(11684),
    [anon_sym_COLON2] = ACTIONS(11684),
    [anon_sym_export] = ACTIONS(11684),
    [anon_sym_import] = ACTIONS(11684),
    [anon_sym_using] = ACTIONS(11684),
    [anon_sym_LBRACK] = ACTIONS(11684),
    [anon_sym_LF] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11684),
    [anon_sym_LBRACE] = ACTIONS(11684),
    [anon_sym_DOLLAR] = ACTIONS(11684),
    [anon_sym_COLON_COLON] = ACTIONS(11684),
    [aux_sym_quote_expression_token1] = ACTIONS(11836),
    [anon_sym_isa] = ACTIONS(11684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11684),
    [anon_sym_QMARK] = ACTIONS(11684),
    [anon_sym_AT] = ACTIONS(11684),
    [anon_sym_true] = ACTIONS(11684),
    [anon_sym_false] = ACTIONS(11684),
    [aux_sym_integer_literal_token1] = ACTIONS(11838),
    [aux_sym_integer_literal_token2] = ACTIONS(11838),
    [aux_sym_integer_literal_token3] = ACTIONS(11838),
    [aux_sym_integer_literal_token4] = ACTIONS(11840),
    [aux_sym_float_literal_token1] = ACTIONS(11842),
    [aux_sym_float_literal_token3] = ACTIONS(11842),
    [aux_sym_float_literal_token4] = ACTIONS(11842),
    [sym_character_literal] = ACTIONS(11836),
    [sym__assignment_operator] = ACTIONS(11836),
    [sym__pair_operator] = ACTIONS(11844),
    [sym__arrow_operator] = ACTIONS(11844),
    [sym__lazy_or_operator] = ACTIONS(11836),
    [sym__lazy_and_operator] = ACTIONS(11836),
    [sym__comparison_operator] = ACTIONS(11844),
    [sym__pipe_right_operator] = ACTIONS(11844),
    [sym__pipe_left_operator] = ACTIONS(11844),
    [sym__ellipsis_operator] = ACTIONS(11844),
    [sym__plus_operator] = ACTIONS(11844),
    [sym__times_operator] = ACTIONS(11844),
    [sym__rational_operator] = ACTIONS(11844),
    [sym__bitshift_operator] = ACTIONS(11844),
    [sym__power_operator] = ACTIONS(11844),
    [sym__tilde_operator] = ACTIONS(11844),
    [sym__type_order_operator] = ACTIONS(11844),
    [sym__unary_operator] = ACTIONS(11844),
    [sym__unary_plus_operator] = ACTIONS(11844),
    [sym__syntactic_operator] = ACTIONS(11836),
    [aux_sym__terminator_token1] = ACTIONS(11684),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11846),
    [sym__immediate_bracket] = ACTIONS(11848),
    [sym__immediate_brace] = ACTIONS(11850),
    [sym__string_start] = ACTIONS(1087),
    [sym__command_start] = ACTIONS(1089),
  },
  [4270] = {
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11852),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11854),
    [sym__immediate_command_start] = ACTIONS(11856),
  },
  [4271] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11858),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11860),
    [sym__immediate_command_start] = ACTIONS(11862),
  },
  [4272] = {
    [ts_builtin_sym_end] = ACTIONS(11864),
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4273] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4274] = {
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11868),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11854),
    [sym__immediate_command_start] = ACTIONS(11856),
  },
  [4275] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_elseif] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11870),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11872),
    [sym__immediate_command_start] = ACTIONS(11874),
  },
  [4276] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_elseif] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4277] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11876),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11860),
    [sym__immediate_command_start] = ACTIONS(11862),
  },
  [4278] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_elseif] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11878),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11872),
    [sym__immediate_command_start] = ACTIONS(11874),
  },
  [4279] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_elseif] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11880),
    [sym__immediate_command_start] = ACTIONS(11882),
  },
  [4280] = {
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11884),
    [sym__immediate_command_start] = ACTIONS(11886),
  },
  [4281] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_elseif] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11872),
    [sym__immediate_command_start] = ACTIONS(11874),
  },
  [4282] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_elseif] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11880),
    [sym__immediate_command_start] = ACTIONS(11882),
  },
  [4283] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11860),
    [sym__immediate_command_start] = ACTIONS(11862),
  },
  [4284] = {
    [sym_do_clause] = STATE(5090),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_elseif] = ACTIONS(11896),
    [anon_sym_else] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(11900),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__assignment_operator] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4285] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11860),
    [sym__immediate_command_start] = ACTIONS(11862),
  },
  [4286] = {
    [ts_builtin_sym_end] = ACTIONS(11890),
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_RBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11854),
    [sym__immediate_command_start] = ACTIONS(11856),
  },
  [4287] = {
    [sym_do_clause] = STATE(5161),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_else] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_finally] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(11906),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__assignment_operator] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4288] = {
    [sym_do_clause] = STATE(5175),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_elseif] = ACTIONS(11902),
    [anon_sym_else] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(11900),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__assignment_operator] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4289] = {
    [sym_do_clause] = STATE(4981),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_else] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_finally] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(11906),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__assignment_operator] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4290] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4291] = {
    [sym_do_clause] = STATE(4999),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_elseif] = ACTIONS(11902),
    [anon_sym_else] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(11908),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_DASH_GT] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4292] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_elseif] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4293] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11910),
    [sym__immediate_command_start] = ACTIONS(11912),
  },
  [4294] = {
    [sym_do_clause] = STATE(4586),
    [ts_builtin_sym_end] = ACTIONS(11914),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_RBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(11918),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4295] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4296] = {
    [sym_do_clause] = STATE(5168),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(11906),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4297] = {
    [sym_do_clause] = STATE(4720),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_else] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_finally] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(11920),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_DASH_GT] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4298] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11922),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11924),
    [sym__immediate_command_start] = ACTIONS(11926),
  },
  [4299] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11910),
    [sym__immediate_command_start] = ACTIONS(11912),
  },
  [4300] = {
    [ts_builtin_sym_end] = ACTIONS(11930),
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_RBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11884),
    [sym__immediate_command_start] = ACTIONS(11886),
  },
  [4301] = {
    [ts_builtin_sym_end] = ACTIONS(11864),
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4302] = {
    [sym_do_clause] = STATE(4721),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(11920),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4303] = {
    [sym_do_clause] = STATE(4896),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_elseif] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(11900),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4304] = {
    [sym_do_clause] = STATE(4936),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_elseif] = ACTIONS(11896),
    [anon_sym_else] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(11908),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_DASH_GT] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4305] = {
    [sym_do_clause] = STATE(4982),
    [ts_builtin_sym_end] = ACTIONS(11898),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_RPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_RBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(11936),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_DASH_GT] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4306] = {
    [ts_builtin_sym_end] = ACTIONS(11894),
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_RBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11854),
    [sym__immediate_command_start] = ACTIONS(11856),
  },
  [4307] = {
    [sym_do_clause] = STATE(4984),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_elseif] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(11908),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4308] = {
    [sym_do_clause] = STATE(5107),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_elseif] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(11900),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4309] = {
    [sym_do_clause] = STATE(4567),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_else] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_finally] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(11920),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_DASH_GT] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4310] = {
    [sym_do_clause] = STATE(5001),
    [ts_builtin_sym_end] = ACTIONS(11904),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_RPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_RBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(11936),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_DASH_GT] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4311] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_elseif] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11872),
    [sym__immediate_command_start] = ACTIONS(11874),
  },
  [4312] = {
    [sym_do_clause] = STATE(5094),
    [ts_builtin_sym_end] = ACTIONS(11898),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_RPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_RBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(11918),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__assignment_operator] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4313] = {
    [sym_do_clause] = STATE(5006),
    [ts_builtin_sym_end] = ACTIONS(11914),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_RBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(11936),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4314] = {
    [ts_builtin_sym_end] = ACTIONS(11930),
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_RBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11854),
    [sym__immediate_command_start] = ACTIONS(11856),
  },
  [4315] = {
    [sym_do_clause] = STATE(5127),
    [ts_builtin_sym_end] = ACTIONS(11934),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_RBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(11918),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4316] = {
    [ts_builtin_sym_end] = ACTIONS(11894),
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_RBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11884),
    [sym__immediate_command_start] = ACTIONS(11886),
  },
  [4317] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11910),
    [sym__immediate_command_start] = ACTIONS(11912),
  },
  [4318] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11860),
    [sym__immediate_command_start] = ACTIONS(11862),
  },
  [4319] = {
    [sym_do_clause] = STATE(5156),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(11906),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4320] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_elseif] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4321] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4322] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11938),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11940),
    [sym__immediate_command_start] = ACTIONS(11942),
  },
  [4323] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_elseif] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11880),
    [sym__immediate_command_start] = ACTIONS(11882),
  },
  [4324] = {
    [ts_builtin_sym_end] = ACTIONS(11864),
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4325] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4326] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11944),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11924),
    [sym__immediate_command_start] = ACTIONS(11926),
  },
  [4327] = {
    [sym_do_clause] = STATE(4572),
    [ts_builtin_sym_end] = ACTIONS(11904),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_RPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_RBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(11918),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__assignment_operator] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4328] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_RPAREN] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_RBRACE] = ACTIONS(11864),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11864),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11864),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_DASH_GT] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11864),
    [sym__pipe_left_operator] = ACTIONS(11864),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11864),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4329] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11946),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11948),
    [sym__immediate_command_start] = ACTIONS(11950),
  },
  [4330] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11952),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11948),
    [sym__immediate_command_start] = ACTIONS(11950),
  },
  [4331] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_elseif] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11872),
    [sym__immediate_command_start] = ACTIONS(11874),
  },
  [4332] = {
    [sym_do_clause] = STATE(4767),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(11920),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4333] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4334] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(11954),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11940),
    [sym__immediate_command_start] = ACTIONS(11942),
  },
  [4335] = {
    [sym_do_clause] = STATE(5022),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_elseif] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(11908),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4336] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11910),
    [sym__immediate_command_start] = ACTIONS(11912),
  },
  [4337] = {
    [ts_builtin_sym_end] = ACTIONS(11890),
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_RBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11884),
    [sym__immediate_command_start] = ACTIONS(11886),
  },
  [4338] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_elseif] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11880),
    [sym__immediate_command_start] = ACTIONS(11882),
  },
  [4339] = {
    [sym_do_clause] = STATE(4996),
    [ts_builtin_sym_end] = ACTIONS(11934),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_RBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(11936),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4340] = {
    [sym_identifier] = STATE(5170),
    [ts_builtin_sym_end] = ACTIONS(11956),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_RPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_RBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__assignment_operator] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4341] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_elseif] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4342] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11960),
    [sym__immediate_command_start] = ACTIONS(11962),
  },
  [4343] = {
    [sym_do_clause] = STATE(5805),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_catch] = ACTIONS(11896),
    [anon_sym_finally] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(11964),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_DASH_GT] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4344] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11966),
    [sym__immediate_command_start] = ACTIONS(11968),
  },
  [4345] = {
    [sym_do_clause] = STATE(5247),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(11964),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4346] = {
    [sym_do_clause] = STATE(5887),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_catch] = ACTIONS(11902),
    [anon_sym_finally] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(11964),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_DASH_GT] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4347] = {
    [sym_do_clause] = STATE(5692),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(11964),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4348] = {
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11970),
    [sym__immediate_command_start] = ACTIONS(11972),
  },
  [4349] = {
    [sym_do_clause] = STATE(5250),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(11974),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4350] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11924),
    [sym__immediate_command_start] = ACTIONS(11926),
  },
  [4351] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_else] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_finally] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4352] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_elseif] = ACTIONS(11980),
    [anon_sym_else] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4353] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_else] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_finally] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4354] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_elseif] = ACTIONS(11988),
    [anon_sym_else] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_DASH_GT] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4355] = {
    [sym_identifier] = STATE(5110),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_elseif] = ACTIONS(11992),
    [anon_sym_else] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__assignment_operator] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4356] = {
    [sym_identifier] = STATE(5123),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_elseif] = ACTIONS(11958),
    [anon_sym_else] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__assignment_operator] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4357] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11966),
    [sym__immediate_command_start] = ACTIONS(11968),
  },
  [4358] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_elseif] = ACTIONS(11996),
    [anon_sym_else] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_DASH_GT] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4359] = {
    [sym_do_clause] = STATE(5486),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_catch] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12000),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_DASH_GT] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4360] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_elseif] = ACTIONS(11976),
    [anon_sym_else] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__assignment_operator] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4361] = {
    [sym_identifier] = STATE(4735),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_elseif] = ACTIONS(12002),
    [anon_sym_else] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__assignment_operator] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4362] = {
    [sym_identifier] = STATE(4753),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_elseif] = ACTIONS(12006),
    [anon_sym_else] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__assignment_operator] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4363] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_elseif] = ACTIONS(11984),
    [anon_sym_else] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__assignment_operator] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4364] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12010),
    [sym__immediate_command_start] = ACTIONS(12012),
  },
  [4365] = {
    [sym_do_clause] = STATE(5491),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12000),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4366] = {
    [sym_do_clause] = STATE(5534),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_catch] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12000),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_DASH_GT] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4367] = {
    [sym_do_clause] = STATE(5550),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12000),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4368] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_RPAREN] = ACTIONS(171),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(171),
    [anon_sym_RBRACK] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(171),
    [anon_sym_RBRACE] = ACTIONS(171),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(171),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_DASH_GT] = ACTIONS(12014),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(171),
    [aux_sym_integer_literal_token2] = ACTIONS(171),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(171),
    [aux_sym_float_literal_token3] = ACTIONS(171),
    [aux_sym_float_literal_token4] = ACTIONS(171),
    [sym_character_literal] = ACTIONS(171),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(171),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(171),
    [sym__lazy_and_operator] = ACTIONS(171),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(171),
    [sym__pipe_left_operator] = ACTIONS(171),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(171),
    [sym__type_order_operator] = ACTIONS(171),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12016),
    [sym__immediate_command_start] = ACTIONS(12018),
  },
  [4369] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_else] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_finally] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4370] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_else] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_finally] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4371] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_else] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_finally] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_DASH_GT] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4372] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_else] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_finally] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_DASH_GT] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4373] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_else] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_finally] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_DASH_GT] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4374] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_else] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_finally] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4375] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_else] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_finally] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_DASH_GT] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4376] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_else] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_finally] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_DASH_GT] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4377] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_else] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_finally] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_DASH_GT] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4378] = {
    [ts_builtin_sym_end] = ACTIONS(12044),
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_RBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4379] = {
    [ts_builtin_sym_end] = ACTIONS(12044),
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_RBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4380] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_else] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_DASH_GT] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4381] = {
    [ts_builtin_sym_end] = ACTIONS(12052),
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_RBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [4382] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11940),
    [sym__immediate_command_start] = ACTIONS(11942),
  },
  [4383] = {
    [ts_builtin_sym_end] = ACTIONS(12056),
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_RBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [4384] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_elseif] = ACTIONS(12020),
    [anon_sym_else] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__assignment_operator] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4385] = {
    [ts_builtin_sym_end] = ACTIONS(12060),
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_RBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4386] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_elseif] = ACTIONS(11980),
    [anon_sym_else] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__assignment_operator] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4387] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_elseif] = ACTIONS(11988),
    [anon_sym_else] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__assignment_operator] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4388] = {
    [ts_builtin_sym_end] = ACTIONS(12064),
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_RBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [4389] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_elseif] = ACTIONS(11996),
    [anon_sym_else] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__assignment_operator] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4390] = {
    [ts_builtin_sym_end] = ACTIONS(11978),
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_RPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_RBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__assignment_operator] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4391] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_elseif] = ACTIONS(12024),
    [anon_sym_else] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__assignment_operator] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4392] = {
    [ts_builtin_sym_end] = ACTIONS(12068),
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_RBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [4393] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_elseif] = ACTIONS(12028),
    [anon_sym_else] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__assignment_operator] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4394] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_elseif] = ACTIONS(12032),
    [anon_sym_else] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__assignment_operator] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4395] = {
    [ts_builtin_sym_end] = ACTIONS(11986),
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_RPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_RBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__assignment_operator] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4396] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_elseif] = ACTIONS(12036),
    [anon_sym_else] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__assignment_operator] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4397] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_elseif] = ACTIONS(12040),
    [anon_sym_else] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__assignment_operator] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4398] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_elseif] = ACTIONS(12048),
    [anon_sym_else] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__assignment_operator] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4399] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_elseif] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(12072),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11872),
    [sym__immediate_command_start] = ACTIONS(11874),
  },
  [4400] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4401] = {
    [sym_do_clause] = STATE(5207),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_finally] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12074),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_DASH_GT] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4402] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12076),
    [sym__immediate_command_start] = ACTIONS(12078),
  },
  [4403] = {
    [sym_do_clause] = STATE(5225),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12074),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4404] = {
    [sym_do_clause] = STATE(5306),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_finally] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12074),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_DASH_GT] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4405] = {
    [sym_do_clause] = STATE(5398),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12074),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4406] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11890),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11890),
    [anon_sym_RPAREN] = ACTIONS(11890),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11890),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11890),
    [anon_sym_RBRACE] = ACTIONS(11890),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11890),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11890),
    [anon_sym_QMARK] = ACTIONS(11890),
    [anon_sym_AT] = ACTIONS(11890),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11890),
    [aux_sym_integer_literal_token2] = ACTIONS(11890),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11890),
    [aux_sym_float_literal_token3] = ACTIONS(11890),
    [aux_sym_float_literal_token4] = ACTIONS(11890),
    [sym_character_literal] = ACTIONS(11890),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11890),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11890),
    [sym__lazy_and_operator] = ACTIONS(11890),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11890),
    [sym__pipe_left_operator] = ACTIONS(11890),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11890),
    [sym__type_order_operator] = ACTIONS(11890),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12016),
    [sym__immediate_command_start] = ACTIONS(12018),
  },
  [4407] = {
    [ts_builtin_sym_end] = ACTIONS(12022),
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_RPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_RBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__assignment_operator] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4408] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4409] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4410] = {
    [sym_do_clause] = STATE(5875),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11898),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11898),
    [anon_sym_RPAREN] = ACTIONS(11898),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11898),
    [anon_sym_RBRACK] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_SEMI] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11898),
    [anon_sym_RBRACE] = ACTIONS(11898),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12080),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11898),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11898),
    [anon_sym_QMARK] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11898),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11898),
    [aux_sym_integer_literal_token2] = ACTIONS(11898),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11898),
    [aux_sym_float_literal_token3] = ACTIONS(11898),
    [aux_sym_float_literal_token4] = ACTIONS(11898),
    [sym_character_literal] = ACTIONS(11898),
    [sym__assignment_operator] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11898),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11898),
    [sym__lazy_and_operator] = ACTIONS(11898),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11898),
    [sym__pipe_left_operator] = ACTIONS(11898),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11898),
    [sym__type_order_operator] = ACTIONS(11898),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4411] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11930),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11930),
    [anon_sym_RPAREN] = ACTIONS(11930),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11930),
    [anon_sym_RBRACK] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11930),
    [anon_sym_LBRACE] = ACTIONS(11930),
    [anon_sym_RBRACE] = ACTIONS(11930),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11930),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11930),
    [anon_sym_QMARK] = ACTIONS(11930),
    [anon_sym_AT] = ACTIONS(11930),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11930),
    [aux_sym_integer_literal_token2] = ACTIONS(11930),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11930),
    [aux_sym_float_literal_token3] = ACTIONS(11930),
    [aux_sym_float_literal_token4] = ACTIONS(11930),
    [sym_character_literal] = ACTIONS(11930),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11930),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11930),
    [sym__lazy_and_operator] = ACTIONS(11930),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11930),
    [sym__pipe_left_operator] = ACTIONS(11930),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11930),
    [sym__type_order_operator] = ACTIONS(11930),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12016),
    [sym__immediate_command_start] = ACTIONS(12018),
  },
  [4412] = {
    [sym_do_clause] = STATE(5878),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11934),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11934),
    [anon_sym_RPAREN] = ACTIONS(11934),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11934),
    [anon_sym_RBRACK] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11934),
    [anon_sym_LBRACE] = ACTIONS(11934),
    [anon_sym_RBRACE] = ACTIONS(11934),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12080),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11934),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11934),
    [anon_sym_QMARK] = ACTIONS(11934),
    [anon_sym_AT] = ACTIONS(11934),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11934),
    [aux_sym_integer_literal_token2] = ACTIONS(11934),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11934),
    [aux_sym_float_literal_token3] = ACTIONS(11934),
    [aux_sym_float_literal_token4] = ACTIONS(11934),
    [sym_character_literal] = ACTIONS(11934),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11934),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11934),
    [sym__lazy_and_operator] = ACTIONS(11934),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11934),
    [sym__pipe_left_operator] = ACTIONS(11934),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11934),
    [sym__type_order_operator] = ACTIONS(11934),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4413] = {
    [sym_identifier] = STATE(5167),
    [ts_builtin_sym_end] = ACTIONS(11994),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_RPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_RBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__assignment_operator] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4414] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11940),
    [sym__immediate_command_start] = ACTIONS(11942),
  },
  [4415] = {
    [ts_builtin_sym_end] = ACTIONS(11982),
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_RPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_RBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__assignment_operator] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4416] = {
    [ts_builtin_sym_end] = ACTIONS(11990),
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_RPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_RBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__assignment_operator] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4417] = {
    [ts_builtin_sym_end] = ACTIONS(11998),
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_RPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_RBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__assignment_operator] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4418] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [4419] = {
    [sym_do_clause] = STATE(5932),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11904),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11904),
    [anon_sym_RPAREN] = ACTIONS(11904),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11904),
    [anon_sym_RBRACK] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_SEMI] = ACTIONS(11904),
    [anon_sym_LBRACE] = ACTIONS(11904),
    [anon_sym_RBRACE] = ACTIONS(11904),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12080),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11904),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11904),
    [anon_sym_QMARK] = ACTIONS(11904),
    [anon_sym_AT] = ACTIONS(11904),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11904),
    [aux_sym_integer_literal_token2] = ACTIONS(11904),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11904),
    [aux_sym_float_literal_token3] = ACTIONS(11904),
    [aux_sym_float_literal_token4] = ACTIONS(11904),
    [sym_character_literal] = ACTIONS(11904),
    [sym__assignment_operator] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11904),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11904),
    [sym__lazy_and_operator] = ACTIONS(11904),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11904),
    [sym__pipe_left_operator] = ACTIONS(11904),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11904),
    [sym__type_order_operator] = ACTIONS(11904),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4420] = {
    [sym_identifier] = STATE(4576),
    [ts_builtin_sym_end] = ACTIONS(12004),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_RPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_RBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__assignment_operator] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4421] = {
    [sym_identifier] = STATE(4582),
    [ts_builtin_sym_end] = ACTIONS(12008),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_RPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_RBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__assignment_operator] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4422] = {
    [ts_builtin_sym_end] = ACTIONS(12026),
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_RPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_RBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__assignment_operator] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4423] = {
    [ts_builtin_sym_end] = ACTIONS(12030),
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_RPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_RBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__assignment_operator] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4424] = {
    [ts_builtin_sym_end] = ACTIONS(12034),
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_RPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_RBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__assignment_operator] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4425] = {
    [sym_do_clause] = STATE(5958),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11914),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11914),
    [anon_sym_RPAREN] = ACTIONS(11914),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11914),
    [anon_sym_RBRACK] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11914),
    [anon_sym_LBRACE] = ACTIONS(11914),
    [anon_sym_RBRACE] = ACTIONS(11914),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12080),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11914),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11914),
    [anon_sym_QMARK] = ACTIONS(11914),
    [anon_sym_AT] = ACTIONS(11914),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11914),
    [aux_sym_integer_literal_token2] = ACTIONS(11914),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11914),
    [aux_sym_float_literal_token3] = ACTIONS(11914),
    [aux_sym_float_literal_token4] = ACTIONS(11914),
    [sym_character_literal] = ACTIONS(11914),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11914),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11914),
    [sym__lazy_and_operator] = ACTIONS(11914),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11914),
    [sym__pipe_left_operator] = ACTIONS(11914),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11914),
    [sym__type_order_operator] = ACTIONS(11914),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4426] = {
    [ts_builtin_sym_end] = ACTIONS(12038),
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_RPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_RBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__assignment_operator] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4427] = {
    [ts_builtin_sym_end] = ACTIONS(12042),
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_RPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_RBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__assignment_operator] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4428] = {
    [ts_builtin_sym_end] = ACTIONS(12050),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_RPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_RBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__assignment_operator] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4429] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_elseif] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12082),
    [sym__immediate_command_start] = ACTIONS(12084),
  },
  [4430] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [4431] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4432] = {
    [sym_do_clause] = STATE(5313),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_elseif] = ACTIONS(11896),
    [anon_sym_else] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12086),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4433] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_elseif] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12082),
    [sym__immediate_command_start] = ACTIONS(12084),
  },
  [4434] = {
    [sym_do_clause] = STATE(5317),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_elseif] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12086),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4435] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12010),
    [sym__immediate_command_start] = ACTIONS(12012),
  },
  [4436] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [4437] = {
    [sym_do_clause] = STATE(5348),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_elseif] = ACTIONS(11902),
    [anon_sym_else] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12086),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4438] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [4439] = {
    [sym_do_clause] = STATE(5369),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_elseif] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12086),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4440] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11948),
    [sym__immediate_command_start] = ACTIONS(11950),
  },
  [4441] = {
    [sym_do_clause] = STATE(5583),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_catch] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(11974),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__assignment_operator] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4442] = {
    [sym_do_clause] = STATE(5546),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_catch] = ACTIONS(11896),
    [anon_sym_finally] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12088),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__assignment_operator] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4443] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11948),
    [sym__immediate_command_start] = ACTIONS(11950),
  },
  [4444] = {
    [sym_do_clause] = STATE(5557),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12088),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4445] = {
    [sym_do_clause] = STATE(5574),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_catch] = ACTIONS(11902),
    [anon_sym_finally] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12088),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__assignment_operator] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4446] = {
    [sym_do_clause] = STATE(5595),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12088),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4447] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11894),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11894),
    [anon_sym_RPAREN] = ACTIONS(11894),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11894),
    [anon_sym_RBRACK] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11894),
    [anon_sym_RBRACE] = ACTIONS(11894),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11894),
    [anon_sym_COLON_COLON] = ACTIONS(11894),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11894),
    [anon_sym_QMARK] = ACTIONS(11894),
    [anon_sym_DASH_GT] = ACTIONS(11894),
    [anon_sym_AT] = ACTIONS(11894),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11894),
    [aux_sym_integer_literal_token2] = ACTIONS(11894),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11894),
    [aux_sym_float_literal_token3] = ACTIONS(11894),
    [aux_sym_float_literal_token4] = ACTIONS(11894),
    [sym_character_literal] = ACTIONS(11894),
    [sym__pair_operator] = ACTIONS(11894),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11894),
    [sym__lazy_and_operator] = ACTIONS(11894),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11894),
    [sym__pipe_left_operator] = ACTIONS(11894),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11894),
    [sym__bitshift_operator] = ACTIONS(11894),
    [sym__power_operator] = ACTIONS(11894),
    [sym__tilde_operator] = ACTIONS(11894),
    [sym__type_order_operator] = ACTIONS(11894),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12090),
    [sym__immediate_command_start] = ACTIONS(12092),
  },
  [4448] = {
    [sym_identifier] = STATE(5063),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_elseif] = ACTIONS(11992),
    [anon_sym_else] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_DASH_GT] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4449] = {
    [sym_identifier] = STATE(5065),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_elseif] = ACTIONS(11958),
    [anon_sym_else] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_DASH_GT] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4450] = {
    [sym_identifier] = STATE(5081),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_elseif] = ACTIONS(12002),
    [anon_sym_else] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_DASH_GT] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4451] = {
    [sym_identifier] = STATE(5082),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_elseif] = ACTIONS(12006),
    [anon_sym_else] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_DASH_GT] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4452] = {
    [ts_builtin_sym_end] = ACTIONS(11864),
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4453] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11960),
    [sym__immediate_command_start] = ACTIONS(11962),
  },
  [4454] = {
    [sym_identifier] = STATE(5121),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_else] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__assignment_operator] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4455] = {
    [sym_identifier] = STATE(5122),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_else] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__assignment_operator] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4456] = {
    [sym_identifier] = STATE(5136),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_else] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__assignment_operator] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4457] = {
    [sym_identifier] = STATE(5137),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_else] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__assignment_operator] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4458] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12098),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4459] = {
    [ts_builtin_sym_end] = ACTIONS(11890),
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_RBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(11970),
    [sym__immediate_command_start] = ACTIONS(11972),
  },
  [4460] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12100),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4461] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11924),
    [sym__immediate_command_start] = ACTIONS(11926),
  },
  [4462] = {
    [sym_do_clause] = STATE(5193),
    [ts_builtin_sym_end] = ACTIONS(11898),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_RPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_RBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12102),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4463] = {
    [ts_builtin_sym_end] = ACTIONS(11930),
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_RBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11970),
    [sym__immediate_command_start] = ACTIONS(11972),
  },
  [4464] = {
    [sym_do_clause] = STATE(5937),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12104),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4465] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_RPAREN] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_RBRACE] = ACTIONS(11864),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11864),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11864),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11864),
    [sym__pipe_left_operator] = ACTIONS(11864),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11864),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4466] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11966),
    [sym__immediate_command_start] = ACTIONS(11968),
  },
  [4467] = {
    [sym_do_clause] = STATE(5226),
    [ts_builtin_sym_end] = ACTIONS(11904),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_RPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_RBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12102),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4468] = {
    [sym_do_clause] = STATE(5246),
    [ts_builtin_sym_end] = ACTIONS(11914),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_RBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12102),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4469] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12076),
    [sym__immediate_command_start] = ACTIONS(12078),
  },
  [4470] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(12106),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12108),
    [sym__immediate_command_start] = ACTIONS(12110),
  },
  [4471] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12010),
    [sym__immediate_command_start] = ACTIONS(12012),
  },
  [4472] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12112),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4473] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12114),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4474] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11894),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11894),
    [anon_sym_RPAREN] = ACTIONS(11894),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11894),
    [anon_sym_RBRACK] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11894),
    [anon_sym_RBRACE] = ACTIONS(11894),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11894),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11894),
    [anon_sym_QMARK] = ACTIONS(11894),
    [anon_sym_AT] = ACTIONS(11894),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11894),
    [aux_sym_integer_literal_token2] = ACTIONS(11894),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11894),
    [aux_sym_float_literal_token3] = ACTIONS(11894),
    [aux_sym_float_literal_token4] = ACTIONS(11894),
    [sym_character_literal] = ACTIONS(11894),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11894),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11894),
    [sym__lazy_and_operator] = ACTIONS(11894),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11894),
    [sym__pipe_left_operator] = ACTIONS(11894),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11894),
    [sym__type_order_operator] = ACTIONS(11894),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12016),
    [sym__immediate_command_start] = ACTIONS(12018),
  },
  [4475] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4476] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12076),
    [sym__immediate_command_start] = ACTIONS(12078),
  },
  [4477] = {
    [sym_identifier] = STATE(4631),
    [ts_builtin_sym_end] = ACTIONS(11994),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_RPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_RBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_DASH_GT] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4478] = {
    [sym_identifier] = STATE(4632),
    [ts_builtin_sym_end] = ACTIONS(11956),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_RPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_RBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_DASH_GT] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4479] = {
    [sym_identifier] = STATE(4640),
    [ts_builtin_sym_end] = ACTIONS(12004),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_RPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_RBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_DASH_GT] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4480] = {
    [sym_identifier] = STATE(4641),
    [ts_builtin_sym_end] = ACTIONS(12008),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_RPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_RBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_DASH_GT] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4481] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12116),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4482] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_RPAREN] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_RBRACE] = ACTIONS(11864),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11864),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11864),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_DASH_GT] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11864),
    [sym__pipe_left_operator] = ACTIONS(11864),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11864),
    [sym__bitshift_operator] = ACTIONS(11864),
    [sym__power_operator] = ACTIONS(11864),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11864),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4483] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_RPAREN] = ACTIONS(171),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(171),
    [anon_sym_RBRACK] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(171),
    [anon_sym_LBRACE] = ACTIONS(171),
    [anon_sym_RBRACE] = ACTIONS(171),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(171),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(171),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_DASH_GT] = ACTIONS(171),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(171),
    [aux_sym_integer_literal_token2] = ACTIONS(171),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(171),
    [aux_sym_float_literal_token3] = ACTIONS(171),
    [aux_sym_float_literal_token4] = ACTIONS(171),
    [sym_character_literal] = ACTIONS(171),
    [sym__pair_operator] = ACTIONS(171),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(171),
    [sym__lazy_and_operator] = ACTIONS(171),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(171),
    [sym__pipe_left_operator] = ACTIONS(171),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(171),
    [sym__bitshift_operator] = ACTIONS(171),
    [sym__power_operator] = ACTIONS(171),
    [sym__tilde_operator] = ACTIONS(171),
    [sym__type_order_operator] = ACTIONS(171),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12090),
    [sym__immediate_command_start] = ACTIONS(12092),
  },
  [4484] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_else] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_finally] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__assignment_operator] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4485] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4486] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4487] = {
    [sym_identifier] = STATE(4796),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_else] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_DASH_GT] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4488] = {
    [sym_identifier] = STATE(4797),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_else] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_DASH_GT] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4489] = {
    [sym_identifier] = STATE(4805),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_else] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_DASH_GT] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4490] = {
    [sym_identifier] = STATE(4806),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_else] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_DASH_GT] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4491] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4492] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4493] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4494] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_elseif] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12082),
    [sym__immediate_command_start] = ACTIONS(12084),
  },
  [4495] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11960),
    [sym__immediate_command_start] = ACTIONS(11962),
  },
  [4496] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4497] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4498] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_elseif] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12082),
    [sym__immediate_command_start] = ACTIONS(12084),
  },
  [4499] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_else] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_finally] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__assignment_operator] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4500] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_else] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_finally] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__assignment_operator] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4501] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_else] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_finally] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__assignment_operator] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4502] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_else] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_finally] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__assignment_operator] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4503] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_else] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_finally] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__assignment_operator] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4504] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_else] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_finally] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__assignment_operator] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4505] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_else] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_finally] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__assignment_operator] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4506] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_else] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_finally] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__assignment_operator] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4507] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_else] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__assignment_operator] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4508] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_elseif] = ACTIONS(12024),
    [anon_sym_else] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_DASH_GT] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4509] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_elseif] = ACTIONS(12028),
    [anon_sym_else] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4510] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_elseif] = ACTIONS(12032),
    [anon_sym_else] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_DASH_GT] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4511] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12118),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4512] = {
    [sym_do_clause] = STATE(5589),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(11974),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4513] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_elseif] = ACTIONS(12036),
    [anon_sym_else] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_DASH_GT] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4514] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_elseif] = ACTIONS(12040),
    [anon_sym_else] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_DASH_GT] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4515] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_elseif] = ACTIONS(12048),
    [anon_sym_else] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_DASH_GT] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4516] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_elseif] = ACTIONS(12020),
    [anon_sym_else] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4517] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11948),
    [sym__immediate_command_start] = ACTIONS(11950),
  },
  [4518] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_elseif] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [4519] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_elseif] = ACTIONS(11976),
    [anon_sym_else] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4520] = {
    [ts_builtin_sym_end] = ACTIONS(11894),
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_RBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(11970),
    [sym__immediate_command_start] = ACTIONS(11972),
  },
  [4521] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12076),
    [sym__immediate_command_start] = ACTIONS(12078),
  },
  [4522] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12010),
    [sym__immediate_command_start] = ACTIONS(12012),
  },
  [4523] = {
    [ts_builtin_sym_end] = ACTIONS(11978),
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_RPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_RBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4524] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_elseif] = ACTIONS(11984),
    [anon_sym_else] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4525] = {
    [ts_builtin_sym_end] = ACTIONS(11986),
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_RPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_RBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4526] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(12120),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12122),
    [sym__immediate_command_start] = ACTIONS(12124),
  },
  [4527] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_elseif] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4528] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_elseif] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4529] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_elseif] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4530] = {
    [sym_do_clause] = STATE(5717),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11898),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11898),
    [anon_sym_RPAREN] = ACTIONS(11898),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11898),
    [anon_sym_RBRACK] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_SEMI] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11898),
    [anon_sym_RBRACE] = ACTIONS(11898),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12126),
    [anon_sym_DOLLAR] = ACTIONS(11898),
    [anon_sym_COLON_COLON] = ACTIONS(11898),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11898),
    [anon_sym_QMARK] = ACTIONS(11898),
    [anon_sym_DASH_GT] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11898),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11898),
    [aux_sym_integer_literal_token2] = ACTIONS(11898),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11898),
    [aux_sym_float_literal_token3] = ACTIONS(11898),
    [aux_sym_float_literal_token4] = ACTIONS(11898),
    [sym_character_literal] = ACTIONS(11898),
    [sym__pair_operator] = ACTIONS(11898),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11898),
    [sym__lazy_and_operator] = ACTIONS(11898),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11898),
    [sym__pipe_left_operator] = ACTIONS(11898),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11898),
    [sym__bitshift_operator] = ACTIONS(11898),
    [sym__power_operator] = ACTIONS(11898),
    [sym__tilde_operator] = ACTIONS(11898),
    [sym__type_order_operator] = ACTIONS(11898),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4531] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11930),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11930),
    [anon_sym_RPAREN] = ACTIONS(11930),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11930),
    [anon_sym_RBRACK] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11930),
    [anon_sym_LBRACE] = ACTIONS(11930),
    [anon_sym_RBRACE] = ACTIONS(11930),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11930),
    [anon_sym_COLON_COLON] = ACTIONS(11930),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11930),
    [anon_sym_QMARK] = ACTIONS(11930),
    [anon_sym_DASH_GT] = ACTIONS(11930),
    [anon_sym_AT] = ACTIONS(11930),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11930),
    [aux_sym_integer_literal_token2] = ACTIONS(11930),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11930),
    [aux_sym_float_literal_token3] = ACTIONS(11930),
    [aux_sym_float_literal_token4] = ACTIONS(11930),
    [sym_character_literal] = ACTIONS(11930),
    [sym__pair_operator] = ACTIONS(11930),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11930),
    [sym__lazy_and_operator] = ACTIONS(11930),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11930),
    [sym__pipe_left_operator] = ACTIONS(11930),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11930),
    [sym__bitshift_operator] = ACTIONS(11930),
    [sym__power_operator] = ACTIONS(11930),
    [sym__tilde_operator] = ACTIONS(11930),
    [sym__type_order_operator] = ACTIONS(11930),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12090),
    [sym__immediate_command_start] = ACTIONS(12092),
  },
  [4532] = {
    [sym_do_clause] = STATE(5719),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11934),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11934),
    [anon_sym_RPAREN] = ACTIONS(11934),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11934),
    [anon_sym_RBRACK] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11934),
    [anon_sym_LBRACE] = ACTIONS(11934),
    [anon_sym_RBRACE] = ACTIONS(11934),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12126),
    [anon_sym_DOLLAR] = ACTIONS(11934),
    [anon_sym_COLON_COLON] = ACTIONS(11934),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11934),
    [anon_sym_QMARK] = ACTIONS(11934),
    [anon_sym_DASH_GT] = ACTIONS(11934),
    [anon_sym_AT] = ACTIONS(11934),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11934),
    [aux_sym_integer_literal_token2] = ACTIONS(11934),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11934),
    [aux_sym_float_literal_token3] = ACTIONS(11934),
    [aux_sym_float_literal_token4] = ACTIONS(11934),
    [sym_character_literal] = ACTIONS(11934),
    [sym__pair_operator] = ACTIONS(11934),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11934),
    [sym__lazy_and_operator] = ACTIONS(11934),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11934),
    [sym__pipe_left_operator] = ACTIONS(11934),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11934),
    [sym__bitshift_operator] = ACTIONS(11934),
    [sym__power_operator] = ACTIONS(11934),
    [sym__tilde_operator] = ACTIONS(11934),
    [sym__type_order_operator] = ACTIONS(11934),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4533] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_RPAREN] = ACTIONS(171),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(171),
    [anon_sym_RBRACK] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(171),
    [anon_sym_RBRACE] = ACTIONS(171),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(171),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_DASH_GT] = ACTIONS(12128),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(171),
    [aux_sym_integer_literal_token2] = ACTIONS(171),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(171),
    [aux_sym_float_literal_token3] = ACTIONS(171),
    [aux_sym_float_literal_token4] = ACTIONS(171),
    [sym_character_literal] = ACTIONS(171),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(171),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(171),
    [sym__lazy_and_operator] = ACTIONS(171),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(171),
    [sym__pipe_left_operator] = ACTIONS(171),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(171),
    [sym__type_order_operator] = ACTIONS(171),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12016),
    [sym__immediate_command_start] = ACTIONS(12018),
  },
  [4534] = {
    [sym_do_clause] = STATE(5725),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11904),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11904),
    [anon_sym_RPAREN] = ACTIONS(11904),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11904),
    [anon_sym_RBRACK] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_SEMI] = ACTIONS(11904),
    [anon_sym_LBRACE] = ACTIONS(11904),
    [anon_sym_RBRACE] = ACTIONS(11904),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12126),
    [anon_sym_DOLLAR] = ACTIONS(11904),
    [anon_sym_COLON_COLON] = ACTIONS(11904),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11904),
    [anon_sym_QMARK] = ACTIONS(11904),
    [anon_sym_DASH_GT] = ACTIONS(11904),
    [anon_sym_AT] = ACTIONS(11904),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11904),
    [aux_sym_integer_literal_token2] = ACTIONS(11904),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11904),
    [aux_sym_float_literal_token3] = ACTIONS(11904),
    [aux_sym_float_literal_token4] = ACTIONS(11904),
    [sym_character_literal] = ACTIONS(11904),
    [sym__pair_operator] = ACTIONS(11904),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11904),
    [sym__lazy_and_operator] = ACTIONS(11904),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11904),
    [sym__pipe_left_operator] = ACTIONS(11904),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11904),
    [sym__bitshift_operator] = ACTIONS(11904),
    [sym__power_operator] = ACTIONS(11904),
    [sym__tilde_operator] = ACTIONS(11904),
    [sym__type_order_operator] = ACTIONS(11904),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4535] = {
    [sym_do_clause] = STATE(5734),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11914),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11914),
    [anon_sym_RPAREN] = ACTIONS(11914),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11914),
    [anon_sym_RBRACK] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11914),
    [anon_sym_LBRACE] = ACTIONS(11914),
    [anon_sym_RBRACE] = ACTIONS(11914),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12126),
    [anon_sym_DOLLAR] = ACTIONS(11914),
    [anon_sym_COLON_COLON] = ACTIONS(11914),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11914),
    [anon_sym_QMARK] = ACTIONS(11914),
    [anon_sym_DASH_GT] = ACTIONS(11914),
    [anon_sym_AT] = ACTIONS(11914),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11914),
    [aux_sym_integer_literal_token2] = ACTIONS(11914),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11914),
    [aux_sym_float_literal_token3] = ACTIONS(11914),
    [aux_sym_float_literal_token4] = ACTIONS(11914),
    [sym_character_literal] = ACTIONS(11914),
    [sym__pair_operator] = ACTIONS(11914),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11914),
    [sym__lazy_and_operator] = ACTIONS(11914),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11914),
    [sym__pipe_left_operator] = ACTIONS(11914),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11914),
    [sym__bitshift_operator] = ACTIONS(11914),
    [sym__power_operator] = ACTIONS(11914),
    [sym__tilde_operator] = ACTIONS(11914),
    [sym__type_order_operator] = ACTIONS(11914),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4536] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(12130),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12108),
    [sym__immediate_command_start] = ACTIONS(12110),
  },
  [4537] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11940),
    [sym__immediate_command_start] = ACTIONS(11942),
  },
  [4538] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_elseif] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [4539] = {
    [ts_builtin_sym_end] = ACTIONS(12022),
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_RPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_RBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4540] = {
    [sym_do_clause] = STATE(5776),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_else] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_finally] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12132),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4541] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11960),
    [sym__immediate_command_start] = ACTIONS(11962),
  },
  [4542] = {
    [sym_do_clause] = STATE(5778),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12132),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4543] = {
    [ts_builtin_sym_end] = ACTIONS(11982),
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_RPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_RBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4544] = {
    [ts_builtin_sym_end] = ACTIONS(11990),
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_RPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_RBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_DASH_GT] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4545] = {
    [ts_builtin_sym_end] = ACTIONS(11998),
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_RPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_RBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_DASH_GT] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4546] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_elseif] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [4547] = {
    [sym_do_clause] = STATE(5798),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_else] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_finally] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12132),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4548] = {
    [ts_builtin_sym_end] = ACTIONS(12026),
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_RPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_RBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_DASH_GT] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4549] = {
    [ts_builtin_sym_end] = ACTIONS(12030),
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_RPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_RBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4550] = {
    [ts_builtin_sym_end] = ACTIONS(12034),
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_RPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_RBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_DASH_GT] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4551] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(12134),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12122),
    [sym__immediate_command_start] = ACTIONS(12124),
  },
  [4552] = {
    [sym_do_clause] = STATE(5809),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12132),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4553] = {
    [ts_builtin_sym_end] = ACTIONS(12038),
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_RPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_RBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_DASH_GT] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4554] = {
    [ts_builtin_sym_end] = ACTIONS(12042),
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_RPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_RBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_DASH_GT] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4555] = {
    [ts_builtin_sym_end] = ACTIONS(12050),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_RPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_RBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_DASH_GT] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4556] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11890),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11890),
    [anon_sym_RPAREN] = ACTIONS(11890),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11890),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11890),
    [anon_sym_RBRACE] = ACTIONS(11890),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11890),
    [anon_sym_COLON_COLON] = ACTIONS(11890),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11890),
    [anon_sym_QMARK] = ACTIONS(11890),
    [anon_sym_DASH_GT] = ACTIONS(11890),
    [anon_sym_AT] = ACTIONS(11890),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11890),
    [aux_sym_integer_literal_token2] = ACTIONS(11890),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11890),
    [aux_sym_float_literal_token3] = ACTIONS(11890),
    [aux_sym_float_literal_token4] = ACTIONS(11890),
    [sym_character_literal] = ACTIONS(11890),
    [sym__pair_operator] = ACTIONS(11890),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11890),
    [sym__lazy_and_operator] = ACTIONS(11890),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11890),
    [sym__pipe_left_operator] = ACTIONS(11890),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11890),
    [sym__bitshift_operator] = ACTIONS(11890),
    [sym__power_operator] = ACTIONS(11890),
    [sym__tilde_operator] = ACTIONS(11890),
    [sym__type_order_operator] = ACTIONS(11890),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12090),
    [sym__immediate_command_start] = ACTIONS(12092),
  },
  [4557] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11966),
    [sym__immediate_command_start] = ACTIONS(11968),
  },
  [4558] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_elseif] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [4559] = {
    [sym_do_clause] = STATE(5895),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_catch] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(11974),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__assignment_operator] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4560] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_else] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_finally] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__assignment_operator] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4561] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_else] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_finally] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__assignment_operator] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4562] = {
    [sym_do_clause] = STATE(5942),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_finally] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12104),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__assignment_operator] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4563] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(11924),
    [sym__immediate_command_start] = ACTIONS(11926),
  },
  [4564] = {
    [sym_do_clause] = STATE(5945),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12104),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4565] = {
    [sym_do_clause] = STATE(5959),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_finally] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12104),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__assignment_operator] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4566] = {
    [sym_do_clause] = STATE(5197),
    [ts_builtin_sym_end] = ACTIONS(11934),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_RBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12102),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4567] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_else] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_finally] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_DASH_GT] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [4568] = {
    [ts_builtin_sym_end] = ACTIONS(12140),
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_RPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_RBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__assignment_operator] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [4569] = {
    [ts_builtin_sym_end] = ACTIONS(12144),
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_RPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_RBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__assignment_operator] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [4570] = {
    [ts_builtin_sym_end] = ACTIONS(12148),
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_RPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_RBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__assignment_operator] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [4571] = {
    [ts_builtin_sym_end] = ACTIONS(12152),
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_RPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_RBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__assignment_operator] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [4572] = {
    [ts_builtin_sym_end] = ACTIONS(12138),
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_RPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_RBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__assignment_operator] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [4573] = {
    [ts_builtin_sym_end] = ACTIONS(12060),
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_RBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4574] = {
    [ts_builtin_sym_end] = ACTIONS(12044),
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_RBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4575] = {
    [ts_builtin_sym_end] = ACTIONS(11914),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_RBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4576] = {
    [ts_builtin_sym_end] = ACTIONS(12156),
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_RPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_RBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__assignment_operator] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [4577] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_catch] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_DASH_GT] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4578] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_catch] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4579] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_catch] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_DASH_GT] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4580] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_catch] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_DASH_GT] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4581] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_catch] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_DASH_GT] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4582] = {
    [ts_builtin_sym_end] = ACTIONS(12160),
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_RPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_RBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__assignment_operator] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [4583] = {
    [ts_builtin_sym_end] = ACTIONS(12164),
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__assignment_operator] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [4584] = {
    [ts_builtin_sym_end] = ACTIONS(12168),
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_RPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_RBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__assignment_operator] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [4585] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_catch] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_DASH_GT] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4586] = {
    [ts_builtin_sym_end] = ACTIONS(12172),
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_RPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_RBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__assignment_operator] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [4587] = {
    [ts_builtin_sym_end] = ACTIONS(12176),
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_RPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_RBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__assignment_operator] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [4588] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4589] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12180),
    [anon_sym_DOT] = ACTIONS(12182),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12184),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__immediate_bracket] = ACTIONS(12188),
    [sym__immediate_brace] = ACTIONS(12190),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [4590] = {
    [sym_do_clause] = STATE(6406),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_RPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_SEMI] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12192),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__assignment_operator] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4591] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12108),
    [sym__immediate_command_start] = ACTIONS(12110),
  },
  [4592] = {
    [sym_do_clause] = STATE(6414),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12192),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4593] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12044),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12044),
    [anon_sym_RPAREN] = ACTIONS(12044),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12044),
    [anon_sym_RBRACK] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12044),
    [anon_sym_LBRACE] = ACTIONS(12044),
    [anon_sym_RBRACE] = ACTIONS(12044),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12044),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12044),
    [anon_sym_QMARK] = ACTIONS(12044),
    [anon_sym_DASH_GT] = ACTIONS(11986),
    [anon_sym_AT] = ACTIONS(12044),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12044),
    [aux_sym_integer_literal_token2] = ACTIONS(12044),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12044),
    [aux_sym_float_literal_token3] = ACTIONS(12044),
    [aux_sym_float_literal_token4] = ACTIONS(12044),
    [sym_character_literal] = ACTIONS(12044),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12044),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12044),
    [sym__lazy_and_operator] = ACTIONS(12044),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12044),
    [sym__pipe_left_operator] = ACTIONS(12044),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12044),
    [sym__type_order_operator] = ACTIONS(12044),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4594] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12044),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12044),
    [anon_sym_RPAREN] = ACTIONS(12044),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12044),
    [anon_sym_RBRACK] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12044),
    [anon_sym_LBRACE] = ACTIONS(12044),
    [anon_sym_RBRACE] = ACTIONS(12044),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12044),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12044),
    [anon_sym_QMARK] = ACTIONS(12044),
    [anon_sym_DASH_GT] = ACTIONS(12022),
    [anon_sym_AT] = ACTIONS(12044),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12044),
    [aux_sym_integer_literal_token2] = ACTIONS(12044),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12044),
    [aux_sym_float_literal_token3] = ACTIONS(12044),
    [aux_sym_float_literal_token4] = ACTIONS(12044),
    [sym_character_literal] = ACTIONS(12044),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12044),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12044),
    [sym__lazy_and_operator] = ACTIONS(12044),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12044),
    [sym__pipe_left_operator] = ACTIONS(12044),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12044),
    [sym__type_order_operator] = ACTIONS(12044),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4595] = {
    [sym_do_clause] = STATE(6459),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_RPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_SEMI] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12192),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__assignment_operator] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4596] = {
    [sym__word_identifier] = ACTIONS(12194),
    [anon_sym_EQ] = ACTIONS(12194),
    [anon_sym_COMMA] = ACTIONS(12194),
    [anon_sym_COLON] = ACTIONS(12194),
    [anon_sym_begin] = ACTIONS(12194),
    [anon_sym_module] = ACTIONS(12194),
    [anon_sym_baremodule] = ACTIONS(12194),
    [anon_sym_end] = ACTIONS(12194),
    [anon_sym_abstract] = ACTIONS(12194),
    [anon_sym_primitive] = ACTIONS(12194),
    [anon_sym_mutable] = ACTIONS(12194),
    [anon_sym_struct] = ACTIONS(12194),
    [anon_sym_function] = ACTIONS(12194),
    [anon_sym_macro] = ACTIONS(12194),
    [anon_sym_where] = ACTIONS(12194),
    [anon_sym_quote] = ACTIONS(12194),
    [anon_sym_let] = ACTIONS(12194),
    [anon_sym_if] = ACTIONS(12194),
    [anon_sym_elseif] = ACTIONS(12194),
    [anon_sym_else] = ACTIONS(12194),
    [anon_sym_try] = ACTIONS(12194),
    [anon_sym_for] = ACTIONS(12194),
    [anon_sym_while] = ACTIONS(12194),
    [sym_break_statement] = ACTIONS(12194),
    [sym_continue_statement] = ACTIONS(12194),
    [anon_sym_return] = ACTIONS(12194),
    [anon_sym_const] = ACTIONS(12194),
    [anon_sym_global] = ACTIONS(12194),
    [anon_sym_local] = ACTIONS(12194),
    [anon_sym_LPAREN] = ACTIONS(12194),
    [anon_sym_COLON2] = ACTIONS(12194),
    [anon_sym_export] = ACTIONS(12194),
    [anon_sym_import] = ACTIONS(12194),
    [anon_sym_using] = ACTIONS(12194),
    [anon_sym_LBRACK] = ACTIONS(12194),
    [anon_sym_LF] = ACTIONS(12196),
    [anon_sym_in] = ACTIONS(12194),
    [anon_sym_LBRACE] = ACTIONS(12194),
    [anon_sym_SQUOTE] = ACTIONS(12198),
    [anon_sym_DOT] = ACTIONS(12200),
    [anon_sym_DOLLAR] = ACTIONS(12194),
    [anon_sym_COLON_COLON] = ACTIONS(12194),
    [anon_sym_isa] = ACTIONS(12194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12194),
    [anon_sym_QMARK] = ACTIONS(12194),
    [anon_sym_DASH_GT] = ACTIONS(12194),
    [anon_sym_AT] = ACTIONS(12194),
    [anon_sym_true] = ACTIONS(12194),
    [anon_sym_false] = ACTIONS(12194),
    [aux_sym_integer_literal_token1] = ACTIONS(12194),
    [aux_sym_integer_literal_token2] = ACTIONS(12194),
    [aux_sym_integer_literal_token3] = ACTIONS(12194),
    [aux_sym_integer_literal_token4] = ACTIONS(12194),
    [aux_sym_float_literal_token1] = ACTIONS(12194),
    [aux_sym_float_literal_token3] = ACTIONS(12194),
    [aux_sym_float_literal_token4] = ACTIONS(12194),
    [sym_character_literal] = ACTIONS(12194),
    [sym__pair_operator] = ACTIONS(12194),
    [sym__arrow_operator] = ACTIONS(12194),
    [sym__lazy_or_operator] = ACTIONS(12194),
    [sym__lazy_and_operator] = ACTIONS(12194),
    [sym__comparison_operator] = ACTIONS(12194),
    [sym__pipe_right_operator] = ACTIONS(12194),
    [sym__pipe_left_operator] = ACTIONS(12194),
    [sym__ellipsis_operator] = ACTIONS(12194),
    [sym__plus_operator] = ACTIONS(12194),
    [sym__times_operator] = ACTIONS(12194),
    [sym__rational_operator] = ACTIONS(12194),
    [sym__bitshift_operator] = ACTIONS(12194),
    [sym__power_operator] = ACTIONS(12194),
    [sym__tilde_operator] = ACTIONS(12194),
    [sym__type_order_operator] = ACTIONS(12194),
    [sym__unary_operator] = ACTIONS(12194),
    [sym__unary_plus_operator] = ACTIONS(12194),
    [aux_sym__terminator_token1] = ACTIONS(12194),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12202),
    [sym__immediate_bracket] = ACTIONS(12204),
    [sym__immediate_brace] = ACTIONS(12206),
    [sym__string_start] = ACTIONS(12196),
    [sym__command_start] = ACTIONS(12196),
  },
  [4597] = {
    [ts_builtin_sym_end] = ACTIONS(12064),
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_RBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [4598] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_RPAREN] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_RBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_RBRACE] = ACTIONS(12052),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_DASH_GT] = ACTIONS(11982),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [4599] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_catch] = ACTIONS(11984),
    [anon_sym_finally] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4600] = {
    [ts_builtin_sym_end] = ACTIONS(12068),
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_RBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [4601] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12122),
    [sym__immediate_command_start] = ACTIONS(12124),
  },
  [4602] = {
    [ts_builtin_sym_end] = ACTIONS(12208),
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_RPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_RBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__assignment_operator] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [4603] = {
    [ts_builtin_sym_end] = ACTIONS(12212),
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_RPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_RBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__assignment_operator] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [4604] = {
    [ts_builtin_sym_end] = ACTIONS(12216),
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_RPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_RBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__assignment_operator] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [4605] = {
    [sym_do_clause] = STATE(6002),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12192),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4606] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12220),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12222),
    [anon_sym_DOT] = ACTIONS(12224),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12226),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12228),
    [sym__immediate_bracket] = ACTIONS(12230),
    [sym__immediate_brace] = ACTIONS(12232),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [4607] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12056),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12056),
    [anon_sym_RPAREN] = ACTIONS(12056),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12056),
    [anon_sym_RBRACK] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12056),
    [anon_sym_LBRACE] = ACTIONS(12056),
    [anon_sym_RBRACE] = ACTIONS(12056),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12056),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12056),
    [anon_sym_QMARK] = ACTIONS(12056),
    [anon_sym_DASH_GT] = ACTIONS(11978),
    [anon_sym_AT] = ACTIONS(12056),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12056),
    [aux_sym_integer_literal_token2] = ACTIONS(12056),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12056),
    [aux_sym_float_literal_token3] = ACTIONS(12056),
    [aux_sym_float_literal_token4] = ACTIONS(12056),
    [sym_character_literal] = ACTIONS(12056),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12056),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12056),
    [sym__lazy_and_operator] = ACTIONS(12056),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12056),
    [sym__pipe_left_operator] = ACTIONS(12056),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12056),
    [sym__type_order_operator] = ACTIONS(12056),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [4608] = {
    [ts_builtin_sym_end] = ACTIONS(12234),
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_RPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_RBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_DASH_GT] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [4609] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12122),
    [sym__immediate_command_start] = ACTIONS(12124),
  },
  [4610] = {
    [ts_builtin_sym_end] = ACTIONS(12238),
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_RPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_RBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_DASH_GT] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [4611] = {
    [ts_builtin_sym_end] = ACTIONS(12242),
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_RPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_RBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_DASH_GT] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [4612] = {
    [ts_builtin_sym_end] = ACTIONS(12246),
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_RPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_RBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_DASH_GT] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [4613] = {
    [ts_builtin_sym_end] = ACTIONS(12250),
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_RPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_RBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_DASH_GT] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [4614] = {
    [ts_builtin_sym_end] = ACTIONS(12254),
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_RPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_RBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_DASH_GT] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [4615] = {
    [ts_builtin_sym_end] = ACTIONS(12258),
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_RPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_RBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_DASH_GT] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [4616] = {
    [ts_builtin_sym_end] = ACTIONS(12064),
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_RBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [4617] = {
    [ts_builtin_sym_end] = ACTIONS(12052),
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_RBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [4618] = {
    [ts_builtin_sym_end] = ACTIONS(12262),
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_RPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_RBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_DASH_GT] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [4619] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12060),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12060),
    [anon_sym_RPAREN] = ACTIONS(12060),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12060),
    [anon_sym_RBRACK] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12060),
    [anon_sym_LBRACE] = ACTIONS(12060),
    [anon_sym_RBRACE] = ACTIONS(12060),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12060),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12060),
    [anon_sym_QMARK] = ACTIONS(12060),
    [anon_sym_DASH_GT] = ACTIONS(12022),
    [anon_sym_AT] = ACTIONS(12060),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12060),
    [aux_sym_integer_literal_token2] = ACTIONS(12060),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12060),
    [aux_sym_float_literal_token3] = ACTIONS(12060),
    [aux_sym_float_literal_token4] = ACTIONS(12060),
    [sym_character_literal] = ACTIONS(12060),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12060),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12060),
    [sym__lazy_and_operator] = ACTIONS(12060),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12060),
    [sym__pipe_left_operator] = ACTIONS(12060),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12060),
    [sym__type_order_operator] = ACTIONS(12060),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4620] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4621] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4622] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_elseif] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [4623] = {
    [ts_builtin_sym_end] = ACTIONS(12266),
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_RPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_RBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_DASH_GT] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [4624] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12064),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12064),
    [anon_sym_RPAREN] = ACTIONS(12064),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12064),
    [anon_sym_RBRACK] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12064),
    [anon_sym_LBRACE] = ACTIONS(12064),
    [anon_sym_RBRACE] = ACTIONS(12064),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12064),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12064),
    [anon_sym_QMARK] = ACTIONS(12064),
    [anon_sym_DASH_GT] = ACTIONS(11982),
    [anon_sym_AT] = ACTIONS(12064),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12064),
    [aux_sym_integer_literal_token2] = ACTIONS(12064),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12064),
    [aux_sym_float_literal_token3] = ACTIONS(12064),
    [aux_sym_float_literal_token4] = ACTIONS(12064),
    [sym_character_literal] = ACTIONS(12064),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12064),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12064),
    [sym__lazy_and_operator] = ACTIONS(12064),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12064),
    [sym__pipe_left_operator] = ACTIONS(12064),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12064),
    [sym__type_order_operator] = ACTIONS(12064),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [4625] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [4626] = {
    [ts_builtin_sym_end] = ACTIONS(12270),
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_RPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_RBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_DASH_GT] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [4627] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_finally] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4628] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_elseif] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4629] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_elseif] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4630] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12068),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12068),
    [anon_sym_RPAREN] = ACTIONS(12068),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12068),
    [anon_sym_RBRACK] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12068),
    [anon_sym_LBRACE] = ACTIONS(12068),
    [anon_sym_RBRACE] = ACTIONS(12068),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12068),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12068),
    [anon_sym_QMARK] = ACTIONS(12068),
    [anon_sym_DASH_GT] = ACTIONS(12030),
    [anon_sym_AT] = ACTIONS(12068),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12068),
    [aux_sym_integer_literal_token2] = ACTIONS(12068),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12068),
    [aux_sym_float_literal_token3] = ACTIONS(12068),
    [aux_sym_float_literal_token4] = ACTIONS(12068),
    [sym_character_literal] = ACTIONS(12068),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12068),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12068),
    [sym__lazy_and_operator] = ACTIONS(12068),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12068),
    [sym__pipe_left_operator] = ACTIONS(12068),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12068),
    [sym__type_order_operator] = ACTIONS(12068),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [4631] = {
    [ts_builtin_sym_end] = ACTIONS(12274),
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_RPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_RBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_DASH_GT] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [4632] = {
    [ts_builtin_sym_end] = ACTIONS(12278),
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_RPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_RBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_DASH_GT] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [4633] = {
    [ts_builtin_sym_end] = ACTIONS(12068),
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_RBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [4634] = {
    [ts_builtin_sym_end] = ACTIONS(12282),
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_RPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_RBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_DASH_GT] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [4635] = {
    [ts_builtin_sym_end] = ACTIONS(12140),
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_RPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_RBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_DASH_GT] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [4636] = {
    [ts_builtin_sym_end] = ACTIONS(12144),
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_RPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_RBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_DASH_GT] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [4637] = {
    [ts_builtin_sym_end] = ACTIONS(12148),
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_RPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_RBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_DASH_GT] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [4638] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_finally] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4639] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12286),
    [sym__immediate_command_start] = ACTIONS(12288),
  },
  [4640] = {
    [ts_builtin_sym_end] = ACTIONS(12156),
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_RPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_RBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_DASH_GT] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [4641] = {
    [ts_builtin_sym_end] = ACTIONS(12160),
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_RPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_RBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_DASH_GT] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [4642] = {
    [ts_builtin_sym_end] = ACTIONS(12208),
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_RPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_RBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_DASH_GT] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [4643] = {
    [ts_builtin_sym_end] = ACTIONS(12164),
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_DASH_GT] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [4644] = {
    [ts_builtin_sym_end] = ACTIONS(12168),
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_RPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_RBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_DASH_GT] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [4645] = {
    [ts_builtin_sym_end] = ACTIONS(12176),
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_RPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_RBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_DASH_GT] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [4646] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_finally] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__assignment_operator] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4647] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [4648] = {
    [ts_builtin_sym_end] = ACTIONS(12290),
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_RPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_RBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_DASH_GT] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [4649] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12294),
    [sym__immediate_command_start] = ACTIONS(12296),
  },
  [4650] = {
    [ts_builtin_sym_end] = ACTIONS(12298),
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_RPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_RBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_DASH_GT] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [4651] = {
    [ts_builtin_sym_end] = ACTIONS(12302),
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_RPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_RBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_DASH_GT] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [4652] = {
    [ts_builtin_sym_end] = ACTIONS(12306),
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_RPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_RBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__assignment_operator] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [4653] = {
    [ts_builtin_sym_end] = ACTIONS(12152),
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_RPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_RBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_DASH_GT] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [4654] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_finally] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__assignment_operator] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4655] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4656] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_finally] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__assignment_operator] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4657] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_finally] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__assignment_operator] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4658] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12310),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4659] = {
    [sym__word_identifier] = ACTIONS(12194),
    [anon_sym_EQ] = ACTIONS(12194),
    [anon_sym_COMMA] = ACTIONS(12194),
    [anon_sym_COLON] = ACTIONS(12194),
    [anon_sym_begin] = ACTIONS(12194),
    [anon_sym_module] = ACTIONS(12194),
    [anon_sym_baremodule] = ACTIONS(12194),
    [anon_sym_end] = ACTIONS(12194),
    [anon_sym_abstract] = ACTIONS(12194),
    [anon_sym_primitive] = ACTIONS(12194),
    [anon_sym_mutable] = ACTIONS(12194),
    [anon_sym_struct] = ACTIONS(12194),
    [anon_sym_function] = ACTIONS(12194),
    [anon_sym_macro] = ACTIONS(12194),
    [anon_sym_where] = ACTIONS(12194),
    [anon_sym_quote] = ACTIONS(12194),
    [anon_sym_let] = ACTIONS(12194),
    [anon_sym_if] = ACTIONS(12194),
    [anon_sym_else] = ACTIONS(12194),
    [anon_sym_try] = ACTIONS(12194),
    [anon_sym_finally] = ACTIONS(12194),
    [anon_sym_for] = ACTIONS(12194),
    [anon_sym_while] = ACTIONS(12194),
    [sym_break_statement] = ACTIONS(12194),
    [sym_continue_statement] = ACTIONS(12194),
    [anon_sym_return] = ACTIONS(12194),
    [anon_sym_const] = ACTIONS(12194),
    [anon_sym_global] = ACTIONS(12194),
    [anon_sym_local] = ACTIONS(12194),
    [anon_sym_LPAREN] = ACTIONS(12194),
    [anon_sym_COLON2] = ACTIONS(12194),
    [anon_sym_export] = ACTIONS(12194),
    [anon_sym_import] = ACTIONS(12194),
    [anon_sym_using] = ACTIONS(12194),
    [anon_sym_LBRACK] = ACTIONS(12194),
    [anon_sym_LF] = ACTIONS(12196),
    [anon_sym_in] = ACTIONS(12194),
    [anon_sym_LBRACE] = ACTIONS(12194),
    [anon_sym_SQUOTE] = ACTIONS(12312),
    [anon_sym_DOT] = ACTIONS(12314),
    [anon_sym_DOLLAR] = ACTIONS(12194),
    [anon_sym_COLON_COLON] = ACTIONS(12194),
    [anon_sym_isa] = ACTIONS(12194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12194),
    [anon_sym_QMARK] = ACTIONS(12194),
    [anon_sym_DASH_GT] = ACTIONS(12194),
    [anon_sym_AT] = ACTIONS(12194),
    [anon_sym_true] = ACTIONS(12194),
    [anon_sym_false] = ACTIONS(12194),
    [aux_sym_integer_literal_token1] = ACTIONS(12194),
    [aux_sym_integer_literal_token2] = ACTIONS(12194),
    [aux_sym_integer_literal_token3] = ACTIONS(12194),
    [aux_sym_integer_literal_token4] = ACTIONS(12194),
    [aux_sym_float_literal_token1] = ACTIONS(12194),
    [aux_sym_float_literal_token3] = ACTIONS(12194),
    [aux_sym_float_literal_token4] = ACTIONS(12194),
    [sym_character_literal] = ACTIONS(12194),
    [sym__pair_operator] = ACTIONS(12194),
    [sym__arrow_operator] = ACTIONS(12194),
    [sym__lazy_or_operator] = ACTIONS(12194),
    [sym__lazy_and_operator] = ACTIONS(12194),
    [sym__comparison_operator] = ACTIONS(12194),
    [sym__pipe_right_operator] = ACTIONS(12194),
    [sym__pipe_left_operator] = ACTIONS(12194),
    [sym__ellipsis_operator] = ACTIONS(12194),
    [sym__plus_operator] = ACTIONS(12194),
    [sym__times_operator] = ACTIONS(12194),
    [sym__rational_operator] = ACTIONS(12194),
    [sym__bitshift_operator] = ACTIONS(12194),
    [sym__power_operator] = ACTIONS(12194),
    [sym__tilde_operator] = ACTIONS(12194),
    [sym__type_order_operator] = ACTIONS(12194),
    [sym__unary_operator] = ACTIONS(12194),
    [sym__unary_plus_operator] = ACTIONS(12194),
    [aux_sym__terminator_token1] = ACTIONS(12194),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12316),
    [sym__immediate_bracket] = ACTIONS(12318),
    [sym__immediate_brace] = ACTIONS(12320),
    [sym__string_start] = ACTIONS(12196),
    [sym__command_start] = ACTIONS(12196),
  },
  [4660] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [4661] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_finally] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__assignment_operator] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4662] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_catch] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__assignment_operator] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4663] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_else] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_finally] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_DASH_GT] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [4664] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_finally] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__assignment_operator] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4665] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_elseif] = ACTIONS(12308),
    [anon_sym_else] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__assignment_operator] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [4666] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_else] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_DASH_GT] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [4667] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_finally] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__assignment_operator] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4668] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_finally] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4669] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_finally] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__assignment_operator] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4670] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_finally] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__assignment_operator] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4671] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [4672] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__assignment_operator] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4673] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [4674] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_else] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_finally] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_DASH_GT] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [4675] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [4676] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11894),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11894),
    [anon_sym_RPAREN] = ACTIONS(11894),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11894),
    [anon_sym_RBRACK] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11894),
    [anon_sym_RBRACE] = ACTIONS(11894),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11894),
    [anon_sym_COLON_COLON] = ACTIONS(11894),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11894),
    [anon_sym_QMARK] = ACTIONS(11894),
    [anon_sym_AT] = ACTIONS(11894),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11894),
    [aux_sym_integer_literal_token2] = ACTIONS(11894),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11894),
    [aux_sym_float_literal_token3] = ACTIONS(11894),
    [aux_sym_float_literal_token4] = ACTIONS(11894),
    [sym_character_literal] = ACTIONS(11894),
    [sym__pair_operator] = ACTIONS(11894),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11894),
    [sym__lazy_and_operator] = ACTIONS(11894),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11894),
    [sym__pipe_left_operator] = ACTIONS(11894),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11894),
    [sym__bitshift_operator] = ACTIONS(11894),
    [sym__power_operator] = ACTIONS(11894),
    [sym__tilde_operator] = ACTIONS(11894),
    [sym__type_order_operator] = ACTIONS(11894),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12330),
    [sym__immediate_command_start] = ACTIONS(12332),
  },
  [4677] = {
    [ts_builtin_sym_end] = ACTIONS(12306),
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_RPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_RBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_DASH_GT] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [4678] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_finally] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4679] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_finally] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_DASH_GT] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4680] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_finally] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_DASH_GT] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4681] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_catch] = ACTIONS(12020),
    [anon_sym_finally] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4682] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4683] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4684] = {
    [ts_builtin_sym_end] = ACTIONS(11894),
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_RBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [4685] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_RPAREN] = ACTIONS(171),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(171),
    [anon_sym_RBRACK] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(171),
    [anon_sym_LBRACE] = ACTIONS(171),
    [anon_sym_RBRACE] = ACTIONS(171),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(171),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(171),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(171),
    [aux_sym_integer_literal_token2] = ACTIONS(171),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(171),
    [aux_sym_float_literal_token3] = ACTIONS(171),
    [aux_sym_float_literal_token4] = ACTIONS(171),
    [sym_character_literal] = ACTIONS(171),
    [sym__pair_operator] = ACTIONS(171),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(171),
    [sym__lazy_and_operator] = ACTIONS(171),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(171),
    [sym__pipe_left_operator] = ACTIONS(171),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(171),
    [sym__bitshift_operator] = ACTIONS(171),
    [sym__power_operator] = ACTIONS(171),
    [sym__tilde_operator] = ACTIONS(171),
    [sym__type_order_operator] = ACTIONS(171),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12330),
    [sym__immediate_command_start] = ACTIONS(12332),
  },
  [4686] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_else] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_DASH_GT] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [4687] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_finally] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_DASH_GT] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4688] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_finally] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4689] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_finally] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_DASH_GT] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4690] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_finally] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_DASH_GT] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4691] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_finally] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_DASH_GT] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4692] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_else] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_finally] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_DASH_GT] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [4693] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4694] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4695] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_else] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_finally] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_DASH_GT] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [4696] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_DASH_GT] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4697] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [4698] = {
    [sym_identifier] = STATE(5198),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_catch] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__assignment_operator] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4699] = {
    [sym_identifier] = STATE(5199),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_catch] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__assignment_operator] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4700] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4701] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [4702] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11978),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11978),
    [anon_sym_RPAREN] = ACTIONS(11978),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11978),
    [anon_sym_RBRACK] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_SEMI] = ACTIONS(11978),
    [anon_sym_LBRACE] = ACTIONS(11978),
    [anon_sym_RBRACE] = ACTIONS(11978),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11978),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11978),
    [anon_sym_QMARK] = ACTIONS(11978),
    [anon_sym_AT] = ACTIONS(11978),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11978),
    [aux_sym_integer_literal_token2] = ACTIONS(11978),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11978),
    [aux_sym_float_literal_token3] = ACTIONS(11978),
    [aux_sym_float_literal_token4] = ACTIONS(11978),
    [sym_character_literal] = ACTIONS(11978),
    [sym__assignment_operator] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11978),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11978),
    [sym__lazy_and_operator] = ACTIONS(11978),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11978),
    [sym__pipe_left_operator] = ACTIONS(11978),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11978),
    [sym__type_order_operator] = ACTIONS(11978),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4703] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_catch] = ACTIONS(11980),
    [anon_sym_finally] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4704] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12346),
    [sym__immediate_command_start] = ACTIONS(12348),
  },
  [4705] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_catch] = ACTIONS(11988),
    [anon_sym_finally] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_DASH_GT] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4706] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11986),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11986),
    [anon_sym_RPAREN] = ACTIONS(11986),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11986),
    [anon_sym_RBRACK] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_SEMI] = ACTIONS(11986),
    [anon_sym_LBRACE] = ACTIONS(11986),
    [anon_sym_RBRACE] = ACTIONS(11986),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11986),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11986),
    [anon_sym_QMARK] = ACTIONS(11986),
    [anon_sym_AT] = ACTIONS(11986),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11986),
    [aux_sym_integer_literal_token2] = ACTIONS(11986),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11986),
    [aux_sym_float_literal_token3] = ACTIONS(11986),
    [aux_sym_float_literal_token4] = ACTIONS(11986),
    [sym_character_literal] = ACTIONS(11986),
    [sym__assignment_operator] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11986),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11986),
    [sym__lazy_and_operator] = ACTIONS(11986),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11986),
    [sym__pipe_left_operator] = ACTIONS(11986),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11986),
    [sym__type_order_operator] = ACTIONS(11986),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4707] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_catch] = ACTIONS(11996),
    [anon_sym_finally] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_DASH_GT] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4708] = {
    [sym_do_clause] = STATE(6441),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_RPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_SEMI] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12350),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_DASH_GT] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4709] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12352),
    [sym__immediate_command_start] = ACTIONS(12354),
  },
  [4710] = {
    [sym_do_clause] = STATE(6443),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12350),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4711] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_else] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4712] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [4713] = {
    [sym_do_clause] = STATE(6452),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_RPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_SEMI] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12350),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_DASH_GT] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4714] = {
    [sym_do_clause] = STATE(6461),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12350),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4715] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4716] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12356),
    [sym__immediate_command_start] = ACTIONS(12358),
  },
  [4717] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4718] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4719] = {
    [ts_builtin_sym_end] = ACTIONS(11894),
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_RBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [4720] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_else] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_finally] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_DASH_GT] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [4721] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_else] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_finally] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_DASH_GT] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [4722] = {
    [sym_do_clause] = STATE(6272),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12368),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__assignment_operator] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4723] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [4724] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [4725] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_elseif] = ACTIONS(11976),
    [anon_sym_else] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4726] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [4727] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_elseif] = ACTIONS(11984),
    [anon_sym_else] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4728] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_catch] = ACTIONS(12024),
    [anon_sym_finally] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_DASH_GT] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4729] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12370),
    [anon_sym_DOT] = ACTIONS(12372),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12374),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12376),
    [sym__immediate_bracket] = ACTIONS(12378),
    [sym__immediate_brace] = ACTIONS(12380),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [4730] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [4731] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12294),
    [sym__immediate_command_start] = ACTIONS(12296),
  },
  [4732] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_catch] = ACTIONS(12028),
    [anon_sym_finally] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4733] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_catch] = ACTIONS(12032),
    [anon_sym_finally] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_DASH_GT] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4734] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_RPAREN] = ACTIONS(171),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(171),
    [anon_sym_LBRACE] = ACTIONS(171),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(171),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_DASH_GT] = ACTIONS(12382),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(171),
    [aux_sym_integer_literal_token2] = ACTIONS(171),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(171),
    [aux_sym_float_literal_token3] = ACTIONS(171),
    [aux_sym_float_literal_token4] = ACTIONS(171),
    [sym_character_literal] = ACTIONS(171),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(171),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(171),
    [sym__lazy_and_operator] = ACTIONS(171),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(171),
    [sym__pipe_left_operator] = ACTIONS(171),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(171),
    [sym__type_order_operator] = ACTIONS(171),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12016),
    [sym__immediate_command_start] = ACTIONS(12018),
  },
  [4735] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_elseif] = ACTIONS(12158),
    [anon_sym_else] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__assignment_operator] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [4736] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12022),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12022),
    [anon_sym_RPAREN] = ACTIONS(12022),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12022),
    [anon_sym_RBRACK] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_SEMI] = ACTIONS(12022),
    [anon_sym_LBRACE] = ACTIONS(12022),
    [anon_sym_RBRACE] = ACTIONS(12022),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12022),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12022),
    [anon_sym_QMARK] = ACTIONS(12022),
    [anon_sym_AT] = ACTIONS(12022),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12022),
    [aux_sym_integer_literal_token2] = ACTIONS(12022),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12022),
    [aux_sym_float_literal_token3] = ACTIONS(12022),
    [aux_sym_float_literal_token4] = ACTIONS(12022),
    [sym_character_literal] = ACTIONS(12022),
    [sym__assignment_operator] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12022),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12022),
    [sym__lazy_and_operator] = ACTIONS(12022),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12022),
    [sym__pipe_left_operator] = ACTIONS(12022),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12022),
    [sym__type_order_operator] = ACTIONS(12022),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4737] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4738] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [4739] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11982),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11982),
    [anon_sym_RPAREN] = ACTIONS(11982),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11982),
    [anon_sym_RBRACK] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_SEMI] = ACTIONS(11982),
    [anon_sym_LBRACE] = ACTIONS(11982),
    [anon_sym_RBRACE] = ACTIONS(11982),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11982),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11982),
    [anon_sym_QMARK] = ACTIONS(11982),
    [anon_sym_AT] = ACTIONS(11982),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11982),
    [aux_sym_integer_literal_token2] = ACTIONS(11982),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11982),
    [aux_sym_float_literal_token3] = ACTIONS(11982),
    [aux_sym_float_literal_token4] = ACTIONS(11982),
    [sym_character_literal] = ACTIONS(11982),
    [sym__assignment_operator] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11982),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11982),
    [sym__lazy_and_operator] = ACTIONS(11982),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11982),
    [sym__pipe_left_operator] = ACTIONS(11982),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11982),
    [sym__type_order_operator] = ACTIONS(11982),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4740] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11990),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11990),
    [anon_sym_RPAREN] = ACTIONS(11990),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11990),
    [anon_sym_RBRACK] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_SEMI] = ACTIONS(11990),
    [anon_sym_LBRACE] = ACTIONS(11990),
    [anon_sym_RBRACE] = ACTIONS(11990),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11990),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11990),
    [anon_sym_QMARK] = ACTIONS(11990),
    [anon_sym_AT] = ACTIONS(11990),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11990),
    [aux_sym_integer_literal_token2] = ACTIONS(11990),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11990),
    [aux_sym_float_literal_token3] = ACTIONS(11990),
    [aux_sym_float_literal_token4] = ACTIONS(11990),
    [sym_character_literal] = ACTIONS(11990),
    [sym__assignment_operator] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11990),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11990),
    [sym__lazy_and_operator] = ACTIONS(11990),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11990),
    [sym__pipe_left_operator] = ACTIONS(11990),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11990),
    [sym__type_order_operator] = ACTIONS(11990),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4741] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [4742] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11998),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11998),
    [anon_sym_RPAREN] = ACTIONS(11998),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11998),
    [anon_sym_RBRACK] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_SEMI] = ACTIONS(11998),
    [anon_sym_LBRACE] = ACTIONS(11998),
    [anon_sym_RBRACE] = ACTIONS(11998),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11998),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11998),
    [anon_sym_QMARK] = ACTIONS(11998),
    [anon_sym_AT] = ACTIONS(11998),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11998),
    [aux_sym_integer_literal_token2] = ACTIONS(11998),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11998),
    [aux_sym_float_literal_token3] = ACTIONS(11998),
    [aux_sym_float_literal_token4] = ACTIONS(11998),
    [sym_character_literal] = ACTIONS(11998),
    [sym__assignment_operator] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11998),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11998),
    [sym__lazy_and_operator] = ACTIONS(11998),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11998),
    [sym__pipe_left_operator] = ACTIONS(11998),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11998),
    [sym__type_order_operator] = ACTIONS(11998),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4743] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_catch] = ACTIONS(11976),
    [anon_sym_finally] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__assignment_operator] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4744] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12122),
    [sym__immediate_command_start] = ACTIONS(12124),
  },
  [4745] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__assignment_operator] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [4746] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12026),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12026),
    [anon_sym_RPAREN] = ACTIONS(12026),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12026),
    [anon_sym_RBRACK] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_SEMI] = ACTIONS(12026),
    [anon_sym_LBRACE] = ACTIONS(12026),
    [anon_sym_RBRACE] = ACTIONS(12026),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12026),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12026),
    [anon_sym_QMARK] = ACTIONS(12026),
    [anon_sym_AT] = ACTIONS(12026),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12026),
    [aux_sym_integer_literal_token2] = ACTIONS(12026),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12026),
    [aux_sym_float_literal_token3] = ACTIONS(12026),
    [aux_sym_float_literal_token4] = ACTIONS(12026),
    [sym_character_literal] = ACTIONS(12026),
    [sym__assignment_operator] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12026),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12026),
    [sym__lazy_and_operator] = ACTIONS(12026),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12026),
    [sym__pipe_left_operator] = ACTIONS(12026),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12026),
    [sym__type_order_operator] = ACTIONS(12026),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4747] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [4748] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12030),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12030),
    [anon_sym_RPAREN] = ACTIONS(12030),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12030),
    [anon_sym_RBRACK] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_SEMI] = ACTIONS(12030),
    [anon_sym_LBRACE] = ACTIONS(12030),
    [anon_sym_RBRACE] = ACTIONS(12030),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12030),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12030),
    [anon_sym_QMARK] = ACTIONS(12030),
    [anon_sym_AT] = ACTIONS(12030),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12030),
    [aux_sym_integer_literal_token2] = ACTIONS(12030),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12030),
    [aux_sym_float_literal_token3] = ACTIONS(12030),
    [aux_sym_float_literal_token4] = ACTIONS(12030),
    [sym_character_literal] = ACTIONS(12030),
    [sym__assignment_operator] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12030),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12030),
    [sym__lazy_and_operator] = ACTIONS(12030),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12030),
    [sym__pipe_left_operator] = ACTIONS(12030),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12030),
    [sym__type_order_operator] = ACTIONS(12030),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4749] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4750] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12034),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12034),
    [anon_sym_RPAREN] = ACTIONS(12034),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12034),
    [anon_sym_RBRACK] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_SEMI] = ACTIONS(12034),
    [anon_sym_LBRACE] = ACTIONS(12034),
    [anon_sym_RBRACE] = ACTIONS(12034),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12034),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12034),
    [anon_sym_QMARK] = ACTIONS(12034),
    [anon_sym_AT] = ACTIONS(12034),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12034),
    [aux_sym_integer_literal_token2] = ACTIONS(12034),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12034),
    [aux_sym_float_literal_token3] = ACTIONS(12034),
    [aux_sym_float_literal_token4] = ACTIONS(12034),
    [sym_character_literal] = ACTIONS(12034),
    [sym__assignment_operator] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12034),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12034),
    [sym__lazy_and_operator] = ACTIONS(12034),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12034),
    [sym__pipe_left_operator] = ACTIONS(12034),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12034),
    [sym__type_order_operator] = ACTIONS(12034),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4751] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_elseif] = ACTIONS(12384),
    [anon_sym_else] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_DASH_GT] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [4752] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12108),
    [sym__immediate_command_start] = ACTIONS(12110),
  },
  [4753] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_elseif] = ACTIONS(12162),
    [anon_sym_else] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__assignment_operator] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [4754] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_catch] = ACTIONS(11984),
    [anon_sym_finally] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__assignment_operator] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4755] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_elseif] = ACTIONS(12388),
    [anon_sym_else] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_DASH_GT] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [4756] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12038),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12038),
    [anon_sym_RPAREN] = ACTIONS(12038),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12038),
    [anon_sym_RBRACK] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_SEMI] = ACTIONS(12038),
    [anon_sym_LBRACE] = ACTIONS(12038),
    [anon_sym_RBRACE] = ACTIONS(12038),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12038),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12038),
    [anon_sym_QMARK] = ACTIONS(12038),
    [anon_sym_AT] = ACTIONS(12038),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12038),
    [aux_sym_integer_literal_token2] = ACTIONS(12038),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12038),
    [aux_sym_float_literal_token3] = ACTIONS(12038),
    [aux_sym_float_literal_token4] = ACTIONS(12038),
    [sym_character_literal] = ACTIONS(12038),
    [sym__assignment_operator] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12038),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12038),
    [sym__lazy_and_operator] = ACTIONS(12038),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12038),
    [sym__pipe_left_operator] = ACTIONS(12038),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12038),
    [sym__type_order_operator] = ACTIONS(12038),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4757] = {
    [sym_do_clause] = STATE(6274),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12368),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4758] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4759] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12042),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12042),
    [anon_sym_RPAREN] = ACTIONS(12042),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12042),
    [anon_sym_RBRACK] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_SEMI] = ACTIONS(12042),
    [anon_sym_LBRACE] = ACTIONS(12042),
    [anon_sym_RBRACE] = ACTIONS(12042),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12042),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12042),
    [anon_sym_QMARK] = ACTIONS(12042),
    [anon_sym_AT] = ACTIONS(12042),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12042),
    [aux_sym_integer_literal_token2] = ACTIONS(12042),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12042),
    [aux_sym_float_literal_token3] = ACTIONS(12042),
    [aux_sym_float_literal_token4] = ACTIONS(12042),
    [sym_character_literal] = ACTIONS(12042),
    [sym__assignment_operator] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12042),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12042),
    [sym__lazy_and_operator] = ACTIONS(12042),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12042),
    [sym__pipe_left_operator] = ACTIONS(12042),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12042),
    [sym__type_order_operator] = ACTIONS(12042),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4760] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_catch] = ACTIONS(12036),
    [anon_sym_finally] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_DASH_GT] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4761] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12050),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12050),
    [anon_sym_RPAREN] = ACTIONS(12050),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12050),
    [anon_sym_RBRACK] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_SEMI] = ACTIONS(12050),
    [anon_sym_LBRACE] = ACTIONS(12050),
    [anon_sym_RBRACE] = ACTIONS(12050),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12050),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12050),
    [anon_sym_QMARK] = ACTIONS(12050),
    [anon_sym_AT] = ACTIONS(12050),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12050),
    [aux_sym_integer_literal_token2] = ACTIONS(12050),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12050),
    [aux_sym_float_literal_token3] = ACTIONS(12050),
    [aux_sym_float_literal_token4] = ACTIONS(12050),
    [sym_character_literal] = ACTIONS(12050),
    [sym__assignment_operator] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12050),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12050),
    [sym__lazy_and_operator] = ACTIONS(12050),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12050),
    [sym__pipe_left_operator] = ACTIONS(12050),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12050),
    [sym__type_order_operator] = ACTIONS(12050),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4762] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_catch] = ACTIONS(12040),
    [anon_sym_finally] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_DASH_GT] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4763] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4764] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_else] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_finally] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_DASH_GT] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [4765] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_else] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__assignment_operator] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [4766] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_else] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__assignment_operator] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [4767] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_else] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_finally] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_DASH_GT] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [4768] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_catch] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_DASH_GT] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4769] = {
    [sym_identifier] = STATE(5947),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_catch] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__assignment_operator] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4770] = {
    [sym_identifier] = STATE(5948),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_catch] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__assignment_operator] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4771] = {
    [sym_identifier] = STATE(5355),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_catch] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__assignment_operator] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4772] = {
    [sym_identifier] = STATE(5412),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_catch] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__assignment_operator] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4773] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12392),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4774] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12286),
    [sym__immediate_command_start] = ACTIONS(12288),
  },
  [4775] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [4776] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4777] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4778] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_elseif] = ACTIONS(12020),
    [anon_sym_else] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4779] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_else] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_finally] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_DASH_GT] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [4780] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_elseif] = ACTIONS(11980),
    [anon_sym_else] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4781] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_elseif] = ACTIONS(11988),
    [anon_sym_else] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4782] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_elseif] = ACTIONS(11996),
    [anon_sym_else] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4783] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_else] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_DASH_GT] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [4784] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_else] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_DASH_GT] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [4785] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_else] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_DASH_GT] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [4786] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_else] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_DASH_GT] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [4787] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_else] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_DASH_GT] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [4788] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_else] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_DASH_GT] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [4789] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_else] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_DASH_GT] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [4790] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [4791] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [4792] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_else] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_DASH_GT] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [4793] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_else] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_DASH_GT] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [4794] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_elseif] = ACTIONS(12024),
    [anon_sym_else] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4795] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_else] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_DASH_GT] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [4796] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_else] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_DASH_GT] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [4797] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_else] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_DASH_GT] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [4798] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_elseif] = ACTIONS(12028),
    [anon_sym_else] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4799] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [4800] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_else] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_DASH_GT] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [4801] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_else] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_DASH_GT] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [4802] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_elseif] = ACTIONS(12032),
    [anon_sym_else] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4803] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_else] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_DASH_GT] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [4804] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_else] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_DASH_GT] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [4805] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_else] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_DASH_GT] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [4806] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_else] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_DASH_GT] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [4807] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_else] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_DASH_GT] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [4808] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_DASH_GT] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [4809] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_else] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_DASH_GT] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [4810] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_else] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_DASH_GT] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [4811] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12394),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4812] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_elseif] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [4813] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_elseif] = ACTIONS(12036),
    [anon_sym_else] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4814] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_elseif] = ACTIONS(12040),
    [anon_sym_else] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4815] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_elseif] = ACTIONS(12048),
    [anon_sym_else] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4816] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_else] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_DASH_GT] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [4817] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [4818] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_else] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_DASH_GT] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [4819] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_else] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_DASH_GT] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [4820] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12346),
    [sym__immediate_command_start] = ACTIONS(12348),
  },
  [4821] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_else] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_DASH_GT] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [4822] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_RPAREN] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_RBRACE] = ACTIONS(11864),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11864),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11864),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11864),
    [sym__pipe_left_operator] = ACTIONS(11864),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11864),
    [sym__bitshift_operator] = ACTIONS(11864),
    [sym__power_operator] = ACTIONS(11864),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11864),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4823] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4824] = {
    [ts_builtin_sym_end] = ACTIONS(12386),
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_RPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_RBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_DASH_GT] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [4825] = {
    [ts_builtin_sym_end] = ACTIONS(12390),
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_RPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_RBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_DASH_GT] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [4826] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_catch] = ACTIONS(12020),
    [anon_sym_finally] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__assignment_operator] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4827] = {
    [ts_builtin_sym_end] = ACTIONS(12056),
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_RBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [4828] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_catch] = ACTIONS(11980),
    [anon_sym_finally] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__assignment_operator] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4829] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_catch] = ACTIONS(11988),
    [anon_sym_finally] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__assignment_operator] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4830] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_catch] = ACTIONS(11996),
    [anon_sym_finally] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__assignment_operator] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4831] = {
    [ts_builtin_sym_end] = ACTIONS(12060),
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_RBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [4832] = {
    [ts_builtin_sym_end] = ACTIONS(12044),
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_RBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [4833] = {
    [ts_builtin_sym_end] = ACTIONS(11978),
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_RPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_RBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4834] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_catch] = ACTIONS(12024),
    [anon_sym_finally] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__assignment_operator] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4835] = {
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [4836] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_catch] = ACTIONS(12028),
    [anon_sym_finally] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__assignment_operator] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4837] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_catch] = ACTIONS(12032),
    [anon_sym_finally] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__assignment_operator] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4838] = {
    [ts_builtin_sym_end] = ACTIONS(11986),
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_RPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_RBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4839] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_catch] = ACTIONS(12036),
    [anon_sym_finally] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__assignment_operator] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4840] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_catch] = ACTIONS(12040),
    [anon_sym_finally] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__assignment_operator] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4841] = {
    [sym_identifier] = STATE(5235),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_catch] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__assignment_operator] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4842] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_catch] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__assignment_operator] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4843] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12356),
    [sym__immediate_command_start] = ACTIONS(12358),
  },
  [4844] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4845] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12370),
    [anon_sym_DOT] = ACTIONS(12372),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12374),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12376),
    [sym__immediate_bracket] = ACTIONS(12378),
    [sym__immediate_brace] = ACTIONS(12380),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [4846] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_elseif] = ACTIONS(12384),
    [anon_sym_else] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__assignment_operator] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [4847] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__assignment_operator] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [4848] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_elseif] = ACTIONS(12388),
    [anon_sym_else] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__assignment_operator] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [4849] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12096),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_DASH_GT] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12396),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12096),
    [sym__bitshift_operator] = ACTIONS(12096),
    [sym__power_operator] = ACTIONS(12096),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4850] = {
    [sym_identifier] = STATE(5237),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_catch] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__assignment_operator] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4851] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12352),
    [sym__immediate_command_start] = ACTIONS(12354),
  },
  [4852] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12108),
    [sym__immediate_command_start] = ACTIONS(12110),
  },
  [4853] = {
    [sym_identifier] = STATE(5558),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11994),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11994),
    [anon_sym_RPAREN] = ACTIONS(11994),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11994),
    [anon_sym_RBRACK] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_SEMI] = ACTIONS(11994),
    [anon_sym_LBRACE] = ACTIONS(11994),
    [anon_sym_RBRACE] = ACTIONS(11994),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11994),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11994),
    [anon_sym_QMARK] = ACTIONS(11994),
    [anon_sym_AT] = ACTIONS(11994),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11994),
    [aux_sym_integer_literal_token2] = ACTIONS(11994),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11994),
    [aux_sym_float_literal_token3] = ACTIONS(11994),
    [aux_sym_float_literal_token4] = ACTIONS(11994),
    [sym_character_literal] = ACTIONS(11994),
    [sym__assignment_operator] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11994),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11994),
    [sym__lazy_and_operator] = ACTIONS(11994),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11994),
    [sym__pipe_left_operator] = ACTIONS(11994),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11994),
    [sym__type_order_operator] = ACTIONS(11994),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4854] = {
    [sym_identifier] = STATE(5562),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11956),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11956),
    [anon_sym_RPAREN] = ACTIONS(11956),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11956),
    [anon_sym_RBRACK] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_SEMI] = ACTIONS(11956),
    [anon_sym_LBRACE] = ACTIONS(11956),
    [anon_sym_RBRACE] = ACTIONS(11956),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11956),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11956),
    [anon_sym_QMARK] = ACTIONS(11956),
    [anon_sym_AT] = ACTIONS(11956),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11956),
    [aux_sym_integer_literal_token2] = ACTIONS(11956),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11956),
    [aux_sym_float_literal_token3] = ACTIONS(11956),
    [aux_sym_float_literal_token4] = ACTIONS(11956),
    [sym_character_literal] = ACTIONS(11956),
    [sym__assignment_operator] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11956),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11956),
    [sym__lazy_and_operator] = ACTIONS(11956),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11956),
    [sym__pipe_left_operator] = ACTIONS(11956),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11956),
    [sym__type_order_operator] = ACTIONS(11956),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4855] = {
    [sym_identifier] = STATE(5580),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12004),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12004),
    [anon_sym_RPAREN] = ACTIONS(12004),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12004),
    [anon_sym_RBRACK] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_SEMI] = ACTIONS(12004),
    [anon_sym_LBRACE] = ACTIONS(12004),
    [anon_sym_RBRACE] = ACTIONS(12004),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12004),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12004),
    [anon_sym_QMARK] = ACTIONS(12004),
    [anon_sym_AT] = ACTIONS(12004),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12004),
    [aux_sym_integer_literal_token2] = ACTIONS(12004),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12004),
    [aux_sym_float_literal_token3] = ACTIONS(12004),
    [aux_sym_float_literal_token4] = ACTIONS(12004),
    [sym_character_literal] = ACTIONS(12004),
    [sym__assignment_operator] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12004),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12004),
    [sym__lazy_and_operator] = ACTIONS(12004),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12004),
    [sym__pipe_left_operator] = ACTIONS(12004),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12004),
    [sym__type_order_operator] = ACTIONS(12004),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4856] = {
    [sym_identifier] = STATE(5582),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12008),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12008),
    [anon_sym_RPAREN] = ACTIONS(12008),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12008),
    [anon_sym_RBRACK] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_SEMI] = ACTIONS(12008),
    [anon_sym_LBRACE] = ACTIONS(12008),
    [anon_sym_RBRACE] = ACTIONS(12008),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12008),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12008),
    [anon_sym_QMARK] = ACTIONS(12008),
    [anon_sym_AT] = ACTIONS(12008),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12008),
    [aux_sym_integer_literal_token2] = ACTIONS(12008),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12008),
    [aux_sym_float_literal_token3] = ACTIONS(12008),
    [aux_sym_float_literal_token4] = ACTIONS(12008),
    [sym_character_literal] = ACTIONS(12008),
    [sym__assignment_operator] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12008),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12008),
    [sym__lazy_and_operator] = ACTIONS(12008),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12008),
    [sym__pipe_left_operator] = ACTIONS(12008),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12008),
    [sym__type_order_operator] = ACTIONS(12008),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4857] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_elseif] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__assignment_operator] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [4858] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12398),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4859] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12180),
    [anon_sym_DOT] = ACTIONS(12182),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12184),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__immediate_bracket] = ACTIONS(12188),
    [sym__immediate_brace] = ACTIONS(12190),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [4860] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4861] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4862] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_else] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_DASH_GT] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [4863] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_else] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_DASH_GT] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [4864] = {
    [sym_do_clause] = STATE(6334),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12368),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__assignment_operator] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4865] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_elseif] = ACTIONS(12170),
    [anon_sym_else] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__assignment_operator] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [4866] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12400),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4867] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [4868] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12402),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4869] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12352),
    [sym__immediate_command_start] = ACTIONS(12354),
  },
  [4870] = {
    [ts_builtin_sym_end] = ACTIONS(12022),
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_RPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_RBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4871] = {
    [sym_identifier] = STATE(5766),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_elseif] = ACTIONS(11992),
    [anon_sym_else] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4872] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4873] = {
    [sym_identifier] = STATE(5769),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_elseif] = ACTIONS(11958),
    [anon_sym_else] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4874] = {
    [ts_builtin_sym_end] = ACTIONS(11982),
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_RPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_RBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4875] = {
    [ts_builtin_sym_end] = ACTIONS(11990),
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_RPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_RBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4876] = {
    [ts_builtin_sym_end] = ACTIONS(11998),
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_RPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_RBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4877] = {
    [sym_identifier] = STATE(5429),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11994),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11994),
    [anon_sym_RPAREN] = ACTIONS(11994),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11994),
    [anon_sym_RBRACK] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_SEMI] = ACTIONS(11994),
    [anon_sym_LBRACE] = ACTIONS(11994),
    [anon_sym_RBRACE] = ACTIONS(11994),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11994),
    [anon_sym_COLON_COLON] = ACTIONS(11994),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11994),
    [anon_sym_QMARK] = ACTIONS(11994),
    [anon_sym_DASH_GT] = ACTIONS(11994),
    [anon_sym_AT] = ACTIONS(11994),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11994),
    [aux_sym_integer_literal_token2] = ACTIONS(11994),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11994),
    [aux_sym_float_literal_token3] = ACTIONS(11994),
    [aux_sym_float_literal_token4] = ACTIONS(11994),
    [sym_character_literal] = ACTIONS(11994),
    [sym__pair_operator] = ACTIONS(11994),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11994),
    [sym__lazy_and_operator] = ACTIONS(11994),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11994),
    [sym__pipe_left_operator] = ACTIONS(11994),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11994),
    [sym__bitshift_operator] = ACTIONS(11994),
    [sym__power_operator] = ACTIONS(11994),
    [sym__tilde_operator] = ACTIONS(11994),
    [sym__type_order_operator] = ACTIONS(11994),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4878] = {
    [sym_identifier] = STATE(5430),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11956),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11956),
    [anon_sym_RPAREN] = ACTIONS(11956),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11956),
    [anon_sym_RBRACK] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_SEMI] = ACTIONS(11956),
    [anon_sym_LBRACE] = ACTIONS(11956),
    [anon_sym_RBRACE] = ACTIONS(11956),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11956),
    [anon_sym_COLON_COLON] = ACTIONS(11956),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11956),
    [anon_sym_QMARK] = ACTIONS(11956),
    [anon_sym_DASH_GT] = ACTIONS(11956),
    [anon_sym_AT] = ACTIONS(11956),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11956),
    [aux_sym_integer_literal_token2] = ACTIONS(11956),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11956),
    [aux_sym_float_literal_token3] = ACTIONS(11956),
    [aux_sym_float_literal_token4] = ACTIONS(11956),
    [sym_character_literal] = ACTIONS(11956),
    [sym__pair_operator] = ACTIONS(11956),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11956),
    [sym__lazy_and_operator] = ACTIONS(11956),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11956),
    [sym__pipe_left_operator] = ACTIONS(11956),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11956),
    [sym__bitshift_operator] = ACTIONS(11956),
    [sym__power_operator] = ACTIONS(11956),
    [sym__tilde_operator] = ACTIONS(11956),
    [sym__type_order_operator] = ACTIONS(11956),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4879] = {
    [sym_identifier] = STATE(5439),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12004),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12004),
    [anon_sym_RPAREN] = ACTIONS(12004),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12004),
    [anon_sym_RBRACK] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_SEMI] = ACTIONS(12004),
    [anon_sym_LBRACE] = ACTIONS(12004),
    [anon_sym_RBRACE] = ACTIONS(12004),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12004),
    [anon_sym_COLON_COLON] = ACTIONS(12004),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12004),
    [anon_sym_QMARK] = ACTIONS(12004),
    [anon_sym_DASH_GT] = ACTIONS(12004),
    [anon_sym_AT] = ACTIONS(12004),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12004),
    [aux_sym_integer_literal_token2] = ACTIONS(12004),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12004),
    [aux_sym_float_literal_token3] = ACTIONS(12004),
    [aux_sym_float_literal_token4] = ACTIONS(12004),
    [sym_character_literal] = ACTIONS(12004),
    [sym__pair_operator] = ACTIONS(12004),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12004),
    [sym__lazy_and_operator] = ACTIONS(12004),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12004),
    [sym__pipe_left_operator] = ACTIONS(12004),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12004),
    [sym__bitshift_operator] = ACTIONS(12004),
    [sym__power_operator] = ACTIONS(12004),
    [sym__tilde_operator] = ACTIONS(12004),
    [sym__type_order_operator] = ACTIONS(12004),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4880] = {
    [sym_identifier] = STATE(5440),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12008),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12008),
    [anon_sym_RPAREN] = ACTIONS(12008),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12008),
    [anon_sym_RBRACK] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_SEMI] = ACTIONS(12008),
    [anon_sym_LBRACE] = ACTIONS(12008),
    [anon_sym_RBRACE] = ACTIONS(12008),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12008),
    [anon_sym_COLON_COLON] = ACTIONS(12008),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12008),
    [anon_sym_QMARK] = ACTIONS(12008),
    [anon_sym_DASH_GT] = ACTIONS(12008),
    [anon_sym_AT] = ACTIONS(12008),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12008),
    [aux_sym_integer_literal_token2] = ACTIONS(12008),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12008),
    [aux_sym_float_literal_token3] = ACTIONS(12008),
    [aux_sym_float_literal_token4] = ACTIONS(12008),
    [sym_character_literal] = ACTIONS(12008),
    [sym__pair_operator] = ACTIONS(12008),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12008),
    [sym__lazy_and_operator] = ACTIONS(12008),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12008),
    [sym__pipe_left_operator] = ACTIONS(12008),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12008),
    [sym__bitshift_operator] = ACTIONS(12008),
    [sym__power_operator] = ACTIONS(12008),
    [sym__tilde_operator] = ACTIONS(12008),
    [sym__type_order_operator] = ACTIONS(12008),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4881] = {
    [sym_identifier] = STATE(5796),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_elseif] = ACTIONS(12002),
    [anon_sym_else] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4882] = {
    [sym_identifier] = STATE(5797),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_elseif] = ACTIONS(12006),
    [anon_sym_else] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4883] = {
    [ts_builtin_sym_end] = ACTIONS(12026),
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_RPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_RBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4884] = {
    [ts_builtin_sym_end] = ACTIONS(12030),
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_RPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_RBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4885] = {
    [ts_builtin_sym_end] = ACTIONS(12034),
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_RPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_RBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4886] = {
    [ts_builtin_sym_end] = ACTIONS(12038),
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_RPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_RBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4887] = {
    [ts_builtin_sym_end] = ACTIONS(12042),
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_RPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_RBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4888] = {
    [ts_builtin_sym_end] = ACTIONS(12050),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_RPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_RBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4889] = {
    [sym_do_clause] = STATE(6364),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12368),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4890] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12404),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4891] = {
    [sym_identifier] = STATE(5607),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_else] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4892] = {
    [sym_identifier] = STATE(5609),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_else] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4893] = {
    [sym_identifier] = STATE(5626),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_else] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4894] = {
    [sym_identifier] = STATE(5963),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_else] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4895] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_elseif] = ACTIONS(12214),
    [anon_sym_else] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__assignment_operator] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [4896] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_elseif] = ACTIONS(12174),
    [anon_sym_else] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__assignment_operator] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [4897] = {
    [sym_identifier] = STATE(5728),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__assignment_operator] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4898] = {
    [sym_identifier] = STATE(5739),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__assignment_operator] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4899] = {
    [sym_identifier] = STATE(5750),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__assignment_operator] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4900] = {
    [sym_identifier] = STATE(5752),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__assignment_operator] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4901] = {
    [sym_identifier] = STATE(5847),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_catch] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_DASH_GT] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4902] = {
    [sym_identifier] = STATE(5848),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_catch] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_DASH_GT] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4903] = {
    [sym_identifier] = STATE(5860),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_catch] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_DASH_GT] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4904] = {
    [sym_identifier] = STATE(5861),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_catch] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_DASH_GT] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4905] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4906] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12406),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4907] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_elseif] = ACTIONS(12218),
    [anon_sym_else] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__assignment_operator] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [4908] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_catch] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [4909] = {
    [sym_do_clause] = STATE(6208),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11898),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11898),
    [anon_sym_RPAREN] = ACTIONS(11898),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11898),
    [anon_sym_RBRACK] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_SEMI] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11898),
    [anon_sym_RBRACE] = ACTIONS(11898),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12408),
    [anon_sym_DOLLAR] = ACTIONS(11898),
    [anon_sym_COLON_COLON] = ACTIONS(11898),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11898),
    [anon_sym_QMARK] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11898),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11898),
    [aux_sym_integer_literal_token2] = ACTIONS(11898),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11898),
    [aux_sym_float_literal_token3] = ACTIONS(11898),
    [aux_sym_float_literal_token4] = ACTIONS(11898),
    [sym_character_literal] = ACTIONS(11898),
    [sym__pair_operator] = ACTIONS(11898),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11898),
    [sym__lazy_and_operator] = ACTIONS(11898),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11898),
    [sym__pipe_left_operator] = ACTIONS(11898),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11898),
    [sym__bitshift_operator] = ACTIONS(11898),
    [sym__power_operator] = ACTIONS(11898),
    [sym__tilde_operator] = ACTIONS(11898),
    [sym__type_order_operator] = ACTIONS(11898),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4910] = {
    [sym_identifier] = STATE(5281),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_catch] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_DASH_GT] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [4911] = {
    [sym_identifier] = STATE(5282),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_catch] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_DASH_GT] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4912] = {
    [sym_identifier] = STATE(5288),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_catch] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_DASH_GT] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4913] = {
    [sym_identifier] = STATE(5289),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_catch] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_DASH_GT] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4914] = {
    [sym__word_identifier] = ACTIONS(12194),
    [anon_sym_EQ] = ACTIONS(12410),
    [anon_sym_COMMA] = ACTIONS(12410),
    [anon_sym_COLON] = ACTIONS(12194),
    [anon_sym_begin] = ACTIONS(12194),
    [anon_sym_module] = ACTIONS(12194),
    [anon_sym_baremodule] = ACTIONS(12194),
    [anon_sym_end] = ACTIONS(12194),
    [anon_sym_abstract] = ACTIONS(12194),
    [anon_sym_primitive] = ACTIONS(12194),
    [anon_sym_mutable] = ACTIONS(12194),
    [anon_sym_struct] = ACTIONS(12194),
    [anon_sym_function] = ACTIONS(12194),
    [anon_sym_macro] = ACTIONS(12194),
    [anon_sym_where] = ACTIONS(12194),
    [anon_sym_quote] = ACTIONS(12194),
    [anon_sym_let] = ACTIONS(12194),
    [anon_sym_if] = ACTIONS(12194),
    [anon_sym_elseif] = ACTIONS(12194),
    [anon_sym_else] = ACTIONS(12194),
    [anon_sym_try] = ACTIONS(12194),
    [anon_sym_for] = ACTIONS(12194),
    [anon_sym_while] = ACTIONS(12194),
    [sym_break_statement] = ACTIONS(12194),
    [sym_continue_statement] = ACTIONS(12194),
    [anon_sym_return] = ACTIONS(12194),
    [anon_sym_const] = ACTIONS(12194),
    [anon_sym_global] = ACTIONS(12194),
    [anon_sym_local] = ACTIONS(12194),
    [anon_sym_LPAREN] = ACTIONS(12194),
    [anon_sym_COLON2] = ACTIONS(12194),
    [anon_sym_export] = ACTIONS(12194),
    [anon_sym_import] = ACTIONS(12194),
    [anon_sym_using] = ACTIONS(12194),
    [anon_sym_LBRACK] = ACTIONS(12194),
    [anon_sym_LF] = ACTIONS(12196),
    [anon_sym_in] = ACTIONS(12194),
    [anon_sym_LBRACE] = ACTIONS(12194),
    [anon_sym_SQUOTE] = ACTIONS(12198),
    [anon_sym_DOT] = ACTIONS(12200),
    [anon_sym_DOLLAR] = ACTIONS(12194),
    [anon_sym_COLON_COLON] = ACTIONS(12194),
    [anon_sym_isa] = ACTIONS(12194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12194),
    [anon_sym_QMARK] = ACTIONS(12194),
    [anon_sym_DASH_GT] = ACTIONS(12194),
    [anon_sym_AT] = ACTIONS(12194),
    [anon_sym_true] = ACTIONS(12194),
    [anon_sym_false] = ACTIONS(12194),
    [aux_sym_integer_literal_token1] = ACTIONS(12194),
    [aux_sym_integer_literal_token2] = ACTIONS(12194),
    [aux_sym_integer_literal_token3] = ACTIONS(12194),
    [aux_sym_integer_literal_token4] = ACTIONS(12194),
    [aux_sym_float_literal_token1] = ACTIONS(12194),
    [aux_sym_float_literal_token3] = ACTIONS(12194),
    [aux_sym_float_literal_token4] = ACTIONS(12194),
    [sym_character_literal] = ACTIONS(12194),
    [sym__pair_operator] = ACTIONS(12194),
    [sym__arrow_operator] = ACTIONS(12194),
    [sym__lazy_or_operator] = ACTIONS(12194),
    [sym__lazy_and_operator] = ACTIONS(12194),
    [sym__comparison_operator] = ACTIONS(12194),
    [sym__pipe_right_operator] = ACTIONS(12194),
    [sym__pipe_left_operator] = ACTIONS(12194),
    [sym__ellipsis_operator] = ACTIONS(12194),
    [sym__plus_operator] = ACTIONS(12194),
    [sym__times_operator] = ACTIONS(12194),
    [sym__rational_operator] = ACTIONS(12194),
    [sym__bitshift_operator] = ACTIONS(12194),
    [sym__power_operator] = ACTIONS(12194),
    [sym__tilde_operator] = ACTIONS(12194),
    [sym__type_order_operator] = ACTIONS(12194),
    [sym__unary_operator] = ACTIONS(12194),
    [sym__unary_plus_operator] = ACTIONS(12194),
    [aux_sym__terminator_token1] = ACTIONS(12194),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12202),
    [sym__immediate_bracket] = ACTIONS(12204),
    [sym__immediate_brace] = ACTIONS(12206),
    [sym__string_start] = ACTIONS(12196),
    [sym__command_start] = ACTIONS(12196),
  },
  [4915] = {
    [ts_builtin_sym_end] = ACTIONS(12282),
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_RPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_RBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__assignment_operator] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [4916] = {
    [sym_identifier] = STATE(5373),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_DASH_GT] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [4917] = {
    [sym_identifier] = STATE(5379),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_DASH_GT] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [4918] = {
    [sym_identifier] = STATE(5380),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_DASH_GT] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [4919] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_catch] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4920] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11890),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11890),
    [anon_sym_RPAREN] = ACTIONS(11890),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11890),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11890),
    [anon_sym_RBRACE] = ACTIONS(11890),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11890),
    [anon_sym_COLON_COLON] = ACTIONS(11890),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11890),
    [anon_sym_QMARK] = ACTIONS(11890),
    [anon_sym_AT] = ACTIONS(11890),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11890),
    [aux_sym_integer_literal_token2] = ACTIONS(11890),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11890),
    [aux_sym_float_literal_token3] = ACTIONS(11890),
    [aux_sym_float_literal_token4] = ACTIONS(11890),
    [sym_character_literal] = ACTIONS(11890),
    [sym__pair_operator] = ACTIONS(11890),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11890),
    [sym__lazy_and_operator] = ACTIONS(11890),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11890),
    [sym__pipe_left_operator] = ACTIONS(11890),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11890),
    [sym__bitshift_operator] = ACTIONS(11890),
    [sym__power_operator] = ACTIONS(11890),
    [sym__tilde_operator] = ACTIONS(11890),
    [sym__type_order_operator] = ACTIONS(11890),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12330),
    [sym__immediate_command_start] = ACTIONS(12332),
  },
  [4921] = {
    [ts_builtin_sym_end] = ACTIONS(12328),
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_RPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_RBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__assignment_operator] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [4922] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4923] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__assignment_operator] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4924] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_DASH_GT] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [4925] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12294),
    [sym__immediate_command_start] = ACTIONS(12296),
  },
  [4926] = {
    [sym_do_clause] = STATE(6244),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12412),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4927] = {
    [sym_do_clause] = STATE(6253),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_catch] = ACTIONS(11902),
    [anon_sym_finally] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12412),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4928] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12414),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4929] = {
    [sym_do_clause] = STATE(6257),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12412),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4930] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11930),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11930),
    [anon_sym_RPAREN] = ACTIONS(11930),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11930),
    [anon_sym_RBRACK] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11930),
    [anon_sym_LBRACE] = ACTIONS(11930),
    [anon_sym_RBRACE] = ACTIONS(11930),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11930),
    [anon_sym_COLON_COLON] = ACTIONS(11930),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11930),
    [anon_sym_QMARK] = ACTIONS(11930),
    [anon_sym_AT] = ACTIONS(11930),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11930),
    [aux_sym_integer_literal_token2] = ACTIONS(11930),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11930),
    [aux_sym_float_literal_token3] = ACTIONS(11930),
    [aux_sym_float_literal_token4] = ACTIONS(11930),
    [sym_character_literal] = ACTIONS(11930),
    [sym__pair_operator] = ACTIONS(11930),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11930),
    [sym__lazy_and_operator] = ACTIONS(11930),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11930),
    [sym__pipe_left_operator] = ACTIONS(11930),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11930),
    [sym__bitshift_operator] = ACTIONS(11930),
    [sym__power_operator] = ACTIONS(11930),
    [sym__tilde_operator] = ACTIONS(11930),
    [sym__type_order_operator] = ACTIONS(11930),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12330),
    [sym__immediate_command_start] = ACTIONS(12332),
  },
  [4931] = {
    [ts_builtin_sym_end] = ACTIONS(12234),
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_RPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_RBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__assignment_operator] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [4932] = {
    [ts_builtin_sym_end] = ACTIONS(12238),
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_RPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_RBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__assignment_operator] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [4933] = {
    [sym_do_clause] = STATE(6263),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11934),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11934),
    [anon_sym_RPAREN] = ACTIONS(11934),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11934),
    [anon_sym_RBRACK] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11934),
    [anon_sym_LBRACE] = ACTIONS(11934),
    [anon_sym_RBRACE] = ACTIONS(11934),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12408),
    [anon_sym_DOLLAR] = ACTIONS(11934),
    [anon_sym_COLON_COLON] = ACTIONS(11934),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11934),
    [anon_sym_QMARK] = ACTIONS(11934),
    [anon_sym_AT] = ACTIONS(11934),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11934),
    [aux_sym_integer_literal_token2] = ACTIONS(11934),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11934),
    [aux_sym_float_literal_token3] = ACTIONS(11934),
    [aux_sym_float_literal_token4] = ACTIONS(11934),
    [sym_character_literal] = ACTIONS(11934),
    [sym__pair_operator] = ACTIONS(11934),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11934),
    [sym__lazy_and_operator] = ACTIONS(11934),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11934),
    [sym__pipe_left_operator] = ACTIONS(11934),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11934),
    [sym__bitshift_operator] = ACTIONS(11934),
    [sym__power_operator] = ACTIONS(11934),
    [sym__tilde_operator] = ACTIONS(11934),
    [sym__type_order_operator] = ACTIONS(11934),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4934] = {
    [ts_builtin_sym_end] = ACTIONS(11890),
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_RBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [4935] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [4936] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_elseif] = ACTIONS(12360),
    [anon_sym_else] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_DASH_GT] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [4937] = {
    [sym_do_clause] = STATE(6267),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11904),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11904),
    [anon_sym_RPAREN] = ACTIONS(11904),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11904),
    [anon_sym_RBRACK] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_SEMI] = ACTIONS(11904),
    [anon_sym_LBRACE] = ACTIONS(11904),
    [anon_sym_RBRACE] = ACTIONS(11904),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12408),
    [anon_sym_DOLLAR] = ACTIONS(11904),
    [anon_sym_COLON_COLON] = ACTIONS(11904),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11904),
    [anon_sym_QMARK] = ACTIONS(11904),
    [anon_sym_AT] = ACTIONS(11904),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11904),
    [aux_sym_integer_literal_token2] = ACTIONS(11904),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11904),
    [aux_sym_float_literal_token3] = ACTIONS(11904),
    [aux_sym_float_literal_token4] = ACTIONS(11904),
    [sym_character_literal] = ACTIONS(11904),
    [sym__pair_operator] = ACTIONS(11904),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11904),
    [sym__lazy_and_operator] = ACTIONS(11904),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11904),
    [sym__pipe_left_operator] = ACTIONS(11904),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11904),
    [sym__bitshift_operator] = ACTIONS(11904),
    [sym__power_operator] = ACTIONS(11904),
    [sym__tilde_operator] = ACTIONS(11904),
    [sym__type_order_operator] = ACTIONS(11904),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4938] = {
    [ts_builtin_sym_end] = ACTIONS(12242),
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_RPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_RBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__assignment_operator] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [4939] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [4940] = {
    [ts_builtin_sym_end] = ACTIONS(12290),
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_RPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_RBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__assignment_operator] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [4941] = {
    [ts_builtin_sym_end] = ACTIONS(12386),
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_RPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_RBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__assignment_operator] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [4942] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_catch] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__assignment_operator] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [4943] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12356),
    [sym__immediate_command_start] = ACTIONS(12358),
  },
  [4944] = {
    [sym_do_clause] = STATE(6270),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11914),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11914),
    [anon_sym_RPAREN] = ACTIONS(11914),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11914),
    [anon_sym_RBRACK] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11914),
    [anon_sym_LBRACE] = ACTIONS(11914),
    [anon_sym_RBRACE] = ACTIONS(11914),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12408),
    [anon_sym_DOLLAR] = ACTIONS(11914),
    [anon_sym_COLON_COLON] = ACTIONS(11914),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11914),
    [anon_sym_QMARK] = ACTIONS(11914),
    [anon_sym_AT] = ACTIONS(11914),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11914),
    [aux_sym_integer_literal_token2] = ACTIONS(11914),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11914),
    [aux_sym_float_literal_token3] = ACTIONS(11914),
    [aux_sym_float_literal_token4] = ACTIONS(11914),
    [sym_character_literal] = ACTIONS(11914),
    [sym__pair_operator] = ACTIONS(11914),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11914),
    [sym__lazy_and_operator] = ACTIONS(11914),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11914),
    [sym__pipe_left_operator] = ACTIONS(11914),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11914),
    [sym__bitshift_operator] = ACTIONS(11914),
    [sym__power_operator] = ACTIONS(11914),
    [sym__tilde_operator] = ACTIONS(11914),
    [sym__type_order_operator] = ACTIONS(11914),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4945] = {
    [ts_builtin_sym_end] = ACTIONS(12390),
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_RPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_RBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__assignment_operator] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [4946] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_elseif] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [4947] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_elseif] = ACTIONS(12326),
    [anon_sym_else] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_DASH_GT] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [4948] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_elseif] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [4949] = {
    [sym_do_clause] = STATE(6068),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_finally] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12416),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4950] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12356),
    [sym__immediate_command_start] = ACTIONS(12358),
  },
  [4951] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12286),
    [sym__immediate_command_start] = ACTIONS(12288),
  },
  [4952] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12294),
    [sym__immediate_command_start] = ACTIONS(12296),
  },
  [4953] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12418),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12180),
    [anon_sym_DOT] = ACTIONS(12420),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12422),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__immediate_bracket] = ACTIONS(12188),
    [sym__immediate_brace] = ACTIONS(12190),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [4954] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_catch] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__assignment_operator] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [4955] = {
    [sym_do_clause] = STATE(6291),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12424),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_DASH_GT] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4956] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_catch] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__assignment_operator] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [4957] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_catch] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__assignment_operator] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [4958] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_catch] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__assignment_operator] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [4959] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_catch] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__assignment_operator] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [4960] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_catch] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__assignment_operator] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [4961] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_catch] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__assignment_operator] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [4962] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_elseif] = ACTIONS(12326),
    [anon_sym_else] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__assignment_operator] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [4963] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_catch] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__assignment_operator] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4964] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_catch] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__assignment_operator] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [4965] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_catch] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__assignment_operator] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [4966] = {
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__assignment_operator] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [4967] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12346),
    [sym__immediate_command_start] = ACTIONS(12348),
  },
  [4968] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_elseif] = ACTIONS(12322),
    [anon_sym_else] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_DASH_GT] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [4969] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_elseif] = ACTIONS(12236),
    [anon_sym_else] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__assignment_operator] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [4970] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_elseif] = ACTIONS(12338),
    [anon_sym_else] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_DASH_GT] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [4971] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_elseif] = ACTIONS(12240),
    [anon_sym_else] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__assignment_operator] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [4972] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_elseif] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [4973] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12346),
    [sym__immediate_command_start] = ACTIONS(12348),
  },
  [4974] = {
    [sym_do_clause] = STATE(6322),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12424),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4975] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_elseif] = ACTIONS(12342),
    [anon_sym_else] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_DASH_GT] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [4976] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_elseif] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [4977] = {
    [sym_do_clause] = STATE(6073),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12416),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4978] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_elseif] = ACTIONS(12244),
    [anon_sym_else] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__assignment_operator] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [4979] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_elseif] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4980] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_else] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_finally] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [4981] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_else] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_finally] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__assignment_operator] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [4982] = {
    [ts_builtin_sym_end] = ACTIONS(12362),
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_RPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_RBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_DASH_GT] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [4983] = {
    [sym_do_clause] = STATE(6333),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12424),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_DASH_GT] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4984] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_elseif] = ACTIONS(12364),
    [anon_sym_else] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_DASH_GT] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [4985] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_elseif] = ACTIONS(12292),
    [anon_sym_else] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__assignment_operator] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [4986] = {
    [sym_do_clause] = STATE(6343),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12424),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [4987] = {
    [ts_builtin_sym_end] = ACTIONS(12328),
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_RPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_RBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_DASH_GT] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [4988] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_elseif] = ACTIONS(12308),
    [anon_sym_else] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_DASH_GT] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [4989] = {
    [ts_builtin_sym_end] = ACTIONS(12340),
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_RPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_RBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_DASH_GT] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [4990] = {
    [ts_builtin_sym_end] = ACTIONS(12344),
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_RPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_RBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_DASH_GT] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [4991] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_RPAREN] = ACTIONS(171),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(171),
    [anon_sym_LBRACE] = ACTIONS(171),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(171),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_DASH_GT] = ACTIONS(12426),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(171),
    [aux_sym_integer_literal_token2] = ACTIONS(171),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(171),
    [aux_sym_float_literal_token3] = ACTIONS(171),
    [aux_sym_float_literal_token4] = ACTIONS(171),
    [sym_character_literal] = ACTIONS(171),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(171),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(171),
    [sym__lazy_and_operator] = ACTIONS(171),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(171),
    [sym__pipe_left_operator] = ACTIONS(171),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(171),
    [sym__type_order_operator] = ACTIONS(171),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12016),
    [sym__immediate_command_start] = ACTIONS(12018),
  },
  [4992] = {
    [ts_builtin_sym_end] = ACTIONS(11930),
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_RBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [4993] = {
    [ts_builtin_sym_end] = ACTIONS(11934),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_RBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [4994] = {
    [sym_do_clause] = STATE(6093),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_finally] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12416),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [4995] = {
    [sym_do_clause] = STATE(6464),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_catch] = ACTIONS(11896),
    [anon_sym_finally] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12412),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [4996] = {
    [ts_builtin_sym_end] = ACTIONS(12366),
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_RPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_RBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_DASH_GT] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [4997] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_elseif] = ACTIONS(12334),
    [anon_sym_else] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_DASH_GT] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [4998] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12222),
    [anon_sym_DOT] = ACTIONS(12428),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12430),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12228),
    [sym__immediate_bracket] = ACTIONS(12230),
    [sym__immediate_brace] = ACTIONS(12232),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [4999] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_elseif] = ACTIONS(12136),
    [anon_sym_else] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_DASH_GT] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5000] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_elseif] = ACTIONS(12210),
    [anon_sym_else] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__assignment_operator] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5001] = {
    [ts_builtin_sym_end] = ACTIONS(12138),
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_RPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_RBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_DASH_GT] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5002] = {
    [ts_builtin_sym_end] = ACTIONS(11914),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_RBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5003] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_elseif] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5004] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_else] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_finally] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [5005] = {
    [ts_builtin_sym_end] = ACTIONS(12212),
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_RPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_RBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_DASH_GT] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5006] = {
    [ts_builtin_sym_end] = ACTIONS(12172),
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_RPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_RBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_DASH_GT] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5007] = {
    [ts_builtin_sym_end] = ACTIONS(12216),
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_RPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_RBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_DASH_GT] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5008] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_elseif] = ACTIONS(12248),
    [anon_sym_else] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__assignment_operator] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5009] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_elseif] = ACTIONS(12252),
    [anon_sym_else] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__assignment_operator] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5010] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_elseif] = ACTIONS(12322),
    [anon_sym_else] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__assignment_operator] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5011] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_elseif] = ACTIONS(12214),
    [anon_sym_else] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_DASH_GT] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5012] = {
    [ts_builtin_sym_end] = ACTIONS(11890),
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_RBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5013] = {
    [sym_do_clause] = STATE(6193),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12416),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5014] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_else] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_finally] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__assignment_operator] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5015] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_elseif] = ACTIONS(12256),
    [anon_sym_else] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__assignment_operator] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5016] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_elseif] = ACTIONS(12260),
    [anon_sym_else] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__assignment_operator] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5017] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_elseif] = ACTIONS(12300),
    [anon_sym_else] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__assignment_operator] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5018] = {
    [ts_builtin_sym_end] = ACTIONS(12324),
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_RPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_DASH_GT] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5019] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_elseif] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5020] = {
    [ts_builtin_sym_end] = ACTIONS(12246),
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_RPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_RBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__assignment_operator] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5021] = {
    [ts_builtin_sym_end] = ACTIONS(12250),
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_RPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_RBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__assignment_operator] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5022] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_elseif] = ACTIONS(12174),
    [anon_sym_else] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_DASH_GT] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5023] = {
    [ts_builtin_sym_end] = ACTIONS(12324),
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_RPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__assignment_operator] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5024] = {
    [ts_builtin_sym_end] = ACTIONS(12196),
    [sym__word_identifier] = ACTIONS(12194),
    [anon_sym_EQ] = ACTIONS(12194),
    [anon_sym_COMMA] = ACTIONS(12194),
    [anon_sym_COLON] = ACTIONS(12194),
    [anon_sym_begin] = ACTIONS(12194),
    [anon_sym_module] = ACTIONS(12194),
    [anon_sym_baremodule] = ACTIONS(12194),
    [anon_sym_abstract] = ACTIONS(12194),
    [anon_sym_primitive] = ACTIONS(12194),
    [anon_sym_mutable] = ACTIONS(12194),
    [anon_sym_struct] = ACTIONS(12194),
    [anon_sym_function] = ACTIONS(12194),
    [anon_sym_macro] = ACTIONS(12194),
    [anon_sym_where] = ACTIONS(12194),
    [anon_sym_quote] = ACTIONS(12194),
    [anon_sym_let] = ACTIONS(12194),
    [anon_sym_if] = ACTIONS(12194),
    [anon_sym_try] = ACTIONS(12194),
    [anon_sym_for] = ACTIONS(12194),
    [anon_sym_while] = ACTIONS(12194),
    [sym_break_statement] = ACTIONS(12194),
    [sym_continue_statement] = ACTIONS(12194),
    [anon_sym_return] = ACTIONS(12194),
    [anon_sym_const] = ACTIONS(12194),
    [anon_sym_global] = ACTIONS(12194),
    [anon_sym_local] = ACTIONS(12194),
    [anon_sym_LPAREN] = ACTIONS(12194),
    [anon_sym_RPAREN] = ACTIONS(12194),
    [anon_sym_COLON2] = ACTIONS(12194),
    [anon_sym_export] = ACTIONS(12194),
    [anon_sym_import] = ACTIONS(12194),
    [anon_sym_using] = ACTIONS(12194),
    [anon_sym_LBRACK] = ACTIONS(12194),
    [anon_sym_RBRACK] = ACTIONS(12194),
    [anon_sym_LF] = ACTIONS(12196),
    [anon_sym_in] = ACTIONS(12194),
    [anon_sym_LBRACE] = ACTIONS(12194),
    [anon_sym_SQUOTE] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(12434),
    [anon_sym_DOLLAR] = ACTIONS(12194),
    [anon_sym_COLON_COLON] = ACTIONS(12194),
    [anon_sym_isa] = ACTIONS(12194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12194),
    [anon_sym_QMARK] = ACTIONS(12194),
    [anon_sym_DASH_GT] = ACTIONS(12194),
    [anon_sym_AT] = ACTIONS(12194),
    [anon_sym_true] = ACTIONS(12194),
    [anon_sym_false] = ACTIONS(12194),
    [aux_sym_integer_literal_token1] = ACTIONS(12194),
    [aux_sym_integer_literal_token2] = ACTIONS(12194),
    [aux_sym_integer_literal_token3] = ACTIONS(12194),
    [aux_sym_integer_literal_token4] = ACTIONS(12194),
    [aux_sym_float_literal_token1] = ACTIONS(12194),
    [aux_sym_float_literal_token3] = ACTIONS(12194),
    [aux_sym_float_literal_token4] = ACTIONS(12194),
    [sym_character_literal] = ACTIONS(12194),
    [sym__pair_operator] = ACTIONS(12194),
    [sym__arrow_operator] = ACTIONS(12194),
    [sym__lazy_or_operator] = ACTIONS(12194),
    [sym__lazy_and_operator] = ACTIONS(12194),
    [sym__comparison_operator] = ACTIONS(12194),
    [sym__pipe_right_operator] = ACTIONS(12194),
    [sym__pipe_left_operator] = ACTIONS(12194),
    [sym__ellipsis_operator] = ACTIONS(12194),
    [sym__plus_operator] = ACTIONS(12194),
    [sym__times_operator] = ACTIONS(12194),
    [sym__rational_operator] = ACTIONS(12194),
    [sym__bitshift_operator] = ACTIONS(12194),
    [sym__power_operator] = ACTIONS(12194),
    [sym__tilde_operator] = ACTIONS(12194),
    [sym__type_order_operator] = ACTIONS(12194),
    [sym__unary_operator] = ACTIONS(12194),
    [sym__unary_plus_operator] = ACTIONS(12194),
    [aux_sym__terminator_token1] = ACTIONS(12194),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12436),
    [sym__immediate_bracket] = ACTIONS(12438),
    [sym__immediate_brace] = ACTIONS(12440),
    [sym__string_start] = ACTIONS(12196),
    [sym__command_start] = ACTIONS(12196),
  },
  [5025] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_elseif] = ACTIONS(12338),
    [anon_sym_else] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__assignment_operator] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5026] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_elseif] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5027] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_elseif] = ACTIONS(12342),
    [anon_sym_else] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__assignment_operator] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5028] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_elseif] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5029] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_elseif] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5030] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_elseif] = ACTIONS(12218),
    [anon_sym_else] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_DASH_GT] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5031] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11978),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11978),
    [anon_sym_RPAREN] = ACTIONS(11978),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11978),
    [anon_sym_RBRACK] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_SEMI] = ACTIONS(11978),
    [anon_sym_LBRACE] = ACTIONS(11978),
    [anon_sym_RBRACE] = ACTIONS(11978),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11978),
    [anon_sym_COLON_COLON] = ACTIONS(11978),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11978),
    [anon_sym_QMARK] = ACTIONS(11978),
    [anon_sym_DASH_GT] = ACTIONS(11978),
    [anon_sym_AT] = ACTIONS(11978),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11978),
    [aux_sym_integer_literal_token2] = ACTIONS(11978),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11978),
    [aux_sym_float_literal_token3] = ACTIONS(11978),
    [aux_sym_float_literal_token4] = ACTIONS(11978),
    [sym_character_literal] = ACTIONS(11978),
    [sym__pair_operator] = ACTIONS(11978),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11978),
    [sym__lazy_and_operator] = ACTIONS(11978),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11978),
    [sym__pipe_left_operator] = ACTIONS(11978),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11978),
    [sym__bitshift_operator] = ACTIONS(11978),
    [sym__power_operator] = ACTIONS(11978),
    [sym__tilde_operator] = ACTIONS(11978),
    [sym__type_order_operator] = ACTIONS(11978),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5032] = {
    [ts_builtin_sym_end] = ACTIONS(12336),
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_RPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_RBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_DASH_GT] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5033] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11986),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11986),
    [anon_sym_RPAREN] = ACTIONS(11986),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11986),
    [anon_sym_RBRACK] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_SEMI] = ACTIONS(11986),
    [anon_sym_LBRACE] = ACTIONS(11986),
    [anon_sym_RBRACE] = ACTIONS(11986),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11986),
    [anon_sym_COLON_COLON] = ACTIONS(11986),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11986),
    [anon_sym_QMARK] = ACTIONS(11986),
    [anon_sym_DASH_GT] = ACTIONS(11986),
    [anon_sym_AT] = ACTIONS(11986),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11986),
    [aux_sym_integer_literal_token2] = ACTIONS(11986),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11986),
    [aux_sym_float_literal_token3] = ACTIONS(11986),
    [aux_sym_float_literal_token4] = ACTIONS(11986),
    [sym_character_literal] = ACTIONS(11986),
    [sym__pair_operator] = ACTIONS(11986),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11986),
    [sym__lazy_and_operator] = ACTIONS(11986),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11986),
    [sym__pipe_left_operator] = ACTIONS(11986),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11986),
    [sym__bitshift_operator] = ACTIONS(11986),
    [sym__power_operator] = ACTIONS(11986),
    [sym__tilde_operator] = ACTIONS(11986),
    [sym__type_order_operator] = ACTIONS(11986),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [5034] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_elseif] = ACTIONS(12178),
    [anon_sym_else] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__assignment_operator] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5035] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_elseif] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5036] = {
    [ts_builtin_sym_end] = ACTIONS(12254),
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_RPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_RBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__assignment_operator] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5037] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12222),
    [anon_sym_DOT] = ACTIONS(12428),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12430),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12228),
    [sym__immediate_bracket] = ACTIONS(12230),
    [sym__immediate_brace] = ACTIONS(12232),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5038] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_elseif] = ACTIONS(12236),
    [anon_sym_else] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_DASH_GT] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5039] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_elseif] = ACTIONS(12240),
    [anon_sym_else] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_DASH_GT] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5040] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_elseif] = ACTIONS(12244),
    [anon_sym_else] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_DASH_GT] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5041] = {
    [ts_builtin_sym_end] = ACTIONS(12258),
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_RPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_RBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__assignment_operator] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5042] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_elseif] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5043] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_elseif] = ACTIONS(12248),
    [anon_sym_else] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_DASH_GT] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5044] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_elseif] = ACTIONS(12252),
    [anon_sym_else] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_DASH_GT] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5045] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_elseif] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5046] = {
    [ts_builtin_sym_end] = ACTIONS(12298),
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_RPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_RBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__assignment_operator] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5047] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_elseif] = ACTIONS(12256),
    [anon_sym_else] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_DASH_GT] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5048] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_elseif] = ACTIONS(12260),
    [anon_sym_else] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_DASH_GT] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5049] = {
    [ts_builtin_sym_end] = ACTIONS(12340),
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_RPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_RBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__assignment_operator] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5050] = {
    [ts_builtin_sym_end] = ACTIONS(12344),
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_RPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_RBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__assignment_operator] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5051] = {
    [sym_identifier] = STATE(5499),
    [ts_builtin_sym_end] = ACTIONS(11994),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_RPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_RBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [5052] = {
    [sym_identifier] = STATE(5501),
    [ts_builtin_sym_end] = ACTIONS(11956),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_RPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_RBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [5053] = {
    [ts_builtin_sym_end] = ACTIONS(11930),
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_RBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5054] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_elseif] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5055] = {
    [ts_builtin_sym_end] = ACTIONS(11934),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_RBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5056] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_elseif] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5057] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_elseif] = ACTIONS(12264),
    [anon_sym_else] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_DASH_GT] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5058] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_elseif] = ACTIONS(12264),
    [anon_sym_else] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__assignment_operator] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5059] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_elseif] = ACTIONS(12268),
    [anon_sym_else] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_DASH_GT] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5060] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_elseif] = ACTIONS(12272),
    [anon_sym_else] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_DASH_GT] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5061] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_else] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_finally] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5062] = {
    [ts_builtin_sym_end] = ACTIONS(12052),
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_RBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5063] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_elseif] = ACTIONS(12276),
    [anon_sym_else] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_DASH_GT] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5064] = {
    [sym_identifier] = STATE(5513),
    [ts_builtin_sym_end] = ACTIONS(12004),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_RPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_RBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [5065] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_elseif] = ACTIONS(12280),
    [anon_sym_else] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_DASH_GT] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5066] = {
    [sym_identifier] = STATE(5515),
    [ts_builtin_sym_end] = ACTIONS(12008),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_RPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_RBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [5067] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_elseif] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5068] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_elseif] = ACTIONS(12284),
    [anon_sym_else] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_DASH_GT] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5069] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_elseif] = ACTIONS(12268),
    [anon_sym_else] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__assignment_operator] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5070] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_catch] = ACTIONS(11976),
    [anon_sym_finally] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5071] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_else] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_finally] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__assignment_operator] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5072] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_elseif] = ACTIONS(12272),
    [anon_sym_else] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__assignment_operator] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5073] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_elseif] = ACTIONS(12142),
    [anon_sym_else] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_DASH_GT] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5074] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_elseif] = ACTIONS(12146),
    [anon_sym_else] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_DASH_GT] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5075] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_elseif] = ACTIONS(12304),
    [anon_sym_else] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__assignment_operator] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5076] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_elseif] = ACTIONS(12150),
    [anon_sym_else] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_DASH_GT] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5077] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_else] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_finally] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [5078] = {
    [ts_builtin_sym_end] = ACTIONS(12262),
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_RPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_RBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__assignment_operator] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5079] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(12442),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11854),
    [sym__immediate_command_start] = ACTIONS(11856),
  },
  [5080] = {
    [ts_builtin_sym_end] = ACTIONS(12266),
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_RPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_RBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__assignment_operator] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5081] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_elseif] = ACTIONS(12158),
    [anon_sym_else] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_DASH_GT] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5082] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_elseif] = ACTIONS(12162),
    [anon_sym_else] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_DASH_GT] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5083] = {
    [ts_builtin_sym_end] = ACTIONS(12270),
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_RPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_RBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__assignment_operator] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5084] = {
    [ts_builtin_sym_end] = ACTIONS(12302),
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_RPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_RBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__assignment_operator] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5085] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_elseif] = ACTIONS(12210),
    [anon_sym_else] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_DASH_GT] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5086] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_elseif] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_DASH_GT] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5087] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_elseif] = ACTIONS(12170),
    [anon_sym_else] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_DASH_GT] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5088] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_elseif] = ACTIONS(12178),
    [anon_sym_else] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_DASH_GT] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5089] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12444),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5090] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_elseif] = ACTIONS(12360),
    [anon_sym_else] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__assignment_operator] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5091] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5092] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_else] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__assignment_operator] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5093] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_else] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__assignment_operator] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5094] = {
    [ts_builtin_sym_end] = ACTIONS(12362),
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_RPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_RBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__assignment_operator] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5095] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_else] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__assignment_operator] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5096] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_catch] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [5097] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(12446),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(11854),
    [sym__immediate_command_start] = ACTIONS(11856),
  },
  [5098] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_elseif] = ACTIONS(12292),
    [anon_sym_else] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_DASH_GT] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5099] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12352),
    [sym__immediate_command_start] = ACTIONS(12354),
  },
  [5100] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_else] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__assignment_operator] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5101] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_else] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__assignment_operator] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5102] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12022),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12022),
    [anon_sym_RPAREN] = ACTIONS(12022),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12022),
    [anon_sym_RBRACK] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_SEMI] = ACTIONS(12022),
    [anon_sym_LBRACE] = ACTIONS(12022),
    [anon_sym_RBRACE] = ACTIONS(12022),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12022),
    [anon_sym_COLON_COLON] = ACTIONS(12022),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12022),
    [anon_sym_QMARK] = ACTIONS(12022),
    [anon_sym_DASH_GT] = ACTIONS(12022),
    [anon_sym_AT] = ACTIONS(12022),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12022),
    [aux_sym_integer_literal_token2] = ACTIONS(12022),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12022),
    [aux_sym_float_literal_token3] = ACTIONS(12022),
    [aux_sym_float_literal_token4] = ACTIONS(12022),
    [sym_character_literal] = ACTIONS(12022),
    [sym__pair_operator] = ACTIONS(12022),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12022),
    [sym__lazy_and_operator] = ACTIONS(12022),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12022),
    [sym__pipe_left_operator] = ACTIONS(12022),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12022),
    [sym__bitshift_operator] = ACTIONS(12022),
    [sym__power_operator] = ACTIONS(12022),
    [sym__tilde_operator] = ACTIONS(12022),
    [sym__type_order_operator] = ACTIONS(12022),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [5103] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_else] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__assignment_operator] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5104] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_else] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__assignment_operator] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5105] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_elseif] = ACTIONS(12300),
    [anon_sym_else] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_DASH_GT] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5106] = {
    [sym_do_clause] = STATE(6407),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_catch] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12448),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [5107] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_elseif] = ACTIONS(12364),
    [anon_sym_else] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__assignment_operator] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5108] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12286),
    [sym__immediate_command_start] = ACTIONS(12288),
  },
  [5109] = {
    [sym_do_clause] = STATE(6409),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12448),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5110] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_elseif] = ACTIONS(12276),
    [anon_sym_else] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__assignment_operator] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5111] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11982),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11982),
    [anon_sym_RPAREN] = ACTIONS(11982),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11982),
    [anon_sym_RBRACK] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_SEMI] = ACTIONS(11982),
    [anon_sym_LBRACE] = ACTIONS(11982),
    [anon_sym_RBRACE] = ACTIONS(11982),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11982),
    [anon_sym_COLON_COLON] = ACTIONS(11982),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11982),
    [anon_sym_QMARK] = ACTIONS(11982),
    [anon_sym_DASH_GT] = ACTIONS(11982),
    [anon_sym_AT] = ACTIONS(11982),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11982),
    [aux_sym_integer_literal_token2] = ACTIONS(11982),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11982),
    [aux_sym_float_literal_token3] = ACTIONS(11982),
    [aux_sym_float_literal_token4] = ACTIONS(11982),
    [sym_character_literal] = ACTIONS(11982),
    [sym__pair_operator] = ACTIONS(11982),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11982),
    [sym__lazy_and_operator] = ACTIONS(11982),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11982),
    [sym__pipe_left_operator] = ACTIONS(11982),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11982),
    [sym__bitshift_operator] = ACTIONS(11982),
    [sym__power_operator] = ACTIONS(11982),
    [sym__tilde_operator] = ACTIONS(11982),
    [sym__type_order_operator] = ACTIONS(11982),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [5112] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11990),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11990),
    [anon_sym_RPAREN] = ACTIONS(11990),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11990),
    [anon_sym_RBRACK] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_SEMI] = ACTIONS(11990),
    [anon_sym_LBRACE] = ACTIONS(11990),
    [anon_sym_RBRACE] = ACTIONS(11990),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11990),
    [anon_sym_COLON_COLON] = ACTIONS(11990),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11990),
    [anon_sym_QMARK] = ACTIONS(11990),
    [anon_sym_DASH_GT] = ACTIONS(11990),
    [anon_sym_AT] = ACTIONS(11990),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11990),
    [aux_sym_integer_literal_token2] = ACTIONS(11990),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11990),
    [aux_sym_float_literal_token3] = ACTIONS(11990),
    [aux_sym_float_literal_token4] = ACTIONS(11990),
    [sym_character_literal] = ACTIONS(11990),
    [sym__pair_operator] = ACTIONS(11990),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11990),
    [sym__lazy_and_operator] = ACTIONS(11990),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11990),
    [sym__pipe_left_operator] = ACTIONS(11990),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11990),
    [sym__bitshift_operator] = ACTIONS(11990),
    [sym__power_operator] = ACTIONS(11990),
    [sym__tilde_operator] = ACTIONS(11990),
    [sym__type_order_operator] = ACTIONS(11990),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [5113] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5114] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11998),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11998),
    [anon_sym_RPAREN] = ACTIONS(11998),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11998),
    [anon_sym_RBRACK] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_SEMI] = ACTIONS(11998),
    [anon_sym_LBRACE] = ACTIONS(11998),
    [anon_sym_RBRACE] = ACTIONS(11998),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11998),
    [anon_sym_COLON_COLON] = ACTIONS(11998),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11998),
    [anon_sym_QMARK] = ACTIONS(11998),
    [anon_sym_DASH_GT] = ACTIONS(11998),
    [anon_sym_AT] = ACTIONS(11998),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11998),
    [aux_sym_integer_literal_token2] = ACTIONS(11998),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11998),
    [aux_sym_float_literal_token3] = ACTIONS(11998),
    [aux_sym_float_literal_token4] = ACTIONS(11998),
    [sym_character_literal] = ACTIONS(11998),
    [sym__pair_operator] = ACTIONS(11998),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11998),
    [sym__lazy_and_operator] = ACTIONS(11998),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11998),
    [sym__pipe_left_operator] = ACTIONS(11998),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11998),
    [sym__bitshift_operator] = ACTIONS(11998),
    [sym__power_operator] = ACTIONS(11998),
    [sym__tilde_operator] = ACTIONS(11998),
    [sym__type_order_operator] = ACTIONS(11998),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [5115] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5116] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_else] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__assignment_operator] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5117] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_else] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__assignment_operator] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5118] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_else] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__assignment_operator] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5119] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_elseif] = ACTIONS(12304),
    [anon_sym_else] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_DASH_GT] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5120] = {
    [sym_do_clause] = STATE(6418),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_catch] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12448),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [5121] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_else] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__assignment_operator] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5122] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_else] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__assignment_operator] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5123] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_elseif] = ACTIONS(12280),
    [anon_sym_else] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__assignment_operator] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5124] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_elseif] = ACTIONS(12334),
    [anon_sym_else] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__assignment_operator] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5125] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12026),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12026),
    [anon_sym_RPAREN] = ACTIONS(12026),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12026),
    [anon_sym_RBRACK] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_SEMI] = ACTIONS(12026),
    [anon_sym_LBRACE] = ACTIONS(12026),
    [anon_sym_RBRACE] = ACTIONS(12026),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12026),
    [anon_sym_COLON_COLON] = ACTIONS(12026),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12026),
    [anon_sym_QMARK] = ACTIONS(12026),
    [anon_sym_DASH_GT] = ACTIONS(12026),
    [anon_sym_AT] = ACTIONS(12026),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12026),
    [aux_sym_integer_literal_token2] = ACTIONS(12026),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12026),
    [aux_sym_float_literal_token3] = ACTIONS(12026),
    [aux_sym_float_literal_token4] = ACTIONS(12026),
    [sym_character_literal] = ACTIONS(12026),
    [sym__pair_operator] = ACTIONS(12026),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12026),
    [sym__lazy_and_operator] = ACTIONS(12026),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12026),
    [sym__pipe_left_operator] = ACTIONS(12026),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12026),
    [sym__bitshift_operator] = ACTIONS(12026),
    [sym__power_operator] = ACTIONS(12026),
    [sym__tilde_operator] = ACTIONS(12026),
    [sym__type_order_operator] = ACTIONS(12026),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [5126] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12030),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12030),
    [anon_sym_RPAREN] = ACTIONS(12030),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12030),
    [anon_sym_RBRACK] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_SEMI] = ACTIONS(12030),
    [anon_sym_LBRACE] = ACTIONS(12030),
    [anon_sym_RBRACE] = ACTIONS(12030),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12030),
    [anon_sym_COLON_COLON] = ACTIONS(12030),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12030),
    [anon_sym_QMARK] = ACTIONS(12030),
    [anon_sym_DASH_GT] = ACTIONS(12030),
    [anon_sym_AT] = ACTIONS(12030),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12030),
    [aux_sym_integer_literal_token2] = ACTIONS(12030),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12030),
    [aux_sym_float_literal_token3] = ACTIONS(12030),
    [aux_sym_float_literal_token4] = ACTIONS(12030),
    [sym_character_literal] = ACTIONS(12030),
    [sym__pair_operator] = ACTIONS(12030),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12030),
    [sym__lazy_and_operator] = ACTIONS(12030),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12030),
    [sym__pipe_left_operator] = ACTIONS(12030),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12030),
    [sym__bitshift_operator] = ACTIONS(12030),
    [sym__power_operator] = ACTIONS(12030),
    [sym__tilde_operator] = ACTIONS(12030),
    [sym__type_order_operator] = ACTIONS(12030),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [5127] = {
    [ts_builtin_sym_end] = ACTIONS(12366),
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_RPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_RBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__assignment_operator] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5128] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5129] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_else] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__assignment_operator] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5130] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12034),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12034),
    [anon_sym_RPAREN] = ACTIONS(12034),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12034),
    [anon_sym_RBRACK] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_SEMI] = ACTIONS(12034),
    [anon_sym_LBRACE] = ACTIONS(12034),
    [anon_sym_RBRACE] = ACTIONS(12034),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12034),
    [anon_sym_COLON_COLON] = ACTIONS(12034),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12034),
    [anon_sym_QMARK] = ACTIONS(12034),
    [anon_sym_DASH_GT] = ACTIONS(12034),
    [anon_sym_AT] = ACTIONS(12034),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12034),
    [aux_sym_integer_literal_token2] = ACTIONS(12034),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12034),
    [aux_sym_float_literal_token3] = ACTIONS(12034),
    [aux_sym_float_literal_token4] = ACTIONS(12034),
    [sym_character_literal] = ACTIONS(12034),
    [sym__pair_operator] = ACTIONS(12034),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12034),
    [sym__lazy_and_operator] = ACTIONS(12034),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12034),
    [sym__pipe_left_operator] = ACTIONS(12034),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12034),
    [sym__bitshift_operator] = ACTIONS(12034),
    [sym__power_operator] = ACTIONS(12034),
    [sym__tilde_operator] = ACTIONS(12034),
    [sym__type_order_operator] = ACTIONS(12034),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [5131] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_else] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__assignment_operator] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5132] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_else] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__assignment_operator] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5133] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_else] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__assignment_operator] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5134] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_elseif] = ACTIONS(12154),
    [anon_sym_else] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_DASH_GT] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5135] = {
    [sym_do_clause] = STATE(6426),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12448),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5136] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_else] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__assignment_operator] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5137] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_else] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__assignment_operator] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5138] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12038),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12038),
    [anon_sym_RPAREN] = ACTIONS(12038),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12038),
    [anon_sym_RBRACK] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_SEMI] = ACTIONS(12038),
    [anon_sym_LBRACE] = ACTIONS(12038),
    [anon_sym_RBRACE] = ACTIONS(12038),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12038),
    [anon_sym_COLON_COLON] = ACTIONS(12038),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12038),
    [anon_sym_QMARK] = ACTIONS(12038),
    [anon_sym_DASH_GT] = ACTIONS(12038),
    [anon_sym_AT] = ACTIONS(12038),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12038),
    [aux_sym_integer_literal_token2] = ACTIONS(12038),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12038),
    [aux_sym_float_literal_token3] = ACTIONS(12038),
    [aux_sym_float_literal_token4] = ACTIONS(12038),
    [sym_character_literal] = ACTIONS(12038),
    [sym__pair_operator] = ACTIONS(12038),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12038),
    [sym__lazy_and_operator] = ACTIONS(12038),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12038),
    [sym__pipe_left_operator] = ACTIONS(12038),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12038),
    [sym__bitshift_operator] = ACTIONS(12038),
    [sym__power_operator] = ACTIONS(12038),
    [sym__tilde_operator] = ACTIONS(12038),
    [sym__type_order_operator] = ACTIONS(12038),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [5139] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12042),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12042),
    [anon_sym_RPAREN] = ACTIONS(12042),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12042),
    [anon_sym_RBRACK] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_SEMI] = ACTIONS(12042),
    [anon_sym_LBRACE] = ACTIONS(12042),
    [anon_sym_RBRACE] = ACTIONS(12042),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12042),
    [anon_sym_COLON_COLON] = ACTIONS(12042),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12042),
    [anon_sym_QMARK] = ACTIONS(12042),
    [anon_sym_DASH_GT] = ACTIONS(12042),
    [anon_sym_AT] = ACTIONS(12042),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12042),
    [aux_sym_integer_literal_token2] = ACTIONS(12042),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12042),
    [aux_sym_float_literal_token3] = ACTIONS(12042),
    [aux_sym_float_literal_token4] = ACTIONS(12042),
    [sym_character_literal] = ACTIONS(12042),
    [sym__pair_operator] = ACTIONS(12042),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12042),
    [sym__lazy_and_operator] = ACTIONS(12042),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12042),
    [sym__pipe_left_operator] = ACTIONS(12042),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12042),
    [sym__bitshift_operator] = ACTIONS(12042),
    [sym__power_operator] = ACTIONS(12042),
    [sym__tilde_operator] = ACTIONS(12042),
    [sym__type_order_operator] = ACTIONS(12042),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [5140] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_else] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__assignment_operator] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5141] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__assignment_operator] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5142] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_else] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__assignment_operator] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5143] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_else] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__assignment_operator] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5144] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_elseif] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5145] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_elseif] = ACTIONS(12284),
    [anon_sym_else] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__assignment_operator] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5146] = {
    [ts_builtin_sym_end] = ACTIONS(12056),
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_RBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5147] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_else] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_finally] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__assignment_operator] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5148] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_else] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_finally] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__assignment_operator] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5149] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12050),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12050),
    [anon_sym_RPAREN] = ACTIONS(12050),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12050),
    [anon_sym_RBRACK] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_SEMI] = ACTIONS(12050),
    [anon_sym_LBRACE] = ACTIONS(12050),
    [anon_sym_RBRACE] = ACTIONS(12050),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12050),
    [anon_sym_COLON_COLON] = ACTIONS(12050),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12050),
    [anon_sym_QMARK] = ACTIONS(12050),
    [anon_sym_DASH_GT] = ACTIONS(12050),
    [anon_sym_AT] = ACTIONS(12050),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12050),
    [aux_sym_integer_literal_token2] = ACTIONS(12050),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12050),
    [aux_sym_float_literal_token3] = ACTIONS(12050),
    [aux_sym_float_literal_token4] = ACTIONS(12050),
    [sym_character_literal] = ACTIONS(12050),
    [sym__pair_operator] = ACTIONS(12050),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12050),
    [sym__lazy_and_operator] = ACTIONS(12050),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12050),
    [sym__pipe_left_operator] = ACTIONS(12050),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12050),
    [sym__bitshift_operator] = ACTIONS(12050),
    [sym__power_operator] = ACTIONS(12050),
    [sym__tilde_operator] = ACTIONS(12050),
    [sym__type_order_operator] = ACTIONS(12050),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [5150] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_elseif] = ACTIONS(12142),
    [anon_sym_else] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__assignment_operator] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5151] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5152] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_else] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__assignment_operator] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5153] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5154] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_catch] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [5155] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_else] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__assignment_operator] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5156] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_else] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_finally] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__assignment_operator] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5157] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_else] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__assignment_operator] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5158] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_elseif] = ACTIONS(12146),
    [anon_sym_else] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__assignment_operator] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5159] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_catch] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_DASH_GT] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [5160] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_elseif] = ACTIONS(12150),
    [anon_sym_else] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__assignment_operator] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5161] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_else] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_finally] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__assignment_operator] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5162] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_else] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_finally] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [5163] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_elseif] = ACTIONS(12154),
    [anon_sym_else] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__assignment_operator] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5164] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5165] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_else] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__assignment_operator] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5166] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_else] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_finally] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__assignment_operator] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5167] = {
    [ts_builtin_sym_end] = ACTIONS(12274),
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_RPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_RBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__assignment_operator] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5168] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_else] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_finally] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__assignment_operator] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5169] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_else] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_finally] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__assignment_operator] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5170] = {
    [ts_builtin_sym_end] = ACTIONS(12278),
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_RPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_RBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__assignment_operator] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5171] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_catch] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_DASH_GT] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [5172] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_else] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_finally] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [5173] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_else] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_finally] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [5174] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_else] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_finally] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [5175] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_elseif] = ACTIONS(12136),
    [anon_sym_else] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__assignment_operator] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5176] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12450),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12370),
    [anon_sym_DOT] = ACTIONS(12452),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12454),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12376),
    [sym__immediate_bracket] = ACTIONS(12378),
    [sym__immediate_brace] = ACTIONS(12380),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5177] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_else] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__assignment_operator] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5178] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_finally] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__assignment_operator] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5179] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_elseif] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5180] = {
    [ts_builtin_sym_end] = ACTIONS(12336),
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_RPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_RBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__assignment_operator] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5181] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_else] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_finally] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [5182] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_else] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_finally] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [5183] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_else] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_finally] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [5184] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_else] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__assignment_operator] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5185] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_finally] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__assignment_operator] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [5186] = {
    [sym_identifier] = STATE(5372),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_DASH_GT] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [5187] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_DASH_GT] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5188] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_catch] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__assignment_operator] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5189] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [5190] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5191] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__assignment_operator] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5192] = {
    [sym_do_clause] = STATE(6587),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_RPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_SEMI] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12456),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [5193] = {
    [ts_builtin_sym_end] = ACTIONS(12362),
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_RPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_RBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5194] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12458),
    [sym__immediate_command_start] = ACTIONS(12460),
  },
  [5195] = {
    [sym_do_clause] = STATE(6589),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12456),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5196] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5197] = {
    [ts_builtin_sym_end] = ACTIONS(12366),
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_RPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_RBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5198] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_catch] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__assignment_operator] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5199] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_catch] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__assignment_operator] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5200] = {
    [sym_identifier] = STATE(6323),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11994),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11994),
    [anon_sym_RPAREN] = ACTIONS(11994),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11994),
    [anon_sym_RBRACK] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_SEMI] = ACTIONS(11994),
    [anon_sym_LBRACE] = ACTIONS(11994),
    [anon_sym_RBRACE] = ACTIONS(11994),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11994),
    [anon_sym_COLON_COLON] = ACTIONS(11994),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11994),
    [anon_sym_QMARK] = ACTIONS(11994),
    [anon_sym_AT] = ACTIONS(11994),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11994),
    [aux_sym_integer_literal_token2] = ACTIONS(11994),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11994),
    [aux_sym_float_literal_token3] = ACTIONS(11994),
    [aux_sym_float_literal_token4] = ACTIONS(11994),
    [sym_character_literal] = ACTIONS(11994),
    [sym__pair_operator] = ACTIONS(11994),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11994),
    [sym__lazy_and_operator] = ACTIONS(11994),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11994),
    [sym__pipe_left_operator] = ACTIONS(11994),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11994),
    [sym__bitshift_operator] = ACTIONS(11994),
    [sym__power_operator] = ACTIONS(11994),
    [sym__tilde_operator] = ACTIONS(11994),
    [sym__type_order_operator] = ACTIONS(11994),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [5201] = {
    [sym_identifier] = STATE(6324),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11956),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11956),
    [anon_sym_RPAREN] = ACTIONS(11956),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11956),
    [anon_sym_RBRACK] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_SEMI] = ACTIONS(11956),
    [anon_sym_LBRACE] = ACTIONS(11956),
    [anon_sym_RBRACE] = ACTIONS(11956),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11956),
    [anon_sym_COLON_COLON] = ACTIONS(11956),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11956),
    [anon_sym_QMARK] = ACTIONS(11956),
    [anon_sym_AT] = ACTIONS(11956),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11956),
    [aux_sym_integer_literal_token2] = ACTIONS(11956),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11956),
    [aux_sym_float_literal_token3] = ACTIONS(11956),
    [aux_sym_float_literal_token4] = ACTIONS(11956),
    [sym_character_literal] = ACTIONS(11956),
    [sym__pair_operator] = ACTIONS(11956),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11956),
    [sym__lazy_and_operator] = ACTIONS(11956),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11956),
    [sym__pipe_left_operator] = ACTIONS(11956),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11956),
    [sym__bitshift_operator] = ACTIONS(11956),
    [sym__power_operator] = ACTIONS(11956),
    [sym__tilde_operator] = ACTIONS(11956),
    [sym__type_order_operator] = ACTIONS(11956),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [5202] = {
    [ts_builtin_sym_end] = ACTIONS(12336),
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_RPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_RBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5203] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_finally] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [5204] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_elseif] = ACTIONS(12326),
    [anon_sym_else] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5205] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5206] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12462),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12464),
    [anon_sym_DOT] = ACTIONS(12466),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12468),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12470),
    [sym__immediate_bracket] = ACTIONS(12472),
    [sym__immediate_brace] = ACTIONS(12474),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5207] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_finally] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_DASH_GT] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5208] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_elseif] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5209] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_finally] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [5210] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_elseif] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5211] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_catch] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__assignment_operator] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5212] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5213] = {
    [ts_builtin_sym_end] = ACTIONS(12476),
    [sym__word_identifier] = ACTIONS(12410),
    [anon_sym_EQ] = ACTIONS(12410),
    [anon_sym_COMMA] = ACTIONS(12410),
    [anon_sym_COLON] = ACTIONS(12410),
    [anon_sym_begin] = ACTIONS(12410),
    [anon_sym_module] = ACTIONS(12410),
    [anon_sym_baremodule] = ACTIONS(12410),
    [anon_sym_abstract] = ACTIONS(12410),
    [anon_sym_primitive] = ACTIONS(12410),
    [anon_sym_mutable] = ACTIONS(12410),
    [anon_sym_struct] = ACTIONS(12410),
    [anon_sym_function] = ACTIONS(12410),
    [anon_sym_macro] = ACTIONS(12410),
    [anon_sym_where] = ACTIONS(12410),
    [anon_sym_quote] = ACTIONS(12410),
    [anon_sym_let] = ACTIONS(12410),
    [anon_sym_if] = ACTIONS(12410),
    [anon_sym_try] = ACTIONS(12410),
    [anon_sym_for] = ACTIONS(12410),
    [anon_sym_while] = ACTIONS(12410),
    [sym_break_statement] = ACTIONS(12410),
    [sym_continue_statement] = ACTIONS(12410),
    [anon_sym_return] = ACTIONS(12410),
    [anon_sym_const] = ACTIONS(12410),
    [anon_sym_global] = ACTIONS(12410),
    [anon_sym_local] = ACTIONS(12410),
    [anon_sym_LPAREN] = ACTIONS(12410),
    [anon_sym_RPAREN] = ACTIONS(12410),
    [anon_sym_COLON2] = ACTIONS(12410),
    [anon_sym_export] = ACTIONS(12410),
    [anon_sym_import] = ACTIONS(12410),
    [anon_sym_using] = ACTIONS(12410),
    [anon_sym_LBRACK] = ACTIONS(12410),
    [anon_sym_RBRACK] = ACTIONS(12410),
    [anon_sym_LF] = ACTIONS(12476),
    [anon_sym_in] = ACTIONS(12410),
    [anon_sym_LBRACE] = ACTIONS(12410),
    [anon_sym_SQUOTE] = ACTIONS(12478),
    [anon_sym_DOT] = ACTIONS(12480),
    [anon_sym_DOLLAR] = ACTIONS(12410),
    [anon_sym_COLON_COLON] = ACTIONS(12410),
    [anon_sym_isa] = ACTIONS(12410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12410),
    [anon_sym_QMARK] = ACTIONS(12410),
    [anon_sym_AT] = ACTIONS(12410),
    [anon_sym_true] = ACTIONS(12410),
    [anon_sym_false] = ACTIONS(12410),
    [aux_sym_integer_literal_token1] = ACTIONS(12410),
    [aux_sym_integer_literal_token2] = ACTIONS(12410),
    [aux_sym_integer_literal_token3] = ACTIONS(12410),
    [aux_sym_integer_literal_token4] = ACTIONS(12410),
    [aux_sym_float_literal_token1] = ACTIONS(12410),
    [aux_sym_float_literal_token3] = ACTIONS(12410),
    [aux_sym_float_literal_token4] = ACTIONS(12410),
    [sym_character_literal] = ACTIONS(12410),
    [sym__pair_operator] = ACTIONS(12410),
    [sym__arrow_operator] = ACTIONS(12410),
    [sym__lazy_or_operator] = ACTIONS(12410),
    [sym__lazy_and_operator] = ACTIONS(12410),
    [sym__comparison_operator] = ACTIONS(12410),
    [sym__pipe_right_operator] = ACTIONS(12410),
    [sym__pipe_left_operator] = ACTIONS(12410),
    [sym__ellipsis_operator] = ACTIONS(12410),
    [sym__plus_operator] = ACTIONS(12410),
    [sym__times_operator] = ACTIONS(12410),
    [sym__rational_operator] = ACTIONS(12410),
    [sym__bitshift_operator] = ACTIONS(12410),
    [sym__power_operator] = ACTIONS(12410),
    [sym__tilde_operator] = ACTIONS(12410),
    [sym__type_order_operator] = ACTIONS(12410),
    [sym__unary_operator] = ACTIONS(12410),
    [sym__unary_plus_operator] = ACTIONS(12410),
    [aux_sym__terminator_token1] = ACTIONS(12410),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12482),
    [sym__immediate_bracket] = ACTIONS(12484),
    [sym__immediate_brace] = ACTIONS(12486),
    [sym__string_start] = ACTIONS(12476),
    [sym__command_start] = ACTIONS(12476),
  },
  [5214] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_elseif] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [5215] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__assignment_operator] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [5216] = {
    [sym_do_clause] = STATE(6591),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_RPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_SEMI] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12456),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [5217] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_catch] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__assignment_operator] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5218] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_catch] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__assignment_operator] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5219] = {
    [sym_identifier] = STATE(6336),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12004),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12004),
    [anon_sym_RPAREN] = ACTIONS(12004),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12004),
    [anon_sym_RBRACK] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_SEMI] = ACTIONS(12004),
    [anon_sym_LBRACE] = ACTIONS(12004),
    [anon_sym_RBRACE] = ACTIONS(12004),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12004),
    [anon_sym_COLON_COLON] = ACTIONS(12004),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12004),
    [anon_sym_QMARK] = ACTIONS(12004),
    [anon_sym_AT] = ACTIONS(12004),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12004),
    [aux_sym_integer_literal_token2] = ACTIONS(12004),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12004),
    [aux_sym_float_literal_token3] = ACTIONS(12004),
    [aux_sym_float_literal_token4] = ACTIONS(12004),
    [sym_character_literal] = ACTIONS(12004),
    [sym__pair_operator] = ACTIONS(12004),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12004),
    [sym__lazy_and_operator] = ACTIONS(12004),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12004),
    [sym__pipe_left_operator] = ACTIONS(12004),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12004),
    [sym__bitshift_operator] = ACTIONS(12004),
    [sym__power_operator] = ACTIONS(12004),
    [sym__tilde_operator] = ACTIONS(12004),
    [sym__type_order_operator] = ACTIONS(12004),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [5220] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_catch] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__assignment_operator] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5221] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_catch] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__assignment_operator] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5222] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_catch] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__assignment_operator] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5223] = {
    [sym_identifier] = STATE(6337),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12008),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12008),
    [anon_sym_RPAREN] = ACTIONS(12008),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12008),
    [anon_sym_RBRACK] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_SEMI] = ACTIONS(12008),
    [anon_sym_LBRACE] = ACTIONS(12008),
    [anon_sym_RBRACE] = ACTIONS(12008),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12008),
    [anon_sym_COLON_COLON] = ACTIONS(12008),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12008),
    [anon_sym_QMARK] = ACTIONS(12008),
    [anon_sym_AT] = ACTIONS(12008),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12008),
    [aux_sym_integer_literal_token2] = ACTIONS(12008),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12008),
    [aux_sym_float_literal_token3] = ACTIONS(12008),
    [aux_sym_float_literal_token4] = ACTIONS(12008),
    [sym_character_literal] = ACTIONS(12008),
    [sym__pair_operator] = ACTIONS(12008),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12008),
    [sym__lazy_and_operator] = ACTIONS(12008),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12008),
    [sym__pipe_left_operator] = ACTIONS(12008),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12008),
    [sym__bitshift_operator] = ACTIONS(12008),
    [sym__power_operator] = ACTIONS(12008),
    [sym__tilde_operator] = ACTIONS(12008),
    [sym__type_order_operator] = ACTIONS(12008),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [5224] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__assignment_operator] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [5225] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_finally] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_DASH_GT] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5226] = {
    [ts_builtin_sym_end] = ACTIONS(12138),
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_RPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_RBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5227] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__assignment_operator] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [5228] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_RPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_SEMI] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__assignment_operator] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5229] = {
    [sym_do_clause] = STATE(6595),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12456),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5230] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12488),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5231] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5232] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_catch] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__assignment_operator] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5233] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_DASH_GT] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5234] = {
    [ts_builtin_sym_end] = ACTIONS(11914),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_RBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5235] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_catch] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__assignment_operator] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5236] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5237] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_catch] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__assignment_operator] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5238] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5239] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5240] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_catch] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [5241] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_DASH_GT] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5242] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_elseif] = ACTIONS(12322),
    [anon_sym_else] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5243] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_elseif] = ACTIONS(12210),
    [anon_sym_else] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5244] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_catch] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__assignment_operator] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5245] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_catch] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__assignment_operator] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5246] = {
    [ts_builtin_sym_end] = ACTIONS(12172),
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_RPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_RBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5247] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_catch] = ACTIONS(12364),
    [anon_sym_finally] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_DASH_GT] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5248] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_catch] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [5249] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__assignment_operator] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [5250] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_catch] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__assignment_operator] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5251] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_catch] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__assignment_operator] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5252] = {
    [sym__word_identifier] = ACTIONS(12194),
    [anon_sym_EQ] = ACTIONS(12194),
    [anon_sym_COMMA] = ACTIONS(12194),
    [anon_sym_COLON] = ACTIONS(12194),
    [anon_sym_begin] = ACTIONS(12194),
    [anon_sym_module] = ACTIONS(12194),
    [anon_sym_baremodule] = ACTIONS(12194),
    [anon_sym_end] = ACTIONS(12194),
    [anon_sym_abstract] = ACTIONS(12194),
    [anon_sym_primitive] = ACTIONS(12194),
    [anon_sym_mutable] = ACTIONS(12194),
    [anon_sym_struct] = ACTIONS(12194),
    [anon_sym_function] = ACTIONS(12194),
    [anon_sym_macro] = ACTIONS(12194),
    [anon_sym_where] = ACTIONS(12194),
    [anon_sym_quote] = ACTIONS(12194),
    [anon_sym_let] = ACTIONS(12194),
    [anon_sym_if] = ACTIONS(12194),
    [anon_sym_try] = ACTIONS(12194),
    [anon_sym_catch] = ACTIONS(12194),
    [anon_sym_for] = ACTIONS(12194),
    [anon_sym_while] = ACTIONS(12194),
    [sym_break_statement] = ACTIONS(12194),
    [sym_continue_statement] = ACTIONS(12194),
    [anon_sym_return] = ACTIONS(12194),
    [anon_sym_const] = ACTIONS(12194),
    [anon_sym_global] = ACTIONS(12194),
    [anon_sym_local] = ACTIONS(12194),
    [anon_sym_LPAREN] = ACTIONS(12194),
    [anon_sym_COLON2] = ACTIONS(12194),
    [anon_sym_export] = ACTIONS(12194),
    [anon_sym_import] = ACTIONS(12194),
    [anon_sym_using] = ACTIONS(12194),
    [anon_sym_LBRACK] = ACTIONS(12194),
    [anon_sym_LF] = ACTIONS(12196),
    [anon_sym_in] = ACTIONS(12194),
    [anon_sym_LBRACE] = ACTIONS(12194),
    [anon_sym_SQUOTE] = ACTIONS(12490),
    [anon_sym_DOT] = ACTIONS(12492),
    [anon_sym_DOLLAR] = ACTIONS(12194),
    [anon_sym_COLON_COLON] = ACTIONS(12194),
    [anon_sym_isa] = ACTIONS(12194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12194),
    [anon_sym_QMARK] = ACTIONS(12194),
    [anon_sym_DASH_GT] = ACTIONS(12194),
    [anon_sym_AT] = ACTIONS(12194),
    [anon_sym_true] = ACTIONS(12194),
    [anon_sym_false] = ACTIONS(12194),
    [aux_sym_integer_literal_token1] = ACTIONS(12194),
    [aux_sym_integer_literal_token2] = ACTIONS(12194),
    [aux_sym_integer_literal_token3] = ACTIONS(12194),
    [aux_sym_integer_literal_token4] = ACTIONS(12194),
    [aux_sym_float_literal_token1] = ACTIONS(12194),
    [aux_sym_float_literal_token3] = ACTIONS(12194),
    [aux_sym_float_literal_token4] = ACTIONS(12194),
    [sym_character_literal] = ACTIONS(12194),
    [sym__pair_operator] = ACTIONS(12194),
    [sym__arrow_operator] = ACTIONS(12194),
    [sym__lazy_or_operator] = ACTIONS(12194),
    [sym__lazy_and_operator] = ACTIONS(12194),
    [sym__comparison_operator] = ACTIONS(12194),
    [sym__pipe_right_operator] = ACTIONS(12194),
    [sym__pipe_left_operator] = ACTIONS(12194),
    [sym__ellipsis_operator] = ACTIONS(12194),
    [sym__plus_operator] = ACTIONS(12194),
    [sym__times_operator] = ACTIONS(12194),
    [sym__rational_operator] = ACTIONS(12194),
    [sym__bitshift_operator] = ACTIONS(12194),
    [sym__power_operator] = ACTIONS(12194),
    [sym__tilde_operator] = ACTIONS(12194),
    [sym__type_order_operator] = ACTIONS(12194),
    [sym__unary_operator] = ACTIONS(12194),
    [sym__unary_plus_operator] = ACTIONS(12194),
    [aux_sym__terminator_token1] = ACTIONS(12194),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12494),
    [sym__immediate_bracket] = ACTIONS(12496),
    [sym__immediate_brace] = ACTIONS(12498),
    [sym__string_start] = ACTIONS(12196),
    [sym__command_start] = ACTIONS(12196),
  },
  [5253] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5254] = {
    [sym_identifier] = STATE(6049),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_catch] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [5255] = {
    [sym_identifier] = STATE(6055),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_catch] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [5256] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__assignment_operator] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [5257] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5258] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5259] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_elseif] = ACTIONS(12384),
    [anon_sym_else] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [5260] = {
    [sym_identifier] = STATE(6384),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_catch] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [5261] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5262] = {
    [sym_identifier] = STATE(6430),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_catch] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [5263] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_elseif] = ACTIONS(12338),
    [anon_sym_else] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5264] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_elseif] = ACTIONS(12342),
    [anon_sym_else] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5265] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_elseif] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5266] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12500),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5267] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_catch] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_DASH_GT] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5268] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_catch] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_DASH_GT] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5269] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_catch] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_DASH_GT] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5270] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [5271] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12306),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12306),
    [anon_sym_RPAREN] = ACTIONS(12306),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12306),
    [anon_sym_RBRACK] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_SEMI] = ACTIONS(12306),
    [anon_sym_LBRACE] = ACTIONS(12306),
    [anon_sym_RBRACE] = ACTIONS(12306),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12306),
    [anon_sym_COLON_COLON] = ACTIONS(12306),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12306),
    [anon_sym_QMARK] = ACTIONS(12306),
    [anon_sym_DASH_GT] = ACTIONS(12306),
    [anon_sym_AT] = ACTIONS(12306),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12306),
    [aux_sym_integer_literal_token2] = ACTIONS(12306),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12306),
    [aux_sym_float_literal_token3] = ACTIONS(12306),
    [aux_sym_float_literal_token4] = ACTIONS(12306),
    [sym_character_literal] = ACTIONS(12306),
    [sym__pair_operator] = ACTIONS(12306),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12306),
    [sym__lazy_and_operator] = ACTIONS(12306),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12306),
    [sym__pipe_left_operator] = ACTIONS(12306),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12306),
    [sym__bitshift_operator] = ACTIONS(12306),
    [sym__power_operator] = ACTIONS(12306),
    [sym__tilde_operator] = ACTIONS(12306),
    [sym__type_order_operator] = ACTIONS(12306),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5272] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_catch] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_DASH_GT] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5273] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_catch] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_DASH_GT] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5274] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_catch] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_DASH_GT] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5275] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_catch] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_DASH_GT] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5276] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5277] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5278] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_catch] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_DASH_GT] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5279] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_catch] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_DASH_GT] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5280] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_catch] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_DASH_GT] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5281] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_catch] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_DASH_GT] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5282] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_catch] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_DASH_GT] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5283] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5284] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_catch] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_DASH_GT] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5285] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_catch] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_DASH_GT] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5286] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_catch] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_DASH_GT] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5287] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_catch] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_DASH_GT] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5288] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_catch] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_DASH_GT] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5289] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_catch] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_DASH_GT] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5290] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_catch] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_DASH_GT] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5291] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_catch] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_DASH_GT] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5292] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_catch] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_DASH_GT] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5293] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_catch] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_DASH_GT] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5294] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_RPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_SEMI] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__assignment_operator] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [5295] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__assignment_operator] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [5296] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12458),
    [sym__immediate_command_start] = ACTIONS(12460),
  },
  [5297] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_catch] = ACTIONS(12214),
    [anon_sym_finally] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_DASH_GT] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5298] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12234),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12234),
    [anon_sym_RPAREN] = ACTIONS(12234),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12234),
    [anon_sym_RBRACK] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_SEMI] = ACTIONS(12234),
    [anon_sym_LBRACE] = ACTIONS(12234),
    [anon_sym_RBRACE] = ACTIONS(12234),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12234),
    [anon_sym_COLON_COLON] = ACTIONS(12234),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12234),
    [anon_sym_QMARK] = ACTIONS(12234),
    [anon_sym_DASH_GT] = ACTIONS(12234),
    [anon_sym_AT] = ACTIONS(12234),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12234),
    [aux_sym_integer_literal_token2] = ACTIONS(12234),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12234),
    [aux_sym_float_literal_token3] = ACTIONS(12234),
    [aux_sym_float_literal_token4] = ACTIONS(12234),
    [sym_character_literal] = ACTIONS(12234),
    [sym__pair_operator] = ACTIONS(12234),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12234),
    [sym__lazy_and_operator] = ACTIONS(12234),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12234),
    [sym__pipe_left_operator] = ACTIONS(12234),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12234),
    [sym__bitshift_operator] = ACTIONS(12234),
    [sym__power_operator] = ACTIONS(12234),
    [sym__tilde_operator] = ACTIONS(12234),
    [sym__type_order_operator] = ACTIONS(12234),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5299] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5300] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_elseif] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5301] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12238),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12238),
    [anon_sym_RPAREN] = ACTIONS(12238),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12238),
    [anon_sym_RBRACK] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_SEMI] = ACTIONS(12238),
    [anon_sym_LBRACE] = ACTIONS(12238),
    [anon_sym_RBRACE] = ACTIONS(12238),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12238),
    [anon_sym_COLON_COLON] = ACTIONS(12238),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12238),
    [anon_sym_QMARK] = ACTIONS(12238),
    [anon_sym_DASH_GT] = ACTIONS(12238),
    [anon_sym_AT] = ACTIONS(12238),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12238),
    [aux_sym_integer_literal_token2] = ACTIONS(12238),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12238),
    [aux_sym_float_literal_token3] = ACTIONS(12238),
    [aux_sym_float_literal_token4] = ACTIONS(12238),
    [sym_character_literal] = ACTIONS(12238),
    [sym__pair_operator] = ACTIONS(12238),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12238),
    [sym__lazy_and_operator] = ACTIONS(12238),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12238),
    [sym__pipe_left_operator] = ACTIONS(12238),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12238),
    [sym__bitshift_operator] = ACTIONS(12238),
    [sym__power_operator] = ACTIONS(12238),
    [sym__tilde_operator] = ACTIONS(12238),
    [sym__type_order_operator] = ACTIONS(12238),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5302] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5303] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5304] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5305] = {
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [5306] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_finally] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_DASH_GT] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5307] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12502),
    [anon_sym_DOT] = ACTIONS(12504),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12506),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12508),
    [sym__immediate_bracket] = ACTIONS(12510),
    [sym__immediate_brace] = ACTIONS(12512),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5308] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12242),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12242),
    [anon_sym_RPAREN] = ACTIONS(12242),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12242),
    [anon_sym_RBRACK] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_SEMI] = ACTIONS(12242),
    [anon_sym_LBRACE] = ACTIONS(12242),
    [anon_sym_RBRACE] = ACTIONS(12242),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12242),
    [anon_sym_COLON_COLON] = ACTIONS(12242),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12242),
    [anon_sym_QMARK] = ACTIONS(12242),
    [anon_sym_DASH_GT] = ACTIONS(12242),
    [anon_sym_AT] = ACTIONS(12242),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12242),
    [aux_sym_integer_literal_token2] = ACTIONS(12242),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12242),
    [aux_sym_float_literal_token3] = ACTIONS(12242),
    [aux_sym_float_literal_token4] = ACTIONS(12242),
    [sym_character_literal] = ACTIONS(12242),
    [sym__pair_operator] = ACTIONS(12242),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12242),
    [sym__lazy_and_operator] = ACTIONS(12242),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12242),
    [sym__pipe_left_operator] = ACTIONS(12242),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12242),
    [sym__bitshift_operator] = ACTIONS(12242),
    [sym__power_operator] = ACTIONS(12242),
    [sym__tilde_operator] = ACTIONS(12242),
    [sym__type_order_operator] = ACTIONS(12242),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5309] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5310] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12096),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_DASH_GT] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12096),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12096),
    [sym__bitshift_operator] = ACTIONS(12096),
    [sym__power_operator] = ACTIONS(12096),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5311] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5312] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12386),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12386),
    [anon_sym_RPAREN] = ACTIONS(12386),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12386),
    [anon_sym_RBRACK] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_SEMI] = ACTIONS(12386),
    [anon_sym_LBRACE] = ACTIONS(12386),
    [anon_sym_RBRACE] = ACTIONS(12386),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12386),
    [anon_sym_COLON_COLON] = ACTIONS(12386),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12386),
    [anon_sym_QMARK] = ACTIONS(12386),
    [anon_sym_DASH_GT] = ACTIONS(12386),
    [anon_sym_AT] = ACTIONS(12386),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12386),
    [aux_sym_integer_literal_token2] = ACTIONS(12386),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12386),
    [aux_sym_float_literal_token3] = ACTIONS(12386),
    [aux_sym_float_literal_token4] = ACTIONS(12386),
    [sym_character_literal] = ACTIONS(12386),
    [sym__pair_operator] = ACTIONS(12386),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12386),
    [sym__lazy_and_operator] = ACTIONS(12386),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12386),
    [sym__pipe_left_operator] = ACTIONS(12386),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12386),
    [sym__power_operator] = ACTIONS(12386),
    [sym__tilde_operator] = ACTIONS(12386),
    [sym__type_order_operator] = ACTIONS(12386),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [5313] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_elseif] = ACTIONS(12360),
    [anon_sym_else] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5314] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_finally] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__assignment_operator] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5315] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5316] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_catch] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_DASH_GT] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5317] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_elseif] = ACTIONS(12364),
    [anon_sym_else] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5318] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_finally] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [5319] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_catch] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_DASH_GT] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5320] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12246),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12246),
    [anon_sym_RPAREN] = ACTIONS(12246),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12246),
    [anon_sym_RBRACK] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_SEMI] = ACTIONS(12246),
    [anon_sym_LBRACE] = ACTIONS(12246),
    [anon_sym_RBRACE] = ACTIONS(12246),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12246),
    [anon_sym_COLON_COLON] = ACTIONS(12246),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12246),
    [anon_sym_QMARK] = ACTIONS(12246),
    [anon_sym_DASH_GT] = ACTIONS(12246),
    [anon_sym_AT] = ACTIONS(12246),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12246),
    [aux_sym_integer_literal_token2] = ACTIONS(12246),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12246),
    [aux_sym_float_literal_token3] = ACTIONS(12246),
    [aux_sym_float_literal_token4] = ACTIONS(12246),
    [sym_character_literal] = ACTIONS(12246),
    [sym__pair_operator] = ACTIONS(12246),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12246),
    [sym__lazy_and_operator] = ACTIONS(12246),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12246),
    [sym__pipe_left_operator] = ACTIONS(12246),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12246),
    [sym__bitshift_operator] = ACTIONS(12246),
    [sym__power_operator] = ACTIONS(12246),
    [sym__tilde_operator] = ACTIONS(12246),
    [sym__type_order_operator] = ACTIONS(12246),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5321] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12390),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12390),
    [anon_sym_RPAREN] = ACTIONS(12390),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12390),
    [anon_sym_RBRACK] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_SEMI] = ACTIONS(12390),
    [anon_sym_LBRACE] = ACTIONS(12390),
    [anon_sym_RBRACE] = ACTIONS(12390),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12390),
    [anon_sym_COLON_COLON] = ACTIONS(12390),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12390),
    [anon_sym_QMARK] = ACTIONS(12390),
    [anon_sym_DASH_GT] = ACTIONS(12390),
    [anon_sym_AT] = ACTIONS(12390),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12390),
    [aux_sym_integer_literal_token2] = ACTIONS(12390),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12390),
    [aux_sym_float_literal_token3] = ACTIONS(12390),
    [aux_sym_float_literal_token4] = ACTIONS(12390),
    [sym_character_literal] = ACTIONS(12390),
    [sym__pair_operator] = ACTIONS(12390),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12390),
    [sym__lazy_and_operator] = ACTIONS(12390),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12390),
    [sym__pipe_left_operator] = ACTIONS(12390),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12390),
    [sym__bitshift_operator] = ACTIONS(12390),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(12390),
    [sym__type_order_operator] = ACTIONS(12390),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [5322] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_catch] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_DASH_GT] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5323] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_catch] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__assignment_operator] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5324] = {
    [ts_builtin_sym_end] = ACTIONS(12212),
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_RPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_RBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5325] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_catch] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_DASH_GT] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5326] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_catch] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_DASH_GT] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5327] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12250),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12250),
    [anon_sym_RPAREN] = ACTIONS(12250),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12250),
    [anon_sym_RBRACK] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_SEMI] = ACTIONS(12250),
    [anon_sym_LBRACE] = ACTIONS(12250),
    [anon_sym_RBRACE] = ACTIONS(12250),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12250),
    [anon_sym_COLON_COLON] = ACTIONS(12250),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12250),
    [anon_sym_QMARK] = ACTIONS(12250),
    [anon_sym_DASH_GT] = ACTIONS(12250),
    [anon_sym_AT] = ACTIONS(12250),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12250),
    [aux_sym_integer_literal_token2] = ACTIONS(12250),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12250),
    [aux_sym_float_literal_token3] = ACTIONS(12250),
    [aux_sym_float_literal_token4] = ACTIONS(12250),
    [sym_character_literal] = ACTIONS(12250),
    [sym__pair_operator] = ACTIONS(12250),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12250),
    [sym__lazy_and_operator] = ACTIONS(12250),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12250),
    [sym__pipe_left_operator] = ACTIONS(12250),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12250),
    [sym__bitshift_operator] = ACTIONS(12250),
    [sym__power_operator] = ACTIONS(12250),
    [sym__tilde_operator] = ACTIONS(12250),
    [sym__type_order_operator] = ACTIONS(12250),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5328] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_catch] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_DASH_GT] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5329] = {
    [ts_builtin_sym_end] = ACTIONS(12216),
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_RPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_RBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5330] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_catch] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_DASH_GT] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5331] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2188),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_DASH_GT] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2188),
    [aux_sym_integer_literal_token2] = ACTIONS(2188),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2188),
    [aux_sym_float_literal_token3] = ACTIONS(2188),
    [aux_sym_float_literal_token4] = ACTIONS(2188),
    [sym_character_literal] = ACTIONS(2188),
    [sym__pair_operator] = ACTIONS(2188),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2188),
    [sym__pipe_left_operator] = ACTIONS(2188),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2188),
    [sym__bitshift_operator] = ACTIONS(2188),
    [sym__power_operator] = ACTIONS(2188),
    [sym__tilde_operator] = ACTIONS(2188),
    [sym__type_order_operator] = ACTIONS(2188),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [5332] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12254),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12254),
    [anon_sym_RPAREN] = ACTIONS(12254),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12254),
    [anon_sym_RBRACK] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_SEMI] = ACTIONS(12254),
    [anon_sym_LBRACE] = ACTIONS(12254),
    [anon_sym_RBRACE] = ACTIONS(12254),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12254),
    [anon_sym_COLON_COLON] = ACTIONS(12254),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12254),
    [anon_sym_QMARK] = ACTIONS(12254),
    [anon_sym_DASH_GT] = ACTIONS(12254),
    [anon_sym_AT] = ACTIONS(12254),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12254),
    [aux_sym_integer_literal_token2] = ACTIONS(12254),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12254),
    [aux_sym_float_literal_token3] = ACTIONS(12254),
    [aux_sym_float_literal_token4] = ACTIONS(12254),
    [sym_character_literal] = ACTIONS(12254),
    [sym__pair_operator] = ACTIONS(12254),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12254),
    [sym__lazy_and_operator] = ACTIONS(12254),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12254),
    [sym__pipe_left_operator] = ACTIONS(12254),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12254),
    [sym__bitshift_operator] = ACTIONS(12254),
    [sym__power_operator] = ACTIONS(12254),
    [sym__tilde_operator] = ACTIONS(12254),
    [sym__type_order_operator] = ACTIONS(12254),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5333] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_elseif] = ACTIONS(12334),
    [anon_sym_else] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5334] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_finally] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [5335] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12258),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12258),
    [anon_sym_RPAREN] = ACTIONS(12258),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12258),
    [anon_sym_RBRACK] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_SEMI] = ACTIONS(12258),
    [anon_sym_LBRACE] = ACTIONS(12258),
    [anon_sym_RBRACE] = ACTIONS(12258),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12258),
    [anon_sym_COLON_COLON] = ACTIONS(12258),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12258),
    [anon_sym_QMARK] = ACTIONS(12258),
    [anon_sym_DASH_GT] = ACTIONS(12258),
    [anon_sym_AT] = ACTIONS(12258),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12258),
    [aux_sym_integer_literal_token2] = ACTIONS(12258),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12258),
    [aux_sym_float_literal_token3] = ACTIONS(12258),
    [aux_sym_float_literal_token4] = ACTIONS(12258),
    [sym_character_literal] = ACTIONS(12258),
    [sym__pair_operator] = ACTIONS(12258),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12258),
    [sym__lazy_and_operator] = ACTIONS(12258),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12258),
    [sym__pipe_left_operator] = ACTIONS(12258),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12258),
    [sym__bitshift_operator] = ACTIONS(12258),
    [sym__power_operator] = ACTIONS(12258),
    [sym__tilde_operator] = ACTIONS(12258),
    [sym__type_order_operator] = ACTIONS(12258),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5336] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12328),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12328),
    [anon_sym_RPAREN] = ACTIONS(12328),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12328),
    [anon_sym_RBRACK] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_SEMI] = ACTIONS(12328),
    [anon_sym_LBRACE] = ACTIONS(12328),
    [anon_sym_RBRACE] = ACTIONS(12328),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12328),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12328),
    [anon_sym_QMARK] = ACTIONS(12328),
    [anon_sym_AT] = ACTIONS(12328),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12328),
    [aux_sym_integer_literal_token2] = ACTIONS(12328),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12328),
    [aux_sym_float_literal_token3] = ACTIONS(12328),
    [aux_sym_float_literal_token4] = ACTIONS(12328),
    [sym_character_literal] = ACTIONS(12328),
    [sym__assignment_operator] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12328),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12328),
    [sym__lazy_and_operator] = ACTIONS(12328),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12328),
    [sym__pipe_left_operator] = ACTIONS(12328),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12328),
    [sym__type_order_operator] = ACTIONS(12328),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5337] = {
    [sym_identifier] = STATE(6074),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_DASH_GT] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [5338] = {
    [sym_identifier] = STATE(6076),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_DASH_GT] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [5339] = {
    [sym_identifier] = STATE(6112),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_DASH_GT] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [5340] = {
    [sym_identifier] = STATE(6117),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_DASH_GT] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [5341] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12502),
    [anon_sym_DOT] = ACTIONS(12504),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12506),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12508),
    [sym__immediate_bracket] = ACTIONS(12510),
    [sym__immediate_brace] = ACTIONS(12512),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5342] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11894),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11894),
    [anon_sym_RPAREN] = ACTIONS(11894),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11894),
    [anon_sym_RBRACK] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11894),
    [anon_sym_RBRACE] = ACTIONS(11894),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11894),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11894),
    [anon_sym_QMARK] = ACTIONS(11894),
    [anon_sym_AT] = ACTIONS(11894),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11894),
    [aux_sym_integer_literal_token2] = ACTIONS(11894),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11894),
    [aux_sym_float_literal_token3] = ACTIONS(11894),
    [aux_sym_float_literal_token4] = ACTIONS(11894),
    [sym_character_literal] = ACTIONS(11894),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11894),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11894),
    [sym__lazy_and_operator] = ACTIONS(11894),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11894),
    [sym__pipe_left_operator] = ACTIONS(11894),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11894),
    [sym__type_order_operator] = ACTIONS(11894),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [5343] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_catch] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_DASH_GT] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5344] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [5345] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5346] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_else] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [5347] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__assignment_operator] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [5348] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_elseif] = ACTIONS(12136),
    [anon_sym_else] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5349] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_else] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [5350] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_finally] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [5351] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5352] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5353] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5354] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_elseif] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5355] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_catch] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__assignment_operator] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5356] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_DASH_GT] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5357] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12212),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12212),
    [anon_sym_RPAREN] = ACTIONS(12212),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12212),
    [anon_sym_RBRACK] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_SEMI] = ACTIONS(12212),
    [anon_sym_LBRACE] = ACTIONS(12212),
    [anon_sym_RBRACE] = ACTIONS(12212),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12212),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12212),
    [anon_sym_QMARK] = ACTIONS(12212),
    [anon_sym_AT] = ACTIONS(12212),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12212),
    [aux_sym_integer_literal_token2] = ACTIONS(12212),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12212),
    [aux_sym_float_literal_token3] = ACTIONS(12212),
    [aux_sym_float_literal_token4] = ACTIONS(12212),
    [sym_character_literal] = ACTIONS(12212),
    [sym__assignment_operator] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12212),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12212),
    [sym__lazy_and_operator] = ACTIONS(12212),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12212),
    [sym__pipe_left_operator] = ACTIONS(12212),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12212),
    [sym__type_order_operator] = ACTIONS(12212),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5358] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_DASH_GT] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5359] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5360] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_DASH_GT] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5361] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_DASH_GT] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5362] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_DASH_GT] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5363] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_DASH_GT] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5364] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5365] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5366] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_DASH_GT] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5367] = {
    [ts_builtin_sym_end] = ACTIONS(12056),
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_RBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5368] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [5369] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_elseif] = ACTIONS(12174),
    [anon_sym_else] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5370] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_DASH_GT] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5371] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_DASH_GT] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5372] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_DASH_GT] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5373] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_DASH_GT] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5374] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5375] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_DASH_GT] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5376] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_DASH_GT] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5377] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_DASH_GT] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5378] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_DASH_GT] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5379] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_DASH_GT] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5380] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_DASH_GT] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5381] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_DASH_GT] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5382] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_DASH_GT] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5383] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_DASH_GT] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5384] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_DASH_GT] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5385] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_catch] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_DASH_GT] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5386] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5387] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__assignment_operator] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [5388] = {
    [ts_builtin_sym_end] = ACTIONS(12060),
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_RBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5389] = {
    [ts_builtin_sym_end] = ACTIONS(12044),
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_RBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5390] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [5391] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__assignment_operator] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [5392] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5393] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_catch] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_DASH_GT] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [5394] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_DASH_GT] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5395] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12216),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12216),
    [anon_sym_RPAREN] = ACTIONS(12216),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12216),
    [anon_sym_RBRACK] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_SEMI] = ACTIONS(12216),
    [anon_sym_LBRACE] = ACTIONS(12216),
    [anon_sym_RBRACE] = ACTIONS(12216),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12216),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_QMARK] = ACTIONS(12216),
    [anon_sym_AT] = ACTIONS(12216),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12216),
    [aux_sym_integer_literal_token2] = ACTIONS(12216),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12216),
    [aux_sym_float_literal_token3] = ACTIONS(12216),
    [aux_sym_float_literal_token4] = ACTIONS(12216),
    [sym_character_literal] = ACTIONS(12216),
    [sym__assignment_operator] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12216),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12216),
    [sym__lazy_and_operator] = ACTIONS(12216),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12216),
    [sym__pipe_left_operator] = ACTIONS(12216),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12216),
    [sym__type_order_operator] = ACTIONS(12216),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5396] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [5397] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_finally] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_DASH_GT] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5398] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_finally] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_DASH_GT] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5399] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_catch] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_DASH_GT] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [5400] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_DASH_GT] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5401] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_DASH_GT] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5402] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_DASH_GT] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5403] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12064),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12064),
    [anon_sym_RPAREN] = ACTIONS(12064),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12064),
    [anon_sym_RBRACK] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12064),
    [anon_sym_LBRACE] = ACTIONS(12064),
    [anon_sym_RBRACE] = ACTIONS(12064),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12064),
    [anon_sym_COLON_COLON] = ACTIONS(12064),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12064),
    [anon_sym_QMARK] = ACTIONS(12064),
    [anon_sym_DASH_GT] = ACTIONS(12064),
    [anon_sym_AT] = ACTIONS(12064),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12064),
    [aux_sym_integer_literal_token2] = ACTIONS(12064),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12064),
    [aux_sym_float_literal_token3] = ACTIONS(12064),
    [aux_sym_float_literal_token4] = ACTIONS(12064),
    [sym_character_literal] = ACTIONS(12064),
    [sym__pair_operator] = ACTIONS(12064),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12064),
    [sym__lazy_and_operator] = ACTIONS(12064),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12064),
    [sym__pipe_left_operator] = ACTIONS(12064),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12064),
    [sym__bitshift_operator] = ACTIONS(12064),
    [sym__power_operator] = ACTIONS(12064),
    [sym__tilde_operator] = ACTIONS(12064),
    [sym__type_order_operator] = ACTIONS(12064),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5404] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_RPAREN] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_RBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_RBRACE] = ACTIONS(12052),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_DASH_GT] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12052),
    [sym__bitshift_operator] = ACTIONS(12052),
    [sym__power_operator] = ACTIONS(12052),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5405] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_catch] = ACTIONS(12326),
    [anon_sym_finally] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__assignment_operator] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5406] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12262),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12262),
    [anon_sym_RPAREN] = ACTIONS(12262),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12262),
    [anon_sym_RBRACK] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_SEMI] = ACTIONS(12262),
    [anon_sym_LBRACE] = ACTIONS(12262),
    [anon_sym_RBRACE] = ACTIONS(12262),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12262),
    [anon_sym_COLON_COLON] = ACTIONS(12262),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12262),
    [anon_sym_QMARK] = ACTIONS(12262),
    [anon_sym_DASH_GT] = ACTIONS(12262),
    [anon_sym_AT] = ACTIONS(12262),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12262),
    [aux_sym_integer_literal_token2] = ACTIONS(12262),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12262),
    [aux_sym_float_literal_token3] = ACTIONS(12262),
    [aux_sym_float_literal_token4] = ACTIONS(12262),
    [sym_character_literal] = ACTIONS(12262),
    [sym__pair_operator] = ACTIONS(12262),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12262),
    [sym__lazy_and_operator] = ACTIONS(12262),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12262),
    [sym__pipe_left_operator] = ACTIONS(12262),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12262),
    [sym__bitshift_operator] = ACTIONS(12262),
    [sym__power_operator] = ACTIONS(12262),
    [sym__tilde_operator] = ACTIONS(12262),
    [sym__type_order_operator] = ACTIONS(12262),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5407] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12266),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12266),
    [anon_sym_RPAREN] = ACTIONS(12266),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12266),
    [anon_sym_RBRACK] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_SEMI] = ACTIONS(12266),
    [anon_sym_LBRACE] = ACTIONS(12266),
    [anon_sym_RBRACE] = ACTIONS(12266),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12266),
    [anon_sym_COLON_COLON] = ACTIONS(12266),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12266),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_DASH_GT] = ACTIONS(12266),
    [anon_sym_AT] = ACTIONS(12266),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12266),
    [aux_sym_integer_literal_token2] = ACTIONS(12266),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12266),
    [aux_sym_float_literal_token3] = ACTIONS(12266),
    [aux_sym_float_literal_token4] = ACTIONS(12266),
    [sym_character_literal] = ACTIONS(12266),
    [sym__pair_operator] = ACTIONS(12266),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12266),
    [sym__lazy_and_operator] = ACTIONS(12266),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12266),
    [sym__pipe_left_operator] = ACTIONS(12266),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12266),
    [sym__bitshift_operator] = ACTIONS(12266),
    [sym__power_operator] = ACTIONS(12266),
    [sym__tilde_operator] = ACTIONS(12266),
    [sym__type_order_operator] = ACTIONS(12266),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5408] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12234),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12234),
    [anon_sym_RPAREN] = ACTIONS(12234),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12234),
    [anon_sym_RBRACK] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_SEMI] = ACTIONS(12234),
    [anon_sym_LBRACE] = ACTIONS(12234),
    [anon_sym_RBRACE] = ACTIONS(12234),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12234),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12234),
    [anon_sym_QMARK] = ACTIONS(12234),
    [anon_sym_AT] = ACTIONS(12234),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12234),
    [aux_sym_integer_literal_token2] = ACTIONS(12234),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12234),
    [aux_sym_float_literal_token3] = ACTIONS(12234),
    [aux_sym_float_literal_token4] = ACTIONS(12234),
    [sym_character_literal] = ACTIONS(12234),
    [sym__assignment_operator] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12234),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12234),
    [sym__lazy_and_operator] = ACTIONS(12234),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12234),
    [sym__pipe_left_operator] = ACTIONS(12234),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12234),
    [sym__type_order_operator] = ACTIONS(12234),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5409] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12238),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12238),
    [anon_sym_RPAREN] = ACTIONS(12238),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12238),
    [anon_sym_RBRACK] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_SEMI] = ACTIONS(12238),
    [anon_sym_LBRACE] = ACTIONS(12238),
    [anon_sym_RBRACE] = ACTIONS(12238),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12238),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12238),
    [anon_sym_QMARK] = ACTIONS(12238),
    [anon_sym_AT] = ACTIONS(12238),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12238),
    [aux_sym_integer_literal_token2] = ACTIONS(12238),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12238),
    [aux_sym_float_literal_token3] = ACTIONS(12238),
    [aux_sym_float_literal_token4] = ACTIONS(12238),
    [sym_character_literal] = ACTIONS(12238),
    [sym__assignment_operator] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12238),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12238),
    [sym__lazy_and_operator] = ACTIONS(12238),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12238),
    [sym__pipe_left_operator] = ACTIONS(12238),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12238),
    [sym__type_order_operator] = ACTIONS(12238),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5410] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5411] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5412] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_catch] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__assignment_operator] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5413] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5414] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12514),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5415] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_catch] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_DASH_GT] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [5416] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_catch] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_DASH_GT] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [5417] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_finally] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_DASH_GT] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5418] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12464),
    [anon_sym_DOT] = ACTIONS(12516),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12518),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12470),
    [sym__immediate_bracket] = ACTIONS(12472),
    [sym__immediate_brace] = ACTIONS(12474),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5419] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12458),
    [sym__immediate_command_start] = ACTIONS(12460),
  },
  [5420] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_finally] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_DASH_GT] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5421] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [5422] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12242),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12242),
    [anon_sym_RPAREN] = ACTIONS(12242),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12242),
    [anon_sym_RBRACK] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_SEMI] = ACTIONS(12242),
    [anon_sym_LBRACE] = ACTIONS(12242),
    [anon_sym_RBRACE] = ACTIONS(12242),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12242),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12242),
    [anon_sym_QMARK] = ACTIONS(12242),
    [anon_sym_AT] = ACTIONS(12242),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12242),
    [aux_sym_integer_literal_token2] = ACTIONS(12242),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12242),
    [aux_sym_float_literal_token3] = ACTIONS(12242),
    [aux_sym_float_literal_token4] = ACTIONS(12242),
    [sym_character_literal] = ACTIONS(12242),
    [sym__assignment_operator] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12242),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12242),
    [sym__lazy_and_operator] = ACTIONS(12242),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12242),
    [sym__pipe_left_operator] = ACTIONS(12242),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12242),
    [sym__type_order_operator] = ACTIONS(12242),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5423] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12290),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12290),
    [anon_sym_RPAREN] = ACTIONS(12290),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12290),
    [anon_sym_RBRACK] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_SEMI] = ACTIONS(12290),
    [anon_sym_LBRACE] = ACTIONS(12290),
    [anon_sym_RBRACE] = ACTIONS(12290),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12290),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_QMARK] = ACTIONS(12290),
    [anon_sym_AT] = ACTIONS(12290),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12290),
    [aux_sym_integer_literal_token2] = ACTIONS(12290),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12290),
    [aux_sym_float_literal_token3] = ACTIONS(12290),
    [aux_sym_float_literal_token4] = ACTIONS(12290),
    [sym_character_literal] = ACTIONS(12290),
    [sym__assignment_operator] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12290),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12290),
    [sym__lazy_and_operator] = ACTIONS(12290),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12290),
    [sym__pipe_left_operator] = ACTIONS(12290),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12290),
    [sym__type_order_operator] = ACTIONS(12290),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5424] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12270),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12270),
    [anon_sym_RPAREN] = ACTIONS(12270),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12270),
    [anon_sym_RBRACK] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_SEMI] = ACTIONS(12270),
    [anon_sym_LBRACE] = ACTIONS(12270),
    [anon_sym_RBRACE] = ACTIONS(12270),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12270),
    [anon_sym_COLON_COLON] = ACTIONS(12270),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_QMARK] = ACTIONS(12270),
    [anon_sym_DASH_GT] = ACTIONS(12270),
    [anon_sym_AT] = ACTIONS(12270),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12270),
    [aux_sym_integer_literal_token2] = ACTIONS(12270),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12270),
    [aux_sym_float_literal_token3] = ACTIONS(12270),
    [aux_sym_float_literal_token4] = ACTIONS(12270),
    [sym_character_literal] = ACTIONS(12270),
    [sym__pair_operator] = ACTIONS(12270),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12270),
    [sym__lazy_and_operator] = ACTIONS(12270),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12270),
    [sym__pipe_left_operator] = ACTIONS(12270),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12270),
    [sym__bitshift_operator] = ACTIONS(12270),
    [sym__power_operator] = ACTIONS(12270),
    [sym__tilde_operator] = ACTIONS(12270),
    [sym__type_order_operator] = ACTIONS(12270),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5425] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5426] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5427] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_RPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_SEMI] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5428] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5429] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12274),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12274),
    [anon_sym_RPAREN] = ACTIONS(12274),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12274),
    [anon_sym_RBRACK] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_SEMI] = ACTIONS(12274),
    [anon_sym_LBRACE] = ACTIONS(12274),
    [anon_sym_RBRACE] = ACTIONS(12274),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12274),
    [anon_sym_COLON_COLON] = ACTIONS(12274),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12274),
    [anon_sym_QMARK] = ACTIONS(12274),
    [anon_sym_DASH_GT] = ACTIONS(12274),
    [anon_sym_AT] = ACTIONS(12274),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12274),
    [aux_sym_integer_literal_token2] = ACTIONS(12274),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12274),
    [aux_sym_float_literal_token3] = ACTIONS(12274),
    [aux_sym_float_literal_token4] = ACTIONS(12274),
    [sym_character_literal] = ACTIONS(12274),
    [sym__pair_operator] = ACTIONS(12274),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12274),
    [sym__lazy_and_operator] = ACTIONS(12274),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12274),
    [sym__pipe_left_operator] = ACTIONS(12274),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12274),
    [sym__bitshift_operator] = ACTIONS(12274),
    [sym__power_operator] = ACTIONS(12274),
    [sym__tilde_operator] = ACTIONS(12274),
    [sym__type_order_operator] = ACTIONS(12274),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5430] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12278),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12278),
    [anon_sym_RPAREN] = ACTIONS(12278),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12278),
    [anon_sym_RBRACK] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12278),
    [anon_sym_LBRACE] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(12278),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12278),
    [anon_sym_COLON_COLON] = ACTIONS(12278),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12278),
    [anon_sym_QMARK] = ACTIONS(12278),
    [anon_sym_DASH_GT] = ACTIONS(12278),
    [anon_sym_AT] = ACTIONS(12278),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12278),
    [aux_sym_integer_literal_token2] = ACTIONS(12278),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12278),
    [aux_sym_float_literal_token3] = ACTIONS(12278),
    [aux_sym_float_literal_token4] = ACTIONS(12278),
    [sym_character_literal] = ACTIONS(12278),
    [sym__pair_operator] = ACTIONS(12278),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12278),
    [sym__lazy_and_operator] = ACTIONS(12278),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12278),
    [sym__pipe_left_operator] = ACTIONS(12278),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12278),
    [sym__bitshift_operator] = ACTIONS(12278),
    [sym__power_operator] = ACTIONS(12278),
    [sym__tilde_operator] = ACTIONS(12278),
    [sym__type_order_operator] = ACTIONS(12278),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5431] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_catch] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_DASH_GT] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5432] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12068),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12068),
    [anon_sym_RPAREN] = ACTIONS(12068),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12068),
    [anon_sym_RBRACK] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12068),
    [anon_sym_LBRACE] = ACTIONS(12068),
    [anon_sym_RBRACE] = ACTIONS(12068),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12068),
    [anon_sym_COLON_COLON] = ACTIONS(12068),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12068),
    [anon_sym_QMARK] = ACTIONS(12068),
    [anon_sym_DASH_GT] = ACTIONS(12068),
    [anon_sym_AT] = ACTIONS(12068),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12068),
    [aux_sym_integer_literal_token2] = ACTIONS(12068),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12068),
    [aux_sym_float_literal_token3] = ACTIONS(12068),
    [aux_sym_float_literal_token4] = ACTIONS(12068),
    [sym_character_literal] = ACTIONS(12068),
    [sym__pair_operator] = ACTIONS(12068),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12068),
    [sym__lazy_and_operator] = ACTIONS(12068),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12068),
    [sym__pipe_left_operator] = ACTIONS(12068),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12068),
    [sym__bitshift_operator] = ACTIONS(12068),
    [sym__power_operator] = ACTIONS(12068),
    [sym__tilde_operator] = ACTIONS(12068),
    [sym__type_order_operator] = ACTIONS(12068),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5433] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12282),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12282),
    [anon_sym_RPAREN] = ACTIONS(12282),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12282),
    [anon_sym_RBRACK] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_SEMI] = ACTIONS(12282),
    [anon_sym_LBRACE] = ACTIONS(12282),
    [anon_sym_RBRACE] = ACTIONS(12282),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12282),
    [anon_sym_COLON_COLON] = ACTIONS(12282),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12282),
    [anon_sym_QMARK] = ACTIONS(12282),
    [anon_sym_DASH_GT] = ACTIONS(12282),
    [anon_sym_AT] = ACTIONS(12282),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12282),
    [aux_sym_integer_literal_token2] = ACTIONS(12282),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12282),
    [aux_sym_float_literal_token3] = ACTIONS(12282),
    [aux_sym_float_literal_token4] = ACTIONS(12282),
    [sym_character_literal] = ACTIONS(12282),
    [sym__pair_operator] = ACTIONS(12282),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12282),
    [sym__lazy_and_operator] = ACTIONS(12282),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12282),
    [sym__pipe_left_operator] = ACTIONS(12282),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12282),
    [sym__bitshift_operator] = ACTIONS(12282),
    [sym__power_operator] = ACTIONS(12282),
    [sym__tilde_operator] = ACTIONS(12282),
    [sym__type_order_operator] = ACTIONS(12282),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5434] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12140),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12140),
    [anon_sym_RPAREN] = ACTIONS(12140),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12140),
    [anon_sym_RBRACK] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_SEMI] = ACTIONS(12140),
    [anon_sym_LBRACE] = ACTIONS(12140),
    [anon_sym_RBRACE] = ACTIONS(12140),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12140),
    [anon_sym_COLON_COLON] = ACTIONS(12140),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12140),
    [anon_sym_QMARK] = ACTIONS(12140),
    [anon_sym_DASH_GT] = ACTIONS(12140),
    [anon_sym_AT] = ACTIONS(12140),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12140),
    [aux_sym_integer_literal_token2] = ACTIONS(12140),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12140),
    [aux_sym_float_literal_token3] = ACTIONS(12140),
    [aux_sym_float_literal_token4] = ACTIONS(12140),
    [sym_character_literal] = ACTIONS(12140),
    [sym__pair_operator] = ACTIONS(12140),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12140),
    [sym__lazy_and_operator] = ACTIONS(12140),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12140),
    [sym__pipe_left_operator] = ACTIONS(12140),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12140),
    [sym__bitshift_operator] = ACTIONS(12140),
    [sym__power_operator] = ACTIONS(12140),
    [sym__tilde_operator] = ACTIONS(12140),
    [sym__type_order_operator] = ACTIONS(12140),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5435] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12144),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12144),
    [anon_sym_RPAREN] = ACTIONS(12144),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12144),
    [anon_sym_RBRACK] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_SEMI] = ACTIONS(12144),
    [anon_sym_LBRACE] = ACTIONS(12144),
    [anon_sym_RBRACE] = ACTIONS(12144),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12144),
    [anon_sym_COLON_COLON] = ACTIONS(12144),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12144),
    [anon_sym_QMARK] = ACTIONS(12144),
    [anon_sym_DASH_GT] = ACTIONS(12144),
    [anon_sym_AT] = ACTIONS(12144),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12144),
    [aux_sym_integer_literal_token2] = ACTIONS(12144),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12144),
    [aux_sym_float_literal_token3] = ACTIONS(12144),
    [aux_sym_float_literal_token4] = ACTIONS(12144),
    [sym_character_literal] = ACTIONS(12144),
    [sym__pair_operator] = ACTIONS(12144),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12144),
    [sym__lazy_and_operator] = ACTIONS(12144),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12144),
    [sym__pipe_left_operator] = ACTIONS(12144),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12144),
    [sym__bitshift_operator] = ACTIONS(12144),
    [sym__power_operator] = ACTIONS(12144),
    [sym__tilde_operator] = ACTIONS(12144),
    [sym__type_order_operator] = ACTIONS(12144),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5436] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12148),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12148),
    [anon_sym_RPAREN] = ACTIONS(12148),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12148),
    [anon_sym_RBRACK] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_SEMI] = ACTIONS(12148),
    [anon_sym_LBRACE] = ACTIONS(12148),
    [anon_sym_RBRACE] = ACTIONS(12148),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12148),
    [anon_sym_COLON_COLON] = ACTIONS(12148),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12148),
    [anon_sym_QMARK] = ACTIONS(12148),
    [anon_sym_DASH_GT] = ACTIONS(12148),
    [anon_sym_AT] = ACTIONS(12148),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12148),
    [aux_sym_integer_literal_token2] = ACTIONS(12148),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12148),
    [aux_sym_float_literal_token3] = ACTIONS(12148),
    [aux_sym_float_literal_token4] = ACTIONS(12148),
    [sym_character_literal] = ACTIONS(12148),
    [sym__pair_operator] = ACTIONS(12148),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12148),
    [sym__lazy_and_operator] = ACTIONS(12148),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12148),
    [sym__pipe_left_operator] = ACTIONS(12148),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12148),
    [sym__bitshift_operator] = ACTIONS(12148),
    [sym__power_operator] = ACTIONS(12148),
    [sym__tilde_operator] = ACTIONS(12148),
    [sym__type_order_operator] = ACTIONS(12148),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5437] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_RPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_SEMI] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [5438] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11890),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11890),
    [anon_sym_RPAREN] = ACTIONS(11890),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11890),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11890),
    [anon_sym_RBRACE] = ACTIONS(11890),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11890),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11890),
    [anon_sym_QMARK] = ACTIONS(11890),
    [anon_sym_AT] = ACTIONS(11890),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11890),
    [aux_sym_integer_literal_token2] = ACTIONS(11890),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11890),
    [aux_sym_float_literal_token3] = ACTIONS(11890),
    [aux_sym_float_literal_token4] = ACTIONS(11890),
    [sym_character_literal] = ACTIONS(11890),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11890),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11890),
    [sym__lazy_and_operator] = ACTIONS(11890),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11890),
    [sym__pipe_left_operator] = ACTIONS(11890),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11890),
    [sym__type_order_operator] = ACTIONS(11890),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5439] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12156),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12156),
    [anon_sym_RPAREN] = ACTIONS(12156),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12156),
    [anon_sym_RBRACK] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_SEMI] = ACTIONS(12156),
    [anon_sym_LBRACE] = ACTIONS(12156),
    [anon_sym_RBRACE] = ACTIONS(12156),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12156),
    [anon_sym_COLON_COLON] = ACTIONS(12156),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12156),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_DASH_GT] = ACTIONS(12156),
    [anon_sym_AT] = ACTIONS(12156),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12156),
    [aux_sym_integer_literal_token2] = ACTIONS(12156),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12156),
    [aux_sym_float_literal_token3] = ACTIONS(12156),
    [aux_sym_float_literal_token4] = ACTIONS(12156),
    [sym_character_literal] = ACTIONS(12156),
    [sym__pair_operator] = ACTIONS(12156),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12156),
    [sym__lazy_and_operator] = ACTIONS(12156),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12156),
    [sym__pipe_left_operator] = ACTIONS(12156),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12156),
    [sym__bitshift_operator] = ACTIONS(12156),
    [sym__power_operator] = ACTIONS(12156),
    [sym__tilde_operator] = ACTIONS(12156),
    [sym__type_order_operator] = ACTIONS(12156),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5440] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12160),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12160),
    [anon_sym_RPAREN] = ACTIONS(12160),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12160),
    [anon_sym_RBRACK] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_SEMI] = ACTIONS(12160),
    [anon_sym_LBRACE] = ACTIONS(12160),
    [anon_sym_RBRACE] = ACTIONS(12160),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12160),
    [anon_sym_COLON_COLON] = ACTIONS(12160),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12160),
    [anon_sym_QMARK] = ACTIONS(12160),
    [anon_sym_DASH_GT] = ACTIONS(12160),
    [anon_sym_AT] = ACTIONS(12160),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12160),
    [aux_sym_integer_literal_token2] = ACTIONS(12160),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12160),
    [aux_sym_float_literal_token3] = ACTIONS(12160),
    [aux_sym_float_literal_token4] = ACTIONS(12160),
    [sym_character_literal] = ACTIONS(12160),
    [sym__pair_operator] = ACTIONS(12160),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12160),
    [sym__lazy_and_operator] = ACTIONS(12160),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12160),
    [sym__pipe_left_operator] = ACTIONS(12160),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12160),
    [sym__bitshift_operator] = ACTIONS(12160),
    [sym__power_operator] = ACTIONS(12160),
    [sym__tilde_operator] = ACTIONS(12160),
    [sym__type_order_operator] = ACTIONS(12160),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5441] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12208),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12208),
    [anon_sym_RPAREN] = ACTIONS(12208),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_SEMI] = ACTIONS(12208),
    [anon_sym_LBRACE] = ACTIONS(12208),
    [anon_sym_RBRACE] = ACTIONS(12208),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12208),
    [anon_sym_COLON_COLON] = ACTIONS(12208),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12208),
    [anon_sym_QMARK] = ACTIONS(12208),
    [anon_sym_DASH_GT] = ACTIONS(12208),
    [anon_sym_AT] = ACTIONS(12208),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12208),
    [aux_sym_integer_literal_token2] = ACTIONS(12208),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12208),
    [aux_sym_float_literal_token3] = ACTIONS(12208),
    [aux_sym_float_literal_token4] = ACTIONS(12208),
    [sym_character_literal] = ACTIONS(12208),
    [sym__pair_operator] = ACTIONS(12208),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12208),
    [sym__lazy_and_operator] = ACTIONS(12208),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12208),
    [sym__pipe_left_operator] = ACTIONS(12208),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12208),
    [sym__bitshift_operator] = ACTIONS(12208),
    [sym__power_operator] = ACTIONS(12208),
    [sym__tilde_operator] = ACTIONS(12208),
    [sym__type_order_operator] = ACTIONS(12208),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5442] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5443] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_DASH_GT] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [5444] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_DASH_GT] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [5445] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [5446] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12164),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12164),
    [anon_sym_RPAREN] = ACTIONS(12164),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12164),
    [anon_sym_RBRACK] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12164),
    [anon_sym_LBRACE] = ACTIONS(12164),
    [anon_sym_RBRACE] = ACTIONS(12164),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12164),
    [anon_sym_COLON_COLON] = ACTIONS(12164),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12164),
    [anon_sym_QMARK] = ACTIONS(12164),
    [anon_sym_DASH_GT] = ACTIONS(12164),
    [anon_sym_AT] = ACTIONS(12164),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12164),
    [aux_sym_integer_literal_token2] = ACTIONS(12164),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12164),
    [aux_sym_float_literal_token3] = ACTIONS(12164),
    [aux_sym_float_literal_token4] = ACTIONS(12164),
    [sym_character_literal] = ACTIONS(12164),
    [sym__pair_operator] = ACTIONS(12164),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12164),
    [sym__lazy_and_operator] = ACTIONS(12164),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12164),
    [sym__pipe_left_operator] = ACTIONS(12164),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12164),
    [sym__bitshift_operator] = ACTIONS(12164),
    [sym__power_operator] = ACTIONS(12164),
    [sym__tilde_operator] = ACTIONS(12164),
    [sym__type_order_operator] = ACTIONS(12164),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5447] = {
    [ts_builtin_sym_end] = ACTIONS(12234),
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_RPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_RBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5448] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12168),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12168),
    [anon_sym_RPAREN] = ACTIONS(12168),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12168),
    [anon_sym_RBRACK] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_SEMI] = ACTIONS(12168),
    [anon_sym_LBRACE] = ACTIONS(12168),
    [anon_sym_RBRACE] = ACTIONS(12168),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12168),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(12168),
    [anon_sym_DASH_GT] = ACTIONS(12168),
    [anon_sym_AT] = ACTIONS(12168),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12168),
    [aux_sym_integer_literal_token2] = ACTIONS(12168),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12168),
    [aux_sym_float_literal_token3] = ACTIONS(12168),
    [aux_sym_float_literal_token4] = ACTIONS(12168),
    [sym_character_literal] = ACTIONS(12168),
    [sym__pair_operator] = ACTIONS(12168),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12168),
    [sym__lazy_and_operator] = ACTIONS(12168),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12168),
    [sym__pipe_left_operator] = ACTIONS(12168),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12168),
    [sym__bitshift_operator] = ACTIONS(12168),
    [sym__power_operator] = ACTIONS(12168),
    [sym__tilde_operator] = ACTIONS(12168),
    [sym__type_order_operator] = ACTIONS(12168),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5449] = {
    [ts_builtin_sym_end] = ACTIONS(12238),
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_RPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_RBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5450] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12246),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12246),
    [anon_sym_RPAREN] = ACTIONS(12246),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12246),
    [anon_sym_RBRACK] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_SEMI] = ACTIONS(12246),
    [anon_sym_LBRACE] = ACTIONS(12246),
    [anon_sym_RBRACE] = ACTIONS(12246),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12246),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12246),
    [anon_sym_QMARK] = ACTIONS(12246),
    [anon_sym_AT] = ACTIONS(12246),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12246),
    [aux_sym_integer_literal_token2] = ACTIONS(12246),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12246),
    [aux_sym_float_literal_token3] = ACTIONS(12246),
    [aux_sym_float_literal_token4] = ACTIONS(12246),
    [sym_character_literal] = ACTIONS(12246),
    [sym__assignment_operator] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12246),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12246),
    [sym__lazy_and_operator] = ACTIONS(12246),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12246),
    [sym__pipe_left_operator] = ACTIONS(12246),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12246),
    [sym__type_order_operator] = ACTIONS(12246),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5451] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12250),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12250),
    [anon_sym_RPAREN] = ACTIONS(12250),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12250),
    [anon_sym_RBRACK] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_SEMI] = ACTIONS(12250),
    [anon_sym_LBRACE] = ACTIONS(12250),
    [anon_sym_RBRACE] = ACTIONS(12250),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12250),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12250),
    [anon_sym_QMARK] = ACTIONS(12250),
    [anon_sym_AT] = ACTIONS(12250),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12250),
    [aux_sym_integer_literal_token2] = ACTIONS(12250),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12250),
    [aux_sym_float_literal_token3] = ACTIONS(12250),
    [aux_sym_float_literal_token4] = ACTIONS(12250),
    [sym_character_literal] = ACTIONS(12250),
    [sym__assignment_operator] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12250),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12250),
    [sym__lazy_and_operator] = ACTIONS(12250),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12250),
    [sym__pipe_left_operator] = ACTIONS(12250),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12250),
    [sym__type_order_operator] = ACTIONS(12250),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5452] = {
    [ts_builtin_sym_end] = ACTIONS(12242),
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_RPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_RBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5453] = {
    [ts_builtin_sym_end] = ACTIONS(12290),
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_RPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_RBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5454] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12176),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12176),
    [anon_sym_RPAREN] = ACTIONS(12176),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12176),
    [anon_sym_RBRACK] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_SEMI] = ACTIONS(12176),
    [anon_sym_LBRACE] = ACTIONS(12176),
    [anon_sym_RBRACE] = ACTIONS(12176),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12176),
    [anon_sym_COLON_COLON] = ACTIONS(12176),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12176),
    [anon_sym_QMARK] = ACTIONS(12176),
    [anon_sym_DASH_GT] = ACTIONS(12176),
    [anon_sym_AT] = ACTIONS(12176),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12176),
    [aux_sym_integer_literal_token2] = ACTIONS(12176),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12176),
    [aux_sym_float_literal_token3] = ACTIONS(12176),
    [aux_sym_float_literal_token4] = ACTIONS(12176),
    [sym_character_literal] = ACTIONS(12176),
    [sym__pair_operator] = ACTIONS(12176),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12176),
    [sym__lazy_and_operator] = ACTIONS(12176),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12176),
    [sym__pipe_left_operator] = ACTIONS(12176),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12176),
    [sym__bitshift_operator] = ACTIONS(12176),
    [sym__power_operator] = ACTIONS(12176),
    [sym__tilde_operator] = ACTIONS(12176),
    [sym__type_order_operator] = ACTIONS(12176),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5455] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_else] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5456] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_else] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5457] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5458] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12520),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5459] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_catch] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__assignment_operator] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5460] = {
    [sym_identifier] = STATE(6170),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_catch] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [5461] = {
    [sym_identifier] = STATE(6173),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_catch] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [5462] = {
    [sym_identifier] = STATE(6189),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_catch] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [5463] = {
    [sym_identifier] = STATE(6192),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_catch] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [5464] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__assignment_operator] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [5465] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_finally] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [5466] = {
    [sym__word_identifier] = ACTIONS(12410),
    [anon_sym_EQ] = ACTIONS(12410),
    [anon_sym_COMMA] = ACTIONS(12410),
    [anon_sym_COLON] = ACTIONS(12410),
    [anon_sym_begin] = ACTIONS(12410),
    [anon_sym_module] = ACTIONS(12410),
    [anon_sym_baremodule] = ACTIONS(12410),
    [anon_sym_end] = ACTIONS(12410),
    [anon_sym_abstract] = ACTIONS(12410),
    [anon_sym_primitive] = ACTIONS(12410),
    [anon_sym_mutable] = ACTIONS(12410),
    [anon_sym_struct] = ACTIONS(12410),
    [anon_sym_function] = ACTIONS(12410),
    [anon_sym_macro] = ACTIONS(12410),
    [anon_sym_where] = ACTIONS(12410),
    [anon_sym_quote] = ACTIONS(12410),
    [anon_sym_let] = ACTIONS(12410),
    [anon_sym_if] = ACTIONS(12410),
    [anon_sym_else] = ACTIONS(12410),
    [anon_sym_try] = ACTIONS(12410),
    [anon_sym_finally] = ACTIONS(12410),
    [anon_sym_for] = ACTIONS(12410),
    [anon_sym_while] = ACTIONS(12410),
    [sym_break_statement] = ACTIONS(12410),
    [sym_continue_statement] = ACTIONS(12410),
    [anon_sym_return] = ACTIONS(12410),
    [anon_sym_const] = ACTIONS(12410),
    [anon_sym_global] = ACTIONS(12410),
    [anon_sym_local] = ACTIONS(12410),
    [anon_sym_LPAREN] = ACTIONS(12410),
    [anon_sym_COLON2] = ACTIONS(12410),
    [anon_sym_export] = ACTIONS(12410),
    [anon_sym_import] = ACTIONS(12410),
    [anon_sym_using] = ACTIONS(12410),
    [anon_sym_LBRACK] = ACTIONS(12410),
    [anon_sym_LF] = ACTIONS(12476),
    [anon_sym_in] = ACTIONS(12410),
    [anon_sym_LBRACE] = ACTIONS(12410),
    [anon_sym_SQUOTE] = ACTIONS(12522),
    [anon_sym_DOT] = ACTIONS(12524),
    [anon_sym_DOLLAR] = ACTIONS(12410),
    [anon_sym_COLON_COLON] = ACTIONS(12410),
    [anon_sym_isa] = ACTIONS(12410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12410),
    [anon_sym_QMARK] = ACTIONS(12410),
    [anon_sym_AT] = ACTIONS(12410),
    [anon_sym_true] = ACTIONS(12410),
    [anon_sym_false] = ACTIONS(12410),
    [aux_sym_integer_literal_token1] = ACTIONS(12410),
    [aux_sym_integer_literal_token2] = ACTIONS(12410),
    [aux_sym_integer_literal_token3] = ACTIONS(12410),
    [aux_sym_integer_literal_token4] = ACTIONS(12410),
    [aux_sym_float_literal_token1] = ACTIONS(12410),
    [aux_sym_float_literal_token3] = ACTIONS(12410),
    [aux_sym_float_literal_token4] = ACTIONS(12410),
    [sym_character_literal] = ACTIONS(12410),
    [sym__pair_operator] = ACTIONS(12410),
    [sym__arrow_operator] = ACTIONS(12410),
    [sym__lazy_or_operator] = ACTIONS(12410),
    [sym__lazy_and_operator] = ACTIONS(12410),
    [sym__comparison_operator] = ACTIONS(12410),
    [sym__pipe_right_operator] = ACTIONS(12410),
    [sym__pipe_left_operator] = ACTIONS(12410),
    [sym__ellipsis_operator] = ACTIONS(12410),
    [sym__plus_operator] = ACTIONS(12410),
    [sym__times_operator] = ACTIONS(12410),
    [sym__rational_operator] = ACTIONS(12410),
    [sym__bitshift_operator] = ACTIONS(12410),
    [sym__power_operator] = ACTIONS(12410),
    [sym__tilde_operator] = ACTIONS(12410),
    [sym__type_order_operator] = ACTIONS(12410),
    [sym__unary_operator] = ACTIONS(12410),
    [sym__unary_plus_operator] = ACTIONS(12410),
    [aux_sym__terminator_token1] = ACTIONS(12410),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12526),
    [sym__immediate_bracket] = ACTIONS(12528),
    [sym__immediate_brace] = ACTIONS(12530),
    [sym__string_start] = ACTIONS(12476),
    [sym__command_start] = ACTIONS(12476),
  },
  [5467] = {
    [ts_builtin_sym_end] = ACTIONS(12386),
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_RPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_RBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [5468] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_catch] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__assignment_operator] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5469] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12532),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5470] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5471] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12254),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12254),
    [anon_sym_RPAREN] = ACTIONS(12254),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12254),
    [anon_sym_RBRACK] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_SEMI] = ACTIONS(12254),
    [anon_sym_LBRACE] = ACTIONS(12254),
    [anon_sym_RBRACE] = ACTIONS(12254),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12254),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12254),
    [anon_sym_QMARK] = ACTIONS(12254),
    [anon_sym_AT] = ACTIONS(12254),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12254),
    [aux_sym_integer_literal_token2] = ACTIONS(12254),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12254),
    [aux_sym_float_literal_token3] = ACTIONS(12254),
    [aux_sym_float_literal_token4] = ACTIONS(12254),
    [sym_character_literal] = ACTIONS(12254),
    [sym__assignment_operator] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12254),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12254),
    [sym__lazy_and_operator] = ACTIONS(12254),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12254),
    [sym__pipe_left_operator] = ACTIONS(12254),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12254),
    [sym__type_order_operator] = ACTIONS(12254),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5472] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12258),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12258),
    [anon_sym_RPAREN] = ACTIONS(12258),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12258),
    [anon_sym_RBRACK] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_SEMI] = ACTIONS(12258),
    [anon_sym_LBRACE] = ACTIONS(12258),
    [anon_sym_RBRACE] = ACTIONS(12258),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12258),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12258),
    [anon_sym_QMARK] = ACTIONS(12258),
    [anon_sym_AT] = ACTIONS(12258),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12258),
    [aux_sym_integer_literal_token2] = ACTIONS(12258),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12258),
    [aux_sym_float_literal_token3] = ACTIONS(12258),
    [aux_sym_float_literal_token4] = ACTIONS(12258),
    [sym_character_literal] = ACTIONS(12258),
    [sym__assignment_operator] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12258),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12258),
    [sym__lazy_and_operator] = ACTIONS(12258),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12258),
    [sym__pipe_left_operator] = ACTIONS(12258),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12258),
    [sym__type_order_operator] = ACTIONS(12258),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5473] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12298),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12298),
    [anon_sym_RPAREN] = ACTIONS(12298),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12298),
    [anon_sym_RBRACK] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_SEMI] = ACTIONS(12298),
    [anon_sym_LBRACE] = ACTIONS(12298),
    [anon_sym_RBRACE] = ACTIONS(12298),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12298),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12298),
    [anon_sym_QMARK] = ACTIONS(12298),
    [anon_sym_AT] = ACTIONS(12298),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12298),
    [aux_sym_integer_literal_token2] = ACTIONS(12298),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12298),
    [aux_sym_float_literal_token3] = ACTIONS(12298),
    [aux_sym_float_literal_token4] = ACTIONS(12298),
    [sym_character_literal] = ACTIONS(12298),
    [sym__assignment_operator] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12298),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12298),
    [sym__lazy_and_operator] = ACTIONS(12298),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12298),
    [sym__pipe_left_operator] = ACTIONS(12298),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12298),
    [sym__type_order_operator] = ACTIONS(12298),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5474] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_else] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5475] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_finally] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [5476] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_catch] = ACTIONS(12308),
    [anon_sym_finally] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__assignment_operator] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5477] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12056),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12056),
    [anon_sym_RPAREN] = ACTIONS(12056),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12056),
    [anon_sym_RBRACK] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12056),
    [anon_sym_LBRACE] = ACTIONS(12056),
    [anon_sym_RBRACE] = ACTIONS(12056),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12056),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12056),
    [anon_sym_QMARK] = ACTIONS(12056),
    [anon_sym_AT] = ACTIONS(12056),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12056),
    [aux_sym_integer_literal_token2] = ACTIONS(12056),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12056),
    [aux_sym_float_literal_token3] = ACTIONS(12056),
    [aux_sym_float_literal_token4] = ACTIONS(12056),
    [sym_character_literal] = ACTIONS(12056),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12056),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12056),
    [sym__lazy_and_operator] = ACTIONS(12056),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12056),
    [sym__pipe_left_operator] = ACTIONS(12056),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12056),
    [sym__type_order_operator] = ACTIONS(12056),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5478] = {
    [sym_identifier] = STATE(6279),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__assignment_operator] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [5479] = {
    [ts_builtin_sym_end] = ACTIONS(12246),
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_RPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_RBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5480] = {
    [ts_builtin_sym_end] = ACTIONS(12250),
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_RPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_RBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5481] = {
    [ts_builtin_sym_end] = ACTIONS(12254),
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_RPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_RBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5482] = {
    [ts_builtin_sym_end] = ACTIONS(12258),
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_RPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_RBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5483] = {
    [sym__word_identifier] = ACTIONS(12194),
    [anon_sym_EQ] = ACTIONS(12194),
    [anon_sym_COMMA] = ACTIONS(12194),
    [anon_sym_COLON] = ACTIONS(12194),
    [anon_sym_begin] = ACTIONS(12194),
    [anon_sym_module] = ACTIONS(12194),
    [anon_sym_baremodule] = ACTIONS(12194),
    [anon_sym_end] = ACTIONS(12194),
    [anon_sym_abstract] = ACTIONS(12194),
    [anon_sym_primitive] = ACTIONS(12194),
    [anon_sym_mutable] = ACTIONS(12194),
    [anon_sym_struct] = ACTIONS(12194),
    [anon_sym_function] = ACTIONS(12194),
    [anon_sym_macro] = ACTIONS(12194),
    [anon_sym_where] = ACTIONS(12194),
    [anon_sym_quote] = ACTIONS(12194),
    [anon_sym_let] = ACTIONS(12194),
    [anon_sym_if] = ACTIONS(12194),
    [anon_sym_try] = ACTIONS(12194),
    [anon_sym_finally] = ACTIONS(12194),
    [anon_sym_for] = ACTIONS(12194),
    [anon_sym_while] = ACTIONS(12194),
    [sym_break_statement] = ACTIONS(12194),
    [sym_continue_statement] = ACTIONS(12194),
    [anon_sym_return] = ACTIONS(12194),
    [anon_sym_const] = ACTIONS(12194),
    [anon_sym_global] = ACTIONS(12194),
    [anon_sym_local] = ACTIONS(12194),
    [anon_sym_LPAREN] = ACTIONS(12194),
    [anon_sym_COLON2] = ACTIONS(12194),
    [anon_sym_export] = ACTIONS(12194),
    [anon_sym_import] = ACTIONS(12194),
    [anon_sym_using] = ACTIONS(12194),
    [anon_sym_LBRACK] = ACTIONS(12194),
    [anon_sym_LF] = ACTIONS(12196),
    [anon_sym_in] = ACTIONS(12194),
    [anon_sym_LBRACE] = ACTIONS(12194),
    [anon_sym_SQUOTE] = ACTIONS(12534),
    [anon_sym_DOT] = ACTIONS(12536),
    [anon_sym_DOLLAR] = ACTIONS(12194),
    [anon_sym_COLON_COLON] = ACTIONS(12194),
    [anon_sym_isa] = ACTIONS(12194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12194),
    [anon_sym_QMARK] = ACTIONS(12194),
    [anon_sym_DASH_GT] = ACTIONS(12194),
    [anon_sym_AT] = ACTIONS(12194),
    [anon_sym_true] = ACTIONS(12194),
    [anon_sym_false] = ACTIONS(12194),
    [aux_sym_integer_literal_token1] = ACTIONS(12194),
    [aux_sym_integer_literal_token2] = ACTIONS(12194),
    [aux_sym_integer_literal_token3] = ACTIONS(12194),
    [aux_sym_integer_literal_token4] = ACTIONS(12194),
    [aux_sym_float_literal_token1] = ACTIONS(12194),
    [aux_sym_float_literal_token3] = ACTIONS(12194),
    [aux_sym_float_literal_token4] = ACTIONS(12194),
    [sym_character_literal] = ACTIONS(12194),
    [sym__pair_operator] = ACTIONS(12194),
    [sym__arrow_operator] = ACTIONS(12194),
    [sym__lazy_or_operator] = ACTIONS(12194),
    [sym__lazy_and_operator] = ACTIONS(12194),
    [sym__comparison_operator] = ACTIONS(12194),
    [sym__pipe_right_operator] = ACTIONS(12194),
    [sym__pipe_left_operator] = ACTIONS(12194),
    [sym__ellipsis_operator] = ACTIONS(12194),
    [sym__plus_operator] = ACTIONS(12194),
    [sym__times_operator] = ACTIONS(12194),
    [sym__rational_operator] = ACTIONS(12194),
    [sym__bitshift_operator] = ACTIONS(12194),
    [sym__power_operator] = ACTIONS(12194),
    [sym__tilde_operator] = ACTIONS(12194),
    [sym__type_order_operator] = ACTIONS(12194),
    [sym__unary_operator] = ACTIONS(12194),
    [sym__unary_plus_operator] = ACTIONS(12194),
    [aux_sym__terminator_token1] = ACTIONS(12194),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12538),
    [sym__immediate_bracket] = ACTIONS(12540),
    [sym__immediate_brace] = ACTIONS(12542),
    [sym__string_start] = ACTIONS(12196),
    [sym__command_start] = ACTIONS(12196),
  },
  [5484] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_catch] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__assignment_operator] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5485] = {
    [ts_builtin_sym_end] = ACTIONS(12298),
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_RPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_RBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5486] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_catch] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_DASH_GT] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5487] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_elseif] = ACTIONS(12388),
    [anon_sym_else] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [5488] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_catch] = ACTIONS(12338),
    [anon_sym_finally] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__assignment_operator] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5489] = {
    [ts_builtin_sym_end] = ACTIONS(12064),
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_RBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5490] = {
    [ts_builtin_sym_end] = ACTIONS(12052),
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_RBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5491] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_catch] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_DASH_GT] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5492] = {
    [ts_builtin_sym_end] = ACTIONS(12262),
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_RPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_RBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5493] = {
    [ts_builtin_sym_end] = ACTIONS(12266),
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_RPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_RBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5494] = {
    [ts_builtin_sym_end] = ACTIONS(12270),
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_RPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_RBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5495] = {
    [ts_builtin_sym_end] = ACTIONS(12302),
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_RPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_RBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5496] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_catch] = ACTIONS(12342),
    [anon_sym_finally] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__assignment_operator] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5497] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_else] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5498] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5499] = {
    [ts_builtin_sym_end] = ACTIONS(12274),
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_RPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_RBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5500] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_else] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5501] = {
    [ts_builtin_sym_end] = ACTIONS(12278),
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_RPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_RBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5502] = {
    [ts_builtin_sym_end] = ACTIONS(12068),
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_RBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5503] = {
    [ts_builtin_sym_end] = ACTIONS(12282),
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_RPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_RBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5504] = {
    [ts_builtin_sym_end] = ACTIONS(12140),
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_RPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_RBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5505] = {
    [ts_builtin_sym_end] = ACTIONS(12144),
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_RPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_RBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5506] = {
    [sym_identifier] = STATE(5983),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [5507] = {
    [ts_builtin_sym_end] = ACTIONS(12148),
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_RPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_RBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5508] = {
    [sym_identifier] = STATE(5984),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [5509] = {
    [sym_identifier] = STATE(5993),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [5510] = {
    [sym_identifier] = STATE(5994),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [5511] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12544),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5512] = {
    [ts_builtin_sym_end] = ACTIONS(12152),
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_RPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_RBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5513] = {
    [ts_builtin_sym_end] = ACTIONS(12156),
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_RPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_RBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5514] = {
    [sym_identifier] = STATE(6030),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_RPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_SEMI] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__assignment_operator] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [5515] = {
    [ts_builtin_sym_end] = ACTIONS(12160),
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_RPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_RBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5516] = {
    [sym_identifier] = STATE(6031),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_RPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_SEMI] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__assignment_operator] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [5517] = {
    [ts_builtin_sym_end] = ACTIONS(12208),
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_RPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_RBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5518] = {
    [ts_builtin_sym_end] = ACTIONS(12164),
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5519] = {
    [ts_builtin_sym_end] = ACTIONS(12168),
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_RPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_RBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5520] = {
    [ts_builtin_sym_end] = ACTIONS(12176),
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_RPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_RBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5521] = {
    [sym_identifier] = STATE(6040),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_RPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_SEMI] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__assignment_operator] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [5522] = {
    [sym_identifier] = STATE(6041),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_RPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_SEMI] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__assignment_operator] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [5523] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [5524] = {
    [ts_builtin_sym_end] = ACTIONS(12390),
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_RPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_RBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [5525] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_RPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_SEMI] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__assignment_operator] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [5526] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5527] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_catch] = ACTIONS(12308),
    [anon_sym_finally] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_DASH_GT] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5528] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_RPAREN] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_RBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_RBRACE] = ACTIONS(12052),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5529] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_catch] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_DASH_GT] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5530] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12056),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12056),
    [anon_sym_RPAREN] = ACTIONS(12056),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12056),
    [anon_sym_RBRACK] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12056),
    [anon_sym_LBRACE] = ACTIONS(12056),
    [anon_sym_RBRACE] = ACTIONS(12056),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12056),
    [anon_sym_COLON_COLON] = ACTIONS(12056),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12056),
    [anon_sym_QMARK] = ACTIONS(12056),
    [anon_sym_DASH_GT] = ACTIONS(12056),
    [anon_sym_AT] = ACTIONS(12056),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12056),
    [aux_sym_integer_literal_token2] = ACTIONS(12056),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12056),
    [aux_sym_float_literal_token3] = ACTIONS(12056),
    [aux_sym_float_literal_token4] = ACTIONS(12056),
    [sym_character_literal] = ACTIONS(12056),
    [sym__pair_operator] = ACTIONS(12056),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12056),
    [sym__lazy_and_operator] = ACTIONS(12056),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12056),
    [sym__pipe_left_operator] = ACTIONS(12056),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12056),
    [sym__bitshift_operator] = ACTIONS(12056),
    [sym__power_operator] = ACTIONS(12056),
    [sym__tilde_operator] = ACTIONS(12056),
    [sym__type_order_operator] = ACTIONS(12056),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5531] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12262),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12262),
    [anon_sym_RPAREN] = ACTIONS(12262),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12262),
    [anon_sym_RBRACK] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_SEMI] = ACTIONS(12262),
    [anon_sym_LBRACE] = ACTIONS(12262),
    [anon_sym_RBRACE] = ACTIONS(12262),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12262),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12262),
    [anon_sym_QMARK] = ACTIONS(12262),
    [anon_sym_AT] = ACTIONS(12262),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12262),
    [aux_sym_integer_literal_token2] = ACTIONS(12262),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12262),
    [aux_sym_float_literal_token3] = ACTIONS(12262),
    [aux_sym_float_literal_token4] = ACTIONS(12262),
    [sym_character_literal] = ACTIONS(12262),
    [sym__assignment_operator] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12262),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12262),
    [sym__lazy_and_operator] = ACTIONS(12262),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12262),
    [sym__pipe_left_operator] = ACTIONS(12262),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12262),
    [sym__type_order_operator] = ACTIONS(12262),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5532] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_elseif] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [5533] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12266),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12266),
    [anon_sym_RPAREN] = ACTIONS(12266),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12266),
    [anon_sym_RBRACK] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_SEMI] = ACTIONS(12266),
    [anon_sym_LBRACE] = ACTIONS(12266),
    [anon_sym_RBRACE] = ACTIONS(12266),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12266),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12266),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_AT] = ACTIONS(12266),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12266),
    [aux_sym_integer_literal_token2] = ACTIONS(12266),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12266),
    [aux_sym_float_literal_token3] = ACTIONS(12266),
    [aux_sym_float_literal_token4] = ACTIONS(12266),
    [sym_character_literal] = ACTIONS(12266),
    [sym__assignment_operator] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12266),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12266),
    [sym__lazy_and_operator] = ACTIONS(12266),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12266),
    [sym__pipe_left_operator] = ACTIONS(12266),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12266),
    [sym__type_order_operator] = ACTIONS(12266),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5534] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_catch] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_DASH_GT] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5535] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12270),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12270),
    [anon_sym_RPAREN] = ACTIONS(12270),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12270),
    [anon_sym_RBRACK] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_SEMI] = ACTIONS(12270),
    [anon_sym_LBRACE] = ACTIONS(12270),
    [anon_sym_RBRACE] = ACTIONS(12270),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12270),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_QMARK] = ACTIONS(12270),
    [anon_sym_AT] = ACTIONS(12270),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12270),
    [aux_sym_integer_literal_token2] = ACTIONS(12270),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12270),
    [aux_sym_float_literal_token3] = ACTIONS(12270),
    [aux_sym_float_literal_token4] = ACTIONS(12270),
    [sym_character_literal] = ACTIONS(12270),
    [sym__assignment_operator] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12270),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12270),
    [sym__lazy_and_operator] = ACTIONS(12270),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12270),
    [sym__pipe_left_operator] = ACTIONS(12270),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12270),
    [sym__type_order_operator] = ACTIONS(12270),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5536] = {
    [sym_identifier] = STATE(6136),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_RPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_SEMI] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_DASH_GT] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [5537] = {
    [sym_identifier] = STATE(6137),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_RPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_SEMI] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_DASH_GT] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [5538] = {
    [sym_identifier] = STATE(6143),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_RPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_SEMI] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_DASH_GT] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [5539] = {
    [sym_identifier] = STATE(6144),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_RPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_SEMI] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_DASH_GT] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [5540] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_else] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5541] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5542] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12302),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12302),
    [anon_sym_RPAREN] = ACTIONS(12302),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12302),
    [anon_sym_RBRACK] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_SEMI] = ACTIONS(12302),
    [anon_sym_LBRACE] = ACTIONS(12302),
    [anon_sym_RBRACE] = ACTIONS(12302),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12302),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12302),
    [anon_sym_QMARK] = ACTIONS(12302),
    [anon_sym_AT] = ACTIONS(12302),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12302),
    [aux_sym_integer_literal_token2] = ACTIONS(12302),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12302),
    [aux_sym_float_literal_token3] = ACTIONS(12302),
    [aux_sym_float_literal_token4] = ACTIONS(12302),
    [sym_character_literal] = ACTIONS(12302),
    [sym__assignment_operator] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12302),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12302),
    [sym__lazy_and_operator] = ACTIONS(12302),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12302),
    [sym__pipe_left_operator] = ACTIONS(12302),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12302),
    [sym__type_order_operator] = ACTIONS(12302),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5543] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [5544] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_RPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_SEMI] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__assignment_operator] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [5545] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_DASH_GT] = ACTIONS(12546),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12122),
    [sym__immediate_command_start] = ACTIONS(12124),
  },
  [5546] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_catch] = ACTIONS(12360),
    [anon_sym_finally] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__assignment_operator] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5547] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__assignment_operator] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5548] = {
    [sym__word_identifier] = ACTIONS(12410),
    [anon_sym_EQ] = ACTIONS(12410),
    [anon_sym_COMMA] = ACTIONS(12410),
    [anon_sym_COLON] = ACTIONS(12410),
    [anon_sym_begin] = ACTIONS(12410),
    [anon_sym_module] = ACTIONS(12410),
    [anon_sym_baremodule] = ACTIONS(12410),
    [anon_sym_end] = ACTIONS(12410),
    [anon_sym_abstract] = ACTIONS(12410),
    [anon_sym_primitive] = ACTIONS(12410),
    [anon_sym_mutable] = ACTIONS(12410),
    [anon_sym_struct] = ACTIONS(12410),
    [anon_sym_function] = ACTIONS(12410),
    [anon_sym_macro] = ACTIONS(12410),
    [anon_sym_where] = ACTIONS(12410),
    [anon_sym_quote] = ACTIONS(12410),
    [anon_sym_let] = ACTIONS(12410),
    [anon_sym_if] = ACTIONS(12410),
    [anon_sym_elseif] = ACTIONS(12410),
    [anon_sym_else] = ACTIONS(12410),
    [anon_sym_try] = ACTIONS(12410),
    [anon_sym_for] = ACTIONS(12410),
    [anon_sym_while] = ACTIONS(12410),
    [sym_break_statement] = ACTIONS(12410),
    [sym_continue_statement] = ACTIONS(12410),
    [anon_sym_return] = ACTIONS(12410),
    [anon_sym_const] = ACTIONS(12410),
    [anon_sym_global] = ACTIONS(12410),
    [anon_sym_local] = ACTIONS(12410),
    [anon_sym_LPAREN] = ACTIONS(12410),
    [anon_sym_COLON2] = ACTIONS(12410),
    [anon_sym_export] = ACTIONS(12410),
    [anon_sym_import] = ACTIONS(12410),
    [anon_sym_using] = ACTIONS(12410),
    [anon_sym_LBRACK] = ACTIONS(12410),
    [anon_sym_LF] = ACTIONS(12476),
    [anon_sym_in] = ACTIONS(12410),
    [anon_sym_LBRACE] = ACTIONS(12410),
    [anon_sym_SQUOTE] = ACTIONS(12548),
    [anon_sym_DOT] = ACTIONS(12550),
    [anon_sym_DOLLAR] = ACTIONS(12410),
    [anon_sym_COLON_COLON] = ACTIONS(12410),
    [anon_sym_isa] = ACTIONS(12410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12410),
    [anon_sym_QMARK] = ACTIONS(12410),
    [anon_sym_AT] = ACTIONS(12410),
    [anon_sym_true] = ACTIONS(12410),
    [anon_sym_false] = ACTIONS(12410),
    [aux_sym_integer_literal_token1] = ACTIONS(12410),
    [aux_sym_integer_literal_token2] = ACTIONS(12410),
    [aux_sym_integer_literal_token3] = ACTIONS(12410),
    [aux_sym_integer_literal_token4] = ACTIONS(12410),
    [aux_sym_float_literal_token1] = ACTIONS(12410),
    [aux_sym_float_literal_token3] = ACTIONS(12410),
    [aux_sym_float_literal_token4] = ACTIONS(12410),
    [sym_character_literal] = ACTIONS(12410),
    [sym__pair_operator] = ACTIONS(12410),
    [sym__arrow_operator] = ACTIONS(12410),
    [sym__lazy_or_operator] = ACTIONS(12410),
    [sym__lazy_and_operator] = ACTIONS(12410),
    [sym__comparison_operator] = ACTIONS(12410),
    [sym__pipe_right_operator] = ACTIONS(12410),
    [sym__pipe_left_operator] = ACTIONS(12410),
    [sym__ellipsis_operator] = ACTIONS(12410),
    [sym__plus_operator] = ACTIONS(12410),
    [sym__times_operator] = ACTIONS(12410),
    [sym__rational_operator] = ACTIONS(12410),
    [sym__bitshift_operator] = ACTIONS(12410),
    [sym__power_operator] = ACTIONS(12410),
    [sym__tilde_operator] = ACTIONS(12410),
    [sym__type_order_operator] = ACTIONS(12410),
    [sym__unary_operator] = ACTIONS(12410),
    [sym__unary_plus_operator] = ACTIONS(12410),
    [aux_sym__terminator_token1] = ACTIONS(12410),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12552),
    [sym__immediate_bracket] = ACTIONS(12554),
    [sym__immediate_brace] = ACTIONS(12556),
    [sym__string_start] = ACTIONS(12476),
    [sym__command_start] = ACTIONS(12476),
  },
  [5549] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_catch] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_DASH_GT] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5550] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_catch] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_DASH_GT] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5551] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_catch] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_DASH_GT] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5552] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5553] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12060),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12060),
    [anon_sym_RPAREN] = ACTIONS(12060),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12060),
    [anon_sym_RBRACK] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12060),
    [anon_sym_LBRACE] = ACTIONS(12060),
    [anon_sym_RBRACE] = ACTIONS(12060),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12060),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12060),
    [anon_sym_QMARK] = ACTIONS(12060),
    [anon_sym_AT] = ACTIONS(12060),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12060),
    [aux_sym_integer_literal_token2] = ACTIONS(12060),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12060),
    [aux_sym_float_literal_token3] = ACTIONS(12060),
    [aux_sym_float_literal_token4] = ACTIONS(12060),
    [sym_character_literal] = ACTIONS(12060),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12060),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12060),
    [sym__lazy_and_operator] = ACTIONS(12060),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12060),
    [sym__pipe_left_operator] = ACTIONS(12060),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12060),
    [sym__type_order_operator] = ACTIONS(12060),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5554] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12044),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12044),
    [anon_sym_RPAREN] = ACTIONS(12044),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12044),
    [anon_sym_RBRACK] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12044),
    [anon_sym_LBRACE] = ACTIONS(12044),
    [anon_sym_RBRACE] = ACTIONS(12044),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12044),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12044),
    [anon_sym_QMARK] = ACTIONS(12044),
    [anon_sym_AT] = ACTIONS(12044),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12044),
    [aux_sym_integer_literal_token2] = ACTIONS(12044),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12044),
    [aux_sym_float_literal_token3] = ACTIONS(12044),
    [aux_sym_float_literal_token4] = ACTIONS(12044),
    [sym_character_literal] = ACTIONS(12044),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12044),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12044),
    [sym__lazy_and_operator] = ACTIONS(12044),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12044),
    [sym__pipe_left_operator] = ACTIONS(12044),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12044),
    [sym__type_order_operator] = ACTIONS(12044),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5555] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_catch] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__assignment_operator] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5556] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_catch] = ACTIONS(11976),
    [anon_sym_finally] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5557] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_catch] = ACTIONS(12364),
    [anon_sym_finally] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__assignment_operator] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5558] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12274),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12274),
    [anon_sym_RPAREN] = ACTIONS(12274),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12274),
    [anon_sym_RBRACK] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_SEMI] = ACTIONS(12274),
    [anon_sym_LBRACE] = ACTIONS(12274),
    [anon_sym_RBRACE] = ACTIONS(12274),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12274),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12274),
    [anon_sym_QMARK] = ACTIONS(12274),
    [anon_sym_AT] = ACTIONS(12274),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12274),
    [aux_sym_integer_literal_token2] = ACTIONS(12274),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12274),
    [aux_sym_float_literal_token3] = ACTIONS(12274),
    [aux_sym_float_literal_token4] = ACTIONS(12274),
    [sym_character_literal] = ACTIONS(12274),
    [sym__assignment_operator] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12274),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12274),
    [sym__lazy_and_operator] = ACTIONS(12274),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12274),
    [sym__pipe_left_operator] = ACTIONS(12274),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12274),
    [sym__type_order_operator] = ACTIONS(12274),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5559] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_catch] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [5560] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_catch] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__assignment_operator] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [5561] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_catch] = ACTIONS(11984),
    [anon_sym_finally] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [5562] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12278),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12278),
    [anon_sym_RPAREN] = ACTIONS(12278),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12278),
    [anon_sym_RBRACK] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12278),
    [anon_sym_LBRACE] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(12278),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12278),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12278),
    [anon_sym_QMARK] = ACTIONS(12278),
    [anon_sym_AT] = ACTIONS(12278),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12278),
    [aux_sym_integer_literal_token2] = ACTIONS(12278),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12278),
    [aux_sym_float_literal_token3] = ACTIONS(12278),
    [aux_sym_float_literal_token4] = ACTIONS(12278),
    [sym_character_literal] = ACTIONS(12278),
    [sym__assignment_operator] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12278),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12278),
    [sym__lazy_and_operator] = ACTIONS(12278),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12278),
    [sym__pipe_left_operator] = ACTIONS(12278),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12278),
    [sym__type_order_operator] = ACTIONS(12278),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5563] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_catch] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__assignment_operator] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5564] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_RPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_SEMI] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__assignment_operator] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [5565] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12282),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12282),
    [anon_sym_RPAREN] = ACTIONS(12282),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12282),
    [anon_sym_RBRACK] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_SEMI] = ACTIONS(12282),
    [anon_sym_LBRACE] = ACTIONS(12282),
    [anon_sym_RBRACE] = ACTIONS(12282),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12282),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12282),
    [anon_sym_QMARK] = ACTIONS(12282),
    [anon_sym_AT] = ACTIONS(12282),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12282),
    [aux_sym_integer_literal_token2] = ACTIONS(12282),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12282),
    [aux_sym_float_literal_token3] = ACTIONS(12282),
    [aux_sym_float_literal_token4] = ACTIONS(12282),
    [sym_character_literal] = ACTIONS(12282),
    [sym__assignment_operator] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12282),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12282),
    [sym__lazy_and_operator] = ACTIONS(12282),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12282),
    [sym__pipe_left_operator] = ACTIONS(12282),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12282),
    [sym__type_order_operator] = ACTIONS(12282),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5566] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12140),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12140),
    [anon_sym_RPAREN] = ACTIONS(12140),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12140),
    [anon_sym_RBRACK] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_SEMI] = ACTIONS(12140),
    [anon_sym_LBRACE] = ACTIONS(12140),
    [anon_sym_RBRACE] = ACTIONS(12140),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12140),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12140),
    [anon_sym_QMARK] = ACTIONS(12140),
    [anon_sym_AT] = ACTIONS(12140),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12140),
    [aux_sym_integer_literal_token2] = ACTIONS(12140),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12140),
    [aux_sym_float_literal_token3] = ACTIONS(12140),
    [aux_sym_float_literal_token4] = ACTIONS(12140),
    [sym_character_literal] = ACTIONS(12140),
    [sym__assignment_operator] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12140),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12140),
    [sym__lazy_and_operator] = ACTIONS(12140),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12140),
    [sym__pipe_left_operator] = ACTIONS(12140),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12140),
    [sym__type_order_operator] = ACTIONS(12140),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5567] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12144),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12144),
    [anon_sym_RPAREN] = ACTIONS(12144),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12144),
    [anon_sym_RBRACK] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_SEMI] = ACTIONS(12144),
    [anon_sym_LBRACE] = ACTIONS(12144),
    [anon_sym_RBRACE] = ACTIONS(12144),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12144),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12144),
    [anon_sym_QMARK] = ACTIONS(12144),
    [anon_sym_AT] = ACTIONS(12144),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12144),
    [aux_sym_integer_literal_token2] = ACTIONS(12144),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12144),
    [aux_sym_float_literal_token3] = ACTIONS(12144),
    [aux_sym_float_literal_token4] = ACTIONS(12144),
    [sym_character_literal] = ACTIONS(12144),
    [sym__assignment_operator] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12144),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12144),
    [sym__lazy_and_operator] = ACTIONS(12144),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12144),
    [sym__pipe_left_operator] = ACTIONS(12144),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12144),
    [sym__type_order_operator] = ACTIONS(12144),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5568] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5569] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12148),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12148),
    [anon_sym_RPAREN] = ACTIONS(12148),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12148),
    [anon_sym_RBRACK] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_SEMI] = ACTIONS(12148),
    [anon_sym_LBRACE] = ACTIONS(12148),
    [anon_sym_RBRACE] = ACTIONS(12148),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12148),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12148),
    [anon_sym_QMARK] = ACTIONS(12148),
    [anon_sym_AT] = ACTIONS(12148),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12148),
    [aux_sym_integer_literal_token2] = ACTIONS(12148),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12148),
    [aux_sym_float_literal_token3] = ACTIONS(12148),
    [aux_sym_float_literal_token4] = ACTIONS(12148),
    [sym_character_literal] = ACTIONS(12148),
    [sym__assignment_operator] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12148),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12148),
    [sym__lazy_and_operator] = ACTIONS(12148),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12148),
    [sym__pipe_left_operator] = ACTIONS(12148),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12148),
    [sym__type_order_operator] = ACTIONS(12148),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5570] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11978),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11978),
    [anon_sym_RPAREN] = ACTIONS(11978),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11978),
    [anon_sym_RBRACK] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_SEMI] = ACTIONS(11978),
    [anon_sym_LBRACE] = ACTIONS(11978),
    [anon_sym_RBRACE] = ACTIONS(11978),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11978),
    [anon_sym_COLON_COLON] = ACTIONS(11978),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11978),
    [anon_sym_QMARK] = ACTIONS(11978),
    [anon_sym_AT] = ACTIONS(11978),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11978),
    [aux_sym_integer_literal_token2] = ACTIONS(11978),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11978),
    [aux_sym_float_literal_token3] = ACTIONS(11978),
    [aux_sym_float_literal_token4] = ACTIONS(11978),
    [sym_character_literal] = ACTIONS(11978),
    [sym__pair_operator] = ACTIONS(11978),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11978),
    [sym__lazy_and_operator] = ACTIONS(11978),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11978),
    [sym__pipe_left_operator] = ACTIONS(11978),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11978),
    [sym__bitshift_operator] = ACTIONS(11978),
    [sym__power_operator] = ACTIONS(11978),
    [sym__tilde_operator] = ACTIONS(11978),
    [sym__type_order_operator] = ACTIONS(11978),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5571] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12152),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12152),
    [anon_sym_RPAREN] = ACTIONS(12152),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12152),
    [anon_sym_RBRACK] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_SEMI] = ACTIONS(12152),
    [anon_sym_LBRACE] = ACTIONS(12152),
    [anon_sym_RBRACE] = ACTIONS(12152),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12152),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12152),
    [anon_sym_QMARK] = ACTIONS(12152),
    [anon_sym_AT] = ACTIONS(12152),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12152),
    [aux_sym_integer_literal_token2] = ACTIONS(12152),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12152),
    [aux_sym_float_literal_token3] = ACTIONS(12152),
    [aux_sym_float_literal_token4] = ACTIONS(12152),
    [sym_character_literal] = ACTIONS(12152),
    [sym__assignment_operator] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12152),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12152),
    [sym__lazy_and_operator] = ACTIONS(12152),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12152),
    [sym__pipe_left_operator] = ACTIONS(12152),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12152),
    [sym__type_order_operator] = ACTIONS(12152),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5572] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_RPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_SEMI] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__assignment_operator] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [5573] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_else] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5574] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_catch] = ACTIONS(12136),
    [anon_sym_finally] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__assignment_operator] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5575] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_else] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5576] = {
    [sym_identifier] = STATE(6283),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__assignment_operator] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [5577] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5578] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11986),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11986),
    [anon_sym_RPAREN] = ACTIONS(11986),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11986),
    [anon_sym_RBRACK] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_SEMI] = ACTIONS(11986),
    [anon_sym_LBRACE] = ACTIONS(11986),
    [anon_sym_RBRACE] = ACTIONS(11986),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11986),
    [anon_sym_COLON_COLON] = ACTIONS(11986),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11986),
    [anon_sym_QMARK] = ACTIONS(11986),
    [anon_sym_AT] = ACTIONS(11986),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11986),
    [aux_sym_integer_literal_token2] = ACTIONS(11986),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11986),
    [aux_sym_float_literal_token3] = ACTIONS(11986),
    [aux_sym_float_literal_token4] = ACTIONS(11986),
    [sym_character_literal] = ACTIONS(11986),
    [sym__pair_operator] = ACTIONS(11986),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11986),
    [sym__lazy_and_operator] = ACTIONS(11986),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11986),
    [sym__pipe_left_operator] = ACTIONS(11986),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11986),
    [sym__bitshift_operator] = ACTIONS(11986),
    [sym__power_operator] = ACTIONS(11986),
    [sym__tilde_operator] = ACTIONS(11986),
    [sym__type_order_operator] = ACTIONS(11986),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [5579] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5580] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12156),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12156),
    [anon_sym_RPAREN] = ACTIONS(12156),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12156),
    [anon_sym_RBRACK] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_SEMI] = ACTIONS(12156),
    [anon_sym_LBRACE] = ACTIONS(12156),
    [anon_sym_RBRACE] = ACTIONS(12156),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12156),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12156),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_AT] = ACTIONS(12156),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12156),
    [aux_sym_integer_literal_token2] = ACTIONS(12156),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12156),
    [aux_sym_float_literal_token3] = ACTIONS(12156),
    [aux_sym_float_literal_token4] = ACTIONS(12156),
    [sym_character_literal] = ACTIONS(12156),
    [sym__assignment_operator] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12156),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12156),
    [sym__lazy_and_operator] = ACTIONS(12156),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12156),
    [sym__pipe_left_operator] = ACTIONS(12156),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12156),
    [sym__type_order_operator] = ACTIONS(12156),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5581] = {
    [sym__word_identifier] = ACTIONS(12558),
    [anon_sym_EQ] = ACTIONS(12558),
    [anon_sym_COMMA] = ACTIONS(12558),
    [anon_sym_COLON] = ACTIONS(12558),
    [anon_sym_begin] = ACTIONS(12558),
    [anon_sym_module] = ACTIONS(12558),
    [anon_sym_baremodule] = ACTIONS(12558),
    [anon_sym_end] = ACTIONS(12558),
    [anon_sym_abstract] = ACTIONS(12558),
    [anon_sym_primitive] = ACTIONS(12558),
    [anon_sym_mutable] = ACTIONS(12558),
    [anon_sym_struct] = ACTIONS(12558),
    [anon_sym_function] = ACTIONS(12558),
    [anon_sym_macro] = ACTIONS(12558),
    [anon_sym_where] = ACTIONS(12558),
    [anon_sym_quote] = ACTIONS(12558),
    [anon_sym_let] = ACTIONS(12558),
    [anon_sym_if] = ACTIONS(12558),
    [anon_sym_elseif] = ACTIONS(12558),
    [anon_sym_else] = ACTIONS(12558),
    [anon_sym_try] = ACTIONS(12558),
    [anon_sym_for] = ACTIONS(12558),
    [anon_sym_while] = ACTIONS(12558),
    [sym_break_statement] = ACTIONS(12558),
    [sym_continue_statement] = ACTIONS(12558),
    [anon_sym_return] = ACTIONS(12558),
    [anon_sym_const] = ACTIONS(12558),
    [anon_sym_global] = ACTIONS(12558),
    [anon_sym_local] = ACTIONS(12558),
    [anon_sym_LPAREN] = ACTIONS(12558),
    [anon_sym_COLON2] = ACTIONS(12558),
    [anon_sym_export] = ACTIONS(12558),
    [anon_sym_import] = ACTIONS(12558),
    [anon_sym_using] = ACTIONS(12558),
    [anon_sym_LBRACK] = ACTIONS(12558),
    [anon_sym_LF] = ACTIONS(12560),
    [anon_sym_in] = ACTIONS(12558),
    [anon_sym_LBRACE] = ACTIONS(12558),
    [anon_sym_SQUOTE] = ACTIONS(12548),
    [anon_sym_DOT] = ACTIONS(12550),
    [anon_sym_DOLLAR] = ACTIONS(12558),
    [anon_sym_COLON_COLON] = ACTIONS(12558),
    [anon_sym_isa] = ACTIONS(12558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12558),
    [anon_sym_QMARK] = ACTIONS(12558),
    [anon_sym_AT] = ACTIONS(12558),
    [anon_sym_true] = ACTIONS(12558),
    [anon_sym_false] = ACTIONS(12558),
    [aux_sym_integer_literal_token1] = ACTIONS(12558),
    [aux_sym_integer_literal_token2] = ACTIONS(12558),
    [aux_sym_integer_literal_token3] = ACTIONS(12558),
    [aux_sym_integer_literal_token4] = ACTIONS(12558),
    [aux_sym_float_literal_token1] = ACTIONS(12558),
    [aux_sym_float_literal_token3] = ACTIONS(12558),
    [aux_sym_float_literal_token4] = ACTIONS(12558),
    [sym_character_literal] = ACTIONS(12558),
    [sym__pair_operator] = ACTIONS(12558),
    [sym__arrow_operator] = ACTIONS(12558),
    [sym__lazy_or_operator] = ACTIONS(12558),
    [sym__lazy_and_operator] = ACTIONS(12558),
    [sym__comparison_operator] = ACTIONS(12558),
    [sym__pipe_right_operator] = ACTIONS(12558),
    [sym__pipe_left_operator] = ACTIONS(12558),
    [sym__ellipsis_operator] = ACTIONS(12558),
    [sym__plus_operator] = ACTIONS(12558),
    [sym__times_operator] = ACTIONS(12558),
    [sym__rational_operator] = ACTIONS(12558),
    [sym__bitshift_operator] = ACTIONS(12558),
    [sym__power_operator] = ACTIONS(12558),
    [sym__tilde_operator] = ACTIONS(12558),
    [sym__type_order_operator] = ACTIONS(12558),
    [sym__unary_operator] = ACTIONS(12558),
    [sym__unary_plus_operator] = ACTIONS(12558),
    [aux_sym__terminator_token1] = ACTIONS(12558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12552),
    [sym__immediate_bracket] = ACTIONS(12554),
    [sym__immediate_brace] = ACTIONS(12556),
    [sym__string_start] = ACTIONS(12560),
    [sym__command_start] = ACTIONS(12560),
  },
  [5582] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12160),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12160),
    [anon_sym_RPAREN] = ACTIONS(12160),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12160),
    [anon_sym_RBRACK] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_SEMI] = ACTIONS(12160),
    [anon_sym_LBRACE] = ACTIONS(12160),
    [anon_sym_RBRACE] = ACTIONS(12160),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12160),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12160),
    [anon_sym_QMARK] = ACTIONS(12160),
    [anon_sym_AT] = ACTIONS(12160),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12160),
    [aux_sym_integer_literal_token2] = ACTIONS(12160),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12160),
    [aux_sym_float_literal_token3] = ACTIONS(12160),
    [aux_sym_float_literal_token4] = ACTIONS(12160),
    [sym_character_literal] = ACTIONS(12160),
    [sym__assignment_operator] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12160),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12160),
    [sym__lazy_and_operator] = ACTIONS(12160),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12160),
    [sym__pipe_left_operator] = ACTIONS(12160),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12160),
    [sym__type_order_operator] = ACTIONS(12160),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5583] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_catch] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__assignment_operator] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5584] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12164),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12164),
    [anon_sym_RPAREN] = ACTIONS(12164),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12164),
    [anon_sym_RBRACK] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12164),
    [anon_sym_LBRACE] = ACTIONS(12164),
    [anon_sym_RBRACE] = ACTIONS(12164),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12164),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12164),
    [anon_sym_QMARK] = ACTIONS(12164),
    [anon_sym_AT] = ACTIONS(12164),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12164),
    [aux_sym_integer_literal_token2] = ACTIONS(12164),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12164),
    [aux_sym_float_literal_token3] = ACTIONS(12164),
    [aux_sym_float_literal_token4] = ACTIONS(12164),
    [sym_character_literal] = ACTIONS(12164),
    [sym__assignment_operator] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12164),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12164),
    [sym__lazy_and_operator] = ACTIONS(12164),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12164),
    [sym__pipe_left_operator] = ACTIONS(12164),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12164),
    [sym__type_order_operator] = ACTIONS(12164),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5585] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5586] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_catch] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__assignment_operator] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [5587] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_else] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_finally] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5588] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_catch] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__assignment_operator] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5589] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_catch] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__assignment_operator] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5590] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_catch] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__assignment_operator] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5591] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_catch] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__assignment_operator] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5592] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12168),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12168),
    [anon_sym_RPAREN] = ACTIONS(12168),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12168),
    [anon_sym_RBRACK] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_SEMI] = ACTIONS(12168),
    [anon_sym_LBRACE] = ACTIONS(12168),
    [anon_sym_RBRACE] = ACTIONS(12168),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(12168),
    [anon_sym_AT] = ACTIONS(12168),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12168),
    [aux_sym_integer_literal_token2] = ACTIONS(12168),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12168),
    [aux_sym_float_literal_token3] = ACTIONS(12168),
    [aux_sym_float_literal_token4] = ACTIONS(12168),
    [sym_character_literal] = ACTIONS(12168),
    [sym__assignment_operator] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12168),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12168),
    [sym__lazy_and_operator] = ACTIONS(12168),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12168),
    [sym__pipe_left_operator] = ACTIONS(12168),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12168),
    [sym__type_order_operator] = ACTIONS(12168),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5593] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_elseif] = ACTIONS(12214),
    [anon_sym_else] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5594] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_catch] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__assignment_operator] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5595] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_catch] = ACTIONS(12174),
    [anon_sym_finally] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__assignment_operator] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5596] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [5597] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12176),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12176),
    [anon_sym_RPAREN] = ACTIONS(12176),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12176),
    [anon_sym_RBRACK] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_SEMI] = ACTIONS(12176),
    [anon_sym_LBRACE] = ACTIONS(12176),
    [anon_sym_RBRACE] = ACTIONS(12176),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12176),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12176),
    [anon_sym_QMARK] = ACTIONS(12176),
    [anon_sym_AT] = ACTIONS(12176),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12176),
    [aux_sym_integer_literal_token2] = ACTIONS(12176),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12176),
    [aux_sym_float_literal_token3] = ACTIONS(12176),
    [aux_sym_float_literal_token4] = ACTIONS(12176),
    [sym_character_literal] = ACTIONS(12176),
    [sym__assignment_operator] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12176),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12176),
    [sym__lazy_and_operator] = ACTIONS(12176),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12176),
    [sym__pipe_left_operator] = ACTIONS(12176),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12176),
    [sym__type_order_operator] = ACTIONS(12176),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5598] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12562),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12564),
    [anon_sym_DOT] = ACTIONS(12566),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12568),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12570),
    [sym__immediate_bracket] = ACTIONS(12572),
    [sym__immediate_brace] = ACTIONS(12574),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5599] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_elseif] = ACTIONS(12218),
    [anon_sym_else] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5600] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5601] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5602] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_else] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5603] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_else] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5604] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_else] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5605] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5606] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5607] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_else] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5608] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_elseif] = ACTIONS(12236),
    [anon_sym_else] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5609] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_else] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5610] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_elseif] = ACTIONS(12240),
    [anon_sym_else] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5611] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12576),
    [sym__immediate_command_start] = ACTIONS(12578),
  },
  [5612] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12060),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12060),
    [anon_sym_RPAREN] = ACTIONS(12060),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12060),
    [anon_sym_RBRACK] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12060),
    [anon_sym_LBRACE] = ACTIONS(12060),
    [anon_sym_RBRACE] = ACTIONS(12060),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12060),
    [anon_sym_COLON_COLON] = ACTIONS(12060),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12060),
    [anon_sym_QMARK] = ACTIONS(12060),
    [anon_sym_DASH_GT] = ACTIONS(12060),
    [anon_sym_AT] = ACTIONS(12060),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12060),
    [aux_sym_integer_literal_token2] = ACTIONS(12060),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12060),
    [aux_sym_float_literal_token3] = ACTIONS(12060),
    [aux_sym_float_literal_token4] = ACTIONS(12060),
    [sym_character_literal] = ACTIONS(12060),
    [sym__pair_operator] = ACTIONS(12060),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12060),
    [sym__lazy_and_operator] = ACTIONS(12060),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12060),
    [sym__pipe_left_operator] = ACTIONS(12060),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12060),
    [sym__bitshift_operator] = ACTIONS(12060),
    [sym__power_operator] = ACTIONS(12060),
    [sym__tilde_operator] = ACTIONS(12060),
    [sym__type_order_operator] = ACTIONS(12060),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5613] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12044),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12044),
    [anon_sym_RPAREN] = ACTIONS(12044),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12044),
    [anon_sym_RBRACK] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12044),
    [anon_sym_LBRACE] = ACTIONS(12044),
    [anon_sym_RBRACE] = ACTIONS(12044),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12044),
    [anon_sym_COLON_COLON] = ACTIONS(12044),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12044),
    [anon_sym_QMARK] = ACTIONS(12044),
    [anon_sym_DASH_GT] = ACTIONS(12044),
    [anon_sym_AT] = ACTIONS(12044),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12044),
    [aux_sym_integer_literal_token2] = ACTIONS(12044),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12044),
    [aux_sym_float_literal_token3] = ACTIONS(12044),
    [aux_sym_float_literal_token4] = ACTIONS(12044),
    [sym_character_literal] = ACTIONS(12044),
    [sym__pair_operator] = ACTIONS(12044),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12044),
    [sym__lazy_and_operator] = ACTIONS(12044),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12044),
    [sym__pipe_left_operator] = ACTIONS(12044),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12044),
    [sym__bitshift_operator] = ACTIONS(12044),
    [sym__power_operator] = ACTIONS(12044),
    [sym__tilde_operator] = ACTIONS(12044),
    [sym__type_order_operator] = ACTIONS(12044),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5614] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_elseif] = ACTIONS(12244),
    [anon_sym_else] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5615] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12464),
    [anon_sym_DOT] = ACTIONS(12516),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12518),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12470),
    [sym__immediate_bracket] = ACTIONS(12472),
    [sym__immediate_brace] = ACTIONS(12474),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5616] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5617] = {
    [ts_builtin_sym_end] = ACTIONS(12306),
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_RPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_RBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5618] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_catch] = ACTIONS(12020),
    [anon_sym_finally] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [5619] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12576),
    [sym__immediate_command_start] = ACTIONS(12578),
  },
  [5620] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_elseif] = ACTIONS(12292),
    [anon_sym_else] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5621] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_else] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5622] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_else] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5623] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_else] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5624] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_else] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5625] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_else] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5626] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_else] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5627] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_catch] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__assignment_operator] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5628] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_else] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5629] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_catch] = ACTIONS(11980),
    [anon_sym_finally] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [5630] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_catch] = ACTIONS(11988),
    [anon_sym_finally] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [5631] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5632] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_else] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5633] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_else] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5634] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_catch] = ACTIONS(11996),
    [anon_sym_finally] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [5635] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12290),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12290),
    [anon_sym_RPAREN] = ACTIONS(12290),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12290),
    [anon_sym_RBRACK] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_SEMI] = ACTIONS(12290),
    [anon_sym_LBRACE] = ACTIONS(12290),
    [anon_sym_RBRACE] = ACTIONS(12290),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12290),
    [anon_sym_COLON_COLON] = ACTIONS(12290),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_QMARK] = ACTIONS(12290),
    [anon_sym_DASH_GT] = ACTIONS(12290),
    [anon_sym_AT] = ACTIONS(12290),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12290),
    [aux_sym_integer_literal_token2] = ACTIONS(12290),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12290),
    [aux_sym_float_literal_token3] = ACTIONS(12290),
    [aux_sym_float_literal_token4] = ACTIONS(12290),
    [sym_character_literal] = ACTIONS(12290),
    [sym__pair_operator] = ACTIONS(12290),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12290),
    [sym__lazy_and_operator] = ACTIONS(12290),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12290),
    [sym__pipe_left_operator] = ACTIONS(12290),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12290),
    [sym__bitshift_operator] = ACTIONS(12290),
    [sym__power_operator] = ACTIONS(12290),
    [sym__tilde_operator] = ACTIONS(12290),
    [sym__type_order_operator] = ACTIONS(12290),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5636] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11894),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11894),
    [anon_sym_RPAREN] = ACTIONS(11894),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11894),
    [anon_sym_RBRACK] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11894),
    [anon_sym_RBRACE] = ACTIONS(11894),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11894),
    [anon_sym_COLON_COLON] = ACTIONS(11894),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11894),
    [anon_sym_QMARK] = ACTIONS(11894),
    [anon_sym_DASH_GT] = ACTIONS(11894),
    [anon_sym_AT] = ACTIONS(11894),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11894),
    [aux_sym_integer_literal_token2] = ACTIONS(11894),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11894),
    [aux_sym_float_literal_token3] = ACTIONS(11894),
    [aux_sym_float_literal_token4] = ACTIONS(11894),
    [sym_character_literal] = ACTIONS(11894),
    [sym__pair_operator] = ACTIONS(11894),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11894),
    [sym__lazy_and_operator] = ACTIONS(11894),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11894),
    [sym__pipe_left_operator] = ACTIONS(11894),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11894),
    [sym__bitshift_operator] = ACTIONS(11894),
    [sym__power_operator] = ACTIONS(11894),
    [sym__tilde_operator] = ACTIONS(11894),
    [sym__type_order_operator] = ACTIONS(11894),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [5637] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_DASH_GT] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5638] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_RPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_SEMI] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__assignment_operator] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [5639] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_RPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_SEMI] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [5640] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12298),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12298),
    [anon_sym_RPAREN] = ACTIONS(12298),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12298),
    [anon_sym_RBRACK] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_SEMI] = ACTIONS(12298),
    [anon_sym_LBRACE] = ACTIONS(12298),
    [anon_sym_RBRACE] = ACTIONS(12298),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12298),
    [anon_sym_COLON_COLON] = ACTIONS(12298),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12298),
    [anon_sym_QMARK] = ACTIONS(12298),
    [anon_sym_DASH_GT] = ACTIONS(12298),
    [anon_sym_AT] = ACTIONS(12298),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12298),
    [aux_sym_integer_literal_token2] = ACTIONS(12298),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12298),
    [aux_sym_float_literal_token3] = ACTIONS(12298),
    [aux_sym_float_literal_token4] = ACTIONS(12298),
    [sym_character_literal] = ACTIONS(12298),
    [sym__pair_operator] = ACTIONS(12298),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12298),
    [sym__lazy_and_operator] = ACTIONS(12298),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12298),
    [sym__pipe_left_operator] = ACTIONS(12298),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12298),
    [sym__bitshift_operator] = ACTIONS(12298),
    [sym__power_operator] = ACTIONS(12298),
    [sym__tilde_operator] = ACTIONS(12298),
    [sym__type_order_operator] = ACTIONS(12298),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5641] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_catch] = ACTIONS(12024),
    [anon_sym_finally] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [5642] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_catch] = ACTIONS(12028),
    [anon_sym_finally] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [5643] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_RPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_SEMI] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__assignment_operator] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [5644] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12576),
    [sym__immediate_command_start] = ACTIONS(12578),
  },
  [5645] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_catch] = ACTIONS(12032),
    [anon_sym_finally] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [5646] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [5647] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_RPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_SEMI] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__assignment_operator] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [5648] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_catch] = ACTIONS(12036),
    [anon_sym_finally] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [5649] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_catch] = ACTIONS(12040),
    [anon_sym_finally] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [5650] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_catch] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [5651] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_RPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_SEMI] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [5652] = {
    [ts_builtin_sym_end] = ACTIONS(11894),
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_RBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [5653] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_catch] = ACTIONS(12338),
    [anon_sym_finally] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_DASH_GT] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5654] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_catch] = ACTIONS(12342),
    [anon_sym_finally] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_DASH_GT] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5655] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_RPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_SEMI] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_DASH_GT] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [5656] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_RPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_SEMI] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_DASH_GT] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [5657] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12306),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12306),
    [anon_sym_RPAREN] = ACTIONS(12306),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12306),
    [anon_sym_RBRACK] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_SEMI] = ACTIONS(12306),
    [anon_sym_LBRACE] = ACTIONS(12306),
    [anon_sym_RBRACE] = ACTIONS(12306),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12306),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12306),
    [anon_sym_QMARK] = ACTIONS(12306),
    [anon_sym_AT] = ACTIONS(12306),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12306),
    [aux_sym_integer_literal_token2] = ACTIONS(12306),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12306),
    [aux_sym_float_literal_token3] = ACTIONS(12306),
    [aux_sym_float_literal_token4] = ACTIONS(12306),
    [sym_character_literal] = ACTIONS(12306),
    [sym__assignment_operator] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12306),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12306),
    [sym__lazy_and_operator] = ACTIONS(12306),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12306),
    [sym__pipe_left_operator] = ACTIONS(12306),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12306),
    [sym__type_order_operator] = ACTIONS(12306),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5658] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12302),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12302),
    [anon_sym_RPAREN] = ACTIONS(12302),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12302),
    [anon_sym_RBRACK] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_SEMI] = ACTIONS(12302),
    [anon_sym_LBRACE] = ACTIONS(12302),
    [anon_sym_RBRACE] = ACTIONS(12302),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12302),
    [anon_sym_COLON_COLON] = ACTIONS(12302),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12302),
    [anon_sym_QMARK] = ACTIONS(12302),
    [anon_sym_DASH_GT] = ACTIONS(12302),
    [anon_sym_AT] = ACTIONS(12302),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12302),
    [aux_sym_integer_literal_token2] = ACTIONS(12302),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12302),
    [aux_sym_float_literal_token3] = ACTIONS(12302),
    [aux_sym_float_literal_token4] = ACTIONS(12302),
    [sym_character_literal] = ACTIONS(12302),
    [sym__pair_operator] = ACTIONS(12302),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12302),
    [sym__lazy_and_operator] = ACTIONS(12302),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12302),
    [sym__pipe_left_operator] = ACTIONS(12302),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12302),
    [sym__bitshift_operator] = ACTIONS(12302),
    [sym__power_operator] = ACTIONS(12302),
    [sym__tilde_operator] = ACTIONS(12302),
    [sym__type_order_operator] = ACTIONS(12302),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5659] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_finally] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__assignment_operator] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5660] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_finally] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5661] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_catch] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [5662] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_RPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_SEMI] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_DASH_GT] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [5663] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_RPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_SEMI] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [5664] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_elseif] = ACTIONS(12248),
    [anon_sym_else] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5665] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_elseif] = ACTIONS(12252),
    [anon_sym_else] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5666] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5667] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_RPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_SEMI] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_DASH_GT] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [5668] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_RPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_SEMI] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__assignment_operator] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [5669] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12152),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12152),
    [anon_sym_RPAREN] = ACTIONS(12152),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12152),
    [anon_sym_RBRACK] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_SEMI] = ACTIONS(12152),
    [anon_sym_LBRACE] = ACTIONS(12152),
    [anon_sym_RBRACE] = ACTIONS(12152),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12152),
    [anon_sym_COLON_COLON] = ACTIONS(12152),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12152),
    [anon_sym_QMARK] = ACTIONS(12152),
    [anon_sym_DASH_GT] = ACTIONS(12152),
    [anon_sym_AT] = ACTIONS(12152),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12152),
    [aux_sym_integer_literal_token2] = ACTIONS(12152),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12152),
    [aux_sym_float_literal_token3] = ACTIONS(12152),
    [aux_sym_float_literal_token4] = ACTIONS(12152),
    [sym_character_literal] = ACTIONS(12152),
    [sym__pair_operator] = ACTIONS(12152),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12152),
    [sym__lazy_and_operator] = ACTIONS(12152),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12152),
    [sym__pipe_left_operator] = ACTIONS(12152),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12152),
    [sym__bitshift_operator] = ACTIONS(12152),
    [sym__power_operator] = ACTIONS(12152),
    [sym__tilde_operator] = ACTIONS(12152),
    [sym__type_order_operator] = ACTIONS(12152),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5670] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_RPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_SEMI] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__assignment_operator] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [5671] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_catch] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__assignment_operator] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5672] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_elseif] = ACTIONS(12256),
    [anon_sym_else] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5673] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_elseif] = ACTIONS(12260),
    [anon_sym_else] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5674] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_elseif] = ACTIONS(12300),
    [anon_sym_else] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5675] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_RPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_SEMI] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_DASH_GT] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [5676] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_RPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_SEMI] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_DASH_GT] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [5677] = {
    [sym_do_clause] = STATE(6497),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_EQ] = ACTIONS(11896),
    [anon_sym_COMMA] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_COLON2] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11896),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(12580),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_isa] = ACTIONS(11896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11896),
    [anon_sym_QMARK] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__lazy_or_operator] = ACTIONS(11896),
    [sym__lazy_and_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [5678] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_RPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_SEMI] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_DASH_GT] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [5679] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_catch] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__assignment_operator] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5680] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12324),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12324),
    [anon_sym_RPAREN] = ACTIONS(12324),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12324),
    [anon_sym_RBRACK] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_SEMI] = ACTIONS(12324),
    [anon_sym_LBRACE] = ACTIONS(12324),
    [anon_sym_RBRACE] = ACTIONS(12324),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12324),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12324),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_AT] = ACTIONS(12324),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12324),
    [aux_sym_integer_literal_token2] = ACTIONS(12324),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12324),
    [aux_sym_float_literal_token3] = ACTIONS(12324),
    [aux_sym_float_literal_token4] = ACTIONS(12324),
    [sym_character_literal] = ACTIONS(12324),
    [sym__assignment_operator] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12324),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12324),
    [sym__lazy_and_operator] = ACTIONS(12324),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12324),
    [sym__pipe_left_operator] = ACTIONS(12324),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12324),
    [sym__type_order_operator] = ACTIONS(12324),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5681] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12328),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12328),
    [anon_sym_RPAREN] = ACTIONS(12328),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12328),
    [anon_sym_RBRACK] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_SEMI] = ACTIONS(12328),
    [anon_sym_LBRACE] = ACTIONS(12328),
    [anon_sym_RBRACE] = ACTIONS(12328),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12328),
    [anon_sym_COLON_COLON] = ACTIONS(12328),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12328),
    [anon_sym_QMARK] = ACTIONS(12328),
    [anon_sym_DASH_GT] = ACTIONS(12328),
    [anon_sym_AT] = ACTIONS(12328),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12328),
    [aux_sym_integer_literal_token2] = ACTIONS(12328),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12328),
    [aux_sym_float_literal_token3] = ACTIONS(12328),
    [aux_sym_float_literal_token4] = ACTIONS(12328),
    [sym_character_literal] = ACTIONS(12328),
    [sym__pair_operator] = ACTIONS(12328),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12328),
    [sym__lazy_and_operator] = ACTIONS(12328),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12328),
    [sym__pipe_left_operator] = ACTIONS(12328),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12328),
    [sym__bitshift_operator] = ACTIONS(12328),
    [sym__power_operator] = ACTIONS(12328),
    [sym__tilde_operator] = ACTIONS(12328),
    [sym__type_order_operator] = ACTIONS(12328),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5682] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__assignment_operator] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5683] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__assignment_operator] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5684] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(12576),
    [sym__immediate_command_start] = ACTIONS(12578),
  },
  [5685] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5686] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_finally] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [5687] = {
    [sym_do_clause] = STATE(6501),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(12580),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5688] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5689] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__assignment_operator] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5690] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_else] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5691] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_finally] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [5692] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_catch] = ACTIONS(12174),
    [anon_sym_finally] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_DASH_GT] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5693] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_finally] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_DASH_GT] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5694] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [5695] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_finally] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_DASH_GT] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5696] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_catch] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [5697] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12340),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12340),
    [anon_sym_RPAREN] = ACTIONS(12340),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12340),
    [anon_sym_RBRACK] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(12340),
    [anon_sym_LBRACE] = ACTIONS(12340),
    [anon_sym_RBRACE] = ACTIONS(12340),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12340),
    [anon_sym_COLON_COLON] = ACTIONS(12340),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12340),
    [anon_sym_QMARK] = ACTIONS(12340),
    [anon_sym_DASH_GT] = ACTIONS(12340),
    [anon_sym_AT] = ACTIONS(12340),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12340),
    [aux_sym_integer_literal_token2] = ACTIONS(12340),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12340),
    [aux_sym_float_literal_token3] = ACTIONS(12340),
    [aux_sym_float_literal_token4] = ACTIONS(12340),
    [sym_character_literal] = ACTIONS(12340),
    [sym__pair_operator] = ACTIONS(12340),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12340),
    [sym__lazy_and_operator] = ACTIONS(12340),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12340),
    [sym__pipe_left_operator] = ACTIONS(12340),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12340),
    [sym__bitshift_operator] = ACTIONS(12340),
    [sym__power_operator] = ACTIONS(12340),
    [sym__tilde_operator] = ACTIONS(12340),
    [sym__type_order_operator] = ACTIONS(12340),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5698] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12344),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12344),
    [anon_sym_RPAREN] = ACTIONS(12344),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12344),
    [anon_sym_RBRACK] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_SEMI] = ACTIONS(12344),
    [anon_sym_LBRACE] = ACTIONS(12344),
    [anon_sym_RBRACE] = ACTIONS(12344),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12344),
    [anon_sym_COLON_COLON] = ACTIONS(12344),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12344),
    [anon_sym_QMARK] = ACTIONS(12344),
    [anon_sym_DASH_GT] = ACTIONS(12344),
    [anon_sym_AT] = ACTIONS(12344),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12344),
    [aux_sym_integer_literal_token2] = ACTIONS(12344),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12344),
    [aux_sym_float_literal_token3] = ACTIONS(12344),
    [aux_sym_float_literal_token4] = ACTIONS(12344),
    [sym_character_literal] = ACTIONS(12344),
    [sym__pair_operator] = ACTIONS(12344),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12344),
    [sym__lazy_and_operator] = ACTIONS(12344),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12344),
    [sym__pipe_left_operator] = ACTIONS(12344),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12344),
    [sym__bitshift_operator] = ACTIONS(12344),
    [sym__power_operator] = ACTIONS(12344),
    [sym__tilde_operator] = ACTIONS(12344),
    [sym__type_order_operator] = ACTIONS(12344),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5699] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11930),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11930),
    [anon_sym_RPAREN] = ACTIONS(11930),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11930),
    [anon_sym_RBRACK] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11930),
    [anon_sym_LBRACE] = ACTIONS(11930),
    [anon_sym_RBRACE] = ACTIONS(11930),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11930),
    [anon_sym_COLON_COLON] = ACTIONS(11930),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11930),
    [anon_sym_QMARK] = ACTIONS(11930),
    [anon_sym_DASH_GT] = ACTIONS(11930),
    [anon_sym_AT] = ACTIONS(11930),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11930),
    [aux_sym_integer_literal_token2] = ACTIONS(11930),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11930),
    [aux_sym_float_literal_token3] = ACTIONS(11930),
    [aux_sym_float_literal_token4] = ACTIONS(11930),
    [sym_character_literal] = ACTIONS(11930),
    [sym__pair_operator] = ACTIONS(11930),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11930),
    [sym__lazy_and_operator] = ACTIONS(11930),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11930),
    [sym__pipe_left_operator] = ACTIONS(11930),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11930),
    [sym__bitshift_operator] = ACTIONS(11930),
    [sym__power_operator] = ACTIONS(11930),
    [sym__tilde_operator] = ACTIONS(11930),
    [sym__type_order_operator] = ACTIONS(11930),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5700] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12064),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12064),
    [anon_sym_RPAREN] = ACTIONS(12064),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12064),
    [anon_sym_RBRACK] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12064),
    [anon_sym_LBRACE] = ACTIONS(12064),
    [anon_sym_RBRACE] = ACTIONS(12064),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12064),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12064),
    [anon_sym_QMARK] = ACTIONS(12064),
    [anon_sym_AT] = ACTIONS(12064),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12064),
    [aux_sym_integer_literal_token2] = ACTIONS(12064),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12064),
    [aux_sym_float_literal_token3] = ACTIONS(12064),
    [aux_sym_float_literal_token4] = ACTIONS(12064),
    [sym_character_literal] = ACTIONS(12064),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12064),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12064),
    [sym__lazy_and_operator] = ACTIONS(12064),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12064),
    [sym__pipe_left_operator] = ACTIONS(12064),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12064),
    [sym__type_order_operator] = ACTIONS(12064),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5701] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__assignment_operator] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5702] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__assignment_operator] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5703] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_finally] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_DASH_GT] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5704] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11934),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11934),
    [anon_sym_RPAREN] = ACTIONS(11934),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11934),
    [anon_sym_RBRACK] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11934),
    [anon_sym_LBRACE] = ACTIONS(11934),
    [anon_sym_RBRACE] = ACTIONS(11934),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11934),
    [anon_sym_COLON_COLON] = ACTIONS(11934),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11934),
    [anon_sym_QMARK] = ACTIONS(11934),
    [anon_sym_DASH_GT] = ACTIONS(11934),
    [anon_sym_AT] = ACTIONS(11934),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11934),
    [aux_sym_integer_literal_token2] = ACTIONS(11934),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11934),
    [aux_sym_float_literal_token3] = ACTIONS(11934),
    [aux_sym_float_literal_token4] = ACTIONS(11934),
    [sym_character_literal] = ACTIONS(11934),
    [sym__pair_operator] = ACTIONS(11934),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11934),
    [sym__lazy_and_operator] = ACTIONS(11934),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11934),
    [sym__pipe_left_operator] = ACTIONS(11934),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11934),
    [sym__bitshift_operator] = ACTIONS(11934),
    [sym__power_operator] = ACTIONS(11934),
    [sym__tilde_operator] = ACTIONS(11934),
    [sym__type_order_operator] = ACTIONS(11934),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5705] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [5706] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_DASH_GT] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [5707] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_DASH_GT] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [5708] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__assignment_operator] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5709] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__assignment_operator] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5710] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_else] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5711] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5712] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5713] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__assignment_operator] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5714] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_elseif] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5715] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__assignment_operator] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5716] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12180),
    [anon_sym_DOT] = ACTIONS(12420),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12422),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__immediate_bracket] = ACTIONS(12188),
    [sym__immediate_brace] = ACTIONS(12190),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5717] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12362),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12362),
    [anon_sym_RPAREN] = ACTIONS(12362),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12362),
    [anon_sym_RBRACK] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_SEMI] = ACTIONS(12362),
    [anon_sym_LBRACE] = ACTIONS(12362),
    [anon_sym_RBRACE] = ACTIONS(12362),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12362),
    [anon_sym_COLON_COLON] = ACTIONS(12362),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12362),
    [anon_sym_QMARK] = ACTIONS(12362),
    [anon_sym_DASH_GT] = ACTIONS(12362),
    [anon_sym_AT] = ACTIONS(12362),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12362),
    [aux_sym_integer_literal_token2] = ACTIONS(12362),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12362),
    [aux_sym_float_literal_token3] = ACTIONS(12362),
    [aux_sym_float_literal_token4] = ACTIONS(12362),
    [sym_character_literal] = ACTIONS(12362),
    [sym__pair_operator] = ACTIONS(12362),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12362),
    [sym__lazy_and_operator] = ACTIONS(12362),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12362),
    [sym__pipe_left_operator] = ACTIONS(12362),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12362),
    [sym__bitshift_operator] = ACTIONS(12362),
    [sym__power_operator] = ACTIONS(12362),
    [sym__tilde_operator] = ACTIONS(12362),
    [sym__type_order_operator] = ACTIONS(12362),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5718] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5719] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12366),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12366),
    [anon_sym_RPAREN] = ACTIONS(12366),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12366),
    [anon_sym_RBRACK] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_SEMI] = ACTIONS(12366),
    [anon_sym_LBRACE] = ACTIONS(12366),
    [anon_sym_RBRACE] = ACTIONS(12366),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12366),
    [anon_sym_COLON_COLON] = ACTIONS(12366),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12366),
    [anon_sym_QMARK] = ACTIONS(12366),
    [anon_sym_DASH_GT] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(12366),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12366),
    [aux_sym_integer_literal_token2] = ACTIONS(12366),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12366),
    [aux_sym_float_literal_token3] = ACTIONS(12366),
    [aux_sym_float_literal_token4] = ACTIONS(12366),
    [sym_character_literal] = ACTIONS(12366),
    [sym__pair_operator] = ACTIONS(12366),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12366),
    [sym__lazy_and_operator] = ACTIONS(12366),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12366),
    [sym__pipe_left_operator] = ACTIONS(12366),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12366),
    [sym__bitshift_operator] = ACTIONS(12366),
    [sym__power_operator] = ACTIONS(12366),
    [sym__tilde_operator] = ACTIONS(12366),
    [sym__type_order_operator] = ACTIONS(12366),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5720] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_elseif] = ACTIONS(12264),
    [anon_sym_else] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5721] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_DASH_GT] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [5722] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [5723] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_DASH_GT] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [5724] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__assignment_operator] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5725] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12138),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12138),
    [anon_sym_RPAREN] = ACTIONS(12138),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12138),
    [anon_sym_RBRACK] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_SEMI] = ACTIONS(12138),
    [anon_sym_LBRACE] = ACTIONS(12138),
    [anon_sym_RBRACE] = ACTIONS(12138),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12138),
    [anon_sym_COLON_COLON] = ACTIONS(12138),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_QMARK] = ACTIONS(12138),
    [anon_sym_DASH_GT] = ACTIONS(12138),
    [anon_sym_AT] = ACTIONS(12138),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12138),
    [aux_sym_integer_literal_token2] = ACTIONS(12138),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12138),
    [aux_sym_float_literal_token3] = ACTIONS(12138),
    [aux_sym_float_literal_token4] = ACTIONS(12138),
    [sym_character_literal] = ACTIONS(12138),
    [sym__pair_operator] = ACTIONS(12138),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12138),
    [sym__lazy_and_operator] = ACTIONS(12138),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12138),
    [sym__pipe_left_operator] = ACTIONS(12138),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12138),
    [sym__bitshift_operator] = ACTIONS(12138),
    [sym__power_operator] = ACTIONS(12138),
    [sym__tilde_operator] = ACTIONS(12138),
    [sym__type_order_operator] = ACTIONS(12138),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5726] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_else] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5727] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11914),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11914),
    [anon_sym_RPAREN] = ACTIONS(11914),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11914),
    [anon_sym_RBRACK] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11914),
    [anon_sym_LBRACE] = ACTIONS(11914),
    [anon_sym_RBRACE] = ACTIONS(11914),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11914),
    [anon_sym_COLON_COLON] = ACTIONS(11914),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11914),
    [anon_sym_QMARK] = ACTIONS(11914),
    [anon_sym_DASH_GT] = ACTIONS(11914),
    [anon_sym_AT] = ACTIONS(11914),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11914),
    [aux_sym_integer_literal_token2] = ACTIONS(11914),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11914),
    [aux_sym_float_literal_token3] = ACTIONS(11914),
    [aux_sym_float_literal_token4] = ACTIONS(11914),
    [sym_character_literal] = ACTIONS(11914),
    [sym__pair_operator] = ACTIONS(11914),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11914),
    [sym__lazy_and_operator] = ACTIONS(11914),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11914),
    [sym__pipe_left_operator] = ACTIONS(11914),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11914),
    [sym__bitshift_operator] = ACTIONS(11914),
    [sym__power_operator] = ACTIONS(11914),
    [sym__tilde_operator] = ACTIONS(11914),
    [sym__type_order_operator] = ACTIONS(11914),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5728] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__assignment_operator] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5729] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_DASH_GT] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [5730] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_DASH_GT] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [5731] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12370),
    [anon_sym_DOT] = ACTIONS(12452),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12454),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12376),
    [sym__immediate_bracket] = ACTIONS(12378),
    [sym__immediate_brace] = ACTIONS(12380),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5732] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_catch] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [5733] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12212),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12212),
    [anon_sym_RPAREN] = ACTIONS(12212),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12212),
    [anon_sym_RBRACK] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_SEMI] = ACTIONS(12212),
    [anon_sym_LBRACE] = ACTIONS(12212),
    [anon_sym_RBRACE] = ACTIONS(12212),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12212),
    [anon_sym_COLON_COLON] = ACTIONS(12212),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12212),
    [anon_sym_QMARK] = ACTIONS(12212),
    [anon_sym_DASH_GT] = ACTIONS(12212),
    [anon_sym_AT] = ACTIONS(12212),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12212),
    [aux_sym_integer_literal_token2] = ACTIONS(12212),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12212),
    [aux_sym_float_literal_token3] = ACTIONS(12212),
    [aux_sym_float_literal_token4] = ACTIONS(12212),
    [sym_character_literal] = ACTIONS(12212),
    [sym__pair_operator] = ACTIONS(12212),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12212),
    [sym__lazy_and_operator] = ACTIONS(12212),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12212),
    [sym__pipe_left_operator] = ACTIONS(12212),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12212),
    [sym__bitshift_operator] = ACTIONS(12212),
    [sym__power_operator] = ACTIONS(12212),
    [sym__tilde_operator] = ACTIONS(12212),
    [sym__type_order_operator] = ACTIONS(12212),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5734] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12172),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12172),
    [anon_sym_RPAREN] = ACTIONS(12172),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12172),
    [anon_sym_RBRACK] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_SEMI] = ACTIONS(12172),
    [anon_sym_LBRACE] = ACTIONS(12172),
    [anon_sym_RBRACE] = ACTIONS(12172),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12172),
    [anon_sym_COLON_COLON] = ACTIONS(12172),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12172),
    [anon_sym_QMARK] = ACTIONS(12172),
    [anon_sym_DASH_GT] = ACTIONS(12172),
    [anon_sym_AT] = ACTIONS(12172),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12172),
    [aux_sym_integer_literal_token2] = ACTIONS(12172),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12172),
    [aux_sym_float_literal_token3] = ACTIONS(12172),
    [aux_sym_float_literal_token4] = ACTIONS(12172),
    [sym_character_literal] = ACTIONS(12172),
    [sym__pair_operator] = ACTIONS(12172),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12172),
    [sym__lazy_and_operator] = ACTIONS(12172),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12172),
    [sym__pipe_left_operator] = ACTIONS(12172),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12172),
    [sym__bitshift_operator] = ACTIONS(12172),
    [sym__power_operator] = ACTIONS(12172),
    [sym__tilde_operator] = ACTIONS(12172),
    [sym__type_order_operator] = ACTIONS(12172),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5735] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_DASH_GT] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [5736] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12216),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12216),
    [anon_sym_RPAREN] = ACTIONS(12216),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12216),
    [anon_sym_RBRACK] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_SEMI] = ACTIONS(12216),
    [anon_sym_LBRACE] = ACTIONS(12216),
    [anon_sym_RBRACE] = ACTIONS(12216),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12216),
    [anon_sym_COLON_COLON] = ACTIONS(12216),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_QMARK] = ACTIONS(12216),
    [anon_sym_DASH_GT] = ACTIONS(12216),
    [anon_sym_AT] = ACTIONS(12216),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12216),
    [aux_sym_integer_literal_token2] = ACTIONS(12216),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12216),
    [aux_sym_float_literal_token3] = ACTIONS(12216),
    [aux_sym_float_literal_token4] = ACTIONS(12216),
    [sym_character_literal] = ACTIONS(12216),
    [sym__pair_operator] = ACTIONS(12216),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12216),
    [sym__lazy_and_operator] = ACTIONS(12216),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12216),
    [sym__pipe_left_operator] = ACTIONS(12216),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12216),
    [sym__bitshift_operator] = ACTIONS(12216),
    [sym__power_operator] = ACTIONS(12216),
    [sym__tilde_operator] = ACTIONS(12216),
    [sym__type_order_operator] = ACTIONS(12216),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5737] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_elseif] = ACTIONS(12268),
    [anon_sym_else] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5738] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_else] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_finally] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5739] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__assignment_operator] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5740] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_elseif] = ACTIONS(12272),
    [anon_sym_else] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5741] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5742] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__assignment_operator] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5743] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(12458),
    [sym__immediate_command_start] = ACTIONS(12460),
  },
  [5744] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__assignment_operator] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5745] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_catch] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__assignment_operator] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5746] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_elseif] = ACTIONS(12304),
    [anon_sym_else] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5747] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__assignment_operator] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5748] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__assignment_operator] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5749] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_else] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5750] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__assignment_operator] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5751] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_RPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_SEMI] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__assignment_operator] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [5752] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__assignment_operator] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5753] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5754] = {
    [sym__word_identifier] = ACTIONS(12194),
    [anon_sym_EQ] = ACTIONS(12194),
    [anon_sym_COMMA] = ACTIONS(12196),
    [anon_sym_COLON] = ACTIONS(12194),
    [anon_sym_begin] = ACTIONS(12194),
    [anon_sym_module] = ACTIONS(12194),
    [anon_sym_baremodule] = ACTIONS(12194),
    [anon_sym_abstract] = ACTIONS(12194),
    [anon_sym_primitive] = ACTIONS(12194),
    [anon_sym_mutable] = ACTIONS(12194),
    [anon_sym_struct] = ACTIONS(12194),
    [anon_sym_function] = ACTIONS(12194),
    [anon_sym_macro] = ACTIONS(12194),
    [anon_sym_where] = ACTIONS(12194),
    [anon_sym_quote] = ACTIONS(12194),
    [anon_sym_let] = ACTIONS(12194),
    [anon_sym_if] = ACTIONS(12194),
    [anon_sym_try] = ACTIONS(12194),
    [anon_sym_for] = ACTIONS(12194),
    [anon_sym_while] = ACTIONS(12194),
    [sym_break_statement] = ACTIONS(12194),
    [sym_continue_statement] = ACTIONS(12194),
    [anon_sym_return] = ACTIONS(12194),
    [anon_sym_const] = ACTIONS(12194),
    [anon_sym_global] = ACTIONS(12194),
    [anon_sym_local] = ACTIONS(12194),
    [anon_sym_LPAREN] = ACTIONS(12196),
    [anon_sym_RPAREN] = ACTIONS(12196),
    [anon_sym_COLON2] = ACTIONS(12194),
    [anon_sym_export] = ACTIONS(12194),
    [anon_sym_import] = ACTIONS(12194),
    [anon_sym_using] = ACTIONS(12194),
    [anon_sym_LBRACK] = ACTIONS(12196),
    [anon_sym_RBRACK] = ACTIONS(12196),
    [anon_sym_in] = ACTIONS(12194),
    [anon_sym_SEMI] = ACTIONS(12196),
    [anon_sym_LBRACE] = ACTIONS(12196),
    [anon_sym_RBRACE] = ACTIONS(12196),
    [anon_sym_SQUOTE] = ACTIONS(12582),
    [anon_sym_DOT] = ACTIONS(12584),
    [anon_sym_DOLLAR] = ACTIONS(12196),
    [anon_sym_COLON_COLON] = ACTIONS(12196),
    [anon_sym_isa] = ACTIONS(12194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12196),
    [anon_sym_QMARK] = ACTIONS(12196),
    [anon_sym_DASH_GT] = ACTIONS(12196),
    [anon_sym_AT] = ACTIONS(12196),
    [anon_sym_true] = ACTIONS(12194),
    [anon_sym_false] = ACTIONS(12194),
    [aux_sym_integer_literal_token1] = ACTIONS(12196),
    [aux_sym_integer_literal_token2] = ACTIONS(12196),
    [aux_sym_integer_literal_token3] = ACTIONS(12194),
    [aux_sym_integer_literal_token4] = ACTIONS(12194),
    [aux_sym_float_literal_token1] = ACTIONS(12196),
    [aux_sym_float_literal_token3] = ACTIONS(12196),
    [aux_sym_float_literal_token4] = ACTIONS(12196),
    [sym_character_literal] = ACTIONS(12196),
    [sym__pair_operator] = ACTIONS(12196),
    [sym__arrow_operator] = ACTIONS(12194),
    [sym__lazy_or_operator] = ACTIONS(12196),
    [sym__lazy_and_operator] = ACTIONS(12196),
    [sym__comparison_operator] = ACTIONS(12194),
    [sym__pipe_right_operator] = ACTIONS(12196),
    [sym__pipe_left_operator] = ACTIONS(12196),
    [sym__ellipsis_operator] = ACTIONS(12194),
    [sym__plus_operator] = ACTIONS(12194),
    [sym__times_operator] = ACTIONS(12194),
    [sym__rational_operator] = ACTIONS(12196),
    [sym__bitshift_operator] = ACTIONS(12196),
    [sym__power_operator] = ACTIONS(12196),
    [sym__tilde_operator] = ACTIONS(12196),
    [sym__type_order_operator] = ACTIONS(12196),
    [sym__unary_operator] = ACTIONS(12194),
    [sym__unary_plus_operator] = ACTIONS(12194),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12586),
    [sym__immediate_bracket] = ACTIONS(12588),
    [sym__immediate_brace] = ACTIONS(12590),
    [sym__string_start] = ACTIONS(12196),
    [sym__command_start] = ACTIONS(12196),
  },
  [5755] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_else] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_finally] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5756] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_else] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_finally] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5757] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_else] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5758] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__assignment_operator] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5759] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__assignment_operator] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5760] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_else] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5761] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__assignment_operator] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5762] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__assignment_operator] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5763] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [5764] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_catch] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [5765] = {
    [sym_do_clause] = STATE(6526),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_EQ] = ACTIONS(11902),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_COLON2] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11902),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(12580),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_isa] = ACTIONS(11902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11902),
    [anon_sym_QMARK] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__lazy_or_operator] = ACTIONS(11902),
    [sym__lazy_and_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [5766] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_elseif] = ACTIONS(12276),
    [anon_sym_else] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5767] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5768] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5769] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_elseif] = ACTIONS(12280),
    [anon_sym_else] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5770] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_elseif] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5771] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_catch] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [5772] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_catch] = ACTIONS(12218),
    [anon_sym_finally] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_DASH_GT] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5773] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5774] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5775] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12068),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12068),
    [anon_sym_RPAREN] = ACTIONS(12068),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12068),
    [anon_sym_RBRACK] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12068),
    [anon_sym_LBRACE] = ACTIONS(12068),
    [anon_sym_RBRACE] = ACTIONS(12068),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12068),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12068),
    [anon_sym_QMARK] = ACTIONS(12068),
    [anon_sym_AT] = ACTIONS(12068),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12068),
    [aux_sym_integer_literal_token2] = ACTIONS(12068),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12068),
    [aux_sym_float_literal_token3] = ACTIONS(12068),
    [aux_sym_float_literal_token4] = ACTIONS(12068),
    [sym_character_literal] = ACTIONS(12068),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12068),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12068),
    [sym__lazy_and_operator] = ACTIONS(12068),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12068),
    [sym__pipe_left_operator] = ACTIONS(12068),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12068),
    [sym__type_order_operator] = ACTIONS(12068),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5776] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_else] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_finally] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5777] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_elseif] = ACTIONS(12284),
    [anon_sym_else] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5778] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_else] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_finally] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5779] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5780] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12340),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12340),
    [anon_sym_RPAREN] = ACTIONS(12340),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12340),
    [anon_sym_RBRACK] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(12340),
    [anon_sym_LBRACE] = ACTIONS(12340),
    [anon_sym_RBRACE] = ACTIONS(12340),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12340),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12340),
    [anon_sym_QMARK] = ACTIONS(12340),
    [anon_sym_AT] = ACTIONS(12340),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12340),
    [aux_sym_integer_literal_token2] = ACTIONS(12340),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12340),
    [aux_sym_float_literal_token3] = ACTIONS(12340),
    [aux_sym_float_literal_token4] = ACTIONS(12340),
    [sym_character_literal] = ACTIONS(12340),
    [sym__assignment_operator] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12340),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12340),
    [sym__lazy_and_operator] = ACTIONS(12340),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12340),
    [sym__pipe_left_operator] = ACTIONS(12340),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12340),
    [sym__type_order_operator] = ACTIONS(12340),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5781] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12096),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12592),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12096),
    [sym__bitshift_operator] = ACTIONS(12096),
    [sym__power_operator] = ACTIONS(12096),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5782] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12344),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12344),
    [anon_sym_RPAREN] = ACTIONS(12344),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12344),
    [anon_sym_RBRACK] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_SEMI] = ACTIONS(12344),
    [anon_sym_LBRACE] = ACTIONS(12344),
    [anon_sym_RBRACE] = ACTIONS(12344),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12344),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12344),
    [anon_sym_QMARK] = ACTIONS(12344),
    [anon_sym_AT] = ACTIONS(12344),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12344),
    [aux_sym_integer_literal_token2] = ACTIONS(12344),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12344),
    [aux_sym_float_literal_token3] = ACTIONS(12344),
    [aux_sym_float_literal_token4] = ACTIONS(12344),
    [sym_character_literal] = ACTIONS(12344),
    [sym__assignment_operator] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12344),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12344),
    [sym__lazy_and_operator] = ACTIONS(12344),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12344),
    [sym__pipe_left_operator] = ACTIONS(12344),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12344),
    [sym__type_order_operator] = ACTIONS(12344),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5783] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_catch] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__assignment_operator] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5784] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [5785] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_elseif] = ACTIONS(12142),
    [anon_sym_else] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5786] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_elseif] = ACTIONS(12146),
    [anon_sym_else] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5787] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11930),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11930),
    [anon_sym_RPAREN] = ACTIONS(11930),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11930),
    [anon_sym_RBRACK] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11930),
    [anon_sym_LBRACE] = ACTIONS(11930),
    [anon_sym_RBRACE] = ACTIONS(11930),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11930),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11930),
    [anon_sym_QMARK] = ACTIONS(11930),
    [anon_sym_AT] = ACTIONS(11930),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11930),
    [aux_sym_integer_literal_token2] = ACTIONS(11930),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11930),
    [aux_sym_float_literal_token3] = ACTIONS(11930),
    [aux_sym_float_literal_token4] = ACTIONS(11930),
    [sym_character_literal] = ACTIONS(11930),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11930),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11930),
    [sym__lazy_and_operator] = ACTIONS(11930),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11930),
    [sym__pipe_left_operator] = ACTIONS(11930),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11930),
    [sym__type_order_operator] = ACTIONS(11930),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5788] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_elseif] = ACTIONS(12150),
    [anon_sym_else] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5789] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__assignment_operator] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5790] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [5791] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_elseif] = ACTIONS(12154),
    [anon_sym_else] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5792] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_catch] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [5793] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__assignment_operator] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [5794] = {
    [sym__word_identifier] = ACTIONS(12558),
    [anon_sym_EQ] = ACTIONS(12558),
    [anon_sym_COMMA] = ACTIONS(12558),
    [anon_sym_COLON] = ACTIONS(12558),
    [anon_sym_begin] = ACTIONS(12558),
    [anon_sym_module] = ACTIONS(12558),
    [anon_sym_baremodule] = ACTIONS(12558),
    [anon_sym_end] = ACTIONS(12558),
    [anon_sym_abstract] = ACTIONS(12558),
    [anon_sym_primitive] = ACTIONS(12558),
    [anon_sym_mutable] = ACTIONS(12558),
    [anon_sym_struct] = ACTIONS(12558),
    [anon_sym_function] = ACTIONS(12558),
    [anon_sym_macro] = ACTIONS(12558),
    [anon_sym_where] = ACTIONS(12558),
    [anon_sym_quote] = ACTIONS(12558),
    [anon_sym_let] = ACTIONS(12558),
    [anon_sym_if] = ACTIONS(12558),
    [anon_sym_else] = ACTIONS(12558),
    [anon_sym_try] = ACTIONS(12558),
    [anon_sym_finally] = ACTIONS(12558),
    [anon_sym_for] = ACTIONS(12558),
    [anon_sym_while] = ACTIONS(12558),
    [sym_break_statement] = ACTIONS(12558),
    [sym_continue_statement] = ACTIONS(12558),
    [anon_sym_return] = ACTIONS(12558),
    [anon_sym_const] = ACTIONS(12558),
    [anon_sym_global] = ACTIONS(12558),
    [anon_sym_local] = ACTIONS(12558),
    [anon_sym_LPAREN] = ACTIONS(12558),
    [anon_sym_COLON2] = ACTIONS(12558),
    [anon_sym_export] = ACTIONS(12558),
    [anon_sym_import] = ACTIONS(12558),
    [anon_sym_using] = ACTIONS(12558),
    [anon_sym_LBRACK] = ACTIONS(12558),
    [anon_sym_LF] = ACTIONS(12560),
    [anon_sym_in] = ACTIONS(12558),
    [anon_sym_LBRACE] = ACTIONS(12558),
    [anon_sym_SQUOTE] = ACTIONS(12522),
    [anon_sym_DOT] = ACTIONS(12524),
    [anon_sym_DOLLAR] = ACTIONS(12558),
    [anon_sym_COLON_COLON] = ACTIONS(12558),
    [anon_sym_isa] = ACTIONS(12558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12558),
    [anon_sym_QMARK] = ACTIONS(12558),
    [anon_sym_AT] = ACTIONS(12558),
    [anon_sym_true] = ACTIONS(12558),
    [anon_sym_false] = ACTIONS(12558),
    [aux_sym_integer_literal_token1] = ACTIONS(12558),
    [aux_sym_integer_literal_token2] = ACTIONS(12558),
    [aux_sym_integer_literal_token3] = ACTIONS(12558),
    [aux_sym_integer_literal_token4] = ACTIONS(12558),
    [aux_sym_float_literal_token1] = ACTIONS(12558),
    [aux_sym_float_literal_token3] = ACTIONS(12558),
    [aux_sym_float_literal_token4] = ACTIONS(12558),
    [sym_character_literal] = ACTIONS(12558),
    [sym__pair_operator] = ACTIONS(12558),
    [sym__arrow_operator] = ACTIONS(12558),
    [sym__lazy_or_operator] = ACTIONS(12558),
    [sym__lazy_and_operator] = ACTIONS(12558),
    [sym__comparison_operator] = ACTIONS(12558),
    [sym__pipe_right_operator] = ACTIONS(12558),
    [sym__pipe_left_operator] = ACTIONS(12558),
    [sym__ellipsis_operator] = ACTIONS(12558),
    [sym__plus_operator] = ACTIONS(12558),
    [sym__times_operator] = ACTIONS(12558),
    [sym__rational_operator] = ACTIONS(12558),
    [sym__bitshift_operator] = ACTIONS(12558),
    [sym__power_operator] = ACTIONS(12558),
    [sym__tilde_operator] = ACTIONS(12558),
    [sym__type_order_operator] = ACTIONS(12558),
    [sym__unary_operator] = ACTIONS(12558),
    [sym__unary_plus_operator] = ACTIONS(12558),
    [aux_sym__terminator_token1] = ACTIONS(12558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12526),
    [sym__immediate_bracket] = ACTIONS(12528),
    [sym__immediate_brace] = ACTIONS(12530),
    [sym__string_start] = ACTIONS(12560),
    [sym__command_start] = ACTIONS(12560),
  },
  [5795] = {
    [sym_do_clause] = STATE(6555),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(12580),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5796] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_elseif] = ACTIONS(12158),
    [anon_sym_else] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5797] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_elseif] = ACTIONS(12162),
    [anon_sym_else] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5798] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_else] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_finally] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5799] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__assignment_operator] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5800] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_else] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5801] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_catch] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [5802] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5803] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11934),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11934),
    [anon_sym_RPAREN] = ACTIONS(11934),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11934),
    [anon_sym_RBRACK] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11934),
    [anon_sym_LBRACE] = ACTIONS(11934),
    [anon_sym_RBRACE] = ACTIONS(11934),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11934),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11934),
    [anon_sym_QMARK] = ACTIONS(11934),
    [anon_sym_AT] = ACTIONS(11934),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11934),
    [aux_sym_integer_literal_token2] = ACTIONS(11934),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11934),
    [aux_sym_float_literal_token3] = ACTIONS(11934),
    [aux_sym_float_literal_token4] = ACTIONS(11934),
    [sym_character_literal] = ACTIONS(11934),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11934),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11934),
    [sym__lazy_and_operator] = ACTIONS(11934),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11934),
    [sym__pipe_left_operator] = ACTIONS(11934),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11934),
    [sym__type_order_operator] = ACTIONS(11934),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5804] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__assignment_operator] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [5805] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_catch] = ACTIONS(12360),
    [anon_sym_finally] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_DASH_GT] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5806] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12208),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12208),
    [anon_sym_RPAREN] = ACTIONS(12208),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_SEMI] = ACTIONS(12208),
    [anon_sym_LBRACE] = ACTIONS(12208),
    [anon_sym_RBRACE] = ACTIONS(12208),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12208),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12208),
    [anon_sym_QMARK] = ACTIONS(12208),
    [anon_sym_AT] = ACTIONS(12208),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12208),
    [aux_sym_integer_literal_token2] = ACTIONS(12208),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12208),
    [aux_sym_float_literal_token3] = ACTIONS(12208),
    [aux_sym_float_literal_token4] = ACTIONS(12208),
    [sym_character_literal] = ACTIONS(12208),
    [sym__assignment_operator] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12208),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12208),
    [sym__lazy_and_operator] = ACTIONS(12208),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12208),
    [sym__pipe_left_operator] = ACTIONS(12208),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12208),
    [sym__type_order_operator] = ACTIONS(12208),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5807] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_elseif] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5808] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_else] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_finally] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5809] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_else] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_finally] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5810] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__assignment_operator] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5811] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__assignment_operator] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5812] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_else] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_finally] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5813] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12096),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5814] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5815] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12386),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12386),
    [anon_sym_RPAREN] = ACTIONS(12386),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12386),
    [anon_sym_RBRACK] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_SEMI] = ACTIONS(12386),
    [anon_sym_LBRACE] = ACTIONS(12386),
    [anon_sym_RBRACE] = ACTIONS(12386),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12386),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12386),
    [anon_sym_QMARK] = ACTIONS(12386),
    [anon_sym_AT] = ACTIONS(12386),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12386),
    [aux_sym_integer_literal_token2] = ACTIONS(12386),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12386),
    [aux_sym_float_literal_token3] = ACTIONS(12386),
    [aux_sym_float_literal_token4] = ACTIONS(12386),
    [sym_character_literal] = ACTIONS(12386),
    [sym__assignment_operator] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12386),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12386),
    [sym__lazy_and_operator] = ACTIONS(12386),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12386),
    [sym__pipe_left_operator] = ACTIONS(12386),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12386),
    [sym__type_order_operator] = ACTIONS(12386),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [5816] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_elseif] = ACTIONS(12170),
    [anon_sym_else] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5817] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5818] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_catch] = ACTIONS(12214),
    [anon_sym_finally] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__assignment_operator] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5819] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_catch] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__assignment_operator] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5820] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11890),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11890),
    [anon_sym_RPAREN] = ACTIONS(11890),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11890),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11890),
    [anon_sym_RBRACE] = ACTIONS(11890),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11890),
    [anon_sym_COLON_COLON] = ACTIONS(11890),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11890),
    [anon_sym_QMARK] = ACTIONS(11890),
    [anon_sym_DASH_GT] = ACTIONS(11890),
    [anon_sym_AT] = ACTIONS(11890),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11890),
    [aux_sym_integer_literal_token2] = ACTIONS(11890),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11890),
    [aux_sym_float_literal_token3] = ACTIONS(11890),
    [aux_sym_float_literal_token4] = ACTIONS(11890),
    [sym_character_literal] = ACTIONS(11890),
    [sym__pair_operator] = ACTIONS(11890),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11890),
    [sym__lazy_and_operator] = ACTIONS(11890),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11890),
    [sym__pipe_left_operator] = ACTIONS(11890),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11890),
    [sym__bitshift_operator] = ACTIONS(11890),
    [sym__power_operator] = ACTIONS(11890),
    [sym__tilde_operator] = ACTIONS(11890),
    [sym__type_order_operator] = ACTIONS(11890),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5821] = {
    [ts_builtin_sym_end] = ACTIONS(12560),
    [sym__word_identifier] = ACTIONS(12558),
    [anon_sym_EQ] = ACTIONS(12558),
    [anon_sym_COMMA] = ACTIONS(12558),
    [anon_sym_COLON] = ACTIONS(12558),
    [anon_sym_begin] = ACTIONS(12558),
    [anon_sym_module] = ACTIONS(12558),
    [anon_sym_baremodule] = ACTIONS(12558),
    [anon_sym_abstract] = ACTIONS(12558),
    [anon_sym_primitive] = ACTIONS(12558),
    [anon_sym_mutable] = ACTIONS(12558),
    [anon_sym_struct] = ACTIONS(12558),
    [anon_sym_function] = ACTIONS(12558),
    [anon_sym_macro] = ACTIONS(12558),
    [anon_sym_where] = ACTIONS(12558),
    [anon_sym_quote] = ACTIONS(12558),
    [anon_sym_let] = ACTIONS(12558),
    [anon_sym_if] = ACTIONS(12558),
    [anon_sym_try] = ACTIONS(12558),
    [anon_sym_for] = ACTIONS(12558),
    [anon_sym_while] = ACTIONS(12558),
    [sym_break_statement] = ACTIONS(12558),
    [sym_continue_statement] = ACTIONS(12558),
    [anon_sym_return] = ACTIONS(12558),
    [anon_sym_const] = ACTIONS(12558),
    [anon_sym_global] = ACTIONS(12558),
    [anon_sym_local] = ACTIONS(12558),
    [anon_sym_LPAREN] = ACTIONS(12558),
    [anon_sym_RPAREN] = ACTIONS(12558),
    [anon_sym_COLON2] = ACTIONS(12558),
    [anon_sym_export] = ACTIONS(12558),
    [anon_sym_import] = ACTIONS(12558),
    [anon_sym_using] = ACTIONS(12558),
    [anon_sym_LBRACK] = ACTIONS(12558),
    [anon_sym_RBRACK] = ACTIONS(12558),
    [anon_sym_LF] = ACTIONS(12560),
    [anon_sym_in] = ACTIONS(12558),
    [anon_sym_LBRACE] = ACTIONS(12558),
    [anon_sym_SQUOTE] = ACTIONS(12478),
    [anon_sym_DOT] = ACTIONS(12480),
    [anon_sym_DOLLAR] = ACTIONS(12558),
    [anon_sym_COLON_COLON] = ACTIONS(12558),
    [anon_sym_isa] = ACTIONS(12558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12558),
    [anon_sym_QMARK] = ACTIONS(12558),
    [anon_sym_AT] = ACTIONS(12558),
    [anon_sym_true] = ACTIONS(12558),
    [anon_sym_false] = ACTIONS(12558),
    [aux_sym_integer_literal_token1] = ACTIONS(12558),
    [aux_sym_integer_literal_token2] = ACTIONS(12558),
    [aux_sym_integer_literal_token3] = ACTIONS(12558),
    [aux_sym_integer_literal_token4] = ACTIONS(12558),
    [aux_sym_float_literal_token1] = ACTIONS(12558),
    [aux_sym_float_literal_token3] = ACTIONS(12558),
    [aux_sym_float_literal_token4] = ACTIONS(12558),
    [sym_character_literal] = ACTIONS(12558),
    [sym__pair_operator] = ACTIONS(12558),
    [sym__arrow_operator] = ACTIONS(12558),
    [sym__lazy_or_operator] = ACTIONS(12558),
    [sym__lazy_and_operator] = ACTIONS(12558),
    [sym__comparison_operator] = ACTIONS(12558),
    [sym__pipe_right_operator] = ACTIONS(12558),
    [sym__pipe_left_operator] = ACTIONS(12558),
    [sym__ellipsis_operator] = ACTIONS(12558),
    [sym__plus_operator] = ACTIONS(12558),
    [sym__times_operator] = ACTIONS(12558),
    [sym__rational_operator] = ACTIONS(12558),
    [sym__bitshift_operator] = ACTIONS(12558),
    [sym__power_operator] = ACTIONS(12558),
    [sym__tilde_operator] = ACTIONS(12558),
    [sym__type_order_operator] = ACTIONS(12558),
    [sym__unary_operator] = ACTIONS(12558),
    [sym__unary_plus_operator] = ACTIONS(12558),
    [aux_sym__terminator_token1] = ACTIONS(12558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12482),
    [sym__immediate_bracket] = ACTIONS(12484),
    [sym__immediate_brace] = ACTIONS(12486),
    [sym__string_start] = ACTIONS(12560),
    [sym__command_start] = ACTIONS(12560),
  },
  [5822] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_elseif] = ACTIONS(12178),
    [anon_sym_else] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5823] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_catch] = ACTIONS(12218),
    [anon_sym_finally] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__assignment_operator] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [5824] = {
    [sym_identifier] = STATE(6350),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__assignment_operator] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [5825] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__assignment_operator] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5826] = {
    [sym_identifier] = STATE(6353),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__assignment_operator] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [5827] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12390),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12390),
    [anon_sym_RPAREN] = ACTIONS(12390),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12390),
    [anon_sym_RBRACK] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_SEMI] = ACTIONS(12390),
    [anon_sym_LBRACE] = ACTIONS(12390),
    [anon_sym_RBRACE] = ACTIONS(12390),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12390),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12390),
    [anon_sym_QMARK] = ACTIONS(12390),
    [anon_sym_AT] = ACTIONS(12390),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12390),
    [aux_sym_integer_literal_token2] = ACTIONS(12390),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12390),
    [aux_sym_float_literal_token3] = ACTIONS(12390),
    [aux_sym_float_literal_token4] = ACTIONS(12390),
    [sym_character_literal] = ACTIONS(12390),
    [sym__assignment_operator] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12390),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12390),
    [sym__lazy_and_operator] = ACTIONS(12390),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12390),
    [sym__pipe_left_operator] = ACTIONS(12390),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12390),
    [sym__type_order_operator] = ACTIONS(12390),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [5828] = {
    [sym__word_identifier] = ACTIONS(12194),
    [anon_sym_EQ] = ACTIONS(12194),
    [anon_sym_COMMA] = ACTIONS(12194),
    [anon_sym_COLON] = ACTIONS(12194),
    [anon_sym_begin] = ACTIONS(12194),
    [anon_sym_module] = ACTIONS(12194),
    [anon_sym_baremodule] = ACTIONS(12194),
    [anon_sym_abstract] = ACTIONS(12194),
    [anon_sym_primitive] = ACTIONS(12194),
    [anon_sym_mutable] = ACTIONS(12194),
    [anon_sym_struct] = ACTIONS(12194),
    [anon_sym_function] = ACTIONS(12194),
    [anon_sym_macro] = ACTIONS(12194),
    [anon_sym_where] = ACTIONS(12194),
    [anon_sym_quote] = ACTIONS(12194),
    [anon_sym_let] = ACTIONS(12194),
    [anon_sym_if] = ACTIONS(12194),
    [anon_sym_try] = ACTIONS(12194),
    [anon_sym_catch] = ACTIONS(12194),
    [anon_sym_finally] = ACTIONS(12194),
    [anon_sym_for] = ACTIONS(12194),
    [anon_sym_while] = ACTIONS(12194),
    [sym_break_statement] = ACTIONS(12194),
    [sym_continue_statement] = ACTIONS(12194),
    [anon_sym_return] = ACTIONS(12194),
    [anon_sym_const] = ACTIONS(12194),
    [anon_sym_global] = ACTIONS(12194),
    [anon_sym_local] = ACTIONS(12194),
    [anon_sym_LPAREN] = ACTIONS(12194),
    [anon_sym_COLON2] = ACTIONS(12194),
    [anon_sym_export] = ACTIONS(12194),
    [anon_sym_import] = ACTIONS(12194),
    [anon_sym_using] = ACTIONS(12194),
    [anon_sym_LBRACK] = ACTIONS(12194),
    [anon_sym_LF] = ACTIONS(12196),
    [anon_sym_in] = ACTIONS(12194),
    [anon_sym_LBRACE] = ACTIONS(12194),
    [anon_sym_SQUOTE] = ACTIONS(12594),
    [anon_sym_DOT] = ACTIONS(12596),
    [anon_sym_DOLLAR] = ACTIONS(12194),
    [anon_sym_COLON_COLON] = ACTIONS(12194),
    [anon_sym_isa] = ACTIONS(12194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12194),
    [anon_sym_QMARK] = ACTIONS(12194),
    [anon_sym_DASH_GT] = ACTIONS(12194),
    [anon_sym_AT] = ACTIONS(12194),
    [anon_sym_true] = ACTIONS(12194),
    [anon_sym_false] = ACTIONS(12194),
    [aux_sym_integer_literal_token1] = ACTIONS(12194),
    [aux_sym_integer_literal_token2] = ACTIONS(12194),
    [aux_sym_integer_literal_token3] = ACTIONS(12194),
    [aux_sym_integer_literal_token4] = ACTIONS(12194),
    [aux_sym_float_literal_token1] = ACTIONS(12194),
    [aux_sym_float_literal_token3] = ACTIONS(12194),
    [aux_sym_float_literal_token4] = ACTIONS(12194),
    [sym_character_literal] = ACTIONS(12194),
    [sym__pair_operator] = ACTIONS(12194),
    [sym__arrow_operator] = ACTIONS(12194),
    [sym__lazy_or_operator] = ACTIONS(12194),
    [sym__lazy_and_operator] = ACTIONS(12194),
    [sym__comparison_operator] = ACTIONS(12194),
    [sym__pipe_right_operator] = ACTIONS(12194),
    [sym__pipe_left_operator] = ACTIONS(12194),
    [sym__ellipsis_operator] = ACTIONS(12194),
    [sym__plus_operator] = ACTIONS(12194),
    [sym__times_operator] = ACTIONS(12194),
    [sym__rational_operator] = ACTIONS(12194),
    [sym__bitshift_operator] = ACTIONS(12194),
    [sym__power_operator] = ACTIONS(12194),
    [sym__tilde_operator] = ACTIONS(12194),
    [sym__type_order_operator] = ACTIONS(12194),
    [sym__unary_operator] = ACTIONS(12194),
    [sym__unary_plus_operator] = ACTIONS(12194),
    [aux_sym__terminator_token1] = ACTIONS(12194),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12598),
    [sym__immediate_bracket] = ACTIONS(12600),
    [sym__immediate_brace] = ACTIONS(12602),
    [sym__string_start] = ACTIONS(12196),
    [sym__command_start] = ACTIONS(12196),
  },
  [5829] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_finally] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [5830] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12324),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12324),
    [anon_sym_RPAREN] = ACTIONS(12324),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12324),
    [anon_sym_RBRACK] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_SEMI] = ACTIONS(12324),
    [anon_sym_LBRACE] = ACTIONS(12324),
    [anon_sym_RBRACE] = ACTIONS(12324),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12324),
    [anon_sym_COLON_COLON] = ACTIONS(12324),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12324),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_DASH_GT] = ACTIONS(12324),
    [anon_sym_AT] = ACTIONS(12324),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12324),
    [aux_sym_integer_literal_token2] = ACTIONS(12324),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12324),
    [aux_sym_float_literal_token3] = ACTIONS(12324),
    [aux_sym_float_literal_token4] = ACTIONS(12324),
    [sym_character_literal] = ACTIONS(12324),
    [sym__pair_operator] = ACTIONS(12324),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12324),
    [sym__lazy_and_operator] = ACTIONS(12324),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12324),
    [sym__pipe_left_operator] = ACTIONS(12324),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12324),
    [sym__bitshift_operator] = ACTIONS(12324),
    [sym__power_operator] = ACTIONS(12324),
    [sym__tilde_operator] = ACTIONS(12324),
    [sym__type_order_operator] = ACTIONS(12324),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5831] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_catch] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_DASH_GT] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5832] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_catch] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_DASH_GT] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5833] = {
    [ts_builtin_sym_end] = ACTIONS(11864),
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [5834] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_catch] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_DASH_GT] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5835] = {
    [ts_builtin_sym_end] = ACTIONS(12328),
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_RPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_RBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5836] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_finally] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__assignment_operator] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5837] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_catch] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_DASH_GT] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5838] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_catch] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_DASH_GT] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5839] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_catch] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_DASH_GT] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5840] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_catch] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_DASH_GT] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5841] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5842] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5843] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_catch] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_DASH_GT] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5844] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_catch] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__assignment_operator] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5845] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_catch] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_DASH_GT] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5846] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_catch] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_DASH_GT] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5847] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_catch] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_DASH_GT] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5848] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_catch] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_DASH_GT] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5849] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_catch] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [5850] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_catch] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__assignment_operator] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5851] = {
    [ts_builtin_sym_end] = ACTIONS(11890),
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_RBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5852] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5853] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_elseif] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [5854] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12336),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12336),
    [anon_sym_RPAREN] = ACTIONS(12336),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12336),
    [anon_sym_RBRACK] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_SEMI] = ACTIONS(12336),
    [anon_sym_LBRACE] = ACTIONS(12336),
    [anon_sym_RBRACE] = ACTIONS(12336),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12336),
    [anon_sym_COLON_COLON] = ACTIONS(12336),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12336),
    [anon_sym_QMARK] = ACTIONS(12336),
    [anon_sym_DASH_GT] = ACTIONS(12336),
    [anon_sym_AT] = ACTIONS(12336),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12336),
    [aux_sym_integer_literal_token2] = ACTIONS(12336),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12336),
    [aux_sym_float_literal_token3] = ACTIONS(12336),
    [aux_sym_float_literal_token4] = ACTIONS(12336),
    [sym_character_literal] = ACTIONS(12336),
    [sym__pair_operator] = ACTIONS(12336),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12336),
    [sym__lazy_and_operator] = ACTIONS(12336),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12336),
    [sym__pipe_left_operator] = ACTIONS(12336),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12336),
    [sym__bitshift_operator] = ACTIONS(12336),
    [sym__power_operator] = ACTIONS(12336),
    [sym__tilde_operator] = ACTIONS(12336),
    [sym__type_order_operator] = ACTIONS(12336),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5855] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_catch] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_DASH_GT] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5856] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_catch] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_DASH_GT] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5857] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_catch] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_DASH_GT] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5858] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12564),
    [anon_sym_DOT] = ACTIONS(12604),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12606),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12570),
    [sym__immediate_bracket] = ACTIONS(12572),
    [sym__immediate_brace] = ACTIONS(12574),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5859] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_catch] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_DASH_GT] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5860] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_catch] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_DASH_GT] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5861] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_catch] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_DASH_GT] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5862] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_catch] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_DASH_GT] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5863] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_catch] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__assignment_operator] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5864] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_catch] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__assignment_operator] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5865] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_catch] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_DASH_GT] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5866] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_catch] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [5867] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_catch] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_DASH_GT] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5868] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_catch] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_DASH_GT] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5869] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5870] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_elseif] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5871] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_catch] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__assignment_operator] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [5872] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__assignment_operator] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [5873] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_catch] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__assignment_operator] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [5874] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__assignment_operator] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [5875] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12362),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12362),
    [anon_sym_RPAREN] = ACTIONS(12362),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12362),
    [anon_sym_RBRACK] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_SEMI] = ACTIONS(12362),
    [anon_sym_LBRACE] = ACTIONS(12362),
    [anon_sym_RBRACE] = ACTIONS(12362),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12362),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12362),
    [anon_sym_QMARK] = ACTIONS(12362),
    [anon_sym_AT] = ACTIONS(12362),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12362),
    [aux_sym_integer_literal_token2] = ACTIONS(12362),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12362),
    [aux_sym_float_literal_token3] = ACTIONS(12362),
    [aux_sym_float_literal_token4] = ACTIONS(12362),
    [sym_character_literal] = ACTIONS(12362),
    [sym__assignment_operator] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12362),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12362),
    [sym__lazy_and_operator] = ACTIONS(12362),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12362),
    [sym__pipe_left_operator] = ACTIONS(12362),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12362),
    [sym__type_order_operator] = ACTIONS(12362),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5876] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__assignment_operator] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [5877] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12022),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12022),
    [anon_sym_RPAREN] = ACTIONS(12022),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12022),
    [anon_sym_RBRACK] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_SEMI] = ACTIONS(12022),
    [anon_sym_LBRACE] = ACTIONS(12022),
    [anon_sym_RBRACE] = ACTIONS(12022),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12022),
    [anon_sym_COLON_COLON] = ACTIONS(12022),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12022),
    [anon_sym_QMARK] = ACTIONS(12022),
    [anon_sym_AT] = ACTIONS(12022),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12022),
    [aux_sym_integer_literal_token2] = ACTIONS(12022),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12022),
    [aux_sym_float_literal_token3] = ACTIONS(12022),
    [aux_sym_float_literal_token4] = ACTIONS(12022),
    [sym_character_literal] = ACTIONS(12022),
    [sym__pair_operator] = ACTIONS(12022),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12022),
    [sym__lazy_and_operator] = ACTIONS(12022),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12022),
    [sym__pipe_left_operator] = ACTIONS(12022),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12022),
    [sym__bitshift_operator] = ACTIONS(12022),
    [sym__power_operator] = ACTIONS(12022),
    [sym__tilde_operator] = ACTIONS(12022),
    [sym__type_order_operator] = ACTIONS(12022),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [5878] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12366),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12366),
    [anon_sym_RPAREN] = ACTIONS(12366),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12366),
    [anon_sym_RBRACK] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_SEMI] = ACTIONS(12366),
    [anon_sym_LBRACE] = ACTIONS(12366),
    [anon_sym_RBRACE] = ACTIONS(12366),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12366),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12366),
    [anon_sym_QMARK] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(12366),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12366),
    [aux_sym_integer_literal_token2] = ACTIONS(12366),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12366),
    [aux_sym_float_literal_token3] = ACTIONS(12366),
    [aux_sym_float_literal_token4] = ACTIONS(12366),
    [sym_character_literal] = ACTIONS(12366),
    [sym__assignment_operator] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12366),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12366),
    [sym__lazy_and_operator] = ACTIONS(12366),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12366),
    [sym__pipe_left_operator] = ACTIONS(12366),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12366),
    [sym__type_order_operator] = ACTIONS(12366),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5879] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [5880] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_catch] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_DASH_GT] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [5881] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5882] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_catch] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_DASH_GT] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5883] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12336),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12336),
    [anon_sym_RPAREN] = ACTIONS(12336),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12336),
    [anon_sym_RBRACK] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_SEMI] = ACTIONS(12336),
    [anon_sym_LBRACE] = ACTIONS(12336),
    [anon_sym_RBRACE] = ACTIONS(12336),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12336),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12336),
    [anon_sym_QMARK] = ACTIONS(12336),
    [anon_sym_AT] = ACTIONS(12336),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12336),
    [aux_sym_integer_literal_token2] = ACTIONS(12336),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12336),
    [aux_sym_float_literal_token3] = ACTIONS(12336),
    [aux_sym_float_literal_token4] = ACTIONS(12336),
    [sym_character_literal] = ACTIONS(12336),
    [sym__assignment_operator] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12336),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12336),
    [sym__lazy_and_operator] = ACTIONS(12336),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12336),
    [sym__pipe_left_operator] = ACTIONS(12336),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12336),
    [sym__type_order_operator] = ACTIONS(12336),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [5884] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_catch] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_DASH_GT] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [5885] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5886] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_finally] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__assignment_operator] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5887] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_catch] = ACTIONS(12136),
    [anon_sym_finally] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_DASH_GT] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5888] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11982),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11982),
    [anon_sym_RPAREN] = ACTIONS(11982),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11982),
    [anon_sym_RBRACK] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_SEMI] = ACTIONS(11982),
    [anon_sym_LBRACE] = ACTIONS(11982),
    [anon_sym_RBRACE] = ACTIONS(11982),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11982),
    [anon_sym_COLON_COLON] = ACTIONS(11982),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11982),
    [anon_sym_QMARK] = ACTIONS(11982),
    [anon_sym_AT] = ACTIONS(11982),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11982),
    [aux_sym_integer_literal_token2] = ACTIONS(11982),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11982),
    [aux_sym_float_literal_token3] = ACTIONS(11982),
    [aux_sym_float_literal_token4] = ACTIONS(11982),
    [sym_character_literal] = ACTIONS(11982),
    [sym__pair_operator] = ACTIONS(11982),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11982),
    [sym__lazy_and_operator] = ACTIONS(11982),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11982),
    [sym__pipe_left_operator] = ACTIONS(11982),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11982),
    [sym__bitshift_operator] = ACTIONS(11982),
    [sym__power_operator] = ACTIONS(11982),
    [sym__tilde_operator] = ACTIONS(11982),
    [sym__type_order_operator] = ACTIONS(11982),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [5889] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11990),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11990),
    [anon_sym_RPAREN] = ACTIONS(11990),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11990),
    [anon_sym_RBRACK] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_SEMI] = ACTIONS(11990),
    [anon_sym_LBRACE] = ACTIONS(11990),
    [anon_sym_RBRACE] = ACTIONS(11990),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11990),
    [anon_sym_COLON_COLON] = ACTIONS(11990),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11990),
    [anon_sym_QMARK] = ACTIONS(11990),
    [anon_sym_AT] = ACTIONS(11990),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11990),
    [aux_sym_integer_literal_token2] = ACTIONS(11990),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11990),
    [aux_sym_float_literal_token3] = ACTIONS(11990),
    [aux_sym_float_literal_token4] = ACTIONS(11990),
    [sym_character_literal] = ACTIONS(11990),
    [sym__pair_operator] = ACTIONS(11990),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11990),
    [sym__lazy_and_operator] = ACTIONS(11990),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11990),
    [sym__pipe_left_operator] = ACTIONS(11990),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11990),
    [sym__bitshift_operator] = ACTIONS(11990),
    [sym__power_operator] = ACTIONS(11990),
    [sym__tilde_operator] = ACTIONS(11990),
    [sym__type_order_operator] = ACTIONS(11990),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [5890] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11998),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11998),
    [anon_sym_RPAREN] = ACTIONS(11998),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11998),
    [anon_sym_RBRACK] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_SEMI] = ACTIONS(11998),
    [anon_sym_LBRACE] = ACTIONS(11998),
    [anon_sym_RBRACE] = ACTIONS(11998),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11998),
    [anon_sym_COLON_COLON] = ACTIONS(11998),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11998),
    [anon_sym_QMARK] = ACTIONS(11998),
    [anon_sym_AT] = ACTIONS(11998),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11998),
    [aux_sym_integer_literal_token2] = ACTIONS(11998),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11998),
    [aux_sym_float_literal_token3] = ACTIONS(11998),
    [aux_sym_float_literal_token4] = ACTIONS(11998),
    [sym_character_literal] = ACTIONS(11998),
    [sym__pair_operator] = ACTIONS(11998),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11998),
    [sym__lazy_and_operator] = ACTIONS(11998),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11998),
    [sym__pipe_left_operator] = ACTIONS(11998),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11998),
    [sym__bitshift_operator] = ACTIONS(11998),
    [sym__power_operator] = ACTIONS(11998),
    [sym__tilde_operator] = ACTIONS(11998),
    [sym__type_order_operator] = ACTIONS(11998),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [5891] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2188),
    [aux_sym_integer_literal_token2] = ACTIONS(2188),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2188),
    [aux_sym_float_literal_token3] = ACTIONS(2188),
    [aux_sym_float_literal_token4] = ACTIONS(2188),
    [sym_character_literal] = ACTIONS(2188),
    [sym__assignment_operator] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2188),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2188),
    [sym__pipe_left_operator] = ACTIONS(2188),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2188),
    [sym__type_order_operator] = ACTIONS(2188),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [5892] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_catch] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__assignment_operator] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5893] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_catch] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__assignment_operator] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5894] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_elseif] = ACTIONS(12308),
    [anon_sym_else] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [5895] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_catch] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__assignment_operator] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5896] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_catch] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__assignment_operator] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5897] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_catch] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_DASH_GT] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [5898] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_catch] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__assignment_operator] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5899] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_catch] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__assignment_operator] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5900] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12026),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12026),
    [anon_sym_RPAREN] = ACTIONS(12026),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12026),
    [anon_sym_RBRACK] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_SEMI] = ACTIONS(12026),
    [anon_sym_LBRACE] = ACTIONS(12026),
    [anon_sym_RBRACE] = ACTIONS(12026),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12026),
    [anon_sym_COLON_COLON] = ACTIONS(12026),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12026),
    [anon_sym_QMARK] = ACTIONS(12026),
    [anon_sym_AT] = ACTIONS(12026),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12026),
    [aux_sym_integer_literal_token2] = ACTIONS(12026),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12026),
    [aux_sym_float_literal_token3] = ACTIONS(12026),
    [aux_sym_float_literal_token4] = ACTIONS(12026),
    [sym_character_literal] = ACTIONS(12026),
    [sym__pair_operator] = ACTIONS(12026),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12026),
    [sym__lazy_and_operator] = ACTIONS(12026),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12026),
    [sym__pipe_left_operator] = ACTIONS(12026),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12026),
    [sym__bitshift_operator] = ACTIONS(12026),
    [sym__power_operator] = ACTIONS(12026),
    [sym__tilde_operator] = ACTIONS(12026),
    [sym__type_order_operator] = ACTIONS(12026),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [5901] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_catch] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__assignment_operator] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5902] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12030),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12030),
    [anon_sym_RPAREN] = ACTIONS(12030),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12030),
    [anon_sym_RBRACK] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_SEMI] = ACTIONS(12030),
    [anon_sym_LBRACE] = ACTIONS(12030),
    [anon_sym_RBRACE] = ACTIONS(12030),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12030),
    [anon_sym_COLON_COLON] = ACTIONS(12030),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12030),
    [anon_sym_QMARK] = ACTIONS(12030),
    [anon_sym_AT] = ACTIONS(12030),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12030),
    [aux_sym_integer_literal_token2] = ACTIONS(12030),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12030),
    [aux_sym_float_literal_token3] = ACTIONS(12030),
    [aux_sym_float_literal_token4] = ACTIONS(12030),
    [sym_character_literal] = ACTIONS(12030),
    [sym__pair_operator] = ACTIONS(12030),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12030),
    [sym__lazy_and_operator] = ACTIONS(12030),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12030),
    [sym__pipe_left_operator] = ACTIONS(12030),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12030),
    [sym__bitshift_operator] = ACTIONS(12030),
    [sym__power_operator] = ACTIONS(12030),
    [sym__tilde_operator] = ACTIONS(12030),
    [sym__type_order_operator] = ACTIONS(12030),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [5903] = {
    [ts_builtin_sym_end] = ACTIONS(12324),
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_RPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [5904] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12034),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12034),
    [anon_sym_RPAREN] = ACTIONS(12034),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12034),
    [anon_sym_RBRACK] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_SEMI] = ACTIONS(12034),
    [anon_sym_LBRACE] = ACTIONS(12034),
    [anon_sym_RBRACE] = ACTIONS(12034),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12034),
    [anon_sym_COLON_COLON] = ACTIONS(12034),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12034),
    [anon_sym_QMARK] = ACTIONS(12034),
    [anon_sym_AT] = ACTIONS(12034),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12034),
    [aux_sym_integer_literal_token2] = ACTIONS(12034),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12034),
    [aux_sym_float_literal_token3] = ACTIONS(12034),
    [aux_sym_float_literal_token4] = ACTIONS(12034),
    [sym_character_literal] = ACTIONS(12034),
    [sym__pair_operator] = ACTIONS(12034),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12034),
    [sym__lazy_and_operator] = ACTIONS(12034),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12034),
    [sym__pipe_left_operator] = ACTIONS(12034),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12034),
    [sym__bitshift_operator] = ACTIONS(12034),
    [sym__power_operator] = ACTIONS(12034),
    [sym__tilde_operator] = ACTIONS(12034),
    [sym__type_order_operator] = ACTIONS(12034),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [5905] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_catch] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__assignment_operator] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5906] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12564),
    [anon_sym_DOT] = ACTIONS(12604),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12606),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12570),
    [sym__immediate_bracket] = ACTIONS(12572),
    [sym__immediate_brace] = ACTIONS(12574),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5907] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5908] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [5909] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [5910] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_catch] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__assignment_operator] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5911] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5912] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_catch] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__assignment_operator] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5913] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12038),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12038),
    [anon_sym_RPAREN] = ACTIONS(12038),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12038),
    [anon_sym_RBRACK] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_SEMI] = ACTIONS(12038),
    [anon_sym_LBRACE] = ACTIONS(12038),
    [anon_sym_RBRACE] = ACTIONS(12038),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12038),
    [anon_sym_COLON_COLON] = ACTIONS(12038),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12038),
    [anon_sym_QMARK] = ACTIONS(12038),
    [anon_sym_AT] = ACTIONS(12038),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12038),
    [aux_sym_integer_literal_token2] = ACTIONS(12038),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12038),
    [aux_sym_float_literal_token3] = ACTIONS(12038),
    [aux_sym_float_literal_token4] = ACTIONS(12038),
    [sym_character_literal] = ACTIONS(12038),
    [sym__pair_operator] = ACTIONS(12038),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12038),
    [sym__lazy_and_operator] = ACTIONS(12038),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12038),
    [sym__pipe_left_operator] = ACTIONS(12038),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12038),
    [sym__bitshift_operator] = ACTIONS(12038),
    [sym__power_operator] = ACTIONS(12038),
    [sym__tilde_operator] = ACTIONS(12038),
    [sym__type_order_operator] = ACTIONS(12038),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [5914] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_catch] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__assignment_operator] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5915] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12042),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12042),
    [anon_sym_RPAREN] = ACTIONS(12042),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12042),
    [anon_sym_RBRACK] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_SEMI] = ACTIONS(12042),
    [anon_sym_LBRACE] = ACTIONS(12042),
    [anon_sym_RBRACE] = ACTIONS(12042),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12042),
    [anon_sym_COLON_COLON] = ACTIONS(12042),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12042),
    [anon_sym_QMARK] = ACTIONS(12042),
    [anon_sym_AT] = ACTIONS(12042),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12042),
    [aux_sym_integer_literal_token2] = ACTIONS(12042),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12042),
    [aux_sym_float_literal_token3] = ACTIONS(12042),
    [aux_sym_float_literal_token4] = ACTIONS(12042),
    [sym_character_literal] = ACTIONS(12042),
    [sym__pair_operator] = ACTIONS(12042),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12042),
    [sym__lazy_and_operator] = ACTIONS(12042),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12042),
    [sym__pipe_left_operator] = ACTIONS(12042),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12042),
    [sym__bitshift_operator] = ACTIONS(12042),
    [sym__power_operator] = ACTIONS(12042),
    [sym__tilde_operator] = ACTIONS(12042),
    [sym__type_order_operator] = ACTIONS(12042),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [5916] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_catch] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__assignment_operator] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5917] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_catch] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__assignment_operator] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [5918] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_catch] = ACTIONS(12326),
    [anon_sym_finally] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_DASH_GT] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5919] = {
    [ts_builtin_sym_end] = ACTIONS(12340),
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_RPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_RBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5920] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_finally] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__assignment_operator] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [5921] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12050),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12050),
    [anon_sym_RPAREN] = ACTIONS(12050),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12050),
    [anon_sym_RBRACK] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_SEMI] = ACTIONS(12050),
    [anon_sym_LBRACE] = ACTIONS(12050),
    [anon_sym_RBRACE] = ACTIONS(12050),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12050),
    [anon_sym_COLON_COLON] = ACTIONS(12050),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12050),
    [anon_sym_QMARK] = ACTIONS(12050),
    [anon_sym_AT] = ACTIONS(12050),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12050),
    [aux_sym_integer_literal_token2] = ACTIONS(12050),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12050),
    [aux_sym_float_literal_token3] = ACTIONS(12050),
    [aux_sym_float_literal_token4] = ACTIONS(12050),
    [sym_character_literal] = ACTIONS(12050),
    [sym__pair_operator] = ACTIONS(12050),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12050),
    [sym__lazy_and_operator] = ACTIONS(12050),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12050),
    [sym__pipe_left_operator] = ACTIONS(12050),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12050),
    [sym__bitshift_operator] = ACTIONS(12050),
    [sym__power_operator] = ACTIONS(12050),
    [sym__tilde_operator] = ACTIONS(12050),
    [sym__type_order_operator] = ACTIONS(12050),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [5922] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_finally] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__assignment_operator] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5923] = {
    [ts_builtin_sym_end] = ACTIONS(12344),
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_RPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_RBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [5924] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5925] = {
    [ts_builtin_sym_end] = ACTIONS(11930),
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_RBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [5926] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_catch] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_DASH_GT] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5927] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5928] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5929] = {
    [ts_builtin_sym_end] = ACTIONS(11934),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_RBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [5930] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5931] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_catch] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__assignment_operator] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [5932] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12138),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12138),
    [anon_sym_RPAREN] = ACTIONS(12138),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12138),
    [anon_sym_RBRACK] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_SEMI] = ACTIONS(12138),
    [anon_sym_LBRACE] = ACTIONS(12138),
    [anon_sym_RBRACE] = ACTIONS(12138),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12138),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_QMARK] = ACTIONS(12138),
    [anon_sym_AT] = ACTIONS(12138),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12138),
    [aux_sym_integer_literal_token2] = ACTIONS(12138),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12138),
    [aux_sym_float_literal_token3] = ACTIONS(12138),
    [aux_sym_float_literal_token4] = ACTIONS(12138),
    [sym_character_literal] = ACTIONS(12138),
    [sym__assignment_operator] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12138),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12138),
    [sym__lazy_and_operator] = ACTIONS(12138),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12138),
    [sym__pipe_left_operator] = ACTIONS(12138),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12138),
    [sym__type_order_operator] = ACTIONS(12138),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5933] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5934] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12608),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5935] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_catch] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__assignment_operator] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5936] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_catch] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__assignment_operator] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5937] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_finally] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__assignment_operator] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5938] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_catch] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__assignment_operator] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5939] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_elseif] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5940] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11914),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11914),
    [anon_sym_RPAREN] = ACTIONS(11914),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11914),
    [anon_sym_RBRACK] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11914),
    [anon_sym_LBRACE] = ACTIONS(11914),
    [anon_sym_RBRACE] = ACTIONS(11914),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11914),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11914),
    [anon_sym_QMARK] = ACTIONS(11914),
    [anon_sym_AT] = ACTIONS(11914),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11914),
    [aux_sym_integer_literal_token2] = ACTIONS(11914),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11914),
    [aux_sym_float_literal_token3] = ACTIONS(11914),
    [aux_sym_float_literal_token4] = ACTIONS(11914),
    [sym_character_literal] = ACTIONS(11914),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11914),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11914),
    [sym__lazy_and_operator] = ACTIONS(11914),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11914),
    [sym__pipe_left_operator] = ACTIONS(11914),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11914),
    [sym__type_order_operator] = ACTIONS(11914),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5941] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5942] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_finally] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__assignment_operator] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [5943] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5944] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12610),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12502),
    [anon_sym_DOT] = ACTIONS(12612),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12614),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12508),
    [sym__immediate_bracket] = ACTIONS(12510),
    [sym__immediate_brace] = ACTIONS(12512),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5945] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_finally] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__assignment_operator] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [5946] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5947] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_catch] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__assignment_operator] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5948] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_catch] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__assignment_operator] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5949] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_catch] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__assignment_operator] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5950] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_catch] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__assignment_operator] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5951] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5952] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_catch] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__assignment_operator] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5953] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__assignment_operator] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [5954] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_catch] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__assignment_operator] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5955] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_catch] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__assignment_operator] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5956] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_catch] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__assignment_operator] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5957] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_catch] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__assignment_operator] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5958] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12172),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12172),
    [anon_sym_RPAREN] = ACTIONS(12172),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12172),
    [anon_sym_RBRACK] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_SEMI] = ACTIONS(12172),
    [anon_sym_LBRACE] = ACTIONS(12172),
    [anon_sym_RBRACE] = ACTIONS(12172),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12172),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12172),
    [anon_sym_QMARK] = ACTIONS(12172),
    [anon_sym_AT] = ACTIONS(12172),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12172),
    [aux_sym_integer_literal_token2] = ACTIONS(12172),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12172),
    [aux_sym_float_literal_token3] = ACTIONS(12172),
    [aux_sym_float_literal_token4] = ACTIONS(12172),
    [sym_character_literal] = ACTIONS(12172),
    [sym__assignment_operator] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12172),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12172),
    [sym__lazy_and_operator] = ACTIONS(12172),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12172),
    [sym__pipe_left_operator] = ACTIONS(12172),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12172),
    [sym__type_order_operator] = ACTIONS(12172),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [5959] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_finally] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__assignment_operator] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [5960] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5961] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12222),
    [anon_sym_DOT] = ACTIONS(12224),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12226),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12228),
    [sym__immediate_bracket] = ACTIONS(12230),
    [sym__immediate_brace] = ACTIONS(12232),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5962] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5963] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_else] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5964] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [5965] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [5966] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [5967] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [5968] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [5969] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [5970] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12222),
    [anon_sym_DOT] = ACTIONS(12224),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12616),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12228),
    [sym__immediate_bracket] = ACTIONS(12230),
    [sym__immediate_brace] = ACTIONS(12232),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5971] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_DASH_GT] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5972] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [5973] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [5974] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_catch] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5975] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [5976] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [5977] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [5978] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [5979] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [5980] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [5981] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [5982] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_RPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_SEMI] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__assignment_operator] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [5983] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [5984] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [5985] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [5986] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_else] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_finally] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12620),
    [sym__immediate_bracket] = ACTIONS(12620),
    [sym__immediate_brace] = ACTIONS(12620),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [5987] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [5988] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [5989] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [5990] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [5991] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_SQUOTE] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12624),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__assignment_operator] = ACTIONS(12626),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__immediate_bracket] = ACTIONS(12630),
    [sym__immediate_brace] = ACTIONS(12632),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [5992] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [5993] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [5994] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [5995] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [5996] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [5997] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [5998] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [5999] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_elseif] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6000] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_DASH_GT] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6001] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_finally] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [6002] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_RPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_SEMI] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__assignment_operator] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [6003] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_DASH_GT] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6004] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_RPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_SEMI] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__assignment_operator] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [6005] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_catch] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6006] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6007] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6008] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6009] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6010] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_finally] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [6011] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_RPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_SEMI] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__assignment_operator] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6012] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_RPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_SEMI] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__assignment_operator] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6013] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_RPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_SEMI] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__assignment_operator] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6014] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6015] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6016] = {
    [sym__word_identifier] = ACTIONS(12410),
    [anon_sym_EQ] = ACTIONS(12410),
    [anon_sym_COMMA] = ACTIONS(12410),
    [anon_sym_COLON] = ACTIONS(12410),
    [anon_sym_begin] = ACTIONS(12410),
    [anon_sym_module] = ACTIONS(12410),
    [anon_sym_baremodule] = ACTIONS(12410),
    [anon_sym_abstract] = ACTIONS(12410),
    [anon_sym_primitive] = ACTIONS(12410),
    [anon_sym_mutable] = ACTIONS(12410),
    [anon_sym_struct] = ACTIONS(12410),
    [anon_sym_function] = ACTIONS(12410),
    [anon_sym_macro] = ACTIONS(12410),
    [anon_sym_where] = ACTIONS(12410),
    [anon_sym_quote] = ACTIONS(12410),
    [anon_sym_let] = ACTIONS(12410),
    [anon_sym_if] = ACTIONS(12410),
    [anon_sym_try] = ACTIONS(12410),
    [anon_sym_catch] = ACTIONS(12410),
    [anon_sym_finally] = ACTIONS(12410),
    [anon_sym_for] = ACTIONS(12410),
    [anon_sym_while] = ACTIONS(12410),
    [sym_break_statement] = ACTIONS(12410),
    [sym_continue_statement] = ACTIONS(12410),
    [anon_sym_return] = ACTIONS(12410),
    [anon_sym_const] = ACTIONS(12410),
    [anon_sym_global] = ACTIONS(12410),
    [anon_sym_local] = ACTIONS(12410),
    [anon_sym_LPAREN] = ACTIONS(12410),
    [anon_sym_COLON2] = ACTIONS(12410),
    [anon_sym_export] = ACTIONS(12410),
    [anon_sym_import] = ACTIONS(12410),
    [anon_sym_using] = ACTIONS(12410),
    [anon_sym_LBRACK] = ACTIONS(12410),
    [anon_sym_LF] = ACTIONS(12476),
    [anon_sym_in] = ACTIONS(12410),
    [anon_sym_LBRACE] = ACTIONS(12410),
    [anon_sym_SQUOTE] = ACTIONS(12634),
    [anon_sym_DOT] = ACTIONS(12636),
    [anon_sym_DOLLAR] = ACTIONS(12410),
    [anon_sym_COLON_COLON] = ACTIONS(12410),
    [anon_sym_isa] = ACTIONS(12410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12410),
    [anon_sym_QMARK] = ACTIONS(12410),
    [anon_sym_AT] = ACTIONS(12410),
    [anon_sym_true] = ACTIONS(12410),
    [anon_sym_false] = ACTIONS(12410),
    [aux_sym_integer_literal_token1] = ACTIONS(12410),
    [aux_sym_integer_literal_token2] = ACTIONS(12410),
    [aux_sym_integer_literal_token3] = ACTIONS(12410),
    [aux_sym_integer_literal_token4] = ACTIONS(12410),
    [aux_sym_float_literal_token1] = ACTIONS(12410),
    [aux_sym_float_literal_token3] = ACTIONS(12410),
    [aux_sym_float_literal_token4] = ACTIONS(12410),
    [sym_character_literal] = ACTIONS(12410),
    [sym__pair_operator] = ACTIONS(12410),
    [sym__arrow_operator] = ACTIONS(12410),
    [sym__lazy_or_operator] = ACTIONS(12410),
    [sym__lazy_and_operator] = ACTIONS(12410),
    [sym__comparison_operator] = ACTIONS(12410),
    [sym__pipe_right_operator] = ACTIONS(12410),
    [sym__pipe_left_operator] = ACTIONS(12410),
    [sym__ellipsis_operator] = ACTIONS(12410),
    [sym__plus_operator] = ACTIONS(12410),
    [sym__times_operator] = ACTIONS(12410),
    [sym__rational_operator] = ACTIONS(12410),
    [sym__bitshift_operator] = ACTIONS(12410),
    [sym__power_operator] = ACTIONS(12410),
    [sym__tilde_operator] = ACTIONS(12410),
    [sym__type_order_operator] = ACTIONS(12410),
    [sym__unary_operator] = ACTIONS(12410),
    [sym__unary_plus_operator] = ACTIONS(12410),
    [aux_sym__terminator_token1] = ACTIONS(12410),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12638),
    [sym__immediate_bracket] = ACTIONS(12640),
    [sym__immediate_brace] = ACTIONS(12642),
    [sym__string_start] = ACTIONS(12476),
    [sym__command_start] = ACTIONS(12476),
  },
  [6017] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_finally] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [6018] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_RPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_SEMI] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__assignment_operator] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6019] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_RPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_SEMI] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__assignment_operator] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6020] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_RPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_SEMI] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__assignment_operator] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6021] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [6022] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_RPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_SEMI] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__assignment_operator] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6023] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6024] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6025] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6026] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_RPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_SEMI] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__assignment_operator] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6027] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_RPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_SEMI] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__assignment_operator] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6028] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_RPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_SEMI] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__assignment_operator] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6029] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6030] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_RPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_SEMI] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__assignment_operator] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6031] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_RPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__assignment_operator] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6032] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6033] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_RPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_SEMI] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__assignment_operator] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6034] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_RPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_SEMI] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__assignment_operator] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6035] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_RPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_SEMI] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__assignment_operator] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6036] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_RPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_SEMI] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__assignment_operator] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6037] = {
    [sym__word_identifier] = ACTIONS(12194),
    [anon_sym_EQ] = ACTIONS(12194),
    [anon_sym_COMMA] = ACTIONS(12194),
    [anon_sym_COLON] = ACTIONS(12194),
    [anon_sym_begin] = ACTIONS(12194),
    [anon_sym_module] = ACTIONS(12194),
    [anon_sym_baremodule] = ACTIONS(12194),
    [anon_sym_end] = ACTIONS(12194),
    [anon_sym_abstract] = ACTIONS(12194),
    [anon_sym_primitive] = ACTIONS(12194),
    [anon_sym_mutable] = ACTIONS(12194),
    [anon_sym_struct] = ACTIONS(12194),
    [anon_sym_function] = ACTIONS(12194),
    [anon_sym_macro] = ACTIONS(12194),
    [anon_sym_where] = ACTIONS(12194),
    [anon_sym_quote] = ACTIONS(12194),
    [anon_sym_let] = ACTIONS(12194),
    [anon_sym_if] = ACTIONS(12194),
    [anon_sym_try] = ACTIONS(12194),
    [anon_sym_for] = ACTIONS(12194),
    [anon_sym_while] = ACTIONS(12194),
    [sym_break_statement] = ACTIONS(12194),
    [sym_continue_statement] = ACTIONS(12194),
    [anon_sym_return] = ACTIONS(12194),
    [anon_sym_const] = ACTIONS(12194),
    [anon_sym_global] = ACTIONS(12194),
    [anon_sym_local] = ACTIONS(12194),
    [anon_sym_LPAREN] = ACTIONS(12194),
    [anon_sym_COLON2] = ACTIONS(12194),
    [anon_sym_export] = ACTIONS(12194),
    [anon_sym_import] = ACTIONS(12194),
    [anon_sym_using] = ACTIONS(12194),
    [anon_sym_LBRACK] = ACTIONS(12194),
    [anon_sym_LF] = ACTIONS(12196),
    [anon_sym_in] = ACTIONS(12194),
    [anon_sym_LBRACE] = ACTIONS(12194),
    [anon_sym_SQUOTE] = ACTIONS(12644),
    [anon_sym_DOT] = ACTIONS(12646),
    [anon_sym_DOLLAR] = ACTIONS(12194),
    [anon_sym_COLON_COLON] = ACTIONS(12194),
    [anon_sym_isa] = ACTIONS(12194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12194),
    [anon_sym_QMARK] = ACTIONS(12194),
    [anon_sym_DASH_GT] = ACTIONS(12194),
    [anon_sym_AT] = ACTIONS(12194),
    [anon_sym_true] = ACTIONS(12194),
    [anon_sym_false] = ACTIONS(12194),
    [aux_sym_integer_literal_token1] = ACTIONS(12194),
    [aux_sym_integer_literal_token2] = ACTIONS(12194),
    [aux_sym_integer_literal_token3] = ACTIONS(12194),
    [aux_sym_integer_literal_token4] = ACTIONS(12194),
    [aux_sym_float_literal_token1] = ACTIONS(12194),
    [aux_sym_float_literal_token3] = ACTIONS(12194),
    [aux_sym_float_literal_token4] = ACTIONS(12194),
    [sym_character_literal] = ACTIONS(12194),
    [sym__pair_operator] = ACTIONS(12194),
    [sym__arrow_operator] = ACTIONS(12194),
    [sym__lazy_or_operator] = ACTIONS(12194),
    [sym__lazy_and_operator] = ACTIONS(12194),
    [sym__comparison_operator] = ACTIONS(12194),
    [sym__pipe_right_operator] = ACTIONS(12194),
    [sym__pipe_left_operator] = ACTIONS(12194),
    [sym__ellipsis_operator] = ACTIONS(12194),
    [sym__plus_operator] = ACTIONS(12194),
    [sym__times_operator] = ACTIONS(12194),
    [sym__rational_operator] = ACTIONS(12194),
    [sym__bitshift_operator] = ACTIONS(12194),
    [sym__power_operator] = ACTIONS(12194),
    [sym__tilde_operator] = ACTIONS(12194),
    [sym__type_order_operator] = ACTIONS(12194),
    [sym__unary_operator] = ACTIONS(12194),
    [sym__unary_plus_operator] = ACTIONS(12194),
    [aux_sym__terminator_token1] = ACTIONS(12194),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12648),
    [sym__immediate_bracket] = ACTIONS(12650),
    [sym__immediate_brace] = ACTIONS(12652),
    [sym__string_start] = ACTIONS(12196),
    [sym__command_start] = ACTIONS(12196),
  },
  [6038] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_catch] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6039] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6040] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_RPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_SEMI] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__assignment_operator] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6041] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_RPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_SEMI] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__assignment_operator] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6042] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [6043] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_RPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_SEMI] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__assignment_operator] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6044] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__assignment_operator] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6045] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_RPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_SEMI] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__assignment_operator] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6046] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_RPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_SEMI] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__assignment_operator] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6047] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_RPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_SEMI] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [6048] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_catch] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6049] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_catch] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6050] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [6051] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_RPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_SEMI] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__assignment_operator] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6052] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_RPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_SEMI] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__assignment_operator] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6053] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6054] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_RPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_SEMI] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__assignment_operator] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6055] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_catch] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6056] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_RPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_SEMI] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__assignment_operator] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6057] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6058] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_catch] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6059] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_DASH_GT] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6060] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_DASH_GT] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6061] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6062] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_DASH_GT] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6063] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__assignment_operator] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6064] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_catch] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6065] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_EQ] = ACTIONS(12020),
    [anon_sym_COMMA] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_COLON2] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_in] = ACTIONS(12020),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_isa] = ACTIONS(12020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12020),
    [anon_sym_QMARK] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__lazy_or_operator] = ACTIONS(12020),
    [sym__lazy_and_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [6066] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__assignment_operator] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [6067] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_RPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_SEMI] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_DASH_GT] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6068] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_finally] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [6069] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_RPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_SEMI] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [6070] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_RPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_SEMI] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [6071] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_catch] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6072] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_RPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_SEMI] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [6073] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_finally] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [6074] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_DASH_GT] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6075] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_EQ] = ACTIONS(11980),
    [anon_sym_COMMA] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_COLON2] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_in] = ACTIONS(11980),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_isa] = ACTIONS(11980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11980),
    [anon_sym_QMARK] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__lazy_or_operator] = ACTIONS(11980),
    [sym__lazy_and_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [6076] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_DASH_GT] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6077] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__assignment_operator] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [6078] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_EQ] = ACTIONS(11988),
    [anon_sym_COMMA] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_COLON2] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_in] = ACTIONS(11988),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_isa] = ACTIONS(11988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11988),
    [anon_sym_QMARK] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__lazy_or_operator] = ACTIONS(11988),
    [sym__lazy_and_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [6079] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_RPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_SEMI] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_DASH_GT] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6080] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [6081] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_EQ] = ACTIONS(11996),
    [anon_sym_COMMA] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_COLON2] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_in] = ACTIONS(11996),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_isa] = ACTIONS(11996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11996),
    [anon_sym_QMARK] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__lazy_or_operator] = ACTIONS(11996),
    [sym__lazy_and_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [6082] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6083] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6084] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_DASH_GT] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6085] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_catch] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6086] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_RPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_SEMI] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [6087] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_DASH_GT] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6088] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_RPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_SEMI] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [6089] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_DASH_GT] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6090] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_DASH_GT] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6091] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_catch] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6092] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_RPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_SEMI] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [6093] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_finally] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [6094] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_EQ] = ACTIONS(12024),
    [anon_sym_COMMA] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_in] = ACTIONS(12024),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_isa] = ACTIONS(12024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12024),
    [anon_sym_QMARK] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__lazy_or_operator] = ACTIONS(12024),
    [sym__lazy_and_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [6095] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__assignment_operator] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6096] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_EQ] = ACTIONS(12028),
    [anon_sym_COMMA] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_COLON2] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_in] = ACTIONS(12028),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_isa] = ACTIONS(12028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12028),
    [anon_sym_QMARK] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__lazy_or_operator] = ACTIONS(12028),
    [sym__lazy_and_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [6097] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(12032),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_COLON2] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_in] = ACTIONS(12032),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_isa] = ACTIONS(12032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12032),
    [anon_sym_QMARK] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__lazy_or_operator] = ACTIONS(12032),
    [sym__lazy_and_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [6098] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__assignment_operator] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6099] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__assignment_operator] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6100] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_RPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_SEMI] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [6101] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_RPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_SEMI] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [6102] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_EQ] = ACTIONS(12036),
    [anon_sym_COMMA] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_COLON2] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_in] = ACTIONS(12036),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_isa] = ACTIONS(12036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12036),
    [anon_sym_QMARK] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__lazy_or_operator] = ACTIONS(12036),
    [sym__lazy_and_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [6103] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_EQ] = ACTIONS(12040),
    [anon_sym_COMMA] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_COLON2] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_in] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_isa] = ACTIONS(12040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12040),
    [anon_sym_QMARK] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__lazy_or_operator] = ACTIONS(12040),
    [sym__lazy_and_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [6104] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [6105] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_RPAREN] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_SEMI] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [6106] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12654),
    [anon_sym_DOT] = ACTIONS(12656),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12658),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12660),
    [sym__immediate_bracket] = ACTIONS(12662),
    [sym__immediate_brace] = ACTIONS(12664),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6107] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [6108] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_catch] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6109] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_catch] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6110] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_catch] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6111] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_elseif] = ACTIONS(12618),
    [anon_sym_else] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12620),
    [sym__immediate_bracket] = ACTIONS(12620),
    [sym__immediate_brace] = ACTIONS(12620),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6112] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_DASH_GT] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6113] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_catch] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6114] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_catch] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6115] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6116] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6117] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_DASH_GT] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6118] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_RPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_SEMI] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_DASH_GT] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6119] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_RPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_SEMI] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_DASH_GT] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6120] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_RPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_SEMI] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_DASH_GT] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6121] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6122] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_catch] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6123] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6124] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_RPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_SEMI] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_DASH_GT] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6125] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_RPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_SEMI] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_DASH_GT] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6126] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_RPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_SEMI] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_DASH_GT] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6127] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_RPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_SEMI] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_DASH_GT] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6128] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6129] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_DASH_GT] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6130] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_DASH_GT] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6131] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_RPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_SEMI] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_DASH_GT] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6132] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_RPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_SEMI] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_DASH_GT] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6133] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_RPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_SEMI] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_DASH_GT] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6134] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6135] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6136] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_RPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_SEMI] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_DASH_GT] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6137] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_RPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_DASH_GT] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6138] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_DASH_GT] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6139] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_RPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_SEMI] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_DASH_GT] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6140] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_RPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_SEMI] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_DASH_GT] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6141] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_RPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_SEMI] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_DASH_GT] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6142] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_RPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_SEMI] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_DASH_GT] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6143] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_RPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_SEMI] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_DASH_GT] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6144] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_RPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_SEMI] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_DASH_GT] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6145] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_RPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_SEMI] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_DASH_GT] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6146] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_DASH_GT] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6147] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_RPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_SEMI] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_DASH_GT] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6148] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_RPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_SEMI] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_DASH_GT] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6149] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_catch] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6150] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6151] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_RPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_SEMI] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_DASH_GT] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6152] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_DASH_GT] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6153] = {
    [sym__word_identifier] = ACTIONS(12558),
    [anon_sym_EQ] = ACTIONS(12558),
    [anon_sym_COMMA] = ACTIONS(12560),
    [anon_sym_COLON] = ACTIONS(12558),
    [anon_sym_begin] = ACTIONS(12558),
    [anon_sym_module] = ACTIONS(12558),
    [anon_sym_baremodule] = ACTIONS(12558),
    [anon_sym_abstract] = ACTIONS(12558),
    [anon_sym_primitive] = ACTIONS(12558),
    [anon_sym_mutable] = ACTIONS(12558),
    [anon_sym_struct] = ACTIONS(12558),
    [anon_sym_function] = ACTIONS(12558),
    [anon_sym_macro] = ACTIONS(12558),
    [anon_sym_where] = ACTIONS(12558),
    [anon_sym_quote] = ACTIONS(12558),
    [anon_sym_let] = ACTIONS(12558),
    [anon_sym_if] = ACTIONS(12558),
    [anon_sym_try] = ACTIONS(12558),
    [anon_sym_for] = ACTIONS(12558),
    [anon_sym_while] = ACTIONS(12558),
    [sym_break_statement] = ACTIONS(12558),
    [sym_continue_statement] = ACTIONS(12558),
    [anon_sym_return] = ACTIONS(12558),
    [anon_sym_const] = ACTIONS(12558),
    [anon_sym_global] = ACTIONS(12558),
    [anon_sym_local] = ACTIONS(12558),
    [anon_sym_LPAREN] = ACTIONS(12560),
    [anon_sym_RPAREN] = ACTIONS(12560),
    [anon_sym_COLON2] = ACTIONS(12558),
    [anon_sym_export] = ACTIONS(12558),
    [anon_sym_import] = ACTIONS(12558),
    [anon_sym_using] = ACTIONS(12558),
    [anon_sym_LBRACK] = ACTIONS(12560),
    [anon_sym_RBRACK] = ACTIONS(12560),
    [anon_sym_in] = ACTIONS(12558),
    [anon_sym_SEMI] = ACTIONS(12560),
    [anon_sym_LBRACE] = ACTIONS(12560),
    [anon_sym_RBRACE] = ACTIONS(12560),
    [anon_sym_SQUOTE] = ACTIONS(12666),
    [anon_sym_DOT] = ACTIONS(12668),
    [anon_sym_DOLLAR] = ACTIONS(12560),
    [anon_sym_COLON_COLON] = ACTIONS(12560),
    [anon_sym_isa] = ACTIONS(12558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12560),
    [anon_sym_QMARK] = ACTIONS(12560),
    [anon_sym_AT] = ACTIONS(12560),
    [anon_sym_true] = ACTIONS(12558),
    [anon_sym_false] = ACTIONS(12558),
    [aux_sym_integer_literal_token1] = ACTIONS(12560),
    [aux_sym_integer_literal_token2] = ACTIONS(12560),
    [aux_sym_integer_literal_token3] = ACTIONS(12558),
    [aux_sym_integer_literal_token4] = ACTIONS(12558),
    [aux_sym_float_literal_token1] = ACTIONS(12560),
    [aux_sym_float_literal_token3] = ACTIONS(12560),
    [aux_sym_float_literal_token4] = ACTIONS(12560),
    [sym_character_literal] = ACTIONS(12560),
    [sym__pair_operator] = ACTIONS(12560),
    [sym__arrow_operator] = ACTIONS(12558),
    [sym__lazy_or_operator] = ACTIONS(12560),
    [sym__lazy_and_operator] = ACTIONS(12560),
    [sym__comparison_operator] = ACTIONS(12558),
    [sym__pipe_right_operator] = ACTIONS(12560),
    [sym__pipe_left_operator] = ACTIONS(12560),
    [sym__ellipsis_operator] = ACTIONS(12558),
    [sym__plus_operator] = ACTIONS(12558),
    [sym__times_operator] = ACTIONS(12558),
    [sym__rational_operator] = ACTIONS(12560),
    [sym__bitshift_operator] = ACTIONS(12560),
    [sym__power_operator] = ACTIONS(12560),
    [sym__tilde_operator] = ACTIONS(12560),
    [sym__type_order_operator] = ACTIONS(12560),
    [sym__unary_operator] = ACTIONS(12558),
    [sym__unary_plus_operator] = ACTIONS(12558),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12670),
    [sym__immediate_bracket] = ACTIONS(12672),
    [sym__immediate_brace] = ACTIONS(12674),
    [sym__string_start] = ACTIONS(12560),
    [sym__command_start] = ACTIONS(12560),
  },
  [6154] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_RPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_SEMI] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_DASH_GT] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6155] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6156] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_DASH_GT] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6157] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_RPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_SEMI] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_DASH_GT] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6158] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6159] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_DASH_GT] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6160] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_RPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_SEMI] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_DASH_GT] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6161] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__assignment_operator] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6162] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_catch] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6163] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_catch] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6164] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6165] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_catch] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6166] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6167] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6168] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_RPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_SEMI] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__assignment_operator] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6169] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_RPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_SEMI] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__assignment_operator] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6170] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_catch] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6171] = {
    [ts_builtin_sym_end] = ACTIONS(11864),
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6172] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_catch] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6173] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_catch] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6174] = {
    [ts_builtin_sym_end] = ACTIONS(12676),
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_RBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12680),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6175] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [6176] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6177] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6178] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6179] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6180] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6181] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_catch] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6182] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_catch] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6183] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_catch] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6184] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_catch] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6185] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_elseif] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12682),
    [sym__immediate_command_start] = ACTIONS(12684),
  },
  [6186] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_catch] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6187] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_RPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_SEMI] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_DASH_GT] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6188] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_RPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_SEMI] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_DASH_GT] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6189] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_catch] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6190] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_finally] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [6191] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_DASH_GT] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [6192] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_catch] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6193] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_finally] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [6194] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_catch] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6195] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_catch] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6196] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [6197] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_catch] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6198] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_catch] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6199] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_catch] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6200] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [6201] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12654),
    [anon_sym_DOT] = ACTIONS(12656),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12658),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12660),
    [sym__immediate_bracket] = ACTIONS(12662),
    [sym__immediate_brace] = ACTIONS(12664),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6202] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_catch] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6203] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_DASH_GT] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6204] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_finally] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [6205] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12686),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6206] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_catch] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6207] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__assignment_operator] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6208] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12362),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12362),
    [anon_sym_RPAREN] = ACTIONS(12362),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12362),
    [anon_sym_RBRACK] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_SEMI] = ACTIONS(12362),
    [anon_sym_LBRACE] = ACTIONS(12362),
    [anon_sym_RBRACE] = ACTIONS(12362),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12362),
    [anon_sym_COLON_COLON] = ACTIONS(12362),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12362),
    [anon_sym_QMARK] = ACTIONS(12362),
    [anon_sym_AT] = ACTIONS(12362),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12362),
    [aux_sym_integer_literal_token2] = ACTIONS(12362),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12362),
    [aux_sym_float_literal_token3] = ACTIONS(12362),
    [aux_sym_float_literal_token4] = ACTIONS(12362),
    [sym_character_literal] = ACTIONS(12362),
    [sym__pair_operator] = ACTIONS(12362),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12362),
    [sym__lazy_and_operator] = ACTIONS(12362),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12362),
    [sym__pipe_left_operator] = ACTIONS(12362),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12362),
    [sym__bitshift_operator] = ACTIONS(12362),
    [sym__power_operator] = ACTIONS(12362),
    [sym__tilde_operator] = ACTIONS(12362),
    [sym__type_order_operator] = ACTIONS(12362),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [6209] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6210] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__assignment_operator] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6211] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_DASH_GT] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6212] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6213] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_catch] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6214] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_RPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_SEMI] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__assignment_operator] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [6215] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_catch] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6216] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_catch] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [6217] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6218] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_catch] = ACTIONS(12338),
    [anon_sym_finally] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [6219] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12328),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12328),
    [anon_sym_RPAREN] = ACTIONS(12328),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12328),
    [anon_sym_RBRACK] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_SEMI] = ACTIONS(12328),
    [anon_sym_LBRACE] = ACTIONS(12328),
    [anon_sym_RBRACE] = ACTIONS(12328),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12328),
    [anon_sym_COLON_COLON] = ACTIONS(12328),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12328),
    [anon_sym_QMARK] = ACTIONS(12328),
    [anon_sym_AT] = ACTIONS(12328),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12328),
    [aux_sym_integer_literal_token2] = ACTIONS(12328),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12328),
    [aux_sym_float_literal_token3] = ACTIONS(12328),
    [aux_sym_float_literal_token4] = ACTIONS(12328),
    [sym_character_literal] = ACTIONS(12328),
    [sym__pair_operator] = ACTIONS(12328),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12328),
    [sym__lazy_and_operator] = ACTIONS(12328),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12328),
    [sym__pipe_left_operator] = ACTIONS(12328),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12328),
    [sym__bitshift_operator] = ACTIONS(12328),
    [sym__power_operator] = ACTIONS(12328),
    [sym__tilde_operator] = ACTIONS(12328),
    [sym__type_order_operator] = ACTIONS(12328),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [6220] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12688),
    [anon_sym_DOT] = ACTIONS(12690),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12692),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12694),
    [sym__immediate_bracket] = ACTIONS(12696),
    [sym__immediate_brace] = ACTIONS(12698),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6221] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_catch] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6222] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_catch] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6223] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11890),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11890),
    [anon_sym_RPAREN] = ACTIONS(11890),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11890),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11890),
    [anon_sym_RBRACE] = ACTIONS(11890),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11890),
    [anon_sym_COLON_COLON] = ACTIONS(11890),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11890),
    [anon_sym_QMARK] = ACTIONS(11890),
    [anon_sym_AT] = ACTIONS(11890),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11890),
    [aux_sym_integer_literal_token2] = ACTIONS(11890),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11890),
    [aux_sym_float_literal_token3] = ACTIONS(11890),
    [aux_sym_float_literal_token4] = ACTIONS(11890),
    [sym_character_literal] = ACTIONS(11890),
    [sym__pair_operator] = ACTIONS(11890),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11890),
    [sym__lazy_and_operator] = ACTIONS(11890),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11890),
    [sym__pipe_left_operator] = ACTIONS(11890),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11890),
    [sym__bitshift_operator] = ACTIONS(11890),
    [sym__power_operator] = ACTIONS(11890),
    [sym__tilde_operator] = ACTIONS(11890),
    [sym__type_order_operator] = ACTIONS(11890),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6224] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_catch] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6225] = {
    [sym_identifier] = STATE(6541),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_RPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_SEMI] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6226] = {
    [sym_identifier] = STATE(6543),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_RPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_SEMI] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6227] = {
    [sym_identifier] = STATE(6553),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_RPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_SEMI] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6228] = {
    [sym_identifier] = STATE(6632),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_RPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_SEMI] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6229] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12096),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12096),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12096),
    [sym__bitshift_operator] = ACTIONS(12096),
    [sym__power_operator] = ACTIONS(12096),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6230] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6231] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12386),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12386),
    [anon_sym_RPAREN] = ACTIONS(12386),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12386),
    [anon_sym_RBRACK] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_SEMI] = ACTIONS(12386),
    [anon_sym_LBRACE] = ACTIONS(12386),
    [anon_sym_RBRACE] = ACTIONS(12386),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12386),
    [anon_sym_COLON_COLON] = ACTIONS(12386),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12386),
    [anon_sym_QMARK] = ACTIONS(12386),
    [anon_sym_AT] = ACTIONS(12386),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12386),
    [aux_sym_integer_literal_token2] = ACTIONS(12386),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12386),
    [aux_sym_float_literal_token3] = ACTIONS(12386),
    [aux_sym_float_literal_token4] = ACTIONS(12386),
    [sym_character_literal] = ACTIONS(12386),
    [sym__pair_operator] = ACTIONS(12386),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12386),
    [sym__lazy_and_operator] = ACTIONS(12386),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12386),
    [sym__pipe_left_operator] = ACTIONS(12386),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12386),
    [sym__power_operator] = ACTIONS(12386),
    [sym__tilde_operator] = ACTIONS(12386),
    [sym__type_order_operator] = ACTIONS(12386),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6232] = {
    [sym__word_identifier] = ACTIONS(12558),
    [anon_sym_EQ] = ACTIONS(12558),
    [anon_sym_COMMA] = ACTIONS(12558),
    [anon_sym_COLON] = ACTIONS(12558),
    [anon_sym_begin] = ACTIONS(12558),
    [anon_sym_module] = ACTIONS(12558),
    [anon_sym_baremodule] = ACTIONS(12558),
    [anon_sym_end] = ACTIONS(12558),
    [anon_sym_abstract] = ACTIONS(12558),
    [anon_sym_primitive] = ACTIONS(12558),
    [anon_sym_mutable] = ACTIONS(12558),
    [anon_sym_struct] = ACTIONS(12558),
    [anon_sym_function] = ACTIONS(12558),
    [anon_sym_macro] = ACTIONS(12558),
    [anon_sym_where] = ACTIONS(12558),
    [anon_sym_quote] = ACTIONS(12558),
    [anon_sym_let] = ACTIONS(12558),
    [anon_sym_if] = ACTIONS(12558),
    [anon_sym_try] = ACTIONS(12558),
    [anon_sym_catch] = ACTIONS(12558),
    [anon_sym_for] = ACTIONS(12558),
    [anon_sym_while] = ACTIONS(12558),
    [sym_break_statement] = ACTIONS(12558),
    [sym_continue_statement] = ACTIONS(12558),
    [anon_sym_return] = ACTIONS(12558),
    [anon_sym_const] = ACTIONS(12558),
    [anon_sym_global] = ACTIONS(12558),
    [anon_sym_local] = ACTIONS(12558),
    [anon_sym_LPAREN] = ACTIONS(12558),
    [anon_sym_COLON2] = ACTIONS(12558),
    [anon_sym_export] = ACTIONS(12558),
    [anon_sym_import] = ACTIONS(12558),
    [anon_sym_using] = ACTIONS(12558),
    [anon_sym_LBRACK] = ACTIONS(12558),
    [anon_sym_LF] = ACTIONS(12560),
    [anon_sym_in] = ACTIONS(12558),
    [anon_sym_LBRACE] = ACTIONS(12558),
    [anon_sym_SQUOTE] = ACTIONS(12700),
    [anon_sym_DOT] = ACTIONS(12702),
    [anon_sym_DOLLAR] = ACTIONS(12558),
    [anon_sym_COLON_COLON] = ACTIONS(12558),
    [anon_sym_isa] = ACTIONS(12558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12558),
    [anon_sym_QMARK] = ACTIONS(12558),
    [anon_sym_AT] = ACTIONS(12558),
    [anon_sym_true] = ACTIONS(12558),
    [anon_sym_false] = ACTIONS(12558),
    [aux_sym_integer_literal_token1] = ACTIONS(12558),
    [aux_sym_integer_literal_token2] = ACTIONS(12558),
    [aux_sym_integer_literal_token3] = ACTIONS(12558),
    [aux_sym_integer_literal_token4] = ACTIONS(12558),
    [aux_sym_float_literal_token1] = ACTIONS(12558),
    [aux_sym_float_literal_token3] = ACTIONS(12558),
    [aux_sym_float_literal_token4] = ACTIONS(12558),
    [sym_character_literal] = ACTIONS(12558),
    [sym__pair_operator] = ACTIONS(12558),
    [sym__arrow_operator] = ACTIONS(12558),
    [sym__lazy_or_operator] = ACTIONS(12558),
    [sym__lazy_and_operator] = ACTIONS(12558),
    [sym__comparison_operator] = ACTIONS(12558),
    [sym__pipe_right_operator] = ACTIONS(12558),
    [sym__pipe_left_operator] = ACTIONS(12558),
    [sym__ellipsis_operator] = ACTIONS(12558),
    [sym__plus_operator] = ACTIONS(12558),
    [sym__times_operator] = ACTIONS(12558),
    [sym__rational_operator] = ACTIONS(12558),
    [sym__bitshift_operator] = ACTIONS(12558),
    [sym__power_operator] = ACTIONS(12558),
    [sym__tilde_operator] = ACTIONS(12558),
    [sym__type_order_operator] = ACTIONS(12558),
    [sym__unary_operator] = ACTIONS(12558),
    [sym__unary_plus_operator] = ACTIONS(12558),
    [aux_sym__terminator_token1] = ACTIONS(12558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12704),
    [sym__immediate_bracket] = ACTIONS(12706),
    [sym__immediate_brace] = ACTIONS(12708),
    [sym__string_start] = ACTIONS(12560),
    [sym__command_start] = ACTIONS(12560),
  },
  [6233] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_catch] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6234] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_DASH_GT] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6235] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_catch] = ACTIONS(12342),
    [anon_sym_finally] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [6236] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12710),
    [sym__immediate_command_start] = ACTIONS(12712),
  },
  [6237] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_finally] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [6238] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12390),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12390),
    [anon_sym_RPAREN] = ACTIONS(12390),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12390),
    [anon_sym_RBRACK] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_SEMI] = ACTIONS(12390),
    [anon_sym_LBRACE] = ACTIONS(12390),
    [anon_sym_RBRACE] = ACTIONS(12390),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12390),
    [anon_sym_COLON_COLON] = ACTIONS(12390),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12390),
    [anon_sym_QMARK] = ACTIONS(12390),
    [anon_sym_AT] = ACTIONS(12390),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12390),
    [aux_sym_integer_literal_token2] = ACTIONS(12390),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12390),
    [aux_sym_float_literal_token3] = ACTIONS(12390),
    [aux_sym_float_literal_token4] = ACTIONS(12390),
    [sym_character_literal] = ACTIONS(12390),
    [sym__pair_operator] = ACTIONS(12390),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12390),
    [sym__lazy_and_operator] = ACTIONS(12390),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12390),
    [sym__pipe_left_operator] = ACTIONS(12390),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12390),
    [sym__bitshift_operator] = ACTIONS(12390),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(12390),
    [sym__type_order_operator] = ACTIONS(12390),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6239] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_catch] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6240] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_finally] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [6241] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__assignment_operator] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6242] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_catch] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6243] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__assignment_operator] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [6244] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_catch] = ACTIONS(12364),
    [anon_sym_finally] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [6245] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_DASH_GT] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6246] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_catch] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6247] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__assignment_operator] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6248] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12324),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12324),
    [anon_sym_RPAREN] = ACTIONS(12324),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12324),
    [anon_sym_RBRACK] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_SEMI] = ACTIONS(12324),
    [anon_sym_LBRACE] = ACTIONS(12324),
    [anon_sym_RBRACE] = ACTIONS(12324),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12324),
    [anon_sym_COLON_COLON] = ACTIONS(12324),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12324),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_AT] = ACTIONS(12324),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12324),
    [aux_sym_integer_literal_token2] = ACTIONS(12324),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12324),
    [aux_sym_float_literal_token3] = ACTIONS(12324),
    [aux_sym_float_literal_token4] = ACTIONS(12324),
    [sym_character_literal] = ACTIONS(12324),
    [sym__pair_operator] = ACTIONS(12324),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12324),
    [sym__lazy_and_operator] = ACTIONS(12324),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12324),
    [sym__pipe_left_operator] = ACTIONS(12324),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12324),
    [sym__bitshift_operator] = ACTIONS(12324),
    [sym__power_operator] = ACTIONS(12324),
    [sym__tilde_operator] = ACTIONS(12324),
    [sym__type_order_operator] = ACTIONS(12324),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6249] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__assignment_operator] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6250] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12340),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12340),
    [anon_sym_RPAREN] = ACTIONS(12340),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12340),
    [anon_sym_RBRACK] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(12340),
    [anon_sym_LBRACE] = ACTIONS(12340),
    [anon_sym_RBRACE] = ACTIONS(12340),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12340),
    [anon_sym_COLON_COLON] = ACTIONS(12340),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12340),
    [anon_sym_QMARK] = ACTIONS(12340),
    [anon_sym_AT] = ACTIONS(12340),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12340),
    [aux_sym_integer_literal_token2] = ACTIONS(12340),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12340),
    [aux_sym_float_literal_token3] = ACTIONS(12340),
    [aux_sym_float_literal_token4] = ACTIONS(12340),
    [sym_character_literal] = ACTIONS(12340),
    [sym__pair_operator] = ACTIONS(12340),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12340),
    [sym__lazy_and_operator] = ACTIONS(12340),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12340),
    [sym__pipe_left_operator] = ACTIONS(12340),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12340),
    [sym__bitshift_operator] = ACTIONS(12340),
    [sym__power_operator] = ACTIONS(12340),
    [sym__tilde_operator] = ACTIONS(12340),
    [sym__type_order_operator] = ACTIONS(12340),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [6251] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12344),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12344),
    [anon_sym_RPAREN] = ACTIONS(12344),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12344),
    [anon_sym_RBRACK] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_SEMI] = ACTIONS(12344),
    [anon_sym_LBRACE] = ACTIONS(12344),
    [anon_sym_RBRACE] = ACTIONS(12344),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12344),
    [anon_sym_COLON_COLON] = ACTIONS(12344),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12344),
    [anon_sym_QMARK] = ACTIONS(12344),
    [anon_sym_AT] = ACTIONS(12344),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12344),
    [aux_sym_integer_literal_token2] = ACTIONS(12344),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12344),
    [aux_sym_float_literal_token3] = ACTIONS(12344),
    [aux_sym_float_literal_token4] = ACTIONS(12344),
    [sym_character_literal] = ACTIONS(12344),
    [sym__pair_operator] = ACTIONS(12344),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12344),
    [sym__lazy_and_operator] = ACTIONS(12344),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12344),
    [sym__pipe_left_operator] = ACTIONS(12344),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12344),
    [sym__bitshift_operator] = ACTIONS(12344),
    [sym__power_operator] = ACTIONS(12344),
    [sym__tilde_operator] = ACTIONS(12344),
    [sym__type_order_operator] = ACTIONS(12344),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [6252] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11930),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11930),
    [anon_sym_RPAREN] = ACTIONS(11930),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11930),
    [anon_sym_RBRACK] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11930),
    [anon_sym_LBRACE] = ACTIONS(11930),
    [anon_sym_RBRACE] = ACTIONS(11930),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11930),
    [anon_sym_COLON_COLON] = ACTIONS(11930),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11930),
    [anon_sym_QMARK] = ACTIONS(11930),
    [anon_sym_AT] = ACTIONS(11930),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11930),
    [aux_sym_integer_literal_token2] = ACTIONS(11930),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11930),
    [aux_sym_float_literal_token3] = ACTIONS(11930),
    [aux_sym_float_literal_token4] = ACTIONS(11930),
    [sym_character_literal] = ACTIONS(11930),
    [sym__pair_operator] = ACTIONS(11930),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11930),
    [sym__lazy_and_operator] = ACTIONS(11930),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11930),
    [sym__pipe_left_operator] = ACTIONS(11930),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11930),
    [sym__bitshift_operator] = ACTIONS(11930),
    [sym__power_operator] = ACTIONS(11930),
    [sym__tilde_operator] = ACTIONS(11930),
    [sym__type_order_operator] = ACTIONS(11930),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [6253] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_catch] = ACTIONS(12136),
    [anon_sym_finally] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [6254] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__assignment_operator] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6255] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_finally] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [6256] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_catch] = ACTIONS(12214),
    [anon_sym_finally] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [6257] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_catch] = ACTIONS(12174),
    [anon_sym_finally] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [6258] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6259] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11934),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11934),
    [anon_sym_RPAREN] = ACTIONS(11934),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11934),
    [anon_sym_RBRACK] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11934),
    [anon_sym_LBRACE] = ACTIONS(11934),
    [anon_sym_RBRACE] = ACTIONS(11934),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11934),
    [anon_sym_COLON_COLON] = ACTIONS(11934),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11934),
    [anon_sym_QMARK] = ACTIONS(11934),
    [anon_sym_AT] = ACTIONS(11934),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11934),
    [aux_sym_integer_literal_token2] = ACTIONS(11934),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11934),
    [aux_sym_float_literal_token3] = ACTIONS(11934),
    [aux_sym_float_literal_token4] = ACTIONS(11934),
    [sym_character_literal] = ACTIONS(11934),
    [sym__pair_operator] = ACTIONS(11934),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11934),
    [sym__lazy_and_operator] = ACTIONS(11934),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11934),
    [sym__pipe_left_operator] = ACTIONS(11934),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11934),
    [sym__bitshift_operator] = ACTIONS(11934),
    [sym__power_operator] = ACTIONS(11934),
    [sym__tilde_operator] = ACTIONS(11934),
    [sym__type_order_operator] = ACTIONS(11934),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [6260] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_catch] = ACTIONS(12218),
    [anon_sym_finally] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [6261] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_catch] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6262] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12714),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12654),
    [anon_sym_DOT] = ACTIONS(12716),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12718),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12660),
    [sym__immediate_bracket] = ACTIONS(12662),
    [sym__immediate_brace] = ACTIONS(12664),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6263] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12366),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12366),
    [anon_sym_RPAREN] = ACTIONS(12366),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12366),
    [anon_sym_RBRACK] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_SEMI] = ACTIONS(12366),
    [anon_sym_LBRACE] = ACTIONS(12366),
    [anon_sym_RBRACE] = ACTIONS(12366),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12366),
    [anon_sym_COLON_COLON] = ACTIONS(12366),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12366),
    [anon_sym_QMARK] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(12366),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12366),
    [aux_sym_integer_literal_token2] = ACTIONS(12366),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12366),
    [aux_sym_float_literal_token3] = ACTIONS(12366),
    [aux_sym_float_literal_token4] = ACTIONS(12366),
    [sym_character_literal] = ACTIONS(12366),
    [sym__pair_operator] = ACTIONS(12366),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12366),
    [sym__lazy_and_operator] = ACTIONS(12366),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12366),
    [sym__pipe_left_operator] = ACTIONS(12366),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12366),
    [sym__bitshift_operator] = ACTIONS(12366),
    [sym__power_operator] = ACTIONS(12366),
    [sym__tilde_operator] = ACTIONS(12366),
    [sym__type_order_operator] = ACTIONS(12366),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [6264] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__assignment_operator] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6265] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_catch] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6266] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12336),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12336),
    [anon_sym_RPAREN] = ACTIONS(12336),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12336),
    [anon_sym_RBRACK] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_SEMI] = ACTIONS(12336),
    [anon_sym_LBRACE] = ACTIONS(12336),
    [anon_sym_RBRACE] = ACTIONS(12336),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12336),
    [anon_sym_COLON_COLON] = ACTIONS(12336),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12336),
    [anon_sym_QMARK] = ACTIONS(12336),
    [anon_sym_AT] = ACTIONS(12336),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12336),
    [aux_sym_integer_literal_token2] = ACTIONS(12336),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12336),
    [aux_sym_float_literal_token3] = ACTIONS(12336),
    [aux_sym_float_literal_token4] = ACTIONS(12336),
    [sym_character_literal] = ACTIONS(12336),
    [sym__pair_operator] = ACTIONS(12336),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12336),
    [sym__lazy_and_operator] = ACTIONS(12336),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12336),
    [sym__pipe_left_operator] = ACTIONS(12336),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12336),
    [sym__bitshift_operator] = ACTIONS(12336),
    [sym__power_operator] = ACTIONS(12336),
    [sym__tilde_operator] = ACTIONS(12336),
    [sym__type_order_operator] = ACTIONS(12336),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6267] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12138),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12138),
    [anon_sym_RPAREN] = ACTIONS(12138),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12138),
    [anon_sym_RBRACK] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_SEMI] = ACTIONS(12138),
    [anon_sym_LBRACE] = ACTIONS(12138),
    [anon_sym_RBRACE] = ACTIONS(12138),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12138),
    [anon_sym_COLON_COLON] = ACTIONS(12138),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12138),
    [anon_sym_QMARK] = ACTIONS(12138),
    [anon_sym_AT] = ACTIONS(12138),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12138),
    [aux_sym_integer_literal_token2] = ACTIONS(12138),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12138),
    [aux_sym_float_literal_token3] = ACTIONS(12138),
    [aux_sym_float_literal_token4] = ACTIONS(12138),
    [sym_character_literal] = ACTIONS(12138),
    [sym__pair_operator] = ACTIONS(12138),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12138),
    [sym__lazy_and_operator] = ACTIONS(12138),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12138),
    [sym__pipe_left_operator] = ACTIONS(12138),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12138),
    [sym__bitshift_operator] = ACTIONS(12138),
    [sym__power_operator] = ACTIONS(12138),
    [sym__tilde_operator] = ACTIONS(12138),
    [sym__type_order_operator] = ACTIONS(12138),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [6268] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11914),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11914),
    [anon_sym_RPAREN] = ACTIONS(11914),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11914),
    [anon_sym_RBRACK] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11914),
    [anon_sym_LBRACE] = ACTIONS(11914),
    [anon_sym_RBRACE] = ACTIONS(11914),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11914),
    [anon_sym_COLON_COLON] = ACTIONS(11914),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11914),
    [anon_sym_QMARK] = ACTIONS(11914),
    [anon_sym_AT] = ACTIONS(11914),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11914),
    [aux_sym_integer_literal_token2] = ACTIONS(11914),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11914),
    [aux_sym_float_literal_token3] = ACTIONS(11914),
    [aux_sym_float_literal_token4] = ACTIONS(11914),
    [sym_character_literal] = ACTIONS(11914),
    [sym__pair_operator] = ACTIONS(11914),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11914),
    [sym__lazy_and_operator] = ACTIONS(11914),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11914),
    [sym__pipe_left_operator] = ACTIONS(11914),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11914),
    [sym__bitshift_operator] = ACTIONS(11914),
    [sym__power_operator] = ACTIONS(11914),
    [sym__tilde_operator] = ACTIONS(11914),
    [sym__type_order_operator] = ACTIONS(11914),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [6269] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12212),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12212),
    [anon_sym_RPAREN] = ACTIONS(12212),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12212),
    [anon_sym_RBRACK] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_SEMI] = ACTIONS(12212),
    [anon_sym_LBRACE] = ACTIONS(12212),
    [anon_sym_RBRACE] = ACTIONS(12212),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12212),
    [anon_sym_COLON_COLON] = ACTIONS(12212),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12212),
    [anon_sym_QMARK] = ACTIONS(12212),
    [anon_sym_AT] = ACTIONS(12212),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12212),
    [aux_sym_integer_literal_token2] = ACTIONS(12212),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12212),
    [aux_sym_float_literal_token3] = ACTIONS(12212),
    [aux_sym_float_literal_token4] = ACTIONS(12212),
    [sym_character_literal] = ACTIONS(12212),
    [sym__pair_operator] = ACTIONS(12212),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12212),
    [sym__lazy_and_operator] = ACTIONS(12212),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12212),
    [sym__pipe_left_operator] = ACTIONS(12212),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12212),
    [sym__bitshift_operator] = ACTIONS(12212),
    [sym__power_operator] = ACTIONS(12212),
    [sym__tilde_operator] = ACTIONS(12212),
    [sym__type_order_operator] = ACTIONS(12212),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [6270] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12172),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12172),
    [anon_sym_RPAREN] = ACTIONS(12172),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12172),
    [anon_sym_RBRACK] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_SEMI] = ACTIONS(12172),
    [anon_sym_LBRACE] = ACTIONS(12172),
    [anon_sym_RBRACE] = ACTIONS(12172),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12172),
    [anon_sym_COLON_COLON] = ACTIONS(12172),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12172),
    [anon_sym_QMARK] = ACTIONS(12172),
    [anon_sym_AT] = ACTIONS(12172),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12172),
    [aux_sym_integer_literal_token2] = ACTIONS(12172),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12172),
    [aux_sym_float_literal_token3] = ACTIONS(12172),
    [aux_sym_float_literal_token4] = ACTIONS(12172),
    [sym_character_literal] = ACTIONS(12172),
    [sym__pair_operator] = ACTIONS(12172),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12172),
    [sym__lazy_and_operator] = ACTIONS(12172),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12172),
    [sym__pipe_left_operator] = ACTIONS(12172),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12172),
    [sym__bitshift_operator] = ACTIONS(12172),
    [sym__power_operator] = ACTIONS(12172),
    [sym__tilde_operator] = ACTIONS(12172),
    [sym__type_order_operator] = ACTIONS(12172),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [6271] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12216),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12216),
    [anon_sym_RPAREN] = ACTIONS(12216),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12216),
    [anon_sym_RBRACK] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_SEMI] = ACTIONS(12216),
    [anon_sym_LBRACE] = ACTIONS(12216),
    [anon_sym_RBRACE] = ACTIONS(12216),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12216),
    [anon_sym_COLON_COLON] = ACTIONS(12216),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12216),
    [anon_sym_QMARK] = ACTIONS(12216),
    [anon_sym_AT] = ACTIONS(12216),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12216),
    [aux_sym_integer_literal_token2] = ACTIONS(12216),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12216),
    [aux_sym_float_literal_token3] = ACTIONS(12216),
    [aux_sym_float_literal_token4] = ACTIONS(12216),
    [sym_character_literal] = ACTIONS(12216),
    [sym__pair_operator] = ACTIONS(12216),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12216),
    [sym__lazy_and_operator] = ACTIONS(12216),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12216),
    [sym__pipe_left_operator] = ACTIONS(12216),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12216),
    [sym__bitshift_operator] = ACTIONS(12216),
    [sym__power_operator] = ACTIONS(12216),
    [sym__tilde_operator] = ACTIONS(12216),
    [sym__type_order_operator] = ACTIONS(12216),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [6272] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__assignment_operator] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [6273] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_RPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_SEMI] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__assignment_operator] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6274] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__assignment_operator] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [6275] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__assignment_operator] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6276] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6277] = {
    [sym__word_identifier] = ACTIONS(12194),
    [anon_sym_EQ] = ACTIONS(12410),
    [anon_sym_COMMA] = ACTIONS(12410),
    [anon_sym_COLON] = ACTIONS(12194),
    [anon_sym_begin] = ACTIONS(12194),
    [anon_sym_module] = ACTIONS(12194),
    [anon_sym_baremodule] = ACTIONS(12194),
    [anon_sym_end] = ACTIONS(12194),
    [anon_sym_abstract] = ACTIONS(12194),
    [anon_sym_primitive] = ACTIONS(12194),
    [anon_sym_mutable] = ACTIONS(12194),
    [anon_sym_struct] = ACTIONS(12194),
    [anon_sym_function] = ACTIONS(12194),
    [anon_sym_macro] = ACTIONS(12194),
    [anon_sym_where] = ACTIONS(12194),
    [anon_sym_quote] = ACTIONS(12194),
    [anon_sym_let] = ACTIONS(12194),
    [anon_sym_if] = ACTIONS(12194),
    [anon_sym_try] = ACTIONS(12194),
    [anon_sym_for] = ACTIONS(12194),
    [anon_sym_while] = ACTIONS(12194),
    [sym_break_statement] = ACTIONS(12194),
    [sym_continue_statement] = ACTIONS(12194),
    [anon_sym_return] = ACTIONS(12194),
    [anon_sym_const] = ACTIONS(12194),
    [anon_sym_global] = ACTIONS(12194),
    [anon_sym_local] = ACTIONS(12194),
    [anon_sym_LPAREN] = ACTIONS(12194),
    [anon_sym_COLON2] = ACTIONS(12194),
    [anon_sym_export] = ACTIONS(12194),
    [anon_sym_import] = ACTIONS(12194),
    [anon_sym_using] = ACTIONS(12194),
    [anon_sym_LBRACK] = ACTIONS(12194),
    [anon_sym_LF] = ACTIONS(12196),
    [anon_sym_in] = ACTIONS(12194),
    [anon_sym_LBRACE] = ACTIONS(12194),
    [anon_sym_SQUOTE] = ACTIONS(12644),
    [anon_sym_DOT] = ACTIONS(12646),
    [anon_sym_DOLLAR] = ACTIONS(12194),
    [anon_sym_COLON_COLON] = ACTIONS(12194),
    [anon_sym_isa] = ACTIONS(12194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12194),
    [anon_sym_QMARK] = ACTIONS(12194),
    [anon_sym_DASH_GT] = ACTIONS(12194),
    [anon_sym_AT] = ACTIONS(12194),
    [anon_sym_true] = ACTIONS(12194),
    [anon_sym_false] = ACTIONS(12194),
    [aux_sym_integer_literal_token1] = ACTIONS(12194),
    [aux_sym_integer_literal_token2] = ACTIONS(12194),
    [aux_sym_integer_literal_token3] = ACTIONS(12194),
    [aux_sym_integer_literal_token4] = ACTIONS(12194),
    [aux_sym_float_literal_token1] = ACTIONS(12194),
    [aux_sym_float_literal_token3] = ACTIONS(12194),
    [aux_sym_float_literal_token4] = ACTIONS(12194),
    [sym_character_literal] = ACTIONS(12194),
    [sym__pair_operator] = ACTIONS(12194),
    [sym__arrow_operator] = ACTIONS(12194),
    [sym__lazy_or_operator] = ACTIONS(12194),
    [sym__lazy_and_operator] = ACTIONS(12194),
    [sym__comparison_operator] = ACTIONS(12194),
    [sym__pipe_right_operator] = ACTIONS(12194),
    [sym__pipe_left_operator] = ACTIONS(12194),
    [sym__ellipsis_operator] = ACTIONS(12194),
    [sym__plus_operator] = ACTIONS(12194),
    [sym__times_operator] = ACTIONS(12194),
    [sym__rational_operator] = ACTIONS(12194),
    [sym__bitshift_operator] = ACTIONS(12194),
    [sym__power_operator] = ACTIONS(12194),
    [sym__tilde_operator] = ACTIONS(12194),
    [sym__type_order_operator] = ACTIONS(12194),
    [sym__unary_operator] = ACTIONS(12194),
    [sym__unary_plus_operator] = ACTIONS(12194),
    [aux_sym__terminator_token1] = ACTIONS(12194),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12648),
    [sym__immediate_bracket] = ACTIONS(12650),
    [sym__immediate_brace] = ACTIONS(12652),
    [sym__string_start] = ACTIONS(12196),
    [sym__command_start] = ACTIONS(12196),
  },
  [6278] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_catch] = ACTIONS(12326),
    [anon_sym_finally] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [6279] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__assignment_operator] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6280] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__assignment_operator] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6281] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6282] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_DASH_GT] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6283] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__assignment_operator] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6284] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12056),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12056),
    [anon_sym_RPAREN] = ACTIONS(12056),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12056),
    [anon_sym_RBRACK] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12056),
    [anon_sym_LBRACE] = ACTIONS(12056),
    [anon_sym_RBRACE] = ACTIONS(12056),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12056),
    [anon_sym_COLON_COLON] = ACTIONS(12056),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12056),
    [anon_sym_QMARK] = ACTIONS(12056),
    [anon_sym_AT] = ACTIONS(12056),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12056),
    [aux_sym_integer_literal_token2] = ACTIONS(12056),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12056),
    [aux_sym_float_literal_token3] = ACTIONS(12056),
    [aux_sym_float_literal_token4] = ACTIONS(12056),
    [sym_character_literal] = ACTIONS(12056),
    [sym__pair_operator] = ACTIONS(12056),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12056),
    [sym__lazy_and_operator] = ACTIONS(12056),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12056),
    [sym__pipe_left_operator] = ACTIONS(12056),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12056),
    [sym__bitshift_operator] = ACTIONS(12056),
    [sym__power_operator] = ACTIONS(12056),
    [sym__tilde_operator] = ACTIONS(12056),
    [sym__type_order_operator] = ACTIONS(12056),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6285] = {
    [sym_identifier] = STATE(6496),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6286] = {
    [sym_identifier] = STATE(6500),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6287] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__assignment_operator] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6288] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__assignment_operator] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6289] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12060),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12060),
    [anon_sym_RPAREN] = ACTIONS(12060),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12060),
    [anon_sym_RBRACK] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12060),
    [anon_sym_LBRACE] = ACTIONS(12060),
    [anon_sym_RBRACE] = ACTIONS(12060),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12060),
    [anon_sym_COLON_COLON] = ACTIONS(12060),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12060),
    [anon_sym_QMARK] = ACTIONS(12060),
    [anon_sym_AT] = ACTIONS(12060),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12060),
    [aux_sym_integer_literal_token2] = ACTIONS(12060),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12060),
    [aux_sym_float_literal_token3] = ACTIONS(12060),
    [aux_sym_float_literal_token4] = ACTIONS(12060),
    [sym_character_literal] = ACTIONS(12060),
    [sym__pair_operator] = ACTIONS(12060),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12060),
    [sym__lazy_and_operator] = ACTIONS(12060),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12060),
    [sym__pipe_left_operator] = ACTIONS(12060),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12060),
    [sym__bitshift_operator] = ACTIONS(12060),
    [sym__power_operator] = ACTIONS(12060),
    [sym__tilde_operator] = ACTIONS(12060),
    [sym__type_order_operator] = ACTIONS(12060),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6290] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12044),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12044),
    [anon_sym_RPAREN] = ACTIONS(12044),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12044),
    [anon_sym_RBRACK] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12044),
    [anon_sym_LBRACE] = ACTIONS(12044),
    [anon_sym_RBRACE] = ACTIONS(12044),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12044),
    [anon_sym_COLON_COLON] = ACTIONS(12044),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12044),
    [anon_sym_QMARK] = ACTIONS(12044),
    [anon_sym_AT] = ACTIONS(12044),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12044),
    [aux_sym_integer_literal_token2] = ACTIONS(12044),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12044),
    [aux_sym_float_literal_token3] = ACTIONS(12044),
    [aux_sym_float_literal_token4] = ACTIONS(12044),
    [sym_character_literal] = ACTIONS(12044),
    [sym__pair_operator] = ACTIONS(12044),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12044),
    [sym__lazy_and_operator] = ACTIONS(12044),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12044),
    [sym__pipe_left_operator] = ACTIONS(12044),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12044),
    [sym__bitshift_operator] = ACTIONS(12044),
    [sym__power_operator] = ACTIONS(12044),
    [sym__tilde_operator] = ACTIONS(12044),
    [sym__type_order_operator] = ACTIONS(12044),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6291] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_DASH_GT] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [6292] = {
    [sym_identifier] = STATE(6516),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6293] = {
    [sym_identifier] = STATE(6519),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6294] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__assignment_operator] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6295] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_DASH_GT] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [6296] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__assignment_operator] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6297] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_RPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_SEMI] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__assignment_operator] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6298] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12234),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12234),
    [anon_sym_RPAREN] = ACTIONS(12234),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12234),
    [anon_sym_RBRACK] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_SEMI] = ACTIONS(12234),
    [anon_sym_LBRACE] = ACTIONS(12234),
    [anon_sym_RBRACE] = ACTIONS(12234),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12234),
    [anon_sym_COLON_COLON] = ACTIONS(12234),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12234),
    [anon_sym_QMARK] = ACTIONS(12234),
    [anon_sym_AT] = ACTIONS(12234),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12234),
    [aux_sym_integer_literal_token2] = ACTIONS(12234),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12234),
    [aux_sym_float_literal_token3] = ACTIONS(12234),
    [aux_sym_float_literal_token4] = ACTIONS(12234),
    [sym_character_literal] = ACTIONS(12234),
    [sym__pair_operator] = ACTIONS(12234),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12234),
    [sym__lazy_and_operator] = ACTIONS(12234),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12234),
    [sym__pipe_left_operator] = ACTIONS(12234),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12234),
    [sym__bitshift_operator] = ACTIONS(12234),
    [sym__power_operator] = ACTIONS(12234),
    [sym__tilde_operator] = ACTIONS(12234),
    [sym__type_order_operator] = ACTIONS(12234),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6299] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12238),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12238),
    [anon_sym_RPAREN] = ACTIONS(12238),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12238),
    [anon_sym_RBRACK] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_SEMI] = ACTIONS(12238),
    [anon_sym_LBRACE] = ACTIONS(12238),
    [anon_sym_RBRACE] = ACTIONS(12238),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12238),
    [anon_sym_COLON_COLON] = ACTIONS(12238),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12238),
    [anon_sym_QMARK] = ACTIONS(12238),
    [anon_sym_AT] = ACTIONS(12238),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12238),
    [aux_sym_integer_literal_token2] = ACTIONS(12238),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12238),
    [aux_sym_float_literal_token3] = ACTIONS(12238),
    [aux_sym_float_literal_token4] = ACTIONS(12238),
    [sym_character_literal] = ACTIONS(12238),
    [sym__pair_operator] = ACTIONS(12238),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12238),
    [sym__lazy_and_operator] = ACTIONS(12238),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12238),
    [sym__pipe_left_operator] = ACTIONS(12238),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12238),
    [sym__bitshift_operator] = ACTIONS(12238),
    [sym__power_operator] = ACTIONS(12238),
    [sym__tilde_operator] = ACTIONS(12238),
    [sym__type_order_operator] = ACTIONS(12238),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6300] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_DASH_GT] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6301] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12242),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12242),
    [anon_sym_RPAREN] = ACTIONS(12242),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12242),
    [anon_sym_RBRACK] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_SEMI] = ACTIONS(12242),
    [anon_sym_LBRACE] = ACTIONS(12242),
    [anon_sym_RBRACE] = ACTIONS(12242),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12242),
    [anon_sym_COLON_COLON] = ACTIONS(12242),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12242),
    [anon_sym_QMARK] = ACTIONS(12242),
    [anon_sym_AT] = ACTIONS(12242),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12242),
    [aux_sym_integer_literal_token2] = ACTIONS(12242),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12242),
    [aux_sym_float_literal_token3] = ACTIONS(12242),
    [aux_sym_float_literal_token4] = ACTIONS(12242),
    [sym_character_literal] = ACTIONS(12242),
    [sym__pair_operator] = ACTIONS(12242),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12242),
    [sym__lazy_and_operator] = ACTIONS(12242),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12242),
    [sym__pipe_left_operator] = ACTIONS(12242),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12242),
    [sym__bitshift_operator] = ACTIONS(12242),
    [sym__power_operator] = ACTIONS(12242),
    [sym__tilde_operator] = ACTIONS(12242),
    [sym__type_order_operator] = ACTIONS(12242),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6302] = {
    [ts_builtin_sym_end] = ACTIONS(11894),
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_RBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12720),
    [sym__immediate_command_start] = ACTIONS(12722),
  },
  [6303] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12306),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12306),
    [anon_sym_RPAREN] = ACTIONS(12306),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12306),
    [anon_sym_RBRACK] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_SEMI] = ACTIONS(12306),
    [anon_sym_LBRACE] = ACTIONS(12306),
    [anon_sym_RBRACE] = ACTIONS(12306),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12306),
    [anon_sym_COLON_COLON] = ACTIONS(12306),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12306),
    [anon_sym_QMARK] = ACTIONS(12306),
    [anon_sym_AT] = ACTIONS(12306),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12306),
    [aux_sym_integer_literal_token2] = ACTIONS(12306),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12306),
    [aux_sym_float_literal_token3] = ACTIONS(12306),
    [aux_sym_float_literal_token4] = ACTIONS(12306),
    [sym_character_literal] = ACTIONS(12306),
    [sym__pair_operator] = ACTIONS(12306),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12306),
    [sym__lazy_and_operator] = ACTIONS(12306),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12306),
    [sym__pipe_left_operator] = ACTIONS(12306),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12306),
    [sym__bitshift_operator] = ACTIONS(12306),
    [sym__power_operator] = ACTIONS(12306),
    [sym__tilde_operator] = ACTIONS(12306),
    [sym__type_order_operator] = ACTIONS(12306),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [6304] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12246),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12246),
    [anon_sym_RPAREN] = ACTIONS(12246),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12246),
    [anon_sym_RBRACK] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_SEMI] = ACTIONS(12246),
    [anon_sym_LBRACE] = ACTIONS(12246),
    [anon_sym_RBRACE] = ACTIONS(12246),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12246),
    [anon_sym_COLON_COLON] = ACTIONS(12246),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12246),
    [anon_sym_QMARK] = ACTIONS(12246),
    [anon_sym_AT] = ACTIONS(12246),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12246),
    [aux_sym_integer_literal_token2] = ACTIONS(12246),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12246),
    [aux_sym_float_literal_token3] = ACTIONS(12246),
    [aux_sym_float_literal_token4] = ACTIONS(12246),
    [sym_character_literal] = ACTIONS(12246),
    [sym__pair_operator] = ACTIONS(12246),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12246),
    [sym__lazy_and_operator] = ACTIONS(12246),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12246),
    [sym__pipe_left_operator] = ACTIONS(12246),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12246),
    [sym__bitshift_operator] = ACTIONS(12246),
    [sym__power_operator] = ACTIONS(12246),
    [sym__tilde_operator] = ACTIONS(12246),
    [sym__type_order_operator] = ACTIONS(12246),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6305] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12250),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12250),
    [anon_sym_RPAREN] = ACTIONS(12250),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12250),
    [anon_sym_RBRACK] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_SEMI] = ACTIONS(12250),
    [anon_sym_LBRACE] = ACTIONS(12250),
    [anon_sym_RBRACE] = ACTIONS(12250),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12250),
    [anon_sym_COLON_COLON] = ACTIONS(12250),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12250),
    [anon_sym_QMARK] = ACTIONS(12250),
    [anon_sym_AT] = ACTIONS(12250),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12250),
    [aux_sym_integer_literal_token2] = ACTIONS(12250),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12250),
    [aux_sym_float_literal_token3] = ACTIONS(12250),
    [aux_sym_float_literal_token4] = ACTIONS(12250),
    [sym_character_literal] = ACTIONS(12250),
    [sym__pair_operator] = ACTIONS(12250),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12250),
    [sym__lazy_and_operator] = ACTIONS(12250),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12250),
    [sym__pipe_left_operator] = ACTIONS(12250),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12250),
    [sym__bitshift_operator] = ACTIONS(12250),
    [sym__power_operator] = ACTIONS(12250),
    [sym__tilde_operator] = ACTIONS(12250),
    [sym__type_order_operator] = ACTIONS(12250),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6306] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_DASH_GT] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6307] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12254),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12254),
    [anon_sym_RPAREN] = ACTIONS(12254),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12254),
    [anon_sym_RBRACK] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_SEMI] = ACTIONS(12254),
    [anon_sym_LBRACE] = ACTIONS(12254),
    [anon_sym_RBRACE] = ACTIONS(12254),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12254),
    [anon_sym_COLON_COLON] = ACTIONS(12254),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12254),
    [anon_sym_QMARK] = ACTIONS(12254),
    [anon_sym_AT] = ACTIONS(12254),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12254),
    [aux_sym_integer_literal_token2] = ACTIONS(12254),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12254),
    [aux_sym_float_literal_token3] = ACTIONS(12254),
    [aux_sym_float_literal_token4] = ACTIONS(12254),
    [sym_character_literal] = ACTIONS(12254),
    [sym__pair_operator] = ACTIONS(12254),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12254),
    [sym__lazy_and_operator] = ACTIONS(12254),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12254),
    [sym__pipe_left_operator] = ACTIONS(12254),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12254),
    [sym__bitshift_operator] = ACTIONS(12254),
    [sym__power_operator] = ACTIONS(12254),
    [sym__tilde_operator] = ACTIONS(12254),
    [sym__type_order_operator] = ACTIONS(12254),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6308] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12258),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12258),
    [anon_sym_RPAREN] = ACTIONS(12258),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12258),
    [anon_sym_RBRACK] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_SEMI] = ACTIONS(12258),
    [anon_sym_LBRACE] = ACTIONS(12258),
    [anon_sym_RBRACE] = ACTIONS(12258),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12258),
    [anon_sym_COLON_COLON] = ACTIONS(12258),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12258),
    [anon_sym_QMARK] = ACTIONS(12258),
    [anon_sym_AT] = ACTIONS(12258),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12258),
    [aux_sym_integer_literal_token2] = ACTIONS(12258),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12258),
    [aux_sym_float_literal_token3] = ACTIONS(12258),
    [aux_sym_float_literal_token4] = ACTIONS(12258),
    [sym_character_literal] = ACTIONS(12258),
    [sym__pair_operator] = ACTIONS(12258),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12258),
    [sym__lazy_and_operator] = ACTIONS(12258),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12258),
    [sym__pipe_left_operator] = ACTIONS(12258),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12258),
    [sym__bitshift_operator] = ACTIONS(12258),
    [sym__power_operator] = ACTIONS(12258),
    [sym__tilde_operator] = ACTIONS(12258),
    [sym__type_order_operator] = ACTIONS(12258),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6309] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_DASH_GT] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [6310] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_DASH_GT] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [6311] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [6312] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [6313] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__assignment_operator] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6314] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12064),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12064),
    [anon_sym_RPAREN] = ACTIONS(12064),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12064),
    [anon_sym_RBRACK] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12064),
    [anon_sym_LBRACE] = ACTIONS(12064),
    [anon_sym_RBRACE] = ACTIONS(12064),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12064),
    [anon_sym_COLON_COLON] = ACTIONS(12064),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12064),
    [anon_sym_QMARK] = ACTIONS(12064),
    [anon_sym_AT] = ACTIONS(12064),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12064),
    [aux_sym_integer_literal_token2] = ACTIONS(12064),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12064),
    [aux_sym_float_literal_token3] = ACTIONS(12064),
    [aux_sym_float_literal_token4] = ACTIONS(12064),
    [sym_character_literal] = ACTIONS(12064),
    [sym__pair_operator] = ACTIONS(12064),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12064),
    [sym__lazy_and_operator] = ACTIONS(12064),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12064),
    [sym__pipe_left_operator] = ACTIONS(12064),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12064),
    [sym__bitshift_operator] = ACTIONS(12064),
    [sym__power_operator] = ACTIONS(12064),
    [sym__tilde_operator] = ACTIONS(12064),
    [sym__type_order_operator] = ACTIONS(12064),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6315] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_RPAREN] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_RBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_RBRACE] = ACTIONS(12052),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12052),
    [sym__bitshift_operator] = ACTIONS(12052),
    [sym__power_operator] = ACTIONS(12052),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6316] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12262),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12262),
    [anon_sym_RPAREN] = ACTIONS(12262),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12262),
    [anon_sym_RBRACK] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_SEMI] = ACTIONS(12262),
    [anon_sym_LBRACE] = ACTIONS(12262),
    [anon_sym_RBRACE] = ACTIONS(12262),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12262),
    [anon_sym_COLON_COLON] = ACTIONS(12262),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12262),
    [anon_sym_QMARK] = ACTIONS(12262),
    [anon_sym_AT] = ACTIONS(12262),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12262),
    [aux_sym_integer_literal_token2] = ACTIONS(12262),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12262),
    [aux_sym_float_literal_token3] = ACTIONS(12262),
    [aux_sym_float_literal_token4] = ACTIONS(12262),
    [sym_character_literal] = ACTIONS(12262),
    [sym__pair_operator] = ACTIONS(12262),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12262),
    [sym__lazy_and_operator] = ACTIONS(12262),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12262),
    [sym__pipe_left_operator] = ACTIONS(12262),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12262),
    [sym__bitshift_operator] = ACTIONS(12262),
    [sym__power_operator] = ACTIONS(12262),
    [sym__tilde_operator] = ACTIONS(12262),
    [sym__type_order_operator] = ACTIONS(12262),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6317] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12266),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12266),
    [anon_sym_RPAREN] = ACTIONS(12266),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12266),
    [anon_sym_RBRACK] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_SEMI] = ACTIONS(12266),
    [anon_sym_LBRACE] = ACTIONS(12266),
    [anon_sym_RBRACE] = ACTIONS(12266),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12266),
    [anon_sym_COLON_COLON] = ACTIONS(12266),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12266),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_AT] = ACTIONS(12266),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12266),
    [aux_sym_integer_literal_token2] = ACTIONS(12266),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12266),
    [aux_sym_float_literal_token3] = ACTIONS(12266),
    [aux_sym_float_literal_token4] = ACTIONS(12266),
    [sym_character_literal] = ACTIONS(12266),
    [sym__pair_operator] = ACTIONS(12266),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12266),
    [sym__lazy_and_operator] = ACTIONS(12266),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12266),
    [sym__pipe_left_operator] = ACTIONS(12266),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12266),
    [sym__bitshift_operator] = ACTIONS(12266),
    [sym__power_operator] = ACTIONS(12266),
    [sym__tilde_operator] = ACTIONS(12266),
    [sym__type_order_operator] = ACTIONS(12266),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6318] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12270),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12270),
    [anon_sym_RPAREN] = ACTIONS(12270),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12270),
    [anon_sym_RBRACK] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_SEMI] = ACTIONS(12270),
    [anon_sym_LBRACE] = ACTIONS(12270),
    [anon_sym_RBRACE] = ACTIONS(12270),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12270),
    [anon_sym_COLON_COLON] = ACTIONS(12270),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_QMARK] = ACTIONS(12270),
    [anon_sym_AT] = ACTIONS(12270),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12270),
    [aux_sym_integer_literal_token2] = ACTIONS(12270),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12270),
    [aux_sym_float_literal_token3] = ACTIONS(12270),
    [aux_sym_float_literal_token4] = ACTIONS(12270),
    [sym_character_literal] = ACTIONS(12270),
    [sym__pair_operator] = ACTIONS(12270),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12270),
    [sym__lazy_and_operator] = ACTIONS(12270),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12270),
    [sym__pipe_left_operator] = ACTIONS(12270),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12270),
    [sym__bitshift_operator] = ACTIONS(12270),
    [sym__power_operator] = ACTIONS(12270),
    [sym__tilde_operator] = ACTIONS(12270),
    [sym__type_order_operator] = ACTIONS(12270),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6319] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_DASH_GT] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6320] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_RPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_SEMI] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_DASH_GT] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [6321] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2188),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2188),
    [aux_sym_integer_literal_token2] = ACTIONS(2188),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2188),
    [aux_sym_float_literal_token3] = ACTIONS(2188),
    [aux_sym_float_literal_token4] = ACTIONS(2188),
    [sym_character_literal] = ACTIONS(2188),
    [sym__pair_operator] = ACTIONS(2188),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2188),
    [sym__pipe_left_operator] = ACTIONS(2188),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2188),
    [sym__bitshift_operator] = ACTIONS(2188),
    [sym__power_operator] = ACTIONS(2188),
    [sym__tilde_operator] = ACTIONS(2188),
    [sym__type_order_operator] = ACTIONS(2188),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6322] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_DASH_GT] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [6323] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12274),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12274),
    [anon_sym_RPAREN] = ACTIONS(12274),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12274),
    [anon_sym_RBRACK] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_SEMI] = ACTIONS(12274),
    [anon_sym_LBRACE] = ACTIONS(12274),
    [anon_sym_RBRACE] = ACTIONS(12274),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12274),
    [anon_sym_COLON_COLON] = ACTIONS(12274),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12274),
    [anon_sym_QMARK] = ACTIONS(12274),
    [anon_sym_AT] = ACTIONS(12274),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12274),
    [aux_sym_integer_literal_token2] = ACTIONS(12274),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12274),
    [aux_sym_float_literal_token3] = ACTIONS(12274),
    [aux_sym_float_literal_token4] = ACTIONS(12274),
    [sym_character_literal] = ACTIONS(12274),
    [sym__pair_operator] = ACTIONS(12274),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12274),
    [sym__lazy_and_operator] = ACTIONS(12274),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12274),
    [sym__pipe_left_operator] = ACTIONS(12274),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12274),
    [sym__bitshift_operator] = ACTIONS(12274),
    [sym__power_operator] = ACTIONS(12274),
    [sym__tilde_operator] = ACTIONS(12274),
    [sym__type_order_operator] = ACTIONS(12274),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6324] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12278),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12278),
    [anon_sym_RPAREN] = ACTIONS(12278),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12278),
    [anon_sym_RBRACK] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12278),
    [anon_sym_LBRACE] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(12278),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12278),
    [anon_sym_COLON_COLON] = ACTIONS(12278),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12278),
    [anon_sym_QMARK] = ACTIONS(12278),
    [anon_sym_AT] = ACTIONS(12278),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12278),
    [aux_sym_integer_literal_token2] = ACTIONS(12278),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12278),
    [aux_sym_float_literal_token3] = ACTIONS(12278),
    [aux_sym_float_literal_token4] = ACTIONS(12278),
    [sym_character_literal] = ACTIONS(12278),
    [sym__pair_operator] = ACTIONS(12278),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12278),
    [sym__lazy_and_operator] = ACTIONS(12278),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12278),
    [sym__pipe_left_operator] = ACTIONS(12278),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12278),
    [sym__bitshift_operator] = ACTIONS(12278),
    [sym__power_operator] = ACTIONS(12278),
    [sym__tilde_operator] = ACTIONS(12278),
    [sym__type_order_operator] = ACTIONS(12278),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6325] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_DASH_GT] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6326] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12068),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12068),
    [anon_sym_RPAREN] = ACTIONS(12068),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12068),
    [anon_sym_RBRACK] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12068),
    [anon_sym_LBRACE] = ACTIONS(12068),
    [anon_sym_RBRACE] = ACTIONS(12068),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12068),
    [anon_sym_COLON_COLON] = ACTIONS(12068),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12068),
    [anon_sym_QMARK] = ACTIONS(12068),
    [anon_sym_AT] = ACTIONS(12068),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12068),
    [aux_sym_integer_literal_token2] = ACTIONS(12068),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12068),
    [aux_sym_float_literal_token3] = ACTIONS(12068),
    [aux_sym_float_literal_token4] = ACTIONS(12068),
    [sym_character_literal] = ACTIONS(12068),
    [sym__pair_operator] = ACTIONS(12068),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12068),
    [sym__lazy_and_operator] = ACTIONS(12068),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12068),
    [sym__pipe_left_operator] = ACTIONS(12068),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12068),
    [sym__bitshift_operator] = ACTIONS(12068),
    [sym__power_operator] = ACTIONS(12068),
    [sym__tilde_operator] = ACTIONS(12068),
    [sym__type_order_operator] = ACTIONS(12068),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6327] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__assignment_operator] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6328] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_catch] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6329] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12282),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12282),
    [anon_sym_RPAREN] = ACTIONS(12282),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12282),
    [anon_sym_RBRACK] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_SEMI] = ACTIONS(12282),
    [anon_sym_LBRACE] = ACTIONS(12282),
    [anon_sym_RBRACE] = ACTIONS(12282),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12282),
    [anon_sym_COLON_COLON] = ACTIONS(12282),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12282),
    [anon_sym_QMARK] = ACTIONS(12282),
    [anon_sym_AT] = ACTIONS(12282),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12282),
    [aux_sym_integer_literal_token2] = ACTIONS(12282),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12282),
    [aux_sym_float_literal_token3] = ACTIONS(12282),
    [aux_sym_float_literal_token4] = ACTIONS(12282),
    [sym_character_literal] = ACTIONS(12282),
    [sym__pair_operator] = ACTIONS(12282),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12282),
    [sym__lazy_and_operator] = ACTIONS(12282),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12282),
    [sym__pipe_left_operator] = ACTIONS(12282),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12282),
    [sym__bitshift_operator] = ACTIONS(12282),
    [sym__power_operator] = ACTIONS(12282),
    [sym__tilde_operator] = ACTIONS(12282),
    [sym__type_order_operator] = ACTIONS(12282),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6330] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12140),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12140),
    [anon_sym_RPAREN] = ACTIONS(12140),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12140),
    [anon_sym_RBRACK] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_SEMI] = ACTIONS(12140),
    [anon_sym_LBRACE] = ACTIONS(12140),
    [anon_sym_RBRACE] = ACTIONS(12140),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12140),
    [anon_sym_COLON_COLON] = ACTIONS(12140),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12140),
    [anon_sym_QMARK] = ACTIONS(12140),
    [anon_sym_AT] = ACTIONS(12140),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12140),
    [aux_sym_integer_literal_token2] = ACTIONS(12140),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12140),
    [aux_sym_float_literal_token3] = ACTIONS(12140),
    [aux_sym_float_literal_token4] = ACTIONS(12140),
    [sym_character_literal] = ACTIONS(12140),
    [sym__pair_operator] = ACTIONS(12140),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12140),
    [sym__lazy_and_operator] = ACTIONS(12140),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12140),
    [sym__pipe_left_operator] = ACTIONS(12140),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12140),
    [sym__bitshift_operator] = ACTIONS(12140),
    [sym__power_operator] = ACTIONS(12140),
    [sym__tilde_operator] = ACTIONS(12140),
    [sym__type_order_operator] = ACTIONS(12140),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6331] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12144),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12144),
    [anon_sym_RPAREN] = ACTIONS(12144),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12144),
    [anon_sym_RBRACK] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_SEMI] = ACTIONS(12144),
    [anon_sym_LBRACE] = ACTIONS(12144),
    [anon_sym_RBRACE] = ACTIONS(12144),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12144),
    [anon_sym_COLON_COLON] = ACTIONS(12144),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12144),
    [anon_sym_QMARK] = ACTIONS(12144),
    [anon_sym_AT] = ACTIONS(12144),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12144),
    [aux_sym_integer_literal_token2] = ACTIONS(12144),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12144),
    [aux_sym_float_literal_token3] = ACTIONS(12144),
    [aux_sym_float_literal_token4] = ACTIONS(12144),
    [sym_character_literal] = ACTIONS(12144),
    [sym__pair_operator] = ACTIONS(12144),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12144),
    [sym__lazy_and_operator] = ACTIONS(12144),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12144),
    [sym__pipe_left_operator] = ACTIONS(12144),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12144),
    [sym__bitshift_operator] = ACTIONS(12144),
    [sym__power_operator] = ACTIONS(12144),
    [sym__tilde_operator] = ACTIONS(12144),
    [sym__type_order_operator] = ACTIONS(12144),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6332] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12148),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12148),
    [anon_sym_RPAREN] = ACTIONS(12148),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12148),
    [anon_sym_RBRACK] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_SEMI] = ACTIONS(12148),
    [anon_sym_LBRACE] = ACTIONS(12148),
    [anon_sym_RBRACE] = ACTIONS(12148),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12148),
    [anon_sym_COLON_COLON] = ACTIONS(12148),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12148),
    [anon_sym_QMARK] = ACTIONS(12148),
    [anon_sym_AT] = ACTIONS(12148),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12148),
    [aux_sym_integer_literal_token2] = ACTIONS(12148),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12148),
    [aux_sym_float_literal_token3] = ACTIONS(12148),
    [aux_sym_float_literal_token4] = ACTIONS(12148),
    [sym_character_literal] = ACTIONS(12148),
    [sym__pair_operator] = ACTIONS(12148),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12148),
    [sym__lazy_and_operator] = ACTIONS(12148),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12148),
    [sym__pipe_left_operator] = ACTIONS(12148),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12148),
    [sym__bitshift_operator] = ACTIONS(12148),
    [sym__power_operator] = ACTIONS(12148),
    [sym__tilde_operator] = ACTIONS(12148),
    [sym__type_order_operator] = ACTIONS(12148),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6333] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_DASH_GT] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [6334] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__assignment_operator] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [6335] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [6336] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12156),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12156),
    [anon_sym_RPAREN] = ACTIONS(12156),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12156),
    [anon_sym_RBRACK] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_SEMI] = ACTIONS(12156),
    [anon_sym_LBRACE] = ACTIONS(12156),
    [anon_sym_RBRACE] = ACTIONS(12156),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12156),
    [anon_sym_COLON_COLON] = ACTIONS(12156),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12156),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_AT] = ACTIONS(12156),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12156),
    [aux_sym_integer_literal_token2] = ACTIONS(12156),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12156),
    [aux_sym_float_literal_token3] = ACTIONS(12156),
    [aux_sym_float_literal_token4] = ACTIONS(12156),
    [sym_character_literal] = ACTIONS(12156),
    [sym__pair_operator] = ACTIONS(12156),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12156),
    [sym__lazy_and_operator] = ACTIONS(12156),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12156),
    [sym__pipe_left_operator] = ACTIONS(12156),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12156),
    [sym__bitshift_operator] = ACTIONS(12156),
    [sym__power_operator] = ACTIONS(12156),
    [sym__tilde_operator] = ACTIONS(12156),
    [sym__type_order_operator] = ACTIONS(12156),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6337] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12160),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12160),
    [anon_sym_RPAREN] = ACTIONS(12160),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12160),
    [anon_sym_RBRACK] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_SEMI] = ACTIONS(12160),
    [anon_sym_LBRACE] = ACTIONS(12160),
    [anon_sym_RBRACE] = ACTIONS(12160),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12160),
    [anon_sym_COLON_COLON] = ACTIONS(12160),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12160),
    [anon_sym_QMARK] = ACTIONS(12160),
    [anon_sym_AT] = ACTIONS(12160),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12160),
    [aux_sym_integer_literal_token2] = ACTIONS(12160),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12160),
    [aux_sym_float_literal_token3] = ACTIONS(12160),
    [aux_sym_float_literal_token4] = ACTIONS(12160),
    [sym_character_literal] = ACTIONS(12160),
    [sym__pair_operator] = ACTIONS(12160),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12160),
    [sym__lazy_and_operator] = ACTIONS(12160),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12160),
    [sym__pipe_left_operator] = ACTIONS(12160),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12160),
    [sym__bitshift_operator] = ACTIONS(12160),
    [sym__power_operator] = ACTIONS(12160),
    [sym__tilde_operator] = ACTIONS(12160),
    [sym__type_order_operator] = ACTIONS(12160),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6338] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__assignment_operator] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6339] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12208),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12208),
    [anon_sym_RPAREN] = ACTIONS(12208),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_SEMI] = ACTIONS(12208),
    [anon_sym_LBRACE] = ACTIONS(12208),
    [anon_sym_RBRACE] = ACTIONS(12208),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12208),
    [anon_sym_COLON_COLON] = ACTIONS(12208),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12208),
    [anon_sym_QMARK] = ACTIONS(12208),
    [anon_sym_AT] = ACTIONS(12208),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12208),
    [aux_sym_integer_literal_token2] = ACTIONS(12208),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12208),
    [aux_sym_float_literal_token3] = ACTIONS(12208),
    [aux_sym_float_literal_token4] = ACTIONS(12208),
    [sym_character_literal] = ACTIONS(12208),
    [sym__pair_operator] = ACTIONS(12208),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12208),
    [sym__lazy_and_operator] = ACTIONS(12208),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12208),
    [sym__pipe_left_operator] = ACTIONS(12208),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12208),
    [sym__bitshift_operator] = ACTIONS(12208),
    [sym__power_operator] = ACTIONS(12208),
    [sym__tilde_operator] = ACTIONS(12208),
    [sym__type_order_operator] = ACTIONS(12208),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6340] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12164),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12164),
    [anon_sym_RPAREN] = ACTIONS(12164),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12164),
    [anon_sym_RBRACK] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12164),
    [anon_sym_LBRACE] = ACTIONS(12164),
    [anon_sym_RBRACE] = ACTIONS(12164),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12164),
    [anon_sym_COLON_COLON] = ACTIONS(12164),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12164),
    [anon_sym_QMARK] = ACTIONS(12164),
    [anon_sym_AT] = ACTIONS(12164),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12164),
    [aux_sym_integer_literal_token2] = ACTIONS(12164),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12164),
    [aux_sym_float_literal_token3] = ACTIONS(12164),
    [aux_sym_float_literal_token4] = ACTIONS(12164),
    [sym_character_literal] = ACTIONS(12164),
    [sym__pair_operator] = ACTIONS(12164),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12164),
    [sym__lazy_and_operator] = ACTIONS(12164),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12164),
    [sym__pipe_left_operator] = ACTIONS(12164),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12164),
    [sym__bitshift_operator] = ACTIONS(12164),
    [sym__power_operator] = ACTIONS(12164),
    [sym__tilde_operator] = ACTIONS(12164),
    [sym__type_order_operator] = ACTIONS(12164),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6341] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12168),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12168),
    [anon_sym_RPAREN] = ACTIONS(12168),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12168),
    [anon_sym_RBRACK] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_SEMI] = ACTIONS(12168),
    [anon_sym_LBRACE] = ACTIONS(12168),
    [anon_sym_RBRACE] = ACTIONS(12168),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12168),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(12168),
    [anon_sym_AT] = ACTIONS(12168),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12168),
    [aux_sym_integer_literal_token2] = ACTIONS(12168),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12168),
    [aux_sym_float_literal_token3] = ACTIONS(12168),
    [aux_sym_float_literal_token4] = ACTIONS(12168),
    [sym_character_literal] = ACTIONS(12168),
    [sym__pair_operator] = ACTIONS(12168),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12168),
    [sym__lazy_and_operator] = ACTIONS(12168),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12168),
    [sym__pipe_left_operator] = ACTIONS(12168),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12168),
    [sym__bitshift_operator] = ACTIONS(12168),
    [sym__power_operator] = ACTIONS(12168),
    [sym__tilde_operator] = ACTIONS(12168),
    [sym__type_order_operator] = ACTIONS(12168),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6342] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_DASH_GT] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [6343] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_DASH_GT] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [6344] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12176),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12176),
    [anon_sym_RPAREN] = ACTIONS(12176),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12176),
    [anon_sym_RBRACK] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_SEMI] = ACTIONS(12176),
    [anon_sym_LBRACE] = ACTIONS(12176),
    [anon_sym_RBRACE] = ACTIONS(12176),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12176),
    [anon_sym_COLON_COLON] = ACTIONS(12176),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12176),
    [anon_sym_QMARK] = ACTIONS(12176),
    [anon_sym_AT] = ACTIONS(12176),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12176),
    [aux_sym_integer_literal_token2] = ACTIONS(12176),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12176),
    [aux_sym_float_literal_token3] = ACTIONS(12176),
    [aux_sym_float_literal_token4] = ACTIONS(12176),
    [sym_character_literal] = ACTIONS(12176),
    [sym__pair_operator] = ACTIONS(12176),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12176),
    [sym__lazy_and_operator] = ACTIONS(12176),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12176),
    [sym__pipe_left_operator] = ACTIONS(12176),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12176),
    [sym__bitshift_operator] = ACTIONS(12176),
    [sym__power_operator] = ACTIONS(12176),
    [sym__tilde_operator] = ACTIONS(12176),
    [sym__type_order_operator] = ACTIONS(12176),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6345] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_DASH_GT] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [6346] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_RPAREN] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_RBRACE] = ACTIONS(11864),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11864),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11864),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11864),
    [sym__pipe_left_operator] = ACTIONS(11864),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11864),
    [sym__bitshift_operator] = ACTIONS(11864),
    [sym__power_operator] = ACTIONS(11864),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11864),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [6347] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12724),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12688),
    [anon_sym_DOT] = ACTIONS(12726),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12728),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12694),
    [sym__immediate_bracket] = ACTIONS(12696),
    [sym__immediate_brace] = ACTIONS(12698),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6348] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12290),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12290),
    [anon_sym_RPAREN] = ACTIONS(12290),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12290),
    [anon_sym_RBRACK] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_SEMI] = ACTIONS(12290),
    [anon_sym_LBRACE] = ACTIONS(12290),
    [anon_sym_RBRACE] = ACTIONS(12290),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12290),
    [anon_sym_COLON_COLON] = ACTIONS(12290),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_QMARK] = ACTIONS(12290),
    [anon_sym_AT] = ACTIONS(12290),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12290),
    [aux_sym_integer_literal_token2] = ACTIONS(12290),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12290),
    [aux_sym_float_literal_token3] = ACTIONS(12290),
    [aux_sym_float_literal_token4] = ACTIONS(12290),
    [sym_character_literal] = ACTIONS(12290),
    [sym__pair_operator] = ACTIONS(12290),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12290),
    [sym__lazy_and_operator] = ACTIONS(12290),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12290),
    [sym__pipe_left_operator] = ACTIONS(12290),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12290),
    [sym__bitshift_operator] = ACTIONS(12290),
    [sym__power_operator] = ACTIONS(12290),
    [sym__tilde_operator] = ACTIONS(12290),
    [sym__type_order_operator] = ACTIONS(12290),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6349] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__assignment_operator] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [6350] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__assignment_operator] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6351] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12298),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12298),
    [anon_sym_RPAREN] = ACTIONS(12298),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12298),
    [anon_sym_RBRACK] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_SEMI] = ACTIONS(12298),
    [anon_sym_LBRACE] = ACTIONS(12298),
    [anon_sym_RBRACE] = ACTIONS(12298),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12298),
    [anon_sym_COLON_COLON] = ACTIONS(12298),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12298),
    [anon_sym_QMARK] = ACTIONS(12298),
    [anon_sym_AT] = ACTIONS(12298),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12298),
    [aux_sym_integer_literal_token2] = ACTIONS(12298),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12298),
    [aux_sym_float_literal_token3] = ACTIONS(12298),
    [aux_sym_float_literal_token4] = ACTIONS(12298),
    [sym_character_literal] = ACTIONS(12298),
    [sym__pair_operator] = ACTIONS(12298),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12298),
    [sym__lazy_and_operator] = ACTIONS(12298),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12298),
    [sym__pipe_left_operator] = ACTIONS(12298),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12298),
    [sym__bitshift_operator] = ACTIONS(12298),
    [sym__power_operator] = ACTIONS(12298),
    [sym__tilde_operator] = ACTIONS(12298),
    [sym__type_order_operator] = ACTIONS(12298),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6352] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__assignment_operator] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [6353] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__assignment_operator] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6354] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__assignment_operator] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6355] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12302),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12302),
    [anon_sym_RPAREN] = ACTIONS(12302),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12302),
    [anon_sym_RBRACK] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_SEMI] = ACTIONS(12302),
    [anon_sym_LBRACE] = ACTIONS(12302),
    [anon_sym_RBRACE] = ACTIONS(12302),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12302),
    [anon_sym_COLON_COLON] = ACTIONS(12302),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12302),
    [anon_sym_QMARK] = ACTIONS(12302),
    [anon_sym_AT] = ACTIONS(12302),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12302),
    [aux_sym_integer_literal_token2] = ACTIONS(12302),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12302),
    [aux_sym_float_literal_token3] = ACTIONS(12302),
    [aux_sym_float_literal_token4] = ACTIONS(12302),
    [sym_character_literal] = ACTIONS(12302),
    [sym__pair_operator] = ACTIONS(12302),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12302),
    [sym__lazy_and_operator] = ACTIONS(12302),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12302),
    [sym__pipe_left_operator] = ACTIONS(12302),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12302),
    [sym__bitshift_operator] = ACTIONS(12302),
    [sym__power_operator] = ACTIONS(12302),
    [sym__tilde_operator] = ACTIONS(12302),
    [sym__type_order_operator] = ACTIONS(12302),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6356] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__assignment_operator] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [6357] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__assignment_operator] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6358] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_RPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_SEMI] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__assignment_operator] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [6359] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12152),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12152),
    [anon_sym_RPAREN] = ACTIONS(12152),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12152),
    [anon_sym_RBRACK] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_SEMI] = ACTIONS(12152),
    [anon_sym_LBRACE] = ACTIONS(12152),
    [anon_sym_RBRACE] = ACTIONS(12152),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12152),
    [anon_sym_COLON_COLON] = ACTIONS(12152),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12152),
    [anon_sym_QMARK] = ACTIONS(12152),
    [anon_sym_AT] = ACTIONS(12152),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12152),
    [aux_sym_integer_literal_token2] = ACTIONS(12152),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12152),
    [aux_sym_float_literal_token3] = ACTIONS(12152),
    [aux_sym_float_literal_token4] = ACTIONS(12152),
    [sym_character_literal] = ACTIONS(12152),
    [sym__pair_operator] = ACTIONS(12152),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12152),
    [sym__lazy_and_operator] = ACTIONS(12152),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12152),
    [sym__pipe_left_operator] = ACTIONS(12152),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12152),
    [sym__bitshift_operator] = ACTIONS(12152),
    [sym__power_operator] = ACTIONS(12152),
    [sym__tilde_operator] = ACTIONS(12152),
    [sym__type_order_operator] = ACTIONS(12152),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6360] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12730),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6361] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12732),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_SQUOTE] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12734),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__assignment_operator] = ACTIONS(12736),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__immediate_bracket] = ACTIONS(12630),
    [sym__immediate_brace] = ACTIONS(12632),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6362] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12688),
    [anon_sym_DOT] = ACTIONS(12690),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12692),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12694),
    [sym__immediate_bracket] = ACTIONS(12696),
    [sym__immediate_brace] = ACTIONS(12698),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6363] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__assignment_operator] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6364] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__assignment_operator] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [6365] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_catch] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6366] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_RPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_SEMI] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [6367] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6368] = {
    [sym__word_identifier] = ACTIONS(12410),
    [anon_sym_EQ] = ACTIONS(12410),
    [anon_sym_COMMA] = ACTIONS(12410),
    [anon_sym_COLON] = ACTIONS(12410),
    [anon_sym_begin] = ACTIONS(12410),
    [anon_sym_module] = ACTIONS(12410),
    [anon_sym_baremodule] = ACTIONS(12410),
    [anon_sym_end] = ACTIONS(12410),
    [anon_sym_abstract] = ACTIONS(12410),
    [anon_sym_primitive] = ACTIONS(12410),
    [anon_sym_mutable] = ACTIONS(12410),
    [anon_sym_struct] = ACTIONS(12410),
    [anon_sym_function] = ACTIONS(12410),
    [anon_sym_macro] = ACTIONS(12410),
    [anon_sym_where] = ACTIONS(12410),
    [anon_sym_quote] = ACTIONS(12410),
    [anon_sym_let] = ACTIONS(12410),
    [anon_sym_if] = ACTIONS(12410),
    [anon_sym_try] = ACTIONS(12410),
    [anon_sym_catch] = ACTIONS(12410),
    [anon_sym_for] = ACTIONS(12410),
    [anon_sym_while] = ACTIONS(12410),
    [sym_break_statement] = ACTIONS(12410),
    [sym_continue_statement] = ACTIONS(12410),
    [anon_sym_return] = ACTIONS(12410),
    [anon_sym_const] = ACTIONS(12410),
    [anon_sym_global] = ACTIONS(12410),
    [anon_sym_local] = ACTIONS(12410),
    [anon_sym_LPAREN] = ACTIONS(12410),
    [anon_sym_COLON2] = ACTIONS(12410),
    [anon_sym_export] = ACTIONS(12410),
    [anon_sym_import] = ACTIONS(12410),
    [anon_sym_using] = ACTIONS(12410),
    [anon_sym_LBRACK] = ACTIONS(12410),
    [anon_sym_LF] = ACTIONS(12476),
    [anon_sym_in] = ACTIONS(12410),
    [anon_sym_LBRACE] = ACTIONS(12410),
    [anon_sym_SQUOTE] = ACTIONS(12700),
    [anon_sym_DOT] = ACTIONS(12702),
    [anon_sym_DOLLAR] = ACTIONS(12410),
    [anon_sym_COLON_COLON] = ACTIONS(12410),
    [anon_sym_isa] = ACTIONS(12410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12410),
    [anon_sym_QMARK] = ACTIONS(12410),
    [anon_sym_AT] = ACTIONS(12410),
    [anon_sym_true] = ACTIONS(12410),
    [anon_sym_false] = ACTIONS(12410),
    [aux_sym_integer_literal_token1] = ACTIONS(12410),
    [aux_sym_integer_literal_token2] = ACTIONS(12410),
    [aux_sym_integer_literal_token3] = ACTIONS(12410),
    [aux_sym_integer_literal_token4] = ACTIONS(12410),
    [aux_sym_float_literal_token1] = ACTIONS(12410),
    [aux_sym_float_literal_token3] = ACTIONS(12410),
    [aux_sym_float_literal_token4] = ACTIONS(12410),
    [sym_character_literal] = ACTIONS(12410),
    [sym__pair_operator] = ACTIONS(12410),
    [sym__arrow_operator] = ACTIONS(12410),
    [sym__lazy_or_operator] = ACTIONS(12410),
    [sym__lazy_and_operator] = ACTIONS(12410),
    [sym__comparison_operator] = ACTIONS(12410),
    [sym__pipe_right_operator] = ACTIONS(12410),
    [sym__pipe_left_operator] = ACTIONS(12410),
    [sym__ellipsis_operator] = ACTIONS(12410),
    [sym__plus_operator] = ACTIONS(12410),
    [sym__times_operator] = ACTIONS(12410),
    [sym__rational_operator] = ACTIONS(12410),
    [sym__bitshift_operator] = ACTIONS(12410),
    [sym__power_operator] = ACTIONS(12410),
    [sym__tilde_operator] = ACTIONS(12410),
    [sym__type_order_operator] = ACTIONS(12410),
    [sym__unary_operator] = ACTIONS(12410),
    [sym__unary_plus_operator] = ACTIONS(12410),
    [aux_sym__terminator_token1] = ACTIONS(12410),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12704),
    [sym__immediate_bracket] = ACTIONS(12706),
    [sym__immediate_brace] = ACTIONS(12708),
    [sym__string_start] = ACTIONS(12476),
    [sym__command_start] = ACTIONS(12476),
  },
  [6369] = {
    [sym__word_identifier] = ACTIONS(12410),
    [anon_sym_EQ] = ACTIONS(12410),
    [anon_sym_COMMA] = ACTIONS(12476),
    [anon_sym_COLON] = ACTIONS(12410),
    [anon_sym_begin] = ACTIONS(12410),
    [anon_sym_module] = ACTIONS(12410),
    [anon_sym_baremodule] = ACTIONS(12410),
    [anon_sym_abstract] = ACTIONS(12410),
    [anon_sym_primitive] = ACTIONS(12410),
    [anon_sym_mutable] = ACTIONS(12410),
    [anon_sym_struct] = ACTIONS(12410),
    [anon_sym_function] = ACTIONS(12410),
    [anon_sym_macro] = ACTIONS(12410),
    [anon_sym_where] = ACTIONS(12410),
    [anon_sym_quote] = ACTIONS(12410),
    [anon_sym_let] = ACTIONS(12410),
    [anon_sym_if] = ACTIONS(12410),
    [anon_sym_try] = ACTIONS(12410),
    [anon_sym_for] = ACTIONS(12410),
    [anon_sym_while] = ACTIONS(12410),
    [sym_break_statement] = ACTIONS(12410),
    [sym_continue_statement] = ACTIONS(12410),
    [anon_sym_return] = ACTIONS(12410),
    [anon_sym_const] = ACTIONS(12410),
    [anon_sym_global] = ACTIONS(12410),
    [anon_sym_local] = ACTIONS(12410),
    [anon_sym_LPAREN] = ACTIONS(12476),
    [anon_sym_RPAREN] = ACTIONS(12476),
    [anon_sym_COLON2] = ACTIONS(12410),
    [anon_sym_export] = ACTIONS(12410),
    [anon_sym_import] = ACTIONS(12410),
    [anon_sym_using] = ACTIONS(12410),
    [anon_sym_LBRACK] = ACTIONS(12476),
    [anon_sym_RBRACK] = ACTIONS(12476),
    [anon_sym_in] = ACTIONS(12410),
    [anon_sym_SEMI] = ACTIONS(12476),
    [anon_sym_LBRACE] = ACTIONS(12476),
    [anon_sym_RBRACE] = ACTIONS(12476),
    [anon_sym_SQUOTE] = ACTIONS(12666),
    [anon_sym_DOT] = ACTIONS(12668),
    [anon_sym_DOLLAR] = ACTIONS(12476),
    [anon_sym_COLON_COLON] = ACTIONS(12476),
    [anon_sym_isa] = ACTIONS(12410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12476),
    [anon_sym_QMARK] = ACTIONS(12476),
    [anon_sym_AT] = ACTIONS(12476),
    [anon_sym_true] = ACTIONS(12410),
    [anon_sym_false] = ACTIONS(12410),
    [aux_sym_integer_literal_token1] = ACTIONS(12476),
    [aux_sym_integer_literal_token2] = ACTIONS(12476),
    [aux_sym_integer_literal_token3] = ACTIONS(12410),
    [aux_sym_integer_literal_token4] = ACTIONS(12410),
    [aux_sym_float_literal_token1] = ACTIONS(12476),
    [aux_sym_float_literal_token3] = ACTIONS(12476),
    [aux_sym_float_literal_token4] = ACTIONS(12476),
    [sym_character_literal] = ACTIONS(12476),
    [sym__pair_operator] = ACTIONS(12476),
    [sym__arrow_operator] = ACTIONS(12410),
    [sym__lazy_or_operator] = ACTIONS(12476),
    [sym__lazy_and_operator] = ACTIONS(12476),
    [sym__comparison_operator] = ACTIONS(12410),
    [sym__pipe_right_operator] = ACTIONS(12476),
    [sym__pipe_left_operator] = ACTIONS(12476),
    [sym__ellipsis_operator] = ACTIONS(12410),
    [sym__plus_operator] = ACTIONS(12410),
    [sym__times_operator] = ACTIONS(12410),
    [sym__rational_operator] = ACTIONS(12476),
    [sym__bitshift_operator] = ACTIONS(12476),
    [sym__power_operator] = ACTIONS(12476),
    [sym__tilde_operator] = ACTIONS(12476),
    [sym__type_order_operator] = ACTIONS(12476),
    [sym__unary_operator] = ACTIONS(12410),
    [sym__unary_plus_operator] = ACTIONS(12410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12670),
    [sym__immediate_bracket] = ACTIONS(12672),
    [sym__immediate_brace] = ACTIONS(12674),
    [sym__string_start] = ACTIONS(12476),
    [sym__command_start] = ACTIONS(12476),
  },
  [6370] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12464),
    [anon_sym_DOT] = ACTIONS(12466),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12468),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12470),
    [sym__immediate_bracket] = ACTIONS(12472),
    [sym__immediate_brace] = ACTIONS(12474),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6371] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12564),
    [anon_sym_DOT] = ACTIONS(12566),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12568),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12570),
    [sym__immediate_bracket] = ACTIONS(12572),
    [sym__immediate_brace] = ACTIONS(12574),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6372] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__assignment_operator] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6373] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12502),
    [anon_sym_DOT] = ACTIONS(12612),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12614),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12508),
    [sym__immediate_bracket] = ACTIONS(12510),
    [sym__immediate_brace] = ACTIONS(12512),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6374] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12710),
    [sym__immediate_command_start] = ACTIONS(12712),
  },
  [6375] = {
    [ts_builtin_sym_end] = ACTIONS(11890),
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_RBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12720),
    [sym__immediate_command_start] = ACTIONS(12722),
  },
  [6376] = {
    [sym__word_identifier] = ACTIONS(12194),
    [anon_sym_EQ] = ACTIONS(12194),
    [anon_sym_COMMA] = ACTIONS(12194),
    [anon_sym_COLON] = ACTIONS(12194),
    [anon_sym_begin] = ACTIONS(12194),
    [anon_sym_module] = ACTIONS(12194),
    [anon_sym_baremodule] = ACTIONS(12194),
    [anon_sym_abstract] = ACTIONS(12194),
    [anon_sym_primitive] = ACTIONS(12194),
    [anon_sym_mutable] = ACTIONS(12194),
    [anon_sym_struct] = ACTIONS(12194),
    [anon_sym_function] = ACTIONS(12194),
    [anon_sym_macro] = ACTIONS(12194),
    [anon_sym_where] = ACTIONS(12194),
    [anon_sym_quote] = ACTIONS(12194),
    [anon_sym_let] = ACTIONS(12194),
    [anon_sym_if] = ACTIONS(12194),
    [anon_sym_try] = ACTIONS(12194),
    [anon_sym_for] = ACTIONS(12194),
    [anon_sym_while] = ACTIONS(12194),
    [sym_break_statement] = ACTIONS(12194),
    [sym_continue_statement] = ACTIONS(12194),
    [anon_sym_return] = ACTIONS(12194),
    [anon_sym_const] = ACTIONS(12194),
    [anon_sym_global] = ACTIONS(12194),
    [anon_sym_local] = ACTIONS(12194),
    [anon_sym_LPAREN] = ACTIONS(12194),
    [anon_sym_RPAREN] = ACTIONS(12194),
    [anon_sym_COLON2] = ACTIONS(12194),
    [anon_sym_export] = ACTIONS(12194),
    [anon_sym_import] = ACTIONS(12194),
    [anon_sym_using] = ACTIONS(12194),
    [anon_sym_LBRACK] = ACTIONS(12194),
    [anon_sym_LF] = ACTIONS(12196),
    [anon_sym_in] = ACTIONS(12194),
    [anon_sym_SEMI] = ACTIONS(12194),
    [anon_sym_LBRACE] = ACTIONS(12194),
    [anon_sym_SQUOTE] = ACTIONS(12738),
    [anon_sym_DOT] = ACTIONS(12740),
    [anon_sym_DOLLAR] = ACTIONS(12194),
    [anon_sym_COLON_COLON] = ACTIONS(12194),
    [anon_sym_isa] = ACTIONS(12194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12194),
    [anon_sym_QMARK] = ACTIONS(12194),
    [anon_sym_DASH_GT] = ACTIONS(12194),
    [anon_sym_AT] = ACTIONS(12194),
    [anon_sym_true] = ACTIONS(12194),
    [anon_sym_false] = ACTIONS(12194),
    [aux_sym_integer_literal_token1] = ACTIONS(12194),
    [aux_sym_integer_literal_token2] = ACTIONS(12194),
    [aux_sym_integer_literal_token3] = ACTIONS(12194),
    [aux_sym_integer_literal_token4] = ACTIONS(12194),
    [aux_sym_float_literal_token1] = ACTIONS(12194),
    [aux_sym_float_literal_token3] = ACTIONS(12194),
    [aux_sym_float_literal_token4] = ACTIONS(12194),
    [sym_character_literal] = ACTIONS(12194),
    [sym__pair_operator] = ACTIONS(12194),
    [sym__arrow_operator] = ACTIONS(12194),
    [sym__lazy_or_operator] = ACTIONS(12194),
    [sym__lazy_and_operator] = ACTIONS(12194),
    [sym__comparison_operator] = ACTIONS(12194),
    [sym__pipe_right_operator] = ACTIONS(12194),
    [sym__pipe_left_operator] = ACTIONS(12194),
    [sym__ellipsis_operator] = ACTIONS(12194),
    [sym__plus_operator] = ACTIONS(12194),
    [sym__times_operator] = ACTIONS(12194),
    [sym__rational_operator] = ACTIONS(12194),
    [sym__bitshift_operator] = ACTIONS(12194),
    [sym__power_operator] = ACTIONS(12194),
    [sym__tilde_operator] = ACTIONS(12194),
    [sym__type_order_operator] = ACTIONS(12194),
    [sym__unary_operator] = ACTIONS(12194),
    [sym__unary_plus_operator] = ACTIONS(12194),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12742),
    [sym__immediate_bracket] = ACTIONS(12744),
    [sym__immediate_brace] = ACTIONS(12746),
    [sym__string_start] = ACTIONS(12196),
    [sym__command_start] = ACTIONS(12196),
  },
  [6377] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_RPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_SEMI] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [6378] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_SQUOTE] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12624),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__assignment_operator] = ACTIONS(12626),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__immediate_bracket] = ACTIONS(12630),
    [sym__immediate_brace] = ACTIONS(12632),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6379] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6380] = {
    [sym__word_identifier] = ACTIONS(12558),
    [anon_sym_EQ] = ACTIONS(12558),
    [anon_sym_COMMA] = ACTIONS(12558),
    [anon_sym_COLON] = ACTIONS(12558),
    [anon_sym_begin] = ACTIONS(12558),
    [anon_sym_module] = ACTIONS(12558),
    [anon_sym_baremodule] = ACTIONS(12558),
    [anon_sym_end] = ACTIONS(12558),
    [anon_sym_abstract] = ACTIONS(12558),
    [anon_sym_primitive] = ACTIONS(12558),
    [anon_sym_mutable] = ACTIONS(12558),
    [anon_sym_struct] = ACTIONS(12558),
    [anon_sym_function] = ACTIONS(12558),
    [anon_sym_macro] = ACTIONS(12558),
    [anon_sym_where] = ACTIONS(12558),
    [anon_sym_quote] = ACTIONS(12558),
    [anon_sym_let] = ACTIONS(12558),
    [anon_sym_if] = ACTIONS(12558),
    [anon_sym_try] = ACTIONS(12558),
    [anon_sym_finally] = ACTIONS(12558),
    [anon_sym_for] = ACTIONS(12558),
    [anon_sym_while] = ACTIONS(12558),
    [sym_break_statement] = ACTIONS(12558),
    [sym_continue_statement] = ACTIONS(12558),
    [anon_sym_return] = ACTIONS(12558),
    [anon_sym_const] = ACTIONS(12558),
    [anon_sym_global] = ACTIONS(12558),
    [anon_sym_local] = ACTIONS(12558),
    [anon_sym_LPAREN] = ACTIONS(12558),
    [anon_sym_COLON2] = ACTIONS(12558),
    [anon_sym_export] = ACTIONS(12558),
    [anon_sym_import] = ACTIONS(12558),
    [anon_sym_using] = ACTIONS(12558),
    [anon_sym_LBRACK] = ACTIONS(12558),
    [anon_sym_LF] = ACTIONS(12560),
    [anon_sym_in] = ACTIONS(12558),
    [anon_sym_LBRACE] = ACTIONS(12558),
    [anon_sym_SQUOTE] = ACTIONS(12748),
    [anon_sym_DOT] = ACTIONS(12750),
    [anon_sym_DOLLAR] = ACTIONS(12558),
    [anon_sym_COLON_COLON] = ACTIONS(12558),
    [anon_sym_isa] = ACTIONS(12558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12558),
    [anon_sym_QMARK] = ACTIONS(12558),
    [anon_sym_AT] = ACTIONS(12558),
    [anon_sym_true] = ACTIONS(12558),
    [anon_sym_false] = ACTIONS(12558),
    [aux_sym_integer_literal_token1] = ACTIONS(12558),
    [aux_sym_integer_literal_token2] = ACTIONS(12558),
    [aux_sym_integer_literal_token3] = ACTIONS(12558),
    [aux_sym_integer_literal_token4] = ACTIONS(12558),
    [aux_sym_float_literal_token1] = ACTIONS(12558),
    [aux_sym_float_literal_token3] = ACTIONS(12558),
    [aux_sym_float_literal_token4] = ACTIONS(12558),
    [sym_character_literal] = ACTIONS(12558),
    [sym__pair_operator] = ACTIONS(12558),
    [sym__arrow_operator] = ACTIONS(12558),
    [sym__lazy_or_operator] = ACTIONS(12558),
    [sym__lazy_and_operator] = ACTIONS(12558),
    [sym__comparison_operator] = ACTIONS(12558),
    [sym__pipe_right_operator] = ACTIONS(12558),
    [sym__pipe_left_operator] = ACTIONS(12558),
    [sym__ellipsis_operator] = ACTIONS(12558),
    [sym__plus_operator] = ACTIONS(12558),
    [sym__times_operator] = ACTIONS(12558),
    [sym__rational_operator] = ACTIONS(12558),
    [sym__bitshift_operator] = ACTIONS(12558),
    [sym__power_operator] = ACTIONS(12558),
    [sym__tilde_operator] = ACTIONS(12558),
    [sym__type_order_operator] = ACTIONS(12558),
    [sym__unary_operator] = ACTIONS(12558),
    [sym__unary_plus_operator] = ACTIONS(12558),
    [aux_sym__terminator_token1] = ACTIONS(12558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12752),
    [sym__immediate_bracket] = ACTIONS(12754),
    [sym__immediate_brace] = ACTIONS(12756),
    [sym__string_start] = ACTIONS(12560),
    [sym__command_start] = ACTIONS(12560),
  },
  [6381] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_catch] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6382] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6383] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__assignment_operator] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6384] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_catch] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6385] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_catch] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6386] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_catch] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [6387] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_EQ] = ACTIONS(11976),
    [anon_sym_COMMA] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_COLON2] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_in] = ACTIONS(11976),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_isa] = ACTIONS(11976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11976),
    [anon_sym_QMARK] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__lazy_or_operator] = ACTIONS(11976),
    [sym__lazy_and_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [6388] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__assignment_operator] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6389] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_RPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__assignment_operator] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [6390] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_RPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_SEMI] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__assignment_operator] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [6391] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__assignment_operator] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [6392] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_RPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_SEMI] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_DASH_GT] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [6393] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__assignment_operator] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [6394] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__assignment_operator] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [6395] = {
    [sym__word_identifier] = ACTIONS(12558),
    [anon_sym_EQ] = ACTIONS(12558),
    [anon_sym_COMMA] = ACTIONS(12558),
    [anon_sym_COLON] = ACTIONS(12558),
    [anon_sym_begin] = ACTIONS(12558),
    [anon_sym_module] = ACTIONS(12558),
    [anon_sym_baremodule] = ACTIONS(12558),
    [anon_sym_abstract] = ACTIONS(12558),
    [anon_sym_primitive] = ACTIONS(12558),
    [anon_sym_mutable] = ACTIONS(12558),
    [anon_sym_struct] = ACTIONS(12558),
    [anon_sym_function] = ACTIONS(12558),
    [anon_sym_macro] = ACTIONS(12558),
    [anon_sym_where] = ACTIONS(12558),
    [anon_sym_quote] = ACTIONS(12558),
    [anon_sym_let] = ACTIONS(12558),
    [anon_sym_if] = ACTIONS(12558),
    [anon_sym_try] = ACTIONS(12558),
    [anon_sym_catch] = ACTIONS(12558),
    [anon_sym_finally] = ACTIONS(12558),
    [anon_sym_for] = ACTIONS(12558),
    [anon_sym_while] = ACTIONS(12558),
    [sym_break_statement] = ACTIONS(12558),
    [sym_continue_statement] = ACTIONS(12558),
    [anon_sym_return] = ACTIONS(12558),
    [anon_sym_const] = ACTIONS(12558),
    [anon_sym_global] = ACTIONS(12558),
    [anon_sym_local] = ACTIONS(12558),
    [anon_sym_LPAREN] = ACTIONS(12558),
    [anon_sym_COLON2] = ACTIONS(12558),
    [anon_sym_export] = ACTIONS(12558),
    [anon_sym_import] = ACTIONS(12558),
    [anon_sym_using] = ACTIONS(12558),
    [anon_sym_LBRACK] = ACTIONS(12558),
    [anon_sym_LF] = ACTIONS(12560),
    [anon_sym_in] = ACTIONS(12558),
    [anon_sym_LBRACE] = ACTIONS(12558),
    [anon_sym_SQUOTE] = ACTIONS(12634),
    [anon_sym_DOT] = ACTIONS(12636),
    [anon_sym_DOLLAR] = ACTIONS(12558),
    [anon_sym_COLON_COLON] = ACTIONS(12558),
    [anon_sym_isa] = ACTIONS(12558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12558),
    [anon_sym_QMARK] = ACTIONS(12558),
    [anon_sym_AT] = ACTIONS(12558),
    [anon_sym_true] = ACTIONS(12558),
    [anon_sym_false] = ACTIONS(12558),
    [aux_sym_integer_literal_token1] = ACTIONS(12558),
    [aux_sym_integer_literal_token2] = ACTIONS(12558),
    [aux_sym_integer_literal_token3] = ACTIONS(12558),
    [aux_sym_integer_literal_token4] = ACTIONS(12558),
    [aux_sym_float_literal_token1] = ACTIONS(12558),
    [aux_sym_float_literal_token3] = ACTIONS(12558),
    [aux_sym_float_literal_token4] = ACTIONS(12558),
    [sym_character_literal] = ACTIONS(12558),
    [sym__pair_operator] = ACTIONS(12558),
    [sym__arrow_operator] = ACTIONS(12558),
    [sym__lazy_or_operator] = ACTIONS(12558),
    [sym__lazy_and_operator] = ACTIONS(12558),
    [sym__comparison_operator] = ACTIONS(12558),
    [sym__pipe_right_operator] = ACTIONS(12558),
    [sym__pipe_left_operator] = ACTIONS(12558),
    [sym__ellipsis_operator] = ACTIONS(12558),
    [sym__plus_operator] = ACTIONS(12558),
    [sym__times_operator] = ACTIONS(12558),
    [sym__rational_operator] = ACTIONS(12558),
    [sym__bitshift_operator] = ACTIONS(12558),
    [sym__power_operator] = ACTIONS(12558),
    [sym__tilde_operator] = ACTIONS(12558),
    [sym__type_order_operator] = ACTIONS(12558),
    [sym__unary_operator] = ACTIONS(12558),
    [sym__unary_plus_operator] = ACTIONS(12558),
    [aux_sym__terminator_token1] = ACTIONS(12558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12638),
    [sym__immediate_bracket] = ACTIONS(12640),
    [sym__immediate_brace] = ACTIONS(12642),
    [sym__string_start] = ACTIONS(12560),
    [sym__command_start] = ACTIONS(12560),
  },
  [6396] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6397] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__assignment_operator] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6398] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_catch] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [6399] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_catch] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [6400] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_catch] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [6401] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_catch] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [6402] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_DASH_GT] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6403] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__assignment_operator] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6404] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6405] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6406] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_RPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_SEMI] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__assignment_operator] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [6407] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_catch] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [6408] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__assignment_operator] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6409] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_catch] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [6410] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_catch] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6411] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__assignment_operator] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6412] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_EQ] = ACTIONS(11984),
    [anon_sym_COMMA] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_COLON2] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_in] = ACTIONS(11984),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_isa] = ACTIONS(11984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11984),
    [anon_sym_QMARK] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__lazy_or_operator] = ACTIONS(11984),
    [sym__lazy_and_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [6413] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11894),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11894),
    [anon_sym_RPAREN] = ACTIONS(11894),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11894),
    [anon_sym_RBRACK] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11894),
    [anon_sym_RBRACE] = ACTIONS(11894),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11894),
    [anon_sym_COLON_COLON] = ACTIONS(11894),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11894),
    [anon_sym_QMARK] = ACTIONS(11894),
    [anon_sym_AT] = ACTIONS(11894),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11894),
    [aux_sym_integer_literal_token2] = ACTIONS(11894),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11894),
    [aux_sym_float_literal_token3] = ACTIONS(11894),
    [aux_sym_float_literal_token4] = ACTIONS(11894),
    [sym_character_literal] = ACTIONS(11894),
    [sym__pair_operator] = ACTIONS(11894),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11894),
    [sym__lazy_and_operator] = ACTIONS(11894),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11894),
    [sym__pipe_left_operator] = ACTIONS(11894),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11894),
    [sym__bitshift_operator] = ACTIONS(11894),
    [sym__power_operator] = ACTIONS(11894),
    [sym__tilde_operator] = ACTIONS(11894),
    [sym__type_order_operator] = ACTIONS(11894),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6414] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_RPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_SEMI] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__assignment_operator] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [6415] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__assignment_operator] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6416] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_RPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_DASH_GT] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [6417] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_RPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_SEMI] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_DASH_GT] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [6418] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_catch] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [6419] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_catch] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [6420] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_DASH_GT] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [6421] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_DASH_GT] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [6422] = {
    [ts_builtin_sym_end] = ACTIONS(12620),
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_RPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_RBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12620),
    [sym__immediate_bracket] = ACTIONS(12620),
    [sym__immediate_brace] = ACTIONS(12620),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6423] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_catch] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [6424] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_DASH_GT] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6425] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_finally] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [6426] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_catch] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [6427] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_DASH_GT] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6428] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_DASH_GT] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6429] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_catch] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [6430] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_catch] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6431] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6432] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_DASH_GT] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6433] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_elseif] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12682),
    [sym__immediate_command_start] = ACTIONS(12684),
  },
  [6434] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_catch] = ACTIONS(12308),
    [anon_sym_finally] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [6435] = {
    [sym__word_identifier] = ACTIONS(12410),
    [anon_sym_EQ] = ACTIONS(12410),
    [anon_sym_COMMA] = ACTIONS(12410),
    [anon_sym_COLON] = ACTIONS(12410),
    [anon_sym_begin] = ACTIONS(12410),
    [anon_sym_module] = ACTIONS(12410),
    [anon_sym_baremodule] = ACTIONS(12410),
    [anon_sym_end] = ACTIONS(12410),
    [anon_sym_abstract] = ACTIONS(12410),
    [anon_sym_primitive] = ACTIONS(12410),
    [anon_sym_mutable] = ACTIONS(12410),
    [anon_sym_struct] = ACTIONS(12410),
    [anon_sym_function] = ACTIONS(12410),
    [anon_sym_macro] = ACTIONS(12410),
    [anon_sym_where] = ACTIONS(12410),
    [anon_sym_quote] = ACTIONS(12410),
    [anon_sym_let] = ACTIONS(12410),
    [anon_sym_if] = ACTIONS(12410),
    [anon_sym_try] = ACTIONS(12410),
    [anon_sym_finally] = ACTIONS(12410),
    [anon_sym_for] = ACTIONS(12410),
    [anon_sym_while] = ACTIONS(12410),
    [sym_break_statement] = ACTIONS(12410),
    [sym_continue_statement] = ACTIONS(12410),
    [anon_sym_return] = ACTIONS(12410),
    [anon_sym_const] = ACTIONS(12410),
    [anon_sym_global] = ACTIONS(12410),
    [anon_sym_local] = ACTIONS(12410),
    [anon_sym_LPAREN] = ACTIONS(12410),
    [anon_sym_COLON2] = ACTIONS(12410),
    [anon_sym_export] = ACTIONS(12410),
    [anon_sym_import] = ACTIONS(12410),
    [anon_sym_using] = ACTIONS(12410),
    [anon_sym_LBRACK] = ACTIONS(12410),
    [anon_sym_LF] = ACTIONS(12476),
    [anon_sym_in] = ACTIONS(12410),
    [anon_sym_LBRACE] = ACTIONS(12410),
    [anon_sym_SQUOTE] = ACTIONS(12748),
    [anon_sym_DOT] = ACTIONS(12750),
    [anon_sym_DOLLAR] = ACTIONS(12410),
    [anon_sym_COLON_COLON] = ACTIONS(12410),
    [anon_sym_isa] = ACTIONS(12410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12410),
    [anon_sym_QMARK] = ACTIONS(12410),
    [anon_sym_AT] = ACTIONS(12410),
    [anon_sym_true] = ACTIONS(12410),
    [anon_sym_false] = ACTIONS(12410),
    [aux_sym_integer_literal_token1] = ACTIONS(12410),
    [aux_sym_integer_literal_token2] = ACTIONS(12410),
    [aux_sym_integer_literal_token3] = ACTIONS(12410),
    [aux_sym_integer_literal_token4] = ACTIONS(12410),
    [aux_sym_float_literal_token1] = ACTIONS(12410),
    [aux_sym_float_literal_token3] = ACTIONS(12410),
    [aux_sym_float_literal_token4] = ACTIONS(12410),
    [sym_character_literal] = ACTIONS(12410),
    [sym__pair_operator] = ACTIONS(12410),
    [sym__arrow_operator] = ACTIONS(12410),
    [sym__lazy_or_operator] = ACTIONS(12410),
    [sym__lazy_and_operator] = ACTIONS(12410),
    [sym__comparison_operator] = ACTIONS(12410),
    [sym__pipe_right_operator] = ACTIONS(12410),
    [sym__pipe_left_operator] = ACTIONS(12410),
    [sym__ellipsis_operator] = ACTIONS(12410),
    [sym__plus_operator] = ACTIONS(12410),
    [sym__times_operator] = ACTIONS(12410),
    [sym__rational_operator] = ACTIONS(12410),
    [sym__bitshift_operator] = ACTIONS(12410),
    [sym__power_operator] = ACTIONS(12410),
    [sym__tilde_operator] = ACTIONS(12410),
    [sym__type_order_operator] = ACTIONS(12410),
    [sym__unary_operator] = ACTIONS(12410),
    [sym__unary_plus_operator] = ACTIONS(12410),
    [aux_sym__terminator_token1] = ACTIONS(12410),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12752),
    [sym__immediate_bracket] = ACTIONS(12754),
    [sym__immediate_brace] = ACTIONS(12756),
    [sym__string_start] = ACTIONS(12476),
    [sym__command_start] = ACTIONS(12476),
  },
  [6436] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__assignment_operator] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6437] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12758),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6438] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__assignment_operator] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6439] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_catch] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6440] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_DASH_GT] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6441] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_RPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_SEMI] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_DASH_GT] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [6442] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_catch] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6443] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_RPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_SEMI] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_DASH_GT] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [6444] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_DASH_GT] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6445] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__assignment_operator] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6446] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6447] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__assignment_operator] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6448] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__assignment_operator] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6449] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_DASH_GT] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6450] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_elseif] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12760),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6451] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6452] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_RPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_SEMI] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_DASH_GT] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [6453] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_DASH_GT] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [6454] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_DASH_GT] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6455] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6456] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6457] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12762),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12180),
    [anon_sym_DOT] = ACTIONS(12420),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12422),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__immediate_bracket] = ACTIONS(12188),
    [sym__immediate_brace] = ACTIONS(12190),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6458] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_DASH_GT] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6459] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_RPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_SEMI] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__assignment_operator] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [6460] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_RPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_SEMI] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_DASH_GT] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [6461] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_RPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_SEMI] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_DASH_GT] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [6462] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_catch] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6463] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_RPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_SEMI] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_DASH_GT] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [6464] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_catch] = ACTIONS(12360),
    [anon_sym_finally] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [6465] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_catch] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6466] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6467] = {
    [sym_identifier] = STATE(6692),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_elseif] = ACTIONS(12006),
    [anon_sym_else] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_as] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6468] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6469] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12764),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6470] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [6471] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [6472] = {
    [sym_identifier] = STATE(6722),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_else] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_as] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6473] = {
    [sym_identifier] = STATE(6723),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_else] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_as] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6474] = {
    [sym_identifier] = STATE(6732),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_else] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_as] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6475] = {
    [sym_identifier] = STATE(6733),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_else] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_as] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6476] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [6477] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_catch] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12620),
    [sym__immediate_bracket] = ACTIONS(12620),
    [sym__immediate_brace] = ACTIONS(12620),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6478] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6479] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6480] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6481] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [6482] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12766),
    [sym__immediate_command_start] = ACTIONS(12768),
  },
  [6483] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6484] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6485] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6486] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6487] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6488] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6489] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_elseif] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12770),
    [sym__immediate_command_start] = ACTIONS(12772),
  },
  [6490] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6491] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6492] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12620),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12620),
    [anon_sym_RPAREN] = ACTIONS(12620),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12620),
    [anon_sym_RBRACK] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_SEMI] = ACTIONS(12620),
    [anon_sym_LBRACE] = ACTIONS(12620),
    [anon_sym_RBRACE] = ACTIONS(12620),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12620),
    [anon_sym_COLON_COLON] = ACTIONS(12620),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12620),
    [anon_sym_QMARK] = ACTIONS(12620),
    [anon_sym_AT] = ACTIONS(12620),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12620),
    [aux_sym_integer_literal_token2] = ACTIONS(12620),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12620),
    [aux_sym_float_literal_token3] = ACTIONS(12620),
    [aux_sym_float_literal_token4] = ACTIONS(12620),
    [sym_character_literal] = ACTIONS(12620),
    [sym__pair_operator] = ACTIONS(12620),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12620),
    [sym__lazy_and_operator] = ACTIONS(12620),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12620),
    [sym__pipe_left_operator] = ACTIONS(12620),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12620),
    [sym__bitshift_operator] = ACTIONS(12620),
    [sym__power_operator] = ACTIONS(12620),
    [sym__tilde_operator] = ACTIONS(12620),
    [sym__type_order_operator] = ACTIONS(12620),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12620),
    [sym__immediate_bracket] = ACTIONS(12620),
    [sym__immediate_brace] = ACTIONS(12620),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6493] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6494] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6495] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6496] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6497] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [6498] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12774),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6499] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6500] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6501] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [6502] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6503] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [6504] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6505] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6506] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [6507] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6508] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6509] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6510] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6511] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6512] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_RPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_SEMI] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6513] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_RPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_SEMI] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6514] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_RPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_SEMI] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6515] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6516] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6517] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_RPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_SEMI] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [6518] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_RPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_SEMI] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6519] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6520] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_RPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_SEMI] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6521] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_RPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_SEMI] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6522] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_RPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_SEMI] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6523] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6524] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_EQ] = ACTIONS(12308),
    [anon_sym_COMMA] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_RPAREN] = ACTIONS(12308),
    [anon_sym_COLON2] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_in] = ACTIONS(12308),
    [anon_sym_SEMI] = ACTIONS(12308),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_isa] = ACTIONS(12308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12308),
    [anon_sym_QMARK] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__lazy_or_operator] = ACTIONS(12308),
    [sym__lazy_and_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [6525] = {
    [ts_builtin_sym_end] = ACTIONS(11894),
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_RBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12776),
    [sym__immediate_command_start] = ACTIONS(12778),
  },
  [6526] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [6527] = {
    [sym_identifier] = STATE(6776),
    [ts_builtin_sym_end] = ACTIONS(11994),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_as] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_RPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_RBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6528] = {
    [sym_identifier] = STATE(6777),
    [ts_builtin_sym_end] = ACTIONS(11956),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_as] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_RPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_RBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6529] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6530] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6531] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [6532] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6533] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6534] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6535] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_RPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_SEMI] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6536] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6537] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_RPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_SEMI] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6538] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_RPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_SEMI] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6539] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6540] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6541] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_RPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_SEMI] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6542] = {
    [sym_identifier] = STATE(6656),
    [ts_builtin_sym_end] = ACTIONS(12004),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_as] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_RPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_RBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6543] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_RPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6544] = {
    [sym_identifier] = STATE(6809),
    [ts_builtin_sym_end] = ACTIONS(12008),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_as] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_RPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_RBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6545] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6546] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_RPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_SEMI] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6547] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_RPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_SEMI] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6548] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_finally] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12620),
    [sym__immediate_bracket] = ACTIONS(12620),
    [sym__immediate_brace] = ACTIONS(12620),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6549] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_RPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_SEMI] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6550] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [6551] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6552] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_RPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_SEMI] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6553] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_RPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_SEMI] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6554] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12180),
    [anon_sym_DOT] = ACTIONS(12182),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12780),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__immediate_bracket] = ACTIONS(12188),
    [sym__immediate_brace] = ACTIONS(12190),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6555] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [6556] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_RPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_SEMI] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6557] = {
    [ts_builtin_sym_end] = ACTIONS(12676),
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_RBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6558] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6559] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_RPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_SEMI] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6560] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_RPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_SEMI] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6561] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6562] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12782),
    [sym__immediate_command_start] = ACTIONS(12784),
  },
  [6563] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_catch] = ACTIONS(12618),
    [anon_sym_finally] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12620),
    [sym__immediate_bracket] = ACTIONS(12620),
    [sym__immediate_brace] = ACTIONS(12620),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6564] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12786),
    [sym__immediate_command_start] = ACTIONS(12788),
  },
  [6565] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_elseif] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12770),
    [sym__immediate_command_start] = ACTIONS(12772),
  },
  [6566] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_RPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_SEMI] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6567] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_RPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_SEMI] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6568] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_RPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_SEMI] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6569] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12790),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_SQUOTE] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12792),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__assignment_operator] = ACTIONS(12794),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__immediate_bracket] = ACTIONS(12630),
    [sym__immediate_brace] = ACTIONS(12632),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6570] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_RPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_SEMI] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6571] = {
    [sym__word_identifier] = ACTIONS(12410),
    [anon_sym_EQ] = ACTIONS(12410),
    [anon_sym_COMMA] = ACTIONS(12410),
    [anon_sym_COLON] = ACTIONS(12410),
    [anon_sym_begin] = ACTIONS(12410),
    [anon_sym_module] = ACTIONS(12410),
    [anon_sym_baremodule] = ACTIONS(12410),
    [anon_sym_end] = ACTIONS(12410),
    [anon_sym_abstract] = ACTIONS(12410),
    [anon_sym_primitive] = ACTIONS(12410),
    [anon_sym_mutable] = ACTIONS(12410),
    [anon_sym_struct] = ACTIONS(12410),
    [anon_sym_function] = ACTIONS(12410),
    [anon_sym_macro] = ACTIONS(12410),
    [anon_sym_where] = ACTIONS(12410),
    [anon_sym_quote] = ACTIONS(12410),
    [anon_sym_let] = ACTIONS(12410),
    [anon_sym_if] = ACTIONS(12410),
    [anon_sym_try] = ACTIONS(12410),
    [anon_sym_for] = ACTIONS(12410),
    [anon_sym_while] = ACTIONS(12410),
    [sym_break_statement] = ACTIONS(12410),
    [sym_continue_statement] = ACTIONS(12410),
    [anon_sym_return] = ACTIONS(12410),
    [anon_sym_const] = ACTIONS(12410),
    [anon_sym_global] = ACTIONS(12410),
    [anon_sym_local] = ACTIONS(12410),
    [anon_sym_LPAREN] = ACTIONS(12410),
    [anon_sym_COLON2] = ACTIONS(12410),
    [anon_sym_export] = ACTIONS(12410),
    [anon_sym_import] = ACTIONS(12410),
    [anon_sym_using] = ACTIONS(12410),
    [anon_sym_LBRACK] = ACTIONS(12410),
    [anon_sym_LF] = ACTIONS(12476),
    [anon_sym_in] = ACTIONS(12410),
    [anon_sym_LBRACE] = ACTIONS(12410),
    [anon_sym_SQUOTE] = ACTIONS(12796),
    [anon_sym_DOT] = ACTIONS(12798),
    [anon_sym_DOLLAR] = ACTIONS(12410),
    [anon_sym_COLON_COLON] = ACTIONS(12410),
    [anon_sym_isa] = ACTIONS(12410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12410),
    [anon_sym_QMARK] = ACTIONS(12410),
    [anon_sym_AT] = ACTIONS(12410),
    [anon_sym_true] = ACTIONS(12410),
    [anon_sym_false] = ACTIONS(12410),
    [aux_sym_integer_literal_token1] = ACTIONS(12410),
    [aux_sym_integer_literal_token2] = ACTIONS(12410),
    [aux_sym_integer_literal_token3] = ACTIONS(12410),
    [aux_sym_integer_literal_token4] = ACTIONS(12410),
    [aux_sym_float_literal_token1] = ACTIONS(12410),
    [aux_sym_float_literal_token3] = ACTIONS(12410),
    [aux_sym_float_literal_token4] = ACTIONS(12410),
    [sym_character_literal] = ACTIONS(12410),
    [sym__pair_operator] = ACTIONS(12410),
    [sym__arrow_operator] = ACTIONS(12410),
    [sym__lazy_or_operator] = ACTIONS(12410),
    [sym__lazy_and_operator] = ACTIONS(12410),
    [sym__comparison_operator] = ACTIONS(12410),
    [sym__pipe_right_operator] = ACTIONS(12410),
    [sym__pipe_left_operator] = ACTIONS(12410),
    [sym__ellipsis_operator] = ACTIONS(12410),
    [sym__plus_operator] = ACTIONS(12410),
    [sym__times_operator] = ACTIONS(12410),
    [sym__rational_operator] = ACTIONS(12410),
    [sym__bitshift_operator] = ACTIONS(12410),
    [sym__power_operator] = ACTIONS(12410),
    [sym__tilde_operator] = ACTIONS(12410),
    [sym__type_order_operator] = ACTIONS(12410),
    [sym__unary_operator] = ACTIONS(12410),
    [sym__unary_plus_operator] = ACTIONS(12410),
    [aux_sym__terminator_token1] = ACTIONS(12410),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12800),
    [sym__immediate_bracket] = ACTIONS(12802),
    [sym__immediate_brace] = ACTIONS(12804),
    [sym__string_start] = ACTIONS(12476),
    [sym__command_start] = ACTIONS(12476),
  },
  [6572] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12676),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12676),
    [anon_sym_RPAREN] = ACTIONS(12676),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12676),
    [anon_sym_RBRACK] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12676),
    [anon_sym_LBRACE] = ACTIONS(12676),
    [anon_sym_RBRACE] = ACTIONS(12676),
    [anon_sym_DOT] = ACTIONS(12806),
    [anon_sym_DOLLAR] = ACTIONS(12676),
    [anon_sym_COLON_COLON] = ACTIONS(12676),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12676),
    [anon_sym_QMARK] = ACTIONS(12676),
    [anon_sym_AT] = ACTIONS(12676),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12676),
    [aux_sym_integer_literal_token2] = ACTIONS(12676),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12676),
    [aux_sym_float_literal_token3] = ACTIONS(12676),
    [aux_sym_float_literal_token4] = ACTIONS(12676),
    [sym_character_literal] = ACTIONS(12676),
    [sym__pair_operator] = ACTIONS(12676),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12676),
    [sym__lazy_and_operator] = ACTIONS(12676),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12676),
    [sym__pipe_left_operator] = ACTIONS(12676),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12676),
    [sym__bitshift_operator] = ACTIONS(12676),
    [sym__power_operator] = ACTIONS(12676),
    [sym__tilde_operator] = ACTIONS(12676),
    [sym__type_order_operator] = ACTIONS(12676),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6573] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6574] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_elseif] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6575] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_EQ] = ACTIONS(12338),
    [anon_sym_COMMA] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_RPAREN] = ACTIONS(12338),
    [anon_sym_COLON2] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_in] = ACTIONS(12338),
    [anon_sym_SEMI] = ACTIONS(12338),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_isa] = ACTIONS(12338),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12338),
    [anon_sym_QMARK] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__lazy_or_operator] = ACTIONS(12338),
    [sym__lazy_and_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [6576] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_EQ] = ACTIONS(12342),
    [anon_sym_COMMA] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_RPAREN] = ACTIONS(12342),
    [anon_sym_COLON2] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_in] = ACTIONS(12342),
    [anon_sym_SEMI] = ACTIONS(12342),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_isa] = ACTIONS(12342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12342),
    [anon_sym_QMARK] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__lazy_or_operator] = ACTIONS(12342),
    [sym__lazy_and_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [6577] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_EQ] = ACTIONS(11928),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_RPAREN] = ACTIONS(11928),
    [anon_sym_COLON2] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11928),
    [anon_sym_SEMI] = ACTIONS(11928),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_isa] = ACTIONS(11928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11928),
    [anon_sym_QMARK] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__lazy_or_operator] = ACTIONS(11928),
    [sym__lazy_and_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [6578] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_EQ] = ACTIONS(11932),
    [anon_sym_COMMA] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_RPAREN] = ACTIONS(11932),
    [anon_sym_COLON2] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_in] = ACTIONS(11932),
    [anon_sym_SEMI] = ACTIONS(11932),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_isa] = ACTIONS(11932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11932),
    [anon_sym_QMARK] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__lazy_or_operator] = ACTIONS(11932),
    [sym__lazy_and_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [6579] = {
    [sym__word_identifier] = ACTIONS(12558),
    [anon_sym_EQ] = ACTIONS(12558),
    [anon_sym_COMMA] = ACTIONS(12558),
    [anon_sym_COLON] = ACTIONS(12558),
    [anon_sym_begin] = ACTIONS(12558),
    [anon_sym_module] = ACTIONS(12558),
    [anon_sym_baremodule] = ACTIONS(12558),
    [anon_sym_end] = ACTIONS(12558),
    [anon_sym_abstract] = ACTIONS(12558),
    [anon_sym_primitive] = ACTIONS(12558),
    [anon_sym_mutable] = ACTIONS(12558),
    [anon_sym_struct] = ACTIONS(12558),
    [anon_sym_function] = ACTIONS(12558),
    [anon_sym_macro] = ACTIONS(12558),
    [anon_sym_where] = ACTIONS(12558),
    [anon_sym_quote] = ACTIONS(12558),
    [anon_sym_let] = ACTIONS(12558),
    [anon_sym_if] = ACTIONS(12558),
    [anon_sym_try] = ACTIONS(12558),
    [anon_sym_for] = ACTIONS(12558),
    [anon_sym_while] = ACTIONS(12558),
    [sym_break_statement] = ACTIONS(12558),
    [sym_continue_statement] = ACTIONS(12558),
    [anon_sym_return] = ACTIONS(12558),
    [anon_sym_const] = ACTIONS(12558),
    [anon_sym_global] = ACTIONS(12558),
    [anon_sym_local] = ACTIONS(12558),
    [anon_sym_LPAREN] = ACTIONS(12558),
    [anon_sym_COLON2] = ACTIONS(12558),
    [anon_sym_export] = ACTIONS(12558),
    [anon_sym_import] = ACTIONS(12558),
    [anon_sym_using] = ACTIONS(12558),
    [anon_sym_LBRACK] = ACTIONS(12558),
    [anon_sym_LF] = ACTIONS(12560),
    [anon_sym_in] = ACTIONS(12558),
    [anon_sym_LBRACE] = ACTIONS(12558),
    [anon_sym_SQUOTE] = ACTIONS(12796),
    [anon_sym_DOT] = ACTIONS(12798),
    [anon_sym_DOLLAR] = ACTIONS(12558),
    [anon_sym_COLON_COLON] = ACTIONS(12558),
    [anon_sym_isa] = ACTIONS(12558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12558),
    [anon_sym_QMARK] = ACTIONS(12558),
    [anon_sym_AT] = ACTIONS(12558),
    [anon_sym_true] = ACTIONS(12558),
    [anon_sym_false] = ACTIONS(12558),
    [aux_sym_integer_literal_token1] = ACTIONS(12558),
    [aux_sym_integer_literal_token2] = ACTIONS(12558),
    [aux_sym_integer_literal_token3] = ACTIONS(12558),
    [aux_sym_integer_literal_token4] = ACTIONS(12558),
    [aux_sym_float_literal_token1] = ACTIONS(12558),
    [aux_sym_float_literal_token3] = ACTIONS(12558),
    [aux_sym_float_literal_token4] = ACTIONS(12558),
    [sym_character_literal] = ACTIONS(12558),
    [sym__pair_operator] = ACTIONS(12558),
    [sym__arrow_operator] = ACTIONS(12558),
    [sym__lazy_or_operator] = ACTIONS(12558),
    [sym__lazy_and_operator] = ACTIONS(12558),
    [sym__comparison_operator] = ACTIONS(12558),
    [sym__pipe_right_operator] = ACTIONS(12558),
    [sym__pipe_left_operator] = ACTIONS(12558),
    [sym__ellipsis_operator] = ACTIONS(12558),
    [sym__plus_operator] = ACTIONS(12558),
    [sym__times_operator] = ACTIONS(12558),
    [sym__rational_operator] = ACTIONS(12558),
    [sym__bitshift_operator] = ACTIONS(12558),
    [sym__power_operator] = ACTIONS(12558),
    [sym__tilde_operator] = ACTIONS(12558),
    [sym__type_order_operator] = ACTIONS(12558),
    [sym__unary_operator] = ACTIONS(12558),
    [sym__unary_plus_operator] = ACTIONS(12558),
    [aux_sym__terminator_token1] = ACTIONS(12558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12800),
    [sym__immediate_bracket] = ACTIONS(12802),
    [sym__immediate_brace] = ACTIONS(12804),
    [sym__string_start] = ACTIONS(12560),
    [sym__command_start] = ACTIONS(12560),
  },
  [6580] = {
    [sym__word_identifier] = ACTIONS(12410),
    [anon_sym_EQ] = ACTIONS(12410),
    [anon_sym_COMMA] = ACTIONS(12410),
    [anon_sym_COLON] = ACTIONS(12410),
    [anon_sym_begin] = ACTIONS(12410),
    [anon_sym_module] = ACTIONS(12410),
    [anon_sym_baremodule] = ACTIONS(12410),
    [anon_sym_abstract] = ACTIONS(12410),
    [anon_sym_primitive] = ACTIONS(12410),
    [anon_sym_mutable] = ACTIONS(12410),
    [anon_sym_struct] = ACTIONS(12410),
    [anon_sym_function] = ACTIONS(12410),
    [anon_sym_macro] = ACTIONS(12410),
    [anon_sym_where] = ACTIONS(12410),
    [anon_sym_quote] = ACTIONS(12410),
    [anon_sym_let] = ACTIONS(12410),
    [anon_sym_if] = ACTIONS(12410),
    [anon_sym_try] = ACTIONS(12410),
    [anon_sym_for] = ACTIONS(12410),
    [anon_sym_while] = ACTIONS(12410),
    [sym_break_statement] = ACTIONS(12410),
    [sym_continue_statement] = ACTIONS(12410),
    [anon_sym_return] = ACTIONS(12410),
    [anon_sym_const] = ACTIONS(12410),
    [anon_sym_global] = ACTIONS(12410),
    [anon_sym_local] = ACTIONS(12410),
    [anon_sym_LPAREN] = ACTIONS(12410),
    [anon_sym_RPAREN] = ACTIONS(12410),
    [anon_sym_COLON2] = ACTIONS(12410),
    [anon_sym_export] = ACTIONS(12410),
    [anon_sym_import] = ACTIONS(12410),
    [anon_sym_using] = ACTIONS(12410),
    [anon_sym_LBRACK] = ACTIONS(12410),
    [anon_sym_LF] = ACTIONS(12476),
    [anon_sym_in] = ACTIONS(12410),
    [anon_sym_SEMI] = ACTIONS(12410),
    [anon_sym_LBRACE] = ACTIONS(12410),
    [anon_sym_SQUOTE] = ACTIONS(12808),
    [anon_sym_DOT] = ACTIONS(12810),
    [anon_sym_DOLLAR] = ACTIONS(12410),
    [anon_sym_COLON_COLON] = ACTIONS(12410),
    [anon_sym_isa] = ACTIONS(12410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12410),
    [anon_sym_QMARK] = ACTIONS(12410),
    [anon_sym_AT] = ACTIONS(12410),
    [anon_sym_true] = ACTIONS(12410),
    [anon_sym_false] = ACTIONS(12410),
    [aux_sym_integer_literal_token1] = ACTIONS(12410),
    [aux_sym_integer_literal_token2] = ACTIONS(12410),
    [aux_sym_integer_literal_token3] = ACTIONS(12410),
    [aux_sym_integer_literal_token4] = ACTIONS(12410),
    [aux_sym_float_literal_token1] = ACTIONS(12410),
    [aux_sym_float_literal_token3] = ACTIONS(12410),
    [aux_sym_float_literal_token4] = ACTIONS(12410),
    [sym_character_literal] = ACTIONS(12410),
    [sym__pair_operator] = ACTIONS(12410),
    [sym__arrow_operator] = ACTIONS(12410),
    [sym__lazy_or_operator] = ACTIONS(12410),
    [sym__lazy_and_operator] = ACTIONS(12410),
    [sym__comparison_operator] = ACTIONS(12410),
    [sym__pipe_right_operator] = ACTIONS(12410),
    [sym__pipe_left_operator] = ACTIONS(12410),
    [sym__ellipsis_operator] = ACTIONS(12410),
    [sym__plus_operator] = ACTIONS(12410),
    [sym__times_operator] = ACTIONS(12410),
    [sym__rational_operator] = ACTIONS(12410),
    [sym__bitshift_operator] = ACTIONS(12410),
    [sym__power_operator] = ACTIONS(12410),
    [sym__tilde_operator] = ACTIONS(12410),
    [sym__type_order_operator] = ACTIONS(12410),
    [sym__unary_operator] = ACTIONS(12410),
    [sym__unary_plus_operator] = ACTIONS(12410),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12812),
    [sym__immediate_bracket] = ACTIONS(12814),
    [sym__immediate_brace] = ACTIONS(12816),
    [sym__string_start] = ACTIONS(12476),
    [sym__command_start] = ACTIONS(12476),
  },
  [6581] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6582] = {
    [ts_builtin_sym_end] = ACTIONS(11890),
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_RBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12776),
    [sym__immediate_command_start] = ACTIONS(12778),
  },
  [6583] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_SQUOTE] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12818),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__assignment_operator] = ACTIONS(12820),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__immediate_bracket] = ACTIONS(12630),
    [sym__immediate_brace] = ACTIONS(12632),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6584] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_SQUOTE] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12818),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__assignment_operator] = ACTIONS(12820),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__immediate_bracket] = ACTIONS(12630),
    [sym__immediate_brace] = ACTIONS(12632),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6585] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12822),
    [sym__immediate_command_start] = ACTIONS(12824),
  },
  [6586] = {
    [sym_identifier] = STATE(6682),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_elseif] = ACTIONS(11992),
    [anon_sym_else] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_as] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6587] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_EQ] = ACTIONS(12360),
    [anon_sym_COMMA] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_RPAREN] = ACTIONS(12360),
    [anon_sym_COLON2] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_in] = ACTIONS(12360),
    [anon_sym_SEMI] = ACTIONS(12360),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_isa] = ACTIONS(12360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12360),
    [anon_sym_QMARK] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__lazy_or_operator] = ACTIONS(12360),
    [sym__lazy_and_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [6588] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_SQUOTE] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12734),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__assignment_operator] = ACTIONS(12736),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__immediate_bracket] = ACTIONS(12630),
    [sym__immediate_brace] = ACTIONS(12632),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6589] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_EQ] = ACTIONS(12364),
    [anon_sym_COMMA] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_RPAREN] = ACTIONS(12364),
    [anon_sym_COLON2] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_in] = ACTIONS(12364),
    [anon_sym_SEMI] = ACTIONS(12364),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_isa] = ACTIONS(12364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12364),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__lazy_or_operator] = ACTIONS(12364),
    [sym__lazy_and_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [6590] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12654),
    [anon_sym_DOT] = ACTIONS(12716),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12718),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12660),
    [sym__immediate_bracket] = ACTIONS(12662),
    [sym__immediate_brace] = ACTIONS(12664),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6591] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_EQ] = ACTIONS(12136),
    [anon_sym_COMMA] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_RPAREN] = ACTIONS(12136),
    [anon_sym_COLON2] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_in] = ACTIONS(12136),
    [anon_sym_SEMI] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_isa] = ACTIONS(12136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12136),
    [anon_sym_QMARK] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__lazy_or_operator] = ACTIONS(12136),
    [sym__lazy_and_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [6592] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_EQ] = ACTIONS(11916),
    [anon_sym_COMMA] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_RPAREN] = ACTIONS(11916),
    [anon_sym_COLON2] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_in] = ACTIONS(11916),
    [anon_sym_SEMI] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_isa] = ACTIONS(11916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11916),
    [anon_sym_QMARK] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__lazy_or_operator] = ACTIONS(11916),
    [sym__lazy_and_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [6593] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6594] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_RPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_SEMI] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [6595] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_EQ] = ACTIONS(12174),
    [anon_sym_COMMA] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_RPAREN] = ACTIONS(12174),
    [anon_sym_COLON2] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_in] = ACTIONS(12174),
    [anon_sym_SEMI] = ACTIONS(12174),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_isa] = ACTIONS(12174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12174),
    [anon_sym_QMARK] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__lazy_or_operator] = ACTIONS(12174),
    [sym__lazy_and_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [6596] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12822),
    [sym__immediate_command_start] = ACTIONS(12824),
  },
  [6597] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_RPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_SEMI] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6598] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12826),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6599] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_RPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_SEMI] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [6600] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6601] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_RPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_SEMI] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6602] = {
    [ts_builtin_sym_end] = ACTIONS(11864),
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6603] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12828),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6604] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12830),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6605] = {
    [sym__word_identifier] = ACTIONS(12558),
    [anon_sym_EQ] = ACTIONS(12558),
    [anon_sym_COMMA] = ACTIONS(12558),
    [anon_sym_COLON] = ACTIONS(12558),
    [anon_sym_begin] = ACTIONS(12558),
    [anon_sym_module] = ACTIONS(12558),
    [anon_sym_baremodule] = ACTIONS(12558),
    [anon_sym_abstract] = ACTIONS(12558),
    [anon_sym_primitive] = ACTIONS(12558),
    [anon_sym_mutable] = ACTIONS(12558),
    [anon_sym_struct] = ACTIONS(12558),
    [anon_sym_function] = ACTIONS(12558),
    [anon_sym_macro] = ACTIONS(12558),
    [anon_sym_where] = ACTIONS(12558),
    [anon_sym_quote] = ACTIONS(12558),
    [anon_sym_let] = ACTIONS(12558),
    [anon_sym_if] = ACTIONS(12558),
    [anon_sym_try] = ACTIONS(12558),
    [anon_sym_for] = ACTIONS(12558),
    [anon_sym_while] = ACTIONS(12558),
    [sym_break_statement] = ACTIONS(12558),
    [sym_continue_statement] = ACTIONS(12558),
    [anon_sym_return] = ACTIONS(12558),
    [anon_sym_const] = ACTIONS(12558),
    [anon_sym_global] = ACTIONS(12558),
    [anon_sym_local] = ACTIONS(12558),
    [anon_sym_LPAREN] = ACTIONS(12558),
    [anon_sym_RPAREN] = ACTIONS(12558),
    [anon_sym_COLON2] = ACTIONS(12558),
    [anon_sym_export] = ACTIONS(12558),
    [anon_sym_import] = ACTIONS(12558),
    [anon_sym_using] = ACTIONS(12558),
    [anon_sym_LBRACK] = ACTIONS(12558),
    [anon_sym_LF] = ACTIONS(12560),
    [anon_sym_in] = ACTIONS(12558),
    [anon_sym_SEMI] = ACTIONS(12558),
    [anon_sym_LBRACE] = ACTIONS(12558),
    [anon_sym_SQUOTE] = ACTIONS(12808),
    [anon_sym_DOT] = ACTIONS(12810),
    [anon_sym_DOLLAR] = ACTIONS(12558),
    [anon_sym_COLON_COLON] = ACTIONS(12558),
    [anon_sym_isa] = ACTIONS(12558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12558),
    [anon_sym_QMARK] = ACTIONS(12558),
    [anon_sym_AT] = ACTIONS(12558),
    [anon_sym_true] = ACTIONS(12558),
    [anon_sym_false] = ACTIONS(12558),
    [aux_sym_integer_literal_token1] = ACTIONS(12558),
    [aux_sym_integer_literal_token2] = ACTIONS(12558),
    [aux_sym_integer_literal_token3] = ACTIONS(12558),
    [aux_sym_integer_literal_token4] = ACTIONS(12558),
    [aux_sym_float_literal_token1] = ACTIONS(12558),
    [aux_sym_float_literal_token3] = ACTIONS(12558),
    [aux_sym_float_literal_token4] = ACTIONS(12558),
    [sym_character_literal] = ACTIONS(12558),
    [sym__pair_operator] = ACTIONS(12558),
    [sym__arrow_operator] = ACTIONS(12558),
    [sym__lazy_or_operator] = ACTIONS(12558),
    [sym__lazy_and_operator] = ACTIONS(12558),
    [sym__comparison_operator] = ACTIONS(12558),
    [sym__pipe_right_operator] = ACTIONS(12558),
    [sym__pipe_left_operator] = ACTIONS(12558),
    [sym__ellipsis_operator] = ACTIONS(12558),
    [sym__plus_operator] = ACTIONS(12558),
    [sym__times_operator] = ACTIONS(12558),
    [sym__rational_operator] = ACTIONS(12558),
    [sym__bitshift_operator] = ACTIONS(12558),
    [sym__power_operator] = ACTIONS(12558),
    [sym__tilde_operator] = ACTIONS(12558),
    [sym__type_order_operator] = ACTIONS(12558),
    [sym__unary_operator] = ACTIONS(12558),
    [sym__unary_plus_operator] = ACTIONS(12558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12812),
    [sym__immediate_bracket] = ACTIONS(12814),
    [sym__immediate_brace] = ACTIONS(12816),
    [sym__string_start] = ACTIONS(12560),
    [sym__command_start] = ACTIONS(12560),
  },
  [6606] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11890),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11890),
    [anon_sym_RPAREN] = ACTIONS(11890),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11890),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11890),
    [anon_sym_RBRACE] = ACTIONS(11890),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11890),
    [anon_sym_COLON_COLON] = ACTIONS(11890),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11890),
    [anon_sym_QMARK] = ACTIONS(11890),
    [anon_sym_AT] = ACTIONS(11890),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11890),
    [aux_sym_integer_literal_token2] = ACTIONS(11890),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11890),
    [aux_sym_float_literal_token3] = ACTIONS(11890),
    [aux_sym_float_literal_token4] = ACTIONS(11890),
    [sym_character_literal] = ACTIONS(11890),
    [sym__pair_operator] = ACTIONS(11890),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11890),
    [sym__lazy_and_operator] = ACTIONS(11890),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11890),
    [sym__pipe_left_operator] = ACTIONS(11890),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11890),
    [sym__bitshift_operator] = ACTIONS(11890),
    [sym__power_operator] = ACTIONS(11890),
    [sym__tilde_operator] = ACTIONS(11890),
    [sym__type_order_operator] = ACTIONS(11890),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12832),
    [sym__immediate_command_start] = ACTIONS(12834),
  },
  [6607] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6608] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6609] = {
    [sym_identifier] = STATE(6683),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_elseif] = ACTIONS(11958),
    [anon_sym_else] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_as] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6610] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6611] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6612] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_RPAREN] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_RBRACE] = ACTIONS(11864),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11864),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11864),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11864),
    [sym__pipe_left_operator] = ACTIONS(11864),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11864),
    [sym__bitshift_operator] = ACTIONS(11864),
    [sym__power_operator] = ACTIONS(11864),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11864),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6613] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6614] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(12214),
    [anon_sym_COMMA] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_COLON2] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_in] = ACTIONS(12214),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_isa] = ACTIONS(12214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12214),
    [anon_sym_QMARK] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__lazy_or_operator] = ACTIONS(12214),
    [sym__lazy_and_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [6615] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_RPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_SEMI] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6616] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_RPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_SEMI] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6617] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(12218),
    [anon_sym_COMMA] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_in] = ACTIONS(12218),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_isa] = ACTIONS(12218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12218),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__lazy_or_operator] = ACTIONS(12218),
    [sym__lazy_and_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [6618] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6619] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12766),
    [sym__immediate_command_start] = ACTIONS(12768),
  },
  [6620] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6621] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11894),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11894),
    [anon_sym_RPAREN] = ACTIONS(11894),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11894),
    [anon_sym_RBRACK] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11894),
    [anon_sym_RBRACE] = ACTIONS(11894),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11894),
    [anon_sym_COLON_COLON] = ACTIONS(11894),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11894),
    [anon_sym_QMARK] = ACTIONS(11894),
    [anon_sym_AT] = ACTIONS(11894),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11894),
    [aux_sym_integer_literal_token2] = ACTIONS(11894),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11894),
    [aux_sym_float_literal_token3] = ACTIONS(11894),
    [aux_sym_float_literal_token4] = ACTIONS(11894),
    [sym_character_literal] = ACTIONS(11894),
    [sym__pair_operator] = ACTIONS(11894),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11894),
    [sym__lazy_and_operator] = ACTIONS(11894),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11894),
    [sym__pipe_left_operator] = ACTIONS(11894),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11894),
    [sym__bitshift_operator] = ACTIONS(11894),
    [sym__power_operator] = ACTIONS(11894),
    [sym__tilde_operator] = ACTIONS(11894),
    [sym__type_order_operator] = ACTIONS(11894),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12832),
    [sym__immediate_command_start] = ACTIONS(12834),
  },
  [6622] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_elseif] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6623] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12782),
    [sym__immediate_command_start] = ACTIONS(12784),
  },
  [6624] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6625] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_EQ] = ACTIONS(12326),
    [anon_sym_COMMA] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_COLON2] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_in] = ACTIONS(12326),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_isa] = ACTIONS(12326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12326),
    [anon_sym_QMARK] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__lazy_or_operator] = ACTIONS(12326),
    [sym__lazy_and_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [6626] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6627] = {
    [sym_identifier] = STATE(6691),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_elseif] = ACTIONS(12002),
    [anon_sym_else] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_as] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6628] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12836),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6629] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12786),
    [sym__immediate_command_start] = ACTIONS(12788),
  },
  [6630] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12838),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12180),
    [anon_sym_DOT] = ACTIONS(12420),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12840),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__immediate_bracket] = ACTIONS(12188),
    [sym__immediate_brace] = ACTIONS(12190),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6631] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12688),
    [anon_sym_DOT] = ACTIONS(12726),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12728),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12694),
    [sym__immediate_bracket] = ACTIONS(12696),
    [sym__immediate_brace] = ACTIONS(12698),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6632] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_RPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_SEMI] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6633] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [6634] = {
    [ts_builtin_sym_end] = ACTIONS(12208),
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_as] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_RPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_RBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6635] = {
    [sym_identifier] = STATE(7212),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_catch] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_as] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6636] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12676),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12676),
    [anon_sym_RPAREN] = ACTIONS(12676),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12676),
    [anon_sym_RBRACK] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12676),
    [anon_sym_LBRACE] = ACTIONS(12676),
    [anon_sym_RBRACE] = ACTIONS(12676),
    [anon_sym_DOLLAR] = ACTIONS(12676),
    [anon_sym_COLON_COLON] = ACTIONS(12676),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12676),
    [anon_sym_QMARK] = ACTIONS(12676),
    [anon_sym_AT] = ACTIONS(12676),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12676),
    [aux_sym_integer_literal_token2] = ACTIONS(12676),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12676),
    [aux_sym_float_literal_token3] = ACTIONS(12676),
    [aux_sym_float_literal_token4] = ACTIONS(12676),
    [sym_character_literal] = ACTIONS(12676),
    [sym__pair_operator] = ACTIONS(12676),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12676),
    [sym__lazy_and_operator] = ACTIONS(12676),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12676),
    [sym__pipe_left_operator] = ACTIONS(12676),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12676),
    [sym__bitshift_operator] = ACTIONS(12676),
    [sym__power_operator] = ACTIONS(12676),
    [sym__tilde_operator] = ACTIONS(12676),
    [sym__type_order_operator] = ACTIONS(12676),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6637] = {
    [sym_identifier] = STATE(7222),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_catch] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_as] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6638] = {
    [sym_identifier] = STATE(7223),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_catch] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_as] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6639] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6640] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6641] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6642] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_elseif] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_as] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6643] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12764),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6644] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6645] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12842),
    [sym__immediate_command_start] = ACTIONS(12844),
  },
  [6646] = {
    [sym_identifier] = STATE(6974),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11994),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_as] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11994),
    [anon_sym_RPAREN] = ACTIONS(11994),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11994),
    [anon_sym_RBRACK] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_SEMI] = ACTIONS(11994),
    [anon_sym_LBRACE] = ACTIONS(11994),
    [anon_sym_RBRACE] = ACTIONS(11994),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11994),
    [anon_sym_COLON_COLON] = ACTIONS(11994),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11994),
    [anon_sym_QMARK] = ACTIONS(11994),
    [anon_sym_AT] = ACTIONS(11994),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11994),
    [aux_sym_integer_literal_token2] = ACTIONS(11994),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11994),
    [aux_sym_float_literal_token3] = ACTIONS(11994),
    [aux_sym_float_literal_token4] = ACTIONS(11994),
    [sym_character_literal] = ACTIONS(11994),
    [sym__pair_operator] = ACTIONS(11994),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11994),
    [sym__lazy_and_operator] = ACTIONS(11994),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11994),
    [sym__pipe_left_operator] = ACTIONS(11994),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11994),
    [sym__bitshift_operator] = ACTIONS(11994),
    [sym__power_operator] = ACTIONS(11994),
    [sym__tilde_operator] = ACTIONS(11994),
    [sym__type_order_operator] = ACTIONS(11994),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6647] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_elseif] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_as] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6648] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_elseif] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_as] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6649] = {
    [sym_identifier] = STATE(6992),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11956),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_as] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11956),
    [anon_sym_RPAREN] = ACTIONS(11956),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11956),
    [anon_sym_RBRACK] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_SEMI] = ACTIONS(11956),
    [anon_sym_LBRACE] = ACTIONS(11956),
    [anon_sym_RBRACE] = ACTIONS(11956),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11956),
    [anon_sym_COLON_COLON] = ACTIONS(11956),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11956),
    [anon_sym_QMARK] = ACTIONS(11956),
    [anon_sym_AT] = ACTIONS(11956),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11956),
    [aux_sym_integer_literal_token2] = ACTIONS(11956),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11956),
    [aux_sym_float_literal_token3] = ACTIONS(11956),
    [aux_sym_float_literal_token4] = ACTIONS(11956),
    [sym_character_literal] = ACTIONS(11956),
    [sym__pair_operator] = ACTIONS(11956),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11956),
    [sym__lazy_and_operator] = ACTIONS(11956),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11956),
    [sym__pipe_left_operator] = ACTIONS(11956),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11956),
    [sym__bitshift_operator] = ACTIONS(11956),
    [sym__power_operator] = ACTIONS(11956),
    [sym__tilde_operator] = ACTIONS(11956),
    [sym__type_order_operator] = ACTIONS(11956),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6650] = {
    [ts_builtin_sym_end] = ACTIONS(12176),
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_as] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_RPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_RBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6651] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_SQUOTE] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12792),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__assignment_operator] = ACTIONS(12794),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__immediate_bracket] = ACTIONS(12630),
    [sym__immediate_brace] = ACTIONS(12632),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6652] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_else] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_as] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6653] = {
    [sym_identifier] = STATE(7048),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_catch] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_as] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6654] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12830),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6655] = {
    [ts_builtin_sym_end] = ACTIONS(12164),
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_as] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6656] = {
    [ts_builtin_sym_end] = ACTIONS(12156),
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_as] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_RPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_RBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6657] = {
    [sym_identifier] = STATE(6977),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_else] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6658] = {
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6659] = {
    [ts_builtin_sym_end] = ACTIONS(11864),
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [6660] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6661] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_elseif] = ACTIONS(12236),
    [anon_sym_else] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_as] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6662] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_elseif] = ACTIONS(12240),
    [anon_sym_else] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_as] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6663] = {
    [ts_builtin_sym_end] = ACTIONS(12390),
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_as] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_RPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_RBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6664] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_elseif] = ACTIONS(12244),
    [anon_sym_else] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_as] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6665] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_as] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6666] = {
    [sym_identifier] = STATE(7043),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12004),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_as] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12004),
    [anon_sym_RPAREN] = ACTIONS(12004),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12004),
    [anon_sym_RBRACK] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_SEMI] = ACTIONS(12004),
    [anon_sym_LBRACE] = ACTIONS(12004),
    [anon_sym_RBRACE] = ACTIONS(12004),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12004),
    [anon_sym_COLON_COLON] = ACTIONS(12004),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12004),
    [anon_sym_QMARK] = ACTIONS(12004),
    [anon_sym_AT] = ACTIONS(12004),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12004),
    [aux_sym_integer_literal_token2] = ACTIONS(12004),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12004),
    [aux_sym_float_literal_token3] = ACTIONS(12004),
    [aux_sym_float_literal_token4] = ACTIONS(12004),
    [sym_character_literal] = ACTIONS(12004),
    [sym__pair_operator] = ACTIONS(12004),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12004),
    [sym__lazy_and_operator] = ACTIONS(12004),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12004),
    [sym__pipe_left_operator] = ACTIONS(12004),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12004),
    [sym__bitshift_operator] = ACTIONS(12004),
    [sym__power_operator] = ACTIONS(12004),
    [sym__tilde_operator] = ACTIONS(12004),
    [sym__type_order_operator] = ACTIONS(12004),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6667] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_elseif] = ACTIONS(12248),
    [anon_sym_else] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_as] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6668] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_elseif] = ACTIONS(12252),
    [anon_sym_else] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_as] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6669] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_as] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6670] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_as] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6671] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_elseif] = ACTIONS(12256),
    [anon_sym_else] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_as] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6672] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_elseif] = ACTIONS(12260),
    [anon_sym_else] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_as] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6673] = {
    [sym__word_identifier] = ACTIONS(12846),
    [anon_sym_EQ] = ACTIONS(12846),
    [anon_sym_COMMA] = ACTIONS(12846),
    [anon_sym_COLON] = ACTIONS(12846),
    [anon_sym_begin] = ACTIONS(12846),
    [anon_sym_module] = ACTIONS(12846),
    [anon_sym_baremodule] = ACTIONS(12846),
    [anon_sym_end] = ACTIONS(12846),
    [anon_sym_abstract] = ACTIONS(12846),
    [anon_sym_primitive] = ACTIONS(12846),
    [anon_sym_mutable] = ACTIONS(12846),
    [anon_sym_struct] = ACTIONS(12846),
    [anon_sym_function] = ACTIONS(12846),
    [anon_sym_macro] = ACTIONS(12846),
    [anon_sym_where] = ACTIONS(12846),
    [anon_sym_quote] = ACTIONS(12846),
    [anon_sym_let] = ACTIONS(12846),
    [anon_sym_if] = ACTIONS(12846),
    [anon_sym_elseif] = ACTIONS(12846),
    [anon_sym_else] = ACTIONS(12846),
    [anon_sym_try] = ACTIONS(12846),
    [anon_sym_for] = ACTIONS(12846),
    [anon_sym_while] = ACTIONS(12846),
    [sym_break_statement] = ACTIONS(12846),
    [sym_continue_statement] = ACTIONS(12846),
    [anon_sym_return] = ACTIONS(12846),
    [anon_sym_const] = ACTIONS(12846),
    [anon_sym_global] = ACTIONS(12846),
    [anon_sym_local] = ACTIONS(12846),
    [anon_sym_as] = ACTIONS(12846),
    [anon_sym_LPAREN] = ACTIONS(12846),
    [anon_sym_COLON2] = ACTIONS(12846),
    [anon_sym_export] = ACTIONS(12846),
    [anon_sym_import] = ACTIONS(12846),
    [anon_sym_using] = ACTIONS(12846),
    [anon_sym_LBRACK] = ACTIONS(12846),
    [anon_sym_LF] = ACTIONS(12848),
    [anon_sym_in] = ACTIONS(12846),
    [anon_sym_LBRACE] = ACTIONS(12846),
    [anon_sym_DOT] = ACTIONS(12850),
    [anon_sym_DOLLAR] = ACTIONS(12846),
    [anon_sym_COLON_COLON] = ACTIONS(12846),
    [anon_sym_isa] = ACTIONS(12846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12846),
    [anon_sym_QMARK] = ACTIONS(12846),
    [anon_sym_AT] = ACTIONS(12846),
    [anon_sym_true] = ACTIONS(12846),
    [anon_sym_false] = ACTIONS(12846),
    [aux_sym_integer_literal_token1] = ACTIONS(12846),
    [aux_sym_integer_literal_token2] = ACTIONS(12846),
    [aux_sym_integer_literal_token3] = ACTIONS(12846),
    [aux_sym_integer_literal_token4] = ACTIONS(12846),
    [aux_sym_float_literal_token1] = ACTIONS(12846),
    [aux_sym_float_literal_token3] = ACTIONS(12846),
    [aux_sym_float_literal_token4] = ACTIONS(12846),
    [sym_character_literal] = ACTIONS(12846),
    [sym__pair_operator] = ACTIONS(12846),
    [sym__arrow_operator] = ACTIONS(12846),
    [sym__lazy_or_operator] = ACTIONS(12846),
    [sym__lazy_and_operator] = ACTIONS(12846),
    [sym__comparison_operator] = ACTIONS(12846),
    [sym__pipe_right_operator] = ACTIONS(12846),
    [sym__pipe_left_operator] = ACTIONS(12846),
    [sym__ellipsis_operator] = ACTIONS(12846),
    [sym__plus_operator] = ACTIONS(12846),
    [sym__times_operator] = ACTIONS(12846),
    [sym__rational_operator] = ACTIONS(12846),
    [sym__bitshift_operator] = ACTIONS(12846),
    [sym__power_operator] = ACTIONS(12846),
    [sym__tilde_operator] = ACTIONS(12846),
    [sym__type_order_operator] = ACTIONS(12846),
    [sym__unary_operator] = ACTIONS(12846),
    [sym__unary_plus_operator] = ACTIONS(12846),
    [aux_sym__terminator_token1] = ACTIONS(12846),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12848),
    [sym__command_start] = ACTIONS(12848),
  },
  [6674] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11890),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11890),
    [anon_sym_RPAREN] = ACTIONS(11890),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11890),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11890),
    [anon_sym_RBRACE] = ACTIONS(11890),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11890),
    [anon_sym_COLON_COLON] = ACTIONS(11890),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11890),
    [anon_sym_QMARK] = ACTIONS(11890),
    [anon_sym_AT] = ACTIONS(11890),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11890),
    [aux_sym_integer_literal_token2] = ACTIONS(11890),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11890),
    [aux_sym_float_literal_token3] = ACTIONS(11890),
    [aux_sym_float_literal_token4] = ACTIONS(11890),
    [sym_character_literal] = ACTIONS(11890),
    [sym__pair_operator] = ACTIONS(11890),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11890),
    [sym__lazy_and_operator] = ACTIONS(11890),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11890),
    [sym__pipe_left_operator] = ACTIONS(11890),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11890),
    [sym__bitshift_operator] = ACTIONS(11890),
    [sym__power_operator] = ACTIONS(11890),
    [sym__tilde_operator] = ACTIONS(11890),
    [sym__type_order_operator] = ACTIONS(11890),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12852),
    [sym__immediate_command_start] = ACTIONS(12854),
  },
  [6675] = {
    [sym_identifier] = STATE(7047),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12008),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_as] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12008),
    [anon_sym_RPAREN] = ACTIONS(12008),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12008),
    [anon_sym_RBRACK] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_SEMI] = ACTIONS(12008),
    [anon_sym_LBRACE] = ACTIONS(12008),
    [anon_sym_RBRACE] = ACTIONS(12008),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12008),
    [anon_sym_COLON_COLON] = ACTIONS(12008),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12008),
    [anon_sym_QMARK] = ACTIONS(12008),
    [anon_sym_AT] = ACTIONS(12008),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12008),
    [aux_sym_integer_literal_token2] = ACTIONS(12008),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12008),
    [aux_sym_float_literal_token3] = ACTIONS(12008),
    [aux_sym_float_literal_token4] = ACTIONS(12008),
    [sym_character_literal] = ACTIONS(12008),
    [sym__pair_operator] = ACTIONS(12008),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12008),
    [sym__lazy_and_operator] = ACTIONS(12008),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12008),
    [sym__pipe_left_operator] = ACTIONS(12008),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12008),
    [sym__bitshift_operator] = ACTIONS(12008),
    [sym__power_operator] = ACTIONS(12008),
    [sym__tilde_operator] = ACTIONS(12008),
    [sym__type_order_operator] = ACTIONS(12008),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6676] = {
    [ts_builtin_sym_end] = ACTIONS(12302),
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_as] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_RPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_RBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6677] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_elseif] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_as] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6678] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_elseif] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_as] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6679] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_elseif] = ACTIONS(12264),
    [anon_sym_else] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_as] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6680] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_elseif] = ACTIONS(12268),
    [anon_sym_else] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_as] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6681] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_elseif] = ACTIONS(12272),
    [anon_sym_else] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_as] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6682] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_elseif] = ACTIONS(12276),
    [anon_sym_else] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_as] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6683] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_elseif] = ACTIONS(12280),
    [anon_sym_else] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_as] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6684] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6685] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_elseif] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_as] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6686] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_elseif] = ACTIONS(12284),
    [anon_sym_else] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_as] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6687] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_elseif] = ACTIONS(12142),
    [anon_sym_else] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_as] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6688] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_elseif] = ACTIONS(12146),
    [anon_sym_else] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_as] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6689] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_elseif] = ACTIONS(12150),
    [anon_sym_else] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_as] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6690] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6691] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_elseif] = ACTIONS(12158),
    [anon_sym_else] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_as] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6692] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_elseif] = ACTIONS(12162),
    [anon_sym_else] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_as] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6693] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_elseif] = ACTIONS(12210),
    [anon_sym_else] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_as] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6694] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_elseif] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_as] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6695] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6696] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_elseif] = ACTIONS(12170),
    [anon_sym_else] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_as] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6697] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_elseif] = ACTIONS(12178),
    [anon_sym_else] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_as] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6698] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_elseif] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12850),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6699] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_else] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_as] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6700] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_elseif] = ACTIONS(12292),
    [anon_sym_else] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_as] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6701] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_else] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_as] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6702] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12856),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6703] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6704] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_else] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_as] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6705] = {
    [ts_builtin_sym_end] = ACTIONS(12234),
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_as] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_RPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_RBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6706] = {
    [ts_builtin_sym_end] = ACTIONS(12238),
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_as] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_RPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_RBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6707] = {
    [ts_builtin_sym_end] = ACTIONS(11890),
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_RBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6708] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_elseif] = ACTIONS(12300),
    [anon_sym_else] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_as] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6709] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_else] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_as] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6710] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_else] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_as] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6711] = {
    [ts_builtin_sym_end] = ACTIONS(12242),
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_as] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_RPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_RBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6712] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_else] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_as] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6713] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_else] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_as] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6714] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_else] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_as] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6715] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12858),
    [sym__immediate_command_start] = ACTIONS(12860),
  },
  [6716] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_as] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6717] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_as] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6718] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_else] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_as] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6719] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_else] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_as] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6720] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_else] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_as] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6721] = {
    [aux_sym__import_list_repeat1] = STATE(6990),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(12864),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_elseif] = ACTIONS(12862),
    [anon_sym_else] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(12866),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [6722] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_else] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_as] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6723] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_else] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_as] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6724] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_elseif] = ACTIONS(12304),
    [anon_sym_else] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_as] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6725] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_else] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_as] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6726] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_as] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6727] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_else] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_as] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6728] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_else] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_as] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6729] = {
    [ts_builtin_sym_end] = ACTIONS(12620),
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_as] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_RPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_RBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6730] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_else] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_as] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6731] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_else] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_as] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6732] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_else] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_as] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6733] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_else] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_as] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6734] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_else] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_as] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6735] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12870),
    [sym__immediate_command_start] = ACTIONS(12872),
  },
  [6736] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_as] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6737] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_else] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_as] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6738] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_else] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_as] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6739] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12874),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6740] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_elseif] = ACTIONS(12154),
    [anon_sym_else] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_as] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6741] = {
    [sym_identifier] = STATE(7051),
    [ts_builtin_sym_end] = ACTIONS(11994),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_RPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_RBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6742] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12688),
    [anon_sym_DOT] = ACTIONS(12726),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12876),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12694),
    [sym__immediate_bracket] = ACTIONS(12696),
    [sym__immediate_brace] = ACTIONS(12698),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6743] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12620),
    [sym__immediate_bracket] = ACTIONS(12620),
    [sym__immediate_brace] = ACTIONS(12620),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6744] = {
    [ts_builtin_sym_end] = ACTIONS(12246),
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_as] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_RPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_RBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6745] = {
    [ts_builtin_sym_end] = ACTIONS(12250),
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_as] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_RPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_RBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6746] = {
    [ts_builtin_sym_end] = ACTIONS(12324),
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_as] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_RPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6747] = {
    [ts_builtin_sym_end] = ACTIONS(12254),
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_as] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_RPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_RBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6748] = {
    [ts_builtin_sym_end] = ACTIONS(12258),
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_as] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_RPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_RBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6749] = {
    [sym_identifier] = STATE(7120),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_catch] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_as] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6750] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_SQUOTE] = ACTIONS(12180),
    [anon_sym_DOT] = ACTIONS(12420),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__assignment_operator] = ACTIONS(12840),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__immediate_bracket] = ACTIONS(12188),
    [sym__immediate_brace] = ACTIONS(12190),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6751] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12878),
    [sym__immediate_command_start] = ACTIONS(12880),
  },
  [6752] = {
    [sym__word_identifier] = ACTIONS(12882),
    [anon_sym_EQ] = ACTIONS(12882),
    [anon_sym_COMMA] = ACTIONS(12882),
    [anon_sym_COLON] = ACTIONS(12882),
    [anon_sym_begin] = ACTIONS(12882),
    [anon_sym_module] = ACTIONS(12882),
    [anon_sym_baremodule] = ACTIONS(12882),
    [anon_sym_end] = ACTIONS(12882),
    [anon_sym_abstract] = ACTIONS(12882),
    [anon_sym_primitive] = ACTIONS(12882),
    [anon_sym_mutable] = ACTIONS(12882),
    [anon_sym_struct] = ACTIONS(12882),
    [anon_sym_function] = ACTIONS(12882),
    [anon_sym_macro] = ACTIONS(12882),
    [anon_sym_where] = ACTIONS(12882),
    [anon_sym_quote] = ACTIONS(12882),
    [anon_sym_let] = ACTIONS(12882),
    [anon_sym_if] = ACTIONS(12882),
    [anon_sym_elseif] = ACTIONS(12882),
    [anon_sym_else] = ACTIONS(12882),
    [anon_sym_try] = ACTIONS(12882),
    [anon_sym_for] = ACTIONS(12882),
    [anon_sym_while] = ACTIONS(12882),
    [sym_break_statement] = ACTIONS(12882),
    [sym_continue_statement] = ACTIONS(12882),
    [anon_sym_return] = ACTIONS(12882),
    [anon_sym_const] = ACTIONS(12882),
    [anon_sym_global] = ACTIONS(12882),
    [anon_sym_local] = ACTIONS(12882),
    [anon_sym_as] = ACTIONS(12882),
    [anon_sym_LPAREN] = ACTIONS(12882),
    [anon_sym_COLON2] = ACTIONS(12882),
    [anon_sym_export] = ACTIONS(12882),
    [anon_sym_import] = ACTIONS(12882),
    [anon_sym_using] = ACTIONS(12882),
    [anon_sym_LBRACK] = ACTIONS(12882),
    [anon_sym_LF] = ACTIONS(12884),
    [anon_sym_in] = ACTIONS(12882),
    [anon_sym_LBRACE] = ACTIONS(12882),
    [anon_sym_DOT] = ACTIONS(12850),
    [anon_sym_DOLLAR] = ACTIONS(12882),
    [anon_sym_COLON_COLON] = ACTIONS(12882),
    [anon_sym_isa] = ACTIONS(12882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12882),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_AT] = ACTIONS(12882),
    [anon_sym_true] = ACTIONS(12882),
    [anon_sym_false] = ACTIONS(12882),
    [aux_sym_integer_literal_token1] = ACTIONS(12882),
    [aux_sym_integer_literal_token2] = ACTIONS(12882),
    [aux_sym_integer_literal_token3] = ACTIONS(12882),
    [aux_sym_integer_literal_token4] = ACTIONS(12882),
    [aux_sym_float_literal_token1] = ACTIONS(12882),
    [aux_sym_float_literal_token3] = ACTIONS(12882),
    [aux_sym_float_literal_token4] = ACTIONS(12882),
    [sym_character_literal] = ACTIONS(12882),
    [sym__pair_operator] = ACTIONS(12882),
    [sym__arrow_operator] = ACTIONS(12882),
    [sym__lazy_or_operator] = ACTIONS(12882),
    [sym__lazy_and_operator] = ACTIONS(12882),
    [sym__comparison_operator] = ACTIONS(12882),
    [sym__pipe_right_operator] = ACTIONS(12882),
    [sym__pipe_left_operator] = ACTIONS(12882),
    [sym__ellipsis_operator] = ACTIONS(12882),
    [sym__plus_operator] = ACTIONS(12882),
    [sym__times_operator] = ACTIONS(12882),
    [sym__rational_operator] = ACTIONS(12882),
    [sym__bitshift_operator] = ACTIONS(12882),
    [sym__power_operator] = ACTIONS(12882),
    [sym__tilde_operator] = ACTIONS(12882),
    [sym__type_order_operator] = ACTIONS(12882),
    [sym__unary_operator] = ACTIONS(12882),
    [sym__unary_plus_operator] = ACTIONS(12882),
    [aux_sym__terminator_token1] = ACTIONS(12882),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12884),
    [sym__command_start] = ACTIONS(12884),
  },
  [6753] = {
    [sym__word_identifier] = ACTIONS(12886),
    [anon_sym_EQ] = ACTIONS(12886),
    [anon_sym_COMMA] = ACTIONS(12886),
    [anon_sym_COLON] = ACTIONS(12886),
    [anon_sym_begin] = ACTIONS(12886),
    [anon_sym_module] = ACTIONS(12886),
    [anon_sym_baremodule] = ACTIONS(12886),
    [anon_sym_end] = ACTIONS(12886),
    [anon_sym_abstract] = ACTIONS(12886),
    [anon_sym_primitive] = ACTIONS(12886),
    [anon_sym_mutable] = ACTIONS(12886),
    [anon_sym_struct] = ACTIONS(12886),
    [anon_sym_function] = ACTIONS(12886),
    [anon_sym_macro] = ACTIONS(12886),
    [anon_sym_where] = ACTIONS(12886),
    [anon_sym_quote] = ACTIONS(12886),
    [anon_sym_let] = ACTIONS(12886),
    [anon_sym_if] = ACTIONS(12886),
    [anon_sym_elseif] = ACTIONS(12886),
    [anon_sym_else] = ACTIONS(12886),
    [anon_sym_try] = ACTIONS(12886),
    [anon_sym_for] = ACTIONS(12886),
    [anon_sym_while] = ACTIONS(12886),
    [sym_break_statement] = ACTIONS(12886),
    [sym_continue_statement] = ACTIONS(12886),
    [anon_sym_return] = ACTIONS(12886),
    [anon_sym_const] = ACTIONS(12886),
    [anon_sym_global] = ACTIONS(12886),
    [anon_sym_local] = ACTIONS(12886),
    [anon_sym_as] = ACTIONS(12886),
    [anon_sym_LPAREN] = ACTIONS(12886),
    [anon_sym_COLON2] = ACTIONS(12886),
    [anon_sym_export] = ACTIONS(12886),
    [anon_sym_import] = ACTIONS(12886),
    [anon_sym_using] = ACTIONS(12886),
    [anon_sym_LBRACK] = ACTIONS(12886),
    [anon_sym_LF] = ACTIONS(12888),
    [anon_sym_in] = ACTIONS(12886),
    [anon_sym_LBRACE] = ACTIONS(12886),
    [anon_sym_DOT] = ACTIONS(12850),
    [anon_sym_DOLLAR] = ACTIONS(12886),
    [anon_sym_COLON_COLON] = ACTIONS(12886),
    [anon_sym_isa] = ACTIONS(12886),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_QMARK] = ACTIONS(12886),
    [anon_sym_AT] = ACTIONS(12886),
    [anon_sym_true] = ACTIONS(12886),
    [anon_sym_false] = ACTIONS(12886),
    [aux_sym_integer_literal_token1] = ACTIONS(12886),
    [aux_sym_integer_literal_token2] = ACTIONS(12886),
    [aux_sym_integer_literal_token3] = ACTIONS(12886),
    [aux_sym_integer_literal_token4] = ACTIONS(12886),
    [aux_sym_float_literal_token1] = ACTIONS(12886),
    [aux_sym_float_literal_token3] = ACTIONS(12886),
    [aux_sym_float_literal_token4] = ACTIONS(12886),
    [sym_character_literal] = ACTIONS(12886),
    [sym__pair_operator] = ACTIONS(12886),
    [sym__arrow_operator] = ACTIONS(12886),
    [sym__lazy_or_operator] = ACTIONS(12886),
    [sym__lazy_and_operator] = ACTIONS(12886),
    [sym__comparison_operator] = ACTIONS(12886),
    [sym__pipe_right_operator] = ACTIONS(12886),
    [sym__pipe_left_operator] = ACTIONS(12886),
    [sym__ellipsis_operator] = ACTIONS(12886),
    [sym__plus_operator] = ACTIONS(12886),
    [sym__times_operator] = ACTIONS(12886),
    [sym__rational_operator] = ACTIONS(12886),
    [sym__bitshift_operator] = ACTIONS(12886),
    [sym__power_operator] = ACTIONS(12886),
    [sym__tilde_operator] = ACTIONS(12886),
    [sym__type_order_operator] = ACTIONS(12886),
    [sym__unary_operator] = ACTIONS(12886),
    [sym__unary_plus_operator] = ACTIONS(12886),
    [aux_sym__terminator_token1] = ACTIONS(12886),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12888),
    [sym__command_start] = ACTIONS(12888),
  },
  [6754] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12890),
    [sym__immediate_command_start] = ACTIONS(12892),
  },
  [6755] = {
    [sym_identifier] = STATE(7052),
    [ts_builtin_sym_end] = ACTIONS(11956),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_RPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_RBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6756] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_else] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_as] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6757] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12894),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6758] = {
    [aux_sym__import_list_repeat1] = STATE(7122),
    [ts_builtin_sym_end] = ACTIONS(12868),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(12896),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(12898),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_RPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_RBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [6759] = {
    [ts_builtin_sym_end] = ACTIONS(12060),
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_as] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_RBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [6760] = {
    [ts_builtin_sym_end] = ACTIONS(12064),
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_as] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_RBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6761] = {
    [ts_builtin_sym_end] = ACTIONS(12848),
    [sym__word_identifier] = ACTIONS(12846),
    [anon_sym_EQ] = ACTIONS(12846),
    [anon_sym_COMMA] = ACTIONS(12846),
    [anon_sym_COLON] = ACTIONS(12846),
    [anon_sym_begin] = ACTIONS(12846),
    [anon_sym_module] = ACTIONS(12846),
    [anon_sym_baremodule] = ACTIONS(12846),
    [anon_sym_abstract] = ACTIONS(12846),
    [anon_sym_primitive] = ACTIONS(12846),
    [anon_sym_mutable] = ACTIONS(12846),
    [anon_sym_struct] = ACTIONS(12846),
    [anon_sym_function] = ACTIONS(12846),
    [anon_sym_macro] = ACTIONS(12846),
    [anon_sym_where] = ACTIONS(12846),
    [anon_sym_quote] = ACTIONS(12846),
    [anon_sym_let] = ACTIONS(12846),
    [anon_sym_if] = ACTIONS(12846),
    [anon_sym_try] = ACTIONS(12846),
    [anon_sym_for] = ACTIONS(12846),
    [anon_sym_while] = ACTIONS(12846),
    [sym_break_statement] = ACTIONS(12846),
    [sym_continue_statement] = ACTIONS(12846),
    [anon_sym_return] = ACTIONS(12846),
    [anon_sym_const] = ACTIONS(12846),
    [anon_sym_global] = ACTIONS(12846),
    [anon_sym_local] = ACTIONS(12846),
    [anon_sym_as] = ACTIONS(12846),
    [anon_sym_LPAREN] = ACTIONS(12846),
    [anon_sym_RPAREN] = ACTIONS(12846),
    [anon_sym_COLON2] = ACTIONS(12846),
    [anon_sym_export] = ACTIONS(12846),
    [anon_sym_import] = ACTIONS(12846),
    [anon_sym_using] = ACTIONS(12846),
    [anon_sym_LBRACK] = ACTIONS(12846),
    [anon_sym_RBRACK] = ACTIONS(12846),
    [anon_sym_LF] = ACTIONS(12848),
    [anon_sym_in] = ACTIONS(12846),
    [anon_sym_LBRACE] = ACTIONS(12846),
    [anon_sym_DOT] = ACTIONS(12900),
    [anon_sym_DOLLAR] = ACTIONS(12846),
    [anon_sym_COLON_COLON] = ACTIONS(12846),
    [anon_sym_isa] = ACTIONS(12846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12846),
    [anon_sym_QMARK] = ACTIONS(12846),
    [anon_sym_AT] = ACTIONS(12846),
    [anon_sym_true] = ACTIONS(12846),
    [anon_sym_false] = ACTIONS(12846),
    [aux_sym_integer_literal_token1] = ACTIONS(12846),
    [aux_sym_integer_literal_token2] = ACTIONS(12846),
    [aux_sym_integer_literal_token3] = ACTIONS(12846),
    [aux_sym_integer_literal_token4] = ACTIONS(12846),
    [aux_sym_float_literal_token1] = ACTIONS(12846),
    [aux_sym_float_literal_token3] = ACTIONS(12846),
    [aux_sym_float_literal_token4] = ACTIONS(12846),
    [sym_character_literal] = ACTIONS(12846),
    [sym__pair_operator] = ACTIONS(12846),
    [sym__arrow_operator] = ACTIONS(12846),
    [sym__lazy_or_operator] = ACTIONS(12846),
    [sym__lazy_and_operator] = ACTIONS(12846),
    [sym__comparison_operator] = ACTIONS(12846),
    [sym__pipe_right_operator] = ACTIONS(12846),
    [sym__pipe_left_operator] = ACTIONS(12846),
    [sym__ellipsis_operator] = ACTIONS(12846),
    [sym__plus_operator] = ACTIONS(12846),
    [sym__times_operator] = ACTIONS(12846),
    [sym__rational_operator] = ACTIONS(12846),
    [sym__bitshift_operator] = ACTIONS(12846),
    [sym__power_operator] = ACTIONS(12846),
    [sym__tilde_operator] = ACTIONS(12846),
    [sym__type_order_operator] = ACTIONS(12846),
    [sym__unary_operator] = ACTIONS(12846),
    [sym__unary_plus_operator] = ACTIONS(12846),
    [aux_sym__terminator_token1] = ACTIONS(12846),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12848),
    [sym__command_start] = ACTIONS(12848),
  },
  [6762] = {
    [ts_builtin_sym_end] = ACTIONS(12052),
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_as] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_RBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6763] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12902),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6764] = {
    [ts_builtin_sym_end] = ACTIONS(12262),
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_as] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_RPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_RBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6765] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12904),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6766] = {
    [ts_builtin_sym_end] = ACTIONS(12266),
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_as] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_RPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_RBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6767] = {
    [ts_builtin_sym_end] = ACTIONS(12270),
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_as] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_RPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_RBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6768] = {
    [ts_builtin_sym_end] = ACTIONS(12044),
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_as] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_RBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [6769] = {
    [sym__word_identifier] = ACTIONS(12882),
    [anon_sym_EQ] = ACTIONS(12882),
    [anon_sym_COMMA] = ACTIONS(12882),
    [anon_sym_COLON] = ACTIONS(12882),
    [anon_sym_begin] = ACTIONS(12882),
    [anon_sym_module] = ACTIONS(12882),
    [anon_sym_baremodule] = ACTIONS(12882),
    [anon_sym_end] = ACTIONS(12882),
    [anon_sym_abstract] = ACTIONS(12882),
    [anon_sym_primitive] = ACTIONS(12882),
    [anon_sym_mutable] = ACTIONS(12882),
    [anon_sym_struct] = ACTIONS(12882),
    [anon_sym_function] = ACTIONS(12882),
    [anon_sym_macro] = ACTIONS(12882),
    [anon_sym_where] = ACTIONS(12882),
    [anon_sym_quote] = ACTIONS(12882),
    [anon_sym_let] = ACTIONS(12882),
    [anon_sym_if] = ACTIONS(12882),
    [anon_sym_else] = ACTIONS(12882),
    [anon_sym_try] = ACTIONS(12882),
    [anon_sym_finally] = ACTIONS(12882),
    [anon_sym_for] = ACTIONS(12882),
    [anon_sym_while] = ACTIONS(12882),
    [sym_break_statement] = ACTIONS(12882),
    [sym_continue_statement] = ACTIONS(12882),
    [anon_sym_return] = ACTIONS(12882),
    [anon_sym_const] = ACTIONS(12882),
    [anon_sym_global] = ACTIONS(12882),
    [anon_sym_local] = ACTIONS(12882),
    [anon_sym_as] = ACTIONS(12882),
    [anon_sym_LPAREN] = ACTIONS(12882),
    [anon_sym_COLON2] = ACTIONS(12882),
    [anon_sym_export] = ACTIONS(12882),
    [anon_sym_import] = ACTIONS(12882),
    [anon_sym_using] = ACTIONS(12882),
    [anon_sym_LBRACK] = ACTIONS(12882),
    [anon_sym_LF] = ACTIONS(12884),
    [anon_sym_in] = ACTIONS(12882),
    [anon_sym_LBRACE] = ACTIONS(12882),
    [anon_sym_DOT] = ACTIONS(12906),
    [anon_sym_DOLLAR] = ACTIONS(12882),
    [anon_sym_COLON_COLON] = ACTIONS(12882),
    [anon_sym_isa] = ACTIONS(12882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12882),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_AT] = ACTIONS(12882),
    [anon_sym_true] = ACTIONS(12882),
    [anon_sym_false] = ACTIONS(12882),
    [aux_sym_integer_literal_token1] = ACTIONS(12882),
    [aux_sym_integer_literal_token2] = ACTIONS(12882),
    [aux_sym_integer_literal_token3] = ACTIONS(12882),
    [aux_sym_integer_literal_token4] = ACTIONS(12882),
    [aux_sym_float_literal_token1] = ACTIONS(12882),
    [aux_sym_float_literal_token3] = ACTIONS(12882),
    [aux_sym_float_literal_token4] = ACTIONS(12882),
    [sym_character_literal] = ACTIONS(12882),
    [sym__pair_operator] = ACTIONS(12882),
    [sym__arrow_operator] = ACTIONS(12882),
    [sym__lazy_or_operator] = ACTIONS(12882),
    [sym__lazy_and_operator] = ACTIONS(12882),
    [sym__comparison_operator] = ACTIONS(12882),
    [sym__pipe_right_operator] = ACTIONS(12882),
    [sym__pipe_left_operator] = ACTIONS(12882),
    [sym__ellipsis_operator] = ACTIONS(12882),
    [sym__plus_operator] = ACTIONS(12882),
    [sym__times_operator] = ACTIONS(12882),
    [sym__rational_operator] = ACTIONS(12882),
    [sym__bitshift_operator] = ACTIONS(12882),
    [sym__power_operator] = ACTIONS(12882),
    [sym__tilde_operator] = ACTIONS(12882),
    [sym__type_order_operator] = ACTIONS(12882),
    [sym__unary_operator] = ACTIONS(12882),
    [sym__unary_plus_operator] = ACTIONS(12882),
    [aux_sym__terminator_token1] = ACTIONS(12882),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12884),
    [sym__command_start] = ACTIONS(12884),
  },
  [6770] = {
    [sym_identifier] = STATE(6958),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_else] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6771] = {
    [sym__word_identifier] = ACTIONS(12886),
    [anon_sym_EQ] = ACTIONS(12886),
    [anon_sym_COMMA] = ACTIONS(12886),
    [anon_sym_COLON] = ACTIONS(12886),
    [anon_sym_begin] = ACTIONS(12886),
    [anon_sym_module] = ACTIONS(12886),
    [anon_sym_baremodule] = ACTIONS(12886),
    [anon_sym_end] = ACTIONS(12886),
    [anon_sym_abstract] = ACTIONS(12886),
    [anon_sym_primitive] = ACTIONS(12886),
    [anon_sym_mutable] = ACTIONS(12886),
    [anon_sym_struct] = ACTIONS(12886),
    [anon_sym_function] = ACTIONS(12886),
    [anon_sym_macro] = ACTIONS(12886),
    [anon_sym_where] = ACTIONS(12886),
    [anon_sym_quote] = ACTIONS(12886),
    [anon_sym_let] = ACTIONS(12886),
    [anon_sym_if] = ACTIONS(12886),
    [anon_sym_else] = ACTIONS(12886),
    [anon_sym_try] = ACTIONS(12886),
    [anon_sym_finally] = ACTIONS(12886),
    [anon_sym_for] = ACTIONS(12886),
    [anon_sym_while] = ACTIONS(12886),
    [sym_break_statement] = ACTIONS(12886),
    [sym_continue_statement] = ACTIONS(12886),
    [anon_sym_return] = ACTIONS(12886),
    [anon_sym_const] = ACTIONS(12886),
    [anon_sym_global] = ACTIONS(12886),
    [anon_sym_local] = ACTIONS(12886),
    [anon_sym_as] = ACTIONS(12886),
    [anon_sym_LPAREN] = ACTIONS(12886),
    [anon_sym_COLON2] = ACTIONS(12886),
    [anon_sym_export] = ACTIONS(12886),
    [anon_sym_import] = ACTIONS(12886),
    [anon_sym_using] = ACTIONS(12886),
    [anon_sym_LBRACK] = ACTIONS(12886),
    [anon_sym_LF] = ACTIONS(12888),
    [anon_sym_in] = ACTIONS(12886),
    [anon_sym_LBRACE] = ACTIONS(12886),
    [anon_sym_DOT] = ACTIONS(12906),
    [anon_sym_DOLLAR] = ACTIONS(12886),
    [anon_sym_COLON_COLON] = ACTIONS(12886),
    [anon_sym_isa] = ACTIONS(12886),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_QMARK] = ACTIONS(12886),
    [anon_sym_AT] = ACTIONS(12886),
    [anon_sym_true] = ACTIONS(12886),
    [anon_sym_false] = ACTIONS(12886),
    [aux_sym_integer_literal_token1] = ACTIONS(12886),
    [aux_sym_integer_literal_token2] = ACTIONS(12886),
    [aux_sym_integer_literal_token3] = ACTIONS(12886),
    [aux_sym_integer_literal_token4] = ACTIONS(12886),
    [aux_sym_float_literal_token1] = ACTIONS(12886),
    [aux_sym_float_literal_token3] = ACTIONS(12886),
    [aux_sym_float_literal_token4] = ACTIONS(12886),
    [sym_character_literal] = ACTIONS(12886),
    [sym__pair_operator] = ACTIONS(12886),
    [sym__arrow_operator] = ACTIONS(12886),
    [sym__lazy_or_operator] = ACTIONS(12886),
    [sym__lazy_and_operator] = ACTIONS(12886),
    [sym__comparison_operator] = ACTIONS(12886),
    [sym__pipe_right_operator] = ACTIONS(12886),
    [sym__pipe_left_operator] = ACTIONS(12886),
    [sym__ellipsis_operator] = ACTIONS(12886),
    [sym__plus_operator] = ACTIONS(12886),
    [sym__times_operator] = ACTIONS(12886),
    [sym__rational_operator] = ACTIONS(12886),
    [sym__bitshift_operator] = ACTIONS(12886),
    [sym__power_operator] = ACTIONS(12886),
    [sym__tilde_operator] = ACTIONS(12886),
    [sym__type_order_operator] = ACTIONS(12886),
    [sym__unary_operator] = ACTIONS(12886),
    [sym__unary_plus_operator] = ACTIONS(12886),
    [aux_sym__terminator_token1] = ACTIONS(12886),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12888),
    [sym__command_start] = ACTIONS(12888),
  },
  [6772] = {
    [sym_identifier] = STATE(7159),
    [ts_builtin_sym_end] = ACTIONS(12004),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_RPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_RBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6773] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12096),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12908),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12096),
    [sym__bitshift_operator] = ACTIONS(12096),
    [sym__power_operator] = ACTIONS(12096),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6774] = {
    [sym_identifier] = STATE(6959),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_else] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6775] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12910),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6776] = {
    [ts_builtin_sym_end] = ACTIONS(12274),
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_as] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_RPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_RBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6777] = {
    [ts_builtin_sym_end] = ACTIONS(12278),
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_as] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_RPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_RBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6778] = {
    [ts_builtin_sym_end] = ACTIONS(12336),
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_as] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_RPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_RBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6779] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_else] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_as] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6780] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_else] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_as] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6781] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_RPAREN] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_RBRACE] = ACTIONS(11864),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11864),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11864),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11864),
    [sym__pipe_left_operator] = ACTIONS(11864),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11864),
    [sym__bitshift_operator] = ACTIONS(11864),
    [sym__power_operator] = ACTIONS(11864),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11864),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6782] = {
    [sym_identifier] = STATE(7172),
    [ts_builtin_sym_end] = ACTIONS(12008),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_RPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_RBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6783] = {
    [aux_sym__import_list_repeat1] = STATE(7122),
    [ts_builtin_sym_end] = ACTIONS(12868),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(12896),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(12898),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_RPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12912),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_RBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [6784] = {
    [ts_builtin_sym_end] = ACTIONS(12068),
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_as] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_RBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6785] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_else] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_as] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6786] = {
    [ts_builtin_sym_end] = ACTIONS(12056),
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_as] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_RBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [6787] = {
    [sym_identifier] = STATE(6864),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_elseif] = ACTIONS(11992),
    [anon_sym_else] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6788] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6789] = {
    [sym_identifier] = STATE(6866),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_elseif] = ACTIONS(11958),
    [anon_sym_else] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6790] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_else] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_finally] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_as] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6791] = {
    [ts_builtin_sym_end] = ACTIONS(12282),
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_as] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_RPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_RBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6792] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12914),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6793] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_else] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_as] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6794] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6795] = {
    [ts_builtin_sym_end] = ACTIONS(12290),
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_as] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_RPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_RBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6796] = {
    [ts_builtin_sym_end] = ACTIONS(11894),
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_RBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6797] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12906),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6798] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_elseif] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [6799] = {
    [ts_builtin_sym_end] = ACTIONS(12884),
    [sym__word_identifier] = ACTIONS(12882),
    [anon_sym_EQ] = ACTIONS(12882),
    [anon_sym_COMMA] = ACTIONS(12882),
    [anon_sym_COLON] = ACTIONS(12882),
    [anon_sym_begin] = ACTIONS(12882),
    [anon_sym_module] = ACTIONS(12882),
    [anon_sym_baremodule] = ACTIONS(12882),
    [anon_sym_abstract] = ACTIONS(12882),
    [anon_sym_primitive] = ACTIONS(12882),
    [anon_sym_mutable] = ACTIONS(12882),
    [anon_sym_struct] = ACTIONS(12882),
    [anon_sym_function] = ACTIONS(12882),
    [anon_sym_macro] = ACTIONS(12882),
    [anon_sym_where] = ACTIONS(12882),
    [anon_sym_quote] = ACTIONS(12882),
    [anon_sym_let] = ACTIONS(12882),
    [anon_sym_if] = ACTIONS(12882),
    [anon_sym_try] = ACTIONS(12882),
    [anon_sym_for] = ACTIONS(12882),
    [anon_sym_while] = ACTIONS(12882),
    [sym_break_statement] = ACTIONS(12882),
    [sym_continue_statement] = ACTIONS(12882),
    [anon_sym_return] = ACTIONS(12882),
    [anon_sym_const] = ACTIONS(12882),
    [anon_sym_global] = ACTIONS(12882),
    [anon_sym_local] = ACTIONS(12882),
    [anon_sym_as] = ACTIONS(12882),
    [anon_sym_LPAREN] = ACTIONS(12882),
    [anon_sym_RPAREN] = ACTIONS(12882),
    [anon_sym_COLON2] = ACTIONS(12882),
    [anon_sym_export] = ACTIONS(12882),
    [anon_sym_import] = ACTIONS(12882),
    [anon_sym_using] = ACTIONS(12882),
    [anon_sym_LBRACK] = ACTIONS(12882),
    [anon_sym_RBRACK] = ACTIONS(12882),
    [anon_sym_LF] = ACTIONS(12884),
    [anon_sym_in] = ACTIONS(12882),
    [anon_sym_LBRACE] = ACTIONS(12882),
    [anon_sym_DOT] = ACTIONS(12900),
    [anon_sym_DOLLAR] = ACTIONS(12882),
    [anon_sym_COLON_COLON] = ACTIONS(12882),
    [anon_sym_isa] = ACTIONS(12882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12882),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_AT] = ACTIONS(12882),
    [anon_sym_true] = ACTIONS(12882),
    [anon_sym_false] = ACTIONS(12882),
    [aux_sym_integer_literal_token1] = ACTIONS(12882),
    [aux_sym_integer_literal_token2] = ACTIONS(12882),
    [aux_sym_integer_literal_token3] = ACTIONS(12882),
    [aux_sym_integer_literal_token4] = ACTIONS(12882),
    [aux_sym_float_literal_token1] = ACTIONS(12882),
    [aux_sym_float_literal_token3] = ACTIONS(12882),
    [aux_sym_float_literal_token4] = ACTIONS(12882),
    [sym_character_literal] = ACTIONS(12882),
    [sym__pair_operator] = ACTIONS(12882),
    [sym__arrow_operator] = ACTIONS(12882),
    [sym__lazy_or_operator] = ACTIONS(12882),
    [sym__lazy_and_operator] = ACTIONS(12882),
    [sym__comparison_operator] = ACTIONS(12882),
    [sym__pipe_right_operator] = ACTIONS(12882),
    [sym__pipe_left_operator] = ACTIONS(12882),
    [sym__ellipsis_operator] = ACTIONS(12882),
    [sym__plus_operator] = ACTIONS(12882),
    [sym__times_operator] = ACTIONS(12882),
    [sym__rational_operator] = ACTIONS(12882),
    [sym__bitshift_operator] = ACTIONS(12882),
    [sym__power_operator] = ACTIONS(12882),
    [sym__tilde_operator] = ACTIONS(12882),
    [sym__type_order_operator] = ACTIONS(12882),
    [sym__unary_operator] = ACTIONS(12882),
    [sym__unary_plus_operator] = ACTIONS(12882),
    [aux_sym__terminator_token1] = ACTIONS(12882),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12884),
    [sym__command_start] = ACTIONS(12884),
  },
  [6800] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6801] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12826),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6802] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12870),
    [sym__immediate_command_start] = ACTIONS(12872),
  },
  [6803] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_elseif] = ACTIONS(12384),
    [anon_sym_else] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_as] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6804] = {
    [ts_builtin_sym_end] = ACTIONS(12140),
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_as] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_RPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_RBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6805] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11894),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11894),
    [anon_sym_RPAREN] = ACTIONS(11894),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11894),
    [anon_sym_RBRACK] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11894),
    [anon_sym_RBRACE] = ACTIONS(11894),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11894),
    [anon_sym_COLON_COLON] = ACTIONS(11894),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11894),
    [anon_sym_QMARK] = ACTIONS(11894),
    [anon_sym_AT] = ACTIONS(11894),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11894),
    [aux_sym_integer_literal_token2] = ACTIONS(11894),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11894),
    [aux_sym_float_literal_token3] = ACTIONS(11894),
    [aux_sym_float_literal_token4] = ACTIONS(11894),
    [sym_character_literal] = ACTIONS(11894),
    [sym__pair_operator] = ACTIONS(11894),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11894),
    [sym__lazy_and_operator] = ACTIONS(11894),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11894),
    [sym__pipe_left_operator] = ACTIONS(11894),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11894),
    [sym__bitshift_operator] = ACTIONS(11894),
    [sym__power_operator] = ACTIONS(11894),
    [sym__tilde_operator] = ACTIONS(11894),
    [sym__type_order_operator] = ACTIONS(11894),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12852),
    [sym__immediate_command_start] = ACTIONS(12854),
  },
  [6806] = {
    [ts_builtin_sym_end] = ACTIONS(12888),
    [sym__word_identifier] = ACTIONS(12886),
    [anon_sym_EQ] = ACTIONS(12886),
    [anon_sym_COMMA] = ACTIONS(12886),
    [anon_sym_COLON] = ACTIONS(12886),
    [anon_sym_begin] = ACTIONS(12886),
    [anon_sym_module] = ACTIONS(12886),
    [anon_sym_baremodule] = ACTIONS(12886),
    [anon_sym_abstract] = ACTIONS(12886),
    [anon_sym_primitive] = ACTIONS(12886),
    [anon_sym_mutable] = ACTIONS(12886),
    [anon_sym_struct] = ACTIONS(12886),
    [anon_sym_function] = ACTIONS(12886),
    [anon_sym_macro] = ACTIONS(12886),
    [anon_sym_where] = ACTIONS(12886),
    [anon_sym_quote] = ACTIONS(12886),
    [anon_sym_let] = ACTIONS(12886),
    [anon_sym_if] = ACTIONS(12886),
    [anon_sym_try] = ACTIONS(12886),
    [anon_sym_for] = ACTIONS(12886),
    [anon_sym_while] = ACTIONS(12886),
    [sym_break_statement] = ACTIONS(12886),
    [sym_continue_statement] = ACTIONS(12886),
    [anon_sym_return] = ACTIONS(12886),
    [anon_sym_const] = ACTIONS(12886),
    [anon_sym_global] = ACTIONS(12886),
    [anon_sym_local] = ACTIONS(12886),
    [anon_sym_as] = ACTIONS(12886),
    [anon_sym_LPAREN] = ACTIONS(12886),
    [anon_sym_RPAREN] = ACTIONS(12886),
    [anon_sym_COLON2] = ACTIONS(12886),
    [anon_sym_export] = ACTIONS(12886),
    [anon_sym_import] = ACTIONS(12886),
    [anon_sym_using] = ACTIONS(12886),
    [anon_sym_LBRACK] = ACTIONS(12886),
    [anon_sym_RBRACK] = ACTIONS(12886),
    [anon_sym_LF] = ACTIONS(12888),
    [anon_sym_in] = ACTIONS(12886),
    [anon_sym_LBRACE] = ACTIONS(12886),
    [anon_sym_DOT] = ACTIONS(12900),
    [anon_sym_DOLLAR] = ACTIONS(12886),
    [anon_sym_COLON_COLON] = ACTIONS(12886),
    [anon_sym_isa] = ACTIONS(12886),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_QMARK] = ACTIONS(12886),
    [anon_sym_AT] = ACTIONS(12886),
    [anon_sym_true] = ACTIONS(12886),
    [anon_sym_false] = ACTIONS(12886),
    [aux_sym_integer_literal_token1] = ACTIONS(12886),
    [aux_sym_integer_literal_token2] = ACTIONS(12886),
    [aux_sym_integer_literal_token3] = ACTIONS(12886),
    [aux_sym_integer_literal_token4] = ACTIONS(12886),
    [aux_sym_float_literal_token1] = ACTIONS(12886),
    [aux_sym_float_literal_token3] = ACTIONS(12886),
    [aux_sym_float_literal_token4] = ACTIONS(12886),
    [sym_character_literal] = ACTIONS(12886),
    [sym__pair_operator] = ACTIONS(12886),
    [sym__arrow_operator] = ACTIONS(12886),
    [sym__lazy_or_operator] = ACTIONS(12886),
    [sym__lazy_and_operator] = ACTIONS(12886),
    [sym__comparison_operator] = ACTIONS(12886),
    [sym__pipe_right_operator] = ACTIONS(12886),
    [sym__pipe_left_operator] = ACTIONS(12886),
    [sym__ellipsis_operator] = ACTIONS(12886),
    [sym__plus_operator] = ACTIONS(12886),
    [sym__times_operator] = ACTIONS(12886),
    [sym__rational_operator] = ACTIONS(12886),
    [sym__bitshift_operator] = ACTIONS(12886),
    [sym__power_operator] = ACTIONS(12886),
    [sym__tilde_operator] = ACTIONS(12886),
    [sym__type_order_operator] = ACTIONS(12886),
    [sym__unary_operator] = ACTIONS(12886),
    [sym__unary_plus_operator] = ACTIONS(12886),
    [aux_sym__terminator_token1] = ACTIONS(12886),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12888),
    [sym__command_start] = ACTIONS(12888),
  },
  [6807] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_elseif] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6808] = {
    [ts_builtin_sym_end] = ACTIONS(12144),
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_as] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_RPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_RBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6809] = {
    [ts_builtin_sym_end] = ACTIONS(12160),
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_as] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_RPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_RBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6810] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_elseif] = ACTIONS(12388),
    [anon_sym_else] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_as] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [6811] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_elseif] = ACTIONS(12618),
    [anon_sym_else] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_as] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6812] = {
    [ts_builtin_sym_end] = ACTIONS(12148),
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_as] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_RPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_RBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6813] = {
    [ts_builtin_sym_end] = ACTIONS(12168),
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_as] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_RPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_RBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6814] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_elseif] = ACTIONS(12322),
    [anon_sym_else] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_as] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6815] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12890),
    [sym__immediate_command_start] = ACTIONS(12892),
  },
  [6816] = {
    [ts_builtin_sym_end] = ACTIONS(12298),
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_as] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_RPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_RBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6817] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_elseif] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6818] = {
    [ts_builtin_sym_end] = ACTIONS(12676),
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_RBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12900),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6819] = {
    [aux_sym__import_list_repeat1] = STATE(7256),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_else] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_finally] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(12918),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12920),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [6820] = {
    [sym_identifier] = STATE(6976),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_else] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6821] = {
    [sym_identifier] = STATE(6882),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_elseif] = ACTIONS(12002),
    [anon_sym_else] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6822] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12922),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6823] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_RPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_SEMI] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12620),
    [sym__immediate_bracket] = ACTIONS(12620),
    [sym__immediate_brace] = ACTIONS(12620),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6824] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12878),
    [sym__immediate_command_start] = ACTIONS(12880),
  },
  [6825] = {
    [ts_builtin_sym_end] = ACTIONS(12152),
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_as] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_RPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_RBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6826] = {
    [sym_identifier] = STATE(6883),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_elseif] = ACTIONS(12006),
    [anon_sym_else] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6827] = {
    [sym_identifier] = STATE(7210),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_catch] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_as] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6828] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6829] = {
    [ts_builtin_sym_end] = ACTIONS(12386),
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_as] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_RPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_RBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6830] = {
    [sym_identifier] = STATE(7119),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_catch] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_as] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6831] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_elseif] = ACTIONS(12334),
    [anon_sym_else] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_as] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6832] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [6833] = {
    [sym__word_identifier] = ACTIONS(12846),
    [anon_sym_EQ] = ACTIONS(12846),
    [anon_sym_COMMA] = ACTIONS(12846),
    [anon_sym_COLON] = ACTIONS(12846),
    [anon_sym_begin] = ACTIONS(12846),
    [anon_sym_module] = ACTIONS(12846),
    [anon_sym_baremodule] = ACTIONS(12846),
    [anon_sym_end] = ACTIONS(12846),
    [anon_sym_abstract] = ACTIONS(12846),
    [anon_sym_primitive] = ACTIONS(12846),
    [anon_sym_mutable] = ACTIONS(12846),
    [anon_sym_struct] = ACTIONS(12846),
    [anon_sym_function] = ACTIONS(12846),
    [anon_sym_macro] = ACTIONS(12846),
    [anon_sym_where] = ACTIONS(12846),
    [anon_sym_quote] = ACTIONS(12846),
    [anon_sym_let] = ACTIONS(12846),
    [anon_sym_if] = ACTIONS(12846),
    [anon_sym_else] = ACTIONS(12846),
    [anon_sym_try] = ACTIONS(12846),
    [anon_sym_finally] = ACTIONS(12846),
    [anon_sym_for] = ACTIONS(12846),
    [anon_sym_while] = ACTIONS(12846),
    [sym_break_statement] = ACTIONS(12846),
    [sym_continue_statement] = ACTIONS(12846),
    [anon_sym_return] = ACTIONS(12846),
    [anon_sym_const] = ACTIONS(12846),
    [anon_sym_global] = ACTIONS(12846),
    [anon_sym_local] = ACTIONS(12846),
    [anon_sym_as] = ACTIONS(12846),
    [anon_sym_LPAREN] = ACTIONS(12846),
    [anon_sym_COLON2] = ACTIONS(12846),
    [anon_sym_export] = ACTIONS(12846),
    [anon_sym_import] = ACTIONS(12846),
    [anon_sym_using] = ACTIONS(12846),
    [anon_sym_LBRACK] = ACTIONS(12846),
    [anon_sym_LF] = ACTIONS(12848),
    [anon_sym_in] = ACTIONS(12846),
    [anon_sym_LBRACE] = ACTIONS(12846),
    [anon_sym_DOT] = ACTIONS(12906),
    [anon_sym_DOLLAR] = ACTIONS(12846),
    [anon_sym_COLON_COLON] = ACTIONS(12846),
    [anon_sym_isa] = ACTIONS(12846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12846),
    [anon_sym_QMARK] = ACTIONS(12846),
    [anon_sym_AT] = ACTIONS(12846),
    [anon_sym_true] = ACTIONS(12846),
    [anon_sym_false] = ACTIONS(12846),
    [aux_sym_integer_literal_token1] = ACTIONS(12846),
    [aux_sym_integer_literal_token2] = ACTIONS(12846),
    [aux_sym_integer_literal_token3] = ACTIONS(12846),
    [aux_sym_integer_literal_token4] = ACTIONS(12846),
    [aux_sym_float_literal_token1] = ACTIONS(12846),
    [aux_sym_float_literal_token3] = ACTIONS(12846),
    [aux_sym_float_literal_token4] = ACTIONS(12846),
    [sym_character_literal] = ACTIONS(12846),
    [sym__pair_operator] = ACTIONS(12846),
    [sym__arrow_operator] = ACTIONS(12846),
    [sym__lazy_or_operator] = ACTIONS(12846),
    [sym__lazy_and_operator] = ACTIONS(12846),
    [sym__comparison_operator] = ACTIONS(12846),
    [sym__pipe_right_operator] = ACTIONS(12846),
    [sym__pipe_left_operator] = ACTIONS(12846),
    [sym__ellipsis_operator] = ACTIONS(12846),
    [sym__plus_operator] = ACTIONS(12846),
    [sym__times_operator] = ACTIONS(12846),
    [sym__rational_operator] = ACTIONS(12846),
    [sym__bitshift_operator] = ACTIONS(12846),
    [sym__power_operator] = ACTIONS(12846),
    [sym__tilde_operator] = ACTIONS(12846),
    [sym__type_order_operator] = ACTIONS(12846),
    [sym__unary_operator] = ACTIONS(12846),
    [sym__unary_plus_operator] = ACTIONS(12846),
    [aux_sym__terminator_token1] = ACTIONS(12846),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12848),
    [sym__command_start] = ACTIONS(12848),
  },
  [6834] = {
    [aux_sym__import_list_repeat1] = STATE(7256),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_else] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_finally] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(12918),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [6835] = {
    [sym_identifier] = STATE(6955),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_as] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6836] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6837] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12858),
    [sym__immediate_command_start] = ACTIONS(12860),
  },
  [6838] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12842),
    [sym__immediate_command_start] = ACTIONS(12844),
  },
  [6839] = {
    [sym_identifier] = STATE(6980),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_as] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6840] = {
    [sym_identifier] = STATE(7026),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_as] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6841] = {
    [sym_identifier] = STATE(7045),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_catch] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_as] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6842] = {
    [sym_identifier] = STATE(7057),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_as] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6843] = {
    [aux_sym__import_list_repeat1] = STATE(6990),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(12864),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_elseif] = ACTIONS(12862),
    [anon_sym_else] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(12866),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12924),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [6844] = {
    [aux_sym_open_tuple_repeat1] = STATE(7255),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(12928),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_elseif] = ACTIONS(12926),
    [anon_sym_else] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(12940),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [6845] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_as] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6846] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_as] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6847] = {
    [sym_identifier] = STATE(7876),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_catch] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6848] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_catch] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_as] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6849] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_catch] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_as] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6850] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(12966),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6851] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_as] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6852] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_elseif] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6853] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_elseif] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6854] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_else] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_finally] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [6855] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_elseif] = ACTIONS(12264),
    [anon_sym_else] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6856] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_elseif] = ACTIONS(12268),
    [anon_sym_else] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6857] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_elseif] = ACTIONS(12272),
    [anon_sym_else] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6858] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(12968),
    [sym__immediate_command_start] = ACTIONS(12970),
  },
  [6859] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_as] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6860] = {
    [sym_identifier] = STATE(7877),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_catch] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6861] = {
    [aux_sym_export_statement_repeat1] = STATE(6861),
    [ts_builtin_sym_end] = ACTIONS(12972),
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(12976),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_RPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_RBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [6862] = {
    [ts_builtin_sym_end] = ACTIONS(12979),
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_as] = ACTIONS(12898),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_RPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_RBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [6863] = {
    [ts_builtin_sym_end] = ACTIONS(12176),
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_RPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_RBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6864] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_elseif] = ACTIONS(12276),
    [anon_sym_else] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6865] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_as] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6866] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_elseif] = ACTIONS(12280),
    [anon_sym_else] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6867] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12983),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6868] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_elseif] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6869] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11876),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6870] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_elseif] = ACTIONS(12284),
    [anon_sym_else] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6871] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_elseif] = ACTIONS(12142),
    [anon_sym_else] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6872] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_catch] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_as] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6873] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11870),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6874] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6875] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_elseif] = ACTIONS(12146),
    [anon_sym_else] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6876] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_elseif] = ACTIONS(12150),
    [anon_sym_else] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6877] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_as] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6878] = {
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6879] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_as] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6880] = {
    [sym__primary_expression] = STATE(11363),
    [sym__array] = STATE(11363),
    [sym_comprehension_expression] = STATE(11363),
    [sym_matrix_expression] = STATE(11363),
    [sym_vector_expression] = STATE(11363),
    [sym_parenthesized_expression] = STATE(11363),
    [sym_tuple_expression] = STATE(11363),
    [sym_curly_expression] = STATE(11363),
    [sym_adjoint_expression] = STATE(11363),
    [sym_field_expression] = STATE(11363),
    [sym_index_expression] = STATE(11363),
    [sym_parametrized_type_expression] = STATE(11363),
    [sym_call_expression] = STATE(11363),
    [sym_broadcast_call_expression] = STATE(11363),
    [sym__closed_macrocall_expression] = STATE(11363),
    [sym_interpolation_expression] = STATE(11363),
    [sym_quote_expression] = STATE(11363),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(10801),
    [sym_boolean_literal] = STATE(11363),
    [sym__string] = STATE(11363),
    [sym_string_literal] = STATE(11363),
    [sym_command_literal] = STATE(11363),
    [sym_prefixed_string_literal] = STATE(11363),
    [sym_prefixed_command_literal] = STATE(11363),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(12987),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_elseif] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(12995),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(13001),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [6881] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12234),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_as] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12234),
    [anon_sym_RPAREN] = ACTIONS(12234),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12234),
    [anon_sym_RBRACK] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_SEMI] = ACTIONS(12234),
    [anon_sym_LBRACE] = ACTIONS(12234),
    [anon_sym_RBRACE] = ACTIONS(12234),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12234),
    [anon_sym_COLON_COLON] = ACTIONS(12234),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12234),
    [anon_sym_QMARK] = ACTIONS(12234),
    [anon_sym_AT] = ACTIONS(12234),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12234),
    [aux_sym_integer_literal_token2] = ACTIONS(12234),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12234),
    [aux_sym_float_literal_token3] = ACTIONS(12234),
    [aux_sym_float_literal_token4] = ACTIONS(12234),
    [sym_character_literal] = ACTIONS(12234),
    [sym__pair_operator] = ACTIONS(12234),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12234),
    [sym__lazy_and_operator] = ACTIONS(12234),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12234),
    [sym__pipe_left_operator] = ACTIONS(12234),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12234),
    [sym__bitshift_operator] = ACTIONS(12234),
    [sym__power_operator] = ACTIONS(12234),
    [sym__tilde_operator] = ACTIONS(12234),
    [sym__type_order_operator] = ACTIONS(12234),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6882] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_elseif] = ACTIONS(12158),
    [anon_sym_else] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6883] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_elseif] = ACTIONS(12162),
    [anon_sym_else] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6884] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12064),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_as] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12064),
    [anon_sym_RPAREN] = ACTIONS(12064),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12064),
    [anon_sym_RBRACK] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12064),
    [anon_sym_LBRACE] = ACTIONS(12064),
    [anon_sym_RBRACE] = ACTIONS(12064),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12064),
    [anon_sym_COLON_COLON] = ACTIONS(12064),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12064),
    [anon_sym_QMARK] = ACTIONS(12064),
    [anon_sym_AT] = ACTIONS(12064),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12064),
    [aux_sym_integer_literal_token2] = ACTIONS(12064),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12064),
    [aux_sym_float_literal_token3] = ACTIONS(12064),
    [aux_sym_float_literal_token4] = ACTIONS(12064),
    [sym_character_literal] = ACTIONS(12064),
    [sym__pair_operator] = ACTIONS(12064),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12064),
    [sym__lazy_and_operator] = ACTIONS(12064),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12064),
    [sym__pipe_left_operator] = ACTIONS(12064),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12064),
    [sym__bitshift_operator] = ACTIONS(12064),
    [sym__power_operator] = ACTIONS(12064),
    [sym__tilde_operator] = ACTIONS(12064),
    [sym__type_order_operator] = ACTIONS(12064),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6885] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_as] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6886] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_as] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6887] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_elseif] = ACTIONS(12210),
    [anon_sym_else] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6888] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_elseif] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6889] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_elseif] = ACTIONS(12170),
    [anon_sym_else] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6890] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_catch] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_as] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6891] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_as] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6892] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_elseif] = ACTIONS(12178),
    [anon_sym_else] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6893] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_as] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_RPAREN] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_RBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_RBRACE] = ACTIONS(12052),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12052),
    [sym__bitshift_operator] = ACTIONS(12052),
    [sym__power_operator] = ACTIONS(12052),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6894] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12238),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_as] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12238),
    [anon_sym_RPAREN] = ACTIONS(12238),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12238),
    [anon_sym_RBRACK] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_SEMI] = ACTIONS(12238),
    [anon_sym_LBRACE] = ACTIONS(12238),
    [anon_sym_RBRACE] = ACTIONS(12238),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12238),
    [anon_sym_COLON_COLON] = ACTIONS(12238),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12238),
    [anon_sym_QMARK] = ACTIONS(12238),
    [anon_sym_AT] = ACTIONS(12238),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12238),
    [aux_sym_integer_literal_token2] = ACTIONS(12238),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12238),
    [aux_sym_float_literal_token3] = ACTIONS(12238),
    [aux_sym_float_literal_token4] = ACTIONS(12238),
    [sym_character_literal] = ACTIONS(12238),
    [sym__pair_operator] = ACTIONS(12238),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12238),
    [sym__lazy_and_operator] = ACTIONS(12238),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12238),
    [sym__pipe_left_operator] = ACTIONS(12238),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12238),
    [sym__bitshift_operator] = ACTIONS(12238),
    [sym__power_operator] = ACTIONS(12238),
    [sym__tilde_operator] = ACTIONS(12238),
    [sym__type_order_operator] = ACTIONS(12238),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6895] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12262),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_as] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12262),
    [anon_sym_RPAREN] = ACTIONS(12262),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12262),
    [anon_sym_RBRACK] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_SEMI] = ACTIONS(12262),
    [anon_sym_LBRACE] = ACTIONS(12262),
    [anon_sym_RBRACE] = ACTIONS(12262),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12262),
    [anon_sym_COLON_COLON] = ACTIONS(12262),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12262),
    [anon_sym_QMARK] = ACTIONS(12262),
    [anon_sym_AT] = ACTIONS(12262),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12262),
    [aux_sym_integer_literal_token2] = ACTIONS(12262),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12262),
    [aux_sym_float_literal_token3] = ACTIONS(12262),
    [aux_sym_float_literal_token4] = ACTIONS(12262),
    [sym_character_literal] = ACTIONS(12262),
    [sym__pair_operator] = ACTIONS(12262),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12262),
    [sym__lazy_and_operator] = ACTIONS(12262),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12262),
    [sym__pipe_left_operator] = ACTIONS(12262),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12262),
    [sym__bitshift_operator] = ACTIONS(12262),
    [sym__power_operator] = ACTIONS(12262),
    [sym__tilde_operator] = ACTIONS(12262),
    [sym__type_order_operator] = ACTIONS(12262),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6896] = {
    [ts_builtin_sym_end] = ACTIONS(11890),
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_RBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [6897] = {
    [sym_identifier] = STATE(7883),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_catch] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [6898] = {
    [aux_sym__import_list_repeat1] = STATE(6898),
    [ts_builtin_sym_end] = ACTIONS(12979),
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(13007),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_RPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_RBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [6899] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_catch] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_as] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6900] = {
    [ts_builtin_sym_end] = ACTIONS(12246),
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_RPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_RBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6901] = {
    [ts_builtin_sym_end] = ACTIONS(12250),
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_RPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_RBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6902] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6903] = {
    [ts_builtin_sym_end] = ACTIONS(12052),
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_RBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6904] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6905] = {
    [ts_builtin_sym_end] = ACTIONS(12262),
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_RPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_RBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6906] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12266),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_as] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12266),
    [anon_sym_RPAREN] = ACTIONS(12266),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12266),
    [anon_sym_RBRACK] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_SEMI] = ACTIONS(12266),
    [anon_sym_LBRACE] = ACTIONS(12266),
    [anon_sym_RBRACE] = ACTIONS(12266),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12266),
    [anon_sym_COLON_COLON] = ACTIONS(12266),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12266),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_AT] = ACTIONS(12266),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12266),
    [aux_sym_integer_literal_token2] = ACTIONS(12266),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12266),
    [aux_sym_float_literal_token3] = ACTIONS(12266),
    [aux_sym_float_literal_token4] = ACTIONS(12266),
    [sym_character_literal] = ACTIONS(12266),
    [sym__pair_operator] = ACTIONS(12266),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12266),
    [sym__lazy_and_operator] = ACTIONS(12266),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12266),
    [sym__pipe_left_operator] = ACTIONS(12266),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12266),
    [sym__bitshift_operator] = ACTIONS(12266),
    [sym__power_operator] = ACTIONS(12266),
    [sym__tilde_operator] = ACTIONS(12266),
    [sym__type_order_operator] = ACTIONS(12266),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6907] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12376),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6908] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_elseif] = ACTIONS(12292),
    [anon_sym_else] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [6909] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6910] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(13010),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6911] = {
    [ts_builtin_sym_end] = ACTIONS(12324),
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_RPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_RBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6912] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_catch] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_as] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6913] = {
    [ts_builtin_sym_end] = ACTIONS(11894),
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_RBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [6914] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12270),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_as] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12270),
    [anon_sym_RPAREN] = ACTIONS(12270),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12270),
    [anon_sym_RBRACK] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_SEMI] = ACTIONS(12270),
    [anon_sym_LBRACE] = ACTIONS(12270),
    [anon_sym_RBRACE] = ACTIONS(12270),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12270),
    [anon_sym_COLON_COLON] = ACTIONS(12270),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_QMARK] = ACTIONS(12270),
    [anon_sym_AT] = ACTIONS(12270),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12270),
    [aux_sym_integer_literal_token2] = ACTIONS(12270),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12270),
    [aux_sym_float_literal_token3] = ACTIONS(12270),
    [aux_sym_float_literal_token4] = ACTIONS(12270),
    [sym_character_literal] = ACTIONS(12270),
    [sym__pair_operator] = ACTIONS(12270),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12270),
    [sym__lazy_and_operator] = ACTIONS(12270),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12270),
    [sym__pipe_left_operator] = ACTIONS(12270),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12270),
    [sym__bitshift_operator] = ACTIONS(12270),
    [sym__power_operator] = ACTIONS(12270),
    [sym__tilde_operator] = ACTIONS(12270),
    [sym__type_order_operator] = ACTIONS(12270),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6915] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_as] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6916] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12324),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_as] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12324),
    [anon_sym_RPAREN] = ACTIONS(12324),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12324),
    [anon_sym_RBRACK] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_SEMI] = ACTIONS(12324),
    [anon_sym_LBRACE] = ACTIONS(12324),
    [anon_sym_RBRACE] = ACTIONS(12324),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12324),
    [anon_sym_COLON_COLON] = ACTIONS(12324),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12324),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_AT] = ACTIONS(12324),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12324),
    [aux_sym_integer_literal_token2] = ACTIONS(12324),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12324),
    [aux_sym_float_literal_token3] = ACTIONS(12324),
    [aux_sym_float_literal_token4] = ACTIONS(12324),
    [sym_character_literal] = ACTIONS(12324),
    [sym__pair_operator] = ACTIONS(12324),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12324),
    [sym__lazy_and_operator] = ACTIONS(12324),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12324),
    [sym__pipe_left_operator] = ACTIONS(12324),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12324),
    [sym__bitshift_operator] = ACTIONS(12324),
    [sym__power_operator] = ACTIONS(12324),
    [sym__tilde_operator] = ACTIONS(12324),
    [sym__type_order_operator] = ACTIONS(12324),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [6917] = {
    [ts_builtin_sym_end] = ACTIONS(12238),
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_RPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_RBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6918] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_catch] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_as] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6919] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_catch] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_as] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6920] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [6921] = {
    [aux_sym__import_list_repeat1] = STATE(7348),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13012),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_catch] = ACTIONS(12862),
    [anon_sym_finally] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13014),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(13016),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [6922] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6923] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13018),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6924] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_elseif] = ACTIONS(12300),
    [anon_sym_else] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [6925] = {
    [aux_sym__import_list_repeat1] = STATE(7554),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13020),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_catch] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13022),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(13024),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [6926] = {
    [ts_builtin_sym_end] = ACTIONS(12336),
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_RPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_RBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6927] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_catch] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_as] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6928] = {
    [aux_sym__import_list_repeat1] = STATE(7616),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13026),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_finally] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13028),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(13030),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [6929] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_else] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [6930] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_else] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [6931] = {
    [sym__word_identifier] = ACTIONS(12882),
    [anon_sym_EQ] = ACTIONS(12882),
    [anon_sym_COMMA] = ACTIONS(12882),
    [anon_sym_COLON] = ACTIONS(12882),
    [anon_sym_begin] = ACTIONS(12882),
    [anon_sym_module] = ACTIONS(12882),
    [anon_sym_baremodule] = ACTIONS(12882),
    [anon_sym_end] = ACTIONS(12882),
    [anon_sym_abstract] = ACTIONS(12882),
    [anon_sym_primitive] = ACTIONS(12882),
    [anon_sym_mutable] = ACTIONS(12882),
    [anon_sym_struct] = ACTIONS(12882),
    [anon_sym_function] = ACTIONS(12882),
    [anon_sym_macro] = ACTIONS(12882),
    [anon_sym_where] = ACTIONS(12882),
    [anon_sym_quote] = ACTIONS(12882),
    [anon_sym_let] = ACTIONS(12882),
    [anon_sym_if] = ACTIONS(12882),
    [anon_sym_try] = ACTIONS(12882),
    [anon_sym_catch] = ACTIONS(12882),
    [anon_sym_for] = ACTIONS(12882),
    [anon_sym_while] = ACTIONS(12882),
    [sym_break_statement] = ACTIONS(12882),
    [sym_continue_statement] = ACTIONS(12882),
    [anon_sym_return] = ACTIONS(12882),
    [anon_sym_const] = ACTIONS(12882),
    [anon_sym_global] = ACTIONS(12882),
    [anon_sym_local] = ACTIONS(12882),
    [anon_sym_as] = ACTIONS(12882),
    [anon_sym_LPAREN] = ACTIONS(12882),
    [anon_sym_COLON2] = ACTIONS(12882),
    [anon_sym_export] = ACTIONS(12882),
    [anon_sym_import] = ACTIONS(12882),
    [anon_sym_using] = ACTIONS(12882),
    [anon_sym_LBRACK] = ACTIONS(12882),
    [anon_sym_LF] = ACTIONS(12884),
    [anon_sym_in] = ACTIONS(12882),
    [anon_sym_LBRACE] = ACTIONS(12882),
    [anon_sym_DOT] = ACTIONS(13010),
    [anon_sym_DOLLAR] = ACTIONS(12882),
    [anon_sym_COLON_COLON] = ACTIONS(12882),
    [anon_sym_isa] = ACTIONS(12882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12882),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_AT] = ACTIONS(12882),
    [anon_sym_true] = ACTIONS(12882),
    [anon_sym_false] = ACTIONS(12882),
    [aux_sym_integer_literal_token1] = ACTIONS(12882),
    [aux_sym_integer_literal_token2] = ACTIONS(12882),
    [aux_sym_integer_literal_token3] = ACTIONS(12882),
    [aux_sym_integer_literal_token4] = ACTIONS(12882),
    [aux_sym_float_literal_token1] = ACTIONS(12882),
    [aux_sym_float_literal_token3] = ACTIONS(12882),
    [aux_sym_float_literal_token4] = ACTIONS(12882),
    [sym_character_literal] = ACTIONS(12882),
    [sym__pair_operator] = ACTIONS(12882),
    [sym__arrow_operator] = ACTIONS(12882),
    [sym__lazy_or_operator] = ACTIONS(12882),
    [sym__lazy_and_operator] = ACTIONS(12882),
    [sym__comparison_operator] = ACTIONS(12882),
    [sym__pipe_right_operator] = ACTIONS(12882),
    [sym__pipe_left_operator] = ACTIONS(12882),
    [sym__ellipsis_operator] = ACTIONS(12882),
    [sym__plus_operator] = ACTIONS(12882),
    [sym__times_operator] = ACTIONS(12882),
    [sym__rational_operator] = ACTIONS(12882),
    [sym__bitshift_operator] = ACTIONS(12882),
    [sym__power_operator] = ACTIONS(12882),
    [sym__tilde_operator] = ACTIONS(12882),
    [sym__type_order_operator] = ACTIONS(12882),
    [sym__unary_operator] = ACTIONS(12882),
    [sym__unary_plus_operator] = ACTIONS(12882),
    [aux_sym__terminator_token1] = ACTIONS(12882),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12884),
    [sym__command_start] = ACTIONS(12884),
  },
  [6932] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_else] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6933] = {
    [sym__word_identifier] = ACTIONS(12882),
    [anon_sym_EQ] = ACTIONS(12882),
    [anon_sym_COMMA] = ACTIONS(12882),
    [anon_sym_COLON] = ACTIONS(12882),
    [anon_sym_begin] = ACTIONS(12882),
    [anon_sym_module] = ACTIONS(12882),
    [anon_sym_baremodule] = ACTIONS(12882),
    [anon_sym_end] = ACTIONS(12882),
    [anon_sym_abstract] = ACTIONS(12882),
    [anon_sym_primitive] = ACTIONS(12882),
    [anon_sym_mutable] = ACTIONS(12882),
    [anon_sym_struct] = ACTIONS(12882),
    [anon_sym_function] = ACTIONS(12882),
    [anon_sym_macro] = ACTIONS(12882),
    [anon_sym_where] = ACTIONS(12882),
    [anon_sym_quote] = ACTIONS(12882),
    [anon_sym_let] = ACTIONS(12882),
    [anon_sym_if] = ACTIONS(12882),
    [anon_sym_try] = ACTIONS(12882),
    [anon_sym_finally] = ACTIONS(12882),
    [anon_sym_for] = ACTIONS(12882),
    [anon_sym_while] = ACTIONS(12882),
    [sym_break_statement] = ACTIONS(12882),
    [sym_continue_statement] = ACTIONS(12882),
    [anon_sym_return] = ACTIONS(12882),
    [anon_sym_const] = ACTIONS(12882),
    [anon_sym_global] = ACTIONS(12882),
    [anon_sym_local] = ACTIONS(12882),
    [anon_sym_as] = ACTIONS(12882),
    [anon_sym_LPAREN] = ACTIONS(12882),
    [anon_sym_COLON2] = ACTIONS(12882),
    [anon_sym_export] = ACTIONS(12882),
    [anon_sym_import] = ACTIONS(12882),
    [anon_sym_using] = ACTIONS(12882),
    [anon_sym_LBRACK] = ACTIONS(12882),
    [anon_sym_LF] = ACTIONS(12884),
    [anon_sym_in] = ACTIONS(12882),
    [anon_sym_LBRACE] = ACTIONS(12882),
    [anon_sym_DOT] = ACTIONS(13032),
    [anon_sym_DOLLAR] = ACTIONS(12882),
    [anon_sym_COLON_COLON] = ACTIONS(12882),
    [anon_sym_isa] = ACTIONS(12882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12882),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_AT] = ACTIONS(12882),
    [anon_sym_true] = ACTIONS(12882),
    [anon_sym_false] = ACTIONS(12882),
    [aux_sym_integer_literal_token1] = ACTIONS(12882),
    [aux_sym_integer_literal_token2] = ACTIONS(12882),
    [aux_sym_integer_literal_token3] = ACTIONS(12882),
    [aux_sym_integer_literal_token4] = ACTIONS(12882),
    [aux_sym_float_literal_token1] = ACTIONS(12882),
    [aux_sym_float_literal_token3] = ACTIONS(12882),
    [aux_sym_float_literal_token4] = ACTIONS(12882),
    [sym_character_literal] = ACTIONS(12882),
    [sym__pair_operator] = ACTIONS(12882),
    [sym__arrow_operator] = ACTIONS(12882),
    [sym__lazy_or_operator] = ACTIONS(12882),
    [sym__lazy_and_operator] = ACTIONS(12882),
    [sym__comparison_operator] = ACTIONS(12882),
    [sym__pipe_right_operator] = ACTIONS(12882),
    [sym__pipe_left_operator] = ACTIONS(12882),
    [sym__ellipsis_operator] = ACTIONS(12882),
    [sym__plus_operator] = ACTIONS(12882),
    [sym__times_operator] = ACTIONS(12882),
    [sym__rational_operator] = ACTIONS(12882),
    [sym__bitshift_operator] = ACTIONS(12882),
    [sym__power_operator] = ACTIONS(12882),
    [sym__tilde_operator] = ACTIONS(12882),
    [sym__type_order_operator] = ACTIONS(12882),
    [sym__unary_operator] = ACTIONS(12882),
    [sym__unary_plus_operator] = ACTIONS(12882),
    [aux_sym__terminator_token1] = ACTIONS(12882),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12884),
    [sym__command_start] = ACTIONS(12884),
  },
  [6934] = {
    [sym__word_identifier] = ACTIONS(12886),
    [anon_sym_EQ] = ACTIONS(12886),
    [anon_sym_COMMA] = ACTIONS(12886),
    [anon_sym_COLON] = ACTIONS(12886),
    [anon_sym_begin] = ACTIONS(12886),
    [anon_sym_module] = ACTIONS(12886),
    [anon_sym_baremodule] = ACTIONS(12886),
    [anon_sym_end] = ACTIONS(12886),
    [anon_sym_abstract] = ACTIONS(12886),
    [anon_sym_primitive] = ACTIONS(12886),
    [anon_sym_mutable] = ACTIONS(12886),
    [anon_sym_struct] = ACTIONS(12886),
    [anon_sym_function] = ACTIONS(12886),
    [anon_sym_macro] = ACTIONS(12886),
    [anon_sym_where] = ACTIONS(12886),
    [anon_sym_quote] = ACTIONS(12886),
    [anon_sym_let] = ACTIONS(12886),
    [anon_sym_if] = ACTIONS(12886),
    [anon_sym_try] = ACTIONS(12886),
    [anon_sym_catch] = ACTIONS(12886),
    [anon_sym_for] = ACTIONS(12886),
    [anon_sym_while] = ACTIONS(12886),
    [sym_break_statement] = ACTIONS(12886),
    [sym_continue_statement] = ACTIONS(12886),
    [anon_sym_return] = ACTIONS(12886),
    [anon_sym_const] = ACTIONS(12886),
    [anon_sym_global] = ACTIONS(12886),
    [anon_sym_local] = ACTIONS(12886),
    [anon_sym_as] = ACTIONS(12886),
    [anon_sym_LPAREN] = ACTIONS(12886),
    [anon_sym_COLON2] = ACTIONS(12886),
    [anon_sym_export] = ACTIONS(12886),
    [anon_sym_import] = ACTIONS(12886),
    [anon_sym_using] = ACTIONS(12886),
    [anon_sym_LBRACK] = ACTIONS(12886),
    [anon_sym_LF] = ACTIONS(12888),
    [anon_sym_in] = ACTIONS(12886),
    [anon_sym_LBRACE] = ACTIONS(12886),
    [anon_sym_DOT] = ACTIONS(13010),
    [anon_sym_DOLLAR] = ACTIONS(12886),
    [anon_sym_COLON_COLON] = ACTIONS(12886),
    [anon_sym_isa] = ACTIONS(12886),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_QMARK] = ACTIONS(12886),
    [anon_sym_AT] = ACTIONS(12886),
    [anon_sym_true] = ACTIONS(12886),
    [anon_sym_false] = ACTIONS(12886),
    [aux_sym_integer_literal_token1] = ACTIONS(12886),
    [aux_sym_integer_literal_token2] = ACTIONS(12886),
    [aux_sym_integer_literal_token3] = ACTIONS(12886),
    [aux_sym_integer_literal_token4] = ACTIONS(12886),
    [aux_sym_float_literal_token1] = ACTIONS(12886),
    [aux_sym_float_literal_token3] = ACTIONS(12886),
    [aux_sym_float_literal_token4] = ACTIONS(12886),
    [sym_character_literal] = ACTIONS(12886),
    [sym__pair_operator] = ACTIONS(12886),
    [sym__arrow_operator] = ACTIONS(12886),
    [sym__lazy_or_operator] = ACTIONS(12886),
    [sym__lazy_and_operator] = ACTIONS(12886),
    [sym__comparison_operator] = ACTIONS(12886),
    [sym__pipe_right_operator] = ACTIONS(12886),
    [sym__pipe_left_operator] = ACTIONS(12886),
    [sym__ellipsis_operator] = ACTIONS(12886),
    [sym__plus_operator] = ACTIONS(12886),
    [sym__times_operator] = ACTIONS(12886),
    [sym__rational_operator] = ACTIONS(12886),
    [sym__bitshift_operator] = ACTIONS(12886),
    [sym__power_operator] = ACTIONS(12886),
    [sym__tilde_operator] = ACTIONS(12886),
    [sym__type_order_operator] = ACTIONS(12886),
    [sym__unary_operator] = ACTIONS(12886),
    [sym__unary_plus_operator] = ACTIONS(12886),
    [aux_sym__terminator_token1] = ACTIONS(12886),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12888),
    [sym__command_start] = ACTIONS(12888),
  },
  [6935] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(13034),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6936] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_else] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6937] = {
    [ts_builtin_sym_end] = ACTIONS(12266),
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_RPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_RBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6938] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_else] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6939] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_elseif] = ACTIONS(12334),
    [anon_sym_else] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [6940] = {
    [ts_builtin_sym_end] = ACTIONS(13036),
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_as] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_RPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_RBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [6941] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_else] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6942] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_catch] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_as] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6943] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11876),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6944] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_else] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6945] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_elseif] = ACTIONS(12304),
    [anon_sym_else] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6946] = {
    [sym__word_identifier] = ACTIONS(12886),
    [anon_sym_EQ] = ACTIONS(12886),
    [anon_sym_COMMA] = ACTIONS(12886),
    [anon_sym_COLON] = ACTIONS(12886),
    [anon_sym_begin] = ACTIONS(12886),
    [anon_sym_module] = ACTIONS(12886),
    [anon_sym_baremodule] = ACTIONS(12886),
    [anon_sym_end] = ACTIONS(12886),
    [anon_sym_abstract] = ACTIONS(12886),
    [anon_sym_primitive] = ACTIONS(12886),
    [anon_sym_mutable] = ACTIONS(12886),
    [anon_sym_struct] = ACTIONS(12886),
    [anon_sym_function] = ACTIONS(12886),
    [anon_sym_macro] = ACTIONS(12886),
    [anon_sym_where] = ACTIONS(12886),
    [anon_sym_quote] = ACTIONS(12886),
    [anon_sym_let] = ACTIONS(12886),
    [anon_sym_if] = ACTIONS(12886),
    [anon_sym_try] = ACTIONS(12886),
    [anon_sym_finally] = ACTIONS(12886),
    [anon_sym_for] = ACTIONS(12886),
    [anon_sym_while] = ACTIONS(12886),
    [sym_break_statement] = ACTIONS(12886),
    [sym_continue_statement] = ACTIONS(12886),
    [anon_sym_return] = ACTIONS(12886),
    [anon_sym_const] = ACTIONS(12886),
    [anon_sym_global] = ACTIONS(12886),
    [anon_sym_local] = ACTIONS(12886),
    [anon_sym_as] = ACTIONS(12886),
    [anon_sym_LPAREN] = ACTIONS(12886),
    [anon_sym_COLON2] = ACTIONS(12886),
    [anon_sym_export] = ACTIONS(12886),
    [anon_sym_import] = ACTIONS(12886),
    [anon_sym_using] = ACTIONS(12886),
    [anon_sym_LBRACK] = ACTIONS(12886),
    [anon_sym_LF] = ACTIONS(12888),
    [anon_sym_in] = ACTIONS(12886),
    [anon_sym_LBRACE] = ACTIONS(12886),
    [anon_sym_DOT] = ACTIONS(13032),
    [anon_sym_DOLLAR] = ACTIONS(12886),
    [anon_sym_COLON_COLON] = ACTIONS(12886),
    [anon_sym_isa] = ACTIONS(12886),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_QMARK] = ACTIONS(12886),
    [anon_sym_AT] = ACTIONS(12886),
    [anon_sym_true] = ACTIONS(12886),
    [anon_sym_false] = ACTIONS(12886),
    [aux_sym_integer_literal_token1] = ACTIONS(12886),
    [aux_sym_integer_literal_token2] = ACTIONS(12886),
    [aux_sym_integer_literal_token3] = ACTIONS(12886),
    [aux_sym_integer_literal_token4] = ACTIONS(12886),
    [aux_sym_float_literal_token1] = ACTIONS(12886),
    [aux_sym_float_literal_token3] = ACTIONS(12886),
    [aux_sym_float_literal_token4] = ACTIONS(12886),
    [sym_character_literal] = ACTIONS(12886),
    [sym__pair_operator] = ACTIONS(12886),
    [sym__arrow_operator] = ACTIONS(12886),
    [sym__lazy_or_operator] = ACTIONS(12886),
    [sym__lazy_and_operator] = ACTIONS(12886),
    [sym__comparison_operator] = ACTIONS(12886),
    [sym__pipe_right_operator] = ACTIONS(12886),
    [sym__pipe_left_operator] = ACTIONS(12886),
    [sym__ellipsis_operator] = ACTIONS(12886),
    [sym__plus_operator] = ACTIONS(12886),
    [sym__times_operator] = ACTIONS(12886),
    [sym__rational_operator] = ACTIONS(12886),
    [sym__bitshift_operator] = ACTIONS(12886),
    [sym__power_operator] = ACTIONS(12886),
    [sym__tilde_operator] = ACTIONS(12886),
    [sym__type_order_operator] = ACTIONS(12886),
    [sym__unary_operator] = ACTIONS(12886),
    [sym__unary_plus_operator] = ACTIONS(12886),
    [aux_sym__terminator_token1] = ACTIONS(12886),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12888),
    [sym__command_start] = ACTIONS(12888),
  },
  [6947] = {
    [sym__word_identifier] = ACTIONS(12882),
    [anon_sym_EQ] = ACTIONS(12882),
    [anon_sym_COMMA] = ACTIONS(12882),
    [anon_sym_COLON] = ACTIONS(12882),
    [anon_sym_begin] = ACTIONS(12882),
    [anon_sym_module] = ACTIONS(12882),
    [anon_sym_baremodule] = ACTIONS(12882),
    [anon_sym_abstract] = ACTIONS(12882),
    [anon_sym_primitive] = ACTIONS(12882),
    [anon_sym_mutable] = ACTIONS(12882),
    [anon_sym_struct] = ACTIONS(12882),
    [anon_sym_function] = ACTIONS(12882),
    [anon_sym_macro] = ACTIONS(12882),
    [anon_sym_where] = ACTIONS(12882),
    [anon_sym_quote] = ACTIONS(12882),
    [anon_sym_let] = ACTIONS(12882),
    [anon_sym_if] = ACTIONS(12882),
    [anon_sym_try] = ACTIONS(12882),
    [anon_sym_catch] = ACTIONS(12882),
    [anon_sym_finally] = ACTIONS(12882),
    [anon_sym_for] = ACTIONS(12882),
    [anon_sym_while] = ACTIONS(12882),
    [sym_break_statement] = ACTIONS(12882),
    [sym_continue_statement] = ACTIONS(12882),
    [anon_sym_return] = ACTIONS(12882),
    [anon_sym_const] = ACTIONS(12882),
    [anon_sym_global] = ACTIONS(12882),
    [anon_sym_local] = ACTIONS(12882),
    [anon_sym_as] = ACTIONS(12882),
    [anon_sym_LPAREN] = ACTIONS(12882),
    [anon_sym_COLON2] = ACTIONS(12882),
    [anon_sym_export] = ACTIONS(12882),
    [anon_sym_import] = ACTIONS(12882),
    [anon_sym_using] = ACTIONS(12882),
    [anon_sym_LBRACK] = ACTIONS(12882),
    [anon_sym_LF] = ACTIONS(12884),
    [anon_sym_in] = ACTIONS(12882),
    [anon_sym_LBRACE] = ACTIONS(12882),
    [anon_sym_DOT] = ACTIONS(12966),
    [anon_sym_DOLLAR] = ACTIONS(12882),
    [anon_sym_COLON_COLON] = ACTIONS(12882),
    [anon_sym_isa] = ACTIONS(12882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12882),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_AT] = ACTIONS(12882),
    [anon_sym_true] = ACTIONS(12882),
    [anon_sym_false] = ACTIONS(12882),
    [aux_sym_integer_literal_token1] = ACTIONS(12882),
    [aux_sym_integer_literal_token2] = ACTIONS(12882),
    [aux_sym_integer_literal_token3] = ACTIONS(12882),
    [aux_sym_integer_literal_token4] = ACTIONS(12882),
    [aux_sym_float_literal_token1] = ACTIONS(12882),
    [aux_sym_float_literal_token3] = ACTIONS(12882),
    [aux_sym_float_literal_token4] = ACTIONS(12882),
    [sym_character_literal] = ACTIONS(12882),
    [sym__pair_operator] = ACTIONS(12882),
    [sym__arrow_operator] = ACTIONS(12882),
    [sym__lazy_or_operator] = ACTIONS(12882),
    [sym__lazy_and_operator] = ACTIONS(12882),
    [sym__comparison_operator] = ACTIONS(12882),
    [sym__pipe_right_operator] = ACTIONS(12882),
    [sym__pipe_left_operator] = ACTIONS(12882),
    [sym__ellipsis_operator] = ACTIONS(12882),
    [sym__plus_operator] = ACTIONS(12882),
    [sym__times_operator] = ACTIONS(12882),
    [sym__rational_operator] = ACTIONS(12882),
    [sym__bitshift_operator] = ACTIONS(12882),
    [sym__power_operator] = ACTIONS(12882),
    [sym__tilde_operator] = ACTIONS(12882),
    [sym__type_order_operator] = ACTIONS(12882),
    [sym__unary_operator] = ACTIONS(12882),
    [sym__unary_plus_operator] = ACTIONS(12882),
    [aux_sym__terminator_token1] = ACTIONS(12882),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12884),
    [sym__command_start] = ACTIONS(12884),
  },
  [6948] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_else] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6949] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_else] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6950] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_else] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [6951] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_else] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [6952] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_else] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6953] = {
    [sym__word_identifier] = ACTIONS(12886),
    [anon_sym_EQ] = ACTIONS(12886),
    [anon_sym_COMMA] = ACTIONS(12886),
    [anon_sym_COLON] = ACTIONS(12886),
    [anon_sym_begin] = ACTIONS(12886),
    [anon_sym_module] = ACTIONS(12886),
    [anon_sym_baremodule] = ACTIONS(12886),
    [anon_sym_abstract] = ACTIONS(12886),
    [anon_sym_primitive] = ACTIONS(12886),
    [anon_sym_mutable] = ACTIONS(12886),
    [anon_sym_struct] = ACTIONS(12886),
    [anon_sym_function] = ACTIONS(12886),
    [anon_sym_macro] = ACTIONS(12886),
    [anon_sym_where] = ACTIONS(12886),
    [anon_sym_quote] = ACTIONS(12886),
    [anon_sym_let] = ACTIONS(12886),
    [anon_sym_if] = ACTIONS(12886),
    [anon_sym_try] = ACTIONS(12886),
    [anon_sym_catch] = ACTIONS(12886),
    [anon_sym_finally] = ACTIONS(12886),
    [anon_sym_for] = ACTIONS(12886),
    [anon_sym_while] = ACTIONS(12886),
    [sym_break_statement] = ACTIONS(12886),
    [sym_continue_statement] = ACTIONS(12886),
    [anon_sym_return] = ACTIONS(12886),
    [anon_sym_const] = ACTIONS(12886),
    [anon_sym_global] = ACTIONS(12886),
    [anon_sym_local] = ACTIONS(12886),
    [anon_sym_as] = ACTIONS(12886),
    [anon_sym_LPAREN] = ACTIONS(12886),
    [anon_sym_COLON2] = ACTIONS(12886),
    [anon_sym_export] = ACTIONS(12886),
    [anon_sym_import] = ACTIONS(12886),
    [anon_sym_using] = ACTIONS(12886),
    [anon_sym_LBRACK] = ACTIONS(12886),
    [anon_sym_LF] = ACTIONS(12888),
    [anon_sym_in] = ACTIONS(12886),
    [anon_sym_LBRACE] = ACTIONS(12886),
    [anon_sym_DOT] = ACTIONS(12966),
    [anon_sym_DOLLAR] = ACTIONS(12886),
    [anon_sym_COLON_COLON] = ACTIONS(12886),
    [anon_sym_isa] = ACTIONS(12886),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_QMARK] = ACTIONS(12886),
    [anon_sym_AT] = ACTIONS(12886),
    [anon_sym_true] = ACTIONS(12886),
    [anon_sym_false] = ACTIONS(12886),
    [aux_sym_integer_literal_token1] = ACTIONS(12886),
    [aux_sym_integer_literal_token2] = ACTIONS(12886),
    [aux_sym_integer_literal_token3] = ACTIONS(12886),
    [aux_sym_integer_literal_token4] = ACTIONS(12886),
    [aux_sym_float_literal_token1] = ACTIONS(12886),
    [aux_sym_float_literal_token3] = ACTIONS(12886),
    [aux_sym_float_literal_token4] = ACTIONS(12886),
    [sym_character_literal] = ACTIONS(12886),
    [sym__pair_operator] = ACTIONS(12886),
    [sym__arrow_operator] = ACTIONS(12886),
    [sym__lazy_or_operator] = ACTIONS(12886),
    [sym__lazy_and_operator] = ACTIONS(12886),
    [sym__comparison_operator] = ACTIONS(12886),
    [sym__pipe_right_operator] = ACTIONS(12886),
    [sym__pipe_left_operator] = ACTIONS(12886),
    [sym__ellipsis_operator] = ACTIONS(12886),
    [sym__plus_operator] = ACTIONS(12886),
    [sym__times_operator] = ACTIONS(12886),
    [sym__rational_operator] = ACTIONS(12886),
    [sym__bitshift_operator] = ACTIONS(12886),
    [sym__power_operator] = ACTIONS(12886),
    [sym__tilde_operator] = ACTIONS(12886),
    [sym__type_order_operator] = ACTIONS(12886),
    [sym__unary_operator] = ACTIONS(12886),
    [sym__unary_plus_operator] = ACTIONS(12886),
    [aux_sym__terminator_token1] = ACTIONS(12886),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12888),
    [sym__command_start] = ACTIONS(12888),
  },
  [6954] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_catch] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_as] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [6955] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_as] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6956] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_catch] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_as] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6957] = {
    [ts_builtin_sym_end] = ACTIONS(12270),
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_RPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_RBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [6958] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_else] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6959] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_else] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6960] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_catch] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_as] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [6961] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_else] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6962] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12242),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_as] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12242),
    [anon_sym_RPAREN] = ACTIONS(12242),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12242),
    [anon_sym_RBRACK] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_SEMI] = ACTIONS(12242),
    [anon_sym_LBRACE] = ACTIONS(12242),
    [anon_sym_RBRACE] = ACTIONS(12242),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12242),
    [anon_sym_COLON_COLON] = ACTIONS(12242),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12242),
    [anon_sym_QMARK] = ACTIONS(12242),
    [anon_sym_AT] = ACTIONS(12242),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12242),
    [aux_sym_integer_literal_token2] = ACTIONS(12242),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12242),
    [aux_sym_float_literal_token3] = ACTIONS(12242),
    [aux_sym_float_literal_token4] = ACTIONS(12242),
    [sym_character_literal] = ACTIONS(12242),
    [sym__pair_operator] = ACTIONS(12242),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12242),
    [sym__lazy_and_operator] = ACTIONS(12242),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12242),
    [sym__pipe_left_operator] = ACTIONS(12242),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12242),
    [sym__bitshift_operator] = ACTIONS(12242),
    [sym__power_operator] = ACTIONS(12242),
    [sym__tilde_operator] = ACTIONS(12242),
    [sym__type_order_operator] = ACTIONS(12242),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6963] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_elseif] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12910),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6964] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_else] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6965] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12246),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_as] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12246),
    [anon_sym_RPAREN] = ACTIONS(12246),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12246),
    [anon_sym_RBRACK] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_SEMI] = ACTIONS(12246),
    [anon_sym_LBRACE] = ACTIONS(12246),
    [anon_sym_RBRACE] = ACTIONS(12246),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12246),
    [anon_sym_COLON_COLON] = ACTIONS(12246),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12246),
    [anon_sym_QMARK] = ACTIONS(12246),
    [anon_sym_AT] = ACTIONS(12246),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12246),
    [aux_sym_integer_literal_token2] = ACTIONS(12246),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12246),
    [aux_sym_float_literal_token3] = ACTIONS(12246),
    [aux_sym_float_literal_token4] = ACTIONS(12246),
    [sym_character_literal] = ACTIONS(12246),
    [sym__pair_operator] = ACTIONS(12246),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12246),
    [sym__lazy_and_operator] = ACTIONS(12246),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12246),
    [sym__pipe_left_operator] = ACTIONS(12246),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12246),
    [sym__bitshift_operator] = ACTIONS(12246),
    [sym__power_operator] = ACTIONS(12246),
    [sym__tilde_operator] = ACTIONS(12246),
    [sym__type_order_operator] = ACTIONS(12246),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [6966] = {
    [ts_builtin_sym_end] = ACTIONS(12254),
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_RPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_RBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [6967] = {
    [ts_builtin_sym_end] = ACTIONS(12242),
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_RPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_RBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [6968] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_elseif] = ACTIONS(12154),
    [anon_sym_else] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [6969] = {
    [sym_identifier] = STATE(7884),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_catch] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [6970] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_else] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6971] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_else] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [6972] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_else] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [6973] = {
    [sym_identifier] = STATE(8057),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_as] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_RPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_SEMI] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [6974] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12274),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_as] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12274),
    [anon_sym_RPAREN] = ACTIONS(12274),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12274),
    [anon_sym_RBRACK] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_SEMI] = ACTIONS(12274),
    [anon_sym_LBRACE] = ACTIONS(12274),
    [anon_sym_RBRACE] = ACTIONS(12274),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12274),
    [anon_sym_COLON_COLON] = ACTIONS(12274),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12274),
    [anon_sym_QMARK] = ACTIONS(12274),
    [anon_sym_AT] = ACTIONS(12274),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12274),
    [aux_sym_integer_literal_token2] = ACTIONS(12274),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12274),
    [aux_sym_float_literal_token3] = ACTIONS(12274),
    [aux_sym_float_literal_token4] = ACTIONS(12274),
    [sym_character_literal] = ACTIONS(12274),
    [sym__pair_operator] = ACTIONS(12274),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12274),
    [sym__lazy_and_operator] = ACTIONS(12274),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12274),
    [sym__pipe_left_operator] = ACTIONS(12274),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12274),
    [sym__bitshift_operator] = ACTIONS(12274),
    [sym__power_operator] = ACTIONS(12274),
    [sym__tilde_operator] = ACTIONS(12274),
    [sym__type_order_operator] = ACTIONS(12274),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [6975] = {
    [sym__primary_expression] = STATE(11344),
    [sym__array] = STATE(11344),
    [sym_comprehension_expression] = STATE(11344),
    [sym_matrix_expression] = STATE(11344),
    [sym_vector_expression] = STATE(11344),
    [sym_parenthesized_expression] = STATE(11344),
    [sym_tuple_expression] = STATE(11344),
    [sym_curly_expression] = STATE(11344),
    [sym_adjoint_expression] = STATE(11344),
    [sym_field_expression] = STATE(11344),
    [sym_index_expression] = STATE(11344),
    [sym_parametrized_type_expression] = STATE(11344),
    [sym_call_expression] = STATE(11344),
    [sym_broadcast_call_expression] = STATE(11344),
    [sym__closed_macrocall_expression] = STATE(11344),
    [sym_interpolation_expression] = STATE(11344),
    [sym_quote_expression] = STATE(11344),
    [sym_macro_identifier] = STATE(17042),
    [sym_identifier] = STATE(10822),
    [sym_boolean_literal] = STATE(11344),
    [sym__string] = STATE(11344),
    [sym_string_literal] = STATE(11344),
    [sym_command_literal] = STATE(11344),
    [sym_prefixed_string_literal] = STATE(11344),
    [sym_prefixed_command_literal] = STATE(11344),
    [sym_operator] = STATE(19221),
    [sym__word_identifier] = ACTIONS(13040),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(13042),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(13044),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(13046),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(13048),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(13050),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(13052),
    [anon_sym_false] = ACTIONS(13052),
    [sym_character_literal] = ACTIONS(13054),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13056),
    [sym__command_start] = ACTIONS(13058),
  },
  [6976] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_else] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [6977] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_else] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [6978] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12450),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12376),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6979] = {
    [aux_sym_export_statement_repeat1] = STATE(7001),
    [sym__word_identifier] = ACTIONS(13060),
    [anon_sym_EQ] = ACTIONS(13060),
    [anon_sym_COMMA] = ACTIONS(13062),
    [anon_sym_COLON] = ACTIONS(13060),
    [anon_sym_begin] = ACTIONS(13060),
    [anon_sym_module] = ACTIONS(13060),
    [anon_sym_baremodule] = ACTIONS(13060),
    [anon_sym_end] = ACTIONS(13060),
    [anon_sym_abstract] = ACTIONS(13060),
    [anon_sym_primitive] = ACTIONS(13060),
    [anon_sym_mutable] = ACTIONS(13060),
    [anon_sym_struct] = ACTIONS(13060),
    [anon_sym_function] = ACTIONS(13060),
    [anon_sym_macro] = ACTIONS(13060),
    [anon_sym_where] = ACTIONS(13060),
    [anon_sym_quote] = ACTIONS(13060),
    [anon_sym_let] = ACTIONS(13060),
    [anon_sym_if] = ACTIONS(13060),
    [anon_sym_elseif] = ACTIONS(13060),
    [anon_sym_else] = ACTIONS(13060),
    [anon_sym_try] = ACTIONS(13060),
    [anon_sym_for] = ACTIONS(13060),
    [anon_sym_while] = ACTIONS(13060),
    [sym_break_statement] = ACTIONS(13060),
    [sym_continue_statement] = ACTIONS(13060),
    [anon_sym_return] = ACTIONS(13060),
    [anon_sym_const] = ACTIONS(13060),
    [anon_sym_global] = ACTIONS(13060),
    [anon_sym_local] = ACTIONS(13060),
    [anon_sym_LPAREN] = ACTIONS(13060),
    [anon_sym_COLON2] = ACTIONS(13060),
    [anon_sym_export] = ACTIONS(13060),
    [anon_sym_import] = ACTIONS(13060),
    [anon_sym_using] = ACTIONS(13060),
    [anon_sym_LBRACK] = ACTIONS(13060),
    [anon_sym_LF] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13060),
    [anon_sym_LBRACE] = ACTIONS(13060),
    [anon_sym_DOLLAR] = ACTIONS(13060),
    [anon_sym_COLON_COLON] = ACTIONS(13060),
    [anon_sym_isa] = ACTIONS(13060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13060),
    [anon_sym_QMARK] = ACTIONS(13060),
    [anon_sym_AT] = ACTIONS(13060),
    [anon_sym_true] = ACTIONS(13060),
    [anon_sym_false] = ACTIONS(13060),
    [aux_sym_integer_literal_token1] = ACTIONS(13060),
    [aux_sym_integer_literal_token2] = ACTIONS(13060),
    [aux_sym_integer_literal_token3] = ACTIONS(13060),
    [aux_sym_integer_literal_token4] = ACTIONS(13060),
    [aux_sym_float_literal_token1] = ACTIONS(13060),
    [aux_sym_float_literal_token3] = ACTIONS(13060),
    [aux_sym_float_literal_token4] = ACTIONS(13060),
    [sym_character_literal] = ACTIONS(13060),
    [sym__pair_operator] = ACTIONS(13060),
    [sym__arrow_operator] = ACTIONS(13060),
    [sym__lazy_or_operator] = ACTIONS(13060),
    [sym__lazy_and_operator] = ACTIONS(13060),
    [sym__comparison_operator] = ACTIONS(13060),
    [sym__pipe_right_operator] = ACTIONS(13060),
    [sym__pipe_left_operator] = ACTIONS(13060),
    [sym__ellipsis_operator] = ACTIONS(13060),
    [sym__plus_operator] = ACTIONS(13060),
    [sym__times_operator] = ACTIONS(13060),
    [sym__rational_operator] = ACTIONS(13060),
    [sym__bitshift_operator] = ACTIONS(13060),
    [sym__power_operator] = ACTIONS(13060),
    [sym__tilde_operator] = ACTIONS(13060),
    [sym__type_order_operator] = ACTIONS(13060),
    [sym__unary_operator] = ACTIONS(13060),
    [sym__unary_plus_operator] = ACTIONS(13060),
    [aux_sym__terminator_token1] = ACTIONS(13060),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13064),
    [sym__command_start] = ACTIONS(13064),
  },
  [6980] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_as] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6981] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_else] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [6982] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_as] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [6983] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_as] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [6984] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_as] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [6985] = {
    [sym_identifier] = STATE(8058),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_as] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_RPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_SEMI] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [6986] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12250),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_as] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12250),
    [anon_sym_RPAREN] = ACTIONS(12250),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12250),
    [anon_sym_RBRACK] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_SEMI] = ACTIONS(12250),
    [anon_sym_LBRACE] = ACTIONS(12250),
    [anon_sym_RBRACE] = ACTIONS(12250),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12250),
    [anon_sym_COLON_COLON] = ACTIONS(12250),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12250),
    [anon_sym_QMARK] = ACTIONS(12250),
    [anon_sym_AT] = ACTIONS(12250),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12250),
    [aux_sym_integer_literal_token2] = ACTIONS(12250),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12250),
    [aux_sym_float_literal_token3] = ACTIONS(12250),
    [aux_sym_float_literal_token4] = ACTIONS(12250),
    [sym_character_literal] = ACTIONS(12250),
    [sym__pair_operator] = ACTIONS(12250),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12250),
    [sym__lazy_and_operator] = ACTIONS(12250),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12250),
    [sym__pipe_left_operator] = ACTIONS(12250),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12250),
    [sym__bitshift_operator] = ACTIONS(12250),
    [sym__power_operator] = ACTIONS(12250),
    [sym__tilde_operator] = ACTIONS(12250),
    [sym__type_order_operator] = ACTIONS(12250),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [6987] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_elseif] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [6988] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [6989] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_else] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [6990] = {
    [aux_sym__import_list_repeat1] = STATE(7005),
    [sym__word_identifier] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(12864),
    [anon_sym_COLON] = ACTIONS(13066),
    [anon_sym_begin] = ACTIONS(13066),
    [anon_sym_module] = ACTIONS(13066),
    [anon_sym_baremodule] = ACTIONS(13066),
    [anon_sym_end] = ACTIONS(13066),
    [anon_sym_abstract] = ACTIONS(13066),
    [anon_sym_primitive] = ACTIONS(13066),
    [anon_sym_mutable] = ACTIONS(13066),
    [anon_sym_struct] = ACTIONS(13066),
    [anon_sym_function] = ACTIONS(13066),
    [anon_sym_macro] = ACTIONS(13066),
    [anon_sym_where] = ACTIONS(13066),
    [anon_sym_quote] = ACTIONS(13066),
    [anon_sym_let] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13066),
    [anon_sym_elseif] = ACTIONS(13066),
    [anon_sym_else] = ACTIONS(13066),
    [anon_sym_try] = ACTIONS(13066),
    [anon_sym_for] = ACTIONS(13066),
    [anon_sym_while] = ACTIONS(13066),
    [sym_break_statement] = ACTIONS(13066),
    [sym_continue_statement] = ACTIONS(13066),
    [anon_sym_return] = ACTIONS(13066),
    [anon_sym_const] = ACTIONS(13066),
    [anon_sym_global] = ACTIONS(13066),
    [anon_sym_local] = ACTIONS(13066),
    [anon_sym_LPAREN] = ACTIONS(13066),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_export] = ACTIONS(13066),
    [anon_sym_import] = ACTIONS(13066),
    [anon_sym_using] = ACTIONS(13066),
    [anon_sym_LBRACK] = ACTIONS(13066),
    [anon_sym_LF] = ACTIONS(13068),
    [anon_sym_in] = ACTIONS(13066),
    [anon_sym_LBRACE] = ACTIONS(13066),
    [anon_sym_DOLLAR] = ACTIONS(13066),
    [anon_sym_COLON_COLON] = ACTIONS(13066),
    [anon_sym_isa] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13066),
    [anon_sym_QMARK] = ACTIONS(13066),
    [anon_sym_AT] = ACTIONS(13066),
    [anon_sym_true] = ACTIONS(13066),
    [anon_sym_false] = ACTIONS(13066),
    [aux_sym_integer_literal_token1] = ACTIONS(13066),
    [aux_sym_integer_literal_token2] = ACTIONS(13066),
    [aux_sym_integer_literal_token3] = ACTIONS(13066),
    [aux_sym_integer_literal_token4] = ACTIONS(13066),
    [aux_sym_float_literal_token1] = ACTIONS(13066),
    [aux_sym_float_literal_token3] = ACTIONS(13066),
    [aux_sym_float_literal_token4] = ACTIONS(13066),
    [sym_character_literal] = ACTIONS(13066),
    [sym__pair_operator] = ACTIONS(13066),
    [sym__arrow_operator] = ACTIONS(13066),
    [sym__lazy_or_operator] = ACTIONS(13066),
    [sym__lazy_and_operator] = ACTIONS(13066),
    [sym__comparison_operator] = ACTIONS(13066),
    [sym__pipe_right_operator] = ACTIONS(13066),
    [sym__pipe_left_operator] = ACTIONS(13066),
    [sym__ellipsis_operator] = ACTIONS(13066),
    [sym__plus_operator] = ACTIONS(13066),
    [sym__times_operator] = ACTIONS(13066),
    [sym__rational_operator] = ACTIONS(13066),
    [sym__bitshift_operator] = ACTIONS(13066),
    [sym__power_operator] = ACTIONS(13066),
    [sym__tilde_operator] = ACTIONS(13066),
    [sym__type_order_operator] = ACTIONS(13066),
    [sym__unary_operator] = ACTIONS(13066),
    [sym__unary_plus_operator] = ACTIONS(13066),
    [aux_sym__terminator_token1] = ACTIONS(13066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13068),
    [sym__command_start] = ACTIONS(13068),
  },
  [6991] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_else] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [6992] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12278),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_as] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12278),
    [anon_sym_RPAREN] = ACTIONS(12278),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12278),
    [anon_sym_RBRACK] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12278),
    [anon_sym_LBRACE] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(12278),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12278),
    [anon_sym_COLON_COLON] = ACTIONS(12278),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12278),
    [anon_sym_QMARK] = ACTIONS(12278),
    [anon_sym_AT] = ACTIONS(12278),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12278),
    [aux_sym_integer_literal_token2] = ACTIONS(12278),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12278),
    [aux_sym_float_literal_token3] = ACTIONS(12278),
    [aux_sym_float_literal_token4] = ACTIONS(12278),
    [sym_character_literal] = ACTIONS(12278),
    [sym__pair_operator] = ACTIONS(12278),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12278),
    [sym__lazy_and_operator] = ACTIONS(12278),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12278),
    [sym__pipe_left_operator] = ACTIONS(12278),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12278),
    [sym__bitshift_operator] = ACTIONS(12278),
    [sym__power_operator] = ACTIONS(12278),
    [sym__tilde_operator] = ACTIONS(12278),
    [sym__type_order_operator] = ACTIONS(12278),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [6993] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [6994] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_catch] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_as] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [6995] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11870),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [6996] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_as] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [6997] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [6998] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_as] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [6999] = {
    [sym_identifier] = STATE(8064),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_as] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_RPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_SEMI] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [7000] = {
    [aux_sym_open_tuple_repeat1] = STATE(7000),
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13072),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_end] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13070),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_else] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_finally] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(13070),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13070),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(13070),
    [anon_sym_isa] = ACTIONS(13070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13070),
    [anon_sym_QMARK] = ACTIONS(13070),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(13070),
    [sym__arrow_operator] = ACTIONS(13070),
    [sym__lazy_or_operator] = ACTIONS(13070),
    [sym__lazy_and_operator] = ACTIONS(13070),
    [sym__comparison_operator] = ACTIONS(13070),
    [sym__pipe_right_operator] = ACTIONS(13070),
    [sym__pipe_left_operator] = ACTIONS(13070),
    [sym__ellipsis_operator] = ACTIONS(13070),
    [sym__plus_operator] = ACTIONS(13070),
    [sym__times_operator] = ACTIONS(13070),
    [sym__rational_operator] = ACTIONS(13070),
    [sym__bitshift_operator] = ACTIONS(13070),
    [sym__power_operator] = ACTIONS(13070),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(13070),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13070),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [7001] = {
    [aux_sym_export_statement_repeat1] = STATE(7001),
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(13077),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_end] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_elseif] = ACTIONS(12974),
    [anon_sym_else] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [7002] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_catch] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_as] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [7003] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_as] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [7004] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_elseif] = ACTIONS(12981),
    [anon_sym_else] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_as] = ACTIONS(12866),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7005] = {
    [aux_sym__import_list_repeat1] = STATE(7005),
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(13080),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_elseif] = ACTIONS(12981),
    [anon_sym_else] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7006] = {
    [sym_identifier] = STATE(8065),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_as] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_RPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_SEMI] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [7007] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_DOLLAR] = ACTIONS(12096),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12908),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12096),
    [sym__bitshift_operator] = ACTIONS(12096),
    [sym__power_operator] = ACTIONS(12096),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7008] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_as] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [7009] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12068),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_as] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12068),
    [anon_sym_RPAREN] = ACTIONS(12068),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12068),
    [anon_sym_RBRACK] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12068),
    [anon_sym_LBRACE] = ACTIONS(12068),
    [anon_sym_RBRACE] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12068),
    [anon_sym_COLON_COLON] = ACTIONS(12068),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12068),
    [anon_sym_QMARK] = ACTIONS(12068),
    [anon_sym_AT] = ACTIONS(12068),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12068),
    [aux_sym_integer_literal_token2] = ACTIONS(12068),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12068),
    [aux_sym_float_literal_token3] = ACTIONS(12068),
    [aux_sym_float_literal_token4] = ACTIONS(12068),
    [sym_character_literal] = ACTIONS(12068),
    [sym__pair_operator] = ACTIONS(12068),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12068),
    [sym__lazy_and_operator] = ACTIONS(12068),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12068),
    [sym__pipe_left_operator] = ACTIONS(12068),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12068),
    [sym__bitshift_operator] = ACTIONS(12068),
    [sym__power_operator] = ACTIONS(12068),
    [sym__tilde_operator] = ACTIONS(12068),
    [sym__type_order_operator] = ACTIONS(12068),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [7010] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_catch] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_as] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7011] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_catch] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_as] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [7012] = {
    [aux_sym_export_statement_repeat1] = STATE(7012),
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(13083),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_end] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_else] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_finally] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [7013] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12282),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_as] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12282),
    [anon_sym_RPAREN] = ACTIONS(12282),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12282),
    [anon_sym_RBRACK] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_SEMI] = ACTIONS(12282),
    [anon_sym_LBRACE] = ACTIONS(12282),
    [anon_sym_RBRACE] = ACTIONS(12282),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12282),
    [anon_sym_COLON_COLON] = ACTIONS(12282),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12282),
    [anon_sym_QMARK] = ACTIONS(12282),
    [anon_sym_AT] = ACTIONS(12282),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12282),
    [aux_sym_integer_literal_token2] = ACTIONS(12282),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12282),
    [aux_sym_float_literal_token3] = ACTIONS(12282),
    [aux_sym_float_literal_token4] = ACTIONS(12282),
    [sym_character_literal] = ACTIONS(12282),
    [sym__pair_operator] = ACTIONS(12282),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12282),
    [sym__lazy_and_operator] = ACTIONS(12282),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12282),
    [sym__pipe_left_operator] = ACTIONS(12282),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12282),
    [sym__bitshift_operator] = ACTIONS(12282),
    [sym__power_operator] = ACTIONS(12282),
    [sym__tilde_operator] = ACTIONS(12282),
    [sym__type_order_operator] = ACTIONS(12282),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [7014] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12676),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12676),
    [anon_sym_RPAREN] = ACTIONS(12676),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12676),
    [anon_sym_RBRACK] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12676),
    [anon_sym_LBRACE] = ACTIONS(12676),
    [anon_sym_RBRACE] = ACTIONS(12676),
    [anon_sym_DOT] = ACTIONS(13086),
    [anon_sym_DOLLAR] = ACTIONS(12676),
    [anon_sym_COLON_COLON] = ACTIONS(12676),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12676),
    [anon_sym_QMARK] = ACTIONS(12676),
    [anon_sym_AT] = ACTIONS(12676),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12676),
    [aux_sym_integer_literal_token2] = ACTIONS(12676),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12676),
    [aux_sym_float_literal_token3] = ACTIONS(12676),
    [aux_sym_float_literal_token4] = ACTIONS(12676),
    [sym_character_literal] = ACTIONS(12676),
    [sym__pair_operator] = ACTIONS(12676),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12676),
    [sym__lazy_and_operator] = ACTIONS(12676),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12676),
    [sym__pipe_left_operator] = ACTIONS(12676),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12676),
    [sym__bitshift_operator] = ACTIONS(12676),
    [sym__power_operator] = ACTIONS(12676),
    [sym__tilde_operator] = ACTIONS(12676),
    [sym__type_order_operator] = ACTIONS(12676),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7015] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_elseif] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(13088),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7016] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12228),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7017] = {
    [ts_builtin_sym_end] = ACTIONS(12390),
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_RPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_RBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7018] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12620),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_as] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12620),
    [anon_sym_RPAREN] = ACTIONS(12620),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12620),
    [anon_sym_RBRACK] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_SEMI] = ACTIONS(12620),
    [anon_sym_LBRACE] = ACTIONS(12620),
    [anon_sym_RBRACE] = ACTIONS(12620),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12620),
    [anon_sym_COLON_COLON] = ACTIONS(12620),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12620),
    [anon_sym_QMARK] = ACTIONS(12620),
    [anon_sym_AT] = ACTIONS(12620),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12620),
    [aux_sym_integer_literal_token2] = ACTIONS(12620),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12620),
    [aux_sym_float_literal_token3] = ACTIONS(12620),
    [aux_sym_float_literal_token4] = ACTIONS(12620),
    [sym_character_literal] = ACTIONS(12620),
    [sym__pair_operator] = ACTIONS(12620),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12620),
    [sym__lazy_and_operator] = ACTIONS(12620),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12620),
    [sym__pipe_left_operator] = ACTIONS(12620),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12620),
    [sym__bitshift_operator] = ACTIONS(12620),
    [sym__power_operator] = ACTIONS(12620),
    [sym__tilde_operator] = ACTIONS(12620),
    [sym__type_order_operator] = ACTIONS(12620),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7019] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_catch] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_as] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [7020] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12140),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_as] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12140),
    [anon_sym_RPAREN] = ACTIONS(12140),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12140),
    [anon_sym_RBRACK] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_SEMI] = ACTIONS(12140),
    [anon_sym_LBRACE] = ACTIONS(12140),
    [anon_sym_RBRACE] = ACTIONS(12140),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12140),
    [anon_sym_COLON_COLON] = ACTIONS(12140),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12140),
    [anon_sym_QMARK] = ACTIONS(12140),
    [anon_sym_AT] = ACTIONS(12140),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12140),
    [aux_sym_integer_literal_token2] = ACTIONS(12140),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12140),
    [aux_sym_float_literal_token3] = ACTIONS(12140),
    [aux_sym_float_literal_token4] = ACTIONS(12140),
    [sym_character_literal] = ACTIONS(12140),
    [sym__pair_operator] = ACTIONS(12140),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12140),
    [sym__lazy_and_operator] = ACTIONS(12140),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12140),
    [sym__pipe_left_operator] = ACTIONS(12140),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12140),
    [sym__bitshift_operator] = ACTIONS(12140),
    [sym__power_operator] = ACTIONS(12140),
    [sym__tilde_operator] = ACTIONS(12140),
    [sym__type_order_operator] = ACTIONS(12140),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [7021] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12144),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_as] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12144),
    [anon_sym_RPAREN] = ACTIONS(12144),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12144),
    [anon_sym_RBRACK] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_SEMI] = ACTIONS(12144),
    [anon_sym_LBRACE] = ACTIONS(12144),
    [anon_sym_RBRACE] = ACTIONS(12144),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12144),
    [anon_sym_COLON_COLON] = ACTIONS(12144),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12144),
    [anon_sym_QMARK] = ACTIONS(12144),
    [anon_sym_AT] = ACTIONS(12144),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12144),
    [aux_sym_integer_literal_token2] = ACTIONS(12144),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12144),
    [aux_sym_float_literal_token3] = ACTIONS(12144),
    [aux_sym_float_literal_token4] = ACTIONS(12144),
    [sym_character_literal] = ACTIONS(12144),
    [sym__pair_operator] = ACTIONS(12144),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12144),
    [sym__lazy_and_operator] = ACTIONS(12144),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12144),
    [sym__pipe_left_operator] = ACTIONS(12144),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12144),
    [sym__bitshift_operator] = ACTIONS(12144),
    [sym__power_operator] = ACTIONS(12144),
    [sym__tilde_operator] = ACTIONS(12144),
    [sym__type_order_operator] = ACTIONS(12144),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [7022] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12148),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_as] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12148),
    [anon_sym_RPAREN] = ACTIONS(12148),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12148),
    [anon_sym_RBRACK] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_SEMI] = ACTIONS(12148),
    [anon_sym_LBRACE] = ACTIONS(12148),
    [anon_sym_RBRACE] = ACTIONS(12148),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12148),
    [anon_sym_COLON_COLON] = ACTIONS(12148),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12148),
    [anon_sym_QMARK] = ACTIONS(12148),
    [anon_sym_AT] = ACTIONS(12148),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12148),
    [aux_sym_integer_literal_token2] = ACTIONS(12148),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12148),
    [aux_sym_float_literal_token3] = ACTIONS(12148),
    [aux_sym_float_literal_token4] = ACTIONS(12148),
    [sym_character_literal] = ACTIONS(12148),
    [sym__pair_operator] = ACTIONS(12148),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12148),
    [sym__lazy_and_operator] = ACTIONS(12148),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12148),
    [sym__pipe_left_operator] = ACTIONS(12148),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12148),
    [sym__bitshift_operator] = ACTIONS(12148),
    [sym__power_operator] = ACTIONS(12148),
    [sym__tilde_operator] = ACTIONS(12148),
    [sym__type_order_operator] = ACTIONS(12148),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [7023] = {
    [ts_builtin_sym_end] = ACTIONS(12258),
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_RPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_RBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [7024] = {
    [aux_sym__import_list_repeat1] = STATE(8019),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13090),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13092),
    [anon_sym_LPAREN] = ACTIONS(12868),
    [anon_sym_RPAREN] = ACTIONS(12868),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12868),
    [anon_sym_RBRACK] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_SEMI] = ACTIONS(12868),
    [anon_sym_LBRACE] = ACTIONS(12868),
    [anon_sym_RBRACE] = ACTIONS(12868),
    [anon_sym_DOLLAR] = ACTIONS(12868),
    [anon_sym_COLON_COLON] = ACTIONS(12868),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12868),
    [anon_sym_QMARK] = ACTIONS(12868),
    [anon_sym_AT] = ACTIONS(12868),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12868),
    [aux_sym_integer_literal_token2] = ACTIONS(12868),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12868),
    [aux_sym_float_literal_token3] = ACTIONS(12868),
    [aux_sym_float_literal_token4] = ACTIONS(12868),
    [sym_character_literal] = ACTIONS(12868),
    [sym__pair_operator] = ACTIONS(12868),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12868),
    [sym__lazy_and_operator] = ACTIONS(12868),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12868),
    [sym__pipe_left_operator] = ACTIONS(12868),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12868),
    [sym__bitshift_operator] = ACTIONS(12868),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(12868),
    [sym__type_order_operator] = ACTIONS(12868),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7025] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7026] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_as] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [7027] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_elseif] = ACTIONS(12384),
    [anon_sym_else] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [7028] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_end] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_elseif] = ACTIONS(13038),
    [anon_sym_else] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_as] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [7029] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_finally] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_as] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7030] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_elseif] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [7031] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12152),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_as] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12152),
    [anon_sym_RPAREN] = ACTIONS(12152),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12152),
    [anon_sym_RBRACK] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_SEMI] = ACTIONS(12152),
    [anon_sym_LBRACE] = ACTIONS(12152),
    [anon_sym_RBRACE] = ACTIONS(12152),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12152),
    [anon_sym_COLON_COLON] = ACTIONS(12152),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12152),
    [anon_sym_QMARK] = ACTIONS(12152),
    [anon_sym_AT] = ACTIONS(12152),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12152),
    [aux_sym_integer_literal_token2] = ACTIONS(12152),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12152),
    [aux_sym_float_literal_token3] = ACTIONS(12152),
    [aux_sym_float_literal_token4] = ACTIONS(12152),
    [sym_character_literal] = ACTIONS(12152),
    [sym__pair_operator] = ACTIONS(12152),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12152),
    [sym__lazy_and_operator] = ACTIONS(12152),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12152),
    [sym__pipe_left_operator] = ACTIONS(12152),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12152),
    [sym__bitshift_operator] = ACTIONS(12152),
    [sym__power_operator] = ACTIONS(12152),
    [sym__tilde_operator] = ACTIONS(12152),
    [sym__type_order_operator] = ACTIONS(12152),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [7032] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_else] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_finally] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13108),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [7033] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12096),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13132),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12096),
    [sym__bitshift_operator] = ACTIONS(12096),
    [sym__power_operator] = ACTIONS(12096),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7034] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12254),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_as] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12254),
    [anon_sym_RPAREN] = ACTIONS(12254),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12254),
    [anon_sym_RBRACK] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_SEMI] = ACTIONS(12254),
    [anon_sym_LBRACE] = ACTIONS(12254),
    [anon_sym_RBRACE] = ACTIONS(12254),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12254),
    [anon_sym_COLON_COLON] = ACTIONS(12254),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12254),
    [anon_sym_QMARK] = ACTIONS(12254),
    [anon_sym_AT] = ACTIONS(12254),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12254),
    [aux_sym_integer_literal_token2] = ACTIONS(12254),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12254),
    [aux_sym_float_literal_token3] = ACTIONS(12254),
    [aux_sym_float_literal_token4] = ACTIONS(12254),
    [sym_character_literal] = ACTIONS(12254),
    [sym__pair_operator] = ACTIONS(12254),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12254),
    [sym__lazy_and_operator] = ACTIONS(12254),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12254),
    [sym__pipe_left_operator] = ACTIONS(12254),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12254),
    [sym__bitshift_operator] = ACTIONS(12254),
    [sym__power_operator] = ACTIONS(12254),
    [sym__tilde_operator] = ACTIONS(12254),
    [sym__type_order_operator] = ACTIONS(12254),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [7035] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [7036] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12386),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_as] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12386),
    [anon_sym_RPAREN] = ACTIONS(12386),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12386),
    [anon_sym_RBRACK] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_SEMI] = ACTIONS(12386),
    [anon_sym_LBRACE] = ACTIONS(12386),
    [anon_sym_RBRACE] = ACTIONS(12386),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12386),
    [anon_sym_COLON_COLON] = ACTIONS(12386),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12386),
    [anon_sym_QMARK] = ACTIONS(12386),
    [anon_sym_AT] = ACTIONS(12386),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12386),
    [aux_sym_integer_literal_token2] = ACTIONS(12386),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12386),
    [aux_sym_float_literal_token3] = ACTIONS(12386),
    [aux_sym_float_literal_token4] = ACTIONS(12386),
    [sym_character_literal] = ACTIONS(12386),
    [sym__pair_operator] = ACTIONS(12386),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12386),
    [sym__lazy_and_operator] = ACTIONS(12386),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12386),
    [sym__pipe_left_operator] = ACTIONS(12386),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12386),
    [sym__power_operator] = ACTIONS(12386),
    [sym__tilde_operator] = ACTIONS(12386),
    [sym__type_order_operator] = ACTIONS(12386),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [7037] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_else] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_finally] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_as] = ACTIONS(12918),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7038] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12418),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11852),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7039] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7040] = {
    [ts_builtin_sym_end] = ACTIONS(12290),
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_RPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_RBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [7041] = {
    [sym_identifier] = STATE(7617),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_as] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [7042] = {
    [sym_identifier] = STATE(7618),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_as] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [7043] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12156),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_as] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12156),
    [anon_sym_RPAREN] = ACTIONS(12156),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12156),
    [anon_sym_RBRACK] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_SEMI] = ACTIONS(12156),
    [anon_sym_LBRACE] = ACTIONS(12156),
    [anon_sym_RBRACE] = ACTIONS(12156),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12156),
    [anon_sym_COLON_COLON] = ACTIONS(12156),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12156),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_AT] = ACTIONS(12156),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12156),
    [aux_sym_integer_literal_token2] = ACTIONS(12156),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12156),
    [aux_sym_float_literal_token3] = ACTIONS(12156),
    [aux_sym_float_literal_token4] = ACTIONS(12156),
    [sym_character_literal] = ACTIONS(12156),
    [sym__pair_operator] = ACTIONS(12156),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12156),
    [sym__lazy_and_operator] = ACTIONS(12156),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12156),
    [sym__pipe_left_operator] = ACTIONS(12156),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12156),
    [sym__bitshift_operator] = ACTIONS(12156),
    [sym__power_operator] = ACTIONS(12156),
    [sym__tilde_operator] = ACTIONS(12156),
    [sym__type_order_operator] = ACTIONS(12156),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [7044] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13134),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7045] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_catch] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_as] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [7046] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12258),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_as] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12258),
    [anon_sym_RPAREN] = ACTIONS(12258),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12258),
    [anon_sym_RBRACK] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_SEMI] = ACTIONS(12258),
    [anon_sym_LBRACE] = ACTIONS(12258),
    [anon_sym_RBRACE] = ACTIONS(12258),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12258),
    [anon_sym_COLON_COLON] = ACTIONS(12258),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12258),
    [anon_sym_QMARK] = ACTIONS(12258),
    [anon_sym_AT] = ACTIONS(12258),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12258),
    [aux_sym_integer_literal_token2] = ACTIONS(12258),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12258),
    [aux_sym_float_literal_token3] = ACTIONS(12258),
    [aux_sym_float_literal_token4] = ACTIONS(12258),
    [sym_character_literal] = ACTIONS(12258),
    [sym__pair_operator] = ACTIONS(12258),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12258),
    [sym__lazy_and_operator] = ACTIONS(12258),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12258),
    [sym__pipe_left_operator] = ACTIONS(12258),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12258),
    [sym__bitshift_operator] = ACTIONS(12258),
    [sym__power_operator] = ACTIONS(12258),
    [sym__tilde_operator] = ACTIONS(12258),
    [sym__type_order_operator] = ACTIONS(12258),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [7047] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12160),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_as] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12160),
    [anon_sym_RPAREN] = ACTIONS(12160),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12160),
    [anon_sym_RBRACK] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_SEMI] = ACTIONS(12160),
    [anon_sym_LBRACE] = ACTIONS(12160),
    [anon_sym_RBRACE] = ACTIONS(12160),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12160),
    [anon_sym_COLON_COLON] = ACTIONS(12160),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12160),
    [anon_sym_QMARK] = ACTIONS(12160),
    [anon_sym_AT] = ACTIONS(12160),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12160),
    [aux_sym_integer_literal_token2] = ACTIONS(12160),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12160),
    [aux_sym_float_literal_token3] = ACTIONS(12160),
    [aux_sym_float_literal_token4] = ACTIONS(12160),
    [sym_character_literal] = ACTIONS(12160),
    [sym__pair_operator] = ACTIONS(12160),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12160),
    [sym__lazy_and_operator] = ACTIONS(12160),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12160),
    [sym__pipe_left_operator] = ACTIONS(12160),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12160),
    [sym__bitshift_operator] = ACTIONS(12160),
    [sym__power_operator] = ACTIONS(12160),
    [sym__tilde_operator] = ACTIONS(12160),
    [sym__type_order_operator] = ACTIONS(12160),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [7048] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_catch] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_as] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [7049] = {
    [ts_builtin_sym_end] = ACTIONS(12234),
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_RPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_RBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [7050] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7051] = {
    [ts_builtin_sym_end] = ACTIONS(12274),
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_RPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_RBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [7052] = {
    [ts_builtin_sym_end] = ACTIONS(12278),
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_RPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_RBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [7053] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_elseif] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7054] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12208),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_as] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12208),
    [anon_sym_RPAREN] = ACTIONS(12208),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_SEMI] = ACTIONS(12208),
    [anon_sym_LBRACE] = ACTIONS(12208),
    [anon_sym_RBRACE] = ACTIONS(12208),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12208),
    [anon_sym_COLON_COLON] = ACTIONS(12208),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12208),
    [anon_sym_QMARK] = ACTIONS(12208),
    [anon_sym_AT] = ACTIONS(12208),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12208),
    [aux_sym_integer_literal_token2] = ACTIONS(12208),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12208),
    [aux_sym_float_literal_token3] = ACTIONS(12208),
    [aux_sym_float_literal_token4] = ACTIONS(12208),
    [sym_character_literal] = ACTIONS(12208),
    [sym__pair_operator] = ACTIONS(12208),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12208),
    [sym__lazy_and_operator] = ACTIONS(12208),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12208),
    [sym__pipe_left_operator] = ACTIONS(12208),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12208),
    [sym__bitshift_operator] = ACTIONS(12208),
    [sym__power_operator] = ACTIONS(12208),
    [sym__tilde_operator] = ACTIONS(12208),
    [sym__type_order_operator] = ACTIONS(12208),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [7055] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12164),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_as] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12164),
    [anon_sym_RPAREN] = ACTIONS(12164),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12164),
    [anon_sym_RBRACK] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12164),
    [anon_sym_LBRACE] = ACTIONS(12164),
    [anon_sym_RBRACE] = ACTIONS(12164),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12164),
    [anon_sym_COLON_COLON] = ACTIONS(12164),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12164),
    [anon_sym_QMARK] = ACTIONS(12164),
    [anon_sym_AT] = ACTIONS(12164),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12164),
    [aux_sym_integer_literal_token2] = ACTIONS(12164),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12164),
    [aux_sym_float_literal_token3] = ACTIONS(12164),
    [aux_sym_float_literal_token4] = ACTIONS(12164),
    [sym_character_literal] = ACTIONS(12164),
    [sym__pair_operator] = ACTIONS(12164),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12164),
    [sym__lazy_and_operator] = ACTIONS(12164),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12164),
    [sym__pipe_left_operator] = ACTIONS(12164),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12164),
    [sym__bitshift_operator] = ACTIONS(12164),
    [sym__power_operator] = ACTIONS(12164),
    [sym__tilde_operator] = ACTIONS(12164),
    [sym__type_order_operator] = ACTIONS(12164),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [7056] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_elseif] = ACTIONS(12618),
    [anon_sym_else] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7057] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_as] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [7058] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12168),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_as] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12168),
    [anon_sym_RPAREN] = ACTIONS(12168),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12168),
    [anon_sym_RBRACK] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_SEMI] = ACTIONS(12168),
    [anon_sym_LBRACE] = ACTIONS(12168),
    [anon_sym_RBRACE] = ACTIONS(12168),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12168),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(12168),
    [anon_sym_AT] = ACTIONS(12168),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12168),
    [aux_sym_integer_literal_token2] = ACTIONS(12168),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12168),
    [aux_sym_float_literal_token3] = ACTIONS(12168),
    [aux_sym_float_literal_token4] = ACTIONS(12168),
    [sym_character_literal] = ACTIONS(12168),
    [sym__pair_operator] = ACTIONS(12168),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12168),
    [sym__lazy_and_operator] = ACTIONS(12168),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12168),
    [sym__pipe_left_operator] = ACTIONS(12168),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12168),
    [sym__bitshift_operator] = ACTIONS(12168),
    [sym__power_operator] = ACTIONS(12168),
    [sym__tilde_operator] = ACTIONS(12168),
    [sym__type_order_operator] = ACTIONS(12168),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [7059] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12418),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7060] = {
    [sym__primary_expression] = STATE(11287),
    [sym__array] = STATE(11287),
    [sym_comprehension_expression] = STATE(11287),
    [sym_matrix_expression] = STATE(11287),
    [sym_vector_expression] = STATE(11287),
    [sym_parenthesized_expression] = STATE(11287),
    [sym_tuple_expression] = STATE(11287),
    [sym_curly_expression] = STATE(11287),
    [sym_adjoint_expression] = STATE(11287),
    [sym_field_expression] = STATE(11287),
    [sym_index_expression] = STATE(11287),
    [sym_parametrized_type_expression] = STATE(11287),
    [sym_call_expression] = STATE(11287),
    [sym_broadcast_call_expression] = STATE(11287),
    [sym__closed_macrocall_expression] = STATE(11287),
    [sym_interpolation_expression] = STATE(11287),
    [sym_quote_expression] = STATE(11287),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(10846),
    [sym_boolean_literal] = STATE(11287),
    [sym__string] = STATE(11287),
    [sym_string_literal] = STATE(11287),
    [sym_command_literal] = STATE(11287),
    [sym_prefixed_string_literal] = STATE(11287),
    [sym_prefixed_command_literal] = STATE(11287),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(13136),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(13138),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(13140),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [7061] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_as] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [7062] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12922),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7063] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7064] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_as] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [7065] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13142),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7066] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12096),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12096),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12096),
    [sym__bitshift_operator] = ACTIONS(12096),
    [sym__power_operator] = ACTIONS(12096),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7067] = {
    [aux_sym_export_statement_repeat1] = STATE(6979),
    [sym__word_identifier] = ACTIONS(13144),
    [anon_sym_EQ] = ACTIONS(13144),
    [anon_sym_COMMA] = ACTIONS(13062),
    [anon_sym_COLON] = ACTIONS(13144),
    [anon_sym_begin] = ACTIONS(13144),
    [anon_sym_module] = ACTIONS(13144),
    [anon_sym_baremodule] = ACTIONS(13144),
    [anon_sym_end] = ACTIONS(13144),
    [anon_sym_abstract] = ACTIONS(13144),
    [anon_sym_primitive] = ACTIONS(13144),
    [anon_sym_mutable] = ACTIONS(13144),
    [anon_sym_struct] = ACTIONS(13144),
    [anon_sym_function] = ACTIONS(13144),
    [anon_sym_macro] = ACTIONS(13144),
    [anon_sym_where] = ACTIONS(13144),
    [anon_sym_quote] = ACTIONS(13144),
    [anon_sym_let] = ACTIONS(13144),
    [anon_sym_if] = ACTIONS(13144),
    [anon_sym_elseif] = ACTIONS(13144),
    [anon_sym_else] = ACTIONS(13144),
    [anon_sym_try] = ACTIONS(13144),
    [anon_sym_for] = ACTIONS(13144),
    [anon_sym_while] = ACTIONS(13144),
    [sym_break_statement] = ACTIONS(13144),
    [sym_continue_statement] = ACTIONS(13144),
    [anon_sym_return] = ACTIONS(13144),
    [anon_sym_const] = ACTIONS(13144),
    [anon_sym_global] = ACTIONS(13144),
    [anon_sym_local] = ACTIONS(13144),
    [anon_sym_LPAREN] = ACTIONS(13144),
    [anon_sym_COLON2] = ACTIONS(13144),
    [anon_sym_export] = ACTIONS(13144),
    [anon_sym_import] = ACTIONS(13144),
    [anon_sym_using] = ACTIONS(13144),
    [anon_sym_LBRACK] = ACTIONS(13144),
    [anon_sym_LF] = ACTIONS(13146),
    [anon_sym_in] = ACTIONS(13144),
    [anon_sym_LBRACE] = ACTIONS(13144),
    [anon_sym_DOLLAR] = ACTIONS(13144),
    [anon_sym_COLON_COLON] = ACTIONS(13144),
    [anon_sym_isa] = ACTIONS(13144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13144),
    [anon_sym_QMARK] = ACTIONS(13144),
    [anon_sym_AT] = ACTIONS(13144),
    [anon_sym_true] = ACTIONS(13144),
    [anon_sym_false] = ACTIONS(13144),
    [aux_sym_integer_literal_token1] = ACTIONS(13144),
    [aux_sym_integer_literal_token2] = ACTIONS(13144),
    [aux_sym_integer_literal_token3] = ACTIONS(13144),
    [aux_sym_integer_literal_token4] = ACTIONS(13144),
    [aux_sym_float_literal_token1] = ACTIONS(13144),
    [aux_sym_float_literal_token3] = ACTIONS(13144),
    [aux_sym_float_literal_token4] = ACTIONS(13144),
    [sym_character_literal] = ACTIONS(13144),
    [sym__pair_operator] = ACTIONS(13144),
    [sym__arrow_operator] = ACTIONS(13144),
    [sym__lazy_or_operator] = ACTIONS(13144),
    [sym__lazy_and_operator] = ACTIONS(13144),
    [sym__comparison_operator] = ACTIONS(13144),
    [sym__pipe_right_operator] = ACTIONS(13144),
    [sym__pipe_left_operator] = ACTIONS(13144),
    [sym__ellipsis_operator] = ACTIONS(13144),
    [sym__plus_operator] = ACTIONS(13144),
    [sym__times_operator] = ACTIONS(13144),
    [sym__rational_operator] = ACTIONS(13144),
    [sym__bitshift_operator] = ACTIONS(13144),
    [sym__power_operator] = ACTIONS(13144),
    [sym__tilde_operator] = ACTIONS(13144),
    [sym__type_order_operator] = ACTIONS(13144),
    [sym__unary_operator] = ACTIONS(13144),
    [sym__unary_plus_operator] = ACTIONS(13144),
    [aux_sym__terminator_token1] = ACTIONS(13144),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13146),
    [sym__command_start] = ACTIONS(13146),
  },
  [7068] = {
    [aux_sym_open_tuple_repeat1] = STATE(7252),
    [ts_builtin_sym_end] = ACTIONS(13148),
    [sym__word_identifier] = ACTIONS(13150),
    [anon_sym_EQ] = ACTIONS(13150),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_COLON] = ACTIONS(13150),
    [anon_sym_begin] = ACTIONS(13150),
    [anon_sym_module] = ACTIONS(13150),
    [anon_sym_baremodule] = ACTIONS(13150),
    [anon_sym_abstract] = ACTIONS(13150),
    [anon_sym_primitive] = ACTIONS(13150),
    [anon_sym_mutable] = ACTIONS(13150),
    [anon_sym_struct] = ACTIONS(13150),
    [anon_sym_function] = ACTIONS(13150),
    [anon_sym_macro] = ACTIONS(13150),
    [anon_sym_where] = ACTIONS(13150),
    [anon_sym_quote] = ACTIONS(13150),
    [anon_sym_let] = ACTIONS(13150),
    [anon_sym_if] = ACTIONS(13150),
    [anon_sym_try] = ACTIONS(13150),
    [anon_sym_for] = ACTIONS(13150),
    [anon_sym_while] = ACTIONS(13150),
    [sym_break_statement] = ACTIONS(13150),
    [sym_continue_statement] = ACTIONS(13150),
    [anon_sym_return] = ACTIONS(13150),
    [anon_sym_const] = ACTIONS(13150),
    [anon_sym_global] = ACTIONS(13150),
    [anon_sym_local] = ACTIONS(13150),
    [anon_sym_LPAREN] = ACTIONS(13150),
    [anon_sym_RPAREN] = ACTIONS(13150),
    [anon_sym_COLON2] = ACTIONS(13150),
    [anon_sym_export] = ACTIONS(13150),
    [anon_sym_import] = ACTIONS(13150),
    [anon_sym_using] = ACTIONS(13150),
    [anon_sym_LBRACK] = ACTIONS(13150),
    [anon_sym_RBRACK] = ACTIONS(13150),
    [anon_sym_LF] = ACTIONS(13148),
    [anon_sym_in] = ACTIONS(13150),
    [anon_sym_LBRACE] = ACTIONS(13150),
    [anon_sym_DOLLAR] = ACTIONS(13150),
    [anon_sym_COLON_COLON] = ACTIONS(13150),
    [anon_sym_isa] = ACTIONS(13150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13150),
    [anon_sym_QMARK] = ACTIONS(13150),
    [anon_sym_AT] = ACTIONS(13150),
    [anon_sym_true] = ACTIONS(13150),
    [anon_sym_false] = ACTIONS(13150),
    [aux_sym_integer_literal_token1] = ACTIONS(13150),
    [aux_sym_integer_literal_token2] = ACTIONS(13150),
    [aux_sym_integer_literal_token3] = ACTIONS(13150),
    [aux_sym_integer_literal_token4] = ACTIONS(13150),
    [aux_sym_float_literal_token1] = ACTIONS(13150),
    [aux_sym_float_literal_token3] = ACTIONS(13150),
    [aux_sym_float_literal_token4] = ACTIONS(13150),
    [sym_character_literal] = ACTIONS(13150),
    [sym__pair_operator] = ACTIONS(13150),
    [sym__arrow_operator] = ACTIONS(13150),
    [sym__lazy_or_operator] = ACTIONS(13150),
    [sym__lazy_and_operator] = ACTIONS(13150),
    [sym__comparison_operator] = ACTIONS(13150),
    [sym__pipe_right_operator] = ACTIONS(13150),
    [sym__pipe_left_operator] = ACTIONS(13150),
    [sym__ellipsis_operator] = ACTIONS(13150),
    [sym__plus_operator] = ACTIONS(13150),
    [sym__times_operator] = ACTIONS(13150),
    [sym__rational_operator] = ACTIONS(13150),
    [sym__bitshift_operator] = ACTIONS(13150),
    [sym__power_operator] = ACTIONS(13150),
    [sym__tilde_operator] = ACTIONS(13150),
    [sym__type_order_operator] = ACTIONS(13150),
    [sym__unary_operator] = ACTIONS(13150),
    [sym__unary_plus_operator] = ACTIONS(13150),
    [aux_sym__terminator_token1] = ACTIONS(13150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13148),
    [sym__command_start] = ACTIONS(13148),
  },
  [7069] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [7070] = {
    [aux_sym__import_list_repeat1] = STATE(6990),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(12864),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_elseif] = ACTIONS(12862),
    [anon_sym_else] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7071] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12044),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_as] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12044),
    [anon_sym_RPAREN] = ACTIONS(12044),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12044),
    [anon_sym_RBRACK] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12044),
    [anon_sym_LBRACE] = ACTIONS(12044),
    [anon_sym_RBRACE] = ACTIONS(12044),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12044),
    [anon_sym_COLON_COLON] = ACTIONS(12044),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12044),
    [anon_sym_QMARK] = ACTIONS(12044),
    [anon_sym_AT] = ACTIONS(12044),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12044),
    [aux_sym_integer_literal_token2] = ACTIONS(12044),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12044),
    [aux_sym_float_literal_token3] = ACTIONS(12044),
    [aux_sym_float_literal_token4] = ACTIONS(12044),
    [sym_character_literal] = ACTIONS(12044),
    [sym__pair_operator] = ACTIONS(12044),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12044),
    [sym__lazy_and_operator] = ACTIONS(12044),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12044),
    [sym__pipe_left_operator] = ACTIONS(12044),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12044),
    [sym__bitshift_operator] = ACTIONS(12044),
    [sym__power_operator] = ACTIONS(12044),
    [sym__tilde_operator] = ACTIONS(12044),
    [sym__type_order_operator] = ACTIONS(12044),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7072] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_else] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [7073] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12390),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_as] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12390),
    [anon_sym_RPAREN] = ACTIONS(12390),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12390),
    [anon_sym_RBRACK] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_SEMI] = ACTIONS(12390),
    [anon_sym_LBRACE] = ACTIONS(12390),
    [anon_sym_RBRACE] = ACTIONS(12390),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12390),
    [anon_sym_COLON_COLON] = ACTIONS(12390),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12390),
    [anon_sym_QMARK] = ACTIONS(12390),
    [anon_sym_AT] = ACTIONS(12390),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12390),
    [aux_sym_integer_literal_token2] = ACTIONS(12390),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12390),
    [aux_sym_float_literal_token3] = ACTIONS(12390),
    [aux_sym_float_literal_token4] = ACTIONS(12390),
    [sym_character_literal] = ACTIONS(12390),
    [sym__pair_operator] = ACTIONS(12390),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12390),
    [sym__lazy_and_operator] = ACTIONS(12390),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12390),
    [sym__pipe_left_operator] = ACTIONS(12390),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12390),
    [sym__bitshift_operator] = ACTIONS(12390),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(12390),
    [sym__type_order_operator] = ACTIONS(12390),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7074] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_as] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [7075] = {
    [sym__word_identifier] = ACTIONS(12846),
    [anon_sym_EQ] = ACTIONS(12846),
    [anon_sym_COMMA] = ACTIONS(12846),
    [anon_sym_COLON] = ACTIONS(12846),
    [anon_sym_begin] = ACTIONS(12846),
    [anon_sym_module] = ACTIONS(12846),
    [anon_sym_baremodule] = ACTIONS(12846),
    [anon_sym_end] = ACTIONS(12846),
    [anon_sym_abstract] = ACTIONS(12846),
    [anon_sym_primitive] = ACTIONS(12846),
    [anon_sym_mutable] = ACTIONS(12846),
    [anon_sym_struct] = ACTIONS(12846),
    [anon_sym_function] = ACTIONS(12846),
    [anon_sym_macro] = ACTIONS(12846),
    [anon_sym_where] = ACTIONS(12846),
    [anon_sym_quote] = ACTIONS(12846),
    [anon_sym_let] = ACTIONS(12846),
    [anon_sym_if] = ACTIONS(12846),
    [anon_sym_try] = ACTIONS(12846),
    [anon_sym_finally] = ACTIONS(12846),
    [anon_sym_for] = ACTIONS(12846),
    [anon_sym_while] = ACTIONS(12846),
    [sym_break_statement] = ACTIONS(12846),
    [sym_continue_statement] = ACTIONS(12846),
    [anon_sym_return] = ACTIONS(12846),
    [anon_sym_const] = ACTIONS(12846),
    [anon_sym_global] = ACTIONS(12846),
    [anon_sym_local] = ACTIONS(12846),
    [anon_sym_as] = ACTIONS(12846),
    [anon_sym_LPAREN] = ACTIONS(12846),
    [anon_sym_COLON2] = ACTIONS(12846),
    [anon_sym_export] = ACTIONS(12846),
    [anon_sym_import] = ACTIONS(12846),
    [anon_sym_using] = ACTIONS(12846),
    [anon_sym_LBRACK] = ACTIONS(12846),
    [anon_sym_LF] = ACTIONS(12848),
    [anon_sym_in] = ACTIONS(12846),
    [anon_sym_LBRACE] = ACTIONS(12846),
    [anon_sym_DOT] = ACTIONS(13032),
    [anon_sym_DOLLAR] = ACTIONS(12846),
    [anon_sym_COLON_COLON] = ACTIONS(12846),
    [anon_sym_isa] = ACTIONS(12846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12846),
    [anon_sym_QMARK] = ACTIONS(12846),
    [anon_sym_AT] = ACTIONS(12846),
    [anon_sym_true] = ACTIONS(12846),
    [anon_sym_false] = ACTIONS(12846),
    [aux_sym_integer_literal_token1] = ACTIONS(12846),
    [aux_sym_integer_literal_token2] = ACTIONS(12846),
    [aux_sym_integer_literal_token3] = ACTIONS(12846),
    [aux_sym_integer_literal_token4] = ACTIONS(12846),
    [aux_sym_float_literal_token1] = ACTIONS(12846),
    [aux_sym_float_literal_token3] = ACTIONS(12846),
    [aux_sym_float_literal_token4] = ACTIONS(12846),
    [sym_character_literal] = ACTIONS(12846),
    [sym__pair_operator] = ACTIONS(12846),
    [sym__arrow_operator] = ACTIONS(12846),
    [sym__lazy_or_operator] = ACTIONS(12846),
    [sym__lazy_and_operator] = ACTIONS(12846),
    [sym__comparison_operator] = ACTIONS(12846),
    [sym__pipe_right_operator] = ACTIONS(12846),
    [sym__pipe_left_operator] = ACTIONS(12846),
    [sym__ellipsis_operator] = ACTIONS(12846),
    [sym__plus_operator] = ACTIONS(12846),
    [sym__times_operator] = ACTIONS(12846),
    [sym__rational_operator] = ACTIONS(12846),
    [sym__bitshift_operator] = ACTIONS(12846),
    [sym__power_operator] = ACTIONS(12846),
    [sym__tilde_operator] = ACTIONS(12846),
    [sym__type_order_operator] = ACTIONS(12846),
    [sym__unary_operator] = ACTIONS(12846),
    [sym__unary_plus_operator] = ACTIONS(12846),
    [aux_sym__terminator_token1] = ACTIONS(12846),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12848),
    [sym__command_start] = ACTIONS(12848),
  },
  [7076] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_as] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [7077] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_else] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12874),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7078] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11868),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7079] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_elseif] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [7080] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_as] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [7081] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7082] = {
    [aux_sym__import_list_repeat1] = STATE(7082),
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(13154),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_else] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_finally] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7083] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_catch] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_as] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [7084] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_elseif] = ACTIONS(12322),
    [anon_sym_else] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [7085] = {
    [ts_builtin_sym_end] = ACTIONS(12298),
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_RPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_RBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [7086] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_catch] = ACTIONS(12618),
    [anon_sym_finally] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_as] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7087] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_else] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [7088] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7089] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12904),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7090] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12176),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_as] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12176),
    [anon_sym_RPAREN] = ACTIONS(12176),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12176),
    [anon_sym_RBRACK] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_SEMI] = ACTIONS(12176),
    [anon_sym_LBRACE] = ACTIONS(12176),
    [anon_sym_RBRACE] = ACTIONS(12176),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12176),
    [anon_sym_COLON_COLON] = ACTIONS(12176),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12176),
    [anon_sym_QMARK] = ACTIONS(12176),
    [anon_sym_AT] = ACTIONS(12176),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12176),
    [aux_sym_integer_literal_token2] = ACTIONS(12176),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12176),
    [aux_sym_float_literal_token3] = ACTIONS(12176),
    [aux_sym_float_literal_token4] = ACTIONS(12176),
    [sym_character_literal] = ACTIONS(12176),
    [sym__pair_operator] = ACTIONS(12176),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12176),
    [sym__lazy_and_operator] = ACTIONS(12176),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12176),
    [sym__pipe_left_operator] = ACTIONS(12176),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12176),
    [sym__bitshift_operator] = ACTIONS(12176),
    [sym__power_operator] = ACTIONS(12176),
    [sym__tilde_operator] = ACTIONS(12176),
    [sym__type_order_operator] = ACTIONS(12176),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [7091] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(13157),
    [sym__immediate_command_start] = ACTIONS(13159),
  },
  [7092] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_as] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7093] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_catch] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_as] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [7094] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_as] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7095] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7096] = {
    [aux_sym_export_statement_repeat1] = STATE(6861),
    [ts_builtin_sym_end] = ACTIONS(13064),
    [sym__word_identifier] = ACTIONS(13060),
    [anon_sym_EQ] = ACTIONS(13060),
    [anon_sym_COMMA] = ACTIONS(13161),
    [anon_sym_COLON] = ACTIONS(13060),
    [anon_sym_begin] = ACTIONS(13060),
    [anon_sym_module] = ACTIONS(13060),
    [anon_sym_baremodule] = ACTIONS(13060),
    [anon_sym_abstract] = ACTIONS(13060),
    [anon_sym_primitive] = ACTIONS(13060),
    [anon_sym_mutable] = ACTIONS(13060),
    [anon_sym_struct] = ACTIONS(13060),
    [anon_sym_function] = ACTIONS(13060),
    [anon_sym_macro] = ACTIONS(13060),
    [anon_sym_where] = ACTIONS(13060),
    [anon_sym_quote] = ACTIONS(13060),
    [anon_sym_let] = ACTIONS(13060),
    [anon_sym_if] = ACTIONS(13060),
    [anon_sym_try] = ACTIONS(13060),
    [anon_sym_for] = ACTIONS(13060),
    [anon_sym_while] = ACTIONS(13060),
    [sym_break_statement] = ACTIONS(13060),
    [sym_continue_statement] = ACTIONS(13060),
    [anon_sym_return] = ACTIONS(13060),
    [anon_sym_const] = ACTIONS(13060),
    [anon_sym_global] = ACTIONS(13060),
    [anon_sym_local] = ACTIONS(13060),
    [anon_sym_LPAREN] = ACTIONS(13060),
    [anon_sym_RPAREN] = ACTIONS(13060),
    [anon_sym_COLON2] = ACTIONS(13060),
    [anon_sym_export] = ACTIONS(13060),
    [anon_sym_import] = ACTIONS(13060),
    [anon_sym_using] = ACTIONS(13060),
    [anon_sym_LBRACK] = ACTIONS(13060),
    [anon_sym_RBRACK] = ACTIONS(13060),
    [anon_sym_LF] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13060),
    [anon_sym_LBRACE] = ACTIONS(13060),
    [anon_sym_DOLLAR] = ACTIONS(13060),
    [anon_sym_COLON_COLON] = ACTIONS(13060),
    [anon_sym_isa] = ACTIONS(13060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13060),
    [anon_sym_QMARK] = ACTIONS(13060),
    [anon_sym_AT] = ACTIONS(13060),
    [anon_sym_true] = ACTIONS(13060),
    [anon_sym_false] = ACTIONS(13060),
    [aux_sym_integer_literal_token1] = ACTIONS(13060),
    [aux_sym_integer_literal_token2] = ACTIONS(13060),
    [aux_sym_integer_literal_token3] = ACTIONS(13060),
    [aux_sym_integer_literal_token4] = ACTIONS(13060),
    [aux_sym_float_literal_token1] = ACTIONS(13060),
    [aux_sym_float_literal_token3] = ACTIONS(13060),
    [aux_sym_float_literal_token4] = ACTIONS(13060),
    [sym_character_literal] = ACTIONS(13060),
    [sym__pair_operator] = ACTIONS(13060),
    [sym__arrow_operator] = ACTIONS(13060),
    [sym__lazy_or_operator] = ACTIONS(13060),
    [sym__lazy_and_operator] = ACTIONS(13060),
    [sym__comparison_operator] = ACTIONS(13060),
    [sym__pipe_right_operator] = ACTIONS(13060),
    [sym__pipe_left_operator] = ACTIONS(13060),
    [sym__ellipsis_operator] = ACTIONS(13060),
    [sym__plus_operator] = ACTIONS(13060),
    [sym__times_operator] = ACTIONS(13060),
    [sym__rational_operator] = ACTIONS(13060),
    [sym__bitshift_operator] = ACTIONS(13060),
    [sym__power_operator] = ACTIONS(13060),
    [sym__tilde_operator] = ACTIONS(13060),
    [sym__type_order_operator] = ACTIONS(13060),
    [sym__unary_operator] = ACTIONS(13060),
    [sym__unary_plus_operator] = ACTIONS(13060),
    [aux_sym__terminator_token1] = ACTIONS(13060),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13064),
    [sym__command_start] = ACTIONS(13064),
  },
  [7097] = {
    [ts_builtin_sym_end] = ACTIONS(12060),
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_RBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7098] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12228),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7099] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12290),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_as] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12290),
    [anon_sym_RPAREN] = ACTIONS(12290),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12290),
    [anon_sym_RBRACK] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_SEMI] = ACTIONS(12290),
    [anon_sym_LBRACE] = ACTIONS(12290),
    [anon_sym_RBRACE] = ACTIONS(12290),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12290),
    [anon_sym_COLON_COLON] = ACTIONS(12290),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_QMARK] = ACTIONS(12290),
    [anon_sym_AT] = ACTIONS(12290),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12290),
    [aux_sym_integer_literal_token2] = ACTIONS(12290),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12290),
    [aux_sym_float_literal_token3] = ACTIONS(12290),
    [aux_sym_float_literal_token4] = ACTIONS(12290),
    [sym_character_literal] = ACTIONS(12290),
    [sym__pair_operator] = ACTIONS(12290),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12290),
    [sym__lazy_and_operator] = ACTIONS(12290),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12290),
    [sym__pipe_left_operator] = ACTIONS(12290),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12290),
    [sym__bitshift_operator] = ACTIONS(12290),
    [sym__power_operator] = ACTIONS(12290),
    [sym__tilde_operator] = ACTIONS(12290),
    [sym__type_order_operator] = ACTIONS(12290),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [7100] = {
    [ts_builtin_sym_end] = ACTIONS(12044),
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_RBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7101] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12060),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_as] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12060),
    [anon_sym_RPAREN] = ACTIONS(12060),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12060),
    [anon_sym_RBRACK] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12060),
    [anon_sym_LBRACE] = ACTIONS(12060),
    [anon_sym_RBRACE] = ACTIONS(12060),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12060),
    [anon_sym_COLON_COLON] = ACTIONS(12060),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12060),
    [anon_sym_QMARK] = ACTIONS(12060),
    [anon_sym_AT] = ACTIONS(12060),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12060),
    [aux_sym_integer_literal_token2] = ACTIONS(12060),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12060),
    [aux_sym_float_literal_token3] = ACTIONS(12060),
    [aux_sym_float_literal_token4] = ACTIONS(12060),
    [sym_character_literal] = ACTIONS(12060),
    [sym__pair_operator] = ACTIONS(12060),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12060),
    [sym__lazy_and_operator] = ACTIONS(12060),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12060),
    [sym__pipe_left_operator] = ACTIONS(12060),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12060),
    [sym__bitshift_operator] = ACTIONS(12060),
    [sym__power_operator] = ACTIONS(12060),
    [sym__tilde_operator] = ACTIONS(12060),
    [sym__type_order_operator] = ACTIONS(12060),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7102] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_else] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [7103] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_as] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7104] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_as] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7105] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_catch] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_as] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [7106] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_catch] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_as] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [7107] = {
    [ts_builtin_sym_end] = ACTIONS(12056),
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_RBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7108] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(12968),
    [sym__immediate_command_start] = ACTIONS(12970),
  },
  [7109] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_elseif] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7110] = {
    [aux_sym__import_list_repeat1] = STATE(7616),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13026),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_finally] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13028),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7111] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_catch] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_as] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [7112] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [7113] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_catch] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_as] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [7114] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11890),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11890),
    [anon_sym_RPAREN] = ACTIONS(11890),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11890),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11890),
    [anon_sym_RBRACE] = ACTIONS(11890),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11890),
    [anon_sym_COLON_COLON] = ACTIONS(11890),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11890),
    [anon_sym_QMARK] = ACTIONS(11890),
    [anon_sym_AT] = ACTIONS(11890),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11890),
    [aux_sym_integer_literal_token2] = ACTIONS(11890),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11890),
    [aux_sym_float_literal_token3] = ACTIONS(11890),
    [aux_sym_float_literal_token4] = ACTIONS(11890),
    [sym_character_literal] = ACTIONS(11890),
    [sym__pair_operator] = ACTIONS(11890),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11890),
    [sym__lazy_and_operator] = ACTIONS(11890),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11890),
    [sym__pipe_left_operator] = ACTIONS(11890),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11890),
    [sym__bitshift_operator] = ACTIONS(11890),
    [sym__power_operator] = ACTIONS(11890),
    [sym__tilde_operator] = ACTIONS(11890),
    [sym__type_order_operator] = ACTIONS(11890),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [7115] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_catch] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_as] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [7116] = {
    [ts_builtin_sym_end] = ACTIONS(11864),
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [7117] = {
    [aux_sym__import_list_repeat1] = STATE(7554),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13020),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_catch] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13022),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7118] = {
    [ts_builtin_sym_end] = ACTIONS(12096),
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12902),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7119] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_catch] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_as] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [7120] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_catch] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_as] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [7121] = {
    [ts_builtin_sym_end] = ACTIONS(12302),
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_RPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_RBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [7122] = {
    [aux_sym__import_list_repeat1] = STATE(6898),
    [ts_builtin_sym_end] = ACTIONS(13068),
    [sym__word_identifier] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(12896),
    [anon_sym_COLON] = ACTIONS(13066),
    [anon_sym_begin] = ACTIONS(13066),
    [anon_sym_module] = ACTIONS(13066),
    [anon_sym_baremodule] = ACTIONS(13066),
    [anon_sym_abstract] = ACTIONS(13066),
    [anon_sym_primitive] = ACTIONS(13066),
    [anon_sym_mutable] = ACTIONS(13066),
    [anon_sym_struct] = ACTIONS(13066),
    [anon_sym_function] = ACTIONS(13066),
    [anon_sym_macro] = ACTIONS(13066),
    [anon_sym_where] = ACTIONS(13066),
    [anon_sym_quote] = ACTIONS(13066),
    [anon_sym_let] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13066),
    [anon_sym_try] = ACTIONS(13066),
    [anon_sym_for] = ACTIONS(13066),
    [anon_sym_while] = ACTIONS(13066),
    [sym_break_statement] = ACTIONS(13066),
    [sym_continue_statement] = ACTIONS(13066),
    [anon_sym_return] = ACTIONS(13066),
    [anon_sym_const] = ACTIONS(13066),
    [anon_sym_global] = ACTIONS(13066),
    [anon_sym_local] = ACTIONS(13066),
    [anon_sym_LPAREN] = ACTIONS(13066),
    [anon_sym_RPAREN] = ACTIONS(13066),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_export] = ACTIONS(13066),
    [anon_sym_import] = ACTIONS(13066),
    [anon_sym_using] = ACTIONS(13066),
    [anon_sym_LBRACK] = ACTIONS(13066),
    [anon_sym_RBRACK] = ACTIONS(13066),
    [anon_sym_LF] = ACTIONS(13068),
    [anon_sym_in] = ACTIONS(13066),
    [anon_sym_LBRACE] = ACTIONS(13066),
    [anon_sym_DOLLAR] = ACTIONS(13066),
    [anon_sym_COLON_COLON] = ACTIONS(13066),
    [anon_sym_isa] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13066),
    [anon_sym_QMARK] = ACTIONS(13066),
    [anon_sym_AT] = ACTIONS(13066),
    [anon_sym_true] = ACTIONS(13066),
    [anon_sym_false] = ACTIONS(13066),
    [aux_sym_integer_literal_token1] = ACTIONS(13066),
    [aux_sym_integer_literal_token2] = ACTIONS(13066),
    [aux_sym_integer_literal_token3] = ACTIONS(13066),
    [aux_sym_integer_literal_token4] = ACTIONS(13066),
    [aux_sym_float_literal_token1] = ACTIONS(13066),
    [aux_sym_float_literal_token3] = ACTIONS(13066),
    [aux_sym_float_literal_token4] = ACTIONS(13066),
    [sym_character_literal] = ACTIONS(13066),
    [sym__pair_operator] = ACTIONS(13066),
    [sym__arrow_operator] = ACTIONS(13066),
    [sym__lazy_or_operator] = ACTIONS(13066),
    [sym__lazy_and_operator] = ACTIONS(13066),
    [sym__comparison_operator] = ACTIONS(13066),
    [sym__pipe_right_operator] = ACTIONS(13066),
    [sym__pipe_left_operator] = ACTIONS(13066),
    [sym__ellipsis_operator] = ACTIONS(13066),
    [sym__plus_operator] = ACTIONS(13066),
    [sym__times_operator] = ACTIONS(13066),
    [sym__rational_operator] = ACTIONS(13066),
    [sym__bitshift_operator] = ACTIONS(13066),
    [sym__power_operator] = ACTIONS(13066),
    [sym__tilde_operator] = ACTIONS(13066),
    [sym__type_order_operator] = ACTIONS(13066),
    [sym__unary_operator] = ACTIONS(13066),
    [sym__unary_plus_operator] = ACTIONS(13066),
    [aux_sym__terminator_token1] = ACTIONS(13066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13068),
    [sym__command_start] = ACTIONS(13068),
  },
  [7123] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_else] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [7124] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_else] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [7125] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_catch] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_as] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [7126] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_catch] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_as] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [7127] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_catch] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_as] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [7128] = {
    [ts_builtin_sym_end] = ACTIONS(12386),
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_RPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_RBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [7129] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11868),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7130] = {
    [aux_sym_open_tuple_repeat1] = STATE(7130),
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13163),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_end] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13070),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_elseif] = ACTIONS(13070),
    [anon_sym_else] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(13070),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13070),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(13070),
    [anon_sym_isa] = ACTIONS(13070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13070),
    [anon_sym_QMARK] = ACTIONS(13070),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(13070),
    [sym__arrow_operator] = ACTIONS(13070),
    [sym__lazy_or_operator] = ACTIONS(13070),
    [sym__lazy_and_operator] = ACTIONS(13070),
    [sym__comparison_operator] = ACTIONS(13070),
    [sym__pipe_right_operator] = ACTIONS(13070),
    [sym__pipe_left_operator] = ACTIONS(13070),
    [sym__ellipsis_operator] = ACTIONS(13070),
    [sym__plus_operator] = ACTIONS(13070),
    [sym__times_operator] = ACTIONS(13070),
    [sym__rational_operator] = ACTIONS(13070),
    [sym__bitshift_operator] = ACTIONS(13070),
    [sym__power_operator] = ACTIONS(13070),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(13070),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13070),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [7131] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_catch] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_as] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [7132] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12336),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_as] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12336),
    [anon_sym_RPAREN] = ACTIONS(12336),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12336),
    [anon_sym_RBRACK] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_SEMI] = ACTIONS(12336),
    [anon_sym_LBRACE] = ACTIONS(12336),
    [anon_sym_RBRACE] = ACTIONS(12336),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12336),
    [anon_sym_COLON_COLON] = ACTIONS(12336),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12336),
    [anon_sym_QMARK] = ACTIONS(12336),
    [anon_sym_AT] = ACTIONS(12336),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12336),
    [aux_sym_integer_literal_token2] = ACTIONS(12336),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12336),
    [aux_sym_float_literal_token3] = ACTIONS(12336),
    [aux_sym_float_literal_token4] = ACTIONS(12336),
    [sym_character_literal] = ACTIONS(12336),
    [sym__pair_operator] = ACTIONS(12336),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12336),
    [sym__lazy_and_operator] = ACTIONS(12336),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12336),
    [sym__pipe_left_operator] = ACTIONS(12336),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12336),
    [sym__bitshift_operator] = ACTIONS(12336),
    [sym__power_operator] = ACTIONS(12336),
    [sym__tilde_operator] = ACTIONS(12336),
    [sym__type_order_operator] = ACTIONS(12336),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [7133] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(13157),
    [sym__immediate_command_start] = ACTIONS(13159),
  },
  [7134] = {
    [sym__word_identifier] = ACTIONS(12846),
    [anon_sym_EQ] = ACTIONS(12846),
    [anon_sym_COMMA] = ACTIONS(12846),
    [anon_sym_COLON] = ACTIONS(12846),
    [anon_sym_begin] = ACTIONS(12846),
    [anon_sym_module] = ACTIONS(12846),
    [anon_sym_baremodule] = ACTIONS(12846),
    [anon_sym_abstract] = ACTIONS(12846),
    [anon_sym_primitive] = ACTIONS(12846),
    [anon_sym_mutable] = ACTIONS(12846),
    [anon_sym_struct] = ACTIONS(12846),
    [anon_sym_function] = ACTIONS(12846),
    [anon_sym_macro] = ACTIONS(12846),
    [anon_sym_where] = ACTIONS(12846),
    [anon_sym_quote] = ACTIONS(12846),
    [anon_sym_let] = ACTIONS(12846),
    [anon_sym_if] = ACTIONS(12846),
    [anon_sym_try] = ACTIONS(12846),
    [anon_sym_catch] = ACTIONS(12846),
    [anon_sym_finally] = ACTIONS(12846),
    [anon_sym_for] = ACTIONS(12846),
    [anon_sym_while] = ACTIONS(12846),
    [sym_break_statement] = ACTIONS(12846),
    [sym_continue_statement] = ACTIONS(12846),
    [anon_sym_return] = ACTIONS(12846),
    [anon_sym_const] = ACTIONS(12846),
    [anon_sym_global] = ACTIONS(12846),
    [anon_sym_local] = ACTIONS(12846),
    [anon_sym_as] = ACTIONS(12846),
    [anon_sym_LPAREN] = ACTIONS(12846),
    [anon_sym_COLON2] = ACTIONS(12846),
    [anon_sym_export] = ACTIONS(12846),
    [anon_sym_import] = ACTIONS(12846),
    [anon_sym_using] = ACTIONS(12846),
    [anon_sym_LBRACK] = ACTIONS(12846),
    [anon_sym_LF] = ACTIONS(12848),
    [anon_sym_in] = ACTIONS(12846),
    [anon_sym_LBRACE] = ACTIONS(12846),
    [anon_sym_DOT] = ACTIONS(12966),
    [anon_sym_DOLLAR] = ACTIONS(12846),
    [anon_sym_COLON_COLON] = ACTIONS(12846),
    [anon_sym_isa] = ACTIONS(12846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12846),
    [anon_sym_QMARK] = ACTIONS(12846),
    [anon_sym_AT] = ACTIONS(12846),
    [anon_sym_true] = ACTIONS(12846),
    [anon_sym_false] = ACTIONS(12846),
    [aux_sym_integer_literal_token1] = ACTIONS(12846),
    [aux_sym_integer_literal_token2] = ACTIONS(12846),
    [aux_sym_integer_literal_token3] = ACTIONS(12846),
    [aux_sym_integer_literal_token4] = ACTIONS(12846),
    [aux_sym_float_literal_token1] = ACTIONS(12846),
    [aux_sym_float_literal_token3] = ACTIONS(12846),
    [aux_sym_float_literal_token4] = ACTIONS(12846),
    [sym_character_literal] = ACTIONS(12846),
    [sym__pair_operator] = ACTIONS(12846),
    [sym__arrow_operator] = ACTIONS(12846),
    [sym__lazy_or_operator] = ACTIONS(12846),
    [sym__lazy_and_operator] = ACTIONS(12846),
    [sym__comparison_operator] = ACTIONS(12846),
    [sym__pipe_right_operator] = ACTIONS(12846),
    [sym__pipe_left_operator] = ACTIONS(12846),
    [sym__ellipsis_operator] = ACTIONS(12846),
    [sym__plus_operator] = ACTIONS(12846),
    [sym__times_operator] = ACTIONS(12846),
    [sym__rational_operator] = ACTIONS(12846),
    [sym__bitshift_operator] = ACTIONS(12846),
    [sym__power_operator] = ACTIONS(12846),
    [sym__tilde_operator] = ACTIONS(12846),
    [sym__type_order_operator] = ACTIONS(12846),
    [sym__unary_operator] = ACTIONS(12846),
    [sym__unary_plus_operator] = ACTIONS(12846),
    [aux_sym__terminator_token1] = ACTIONS(12846),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12848),
    [sym__command_start] = ACTIONS(12848),
  },
  [7135] = {
    [ts_builtin_sym_end] = ACTIONS(12068),
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_RBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [7136] = {
    [ts_builtin_sym_end] = ACTIONS(12282),
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_RPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_RBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [7137] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_catch] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_as] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7138] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [7139] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7140] = {
    [ts_builtin_sym_end] = ACTIONS(12140),
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_RPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_RBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [7141] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12376),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7142] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_catch] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_as] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [7143] = {
    [aux_sym_export_statement_repeat1] = STATE(7096),
    [ts_builtin_sym_end] = ACTIONS(13146),
    [sym__word_identifier] = ACTIONS(13144),
    [anon_sym_EQ] = ACTIONS(13144),
    [anon_sym_COMMA] = ACTIONS(13161),
    [anon_sym_COLON] = ACTIONS(13144),
    [anon_sym_begin] = ACTIONS(13144),
    [anon_sym_module] = ACTIONS(13144),
    [anon_sym_baremodule] = ACTIONS(13144),
    [anon_sym_abstract] = ACTIONS(13144),
    [anon_sym_primitive] = ACTIONS(13144),
    [anon_sym_mutable] = ACTIONS(13144),
    [anon_sym_struct] = ACTIONS(13144),
    [anon_sym_function] = ACTIONS(13144),
    [anon_sym_macro] = ACTIONS(13144),
    [anon_sym_where] = ACTIONS(13144),
    [anon_sym_quote] = ACTIONS(13144),
    [anon_sym_let] = ACTIONS(13144),
    [anon_sym_if] = ACTIONS(13144),
    [anon_sym_try] = ACTIONS(13144),
    [anon_sym_for] = ACTIONS(13144),
    [anon_sym_while] = ACTIONS(13144),
    [sym_break_statement] = ACTIONS(13144),
    [sym_continue_statement] = ACTIONS(13144),
    [anon_sym_return] = ACTIONS(13144),
    [anon_sym_const] = ACTIONS(13144),
    [anon_sym_global] = ACTIONS(13144),
    [anon_sym_local] = ACTIONS(13144),
    [anon_sym_LPAREN] = ACTIONS(13144),
    [anon_sym_RPAREN] = ACTIONS(13144),
    [anon_sym_COLON2] = ACTIONS(13144),
    [anon_sym_export] = ACTIONS(13144),
    [anon_sym_import] = ACTIONS(13144),
    [anon_sym_using] = ACTIONS(13144),
    [anon_sym_LBRACK] = ACTIONS(13144),
    [anon_sym_RBRACK] = ACTIONS(13144),
    [anon_sym_LF] = ACTIONS(13146),
    [anon_sym_in] = ACTIONS(13144),
    [anon_sym_LBRACE] = ACTIONS(13144),
    [anon_sym_DOLLAR] = ACTIONS(13144),
    [anon_sym_COLON_COLON] = ACTIONS(13144),
    [anon_sym_isa] = ACTIONS(13144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13144),
    [anon_sym_QMARK] = ACTIONS(13144),
    [anon_sym_AT] = ACTIONS(13144),
    [anon_sym_true] = ACTIONS(13144),
    [anon_sym_false] = ACTIONS(13144),
    [aux_sym_integer_literal_token1] = ACTIONS(13144),
    [aux_sym_integer_literal_token2] = ACTIONS(13144),
    [aux_sym_integer_literal_token3] = ACTIONS(13144),
    [aux_sym_integer_literal_token4] = ACTIONS(13144),
    [aux_sym_float_literal_token1] = ACTIONS(13144),
    [aux_sym_float_literal_token3] = ACTIONS(13144),
    [aux_sym_float_literal_token4] = ACTIONS(13144),
    [sym_character_literal] = ACTIONS(13144),
    [sym__pair_operator] = ACTIONS(13144),
    [sym__arrow_operator] = ACTIONS(13144),
    [sym__lazy_or_operator] = ACTIONS(13144),
    [sym__lazy_and_operator] = ACTIONS(13144),
    [sym__comparison_operator] = ACTIONS(13144),
    [sym__pipe_right_operator] = ACTIONS(13144),
    [sym__pipe_left_operator] = ACTIONS(13144),
    [sym__ellipsis_operator] = ACTIONS(13144),
    [sym__plus_operator] = ACTIONS(13144),
    [sym__times_operator] = ACTIONS(13144),
    [sym__rational_operator] = ACTIONS(13144),
    [sym__bitshift_operator] = ACTIONS(13144),
    [sym__power_operator] = ACTIONS(13144),
    [sym__tilde_operator] = ACTIONS(13144),
    [sym__type_order_operator] = ACTIONS(13144),
    [sym__unary_operator] = ACTIONS(13144),
    [sym__unary_plus_operator] = ACTIONS(13144),
    [aux_sym__terminator_token1] = ACTIONS(13144),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13146),
    [sym__command_start] = ACTIONS(13146),
  },
  [7144] = {
    [ts_builtin_sym_end] = ACTIONS(12620),
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_RPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_RBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7145] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2188),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2188),
    [aux_sym_integer_literal_token2] = ACTIONS(2188),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2188),
    [aux_sym_float_literal_token3] = ACTIONS(2188),
    [aux_sym_float_literal_token4] = ACTIONS(2188),
    [sym_character_literal] = ACTIONS(2188),
    [sym__pair_operator] = ACTIONS(2188),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2188),
    [sym__pipe_left_operator] = ACTIONS(2188),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2188),
    [sym__bitshift_operator] = ACTIONS(2188),
    [sym__power_operator] = ACTIONS(2188),
    [sym__tilde_operator] = ACTIONS(2188),
    [sym__type_order_operator] = ACTIONS(2188),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7146] = {
    [ts_builtin_sym_end] = ACTIONS(12064),
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_RBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [7147] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_catch] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_as] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [7148] = {
    [aux_sym__import_list_repeat1] = STATE(7122),
    [ts_builtin_sym_end] = ACTIONS(12868),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(12896),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_RPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_RBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7149] = {
    [ts_builtin_sym_end] = ACTIONS(12144),
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_RPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_RBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [7150] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_elseif] = ACTIONS(11892),
    [anon_sym_else] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [7151] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_as] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [7152] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12298),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_as] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12298),
    [anon_sym_RPAREN] = ACTIONS(12298),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12298),
    [anon_sym_RBRACK] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_SEMI] = ACTIONS(12298),
    [anon_sym_LBRACE] = ACTIONS(12298),
    [anon_sym_RBRACE] = ACTIONS(12298),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12298),
    [anon_sym_COLON_COLON] = ACTIONS(12298),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12298),
    [anon_sym_QMARK] = ACTIONS(12298),
    [anon_sym_AT] = ACTIONS(12298),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12298),
    [aux_sym_integer_literal_token2] = ACTIONS(12298),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12298),
    [aux_sym_float_literal_token3] = ACTIONS(12298),
    [aux_sym_float_literal_token4] = ACTIONS(12298),
    [sym_character_literal] = ACTIONS(12298),
    [sym__pair_operator] = ACTIONS(12298),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12298),
    [sym__lazy_and_operator] = ACTIONS(12298),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12298),
    [sym__pipe_left_operator] = ACTIONS(12298),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12298),
    [sym__bitshift_operator] = ACTIONS(12298),
    [sym__power_operator] = ACTIONS(12298),
    [sym__tilde_operator] = ACTIONS(12298),
    [sym__type_order_operator] = ACTIONS(12298),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [7153] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_as] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7154] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_elseif] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7155] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_elseif] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7156] = {
    [ts_builtin_sym_end] = ACTIONS(12148),
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_RPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_RBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [7157] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_as] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7158] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13166),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7159] = {
    [ts_builtin_sym_end] = ACTIONS(12156),
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_RPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_RBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [7160] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7161] = {
    [ts_builtin_sym_end] = ACTIONS(12676),
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_RBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7162] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_RPAREN] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_RBRACE] = ACTIONS(11864),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11864),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11864),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11864),
    [sym__pipe_left_operator] = ACTIONS(11864),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11864),
    [sym__bitshift_operator] = ACTIONS(11864),
    [sym__power_operator] = ACTIONS(11864),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11864),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [7163] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12220),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12228),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7164] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_as] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [7165] = {
    [aux_sym_export_statement_repeat1] = STATE(7233),
    [sym__word_identifier] = ACTIONS(13144),
    [anon_sym_EQ] = ACTIONS(13144),
    [anon_sym_COMMA] = ACTIONS(13168),
    [anon_sym_COLON] = ACTIONS(13144),
    [anon_sym_begin] = ACTIONS(13144),
    [anon_sym_module] = ACTIONS(13144),
    [anon_sym_baremodule] = ACTIONS(13144),
    [anon_sym_end] = ACTIONS(13144),
    [anon_sym_abstract] = ACTIONS(13144),
    [anon_sym_primitive] = ACTIONS(13144),
    [anon_sym_mutable] = ACTIONS(13144),
    [anon_sym_struct] = ACTIONS(13144),
    [anon_sym_function] = ACTIONS(13144),
    [anon_sym_macro] = ACTIONS(13144),
    [anon_sym_where] = ACTIONS(13144),
    [anon_sym_quote] = ACTIONS(13144),
    [anon_sym_let] = ACTIONS(13144),
    [anon_sym_if] = ACTIONS(13144),
    [anon_sym_else] = ACTIONS(13144),
    [anon_sym_try] = ACTIONS(13144),
    [anon_sym_finally] = ACTIONS(13144),
    [anon_sym_for] = ACTIONS(13144),
    [anon_sym_while] = ACTIONS(13144),
    [sym_break_statement] = ACTIONS(13144),
    [sym_continue_statement] = ACTIONS(13144),
    [anon_sym_return] = ACTIONS(13144),
    [anon_sym_const] = ACTIONS(13144),
    [anon_sym_global] = ACTIONS(13144),
    [anon_sym_local] = ACTIONS(13144),
    [anon_sym_LPAREN] = ACTIONS(13144),
    [anon_sym_COLON2] = ACTIONS(13144),
    [anon_sym_export] = ACTIONS(13144),
    [anon_sym_import] = ACTIONS(13144),
    [anon_sym_using] = ACTIONS(13144),
    [anon_sym_LBRACK] = ACTIONS(13144),
    [anon_sym_LF] = ACTIONS(13146),
    [anon_sym_in] = ACTIONS(13144),
    [anon_sym_LBRACE] = ACTIONS(13144),
    [anon_sym_DOLLAR] = ACTIONS(13144),
    [anon_sym_COLON_COLON] = ACTIONS(13144),
    [anon_sym_isa] = ACTIONS(13144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13144),
    [anon_sym_QMARK] = ACTIONS(13144),
    [anon_sym_AT] = ACTIONS(13144),
    [anon_sym_true] = ACTIONS(13144),
    [anon_sym_false] = ACTIONS(13144),
    [aux_sym_integer_literal_token1] = ACTIONS(13144),
    [aux_sym_integer_literal_token2] = ACTIONS(13144),
    [aux_sym_integer_literal_token3] = ACTIONS(13144),
    [aux_sym_integer_literal_token4] = ACTIONS(13144),
    [aux_sym_float_literal_token1] = ACTIONS(13144),
    [aux_sym_float_literal_token3] = ACTIONS(13144),
    [aux_sym_float_literal_token4] = ACTIONS(13144),
    [sym_character_literal] = ACTIONS(13144),
    [sym__pair_operator] = ACTIONS(13144),
    [sym__arrow_operator] = ACTIONS(13144),
    [sym__lazy_or_operator] = ACTIONS(13144),
    [sym__lazy_and_operator] = ACTIONS(13144),
    [sym__comparison_operator] = ACTIONS(13144),
    [sym__pipe_right_operator] = ACTIONS(13144),
    [sym__pipe_left_operator] = ACTIONS(13144),
    [sym__ellipsis_operator] = ACTIONS(13144),
    [sym__plus_operator] = ACTIONS(13144),
    [sym__times_operator] = ACTIONS(13144),
    [sym__rational_operator] = ACTIONS(13144),
    [sym__bitshift_operator] = ACTIONS(13144),
    [sym__power_operator] = ACTIONS(13144),
    [sym__tilde_operator] = ACTIONS(13144),
    [sym__type_order_operator] = ACTIONS(13144),
    [sym__unary_operator] = ACTIONS(13144),
    [sym__unary_plus_operator] = ACTIONS(13144),
    [aux_sym__terminator_token1] = ACTIONS(13144),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13146),
    [sym__command_start] = ACTIONS(13146),
  },
  [7166] = {
    [sym_identifier] = STATE(7981),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [7167] = {
    [sym__primary_expression] = STATE(11232),
    [sym__array] = STATE(11232),
    [sym_comprehension_expression] = STATE(11232),
    [sym_matrix_expression] = STATE(11232),
    [sym_vector_expression] = STATE(11232),
    [sym_parenthesized_expression] = STATE(11232),
    [sym_tuple_expression] = STATE(11232),
    [sym_curly_expression] = STATE(11232),
    [sym_adjoint_expression] = STATE(11232),
    [sym_field_expression] = STATE(11232),
    [sym_index_expression] = STATE(11232),
    [sym_parametrized_type_expression] = STATE(11232),
    [sym_call_expression] = STATE(11232),
    [sym_broadcast_call_expression] = STATE(11232),
    [sym__closed_macrocall_expression] = STATE(11232),
    [sym_interpolation_expression] = STATE(11232),
    [sym_quote_expression] = STATE(11232),
    [sym_macro_identifier] = STATE(16973),
    [sym_identifier] = STATE(10685),
    [sym_boolean_literal] = STATE(11232),
    [sym__string] = STATE(11232),
    [sym_string_literal] = STATE(11232),
    [sym_command_literal] = STATE(11232),
    [sym_prefixed_string_literal] = STATE(11232),
    [sym_prefixed_command_literal] = STATE(11232),
    [sym_operator] = STATE(19061),
    [sym__word_identifier] = ACTIONS(13170),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(13172),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(13174),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(13176),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(13178),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(13180),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(13182),
    [anon_sym_false] = ACTIONS(13182),
    [sym_character_literal] = ACTIONS(13184),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13186),
    [sym__command_start] = ACTIONS(13188),
  },
  [7168] = {
    [ts_builtin_sym_end] = ACTIONS(12676),
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_RBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(13190),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7169] = {
    [sym_identifier] = STATE(7625),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_as] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [7170] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_catch] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_as] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [7171] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [7172] = {
    [ts_builtin_sym_end] = ACTIONS(12160),
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_RPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_RBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [7173] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_catch] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_as] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [7174] = {
    [sym_identifier] = STATE(7982),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [7175] = {
    [sym_identifier] = STATE(7988),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [7176] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [7177] = {
    [sym_identifier] = STATE(7989),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [7178] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7179] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_catch] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_as] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [7180] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_as] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7181] = {
    [sym__word_identifier] = ACTIONS(12846),
    [anon_sym_EQ] = ACTIONS(12846),
    [anon_sym_COMMA] = ACTIONS(12846),
    [anon_sym_COLON] = ACTIONS(12846),
    [anon_sym_begin] = ACTIONS(12846),
    [anon_sym_module] = ACTIONS(12846),
    [anon_sym_baremodule] = ACTIONS(12846),
    [anon_sym_end] = ACTIONS(12846),
    [anon_sym_abstract] = ACTIONS(12846),
    [anon_sym_primitive] = ACTIONS(12846),
    [anon_sym_mutable] = ACTIONS(12846),
    [anon_sym_struct] = ACTIONS(12846),
    [anon_sym_function] = ACTIONS(12846),
    [anon_sym_macro] = ACTIONS(12846),
    [anon_sym_where] = ACTIONS(12846),
    [anon_sym_quote] = ACTIONS(12846),
    [anon_sym_let] = ACTIONS(12846),
    [anon_sym_if] = ACTIONS(12846),
    [anon_sym_try] = ACTIONS(12846),
    [anon_sym_catch] = ACTIONS(12846),
    [anon_sym_for] = ACTIONS(12846),
    [anon_sym_while] = ACTIONS(12846),
    [sym_break_statement] = ACTIONS(12846),
    [sym_continue_statement] = ACTIONS(12846),
    [anon_sym_return] = ACTIONS(12846),
    [anon_sym_const] = ACTIONS(12846),
    [anon_sym_global] = ACTIONS(12846),
    [anon_sym_local] = ACTIONS(12846),
    [anon_sym_as] = ACTIONS(12846),
    [anon_sym_LPAREN] = ACTIONS(12846),
    [anon_sym_COLON2] = ACTIONS(12846),
    [anon_sym_export] = ACTIONS(12846),
    [anon_sym_import] = ACTIONS(12846),
    [anon_sym_using] = ACTIONS(12846),
    [anon_sym_LBRACK] = ACTIONS(12846),
    [anon_sym_LF] = ACTIONS(12848),
    [anon_sym_in] = ACTIONS(12846),
    [anon_sym_LBRACE] = ACTIONS(12846),
    [anon_sym_DOT] = ACTIONS(13010),
    [anon_sym_DOLLAR] = ACTIONS(12846),
    [anon_sym_COLON_COLON] = ACTIONS(12846),
    [anon_sym_isa] = ACTIONS(12846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12846),
    [anon_sym_QMARK] = ACTIONS(12846),
    [anon_sym_AT] = ACTIONS(12846),
    [anon_sym_true] = ACTIONS(12846),
    [anon_sym_false] = ACTIONS(12846),
    [aux_sym_integer_literal_token1] = ACTIONS(12846),
    [aux_sym_integer_literal_token2] = ACTIONS(12846),
    [aux_sym_integer_literal_token3] = ACTIONS(12846),
    [aux_sym_integer_literal_token4] = ACTIONS(12846),
    [aux_sym_float_literal_token1] = ACTIONS(12846),
    [aux_sym_float_literal_token3] = ACTIONS(12846),
    [aux_sym_float_literal_token4] = ACTIONS(12846),
    [sym_character_literal] = ACTIONS(12846),
    [sym__pair_operator] = ACTIONS(12846),
    [sym__arrow_operator] = ACTIONS(12846),
    [sym__lazy_or_operator] = ACTIONS(12846),
    [sym__lazy_and_operator] = ACTIONS(12846),
    [sym__comparison_operator] = ACTIONS(12846),
    [sym__pipe_right_operator] = ACTIONS(12846),
    [sym__pipe_left_operator] = ACTIONS(12846),
    [sym__ellipsis_operator] = ACTIONS(12846),
    [sym__plus_operator] = ACTIONS(12846),
    [sym__times_operator] = ACTIONS(12846),
    [sym__rational_operator] = ACTIONS(12846),
    [sym__bitshift_operator] = ACTIONS(12846),
    [sym__power_operator] = ACTIONS(12846),
    [sym__tilde_operator] = ACTIONS(12846),
    [sym__type_order_operator] = ACTIONS(12846),
    [sym__unary_operator] = ACTIONS(12846),
    [sym__unary_plus_operator] = ACTIONS(12846),
    [aux_sym__terminator_token1] = ACTIONS(12846),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12848),
    [sym__command_start] = ACTIONS(12848),
  },
  [7182] = {
    [ts_builtin_sym_end] = ACTIONS(12208),
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_RPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_RBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [7183] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12676),
    [sym__immediate_bracket] = ACTIONS(12676),
    [sym__immediate_brace] = ACTIONS(12676),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7184] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_as] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [7185] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_else] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [7186] = {
    [sym__word_identifier] = ACTIONS(12846),
    [anon_sym_EQ] = ACTIONS(12846),
    [anon_sym_COMMA] = ACTIONS(12848),
    [anon_sym_COLON] = ACTIONS(12846),
    [anon_sym_begin] = ACTIONS(12846),
    [anon_sym_module] = ACTIONS(12846),
    [anon_sym_baremodule] = ACTIONS(12846),
    [anon_sym_abstract] = ACTIONS(12846),
    [anon_sym_primitive] = ACTIONS(12846),
    [anon_sym_mutable] = ACTIONS(12846),
    [anon_sym_struct] = ACTIONS(12846),
    [anon_sym_function] = ACTIONS(12846),
    [anon_sym_macro] = ACTIONS(12846),
    [anon_sym_where] = ACTIONS(12846),
    [anon_sym_quote] = ACTIONS(12846),
    [anon_sym_let] = ACTIONS(12846),
    [anon_sym_if] = ACTIONS(12846),
    [anon_sym_try] = ACTIONS(12846),
    [anon_sym_for] = ACTIONS(12846),
    [anon_sym_while] = ACTIONS(12846),
    [sym_break_statement] = ACTIONS(12846),
    [sym_continue_statement] = ACTIONS(12846),
    [anon_sym_return] = ACTIONS(12846),
    [anon_sym_const] = ACTIONS(12846),
    [anon_sym_global] = ACTIONS(12846),
    [anon_sym_local] = ACTIONS(12846),
    [anon_sym_as] = ACTIONS(12846),
    [anon_sym_LPAREN] = ACTIONS(12848),
    [anon_sym_RPAREN] = ACTIONS(12848),
    [anon_sym_COLON2] = ACTIONS(12846),
    [anon_sym_export] = ACTIONS(12846),
    [anon_sym_import] = ACTIONS(12846),
    [anon_sym_using] = ACTIONS(12846),
    [anon_sym_LBRACK] = ACTIONS(12848),
    [anon_sym_RBRACK] = ACTIONS(12848),
    [anon_sym_in] = ACTIONS(12846),
    [anon_sym_SEMI] = ACTIONS(12848),
    [anon_sym_LBRACE] = ACTIONS(12848),
    [anon_sym_RBRACE] = ACTIONS(12848),
    [anon_sym_DOT] = ACTIONS(13086),
    [anon_sym_DOLLAR] = ACTIONS(12848),
    [anon_sym_COLON_COLON] = ACTIONS(12848),
    [anon_sym_isa] = ACTIONS(12846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12848),
    [anon_sym_QMARK] = ACTIONS(12848),
    [anon_sym_AT] = ACTIONS(12848),
    [anon_sym_true] = ACTIONS(12846),
    [anon_sym_false] = ACTIONS(12846),
    [aux_sym_integer_literal_token1] = ACTIONS(12848),
    [aux_sym_integer_literal_token2] = ACTIONS(12848),
    [aux_sym_integer_literal_token3] = ACTIONS(12846),
    [aux_sym_integer_literal_token4] = ACTIONS(12846),
    [aux_sym_float_literal_token1] = ACTIONS(12848),
    [aux_sym_float_literal_token3] = ACTIONS(12848),
    [aux_sym_float_literal_token4] = ACTIONS(12848),
    [sym_character_literal] = ACTIONS(12848),
    [sym__pair_operator] = ACTIONS(12848),
    [sym__arrow_operator] = ACTIONS(12846),
    [sym__lazy_or_operator] = ACTIONS(12848),
    [sym__lazy_and_operator] = ACTIONS(12848),
    [sym__comparison_operator] = ACTIONS(12846),
    [sym__pipe_right_operator] = ACTIONS(12848),
    [sym__pipe_left_operator] = ACTIONS(12848),
    [sym__ellipsis_operator] = ACTIONS(12846),
    [sym__plus_operator] = ACTIONS(12846),
    [sym__times_operator] = ACTIONS(12846),
    [sym__rational_operator] = ACTIONS(12848),
    [sym__bitshift_operator] = ACTIONS(12848),
    [sym__power_operator] = ACTIONS(12848),
    [sym__tilde_operator] = ACTIONS(12848),
    [sym__type_order_operator] = ACTIONS(12848),
    [sym__unary_operator] = ACTIONS(12846),
    [sym__unary_plus_operator] = ACTIONS(12846),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12848),
    [sym__command_start] = ACTIONS(12848),
  },
  [7187] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_catch] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_as] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [7188] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_catch] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_as] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [7189] = {
    [sym_identifier] = STATE(7626),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_as] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [7190] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(13032),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7191] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_as] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7192] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12220),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11878),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7193] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_catch] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_as] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [7194] = {
    [aux_sym__import_list_repeat1] = STATE(7256),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_else] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_finally] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7195] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_catch] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_as] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [7196] = {
    [aux_sym__import_list_repeat1] = STATE(7348),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13012),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_catch] = ACTIONS(12862),
    [anon_sym_finally] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13014),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7197] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_else] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7198] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_as] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7199] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_as] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7200] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_as] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [7201] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_as] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [7202] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_catch] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_as] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [7203] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_catch] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_as] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [7204] = {
    [sym_identifier] = STATE(7682),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11994),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11994),
    [anon_sym_RPAREN] = ACTIONS(11994),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11994),
    [anon_sym_RBRACK] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_SEMI] = ACTIONS(11994),
    [anon_sym_LBRACE] = ACTIONS(11994),
    [anon_sym_RBRACE] = ACTIONS(11994),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11994),
    [anon_sym_COLON_COLON] = ACTIONS(11994),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11994),
    [anon_sym_QMARK] = ACTIONS(11994),
    [anon_sym_AT] = ACTIONS(11994),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11994),
    [aux_sym_integer_literal_token2] = ACTIONS(11994),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11994),
    [aux_sym_float_literal_token3] = ACTIONS(11994),
    [aux_sym_float_literal_token4] = ACTIONS(11994),
    [sym_character_literal] = ACTIONS(11994),
    [sym__pair_operator] = ACTIONS(11994),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11994),
    [sym__lazy_and_operator] = ACTIONS(11994),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11994),
    [sym__pipe_left_operator] = ACTIONS(11994),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11994),
    [sym__bitshift_operator] = ACTIONS(11994),
    [sym__power_operator] = ACTIONS(11994),
    [sym__tilde_operator] = ACTIONS(11994),
    [sym__type_order_operator] = ACTIONS(11994),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [7205] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_catch] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_as] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [7206] = {
    [sym_identifier] = STATE(7683),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11956),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11956),
    [anon_sym_RPAREN] = ACTIONS(11956),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11956),
    [anon_sym_RBRACK] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_SEMI] = ACTIONS(11956),
    [anon_sym_LBRACE] = ACTIONS(11956),
    [anon_sym_RBRACE] = ACTIONS(11956),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11956),
    [anon_sym_COLON_COLON] = ACTIONS(11956),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11956),
    [anon_sym_QMARK] = ACTIONS(11956),
    [anon_sym_AT] = ACTIONS(11956),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11956),
    [aux_sym_integer_literal_token2] = ACTIONS(11956),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11956),
    [aux_sym_float_literal_token3] = ACTIONS(11956),
    [aux_sym_float_literal_token4] = ACTIONS(11956),
    [sym_character_literal] = ACTIONS(11956),
    [sym__pair_operator] = ACTIONS(11956),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11956),
    [sym__lazy_and_operator] = ACTIONS(11956),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11956),
    [sym__pipe_left_operator] = ACTIONS(11956),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11956),
    [sym__bitshift_operator] = ACTIONS(11956),
    [sym__power_operator] = ACTIONS(11956),
    [sym__tilde_operator] = ACTIONS(11956),
    [sym__type_order_operator] = ACTIONS(11956),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [7207] = {
    [sym_identifier] = STATE(7690),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12004),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12004),
    [anon_sym_RPAREN] = ACTIONS(12004),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12004),
    [anon_sym_RBRACK] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_SEMI] = ACTIONS(12004),
    [anon_sym_LBRACE] = ACTIONS(12004),
    [anon_sym_RBRACE] = ACTIONS(12004),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12004),
    [anon_sym_COLON_COLON] = ACTIONS(12004),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12004),
    [anon_sym_QMARK] = ACTIONS(12004),
    [anon_sym_AT] = ACTIONS(12004),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12004),
    [aux_sym_integer_literal_token2] = ACTIONS(12004),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12004),
    [aux_sym_float_literal_token3] = ACTIONS(12004),
    [aux_sym_float_literal_token4] = ACTIONS(12004),
    [sym_character_literal] = ACTIONS(12004),
    [sym__pair_operator] = ACTIONS(12004),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12004),
    [sym__lazy_and_operator] = ACTIONS(12004),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12004),
    [sym__pipe_left_operator] = ACTIONS(12004),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12004),
    [sym__bitshift_operator] = ACTIONS(12004),
    [sym__power_operator] = ACTIONS(12004),
    [sym__tilde_operator] = ACTIONS(12004),
    [sym__type_order_operator] = ACTIONS(12004),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [7208] = {
    [ts_builtin_sym_end] = ACTIONS(12164),
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [7209] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11894),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11894),
    [anon_sym_RPAREN] = ACTIONS(11894),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11894),
    [anon_sym_RBRACK] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11894),
    [anon_sym_RBRACE] = ACTIONS(11894),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11894),
    [anon_sym_COLON_COLON] = ACTIONS(11894),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11894),
    [anon_sym_QMARK] = ACTIONS(11894),
    [anon_sym_AT] = ACTIONS(11894),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11894),
    [aux_sym_integer_literal_token2] = ACTIONS(11894),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11894),
    [aux_sym_float_literal_token3] = ACTIONS(11894),
    [aux_sym_float_literal_token4] = ACTIONS(11894),
    [sym_character_literal] = ACTIONS(11894),
    [sym__pair_operator] = ACTIONS(11894),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11894),
    [sym__lazy_and_operator] = ACTIONS(11894),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11894),
    [sym__pipe_left_operator] = ACTIONS(11894),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11894),
    [sym__bitshift_operator] = ACTIONS(11894),
    [sym__power_operator] = ACTIONS(11894),
    [sym__tilde_operator] = ACTIONS(11894),
    [sym__type_order_operator] = ACTIONS(11894),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [7210] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_catch] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_as] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [7211] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_end] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_else] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_finally] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_as] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [7212] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_catch] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_as] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [7213] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12302),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_as] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12302),
    [anon_sym_RPAREN] = ACTIONS(12302),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12302),
    [anon_sym_RBRACK] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_SEMI] = ACTIONS(12302),
    [anon_sym_LBRACE] = ACTIONS(12302),
    [anon_sym_RBRACE] = ACTIONS(12302),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12302),
    [anon_sym_COLON_COLON] = ACTIONS(12302),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12302),
    [anon_sym_QMARK] = ACTIONS(12302),
    [anon_sym_AT] = ACTIONS(12302),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12302),
    [aux_sym_integer_literal_token2] = ACTIONS(12302),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12302),
    [aux_sym_float_literal_token3] = ACTIONS(12302),
    [aux_sym_float_literal_token4] = ACTIONS(12302),
    [sym_character_literal] = ACTIONS(12302),
    [sym__pair_operator] = ACTIONS(12302),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12302),
    [sym__lazy_and_operator] = ACTIONS(12302),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12302),
    [sym__pipe_left_operator] = ACTIONS(12302),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12302),
    [sym__bitshift_operator] = ACTIONS(12302),
    [sym__power_operator] = ACTIONS(12302),
    [sym__tilde_operator] = ACTIONS(12302),
    [sym__type_order_operator] = ACTIONS(12302),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [7214] = {
    [sym_identifier] = STATE(7691),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12008),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12008),
    [anon_sym_RPAREN] = ACTIONS(12008),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12008),
    [anon_sym_RBRACK] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_SEMI] = ACTIONS(12008),
    [anon_sym_LBRACE] = ACTIONS(12008),
    [anon_sym_RBRACE] = ACTIONS(12008),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12008),
    [anon_sym_COLON_COLON] = ACTIONS(12008),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12008),
    [anon_sym_QMARK] = ACTIONS(12008),
    [anon_sym_AT] = ACTIONS(12008),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12008),
    [aux_sym_integer_literal_token2] = ACTIONS(12008),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12008),
    [aux_sym_float_literal_token3] = ACTIONS(12008),
    [aux_sym_float_literal_token4] = ACTIONS(12008),
    [sym_character_literal] = ACTIONS(12008),
    [sym__pair_operator] = ACTIONS(12008),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12008),
    [sym__lazy_and_operator] = ACTIONS(12008),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12008),
    [sym__pipe_left_operator] = ACTIONS(12008),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12008),
    [sym__bitshift_operator] = ACTIONS(12008),
    [sym__power_operator] = ACTIONS(12008),
    [sym__tilde_operator] = ACTIONS(12008),
    [sym__type_order_operator] = ACTIONS(12008),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [7215] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_as] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [7216] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12894),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7217] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_catch] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_as] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [7218] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_catch] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_as] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [7219] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_catch] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_as] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [7220] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_catch] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_as] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [7221] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [7222] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_catch] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_as] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [7223] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_catch] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_as] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [7224] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_catch] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_as] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [7225] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_catch] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_as] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [7226] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_catch] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_as] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [7227] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_catch] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_as] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [7228] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [7229] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_as] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [7230] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_catch] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_as] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [7231] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_else] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [7232] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7233] = {
    [aux_sym_export_statement_repeat1] = STATE(7012),
    [sym__word_identifier] = ACTIONS(13060),
    [anon_sym_EQ] = ACTIONS(13060),
    [anon_sym_COMMA] = ACTIONS(13168),
    [anon_sym_COLON] = ACTIONS(13060),
    [anon_sym_begin] = ACTIONS(13060),
    [anon_sym_module] = ACTIONS(13060),
    [anon_sym_baremodule] = ACTIONS(13060),
    [anon_sym_end] = ACTIONS(13060),
    [anon_sym_abstract] = ACTIONS(13060),
    [anon_sym_primitive] = ACTIONS(13060),
    [anon_sym_mutable] = ACTIONS(13060),
    [anon_sym_struct] = ACTIONS(13060),
    [anon_sym_function] = ACTIONS(13060),
    [anon_sym_macro] = ACTIONS(13060),
    [anon_sym_where] = ACTIONS(13060),
    [anon_sym_quote] = ACTIONS(13060),
    [anon_sym_let] = ACTIONS(13060),
    [anon_sym_if] = ACTIONS(13060),
    [anon_sym_else] = ACTIONS(13060),
    [anon_sym_try] = ACTIONS(13060),
    [anon_sym_finally] = ACTIONS(13060),
    [anon_sym_for] = ACTIONS(13060),
    [anon_sym_while] = ACTIONS(13060),
    [sym_break_statement] = ACTIONS(13060),
    [sym_continue_statement] = ACTIONS(13060),
    [anon_sym_return] = ACTIONS(13060),
    [anon_sym_const] = ACTIONS(13060),
    [anon_sym_global] = ACTIONS(13060),
    [anon_sym_local] = ACTIONS(13060),
    [anon_sym_LPAREN] = ACTIONS(13060),
    [anon_sym_COLON2] = ACTIONS(13060),
    [anon_sym_export] = ACTIONS(13060),
    [anon_sym_import] = ACTIONS(13060),
    [anon_sym_using] = ACTIONS(13060),
    [anon_sym_LBRACK] = ACTIONS(13060),
    [anon_sym_LF] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13060),
    [anon_sym_LBRACE] = ACTIONS(13060),
    [anon_sym_DOLLAR] = ACTIONS(13060),
    [anon_sym_COLON_COLON] = ACTIONS(13060),
    [anon_sym_isa] = ACTIONS(13060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13060),
    [anon_sym_QMARK] = ACTIONS(13060),
    [anon_sym_AT] = ACTIONS(13060),
    [anon_sym_true] = ACTIONS(13060),
    [anon_sym_false] = ACTIONS(13060),
    [aux_sym_integer_literal_token1] = ACTIONS(13060),
    [aux_sym_integer_literal_token2] = ACTIONS(13060),
    [aux_sym_integer_literal_token3] = ACTIONS(13060),
    [aux_sym_integer_literal_token4] = ACTIONS(13060),
    [aux_sym_float_literal_token1] = ACTIONS(13060),
    [aux_sym_float_literal_token3] = ACTIONS(13060),
    [aux_sym_float_literal_token4] = ACTIONS(13060),
    [sym_character_literal] = ACTIONS(13060),
    [sym__pair_operator] = ACTIONS(13060),
    [sym__arrow_operator] = ACTIONS(13060),
    [sym__lazy_or_operator] = ACTIONS(13060),
    [sym__lazy_and_operator] = ACTIONS(13060),
    [sym__comparison_operator] = ACTIONS(13060),
    [sym__pipe_right_operator] = ACTIONS(13060),
    [sym__pipe_left_operator] = ACTIONS(13060),
    [sym__ellipsis_operator] = ACTIONS(13060),
    [sym__plus_operator] = ACTIONS(13060),
    [sym__times_operator] = ACTIONS(13060),
    [sym__rational_operator] = ACTIONS(13060),
    [sym__bitshift_operator] = ACTIONS(13060),
    [sym__power_operator] = ACTIONS(13060),
    [sym__tilde_operator] = ACTIONS(13060),
    [sym__type_order_operator] = ACTIONS(13060),
    [sym__unary_operator] = ACTIONS(13060),
    [sym__unary_plus_operator] = ACTIONS(13060),
    [aux_sym__terminator_token1] = ACTIONS(13060),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13064),
    [sym__command_start] = ACTIONS(13064),
  },
  [7234] = {
    [ts_builtin_sym_end] = ACTIONS(12168),
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_RPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_RBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [7235] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12056),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_as] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12056),
    [anon_sym_RPAREN] = ACTIONS(12056),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12056),
    [anon_sym_RBRACK] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12056),
    [anon_sym_LBRACE] = ACTIONS(12056),
    [anon_sym_RBRACE] = ACTIONS(12056),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12056),
    [anon_sym_COLON_COLON] = ACTIONS(12056),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12056),
    [anon_sym_QMARK] = ACTIONS(12056),
    [anon_sym_AT] = ACTIONS(12056),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12056),
    [aux_sym_integer_literal_token2] = ACTIONS(12056),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12056),
    [aux_sym_float_literal_token3] = ACTIONS(12056),
    [aux_sym_float_literal_token4] = ACTIONS(12056),
    [sym_character_literal] = ACTIONS(12056),
    [sym__pair_operator] = ACTIONS(12056),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12056),
    [sym__lazy_and_operator] = ACTIONS(12056),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12056),
    [sym__pipe_left_operator] = ACTIONS(12056),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12056),
    [sym__bitshift_operator] = ACTIONS(12056),
    [sym__power_operator] = ACTIONS(12056),
    [sym__tilde_operator] = ACTIONS(12056),
    [sym__type_order_operator] = ACTIONS(12056),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7236] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_catch] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_as] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [7237] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_else] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7238] = {
    [aux_sym__import_list_repeat1] = STATE(8019),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13090),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13092),
    [anon_sym_LPAREN] = ACTIONS(12868),
    [anon_sym_RPAREN] = ACTIONS(12868),
    [anon_sym_COLON2] = ACTIONS(13192),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12868),
    [anon_sym_RBRACK] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_SEMI] = ACTIONS(12868),
    [anon_sym_LBRACE] = ACTIONS(12868),
    [anon_sym_RBRACE] = ACTIONS(12868),
    [anon_sym_DOLLAR] = ACTIONS(12868),
    [anon_sym_COLON_COLON] = ACTIONS(12868),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12868),
    [anon_sym_QMARK] = ACTIONS(12868),
    [anon_sym_AT] = ACTIONS(12868),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12868),
    [aux_sym_integer_literal_token2] = ACTIONS(12868),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12868),
    [aux_sym_float_literal_token3] = ACTIONS(12868),
    [aux_sym_float_literal_token4] = ACTIONS(12868),
    [sym_character_literal] = ACTIONS(12868),
    [sym__pair_operator] = ACTIONS(12868),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12868),
    [sym__lazy_and_operator] = ACTIONS(12868),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12868),
    [sym__pipe_left_operator] = ACTIONS(12868),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12868),
    [sym__bitshift_operator] = ACTIONS(12868),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(12868),
    [sym__type_order_operator] = ACTIONS(12868),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7239] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_as] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [7240] = {
    [sym__word_identifier] = ACTIONS(12882),
    [anon_sym_EQ] = ACTIONS(12882),
    [anon_sym_COMMA] = ACTIONS(12884),
    [anon_sym_COLON] = ACTIONS(12882),
    [anon_sym_begin] = ACTIONS(12882),
    [anon_sym_module] = ACTIONS(12882),
    [anon_sym_baremodule] = ACTIONS(12882),
    [anon_sym_abstract] = ACTIONS(12882),
    [anon_sym_primitive] = ACTIONS(12882),
    [anon_sym_mutable] = ACTIONS(12882),
    [anon_sym_struct] = ACTIONS(12882),
    [anon_sym_function] = ACTIONS(12882),
    [anon_sym_macro] = ACTIONS(12882),
    [anon_sym_where] = ACTIONS(12882),
    [anon_sym_quote] = ACTIONS(12882),
    [anon_sym_let] = ACTIONS(12882),
    [anon_sym_if] = ACTIONS(12882),
    [anon_sym_try] = ACTIONS(12882),
    [anon_sym_for] = ACTIONS(12882),
    [anon_sym_while] = ACTIONS(12882),
    [sym_break_statement] = ACTIONS(12882),
    [sym_continue_statement] = ACTIONS(12882),
    [anon_sym_return] = ACTIONS(12882),
    [anon_sym_const] = ACTIONS(12882),
    [anon_sym_global] = ACTIONS(12882),
    [anon_sym_local] = ACTIONS(12882),
    [anon_sym_as] = ACTIONS(12882),
    [anon_sym_LPAREN] = ACTIONS(12884),
    [anon_sym_RPAREN] = ACTIONS(12884),
    [anon_sym_COLON2] = ACTIONS(12882),
    [anon_sym_export] = ACTIONS(12882),
    [anon_sym_import] = ACTIONS(12882),
    [anon_sym_using] = ACTIONS(12882),
    [anon_sym_LBRACK] = ACTIONS(12884),
    [anon_sym_RBRACK] = ACTIONS(12884),
    [anon_sym_in] = ACTIONS(12882),
    [anon_sym_SEMI] = ACTIONS(12884),
    [anon_sym_LBRACE] = ACTIONS(12884),
    [anon_sym_RBRACE] = ACTIONS(12884),
    [anon_sym_DOT] = ACTIONS(13086),
    [anon_sym_DOLLAR] = ACTIONS(12884),
    [anon_sym_COLON_COLON] = ACTIONS(12884),
    [anon_sym_isa] = ACTIONS(12882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12884),
    [anon_sym_QMARK] = ACTIONS(12884),
    [anon_sym_AT] = ACTIONS(12884),
    [anon_sym_true] = ACTIONS(12882),
    [anon_sym_false] = ACTIONS(12882),
    [aux_sym_integer_literal_token1] = ACTIONS(12884),
    [aux_sym_integer_literal_token2] = ACTIONS(12884),
    [aux_sym_integer_literal_token3] = ACTIONS(12882),
    [aux_sym_integer_literal_token4] = ACTIONS(12882),
    [aux_sym_float_literal_token1] = ACTIONS(12884),
    [aux_sym_float_literal_token3] = ACTIONS(12884),
    [aux_sym_float_literal_token4] = ACTIONS(12884),
    [sym_character_literal] = ACTIONS(12884),
    [sym__pair_operator] = ACTIONS(12884),
    [sym__arrow_operator] = ACTIONS(12882),
    [sym__lazy_or_operator] = ACTIONS(12884),
    [sym__lazy_and_operator] = ACTIONS(12884),
    [sym__comparison_operator] = ACTIONS(12882),
    [sym__pipe_right_operator] = ACTIONS(12884),
    [sym__pipe_left_operator] = ACTIONS(12884),
    [sym__ellipsis_operator] = ACTIONS(12882),
    [sym__plus_operator] = ACTIONS(12882),
    [sym__times_operator] = ACTIONS(12882),
    [sym__rational_operator] = ACTIONS(12884),
    [sym__bitshift_operator] = ACTIONS(12884),
    [sym__power_operator] = ACTIONS(12884),
    [sym__tilde_operator] = ACTIONS(12884),
    [sym__type_order_operator] = ACTIONS(12884),
    [sym__unary_operator] = ACTIONS(12882),
    [sym__unary_plus_operator] = ACTIONS(12882),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12884),
    [sym__command_start] = ACTIONS(12884),
  },
  [7241] = {
    [sym__word_identifier] = ACTIONS(12886),
    [anon_sym_EQ] = ACTIONS(12886),
    [anon_sym_COMMA] = ACTIONS(12888),
    [anon_sym_COLON] = ACTIONS(12886),
    [anon_sym_begin] = ACTIONS(12886),
    [anon_sym_module] = ACTIONS(12886),
    [anon_sym_baremodule] = ACTIONS(12886),
    [anon_sym_abstract] = ACTIONS(12886),
    [anon_sym_primitive] = ACTIONS(12886),
    [anon_sym_mutable] = ACTIONS(12886),
    [anon_sym_struct] = ACTIONS(12886),
    [anon_sym_function] = ACTIONS(12886),
    [anon_sym_macro] = ACTIONS(12886),
    [anon_sym_where] = ACTIONS(12886),
    [anon_sym_quote] = ACTIONS(12886),
    [anon_sym_let] = ACTIONS(12886),
    [anon_sym_if] = ACTIONS(12886),
    [anon_sym_try] = ACTIONS(12886),
    [anon_sym_for] = ACTIONS(12886),
    [anon_sym_while] = ACTIONS(12886),
    [sym_break_statement] = ACTIONS(12886),
    [sym_continue_statement] = ACTIONS(12886),
    [anon_sym_return] = ACTIONS(12886),
    [anon_sym_const] = ACTIONS(12886),
    [anon_sym_global] = ACTIONS(12886),
    [anon_sym_local] = ACTIONS(12886),
    [anon_sym_as] = ACTIONS(12886),
    [anon_sym_LPAREN] = ACTIONS(12888),
    [anon_sym_RPAREN] = ACTIONS(12888),
    [anon_sym_COLON2] = ACTIONS(12886),
    [anon_sym_export] = ACTIONS(12886),
    [anon_sym_import] = ACTIONS(12886),
    [anon_sym_using] = ACTIONS(12886),
    [anon_sym_LBRACK] = ACTIONS(12888),
    [anon_sym_RBRACK] = ACTIONS(12888),
    [anon_sym_in] = ACTIONS(12886),
    [anon_sym_SEMI] = ACTIONS(12888),
    [anon_sym_LBRACE] = ACTIONS(12888),
    [anon_sym_RBRACE] = ACTIONS(12888),
    [anon_sym_DOT] = ACTIONS(13086),
    [anon_sym_DOLLAR] = ACTIONS(12888),
    [anon_sym_COLON_COLON] = ACTIONS(12888),
    [anon_sym_isa] = ACTIONS(12886),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12888),
    [anon_sym_QMARK] = ACTIONS(12888),
    [anon_sym_AT] = ACTIONS(12888),
    [anon_sym_true] = ACTIONS(12886),
    [anon_sym_false] = ACTIONS(12886),
    [aux_sym_integer_literal_token1] = ACTIONS(12888),
    [aux_sym_integer_literal_token2] = ACTIONS(12888),
    [aux_sym_integer_literal_token3] = ACTIONS(12886),
    [aux_sym_integer_literal_token4] = ACTIONS(12886),
    [aux_sym_float_literal_token1] = ACTIONS(12888),
    [aux_sym_float_literal_token3] = ACTIONS(12888),
    [aux_sym_float_literal_token4] = ACTIONS(12888),
    [sym_character_literal] = ACTIONS(12888),
    [sym__pair_operator] = ACTIONS(12888),
    [sym__arrow_operator] = ACTIONS(12886),
    [sym__lazy_or_operator] = ACTIONS(12888),
    [sym__lazy_and_operator] = ACTIONS(12888),
    [sym__comparison_operator] = ACTIONS(12886),
    [sym__pipe_right_operator] = ACTIONS(12888),
    [sym__pipe_left_operator] = ACTIONS(12888),
    [sym__ellipsis_operator] = ACTIONS(12886),
    [sym__plus_operator] = ACTIONS(12886),
    [sym__times_operator] = ACTIONS(12886),
    [sym__rational_operator] = ACTIONS(12888),
    [sym__bitshift_operator] = ACTIONS(12888),
    [sym__power_operator] = ACTIONS(12888),
    [sym__tilde_operator] = ACTIONS(12888),
    [sym__type_order_operator] = ACTIONS(12888),
    [sym__unary_operator] = ACTIONS(12886),
    [sym__unary_plus_operator] = ACTIONS(12886),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12888),
    [sym__command_start] = ACTIONS(12888),
  },
  [7242] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_as] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [7243] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12450),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11858),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7244] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_elseif] = ACTIONS(12388),
    [anon_sym_else] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7245] = {
    [ts_builtin_sym_end] = ACTIONS(2188),
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7246] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_else] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [7247] = {
    [aux_sym_open_tuple_repeat1] = STATE(7000),
    [sym__word_identifier] = ACTIONS(13150),
    [anon_sym_EQ] = ACTIONS(13150),
    [anon_sym_COMMA] = ACTIONS(13194),
    [anon_sym_COLON] = ACTIONS(13150),
    [anon_sym_begin] = ACTIONS(13150),
    [anon_sym_module] = ACTIONS(13150),
    [anon_sym_baremodule] = ACTIONS(13150),
    [anon_sym_end] = ACTIONS(13150),
    [anon_sym_abstract] = ACTIONS(13150),
    [anon_sym_primitive] = ACTIONS(13150),
    [anon_sym_mutable] = ACTIONS(13150),
    [anon_sym_struct] = ACTIONS(13150),
    [anon_sym_function] = ACTIONS(13150),
    [anon_sym_macro] = ACTIONS(13150),
    [anon_sym_where] = ACTIONS(13150),
    [anon_sym_quote] = ACTIONS(13150),
    [anon_sym_let] = ACTIONS(13150),
    [anon_sym_if] = ACTIONS(13150),
    [anon_sym_else] = ACTIONS(13150),
    [anon_sym_try] = ACTIONS(13150),
    [anon_sym_finally] = ACTIONS(13150),
    [anon_sym_for] = ACTIONS(13150),
    [anon_sym_while] = ACTIONS(13150),
    [sym_break_statement] = ACTIONS(13150),
    [sym_continue_statement] = ACTIONS(13150),
    [anon_sym_return] = ACTIONS(13150),
    [anon_sym_const] = ACTIONS(13150),
    [anon_sym_global] = ACTIONS(13150),
    [anon_sym_local] = ACTIONS(13150),
    [anon_sym_LPAREN] = ACTIONS(13150),
    [anon_sym_COLON2] = ACTIONS(13150),
    [anon_sym_export] = ACTIONS(13150),
    [anon_sym_import] = ACTIONS(13150),
    [anon_sym_using] = ACTIONS(13150),
    [anon_sym_LBRACK] = ACTIONS(13150),
    [anon_sym_LF] = ACTIONS(13148),
    [anon_sym_in] = ACTIONS(13150),
    [anon_sym_LBRACE] = ACTIONS(13150),
    [anon_sym_DOLLAR] = ACTIONS(13150),
    [anon_sym_COLON_COLON] = ACTIONS(13150),
    [anon_sym_isa] = ACTIONS(13150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13150),
    [anon_sym_QMARK] = ACTIONS(13150),
    [anon_sym_AT] = ACTIONS(13150),
    [anon_sym_true] = ACTIONS(13150),
    [anon_sym_false] = ACTIONS(13150),
    [aux_sym_integer_literal_token1] = ACTIONS(13150),
    [aux_sym_integer_literal_token2] = ACTIONS(13150),
    [aux_sym_integer_literal_token3] = ACTIONS(13150),
    [aux_sym_integer_literal_token4] = ACTIONS(13150),
    [aux_sym_float_literal_token1] = ACTIONS(13150),
    [aux_sym_float_literal_token3] = ACTIONS(13150),
    [aux_sym_float_literal_token4] = ACTIONS(13150),
    [sym_character_literal] = ACTIONS(13150),
    [sym__pair_operator] = ACTIONS(13150),
    [sym__arrow_operator] = ACTIONS(13150),
    [sym__lazy_or_operator] = ACTIONS(13150),
    [sym__lazy_and_operator] = ACTIONS(13150),
    [sym__comparison_operator] = ACTIONS(13150),
    [sym__pipe_right_operator] = ACTIONS(13150),
    [sym__pipe_left_operator] = ACTIONS(13150),
    [sym__ellipsis_operator] = ACTIONS(13150),
    [sym__plus_operator] = ACTIONS(13150),
    [sym__times_operator] = ACTIONS(13150),
    [sym__rational_operator] = ACTIONS(13150),
    [sym__bitshift_operator] = ACTIONS(13150),
    [sym__power_operator] = ACTIONS(13150),
    [sym__tilde_operator] = ACTIONS(13150),
    [sym__type_order_operator] = ACTIONS(13150),
    [sym__unary_operator] = ACTIONS(13150),
    [sym__unary_plus_operator] = ACTIONS(13150),
    [aux_sym__terminator_token1] = ACTIONS(13150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13148),
    [sym__command_start] = ACTIONS(13148),
  },
  [7248] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_elseif] = ACTIONS(12236),
    [anon_sym_else] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [7249] = {
    [ts_builtin_sym_end] = ACTIONS(12152),
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_RPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_RBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [7250] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_elseif] = ACTIONS(12240),
    [anon_sym_else] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [7251] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_elseif] = ACTIONS(12244),
    [anon_sym_else] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [7252] = {
    [aux_sym_open_tuple_repeat1] = STATE(7252),
    [ts_builtin_sym_end] = ACTIONS(13075),
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13196),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13070),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_RPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(13070),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_RBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13070),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(13070),
    [anon_sym_isa] = ACTIONS(13070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13070),
    [anon_sym_QMARK] = ACTIONS(13070),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(13070),
    [sym__arrow_operator] = ACTIONS(13070),
    [sym__lazy_or_operator] = ACTIONS(13070),
    [sym__lazy_and_operator] = ACTIONS(13070),
    [sym__comparison_operator] = ACTIONS(13070),
    [sym__pipe_right_operator] = ACTIONS(13070),
    [sym__pipe_left_operator] = ACTIONS(13070),
    [sym__ellipsis_operator] = ACTIONS(13070),
    [sym__plus_operator] = ACTIONS(13070),
    [sym__times_operator] = ACTIONS(13070),
    [sym__rational_operator] = ACTIONS(13070),
    [sym__bitshift_operator] = ACTIONS(13070),
    [sym__power_operator] = ACTIONS(13070),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(13070),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13070),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [7253] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_as] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [7254] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [7255] = {
    [aux_sym_open_tuple_repeat1] = STATE(7130),
    [sym__word_identifier] = ACTIONS(13150),
    [anon_sym_EQ] = ACTIONS(13150),
    [anon_sym_COMMA] = ACTIONS(12928),
    [anon_sym_COLON] = ACTIONS(13150),
    [anon_sym_begin] = ACTIONS(13150),
    [anon_sym_module] = ACTIONS(13150),
    [anon_sym_baremodule] = ACTIONS(13150),
    [anon_sym_end] = ACTIONS(13150),
    [anon_sym_abstract] = ACTIONS(13150),
    [anon_sym_primitive] = ACTIONS(13150),
    [anon_sym_mutable] = ACTIONS(13150),
    [anon_sym_struct] = ACTIONS(13150),
    [anon_sym_function] = ACTIONS(13150),
    [anon_sym_macro] = ACTIONS(13150),
    [anon_sym_where] = ACTIONS(13150),
    [anon_sym_quote] = ACTIONS(13150),
    [anon_sym_let] = ACTIONS(13150),
    [anon_sym_if] = ACTIONS(13150),
    [anon_sym_elseif] = ACTIONS(13150),
    [anon_sym_else] = ACTIONS(13150),
    [anon_sym_try] = ACTIONS(13150),
    [anon_sym_for] = ACTIONS(13150),
    [anon_sym_while] = ACTIONS(13150),
    [sym_break_statement] = ACTIONS(13150),
    [sym_continue_statement] = ACTIONS(13150),
    [anon_sym_return] = ACTIONS(13150),
    [anon_sym_const] = ACTIONS(13150),
    [anon_sym_global] = ACTIONS(13150),
    [anon_sym_local] = ACTIONS(13150),
    [anon_sym_LPAREN] = ACTIONS(13150),
    [anon_sym_COLON2] = ACTIONS(13150),
    [anon_sym_export] = ACTIONS(13150),
    [anon_sym_import] = ACTIONS(13150),
    [anon_sym_using] = ACTIONS(13150),
    [anon_sym_LBRACK] = ACTIONS(13150),
    [anon_sym_LF] = ACTIONS(13148),
    [anon_sym_in] = ACTIONS(13150),
    [anon_sym_LBRACE] = ACTIONS(13150),
    [anon_sym_DOLLAR] = ACTIONS(13150),
    [anon_sym_COLON_COLON] = ACTIONS(13150),
    [anon_sym_isa] = ACTIONS(13150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13150),
    [anon_sym_QMARK] = ACTIONS(13150),
    [anon_sym_AT] = ACTIONS(13150),
    [anon_sym_true] = ACTIONS(13150),
    [anon_sym_false] = ACTIONS(13150),
    [aux_sym_integer_literal_token1] = ACTIONS(13150),
    [aux_sym_integer_literal_token2] = ACTIONS(13150),
    [aux_sym_integer_literal_token3] = ACTIONS(13150),
    [aux_sym_integer_literal_token4] = ACTIONS(13150),
    [aux_sym_float_literal_token1] = ACTIONS(13150),
    [aux_sym_float_literal_token3] = ACTIONS(13150),
    [aux_sym_float_literal_token4] = ACTIONS(13150),
    [sym_character_literal] = ACTIONS(13150),
    [sym__pair_operator] = ACTIONS(13150),
    [sym__arrow_operator] = ACTIONS(13150),
    [sym__lazy_or_operator] = ACTIONS(13150),
    [sym__lazy_and_operator] = ACTIONS(13150),
    [sym__comparison_operator] = ACTIONS(13150),
    [sym__pipe_right_operator] = ACTIONS(13150),
    [sym__pipe_left_operator] = ACTIONS(13150),
    [sym__ellipsis_operator] = ACTIONS(13150),
    [sym__plus_operator] = ACTIONS(13150),
    [sym__times_operator] = ACTIONS(13150),
    [sym__rational_operator] = ACTIONS(13150),
    [sym__bitshift_operator] = ACTIONS(13150),
    [sym__power_operator] = ACTIONS(13150),
    [sym__tilde_operator] = ACTIONS(13150),
    [sym__type_order_operator] = ACTIONS(13150),
    [sym__unary_operator] = ACTIONS(13150),
    [sym__unary_plus_operator] = ACTIONS(13150),
    [aux_sym__terminator_token1] = ACTIONS(13150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13148),
    [sym__command_start] = ACTIONS(13148),
  },
  [7256] = {
    [aux_sym__import_list_repeat1] = STATE(7082),
    [sym__word_identifier] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_COLON] = ACTIONS(13066),
    [anon_sym_begin] = ACTIONS(13066),
    [anon_sym_module] = ACTIONS(13066),
    [anon_sym_baremodule] = ACTIONS(13066),
    [anon_sym_end] = ACTIONS(13066),
    [anon_sym_abstract] = ACTIONS(13066),
    [anon_sym_primitive] = ACTIONS(13066),
    [anon_sym_mutable] = ACTIONS(13066),
    [anon_sym_struct] = ACTIONS(13066),
    [anon_sym_function] = ACTIONS(13066),
    [anon_sym_macro] = ACTIONS(13066),
    [anon_sym_where] = ACTIONS(13066),
    [anon_sym_quote] = ACTIONS(13066),
    [anon_sym_let] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13066),
    [anon_sym_else] = ACTIONS(13066),
    [anon_sym_try] = ACTIONS(13066),
    [anon_sym_finally] = ACTIONS(13066),
    [anon_sym_for] = ACTIONS(13066),
    [anon_sym_while] = ACTIONS(13066),
    [sym_break_statement] = ACTIONS(13066),
    [sym_continue_statement] = ACTIONS(13066),
    [anon_sym_return] = ACTIONS(13066),
    [anon_sym_const] = ACTIONS(13066),
    [anon_sym_global] = ACTIONS(13066),
    [anon_sym_local] = ACTIONS(13066),
    [anon_sym_LPAREN] = ACTIONS(13066),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_export] = ACTIONS(13066),
    [anon_sym_import] = ACTIONS(13066),
    [anon_sym_using] = ACTIONS(13066),
    [anon_sym_LBRACK] = ACTIONS(13066),
    [anon_sym_LF] = ACTIONS(13068),
    [anon_sym_in] = ACTIONS(13066),
    [anon_sym_LBRACE] = ACTIONS(13066),
    [anon_sym_DOLLAR] = ACTIONS(13066),
    [anon_sym_COLON_COLON] = ACTIONS(13066),
    [anon_sym_isa] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13066),
    [anon_sym_QMARK] = ACTIONS(13066),
    [anon_sym_AT] = ACTIONS(13066),
    [anon_sym_true] = ACTIONS(13066),
    [anon_sym_false] = ACTIONS(13066),
    [aux_sym_integer_literal_token1] = ACTIONS(13066),
    [aux_sym_integer_literal_token2] = ACTIONS(13066),
    [aux_sym_integer_literal_token3] = ACTIONS(13066),
    [aux_sym_integer_literal_token4] = ACTIONS(13066),
    [aux_sym_float_literal_token1] = ACTIONS(13066),
    [aux_sym_float_literal_token3] = ACTIONS(13066),
    [aux_sym_float_literal_token4] = ACTIONS(13066),
    [sym_character_literal] = ACTIONS(13066),
    [sym__pair_operator] = ACTIONS(13066),
    [sym__arrow_operator] = ACTIONS(13066),
    [sym__lazy_or_operator] = ACTIONS(13066),
    [sym__lazy_and_operator] = ACTIONS(13066),
    [sym__comparison_operator] = ACTIONS(13066),
    [sym__pipe_right_operator] = ACTIONS(13066),
    [sym__pipe_left_operator] = ACTIONS(13066),
    [sym__ellipsis_operator] = ACTIONS(13066),
    [sym__plus_operator] = ACTIONS(13066),
    [sym__times_operator] = ACTIONS(13066),
    [sym__rational_operator] = ACTIONS(13066),
    [sym__bitshift_operator] = ACTIONS(13066),
    [sym__power_operator] = ACTIONS(13066),
    [sym__tilde_operator] = ACTIONS(13066),
    [sym__type_order_operator] = ACTIONS(13066),
    [sym__unary_operator] = ACTIONS(13066),
    [sym__unary_plus_operator] = ACTIONS(13066),
    [aux_sym__terminator_token1] = ACTIONS(13066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13068),
    [sym__command_start] = ACTIONS(13068),
  },
  [7257] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_else] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7258] = {
    [sym_identifier] = STATE(7758),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_catch] = ACTIONS(11992),
    [anon_sym_finally] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [7259] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_else] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7260] = {
    [sym_identifier] = STATE(7760),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_catch] = ACTIONS(11958),
    [anon_sym_finally] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [7261] = {
    [sym_identifier] = STATE(7766),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_catch] = ACTIONS(12002),
    [anon_sym_finally] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [7262] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_catch] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_as] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7263] = {
    [sym_identifier] = STATE(7767),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_catch] = ACTIONS(12006),
    [anon_sym_finally] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [7264] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_elseif] = ACTIONS(12248),
    [anon_sym_else] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [7265] = {
    [aux_sym_open_tuple_repeat1] = STATE(7068),
    [ts_builtin_sym_end] = ACTIONS(13199),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_RPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_RBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [7266] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_elseif] = ACTIONS(12252),
    [anon_sym_else] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [7267] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_elseif] = ACTIONS(12256),
    [anon_sym_else] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [7268] = {
    [aux_sym_open_tuple_repeat1] = STATE(7255),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(12928),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_elseif] = ACTIONS(13239),
    [anon_sym_else] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(12940),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7269] = {
    [aux_sym_open_tuple_repeat1] = STATE(7255),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(12928),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_elseif] = ACTIONS(13243),
    [anon_sym_else] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(12940),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7270] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_elseif] = ACTIONS(12260),
    [anon_sym_else] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [7271] = {
    [aux_sym_open_tuple_repeat1] = STATE(7255),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(12928),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_elseif] = ACTIONS(13201),
    [anon_sym_else] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(12940),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [7272] = {
    [aux_sym_open_tuple_repeat1] = STATE(7068),
    [ts_builtin_sym_end] = ACTIONS(13247),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_RPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_RBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7273] = {
    [aux_sym_open_tuple_repeat1] = STATE(7068),
    [ts_builtin_sym_end] = ACTIONS(13241),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_RPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_RBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7274] = {
    [aux_sym_open_tuple_repeat1] = STATE(7068),
    [ts_builtin_sym_end] = ACTIONS(13245),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_RPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_RBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7275] = {
    [aux_sym_open_tuple_repeat1] = STATE(7068),
    [ts_builtin_sym_end] = ACTIONS(12934),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_RPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_RBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7276] = {
    [aux_sym_open_tuple_repeat1] = STATE(7247),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(13194),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_else] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13108),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [7277] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_as] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [7278] = {
    [aux_sym_open_tuple_repeat1] = STATE(7247),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13194),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_else] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13108),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7279] = {
    [aux_sym_open_tuple_repeat1] = STATE(7247),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13194),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_else] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13108),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7280] = {
    [aux_sym_open_tuple_repeat1] = STATE(7247),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(13194),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_else] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13108),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7281] = {
    [aux_sym_open_tuple_repeat1] = STATE(7255),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(12928),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_elseif] = ACTIONS(13249),
    [anon_sym_else] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(12940),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7282] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [ts_builtin_sym_end] = ACTIONS(13253),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_RPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_RBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [7283] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [ts_builtin_sym_end] = ACTIONS(13100),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_RPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_RBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [7284] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_elseif] = ACTIONS(13255),
    [anon_sym_else] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(12940),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [7285] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_elseif] = ACTIONS(13094),
    [anon_sym_else] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(12940),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [7286] = {
    [aux_sym_open_tuple_repeat1] = STATE(7247),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13194),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_else] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13108),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7287] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_else] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_finally] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13108),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [7288] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_else] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [7289] = {
    [sym__word_identifier] = ACTIONS(13257),
    [anon_sym_EQ] = ACTIONS(13257),
    [anon_sym_COMMA] = ACTIONS(13257),
    [anon_sym_COLON] = ACTIONS(13257),
    [anon_sym_begin] = ACTIONS(13257),
    [anon_sym_module] = ACTIONS(13257),
    [anon_sym_baremodule] = ACTIONS(13257),
    [anon_sym_end] = ACTIONS(13257),
    [anon_sym_abstract] = ACTIONS(13257),
    [anon_sym_primitive] = ACTIONS(13257),
    [anon_sym_mutable] = ACTIONS(13257),
    [anon_sym_struct] = ACTIONS(13257),
    [anon_sym_function] = ACTIONS(13257),
    [anon_sym_macro] = ACTIONS(13257),
    [anon_sym_where] = ACTIONS(13257),
    [anon_sym_quote] = ACTIONS(13257),
    [anon_sym_let] = ACTIONS(13257),
    [anon_sym_if] = ACTIONS(13257),
    [anon_sym_elseif] = ACTIONS(13257),
    [anon_sym_else] = ACTIONS(13257),
    [anon_sym_try] = ACTIONS(13257),
    [anon_sym_for] = ACTIONS(13257),
    [anon_sym_while] = ACTIONS(13257),
    [sym_break_statement] = ACTIONS(13257),
    [sym_continue_statement] = ACTIONS(13257),
    [anon_sym_return] = ACTIONS(13257),
    [anon_sym_const] = ACTIONS(13257),
    [anon_sym_global] = ACTIONS(13257),
    [anon_sym_local] = ACTIONS(13257),
    [anon_sym_LPAREN] = ACTIONS(13257),
    [anon_sym_COLON2] = ACTIONS(13257),
    [anon_sym_export] = ACTIONS(13257),
    [anon_sym_import] = ACTIONS(13257),
    [anon_sym_using] = ACTIONS(13257),
    [anon_sym_LBRACK] = ACTIONS(13257),
    [anon_sym_LF] = ACTIONS(13259),
    [anon_sym_in] = ACTIONS(13257),
    [anon_sym_LBRACE] = ACTIONS(13257),
    [anon_sym_DOLLAR] = ACTIONS(13257),
    [anon_sym_COLON_COLON] = ACTIONS(13257),
    [anon_sym_isa] = ACTIONS(13257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13257),
    [anon_sym_QMARK] = ACTIONS(13257),
    [anon_sym_AT] = ACTIONS(13257),
    [anon_sym_true] = ACTIONS(13257),
    [anon_sym_false] = ACTIONS(13257),
    [aux_sym_integer_literal_token1] = ACTIONS(13257),
    [aux_sym_integer_literal_token2] = ACTIONS(13257),
    [aux_sym_integer_literal_token3] = ACTIONS(13257),
    [aux_sym_integer_literal_token4] = ACTIONS(13257),
    [aux_sym_float_literal_token1] = ACTIONS(13257),
    [aux_sym_float_literal_token3] = ACTIONS(13257),
    [aux_sym_float_literal_token4] = ACTIONS(13257),
    [sym_character_literal] = ACTIONS(13257),
    [sym__pair_operator] = ACTIONS(13257),
    [sym__arrow_operator] = ACTIONS(13257),
    [sym__lazy_or_operator] = ACTIONS(13257),
    [sym__lazy_and_operator] = ACTIONS(13257),
    [sym__comparison_operator] = ACTIONS(13257),
    [sym__pipe_right_operator] = ACTIONS(13257),
    [sym__pipe_left_operator] = ACTIONS(13257),
    [sym__ellipsis_operator] = ACTIONS(13257),
    [sym__plus_operator] = ACTIONS(13257),
    [sym__times_operator] = ACTIONS(13257),
    [sym__rational_operator] = ACTIONS(13257),
    [sym__bitshift_operator] = ACTIONS(13257),
    [sym__power_operator] = ACTIONS(13257),
    [sym__tilde_operator] = ACTIONS(13257),
    [sym__type_order_operator] = ACTIONS(13257),
    [sym__unary_operator] = ACTIONS(13257),
    [sym__unary_plus_operator] = ACTIONS(13257),
    [aux_sym__terminator_token1] = ACTIONS(13257),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13259),
    [sym__command_start] = ACTIONS(13259),
  },
  [7290] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [7291] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_end] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_finally] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_as] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [7292] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13166),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7293] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13261),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7294] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7295] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(12983),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7296] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_catch] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [7297] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12450),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7298] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [7299] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_catch] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7300] = {
    [sym_identifier] = STATE(8632),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_RPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_SEMI] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [7301] = {
    [sym_identifier] = STATE(8633),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_RPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_SEMI] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [7302] = {
    [sym_identifier] = STATE(8641),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_RPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_SEMI] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [7303] = {
    [sym_identifier] = STATE(8642),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_RPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_SEMI] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [7304] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7305] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [7306] = {
    [sym__comprehension_clause] = STATE(18271),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17127),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13265),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13270),
    [anon_sym_LF] = ACTIONS(13272),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13277),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7307] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_else] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_finally] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13282),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [7308] = {
    [sym__primary_expression] = STATE(11359),
    [sym__array] = STATE(11359),
    [sym_comprehension_expression] = STATE(11359),
    [sym_matrix_expression] = STATE(11359),
    [sym_vector_expression] = STATE(11359),
    [sym_parenthesized_expression] = STATE(11359),
    [sym_tuple_expression] = STATE(11359),
    [sym_curly_expression] = STATE(11359),
    [sym_adjoint_expression] = STATE(11359),
    [sym_field_expression] = STATE(11359),
    [sym_index_expression] = STATE(11359),
    [sym_parametrized_type_expression] = STATE(11359),
    [sym_call_expression] = STATE(11359),
    [sym_broadcast_call_expression] = STATE(11359),
    [sym__closed_macrocall_expression] = STATE(11359),
    [sym_interpolation_expression] = STATE(11359),
    [sym_quote_expression] = STATE(11359),
    [sym_macro_identifier] = STATE(17273),
    [sym_identifier] = STATE(10579),
    [sym_boolean_literal] = STATE(11359),
    [sym__string] = STATE(11359),
    [sym_string_literal] = STATE(11359),
    [sym_command_literal] = STATE(11359),
    [sym_prefixed_string_literal] = STATE(11359),
    [sym_prefixed_command_literal] = STATE(11359),
    [sym_operator] = STATE(18510),
    [sym__word_identifier] = ACTIONS(13284),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(13286),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(13288),
    [anon_sym_RPAREN] = ACTIONS(171),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(13290),
    [anon_sym_RBRACK] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(171),
    [anon_sym_LBRACE] = ACTIONS(13292),
    [anon_sym_RBRACE] = ACTIONS(171),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(13294),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(171),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_AT] = ACTIONS(13296),
    [anon_sym_true] = ACTIONS(13298),
    [anon_sym_false] = ACTIONS(13298),
    [sym_character_literal] = ACTIONS(13300),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(171),
    [sym__lazy_and_operator] = ACTIONS(171),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13302),
    [sym__command_start] = ACTIONS(13304),
  },
  [7309] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12418),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7310] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_else] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_finally] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13282),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [7311] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13308),
    [anon_sym_else] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7312] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13308),
    [anon_sym_else] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7313] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7314] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12470),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7315] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12562),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12570),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7316] = {
    [aux_sym_export_statement_repeat1] = STATE(7346),
    [sym__word_identifier] = ACTIONS(13144),
    [anon_sym_EQ] = ACTIONS(13144),
    [anon_sym_COMMA] = ACTIONS(13314),
    [anon_sym_COLON] = ACTIONS(13144),
    [anon_sym_begin] = ACTIONS(13144),
    [anon_sym_module] = ACTIONS(13144),
    [anon_sym_baremodule] = ACTIONS(13144),
    [anon_sym_abstract] = ACTIONS(13144),
    [anon_sym_primitive] = ACTIONS(13144),
    [anon_sym_mutable] = ACTIONS(13144),
    [anon_sym_struct] = ACTIONS(13144),
    [anon_sym_function] = ACTIONS(13144),
    [anon_sym_macro] = ACTIONS(13144),
    [anon_sym_where] = ACTIONS(13144),
    [anon_sym_quote] = ACTIONS(13144),
    [anon_sym_let] = ACTIONS(13144),
    [anon_sym_if] = ACTIONS(13144),
    [anon_sym_try] = ACTIONS(13144),
    [anon_sym_catch] = ACTIONS(13144),
    [anon_sym_finally] = ACTIONS(13144),
    [anon_sym_for] = ACTIONS(13144),
    [anon_sym_while] = ACTIONS(13144),
    [sym_break_statement] = ACTIONS(13144),
    [sym_continue_statement] = ACTIONS(13144),
    [anon_sym_return] = ACTIONS(13144),
    [anon_sym_const] = ACTIONS(13144),
    [anon_sym_global] = ACTIONS(13144),
    [anon_sym_local] = ACTIONS(13144),
    [anon_sym_LPAREN] = ACTIONS(13144),
    [anon_sym_COLON2] = ACTIONS(13144),
    [anon_sym_export] = ACTIONS(13144),
    [anon_sym_import] = ACTIONS(13144),
    [anon_sym_using] = ACTIONS(13144),
    [anon_sym_LBRACK] = ACTIONS(13144),
    [anon_sym_LF] = ACTIONS(13146),
    [anon_sym_in] = ACTIONS(13144),
    [anon_sym_LBRACE] = ACTIONS(13144),
    [anon_sym_DOLLAR] = ACTIONS(13144),
    [anon_sym_COLON_COLON] = ACTIONS(13144),
    [anon_sym_isa] = ACTIONS(13144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13144),
    [anon_sym_QMARK] = ACTIONS(13144),
    [anon_sym_AT] = ACTIONS(13144),
    [anon_sym_true] = ACTIONS(13144),
    [anon_sym_false] = ACTIONS(13144),
    [aux_sym_integer_literal_token1] = ACTIONS(13144),
    [aux_sym_integer_literal_token2] = ACTIONS(13144),
    [aux_sym_integer_literal_token3] = ACTIONS(13144),
    [aux_sym_integer_literal_token4] = ACTIONS(13144),
    [aux_sym_float_literal_token1] = ACTIONS(13144),
    [aux_sym_float_literal_token3] = ACTIONS(13144),
    [aux_sym_float_literal_token4] = ACTIONS(13144),
    [sym_character_literal] = ACTIONS(13144),
    [sym__pair_operator] = ACTIONS(13144),
    [sym__arrow_operator] = ACTIONS(13144),
    [sym__lazy_or_operator] = ACTIONS(13144),
    [sym__lazy_and_operator] = ACTIONS(13144),
    [sym__comparison_operator] = ACTIONS(13144),
    [sym__pipe_right_operator] = ACTIONS(13144),
    [sym__pipe_left_operator] = ACTIONS(13144),
    [sym__ellipsis_operator] = ACTIONS(13144),
    [sym__plus_operator] = ACTIONS(13144),
    [sym__times_operator] = ACTIONS(13144),
    [sym__rational_operator] = ACTIONS(13144),
    [sym__bitshift_operator] = ACTIONS(13144),
    [sym__power_operator] = ACTIONS(13144),
    [sym__tilde_operator] = ACTIONS(13144),
    [sym__type_order_operator] = ACTIONS(13144),
    [sym__unary_operator] = ACTIONS(13144),
    [sym__unary_plus_operator] = ACTIONS(13144),
    [aux_sym__terminator_token1] = ACTIONS(13144),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13146),
    [sym__command_start] = ACTIONS(13146),
  },
  [7317] = {
    [aux_sym__import_list_repeat1] = STATE(7348),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13012),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_catch] = ACTIONS(12862),
    [anon_sym_finally] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7318] = {
    [sym__word_identifier] = ACTIONS(13316),
    [anon_sym_EQ] = ACTIONS(13316),
    [anon_sym_COMMA] = ACTIONS(13316),
    [anon_sym_COLON] = ACTIONS(13316),
    [anon_sym_begin] = ACTIONS(13316),
    [anon_sym_module] = ACTIONS(13316),
    [anon_sym_baremodule] = ACTIONS(13316),
    [anon_sym_end] = ACTIONS(13316),
    [anon_sym_abstract] = ACTIONS(13316),
    [anon_sym_primitive] = ACTIONS(13316),
    [anon_sym_mutable] = ACTIONS(13316),
    [anon_sym_struct] = ACTIONS(13316),
    [anon_sym_function] = ACTIONS(13316),
    [anon_sym_macro] = ACTIONS(13316),
    [anon_sym_where] = ACTIONS(13316),
    [anon_sym_quote] = ACTIONS(13316),
    [anon_sym_let] = ACTIONS(13316),
    [anon_sym_if] = ACTIONS(13316),
    [anon_sym_elseif] = ACTIONS(13316),
    [anon_sym_else] = ACTIONS(13316),
    [anon_sym_try] = ACTIONS(13316),
    [anon_sym_for] = ACTIONS(13316),
    [anon_sym_while] = ACTIONS(13316),
    [sym_break_statement] = ACTIONS(13316),
    [sym_continue_statement] = ACTIONS(13316),
    [anon_sym_return] = ACTIONS(13316),
    [anon_sym_const] = ACTIONS(13316),
    [anon_sym_global] = ACTIONS(13316),
    [anon_sym_local] = ACTIONS(13316),
    [anon_sym_LPAREN] = ACTIONS(13316),
    [anon_sym_COLON2] = ACTIONS(13316),
    [anon_sym_export] = ACTIONS(13316),
    [anon_sym_import] = ACTIONS(13316),
    [anon_sym_using] = ACTIONS(13316),
    [anon_sym_LBRACK] = ACTIONS(13316),
    [anon_sym_LF] = ACTIONS(13318),
    [anon_sym_in] = ACTIONS(13316),
    [anon_sym_LBRACE] = ACTIONS(13316),
    [anon_sym_DOLLAR] = ACTIONS(13316),
    [anon_sym_COLON_COLON] = ACTIONS(13316),
    [anon_sym_isa] = ACTIONS(13316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13316),
    [anon_sym_QMARK] = ACTIONS(13316),
    [anon_sym_AT] = ACTIONS(13316),
    [anon_sym_true] = ACTIONS(13316),
    [anon_sym_false] = ACTIONS(13316),
    [aux_sym_integer_literal_token1] = ACTIONS(13316),
    [aux_sym_integer_literal_token2] = ACTIONS(13316),
    [aux_sym_integer_literal_token3] = ACTIONS(13316),
    [aux_sym_integer_literal_token4] = ACTIONS(13316),
    [aux_sym_float_literal_token1] = ACTIONS(13316),
    [aux_sym_float_literal_token3] = ACTIONS(13316),
    [aux_sym_float_literal_token4] = ACTIONS(13316),
    [sym_character_literal] = ACTIONS(13316),
    [sym__pair_operator] = ACTIONS(13316),
    [sym__arrow_operator] = ACTIONS(13316),
    [sym__lazy_or_operator] = ACTIONS(13316),
    [sym__lazy_and_operator] = ACTIONS(13316),
    [sym__comparison_operator] = ACTIONS(13316),
    [sym__pipe_right_operator] = ACTIONS(13316),
    [sym__pipe_left_operator] = ACTIONS(13316),
    [sym__ellipsis_operator] = ACTIONS(13316),
    [sym__plus_operator] = ACTIONS(13316),
    [sym__times_operator] = ACTIONS(13316),
    [sym__rational_operator] = ACTIONS(13316),
    [sym__bitshift_operator] = ACTIONS(13316),
    [sym__power_operator] = ACTIONS(13316),
    [sym__tilde_operator] = ACTIONS(13316),
    [sym__type_order_operator] = ACTIONS(13316),
    [sym__unary_operator] = ACTIONS(13316),
    [sym__unary_plus_operator] = ACTIONS(13316),
    [aux_sym__terminator_token1] = ACTIONS(13316),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13318),
    [sym__command_start] = ACTIONS(13318),
  },
  [7319] = {
    [sym__word_identifier] = ACTIONS(13320),
    [anon_sym_EQ] = ACTIONS(13320),
    [anon_sym_COMMA] = ACTIONS(13320),
    [anon_sym_COLON] = ACTIONS(13320),
    [anon_sym_begin] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(13320),
    [anon_sym_baremodule] = ACTIONS(13320),
    [anon_sym_end] = ACTIONS(13320),
    [anon_sym_abstract] = ACTIONS(13320),
    [anon_sym_primitive] = ACTIONS(13320),
    [anon_sym_mutable] = ACTIONS(13320),
    [anon_sym_struct] = ACTIONS(13320),
    [anon_sym_function] = ACTIONS(13320),
    [anon_sym_macro] = ACTIONS(13320),
    [anon_sym_where] = ACTIONS(13320),
    [anon_sym_quote] = ACTIONS(13320),
    [anon_sym_let] = ACTIONS(13320),
    [anon_sym_if] = ACTIONS(13320),
    [anon_sym_elseif] = ACTIONS(13320),
    [anon_sym_else] = ACTIONS(13320),
    [anon_sym_try] = ACTIONS(13320),
    [anon_sym_for] = ACTIONS(13320),
    [anon_sym_while] = ACTIONS(13320),
    [sym_break_statement] = ACTIONS(13320),
    [sym_continue_statement] = ACTIONS(13320),
    [anon_sym_return] = ACTIONS(13320),
    [anon_sym_const] = ACTIONS(13320),
    [anon_sym_global] = ACTIONS(13320),
    [anon_sym_local] = ACTIONS(13320),
    [anon_sym_LPAREN] = ACTIONS(13320),
    [anon_sym_COLON2] = ACTIONS(13320),
    [anon_sym_export] = ACTIONS(13320),
    [anon_sym_import] = ACTIONS(13320),
    [anon_sym_using] = ACTIONS(13320),
    [anon_sym_LBRACK] = ACTIONS(13320),
    [anon_sym_LF] = ACTIONS(13322),
    [anon_sym_in] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(13320),
    [anon_sym_DOLLAR] = ACTIONS(13320),
    [anon_sym_COLON_COLON] = ACTIONS(13320),
    [anon_sym_isa] = ACTIONS(13320),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13320),
    [anon_sym_QMARK] = ACTIONS(13320),
    [anon_sym_AT] = ACTIONS(13320),
    [anon_sym_true] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(13320),
    [aux_sym_integer_literal_token1] = ACTIONS(13320),
    [aux_sym_integer_literal_token2] = ACTIONS(13320),
    [aux_sym_integer_literal_token3] = ACTIONS(13320),
    [aux_sym_integer_literal_token4] = ACTIONS(13320),
    [aux_sym_float_literal_token1] = ACTIONS(13320),
    [aux_sym_float_literal_token3] = ACTIONS(13320),
    [aux_sym_float_literal_token4] = ACTIONS(13320),
    [sym_character_literal] = ACTIONS(13320),
    [sym__pair_operator] = ACTIONS(13320),
    [sym__arrow_operator] = ACTIONS(13320),
    [sym__lazy_or_operator] = ACTIONS(13320),
    [sym__lazy_and_operator] = ACTIONS(13320),
    [sym__comparison_operator] = ACTIONS(13320),
    [sym__pipe_right_operator] = ACTIONS(13320),
    [sym__pipe_left_operator] = ACTIONS(13320),
    [sym__ellipsis_operator] = ACTIONS(13320),
    [sym__plus_operator] = ACTIONS(13320),
    [sym__times_operator] = ACTIONS(13320),
    [sym__rational_operator] = ACTIONS(13320),
    [sym__bitshift_operator] = ACTIONS(13320),
    [sym__power_operator] = ACTIONS(13320),
    [sym__tilde_operator] = ACTIONS(13320),
    [sym__type_order_operator] = ACTIONS(13320),
    [sym__unary_operator] = ACTIONS(13320),
    [sym__unary_plus_operator] = ACTIONS(13320),
    [aux_sym__terminator_token1] = ACTIONS(13320),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13322),
    [sym__command_start] = ACTIONS(13322),
  },
  [7320] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_elseif] = ACTIONS(13239),
    [anon_sym_else] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7321] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(12220),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_elseif] = ACTIONS(13239),
    [anon_sym_else] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7322] = {
    [aux_sym_open_tuple_repeat1] = STATE(7255),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(12928),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_elseif] = ACTIONS(13239),
    [anon_sym_else] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13324),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7323] = {
    [sym__word_identifier] = ACTIONS(13326),
    [anon_sym_EQ] = ACTIONS(13326),
    [anon_sym_COMMA] = ACTIONS(13326),
    [anon_sym_COLON] = ACTIONS(13326),
    [anon_sym_begin] = ACTIONS(13326),
    [anon_sym_module] = ACTIONS(13326),
    [anon_sym_baremodule] = ACTIONS(13326),
    [anon_sym_end] = ACTIONS(13326),
    [anon_sym_abstract] = ACTIONS(13326),
    [anon_sym_primitive] = ACTIONS(13326),
    [anon_sym_mutable] = ACTIONS(13326),
    [anon_sym_struct] = ACTIONS(13326),
    [anon_sym_function] = ACTIONS(13326),
    [anon_sym_macro] = ACTIONS(13326),
    [anon_sym_where] = ACTIONS(13326),
    [anon_sym_quote] = ACTIONS(13326),
    [anon_sym_let] = ACTIONS(13326),
    [anon_sym_if] = ACTIONS(13326),
    [anon_sym_elseif] = ACTIONS(13326),
    [anon_sym_else] = ACTIONS(13326),
    [anon_sym_try] = ACTIONS(13326),
    [anon_sym_for] = ACTIONS(13326),
    [anon_sym_while] = ACTIONS(13326),
    [sym_break_statement] = ACTIONS(13326),
    [sym_continue_statement] = ACTIONS(13326),
    [anon_sym_return] = ACTIONS(13326),
    [anon_sym_const] = ACTIONS(13326),
    [anon_sym_global] = ACTIONS(13326),
    [anon_sym_local] = ACTIONS(13326),
    [anon_sym_LPAREN] = ACTIONS(13326),
    [anon_sym_COLON2] = ACTIONS(13326),
    [anon_sym_export] = ACTIONS(13326),
    [anon_sym_import] = ACTIONS(13326),
    [anon_sym_using] = ACTIONS(13326),
    [anon_sym_LBRACK] = ACTIONS(13326),
    [anon_sym_LF] = ACTIONS(13328),
    [anon_sym_in] = ACTIONS(13326),
    [anon_sym_LBRACE] = ACTIONS(13326),
    [anon_sym_DOLLAR] = ACTIONS(13326),
    [anon_sym_COLON_COLON] = ACTIONS(13326),
    [anon_sym_isa] = ACTIONS(13326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13326),
    [anon_sym_QMARK] = ACTIONS(13326),
    [anon_sym_AT] = ACTIONS(13326),
    [anon_sym_true] = ACTIONS(13326),
    [anon_sym_false] = ACTIONS(13326),
    [aux_sym_integer_literal_token1] = ACTIONS(13326),
    [aux_sym_integer_literal_token2] = ACTIONS(13326),
    [aux_sym_integer_literal_token3] = ACTIONS(13326),
    [aux_sym_integer_literal_token4] = ACTIONS(13326),
    [aux_sym_float_literal_token1] = ACTIONS(13326),
    [aux_sym_float_literal_token3] = ACTIONS(13326),
    [aux_sym_float_literal_token4] = ACTIONS(13326),
    [sym_character_literal] = ACTIONS(13326),
    [sym__pair_operator] = ACTIONS(13326),
    [sym__arrow_operator] = ACTIONS(13326),
    [sym__lazy_or_operator] = ACTIONS(13326),
    [sym__lazy_and_operator] = ACTIONS(13326),
    [sym__comparison_operator] = ACTIONS(13326),
    [sym__pipe_right_operator] = ACTIONS(13326),
    [sym__pipe_left_operator] = ACTIONS(13326),
    [sym__ellipsis_operator] = ACTIONS(13326),
    [sym__plus_operator] = ACTIONS(13326),
    [sym__times_operator] = ACTIONS(13326),
    [sym__rational_operator] = ACTIONS(13326),
    [sym__bitshift_operator] = ACTIONS(13326),
    [sym__power_operator] = ACTIONS(13326),
    [sym__tilde_operator] = ACTIONS(13326),
    [sym__type_order_operator] = ACTIONS(13326),
    [sym__unary_operator] = ACTIONS(13326),
    [sym__unary_plus_operator] = ACTIONS(13326),
    [aux_sym__terminator_token1] = ACTIONS(13326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13328),
    [sym__command_start] = ACTIONS(13328),
  },
  [7324] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_elseif] = ACTIONS(13243),
    [anon_sym_else] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7325] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12620),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12620),
    [anon_sym_RPAREN] = ACTIONS(12620),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12620),
    [anon_sym_RBRACK] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_SEMI] = ACTIONS(12620),
    [anon_sym_LBRACE] = ACTIONS(12620),
    [anon_sym_RBRACE] = ACTIONS(12620),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12620),
    [anon_sym_COLON_COLON] = ACTIONS(12620),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12620),
    [anon_sym_QMARK] = ACTIONS(12620),
    [anon_sym_AT] = ACTIONS(12620),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12620),
    [aux_sym_integer_literal_token2] = ACTIONS(12620),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12620),
    [aux_sym_float_literal_token3] = ACTIONS(12620),
    [aux_sym_float_literal_token4] = ACTIONS(12620),
    [sym_character_literal] = ACTIONS(12620),
    [sym__pair_operator] = ACTIONS(12620),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12620),
    [sym__lazy_and_operator] = ACTIONS(12620),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12620),
    [sym__pipe_left_operator] = ACTIONS(12620),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12620),
    [sym__bitshift_operator] = ACTIONS(12620),
    [sym__power_operator] = ACTIONS(12620),
    [sym__tilde_operator] = ACTIONS(12620),
    [sym__type_order_operator] = ACTIONS(12620),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7326] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(12220),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_elseif] = ACTIONS(13243),
    [anon_sym_else] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7327] = {
    [aux_sym_open_tuple_repeat1] = STATE(7255),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(12928),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_elseif] = ACTIONS(13243),
    [anon_sym_else] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13324),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7328] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_elseif] = ACTIONS(12926),
    [anon_sym_else] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7329] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12220),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_elseif] = ACTIONS(12926),
    [anon_sym_else] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7330] = {
    [aux_sym_open_tuple_repeat1] = STATE(7255),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(12928),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_elseif] = ACTIONS(12926),
    [anon_sym_else] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13324),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7331] = {
    [sym__word_identifier] = ACTIONS(13330),
    [anon_sym_EQ] = ACTIONS(13330),
    [anon_sym_COMMA] = ACTIONS(13330),
    [anon_sym_COLON] = ACTIONS(13330),
    [anon_sym_begin] = ACTIONS(13330),
    [anon_sym_module] = ACTIONS(13330),
    [anon_sym_baremodule] = ACTIONS(13330),
    [anon_sym_end] = ACTIONS(13330),
    [anon_sym_abstract] = ACTIONS(13330),
    [anon_sym_primitive] = ACTIONS(13330),
    [anon_sym_mutable] = ACTIONS(13330),
    [anon_sym_struct] = ACTIONS(13330),
    [anon_sym_function] = ACTIONS(13330),
    [anon_sym_macro] = ACTIONS(13330),
    [anon_sym_where] = ACTIONS(13330),
    [anon_sym_quote] = ACTIONS(13330),
    [anon_sym_let] = ACTIONS(13330),
    [anon_sym_if] = ACTIONS(13330),
    [anon_sym_elseif] = ACTIONS(13330),
    [anon_sym_else] = ACTIONS(13330),
    [anon_sym_try] = ACTIONS(13330),
    [anon_sym_for] = ACTIONS(13330),
    [anon_sym_while] = ACTIONS(13330),
    [sym_break_statement] = ACTIONS(13330),
    [sym_continue_statement] = ACTIONS(13330),
    [anon_sym_return] = ACTIONS(13330),
    [anon_sym_const] = ACTIONS(13330),
    [anon_sym_global] = ACTIONS(13330),
    [anon_sym_local] = ACTIONS(13330),
    [anon_sym_LPAREN] = ACTIONS(13330),
    [anon_sym_COLON2] = ACTIONS(13330),
    [anon_sym_export] = ACTIONS(13330),
    [anon_sym_import] = ACTIONS(13330),
    [anon_sym_using] = ACTIONS(13330),
    [anon_sym_LBRACK] = ACTIONS(13330),
    [anon_sym_LF] = ACTIONS(13332),
    [anon_sym_in] = ACTIONS(13330),
    [anon_sym_LBRACE] = ACTIONS(13330),
    [anon_sym_DOLLAR] = ACTIONS(13330),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_isa] = ACTIONS(13330),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13330),
    [anon_sym_QMARK] = ACTIONS(13330),
    [anon_sym_AT] = ACTIONS(13330),
    [anon_sym_true] = ACTIONS(13330),
    [anon_sym_false] = ACTIONS(13330),
    [aux_sym_integer_literal_token1] = ACTIONS(13330),
    [aux_sym_integer_literal_token2] = ACTIONS(13330),
    [aux_sym_integer_literal_token3] = ACTIONS(13330),
    [aux_sym_integer_literal_token4] = ACTIONS(13330),
    [aux_sym_float_literal_token1] = ACTIONS(13330),
    [aux_sym_float_literal_token3] = ACTIONS(13330),
    [aux_sym_float_literal_token4] = ACTIONS(13330),
    [sym_character_literal] = ACTIONS(13330),
    [sym__pair_operator] = ACTIONS(13330),
    [sym__arrow_operator] = ACTIONS(13330),
    [sym__lazy_or_operator] = ACTIONS(13330),
    [sym__lazy_and_operator] = ACTIONS(13330),
    [sym__comparison_operator] = ACTIONS(13330),
    [sym__pipe_right_operator] = ACTIONS(13330),
    [sym__pipe_left_operator] = ACTIONS(13330),
    [sym__ellipsis_operator] = ACTIONS(13330),
    [sym__plus_operator] = ACTIONS(13330),
    [sym__times_operator] = ACTIONS(13330),
    [sym__rational_operator] = ACTIONS(13330),
    [sym__bitshift_operator] = ACTIONS(13330),
    [sym__power_operator] = ACTIONS(13330),
    [sym__tilde_operator] = ACTIONS(13330),
    [sym__type_order_operator] = ACTIONS(13330),
    [sym__unary_operator] = ACTIONS(13330),
    [sym__unary_plus_operator] = ACTIONS(13330),
    [aux_sym__terminator_token1] = ACTIONS(13330),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13332),
    [sym__command_start] = ACTIONS(13332),
  },
  [7332] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_EQ] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_elseif] = ACTIONS(13334),
    [anon_sym_else] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [7333] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7334] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(12940),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7335] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7336] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7337] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7338] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7339] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7340] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_EQ] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_elseif] = ACTIONS(13338),
    [anon_sym_else] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(12940),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [7341] = {
    [ts_builtin_sym_end] = ACTIONS(13241),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13342),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_RPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_RBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7342] = {
    [ts_builtin_sym_end] = ACTIONS(13245),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13342),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_RPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_RBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7343] = {
    [ts_builtin_sym_end] = ACTIONS(12934),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(13342),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_RPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_RBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7344] = {
    [ts_builtin_sym_end] = ACTIONS(13247),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13342),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_RPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_RBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7345] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12470),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7346] = {
    [aux_sym_export_statement_repeat1] = STATE(7355),
    [sym__word_identifier] = ACTIONS(13060),
    [anon_sym_EQ] = ACTIONS(13060),
    [anon_sym_COMMA] = ACTIONS(13314),
    [anon_sym_COLON] = ACTIONS(13060),
    [anon_sym_begin] = ACTIONS(13060),
    [anon_sym_module] = ACTIONS(13060),
    [anon_sym_baremodule] = ACTIONS(13060),
    [anon_sym_abstract] = ACTIONS(13060),
    [anon_sym_primitive] = ACTIONS(13060),
    [anon_sym_mutable] = ACTIONS(13060),
    [anon_sym_struct] = ACTIONS(13060),
    [anon_sym_function] = ACTIONS(13060),
    [anon_sym_macro] = ACTIONS(13060),
    [anon_sym_where] = ACTIONS(13060),
    [anon_sym_quote] = ACTIONS(13060),
    [anon_sym_let] = ACTIONS(13060),
    [anon_sym_if] = ACTIONS(13060),
    [anon_sym_try] = ACTIONS(13060),
    [anon_sym_catch] = ACTIONS(13060),
    [anon_sym_finally] = ACTIONS(13060),
    [anon_sym_for] = ACTIONS(13060),
    [anon_sym_while] = ACTIONS(13060),
    [sym_break_statement] = ACTIONS(13060),
    [sym_continue_statement] = ACTIONS(13060),
    [anon_sym_return] = ACTIONS(13060),
    [anon_sym_const] = ACTIONS(13060),
    [anon_sym_global] = ACTIONS(13060),
    [anon_sym_local] = ACTIONS(13060),
    [anon_sym_LPAREN] = ACTIONS(13060),
    [anon_sym_COLON2] = ACTIONS(13060),
    [anon_sym_export] = ACTIONS(13060),
    [anon_sym_import] = ACTIONS(13060),
    [anon_sym_using] = ACTIONS(13060),
    [anon_sym_LBRACK] = ACTIONS(13060),
    [anon_sym_LF] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13060),
    [anon_sym_LBRACE] = ACTIONS(13060),
    [anon_sym_DOLLAR] = ACTIONS(13060),
    [anon_sym_COLON_COLON] = ACTIONS(13060),
    [anon_sym_isa] = ACTIONS(13060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13060),
    [anon_sym_QMARK] = ACTIONS(13060),
    [anon_sym_AT] = ACTIONS(13060),
    [anon_sym_true] = ACTIONS(13060),
    [anon_sym_false] = ACTIONS(13060),
    [aux_sym_integer_literal_token1] = ACTIONS(13060),
    [aux_sym_integer_literal_token2] = ACTIONS(13060),
    [aux_sym_integer_literal_token3] = ACTIONS(13060),
    [aux_sym_integer_literal_token4] = ACTIONS(13060),
    [aux_sym_float_literal_token1] = ACTIONS(13060),
    [aux_sym_float_literal_token3] = ACTIONS(13060),
    [aux_sym_float_literal_token4] = ACTIONS(13060),
    [sym_character_literal] = ACTIONS(13060),
    [sym__pair_operator] = ACTIONS(13060),
    [sym__arrow_operator] = ACTIONS(13060),
    [sym__lazy_or_operator] = ACTIONS(13060),
    [sym__lazy_and_operator] = ACTIONS(13060),
    [sym__comparison_operator] = ACTIONS(13060),
    [sym__pipe_right_operator] = ACTIONS(13060),
    [sym__pipe_left_operator] = ACTIONS(13060),
    [sym__ellipsis_operator] = ACTIONS(13060),
    [sym__plus_operator] = ACTIONS(13060),
    [sym__times_operator] = ACTIONS(13060),
    [sym__rational_operator] = ACTIONS(13060),
    [sym__bitshift_operator] = ACTIONS(13060),
    [sym__power_operator] = ACTIONS(13060),
    [sym__tilde_operator] = ACTIONS(13060),
    [sym__type_order_operator] = ACTIONS(13060),
    [sym__unary_operator] = ACTIONS(13060),
    [sym__unary_plus_operator] = ACTIONS(13060),
    [aux_sym__terminator_token1] = ACTIONS(13060),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13064),
    [sym__command_start] = ACTIONS(13064),
  },
  [7347] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [7348] = {
    [aux_sym__import_list_repeat1] = STATE(7357),
    [sym__word_identifier] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13012),
    [anon_sym_COLON] = ACTIONS(13066),
    [anon_sym_begin] = ACTIONS(13066),
    [anon_sym_module] = ACTIONS(13066),
    [anon_sym_baremodule] = ACTIONS(13066),
    [anon_sym_abstract] = ACTIONS(13066),
    [anon_sym_primitive] = ACTIONS(13066),
    [anon_sym_mutable] = ACTIONS(13066),
    [anon_sym_struct] = ACTIONS(13066),
    [anon_sym_function] = ACTIONS(13066),
    [anon_sym_macro] = ACTIONS(13066),
    [anon_sym_where] = ACTIONS(13066),
    [anon_sym_quote] = ACTIONS(13066),
    [anon_sym_let] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13066),
    [anon_sym_try] = ACTIONS(13066),
    [anon_sym_catch] = ACTIONS(13066),
    [anon_sym_finally] = ACTIONS(13066),
    [anon_sym_for] = ACTIONS(13066),
    [anon_sym_while] = ACTIONS(13066),
    [sym_break_statement] = ACTIONS(13066),
    [sym_continue_statement] = ACTIONS(13066),
    [anon_sym_return] = ACTIONS(13066),
    [anon_sym_const] = ACTIONS(13066),
    [anon_sym_global] = ACTIONS(13066),
    [anon_sym_local] = ACTIONS(13066),
    [anon_sym_LPAREN] = ACTIONS(13066),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_export] = ACTIONS(13066),
    [anon_sym_import] = ACTIONS(13066),
    [anon_sym_using] = ACTIONS(13066),
    [anon_sym_LBRACK] = ACTIONS(13066),
    [anon_sym_LF] = ACTIONS(13068),
    [anon_sym_in] = ACTIONS(13066),
    [anon_sym_LBRACE] = ACTIONS(13066),
    [anon_sym_DOLLAR] = ACTIONS(13066),
    [anon_sym_COLON_COLON] = ACTIONS(13066),
    [anon_sym_isa] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13066),
    [anon_sym_QMARK] = ACTIONS(13066),
    [anon_sym_AT] = ACTIONS(13066),
    [anon_sym_true] = ACTIONS(13066),
    [anon_sym_false] = ACTIONS(13066),
    [aux_sym_integer_literal_token1] = ACTIONS(13066),
    [aux_sym_integer_literal_token2] = ACTIONS(13066),
    [aux_sym_integer_literal_token3] = ACTIONS(13066),
    [aux_sym_integer_literal_token4] = ACTIONS(13066),
    [aux_sym_float_literal_token1] = ACTIONS(13066),
    [aux_sym_float_literal_token3] = ACTIONS(13066),
    [aux_sym_float_literal_token4] = ACTIONS(13066),
    [sym_character_literal] = ACTIONS(13066),
    [sym__pair_operator] = ACTIONS(13066),
    [sym__arrow_operator] = ACTIONS(13066),
    [sym__lazy_or_operator] = ACTIONS(13066),
    [sym__lazy_and_operator] = ACTIONS(13066),
    [sym__comparison_operator] = ACTIONS(13066),
    [sym__pipe_right_operator] = ACTIONS(13066),
    [sym__pipe_left_operator] = ACTIONS(13066),
    [sym__ellipsis_operator] = ACTIONS(13066),
    [sym__plus_operator] = ACTIONS(13066),
    [sym__times_operator] = ACTIONS(13066),
    [sym__rational_operator] = ACTIONS(13066),
    [sym__bitshift_operator] = ACTIONS(13066),
    [sym__power_operator] = ACTIONS(13066),
    [sym__tilde_operator] = ACTIONS(13066),
    [sym__type_order_operator] = ACTIONS(13066),
    [sym__unary_operator] = ACTIONS(13066),
    [sym__unary_plus_operator] = ACTIONS(13066),
    [aux_sym__terminator_token1] = ACTIONS(13066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13068),
    [sym__command_start] = ACTIONS(13068),
  },
  [7349] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7350] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(13344),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7351] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(12450),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_else] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7352] = {
    [ts_builtin_sym_end] = ACTIONS(13340),
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_EQ] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_RPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_RBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [7353] = {
    [sym__word_identifier] = ACTIONS(13346),
    [anon_sym_EQ] = ACTIONS(13346),
    [anon_sym_COMMA] = ACTIONS(13346),
    [anon_sym_COLON] = ACTIONS(13346),
    [anon_sym_begin] = ACTIONS(13346),
    [anon_sym_module] = ACTIONS(13346),
    [anon_sym_baremodule] = ACTIONS(13346),
    [anon_sym_end] = ACTIONS(13346),
    [anon_sym_abstract] = ACTIONS(13346),
    [anon_sym_primitive] = ACTIONS(13346),
    [anon_sym_mutable] = ACTIONS(13346),
    [anon_sym_struct] = ACTIONS(13346),
    [anon_sym_function] = ACTIONS(13346),
    [anon_sym_macro] = ACTIONS(13346),
    [anon_sym_where] = ACTIONS(13346),
    [anon_sym_quote] = ACTIONS(13346),
    [anon_sym_let] = ACTIONS(13346),
    [anon_sym_if] = ACTIONS(13346),
    [anon_sym_elseif] = ACTIONS(13346),
    [anon_sym_else] = ACTIONS(13346),
    [anon_sym_try] = ACTIONS(13346),
    [anon_sym_for] = ACTIONS(13346),
    [anon_sym_while] = ACTIONS(13346),
    [sym_break_statement] = ACTIONS(13346),
    [sym_continue_statement] = ACTIONS(13346),
    [anon_sym_return] = ACTIONS(13346),
    [anon_sym_const] = ACTIONS(13346),
    [anon_sym_global] = ACTIONS(13346),
    [anon_sym_local] = ACTIONS(13346),
    [anon_sym_LPAREN] = ACTIONS(13346),
    [anon_sym_COLON2] = ACTIONS(13346),
    [anon_sym_export] = ACTIONS(13346),
    [anon_sym_import] = ACTIONS(13346),
    [anon_sym_using] = ACTIONS(13346),
    [anon_sym_LBRACK] = ACTIONS(13346),
    [anon_sym_LF] = ACTIONS(13348),
    [anon_sym_in] = ACTIONS(13346),
    [anon_sym_LBRACE] = ACTIONS(13346),
    [anon_sym_DOLLAR] = ACTIONS(13346),
    [anon_sym_COLON_COLON] = ACTIONS(13346),
    [anon_sym_isa] = ACTIONS(13346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13346),
    [anon_sym_QMARK] = ACTIONS(13346),
    [anon_sym_AT] = ACTIONS(13346),
    [anon_sym_true] = ACTIONS(13346),
    [anon_sym_false] = ACTIONS(13346),
    [aux_sym_integer_literal_token1] = ACTIONS(13346),
    [aux_sym_integer_literal_token2] = ACTIONS(13346),
    [aux_sym_integer_literal_token3] = ACTIONS(13346),
    [aux_sym_integer_literal_token4] = ACTIONS(13346),
    [aux_sym_float_literal_token1] = ACTIONS(13346),
    [aux_sym_float_literal_token3] = ACTIONS(13346),
    [aux_sym_float_literal_token4] = ACTIONS(13346),
    [sym_character_literal] = ACTIONS(13346),
    [sym__pair_operator] = ACTIONS(13346),
    [sym__arrow_operator] = ACTIONS(13346),
    [sym__lazy_or_operator] = ACTIONS(13346),
    [sym__lazy_and_operator] = ACTIONS(13346),
    [sym__comparison_operator] = ACTIONS(13346),
    [sym__pipe_right_operator] = ACTIONS(13346),
    [sym__pipe_left_operator] = ACTIONS(13346),
    [sym__ellipsis_operator] = ACTIONS(13346),
    [sym__plus_operator] = ACTIONS(13346),
    [sym__times_operator] = ACTIONS(13346),
    [sym__rational_operator] = ACTIONS(13346),
    [sym__bitshift_operator] = ACTIONS(13346),
    [sym__power_operator] = ACTIONS(13346),
    [sym__tilde_operator] = ACTIONS(13346),
    [sym__type_order_operator] = ACTIONS(13346),
    [sym__unary_operator] = ACTIONS(13346),
    [sym__unary_plus_operator] = ACTIONS(13346),
    [aux_sym__terminator_token1] = ACTIONS(13346),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13348),
    [sym__command_start] = ACTIONS(13348),
  },
  [7354] = {
    [ts_builtin_sym_end] = ACTIONS(13036),
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_RPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_RBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [7355] = {
    [aux_sym_export_statement_repeat1] = STATE(7355),
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(13350),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_catch] = ACTIONS(12974),
    [anon_sym_finally] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [7356] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_catch] = ACTIONS(12981),
    [anon_sym_finally] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_as] = ACTIONS(13014),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7357] = {
    [aux_sym__import_list_repeat1] = STATE(7357),
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(13353),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_catch] = ACTIONS(12981),
    [anon_sym_finally] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7358] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7359] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12562),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11954),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7360] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13356),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_elseif] = ACTIONS(13249),
    [anon_sym_else] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7361] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7362] = {
    [sym__word_identifier] = ACTIONS(13358),
    [anon_sym_EQ] = ACTIONS(13358),
    [anon_sym_COMMA] = ACTIONS(13358),
    [anon_sym_COLON] = ACTIONS(13358),
    [anon_sym_begin] = ACTIONS(13358),
    [anon_sym_module] = ACTIONS(13358),
    [anon_sym_baremodule] = ACTIONS(13358),
    [anon_sym_end] = ACTIONS(13358),
    [anon_sym_abstract] = ACTIONS(13358),
    [anon_sym_primitive] = ACTIONS(13358),
    [anon_sym_mutable] = ACTIONS(13358),
    [anon_sym_struct] = ACTIONS(13358),
    [anon_sym_function] = ACTIONS(13358),
    [anon_sym_macro] = ACTIONS(13358),
    [anon_sym_where] = ACTIONS(13358),
    [anon_sym_quote] = ACTIONS(13358),
    [anon_sym_let] = ACTIONS(13358),
    [anon_sym_if] = ACTIONS(13358),
    [anon_sym_elseif] = ACTIONS(13358),
    [anon_sym_else] = ACTIONS(13358),
    [anon_sym_try] = ACTIONS(13358),
    [anon_sym_for] = ACTIONS(13358),
    [anon_sym_while] = ACTIONS(13358),
    [sym_break_statement] = ACTIONS(13358),
    [sym_continue_statement] = ACTIONS(13358),
    [anon_sym_return] = ACTIONS(13358),
    [anon_sym_const] = ACTIONS(13358),
    [anon_sym_global] = ACTIONS(13358),
    [anon_sym_local] = ACTIONS(13358),
    [anon_sym_LPAREN] = ACTIONS(13358),
    [anon_sym_COLON2] = ACTIONS(13358),
    [anon_sym_export] = ACTIONS(13358),
    [anon_sym_import] = ACTIONS(13358),
    [anon_sym_using] = ACTIONS(13358),
    [anon_sym_LBRACK] = ACTIONS(13358),
    [anon_sym_LF] = ACTIONS(13360),
    [anon_sym_in] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(13358),
    [anon_sym_DOLLAR] = ACTIONS(13358),
    [anon_sym_COLON_COLON] = ACTIONS(13358),
    [anon_sym_isa] = ACTIONS(13358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13358),
    [anon_sym_QMARK] = ACTIONS(13358),
    [anon_sym_AT] = ACTIONS(13358),
    [anon_sym_true] = ACTIONS(13358),
    [anon_sym_false] = ACTIONS(13358),
    [aux_sym_integer_literal_token1] = ACTIONS(13358),
    [aux_sym_integer_literal_token2] = ACTIONS(13358),
    [aux_sym_integer_literal_token3] = ACTIONS(13358),
    [aux_sym_integer_literal_token4] = ACTIONS(13358),
    [aux_sym_float_literal_token1] = ACTIONS(13358),
    [aux_sym_float_literal_token3] = ACTIONS(13358),
    [aux_sym_float_literal_token4] = ACTIONS(13358),
    [sym_character_literal] = ACTIONS(13358),
    [sym__pair_operator] = ACTIONS(13358),
    [sym__arrow_operator] = ACTIONS(13358),
    [sym__lazy_or_operator] = ACTIONS(13358),
    [sym__lazy_and_operator] = ACTIONS(13358),
    [sym__comparison_operator] = ACTIONS(13358),
    [sym__pipe_right_operator] = ACTIONS(13358),
    [sym__pipe_left_operator] = ACTIONS(13358),
    [sym__ellipsis_operator] = ACTIONS(13358),
    [sym__plus_operator] = ACTIONS(13358),
    [sym__times_operator] = ACTIONS(13358),
    [sym__rational_operator] = ACTIONS(13358),
    [sym__bitshift_operator] = ACTIONS(13358),
    [sym__power_operator] = ACTIONS(13358),
    [sym__tilde_operator] = ACTIONS(13358),
    [sym__type_order_operator] = ACTIONS(13358),
    [sym__unary_operator] = ACTIONS(13358),
    [sym__unary_plus_operator] = ACTIONS(13358),
    [aux_sym__terminator_token1] = ACTIONS(13358),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13360),
    [sym__command_start] = ACTIONS(13360),
  },
  [7363] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7364] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7365] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_EQ] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_else] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_finally] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13108),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [7366] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7367] = {
    [sym__word_identifier] = ACTIONS(13362),
    [anon_sym_EQ] = ACTIONS(13362),
    [anon_sym_COMMA] = ACTIONS(13362),
    [anon_sym_COLON] = ACTIONS(13362),
    [anon_sym_begin] = ACTIONS(13362),
    [anon_sym_module] = ACTIONS(13362),
    [anon_sym_baremodule] = ACTIONS(13362),
    [anon_sym_end] = ACTIONS(13362),
    [anon_sym_abstract] = ACTIONS(13362),
    [anon_sym_primitive] = ACTIONS(13362),
    [anon_sym_mutable] = ACTIONS(13362),
    [anon_sym_struct] = ACTIONS(13362),
    [anon_sym_function] = ACTIONS(13362),
    [anon_sym_macro] = ACTIONS(13362),
    [anon_sym_where] = ACTIONS(13362),
    [anon_sym_quote] = ACTIONS(13362),
    [anon_sym_let] = ACTIONS(13362),
    [anon_sym_if] = ACTIONS(13362),
    [anon_sym_elseif] = ACTIONS(13362),
    [anon_sym_else] = ACTIONS(13362),
    [anon_sym_try] = ACTIONS(13362),
    [anon_sym_for] = ACTIONS(13362),
    [anon_sym_while] = ACTIONS(13362),
    [sym_break_statement] = ACTIONS(13362),
    [sym_continue_statement] = ACTIONS(13362),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_const] = ACTIONS(13362),
    [anon_sym_global] = ACTIONS(13362),
    [anon_sym_local] = ACTIONS(13362),
    [anon_sym_LPAREN] = ACTIONS(13362),
    [anon_sym_COLON2] = ACTIONS(13362),
    [anon_sym_export] = ACTIONS(13362),
    [anon_sym_import] = ACTIONS(13362),
    [anon_sym_using] = ACTIONS(13362),
    [anon_sym_LBRACK] = ACTIONS(13362),
    [anon_sym_LF] = ACTIONS(13364),
    [anon_sym_in] = ACTIONS(13362),
    [anon_sym_LBRACE] = ACTIONS(13362),
    [anon_sym_DOLLAR] = ACTIONS(13362),
    [anon_sym_COLON_COLON] = ACTIONS(13362),
    [anon_sym_isa] = ACTIONS(13362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13362),
    [anon_sym_QMARK] = ACTIONS(13362),
    [anon_sym_AT] = ACTIONS(13362),
    [anon_sym_true] = ACTIONS(13362),
    [anon_sym_false] = ACTIONS(13362),
    [aux_sym_integer_literal_token1] = ACTIONS(13362),
    [aux_sym_integer_literal_token2] = ACTIONS(13362),
    [aux_sym_integer_literal_token3] = ACTIONS(13362),
    [aux_sym_integer_literal_token4] = ACTIONS(13362),
    [aux_sym_float_literal_token1] = ACTIONS(13362),
    [aux_sym_float_literal_token3] = ACTIONS(13362),
    [aux_sym_float_literal_token4] = ACTIONS(13362),
    [sym_character_literal] = ACTIONS(13362),
    [sym__pair_operator] = ACTIONS(13362),
    [sym__arrow_operator] = ACTIONS(13362),
    [sym__lazy_or_operator] = ACTIONS(13362),
    [sym__lazy_and_operator] = ACTIONS(13362),
    [sym__comparison_operator] = ACTIONS(13362),
    [sym__pipe_right_operator] = ACTIONS(13362),
    [sym__pipe_left_operator] = ACTIONS(13362),
    [sym__ellipsis_operator] = ACTIONS(13362),
    [sym__plus_operator] = ACTIONS(13362),
    [sym__times_operator] = ACTIONS(13362),
    [sym__rational_operator] = ACTIONS(13362),
    [sym__bitshift_operator] = ACTIONS(13362),
    [sym__power_operator] = ACTIONS(13362),
    [sym__tilde_operator] = ACTIONS(13362),
    [sym__type_order_operator] = ACTIONS(13362),
    [sym__unary_operator] = ACTIONS(13362),
    [sym__unary_plus_operator] = ACTIONS(13362),
    [aux_sym__terminator_token1] = ACTIONS(13362),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13364),
    [sym__command_start] = ACTIONS(13364),
  },
  [7368] = {
    [sym__word_identifier] = ACTIONS(13366),
    [anon_sym_EQ] = ACTIONS(13366),
    [anon_sym_COMMA] = ACTIONS(13366),
    [anon_sym_COLON] = ACTIONS(13366),
    [anon_sym_begin] = ACTIONS(13366),
    [anon_sym_module] = ACTIONS(13366),
    [anon_sym_baremodule] = ACTIONS(13366),
    [anon_sym_end] = ACTIONS(13366),
    [anon_sym_abstract] = ACTIONS(13366),
    [anon_sym_primitive] = ACTIONS(13366),
    [anon_sym_mutable] = ACTIONS(13366),
    [anon_sym_struct] = ACTIONS(13366),
    [anon_sym_function] = ACTIONS(13366),
    [anon_sym_macro] = ACTIONS(13366),
    [anon_sym_where] = ACTIONS(13366),
    [anon_sym_quote] = ACTIONS(13366),
    [anon_sym_let] = ACTIONS(13366),
    [anon_sym_if] = ACTIONS(13366),
    [anon_sym_elseif] = ACTIONS(13366),
    [anon_sym_else] = ACTIONS(13366),
    [anon_sym_try] = ACTIONS(13366),
    [anon_sym_for] = ACTIONS(13366),
    [anon_sym_while] = ACTIONS(13366),
    [sym_break_statement] = ACTIONS(13366),
    [sym_continue_statement] = ACTIONS(13366),
    [anon_sym_return] = ACTIONS(13366),
    [anon_sym_const] = ACTIONS(13366),
    [anon_sym_global] = ACTIONS(13366),
    [anon_sym_local] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(13366),
    [anon_sym_COLON2] = ACTIONS(13366),
    [anon_sym_export] = ACTIONS(13366),
    [anon_sym_import] = ACTIONS(13366),
    [anon_sym_using] = ACTIONS(13366),
    [anon_sym_LBRACK] = ACTIONS(13366),
    [anon_sym_LF] = ACTIONS(13368),
    [anon_sym_in] = ACTIONS(13366),
    [anon_sym_LBRACE] = ACTIONS(13366),
    [anon_sym_DOLLAR] = ACTIONS(13366),
    [anon_sym_COLON_COLON] = ACTIONS(13366),
    [anon_sym_isa] = ACTIONS(13366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13366),
    [anon_sym_QMARK] = ACTIONS(13366),
    [anon_sym_AT] = ACTIONS(13366),
    [anon_sym_true] = ACTIONS(13366),
    [anon_sym_false] = ACTIONS(13366),
    [aux_sym_integer_literal_token1] = ACTIONS(13366),
    [aux_sym_integer_literal_token2] = ACTIONS(13366),
    [aux_sym_integer_literal_token3] = ACTIONS(13366),
    [aux_sym_integer_literal_token4] = ACTIONS(13366),
    [aux_sym_float_literal_token1] = ACTIONS(13366),
    [aux_sym_float_literal_token3] = ACTIONS(13366),
    [aux_sym_float_literal_token4] = ACTIONS(13366),
    [sym_character_literal] = ACTIONS(13366),
    [sym__pair_operator] = ACTIONS(13366),
    [sym__arrow_operator] = ACTIONS(13366),
    [sym__lazy_or_operator] = ACTIONS(13366),
    [sym__lazy_and_operator] = ACTIONS(13366),
    [sym__comparison_operator] = ACTIONS(13366),
    [sym__pipe_right_operator] = ACTIONS(13366),
    [sym__pipe_left_operator] = ACTIONS(13366),
    [sym__ellipsis_operator] = ACTIONS(13366),
    [sym__plus_operator] = ACTIONS(13366),
    [sym__times_operator] = ACTIONS(13366),
    [sym__rational_operator] = ACTIONS(13366),
    [sym__bitshift_operator] = ACTIONS(13366),
    [sym__power_operator] = ACTIONS(13366),
    [sym__tilde_operator] = ACTIONS(13366),
    [sym__type_order_operator] = ACTIONS(13366),
    [sym__unary_operator] = ACTIONS(13366),
    [sym__unary_plus_operator] = ACTIONS(13366),
    [aux_sym__terminator_token1] = ACTIONS(13366),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13368),
    [sym__command_start] = ACTIONS(13368),
  },
  [7369] = {
    [sym__word_identifier] = ACTIONS(13370),
    [anon_sym_EQ] = ACTIONS(13370),
    [anon_sym_COMMA] = ACTIONS(13370),
    [anon_sym_COLON] = ACTIONS(13370),
    [anon_sym_begin] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(13370),
    [anon_sym_baremodule] = ACTIONS(13370),
    [anon_sym_end] = ACTIONS(13370),
    [anon_sym_abstract] = ACTIONS(13370),
    [anon_sym_primitive] = ACTIONS(13370),
    [anon_sym_mutable] = ACTIONS(13370),
    [anon_sym_struct] = ACTIONS(13370),
    [anon_sym_function] = ACTIONS(13370),
    [anon_sym_macro] = ACTIONS(13370),
    [anon_sym_where] = ACTIONS(13370),
    [anon_sym_quote] = ACTIONS(13370),
    [anon_sym_let] = ACTIONS(13370),
    [anon_sym_if] = ACTIONS(13370),
    [anon_sym_elseif] = ACTIONS(13370),
    [anon_sym_else] = ACTIONS(13370),
    [anon_sym_try] = ACTIONS(13370),
    [anon_sym_for] = ACTIONS(13370),
    [anon_sym_while] = ACTIONS(13370),
    [sym_break_statement] = ACTIONS(13370),
    [sym_continue_statement] = ACTIONS(13370),
    [anon_sym_return] = ACTIONS(13370),
    [anon_sym_const] = ACTIONS(13370),
    [anon_sym_global] = ACTIONS(13370),
    [anon_sym_local] = ACTIONS(13370),
    [anon_sym_LPAREN] = ACTIONS(13370),
    [anon_sym_COLON2] = ACTIONS(13370),
    [anon_sym_export] = ACTIONS(13370),
    [anon_sym_import] = ACTIONS(13370),
    [anon_sym_using] = ACTIONS(13370),
    [anon_sym_LBRACK] = ACTIONS(13370),
    [anon_sym_LF] = ACTIONS(13372),
    [anon_sym_in] = ACTIONS(13370),
    [anon_sym_LBRACE] = ACTIONS(13370),
    [anon_sym_DOLLAR] = ACTIONS(13370),
    [anon_sym_COLON_COLON] = ACTIONS(13370),
    [anon_sym_isa] = ACTIONS(13370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13370),
    [anon_sym_QMARK] = ACTIONS(13370),
    [anon_sym_AT] = ACTIONS(13370),
    [anon_sym_true] = ACTIONS(13370),
    [anon_sym_false] = ACTIONS(13370),
    [aux_sym_integer_literal_token1] = ACTIONS(13370),
    [aux_sym_integer_literal_token2] = ACTIONS(13370),
    [aux_sym_integer_literal_token3] = ACTIONS(13370),
    [aux_sym_integer_literal_token4] = ACTIONS(13370),
    [aux_sym_float_literal_token1] = ACTIONS(13370),
    [aux_sym_float_literal_token3] = ACTIONS(13370),
    [aux_sym_float_literal_token4] = ACTIONS(13370),
    [sym_character_literal] = ACTIONS(13370),
    [sym__pair_operator] = ACTIONS(13370),
    [sym__arrow_operator] = ACTIONS(13370),
    [sym__lazy_or_operator] = ACTIONS(13370),
    [sym__lazy_and_operator] = ACTIONS(13370),
    [sym__comparison_operator] = ACTIONS(13370),
    [sym__pipe_right_operator] = ACTIONS(13370),
    [sym__pipe_left_operator] = ACTIONS(13370),
    [sym__ellipsis_operator] = ACTIONS(13370),
    [sym__plus_operator] = ACTIONS(13370),
    [sym__times_operator] = ACTIONS(13370),
    [sym__rational_operator] = ACTIONS(13370),
    [sym__bitshift_operator] = ACTIONS(13370),
    [sym__power_operator] = ACTIONS(13370),
    [sym__tilde_operator] = ACTIONS(13370),
    [sym__type_order_operator] = ACTIONS(13370),
    [sym__unary_operator] = ACTIONS(13370),
    [sym__unary_plus_operator] = ACTIONS(13370),
    [aux_sym__terminator_token1] = ACTIONS(13370),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13372),
    [sym__command_start] = ACTIONS(13372),
  },
  [7370] = {
    [sym__word_identifier] = ACTIONS(13374),
    [anon_sym_EQ] = ACTIONS(13374),
    [anon_sym_COMMA] = ACTIONS(13374),
    [anon_sym_COLON] = ACTIONS(13374),
    [anon_sym_begin] = ACTIONS(13374),
    [anon_sym_module] = ACTIONS(13374),
    [anon_sym_baremodule] = ACTIONS(13374),
    [anon_sym_end] = ACTIONS(13374),
    [anon_sym_abstract] = ACTIONS(13374),
    [anon_sym_primitive] = ACTIONS(13374),
    [anon_sym_mutable] = ACTIONS(13374),
    [anon_sym_struct] = ACTIONS(13374),
    [anon_sym_function] = ACTIONS(13374),
    [anon_sym_macro] = ACTIONS(13374),
    [anon_sym_where] = ACTIONS(13374),
    [anon_sym_quote] = ACTIONS(13374),
    [anon_sym_let] = ACTIONS(13374),
    [anon_sym_if] = ACTIONS(13374),
    [anon_sym_elseif] = ACTIONS(13374),
    [anon_sym_else] = ACTIONS(13374),
    [anon_sym_try] = ACTIONS(13374),
    [anon_sym_for] = ACTIONS(13374),
    [anon_sym_while] = ACTIONS(13374),
    [sym_break_statement] = ACTIONS(13374),
    [sym_continue_statement] = ACTIONS(13374),
    [anon_sym_return] = ACTIONS(13374),
    [anon_sym_const] = ACTIONS(13374),
    [anon_sym_global] = ACTIONS(13374),
    [anon_sym_local] = ACTIONS(13374),
    [anon_sym_LPAREN] = ACTIONS(13374),
    [anon_sym_COLON2] = ACTIONS(13374),
    [anon_sym_export] = ACTIONS(13374),
    [anon_sym_import] = ACTIONS(13374),
    [anon_sym_using] = ACTIONS(13374),
    [anon_sym_LBRACK] = ACTIONS(13374),
    [anon_sym_LF] = ACTIONS(13376),
    [anon_sym_in] = ACTIONS(13374),
    [anon_sym_LBRACE] = ACTIONS(13374),
    [anon_sym_DOLLAR] = ACTIONS(13374),
    [anon_sym_COLON_COLON] = ACTIONS(13374),
    [anon_sym_isa] = ACTIONS(13374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13374),
    [anon_sym_QMARK] = ACTIONS(13374),
    [anon_sym_AT] = ACTIONS(13374),
    [anon_sym_true] = ACTIONS(13374),
    [anon_sym_false] = ACTIONS(13374),
    [aux_sym_integer_literal_token1] = ACTIONS(13374),
    [aux_sym_integer_literal_token2] = ACTIONS(13374),
    [aux_sym_integer_literal_token3] = ACTIONS(13374),
    [aux_sym_integer_literal_token4] = ACTIONS(13374),
    [aux_sym_float_literal_token1] = ACTIONS(13374),
    [aux_sym_float_literal_token3] = ACTIONS(13374),
    [aux_sym_float_literal_token4] = ACTIONS(13374),
    [sym_character_literal] = ACTIONS(13374),
    [sym__pair_operator] = ACTIONS(13374),
    [sym__arrow_operator] = ACTIONS(13374),
    [sym__lazy_or_operator] = ACTIONS(13374),
    [sym__lazy_and_operator] = ACTIONS(13374),
    [sym__comparison_operator] = ACTIONS(13374),
    [sym__pipe_right_operator] = ACTIONS(13374),
    [sym__pipe_left_operator] = ACTIONS(13374),
    [sym__ellipsis_operator] = ACTIONS(13374),
    [sym__plus_operator] = ACTIONS(13374),
    [sym__times_operator] = ACTIONS(13374),
    [sym__rational_operator] = ACTIONS(13374),
    [sym__bitshift_operator] = ACTIONS(13374),
    [sym__power_operator] = ACTIONS(13374),
    [sym__tilde_operator] = ACTIONS(13374),
    [sym__type_order_operator] = ACTIONS(13374),
    [sym__unary_operator] = ACTIONS(13374),
    [sym__unary_plus_operator] = ACTIONS(13374),
    [aux_sym__terminator_token1] = ACTIONS(13374),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13376),
    [sym__command_start] = ACTIONS(13376),
  },
  [7371] = {
    [sym__word_identifier] = ACTIONS(13378),
    [anon_sym_EQ] = ACTIONS(13378),
    [anon_sym_COMMA] = ACTIONS(13378),
    [anon_sym_COLON] = ACTIONS(13378),
    [anon_sym_begin] = ACTIONS(13378),
    [anon_sym_module] = ACTIONS(13378),
    [anon_sym_baremodule] = ACTIONS(13378),
    [anon_sym_end] = ACTIONS(13378),
    [anon_sym_abstract] = ACTIONS(13378),
    [anon_sym_primitive] = ACTIONS(13378),
    [anon_sym_mutable] = ACTIONS(13378),
    [anon_sym_struct] = ACTIONS(13378),
    [anon_sym_function] = ACTIONS(13378),
    [anon_sym_macro] = ACTIONS(13378),
    [anon_sym_where] = ACTIONS(13378),
    [anon_sym_quote] = ACTIONS(13378),
    [anon_sym_let] = ACTIONS(13378),
    [anon_sym_if] = ACTIONS(13378),
    [anon_sym_elseif] = ACTIONS(13378),
    [anon_sym_else] = ACTIONS(13378),
    [anon_sym_try] = ACTIONS(13378),
    [anon_sym_for] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(13378),
    [sym_break_statement] = ACTIONS(13378),
    [sym_continue_statement] = ACTIONS(13378),
    [anon_sym_return] = ACTIONS(13378),
    [anon_sym_const] = ACTIONS(13378),
    [anon_sym_global] = ACTIONS(13378),
    [anon_sym_local] = ACTIONS(13378),
    [anon_sym_LPAREN] = ACTIONS(13378),
    [anon_sym_COLON2] = ACTIONS(13378),
    [anon_sym_export] = ACTIONS(13378),
    [anon_sym_import] = ACTIONS(13378),
    [anon_sym_using] = ACTIONS(13378),
    [anon_sym_LBRACK] = ACTIONS(13378),
    [anon_sym_LF] = ACTIONS(13380),
    [anon_sym_in] = ACTIONS(13378),
    [anon_sym_LBRACE] = ACTIONS(13378),
    [anon_sym_DOLLAR] = ACTIONS(13378),
    [anon_sym_COLON_COLON] = ACTIONS(13378),
    [anon_sym_isa] = ACTIONS(13378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13378),
    [anon_sym_QMARK] = ACTIONS(13378),
    [anon_sym_AT] = ACTIONS(13378),
    [anon_sym_true] = ACTIONS(13378),
    [anon_sym_false] = ACTIONS(13378),
    [aux_sym_integer_literal_token1] = ACTIONS(13378),
    [aux_sym_integer_literal_token2] = ACTIONS(13378),
    [aux_sym_integer_literal_token3] = ACTIONS(13378),
    [aux_sym_integer_literal_token4] = ACTIONS(13378),
    [aux_sym_float_literal_token1] = ACTIONS(13378),
    [aux_sym_float_literal_token3] = ACTIONS(13378),
    [aux_sym_float_literal_token4] = ACTIONS(13378),
    [sym_character_literal] = ACTIONS(13378),
    [sym__pair_operator] = ACTIONS(13378),
    [sym__arrow_operator] = ACTIONS(13378),
    [sym__lazy_or_operator] = ACTIONS(13378),
    [sym__lazy_and_operator] = ACTIONS(13378),
    [sym__comparison_operator] = ACTIONS(13378),
    [sym__pipe_right_operator] = ACTIONS(13378),
    [sym__pipe_left_operator] = ACTIONS(13378),
    [sym__ellipsis_operator] = ACTIONS(13378),
    [sym__plus_operator] = ACTIONS(13378),
    [sym__times_operator] = ACTIONS(13378),
    [sym__rational_operator] = ACTIONS(13378),
    [sym__bitshift_operator] = ACTIONS(13378),
    [sym__power_operator] = ACTIONS(13378),
    [sym__tilde_operator] = ACTIONS(13378),
    [sym__type_order_operator] = ACTIONS(13378),
    [sym__unary_operator] = ACTIONS(13378),
    [sym__unary_plus_operator] = ACTIONS(13378),
    [aux_sym__terminator_token1] = ACTIONS(13378),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13380),
    [sym__command_start] = ACTIONS(13380),
  },
  [7372] = {
    [sym__word_identifier] = ACTIONS(13382),
    [anon_sym_EQ] = ACTIONS(13382),
    [anon_sym_COMMA] = ACTIONS(13382),
    [anon_sym_COLON] = ACTIONS(13382),
    [anon_sym_begin] = ACTIONS(13382),
    [anon_sym_module] = ACTIONS(13382),
    [anon_sym_baremodule] = ACTIONS(13382),
    [anon_sym_end] = ACTIONS(13382),
    [anon_sym_abstract] = ACTIONS(13382),
    [anon_sym_primitive] = ACTIONS(13382),
    [anon_sym_mutable] = ACTIONS(13382),
    [anon_sym_struct] = ACTIONS(13382),
    [anon_sym_function] = ACTIONS(13382),
    [anon_sym_macro] = ACTIONS(13382),
    [anon_sym_where] = ACTIONS(13382),
    [anon_sym_quote] = ACTIONS(13382),
    [anon_sym_let] = ACTIONS(13382),
    [anon_sym_if] = ACTIONS(13382),
    [anon_sym_elseif] = ACTIONS(13382),
    [anon_sym_else] = ACTIONS(13382),
    [anon_sym_try] = ACTIONS(13382),
    [anon_sym_for] = ACTIONS(13382),
    [anon_sym_while] = ACTIONS(13382),
    [sym_break_statement] = ACTIONS(13382),
    [sym_continue_statement] = ACTIONS(13382),
    [anon_sym_return] = ACTIONS(13382),
    [anon_sym_const] = ACTIONS(13382),
    [anon_sym_global] = ACTIONS(13382),
    [anon_sym_local] = ACTIONS(13382),
    [anon_sym_LPAREN] = ACTIONS(13382),
    [anon_sym_COLON2] = ACTIONS(13382),
    [anon_sym_export] = ACTIONS(13382),
    [anon_sym_import] = ACTIONS(13382),
    [anon_sym_using] = ACTIONS(13382),
    [anon_sym_LBRACK] = ACTIONS(13382),
    [anon_sym_LF] = ACTIONS(13384),
    [anon_sym_in] = ACTIONS(13382),
    [anon_sym_LBRACE] = ACTIONS(13382),
    [anon_sym_DOLLAR] = ACTIONS(13382),
    [anon_sym_COLON_COLON] = ACTIONS(13382),
    [anon_sym_isa] = ACTIONS(13382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13382),
    [anon_sym_QMARK] = ACTIONS(13382),
    [anon_sym_AT] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(13382),
    [anon_sym_false] = ACTIONS(13382),
    [aux_sym_integer_literal_token1] = ACTIONS(13382),
    [aux_sym_integer_literal_token2] = ACTIONS(13382),
    [aux_sym_integer_literal_token3] = ACTIONS(13382),
    [aux_sym_integer_literal_token4] = ACTIONS(13382),
    [aux_sym_float_literal_token1] = ACTIONS(13382),
    [aux_sym_float_literal_token3] = ACTIONS(13382),
    [aux_sym_float_literal_token4] = ACTIONS(13382),
    [sym_character_literal] = ACTIONS(13382),
    [sym__pair_operator] = ACTIONS(13382),
    [sym__arrow_operator] = ACTIONS(13382),
    [sym__lazy_or_operator] = ACTIONS(13382),
    [sym__lazy_and_operator] = ACTIONS(13382),
    [sym__comparison_operator] = ACTIONS(13382),
    [sym__pipe_right_operator] = ACTIONS(13382),
    [sym__pipe_left_operator] = ACTIONS(13382),
    [sym__ellipsis_operator] = ACTIONS(13382),
    [sym__plus_operator] = ACTIONS(13382),
    [sym__times_operator] = ACTIONS(13382),
    [sym__rational_operator] = ACTIONS(13382),
    [sym__bitshift_operator] = ACTIONS(13382),
    [sym__power_operator] = ACTIONS(13382),
    [sym__tilde_operator] = ACTIONS(13382),
    [sym__type_order_operator] = ACTIONS(13382),
    [sym__unary_operator] = ACTIONS(13382),
    [sym__unary_plus_operator] = ACTIONS(13382),
    [aux_sym__terminator_token1] = ACTIONS(13382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13384),
    [sym__command_start] = ACTIONS(13384),
  },
  [7373] = {
    [sym__word_identifier] = ACTIONS(13386),
    [anon_sym_EQ] = ACTIONS(13386),
    [anon_sym_COMMA] = ACTIONS(13386),
    [anon_sym_COLON] = ACTIONS(13386),
    [anon_sym_begin] = ACTIONS(13386),
    [anon_sym_module] = ACTIONS(13386),
    [anon_sym_baremodule] = ACTIONS(13386),
    [anon_sym_end] = ACTIONS(13386),
    [anon_sym_abstract] = ACTIONS(13386),
    [anon_sym_primitive] = ACTIONS(13386),
    [anon_sym_mutable] = ACTIONS(13386),
    [anon_sym_struct] = ACTIONS(13386),
    [anon_sym_function] = ACTIONS(13386),
    [anon_sym_macro] = ACTIONS(13386),
    [anon_sym_where] = ACTIONS(13386),
    [anon_sym_quote] = ACTIONS(13386),
    [anon_sym_let] = ACTIONS(13386),
    [anon_sym_if] = ACTIONS(13386),
    [anon_sym_elseif] = ACTIONS(13386),
    [anon_sym_else] = ACTIONS(13386),
    [anon_sym_try] = ACTIONS(13386),
    [anon_sym_for] = ACTIONS(13386),
    [anon_sym_while] = ACTIONS(13386),
    [sym_break_statement] = ACTIONS(13386),
    [sym_continue_statement] = ACTIONS(13386),
    [anon_sym_return] = ACTIONS(13386),
    [anon_sym_const] = ACTIONS(13386),
    [anon_sym_global] = ACTIONS(13386),
    [anon_sym_local] = ACTIONS(13386),
    [anon_sym_LPAREN] = ACTIONS(13386),
    [anon_sym_COLON2] = ACTIONS(13386),
    [anon_sym_export] = ACTIONS(13386),
    [anon_sym_import] = ACTIONS(13386),
    [anon_sym_using] = ACTIONS(13386),
    [anon_sym_LBRACK] = ACTIONS(13386),
    [anon_sym_LF] = ACTIONS(13388),
    [anon_sym_in] = ACTIONS(13386),
    [anon_sym_LBRACE] = ACTIONS(13386),
    [anon_sym_DOLLAR] = ACTIONS(13386),
    [anon_sym_COLON_COLON] = ACTIONS(13386),
    [anon_sym_isa] = ACTIONS(13386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13386),
    [anon_sym_QMARK] = ACTIONS(13386),
    [anon_sym_AT] = ACTIONS(13386),
    [anon_sym_true] = ACTIONS(13386),
    [anon_sym_false] = ACTIONS(13386),
    [aux_sym_integer_literal_token1] = ACTIONS(13386),
    [aux_sym_integer_literal_token2] = ACTIONS(13386),
    [aux_sym_integer_literal_token3] = ACTIONS(13386),
    [aux_sym_integer_literal_token4] = ACTIONS(13386),
    [aux_sym_float_literal_token1] = ACTIONS(13386),
    [aux_sym_float_literal_token3] = ACTIONS(13386),
    [aux_sym_float_literal_token4] = ACTIONS(13386),
    [sym_character_literal] = ACTIONS(13386),
    [sym__pair_operator] = ACTIONS(13386),
    [sym__arrow_operator] = ACTIONS(13386),
    [sym__lazy_or_operator] = ACTIONS(13386),
    [sym__lazy_and_operator] = ACTIONS(13386),
    [sym__comparison_operator] = ACTIONS(13386),
    [sym__pipe_right_operator] = ACTIONS(13386),
    [sym__pipe_left_operator] = ACTIONS(13386),
    [sym__ellipsis_operator] = ACTIONS(13386),
    [sym__plus_operator] = ACTIONS(13386),
    [sym__times_operator] = ACTIONS(13386),
    [sym__rational_operator] = ACTIONS(13386),
    [sym__bitshift_operator] = ACTIONS(13386),
    [sym__power_operator] = ACTIONS(13386),
    [sym__tilde_operator] = ACTIONS(13386),
    [sym__type_order_operator] = ACTIONS(13386),
    [sym__unary_operator] = ACTIONS(13386),
    [sym__unary_plus_operator] = ACTIONS(13386),
    [aux_sym__terminator_token1] = ACTIONS(13386),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13388),
    [sym__command_start] = ACTIONS(13388),
  },
  [7374] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12220),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7375] = {
    [sym__word_identifier] = ACTIONS(13390),
    [anon_sym_EQ] = ACTIONS(13390),
    [anon_sym_COMMA] = ACTIONS(13390),
    [anon_sym_COLON] = ACTIONS(13390),
    [anon_sym_begin] = ACTIONS(13390),
    [anon_sym_module] = ACTIONS(13390),
    [anon_sym_baremodule] = ACTIONS(13390),
    [anon_sym_end] = ACTIONS(13390),
    [anon_sym_abstract] = ACTIONS(13390),
    [anon_sym_primitive] = ACTIONS(13390),
    [anon_sym_mutable] = ACTIONS(13390),
    [anon_sym_struct] = ACTIONS(13390),
    [anon_sym_function] = ACTIONS(13390),
    [anon_sym_macro] = ACTIONS(13390),
    [anon_sym_where] = ACTIONS(13390),
    [anon_sym_quote] = ACTIONS(13390),
    [anon_sym_let] = ACTIONS(13390),
    [anon_sym_if] = ACTIONS(13390),
    [anon_sym_elseif] = ACTIONS(13390),
    [anon_sym_else] = ACTIONS(13390),
    [anon_sym_try] = ACTIONS(13390),
    [anon_sym_for] = ACTIONS(13390),
    [anon_sym_while] = ACTIONS(13390),
    [sym_break_statement] = ACTIONS(13390),
    [sym_continue_statement] = ACTIONS(13390),
    [anon_sym_return] = ACTIONS(13390),
    [anon_sym_const] = ACTIONS(13390),
    [anon_sym_global] = ACTIONS(13390),
    [anon_sym_local] = ACTIONS(13390),
    [anon_sym_LPAREN] = ACTIONS(13390),
    [anon_sym_COLON2] = ACTIONS(13390),
    [anon_sym_export] = ACTIONS(13390),
    [anon_sym_import] = ACTIONS(13390),
    [anon_sym_using] = ACTIONS(13390),
    [anon_sym_LBRACK] = ACTIONS(13390),
    [anon_sym_LF] = ACTIONS(13392),
    [anon_sym_in] = ACTIONS(13390),
    [anon_sym_LBRACE] = ACTIONS(13390),
    [anon_sym_DOLLAR] = ACTIONS(13390),
    [anon_sym_COLON_COLON] = ACTIONS(13390),
    [anon_sym_isa] = ACTIONS(13390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13390),
    [anon_sym_QMARK] = ACTIONS(13390),
    [anon_sym_AT] = ACTIONS(13390),
    [anon_sym_true] = ACTIONS(13390),
    [anon_sym_false] = ACTIONS(13390),
    [aux_sym_integer_literal_token1] = ACTIONS(13390),
    [aux_sym_integer_literal_token2] = ACTIONS(13390),
    [aux_sym_integer_literal_token3] = ACTIONS(13390),
    [aux_sym_integer_literal_token4] = ACTIONS(13390),
    [aux_sym_float_literal_token1] = ACTIONS(13390),
    [aux_sym_float_literal_token3] = ACTIONS(13390),
    [aux_sym_float_literal_token4] = ACTIONS(13390),
    [sym_character_literal] = ACTIONS(13390),
    [sym__pair_operator] = ACTIONS(13390),
    [sym__arrow_operator] = ACTIONS(13390),
    [sym__lazy_or_operator] = ACTIONS(13390),
    [sym__lazy_and_operator] = ACTIONS(13390),
    [sym__comparison_operator] = ACTIONS(13390),
    [sym__pipe_right_operator] = ACTIONS(13390),
    [sym__pipe_left_operator] = ACTIONS(13390),
    [sym__ellipsis_operator] = ACTIONS(13390),
    [sym__plus_operator] = ACTIONS(13390),
    [sym__times_operator] = ACTIONS(13390),
    [sym__rational_operator] = ACTIONS(13390),
    [sym__bitshift_operator] = ACTIONS(13390),
    [sym__power_operator] = ACTIONS(13390),
    [sym__tilde_operator] = ACTIONS(13390),
    [sym__type_order_operator] = ACTIONS(13390),
    [sym__unary_operator] = ACTIONS(13390),
    [sym__unary_plus_operator] = ACTIONS(13390),
    [aux_sym__terminator_token1] = ACTIONS(13390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13392),
    [sym__command_start] = ACTIONS(13392),
  },
  [7376] = {
    [aux_sym_open_tuple_repeat1] = STATE(7379),
    [sym__word_identifier] = ACTIONS(13150),
    [anon_sym_EQ] = ACTIONS(13150),
    [anon_sym_COMMA] = ACTIONS(13394),
    [anon_sym_COLON] = ACTIONS(13150),
    [anon_sym_begin] = ACTIONS(13150),
    [anon_sym_module] = ACTIONS(13150),
    [anon_sym_baremodule] = ACTIONS(13150),
    [anon_sym_end] = ACTIONS(13150),
    [anon_sym_abstract] = ACTIONS(13150),
    [anon_sym_primitive] = ACTIONS(13150),
    [anon_sym_mutable] = ACTIONS(13150),
    [anon_sym_struct] = ACTIONS(13150),
    [anon_sym_function] = ACTIONS(13150),
    [anon_sym_macro] = ACTIONS(13150),
    [anon_sym_where] = ACTIONS(13150),
    [anon_sym_quote] = ACTIONS(13150),
    [anon_sym_let] = ACTIONS(13150),
    [anon_sym_if] = ACTIONS(13150),
    [anon_sym_try] = ACTIONS(13150),
    [anon_sym_catch] = ACTIONS(13150),
    [anon_sym_for] = ACTIONS(13150),
    [anon_sym_while] = ACTIONS(13150),
    [sym_break_statement] = ACTIONS(13150),
    [sym_continue_statement] = ACTIONS(13150),
    [anon_sym_return] = ACTIONS(13150),
    [anon_sym_const] = ACTIONS(13150),
    [anon_sym_global] = ACTIONS(13150),
    [anon_sym_local] = ACTIONS(13150),
    [anon_sym_LPAREN] = ACTIONS(13150),
    [anon_sym_COLON2] = ACTIONS(13150),
    [anon_sym_export] = ACTIONS(13150),
    [anon_sym_import] = ACTIONS(13150),
    [anon_sym_using] = ACTIONS(13150),
    [anon_sym_LBRACK] = ACTIONS(13150),
    [anon_sym_LF] = ACTIONS(13148),
    [anon_sym_in] = ACTIONS(13150),
    [anon_sym_LBRACE] = ACTIONS(13150),
    [anon_sym_DOLLAR] = ACTIONS(13150),
    [anon_sym_COLON_COLON] = ACTIONS(13150),
    [anon_sym_isa] = ACTIONS(13150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13150),
    [anon_sym_QMARK] = ACTIONS(13150),
    [anon_sym_AT] = ACTIONS(13150),
    [anon_sym_true] = ACTIONS(13150),
    [anon_sym_false] = ACTIONS(13150),
    [aux_sym_integer_literal_token1] = ACTIONS(13150),
    [aux_sym_integer_literal_token2] = ACTIONS(13150),
    [aux_sym_integer_literal_token3] = ACTIONS(13150),
    [aux_sym_integer_literal_token4] = ACTIONS(13150),
    [aux_sym_float_literal_token1] = ACTIONS(13150),
    [aux_sym_float_literal_token3] = ACTIONS(13150),
    [aux_sym_float_literal_token4] = ACTIONS(13150),
    [sym_character_literal] = ACTIONS(13150),
    [sym__pair_operator] = ACTIONS(13150),
    [sym__arrow_operator] = ACTIONS(13150),
    [sym__lazy_or_operator] = ACTIONS(13150),
    [sym__lazy_and_operator] = ACTIONS(13150),
    [sym__comparison_operator] = ACTIONS(13150),
    [sym__pipe_right_operator] = ACTIONS(13150),
    [sym__pipe_left_operator] = ACTIONS(13150),
    [sym__ellipsis_operator] = ACTIONS(13150),
    [sym__plus_operator] = ACTIONS(13150),
    [sym__times_operator] = ACTIONS(13150),
    [sym__rational_operator] = ACTIONS(13150),
    [sym__bitshift_operator] = ACTIONS(13150),
    [sym__power_operator] = ACTIONS(13150),
    [sym__tilde_operator] = ACTIONS(13150),
    [sym__type_order_operator] = ACTIONS(13150),
    [sym__unary_operator] = ACTIONS(13150),
    [sym__unary_plus_operator] = ACTIONS(13150),
    [aux_sym__terminator_token1] = ACTIONS(13150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13148),
    [sym__command_start] = ACTIONS(13148),
  },
  [7377] = {
    [sym__word_identifier] = ACTIONS(13396),
    [anon_sym_EQ] = ACTIONS(13396),
    [anon_sym_COMMA] = ACTIONS(13396),
    [anon_sym_COLON] = ACTIONS(13396),
    [anon_sym_begin] = ACTIONS(13396),
    [anon_sym_module] = ACTIONS(13396),
    [anon_sym_baremodule] = ACTIONS(13396),
    [anon_sym_end] = ACTIONS(13396),
    [anon_sym_abstract] = ACTIONS(13396),
    [anon_sym_primitive] = ACTIONS(13396),
    [anon_sym_mutable] = ACTIONS(13396),
    [anon_sym_struct] = ACTIONS(13396),
    [anon_sym_function] = ACTIONS(13396),
    [anon_sym_macro] = ACTIONS(13396),
    [anon_sym_where] = ACTIONS(13396),
    [anon_sym_quote] = ACTIONS(13396),
    [anon_sym_let] = ACTIONS(13396),
    [anon_sym_if] = ACTIONS(13396),
    [anon_sym_elseif] = ACTIONS(13396),
    [anon_sym_else] = ACTIONS(13396),
    [anon_sym_try] = ACTIONS(13396),
    [anon_sym_for] = ACTIONS(13396),
    [anon_sym_while] = ACTIONS(13396),
    [sym_break_statement] = ACTIONS(13396),
    [sym_continue_statement] = ACTIONS(13396),
    [anon_sym_return] = ACTIONS(13396),
    [anon_sym_const] = ACTIONS(13396),
    [anon_sym_global] = ACTIONS(13396),
    [anon_sym_local] = ACTIONS(13396),
    [anon_sym_LPAREN] = ACTIONS(13396),
    [anon_sym_COLON2] = ACTIONS(13396),
    [anon_sym_export] = ACTIONS(13396),
    [anon_sym_import] = ACTIONS(13396),
    [anon_sym_using] = ACTIONS(13396),
    [anon_sym_LBRACK] = ACTIONS(13396),
    [anon_sym_LF] = ACTIONS(13398),
    [anon_sym_in] = ACTIONS(13396),
    [anon_sym_LBRACE] = ACTIONS(13396),
    [anon_sym_DOLLAR] = ACTIONS(13396),
    [anon_sym_COLON_COLON] = ACTIONS(13396),
    [anon_sym_isa] = ACTIONS(13396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13396),
    [anon_sym_QMARK] = ACTIONS(13396),
    [anon_sym_AT] = ACTIONS(13396),
    [anon_sym_true] = ACTIONS(13396),
    [anon_sym_false] = ACTIONS(13396),
    [aux_sym_integer_literal_token1] = ACTIONS(13396),
    [aux_sym_integer_literal_token2] = ACTIONS(13396),
    [aux_sym_integer_literal_token3] = ACTIONS(13396),
    [aux_sym_integer_literal_token4] = ACTIONS(13396),
    [aux_sym_float_literal_token1] = ACTIONS(13396),
    [aux_sym_float_literal_token3] = ACTIONS(13396),
    [aux_sym_float_literal_token4] = ACTIONS(13396),
    [sym_character_literal] = ACTIONS(13396),
    [sym__pair_operator] = ACTIONS(13396),
    [sym__arrow_operator] = ACTIONS(13396),
    [sym__lazy_or_operator] = ACTIONS(13396),
    [sym__lazy_and_operator] = ACTIONS(13396),
    [sym__comparison_operator] = ACTIONS(13396),
    [sym__pipe_right_operator] = ACTIONS(13396),
    [sym__pipe_left_operator] = ACTIONS(13396),
    [sym__ellipsis_operator] = ACTIONS(13396),
    [sym__plus_operator] = ACTIONS(13396),
    [sym__times_operator] = ACTIONS(13396),
    [sym__rational_operator] = ACTIONS(13396),
    [sym__bitshift_operator] = ACTIONS(13396),
    [sym__power_operator] = ACTIONS(13396),
    [sym__tilde_operator] = ACTIONS(13396),
    [sym__type_order_operator] = ACTIONS(13396),
    [sym__unary_operator] = ACTIONS(13396),
    [sym__unary_plus_operator] = ACTIONS(13396),
    [aux_sym__terminator_token1] = ACTIONS(13396),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13398),
    [sym__command_start] = ACTIONS(13398),
  },
  [7378] = {
    [sym__word_identifier] = ACTIONS(13400),
    [anon_sym_EQ] = ACTIONS(13400),
    [anon_sym_COMMA] = ACTIONS(13400),
    [anon_sym_COLON] = ACTIONS(13400),
    [anon_sym_begin] = ACTIONS(13400),
    [anon_sym_module] = ACTIONS(13400),
    [anon_sym_baremodule] = ACTIONS(13400),
    [anon_sym_end] = ACTIONS(13400),
    [anon_sym_abstract] = ACTIONS(13400),
    [anon_sym_primitive] = ACTIONS(13400),
    [anon_sym_mutable] = ACTIONS(13400),
    [anon_sym_struct] = ACTIONS(13400),
    [anon_sym_function] = ACTIONS(13400),
    [anon_sym_macro] = ACTIONS(13400),
    [anon_sym_where] = ACTIONS(13400),
    [anon_sym_quote] = ACTIONS(13400),
    [anon_sym_let] = ACTIONS(13400),
    [anon_sym_if] = ACTIONS(13400),
    [anon_sym_elseif] = ACTIONS(13400),
    [anon_sym_else] = ACTIONS(13400),
    [anon_sym_try] = ACTIONS(13400),
    [anon_sym_for] = ACTIONS(13400),
    [anon_sym_while] = ACTIONS(13400),
    [sym_break_statement] = ACTIONS(13400),
    [sym_continue_statement] = ACTIONS(13400),
    [anon_sym_return] = ACTIONS(13400),
    [anon_sym_const] = ACTIONS(13400),
    [anon_sym_global] = ACTIONS(13400),
    [anon_sym_local] = ACTIONS(13400),
    [anon_sym_LPAREN] = ACTIONS(13400),
    [anon_sym_COLON2] = ACTIONS(13400),
    [anon_sym_export] = ACTIONS(13400),
    [anon_sym_import] = ACTIONS(13400),
    [anon_sym_using] = ACTIONS(13400),
    [anon_sym_LBRACK] = ACTIONS(13400),
    [anon_sym_LF] = ACTIONS(13402),
    [anon_sym_in] = ACTIONS(13400),
    [anon_sym_LBRACE] = ACTIONS(13400),
    [anon_sym_DOLLAR] = ACTIONS(13400),
    [anon_sym_COLON_COLON] = ACTIONS(13400),
    [anon_sym_isa] = ACTIONS(13400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13400),
    [anon_sym_QMARK] = ACTIONS(13400),
    [anon_sym_AT] = ACTIONS(13400),
    [anon_sym_true] = ACTIONS(13400),
    [anon_sym_false] = ACTIONS(13400),
    [aux_sym_integer_literal_token1] = ACTIONS(13400),
    [aux_sym_integer_literal_token2] = ACTIONS(13400),
    [aux_sym_integer_literal_token3] = ACTIONS(13400),
    [aux_sym_integer_literal_token4] = ACTIONS(13400),
    [aux_sym_float_literal_token1] = ACTIONS(13400),
    [aux_sym_float_literal_token3] = ACTIONS(13400),
    [aux_sym_float_literal_token4] = ACTIONS(13400),
    [sym_character_literal] = ACTIONS(13400),
    [sym__pair_operator] = ACTIONS(13400),
    [sym__arrow_operator] = ACTIONS(13400),
    [sym__lazy_or_operator] = ACTIONS(13400),
    [sym__lazy_and_operator] = ACTIONS(13400),
    [sym__comparison_operator] = ACTIONS(13400),
    [sym__pipe_right_operator] = ACTIONS(13400),
    [sym__pipe_left_operator] = ACTIONS(13400),
    [sym__ellipsis_operator] = ACTIONS(13400),
    [sym__plus_operator] = ACTIONS(13400),
    [sym__times_operator] = ACTIONS(13400),
    [sym__rational_operator] = ACTIONS(13400),
    [sym__bitshift_operator] = ACTIONS(13400),
    [sym__power_operator] = ACTIONS(13400),
    [sym__tilde_operator] = ACTIONS(13400),
    [sym__type_order_operator] = ACTIONS(13400),
    [sym__unary_operator] = ACTIONS(13400),
    [sym__unary_plus_operator] = ACTIONS(13400),
    [aux_sym__terminator_token1] = ACTIONS(13400),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13402),
    [sym__command_start] = ACTIONS(13402),
  },
  [7379] = {
    [aux_sym_open_tuple_repeat1] = STATE(7379),
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13404),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_end] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13070),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_catch] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(13070),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13070),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(13070),
    [anon_sym_isa] = ACTIONS(13070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13070),
    [anon_sym_QMARK] = ACTIONS(13070),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(13070),
    [sym__arrow_operator] = ACTIONS(13070),
    [sym__lazy_or_operator] = ACTIONS(13070),
    [sym__lazy_and_operator] = ACTIONS(13070),
    [sym__comparison_operator] = ACTIONS(13070),
    [sym__pipe_right_operator] = ACTIONS(13070),
    [sym__pipe_left_operator] = ACTIONS(13070),
    [sym__ellipsis_operator] = ACTIONS(13070),
    [sym__plus_operator] = ACTIONS(13070),
    [sym__times_operator] = ACTIONS(13070),
    [sym__rational_operator] = ACTIONS(13070),
    [sym__bitshift_operator] = ACTIONS(13070),
    [sym__power_operator] = ACTIONS(13070),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(13070),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13070),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [7380] = {
    [sym__word_identifier] = ACTIONS(13316),
    [anon_sym_EQ] = ACTIONS(13316),
    [anon_sym_COMMA] = ACTIONS(13316),
    [anon_sym_COLON] = ACTIONS(13316),
    [anon_sym_begin] = ACTIONS(13316),
    [anon_sym_module] = ACTIONS(13316),
    [anon_sym_baremodule] = ACTIONS(13316),
    [anon_sym_end] = ACTIONS(13316),
    [anon_sym_abstract] = ACTIONS(13316),
    [anon_sym_primitive] = ACTIONS(13316),
    [anon_sym_mutable] = ACTIONS(13316),
    [anon_sym_struct] = ACTIONS(13316),
    [anon_sym_function] = ACTIONS(13316),
    [anon_sym_macro] = ACTIONS(13316),
    [anon_sym_where] = ACTIONS(13316),
    [anon_sym_quote] = ACTIONS(13316),
    [anon_sym_let] = ACTIONS(13316),
    [anon_sym_if] = ACTIONS(13316),
    [anon_sym_else] = ACTIONS(13316),
    [anon_sym_try] = ACTIONS(13316),
    [anon_sym_finally] = ACTIONS(13316),
    [anon_sym_for] = ACTIONS(13316),
    [anon_sym_while] = ACTIONS(13316),
    [sym_break_statement] = ACTIONS(13316),
    [sym_continue_statement] = ACTIONS(13316),
    [anon_sym_return] = ACTIONS(13316),
    [anon_sym_const] = ACTIONS(13316),
    [anon_sym_global] = ACTIONS(13316),
    [anon_sym_local] = ACTIONS(13316),
    [anon_sym_LPAREN] = ACTIONS(13316),
    [anon_sym_COLON2] = ACTIONS(13316),
    [anon_sym_export] = ACTIONS(13316),
    [anon_sym_import] = ACTIONS(13316),
    [anon_sym_using] = ACTIONS(13316),
    [anon_sym_LBRACK] = ACTIONS(13316),
    [anon_sym_LF] = ACTIONS(13318),
    [anon_sym_in] = ACTIONS(13316),
    [anon_sym_LBRACE] = ACTIONS(13316),
    [anon_sym_DOLLAR] = ACTIONS(13316),
    [anon_sym_COLON_COLON] = ACTIONS(13316),
    [anon_sym_isa] = ACTIONS(13316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13316),
    [anon_sym_QMARK] = ACTIONS(13316),
    [anon_sym_AT] = ACTIONS(13316),
    [anon_sym_true] = ACTIONS(13316),
    [anon_sym_false] = ACTIONS(13316),
    [aux_sym_integer_literal_token1] = ACTIONS(13316),
    [aux_sym_integer_literal_token2] = ACTIONS(13316),
    [aux_sym_integer_literal_token3] = ACTIONS(13316),
    [aux_sym_integer_literal_token4] = ACTIONS(13316),
    [aux_sym_float_literal_token1] = ACTIONS(13316),
    [aux_sym_float_literal_token3] = ACTIONS(13316),
    [aux_sym_float_literal_token4] = ACTIONS(13316),
    [sym_character_literal] = ACTIONS(13316),
    [sym__pair_operator] = ACTIONS(13316),
    [sym__arrow_operator] = ACTIONS(13316),
    [sym__lazy_or_operator] = ACTIONS(13316),
    [sym__lazy_and_operator] = ACTIONS(13316),
    [sym__comparison_operator] = ACTIONS(13316),
    [sym__pipe_right_operator] = ACTIONS(13316),
    [sym__pipe_left_operator] = ACTIONS(13316),
    [sym__ellipsis_operator] = ACTIONS(13316),
    [sym__plus_operator] = ACTIONS(13316),
    [sym__times_operator] = ACTIONS(13316),
    [sym__rational_operator] = ACTIONS(13316),
    [sym__bitshift_operator] = ACTIONS(13316),
    [sym__power_operator] = ACTIONS(13316),
    [sym__tilde_operator] = ACTIONS(13316),
    [sym__type_order_operator] = ACTIONS(13316),
    [sym__unary_operator] = ACTIONS(13316),
    [sym__unary_plus_operator] = ACTIONS(13316),
    [aux_sym__terminator_token1] = ACTIONS(13316),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13318),
    [sym__command_start] = ACTIONS(13318),
  },
  [7381] = {
    [sym__word_identifier] = ACTIONS(13320),
    [anon_sym_EQ] = ACTIONS(13320),
    [anon_sym_COMMA] = ACTIONS(13320),
    [anon_sym_COLON] = ACTIONS(13320),
    [anon_sym_begin] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(13320),
    [anon_sym_baremodule] = ACTIONS(13320),
    [anon_sym_end] = ACTIONS(13320),
    [anon_sym_abstract] = ACTIONS(13320),
    [anon_sym_primitive] = ACTIONS(13320),
    [anon_sym_mutable] = ACTIONS(13320),
    [anon_sym_struct] = ACTIONS(13320),
    [anon_sym_function] = ACTIONS(13320),
    [anon_sym_macro] = ACTIONS(13320),
    [anon_sym_where] = ACTIONS(13320),
    [anon_sym_quote] = ACTIONS(13320),
    [anon_sym_let] = ACTIONS(13320),
    [anon_sym_if] = ACTIONS(13320),
    [anon_sym_else] = ACTIONS(13320),
    [anon_sym_try] = ACTIONS(13320),
    [anon_sym_finally] = ACTIONS(13320),
    [anon_sym_for] = ACTIONS(13320),
    [anon_sym_while] = ACTIONS(13320),
    [sym_break_statement] = ACTIONS(13320),
    [sym_continue_statement] = ACTIONS(13320),
    [anon_sym_return] = ACTIONS(13320),
    [anon_sym_const] = ACTIONS(13320),
    [anon_sym_global] = ACTIONS(13320),
    [anon_sym_local] = ACTIONS(13320),
    [anon_sym_LPAREN] = ACTIONS(13320),
    [anon_sym_COLON2] = ACTIONS(13320),
    [anon_sym_export] = ACTIONS(13320),
    [anon_sym_import] = ACTIONS(13320),
    [anon_sym_using] = ACTIONS(13320),
    [anon_sym_LBRACK] = ACTIONS(13320),
    [anon_sym_LF] = ACTIONS(13322),
    [anon_sym_in] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(13320),
    [anon_sym_DOLLAR] = ACTIONS(13320),
    [anon_sym_COLON_COLON] = ACTIONS(13320),
    [anon_sym_isa] = ACTIONS(13320),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13320),
    [anon_sym_QMARK] = ACTIONS(13320),
    [anon_sym_AT] = ACTIONS(13320),
    [anon_sym_true] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(13320),
    [aux_sym_integer_literal_token1] = ACTIONS(13320),
    [aux_sym_integer_literal_token2] = ACTIONS(13320),
    [aux_sym_integer_literal_token3] = ACTIONS(13320),
    [aux_sym_integer_literal_token4] = ACTIONS(13320),
    [aux_sym_float_literal_token1] = ACTIONS(13320),
    [aux_sym_float_literal_token3] = ACTIONS(13320),
    [aux_sym_float_literal_token4] = ACTIONS(13320),
    [sym_character_literal] = ACTIONS(13320),
    [sym__pair_operator] = ACTIONS(13320),
    [sym__arrow_operator] = ACTIONS(13320),
    [sym__lazy_or_operator] = ACTIONS(13320),
    [sym__lazy_and_operator] = ACTIONS(13320),
    [sym__comparison_operator] = ACTIONS(13320),
    [sym__pipe_right_operator] = ACTIONS(13320),
    [sym__pipe_left_operator] = ACTIONS(13320),
    [sym__ellipsis_operator] = ACTIONS(13320),
    [sym__plus_operator] = ACTIONS(13320),
    [sym__times_operator] = ACTIONS(13320),
    [sym__rational_operator] = ACTIONS(13320),
    [sym__bitshift_operator] = ACTIONS(13320),
    [sym__power_operator] = ACTIONS(13320),
    [sym__tilde_operator] = ACTIONS(13320),
    [sym__type_order_operator] = ACTIONS(13320),
    [sym__unary_operator] = ACTIONS(13320),
    [sym__unary_plus_operator] = ACTIONS(13320),
    [aux_sym__terminator_token1] = ACTIONS(13320),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13322),
    [sym__command_start] = ACTIONS(13322),
  },
  [7382] = {
    [sym__word_identifier] = ACTIONS(13407),
    [anon_sym_EQ] = ACTIONS(13407),
    [anon_sym_COMMA] = ACTIONS(13407),
    [anon_sym_COLON] = ACTIONS(13407),
    [anon_sym_begin] = ACTIONS(13407),
    [anon_sym_module] = ACTIONS(13407),
    [anon_sym_baremodule] = ACTIONS(13407),
    [anon_sym_end] = ACTIONS(13407),
    [anon_sym_abstract] = ACTIONS(13407),
    [anon_sym_primitive] = ACTIONS(13407),
    [anon_sym_mutable] = ACTIONS(13407),
    [anon_sym_struct] = ACTIONS(13407),
    [anon_sym_function] = ACTIONS(13407),
    [anon_sym_macro] = ACTIONS(13407),
    [anon_sym_where] = ACTIONS(13407),
    [anon_sym_quote] = ACTIONS(13407),
    [anon_sym_let] = ACTIONS(13407),
    [anon_sym_if] = ACTIONS(13407),
    [anon_sym_elseif] = ACTIONS(13407),
    [anon_sym_else] = ACTIONS(13407),
    [anon_sym_try] = ACTIONS(13407),
    [anon_sym_for] = ACTIONS(13407),
    [anon_sym_while] = ACTIONS(13407),
    [sym_break_statement] = ACTIONS(13407),
    [sym_continue_statement] = ACTIONS(13407),
    [anon_sym_return] = ACTIONS(13407),
    [anon_sym_const] = ACTIONS(13407),
    [anon_sym_global] = ACTIONS(13407),
    [anon_sym_local] = ACTIONS(13407),
    [anon_sym_LPAREN] = ACTIONS(13407),
    [anon_sym_COLON2] = ACTIONS(13407),
    [anon_sym_export] = ACTIONS(13407),
    [anon_sym_import] = ACTIONS(13407),
    [anon_sym_using] = ACTIONS(13407),
    [anon_sym_LBRACK] = ACTIONS(13407),
    [anon_sym_LF] = ACTIONS(13409),
    [anon_sym_in] = ACTIONS(13407),
    [anon_sym_LBRACE] = ACTIONS(13407),
    [anon_sym_DOLLAR] = ACTIONS(13407),
    [anon_sym_COLON_COLON] = ACTIONS(13407),
    [anon_sym_isa] = ACTIONS(13407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13407),
    [anon_sym_QMARK] = ACTIONS(13407),
    [anon_sym_AT] = ACTIONS(13407),
    [anon_sym_true] = ACTIONS(13407),
    [anon_sym_false] = ACTIONS(13407),
    [aux_sym_integer_literal_token1] = ACTIONS(13407),
    [aux_sym_integer_literal_token2] = ACTIONS(13407),
    [aux_sym_integer_literal_token3] = ACTIONS(13407),
    [aux_sym_integer_literal_token4] = ACTIONS(13407),
    [aux_sym_float_literal_token1] = ACTIONS(13407),
    [aux_sym_float_literal_token3] = ACTIONS(13407),
    [aux_sym_float_literal_token4] = ACTIONS(13407),
    [sym_character_literal] = ACTIONS(13407),
    [sym__pair_operator] = ACTIONS(13407),
    [sym__arrow_operator] = ACTIONS(13407),
    [sym__lazy_or_operator] = ACTIONS(13407),
    [sym__lazy_and_operator] = ACTIONS(13407),
    [sym__comparison_operator] = ACTIONS(13407),
    [sym__pipe_right_operator] = ACTIONS(13407),
    [sym__pipe_left_operator] = ACTIONS(13407),
    [sym__ellipsis_operator] = ACTIONS(13407),
    [sym__plus_operator] = ACTIONS(13407),
    [sym__times_operator] = ACTIONS(13407),
    [sym__rational_operator] = ACTIONS(13407),
    [sym__bitshift_operator] = ACTIONS(13407),
    [sym__power_operator] = ACTIONS(13407),
    [sym__tilde_operator] = ACTIONS(13407),
    [sym__type_order_operator] = ACTIONS(13407),
    [sym__unary_operator] = ACTIONS(13407),
    [sym__unary_plus_operator] = ACTIONS(13407),
    [aux_sym__terminator_token1] = ACTIONS(13407),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13409),
    [sym__command_start] = ACTIONS(13409),
  },
  [7383] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_else] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7384] = {
    [aux_sym_open_tuple_repeat1] = STATE(7247),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13194),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_else] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13282),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7385] = {
    [sym__word_identifier] = ACTIONS(13326),
    [anon_sym_EQ] = ACTIONS(13326),
    [anon_sym_COMMA] = ACTIONS(13326),
    [anon_sym_COLON] = ACTIONS(13326),
    [anon_sym_begin] = ACTIONS(13326),
    [anon_sym_module] = ACTIONS(13326),
    [anon_sym_baremodule] = ACTIONS(13326),
    [anon_sym_end] = ACTIONS(13326),
    [anon_sym_abstract] = ACTIONS(13326),
    [anon_sym_primitive] = ACTIONS(13326),
    [anon_sym_mutable] = ACTIONS(13326),
    [anon_sym_struct] = ACTIONS(13326),
    [anon_sym_function] = ACTIONS(13326),
    [anon_sym_macro] = ACTIONS(13326),
    [anon_sym_where] = ACTIONS(13326),
    [anon_sym_quote] = ACTIONS(13326),
    [anon_sym_let] = ACTIONS(13326),
    [anon_sym_if] = ACTIONS(13326),
    [anon_sym_else] = ACTIONS(13326),
    [anon_sym_try] = ACTIONS(13326),
    [anon_sym_finally] = ACTIONS(13326),
    [anon_sym_for] = ACTIONS(13326),
    [anon_sym_while] = ACTIONS(13326),
    [sym_break_statement] = ACTIONS(13326),
    [sym_continue_statement] = ACTIONS(13326),
    [anon_sym_return] = ACTIONS(13326),
    [anon_sym_const] = ACTIONS(13326),
    [anon_sym_global] = ACTIONS(13326),
    [anon_sym_local] = ACTIONS(13326),
    [anon_sym_LPAREN] = ACTIONS(13326),
    [anon_sym_COLON2] = ACTIONS(13326),
    [anon_sym_export] = ACTIONS(13326),
    [anon_sym_import] = ACTIONS(13326),
    [anon_sym_using] = ACTIONS(13326),
    [anon_sym_LBRACK] = ACTIONS(13326),
    [anon_sym_LF] = ACTIONS(13328),
    [anon_sym_in] = ACTIONS(13326),
    [anon_sym_LBRACE] = ACTIONS(13326),
    [anon_sym_DOLLAR] = ACTIONS(13326),
    [anon_sym_COLON_COLON] = ACTIONS(13326),
    [anon_sym_isa] = ACTIONS(13326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13326),
    [anon_sym_QMARK] = ACTIONS(13326),
    [anon_sym_AT] = ACTIONS(13326),
    [anon_sym_true] = ACTIONS(13326),
    [anon_sym_false] = ACTIONS(13326),
    [aux_sym_integer_literal_token1] = ACTIONS(13326),
    [aux_sym_integer_literal_token2] = ACTIONS(13326),
    [aux_sym_integer_literal_token3] = ACTIONS(13326),
    [aux_sym_integer_literal_token4] = ACTIONS(13326),
    [aux_sym_float_literal_token1] = ACTIONS(13326),
    [aux_sym_float_literal_token3] = ACTIONS(13326),
    [aux_sym_float_literal_token4] = ACTIONS(13326),
    [sym_character_literal] = ACTIONS(13326),
    [sym__pair_operator] = ACTIONS(13326),
    [sym__arrow_operator] = ACTIONS(13326),
    [sym__lazy_or_operator] = ACTIONS(13326),
    [sym__lazy_and_operator] = ACTIONS(13326),
    [sym__comparison_operator] = ACTIONS(13326),
    [sym__pipe_right_operator] = ACTIONS(13326),
    [sym__pipe_left_operator] = ACTIONS(13326),
    [sym__ellipsis_operator] = ACTIONS(13326),
    [sym__plus_operator] = ACTIONS(13326),
    [sym__times_operator] = ACTIONS(13326),
    [sym__rational_operator] = ACTIONS(13326),
    [sym__bitshift_operator] = ACTIONS(13326),
    [sym__power_operator] = ACTIONS(13326),
    [sym__tilde_operator] = ACTIONS(13326),
    [sym__type_order_operator] = ACTIONS(13326),
    [sym__unary_operator] = ACTIONS(13326),
    [sym__unary_plus_operator] = ACTIONS(13326),
    [aux_sym__terminator_token1] = ACTIONS(13326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13328),
    [sym__command_start] = ACTIONS(13328),
  },
  [7386] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_else] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7387] = {
    [aux_sym_open_tuple_repeat1] = STATE(7247),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13194),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_else] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13282),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7388] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_else] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7389] = {
    [aux_sym_open_tuple_repeat1] = STATE(7247),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(13194),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_else] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13282),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7390] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11946),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7391] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12570),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7392] = {
    [sym__word_identifier] = ACTIONS(13330),
    [anon_sym_EQ] = ACTIONS(13330),
    [anon_sym_COMMA] = ACTIONS(13330),
    [anon_sym_COLON] = ACTIONS(13330),
    [anon_sym_begin] = ACTIONS(13330),
    [anon_sym_module] = ACTIONS(13330),
    [anon_sym_baremodule] = ACTIONS(13330),
    [anon_sym_end] = ACTIONS(13330),
    [anon_sym_abstract] = ACTIONS(13330),
    [anon_sym_primitive] = ACTIONS(13330),
    [anon_sym_mutable] = ACTIONS(13330),
    [anon_sym_struct] = ACTIONS(13330),
    [anon_sym_function] = ACTIONS(13330),
    [anon_sym_macro] = ACTIONS(13330),
    [anon_sym_where] = ACTIONS(13330),
    [anon_sym_quote] = ACTIONS(13330),
    [anon_sym_let] = ACTIONS(13330),
    [anon_sym_if] = ACTIONS(13330),
    [anon_sym_else] = ACTIONS(13330),
    [anon_sym_try] = ACTIONS(13330),
    [anon_sym_finally] = ACTIONS(13330),
    [anon_sym_for] = ACTIONS(13330),
    [anon_sym_while] = ACTIONS(13330),
    [sym_break_statement] = ACTIONS(13330),
    [sym_continue_statement] = ACTIONS(13330),
    [anon_sym_return] = ACTIONS(13330),
    [anon_sym_const] = ACTIONS(13330),
    [anon_sym_global] = ACTIONS(13330),
    [anon_sym_local] = ACTIONS(13330),
    [anon_sym_LPAREN] = ACTIONS(13330),
    [anon_sym_COLON2] = ACTIONS(13330),
    [anon_sym_export] = ACTIONS(13330),
    [anon_sym_import] = ACTIONS(13330),
    [anon_sym_using] = ACTIONS(13330),
    [anon_sym_LBRACK] = ACTIONS(13330),
    [anon_sym_LF] = ACTIONS(13332),
    [anon_sym_in] = ACTIONS(13330),
    [anon_sym_LBRACE] = ACTIONS(13330),
    [anon_sym_DOLLAR] = ACTIONS(13330),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_isa] = ACTIONS(13330),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13330),
    [anon_sym_QMARK] = ACTIONS(13330),
    [anon_sym_AT] = ACTIONS(13330),
    [anon_sym_true] = ACTIONS(13330),
    [anon_sym_false] = ACTIONS(13330),
    [aux_sym_integer_literal_token1] = ACTIONS(13330),
    [aux_sym_integer_literal_token2] = ACTIONS(13330),
    [aux_sym_integer_literal_token3] = ACTIONS(13330),
    [aux_sym_integer_literal_token4] = ACTIONS(13330),
    [aux_sym_float_literal_token1] = ACTIONS(13330),
    [aux_sym_float_literal_token3] = ACTIONS(13330),
    [aux_sym_float_literal_token4] = ACTIONS(13330),
    [sym_character_literal] = ACTIONS(13330),
    [sym__pair_operator] = ACTIONS(13330),
    [sym__arrow_operator] = ACTIONS(13330),
    [sym__lazy_or_operator] = ACTIONS(13330),
    [sym__lazy_and_operator] = ACTIONS(13330),
    [sym__comparison_operator] = ACTIONS(13330),
    [sym__pipe_right_operator] = ACTIONS(13330),
    [sym__pipe_left_operator] = ACTIONS(13330),
    [sym__ellipsis_operator] = ACTIONS(13330),
    [sym__plus_operator] = ACTIONS(13330),
    [sym__times_operator] = ACTIONS(13330),
    [sym__rational_operator] = ACTIONS(13330),
    [sym__bitshift_operator] = ACTIONS(13330),
    [sym__power_operator] = ACTIONS(13330),
    [sym__tilde_operator] = ACTIONS(13330),
    [sym__type_order_operator] = ACTIONS(13330),
    [sym__unary_operator] = ACTIONS(13330),
    [sym__unary_plus_operator] = ACTIONS(13330),
    [aux_sym__terminator_token1] = ACTIONS(13330),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13332),
    [sym__command_start] = ACTIONS(13332),
  },
  [7393] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_else] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_finally] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [7394] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(13306),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7395] = {
    [sym__word_identifier] = ACTIONS(13346),
    [anon_sym_EQ] = ACTIONS(13346),
    [anon_sym_COMMA] = ACTIONS(13346),
    [anon_sym_COLON] = ACTIONS(13346),
    [anon_sym_begin] = ACTIONS(13346),
    [anon_sym_module] = ACTIONS(13346),
    [anon_sym_baremodule] = ACTIONS(13346),
    [anon_sym_end] = ACTIONS(13346),
    [anon_sym_abstract] = ACTIONS(13346),
    [anon_sym_primitive] = ACTIONS(13346),
    [anon_sym_mutable] = ACTIONS(13346),
    [anon_sym_struct] = ACTIONS(13346),
    [anon_sym_function] = ACTIONS(13346),
    [anon_sym_macro] = ACTIONS(13346),
    [anon_sym_where] = ACTIONS(13346),
    [anon_sym_quote] = ACTIONS(13346),
    [anon_sym_let] = ACTIONS(13346),
    [anon_sym_if] = ACTIONS(13346),
    [anon_sym_else] = ACTIONS(13346),
    [anon_sym_try] = ACTIONS(13346),
    [anon_sym_finally] = ACTIONS(13346),
    [anon_sym_for] = ACTIONS(13346),
    [anon_sym_while] = ACTIONS(13346),
    [sym_break_statement] = ACTIONS(13346),
    [sym_continue_statement] = ACTIONS(13346),
    [anon_sym_return] = ACTIONS(13346),
    [anon_sym_const] = ACTIONS(13346),
    [anon_sym_global] = ACTIONS(13346),
    [anon_sym_local] = ACTIONS(13346),
    [anon_sym_LPAREN] = ACTIONS(13346),
    [anon_sym_COLON2] = ACTIONS(13346),
    [anon_sym_export] = ACTIONS(13346),
    [anon_sym_import] = ACTIONS(13346),
    [anon_sym_using] = ACTIONS(13346),
    [anon_sym_LBRACK] = ACTIONS(13346),
    [anon_sym_LF] = ACTIONS(13348),
    [anon_sym_in] = ACTIONS(13346),
    [anon_sym_LBRACE] = ACTIONS(13346),
    [anon_sym_DOLLAR] = ACTIONS(13346),
    [anon_sym_COLON_COLON] = ACTIONS(13346),
    [anon_sym_isa] = ACTIONS(13346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13346),
    [anon_sym_QMARK] = ACTIONS(13346),
    [anon_sym_AT] = ACTIONS(13346),
    [anon_sym_true] = ACTIONS(13346),
    [anon_sym_false] = ACTIONS(13346),
    [aux_sym_integer_literal_token1] = ACTIONS(13346),
    [aux_sym_integer_literal_token2] = ACTIONS(13346),
    [aux_sym_integer_literal_token3] = ACTIONS(13346),
    [aux_sym_integer_literal_token4] = ACTIONS(13346),
    [aux_sym_float_literal_token1] = ACTIONS(13346),
    [aux_sym_float_literal_token3] = ACTIONS(13346),
    [aux_sym_float_literal_token4] = ACTIONS(13346),
    [sym_character_literal] = ACTIONS(13346),
    [sym__pair_operator] = ACTIONS(13346),
    [sym__arrow_operator] = ACTIONS(13346),
    [sym__lazy_or_operator] = ACTIONS(13346),
    [sym__lazy_and_operator] = ACTIONS(13346),
    [sym__comparison_operator] = ACTIONS(13346),
    [sym__pipe_right_operator] = ACTIONS(13346),
    [sym__pipe_left_operator] = ACTIONS(13346),
    [sym__ellipsis_operator] = ACTIONS(13346),
    [sym__plus_operator] = ACTIONS(13346),
    [sym__times_operator] = ACTIONS(13346),
    [sym__rational_operator] = ACTIONS(13346),
    [sym__bitshift_operator] = ACTIONS(13346),
    [sym__power_operator] = ACTIONS(13346),
    [sym__tilde_operator] = ACTIONS(13346),
    [sym__type_order_operator] = ACTIONS(13346),
    [sym__unary_operator] = ACTIONS(13346),
    [sym__unary_plus_operator] = ACTIONS(13346),
    [aux_sym__terminator_token1] = ACTIONS(13346),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13348),
    [sym__command_start] = ACTIONS(13348),
  },
  [7396] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13411),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_else] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7397] = {
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13255),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_elseif] = ACTIONS(13255),
    [anon_sym_else] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13255),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13255),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13255),
    [anon_sym_isa] = ACTIONS(13255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13255),
    [anon_sym_QMARK] = ACTIONS(13255),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13255),
    [sym__arrow_operator] = ACTIONS(13255),
    [sym__lazy_or_operator] = ACTIONS(13255),
    [sym__lazy_and_operator] = ACTIONS(13255),
    [sym__comparison_operator] = ACTIONS(13255),
    [sym__pipe_right_operator] = ACTIONS(13255),
    [sym__pipe_left_operator] = ACTIONS(13255),
    [sym__ellipsis_operator] = ACTIONS(13255),
    [sym__plus_operator] = ACTIONS(13255),
    [sym__times_operator] = ACTIONS(13255),
    [sym__rational_operator] = ACTIONS(13255),
    [sym__bitshift_operator] = ACTIONS(13255),
    [sym__power_operator] = ACTIONS(13255),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13255),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13255),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [7398] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_catch] = ACTIONS(12618),
    [anon_sym_finally] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7399] = {
    [sym__word_identifier] = ACTIONS(13413),
    [anon_sym_EQ] = ACTIONS(13413),
    [anon_sym_COMMA] = ACTIONS(13413),
    [anon_sym_COLON] = ACTIONS(13413),
    [anon_sym_begin] = ACTIONS(13413),
    [anon_sym_module] = ACTIONS(13413),
    [anon_sym_baremodule] = ACTIONS(13413),
    [anon_sym_end] = ACTIONS(13413),
    [anon_sym_abstract] = ACTIONS(13413),
    [anon_sym_primitive] = ACTIONS(13413),
    [anon_sym_mutable] = ACTIONS(13413),
    [anon_sym_struct] = ACTIONS(13413),
    [anon_sym_function] = ACTIONS(13413),
    [anon_sym_macro] = ACTIONS(13413),
    [anon_sym_where] = ACTIONS(13413),
    [anon_sym_quote] = ACTIONS(13413),
    [anon_sym_let] = ACTIONS(13413),
    [anon_sym_if] = ACTIONS(13413),
    [anon_sym_elseif] = ACTIONS(13413),
    [anon_sym_else] = ACTIONS(13413),
    [anon_sym_try] = ACTIONS(13413),
    [anon_sym_for] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(13413),
    [sym_break_statement] = ACTIONS(13413),
    [sym_continue_statement] = ACTIONS(13413),
    [anon_sym_return] = ACTIONS(13413),
    [anon_sym_const] = ACTIONS(13413),
    [anon_sym_global] = ACTIONS(13413),
    [anon_sym_local] = ACTIONS(13413),
    [anon_sym_LPAREN] = ACTIONS(13413),
    [anon_sym_COLON2] = ACTIONS(13413),
    [anon_sym_export] = ACTIONS(13413),
    [anon_sym_import] = ACTIONS(13413),
    [anon_sym_using] = ACTIONS(13413),
    [anon_sym_LBRACK] = ACTIONS(13413),
    [anon_sym_LF] = ACTIONS(13415),
    [anon_sym_in] = ACTIONS(13413),
    [anon_sym_LBRACE] = ACTIONS(13413),
    [anon_sym_DOLLAR] = ACTIONS(13413),
    [anon_sym_COLON_COLON] = ACTIONS(13413),
    [anon_sym_isa] = ACTIONS(13413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_QMARK] = ACTIONS(13413),
    [anon_sym_AT] = ACTIONS(13413),
    [anon_sym_true] = ACTIONS(13413),
    [anon_sym_false] = ACTIONS(13413),
    [aux_sym_integer_literal_token1] = ACTIONS(13413),
    [aux_sym_integer_literal_token2] = ACTIONS(13413),
    [aux_sym_integer_literal_token3] = ACTIONS(13413),
    [aux_sym_integer_literal_token4] = ACTIONS(13413),
    [aux_sym_float_literal_token1] = ACTIONS(13413),
    [aux_sym_float_literal_token3] = ACTIONS(13413),
    [aux_sym_float_literal_token4] = ACTIONS(13413),
    [sym_character_literal] = ACTIONS(13413),
    [sym__pair_operator] = ACTIONS(13413),
    [sym__arrow_operator] = ACTIONS(13413),
    [sym__lazy_or_operator] = ACTIONS(13413),
    [sym__lazy_and_operator] = ACTIONS(13413),
    [sym__comparison_operator] = ACTIONS(13413),
    [sym__pipe_right_operator] = ACTIONS(13413),
    [sym__pipe_left_operator] = ACTIONS(13413),
    [sym__ellipsis_operator] = ACTIONS(13413),
    [sym__plus_operator] = ACTIONS(13413),
    [sym__times_operator] = ACTIONS(13413),
    [sym__rational_operator] = ACTIONS(13413),
    [sym__bitshift_operator] = ACTIONS(13413),
    [sym__power_operator] = ACTIONS(13413),
    [sym__tilde_operator] = ACTIONS(13413),
    [sym__type_order_operator] = ACTIONS(13413),
    [sym__unary_operator] = ACTIONS(13413),
    [sym__unary_plus_operator] = ACTIONS(13413),
    [aux_sym__terminator_token1] = ACTIONS(13413),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13415),
    [sym__command_start] = ACTIONS(13415),
  },
  [7400] = {
    [sym__word_identifier] = ACTIONS(13417),
    [anon_sym_EQ] = ACTIONS(13417),
    [anon_sym_COMMA] = ACTIONS(13417),
    [anon_sym_COLON] = ACTIONS(13417),
    [anon_sym_begin] = ACTIONS(13417),
    [anon_sym_module] = ACTIONS(13417),
    [anon_sym_baremodule] = ACTIONS(13417),
    [anon_sym_end] = ACTIONS(13417),
    [anon_sym_abstract] = ACTIONS(13417),
    [anon_sym_primitive] = ACTIONS(13417),
    [anon_sym_mutable] = ACTIONS(13417),
    [anon_sym_struct] = ACTIONS(13417),
    [anon_sym_function] = ACTIONS(13417),
    [anon_sym_macro] = ACTIONS(13417),
    [anon_sym_where] = ACTIONS(13417),
    [anon_sym_quote] = ACTIONS(13417),
    [anon_sym_let] = ACTIONS(13417),
    [anon_sym_if] = ACTIONS(13417),
    [anon_sym_elseif] = ACTIONS(13417),
    [anon_sym_else] = ACTIONS(13417),
    [anon_sym_try] = ACTIONS(13417),
    [anon_sym_for] = ACTIONS(13417),
    [anon_sym_while] = ACTIONS(13417),
    [sym_break_statement] = ACTIONS(13417),
    [sym_continue_statement] = ACTIONS(13417),
    [anon_sym_return] = ACTIONS(13417),
    [anon_sym_const] = ACTIONS(13417),
    [anon_sym_global] = ACTIONS(13417),
    [anon_sym_local] = ACTIONS(13417),
    [anon_sym_LPAREN] = ACTIONS(13417),
    [anon_sym_COLON2] = ACTIONS(13417),
    [anon_sym_export] = ACTIONS(13417),
    [anon_sym_import] = ACTIONS(13417),
    [anon_sym_using] = ACTIONS(13417),
    [anon_sym_LBRACK] = ACTIONS(13417),
    [anon_sym_LF] = ACTIONS(13419),
    [anon_sym_in] = ACTIONS(13417),
    [anon_sym_LBRACE] = ACTIONS(13417),
    [anon_sym_DOLLAR] = ACTIONS(13417),
    [anon_sym_COLON_COLON] = ACTIONS(13417),
    [anon_sym_isa] = ACTIONS(13417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13417),
    [anon_sym_QMARK] = ACTIONS(13417),
    [anon_sym_AT] = ACTIONS(13417),
    [anon_sym_true] = ACTIONS(13417),
    [anon_sym_false] = ACTIONS(13417),
    [aux_sym_integer_literal_token1] = ACTIONS(13417),
    [aux_sym_integer_literal_token2] = ACTIONS(13417),
    [aux_sym_integer_literal_token3] = ACTIONS(13417),
    [aux_sym_integer_literal_token4] = ACTIONS(13417),
    [aux_sym_float_literal_token1] = ACTIONS(13417),
    [aux_sym_float_literal_token3] = ACTIONS(13417),
    [aux_sym_float_literal_token4] = ACTIONS(13417),
    [sym_character_literal] = ACTIONS(13417),
    [sym__pair_operator] = ACTIONS(13417),
    [sym__arrow_operator] = ACTIONS(13417),
    [sym__lazy_or_operator] = ACTIONS(13417),
    [sym__lazy_and_operator] = ACTIONS(13417),
    [sym__comparison_operator] = ACTIONS(13417),
    [sym__pipe_right_operator] = ACTIONS(13417),
    [sym__pipe_left_operator] = ACTIONS(13417),
    [sym__ellipsis_operator] = ACTIONS(13417),
    [sym__plus_operator] = ACTIONS(13417),
    [sym__times_operator] = ACTIONS(13417),
    [sym__rational_operator] = ACTIONS(13417),
    [sym__bitshift_operator] = ACTIONS(13417),
    [sym__power_operator] = ACTIONS(13417),
    [sym__tilde_operator] = ACTIONS(13417),
    [sym__type_order_operator] = ACTIONS(13417),
    [sym__unary_operator] = ACTIONS(13417),
    [sym__unary_plus_operator] = ACTIONS(13417),
    [aux_sym__terminator_token1] = ACTIONS(13417),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13419),
    [sym__command_start] = ACTIONS(13419),
  },
  [7401] = {
    [sym__word_identifier] = ACTIONS(13421),
    [anon_sym_EQ] = ACTIONS(13421),
    [anon_sym_COMMA] = ACTIONS(13421),
    [anon_sym_COLON] = ACTIONS(13421),
    [anon_sym_begin] = ACTIONS(13421),
    [anon_sym_module] = ACTIONS(13421),
    [anon_sym_baremodule] = ACTIONS(13421),
    [anon_sym_end] = ACTIONS(13421),
    [anon_sym_abstract] = ACTIONS(13421),
    [anon_sym_primitive] = ACTIONS(13421),
    [anon_sym_mutable] = ACTIONS(13421),
    [anon_sym_struct] = ACTIONS(13421),
    [anon_sym_function] = ACTIONS(13421),
    [anon_sym_macro] = ACTIONS(13421),
    [anon_sym_where] = ACTIONS(13421),
    [anon_sym_quote] = ACTIONS(13421),
    [anon_sym_let] = ACTIONS(13421),
    [anon_sym_if] = ACTIONS(13421),
    [anon_sym_elseif] = ACTIONS(13421),
    [anon_sym_else] = ACTIONS(13421),
    [anon_sym_try] = ACTIONS(13421),
    [anon_sym_for] = ACTIONS(13421),
    [anon_sym_while] = ACTIONS(13421),
    [sym_break_statement] = ACTIONS(13421),
    [sym_continue_statement] = ACTIONS(13421),
    [anon_sym_return] = ACTIONS(13421),
    [anon_sym_const] = ACTIONS(13421),
    [anon_sym_global] = ACTIONS(13421),
    [anon_sym_local] = ACTIONS(13421),
    [anon_sym_LPAREN] = ACTIONS(13421),
    [anon_sym_COLON2] = ACTIONS(13421),
    [anon_sym_export] = ACTIONS(13421),
    [anon_sym_import] = ACTIONS(13421),
    [anon_sym_using] = ACTIONS(13421),
    [anon_sym_LBRACK] = ACTIONS(13421),
    [anon_sym_LF] = ACTIONS(13423),
    [anon_sym_in] = ACTIONS(13421),
    [anon_sym_LBRACE] = ACTIONS(13421),
    [anon_sym_DOLLAR] = ACTIONS(13421),
    [anon_sym_COLON_COLON] = ACTIONS(13421),
    [anon_sym_isa] = ACTIONS(13421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13421),
    [anon_sym_QMARK] = ACTIONS(13421),
    [anon_sym_AT] = ACTIONS(13421),
    [anon_sym_true] = ACTIONS(13421),
    [anon_sym_false] = ACTIONS(13421),
    [aux_sym_integer_literal_token1] = ACTIONS(13421),
    [aux_sym_integer_literal_token2] = ACTIONS(13421),
    [aux_sym_integer_literal_token3] = ACTIONS(13421),
    [aux_sym_integer_literal_token4] = ACTIONS(13421),
    [aux_sym_float_literal_token1] = ACTIONS(13421),
    [aux_sym_float_literal_token3] = ACTIONS(13421),
    [aux_sym_float_literal_token4] = ACTIONS(13421),
    [sym_character_literal] = ACTIONS(13421),
    [sym__pair_operator] = ACTIONS(13421),
    [sym__arrow_operator] = ACTIONS(13421),
    [sym__lazy_or_operator] = ACTIONS(13421),
    [sym__lazy_and_operator] = ACTIONS(13421),
    [sym__comparison_operator] = ACTIONS(13421),
    [sym__pipe_right_operator] = ACTIONS(13421),
    [sym__pipe_left_operator] = ACTIONS(13421),
    [sym__ellipsis_operator] = ACTIONS(13421),
    [sym__plus_operator] = ACTIONS(13421),
    [sym__times_operator] = ACTIONS(13421),
    [sym__rational_operator] = ACTIONS(13421),
    [sym__bitshift_operator] = ACTIONS(13421),
    [sym__power_operator] = ACTIONS(13421),
    [sym__tilde_operator] = ACTIONS(13421),
    [sym__type_order_operator] = ACTIONS(13421),
    [sym__unary_operator] = ACTIONS(13421),
    [sym__unary_plus_operator] = ACTIONS(13421),
    [aux_sym__terminator_token1] = ACTIONS(13421),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13423),
    [sym__command_start] = ACTIONS(13423),
  },
  [7402] = {
    [sym__word_identifier] = ACTIONS(13425),
    [anon_sym_EQ] = ACTIONS(13425),
    [anon_sym_COMMA] = ACTIONS(13425),
    [anon_sym_COLON] = ACTIONS(13425),
    [anon_sym_begin] = ACTIONS(13425),
    [anon_sym_module] = ACTIONS(13425),
    [anon_sym_baremodule] = ACTIONS(13425),
    [anon_sym_end] = ACTIONS(13425),
    [anon_sym_abstract] = ACTIONS(13425),
    [anon_sym_primitive] = ACTIONS(13425),
    [anon_sym_mutable] = ACTIONS(13425),
    [anon_sym_struct] = ACTIONS(13425),
    [anon_sym_function] = ACTIONS(13425),
    [anon_sym_macro] = ACTIONS(13425),
    [anon_sym_where] = ACTIONS(13425),
    [anon_sym_quote] = ACTIONS(13425),
    [anon_sym_let] = ACTIONS(13425),
    [anon_sym_if] = ACTIONS(13425),
    [anon_sym_elseif] = ACTIONS(13425),
    [anon_sym_else] = ACTIONS(13425),
    [anon_sym_try] = ACTIONS(13425),
    [anon_sym_for] = ACTIONS(13425),
    [anon_sym_while] = ACTIONS(13425),
    [sym_break_statement] = ACTIONS(13425),
    [sym_continue_statement] = ACTIONS(13425),
    [anon_sym_return] = ACTIONS(13425),
    [anon_sym_const] = ACTIONS(13425),
    [anon_sym_global] = ACTIONS(13425),
    [anon_sym_local] = ACTIONS(13425),
    [anon_sym_LPAREN] = ACTIONS(13425),
    [anon_sym_COLON2] = ACTIONS(13425),
    [anon_sym_export] = ACTIONS(13425),
    [anon_sym_import] = ACTIONS(13425),
    [anon_sym_using] = ACTIONS(13425),
    [anon_sym_LBRACK] = ACTIONS(13425),
    [anon_sym_LF] = ACTIONS(13427),
    [anon_sym_in] = ACTIONS(13425),
    [anon_sym_LBRACE] = ACTIONS(13425),
    [anon_sym_DOLLAR] = ACTIONS(13425),
    [anon_sym_COLON_COLON] = ACTIONS(13425),
    [anon_sym_isa] = ACTIONS(13425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13425),
    [anon_sym_QMARK] = ACTIONS(13425),
    [anon_sym_AT] = ACTIONS(13425),
    [anon_sym_true] = ACTIONS(13425),
    [anon_sym_false] = ACTIONS(13425),
    [aux_sym_integer_literal_token1] = ACTIONS(13425),
    [aux_sym_integer_literal_token2] = ACTIONS(13425),
    [aux_sym_integer_literal_token3] = ACTIONS(13425),
    [aux_sym_integer_literal_token4] = ACTIONS(13425),
    [aux_sym_float_literal_token1] = ACTIONS(13425),
    [aux_sym_float_literal_token3] = ACTIONS(13425),
    [aux_sym_float_literal_token4] = ACTIONS(13425),
    [sym_character_literal] = ACTIONS(13425),
    [sym__pair_operator] = ACTIONS(13425),
    [sym__arrow_operator] = ACTIONS(13425),
    [sym__lazy_or_operator] = ACTIONS(13425),
    [sym__lazy_and_operator] = ACTIONS(13425),
    [sym__comparison_operator] = ACTIONS(13425),
    [sym__pipe_right_operator] = ACTIONS(13425),
    [sym__pipe_left_operator] = ACTIONS(13425),
    [sym__ellipsis_operator] = ACTIONS(13425),
    [sym__plus_operator] = ACTIONS(13425),
    [sym__times_operator] = ACTIONS(13425),
    [sym__rational_operator] = ACTIONS(13425),
    [sym__bitshift_operator] = ACTIONS(13425),
    [sym__power_operator] = ACTIONS(13425),
    [sym__tilde_operator] = ACTIONS(13425),
    [sym__type_order_operator] = ACTIONS(13425),
    [sym__unary_operator] = ACTIONS(13425),
    [sym__unary_plus_operator] = ACTIONS(13425),
    [aux_sym__terminator_token1] = ACTIONS(13425),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13427),
    [sym__command_start] = ACTIONS(13427),
  },
  [7403] = {
    [sym__word_identifier] = ACTIONS(13429),
    [anon_sym_EQ] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(13429),
    [anon_sym_COLON] = ACTIONS(13429),
    [anon_sym_begin] = ACTIONS(13429),
    [anon_sym_module] = ACTIONS(13429),
    [anon_sym_baremodule] = ACTIONS(13429),
    [anon_sym_end] = ACTIONS(13429),
    [anon_sym_abstract] = ACTIONS(13429),
    [anon_sym_primitive] = ACTIONS(13429),
    [anon_sym_mutable] = ACTIONS(13429),
    [anon_sym_struct] = ACTIONS(13429),
    [anon_sym_function] = ACTIONS(13429),
    [anon_sym_macro] = ACTIONS(13429),
    [anon_sym_where] = ACTIONS(13429),
    [anon_sym_quote] = ACTIONS(13429),
    [anon_sym_let] = ACTIONS(13429),
    [anon_sym_if] = ACTIONS(13429),
    [anon_sym_elseif] = ACTIONS(13429),
    [anon_sym_else] = ACTIONS(13429),
    [anon_sym_try] = ACTIONS(13429),
    [anon_sym_for] = ACTIONS(13429),
    [anon_sym_while] = ACTIONS(13429),
    [sym_break_statement] = ACTIONS(13429),
    [sym_continue_statement] = ACTIONS(13429),
    [anon_sym_return] = ACTIONS(13429),
    [anon_sym_const] = ACTIONS(13429),
    [anon_sym_global] = ACTIONS(13429),
    [anon_sym_local] = ACTIONS(13429),
    [anon_sym_LPAREN] = ACTIONS(13429),
    [anon_sym_COLON2] = ACTIONS(13429),
    [anon_sym_export] = ACTIONS(13429),
    [anon_sym_import] = ACTIONS(13429),
    [anon_sym_using] = ACTIONS(13429),
    [anon_sym_LBRACK] = ACTIONS(13429),
    [anon_sym_LF] = ACTIONS(13431),
    [anon_sym_in] = ACTIONS(13429),
    [anon_sym_LBRACE] = ACTIONS(13429),
    [anon_sym_DOLLAR] = ACTIONS(13429),
    [anon_sym_COLON_COLON] = ACTIONS(13429),
    [anon_sym_isa] = ACTIONS(13429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13429),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_AT] = ACTIONS(13429),
    [anon_sym_true] = ACTIONS(13429),
    [anon_sym_false] = ACTIONS(13429),
    [aux_sym_integer_literal_token1] = ACTIONS(13429),
    [aux_sym_integer_literal_token2] = ACTIONS(13429),
    [aux_sym_integer_literal_token3] = ACTIONS(13429),
    [aux_sym_integer_literal_token4] = ACTIONS(13429),
    [aux_sym_float_literal_token1] = ACTIONS(13429),
    [aux_sym_float_literal_token3] = ACTIONS(13429),
    [aux_sym_float_literal_token4] = ACTIONS(13429),
    [sym_character_literal] = ACTIONS(13429),
    [sym__pair_operator] = ACTIONS(13429),
    [sym__arrow_operator] = ACTIONS(13429),
    [sym__lazy_or_operator] = ACTIONS(13429),
    [sym__lazy_and_operator] = ACTIONS(13429),
    [sym__comparison_operator] = ACTIONS(13429),
    [sym__pipe_right_operator] = ACTIONS(13429),
    [sym__pipe_left_operator] = ACTIONS(13429),
    [sym__ellipsis_operator] = ACTIONS(13429),
    [sym__plus_operator] = ACTIONS(13429),
    [sym__times_operator] = ACTIONS(13429),
    [sym__rational_operator] = ACTIONS(13429),
    [sym__bitshift_operator] = ACTIONS(13429),
    [sym__power_operator] = ACTIONS(13429),
    [sym__tilde_operator] = ACTIONS(13429),
    [sym__type_order_operator] = ACTIONS(13429),
    [sym__unary_operator] = ACTIONS(13429),
    [sym__unary_plus_operator] = ACTIONS(13429),
    [aux_sym__terminator_token1] = ACTIONS(13429),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13431),
    [sym__command_start] = ACTIONS(13431),
  },
  [7404] = {
    [sym__word_identifier] = ACTIONS(13433),
    [anon_sym_EQ] = ACTIONS(13433),
    [anon_sym_COMMA] = ACTIONS(13433),
    [anon_sym_COLON] = ACTIONS(13433),
    [anon_sym_begin] = ACTIONS(13433),
    [anon_sym_module] = ACTIONS(13433),
    [anon_sym_baremodule] = ACTIONS(13433),
    [anon_sym_end] = ACTIONS(13433),
    [anon_sym_abstract] = ACTIONS(13433),
    [anon_sym_primitive] = ACTIONS(13433),
    [anon_sym_mutable] = ACTIONS(13433),
    [anon_sym_struct] = ACTIONS(13433),
    [anon_sym_function] = ACTIONS(13433),
    [anon_sym_macro] = ACTIONS(13433),
    [anon_sym_where] = ACTIONS(13433),
    [anon_sym_quote] = ACTIONS(13433),
    [anon_sym_let] = ACTIONS(13433),
    [anon_sym_if] = ACTIONS(13433),
    [anon_sym_elseif] = ACTIONS(13433),
    [anon_sym_else] = ACTIONS(13433),
    [anon_sym_try] = ACTIONS(13433),
    [anon_sym_for] = ACTIONS(13433),
    [anon_sym_while] = ACTIONS(13433),
    [sym_break_statement] = ACTIONS(13433),
    [sym_continue_statement] = ACTIONS(13433),
    [anon_sym_return] = ACTIONS(13433),
    [anon_sym_const] = ACTIONS(13433),
    [anon_sym_global] = ACTIONS(13433),
    [anon_sym_local] = ACTIONS(13433),
    [anon_sym_LPAREN] = ACTIONS(13433),
    [anon_sym_COLON2] = ACTIONS(13433),
    [anon_sym_export] = ACTIONS(13433),
    [anon_sym_import] = ACTIONS(13433),
    [anon_sym_using] = ACTIONS(13433),
    [anon_sym_LBRACK] = ACTIONS(13433),
    [anon_sym_LF] = ACTIONS(13435),
    [anon_sym_in] = ACTIONS(13433),
    [anon_sym_LBRACE] = ACTIONS(13433),
    [anon_sym_DOLLAR] = ACTIONS(13433),
    [anon_sym_COLON_COLON] = ACTIONS(13433),
    [anon_sym_isa] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13433),
    [anon_sym_QMARK] = ACTIONS(13433),
    [anon_sym_AT] = ACTIONS(13433),
    [anon_sym_true] = ACTIONS(13433),
    [anon_sym_false] = ACTIONS(13433),
    [aux_sym_integer_literal_token1] = ACTIONS(13433),
    [aux_sym_integer_literal_token2] = ACTIONS(13433),
    [aux_sym_integer_literal_token3] = ACTIONS(13433),
    [aux_sym_integer_literal_token4] = ACTIONS(13433),
    [aux_sym_float_literal_token1] = ACTIONS(13433),
    [aux_sym_float_literal_token3] = ACTIONS(13433),
    [aux_sym_float_literal_token4] = ACTIONS(13433),
    [sym_character_literal] = ACTIONS(13433),
    [sym__pair_operator] = ACTIONS(13433),
    [sym__arrow_operator] = ACTIONS(13433),
    [sym__lazy_or_operator] = ACTIONS(13433),
    [sym__lazy_and_operator] = ACTIONS(13433),
    [sym__comparison_operator] = ACTIONS(13433),
    [sym__pipe_right_operator] = ACTIONS(13433),
    [sym__pipe_left_operator] = ACTIONS(13433),
    [sym__ellipsis_operator] = ACTIONS(13433),
    [sym__plus_operator] = ACTIONS(13433),
    [sym__times_operator] = ACTIONS(13433),
    [sym__rational_operator] = ACTIONS(13433),
    [sym__bitshift_operator] = ACTIONS(13433),
    [sym__power_operator] = ACTIONS(13433),
    [sym__tilde_operator] = ACTIONS(13433),
    [sym__type_order_operator] = ACTIONS(13433),
    [sym__unary_operator] = ACTIONS(13433),
    [sym__unary_plus_operator] = ACTIONS(13433),
    [aux_sym__terminator_token1] = ACTIONS(13433),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13435),
    [sym__command_start] = ACTIONS(13435),
  },
  [7405] = {
    [sym__word_identifier] = ACTIONS(13358),
    [anon_sym_EQ] = ACTIONS(13358),
    [anon_sym_COMMA] = ACTIONS(13358),
    [anon_sym_COLON] = ACTIONS(13358),
    [anon_sym_begin] = ACTIONS(13358),
    [anon_sym_module] = ACTIONS(13358),
    [anon_sym_baremodule] = ACTIONS(13358),
    [anon_sym_end] = ACTIONS(13358),
    [anon_sym_abstract] = ACTIONS(13358),
    [anon_sym_primitive] = ACTIONS(13358),
    [anon_sym_mutable] = ACTIONS(13358),
    [anon_sym_struct] = ACTIONS(13358),
    [anon_sym_function] = ACTIONS(13358),
    [anon_sym_macro] = ACTIONS(13358),
    [anon_sym_where] = ACTIONS(13358),
    [anon_sym_quote] = ACTIONS(13358),
    [anon_sym_let] = ACTIONS(13358),
    [anon_sym_if] = ACTIONS(13358),
    [anon_sym_else] = ACTIONS(13358),
    [anon_sym_try] = ACTIONS(13358),
    [anon_sym_finally] = ACTIONS(13358),
    [anon_sym_for] = ACTIONS(13358),
    [anon_sym_while] = ACTIONS(13358),
    [sym_break_statement] = ACTIONS(13358),
    [sym_continue_statement] = ACTIONS(13358),
    [anon_sym_return] = ACTIONS(13358),
    [anon_sym_const] = ACTIONS(13358),
    [anon_sym_global] = ACTIONS(13358),
    [anon_sym_local] = ACTIONS(13358),
    [anon_sym_LPAREN] = ACTIONS(13358),
    [anon_sym_COLON2] = ACTIONS(13358),
    [anon_sym_export] = ACTIONS(13358),
    [anon_sym_import] = ACTIONS(13358),
    [anon_sym_using] = ACTIONS(13358),
    [anon_sym_LBRACK] = ACTIONS(13358),
    [anon_sym_LF] = ACTIONS(13360),
    [anon_sym_in] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(13358),
    [anon_sym_DOLLAR] = ACTIONS(13358),
    [anon_sym_COLON_COLON] = ACTIONS(13358),
    [anon_sym_isa] = ACTIONS(13358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13358),
    [anon_sym_QMARK] = ACTIONS(13358),
    [anon_sym_AT] = ACTIONS(13358),
    [anon_sym_true] = ACTIONS(13358),
    [anon_sym_false] = ACTIONS(13358),
    [aux_sym_integer_literal_token1] = ACTIONS(13358),
    [aux_sym_integer_literal_token2] = ACTIONS(13358),
    [aux_sym_integer_literal_token3] = ACTIONS(13358),
    [aux_sym_integer_literal_token4] = ACTIONS(13358),
    [aux_sym_float_literal_token1] = ACTIONS(13358),
    [aux_sym_float_literal_token3] = ACTIONS(13358),
    [aux_sym_float_literal_token4] = ACTIONS(13358),
    [sym_character_literal] = ACTIONS(13358),
    [sym__pair_operator] = ACTIONS(13358),
    [sym__arrow_operator] = ACTIONS(13358),
    [sym__lazy_or_operator] = ACTIONS(13358),
    [sym__lazy_and_operator] = ACTIONS(13358),
    [sym__comparison_operator] = ACTIONS(13358),
    [sym__pipe_right_operator] = ACTIONS(13358),
    [sym__pipe_left_operator] = ACTIONS(13358),
    [sym__ellipsis_operator] = ACTIONS(13358),
    [sym__plus_operator] = ACTIONS(13358),
    [sym__times_operator] = ACTIONS(13358),
    [sym__rational_operator] = ACTIONS(13358),
    [sym__bitshift_operator] = ACTIONS(13358),
    [sym__power_operator] = ACTIONS(13358),
    [sym__tilde_operator] = ACTIONS(13358),
    [sym__type_order_operator] = ACTIONS(13358),
    [sym__unary_operator] = ACTIONS(13358),
    [sym__unary_plus_operator] = ACTIONS(13358),
    [aux_sym__terminator_token1] = ACTIONS(13358),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13360),
    [sym__command_start] = ACTIONS(13360),
  },
  [7406] = {
    [sym__word_identifier] = ACTIONS(13437),
    [anon_sym_EQ] = ACTIONS(13437),
    [anon_sym_COMMA] = ACTIONS(13437),
    [anon_sym_COLON] = ACTIONS(13437),
    [anon_sym_begin] = ACTIONS(13437),
    [anon_sym_module] = ACTIONS(13437),
    [anon_sym_baremodule] = ACTIONS(13437),
    [anon_sym_end] = ACTIONS(13437),
    [anon_sym_abstract] = ACTIONS(13437),
    [anon_sym_primitive] = ACTIONS(13437),
    [anon_sym_mutable] = ACTIONS(13437),
    [anon_sym_struct] = ACTIONS(13437),
    [anon_sym_function] = ACTIONS(13437),
    [anon_sym_macro] = ACTIONS(13437),
    [anon_sym_where] = ACTIONS(13437),
    [anon_sym_quote] = ACTIONS(13437),
    [anon_sym_let] = ACTIONS(13437),
    [anon_sym_if] = ACTIONS(13437),
    [anon_sym_elseif] = ACTIONS(13437),
    [anon_sym_else] = ACTIONS(13437),
    [anon_sym_try] = ACTIONS(13437),
    [anon_sym_for] = ACTIONS(13437),
    [anon_sym_while] = ACTIONS(13437),
    [sym_break_statement] = ACTIONS(13437),
    [sym_continue_statement] = ACTIONS(13437),
    [anon_sym_return] = ACTIONS(13437),
    [anon_sym_const] = ACTIONS(13437),
    [anon_sym_global] = ACTIONS(13437),
    [anon_sym_local] = ACTIONS(13437),
    [anon_sym_LPAREN] = ACTIONS(13437),
    [anon_sym_COLON2] = ACTIONS(13437),
    [anon_sym_export] = ACTIONS(13437),
    [anon_sym_import] = ACTIONS(13437),
    [anon_sym_using] = ACTIONS(13437),
    [anon_sym_LBRACK] = ACTIONS(13437),
    [anon_sym_LF] = ACTIONS(13439),
    [anon_sym_in] = ACTIONS(13437),
    [anon_sym_LBRACE] = ACTIONS(13437),
    [anon_sym_DOLLAR] = ACTIONS(13437),
    [anon_sym_COLON_COLON] = ACTIONS(13437),
    [anon_sym_isa] = ACTIONS(13437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13437),
    [anon_sym_QMARK] = ACTIONS(13437),
    [anon_sym_AT] = ACTIONS(13437),
    [anon_sym_true] = ACTIONS(13437),
    [anon_sym_false] = ACTIONS(13437),
    [aux_sym_integer_literal_token1] = ACTIONS(13437),
    [aux_sym_integer_literal_token2] = ACTIONS(13437),
    [aux_sym_integer_literal_token3] = ACTIONS(13437),
    [aux_sym_integer_literal_token4] = ACTIONS(13437),
    [aux_sym_float_literal_token1] = ACTIONS(13437),
    [aux_sym_float_literal_token3] = ACTIONS(13437),
    [aux_sym_float_literal_token4] = ACTIONS(13437),
    [sym_character_literal] = ACTIONS(13437),
    [sym__pair_operator] = ACTIONS(13437),
    [sym__arrow_operator] = ACTIONS(13437),
    [sym__lazy_or_operator] = ACTIONS(13437),
    [sym__lazy_and_operator] = ACTIONS(13437),
    [sym__comparison_operator] = ACTIONS(13437),
    [sym__pipe_right_operator] = ACTIONS(13437),
    [sym__pipe_left_operator] = ACTIONS(13437),
    [sym__ellipsis_operator] = ACTIONS(13437),
    [sym__plus_operator] = ACTIONS(13437),
    [sym__times_operator] = ACTIONS(13437),
    [sym__rational_operator] = ACTIONS(13437),
    [sym__bitshift_operator] = ACTIONS(13437),
    [sym__power_operator] = ACTIONS(13437),
    [sym__tilde_operator] = ACTIONS(13437),
    [sym__type_order_operator] = ACTIONS(13437),
    [sym__unary_operator] = ACTIONS(13437),
    [sym__unary_plus_operator] = ACTIONS(13437),
    [aux_sym__terminator_token1] = ACTIONS(13437),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13439),
    [sym__command_start] = ACTIONS(13439),
  },
  [7407] = {
    [sym__word_identifier] = ACTIONS(13362),
    [anon_sym_EQ] = ACTIONS(13362),
    [anon_sym_COMMA] = ACTIONS(13362),
    [anon_sym_COLON] = ACTIONS(13362),
    [anon_sym_begin] = ACTIONS(13362),
    [anon_sym_module] = ACTIONS(13362),
    [anon_sym_baremodule] = ACTIONS(13362),
    [anon_sym_end] = ACTIONS(13362),
    [anon_sym_abstract] = ACTIONS(13362),
    [anon_sym_primitive] = ACTIONS(13362),
    [anon_sym_mutable] = ACTIONS(13362),
    [anon_sym_struct] = ACTIONS(13362),
    [anon_sym_function] = ACTIONS(13362),
    [anon_sym_macro] = ACTIONS(13362),
    [anon_sym_where] = ACTIONS(13362),
    [anon_sym_quote] = ACTIONS(13362),
    [anon_sym_let] = ACTIONS(13362),
    [anon_sym_if] = ACTIONS(13362),
    [anon_sym_else] = ACTIONS(13362),
    [anon_sym_try] = ACTIONS(13362),
    [anon_sym_finally] = ACTIONS(13362),
    [anon_sym_for] = ACTIONS(13362),
    [anon_sym_while] = ACTIONS(13362),
    [sym_break_statement] = ACTIONS(13362),
    [sym_continue_statement] = ACTIONS(13362),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_const] = ACTIONS(13362),
    [anon_sym_global] = ACTIONS(13362),
    [anon_sym_local] = ACTIONS(13362),
    [anon_sym_LPAREN] = ACTIONS(13362),
    [anon_sym_COLON2] = ACTIONS(13362),
    [anon_sym_export] = ACTIONS(13362),
    [anon_sym_import] = ACTIONS(13362),
    [anon_sym_using] = ACTIONS(13362),
    [anon_sym_LBRACK] = ACTIONS(13362),
    [anon_sym_LF] = ACTIONS(13364),
    [anon_sym_in] = ACTIONS(13362),
    [anon_sym_LBRACE] = ACTIONS(13362),
    [anon_sym_DOLLAR] = ACTIONS(13362),
    [anon_sym_COLON_COLON] = ACTIONS(13362),
    [anon_sym_isa] = ACTIONS(13362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13362),
    [anon_sym_QMARK] = ACTIONS(13362),
    [anon_sym_AT] = ACTIONS(13362),
    [anon_sym_true] = ACTIONS(13362),
    [anon_sym_false] = ACTIONS(13362),
    [aux_sym_integer_literal_token1] = ACTIONS(13362),
    [aux_sym_integer_literal_token2] = ACTIONS(13362),
    [aux_sym_integer_literal_token3] = ACTIONS(13362),
    [aux_sym_integer_literal_token4] = ACTIONS(13362),
    [aux_sym_float_literal_token1] = ACTIONS(13362),
    [aux_sym_float_literal_token3] = ACTIONS(13362),
    [aux_sym_float_literal_token4] = ACTIONS(13362),
    [sym_character_literal] = ACTIONS(13362),
    [sym__pair_operator] = ACTIONS(13362),
    [sym__arrow_operator] = ACTIONS(13362),
    [sym__lazy_or_operator] = ACTIONS(13362),
    [sym__lazy_and_operator] = ACTIONS(13362),
    [sym__comparison_operator] = ACTIONS(13362),
    [sym__pipe_right_operator] = ACTIONS(13362),
    [sym__pipe_left_operator] = ACTIONS(13362),
    [sym__ellipsis_operator] = ACTIONS(13362),
    [sym__plus_operator] = ACTIONS(13362),
    [sym__times_operator] = ACTIONS(13362),
    [sym__rational_operator] = ACTIONS(13362),
    [sym__bitshift_operator] = ACTIONS(13362),
    [sym__power_operator] = ACTIONS(13362),
    [sym__tilde_operator] = ACTIONS(13362),
    [sym__type_order_operator] = ACTIONS(13362),
    [sym__unary_operator] = ACTIONS(13362),
    [sym__unary_plus_operator] = ACTIONS(13362),
    [aux_sym__terminator_token1] = ACTIONS(13362),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13364),
    [sym__command_start] = ACTIONS(13364),
  },
  [7408] = {
    [sym__word_identifier] = ACTIONS(13366),
    [anon_sym_EQ] = ACTIONS(13366),
    [anon_sym_COMMA] = ACTIONS(13366),
    [anon_sym_COLON] = ACTIONS(13366),
    [anon_sym_begin] = ACTIONS(13366),
    [anon_sym_module] = ACTIONS(13366),
    [anon_sym_baremodule] = ACTIONS(13366),
    [anon_sym_end] = ACTIONS(13366),
    [anon_sym_abstract] = ACTIONS(13366),
    [anon_sym_primitive] = ACTIONS(13366),
    [anon_sym_mutable] = ACTIONS(13366),
    [anon_sym_struct] = ACTIONS(13366),
    [anon_sym_function] = ACTIONS(13366),
    [anon_sym_macro] = ACTIONS(13366),
    [anon_sym_where] = ACTIONS(13366),
    [anon_sym_quote] = ACTIONS(13366),
    [anon_sym_let] = ACTIONS(13366),
    [anon_sym_if] = ACTIONS(13366),
    [anon_sym_else] = ACTIONS(13366),
    [anon_sym_try] = ACTIONS(13366),
    [anon_sym_finally] = ACTIONS(13366),
    [anon_sym_for] = ACTIONS(13366),
    [anon_sym_while] = ACTIONS(13366),
    [sym_break_statement] = ACTIONS(13366),
    [sym_continue_statement] = ACTIONS(13366),
    [anon_sym_return] = ACTIONS(13366),
    [anon_sym_const] = ACTIONS(13366),
    [anon_sym_global] = ACTIONS(13366),
    [anon_sym_local] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(13366),
    [anon_sym_COLON2] = ACTIONS(13366),
    [anon_sym_export] = ACTIONS(13366),
    [anon_sym_import] = ACTIONS(13366),
    [anon_sym_using] = ACTIONS(13366),
    [anon_sym_LBRACK] = ACTIONS(13366),
    [anon_sym_LF] = ACTIONS(13368),
    [anon_sym_in] = ACTIONS(13366),
    [anon_sym_LBRACE] = ACTIONS(13366),
    [anon_sym_DOLLAR] = ACTIONS(13366),
    [anon_sym_COLON_COLON] = ACTIONS(13366),
    [anon_sym_isa] = ACTIONS(13366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13366),
    [anon_sym_QMARK] = ACTIONS(13366),
    [anon_sym_AT] = ACTIONS(13366),
    [anon_sym_true] = ACTIONS(13366),
    [anon_sym_false] = ACTIONS(13366),
    [aux_sym_integer_literal_token1] = ACTIONS(13366),
    [aux_sym_integer_literal_token2] = ACTIONS(13366),
    [aux_sym_integer_literal_token3] = ACTIONS(13366),
    [aux_sym_integer_literal_token4] = ACTIONS(13366),
    [aux_sym_float_literal_token1] = ACTIONS(13366),
    [aux_sym_float_literal_token3] = ACTIONS(13366),
    [aux_sym_float_literal_token4] = ACTIONS(13366),
    [sym_character_literal] = ACTIONS(13366),
    [sym__pair_operator] = ACTIONS(13366),
    [sym__arrow_operator] = ACTIONS(13366),
    [sym__lazy_or_operator] = ACTIONS(13366),
    [sym__lazy_and_operator] = ACTIONS(13366),
    [sym__comparison_operator] = ACTIONS(13366),
    [sym__pipe_right_operator] = ACTIONS(13366),
    [sym__pipe_left_operator] = ACTIONS(13366),
    [sym__ellipsis_operator] = ACTIONS(13366),
    [sym__plus_operator] = ACTIONS(13366),
    [sym__times_operator] = ACTIONS(13366),
    [sym__rational_operator] = ACTIONS(13366),
    [sym__bitshift_operator] = ACTIONS(13366),
    [sym__power_operator] = ACTIONS(13366),
    [sym__tilde_operator] = ACTIONS(13366),
    [sym__type_order_operator] = ACTIONS(13366),
    [sym__unary_operator] = ACTIONS(13366),
    [sym__unary_plus_operator] = ACTIONS(13366),
    [aux_sym__terminator_token1] = ACTIONS(13366),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13368),
    [sym__command_start] = ACTIONS(13368),
  },
  [7409] = {
    [sym__word_identifier] = ACTIONS(13370),
    [anon_sym_EQ] = ACTIONS(13370),
    [anon_sym_COMMA] = ACTIONS(13370),
    [anon_sym_COLON] = ACTIONS(13370),
    [anon_sym_begin] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(13370),
    [anon_sym_baremodule] = ACTIONS(13370),
    [anon_sym_end] = ACTIONS(13370),
    [anon_sym_abstract] = ACTIONS(13370),
    [anon_sym_primitive] = ACTIONS(13370),
    [anon_sym_mutable] = ACTIONS(13370),
    [anon_sym_struct] = ACTIONS(13370),
    [anon_sym_function] = ACTIONS(13370),
    [anon_sym_macro] = ACTIONS(13370),
    [anon_sym_where] = ACTIONS(13370),
    [anon_sym_quote] = ACTIONS(13370),
    [anon_sym_let] = ACTIONS(13370),
    [anon_sym_if] = ACTIONS(13370),
    [anon_sym_else] = ACTIONS(13370),
    [anon_sym_try] = ACTIONS(13370),
    [anon_sym_finally] = ACTIONS(13370),
    [anon_sym_for] = ACTIONS(13370),
    [anon_sym_while] = ACTIONS(13370),
    [sym_break_statement] = ACTIONS(13370),
    [sym_continue_statement] = ACTIONS(13370),
    [anon_sym_return] = ACTIONS(13370),
    [anon_sym_const] = ACTIONS(13370),
    [anon_sym_global] = ACTIONS(13370),
    [anon_sym_local] = ACTIONS(13370),
    [anon_sym_LPAREN] = ACTIONS(13370),
    [anon_sym_COLON2] = ACTIONS(13370),
    [anon_sym_export] = ACTIONS(13370),
    [anon_sym_import] = ACTIONS(13370),
    [anon_sym_using] = ACTIONS(13370),
    [anon_sym_LBRACK] = ACTIONS(13370),
    [anon_sym_LF] = ACTIONS(13372),
    [anon_sym_in] = ACTIONS(13370),
    [anon_sym_LBRACE] = ACTIONS(13370),
    [anon_sym_DOLLAR] = ACTIONS(13370),
    [anon_sym_COLON_COLON] = ACTIONS(13370),
    [anon_sym_isa] = ACTIONS(13370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13370),
    [anon_sym_QMARK] = ACTIONS(13370),
    [anon_sym_AT] = ACTIONS(13370),
    [anon_sym_true] = ACTIONS(13370),
    [anon_sym_false] = ACTIONS(13370),
    [aux_sym_integer_literal_token1] = ACTIONS(13370),
    [aux_sym_integer_literal_token2] = ACTIONS(13370),
    [aux_sym_integer_literal_token3] = ACTIONS(13370),
    [aux_sym_integer_literal_token4] = ACTIONS(13370),
    [aux_sym_float_literal_token1] = ACTIONS(13370),
    [aux_sym_float_literal_token3] = ACTIONS(13370),
    [aux_sym_float_literal_token4] = ACTIONS(13370),
    [sym_character_literal] = ACTIONS(13370),
    [sym__pair_operator] = ACTIONS(13370),
    [sym__arrow_operator] = ACTIONS(13370),
    [sym__lazy_or_operator] = ACTIONS(13370),
    [sym__lazy_and_operator] = ACTIONS(13370),
    [sym__comparison_operator] = ACTIONS(13370),
    [sym__pipe_right_operator] = ACTIONS(13370),
    [sym__pipe_left_operator] = ACTIONS(13370),
    [sym__ellipsis_operator] = ACTIONS(13370),
    [sym__plus_operator] = ACTIONS(13370),
    [sym__times_operator] = ACTIONS(13370),
    [sym__rational_operator] = ACTIONS(13370),
    [sym__bitshift_operator] = ACTIONS(13370),
    [sym__power_operator] = ACTIONS(13370),
    [sym__tilde_operator] = ACTIONS(13370),
    [sym__type_order_operator] = ACTIONS(13370),
    [sym__unary_operator] = ACTIONS(13370),
    [sym__unary_plus_operator] = ACTIONS(13370),
    [aux_sym__terminator_token1] = ACTIONS(13370),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13372),
    [sym__command_start] = ACTIONS(13372),
  },
  [7410] = {
    [sym__word_identifier] = ACTIONS(13374),
    [anon_sym_EQ] = ACTIONS(13374),
    [anon_sym_COMMA] = ACTIONS(13374),
    [anon_sym_COLON] = ACTIONS(13374),
    [anon_sym_begin] = ACTIONS(13374),
    [anon_sym_module] = ACTIONS(13374),
    [anon_sym_baremodule] = ACTIONS(13374),
    [anon_sym_end] = ACTIONS(13374),
    [anon_sym_abstract] = ACTIONS(13374),
    [anon_sym_primitive] = ACTIONS(13374),
    [anon_sym_mutable] = ACTIONS(13374),
    [anon_sym_struct] = ACTIONS(13374),
    [anon_sym_function] = ACTIONS(13374),
    [anon_sym_macro] = ACTIONS(13374),
    [anon_sym_where] = ACTIONS(13374),
    [anon_sym_quote] = ACTIONS(13374),
    [anon_sym_let] = ACTIONS(13374),
    [anon_sym_if] = ACTIONS(13374),
    [anon_sym_else] = ACTIONS(13374),
    [anon_sym_try] = ACTIONS(13374),
    [anon_sym_finally] = ACTIONS(13374),
    [anon_sym_for] = ACTIONS(13374),
    [anon_sym_while] = ACTIONS(13374),
    [sym_break_statement] = ACTIONS(13374),
    [sym_continue_statement] = ACTIONS(13374),
    [anon_sym_return] = ACTIONS(13374),
    [anon_sym_const] = ACTIONS(13374),
    [anon_sym_global] = ACTIONS(13374),
    [anon_sym_local] = ACTIONS(13374),
    [anon_sym_LPAREN] = ACTIONS(13374),
    [anon_sym_COLON2] = ACTIONS(13374),
    [anon_sym_export] = ACTIONS(13374),
    [anon_sym_import] = ACTIONS(13374),
    [anon_sym_using] = ACTIONS(13374),
    [anon_sym_LBRACK] = ACTIONS(13374),
    [anon_sym_LF] = ACTIONS(13376),
    [anon_sym_in] = ACTIONS(13374),
    [anon_sym_LBRACE] = ACTIONS(13374),
    [anon_sym_DOLLAR] = ACTIONS(13374),
    [anon_sym_COLON_COLON] = ACTIONS(13374),
    [anon_sym_isa] = ACTIONS(13374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13374),
    [anon_sym_QMARK] = ACTIONS(13374),
    [anon_sym_AT] = ACTIONS(13374),
    [anon_sym_true] = ACTIONS(13374),
    [anon_sym_false] = ACTIONS(13374),
    [aux_sym_integer_literal_token1] = ACTIONS(13374),
    [aux_sym_integer_literal_token2] = ACTIONS(13374),
    [aux_sym_integer_literal_token3] = ACTIONS(13374),
    [aux_sym_integer_literal_token4] = ACTIONS(13374),
    [aux_sym_float_literal_token1] = ACTIONS(13374),
    [aux_sym_float_literal_token3] = ACTIONS(13374),
    [aux_sym_float_literal_token4] = ACTIONS(13374),
    [sym_character_literal] = ACTIONS(13374),
    [sym__pair_operator] = ACTIONS(13374),
    [sym__arrow_operator] = ACTIONS(13374),
    [sym__lazy_or_operator] = ACTIONS(13374),
    [sym__lazy_and_operator] = ACTIONS(13374),
    [sym__comparison_operator] = ACTIONS(13374),
    [sym__pipe_right_operator] = ACTIONS(13374),
    [sym__pipe_left_operator] = ACTIONS(13374),
    [sym__ellipsis_operator] = ACTIONS(13374),
    [sym__plus_operator] = ACTIONS(13374),
    [sym__times_operator] = ACTIONS(13374),
    [sym__rational_operator] = ACTIONS(13374),
    [sym__bitshift_operator] = ACTIONS(13374),
    [sym__power_operator] = ACTIONS(13374),
    [sym__tilde_operator] = ACTIONS(13374),
    [sym__type_order_operator] = ACTIONS(13374),
    [sym__unary_operator] = ACTIONS(13374),
    [sym__unary_plus_operator] = ACTIONS(13374),
    [aux_sym__terminator_token1] = ACTIONS(13374),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13376),
    [sym__command_start] = ACTIONS(13376),
  },
  [7411] = {
    [sym__word_identifier] = ACTIONS(13378),
    [anon_sym_EQ] = ACTIONS(13378),
    [anon_sym_COMMA] = ACTIONS(13378),
    [anon_sym_COLON] = ACTIONS(13378),
    [anon_sym_begin] = ACTIONS(13378),
    [anon_sym_module] = ACTIONS(13378),
    [anon_sym_baremodule] = ACTIONS(13378),
    [anon_sym_end] = ACTIONS(13378),
    [anon_sym_abstract] = ACTIONS(13378),
    [anon_sym_primitive] = ACTIONS(13378),
    [anon_sym_mutable] = ACTIONS(13378),
    [anon_sym_struct] = ACTIONS(13378),
    [anon_sym_function] = ACTIONS(13378),
    [anon_sym_macro] = ACTIONS(13378),
    [anon_sym_where] = ACTIONS(13378),
    [anon_sym_quote] = ACTIONS(13378),
    [anon_sym_let] = ACTIONS(13378),
    [anon_sym_if] = ACTIONS(13378),
    [anon_sym_else] = ACTIONS(13378),
    [anon_sym_try] = ACTIONS(13378),
    [anon_sym_finally] = ACTIONS(13378),
    [anon_sym_for] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(13378),
    [sym_break_statement] = ACTIONS(13378),
    [sym_continue_statement] = ACTIONS(13378),
    [anon_sym_return] = ACTIONS(13378),
    [anon_sym_const] = ACTIONS(13378),
    [anon_sym_global] = ACTIONS(13378),
    [anon_sym_local] = ACTIONS(13378),
    [anon_sym_LPAREN] = ACTIONS(13378),
    [anon_sym_COLON2] = ACTIONS(13378),
    [anon_sym_export] = ACTIONS(13378),
    [anon_sym_import] = ACTIONS(13378),
    [anon_sym_using] = ACTIONS(13378),
    [anon_sym_LBRACK] = ACTIONS(13378),
    [anon_sym_LF] = ACTIONS(13380),
    [anon_sym_in] = ACTIONS(13378),
    [anon_sym_LBRACE] = ACTIONS(13378),
    [anon_sym_DOLLAR] = ACTIONS(13378),
    [anon_sym_COLON_COLON] = ACTIONS(13378),
    [anon_sym_isa] = ACTIONS(13378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13378),
    [anon_sym_QMARK] = ACTIONS(13378),
    [anon_sym_AT] = ACTIONS(13378),
    [anon_sym_true] = ACTIONS(13378),
    [anon_sym_false] = ACTIONS(13378),
    [aux_sym_integer_literal_token1] = ACTIONS(13378),
    [aux_sym_integer_literal_token2] = ACTIONS(13378),
    [aux_sym_integer_literal_token3] = ACTIONS(13378),
    [aux_sym_integer_literal_token4] = ACTIONS(13378),
    [aux_sym_float_literal_token1] = ACTIONS(13378),
    [aux_sym_float_literal_token3] = ACTIONS(13378),
    [aux_sym_float_literal_token4] = ACTIONS(13378),
    [sym_character_literal] = ACTIONS(13378),
    [sym__pair_operator] = ACTIONS(13378),
    [sym__arrow_operator] = ACTIONS(13378),
    [sym__lazy_or_operator] = ACTIONS(13378),
    [sym__lazy_and_operator] = ACTIONS(13378),
    [sym__comparison_operator] = ACTIONS(13378),
    [sym__pipe_right_operator] = ACTIONS(13378),
    [sym__pipe_left_operator] = ACTIONS(13378),
    [sym__ellipsis_operator] = ACTIONS(13378),
    [sym__plus_operator] = ACTIONS(13378),
    [sym__times_operator] = ACTIONS(13378),
    [sym__rational_operator] = ACTIONS(13378),
    [sym__bitshift_operator] = ACTIONS(13378),
    [sym__power_operator] = ACTIONS(13378),
    [sym__tilde_operator] = ACTIONS(13378),
    [sym__type_order_operator] = ACTIONS(13378),
    [sym__unary_operator] = ACTIONS(13378),
    [sym__unary_plus_operator] = ACTIONS(13378),
    [aux_sym__terminator_token1] = ACTIONS(13378),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13380),
    [sym__command_start] = ACTIONS(13380),
  },
  [7412] = {
    [sym__word_identifier] = ACTIONS(13382),
    [anon_sym_EQ] = ACTIONS(13382),
    [anon_sym_COMMA] = ACTIONS(13382),
    [anon_sym_COLON] = ACTIONS(13382),
    [anon_sym_begin] = ACTIONS(13382),
    [anon_sym_module] = ACTIONS(13382),
    [anon_sym_baremodule] = ACTIONS(13382),
    [anon_sym_end] = ACTIONS(13382),
    [anon_sym_abstract] = ACTIONS(13382),
    [anon_sym_primitive] = ACTIONS(13382),
    [anon_sym_mutable] = ACTIONS(13382),
    [anon_sym_struct] = ACTIONS(13382),
    [anon_sym_function] = ACTIONS(13382),
    [anon_sym_macro] = ACTIONS(13382),
    [anon_sym_where] = ACTIONS(13382),
    [anon_sym_quote] = ACTIONS(13382),
    [anon_sym_let] = ACTIONS(13382),
    [anon_sym_if] = ACTIONS(13382),
    [anon_sym_else] = ACTIONS(13382),
    [anon_sym_try] = ACTIONS(13382),
    [anon_sym_finally] = ACTIONS(13382),
    [anon_sym_for] = ACTIONS(13382),
    [anon_sym_while] = ACTIONS(13382),
    [sym_break_statement] = ACTIONS(13382),
    [sym_continue_statement] = ACTIONS(13382),
    [anon_sym_return] = ACTIONS(13382),
    [anon_sym_const] = ACTIONS(13382),
    [anon_sym_global] = ACTIONS(13382),
    [anon_sym_local] = ACTIONS(13382),
    [anon_sym_LPAREN] = ACTIONS(13382),
    [anon_sym_COLON2] = ACTIONS(13382),
    [anon_sym_export] = ACTIONS(13382),
    [anon_sym_import] = ACTIONS(13382),
    [anon_sym_using] = ACTIONS(13382),
    [anon_sym_LBRACK] = ACTIONS(13382),
    [anon_sym_LF] = ACTIONS(13384),
    [anon_sym_in] = ACTIONS(13382),
    [anon_sym_LBRACE] = ACTIONS(13382),
    [anon_sym_DOLLAR] = ACTIONS(13382),
    [anon_sym_COLON_COLON] = ACTIONS(13382),
    [anon_sym_isa] = ACTIONS(13382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13382),
    [anon_sym_QMARK] = ACTIONS(13382),
    [anon_sym_AT] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(13382),
    [anon_sym_false] = ACTIONS(13382),
    [aux_sym_integer_literal_token1] = ACTIONS(13382),
    [aux_sym_integer_literal_token2] = ACTIONS(13382),
    [aux_sym_integer_literal_token3] = ACTIONS(13382),
    [aux_sym_integer_literal_token4] = ACTIONS(13382),
    [aux_sym_float_literal_token1] = ACTIONS(13382),
    [aux_sym_float_literal_token3] = ACTIONS(13382),
    [aux_sym_float_literal_token4] = ACTIONS(13382),
    [sym_character_literal] = ACTIONS(13382),
    [sym__pair_operator] = ACTIONS(13382),
    [sym__arrow_operator] = ACTIONS(13382),
    [sym__lazy_or_operator] = ACTIONS(13382),
    [sym__lazy_and_operator] = ACTIONS(13382),
    [sym__comparison_operator] = ACTIONS(13382),
    [sym__pipe_right_operator] = ACTIONS(13382),
    [sym__pipe_left_operator] = ACTIONS(13382),
    [sym__ellipsis_operator] = ACTIONS(13382),
    [sym__plus_operator] = ACTIONS(13382),
    [sym__times_operator] = ACTIONS(13382),
    [sym__rational_operator] = ACTIONS(13382),
    [sym__bitshift_operator] = ACTIONS(13382),
    [sym__power_operator] = ACTIONS(13382),
    [sym__tilde_operator] = ACTIONS(13382),
    [sym__type_order_operator] = ACTIONS(13382),
    [sym__unary_operator] = ACTIONS(13382),
    [sym__unary_plus_operator] = ACTIONS(13382),
    [aux_sym__terminator_token1] = ACTIONS(13382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13384),
    [sym__command_start] = ACTIONS(13384),
  },
  [7413] = {
    [sym__word_identifier] = ACTIONS(13386),
    [anon_sym_EQ] = ACTIONS(13386),
    [anon_sym_COMMA] = ACTIONS(13386),
    [anon_sym_COLON] = ACTIONS(13386),
    [anon_sym_begin] = ACTIONS(13386),
    [anon_sym_module] = ACTIONS(13386),
    [anon_sym_baremodule] = ACTIONS(13386),
    [anon_sym_end] = ACTIONS(13386),
    [anon_sym_abstract] = ACTIONS(13386),
    [anon_sym_primitive] = ACTIONS(13386),
    [anon_sym_mutable] = ACTIONS(13386),
    [anon_sym_struct] = ACTIONS(13386),
    [anon_sym_function] = ACTIONS(13386),
    [anon_sym_macro] = ACTIONS(13386),
    [anon_sym_where] = ACTIONS(13386),
    [anon_sym_quote] = ACTIONS(13386),
    [anon_sym_let] = ACTIONS(13386),
    [anon_sym_if] = ACTIONS(13386),
    [anon_sym_else] = ACTIONS(13386),
    [anon_sym_try] = ACTIONS(13386),
    [anon_sym_finally] = ACTIONS(13386),
    [anon_sym_for] = ACTIONS(13386),
    [anon_sym_while] = ACTIONS(13386),
    [sym_break_statement] = ACTIONS(13386),
    [sym_continue_statement] = ACTIONS(13386),
    [anon_sym_return] = ACTIONS(13386),
    [anon_sym_const] = ACTIONS(13386),
    [anon_sym_global] = ACTIONS(13386),
    [anon_sym_local] = ACTIONS(13386),
    [anon_sym_LPAREN] = ACTIONS(13386),
    [anon_sym_COLON2] = ACTIONS(13386),
    [anon_sym_export] = ACTIONS(13386),
    [anon_sym_import] = ACTIONS(13386),
    [anon_sym_using] = ACTIONS(13386),
    [anon_sym_LBRACK] = ACTIONS(13386),
    [anon_sym_LF] = ACTIONS(13388),
    [anon_sym_in] = ACTIONS(13386),
    [anon_sym_LBRACE] = ACTIONS(13386),
    [anon_sym_DOLLAR] = ACTIONS(13386),
    [anon_sym_COLON_COLON] = ACTIONS(13386),
    [anon_sym_isa] = ACTIONS(13386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13386),
    [anon_sym_QMARK] = ACTIONS(13386),
    [anon_sym_AT] = ACTIONS(13386),
    [anon_sym_true] = ACTIONS(13386),
    [anon_sym_false] = ACTIONS(13386),
    [aux_sym_integer_literal_token1] = ACTIONS(13386),
    [aux_sym_integer_literal_token2] = ACTIONS(13386),
    [aux_sym_integer_literal_token3] = ACTIONS(13386),
    [aux_sym_integer_literal_token4] = ACTIONS(13386),
    [aux_sym_float_literal_token1] = ACTIONS(13386),
    [aux_sym_float_literal_token3] = ACTIONS(13386),
    [aux_sym_float_literal_token4] = ACTIONS(13386),
    [sym_character_literal] = ACTIONS(13386),
    [sym__pair_operator] = ACTIONS(13386),
    [sym__arrow_operator] = ACTIONS(13386),
    [sym__lazy_or_operator] = ACTIONS(13386),
    [sym__lazy_and_operator] = ACTIONS(13386),
    [sym__comparison_operator] = ACTIONS(13386),
    [sym__pipe_right_operator] = ACTIONS(13386),
    [sym__pipe_left_operator] = ACTIONS(13386),
    [sym__ellipsis_operator] = ACTIONS(13386),
    [sym__plus_operator] = ACTIONS(13386),
    [sym__times_operator] = ACTIONS(13386),
    [sym__rational_operator] = ACTIONS(13386),
    [sym__bitshift_operator] = ACTIONS(13386),
    [sym__power_operator] = ACTIONS(13386),
    [sym__tilde_operator] = ACTIONS(13386),
    [sym__type_order_operator] = ACTIONS(13386),
    [sym__unary_operator] = ACTIONS(13386),
    [sym__unary_plus_operator] = ACTIONS(13386),
    [aux_sym__terminator_token1] = ACTIONS(13386),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13388),
    [sym__command_start] = ACTIONS(13388),
  },
  [7414] = {
    [sym__word_identifier] = ACTIONS(13390),
    [anon_sym_EQ] = ACTIONS(13390),
    [anon_sym_COMMA] = ACTIONS(13390),
    [anon_sym_COLON] = ACTIONS(13390),
    [anon_sym_begin] = ACTIONS(13390),
    [anon_sym_module] = ACTIONS(13390),
    [anon_sym_baremodule] = ACTIONS(13390),
    [anon_sym_end] = ACTIONS(13390),
    [anon_sym_abstract] = ACTIONS(13390),
    [anon_sym_primitive] = ACTIONS(13390),
    [anon_sym_mutable] = ACTIONS(13390),
    [anon_sym_struct] = ACTIONS(13390),
    [anon_sym_function] = ACTIONS(13390),
    [anon_sym_macro] = ACTIONS(13390),
    [anon_sym_where] = ACTIONS(13390),
    [anon_sym_quote] = ACTIONS(13390),
    [anon_sym_let] = ACTIONS(13390),
    [anon_sym_if] = ACTIONS(13390),
    [anon_sym_else] = ACTIONS(13390),
    [anon_sym_try] = ACTIONS(13390),
    [anon_sym_finally] = ACTIONS(13390),
    [anon_sym_for] = ACTIONS(13390),
    [anon_sym_while] = ACTIONS(13390),
    [sym_break_statement] = ACTIONS(13390),
    [sym_continue_statement] = ACTIONS(13390),
    [anon_sym_return] = ACTIONS(13390),
    [anon_sym_const] = ACTIONS(13390),
    [anon_sym_global] = ACTIONS(13390),
    [anon_sym_local] = ACTIONS(13390),
    [anon_sym_LPAREN] = ACTIONS(13390),
    [anon_sym_COLON2] = ACTIONS(13390),
    [anon_sym_export] = ACTIONS(13390),
    [anon_sym_import] = ACTIONS(13390),
    [anon_sym_using] = ACTIONS(13390),
    [anon_sym_LBRACK] = ACTIONS(13390),
    [anon_sym_LF] = ACTIONS(13392),
    [anon_sym_in] = ACTIONS(13390),
    [anon_sym_LBRACE] = ACTIONS(13390),
    [anon_sym_DOLLAR] = ACTIONS(13390),
    [anon_sym_COLON_COLON] = ACTIONS(13390),
    [anon_sym_isa] = ACTIONS(13390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13390),
    [anon_sym_QMARK] = ACTIONS(13390),
    [anon_sym_AT] = ACTIONS(13390),
    [anon_sym_true] = ACTIONS(13390),
    [anon_sym_false] = ACTIONS(13390),
    [aux_sym_integer_literal_token1] = ACTIONS(13390),
    [aux_sym_integer_literal_token2] = ACTIONS(13390),
    [aux_sym_integer_literal_token3] = ACTIONS(13390),
    [aux_sym_integer_literal_token4] = ACTIONS(13390),
    [aux_sym_float_literal_token1] = ACTIONS(13390),
    [aux_sym_float_literal_token3] = ACTIONS(13390),
    [aux_sym_float_literal_token4] = ACTIONS(13390),
    [sym_character_literal] = ACTIONS(13390),
    [sym__pair_operator] = ACTIONS(13390),
    [sym__arrow_operator] = ACTIONS(13390),
    [sym__lazy_or_operator] = ACTIONS(13390),
    [sym__lazy_and_operator] = ACTIONS(13390),
    [sym__comparison_operator] = ACTIONS(13390),
    [sym__pipe_right_operator] = ACTIONS(13390),
    [sym__pipe_left_operator] = ACTIONS(13390),
    [sym__ellipsis_operator] = ACTIONS(13390),
    [sym__plus_operator] = ACTIONS(13390),
    [sym__times_operator] = ACTIONS(13390),
    [sym__rational_operator] = ACTIONS(13390),
    [sym__bitshift_operator] = ACTIONS(13390),
    [sym__power_operator] = ACTIONS(13390),
    [sym__tilde_operator] = ACTIONS(13390),
    [sym__type_order_operator] = ACTIONS(13390),
    [sym__unary_operator] = ACTIONS(13390),
    [sym__unary_plus_operator] = ACTIONS(13390),
    [aux_sym__terminator_token1] = ACTIONS(13390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13392),
    [sym__command_start] = ACTIONS(13392),
  },
  [7415] = {
    [sym__word_identifier] = ACTIONS(13396),
    [anon_sym_EQ] = ACTIONS(13396),
    [anon_sym_COMMA] = ACTIONS(13396),
    [anon_sym_COLON] = ACTIONS(13396),
    [anon_sym_begin] = ACTIONS(13396),
    [anon_sym_module] = ACTIONS(13396),
    [anon_sym_baremodule] = ACTIONS(13396),
    [anon_sym_end] = ACTIONS(13396),
    [anon_sym_abstract] = ACTIONS(13396),
    [anon_sym_primitive] = ACTIONS(13396),
    [anon_sym_mutable] = ACTIONS(13396),
    [anon_sym_struct] = ACTIONS(13396),
    [anon_sym_function] = ACTIONS(13396),
    [anon_sym_macro] = ACTIONS(13396),
    [anon_sym_where] = ACTIONS(13396),
    [anon_sym_quote] = ACTIONS(13396),
    [anon_sym_let] = ACTIONS(13396),
    [anon_sym_if] = ACTIONS(13396),
    [anon_sym_else] = ACTIONS(13396),
    [anon_sym_try] = ACTIONS(13396),
    [anon_sym_finally] = ACTIONS(13396),
    [anon_sym_for] = ACTIONS(13396),
    [anon_sym_while] = ACTIONS(13396),
    [sym_break_statement] = ACTIONS(13396),
    [sym_continue_statement] = ACTIONS(13396),
    [anon_sym_return] = ACTIONS(13396),
    [anon_sym_const] = ACTIONS(13396),
    [anon_sym_global] = ACTIONS(13396),
    [anon_sym_local] = ACTIONS(13396),
    [anon_sym_LPAREN] = ACTIONS(13396),
    [anon_sym_COLON2] = ACTIONS(13396),
    [anon_sym_export] = ACTIONS(13396),
    [anon_sym_import] = ACTIONS(13396),
    [anon_sym_using] = ACTIONS(13396),
    [anon_sym_LBRACK] = ACTIONS(13396),
    [anon_sym_LF] = ACTIONS(13398),
    [anon_sym_in] = ACTIONS(13396),
    [anon_sym_LBRACE] = ACTIONS(13396),
    [anon_sym_DOLLAR] = ACTIONS(13396),
    [anon_sym_COLON_COLON] = ACTIONS(13396),
    [anon_sym_isa] = ACTIONS(13396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13396),
    [anon_sym_QMARK] = ACTIONS(13396),
    [anon_sym_AT] = ACTIONS(13396),
    [anon_sym_true] = ACTIONS(13396),
    [anon_sym_false] = ACTIONS(13396),
    [aux_sym_integer_literal_token1] = ACTIONS(13396),
    [aux_sym_integer_literal_token2] = ACTIONS(13396),
    [aux_sym_integer_literal_token3] = ACTIONS(13396),
    [aux_sym_integer_literal_token4] = ACTIONS(13396),
    [aux_sym_float_literal_token1] = ACTIONS(13396),
    [aux_sym_float_literal_token3] = ACTIONS(13396),
    [aux_sym_float_literal_token4] = ACTIONS(13396),
    [sym_character_literal] = ACTIONS(13396),
    [sym__pair_operator] = ACTIONS(13396),
    [sym__arrow_operator] = ACTIONS(13396),
    [sym__lazy_or_operator] = ACTIONS(13396),
    [sym__lazy_and_operator] = ACTIONS(13396),
    [sym__comparison_operator] = ACTIONS(13396),
    [sym__pipe_right_operator] = ACTIONS(13396),
    [sym__pipe_left_operator] = ACTIONS(13396),
    [sym__ellipsis_operator] = ACTIONS(13396),
    [sym__plus_operator] = ACTIONS(13396),
    [sym__times_operator] = ACTIONS(13396),
    [sym__rational_operator] = ACTIONS(13396),
    [sym__bitshift_operator] = ACTIONS(13396),
    [sym__power_operator] = ACTIONS(13396),
    [sym__tilde_operator] = ACTIONS(13396),
    [sym__type_order_operator] = ACTIONS(13396),
    [sym__unary_operator] = ACTIONS(13396),
    [sym__unary_plus_operator] = ACTIONS(13396),
    [aux_sym__terminator_token1] = ACTIONS(13396),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13398),
    [sym__command_start] = ACTIONS(13398),
  },
  [7416] = {
    [sym__word_identifier] = ACTIONS(13400),
    [anon_sym_EQ] = ACTIONS(13400),
    [anon_sym_COMMA] = ACTIONS(13400),
    [anon_sym_COLON] = ACTIONS(13400),
    [anon_sym_begin] = ACTIONS(13400),
    [anon_sym_module] = ACTIONS(13400),
    [anon_sym_baremodule] = ACTIONS(13400),
    [anon_sym_end] = ACTIONS(13400),
    [anon_sym_abstract] = ACTIONS(13400),
    [anon_sym_primitive] = ACTIONS(13400),
    [anon_sym_mutable] = ACTIONS(13400),
    [anon_sym_struct] = ACTIONS(13400),
    [anon_sym_function] = ACTIONS(13400),
    [anon_sym_macro] = ACTIONS(13400),
    [anon_sym_where] = ACTIONS(13400),
    [anon_sym_quote] = ACTIONS(13400),
    [anon_sym_let] = ACTIONS(13400),
    [anon_sym_if] = ACTIONS(13400),
    [anon_sym_else] = ACTIONS(13400),
    [anon_sym_try] = ACTIONS(13400),
    [anon_sym_finally] = ACTIONS(13400),
    [anon_sym_for] = ACTIONS(13400),
    [anon_sym_while] = ACTIONS(13400),
    [sym_break_statement] = ACTIONS(13400),
    [sym_continue_statement] = ACTIONS(13400),
    [anon_sym_return] = ACTIONS(13400),
    [anon_sym_const] = ACTIONS(13400),
    [anon_sym_global] = ACTIONS(13400),
    [anon_sym_local] = ACTIONS(13400),
    [anon_sym_LPAREN] = ACTIONS(13400),
    [anon_sym_COLON2] = ACTIONS(13400),
    [anon_sym_export] = ACTIONS(13400),
    [anon_sym_import] = ACTIONS(13400),
    [anon_sym_using] = ACTIONS(13400),
    [anon_sym_LBRACK] = ACTIONS(13400),
    [anon_sym_LF] = ACTIONS(13402),
    [anon_sym_in] = ACTIONS(13400),
    [anon_sym_LBRACE] = ACTIONS(13400),
    [anon_sym_DOLLAR] = ACTIONS(13400),
    [anon_sym_COLON_COLON] = ACTIONS(13400),
    [anon_sym_isa] = ACTIONS(13400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13400),
    [anon_sym_QMARK] = ACTIONS(13400),
    [anon_sym_AT] = ACTIONS(13400),
    [anon_sym_true] = ACTIONS(13400),
    [anon_sym_false] = ACTIONS(13400),
    [aux_sym_integer_literal_token1] = ACTIONS(13400),
    [aux_sym_integer_literal_token2] = ACTIONS(13400),
    [aux_sym_integer_literal_token3] = ACTIONS(13400),
    [aux_sym_integer_literal_token4] = ACTIONS(13400),
    [aux_sym_float_literal_token1] = ACTIONS(13400),
    [aux_sym_float_literal_token3] = ACTIONS(13400),
    [aux_sym_float_literal_token4] = ACTIONS(13400),
    [sym_character_literal] = ACTIONS(13400),
    [sym__pair_operator] = ACTIONS(13400),
    [sym__arrow_operator] = ACTIONS(13400),
    [sym__lazy_or_operator] = ACTIONS(13400),
    [sym__lazy_and_operator] = ACTIONS(13400),
    [sym__comparison_operator] = ACTIONS(13400),
    [sym__pipe_right_operator] = ACTIONS(13400),
    [sym__pipe_left_operator] = ACTIONS(13400),
    [sym__ellipsis_operator] = ACTIONS(13400),
    [sym__plus_operator] = ACTIONS(13400),
    [sym__times_operator] = ACTIONS(13400),
    [sym__rational_operator] = ACTIONS(13400),
    [sym__bitshift_operator] = ACTIONS(13400),
    [sym__power_operator] = ACTIONS(13400),
    [sym__tilde_operator] = ACTIONS(13400),
    [sym__type_order_operator] = ACTIONS(13400),
    [sym__unary_operator] = ACTIONS(13400),
    [sym__unary_plus_operator] = ACTIONS(13400),
    [aux_sym__terminator_token1] = ACTIONS(13400),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13402),
    [sym__command_start] = ACTIONS(13402),
  },
  [7417] = {
    [sym__word_identifier] = ACTIONS(13407),
    [anon_sym_EQ] = ACTIONS(13407),
    [anon_sym_COMMA] = ACTIONS(13407),
    [anon_sym_COLON] = ACTIONS(13407),
    [anon_sym_begin] = ACTIONS(13407),
    [anon_sym_module] = ACTIONS(13407),
    [anon_sym_baremodule] = ACTIONS(13407),
    [anon_sym_end] = ACTIONS(13407),
    [anon_sym_abstract] = ACTIONS(13407),
    [anon_sym_primitive] = ACTIONS(13407),
    [anon_sym_mutable] = ACTIONS(13407),
    [anon_sym_struct] = ACTIONS(13407),
    [anon_sym_function] = ACTIONS(13407),
    [anon_sym_macro] = ACTIONS(13407),
    [anon_sym_where] = ACTIONS(13407),
    [anon_sym_quote] = ACTIONS(13407),
    [anon_sym_let] = ACTIONS(13407),
    [anon_sym_if] = ACTIONS(13407),
    [anon_sym_else] = ACTIONS(13407),
    [anon_sym_try] = ACTIONS(13407),
    [anon_sym_finally] = ACTIONS(13407),
    [anon_sym_for] = ACTIONS(13407),
    [anon_sym_while] = ACTIONS(13407),
    [sym_break_statement] = ACTIONS(13407),
    [sym_continue_statement] = ACTIONS(13407),
    [anon_sym_return] = ACTIONS(13407),
    [anon_sym_const] = ACTIONS(13407),
    [anon_sym_global] = ACTIONS(13407),
    [anon_sym_local] = ACTIONS(13407),
    [anon_sym_LPAREN] = ACTIONS(13407),
    [anon_sym_COLON2] = ACTIONS(13407),
    [anon_sym_export] = ACTIONS(13407),
    [anon_sym_import] = ACTIONS(13407),
    [anon_sym_using] = ACTIONS(13407),
    [anon_sym_LBRACK] = ACTIONS(13407),
    [anon_sym_LF] = ACTIONS(13409),
    [anon_sym_in] = ACTIONS(13407),
    [anon_sym_LBRACE] = ACTIONS(13407),
    [anon_sym_DOLLAR] = ACTIONS(13407),
    [anon_sym_COLON_COLON] = ACTIONS(13407),
    [anon_sym_isa] = ACTIONS(13407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13407),
    [anon_sym_QMARK] = ACTIONS(13407),
    [anon_sym_AT] = ACTIONS(13407),
    [anon_sym_true] = ACTIONS(13407),
    [anon_sym_false] = ACTIONS(13407),
    [aux_sym_integer_literal_token1] = ACTIONS(13407),
    [aux_sym_integer_literal_token2] = ACTIONS(13407),
    [aux_sym_integer_literal_token3] = ACTIONS(13407),
    [aux_sym_integer_literal_token4] = ACTIONS(13407),
    [aux_sym_float_literal_token1] = ACTIONS(13407),
    [aux_sym_float_literal_token3] = ACTIONS(13407),
    [aux_sym_float_literal_token4] = ACTIONS(13407),
    [sym_character_literal] = ACTIONS(13407),
    [sym__pair_operator] = ACTIONS(13407),
    [sym__arrow_operator] = ACTIONS(13407),
    [sym__lazy_or_operator] = ACTIONS(13407),
    [sym__lazy_and_operator] = ACTIONS(13407),
    [sym__comparison_operator] = ACTIONS(13407),
    [sym__pipe_right_operator] = ACTIONS(13407),
    [sym__pipe_left_operator] = ACTIONS(13407),
    [sym__ellipsis_operator] = ACTIONS(13407),
    [sym__plus_operator] = ACTIONS(13407),
    [sym__times_operator] = ACTIONS(13407),
    [sym__rational_operator] = ACTIONS(13407),
    [sym__bitshift_operator] = ACTIONS(13407),
    [sym__power_operator] = ACTIONS(13407),
    [sym__tilde_operator] = ACTIONS(13407),
    [sym__type_order_operator] = ACTIONS(13407),
    [sym__unary_operator] = ACTIONS(13407),
    [sym__unary_plus_operator] = ACTIONS(13407),
    [aux_sym__terminator_token1] = ACTIONS(13407),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13409),
    [sym__command_start] = ACTIONS(13409),
  },
  [7418] = {
    [sym__word_identifier] = ACTIONS(13441),
    [anon_sym_EQ] = ACTIONS(13441),
    [anon_sym_COMMA] = ACTIONS(13441),
    [anon_sym_COLON] = ACTIONS(13441),
    [anon_sym_begin] = ACTIONS(13441),
    [anon_sym_module] = ACTIONS(13441),
    [anon_sym_baremodule] = ACTIONS(13441),
    [anon_sym_end] = ACTIONS(13441),
    [anon_sym_abstract] = ACTIONS(13441),
    [anon_sym_primitive] = ACTIONS(13441),
    [anon_sym_mutable] = ACTIONS(13441),
    [anon_sym_struct] = ACTIONS(13441),
    [anon_sym_function] = ACTIONS(13441),
    [anon_sym_macro] = ACTIONS(13441),
    [anon_sym_where] = ACTIONS(13441),
    [anon_sym_quote] = ACTIONS(13441),
    [anon_sym_let] = ACTIONS(13441),
    [anon_sym_if] = ACTIONS(13441),
    [anon_sym_elseif] = ACTIONS(13441),
    [anon_sym_else] = ACTIONS(13441),
    [anon_sym_try] = ACTIONS(13441),
    [anon_sym_for] = ACTIONS(13441),
    [anon_sym_while] = ACTIONS(13441),
    [sym_break_statement] = ACTIONS(13441),
    [sym_continue_statement] = ACTIONS(13441),
    [anon_sym_return] = ACTIONS(13441),
    [anon_sym_const] = ACTIONS(13441),
    [anon_sym_global] = ACTIONS(13441),
    [anon_sym_local] = ACTIONS(13441),
    [anon_sym_LPAREN] = ACTIONS(13441),
    [anon_sym_COLON2] = ACTIONS(13441),
    [anon_sym_export] = ACTIONS(13441),
    [anon_sym_import] = ACTIONS(13441),
    [anon_sym_using] = ACTIONS(13441),
    [anon_sym_LBRACK] = ACTIONS(13441),
    [anon_sym_LF] = ACTIONS(13443),
    [anon_sym_in] = ACTIONS(13441),
    [anon_sym_LBRACE] = ACTIONS(13441),
    [anon_sym_DOLLAR] = ACTIONS(13441),
    [anon_sym_COLON_COLON] = ACTIONS(13441),
    [anon_sym_isa] = ACTIONS(13441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13441),
    [anon_sym_QMARK] = ACTIONS(13441),
    [anon_sym_AT] = ACTIONS(13441),
    [anon_sym_true] = ACTIONS(13441),
    [anon_sym_false] = ACTIONS(13441),
    [aux_sym_integer_literal_token1] = ACTIONS(13441),
    [aux_sym_integer_literal_token2] = ACTIONS(13441),
    [aux_sym_integer_literal_token3] = ACTIONS(13441),
    [aux_sym_integer_literal_token4] = ACTIONS(13441),
    [aux_sym_float_literal_token1] = ACTIONS(13441),
    [aux_sym_float_literal_token3] = ACTIONS(13441),
    [aux_sym_float_literal_token4] = ACTIONS(13441),
    [sym_character_literal] = ACTIONS(13441),
    [sym__pair_operator] = ACTIONS(13441),
    [sym__arrow_operator] = ACTIONS(13441),
    [sym__lazy_or_operator] = ACTIONS(13441),
    [sym__lazy_and_operator] = ACTIONS(13441),
    [sym__comparison_operator] = ACTIONS(13441),
    [sym__pipe_right_operator] = ACTIONS(13441),
    [sym__pipe_left_operator] = ACTIONS(13441),
    [sym__ellipsis_operator] = ACTIONS(13441),
    [sym__plus_operator] = ACTIONS(13441),
    [sym__times_operator] = ACTIONS(13441),
    [sym__rational_operator] = ACTIONS(13441),
    [sym__bitshift_operator] = ACTIONS(13441),
    [sym__power_operator] = ACTIONS(13441),
    [sym__tilde_operator] = ACTIONS(13441),
    [sym__type_order_operator] = ACTIONS(13441),
    [sym__unary_operator] = ACTIONS(13441),
    [sym__unary_plus_operator] = ACTIONS(13441),
    [aux_sym__terminator_token1] = ACTIONS(13441),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13443),
    [sym__command_start] = ACTIONS(13443),
  },
  [7419] = {
    [sym__word_identifier] = ACTIONS(13445),
    [anon_sym_EQ] = ACTIONS(13445),
    [anon_sym_COMMA] = ACTIONS(13445),
    [anon_sym_COLON] = ACTIONS(13445),
    [anon_sym_begin] = ACTIONS(13445),
    [anon_sym_module] = ACTIONS(13445),
    [anon_sym_baremodule] = ACTIONS(13445),
    [anon_sym_end] = ACTIONS(13445),
    [anon_sym_abstract] = ACTIONS(13445),
    [anon_sym_primitive] = ACTIONS(13445),
    [anon_sym_mutable] = ACTIONS(13445),
    [anon_sym_struct] = ACTIONS(13445),
    [anon_sym_function] = ACTIONS(13445),
    [anon_sym_macro] = ACTIONS(13445),
    [anon_sym_where] = ACTIONS(13445),
    [anon_sym_quote] = ACTIONS(13445),
    [anon_sym_let] = ACTIONS(13445),
    [anon_sym_if] = ACTIONS(13445),
    [anon_sym_elseif] = ACTIONS(13445),
    [anon_sym_else] = ACTIONS(13445),
    [anon_sym_try] = ACTIONS(13445),
    [anon_sym_for] = ACTIONS(13445),
    [anon_sym_while] = ACTIONS(13445),
    [sym_break_statement] = ACTIONS(13445),
    [sym_continue_statement] = ACTIONS(13445),
    [anon_sym_return] = ACTIONS(13445),
    [anon_sym_const] = ACTIONS(13445),
    [anon_sym_global] = ACTIONS(13445),
    [anon_sym_local] = ACTIONS(13445),
    [anon_sym_LPAREN] = ACTIONS(13445),
    [anon_sym_COLON2] = ACTIONS(13445),
    [anon_sym_export] = ACTIONS(13445),
    [anon_sym_import] = ACTIONS(13445),
    [anon_sym_using] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(13445),
    [anon_sym_LF] = ACTIONS(13447),
    [anon_sym_in] = ACTIONS(13445),
    [anon_sym_LBRACE] = ACTIONS(13445),
    [anon_sym_DOLLAR] = ACTIONS(13445),
    [anon_sym_COLON_COLON] = ACTIONS(13445),
    [anon_sym_isa] = ACTIONS(13445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13445),
    [anon_sym_QMARK] = ACTIONS(13445),
    [anon_sym_AT] = ACTIONS(13445),
    [anon_sym_true] = ACTIONS(13445),
    [anon_sym_false] = ACTIONS(13445),
    [aux_sym_integer_literal_token1] = ACTIONS(13445),
    [aux_sym_integer_literal_token2] = ACTIONS(13445),
    [aux_sym_integer_literal_token3] = ACTIONS(13445),
    [aux_sym_integer_literal_token4] = ACTIONS(13445),
    [aux_sym_float_literal_token1] = ACTIONS(13445),
    [aux_sym_float_literal_token3] = ACTIONS(13445),
    [aux_sym_float_literal_token4] = ACTIONS(13445),
    [sym_character_literal] = ACTIONS(13445),
    [sym__pair_operator] = ACTIONS(13445),
    [sym__arrow_operator] = ACTIONS(13445),
    [sym__lazy_or_operator] = ACTIONS(13445),
    [sym__lazy_and_operator] = ACTIONS(13445),
    [sym__comparison_operator] = ACTIONS(13445),
    [sym__pipe_right_operator] = ACTIONS(13445),
    [sym__pipe_left_operator] = ACTIONS(13445),
    [sym__ellipsis_operator] = ACTIONS(13445),
    [sym__plus_operator] = ACTIONS(13445),
    [sym__times_operator] = ACTIONS(13445),
    [sym__rational_operator] = ACTIONS(13445),
    [sym__bitshift_operator] = ACTIONS(13445),
    [sym__power_operator] = ACTIONS(13445),
    [sym__tilde_operator] = ACTIONS(13445),
    [sym__type_order_operator] = ACTIONS(13445),
    [sym__unary_operator] = ACTIONS(13445),
    [sym__unary_plus_operator] = ACTIONS(13445),
    [aux_sym__terminator_token1] = ACTIONS(13445),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13447),
    [sym__command_start] = ACTIONS(13447),
  },
  [7420] = {
    [sym__word_identifier] = ACTIONS(13449),
    [anon_sym_EQ] = ACTIONS(13449),
    [anon_sym_COMMA] = ACTIONS(13449),
    [anon_sym_COLON] = ACTIONS(13449),
    [anon_sym_begin] = ACTIONS(13449),
    [anon_sym_module] = ACTIONS(13449),
    [anon_sym_baremodule] = ACTIONS(13449),
    [anon_sym_end] = ACTIONS(13449),
    [anon_sym_abstract] = ACTIONS(13449),
    [anon_sym_primitive] = ACTIONS(13449),
    [anon_sym_mutable] = ACTIONS(13449),
    [anon_sym_struct] = ACTIONS(13449),
    [anon_sym_function] = ACTIONS(13449),
    [anon_sym_macro] = ACTIONS(13449),
    [anon_sym_where] = ACTIONS(13449),
    [anon_sym_quote] = ACTIONS(13449),
    [anon_sym_let] = ACTIONS(13449),
    [anon_sym_if] = ACTIONS(13449),
    [anon_sym_elseif] = ACTIONS(13449),
    [anon_sym_else] = ACTIONS(13449),
    [anon_sym_try] = ACTIONS(13449),
    [anon_sym_for] = ACTIONS(13449),
    [anon_sym_while] = ACTIONS(13449),
    [sym_break_statement] = ACTIONS(13449),
    [sym_continue_statement] = ACTIONS(13449),
    [anon_sym_return] = ACTIONS(13449),
    [anon_sym_const] = ACTIONS(13449),
    [anon_sym_global] = ACTIONS(13449),
    [anon_sym_local] = ACTIONS(13449),
    [anon_sym_LPAREN] = ACTIONS(13449),
    [anon_sym_COLON2] = ACTIONS(13449),
    [anon_sym_export] = ACTIONS(13449),
    [anon_sym_import] = ACTIONS(13449),
    [anon_sym_using] = ACTIONS(13449),
    [anon_sym_LBRACK] = ACTIONS(13449),
    [anon_sym_LF] = ACTIONS(13451),
    [anon_sym_in] = ACTIONS(13449),
    [anon_sym_LBRACE] = ACTIONS(13449),
    [anon_sym_DOLLAR] = ACTIONS(13449),
    [anon_sym_COLON_COLON] = ACTIONS(13449),
    [anon_sym_isa] = ACTIONS(13449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13449),
    [anon_sym_QMARK] = ACTIONS(13449),
    [anon_sym_AT] = ACTIONS(13449),
    [anon_sym_true] = ACTIONS(13449),
    [anon_sym_false] = ACTIONS(13449),
    [aux_sym_integer_literal_token1] = ACTIONS(13449),
    [aux_sym_integer_literal_token2] = ACTIONS(13449),
    [aux_sym_integer_literal_token3] = ACTIONS(13449),
    [aux_sym_integer_literal_token4] = ACTIONS(13449),
    [aux_sym_float_literal_token1] = ACTIONS(13449),
    [aux_sym_float_literal_token3] = ACTIONS(13449),
    [aux_sym_float_literal_token4] = ACTIONS(13449),
    [sym_character_literal] = ACTIONS(13449),
    [sym__pair_operator] = ACTIONS(13449),
    [sym__arrow_operator] = ACTIONS(13449),
    [sym__lazy_or_operator] = ACTIONS(13449),
    [sym__lazy_and_operator] = ACTIONS(13449),
    [sym__comparison_operator] = ACTIONS(13449),
    [sym__pipe_right_operator] = ACTIONS(13449),
    [sym__pipe_left_operator] = ACTIONS(13449),
    [sym__ellipsis_operator] = ACTIONS(13449),
    [sym__plus_operator] = ACTIONS(13449),
    [sym__times_operator] = ACTIONS(13449),
    [sym__rational_operator] = ACTIONS(13449),
    [sym__bitshift_operator] = ACTIONS(13449),
    [sym__power_operator] = ACTIONS(13449),
    [sym__tilde_operator] = ACTIONS(13449),
    [sym__type_order_operator] = ACTIONS(13449),
    [sym__unary_operator] = ACTIONS(13449),
    [sym__unary_plus_operator] = ACTIONS(13449),
    [aux_sym__terminator_token1] = ACTIONS(13449),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13451),
    [sym__command_start] = ACTIONS(13451),
  },
  [7421] = {
    [sym__word_identifier] = ACTIONS(13453),
    [anon_sym_EQ] = ACTIONS(13453),
    [anon_sym_COMMA] = ACTIONS(13453),
    [anon_sym_COLON] = ACTIONS(13453),
    [anon_sym_begin] = ACTIONS(13453),
    [anon_sym_module] = ACTIONS(13453),
    [anon_sym_baremodule] = ACTIONS(13453),
    [anon_sym_end] = ACTIONS(13453),
    [anon_sym_abstract] = ACTIONS(13453),
    [anon_sym_primitive] = ACTIONS(13453),
    [anon_sym_mutable] = ACTIONS(13453),
    [anon_sym_struct] = ACTIONS(13453),
    [anon_sym_function] = ACTIONS(13453),
    [anon_sym_macro] = ACTIONS(13453),
    [anon_sym_where] = ACTIONS(13453),
    [anon_sym_quote] = ACTIONS(13453),
    [anon_sym_let] = ACTIONS(13453),
    [anon_sym_if] = ACTIONS(13453),
    [anon_sym_elseif] = ACTIONS(13453),
    [anon_sym_else] = ACTIONS(13453),
    [anon_sym_try] = ACTIONS(13453),
    [anon_sym_for] = ACTIONS(13453),
    [anon_sym_while] = ACTIONS(13453),
    [sym_break_statement] = ACTIONS(13453),
    [sym_continue_statement] = ACTIONS(13453),
    [anon_sym_return] = ACTIONS(13453),
    [anon_sym_const] = ACTIONS(13453),
    [anon_sym_global] = ACTIONS(13453),
    [anon_sym_local] = ACTIONS(13453),
    [anon_sym_LPAREN] = ACTIONS(13453),
    [anon_sym_COLON2] = ACTIONS(13453),
    [anon_sym_export] = ACTIONS(13453),
    [anon_sym_import] = ACTIONS(13453),
    [anon_sym_using] = ACTIONS(13453),
    [anon_sym_LBRACK] = ACTIONS(13453),
    [anon_sym_LF] = ACTIONS(13455),
    [anon_sym_in] = ACTIONS(13453),
    [anon_sym_LBRACE] = ACTIONS(13453),
    [anon_sym_DOLLAR] = ACTIONS(13453),
    [anon_sym_COLON_COLON] = ACTIONS(13453),
    [anon_sym_isa] = ACTIONS(13453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13453),
    [anon_sym_QMARK] = ACTIONS(13453),
    [anon_sym_AT] = ACTIONS(13453),
    [anon_sym_true] = ACTIONS(13453),
    [anon_sym_false] = ACTIONS(13453),
    [aux_sym_integer_literal_token1] = ACTIONS(13453),
    [aux_sym_integer_literal_token2] = ACTIONS(13453),
    [aux_sym_integer_literal_token3] = ACTIONS(13453),
    [aux_sym_integer_literal_token4] = ACTIONS(13453),
    [aux_sym_float_literal_token1] = ACTIONS(13453),
    [aux_sym_float_literal_token3] = ACTIONS(13453),
    [aux_sym_float_literal_token4] = ACTIONS(13453),
    [sym_character_literal] = ACTIONS(13453),
    [sym__pair_operator] = ACTIONS(13453),
    [sym__arrow_operator] = ACTIONS(13453),
    [sym__lazy_or_operator] = ACTIONS(13453),
    [sym__lazy_and_operator] = ACTIONS(13453),
    [sym__comparison_operator] = ACTIONS(13453),
    [sym__pipe_right_operator] = ACTIONS(13453),
    [sym__pipe_left_operator] = ACTIONS(13453),
    [sym__ellipsis_operator] = ACTIONS(13453),
    [sym__plus_operator] = ACTIONS(13453),
    [sym__times_operator] = ACTIONS(13453),
    [sym__rational_operator] = ACTIONS(13453),
    [sym__bitshift_operator] = ACTIONS(13453),
    [sym__power_operator] = ACTIONS(13453),
    [sym__tilde_operator] = ACTIONS(13453),
    [sym__type_order_operator] = ACTIONS(13453),
    [sym__unary_operator] = ACTIONS(13453),
    [sym__unary_plus_operator] = ACTIONS(13453),
    [aux_sym__terminator_token1] = ACTIONS(13453),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13455),
    [sym__command_start] = ACTIONS(13455),
  },
  [7422] = {
    [sym__word_identifier] = ACTIONS(13457),
    [anon_sym_EQ] = ACTIONS(13457),
    [anon_sym_COMMA] = ACTIONS(13457),
    [anon_sym_COLON] = ACTIONS(13457),
    [anon_sym_begin] = ACTIONS(13457),
    [anon_sym_module] = ACTIONS(13457),
    [anon_sym_baremodule] = ACTIONS(13457),
    [anon_sym_end] = ACTIONS(13457),
    [anon_sym_abstract] = ACTIONS(13457),
    [anon_sym_primitive] = ACTIONS(13457),
    [anon_sym_mutable] = ACTIONS(13457),
    [anon_sym_struct] = ACTIONS(13457),
    [anon_sym_function] = ACTIONS(13457),
    [anon_sym_macro] = ACTIONS(13457),
    [anon_sym_where] = ACTIONS(13457),
    [anon_sym_quote] = ACTIONS(13457),
    [anon_sym_let] = ACTIONS(13457),
    [anon_sym_if] = ACTIONS(13457),
    [anon_sym_elseif] = ACTIONS(13457),
    [anon_sym_else] = ACTIONS(13457),
    [anon_sym_try] = ACTIONS(13457),
    [anon_sym_for] = ACTIONS(13457),
    [anon_sym_while] = ACTIONS(13457),
    [sym_break_statement] = ACTIONS(13457),
    [sym_continue_statement] = ACTIONS(13457),
    [anon_sym_return] = ACTIONS(13457),
    [anon_sym_const] = ACTIONS(13457),
    [anon_sym_global] = ACTIONS(13457),
    [anon_sym_local] = ACTIONS(13457),
    [anon_sym_LPAREN] = ACTIONS(13457),
    [anon_sym_COLON2] = ACTIONS(13457),
    [anon_sym_export] = ACTIONS(13457),
    [anon_sym_import] = ACTIONS(13457),
    [anon_sym_using] = ACTIONS(13457),
    [anon_sym_LBRACK] = ACTIONS(13457),
    [anon_sym_LF] = ACTIONS(13459),
    [anon_sym_in] = ACTIONS(13457),
    [anon_sym_LBRACE] = ACTIONS(13457),
    [anon_sym_DOLLAR] = ACTIONS(13457),
    [anon_sym_COLON_COLON] = ACTIONS(13457),
    [anon_sym_isa] = ACTIONS(13457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13457),
    [anon_sym_QMARK] = ACTIONS(13457),
    [anon_sym_AT] = ACTIONS(13457),
    [anon_sym_true] = ACTIONS(13457),
    [anon_sym_false] = ACTIONS(13457),
    [aux_sym_integer_literal_token1] = ACTIONS(13457),
    [aux_sym_integer_literal_token2] = ACTIONS(13457),
    [aux_sym_integer_literal_token3] = ACTIONS(13457),
    [aux_sym_integer_literal_token4] = ACTIONS(13457),
    [aux_sym_float_literal_token1] = ACTIONS(13457),
    [aux_sym_float_literal_token3] = ACTIONS(13457),
    [aux_sym_float_literal_token4] = ACTIONS(13457),
    [sym_character_literal] = ACTIONS(13457),
    [sym__pair_operator] = ACTIONS(13457),
    [sym__arrow_operator] = ACTIONS(13457),
    [sym__lazy_or_operator] = ACTIONS(13457),
    [sym__lazy_and_operator] = ACTIONS(13457),
    [sym__comparison_operator] = ACTIONS(13457),
    [sym__pipe_right_operator] = ACTIONS(13457),
    [sym__pipe_left_operator] = ACTIONS(13457),
    [sym__ellipsis_operator] = ACTIONS(13457),
    [sym__plus_operator] = ACTIONS(13457),
    [sym__times_operator] = ACTIONS(13457),
    [sym__rational_operator] = ACTIONS(13457),
    [sym__bitshift_operator] = ACTIONS(13457),
    [sym__power_operator] = ACTIONS(13457),
    [sym__tilde_operator] = ACTIONS(13457),
    [sym__type_order_operator] = ACTIONS(13457),
    [sym__unary_operator] = ACTIONS(13457),
    [sym__unary_plus_operator] = ACTIONS(13457),
    [aux_sym__terminator_token1] = ACTIONS(13457),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13459),
    [sym__command_start] = ACTIONS(13459),
  },
  [7423] = {
    [sym__word_identifier] = ACTIONS(13461),
    [anon_sym_EQ] = ACTIONS(13461),
    [anon_sym_COMMA] = ACTIONS(13461),
    [anon_sym_COLON] = ACTIONS(13461),
    [anon_sym_begin] = ACTIONS(13461),
    [anon_sym_module] = ACTIONS(13461),
    [anon_sym_baremodule] = ACTIONS(13461),
    [anon_sym_end] = ACTIONS(13461),
    [anon_sym_abstract] = ACTIONS(13461),
    [anon_sym_primitive] = ACTIONS(13461),
    [anon_sym_mutable] = ACTIONS(13461),
    [anon_sym_struct] = ACTIONS(13461),
    [anon_sym_function] = ACTIONS(13461),
    [anon_sym_macro] = ACTIONS(13461),
    [anon_sym_where] = ACTIONS(13461),
    [anon_sym_quote] = ACTIONS(13461),
    [anon_sym_let] = ACTIONS(13461),
    [anon_sym_if] = ACTIONS(13461),
    [anon_sym_elseif] = ACTIONS(13461),
    [anon_sym_else] = ACTIONS(13461),
    [anon_sym_try] = ACTIONS(13461),
    [anon_sym_for] = ACTIONS(13461),
    [anon_sym_while] = ACTIONS(13461),
    [sym_break_statement] = ACTIONS(13461),
    [sym_continue_statement] = ACTIONS(13461),
    [anon_sym_return] = ACTIONS(13461),
    [anon_sym_const] = ACTIONS(13461),
    [anon_sym_global] = ACTIONS(13461),
    [anon_sym_local] = ACTIONS(13461),
    [anon_sym_LPAREN] = ACTIONS(13461),
    [anon_sym_COLON2] = ACTIONS(13461),
    [anon_sym_export] = ACTIONS(13461),
    [anon_sym_import] = ACTIONS(13461),
    [anon_sym_using] = ACTIONS(13461),
    [anon_sym_LBRACK] = ACTIONS(13461),
    [anon_sym_LF] = ACTIONS(13463),
    [anon_sym_in] = ACTIONS(13461),
    [anon_sym_LBRACE] = ACTIONS(13461),
    [anon_sym_DOLLAR] = ACTIONS(13461),
    [anon_sym_COLON_COLON] = ACTIONS(13461),
    [anon_sym_isa] = ACTIONS(13461),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13461),
    [anon_sym_QMARK] = ACTIONS(13461),
    [anon_sym_AT] = ACTIONS(13461),
    [anon_sym_true] = ACTIONS(13461),
    [anon_sym_false] = ACTIONS(13461),
    [aux_sym_integer_literal_token1] = ACTIONS(13461),
    [aux_sym_integer_literal_token2] = ACTIONS(13461),
    [aux_sym_integer_literal_token3] = ACTIONS(13461),
    [aux_sym_integer_literal_token4] = ACTIONS(13461),
    [aux_sym_float_literal_token1] = ACTIONS(13461),
    [aux_sym_float_literal_token3] = ACTIONS(13461),
    [aux_sym_float_literal_token4] = ACTIONS(13461),
    [sym_character_literal] = ACTIONS(13461),
    [sym__pair_operator] = ACTIONS(13461),
    [sym__arrow_operator] = ACTIONS(13461),
    [sym__lazy_or_operator] = ACTIONS(13461),
    [sym__lazy_and_operator] = ACTIONS(13461),
    [sym__comparison_operator] = ACTIONS(13461),
    [sym__pipe_right_operator] = ACTIONS(13461),
    [sym__pipe_left_operator] = ACTIONS(13461),
    [sym__ellipsis_operator] = ACTIONS(13461),
    [sym__plus_operator] = ACTIONS(13461),
    [sym__times_operator] = ACTIONS(13461),
    [sym__rational_operator] = ACTIONS(13461),
    [sym__bitshift_operator] = ACTIONS(13461),
    [sym__power_operator] = ACTIONS(13461),
    [sym__tilde_operator] = ACTIONS(13461),
    [sym__type_order_operator] = ACTIONS(13461),
    [sym__unary_operator] = ACTIONS(13461),
    [sym__unary_plus_operator] = ACTIONS(13461),
    [aux_sym__terminator_token1] = ACTIONS(13461),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13463),
    [sym__command_start] = ACTIONS(13463),
  },
  [7424] = {
    [aux_sym_open_tuple_repeat1] = STATE(7255),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(12928),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_elseif] = ACTIONS(13249),
    [anon_sym_else] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13324),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7425] = {
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13070),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_end] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_elseif] = ACTIONS(13070),
    [anon_sym_else] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(12940),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [7426] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12610),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12508),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7427] = {
    [ts_builtin_sym_end] = ACTIONS(13336),
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_EQ] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_RPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_RBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [7428] = {
    [ts_builtin_sym_end] = ACTIONS(13465),
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_EQ] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_RPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_RBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [7429] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7430] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7431] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7432] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7433] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7434] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(13469),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7435] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7436] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7437] = {
    [sym__comprehension_clause] = STATE(18897),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16844),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13471),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13473),
    [anon_sym_LF] = ACTIONS(13475),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13478),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7438] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7439] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7440] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7441] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7442] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7443] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7444] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(13306),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7445] = {
    [sym__word_identifier] = ACTIONS(13481),
    [anon_sym_EQ] = ACTIONS(13481),
    [anon_sym_COMMA] = ACTIONS(13481),
    [anon_sym_COLON] = ACTIONS(13481),
    [anon_sym_begin] = ACTIONS(13481),
    [anon_sym_module] = ACTIONS(13481),
    [anon_sym_baremodule] = ACTIONS(13481),
    [anon_sym_end] = ACTIONS(13481),
    [anon_sym_abstract] = ACTIONS(13481),
    [anon_sym_primitive] = ACTIONS(13481),
    [anon_sym_mutable] = ACTIONS(13481),
    [anon_sym_struct] = ACTIONS(13481),
    [anon_sym_function] = ACTIONS(13481),
    [anon_sym_macro] = ACTIONS(13481),
    [anon_sym_where] = ACTIONS(13481),
    [anon_sym_quote] = ACTIONS(13481),
    [anon_sym_let] = ACTIONS(13481),
    [anon_sym_if] = ACTIONS(13481),
    [anon_sym_elseif] = ACTIONS(13481),
    [anon_sym_else] = ACTIONS(13481),
    [anon_sym_try] = ACTIONS(13481),
    [anon_sym_for] = ACTIONS(13481),
    [anon_sym_while] = ACTIONS(13481),
    [sym_break_statement] = ACTIONS(13481),
    [sym_continue_statement] = ACTIONS(13481),
    [anon_sym_return] = ACTIONS(13481),
    [anon_sym_const] = ACTIONS(13481),
    [anon_sym_global] = ACTIONS(13481),
    [anon_sym_local] = ACTIONS(13481),
    [anon_sym_LPAREN] = ACTIONS(13481),
    [anon_sym_COLON2] = ACTIONS(13481),
    [anon_sym_export] = ACTIONS(13481),
    [anon_sym_import] = ACTIONS(13481),
    [anon_sym_using] = ACTIONS(13481),
    [anon_sym_LBRACK] = ACTIONS(13481),
    [anon_sym_LF] = ACTIONS(13483),
    [anon_sym_in] = ACTIONS(13481),
    [anon_sym_LBRACE] = ACTIONS(13481),
    [anon_sym_DOLLAR] = ACTIONS(13481),
    [anon_sym_COLON_COLON] = ACTIONS(13481),
    [anon_sym_isa] = ACTIONS(13481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13481),
    [anon_sym_QMARK] = ACTIONS(13481),
    [anon_sym_AT] = ACTIONS(13481),
    [anon_sym_true] = ACTIONS(13481),
    [anon_sym_false] = ACTIONS(13481),
    [aux_sym_integer_literal_token1] = ACTIONS(13481),
    [aux_sym_integer_literal_token2] = ACTIONS(13481),
    [aux_sym_integer_literal_token3] = ACTIONS(13481),
    [aux_sym_integer_literal_token4] = ACTIONS(13481),
    [aux_sym_float_literal_token1] = ACTIONS(13481),
    [aux_sym_float_literal_token3] = ACTIONS(13481),
    [aux_sym_float_literal_token4] = ACTIONS(13481),
    [sym_character_literal] = ACTIONS(13481),
    [sym__pair_operator] = ACTIONS(13481),
    [sym__arrow_operator] = ACTIONS(13481),
    [sym__lazy_or_operator] = ACTIONS(13481),
    [sym__lazy_and_operator] = ACTIONS(13481),
    [sym__comparison_operator] = ACTIONS(13481),
    [sym__pipe_right_operator] = ACTIONS(13481),
    [sym__pipe_left_operator] = ACTIONS(13481),
    [sym__ellipsis_operator] = ACTIONS(13481),
    [sym__plus_operator] = ACTIONS(13481),
    [sym__times_operator] = ACTIONS(13481),
    [sym__rational_operator] = ACTIONS(13481),
    [sym__bitshift_operator] = ACTIONS(13481),
    [sym__power_operator] = ACTIONS(13481),
    [sym__tilde_operator] = ACTIONS(13481),
    [sym__type_order_operator] = ACTIONS(13481),
    [sym__unary_operator] = ACTIONS(13481),
    [sym__unary_plus_operator] = ACTIONS(13481),
    [aux_sym__terminator_token1] = ACTIONS(13481),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13483),
    [sym__command_start] = ACTIONS(13483),
  },
  [7446] = {
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13255),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_else] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_finally] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13255),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13255),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13255),
    [anon_sym_isa] = ACTIONS(13255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13255),
    [anon_sym_QMARK] = ACTIONS(13255),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13255),
    [sym__arrow_operator] = ACTIONS(13255),
    [sym__lazy_or_operator] = ACTIONS(13255),
    [sym__lazy_and_operator] = ACTIONS(13255),
    [sym__comparison_operator] = ACTIONS(13255),
    [sym__pipe_right_operator] = ACTIONS(13255),
    [sym__pipe_left_operator] = ACTIONS(13255),
    [sym__ellipsis_operator] = ACTIONS(13255),
    [sym__plus_operator] = ACTIONS(13255),
    [sym__times_operator] = ACTIONS(13255),
    [sym__rational_operator] = ACTIONS(13255),
    [sym__bitshift_operator] = ACTIONS(13255),
    [sym__power_operator] = ACTIONS(13255),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13255),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13255),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [7447] = {
    [sym__word_identifier] = ACTIONS(13485),
    [anon_sym_EQ] = ACTIONS(13485),
    [anon_sym_COMMA] = ACTIONS(13485),
    [anon_sym_COLON] = ACTIONS(13485),
    [anon_sym_begin] = ACTIONS(13485),
    [anon_sym_module] = ACTIONS(13485),
    [anon_sym_baremodule] = ACTIONS(13485),
    [anon_sym_end] = ACTIONS(13485),
    [anon_sym_abstract] = ACTIONS(13485),
    [anon_sym_primitive] = ACTIONS(13485),
    [anon_sym_mutable] = ACTIONS(13485),
    [anon_sym_struct] = ACTIONS(13485),
    [anon_sym_function] = ACTIONS(13485),
    [anon_sym_macro] = ACTIONS(13485),
    [anon_sym_where] = ACTIONS(13485),
    [anon_sym_quote] = ACTIONS(13485),
    [anon_sym_let] = ACTIONS(13485),
    [anon_sym_if] = ACTIONS(13485),
    [anon_sym_elseif] = ACTIONS(13485),
    [anon_sym_else] = ACTIONS(13485),
    [anon_sym_try] = ACTIONS(13485),
    [anon_sym_for] = ACTIONS(13485),
    [anon_sym_while] = ACTIONS(13485),
    [sym_break_statement] = ACTIONS(13485),
    [sym_continue_statement] = ACTIONS(13485),
    [anon_sym_return] = ACTIONS(13485),
    [anon_sym_const] = ACTIONS(13485),
    [anon_sym_global] = ACTIONS(13485),
    [anon_sym_local] = ACTIONS(13485),
    [anon_sym_LPAREN] = ACTIONS(13485),
    [anon_sym_COLON2] = ACTIONS(13485),
    [anon_sym_export] = ACTIONS(13485),
    [anon_sym_import] = ACTIONS(13485),
    [anon_sym_using] = ACTIONS(13485),
    [anon_sym_LBRACK] = ACTIONS(13485),
    [anon_sym_LF] = ACTIONS(13487),
    [anon_sym_in] = ACTIONS(13485),
    [anon_sym_LBRACE] = ACTIONS(13485),
    [anon_sym_DOLLAR] = ACTIONS(13485),
    [anon_sym_COLON_COLON] = ACTIONS(13485),
    [anon_sym_isa] = ACTIONS(13485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13485),
    [anon_sym_QMARK] = ACTIONS(13485),
    [anon_sym_AT] = ACTIONS(13485),
    [anon_sym_true] = ACTIONS(13485),
    [anon_sym_false] = ACTIONS(13485),
    [aux_sym_integer_literal_token1] = ACTIONS(13485),
    [aux_sym_integer_literal_token2] = ACTIONS(13485),
    [aux_sym_integer_literal_token3] = ACTIONS(13485),
    [aux_sym_integer_literal_token4] = ACTIONS(13485),
    [aux_sym_float_literal_token1] = ACTIONS(13485),
    [aux_sym_float_literal_token3] = ACTIONS(13485),
    [aux_sym_float_literal_token4] = ACTIONS(13485),
    [sym_character_literal] = ACTIONS(13485),
    [sym__pair_operator] = ACTIONS(13485),
    [sym__arrow_operator] = ACTIONS(13485),
    [sym__lazy_or_operator] = ACTIONS(13485),
    [sym__lazy_and_operator] = ACTIONS(13485),
    [sym__comparison_operator] = ACTIONS(13485),
    [sym__pipe_right_operator] = ACTIONS(13485),
    [sym__pipe_left_operator] = ACTIONS(13485),
    [sym__ellipsis_operator] = ACTIONS(13485),
    [sym__plus_operator] = ACTIONS(13485),
    [sym__times_operator] = ACTIONS(13485),
    [sym__rational_operator] = ACTIONS(13485),
    [sym__bitshift_operator] = ACTIONS(13485),
    [sym__power_operator] = ACTIONS(13485),
    [sym__tilde_operator] = ACTIONS(13485),
    [sym__type_order_operator] = ACTIONS(13485),
    [sym__unary_operator] = ACTIONS(13485),
    [sym__unary_plus_operator] = ACTIONS(13485),
    [aux_sym__terminator_token1] = ACTIONS(13485),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13487),
    [sym__command_start] = ACTIONS(13487),
  },
  [7448] = {
    [sym__word_identifier] = ACTIONS(13413),
    [anon_sym_EQ] = ACTIONS(13413),
    [anon_sym_COMMA] = ACTIONS(13413),
    [anon_sym_COLON] = ACTIONS(13413),
    [anon_sym_begin] = ACTIONS(13413),
    [anon_sym_module] = ACTIONS(13413),
    [anon_sym_baremodule] = ACTIONS(13413),
    [anon_sym_end] = ACTIONS(13413),
    [anon_sym_abstract] = ACTIONS(13413),
    [anon_sym_primitive] = ACTIONS(13413),
    [anon_sym_mutable] = ACTIONS(13413),
    [anon_sym_struct] = ACTIONS(13413),
    [anon_sym_function] = ACTIONS(13413),
    [anon_sym_macro] = ACTIONS(13413),
    [anon_sym_where] = ACTIONS(13413),
    [anon_sym_quote] = ACTIONS(13413),
    [anon_sym_let] = ACTIONS(13413),
    [anon_sym_if] = ACTIONS(13413),
    [anon_sym_else] = ACTIONS(13413),
    [anon_sym_try] = ACTIONS(13413),
    [anon_sym_finally] = ACTIONS(13413),
    [anon_sym_for] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(13413),
    [sym_break_statement] = ACTIONS(13413),
    [sym_continue_statement] = ACTIONS(13413),
    [anon_sym_return] = ACTIONS(13413),
    [anon_sym_const] = ACTIONS(13413),
    [anon_sym_global] = ACTIONS(13413),
    [anon_sym_local] = ACTIONS(13413),
    [anon_sym_LPAREN] = ACTIONS(13413),
    [anon_sym_COLON2] = ACTIONS(13413),
    [anon_sym_export] = ACTIONS(13413),
    [anon_sym_import] = ACTIONS(13413),
    [anon_sym_using] = ACTIONS(13413),
    [anon_sym_LBRACK] = ACTIONS(13413),
    [anon_sym_LF] = ACTIONS(13415),
    [anon_sym_in] = ACTIONS(13413),
    [anon_sym_LBRACE] = ACTIONS(13413),
    [anon_sym_DOLLAR] = ACTIONS(13413),
    [anon_sym_COLON_COLON] = ACTIONS(13413),
    [anon_sym_isa] = ACTIONS(13413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_QMARK] = ACTIONS(13413),
    [anon_sym_AT] = ACTIONS(13413),
    [anon_sym_true] = ACTIONS(13413),
    [anon_sym_false] = ACTIONS(13413),
    [aux_sym_integer_literal_token1] = ACTIONS(13413),
    [aux_sym_integer_literal_token2] = ACTIONS(13413),
    [aux_sym_integer_literal_token3] = ACTIONS(13413),
    [aux_sym_integer_literal_token4] = ACTIONS(13413),
    [aux_sym_float_literal_token1] = ACTIONS(13413),
    [aux_sym_float_literal_token3] = ACTIONS(13413),
    [aux_sym_float_literal_token4] = ACTIONS(13413),
    [sym_character_literal] = ACTIONS(13413),
    [sym__pair_operator] = ACTIONS(13413),
    [sym__arrow_operator] = ACTIONS(13413),
    [sym__lazy_or_operator] = ACTIONS(13413),
    [sym__lazy_and_operator] = ACTIONS(13413),
    [sym__comparison_operator] = ACTIONS(13413),
    [sym__pipe_right_operator] = ACTIONS(13413),
    [sym__pipe_left_operator] = ACTIONS(13413),
    [sym__ellipsis_operator] = ACTIONS(13413),
    [sym__plus_operator] = ACTIONS(13413),
    [sym__times_operator] = ACTIONS(13413),
    [sym__rational_operator] = ACTIONS(13413),
    [sym__bitshift_operator] = ACTIONS(13413),
    [sym__power_operator] = ACTIONS(13413),
    [sym__tilde_operator] = ACTIONS(13413),
    [sym__type_order_operator] = ACTIONS(13413),
    [sym__unary_operator] = ACTIONS(13413),
    [sym__unary_plus_operator] = ACTIONS(13413),
    [aux_sym__terminator_token1] = ACTIONS(13413),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13415),
    [sym__command_start] = ACTIONS(13415),
  },
  [7449] = {
    [sym__word_identifier] = ACTIONS(13417),
    [anon_sym_EQ] = ACTIONS(13417),
    [anon_sym_COMMA] = ACTIONS(13417),
    [anon_sym_COLON] = ACTIONS(13417),
    [anon_sym_begin] = ACTIONS(13417),
    [anon_sym_module] = ACTIONS(13417),
    [anon_sym_baremodule] = ACTIONS(13417),
    [anon_sym_end] = ACTIONS(13417),
    [anon_sym_abstract] = ACTIONS(13417),
    [anon_sym_primitive] = ACTIONS(13417),
    [anon_sym_mutable] = ACTIONS(13417),
    [anon_sym_struct] = ACTIONS(13417),
    [anon_sym_function] = ACTIONS(13417),
    [anon_sym_macro] = ACTIONS(13417),
    [anon_sym_where] = ACTIONS(13417),
    [anon_sym_quote] = ACTIONS(13417),
    [anon_sym_let] = ACTIONS(13417),
    [anon_sym_if] = ACTIONS(13417),
    [anon_sym_else] = ACTIONS(13417),
    [anon_sym_try] = ACTIONS(13417),
    [anon_sym_finally] = ACTIONS(13417),
    [anon_sym_for] = ACTIONS(13417),
    [anon_sym_while] = ACTIONS(13417),
    [sym_break_statement] = ACTIONS(13417),
    [sym_continue_statement] = ACTIONS(13417),
    [anon_sym_return] = ACTIONS(13417),
    [anon_sym_const] = ACTIONS(13417),
    [anon_sym_global] = ACTIONS(13417),
    [anon_sym_local] = ACTIONS(13417),
    [anon_sym_LPAREN] = ACTIONS(13417),
    [anon_sym_COLON2] = ACTIONS(13417),
    [anon_sym_export] = ACTIONS(13417),
    [anon_sym_import] = ACTIONS(13417),
    [anon_sym_using] = ACTIONS(13417),
    [anon_sym_LBRACK] = ACTIONS(13417),
    [anon_sym_LF] = ACTIONS(13419),
    [anon_sym_in] = ACTIONS(13417),
    [anon_sym_LBRACE] = ACTIONS(13417),
    [anon_sym_DOLLAR] = ACTIONS(13417),
    [anon_sym_COLON_COLON] = ACTIONS(13417),
    [anon_sym_isa] = ACTIONS(13417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13417),
    [anon_sym_QMARK] = ACTIONS(13417),
    [anon_sym_AT] = ACTIONS(13417),
    [anon_sym_true] = ACTIONS(13417),
    [anon_sym_false] = ACTIONS(13417),
    [aux_sym_integer_literal_token1] = ACTIONS(13417),
    [aux_sym_integer_literal_token2] = ACTIONS(13417),
    [aux_sym_integer_literal_token3] = ACTIONS(13417),
    [aux_sym_integer_literal_token4] = ACTIONS(13417),
    [aux_sym_float_literal_token1] = ACTIONS(13417),
    [aux_sym_float_literal_token3] = ACTIONS(13417),
    [aux_sym_float_literal_token4] = ACTIONS(13417),
    [sym_character_literal] = ACTIONS(13417),
    [sym__pair_operator] = ACTIONS(13417),
    [sym__arrow_operator] = ACTIONS(13417),
    [sym__lazy_or_operator] = ACTIONS(13417),
    [sym__lazy_and_operator] = ACTIONS(13417),
    [sym__comparison_operator] = ACTIONS(13417),
    [sym__pipe_right_operator] = ACTIONS(13417),
    [sym__pipe_left_operator] = ACTIONS(13417),
    [sym__ellipsis_operator] = ACTIONS(13417),
    [sym__plus_operator] = ACTIONS(13417),
    [sym__times_operator] = ACTIONS(13417),
    [sym__rational_operator] = ACTIONS(13417),
    [sym__bitshift_operator] = ACTIONS(13417),
    [sym__power_operator] = ACTIONS(13417),
    [sym__tilde_operator] = ACTIONS(13417),
    [sym__type_order_operator] = ACTIONS(13417),
    [sym__unary_operator] = ACTIONS(13417),
    [sym__unary_plus_operator] = ACTIONS(13417),
    [aux_sym__terminator_token1] = ACTIONS(13417),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13419),
    [sym__command_start] = ACTIONS(13419),
  },
  [7450] = {
    [sym__word_identifier] = ACTIONS(13421),
    [anon_sym_EQ] = ACTIONS(13421),
    [anon_sym_COMMA] = ACTIONS(13421),
    [anon_sym_COLON] = ACTIONS(13421),
    [anon_sym_begin] = ACTIONS(13421),
    [anon_sym_module] = ACTIONS(13421),
    [anon_sym_baremodule] = ACTIONS(13421),
    [anon_sym_end] = ACTIONS(13421),
    [anon_sym_abstract] = ACTIONS(13421),
    [anon_sym_primitive] = ACTIONS(13421),
    [anon_sym_mutable] = ACTIONS(13421),
    [anon_sym_struct] = ACTIONS(13421),
    [anon_sym_function] = ACTIONS(13421),
    [anon_sym_macro] = ACTIONS(13421),
    [anon_sym_where] = ACTIONS(13421),
    [anon_sym_quote] = ACTIONS(13421),
    [anon_sym_let] = ACTIONS(13421),
    [anon_sym_if] = ACTIONS(13421),
    [anon_sym_else] = ACTIONS(13421),
    [anon_sym_try] = ACTIONS(13421),
    [anon_sym_finally] = ACTIONS(13421),
    [anon_sym_for] = ACTIONS(13421),
    [anon_sym_while] = ACTIONS(13421),
    [sym_break_statement] = ACTIONS(13421),
    [sym_continue_statement] = ACTIONS(13421),
    [anon_sym_return] = ACTIONS(13421),
    [anon_sym_const] = ACTIONS(13421),
    [anon_sym_global] = ACTIONS(13421),
    [anon_sym_local] = ACTIONS(13421),
    [anon_sym_LPAREN] = ACTIONS(13421),
    [anon_sym_COLON2] = ACTIONS(13421),
    [anon_sym_export] = ACTIONS(13421),
    [anon_sym_import] = ACTIONS(13421),
    [anon_sym_using] = ACTIONS(13421),
    [anon_sym_LBRACK] = ACTIONS(13421),
    [anon_sym_LF] = ACTIONS(13423),
    [anon_sym_in] = ACTIONS(13421),
    [anon_sym_LBRACE] = ACTIONS(13421),
    [anon_sym_DOLLAR] = ACTIONS(13421),
    [anon_sym_COLON_COLON] = ACTIONS(13421),
    [anon_sym_isa] = ACTIONS(13421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13421),
    [anon_sym_QMARK] = ACTIONS(13421),
    [anon_sym_AT] = ACTIONS(13421),
    [anon_sym_true] = ACTIONS(13421),
    [anon_sym_false] = ACTIONS(13421),
    [aux_sym_integer_literal_token1] = ACTIONS(13421),
    [aux_sym_integer_literal_token2] = ACTIONS(13421),
    [aux_sym_integer_literal_token3] = ACTIONS(13421),
    [aux_sym_integer_literal_token4] = ACTIONS(13421),
    [aux_sym_float_literal_token1] = ACTIONS(13421),
    [aux_sym_float_literal_token3] = ACTIONS(13421),
    [aux_sym_float_literal_token4] = ACTIONS(13421),
    [sym_character_literal] = ACTIONS(13421),
    [sym__pair_operator] = ACTIONS(13421),
    [sym__arrow_operator] = ACTIONS(13421),
    [sym__lazy_or_operator] = ACTIONS(13421),
    [sym__lazy_and_operator] = ACTIONS(13421),
    [sym__comparison_operator] = ACTIONS(13421),
    [sym__pipe_right_operator] = ACTIONS(13421),
    [sym__pipe_left_operator] = ACTIONS(13421),
    [sym__ellipsis_operator] = ACTIONS(13421),
    [sym__plus_operator] = ACTIONS(13421),
    [sym__times_operator] = ACTIONS(13421),
    [sym__rational_operator] = ACTIONS(13421),
    [sym__bitshift_operator] = ACTIONS(13421),
    [sym__power_operator] = ACTIONS(13421),
    [sym__tilde_operator] = ACTIONS(13421),
    [sym__type_order_operator] = ACTIONS(13421),
    [sym__unary_operator] = ACTIONS(13421),
    [sym__unary_plus_operator] = ACTIONS(13421),
    [aux_sym__terminator_token1] = ACTIONS(13421),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13423),
    [sym__command_start] = ACTIONS(13423),
  },
  [7451] = {
    [sym__word_identifier] = ACTIONS(13425),
    [anon_sym_EQ] = ACTIONS(13425),
    [anon_sym_COMMA] = ACTIONS(13425),
    [anon_sym_COLON] = ACTIONS(13425),
    [anon_sym_begin] = ACTIONS(13425),
    [anon_sym_module] = ACTIONS(13425),
    [anon_sym_baremodule] = ACTIONS(13425),
    [anon_sym_end] = ACTIONS(13425),
    [anon_sym_abstract] = ACTIONS(13425),
    [anon_sym_primitive] = ACTIONS(13425),
    [anon_sym_mutable] = ACTIONS(13425),
    [anon_sym_struct] = ACTIONS(13425),
    [anon_sym_function] = ACTIONS(13425),
    [anon_sym_macro] = ACTIONS(13425),
    [anon_sym_where] = ACTIONS(13425),
    [anon_sym_quote] = ACTIONS(13425),
    [anon_sym_let] = ACTIONS(13425),
    [anon_sym_if] = ACTIONS(13425),
    [anon_sym_else] = ACTIONS(13425),
    [anon_sym_try] = ACTIONS(13425),
    [anon_sym_finally] = ACTIONS(13425),
    [anon_sym_for] = ACTIONS(13425),
    [anon_sym_while] = ACTIONS(13425),
    [sym_break_statement] = ACTIONS(13425),
    [sym_continue_statement] = ACTIONS(13425),
    [anon_sym_return] = ACTIONS(13425),
    [anon_sym_const] = ACTIONS(13425),
    [anon_sym_global] = ACTIONS(13425),
    [anon_sym_local] = ACTIONS(13425),
    [anon_sym_LPAREN] = ACTIONS(13425),
    [anon_sym_COLON2] = ACTIONS(13425),
    [anon_sym_export] = ACTIONS(13425),
    [anon_sym_import] = ACTIONS(13425),
    [anon_sym_using] = ACTIONS(13425),
    [anon_sym_LBRACK] = ACTIONS(13425),
    [anon_sym_LF] = ACTIONS(13427),
    [anon_sym_in] = ACTIONS(13425),
    [anon_sym_LBRACE] = ACTIONS(13425),
    [anon_sym_DOLLAR] = ACTIONS(13425),
    [anon_sym_COLON_COLON] = ACTIONS(13425),
    [anon_sym_isa] = ACTIONS(13425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13425),
    [anon_sym_QMARK] = ACTIONS(13425),
    [anon_sym_AT] = ACTIONS(13425),
    [anon_sym_true] = ACTIONS(13425),
    [anon_sym_false] = ACTIONS(13425),
    [aux_sym_integer_literal_token1] = ACTIONS(13425),
    [aux_sym_integer_literal_token2] = ACTIONS(13425),
    [aux_sym_integer_literal_token3] = ACTIONS(13425),
    [aux_sym_integer_literal_token4] = ACTIONS(13425),
    [aux_sym_float_literal_token1] = ACTIONS(13425),
    [aux_sym_float_literal_token3] = ACTIONS(13425),
    [aux_sym_float_literal_token4] = ACTIONS(13425),
    [sym_character_literal] = ACTIONS(13425),
    [sym__pair_operator] = ACTIONS(13425),
    [sym__arrow_operator] = ACTIONS(13425),
    [sym__lazy_or_operator] = ACTIONS(13425),
    [sym__lazy_and_operator] = ACTIONS(13425),
    [sym__comparison_operator] = ACTIONS(13425),
    [sym__pipe_right_operator] = ACTIONS(13425),
    [sym__pipe_left_operator] = ACTIONS(13425),
    [sym__ellipsis_operator] = ACTIONS(13425),
    [sym__plus_operator] = ACTIONS(13425),
    [sym__times_operator] = ACTIONS(13425),
    [sym__rational_operator] = ACTIONS(13425),
    [sym__bitshift_operator] = ACTIONS(13425),
    [sym__power_operator] = ACTIONS(13425),
    [sym__tilde_operator] = ACTIONS(13425),
    [sym__type_order_operator] = ACTIONS(13425),
    [sym__unary_operator] = ACTIONS(13425),
    [sym__unary_plus_operator] = ACTIONS(13425),
    [aux_sym__terminator_token1] = ACTIONS(13425),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13427),
    [sym__command_start] = ACTIONS(13427),
  },
  [7452] = {
    [sym__word_identifier] = ACTIONS(13429),
    [anon_sym_EQ] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(13429),
    [anon_sym_COLON] = ACTIONS(13429),
    [anon_sym_begin] = ACTIONS(13429),
    [anon_sym_module] = ACTIONS(13429),
    [anon_sym_baremodule] = ACTIONS(13429),
    [anon_sym_end] = ACTIONS(13429),
    [anon_sym_abstract] = ACTIONS(13429),
    [anon_sym_primitive] = ACTIONS(13429),
    [anon_sym_mutable] = ACTIONS(13429),
    [anon_sym_struct] = ACTIONS(13429),
    [anon_sym_function] = ACTIONS(13429),
    [anon_sym_macro] = ACTIONS(13429),
    [anon_sym_where] = ACTIONS(13429),
    [anon_sym_quote] = ACTIONS(13429),
    [anon_sym_let] = ACTIONS(13429),
    [anon_sym_if] = ACTIONS(13429),
    [anon_sym_else] = ACTIONS(13429),
    [anon_sym_try] = ACTIONS(13429),
    [anon_sym_finally] = ACTIONS(13429),
    [anon_sym_for] = ACTIONS(13429),
    [anon_sym_while] = ACTIONS(13429),
    [sym_break_statement] = ACTIONS(13429),
    [sym_continue_statement] = ACTIONS(13429),
    [anon_sym_return] = ACTIONS(13429),
    [anon_sym_const] = ACTIONS(13429),
    [anon_sym_global] = ACTIONS(13429),
    [anon_sym_local] = ACTIONS(13429),
    [anon_sym_LPAREN] = ACTIONS(13429),
    [anon_sym_COLON2] = ACTIONS(13429),
    [anon_sym_export] = ACTIONS(13429),
    [anon_sym_import] = ACTIONS(13429),
    [anon_sym_using] = ACTIONS(13429),
    [anon_sym_LBRACK] = ACTIONS(13429),
    [anon_sym_LF] = ACTIONS(13431),
    [anon_sym_in] = ACTIONS(13429),
    [anon_sym_LBRACE] = ACTIONS(13429),
    [anon_sym_DOLLAR] = ACTIONS(13429),
    [anon_sym_COLON_COLON] = ACTIONS(13429),
    [anon_sym_isa] = ACTIONS(13429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13429),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_AT] = ACTIONS(13429),
    [anon_sym_true] = ACTIONS(13429),
    [anon_sym_false] = ACTIONS(13429),
    [aux_sym_integer_literal_token1] = ACTIONS(13429),
    [aux_sym_integer_literal_token2] = ACTIONS(13429),
    [aux_sym_integer_literal_token3] = ACTIONS(13429),
    [aux_sym_integer_literal_token4] = ACTIONS(13429),
    [aux_sym_float_literal_token1] = ACTIONS(13429),
    [aux_sym_float_literal_token3] = ACTIONS(13429),
    [aux_sym_float_literal_token4] = ACTIONS(13429),
    [sym_character_literal] = ACTIONS(13429),
    [sym__pair_operator] = ACTIONS(13429),
    [sym__arrow_operator] = ACTIONS(13429),
    [sym__lazy_or_operator] = ACTIONS(13429),
    [sym__lazy_and_operator] = ACTIONS(13429),
    [sym__comparison_operator] = ACTIONS(13429),
    [sym__pipe_right_operator] = ACTIONS(13429),
    [sym__pipe_left_operator] = ACTIONS(13429),
    [sym__ellipsis_operator] = ACTIONS(13429),
    [sym__plus_operator] = ACTIONS(13429),
    [sym__times_operator] = ACTIONS(13429),
    [sym__rational_operator] = ACTIONS(13429),
    [sym__bitshift_operator] = ACTIONS(13429),
    [sym__power_operator] = ACTIONS(13429),
    [sym__tilde_operator] = ACTIONS(13429),
    [sym__type_order_operator] = ACTIONS(13429),
    [sym__unary_operator] = ACTIONS(13429),
    [sym__unary_plus_operator] = ACTIONS(13429),
    [aux_sym__terminator_token1] = ACTIONS(13429),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13431),
    [sym__command_start] = ACTIONS(13431),
  },
  [7453] = {
    [sym__word_identifier] = ACTIONS(13433),
    [anon_sym_EQ] = ACTIONS(13433),
    [anon_sym_COMMA] = ACTIONS(13433),
    [anon_sym_COLON] = ACTIONS(13433),
    [anon_sym_begin] = ACTIONS(13433),
    [anon_sym_module] = ACTIONS(13433),
    [anon_sym_baremodule] = ACTIONS(13433),
    [anon_sym_end] = ACTIONS(13433),
    [anon_sym_abstract] = ACTIONS(13433),
    [anon_sym_primitive] = ACTIONS(13433),
    [anon_sym_mutable] = ACTIONS(13433),
    [anon_sym_struct] = ACTIONS(13433),
    [anon_sym_function] = ACTIONS(13433),
    [anon_sym_macro] = ACTIONS(13433),
    [anon_sym_where] = ACTIONS(13433),
    [anon_sym_quote] = ACTIONS(13433),
    [anon_sym_let] = ACTIONS(13433),
    [anon_sym_if] = ACTIONS(13433),
    [anon_sym_else] = ACTIONS(13433),
    [anon_sym_try] = ACTIONS(13433),
    [anon_sym_finally] = ACTIONS(13433),
    [anon_sym_for] = ACTIONS(13433),
    [anon_sym_while] = ACTIONS(13433),
    [sym_break_statement] = ACTIONS(13433),
    [sym_continue_statement] = ACTIONS(13433),
    [anon_sym_return] = ACTIONS(13433),
    [anon_sym_const] = ACTIONS(13433),
    [anon_sym_global] = ACTIONS(13433),
    [anon_sym_local] = ACTIONS(13433),
    [anon_sym_LPAREN] = ACTIONS(13433),
    [anon_sym_COLON2] = ACTIONS(13433),
    [anon_sym_export] = ACTIONS(13433),
    [anon_sym_import] = ACTIONS(13433),
    [anon_sym_using] = ACTIONS(13433),
    [anon_sym_LBRACK] = ACTIONS(13433),
    [anon_sym_LF] = ACTIONS(13435),
    [anon_sym_in] = ACTIONS(13433),
    [anon_sym_LBRACE] = ACTIONS(13433),
    [anon_sym_DOLLAR] = ACTIONS(13433),
    [anon_sym_COLON_COLON] = ACTIONS(13433),
    [anon_sym_isa] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13433),
    [anon_sym_QMARK] = ACTIONS(13433),
    [anon_sym_AT] = ACTIONS(13433),
    [anon_sym_true] = ACTIONS(13433),
    [anon_sym_false] = ACTIONS(13433),
    [aux_sym_integer_literal_token1] = ACTIONS(13433),
    [aux_sym_integer_literal_token2] = ACTIONS(13433),
    [aux_sym_integer_literal_token3] = ACTIONS(13433),
    [aux_sym_integer_literal_token4] = ACTIONS(13433),
    [aux_sym_float_literal_token1] = ACTIONS(13433),
    [aux_sym_float_literal_token3] = ACTIONS(13433),
    [aux_sym_float_literal_token4] = ACTIONS(13433),
    [sym_character_literal] = ACTIONS(13433),
    [sym__pair_operator] = ACTIONS(13433),
    [sym__arrow_operator] = ACTIONS(13433),
    [sym__lazy_or_operator] = ACTIONS(13433),
    [sym__lazy_and_operator] = ACTIONS(13433),
    [sym__comparison_operator] = ACTIONS(13433),
    [sym__pipe_right_operator] = ACTIONS(13433),
    [sym__pipe_left_operator] = ACTIONS(13433),
    [sym__ellipsis_operator] = ACTIONS(13433),
    [sym__plus_operator] = ACTIONS(13433),
    [sym__times_operator] = ACTIONS(13433),
    [sym__rational_operator] = ACTIONS(13433),
    [sym__bitshift_operator] = ACTIONS(13433),
    [sym__power_operator] = ACTIONS(13433),
    [sym__tilde_operator] = ACTIONS(13433),
    [sym__type_order_operator] = ACTIONS(13433),
    [sym__unary_operator] = ACTIONS(13433),
    [sym__unary_plus_operator] = ACTIONS(13433),
    [aux_sym__terminator_token1] = ACTIONS(13433),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13435),
    [sym__command_start] = ACTIONS(13435),
  },
  [7454] = {
    [sym__word_identifier] = ACTIONS(13437),
    [anon_sym_EQ] = ACTIONS(13437),
    [anon_sym_COMMA] = ACTIONS(13437),
    [anon_sym_COLON] = ACTIONS(13437),
    [anon_sym_begin] = ACTIONS(13437),
    [anon_sym_module] = ACTIONS(13437),
    [anon_sym_baremodule] = ACTIONS(13437),
    [anon_sym_end] = ACTIONS(13437),
    [anon_sym_abstract] = ACTIONS(13437),
    [anon_sym_primitive] = ACTIONS(13437),
    [anon_sym_mutable] = ACTIONS(13437),
    [anon_sym_struct] = ACTIONS(13437),
    [anon_sym_function] = ACTIONS(13437),
    [anon_sym_macro] = ACTIONS(13437),
    [anon_sym_where] = ACTIONS(13437),
    [anon_sym_quote] = ACTIONS(13437),
    [anon_sym_let] = ACTIONS(13437),
    [anon_sym_if] = ACTIONS(13437),
    [anon_sym_else] = ACTIONS(13437),
    [anon_sym_try] = ACTIONS(13437),
    [anon_sym_finally] = ACTIONS(13437),
    [anon_sym_for] = ACTIONS(13437),
    [anon_sym_while] = ACTIONS(13437),
    [sym_break_statement] = ACTIONS(13437),
    [sym_continue_statement] = ACTIONS(13437),
    [anon_sym_return] = ACTIONS(13437),
    [anon_sym_const] = ACTIONS(13437),
    [anon_sym_global] = ACTIONS(13437),
    [anon_sym_local] = ACTIONS(13437),
    [anon_sym_LPAREN] = ACTIONS(13437),
    [anon_sym_COLON2] = ACTIONS(13437),
    [anon_sym_export] = ACTIONS(13437),
    [anon_sym_import] = ACTIONS(13437),
    [anon_sym_using] = ACTIONS(13437),
    [anon_sym_LBRACK] = ACTIONS(13437),
    [anon_sym_LF] = ACTIONS(13439),
    [anon_sym_in] = ACTIONS(13437),
    [anon_sym_LBRACE] = ACTIONS(13437),
    [anon_sym_DOLLAR] = ACTIONS(13437),
    [anon_sym_COLON_COLON] = ACTIONS(13437),
    [anon_sym_isa] = ACTIONS(13437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13437),
    [anon_sym_QMARK] = ACTIONS(13437),
    [anon_sym_AT] = ACTIONS(13437),
    [anon_sym_true] = ACTIONS(13437),
    [anon_sym_false] = ACTIONS(13437),
    [aux_sym_integer_literal_token1] = ACTIONS(13437),
    [aux_sym_integer_literal_token2] = ACTIONS(13437),
    [aux_sym_integer_literal_token3] = ACTIONS(13437),
    [aux_sym_integer_literal_token4] = ACTIONS(13437),
    [aux_sym_float_literal_token1] = ACTIONS(13437),
    [aux_sym_float_literal_token3] = ACTIONS(13437),
    [aux_sym_float_literal_token4] = ACTIONS(13437),
    [sym_character_literal] = ACTIONS(13437),
    [sym__pair_operator] = ACTIONS(13437),
    [sym__arrow_operator] = ACTIONS(13437),
    [sym__lazy_or_operator] = ACTIONS(13437),
    [sym__lazy_and_operator] = ACTIONS(13437),
    [sym__comparison_operator] = ACTIONS(13437),
    [sym__pipe_right_operator] = ACTIONS(13437),
    [sym__pipe_left_operator] = ACTIONS(13437),
    [sym__ellipsis_operator] = ACTIONS(13437),
    [sym__plus_operator] = ACTIONS(13437),
    [sym__times_operator] = ACTIONS(13437),
    [sym__rational_operator] = ACTIONS(13437),
    [sym__bitshift_operator] = ACTIONS(13437),
    [sym__power_operator] = ACTIONS(13437),
    [sym__tilde_operator] = ACTIONS(13437),
    [sym__type_order_operator] = ACTIONS(13437),
    [sym__unary_operator] = ACTIONS(13437),
    [sym__unary_plus_operator] = ACTIONS(13437),
    [aux_sym__terminator_token1] = ACTIONS(13437),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13439),
    [sym__command_start] = ACTIONS(13439),
  },
  [7455] = {
    [sym__word_identifier] = ACTIONS(13441),
    [anon_sym_EQ] = ACTIONS(13441),
    [anon_sym_COMMA] = ACTIONS(13441),
    [anon_sym_COLON] = ACTIONS(13441),
    [anon_sym_begin] = ACTIONS(13441),
    [anon_sym_module] = ACTIONS(13441),
    [anon_sym_baremodule] = ACTIONS(13441),
    [anon_sym_end] = ACTIONS(13441),
    [anon_sym_abstract] = ACTIONS(13441),
    [anon_sym_primitive] = ACTIONS(13441),
    [anon_sym_mutable] = ACTIONS(13441),
    [anon_sym_struct] = ACTIONS(13441),
    [anon_sym_function] = ACTIONS(13441),
    [anon_sym_macro] = ACTIONS(13441),
    [anon_sym_where] = ACTIONS(13441),
    [anon_sym_quote] = ACTIONS(13441),
    [anon_sym_let] = ACTIONS(13441),
    [anon_sym_if] = ACTIONS(13441),
    [anon_sym_else] = ACTIONS(13441),
    [anon_sym_try] = ACTIONS(13441),
    [anon_sym_finally] = ACTIONS(13441),
    [anon_sym_for] = ACTIONS(13441),
    [anon_sym_while] = ACTIONS(13441),
    [sym_break_statement] = ACTIONS(13441),
    [sym_continue_statement] = ACTIONS(13441),
    [anon_sym_return] = ACTIONS(13441),
    [anon_sym_const] = ACTIONS(13441),
    [anon_sym_global] = ACTIONS(13441),
    [anon_sym_local] = ACTIONS(13441),
    [anon_sym_LPAREN] = ACTIONS(13441),
    [anon_sym_COLON2] = ACTIONS(13441),
    [anon_sym_export] = ACTIONS(13441),
    [anon_sym_import] = ACTIONS(13441),
    [anon_sym_using] = ACTIONS(13441),
    [anon_sym_LBRACK] = ACTIONS(13441),
    [anon_sym_LF] = ACTIONS(13443),
    [anon_sym_in] = ACTIONS(13441),
    [anon_sym_LBRACE] = ACTIONS(13441),
    [anon_sym_DOLLAR] = ACTIONS(13441),
    [anon_sym_COLON_COLON] = ACTIONS(13441),
    [anon_sym_isa] = ACTIONS(13441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13441),
    [anon_sym_QMARK] = ACTIONS(13441),
    [anon_sym_AT] = ACTIONS(13441),
    [anon_sym_true] = ACTIONS(13441),
    [anon_sym_false] = ACTIONS(13441),
    [aux_sym_integer_literal_token1] = ACTIONS(13441),
    [aux_sym_integer_literal_token2] = ACTIONS(13441),
    [aux_sym_integer_literal_token3] = ACTIONS(13441),
    [aux_sym_integer_literal_token4] = ACTIONS(13441),
    [aux_sym_float_literal_token1] = ACTIONS(13441),
    [aux_sym_float_literal_token3] = ACTIONS(13441),
    [aux_sym_float_literal_token4] = ACTIONS(13441),
    [sym_character_literal] = ACTIONS(13441),
    [sym__pair_operator] = ACTIONS(13441),
    [sym__arrow_operator] = ACTIONS(13441),
    [sym__lazy_or_operator] = ACTIONS(13441),
    [sym__lazy_and_operator] = ACTIONS(13441),
    [sym__comparison_operator] = ACTIONS(13441),
    [sym__pipe_right_operator] = ACTIONS(13441),
    [sym__pipe_left_operator] = ACTIONS(13441),
    [sym__ellipsis_operator] = ACTIONS(13441),
    [sym__plus_operator] = ACTIONS(13441),
    [sym__times_operator] = ACTIONS(13441),
    [sym__rational_operator] = ACTIONS(13441),
    [sym__bitshift_operator] = ACTIONS(13441),
    [sym__power_operator] = ACTIONS(13441),
    [sym__tilde_operator] = ACTIONS(13441),
    [sym__type_order_operator] = ACTIONS(13441),
    [sym__unary_operator] = ACTIONS(13441),
    [sym__unary_plus_operator] = ACTIONS(13441),
    [aux_sym__terminator_token1] = ACTIONS(13441),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13443),
    [sym__command_start] = ACTIONS(13443),
  },
  [7456] = {
    [sym__word_identifier] = ACTIONS(13445),
    [anon_sym_EQ] = ACTIONS(13445),
    [anon_sym_COMMA] = ACTIONS(13445),
    [anon_sym_COLON] = ACTIONS(13445),
    [anon_sym_begin] = ACTIONS(13445),
    [anon_sym_module] = ACTIONS(13445),
    [anon_sym_baremodule] = ACTIONS(13445),
    [anon_sym_end] = ACTIONS(13445),
    [anon_sym_abstract] = ACTIONS(13445),
    [anon_sym_primitive] = ACTIONS(13445),
    [anon_sym_mutable] = ACTIONS(13445),
    [anon_sym_struct] = ACTIONS(13445),
    [anon_sym_function] = ACTIONS(13445),
    [anon_sym_macro] = ACTIONS(13445),
    [anon_sym_where] = ACTIONS(13445),
    [anon_sym_quote] = ACTIONS(13445),
    [anon_sym_let] = ACTIONS(13445),
    [anon_sym_if] = ACTIONS(13445),
    [anon_sym_else] = ACTIONS(13445),
    [anon_sym_try] = ACTIONS(13445),
    [anon_sym_finally] = ACTIONS(13445),
    [anon_sym_for] = ACTIONS(13445),
    [anon_sym_while] = ACTIONS(13445),
    [sym_break_statement] = ACTIONS(13445),
    [sym_continue_statement] = ACTIONS(13445),
    [anon_sym_return] = ACTIONS(13445),
    [anon_sym_const] = ACTIONS(13445),
    [anon_sym_global] = ACTIONS(13445),
    [anon_sym_local] = ACTIONS(13445),
    [anon_sym_LPAREN] = ACTIONS(13445),
    [anon_sym_COLON2] = ACTIONS(13445),
    [anon_sym_export] = ACTIONS(13445),
    [anon_sym_import] = ACTIONS(13445),
    [anon_sym_using] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(13445),
    [anon_sym_LF] = ACTIONS(13447),
    [anon_sym_in] = ACTIONS(13445),
    [anon_sym_LBRACE] = ACTIONS(13445),
    [anon_sym_DOLLAR] = ACTIONS(13445),
    [anon_sym_COLON_COLON] = ACTIONS(13445),
    [anon_sym_isa] = ACTIONS(13445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13445),
    [anon_sym_QMARK] = ACTIONS(13445),
    [anon_sym_AT] = ACTIONS(13445),
    [anon_sym_true] = ACTIONS(13445),
    [anon_sym_false] = ACTIONS(13445),
    [aux_sym_integer_literal_token1] = ACTIONS(13445),
    [aux_sym_integer_literal_token2] = ACTIONS(13445),
    [aux_sym_integer_literal_token3] = ACTIONS(13445),
    [aux_sym_integer_literal_token4] = ACTIONS(13445),
    [aux_sym_float_literal_token1] = ACTIONS(13445),
    [aux_sym_float_literal_token3] = ACTIONS(13445),
    [aux_sym_float_literal_token4] = ACTIONS(13445),
    [sym_character_literal] = ACTIONS(13445),
    [sym__pair_operator] = ACTIONS(13445),
    [sym__arrow_operator] = ACTIONS(13445),
    [sym__lazy_or_operator] = ACTIONS(13445),
    [sym__lazy_and_operator] = ACTIONS(13445),
    [sym__comparison_operator] = ACTIONS(13445),
    [sym__pipe_right_operator] = ACTIONS(13445),
    [sym__pipe_left_operator] = ACTIONS(13445),
    [sym__ellipsis_operator] = ACTIONS(13445),
    [sym__plus_operator] = ACTIONS(13445),
    [sym__times_operator] = ACTIONS(13445),
    [sym__rational_operator] = ACTIONS(13445),
    [sym__bitshift_operator] = ACTIONS(13445),
    [sym__power_operator] = ACTIONS(13445),
    [sym__tilde_operator] = ACTIONS(13445),
    [sym__type_order_operator] = ACTIONS(13445),
    [sym__unary_operator] = ACTIONS(13445),
    [sym__unary_plus_operator] = ACTIONS(13445),
    [aux_sym__terminator_token1] = ACTIONS(13445),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13447),
    [sym__command_start] = ACTIONS(13447),
  },
  [7457] = {
    [sym__word_identifier] = ACTIONS(13449),
    [anon_sym_EQ] = ACTIONS(13449),
    [anon_sym_COMMA] = ACTIONS(13449),
    [anon_sym_COLON] = ACTIONS(13449),
    [anon_sym_begin] = ACTIONS(13449),
    [anon_sym_module] = ACTIONS(13449),
    [anon_sym_baremodule] = ACTIONS(13449),
    [anon_sym_end] = ACTIONS(13449),
    [anon_sym_abstract] = ACTIONS(13449),
    [anon_sym_primitive] = ACTIONS(13449),
    [anon_sym_mutable] = ACTIONS(13449),
    [anon_sym_struct] = ACTIONS(13449),
    [anon_sym_function] = ACTIONS(13449),
    [anon_sym_macro] = ACTIONS(13449),
    [anon_sym_where] = ACTIONS(13449),
    [anon_sym_quote] = ACTIONS(13449),
    [anon_sym_let] = ACTIONS(13449),
    [anon_sym_if] = ACTIONS(13449),
    [anon_sym_else] = ACTIONS(13449),
    [anon_sym_try] = ACTIONS(13449),
    [anon_sym_finally] = ACTIONS(13449),
    [anon_sym_for] = ACTIONS(13449),
    [anon_sym_while] = ACTIONS(13449),
    [sym_break_statement] = ACTIONS(13449),
    [sym_continue_statement] = ACTIONS(13449),
    [anon_sym_return] = ACTIONS(13449),
    [anon_sym_const] = ACTIONS(13449),
    [anon_sym_global] = ACTIONS(13449),
    [anon_sym_local] = ACTIONS(13449),
    [anon_sym_LPAREN] = ACTIONS(13449),
    [anon_sym_COLON2] = ACTIONS(13449),
    [anon_sym_export] = ACTIONS(13449),
    [anon_sym_import] = ACTIONS(13449),
    [anon_sym_using] = ACTIONS(13449),
    [anon_sym_LBRACK] = ACTIONS(13449),
    [anon_sym_LF] = ACTIONS(13451),
    [anon_sym_in] = ACTIONS(13449),
    [anon_sym_LBRACE] = ACTIONS(13449),
    [anon_sym_DOLLAR] = ACTIONS(13449),
    [anon_sym_COLON_COLON] = ACTIONS(13449),
    [anon_sym_isa] = ACTIONS(13449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13449),
    [anon_sym_QMARK] = ACTIONS(13449),
    [anon_sym_AT] = ACTIONS(13449),
    [anon_sym_true] = ACTIONS(13449),
    [anon_sym_false] = ACTIONS(13449),
    [aux_sym_integer_literal_token1] = ACTIONS(13449),
    [aux_sym_integer_literal_token2] = ACTIONS(13449),
    [aux_sym_integer_literal_token3] = ACTIONS(13449),
    [aux_sym_integer_literal_token4] = ACTIONS(13449),
    [aux_sym_float_literal_token1] = ACTIONS(13449),
    [aux_sym_float_literal_token3] = ACTIONS(13449),
    [aux_sym_float_literal_token4] = ACTIONS(13449),
    [sym_character_literal] = ACTIONS(13449),
    [sym__pair_operator] = ACTIONS(13449),
    [sym__arrow_operator] = ACTIONS(13449),
    [sym__lazy_or_operator] = ACTIONS(13449),
    [sym__lazy_and_operator] = ACTIONS(13449),
    [sym__comparison_operator] = ACTIONS(13449),
    [sym__pipe_right_operator] = ACTIONS(13449),
    [sym__pipe_left_operator] = ACTIONS(13449),
    [sym__ellipsis_operator] = ACTIONS(13449),
    [sym__plus_operator] = ACTIONS(13449),
    [sym__times_operator] = ACTIONS(13449),
    [sym__rational_operator] = ACTIONS(13449),
    [sym__bitshift_operator] = ACTIONS(13449),
    [sym__power_operator] = ACTIONS(13449),
    [sym__tilde_operator] = ACTIONS(13449),
    [sym__type_order_operator] = ACTIONS(13449),
    [sym__unary_operator] = ACTIONS(13449),
    [sym__unary_plus_operator] = ACTIONS(13449),
    [aux_sym__terminator_token1] = ACTIONS(13449),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13451),
    [sym__command_start] = ACTIONS(13451),
  },
  [7458] = {
    [sym__word_identifier] = ACTIONS(13453),
    [anon_sym_EQ] = ACTIONS(13453),
    [anon_sym_COMMA] = ACTIONS(13453),
    [anon_sym_COLON] = ACTIONS(13453),
    [anon_sym_begin] = ACTIONS(13453),
    [anon_sym_module] = ACTIONS(13453),
    [anon_sym_baremodule] = ACTIONS(13453),
    [anon_sym_end] = ACTIONS(13453),
    [anon_sym_abstract] = ACTIONS(13453),
    [anon_sym_primitive] = ACTIONS(13453),
    [anon_sym_mutable] = ACTIONS(13453),
    [anon_sym_struct] = ACTIONS(13453),
    [anon_sym_function] = ACTIONS(13453),
    [anon_sym_macro] = ACTIONS(13453),
    [anon_sym_where] = ACTIONS(13453),
    [anon_sym_quote] = ACTIONS(13453),
    [anon_sym_let] = ACTIONS(13453),
    [anon_sym_if] = ACTIONS(13453),
    [anon_sym_else] = ACTIONS(13453),
    [anon_sym_try] = ACTIONS(13453),
    [anon_sym_finally] = ACTIONS(13453),
    [anon_sym_for] = ACTIONS(13453),
    [anon_sym_while] = ACTIONS(13453),
    [sym_break_statement] = ACTIONS(13453),
    [sym_continue_statement] = ACTIONS(13453),
    [anon_sym_return] = ACTIONS(13453),
    [anon_sym_const] = ACTIONS(13453),
    [anon_sym_global] = ACTIONS(13453),
    [anon_sym_local] = ACTIONS(13453),
    [anon_sym_LPAREN] = ACTIONS(13453),
    [anon_sym_COLON2] = ACTIONS(13453),
    [anon_sym_export] = ACTIONS(13453),
    [anon_sym_import] = ACTIONS(13453),
    [anon_sym_using] = ACTIONS(13453),
    [anon_sym_LBRACK] = ACTIONS(13453),
    [anon_sym_LF] = ACTIONS(13455),
    [anon_sym_in] = ACTIONS(13453),
    [anon_sym_LBRACE] = ACTIONS(13453),
    [anon_sym_DOLLAR] = ACTIONS(13453),
    [anon_sym_COLON_COLON] = ACTIONS(13453),
    [anon_sym_isa] = ACTIONS(13453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13453),
    [anon_sym_QMARK] = ACTIONS(13453),
    [anon_sym_AT] = ACTIONS(13453),
    [anon_sym_true] = ACTIONS(13453),
    [anon_sym_false] = ACTIONS(13453),
    [aux_sym_integer_literal_token1] = ACTIONS(13453),
    [aux_sym_integer_literal_token2] = ACTIONS(13453),
    [aux_sym_integer_literal_token3] = ACTIONS(13453),
    [aux_sym_integer_literal_token4] = ACTIONS(13453),
    [aux_sym_float_literal_token1] = ACTIONS(13453),
    [aux_sym_float_literal_token3] = ACTIONS(13453),
    [aux_sym_float_literal_token4] = ACTIONS(13453),
    [sym_character_literal] = ACTIONS(13453),
    [sym__pair_operator] = ACTIONS(13453),
    [sym__arrow_operator] = ACTIONS(13453),
    [sym__lazy_or_operator] = ACTIONS(13453),
    [sym__lazy_and_operator] = ACTIONS(13453),
    [sym__comparison_operator] = ACTIONS(13453),
    [sym__pipe_right_operator] = ACTIONS(13453),
    [sym__pipe_left_operator] = ACTIONS(13453),
    [sym__ellipsis_operator] = ACTIONS(13453),
    [sym__plus_operator] = ACTIONS(13453),
    [sym__times_operator] = ACTIONS(13453),
    [sym__rational_operator] = ACTIONS(13453),
    [sym__bitshift_operator] = ACTIONS(13453),
    [sym__power_operator] = ACTIONS(13453),
    [sym__tilde_operator] = ACTIONS(13453),
    [sym__type_order_operator] = ACTIONS(13453),
    [sym__unary_operator] = ACTIONS(13453),
    [sym__unary_plus_operator] = ACTIONS(13453),
    [aux_sym__terminator_token1] = ACTIONS(13453),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13455),
    [sym__command_start] = ACTIONS(13455),
  },
  [7459] = {
    [sym__word_identifier] = ACTIONS(13457),
    [anon_sym_EQ] = ACTIONS(13457),
    [anon_sym_COMMA] = ACTIONS(13457),
    [anon_sym_COLON] = ACTIONS(13457),
    [anon_sym_begin] = ACTIONS(13457),
    [anon_sym_module] = ACTIONS(13457),
    [anon_sym_baremodule] = ACTIONS(13457),
    [anon_sym_end] = ACTIONS(13457),
    [anon_sym_abstract] = ACTIONS(13457),
    [anon_sym_primitive] = ACTIONS(13457),
    [anon_sym_mutable] = ACTIONS(13457),
    [anon_sym_struct] = ACTIONS(13457),
    [anon_sym_function] = ACTIONS(13457),
    [anon_sym_macro] = ACTIONS(13457),
    [anon_sym_where] = ACTIONS(13457),
    [anon_sym_quote] = ACTIONS(13457),
    [anon_sym_let] = ACTIONS(13457),
    [anon_sym_if] = ACTIONS(13457),
    [anon_sym_else] = ACTIONS(13457),
    [anon_sym_try] = ACTIONS(13457),
    [anon_sym_finally] = ACTIONS(13457),
    [anon_sym_for] = ACTIONS(13457),
    [anon_sym_while] = ACTIONS(13457),
    [sym_break_statement] = ACTIONS(13457),
    [sym_continue_statement] = ACTIONS(13457),
    [anon_sym_return] = ACTIONS(13457),
    [anon_sym_const] = ACTIONS(13457),
    [anon_sym_global] = ACTIONS(13457),
    [anon_sym_local] = ACTIONS(13457),
    [anon_sym_LPAREN] = ACTIONS(13457),
    [anon_sym_COLON2] = ACTIONS(13457),
    [anon_sym_export] = ACTIONS(13457),
    [anon_sym_import] = ACTIONS(13457),
    [anon_sym_using] = ACTIONS(13457),
    [anon_sym_LBRACK] = ACTIONS(13457),
    [anon_sym_LF] = ACTIONS(13459),
    [anon_sym_in] = ACTIONS(13457),
    [anon_sym_LBRACE] = ACTIONS(13457),
    [anon_sym_DOLLAR] = ACTIONS(13457),
    [anon_sym_COLON_COLON] = ACTIONS(13457),
    [anon_sym_isa] = ACTIONS(13457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13457),
    [anon_sym_QMARK] = ACTIONS(13457),
    [anon_sym_AT] = ACTIONS(13457),
    [anon_sym_true] = ACTIONS(13457),
    [anon_sym_false] = ACTIONS(13457),
    [aux_sym_integer_literal_token1] = ACTIONS(13457),
    [aux_sym_integer_literal_token2] = ACTIONS(13457),
    [aux_sym_integer_literal_token3] = ACTIONS(13457),
    [aux_sym_integer_literal_token4] = ACTIONS(13457),
    [aux_sym_float_literal_token1] = ACTIONS(13457),
    [aux_sym_float_literal_token3] = ACTIONS(13457),
    [aux_sym_float_literal_token4] = ACTIONS(13457),
    [sym_character_literal] = ACTIONS(13457),
    [sym__pair_operator] = ACTIONS(13457),
    [sym__arrow_operator] = ACTIONS(13457),
    [sym__lazy_or_operator] = ACTIONS(13457),
    [sym__lazy_and_operator] = ACTIONS(13457),
    [sym__comparison_operator] = ACTIONS(13457),
    [sym__pipe_right_operator] = ACTIONS(13457),
    [sym__pipe_left_operator] = ACTIONS(13457),
    [sym__ellipsis_operator] = ACTIONS(13457),
    [sym__plus_operator] = ACTIONS(13457),
    [sym__times_operator] = ACTIONS(13457),
    [sym__rational_operator] = ACTIONS(13457),
    [sym__bitshift_operator] = ACTIONS(13457),
    [sym__power_operator] = ACTIONS(13457),
    [sym__tilde_operator] = ACTIONS(13457),
    [sym__type_order_operator] = ACTIONS(13457),
    [sym__unary_operator] = ACTIONS(13457),
    [sym__unary_plus_operator] = ACTIONS(13457),
    [aux_sym__terminator_token1] = ACTIONS(13457),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13459),
    [sym__command_start] = ACTIONS(13459),
  },
  [7460] = {
    [sym__word_identifier] = ACTIONS(13461),
    [anon_sym_EQ] = ACTIONS(13461),
    [anon_sym_COMMA] = ACTIONS(13461),
    [anon_sym_COLON] = ACTIONS(13461),
    [anon_sym_begin] = ACTIONS(13461),
    [anon_sym_module] = ACTIONS(13461),
    [anon_sym_baremodule] = ACTIONS(13461),
    [anon_sym_end] = ACTIONS(13461),
    [anon_sym_abstract] = ACTIONS(13461),
    [anon_sym_primitive] = ACTIONS(13461),
    [anon_sym_mutable] = ACTIONS(13461),
    [anon_sym_struct] = ACTIONS(13461),
    [anon_sym_function] = ACTIONS(13461),
    [anon_sym_macro] = ACTIONS(13461),
    [anon_sym_where] = ACTIONS(13461),
    [anon_sym_quote] = ACTIONS(13461),
    [anon_sym_let] = ACTIONS(13461),
    [anon_sym_if] = ACTIONS(13461),
    [anon_sym_else] = ACTIONS(13461),
    [anon_sym_try] = ACTIONS(13461),
    [anon_sym_finally] = ACTIONS(13461),
    [anon_sym_for] = ACTIONS(13461),
    [anon_sym_while] = ACTIONS(13461),
    [sym_break_statement] = ACTIONS(13461),
    [sym_continue_statement] = ACTIONS(13461),
    [anon_sym_return] = ACTIONS(13461),
    [anon_sym_const] = ACTIONS(13461),
    [anon_sym_global] = ACTIONS(13461),
    [anon_sym_local] = ACTIONS(13461),
    [anon_sym_LPAREN] = ACTIONS(13461),
    [anon_sym_COLON2] = ACTIONS(13461),
    [anon_sym_export] = ACTIONS(13461),
    [anon_sym_import] = ACTIONS(13461),
    [anon_sym_using] = ACTIONS(13461),
    [anon_sym_LBRACK] = ACTIONS(13461),
    [anon_sym_LF] = ACTIONS(13463),
    [anon_sym_in] = ACTIONS(13461),
    [anon_sym_LBRACE] = ACTIONS(13461),
    [anon_sym_DOLLAR] = ACTIONS(13461),
    [anon_sym_COLON_COLON] = ACTIONS(13461),
    [anon_sym_isa] = ACTIONS(13461),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13461),
    [anon_sym_QMARK] = ACTIONS(13461),
    [anon_sym_AT] = ACTIONS(13461),
    [anon_sym_true] = ACTIONS(13461),
    [anon_sym_false] = ACTIONS(13461),
    [aux_sym_integer_literal_token1] = ACTIONS(13461),
    [aux_sym_integer_literal_token2] = ACTIONS(13461),
    [aux_sym_integer_literal_token3] = ACTIONS(13461),
    [aux_sym_integer_literal_token4] = ACTIONS(13461),
    [aux_sym_float_literal_token1] = ACTIONS(13461),
    [aux_sym_float_literal_token3] = ACTIONS(13461),
    [aux_sym_float_literal_token4] = ACTIONS(13461),
    [sym_character_literal] = ACTIONS(13461),
    [sym__pair_operator] = ACTIONS(13461),
    [sym__arrow_operator] = ACTIONS(13461),
    [sym__lazy_or_operator] = ACTIONS(13461),
    [sym__lazy_and_operator] = ACTIONS(13461),
    [sym__comparison_operator] = ACTIONS(13461),
    [sym__pipe_right_operator] = ACTIONS(13461),
    [sym__pipe_left_operator] = ACTIONS(13461),
    [sym__ellipsis_operator] = ACTIONS(13461),
    [sym__plus_operator] = ACTIONS(13461),
    [sym__times_operator] = ACTIONS(13461),
    [sym__rational_operator] = ACTIONS(13461),
    [sym__bitshift_operator] = ACTIONS(13461),
    [sym__power_operator] = ACTIONS(13461),
    [sym__tilde_operator] = ACTIONS(13461),
    [sym__type_order_operator] = ACTIONS(13461),
    [sym__unary_operator] = ACTIONS(13461),
    [sym__unary_plus_operator] = ACTIONS(13461),
    [aux_sym__terminator_token1] = ACTIONS(13461),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13463),
    [sym__command_start] = ACTIONS(13463),
  },
  [7461] = {
    [sym__word_identifier] = ACTIONS(13481),
    [anon_sym_EQ] = ACTIONS(13481),
    [anon_sym_COMMA] = ACTIONS(13481),
    [anon_sym_COLON] = ACTIONS(13481),
    [anon_sym_begin] = ACTIONS(13481),
    [anon_sym_module] = ACTIONS(13481),
    [anon_sym_baremodule] = ACTIONS(13481),
    [anon_sym_end] = ACTIONS(13481),
    [anon_sym_abstract] = ACTIONS(13481),
    [anon_sym_primitive] = ACTIONS(13481),
    [anon_sym_mutable] = ACTIONS(13481),
    [anon_sym_struct] = ACTIONS(13481),
    [anon_sym_function] = ACTIONS(13481),
    [anon_sym_macro] = ACTIONS(13481),
    [anon_sym_where] = ACTIONS(13481),
    [anon_sym_quote] = ACTIONS(13481),
    [anon_sym_let] = ACTIONS(13481),
    [anon_sym_if] = ACTIONS(13481),
    [anon_sym_else] = ACTIONS(13481),
    [anon_sym_try] = ACTIONS(13481),
    [anon_sym_finally] = ACTIONS(13481),
    [anon_sym_for] = ACTIONS(13481),
    [anon_sym_while] = ACTIONS(13481),
    [sym_break_statement] = ACTIONS(13481),
    [sym_continue_statement] = ACTIONS(13481),
    [anon_sym_return] = ACTIONS(13481),
    [anon_sym_const] = ACTIONS(13481),
    [anon_sym_global] = ACTIONS(13481),
    [anon_sym_local] = ACTIONS(13481),
    [anon_sym_LPAREN] = ACTIONS(13481),
    [anon_sym_COLON2] = ACTIONS(13481),
    [anon_sym_export] = ACTIONS(13481),
    [anon_sym_import] = ACTIONS(13481),
    [anon_sym_using] = ACTIONS(13481),
    [anon_sym_LBRACK] = ACTIONS(13481),
    [anon_sym_LF] = ACTIONS(13483),
    [anon_sym_in] = ACTIONS(13481),
    [anon_sym_LBRACE] = ACTIONS(13481),
    [anon_sym_DOLLAR] = ACTIONS(13481),
    [anon_sym_COLON_COLON] = ACTIONS(13481),
    [anon_sym_isa] = ACTIONS(13481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13481),
    [anon_sym_QMARK] = ACTIONS(13481),
    [anon_sym_AT] = ACTIONS(13481),
    [anon_sym_true] = ACTIONS(13481),
    [anon_sym_false] = ACTIONS(13481),
    [aux_sym_integer_literal_token1] = ACTIONS(13481),
    [aux_sym_integer_literal_token2] = ACTIONS(13481),
    [aux_sym_integer_literal_token3] = ACTIONS(13481),
    [aux_sym_integer_literal_token4] = ACTIONS(13481),
    [aux_sym_float_literal_token1] = ACTIONS(13481),
    [aux_sym_float_literal_token3] = ACTIONS(13481),
    [aux_sym_float_literal_token4] = ACTIONS(13481),
    [sym_character_literal] = ACTIONS(13481),
    [sym__pair_operator] = ACTIONS(13481),
    [sym__arrow_operator] = ACTIONS(13481),
    [sym__lazy_or_operator] = ACTIONS(13481),
    [sym__lazy_and_operator] = ACTIONS(13481),
    [sym__comparison_operator] = ACTIONS(13481),
    [sym__pipe_right_operator] = ACTIONS(13481),
    [sym__pipe_left_operator] = ACTIONS(13481),
    [sym__ellipsis_operator] = ACTIONS(13481),
    [sym__plus_operator] = ACTIONS(13481),
    [sym__times_operator] = ACTIONS(13481),
    [sym__rational_operator] = ACTIONS(13481),
    [sym__bitshift_operator] = ACTIONS(13481),
    [sym__power_operator] = ACTIONS(13481),
    [sym__tilde_operator] = ACTIONS(13481),
    [sym__type_order_operator] = ACTIONS(13481),
    [sym__unary_operator] = ACTIONS(13481),
    [sym__unary_plus_operator] = ACTIONS(13481),
    [aux_sym__terminator_token1] = ACTIONS(13481),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13483),
    [sym__command_start] = ACTIONS(13483),
  },
  [7462] = {
    [sym__word_identifier] = ACTIONS(13485),
    [anon_sym_EQ] = ACTIONS(13485),
    [anon_sym_COMMA] = ACTIONS(13485),
    [anon_sym_COLON] = ACTIONS(13485),
    [anon_sym_begin] = ACTIONS(13485),
    [anon_sym_module] = ACTIONS(13485),
    [anon_sym_baremodule] = ACTIONS(13485),
    [anon_sym_end] = ACTIONS(13485),
    [anon_sym_abstract] = ACTIONS(13485),
    [anon_sym_primitive] = ACTIONS(13485),
    [anon_sym_mutable] = ACTIONS(13485),
    [anon_sym_struct] = ACTIONS(13485),
    [anon_sym_function] = ACTIONS(13485),
    [anon_sym_macro] = ACTIONS(13485),
    [anon_sym_where] = ACTIONS(13485),
    [anon_sym_quote] = ACTIONS(13485),
    [anon_sym_let] = ACTIONS(13485),
    [anon_sym_if] = ACTIONS(13485),
    [anon_sym_else] = ACTIONS(13485),
    [anon_sym_try] = ACTIONS(13485),
    [anon_sym_finally] = ACTIONS(13485),
    [anon_sym_for] = ACTIONS(13485),
    [anon_sym_while] = ACTIONS(13485),
    [sym_break_statement] = ACTIONS(13485),
    [sym_continue_statement] = ACTIONS(13485),
    [anon_sym_return] = ACTIONS(13485),
    [anon_sym_const] = ACTIONS(13485),
    [anon_sym_global] = ACTIONS(13485),
    [anon_sym_local] = ACTIONS(13485),
    [anon_sym_LPAREN] = ACTIONS(13485),
    [anon_sym_COLON2] = ACTIONS(13485),
    [anon_sym_export] = ACTIONS(13485),
    [anon_sym_import] = ACTIONS(13485),
    [anon_sym_using] = ACTIONS(13485),
    [anon_sym_LBRACK] = ACTIONS(13485),
    [anon_sym_LF] = ACTIONS(13487),
    [anon_sym_in] = ACTIONS(13485),
    [anon_sym_LBRACE] = ACTIONS(13485),
    [anon_sym_DOLLAR] = ACTIONS(13485),
    [anon_sym_COLON_COLON] = ACTIONS(13485),
    [anon_sym_isa] = ACTIONS(13485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13485),
    [anon_sym_QMARK] = ACTIONS(13485),
    [anon_sym_AT] = ACTIONS(13485),
    [anon_sym_true] = ACTIONS(13485),
    [anon_sym_false] = ACTIONS(13485),
    [aux_sym_integer_literal_token1] = ACTIONS(13485),
    [aux_sym_integer_literal_token2] = ACTIONS(13485),
    [aux_sym_integer_literal_token3] = ACTIONS(13485),
    [aux_sym_integer_literal_token4] = ACTIONS(13485),
    [aux_sym_float_literal_token1] = ACTIONS(13485),
    [aux_sym_float_literal_token3] = ACTIONS(13485),
    [aux_sym_float_literal_token4] = ACTIONS(13485),
    [sym_character_literal] = ACTIONS(13485),
    [sym__pair_operator] = ACTIONS(13485),
    [sym__arrow_operator] = ACTIONS(13485),
    [sym__lazy_or_operator] = ACTIONS(13485),
    [sym__lazy_and_operator] = ACTIONS(13485),
    [sym__comparison_operator] = ACTIONS(13485),
    [sym__pipe_right_operator] = ACTIONS(13485),
    [sym__pipe_left_operator] = ACTIONS(13485),
    [sym__ellipsis_operator] = ACTIONS(13485),
    [sym__plus_operator] = ACTIONS(13485),
    [sym__times_operator] = ACTIONS(13485),
    [sym__rational_operator] = ACTIONS(13485),
    [sym__bitshift_operator] = ACTIONS(13485),
    [sym__power_operator] = ACTIONS(13485),
    [sym__tilde_operator] = ACTIONS(13485),
    [sym__type_order_operator] = ACTIONS(13485),
    [sym__unary_operator] = ACTIONS(13485),
    [sym__unary_plus_operator] = ACTIONS(13485),
    [aux_sym__terminator_token1] = ACTIONS(13485),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13487),
    [sym__command_start] = ACTIONS(13487),
  },
  [7463] = {
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(12974),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_end] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_else] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_finally] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [7464] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_else] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_finally] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7465] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_end] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_elseif] = ACTIONS(13038),
    [anon_sym_else] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [7466] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12508),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7467] = {
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(12974),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_end] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_elseif] = ACTIONS(12974),
    [anon_sym_else] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [7468] = {
    [sym__word_identifier] = ACTIONS(13489),
    [anon_sym_EQ] = ACTIONS(13489),
    [anon_sym_COMMA] = ACTIONS(13489),
    [anon_sym_COLON] = ACTIONS(13489),
    [anon_sym_begin] = ACTIONS(13489),
    [anon_sym_module] = ACTIONS(13489),
    [anon_sym_baremodule] = ACTIONS(13489),
    [anon_sym_end] = ACTIONS(13489),
    [anon_sym_abstract] = ACTIONS(13489),
    [anon_sym_primitive] = ACTIONS(13489),
    [anon_sym_mutable] = ACTIONS(13489),
    [anon_sym_struct] = ACTIONS(13489),
    [anon_sym_function] = ACTIONS(13489),
    [anon_sym_macro] = ACTIONS(13489),
    [anon_sym_where] = ACTIONS(13489),
    [anon_sym_quote] = ACTIONS(13489),
    [anon_sym_let] = ACTIONS(13489),
    [anon_sym_if] = ACTIONS(13489),
    [anon_sym_else] = ACTIONS(13489),
    [anon_sym_try] = ACTIONS(13489),
    [anon_sym_finally] = ACTIONS(13489),
    [anon_sym_for] = ACTIONS(13489),
    [anon_sym_while] = ACTIONS(13489),
    [sym_break_statement] = ACTIONS(13489),
    [sym_continue_statement] = ACTIONS(13489),
    [anon_sym_return] = ACTIONS(13489),
    [anon_sym_const] = ACTIONS(13489),
    [anon_sym_global] = ACTIONS(13489),
    [anon_sym_local] = ACTIONS(13489),
    [anon_sym_LPAREN] = ACTIONS(13489),
    [anon_sym_COLON2] = ACTIONS(13489),
    [anon_sym_export] = ACTIONS(13489),
    [anon_sym_import] = ACTIONS(13489),
    [anon_sym_using] = ACTIONS(13489),
    [anon_sym_LBRACK] = ACTIONS(13489),
    [anon_sym_LF] = ACTIONS(13491),
    [anon_sym_in] = ACTIONS(13489),
    [anon_sym_LBRACE] = ACTIONS(13489),
    [anon_sym_DOLLAR] = ACTIONS(13489),
    [anon_sym_COLON_COLON] = ACTIONS(13489),
    [anon_sym_isa] = ACTIONS(13489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13489),
    [anon_sym_QMARK] = ACTIONS(13489),
    [anon_sym_AT] = ACTIONS(13489),
    [anon_sym_true] = ACTIONS(13489),
    [anon_sym_false] = ACTIONS(13489),
    [aux_sym_integer_literal_token1] = ACTIONS(13489),
    [aux_sym_integer_literal_token2] = ACTIONS(13489),
    [aux_sym_integer_literal_token3] = ACTIONS(13489),
    [aux_sym_integer_literal_token4] = ACTIONS(13489),
    [aux_sym_float_literal_token1] = ACTIONS(13489),
    [aux_sym_float_literal_token3] = ACTIONS(13489),
    [aux_sym_float_literal_token4] = ACTIONS(13489),
    [sym_character_literal] = ACTIONS(13489),
    [sym__pair_operator] = ACTIONS(13489),
    [sym__arrow_operator] = ACTIONS(13489),
    [sym__lazy_or_operator] = ACTIONS(13489),
    [sym__lazy_and_operator] = ACTIONS(13489),
    [sym__comparison_operator] = ACTIONS(13489),
    [sym__pipe_right_operator] = ACTIONS(13489),
    [sym__pipe_left_operator] = ACTIONS(13489),
    [sym__ellipsis_operator] = ACTIONS(13489),
    [sym__plus_operator] = ACTIONS(13489),
    [sym__times_operator] = ACTIONS(13489),
    [sym__rational_operator] = ACTIONS(13489),
    [sym__bitshift_operator] = ACTIONS(13489),
    [sym__power_operator] = ACTIONS(13489),
    [sym__tilde_operator] = ACTIONS(13489),
    [sym__type_order_operator] = ACTIONS(13489),
    [sym__unary_operator] = ACTIONS(13489),
    [sym__unary_plus_operator] = ACTIONS(13489),
    [aux_sym__terminator_token1] = ACTIONS(13489),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13491),
    [sym__command_start] = ACTIONS(13491),
  },
  [7469] = {
    [sym__word_identifier] = ACTIONS(13493),
    [anon_sym_EQ] = ACTIONS(13493),
    [anon_sym_COMMA] = ACTIONS(13493),
    [anon_sym_COLON] = ACTIONS(13493),
    [anon_sym_begin] = ACTIONS(13493),
    [anon_sym_module] = ACTIONS(13493),
    [anon_sym_baremodule] = ACTIONS(13493),
    [anon_sym_end] = ACTIONS(13493),
    [anon_sym_abstract] = ACTIONS(13493),
    [anon_sym_primitive] = ACTIONS(13493),
    [anon_sym_mutable] = ACTIONS(13493),
    [anon_sym_struct] = ACTIONS(13493),
    [anon_sym_function] = ACTIONS(13493),
    [anon_sym_macro] = ACTIONS(13493),
    [anon_sym_where] = ACTIONS(13493),
    [anon_sym_quote] = ACTIONS(13493),
    [anon_sym_let] = ACTIONS(13493),
    [anon_sym_if] = ACTIONS(13493),
    [anon_sym_else] = ACTIONS(13493),
    [anon_sym_try] = ACTIONS(13493),
    [anon_sym_finally] = ACTIONS(13493),
    [anon_sym_for] = ACTIONS(13493),
    [anon_sym_while] = ACTIONS(13493),
    [sym_break_statement] = ACTIONS(13493),
    [sym_continue_statement] = ACTIONS(13493),
    [anon_sym_return] = ACTIONS(13493),
    [anon_sym_const] = ACTIONS(13493),
    [anon_sym_global] = ACTIONS(13493),
    [anon_sym_local] = ACTIONS(13493),
    [anon_sym_LPAREN] = ACTIONS(13493),
    [anon_sym_COLON2] = ACTIONS(13493),
    [anon_sym_export] = ACTIONS(13493),
    [anon_sym_import] = ACTIONS(13493),
    [anon_sym_using] = ACTIONS(13493),
    [anon_sym_LBRACK] = ACTIONS(13493),
    [anon_sym_LF] = ACTIONS(13495),
    [anon_sym_in] = ACTIONS(13493),
    [anon_sym_LBRACE] = ACTIONS(13493),
    [anon_sym_DOLLAR] = ACTIONS(13493),
    [anon_sym_COLON_COLON] = ACTIONS(13493),
    [anon_sym_isa] = ACTIONS(13493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13493),
    [anon_sym_QMARK] = ACTIONS(13493),
    [anon_sym_AT] = ACTIONS(13493),
    [anon_sym_true] = ACTIONS(13493),
    [anon_sym_false] = ACTIONS(13493),
    [aux_sym_integer_literal_token1] = ACTIONS(13493),
    [aux_sym_integer_literal_token2] = ACTIONS(13493),
    [aux_sym_integer_literal_token3] = ACTIONS(13493),
    [aux_sym_integer_literal_token4] = ACTIONS(13493),
    [aux_sym_float_literal_token1] = ACTIONS(13493),
    [aux_sym_float_literal_token3] = ACTIONS(13493),
    [aux_sym_float_literal_token4] = ACTIONS(13493),
    [sym_character_literal] = ACTIONS(13493),
    [sym__pair_operator] = ACTIONS(13493),
    [sym__arrow_operator] = ACTIONS(13493),
    [sym__lazy_or_operator] = ACTIONS(13493),
    [sym__lazy_and_operator] = ACTIONS(13493),
    [sym__comparison_operator] = ACTIONS(13493),
    [sym__pipe_right_operator] = ACTIONS(13493),
    [sym__pipe_left_operator] = ACTIONS(13493),
    [sym__ellipsis_operator] = ACTIONS(13493),
    [sym__plus_operator] = ACTIONS(13493),
    [sym__times_operator] = ACTIONS(13493),
    [sym__rational_operator] = ACTIONS(13493),
    [sym__bitshift_operator] = ACTIONS(13493),
    [sym__power_operator] = ACTIONS(13493),
    [sym__tilde_operator] = ACTIONS(13493),
    [sym__type_order_operator] = ACTIONS(13493),
    [sym__unary_operator] = ACTIONS(13493),
    [sym__unary_plus_operator] = ACTIONS(13493),
    [aux_sym__terminator_token1] = ACTIONS(13493),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13495),
    [sym__command_start] = ACTIONS(13495),
  },
  [7470] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_elseif] = ACTIONS(12981),
    [anon_sym_else] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7471] = {
    [aux_sym_open_tuple_repeat1] = STATE(7474),
    [sym__word_identifier] = ACTIONS(13150),
    [anon_sym_EQ] = ACTIONS(13150),
    [anon_sym_COMMA] = ACTIONS(13497),
    [anon_sym_COLON] = ACTIONS(13150),
    [anon_sym_begin] = ACTIONS(13150),
    [anon_sym_module] = ACTIONS(13150),
    [anon_sym_baremodule] = ACTIONS(13150),
    [anon_sym_end] = ACTIONS(13150),
    [anon_sym_abstract] = ACTIONS(13150),
    [anon_sym_primitive] = ACTIONS(13150),
    [anon_sym_mutable] = ACTIONS(13150),
    [anon_sym_struct] = ACTIONS(13150),
    [anon_sym_function] = ACTIONS(13150),
    [anon_sym_macro] = ACTIONS(13150),
    [anon_sym_where] = ACTIONS(13150),
    [anon_sym_quote] = ACTIONS(13150),
    [anon_sym_let] = ACTIONS(13150),
    [anon_sym_if] = ACTIONS(13150),
    [anon_sym_try] = ACTIONS(13150),
    [anon_sym_finally] = ACTIONS(13150),
    [anon_sym_for] = ACTIONS(13150),
    [anon_sym_while] = ACTIONS(13150),
    [sym_break_statement] = ACTIONS(13150),
    [sym_continue_statement] = ACTIONS(13150),
    [anon_sym_return] = ACTIONS(13150),
    [anon_sym_const] = ACTIONS(13150),
    [anon_sym_global] = ACTIONS(13150),
    [anon_sym_local] = ACTIONS(13150),
    [anon_sym_LPAREN] = ACTIONS(13150),
    [anon_sym_COLON2] = ACTIONS(13150),
    [anon_sym_export] = ACTIONS(13150),
    [anon_sym_import] = ACTIONS(13150),
    [anon_sym_using] = ACTIONS(13150),
    [anon_sym_LBRACK] = ACTIONS(13150),
    [anon_sym_LF] = ACTIONS(13148),
    [anon_sym_in] = ACTIONS(13150),
    [anon_sym_LBRACE] = ACTIONS(13150),
    [anon_sym_DOLLAR] = ACTIONS(13150),
    [anon_sym_COLON_COLON] = ACTIONS(13150),
    [anon_sym_isa] = ACTIONS(13150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13150),
    [anon_sym_QMARK] = ACTIONS(13150),
    [anon_sym_AT] = ACTIONS(13150),
    [anon_sym_true] = ACTIONS(13150),
    [anon_sym_false] = ACTIONS(13150),
    [aux_sym_integer_literal_token1] = ACTIONS(13150),
    [aux_sym_integer_literal_token2] = ACTIONS(13150),
    [aux_sym_integer_literal_token3] = ACTIONS(13150),
    [aux_sym_integer_literal_token4] = ACTIONS(13150),
    [aux_sym_float_literal_token1] = ACTIONS(13150),
    [aux_sym_float_literal_token3] = ACTIONS(13150),
    [aux_sym_float_literal_token4] = ACTIONS(13150),
    [sym_character_literal] = ACTIONS(13150),
    [sym__pair_operator] = ACTIONS(13150),
    [sym__arrow_operator] = ACTIONS(13150),
    [sym__lazy_or_operator] = ACTIONS(13150),
    [sym__lazy_and_operator] = ACTIONS(13150),
    [sym__comparison_operator] = ACTIONS(13150),
    [sym__pipe_right_operator] = ACTIONS(13150),
    [sym__pipe_left_operator] = ACTIONS(13150),
    [sym__ellipsis_operator] = ACTIONS(13150),
    [sym__plus_operator] = ACTIONS(13150),
    [sym__times_operator] = ACTIONS(13150),
    [sym__rational_operator] = ACTIONS(13150),
    [sym__bitshift_operator] = ACTIONS(13150),
    [sym__power_operator] = ACTIONS(13150),
    [sym__tilde_operator] = ACTIONS(13150),
    [sym__type_order_operator] = ACTIONS(13150),
    [sym__unary_operator] = ACTIONS(13150),
    [sym__unary_plus_operator] = ACTIONS(13150),
    [aux_sym__terminator_token1] = ACTIONS(13150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13148),
    [sym__command_start] = ACTIONS(13148),
  },
  [7472] = {
    [sym__word_identifier] = ACTIONS(13489),
    [anon_sym_EQ] = ACTIONS(13489),
    [anon_sym_COMMA] = ACTIONS(13489),
    [anon_sym_COLON] = ACTIONS(13489),
    [anon_sym_begin] = ACTIONS(13489),
    [anon_sym_module] = ACTIONS(13489),
    [anon_sym_baremodule] = ACTIONS(13489),
    [anon_sym_end] = ACTIONS(13489),
    [anon_sym_abstract] = ACTIONS(13489),
    [anon_sym_primitive] = ACTIONS(13489),
    [anon_sym_mutable] = ACTIONS(13489),
    [anon_sym_struct] = ACTIONS(13489),
    [anon_sym_function] = ACTIONS(13489),
    [anon_sym_macro] = ACTIONS(13489),
    [anon_sym_where] = ACTIONS(13489),
    [anon_sym_quote] = ACTIONS(13489),
    [anon_sym_let] = ACTIONS(13489),
    [anon_sym_if] = ACTIONS(13489),
    [anon_sym_elseif] = ACTIONS(13489),
    [anon_sym_else] = ACTIONS(13489),
    [anon_sym_try] = ACTIONS(13489),
    [anon_sym_for] = ACTIONS(13489),
    [anon_sym_while] = ACTIONS(13489),
    [sym_break_statement] = ACTIONS(13489),
    [sym_continue_statement] = ACTIONS(13489),
    [anon_sym_return] = ACTIONS(13489),
    [anon_sym_const] = ACTIONS(13489),
    [anon_sym_global] = ACTIONS(13489),
    [anon_sym_local] = ACTIONS(13489),
    [anon_sym_LPAREN] = ACTIONS(13489),
    [anon_sym_COLON2] = ACTIONS(13489),
    [anon_sym_export] = ACTIONS(13489),
    [anon_sym_import] = ACTIONS(13489),
    [anon_sym_using] = ACTIONS(13489),
    [anon_sym_LBRACK] = ACTIONS(13489),
    [anon_sym_LF] = ACTIONS(13491),
    [anon_sym_in] = ACTIONS(13489),
    [anon_sym_LBRACE] = ACTIONS(13489),
    [anon_sym_DOLLAR] = ACTIONS(13489),
    [anon_sym_COLON_COLON] = ACTIONS(13489),
    [anon_sym_isa] = ACTIONS(13489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13489),
    [anon_sym_QMARK] = ACTIONS(13489),
    [anon_sym_AT] = ACTIONS(13489),
    [anon_sym_true] = ACTIONS(13489),
    [anon_sym_false] = ACTIONS(13489),
    [aux_sym_integer_literal_token1] = ACTIONS(13489),
    [aux_sym_integer_literal_token2] = ACTIONS(13489),
    [aux_sym_integer_literal_token3] = ACTIONS(13489),
    [aux_sym_integer_literal_token4] = ACTIONS(13489),
    [aux_sym_float_literal_token1] = ACTIONS(13489),
    [aux_sym_float_literal_token3] = ACTIONS(13489),
    [aux_sym_float_literal_token4] = ACTIONS(13489),
    [sym_character_literal] = ACTIONS(13489),
    [sym__pair_operator] = ACTIONS(13489),
    [sym__arrow_operator] = ACTIONS(13489),
    [sym__lazy_or_operator] = ACTIONS(13489),
    [sym__lazy_and_operator] = ACTIONS(13489),
    [sym__comparison_operator] = ACTIONS(13489),
    [sym__pipe_right_operator] = ACTIONS(13489),
    [sym__pipe_left_operator] = ACTIONS(13489),
    [sym__ellipsis_operator] = ACTIONS(13489),
    [sym__plus_operator] = ACTIONS(13489),
    [sym__times_operator] = ACTIONS(13489),
    [sym__rational_operator] = ACTIONS(13489),
    [sym__bitshift_operator] = ACTIONS(13489),
    [sym__power_operator] = ACTIONS(13489),
    [sym__tilde_operator] = ACTIONS(13489),
    [sym__type_order_operator] = ACTIONS(13489),
    [sym__unary_operator] = ACTIONS(13489),
    [sym__unary_plus_operator] = ACTIONS(13489),
    [aux_sym__terminator_token1] = ACTIONS(13489),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13491),
    [sym__command_start] = ACTIONS(13491),
  },
  [7473] = {
    [sym__word_identifier] = ACTIONS(13499),
    [anon_sym_EQ] = ACTIONS(13499),
    [anon_sym_COMMA] = ACTIONS(13499),
    [anon_sym_COLON] = ACTIONS(13499),
    [anon_sym_begin] = ACTIONS(13499),
    [anon_sym_module] = ACTIONS(13499),
    [anon_sym_baremodule] = ACTIONS(13499),
    [anon_sym_end] = ACTIONS(13499),
    [anon_sym_abstract] = ACTIONS(13499),
    [anon_sym_primitive] = ACTIONS(13499),
    [anon_sym_mutable] = ACTIONS(13499),
    [anon_sym_struct] = ACTIONS(13499),
    [anon_sym_function] = ACTIONS(13499),
    [anon_sym_macro] = ACTIONS(13499),
    [anon_sym_where] = ACTIONS(13499),
    [anon_sym_quote] = ACTIONS(13499),
    [anon_sym_let] = ACTIONS(13499),
    [anon_sym_if] = ACTIONS(13499),
    [anon_sym_else] = ACTIONS(13499),
    [anon_sym_try] = ACTIONS(13499),
    [anon_sym_finally] = ACTIONS(13499),
    [anon_sym_for] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(13499),
    [sym_break_statement] = ACTIONS(13499),
    [sym_continue_statement] = ACTIONS(13499),
    [anon_sym_return] = ACTIONS(13499),
    [anon_sym_const] = ACTIONS(13499),
    [anon_sym_global] = ACTIONS(13499),
    [anon_sym_local] = ACTIONS(13499),
    [anon_sym_LPAREN] = ACTIONS(13499),
    [anon_sym_COLON2] = ACTIONS(13499),
    [anon_sym_export] = ACTIONS(13499),
    [anon_sym_import] = ACTIONS(13499),
    [anon_sym_using] = ACTIONS(13499),
    [anon_sym_LBRACK] = ACTIONS(13499),
    [anon_sym_LF] = ACTIONS(13501),
    [anon_sym_in] = ACTIONS(13499),
    [anon_sym_LBRACE] = ACTIONS(13499),
    [anon_sym_DOLLAR] = ACTIONS(13499),
    [anon_sym_COLON_COLON] = ACTIONS(13499),
    [anon_sym_isa] = ACTIONS(13499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13499),
    [anon_sym_QMARK] = ACTIONS(13499),
    [anon_sym_AT] = ACTIONS(13499),
    [anon_sym_true] = ACTIONS(13499),
    [anon_sym_false] = ACTIONS(13499),
    [aux_sym_integer_literal_token1] = ACTIONS(13499),
    [aux_sym_integer_literal_token2] = ACTIONS(13499),
    [aux_sym_integer_literal_token3] = ACTIONS(13499),
    [aux_sym_integer_literal_token4] = ACTIONS(13499),
    [aux_sym_float_literal_token1] = ACTIONS(13499),
    [aux_sym_float_literal_token3] = ACTIONS(13499),
    [aux_sym_float_literal_token4] = ACTIONS(13499),
    [sym_character_literal] = ACTIONS(13499),
    [sym__pair_operator] = ACTIONS(13499),
    [sym__arrow_operator] = ACTIONS(13499),
    [sym__lazy_or_operator] = ACTIONS(13499),
    [sym__lazy_and_operator] = ACTIONS(13499),
    [sym__comparison_operator] = ACTIONS(13499),
    [sym__pipe_right_operator] = ACTIONS(13499),
    [sym__pipe_left_operator] = ACTIONS(13499),
    [sym__ellipsis_operator] = ACTIONS(13499),
    [sym__plus_operator] = ACTIONS(13499),
    [sym__times_operator] = ACTIONS(13499),
    [sym__rational_operator] = ACTIONS(13499),
    [sym__bitshift_operator] = ACTIONS(13499),
    [sym__power_operator] = ACTIONS(13499),
    [sym__tilde_operator] = ACTIONS(13499),
    [sym__type_order_operator] = ACTIONS(13499),
    [sym__unary_operator] = ACTIONS(13499),
    [sym__unary_plus_operator] = ACTIONS(13499),
    [aux_sym__terminator_token1] = ACTIONS(13499),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13501),
    [sym__command_start] = ACTIONS(13501),
  },
  [7474] = {
    [aux_sym_open_tuple_repeat1] = STATE(7474),
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13503),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_end] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13070),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_finally] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(13070),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13070),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(13070),
    [anon_sym_isa] = ACTIONS(13070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13070),
    [anon_sym_QMARK] = ACTIONS(13070),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(13070),
    [sym__arrow_operator] = ACTIONS(13070),
    [sym__lazy_or_operator] = ACTIONS(13070),
    [sym__lazy_and_operator] = ACTIONS(13070),
    [sym__comparison_operator] = ACTIONS(13070),
    [sym__pipe_right_operator] = ACTIONS(13070),
    [sym__pipe_left_operator] = ACTIONS(13070),
    [sym__ellipsis_operator] = ACTIONS(13070),
    [sym__plus_operator] = ACTIONS(13070),
    [sym__times_operator] = ACTIONS(13070),
    [sym__rational_operator] = ACTIONS(13070),
    [sym__bitshift_operator] = ACTIONS(13070),
    [sym__power_operator] = ACTIONS(13070),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(13070),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13070),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [7475] = {
    [sym__word_identifier] = ACTIONS(13506),
    [anon_sym_EQ] = ACTIONS(13506),
    [anon_sym_COMMA] = ACTIONS(13506),
    [anon_sym_COLON] = ACTIONS(13506),
    [anon_sym_begin] = ACTIONS(13506),
    [anon_sym_module] = ACTIONS(13506),
    [anon_sym_baremodule] = ACTIONS(13506),
    [anon_sym_end] = ACTIONS(13506),
    [anon_sym_abstract] = ACTIONS(13506),
    [anon_sym_primitive] = ACTIONS(13506),
    [anon_sym_mutable] = ACTIONS(13506),
    [anon_sym_struct] = ACTIONS(13506),
    [anon_sym_function] = ACTIONS(13506),
    [anon_sym_macro] = ACTIONS(13506),
    [anon_sym_where] = ACTIONS(13506),
    [anon_sym_quote] = ACTIONS(13506),
    [anon_sym_let] = ACTIONS(13506),
    [anon_sym_if] = ACTIONS(13506),
    [anon_sym_else] = ACTIONS(13506),
    [anon_sym_try] = ACTIONS(13506),
    [anon_sym_finally] = ACTIONS(13506),
    [anon_sym_for] = ACTIONS(13506),
    [anon_sym_while] = ACTIONS(13506),
    [sym_break_statement] = ACTIONS(13506),
    [sym_continue_statement] = ACTIONS(13506),
    [anon_sym_return] = ACTIONS(13506),
    [anon_sym_const] = ACTIONS(13506),
    [anon_sym_global] = ACTIONS(13506),
    [anon_sym_local] = ACTIONS(13506),
    [anon_sym_LPAREN] = ACTIONS(13506),
    [anon_sym_COLON2] = ACTIONS(13506),
    [anon_sym_export] = ACTIONS(13506),
    [anon_sym_import] = ACTIONS(13506),
    [anon_sym_using] = ACTIONS(13506),
    [anon_sym_LBRACK] = ACTIONS(13506),
    [anon_sym_LF] = ACTIONS(13508),
    [anon_sym_in] = ACTIONS(13506),
    [anon_sym_LBRACE] = ACTIONS(13506),
    [anon_sym_DOLLAR] = ACTIONS(13506),
    [anon_sym_COLON_COLON] = ACTIONS(13506),
    [anon_sym_isa] = ACTIONS(13506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13506),
    [anon_sym_QMARK] = ACTIONS(13506),
    [anon_sym_AT] = ACTIONS(13506),
    [anon_sym_true] = ACTIONS(13506),
    [anon_sym_false] = ACTIONS(13506),
    [aux_sym_integer_literal_token1] = ACTIONS(13506),
    [aux_sym_integer_literal_token2] = ACTIONS(13506),
    [aux_sym_integer_literal_token3] = ACTIONS(13506),
    [aux_sym_integer_literal_token4] = ACTIONS(13506),
    [aux_sym_float_literal_token1] = ACTIONS(13506),
    [aux_sym_float_literal_token3] = ACTIONS(13506),
    [aux_sym_float_literal_token4] = ACTIONS(13506),
    [sym_character_literal] = ACTIONS(13506),
    [sym__pair_operator] = ACTIONS(13506),
    [sym__arrow_operator] = ACTIONS(13506),
    [sym__lazy_or_operator] = ACTIONS(13506),
    [sym__lazy_and_operator] = ACTIONS(13506),
    [sym__comparison_operator] = ACTIONS(13506),
    [sym__pipe_right_operator] = ACTIONS(13506),
    [sym__pipe_left_operator] = ACTIONS(13506),
    [sym__ellipsis_operator] = ACTIONS(13506),
    [sym__plus_operator] = ACTIONS(13506),
    [sym__times_operator] = ACTIONS(13506),
    [sym__rational_operator] = ACTIONS(13506),
    [sym__bitshift_operator] = ACTIONS(13506),
    [sym__power_operator] = ACTIONS(13506),
    [sym__tilde_operator] = ACTIONS(13506),
    [sym__type_order_operator] = ACTIONS(13506),
    [sym__unary_operator] = ACTIONS(13506),
    [sym__unary_plus_operator] = ACTIONS(13506),
    [aux_sym__terminator_token1] = ACTIONS(13506),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13508),
    [sym__command_start] = ACTIONS(13508),
  },
  [7476] = {
    [sym__word_identifier] = ACTIONS(13510),
    [anon_sym_EQ] = ACTIONS(13510),
    [anon_sym_COMMA] = ACTIONS(13510),
    [anon_sym_COLON] = ACTIONS(13510),
    [anon_sym_begin] = ACTIONS(13510),
    [anon_sym_module] = ACTIONS(13510),
    [anon_sym_baremodule] = ACTIONS(13510),
    [anon_sym_end] = ACTIONS(13510),
    [anon_sym_abstract] = ACTIONS(13510),
    [anon_sym_primitive] = ACTIONS(13510),
    [anon_sym_mutable] = ACTIONS(13510),
    [anon_sym_struct] = ACTIONS(13510),
    [anon_sym_function] = ACTIONS(13510),
    [anon_sym_macro] = ACTIONS(13510),
    [anon_sym_where] = ACTIONS(13510),
    [anon_sym_quote] = ACTIONS(13510),
    [anon_sym_let] = ACTIONS(13510),
    [anon_sym_if] = ACTIONS(13510),
    [anon_sym_else] = ACTIONS(13510),
    [anon_sym_try] = ACTIONS(13510),
    [anon_sym_finally] = ACTIONS(13510),
    [anon_sym_for] = ACTIONS(13510),
    [anon_sym_while] = ACTIONS(13510),
    [sym_break_statement] = ACTIONS(13510),
    [sym_continue_statement] = ACTIONS(13510),
    [anon_sym_return] = ACTIONS(13510),
    [anon_sym_const] = ACTIONS(13510),
    [anon_sym_global] = ACTIONS(13510),
    [anon_sym_local] = ACTIONS(13510),
    [anon_sym_LPAREN] = ACTIONS(13510),
    [anon_sym_COLON2] = ACTIONS(13510),
    [anon_sym_export] = ACTIONS(13510),
    [anon_sym_import] = ACTIONS(13510),
    [anon_sym_using] = ACTIONS(13510),
    [anon_sym_LBRACK] = ACTIONS(13510),
    [anon_sym_LF] = ACTIONS(13512),
    [anon_sym_in] = ACTIONS(13510),
    [anon_sym_LBRACE] = ACTIONS(13510),
    [anon_sym_DOLLAR] = ACTIONS(13510),
    [anon_sym_COLON_COLON] = ACTIONS(13510),
    [anon_sym_isa] = ACTIONS(13510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13510),
    [anon_sym_QMARK] = ACTIONS(13510),
    [anon_sym_AT] = ACTIONS(13510),
    [anon_sym_true] = ACTIONS(13510),
    [anon_sym_false] = ACTIONS(13510),
    [aux_sym_integer_literal_token1] = ACTIONS(13510),
    [aux_sym_integer_literal_token2] = ACTIONS(13510),
    [aux_sym_integer_literal_token3] = ACTIONS(13510),
    [aux_sym_integer_literal_token4] = ACTIONS(13510),
    [aux_sym_float_literal_token1] = ACTIONS(13510),
    [aux_sym_float_literal_token3] = ACTIONS(13510),
    [aux_sym_float_literal_token4] = ACTIONS(13510),
    [sym_character_literal] = ACTIONS(13510),
    [sym__pair_operator] = ACTIONS(13510),
    [sym__arrow_operator] = ACTIONS(13510),
    [sym__lazy_or_operator] = ACTIONS(13510),
    [sym__lazy_and_operator] = ACTIONS(13510),
    [sym__comparison_operator] = ACTIONS(13510),
    [sym__pipe_right_operator] = ACTIONS(13510),
    [sym__pipe_left_operator] = ACTIONS(13510),
    [sym__ellipsis_operator] = ACTIONS(13510),
    [sym__plus_operator] = ACTIONS(13510),
    [sym__times_operator] = ACTIONS(13510),
    [sym__rational_operator] = ACTIONS(13510),
    [sym__bitshift_operator] = ACTIONS(13510),
    [sym__power_operator] = ACTIONS(13510),
    [sym__tilde_operator] = ACTIONS(13510),
    [sym__type_order_operator] = ACTIONS(13510),
    [sym__unary_operator] = ACTIONS(13510),
    [sym__unary_plus_operator] = ACTIONS(13510),
    [aux_sym__terminator_token1] = ACTIONS(13510),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13512),
    [sym__command_start] = ACTIONS(13512),
  },
  [7477] = {
    [sym__word_identifier] = ACTIONS(13514),
    [anon_sym_EQ] = ACTIONS(13514),
    [anon_sym_COMMA] = ACTIONS(13514),
    [anon_sym_COLON] = ACTIONS(13514),
    [anon_sym_begin] = ACTIONS(13514),
    [anon_sym_module] = ACTIONS(13514),
    [anon_sym_baremodule] = ACTIONS(13514),
    [anon_sym_end] = ACTIONS(13514),
    [anon_sym_abstract] = ACTIONS(13514),
    [anon_sym_primitive] = ACTIONS(13514),
    [anon_sym_mutable] = ACTIONS(13514),
    [anon_sym_struct] = ACTIONS(13514),
    [anon_sym_function] = ACTIONS(13514),
    [anon_sym_macro] = ACTIONS(13514),
    [anon_sym_where] = ACTIONS(13514),
    [anon_sym_quote] = ACTIONS(13514),
    [anon_sym_let] = ACTIONS(13514),
    [anon_sym_if] = ACTIONS(13514),
    [anon_sym_else] = ACTIONS(13514),
    [anon_sym_try] = ACTIONS(13514),
    [anon_sym_finally] = ACTIONS(13514),
    [anon_sym_for] = ACTIONS(13514),
    [anon_sym_while] = ACTIONS(13514),
    [sym_break_statement] = ACTIONS(13514),
    [sym_continue_statement] = ACTIONS(13514),
    [anon_sym_return] = ACTIONS(13514),
    [anon_sym_const] = ACTIONS(13514),
    [anon_sym_global] = ACTIONS(13514),
    [anon_sym_local] = ACTIONS(13514),
    [anon_sym_LPAREN] = ACTIONS(13514),
    [anon_sym_COLON2] = ACTIONS(13514),
    [anon_sym_export] = ACTIONS(13514),
    [anon_sym_import] = ACTIONS(13514),
    [anon_sym_using] = ACTIONS(13514),
    [anon_sym_LBRACK] = ACTIONS(13514),
    [anon_sym_LF] = ACTIONS(13516),
    [anon_sym_in] = ACTIONS(13514),
    [anon_sym_LBRACE] = ACTIONS(13514),
    [anon_sym_DOLLAR] = ACTIONS(13514),
    [anon_sym_COLON_COLON] = ACTIONS(13514),
    [anon_sym_isa] = ACTIONS(13514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13514),
    [anon_sym_QMARK] = ACTIONS(13514),
    [anon_sym_AT] = ACTIONS(13514),
    [anon_sym_true] = ACTIONS(13514),
    [anon_sym_false] = ACTIONS(13514),
    [aux_sym_integer_literal_token1] = ACTIONS(13514),
    [aux_sym_integer_literal_token2] = ACTIONS(13514),
    [aux_sym_integer_literal_token3] = ACTIONS(13514),
    [aux_sym_integer_literal_token4] = ACTIONS(13514),
    [aux_sym_float_literal_token1] = ACTIONS(13514),
    [aux_sym_float_literal_token3] = ACTIONS(13514),
    [aux_sym_float_literal_token4] = ACTIONS(13514),
    [sym_character_literal] = ACTIONS(13514),
    [sym__pair_operator] = ACTIONS(13514),
    [sym__arrow_operator] = ACTIONS(13514),
    [sym__lazy_or_operator] = ACTIONS(13514),
    [sym__lazy_and_operator] = ACTIONS(13514),
    [sym__comparison_operator] = ACTIONS(13514),
    [sym__pipe_right_operator] = ACTIONS(13514),
    [sym__pipe_left_operator] = ACTIONS(13514),
    [sym__ellipsis_operator] = ACTIONS(13514),
    [sym__plus_operator] = ACTIONS(13514),
    [sym__times_operator] = ACTIONS(13514),
    [sym__rational_operator] = ACTIONS(13514),
    [sym__bitshift_operator] = ACTIONS(13514),
    [sym__power_operator] = ACTIONS(13514),
    [sym__tilde_operator] = ACTIONS(13514),
    [sym__type_order_operator] = ACTIONS(13514),
    [sym__unary_operator] = ACTIONS(13514),
    [sym__unary_plus_operator] = ACTIONS(13514),
    [aux_sym__terminator_token1] = ACTIONS(13514),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13516),
    [sym__command_start] = ACTIONS(13516),
  },
  [7478] = {
    [sym__word_identifier] = ACTIONS(13518),
    [anon_sym_EQ] = ACTIONS(13518),
    [anon_sym_COMMA] = ACTIONS(13518),
    [anon_sym_COLON] = ACTIONS(13518),
    [anon_sym_begin] = ACTIONS(13518),
    [anon_sym_module] = ACTIONS(13518),
    [anon_sym_baremodule] = ACTIONS(13518),
    [anon_sym_end] = ACTIONS(13518),
    [anon_sym_abstract] = ACTIONS(13518),
    [anon_sym_primitive] = ACTIONS(13518),
    [anon_sym_mutable] = ACTIONS(13518),
    [anon_sym_struct] = ACTIONS(13518),
    [anon_sym_function] = ACTIONS(13518),
    [anon_sym_macro] = ACTIONS(13518),
    [anon_sym_where] = ACTIONS(13518),
    [anon_sym_quote] = ACTIONS(13518),
    [anon_sym_let] = ACTIONS(13518),
    [anon_sym_if] = ACTIONS(13518),
    [anon_sym_else] = ACTIONS(13518),
    [anon_sym_try] = ACTIONS(13518),
    [anon_sym_finally] = ACTIONS(13518),
    [anon_sym_for] = ACTIONS(13518),
    [anon_sym_while] = ACTIONS(13518),
    [sym_break_statement] = ACTIONS(13518),
    [sym_continue_statement] = ACTIONS(13518),
    [anon_sym_return] = ACTIONS(13518),
    [anon_sym_const] = ACTIONS(13518),
    [anon_sym_global] = ACTIONS(13518),
    [anon_sym_local] = ACTIONS(13518),
    [anon_sym_LPAREN] = ACTIONS(13518),
    [anon_sym_COLON2] = ACTIONS(13518),
    [anon_sym_export] = ACTIONS(13518),
    [anon_sym_import] = ACTIONS(13518),
    [anon_sym_using] = ACTIONS(13518),
    [anon_sym_LBRACK] = ACTIONS(13518),
    [anon_sym_LF] = ACTIONS(13520),
    [anon_sym_in] = ACTIONS(13518),
    [anon_sym_LBRACE] = ACTIONS(13518),
    [anon_sym_DOLLAR] = ACTIONS(13518),
    [anon_sym_COLON_COLON] = ACTIONS(13518),
    [anon_sym_isa] = ACTIONS(13518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13518),
    [anon_sym_QMARK] = ACTIONS(13518),
    [anon_sym_AT] = ACTIONS(13518),
    [anon_sym_true] = ACTIONS(13518),
    [anon_sym_false] = ACTIONS(13518),
    [aux_sym_integer_literal_token1] = ACTIONS(13518),
    [aux_sym_integer_literal_token2] = ACTIONS(13518),
    [aux_sym_integer_literal_token3] = ACTIONS(13518),
    [aux_sym_integer_literal_token4] = ACTIONS(13518),
    [aux_sym_float_literal_token1] = ACTIONS(13518),
    [aux_sym_float_literal_token3] = ACTIONS(13518),
    [aux_sym_float_literal_token4] = ACTIONS(13518),
    [sym_character_literal] = ACTIONS(13518),
    [sym__pair_operator] = ACTIONS(13518),
    [sym__arrow_operator] = ACTIONS(13518),
    [sym__lazy_or_operator] = ACTIONS(13518),
    [sym__lazy_and_operator] = ACTIONS(13518),
    [sym__comparison_operator] = ACTIONS(13518),
    [sym__pipe_right_operator] = ACTIONS(13518),
    [sym__pipe_left_operator] = ACTIONS(13518),
    [sym__ellipsis_operator] = ACTIONS(13518),
    [sym__plus_operator] = ACTIONS(13518),
    [sym__times_operator] = ACTIONS(13518),
    [sym__rational_operator] = ACTIONS(13518),
    [sym__bitshift_operator] = ACTIONS(13518),
    [sym__power_operator] = ACTIONS(13518),
    [sym__tilde_operator] = ACTIONS(13518),
    [sym__type_order_operator] = ACTIONS(13518),
    [sym__unary_operator] = ACTIONS(13518),
    [sym__unary_plus_operator] = ACTIONS(13518),
    [aux_sym__terminator_token1] = ACTIONS(13518),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13520),
    [sym__command_start] = ACTIONS(13520),
  },
  [7479] = {
    [sym__word_identifier] = ACTIONS(13257),
    [anon_sym_EQ] = ACTIONS(13257),
    [anon_sym_COMMA] = ACTIONS(13257),
    [anon_sym_COLON] = ACTIONS(13257),
    [anon_sym_begin] = ACTIONS(13257),
    [anon_sym_module] = ACTIONS(13257),
    [anon_sym_baremodule] = ACTIONS(13257),
    [anon_sym_end] = ACTIONS(13257),
    [anon_sym_abstract] = ACTIONS(13257),
    [anon_sym_primitive] = ACTIONS(13257),
    [anon_sym_mutable] = ACTIONS(13257),
    [anon_sym_struct] = ACTIONS(13257),
    [anon_sym_function] = ACTIONS(13257),
    [anon_sym_macro] = ACTIONS(13257),
    [anon_sym_where] = ACTIONS(13257),
    [anon_sym_quote] = ACTIONS(13257),
    [anon_sym_let] = ACTIONS(13257),
    [anon_sym_if] = ACTIONS(13257),
    [anon_sym_else] = ACTIONS(13257),
    [anon_sym_try] = ACTIONS(13257),
    [anon_sym_finally] = ACTIONS(13257),
    [anon_sym_for] = ACTIONS(13257),
    [anon_sym_while] = ACTIONS(13257),
    [sym_break_statement] = ACTIONS(13257),
    [sym_continue_statement] = ACTIONS(13257),
    [anon_sym_return] = ACTIONS(13257),
    [anon_sym_const] = ACTIONS(13257),
    [anon_sym_global] = ACTIONS(13257),
    [anon_sym_local] = ACTIONS(13257),
    [anon_sym_LPAREN] = ACTIONS(13257),
    [anon_sym_COLON2] = ACTIONS(13257),
    [anon_sym_export] = ACTIONS(13257),
    [anon_sym_import] = ACTIONS(13257),
    [anon_sym_using] = ACTIONS(13257),
    [anon_sym_LBRACK] = ACTIONS(13257),
    [anon_sym_LF] = ACTIONS(13259),
    [anon_sym_in] = ACTIONS(13257),
    [anon_sym_LBRACE] = ACTIONS(13257),
    [anon_sym_DOLLAR] = ACTIONS(13257),
    [anon_sym_COLON_COLON] = ACTIONS(13257),
    [anon_sym_isa] = ACTIONS(13257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13257),
    [anon_sym_QMARK] = ACTIONS(13257),
    [anon_sym_AT] = ACTIONS(13257),
    [anon_sym_true] = ACTIONS(13257),
    [anon_sym_false] = ACTIONS(13257),
    [aux_sym_integer_literal_token1] = ACTIONS(13257),
    [aux_sym_integer_literal_token2] = ACTIONS(13257),
    [aux_sym_integer_literal_token3] = ACTIONS(13257),
    [aux_sym_integer_literal_token4] = ACTIONS(13257),
    [aux_sym_float_literal_token1] = ACTIONS(13257),
    [aux_sym_float_literal_token3] = ACTIONS(13257),
    [aux_sym_float_literal_token4] = ACTIONS(13257),
    [sym_character_literal] = ACTIONS(13257),
    [sym__pair_operator] = ACTIONS(13257),
    [sym__arrow_operator] = ACTIONS(13257),
    [sym__lazy_or_operator] = ACTIONS(13257),
    [sym__lazy_and_operator] = ACTIONS(13257),
    [sym__comparison_operator] = ACTIONS(13257),
    [sym__pipe_right_operator] = ACTIONS(13257),
    [sym__pipe_left_operator] = ACTIONS(13257),
    [sym__ellipsis_operator] = ACTIONS(13257),
    [sym__plus_operator] = ACTIONS(13257),
    [sym__times_operator] = ACTIONS(13257),
    [sym__rational_operator] = ACTIONS(13257),
    [sym__bitshift_operator] = ACTIONS(13257),
    [sym__power_operator] = ACTIONS(13257),
    [sym__tilde_operator] = ACTIONS(13257),
    [sym__type_order_operator] = ACTIONS(13257),
    [sym__unary_operator] = ACTIONS(13257),
    [sym__unary_plus_operator] = ACTIONS(13257),
    [aux_sym__terminator_token1] = ACTIONS(13257),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13259),
    [sym__command_start] = ACTIONS(13259),
  },
  [7480] = {
    [sym__word_identifier] = ACTIONS(13522),
    [anon_sym_EQ] = ACTIONS(13522),
    [anon_sym_COMMA] = ACTIONS(13522),
    [anon_sym_COLON] = ACTIONS(13522),
    [anon_sym_begin] = ACTIONS(13522),
    [anon_sym_module] = ACTIONS(13522),
    [anon_sym_baremodule] = ACTIONS(13522),
    [anon_sym_end] = ACTIONS(13522),
    [anon_sym_abstract] = ACTIONS(13522),
    [anon_sym_primitive] = ACTIONS(13522),
    [anon_sym_mutable] = ACTIONS(13522),
    [anon_sym_struct] = ACTIONS(13522),
    [anon_sym_function] = ACTIONS(13522),
    [anon_sym_macro] = ACTIONS(13522),
    [anon_sym_where] = ACTIONS(13522),
    [anon_sym_quote] = ACTIONS(13522),
    [anon_sym_let] = ACTIONS(13522),
    [anon_sym_if] = ACTIONS(13522),
    [anon_sym_else] = ACTIONS(13522),
    [anon_sym_try] = ACTIONS(13522),
    [anon_sym_finally] = ACTIONS(13522),
    [anon_sym_for] = ACTIONS(13522),
    [anon_sym_while] = ACTIONS(13522),
    [sym_break_statement] = ACTIONS(13522),
    [sym_continue_statement] = ACTIONS(13522),
    [anon_sym_return] = ACTIONS(13522),
    [anon_sym_const] = ACTIONS(13522),
    [anon_sym_global] = ACTIONS(13522),
    [anon_sym_local] = ACTIONS(13522),
    [anon_sym_LPAREN] = ACTIONS(13522),
    [anon_sym_COLON2] = ACTIONS(13522),
    [anon_sym_export] = ACTIONS(13522),
    [anon_sym_import] = ACTIONS(13522),
    [anon_sym_using] = ACTIONS(13522),
    [anon_sym_LBRACK] = ACTIONS(13522),
    [anon_sym_LF] = ACTIONS(13524),
    [anon_sym_in] = ACTIONS(13522),
    [anon_sym_LBRACE] = ACTIONS(13522),
    [anon_sym_DOLLAR] = ACTIONS(13522),
    [anon_sym_COLON_COLON] = ACTIONS(13522),
    [anon_sym_isa] = ACTIONS(13522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13522),
    [anon_sym_QMARK] = ACTIONS(13522),
    [anon_sym_AT] = ACTIONS(13522),
    [anon_sym_true] = ACTIONS(13522),
    [anon_sym_false] = ACTIONS(13522),
    [aux_sym_integer_literal_token1] = ACTIONS(13522),
    [aux_sym_integer_literal_token2] = ACTIONS(13522),
    [aux_sym_integer_literal_token3] = ACTIONS(13522),
    [aux_sym_integer_literal_token4] = ACTIONS(13522),
    [aux_sym_float_literal_token1] = ACTIONS(13522),
    [aux_sym_float_literal_token3] = ACTIONS(13522),
    [aux_sym_float_literal_token4] = ACTIONS(13522),
    [sym_character_literal] = ACTIONS(13522),
    [sym__pair_operator] = ACTIONS(13522),
    [sym__arrow_operator] = ACTIONS(13522),
    [sym__lazy_or_operator] = ACTIONS(13522),
    [sym__lazy_and_operator] = ACTIONS(13522),
    [sym__comparison_operator] = ACTIONS(13522),
    [sym__pipe_right_operator] = ACTIONS(13522),
    [sym__pipe_left_operator] = ACTIONS(13522),
    [sym__ellipsis_operator] = ACTIONS(13522),
    [sym__plus_operator] = ACTIONS(13522),
    [sym__times_operator] = ACTIONS(13522),
    [sym__rational_operator] = ACTIONS(13522),
    [sym__bitshift_operator] = ACTIONS(13522),
    [sym__power_operator] = ACTIONS(13522),
    [sym__tilde_operator] = ACTIONS(13522),
    [sym__type_order_operator] = ACTIONS(13522),
    [sym__unary_operator] = ACTIONS(13522),
    [sym__unary_plus_operator] = ACTIONS(13522),
    [aux_sym__terminator_token1] = ACTIONS(13522),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13524),
    [sym__command_start] = ACTIONS(13524),
  },
  [7481] = {
    [sym__word_identifier] = ACTIONS(13526),
    [anon_sym_EQ] = ACTIONS(13526),
    [anon_sym_COMMA] = ACTIONS(13526),
    [anon_sym_COLON] = ACTIONS(13526),
    [anon_sym_begin] = ACTIONS(13526),
    [anon_sym_module] = ACTIONS(13526),
    [anon_sym_baremodule] = ACTIONS(13526),
    [anon_sym_end] = ACTIONS(13526),
    [anon_sym_abstract] = ACTIONS(13526),
    [anon_sym_primitive] = ACTIONS(13526),
    [anon_sym_mutable] = ACTIONS(13526),
    [anon_sym_struct] = ACTIONS(13526),
    [anon_sym_function] = ACTIONS(13526),
    [anon_sym_macro] = ACTIONS(13526),
    [anon_sym_where] = ACTIONS(13526),
    [anon_sym_quote] = ACTIONS(13526),
    [anon_sym_let] = ACTIONS(13526),
    [anon_sym_if] = ACTIONS(13526),
    [anon_sym_else] = ACTIONS(13526),
    [anon_sym_try] = ACTIONS(13526),
    [anon_sym_finally] = ACTIONS(13526),
    [anon_sym_for] = ACTIONS(13526),
    [anon_sym_while] = ACTIONS(13526),
    [sym_break_statement] = ACTIONS(13526),
    [sym_continue_statement] = ACTIONS(13526),
    [anon_sym_return] = ACTIONS(13526),
    [anon_sym_const] = ACTIONS(13526),
    [anon_sym_global] = ACTIONS(13526),
    [anon_sym_local] = ACTIONS(13526),
    [anon_sym_LPAREN] = ACTIONS(13526),
    [anon_sym_COLON2] = ACTIONS(13526),
    [anon_sym_export] = ACTIONS(13526),
    [anon_sym_import] = ACTIONS(13526),
    [anon_sym_using] = ACTIONS(13526),
    [anon_sym_LBRACK] = ACTIONS(13526),
    [anon_sym_LF] = ACTIONS(13528),
    [anon_sym_in] = ACTIONS(13526),
    [anon_sym_LBRACE] = ACTIONS(13526),
    [anon_sym_DOLLAR] = ACTIONS(13526),
    [anon_sym_COLON_COLON] = ACTIONS(13526),
    [anon_sym_isa] = ACTIONS(13526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13526),
    [anon_sym_QMARK] = ACTIONS(13526),
    [anon_sym_AT] = ACTIONS(13526),
    [anon_sym_true] = ACTIONS(13526),
    [anon_sym_false] = ACTIONS(13526),
    [aux_sym_integer_literal_token1] = ACTIONS(13526),
    [aux_sym_integer_literal_token2] = ACTIONS(13526),
    [aux_sym_integer_literal_token3] = ACTIONS(13526),
    [aux_sym_integer_literal_token4] = ACTIONS(13526),
    [aux_sym_float_literal_token1] = ACTIONS(13526),
    [aux_sym_float_literal_token3] = ACTIONS(13526),
    [aux_sym_float_literal_token4] = ACTIONS(13526),
    [sym_character_literal] = ACTIONS(13526),
    [sym__pair_operator] = ACTIONS(13526),
    [sym__arrow_operator] = ACTIONS(13526),
    [sym__lazy_or_operator] = ACTIONS(13526),
    [sym__lazy_and_operator] = ACTIONS(13526),
    [sym__comparison_operator] = ACTIONS(13526),
    [sym__pipe_right_operator] = ACTIONS(13526),
    [sym__pipe_left_operator] = ACTIONS(13526),
    [sym__ellipsis_operator] = ACTIONS(13526),
    [sym__plus_operator] = ACTIONS(13526),
    [sym__times_operator] = ACTIONS(13526),
    [sym__rational_operator] = ACTIONS(13526),
    [sym__bitshift_operator] = ACTIONS(13526),
    [sym__power_operator] = ACTIONS(13526),
    [sym__tilde_operator] = ACTIONS(13526),
    [sym__type_order_operator] = ACTIONS(13526),
    [sym__unary_operator] = ACTIONS(13526),
    [sym__unary_plus_operator] = ACTIONS(13526),
    [aux_sym__terminator_token1] = ACTIONS(13526),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13528),
    [sym__command_start] = ACTIONS(13528),
  },
  [7482] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_catch] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7483] = {
    [sym__word_identifier] = ACTIONS(13530),
    [anon_sym_EQ] = ACTIONS(13530),
    [anon_sym_COMMA] = ACTIONS(13530),
    [anon_sym_COLON] = ACTIONS(13530),
    [anon_sym_begin] = ACTIONS(13530),
    [anon_sym_module] = ACTIONS(13530),
    [anon_sym_baremodule] = ACTIONS(13530),
    [anon_sym_end] = ACTIONS(13530),
    [anon_sym_abstract] = ACTIONS(13530),
    [anon_sym_primitive] = ACTIONS(13530),
    [anon_sym_mutable] = ACTIONS(13530),
    [anon_sym_struct] = ACTIONS(13530),
    [anon_sym_function] = ACTIONS(13530),
    [anon_sym_macro] = ACTIONS(13530),
    [anon_sym_where] = ACTIONS(13530),
    [anon_sym_quote] = ACTIONS(13530),
    [anon_sym_let] = ACTIONS(13530),
    [anon_sym_if] = ACTIONS(13530),
    [anon_sym_else] = ACTIONS(13530),
    [anon_sym_try] = ACTIONS(13530),
    [anon_sym_finally] = ACTIONS(13530),
    [anon_sym_for] = ACTIONS(13530),
    [anon_sym_while] = ACTIONS(13530),
    [sym_break_statement] = ACTIONS(13530),
    [sym_continue_statement] = ACTIONS(13530),
    [anon_sym_return] = ACTIONS(13530),
    [anon_sym_const] = ACTIONS(13530),
    [anon_sym_global] = ACTIONS(13530),
    [anon_sym_local] = ACTIONS(13530),
    [anon_sym_LPAREN] = ACTIONS(13530),
    [anon_sym_COLON2] = ACTIONS(13530),
    [anon_sym_export] = ACTIONS(13530),
    [anon_sym_import] = ACTIONS(13530),
    [anon_sym_using] = ACTIONS(13530),
    [anon_sym_LBRACK] = ACTIONS(13530),
    [anon_sym_LF] = ACTIONS(13532),
    [anon_sym_in] = ACTIONS(13530),
    [anon_sym_LBRACE] = ACTIONS(13530),
    [anon_sym_DOLLAR] = ACTIONS(13530),
    [anon_sym_COLON_COLON] = ACTIONS(13530),
    [anon_sym_isa] = ACTIONS(13530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13530),
    [anon_sym_QMARK] = ACTIONS(13530),
    [anon_sym_AT] = ACTIONS(13530),
    [anon_sym_true] = ACTIONS(13530),
    [anon_sym_false] = ACTIONS(13530),
    [aux_sym_integer_literal_token1] = ACTIONS(13530),
    [aux_sym_integer_literal_token2] = ACTIONS(13530),
    [aux_sym_integer_literal_token3] = ACTIONS(13530),
    [aux_sym_integer_literal_token4] = ACTIONS(13530),
    [aux_sym_float_literal_token1] = ACTIONS(13530),
    [aux_sym_float_literal_token3] = ACTIONS(13530),
    [aux_sym_float_literal_token4] = ACTIONS(13530),
    [sym_character_literal] = ACTIONS(13530),
    [sym__pair_operator] = ACTIONS(13530),
    [sym__arrow_operator] = ACTIONS(13530),
    [sym__lazy_or_operator] = ACTIONS(13530),
    [sym__lazy_and_operator] = ACTIONS(13530),
    [sym__comparison_operator] = ACTIONS(13530),
    [sym__pipe_right_operator] = ACTIONS(13530),
    [sym__pipe_left_operator] = ACTIONS(13530),
    [sym__ellipsis_operator] = ACTIONS(13530),
    [sym__plus_operator] = ACTIONS(13530),
    [sym__times_operator] = ACTIONS(13530),
    [sym__rational_operator] = ACTIONS(13530),
    [sym__bitshift_operator] = ACTIONS(13530),
    [sym__power_operator] = ACTIONS(13530),
    [sym__tilde_operator] = ACTIONS(13530),
    [sym__type_order_operator] = ACTIONS(13530),
    [sym__unary_operator] = ACTIONS(13530),
    [sym__unary_plus_operator] = ACTIONS(13530),
    [aux_sym__terminator_token1] = ACTIONS(13530),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13532),
    [sym__command_start] = ACTIONS(13532),
  },
  [7484] = {
    [sym__word_identifier] = ACTIONS(13534),
    [anon_sym_EQ] = ACTIONS(13534),
    [anon_sym_COMMA] = ACTIONS(13534),
    [anon_sym_COLON] = ACTIONS(13534),
    [anon_sym_begin] = ACTIONS(13534),
    [anon_sym_module] = ACTIONS(13534),
    [anon_sym_baremodule] = ACTIONS(13534),
    [anon_sym_end] = ACTIONS(13534),
    [anon_sym_abstract] = ACTIONS(13534),
    [anon_sym_primitive] = ACTIONS(13534),
    [anon_sym_mutable] = ACTIONS(13534),
    [anon_sym_struct] = ACTIONS(13534),
    [anon_sym_function] = ACTIONS(13534),
    [anon_sym_macro] = ACTIONS(13534),
    [anon_sym_where] = ACTIONS(13534),
    [anon_sym_quote] = ACTIONS(13534),
    [anon_sym_let] = ACTIONS(13534),
    [anon_sym_if] = ACTIONS(13534),
    [anon_sym_else] = ACTIONS(13534),
    [anon_sym_try] = ACTIONS(13534),
    [anon_sym_finally] = ACTIONS(13534),
    [anon_sym_for] = ACTIONS(13534),
    [anon_sym_while] = ACTIONS(13534),
    [sym_break_statement] = ACTIONS(13534),
    [sym_continue_statement] = ACTIONS(13534),
    [anon_sym_return] = ACTIONS(13534),
    [anon_sym_const] = ACTIONS(13534),
    [anon_sym_global] = ACTIONS(13534),
    [anon_sym_local] = ACTIONS(13534),
    [anon_sym_LPAREN] = ACTIONS(13534),
    [anon_sym_COLON2] = ACTIONS(13534),
    [anon_sym_export] = ACTIONS(13534),
    [anon_sym_import] = ACTIONS(13534),
    [anon_sym_using] = ACTIONS(13534),
    [anon_sym_LBRACK] = ACTIONS(13534),
    [anon_sym_LF] = ACTIONS(13536),
    [anon_sym_in] = ACTIONS(13534),
    [anon_sym_LBRACE] = ACTIONS(13534),
    [anon_sym_DOLLAR] = ACTIONS(13534),
    [anon_sym_COLON_COLON] = ACTIONS(13534),
    [anon_sym_isa] = ACTIONS(13534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13534),
    [anon_sym_QMARK] = ACTIONS(13534),
    [anon_sym_AT] = ACTIONS(13534),
    [anon_sym_true] = ACTIONS(13534),
    [anon_sym_false] = ACTIONS(13534),
    [aux_sym_integer_literal_token1] = ACTIONS(13534),
    [aux_sym_integer_literal_token2] = ACTIONS(13534),
    [aux_sym_integer_literal_token3] = ACTIONS(13534),
    [aux_sym_integer_literal_token4] = ACTIONS(13534),
    [aux_sym_float_literal_token1] = ACTIONS(13534),
    [aux_sym_float_literal_token3] = ACTIONS(13534),
    [aux_sym_float_literal_token4] = ACTIONS(13534),
    [sym_character_literal] = ACTIONS(13534),
    [sym__pair_operator] = ACTIONS(13534),
    [sym__arrow_operator] = ACTIONS(13534),
    [sym__lazy_or_operator] = ACTIONS(13534),
    [sym__lazy_and_operator] = ACTIONS(13534),
    [sym__comparison_operator] = ACTIONS(13534),
    [sym__pipe_right_operator] = ACTIONS(13534),
    [sym__pipe_left_operator] = ACTIONS(13534),
    [sym__ellipsis_operator] = ACTIONS(13534),
    [sym__plus_operator] = ACTIONS(13534),
    [sym__times_operator] = ACTIONS(13534),
    [sym__rational_operator] = ACTIONS(13534),
    [sym__bitshift_operator] = ACTIONS(13534),
    [sym__power_operator] = ACTIONS(13534),
    [sym__tilde_operator] = ACTIONS(13534),
    [sym__type_order_operator] = ACTIONS(13534),
    [sym__unary_operator] = ACTIONS(13534),
    [sym__unary_plus_operator] = ACTIONS(13534),
    [aux_sym__terminator_token1] = ACTIONS(13534),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13536),
    [sym__command_start] = ACTIONS(13536),
  },
  [7485] = {
    [sym__word_identifier] = ACTIONS(13538),
    [anon_sym_EQ] = ACTIONS(13538),
    [anon_sym_COMMA] = ACTIONS(13538),
    [anon_sym_COLON] = ACTIONS(13538),
    [anon_sym_begin] = ACTIONS(13538),
    [anon_sym_module] = ACTIONS(13538),
    [anon_sym_baremodule] = ACTIONS(13538),
    [anon_sym_end] = ACTIONS(13538),
    [anon_sym_abstract] = ACTIONS(13538),
    [anon_sym_primitive] = ACTIONS(13538),
    [anon_sym_mutable] = ACTIONS(13538),
    [anon_sym_struct] = ACTIONS(13538),
    [anon_sym_function] = ACTIONS(13538),
    [anon_sym_macro] = ACTIONS(13538),
    [anon_sym_where] = ACTIONS(13538),
    [anon_sym_quote] = ACTIONS(13538),
    [anon_sym_let] = ACTIONS(13538),
    [anon_sym_if] = ACTIONS(13538),
    [anon_sym_else] = ACTIONS(13538),
    [anon_sym_try] = ACTIONS(13538),
    [anon_sym_finally] = ACTIONS(13538),
    [anon_sym_for] = ACTIONS(13538),
    [anon_sym_while] = ACTIONS(13538),
    [sym_break_statement] = ACTIONS(13538),
    [sym_continue_statement] = ACTIONS(13538),
    [anon_sym_return] = ACTIONS(13538),
    [anon_sym_const] = ACTIONS(13538),
    [anon_sym_global] = ACTIONS(13538),
    [anon_sym_local] = ACTIONS(13538),
    [anon_sym_LPAREN] = ACTIONS(13538),
    [anon_sym_COLON2] = ACTIONS(13538),
    [anon_sym_export] = ACTIONS(13538),
    [anon_sym_import] = ACTIONS(13538),
    [anon_sym_using] = ACTIONS(13538),
    [anon_sym_LBRACK] = ACTIONS(13538),
    [anon_sym_LF] = ACTIONS(13540),
    [anon_sym_in] = ACTIONS(13538),
    [anon_sym_LBRACE] = ACTIONS(13538),
    [anon_sym_DOLLAR] = ACTIONS(13538),
    [anon_sym_COLON_COLON] = ACTIONS(13538),
    [anon_sym_isa] = ACTIONS(13538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13538),
    [anon_sym_QMARK] = ACTIONS(13538),
    [anon_sym_AT] = ACTIONS(13538),
    [anon_sym_true] = ACTIONS(13538),
    [anon_sym_false] = ACTIONS(13538),
    [aux_sym_integer_literal_token1] = ACTIONS(13538),
    [aux_sym_integer_literal_token2] = ACTIONS(13538),
    [aux_sym_integer_literal_token3] = ACTIONS(13538),
    [aux_sym_integer_literal_token4] = ACTIONS(13538),
    [aux_sym_float_literal_token1] = ACTIONS(13538),
    [aux_sym_float_literal_token3] = ACTIONS(13538),
    [aux_sym_float_literal_token4] = ACTIONS(13538),
    [sym_character_literal] = ACTIONS(13538),
    [sym__pair_operator] = ACTIONS(13538),
    [sym__arrow_operator] = ACTIONS(13538),
    [sym__lazy_or_operator] = ACTIONS(13538),
    [sym__lazy_and_operator] = ACTIONS(13538),
    [sym__comparison_operator] = ACTIONS(13538),
    [sym__pipe_right_operator] = ACTIONS(13538),
    [sym__pipe_left_operator] = ACTIONS(13538),
    [sym__ellipsis_operator] = ACTIONS(13538),
    [sym__plus_operator] = ACTIONS(13538),
    [sym__times_operator] = ACTIONS(13538),
    [sym__rational_operator] = ACTIONS(13538),
    [sym__bitshift_operator] = ACTIONS(13538),
    [sym__power_operator] = ACTIONS(13538),
    [sym__tilde_operator] = ACTIONS(13538),
    [sym__type_order_operator] = ACTIONS(13538),
    [sym__unary_operator] = ACTIONS(13538),
    [sym__unary_plus_operator] = ACTIONS(13538),
    [aux_sym__terminator_token1] = ACTIONS(13538),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13540),
    [sym__command_start] = ACTIONS(13540),
  },
  [7486] = {
    [sym__word_identifier] = ACTIONS(13542),
    [anon_sym_EQ] = ACTIONS(13542),
    [anon_sym_COMMA] = ACTIONS(13542),
    [anon_sym_COLON] = ACTIONS(13542),
    [anon_sym_begin] = ACTIONS(13542),
    [anon_sym_module] = ACTIONS(13542),
    [anon_sym_baremodule] = ACTIONS(13542),
    [anon_sym_end] = ACTIONS(13542),
    [anon_sym_abstract] = ACTIONS(13542),
    [anon_sym_primitive] = ACTIONS(13542),
    [anon_sym_mutable] = ACTIONS(13542),
    [anon_sym_struct] = ACTIONS(13542),
    [anon_sym_function] = ACTIONS(13542),
    [anon_sym_macro] = ACTIONS(13542),
    [anon_sym_where] = ACTIONS(13542),
    [anon_sym_quote] = ACTIONS(13542),
    [anon_sym_let] = ACTIONS(13542),
    [anon_sym_if] = ACTIONS(13542),
    [anon_sym_else] = ACTIONS(13542),
    [anon_sym_try] = ACTIONS(13542),
    [anon_sym_finally] = ACTIONS(13542),
    [anon_sym_for] = ACTIONS(13542),
    [anon_sym_while] = ACTIONS(13542),
    [sym_break_statement] = ACTIONS(13542),
    [sym_continue_statement] = ACTIONS(13542),
    [anon_sym_return] = ACTIONS(13542),
    [anon_sym_const] = ACTIONS(13542),
    [anon_sym_global] = ACTIONS(13542),
    [anon_sym_local] = ACTIONS(13542),
    [anon_sym_LPAREN] = ACTIONS(13542),
    [anon_sym_COLON2] = ACTIONS(13542),
    [anon_sym_export] = ACTIONS(13542),
    [anon_sym_import] = ACTIONS(13542),
    [anon_sym_using] = ACTIONS(13542),
    [anon_sym_LBRACK] = ACTIONS(13542),
    [anon_sym_LF] = ACTIONS(13544),
    [anon_sym_in] = ACTIONS(13542),
    [anon_sym_LBRACE] = ACTIONS(13542),
    [anon_sym_DOLLAR] = ACTIONS(13542),
    [anon_sym_COLON_COLON] = ACTIONS(13542),
    [anon_sym_isa] = ACTIONS(13542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13542),
    [anon_sym_QMARK] = ACTIONS(13542),
    [anon_sym_AT] = ACTIONS(13542),
    [anon_sym_true] = ACTIONS(13542),
    [anon_sym_false] = ACTIONS(13542),
    [aux_sym_integer_literal_token1] = ACTIONS(13542),
    [aux_sym_integer_literal_token2] = ACTIONS(13542),
    [aux_sym_integer_literal_token3] = ACTIONS(13542),
    [aux_sym_integer_literal_token4] = ACTIONS(13542),
    [aux_sym_float_literal_token1] = ACTIONS(13542),
    [aux_sym_float_literal_token3] = ACTIONS(13542),
    [aux_sym_float_literal_token4] = ACTIONS(13542),
    [sym_character_literal] = ACTIONS(13542),
    [sym__pair_operator] = ACTIONS(13542),
    [sym__arrow_operator] = ACTIONS(13542),
    [sym__lazy_or_operator] = ACTIONS(13542),
    [sym__lazy_and_operator] = ACTIONS(13542),
    [sym__comparison_operator] = ACTIONS(13542),
    [sym__pipe_right_operator] = ACTIONS(13542),
    [sym__pipe_left_operator] = ACTIONS(13542),
    [sym__ellipsis_operator] = ACTIONS(13542),
    [sym__plus_operator] = ACTIONS(13542),
    [sym__times_operator] = ACTIONS(13542),
    [sym__rational_operator] = ACTIONS(13542),
    [sym__bitshift_operator] = ACTIONS(13542),
    [sym__power_operator] = ACTIONS(13542),
    [sym__tilde_operator] = ACTIONS(13542),
    [sym__type_order_operator] = ACTIONS(13542),
    [sym__unary_operator] = ACTIONS(13542),
    [sym__unary_plus_operator] = ACTIONS(13542),
    [aux_sym__terminator_token1] = ACTIONS(13542),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13544),
    [sym__command_start] = ACTIONS(13544),
  },
  [7487] = {
    [sym__word_identifier] = ACTIONS(13546),
    [anon_sym_EQ] = ACTIONS(13546),
    [anon_sym_COMMA] = ACTIONS(13546),
    [anon_sym_COLON] = ACTIONS(13546),
    [anon_sym_begin] = ACTIONS(13546),
    [anon_sym_module] = ACTIONS(13546),
    [anon_sym_baremodule] = ACTIONS(13546),
    [anon_sym_end] = ACTIONS(13546),
    [anon_sym_abstract] = ACTIONS(13546),
    [anon_sym_primitive] = ACTIONS(13546),
    [anon_sym_mutable] = ACTIONS(13546),
    [anon_sym_struct] = ACTIONS(13546),
    [anon_sym_function] = ACTIONS(13546),
    [anon_sym_macro] = ACTIONS(13546),
    [anon_sym_where] = ACTIONS(13546),
    [anon_sym_quote] = ACTIONS(13546),
    [anon_sym_let] = ACTIONS(13546),
    [anon_sym_if] = ACTIONS(13546),
    [anon_sym_else] = ACTIONS(13546),
    [anon_sym_try] = ACTIONS(13546),
    [anon_sym_finally] = ACTIONS(13546),
    [anon_sym_for] = ACTIONS(13546),
    [anon_sym_while] = ACTIONS(13546),
    [sym_break_statement] = ACTIONS(13546),
    [sym_continue_statement] = ACTIONS(13546),
    [anon_sym_return] = ACTIONS(13546),
    [anon_sym_const] = ACTIONS(13546),
    [anon_sym_global] = ACTIONS(13546),
    [anon_sym_local] = ACTIONS(13546),
    [anon_sym_LPAREN] = ACTIONS(13546),
    [anon_sym_COLON2] = ACTIONS(13546),
    [anon_sym_export] = ACTIONS(13546),
    [anon_sym_import] = ACTIONS(13546),
    [anon_sym_using] = ACTIONS(13546),
    [anon_sym_LBRACK] = ACTIONS(13546),
    [anon_sym_LF] = ACTIONS(13548),
    [anon_sym_in] = ACTIONS(13546),
    [anon_sym_LBRACE] = ACTIONS(13546),
    [anon_sym_DOLLAR] = ACTIONS(13546),
    [anon_sym_COLON_COLON] = ACTIONS(13546),
    [anon_sym_isa] = ACTIONS(13546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13546),
    [anon_sym_QMARK] = ACTIONS(13546),
    [anon_sym_AT] = ACTIONS(13546),
    [anon_sym_true] = ACTIONS(13546),
    [anon_sym_false] = ACTIONS(13546),
    [aux_sym_integer_literal_token1] = ACTIONS(13546),
    [aux_sym_integer_literal_token2] = ACTIONS(13546),
    [aux_sym_integer_literal_token3] = ACTIONS(13546),
    [aux_sym_integer_literal_token4] = ACTIONS(13546),
    [aux_sym_float_literal_token1] = ACTIONS(13546),
    [aux_sym_float_literal_token3] = ACTIONS(13546),
    [aux_sym_float_literal_token4] = ACTIONS(13546),
    [sym_character_literal] = ACTIONS(13546),
    [sym__pair_operator] = ACTIONS(13546),
    [sym__arrow_operator] = ACTIONS(13546),
    [sym__lazy_or_operator] = ACTIONS(13546),
    [sym__lazy_and_operator] = ACTIONS(13546),
    [sym__comparison_operator] = ACTIONS(13546),
    [sym__pipe_right_operator] = ACTIONS(13546),
    [sym__pipe_left_operator] = ACTIONS(13546),
    [sym__ellipsis_operator] = ACTIONS(13546),
    [sym__plus_operator] = ACTIONS(13546),
    [sym__times_operator] = ACTIONS(13546),
    [sym__rational_operator] = ACTIONS(13546),
    [sym__bitshift_operator] = ACTIONS(13546),
    [sym__power_operator] = ACTIONS(13546),
    [sym__tilde_operator] = ACTIONS(13546),
    [sym__type_order_operator] = ACTIONS(13546),
    [sym__unary_operator] = ACTIONS(13546),
    [sym__unary_plus_operator] = ACTIONS(13546),
    [aux_sym__terminator_token1] = ACTIONS(13546),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13548),
    [sym__command_start] = ACTIONS(13548),
  },
  [7488] = {
    [sym__word_identifier] = ACTIONS(13550),
    [anon_sym_EQ] = ACTIONS(13550),
    [anon_sym_COMMA] = ACTIONS(13550),
    [anon_sym_COLON] = ACTIONS(13550),
    [anon_sym_begin] = ACTIONS(13550),
    [anon_sym_module] = ACTIONS(13550),
    [anon_sym_baremodule] = ACTIONS(13550),
    [anon_sym_end] = ACTIONS(13550),
    [anon_sym_abstract] = ACTIONS(13550),
    [anon_sym_primitive] = ACTIONS(13550),
    [anon_sym_mutable] = ACTIONS(13550),
    [anon_sym_struct] = ACTIONS(13550),
    [anon_sym_function] = ACTIONS(13550),
    [anon_sym_macro] = ACTIONS(13550),
    [anon_sym_where] = ACTIONS(13550),
    [anon_sym_quote] = ACTIONS(13550),
    [anon_sym_let] = ACTIONS(13550),
    [anon_sym_if] = ACTIONS(13550),
    [anon_sym_else] = ACTIONS(13550),
    [anon_sym_try] = ACTIONS(13550),
    [anon_sym_finally] = ACTIONS(13550),
    [anon_sym_for] = ACTIONS(13550),
    [anon_sym_while] = ACTIONS(13550),
    [sym_break_statement] = ACTIONS(13550),
    [sym_continue_statement] = ACTIONS(13550),
    [anon_sym_return] = ACTIONS(13550),
    [anon_sym_const] = ACTIONS(13550),
    [anon_sym_global] = ACTIONS(13550),
    [anon_sym_local] = ACTIONS(13550),
    [anon_sym_LPAREN] = ACTIONS(13550),
    [anon_sym_COLON2] = ACTIONS(13550),
    [anon_sym_export] = ACTIONS(13550),
    [anon_sym_import] = ACTIONS(13550),
    [anon_sym_using] = ACTIONS(13550),
    [anon_sym_LBRACK] = ACTIONS(13550),
    [anon_sym_LF] = ACTIONS(13552),
    [anon_sym_in] = ACTIONS(13550),
    [anon_sym_LBRACE] = ACTIONS(13550),
    [anon_sym_DOLLAR] = ACTIONS(13550),
    [anon_sym_COLON_COLON] = ACTIONS(13550),
    [anon_sym_isa] = ACTIONS(13550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13550),
    [anon_sym_QMARK] = ACTIONS(13550),
    [anon_sym_AT] = ACTIONS(13550),
    [anon_sym_true] = ACTIONS(13550),
    [anon_sym_false] = ACTIONS(13550),
    [aux_sym_integer_literal_token1] = ACTIONS(13550),
    [aux_sym_integer_literal_token2] = ACTIONS(13550),
    [aux_sym_integer_literal_token3] = ACTIONS(13550),
    [aux_sym_integer_literal_token4] = ACTIONS(13550),
    [aux_sym_float_literal_token1] = ACTIONS(13550),
    [aux_sym_float_literal_token3] = ACTIONS(13550),
    [aux_sym_float_literal_token4] = ACTIONS(13550),
    [sym_character_literal] = ACTIONS(13550),
    [sym__pair_operator] = ACTIONS(13550),
    [sym__arrow_operator] = ACTIONS(13550),
    [sym__lazy_or_operator] = ACTIONS(13550),
    [sym__lazy_and_operator] = ACTIONS(13550),
    [sym__comparison_operator] = ACTIONS(13550),
    [sym__pipe_right_operator] = ACTIONS(13550),
    [sym__pipe_left_operator] = ACTIONS(13550),
    [sym__ellipsis_operator] = ACTIONS(13550),
    [sym__plus_operator] = ACTIONS(13550),
    [sym__times_operator] = ACTIONS(13550),
    [sym__rational_operator] = ACTIONS(13550),
    [sym__bitshift_operator] = ACTIONS(13550),
    [sym__power_operator] = ACTIONS(13550),
    [sym__tilde_operator] = ACTIONS(13550),
    [sym__type_order_operator] = ACTIONS(13550),
    [sym__unary_operator] = ACTIONS(13550),
    [sym__unary_plus_operator] = ACTIONS(13550),
    [aux_sym__terminator_token1] = ACTIONS(13550),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13552),
    [sym__command_start] = ACTIONS(13552),
  },
  [7489] = {
    [sym__word_identifier] = ACTIONS(13554),
    [anon_sym_EQ] = ACTIONS(13554),
    [anon_sym_COMMA] = ACTIONS(13554),
    [anon_sym_COLON] = ACTIONS(13554),
    [anon_sym_begin] = ACTIONS(13554),
    [anon_sym_module] = ACTIONS(13554),
    [anon_sym_baremodule] = ACTIONS(13554),
    [anon_sym_end] = ACTIONS(13554),
    [anon_sym_abstract] = ACTIONS(13554),
    [anon_sym_primitive] = ACTIONS(13554),
    [anon_sym_mutable] = ACTIONS(13554),
    [anon_sym_struct] = ACTIONS(13554),
    [anon_sym_function] = ACTIONS(13554),
    [anon_sym_macro] = ACTIONS(13554),
    [anon_sym_where] = ACTIONS(13554),
    [anon_sym_quote] = ACTIONS(13554),
    [anon_sym_let] = ACTIONS(13554),
    [anon_sym_if] = ACTIONS(13554),
    [anon_sym_else] = ACTIONS(13554),
    [anon_sym_try] = ACTIONS(13554),
    [anon_sym_finally] = ACTIONS(13554),
    [anon_sym_for] = ACTIONS(13554),
    [anon_sym_while] = ACTIONS(13554),
    [sym_break_statement] = ACTIONS(13554),
    [sym_continue_statement] = ACTIONS(13554),
    [anon_sym_return] = ACTIONS(13554),
    [anon_sym_const] = ACTIONS(13554),
    [anon_sym_global] = ACTIONS(13554),
    [anon_sym_local] = ACTIONS(13554),
    [anon_sym_LPAREN] = ACTIONS(13554),
    [anon_sym_COLON2] = ACTIONS(13554),
    [anon_sym_export] = ACTIONS(13554),
    [anon_sym_import] = ACTIONS(13554),
    [anon_sym_using] = ACTIONS(13554),
    [anon_sym_LBRACK] = ACTIONS(13554),
    [anon_sym_LF] = ACTIONS(13556),
    [anon_sym_in] = ACTIONS(13554),
    [anon_sym_LBRACE] = ACTIONS(13554),
    [anon_sym_DOLLAR] = ACTIONS(13554),
    [anon_sym_COLON_COLON] = ACTIONS(13554),
    [anon_sym_isa] = ACTIONS(13554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13554),
    [anon_sym_QMARK] = ACTIONS(13554),
    [anon_sym_AT] = ACTIONS(13554),
    [anon_sym_true] = ACTIONS(13554),
    [anon_sym_false] = ACTIONS(13554),
    [aux_sym_integer_literal_token1] = ACTIONS(13554),
    [aux_sym_integer_literal_token2] = ACTIONS(13554),
    [aux_sym_integer_literal_token3] = ACTIONS(13554),
    [aux_sym_integer_literal_token4] = ACTIONS(13554),
    [aux_sym_float_literal_token1] = ACTIONS(13554),
    [aux_sym_float_literal_token3] = ACTIONS(13554),
    [aux_sym_float_literal_token4] = ACTIONS(13554),
    [sym_character_literal] = ACTIONS(13554),
    [sym__pair_operator] = ACTIONS(13554),
    [sym__arrow_operator] = ACTIONS(13554),
    [sym__lazy_or_operator] = ACTIONS(13554),
    [sym__lazy_and_operator] = ACTIONS(13554),
    [sym__comparison_operator] = ACTIONS(13554),
    [sym__pipe_right_operator] = ACTIONS(13554),
    [sym__pipe_left_operator] = ACTIONS(13554),
    [sym__ellipsis_operator] = ACTIONS(13554),
    [sym__plus_operator] = ACTIONS(13554),
    [sym__times_operator] = ACTIONS(13554),
    [sym__rational_operator] = ACTIONS(13554),
    [sym__bitshift_operator] = ACTIONS(13554),
    [sym__power_operator] = ACTIONS(13554),
    [sym__tilde_operator] = ACTIONS(13554),
    [sym__type_order_operator] = ACTIONS(13554),
    [sym__unary_operator] = ACTIONS(13554),
    [sym__unary_plus_operator] = ACTIONS(13554),
    [aux_sym__terminator_token1] = ACTIONS(13554),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13556),
    [sym__command_start] = ACTIONS(13556),
  },
  [7490] = {
    [sym__word_identifier] = ACTIONS(13558),
    [anon_sym_EQ] = ACTIONS(13558),
    [anon_sym_COMMA] = ACTIONS(13558),
    [anon_sym_COLON] = ACTIONS(13558),
    [anon_sym_begin] = ACTIONS(13558),
    [anon_sym_module] = ACTIONS(13558),
    [anon_sym_baremodule] = ACTIONS(13558),
    [anon_sym_end] = ACTIONS(13558),
    [anon_sym_abstract] = ACTIONS(13558),
    [anon_sym_primitive] = ACTIONS(13558),
    [anon_sym_mutable] = ACTIONS(13558),
    [anon_sym_struct] = ACTIONS(13558),
    [anon_sym_function] = ACTIONS(13558),
    [anon_sym_macro] = ACTIONS(13558),
    [anon_sym_where] = ACTIONS(13558),
    [anon_sym_quote] = ACTIONS(13558),
    [anon_sym_let] = ACTIONS(13558),
    [anon_sym_if] = ACTIONS(13558),
    [anon_sym_else] = ACTIONS(13558),
    [anon_sym_try] = ACTIONS(13558),
    [anon_sym_finally] = ACTIONS(13558),
    [anon_sym_for] = ACTIONS(13558),
    [anon_sym_while] = ACTIONS(13558),
    [sym_break_statement] = ACTIONS(13558),
    [sym_continue_statement] = ACTIONS(13558),
    [anon_sym_return] = ACTIONS(13558),
    [anon_sym_const] = ACTIONS(13558),
    [anon_sym_global] = ACTIONS(13558),
    [anon_sym_local] = ACTIONS(13558),
    [anon_sym_LPAREN] = ACTIONS(13558),
    [anon_sym_COLON2] = ACTIONS(13558),
    [anon_sym_export] = ACTIONS(13558),
    [anon_sym_import] = ACTIONS(13558),
    [anon_sym_using] = ACTIONS(13558),
    [anon_sym_LBRACK] = ACTIONS(13558),
    [anon_sym_LF] = ACTIONS(13560),
    [anon_sym_in] = ACTIONS(13558),
    [anon_sym_LBRACE] = ACTIONS(13558),
    [anon_sym_DOLLAR] = ACTIONS(13558),
    [anon_sym_COLON_COLON] = ACTIONS(13558),
    [anon_sym_isa] = ACTIONS(13558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13558),
    [anon_sym_QMARK] = ACTIONS(13558),
    [anon_sym_AT] = ACTIONS(13558),
    [anon_sym_true] = ACTIONS(13558),
    [anon_sym_false] = ACTIONS(13558),
    [aux_sym_integer_literal_token1] = ACTIONS(13558),
    [aux_sym_integer_literal_token2] = ACTIONS(13558),
    [aux_sym_integer_literal_token3] = ACTIONS(13558),
    [aux_sym_integer_literal_token4] = ACTIONS(13558),
    [aux_sym_float_literal_token1] = ACTIONS(13558),
    [aux_sym_float_literal_token3] = ACTIONS(13558),
    [aux_sym_float_literal_token4] = ACTIONS(13558),
    [sym_character_literal] = ACTIONS(13558),
    [sym__pair_operator] = ACTIONS(13558),
    [sym__arrow_operator] = ACTIONS(13558),
    [sym__lazy_or_operator] = ACTIONS(13558),
    [sym__lazy_and_operator] = ACTIONS(13558),
    [sym__comparison_operator] = ACTIONS(13558),
    [sym__pipe_right_operator] = ACTIONS(13558),
    [sym__pipe_left_operator] = ACTIONS(13558),
    [sym__ellipsis_operator] = ACTIONS(13558),
    [sym__plus_operator] = ACTIONS(13558),
    [sym__times_operator] = ACTIONS(13558),
    [sym__rational_operator] = ACTIONS(13558),
    [sym__bitshift_operator] = ACTIONS(13558),
    [sym__power_operator] = ACTIONS(13558),
    [sym__tilde_operator] = ACTIONS(13558),
    [sym__type_order_operator] = ACTIONS(13558),
    [sym__unary_operator] = ACTIONS(13558),
    [sym__unary_plus_operator] = ACTIONS(13558),
    [aux_sym__terminator_token1] = ACTIONS(13558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13560),
    [sym__command_start] = ACTIONS(13560),
  },
  [7491] = {
    [sym__word_identifier] = ACTIONS(13562),
    [anon_sym_EQ] = ACTIONS(13562),
    [anon_sym_COMMA] = ACTIONS(13562),
    [anon_sym_COLON] = ACTIONS(13562),
    [anon_sym_begin] = ACTIONS(13562),
    [anon_sym_module] = ACTIONS(13562),
    [anon_sym_baremodule] = ACTIONS(13562),
    [anon_sym_end] = ACTIONS(13562),
    [anon_sym_abstract] = ACTIONS(13562),
    [anon_sym_primitive] = ACTIONS(13562),
    [anon_sym_mutable] = ACTIONS(13562),
    [anon_sym_struct] = ACTIONS(13562),
    [anon_sym_function] = ACTIONS(13562),
    [anon_sym_macro] = ACTIONS(13562),
    [anon_sym_where] = ACTIONS(13562),
    [anon_sym_quote] = ACTIONS(13562),
    [anon_sym_let] = ACTIONS(13562),
    [anon_sym_if] = ACTIONS(13562),
    [anon_sym_else] = ACTIONS(13562),
    [anon_sym_try] = ACTIONS(13562),
    [anon_sym_finally] = ACTIONS(13562),
    [anon_sym_for] = ACTIONS(13562),
    [anon_sym_while] = ACTIONS(13562),
    [sym_break_statement] = ACTIONS(13562),
    [sym_continue_statement] = ACTIONS(13562),
    [anon_sym_return] = ACTIONS(13562),
    [anon_sym_const] = ACTIONS(13562),
    [anon_sym_global] = ACTIONS(13562),
    [anon_sym_local] = ACTIONS(13562),
    [anon_sym_LPAREN] = ACTIONS(13562),
    [anon_sym_COLON2] = ACTIONS(13562),
    [anon_sym_export] = ACTIONS(13562),
    [anon_sym_import] = ACTIONS(13562),
    [anon_sym_using] = ACTIONS(13562),
    [anon_sym_LBRACK] = ACTIONS(13562),
    [anon_sym_LF] = ACTIONS(13564),
    [anon_sym_in] = ACTIONS(13562),
    [anon_sym_LBRACE] = ACTIONS(13562),
    [anon_sym_DOLLAR] = ACTIONS(13562),
    [anon_sym_COLON_COLON] = ACTIONS(13562),
    [anon_sym_isa] = ACTIONS(13562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13562),
    [anon_sym_QMARK] = ACTIONS(13562),
    [anon_sym_AT] = ACTIONS(13562),
    [anon_sym_true] = ACTIONS(13562),
    [anon_sym_false] = ACTIONS(13562),
    [aux_sym_integer_literal_token1] = ACTIONS(13562),
    [aux_sym_integer_literal_token2] = ACTIONS(13562),
    [aux_sym_integer_literal_token3] = ACTIONS(13562),
    [aux_sym_integer_literal_token4] = ACTIONS(13562),
    [aux_sym_float_literal_token1] = ACTIONS(13562),
    [aux_sym_float_literal_token3] = ACTIONS(13562),
    [aux_sym_float_literal_token4] = ACTIONS(13562),
    [sym_character_literal] = ACTIONS(13562),
    [sym__pair_operator] = ACTIONS(13562),
    [sym__arrow_operator] = ACTIONS(13562),
    [sym__lazy_or_operator] = ACTIONS(13562),
    [sym__lazy_and_operator] = ACTIONS(13562),
    [sym__comparison_operator] = ACTIONS(13562),
    [sym__pipe_right_operator] = ACTIONS(13562),
    [sym__pipe_left_operator] = ACTIONS(13562),
    [sym__ellipsis_operator] = ACTIONS(13562),
    [sym__plus_operator] = ACTIONS(13562),
    [sym__times_operator] = ACTIONS(13562),
    [sym__rational_operator] = ACTIONS(13562),
    [sym__bitshift_operator] = ACTIONS(13562),
    [sym__power_operator] = ACTIONS(13562),
    [sym__tilde_operator] = ACTIONS(13562),
    [sym__type_order_operator] = ACTIONS(13562),
    [sym__unary_operator] = ACTIONS(13562),
    [sym__unary_plus_operator] = ACTIONS(13562),
    [aux_sym__terminator_token1] = ACTIONS(13562),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13564),
    [sym__command_start] = ACTIONS(13564),
  },
  [7492] = {
    [sym__word_identifier] = ACTIONS(13493),
    [anon_sym_EQ] = ACTIONS(13493),
    [anon_sym_COMMA] = ACTIONS(13493),
    [anon_sym_COLON] = ACTIONS(13493),
    [anon_sym_begin] = ACTIONS(13493),
    [anon_sym_module] = ACTIONS(13493),
    [anon_sym_baremodule] = ACTIONS(13493),
    [anon_sym_end] = ACTIONS(13493),
    [anon_sym_abstract] = ACTIONS(13493),
    [anon_sym_primitive] = ACTIONS(13493),
    [anon_sym_mutable] = ACTIONS(13493),
    [anon_sym_struct] = ACTIONS(13493),
    [anon_sym_function] = ACTIONS(13493),
    [anon_sym_macro] = ACTIONS(13493),
    [anon_sym_where] = ACTIONS(13493),
    [anon_sym_quote] = ACTIONS(13493),
    [anon_sym_let] = ACTIONS(13493),
    [anon_sym_if] = ACTIONS(13493),
    [anon_sym_elseif] = ACTIONS(13493),
    [anon_sym_else] = ACTIONS(13493),
    [anon_sym_try] = ACTIONS(13493),
    [anon_sym_for] = ACTIONS(13493),
    [anon_sym_while] = ACTIONS(13493),
    [sym_break_statement] = ACTIONS(13493),
    [sym_continue_statement] = ACTIONS(13493),
    [anon_sym_return] = ACTIONS(13493),
    [anon_sym_const] = ACTIONS(13493),
    [anon_sym_global] = ACTIONS(13493),
    [anon_sym_local] = ACTIONS(13493),
    [anon_sym_LPAREN] = ACTIONS(13493),
    [anon_sym_COLON2] = ACTIONS(13493),
    [anon_sym_export] = ACTIONS(13493),
    [anon_sym_import] = ACTIONS(13493),
    [anon_sym_using] = ACTIONS(13493),
    [anon_sym_LBRACK] = ACTIONS(13493),
    [anon_sym_LF] = ACTIONS(13495),
    [anon_sym_in] = ACTIONS(13493),
    [anon_sym_LBRACE] = ACTIONS(13493),
    [anon_sym_DOLLAR] = ACTIONS(13493),
    [anon_sym_COLON_COLON] = ACTIONS(13493),
    [anon_sym_isa] = ACTIONS(13493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13493),
    [anon_sym_QMARK] = ACTIONS(13493),
    [anon_sym_AT] = ACTIONS(13493),
    [anon_sym_true] = ACTIONS(13493),
    [anon_sym_false] = ACTIONS(13493),
    [aux_sym_integer_literal_token1] = ACTIONS(13493),
    [aux_sym_integer_literal_token2] = ACTIONS(13493),
    [aux_sym_integer_literal_token3] = ACTIONS(13493),
    [aux_sym_integer_literal_token4] = ACTIONS(13493),
    [aux_sym_float_literal_token1] = ACTIONS(13493),
    [aux_sym_float_literal_token3] = ACTIONS(13493),
    [aux_sym_float_literal_token4] = ACTIONS(13493),
    [sym_character_literal] = ACTIONS(13493),
    [sym__pair_operator] = ACTIONS(13493),
    [sym__arrow_operator] = ACTIONS(13493),
    [sym__lazy_or_operator] = ACTIONS(13493),
    [sym__lazy_and_operator] = ACTIONS(13493),
    [sym__comparison_operator] = ACTIONS(13493),
    [sym__pipe_right_operator] = ACTIONS(13493),
    [sym__pipe_left_operator] = ACTIONS(13493),
    [sym__ellipsis_operator] = ACTIONS(13493),
    [sym__plus_operator] = ACTIONS(13493),
    [sym__times_operator] = ACTIONS(13493),
    [sym__rational_operator] = ACTIONS(13493),
    [sym__bitshift_operator] = ACTIONS(13493),
    [sym__power_operator] = ACTIONS(13493),
    [sym__tilde_operator] = ACTIONS(13493),
    [sym__type_order_operator] = ACTIONS(13493),
    [sym__unary_operator] = ACTIONS(13493),
    [sym__unary_plus_operator] = ACTIONS(13493),
    [aux_sym__terminator_token1] = ACTIONS(13493),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13495),
    [sym__command_start] = ACTIONS(13495),
  },
  [7493] = {
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13094),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_else] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_finally] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13094),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13094),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13094),
    [anon_sym_isa] = ACTIONS(13094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13094),
    [anon_sym_QMARK] = ACTIONS(13094),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13094),
    [sym__lazy_or_operator] = ACTIONS(13094),
    [sym__lazy_and_operator] = ACTIONS(13094),
    [sym__comparison_operator] = ACTIONS(13094),
    [sym__pipe_right_operator] = ACTIONS(13094),
    [sym__pipe_left_operator] = ACTIONS(13094),
    [sym__ellipsis_operator] = ACTIONS(13094),
    [sym__plus_operator] = ACTIONS(13094),
    [sym__times_operator] = ACTIONS(13094),
    [sym__rational_operator] = ACTIONS(13094),
    [sym__bitshift_operator] = ACTIONS(13094),
    [sym__power_operator] = ACTIONS(13094),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13094),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13094),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [7494] = {
    [sym__word_identifier] = ACTIONS(13566),
    [anon_sym_EQ] = ACTIONS(13566),
    [anon_sym_COMMA] = ACTIONS(13566),
    [anon_sym_COLON] = ACTIONS(13566),
    [anon_sym_begin] = ACTIONS(13566),
    [anon_sym_module] = ACTIONS(13566),
    [anon_sym_baremodule] = ACTIONS(13566),
    [anon_sym_end] = ACTIONS(13566),
    [anon_sym_abstract] = ACTIONS(13566),
    [anon_sym_primitive] = ACTIONS(13566),
    [anon_sym_mutable] = ACTIONS(13566),
    [anon_sym_struct] = ACTIONS(13566),
    [anon_sym_function] = ACTIONS(13566),
    [anon_sym_macro] = ACTIONS(13566),
    [anon_sym_where] = ACTIONS(13566),
    [anon_sym_quote] = ACTIONS(13566),
    [anon_sym_let] = ACTIONS(13566),
    [anon_sym_if] = ACTIONS(13566),
    [anon_sym_else] = ACTIONS(13566),
    [anon_sym_try] = ACTIONS(13566),
    [anon_sym_finally] = ACTIONS(13566),
    [anon_sym_for] = ACTIONS(13566),
    [anon_sym_while] = ACTIONS(13566),
    [sym_break_statement] = ACTIONS(13566),
    [sym_continue_statement] = ACTIONS(13566),
    [anon_sym_return] = ACTIONS(13566),
    [anon_sym_const] = ACTIONS(13566),
    [anon_sym_global] = ACTIONS(13566),
    [anon_sym_local] = ACTIONS(13566),
    [anon_sym_LPAREN] = ACTIONS(13566),
    [anon_sym_COLON2] = ACTIONS(13566),
    [anon_sym_export] = ACTIONS(13566),
    [anon_sym_import] = ACTIONS(13566),
    [anon_sym_using] = ACTIONS(13566),
    [anon_sym_LBRACK] = ACTIONS(13566),
    [anon_sym_LF] = ACTIONS(13568),
    [anon_sym_in] = ACTIONS(13566),
    [anon_sym_LBRACE] = ACTIONS(13566),
    [anon_sym_DOLLAR] = ACTIONS(13566),
    [anon_sym_COLON_COLON] = ACTIONS(13566),
    [anon_sym_isa] = ACTIONS(13566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13566),
    [anon_sym_QMARK] = ACTIONS(13566),
    [anon_sym_AT] = ACTIONS(13566),
    [anon_sym_true] = ACTIONS(13566),
    [anon_sym_false] = ACTIONS(13566),
    [aux_sym_integer_literal_token1] = ACTIONS(13566),
    [aux_sym_integer_literal_token2] = ACTIONS(13566),
    [aux_sym_integer_literal_token3] = ACTIONS(13566),
    [aux_sym_integer_literal_token4] = ACTIONS(13566),
    [aux_sym_float_literal_token1] = ACTIONS(13566),
    [aux_sym_float_literal_token3] = ACTIONS(13566),
    [aux_sym_float_literal_token4] = ACTIONS(13566),
    [sym_character_literal] = ACTIONS(13566),
    [sym__pair_operator] = ACTIONS(13566),
    [sym__arrow_operator] = ACTIONS(13566),
    [sym__lazy_or_operator] = ACTIONS(13566),
    [sym__lazy_and_operator] = ACTIONS(13566),
    [sym__comparison_operator] = ACTIONS(13566),
    [sym__pipe_right_operator] = ACTIONS(13566),
    [sym__pipe_left_operator] = ACTIONS(13566),
    [sym__ellipsis_operator] = ACTIONS(13566),
    [sym__plus_operator] = ACTIONS(13566),
    [sym__times_operator] = ACTIONS(13566),
    [sym__rational_operator] = ACTIONS(13566),
    [sym__bitshift_operator] = ACTIONS(13566),
    [sym__power_operator] = ACTIONS(13566),
    [sym__tilde_operator] = ACTIONS(13566),
    [sym__type_order_operator] = ACTIONS(13566),
    [sym__unary_operator] = ACTIONS(13566),
    [sym__unary_plus_operator] = ACTIONS(13566),
    [aux_sym__terminator_token1] = ACTIONS(13566),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13568),
    [sym__command_start] = ACTIONS(13568),
  },
  [7495] = {
    [sym__word_identifier] = ACTIONS(13570),
    [anon_sym_EQ] = ACTIONS(13570),
    [anon_sym_COMMA] = ACTIONS(13570),
    [anon_sym_COLON] = ACTIONS(13570),
    [anon_sym_begin] = ACTIONS(13570),
    [anon_sym_module] = ACTIONS(13570),
    [anon_sym_baremodule] = ACTIONS(13570),
    [anon_sym_end] = ACTIONS(13570),
    [anon_sym_abstract] = ACTIONS(13570),
    [anon_sym_primitive] = ACTIONS(13570),
    [anon_sym_mutable] = ACTIONS(13570),
    [anon_sym_struct] = ACTIONS(13570),
    [anon_sym_function] = ACTIONS(13570),
    [anon_sym_macro] = ACTIONS(13570),
    [anon_sym_where] = ACTIONS(13570),
    [anon_sym_quote] = ACTIONS(13570),
    [anon_sym_let] = ACTIONS(13570),
    [anon_sym_if] = ACTIONS(13570),
    [anon_sym_else] = ACTIONS(13570),
    [anon_sym_try] = ACTIONS(13570),
    [anon_sym_finally] = ACTIONS(13570),
    [anon_sym_for] = ACTIONS(13570),
    [anon_sym_while] = ACTIONS(13570),
    [sym_break_statement] = ACTIONS(13570),
    [sym_continue_statement] = ACTIONS(13570),
    [anon_sym_return] = ACTIONS(13570),
    [anon_sym_const] = ACTIONS(13570),
    [anon_sym_global] = ACTIONS(13570),
    [anon_sym_local] = ACTIONS(13570),
    [anon_sym_LPAREN] = ACTIONS(13570),
    [anon_sym_COLON2] = ACTIONS(13570),
    [anon_sym_export] = ACTIONS(13570),
    [anon_sym_import] = ACTIONS(13570),
    [anon_sym_using] = ACTIONS(13570),
    [anon_sym_LBRACK] = ACTIONS(13570),
    [anon_sym_LF] = ACTIONS(13572),
    [anon_sym_in] = ACTIONS(13570),
    [anon_sym_LBRACE] = ACTIONS(13570),
    [anon_sym_DOLLAR] = ACTIONS(13570),
    [anon_sym_COLON_COLON] = ACTIONS(13570),
    [anon_sym_isa] = ACTIONS(13570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13570),
    [anon_sym_QMARK] = ACTIONS(13570),
    [anon_sym_AT] = ACTIONS(13570),
    [anon_sym_true] = ACTIONS(13570),
    [anon_sym_false] = ACTIONS(13570),
    [aux_sym_integer_literal_token1] = ACTIONS(13570),
    [aux_sym_integer_literal_token2] = ACTIONS(13570),
    [aux_sym_integer_literal_token3] = ACTIONS(13570),
    [aux_sym_integer_literal_token4] = ACTIONS(13570),
    [aux_sym_float_literal_token1] = ACTIONS(13570),
    [aux_sym_float_literal_token3] = ACTIONS(13570),
    [aux_sym_float_literal_token4] = ACTIONS(13570),
    [sym_character_literal] = ACTIONS(13570),
    [sym__pair_operator] = ACTIONS(13570),
    [sym__arrow_operator] = ACTIONS(13570),
    [sym__lazy_or_operator] = ACTIONS(13570),
    [sym__lazy_and_operator] = ACTIONS(13570),
    [sym__comparison_operator] = ACTIONS(13570),
    [sym__pipe_right_operator] = ACTIONS(13570),
    [sym__pipe_left_operator] = ACTIONS(13570),
    [sym__ellipsis_operator] = ACTIONS(13570),
    [sym__plus_operator] = ACTIONS(13570),
    [sym__times_operator] = ACTIONS(13570),
    [sym__rational_operator] = ACTIONS(13570),
    [sym__bitshift_operator] = ACTIONS(13570),
    [sym__power_operator] = ACTIONS(13570),
    [sym__tilde_operator] = ACTIONS(13570),
    [sym__type_order_operator] = ACTIONS(13570),
    [sym__unary_operator] = ACTIONS(13570),
    [sym__unary_plus_operator] = ACTIONS(13570),
    [aux_sym__terminator_token1] = ACTIONS(13570),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13572),
    [sym__command_start] = ACTIONS(13572),
  },
  [7496] = {
    [sym__word_identifier] = ACTIONS(13574),
    [anon_sym_EQ] = ACTIONS(13574),
    [anon_sym_COMMA] = ACTIONS(13574),
    [anon_sym_COLON] = ACTIONS(13574),
    [anon_sym_begin] = ACTIONS(13574),
    [anon_sym_module] = ACTIONS(13574),
    [anon_sym_baremodule] = ACTIONS(13574),
    [anon_sym_end] = ACTIONS(13574),
    [anon_sym_abstract] = ACTIONS(13574),
    [anon_sym_primitive] = ACTIONS(13574),
    [anon_sym_mutable] = ACTIONS(13574),
    [anon_sym_struct] = ACTIONS(13574),
    [anon_sym_function] = ACTIONS(13574),
    [anon_sym_macro] = ACTIONS(13574),
    [anon_sym_where] = ACTIONS(13574),
    [anon_sym_quote] = ACTIONS(13574),
    [anon_sym_let] = ACTIONS(13574),
    [anon_sym_if] = ACTIONS(13574),
    [anon_sym_else] = ACTIONS(13574),
    [anon_sym_try] = ACTIONS(13574),
    [anon_sym_finally] = ACTIONS(13574),
    [anon_sym_for] = ACTIONS(13574),
    [anon_sym_while] = ACTIONS(13574),
    [sym_break_statement] = ACTIONS(13574),
    [sym_continue_statement] = ACTIONS(13574),
    [anon_sym_return] = ACTIONS(13574),
    [anon_sym_const] = ACTIONS(13574),
    [anon_sym_global] = ACTIONS(13574),
    [anon_sym_local] = ACTIONS(13574),
    [anon_sym_LPAREN] = ACTIONS(13574),
    [anon_sym_COLON2] = ACTIONS(13574),
    [anon_sym_export] = ACTIONS(13574),
    [anon_sym_import] = ACTIONS(13574),
    [anon_sym_using] = ACTIONS(13574),
    [anon_sym_LBRACK] = ACTIONS(13574),
    [anon_sym_LF] = ACTIONS(13576),
    [anon_sym_in] = ACTIONS(13574),
    [anon_sym_LBRACE] = ACTIONS(13574),
    [anon_sym_DOLLAR] = ACTIONS(13574),
    [anon_sym_COLON_COLON] = ACTIONS(13574),
    [anon_sym_isa] = ACTIONS(13574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13574),
    [anon_sym_QMARK] = ACTIONS(13574),
    [anon_sym_AT] = ACTIONS(13574),
    [anon_sym_true] = ACTIONS(13574),
    [anon_sym_false] = ACTIONS(13574),
    [aux_sym_integer_literal_token1] = ACTIONS(13574),
    [aux_sym_integer_literal_token2] = ACTIONS(13574),
    [aux_sym_integer_literal_token3] = ACTIONS(13574),
    [aux_sym_integer_literal_token4] = ACTIONS(13574),
    [aux_sym_float_literal_token1] = ACTIONS(13574),
    [aux_sym_float_literal_token3] = ACTIONS(13574),
    [aux_sym_float_literal_token4] = ACTIONS(13574),
    [sym_character_literal] = ACTIONS(13574),
    [sym__pair_operator] = ACTIONS(13574),
    [sym__arrow_operator] = ACTIONS(13574),
    [sym__lazy_or_operator] = ACTIONS(13574),
    [sym__lazy_and_operator] = ACTIONS(13574),
    [sym__comparison_operator] = ACTIONS(13574),
    [sym__pipe_right_operator] = ACTIONS(13574),
    [sym__pipe_left_operator] = ACTIONS(13574),
    [sym__ellipsis_operator] = ACTIONS(13574),
    [sym__plus_operator] = ACTIONS(13574),
    [sym__times_operator] = ACTIONS(13574),
    [sym__rational_operator] = ACTIONS(13574),
    [sym__bitshift_operator] = ACTIONS(13574),
    [sym__power_operator] = ACTIONS(13574),
    [sym__tilde_operator] = ACTIONS(13574),
    [sym__type_order_operator] = ACTIONS(13574),
    [sym__unary_operator] = ACTIONS(13574),
    [sym__unary_plus_operator] = ACTIONS(13574),
    [aux_sym__terminator_token1] = ACTIONS(13574),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13576),
    [sym__command_start] = ACTIONS(13576),
  },
  [7497] = {
    [sym__word_identifier] = ACTIONS(13578),
    [anon_sym_EQ] = ACTIONS(13578),
    [anon_sym_COMMA] = ACTIONS(13578),
    [anon_sym_COLON] = ACTIONS(13578),
    [anon_sym_begin] = ACTIONS(13578),
    [anon_sym_module] = ACTIONS(13578),
    [anon_sym_baremodule] = ACTIONS(13578),
    [anon_sym_end] = ACTIONS(13578),
    [anon_sym_abstract] = ACTIONS(13578),
    [anon_sym_primitive] = ACTIONS(13578),
    [anon_sym_mutable] = ACTIONS(13578),
    [anon_sym_struct] = ACTIONS(13578),
    [anon_sym_function] = ACTIONS(13578),
    [anon_sym_macro] = ACTIONS(13578),
    [anon_sym_where] = ACTIONS(13578),
    [anon_sym_quote] = ACTIONS(13578),
    [anon_sym_let] = ACTIONS(13578),
    [anon_sym_if] = ACTIONS(13578),
    [anon_sym_else] = ACTIONS(13578),
    [anon_sym_try] = ACTIONS(13578),
    [anon_sym_finally] = ACTIONS(13578),
    [anon_sym_for] = ACTIONS(13578),
    [anon_sym_while] = ACTIONS(13578),
    [sym_break_statement] = ACTIONS(13578),
    [sym_continue_statement] = ACTIONS(13578),
    [anon_sym_return] = ACTIONS(13578),
    [anon_sym_const] = ACTIONS(13578),
    [anon_sym_global] = ACTIONS(13578),
    [anon_sym_local] = ACTIONS(13578),
    [anon_sym_LPAREN] = ACTIONS(13578),
    [anon_sym_COLON2] = ACTIONS(13578),
    [anon_sym_export] = ACTIONS(13578),
    [anon_sym_import] = ACTIONS(13578),
    [anon_sym_using] = ACTIONS(13578),
    [anon_sym_LBRACK] = ACTIONS(13578),
    [anon_sym_LF] = ACTIONS(13580),
    [anon_sym_in] = ACTIONS(13578),
    [anon_sym_LBRACE] = ACTIONS(13578),
    [anon_sym_DOLLAR] = ACTIONS(13578),
    [anon_sym_COLON_COLON] = ACTIONS(13578),
    [anon_sym_isa] = ACTIONS(13578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13578),
    [anon_sym_QMARK] = ACTIONS(13578),
    [anon_sym_AT] = ACTIONS(13578),
    [anon_sym_true] = ACTIONS(13578),
    [anon_sym_false] = ACTIONS(13578),
    [aux_sym_integer_literal_token1] = ACTIONS(13578),
    [aux_sym_integer_literal_token2] = ACTIONS(13578),
    [aux_sym_integer_literal_token3] = ACTIONS(13578),
    [aux_sym_integer_literal_token4] = ACTIONS(13578),
    [aux_sym_float_literal_token1] = ACTIONS(13578),
    [aux_sym_float_literal_token3] = ACTIONS(13578),
    [aux_sym_float_literal_token4] = ACTIONS(13578),
    [sym_character_literal] = ACTIONS(13578),
    [sym__pair_operator] = ACTIONS(13578),
    [sym__arrow_operator] = ACTIONS(13578),
    [sym__lazy_or_operator] = ACTIONS(13578),
    [sym__lazy_and_operator] = ACTIONS(13578),
    [sym__comparison_operator] = ACTIONS(13578),
    [sym__pipe_right_operator] = ACTIONS(13578),
    [sym__pipe_left_operator] = ACTIONS(13578),
    [sym__ellipsis_operator] = ACTIONS(13578),
    [sym__plus_operator] = ACTIONS(13578),
    [sym__times_operator] = ACTIONS(13578),
    [sym__rational_operator] = ACTIONS(13578),
    [sym__bitshift_operator] = ACTIONS(13578),
    [sym__power_operator] = ACTIONS(13578),
    [sym__tilde_operator] = ACTIONS(13578),
    [sym__type_order_operator] = ACTIONS(13578),
    [sym__unary_operator] = ACTIONS(13578),
    [sym__unary_plus_operator] = ACTIONS(13578),
    [aux_sym__terminator_token1] = ACTIONS(13578),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13580),
    [sym__command_start] = ACTIONS(13580),
  },
  [7498] = {
    [sym__word_identifier] = ACTIONS(13582),
    [anon_sym_EQ] = ACTIONS(13582),
    [anon_sym_COMMA] = ACTIONS(13582),
    [anon_sym_COLON] = ACTIONS(13582),
    [anon_sym_begin] = ACTIONS(13582),
    [anon_sym_module] = ACTIONS(13582),
    [anon_sym_baremodule] = ACTIONS(13582),
    [anon_sym_end] = ACTIONS(13582),
    [anon_sym_abstract] = ACTIONS(13582),
    [anon_sym_primitive] = ACTIONS(13582),
    [anon_sym_mutable] = ACTIONS(13582),
    [anon_sym_struct] = ACTIONS(13582),
    [anon_sym_function] = ACTIONS(13582),
    [anon_sym_macro] = ACTIONS(13582),
    [anon_sym_where] = ACTIONS(13582),
    [anon_sym_quote] = ACTIONS(13582),
    [anon_sym_let] = ACTIONS(13582),
    [anon_sym_if] = ACTIONS(13582),
    [anon_sym_else] = ACTIONS(13582),
    [anon_sym_try] = ACTIONS(13582),
    [anon_sym_finally] = ACTIONS(13582),
    [anon_sym_for] = ACTIONS(13582),
    [anon_sym_while] = ACTIONS(13582),
    [sym_break_statement] = ACTIONS(13582),
    [sym_continue_statement] = ACTIONS(13582),
    [anon_sym_return] = ACTIONS(13582),
    [anon_sym_const] = ACTIONS(13582),
    [anon_sym_global] = ACTIONS(13582),
    [anon_sym_local] = ACTIONS(13582),
    [anon_sym_LPAREN] = ACTIONS(13582),
    [anon_sym_COLON2] = ACTIONS(13582),
    [anon_sym_export] = ACTIONS(13582),
    [anon_sym_import] = ACTIONS(13582),
    [anon_sym_using] = ACTIONS(13582),
    [anon_sym_LBRACK] = ACTIONS(13582),
    [anon_sym_LF] = ACTIONS(13584),
    [anon_sym_in] = ACTIONS(13582),
    [anon_sym_LBRACE] = ACTIONS(13582),
    [anon_sym_DOLLAR] = ACTIONS(13582),
    [anon_sym_COLON_COLON] = ACTIONS(13582),
    [anon_sym_isa] = ACTIONS(13582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13582),
    [anon_sym_QMARK] = ACTIONS(13582),
    [anon_sym_AT] = ACTIONS(13582),
    [anon_sym_true] = ACTIONS(13582),
    [anon_sym_false] = ACTIONS(13582),
    [aux_sym_integer_literal_token1] = ACTIONS(13582),
    [aux_sym_integer_literal_token2] = ACTIONS(13582),
    [aux_sym_integer_literal_token3] = ACTIONS(13582),
    [aux_sym_integer_literal_token4] = ACTIONS(13582),
    [aux_sym_float_literal_token1] = ACTIONS(13582),
    [aux_sym_float_literal_token3] = ACTIONS(13582),
    [aux_sym_float_literal_token4] = ACTIONS(13582),
    [sym_character_literal] = ACTIONS(13582),
    [sym__pair_operator] = ACTIONS(13582),
    [sym__arrow_operator] = ACTIONS(13582),
    [sym__lazy_or_operator] = ACTIONS(13582),
    [sym__lazy_and_operator] = ACTIONS(13582),
    [sym__comparison_operator] = ACTIONS(13582),
    [sym__pipe_right_operator] = ACTIONS(13582),
    [sym__pipe_left_operator] = ACTIONS(13582),
    [sym__ellipsis_operator] = ACTIONS(13582),
    [sym__plus_operator] = ACTIONS(13582),
    [sym__times_operator] = ACTIONS(13582),
    [sym__rational_operator] = ACTIONS(13582),
    [sym__bitshift_operator] = ACTIONS(13582),
    [sym__power_operator] = ACTIONS(13582),
    [sym__tilde_operator] = ACTIONS(13582),
    [sym__type_order_operator] = ACTIONS(13582),
    [sym__unary_operator] = ACTIONS(13582),
    [sym__unary_plus_operator] = ACTIONS(13582),
    [aux_sym__terminator_token1] = ACTIONS(13582),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13584),
    [sym__command_start] = ACTIONS(13584),
  },
  [7499] = {
    [sym__word_identifier] = ACTIONS(13586),
    [anon_sym_EQ] = ACTIONS(13586),
    [anon_sym_COMMA] = ACTIONS(13586),
    [anon_sym_COLON] = ACTIONS(13586),
    [anon_sym_begin] = ACTIONS(13586),
    [anon_sym_module] = ACTIONS(13586),
    [anon_sym_baremodule] = ACTIONS(13586),
    [anon_sym_end] = ACTIONS(13586),
    [anon_sym_abstract] = ACTIONS(13586),
    [anon_sym_primitive] = ACTIONS(13586),
    [anon_sym_mutable] = ACTIONS(13586),
    [anon_sym_struct] = ACTIONS(13586),
    [anon_sym_function] = ACTIONS(13586),
    [anon_sym_macro] = ACTIONS(13586),
    [anon_sym_where] = ACTIONS(13586),
    [anon_sym_quote] = ACTIONS(13586),
    [anon_sym_let] = ACTIONS(13586),
    [anon_sym_if] = ACTIONS(13586),
    [anon_sym_else] = ACTIONS(13586),
    [anon_sym_try] = ACTIONS(13586),
    [anon_sym_finally] = ACTIONS(13586),
    [anon_sym_for] = ACTIONS(13586),
    [anon_sym_while] = ACTIONS(13586),
    [sym_break_statement] = ACTIONS(13586),
    [sym_continue_statement] = ACTIONS(13586),
    [anon_sym_return] = ACTIONS(13586),
    [anon_sym_const] = ACTIONS(13586),
    [anon_sym_global] = ACTIONS(13586),
    [anon_sym_local] = ACTIONS(13586),
    [anon_sym_LPAREN] = ACTIONS(13586),
    [anon_sym_COLON2] = ACTIONS(13586),
    [anon_sym_export] = ACTIONS(13586),
    [anon_sym_import] = ACTIONS(13586),
    [anon_sym_using] = ACTIONS(13586),
    [anon_sym_LBRACK] = ACTIONS(13586),
    [anon_sym_LF] = ACTIONS(13588),
    [anon_sym_in] = ACTIONS(13586),
    [anon_sym_LBRACE] = ACTIONS(13586),
    [anon_sym_DOLLAR] = ACTIONS(13586),
    [anon_sym_COLON_COLON] = ACTIONS(13586),
    [anon_sym_isa] = ACTIONS(13586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13586),
    [anon_sym_QMARK] = ACTIONS(13586),
    [anon_sym_AT] = ACTIONS(13586),
    [anon_sym_true] = ACTIONS(13586),
    [anon_sym_false] = ACTIONS(13586),
    [aux_sym_integer_literal_token1] = ACTIONS(13586),
    [aux_sym_integer_literal_token2] = ACTIONS(13586),
    [aux_sym_integer_literal_token3] = ACTIONS(13586),
    [aux_sym_integer_literal_token4] = ACTIONS(13586),
    [aux_sym_float_literal_token1] = ACTIONS(13586),
    [aux_sym_float_literal_token3] = ACTIONS(13586),
    [aux_sym_float_literal_token4] = ACTIONS(13586),
    [sym_character_literal] = ACTIONS(13586),
    [sym__pair_operator] = ACTIONS(13586),
    [sym__arrow_operator] = ACTIONS(13586),
    [sym__lazy_or_operator] = ACTIONS(13586),
    [sym__lazy_and_operator] = ACTIONS(13586),
    [sym__comparison_operator] = ACTIONS(13586),
    [sym__pipe_right_operator] = ACTIONS(13586),
    [sym__pipe_left_operator] = ACTIONS(13586),
    [sym__ellipsis_operator] = ACTIONS(13586),
    [sym__plus_operator] = ACTIONS(13586),
    [sym__times_operator] = ACTIONS(13586),
    [sym__rational_operator] = ACTIONS(13586),
    [sym__bitshift_operator] = ACTIONS(13586),
    [sym__power_operator] = ACTIONS(13586),
    [sym__tilde_operator] = ACTIONS(13586),
    [sym__type_order_operator] = ACTIONS(13586),
    [sym__unary_operator] = ACTIONS(13586),
    [sym__unary_plus_operator] = ACTIONS(13586),
    [aux_sym__terminator_token1] = ACTIONS(13586),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13588),
    [sym__command_start] = ACTIONS(13588),
  },
  [7500] = {
    [sym__word_identifier] = ACTIONS(13590),
    [anon_sym_EQ] = ACTIONS(13590),
    [anon_sym_COMMA] = ACTIONS(13590),
    [anon_sym_COLON] = ACTIONS(13590),
    [anon_sym_begin] = ACTIONS(13590),
    [anon_sym_module] = ACTIONS(13590),
    [anon_sym_baremodule] = ACTIONS(13590),
    [anon_sym_end] = ACTIONS(13590),
    [anon_sym_abstract] = ACTIONS(13590),
    [anon_sym_primitive] = ACTIONS(13590),
    [anon_sym_mutable] = ACTIONS(13590),
    [anon_sym_struct] = ACTIONS(13590),
    [anon_sym_function] = ACTIONS(13590),
    [anon_sym_macro] = ACTIONS(13590),
    [anon_sym_where] = ACTIONS(13590),
    [anon_sym_quote] = ACTIONS(13590),
    [anon_sym_let] = ACTIONS(13590),
    [anon_sym_if] = ACTIONS(13590),
    [anon_sym_else] = ACTIONS(13590),
    [anon_sym_try] = ACTIONS(13590),
    [anon_sym_finally] = ACTIONS(13590),
    [anon_sym_for] = ACTIONS(13590),
    [anon_sym_while] = ACTIONS(13590),
    [sym_break_statement] = ACTIONS(13590),
    [sym_continue_statement] = ACTIONS(13590),
    [anon_sym_return] = ACTIONS(13590),
    [anon_sym_const] = ACTIONS(13590),
    [anon_sym_global] = ACTIONS(13590),
    [anon_sym_local] = ACTIONS(13590),
    [anon_sym_LPAREN] = ACTIONS(13590),
    [anon_sym_COLON2] = ACTIONS(13590),
    [anon_sym_export] = ACTIONS(13590),
    [anon_sym_import] = ACTIONS(13590),
    [anon_sym_using] = ACTIONS(13590),
    [anon_sym_LBRACK] = ACTIONS(13590),
    [anon_sym_LF] = ACTIONS(13592),
    [anon_sym_in] = ACTIONS(13590),
    [anon_sym_LBRACE] = ACTIONS(13590),
    [anon_sym_DOLLAR] = ACTIONS(13590),
    [anon_sym_COLON_COLON] = ACTIONS(13590),
    [anon_sym_isa] = ACTIONS(13590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13590),
    [anon_sym_QMARK] = ACTIONS(13590),
    [anon_sym_AT] = ACTIONS(13590),
    [anon_sym_true] = ACTIONS(13590),
    [anon_sym_false] = ACTIONS(13590),
    [aux_sym_integer_literal_token1] = ACTIONS(13590),
    [aux_sym_integer_literal_token2] = ACTIONS(13590),
    [aux_sym_integer_literal_token3] = ACTIONS(13590),
    [aux_sym_integer_literal_token4] = ACTIONS(13590),
    [aux_sym_float_literal_token1] = ACTIONS(13590),
    [aux_sym_float_literal_token3] = ACTIONS(13590),
    [aux_sym_float_literal_token4] = ACTIONS(13590),
    [sym_character_literal] = ACTIONS(13590),
    [sym__pair_operator] = ACTIONS(13590),
    [sym__arrow_operator] = ACTIONS(13590),
    [sym__lazy_or_operator] = ACTIONS(13590),
    [sym__lazy_and_operator] = ACTIONS(13590),
    [sym__comparison_operator] = ACTIONS(13590),
    [sym__pipe_right_operator] = ACTIONS(13590),
    [sym__pipe_left_operator] = ACTIONS(13590),
    [sym__ellipsis_operator] = ACTIONS(13590),
    [sym__plus_operator] = ACTIONS(13590),
    [sym__times_operator] = ACTIONS(13590),
    [sym__rational_operator] = ACTIONS(13590),
    [sym__bitshift_operator] = ACTIONS(13590),
    [sym__power_operator] = ACTIONS(13590),
    [sym__tilde_operator] = ACTIONS(13590),
    [sym__type_order_operator] = ACTIONS(13590),
    [sym__unary_operator] = ACTIONS(13590),
    [sym__unary_plus_operator] = ACTIONS(13590),
    [aux_sym__terminator_token1] = ACTIONS(13590),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13592),
    [sym__command_start] = ACTIONS(13592),
  },
  [7501] = {
    [sym__word_identifier] = ACTIONS(13594),
    [anon_sym_EQ] = ACTIONS(13594),
    [anon_sym_COMMA] = ACTIONS(13594),
    [anon_sym_COLON] = ACTIONS(13594),
    [anon_sym_begin] = ACTIONS(13594),
    [anon_sym_module] = ACTIONS(13594),
    [anon_sym_baremodule] = ACTIONS(13594),
    [anon_sym_end] = ACTIONS(13594),
    [anon_sym_abstract] = ACTIONS(13594),
    [anon_sym_primitive] = ACTIONS(13594),
    [anon_sym_mutable] = ACTIONS(13594),
    [anon_sym_struct] = ACTIONS(13594),
    [anon_sym_function] = ACTIONS(13594),
    [anon_sym_macro] = ACTIONS(13594),
    [anon_sym_where] = ACTIONS(13594),
    [anon_sym_quote] = ACTIONS(13594),
    [anon_sym_let] = ACTIONS(13594),
    [anon_sym_if] = ACTIONS(13594),
    [anon_sym_else] = ACTIONS(13594),
    [anon_sym_try] = ACTIONS(13594),
    [anon_sym_finally] = ACTIONS(13594),
    [anon_sym_for] = ACTIONS(13594),
    [anon_sym_while] = ACTIONS(13594),
    [sym_break_statement] = ACTIONS(13594),
    [sym_continue_statement] = ACTIONS(13594),
    [anon_sym_return] = ACTIONS(13594),
    [anon_sym_const] = ACTIONS(13594),
    [anon_sym_global] = ACTIONS(13594),
    [anon_sym_local] = ACTIONS(13594),
    [anon_sym_LPAREN] = ACTIONS(13594),
    [anon_sym_COLON2] = ACTIONS(13594),
    [anon_sym_export] = ACTIONS(13594),
    [anon_sym_import] = ACTIONS(13594),
    [anon_sym_using] = ACTIONS(13594),
    [anon_sym_LBRACK] = ACTIONS(13594),
    [anon_sym_LF] = ACTIONS(13596),
    [anon_sym_in] = ACTIONS(13594),
    [anon_sym_LBRACE] = ACTIONS(13594),
    [anon_sym_DOLLAR] = ACTIONS(13594),
    [anon_sym_COLON_COLON] = ACTIONS(13594),
    [anon_sym_isa] = ACTIONS(13594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13594),
    [anon_sym_QMARK] = ACTIONS(13594),
    [anon_sym_AT] = ACTIONS(13594),
    [anon_sym_true] = ACTIONS(13594),
    [anon_sym_false] = ACTIONS(13594),
    [aux_sym_integer_literal_token1] = ACTIONS(13594),
    [aux_sym_integer_literal_token2] = ACTIONS(13594),
    [aux_sym_integer_literal_token3] = ACTIONS(13594),
    [aux_sym_integer_literal_token4] = ACTIONS(13594),
    [aux_sym_float_literal_token1] = ACTIONS(13594),
    [aux_sym_float_literal_token3] = ACTIONS(13594),
    [aux_sym_float_literal_token4] = ACTIONS(13594),
    [sym_character_literal] = ACTIONS(13594),
    [sym__pair_operator] = ACTIONS(13594),
    [sym__arrow_operator] = ACTIONS(13594),
    [sym__lazy_or_operator] = ACTIONS(13594),
    [sym__lazy_and_operator] = ACTIONS(13594),
    [sym__comparison_operator] = ACTIONS(13594),
    [sym__pipe_right_operator] = ACTIONS(13594),
    [sym__pipe_left_operator] = ACTIONS(13594),
    [sym__ellipsis_operator] = ACTIONS(13594),
    [sym__plus_operator] = ACTIONS(13594),
    [sym__times_operator] = ACTIONS(13594),
    [sym__rational_operator] = ACTIONS(13594),
    [sym__bitshift_operator] = ACTIONS(13594),
    [sym__power_operator] = ACTIONS(13594),
    [sym__tilde_operator] = ACTIONS(13594),
    [sym__type_order_operator] = ACTIONS(13594),
    [sym__unary_operator] = ACTIONS(13594),
    [sym__unary_plus_operator] = ACTIONS(13594),
    [aux_sym__terminator_token1] = ACTIONS(13594),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13596),
    [sym__command_start] = ACTIONS(13596),
  },
  [7502] = {
    [sym__word_identifier] = ACTIONS(13598),
    [anon_sym_EQ] = ACTIONS(13598),
    [anon_sym_COMMA] = ACTIONS(13598),
    [anon_sym_COLON] = ACTIONS(13598),
    [anon_sym_begin] = ACTIONS(13598),
    [anon_sym_module] = ACTIONS(13598),
    [anon_sym_baremodule] = ACTIONS(13598),
    [anon_sym_end] = ACTIONS(13598),
    [anon_sym_abstract] = ACTIONS(13598),
    [anon_sym_primitive] = ACTIONS(13598),
    [anon_sym_mutable] = ACTIONS(13598),
    [anon_sym_struct] = ACTIONS(13598),
    [anon_sym_function] = ACTIONS(13598),
    [anon_sym_macro] = ACTIONS(13598),
    [anon_sym_where] = ACTIONS(13598),
    [anon_sym_quote] = ACTIONS(13598),
    [anon_sym_let] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(13598),
    [anon_sym_else] = ACTIONS(13598),
    [anon_sym_try] = ACTIONS(13598),
    [anon_sym_finally] = ACTIONS(13598),
    [anon_sym_for] = ACTIONS(13598),
    [anon_sym_while] = ACTIONS(13598),
    [sym_break_statement] = ACTIONS(13598),
    [sym_continue_statement] = ACTIONS(13598),
    [anon_sym_return] = ACTIONS(13598),
    [anon_sym_const] = ACTIONS(13598),
    [anon_sym_global] = ACTIONS(13598),
    [anon_sym_local] = ACTIONS(13598),
    [anon_sym_LPAREN] = ACTIONS(13598),
    [anon_sym_COLON2] = ACTIONS(13598),
    [anon_sym_export] = ACTIONS(13598),
    [anon_sym_import] = ACTIONS(13598),
    [anon_sym_using] = ACTIONS(13598),
    [anon_sym_LBRACK] = ACTIONS(13598),
    [anon_sym_LF] = ACTIONS(13600),
    [anon_sym_in] = ACTIONS(13598),
    [anon_sym_LBRACE] = ACTIONS(13598),
    [anon_sym_DOLLAR] = ACTIONS(13598),
    [anon_sym_COLON_COLON] = ACTIONS(13598),
    [anon_sym_isa] = ACTIONS(13598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13598),
    [anon_sym_QMARK] = ACTIONS(13598),
    [anon_sym_AT] = ACTIONS(13598),
    [anon_sym_true] = ACTIONS(13598),
    [anon_sym_false] = ACTIONS(13598),
    [aux_sym_integer_literal_token1] = ACTIONS(13598),
    [aux_sym_integer_literal_token2] = ACTIONS(13598),
    [aux_sym_integer_literal_token3] = ACTIONS(13598),
    [aux_sym_integer_literal_token4] = ACTIONS(13598),
    [aux_sym_float_literal_token1] = ACTIONS(13598),
    [aux_sym_float_literal_token3] = ACTIONS(13598),
    [aux_sym_float_literal_token4] = ACTIONS(13598),
    [sym_character_literal] = ACTIONS(13598),
    [sym__pair_operator] = ACTIONS(13598),
    [sym__arrow_operator] = ACTIONS(13598),
    [sym__lazy_or_operator] = ACTIONS(13598),
    [sym__lazy_and_operator] = ACTIONS(13598),
    [sym__comparison_operator] = ACTIONS(13598),
    [sym__pipe_right_operator] = ACTIONS(13598),
    [sym__pipe_left_operator] = ACTIONS(13598),
    [sym__ellipsis_operator] = ACTIONS(13598),
    [sym__plus_operator] = ACTIONS(13598),
    [sym__times_operator] = ACTIONS(13598),
    [sym__rational_operator] = ACTIONS(13598),
    [sym__bitshift_operator] = ACTIONS(13598),
    [sym__power_operator] = ACTIONS(13598),
    [sym__tilde_operator] = ACTIONS(13598),
    [sym__type_order_operator] = ACTIONS(13598),
    [sym__unary_operator] = ACTIONS(13598),
    [sym__unary_plus_operator] = ACTIONS(13598),
    [aux_sym__terminator_token1] = ACTIONS(13598),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13600),
    [sym__command_start] = ACTIONS(13600),
  },
  [7503] = {
    [sym__word_identifier] = ACTIONS(13602),
    [anon_sym_EQ] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(13602),
    [anon_sym_COLON] = ACTIONS(13602),
    [anon_sym_begin] = ACTIONS(13602),
    [anon_sym_module] = ACTIONS(13602),
    [anon_sym_baremodule] = ACTIONS(13602),
    [anon_sym_end] = ACTIONS(13602),
    [anon_sym_abstract] = ACTIONS(13602),
    [anon_sym_primitive] = ACTIONS(13602),
    [anon_sym_mutable] = ACTIONS(13602),
    [anon_sym_struct] = ACTIONS(13602),
    [anon_sym_function] = ACTIONS(13602),
    [anon_sym_macro] = ACTIONS(13602),
    [anon_sym_where] = ACTIONS(13602),
    [anon_sym_quote] = ACTIONS(13602),
    [anon_sym_let] = ACTIONS(13602),
    [anon_sym_if] = ACTIONS(13602),
    [anon_sym_else] = ACTIONS(13602),
    [anon_sym_try] = ACTIONS(13602),
    [anon_sym_finally] = ACTIONS(13602),
    [anon_sym_for] = ACTIONS(13602),
    [anon_sym_while] = ACTIONS(13602),
    [sym_break_statement] = ACTIONS(13602),
    [sym_continue_statement] = ACTIONS(13602),
    [anon_sym_return] = ACTIONS(13602),
    [anon_sym_const] = ACTIONS(13602),
    [anon_sym_global] = ACTIONS(13602),
    [anon_sym_local] = ACTIONS(13602),
    [anon_sym_LPAREN] = ACTIONS(13602),
    [anon_sym_COLON2] = ACTIONS(13602),
    [anon_sym_export] = ACTIONS(13602),
    [anon_sym_import] = ACTIONS(13602),
    [anon_sym_using] = ACTIONS(13602),
    [anon_sym_LBRACK] = ACTIONS(13602),
    [anon_sym_LF] = ACTIONS(13604),
    [anon_sym_in] = ACTIONS(13602),
    [anon_sym_LBRACE] = ACTIONS(13602),
    [anon_sym_DOLLAR] = ACTIONS(13602),
    [anon_sym_COLON_COLON] = ACTIONS(13602),
    [anon_sym_isa] = ACTIONS(13602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13602),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_AT] = ACTIONS(13602),
    [anon_sym_true] = ACTIONS(13602),
    [anon_sym_false] = ACTIONS(13602),
    [aux_sym_integer_literal_token1] = ACTIONS(13602),
    [aux_sym_integer_literal_token2] = ACTIONS(13602),
    [aux_sym_integer_literal_token3] = ACTIONS(13602),
    [aux_sym_integer_literal_token4] = ACTIONS(13602),
    [aux_sym_float_literal_token1] = ACTIONS(13602),
    [aux_sym_float_literal_token3] = ACTIONS(13602),
    [aux_sym_float_literal_token4] = ACTIONS(13602),
    [sym_character_literal] = ACTIONS(13602),
    [sym__pair_operator] = ACTIONS(13602),
    [sym__arrow_operator] = ACTIONS(13602),
    [sym__lazy_or_operator] = ACTIONS(13602),
    [sym__lazy_and_operator] = ACTIONS(13602),
    [sym__comparison_operator] = ACTIONS(13602),
    [sym__pipe_right_operator] = ACTIONS(13602),
    [sym__pipe_left_operator] = ACTIONS(13602),
    [sym__ellipsis_operator] = ACTIONS(13602),
    [sym__plus_operator] = ACTIONS(13602),
    [sym__times_operator] = ACTIONS(13602),
    [sym__rational_operator] = ACTIONS(13602),
    [sym__bitshift_operator] = ACTIONS(13602),
    [sym__power_operator] = ACTIONS(13602),
    [sym__tilde_operator] = ACTIONS(13602),
    [sym__type_order_operator] = ACTIONS(13602),
    [sym__unary_operator] = ACTIONS(13602),
    [sym__unary_plus_operator] = ACTIONS(13602),
    [aux_sym__terminator_token1] = ACTIONS(13602),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13604),
    [sym__command_start] = ACTIONS(13604),
  },
  [7504] = {
    [sym__word_identifier] = ACTIONS(13606),
    [anon_sym_EQ] = ACTIONS(13606),
    [anon_sym_COMMA] = ACTIONS(13606),
    [anon_sym_COLON] = ACTIONS(13606),
    [anon_sym_begin] = ACTIONS(13606),
    [anon_sym_module] = ACTIONS(13606),
    [anon_sym_baremodule] = ACTIONS(13606),
    [anon_sym_end] = ACTIONS(13606),
    [anon_sym_abstract] = ACTIONS(13606),
    [anon_sym_primitive] = ACTIONS(13606),
    [anon_sym_mutable] = ACTIONS(13606),
    [anon_sym_struct] = ACTIONS(13606),
    [anon_sym_function] = ACTIONS(13606),
    [anon_sym_macro] = ACTIONS(13606),
    [anon_sym_where] = ACTIONS(13606),
    [anon_sym_quote] = ACTIONS(13606),
    [anon_sym_let] = ACTIONS(13606),
    [anon_sym_if] = ACTIONS(13606),
    [anon_sym_else] = ACTIONS(13606),
    [anon_sym_try] = ACTIONS(13606),
    [anon_sym_finally] = ACTIONS(13606),
    [anon_sym_for] = ACTIONS(13606),
    [anon_sym_while] = ACTIONS(13606),
    [sym_break_statement] = ACTIONS(13606),
    [sym_continue_statement] = ACTIONS(13606),
    [anon_sym_return] = ACTIONS(13606),
    [anon_sym_const] = ACTIONS(13606),
    [anon_sym_global] = ACTIONS(13606),
    [anon_sym_local] = ACTIONS(13606),
    [anon_sym_LPAREN] = ACTIONS(13606),
    [anon_sym_COLON2] = ACTIONS(13606),
    [anon_sym_export] = ACTIONS(13606),
    [anon_sym_import] = ACTIONS(13606),
    [anon_sym_using] = ACTIONS(13606),
    [anon_sym_LBRACK] = ACTIONS(13606),
    [anon_sym_LF] = ACTIONS(13608),
    [anon_sym_in] = ACTIONS(13606),
    [anon_sym_LBRACE] = ACTIONS(13606),
    [anon_sym_DOLLAR] = ACTIONS(13606),
    [anon_sym_COLON_COLON] = ACTIONS(13606),
    [anon_sym_isa] = ACTIONS(13606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_QMARK] = ACTIONS(13606),
    [anon_sym_AT] = ACTIONS(13606),
    [anon_sym_true] = ACTIONS(13606),
    [anon_sym_false] = ACTIONS(13606),
    [aux_sym_integer_literal_token1] = ACTIONS(13606),
    [aux_sym_integer_literal_token2] = ACTIONS(13606),
    [aux_sym_integer_literal_token3] = ACTIONS(13606),
    [aux_sym_integer_literal_token4] = ACTIONS(13606),
    [aux_sym_float_literal_token1] = ACTIONS(13606),
    [aux_sym_float_literal_token3] = ACTIONS(13606),
    [aux_sym_float_literal_token4] = ACTIONS(13606),
    [sym_character_literal] = ACTIONS(13606),
    [sym__pair_operator] = ACTIONS(13606),
    [sym__arrow_operator] = ACTIONS(13606),
    [sym__lazy_or_operator] = ACTIONS(13606),
    [sym__lazy_and_operator] = ACTIONS(13606),
    [sym__comparison_operator] = ACTIONS(13606),
    [sym__pipe_right_operator] = ACTIONS(13606),
    [sym__pipe_left_operator] = ACTIONS(13606),
    [sym__ellipsis_operator] = ACTIONS(13606),
    [sym__plus_operator] = ACTIONS(13606),
    [sym__times_operator] = ACTIONS(13606),
    [sym__rational_operator] = ACTIONS(13606),
    [sym__bitshift_operator] = ACTIONS(13606),
    [sym__power_operator] = ACTIONS(13606),
    [sym__tilde_operator] = ACTIONS(13606),
    [sym__type_order_operator] = ACTIONS(13606),
    [sym__unary_operator] = ACTIONS(13606),
    [sym__unary_plus_operator] = ACTIONS(13606),
    [aux_sym__terminator_token1] = ACTIONS(13606),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13608),
    [sym__command_start] = ACTIONS(13608),
  },
  [7505] = {
    [sym__comprehension_clause] = STATE(19797),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17274),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13610),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13612),
    [anon_sym_LF] = ACTIONS(13614),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13617),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7506] = {
    [sym__word_identifier] = ACTIONS(13620),
    [anon_sym_EQ] = ACTIONS(13620),
    [anon_sym_COMMA] = ACTIONS(13620),
    [anon_sym_COLON] = ACTIONS(13620),
    [anon_sym_begin] = ACTIONS(13620),
    [anon_sym_module] = ACTIONS(13620),
    [anon_sym_baremodule] = ACTIONS(13620),
    [anon_sym_end] = ACTIONS(13620),
    [anon_sym_abstract] = ACTIONS(13620),
    [anon_sym_primitive] = ACTIONS(13620),
    [anon_sym_mutable] = ACTIONS(13620),
    [anon_sym_struct] = ACTIONS(13620),
    [anon_sym_function] = ACTIONS(13620),
    [anon_sym_macro] = ACTIONS(13620),
    [anon_sym_where] = ACTIONS(13620),
    [anon_sym_quote] = ACTIONS(13620),
    [anon_sym_let] = ACTIONS(13620),
    [anon_sym_if] = ACTIONS(13620),
    [anon_sym_else] = ACTIONS(13620),
    [anon_sym_try] = ACTIONS(13620),
    [anon_sym_finally] = ACTIONS(13620),
    [anon_sym_for] = ACTIONS(13620),
    [anon_sym_while] = ACTIONS(13620),
    [sym_break_statement] = ACTIONS(13620),
    [sym_continue_statement] = ACTIONS(13620),
    [anon_sym_return] = ACTIONS(13620),
    [anon_sym_const] = ACTIONS(13620),
    [anon_sym_global] = ACTIONS(13620),
    [anon_sym_local] = ACTIONS(13620),
    [anon_sym_LPAREN] = ACTIONS(13620),
    [anon_sym_COLON2] = ACTIONS(13620),
    [anon_sym_export] = ACTIONS(13620),
    [anon_sym_import] = ACTIONS(13620),
    [anon_sym_using] = ACTIONS(13620),
    [anon_sym_LBRACK] = ACTIONS(13620),
    [anon_sym_LF] = ACTIONS(13622),
    [anon_sym_in] = ACTIONS(13620),
    [anon_sym_LBRACE] = ACTIONS(13620),
    [anon_sym_DOLLAR] = ACTIONS(13620),
    [anon_sym_COLON_COLON] = ACTIONS(13620),
    [anon_sym_isa] = ACTIONS(13620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13620),
    [anon_sym_QMARK] = ACTIONS(13620),
    [anon_sym_AT] = ACTIONS(13620),
    [anon_sym_true] = ACTIONS(13620),
    [anon_sym_false] = ACTIONS(13620),
    [aux_sym_integer_literal_token1] = ACTIONS(13620),
    [aux_sym_integer_literal_token2] = ACTIONS(13620),
    [aux_sym_integer_literal_token3] = ACTIONS(13620),
    [aux_sym_integer_literal_token4] = ACTIONS(13620),
    [aux_sym_float_literal_token1] = ACTIONS(13620),
    [aux_sym_float_literal_token3] = ACTIONS(13620),
    [aux_sym_float_literal_token4] = ACTIONS(13620),
    [sym_character_literal] = ACTIONS(13620),
    [sym__pair_operator] = ACTIONS(13620),
    [sym__arrow_operator] = ACTIONS(13620),
    [sym__lazy_or_operator] = ACTIONS(13620),
    [sym__lazy_and_operator] = ACTIONS(13620),
    [sym__comparison_operator] = ACTIONS(13620),
    [sym__pipe_right_operator] = ACTIONS(13620),
    [sym__pipe_left_operator] = ACTIONS(13620),
    [sym__ellipsis_operator] = ACTIONS(13620),
    [sym__plus_operator] = ACTIONS(13620),
    [sym__times_operator] = ACTIONS(13620),
    [sym__rational_operator] = ACTIONS(13620),
    [sym__bitshift_operator] = ACTIONS(13620),
    [sym__power_operator] = ACTIONS(13620),
    [sym__tilde_operator] = ACTIONS(13620),
    [sym__type_order_operator] = ACTIONS(13620),
    [sym__unary_operator] = ACTIONS(13620),
    [sym__unary_plus_operator] = ACTIONS(13620),
    [aux_sym__terminator_token1] = ACTIONS(13620),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13622),
    [sym__command_start] = ACTIONS(13622),
  },
  [7507] = {
    [sym__word_identifier] = ACTIONS(13624),
    [anon_sym_EQ] = ACTIONS(13624),
    [anon_sym_COMMA] = ACTIONS(13624),
    [anon_sym_COLON] = ACTIONS(13624),
    [anon_sym_begin] = ACTIONS(13624),
    [anon_sym_module] = ACTIONS(13624),
    [anon_sym_baremodule] = ACTIONS(13624),
    [anon_sym_end] = ACTIONS(13624),
    [anon_sym_abstract] = ACTIONS(13624),
    [anon_sym_primitive] = ACTIONS(13624),
    [anon_sym_mutable] = ACTIONS(13624),
    [anon_sym_struct] = ACTIONS(13624),
    [anon_sym_function] = ACTIONS(13624),
    [anon_sym_macro] = ACTIONS(13624),
    [anon_sym_where] = ACTIONS(13624),
    [anon_sym_quote] = ACTIONS(13624),
    [anon_sym_let] = ACTIONS(13624),
    [anon_sym_if] = ACTIONS(13624),
    [anon_sym_else] = ACTIONS(13624),
    [anon_sym_try] = ACTIONS(13624),
    [anon_sym_finally] = ACTIONS(13624),
    [anon_sym_for] = ACTIONS(13624),
    [anon_sym_while] = ACTIONS(13624),
    [sym_break_statement] = ACTIONS(13624),
    [sym_continue_statement] = ACTIONS(13624),
    [anon_sym_return] = ACTIONS(13624),
    [anon_sym_const] = ACTIONS(13624),
    [anon_sym_global] = ACTIONS(13624),
    [anon_sym_local] = ACTIONS(13624),
    [anon_sym_LPAREN] = ACTIONS(13624),
    [anon_sym_COLON2] = ACTIONS(13624),
    [anon_sym_export] = ACTIONS(13624),
    [anon_sym_import] = ACTIONS(13624),
    [anon_sym_using] = ACTIONS(13624),
    [anon_sym_LBRACK] = ACTIONS(13624),
    [anon_sym_LF] = ACTIONS(13626),
    [anon_sym_in] = ACTIONS(13624),
    [anon_sym_LBRACE] = ACTIONS(13624),
    [anon_sym_DOLLAR] = ACTIONS(13624),
    [anon_sym_COLON_COLON] = ACTIONS(13624),
    [anon_sym_isa] = ACTIONS(13624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13624),
    [anon_sym_QMARK] = ACTIONS(13624),
    [anon_sym_AT] = ACTIONS(13624),
    [anon_sym_true] = ACTIONS(13624),
    [anon_sym_false] = ACTIONS(13624),
    [aux_sym_integer_literal_token1] = ACTIONS(13624),
    [aux_sym_integer_literal_token2] = ACTIONS(13624),
    [aux_sym_integer_literal_token3] = ACTIONS(13624),
    [aux_sym_integer_literal_token4] = ACTIONS(13624),
    [aux_sym_float_literal_token1] = ACTIONS(13624),
    [aux_sym_float_literal_token3] = ACTIONS(13624),
    [aux_sym_float_literal_token4] = ACTIONS(13624),
    [sym_character_literal] = ACTIONS(13624),
    [sym__pair_operator] = ACTIONS(13624),
    [sym__arrow_operator] = ACTIONS(13624),
    [sym__lazy_or_operator] = ACTIONS(13624),
    [sym__lazy_and_operator] = ACTIONS(13624),
    [sym__comparison_operator] = ACTIONS(13624),
    [sym__pipe_right_operator] = ACTIONS(13624),
    [sym__pipe_left_operator] = ACTIONS(13624),
    [sym__ellipsis_operator] = ACTIONS(13624),
    [sym__plus_operator] = ACTIONS(13624),
    [sym__times_operator] = ACTIONS(13624),
    [sym__rational_operator] = ACTIONS(13624),
    [sym__bitshift_operator] = ACTIONS(13624),
    [sym__power_operator] = ACTIONS(13624),
    [sym__tilde_operator] = ACTIONS(13624),
    [sym__type_order_operator] = ACTIONS(13624),
    [sym__unary_operator] = ACTIONS(13624),
    [sym__unary_plus_operator] = ACTIONS(13624),
    [aux_sym__terminator_token1] = ACTIONS(13624),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13626),
    [sym__command_start] = ACTIONS(13626),
  },
  [7508] = {
    [sym__word_identifier] = ACTIONS(13628),
    [anon_sym_EQ] = ACTIONS(13628),
    [anon_sym_COMMA] = ACTIONS(13628),
    [anon_sym_COLON] = ACTIONS(13628),
    [anon_sym_begin] = ACTIONS(13628),
    [anon_sym_module] = ACTIONS(13628),
    [anon_sym_baremodule] = ACTIONS(13628),
    [anon_sym_end] = ACTIONS(13628),
    [anon_sym_abstract] = ACTIONS(13628),
    [anon_sym_primitive] = ACTIONS(13628),
    [anon_sym_mutable] = ACTIONS(13628),
    [anon_sym_struct] = ACTIONS(13628),
    [anon_sym_function] = ACTIONS(13628),
    [anon_sym_macro] = ACTIONS(13628),
    [anon_sym_where] = ACTIONS(13628),
    [anon_sym_quote] = ACTIONS(13628),
    [anon_sym_let] = ACTIONS(13628),
    [anon_sym_if] = ACTIONS(13628),
    [anon_sym_else] = ACTIONS(13628),
    [anon_sym_try] = ACTIONS(13628),
    [anon_sym_finally] = ACTIONS(13628),
    [anon_sym_for] = ACTIONS(13628),
    [anon_sym_while] = ACTIONS(13628),
    [sym_break_statement] = ACTIONS(13628),
    [sym_continue_statement] = ACTIONS(13628),
    [anon_sym_return] = ACTIONS(13628),
    [anon_sym_const] = ACTIONS(13628),
    [anon_sym_global] = ACTIONS(13628),
    [anon_sym_local] = ACTIONS(13628),
    [anon_sym_LPAREN] = ACTIONS(13628),
    [anon_sym_COLON2] = ACTIONS(13628),
    [anon_sym_export] = ACTIONS(13628),
    [anon_sym_import] = ACTIONS(13628),
    [anon_sym_using] = ACTIONS(13628),
    [anon_sym_LBRACK] = ACTIONS(13628),
    [anon_sym_LF] = ACTIONS(13630),
    [anon_sym_in] = ACTIONS(13628),
    [anon_sym_LBRACE] = ACTIONS(13628),
    [anon_sym_DOLLAR] = ACTIONS(13628),
    [anon_sym_COLON_COLON] = ACTIONS(13628),
    [anon_sym_isa] = ACTIONS(13628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13628),
    [anon_sym_QMARK] = ACTIONS(13628),
    [anon_sym_AT] = ACTIONS(13628),
    [anon_sym_true] = ACTIONS(13628),
    [anon_sym_false] = ACTIONS(13628),
    [aux_sym_integer_literal_token1] = ACTIONS(13628),
    [aux_sym_integer_literal_token2] = ACTIONS(13628),
    [aux_sym_integer_literal_token3] = ACTIONS(13628),
    [aux_sym_integer_literal_token4] = ACTIONS(13628),
    [aux_sym_float_literal_token1] = ACTIONS(13628),
    [aux_sym_float_literal_token3] = ACTIONS(13628),
    [aux_sym_float_literal_token4] = ACTIONS(13628),
    [sym_character_literal] = ACTIONS(13628),
    [sym__pair_operator] = ACTIONS(13628),
    [sym__arrow_operator] = ACTIONS(13628),
    [sym__lazy_or_operator] = ACTIONS(13628),
    [sym__lazy_and_operator] = ACTIONS(13628),
    [sym__comparison_operator] = ACTIONS(13628),
    [sym__pipe_right_operator] = ACTIONS(13628),
    [sym__pipe_left_operator] = ACTIONS(13628),
    [sym__ellipsis_operator] = ACTIONS(13628),
    [sym__plus_operator] = ACTIONS(13628),
    [sym__times_operator] = ACTIONS(13628),
    [sym__rational_operator] = ACTIONS(13628),
    [sym__bitshift_operator] = ACTIONS(13628),
    [sym__power_operator] = ACTIONS(13628),
    [sym__tilde_operator] = ACTIONS(13628),
    [sym__type_order_operator] = ACTIONS(13628),
    [sym__unary_operator] = ACTIONS(13628),
    [sym__unary_plus_operator] = ACTIONS(13628),
    [aux_sym__terminator_token1] = ACTIONS(13628),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13630),
    [sym__command_start] = ACTIONS(13630),
  },
  [7509] = {
    [sym__word_identifier] = ACTIONS(13632),
    [anon_sym_EQ] = ACTIONS(13632),
    [anon_sym_COMMA] = ACTIONS(13632),
    [anon_sym_COLON] = ACTIONS(13632),
    [anon_sym_begin] = ACTIONS(13632),
    [anon_sym_module] = ACTIONS(13632),
    [anon_sym_baremodule] = ACTIONS(13632),
    [anon_sym_end] = ACTIONS(13632),
    [anon_sym_abstract] = ACTIONS(13632),
    [anon_sym_primitive] = ACTIONS(13632),
    [anon_sym_mutable] = ACTIONS(13632),
    [anon_sym_struct] = ACTIONS(13632),
    [anon_sym_function] = ACTIONS(13632),
    [anon_sym_macro] = ACTIONS(13632),
    [anon_sym_where] = ACTIONS(13632),
    [anon_sym_quote] = ACTIONS(13632),
    [anon_sym_let] = ACTIONS(13632),
    [anon_sym_if] = ACTIONS(13632),
    [anon_sym_else] = ACTIONS(13632),
    [anon_sym_try] = ACTIONS(13632),
    [anon_sym_finally] = ACTIONS(13632),
    [anon_sym_for] = ACTIONS(13632),
    [anon_sym_while] = ACTIONS(13632),
    [sym_break_statement] = ACTIONS(13632),
    [sym_continue_statement] = ACTIONS(13632),
    [anon_sym_return] = ACTIONS(13632),
    [anon_sym_const] = ACTIONS(13632),
    [anon_sym_global] = ACTIONS(13632),
    [anon_sym_local] = ACTIONS(13632),
    [anon_sym_LPAREN] = ACTIONS(13632),
    [anon_sym_COLON2] = ACTIONS(13632),
    [anon_sym_export] = ACTIONS(13632),
    [anon_sym_import] = ACTIONS(13632),
    [anon_sym_using] = ACTIONS(13632),
    [anon_sym_LBRACK] = ACTIONS(13632),
    [anon_sym_LF] = ACTIONS(13634),
    [anon_sym_in] = ACTIONS(13632),
    [anon_sym_LBRACE] = ACTIONS(13632),
    [anon_sym_DOLLAR] = ACTIONS(13632),
    [anon_sym_COLON_COLON] = ACTIONS(13632),
    [anon_sym_isa] = ACTIONS(13632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13632),
    [anon_sym_QMARK] = ACTIONS(13632),
    [anon_sym_AT] = ACTIONS(13632),
    [anon_sym_true] = ACTIONS(13632),
    [anon_sym_false] = ACTIONS(13632),
    [aux_sym_integer_literal_token1] = ACTIONS(13632),
    [aux_sym_integer_literal_token2] = ACTIONS(13632),
    [aux_sym_integer_literal_token3] = ACTIONS(13632),
    [aux_sym_integer_literal_token4] = ACTIONS(13632),
    [aux_sym_float_literal_token1] = ACTIONS(13632),
    [aux_sym_float_literal_token3] = ACTIONS(13632),
    [aux_sym_float_literal_token4] = ACTIONS(13632),
    [sym_character_literal] = ACTIONS(13632),
    [sym__pair_operator] = ACTIONS(13632),
    [sym__arrow_operator] = ACTIONS(13632),
    [sym__lazy_or_operator] = ACTIONS(13632),
    [sym__lazy_and_operator] = ACTIONS(13632),
    [sym__comparison_operator] = ACTIONS(13632),
    [sym__pipe_right_operator] = ACTIONS(13632),
    [sym__pipe_left_operator] = ACTIONS(13632),
    [sym__ellipsis_operator] = ACTIONS(13632),
    [sym__plus_operator] = ACTIONS(13632),
    [sym__times_operator] = ACTIONS(13632),
    [sym__rational_operator] = ACTIONS(13632),
    [sym__bitshift_operator] = ACTIONS(13632),
    [sym__power_operator] = ACTIONS(13632),
    [sym__tilde_operator] = ACTIONS(13632),
    [sym__type_order_operator] = ACTIONS(13632),
    [sym__unary_operator] = ACTIONS(13632),
    [sym__unary_plus_operator] = ACTIONS(13632),
    [aux_sym__terminator_token1] = ACTIONS(13632),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13634),
    [sym__command_start] = ACTIONS(13634),
  },
  [7510] = {
    [sym__word_identifier] = ACTIONS(13636),
    [anon_sym_EQ] = ACTIONS(13636),
    [anon_sym_COMMA] = ACTIONS(13636),
    [anon_sym_COLON] = ACTIONS(13636),
    [anon_sym_begin] = ACTIONS(13636),
    [anon_sym_module] = ACTIONS(13636),
    [anon_sym_baremodule] = ACTIONS(13636),
    [anon_sym_end] = ACTIONS(13636),
    [anon_sym_abstract] = ACTIONS(13636),
    [anon_sym_primitive] = ACTIONS(13636),
    [anon_sym_mutable] = ACTIONS(13636),
    [anon_sym_struct] = ACTIONS(13636),
    [anon_sym_function] = ACTIONS(13636),
    [anon_sym_macro] = ACTIONS(13636),
    [anon_sym_where] = ACTIONS(13636),
    [anon_sym_quote] = ACTIONS(13636),
    [anon_sym_let] = ACTIONS(13636),
    [anon_sym_if] = ACTIONS(13636),
    [anon_sym_else] = ACTIONS(13636),
    [anon_sym_try] = ACTIONS(13636),
    [anon_sym_finally] = ACTIONS(13636),
    [anon_sym_for] = ACTIONS(13636),
    [anon_sym_while] = ACTIONS(13636),
    [sym_break_statement] = ACTIONS(13636),
    [sym_continue_statement] = ACTIONS(13636),
    [anon_sym_return] = ACTIONS(13636),
    [anon_sym_const] = ACTIONS(13636),
    [anon_sym_global] = ACTIONS(13636),
    [anon_sym_local] = ACTIONS(13636),
    [anon_sym_LPAREN] = ACTIONS(13636),
    [anon_sym_COLON2] = ACTIONS(13636),
    [anon_sym_export] = ACTIONS(13636),
    [anon_sym_import] = ACTIONS(13636),
    [anon_sym_using] = ACTIONS(13636),
    [anon_sym_LBRACK] = ACTIONS(13636),
    [anon_sym_LF] = ACTIONS(13638),
    [anon_sym_in] = ACTIONS(13636),
    [anon_sym_LBRACE] = ACTIONS(13636),
    [anon_sym_DOLLAR] = ACTIONS(13636),
    [anon_sym_COLON_COLON] = ACTIONS(13636),
    [anon_sym_isa] = ACTIONS(13636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13636),
    [anon_sym_QMARK] = ACTIONS(13636),
    [anon_sym_AT] = ACTIONS(13636),
    [anon_sym_true] = ACTIONS(13636),
    [anon_sym_false] = ACTIONS(13636),
    [aux_sym_integer_literal_token1] = ACTIONS(13636),
    [aux_sym_integer_literal_token2] = ACTIONS(13636),
    [aux_sym_integer_literal_token3] = ACTIONS(13636),
    [aux_sym_integer_literal_token4] = ACTIONS(13636),
    [aux_sym_float_literal_token1] = ACTIONS(13636),
    [aux_sym_float_literal_token3] = ACTIONS(13636),
    [aux_sym_float_literal_token4] = ACTIONS(13636),
    [sym_character_literal] = ACTIONS(13636),
    [sym__pair_operator] = ACTIONS(13636),
    [sym__arrow_operator] = ACTIONS(13636),
    [sym__lazy_or_operator] = ACTIONS(13636),
    [sym__lazy_and_operator] = ACTIONS(13636),
    [sym__comparison_operator] = ACTIONS(13636),
    [sym__pipe_right_operator] = ACTIONS(13636),
    [sym__pipe_left_operator] = ACTIONS(13636),
    [sym__ellipsis_operator] = ACTIONS(13636),
    [sym__plus_operator] = ACTIONS(13636),
    [sym__times_operator] = ACTIONS(13636),
    [sym__rational_operator] = ACTIONS(13636),
    [sym__bitshift_operator] = ACTIONS(13636),
    [sym__power_operator] = ACTIONS(13636),
    [sym__tilde_operator] = ACTIONS(13636),
    [sym__type_order_operator] = ACTIONS(13636),
    [sym__unary_operator] = ACTIONS(13636),
    [sym__unary_plus_operator] = ACTIONS(13636),
    [aux_sym__terminator_token1] = ACTIONS(13636),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13638),
    [sym__command_start] = ACTIONS(13638),
  },
  [7511] = {
    [sym__word_identifier] = ACTIONS(13640),
    [anon_sym_EQ] = ACTIONS(13640),
    [anon_sym_COMMA] = ACTIONS(13640),
    [anon_sym_COLON] = ACTIONS(13640),
    [anon_sym_begin] = ACTIONS(13640),
    [anon_sym_module] = ACTIONS(13640),
    [anon_sym_baremodule] = ACTIONS(13640),
    [anon_sym_end] = ACTIONS(13640),
    [anon_sym_abstract] = ACTIONS(13640),
    [anon_sym_primitive] = ACTIONS(13640),
    [anon_sym_mutable] = ACTIONS(13640),
    [anon_sym_struct] = ACTIONS(13640),
    [anon_sym_function] = ACTIONS(13640),
    [anon_sym_macro] = ACTIONS(13640),
    [anon_sym_where] = ACTIONS(13640),
    [anon_sym_quote] = ACTIONS(13640),
    [anon_sym_let] = ACTIONS(13640),
    [anon_sym_if] = ACTIONS(13640),
    [anon_sym_else] = ACTIONS(13640),
    [anon_sym_try] = ACTIONS(13640),
    [anon_sym_finally] = ACTIONS(13640),
    [anon_sym_for] = ACTIONS(13640),
    [anon_sym_while] = ACTIONS(13640),
    [sym_break_statement] = ACTIONS(13640),
    [sym_continue_statement] = ACTIONS(13640),
    [anon_sym_return] = ACTIONS(13640),
    [anon_sym_const] = ACTIONS(13640),
    [anon_sym_global] = ACTIONS(13640),
    [anon_sym_local] = ACTIONS(13640),
    [anon_sym_LPAREN] = ACTIONS(13640),
    [anon_sym_COLON2] = ACTIONS(13640),
    [anon_sym_export] = ACTIONS(13640),
    [anon_sym_import] = ACTIONS(13640),
    [anon_sym_using] = ACTIONS(13640),
    [anon_sym_LBRACK] = ACTIONS(13640),
    [anon_sym_LF] = ACTIONS(13642),
    [anon_sym_in] = ACTIONS(13640),
    [anon_sym_LBRACE] = ACTIONS(13640),
    [anon_sym_DOLLAR] = ACTIONS(13640),
    [anon_sym_COLON_COLON] = ACTIONS(13640),
    [anon_sym_isa] = ACTIONS(13640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13640),
    [anon_sym_QMARK] = ACTIONS(13640),
    [anon_sym_AT] = ACTIONS(13640),
    [anon_sym_true] = ACTIONS(13640),
    [anon_sym_false] = ACTIONS(13640),
    [aux_sym_integer_literal_token1] = ACTIONS(13640),
    [aux_sym_integer_literal_token2] = ACTIONS(13640),
    [aux_sym_integer_literal_token3] = ACTIONS(13640),
    [aux_sym_integer_literal_token4] = ACTIONS(13640),
    [aux_sym_float_literal_token1] = ACTIONS(13640),
    [aux_sym_float_literal_token3] = ACTIONS(13640),
    [aux_sym_float_literal_token4] = ACTIONS(13640),
    [sym_character_literal] = ACTIONS(13640),
    [sym__pair_operator] = ACTIONS(13640),
    [sym__arrow_operator] = ACTIONS(13640),
    [sym__lazy_or_operator] = ACTIONS(13640),
    [sym__lazy_and_operator] = ACTIONS(13640),
    [sym__comparison_operator] = ACTIONS(13640),
    [sym__pipe_right_operator] = ACTIONS(13640),
    [sym__pipe_left_operator] = ACTIONS(13640),
    [sym__ellipsis_operator] = ACTIONS(13640),
    [sym__plus_operator] = ACTIONS(13640),
    [sym__times_operator] = ACTIONS(13640),
    [sym__rational_operator] = ACTIONS(13640),
    [sym__bitshift_operator] = ACTIONS(13640),
    [sym__power_operator] = ACTIONS(13640),
    [sym__tilde_operator] = ACTIONS(13640),
    [sym__type_order_operator] = ACTIONS(13640),
    [sym__unary_operator] = ACTIONS(13640),
    [sym__unary_plus_operator] = ACTIONS(13640),
    [aux_sym__terminator_token1] = ACTIONS(13640),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13642),
    [sym__command_start] = ACTIONS(13642),
  },
  [7512] = {
    [sym__word_identifier] = ACTIONS(13644),
    [anon_sym_EQ] = ACTIONS(13644),
    [anon_sym_COMMA] = ACTIONS(13644),
    [anon_sym_COLON] = ACTIONS(13644),
    [anon_sym_begin] = ACTIONS(13644),
    [anon_sym_module] = ACTIONS(13644),
    [anon_sym_baremodule] = ACTIONS(13644),
    [anon_sym_end] = ACTIONS(13644),
    [anon_sym_abstract] = ACTIONS(13644),
    [anon_sym_primitive] = ACTIONS(13644),
    [anon_sym_mutable] = ACTIONS(13644),
    [anon_sym_struct] = ACTIONS(13644),
    [anon_sym_function] = ACTIONS(13644),
    [anon_sym_macro] = ACTIONS(13644),
    [anon_sym_where] = ACTIONS(13644),
    [anon_sym_quote] = ACTIONS(13644),
    [anon_sym_let] = ACTIONS(13644),
    [anon_sym_if] = ACTIONS(13644),
    [anon_sym_else] = ACTIONS(13644),
    [anon_sym_try] = ACTIONS(13644),
    [anon_sym_finally] = ACTIONS(13644),
    [anon_sym_for] = ACTIONS(13644),
    [anon_sym_while] = ACTIONS(13644),
    [sym_break_statement] = ACTIONS(13644),
    [sym_continue_statement] = ACTIONS(13644),
    [anon_sym_return] = ACTIONS(13644),
    [anon_sym_const] = ACTIONS(13644),
    [anon_sym_global] = ACTIONS(13644),
    [anon_sym_local] = ACTIONS(13644),
    [anon_sym_LPAREN] = ACTIONS(13644),
    [anon_sym_COLON2] = ACTIONS(13644),
    [anon_sym_export] = ACTIONS(13644),
    [anon_sym_import] = ACTIONS(13644),
    [anon_sym_using] = ACTIONS(13644),
    [anon_sym_LBRACK] = ACTIONS(13644),
    [anon_sym_LF] = ACTIONS(13646),
    [anon_sym_in] = ACTIONS(13644),
    [anon_sym_LBRACE] = ACTIONS(13644),
    [anon_sym_DOLLAR] = ACTIONS(13644),
    [anon_sym_COLON_COLON] = ACTIONS(13644),
    [anon_sym_isa] = ACTIONS(13644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13644),
    [anon_sym_QMARK] = ACTIONS(13644),
    [anon_sym_AT] = ACTIONS(13644),
    [anon_sym_true] = ACTIONS(13644),
    [anon_sym_false] = ACTIONS(13644),
    [aux_sym_integer_literal_token1] = ACTIONS(13644),
    [aux_sym_integer_literal_token2] = ACTIONS(13644),
    [aux_sym_integer_literal_token3] = ACTIONS(13644),
    [aux_sym_integer_literal_token4] = ACTIONS(13644),
    [aux_sym_float_literal_token1] = ACTIONS(13644),
    [aux_sym_float_literal_token3] = ACTIONS(13644),
    [aux_sym_float_literal_token4] = ACTIONS(13644),
    [sym_character_literal] = ACTIONS(13644),
    [sym__pair_operator] = ACTIONS(13644),
    [sym__arrow_operator] = ACTIONS(13644),
    [sym__lazy_or_operator] = ACTIONS(13644),
    [sym__lazy_and_operator] = ACTIONS(13644),
    [sym__comparison_operator] = ACTIONS(13644),
    [sym__pipe_right_operator] = ACTIONS(13644),
    [sym__pipe_left_operator] = ACTIONS(13644),
    [sym__ellipsis_operator] = ACTIONS(13644),
    [sym__plus_operator] = ACTIONS(13644),
    [sym__times_operator] = ACTIONS(13644),
    [sym__rational_operator] = ACTIONS(13644),
    [sym__bitshift_operator] = ACTIONS(13644),
    [sym__power_operator] = ACTIONS(13644),
    [sym__tilde_operator] = ACTIONS(13644),
    [sym__type_order_operator] = ACTIONS(13644),
    [sym__unary_operator] = ACTIONS(13644),
    [sym__unary_plus_operator] = ACTIONS(13644),
    [aux_sym__terminator_token1] = ACTIONS(13644),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13646),
    [sym__command_start] = ACTIONS(13646),
  },
  [7513] = {
    [sym__word_identifier] = ACTIONS(13648),
    [anon_sym_EQ] = ACTIONS(13648),
    [anon_sym_COMMA] = ACTIONS(13648),
    [anon_sym_COLON] = ACTIONS(13648),
    [anon_sym_begin] = ACTIONS(13648),
    [anon_sym_module] = ACTIONS(13648),
    [anon_sym_baremodule] = ACTIONS(13648),
    [anon_sym_end] = ACTIONS(13648),
    [anon_sym_abstract] = ACTIONS(13648),
    [anon_sym_primitive] = ACTIONS(13648),
    [anon_sym_mutable] = ACTIONS(13648),
    [anon_sym_struct] = ACTIONS(13648),
    [anon_sym_function] = ACTIONS(13648),
    [anon_sym_macro] = ACTIONS(13648),
    [anon_sym_where] = ACTIONS(13648),
    [anon_sym_quote] = ACTIONS(13648),
    [anon_sym_let] = ACTIONS(13648),
    [anon_sym_if] = ACTIONS(13648),
    [anon_sym_else] = ACTIONS(13648),
    [anon_sym_try] = ACTIONS(13648),
    [anon_sym_finally] = ACTIONS(13648),
    [anon_sym_for] = ACTIONS(13648),
    [anon_sym_while] = ACTIONS(13648),
    [sym_break_statement] = ACTIONS(13648),
    [sym_continue_statement] = ACTIONS(13648),
    [anon_sym_return] = ACTIONS(13648),
    [anon_sym_const] = ACTIONS(13648),
    [anon_sym_global] = ACTIONS(13648),
    [anon_sym_local] = ACTIONS(13648),
    [anon_sym_LPAREN] = ACTIONS(13648),
    [anon_sym_COLON2] = ACTIONS(13648),
    [anon_sym_export] = ACTIONS(13648),
    [anon_sym_import] = ACTIONS(13648),
    [anon_sym_using] = ACTIONS(13648),
    [anon_sym_LBRACK] = ACTIONS(13648),
    [anon_sym_LF] = ACTIONS(13650),
    [anon_sym_in] = ACTIONS(13648),
    [anon_sym_LBRACE] = ACTIONS(13648),
    [anon_sym_DOLLAR] = ACTIONS(13648),
    [anon_sym_COLON_COLON] = ACTIONS(13648),
    [anon_sym_isa] = ACTIONS(13648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13648),
    [anon_sym_QMARK] = ACTIONS(13648),
    [anon_sym_AT] = ACTIONS(13648),
    [anon_sym_true] = ACTIONS(13648),
    [anon_sym_false] = ACTIONS(13648),
    [aux_sym_integer_literal_token1] = ACTIONS(13648),
    [aux_sym_integer_literal_token2] = ACTIONS(13648),
    [aux_sym_integer_literal_token3] = ACTIONS(13648),
    [aux_sym_integer_literal_token4] = ACTIONS(13648),
    [aux_sym_float_literal_token1] = ACTIONS(13648),
    [aux_sym_float_literal_token3] = ACTIONS(13648),
    [aux_sym_float_literal_token4] = ACTIONS(13648),
    [sym_character_literal] = ACTIONS(13648),
    [sym__pair_operator] = ACTIONS(13648),
    [sym__arrow_operator] = ACTIONS(13648),
    [sym__lazy_or_operator] = ACTIONS(13648),
    [sym__lazy_and_operator] = ACTIONS(13648),
    [sym__comparison_operator] = ACTIONS(13648),
    [sym__pipe_right_operator] = ACTIONS(13648),
    [sym__pipe_left_operator] = ACTIONS(13648),
    [sym__ellipsis_operator] = ACTIONS(13648),
    [sym__plus_operator] = ACTIONS(13648),
    [sym__times_operator] = ACTIONS(13648),
    [sym__rational_operator] = ACTIONS(13648),
    [sym__bitshift_operator] = ACTIONS(13648),
    [sym__power_operator] = ACTIONS(13648),
    [sym__tilde_operator] = ACTIONS(13648),
    [sym__type_order_operator] = ACTIONS(13648),
    [sym__unary_operator] = ACTIONS(13648),
    [sym__unary_plus_operator] = ACTIONS(13648),
    [aux_sym__terminator_token1] = ACTIONS(13648),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13650),
    [sym__command_start] = ACTIONS(13650),
  },
  [7514] = {
    [sym__word_identifier] = ACTIONS(13652),
    [anon_sym_EQ] = ACTIONS(13652),
    [anon_sym_COMMA] = ACTIONS(13652),
    [anon_sym_COLON] = ACTIONS(13652),
    [anon_sym_begin] = ACTIONS(13652),
    [anon_sym_module] = ACTIONS(13652),
    [anon_sym_baremodule] = ACTIONS(13652),
    [anon_sym_end] = ACTIONS(13652),
    [anon_sym_abstract] = ACTIONS(13652),
    [anon_sym_primitive] = ACTIONS(13652),
    [anon_sym_mutable] = ACTIONS(13652),
    [anon_sym_struct] = ACTIONS(13652),
    [anon_sym_function] = ACTIONS(13652),
    [anon_sym_macro] = ACTIONS(13652),
    [anon_sym_where] = ACTIONS(13652),
    [anon_sym_quote] = ACTIONS(13652),
    [anon_sym_let] = ACTIONS(13652),
    [anon_sym_if] = ACTIONS(13652),
    [anon_sym_else] = ACTIONS(13652),
    [anon_sym_try] = ACTIONS(13652),
    [anon_sym_finally] = ACTIONS(13652),
    [anon_sym_for] = ACTIONS(13652),
    [anon_sym_while] = ACTIONS(13652),
    [sym_break_statement] = ACTIONS(13652),
    [sym_continue_statement] = ACTIONS(13652),
    [anon_sym_return] = ACTIONS(13652),
    [anon_sym_const] = ACTIONS(13652),
    [anon_sym_global] = ACTIONS(13652),
    [anon_sym_local] = ACTIONS(13652),
    [anon_sym_LPAREN] = ACTIONS(13652),
    [anon_sym_COLON2] = ACTIONS(13652),
    [anon_sym_export] = ACTIONS(13652),
    [anon_sym_import] = ACTIONS(13652),
    [anon_sym_using] = ACTIONS(13652),
    [anon_sym_LBRACK] = ACTIONS(13652),
    [anon_sym_LF] = ACTIONS(13654),
    [anon_sym_in] = ACTIONS(13652),
    [anon_sym_LBRACE] = ACTIONS(13652),
    [anon_sym_DOLLAR] = ACTIONS(13652),
    [anon_sym_COLON_COLON] = ACTIONS(13652),
    [anon_sym_isa] = ACTIONS(13652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13652),
    [anon_sym_QMARK] = ACTIONS(13652),
    [anon_sym_AT] = ACTIONS(13652),
    [anon_sym_true] = ACTIONS(13652),
    [anon_sym_false] = ACTIONS(13652),
    [aux_sym_integer_literal_token1] = ACTIONS(13652),
    [aux_sym_integer_literal_token2] = ACTIONS(13652),
    [aux_sym_integer_literal_token3] = ACTIONS(13652),
    [aux_sym_integer_literal_token4] = ACTIONS(13652),
    [aux_sym_float_literal_token1] = ACTIONS(13652),
    [aux_sym_float_literal_token3] = ACTIONS(13652),
    [aux_sym_float_literal_token4] = ACTIONS(13652),
    [sym_character_literal] = ACTIONS(13652),
    [sym__pair_operator] = ACTIONS(13652),
    [sym__arrow_operator] = ACTIONS(13652),
    [sym__lazy_or_operator] = ACTIONS(13652),
    [sym__lazy_and_operator] = ACTIONS(13652),
    [sym__comparison_operator] = ACTIONS(13652),
    [sym__pipe_right_operator] = ACTIONS(13652),
    [sym__pipe_left_operator] = ACTIONS(13652),
    [sym__ellipsis_operator] = ACTIONS(13652),
    [sym__plus_operator] = ACTIONS(13652),
    [sym__times_operator] = ACTIONS(13652),
    [sym__rational_operator] = ACTIONS(13652),
    [sym__bitshift_operator] = ACTIONS(13652),
    [sym__power_operator] = ACTIONS(13652),
    [sym__tilde_operator] = ACTIONS(13652),
    [sym__type_order_operator] = ACTIONS(13652),
    [sym__unary_operator] = ACTIONS(13652),
    [sym__unary_plus_operator] = ACTIONS(13652),
    [aux_sym__terminator_token1] = ACTIONS(13652),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13654),
    [sym__command_start] = ACTIONS(13654),
  },
  [7515] = {
    [sym__word_identifier] = ACTIONS(13656),
    [anon_sym_EQ] = ACTIONS(13656),
    [anon_sym_COMMA] = ACTIONS(13656),
    [anon_sym_COLON] = ACTIONS(13656),
    [anon_sym_begin] = ACTIONS(13656),
    [anon_sym_module] = ACTIONS(13656),
    [anon_sym_baremodule] = ACTIONS(13656),
    [anon_sym_end] = ACTIONS(13656),
    [anon_sym_abstract] = ACTIONS(13656),
    [anon_sym_primitive] = ACTIONS(13656),
    [anon_sym_mutable] = ACTIONS(13656),
    [anon_sym_struct] = ACTIONS(13656),
    [anon_sym_function] = ACTIONS(13656),
    [anon_sym_macro] = ACTIONS(13656),
    [anon_sym_where] = ACTIONS(13656),
    [anon_sym_quote] = ACTIONS(13656),
    [anon_sym_let] = ACTIONS(13656),
    [anon_sym_if] = ACTIONS(13656),
    [anon_sym_else] = ACTIONS(13656),
    [anon_sym_try] = ACTIONS(13656),
    [anon_sym_finally] = ACTIONS(13656),
    [anon_sym_for] = ACTIONS(13656),
    [anon_sym_while] = ACTIONS(13656),
    [sym_break_statement] = ACTIONS(13656),
    [sym_continue_statement] = ACTIONS(13656),
    [anon_sym_return] = ACTIONS(13656),
    [anon_sym_const] = ACTIONS(13656),
    [anon_sym_global] = ACTIONS(13656),
    [anon_sym_local] = ACTIONS(13656),
    [anon_sym_LPAREN] = ACTIONS(13656),
    [anon_sym_COLON2] = ACTIONS(13656),
    [anon_sym_export] = ACTIONS(13656),
    [anon_sym_import] = ACTIONS(13656),
    [anon_sym_using] = ACTIONS(13656),
    [anon_sym_LBRACK] = ACTIONS(13656),
    [anon_sym_LF] = ACTIONS(13658),
    [anon_sym_in] = ACTIONS(13656),
    [anon_sym_LBRACE] = ACTIONS(13656),
    [anon_sym_DOLLAR] = ACTIONS(13656),
    [anon_sym_COLON_COLON] = ACTIONS(13656),
    [anon_sym_isa] = ACTIONS(13656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13656),
    [anon_sym_QMARK] = ACTIONS(13656),
    [anon_sym_AT] = ACTIONS(13656),
    [anon_sym_true] = ACTIONS(13656),
    [anon_sym_false] = ACTIONS(13656),
    [aux_sym_integer_literal_token1] = ACTIONS(13656),
    [aux_sym_integer_literal_token2] = ACTIONS(13656),
    [aux_sym_integer_literal_token3] = ACTIONS(13656),
    [aux_sym_integer_literal_token4] = ACTIONS(13656),
    [aux_sym_float_literal_token1] = ACTIONS(13656),
    [aux_sym_float_literal_token3] = ACTIONS(13656),
    [aux_sym_float_literal_token4] = ACTIONS(13656),
    [sym_character_literal] = ACTIONS(13656),
    [sym__pair_operator] = ACTIONS(13656),
    [sym__arrow_operator] = ACTIONS(13656),
    [sym__lazy_or_operator] = ACTIONS(13656),
    [sym__lazy_and_operator] = ACTIONS(13656),
    [sym__comparison_operator] = ACTIONS(13656),
    [sym__pipe_right_operator] = ACTIONS(13656),
    [sym__pipe_left_operator] = ACTIONS(13656),
    [sym__ellipsis_operator] = ACTIONS(13656),
    [sym__plus_operator] = ACTIONS(13656),
    [sym__times_operator] = ACTIONS(13656),
    [sym__rational_operator] = ACTIONS(13656),
    [sym__bitshift_operator] = ACTIONS(13656),
    [sym__power_operator] = ACTIONS(13656),
    [sym__tilde_operator] = ACTIONS(13656),
    [sym__type_order_operator] = ACTIONS(13656),
    [sym__unary_operator] = ACTIONS(13656),
    [sym__unary_plus_operator] = ACTIONS(13656),
    [aux_sym__terminator_token1] = ACTIONS(13656),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13658),
    [sym__command_start] = ACTIONS(13658),
  },
  [7516] = {
    [sym__word_identifier] = ACTIONS(13660),
    [anon_sym_EQ] = ACTIONS(13660),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_COLON] = ACTIONS(13660),
    [anon_sym_begin] = ACTIONS(13660),
    [anon_sym_module] = ACTIONS(13660),
    [anon_sym_baremodule] = ACTIONS(13660),
    [anon_sym_end] = ACTIONS(13660),
    [anon_sym_abstract] = ACTIONS(13660),
    [anon_sym_primitive] = ACTIONS(13660),
    [anon_sym_mutable] = ACTIONS(13660),
    [anon_sym_struct] = ACTIONS(13660),
    [anon_sym_function] = ACTIONS(13660),
    [anon_sym_macro] = ACTIONS(13660),
    [anon_sym_where] = ACTIONS(13660),
    [anon_sym_quote] = ACTIONS(13660),
    [anon_sym_let] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_else] = ACTIONS(13660),
    [anon_sym_try] = ACTIONS(13660),
    [anon_sym_finally] = ACTIONS(13660),
    [anon_sym_for] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [sym_break_statement] = ACTIONS(13660),
    [sym_continue_statement] = ACTIONS(13660),
    [anon_sym_return] = ACTIONS(13660),
    [anon_sym_const] = ACTIONS(13660),
    [anon_sym_global] = ACTIONS(13660),
    [anon_sym_local] = ACTIONS(13660),
    [anon_sym_LPAREN] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13660),
    [anon_sym_export] = ACTIONS(13660),
    [anon_sym_import] = ACTIONS(13660),
    [anon_sym_using] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_LF] = ACTIONS(13662),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_DOLLAR] = ACTIONS(13660),
    [anon_sym_COLON_COLON] = ACTIONS(13660),
    [anon_sym_isa] = ACTIONS(13660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_AT] = ACTIONS(13660),
    [anon_sym_true] = ACTIONS(13660),
    [anon_sym_false] = ACTIONS(13660),
    [aux_sym_integer_literal_token1] = ACTIONS(13660),
    [aux_sym_integer_literal_token2] = ACTIONS(13660),
    [aux_sym_integer_literal_token3] = ACTIONS(13660),
    [aux_sym_integer_literal_token4] = ACTIONS(13660),
    [aux_sym_float_literal_token1] = ACTIONS(13660),
    [aux_sym_float_literal_token3] = ACTIONS(13660),
    [aux_sym_float_literal_token4] = ACTIONS(13660),
    [sym_character_literal] = ACTIONS(13660),
    [sym__pair_operator] = ACTIONS(13660),
    [sym__arrow_operator] = ACTIONS(13660),
    [sym__lazy_or_operator] = ACTIONS(13660),
    [sym__lazy_and_operator] = ACTIONS(13660),
    [sym__comparison_operator] = ACTIONS(13660),
    [sym__pipe_right_operator] = ACTIONS(13660),
    [sym__pipe_left_operator] = ACTIONS(13660),
    [sym__ellipsis_operator] = ACTIONS(13660),
    [sym__plus_operator] = ACTIONS(13660),
    [sym__times_operator] = ACTIONS(13660),
    [sym__rational_operator] = ACTIONS(13660),
    [sym__bitshift_operator] = ACTIONS(13660),
    [sym__power_operator] = ACTIONS(13660),
    [sym__tilde_operator] = ACTIONS(13660),
    [sym__type_order_operator] = ACTIONS(13660),
    [sym__unary_operator] = ACTIONS(13660),
    [sym__unary_plus_operator] = ACTIONS(13660),
    [aux_sym__terminator_token1] = ACTIONS(13660),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13662),
    [sym__command_start] = ACTIONS(13662),
  },
  [7517] = {
    [sym__word_identifier] = ACTIONS(13664),
    [anon_sym_EQ] = ACTIONS(13664),
    [anon_sym_COMMA] = ACTIONS(13664),
    [anon_sym_COLON] = ACTIONS(13664),
    [anon_sym_begin] = ACTIONS(13664),
    [anon_sym_module] = ACTIONS(13664),
    [anon_sym_baremodule] = ACTIONS(13664),
    [anon_sym_end] = ACTIONS(13664),
    [anon_sym_abstract] = ACTIONS(13664),
    [anon_sym_primitive] = ACTIONS(13664),
    [anon_sym_mutable] = ACTIONS(13664),
    [anon_sym_struct] = ACTIONS(13664),
    [anon_sym_function] = ACTIONS(13664),
    [anon_sym_macro] = ACTIONS(13664),
    [anon_sym_where] = ACTIONS(13664),
    [anon_sym_quote] = ACTIONS(13664),
    [anon_sym_let] = ACTIONS(13664),
    [anon_sym_if] = ACTIONS(13664),
    [anon_sym_else] = ACTIONS(13664),
    [anon_sym_try] = ACTIONS(13664),
    [anon_sym_finally] = ACTIONS(13664),
    [anon_sym_for] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(13664),
    [sym_break_statement] = ACTIONS(13664),
    [sym_continue_statement] = ACTIONS(13664),
    [anon_sym_return] = ACTIONS(13664),
    [anon_sym_const] = ACTIONS(13664),
    [anon_sym_global] = ACTIONS(13664),
    [anon_sym_local] = ACTIONS(13664),
    [anon_sym_LPAREN] = ACTIONS(13664),
    [anon_sym_COLON2] = ACTIONS(13664),
    [anon_sym_export] = ACTIONS(13664),
    [anon_sym_import] = ACTIONS(13664),
    [anon_sym_using] = ACTIONS(13664),
    [anon_sym_LBRACK] = ACTIONS(13664),
    [anon_sym_LF] = ACTIONS(13666),
    [anon_sym_in] = ACTIONS(13664),
    [anon_sym_LBRACE] = ACTIONS(13664),
    [anon_sym_DOLLAR] = ACTIONS(13664),
    [anon_sym_COLON_COLON] = ACTIONS(13664),
    [anon_sym_isa] = ACTIONS(13664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13664),
    [anon_sym_QMARK] = ACTIONS(13664),
    [anon_sym_AT] = ACTIONS(13664),
    [anon_sym_true] = ACTIONS(13664),
    [anon_sym_false] = ACTIONS(13664),
    [aux_sym_integer_literal_token1] = ACTIONS(13664),
    [aux_sym_integer_literal_token2] = ACTIONS(13664),
    [aux_sym_integer_literal_token3] = ACTIONS(13664),
    [aux_sym_integer_literal_token4] = ACTIONS(13664),
    [aux_sym_float_literal_token1] = ACTIONS(13664),
    [aux_sym_float_literal_token3] = ACTIONS(13664),
    [aux_sym_float_literal_token4] = ACTIONS(13664),
    [sym_character_literal] = ACTIONS(13664),
    [sym__pair_operator] = ACTIONS(13664),
    [sym__arrow_operator] = ACTIONS(13664),
    [sym__lazy_or_operator] = ACTIONS(13664),
    [sym__lazy_and_operator] = ACTIONS(13664),
    [sym__comparison_operator] = ACTIONS(13664),
    [sym__pipe_right_operator] = ACTIONS(13664),
    [sym__pipe_left_operator] = ACTIONS(13664),
    [sym__ellipsis_operator] = ACTIONS(13664),
    [sym__plus_operator] = ACTIONS(13664),
    [sym__times_operator] = ACTIONS(13664),
    [sym__rational_operator] = ACTIONS(13664),
    [sym__bitshift_operator] = ACTIONS(13664),
    [sym__power_operator] = ACTIONS(13664),
    [sym__tilde_operator] = ACTIONS(13664),
    [sym__type_order_operator] = ACTIONS(13664),
    [sym__unary_operator] = ACTIONS(13664),
    [sym__unary_plus_operator] = ACTIONS(13664),
    [aux_sym__terminator_token1] = ACTIONS(13664),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13666),
    [sym__command_start] = ACTIONS(13666),
  },
  [7518] = {
    [sym__word_identifier] = ACTIONS(13499),
    [anon_sym_EQ] = ACTIONS(13499),
    [anon_sym_COMMA] = ACTIONS(13499),
    [anon_sym_COLON] = ACTIONS(13499),
    [anon_sym_begin] = ACTIONS(13499),
    [anon_sym_module] = ACTIONS(13499),
    [anon_sym_baremodule] = ACTIONS(13499),
    [anon_sym_end] = ACTIONS(13499),
    [anon_sym_abstract] = ACTIONS(13499),
    [anon_sym_primitive] = ACTIONS(13499),
    [anon_sym_mutable] = ACTIONS(13499),
    [anon_sym_struct] = ACTIONS(13499),
    [anon_sym_function] = ACTIONS(13499),
    [anon_sym_macro] = ACTIONS(13499),
    [anon_sym_where] = ACTIONS(13499),
    [anon_sym_quote] = ACTIONS(13499),
    [anon_sym_let] = ACTIONS(13499),
    [anon_sym_if] = ACTIONS(13499),
    [anon_sym_elseif] = ACTIONS(13499),
    [anon_sym_else] = ACTIONS(13499),
    [anon_sym_try] = ACTIONS(13499),
    [anon_sym_for] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(13499),
    [sym_break_statement] = ACTIONS(13499),
    [sym_continue_statement] = ACTIONS(13499),
    [anon_sym_return] = ACTIONS(13499),
    [anon_sym_const] = ACTIONS(13499),
    [anon_sym_global] = ACTIONS(13499),
    [anon_sym_local] = ACTIONS(13499),
    [anon_sym_LPAREN] = ACTIONS(13499),
    [anon_sym_COLON2] = ACTIONS(13499),
    [anon_sym_export] = ACTIONS(13499),
    [anon_sym_import] = ACTIONS(13499),
    [anon_sym_using] = ACTIONS(13499),
    [anon_sym_LBRACK] = ACTIONS(13499),
    [anon_sym_LF] = ACTIONS(13501),
    [anon_sym_in] = ACTIONS(13499),
    [anon_sym_LBRACE] = ACTIONS(13499),
    [anon_sym_DOLLAR] = ACTIONS(13499),
    [anon_sym_COLON_COLON] = ACTIONS(13499),
    [anon_sym_isa] = ACTIONS(13499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13499),
    [anon_sym_QMARK] = ACTIONS(13499),
    [anon_sym_AT] = ACTIONS(13499),
    [anon_sym_true] = ACTIONS(13499),
    [anon_sym_false] = ACTIONS(13499),
    [aux_sym_integer_literal_token1] = ACTIONS(13499),
    [aux_sym_integer_literal_token2] = ACTIONS(13499),
    [aux_sym_integer_literal_token3] = ACTIONS(13499),
    [aux_sym_integer_literal_token4] = ACTIONS(13499),
    [aux_sym_float_literal_token1] = ACTIONS(13499),
    [aux_sym_float_literal_token3] = ACTIONS(13499),
    [aux_sym_float_literal_token4] = ACTIONS(13499),
    [sym_character_literal] = ACTIONS(13499),
    [sym__pair_operator] = ACTIONS(13499),
    [sym__arrow_operator] = ACTIONS(13499),
    [sym__lazy_or_operator] = ACTIONS(13499),
    [sym__lazy_and_operator] = ACTIONS(13499),
    [sym__comparison_operator] = ACTIONS(13499),
    [sym__pipe_right_operator] = ACTIONS(13499),
    [sym__pipe_left_operator] = ACTIONS(13499),
    [sym__ellipsis_operator] = ACTIONS(13499),
    [sym__plus_operator] = ACTIONS(13499),
    [sym__times_operator] = ACTIONS(13499),
    [sym__rational_operator] = ACTIONS(13499),
    [sym__bitshift_operator] = ACTIONS(13499),
    [sym__power_operator] = ACTIONS(13499),
    [sym__tilde_operator] = ACTIONS(13499),
    [sym__type_order_operator] = ACTIONS(13499),
    [sym__unary_operator] = ACTIONS(13499),
    [sym__unary_plus_operator] = ACTIONS(13499),
    [aux_sym__terminator_token1] = ACTIONS(13499),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13501),
    [sym__command_start] = ACTIONS(13501),
  },
  [7519] = {
    [sym__word_identifier] = ACTIONS(13506),
    [anon_sym_EQ] = ACTIONS(13506),
    [anon_sym_COMMA] = ACTIONS(13506),
    [anon_sym_COLON] = ACTIONS(13506),
    [anon_sym_begin] = ACTIONS(13506),
    [anon_sym_module] = ACTIONS(13506),
    [anon_sym_baremodule] = ACTIONS(13506),
    [anon_sym_end] = ACTIONS(13506),
    [anon_sym_abstract] = ACTIONS(13506),
    [anon_sym_primitive] = ACTIONS(13506),
    [anon_sym_mutable] = ACTIONS(13506),
    [anon_sym_struct] = ACTIONS(13506),
    [anon_sym_function] = ACTIONS(13506),
    [anon_sym_macro] = ACTIONS(13506),
    [anon_sym_where] = ACTIONS(13506),
    [anon_sym_quote] = ACTIONS(13506),
    [anon_sym_let] = ACTIONS(13506),
    [anon_sym_if] = ACTIONS(13506),
    [anon_sym_elseif] = ACTIONS(13506),
    [anon_sym_else] = ACTIONS(13506),
    [anon_sym_try] = ACTIONS(13506),
    [anon_sym_for] = ACTIONS(13506),
    [anon_sym_while] = ACTIONS(13506),
    [sym_break_statement] = ACTIONS(13506),
    [sym_continue_statement] = ACTIONS(13506),
    [anon_sym_return] = ACTIONS(13506),
    [anon_sym_const] = ACTIONS(13506),
    [anon_sym_global] = ACTIONS(13506),
    [anon_sym_local] = ACTIONS(13506),
    [anon_sym_LPAREN] = ACTIONS(13506),
    [anon_sym_COLON2] = ACTIONS(13506),
    [anon_sym_export] = ACTIONS(13506),
    [anon_sym_import] = ACTIONS(13506),
    [anon_sym_using] = ACTIONS(13506),
    [anon_sym_LBRACK] = ACTIONS(13506),
    [anon_sym_LF] = ACTIONS(13508),
    [anon_sym_in] = ACTIONS(13506),
    [anon_sym_LBRACE] = ACTIONS(13506),
    [anon_sym_DOLLAR] = ACTIONS(13506),
    [anon_sym_COLON_COLON] = ACTIONS(13506),
    [anon_sym_isa] = ACTIONS(13506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13506),
    [anon_sym_QMARK] = ACTIONS(13506),
    [anon_sym_AT] = ACTIONS(13506),
    [anon_sym_true] = ACTIONS(13506),
    [anon_sym_false] = ACTIONS(13506),
    [aux_sym_integer_literal_token1] = ACTIONS(13506),
    [aux_sym_integer_literal_token2] = ACTIONS(13506),
    [aux_sym_integer_literal_token3] = ACTIONS(13506),
    [aux_sym_integer_literal_token4] = ACTIONS(13506),
    [aux_sym_float_literal_token1] = ACTIONS(13506),
    [aux_sym_float_literal_token3] = ACTIONS(13506),
    [aux_sym_float_literal_token4] = ACTIONS(13506),
    [sym_character_literal] = ACTIONS(13506),
    [sym__pair_operator] = ACTIONS(13506),
    [sym__arrow_operator] = ACTIONS(13506),
    [sym__lazy_or_operator] = ACTIONS(13506),
    [sym__lazy_and_operator] = ACTIONS(13506),
    [sym__comparison_operator] = ACTIONS(13506),
    [sym__pipe_right_operator] = ACTIONS(13506),
    [sym__pipe_left_operator] = ACTIONS(13506),
    [sym__ellipsis_operator] = ACTIONS(13506),
    [sym__plus_operator] = ACTIONS(13506),
    [sym__times_operator] = ACTIONS(13506),
    [sym__rational_operator] = ACTIONS(13506),
    [sym__bitshift_operator] = ACTIONS(13506),
    [sym__power_operator] = ACTIONS(13506),
    [sym__tilde_operator] = ACTIONS(13506),
    [sym__type_order_operator] = ACTIONS(13506),
    [sym__unary_operator] = ACTIONS(13506),
    [sym__unary_plus_operator] = ACTIONS(13506),
    [aux_sym__terminator_token1] = ACTIONS(13506),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13508),
    [sym__command_start] = ACTIONS(13508),
  },
  [7520] = {
    [sym__word_identifier] = ACTIONS(13510),
    [anon_sym_EQ] = ACTIONS(13510),
    [anon_sym_COMMA] = ACTIONS(13510),
    [anon_sym_COLON] = ACTIONS(13510),
    [anon_sym_begin] = ACTIONS(13510),
    [anon_sym_module] = ACTIONS(13510),
    [anon_sym_baremodule] = ACTIONS(13510),
    [anon_sym_end] = ACTIONS(13510),
    [anon_sym_abstract] = ACTIONS(13510),
    [anon_sym_primitive] = ACTIONS(13510),
    [anon_sym_mutable] = ACTIONS(13510),
    [anon_sym_struct] = ACTIONS(13510),
    [anon_sym_function] = ACTIONS(13510),
    [anon_sym_macro] = ACTIONS(13510),
    [anon_sym_where] = ACTIONS(13510),
    [anon_sym_quote] = ACTIONS(13510),
    [anon_sym_let] = ACTIONS(13510),
    [anon_sym_if] = ACTIONS(13510),
    [anon_sym_elseif] = ACTIONS(13510),
    [anon_sym_else] = ACTIONS(13510),
    [anon_sym_try] = ACTIONS(13510),
    [anon_sym_for] = ACTIONS(13510),
    [anon_sym_while] = ACTIONS(13510),
    [sym_break_statement] = ACTIONS(13510),
    [sym_continue_statement] = ACTIONS(13510),
    [anon_sym_return] = ACTIONS(13510),
    [anon_sym_const] = ACTIONS(13510),
    [anon_sym_global] = ACTIONS(13510),
    [anon_sym_local] = ACTIONS(13510),
    [anon_sym_LPAREN] = ACTIONS(13510),
    [anon_sym_COLON2] = ACTIONS(13510),
    [anon_sym_export] = ACTIONS(13510),
    [anon_sym_import] = ACTIONS(13510),
    [anon_sym_using] = ACTIONS(13510),
    [anon_sym_LBRACK] = ACTIONS(13510),
    [anon_sym_LF] = ACTIONS(13512),
    [anon_sym_in] = ACTIONS(13510),
    [anon_sym_LBRACE] = ACTIONS(13510),
    [anon_sym_DOLLAR] = ACTIONS(13510),
    [anon_sym_COLON_COLON] = ACTIONS(13510),
    [anon_sym_isa] = ACTIONS(13510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13510),
    [anon_sym_QMARK] = ACTIONS(13510),
    [anon_sym_AT] = ACTIONS(13510),
    [anon_sym_true] = ACTIONS(13510),
    [anon_sym_false] = ACTIONS(13510),
    [aux_sym_integer_literal_token1] = ACTIONS(13510),
    [aux_sym_integer_literal_token2] = ACTIONS(13510),
    [aux_sym_integer_literal_token3] = ACTIONS(13510),
    [aux_sym_integer_literal_token4] = ACTIONS(13510),
    [aux_sym_float_literal_token1] = ACTIONS(13510),
    [aux_sym_float_literal_token3] = ACTIONS(13510),
    [aux_sym_float_literal_token4] = ACTIONS(13510),
    [sym_character_literal] = ACTIONS(13510),
    [sym__pair_operator] = ACTIONS(13510),
    [sym__arrow_operator] = ACTIONS(13510),
    [sym__lazy_or_operator] = ACTIONS(13510),
    [sym__lazy_and_operator] = ACTIONS(13510),
    [sym__comparison_operator] = ACTIONS(13510),
    [sym__pipe_right_operator] = ACTIONS(13510),
    [sym__pipe_left_operator] = ACTIONS(13510),
    [sym__ellipsis_operator] = ACTIONS(13510),
    [sym__plus_operator] = ACTIONS(13510),
    [sym__times_operator] = ACTIONS(13510),
    [sym__rational_operator] = ACTIONS(13510),
    [sym__bitshift_operator] = ACTIONS(13510),
    [sym__power_operator] = ACTIONS(13510),
    [sym__tilde_operator] = ACTIONS(13510),
    [sym__type_order_operator] = ACTIONS(13510),
    [sym__unary_operator] = ACTIONS(13510),
    [sym__unary_plus_operator] = ACTIONS(13510),
    [aux_sym__terminator_token1] = ACTIONS(13510),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13512),
    [sym__command_start] = ACTIONS(13512),
  },
  [7521] = {
    [sym__word_identifier] = ACTIONS(13514),
    [anon_sym_EQ] = ACTIONS(13514),
    [anon_sym_COMMA] = ACTIONS(13514),
    [anon_sym_COLON] = ACTIONS(13514),
    [anon_sym_begin] = ACTIONS(13514),
    [anon_sym_module] = ACTIONS(13514),
    [anon_sym_baremodule] = ACTIONS(13514),
    [anon_sym_end] = ACTIONS(13514),
    [anon_sym_abstract] = ACTIONS(13514),
    [anon_sym_primitive] = ACTIONS(13514),
    [anon_sym_mutable] = ACTIONS(13514),
    [anon_sym_struct] = ACTIONS(13514),
    [anon_sym_function] = ACTIONS(13514),
    [anon_sym_macro] = ACTIONS(13514),
    [anon_sym_where] = ACTIONS(13514),
    [anon_sym_quote] = ACTIONS(13514),
    [anon_sym_let] = ACTIONS(13514),
    [anon_sym_if] = ACTIONS(13514),
    [anon_sym_elseif] = ACTIONS(13514),
    [anon_sym_else] = ACTIONS(13514),
    [anon_sym_try] = ACTIONS(13514),
    [anon_sym_for] = ACTIONS(13514),
    [anon_sym_while] = ACTIONS(13514),
    [sym_break_statement] = ACTIONS(13514),
    [sym_continue_statement] = ACTIONS(13514),
    [anon_sym_return] = ACTIONS(13514),
    [anon_sym_const] = ACTIONS(13514),
    [anon_sym_global] = ACTIONS(13514),
    [anon_sym_local] = ACTIONS(13514),
    [anon_sym_LPAREN] = ACTIONS(13514),
    [anon_sym_COLON2] = ACTIONS(13514),
    [anon_sym_export] = ACTIONS(13514),
    [anon_sym_import] = ACTIONS(13514),
    [anon_sym_using] = ACTIONS(13514),
    [anon_sym_LBRACK] = ACTIONS(13514),
    [anon_sym_LF] = ACTIONS(13516),
    [anon_sym_in] = ACTIONS(13514),
    [anon_sym_LBRACE] = ACTIONS(13514),
    [anon_sym_DOLLAR] = ACTIONS(13514),
    [anon_sym_COLON_COLON] = ACTIONS(13514),
    [anon_sym_isa] = ACTIONS(13514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13514),
    [anon_sym_QMARK] = ACTIONS(13514),
    [anon_sym_AT] = ACTIONS(13514),
    [anon_sym_true] = ACTIONS(13514),
    [anon_sym_false] = ACTIONS(13514),
    [aux_sym_integer_literal_token1] = ACTIONS(13514),
    [aux_sym_integer_literal_token2] = ACTIONS(13514),
    [aux_sym_integer_literal_token3] = ACTIONS(13514),
    [aux_sym_integer_literal_token4] = ACTIONS(13514),
    [aux_sym_float_literal_token1] = ACTIONS(13514),
    [aux_sym_float_literal_token3] = ACTIONS(13514),
    [aux_sym_float_literal_token4] = ACTIONS(13514),
    [sym_character_literal] = ACTIONS(13514),
    [sym__pair_operator] = ACTIONS(13514),
    [sym__arrow_operator] = ACTIONS(13514),
    [sym__lazy_or_operator] = ACTIONS(13514),
    [sym__lazy_and_operator] = ACTIONS(13514),
    [sym__comparison_operator] = ACTIONS(13514),
    [sym__pipe_right_operator] = ACTIONS(13514),
    [sym__pipe_left_operator] = ACTIONS(13514),
    [sym__ellipsis_operator] = ACTIONS(13514),
    [sym__plus_operator] = ACTIONS(13514),
    [sym__times_operator] = ACTIONS(13514),
    [sym__rational_operator] = ACTIONS(13514),
    [sym__bitshift_operator] = ACTIONS(13514),
    [sym__power_operator] = ACTIONS(13514),
    [sym__tilde_operator] = ACTIONS(13514),
    [sym__type_order_operator] = ACTIONS(13514),
    [sym__unary_operator] = ACTIONS(13514),
    [sym__unary_plus_operator] = ACTIONS(13514),
    [aux_sym__terminator_token1] = ACTIONS(13514),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13516),
    [sym__command_start] = ACTIONS(13516),
  },
  [7522] = {
    [sym__word_identifier] = ACTIONS(13518),
    [anon_sym_EQ] = ACTIONS(13518),
    [anon_sym_COMMA] = ACTIONS(13518),
    [anon_sym_COLON] = ACTIONS(13518),
    [anon_sym_begin] = ACTIONS(13518),
    [anon_sym_module] = ACTIONS(13518),
    [anon_sym_baremodule] = ACTIONS(13518),
    [anon_sym_end] = ACTIONS(13518),
    [anon_sym_abstract] = ACTIONS(13518),
    [anon_sym_primitive] = ACTIONS(13518),
    [anon_sym_mutable] = ACTIONS(13518),
    [anon_sym_struct] = ACTIONS(13518),
    [anon_sym_function] = ACTIONS(13518),
    [anon_sym_macro] = ACTIONS(13518),
    [anon_sym_where] = ACTIONS(13518),
    [anon_sym_quote] = ACTIONS(13518),
    [anon_sym_let] = ACTIONS(13518),
    [anon_sym_if] = ACTIONS(13518),
    [anon_sym_elseif] = ACTIONS(13518),
    [anon_sym_else] = ACTIONS(13518),
    [anon_sym_try] = ACTIONS(13518),
    [anon_sym_for] = ACTIONS(13518),
    [anon_sym_while] = ACTIONS(13518),
    [sym_break_statement] = ACTIONS(13518),
    [sym_continue_statement] = ACTIONS(13518),
    [anon_sym_return] = ACTIONS(13518),
    [anon_sym_const] = ACTIONS(13518),
    [anon_sym_global] = ACTIONS(13518),
    [anon_sym_local] = ACTIONS(13518),
    [anon_sym_LPAREN] = ACTIONS(13518),
    [anon_sym_COLON2] = ACTIONS(13518),
    [anon_sym_export] = ACTIONS(13518),
    [anon_sym_import] = ACTIONS(13518),
    [anon_sym_using] = ACTIONS(13518),
    [anon_sym_LBRACK] = ACTIONS(13518),
    [anon_sym_LF] = ACTIONS(13520),
    [anon_sym_in] = ACTIONS(13518),
    [anon_sym_LBRACE] = ACTIONS(13518),
    [anon_sym_DOLLAR] = ACTIONS(13518),
    [anon_sym_COLON_COLON] = ACTIONS(13518),
    [anon_sym_isa] = ACTIONS(13518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13518),
    [anon_sym_QMARK] = ACTIONS(13518),
    [anon_sym_AT] = ACTIONS(13518),
    [anon_sym_true] = ACTIONS(13518),
    [anon_sym_false] = ACTIONS(13518),
    [aux_sym_integer_literal_token1] = ACTIONS(13518),
    [aux_sym_integer_literal_token2] = ACTIONS(13518),
    [aux_sym_integer_literal_token3] = ACTIONS(13518),
    [aux_sym_integer_literal_token4] = ACTIONS(13518),
    [aux_sym_float_literal_token1] = ACTIONS(13518),
    [aux_sym_float_literal_token3] = ACTIONS(13518),
    [aux_sym_float_literal_token4] = ACTIONS(13518),
    [sym_character_literal] = ACTIONS(13518),
    [sym__pair_operator] = ACTIONS(13518),
    [sym__arrow_operator] = ACTIONS(13518),
    [sym__lazy_or_operator] = ACTIONS(13518),
    [sym__lazy_and_operator] = ACTIONS(13518),
    [sym__comparison_operator] = ACTIONS(13518),
    [sym__pipe_right_operator] = ACTIONS(13518),
    [sym__pipe_left_operator] = ACTIONS(13518),
    [sym__ellipsis_operator] = ACTIONS(13518),
    [sym__plus_operator] = ACTIONS(13518),
    [sym__times_operator] = ACTIONS(13518),
    [sym__rational_operator] = ACTIONS(13518),
    [sym__bitshift_operator] = ACTIONS(13518),
    [sym__power_operator] = ACTIONS(13518),
    [sym__tilde_operator] = ACTIONS(13518),
    [sym__type_order_operator] = ACTIONS(13518),
    [sym__unary_operator] = ACTIONS(13518),
    [sym__unary_plus_operator] = ACTIONS(13518),
    [aux_sym__terminator_token1] = ACTIONS(13518),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13520),
    [sym__command_start] = ACTIONS(13520),
  },
  [7523] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12570),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7524] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(12450),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_else] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7525] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(12450),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_else] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7526] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12450),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_else] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7527] = {
    [sym__word_identifier] = ACTIONS(13522),
    [anon_sym_EQ] = ACTIONS(13522),
    [anon_sym_COMMA] = ACTIONS(13522),
    [anon_sym_COLON] = ACTIONS(13522),
    [anon_sym_begin] = ACTIONS(13522),
    [anon_sym_module] = ACTIONS(13522),
    [anon_sym_baremodule] = ACTIONS(13522),
    [anon_sym_end] = ACTIONS(13522),
    [anon_sym_abstract] = ACTIONS(13522),
    [anon_sym_primitive] = ACTIONS(13522),
    [anon_sym_mutable] = ACTIONS(13522),
    [anon_sym_struct] = ACTIONS(13522),
    [anon_sym_function] = ACTIONS(13522),
    [anon_sym_macro] = ACTIONS(13522),
    [anon_sym_where] = ACTIONS(13522),
    [anon_sym_quote] = ACTIONS(13522),
    [anon_sym_let] = ACTIONS(13522),
    [anon_sym_if] = ACTIONS(13522),
    [anon_sym_elseif] = ACTIONS(13522),
    [anon_sym_else] = ACTIONS(13522),
    [anon_sym_try] = ACTIONS(13522),
    [anon_sym_for] = ACTIONS(13522),
    [anon_sym_while] = ACTIONS(13522),
    [sym_break_statement] = ACTIONS(13522),
    [sym_continue_statement] = ACTIONS(13522),
    [anon_sym_return] = ACTIONS(13522),
    [anon_sym_const] = ACTIONS(13522),
    [anon_sym_global] = ACTIONS(13522),
    [anon_sym_local] = ACTIONS(13522),
    [anon_sym_LPAREN] = ACTIONS(13522),
    [anon_sym_COLON2] = ACTIONS(13522),
    [anon_sym_export] = ACTIONS(13522),
    [anon_sym_import] = ACTIONS(13522),
    [anon_sym_using] = ACTIONS(13522),
    [anon_sym_LBRACK] = ACTIONS(13522),
    [anon_sym_LF] = ACTIONS(13524),
    [anon_sym_in] = ACTIONS(13522),
    [anon_sym_LBRACE] = ACTIONS(13522),
    [anon_sym_DOLLAR] = ACTIONS(13522),
    [anon_sym_COLON_COLON] = ACTIONS(13522),
    [anon_sym_isa] = ACTIONS(13522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13522),
    [anon_sym_QMARK] = ACTIONS(13522),
    [anon_sym_AT] = ACTIONS(13522),
    [anon_sym_true] = ACTIONS(13522),
    [anon_sym_false] = ACTIONS(13522),
    [aux_sym_integer_literal_token1] = ACTIONS(13522),
    [aux_sym_integer_literal_token2] = ACTIONS(13522),
    [aux_sym_integer_literal_token3] = ACTIONS(13522),
    [aux_sym_integer_literal_token4] = ACTIONS(13522),
    [aux_sym_float_literal_token1] = ACTIONS(13522),
    [aux_sym_float_literal_token3] = ACTIONS(13522),
    [aux_sym_float_literal_token4] = ACTIONS(13522),
    [sym_character_literal] = ACTIONS(13522),
    [sym__pair_operator] = ACTIONS(13522),
    [sym__arrow_operator] = ACTIONS(13522),
    [sym__lazy_or_operator] = ACTIONS(13522),
    [sym__lazy_and_operator] = ACTIONS(13522),
    [sym__comparison_operator] = ACTIONS(13522),
    [sym__pipe_right_operator] = ACTIONS(13522),
    [sym__pipe_left_operator] = ACTIONS(13522),
    [sym__ellipsis_operator] = ACTIONS(13522),
    [sym__plus_operator] = ACTIONS(13522),
    [sym__times_operator] = ACTIONS(13522),
    [sym__rational_operator] = ACTIONS(13522),
    [sym__bitshift_operator] = ACTIONS(13522),
    [sym__power_operator] = ACTIONS(13522),
    [sym__tilde_operator] = ACTIONS(13522),
    [sym__type_order_operator] = ACTIONS(13522),
    [sym__unary_operator] = ACTIONS(13522),
    [sym__unary_plus_operator] = ACTIONS(13522),
    [aux_sym__terminator_token1] = ACTIONS(13522),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13524),
    [sym__command_start] = ACTIONS(13524),
  },
  [7528] = {
    [aux_sym_export_statement_repeat1] = STATE(7552),
    [sym__word_identifier] = ACTIONS(13144),
    [anon_sym_EQ] = ACTIONS(13144),
    [anon_sym_COMMA] = ACTIONS(13668),
    [anon_sym_COLON] = ACTIONS(13144),
    [anon_sym_begin] = ACTIONS(13144),
    [anon_sym_module] = ACTIONS(13144),
    [anon_sym_baremodule] = ACTIONS(13144),
    [anon_sym_end] = ACTIONS(13144),
    [anon_sym_abstract] = ACTIONS(13144),
    [anon_sym_primitive] = ACTIONS(13144),
    [anon_sym_mutable] = ACTIONS(13144),
    [anon_sym_struct] = ACTIONS(13144),
    [anon_sym_function] = ACTIONS(13144),
    [anon_sym_macro] = ACTIONS(13144),
    [anon_sym_where] = ACTIONS(13144),
    [anon_sym_quote] = ACTIONS(13144),
    [anon_sym_let] = ACTIONS(13144),
    [anon_sym_if] = ACTIONS(13144),
    [anon_sym_try] = ACTIONS(13144),
    [anon_sym_catch] = ACTIONS(13144),
    [anon_sym_for] = ACTIONS(13144),
    [anon_sym_while] = ACTIONS(13144),
    [sym_break_statement] = ACTIONS(13144),
    [sym_continue_statement] = ACTIONS(13144),
    [anon_sym_return] = ACTIONS(13144),
    [anon_sym_const] = ACTIONS(13144),
    [anon_sym_global] = ACTIONS(13144),
    [anon_sym_local] = ACTIONS(13144),
    [anon_sym_LPAREN] = ACTIONS(13144),
    [anon_sym_COLON2] = ACTIONS(13144),
    [anon_sym_export] = ACTIONS(13144),
    [anon_sym_import] = ACTIONS(13144),
    [anon_sym_using] = ACTIONS(13144),
    [anon_sym_LBRACK] = ACTIONS(13144),
    [anon_sym_LF] = ACTIONS(13146),
    [anon_sym_in] = ACTIONS(13144),
    [anon_sym_LBRACE] = ACTIONS(13144),
    [anon_sym_DOLLAR] = ACTIONS(13144),
    [anon_sym_COLON_COLON] = ACTIONS(13144),
    [anon_sym_isa] = ACTIONS(13144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13144),
    [anon_sym_QMARK] = ACTIONS(13144),
    [anon_sym_AT] = ACTIONS(13144),
    [anon_sym_true] = ACTIONS(13144),
    [anon_sym_false] = ACTIONS(13144),
    [aux_sym_integer_literal_token1] = ACTIONS(13144),
    [aux_sym_integer_literal_token2] = ACTIONS(13144),
    [aux_sym_integer_literal_token3] = ACTIONS(13144),
    [aux_sym_integer_literal_token4] = ACTIONS(13144),
    [aux_sym_float_literal_token1] = ACTIONS(13144),
    [aux_sym_float_literal_token3] = ACTIONS(13144),
    [aux_sym_float_literal_token4] = ACTIONS(13144),
    [sym_character_literal] = ACTIONS(13144),
    [sym__pair_operator] = ACTIONS(13144),
    [sym__arrow_operator] = ACTIONS(13144),
    [sym__lazy_or_operator] = ACTIONS(13144),
    [sym__lazy_and_operator] = ACTIONS(13144),
    [sym__comparison_operator] = ACTIONS(13144),
    [sym__pipe_right_operator] = ACTIONS(13144),
    [sym__pipe_left_operator] = ACTIONS(13144),
    [sym__ellipsis_operator] = ACTIONS(13144),
    [sym__plus_operator] = ACTIONS(13144),
    [sym__times_operator] = ACTIONS(13144),
    [sym__rational_operator] = ACTIONS(13144),
    [sym__bitshift_operator] = ACTIONS(13144),
    [sym__power_operator] = ACTIONS(13144),
    [sym__tilde_operator] = ACTIONS(13144),
    [sym__type_order_operator] = ACTIONS(13144),
    [sym__unary_operator] = ACTIONS(13144),
    [sym__unary_plus_operator] = ACTIONS(13144),
    [aux_sym__terminator_token1] = ACTIONS(13144),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13146),
    [sym__command_start] = ACTIONS(13146),
  },
  [7529] = {
    [aux_sym__import_list_repeat1] = STATE(7554),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13020),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_catch] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7530] = {
    [sym__word_identifier] = ACTIONS(13526),
    [anon_sym_EQ] = ACTIONS(13526),
    [anon_sym_COMMA] = ACTIONS(13526),
    [anon_sym_COLON] = ACTIONS(13526),
    [anon_sym_begin] = ACTIONS(13526),
    [anon_sym_module] = ACTIONS(13526),
    [anon_sym_baremodule] = ACTIONS(13526),
    [anon_sym_end] = ACTIONS(13526),
    [anon_sym_abstract] = ACTIONS(13526),
    [anon_sym_primitive] = ACTIONS(13526),
    [anon_sym_mutable] = ACTIONS(13526),
    [anon_sym_struct] = ACTIONS(13526),
    [anon_sym_function] = ACTIONS(13526),
    [anon_sym_macro] = ACTIONS(13526),
    [anon_sym_where] = ACTIONS(13526),
    [anon_sym_quote] = ACTIONS(13526),
    [anon_sym_let] = ACTIONS(13526),
    [anon_sym_if] = ACTIONS(13526),
    [anon_sym_elseif] = ACTIONS(13526),
    [anon_sym_else] = ACTIONS(13526),
    [anon_sym_try] = ACTIONS(13526),
    [anon_sym_for] = ACTIONS(13526),
    [anon_sym_while] = ACTIONS(13526),
    [sym_break_statement] = ACTIONS(13526),
    [sym_continue_statement] = ACTIONS(13526),
    [anon_sym_return] = ACTIONS(13526),
    [anon_sym_const] = ACTIONS(13526),
    [anon_sym_global] = ACTIONS(13526),
    [anon_sym_local] = ACTIONS(13526),
    [anon_sym_LPAREN] = ACTIONS(13526),
    [anon_sym_COLON2] = ACTIONS(13526),
    [anon_sym_export] = ACTIONS(13526),
    [anon_sym_import] = ACTIONS(13526),
    [anon_sym_using] = ACTIONS(13526),
    [anon_sym_LBRACK] = ACTIONS(13526),
    [anon_sym_LF] = ACTIONS(13528),
    [anon_sym_in] = ACTIONS(13526),
    [anon_sym_LBRACE] = ACTIONS(13526),
    [anon_sym_DOLLAR] = ACTIONS(13526),
    [anon_sym_COLON_COLON] = ACTIONS(13526),
    [anon_sym_isa] = ACTIONS(13526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13526),
    [anon_sym_QMARK] = ACTIONS(13526),
    [anon_sym_AT] = ACTIONS(13526),
    [anon_sym_true] = ACTIONS(13526),
    [anon_sym_false] = ACTIONS(13526),
    [aux_sym_integer_literal_token1] = ACTIONS(13526),
    [aux_sym_integer_literal_token2] = ACTIONS(13526),
    [aux_sym_integer_literal_token3] = ACTIONS(13526),
    [aux_sym_integer_literal_token4] = ACTIONS(13526),
    [aux_sym_float_literal_token1] = ACTIONS(13526),
    [aux_sym_float_literal_token3] = ACTIONS(13526),
    [aux_sym_float_literal_token4] = ACTIONS(13526),
    [sym_character_literal] = ACTIONS(13526),
    [sym__pair_operator] = ACTIONS(13526),
    [sym__arrow_operator] = ACTIONS(13526),
    [sym__lazy_or_operator] = ACTIONS(13526),
    [sym__lazy_and_operator] = ACTIONS(13526),
    [sym__comparison_operator] = ACTIONS(13526),
    [sym__pipe_right_operator] = ACTIONS(13526),
    [sym__pipe_left_operator] = ACTIONS(13526),
    [sym__ellipsis_operator] = ACTIONS(13526),
    [sym__plus_operator] = ACTIONS(13526),
    [sym__times_operator] = ACTIONS(13526),
    [sym__rational_operator] = ACTIONS(13526),
    [sym__bitshift_operator] = ACTIONS(13526),
    [sym__power_operator] = ACTIONS(13526),
    [sym__tilde_operator] = ACTIONS(13526),
    [sym__type_order_operator] = ACTIONS(13526),
    [sym__unary_operator] = ACTIONS(13526),
    [sym__unary_plus_operator] = ACTIONS(13526),
    [aux_sym__terminator_token1] = ACTIONS(13526),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13528),
    [sym__command_start] = ACTIONS(13528),
  },
  [7531] = {
    [sym__word_identifier] = ACTIONS(13530),
    [anon_sym_EQ] = ACTIONS(13530),
    [anon_sym_COMMA] = ACTIONS(13530),
    [anon_sym_COLON] = ACTIONS(13530),
    [anon_sym_begin] = ACTIONS(13530),
    [anon_sym_module] = ACTIONS(13530),
    [anon_sym_baremodule] = ACTIONS(13530),
    [anon_sym_end] = ACTIONS(13530),
    [anon_sym_abstract] = ACTIONS(13530),
    [anon_sym_primitive] = ACTIONS(13530),
    [anon_sym_mutable] = ACTIONS(13530),
    [anon_sym_struct] = ACTIONS(13530),
    [anon_sym_function] = ACTIONS(13530),
    [anon_sym_macro] = ACTIONS(13530),
    [anon_sym_where] = ACTIONS(13530),
    [anon_sym_quote] = ACTIONS(13530),
    [anon_sym_let] = ACTIONS(13530),
    [anon_sym_if] = ACTIONS(13530),
    [anon_sym_elseif] = ACTIONS(13530),
    [anon_sym_else] = ACTIONS(13530),
    [anon_sym_try] = ACTIONS(13530),
    [anon_sym_for] = ACTIONS(13530),
    [anon_sym_while] = ACTIONS(13530),
    [sym_break_statement] = ACTIONS(13530),
    [sym_continue_statement] = ACTIONS(13530),
    [anon_sym_return] = ACTIONS(13530),
    [anon_sym_const] = ACTIONS(13530),
    [anon_sym_global] = ACTIONS(13530),
    [anon_sym_local] = ACTIONS(13530),
    [anon_sym_LPAREN] = ACTIONS(13530),
    [anon_sym_COLON2] = ACTIONS(13530),
    [anon_sym_export] = ACTIONS(13530),
    [anon_sym_import] = ACTIONS(13530),
    [anon_sym_using] = ACTIONS(13530),
    [anon_sym_LBRACK] = ACTIONS(13530),
    [anon_sym_LF] = ACTIONS(13532),
    [anon_sym_in] = ACTIONS(13530),
    [anon_sym_LBRACE] = ACTIONS(13530),
    [anon_sym_DOLLAR] = ACTIONS(13530),
    [anon_sym_COLON_COLON] = ACTIONS(13530),
    [anon_sym_isa] = ACTIONS(13530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13530),
    [anon_sym_QMARK] = ACTIONS(13530),
    [anon_sym_AT] = ACTIONS(13530),
    [anon_sym_true] = ACTIONS(13530),
    [anon_sym_false] = ACTIONS(13530),
    [aux_sym_integer_literal_token1] = ACTIONS(13530),
    [aux_sym_integer_literal_token2] = ACTIONS(13530),
    [aux_sym_integer_literal_token3] = ACTIONS(13530),
    [aux_sym_integer_literal_token4] = ACTIONS(13530),
    [aux_sym_float_literal_token1] = ACTIONS(13530),
    [aux_sym_float_literal_token3] = ACTIONS(13530),
    [aux_sym_float_literal_token4] = ACTIONS(13530),
    [sym_character_literal] = ACTIONS(13530),
    [sym__pair_operator] = ACTIONS(13530),
    [sym__arrow_operator] = ACTIONS(13530),
    [sym__lazy_or_operator] = ACTIONS(13530),
    [sym__lazy_and_operator] = ACTIONS(13530),
    [sym__comparison_operator] = ACTIONS(13530),
    [sym__pipe_right_operator] = ACTIONS(13530),
    [sym__pipe_left_operator] = ACTIONS(13530),
    [sym__ellipsis_operator] = ACTIONS(13530),
    [sym__plus_operator] = ACTIONS(13530),
    [sym__times_operator] = ACTIONS(13530),
    [sym__rational_operator] = ACTIONS(13530),
    [sym__bitshift_operator] = ACTIONS(13530),
    [sym__power_operator] = ACTIONS(13530),
    [sym__tilde_operator] = ACTIONS(13530),
    [sym__type_order_operator] = ACTIONS(13530),
    [sym__unary_operator] = ACTIONS(13530),
    [sym__unary_plus_operator] = ACTIONS(13530),
    [aux_sym__terminator_token1] = ACTIONS(13530),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13532),
    [sym__command_start] = ACTIONS(13532),
  },
  [7532] = {
    [sym__word_identifier] = ACTIONS(13534),
    [anon_sym_EQ] = ACTIONS(13534),
    [anon_sym_COMMA] = ACTIONS(13534),
    [anon_sym_COLON] = ACTIONS(13534),
    [anon_sym_begin] = ACTIONS(13534),
    [anon_sym_module] = ACTIONS(13534),
    [anon_sym_baremodule] = ACTIONS(13534),
    [anon_sym_end] = ACTIONS(13534),
    [anon_sym_abstract] = ACTIONS(13534),
    [anon_sym_primitive] = ACTIONS(13534),
    [anon_sym_mutable] = ACTIONS(13534),
    [anon_sym_struct] = ACTIONS(13534),
    [anon_sym_function] = ACTIONS(13534),
    [anon_sym_macro] = ACTIONS(13534),
    [anon_sym_where] = ACTIONS(13534),
    [anon_sym_quote] = ACTIONS(13534),
    [anon_sym_let] = ACTIONS(13534),
    [anon_sym_if] = ACTIONS(13534),
    [anon_sym_elseif] = ACTIONS(13534),
    [anon_sym_else] = ACTIONS(13534),
    [anon_sym_try] = ACTIONS(13534),
    [anon_sym_for] = ACTIONS(13534),
    [anon_sym_while] = ACTIONS(13534),
    [sym_break_statement] = ACTIONS(13534),
    [sym_continue_statement] = ACTIONS(13534),
    [anon_sym_return] = ACTIONS(13534),
    [anon_sym_const] = ACTIONS(13534),
    [anon_sym_global] = ACTIONS(13534),
    [anon_sym_local] = ACTIONS(13534),
    [anon_sym_LPAREN] = ACTIONS(13534),
    [anon_sym_COLON2] = ACTIONS(13534),
    [anon_sym_export] = ACTIONS(13534),
    [anon_sym_import] = ACTIONS(13534),
    [anon_sym_using] = ACTIONS(13534),
    [anon_sym_LBRACK] = ACTIONS(13534),
    [anon_sym_LF] = ACTIONS(13536),
    [anon_sym_in] = ACTIONS(13534),
    [anon_sym_LBRACE] = ACTIONS(13534),
    [anon_sym_DOLLAR] = ACTIONS(13534),
    [anon_sym_COLON_COLON] = ACTIONS(13534),
    [anon_sym_isa] = ACTIONS(13534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13534),
    [anon_sym_QMARK] = ACTIONS(13534),
    [anon_sym_AT] = ACTIONS(13534),
    [anon_sym_true] = ACTIONS(13534),
    [anon_sym_false] = ACTIONS(13534),
    [aux_sym_integer_literal_token1] = ACTIONS(13534),
    [aux_sym_integer_literal_token2] = ACTIONS(13534),
    [aux_sym_integer_literal_token3] = ACTIONS(13534),
    [aux_sym_integer_literal_token4] = ACTIONS(13534),
    [aux_sym_float_literal_token1] = ACTIONS(13534),
    [aux_sym_float_literal_token3] = ACTIONS(13534),
    [aux_sym_float_literal_token4] = ACTIONS(13534),
    [sym_character_literal] = ACTIONS(13534),
    [sym__pair_operator] = ACTIONS(13534),
    [sym__arrow_operator] = ACTIONS(13534),
    [sym__lazy_or_operator] = ACTIONS(13534),
    [sym__lazy_and_operator] = ACTIONS(13534),
    [sym__comparison_operator] = ACTIONS(13534),
    [sym__pipe_right_operator] = ACTIONS(13534),
    [sym__pipe_left_operator] = ACTIONS(13534),
    [sym__ellipsis_operator] = ACTIONS(13534),
    [sym__plus_operator] = ACTIONS(13534),
    [sym__times_operator] = ACTIONS(13534),
    [sym__rational_operator] = ACTIONS(13534),
    [sym__bitshift_operator] = ACTIONS(13534),
    [sym__power_operator] = ACTIONS(13534),
    [sym__tilde_operator] = ACTIONS(13534),
    [sym__type_order_operator] = ACTIONS(13534),
    [sym__unary_operator] = ACTIONS(13534),
    [sym__unary_plus_operator] = ACTIONS(13534),
    [aux_sym__terminator_token1] = ACTIONS(13534),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13536),
    [sym__command_start] = ACTIONS(13536),
  },
  [7533] = {
    [sym__word_identifier] = ACTIONS(13538),
    [anon_sym_EQ] = ACTIONS(13538),
    [anon_sym_COMMA] = ACTIONS(13538),
    [anon_sym_COLON] = ACTIONS(13538),
    [anon_sym_begin] = ACTIONS(13538),
    [anon_sym_module] = ACTIONS(13538),
    [anon_sym_baremodule] = ACTIONS(13538),
    [anon_sym_end] = ACTIONS(13538),
    [anon_sym_abstract] = ACTIONS(13538),
    [anon_sym_primitive] = ACTIONS(13538),
    [anon_sym_mutable] = ACTIONS(13538),
    [anon_sym_struct] = ACTIONS(13538),
    [anon_sym_function] = ACTIONS(13538),
    [anon_sym_macro] = ACTIONS(13538),
    [anon_sym_where] = ACTIONS(13538),
    [anon_sym_quote] = ACTIONS(13538),
    [anon_sym_let] = ACTIONS(13538),
    [anon_sym_if] = ACTIONS(13538),
    [anon_sym_elseif] = ACTIONS(13538),
    [anon_sym_else] = ACTIONS(13538),
    [anon_sym_try] = ACTIONS(13538),
    [anon_sym_for] = ACTIONS(13538),
    [anon_sym_while] = ACTIONS(13538),
    [sym_break_statement] = ACTIONS(13538),
    [sym_continue_statement] = ACTIONS(13538),
    [anon_sym_return] = ACTIONS(13538),
    [anon_sym_const] = ACTIONS(13538),
    [anon_sym_global] = ACTIONS(13538),
    [anon_sym_local] = ACTIONS(13538),
    [anon_sym_LPAREN] = ACTIONS(13538),
    [anon_sym_COLON2] = ACTIONS(13538),
    [anon_sym_export] = ACTIONS(13538),
    [anon_sym_import] = ACTIONS(13538),
    [anon_sym_using] = ACTIONS(13538),
    [anon_sym_LBRACK] = ACTIONS(13538),
    [anon_sym_LF] = ACTIONS(13540),
    [anon_sym_in] = ACTIONS(13538),
    [anon_sym_LBRACE] = ACTIONS(13538),
    [anon_sym_DOLLAR] = ACTIONS(13538),
    [anon_sym_COLON_COLON] = ACTIONS(13538),
    [anon_sym_isa] = ACTIONS(13538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13538),
    [anon_sym_QMARK] = ACTIONS(13538),
    [anon_sym_AT] = ACTIONS(13538),
    [anon_sym_true] = ACTIONS(13538),
    [anon_sym_false] = ACTIONS(13538),
    [aux_sym_integer_literal_token1] = ACTIONS(13538),
    [aux_sym_integer_literal_token2] = ACTIONS(13538),
    [aux_sym_integer_literal_token3] = ACTIONS(13538),
    [aux_sym_integer_literal_token4] = ACTIONS(13538),
    [aux_sym_float_literal_token1] = ACTIONS(13538),
    [aux_sym_float_literal_token3] = ACTIONS(13538),
    [aux_sym_float_literal_token4] = ACTIONS(13538),
    [sym_character_literal] = ACTIONS(13538),
    [sym__pair_operator] = ACTIONS(13538),
    [sym__arrow_operator] = ACTIONS(13538),
    [sym__lazy_or_operator] = ACTIONS(13538),
    [sym__lazy_and_operator] = ACTIONS(13538),
    [sym__comparison_operator] = ACTIONS(13538),
    [sym__pipe_right_operator] = ACTIONS(13538),
    [sym__pipe_left_operator] = ACTIONS(13538),
    [sym__ellipsis_operator] = ACTIONS(13538),
    [sym__plus_operator] = ACTIONS(13538),
    [sym__times_operator] = ACTIONS(13538),
    [sym__rational_operator] = ACTIONS(13538),
    [sym__bitshift_operator] = ACTIONS(13538),
    [sym__power_operator] = ACTIONS(13538),
    [sym__tilde_operator] = ACTIONS(13538),
    [sym__type_order_operator] = ACTIONS(13538),
    [sym__unary_operator] = ACTIONS(13538),
    [sym__unary_plus_operator] = ACTIONS(13538),
    [aux_sym__terminator_token1] = ACTIONS(13538),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13540),
    [sym__command_start] = ACTIONS(13540),
  },
  [7534] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_elseif] = ACTIONS(12678),
    [anon_sym_else] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7535] = {
    [sym__word_identifier] = ACTIONS(13542),
    [anon_sym_EQ] = ACTIONS(13542),
    [anon_sym_COMMA] = ACTIONS(13542),
    [anon_sym_COLON] = ACTIONS(13542),
    [anon_sym_begin] = ACTIONS(13542),
    [anon_sym_module] = ACTIONS(13542),
    [anon_sym_baremodule] = ACTIONS(13542),
    [anon_sym_end] = ACTIONS(13542),
    [anon_sym_abstract] = ACTIONS(13542),
    [anon_sym_primitive] = ACTIONS(13542),
    [anon_sym_mutable] = ACTIONS(13542),
    [anon_sym_struct] = ACTIONS(13542),
    [anon_sym_function] = ACTIONS(13542),
    [anon_sym_macro] = ACTIONS(13542),
    [anon_sym_where] = ACTIONS(13542),
    [anon_sym_quote] = ACTIONS(13542),
    [anon_sym_let] = ACTIONS(13542),
    [anon_sym_if] = ACTIONS(13542),
    [anon_sym_elseif] = ACTIONS(13542),
    [anon_sym_else] = ACTIONS(13542),
    [anon_sym_try] = ACTIONS(13542),
    [anon_sym_for] = ACTIONS(13542),
    [anon_sym_while] = ACTIONS(13542),
    [sym_break_statement] = ACTIONS(13542),
    [sym_continue_statement] = ACTIONS(13542),
    [anon_sym_return] = ACTIONS(13542),
    [anon_sym_const] = ACTIONS(13542),
    [anon_sym_global] = ACTIONS(13542),
    [anon_sym_local] = ACTIONS(13542),
    [anon_sym_LPAREN] = ACTIONS(13542),
    [anon_sym_COLON2] = ACTIONS(13542),
    [anon_sym_export] = ACTIONS(13542),
    [anon_sym_import] = ACTIONS(13542),
    [anon_sym_using] = ACTIONS(13542),
    [anon_sym_LBRACK] = ACTIONS(13542),
    [anon_sym_LF] = ACTIONS(13544),
    [anon_sym_in] = ACTIONS(13542),
    [anon_sym_LBRACE] = ACTIONS(13542),
    [anon_sym_DOLLAR] = ACTIONS(13542),
    [anon_sym_COLON_COLON] = ACTIONS(13542),
    [anon_sym_isa] = ACTIONS(13542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13542),
    [anon_sym_QMARK] = ACTIONS(13542),
    [anon_sym_AT] = ACTIONS(13542),
    [anon_sym_true] = ACTIONS(13542),
    [anon_sym_false] = ACTIONS(13542),
    [aux_sym_integer_literal_token1] = ACTIONS(13542),
    [aux_sym_integer_literal_token2] = ACTIONS(13542),
    [aux_sym_integer_literal_token3] = ACTIONS(13542),
    [aux_sym_integer_literal_token4] = ACTIONS(13542),
    [aux_sym_float_literal_token1] = ACTIONS(13542),
    [aux_sym_float_literal_token3] = ACTIONS(13542),
    [aux_sym_float_literal_token4] = ACTIONS(13542),
    [sym_character_literal] = ACTIONS(13542),
    [sym__pair_operator] = ACTIONS(13542),
    [sym__arrow_operator] = ACTIONS(13542),
    [sym__lazy_or_operator] = ACTIONS(13542),
    [sym__lazy_and_operator] = ACTIONS(13542),
    [sym__comparison_operator] = ACTIONS(13542),
    [sym__pipe_right_operator] = ACTIONS(13542),
    [sym__pipe_left_operator] = ACTIONS(13542),
    [sym__ellipsis_operator] = ACTIONS(13542),
    [sym__plus_operator] = ACTIONS(13542),
    [sym__times_operator] = ACTIONS(13542),
    [sym__rational_operator] = ACTIONS(13542),
    [sym__bitshift_operator] = ACTIONS(13542),
    [sym__power_operator] = ACTIONS(13542),
    [sym__tilde_operator] = ACTIONS(13542),
    [sym__type_order_operator] = ACTIONS(13542),
    [sym__unary_operator] = ACTIONS(13542),
    [sym__unary_plus_operator] = ACTIONS(13542),
    [aux_sym__terminator_token1] = ACTIONS(13542),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13544),
    [sym__command_start] = ACTIONS(13544),
  },
  [7536] = {
    [sym__word_identifier] = ACTIONS(13546),
    [anon_sym_EQ] = ACTIONS(13546),
    [anon_sym_COMMA] = ACTIONS(13546),
    [anon_sym_COLON] = ACTIONS(13546),
    [anon_sym_begin] = ACTIONS(13546),
    [anon_sym_module] = ACTIONS(13546),
    [anon_sym_baremodule] = ACTIONS(13546),
    [anon_sym_end] = ACTIONS(13546),
    [anon_sym_abstract] = ACTIONS(13546),
    [anon_sym_primitive] = ACTIONS(13546),
    [anon_sym_mutable] = ACTIONS(13546),
    [anon_sym_struct] = ACTIONS(13546),
    [anon_sym_function] = ACTIONS(13546),
    [anon_sym_macro] = ACTIONS(13546),
    [anon_sym_where] = ACTIONS(13546),
    [anon_sym_quote] = ACTIONS(13546),
    [anon_sym_let] = ACTIONS(13546),
    [anon_sym_if] = ACTIONS(13546),
    [anon_sym_elseif] = ACTIONS(13546),
    [anon_sym_else] = ACTIONS(13546),
    [anon_sym_try] = ACTIONS(13546),
    [anon_sym_for] = ACTIONS(13546),
    [anon_sym_while] = ACTIONS(13546),
    [sym_break_statement] = ACTIONS(13546),
    [sym_continue_statement] = ACTIONS(13546),
    [anon_sym_return] = ACTIONS(13546),
    [anon_sym_const] = ACTIONS(13546),
    [anon_sym_global] = ACTIONS(13546),
    [anon_sym_local] = ACTIONS(13546),
    [anon_sym_LPAREN] = ACTIONS(13546),
    [anon_sym_COLON2] = ACTIONS(13546),
    [anon_sym_export] = ACTIONS(13546),
    [anon_sym_import] = ACTIONS(13546),
    [anon_sym_using] = ACTIONS(13546),
    [anon_sym_LBRACK] = ACTIONS(13546),
    [anon_sym_LF] = ACTIONS(13548),
    [anon_sym_in] = ACTIONS(13546),
    [anon_sym_LBRACE] = ACTIONS(13546),
    [anon_sym_DOLLAR] = ACTIONS(13546),
    [anon_sym_COLON_COLON] = ACTIONS(13546),
    [anon_sym_isa] = ACTIONS(13546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13546),
    [anon_sym_QMARK] = ACTIONS(13546),
    [anon_sym_AT] = ACTIONS(13546),
    [anon_sym_true] = ACTIONS(13546),
    [anon_sym_false] = ACTIONS(13546),
    [aux_sym_integer_literal_token1] = ACTIONS(13546),
    [aux_sym_integer_literal_token2] = ACTIONS(13546),
    [aux_sym_integer_literal_token3] = ACTIONS(13546),
    [aux_sym_integer_literal_token4] = ACTIONS(13546),
    [aux_sym_float_literal_token1] = ACTIONS(13546),
    [aux_sym_float_literal_token3] = ACTIONS(13546),
    [aux_sym_float_literal_token4] = ACTIONS(13546),
    [sym_character_literal] = ACTIONS(13546),
    [sym__pair_operator] = ACTIONS(13546),
    [sym__arrow_operator] = ACTIONS(13546),
    [sym__lazy_or_operator] = ACTIONS(13546),
    [sym__lazy_and_operator] = ACTIONS(13546),
    [sym__comparison_operator] = ACTIONS(13546),
    [sym__pipe_right_operator] = ACTIONS(13546),
    [sym__pipe_left_operator] = ACTIONS(13546),
    [sym__ellipsis_operator] = ACTIONS(13546),
    [sym__plus_operator] = ACTIONS(13546),
    [sym__times_operator] = ACTIONS(13546),
    [sym__rational_operator] = ACTIONS(13546),
    [sym__bitshift_operator] = ACTIONS(13546),
    [sym__power_operator] = ACTIONS(13546),
    [sym__tilde_operator] = ACTIONS(13546),
    [sym__type_order_operator] = ACTIONS(13546),
    [sym__unary_operator] = ACTIONS(13546),
    [sym__unary_plus_operator] = ACTIONS(13546),
    [aux_sym__terminator_token1] = ACTIONS(13546),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13548),
    [sym__command_start] = ACTIONS(13548),
  },
  [7537] = {
    [sym__word_identifier] = ACTIONS(13550),
    [anon_sym_EQ] = ACTIONS(13550),
    [anon_sym_COMMA] = ACTIONS(13550),
    [anon_sym_COLON] = ACTIONS(13550),
    [anon_sym_begin] = ACTIONS(13550),
    [anon_sym_module] = ACTIONS(13550),
    [anon_sym_baremodule] = ACTIONS(13550),
    [anon_sym_end] = ACTIONS(13550),
    [anon_sym_abstract] = ACTIONS(13550),
    [anon_sym_primitive] = ACTIONS(13550),
    [anon_sym_mutable] = ACTIONS(13550),
    [anon_sym_struct] = ACTIONS(13550),
    [anon_sym_function] = ACTIONS(13550),
    [anon_sym_macro] = ACTIONS(13550),
    [anon_sym_where] = ACTIONS(13550),
    [anon_sym_quote] = ACTIONS(13550),
    [anon_sym_let] = ACTIONS(13550),
    [anon_sym_if] = ACTIONS(13550),
    [anon_sym_elseif] = ACTIONS(13550),
    [anon_sym_else] = ACTIONS(13550),
    [anon_sym_try] = ACTIONS(13550),
    [anon_sym_for] = ACTIONS(13550),
    [anon_sym_while] = ACTIONS(13550),
    [sym_break_statement] = ACTIONS(13550),
    [sym_continue_statement] = ACTIONS(13550),
    [anon_sym_return] = ACTIONS(13550),
    [anon_sym_const] = ACTIONS(13550),
    [anon_sym_global] = ACTIONS(13550),
    [anon_sym_local] = ACTIONS(13550),
    [anon_sym_LPAREN] = ACTIONS(13550),
    [anon_sym_COLON2] = ACTIONS(13550),
    [anon_sym_export] = ACTIONS(13550),
    [anon_sym_import] = ACTIONS(13550),
    [anon_sym_using] = ACTIONS(13550),
    [anon_sym_LBRACK] = ACTIONS(13550),
    [anon_sym_LF] = ACTIONS(13552),
    [anon_sym_in] = ACTIONS(13550),
    [anon_sym_LBRACE] = ACTIONS(13550),
    [anon_sym_DOLLAR] = ACTIONS(13550),
    [anon_sym_COLON_COLON] = ACTIONS(13550),
    [anon_sym_isa] = ACTIONS(13550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13550),
    [anon_sym_QMARK] = ACTIONS(13550),
    [anon_sym_AT] = ACTIONS(13550),
    [anon_sym_true] = ACTIONS(13550),
    [anon_sym_false] = ACTIONS(13550),
    [aux_sym_integer_literal_token1] = ACTIONS(13550),
    [aux_sym_integer_literal_token2] = ACTIONS(13550),
    [aux_sym_integer_literal_token3] = ACTIONS(13550),
    [aux_sym_integer_literal_token4] = ACTIONS(13550),
    [aux_sym_float_literal_token1] = ACTIONS(13550),
    [aux_sym_float_literal_token3] = ACTIONS(13550),
    [aux_sym_float_literal_token4] = ACTIONS(13550),
    [sym_character_literal] = ACTIONS(13550),
    [sym__pair_operator] = ACTIONS(13550),
    [sym__arrow_operator] = ACTIONS(13550),
    [sym__lazy_or_operator] = ACTIONS(13550),
    [sym__lazy_and_operator] = ACTIONS(13550),
    [sym__comparison_operator] = ACTIONS(13550),
    [sym__pipe_right_operator] = ACTIONS(13550),
    [sym__pipe_left_operator] = ACTIONS(13550),
    [sym__ellipsis_operator] = ACTIONS(13550),
    [sym__plus_operator] = ACTIONS(13550),
    [sym__times_operator] = ACTIONS(13550),
    [sym__rational_operator] = ACTIONS(13550),
    [sym__bitshift_operator] = ACTIONS(13550),
    [sym__power_operator] = ACTIONS(13550),
    [sym__tilde_operator] = ACTIONS(13550),
    [sym__type_order_operator] = ACTIONS(13550),
    [sym__unary_operator] = ACTIONS(13550),
    [sym__unary_plus_operator] = ACTIONS(13550),
    [aux_sym__terminator_token1] = ACTIONS(13550),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13552),
    [sym__command_start] = ACTIONS(13552),
  },
  [7538] = {
    [sym__word_identifier] = ACTIONS(13554),
    [anon_sym_EQ] = ACTIONS(13554),
    [anon_sym_COMMA] = ACTIONS(13554),
    [anon_sym_COLON] = ACTIONS(13554),
    [anon_sym_begin] = ACTIONS(13554),
    [anon_sym_module] = ACTIONS(13554),
    [anon_sym_baremodule] = ACTIONS(13554),
    [anon_sym_end] = ACTIONS(13554),
    [anon_sym_abstract] = ACTIONS(13554),
    [anon_sym_primitive] = ACTIONS(13554),
    [anon_sym_mutable] = ACTIONS(13554),
    [anon_sym_struct] = ACTIONS(13554),
    [anon_sym_function] = ACTIONS(13554),
    [anon_sym_macro] = ACTIONS(13554),
    [anon_sym_where] = ACTIONS(13554),
    [anon_sym_quote] = ACTIONS(13554),
    [anon_sym_let] = ACTIONS(13554),
    [anon_sym_if] = ACTIONS(13554),
    [anon_sym_elseif] = ACTIONS(13554),
    [anon_sym_else] = ACTIONS(13554),
    [anon_sym_try] = ACTIONS(13554),
    [anon_sym_for] = ACTIONS(13554),
    [anon_sym_while] = ACTIONS(13554),
    [sym_break_statement] = ACTIONS(13554),
    [sym_continue_statement] = ACTIONS(13554),
    [anon_sym_return] = ACTIONS(13554),
    [anon_sym_const] = ACTIONS(13554),
    [anon_sym_global] = ACTIONS(13554),
    [anon_sym_local] = ACTIONS(13554),
    [anon_sym_LPAREN] = ACTIONS(13554),
    [anon_sym_COLON2] = ACTIONS(13554),
    [anon_sym_export] = ACTIONS(13554),
    [anon_sym_import] = ACTIONS(13554),
    [anon_sym_using] = ACTIONS(13554),
    [anon_sym_LBRACK] = ACTIONS(13554),
    [anon_sym_LF] = ACTIONS(13556),
    [anon_sym_in] = ACTIONS(13554),
    [anon_sym_LBRACE] = ACTIONS(13554),
    [anon_sym_DOLLAR] = ACTIONS(13554),
    [anon_sym_COLON_COLON] = ACTIONS(13554),
    [anon_sym_isa] = ACTIONS(13554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13554),
    [anon_sym_QMARK] = ACTIONS(13554),
    [anon_sym_AT] = ACTIONS(13554),
    [anon_sym_true] = ACTIONS(13554),
    [anon_sym_false] = ACTIONS(13554),
    [aux_sym_integer_literal_token1] = ACTIONS(13554),
    [aux_sym_integer_literal_token2] = ACTIONS(13554),
    [aux_sym_integer_literal_token3] = ACTIONS(13554),
    [aux_sym_integer_literal_token4] = ACTIONS(13554),
    [aux_sym_float_literal_token1] = ACTIONS(13554),
    [aux_sym_float_literal_token3] = ACTIONS(13554),
    [aux_sym_float_literal_token4] = ACTIONS(13554),
    [sym_character_literal] = ACTIONS(13554),
    [sym__pair_operator] = ACTIONS(13554),
    [sym__arrow_operator] = ACTIONS(13554),
    [sym__lazy_or_operator] = ACTIONS(13554),
    [sym__lazy_and_operator] = ACTIONS(13554),
    [sym__comparison_operator] = ACTIONS(13554),
    [sym__pipe_right_operator] = ACTIONS(13554),
    [sym__pipe_left_operator] = ACTIONS(13554),
    [sym__ellipsis_operator] = ACTIONS(13554),
    [sym__plus_operator] = ACTIONS(13554),
    [sym__times_operator] = ACTIONS(13554),
    [sym__rational_operator] = ACTIONS(13554),
    [sym__bitshift_operator] = ACTIONS(13554),
    [sym__power_operator] = ACTIONS(13554),
    [sym__tilde_operator] = ACTIONS(13554),
    [sym__type_order_operator] = ACTIONS(13554),
    [sym__unary_operator] = ACTIONS(13554),
    [sym__unary_plus_operator] = ACTIONS(13554),
    [aux_sym__terminator_token1] = ACTIONS(13554),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13556),
    [sym__command_start] = ACTIONS(13556),
  },
  [7539] = {
    [sym__word_identifier] = ACTIONS(13558),
    [anon_sym_EQ] = ACTIONS(13558),
    [anon_sym_COMMA] = ACTIONS(13558),
    [anon_sym_COLON] = ACTIONS(13558),
    [anon_sym_begin] = ACTIONS(13558),
    [anon_sym_module] = ACTIONS(13558),
    [anon_sym_baremodule] = ACTIONS(13558),
    [anon_sym_end] = ACTIONS(13558),
    [anon_sym_abstract] = ACTIONS(13558),
    [anon_sym_primitive] = ACTIONS(13558),
    [anon_sym_mutable] = ACTIONS(13558),
    [anon_sym_struct] = ACTIONS(13558),
    [anon_sym_function] = ACTIONS(13558),
    [anon_sym_macro] = ACTIONS(13558),
    [anon_sym_where] = ACTIONS(13558),
    [anon_sym_quote] = ACTIONS(13558),
    [anon_sym_let] = ACTIONS(13558),
    [anon_sym_if] = ACTIONS(13558),
    [anon_sym_elseif] = ACTIONS(13558),
    [anon_sym_else] = ACTIONS(13558),
    [anon_sym_try] = ACTIONS(13558),
    [anon_sym_for] = ACTIONS(13558),
    [anon_sym_while] = ACTIONS(13558),
    [sym_break_statement] = ACTIONS(13558),
    [sym_continue_statement] = ACTIONS(13558),
    [anon_sym_return] = ACTIONS(13558),
    [anon_sym_const] = ACTIONS(13558),
    [anon_sym_global] = ACTIONS(13558),
    [anon_sym_local] = ACTIONS(13558),
    [anon_sym_LPAREN] = ACTIONS(13558),
    [anon_sym_COLON2] = ACTIONS(13558),
    [anon_sym_export] = ACTIONS(13558),
    [anon_sym_import] = ACTIONS(13558),
    [anon_sym_using] = ACTIONS(13558),
    [anon_sym_LBRACK] = ACTIONS(13558),
    [anon_sym_LF] = ACTIONS(13560),
    [anon_sym_in] = ACTIONS(13558),
    [anon_sym_LBRACE] = ACTIONS(13558),
    [anon_sym_DOLLAR] = ACTIONS(13558),
    [anon_sym_COLON_COLON] = ACTIONS(13558),
    [anon_sym_isa] = ACTIONS(13558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13558),
    [anon_sym_QMARK] = ACTIONS(13558),
    [anon_sym_AT] = ACTIONS(13558),
    [anon_sym_true] = ACTIONS(13558),
    [anon_sym_false] = ACTIONS(13558),
    [aux_sym_integer_literal_token1] = ACTIONS(13558),
    [aux_sym_integer_literal_token2] = ACTIONS(13558),
    [aux_sym_integer_literal_token3] = ACTIONS(13558),
    [aux_sym_integer_literal_token4] = ACTIONS(13558),
    [aux_sym_float_literal_token1] = ACTIONS(13558),
    [aux_sym_float_literal_token3] = ACTIONS(13558),
    [aux_sym_float_literal_token4] = ACTIONS(13558),
    [sym_character_literal] = ACTIONS(13558),
    [sym__pair_operator] = ACTIONS(13558),
    [sym__arrow_operator] = ACTIONS(13558),
    [sym__lazy_or_operator] = ACTIONS(13558),
    [sym__lazy_and_operator] = ACTIONS(13558),
    [sym__comparison_operator] = ACTIONS(13558),
    [sym__pipe_right_operator] = ACTIONS(13558),
    [sym__pipe_left_operator] = ACTIONS(13558),
    [sym__ellipsis_operator] = ACTIONS(13558),
    [sym__plus_operator] = ACTIONS(13558),
    [sym__times_operator] = ACTIONS(13558),
    [sym__rational_operator] = ACTIONS(13558),
    [sym__bitshift_operator] = ACTIONS(13558),
    [sym__power_operator] = ACTIONS(13558),
    [sym__tilde_operator] = ACTIONS(13558),
    [sym__type_order_operator] = ACTIONS(13558),
    [sym__unary_operator] = ACTIONS(13558),
    [sym__unary_plus_operator] = ACTIONS(13558),
    [aux_sym__terminator_token1] = ACTIONS(13558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13560),
    [sym__command_start] = ACTIONS(13560),
  },
  [7540] = {
    [sym__word_identifier] = ACTIONS(13562),
    [anon_sym_EQ] = ACTIONS(13562),
    [anon_sym_COMMA] = ACTIONS(13562),
    [anon_sym_COLON] = ACTIONS(13562),
    [anon_sym_begin] = ACTIONS(13562),
    [anon_sym_module] = ACTIONS(13562),
    [anon_sym_baremodule] = ACTIONS(13562),
    [anon_sym_end] = ACTIONS(13562),
    [anon_sym_abstract] = ACTIONS(13562),
    [anon_sym_primitive] = ACTIONS(13562),
    [anon_sym_mutable] = ACTIONS(13562),
    [anon_sym_struct] = ACTIONS(13562),
    [anon_sym_function] = ACTIONS(13562),
    [anon_sym_macro] = ACTIONS(13562),
    [anon_sym_where] = ACTIONS(13562),
    [anon_sym_quote] = ACTIONS(13562),
    [anon_sym_let] = ACTIONS(13562),
    [anon_sym_if] = ACTIONS(13562),
    [anon_sym_elseif] = ACTIONS(13562),
    [anon_sym_else] = ACTIONS(13562),
    [anon_sym_try] = ACTIONS(13562),
    [anon_sym_for] = ACTIONS(13562),
    [anon_sym_while] = ACTIONS(13562),
    [sym_break_statement] = ACTIONS(13562),
    [sym_continue_statement] = ACTIONS(13562),
    [anon_sym_return] = ACTIONS(13562),
    [anon_sym_const] = ACTIONS(13562),
    [anon_sym_global] = ACTIONS(13562),
    [anon_sym_local] = ACTIONS(13562),
    [anon_sym_LPAREN] = ACTIONS(13562),
    [anon_sym_COLON2] = ACTIONS(13562),
    [anon_sym_export] = ACTIONS(13562),
    [anon_sym_import] = ACTIONS(13562),
    [anon_sym_using] = ACTIONS(13562),
    [anon_sym_LBRACK] = ACTIONS(13562),
    [anon_sym_LF] = ACTIONS(13564),
    [anon_sym_in] = ACTIONS(13562),
    [anon_sym_LBRACE] = ACTIONS(13562),
    [anon_sym_DOLLAR] = ACTIONS(13562),
    [anon_sym_COLON_COLON] = ACTIONS(13562),
    [anon_sym_isa] = ACTIONS(13562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13562),
    [anon_sym_QMARK] = ACTIONS(13562),
    [anon_sym_AT] = ACTIONS(13562),
    [anon_sym_true] = ACTIONS(13562),
    [anon_sym_false] = ACTIONS(13562),
    [aux_sym_integer_literal_token1] = ACTIONS(13562),
    [aux_sym_integer_literal_token2] = ACTIONS(13562),
    [aux_sym_integer_literal_token3] = ACTIONS(13562),
    [aux_sym_integer_literal_token4] = ACTIONS(13562),
    [aux_sym_float_literal_token1] = ACTIONS(13562),
    [aux_sym_float_literal_token3] = ACTIONS(13562),
    [aux_sym_float_literal_token4] = ACTIONS(13562),
    [sym_character_literal] = ACTIONS(13562),
    [sym__pair_operator] = ACTIONS(13562),
    [sym__arrow_operator] = ACTIONS(13562),
    [sym__lazy_or_operator] = ACTIONS(13562),
    [sym__lazy_and_operator] = ACTIONS(13562),
    [sym__comparison_operator] = ACTIONS(13562),
    [sym__pipe_right_operator] = ACTIONS(13562),
    [sym__pipe_left_operator] = ACTIONS(13562),
    [sym__ellipsis_operator] = ACTIONS(13562),
    [sym__plus_operator] = ACTIONS(13562),
    [sym__times_operator] = ACTIONS(13562),
    [sym__rational_operator] = ACTIONS(13562),
    [sym__bitshift_operator] = ACTIONS(13562),
    [sym__power_operator] = ACTIONS(13562),
    [sym__tilde_operator] = ACTIONS(13562),
    [sym__type_order_operator] = ACTIONS(13562),
    [sym__unary_operator] = ACTIONS(13562),
    [sym__unary_plus_operator] = ACTIONS(13562),
    [aux_sym__terminator_token1] = ACTIONS(13562),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13564),
    [sym__command_start] = ACTIONS(13564),
  },
  [7541] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7542] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(13670),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7543] = {
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13094),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_elseif] = ACTIONS(13094),
    [anon_sym_else] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13094),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13094),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13094),
    [anon_sym_isa] = ACTIONS(13094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13094),
    [anon_sym_QMARK] = ACTIONS(13094),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13094),
    [sym__lazy_or_operator] = ACTIONS(13094),
    [sym__lazy_and_operator] = ACTIONS(13094),
    [sym__comparison_operator] = ACTIONS(13094),
    [sym__pipe_right_operator] = ACTIONS(13094),
    [sym__pipe_left_operator] = ACTIONS(13094),
    [sym__ellipsis_operator] = ACTIONS(13094),
    [sym__plus_operator] = ACTIONS(13094),
    [sym__times_operator] = ACTIONS(13094),
    [sym__rational_operator] = ACTIONS(13094),
    [sym__bitshift_operator] = ACTIONS(13094),
    [sym__power_operator] = ACTIONS(13094),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13094),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13094),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [7544] = {
    [sym__word_identifier] = ACTIONS(13566),
    [anon_sym_EQ] = ACTIONS(13566),
    [anon_sym_COMMA] = ACTIONS(13566),
    [anon_sym_COLON] = ACTIONS(13566),
    [anon_sym_begin] = ACTIONS(13566),
    [anon_sym_module] = ACTIONS(13566),
    [anon_sym_baremodule] = ACTIONS(13566),
    [anon_sym_end] = ACTIONS(13566),
    [anon_sym_abstract] = ACTIONS(13566),
    [anon_sym_primitive] = ACTIONS(13566),
    [anon_sym_mutable] = ACTIONS(13566),
    [anon_sym_struct] = ACTIONS(13566),
    [anon_sym_function] = ACTIONS(13566),
    [anon_sym_macro] = ACTIONS(13566),
    [anon_sym_where] = ACTIONS(13566),
    [anon_sym_quote] = ACTIONS(13566),
    [anon_sym_let] = ACTIONS(13566),
    [anon_sym_if] = ACTIONS(13566),
    [anon_sym_elseif] = ACTIONS(13566),
    [anon_sym_else] = ACTIONS(13566),
    [anon_sym_try] = ACTIONS(13566),
    [anon_sym_for] = ACTIONS(13566),
    [anon_sym_while] = ACTIONS(13566),
    [sym_break_statement] = ACTIONS(13566),
    [sym_continue_statement] = ACTIONS(13566),
    [anon_sym_return] = ACTIONS(13566),
    [anon_sym_const] = ACTIONS(13566),
    [anon_sym_global] = ACTIONS(13566),
    [anon_sym_local] = ACTIONS(13566),
    [anon_sym_LPAREN] = ACTIONS(13566),
    [anon_sym_COLON2] = ACTIONS(13566),
    [anon_sym_export] = ACTIONS(13566),
    [anon_sym_import] = ACTIONS(13566),
    [anon_sym_using] = ACTIONS(13566),
    [anon_sym_LBRACK] = ACTIONS(13566),
    [anon_sym_LF] = ACTIONS(13568),
    [anon_sym_in] = ACTIONS(13566),
    [anon_sym_LBRACE] = ACTIONS(13566),
    [anon_sym_DOLLAR] = ACTIONS(13566),
    [anon_sym_COLON_COLON] = ACTIONS(13566),
    [anon_sym_isa] = ACTIONS(13566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13566),
    [anon_sym_QMARK] = ACTIONS(13566),
    [anon_sym_AT] = ACTIONS(13566),
    [anon_sym_true] = ACTIONS(13566),
    [anon_sym_false] = ACTIONS(13566),
    [aux_sym_integer_literal_token1] = ACTIONS(13566),
    [aux_sym_integer_literal_token2] = ACTIONS(13566),
    [aux_sym_integer_literal_token3] = ACTIONS(13566),
    [aux_sym_integer_literal_token4] = ACTIONS(13566),
    [aux_sym_float_literal_token1] = ACTIONS(13566),
    [aux_sym_float_literal_token3] = ACTIONS(13566),
    [aux_sym_float_literal_token4] = ACTIONS(13566),
    [sym_character_literal] = ACTIONS(13566),
    [sym__pair_operator] = ACTIONS(13566),
    [sym__arrow_operator] = ACTIONS(13566),
    [sym__lazy_or_operator] = ACTIONS(13566),
    [sym__lazy_and_operator] = ACTIONS(13566),
    [sym__comparison_operator] = ACTIONS(13566),
    [sym__pipe_right_operator] = ACTIONS(13566),
    [sym__pipe_left_operator] = ACTIONS(13566),
    [sym__ellipsis_operator] = ACTIONS(13566),
    [sym__plus_operator] = ACTIONS(13566),
    [sym__times_operator] = ACTIONS(13566),
    [sym__rational_operator] = ACTIONS(13566),
    [sym__bitshift_operator] = ACTIONS(13566),
    [sym__power_operator] = ACTIONS(13566),
    [sym__tilde_operator] = ACTIONS(13566),
    [sym__type_order_operator] = ACTIONS(13566),
    [sym__unary_operator] = ACTIONS(13566),
    [sym__unary_plus_operator] = ACTIONS(13566),
    [aux_sym__terminator_token1] = ACTIONS(13566),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13568),
    [sym__command_start] = ACTIONS(13568),
  },
  [7545] = {
    [sym__comprehension_clause] = STATE(18619),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16819),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13672),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13674),
    [anon_sym_LF] = ACTIONS(13676),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13679),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7546] = {
    [sym__word_identifier] = ACTIONS(13570),
    [anon_sym_EQ] = ACTIONS(13570),
    [anon_sym_COMMA] = ACTIONS(13570),
    [anon_sym_COLON] = ACTIONS(13570),
    [anon_sym_begin] = ACTIONS(13570),
    [anon_sym_module] = ACTIONS(13570),
    [anon_sym_baremodule] = ACTIONS(13570),
    [anon_sym_end] = ACTIONS(13570),
    [anon_sym_abstract] = ACTIONS(13570),
    [anon_sym_primitive] = ACTIONS(13570),
    [anon_sym_mutable] = ACTIONS(13570),
    [anon_sym_struct] = ACTIONS(13570),
    [anon_sym_function] = ACTIONS(13570),
    [anon_sym_macro] = ACTIONS(13570),
    [anon_sym_where] = ACTIONS(13570),
    [anon_sym_quote] = ACTIONS(13570),
    [anon_sym_let] = ACTIONS(13570),
    [anon_sym_if] = ACTIONS(13570),
    [anon_sym_elseif] = ACTIONS(13570),
    [anon_sym_else] = ACTIONS(13570),
    [anon_sym_try] = ACTIONS(13570),
    [anon_sym_for] = ACTIONS(13570),
    [anon_sym_while] = ACTIONS(13570),
    [sym_break_statement] = ACTIONS(13570),
    [sym_continue_statement] = ACTIONS(13570),
    [anon_sym_return] = ACTIONS(13570),
    [anon_sym_const] = ACTIONS(13570),
    [anon_sym_global] = ACTIONS(13570),
    [anon_sym_local] = ACTIONS(13570),
    [anon_sym_LPAREN] = ACTIONS(13570),
    [anon_sym_COLON2] = ACTIONS(13570),
    [anon_sym_export] = ACTIONS(13570),
    [anon_sym_import] = ACTIONS(13570),
    [anon_sym_using] = ACTIONS(13570),
    [anon_sym_LBRACK] = ACTIONS(13570),
    [anon_sym_LF] = ACTIONS(13572),
    [anon_sym_in] = ACTIONS(13570),
    [anon_sym_LBRACE] = ACTIONS(13570),
    [anon_sym_DOLLAR] = ACTIONS(13570),
    [anon_sym_COLON_COLON] = ACTIONS(13570),
    [anon_sym_isa] = ACTIONS(13570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13570),
    [anon_sym_QMARK] = ACTIONS(13570),
    [anon_sym_AT] = ACTIONS(13570),
    [anon_sym_true] = ACTIONS(13570),
    [anon_sym_false] = ACTIONS(13570),
    [aux_sym_integer_literal_token1] = ACTIONS(13570),
    [aux_sym_integer_literal_token2] = ACTIONS(13570),
    [aux_sym_integer_literal_token3] = ACTIONS(13570),
    [aux_sym_integer_literal_token4] = ACTIONS(13570),
    [aux_sym_float_literal_token1] = ACTIONS(13570),
    [aux_sym_float_literal_token3] = ACTIONS(13570),
    [aux_sym_float_literal_token4] = ACTIONS(13570),
    [sym_character_literal] = ACTIONS(13570),
    [sym__pair_operator] = ACTIONS(13570),
    [sym__arrow_operator] = ACTIONS(13570),
    [sym__lazy_or_operator] = ACTIONS(13570),
    [sym__lazy_and_operator] = ACTIONS(13570),
    [sym__comparison_operator] = ACTIONS(13570),
    [sym__pipe_right_operator] = ACTIONS(13570),
    [sym__pipe_left_operator] = ACTIONS(13570),
    [sym__ellipsis_operator] = ACTIONS(13570),
    [sym__plus_operator] = ACTIONS(13570),
    [sym__times_operator] = ACTIONS(13570),
    [sym__rational_operator] = ACTIONS(13570),
    [sym__bitshift_operator] = ACTIONS(13570),
    [sym__power_operator] = ACTIONS(13570),
    [sym__tilde_operator] = ACTIONS(13570),
    [sym__type_order_operator] = ACTIONS(13570),
    [sym__unary_operator] = ACTIONS(13570),
    [sym__unary_plus_operator] = ACTIONS(13570),
    [aux_sym__terminator_token1] = ACTIONS(13570),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13572),
    [sym__command_start] = ACTIONS(13572),
  },
  [7547] = {
    [sym__word_identifier] = ACTIONS(13574),
    [anon_sym_EQ] = ACTIONS(13574),
    [anon_sym_COMMA] = ACTIONS(13574),
    [anon_sym_COLON] = ACTIONS(13574),
    [anon_sym_begin] = ACTIONS(13574),
    [anon_sym_module] = ACTIONS(13574),
    [anon_sym_baremodule] = ACTIONS(13574),
    [anon_sym_end] = ACTIONS(13574),
    [anon_sym_abstract] = ACTIONS(13574),
    [anon_sym_primitive] = ACTIONS(13574),
    [anon_sym_mutable] = ACTIONS(13574),
    [anon_sym_struct] = ACTIONS(13574),
    [anon_sym_function] = ACTIONS(13574),
    [anon_sym_macro] = ACTIONS(13574),
    [anon_sym_where] = ACTIONS(13574),
    [anon_sym_quote] = ACTIONS(13574),
    [anon_sym_let] = ACTIONS(13574),
    [anon_sym_if] = ACTIONS(13574),
    [anon_sym_elseif] = ACTIONS(13574),
    [anon_sym_else] = ACTIONS(13574),
    [anon_sym_try] = ACTIONS(13574),
    [anon_sym_for] = ACTIONS(13574),
    [anon_sym_while] = ACTIONS(13574),
    [sym_break_statement] = ACTIONS(13574),
    [sym_continue_statement] = ACTIONS(13574),
    [anon_sym_return] = ACTIONS(13574),
    [anon_sym_const] = ACTIONS(13574),
    [anon_sym_global] = ACTIONS(13574),
    [anon_sym_local] = ACTIONS(13574),
    [anon_sym_LPAREN] = ACTIONS(13574),
    [anon_sym_COLON2] = ACTIONS(13574),
    [anon_sym_export] = ACTIONS(13574),
    [anon_sym_import] = ACTIONS(13574),
    [anon_sym_using] = ACTIONS(13574),
    [anon_sym_LBRACK] = ACTIONS(13574),
    [anon_sym_LF] = ACTIONS(13576),
    [anon_sym_in] = ACTIONS(13574),
    [anon_sym_LBRACE] = ACTIONS(13574),
    [anon_sym_DOLLAR] = ACTIONS(13574),
    [anon_sym_COLON_COLON] = ACTIONS(13574),
    [anon_sym_isa] = ACTIONS(13574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13574),
    [anon_sym_QMARK] = ACTIONS(13574),
    [anon_sym_AT] = ACTIONS(13574),
    [anon_sym_true] = ACTIONS(13574),
    [anon_sym_false] = ACTIONS(13574),
    [aux_sym_integer_literal_token1] = ACTIONS(13574),
    [aux_sym_integer_literal_token2] = ACTIONS(13574),
    [aux_sym_integer_literal_token3] = ACTIONS(13574),
    [aux_sym_integer_literal_token4] = ACTIONS(13574),
    [aux_sym_float_literal_token1] = ACTIONS(13574),
    [aux_sym_float_literal_token3] = ACTIONS(13574),
    [aux_sym_float_literal_token4] = ACTIONS(13574),
    [sym_character_literal] = ACTIONS(13574),
    [sym__pair_operator] = ACTIONS(13574),
    [sym__arrow_operator] = ACTIONS(13574),
    [sym__lazy_or_operator] = ACTIONS(13574),
    [sym__lazy_and_operator] = ACTIONS(13574),
    [sym__comparison_operator] = ACTIONS(13574),
    [sym__pipe_right_operator] = ACTIONS(13574),
    [sym__pipe_left_operator] = ACTIONS(13574),
    [sym__ellipsis_operator] = ACTIONS(13574),
    [sym__plus_operator] = ACTIONS(13574),
    [sym__times_operator] = ACTIONS(13574),
    [sym__rational_operator] = ACTIONS(13574),
    [sym__bitshift_operator] = ACTIONS(13574),
    [sym__power_operator] = ACTIONS(13574),
    [sym__tilde_operator] = ACTIONS(13574),
    [sym__type_order_operator] = ACTIONS(13574),
    [sym__unary_operator] = ACTIONS(13574),
    [sym__unary_plus_operator] = ACTIONS(13574),
    [aux_sym__terminator_token1] = ACTIONS(13574),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13576),
    [sym__command_start] = ACTIONS(13576),
  },
  [7548] = {
    [sym__word_identifier] = ACTIONS(13578),
    [anon_sym_EQ] = ACTIONS(13578),
    [anon_sym_COMMA] = ACTIONS(13578),
    [anon_sym_COLON] = ACTIONS(13578),
    [anon_sym_begin] = ACTIONS(13578),
    [anon_sym_module] = ACTIONS(13578),
    [anon_sym_baremodule] = ACTIONS(13578),
    [anon_sym_end] = ACTIONS(13578),
    [anon_sym_abstract] = ACTIONS(13578),
    [anon_sym_primitive] = ACTIONS(13578),
    [anon_sym_mutable] = ACTIONS(13578),
    [anon_sym_struct] = ACTIONS(13578),
    [anon_sym_function] = ACTIONS(13578),
    [anon_sym_macro] = ACTIONS(13578),
    [anon_sym_where] = ACTIONS(13578),
    [anon_sym_quote] = ACTIONS(13578),
    [anon_sym_let] = ACTIONS(13578),
    [anon_sym_if] = ACTIONS(13578),
    [anon_sym_elseif] = ACTIONS(13578),
    [anon_sym_else] = ACTIONS(13578),
    [anon_sym_try] = ACTIONS(13578),
    [anon_sym_for] = ACTIONS(13578),
    [anon_sym_while] = ACTIONS(13578),
    [sym_break_statement] = ACTIONS(13578),
    [sym_continue_statement] = ACTIONS(13578),
    [anon_sym_return] = ACTIONS(13578),
    [anon_sym_const] = ACTIONS(13578),
    [anon_sym_global] = ACTIONS(13578),
    [anon_sym_local] = ACTIONS(13578),
    [anon_sym_LPAREN] = ACTIONS(13578),
    [anon_sym_COLON2] = ACTIONS(13578),
    [anon_sym_export] = ACTIONS(13578),
    [anon_sym_import] = ACTIONS(13578),
    [anon_sym_using] = ACTIONS(13578),
    [anon_sym_LBRACK] = ACTIONS(13578),
    [anon_sym_LF] = ACTIONS(13580),
    [anon_sym_in] = ACTIONS(13578),
    [anon_sym_LBRACE] = ACTIONS(13578),
    [anon_sym_DOLLAR] = ACTIONS(13578),
    [anon_sym_COLON_COLON] = ACTIONS(13578),
    [anon_sym_isa] = ACTIONS(13578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13578),
    [anon_sym_QMARK] = ACTIONS(13578),
    [anon_sym_AT] = ACTIONS(13578),
    [anon_sym_true] = ACTIONS(13578),
    [anon_sym_false] = ACTIONS(13578),
    [aux_sym_integer_literal_token1] = ACTIONS(13578),
    [aux_sym_integer_literal_token2] = ACTIONS(13578),
    [aux_sym_integer_literal_token3] = ACTIONS(13578),
    [aux_sym_integer_literal_token4] = ACTIONS(13578),
    [aux_sym_float_literal_token1] = ACTIONS(13578),
    [aux_sym_float_literal_token3] = ACTIONS(13578),
    [aux_sym_float_literal_token4] = ACTIONS(13578),
    [sym_character_literal] = ACTIONS(13578),
    [sym__pair_operator] = ACTIONS(13578),
    [sym__arrow_operator] = ACTIONS(13578),
    [sym__lazy_or_operator] = ACTIONS(13578),
    [sym__lazy_and_operator] = ACTIONS(13578),
    [sym__comparison_operator] = ACTIONS(13578),
    [sym__pipe_right_operator] = ACTIONS(13578),
    [sym__pipe_left_operator] = ACTIONS(13578),
    [sym__ellipsis_operator] = ACTIONS(13578),
    [sym__plus_operator] = ACTIONS(13578),
    [sym__times_operator] = ACTIONS(13578),
    [sym__rational_operator] = ACTIONS(13578),
    [sym__bitshift_operator] = ACTIONS(13578),
    [sym__power_operator] = ACTIONS(13578),
    [sym__tilde_operator] = ACTIONS(13578),
    [sym__type_order_operator] = ACTIONS(13578),
    [sym__unary_operator] = ACTIONS(13578),
    [sym__unary_plus_operator] = ACTIONS(13578),
    [aux_sym__terminator_token1] = ACTIONS(13578),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13580),
    [sym__command_start] = ACTIONS(13580),
  },
  [7549] = {
    [sym__word_identifier] = ACTIONS(13582),
    [anon_sym_EQ] = ACTIONS(13582),
    [anon_sym_COMMA] = ACTIONS(13582),
    [anon_sym_COLON] = ACTIONS(13582),
    [anon_sym_begin] = ACTIONS(13582),
    [anon_sym_module] = ACTIONS(13582),
    [anon_sym_baremodule] = ACTIONS(13582),
    [anon_sym_end] = ACTIONS(13582),
    [anon_sym_abstract] = ACTIONS(13582),
    [anon_sym_primitive] = ACTIONS(13582),
    [anon_sym_mutable] = ACTIONS(13582),
    [anon_sym_struct] = ACTIONS(13582),
    [anon_sym_function] = ACTIONS(13582),
    [anon_sym_macro] = ACTIONS(13582),
    [anon_sym_where] = ACTIONS(13582),
    [anon_sym_quote] = ACTIONS(13582),
    [anon_sym_let] = ACTIONS(13582),
    [anon_sym_if] = ACTIONS(13582),
    [anon_sym_elseif] = ACTIONS(13582),
    [anon_sym_else] = ACTIONS(13582),
    [anon_sym_try] = ACTIONS(13582),
    [anon_sym_for] = ACTIONS(13582),
    [anon_sym_while] = ACTIONS(13582),
    [sym_break_statement] = ACTIONS(13582),
    [sym_continue_statement] = ACTIONS(13582),
    [anon_sym_return] = ACTIONS(13582),
    [anon_sym_const] = ACTIONS(13582),
    [anon_sym_global] = ACTIONS(13582),
    [anon_sym_local] = ACTIONS(13582),
    [anon_sym_LPAREN] = ACTIONS(13582),
    [anon_sym_COLON2] = ACTIONS(13582),
    [anon_sym_export] = ACTIONS(13582),
    [anon_sym_import] = ACTIONS(13582),
    [anon_sym_using] = ACTIONS(13582),
    [anon_sym_LBRACK] = ACTIONS(13582),
    [anon_sym_LF] = ACTIONS(13584),
    [anon_sym_in] = ACTIONS(13582),
    [anon_sym_LBRACE] = ACTIONS(13582),
    [anon_sym_DOLLAR] = ACTIONS(13582),
    [anon_sym_COLON_COLON] = ACTIONS(13582),
    [anon_sym_isa] = ACTIONS(13582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13582),
    [anon_sym_QMARK] = ACTIONS(13582),
    [anon_sym_AT] = ACTIONS(13582),
    [anon_sym_true] = ACTIONS(13582),
    [anon_sym_false] = ACTIONS(13582),
    [aux_sym_integer_literal_token1] = ACTIONS(13582),
    [aux_sym_integer_literal_token2] = ACTIONS(13582),
    [aux_sym_integer_literal_token3] = ACTIONS(13582),
    [aux_sym_integer_literal_token4] = ACTIONS(13582),
    [aux_sym_float_literal_token1] = ACTIONS(13582),
    [aux_sym_float_literal_token3] = ACTIONS(13582),
    [aux_sym_float_literal_token4] = ACTIONS(13582),
    [sym_character_literal] = ACTIONS(13582),
    [sym__pair_operator] = ACTIONS(13582),
    [sym__arrow_operator] = ACTIONS(13582),
    [sym__lazy_or_operator] = ACTIONS(13582),
    [sym__lazy_and_operator] = ACTIONS(13582),
    [sym__comparison_operator] = ACTIONS(13582),
    [sym__pipe_right_operator] = ACTIONS(13582),
    [sym__pipe_left_operator] = ACTIONS(13582),
    [sym__ellipsis_operator] = ACTIONS(13582),
    [sym__plus_operator] = ACTIONS(13582),
    [sym__times_operator] = ACTIONS(13582),
    [sym__rational_operator] = ACTIONS(13582),
    [sym__bitshift_operator] = ACTIONS(13582),
    [sym__power_operator] = ACTIONS(13582),
    [sym__tilde_operator] = ACTIONS(13582),
    [sym__type_order_operator] = ACTIONS(13582),
    [sym__unary_operator] = ACTIONS(13582),
    [sym__unary_plus_operator] = ACTIONS(13582),
    [aux_sym__terminator_token1] = ACTIONS(13582),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13584),
    [sym__command_start] = ACTIONS(13584),
  },
  [7550] = {
    [sym__word_identifier] = ACTIONS(13586),
    [anon_sym_EQ] = ACTIONS(13586),
    [anon_sym_COMMA] = ACTIONS(13586),
    [anon_sym_COLON] = ACTIONS(13586),
    [anon_sym_begin] = ACTIONS(13586),
    [anon_sym_module] = ACTIONS(13586),
    [anon_sym_baremodule] = ACTIONS(13586),
    [anon_sym_end] = ACTIONS(13586),
    [anon_sym_abstract] = ACTIONS(13586),
    [anon_sym_primitive] = ACTIONS(13586),
    [anon_sym_mutable] = ACTIONS(13586),
    [anon_sym_struct] = ACTIONS(13586),
    [anon_sym_function] = ACTIONS(13586),
    [anon_sym_macro] = ACTIONS(13586),
    [anon_sym_where] = ACTIONS(13586),
    [anon_sym_quote] = ACTIONS(13586),
    [anon_sym_let] = ACTIONS(13586),
    [anon_sym_if] = ACTIONS(13586),
    [anon_sym_elseif] = ACTIONS(13586),
    [anon_sym_else] = ACTIONS(13586),
    [anon_sym_try] = ACTIONS(13586),
    [anon_sym_for] = ACTIONS(13586),
    [anon_sym_while] = ACTIONS(13586),
    [sym_break_statement] = ACTIONS(13586),
    [sym_continue_statement] = ACTIONS(13586),
    [anon_sym_return] = ACTIONS(13586),
    [anon_sym_const] = ACTIONS(13586),
    [anon_sym_global] = ACTIONS(13586),
    [anon_sym_local] = ACTIONS(13586),
    [anon_sym_LPAREN] = ACTIONS(13586),
    [anon_sym_COLON2] = ACTIONS(13586),
    [anon_sym_export] = ACTIONS(13586),
    [anon_sym_import] = ACTIONS(13586),
    [anon_sym_using] = ACTIONS(13586),
    [anon_sym_LBRACK] = ACTIONS(13586),
    [anon_sym_LF] = ACTIONS(13588),
    [anon_sym_in] = ACTIONS(13586),
    [anon_sym_LBRACE] = ACTIONS(13586),
    [anon_sym_DOLLAR] = ACTIONS(13586),
    [anon_sym_COLON_COLON] = ACTIONS(13586),
    [anon_sym_isa] = ACTIONS(13586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13586),
    [anon_sym_QMARK] = ACTIONS(13586),
    [anon_sym_AT] = ACTIONS(13586),
    [anon_sym_true] = ACTIONS(13586),
    [anon_sym_false] = ACTIONS(13586),
    [aux_sym_integer_literal_token1] = ACTIONS(13586),
    [aux_sym_integer_literal_token2] = ACTIONS(13586),
    [aux_sym_integer_literal_token3] = ACTIONS(13586),
    [aux_sym_integer_literal_token4] = ACTIONS(13586),
    [aux_sym_float_literal_token1] = ACTIONS(13586),
    [aux_sym_float_literal_token3] = ACTIONS(13586),
    [aux_sym_float_literal_token4] = ACTIONS(13586),
    [sym_character_literal] = ACTIONS(13586),
    [sym__pair_operator] = ACTIONS(13586),
    [sym__arrow_operator] = ACTIONS(13586),
    [sym__lazy_or_operator] = ACTIONS(13586),
    [sym__lazy_and_operator] = ACTIONS(13586),
    [sym__comparison_operator] = ACTIONS(13586),
    [sym__pipe_right_operator] = ACTIONS(13586),
    [sym__pipe_left_operator] = ACTIONS(13586),
    [sym__ellipsis_operator] = ACTIONS(13586),
    [sym__plus_operator] = ACTIONS(13586),
    [sym__times_operator] = ACTIONS(13586),
    [sym__rational_operator] = ACTIONS(13586),
    [sym__bitshift_operator] = ACTIONS(13586),
    [sym__power_operator] = ACTIONS(13586),
    [sym__tilde_operator] = ACTIONS(13586),
    [sym__type_order_operator] = ACTIONS(13586),
    [sym__unary_operator] = ACTIONS(13586),
    [sym__unary_plus_operator] = ACTIONS(13586),
    [aux_sym__terminator_token1] = ACTIONS(13586),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13588),
    [sym__command_start] = ACTIONS(13588),
  },
  [7551] = {
    [sym__word_identifier] = ACTIONS(13590),
    [anon_sym_EQ] = ACTIONS(13590),
    [anon_sym_COMMA] = ACTIONS(13590),
    [anon_sym_COLON] = ACTIONS(13590),
    [anon_sym_begin] = ACTIONS(13590),
    [anon_sym_module] = ACTIONS(13590),
    [anon_sym_baremodule] = ACTIONS(13590),
    [anon_sym_end] = ACTIONS(13590),
    [anon_sym_abstract] = ACTIONS(13590),
    [anon_sym_primitive] = ACTIONS(13590),
    [anon_sym_mutable] = ACTIONS(13590),
    [anon_sym_struct] = ACTIONS(13590),
    [anon_sym_function] = ACTIONS(13590),
    [anon_sym_macro] = ACTIONS(13590),
    [anon_sym_where] = ACTIONS(13590),
    [anon_sym_quote] = ACTIONS(13590),
    [anon_sym_let] = ACTIONS(13590),
    [anon_sym_if] = ACTIONS(13590),
    [anon_sym_elseif] = ACTIONS(13590),
    [anon_sym_else] = ACTIONS(13590),
    [anon_sym_try] = ACTIONS(13590),
    [anon_sym_for] = ACTIONS(13590),
    [anon_sym_while] = ACTIONS(13590),
    [sym_break_statement] = ACTIONS(13590),
    [sym_continue_statement] = ACTIONS(13590),
    [anon_sym_return] = ACTIONS(13590),
    [anon_sym_const] = ACTIONS(13590),
    [anon_sym_global] = ACTIONS(13590),
    [anon_sym_local] = ACTIONS(13590),
    [anon_sym_LPAREN] = ACTIONS(13590),
    [anon_sym_COLON2] = ACTIONS(13590),
    [anon_sym_export] = ACTIONS(13590),
    [anon_sym_import] = ACTIONS(13590),
    [anon_sym_using] = ACTIONS(13590),
    [anon_sym_LBRACK] = ACTIONS(13590),
    [anon_sym_LF] = ACTIONS(13592),
    [anon_sym_in] = ACTIONS(13590),
    [anon_sym_LBRACE] = ACTIONS(13590),
    [anon_sym_DOLLAR] = ACTIONS(13590),
    [anon_sym_COLON_COLON] = ACTIONS(13590),
    [anon_sym_isa] = ACTIONS(13590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13590),
    [anon_sym_QMARK] = ACTIONS(13590),
    [anon_sym_AT] = ACTIONS(13590),
    [anon_sym_true] = ACTIONS(13590),
    [anon_sym_false] = ACTIONS(13590),
    [aux_sym_integer_literal_token1] = ACTIONS(13590),
    [aux_sym_integer_literal_token2] = ACTIONS(13590),
    [aux_sym_integer_literal_token3] = ACTIONS(13590),
    [aux_sym_integer_literal_token4] = ACTIONS(13590),
    [aux_sym_float_literal_token1] = ACTIONS(13590),
    [aux_sym_float_literal_token3] = ACTIONS(13590),
    [aux_sym_float_literal_token4] = ACTIONS(13590),
    [sym_character_literal] = ACTIONS(13590),
    [sym__pair_operator] = ACTIONS(13590),
    [sym__arrow_operator] = ACTIONS(13590),
    [sym__lazy_or_operator] = ACTIONS(13590),
    [sym__lazy_and_operator] = ACTIONS(13590),
    [sym__comparison_operator] = ACTIONS(13590),
    [sym__pipe_right_operator] = ACTIONS(13590),
    [sym__pipe_left_operator] = ACTIONS(13590),
    [sym__ellipsis_operator] = ACTIONS(13590),
    [sym__plus_operator] = ACTIONS(13590),
    [sym__times_operator] = ACTIONS(13590),
    [sym__rational_operator] = ACTIONS(13590),
    [sym__bitshift_operator] = ACTIONS(13590),
    [sym__power_operator] = ACTIONS(13590),
    [sym__tilde_operator] = ACTIONS(13590),
    [sym__type_order_operator] = ACTIONS(13590),
    [sym__unary_operator] = ACTIONS(13590),
    [sym__unary_plus_operator] = ACTIONS(13590),
    [aux_sym__terminator_token1] = ACTIONS(13590),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13592),
    [sym__command_start] = ACTIONS(13592),
  },
  [7552] = {
    [aux_sym_export_statement_repeat1] = STATE(7569),
    [sym__word_identifier] = ACTIONS(13060),
    [anon_sym_EQ] = ACTIONS(13060),
    [anon_sym_COMMA] = ACTIONS(13668),
    [anon_sym_COLON] = ACTIONS(13060),
    [anon_sym_begin] = ACTIONS(13060),
    [anon_sym_module] = ACTIONS(13060),
    [anon_sym_baremodule] = ACTIONS(13060),
    [anon_sym_end] = ACTIONS(13060),
    [anon_sym_abstract] = ACTIONS(13060),
    [anon_sym_primitive] = ACTIONS(13060),
    [anon_sym_mutable] = ACTIONS(13060),
    [anon_sym_struct] = ACTIONS(13060),
    [anon_sym_function] = ACTIONS(13060),
    [anon_sym_macro] = ACTIONS(13060),
    [anon_sym_where] = ACTIONS(13060),
    [anon_sym_quote] = ACTIONS(13060),
    [anon_sym_let] = ACTIONS(13060),
    [anon_sym_if] = ACTIONS(13060),
    [anon_sym_try] = ACTIONS(13060),
    [anon_sym_catch] = ACTIONS(13060),
    [anon_sym_for] = ACTIONS(13060),
    [anon_sym_while] = ACTIONS(13060),
    [sym_break_statement] = ACTIONS(13060),
    [sym_continue_statement] = ACTIONS(13060),
    [anon_sym_return] = ACTIONS(13060),
    [anon_sym_const] = ACTIONS(13060),
    [anon_sym_global] = ACTIONS(13060),
    [anon_sym_local] = ACTIONS(13060),
    [anon_sym_LPAREN] = ACTIONS(13060),
    [anon_sym_COLON2] = ACTIONS(13060),
    [anon_sym_export] = ACTIONS(13060),
    [anon_sym_import] = ACTIONS(13060),
    [anon_sym_using] = ACTIONS(13060),
    [anon_sym_LBRACK] = ACTIONS(13060),
    [anon_sym_LF] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13060),
    [anon_sym_LBRACE] = ACTIONS(13060),
    [anon_sym_DOLLAR] = ACTIONS(13060),
    [anon_sym_COLON_COLON] = ACTIONS(13060),
    [anon_sym_isa] = ACTIONS(13060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13060),
    [anon_sym_QMARK] = ACTIONS(13060),
    [anon_sym_AT] = ACTIONS(13060),
    [anon_sym_true] = ACTIONS(13060),
    [anon_sym_false] = ACTIONS(13060),
    [aux_sym_integer_literal_token1] = ACTIONS(13060),
    [aux_sym_integer_literal_token2] = ACTIONS(13060),
    [aux_sym_integer_literal_token3] = ACTIONS(13060),
    [aux_sym_integer_literal_token4] = ACTIONS(13060),
    [aux_sym_float_literal_token1] = ACTIONS(13060),
    [aux_sym_float_literal_token3] = ACTIONS(13060),
    [aux_sym_float_literal_token4] = ACTIONS(13060),
    [sym_character_literal] = ACTIONS(13060),
    [sym__pair_operator] = ACTIONS(13060),
    [sym__arrow_operator] = ACTIONS(13060),
    [sym__lazy_or_operator] = ACTIONS(13060),
    [sym__lazy_and_operator] = ACTIONS(13060),
    [sym__comparison_operator] = ACTIONS(13060),
    [sym__pipe_right_operator] = ACTIONS(13060),
    [sym__pipe_left_operator] = ACTIONS(13060),
    [sym__ellipsis_operator] = ACTIONS(13060),
    [sym__plus_operator] = ACTIONS(13060),
    [sym__times_operator] = ACTIONS(13060),
    [sym__rational_operator] = ACTIONS(13060),
    [sym__bitshift_operator] = ACTIONS(13060),
    [sym__power_operator] = ACTIONS(13060),
    [sym__tilde_operator] = ACTIONS(13060),
    [sym__type_order_operator] = ACTIONS(13060),
    [sym__unary_operator] = ACTIONS(13060),
    [sym__unary_plus_operator] = ACTIONS(13060),
    [aux_sym__terminator_token1] = ACTIONS(13060),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13064),
    [sym__command_start] = ACTIONS(13064),
  },
  [7553] = {
    [sym__word_identifier] = ACTIONS(13594),
    [anon_sym_EQ] = ACTIONS(13594),
    [anon_sym_COMMA] = ACTIONS(13594),
    [anon_sym_COLON] = ACTIONS(13594),
    [anon_sym_begin] = ACTIONS(13594),
    [anon_sym_module] = ACTIONS(13594),
    [anon_sym_baremodule] = ACTIONS(13594),
    [anon_sym_end] = ACTIONS(13594),
    [anon_sym_abstract] = ACTIONS(13594),
    [anon_sym_primitive] = ACTIONS(13594),
    [anon_sym_mutable] = ACTIONS(13594),
    [anon_sym_struct] = ACTIONS(13594),
    [anon_sym_function] = ACTIONS(13594),
    [anon_sym_macro] = ACTIONS(13594),
    [anon_sym_where] = ACTIONS(13594),
    [anon_sym_quote] = ACTIONS(13594),
    [anon_sym_let] = ACTIONS(13594),
    [anon_sym_if] = ACTIONS(13594),
    [anon_sym_elseif] = ACTIONS(13594),
    [anon_sym_else] = ACTIONS(13594),
    [anon_sym_try] = ACTIONS(13594),
    [anon_sym_for] = ACTIONS(13594),
    [anon_sym_while] = ACTIONS(13594),
    [sym_break_statement] = ACTIONS(13594),
    [sym_continue_statement] = ACTIONS(13594),
    [anon_sym_return] = ACTIONS(13594),
    [anon_sym_const] = ACTIONS(13594),
    [anon_sym_global] = ACTIONS(13594),
    [anon_sym_local] = ACTIONS(13594),
    [anon_sym_LPAREN] = ACTIONS(13594),
    [anon_sym_COLON2] = ACTIONS(13594),
    [anon_sym_export] = ACTIONS(13594),
    [anon_sym_import] = ACTIONS(13594),
    [anon_sym_using] = ACTIONS(13594),
    [anon_sym_LBRACK] = ACTIONS(13594),
    [anon_sym_LF] = ACTIONS(13596),
    [anon_sym_in] = ACTIONS(13594),
    [anon_sym_LBRACE] = ACTIONS(13594),
    [anon_sym_DOLLAR] = ACTIONS(13594),
    [anon_sym_COLON_COLON] = ACTIONS(13594),
    [anon_sym_isa] = ACTIONS(13594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13594),
    [anon_sym_QMARK] = ACTIONS(13594),
    [anon_sym_AT] = ACTIONS(13594),
    [anon_sym_true] = ACTIONS(13594),
    [anon_sym_false] = ACTIONS(13594),
    [aux_sym_integer_literal_token1] = ACTIONS(13594),
    [aux_sym_integer_literal_token2] = ACTIONS(13594),
    [aux_sym_integer_literal_token3] = ACTIONS(13594),
    [aux_sym_integer_literal_token4] = ACTIONS(13594),
    [aux_sym_float_literal_token1] = ACTIONS(13594),
    [aux_sym_float_literal_token3] = ACTIONS(13594),
    [aux_sym_float_literal_token4] = ACTIONS(13594),
    [sym_character_literal] = ACTIONS(13594),
    [sym__pair_operator] = ACTIONS(13594),
    [sym__arrow_operator] = ACTIONS(13594),
    [sym__lazy_or_operator] = ACTIONS(13594),
    [sym__lazy_and_operator] = ACTIONS(13594),
    [sym__comparison_operator] = ACTIONS(13594),
    [sym__pipe_right_operator] = ACTIONS(13594),
    [sym__pipe_left_operator] = ACTIONS(13594),
    [sym__ellipsis_operator] = ACTIONS(13594),
    [sym__plus_operator] = ACTIONS(13594),
    [sym__times_operator] = ACTIONS(13594),
    [sym__rational_operator] = ACTIONS(13594),
    [sym__bitshift_operator] = ACTIONS(13594),
    [sym__power_operator] = ACTIONS(13594),
    [sym__tilde_operator] = ACTIONS(13594),
    [sym__type_order_operator] = ACTIONS(13594),
    [sym__unary_operator] = ACTIONS(13594),
    [sym__unary_plus_operator] = ACTIONS(13594),
    [aux_sym__terminator_token1] = ACTIONS(13594),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13596),
    [sym__command_start] = ACTIONS(13596),
  },
  [7554] = {
    [aux_sym__import_list_repeat1] = STATE(7571),
    [sym__word_identifier] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13020),
    [anon_sym_COLON] = ACTIONS(13066),
    [anon_sym_begin] = ACTIONS(13066),
    [anon_sym_module] = ACTIONS(13066),
    [anon_sym_baremodule] = ACTIONS(13066),
    [anon_sym_end] = ACTIONS(13066),
    [anon_sym_abstract] = ACTIONS(13066),
    [anon_sym_primitive] = ACTIONS(13066),
    [anon_sym_mutable] = ACTIONS(13066),
    [anon_sym_struct] = ACTIONS(13066),
    [anon_sym_function] = ACTIONS(13066),
    [anon_sym_macro] = ACTIONS(13066),
    [anon_sym_where] = ACTIONS(13066),
    [anon_sym_quote] = ACTIONS(13066),
    [anon_sym_let] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13066),
    [anon_sym_try] = ACTIONS(13066),
    [anon_sym_catch] = ACTIONS(13066),
    [anon_sym_for] = ACTIONS(13066),
    [anon_sym_while] = ACTIONS(13066),
    [sym_break_statement] = ACTIONS(13066),
    [sym_continue_statement] = ACTIONS(13066),
    [anon_sym_return] = ACTIONS(13066),
    [anon_sym_const] = ACTIONS(13066),
    [anon_sym_global] = ACTIONS(13066),
    [anon_sym_local] = ACTIONS(13066),
    [anon_sym_LPAREN] = ACTIONS(13066),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_export] = ACTIONS(13066),
    [anon_sym_import] = ACTIONS(13066),
    [anon_sym_using] = ACTIONS(13066),
    [anon_sym_LBRACK] = ACTIONS(13066),
    [anon_sym_LF] = ACTIONS(13068),
    [anon_sym_in] = ACTIONS(13066),
    [anon_sym_LBRACE] = ACTIONS(13066),
    [anon_sym_DOLLAR] = ACTIONS(13066),
    [anon_sym_COLON_COLON] = ACTIONS(13066),
    [anon_sym_isa] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13066),
    [anon_sym_QMARK] = ACTIONS(13066),
    [anon_sym_AT] = ACTIONS(13066),
    [anon_sym_true] = ACTIONS(13066),
    [anon_sym_false] = ACTIONS(13066),
    [aux_sym_integer_literal_token1] = ACTIONS(13066),
    [aux_sym_integer_literal_token2] = ACTIONS(13066),
    [aux_sym_integer_literal_token3] = ACTIONS(13066),
    [aux_sym_integer_literal_token4] = ACTIONS(13066),
    [aux_sym_float_literal_token1] = ACTIONS(13066),
    [aux_sym_float_literal_token3] = ACTIONS(13066),
    [aux_sym_float_literal_token4] = ACTIONS(13066),
    [sym_character_literal] = ACTIONS(13066),
    [sym__pair_operator] = ACTIONS(13066),
    [sym__arrow_operator] = ACTIONS(13066),
    [sym__lazy_or_operator] = ACTIONS(13066),
    [sym__lazy_and_operator] = ACTIONS(13066),
    [sym__comparison_operator] = ACTIONS(13066),
    [sym__pipe_right_operator] = ACTIONS(13066),
    [sym__pipe_left_operator] = ACTIONS(13066),
    [sym__ellipsis_operator] = ACTIONS(13066),
    [sym__plus_operator] = ACTIONS(13066),
    [sym__times_operator] = ACTIONS(13066),
    [sym__rational_operator] = ACTIONS(13066),
    [sym__bitshift_operator] = ACTIONS(13066),
    [sym__power_operator] = ACTIONS(13066),
    [sym__tilde_operator] = ACTIONS(13066),
    [sym__type_order_operator] = ACTIONS(13066),
    [sym__unary_operator] = ACTIONS(13066),
    [sym__unary_plus_operator] = ACTIONS(13066),
    [aux_sym__terminator_token1] = ACTIONS(13066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13068),
    [sym__command_start] = ACTIONS(13068),
  },
  [7555] = {
    [sym__word_identifier] = ACTIONS(13598),
    [anon_sym_EQ] = ACTIONS(13598),
    [anon_sym_COMMA] = ACTIONS(13598),
    [anon_sym_COLON] = ACTIONS(13598),
    [anon_sym_begin] = ACTIONS(13598),
    [anon_sym_module] = ACTIONS(13598),
    [anon_sym_baremodule] = ACTIONS(13598),
    [anon_sym_end] = ACTIONS(13598),
    [anon_sym_abstract] = ACTIONS(13598),
    [anon_sym_primitive] = ACTIONS(13598),
    [anon_sym_mutable] = ACTIONS(13598),
    [anon_sym_struct] = ACTIONS(13598),
    [anon_sym_function] = ACTIONS(13598),
    [anon_sym_macro] = ACTIONS(13598),
    [anon_sym_where] = ACTIONS(13598),
    [anon_sym_quote] = ACTIONS(13598),
    [anon_sym_let] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(13598),
    [anon_sym_elseif] = ACTIONS(13598),
    [anon_sym_else] = ACTIONS(13598),
    [anon_sym_try] = ACTIONS(13598),
    [anon_sym_for] = ACTIONS(13598),
    [anon_sym_while] = ACTIONS(13598),
    [sym_break_statement] = ACTIONS(13598),
    [sym_continue_statement] = ACTIONS(13598),
    [anon_sym_return] = ACTIONS(13598),
    [anon_sym_const] = ACTIONS(13598),
    [anon_sym_global] = ACTIONS(13598),
    [anon_sym_local] = ACTIONS(13598),
    [anon_sym_LPAREN] = ACTIONS(13598),
    [anon_sym_COLON2] = ACTIONS(13598),
    [anon_sym_export] = ACTIONS(13598),
    [anon_sym_import] = ACTIONS(13598),
    [anon_sym_using] = ACTIONS(13598),
    [anon_sym_LBRACK] = ACTIONS(13598),
    [anon_sym_LF] = ACTIONS(13600),
    [anon_sym_in] = ACTIONS(13598),
    [anon_sym_LBRACE] = ACTIONS(13598),
    [anon_sym_DOLLAR] = ACTIONS(13598),
    [anon_sym_COLON_COLON] = ACTIONS(13598),
    [anon_sym_isa] = ACTIONS(13598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13598),
    [anon_sym_QMARK] = ACTIONS(13598),
    [anon_sym_AT] = ACTIONS(13598),
    [anon_sym_true] = ACTIONS(13598),
    [anon_sym_false] = ACTIONS(13598),
    [aux_sym_integer_literal_token1] = ACTIONS(13598),
    [aux_sym_integer_literal_token2] = ACTIONS(13598),
    [aux_sym_integer_literal_token3] = ACTIONS(13598),
    [aux_sym_integer_literal_token4] = ACTIONS(13598),
    [aux_sym_float_literal_token1] = ACTIONS(13598),
    [aux_sym_float_literal_token3] = ACTIONS(13598),
    [aux_sym_float_literal_token4] = ACTIONS(13598),
    [sym_character_literal] = ACTIONS(13598),
    [sym__pair_operator] = ACTIONS(13598),
    [sym__arrow_operator] = ACTIONS(13598),
    [sym__lazy_or_operator] = ACTIONS(13598),
    [sym__lazy_and_operator] = ACTIONS(13598),
    [sym__comparison_operator] = ACTIONS(13598),
    [sym__pipe_right_operator] = ACTIONS(13598),
    [sym__pipe_left_operator] = ACTIONS(13598),
    [sym__ellipsis_operator] = ACTIONS(13598),
    [sym__plus_operator] = ACTIONS(13598),
    [sym__times_operator] = ACTIONS(13598),
    [sym__rational_operator] = ACTIONS(13598),
    [sym__bitshift_operator] = ACTIONS(13598),
    [sym__power_operator] = ACTIONS(13598),
    [sym__tilde_operator] = ACTIONS(13598),
    [sym__type_order_operator] = ACTIONS(13598),
    [sym__unary_operator] = ACTIONS(13598),
    [sym__unary_plus_operator] = ACTIONS(13598),
    [aux_sym__terminator_token1] = ACTIONS(13598),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13600),
    [sym__command_start] = ACTIONS(13600),
  },
  [7556] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_else] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7557] = {
    [sym__word_identifier] = ACTIONS(13602),
    [anon_sym_EQ] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(13602),
    [anon_sym_COLON] = ACTIONS(13602),
    [anon_sym_begin] = ACTIONS(13602),
    [anon_sym_module] = ACTIONS(13602),
    [anon_sym_baremodule] = ACTIONS(13602),
    [anon_sym_end] = ACTIONS(13602),
    [anon_sym_abstract] = ACTIONS(13602),
    [anon_sym_primitive] = ACTIONS(13602),
    [anon_sym_mutable] = ACTIONS(13602),
    [anon_sym_struct] = ACTIONS(13602),
    [anon_sym_function] = ACTIONS(13602),
    [anon_sym_macro] = ACTIONS(13602),
    [anon_sym_where] = ACTIONS(13602),
    [anon_sym_quote] = ACTIONS(13602),
    [anon_sym_let] = ACTIONS(13602),
    [anon_sym_if] = ACTIONS(13602),
    [anon_sym_elseif] = ACTIONS(13602),
    [anon_sym_else] = ACTIONS(13602),
    [anon_sym_try] = ACTIONS(13602),
    [anon_sym_for] = ACTIONS(13602),
    [anon_sym_while] = ACTIONS(13602),
    [sym_break_statement] = ACTIONS(13602),
    [sym_continue_statement] = ACTIONS(13602),
    [anon_sym_return] = ACTIONS(13602),
    [anon_sym_const] = ACTIONS(13602),
    [anon_sym_global] = ACTIONS(13602),
    [anon_sym_local] = ACTIONS(13602),
    [anon_sym_LPAREN] = ACTIONS(13602),
    [anon_sym_COLON2] = ACTIONS(13602),
    [anon_sym_export] = ACTIONS(13602),
    [anon_sym_import] = ACTIONS(13602),
    [anon_sym_using] = ACTIONS(13602),
    [anon_sym_LBRACK] = ACTIONS(13602),
    [anon_sym_LF] = ACTIONS(13604),
    [anon_sym_in] = ACTIONS(13602),
    [anon_sym_LBRACE] = ACTIONS(13602),
    [anon_sym_DOLLAR] = ACTIONS(13602),
    [anon_sym_COLON_COLON] = ACTIONS(13602),
    [anon_sym_isa] = ACTIONS(13602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13602),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_AT] = ACTIONS(13602),
    [anon_sym_true] = ACTIONS(13602),
    [anon_sym_false] = ACTIONS(13602),
    [aux_sym_integer_literal_token1] = ACTIONS(13602),
    [aux_sym_integer_literal_token2] = ACTIONS(13602),
    [aux_sym_integer_literal_token3] = ACTIONS(13602),
    [aux_sym_integer_literal_token4] = ACTIONS(13602),
    [aux_sym_float_literal_token1] = ACTIONS(13602),
    [aux_sym_float_literal_token3] = ACTIONS(13602),
    [aux_sym_float_literal_token4] = ACTIONS(13602),
    [sym_character_literal] = ACTIONS(13602),
    [sym__pair_operator] = ACTIONS(13602),
    [sym__arrow_operator] = ACTIONS(13602),
    [sym__lazy_or_operator] = ACTIONS(13602),
    [sym__lazy_and_operator] = ACTIONS(13602),
    [sym__comparison_operator] = ACTIONS(13602),
    [sym__pipe_right_operator] = ACTIONS(13602),
    [sym__pipe_left_operator] = ACTIONS(13602),
    [sym__ellipsis_operator] = ACTIONS(13602),
    [sym__plus_operator] = ACTIONS(13602),
    [sym__times_operator] = ACTIONS(13602),
    [sym__rational_operator] = ACTIONS(13602),
    [sym__bitshift_operator] = ACTIONS(13602),
    [sym__power_operator] = ACTIONS(13602),
    [sym__tilde_operator] = ACTIONS(13602),
    [sym__type_order_operator] = ACTIONS(13602),
    [sym__unary_operator] = ACTIONS(13602),
    [sym__unary_plus_operator] = ACTIONS(13602),
    [aux_sym__terminator_token1] = ACTIONS(13602),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13604),
    [sym__command_start] = ACTIONS(13604),
  },
  [7558] = {
    [sym__word_identifier] = ACTIONS(13606),
    [anon_sym_EQ] = ACTIONS(13606),
    [anon_sym_COMMA] = ACTIONS(13606),
    [anon_sym_COLON] = ACTIONS(13606),
    [anon_sym_begin] = ACTIONS(13606),
    [anon_sym_module] = ACTIONS(13606),
    [anon_sym_baremodule] = ACTIONS(13606),
    [anon_sym_end] = ACTIONS(13606),
    [anon_sym_abstract] = ACTIONS(13606),
    [anon_sym_primitive] = ACTIONS(13606),
    [anon_sym_mutable] = ACTIONS(13606),
    [anon_sym_struct] = ACTIONS(13606),
    [anon_sym_function] = ACTIONS(13606),
    [anon_sym_macro] = ACTIONS(13606),
    [anon_sym_where] = ACTIONS(13606),
    [anon_sym_quote] = ACTIONS(13606),
    [anon_sym_let] = ACTIONS(13606),
    [anon_sym_if] = ACTIONS(13606),
    [anon_sym_elseif] = ACTIONS(13606),
    [anon_sym_else] = ACTIONS(13606),
    [anon_sym_try] = ACTIONS(13606),
    [anon_sym_for] = ACTIONS(13606),
    [anon_sym_while] = ACTIONS(13606),
    [sym_break_statement] = ACTIONS(13606),
    [sym_continue_statement] = ACTIONS(13606),
    [anon_sym_return] = ACTIONS(13606),
    [anon_sym_const] = ACTIONS(13606),
    [anon_sym_global] = ACTIONS(13606),
    [anon_sym_local] = ACTIONS(13606),
    [anon_sym_LPAREN] = ACTIONS(13606),
    [anon_sym_COLON2] = ACTIONS(13606),
    [anon_sym_export] = ACTIONS(13606),
    [anon_sym_import] = ACTIONS(13606),
    [anon_sym_using] = ACTIONS(13606),
    [anon_sym_LBRACK] = ACTIONS(13606),
    [anon_sym_LF] = ACTIONS(13608),
    [anon_sym_in] = ACTIONS(13606),
    [anon_sym_LBRACE] = ACTIONS(13606),
    [anon_sym_DOLLAR] = ACTIONS(13606),
    [anon_sym_COLON_COLON] = ACTIONS(13606),
    [anon_sym_isa] = ACTIONS(13606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_QMARK] = ACTIONS(13606),
    [anon_sym_AT] = ACTIONS(13606),
    [anon_sym_true] = ACTIONS(13606),
    [anon_sym_false] = ACTIONS(13606),
    [aux_sym_integer_literal_token1] = ACTIONS(13606),
    [aux_sym_integer_literal_token2] = ACTIONS(13606),
    [aux_sym_integer_literal_token3] = ACTIONS(13606),
    [aux_sym_integer_literal_token4] = ACTIONS(13606),
    [aux_sym_float_literal_token1] = ACTIONS(13606),
    [aux_sym_float_literal_token3] = ACTIONS(13606),
    [aux_sym_float_literal_token4] = ACTIONS(13606),
    [sym_character_literal] = ACTIONS(13606),
    [sym__pair_operator] = ACTIONS(13606),
    [sym__arrow_operator] = ACTIONS(13606),
    [sym__lazy_or_operator] = ACTIONS(13606),
    [sym__lazy_and_operator] = ACTIONS(13606),
    [sym__comparison_operator] = ACTIONS(13606),
    [sym__pipe_right_operator] = ACTIONS(13606),
    [sym__pipe_left_operator] = ACTIONS(13606),
    [sym__ellipsis_operator] = ACTIONS(13606),
    [sym__plus_operator] = ACTIONS(13606),
    [sym__times_operator] = ACTIONS(13606),
    [sym__rational_operator] = ACTIONS(13606),
    [sym__bitshift_operator] = ACTIONS(13606),
    [sym__power_operator] = ACTIONS(13606),
    [sym__tilde_operator] = ACTIONS(13606),
    [sym__type_order_operator] = ACTIONS(13606),
    [sym__unary_operator] = ACTIONS(13606),
    [sym__unary_plus_operator] = ACTIONS(13606),
    [aux_sym__terminator_token1] = ACTIONS(13606),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13608),
    [sym__command_start] = ACTIONS(13608),
  },
  [7559] = {
    [sym__word_identifier] = ACTIONS(13620),
    [anon_sym_EQ] = ACTIONS(13620),
    [anon_sym_COMMA] = ACTIONS(13620),
    [anon_sym_COLON] = ACTIONS(13620),
    [anon_sym_begin] = ACTIONS(13620),
    [anon_sym_module] = ACTIONS(13620),
    [anon_sym_baremodule] = ACTIONS(13620),
    [anon_sym_end] = ACTIONS(13620),
    [anon_sym_abstract] = ACTIONS(13620),
    [anon_sym_primitive] = ACTIONS(13620),
    [anon_sym_mutable] = ACTIONS(13620),
    [anon_sym_struct] = ACTIONS(13620),
    [anon_sym_function] = ACTIONS(13620),
    [anon_sym_macro] = ACTIONS(13620),
    [anon_sym_where] = ACTIONS(13620),
    [anon_sym_quote] = ACTIONS(13620),
    [anon_sym_let] = ACTIONS(13620),
    [anon_sym_if] = ACTIONS(13620),
    [anon_sym_elseif] = ACTIONS(13620),
    [anon_sym_else] = ACTIONS(13620),
    [anon_sym_try] = ACTIONS(13620),
    [anon_sym_for] = ACTIONS(13620),
    [anon_sym_while] = ACTIONS(13620),
    [sym_break_statement] = ACTIONS(13620),
    [sym_continue_statement] = ACTIONS(13620),
    [anon_sym_return] = ACTIONS(13620),
    [anon_sym_const] = ACTIONS(13620),
    [anon_sym_global] = ACTIONS(13620),
    [anon_sym_local] = ACTIONS(13620),
    [anon_sym_LPAREN] = ACTIONS(13620),
    [anon_sym_COLON2] = ACTIONS(13620),
    [anon_sym_export] = ACTIONS(13620),
    [anon_sym_import] = ACTIONS(13620),
    [anon_sym_using] = ACTIONS(13620),
    [anon_sym_LBRACK] = ACTIONS(13620),
    [anon_sym_LF] = ACTIONS(13622),
    [anon_sym_in] = ACTIONS(13620),
    [anon_sym_LBRACE] = ACTIONS(13620),
    [anon_sym_DOLLAR] = ACTIONS(13620),
    [anon_sym_COLON_COLON] = ACTIONS(13620),
    [anon_sym_isa] = ACTIONS(13620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13620),
    [anon_sym_QMARK] = ACTIONS(13620),
    [anon_sym_AT] = ACTIONS(13620),
    [anon_sym_true] = ACTIONS(13620),
    [anon_sym_false] = ACTIONS(13620),
    [aux_sym_integer_literal_token1] = ACTIONS(13620),
    [aux_sym_integer_literal_token2] = ACTIONS(13620),
    [aux_sym_integer_literal_token3] = ACTIONS(13620),
    [aux_sym_integer_literal_token4] = ACTIONS(13620),
    [aux_sym_float_literal_token1] = ACTIONS(13620),
    [aux_sym_float_literal_token3] = ACTIONS(13620),
    [aux_sym_float_literal_token4] = ACTIONS(13620),
    [sym_character_literal] = ACTIONS(13620),
    [sym__pair_operator] = ACTIONS(13620),
    [sym__arrow_operator] = ACTIONS(13620),
    [sym__lazy_or_operator] = ACTIONS(13620),
    [sym__lazy_and_operator] = ACTIONS(13620),
    [sym__comparison_operator] = ACTIONS(13620),
    [sym__pipe_right_operator] = ACTIONS(13620),
    [sym__pipe_left_operator] = ACTIONS(13620),
    [sym__ellipsis_operator] = ACTIONS(13620),
    [sym__plus_operator] = ACTIONS(13620),
    [sym__times_operator] = ACTIONS(13620),
    [sym__rational_operator] = ACTIONS(13620),
    [sym__bitshift_operator] = ACTIONS(13620),
    [sym__power_operator] = ACTIONS(13620),
    [sym__tilde_operator] = ACTIONS(13620),
    [sym__type_order_operator] = ACTIONS(13620),
    [sym__unary_operator] = ACTIONS(13620),
    [sym__unary_plus_operator] = ACTIONS(13620),
    [aux_sym__terminator_token1] = ACTIONS(13620),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13622),
    [sym__command_start] = ACTIONS(13622),
  },
  [7560] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [ts_builtin_sym_end] = ACTIONS(13253),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_RPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_RBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [7561] = {
    [sym__word_identifier] = ACTIONS(13624),
    [anon_sym_EQ] = ACTIONS(13624),
    [anon_sym_COMMA] = ACTIONS(13624),
    [anon_sym_COLON] = ACTIONS(13624),
    [anon_sym_begin] = ACTIONS(13624),
    [anon_sym_module] = ACTIONS(13624),
    [anon_sym_baremodule] = ACTIONS(13624),
    [anon_sym_end] = ACTIONS(13624),
    [anon_sym_abstract] = ACTIONS(13624),
    [anon_sym_primitive] = ACTIONS(13624),
    [anon_sym_mutable] = ACTIONS(13624),
    [anon_sym_struct] = ACTIONS(13624),
    [anon_sym_function] = ACTIONS(13624),
    [anon_sym_macro] = ACTIONS(13624),
    [anon_sym_where] = ACTIONS(13624),
    [anon_sym_quote] = ACTIONS(13624),
    [anon_sym_let] = ACTIONS(13624),
    [anon_sym_if] = ACTIONS(13624),
    [anon_sym_elseif] = ACTIONS(13624),
    [anon_sym_else] = ACTIONS(13624),
    [anon_sym_try] = ACTIONS(13624),
    [anon_sym_for] = ACTIONS(13624),
    [anon_sym_while] = ACTIONS(13624),
    [sym_break_statement] = ACTIONS(13624),
    [sym_continue_statement] = ACTIONS(13624),
    [anon_sym_return] = ACTIONS(13624),
    [anon_sym_const] = ACTIONS(13624),
    [anon_sym_global] = ACTIONS(13624),
    [anon_sym_local] = ACTIONS(13624),
    [anon_sym_LPAREN] = ACTIONS(13624),
    [anon_sym_COLON2] = ACTIONS(13624),
    [anon_sym_export] = ACTIONS(13624),
    [anon_sym_import] = ACTIONS(13624),
    [anon_sym_using] = ACTIONS(13624),
    [anon_sym_LBRACK] = ACTIONS(13624),
    [anon_sym_LF] = ACTIONS(13626),
    [anon_sym_in] = ACTIONS(13624),
    [anon_sym_LBRACE] = ACTIONS(13624),
    [anon_sym_DOLLAR] = ACTIONS(13624),
    [anon_sym_COLON_COLON] = ACTIONS(13624),
    [anon_sym_isa] = ACTIONS(13624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13624),
    [anon_sym_QMARK] = ACTIONS(13624),
    [anon_sym_AT] = ACTIONS(13624),
    [anon_sym_true] = ACTIONS(13624),
    [anon_sym_false] = ACTIONS(13624),
    [aux_sym_integer_literal_token1] = ACTIONS(13624),
    [aux_sym_integer_literal_token2] = ACTIONS(13624),
    [aux_sym_integer_literal_token3] = ACTIONS(13624),
    [aux_sym_integer_literal_token4] = ACTIONS(13624),
    [aux_sym_float_literal_token1] = ACTIONS(13624),
    [aux_sym_float_literal_token3] = ACTIONS(13624),
    [aux_sym_float_literal_token4] = ACTIONS(13624),
    [sym_character_literal] = ACTIONS(13624),
    [sym__pair_operator] = ACTIONS(13624),
    [sym__arrow_operator] = ACTIONS(13624),
    [sym__lazy_or_operator] = ACTIONS(13624),
    [sym__lazy_and_operator] = ACTIONS(13624),
    [sym__comparison_operator] = ACTIONS(13624),
    [sym__pipe_right_operator] = ACTIONS(13624),
    [sym__pipe_left_operator] = ACTIONS(13624),
    [sym__ellipsis_operator] = ACTIONS(13624),
    [sym__plus_operator] = ACTIONS(13624),
    [sym__times_operator] = ACTIONS(13624),
    [sym__rational_operator] = ACTIONS(13624),
    [sym__bitshift_operator] = ACTIONS(13624),
    [sym__power_operator] = ACTIONS(13624),
    [sym__tilde_operator] = ACTIONS(13624),
    [sym__type_order_operator] = ACTIONS(13624),
    [sym__unary_operator] = ACTIONS(13624),
    [sym__unary_plus_operator] = ACTIONS(13624),
    [aux_sym__terminator_token1] = ACTIONS(13624),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13626),
    [sym__command_start] = ACTIONS(13626),
  },
  [7562] = {
    [sym__word_identifier] = ACTIONS(13628),
    [anon_sym_EQ] = ACTIONS(13628),
    [anon_sym_COMMA] = ACTIONS(13628),
    [anon_sym_COLON] = ACTIONS(13628),
    [anon_sym_begin] = ACTIONS(13628),
    [anon_sym_module] = ACTIONS(13628),
    [anon_sym_baremodule] = ACTIONS(13628),
    [anon_sym_end] = ACTIONS(13628),
    [anon_sym_abstract] = ACTIONS(13628),
    [anon_sym_primitive] = ACTIONS(13628),
    [anon_sym_mutable] = ACTIONS(13628),
    [anon_sym_struct] = ACTIONS(13628),
    [anon_sym_function] = ACTIONS(13628),
    [anon_sym_macro] = ACTIONS(13628),
    [anon_sym_where] = ACTIONS(13628),
    [anon_sym_quote] = ACTIONS(13628),
    [anon_sym_let] = ACTIONS(13628),
    [anon_sym_if] = ACTIONS(13628),
    [anon_sym_elseif] = ACTIONS(13628),
    [anon_sym_else] = ACTIONS(13628),
    [anon_sym_try] = ACTIONS(13628),
    [anon_sym_for] = ACTIONS(13628),
    [anon_sym_while] = ACTIONS(13628),
    [sym_break_statement] = ACTIONS(13628),
    [sym_continue_statement] = ACTIONS(13628),
    [anon_sym_return] = ACTIONS(13628),
    [anon_sym_const] = ACTIONS(13628),
    [anon_sym_global] = ACTIONS(13628),
    [anon_sym_local] = ACTIONS(13628),
    [anon_sym_LPAREN] = ACTIONS(13628),
    [anon_sym_COLON2] = ACTIONS(13628),
    [anon_sym_export] = ACTIONS(13628),
    [anon_sym_import] = ACTIONS(13628),
    [anon_sym_using] = ACTIONS(13628),
    [anon_sym_LBRACK] = ACTIONS(13628),
    [anon_sym_LF] = ACTIONS(13630),
    [anon_sym_in] = ACTIONS(13628),
    [anon_sym_LBRACE] = ACTIONS(13628),
    [anon_sym_DOLLAR] = ACTIONS(13628),
    [anon_sym_COLON_COLON] = ACTIONS(13628),
    [anon_sym_isa] = ACTIONS(13628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13628),
    [anon_sym_QMARK] = ACTIONS(13628),
    [anon_sym_AT] = ACTIONS(13628),
    [anon_sym_true] = ACTIONS(13628),
    [anon_sym_false] = ACTIONS(13628),
    [aux_sym_integer_literal_token1] = ACTIONS(13628),
    [aux_sym_integer_literal_token2] = ACTIONS(13628),
    [aux_sym_integer_literal_token3] = ACTIONS(13628),
    [aux_sym_integer_literal_token4] = ACTIONS(13628),
    [aux_sym_float_literal_token1] = ACTIONS(13628),
    [aux_sym_float_literal_token3] = ACTIONS(13628),
    [aux_sym_float_literal_token4] = ACTIONS(13628),
    [sym_character_literal] = ACTIONS(13628),
    [sym__pair_operator] = ACTIONS(13628),
    [sym__arrow_operator] = ACTIONS(13628),
    [sym__lazy_or_operator] = ACTIONS(13628),
    [sym__lazy_and_operator] = ACTIONS(13628),
    [sym__comparison_operator] = ACTIONS(13628),
    [sym__pipe_right_operator] = ACTIONS(13628),
    [sym__pipe_left_operator] = ACTIONS(13628),
    [sym__ellipsis_operator] = ACTIONS(13628),
    [sym__plus_operator] = ACTIONS(13628),
    [sym__times_operator] = ACTIONS(13628),
    [sym__rational_operator] = ACTIONS(13628),
    [sym__bitshift_operator] = ACTIONS(13628),
    [sym__power_operator] = ACTIONS(13628),
    [sym__tilde_operator] = ACTIONS(13628),
    [sym__type_order_operator] = ACTIONS(13628),
    [sym__unary_operator] = ACTIONS(13628),
    [sym__unary_plus_operator] = ACTIONS(13628),
    [aux_sym__terminator_token1] = ACTIONS(13628),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13630),
    [sym__command_start] = ACTIONS(13630),
  },
  [7563] = {
    [sym__word_identifier] = ACTIONS(13632),
    [anon_sym_EQ] = ACTIONS(13632),
    [anon_sym_COMMA] = ACTIONS(13632),
    [anon_sym_COLON] = ACTIONS(13632),
    [anon_sym_begin] = ACTIONS(13632),
    [anon_sym_module] = ACTIONS(13632),
    [anon_sym_baremodule] = ACTIONS(13632),
    [anon_sym_end] = ACTIONS(13632),
    [anon_sym_abstract] = ACTIONS(13632),
    [anon_sym_primitive] = ACTIONS(13632),
    [anon_sym_mutable] = ACTIONS(13632),
    [anon_sym_struct] = ACTIONS(13632),
    [anon_sym_function] = ACTIONS(13632),
    [anon_sym_macro] = ACTIONS(13632),
    [anon_sym_where] = ACTIONS(13632),
    [anon_sym_quote] = ACTIONS(13632),
    [anon_sym_let] = ACTIONS(13632),
    [anon_sym_if] = ACTIONS(13632),
    [anon_sym_elseif] = ACTIONS(13632),
    [anon_sym_else] = ACTIONS(13632),
    [anon_sym_try] = ACTIONS(13632),
    [anon_sym_for] = ACTIONS(13632),
    [anon_sym_while] = ACTIONS(13632),
    [sym_break_statement] = ACTIONS(13632),
    [sym_continue_statement] = ACTIONS(13632),
    [anon_sym_return] = ACTIONS(13632),
    [anon_sym_const] = ACTIONS(13632),
    [anon_sym_global] = ACTIONS(13632),
    [anon_sym_local] = ACTIONS(13632),
    [anon_sym_LPAREN] = ACTIONS(13632),
    [anon_sym_COLON2] = ACTIONS(13632),
    [anon_sym_export] = ACTIONS(13632),
    [anon_sym_import] = ACTIONS(13632),
    [anon_sym_using] = ACTIONS(13632),
    [anon_sym_LBRACK] = ACTIONS(13632),
    [anon_sym_LF] = ACTIONS(13634),
    [anon_sym_in] = ACTIONS(13632),
    [anon_sym_LBRACE] = ACTIONS(13632),
    [anon_sym_DOLLAR] = ACTIONS(13632),
    [anon_sym_COLON_COLON] = ACTIONS(13632),
    [anon_sym_isa] = ACTIONS(13632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13632),
    [anon_sym_QMARK] = ACTIONS(13632),
    [anon_sym_AT] = ACTIONS(13632),
    [anon_sym_true] = ACTIONS(13632),
    [anon_sym_false] = ACTIONS(13632),
    [aux_sym_integer_literal_token1] = ACTIONS(13632),
    [aux_sym_integer_literal_token2] = ACTIONS(13632),
    [aux_sym_integer_literal_token3] = ACTIONS(13632),
    [aux_sym_integer_literal_token4] = ACTIONS(13632),
    [aux_sym_float_literal_token1] = ACTIONS(13632),
    [aux_sym_float_literal_token3] = ACTIONS(13632),
    [aux_sym_float_literal_token4] = ACTIONS(13632),
    [sym_character_literal] = ACTIONS(13632),
    [sym__pair_operator] = ACTIONS(13632),
    [sym__arrow_operator] = ACTIONS(13632),
    [sym__lazy_or_operator] = ACTIONS(13632),
    [sym__lazy_and_operator] = ACTIONS(13632),
    [sym__comparison_operator] = ACTIONS(13632),
    [sym__pipe_right_operator] = ACTIONS(13632),
    [sym__pipe_left_operator] = ACTIONS(13632),
    [sym__ellipsis_operator] = ACTIONS(13632),
    [sym__plus_operator] = ACTIONS(13632),
    [sym__times_operator] = ACTIONS(13632),
    [sym__rational_operator] = ACTIONS(13632),
    [sym__bitshift_operator] = ACTIONS(13632),
    [sym__power_operator] = ACTIONS(13632),
    [sym__tilde_operator] = ACTIONS(13632),
    [sym__type_order_operator] = ACTIONS(13632),
    [sym__unary_operator] = ACTIONS(13632),
    [sym__unary_plus_operator] = ACTIONS(13632),
    [aux_sym__terminator_token1] = ACTIONS(13632),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13634),
    [sym__command_start] = ACTIONS(13634),
  },
  [7564] = {
    [sym__word_identifier] = ACTIONS(13636),
    [anon_sym_EQ] = ACTIONS(13636),
    [anon_sym_COMMA] = ACTIONS(13636),
    [anon_sym_COLON] = ACTIONS(13636),
    [anon_sym_begin] = ACTIONS(13636),
    [anon_sym_module] = ACTIONS(13636),
    [anon_sym_baremodule] = ACTIONS(13636),
    [anon_sym_end] = ACTIONS(13636),
    [anon_sym_abstract] = ACTIONS(13636),
    [anon_sym_primitive] = ACTIONS(13636),
    [anon_sym_mutable] = ACTIONS(13636),
    [anon_sym_struct] = ACTIONS(13636),
    [anon_sym_function] = ACTIONS(13636),
    [anon_sym_macro] = ACTIONS(13636),
    [anon_sym_where] = ACTIONS(13636),
    [anon_sym_quote] = ACTIONS(13636),
    [anon_sym_let] = ACTIONS(13636),
    [anon_sym_if] = ACTIONS(13636),
    [anon_sym_elseif] = ACTIONS(13636),
    [anon_sym_else] = ACTIONS(13636),
    [anon_sym_try] = ACTIONS(13636),
    [anon_sym_for] = ACTIONS(13636),
    [anon_sym_while] = ACTIONS(13636),
    [sym_break_statement] = ACTIONS(13636),
    [sym_continue_statement] = ACTIONS(13636),
    [anon_sym_return] = ACTIONS(13636),
    [anon_sym_const] = ACTIONS(13636),
    [anon_sym_global] = ACTIONS(13636),
    [anon_sym_local] = ACTIONS(13636),
    [anon_sym_LPAREN] = ACTIONS(13636),
    [anon_sym_COLON2] = ACTIONS(13636),
    [anon_sym_export] = ACTIONS(13636),
    [anon_sym_import] = ACTIONS(13636),
    [anon_sym_using] = ACTIONS(13636),
    [anon_sym_LBRACK] = ACTIONS(13636),
    [anon_sym_LF] = ACTIONS(13638),
    [anon_sym_in] = ACTIONS(13636),
    [anon_sym_LBRACE] = ACTIONS(13636),
    [anon_sym_DOLLAR] = ACTIONS(13636),
    [anon_sym_COLON_COLON] = ACTIONS(13636),
    [anon_sym_isa] = ACTIONS(13636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13636),
    [anon_sym_QMARK] = ACTIONS(13636),
    [anon_sym_AT] = ACTIONS(13636),
    [anon_sym_true] = ACTIONS(13636),
    [anon_sym_false] = ACTIONS(13636),
    [aux_sym_integer_literal_token1] = ACTIONS(13636),
    [aux_sym_integer_literal_token2] = ACTIONS(13636),
    [aux_sym_integer_literal_token3] = ACTIONS(13636),
    [aux_sym_integer_literal_token4] = ACTIONS(13636),
    [aux_sym_float_literal_token1] = ACTIONS(13636),
    [aux_sym_float_literal_token3] = ACTIONS(13636),
    [aux_sym_float_literal_token4] = ACTIONS(13636),
    [sym_character_literal] = ACTIONS(13636),
    [sym__pair_operator] = ACTIONS(13636),
    [sym__arrow_operator] = ACTIONS(13636),
    [sym__lazy_or_operator] = ACTIONS(13636),
    [sym__lazy_and_operator] = ACTIONS(13636),
    [sym__comparison_operator] = ACTIONS(13636),
    [sym__pipe_right_operator] = ACTIONS(13636),
    [sym__pipe_left_operator] = ACTIONS(13636),
    [sym__ellipsis_operator] = ACTIONS(13636),
    [sym__plus_operator] = ACTIONS(13636),
    [sym__times_operator] = ACTIONS(13636),
    [sym__rational_operator] = ACTIONS(13636),
    [sym__bitshift_operator] = ACTIONS(13636),
    [sym__power_operator] = ACTIONS(13636),
    [sym__tilde_operator] = ACTIONS(13636),
    [sym__type_order_operator] = ACTIONS(13636),
    [sym__unary_operator] = ACTIONS(13636),
    [sym__unary_plus_operator] = ACTIONS(13636),
    [aux_sym__terminator_token1] = ACTIONS(13636),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13638),
    [sym__command_start] = ACTIONS(13638),
  },
  [7565] = {
    [sym__word_identifier] = ACTIONS(13640),
    [anon_sym_EQ] = ACTIONS(13640),
    [anon_sym_COMMA] = ACTIONS(13640),
    [anon_sym_COLON] = ACTIONS(13640),
    [anon_sym_begin] = ACTIONS(13640),
    [anon_sym_module] = ACTIONS(13640),
    [anon_sym_baremodule] = ACTIONS(13640),
    [anon_sym_end] = ACTIONS(13640),
    [anon_sym_abstract] = ACTIONS(13640),
    [anon_sym_primitive] = ACTIONS(13640),
    [anon_sym_mutable] = ACTIONS(13640),
    [anon_sym_struct] = ACTIONS(13640),
    [anon_sym_function] = ACTIONS(13640),
    [anon_sym_macro] = ACTIONS(13640),
    [anon_sym_where] = ACTIONS(13640),
    [anon_sym_quote] = ACTIONS(13640),
    [anon_sym_let] = ACTIONS(13640),
    [anon_sym_if] = ACTIONS(13640),
    [anon_sym_elseif] = ACTIONS(13640),
    [anon_sym_else] = ACTIONS(13640),
    [anon_sym_try] = ACTIONS(13640),
    [anon_sym_for] = ACTIONS(13640),
    [anon_sym_while] = ACTIONS(13640),
    [sym_break_statement] = ACTIONS(13640),
    [sym_continue_statement] = ACTIONS(13640),
    [anon_sym_return] = ACTIONS(13640),
    [anon_sym_const] = ACTIONS(13640),
    [anon_sym_global] = ACTIONS(13640),
    [anon_sym_local] = ACTIONS(13640),
    [anon_sym_LPAREN] = ACTIONS(13640),
    [anon_sym_COLON2] = ACTIONS(13640),
    [anon_sym_export] = ACTIONS(13640),
    [anon_sym_import] = ACTIONS(13640),
    [anon_sym_using] = ACTIONS(13640),
    [anon_sym_LBRACK] = ACTIONS(13640),
    [anon_sym_LF] = ACTIONS(13642),
    [anon_sym_in] = ACTIONS(13640),
    [anon_sym_LBRACE] = ACTIONS(13640),
    [anon_sym_DOLLAR] = ACTIONS(13640),
    [anon_sym_COLON_COLON] = ACTIONS(13640),
    [anon_sym_isa] = ACTIONS(13640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13640),
    [anon_sym_QMARK] = ACTIONS(13640),
    [anon_sym_AT] = ACTIONS(13640),
    [anon_sym_true] = ACTIONS(13640),
    [anon_sym_false] = ACTIONS(13640),
    [aux_sym_integer_literal_token1] = ACTIONS(13640),
    [aux_sym_integer_literal_token2] = ACTIONS(13640),
    [aux_sym_integer_literal_token3] = ACTIONS(13640),
    [aux_sym_integer_literal_token4] = ACTIONS(13640),
    [aux_sym_float_literal_token1] = ACTIONS(13640),
    [aux_sym_float_literal_token3] = ACTIONS(13640),
    [aux_sym_float_literal_token4] = ACTIONS(13640),
    [sym_character_literal] = ACTIONS(13640),
    [sym__pair_operator] = ACTIONS(13640),
    [sym__arrow_operator] = ACTIONS(13640),
    [sym__lazy_or_operator] = ACTIONS(13640),
    [sym__lazy_and_operator] = ACTIONS(13640),
    [sym__comparison_operator] = ACTIONS(13640),
    [sym__pipe_right_operator] = ACTIONS(13640),
    [sym__pipe_left_operator] = ACTIONS(13640),
    [sym__ellipsis_operator] = ACTIONS(13640),
    [sym__plus_operator] = ACTIONS(13640),
    [sym__times_operator] = ACTIONS(13640),
    [sym__rational_operator] = ACTIONS(13640),
    [sym__bitshift_operator] = ACTIONS(13640),
    [sym__power_operator] = ACTIONS(13640),
    [sym__tilde_operator] = ACTIONS(13640),
    [sym__type_order_operator] = ACTIONS(13640),
    [sym__unary_operator] = ACTIONS(13640),
    [sym__unary_plus_operator] = ACTIONS(13640),
    [aux_sym__terminator_token1] = ACTIONS(13640),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13642),
    [sym__command_start] = ACTIONS(13642),
  },
  [7566] = {
    [sym__word_identifier] = ACTIONS(13644),
    [anon_sym_EQ] = ACTIONS(13644),
    [anon_sym_COMMA] = ACTIONS(13644),
    [anon_sym_COLON] = ACTIONS(13644),
    [anon_sym_begin] = ACTIONS(13644),
    [anon_sym_module] = ACTIONS(13644),
    [anon_sym_baremodule] = ACTIONS(13644),
    [anon_sym_end] = ACTIONS(13644),
    [anon_sym_abstract] = ACTIONS(13644),
    [anon_sym_primitive] = ACTIONS(13644),
    [anon_sym_mutable] = ACTIONS(13644),
    [anon_sym_struct] = ACTIONS(13644),
    [anon_sym_function] = ACTIONS(13644),
    [anon_sym_macro] = ACTIONS(13644),
    [anon_sym_where] = ACTIONS(13644),
    [anon_sym_quote] = ACTIONS(13644),
    [anon_sym_let] = ACTIONS(13644),
    [anon_sym_if] = ACTIONS(13644),
    [anon_sym_elseif] = ACTIONS(13644),
    [anon_sym_else] = ACTIONS(13644),
    [anon_sym_try] = ACTIONS(13644),
    [anon_sym_for] = ACTIONS(13644),
    [anon_sym_while] = ACTIONS(13644),
    [sym_break_statement] = ACTIONS(13644),
    [sym_continue_statement] = ACTIONS(13644),
    [anon_sym_return] = ACTIONS(13644),
    [anon_sym_const] = ACTIONS(13644),
    [anon_sym_global] = ACTIONS(13644),
    [anon_sym_local] = ACTIONS(13644),
    [anon_sym_LPAREN] = ACTIONS(13644),
    [anon_sym_COLON2] = ACTIONS(13644),
    [anon_sym_export] = ACTIONS(13644),
    [anon_sym_import] = ACTIONS(13644),
    [anon_sym_using] = ACTIONS(13644),
    [anon_sym_LBRACK] = ACTIONS(13644),
    [anon_sym_LF] = ACTIONS(13646),
    [anon_sym_in] = ACTIONS(13644),
    [anon_sym_LBRACE] = ACTIONS(13644),
    [anon_sym_DOLLAR] = ACTIONS(13644),
    [anon_sym_COLON_COLON] = ACTIONS(13644),
    [anon_sym_isa] = ACTIONS(13644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13644),
    [anon_sym_QMARK] = ACTIONS(13644),
    [anon_sym_AT] = ACTIONS(13644),
    [anon_sym_true] = ACTIONS(13644),
    [anon_sym_false] = ACTIONS(13644),
    [aux_sym_integer_literal_token1] = ACTIONS(13644),
    [aux_sym_integer_literal_token2] = ACTIONS(13644),
    [aux_sym_integer_literal_token3] = ACTIONS(13644),
    [aux_sym_integer_literal_token4] = ACTIONS(13644),
    [aux_sym_float_literal_token1] = ACTIONS(13644),
    [aux_sym_float_literal_token3] = ACTIONS(13644),
    [aux_sym_float_literal_token4] = ACTIONS(13644),
    [sym_character_literal] = ACTIONS(13644),
    [sym__pair_operator] = ACTIONS(13644),
    [sym__arrow_operator] = ACTIONS(13644),
    [sym__lazy_or_operator] = ACTIONS(13644),
    [sym__lazy_and_operator] = ACTIONS(13644),
    [sym__comparison_operator] = ACTIONS(13644),
    [sym__pipe_right_operator] = ACTIONS(13644),
    [sym__pipe_left_operator] = ACTIONS(13644),
    [sym__ellipsis_operator] = ACTIONS(13644),
    [sym__plus_operator] = ACTIONS(13644),
    [sym__times_operator] = ACTIONS(13644),
    [sym__rational_operator] = ACTIONS(13644),
    [sym__bitshift_operator] = ACTIONS(13644),
    [sym__power_operator] = ACTIONS(13644),
    [sym__tilde_operator] = ACTIONS(13644),
    [sym__type_order_operator] = ACTIONS(13644),
    [sym__unary_operator] = ACTIONS(13644),
    [sym__unary_plus_operator] = ACTIONS(13644),
    [aux_sym__terminator_token1] = ACTIONS(13644),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13646),
    [sym__command_start] = ACTIONS(13646),
  },
  [7567] = {
    [sym__word_identifier] = ACTIONS(13648),
    [anon_sym_EQ] = ACTIONS(13648),
    [anon_sym_COMMA] = ACTIONS(13648),
    [anon_sym_COLON] = ACTIONS(13648),
    [anon_sym_begin] = ACTIONS(13648),
    [anon_sym_module] = ACTIONS(13648),
    [anon_sym_baremodule] = ACTIONS(13648),
    [anon_sym_end] = ACTIONS(13648),
    [anon_sym_abstract] = ACTIONS(13648),
    [anon_sym_primitive] = ACTIONS(13648),
    [anon_sym_mutable] = ACTIONS(13648),
    [anon_sym_struct] = ACTIONS(13648),
    [anon_sym_function] = ACTIONS(13648),
    [anon_sym_macro] = ACTIONS(13648),
    [anon_sym_where] = ACTIONS(13648),
    [anon_sym_quote] = ACTIONS(13648),
    [anon_sym_let] = ACTIONS(13648),
    [anon_sym_if] = ACTIONS(13648),
    [anon_sym_elseif] = ACTIONS(13648),
    [anon_sym_else] = ACTIONS(13648),
    [anon_sym_try] = ACTIONS(13648),
    [anon_sym_for] = ACTIONS(13648),
    [anon_sym_while] = ACTIONS(13648),
    [sym_break_statement] = ACTIONS(13648),
    [sym_continue_statement] = ACTIONS(13648),
    [anon_sym_return] = ACTIONS(13648),
    [anon_sym_const] = ACTIONS(13648),
    [anon_sym_global] = ACTIONS(13648),
    [anon_sym_local] = ACTIONS(13648),
    [anon_sym_LPAREN] = ACTIONS(13648),
    [anon_sym_COLON2] = ACTIONS(13648),
    [anon_sym_export] = ACTIONS(13648),
    [anon_sym_import] = ACTIONS(13648),
    [anon_sym_using] = ACTIONS(13648),
    [anon_sym_LBRACK] = ACTIONS(13648),
    [anon_sym_LF] = ACTIONS(13650),
    [anon_sym_in] = ACTIONS(13648),
    [anon_sym_LBRACE] = ACTIONS(13648),
    [anon_sym_DOLLAR] = ACTIONS(13648),
    [anon_sym_COLON_COLON] = ACTIONS(13648),
    [anon_sym_isa] = ACTIONS(13648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13648),
    [anon_sym_QMARK] = ACTIONS(13648),
    [anon_sym_AT] = ACTIONS(13648),
    [anon_sym_true] = ACTIONS(13648),
    [anon_sym_false] = ACTIONS(13648),
    [aux_sym_integer_literal_token1] = ACTIONS(13648),
    [aux_sym_integer_literal_token2] = ACTIONS(13648),
    [aux_sym_integer_literal_token3] = ACTIONS(13648),
    [aux_sym_integer_literal_token4] = ACTIONS(13648),
    [aux_sym_float_literal_token1] = ACTIONS(13648),
    [aux_sym_float_literal_token3] = ACTIONS(13648),
    [aux_sym_float_literal_token4] = ACTIONS(13648),
    [sym_character_literal] = ACTIONS(13648),
    [sym__pair_operator] = ACTIONS(13648),
    [sym__arrow_operator] = ACTIONS(13648),
    [sym__lazy_or_operator] = ACTIONS(13648),
    [sym__lazy_and_operator] = ACTIONS(13648),
    [sym__comparison_operator] = ACTIONS(13648),
    [sym__pipe_right_operator] = ACTIONS(13648),
    [sym__pipe_left_operator] = ACTIONS(13648),
    [sym__ellipsis_operator] = ACTIONS(13648),
    [sym__plus_operator] = ACTIONS(13648),
    [sym__times_operator] = ACTIONS(13648),
    [sym__rational_operator] = ACTIONS(13648),
    [sym__bitshift_operator] = ACTIONS(13648),
    [sym__power_operator] = ACTIONS(13648),
    [sym__tilde_operator] = ACTIONS(13648),
    [sym__type_order_operator] = ACTIONS(13648),
    [sym__unary_operator] = ACTIONS(13648),
    [sym__unary_plus_operator] = ACTIONS(13648),
    [aux_sym__terminator_token1] = ACTIONS(13648),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13650),
    [sym__command_start] = ACTIONS(13650),
  },
  [7568] = {
    [sym__comprehension_clause] = STATE(19087),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17145),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13682),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13684),
    [anon_sym_LF] = ACTIONS(13686),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13689),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7569] = {
    [aux_sym_export_statement_repeat1] = STATE(7569),
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(13692),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_end] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_catch] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [7570] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_catch] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_as] = ACTIONS(13022),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7571] = {
    [aux_sym__import_list_repeat1] = STATE(7571),
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(13695),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_catch] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7572] = {
    [sym__word_identifier] = ACTIONS(13652),
    [anon_sym_EQ] = ACTIONS(13652),
    [anon_sym_COMMA] = ACTIONS(13652),
    [anon_sym_COLON] = ACTIONS(13652),
    [anon_sym_begin] = ACTIONS(13652),
    [anon_sym_module] = ACTIONS(13652),
    [anon_sym_baremodule] = ACTIONS(13652),
    [anon_sym_end] = ACTIONS(13652),
    [anon_sym_abstract] = ACTIONS(13652),
    [anon_sym_primitive] = ACTIONS(13652),
    [anon_sym_mutable] = ACTIONS(13652),
    [anon_sym_struct] = ACTIONS(13652),
    [anon_sym_function] = ACTIONS(13652),
    [anon_sym_macro] = ACTIONS(13652),
    [anon_sym_where] = ACTIONS(13652),
    [anon_sym_quote] = ACTIONS(13652),
    [anon_sym_let] = ACTIONS(13652),
    [anon_sym_if] = ACTIONS(13652),
    [anon_sym_elseif] = ACTIONS(13652),
    [anon_sym_else] = ACTIONS(13652),
    [anon_sym_try] = ACTIONS(13652),
    [anon_sym_for] = ACTIONS(13652),
    [anon_sym_while] = ACTIONS(13652),
    [sym_break_statement] = ACTIONS(13652),
    [sym_continue_statement] = ACTIONS(13652),
    [anon_sym_return] = ACTIONS(13652),
    [anon_sym_const] = ACTIONS(13652),
    [anon_sym_global] = ACTIONS(13652),
    [anon_sym_local] = ACTIONS(13652),
    [anon_sym_LPAREN] = ACTIONS(13652),
    [anon_sym_COLON2] = ACTIONS(13652),
    [anon_sym_export] = ACTIONS(13652),
    [anon_sym_import] = ACTIONS(13652),
    [anon_sym_using] = ACTIONS(13652),
    [anon_sym_LBRACK] = ACTIONS(13652),
    [anon_sym_LF] = ACTIONS(13654),
    [anon_sym_in] = ACTIONS(13652),
    [anon_sym_LBRACE] = ACTIONS(13652),
    [anon_sym_DOLLAR] = ACTIONS(13652),
    [anon_sym_COLON_COLON] = ACTIONS(13652),
    [anon_sym_isa] = ACTIONS(13652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13652),
    [anon_sym_QMARK] = ACTIONS(13652),
    [anon_sym_AT] = ACTIONS(13652),
    [anon_sym_true] = ACTIONS(13652),
    [anon_sym_false] = ACTIONS(13652),
    [aux_sym_integer_literal_token1] = ACTIONS(13652),
    [aux_sym_integer_literal_token2] = ACTIONS(13652),
    [aux_sym_integer_literal_token3] = ACTIONS(13652),
    [aux_sym_integer_literal_token4] = ACTIONS(13652),
    [aux_sym_float_literal_token1] = ACTIONS(13652),
    [aux_sym_float_literal_token3] = ACTIONS(13652),
    [aux_sym_float_literal_token4] = ACTIONS(13652),
    [sym_character_literal] = ACTIONS(13652),
    [sym__pair_operator] = ACTIONS(13652),
    [sym__arrow_operator] = ACTIONS(13652),
    [sym__lazy_or_operator] = ACTIONS(13652),
    [sym__lazy_and_operator] = ACTIONS(13652),
    [sym__comparison_operator] = ACTIONS(13652),
    [sym__pipe_right_operator] = ACTIONS(13652),
    [sym__pipe_left_operator] = ACTIONS(13652),
    [sym__ellipsis_operator] = ACTIONS(13652),
    [sym__plus_operator] = ACTIONS(13652),
    [sym__times_operator] = ACTIONS(13652),
    [sym__rational_operator] = ACTIONS(13652),
    [sym__bitshift_operator] = ACTIONS(13652),
    [sym__power_operator] = ACTIONS(13652),
    [sym__tilde_operator] = ACTIONS(13652),
    [sym__type_order_operator] = ACTIONS(13652),
    [sym__unary_operator] = ACTIONS(13652),
    [sym__unary_plus_operator] = ACTIONS(13652),
    [aux_sym__terminator_token1] = ACTIONS(13652),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13654),
    [sym__command_start] = ACTIONS(13654),
  },
  [7573] = {
    [sym__word_identifier] = ACTIONS(13656),
    [anon_sym_EQ] = ACTIONS(13656),
    [anon_sym_COMMA] = ACTIONS(13656),
    [anon_sym_COLON] = ACTIONS(13656),
    [anon_sym_begin] = ACTIONS(13656),
    [anon_sym_module] = ACTIONS(13656),
    [anon_sym_baremodule] = ACTIONS(13656),
    [anon_sym_end] = ACTIONS(13656),
    [anon_sym_abstract] = ACTIONS(13656),
    [anon_sym_primitive] = ACTIONS(13656),
    [anon_sym_mutable] = ACTIONS(13656),
    [anon_sym_struct] = ACTIONS(13656),
    [anon_sym_function] = ACTIONS(13656),
    [anon_sym_macro] = ACTIONS(13656),
    [anon_sym_where] = ACTIONS(13656),
    [anon_sym_quote] = ACTIONS(13656),
    [anon_sym_let] = ACTIONS(13656),
    [anon_sym_if] = ACTIONS(13656),
    [anon_sym_elseif] = ACTIONS(13656),
    [anon_sym_else] = ACTIONS(13656),
    [anon_sym_try] = ACTIONS(13656),
    [anon_sym_for] = ACTIONS(13656),
    [anon_sym_while] = ACTIONS(13656),
    [sym_break_statement] = ACTIONS(13656),
    [sym_continue_statement] = ACTIONS(13656),
    [anon_sym_return] = ACTIONS(13656),
    [anon_sym_const] = ACTIONS(13656),
    [anon_sym_global] = ACTIONS(13656),
    [anon_sym_local] = ACTIONS(13656),
    [anon_sym_LPAREN] = ACTIONS(13656),
    [anon_sym_COLON2] = ACTIONS(13656),
    [anon_sym_export] = ACTIONS(13656),
    [anon_sym_import] = ACTIONS(13656),
    [anon_sym_using] = ACTIONS(13656),
    [anon_sym_LBRACK] = ACTIONS(13656),
    [anon_sym_LF] = ACTIONS(13658),
    [anon_sym_in] = ACTIONS(13656),
    [anon_sym_LBRACE] = ACTIONS(13656),
    [anon_sym_DOLLAR] = ACTIONS(13656),
    [anon_sym_COLON_COLON] = ACTIONS(13656),
    [anon_sym_isa] = ACTIONS(13656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13656),
    [anon_sym_QMARK] = ACTIONS(13656),
    [anon_sym_AT] = ACTIONS(13656),
    [anon_sym_true] = ACTIONS(13656),
    [anon_sym_false] = ACTIONS(13656),
    [aux_sym_integer_literal_token1] = ACTIONS(13656),
    [aux_sym_integer_literal_token2] = ACTIONS(13656),
    [aux_sym_integer_literal_token3] = ACTIONS(13656),
    [aux_sym_integer_literal_token4] = ACTIONS(13656),
    [aux_sym_float_literal_token1] = ACTIONS(13656),
    [aux_sym_float_literal_token3] = ACTIONS(13656),
    [aux_sym_float_literal_token4] = ACTIONS(13656),
    [sym_character_literal] = ACTIONS(13656),
    [sym__pair_operator] = ACTIONS(13656),
    [sym__arrow_operator] = ACTIONS(13656),
    [sym__lazy_or_operator] = ACTIONS(13656),
    [sym__lazy_and_operator] = ACTIONS(13656),
    [sym__comparison_operator] = ACTIONS(13656),
    [sym__pipe_right_operator] = ACTIONS(13656),
    [sym__pipe_left_operator] = ACTIONS(13656),
    [sym__ellipsis_operator] = ACTIONS(13656),
    [sym__plus_operator] = ACTIONS(13656),
    [sym__times_operator] = ACTIONS(13656),
    [sym__rational_operator] = ACTIONS(13656),
    [sym__bitshift_operator] = ACTIONS(13656),
    [sym__power_operator] = ACTIONS(13656),
    [sym__tilde_operator] = ACTIONS(13656),
    [sym__type_order_operator] = ACTIONS(13656),
    [sym__unary_operator] = ACTIONS(13656),
    [sym__unary_plus_operator] = ACTIONS(13656),
    [aux_sym__terminator_token1] = ACTIONS(13656),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13658),
    [sym__command_start] = ACTIONS(13658),
  },
  [7574] = {
    [sym__word_identifier] = ACTIONS(13660),
    [anon_sym_EQ] = ACTIONS(13660),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_COLON] = ACTIONS(13660),
    [anon_sym_begin] = ACTIONS(13660),
    [anon_sym_module] = ACTIONS(13660),
    [anon_sym_baremodule] = ACTIONS(13660),
    [anon_sym_end] = ACTIONS(13660),
    [anon_sym_abstract] = ACTIONS(13660),
    [anon_sym_primitive] = ACTIONS(13660),
    [anon_sym_mutable] = ACTIONS(13660),
    [anon_sym_struct] = ACTIONS(13660),
    [anon_sym_function] = ACTIONS(13660),
    [anon_sym_macro] = ACTIONS(13660),
    [anon_sym_where] = ACTIONS(13660),
    [anon_sym_quote] = ACTIONS(13660),
    [anon_sym_let] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_elseif] = ACTIONS(13660),
    [anon_sym_else] = ACTIONS(13660),
    [anon_sym_try] = ACTIONS(13660),
    [anon_sym_for] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [sym_break_statement] = ACTIONS(13660),
    [sym_continue_statement] = ACTIONS(13660),
    [anon_sym_return] = ACTIONS(13660),
    [anon_sym_const] = ACTIONS(13660),
    [anon_sym_global] = ACTIONS(13660),
    [anon_sym_local] = ACTIONS(13660),
    [anon_sym_LPAREN] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13660),
    [anon_sym_export] = ACTIONS(13660),
    [anon_sym_import] = ACTIONS(13660),
    [anon_sym_using] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_LF] = ACTIONS(13662),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_DOLLAR] = ACTIONS(13660),
    [anon_sym_COLON_COLON] = ACTIONS(13660),
    [anon_sym_isa] = ACTIONS(13660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_AT] = ACTIONS(13660),
    [anon_sym_true] = ACTIONS(13660),
    [anon_sym_false] = ACTIONS(13660),
    [aux_sym_integer_literal_token1] = ACTIONS(13660),
    [aux_sym_integer_literal_token2] = ACTIONS(13660),
    [aux_sym_integer_literal_token3] = ACTIONS(13660),
    [aux_sym_integer_literal_token4] = ACTIONS(13660),
    [aux_sym_float_literal_token1] = ACTIONS(13660),
    [aux_sym_float_literal_token3] = ACTIONS(13660),
    [aux_sym_float_literal_token4] = ACTIONS(13660),
    [sym_character_literal] = ACTIONS(13660),
    [sym__pair_operator] = ACTIONS(13660),
    [sym__arrow_operator] = ACTIONS(13660),
    [sym__lazy_or_operator] = ACTIONS(13660),
    [sym__lazy_and_operator] = ACTIONS(13660),
    [sym__comparison_operator] = ACTIONS(13660),
    [sym__pipe_right_operator] = ACTIONS(13660),
    [sym__pipe_left_operator] = ACTIONS(13660),
    [sym__ellipsis_operator] = ACTIONS(13660),
    [sym__plus_operator] = ACTIONS(13660),
    [sym__times_operator] = ACTIONS(13660),
    [sym__rational_operator] = ACTIONS(13660),
    [sym__bitshift_operator] = ACTIONS(13660),
    [sym__power_operator] = ACTIONS(13660),
    [sym__tilde_operator] = ACTIONS(13660),
    [sym__type_order_operator] = ACTIONS(13660),
    [sym__unary_operator] = ACTIONS(13660),
    [sym__unary_plus_operator] = ACTIONS(13660),
    [aux_sym__terminator_token1] = ACTIONS(13660),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13662),
    [sym__command_start] = ACTIONS(13662),
  },
  [7575] = {
    [sym__word_identifier] = ACTIONS(13664),
    [anon_sym_EQ] = ACTIONS(13664),
    [anon_sym_COMMA] = ACTIONS(13664),
    [anon_sym_COLON] = ACTIONS(13664),
    [anon_sym_begin] = ACTIONS(13664),
    [anon_sym_module] = ACTIONS(13664),
    [anon_sym_baremodule] = ACTIONS(13664),
    [anon_sym_end] = ACTIONS(13664),
    [anon_sym_abstract] = ACTIONS(13664),
    [anon_sym_primitive] = ACTIONS(13664),
    [anon_sym_mutable] = ACTIONS(13664),
    [anon_sym_struct] = ACTIONS(13664),
    [anon_sym_function] = ACTIONS(13664),
    [anon_sym_macro] = ACTIONS(13664),
    [anon_sym_where] = ACTIONS(13664),
    [anon_sym_quote] = ACTIONS(13664),
    [anon_sym_let] = ACTIONS(13664),
    [anon_sym_if] = ACTIONS(13664),
    [anon_sym_elseif] = ACTIONS(13664),
    [anon_sym_else] = ACTIONS(13664),
    [anon_sym_try] = ACTIONS(13664),
    [anon_sym_for] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(13664),
    [sym_break_statement] = ACTIONS(13664),
    [sym_continue_statement] = ACTIONS(13664),
    [anon_sym_return] = ACTIONS(13664),
    [anon_sym_const] = ACTIONS(13664),
    [anon_sym_global] = ACTIONS(13664),
    [anon_sym_local] = ACTIONS(13664),
    [anon_sym_LPAREN] = ACTIONS(13664),
    [anon_sym_COLON2] = ACTIONS(13664),
    [anon_sym_export] = ACTIONS(13664),
    [anon_sym_import] = ACTIONS(13664),
    [anon_sym_using] = ACTIONS(13664),
    [anon_sym_LBRACK] = ACTIONS(13664),
    [anon_sym_LF] = ACTIONS(13666),
    [anon_sym_in] = ACTIONS(13664),
    [anon_sym_LBRACE] = ACTIONS(13664),
    [anon_sym_DOLLAR] = ACTIONS(13664),
    [anon_sym_COLON_COLON] = ACTIONS(13664),
    [anon_sym_isa] = ACTIONS(13664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13664),
    [anon_sym_QMARK] = ACTIONS(13664),
    [anon_sym_AT] = ACTIONS(13664),
    [anon_sym_true] = ACTIONS(13664),
    [anon_sym_false] = ACTIONS(13664),
    [aux_sym_integer_literal_token1] = ACTIONS(13664),
    [aux_sym_integer_literal_token2] = ACTIONS(13664),
    [aux_sym_integer_literal_token3] = ACTIONS(13664),
    [aux_sym_integer_literal_token4] = ACTIONS(13664),
    [aux_sym_float_literal_token1] = ACTIONS(13664),
    [aux_sym_float_literal_token3] = ACTIONS(13664),
    [aux_sym_float_literal_token4] = ACTIONS(13664),
    [sym_character_literal] = ACTIONS(13664),
    [sym__pair_operator] = ACTIONS(13664),
    [sym__arrow_operator] = ACTIONS(13664),
    [sym__lazy_or_operator] = ACTIONS(13664),
    [sym__lazy_and_operator] = ACTIONS(13664),
    [sym__comparison_operator] = ACTIONS(13664),
    [sym__pipe_right_operator] = ACTIONS(13664),
    [sym__pipe_left_operator] = ACTIONS(13664),
    [sym__ellipsis_operator] = ACTIONS(13664),
    [sym__plus_operator] = ACTIONS(13664),
    [sym__times_operator] = ACTIONS(13664),
    [sym__rational_operator] = ACTIONS(13664),
    [sym__bitshift_operator] = ACTIONS(13664),
    [sym__power_operator] = ACTIONS(13664),
    [sym__tilde_operator] = ACTIONS(13664),
    [sym__type_order_operator] = ACTIONS(13664),
    [sym__unary_operator] = ACTIONS(13664),
    [sym__unary_plus_operator] = ACTIONS(13664),
    [aux_sym__terminator_token1] = ACTIONS(13664),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13666),
    [sym__command_start] = ACTIONS(13666),
  },
  [7576] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2188),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2188),
    [aux_sym_integer_literal_token2] = ACTIONS(2188),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2188),
    [aux_sym_float_literal_token3] = ACTIONS(2188),
    [aux_sym_float_literal_token4] = ACTIONS(2188),
    [sym_character_literal] = ACTIONS(2188),
    [sym__pair_operator] = ACTIONS(2188),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2188),
    [sym__pipe_left_operator] = ACTIONS(2188),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2188),
    [sym__bitshift_operator] = ACTIONS(2188),
    [sym__power_operator] = ACTIONS(2188),
    [sym__tilde_operator] = ACTIONS(2188),
    [sym__type_order_operator] = ACTIONS(2188),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7577] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11894),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11894),
    [anon_sym_RPAREN] = ACTIONS(11894),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11894),
    [anon_sym_RBRACK] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11894),
    [anon_sym_RBRACE] = ACTIONS(11894),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11894),
    [anon_sym_COLON_COLON] = ACTIONS(11894),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11894),
    [anon_sym_QMARK] = ACTIONS(11894),
    [anon_sym_AT] = ACTIONS(11894),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11894),
    [aux_sym_integer_literal_token2] = ACTIONS(11894),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11894),
    [aux_sym_float_literal_token3] = ACTIONS(11894),
    [aux_sym_float_literal_token4] = ACTIONS(11894),
    [sym_character_literal] = ACTIONS(11894),
    [sym__pair_operator] = ACTIONS(11894),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11894),
    [sym__lazy_and_operator] = ACTIONS(11894),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11894),
    [sym__pipe_left_operator] = ACTIONS(11894),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11894),
    [sym__bitshift_operator] = ACTIONS(11894),
    [sym__power_operator] = ACTIONS(11894),
    [sym__tilde_operator] = ACTIONS(11894),
    [sym__type_order_operator] = ACTIONS(11894),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [7578] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [ts_builtin_sym_end] = ACTIONS(13100),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_RPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_RBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [7579] = {
    [sym__comprehension_clause] = STATE(19196),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16787),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13698),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13700),
    [anon_sym_LF] = ACTIONS(13702),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13705),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7580] = {
    [sym__comprehension_clause] = STATE(18457),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16825),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13708),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13710),
    [anon_sym_LF] = ACTIONS(13712),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13715),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7581] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_finally] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7582] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12462),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11952),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7583] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12462),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12470),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7584] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_as] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7585] = {
    [sym__comprehension_clause] = STATE(18220),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16942),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13718),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13720),
    [anon_sym_LF] = ACTIONS(13722),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13725),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7586] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_as] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_RPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_SEMI] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7587] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_as] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7588] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_as] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7589] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7590] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_catch] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13018),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7591] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_catch] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [7592] = {
    [aux_sym_export_statement_repeat1] = STATE(7615),
    [sym__word_identifier] = ACTIONS(13144),
    [anon_sym_EQ] = ACTIONS(13144),
    [anon_sym_COMMA] = ACTIONS(13728),
    [anon_sym_COLON] = ACTIONS(13144),
    [anon_sym_begin] = ACTIONS(13144),
    [anon_sym_module] = ACTIONS(13144),
    [anon_sym_baremodule] = ACTIONS(13144),
    [anon_sym_end] = ACTIONS(13144),
    [anon_sym_abstract] = ACTIONS(13144),
    [anon_sym_primitive] = ACTIONS(13144),
    [anon_sym_mutable] = ACTIONS(13144),
    [anon_sym_struct] = ACTIONS(13144),
    [anon_sym_function] = ACTIONS(13144),
    [anon_sym_macro] = ACTIONS(13144),
    [anon_sym_where] = ACTIONS(13144),
    [anon_sym_quote] = ACTIONS(13144),
    [anon_sym_let] = ACTIONS(13144),
    [anon_sym_if] = ACTIONS(13144),
    [anon_sym_try] = ACTIONS(13144),
    [anon_sym_finally] = ACTIONS(13144),
    [anon_sym_for] = ACTIONS(13144),
    [anon_sym_while] = ACTIONS(13144),
    [sym_break_statement] = ACTIONS(13144),
    [sym_continue_statement] = ACTIONS(13144),
    [anon_sym_return] = ACTIONS(13144),
    [anon_sym_const] = ACTIONS(13144),
    [anon_sym_global] = ACTIONS(13144),
    [anon_sym_local] = ACTIONS(13144),
    [anon_sym_LPAREN] = ACTIONS(13144),
    [anon_sym_COLON2] = ACTIONS(13144),
    [anon_sym_export] = ACTIONS(13144),
    [anon_sym_import] = ACTIONS(13144),
    [anon_sym_using] = ACTIONS(13144),
    [anon_sym_LBRACK] = ACTIONS(13144),
    [anon_sym_LF] = ACTIONS(13146),
    [anon_sym_in] = ACTIONS(13144),
    [anon_sym_LBRACE] = ACTIONS(13144),
    [anon_sym_DOLLAR] = ACTIONS(13144),
    [anon_sym_COLON_COLON] = ACTIONS(13144),
    [anon_sym_isa] = ACTIONS(13144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13144),
    [anon_sym_QMARK] = ACTIONS(13144),
    [anon_sym_AT] = ACTIONS(13144),
    [anon_sym_true] = ACTIONS(13144),
    [anon_sym_false] = ACTIONS(13144),
    [aux_sym_integer_literal_token1] = ACTIONS(13144),
    [aux_sym_integer_literal_token2] = ACTIONS(13144),
    [aux_sym_integer_literal_token3] = ACTIONS(13144),
    [aux_sym_integer_literal_token4] = ACTIONS(13144),
    [aux_sym_float_literal_token1] = ACTIONS(13144),
    [aux_sym_float_literal_token3] = ACTIONS(13144),
    [aux_sym_float_literal_token4] = ACTIONS(13144),
    [sym_character_literal] = ACTIONS(13144),
    [sym__pair_operator] = ACTIONS(13144),
    [sym__arrow_operator] = ACTIONS(13144),
    [sym__lazy_or_operator] = ACTIONS(13144),
    [sym__lazy_and_operator] = ACTIONS(13144),
    [sym__comparison_operator] = ACTIONS(13144),
    [sym__pipe_right_operator] = ACTIONS(13144),
    [sym__pipe_left_operator] = ACTIONS(13144),
    [sym__ellipsis_operator] = ACTIONS(13144),
    [sym__plus_operator] = ACTIONS(13144),
    [sym__times_operator] = ACTIONS(13144),
    [sym__rational_operator] = ACTIONS(13144),
    [sym__bitshift_operator] = ACTIONS(13144),
    [sym__power_operator] = ACTIONS(13144),
    [sym__tilde_operator] = ACTIONS(13144),
    [sym__type_order_operator] = ACTIONS(13144),
    [sym__unary_operator] = ACTIONS(13144),
    [sym__unary_plus_operator] = ACTIONS(13144),
    [aux_sym__terminator_token1] = ACTIONS(13144),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13146),
    [sym__command_start] = ACTIONS(13146),
  },
  [7593] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11938),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7594] = {
    [aux_sym__import_list_repeat1] = STATE(7616),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13026),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_finally] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7595] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(13730),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7596] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_catch] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7597] = {
    [sym__comprehension_clause] = STATE(18587),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16667),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13732),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13734),
    [anon_sym_LF] = ACTIONS(13736),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13739),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7598] = {
    [aux_sym__import_list_repeat1] = STATE(8252),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13742),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13744),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(13746),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7599] = {
    [sym__word_identifier] = ACTIONS(12882),
    [anon_sym_EQ] = ACTIONS(12882),
    [anon_sym_COMMA] = ACTIONS(12882),
    [anon_sym_COLON] = ACTIONS(12882),
    [anon_sym_begin] = ACTIONS(12882),
    [anon_sym_module] = ACTIONS(12882),
    [anon_sym_baremodule] = ACTIONS(12882),
    [anon_sym_end] = ACTIONS(12882),
    [anon_sym_abstract] = ACTIONS(12882),
    [anon_sym_primitive] = ACTIONS(12882),
    [anon_sym_mutable] = ACTIONS(12882),
    [anon_sym_struct] = ACTIONS(12882),
    [anon_sym_function] = ACTIONS(12882),
    [anon_sym_macro] = ACTIONS(12882),
    [anon_sym_where] = ACTIONS(12882),
    [anon_sym_quote] = ACTIONS(12882),
    [anon_sym_let] = ACTIONS(12882),
    [anon_sym_if] = ACTIONS(12882),
    [anon_sym_try] = ACTIONS(12882),
    [anon_sym_for] = ACTIONS(12882),
    [anon_sym_while] = ACTIONS(12882),
    [sym_break_statement] = ACTIONS(12882),
    [sym_continue_statement] = ACTIONS(12882),
    [anon_sym_return] = ACTIONS(12882),
    [anon_sym_const] = ACTIONS(12882),
    [anon_sym_global] = ACTIONS(12882),
    [anon_sym_local] = ACTIONS(12882),
    [anon_sym_as] = ACTIONS(12882),
    [anon_sym_LPAREN] = ACTIONS(12882),
    [anon_sym_COLON2] = ACTIONS(12882),
    [anon_sym_export] = ACTIONS(12882),
    [anon_sym_import] = ACTIONS(12882),
    [anon_sym_using] = ACTIONS(12882),
    [anon_sym_LBRACK] = ACTIONS(12882),
    [anon_sym_LF] = ACTIONS(12884),
    [anon_sym_in] = ACTIONS(12882),
    [anon_sym_LBRACE] = ACTIONS(12882),
    [anon_sym_DOT] = ACTIONS(13748),
    [anon_sym_DOLLAR] = ACTIONS(12882),
    [anon_sym_COLON_COLON] = ACTIONS(12882),
    [anon_sym_isa] = ACTIONS(12882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12882),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_AT] = ACTIONS(12882),
    [anon_sym_true] = ACTIONS(12882),
    [anon_sym_false] = ACTIONS(12882),
    [aux_sym_integer_literal_token1] = ACTIONS(12882),
    [aux_sym_integer_literal_token2] = ACTIONS(12882),
    [aux_sym_integer_literal_token3] = ACTIONS(12882),
    [aux_sym_integer_literal_token4] = ACTIONS(12882),
    [aux_sym_float_literal_token1] = ACTIONS(12882),
    [aux_sym_float_literal_token3] = ACTIONS(12882),
    [aux_sym_float_literal_token4] = ACTIONS(12882),
    [sym_character_literal] = ACTIONS(12882),
    [sym__pair_operator] = ACTIONS(12882),
    [sym__arrow_operator] = ACTIONS(12882),
    [sym__lazy_or_operator] = ACTIONS(12882),
    [sym__lazy_and_operator] = ACTIONS(12882),
    [sym__comparison_operator] = ACTIONS(12882),
    [sym__pipe_right_operator] = ACTIONS(12882),
    [sym__pipe_left_operator] = ACTIONS(12882),
    [sym__ellipsis_operator] = ACTIONS(12882),
    [sym__plus_operator] = ACTIONS(12882),
    [sym__times_operator] = ACTIONS(12882),
    [sym__rational_operator] = ACTIONS(12882),
    [sym__bitshift_operator] = ACTIONS(12882),
    [sym__power_operator] = ACTIONS(12882),
    [sym__tilde_operator] = ACTIONS(12882),
    [sym__type_order_operator] = ACTIONS(12882),
    [sym__unary_operator] = ACTIONS(12882),
    [sym__unary_plus_operator] = ACTIONS(12882),
    [aux_sym__terminator_token1] = ACTIONS(12882),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12884),
    [sym__command_start] = ACTIONS(12884),
  },
  [7600] = {
    [sym__word_identifier] = ACTIONS(12886),
    [anon_sym_EQ] = ACTIONS(12886),
    [anon_sym_COMMA] = ACTIONS(12886),
    [anon_sym_COLON] = ACTIONS(12886),
    [anon_sym_begin] = ACTIONS(12886),
    [anon_sym_module] = ACTIONS(12886),
    [anon_sym_baremodule] = ACTIONS(12886),
    [anon_sym_end] = ACTIONS(12886),
    [anon_sym_abstract] = ACTIONS(12886),
    [anon_sym_primitive] = ACTIONS(12886),
    [anon_sym_mutable] = ACTIONS(12886),
    [anon_sym_struct] = ACTIONS(12886),
    [anon_sym_function] = ACTIONS(12886),
    [anon_sym_macro] = ACTIONS(12886),
    [anon_sym_where] = ACTIONS(12886),
    [anon_sym_quote] = ACTIONS(12886),
    [anon_sym_let] = ACTIONS(12886),
    [anon_sym_if] = ACTIONS(12886),
    [anon_sym_try] = ACTIONS(12886),
    [anon_sym_for] = ACTIONS(12886),
    [anon_sym_while] = ACTIONS(12886),
    [sym_break_statement] = ACTIONS(12886),
    [sym_continue_statement] = ACTIONS(12886),
    [anon_sym_return] = ACTIONS(12886),
    [anon_sym_const] = ACTIONS(12886),
    [anon_sym_global] = ACTIONS(12886),
    [anon_sym_local] = ACTIONS(12886),
    [anon_sym_as] = ACTIONS(12886),
    [anon_sym_LPAREN] = ACTIONS(12886),
    [anon_sym_COLON2] = ACTIONS(12886),
    [anon_sym_export] = ACTIONS(12886),
    [anon_sym_import] = ACTIONS(12886),
    [anon_sym_using] = ACTIONS(12886),
    [anon_sym_LBRACK] = ACTIONS(12886),
    [anon_sym_LF] = ACTIONS(12888),
    [anon_sym_in] = ACTIONS(12886),
    [anon_sym_LBRACE] = ACTIONS(12886),
    [anon_sym_DOT] = ACTIONS(13748),
    [anon_sym_DOLLAR] = ACTIONS(12886),
    [anon_sym_COLON_COLON] = ACTIONS(12886),
    [anon_sym_isa] = ACTIONS(12886),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_QMARK] = ACTIONS(12886),
    [anon_sym_AT] = ACTIONS(12886),
    [anon_sym_true] = ACTIONS(12886),
    [anon_sym_false] = ACTIONS(12886),
    [aux_sym_integer_literal_token1] = ACTIONS(12886),
    [aux_sym_integer_literal_token2] = ACTIONS(12886),
    [aux_sym_integer_literal_token3] = ACTIONS(12886),
    [aux_sym_integer_literal_token4] = ACTIONS(12886),
    [aux_sym_float_literal_token1] = ACTIONS(12886),
    [aux_sym_float_literal_token3] = ACTIONS(12886),
    [aux_sym_float_literal_token4] = ACTIONS(12886),
    [sym_character_literal] = ACTIONS(12886),
    [sym__pair_operator] = ACTIONS(12886),
    [sym__arrow_operator] = ACTIONS(12886),
    [sym__lazy_or_operator] = ACTIONS(12886),
    [sym__lazy_and_operator] = ACTIONS(12886),
    [sym__comparison_operator] = ACTIONS(12886),
    [sym__pipe_right_operator] = ACTIONS(12886),
    [sym__pipe_left_operator] = ACTIONS(12886),
    [sym__ellipsis_operator] = ACTIONS(12886),
    [sym__plus_operator] = ACTIONS(12886),
    [sym__times_operator] = ACTIONS(12886),
    [sym__rational_operator] = ACTIONS(12886),
    [sym__bitshift_operator] = ACTIONS(12886),
    [sym__power_operator] = ACTIONS(12886),
    [sym__tilde_operator] = ACTIONS(12886),
    [sym__type_order_operator] = ACTIONS(12886),
    [sym__unary_operator] = ACTIONS(12886),
    [sym__unary_plus_operator] = ACTIONS(12886),
    [aux_sym__terminator_token1] = ACTIONS(12886),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12888),
    [sym__command_start] = ACTIONS(12888),
  },
  [7601] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12610),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11922),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7602] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_as] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [7603] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_as] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [7604] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_as] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [7605] = {
    [sym__comprehension_clause] = STATE(19090),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16967),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13750),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13752),
    [anon_sym_LF] = ACTIONS(13754),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13757),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7606] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_as] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [7607] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_as] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [7608] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_as] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [7609] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_as] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [7610] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_as] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [7611] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_as] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [7612] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_as] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [7613] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_as] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [7614] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_as] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [7615] = {
    [aux_sym_export_statement_repeat1] = STATE(7640),
    [sym__word_identifier] = ACTIONS(13060),
    [anon_sym_EQ] = ACTIONS(13060),
    [anon_sym_COMMA] = ACTIONS(13728),
    [anon_sym_COLON] = ACTIONS(13060),
    [anon_sym_begin] = ACTIONS(13060),
    [anon_sym_module] = ACTIONS(13060),
    [anon_sym_baremodule] = ACTIONS(13060),
    [anon_sym_end] = ACTIONS(13060),
    [anon_sym_abstract] = ACTIONS(13060),
    [anon_sym_primitive] = ACTIONS(13060),
    [anon_sym_mutable] = ACTIONS(13060),
    [anon_sym_struct] = ACTIONS(13060),
    [anon_sym_function] = ACTIONS(13060),
    [anon_sym_macro] = ACTIONS(13060),
    [anon_sym_where] = ACTIONS(13060),
    [anon_sym_quote] = ACTIONS(13060),
    [anon_sym_let] = ACTIONS(13060),
    [anon_sym_if] = ACTIONS(13060),
    [anon_sym_try] = ACTIONS(13060),
    [anon_sym_finally] = ACTIONS(13060),
    [anon_sym_for] = ACTIONS(13060),
    [anon_sym_while] = ACTIONS(13060),
    [sym_break_statement] = ACTIONS(13060),
    [sym_continue_statement] = ACTIONS(13060),
    [anon_sym_return] = ACTIONS(13060),
    [anon_sym_const] = ACTIONS(13060),
    [anon_sym_global] = ACTIONS(13060),
    [anon_sym_local] = ACTIONS(13060),
    [anon_sym_LPAREN] = ACTIONS(13060),
    [anon_sym_COLON2] = ACTIONS(13060),
    [anon_sym_export] = ACTIONS(13060),
    [anon_sym_import] = ACTIONS(13060),
    [anon_sym_using] = ACTIONS(13060),
    [anon_sym_LBRACK] = ACTIONS(13060),
    [anon_sym_LF] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13060),
    [anon_sym_LBRACE] = ACTIONS(13060),
    [anon_sym_DOLLAR] = ACTIONS(13060),
    [anon_sym_COLON_COLON] = ACTIONS(13060),
    [anon_sym_isa] = ACTIONS(13060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13060),
    [anon_sym_QMARK] = ACTIONS(13060),
    [anon_sym_AT] = ACTIONS(13060),
    [anon_sym_true] = ACTIONS(13060),
    [anon_sym_false] = ACTIONS(13060),
    [aux_sym_integer_literal_token1] = ACTIONS(13060),
    [aux_sym_integer_literal_token2] = ACTIONS(13060),
    [aux_sym_integer_literal_token3] = ACTIONS(13060),
    [aux_sym_integer_literal_token4] = ACTIONS(13060),
    [aux_sym_float_literal_token1] = ACTIONS(13060),
    [aux_sym_float_literal_token3] = ACTIONS(13060),
    [aux_sym_float_literal_token4] = ACTIONS(13060),
    [sym_character_literal] = ACTIONS(13060),
    [sym__pair_operator] = ACTIONS(13060),
    [sym__arrow_operator] = ACTIONS(13060),
    [sym__lazy_or_operator] = ACTIONS(13060),
    [sym__lazy_and_operator] = ACTIONS(13060),
    [sym__comparison_operator] = ACTIONS(13060),
    [sym__pipe_right_operator] = ACTIONS(13060),
    [sym__pipe_left_operator] = ACTIONS(13060),
    [sym__ellipsis_operator] = ACTIONS(13060),
    [sym__plus_operator] = ACTIONS(13060),
    [sym__times_operator] = ACTIONS(13060),
    [sym__rational_operator] = ACTIONS(13060),
    [sym__bitshift_operator] = ACTIONS(13060),
    [sym__power_operator] = ACTIONS(13060),
    [sym__tilde_operator] = ACTIONS(13060),
    [sym__type_order_operator] = ACTIONS(13060),
    [sym__unary_operator] = ACTIONS(13060),
    [sym__unary_plus_operator] = ACTIONS(13060),
    [aux_sym__terminator_token1] = ACTIONS(13060),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13064),
    [sym__command_start] = ACTIONS(13064),
  },
  [7616] = {
    [aux_sym__import_list_repeat1] = STATE(7642),
    [sym__word_identifier] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13026),
    [anon_sym_COLON] = ACTIONS(13066),
    [anon_sym_begin] = ACTIONS(13066),
    [anon_sym_module] = ACTIONS(13066),
    [anon_sym_baremodule] = ACTIONS(13066),
    [anon_sym_end] = ACTIONS(13066),
    [anon_sym_abstract] = ACTIONS(13066),
    [anon_sym_primitive] = ACTIONS(13066),
    [anon_sym_mutable] = ACTIONS(13066),
    [anon_sym_struct] = ACTIONS(13066),
    [anon_sym_function] = ACTIONS(13066),
    [anon_sym_macro] = ACTIONS(13066),
    [anon_sym_where] = ACTIONS(13066),
    [anon_sym_quote] = ACTIONS(13066),
    [anon_sym_let] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13066),
    [anon_sym_try] = ACTIONS(13066),
    [anon_sym_finally] = ACTIONS(13066),
    [anon_sym_for] = ACTIONS(13066),
    [anon_sym_while] = ACTIONS(13066),
    [sym_break_statement] = ACTIONS(13066),
    [sym_continue_statement] = ACTIONS(13066),
    [anon_sym_return] = ACTIONS(13066),
    [anon_sym_const] = ACTIONS(13066),
    [anon_sym_global] = ACTIONS(13066),
    [anon_sym_local] = ACTIONS(13066),
    [anon_sym_LPAREN] = ACTIONS(13066),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_export] = ACTIONS(13066),
    [anon_sym_import] = ACTIONS(13066),
    [anon_sym_using] = ACTIONS(13066),
    [anon_sym_LBRACK] = ACTIONS(13066),
    [anon_sym_LF] = ACTIONS(13068),
    [anon_sym_in] = ACTIONS(13066),
    [anon_sym_LBRACE] = ACTIONS(13066),
    [anon_sym_DOLLAR] = ACTIONS(13066),
    [anon_sym_COLON_COLON] = ACTIONS(13066),
    [anon_sym_isa] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13066),
    [anon_sym_QMARK] = ACTIONS(13066),
    [anon_sym_AT] = ACTIONS(13066),
    [anon_sym_true] = ACTIONS(13066),
    [anon_sym_false] = ACTIONS(13066),
    [aux_sym_integer_literal_token1] = ACTIONS(13066),
    [aux_sym_integer_literal_token2] = ACTIONS(13066),
    [aux_sym_integer_literal_token3] = ACTIONS(13066),
    [aux_sym_integer_literal_token4] = ACTIONS(13066),
    [aux_sym_float_literal_token1] = ACTIONS(13066),
    [aux_sym_float_literal_token3] = ACTIONS(13066),
    [aux_sym_float_literal_token4] = ACTIONS(13066),
    [sym_character_literal] = ACTIONS(13066),
    [sym__pair_operator] = ACTIONS(13066),
    [sym__arrow_operator] = ACTIONS(13066),
    [sym__lazy_or_operator] = ACTIONS(13066),
    [sym__lazy_and_operator] = ACTIONS(13066),
    [sym__comparison_operator] = ACTIONS(13066),
    [sym__pipe_right_operator] = ACTIONS(13066),
    [sym__pipe_left_operator] = ACTIONS(13066),
    [sym__ellipsis_operator] = ACTIONS(13066),
    [sym__plus_operator] = ACTIONS(13066),
    [sym__times_operator] = ACTIONS(13066),
    [sym__rational_operator] = ACTIONS(13066),
    [sym__bitshift_operator] = ACTIONS(13066),
    [sym__power_operator] = ACTIONS(13066),
    [sym__tilde_operator] = ACTIONS(13066),
    [sym__type_order_operator] = ACTIONS(13066),
    [sym__unary_operator] = ACTIONS(13066),
    [sym__unary_plus_operator] = ACTIONS(13066),
    [aux_sym__terminator_token1] = ACTIONS(13066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13068),
    [sym__command_start] = ACTIONS(13068),
  },
  [7617] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_as] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [7618] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_as] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [7619] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_as] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [7620] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_as] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [7621] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_as] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [7622] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_as] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [7623] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_as] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [7624] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(12220),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_elseif] = ACTIONS(13249),
    [anon_sym_else] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7625] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_as] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [7626] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_as] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [7627] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_as] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [7628] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_as] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [7629] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_as] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [7630] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_as] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [7631] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [7632] = {
    [sym__comprehension_clause] = STATE(19650),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17244),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13760),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13762),
    [anon_sym_LF] = ACTIONS(13764),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13767),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7633] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_as] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [7634] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(12220),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_elseif] = ACTIONS(13201),
    [anon_sym_else] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [7635] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_as] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [7636] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_as] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [7637] = {
    [aux_sym_open_tuple_repeat1] = STATE(7255),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(12928),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_elseif] = ACTIONS(13201),
    [anon_sym_else] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13324),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [7638] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_as] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [7639] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13036),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_as] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13036),
    [anon_sym_RPAREN] = ACTIONS(13036),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13036),
    [anon_sym_RBRACK] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_SEMI] = ACTIONS(13036),
    [anon_sym_LBRACE] = ACTIONS(13036),
    [anon_sym_RBRACE] = ACTIONS(13036),
    [anon_sym_DOLLAR] = ACTIONS(13036),
    [anon_sym_COLON_COLON] = ACTIONS(13036),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13036),
    [anon_sym_QMARK] = ACTIONS(13036),
    [anon_sym_AT] = ACTIONS(13036),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13036),
    [aux_sym_integer_literal_token2] = ACTIONS(13036),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13036),
    [aux_sym_float_literal_token3] = ACTIONS(13036),
    [aux_sym_float_literal_token4] = ACTIONS(13036),
    [sym_character_literal] = ACTIONS(13036),
    [sym__pair_operator] = ACTIONS(13036),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13036),
    [sym__lazy_and_operator] = ACTIONS(13036),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13036),
    [sym__pipe_left_operator] = ACTIONS(13036),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13036),
    [sym__bitshift_operator] = ACTIONS(13036),
    [sym__power_operator] = ACTIONS(13036),
    [sym__tilde_operator] = ACTIONS(13036),
    [sym__type_order_operator] = ACTIONS(13036),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [7640] = {
    [aux_sym_export_statement_repeat1] = STATE(7640),
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(13770),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_end] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_finally] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [7641] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_finally] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_as] = ACTIONS(13028),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7642] = {
    [aux_sym__import_list_repeat1] = STATE(7642),
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(13773),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_finally] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7643] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_as] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [7644] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_as] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [7645] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_as] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [7646] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7647] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13142),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7648] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_as] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [7649] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7650] = {
    [sym__comprehension_clause] = STATE(19835),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16841),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13776),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13778),
    [anon_sym_LF] = ACTIONS(13780),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13783),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7651] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_as] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7652] = {
    [sym__comprehension_clause] = STATE(18659),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16836),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13786),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13788),
    [anon_sym_LF] = ACTIONS(13790),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13793),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7653] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11944),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7654] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [7655] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12056),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12056),
    [anon_sym_RPAREN] = ACTIONS(12056),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12056),
    [anon_sym_RBRACK] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12056),
    [anon_sym_LBRACE] = ACTIONS(12056),
    [anon_sym_RBRACE] = ACTIONS(12056),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12056),
    [anon_sym_COLON_COLON] = ACTIONS(12056),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12056),
    [anon_sym_QMARK] = ACTIONS(12056),
    [anon_sym_AT] = ACTIONS(12056),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12056),
    [aux_sym_integer_literal_token2] = ACTIONS(12056),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12056),
    [aux_sym_float_literal_token3] = ACTIONS(12056),
    [aux_sym_float_literal_token4] = ACTIONS(12056),
    [sym_character_literal] = ACTIONS(12056),
    [sym__pair_operator] = ACTIONS(12056),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12056),
    [sym__lazy_and_operator] = ACTIONS(12056),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12056),
    [sym__pipe_left_operator] = ACTIONS(12056),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12056),
    [sym__bitshift_operator] = ACTIONS(12056),
    [sym__power_operator] = ACTIONS(12056),
    [sym__tilde_operator] = ACTIONS(12056),
    [sym__type_order_operator] = ACTIONS(12056),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7656] = {
    [sym__word_identifier] = ACTIONS(12846),
    [anon_sym_EQ] = ACTIONS(12846),
    [anon_sym_COMMA] = ACTIONS(12846),
    [anon_sym_COLON] = ACTIONS(12846),
    [anon_sym_begin] = ACTIONS(12846),
    [anon_sym_module] = ACTIONS(12846),
    [anon_sym_baremodule] = ACTIONS(12846),
    [anon_sym_end] = ACTIONS(12846),
    [anon_sym_abstract] = ACTIONS(12846),
    [anon_sym_primitive] = ACTIONS(12846),
    [anon_sym_mutable] = ACTIONS(12846),
    [anon_sym_struct] = ACTIONS(12846),
    [anon_sym_function] = ACTIONS(12846),
    [anon_sym_macro] = ACTIONS(12846),
    [anon_sym_where] = ACTIONS(12846),
    [anon_sym_quote] = ACTIONS(12846),
    [anon_sym_let] = ACTIONS(12846),
    [anon_sym_if] = ACTIONS(12846),
    [anon_sym_try] = ACTIONS(12846),
    [anon_sym_for] = ACTIONS(12846),
    [anon_sym_while] = ACTIONS(12846),
    [sym_break_statement] = ACTIONS(12846),
    [sym_continue_statement] = ACTIONS(12846),
    [anon_sym_return] = ACTIONS(12846),
    [anon_sym_const] = ACTIONS(12846),
    [anon_sym_global] = ACTIONS(12846),
    [anon_sym_local] = ACTIONS(12846),
    [anon_sym_as] = ACTIONS(12846),
    [anon_sym_LPAREN] = ACTIONS(12846),
    [anon_sym_COLON2] = ACTIONS(12846),
    [anon_sym_export] = ACTIONS(12846),
    [anon_sym_import] = ACTIONS(12846),
    [anon_sym_using] = ACTIONS(12846),
    [anon_sym_LBRACK] = ACTIONS(12846),
    [anon_sym_LF] = ACTIONS(12848),
    [anon_sym_in] = ACTIONS(12846),
    [anon_sym_LBRACE] = ACTIONS(12846),
    [anon_sym_DOT] = ACTIONS(13748),
    [anon_sym_DOLLAR] = ACTIONS(12846),
    [anon_sym_COLON_COLON] = ACTIONS(12846),
    [anon_sym_isa] = ACTIONS(12846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12846),
    [anon_sym_QMARK] = ACTIONS(12846),
    [anon_sym_AT] = ACTIONS(12846),
    [anon_sym_true] = ACTIONS(12846),
    [anon_sym_false] = ACTIONS(12846),
    [aux_sym_integer_literal_token1] = ACTIONS(12846),
    [aux_sym_integer_literal_token2] = ACTIONS(12846),
    [aux_sym_integer_literal_token3] = ACTIONS(12846),
    [aux_sym_integer_literal_token4] = ACTIONS(12846),
    [aux_sym_float_literal_token1] = ACTIONS(12846),
    [aux_sym_float_literal_token3] = ACTIONS(12846),
    [aux_sym_float_literal_token4] = ACTIONS(12846),
    [sym_character_literal] = ACTIONS(12846),
    [sym__pair_operator] = ACTIONS(12846),
    [sym__arrow_operator] = ACTIONS(12846),
    [sym__lazy_or_operator] = ACTIONS(12846),
    [sym__lazy_and_operator] = ACTIONS(12846),
    [sym__comparison_operator] = ACTIONS(12846),
    [sym__pipe_right_operator] = ACTIONS(12846),
    [sym__pipe_left_operator] = ACTIONS(12846),
    [sym__ellipsis_operator] = ACTIONS(12846),
    [sym__plus_operator] = ACTIONS(12846),
    [sym__times_operator] = ACTIONS(12846),
    [sym__rational_operator] = ACTIONS(12846),
    [sym__bitshift_operator] = ACTIONS(12846),
    [sym__power_operator] = ACTIONS(12846),
    [sym__tilde_operator] = ACTIONS(12846),
    [sym__type_order_operator] = ACTIONS(12846),
    [sym__unary_operator] = ACTIONS(12846),
    [sym__unary_plus_operator] = ACTIONS(12846),
    [aux_sym__terminator_token1] = ACTIONS(12846),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12848),
    [sym__command_start] = ACTIONS(12848),
  },
  [7657] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12060),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12060),
    [anon_sym_RPAREN] = ACTIONS(12060),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12060),
    [anon_sym_RBRACK] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12060),
    [anon_sym_LBRACE] = ACTIONS(12060),
    [anon_sym_RBRACE] = ACTIONS(12060),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12060),
    [anon_sym_COLON_COLON] = ACTIONS(12060),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12060),
    [anon_sym_QMARK] = ACTIONS(12060),
    [anon_sym_AT] = ACTIONS(12060),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12060),
    [aux_sym_integer_literal_token2] = ACTIONS(12060),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12060),
    [aux_sym_float_literal_token3] = ACTIONS(12060),
    [aux_sym_float_literal_token4] = ACTIONS(12060),
    [sym_character_literal] = ACTIONS(12060),
    [sym__pair_operator] = ACTIONS(12060),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12060),
    [sym__lazy_and_operator] = ACTIONS(12060),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12060),
    [sym__pipe_left_operator] = ACTIONS(12060),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12060),
    [sym__bitshift_operator] = ACTIONS(12060),
    [sym__power_operator] = ACTIONS(12060),
    [sym__tilde_operator] = ACTIONS(12060),
    [sym__type_order_operator] = ACTIONS(12060),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7658] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12044),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12044),
    [anon_sym_RPAREN] = ACTIONS(12044),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12044),
    [anon_sym_RBRACK] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12044),
    [anon_sym_LBRACE] = ACTIONS(12044),
    [anon_sym_RBRACE] = ACTIONS(12044),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12044),
    [anon_sym_COLON_COLON] = ACTIONS(12044),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12044),
    [anon_sym_QMARK] = ACTIONS(12044),
    [anon_sym_AT] = ACTIONS(12044),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12044),
    [aux_sym_integer_literal_token2] = ACTIONS(12044),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12044),
    [aux_sym_float_literal_token3] = ACTIONS(12044),
    [aux_sym_float_literal_token4] = ACTIONS(12044),
    [sym_character_literal] = ACTIONS(12044),
    [sym__pair_operator] = ACTIONS(12044),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12044),
    [sym__lazy_and_operator] = ACTIONS(12044),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12044),
    [sym__pipe_left_operator] = ACTIONS(12044),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12044),
    [sym__bitshift_operator] = ACTIONS(12044),
    [sym__power_operator] = ACTIONS(12044),
    [sym__tilde_operator] = ACTIONS(12044),
    [sym__type_order_operator] = ACTIONS(12044),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7659] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12508),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7660] = {
    [aux_sym_open_tuple_repeat1] = STATE(7068),
    [ts_builtin_sym_end] = ACTIONS(13247),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_RPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_RBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7661] = {
    [sym__comprehension_clause] = STATE(18446),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17226),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13796),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13798),
    [anon_sym_LF] = ACTIONS(13800),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13803),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7662] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7663] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13806),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_elseif] = ACTIONS(13255),
    [anon_sym_else] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13324),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [7664] = {
    [sym__comprehension_clause] = STATE(18413),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16690),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13808),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13810),
    [anon_sym_LF] = ACTIONS(13812),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13815),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7665] = {
    [sym__comprehension_clause] = STATE(19088),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17166),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13818),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13820),
    [anon_sym_LF] = ACTIONS(13822),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13825),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7666] = {
    [aux_sym__import_list_repeat1] = STATE(8252),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13742),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13744),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7667] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_as] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [7668] = {
    [sym__comprehension_clause] = STATE(19033),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16712),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13828),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13830),
    [anon_sym_LF] = ACTIONS(13832),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13835),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7669] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12234),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12234),
    [anon_sym_RPAREN] = ACTIONS(12234),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12234),
    [anon_sym_RBRACK] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_SEMI] = ACTIONS(12234),
    [anon_sym_LBRACE] = ACTIONS(12234),
    [anon_sym_RBRACE] = ACTIONS(12234),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12234),
    [anon_sym_COLON_COLON] = ACTIONS(12234),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12234),
    [anon_sym_QMARK] = ACTIONS(12234),
    [anon_sym_AT] = ACTIONS(12234),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12234),
    [aux_sym_integer_literal_token2] = ACTIONS(12234),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12234),
    [aux_sym_float_literal_token3] = ACTIONS(12234),
    [aux_sym_float_literal_token4] = ACTIONS(12234),
    [sym_character_literal] = ACTIONS(12234),
    [sym__pair_operator] = ACTIONS(12234),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12234),
    [sym__lazy_and_operator] = ACTIONS(12234),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12234),
    [sym__pipe_left_operator] = ACTIONS(12234),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12234),
    [sym__bitshift_operator] = ACTIONS(12234),
    [sym__power_operator] = ACTIONS(12234),
    [sym__tilde_operator] = ACTIONS(12234),
    [sym__type_order_operator] = ACTIONS(12234),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [7670] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12238),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12238),
    [anon_sym_RPAREN] = ACTIONS(12238),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12238),
    [anon_sym_RBRACK] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_SEMI] = ACTIONS(12238),
    [anon_sym_LBRACE] = ACTIONS(12238),
    [anon_sym_RBRACE] = ACTIONS(12238),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12238),
    [anon_sym_COLON_COLON] = ACTIONS(12238),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12238),
    [anon_sym_QMARK] = ACTIONS(12238),
    [anon_sym_AT] = ACTIONS(12238),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12238),
    [aux_sym_integer_literal_token2] = ACTIONS(12238),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12238),
    [aux_sym_float_literal_token3] = ACTIONS(12238),
    [aux_sym_float_literal_token4] = ACTIONS(12238),
    [sym_character_literal] = ACTIONS(12238),
    [sym__pair_operator] = ACTIONS(12238),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12238),
    [sym__lazy_and_operator] = ACTIONS(12238),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12238),
    [sym__pipe_left_operator] = ACTIONS(12238),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12238),
    [sym__bitshift_operator] = ACTIONS(12238),
    [sym__power_operator] = ACTIONS(12238),
    [sym__tilde_operator] = ACTIONS(12238),
    [sym__type_order_operator] = ACTIONS(12238),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [7671] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12242),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12242),
    [anon_sym_RPAREN] = ACTIONS(12242),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12242),
    [anon_sym_RBRACK] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_SEMI] = ACTIONS(12242),
    [anon_sym_LBRACE] = ACTIONS(12242),
    [anon_sym_RBRACE] = ACTIONS(12242),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12242),
    [anon_sym_COLON_COLON] = ACTIONS(12242),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12242),
    [anon_sym_QMARK] = ACTIONS(12242),
    [anon_sym_AT] = ACTIONS(12242),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12242),
    [aux_sym_integer_literal_token2] = ACTIONS(12242),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12242),
    [aux_sym_float_literal_token3] = ACTIONS(12242),
    [aux_sym_float_literal_token4] = ACTIONS(12242),
    [sym_character_literal] = ACTIONS(12242),
    [sym__pair_operator] = ACTIONS(12242),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12242),
    [sym__lazy_and_operator] = ACTIONS(12242),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12242),
    [sym__pipe_left_operator] = ACTIONS(12242),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12242),
    [sym__bitshift_operator] = ACTIONS(12242),
    [sym__power_operator] = ACTIONS(12242),
    [sym__tilde_operator] = ACTIONS(12242),
    [sym__type_order_operator] = ACTIONS(12242),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [7672] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12246),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12246),
    [anon_sym_RPAREN] = ACTIONS(12246),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12246),
    [anon_sym_RBRACK] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_SEMI] = ACTIONS(12246),
    [anon_sym_LBRACE] = ACTIONS(12246),
    [anon_sym_RBRACE] = ACTIONS(12246),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12246),
    [anon_sym_COLON_COLON] = ACTIONS(12246),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12246),
    [anon_sym_QMARK] = ACTIONS(12246),
    [anon_sym_AT] = ACTIONS(12246),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12246),
    [aux_sym_integer_literal_token2] = ACTIONS(12246),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12246),
    [aux_sym_float_literal_token3] = ACTIONS(12246),
    [aux_sym_float_literal_token4] = ACTIONS(12246),
    [sym_character_literal] = ACTIONS(12246),
    [sym__pair_operator] = ACTIONS(12246),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12246),
    [sym__lazy_and_operator] = ACTIONS(12246),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12246),
    [sym__pipe_left_operator] = ACTIONS(12246),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12246),
    [sym__bitshift_operator] = ACTIONS(12246),
    [sym__power_operator] = ACTIONS(12246),
    [sym__tilde_operator] = ACTIONS(12246),
    [sym__type_order_operator] = ACTIONS(12246),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [7673] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12250),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12250),
    [anon_sym_RPAREN] = ACTIONS(12250),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12250),
    [anon_sym_RBRACK] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_SEMI] = ACTIONS(12250),
    [anon_sym_LBRACE] = ACTIONS(12250),
    [anon_sym_RBRACE] = ACTIONS(12250),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12250),
    [anon_sym_COLON_COLON] = ACTIONS(12250),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12250),
    [anon_sym_QMARK] = ACTIONS(12250),
    [anon_sym_AT] = ACTIONS(12250),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12250),
    [aux_sym_integer_literal_token2] = ACTIONS(12250),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12250),
    [aux_sym_float_literal_token3] = ACTIONS(12250),
    [aux_sym_float_literal_token4] = ACTIONS(12250),
    [sym_character_literal] = ACTIONS(12250),
    [sym__pair_operator] = ACTIONS(12250),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12250),
    [sym__lazy_and_operator] = ACTIONS(12250),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12250),
    [sym__pipe_left_operator] = ACTIONS(12250),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12250),
    [sym__bitshift_operator] = ACTIONS(12250),
    [sym__power_operator] = ACTIONS(12250),
    [sym__tilde_operator] = ACTIONS(12250),
    [sym__type_order_operator] = ACTIONS(12250),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [7674] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12254),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12254),
    [anon_sym_RPAREN] = ACTIONS(12254),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12254),
    [anon_sym_RBRACK] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_SEMI] = ACTIONS(12254),
    [anon_sym_LBRACE] = ACTIONS(12254),
    [anon_sym_RBRACE] = ACTIONS(12254),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12254),
    [anon_sym_COLON_COLON] = ACTIONS(12254),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12254),
    [anon_sym_QMARK] = ACTIONS(12254),
    [anon_sym_AT] = ACTIONS(12254),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12254),
    [aux_sym_integer_literal_token2] = ACTIONS(12254),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12254),
    [aux_sym_float_literal_token3] = ACTIONS(12254),
    [aux_sym_float_literal_token4] = ACTIONS(12254),
    [sym_character_literal] = ACTIONS(12254),
    [sym__pair_operator] = ACTIONS(12254),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12254),
    [sym__lazy_and_operator] = ACTIONS(12254),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12254),
    [sym__pipe_left_operator] = ACTIONS(12254),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12254),
    [sym__bitshift_operator] = ACTIONS(12254),
    [sym__power_operator] = ACTIONS(12254),
    [sym__tilde_operator] = ACTIONS(12254),
    [sym__type_order_operator] = ACTIONS(12254),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [7675] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12258),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12258),
    [anon_sym_RPAREN] = ACTIONS(12258),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12258),
    [anon_sym_RBRACK] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_SEMI] = ACTIONS(12258),
    [anon_sym_LBRACE] = ACTIONS(12258),
    [anon_sym_RBRACE] = ACTIONS(12258),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12258),
    [anon_sym_COLON_COLON] = ACTIONS(12258),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12258),
    [anon_sym_QMARK] = ACTIONS(12258),
    [anon_sym_AT] = ACTIONS(12258),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12258),
    [aux_sym_integer_literal_token2] = ACTIONS(12258),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12258),
    [aux_sym_float_literal_token3] = ACTIONS(12258),
    [aux_sym_float_literal_token4] = ACTIONS(12258),
    [sym_character_literal] = ACTIONS(12258),
    [sym__pair_operator] = ACTIONS(12258),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12258),
    [sym__lazy_and_operator] = ACTIONS(12258),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12258),
    [sym__pipe_left_operator] = ACTIONS(12258),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12258),
    [sym__bitshift_operator] = ACTIONS(12258),
    [sym__power_operator] = ACTIONS(12258),
    [sym__tilde_operator] = ACTIONS(12258),
    [sym__type_order_operator] = ACTIONS(12258),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [7676] = {
    [sym__comprehension_clause] = STATE(19345),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16812),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13838),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13840),
    [anon_sym_LF] = ACTIONS(13842),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13845),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7677] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12064),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12064),
    [anon_sym_RPAREN] = ACTIONS(12064),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12064),
    [anon_sym_RBRACK] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12064),
    [anon_sym_LBRACE] = ACTIONS(12064),
    [anon_sym_RBRACE] = ACTIONS(12064),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12064),
    [anon_sym_COLON_COLON] = ACTIONS(12064),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12064),
    [anon_sym_QMARK] = ACTIONS(12064),
    [anon_sym_AT] = ACTIONS(12064),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12064),
    [aux_sym_integer_literal_token2] = ACTIONS(12064),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12064),
    [aux_sym_float_literal_token3] = ACTIONS(12064),
    [aux_sym_float_literal_token4] = ACTIONS(12064),
    [sym_character_literal] = ACTIONS(12064),
    [sym__pair_operator] = ACTIONS(12064),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12064),
    [sym__lazy_and_operator] = ACTIONS(12064),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12064),
    [sym__pipe_left_operator] = ACTIONS(12064),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12064),
    [sym__bitshift_operator] = ACTIONS(12064),
    [sym__power_operator] = ACTIONS(12064),
    [sym__tilde_operator] = ACTIONS(12064),
    [sym__type_order_operator] = ACTIONS(12064),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [7678] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_RPAREN] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_RBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_RBRACE] = ACTIONS(12052),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12052),
    [sym__bitshift_operator] = ACTIONS(12052),
    [sym__power_operator] = ACTIONS(12052),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [7679] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12262),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12262),
    [anon_sym_RPAREN] = ACTIONS(12262),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12262),
    [anon_sym_RBRACK] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_SEMI] = ACTIONS(12262),
    [anon_sym_LBRACE] = ACTIONS(12262),
    [anon_sym_RBRACE] = ACTIONS(12262),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12262),
    [anon_sym_COLON_COLON] = ACTIONS(12262),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12262),
    [anon_sym_QMARK] = ACTIONS(12262),
    [anon_sym_AT] = ACTIONS(12262),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12262),
    [aux_sym_integer_literal_token2] = ACTIONS(12262),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12262),
    [aux_sym_float_literal_token3] = ACTIONS(12262),
    [aux_sym_float_literal_token4] = ACTIONS(12262),
    [sym_character_literal] = ACTIONS(12262),
    [sym__pair_operator] = ACTIONS(12262),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12262),
    [sym__lazy_and_operator] = ACTIONS(12262),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12262),
    [sym__pipe_left_operator] = ACTIONS(12262),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12262),
    [sym__bitshift_operator] = ACTIONS(12262),
    [sym__power_operator] = ACTIONS(12262),
    [sym__tilde_operator] = ACTIONS(12262),
    [sym__type_order_operator] = ACTIONS(12262),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [7680] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12266),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12266),
    [anon_sym_RPAREN] = ACTIONS(12266),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12266),
    [anon_sym_RBRACK] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_SEMI] = ACTIONS(12266),
    [anon_sym_LBRACE] = ACTIONS(12266),
    [anon_sym_RBRACE] = ACTIONS(12266),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12266),
    [anon_sym_COLON_COLON] = ACTIONS(12266),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12266),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_AT] = ACTIONS(12266),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12266),
    [aux_sym_integer_literal_token2] = ACTIONS(12266),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12266),
    [aux_sym_float_literal_token3] = ACTIONS(12266),
    [aux_sym_float_literal_token4] = ACTIONS(12266),
    [sym_character_literal] = ACTIONS(12266),
    [sym__pair_operator] = ACTIONS(12266),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12266),
    [sym__lazy_and_operator] = ACTIONS(12266),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12266),
    [sym__pipe_left_operator] = ACTIONS(12266),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12266),
    [sym__bitshift_operator] = ACTIONS(12266),
    [sym__power_operator] = ACTIONS(12266),
    [sym__tilde_operator] = ACTIONS(12266),
    [sym__type_order_operator] = ACTIONS(12266),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [7681] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12270),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12270),
    [anon_sym_RPAREN] = ACTIONS(12270),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12270),
    [anon_sym_RBRACK] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_SEMI] = ACTIONS(12270),
    [anon_sym_LBRACE] = ACTIONS(12270),
    [anon_sym_RBRACE] = ACTIONS(12270),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12270),
    [anon_sym_COLON_COLON] = ACTIONS(12270),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_QMARK] = ACTIONS(12270),
    [anon_sym_AT] = ACTIONS(12270),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12270),
    [aux_sym_integer_literal_token2] = ACTIONS(12270),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12270),
    [aux_sym_float_literal_token3] = ACTIONS(12270),
    [aux_sym_float_literal_token4] = ACTIONS(12270),
    [sym_character_literal] = ACTIONS(12270),
    [sym__pair_operator] = ACTIONS(12270),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12270),
    [sym__lazy_and_operator] = ACTIONS(12270),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12270),
    [sym__pipe_left_operator] = ACTIONS(12270),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12270),
    [sym__bitshift_operator] = ACTIONS(12270),
    [sym__power_operator] = ACTIONS(12270),
    [sym__tilde_operator] = ACTIONS(12270),
    [sym__type_order_operator] = ACTIONS(12270),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [7682] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12274),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12274),
    [anon_sym_RPAREN] = ACTIONS(12274),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12274),
    [anon_sym_RBRACK] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_SEMI] = ACTIONS(12274),
    [anon_sym_LBRACE] = ACTIONS(12274),
    [anon_sym_RBRACE] = ACTIONS(12274),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12274),
    [anon_sym_COLON_COLON] = ACTIONS(12274),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12274),
    [anon_sym_QMARK] = ACTIONS(12274),
    [anon_sym_AT] = ACTIONS(12274),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12274),
    [aux_sym_integer_literal_token2] = ACTIONS(12274),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12274),
    [aux_sym_float_literal_token3] = ACTIONS(12274),
    [aux_sym_float_literal_token4] = ACTIONS(12274),
    [sym_character_literal] = ACTIONS(12274),
    [sym__pair_operator] = ACTIONS(12274),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12274),
    [sym__lazy_and_operator] = ACTIONS(12274),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12274),
    [sym__pipe_left_operator] = ACTIONS(12274),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12274),
    [sym__bitshift_operator] = ACTIONS(12274),
    [sym__power_operator] = ACTIONS(12274),
    [sym__tilde_operator] = ACTIONS(12274),
    [sym__type_order_operator] = ACTIONS(12274),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [7683] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12278),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12278),
    [anon_sym_RPAREN] = ACTIONS(12278),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12278),
    [anon_sym_RBRACK] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12278),
    [anon_sym_LBRACE] = ACTIONS(12278),
    [anon_sym_RBRACE] = ACTIONS(12278),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12278),
    [anon_sym_COLON_COLON] = ACTIONS(12278),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12278),
    [anon_sym_QMARK] = ACTIONS(12278),
    [anon_sym_AT] = ACTIONS(12278),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12278),
    [aux_sym_integer_literal_token2] = ACTIONS(12278),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12278),
    [aux_sym_float_literal_token3] = ACTIONS(12278),
    [aux_sym_float_literal_token4] = ACTIONS(12278),
    [sym_character_literal] = ACTIONS(12278),
    [sym__pair_operator] = ACTIONS(12278),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12278),
    [sym__lazy_and_operator] = ACTIONS(12278),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12278),
    [sym__pipe_left_operator] = ACTIONS(12278),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12278),
    [sym__bitshift_operator] = ACTIONS(12278),
    [sym__power_operator] = ACTIONS(12278),
    [sym__tilde_operator] = ACTIONS(12278),
    [sym__type_order_operator] = ACTIONS(12278),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [7684] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12068),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12068),
    [anon_sym_RPAREN] = ACTIONS(12068),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12068),
    [anon_sym_RBRACK] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12068),
    [anon_sym_LBRACE] = ACTIONS(12068),
    [anon_sym_RBRACE] = ACTIONS(12068),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12068),
    [anon_sym_COLON_COLON] = ACTIONS(12068),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12068),
    [anon_sym_QMARK] = ACTIONS(12068),
    [anon_sym_AT] = ACTIONS(12068),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12068),
    [aux_sym_integer_literal_token2] = ACTIONS(12068),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12068),
    [aux_sym_float_literal_token3] = ACTIONS(12068),
    [aux_sym_float_literal_token4] = ACTIONS(12068),
    [sym_character_literal] = ACTIONS(12068),
    [sym__pair_operator] = ACTIONS(12068),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12068),
    [sym__lazy_and_operator] = ACTIONS(12068),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12068),
    [sym__pipe_left_operator] = ACTIONS(12068),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12068),
    [sym__bitshift_operator] = ACTIONS(12068),
    [sym__power_operator] = ACTIONS(12068),
    [sym__tilde_operator] = ACTIONS(12068),
    [sym__type_order_operator] = ACTIONS(12068),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [7685] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12282),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12282),
    [anon_sym_RPAREN] = ACTIONS(12282),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12282),
    [anon_sym_RBRACK] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_SEMI] = ACTIONS(12282),
    [anon_sym_LBRACE] = ACTIONS(12282),
    [anon_sym_RBRACE] = ACTIONS(12282),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12282),
    [anon_sym_COLON_COLON] = ACTIONS(12282),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12282),
    [anon_sym_QMARK] = ACTIONS(12282),
    [anon_sym_AT] = ACTIONS(12282),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12282),
    [aux_sym_integer_literal_token2] = ACTIONS(12282),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12282),
    [aux_sym_float_literal_token3] = ACTIONS(12282),
    [aux_sym_float_literal_token4] = ACTIONS(12282),
    [sym_character_literal] = ACTIONS(12282),
    [sym__pair_operator] = ACTIONS(12282),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12282),
    [sym__lazy_and_operator] = ACTIONS(12282),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12282),
    [sym__pipe_left_operator] = ACTIONS(12282),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12282),
    [sym__bitshift_operator] = ACTIONS(12282),
    [sym__power_operator] = ACTIONS(12282),
    [sym__tilde_operator] = ACTIONS(12282),
    [sym__type_order_operator] = ACTIONS(12282),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [7686] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12140),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12140),
    [anon_sym_RPAREN] = ACTIONS(12140),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12140),
    [anon_sym_RBRACK] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_SEMI] = ACTIONS(12140),
    [anon_sym_LBRACE] = ACTIONS(12140),
    [anon_sym_RBRACE] = ACTIONS(12140),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12140),
    [anon_sym_COLON_COLON] = ACTIONS(12140),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12140),
    [anon_sym_QMARK] = ACTIONS(12140),
    [anon_sym_AT] = ACTIONS(12140),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12140),
    [aux_sym_integer_literal_token2] = ACTIONS(12140),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12140),
    [aux_sym_float_literal_token3] = ACTIONS(12140),
    [aux_sym_float_literal_token4] = ACTIONS(12140),
    [sym_character_literal] = ACTIONS(12140),
    [sym__pair_operator] = ACTIONS(12140),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12140),
    [sym__lazy_and_operator] = ACTIONS(12140),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12140),
    [sym__pipe_left_operator] = ACTIONS(12140),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12140),
    [sym__bitshift_operator] = ACTIONS(12140),
    [sym__power_operator] = ACTIONS(12140),
    [sym__tilde_operator] = ACTIONS(12140),
    [sym__type_order_operator] = ACTIONS(12140),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [7687] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12144),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12144),
    [anon_sym_RPAREN] = ACTIONS(12144),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12144),
    [anon_sym_RBRACK] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_SEMI] = ACTIONS(12144),
    [anon_sym_LBRACE] = ACTIONS(12144),
    [anon_sym_RBRACE] = ACTIONS(12144),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12144),
    [anon_sym_COLON_COLON] = ACTIONS(12144),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12144),
    [anon_sym_QMARK] = ACTIONS(12144),
    [anon_sym_AT] = ACTIONS(12144),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12144),
    [aux_sym_integer_literal_token2] = ACTIONS(12144),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12144),
    [aux_sym_float_literal_token3] = ACTIONS(12144),
    [aux_sym_float_literal_token4] = ACTIONS(12144),
    [sym_character_literal] = ACTIONS(12144),
    [sym__pair_operator] = ACTIONS(12144),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12144),
    [sym__lazy_and_operator] = ACTIONS(12144),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12144),
    [sym__pipe_left_operator] = ACTIONS(12144),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12144),
    [sym__bitshift_operator] = ACTIONS(12144),
    [sym__power_operator] = ACTIONS(12144),
    [sym__tilde_operator] = ACTIONS(12144),
    [sym__type_order_operator] = ACTIONS(12144),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [7688] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12148),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12148),
    [anon_sym_RPAREN] = ACTIONS(12148),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12148),
    [anon_sym_RBRACK] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_SEMI] = ACTIONS(12148),
    [anon_sym_LBRACE] = ACTIONS(12148),
    [anon_sym_RBRACE] = ACTIONS(12148),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12148),
    [anon_sym_COLON_COLON] = ACTIONS(12148),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12148),
    [anon_sym_QMARK] = ACTIONS(12148),
    [anon_sym_AT] = ACTIONS(12148),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12148),
    [aux_sym_integer_literal_token2] = ACTIONS(12148),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12148),
    [aux_sym_float_literal_token3] = ACTIONS(12148),
    [aux_sym_float_literal_token4] = ACTIONS(12148),
    [sym_character_literal] = ACTIONS(12148),
    [sym__pair_operator] = ACTIONS(12148),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12148),
    [sym__lazy_and_operator] = ACTIONS(12148),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12148),
    [sym__pipe_left_operator] = ACTIONS(12148),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12148),
    [sym__bitshift_operator] = ACTIONS(12148),
    [sym__power_operator] = ACTIONS(12148),
    [sym__tilde_operator] = ACTIONS(12148),
    [sym__type_order_operator] = ACTIONS(12148),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [7689] = {
    [sym__comprehension_clause] = STATE(18332),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17263),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13848),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13850),
    [anon_sym_LF] = ACTIONS(13852),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13855),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7690] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12156),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12156),
    [anon_sym_RPAREN] = ACTIONS(12156),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12156),
    [anon_sym_RBRACK] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_SEMI] = ACTIONS(12156),
    [anon_sym_LBRACE] = ACTIONS(12156),
    [anon_sym_RBRACE] = ACTIONS(12156),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12156),
    [anon_sym_COLON_COLON] = ACTIONS(12156),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12156),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_AT] = ACTIONS(12156),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12156),
    [aux_sym_integer_literal_token2] = ACTIONS(12156),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12156),
    [aux_sym_float_literal_token3] = ACTIONS(12156),
    [aux_sym_float_literal_token4] = ACTIONS(12156),
    [sym_character_literal] = ACTIONS(12156),
    [sym__pair_operator] = ACTIONS(12156),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12156),
    [sym__lazy_and_operator] = ACTIONS(12156),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12156),
    [sym__pipe_left_operator] = ACTIONS(12156),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12156),
    [sym__bitshift_operator] = ACTIONS(12156),
    [sym__power_operator] = ACTIONS(12156),
    [sym__tilde_operator] = ACTIONS(12156),
    [sym__type_order_operator] = ACTIONS(12156),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [7691] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12160),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12160),
    [anon_sym_RPAREN] = ACTIONS(12160),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12160),
    [anon_sym_RBRACK] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_SEMI] = ACTIONS(12160),
    [anon_sym_LBRACE] = ACTIONS(12160),
    [anon_sym_RBRACE] = ACTIONS(12160),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12160),
    [anon_sym_COLON_COLON] = ACTIONS(12160),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12160),
    [anon_sym_QMARK] = ACTIONS(12160),
    [anon_sym_AT] = ACTIONS(12160),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12160),
    [aux_sym_integer_literal_token2] = ACTIONS(12160),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12160),
    [aux_sym_float_literal_token3] = ACTIONS(12160),
    [aux_sym_float_literal_token4] = ACTIONS(12160),
    [sym_character_literal] = ACTIONS(12160),
    [sym__pair_operator] = ACTIONS(12160),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12160),
    [sym__lazy_and_operator] = ACTIONS(12160),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12160),
    [sym__pipe_left_operator] = ACTIONS(12160),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12160),
    [sym__bitshift_operator] = ACTIONS(12160),
    [sym__power_operator] = ACTIONS(12160),
    [sym__tilde_operator] = ACTIONS(12160),
    [sym__type_order_operator] = ACTIONS(12160),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [7692] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12208),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12208),
    [anon_sym_RPAREN] = ACTIONS(12208),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12208),
    [anon_sym_RBRACK] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_SEMI] = ACTIONS(12208),
    [anon_sym_LBRACE] = ACTIONS(12208),
    [anon_sym_RBRACE] = ACTIONS(12208),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12208),
    [anon_sym_COLON_COLON] = ACTIONS(12208),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12208),
    [anon_sym_QMARK] = ACTIONS(12208),
    [anon_sym_AT] = ACTIONS(12208),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12208),
    [aux_sym_integer_literal_token2] = ACTIONS(12208),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12208),
    [aux_sym_float_literal_token3] = ACTIONS(12208),
    [aux_sym_float_literal_token4] = ACTIONS(12208),
    [sym_character_literal] = ACTIONS(12208),
    [sym__pair_operator] = ACTIONS(12208),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12208),
    [sym__lazy_and_operator] = ACTIONS(12208),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12208),
    [sym__pipe_left_operator] = ACTIONS(12208),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12208),
    [sym__bitshift_operator] = ACTIONS(12208),
    [sym__power_operator] = ACTIONS(12208),
    [sym__tilde_operator] = ACTIONS(12208),
    [sym__type_order_operator] = ACTIONS(12208),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [7693] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12164),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12164),
    [anon_sym_RPAREN] = ACTIONS(12164),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12164),
    [anon_sym_RBRACK] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12164),
    [anon_sym_LBRACE] = ACTIONS(12164),
    [anon_sym_RBRACE] = ACTIONS(12164),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12164),
    [anon_sym_COLON_COLON] = ACTIONS(12164),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12164),
    [anon_sym_QMARK] = ACTIONS(12164),
    [anon_sym_AT] = ACTIONS(12164),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12164),
    [aux_sym_integer_literal_token2] = ACTIONS(12164),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12164),
    [aux_sym_float_literal_token3] = ACTIONS(12164),
    [aux_sym_float_literal_token4] = ACTIONS(12164),
    [sym_character_literal] = ACTIONS(12164),
    [sym__pair_operator] = ACTIONS(12164),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12164),
    [sym__lazy_and_operator] = ACTIONS(12164),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12164),
    [sym__pipe_left_operator] = ACTIONS(12164),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12164),
    [sym__bitshift_operator] = ACTIONS(12164),
    [sym__power_operator] = ACTIONS(12164),
    [sym__tilde_operator] = ACTIONS(12164),
    [sym__type_order_operator] = ACTIONS(12164),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [7694] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12168),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12168),
    [anon_sym_RPAREN] = ACTIONS(12168),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12168),
    [anon_sym_RBRACK] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_SEMI] = ACTIONS(12168),
    [anon_sym_LBRACE] = ACTIONS(12168),
    [anon_sym_RBRACE] = ACTIONS(12168),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12168),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12168),
    [anon_sym_QMARK] = ACTIONS(12168),
    [anon_sym_AT] = ACTIONS(12168),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12168),
    [aux_sym_integer_literal_token2] = ACTIONS(12168),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12168),
    [aux_sym_float_literal_token3] = ACTIONS(12168),
    [aux_sym_float_literal_token4] = ACTIONS(12168),
    [sym_character_literal] = ACTIONS(12168),
    [sym__pair_operator] = ACTIONS(12168),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12168),
    [sym__lazy_and_operator] = ACTIONS(12168),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12168),
    [sym__pipe_left_operator] = ACTIONS(12168),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12168),
    [sym__bitshift_operator] = ACTIONS(12168),
    [sym__power_operator] = ACTIONS(12168),
    [sym__tilde_operator] = ACTIONS(12168),
    [sym__type_order_operator] = ACTIONS(12168),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [7695] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12176),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12176),
    [anon_sym_RPAREN] = ACTIONS(12176),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12176),
    [anon_sym_RBRACK] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_SEMI] = ACTIONS(12176),
    [anon_sym_LBRACE] = ACTIONS(12176),
    [anon_sym_RBRACE] = ACTIONS(12176),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12176),
    [anon_sym_COLON_COLON] = ACTIONS(12176),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12176),
    [anon_sym_QMARK] = ACTIONS(12176),
    [anon_sym_AT] = ACTIONS(12176),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12176),
    [aux_sym_integer_literal_token2] = ACTIONS(12176),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12176),
    [aux_sym_float_literal_token3] = ACTIONS(12176),
    [aux_sym_float_literal_token4] = ACTIONS(12176),
    [sym_character_literal] = ACTIONS(12176),
    [sym__pair_operator] = ACTIONS(12176),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12176),
    [sym__lazy_and_operator] = ACTIONS(12176),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12176),
    [sym__pipe_left_operator] = ACTIONS(12176),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12176),
    [sym__bitshift_operator] = ACTIONS(12176),
    [sym__power_operator] = ACTIONS(12176),
    [sym__tilde_operator] = ACTIONS(12176),
    [sym__type_order_operator] = ACTIONS(12176),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [7696] = {
    [sym__comprehension_clause] = STATE(19500),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16855),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13858),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13860),
    [anon_sym_LF] = ACTIONS(13862),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13865),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7697] = {
    [sym__primary_expression] = STATE(11435),
    [sym__array] = STATE(11435),
    [sym_comprehension_expression] = STATE(11435),
    [sym_matrix_expression] = STATE(11435),
    [sym_vector_expression] = STATE(11435),
    [sym_parenthesized_expression] = STATE(11435),
    [sym_tuple_expression] = STATE(11435),
    [sym_curly_expression] = STATE(11435),
    [sym_adjoint_expression] = STATE(11435),
    [sym_field_expression] = STATE(11435),
    [sym_index_expression] = STATE(11435),
    [sym_parametrized_type_expression] = STATE(11435),
    [sym_call_expression] = STATE(11435),
    [sym_broadcast_call_expression] = STATE(11435),
    [sym__closed_macrocall_expression] = STATE(11435),
    [sym_interpolation_expression] = STATE(11435),
    [sym_quote_expression] = STATE(11435),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(11008),
    [sym_boolean_literal] = STATE(11435),
    [sym__string] = STATE(11435),
    [sym_string_literal] = STATE(11435),
    [sym_command_literal] = STATE(11435),
    [sym_prefixed_string_literal] = STATE(11435),
    [sym_prefixed_command_literal] = STATE(11435),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(13868),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(13870),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(13872),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [7698] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11946),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7699] = {
    [sym__comprehension_clause] = STATE(18850),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17171),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13874),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13876),
    [anon_sym_LF] = ACTIONS(13878),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13881),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7700] = {
    [aux_sym__import_list_repeat1] = STATE(8284),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13884),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13886),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_RPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(13888),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_SEMI] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7701] = {
    [sym__word_identifier] = ACTIONS(12882),
    [anon_sym_EQ] = ACTIONS(12882),
    [anon_sym_COMMA] = ACTIONS(12882),
    [anon_sym_COLON] = ACTIONS(12882),
    [anon_sym_begin] = ACTIONS(12882),
    [anon_sym_module] = ACTIONS(12882),
    [anon_sym_baremodule] = ACTIONS(12882),
    [anon_sym_abstract] = ACTIONS(12882),
    [anon_sym_primitive] = ACTIONS(12882),
    [anon_sym_mutable] = ACTIONS(12882),
    [anon_sym_struct] = ACTIONS(12882),
    [anon_sym_function] = ACTIONS(12882),
    [anon_sym_macro] = ACTIONS(12882),
    [anon_sym_where] = ACTIONS(12882),
    [anon_sym_quote] = ACTIONS(12882),
    [anon_sym_let] = ACTIONS(12882),
    [anon_sym_if] = ACTIONS(12882),
    [anon_sym_try] = ACTIONS(12882),
    [anon_sym_for] = ACTIONS(12882),
    [anon_sym_while] = ACTIONS(12882),
    [sym_break_statement] = ACTIONS(12882),
    [sym_continue_statement] = ACTIONS(12882),
    [anon_sym_return] = ACTIONS(12882),
    [anon_sym_const] = ACTIONS(12882),
    [anon_sym_global] = ACTIONS(12882),
    [anon_sym_local] = ACTIONS(12882),
    [anon_sym_as] = ACTIONS(12882),
    [anon_sym_LPAREN] = ACTIONS(12882),
    [anon_sym_RPAREN] = ACTIONS(12882),
    [anon_sym_COLON2] = ACTIONS(12882),
    [anon_sym_export] = ACTIONS(12882),
    [anon_sym_import] = ACTIONS(12882),
    [anon_sym_using] = ACTIONS(12882),
    [anon_sym_LBRACK] = ACTIONS(12882),
    [anon_sym_LF] = ACTIONS(12884),
    [anon_sym_in] = ACTIONS(12882),
    [anon_sym_SEMI] = ACTIONS(12882),
    [anon_sym_LBRACE] = ACTIONS(12882),
    [anon_sym_DOT] = ACTIONS(13730),
    [anon_sym_DOLLAR] = ACTIONS(12882),
    [anon_sym_COLON_COLON] = ACTIONS(12882),
    [anon_sym_isa] = ACTIONS(12882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12882),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_AT] = ACTIONS(12882),
    [anon_sym_true] = ACTIONS(12882),
    [anon_sym_false] = ACTIONS(12882),
    [aux_sym_integer_literal_token1] = ACTIONS(12882),
    [aux_sym_integer_literal_token2] = ACTIONS(12882),
    [aux_sym_integer_literal_token3] = ACTIONS(12882),
    [aux_sym_integer_literal_token4] = ACTIONS(12882),
    [aux_sym_float_literal_token1] = ACTIONS(12882),
    [aux_sym_float_literal_token3] = ACTIONS(12882),
    [aux_sym_float_literal_token4] = ACTIONS(12882),
    [sym_character_literal] = ACTIONS(12882),
    [sym__pair_operator] = ACTIONS(12882),
    [sym__arrow_operator] = ACTIONS(12882),
    [sym__lazy_or_operator] = ACTIONS(12882),
    [sym__lazy_and_operator] = ACTIONS(12882),
    [sym__comparison_operator] = ACTIONS(12882),
    [sym__pipe_right_operator] = ACTIONS(12882),
    [sym__pipe_left_operator] = ACTIONS(12882),
    [sym__ellipsis_operator] = ACTIONS(12882),
    [sym__plus_operator] = ACTIONS(12882),
    [sym__times_operator] = ACTIONS(12882),
    [sym__rational_operator] = ACTIONS(12882),
    [sym__bitshift_operator] = ACTIONS(12882),
    [sym__power_operator] = ACTIONS(12882),
    [sym__tilde_operator] = ACTIONS(12882),
    [sym__type_order_operator] = ACTIONS(12882),
    [sym__unary_operator] = ACTIONS(12882),
    [sym__unary_plus_operator] = ACTIONS(12882),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12884),
    [sym__command_start] = ACTIONS(12884),
  },
  [7702] = {
    [sym__word_identifier] = ACTIONS(12886),
    [anon_sym_EQ] = ACTIONS(12886),
    [anon_sym_COMMA] = ACTIONS(12886),
    [anon_sym_COLON] = ACTIONS(12886),
    [anon_sym_begin] = ACTIONS(12886),
    [anon_sym_module] = ACTIONS(12886),
    [anon_sym_baremodule] = ACTIONS(12886),
    [anon_sym_abstract] = ACTIONS(12886),
    [anon_sym_primitive] = ACTIONS(12886),
    [anon_sym_mutable] = ACTIONS(12886),
    [anon_sym_struct] = ACTIONS(12886),
    [anon_sym_function] = ACTIONS(12886),
    [anon_sym_macro] = ACTIONS(12886),
    [anon_sym_where] = ACTIONS(12886),
    [anon_sym_quote] = ACTIONS(12886),
    [anon_sym_let] = ACTIONS(12886),
    [anon_sym_if] = ACTIONS(12886),
    [anon_sym_try] = ACTIONS(12886),
    [anon_sym_for] = ACTIONS(12886),
    [anon_sym_while] = ACTIONS(12886),
    [sym_break_statement] = ACTIONS(12886),
    [sym_continue_statement] = ACTIONS(12886),
    [anon_sym_return] = ACTIONS(12886),
    [anon_sym_const] = ACTIONS(12886),
    [anon_sym_global] = ACTIONS(12886),
    [anon_sym_local] = ACTIONS(12886),
    [anon_sym_as] = ACTIONS(12886),
    [anon_sym_LPAREN] = ACTIONS(12886),
    [anon_sym_RPAREN] = ACTIONS(12886),
    [anon_sym_COLON2] = ACTIONS(12886),
    [anon_sym_export] = ACTIONS(12886),
    [anon_sym_import] = ACTIONS(12886),
    [anon_sym_using] = ACTIONS(12886),
    [anon_sym_LBRACK] = ACTIONS(12886),
    [anon_sym_LF] = ACTIONS(12888),
    [anon_sym_in] = ACTIONS(12886),
    [anon_sym_SEMI] = ACTIONS(12886),
    [anon_sym_LBRACE] = ACTIONS(12886),
    [anon_sym_DOT] = ACTIONS(13730),
    [anon_sym_DOLLAR] = ACTIONS(12886),
    [anon_sym_COLON_COLON] = ACTIONS(12886),
    [anon_sym_isa] = ACTIONS(12886),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_QMARK] = ACTIONS(12886),
    [anon_sym_AT] = ACTIONS(12886),
    [anon_sym_true] = ACTIONS(12886),
    [anon_sym_false] = ACTIONS(12886),
    [aux_sym_integer_literal_token1] = ACTIONS(12886),
    [aux_sym_integer_literal_token2] = ACTIONS(12886),
    [aux_sym_integer_literal_token3] = ACTIONS(12886),
    [aux_sym_integer_literal_token4] = ACTIONS(12886),
    [aux_sym_float_literal_token1] = ACTIONS(12886),
    [aux_sym_float_literal_token3] = ACTIONS(12886),
    [aux_sym_float_literal_token4] = ACTIONS(12886),
    [sym_character_literal] = ACTIONS(12886),
    [sym__pair_operator] = ACTIONS(12886),
    [sym__arrow_operator] = ACTIONS(12886),
    [sym__lazy_or_operator] = ACTIONS(12886),
    [sym__lazy_and_operator] = ACTIONS(12886),
    [sym__comparison_operator] = ACTIONS(12886),
    [sym__pipe_right_operator] = ACTIONS(12886),
    [sym__pipe_left_operator] = ACTIONS(12886),
    [sym__ellipsis_operator] = ACTIONS(12886),
    [sym__plus_operator] = ACTIONS(12886),
    [sym__times_operator] = ACTIONS(12886),
    [sym__rational_operator] = ACTIONS(12886),
    [sym__bitshift_operator] = ACTIONS(12886),
    [sym__power_operator] = ACTIONS(12886),
    [sym__tilde_operator] = ACTIONS(12886),
    [sym__type_order_operator] = ACTIONS(12886),
    [sym__unary_operator] = ACTIONS(12886),
    [sym__unary_plus_operator] = ACTIONS(12886),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12888),
    [sym__command_start] = ACTIONS(12888),
  },
  [7703] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13806),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_elseif] = ACTIONS(13094),
    [anon_sym_else] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13324),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [7704] = {
    [sym__comprehension_clause] = STATE(19749),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16857),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13890),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13892),
    [anon_sym_LF] = ACTIONS(13894),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13897),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7705] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12290),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12290),
    [anon_sym_RPAREN] = ACTIONS(12290),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12290),
    [anon_sym_RBRACK] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_SEMI] = ACTIONS(12290),
    [anon_sym_LBRACE] = ACTIONS(12290),
    [anon_sym_RBRACE] = ACTIONS(12290),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12290),
    [anon_sym_COLON_COLON] = ACTIONS(12290),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12290),
    [anon_sym_QMARK] = ACTIONS(12290),
    [anon_sym_AT] = ACTIONS(12290),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12290),
    [aux_sym_integer_literal_token2] = ACTIONS(12290),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12290),
    [aux_sym_float_literal_token3] = ACTIONS(12290),
    [aux_sym_float_literal_token4] = ACTIONS(12290),
    [sym_character_literal] = ACTIONS(12290),
    [sym__pair_operator] = ACTIONS(12290),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12290),
    [sym__lazy_and_operator] = ACTIONS(12290),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12290),
    [sym__pipe_left_operator] = ACTIONS(12290),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12290),
    [sym__bitshift_operator] = ACTIONS(12290),
    [sym__power_operator] = ACTIONS(12290),
    [sym__tilde_operator] = ACTIONS(12290),
    [sym__type_order_operator] = ACTIONS(12290),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [7706] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12298),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12298),
    [anon_sym_RPAREN] = ACTIONS(12298),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12298),
    [anon_sym_RBRACK] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_SEMI] = ACTIONS(12298),
    [anon_sym_LBRACE] = ACTIONS(12298),
    [anon_sym_RBRACE] = ACTIONS(12298),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12298),
    [anon_sym_COLON_COLON] = ACTIONS(12298),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12298),
    [anon_sym_QMARK] = ACTIONS(12298),
    [anon_sym_AT] = ACTIONS(12298),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12298),
    [aux_sym_integer_literal_token2] = ACTIONS(12298),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12298),
    [aux_sym_float_literal_token3] = ACTIONS(12298),
    [aux_sym_float_literal_token4] = ACTIONS(12298),
    [sym_character_literal] = ACTIONS(12298),
    [sym__pair_operator] = ACTIONS(12298),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12298),
    [sym__lazy_and_operator] = ACTIONS(12298),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12298),
    [sym__pipe_left_operator] = ACTIONS(12298),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12298),
    [sym__bitshift_operator] = ACTIONS(12298),
    [sym__power_operator] = ACTIONS(12298),
    [sym__tilde_operator] = ACTIONS(12298),
    [sym__type_order_operator] = ACTIONS(12298),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [7707] = {
    [sym__comprehension_clause] = STATE(18359),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17143),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13900),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13902),
    [anon_sym_LF] = ACTIONS(13904),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13907),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7708] = {
    [sym__word_identifier] = ACTIONS(12846),
    [anon_sym_EQ] = ACTIONS(12846),
    [anon_sym_COMMA] = ACTIONS(12846),
    [anon_sym_COLON] = ACTIONS(12846),
    [anon_sym_begin] = ACTIONS(12846),
    [anon_sym_module] = ACTIONS(12846),
    [anon_sym_baremodule] = ACTIONS(12846),
    [anon_sym_abstract] = ACTIONS(12846),
    [anon_sym_primitive] = ACTIONS(12846),
    [anon_sym_mutable] = ACTIONS(12846),
    [anon_sym_struct] = ACTIONS(12846),
    [anon_sym_function] = ACTIONS(12846),
    [anon_sym_macro] = ACTIONS(12846),
    [anon_sym_where] = ACTIONS(12846),
    [anon_sym_quote] = ACTIONS(12846),
    [anon_sym_let] = ACTIONS(12846),
    [anon_sym_if] = ACTIONS(12846),
    [anon_sym_try] = ACTIONS(12846),
    [anon_sym_for] = ACTIONS(12846),
    [anon_sym_while] = ACTIONS(12846),
    [sym_break_statement] = ACTIONS(12846),
    [sym_continue_statement] = ACTIONS(12846),
    [anon_sym_return] = ACTIONS(12846),
    [anon_sym_const] = ACTIONS(12846),
    [anon_sym_global] = ACTIONS(12846),
    [anon_sym_local] = ACTIONS(12846),
    [anon_sym_as] = ACTIONS(12846),
    [anon_sym_LPAREN] = ACTIONS(12846),
    [anon_sym_RPAREN] = ACTIONS(12846),
    [anon_sym_COLON2] = ACTIONS(12846),
    [anon_sym_export] = ACTIONS(12846),
    [anon_sym_import] = ACTIONS(12846),
    [anon_sym_using] = ACTIONS(12846),
    [anon_sym_LBRACK] = ACTIONS(12846),
    [anon_sym_LF] = ACTIONS(12848),
    [anon_sym_in] = ACTIONS(12846),
    [anon_sym_SEMI] = ACTIONS(12846),
    [anon_sym_LBRACE] = ACTIONS(12846),
    [anon_sym_DOT] = ACTIONS(13730),
    [anon_sym_DOLLAR] = ACTIONS(12846),
    [anon_sym_COLON_COLON] = ACTIONS(12846),
    [anon_sym_isa] = ACTIONS(12846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12846),
    [anon_sym_QMARK] = ACTIONS(12846),
    [anon_sym_AT] = ACTIONS(12846),
    [anon_sym_true] = ACTIONS(12846),
    [anon_sym_false] = ACTIONS(12846),
    [aux_sym_integer_literal_token1] = ACTIONS(12846),
    [aux_sym_integer_literal_token2] = ACTIONS(12846),
    [aux_sym_integer_literal_token3] = ACTIONS(12846),
    [aux_sym_integer_literal_token4] = ACTIONS(12846),
    [aux_sym_float_literal_token1] = ACTIONS(12846),
    [aux_sym_float_literal_token3] = ACTIONS(12846),
    [aux_sym_float_literal_token4] = ACTIONS(12846),
    [sym_character_literal] = ACTIONS(12846),
    [sym__pair_operator] = ACTIONS(12846),
    [sym__arrow_operator] = ACTIONS(12846),
    [sym__lazy_or_operator] = ACTIONS(12846),
    [sym__lazy_and_operator] = ACTIONS(12846),
    [sym__comparison_operator] = ACTIONS(12846),
    [sym__pipe_right_operator] = ACTIONS(12846),
    [sym__pipe_left_operator] = ACTIONS(12846),
    [sym__ellipsis_operator] = ACTIONS(12846),
    [sym__plus_operator] = ACTIONS(12846),
    [sym__times_operator] = ACTIONS(12846),
    [sym__rational_operator] = ACTIONS(12846),
    [sym__bitshift_operator] = ACTIONS(12846),
    [sym__power_operator] = ACTIONS(12846),
    [sym__tilde_operator] = ACTIONS(12846),
    [sym__type_order_operator] = ACTIONS(12846),
    [sym__unary_operator] = ACTIONS(12846),
    [sym__unary_plus_operator] = ACTIONS(12846),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12848),
    [sym__command_start] = ACTIONS(12848),
  },
  [7709] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12302),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12302),
    [anon_sym_RPAREN] = ACTIONS(12302),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12302),
    [anon_sym_RBRACK] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_SEMI] = ACTIONS(12302),
    [anon_sym_LBRACE] = ACTIONS(12302),
    [anon_sym_RBRACE] = ACTIONS(12302),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12302),
    [anon_sym_COLON_COLON] = ACTIONS(12302),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12302),
    [anon_sym_QMARK] = ACTIONS(12302),
    [anon_sym_AT] = ACTIONS(12302),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12302),
    [aux_sym_integer_literal_token2] = ACTIONS(12302),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12302),
    [aux_sym_float_literal_token3] = ACTIONS(12302),
    [aux_sym_float_literal_token4] = ACTIONS(12302),
    [sym_character_literal] = ACTIONS(12302),
    [sym__pair_operator] = ACTIONS(12302),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12302),
    [sym__lazy_and_operator] = ACTIONS(12302),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12302),
    [sym__pipe_left_operator] = ACTIONS(12302),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12302),
    [sym__bitshift_operator] = ACTIONS(12302),
    [sym__power_operator] = ACTIONS(12302),
    [sym__tilde_operator] = ACTIONS(12302),
    [sym__type_order_operator] = ACTIONS(12302),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [7710] = {
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13070),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_end] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_else] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_finally] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13108),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [7711] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_elseif] = ACTIONS(13255),
    [anon_sym_else] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13324),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(12942),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [7712] = {
    [sym__comprehension_clause] = STATE(18543),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17309),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13910),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13912),
    [anon_sym_LF] = ACTIONS(13914),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13917),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7713] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12152),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12152),
    [anon_sym_RPAREN] = ACTIONS(12152),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12152),
    [anon_sym_RBRACK] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_SEMI] = ACTIONS(12152),
    [anon_sym_LBRACE] = ACTIONS(12152),
    [anon_sym_RBRACE] = ACTIONS(12152),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12152),
    [anon_sym_COLON_COLON] = ACTIONS(12152),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12152),
    [anon_sym_QMARK] = ACTIONS(12152),
    [anon_sym_AT] = ACTIONS(12152),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12152),
    [aux_sym_integer_literal_token2] = ACTIONS(12152),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12152),
    [aux_sym_float_literal_token3] = ACTIONS(12152),
    [aux_sym_float_literal_token4] = ACTIONS(12152),
    [sym_character_literal] = ACTIONS(12152),
    [sym__pair_operator] = ACTIONS(12152),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12152),
    [sym__lazy_and_operator] = ACTIONS(12152),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12152),
    [sym__pipe_left_operator] = ACTIONS(12152),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12152),
    [sym__bitshift_operator] = ACTIONS(12152),
    [sym__power_operator] = ACTIONS(12152),
    [sym__tilde_operator] = ACTIONS(12152),
    [sym__type_order_operator] = ACTIONS(12152),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [7714] = {
    [sym__comprehension_clause] = STATE(18811),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16797),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13920),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13922),
    [anon_sym_LF] = ACTIONS(13924),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13927),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7715] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_catch] = ACTIONS(13038),
    [anon_sym_finally] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_as] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [7716] = {
    [aux_sym__import_list_repeat1] = STATE(8284),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13884),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_as] = ACTIONS(13886),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_RPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_SEMI] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7717] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7718] = {
    [sym__comprehension_clause] = STATE(19380),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17120),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13930),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13932),
    [anon_sym_LF] = ACTIONS(13934),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13937),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7719] = {
    [sym__comprehension_clause] = STATE(19580),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17207),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13940),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13942),
    [anon_sym_LF] = ACTIONS(13944),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7720] = {
    [sym__primary_expression] = STATE(11430),
    [sym__array] = STATE(11430),
    [sym_comprehension_expression] = STATE(11430),
    [sym_matrix_expression] = STATE(11430),
    [sym_vector_expression] = STATE(11430),
    [sym_parenthesized_expression] = STATE(11430),
    [sym_tuple_expression] = STATE(11430),
    [sym_curly_expression] = STATE(11430),
    [sym_adjoint_expression] = STATE(11430),
    [sym_field_expression] = STATE(11430),
    [sym_index_expression] = STATE(11430),
    [sym_parametrized_type_expression] = STATE(11430),
    [sym_call_expression] = STATE(11430),
    [sym_broadcast_call_expression] = STATE(11430),
    [sym__closed_macrocall_expression] = STATE(11430),
    [sym_interpolation_expression] = STATE(11430),
    [sym_quote_expression] = STATE(11430),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(11172),
    [sym_boolean_literal] = STATE(11430),
    [sym__string] = STATE(11430),
    [sym_string_literal] = STATE(11430),
    [sym_command_literal] = STATE(11430),
    [sym_prefixed_string_literal] = STATE(11430),
    [sym_prefixed_command_literal] = STATE(11430),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(13950),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_catch] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(13952),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(13954),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [7721] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(12930),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_elseif] = ACTIONS(13094),
    [anon_sym_else] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(12932),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(12936),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(12936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13324),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(12944),
    [sym__lazy_or_operator] = ACTIONS(12946),
    [sym__lazy_and_operator] = ACTIONS(12948),
    [sym__comparison_operator] = ACTIONS(12936),
    [sym__pipe_right_operator] = ACTIONS(12950),
    [sym__pipe_left_operator] = ACTIONS(12952),
    [sym__ellipsis_operator] = ACTIONS(12954),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(12936),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [7722] = {
    [sym__comprehension_clause] = STATE(19796),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17304),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13956),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13958),
    [anon_sym_LF] = ACTIONS(13960),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13963),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7723] = {
    [ts_builtin_sym_end] = ACTIONS(13318),
    [sym__word_identifier] = ACTIONS(13316),
    [anon_sym_EQ] = ACTIONS(13316),
    [anon_sym_COMMA] = ACTIONS(13316),
    [anon_sym_COLON] = ACTIONS(13316),
    [anon_sym_begin] = ACTIONS(13316),
    [anon_sym_module] = ACTIONS(13316),
    [anon_sym_baremodule] = ACTIONS(13316),
    [anon_sym_abstract] = ACTIONS(13316),
    [anon_sym_primitive] = ACTIONS(13316),
    [anon_sym_mutable] = ACTIONS(13316),
    [anon_sym_struct] = ACTIONS(13316),
    [anon_sym_function] = ACTIONS(13316),
    [anon_sym_macro] = ACTIONS(13316),
    [anon_sym_where] = ACTIONS(13316),
    [anon_sym_quote] = ACTIONS(13316),
    [anon_sym_let] = ACTIONS(13316),
    [anon_sym_if] = ACTIONS(13316),
    [anon_sym_try] = ACTIONS(13316),
    [anon_sym_for] = ACTIONS(13316),
    [anon_sym_while] = ACTIONS(13316),
    [sym_break_statement] = ACTIONS(13316),
    [sym_continue_statement] = ACTIONS(13316),
    [anon_sym_return] = ACTIONS(13316),
    [anon_sym_const] = ACTIONS(13316),
    [anon_sym_global] = ACTIONS(13316),
    [anon_sym_local] = ACTIONS(13316),
    [anon_sym_LPAREN] = ACTIONS(13316),
    [anon_sym_RPAREN] = ACTIONS(13316),
    [anon_sym_COLON2] = ACTIONS(13316),
    [anon_sym_export] = ACTIONS(13316),
    [anon_sym_import] = ACTIONS(13316),
    [anon_sym_using] = ACTIONS(13316),
    [anon_sym_LBRACK] = ACTIONS(13316),
    [anon_sym_RBRACK] = ACTIONS(13316),
    [anon_sym_LF] = ACTIONS(13318),
    [anon_sym_in] = ACTIONS(13316),
    [anon_sym_LBRACE] = ACTIONS(13316),
    [anon_sym_DOLLAR] = ACTIONS(13316),
    [anon_sym_COLON_COLON] = ACTIONS(13316),
    [anon_sym_isa] = ACTIONS(13316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13316),
    [anon_sym_QMARK] = ACTIONS(13316),
    [anon_sym_AT] = ACTIONS(13316),
    [anon_sym_true] = ACTIONS(13316),
    [anon_sym_false] = ACTIONS(13316),
    [aux_sym_integer_literal_token1] = ACTIONS(13316),
    [aux_sym_integer_literal_token2] = ACTIONS(13316),
    [aux_sym_integer_literal_token3] = ACTIONS(13316),
    [aux_sym_integer_literal_token4] = ACTIONS(13316),
    [aux_sym_float_literal_token1] = ACTIONS(13316),
    [aux_sym_float_literal_token3] = ACTIONS(13316),
    [aux_sym_float_literal_token4] = ACTIONS(13316),
    [sym_character_literal] = ACTIONS(13316),
    [sym__pair_operator] = ACTIONS(13316),
    [sym__arrow_operator] = ACTIONS(13316),
    [sym__lazy_or_operator] = ACTIONS(13316),
    [sym__lazy_and_operator] = ACTIONS(13316),
    [sym__comparison_operator] = ACTIONS(13316),
    [sym__pipe_right_operator] = ACTIONS(13316),
    [sym__pipe_left_operator] = ACTIONS(13316),
    [sym__ellipsis_operator] = ACTIONS(13316),
    [sym__plus_operator] = ACTIONS(13316),
    [sym__times_operator] = ACTIONS(13316),
    [sym__rational_operator] = ACTIONS(13316),
    [sym__bitshift_operator] = ACTIONS(13316),
    [sym__power_operator] = ACTIONS(13316),
    [sym__tilde_operator] = ACTIONS(13316),
    [sym__type_order_operator] = ACTIONS(13316),
    [sym__unary_operator] = ACTIONS(13316),
    [sym__unary_plus_operator] = ACTIONS(13316),
    [aux_sym__terminator_token1] = ACTIONS(13316),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13318),
    [sym__command_start] = ACTIONS(13318),
  },
  [7724] = {
    [ts_builtin_sym_end] = ACTIONS(13322),
    [sym__word_identifier] = ACTIONS(13320),
    [anon_sym_EQ] = ACTIONS(13320),
    [anon_sym_COMMA] = ACTIONS(13320),
    [anon_sym_COLON] = ACTIONS(13320),
    [anon_sym_begin] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(13320),
    [anon_sym_baremodule] = ACTIONS(13320),
    [anon_sym_abstract] = ACTIONS(13320),
    [anon_sym_primitive] = ACTIONS(13320),
    [anon_sym_mutable] = ACTIONS(13320),
    [anon_sym_struct] = ACTIONS(13320),
    [anon_sym_function] = ACTIONS(13320),
    [anon_sym_macro] = ACTIONS(13320),
    [anon_sym_where] = ACTIONS(13320),
    [anon_sym_quote] = ACTIONS(13320),
    [anon_sym_let] = ACTIONS(13320),
    [anon_sym_if] = ACTIONS(13320),
    [anon_sym_try] = ACTIONS(13320),
    [anon_sym_for] = ACTIONS(13320),
    [anon_sym_while] = ACTIONS(13320),
    [sym_break_statement] = ACTIONS(13320),
    [sym_continue_statement] = ACTIONS(13320),
    [anon_sym_return] = ACTIONS(13320),
    [anon_sym_const] = ACTIONS(13320),
    [anon_sym_global] = ACTIONS(13320),
    [anon_sym_local] = ACTIONS(13320),
    [anon_sym_LPAREN] = ACTIONS(13320),
    [anon_sym_RPAREN] = ACTIONS(13320),
    [anon_sym_COLON2] = ACTIONS(13320),
    [anon_sym_export] = ACTIONS(13320),
    [anon_sym_import] = ACTIONS(13320),
    [anon_sym_using] = ACTIONS(13320),
    [anon_sym_LBRACK] = ACTIONS(13320),
    [anon_sym_RBRACK] = ACTIONS(13320),
    [anon_sym_LF] = ACTIONS(13322),
    [anon_sym_in] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(13320),
    [anon_sym_DOLLAR] = ACTIONS(13320),
    [anon_sym_COLON_COLON] = ACTIONS(13320),
    [anon_sym_isa] = ACTIONS(13320),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13320),
    [anon_sym_QMARK] = ACTIONS(13320),
    [anon_sym_AT] = ACTIONS(13320),
    [anon_sym_true] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(13320),
    [aux_sym_integer_literal_token1] = ACTIONS(13320),
    [aux_sym_integer_literal_token2] = ACTIONS(13320),
    [aux_sym_integer_literal_token3] = ACTIONS(13320),
    [aux_sym_integer_literal_token4] = ACTIONS(13320),
    [aux_sym_float_literal_token1] = ACTIONS(13320),
    [aux_sym_float_literal_token3] = ACTIONS(13320),
    [aux_sym_float_literal_token4] = ACTIONS(13320),
    [sym_character_literal] = ACTIONS(13320),
    [sym__pair_operator] = ACTIONS(13320),
    [sym__arrow_operator] = ACTIONS(13320),
    [sym__lazy_or_operator] = ACTIONS(13320),
    [sym__lazy_and_operator] = ACTIONS(13320),
    [sym__comparison_operator] = ACTIONS(13320),
    [sym__pipe_right_operator] = ACTIONS(13320),
    [sym__pipe_left_operator] = ACTIONS(13320),
    [sym__ellipsis_operator] = ACTIONS(13320),
    [sym__plus_operator] = ACTIONS(13320),
    [sym__times_operator] = ACTIONS(13320),
    [sym__rational_operator] = ACTIONS(13320),
    [sym__bitshift_operator] = ACTIONS(13320),
    [sym__power_operator] = ACTIONS(13320),
    [sym__tilde_operator] = ACTIONS(13320),
    [sym__type_order_operator] = ACTIONS(13320),
    [sym__unary_operator] = ACTIONS(13320),
    [sym__unary_plus_operator] = ACTIONS(13320),
    [aux_sym__terminator_token1] = ACTIONS(13320),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13322),
    [sym__command_start] = ACTIONS(13322),
  },
  [7725] = {
    [ts_builtin_sym_end] = ACTIONS(13241),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_RPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_RBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7726] = {
    [sym__comprehension_clause] = STATE(18517),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17329),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13966),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13968),
    [anon_sym_LF] = ACTIONS(13970),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13973),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7727] = {
    [ts_builtin_sym_end] = ACTIONS(13241),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(12418),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_RPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_RBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7728] = {
    [aux_sym_open_tuple_repeat1] = STATE(7068),
    [ts_builtin_sym_end] = ACTIONS(13241),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_RPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_RBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [7729] = {
    [ts_builtin_sym_end] = ACTIONS(13328),
    [sym__word_identifier] = ACTIONS(13326),
    [anon_sym_EQ] = ACTIONS(13326),
    [anon_sym_COMMA] = ACTIONS(13326),
    [anon_sym_COLON] = ACTIONS(13326),
    [anon_sym_begin] = ACTIONS(13326),
    [anon_sym_module] = ACTIONS(13326),
    [anon_sym_baremodule] = ACTIONS(13326),
    [anon_sym_abstract] = ACTIONS(13326),
    [anon_sym_primitive] = ACTIONS(13326),
    [anon_sym_mutable] = ACTIONS(13326),
    [anon_sym_struct] = ACTIONS(13326),
    [anon_sym_function] = ACTIONS(13326),
    [anon_sym_macro] = ACTIONS(13326),
    [anon_sym_where] = ACTIONS(13326),
    [anon_sym_quote] = ACTIONS(13326),
    [anon_sym_let] = ACTIONS(13326),
    [anon_sym_if] = ACTIONS(13326),
    [anon_sym_try] = ACTIONS(13326),
    [anon_sym_for] = ACTIONS(13326),
    [anon_sym_while] = ACTIONS(13326),
    [sym_break_statement] = ACTIONS(13326),
    [sym_continue_statement] = ACTIONS(13326),
    [anon_sym_return] = ACTIONS(13326),
    [anon_sym_const] = ACTIONS(13326),
    [anon_sym_global] = ACTIONS(13326),
    [anon_sym_local] = ACTIONS(13326),
    [anon_sym_LPAREN] = ACTIONS(13326),
    [anon_sym_RPAREN] = ACTIONS(13326),
    [anon_sym_COLON2] = ACTIONS(13326),
    [anon_sym_export] = ACTIONS(13326),
    [anon_sym_import] = ACTIONS(13326),
    [anon_sym_using] = ACTIONS(13326),
    [anon_sym_LBRACK] = ACTIONS(13326),
    [anon_sym_RBRACK] = ACTIONS(13326),
    [anon_sym_LF] = ACTIONS(13328),
    [anon_sym_in] = ACTIONS(13326),
    [anon_sym_LBRACE] = ACTIONS(13326),
    [anon_sym_DOLLAR] = ACTIONS(13326),
    [anon_sym_COLON_COLON] = ACTIONS(13326),
    [anon_sym_isa] = ACTIONS(13326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13326),
    [anon_sym_QMARK] = ACTIONS(13326),
    [anon_sym_AT] = ACTIONS(13326),
    [anon_sym_true] = ACTIONS(13326),
    [anon_sym_false] = ACTIONS(13326),
    [aux_sym_integer_literal_token1] = ACTIONS(13326),
    [aux_sym_integer_literal_token2] = ACTIONS(13326),
    [aux_sym_integer_literal_token3] = ACTIONS(13326),
    [aux_sym_integer_literal_token4] = ACTIONS(13326),
    [aux_sym_float_literal_token1] = ACTIONS(13326),
    [aux_sym_float_literal_token3] = ACTIONS(13326),
    [aux_sym_float_literal_token4] = ACTIONS(13326),
    [sym_character_literal] = ACTIONS(13326),
    [sym__pair_operator] = ACTIONS(13326),
    [sym__arrow_operator] = ACTIONS(13326),
    [sym__lazy_or_operator] = ACTIONS(13326),
    [sym__lazy_and_operator] = ACTIONS(13326),
    [sym__comparison_operator] = ACTIONS(13326),
    [sym__pipe_right_operator] = ACTIONS(13326),
    [sym__pipe_left_operator] = ACTIONS(13326),
    [sym__ellipsis_operator] = ACTIONS(13326),
    [sym__plus_operator] = ACTIONS(13326),
    [sym__times_operator] = ACTIONS(13326),
    [sym__rational_operator] = ACTIONS(13326),
    [sym__bitshift_operator] = ACTIONS(13326),
    [sym__power_operator] = ACTIONS(13326),
    [sym__tilde_operator] = ACTIONS(13326),
    [sym__type_order_operator] = ACTIONS(13326),
    [sym__unary_operator] = ACTIONS(13326),
    [sym__unary_plus_operator] = ACTIONS(13326),
    [aux_sym__terminator_token1] = ACTIONS(13326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13328),
    [sym__command_start] = ACTIONS(13328),
  },
  [7730] = {
    [ts_builtin_sym_end] = ACTIONS(13245),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_RPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_RBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7731] = {
    [ts_builtin_sym_end] = ACTIONS(13245),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(12418),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_RPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_RBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7732] = {
    [aux_sym_open_tuple_repeat1] = STATE(7068),
    [ts_builtin_sym_end] = ACTIONS(13245),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_RPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_RBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [7733] = {
    [ts_builtin_sym_end] = ACTIONS(12934),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_RPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_RBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7734] = {
    [ts_builtin_sym_end] = ACTIONS(12934),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12418),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_RPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_RBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7735] = {
    [aux_sym_open_tuple_repeat1] = STATE(7068),
    [ts_builtin_sym_end] = ACTIONS(12934),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_RPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_RBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [7736] = {
    [sym__comprehension_clause] = STATE(18965),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17184),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13976),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13978),
    [anon_sym_LF] = ACTIONS(13980),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13983),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7737] = {
    [ts_builtin_sym_end] = ACTIONS(13332),
    [sym__word_identifier] = ACTIONS(13330),
    [anon_sym_EQ] = ACTIONS(13330),
    [anon_sym_COMMA] = ACTIONS(13330),
    [anon_sym_COLON] = ACTIONS(13330),
    [anon_sym_begin] = ACTIONS(13330),
    [anon_sym_module] = ACTIONS(13330),
    [anon_sym_baremodule] = ACTIONS(13330),
    [anon_sym_abstract] = ACTIONS(13330),
    [anon_sym_primitive] = ACTIONS(13330),
    [anon_sym_mutable] = ACTIONS(13330),
    [anon_sym_struct] = ACTIONS(13330),
    [anon_sym_function] = ACTIONS(13330),
    [anon_sym_macro] = ACTIONS(13330),
    [anon_sym_where] = ACTIONS(13330),
    [anon_sym_quote] = ACTIONS(13330),
    [anon_sym_let] = ACTIONS(13330),
    [anon_sym_if] = ACTIONS(13330),
    [anon_sym_try] = ACTIONS(13330),
    [anon_sym_for] = ACTIONS(13330),
    [anon_sym_while] = ACTIONS(13330),
    [sym_break_statement] = ACTIONS(13330),
    [sym_continue_statement] = ACTIONS(13330),
    [anon_sym_return] = ACTIONS(13330),
    [anon_sym_const] = ACTIONS(13330),
    [anon_sym_global] = ACTIONS(13330),
    [anon_sym_local] = ACTIONS(13330),
    [anon_sym_LPAREN] = ACTIONS(13330),
    [anon_sym_RPAREN] = ACTIONS(13330),
    [anon_sym_COLON2] = ACTIONS(13330),
    [anon_sym_export] = ACTIONS(13330),
    [anon_sym_import] = ACTIONS(13330),
    [anon_sym_using] = ACTIONS(13330),
    [anon_sym_LBRACK] = ACTIONS(13330),
    [anon_sym_RBRACK] = ACTIONS(13330),
    [anon_sym_LF] = ACTIONS(13332),
    [anon_sym_in] = ACTIONS(13330),
    [anon_sym_LBRACE] = ACTIONS(13330),
    [anon_sym_DOLLAR] = ACTIONS(13330),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_isa] = ACTIONS(13330),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13330),
    [anon_sym_QMARK] = ACTIONS(13330),
    [anon_sym_AT] = ACTIONS(13330),
    [anon_sym_true] = ACTIONS(13330),
    [anon_sym_false] = ACTIONS(13330),
    [aux_sym_integer_literal_token1] = ACTIONS(13330),
    [aux_sym_integer_literal_token2] = ACTIONS(13330),
    [aux_sym_integer_literal_token3] = ACTIONS(13330),
    [aux_sym_integer_literal_token4] = ACTIONS(13330),
    [aux_sym_float_literal_token1] = ACTIONS(13330),
    [aux_sym_float_literal_token3] = ACTIONS(13330),
    [aux_sym_float_literal_token4] = ACTIONS(13330),
    [sym_character_literal] = ACTIONS(13330),
    [sym__pair_operator] = ACTIONS(13330),
    [sym__arrow_operator] = ACTIONS(13330),
    [sym__lazy_or_operator] = ACTIONS(13330),
    [sym__lazy_and_operator] = ACTIONS(13330),
    [sym__comparison_operator] = ACTIONS(13330),
    [sym__pipe_right_operator] = ACTIONS(13330),
    [sym__pipe_left_operator] = ACTIONS(13330),
    [sym__ellipsis_operator] = ACTIONS(13330),
    [sym__plus_operator] = ACTIONS(13330),
    [sym__times_operator] = ACTIONS(13330),
    [sym__rational_operator] = ACTIONS(13330),
    [sym__bitshift_operator] = ACTIONS(13330),
    [sym__power_operator] = ACTIONS(13330),
    [sym__tilde_operator] = ACTIONS(13330),
    [sym__type_order_operator] = ACTIONS(13330),
    [sym__unary_operator] = ACTIONS(13330),
    [sym__unary_plus_operator] = ACTIONS(13330),
    [aux_sym__terminator_token1] = ACTIONS(13330),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13332),
    [sym__command_start] = ACTIONS(13332),
  },
  [7738] = {
    [ts_builtin_sym_end] = ACTIONS(13310),
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_RPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_RBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [7739] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7740] = {
    [sym__comprehension_clause] = STATE(19506),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16813),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13986),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13988),
    [anon_sym_LF] = ACTIONS(13990),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7741] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7742] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7743] = {
    [sym__comprehension_clause] = STATE(19454),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16798),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13996),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13998),
    [anon_sym_LF] = ACTIONS(14000),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14003),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7744] = {
    [ts_builtin_sym_end] = ACTIONS(13348),
    [sym__word_identifier] = ACTIONS(13346),
    [anon_sym_EQ] = ACTIONS(13346),
    [anon_sym_COMMA] = ACTIONS(13346),
    [anon_sym_COLON] = ACTIONS(13346),
    [anon_sym_begin] = ACTIONS(13346),
    [anon_sym_module] = ACTIONS(13346),
    [anon_sym_baremodule] = ACTIONS(13346),
    [anon_sym_abstract] = ACTIONS(13346),
    [anon_sym_primitive] = ACTIONS(13346),
    [anon_sym_mutable] = ACTIONS(13346),
    [anon_sym_struct] = ACTIONS(13346),
    [anon_sym_function] = ACTIONS(13346),
    [anon_sym_macro] = ACTIONS(13346),
    [anon_sym_where] = ACTIONS(13346),
    [anon_sym_quote] = ACTIONS(13346),
    [anon_sym_let] = ACTIONS(13346),
    [anon_sym_if] = ACTIONS(13346),
    [anon_sym_try] = ACTIONS(13346),
    [anon_sym_for] = ACTIONS(13346),
    [anon_sym_while] = ACTIONS(13346),
    [sym_break_statement] = ACTIONS(13346),
    [sym_continue_statement] = ACTIONS(13346),
    [anon_sym_return] = ACTIONS(13346),
    [anon_sym_const] = ACTIONS(13346),
    [anon_sym_global] = ACTIONS(13346),
    [anon_sym_local] = ACTIONS(13346),
    [anon_sym_LPAREN] = ACTIONS(13346),
    [anon_sym_RPAREN] = ACTIONS(13346),
    [anon_sym_COLON2] = ACTIONS(13346),
    [anon_sym_export] = ACTIONS(13346),
    [anon_sym_import] = ACTIONS(13346),
    [anon_sym_using] = ACTIONS(13346),
    [anon_sym_LBRACK] = ACTIONS(13346),
    [anon_sym_RBRACK] = ACTIONS(13346),
    [anon_sym_LF] = ACTIONS(13348),
    [anon_sym_in] = ACTIONS(13346),
    [anon_sym_LBRACE] = ACTIONS(13346),
    [anon_sym_DOLLAR] = ACTIONS(13346),
    [anon_sym_COLON_COLON] = ACTIONS(13346),
    [anon_sym_isa] = ACTIONS(13346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13346),
    [anon_sym_QMARK] = ACTIONS(13346),
    [anon_sym_AT] = ACTIONS(13346),
    [anon_sym_true] = ACTIONS(13346),
    [anon_sym_false] = ACTIONS(13346),
    [aux_sym_integer_literal_token1] = ACTIONS(13346),
    [aux_sym_integer_literal_token2] = ACTIONS(13346),
    [aux_sym_integer_literal_token3] = ACTIONS(13346),
    [aux_sym_integer_literal_token4] = ACTIONS(13346),
    [aux_sym_float_literal_token1] = ACTIONS(13346),
    [aux_sym_float_literal_token3] = ACTIONS(13346),
    [aux_sym_float_literal_token4] = ACTIONS(13346),
    [sym_character_literal] = ACTIONS(13346),
    [sym__pair_operator] = ACTIONS(13346),
    [sym__arrow_operator] = ACTIONS(13346),
    [sym__lazy_or_operator] = ACTIONS(13346),
    [sym__lazy_and_operator] = ACTIONS(13346),
    [sym__comparison_operator] = ACTIONS(13346),
    [sym__pipe_right_operator] = ACTIONS(13346),
    [sym__pipe_left_operator] = ACTIONS(13346),
    [sym__ellipsis_operator] = ACTIONS(13346),
    [sym__plus_operator] = ACTIONS(13346),
    [sym__times_operator] = ACTIONS(13346),
    [sym__rational_operator] = ACTIONS(13346),
    [sym__bitshift_operator] = ACTIONS(13346),
    [sym__power_operator] = ACTIONS(13346),
    [sym__tilde_operator] = ACTIONS(13346),
    [sym__type_order_operator] = ACTIONS(13346),
    [sym__unary_operator] = ACTIONS(13346),
    [sym__unary_plus_operator] = ACTIONS(13346),
    [aux_sym__terminator_token1] = ACTIONS(13346),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13348),
    [sym__command_start] = ACTIONS(13348),
  },
  [7745] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_catch] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [7746] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_catch] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [7747] = {
    [sym__comprehension_clause] = STATE(18937),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16748),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14006),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14008),
    [anon_sym_LF] = ACTIONS(14010),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14013),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7748] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_catch] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [7749] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(14016),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7750] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_catch] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [7751] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_catch] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [7752] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_catch] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [7753] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [7754] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [7755] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_catch] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [7756] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_catch] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [7757] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_catch] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [7758] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_catch] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [7759] = {
    [sym__comprehension_clause] = STATE(18583),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17161),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14018),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14020),
    [anon_sym_LF] = ACTIONS(14022),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14025),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7760] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_catch] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [7761] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [7762] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_catch] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [7763] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_catch] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [7764] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_catch] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [7765] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_catch] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [7766] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_catch] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [7767] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_catch] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [7768] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_catch] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [7769] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_catch] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [7770] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_catch] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [7771] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_catch] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [7772] = {
    [sym__comprehension_clause] = STATE(19224),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16987),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14028),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14030),
    [anon_sym_LF] = ACTIONS(14032),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14035),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7773] = {
    [ts_builtin_sym_end] = ACTIONS(13360),
    [sym__word_identifier] = ACTIONS(13358),
    [anon_sym_EQ] = ACTIONS(13358),
    [anon_sym_COMMA] = ACTIONS(13358),
    [anon_sym_COLON] = ACTIONS(13358),
    [anon_sym_begin] = ACTIONS(13358),
    [anon_sym_module] = ACTIONS(13358),
    [anon_sym_baremodule] = ACTIONS(13358),
    [anon_sym_abstract] = ACTIONS(13358),
    [anon_sym_primitive] = ACTIONS(13358),
    [anon_sym_mutable] = ACTIONS(13358),
    [anon_sym_struct] = ACTIONS(13358),
    [anon_sym_function] = ACTIONS(13358),
    [anon_sym_macro] = ACTIONS(13358),
    [anon_sym_where] = ACTIONS(13358),
    [anon_sym_quote] = ACTIONS(13358),
    [anon_sym_let] = ACTIONS(13358),
    [anon_sym_if] = ACTIONS(13358),
    [anon_sym_try] = ACTIONS(13358),
    [anon_sym_for] = ACTIONS(13358),
    [anon_sym_while] = ACTIONS(13358),
    [sym_break_statement] = ACTIONS(13358),
    [sym_continue_statement] = ACTIONS(13358),
    [anon_sym_return] = ACTIONS(13358),
    [anon_sym_const] = ACTIONS(13358),
    [anon_sym_global] = ACTIONS(13358),
    [anon_sym_local] = ACTIONS(13358),
    [anon_sym_LPAREN] = ACTIONS(13358),
    [anon_sym_RPAREN] = ACTIONS(13358),
    [anon_sym_COLON2] = ACTIONS(13358),
    [anon_sym_export] = ACTIONS(13358),
    [anon_sym_import] = ACTIONS(13358),
    [anon_sym_using] = ACTIONS(13358),
    [anon_sym_LBRACK] = ACTIONS(13358),
    [anon_sym_RBRACK] = ACTIONS(13358),
    [anon_sym_LF] = ACTIONS(13360),
    [anon_sym_in] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(13358),
    [anon_sym_DOLLAR] = ACTIONS(13358),
    [anon_sym_COLON_COLON] = ACTIONS(13358),
    [anon_sym_isa] = ACTIONS(13358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13358),
    [anon_sym_QMARK] = ACTIONS(13358),
    [anon_sym_AT] = ACTIONS(13358),
    [anon_sym_true] = ACTIONS(13358),
    [anon_sym_false] = ACTIONS(13358),
    [aux_sym_integer_literal_token1] = ACTIONS(13358),
    [aux_sym_integer_literal_token2] = ACTIONS(13358),
    [aux_sym_integer_literal_token3] = ACTIONS(13358),
    [aux_sym_integer_literal_token4] = ACTIONS(13358),
    [aux_sym_float_literal_token1] = ACTIONS(13358),
    [aux_sym_float_literal_token3] = ACTIONS(13358),
    [aux_sym_float_literal_token4] = ACTIONS(13358),
    [sym_character_literal] = ACTIONS(13358),
    [sym__pair_operator] = ACTIONS(13358),
    [sym__arrow_operator] = ACTIONS(13358),
    [sym__lazy_or_operator] = ACTIONS(13358),
    [sym__lazy_and_operator] = ACTIONS(13358),
    [sym__comparison_operator] = ACTIONS(13358),
    [sym__pipe_right_operator] = ACTIONS(13358),
    [sym__pipe_left_operator] = ACTIONS(13358),
    [sym__ellipsis_operator] = ACTIONS(13358),
    [sym__plus_operator] = ACTIONS(13358),
    [sym__times_operator] = ACTIONS(13358),
    [sym__rational_operator] = ACTIONS(13358),
    [sym__bitshift_operator] = ACTIONS(13358),
    [sym__power_operator] = ACTIONS(13358),
    [sym__tilde_operator] = ACTIONS(13358),
    [sym__type_order_operator] = ACTIONS(13358),
    [sym__unary_operator] = ACTIONS(13358),
    [sym__unary_plus_operator] = ACTIONS(13358),
    [aux_sym__terminator_token1] = ACTIONS(13358),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13360),
    [sym__command_start] = ACTIONS(13360),
  },
  [7774] = {
    [ts_builtin_sym_end] = ACTIONS(13364),
    [sym__word_identifier] = ACTIONS(13362),
    [anon_sym_EQ] = ACTIONS(13362),
    [anon_sym_COMMA] = ACTIONS(13362),
    [anon_sym_COLON] = ACTIONS(13362),
    [anon_sym_begin] = ACTIONS(13362),
    [anon_sym_module] = ACTIONS(13362),
    [anon_sym_baremodule] = ACTIONS(13362),
    [anon_sym_abstract] = ACTIONS(13362),
    [anon_sym_primitive] = ACTIONS(13362),
    [anon_sym_mutable] = ACTIONS(13362),
    [anon_sym_struct] = ACTIONS(13362),
    [anon_sym_function] = ACTIONS(13362),
    [anon_sym_macro] = ACTIONS(13362),
    [anon_sym_where] = ACTIONS(13362),
    [anon_sym_quote] = ACTIONS(13362),
    [anon_sym_let] = ACTIONS(13362),
    [anon_sym_if] = ACTIONS(13362),
    [anon_sym_try] = ACTIONS(13362),
    [anon_sym_for] = ACTIONS(13362),
    [anon_sym_while] = ACTIONS(13362),
    [sym_break_statement] = ACTIONS(13362),
    [sym_continue_statement] = ACTIONS(13362),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_const] = ACTIONS(13362),
    [anon_sym_global] = ACTIONS(13362),
    [anon_sym_local] = ACTIONS(13362),
    [anon_sym_LPAREN] = ACTIONS(13362),
    [anon_sym_RPAREN] = ACTIONS(13362),
    [anon_sym_COLON2] = ACTIONS(13362),
    [anon_sym_export] = ACTIONS(13362),
    [anon_sym_import] = ACTIONS(13362),
    [anon_sym_using] = ACTIONS(13362),
    [anon_sym_LBRACK] = ACTIONS(13362),
    [anon_sym_RBRACK] = ACTIONS(13362),
    [anon_sym_LF] = ACTIONS(13364),
    [anon_sym_in] = ACTIONS(13362),
    [anon_sym_LBRACE] = ACTIONS(13362),
    [anon_sym_DOLLAR] = ACTIONS(13362),
    [anon_sym_COLON_COLON] = ACTIONS(13362),
    [anon_sym_isa] = ACTIONS(13362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13362),
    [anon_sym_QMARK] = ACTIONS(13362),
    [anon_sym_AT] = ACTIONS(13362),
    [anon_sym_true] = ACTIONS(13362),
    [anon_sym_false] = ACTIONS(13362),
    [aux_sym_integer_literal_token1] = ACTIONS(13362),
    [aux_sym_integer_literal_token2] = ACTIONS(13362),
    [aux_sym_integer_literal_token3] = ACTIONS(13362),
    [aux_sym_integer_literal_token4] = ACTIONS(13362),
    [aux_sym_float_literal_token1] = ACTIONS(13362),
    [aux_sym_float_literal_token3] = ACTIONS(13362),
    [aux_sym_float_literal_token4] = ACTIONS(13362),
    [sym_character_literal] = ACTIONS(13362),
    [sym__pair_operator] = ACTIONS(13362),
    [sym__arrow_operator] = ACTIONS(13362),
    [sym__lazy_or_operator] = ACTIONS(13362),
    [sym__lazy_and_operator] = ACTIONS(13362),
    [sym__comparison_operator] = ACTIONS(13362),
    [sym__pipe_right_operator] = ACTIONS(13362),
    [sym__pipe_left_operator] = ACTIONS(13362),
    [sym__ellipsis_operator] = ACTIONS(13362),
    [sym__plus_operator] = ACTIONS(13362),
    [sym__times_operator] = ACTIONS(13362),
    [sym__rational_operator] = ACTIONS(13362),
    [sym__bitshift_operator] = ACTIONS(13362),
    [sym__power_operator] = ACTIONS(13362),
    [sym__tilde_operator] = ACTIONS(13362),
    [sym__type_order_operator] = ACTIONS(13362),
    [sym__unary_operator] = ACTIONS(13362),
    [sym__unary_plus_operator] = ACTIONS(13362),
    [aux_sym__terminator_token1] = ACTIONS(13362),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13364),
    [sym__command_start] = ACTIONS(13364),
  },
  [7775] = {
    [ts_builtin_sym_end] = ACTIONS(13368),
    [sym__word_identifier] = ACTIONS(13366),
    [anon_sym_EQ] = ACTIONS(13366),
    [anon_sym_COMMA] = ACTIONS(13366),
    [anon_sym_COLON] = ACTIONS(13366),
    [anon_sym_begin] = ACTIONS(13366),
    [anon_sym_module] = ACTIONS(13366),
    [anon_sym_baremodule] = ACTIONS(13366),
    [anon_sym_abstract] = ACTIONS(13366),
    [anon_sym_primitive] = ACTIONS(13366),
    [anon_sym_mutable] = ACTIONS(13366),
    [anon_sym_struct] = ACTIONS(13366),
    [anon_sym_function] = ACTIONS(13366),
    [anon_sym_macro] = ACTIONS(13366),
    [anon_sym_where] = ACTIONS(13366),
    [anon_sym_quote] = ACTIONS(13366),
    [anon_sym_let] = ACTIONS(13366),
    [anon_sym_if] = ACTIONS(13366),
    [anon_sym_try] = ACTIONS(13366),
    [anon_sym_for] = ACTIONS(13366),
    [anon_sym_while] = ACTIONS(13366),
    [sym_break_statement] = ACTIONS(13366),
    [sym_continue_statement] = ACTIONS(13366),
    [anon_sym_return] = ACTIONS(13366),
    [anon_sym_const] = ACTIONS(13366),
    [anon_sym_global] = ACTIONS(13366),
    [anon_sym_local] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(13366),
    [anon_sym_RPAREN] = ACTIONS(13366),
    [anon_sym_COLON2] = ACTIONS(13366),
    [anon_sym_export] = ACTIONS(13366),
    [anon_sym_import] = ACTIONS(13366),
    [anon_sym_using] = ACTIONS(13366),
    [anon_sym_LBRACK] = ACTIONS(13366),
    [anon_sym_RBRACK] = ACTIONS(13366),
    [anon_sym_LF] = ACTIONS(13368),
    [anon_sym_in] = ACTIONS(13366),
    [anon_sym_LBRACE] = ACTIONS(13366),
    [anon_sym_DOLLAR] = ACTIONS(13366),
    [anon_sym_COLON_COLON] = ACTIONS(13366),
    [anon_sym_isa] = ACTIONS(13366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13366),
    [anon_sym_QMARK] = ACTIONS(13366),
    [anon_sym_AT] = ACTIONS(13366),
    [anon_sym_true] = ACTIONS(13366),
    [anon_sym_false] = ACTIONS(13366),
    [aux_sym_integer_literal_token1] = ACTIONS(13366),
    [aux_sym_integer_literal_token2] = ACTIONS(13366),
    [aux_sym_integer_literal_token3] = ACTIONS(13366),
    [aux_sym_integer_literal_token4] = ACTIONS(13366),
    [aux_sym_float_literal_token1] = ACTIONS(13366),
    [aux_sym_float_literal_token3] = ACTIONS(13366),
    [aux_sym_float_literal_token4] = ACTIONS(13366),
    [sym_character_literal] = ACTIONS(13366),
    [sym__pair_operator] = ACTIONS(13366),
    [sym__arrow_operator] = ACTIONS(13366),
    [sym__lazy_or_operator] = ACTIONS(13366),
    [sym__lazy_and_operator] = ACTIONS(13366),
    [sym__comparison_operator] = ACTIONS(13366),
    [sym__pipe_right_operator] = ACTIONS(13366),
    [sym__pipe_left_operator] = ACTIONS(13366),
    [sym__ellipsis_operator] = ACTIONS(13366),
    [sym__plus_operator] = ACTIONS(13366),
    [sym__times_operator] = ACTIONS(13366),
    [sym__rational_operator] = ACTIONS(13366),
    [sym__bitshift_operator] = ACTIONS(13366),
    [sym__power_operator] = ACTIONS(13366),
    [sym__tilde_operator] = ACTIONS(13366),
    [sym__type_order_operator] = ACTIONS(13366),
    [sym__unary_operator] = ACTIONS(13366),
    [sym__unary_plus_operator] = ACTIONS(13366),
    [aux_sym__terminator_token1] = ACTIONS(13366),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13368),
    [sym__command_start] = ACTIONS(13368),
  },
  [7776] = {
    [ts_builtin_sym_end] = ACTIONS(13372),
    [sym__word_identifier] = ACTIONS(13370),
    [anon_sym_EQ] = ACTIONS(13370),
    [anon_sym_COMMA] = ACTIONS(13370),
    [anon_sym_COLON] = ACTIONS(13370),
    [anon_sym_begin] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(13370),
    [anon_sym_baremodule] = ACTIONS(13370),
    [anon_sym_abstract] = ACTIONS(13370),
    [anon_sym_primitive] = ACTIONS(13370),
    [anon_sym_mutable] = ACTIONS(13370),
    [anon_sym_struct] = ACTIONS(13370),
    [anon_sym_function] = ACTIONS(13370),
    [anon_sym_macro] = ACTIONS(13370),
    [anon_sym_where] = ACTIONS(13370),
    [anon_sym_quote] = ACTIONS(13370),
    [anon_sym_let] = ACTIONS(13370),
    [anon_sym_if] = ACTIONS(13370),
    [anon_sym_try] = ACTIONS(13370),
    [anon_sym_for] = ACTIONS(13370),
    [anon_sym_while] = ACTIONS(13370),
    [sym_break_statement] = ACTIONS(13370),
    [sym_continue_statement] = ACTIONS(13370),
    [anon_sym_return] = ACTIONS(13370),
    [anon_sym_const] = ACTIONS(13370),
    [anon_sym_global] = ACTIONS(13370),
    [anon_sym_local] = ACTIONS(13370),
    [anon_sym_LPAREN] = ACTIONS(13370),
    [anon_sym_RPAREN] = ACTIONS(13370),
    [anon_sym_COLON2] = ACTIONS(13370),
    [anon_sym_export] = ACTIONS(13370),
    [anon_sym_import] = ACTIONS(13370),
    [anon_sym_using] = ACTIONS(13370),
    [anon_sym_LBRACK] = ACTIONS(13370),
    [anon_sym_RBRACK] = ACTIONS(13370),
    [anon_sym_LF] = ACTIONS(13372),
    [anon_sym_in] = ACTIONS(13370),
    [anon_sym_LBRACE] = ACTIONS(13370),
    [anon_sym_DOLLAR] = ACTIONS(13370),
    [anon_sym_COLON_COLON] = ACTIONS(13370),
    [anon_sym_isa] = ACTIONS(13370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13370),
    [anon_sym_QMARK] = ACTIONS(13370),
    [anon_sym_AT] = ACTIONS(13370),
    [anon_sym_true] = ACTIONS(13370),
    [anon_sym_false] = ACTIONS(13370),
    [aux_sym_integer_literal_token1] = ACTIONS(13370),
    [aux_sym_integer_literal_token2] = ACTIONS(13370),
    [aux_sym_integer_literal_token3] = ACTIONS(13370),
    [aux_sym_integer_literal_token4] = ACTIONS(13370),
    [aux_sym_float_literal_token1] = ACTIONS(13370),
    [aux_sym_float_literal_token3] = ACTIONS(13370),
    [aux_sym_float_literal_token4] = ACTIONS(13370),
    [sym_character_literal] = ACTIONS(13370),
    [sym__pair_operator] = ACTIONS(13370),
    [sym__arrow_operator] = ACTIONS(13370),
    [sym__lazy_or_operator] = ACTIONS(13370),
    [sym__lazy_and_operator] = ACTIONS(13370),
    [sym__comparison_operator] = ACTIONS(13370),
    [sym__pipe_right_operator] = ACTIONS(13370),
    [sym__pipe_left_operator] = ACTIONS(13370),
    [sym__ellipsis_operator] = ACTIONS(13370),
    [sym__plus_operator] = ACTIONS(13370),
    [sym__times_operator] = ACTIONS(13370),
    [sym__rational_operator] = ACTIONS(13370),
    [sym__bitshift_operator] = ACTIONS(13370),
    [sym__power_operator] = ACTIONS(13370),
    [sym__tilde_operator] = ACTIONS(13370),
    [sym__type_order_operator] = ACTIONS(13370),
    [sym__unary_operator] = ACTIONS(13370),
    [sym__unary_plus_operator] = ACTIONS(13370),
    [aux_sym__terminator_token1] = ACTIONS(13370),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13372),
    [sym__command_start] = ACTIONS(13372),
  },
  [7777] = {
    [ts_builtin_sym_end] = ACTIONS(13376),
    [sym__word_identifier] = ACTIONS(13374),
    [anon_sym_EQ] = ACTIONS(13374),
    [anon_sym_COMMA] = ACTIONS(13374),
    [anon_sym_COLON] = ACTIONS(13374),
    [anon_sym_begin] = ACTIONS(13374),
    [anon_sym_module] = ACTIONS(13374),
    [anon_sym_baremodule] = ACTIONS(13374),
    [anon_sym_abstract] = ACTIONS(13374),
    [anon_sym_primitive] = ACTIONS(13374),
    [anon_sym_mutable] = ACTIONS(13374),
    [anon_sym_struct] = ACTIONS(13374),
    [anon_sym_function] = ACTIONS(13374),
    [anon_sym_macro] = ACTIONS(13374),
    [anon_sym_where] = ACTIONS(13374),
    [anon_sym_quote] = ACTIONS(13374),
    [anon_sym_let] = ACTIONS(13374),
    [anon_sym_if] = ACTIONS(13374),
    [anon_sym_try] = ACTIONS(13374),
    [anon_sym_for] = ACTIONS(13374),
    [anon_sym_while] = ACTIONS(13374),
    [sym_break_statement] = ACTIONS(13374),
    [sym_continue_statement] = ACTIONS(13374),
    [anon_sym_return] = ACTIONS(13374),
    [anon_sym_const] = ACTIONS(13374),
    [anon_sym_global] = ACTIONS(13374),
    [anon_sym_local] = ACTIONS(13374),
    [anon_sym_LPAREN] = ACTIONS(13374),
    [anon_sym_RPAREN] = ACTIONS(13374),
    [anon_sym_COLON2] = ACTIONS(13374),
    [anon_sym_export] = ACTIONS(13374),
    [anon_sym_import] = ACTIONS(13374),
    [anon_sym_using] = ACTIONS(13374),
    [anon_sym_LBRACK] = ACTIONS(13374),
    [anon_sym_RBRACK] = ACTIONS(13374),
    [anon_sym_LF] = ACTIONS(13376),
    [anon_sym_in] = ACTIONS(13374),
    [anon_sym_LBRACE] = ACTIONS(13374),
    [anon_sym_DOLLAR] = ACTIONS(13374),
    [anon_sym_COLON_COLON] = ACTIONS(13374),
    [anon_sym_isa] = ACTIONS(13374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13374),
    [anon_sym_QMARK] = ACTIONS(13374),
    [anon_sym_AT] = ACTIONS(13374),
    [anon_sym_true] = ACTIONS(13374),
    [anon_sym_false] = ACTIONS(13374),
    [aux_sym_integer_literal_token1] = ACTIONS(13374),
    [aux_sym_integer_literal_token2] = ACTIONS(13374),
    [aux_sym_integer_literal_token3] = ACTIONS(13374),
    [aux_sym_integer_literal_token4] = ACTIONS(13374),
    [aux_sym_float_literal_token1] = ACTIONS(13374),
    [aux_sym_float_literal_token3] = ACTIONS(13374),
    [aux_sym_float_literal_token4] = ACTIONS(13374),
    [sym_character_literal] = ACTIONS(13374),
    [sym__pair_operator] = ACTIONS(13374),
    [sym__arrow_operator] = ACTIONS(13374),
    [sym__lazy_or_operator] = ACTIONS(13374),
    [sym__lazy_and_operator] = ACTIONS(13374),
    [sym__comparison_operator] = ACTIONS(13374),
    [sym__pipe_right_operator] = ACTIONS(13374),
    [sym__pipe_left_operator] = ACTIONS(13374),
    [sym__ellipsis_operator] = ACTIONS(13374),
    [sym__plus_operator] = ACTIONS(13374),
    [sym__times_operator] = ACTIONS(13374),
    [sym__rational_operator] = ACTIONS(13374),
    [sym__bitshift_operator] = ACTIONS(13374),
    [sym__power_operator] = ACTIONS(13374),
    [sym__tilde_operator] = ACTIONS(13374),
    [sym__type_order_operator] = ACTIONS(13374),
    [sym__unary_operator] = ACTIONS(13374),
    [sym__unary_plus_operator] = ACTIONS(13374),
    [aux_sym__terminator_token1] = ACTIONS(13374),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13376),
    [sym__command_start] = ACTIONS(13376),
  },
  [7778] = {
    [sym__comprehension_clause] = STATE(18200),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16927),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14038),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14040),
    [anon_sym_LF] = ACTIONS(14042),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14045),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7779] = {
    [ts_builtin_sym_end] = ACTIONS(13380),
    [sym__word_identifier] = ACTIONS(13378),
    [anon_sym_EQ] = ACTIONS(13378),
    [anon_sym_COMMA] = ACTIONS(13378),
    [anon_sym_COLON] = ACTIONS(13378),
    [anon_sym_begin] = ACTIONS(13378),
    [anon_sym_module] = ACTIONS(13378),
    [anon_sym_baremodule] = ACTIONS(13378),
    [anon_sym_abstract] = ACTIONS(13378),
    [anon_sym_primitive] = ACTIONS(13378),
    [anon_sym_mutable] = ACTIONS(13378),
    [anon_sym_struct] = ACTIONS(13378),
    [anon_sym_function] = ACTIONS(13378),
    [anon_sym_macro] = ACTIONS(13378),
    [anon_sym_where] = ACTIONS(13378),
    [anon_sym_quote] = ACTIONS(13378),
    [anon_sym_let] = ACTIONS(13378),
    [anon_sym_if] = ACTIONS(13378),
    [anon_sym_try] = ACTIONS(13378),
    [anon_sym_for] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(13378),
    [sym_break_statement] = ACTIONS(13378),
    [sym_continue_statement] = ACTIONS(13378),
    [anon_sym_return] = ACTIONS(13378),
    [anon_sym_const] = ACTIONS(13378),
    [anon_sym_global] = ACTIONS(13378),
    [anon_sym_local] = ACTIONS(13378),
    [anon_sym_LPAREN] = ACTIONS(13378),
    [anon_sym_RPAREN] = ACTIONS(13378),
    [anon_sym_COLON2] = ACTIONS(13378),
    [anon_sym_export] = ACTIONS(13378),
    [anon_sym_import] = ACTIONS(13378),
    [anon_sym_using] = ACTIONS(13378),
    [anon_sym_LBRACK] = ACTIONS(13378),
    [anon_sym_RBRACK] = ACTIONS(13378),
    [anon_sym_LF] = ACTIONS(13380),
    [anon_sym_in] = ACTIONS(13378),
    [anon_sym_LBRACE] = ACTIONS(13378),
    [anon_sym_DOLLAR] = ACTIONS(13378),
    [anon_sym_COLON_COLON] = ACTIONS(13378),
    [anon_sym_isa] = ACTIONS(13378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13378),
    [anon_sym_QMARK] = ACTIONS(13378),
    [anon_sym_AT] = ACTIONS(13378),
    [anon_sym_true] = ACTIONS(13378),
    [anon_sym_false] = ACTIONS(13378),
    [aux_sym_integer_literal_token1] = ACTIONS(13378),
    [aux_sym_integer_literal_token2] = ACTIONS(13378),
    [aux_sym_integer_literal_token3] = ACTIONS(13378),
    [aux_sym_integer_literal_token4] = ACTIONS(13378),
    [aux_sym_float_literal_token1] = ACTIONS(13378),
    [aux_sym_float_literal_token3] = ACTIONS(13378),
    [aux_sym_float_literal_token4] = ACTIONS(13378),
    [sym_character_literal] = ACTIONS(13378),
    [sym__pair_operator] = ACTIONS(13378),
    [sym__arrow_operator] = ACTIONS(13378),
    [sym__lazy_or_operator] = ACTIONS(13378),
    [sym__lazy_and_operator] = ACTIONS(13378),
    [sym__comparison_operator] = ACTIONS(13378),
    [sym__pipe_right_operator] = ACTIONS(13378),
    [sym__pipe_left_operator] = ACTIONS(13378),
    [sym__ellipsis_operator] = ACTIONS(13378),
    [sym__plus_operator] = ACTIONS(13378),
    [sym__times_operator] = ACTIONS(13378),
    [sym__rational_operator] = ACTIONS(13378),
    [sym__bitshift_operator] = ACTIONS(13378),
    [sym__power_operator] = ACTIONS(13378),
    [sym__tilde_operator] = ACTIONS(13378),
    [sym__type_order_operator] = ACTIONS(13378),
    [sym__unary_operator] = ACTIONS(13378),
    [sym__unary_plus_operator] = ACTIONS(13378),
    [aux_sym__terminator_token1] = ACTIONS(13378),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13380),
    [sym__command_start] = ACTIONS(13380),
  },
  [7780] = {
    [ts_builtin_sym_end] = ACTIONS(13384),
    [sym__word_identifier] = ACTIONS(13382),
    [anon_sym_EQ] = ACTIONS(13382),
    [anon_sym_COMMA] = ACTIONS(13382),
    [anon_sym_COLON] = ACTIONS(13382),
    [anon_sym_begin] = ACTIONS(13382),
    [anon_sym_module] = ACTIONS(13382),
    [anon_sym_baremodule] = ACTIONS(13382),
    [anon_sym_abstract] = ACTIONS(13382),
    [anon_sym_primitive] = ACTIONS(13382),
    [anon_sym_mutable] = ACTIONS(13382),
    [anon_sym_struct] = ACTIONS(13382),
    [anon_sym_function] = ACTIONS(13382),
    [anon_sym_macro] = ACTIONS(13382),
    [anon_sym_where] = ACTIONS(13382),
    [anon_sym_quote] = ACTIONS(13382),
    [anon_sym_let] = ACTIONS(13382),
    [anon_sym_if] = ACTIONS(13382),
    [anon_sym_try] = ACTIONS(13382),
    [anon_sym_for] = ACTIONS(13382),
    [anon_sym_while] = ACTIONS(13382),
    [sym_break_statement] = ACTIONS(13382),
    [sym_continue_statement] = ACTIONS(13382),
    [anon_sym_return] = ACTIONS(13382),
    [anon_sym_const] = ACTIONS(13382),
    [anon_sym_global] = ACTIONS(13382),
    [anon_sym_local] = ACTIONS(13382),
    [anon_sym_LPAREN] = ACTIONS(13382),
    [anon_sym_RPAREN] = ACTIONS(13382),
    [anon_sym_COLON2] = ACTIONS(13382),
    [anon_sym_export] = ACTIONS(13382),
    [anon_sym_import] = ACTIONS(13382),
    [anon_sym_using] = ACTIONS(13382),
    [anon_sym_LBRACK] = ACTIONS(13382),
    [anon_sym_RBRACK] = ACTIONS(13382),
    [anon_sym_LF] = ACTIONS(13384),
    [anon_sym_in] = ACTIONS(13382),
    [anon_sym_LBRACE] = ACTIONS(13382),
    [anon_sym_DOLLAR] = ACTIONS(13382),
    [anon_sym_COLON_COLON] = ACTIONS(13382),
    [anon_sym_isa] = ACTIONS(13382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13382),
    [anon_sym_QMARK] = ACTIONS(13382),
    [anon_sym_AT] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(13382),
    [anon_sym_false] = ACTIONS(13382),
    [aux_sym_integer_literal_token1] = ACTIONS(13382),
    [aux_sym_integer_literal_token2] = ACTIONS(13382),
    [aux_sym_integer_literal_token3] = ACTIONS(13382),
    [aux_sym_integer_literal_token4] = ACTIONS(13382),
    [aux_sym_float_literal_token1] = ACTIONS(13382),
    [aux_sym_float_literal_token3] = ACTIONS(13382),
    [aux_sym_float_literal_token4] = ACTIONS(13382),
    [sym_character_literal] = ACTIONS(13382),
    [sym__pair_operator] = ACTIONS(13382),
    [sym__arrow_operator] = ACTIONS(13382),
    [sym__lazy_or_operator] = ACTIONS(13382),
    [sym__lazy_and_operator] = ACTIONS(13382),
    [sym__comparison_operator] = ACTIONS(13382),
    [sym__pipe_right_operator] = ACTIONS(13382),
    [sym__pipe_left_operator] = ACTIONS(13382),
    [sym__ellipsis_operator] = ACTIONS(13382),
    [sym__plus_operator] = ACTIONS(13382),
    [sym__times_operator] = ACTIONS(13382),
    [sym__rational_operator] = ACTIONS(13382),
    [sym__bitshift_operator] = ACTIONS(13382),
    [sym__power_operator] = ACTIONS(13382),
    [sym__tilde_operator] = ACTIONS(13382),
    [sym__type_order_operator] = ACTIONS(13382),
    [sym__unary_operator] = ACTIONS(13382),
    [sym__unary_plus_operator] = ACTIONS(13382),
    [aux_sym__terminator_token1] = ACTIONS(13382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13384),
    [sym__command_start] = ACTIONS(13384),
  },
  [7781] = {
    [ts_builtin_sym_end] = ACTIONS(13388),
    [sym__word_identifier] = ACTIONS(13386),
    [anon_sym_EQ] = ACTIONS(13386),
    [anon_sym_COMMA] = ACTIONS(13386),
    [anon_sym_COLON] = ACTIONS(13386),
    [anon_sym_begin] = ACTIONS(13386),
    [anon_sym_module] = ACTIONS(13386),
    [anon_sym_baremodule] = ACTIONS(13386),
    [anon_sym_abstract] = ACTIONS(13386),
    [anon_sym_primitive] = ACTIONS(13386),
    [anon_sym_mutable] = ACTIONS(13386),
    [anon_sym_struct] = ACTIONS(13386),
    [anon_sym_function] = ACTIONS(13386),
    [anon_sym_macro] = ACTIONS(13386),
    [anon_sym_where] = ACTIONS(13386),
    [anon_sym_quote] = ACTIONS(13386),
    [anon_sym_let] = ACTIONS(13386),
    [anon_sym_if] = ACTIONS(13386),
    [anon_sym_try] = ACTIONS(13386),
    [anon_sym_for] = ACTIONS(13386),
    [anon_sym_while] = ACTIONS(13386),
    [sym_break_statement] = ACTIONS(13386),
    [sym_continue_statement] = ACTIONS(13386),
    [anon_sym_return] = ACTIONS(13386),
    [anon_sym_const] = ACTIONS(13386),
    [anon_sym_global] = ACTIONS(13386),
    [anon_sym_local] = ACTIONS(13386),
    [anon_sym_LPAREN] = ACTIONS(13386),
    [anon_sym_RPAREN] = ACTIONS(13386),
    [anon_sym_COLON2] = ACTIONS(13386),
    [anon_sym_export] = ACTIONS(13386),
    [anon_sym_import] = ACTIONS(13386),
    [anon_sym_using] = ACTIONS(13386),
    [anon_sym_LBRACK] = ACTIONS(13386),
    [anon_sym_RBRACK] = ACTIONS(13386),
    [anon_sym_LF] = ACTIONS(13388),
    [anon_sym_in] = ACTIONS(13386),
    [anon_sym_LBRACE] = ACTIONS(13386),
    [anon_sym_DOLLAR] = ACTIONS(13386),
    [anon_sym_COLON_COLON] = ACTIONS(13386),
    [anon_sym_isa] = ACTIONS(13386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13386),
    [anon_sym_QMARK] = ACTIONS(13386),
    [anon_sym_AT] = ACTIONS(13386),
    [anon_sym_true] = ACTIONS(13386),
    [anon_sym_false] = ACTIONS(13386),
    [aux_sym_integer_literal_token1] = ACTIONS(13386),
    [aux_sym_integer_literal_token2] = ACTIONS(13386),
    [aux_sym_integer_literal_token3] = ACTIONS(13386),
    [aux_sym_integer_literal_token4] = ACTIONS(13386),
    [aux_sym_float_literal_token1] = ACTIONS(13386),
    [aux_sym_float_literal_token3] = ACTIONS(13386),
    [aux_sym_float_literal_token4] = ACTIONS(13386),
    [sym_character_literal] = ACTIONS(13386),
    [sym__pair_operator] = ACTIONS(13386),
    [sym__arrow_operator] = ACTIONS(13386),
    [sym__lazy_or_operator] = ACTIONS(13386),
    [sym__lazy_and_operator] = ACTIONS(13386),
    [sym__comparison_operator] = ACTIONS(13386),
    [sym__pipe_right_operator] = ACTIONS(13386),
    [sym__pipe_left_operator] = ACTIONS(13386),
    [sym__ellipsis_operator] = ACTIONS(13386),
    [sym__plus_operator] = ACTIONS(13386),
    [sym__times_operator] = ACTIONS(13386),
    [sym__rational_operator] = ACTIONS(13386),
    [sym__bitshift_operator] = ACTIONS(13386),
    [sym__power_operator] = ACTIONS(13386),
    [sym__tilde_operator] = ACTIONS(13386),
    [sym__type_order_operator] = ACTIONS(13386),
    [sym__unary_operator] = ACTIONS(13386),
    [sym__unary_plus_operator] = ACTIONS(13386),
    [aux_sym__terminator_token1] = ACTIONS(13386),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13388),
    [sym__command_start] = ACTIONS(13388),
  },
  [7782] = {
    [ts_builtin_sym_end] = ACTIONS(13392),
    [sym__word_identifier] = ACTIONS(13390),
    [anon_sym_EQ] = ACTIONS(13390),
    [anon_sym_COMMA] = ACTIONS(13390),
    [anon_sym_COLON] = ACTIONS(13390),
    [anon_sym_begin] = ACTIONS(13390),
    [anon_sym_module] = ACTIONS(13390),
    [anon_sym_baremodule] = ACTIONS(13390),
    [anon_sym_abstract] = ACTIONS(13390),
    [anon_sym_primitive] = ACTIONS(13390),
    [anon_sym_mutable] = ACTIONS(13390),
    [anon_sym_struct] = ACTIONS(13390),
    [anon_sym_function] = ACTIONS(13390),
    [anon_sym_macro] = ACTIONS(13390),
    [anon_sym_where] = ACTIONS(13390),
    [anon_sym_quote] = ACTIONS(13390),
    [anon_sym_let] = ACTIONS(13390),
    [anon_sym_if] = ACTIONS(13390),
    [anon_sym_try] = ACTIONS(13390),
    [anon_sym_for] = ACTIONS(13390),
    [anon_sym_while] = ACTIONS(13390),
    [sym_break_statement] = ACTIONS(13390),
    [sym_continue_statement] = ACTIONS(13390),
    [anon_sym_return] = ACTIONS(13390),
    [anon_sym_const] = ACTIONS(13390),
    [anon_sym_global] = ACTIONS(13390),
    [anon_sym_local] = ACTIONS(13390),
    [anon_sym_LPAREN] = ACTIONS(13390),
    [anon_sym_RPAREN] = ACTIONS(13390),
    [anon_sym_COLON2] = ACTIONS(13390),
    [anon_sym_export] = ACTIONS(13390),
    [anon_sym_import] = ACTIONS(13390),
    [anon_sym_using] = ACTIONS(13390),
    [anon_sym_LBRACK] = ACTIONS(13390),
    [anon_sym_RBRACK] = ACTIONS(13390),
    [anon_sym_LF] = ACTIONS(13392),
    [anon_sym_in] = ACTIONS(13390),
    [anon_sym_LBRACE] = ACTIONS(13390),
    [anon_sym_DOLLAR] = ACTIONS(13390),
    [anon_sym_COLON_COLON] = ACTIONS(13390),
    [anon_sym_isa] = ACTIONS(13390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13390),
    [anon_sym_QMARK] = ACTIONS(13390),
    [anon_sym_AT] = ACTIONS(13390),
    [anon_sym_true] = ACTIONS(13390),
    [anon_sym_false] = ACTIONS(13390),
    [aux_sym_integer_literal_token1] = ACTIONS(13390),
    [aux_sym_integer_literal_token2] = ACTIONS(13390),
    [aux_sym_integer_literal_token3] = ACTIONS(13390),
    [aux_sym_integer_literal_token4] = ACTIONS(13390),
    [aux_sym_float_literal_token1] = ACTIONS(13390),
    [aux_sym_float_literal_token3] = ACTIONS(13390),
    [aux_sym_float_literal_token4] = ACTIONS(13390),
    [sym_character_literal] = ACTIONS(13390),
    [sym__pair_operator] = ACTIONS(13390),
    [sym__arrow_operator] = ACTIONS(13390),
    [sym__lazy_or_operator] = ACTIONS(13390),
    [sym__lazy_and_operator] = ACTIONS(13390),
    [sym__comparison_operator] = ACTIONS(13390),
    [sym__pipe_right_operator] = ACTIONS(13390),
    [sym__pipe_left_operator] = ACTIONS(13390),
    [sym__ellipsis_operator] = ACTIONS(13390),
    [sym__plus_operator] = ACTIONS(13390),
    [sym__times_operator] = ACTIONS(13390),
    [sym__rational_operator] = ACTIONS(13390),
    [sym__bitshift_operator] = ACTIONS(13390),
    [sym__power_operator] = ACTIONS(13390),
    [sym__tilde_operator] = ACTIONS(13390),
    [sym__type_order_operator] = ACTIONS(13390),
    [sym__unary_operator] = ACTIONS(13390),
    [sym__unary_plus_operator] = ACTIONS(13390),
    [aux_sym__terminator_token1] = ACTIONS(13390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13392),
    [sym__command_start] = ACTIONS(13392),
  },
  [7783] = {
    [ts_builtin_sym_end] = ACTIONS(13398),
    [sym__word_identifier] = ACTIONS(13396),
    [anon_sym_EQ] = ACTIONS(13396),
    [anon_sym_COMMA] = ACTIONS(13396),
    [anon_sym_COLON] = ACTIONS(13396),
    [anon_sym_begin] = ACTIONS(13396),
    [anon_sym_module] = ACTIONS(13396),
    [anon_sym_baremodule] = ACTIONS(13396),
    [anon_sym_abstract] = ACTIONS(13396),
    [anon_sym_primitive] = ACTIONS(13396),
    [anon_sym_mutable] = ACTIONS(13396),
    [anon_sym_struct] = ACTIONS(13396),
    [anon_sym_function] = ACTIONS(13396),
    [anon_sym_macro] = ACTIONS(13396),
    [anon_sym_where] = ACTIONS(13396),
    [anon_sym_quote] = ACTIONS(13396),
    [anon_sym_let] = ACTIONS(13396),
    [anon_sym_if] = ACTIONS(13396),
    [anon_sym_try] = ACTIONS(13396),
    [anon_sym_for] = ACTIONS(13396),
    [anon_sym_while] = ACTIONS(13396),
    [sym_break_statement] = ACTIONS(13396),
    [sym_continue_statement] = ACTIONS(13396),
    [anon_sym_return] = ACTIONS(13396),
    [anon_sym_const] = ACTIONS(13396),
    [anon_sym_global] = ACTIONS(13396),
    [anon_sym_local] = ACTIONS(13396),
    [anon_sym_LPAREN] = ACTIONS(13396),
    [anon_sym_RPAREN] = ACTIONS(13396),
    [anon_sym_COLON2] = ACTIONS(13396),
    [anon_sym_export] = ACTIONS(13396),
    [anon_sym_import] = ACTIONS(13396),
    [anon_sym_using] = ACTIONS(13396),
    [anon_sym_LBRACK] = ACTIONS(13396),
    [anon_sym_RBRACK] = ACTIONS(13396),
    [anon_sym_LF] = ACTIONS(13398),
    [anon_sym_in] = ACTIONS(13396),
    [anon_sym_LBRACE] = ACTIONS(13396),
    [anon_sym_DOLLAR] = ACTIONS(13396),
    [anon_sym_COLON_COLON] = ACTIONS(13396),
    [anon_sym_isa] = ACTIONS(13396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13396),
    [anon_sym_QMARK] = ACTIONS(13396),
    [anon_sym_AT] = ACTIONS(13396),
    [anon_sym_true] = ACTIONS(13396),
    [anon_sym_false] = ACTIONS(13396),
    [aux_sym_integer_literal_token1] = ACTIONS(13396),
    [aux_sym_integer_literal_token2] = ACTIONS(13396),
    [aux_sym_integer_literal_token3] = ACTIONS(13396),
    [aux_sym_integer_literal_token4] = ACTIONS(13396),
    [aux_sym_float_literal_token1] = ACTIONS(13396),
    [aux_sym_float_literal_token3] = ACTIONS(13396),
    [aux_sym_float_literal_token4] = ACTIONS(13396),
    [sym_character_literal] = ACTIONS(13396),
    [sym__pair_operator] = ACTIONS(13396),
    [sym__arrow_operator] = ACTIONS(13396),
    [sym__lazy_or_operator] = ACTIONS(13396),
    [sym__lazy_and_operator] = ACTIONS(13396),
    [sym__comparison_operator] = ACTIONS(13396),
    [sym__pipe_right_operator] = ACTIONS(13396),
    [sym__pipe_left_operator] = ACTIONS(13396),
    [sym__ellipsis_operator] = ACTIONS(13396),
    [sym__plus_operator] = ACTIONS(13396),
    [sym__times_operator] = ACTIONS(13396),
    [sym__rational_operator] = ACTIONS(13396),
    [sym__bitshift_operator] = ACTIONS(13396),
    [sym__power_operator] = ACTIONS(13396),
    [sym__tilde_operator] = ACTIONS(13396),
    [sym__type_order_operator] = ACTIONS(13396),
    [sym__unary_operator] = ACTIONS(13396),
    [sym__unary_plus_operator] = ACTIONS(13396),
    [aux_sym__terminator_token1] = ACTIONS(13396),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13398),
    [sym__command_start] = ACTIONS(13398),
  },
  [7784] = {
    [ts_builtin_sym_end] = ACTIONS(13402),
    [sym__word_identifier] = ACTIONS(13400),
    [anon_sym_EQ] = ACTIONS(13400),
    [anon_sym_COMMA] = ACTIONS(13400),
    [anon_sym_COLON] = ACTIONS(13400),
    [anon_sym_begin] = ACTIONS(13400),
    [anon_sym_module] = ACTIONS(13400),
    [anon_sym_baremodule] = ACTIONS(13400),
    [anon_sym_abstract] = ACTIONS(13400),
    [anon_sym_primitive] = ACTIONS(13400),
    [anon_sym_mutable] = ACTIONS(13400),
    [anon_sym_struct] = ACTIONS(13400),
    [anon_sym_function] = ACTIONS(13400),
    [anon_sym_macro] = ACTIONS(13400),
    [anon_sym_where] = ACTIONS(13400),
    [anon_sym_quote] = ACTIONS(13400),
    [anon_sym_let] = ACTIONS(13400),
    [anon_sym_if] = ACTIONS(13400),
    [anon_sym_try] = ACTIONS(13400),
    [anon_sym_for] = ACTIONS(13400),
    [anon_sym_while] = ACTIONS(13400),
    [sym_break_statement] = ACTIONS(13400),
    [sym_continue_statement] = ACTIONS(13400),
    [anon_sym_return] = ACTIONS(13400),
    [anon_sym_const] = ACTIONS(13400),
    [anon_sym_global] = ACTIONS(13400),
    [anon_sym_local] = ACTIONS(13400),
    [anon_sym_LPAREN] = ACTIONS(13400),
    [anon_sym_RPAREN] = ACTIONS(13400),
    [anon_sym_COLON2] = ACTIONS(13400),
    [anon_sym_export] = ACTIONS(13400),
    [anon_sym_import] = ACTIONS(13400),
    [anon_sym_using] = ACTIONS(13400),
    [anon_sym_LBRACK] = ACTIONS(13400),
    [anon_sym_RBRACK] = ACTIONS(13400),
    [anon_sym_LF] = ACTIONS(13402),
    [anon_sym_in] = ACTIONS(13400),
    [anon_sym_LBRACE] = ACTIONS(13400),
    [anon_sym_DOLLAR] = ACTIONS(13400),
    [anon_sym_COLON_COLON] = ACTIONS(13400),
    [anon_sym_isa] = ACTIONS(13400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13400),
    [anon_sym_QMARK] = ACTIONS(13400),
    [anon_sym_AT] = ACTIONS(13400),
    [anon_sym_true] = ACTIONS(13400),
    [anon_sym_false] = ACTIONS(13400),
    [aux_sym_integer_literal_token1] = ACTIONS(13400),
    [aux_sym_integer_literal_token2] = ACTIONS(13400),
    [aux_sym_integer_literal_token3] = ACTIONS(13400),
    [aux_sym_integer_literal_token4] = ACTIONS(13400),
    [aux_sym_float_literal_token1] = ACTIONS(13400),
    [aux_sym_float_literal_token3] = ACTIONS(13400),
    [aux_sym_float_literal_token4] = ACTIONS(13400),
    [sym_character_literal] = ACTIONS(13400),
    [sym__pair_operator] = ACTIONS(13400),
    [sym__arrow_operator] = ACTIONS(13400),
    [sym__lazy_or_operator] = ACTIONS(13400),
    [sym__lazy_and_operator] = ACTIONS(13400),
    [sym__comparison_operator] = ACTIONS(13400),
    [sym__pipe_right_operator] = ACTIONS(13400),
    [sym__pipe_left_operator] = ACTIONS(13400),
    [sym__ellipsis_operator] = ACTIONS(13400),
    [sym__plus_operator] = ACTIONS(13400),
    [sym__times_operator] = ACTIONS(13400),
    [sym__rational_operator] = ACTIONS(13400),
    [sym__bitshift_operator] = ACTIONS(13400),
    [sym__power_operator] = ACTIONS(13400),
    [sym__tilde_operator] = ACTIONS(13400),
    [sym__type_order_operator] = ACTIONS(13400),
    [sym__unary_operator] = ACTIONS(13400),
    [sym__unary_plus_operator] = ACTIONS(13400),
    [aux_sym__terminator_token1] = ACTIONS(13400),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13402),
    [sym__command_start] = ACTIONS(13402),
  },
  [7785] = {
    [ts_builtin_sym_end] = ACTIONS(13409),
    [sym__word_identifier] = ACTIONS(13407),
    [anon_sym_EQ] = ACTIONS(13407),
    [anon_sym_COMMA] = ACTIONS(13407),
    [anon_sym_COLON] = ACTIONS(13407),
    [anon_sym_begin] = ACTIONS(13407),
    [anon_sym_module] = ACTIONS(13407),
    [anon_sym_baremodule] = ACTIONS(13407),
    [anon_sym_abstract] = ACTIONS(13407),
    [anon_sym_primitive] = ACTIONS(13407),
    [anon_sym_mutable] = ACTIONS(13407),
    [anon_sym_struct] = ACTIONS(13407),
    [anon_sym_function] = ACTIONS(13407),
    [anon_sym_macro] = ACTIONS(13407),
    [anon_sym_where] = ACTIONS(13407),
    [anon_sym_quote] = ACTIONS(13407),
    [anon_sym_let] = ACTIONS(13407),
    [anon_sym_if] = ACTIONS(13407),
    [anon_sym_try] = ACTIONS(13407),
    [anon_sym_for] = ACTIONS(13407),
    [anon_sym_while] = ACTIONS(13407),
    [sym_break_statement] = ACTIONS(13407),
    [sym_continue_statement] = ACTIONS(13407),
    [anon_sym_return] = ACTIONS(13407),
    [anon_sym_const] = ACTIONS(13407),
    [anon_sym_global] = ACTIONS(13407),
    [anon_sym_local] = ACTIONS(13407),
    [anon_sym_LPAREN] = ACTIONS(13407),
    [anon_sym_RPAREN] = ACTIONS(13407),
    [anon_sym_COLON2] = ACTIONS(13407),
    [anon_sym_export] = ACTIONS(13407),
    [anon_sym_import] = ACTIONS(13407),
    [anon_sym_using] = ACTIONS(13407),
    [anon_sym_LBRACK] = ACTIONS(13407),
    [anon_sym_RBRACK] = ACTIONS(13407),
    [anon_sym_LF] = ACTIONS(13409),
    [anon_sym_in] = ACTIONS(13407),
    [anon_sym_LBRACE] = ACTIONS(13407),
    [anon_sym_DOLLAR] = ACTIONS(13407),
    [anon_sym_COLON_COLON] = ACTIONS(13407),
    [anon_sym_isa] = ACTIONS(13407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13407),
    [anon_sym_QMARK] = ACTIONS(13407),
    [anon_sym_AT] = ACTIONS(13407),
    [anon_sym_true] = ACTIONS(13407),
    [anon_sym_false] = ACTIONS(13407),
    [aux_sym_integer_literal_token1] = ACTIONS(13407),
    [aux_sym_integer_literal_token2] = ACTIONS(13407),
    [aux_sym_integer_literal_token3] = ACTIONS(13407),
    [aux_sym_integer_literal_token4] = ACTIONS(13407),
    [aux_sym_float_literal_token1] = ACTIONS(13407),
    [aux_sym_float_literal_token3] = ACTIONS(13407),
    [aux_sym_float_literal_token4] = ACTIONS(13407),
    [sym_character_literal] = ACTIONS(13407),
    [sym__pair_operator] = ACTIONS(13407),
    [sym__arrow_operator] = ACTIONS(13407),
    [sym__lazy_or_operator] = ACTIONS(13407),
    [sym__lazy_and_operator] = ACTIONS(13407),
    [sym__comparison_operator] = ACTIONS(13407),
    [sym__pipe_right_operator] = ACTIONS(13407),
    [sym__pipe_left_operator] = ACTIONS(13407),
    [sym__ellipsis_operator] = ACTIONS(13407),
    [sym__plus_operator] = ACTIONS(13407),
    [sym__times_operator] = ACTIONS(13407),
    [sym__rational_operator] = ACTIONS(13407),
    [sym__bitshift_operator] = ACTIONS(13407),
    [sym__power_operator] = ACTIONS(13407),
    [sym__tilde_operator] = ACTIONS(13407),
    [sym__type_order_operator] = ACTIONS(13407),
    [sym__unary_operator] = ACTIONS(13407),
    [sym__unary_plus_operator] = ACTIONS(13407),
    [aux_sym__terminator_token1] = ACTIONS(13407),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13409),
    [sym__command_start] = ACTIONS(13409),
  },
  [7786] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_end] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_else] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_finally] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [7787] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_catch] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [7788] = {
    [sym__comprehension_clause] = STATE(18697),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16896),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14048),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14050),
    [anon_sym_LF] = ACTIONS(14052),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14055),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7789] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_catch] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [7790] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_catch] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [7791] = {
    [ts_builtin_sym_end] = ACTIONS(13247),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(12418),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_RPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_RBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7792] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_catch] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [7793] = {
    [ts_builtin_sym_end] = ACTIONS(13075),
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13070),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_RPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_RBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [7794] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(13306),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7795] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_catch] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [7796] = {
    [sym__comprehension_clause] = STATE(19448),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17165),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14058),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14060),
    [anon_sym_LF] = ACTIONS(14062),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14065),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7797] = {
    [ts_builtin_sym_end] = ACTIONS(13253),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13255),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_RPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13255),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_RBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13255),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13255),
    [anon_sym_isa] = ACTIONS(13255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13255),
    [anon_sym_QMARK] = ACTIONS(13255),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13255),
    [sym__arrow_operator] = ACTIONS(13255),
    [sym__lazy_or_operator] = ACTIONS(13255),
    [sym__lazy_and_operator] = ACTIONS(13255),
    [sym__comparison_operator] = ACTIONS(13255),
    [sym__pipe_right_operator] = ACTIONS(13255),
    [sym__pipe_left_operator] = ACTIONS(13255),
    [sym__ellipsis_operator] = ACTIONS(13255),
    [sym__plus_operator] = ACTIONS(13255),
    [sym__times_operator] = ACTIONS(13255),
    [sym__rational_operator] = ACTIONS(13255),
    [sym__bitshift_operator] = ACTIONS(13255),
    [sym__power_operator] = ACTIONS(13255),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13255),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13255),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [7798] = {
    [ts_builtin_sym_end] = ACTIONS(13415),
    [sym__word_identifier] = ACTIONS(13413),
    [anon_sym_EQ] = ACTIONS(13413),
    [anon_sym_COMMA] = ACTIONS(13413),
    [anon_sym_COLON] = ACTIONS(13413),
    [anon_sym_begin] = ACTIONS(13413),
    [anon_sym_module] = ACTIONS(13413),
    [anon_sym_baremodule] = ACTIONS(13413),
    [anon_sym_abstract] = ACTIONS(13413),
    [anon_sym_primitive] = ACTIONS(13413),
    [anon_sym_mutable] = ACTIONS(13413),
    [anon_sym_struct] = ACTIONS(13413),
    [anon_sym_function] = ACTIONS(13413),
    [anon_sym_macro] = ACTIONS(13413),
    [anon_sym_where] = ACTIONS(13413),
    [anon_sym_quote] = ACTIONS(13413),
    [anon_sym_let] = ACTIONS(13413),
    [anon_sym_if] = ACTIONS(13413),
    [anon_sym_try] = ACTIONS(13413),
    [anon_sym_for] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(13413),
    [sym_break_statement] = ACTIONS(13413),
    [sym_continue_statement] = ACTIONS(13413),
    [anon_sym_return] = ACTIONS(13413),
    [anon_sym_const] = ACTIONS(13413),
    [anon_sym_global] = ACTIONS(13413),
    [anon_sym_local] = ACTIONS(13413),
    [anon_sym_LPAREN] = ACTIONS(13413),
    [anon_sym_RPAREN] = ACTIONS(13413),
    [anon_sym_COLON2] = ACTIONS(13413),
    [anon_sym_export] = ACTIONS(13413),
    [anon_sym_import] = ACTIONS(13413),
    [anon_sym_using] = ACTIONS(13413),
    [anon_sym_LBRACK] = ACTIONS(13413),
    [anon_sym_RBRACK] = ACTIONS(13413),
    [anon_sym_LF] = ACTIONS(13415),
    [anon_sym_in] = ACTIONS(13413),
    [anon_sym_LBRACE] = ACTIONS(13413),
    [anon_sym_DOLLAR] = ACTIONS(13413),
    [anon_sym_COLON_COLON] = ACTIONS(13413),
    [anon_sym_isa] = ACTIONS(13413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_QMARK] = ACTIONS(13413),
    [anon_sym_AT] = ACTIONS(13413),
    [anon_sym_true] = ACTIONS(13413),
    [anon_sym_false] = ACTIONS(13413),
    [aux_sym_integer_literal_token1] = ACTIONS(13413),
    [aux_sym_integer_literal_token2] = ACTIONS(13413),
    [aux_sym_integer_literal_token3] = ACTIONS(13413),
    [aux_sym_integer_literal_token4] = ACTIONS(13413),
    [aux_sym_float_literal_token1] = ACTIONS(13413),
    [aux_sym_float_literal_token3] = ACTIONS(13413),
    [aux_sym_float_literal_token4] = ACTIONS(13413),
    [sym_character_literal] = ACTIONS(13413),
    [sym__pair_operator] = ACTIONS(13413),
    [sym__arrow_operator] = ACTIONS(13413),
    [sym__lazy_or_operator] = ACTIONS(13413),
    [sym__lazy_and_operator] = ACTIONS(13413),
    [sym__comparison_operator] = ACTIONS(13413),
    [sym__pipe_right_operator] = ACTIONS(13413),
    [sym__pipe_left_operator] = ACTIONS(13413),
    [sym__ellipsis_operator] = ACTIONS(13413),
    [sym__plus_operator] = ACTIONS(13413),
    [sym__times_operator] = ACTIONS(13413),
    [sym__rational_operator] = ACTIONS(13413),
    [sym__bitshift_operator] = ACTIONS(13413),
    [sym__power_operator] = ACTIONS(13413),
    [sym__tilde_operator] = ACTIONS(13413),
    [sym__type_order_operator] = ACTIONS(13413),
    [sym__unary_operator] = ACTIONS(13413),
    [sym__unary_plus_operator] = ACTIONS(13413),
    [aux_sym__terminator_token1] = ACTIONS(13413),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13415),
    [sym__command_start] = ACTIONS(13415),
  },
  [7799] = {
    [ts_builtin_sym_end] = ACTIONS(13419),
    [sym__word_identifier] = ACTIONS(13417),
    [anon_sym_EQ] = ACTIONS(13417),
    [anon_sym_COMMA] = ACTIONS(13417),
    [anon_sym_COLON] = ACTIONS(13417),
    [anon_sym_begin] = ACTIONS(13417),
    [anon_sym_module] = ACTIONS(13417),
    [anon_sym_baremodule] = ACTIONS(13417),
    [anon_sym_abstract] = ACTIONS(13417),
    [anon_sym_primitive] = ACTIONS(13417),
    [anon_sym_mutable] = ACTIONS(13417),
    [anon_sym_struct] = ACTIONS(13417),
    [anon_sym_function] = ACTIONS(13417),
    [anon_sym_macro] = ACTIONS(13417),
    [anon_sym_where] = ACTIONS(13417),
    [anon_sym_quote] = ACTIONS(13417),
    [anon_sym_let] = ACTIONS(13417),
    [anon_sym_if] = ACTIONS(13417),
    [anon_sym_try] = ACTIONS(13417),
    [anon_sym_for] = ACTIONS(13417),
    [anon_sym_while] = ACTIONS(13417),
    [sym_break_statement] = ACTIONS(13417),
    [sym_continue_statement] = ACTIONS(13417),
    [anon_sym_return] = ACTIONS(13417),
    [anon_sym_const] = ACTIONS(13417),
    [anon_sym_global] = ACTIONS(13417),
    [anon_sym_local] = ACTIONS(13417),
    [anon_sym_LPAREN] = ACTIONS(13417),
    [anon_sym_RPAREN] = ACTIONS(13417),
    [anon_sym_COLON2] = ACTIONS(13417),
    [anon_sym_export] = ACTIONS(13417),
    [anon_sym_import] = ACTIONS(13417),
    [anon_sym_using] = ACTIONS(13417),
    [anon_sym_LBRACK] = ACTIONS(13417),
    [anon_sym_RBRACK] = ACTIONS(13417),
    [anon_sym_LF] = ACTIONS(13419),
    [anon_sym_in] = ACTIONS(13417),
    [anon_sym_LBRACE] = ACTIONS(13417),
    [anon_sym_DOLLAR] = ACTIONS(13417),
    [anon_sym_COLON_COLON] = ACTIONS(13417),
    [anon_sym_isa] = ACTIONS(13417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13417),
    [anon_sym_QMARK] = ACTIONS(13417),
    [anon_sym_AT] = ACTIONS(13417),
    [anon_sym_true] = ACTIONS(13417),
    [anon_sym_false] = ACTIONS(13417),
    [aux_sym_integer_literal_token1] = ACTIONS(13417),
    [aux_sym_integer_literal_token2] = ACTIONS(13417),
    [aux_sym_integer_literal_token3] = ACTIONS(13417),
    [aux_sym_integer_literal_token4] = ACTIONS(13417),
    [aux_sym_float_literal_token1] = ACTIONS(13417),
    [aux_sym_float_literal_token3] = ACTIONS(13417),
    [aux_sym_float_literal_token4] = ACTIONS(13417),
    [sym_character_literal] = ACTIONS(13417),
    [sym__pair_operator] = ACTIONS(13417),
    [sym__arrow_operator] = ACTIONS(13417),
    [sym__lazy_or_operator] = ACTIONS(13417),
    [sym__lazy_and_operator] = ACTIONS(13417),
    [sym__comparison_operator] = ACTIONS(13417),
    [sym__pipe_right_operator] = ACTIONS(13417),
    [sym__pipe_left_operator] = ACTIONS(13417),
    [sym__ellipsis_operator] = ACTIONS(13417),
    [sym__plus_operator] = ACTIONS(13417),
    [sym__times_operator] = ACTIONS(13417),
    [sym__rational_operator] = ACTIONS(13417),
    [sym__bitshift_operator] = ACTIONS(13417),
    [sym__power_operator] = ACTIONS(13417),
    [sym__tilde_operator] = ACTIONS(13417),
    [sym__type_order_operator] = ACTIONS(13417),
    [sym__unary_operator] = ACTIONS(13417),
    [sym__unary_plus_operator] = ACTIONS(13417),
    [aux_sym__terminator_token1] = ACTIONS(13417),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13419),
    [sym__command_start] = ACTIONS(13419),
  },
  [7800] = {
    [ts_builtin_sym_end] = ACTIONS(13423),
    [sym__word_identifier] = ACTIONS(13421),
    [anon_sym_EQ] = ACTIONS(13421),
    [anon_sym_COMMA] = ACTIONS(13421),
    [anon_sym_COLON] = ACTIONS(13421),
    [anon_sym_begin] = ACTIONS(13421),
    [anon_sym_module] = ACTIONS(13421),
    [anon_sym_baremodule] = ACTIONS(13421),
    [anon_sym_abstract] = ACTIONS(13421),
    [anon_sym_primitive] = ACTIONS(13421),
    [anon_sym_mutable] = ACTIONS(13421),
    [anon_sym_struct] = ACTIONS(13421),
    [anon_sym_function] = ACTIONS(13421),
    [anon_sym_macro] = ACTIONS(13421),
    [anon_sym_where] = ACTIONS(13421),
    [anon_sym_quote] = ACTIONS(13421),
    [anon_sym_let] = ACTIONS(13421),
    [anon_sym_if] = ACTIONS(13421),
    [anon_sym_try] = ACTIONS(13421),
    [anon_sym_for] = ACTIONS(13421),
    [anon_sym_while] = ACTIONS(13421),
    [sym_break_statement] = ACTIONS(13421),
    [sym_continue_statement] = ACTIONS(13421),
    [anon_sym_return] = ACTIONS(13421),
    [anon_sym_const] = ACTIONS(13421),
    [anon_sym_global] = ACTIONS(13421),
    [anon_sym_local] = ACTIONS(13421),
    [anon_sym_LPAREN] = ACTIONS(13421),
    [anon_sym_RPAREN] = ACTIONS(13421),
    [anon_sym_COLON2] = ACTIONS(13421),
    [anon_sym_export] = ACTIONS(13421),
    [anon_sym_import] = ACTIONS(13421),
    [anon_sym_using] = ACTIONS(13421),
    [anon_sym_LBRACK] = ACTIONS(13421),
    [anon_sym_RBRACK] = ACTIONS(13421),
    [anon_sym_LF] = ACTIONS(13423),
    [anon_sym_in] = ACTIONS(13421),
    [anon_sym_LBRACE] = ACTIONS(13421),
    [anon_sym_DOLLAR] = ACTIONS(13421),
    [anon_sym_COLON_COLON] = ACTIONS(13421),
    [anon_sym_isa] = ACTIONS(13421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13421),
    [anon_sym_QMARK] = ACTIONS(13421),
    [anon_sym_AT] = ACTIONS(13421),
    [anon_sym_true] = ACTIONS(13421),
    [anon_sym_false] = ACTIONS(13421),
    [aux_sym_integer_literal_token1] = ACTIONS(13421),
    [aux_sym_integer_literal_token2] = ACTIONS(13421),
    [aux_sym_integer_literal_token3] = ACTIONS(13421),
    [aux_sym_integer_literal_token4] = ACTIONS(13421),
    [aux_sym_float_literal_token1] = ACTIONS(13421),
    [aux_sym_float_literal_token3] = ACTIONS(13421),
    [aux_sym_float_literal_token4] = ACTIONS(13421),
    [sym_character_literal] = ACTIONS(13421),
    [sym__pair_operator] = ACTIONS(13421),
    [sym__arrow_operator] = ACTIONS(13421),
    [sym__lazy_or_operator] = ACTIONS(13421),
    [sym__lazy_and_operator] = ACTIONS(13421),
    [sym__comparison_operator] = ACTIONS(13421),
    [sym__pipe_right_operator] = ACTIONS(13421),
    [sym__pipe_left_operator] = ACTIONS(13421),
    [sym__ellipsis_operator] = ACTIONS(13421),
    [sym__plus_operator] = ACTIONS(13421),
    [sym__times_operator] = ACTIONS(13421),
    [sym__rational_operator] = ACTIONS(13421),
    [sym__bitshift_operator] = ACTIONS(13421),
    [sym__power_operator] = ACTIONS(13421),
    [sym__tilde_operator] = ACTIONS(13421),
    [sym__type_order_operator] = ACTIONS(13421),
    [sym__unary_operator] = ACTIONS(13421),
    [sym__unary_plus_operator] = ACTIONS(13421),
    [aux_sym__terminator_token1] = ACTIONS(13421),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13423),
    [sym__command_start] = ACTIONS(13423),
  },
  [7801] = {
    [ts_builtin_sym_end] = ACTIONS(13427),
    [sym__word_identifier] = ACTIONS(13425),
    [anon_sym_EQ] = ACTIONS(13425),
    [anon_sym_COMMA] = ACTIONS(13425),
    [anon_sym_COLON] = ACTIONS(13425),
    [anon_sym_begin] = ACTIONS(13425),
    [anon_sym_module] = ACTIONS(13425),
    [anon_sym_baremodule] = ACTIONS(13425),
    [anon_sym_abstract] = ACTIONS(13425),
    [anon_sym_primitive] = ACTIONS(13425),
    [anon_sym_mutable] = ACTIONS(13425),
    [anon_sym_struct] = ACTIONS(13425),
    [anon_sym_function] = ACTIONS(13425),
    [anon_sym_macro] = ACTIONS(13425),
    [anon_sym_where] = ACTIONS(13425),
    [anon_sym_quote] = ACTIONS(13425),
    [anon_sym_let] = ACTIONS(13425),
    [anon_sym_if] = ACTIONS(13425),
    [anon_sym_try] = ACTIONS(13425),
    [anon_sym_for] = ACTIONS(13425),
    [anon_sym_while] = ACTIONS(13425),
    [sym_break_statement] = ACTIONS(13425),
    [sym_continue_statement] = ACTIONS(13425),
    [anon_sym_return] = ACTIONS(13425),
    [anon_sym_const] = ACTIONS(13425),
    [anon_sym_global] = ACTIONS(13425),
    [anon_sym_local] = ACTIONS(13425),
    [anon_sym_LPAREN] = ACTIONS(13425),
    [anon_sym_RPAREN] = ACTIONS(13425),
    [anon_sym_COLON2] = ACTIONS(13425),
    [anon_sym_export] = ACTIONS(13425),
    [anon_sym_import] = ACTIONS(13425),
    [anon_sym_using] = ACTIONS(13425),
    [anon_sym_LBRACK] = ACTIONS(13425),
    [anon_sym_RBRACK] = ACTIONS(13425),
    [anon_sym_LF] = ACTIONS(13427),
    [anon_sym_in] = ACTIONS(13425),
    [anon_sym_LBRACE] = ACTIONS(13425),
    [anon_sym_DOLLAR] = ACTIONS(13425),
    [anon_sym_COLON_COLON] = ACTIONS(13425),
    [anon_sym_isa] = ACTIONS(13425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13425),
    [anon_sym_QMARK] = ACTIONS(13425),
    [anon_sym_AT] = ACTIONS(13425),
    [anon_sym_true] = ACTIONS(13425),
    [anon_sym_false] = ACTIONS(13425),
    [aux_sym_integer_literal_token1] = ACTIONS(13425),
    [aux_sym_integer_literal_token2] = ACTIONS(13425),
    [aux_sym_integer_literal_token3] = ACTIONS(13425),
    [aux_sym_integer_literal_token4] = ACTIONS(13425),
    [aux_sym_float_literal_token1] = ACTIONS(13425),
    [aux_sym_float_literal_token3] = ACTIONS(13425),
    [aux_sym_float_literal_token4] = ACTIONS(13425),
    [sym_character_literal] = ACTIONS(13425),
    [sym__pair_operator] = ACTIONS(13425),
    [sym__arrow_operator] = ACTIONS(13425),
    [sym__lazy_or_operator] = ACTIONS(13425),
    [sym__lazy_and_operator] = ACTIONS(13425),
    [sym__comparison_operator] = ACTIONS(13425),
    [sym__pipe_right_operator] = ACTIONS(13425),
    [sym__pipe_left_operator] = ACTIONS(13425),
    [sym__ellipsis_operator] = ACTIONS(13425),
    [sym__plus_operator] = ACTIONS(13425),
    [sym__times_operator] = ACTIONS(13425),
    [sym__rational_operator] = ACTIONS(13425),
    [sym__bitshift_operator] = ACTIONS(13425),
    [sym__power_operator] = ACTIONS(13425),
    [sym__tilde_operator] = ACTIONS(13425),
    [sym__type_order_operator] = ACTIONS(13425),
    [sym__unary_operator] = ACTIONS(13425),
    [sym__unary_plus_operator] = ACTIONS(13425),
    [aux_sym__terminator_token1] = ACTIONS(13425),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13427),
    [sym__command_start] = ACTIONS(13427),
  },
  [7802] = {
    [ts_builtin_sym_end] = ACTIONS(13431),
    [sym__word_identifier] = ACTIONS(13429),
    [anon_sym_EQ] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(13429),
    [anon_sym_COLON] = ACTIONS(13429),
    [anon_sym_begin] = ACTIONS(13429),
    [anon_sym_module] = ACTIONS(13429),
    [anon_sym_baremodule] = ACTIONS(13429),
    [anon_sym_abstract] = ACTIONS(13429),
    [anon_sym_primitive] = ACTIONS(13429),
    [anon_sym_mutable] = ACTIONS(13429),
    [anon_sym_struct] = ACTIONS(13429),
    [anon_sym_function] = ACTIONS(13429),
    [anon_sym_macro] = ACTIONS(13429),
    [anon_sym_where] = ACTIONS(13429),
    [anon_sym_quote] = ACTIONS(13429),
    [anon_sym_let] = ACTIONS(13429),
    [anon_sym_if] = ACTIONS(13429),
    [anon_sym_try] = ACTIONS(13429),
    [anon_sym_for] = ACTIONS(13429),
    [anon_sym_while] = ACTIONS(13429),
    [sym_break_statement] = ACTIONS(13429),
    [sym_continue_statement] = ACTIONS(13429),
    [anon_sym_return] = ACTIONS(13429),
    [anon_sym_const] = ACTIONS(13429),
    [anon_sym_global] = ACTIONS(13429),
    [anon_sym_local] = ACTIONS(13429),
    [anon_sym_LPAREN] = ACTIONS(13429),
    [anon_sym_RPAREN] = ACTIONS(13429),
    [anon_sym_COLON2] = ACTIONS(13429),
    [anon_sym_export] = ACTIONS(13429),
    [anon_sym_import] = ACTIONS(13429),
    [anon_sym_using] = ACTIONS(13429),
    [anon_sym_LBRACK] = ACTIONS(13429),
    [anon_sym_RBRACK] = ACTIONS(13429),
    [anon_sym_LF] = ACTIONS(13431),
    [anon_sym_in] = ACTIONS(13429),
    [anon_sym_LBRACE] = ACTIONS(13429),
    [anon_sym_DOLLAR] = ACTIONS(13429),
    [anon_sym_COLON_COLON] = ACTIONS(13429),
    [anon_sym_isa] = ACTIONS(13429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13429),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_AT] = ACTIONS(13429),
    [anon_sym_true] = ACTIONS(13429),
    [anon_sym_false] = ACTIONS(13429),
    [aux_sym_integer_literal_token1] = ACTIONS(13429),
    [aux_sym_integer_literal_token2] = ACTIONS(13429),
    [aux_sym_integer_literal_token3] = ACTIONS(13429),
    [aux_sym_integer_literal_token4] = ACTIONS(13429),
    [aux_sym_float_literal_token1] = ACTIONS(13429),
    [aux_sym_float_literal_token3] = ACTIONS(13429),
    [aux_sym_float_literal_token4] = ACTIONS(13429),
    [sym_character_literal] = ACTIONS(13429),
    [sym__pair_operator] = ACTIONS(13429),
    [sym__arrow_operator] = ACTIONS(13429),
    [sym__lazy_or_operator] = ACTIONS(13429),
    [sym__lazy_and_operator] = ACTIONS(13429),
    [sym__comparison_operator] = ACTIONS(13429),
    [sym__pipe_right_operator] = ACTIONS(13429),
    [sym__pipe_left_operator] = ACTIONS(13429),
    [sym__ellipsis_operator] = ACTIONS(13429),
    [sym__plus_operator] = ACTIONS(13429),
    [sym__times_operator] = ACTIONS(13429),
    [sym__rational_operator] = ACTIONS(13429),
    [sym__bitshift_operator] = ACTIONS(13429),
    [sym__power_operator] = ACTIONS(13429),
    [sym__tilde_operator] = ACTIONS(13429),
    [sym__type_order_operator] = ACTIONS(13429),
    [sym__unary_operator] = ACTIONS(13429),
    [sym__unary_plus_operator] = ACTIONS(13429),
    [aux_sym__terminator_token1] = ACTIONS(13429),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13431),
    [sym__command_start] = ACTIONS(13431),
  },
  [7803] = {
    [ts_builtin_sym_end] = ACTIONS(13435),
    [sym__word_identifier] = ACTIONS(13433),
    [anon_sym_EQ] = ACTIONS(13433),
    [anon_sym_COMMA] = ACTIONS(13433),
    [anon_sym_COLON] = ACTIONS(13433),
    [anon_sym_begin] = ACTIONS(13433),
    [anon_sym_module] = ACTIONS(13433),
    [anon_sym_baremodule] = ACTIONS(13433),
    [anon_sym_abstract] = ACTIONS(13433),
    [anon_sym_primitive] = ACTIONS(13433),
    [anon_sym_mutable] = ACTIONS(13433),
    [anon_sym_struct] = ACTIONS(13433),
    [anon_sym_function] = ACTIONS(13433),
    [anon_sym_macro] = ACTIONS(13433),
    [anon_sym_where] = ACTIONS(13433),
    [anon_sym_quote] = ACTIONS(13433),
    [anon_sym_let] = ACTIONS(13433),
    [anon_sym_if] = ACTIONS(13433),
    [anon_sym_try] = ACTIONS(13433),
    [anon_sym_for] = ACTIONS(13433),
    [anon_sym_while] = ACTIONS(13433),
    [sym_break_statement] = ACTIONS(13433),
    [sym_continue_statement] = ACTIONS(13433),
    [anon_sym_return] = ACTIONS(13433),
    [anon_sym_const] = ACTIONS(13433),
    [anon_sym_global] = ACTIONS(13433),
    [anon_sym_local] = ACTIONS(13433),
    [anon_sym_LPAREN] = ACTIONS(13433),
    [anon_sym_RPAREN] = ACTIONS(13433),
    [anon_sym_COLON2] = ACTIONS(13433),
    [anon_sym_export] = ACTIONS(13433),
    [anon_sym_import] = ACTIONS(13433),
    [anon_sym_using] = ACTIONS(13433),
    [anon_sym_LBRACK] = ACTIONS(13433),
    [anon_sym_RBRACK] = ACTIONS(13433),
    [anon_sym_LF] = ACTIONS(13435),
    [anon_sym_in] = ACTIONS(13433),
    [anon_sym_LBRACE] = ACTIONS(13433),
    [anon_sym_DOLLAR] = ACTIONS(13433),
    [anon_sym_COLON_COLON] = ACTIONS(13433),
    [anon_sym_isa] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13433),
    [anon_sym_QMARK] = ACTIONS(13433),
    [anon_sym_AT] = ACTIONS(13433),
    [anon_sym_true] = ACTIONS(13433),
    [anon_sym_false] = ACTIONS(13433),
    [aux_sym_integer_literal_token1] = ACTIONS(13433),
    [aux_sym_integer_literal_token2] = ACTIONS(13433),
    [aux_sym_integer_literal_token3] = ACTIONS(13433),
    [aux_sym_integer_literal_token4] = ACTIONS(13433),
    [aux_sym_float_literal_token1] = ACTIONS(13433),
    [aux_sym_float_literal_token3] = ACTIONS(13433),
    [aux_sym_float_literal_token4] = ACTIONS(13433),
    [sym_character_literal] = ACTIONS(13433),
    [sym__pair_operator] = ACTIONS(13433),
    [sym__arrow_operator] = ACTIONS(13433),
    [sym__lazy_or_operator] = ACTIONS(13433),
    [sym__lazy_and_operator] = ACTIONS(13433),
    [sym__comparison_operator] = ACTIONS(13433),
    [sym__pipe_right_operator] = ACTIONS(13433),
    [sym__pipe_left_operator] = ACTIONS(13433),
    [sym__ellipsis_operator] = ACTIONS(13433),
    [sym__plus_operator] = ACTIONS(13433),
    [sym__times_operator] = ACTIONS(13433),
    [sym__rational_operator] = ACTIONS(13433),
    [sym__bitshift_operator] = ACTIONS(13433),
    [sym__power_operator] = ACTIONS(13433),
    [sym__tilde_operator] = ACTIONS(13433),
    [sym__type_order_operator] = ACTIONS(13433),
    [sym__unary_operator] = ACTIONS(13433),
    [sym__unary_plus_operator] = ACTIONS(13433),
    [aux_sym__terminator_token1] = ACTIONS(13433),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13435),
    [sym__command_start] = ACTIONS(13435),
  },
  [7804] = {
    [ts_builtin_sym_end] = ACTIONS(13439),
    [sym__word_identifier] = ACTIONS(13437),
    [anon_sym_EQ] = ACTIONS(13437),
    [anon_sym_COMMA] = ACTIONS(13437),
    [anon_sym_COLON] = ACTIONS(13437),
    [anon_sym_begin] = ACTIONS(13437),
    [anon_sym_module] = ACTIONS(13437),
    [anon_sym_baremodule] = ACTIONS(13437),
    [anon_sym_abstract] = ACTIONS(13437),
    [anon_sym_primitive] = ACTIONS(13437),
    [anon_sym_mutable] = ACTIONS(13437),
    [anon_sym_struct] = ACTIONS(13437),
    [anon_sym_function] = ACTIONS(13437),
    [anon_sym_macro] = ACTIONS(13437),
    [anon_sym_where] = ACTIONS(13437),
    [anon_sym_quote] = ACTIONS(13437),
    [anon_sym_let] = ACTIONS(13437),
    [anon_sym_if] = ACTIONS(13437),
    [anon_sym_try] = ACTIONS(13437),
    [anon_sym_for] = ACTIONS(13437),
    [anon_sym_while] = ACTIONS(13437),
    [sym_break_statement] = ACTIONS(13437),
    [sym_continue_statement] = ACTIONS(13437),
    [anon_sym_return] = ACTIONS(13437),
    [anon_sym_const] = ACTIONS(13437),
    [anon_sym_global] = ACTIONS(13437),
    [anon_sym_local] = ACTIONS(13437),
    [anon_sym_LPAREN] = ACTIONS(13437),
    [anon_sym_RPAREN] = ACTIONS(13437),
    [anon_sym_COLON2] = ACTIONS(13437),
    [anon_sym_export] = ACTIONS(13437),
    [anon_sym_import] = ACTIONS(13437),
    [anon_sym_using] = ACTIONS(13437),
    [anon_sym_LBRACK] = ACTIONS(13437),
    [anon_sym_RBRACK] = ACTIONS(13437),
    [anon_sym_LF] = ACTIONS(13439),
    [anon_sym_in] = ACTIONS(13437),
    [anon_sym_LBRACE] = ACTIONS(13437),
    [anon_sym_DOLLAR] = ACTIONS(13437),
    [anon_sym_COLON_COLON] = ACTIONS(13437),
    [anon_sym_isa] = ACTIONS(13437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13437),
    [anon_sym_QMARK] = ACTIONS(13437),
    [anon_sym_AT] = ACTIONS(13437),
    [anon_sym_true] = ACTIONS(13437),
    [anon_sym_false] = ACTIONS(13437),
    [aux_sym_integer_literal_token1] = ACTIONS(13437),
    [aux_sym_integer_literal_token2] = ACTIONS(13437),
    [aux_sym_integer_literal_token3] = ACTIONS(13437),
    [aux_sym_integer_literal_token4] = ACTIONS(13437),
    [aux_sym_float_literal_token1] = ACTIONS(13437),
    [aux_sym_float_literal_token3] = ACTIONS(13437),
    [aux_sym_float_literal_token4] = ACTIONS(13437),
    [sym_character_literal] = ACTIONS(13437),
    [sym__pair_operator] = ACTIONS(13437),
    [sym__arrow_operator] = ACTIONS(13437),
    [sym__lazy_or_operator] = ACTIONS(13437),
    [sym__lazy_and_operator] = ACTIONS(13437),
    [sym__comparison_operator] = ACTIONS(13437),
    [sym__pipe_right_operator] = ACTIONS(13437),
    [sym__pipe_left_operator] = ACTIONS(13437),
    [sym__ellipsis_operator] = ACTIONS(13437),
    [sym__plus_operator] = ACTIONS(13437),
    [sym__times_operator] = ACTIONS(13437),
    [sym__rational_operator] = ACTIONS(13437),
    [sym__bitshift_operator] = ACTIONS(13437),
    [sym__power_operator] = ACTIONS(13437),
    [sym__tilde_operator] = ACTIONS(13437),
    [sym__type_order_operator] = ACTIONS(13437),
    [sym__unary_operator] = ACTIONS(13437),
    [sym__unary_plus_operator] = ACTIONS(13437),
    [aux_sym__terminator_token1] = ACTIONS(13437),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13439),
    [sym__command_start] = ACTIONS(13439),
  },
  [7805] = {
    [ts_builtin_sym_end] = ACTIONS(13443),
    [sym__word_identifier] = ACTIONS(13441),
    [anon_sym_EQ] = ACTIONS(13441),
    [anon_sym_COMMA] = ACTIONS(13441),
    [anon_sym_COLON] = ACTIONS(13441),
    [anon_sym_begin] = ACTIONS(13441),
    [anon_sym_module] = ACTIONS(13441),
    [anon_sym_baremodule] = ACTIONS(13441),
    [anon_sym_abstract] = ACTIONS(13441),
    [anon_sym_primitive] = ACTIONS(13441),
    [anon_sym_mutable] = ACTIONS(13441),
    [anon_sym_struct] = ACTIONS(13441),
    [anon_sym_function] = ACTIONS(13441),
    [anon_sym_macro] = ACTIONS(13441),
    [anon_sym_where] = ACTIONS(13441),
    [anon_sym_quote] = ACTIONS(13441),
    [anon_sym_let] = ACTIONS(13441),
    [anon_sym_if] = ACTIONS(13441),
    [anon_sym_try] = ACTIONS(13441),
    [anon_sym_for] = ACTIONS(13441),
    [anon_sym_while] = ACTIONS(13441),
    [sym_break_statement] = ACTIONS(13441),
    [sym_continue_statement] = ACTIONS(13441),
    [anon_sym_return] = ACTIONS(13441),
    [anon_sym_const] = ACTIONS(13441),
    [anon_sym_global] = ACTIONS(13441),
    [anon_sym_local] = ACTIONS(13441),
    [anon_sym_LPAREN] = ACTIONS(13441),
    [anon_sym_RPAREN] = ACTIONS(13441),
    [anon_sym_COLON2] = ACTIONS(13441),
    [anon_sym_export] = ACTIONS(13441),
    [anon_sym_import] = ACTIONS(13441),
    [anon_sym_using] = ACTIONS(13441),
    [anon_sym_LBRACK] = ACTIONS(13441),
    [anon_sym_RBRACK] = ACTIONS(13441),
    [anon_sym_LF] = ACTIONS(13443),
    [anon_sym_in] = ACTIONS(13441),
    [anon_sym_LBRACE] = ACTIONS(13441),
    [anon_sym_DOLLAR] = ACTIONS(13441),
    [anon_sym_COLON_COLON] = ACTIONS(13441),
    [anon_sym_isa] = ACTIONS(13441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13441),
    [anon_sym_QMARK] = ACTIONS(13441),
    [anon_sym_AT] = ACTIONS(13441),
    [anon_sym_true] = ACTIONS(13441),
    [anon_sym_false] = ACTIONS(13441),
    [aux_sym_integer_literal_token1] = ACTIONS(13441),
    [aux_sym_integer_literal_token2] = ACTIONS(13441),
    [aux_sym_integer_literal_token3] = ACTIONS(13441),
    [aux_sym_integer_literal_token4] = ACTIONS(13441),
    [aux_sym_float_literal_token1] = ACTIONS(13441),
    [aux_sym_float_literal_token3] = ACTIONS(13441),
    [aux_sym_float_literal_token4] = ACTIONS(13441),
    [sym_character_literal] = ACTIONS(13441),
    [sym__pair_operator] = ACTIONS(13441),
    [sym__arrow_operator] = ACTIONS(13441),
    [sym__lazy_or_operator] = ACTIONS(13441),
    [sym__lazy_and_operator] = ACTIONS(13441),
    [sym__comparison_operator] = ACTIONS(13441),
    [sym__pipe_right_operator] = ACTIONS(13441),
    [sym__pipe_left_operator] = ACTIONS(13441),
    [sym__ellipsis_operator] = ACTIONS(13441),
    [sym__plus_operator] = ACTIONS(13441),
    [sym__times_operator] = ACTIONS(13441),
    [sym__rational_operator] = ACTIONS(13441),
    [sym__bitshift_operator] = ACTIONS(13441),
    [sym__power_operator] = ACTIONS(13441),
    [sym__tilde_operator] = ACTIONS(13441),
    [sym__type_order_operator] = ACTIONS(13441),
    [sym__unary_operator] = ACTIONS(13441),
    [sym__unary_plus_operator] = ACTIONS(13441),
    [aux_sym__terminator_token1] = ACTIONS(13441),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13443),
    [sym__command_start] = ACTIONS(13443),
  },
  [7806] = {
    [ts_builtin_sym_end] = ACTIONS(13447),
    [sym__word_identifier] = ACTIONS(13445),
    [anon_sym_EQ] = ACTIONS(13445),
    [anon_sym_COMMA] = ACTIONS(13445),
    [anon_sym_COLON] = ACTIONS(13445),
    [anon_sym_begin] = ACTIONS(13445),
    [anon_sym_module] = ACTIONS(13445),
    [anon_sym_baremodule] = ACTIONS(13445),
    [anon_sym_abstract] = ACTIONS(13445),
    [anon_sym_primitive] = ACTIONS(13445),
    [anon_sym_mutable] = ACTIONS(13445),
    [anon_sym_struct] = ACTIONS(13445),
    [anon_sym_function] = ACTIONS(13445),
    [anon_sym_macro] = ACTIONS(13445),
    [anon_sym_where] = ACTIONS(13445),
    [anon_sym_quote] = ACTIONS(13445),
    [anon_sym_let] = ACTIONS(13445),
    [anon_sym_if] = ACTIONS(13445),
    [anon_sym_try] = ACTIONS(13445),
    [anon_sym_for] = ACTIONS(13445),
    [anon_sym_while] = ACTIONS(13445),
    [sym_break_statement] = ACTIONS(13445),
    [sym_continue_statement] = ACTIONS(13445),
    [anon_sym_return] = ACTIONS(13445),
    [anon_sym_const] = ACTIONS(13445),
    [anon_sym_global] = ACTIONS(13445),
    [anon_sym_local] = ACTIONS(13445),
    [anon_sym_LPAREN] = ACTIONS(13445),
    [anon_sym_RPAREN] = ACTIONS(13445),
    [anon_sym_COLON2] = ACTIONS(13445),
    [anon_sym_export] = ACTIONS(13445),
    [anon_sym_import] = ACTIONS(13445),
    [anon_sym_using] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(13445),
    [anon_sym_RBRACK] = ACTIONS(13445),
    [anon_sym_LF] = ACTIONS(13447),
    [anon_sym_in] = ACTIONS(13445),
    [anon_sym_LBRACE] = ACTIONS(13445),
    [anon_sym_DOLLAR] = ACTIONS(13445),
    [anon_sym_COLON_COLON] = ACTIONS(13445),
    [anon_sym_isa] = ACTIONS(13445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13445),
    [anon_sym_QMARK] = ACTIONS(13445),
    [anon_sym_AT] = ACTIONS(13445),
    [anon_sym_true] = ACTIONS(13445),
    [anon_sym_false] = ACTIONS(13445),
    [aux_sym_integer_literal_token1] = ACTIONS(13445),
    [aux_sym_integer_literal_token2] = ACTIONS(13445),
    [aux_sym_integer_literal_token3] = ACTIONS(13445),
    [aux_sym_integer_literal_token4] = ACTIONS(13445),
    [aux_sym_float_literal_token1] = ACTIONS(13445),
    [aux_sym_float_literal_token3] = ACTIONS(13445),
    [aux_sym_float_literal_token4] = ACTIONS(13445),
    [sym_character_literal] = ACTIONS(13445),
    [sym__pair_operator] = ACTIONS(13445),
    [sym__arrow_operator] = ACTIONS(13445),
    [sym__lazy_or_operator] = ACTIONS(13445),
    [sym__lazy_and_operator] = ACTIONS(13445),
    [sym__comparison_operator] = ACTIONS(13445),
    [sym__pipe_right_operator] = ACTIONS(13445),
    [sym__pipe_left_operator] = ACTIONS(13445),
    [sym__ellipsis_operator] = ACTIONS(13445),
    [sym__plus_operator] = ACTIONS(13445),
    [sym__times_operator] = ACTIONS(13445),
    [sym__rational_operator] = ACTIONS(13445),
    [sym__bitshift_operator] = ACTIONS(13445),
    [sym__power_operator] = ACTIONS(13445),
    [sym__tilde_operator] = ACTIONS(13445),
    [sym__type_order_operator] = ACTIONS(13445),
    [sym__unary_operator] = ACTIONS(13445),
    [sym__unary_plus_operator] = ACTIONS(13445),
    [aux_sym__terminator_token1] = ACTIONS(13445),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13447),
    [sym__command_start] = ACTIONS(13447),
  },
  [7807] = {
    [ts_builtin_sym_end] = ACTIONS(13451),
    [sym__word_identifier] = ACTIONS(13449),
    [anon_sym_EQ] = ACTIONS(13449),
    [anon_sym_COMMA] = ACTIONS(13449),
    [anon_sym_COLON] = ACTIONS(13449),
    [anon_sym_begin] = ACTIONS(13449),
    [anon_sym_module] = ACTIONS(13449),
    [anon_sym_baremodule] = ACTIONS(13449),
    [anon_sym_abstract] = ACTIONS(13449),
    [anon_sym_primitive] = ACTIONS(13449),
    [anon_sym_mutable] = ACTIONS(13449),
    [anon_sym_struct] = ACTIONS(13449),
    [anon_sym_function] = ACTIONS(13449),
    [anon_sym_macro] = ACTIONS(13449),
    [anon_sym_where] = ACTIONS(13449),
    [anon_sym_quote] = ACTIONS(13449),
    [anon_sym_let] = ACTIONS(13449),
    [anon_sym_if] = ACTIONS(13449),
    [anon_sym_try] = ACTIONS(13449),
    [anon_sym_for] = ACTIONS(13449),
    [anon_sym_while] = ACTIONS(13449),
    [sym_break_statement] = ACTIONS(13449),
    [sym_continue_statement] = ACTIONS(13449),
    [anon_sym_return] = ACTIONS(13449),
    [anon_sym_const] = ACTIONS(13449),
    [anon_sym_global] = ACTIONS(13449),
    [anon_sym_local] = ACTIONS(13449),
    [anon_sym_LPAREN] = ACTIONS(13449),
    [anon_sym_RPAREN] = ACTIONS(13449),
    [anon_sym_COLON2] = ACTIONS(13449),
    [anon_sym_export] = ACTIONS(13449),
    [anon_sym_import] = ACTIONS(13449),
    [anon_sym_using] = ACTIONS(13449),
    [anon_sym_LBRACK] = ACTIONS(13449),
    [anon_sym_RBRACK] = ACTIONS(13449),
    [anon_sym_LF] = ACTIONS(13451),
    [anon_sym_in] = ACTIONS(13449),
    [anon_sym_LBRACE] = ACTIONS(13449),
    [anon_sym_DOLLAR] = ACTIONS(13449),
    [anon_sym_COLON_COLON] = ACTIONS(13449),
    [anon_sym_isa] = ACTIONS(13449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13449),
    [anon_sym_QMARK] = ACTIONS(13449),
    [anon_sym_AT] = ACTIONS(13449),
    [anon_sym_true] = ACTIONS(13449),
    [anon_sym_false] = ACTIONS(13449),
    [aux_sym_integer_literal_token1] = ACTIONS(13449),
    [aux_sym_integer_literal_token2] = ACTIONS(13449),
    [aux_sym_integer_literal_token3] = ACTIONS(13449),
    [aux_sym_integer_literal_token4] = ACTIONS(13449),
    [aux_sym_float_literal_token1] = ACTIONS(13449),
    [aux_sym_float_literal_token3] = ACTIONS(13449),
    [aux_sym_float_literal_token4] = ACTIONS(13449),
    [sym_character_literal] = ACTIONS(13449),
    [sym__pair_operator] = ACTIONS(13449),
    [sym__arrow_operator] = ACTIONS(13449),
    [sym__lazy_or_operator] = ACTIONS(13449),
    [sym__lazy_and_operator] = ACTIONS(13449),
    [sym__comparison_operator] = ACTIONS(13449),
    [sym__pipe_right_operator] = ACTIONS(13449),
    [sym__pipe_left_operator] = ACTIONS(13449),
    [sym__ellipsis_operator] = ACTIONS(13449),
    [sym__plus_operator] = ACTIONS(13449),
    [sym__times_operator] = ACTIONS(13449),
    [sym__rational_operator] = ACTIONS(13449),
    [sym__bitshift_operator] = ACTIONS(13449),
    [sym__power_operator] = ACTIONS(13449),
    [sym__tilde_operator] = ACTIONS(13449),
    [sym__type_order_operator] = ACTIONS(13449),
    [sym__unary_operator] = ACTIONS(13449),
    [sym__unary_plus_operator] = ACTIONS(13449),
    [aux_sym__terminator_token1] = ACTIONS(13449),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13451),
    [sym__command_start] = ACTIONS(13451),
  },
  [7808] = {
    [ts_builtin_sym_end] = ACTIONS(13455),
    [sym__word_identifier] = ACTIONS(13453),
    [anon_sym_EQ] = ACTIONS(13453),
    [anon_sym_COMMA] = ACTIONS(13453),
    [anon_sym_COLON] = ACTIONS(13453),
    [anon_sym_begin] = ACTIONS(13453),
    [anon_sym_module] = ACTIONS(13453),
    [anon_sym_baremodule] = ACTIONS(13453),
    [anon_sym_abstract] = ACTIONS(13453),
    [anon_sym_primitive] = ACTIONS(13453),
    [anon_sym_mutable] = ACTIONS(13453),
    [anon_sym_struct] = ACTIONS(13453),
    [anon_sym_function] = ACTIONS(13453),
    [anon_sym_macro] = ACTIONS(13453),
    [anon_sym_where] = ACTIONS(13453),
    [anon_sym_quote] = ACTIONS(13453),
    [anon_sym_let] = ACTIONS(13453),
    [anon_sym_if] = ACTIONS(13453),
    [anon_sym_try] = ACTIONS(13453),
    [anon_sym_for] = ACTIONS(13453),
    [anon_sym_while] = ACTIONS(13453),
    [sym_break_statement] = ACTIONS(13453),
    [sym_continue_statement] = ACTIONS(13453),
    [anon_sym_return] = ACTIONS(13453),
    [anon_sym_const] = ACTIONS(13453),
    [anon_sym_global] = ACTIONS(13453),
    [anon_sym_local] = ACTIONS(13453),
    [anon_sym_LPAREN] = ACTIONS(13453),
    [anon_sym_RPAREN] = ACTIONS(13453),
    [anon_sym_COLON2] = ACTIONS(13453),
    [anon_sym_export] = ACTIONS(13453),
    [anon_sym_import] = ACTIONS(13453),
    [anon_sym_using] = ACTIONS(13453),
    [anon_sym_LBRACK] = ACTIONS(13453),
    [anon_sym_RBRACK] = ACTIONS(13453),
    [anon_sym_LF] = ACTIONS(13455),
    [anon_sym_in] = ACTIONS(13453),
    [anon_sym_LBRACE] = ACTIONS(13453),
    [anon_sym_DOLLAR] = ACTIONS(13453),
    [anon_sym_COLON_COLON] = ACTIONS(13453),
    [anon_sym_isa] = ACTIONS(13453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13453),
    [anon_sym_QMARK] = ACTIONS(13453),
    [anon_sym_AT] = ACTIONS(13453),
    [anon_sym_true] = ACTIONS(13453),
    [anon_sym_false] = ACTIONS(13453),
    [aux_sym_integer_literal_token1] = ACTIONS(13453),
    [aux_sym_integer_literal_token2] = ACTIONS(13453),
    [aux_sym_integer_literal_token3] = ACTIONS(13453),
    [aux_sym_integer_literal_token4] = ACTIONS(13453),
    [aux_sym_float_literal_token1] = ACTIONS(13453),
    [aux_sym_float_literal_token3] = ACTIONS(13453),
    [aux_sym_float_literal_token4] = ACTIONS(13453),
    [sym_character_literal] = ACTIONS(13453),
    [sym__pair_operator] = ACTIONS(13453),
    [sym__arrow_operator] = ACTIONS(13453),
    [sym__lazy_or_operator] = ACTIONS(13453),
    [sym__lazy_and_operator] = ACTIONS(13453),
    [sym__comparison_operator] = ACTIONS(13453),
    [sym__pipe_right_operator] = ACTIONS(13453),
    [sym__pipe_left_operator] = ACTIONS(13453),
    [sym__ellipsis_operator] = ACTIONS(13453),
    [sym__plus_operator] = ACTIONS(13453),
    [sym__times_operator] = ACTIONS(13453),
    [sym__rational_operator] = ACTIONS(13453),
    [sym__bitshift_operator] = ACTIONS(13453),
    [sym__power_operator] = ACTIONS(13453),
    [sym__tilde_operator] = ACTIONS(13453),
    [sym__type_order_operator] = ACTIONS(13453),
    [sym__unary_operator] = ACTIONS(13453),
    [sym__unary_plus_operator] = ACTIONS(13453),
    [aux_sym__terminator_token1] = ACTIONS(13453),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13455),
    [sym__command_start] = ACTIONS(13455),
  },
  [7809] = {
    [ts_builtin_sym_end] = ACTIONS(13459),
    [sym__word_identifier] = ACTIONS(13457),
    [anon_sym_EQ] = ACTIONS(13457),
    [anon_sym_COMMA] = ACTIONS(13457),
    [anon_sym_COLON] = ACTIONS(13457),
    [anon_sym_begin] = ACTIONS(13457),
    [anon_sym_module] = ACTIONS(13457),
    [anon_sym_baremodule] = ACTIONS(13457),
    [anon_sym_abstract] = ACTIONS(13457),
    [anon_sym_primitive] = ACTIONS(13457),
    [anon_sym_mutable] = ACTIONS(13457),
    [anon_sym_struct] = ACTIONS(13457),
    [anon_sym_function] = ACTIONS(13457),
    [anon_sym_macro] = ACTIONS(13457),
    [anon_sym_where] = ACTIONS(13457),
    [anon_sym_quote] = ACTIONS(13457),
    [anon_sym_let] = ACTIONS(13457),
    [anon_sym_if] = ACTIONS(13457),
    [anon_sym_try] = ACTIONS(13457),
    [anon_sym_for] = ACTIONS(13457),
    [anon_sym_while] = ACTIONS(13457),
    [sym_break_statement] = ACTIONS(13457),
    [sym_continue_statement] = ACTIONS(13457),
    [anon_sym_return] = ACTIONS(13457),
    [anon_sym_const] = ACTIONS(13457),
    [anon_sym_global] = ACTIONS(13457),
    [anon_sym_local] = ACTIONS(13457),
    [anon_sym_LPAREN] = ACTIONS(13457),
    [anon_sym_RPAREN] = ACTIONS(13457),
    [anon_sym_COLON2] = ACTIONS(13457),
    [anon_sym_export] = ACTIONS(13457),
    [anon_sym_import] = ACTIONS(13457),
    [anon_sym_using] = ACTIONS(13457),
    [anon_sym_LBRACK] = ACTIONS(13457),
    [anon_sym_RBRACK] = ACTIONS(13457),
    [anon_sym_LF] = ACTIONS(13459),
    [anon_sym_in] = ACTIONS(13457),
    [anon_sym_LBRACE] = ACTIONS(13457),
    [anon_sym_DOLLAR] = ACTIONS(13457),
    [anon_sym_COLON_COLON] = ACTIONS(13457),
    [anon_sym_isa] = ACTIONS(13457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13457),
    [anon_sym_QMARK] = ACTIONS(13457),
    [anon_sym_AT] = ACTIONS(13457),
    [anon_sym_true] = ACTIONS(13457),
    [anon_sym_false] = ACTIONS(13457),
    [aux_sym_integer_literal_token1] = ACTIONS(13457),
    [aux_sym_integer_literal_token2] = ACTIONS(13457),
    [aux_sym_integer_literal_token3] = ACTIONS(13457),
    [aux_sym_integer_literal_token4] = ACTIONS(13457),
    [aux_sym_float_literal_token1] = ACTIONS(13457),
    [aux_sym_float_literal_token3] = ACTIONS(13457),
    [aux_sym_float_literal_token4] = ACTIONS(13457),
    [sym_character_literal] = ACTIONS(13457),
    [sym__pair_operator] = ACTIONS(13457),
    [sym__arrow_operator] = ACTIONS(13457),
    [sym__lazy_or_operator] = ACTIONS(13457),
    [sym__lazy_and_operator] = ACTIONS(13457),
    [sym__comparison_operator] = ACTIONS(13457),
    [sym__pipe_right_operator] = ACTIONS(13457),
    [sym__pipe_left_operator] = ACTIONS(13457),
    [sym__ellipsis_operator] = ACTIONS(13457),
    [sym__plus_operator] = ACTIONS(13457),
    [sym__times_operator] = ACTIONS(13457),
    [sym__rational_operator] = ACTIONS(13457),
    [sym__bitshift_operator] = ACTIONS(13457),
    [sym__power_operator] = ACTIONS(13457),
    [sym__tilde_operator] = ACTIONS(13457),
    [sym__type_order_operator] = ACTIONS(13457),
    [sym__unary_operator] = ACTIONS(13457),
    [sym__unary_plus_operator] = ACTIONS(13457),
    [aux_sym__terminator_token1] = ACTIONS(13457),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13459),
    [sym__command_start] = ACTIONS(13459),
  },
  [7810] = {
    [sym__comprehension_clause] = STATE(18386),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16881),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14068),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14070),
    [anon_sym_LF] = ACTIONS(14072),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14075),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7811] = {
    [ts_builtin_sym_end] = ACTIONS(13463),
    [sym__word_identifier] = ACTIONS(13461),
    [anon_sym_EQ] = ACTIONS(13461),
    [anon_sym_COMMA] = ACTIONS(13461),
    [anon_sym_COLON] = ACTIONS(13461),
    [anon_sym_begin] = ACTIONS(13461),
    [anon_sym_module] = ACTIONS(13461),
    [anon_sym_baremodule] = ACTIONS(13461),
    [anon_sym_abstract] = ACTIONS(13461),
    [anon_sym_primitive] = ACTIONS(13461),
    [anon_sym_mutable] = ACTIONS(13461),
    [anon_sym_struct] = ACTIONS(13461),
    [anon_sym_function] = ACTIONS(13461),
    [anon_sym_macro] = ACTIONS(13461),
    [anon_sym_where] = ACTIONS(13461),
    [anon_sym_quote] = ACTIONS(13461),
    [anon_sym_let] = ACTIONS(13461),
    [anon_sym_if] = ACTIONS(13461),
    [anon_sym_try] = ACTIONS(13461),
    [anon_sym_for] = ACTIONS(13461),
    [anon_sym_while] = ACTIONS(13461),
    [sym_break_statement] = ACTIONS(13461),
    [sym_continue_statement] = ACTIONS(13461),
    [anon_sym_return] = ACTIONS(13461),
    [anon_sym_const] = ACTIONS(13461),
    [anon_sym_global] = ACTIONS(13461),
    [anon_sym_local] = ACTIONS(13461),
    [anon_sym_LPAREN] = ACTIONS(13461),
    [anon_sym_RPAREN] = ACTIONS(13461),
    [anon_sym_COLON2] = ACTIONS(13461),
    [anon_sym_export] = ACTIONS(13461),
    [anon_sym_import] = ACTIONS(13461),
    [anon_sym_using] = ACTIONS(13461),
    [anon_sym_LBRACK] = ACTIONS(13461),
    [anon_sym_RBRACK] = ACTIONS(13461),
    [anon_sym_LF] = ACTIONS(13463),
    [anon_sym_in] = ACTIONS(13461),
    [anon_sym_LBRACE] = ACTIONS(13461),
    [anon_sym_DOLLAR] = ACTIONS(13461),
    [anon_sym_COLON_COLON] = ACTIONS(13461),
    [anon_sym_isa] = ACTIONS(13461),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13461),
    [anon_sym_QMARK] = ACTIONS(13461),
    [anon_sym_AT] = ACTIONS(13461),
    [anon_sym_true] = ACTIONS(13461),
    [anon_sym_false] = ACTIONS(13461),
    [aux_sym_integer_literal_token1] = ACTIONS(13461),
    [aux_sym_integer_literal_token2] = ACTIONS(13461),
    [aux_sym_integer_literal_token3] = ACTIONS(13461),
    [aux_sym_integer_literal_token4] = ACTIONS(13461),
    [aux_sym_float_literal_token1] = ACTIONS(13461),
    [aux_sym_float_literal_token3] = ACTIONS(13461),
    [aux_sym_float_literal_token4] = ACTIONS(13461),
    [sym_character_literal] = ACTIONS(13461),
    [sym__pair_operator] = ACTIONS(13461),
    [sym__arrow_operator] = ACTIONS(13461),
    [sym__lazy_or_operator] = ACTIONS(13461),
    [sym__lazy_and_operator] = ACTIONS(13461),
    [sym__comparison_operator] = ACTIONS(13461),
    [sym__pipe_right_operator] = ACTIONS(13461),
    [sym__pipe_left_operator] = ACTIONS(13461),
    [sym__ellipsis_operator] = ACTIONS(13461),
    [sym__plus_operator] = ACTIONS(13461),
    [sym__times_operator] = ACTIONS(13461),
    [sym__rational_operator] = ACTIONS(13461),
    [sym__bitshift_operator] = ACTIONS(13461),
    [sym__power_operator] = ACTIONS(13461),
    [sym__tilde_operator] = ACTIONS(13461),
    [sym__type_order_operator] = ACTIONS(13461),
    [sym__unary_operator] = ACTIONS(13461),
    [sym__unary_plus_operator] = ACTIONS(13461),
    [aux_sym__terminator_token1] = ACTIONS(13461),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13463),
    [sym__command_start] = ACTIONS(13463),
  },
  [7812] = {
    [ts_builtin_sym_end] = ACTIONS(13483),
    [sym__word_identifier] = ACTIONS(13481),
    [anon_sym_EQ] = ACTIONS(13481),
    [anon_sym_COMMA] = ACTIONS(13481),
    [anon_sym_COLON] = ACTIONS(13481),
    [anon_sym_begin] = ACTIONS(13481),
    [anon_sym_module] = ACTIONS(13481),
    [anon_sym_baremodule] = ACTIONS(13481),
    [anon_sym_abstract] = ACTIONS(13481),
    [anon_sym_primitive] = ACTIONS(13481),
    [anon_sym_mutable] = ACTIONS(13481),
    [anon_sym_struct] = ACTIONS(13481),
    [anon_sym_function] = ACTIONS(13481),
    [anon_sym_macro] = ACTIONS(13481),
    [anon_sym_where] = ACTIONS(13481),
    [anon_sym_quote] = ACTIONS(13481),
    [anon_sym_let] = ACTIONS(13481),
    [anon_sym_if] = ACTIONS(13481),
    [anon_sym_try] = ACTIONS(13481),
    [anon_sym_for] = ACTIONS(13481),
    [anon_sym_while] = ACTIONS(13481),
    [sym_break_statement] = ACTIONS(13481),
    [sym_continue_statement] = ACTIONS(13481),
    [anon_sym_return] = ACTIONS(13481),
    [anon_sym_const] = ACTIONS(13481),
    [anon_sym_global] = ACTIONS(13481),
    [anon_sym_local] = ACTIONS(13481),
    [anon_sym_LPAREN] = ACTIONS(13481),
    [anon_sym_RPAREN] = ACTIONS(13481),
    [anon_sym_COLON2] = ACTIONS(13481),
    [anon_sym_export] = ACTIONS(13481),
    [anon_sym_import] = ACTIONS(13481),
    [anon_sym_using] = ACTIONS(13481),
    [anon_sym_LBRACK] = ACTIONS(13481),
    [anon_sym_RBRACK] = ACTIONS(13481),
    [anon_sym_LF] = ACTIONS(13483),
    [anon_sym_in] = ACTIONS(13481),
    [anon_sym_LBRACE] = ACTIONS(13481),
    [anon_sym_DOLLAR] = ACTIONS(13481),
    [anon_sym_COLON_COLON] = ACTIONS(13481),
    [anon_sym_isa] = ACTIONS(13481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13481),
    [anon_sym_QMARK] = ACTIONS(13481),
    [anon_sym_AT] = ACTIONS(13481),
    [anon_sym_true] = ACTIONS(13481),
    [anon_sym_false] = ACTIONS(13481),
    [aux_sym_integer_literal_token1] = ACTIONS(13481),
    [aux_sym_integer_literal_token2] = ACTIONS(13481),
    [aux_sym_integer_literal_token3] = ACTIONS(13481),
    [aux_sym_integer_literal_token4] = ACTIONS(13481),
    [aux_sym_float_literal_token1] = ACTIONS(13481),
    [aux_sym_float_literal_token3] = ACTIONS(13481),
    [aux_sym_float_literal_token4] = ACTIONS(13481),
    [sym_character_literal] = ACTIONS(13481),
    [sym__pair_operator] = ACTIONS(13481),
    [sym__arrow_operator] = ACTIONS(13481),
    [sym__lazy_or_operator] = ACTIONS(13481),
    [sym__lazy_and_operator] = ACTIONS(13481),
    [sym__comparison_operator] = ACTIONS(13481),
    [sym__pipe_right_operator] = ACTIONS(13481),
    [sym__pipe_left_operator] = ACTIONS(13481),
    [sym__ellipsis_operator] = ACTIONS(13481),
    [sym__plus_operator] = ACTIONS(13481),
    [sym__times_operator] = ACTIONS(13481),
    [sym__rational_operator] = ACTIONS(13481),
    [sym__bitshift_operator] = ACTIONS(13481),
    [sym__power_operator] = ACTIONS(13481),
    [sym__tilde_operator] = ACTIONS(13481),
    [sym__type_order_operator] = ACTIONS(13481),
    [sym__unary_operator] = ACTIONS(13481),
    [sym__unary_plus_operator] = ACTIONS(13481),
    [aux_sym__terminator_token1] = ACTIONS(13481),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13483),
    [sym__command_start] = ACTIONS(13483),
  },
  [7813] = {
    [ts_builtin_sym_end] = ACTIONS(13487),
    [sym__word_identifier] = ACTIONS(13485),
    [anon_sym_EQ] = ACTIONS(13485),
    [anon_sym_COMMA] = ACTIONS(13485),
    [anon_sym_COLON] = ACTIONS(13485),
    [anon_sym_begin] = ACTIONS(13485),
    [anon_sym_module] = ACTIONS(13485),
    [anon_sym_baremodule] = ACTIONS(13485),
    [anon_sym_abstract] = ACTIONS(13485),
    [anon_sym_primitive] = ACTIONS(13485),
    [anon_sym_mutable] = ACTIONS(13485),
    [anon_sym_struct] = ACTIONS(13485),
    [anon_sym_function] = ACTIONS(13485),
    [anon_sym_macro] = ACTIONS(13485),
    [anon_sym_where] = ACTIONS(13485),
    [anon_sym_quote] = ACTIONS(13485),
    [anon_sym_let] = ACTIONS(13485),
    [anon_sym_if] = ACTIONS(13485),
    [anon_sym_try] = ACTIONS(13485),
    [anon_sym_for] = ACTIONS(13485),
    [anon_sym_while] = ACTIONS(13485),
    [sym_break_statement] = ACTIONS(13485),
    [sym_continue_statement] = ACTIONS(13485),
    [anon_sym_return] = ACTIONS(13485),
    [anon_sym_const] = ACTIONS(13485),
    [anon_sym_global] = ACTIONS(13485),
    [anon_sym_local] = ACTIONS(13485),
    [anon_sym_LPAREN] = ACTIONS(13485),
    [anon_sym_RPAREN] = ACTIONS(13485),
    [anon_sym_COLON2] = ACTIONS(13485),
    [anon_sym_export] = ACTIONS(13485),
    [anon_sym_import] = ACTIONS(13485),
    [anon_sym_using] = ACTIONS(13485),
    [anon_sym_LBRACK] = ACTIONS(13485),
    [anon_sym_RBRACK] = ACTIONS(13485),
    [anon_sym_LF] = ACTIONS(13487),
    [anon_sym_in] = ACTIONS(13485),
    [anon_sym_LBRACE] = ACTIONS(13485),
    [anon_sym_DOLLAR] = ACTIONS(13485),
    [anon_sym_COLON_COLON] = ACTIONS(13485),
    [anon_sym_isa] = ACTIONS(13485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13485),
    [anon_sym_QMARK] = ACTIONS(13485),
    [anon_sym_AT] = ACTIONS(13485),
    [anon_sym_true] = ACTIONS(13485),
    [anon_sym_false] = ACTIONS(13485),
    [aux_sym_integer_literal_token1] = ACTIONS(13485),
    [aux_sym_integer_literal_token2] = ACTIONS(13485),
    [aux_sym_integer_literal_token3] = ACTIONS(13485),
    [aux_sym_integer_literal_token4] = ACTIONS(13485),
    [aux_sym_float_literal_token1] = ACTIONS(13485),
    [aux_sym_float_literal_token3] = ACTIONS(13485),
    [aux_sym_float_literal_token4] = ACTIONS(13485),
    [sym_character_literal] = ACTIONS(13485),
    [sym__pair_operator] = ACTIONS(13485),
    [sym__arrow_operator] = ACTIONS(13485),
    [sym__lazy_or_operator] = ACTIONS(13485),
    [sym__lazy_and_operator] = ACTIONS(13485),
    [sym__comparison_operator] = ACTIONS(13485),
    [sym__pipe_right_operator] = ACTIONS(13485),
    [sym__pipe_left_operator] = ACTIONS(13485),
    [sym__ellipsis_operator] = ACTIONS(13485),
    [sym__plus_operator] = ACTIONS(13485),
    [sym__times_operator] = ACTIONS(13485),
    [sym__rational_operator] = ACTIONS(13485),
    [sym__bitshift_operator] = ACTIONS(13485),
    [sym__power_operator] = ACTIONS(13485),
    [sym__tilde_operator] = ACTIONS(13485),
    [sym__type_order_operator] = ACTIONS(13485),
    [sym__unary_operator] = ACTIONS(13485),
    [sym__unary_plus_operator] = ACTIONS(13485),
    [aux_sym__terminator_token1] = ACTIONS(13485),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13487),
    [sym__command_start] = ACTIONS(13487),
  },
  [7814] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7815] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_finally] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [7816] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_catch] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7817] = {
    [sym__comprehension_clause] = STATE(18742),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17281),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14078),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14080),
    [anon_sym_LF] = ACTIONS(14082),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14085),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7818] = {
    [ts_builtin_sym_end] = ACTIONS(12972),
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(12974),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_RPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_RBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [7819] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11890),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11890),
    [anon_sym_RPAREN] = ACTIONS(11890),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11890),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11890),
    [anon_sym_RBRACE] = ACTIONS(11890),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11890),
    [anon_sym_COLON_COLON] = ACTIONS(11890),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11890),
    [anon_sym_QMARK] = ACTIONS(11890),
    [anon_sym_AT] = ACTIONS(11890),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11890),
    [aux_sym_integer_literal_token2] = ACTIONS(11890),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11890),
    [aux_sym_float_literal_token3] = ACTIONS(11890),
    [aux_sym_float_literal_token4] = ACTIONS(11890),
    [sym_character_literal] = ACTIONS(11890),
    [sym__pair_operator] = ACTIONS(11890),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11890),
    [sym__lazy_and_operator] = ACTIONS(11890),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11890),
    [sym__pipe_left_operator] = ACTIONS(11890),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11890),
    [sym__bitshift_operator] = ACTIONS(11890),
    [sym__power_operator] = ACTIONS(11890),
    [sym__tilde_operator] = ACTIONS(11890),
    [sym__type_order_operator] = ACTIONS(11890),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [7820] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12096),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12096),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12096),
    [sym__bitshift_operator] = ACTIONS(12096),
    [sym__power_operator] = ACTIONS(12096),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7821] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_DOLLAR] = ACTIONS(12096),
    [anon_sym_COLON_COLON] = ACTIONS(12096),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_AT] = ACTIONS(12096),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12096),
    [aux_sym_integer_literal_token2] = ACTIONS(12096),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13132),
    [aux_sym_float_literal_token3] = ACTIONS(12096),
    [aux_sym_float_literal_token4] = ACTIONS(12096),
    [sym_character_literal] = ACTIONS(12096),
    [sym__pair_operator] = ACTIONS(12096),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12096),
    [sym__lazy_and_operator] = ACTIONS(12096),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12096),
    [sym__pipe_left_operator] = ACTIONS(12096),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12096),
    [sym__bitshift_operator] = ACTIONS(12096),
    [sym__power_operator] = ACTIONS(12096),
    [sym__tilde_operator] = ACTIONS(12096),
    [sym__type_order_operator] = ACTIONS(12096),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7822] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12386),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12386),
    [anon_sym_RPAREN] = ACTIONS(12386),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12386),
    [anon_sym_RBRACK] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_SEMI] = ACTIONS(12386),
    [anon_sym_LBRACE] = ACTIONS(12386),
    [anon_sym_RBRACE] = ACTIONS(12386),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12386),
    [anon_sym_COLON_COLON] = ACTIONS(12386),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12386),
    [anon_sym_QMARK] = ACTIONS(12386),
    [anon_sym_AT] = ACTIONS(12386),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12386),
    [aux_sym_integer_literal_token2] = ACTIONS(12386),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12386),
    [aux_sym_float_literal_token3] = ACTIONS(12386),
    [aux_sym_float_literal_token4] = ACTIONS(12386),
    [sym_character_literal] = ACTIONS(12386),
    [sym__pair_operator] = ACTIONS(12386),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12386),
    [sym__lazy_and_operator] = ACTIONS(12386),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12386),
    [sym__pipe_left_operator] = ACTIONS(12386),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12386),
    [sym__power_operator] = ACTIONS(12386),
    [sym__tilde_operator] = ACTIONS(12386),
    [sym__type_order_operator] = ACTIONS(12386),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [7823] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_DOLLAR] = ACTIONS(2188),
    [anon_sym_COLON_COLON] = ACTIONS(2188),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2188),
    [anon_sym_QMARK] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2188),
    [aux_sym_integer_literal_token2] = ACTIONS(2188),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2188),
    [aux_sym_float_literal_token3] = ACTIONS(2188),
    [aux_sym_float_literal_token4] = ACTIONS(2188),
    [sym_character_literal] = ACTIONS(2188),
    [sym__pair_operator] = ACTIONS(2188),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2188),
    [sym__lazy_and_operator] = ACTIONS(2188),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2188),
    [sym__pipe_left_operator] = ACTIONS(2188),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2188),
    [sym__bitshift_operator] = ACTIONS(2188),
    [sym__power_operator] = ACTIONS(2188),
    [sym__tilde_operator] = ACTIONS(2188),
    [sym__type_order_operator] = ACTIONS(2188),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7824] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_finally] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7825] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12324),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12324),
    [anon_sym_RPAREN] = ACTIONS(12324),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12324),
    [anon_sym_RBRACK] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_SEMI] = ACTIONS(12324),
    [anon_sym_LBRACE] = ACTIONS(12324),
    [anon_sym_RBRACE] = ACTIONS(12324),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12324),
    [anon_sym_COLON_COLON] = ACTIONS(12324),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12324),
    [anon_sym_QMARK] = ACTIONS(12324),
    [anon_sym_AT] = ACTIONS(12324),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12324),
    [aux_sym_integer_literal_token2] = ACTIONS(12324),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12324),
    [aux_sym_float_literal_token3] = ACTIONS(12324),
    [aux_sym_float_literal_token4] = ACTIONS(12324),
    [sym_character_literal] = ACTIONS(12324),
    [sym__pair_operator] = ACTIONS(12324),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12324),
    [sym__lazy_and_operator] = ACTIONS(12324),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12324),
    [sym__pipe_left_operator] = ACTIONS(12324),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12324),
    [sym__bitshift_operator] = ACTIONS(12324),
    [sym__power_operator] = ACTIONS(12324),
    [sym__tilde_operator] = ACTIONS(12324),
    [sym__type_order_operator] = ACTIONS(12324),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [7826] = {
    [ts_builtin_sym_end] = ACTIONS(12979),
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_RPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_RBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [7827] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11938),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7828] = {
    [sym__comprehension_clause] = STATE(19045),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16809),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14088),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14090),
    [anon_sym_LF] = ACTIONS(14092),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14095),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7829] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12336),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12336),
    [anon_sym_RPAREN] = ACTIONS(12336),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12336),
    [anon_sym_RBRACK] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_SEMI] = ACTIONS(12336),
    [anon_sym_LBRACE] = ACTIONS(12336),
    [anon_sym_RBRACE] = ACTIONS(12336),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12336),
    [anon_sym_COLON_COLON] = ACTIONS(12336),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12336),
    [anon_sym_QMARK] = ACTIONS(12336),
    [anon_sym_AT] = ACTIONS(12336),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12336),
    [aux_sym_integer_literal_token2] = ACTIONS(12336),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12336),
    [aux_sym_float_literal_token3] = ACTIONS(12336),
    [aux_sym_float_literal_token4] = ACTIONS(12336),
    [sym_character_literal] = ACTIONS(12336),
    [sym__pair_operator] = ACTIONS(12336),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12336),
    [sym__lazy_and_operator] = ACTIONS(12336),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12336),
    [sym__pipe_left_operator] = ACTIONS(12336),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12336),
    [sym__bitshift_operator] = ACTIONS(12336),
    [sym__power_operator] = ACTIONS(12336),
    [sym__tilde_operator] = ACTIONS(12336),
    [sym__type_order_operator] = ACTIONS(12336),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [7830] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(13748),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7831] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12390),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12390),
    [anon_sym_RPAREN] = ACTIONS(12390),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12390),
    [anon_sym_RBRACK] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_SEMI] = ACTIONS(12390),
    [anon_sym_LBRACE] = ACTIONS(12390),
    [anon_sym_RBRACE] = ACTIONS(12390),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12390),
    [anon_sym_COLON_COLON] = ACTIONS(12390),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12390),
    [anon_sym_QMARK] = ACTIONS(12390),
    [anon_sym_AT] = ACTIONS(12390),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12390),
    [aux_sym_integer_literal_token2] = ACTIONS(12390),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12390),
    [aux_sym_float_literal_token3] = ACTIONS(12390),
    [aux_sym_float_literal_token4] = ACTIONS(12390),
    [sym_character_literal] = ACTIONS(12390),
    [sym__pair_operator] = ACTIONS(12390),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12390),
    [sym__lazy_and_operator] = ACTIONS(12390),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12390),
    [sym__pipe_left_operator] = ACTIONS(12390),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12390),
    [sym__bitshift_operator] = ACTIONS(12390),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(12390),
    [sym__type_order_operator] = ACTIONS(12390),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [7832] = {
    [ts_builtin_sym_end] = ACTIONS(13491),
    [sym__word_identifier] = ACTIONS(13489),
    [anon_sym_EQ] = ACTIONS(13489),
    [anon_sym_COMMA] = ACTIONS(13489),
    [anon_sym_COLON] = ACTIONS(13489),
    [anon_sym_begin] = ACTIONS(13489),
    [anon_sym_module] = ACTIONS(13489),
    [anon_sym_baremodule] = ACTIONS(13489),
    [anon_sym_abstract] = ACTIONS(13489),
    [anon_sym_primitive] = ACTIONS(13489),
    [anon_sym_mutable] = ACTIONS(13489),
    [anon_sym_struct] = ACTIONS(13489),
    [anon_sym_function] = ACTIONS(13489),
    [anon_sym_macro] = ACTIONS(13489),
    [anon_sym_where] = ACTIONS(13489),
    [anon_sym_quote] = ACTIONS(13489),
    [anon_sym_let] = ACTIONS(13489),
    [anon_sym_if] = ACTIONS(13489),
    [anon_sym_try] = ACTIONS(13489),
    [anon_sym_for] = ACTIONS(13489),
    [anon_sym_while] = ACTIONS(13489),
    [sym_break_statement] = ACTIONS(13489),
    [sym_continue_statement] = ACTIONS(13489),
    [anon_sym_return] = ACTIONS(13489),
    [anon_sym_const] = ACTIONS(13489),
    [anon_sym_global] = ACTIONS(13489),
    [anon_sym_local] = ACTIONS(13489),
    [anon_sym_LPAREN] = ACTIONS(13489),
    [anon_sym_RPAREN] = ACTIONS(13489),
    [anon_sym_COLON2] = ACTIONS(13489),
    [anon_sym_export] = ACTIONS(13489),
    [anon_sym_import] = ACTIONS(13489),
    [anon_sym_using] = ACTIONS(13489),
    [anon_sym_LBRACK] = ACTIONS(13489),
    [anon_sym_RBRACK] = ACTIONS(13489),
    [anon_sym_LF] = ACTIONS(13491),
    [anon_sym_in] = ACTIONS(13489),
    [anon_sym_LBRACE] = ACTIONS(13489),
    [anon_sym_DOLLAR] = ACTIONS(13489),
    [anon_sym_COLON_COLON] = ACTIONS(13489),
    [anon_sym_isa] = ACTIONS(13489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13489),
    [anon_sym_QMARK] = ACTIONS(13489),
    [anon_sym_AT] = ACTIONS(13489),
    [anon_sym_true] = ACTIONS(13489),
    [anon_sym_false] = ACTIONS(13489),
    [aux_sym_integer_literal_token1] = ACTIONS(13489),
    [aux_sym_integer_literal_token2] = ACTIONS(13489),
    [aux_sym_integer_literal_token3] = ACTIONS(13489),
    [aux_sym_integer_literal_token4] = ACTIONS(13489),
    [aux_sym_float_literal_token1] = ACTIONS(13489),
    [aux_sym_float_literal_token3] = ACTIONS(13489),
    [aux_sym_float_literal_token4] = ACTIONS(13489),
    [sym_character_literal] = ACTIONS(13489),
    [sym__pair_operator] = ACTIONS(13489),
    [sym__arrow_operator] = ACTIONS(13489),
    [sym__lazy_or_operator] = ACTIONS(13489),
    [sym__lazy_and_operator] = ACTIONS(13489),
    [sym__comparison_operator] = ACTIONS(13489),
    [sym__pipe_right_operator] = ACTIONS(13489),
    [sym__pipe_left_operator] = ACTIONS(13489),
    [sym__ellipsis_operator] = ACTIONS(13489),
    [sym__plus_operator] = ACTIONS(13489),
    [sym__times_operator] = ACTIONS(13489),
    [sym__rational_operator] = ACTIONS(13489),
    [sym__bitshift_operator] = ACTIONS(13489),
    [sym__power_operator] = ACTIONS(13489),
    [sym__tilde_operator] = ACTIONS(13489),
    [sym__type_order_operator] = ACTIONS(13489),
    [sym__unary_operator] = ACTIONS(13489),
    [sym__unary_plus_operator] = ACTIONS(13489),
    [aux_sym__terminator_token1] = ACTIONS(13489),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13491),
    [sym__command_start] = ACTIONS(13491),
  },
  [7833] = {
    [ts_builtin_sym_end] = ACTIONS(13495),
    [sym__word_identifier] = ACTIONS(13493),
    [anon_sym_EQ] = ACTIONS(13493),
    [anon_sym_COMMA] = ACTIONS(13493),
    [anon_sym_COLON] = ACTIONS(13493),
    [anon_sym_begin] = ACTIONS(13493),
    [anon_sym_module] = ACTIONS(13493),
    [anon_sym_baremodule] = ACTIONS(13493),
    [anon_sym_abstract] = ACTIONS(13493),
    [anon_sym_primitive] = ACTIONS(13493),
    [anon_sym_mutable] = ACTIONS(13493),
    [anon_sym_struct] = ACTIONS(13493),
    [anon_sym_function] = ACTIONS(13493),
    [anon_sym_macro] = ACTIONS(13493),
    [anon_sym_where] = ACTIONS(13493),
    [anon_sym_quote] = ACTIONS(13493),
    [anon_sym_let] = ACTIONS(13493),
    [anon_sym_if] = ACTIONS(13493),
    [anon_sym_try] = ACTIONS(13493),
    [anon_sym_for] = ACTIONS(13493),
    [anon_sym_while] = ACTIONS(13493),
    [sym_break_statement] = ACTIONS(13493),
    [sym_continue_statement] = ACTIONS(13493),
    [anon_sym_return] = ACTIONS(13493),
    [anon_sym_const] = ACTIONS(13493),
    [anon_sym_global] = ACTIONS(13493),
    [anon_sym_local] = ACTIONS(13493),
    [anon_sym_LPAREN] = ACTIONS(13493),
    [anon_sym_RPAREN] = ACTIONS(13493),
    [anon_sym_COLON2] = ACTIONS(13493),
    [anon_sym_export] = ACTIONS(13493),
    [anon_sym_import] = ACTIONS(13493),
    [anon_sym_using] = ACTIONS(13493),
    [anon_sym_LBRACK] = ACTIONS(13493),
    [anon_sym_RBRACK] = ACTIONS(13493),
    [anon_sym_LF] = ACTIONS(13495),
    [anon_sym_in] = ACTIONS(13493),
    [anon_sym_LBRACE] = ACTIONS(13493),
    [anon_sym_DOLLAR] = ACTIONS(13493),
    [anon_sym_COLON_COLON] = ACTIONS(13493),
    [anon_sym_isa] = ACTIONS(13493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13493),
    [anon_sym_QMARK] = ACTIONS(13493),
    [anon_sym_AT] = ACTIONS(13493),
    [anon_sym_true] = ACTIONS(13493),
    [anon_sym_false] = ACTIONS(13493),
    [aux_sym_integer_literal_token1] = ACTIONS(13493),
    [aux_sym_integer_literal_token2] = ACTIONS(13493),
    [aux_sym_integer_literal_token3] = ACTIONS(13493),
    [aux_sym_integer_literal_token4] = ACTIONS(13493),
    [aux_sym_float_literal_token1] = ACTIONS(13493),
    [aux_sym_float_literal_token3] = ACTIONS(13493),
    [aux_sym_float_literal_token4] = ACTIONS(13493),
    [sym_character_literal] = ACTIONS(13493),
    [sym__pair_operator] = ACTIONS(13493),
    [sym__arrow_operator] = ACTIONS(13493),
    [sym__lazy_or_operator] = ACTIONS(13493),
    [sym__lazy_and_operator] = ACTIONS(13493),
    [sym__comparison_operator] = ACTIONS(13493),
    [sym__pipe_right_operator] = ACTIONS(13493),
    [sym__pipe_left_operator] = ACTIONS(13493),
    [sym__ellipsis_operator] = ACTIONS(13493),
    [sym__plus_operator] = ACTIONS(13493),
    [sym__times_operator] = ACTIONS(13493),
    [sym__rational_operator] = ACTIONS(13493),
    [sym__bitshift_operator] = ACTIONS(13493),
    [sym__power_operator] = ACTIONS(13493),
    [sym__tilde_operator] = ACTIONS(13493),
    [sym__type_order_operator] = ACTIONS(13493),
    [sym__unary_operator] = ACTIONS(13493),
    [sym__unary_plus_operator] = ACTIONS(13493),
    [aux_sym__terminator_token1] = ACTIONS(13493),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13495),
    [sym__command_start] = ACTIONS(13495),
  },
  [7834] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_finally] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13134),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [7835] = {
    [ts_builtin_sym_end] = ACTIONS(13199),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(12418),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_RPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_RBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [7836] = {
    [aux_sym_open_tuple_repeat1] = STATE(7068),
    [ts_builtin_sym_end] = ACTIONS(13199),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_RPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_RBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [7837] = {
    [ts_builtin_sym_end] = ACTIONS(13501),
    [sym__word_identifier] = ACTIONS(13499),
    [anon_sym_EQ] = ACTIONS(13499),
    [anon_sym_COMMA] = ACTIONS(13499),
    [anon_sym_COLON] = ACTIONS(13499),
    [anon_sym_begin] = ACTIONS(13499),
    [anon_sym_module] = ACTIONS(13499),
    [anon_sym_baremodule] = ACTIONS(13499),
    [anon_sym_abstract] = ACTIONS(13499),
    [anon_sym_primitive] = ACTIONS(13499),
    [anon_sym_mutable] = ACTIONS(13499),
    [anon_sym_struct] = ACTIONS(13499),
    [anon_sym_function] = ACTIONS(13499),
    [anon_sym_macro] = ACTIONS(13499),
    [anon_sym_where] = ACTIONS(13499),
    [anon_sym_quote] = ACTIONS(13499),
    [anon_sym_let] = ACTIONS(13499),
    [anon_sym_if] = ACTIONS(13499),
    [anon_sym_try] = ACTIONS(13499),
    [anon_sym_for] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(13499),
    [sym_break_statement] = ACTIONS(13499),
    [sym_continue_statement] = ACTIONS(13499),
    [anon_sym_return] = ACTIONS(13499),
    [anon_sym_const] = ACTIONS(13499),
    [anon_sym_global] = ACTIONS(13499),
    [anon_sym_local] = ACTIONS(13499),
    [anon_sym_LPAREN] = ACTIONS(13499),
    [anon_sym_RPAREN] = ACTIONS(13499),
    [anon_sym_COLON2] = ACTIONS(13499),
    [anon_sym_export] = ACTIONS(13499),
    [anon_sym_import] = ACTIONS(13499),
    [anon_sym_using] = ACTIONS(13499),
    [anon_sym_LBRACK] = ACTIONS(13499),
    [anon_sym_RBRACK] = ACTIONS(13499),
    [anon_sym_LF] = ACTIONS(13501),
    [anon_sym_in] = ACTIONS(13499),
    [anon_sym_LBRACE] = ACTIONS(13499),
    [anon_sym_DOLLAR] = ACTIONS(13499),
    [anon_sym_COLON_COLON] = ACTIONS(13499),
    [anon_sym_isa] = ACTIONS(13499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13499),
    [anon_sym_QMARK] = ACTIONS(13499),
    [anon_sym_AT] = ACTIONS(13499),
    [anon_sym_true] = ACTIONS(13499),
    [anon_sym_false] = ACTIONS(13499),
    [aux_sym_integer_literal_token1] = ACTIONS(13499),
    [aux_sym_integer_literal_token2] = ACTIONS(13499),
    [aux_sym_integer_literal_token3] = ACTIONS(13499),
    [aux_sym_integer_literal_token4] = ACTIONS(13499),
    [aux_sym_float_literal_token1] = ACTIONS(13499),
    [aux_sym_float_literal_token3] = ACTIONS(13499),
    [aux_sym_float_literal_token4] = ACTIONS(13499),
    [sym_character_literal] = ACTIONS(13499),
    [sym__pair_operator] = ACTIONS(13499),
    [sym__arrow_operator] = ACTIONS(13499),
    [sym__lazy_or_operator] = ACTIONS(13499),
    [sym__lazy_and_operator] = ACTIONS(13499),
    [sym__comparison_operator] = ACTIONS(13499),
    [sym__pipe_right_operator] = ACTIONS(13499),
    [sym__pipe_left_operator] = ACTIONS(13499),
    [sym__ellipsis_operator] = ACTIONS(13499),
    [sym__plus_operator] = ACTIONS(13499),
    [sym__times_operator] = ACTIONS(13499),
    [sym__rational_operator] = ACTIONS(13499),
    [sym__bitshift_operator] = ACTIONS(13499),
    [sym__power_operator] = ACTIONS(13499),
    [sym__tilde_operator] = ACTIONS(13499),
    [sym__type_order_operator] = ACTIONS(13499),
    [sym__unary_operator] = ACTIONS(13499),
    [sym__unary_plus_operator] = ACTIONS(13499),
    [aux_sym__terminator_token1] = ACTIONS(13499),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13501),
    [sym__command_start] = ACTIONS(13501),
  },
  [7838] = {
    [sym__comprehension_clause] = STATE(19385),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16839),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14098),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14100),
    [anon_sym_LF] = ACTIONS(14102),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14105),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7839] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_catch] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7840] = {
    [ts_builtin_sym_end] = ACTIONS(13508),
    [sym__word_identifier] = ACTIONS(13506),
    [anon_sym_EQ] = ACTIONS(13506),
    [anon_sym_COMMA] = ACTIONS(13506),
    [anon_sym_COLON] = ACTIONS(13506),
    [anon_sym_begin] = ACTIONS(13506),
    [anon_sym_module] = ACTIONS(13506),
    [anon_sym_baremodule] = ACTIONS(13506),
    [anon_sym_abstract] = ACTIONS(13506),
    [anon_sym_primitive] = ACTIONS(13506),
    [anon_sym_mutable] = ACTIONS(13506),
    [anon_sym_struct] = ACTIONS(13506),
    [anon_sym_function] = ACTIONS(13506),
    [anon_sym_macro] = ACTIONS(13506),
    [anon_sym_where] = ACTIONS(13506),
    [anon_sym_quote] = ACTIONS(13506),
    [anon_sym_let] = ACTIONS(13506),
    [anon_sym_if] = ACTIONS(13506),
    [anon_sym_try] = ACTIONS(13506),
    [anon_sym_for] = ACTIONS(13506),
    [anon_sym_while] = ACTIONS(13506),
    [sym_break_statement] = ACTIONS(13506),
    [sym_continue_statement] = ACTIONS(13506),
    [anon_sym_return] = ACTIONS(13506),
    [anon_sym_const] = ACTIONS(13506),
    [anon_sym_global] = ACTIONS(13506),
    [anon_sym_local] = ACTIONS(13506),
    [anon_sym_LPAREN] = ACTIONS(13506),
    [anon_sym_RPAREN] = ACTIONS(13506),
    [anon_sym_COLON2] = ACTIONS(13506),
    [anon_sym_export] = ACTIONS(13506),
    [anon_sym_import] = ACTIONS(13506),
    [anon_sym_using] = ACTIONS(13506),
    [anon_sym_LBRACK] = ACTIONS(13506),
    [anon_sym_RBRACK] = ACTIONS(13506),
    [anon_sym_LF] = ACTIONS(13508),
    [anon_sym_in] = ACTIONS(13506),
    [anon_sym_LBRACE] = ACTIONS(13506),
    [anon_sym_DOLLAR] = ACTIONS(13506),
    [anon_sym_COLON_COLON] = ACTIONS(13506),
    [anon_sym_isa] = ACTIONS(13506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13506),
    [anon_sym_QMARK] = ACTIONS(13506),
    [anon_sym_AT] = ACTIONS(13506),
    [anon_sym_true] = ACTIONS(13506),
    [anon_sym_false] = ACTIONS(13506),
    [aux_sym_integer_literal_token1] = ACTIONS(13506),
    [aux_sym_integer_literal_token2] = ACTIONS(13506),
    [aux_sym_integer_literal_token3] = ACTIONS(13506),
    [aux_sym_integer_literal_token4] = ACTIONS(13506),
    [aux_sym_float_literal_token1] = ACTIONS(13506),
    [aux_sym_float_literal_token3] = ACTIONS(13506),
    [aux_sym_float_literal_token4] = ACTIONS(13506),
    [sym_character_literal] = ACTIONS(13506),
    [sym__pair_operator] = ACTIONS(13506),
    [sym__arrow_operator] = ACTIONS(13506),
    [sym__lazy_or_operator] = ACTIONS(13506),
    [sym__lazy_and_operator] = ACTIONS(13506),
    [sym__comparison_operator] = ACTIONS(13506),
    [sym__pipe_right_operator] = ACTIONS(13506),
    [sym__pipe_left_operator] = ACTIONS(13506),
    [sym__ellipsis_operator] = ACTIONS(13506),
    [sym__plus_operator] = ACTIONS(13506),
    [sym__times_operator] = ACTIONS(13506),
    [sym__rational_operator] = ACTIONS(13506),
    [sym__bitshift_operator] = ACTIONS(13506),
    [sym__power_operator] = ACTIONS(13506),
    [sym__tilde_operator] = ACTIONS(13506),
    [sym__type_order_operator] = ACTIONS(13506),
    [sym__unary_operator] = ACTIONS(13506),
    [sym__unary_plus_operator] = ACTIONS(13506),
    [aux_sym__terminator_token1] = ACTIONS(13506),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13508),
    [sym__command_start] = ACTIONS(13508),
  },
  [7841] = {
    [ts_builtin_sym_end] = ACTIONS(13512),
    [sym__word_identifier] = ACTIONS(13510),
    [anon_sym_EQ] = ACTIONS(13510),
    [anon_sym_COMMA] = ACTIONS(13510),
    [anon_sym_COLON] = ACTIONS(13510),
    [anon_sym_begin] = ACTIONS(13510),
    [anon_sym_module] = ACTIONS(13510),
    [anon_sym_baremodule] = ACTIONS(13510),
    [anon_sym_abstract] = ACTIONS(13510),
    [anon_sym_primitive] = ACTIONS(13510),
    [anon_sym_mutable] = ACTIONS(13510),
    [anon_sym_struct] = ACTIONS(13510),
    [anon_sym_function] = ACTIONS(13510),
    [anon_sym_macro] = ACTIONS(13510),
    [anon_sym_where] = ACTIONS(13510),
    [anon_sym_quote] = ACTIONS(13510),
    [anon_sym_let] = ACTIONS(13510),
    [anon_sym_if] = ACTIONS(13510),
    [anon_sym_try] = ACTIONS(13510),
    [anon_sym_for] = ACTIONS(13510),
    [anon_sym_while] = ACTIONS(13510),
    [sym_break_statement] = ACTIONS(13510),
    [sym_continue_statement] = ACTIONS(13510),
    [anon_sym_return] = ACTIONS(13510),
    [anon_sym_const] = ACTIONS(13510),
    [anon_sym_global] = ACTIONS(13510),
    [anon_sym_local] = ACTIONS(13510),
    [anon_sym_LPAREN] = ACTIONS(13510),
    [anon_sym_RPAREN] = ACTIONS(13510),
    [anon_sym_COLON2] = ACTIONS(13510),
    [anon_sym_export] = ACTIONS(13510),
    [anon_sym_import] = ACTIONS(13510),
    [anon_sym_using] = ACTIONS(13510),
    [anon_sym_LBRACK] = ACTIONS(13510),
    [anon_sym_RBRACK] = ACTIONS(13510),
    [anon_sym_LF] = ACTIONS(13512),
    [anon_sym_in] = ACTIONS(13510),
    [anon_sym_LBRACE] = ACTIONS(13510),
    [anon_sym_DOLLAR] = ACTIONS(13510),
    [anon_sym_COLON_COLON] = ACTIONS(13510),
    [anon_sym_isa] = ACTIONS(13510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13510),
    [anon_sym_QMARK] = ACTIONS(13510),
    [anon_sym_AT] = ACTIONS(13510),
    [anon_sym_true] = ACTIONS(13510),
    [anon_sym_false] = ACTIONS(13510),
    [aux_sym_integer_literal_token1] = ACTIONS(13510),
    [aux_sym_integer_literal_token2] = ACTIONS(13510),
    [aux_sym_integer_literal_token3] = ACTIONS(13510),
    [aux_sym_integer_literal_token4] = ACTIONS(13510),
    [aux_sym_float_literal_token1] = ACTIONS(13510),
    [aux_sym_float_literal_token3] = ACTIONS(13510),
    [aux_sym_float_literal_token4] = ACTIONS(13510),
    [sym_character_literal] = ACTIONS(13510),
    [sym__pair_operator] = ACTIONS(13510),
    [sym__arrow_operator] = ACTIONS(13510),
    [sym__lazy_or_operator] = ACTIONS(13510),
    [sym__lazy_and_operator] = ACTIONS(13510),
    [sym__comparison_operator] = ACTIONS(13510),
    [sym__pipe_right_operator] = ACTIONS(13510),
    [sym__pipe_left_operator] = ACTIONS(13510),
    [sym__ellipsis_operator] = ACTIONS(13510),
    [sym__plus_operator] = ACTIONS(13510),
    [sym__times_operator] = ACTIONS(13510),
    [sym__rational_operator] = ACTIONS(13510),
    [sym__bitshift_operator] = ACTIONS(13510),
    [sym__power_operator] = ACTIONS(13510),
    [sym__tilde_operator] = ACTIONS(13510),
    [sym__type_order_operator] = ACTIONS(13510),
    [sym__unary_operator] = ACTIONS(13510),
    [sym__unary_plus_operator] = ACTIONS(13510),
    [aux_sym__terminator_token1] = ACTIONS(13510),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13512),
    [sym__command_start] = ACTIONS(13512),
  },
  [7842] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_catch] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7843] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_catch] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7844] = {
    [ts_builtin_sym_end] = ACTIONS(13516),
    [sym__word_identifier] = ACTIONS(13514),
    [anon_sym_EQ] = ACTIONS(13514),
    [anon_sym_COMMA] = ACTIONS(13514),
    [anon_sym_COLON] = ACTIONS(13514),
    [anon_sym_begin] = ACTIONS(13514),
    [anon_sym_module] = ACTIONS(13514),
    [anon_sym_baremodule] = ACTIONS(13514),
    [anon_sym_abstract] = ACTIONS(13514),
    [anon_sym_primitive] = ACTIONS(13514),
    [anon_sym_mutable] = ACTIONS(13514),
    [anon_sym_struct] = ACTIONS(13514),
    [anon_sym_function] = ACTIONS(13514),
    [anon_sym_macro] = ACTIONS(13514),
    [anon_sym_where] = ACTIONS(13514),
    [anon_sym_quote] = ACTIONS(13514),
    [anon_sym_let] = ACTIONS(13514),
    [anon_sym_if] = ACTIONS(13514),
    [anon_sym_try] = ACTIONS(13514),
    [anon_sym_for] = ACTIONS(13514),
    [anon_sym_while] = ACTIONS(13514),
    [sym_break_statement] = ACTIONS(13514),
    [sym_continue_statement] = ACTIONS(13514),
    [anon_sym_return] = ACTIONS(13514),
    [anon_sym_const] = ACTIONS(13514),
    [anon_sym_global] = ACTIONS(13514),
    [anon_sym_local] = ACTIONS(13514),
    [anon_sym_LPAREN] = ACTIONS(13514),
    [anon_sym_RPAREN] = ACTIONS(13514),
    [anon_sym_COLON2] = ACTIONS(13514),
    [anon_sym_export] = ACTIONS(13514),
    [anon_sym_import] = ACTIONS(13514),
    [anon_sym_using] = ACTIONS(13514),
    [anon_sym_LBRACK] = ACTIONS(13514),
    [anon_sym_RBRACK] = ACTIONS(13514),
    [anon_sym_LF] = ACTIONS(13516),
    [anon_sym_in] = ACTIONS(13514),
    [anon_sym_LBRACE] = ACTIONS(13514),
    [anon_sym_DOLLAR] = ACTIONS(13514),
    [anon_sym_COLON_COLON] = ACTIONS(13514),
    [anon_sym_isa] = ACTIONS(13514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13514),
    [anon_sym_QMARK] = ACTIONS(13514),
    [anon_sym_AT] = ACTIONS(13514),
    [anon_sym_true] = ACTIONS(13514),
    [anon_sym_false] = ACTIONS(13514),
    [aux_sym_integer_literal_token1] = ACTIONS(13514),
    [aux_sym_integer_literal_token2] = ACTIONS(13514),
    [aux_sym_integer_literal_token3] = ACTIONS(13514),
    [aux_sym_integer_literal_token4] = ACTIONS(13514),
    [aux_sym_float_literal_token1] = ACTIONS(13514),
    [aux_sym_float_literal_token3] = ACTIONS(13514),
    [aux_sym_float_literal_token4] = ACTIONS(13514),
    [sym_character_literal] = ACTIONS(13514),
    [sym__pair_operator] = ACTIONS(13514),
    [sym__arrow_operator] = ACTIONS(13514),
    [sym__lazy_or_operator] = ACTIONS(13514),
    [sym__lazy_and_operator] = ACTIONS(13514),
    [sym__comparison_operator] = ACTIONS(13514),
    [sym__pipe_right_operator] = ACTIONS(13514),
    [sym__pipe_left_operator] = ACTIONS(13514),
    [sym__ellipsis_operator] = ACTIONS(13514),
    [sym__plus_operator] = ACTIONS(13514),
    [sym__times_operator] = ACTIONS(13514),
    [sym__rational_operator] = ACTIONS(13514),
    [sym__bitshift_operator] = ACTIONS(13514),
    [sym__power_operator] = ACTIONS(13514),
    [sym__tilde_operator] = ACTIONS(13514),
    [sym__type_order_operator] = ACTIONS(13514),
    [sym__unary_operator] = ACTIONS(13514),
    [sym__unary_plus_operator] = ACTIONS(13514),
    [aux_sym__terminator_token1] = ACTIONS(13514),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13516),
    [sym__command_start] = ACTIONS(13516),
  },
  [7845] = {
    [sym__comprehension_clause] = STATE(19872),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16997),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14108),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14110),
    [anon_sym_LF] = ACTIONS(14112),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14115),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7846] = {
    [ts_builtin_sym_end] = ACTIONS(13520),
    [sym__word_identifier] = ACTIONS(13518),
    [anon_sym_EQ] = ACTIONS(13518),
    [anon_sym_COMMA] = ACTIONS(13518),
    [anon_sym_COLON] = ACTIONS(13518),
    [anon_sym_begin] = ACTIONS(13518),
    [anon_sym_module] = ACTIONS(13518),
    [anon_sym_baremodule] = ACTIONS(13518),
    [anon_sym_abstract] = ACTIONS(13518),
    [anon_sym_primitive] = ACTIONS(13518),
    [anon_sym_mutable] = ACTIONS(13518),
    [anon_sym_struct] = ACTIONS(13518),
    [anon_sym_function] = ACTIONS(13518),
    [anon_sym_macro] = ACTIONS(13518),
    [anon_sym_where] = ACTIONS(13518),
    [anon_sym_quote] = ACTIONS(13518),
    [anon_sym_let] = ACTIONS(13518),
    [anon_sym_if] = ACTIONS(13518),
    [anon_sym_try] = ACTIONS(13518),
    [anon_sym_for] = ACTIONS(13518),
    [anon_sym_while] = ACTIONS(13518),
    [sym_break_statement] = ACTIONS(13518),
    [sym_continue_statement] = ACTIONS(13518),
    [anon_sym_return] = ACTIONS(13518),
    [anon_sym_const] = ACTIONS(13518),
    [anon_sym_global] = ACTIONS(13518),
    [anon_sym_local] = ACTIONS(13518),
    [anon_sym_LPAREN] = ACTIONS(13518),
    [anon_sym_RPAREN] = ACTIONS(13518),
    [anon_sym_COLON2] = ACTIONS(13518),
    [anon_sym_export] = ACTIONS(13518),
    [anon_sym_import] = ACTIONS(13518),
    [anon_sym_using] = ACTIONS(13518),
    [anon_sym_LBRACK] = ACTIONS(13518),
    [anon_sym_RBRACK] = ACTIONS(13518),
    [anon_sym_LF] = ACTIONS(13520),
    [anon_sym_in] = ACTIONS(13518),
    [anon_sym_LBRACE] = ACTIONS(13518),
    [anon_sym_DOLLAR] = ACTIONS(13518),
    [anon_sym_COLON_COLON] = ACTIONS(13518),
    [anon_sym_isa] = ACTIONS(13518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13518),
    [anon_sym_QMARK] = ACTIONS(13518),
    [anon_sym_AT] = ACTIONS(13518),
    [anon_sym_true] = ACTIONS(13518),
    [anon_sym_false] = ACTIONS(13518),
    [aux_sym_integer_literal_token1] = ACTIONS(13518),
    [aux_sym_integer_literal_token2] = ACTIONS(13518),
    [aux_sym_integer_literal_token3] = ACTIONS(13518),
    [aux_sym_integer_literal_token4] = ACTIONS(13518),
    [aux_sym_float_literal_token1] = ACTIONS(13518),
    [aux_sym_float_literal_token3] = ACTIONS(13518),
    [aux_sym_float_literal_token4] = ACTIONS(13518),
    [sym_character_literal] = ACTIONS(13518),
    [sym__pair_operator] = ACTIONS(13518),
    [sym__arrow_operator] = ACTIONS(13518),
    [sym__lazy_or_operator] = ACTIONS(13518),
    [sym__lazy_and_operator] = ACTIONS(13518),
    [sym__comparison_operator] = ACTIONS(13518),
    [sym__pipe_right_operator] = ACTIONS(13518),
    [sym__pipe_left_operator] = ACTIONS(13518),
    [sym__ellipsis_operator] = ACTIONS(13518),
    [sym__plus_operator] = ACTIONS(13518),
    [sym__times_operator] = ACTIONS(13518),
    [sym__rational_operator] = ACTIONS(13518),
    [sym__bitshift_operator] = ACTIONS(13518),
    [sym__power_operator] = ACTIONS(13518),
    [sym__tilde_operator] = ACTIONS(13518),
    [sym__type_order_operator] = ACTIONS(13518),
    [sym__unary_operator] = ACTIONS(13518),
    [sym__unary_plus_operator] = ACTIONS(13518),
    [aux_sym__terminator_token1] = ACTIONS(13518),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13520),
    [sym__command_start] = ACTIONS(13520),
  },
  [7847] = {
    [ts_builtin_sym_end] = ACTIONS(13259),
    [sym__word_identifier] = ACTIONS(13257),
    [anon_sym_EQ] = ACTIONS(13257),
    [anon_sym_COMMA] = ACTIONS(13257),
    [anon_sym_COLON] = ACTIONS(13257),
    [anon_sym_begin] = ACTIONS(13257),
    [anon_sym_module] = ACTIONS(13257),
    [anon_sym_baremodule] = ACTIONS(13257),
    [anon_sym_abstract] = ACTIONS(13257),
    [anon_sym_primitive] = ACTIONS(13257),
    [anon_sym_mutable] = ACTIONS(13257),
    [anon_sym_struct] = ACTIONS(13257),
    [anon_sym_function] = ACTIONS(13257),
    [anon_sym_macro] = ACTIONS(13257),
    [anon_sym_where] = ACTIONS(13257),
    [anon_sym_quote] = ACTIONS(13257),
    [anon_sym_let] = ACTIONS(13257),
    [anon_sym_if] = ACTIONS(13257),
    [anon_sym_try] = ACTIONS(13257),
    [anon_sym_for] = ACTIONS(13257),
    [anon_sym_while] = ACTIONS(13257),
    [sym_break_statement] = ACTIONS(13257),
    [sym_continue_statement] = ACTIONS(13257),
    [anon_sym_return] = ACTIONS(13257),
    [anon_sym_const] = ACTIONS(13257),
    [anon_sym_global] = ACTIONS(13257),
    [anon_sym_local] = ACTIONS(13257),
    [anon_sym_LPAREN] = ACTIONS(13257),
    [anon_sym_RPAREN] = ACTIONS(13257),
    [anon_sym_COLON2] = ACTIONS(13257),
    [anon_sym_export] = ACTIONS(13257),
    [anon_sym_import] = ACTIONS(13257),
    [anon_sym_using] = ACTIONS(13257),
    [anon_sym_LBRACK] = ACTIONS(13257),
    [anon_sym_RBRACK] = ACTIONS(13257),
    [anon_sym_LF] = ACTIONS(13259),
    [anon_sym_in] = ACTIONS(13257),
    [anon_sym_LBRACE] = ACTIONS(13257),
    [anon_sym_DOLLAR] = ACTIONS(13257),
    [anon_sym_COLON_COLON] = ACTIONS(13257),
    [anon_sym_isa] = ACTIONS(13257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13257),
    [anon_sym_QMARK] = ACTIONS(13257),
    [anon_sym_AT] = ACTIONS(13257),
    [anon_sym_true] = ACTIONS(13257),
    [anon_sym_false] = ACTIONS(13257),
    [aux_sym_integer_literal_token1] = ACTIONS(13257),
    [aux_sym_integer_literal_token2] = ACTIONS(13257),
    [aux_sym_integer_literal_token3] = ACTIONS(13257),
    [aux_sym_integer_literal_token4] = ACTIONS(13257),
    [aux_sym_float_literal_token1] = ACTIONS(13257),
    [aux_sym_float_literal_token3] = ACTIONS(13257),
    [aux_sym_float_literal_token4] = ACTIONS(13257),
    [sym_character_literal] = ACTIONS(13257),
    [sym__pair_operator] = ACTIONS(13257),
    [sym__arrow_operator] = ACTIONS(13257),
    [sym__lazy_or_operator] = ACTIONS(13257),
    [sym__lazy_and_operator] = ACTIONS(13257),
    [sym__comparison_operator] = ACTIONS(13257),
    [sym__pipe_right_operator] = ACTIONS(13257),
    [sym__pipe_left_operator] = ACTIONS(13257),
    [sym__ellipsis_operator] = ACTIONS(13257),
    [sym__plus_operator] = ACTIONS(13257),
    [sym__times_operator] = ACTIONS(13257),
    [sym__rational_operator] = ACTIONS(13257),
    [sym__bitshift_operator] = ACTIONS(13257),
    [sym__power_operator] = ACTIONS(13257),
    [sym__tilde_operator] = ACTIONS(13257),
    [sym__type_order_operator] = ACTIONS(13257),
    [sym__unary_operator] = ACTIONS(13257),
    [sym__unary_plus_operator] = ACTIONS(13257),
    [aux_sym__terminator_token1] = ACTIONS(13257),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13259),
    [sym__command_start] = ACTIONS(13259),
  },
  [7848] = {
    [ts_builtin_sym_end] = ACTIONS(13524),
    [sym__word_identifier] = ACTIONS(13522),
    [anon_sym_EQ] = ACTIONS(13522),
    [anon_sym_COMMA] = ACTIONS(13522),
    [anon_sym_COLON] = ACTIONS(13522),
    [anon_sym_begin] = ACTIONS(13522),
    [anon_sym_module] = ACTIONS(13522),
    [anon_sym_baremodule] = ACTIONS(13522),
    [anon_sym_abstract] = ACTIONS(13522),
    [anon_sym_primitive] = ACTIONS(13522),
    [anon_sym_mutable] = ACTIONS(13522),
    [anon_sym_struct] = ACTIONS(13522),
    [anon_sym_function] = ACTIONS(13522),
    [anon_sym_macro] = ACTIONS(13522),
    [anon_sym_where] = ACTIONS(13522),
    [anon_sym_quote] = ACTIONS(13522),
    [anon_sym_let] = ACTIONS(13522),
    [anon_sym_if] = ACTIONS(13522),
    [anon_sym_try] = ACTIONS(13522),
    [anon_sym_for] = ACTIONS(13522),
    [anon_sym_while] = ACTIONS(13522),
    [sym_break_statement] = ACTIONS(13522),
    [sym_continue_statement] = ACTIONS(13522),
    [anon_sym_return] = ACTIONS(13522),
    [anon_sym_const] = ACTIONS(13522),
    [anon_sym_global] = ACTIONS(13522),
    [anon_sym_local] = ACTIONS(13522),
    [anon_sym_LPAREN] = ACTIONS(13522),
    [anon_sym_RPAREN] = ACTIONS(13522),
    [anon_sym_COLON2] = ACTIONS(13522),
    [anon_sym_export] = ACTIONS(13522),
    [anon_sym_import] = ACTIONS(13522),
    [anon_sym_using] = ACTIONS(13522),
    [anon_sym_LBRACK] = ACTIONS(13522),
    [anon_sym_RBRACK] = ACTIONS(13522),
    [anon_sym_LF] = ACTIONS(13524),
    [anon_sym_in] = ACTIONS(13522),
    [anon_sym_LBRACE] = ACTIONS(13522),
    [anon_sym_DOLLAR] = ACTIONS(13522),
    [anon_sym_COLON_COLON] = ACTIONS(13522),
    [anon_sym_isa] = ACTIONS(13522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13522),
    [anon_sym_QMARK] = ACTIONS(13522),
    [anon_sym_AT] = ACTIONS(13522),
    [anon_sym_true] = ACTIONS(13522),
    [anon_sym_false] = ACTIONS(13522),
    [aux_sym_integer_literal_token1] = ACTIONS(13522),
    [aux_sym_integer_literal_token2] = ACTIONS(13522),
    [aux_sym_integer_literal_token3] = ACTIONS(13522),
    [aux_sym_integer_literal_token4] = ACTIONS(13522),
    [aux_sym_float_literal_token1] = ACTIONS(13522),
    [aux_sym_float_literal_token3] = ACTIONS(13522),
    [aux_sym_float_literal_token4] = ACTIONS(13522),
    [sym_character_literal] = ACTIONS(13522),
    [sym__pair_operator] = ACTIONS(13522),
    [sym__arrow_operator] = ACTIONS(13522),
    [sym__lazy_or_operator] = ACTIONS(13522),
    [sym__lazy_and_operator] = ACTIONS(13522),
    [sym__comparison_operator] = ACTIONS(13522),
    [sym__pipe_right_operator] = ACTIONS(13522),
    [sym__pipe_left_operator] = ACTIONS(13522),
    [sym__ellipsis_operator] = ACTIONS(13522),
    [sym__plus_operator] = ACTIONS(13522),
    [sym__times_operator] = ACTIONS(13522),
    [sym__rational_operator] = ACTIONS(13522),
    [sym__bitshift_operator] = ACTIONS(13522),
    [sym__power_operator] = ACTIONS(13522),
    [sym__tilde_operator] = ACTIONS(13522),
    [sym__type_order_operator] = ACTIONS(13522),
    [sym__unary_operator] = ACTIONS(13522),
    [sym__unary_plus_operator] = ACTIONS(13522),
    [aux_sym__terminator_token1] = ACTIONS(13522),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13524),
    [sym__command_start] = ACTIONS(13524),
  },
  [7849] = {
    [ts_builtin_sym_end] = ACTIONS(13528),
    [sym__word_identifier] = ACTIONS(13526),
    [anon_sym_EQ] = ACTIONS(13526),
    [anon_sym_COMMA] = ACTIONS(13526),
    [anon_sym_COLON] = ACTIONS(13526),
    [anon_sym_begin] = ACTIONS(13526),
    [anon_sym_module] = ACTIONS(13526),
    [anon_sym_baremodule] = ACTIONS(13526),
    [anon_sym_abstract] = ACTIONS(13526),
    [anon_sym_primitive] = ACTIONS(13526),
    [anon_sym_mutable] = ACTIONS(13526),
    [anon_sym_struct] = ACTIONS(13526),
    [anon_sym_function] = ACTIONS(13526),
    [anon_sym_macro] = ACTIONS(13526),
    [anon_sym_where] = ACTIONS(13526),
    [anon_sym_quote] = ACTIONS(13526),
    [anon_sym_let] = ACTIONS(13526),
    [anon_sym_if] = ACTIONS(13526),
    [anon_sym_try] = ACTIONS(13526),
    [anon_sym_for] = ACTIONS(13526),
    [anon_sym_while] = ACTIONS(13526),
    [sym_break_statement] = ACTIONS(13526),
    [sym_continue_statement] = ACTIONS(13526),
    [anon_sym_return] = ACTIONS(13526),
    [anon_sym_const] = ACTIONS(13526),
    [anon_sym_global] = ACTIONS(13526),
    [anon_sym_local] = ACTIONS(13526),
    [anon_sym_LPAREN] = ACTIONS(13526),
    [anon_sym_RPAREN] = ACTIONS(13526),
    [anon_sym_COLON2] = ACTIONS(13526),
    [anon_sym_export] = ACTIONS(13526),
    [anon_sym_import] = ACTIONS(13526),
    [anon_sym_using] = ACTIONS(13526),
    [anon_sym_LBRACK] = ACTIONS(13526),
    [anon_sym_RBRACK] = ACTIONS(13526),
    [anon_sym_LF] = ACTIONS(13528),
    [anon_sym_in] = ACTIONS(13526),
    [anon_sym_LBRACE] = ACTIONS(13526),
    [anon_sym_DOLLAR] = ACTIONS(13526),
    [anon_sym_COLON_COLON] = ACTIONS(13526),
    [anon_sym_isa] = ACTIONS(13526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13526),
    [anon_sym_QMARK] = ACTIONS(13526),
    [anon_sym_AT] = ACTIONS(13526),
    [anon_sym_true] = ACTIONS(13526),
    [anon_sym_false] = ACTIONS(13526),
    [aux_sym_integer_literal_token1] = ACTIONS(13526),
    [aux_sym_integer_literal_token2] = ACTIONS(13526),
    [aux_sym_integer_literal_token3] = ACTIONS(13526),
    [aux_sym_integer_literal_token4] = ACTIONS(13526),
    [aux_sym_float_literal_token1] = ACTIONS(13526),
    [aux_sym_float_literal_token3] = ACTIONS(13526),
    [aux_sym_float_literal_token4] = ACTIONS(13526),
    [sym_character_literal] = ACTIONS(13526),
    [sym__pair_operator] = ACTIONS(13526),
    [sym__arrow_operator] = ACTIONS(13526),
    [sym__lazy_or_operator] = ACTIONS(13526),
    [sym__lazy_and_operator] = ACTIONS(13526),
    [sym__comparison_operator] = ACTIONS(13526),
    [sym__pipe_right_operator] = ACTIONS(13526),
    [sym__pipe_left_operator] = ACTIONS(13526),
    [sym__ellipsis_operator] = ACTIONS(13526),
    [sym__plus_operator] = ACTIONS(13526),
    [sym__times_operator] = ACTIONS(13526),
    [sym__rational_operator] = ACTIONS(13526),
    [sym__bitshift_operator] = ACTIONS(13526),
    [sym__power_operator] = ACTIONS(13526),
    [sym__tilde_operator] = ACTIONS(13526),
    [sym__type_order_operator] = ACTIONS(13526),
    [sym__unary_operator] = ACTIONS(13526),
    [sym__unary_plus_operator] = ACTIONS(13526),
    [aux_sym__terminator_token1] = ACTIONS(13526),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13528),
    [sym__command_start] = ACTIONS(13528),
  },
  [7850] = {
    [ts_builtin_sym_end] = ACTIONS(13532),
    [sym__word_identifier] = ACTIONS(13530),
    [anon_sym_EQ] = ACTIONS(13530),
    [anon_sym_COMMA] = ACTIONS(13530),
    [anon_sym_COLON] = ACTIONS(13530),
    [anon_sym_begin] = ACTIONS(13530),
    [anon_sym_module] = ACTIONS(13530),
    [anon_sym_baremodule] = ACTIONS(13530),
    [anon_sym_abstract] = ACTIONS(13530),
    [anon_sym_primitive] = ACTIONS(13530),
    [anon_sym_mutable] = ACTIONS(13530),
    [anon_sym_struct] = ACTIONS(13530),
    [anon_sym_function] = ACTIONS(13530),
    [anon_sym_macro] = ACTIONS(13530),
    [anon_sym_where] = ACTIONS(13530),
    [anon_sym_quote] = ACTIONS(13530),
    [anon_sym_let] = ACTIONS(13530),
    [anon_sym_if] = ACTIONS(13530),
    [anon_sym_try] = ACTIONS(13530),
    [anon_sym_for] = ACTIONS(13530),
    [anon_sym_while] = ACTIONS(13530),
    [sym_break_statement] = ACTIONS(13530),
    [sym_continue_statement] = ACTIONS(13530),
    [anon_sym_return] = ACTIONS(13530),
    [anon_sym_const] = ACTIONS(13530),
    [anon_sym_global] = ACTIONS(13530),
    [anon_sym_local] = ACTIONS(13530),
    [anon_sym_LPAREN] = ACTIONS(13530),
    [anon_sym_RPAREN] = ACTIONS(13530),
    [anon_sym_COLON2] = ACTIONS(13530),
    [anon_sym_export] = ACTIONS(13530),
    [anon_sym_import] = ACTIONS(13530),
    [anon_sym_using] = ACTIONS(13530),
    [anon_sym_LBRACK] = ACTIONS(13530),
    [anon_sym_RBRACK] = ACTIONS(13530),
    [anon_sym_LF] = ACTIONS(13532),
    [anon_sym_in] = ACTIONS(13530),
    [anon_sym_LBRACE] = ACTIONS(13530),
    [anon_sym_DOLLAR] = ACTIONS(13530),
    [anon_sym_COLON_COLON] = ACTIONS(13530),
    [anon_sym_isa] = ACTIONS(13530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13530),
    [anon_sym_QMARK] = ACTIONS(13530),
    [anon_sym_AT] = ACTIONS(13530),
    [anon_sym_true] = ACTIONS(13530),
    [anon_sym_false] = ACTIONS(13530),
    [aux_sym_integer_literal_token1] = ACTIONS(13530),
    [aux_sym_integer_literal_token2] = ACTIONS(13530),
    [aux_sym_integer_literal_token3] = ACTIONS(13530),
    [aux_sym_integer_literal_token4] = ACTIONS(13530),
    [aux_sym_float_literal_token1] = ACTIONS(13530),
    [aux_sym_float_literal_token3] = ACTIONS(13530),
    [aux_sym_float_literal_token4] = ACTIONS(13530),
    [sym_character_literal] = ACTIONS(13530),
    [sym__pair_operator] = ACTIONS(13530),
    [sym__arrow_operator] = ACTIONS(13530),
    [sym__lazy_or_operator] = ACTIONS(13530),
    [sym__lazy_and_operator] = ACTIONS(13530),
    [sym__comparison_operator] = ACTIONS(13530),
    [sym__pipe_right_operator] = ACTIONS(13530),
    [sym__pipe_left_operator] = ACTIONS(13530),
    [sym__ellipsis_operator] = ACTIONS(13530),
    [sym__plus_operator] = ACTIONS(13530),
    [sym__times_operator] = ACTIONS(13530),
    [sym__rational_operator] = ACTIONS(13530),
    [sym__bitshift_operator] = ACTIONS(13530),
    [sym__power_operator] = ACTIONS(13530),
    [sym__tilde_operator] = ACTIONS(13530),
    [sym__type_order_operator] = ACTIONS(13530),
    [sym__unary_operator] = ACTIONS(13530),
    [sym__unary_plus_operator] = ACTIONS(13530),
    [aux_sym__terminator_token1] = ACTIONS(13530),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13532),
    [sym__command_start] = ACTIONS(13532),
  },
  [7851] = {
    [sym__comprehension_clause] = STATE(19353),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17286),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14118),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14120),
    [anon_sym_LF] = ACTIONS(14122),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14125),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7852] = {
    [ts_builtin_sym_end] = ACTIONS(13536),
    [sym__word_identifier] = ACTIONS(13534),
    [anon_sym_EQ] = ACTIONS(13534),
    [anon_sym_COMMA] = ACTIONS(13534),
    [anon_sym_COLON] = ACTIONS(13534),
    [anon_sym_begin] = ACTIONS(13534),
    [anon_sym_module] = ACTIONS(13534),
    [anon_sym_baremodule] = ACTIONS(13534),
    [anon_sym_abstract] = ACTIONS(13534),
    [anon_sym_primitive] = ACTIONS(13534),
    [anon_sym_mutable] = ACTIONS(13534),
    [anon_sym_struct] = ACTIONS(13534),
    [anon_sym_function] = ACTIONS(13534),
    [anon_sym_macro] = ACTIONS(13534),
    [anon_sym_where] = ACTIONS(13534),
    [anon_sym_quote] = ACTIONS(13534),
    [anon_sym_let] = ACTIONS(13534),
    [anon_sym_if] = ACTIONS(13534),
    [anon_sym_try] = ACTIONS(13534),
    [anon_sym_for] = ACTIONS(13534),
    [anon_sym_while] = ACTIONS(13534),
    [sym_break_statement] = ACTIONS(13534),
    [sym_continue_statement] = ACTIONS(13534),
    [anon_sym_return] = ACTIONS(13534),
    [anon_sym_const] = ACTIONS(13534),
    [anon_sym_global] = ACTIONS(13534),
    [anon_sym_local] = ACTIONS(13534),
    [anon_sym_LPAREN] = ACTIONS(13534),
    [anon_sym_RPAREN] = ACTIONS(13534),
    [anon_sym_COLON2] = ACTIONS(13534),
    [anon_sym_export] = ACTIONS(13534),
    [anon_sym_import] = ACTIONS(13534),
    [anon_sym_using] = ACTIONS(13534),
    [anon_sym_LBRACK] = ACTIONS(13534),
    [anon_sym_RBRACK] = ACTIONS(13534),
    [anon_sym_LF] = ACTIONS(13536),
    [anon_sym_in] = ACTIONS(13534),
    [anon_sym_LBRACE] = ACTIONS(13534),
    [anon_sym_DOLLAR] = ACTIONS(13534),
    [anon_sym_COLON_COLON] = ACTIONS(13534),
    [anon_sym_isa] = ACTIONS(13534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13534),
    [anon_sym_QMARK] = ACTIONS(13534),
    [anon_sym_AT] = ACTIONS(13534),
    [anon_sym_true] = ACTIONS(13534),
    [anon_sym_false] = ACTIONS(13534),
    [aux_sym_integer_literal_token1] = ACTIONS(13534),
    [aux_sym_integer_literal_token2] = ACTIONS(13534),
    [aux_sym_integer_literal_token3] = ACTIONS(13534),
    [aux_sym_integer_literal_token4] = ACTIONS(13534),
    [aux_sym_float_literal_token1] = ACTIONS(13534),
    [aux_sym_float_literal_token3] = ACTIONS(13534),
    [aux_sym_float_literal_token4] = ACTIONS(13534),
    [sym_character_literal] = ACTIONS(13534),
    [sym__pair_operator] = ACTIONS(13534),
    [sym__arrow_operator] = ACTIONS(13534),
    [sym__lazy_or_operator] = ACTIONS(13534),
    [sym__lazy_and_operator] = ACTIONS(13534),
    [sym__comparison_operator] = ACTIONS(13534),
    [sym__pipe_right_operator] = ACTIONS(13534),
    [sym__pipe_left_operator] = ACTIONS(13534),
    [sym__ellipsis_operator] = ACTIONS(13534),
    [sym__plus_operator] = ACTIONS(13534),
    [sym__times_operator] = ACTIONS(13534),
    [sym__rational_operator] = ACTIONS(13534),
    [sym__bitshift_operator] = ACTIONS(13534),
    [sym__power_operator] = ACTIONS(13534),
    [sym__tilde_operator] = ACTIONS(13534),
    [sym__type_order_operator] = ACTIONS(13534),
    [sym__unary_operator] = ACTIONS(13534),
    [sym__unary_plus_operator] = ACTIONS(13534),
    [aux_sym__terminator_token1] = ACTIONS(13534),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13536),
    [sym__command_start] = ACTIONS(13536),
  },
  [7853] = {
    [ts_builtin_sym_end] = ACTIONS(13540),
    [sym__word_identifier] = ACTIONS(13538),
    [anon_sym_EQ] = ACTIONS(13538),
    [anon_sym_COMMA] = ACTIONS(13538),
    [anon_sym_COLON] = ACTIONS(13538),
    [anon_sym_begin] = ACTIONS(13538),
    [anon_sym_module] = ACTIONS(13538),
    [anon_sym_baremodule] = ACTIONS(13538),
    [anon_sym_abstract] = ACTIONS(13538),
    [anon_sym_primitive] = ACTIONS(13538),
    [anon_sym_mutable] = ACTIONS(13538),
    [anon_sym_struct] = ACTIONS(13538),
    [anon_sym_function] = ACTIONS(13538),
    [anon_sym_macro] = ACTIONS(13538),
    [anon_sym_where] = ACTIONS(13538),
    [anon_sym_quote] = ACTIONS(13538),
    [anon_sym_let] = ACTIONS(13538),
    [anon_sym_if] = ACTIONS(13538),
    [anon_sym_try] = ACTIONS(13538),
    [anon_sym_for] = ACTIONS(13538),
    [anon_sym_while] = ACTIONS(13538),
    [sym_break_statement] = ACTIONS(13538),
    [sym_continue_statement] = ACTIONS(13538),
    [anon_sym_return] = ACTIONS(13538),
    [anon_sym_const] = ACTIONS(13538),
    [anon_sym_global] = ACTIONS(13538),
    [anon_sym_local] = ACTIONS(13538),
    [anon_sym_LPAREN] = ACTIONS(13538),
    [anon_sym_RPAREN] = ACTIONS(13538),
    [anon_sym_COLON2] = ACTIONS(13538),
    [anon_sym_export] = ACTIONS(13538),
    [anon_sym_import] = ACTIONS(13538),
    [anon_sym_using] = ACTIONS(13538),
    [anon_sym_LBRACK] = ACTIONS(13538),
    [anon_sym_RBRACK] = ACTIONS(13538),
    [anon_sym_LF] = ACTIONS(13540),
    [anon_sym_in] = ACTIONS(13538),
    [anon_sym_LBRACE] = ACTIONS(13538),
    [anon_sym_DOLLAR] = ACTIONS(13538),
    [anon_sym_COLON_COLON] = ACTIONS(13538),
    [anon_sym_isa] = ACTIONS(13538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13538),
    [anon_sym_QMARK] = ACTIONS(13538),
    [anon_sym_AT] = ACTIONS(13538),
    [anon_sym_true] = ACTIONS(13538),
    [anon_sym_false] = ACTIONS(13538),
    [aux_sym_integer_literal_token1] = ACTIONS(13538),
    [aux_sym_integer_literal_token2] = ACTIONS(13538),
    [aux_sym_integer_literal_token3] = ACTIONS(13538),
    [aux_sym_integer_literal_token4] = ACTIONS(13538),
    [aux_sym_float_literal_token1] = ACTIONS(13538),
    [aux_sym_float_literal_token3] = ACTIONS(13538),
    [aux_sym_float_literal_token4] = ACTIONS(13538),
    [sym_character_literal] = ACTIONS(13538),
    [sym__pair_operator] = ACTIONS(13538),
    [sym__arrow_operator] = ACTIONS(13538),
    [sym__lazy_or_operator] = ACTIONS(13538),
    [sym__lazy_and_operator] = ACTIONS(13538),
    [sym__comparison_operator] = ACTIONS(13538),
    [sym__pipe_right_operator] = ACTIONS(13538),
    [sym__pipe_left_operator] = ACTIONS(13538),
    [sym__ellipsis_operator] = ACTIONS(13538),
    [sym__plus_operator] = ACTIONS(13538),
    [sym__times_operator] = ACTIONS(13538),
    [sym__rational_operator] = ACTIONS(13538),
    [sym__bitshift_operator] = ACTIONS(13538),
    [sym__power_operator] = ACTIONS(13538),
    [sym__tilde_operator] = ACTIONS(13538),
    [sym__type_order_operator] = ACTIONS(13538),
    [sym__unary_operator] = ACTIONS(13538),
    [sym__unary_plus_operator] = ACTIONS(13538),
    [aux_sym__terminator_token1] = ACTIONS(13538),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13540),
    [sym__command_start] = ACTIONS(13540),
  },
  [7854] = {
    [ts_builtin_sym_end] = ACTIONS(13544),
    [sym__word_identifier] = ACTIONS(13542),
    [anon_sym_EQ] = ACTIONS(13542),
    [anon_sym_COMMA] = ACTIONS(13542),
    [anon_sym_COLON] = ACTIONS(13542),
    [anon_sym_begin] = ACTIONS(13542),
    [anon_sym_module] = ACTIONS(13542),
    [anon_sym_baremodule] = ACTIONS(13542),
    [anon_sym_abstract] = ACTIONS(13542),
    [anon_sym_primitive] = ACTIONS(13542),
    [anon_sym_mutable] = ACTIONS(13542),
    [anon_sym_struct] = ACTIONS(13542),
    [anon_sym_function] = ACTIONS(13542),
    [anon_sym_macro] = ACTIONS(13542),
    [anon_sym_where] = ACTIONS(13542),
    [anon_sym_quote] = ACTIONS(13542),
    [anon_sym_let] = ACTIONS(13542),
    [anon_sym_if] = ACTIONS(13542),
    [anon_sym_try] = ACTIONS(13542),
    [anon_sym_for] = ACTIONS(13542),
    [anon_sym_while] = ACTIONS(13542),
    [sym_break_statement] = ACTIONS(13542),
    [sym_continue_statement] = ACTIONS(13542),
    [anon_sym_return] = ACTIONS(13542),
    [anon_sym_const] = ACTIONS(13542),
    [anon_sym_global] = ACTIONS(13542),
    [anon_sym_local] = ACTIONS(13542),
    [anon_sym_LPAREN] = ACTIONS(13542),
    [anon_sym_RPAREN] = ACTIONS(13542),
    [anon_sym_COLON2] = ACTIONS(13542),
    [anon_sym_export] = ACTIONS(13542),
    [anon_sym_import] = ACTIONS(13542),
    [anon_sym_using] = ACTIONS(13542),
    [anon_sym_LBRACK] = ACTIONS(13542),
    [anon_sym_RBRACK] = ACTIONS(13542),
    [anon_sym_LF] = ACTIONS(13544),
    [anon_sym_in] = ACTIONS(13542),
    [anon_sym_LBRACE] = ACTIONS(13542),
    [anon_sym_DOLLAR] = ACTIONS(13542),
    [anon_sym_COLON_COLON] = ACTIONS(13542),
    [anon_sym_isa] = ACTIONS(13542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13542),
    [anon_sym_QMARK] = ACTIONS(13542),
    [anon_sym_AT] = ACTIONS(13542),
    [anon_sym_true] = ACTIONS(13542),
    [anon_sym_false] = ACTIONS(13542),
    [aux_sym_integer_literal_token1] = ACTIONS(13542),
    [aux_sym_integer_literal_token2] = ACTIONS(13542),
    [aux_sym_integer_literal_token3] = ACTIONS(13542),
    [aux_sym_integer_literal_token4] = ACTIONS(13542),
    [aux_sym_float_literal_token1] = ACTIONS(13542),
    [aux_sym_float_literal_token3] = ACTIONS(13542),
    [aux_sym_float_literal_token4] = ACTIONS(13542),
    [sym_character_literal] = ACTIONS(13542),
    [sym__pair_operator] = ACTIONS(13542),
    [sym__arrow_operator] = ACTIONS(13542),
    [sym__lazy_or_operator] = ACTIONS(13542),
    [sym__lazy_and_operator] = ACTIONS(13542),
    [sym__comparison_operator] = ACTIONS(13542),
    [sym__pipe_right_operator] = ACTIONS(13542),
    [sym__pipe_left_operator] = ACTIONS(13542),
    [sym__ellipsis_operator] = ACTIONS(13542),
    [sym__plus_operator] = ACTIONS(13542),
    [sym__times_operator] = ACTIONS(13542),
    [sym__rational_operator] = ACTIONS(13542),
    [sym__bitshift_operator] = ACTIONS(13542),
    [sym__power_operator] = ACTIONS(13542),
    [sym__tilde_operator] = ACTIONS(13542),
    [sym__type_order_operator] = ACTIONS(13542),
    [sym__unary_operator] = ACTIONS(13542),
    [sym__unary_plus_operator] = ACTIONS(13542),
    [aux_sym__terminator_token1] = ACTIONS(13542),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13544),
    [sym__command_start] = ACTIONS(13544),
  },
  [7855] = {
    [ts_builtin_sym_end] = ACTIONS(13548),
    [sym__word_identifier] = ACTIONS(13546),
    [anon_sym_EQ] = ACTIONS(13546),
    [anon_sym_COMMA] = ACTIONS(13546),
    [anon_sym_COLON] = ACTIONS(13546),
    [anon_sym_begin] = ACTIONS(13546),
    [anon_sym_module] = ACTIONS(13546),
    [anon_sym_baremodule] = ACTIONS(13546),
    [anon_sym_abstract] = ACTIONS(13546),
    [anon_sym_primitive] = ACTIONS(13546),
    [anon_sym_mutable] = ACTIONS(13546),
    [anon_sym_struct] = ACTIONS(13546),
    [anon_sym_function] = ACTIONS(13546),
    [anon_sym_macro] = ACTIONS(13546),
    [anon_sym_where] = ACTIONS(13546),
    [anon_sym_quote] = ACTIONS(13546),
    [anon_sym_let] = ACTIONS(13546),
    [anon_sym_if] = ACTIONS(13546),
    [anon_sym_try] = ACTIONS(13546),
    [anon_sym_for] = ACTIONS(13546),
    [anon_sym_while] = ACTIONS(13546),
    [sym_break_statement] = ACTIONS(13546),
    [sym_continue_statement] = ACTIONS(13546),
    [anon_sym_return] = ACTIONS(13546),
    [anon_sym_const] = ACTIONS(13546),
    [anon_sym_global] = ACTIONS(13546),
    [anon_sym_local] = ACTIONS(13546),
    [anon_sym_LPAREN] = ACTIONS(13546),
    [anon_sym_RPAREN] = ACTIONS(13546),
    [anon_sym_COLON2] = ACTIONS(13546),
    [anon_sym_export] = ACTIONS(13546),
    [anon_sym_import] = ACTIONS(13546),
    [anon_sym_using] = ACTIONS(13546),
    [anon_sym_LBRACK] = ACTIONS(13546),
    [anon_sym_RBRACK] = ACTIONS(13546),
    [anon_sym_LF] = ACTIONS(13548),
    [anon_sym_in] = ACTIONS(13546),
    [anon_sym_LBRACE] = ACTIONS(13546),
    [anon_sym_DOLLAR] = ACTIONS(13546),
    [anon_sym_COLON_COLON] = ACTIONS(13546),
    [anon_sym_isa] = ACTIONS(13546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13546),
    [anon_sym_QMARK] = ACTIONS(13546),
    [anon_sym_AT] = ACTIONS(13546),
    [anon_sym_true] = ACTIONS(13546),
    [anon_sym_false] = ACTIONS(13546),
    [aux_sym_integer_literal_token1] = ACTIONS(13546),
    [aux_sym_integer_literal_token2] = ACTIONS(13546),
    [aux_sym_integer_literal_token3] = ACTIONS(13546),
    [aux_sym_integer_literal_token4] = ACTIONS(13546),
    [aux_sym_float_literal_token1] = ACTIONS(13546),
    [aux_sym_float_literal_token3] = ACTIONS(13546),
    [aux_sym_float_literal_token4] = ACTIONS(13546),
    [sym_character_literal] = ACTIONS(13546),
    [sym__pair_operator] = ACTIONS(13546),
    [sym__arrow_operator] = ACTIONS(13546),
    [sym__lazy_or_operator] = ACTIONS(13546),
    [sym__lazy_and_operator] = ACTIONS(13546),
    [sym__comparison_operator] = ACTIONS(13546),
    [sym__pipe_right_operator] = ACTIONS(13546),
    [sym__pipe_left_operator] = ACTIONS(13546),
    [sym__ellipsis_operator] = ACTIONS(13546),
    [sym__plus_operator] = ACTIONS(13546),
    [sym__times_operator] = ACTIONS(13546),
    [sym__rational_operator] = ACTIONS(13546),
    [sym__bitshift_operator] = ACTIONS(13546),
    [sym__power_operator] = ACTIONS(13546),
    [sym__tilde_operator] = ACTIONS(13546),
    [sym__type_order_operator] = ACTIONS(13546),
    [sym__unary_operator] = ACTIONS(13546),
    [sym__unary_plus_operator] = ACTIONS(13546),
    [aux_sym__terminator_token1] = ACTIONS(13546),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13548),
    [sym__command_start] = ACTIONS(13548),
  },
  [7856] = {
    [ts_builtin_sym_end] = ACTIONS(13552),
    [sym__word_identifier] = ACTIONS(13550),
    [anon_sym_EQ] = ACTIONS(13550),
    [anon_sym_COMMA] = ACTIONS(13550),
    [anon_sym_COLON] = ACTIONS(13550),
    [anon_sym_begin] = ACTIONS(13550),
    [anon_sym_module] = ACTIONS(13550),
    [anon_sym_baremodule] = ACTIONS(13550),
    [anon_sym_abstract] = ACTIONS(13550),
    [anon_sym_primitive] = ACTIONS(13550),
    [anon_sym_mutable] = ACTIONS(13550),
    [anon_sym_struct] = ACTIONS(13550),
    [anon_sym_function] = ACTIONS(13550),
    [anon_sym_macro] = ACTIONS(13550),
    [anon_sym_where] = ACTIONS(13550),
    [anon_sym_quote] = ACTIONS(13550),
    [anon_sym_let] = ACTIONS(13550),
    [anon_sym_if] = ACTIONS(13550),
    [anon_sym_try] = ACTIONS(13550),
    [anon_sym_for] = ACTIONS(13550),
    [anon_sym_while] = ACTIONS(13550),
    [sym_break_statement] = ACTIONS(13550),
    [sym_continue_statement] = ACTIONS(13550),
    [anon_sym_return] = ACTIONS(13550),
    [anon_sym_const] = ACTIONS(13550),
    [anon_sym_global] = ACTIONS(13550),
    [anon_sym_local] = ACTIONS(13550),
    [anon_sym_LPAREN] = ACTIONS(13550),
    [anon_sym_RPAREN] = ACTIONS(13550),
    [anon_sym_COLON2] = ACTIONS(13550),
    [anon_sym_export] = ACTIONS(13550),
    [anon_sym_import] = ACTIONS(13550),
    [anon_sym_using] = ACTIONS(13550),
    [anon_sym_LBRACK] = ACTIONS(13550),
    [anon_sym_RBRACK] = ACTIONS(13550),
    [anon_sym_LF] = ACTIONS(13552),
    [anon_sym_in] = ACTIONS(13550),
    [anon_sym_LBRACE] = ACTIONS(13550),
    [anon_sym_DOLLAR] = ACTIONS(13550),
    [anon_sym_COLON_COLON] = ACTIONS(13550),
    [anon_sym_isa] = ACTIONS(13550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13550),
    [anon_sym_QMARK] = ACTIONS(13550),
    [anon_sym_AT] = ACTIONS(13550),
    [anon_sym_true] = ACTIONS(13550),
    [anon_sym_false] = ACTIONS(13550),
    [aux_sym_integer_literal_token1] = ACTIONS(13550),
    [aux_sym_integer_literal_token2] = ACTIONS(13550),
    [aux_sym_integer_literal_token3] = ACTIONS(13550),
    [aux_sym_integer_literal_token4] = ACTIONS(13550),
    [aux_sym_float_literal_token1] = ACTIONS(13550),
    [aux_sym_float_literal_token3] = ACTIONS(13550),
    [aux_sym_float_literal_token4] = ACTIONS(13550),
    [sym_character_literal] = ACTIONS(13550),
    [sym__pair_operator] = ACTIONS(13550),
    [sym__arrow_operator] = ACTIONS(13550),
    [sym__lazy_or_operator] = ACTIONS(13550),
    [sym__lazy_and_operator] = ACTIONS(13550),
    [sym__comparison_operator] = ACTIONS(13550),
    [sym__pipe_right_operator] = ACTIONS(13550),
    [sym__pipe_left_operator] = ACTIONS(13550),
    [sym__ellipsis_operator] = ACTIONS(13550),
    [sym__plus_operator] = ACTIONS(13550),
    [sym__times_operator] = ACTIONS(13550),
    [sym__rational_operator] = ACTIONS(13550),
    [sym__bitshift_operator] = ACTIONS(13550),
    [sym__power_operator] = ACTIONS(13550),
    [sym__tilde_operator] = ACTIONS(13550),
    [sym__type_order_operator] = ACTIONS(13550),
    [sym__unary_operator] = ACTIONS(13550),
    [sym__unary_plus_operator] = ACTIONS(13550),
    [aux_sym__terminator_token1] = ACTIONS(13550),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13552),
    [sym__command_start] = ACTIONS(13552),
  },
  [7857] = {
    [ts_builtin_sym_end] = ACTIONS(13556),
    [sym__word_identifier] = ACTIONS(13554),
    [anon_sym_EQ] = ACTIONS(13554),
    [anon_sym_COMMA] = ACTIONS(13554),
    [anon_sym_COLON] = ACTIONS(13554),
    [anon_sym_begin] = ACTIONS(13554),
    [anon_sym_module] = ACTIONS(13554),
    [anon_sym_baremodule] = ACTIONS(13554),
    [anon_sym_abstract] = ACTIONS(13554),
    [anon_sym_primitive] = ACTIONS(13554),
    [anon_sym_mutable] = ACTIONS(13554),
    [anon_sym_struct] = ACTIONS(13554),
    [anon_sym_function] = ACTIONS(13554),
    [anon_sym_macro] = ACTIONS(13554),
    [anon_sym_where] = ACTIONS(13554),
    [anon_sym_quote] = ACTIONS(13554),
    [anon_sym_let] = ACTIONS(13554),
    [anon_sym_if] = ACTIONS(13554),
    [anon_sym_try] = ACTIONS(13554),
    [anon_sym_for] = ACTIONS(13554),
    [anon_sym_while] = ACTIONS(13554),
    [sym_break_statement] = ACTIONS(13554),
    [sym_continue_statement] = ACTIONS(13554),
    [anon_sym_return] = ACTIONS(13554),
    [anon_sym_const] = ACTIONS(13554),
    [anon_sym_global] = ACTIONS(13554),
    [anon_sym_local] = ACTIONS(13554),
    [anon_sym_LPAREN] = ACTIONS(13554),
    [anon_sym_RPAREN] = ACTIONS(13554),
    [anon_sym_COLON2] = ACTIONS(13554),
    [anon_sym_export] = ACTIONS(13554),
    [anon_sym_import] = ACTIONS(13554),
    [anon_sym_using] = ACTIONS(13554),
    [anon_sym_LBRACK] = ACTIONS(13554),
    [anon_sym_RBRACK] = ACTIONS(13554),
    [anon_sym_LF] = ACTIONS(13556),
    [anon_sym_in] = ACTIONS(13554),
    [anon_sym_LBRACE] = ACTIONS(13554),
    [anon_sym_DOLLAR] = ACTIONS(13554),
    [anon_sym_COLON_COLON] = ACTIONS(13554),
    [anon_sym_isa] = ACTIONS(13554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13554),
    [anon_sym_QMARK] = ACTIONS(13554),
    [anon_sym_AT] = ACTIONS(13554),
    [anon_sym_true] = ACTIONS(13554),
    [anon_sym_false] = ACTIONS(13554),
    [aux_sym_integer_literal_token1] = ACTIONS(13554),
    [aux_sym_integer_literal_token2] = ACTIONS(13554),
    [aux_sym_integer_literal_token3] = ACTIONS(13554),
    [aux_sym_integer_literal_token4] = ACTIONS(13554),
    [aux_sym_float_literal_token1] = ACTIONS(13554),
    [aux_sym_float_literal_token3] = ACTIONS(13554),
    [aux_sym_float_literal_token4] = ACTIONS(13554),
    [sym_character_literal] = ACTIONS(13554),
    [sym__pair_operator] = ACTIONS(13554),
    [sym__arrow_operator] = ACTIONS(13554),
    [sym__lazy_or_operator] = ACTIONS(13554),
    [sym__lazy_and_operator] = ACTIONS(13554),
    [sym__comparison_operator] = ACTIONS(13554),
    [sym__pipe_right_operator] = ACTIONS(13554),
    [sym__pipe_left_operator] = ACTIONS(13554),
    [sym__ellipsis_operator] = ACTIONS(13554),
    [sym__plus_operator] = ACTIONS(13554),
    [sym__times_operator] = ACTIONS(13554),
    [sym__rational_operator] = ACTIONS(13554),
    [sym__bitshift_operator] = ACTIONS(13554),
    [sym__power_operator] = ACTIONS(13554),
    [sym__tilde_operator] = ACTIONS(13554),
    [sym__type_order_operator] = ACTIONS(13554),
    [sym__unary_operator] = ACTIONS(13554),
    [sym__unary_plus_operator] = ACTIONS(13554),
    [aux_sym__terminator_token1] = ACTIONS(13554),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13556),
    [sym__command_start] = ACTIONS(13556),
  },
  [7858] = {
    [ts_builtin_sym_end] = ACTIONS(13560),
    [sym__word_identifier] = ACTIONS(13558),
    [anon_sym_EQ] = ACTIONS(13558),
    [anon_sym_COMMA] = ACTIONS(13558),
    [anon_sym_COLON] = ACTIONS(13558),
    [anon_sym_begin] = ACTIONS(13558),
    [anon_sym_module] = ACTIONS(13558),
    [anon_sym_baremodule] = ACTIONS(13558),
    [anon_sym_abstract] = ACTIONS(13558),
    [anon_sym_primitive] = ACTIONS(13558),
    [anon_sym_mutable] = ACTIONS(13558),
    [anon_sym_struct] = ACTIONS(13558),
    [anon_sym_function] = ACTIONS(13558),
    [anon_sym_macro] = ACTIONS(13558),
    [anon_sym_where] = ACTIONS(13558),
    [anon_sym_quote] = ACTIONS(13558),
    [anon_sym_let] = ACTIONS(13558),
    [anon_sym_if] = ACTIONS(13558),
    [anon_sym_try] = ACTIONS(13558),
    [anon_sym_for] = ACTIONS(13558),
    [anon_sym_while] = ACTIONS(13558),
    [sym_break_statement] = ACTIONS(13558),
    [sym_continue_statement] = ACTIONS(13558),
    [anon_sym_return] = ACTIONS(13558),
    [anon_sym_const] = ACTIONS(13558),
    [anon_sym_global] = ACTIONS(13558),
    [anon_sym_local] = ACTIONS(13558),
    [anon_sym_LPAREN] = ACTIONS(13558),
    [anon_sym_RPAREN] = ACTIONS(13558),
    [anon_sym_COLON2] = ACTIONS(13558),
    [anon_sym_export] = ACTIONS(13558),
    [anon_sym_import] = ACTIONS(13558),
    [anon_sym_using] = ACTIONS(13558),
    [anon_sym_LBRACK] = ACTIONS(13558),
    [anon_sym_RBRACK] = ACTIONS(13558),
    [anon_sym_LF] = ACTIONS(13560),
    [anon_sym_in] = ACTIONS(13558),
    [anon_sym_LBRACE] = ACTIONS(13558),
    [anon_sym_DOLLAR] = ACTIONS(13558),
    [anon_sym_COLON_COLON] = ACTIONS(13558),
    [anon_sym_isa] = ACTIONS(13558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13558),
    [anon_sym_QMARK] = ACTIONS(13558),
    [anon_sym_AT] = ACTIONS(13558),
    [anon_sym_true] = ACTIONS(13558),
    [anon_sym_false] = ACTIONS(13558),
    [aux_sym_integer_literal_token1] = ACTIONS(13558),
    [aux_sym_integer_literal_token2] = ACTIONS(13558),
    [aux_sym_integer_literal_token3] = ACTIONS(13558),
    [aux_sym_integer_literal_token4] = ACTIONS(13558),
    [aux_sym_float_literal_token1] = ACTIONS(13558),
    [aux_sym_float_literal_token3] = ACTIONS(13558),
    [aux_sym_float_literal_token4] = ACTIONS(13558),
    [sym_character_literal] = ACTIONS(13558),
    [sym__pair_operator] = ACTIONS(13558),
    [sym__arrow_operator] = ACTIONS(13558),
    [sym__lazy_or_operator] = ACTIONS(13558),
    [sym__lazy_and_operator] = ACTIONS(13558),
    [sym__comparison_operator] = ACTIONS(13558),
    [sym__pipe_right_operator] = ACTIONS(13558),
    [sym__pipe_left_operator] = ACTIONS(13558),
    [sym__ellipsis_operator] = ACTIONS(13558),
    [sym__plus_operator] = ACTIONS(13558),
    [sym__times_operator] = ACTIONS(13558),
    [sym__rational_operator] = ACTIONS(13558),
    [sym__bitshift_operator] = ACTIONS(13558),
    [sym__power_operator] = ACTIONS(13558),
    [sym__tilde_operator] = ACTIONS(13558),
    [sym__type_order_operator] = ACTIONS(13558),
    [sym__unary_operator] = ACTIONS(13558),
    [sym__unary_plus_operator] = ACTIONS(13558),
    [aux_sym__terminator_token1] = ACTIONS(13558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13560),
    [sym__command_start] = ACTIONS(13560),
  },
  [7859] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_RPAREN] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_RBRACE] = ACTIONS(11864),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11864),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11864),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11864),
    [sym__pipe_left_operator] = ACTIONS(11864),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11864),
    [sym__bitshift_operator] = ACTIONS(11864),
    [sym__power_operator] = ACTIONS(11864),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11864),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [7860] = {
    [ts_builtin_sym_end] = ACTIONS(13564),
    [sym__word_identifier] = ACTIONS(13562),
    [anon_sym_EQ] = ACTIONS(13562),
    [anon_sym_COMMA] = ACTIONS(13562),
    [anon_sym_COLON] = ACTIONS(13562),
    [anon_sym_begin] = ACTIONS(13562),
    [anon_sym_module] = ACTIONS(13562),
    [anon_sym_baremodule] = ACTIONS(13562),
    [anon_sym_abstract] = ACTIONS(13562),
    [anon_sym_primitive] = ACTIONS(13562),
    [anon_sym_mutable] = ACTIONS(13562),
    [anon_sym_struct] = ACTIONS(13562),
    [anon_sym_function] = ACTIONS(13562),
    [anon_sym_macro] = ACTIONS(13562),
    [anon_sym_where] = ACTIONS(13562),
    [anon_sym_quote] = ACTIONS(13562),
    [anon_sym_let] = ACTIONS(13562),
    [anon_sym_if] = ACTIONS(13562),
    [anon_sym_try] = ACTIONS(13562),
    [anon_sym_for] = ACTIONS(13562),
    [anon_sym_while] = ACTIONS(13562),
    [sym_break_statement] = ACTIONS(13562),
    [sym_continue_statement] = ACTIONS(13562),
    [anon_sym_return] = ACTIONS(13562),
    [anon_sym_const] = ACTIONS(13562),
    [anon_sym_global] = ACTIONS(13562),
    [anon_sym_local] = ACTIONS(13562),
    [anon_sym_LPAREN] = ACTIONS(13562),
    [anon_sym_RPAREN] = ACTIONS(13562),
    [anon_sym_COLON2] = ACTIONS(13562),
    [anon_sym_export] = ACTIONS(13562),
    [anon_sym_import] = ACTIONS(13562),
    [anon_sym_using] = ACTIONS(13562),
    [anon_sym_LBRACK] = ACTIONS(13562),
    [anon_sym_RBRACK] = ACTIONS(13562),
    [anon_sym_LF] = ACTIONS(13564),
    [anon_sym_in] = ACTIONS(13562),
    [anon_sym_LBRACE] = ACTIONS(13562),
    [anon_sym_DOLLAR] = ACTIONS(13562),
    [anon_sym_COLON_COLON] = ACTIONS(13562),
    [anon_sym_isa] = ACTIONS(13562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13562),
    [anon_sym_QMARK] = ACTIONS(13562),
    [anon_sym_AT] = ACTIONS(13562),
    [anon_sym_true] = ACTIONS(13562),
    [anon_sym_false] = ACTIONS(13562),
    [aux_sym_integer_literal_token1] = ACTIONS(13562),
    [aux_sym_integer_literal_token2] = ACTIONS(13562),
    [aux_sym_integer_literal_token3] = ACTIONS(13562),
    [aux_sym_integer_literal_token4] = ACTIONS(13562),
    [aux_sym_float_literal_token1] = ACTIONS(13562),
    [aux_sym_float_literal_token3] = ACTIONS(13562),
    [aux_sym_float_literal_token4] = ACTIONS(13562),
    [sym_character_literal] = ACTIONS(13562),
    [sym__pair_operator] = ACTIONS(13562),
    [sym__arrow_operator] = ACTIONS(13562),
    [sym__lazy_or_operator] = ACTIONS(13562),
    [sym__lazy_and_operator] = ACTIONS(13562),
    [sym__comparison_operator] = ACTIONS(13562),
    [sym__pipe_right_operator] = ACTIONS(13562),
    [sym__pipe_left_operator] = ACTIONS(13562),
    [sym__ellipsis_operator] = ACTIONS(13562),
    [sym__plus_operator] = ACTIONS(13562),
    [sym__times_operator] = ACTIONS(13562),
    [sym__rational_operator] = ACTIONS(13562),
    [sym__bitshift_operator] = ACTIONS(13562),
    [sym__power_operator] = ACTIONS(13562),
    [sym__tilde_operator] = ACTIONS(13562),
    [sym__type_order_operator] = ACTIONS(13562),
    [sym__unary_operator] = ACTIONS(13562),
    [sym__unary_plus_operator] = ACTIONS(13562),
    [aux_sym__terminator_token1] = ACTIONS(13562),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13564),
    [sym__command_start] = ACTIONS(13564),
  },
  [7861] = {
    [sym__comprehension_clause] = STATE(18486),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16757),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14128),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14130),
    [anon_sym_LF] = ACTIONS(14132),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14135),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7862] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7863] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_catch] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [7864] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_catch] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [7865] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_catch] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [7866] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_catch] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [7867] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_catch] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [7868] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_catch] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [7869] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_catch] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [7870] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_catch] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [7871] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_catch] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [7872] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_catch] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [7873] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_catch] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [7874] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_catch] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [7875] = {
    [sym__comprehension_clause] = STATE(18786),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16910),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14138),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14140),
    [anon_sym_LF] = ACTIONS(14142),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14145),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7876] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_catch] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [7877] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_catch] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [7878] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_catch] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [7879] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_catch] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [7880] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_catch] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [7881] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_catch] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [7882] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_catch] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [7883] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_catch] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [7884] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_catch] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [7885] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_catch] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [7886] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_catch] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [7887] = {
    [sym__comprehension_clause] = STATE(19012),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17021),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14148),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14150),
    [anon_sym_LF] = ACTIONS(14152),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14155),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7888] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_catch] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [7889] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_catch] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [7890] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [7891] = {
    [ts_builtin_sym_end] = ACTIONS(13100),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13094),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_RPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13094),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_RBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13094),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13094),
    [anon_sym_isa] = ACTIONS(13094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13094),
    [anon_sym_QMARK] = ACTIONS(13094),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13094),
    [sym__lazy_or_operator] = ACTIONS(13094),
    [sym__lazy_and_operator] = ACTIONS(13094),
    [sym__comparison_operator] = ACTIONS(13094),
    [sym__pipe_right_operator] = ACTIONS(13094),
    [sym__pipe_left_operator] = ACTIONS(13094),
    [sym__ellipsis_operator] = ACTIONS(13094),
    [sym__plus_operator] = ACTIONS(13094),
    [sym__times_operator] = ACTIONS(13094),
    [sym__rational_operator] = ACTIONS(13094),
    [sym__bitshift_operator] = ACTIONS(13094),
    [sym__power_operator] = ACTIONS(13094),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13094),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13094),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [7892] = {
    [sym__comprehension_clause] = STATE(19191),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17168),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14158),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14160),
    [anon_sym_LF] = ACTIONS(14162),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14165),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7893] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_catch] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [7894] = {
    [ts_builtin_sym_end] = ACTIONS(13568),
    [sym__word_identifier] = ACTIONS(13566),
    [anon_sym_EQ] = ACTIONS(13566),
    [anon_sym_COMMA] = ACTIONS(13566),
    [anon_sym_COLON] = ACTIONS(13566),
    [anon_sym_begin] = ACTIONS(13566),
    [anon_sym_module] = ACTIONS(13566),
    [anon_sym_baremodule] = ACTIONS(13566),
    [anon_sym_abstract] = ACTIONS(13566),
    [anon_sym_primitive] = ACTIONS(13566),
    [anon_sym_mutable] = ACTIONS(13566),
    [anon_sym_struct] = ACTIONS(13566),
    [anon_sym_function] = ACTIONS(13566),
    [anon_sym_macro] = ACTIONS(13566),
    [anon_sym_where] = ACTIONS(13566),
    [anon_sym_quote] = ACTIONS(13566),
    [anon_sym_let] = ACTIONS(13566),
    [anon_sym_if] = ACTIONS(13566),
    [anon_sym_try] = ACTIONS(13566),
    [anon_sym_for] = ACTIONS(13566),
    [anon_sym_while] = ACTIONS(13566),
    [sym_break_statement] = ACTIONS(13566),
    [sym_continue_statement] = ACTIONS(13566),
    [anon_sym_return] = ACTIONS(13566),
    [anon_sym_const] = ACTIONS(13566),
    [anon_sym_global] = ACTIONS(13566),
    [anon_sym_local] = ACTIONS(13566),
    [anon_sym_LPAREN] = ACTIONS(13566),
    [anon_sym_RPAREN] = ACTIONS(13566),
    [anon_sym_COLON2] = ACTIONS(13566),
    [anon_sym_export] = ACTIONS(13566),
    [anon_sym_import] = ACTIONS(13566),
    [anon_sym_using] = ACTIONS(13566),
    [anon_sym_LBRACK] = ACTIONS(13566),
    [anon_sym_RBRACK] = ACTIONS(13566),
    [anon_sym_LF] = ACTIONS(13568),
    [anon_sym_in] = ACTIONS(13566),
    [anon_sym_LBRACE] = ACTIONS(13566),
    [anon_sym_DOLLAR] = ACTIONS(13566),
    [anon_sym_COLON_COLON] = ACTIONS(13566),
    [anon_sym_isa] = ACTIONS(13566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13566),
    [anon_sym_QMARK] = ACTIONS(13566),
    [anon_sym_AT] = ACTIONS(13566),
    [anon_sym_true] = ACTIONS(13566),
    [anon_sym_false] = ACTIONS(13566),
    [aux_sym_integer_literal_token1] = ACTIONS(13566),
    [aux_sym_integer_literal_token2] = ACTIONS(13566),
    [aux_sym_integer_literal_token3] = ACTIONS(13566),
    [aux_sym_integer_literal_token4] = ACTIONS(13566),
    [aux_sym_float_literal_token1] = ACTIONS(13566),
    [aux_sym_float_literal_token3] = ACTIONS(13566),
    [aux_sym_float_literal_token4] = ACTIONS(13566),
    [sym_character_literal] = ACTIONS(13566),
    [sym__pair_operator] = ACTIONS(13566),
    [sym__arrow_operator] = ACTIONS(13566),
    [sym__lazy_or_operator] = ACTIONS(13566),
    [sym__lazy_and_operator] = ACTIONS(13566),
    [sym__comparison_operator] = ACTIONS(13566),
    [sym__pipe_right_operator] = ACTIONS(13566),
    [sym__pipe_left_operator] = ACTIONS(13566),
    [sym__ellipsis_operator] = ACTIONS(13566),
    [sym__plus_operator] = ACTIONS(13566),
    [sym__times_operator] = ACTIONS(13566),
    [sym__rational_operator] = ACTIONS(13566),
    [sym__bitshift_operator] = ACTIONS(13566),
    [sym__power_operator] = ACTIONS(13566),
    [sym__tilde_operator] = ACTIONS(13566),
    [sym__type_order_operator] = ACTIONS(13566),
    [sym__unary_operator] = ACTIONS(13566),
    [sym__unary_plus_operator] = ACTIONS(13566),
    [aux_sym__terminator_token1] = ACTIONS(13566),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13568),
    [sym__command_start] = ACTIONS(13568),
  },
  [7895] = {
    [ts_builtin_sym_end] = ACTIONS(13572),
    [sym__word_identifier] = ACTIONS(13570),
    [anon_sym_EQ] = ACTIONS(13570),
    [anon_sym_COMMA] = ACTIONS(13570),
    [anon_sym_COLON] = ACTIONS(13570),
    [anon_sym_begin] = ACTIONS(13570),
    [anon_sym_module] = ACTIONS(13570),
    [anon_sym_baremodule] = ACTIONS(13570),
    [anon_sym_abstract] = ACTIONS(13570),
    [anon_sym_primitive] = ACTIONS(13570),
    [anon_sym_mutable] = ACTIONS(13570),
    [anon_sym_struct] = ACTIONS(13570),
    [anon_sym_function] = ACTIONS(13570),
    [anon_sym_macro] = ACTIONS(13570),
    [anon_sym_where] = ACTIONS(13570),
    [anon_sym_quote] = ACTIONS(13570),
    [anon_sym_let] = ACTIONS(13570),
    [anon_sym_if] = ACTIONS(13570),
    [anon_sym_try] = ACTIONS(13570),
    [anon_sym_for] = ACTIONS(13570),
    [anon_sym_while] = ACTIONS(13570),
    [sym_break_statement] = ACTIONS(13570),
    [sym_continue_statement] = ACTIONS(13570),
    [anon_sym_return] = ACTIONS(13570),
    [anon_sym_const] = ACTIONS(13570),
    [anon_sym_global] = ACTIONS(13570),
    [anon_sym_local] = ACTIONS(13570),
    [anon_sym_LPAREN] = ACTIONS(13570),
    [anon_sym_RPAREN] = ACTIONS(13570),
    [anon_sym_COLON2] = ACTIONS(13570),
    [anon_sym_export] = ACTIONS(13570),
    [anon_sym_import] = ACTIONS(13570),
    [anon_sym_using] = ACTIONS(13570),
    [anon_sym_LBRACK] = ACTIONS(13570),
    [anon_sym_RBRACK] = ACTIONS(13570),
    [anon_sym_LF] = ACTIONS(13572),
    [anon_sym_in] = ACTIONS(13570),
    [anon_sym_LBRACE] = ACTIONS(13570),
    [anon_sym_DOLLAR] = ACTIONS(13570),
    [anon_sym_COLON_COLON] = ACTIONS(13570),
    [anon_sym_isa] = ACTIONS(13570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13570),
    [anon_sym_QMARK] = ACTIONS(13570),
    [anon_sym_AT] = ACTIONS(13570),
    [anon_sym_true] = ACTIONS(13570),
    [anon_sym_false] = ACTIONS(13570),
    [aux_sym_integer_literal_token1] = ACTIONS(13570),
    [aux_sym_integer_literal_token2] = ACTIONS(13570),
    [aux_sym_integer_literal_token3] = ACTIONS(13570),
    [aux_sym_integer_literal_token4] = ACTIONS(13570),
    [aux_sym_float_literal_token1] = ACTIONS(13570),
    [aux_sym_float_literal_token3] = ACTIONS(13570),
    [aux_sym_float_literal_token4] = ACTIONS(13570),
    [sym_character_literal] = ACTIONS(13570),
    [sym__pair_operator] = ACTIONS(13570),
    [sym__arrow_operator] = ACTIONS(13570),
    [sym__lazy_or_operator] = ACTIONS(13570),
    [sym__lazy_and_operator] = ACTIONS(13570),
    [sym__comparison_operator] = ACTIONS(13570),
    [sym__pipe_right_operator] = ACTIONS(13570),
    [sym__pipe_left_operator] = ACTIONS(13570),
    [sym__ellipsis_operator] = ACTIONS(13570),
    [sym__plus_operator] = ACTIONS(13570),
    [sym__times_operator] = ACTIONS(13570),
    [sym__rational_operator] = ACTIONS(13570),
    [sym__bitshift_operator] = ACTIONS(13570),
    [sym__power_operator] = ACTIONS(13570),
    [sym__tilde_operator] = ACTIONS(13570),
    [sym__type_order_operator] = ACTIONS(13570),
    [sym__unary_operator] = ACTIONS(13570),
    [sym__unary_plus_operator] = ACTIONS(13570),
    [aux_sym__terminator_token1] = ACTIONS(13570),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13572),
    [sym__command_start] = ACTIONS(13572),
  },
  [7896] = {
    [ts_builtin_sym_end] = ACTIONS(13576),
    [sym__word_identifier] = ACTIONS(13574),
    [anon_sym_EQ] = ACTIONS(13574),
    [anon_sym_COMMA] = ACTIONS(13574),
    [anon_sym_COLON] = ACTIONS(13574),
    [anon_sym_begin] = ACTIONS(13574),
    [anon_sym_module] = ACTIONS(13574),
    [anon_sym_baremodule] = ACTIONS(13574),
    [anon_sym_abstract] = ACTIONS(13574),
    [anon_sym_primitive] = ACTIONS(13574),
    [anon_sym_mutable] = ACTIONS(13574),
    [anon_sym_struct] = ACTIONS(13574),
    [anon_sym_function] = ACTIONS(13574),
    [anon_sym_macro] = ACTIONS(13574),
    [anon_sym_where] = ACTIONS(13574),
    [anon_sym_quote] = ACTIONS(13574),
    [anon_sym_let] = ACTIONS(13574),
    [anon_sym_if] = ACTIONS(13574),
    [anon_sym_try] = ACTIONS(13574),
    [anon_sym_for] = ACTIONS(13574),
    [anon_sym_while] = ACTIONS(13574),
    [sym_break_statement] = ACTIONS(13574),
    [sym_continue_statement] = ACTIONS(13574),
    [anon_sym_return] = ACTIONS(13574),
    [anon_sym_const] = ACTIONS(13574),
    [anon_sym_global] = ACTIONS(13574),
    [anon_sym_local] = ACTIONS(13574),
    [anon_sym_LPAREN] = ACTIONS(13574),
    [anon_sym_RPAREN] = ACTIONS(13574),
    [anon_sym_COLON2] = ACTIONS(13574),
    [anon_sym_export] = ACTIONS(13574),
    [anon_sym_import] = ACTIONS(13574),
    [anon_sym_using] = ACTIONS(13574),
    [anon_sym_LBRACK] = ACTIONS(13574),
    [anon_sym_RBRACK] = ACTIONS(13574),
    [anon_sym_LF] = ACTIONS(13576),
    [anon_sym_in] = ACTIONS(13574),
    [anon_sym_LBRACE] = ACTIONS(13574),
    [anon_sym_DOLLAR] = ACTIONS(13574),
    [anon_sym_COLON_COLON] = ACTIONS(13574),
    [anon_sym_isa] = ACTIONS(13574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13574),
    [anon_sym_QMARK] = ACTIONS(13574),
    [anon_sym_AT] = ACTIONS(13574),
    [anon_sym_true] = ACTIONS(13574),
    [anon_sym_false] = ACTIONS(13574),
    [aux_sym_integer_literal_token1] = ACTIONS(13574),
    [aux_sym_integer_literal_token2] = ACTIONS(13574),
    [aux_sym_integer_literal_token3] = ACTIONS(13574),
    [aux_sym_integer_literal_token4] = ACTIONS(13574),
    [aux_sym_float_literal_token1] = ACTIONS(13574),
    [aux_sym_float_literal_token3] = ACTIONS(13574),
    [aux_sym_float_literal_token4] = ACTIONS(13574),
    [sym_character_literal] = ACTIONS(13574),
    [sym__pair_operator] = ACTIONS(13574),
    [sym__arrow_operator] = ACTIONS(13574),
    [sym__lazy_or_operator] = ACTIONS(13574),
    [sym__lazy_and_operator] = ACTIONS(13574),
    [sym__comparison_operator] = ACTIONS(13574),
    [sym__pipe_right_operator] = ACTIONS(13574),
    [sym__pipe_left_operator] = ACTIONS(13574),
    [sym__ellipsis_operator] = ACTIONS(13574),
    [sym__plus_operator] = ACTIONS(13574),
    [sym__times_operator] = ACTIONS(13574),
    [sym__rational_operator] = ACTIONS(13574),
    [sym__bitshift_operator] = ACTIONS(13574),
    [sym__power_operator] = ACTIONS(13574),
    [sym__tilde_operator] = ACTIONS(13574),
    [sym__type_order_operator] = ACTIONS(13574),
    [sym__unary_operator] = ACTIONS(13574),
    [sym__unary_plus_operator] = ACTIONS(13574),
    [aux_sym__terminator_token1] = ACTIONS(13574),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13576),
    [sym__command_start] = ACTIONS(13576),
  },
  [7897] = {
    [ts_builtin_sym_end] = ACTIONS(13580),
    [sym__word_identifier] = ACTIONS(13578),
    [anon_sym_EQ] = ACTIONS(13578),
    [anon_sym_COMMA] = ACTIONS(13578),
    [anon_sym_COLON] = ACTIONS(13578),
    [anon_sym_begin] = ACTIONS(13578),
    [anon_sym_module] = ACTIONS(13578),
    [anon_sym_baremodule] = ACTIONS(13578),
    [anon_sym_abstract] = ACTIONS(13578),
    [anon_sym_primitive] = ACTIONS(13578),
    [anon_sym_mutable] = ACTIONS(13578),
    [anon_sym_struct] = ACTIONS(13578),
    [anon_sym_function] = ACTIONS(13578),
    [anon_sym_macro] = ACTIONS(13578),
    [anon_sym_where] = ACTIONS(13578),
    [anon_sym_quote] = ACTIONS(13578),
    [anon_sym_let] = ACTIONS(13578),
    [anon_sym_if] = ACTIONS(13578),
    [anon_sym_try] = ACTIONS(13578),
    [anon_sym_for] = ACTIONS(13578),
    [anon_sym_while] = ACTIONS(13578),
    [sym_break_statement] = ACTIONS(13578),
    [sym_continue_statement] = ACTIONS(13578),
    [anon_sym_return] = ACTIONS(13578),
    [anon_sym_const] = ACTIONS(13578),
    [anon_sym_global] = ACTIONS(13578),
    [anon_sym_local] = ACTIONS(13578),
    [anon_sym_LPAREN] = ACTIONS(13578),
    [anon_sym_RPAREN] = ACTIONS(13578),
    [anon_sym_COLON2] = ACTIONS(13578),
    [anon_sym_export] = ACTIONS(13578),
    [anon_sym_import] = ACTIONS(13578),
    [anon_sym_using] = ACTIONS(13578),
    [anon_sym_LBRACK] = ACTIONS(13578),
    [anon_sym_RBRACK] = ACTIONS(13578),
    [anon_sym_LF] = ACTIONS(13580),
    [anon_sym_in] = ACTIONS(13578),
    [anon_sym_LBRACE] = ACTIONS(13578),
    [anon_sym_DOLLAR] = ACTIONS(13578),
    [anon_sym_COLON_COLON] = ACTIONS(13578),
    [anon_sym_isa] = ACTIONS(13578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13578),
    [anon_sym_QMARK] = ACTIONS(13578),
    [anon_sym_AT] = ACTIONS(13578),
    [anon_sym_true] = ACTIONS(13578),
    [anon_sym_false] = ACTIONS(13578),
    [aux_sym_integer_literal_token1] = ACTIONS(13578),
    [aux_sym_integer_literal_token2] = ACTIONS(13578),
    [aux_sym_integer_literal_token3] = ACTIONS(13578),
    [aux_sym_integer_literal_token4] = ACTIONS(13578),
    [aux_sym_float_literal_token1] = ACTIONS(13578),
    [aux_sym_float_literal_token3] = ACTIONS(13578),
    [aux_sym_float_literal_token4] = ACTIONS(13578),
    [sym_character_literal] = ACTIONS(13578),
    [sym__pair_operator] = ACTIONS(13578),
    [sym__arrow_operator] = ACTIONS(13578),
    [sym__lazy_or_operator] = ACTIONS(13578),
    [sym__lazy_and_operator] = ACTIONS(13578),
    [sym__comparison_operator] = ACTIONS(13578),
    [sym__pipe_right_operator] = ACTIONS(13578),
    [sym__pipe_left_operator] = ACTIONS(13578),
    [sym__ellipsis_operator] = ACTIONS(13578),
    [sym__plus_operator] = ACTIONS(13578),
    [sym__times_operator] = ACTIONS(13578),
    [sym__rational_operator] = ACTIONS(13578),
    [sym__bitshift_operator] = ACTIONS(13578),
    [sym__power_operator] = ACTIONS(13578),
    [sym__tilde_operator] = ACTIONS(13578),
    [sym__type_order_operator] = ACTIONS(13578),
    [sym__unary_operator] = ACTIONS(13578),
    [sym__unary_plus_operator] = ACTIONS(13578),
    [aux_sym__terminator_token1] = ACTIONS(13578),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13580),
    [sym__command_start] = ACTIONS(13580),
  },
  [7898] = {
    [ts_builtin_sym_end] = ACTIONS(13584),
    [sym__word_identifier] = ACTIONS(13582),
    [anon_sym_EQ] = ACTIONS(13582),
    [anon_sym_COMMA] = ACTIONS(13582),
    [anon_sym_COLON] = ACTIONS(13582),
    [anon_sym_begin] = ACTIONS(13582),
    [anon_sym_module] = ACTIONS(13582),
    [anon_sym_baremodule] = ACTIONS(13582),
    [anon_sym_abstract] = ACTIONS(13582),
    [anon_sym_primitive] = ACTIONS(13582),
    [anon_sym_mutable] = ACTIONS(13582),
    [anon_sym_struct] = ACTIONS(13582),
    [anon_sym_function] = ACTIONS(13582),
    [anon_sym_macro] = ACTIONS(13582),
    [anon_sym_where] = ACTIONS(13582),
    [anon_sym_quote] = ACTIONS(13582),
    [anon_sym_let] = ACTIONS(13582),
    [anon_sym_if] = ACTIONS(13582),
    [anon_sym_try] = ACTIONS(13582),
    [anon_sym_for] = ACTIONS(13582),
    [anon_sym_while] = ACTIONS(13582),
    [sym_break_statement] = ACTIONS(13582),
    [sym_continue_statement] = ACTIONS(13582),
    [anon_sym_return] = ACTIONS(13582),
    [anon_sym_const] = ACTIONS(13582),
    [anon_sym_global] = ACTIONS(13582),
    [anon_sym_local] = ACTIONS(13582),
    [anon_sym_LPAREN] = ACTIONS(13582),
    [anon_sym_RPAREN] = ACTIONS(13582),
    [anon_sym_COLON2] = ACTIONS(13582),
    [anon_sym_export] = ACTIONS(13582),
    [anon_sym_import] = ACTIONS(13582),
    [anon_sym_using] = ACTIONS(13582),
    [anon_sym_LBRACK] = ACTIONS(13582),
    [anon_sym_RBRACK] = ACTIONS(13582),
    [anon_sym_LF] = ACTIONS(13584),
    [anon_sym_in] = ACTIONS(13582),
    [anon_sym_LBRACE] = ACTIONS(13582),
    [anon_sym_DOLLAR] = ACTIONS(13582),
    [anon_sym_COLON_COLON] = ACTIONS(13582),
    [anon_sym_isa] = ACTIONS(13582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13582),
    [anon_sym_QMARK] = ACTIONS(13582),
    [anon_sym_AT] = ACTIONS(13582),
    [anon_sym_true] = ACTIONS(13582),
    [anon_sym_false] = ACTIONS(13582),
    [aux_sym_integer_literal_token1] = ACTIONS(13582),
    [aux_sym_integer_literal_token2] = ACTIONS(13582),
    [aux_sym_integer_literal_token3] = ACTIONS(13582),
    [aux_sym_integer_literal_token4] = ACTIONS(13582),
    [aux_sym_float_literal_token1] = ACTIONS(13582),
    [aux_sym_float_literal_token3] = ACTIONS(13582),
    [aux_sym_float_literal_token4] = ACTIONS(13582),
    [sym_character_literal] = ACTIONS(13582),
    [sym__pair_operator] = ACTIONS(13582),
    [sym__arrow_operator] = ACTIONS(13582),
    [sym__lazy_or_operator] = ACTIONS(13582),
    [sym__lazy_and_operator] = ACTIONS(13582),
    [sym__comparison_operator] = ACTIONS(13582),
    [sym__pipe_right_operator] = ACTIONS(13582),
    [sym__pipe_left_operator] = ACTIONS(13582),
    [sym__ellipsis_operator] = ACTIONS(13582),
    [sym__plus_operator] = ACTIONS(13582),
    [sym__times_operator] = ACTIONS(13582),
    [sym__rational_operator] = ACTIONS(13582),
    [sym__bitshift_operator] = ACTIONS(13582),
    [sym__power_operator] = ACTIONS(13582),
    [sym__tilde_operator] = ACTIONS(13582),
    [sym__type_order_operator] = ACTIONS(13582),
    [sym__unary_operator] = ACTIONS(13582),
    [sym__unary_plus_operator] = ACTIONS(13582),
    [aux_sym__terminator_token1] = ACTIONS(13582),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13584),
    [sym__command_start] = ACTIONS(13584),
  },
  [7899] = {
    [ts_builtin_sym_end] = ACTIONS(13588),
    [sym__word_identifier] = ACTIONS(13586),
    [anon_sym_EQ] = ACTIONS(13586),
    [anon_sym_COMMA] = ACTIONS(13586),
    [anon_sym_COLON] = ACTIONS(13586),
    [anon_sym_begin] = ACTIONS(13586),
    [anon_sym_module] = ACTIONS(13586),
    [anon_sym_baremodule] = ACTIONS(13586),
    [anon_sym_abstract] = ACTIONS(13586),
    [anon_sym_primitive] = ACTIONS(13586),
    [anon_sym_mutable] = ACTIONS(13586),
    [anon_sym_struct] = ACTIONS(13586),
    [anon_sym_function] = ACTIONS(13586),
    [anon_sym_macro] = ACTIONS(13586),
    [anon_sym_where] = ACTIONS(13586),
    [anon_sym_quote] = ACTIONS(13586),
    [anon_sym_let] = ACTIONS(13586),
    [anon_sym_if] = ACTIONS(13586),
    [anon_sym_try] = ACTIONS(13586),
    [anon_sym_for] = ACTIONS(13586),
    [anon_sym_while] = ACTIONS(13586),
    [sym_break_statement] = ACTIONS(13586),
    [sym_continue_statement] = ACTIONS(13586),
    [anon_sym_return] = ACTIONS(13586),
    [anon_sym_const] = ACTIONS(13586),
    [anon_sym_global] = ACTIONS(13586),
    [anon_sym_local] = ACTIONS(13586),
    [anon_sym_LPAREN] = ACTIONS(13586),
    [anon_sym_RPAREN] = ACTIONS(13586),
    [anon_sym_COLON2] = ACTIONS(13586),
    [anon_sym_export] = ACTIONS(13586),
    [anon_sym_import] = ACTIONS(13586),
    [anon_sym_using] = ACTIONS(13586),
    [anon_sym_LBRACK] = ACTIONS(13586),
    [anon_sym_RBRACK] = ACTIONS(13586),
    [anon_sym_LF] = ACTIONS(13588),
    [anon_sym_in] = ACTIONS(13586),
    [anon_sym_LBRACE] = ACTIONS(13586),
    [anon_sym_DOLLAR] = ACTIONS(13586),
    [anon_sym_COLON_COLON] = ACTIONS(13586),
    [anon_sym_isa] = ACTIONS(13586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13586),
    [anon_sym_QMARK] = ACTIONS(13586),
    [anon_sym_AT] = ACTIONS(13586),
    [anon_sym_true] = ACTIONS(13586),
    [anon_sym_false] = ACTIONS(13586),
    [aux_sym_integer_literal_token1] = ACTIONS(13586),
    [aux_sym_integer_literal_token2] = ACTIONS(13586),
    [aux_sym_integer_literal_token3] = ACTIONS(13586),
    [aux_sym_integer_literal_token4] = ACTIONS(13586),
    [aux_sym_float_literal_token1] = ACTIONS(13586),
    [aux_sym_float_literal_token3] = ACTIONS(13586),
    [aux_sym_float_literal_token4] = ACTIONS(13586),
    [sym_character_literal] = ACTIONS(13586),
    [sym__pair_operator] = ACTIONS(13586),
    [sym__arrow_operator] = ACTIONS(13586),
    [sym__lazy_or_operator] = ACTIONS(13586),
    [sym__lazy_and_operator] = ACTIONS(13586),
    [sym__comparison_operator] = ACTIONS(13586),
    [sym__pipe_right_operator] = ACTIONS(13586),
    [sym__pipe_left_operator] = ACTIONS(13586),
    [sym__ellipsis_operator] = ACTIONS(13586),
    [sym__plus_operator] = ACTIONS(13586),
    [sym__times_operator] = ACTIONS(13586),
    [sym__rational_operator] = ACTIONS(13586),
    [sym__bitshift_operator] = ACTIONS(13586),
    [sym__power_operator] = ACTIONS(13586),
    [sym__tilde_operator] = ACTIONS(13586),
    [sym__type_order_operator] = ACTIONS(13586),
    [sym__unary_operator] = ACTIONS(13586),
    [sym__unary_plus_operator] = ACTIONS(13586),
    [aux_sym__terminator_token1] = ACTIONS(13586),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13588),
    [sym__command_start] = ACTIONS(13588),
  },
  [7900] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7901] = {
    [ts_builtin_sym_end] = ACTIONS(13592),
    [sym__word_identifier] = ACTIONS(13590),
    [anon_sym_EQ] = ACTIONS(13590),
    [anon_sym_COMMA] = ACTIONS(13590),
    [anon_sym_COLON] = ACTIONS(13590),
    [anon_sym_begin] = ACTIONS(13590),
    [anon_sym_module] = ACTIONS(13590),
    [anon_sym_baremodule] = ACTIONS(13590),
    [anon_sym_abstract] = ACTIONS(13590),
    [anon_sym_primitive] = ACTIONS(13590),
    [anon_sym_mutable] = ACTIONS(13590),
    [anon_sym_struct] = ACTIONS(13590),
    [anon_sym_function] = ACTIONS(13590),
    [anon_sym_macro] = ACTIONS(13590),
    [anon_sym_where] = ACTIONS(13590),
    [anon_sym_quote] = ACTIONS(13590),
    [anon_sym_let] = ACTIONS(13590),
    [anon_sym_if] = ACTIONS(13590),
    [anon_sym_try] = ACTIONS(13590),
    [anon_sym_for] = ACTIONS(13590),
    [anon_sym_while] = ACTIONS(13590),
    [sym_break_statement] = ACTIONS(13590),
    [sym_continue_statement] = ACTIONS(13590),
    [anon_sym_return] = ACTIONS(13590),
    [anon_sym_const] = ACTIONS(13590),
    [anon_sym_global] = ACTIONS(13590),
    [anon_sym_local] = ACTIONS(13590),
    [anon_sym_LPAREN] = ACTIONS(13590),
    [anon_sym_RPAREN] = ACTIONS(13590),
    [anon_sym_COLON2] = ACTIONS(13590),
    [anon_sym_export] = ACTIONS(13590),
    [anon_sym_import] = ACTIONS(13590),
    [anon_sym_using] = ACTIONS(13590),
    [anon_sym_LBRACK] = ACTIONS(13590),
    [anon_sym_RBRACK] = ACTIONS(13590),
    [anon_sym_LF] = ACTIONS(13592),
    [anon_sym_in] = ACTIONS(13590),
    [anon_sym_LBRACE] = ACTIONS(13590),
    [anon_sym_DOLLAR] = ACTIONS(13590),
    [anon_sym_COLON_COLON] = ACTIONS(13590),
    [anon_sym_isa] = ACTIONS(13590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13590),
    [anon_sym_QMARK] = ACTIONS(13590),
    [anon_sym_AT] = ACTIONS(13590),
    [anon_sym_true] = ACTIONS(13590),
    [anon_sym_false] = ACTIONS(13590),
    [aux_sym_integer_literal_token1] = ACTIONS(13590),
    [aux_sym_integer_literal_token2] = ACTIONS(13590),
    [aux_sym_integer_literal_token3] = ACTIONS(13590),
    [aux_sym_integer_literal_token4] = ACTIONS(13590),
    [aux_sym_float_literal_token1] = ACTIONS(13590),
    [aux_sym_float_literal_token3] = ACTIONS(13590),
    [aux_sym_float_literal_token4] = ACTIONS(13590),
    [sym_character_literal] = ACTIONS(13590),
    [sym__pair_operator] = ACTIONS(13590),
    [sym__arrow_operator] = ACTIONS(13590),
    [sym__lazy_or_operator] = ACTIONS(13590),
    [sym__lazy_and_operator] = ACTIONS(13590),
    [sym__comparison_operator] = ACTIONS(13590),
    [sym__pipe_right_operator] = ACTIONS(13590),
    [sym__pipe_left_operator] = ACTIONS(13590),
    [sym__ellipsis_operator] = ACTIONS(13590),
    [sym__plus_operator] = ACTIONS(13590),
    [sym__times_operator] = ACTIONS(13590),
    [sym__rational_operator] = ACTIONS(13590),
    [sym__bitshift_operator] = ACTIONS(13590),
    [sym__power_operator] = ACTIONS(13590),
    [sym__tilde_operator] = ACTIONS(13590),
    [sym__type_order_operator] = ACTIONS(13590),
    [sym__unary_operator] = ACTIONS(13590),
    [sym__unary_plus_operator] = ACTIONS(13590),
    [aux_sym__terminator_token1] = ACTIONS(13590),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13592),
    [sym__command_start] = ACTIONS(13592),
  },
  [7902] = {
    [ts_builtin_sym_end] = ACTIONS(13596),
    [sym__word_identifier] = ACTIONS(13594),
    [anon_sym_EQ] = ACTIONS(13594),
    [anon_sym_COMMA] = ACTIONS(13594),
    [anon_sym_COLON] = ACTIONS(13594),
    [anon_sym_begin] = ACTIONS(13594),
    [anon_sym_module] = ACTIONS(13594),
    [anon_sym_baremodule] = ACTIONS(13594),
    [anon_sym_abstract] = ACTIONS(13594),
    [anon_sym_primitive] = ACTIONS(13594),
    [anon_sym_mutable] = ACTIONS(13594),
    [anon_sym_struct] = ACTIONS(13594),
    [anon_sym_function] = ACTIONS(13594),
    [anon_sym_macro] = ACTIONS(13594),
    [anon_sym_where] = ACTIONS(13594),
    [anon_sym_quote] = ACTIONS(13594),
    [anon_sym_let] = ACTIONS(13594),
    [anon_sym_if] = ACTIONS(13594),
    [anon_sym_try] = ACTIONS(13594),
    [anon_sym_for] = ACTIONS(13594),
    [anon_sym_while] = ACTIONS(13594),
    [sym_break_statement] = ACTIONS(13594),
    [sym_continue_statement] = ACTIONS(13594),
    [anon_sym_return] = ACTIONS(13594),
    [anon_sym_const] = ACTIONS(13594),
    [anon_sym_global] = ACTIONS(13594),
    [anon_sym_local] = ACTIONS(13594),
    [anon_sym_LPAREN] = ACTIONS(13594),
    [anon_sym_RPAREN] = ACTIONS(13594),
    [anon_sym_COLON2] = ACTIONS(13594),
    [anon_sym_export] = ACTIONS(13594),
    [anon_sym_import] = ACTIONS(13594),
    [anon_sym_using] = ACTIONS(13594),
    [anon_sym_LBRACK] = ACTIONS(13594),
    [anon_sym_RBRACK] = ACTIONS(13594),
    [anon_sym_LF] = ACTIONS(13596),
    [anon_sym_in] = ACTIONS(13594),
    [anon_sym_LBRACE] = ACTIONS(13594),
    [anon_sym_DOLLAR] = ACTIONS(13594),
    [anon_sym_COLON_COLON] = ACTIONS(13594),
    [anon_sym_isa] = ACTIONS(13594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13594),
    [anon_sym_QMARK] = ACTIONS(13594),
    [anon_sym_AT] = ACTIONS(13594),
    [anon_sym_true] = ACTIONS(13594),
    [anon_sym_false] = ACTIONS(13594),
    [aux_sym_integer_literal_token1] = ACTIONS(13594),
    [aux_sym_integer_literal_token2] = ACTIONS(13594),
    [aux_sym_integer_literal_token3] = ACTIONS(13594),
    [aux_sym_integer_literal_token4] = ACTIONS(13594),
    [aux_sym_float_literal_token1] = ACTIONS(13594),
    [aux_sym_float_literal_token3] = ACTIONS(13594),
    [aux_sym_float_literal_token4] = ACTIONS(13594),
    [sym_character_literal] = ACTIONS(13594),
    [sym__pair_operator] = ACTIONS(13594),
    [sym__arrow_operator] = ACTIONS(13594),
    [sym__lazy_or_operator] = ACTIONS(13594),
    [sym__lazy_and_operator] = ACTIONS(13594),
    [sym__comparison_operator] = ACTIONS(13594),
    [sym__pipe_right_operator] = ACTIONS(13594),
    [sym__pipe_left_operator] = ACTIONS(13594),
    [sym__ellipsis_operator] = ACTIONS(13594),
    [sym__plus_operator] = ACTIONS(13594),
    [sym__times_operator] = ACTIONS(13594),
    [sym__rational_operator] = ACTIONS(13594),
    [sym__bitshift_operator] = ACTIONS(13594),
    [sym__power_operator] = ACTIONS(13594),
    [sym__tilde_operator] = ACTIONS(13594),
    [sym__type_order_operator] = ACTIONS(13594),
    [sym__unary_operator] = ACTIONS(13594),
    [sym__unary_plus_operator] = ACTIONS(13594),
    [aux_sym__terminator_token1] = ACTIONS(13594),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13596),
    [sym__command_start] = ACTIONS(13596),
  },
  [7903] = {
    [ts_builtin_sym_end] = ACTIONS(13600),
    [sym__word_identifier] = ACTIONS(13598),
    [anon_sym_EQ] = ACTIONS(13598),
    [anon_sym_COMMA] = ACTIONS(13598),
    [anon_sym_COLON] = ACTIONS(13598),
    [anon_sym_begin] = ACTIONS(13598),
    [anon_sym_module] = ACTIONS(13598),
    [anon_sym_baremodule] = ACTIONS(13598),
    [anon_sym_abstract] = ACTIONS(13598),
    [anon_sym_primitive] = ACTIONS(13598),
    [anon_sym_mutable] = ACTIONS(13598),
    [anon_sym_struct] = ACTIONS(13598),
    [anon_sym_function] = ACTIONS(13598),
    [anon_sym_macro] = ACTIONS(13598),
    [anon_sym_where] = ACTIONS(13598),
    [anon_sym_quote] = ACTIONS(13598),
    [anon_sym_let] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(13598),
    [anon_sym_try] = ACTIONS(13598),
    [anon_sym_for] = ACTIONS(13598),
    [anon_sym_while] = ACTIONS(13598),
    [sym_break_statement] = ACTIONS(13598),
    [sym_continue_statement] = ACTIONS(13598),
    [anon_sym_return] = ACTIONS(13598),
    [anon_sym_const] = ACTIONS(13598),
    [anon_sym_global] = ACTIONS(13598),
    [anon_sym_local] = ACTIONS(13598),
    [anon_sym_LPAREN] = ACTIONS(13598),
    [anon_sym_RPAREN] = ACTIONS(13598),
    [anon_sym_COLON2] = ACTIONS(13598),
    [anon_sym_export] = ACTIONS(13598),
    [anon_sym_import] = ACTIONS(13598),
    [anon_sym_using] = ACTIONS(13598),
    [anon_sym_LBRACK] = ACTIONS(13598),
    [anon_sym_RBRACK] = ACTIONS(13598),
    [anon_sym_LF] = ACTIONS(13600),
    [anon_sym_in] = ACTIONS(13598),
    [anon_sym_LBRACE] = ACTIONS(13598),
    [anon_sym_DOLLAR] = ACTIONS(13598),
    [anon_sym_COLON_COLON] = ACTIONS(13598),
    [anon_sym_isa] = ACTIONS(13598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13598),
    [anon_sym_QMARK] = ACTIONS(13598),
    [anon_sym_AT] = ACTIONS(13598),
    [anon_sym_true] = ACTIONS(13598),
    [anon_sym_false] = ACTIONS(13598),
    [aux_sym_integer_literal_token1] = ACTIONS(13598),
    [aux_sym_integer_literal_token2] = ACTIONS(13598),
    [aux_sym_integer_literal_token3] = ACTIONS(13598),
    [aux_sym_integer_literal_token4] = ACTIONS(13598),
    [aux_sym_float_literal_token1] = ACTIONS(13598),
    [aux_sym_float_literal_token3] = ACTIONS(13598),
    [aux_sym_float_literal_token4] = ACTIONS(13598),
    [sym_character_literal] = ACTIONS(13598),
    [sym__pair_operator] = ACTIONS(13598),
    [sym__arrow_operator] = ACTIONS(13598),
    [sym__lazy_or_operator] = ACTIONS(13598),
    [sym__lazy_and_operator] = ACTIONS(13598),
    [sym__comparison_operator] = ACTIONS(13598),
    [sym__pipe_right_operator] = ACTIONS(13598),
    [sym__pipe_left_operator] = ACTIONS(13598),
    [sym__ellipsis_operator] = ACTIONS(13598),
    [sym__plus_operator] = ACTIONS(13598),
    [sym__times_operator] = ACTIONS(13598),
    [sym__rational_operator] = ACTIONS(13598),
    [sym__bitshift_operator] = ACTIONS(13598),
    [sym__power_operator] = ACTIONS(13598),
    [sym__tilde_operator] = ACTIONS(13598),
    [sym__type_order_operator] = ACTIONS(13598),
    [sym__unary_operator] = ACTIONS(13598),
    [sym__unary_plus_operator] = ACTIONS(13598),
    [aux_sym__terminator_token1] = ACTIONS(13598),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13600),
    [sym__command_start] = ACTIONS(13600),
  },
  [7904] = {
    [sym__comprehension_clause] = STATE(19555),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17245),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14168),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14170),
    [anon_sym_LF] = ACTIONS(14172),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14175),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7905] = {
    [ts_builtin_sym_end] = ACTIONS(13604),
    [sym__word_identifier] = ACTIONS(13602),
    [anon_sym_EQ] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(13602),
    [anon_sym_COLON] = ACTIONS(13602),
    [anon_sym_begin] = ACTIONS(13602),
    [anon_sym_module] = ACTIONS(13602),
    [anon_sym_baremodule] = ACTIONS(13602),
    [anon_sym_abstract] = ACTIONS(13602),
    [anon_sym_primitive] = ACTIONS(13602),
    [anon_sym_mutable] = ACTIONS(13602),
    [anon_sym_struct] = ACTIONS(13602),
    [anon_sym_function] = ACTIONS(13602),
    [anon_sym_macro] = ACTIONS(13602),
    [anon_sym_where] = ACTIONS(13602),
    [anon_sym_quote] = ACTIONS(13602),
    [anon_sym_let] = ACTIONS(13602),
    [anon_sym_if] = ACTIONS(13602),
    [anon_sym_try] = ACTIONS(13602),
    [anon_sym_for] = ACTIONS(13602),
    [anon_sym_while] = ACTIONS(13602),
    [sym_break_statement] = ACTIONS(13602),
    [sym_continue_statement] = ACTIONS(13602),
    [anon_sym_return] = ACTIONS(13602),
    [anon_sym_const] = ACTIONS(13602),
    [anon_sym_global] = ACTIONS(13602),
    [anon_sym_local] = ACTIONS(13602),
    [anon_sym_LPAREN] = ACTIONS(13602),
    [anon_sym_RPAREN] = ACTIONS(13602),
    [anon_sym_COLON2] = ACTIONS(13602),
    [anon_sym_export] = ACTIONS(13602),
    [anon_sym_import] = ACTIONS(13602),
    [anon_sym_using] = ACTIONS(13602),
    [anon_sym_LBRACK] = ACTIONS(13602),
    [anon_sym_RBRACK] = ACTIONS(13602),
    [anon_sym_LF] = ACTIONS(13604),
    [anon_sym_in] = ACTIONS(13602),
    [anon_sym_LBRACE] = ACTIONS(13602),
    [anon_sym_DOLLAR] = ACTIONS(13602),
    [anon_sym_COLON_COLON] = ACTIONS(13602),
    [anon_sym_isa] = ACTIONS(13602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13602),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_AT] = ACTIONS(13602),
    [anon_sym_true] = ACTIONS(13602),
    [anon_sym_false] = ACTIONS(13602),
    [aux_sym_integer_literal_token1] = ACTIONS(13602),
    [aux_sym_integer_literal_token2] = ACTIONS(13602),
    [aux_sym_integer_literal_token3] = ACTIONS(13602),
    [aux_sym_integer_literal_token4] = ACTIONS(13602),
    [aux_sym_float_literal_token1] = ACTIONS(13602),
    [aux_sym_float_literal_token3] = ACTIONS(13602),
    [aux_sym_float_literal_token4] = ACTIONS(13602),
    [sym_character_literal] = ACTIONS(13602),
    [sym__pair_operator] = ACTIONS(13602),
    [sym__arrow_operator] = ACTIONS(13602),
    [sym__lazy_or_operator] = ACTIONS(13602),
    [sym__lazy_and_operator] = ACTIONS(13602),
    [sym__comparison_operator] = ACTIONS(13602),
    [sym__pipe_right_operator] = ACTIONS(13602),
    [sym__pipe_left_operator] = ACTIONS(13602),
    [sym__ellipsis_operator] = ACTIONS(13602),
    [sym__plus_operator] = ACTIONS(13602),
    [sym__times_operator] = ACTIONS(13602),
    [sym__rational_operator] = ACTIONS(13602),
    [sym__bitshift_operator] = ACTIONS(13602),
    [sym__power_operator] = ACTIONS(13602),
    [sym__tilde_operator] = ACTIONS(13602),
    [sym__type_order_operator] = ACTIONS(13602),
    [sym__unary_operator] = ACTIONS(13602),
    [sym__unary_plus_operator] = ACTIONS(13602),
    [aux_sym__terminator_token1] = ACTIONS(13602),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13604),
    [sym__command_start] = ACTIONS(13604),
  },
  [7906] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_catch] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [7907] = {
    [ts_builtin_sym_end] = ACTIONS(13608),
    [sym__word_identifier] = ACTIONS(13606),
    [anon_sym_EQ] = ACTIONS(13606),
    [anon_sym_COMMA] = ACTIONS(13606),
    [anon_sym_COLON] = ACTIONS(13606),
    [anon_sym_begin] = ACTIONS(13606),
    [anon_sym_module] = ACTIONS(13606),
    [anon_sym_baremodule] = ACTIONS(13606),
    [anon_sym_abstract] = ACTIONS(13606),
    [anon_sym_primitive] = ACTIONS(13606),
    [anon_sym_mutable] = ACTIONS(13606),
    [anon_sym_struct] = ACTIONS(13606),
    [anon_sym_function] = ACTIONS(13606),
    [anon_sym_macro] = ACTIONS(13606),
    [anon_sym_where] = ACTIONS(13606),
    [anon_sym_quote] = ACTIONS(13606),
    [anon_sym_let] = ACTIONS(13606),
    [anon_sym_if] = ACTIONS(13606),
    [anon_sym_try] = ACTIONS(13606),
    [anon_sym_for] = ACTIONS(13606),
    [anon_sym_while] = ACTIONS(13606),
    [sym_break_statement] = ACTIONS(13606),
    [sym_continue_statement] = ACTIONS(13606),
    [anon_sym_return] = ACTIONS(13606),
    [anon_sym_const] = ACTIONS(13606),
    [anon_sym_global] = ACTIONS(13606),
    [anon_sym_local] = ACTIONS(13606),
    [anon_sym_LPAREN] = ACTIONS(13606),
    [anon_sym_RPAREN] = ACTIONS(13606),
    [anon_sym_COLON2] = ACTIONS(13606),
    [anon_sym_export] = ACTIONS(13606),
    [anon_sym_import] = ACTIONS(13606),
    [anon_sym_using] = ACTIONS(13606),
    [anon_sym_LBRACK] = ACTIONS(13606),
    [anon_sym_RBRACK] = ACTIONS(13606),
    [anon_sym_LF] = ACTIONS(13608),
    [anon_sym_in] = ACTIONS(13606),
    [anon_sym_LBRACE] = ACTIONS(13606),
    [anon_sym_DOLLAR] = ACTIONS(13606),
    [anon_sym_COLON_COLON] = ACTIONS(13606),
    [anon_sym_isa] = ACTIONS(13606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_QMARK] = ACTIONS(13606),
    [anon_sym_AT] = ACTIONS(13606),
    [anon_sym_true] = ACTIONS(13606),
    [anon_sym_false] = ACTIONS(13606),
    [aux_sym_integer_literal_token1] = ACTIONS(13606),
    [aux_sym_integer_literal_token2] = ACTIONS(13606),
    [aux_sym_integer_literal_token3] = ACTIONS(13606),
    [aux_sym_integer_literal_token4] = ACTIONS(13606),
    [aux_sym_float_literal_token1] = ACTIONS(13606),
    [aux_sym_float_literal_token3] = ACTIONS(13606),
    [aux_sym_float_literal_token4] = ACTIONS(13606),
    [sym_character_literal] = ACTIONS(13606),
    [sym__pair_operator] = ACTIONS(13606),
    [sym__arrow_operator] = ACTIONS(13606),
    [sym__lazy_or_operator] = ACTIONS(13606),
    [sym__lazy_and_operator] = ACTIONS(13606),
    [sym__comparison_operator] = ACTIONS(13606),
    [sym__pipe_right_operator] = ACTIONS(13606),
    [sym__pipe_left_operator] = ACTIONS(13606),
    [sym__ellipsis_operator] = ACTIONS(13606),
    [sym__plus_operator] = ACTIONS(13606),
    [sym__times_operator] = ACTIONS(13606),
    [sym__rational_operator] = ACTIONS(13606),
    [sym__bitshift_operator] = ACTIONS(13606),
    [sym__power_operator] = ACTIONS(13606),
    [sym__tilde_operator] = ACTIONS(13606),
    [sym__type_order_operator] = ACTIONS(13606),
    [sym__unary_operator] = ACTIONS(13606),
    [sym__unary_plus_operator] = ACTIONS(13606),
    [aux_sym__terminator_token1] = ACTIONS(13606),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13608),
    [sym__command_start] = ACTIONS(13608),
  },
  [7908] = {
    [ts_builtin_sym_end] = ACTIONS(13622),
    [sym__word_identifier] = ACTIONS(13620),
    [anon_sym_EQ] = ACTIONS(13620),
    [anon_sym_COMMA] = ACTIONS(13620),
    [anon_sym_COLON] = ACTIONS(13620),
    [anon_sym_begin] = ACTIONS(13620),
    [anon_sym_module] = ACTIONS(13620),
    [anon_sym_baremodule] = ACTIONS(13620),
    [anon_sym_abstract] = ACTIONS(13620),
    [anon_sym_primitive] = ACTIONS(13620),
    [anon_sym_mutable] = ACTIONS(13620),
    [anon_sym_struct] = ACTIONS(13620),
    [anon_sym_function] = ACTIONS(13620),
    [anon_sym_macro] = ACTIONS(13620),
    [anon_sym_where] = ACTIONS(13620),
    [anon_sym_quote] = ACTIONS(13620),
    [anon_sym_let] = ACTIONS(13620),
    [anon_sym_if] = ACTIONS(13620),
    [anon_sym_try] = ACTIONS(13620),
    [anon_sym_for] = ACTIONS(13620),
    [anon_sym_while] = ACTIONS(13620),
    [sym_break_statement] = ACTIONS(13620),
    [sym_continue_statement] = ACTIONS(13620),
    [anon_sym_return] = ACTIONS(13620),
    [anon_sym_const] = ACTIONS(13620),
    [anon_sym_global] = ACTIONS(13620),
    [anon_sym_local] = ACTIONS(13620),
    [anon_sym_LPAREN] = ACTIONS(13620),
    [anon_sym_RPAREN] = ACTIONS(13620),
    [anon_sym_COLON2] = ACTIONS(13620),
    [anon_sym_export] = ACTIONS(13620),
    [anon_sym_import] = ACTIONS(13620),
    [anon_sym_using] = ACTIONS(13620),
    [anon_sym_LBRACK] = ACTIONS(13620),
    [anon_sym_RBRACK] = ACTIONS(13620),
    [anon_sym_LF] = ACTIONS(13622),
    [anon_sym_in] = ACTIONS(13620),
    [anon_sym_LBRACE] = ACTIONS(13620),
    [anon_sym_DOLLAR] = ACTIONS(13620),
    [anon_sym_COLON_COLON] = ACTIONS(13620),
    [anon_sym_isa] = ACTIONS(13620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13620),
    [anon_sym_QMARK] = ACTIONS(13620),
    [anon_sym_AT] = ACTIONS(13620),
    [anon_sym_true] = ACTIONS(13620),
    [anon_sym_false] = ACTIONS(13620),
    [aux_sym_integer_literal_token1] = ACTIONS(13620),
    [aux_sym_integer_literal_token2] = ACTIONS(13620),
    [aux_sym_integer_literal_token3] = ACTIONS(13620),
    [aux_sym_integer_literal_token4] = ACTIONS(13620),
    [aux_sym_float_literal_token1] = ACTIONS(13620),
    [aux_sym_float_literal_token3] = ACTIONS(13620),
    [aux_sym_float_literal_token4] = ACTIONS(13620),
    [sym_character_literal] = ACTIONS(13620),
    [sym__pair_operator] = ACTIONS(13620),
    [sym__arrow_operator] = ACTIONS(13620),
    [sym__lazy_or_operator] = ACTIONS(13620),
    [sym__lazy_and_operator] = ACTIONS(13620),
    [sym__comparison_operator] = ACTIONS(13620),
    [sym__pipe_right_operator] = ACTIONS(13620),
    [sym__pipe_left_operator] = ACTIONS(13620),
    [sym__ellipsis_operator] = ACTIONS(13620),
    [sym__plus_operator] = ACTIONS(13620),
    [sym__times_operator] = ACTIONS(13620),
    [sym__rational_operator] = ACTIONS(13620),
    [sym__bitshift_operator] = ACTIONS(13620),
    [sym__power_operator] = ACTIONS(13620),
    [sym__tilde_operator] = ACTIONS(13620),
    [sym__type_order_operator] = ACTIONS(13620),
    [sym__unary_operator] = ACTIONS(13620),
    [sym__unary_plus_operator] = ACTIONS(13620),
    [aux_sym__terminator_token1] = ACTIONS(13620),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13622),
    [sym__command_start] = ACTIONS(13622),
  },
  [7909] = {
    [ts_builtin_sym_end] = ACTIONS(13247),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_RPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_RBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7910] = {
    [ts_builtin_sym_end] = ACTIONS(12676),
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_RBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [7911] = {
    [ts_builtin_sym_end] = ACTIONS(13626),
    [sym__word_identifier] = ACTIONS(13624),
    [anon_sym_EQ] = ACTIONS(13624),
    [anon_sym_COMMA] = ACTIONS(13624),
    [anon_sym_COLON] = ACTIONS(13624),
    [anon_sym_begin] = ACTIONS(13624),
    [anon_sym_module] = ACTIONS(13624),
    [anon_sym_baremodule] = ACTIONS(13624),
    [anon_sym_abstract] = ACTIONS(13624),
    [anon_sym_primitive] = ACTIONS(13624),
    [anon_sym_mutable] = ACTIONS(13624),
    [anon_sym_struct] = ACTIONS(13624),
    [anon_sym_function] = ACTIONS(13624),
    [anon_sym_macro] = ACTIONS(13624),
    [anon_sym_where] = ACTIONS(13624),
    [anon_sym_quote] = ACTIONS(13624),
    [anon_sym_let] = ACTIONS(13624),
    [anon_sym_if] = ACTIONS(13624),
    [anon_sym_try] = ACTIONS(13624),
    [anon_sym_for] = ACTIONS(13624),
    [anon_sym_while] = ACTIONS(13624),
    [sym_break_statement] = ACTIONS(13624),
    [sym_continue_statement] = ACTIONS(13624),
    [anon_sym_return] = ACTIONS(13624),
    [anon_sym_const] = ACTIONS(13624),
    [anon_sym_global] = ACTIONS(13624),
    [anon_sym_local] = ACTIONS(13624),
    [anon_sym_LPAREN] = ACTIONS(13624),
    [anon_sym_RPAREN] = ACTIONS(13624),
    [anon_sym_COLON2] = ACTIONS(13624),
    [anon_sym_export] = ACTIONS(13624),
    [anon_sym_import] = ACTIONS(13624),
    [anon_sym_using] = ACTIONS(13624),
    [anon_sym_LBRACK] = ACTIONS(13624),
    [anon_sym_RBRACK] = ACTIONS(13624),
    [anon_sym_LF] = ACTIONS(13626),
    [anon_sym_in] = ACTIONS(13624),
    [anon_sym_LBRACE] = ACTIONS(13624),
    [anon_sym_DOLLAR] = ACTIONS(13624),
    [anon_sym_COLON_COLON] = ACTIONS(13624),
    [anon_sym_isa] = ACTIONS(13624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13624),
    [anon_sym_QMARK] = ACTIONS(13624),
    [anon_sym_AT] = ACTIONS(13624),
    [anon_sym_true] = ACTIONS(13624),
    [anon_sym_false] = ACTIONS(13624),
    [aux_sym_integer_literal_token1] = ACTIONS(13624),
    [aux_sym_integer_literal_token2] = ACTIONS(13624),
    [aux_sym_integer_literal_token3] = ACTIONS(13624),
    [aux_sym_integer_literal_token4] = ACTIONS(13624),
    [aux_sym_float_literal_token1] = ACTIONS(13624),
    [aux_sym_float_literal_token3] = ACTIONS(13624),
    [aux_sym_float_literal_token4] = ACTIONS(13624),
    [sym_character_literal] = ACTIONS(13624),
    [sym__pair_operator] = ACTIONS(13624),
    [sym__arrow_operator] = ACTIONS(13624),
    [sym__lazy_or_operator] = ACTIONS(13624),
    [sym__lazy_and_operator] = ACTIONS(13624),
    [sym__comparison_operator] = ACTIONS(13624),
    [sym__pipe_right_operator] = ACTIONS(13624),
    [sym__pipe_left_operator] = ACTIONS(13624),
    [sym__ellipsis_operator] = ACTIONS(13624),
    [sym__plus_operator] = ACTIONS(13624),
    [sym__times_operator] = ACTIONS(13624),
    [sym__rational_operator] = ACTIONS(13624),
    [sym__bitshift_operator] = ACTIONS(13624),
    [sym__power_operator] = ACTIONS(13624),
    [sym__tilde_operator] = ACTIONS(13624),
    [sym__type_order_operator] = ACTIONS(13624),
    [sym__unary_operator] = ACTIONS(13624),
    [sym__unary_plus_operator] = ACTIONS(13624),
    [aux_sym__terminator_token1] = ACTIONS(13624),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13626),
    [sym__command_start] = ACTIONS(13626),
  },
  [7912] = {
    [ts_builtin_sym_end] = ACTIONS(13630),
    [sym__word_identifier] = ACTIONS(13628),
    [anon_sym_EQ] = ACTIONS(13628),
    [anon_sym_COMMA] = ACTIONS(13628),
    [anon_sym_COLON] = ACTIONS(13628),
    [anon_sym_begin] = ACTIONS(13628),
    [anon_sym_module] = ACTIONS(13628),
    [anon_sym_baremodule] = ACTIONS(13628),
    [anon_sym_abstract] = ACTIONS(13628),
    [anon_sym_primitive] = ACTIONS(13628),
    [anon_sym_mutable] = ACTIONS(13628),
    [anon_sym_struct] = ACTIONS(13628),
    [anon_sym_function] = ACTIONS(13628),
    [anon_sym_macro] = ACTIONS(13628),
    [anon_sym_where] = ACTIONS(13628),
    [anon_sym_quote] = ACTIONS(13628),
    [anon_sym_let] = ACTIONS(13628),
    [anon_sym_if] = ACTIONS(13628),
    [anon_sym_try] = ACTIONS(13628),
    [anon_sym_for] = ACTIONS(13628),
    [anon_sym_while] = ACTIONS(13628),
    [sym_break_statement] = ACTIONS(13628),
    [sym_continue_statement] = ACTIONS(13628),
    [anon_sym_return] = ACTIONS(13628),
    [anon_sym_const] = ACTIONS(13628),
    [anon_sym_global] = ACTIONS(13628),
    [anon_sym_local] = ACTIONS(13628),
    [anon_sym_LPAREN] = ACTIONS(13628),
    [anon_sym_RPAREN] = ACTIONS(13628),
    [anon_sym_COLON2] = ACTIONS(13628),
    [anon_sym_export] = ACTIONS(13628),
    [anon_sym_import] = ACTIONS(13628),
    [anon_sym_using] = ACTIONS(13628),
    [anon_sym_LBRACK] = ACTIONS(13628),
    [anon_sym_RBRACK] = ACTIONS(13628),
    [anon_sym_LF] = ACTIONS(13630),
    [anon_sym_in] = ACTIONS(13628),
    [anon_sym_LBRACE] = ACTIONS(13628),
    [anon_sym_DOLLAR] = ACTIONS(13628),
    [anon_sym_COLON_COLON] = ACTIONS(13628),
    [anon_sym_isa] = ACTIONS(13628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13628),
    [anon_sym_QMARK] = ACTIONS(13628),
    [anon_sym_AT] = ACTIONS(13628),
    [anon_sym_true] = ACTIONS(13628),
    [anon_sym_false] = ACTIONS(13628),
    [aux_sym_integer_literal_token1] = ACTIONS(13628),
    [aux_sym_integer_literal_token2] = ACTIONS(13628),
    [aux_sym_integer_literal_token3] = ACTIONS(13628),
    [aux_sym_integer_literal_token4] = ACTIONS(13628),
    [aux_sym_float_literal_token1] = ACTIONS(13628),
    [aux_sym_float_literal_token3] = ACTIONS(13628),
    [aux_sym_float_literal_token4] = ACTIONS(13628),
    [sym_character_literal] = ACTIONS(13628),
    [sym__pair_operator] = ACTIONS(13628),
    [sym__arrow_operator] = ACTIONS(13628),
    [sym__lazy_or_operator] = ACTIONS(13628),
    [sym__lazy_and_operator] = ACTIONS(13628),
    [sym__comparison_operator] = ACTIONS(13628),
    [sym__pipe_right_operator] = ACTIONS(13628),
    [sym__pipe_left_operator] = ACTIONS(13628),
    [sym__ellipsis_operator] = ACTIONS(13628),
    [sym__plus_operator] = ACTIONS(13628),
    [sym__times_operator] = ACTIONS(13628),
    [sym__rational_operator] = ACTIONS(13628),
    [sym__bitshift_operator] = ACTIONS(13628),
    [sym__power_operator] = ACTIONS(13628),
    [sym__tilde_operator] = ACTIONS(13628),
    [sym__type_order_operator] = ACTIONS(13628),
    [sym__unary_operator] = ACTIONS(13628),
    [sym__unary_plus_operator] = ACTIONS(13628),
    [aux_sym__terminator_token1] = ACTIONS(13628),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13630),
    [sym__command_start] = ACTIONS(13630),
  },
  [7913] = {
    [ts_builtin_sym_end] = ACTIONS(13634),
    [sym__word_identifier] = ACTIONS(13632),
    [anon_sym_EQ] = ACTIONS(13632),
    [anon_sym_COMMA] = ACTIONS(13632),
    [anon_sym_COLON] = ACTIONS(13632),
    [anon_sym_begin] = ACTIONS(13632),
    [anon_sym_module] = ACTIONS(13632),
    [anon_sym_baremodule] = ACTIONS(13632),
    [anon_sym_abstract] = ACTIONS(13632),
    [anon_sym_primitive] = ACTIONS(13632),
    [anon_sym_mutable] = ACTIONS(13632),
    [anon_sym_struct] = ACTIONS(13632),
    [anon_sym_function] = ACTIONS(13632),
    [anon_sym_macro] = ACTIONS(13632),
    [anon_sym_where] = ACTIONS(13632),
    [anon_sym_quote] = ACTIONS(13632),
    [anon_sym_let] = ACTIONS(13632),
    [anon_sym_if] = ACTIONS(13632),
    [anon_sym_try] = ACTIONS(13632),
    [anon_sym_for] = ACTIONS(13632),
    [anon_sym_while] = ACTIONS(13632),
    [sym_break_statement] = ACTIONS(13632),
    [sym_continue_statement] = ACTIONS(13632),
    [anon_sym_return] = ACTIONS(13632),
    [anon_sym_const] = ACTIONS(13632),
    [anon_sym_global] = ACTIONS(13632),
    [anon_sym_local] = ACTIONS(13632),
    [anon_sym_LPAREN] = ACTIONS(13632),
    [anon_sym_RPAREN] = ACTIONS(13632),
    [anon_sym_COLON2] = ACTIONS(13632),
    [anon_sym_export] = ACTIONS(13632),
    [anon_sym_import] = ACTIONS(13632),
    [anon_sym_using] = ACTIONS(13632),
    [anon_sym_LBRACK] = ACTIONS(13632),
    [anon_sym_RBRACK] = ACTIONS(13632),
    [anon_sym_LF] = ACTIONS(13634),
    [anon_sym_in] = ACTIONS(13632),
    [anon_sym_LBRACE] = ACTIONS(13632),
    [anon_sym_DOLLAR] = ACTIONS(13632),
    [anon_sym_COLON_COLON] = ACTIONS(13632),
    [anon_sym_isa] = ACTIONS(13632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13632),
    [anon_sym_QMARK] = ACTIONS(13632),
    [anon_sym_AT] = ACTIONS(13632),
    [anon_sym_true] = ACTIONS(13632),
    [anon_sym_false] = ACTIONS(13632),
    [aux_sym_integer_literal_token1] = ACTIONS(13632),
    [aux_sym_integer_literal_token2] = ACTIONS(13632),
    [aux_sym_integer_literal_token3] = ACTIONS(13632),
    [aux_sym_integer_literal_token4] = ACTIONS(13632),
    [aux_sym_float_literal_token1] = ACTIONS(13632),
    [aux_sym_float_literal_token3] = ACTIONS(13632),
    [aux_sym_float_literal_token4] = ACTIONS(13632),
    [sym_character_literal] = ACTIONS(13632),
    [sym__pair_operator] = ACTIONS(13632),
    [sym__arrow_operator] = ACTIONS(13632),
    [sym__lazy_or_operator] = ACTIONS(13632),
    [sym__lazy_and_operator] = ACTIONS(13632),
    [sym__comparison_operator] = ACTIONS(13632),
    [sym__pipe_right_operator] = ACTIONS(13632),
    [sym__pipe_left_operator] = ACTIONS(13632),
    [sym__ellipsis_operator] = ACTIONS(13632),
    [sym__plus_operator] = ACTIONS(13632),
    [sym__times_operator] = ACTIONS(13632),
    [sym__rational_operator] = ACTIONS(13632),
    [sym__bitshift_operator] = ACTIONS(13632),
    [sym__power_operator] = ACTIONS(13632),
    [sym__tilde_operator] = ACTIONS(13632),
    [sym__type_order_operator] = ACTIONS(13632),
    [sym__unary_operator] = ACTIONS(13632),
    [sym__unary_plus_operator] = ACTIONS(13632),
    [aux_sym__terminator_token1] = ACTIONS(13632),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13634),
    [sym__command_start] = ACTIONS(13634),
  },
  [7914] = {
    [sym__comprehension_clause] = STATE(19863),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17303),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14178),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14180),
    [anon_sym_LF] = ACTIONS(14182),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14185),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7915] = {
    [ts_builtin_sym_end] = ACTIONS(13638),
    [sym__word_identifier] = ACTIONS(13636),
    [anon_sym_EQ] = ACTIONS(13636),
    [anon_sym_COMMA] = ACTIONS(13636),
    [anon_sym_COLON] = ACTIONS(13636),
    [anon_sym_begin] = ACTIONS(13636),
    [anon_sym_module] = ACTIONS(13636),
    [anon_sym_baremodule] = ACTIONS(13636),
    [anon_sym_abstract] = ACTIONS(13636),
    [anon_sym_primitive] = ACTIONS(13636),
    [anon_sym_mutable] = ACTIONS(13636),
    [anon_sym_struct] = ACTIONS(13636),
    [anon_sym_function] = ACTIONS(13636),
    [anon_sym_macro] = ACTIONS(13636),
    [anon_sym_where] = ACTIONS(13636),
    [anon_sym_quote] = ACTIONS(13636),
    [anon_sym_let] = ACTIONS(13636),
    [anon_sym_if] = ACTIONS(13636),
    [anon_sym_try] = ACTIONS(13636),
    [anon_sym_for] = ACTIONS(13636),
    [anon_sym_while] = ACTIONS(13636),
    [sym_break_statement] = ACTIONS(13636),
    [sym_continue_statement] = ACTIONS(13636),
    [anon_sym_return] = ACTIONS(13636),
    [anon_sym_const] = ACTIONS(13636),
    [anon_sym_global] = ACTIONS(13636),
    [anon_sym_local] = ACTIONS(13636),
    [anon_sym_LPAREN] = ACTIONS(13636),
    [anon_sym_RPAREN] = ACTIONS(13636),
    [anon_sym_COLON2] = ACTIONS(13636),
    [anon_sym_export] = ACTIONS(13636),
    [anon_sym_import] = ACTIONS(13636),
    [anon_sym_using] = ACTIONS(13636),
    [anon_sym_LBRACK] = ACTIONS(13636),
    [anon_sym_RBRACK] = ACTIONS(13636),
    [anon_sym_LF] = ACTIONS(13638),
    [anon_sym_in] = ACTIONS(13636),
    [anon_sym_LBRACE] = ACTIONS(13636),
    [anon_sym_DOLLAR] = ACTIONS(13636),
    [anon_sym_COLON_COLON] = ACTIONS(13636),
    [anon_sym_isa] = ACTIONS(13636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13636),
    [anon_sym_QMARK] = ACTIONS(13636),
    [anon_sym_AT] = ACTIONS(13636),
    [anon_sym_true] = ACTIONS(13636),
    [anon_sym_false] = ACTIONS(13636),
    [aux_sym_integer_literal_token1] = ACTIONS(13636),
    [aux_sym_integer_literal_token2] = ACTIONS(13636),
    [aux_sym_integer_literal_token3] = ACTIONS(13636),
    [aux_sym_integer_literal_token4] = ACTIONS(13636),
    [aux_sym_float_literal_token1] = ACTIONS(13636),
    [aux_sym_float_literal_token3] = ACTIONS(13636),
    [aux_sym_float_literal_token4] = ACTIONS(13636),
    [sym_character_literal] = ACTIONS(13636),
    [sym__pair_operator] = ACTIONS(13636),
    [sym__arrow_operator] = ACTIONS(13636),
    [sym__lazy_or_operator] = ACTIONS(13636),
    [sym__lazy_and_operator] = ACTIONS(13636),
    [sym__comparison_operator] = ACTIONS(13636),
    [sym__pipe_right_operator] = ACTIONS(13636),
    [sym__pipe_left_operator] = ACTIONS(13636),
    [sym__ellipsis_operator] = ACTIONS(13636),
    [sym__plus_operator] = ACTIONS(13636),
    [sym__times_operator] = ACTIONS(13636),
    [sym__rational_operator] = ACTIONS(13636),
    [sym__bitshift_operator] = ACTIONS(13636),
    [sym__power_operator] = ACTIONS(13636),
    [sym__tilde_operator] = ACTIONS(13636),
    [sym__type_order_operator] = ACTIONS(13636),
    [sym__unary_operator] = ACTIONS(13636),
    [sym__unary_plus_operator] = ACTIONS(13636),
    [aux_sym__terminator_token1] = ACTIONS(13636),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13638),
    [sym__command_start] = ACTIONS(13638),
  },
  [7916] = {
    [ts_builtin_sym_end] = ACTIONS(13642),
    [sym__word_identifier] = ACTIONS(13640),
    [anon_sym_EQ] = ACTIONS(13640),
    [anon_sym_COMMA] = ACTIONS(13640),
    [anon_sym_COLON] = ACTIONS(13640),
    [anon_sym_begin] = ACTIONS(13640),
    [anon_sym_module] = ACTIONS(13640),
    [anon_sym_baremodule] = ACTIONS(13640),
    [anon_sym_abstract] = ACTIONS(13640),
    [anon_sym_primitive] = ACTIONS(13640),
    [anon_sym_mutable] = ACTIONS(13640),
    [anon_sym_struct] = ACTIONS(13640),
    [anon_sym_function] = ACTIONS(13640),
    [anon_sym_macro] = ACTIONS(13640),
    [anon_sym_where] = ACTIONS(13640),
    [anon_sym_quote] = ACTIONS(13640),
    [anon_sym_let] = ACTIONS(13640),
    [anon_sym_if] = ACTIONS(13640),
    [anon_sym_try] = ACTIONS(13640),
    [anon_sym_for] = ACTIONS(13640),
    [anon_sym_while] = ACTIONS(13640),
    [sym_break_statement] = ACTIONS(13640),
    [sym_continue_statement] = ACTIONS(13640),
    [anon_sym_return] = ACTIONS(13640),
    [anon_sym_const] = ACTIONS(13640),
    [anon_sym_global] = ACTIONS(13640),
    [anon_sym_local] = ACTIONS(13640),
    [anon_sym_LPAREN] = ACTIONS(13640),
    [anon_sym_RPAREN] = ACTIONS(13640),
    [anon_sym_COLON2] = ACTIONS(13640),
    [anon_sym_export] = ACTIONS(13640),
    [anon_sym_import] = ACTIONS(13640),
    [anon_sym_using] = ACTIONS(13640),
    [anon_sym_LBRACK] = ACTIONS(13640),
    [anon_sym_RBRACK] = ACTIONS(13640),
    [anon_sym_LF] = ACTIONS(13642),
    [anon_sym_in] = ACTIONS(13640),
    [anon_sym_LBRACE] = ACTIONS(13640),
    [anon_sym_DOLLAR] = ACTIONS(13640),
    [anon_sym_COLON_COLON] = ACTIONS(13640),
    [anon_sym_isa] = ACTIONS(13640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13640),
    [anon_sym_QMARK] = ACTIONS(13640),
    [anon_sym_AT] = ACTIONS(13640),
    [anon_sym_true] = ACTIONS(13640),
    [anon_sym_false] = ACTIONS(13640),
    [aux_sym_integer_literal_token1] = ACTIONS(13640),
    [aux_sym_integer_literal_token2] = ACTIONS(13640),
    [aux_sym_integer_literal_token3] = ACTIONS(13640),
    [aux_sym_integer_literal_token4] = ACTIONS(13640),
    [aux_sym_float_literal_token1] = ACTIONS(13640),
    [aux_sym_float_literal_token3] = ACTIONS(13640),
    [aux_sym_float_literal_token4] = ACTIONS(13640),
    [sym_character_literal] = ACTIONS(13640),
    [sym__pair_operator] = ACTIONS(13640),
    [sym__arrow_operator] = ACTIONS(13640),
    [sym__lazy_or_operator] = ACTIONS(13640),
    [sym__lazy_and_operator] = ACTIONS(13640),
    [sym__comparison_operator] = ACTIONS(13640),
    [sym__pipe_right_operator] = ACTIONS(13640),
    [sym__pipe_left_operator] = ACTIONS(13640),
    [sym__ellipsis_operator] = ACTIONS(13640),
    [sym__plus_operator] = ACTIONS(13640),
    [sym__times_operator] = ACTIONS(13640),
    [sym__rational_operator] = ACTIONS(13640),
    [sym__bitshift_operator] = ACTIONS(13640),
    [sym__power_operator] = ACTIONS(13640),
    [sym__tilde_operator] = ACTIONS(13640),
    [sym__type_order_operator] = ACTIONS(13640),
    [sym__unary_operator] = ACTIONS(13640),
    [sym__unary_plus_operator] = ACTIONS(13640),
    [aux_sym__terminator_token1] = ACTIONS(13640),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13642),
    [sym__command_start] = ACTIONS(13642),
  },
  [7917] = {
    [ts_builtin_sym_end] = ACTIONS(13646),
    [sym__word_identifier] = ACTIONS(13644),
    [anon_sym_EQ] = ACTIONS(13644),
    [anon_sym_COMMA] = ACTIONS(13644),
    [anon_sym_COLON] = ACTIONS(13644),
    [anon_sym_begin] = ACTIONS(13644),
    [anon_sym_module] = ACTIONS(13644),
    [anon_sym_baremodule] = ACTIONS(13644),
    [anon_sym_abstract] = ACTIONS(13644),
    [anon_sym_primitive] = ACTIONS(13644),
    [anon_sym_mutable] = ACTIONS(13644),
    [anon_sym_struct] = ACTIONS(13644),
    [anon_sym_function] = ACTIONS(13644),
    [anon_sym_macro] = ACTIONS(13644),
    [anon_sym_where] = ACTIONS(13644),
    [anon_sym_quote] = ACTIONS(13644),
    [anon_sym_let] = ACTIONS(13644),
    [anon_sym_if] = ACTIONS(13644),
    [anon_sym_try] = ACTIONS(13644),
    [anon_sym_for] = ACTIONS(13644),
    [anon_sym_while] = ACTIONS(13644),
    [sym_break_statement] = ACTIONS(13644),
    [sym_continue_statement] = ACTIONS(13644),
    [anon_sym_return] = ACTIONS(13644),
    [anon_sym_const] = ACTIONS(13644),
    [anon_sym_global] = ACTIONS(13644),
    [anon_sym_local] = ACTIONS(13644),
    [anon_sym_LPAREN] = ACTIONS(13644),
    [anon_sym_RPAREN] = ACTIONS(13644),
    [anon_sym_COLON2] = ACTIONS(13644),
    [anon_sym_export] = ACTIONS(13644),
    [anon_sym_import] = ACTIONS(13644),
    [anon_sym_using] = ACTIONS(13644),
    [anon_sym_LBRACK] = ACTIONS(13644),
    [anon_sym_RBRACK] = ACTIONS(13644),
    [anon_sym_LF] = ACTIONS(13646),
    [anon_sym_in] = ACTIONS(13644),
    [anon_sym_LBRACE] = ACTIONS(13644),
    [anon_sym_DOLLAR] = ACTIONS(13644),
    [anon_sym_COLON_COLON] = ACTIONS(13644),
    [anon_sym_isa] = ACTIONS(13644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13644),
    [anon_sym_QMARK] = ACTIONS(13644),
    [anon_sym_AT] = ACTIONS(13644),
    [anon_sym_true] = ACTIONS(13644),
    [anon_sym_false] = ACTIONS(13644),
    [aux_sym_integer_literal_token1] = ACTIONS(13644),
    [aux_sym_integer_literal_token2] = ACTIONS(13644),
    [aux_sym_integer_literal_token3] = ACTIONS(13644),
    [aux_sym_integer_literal_token4] = ACTIONS(13644),
    [aux_sym_float_literal_token1] = ACTIONS(13644),
    [aux_sym_float_literal_token3] = ACTIONS(13644),
    [aux_sym_float_literal_token4] = ACTIONS(13644),
    [sym_character_literal] = ACTIONS(13644),
    [sym__pair_operator] = ACTIONS(13644),
    [sym__arrow_operator] = ACTIONS(13644),
    [sym__lazy_or_operator] = ACTIONS(13644),
    [sym__lazy_and_operator] = ACTIONS(13644),
    [sym__comparison_operator] = ACTIONS(13644),
    [sym__pipe_right_operator] = ACTIONS(13644),
    [sym__pipe_left_operator] = ACTIONS(13644),
    [sym__ellipsis_operator] = ACTIONS(13644),
    [sym__plus_operator] = ACTIONS(13644),
    [sym__times_operator] = ACTIONS(13644),
    [sym__rational_operator] = ACTIONS(13644),
    [sym__bitshift_operator] = ACTIONS(13644),
    [sym__power_operator] = ACTIONS(13644),
    [sym__tilde_operator] = ACTIONS(13644),
    [sym__type_order_operator] = ACTIONS(13644),
    [sym__unary_operator] = ACTIONS(13644),
    [sym__unary_plus_operator] = ACTIONS(13644),
    [aux_sym__terminator_token1] = ACTIONS(13644),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13646),
    [sym__command_start] = ACTIONS(13646),
  },
  [7918] = {
    [ts_builtin_sym_end] = ACTIONS(13650),
    [sym__word_identifier] = ACTIONS(13648),
    [anon_sym_EQ] = ACTIONS(13648),
    [anon_sym_COMMA] = ACTIONS(13648),
    [anon_sym_COLON] = ACTIONS(13648),
    [anon_sym_begin] = ACTIONS(13648),
    [anon_sym_module] = ACTIONS(13648),
    [anon_sym_baremodule] = ACTIONS(13648),
    [anon_sym_abstract] = ACTIONS(13648),
    [anon_sym_primitive] = ACTIONS(13648),
    [anon_sym_mutable] = ACTIONS(13648),
    [anon_sym_struct] = ACTIONS(13648),
    [anon_sym_function] = ACTIONS(13648),
    [anon_sym_macro] = ACTIONS(13648),
    [anon_sym_where] = ACTIONS(13648),
    [anon_sym_quote] = ACTIONS(13648),
    [anon_sym_let] = ACTIONS(13648),
    [anon_sym_if] = ACTIONS(13648),
    [anon_sym_try] = ACTIONS(13648),
    [anon_sym_for] = ACTIONS(13648),
    [anon_sym_while] = ACTIONS(13648),
    [sym_break_statement] = ACTIONS(13648),
    [sym_continue_statement] = ACTIONS(13648),
    [anon_sym_return] = ACTIONS(13648),
    [anon_sym_const] = ACTIONS(13648),
    [anon_sym_global] = ACTIONS(13648),
    [anon_sym_local] = ACTIONS(13648),
    [anon_sym_LPAREN] = ACTIONS(13648),
    [anon_sym_RPAREN] = ACTIONS(13648),
    [anon_sym_COLON2] = ACTIONS(13648),
    [anon_sym_export] = ACTIONS(13648),
    [anon_sym_import] = ACTIONS(13648),
    [anon_sym_using] = ACTIONS(13648),
    [anon_sym_LBRACK] = ACTIONS(13648),
    [anon_sym_RBRACK] = ACTIONS(13648),
    [anon_sym_LF] = ACTIONS(13650),
    [anon_sym_in] = ACTIONS(13648),
    [anon_sym_LBRACE] = ACTIONS(13648),
    [anon_sym_DOLLAR] = ACTIONS(13648),
    [anon_sym_COLON_COLON] = ACTIONS(13648),
    [anon_sym_isa] = ACTIONS(13648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13648),
    [anon_sym_QMARK] = ACTIONS(13648),
    [anon_sym_AT] = ACTIONS(13648),
    [anon_sym_true] = ACTIONS(13648),
    [anon_sym_false] = ACTIONS(13648),
    [aux_sym_integer_literal_token1] = ACTIONS(13648),
    [aux_sym_integer_literal_token2] = ACTIONS(13648),
    [aux_sym_integer_literal_token3] = ACTIONS(13648),
    [aux_sym_integer_literal_token4] = ACTIONS(13648),
    [aux_sym_float_literal_token1] = ACTIONS(13648),
    [aux_sym_float_literal_token3] = ACTIONS(13648),
    [aux_sym_float_literal_token4] = ACTIONS(13648),
    [sym_character_literal] = ACTIONS(13648),
    [sym__pair_operator] = ACTIONS(13648),
    [sym__arrow_operator] = ACTIONS(13648),
    [sym__lazy_or_operator] = ACTIONS(13648),
    [sym__lazy_and_operator] = ACTIONS(13648),
    [sym__comparison_operator] = ACTIONS(13648),
    [sym__pipe_right_operator] = ACTIONS(13648),
    [sym__pipe_left_operator] = ACTIONS(13648),
    [sym__ellipsis_operator] = ACTIONS(13648),
    [sym__plus_operator] = ACTIONS(13648),
    [sym__times_operator] = ACTIONS(13648),
    [sym__rational_operator] = ACTIONS(13648),
    [sym__bitshift_operator] = ACTIONS(13648),
    [sym__power_operator] = ACTIONS(13648),
    [sym__tilde_operator] = ACTIONS(13648),
    [sym__type_order_operator] = ACTIONS(13648),
    [sym__unary_operator] = ACTIONS(13648),
    [sym__unary_plus_operator] = ACTIONS(13648),
    [aux_sym__terminator_token1] = ACTIONS(13648),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13650),
    [sym__command_start] = ACTIONS(13650),
  },
  [7919] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_catch] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [7920] = {
    [ts_builtin_sym_end] = ACTIONS(13654),
    [sym__word_identifier] = ACTIONS(13652),
    [anon_sym_EQ] = ACTIONS(13652),
    [anon_sym_COMMA] = ACTIONS(13652),
    [anon_sym_COLON] = ACTIONS(13652),
    [anon_sym_begin] = ACTIONS(13652),
    [anon_sym_module] = ACTIONS(13652),
    [anon_sym_baremodule] = ACTIONS(13652),
    [anon_sym_abstract] = ACTIONS(13652),
    [anon_sym_primitive] = ACTIONS(13652),
    [anon_sym_mutable] = ACTIONS(13652),
    [anon_sym_struct] = ACTIONS(13652),
    [anon_sym_function] = ACTIONS(13652),
    [anon_sym_macro] = ACTIONS(13652),
    [anon_sym_where] = ACTIONS(13652),
    [anon_sym_quote] = ACTIONS(13652),
    [anon_sym_let] = ACTIONS(13652),
    [anon_sym_if] = ACTIONS(13652),
    [anon_sym_try] = ACTIONS(13652),
    [anon_sym_for] = ACTIONS(13652),
    [anon_sym_while] = ACTIONS(13652),
    [sym_break_statement] = ACTIONS(13652),
    [sym_continue_statement] = ACTIONS(13652),
    [anon_sym_return] = ACTIONS(13652),
    [anon_sym_const] = ACTIONS(13652),
    [anon_sym_global] = ACTIONS(13652),
    [anon_sym_local] = ACTIONS(13652),
    [anon_sym_LPAREN] = ACTIONS(13652),
    [anon_sym_RPAREN] = ACTIONS(13652),
    [anon_sym_COLON2] = ACTIONS(13652),
    [anon_sym_export] = ACTIONS(13652),
    [anon_sym_import] = ACTIONS(13652),
    [anon_sym_using] = ACTIONS(13652),
    [anon_sym_LBRACK] = ACTIONS(13652),
    [anon_sym_RBRACK] = ACTIONS(13652),
    [anon_sym_LF] = ACTIONS(13654),
    [anon_sym_in] = ACTIONS(13652),
    [anon_sym_LBRACE] = ACTIONS(13652),
    [anon_sym_DOLLAR] = ACTIONS(13652),
    [anon_sym_COLON_COLON] = ACTIONS(13652),
    [anon_sym_isa] = ACTIONS(13652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13652),
    [anon_sym_QMARK] = ACTIONS(13652),
    [anon_sym_AT] = ACTIONS(13652),
    [anon_sym_true] = ACTIONS(13652),
    [anon_sym_false] = ACTIONS(13652),
    [aux_sym_integer_literal_token1] = ACTIONS(13652),
    [aux_sym_integer_literal_token2] = ACTIONS(13652),
    [aux_sym_integer_literal_token3] = ACTIONS(13652),
    [aux_sym_integer_literal_token4] = ACTIONS(13652),
    [aux_sym_float_literal_token1] = ACTIONS(13652),
    [aux_sym_float_literal_token3] = ACTIONS(13652),
    [aux_sym_float_literal_token4] = ACTIONS(13652),
    [sym_character_literal] = ACTIONS(13652),
    [sym__pair_operator] = ACTIONS(13652),
    [sym__arrow_operator] = ACTIONS(13652),
    [sym__lazy_or_operator] = ACTIONS(13652),
    [sym__lazy_and_operator] = ACTIONS(13652),
    [sym__comparison_operator] = ACTIONS(13652),
    [sym__pipe_right_operator] = ACTIONS(13652),
    [sym__pipe_left_operator] = ACTIONS(13652),
    [sym__ellipsis_operator] = ACTIONS(13652),
    [sym__plus_operator] = ACTIONS(13652),
    [sym__times_operator] = ACTIONS(13652),
    [sym__rational_operator] = ACTIONS(13652),
    [sym__bitshift_operator] = ACTIONS(13652),
    [sym__power_operator] = ACTIONS(13652),
    [sym__tilde_operator] = ACTIONS(13652),
    [sym__type_order_operator] = ACTIONS(13652),
    [sym__unary_operator] = ACTIONS(13652),
    [sym__unary_plus_operator] = ACTIONS(13652),
    [aux_sym__terminator_token1] = ACTIONS(13652),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13654),
    [sym__command_start] = ACTIONS(13654),
  },
  [7921] = {
    [ts_builtin_sym_end] = ACTIONS(13658),
    [sym__word_identifier] = ACTIONS(13656),
    [anon_sym_EQ] = ACTIONS(13656),
    [anon_sym_COMMA] = ACTIONS(13656),
    [anon_sym_COLON] = ACTIONS(13656),
    [anon_sym_begin] = ACTIONS(13656),
    [anon_sym_module] = ACTIONS(13656),
    [anon_sym_baremodule] = ACTIONS(13656),
    [anon_sym_abstract] = ACTIONS(13656),
    [anon_sym_primitive] = ACTIONS(13656),
    [anon_sym_mutable] = ACTIONS(13656),
    [anon_sym_struct] = ACTIONS(13656),
    [anon_sym_function] = ACTIONS(13656),
    [anon_sym_macro] = ACTIONS(13656),
    [anon_sym_where] = ACTIONS(13656),
    [anon_sym_quote] = ACTIONS(13656),
    [anon_sym_let] = ACTIONS(13656),
    [anon_sym_if] = ACTIONS(13656),
    [anon_sym_try] = ACTIONS(13656),
    [anon_sym_for] = ACTIONS(13656),
    [anon_sym_while] = ACTIONS(13656),
    [sym_break_statement] = ACTIONS(13656),
    [sym_continue_statement] = ACTIONS(13656),
    [anon_sym_return] = ACTIONS(13656),
    [anon_sym_const] = ACTIONS(13656),
    [anon_sym_global] = ACTIONS(13656),
    [anon_sym_local] = ACTIONS(13656),
    [anon_sym_LPAREN] = ACTIONS(13656),
    [anon_sym_RPAREN] = ACTIONS(13656),
    [anon_sym_COLON2] = ACTIONS(13656),
    [anon_sym_export] = ACTIONS(13656),
    [anon_sym_import] = ACTIONS(13656),
    [anon_sym_using] = ACTIONS(13656),
    [anon_sym_LBRACK] = ACTIONS(13656),
    [anon_sym_RBRACK] = ACTIONS(13656),
    [anon_sym_LF] = ACTIONS(13658),
    [anon_sym_in] = ACTIONS(13656),
    [anon_sym_LBRACE] = ACTIONS(13656),
    [anon_sym_DOLLAR] = ACTIONS(13656),
    [anon_sym_COLON_COLON] = ACTIONS(13656),
    [anon_sym_isa] = ACTIONS(13656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13656),
    [anon_sym_QMARK] = ACTIONS(13656),
    [anon_sym_AT] = ACTIONS(13656),
    [anon_sym_true] = ACTIONS(13656),
    [anon_sym_false] = ACTIONS(13656),
    [aux_sym_integer_literal_token1] = ACTIONS(13656),
    [aux_sym_integer_literal_token2] = ACTIONS(13656),
    [aux_sym_integer_literal_token3] = ACTIONS(13656),
    [aux_sym_integer_literal_token4] = ACTIONS(13656),
    [aux_sym_float_literal_token1] = ACTIONS(13656),
    [aux_sym_float_literal_token3] = ACTIONS(13656),
    [aux_sym_float_literal_token4] = ACTIONS(13656),
    [sym_character_literal] = ACTIONS(13656),
    [sym__pair_operator] = ACTIONS(13656),
    [sym__arrow_operator] = ACTIONS(13656),
    [sym__lazy_or_operator] = ACTIONS(13656),
    [sym__lazy_and_operator] = ACTIONS(13656),
    [sym__comparison_operator] = ACTIONS(13656),
    [sym__pipe_right_operator] = ACTIONS(13656),
    [sym__pipe_left_operator] = ACTIONS(13656),
    [sym__ellipsis_operator] = ACTIONS(13656),
    [sym__plus_operator] = ACTIONS(13656),
    [sym__times_operator] = ACTIONS(13656),
    [sym__rational_operator] = ACTIONS(13656),
    [sym__bitshift_operator] = ACTIONS(13656),
    [sym__power_operator] = ACTIONS(13656),
    [sym__tilde_operator] = ACTIONS(13656),
    [sym__type_order_operator] = ACTIONS(13656),
    [sym__unary_operator] = ACTIONS(13656),
    [sym__unary_plus_operator] = ACTIONS(13656),
    [aux_sym__terminator_token1] = ACTIONS(13656),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13658),
    [sym__command_start] = ACTIONS(13658),
  },
  [7922] = {
    [ts_builtin_sym_end] = ACTIONS(13662),
    [sym__word_identifier] = ACTIONS(13660),
    [anon_sym_EQ] = ACTIONS(13660),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_COLON] = ACTIONS(13660),
    [anon_sym_begin] = ACTIONS(13660),
    [anon_sym_module] = ACTIONS(13660),
    [anon_sym_baremodule] = ACTIONS(13660),
    [anon_sym_abstract] = ACTIONS(13660),
    [anon_sym_primitive] = ACTIONS(13660),
    [anon_sym_mutable] = ACTIONS(13660),
    [anon_sym_struct] = ACTIONS(13660),
    [anon_sym_function] = ACTIONS(13660),
    [anon_sym_macro] = ACTIONS(13660),
    [anon_sym_where] = ACTIONS(13660),
    [anon_sym_quote] = ACTIONS(13660),
    [anon_sym_let] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_try] = ACTIONS(13660),
    [anon_sym_for] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [sym_break_statement] = ACTIONS(13660),
    [sym_continue_statement] = ACTIONS(13660),
    [anon_sym_return] = ACTIONS(13660),
    [anon_sym_const] = ACTIONS(13660),
    [anon_sym_global] = ACTIONS(13660),
    [anon_sym_local] = ACTIONS(13660),
    [anon_sym_LPAREN] = ACTIONS(13660),
    [anon_sym_RPAREN] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13660),
    [anon_sym_export] = ACTIONS(13660),
    [anon_sym_import] = ACTIONS(13660),
    [anon_sym_using] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_RBRACK] = ACTIONS(13660),
    [anon_sym_LF] = ACTIONS(13662),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_DOLLAR] = ACTIONS(13660),
    [anon_sym_COLON_COLON] = ACTIONS(13660),
    [anon_sym_isa] = ACTIONS(13660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_AT] = ACTIONS(13660),
    [anon_sym_true] = ACTIONS(13660),
    [anon_sym_false] = ACTIONS(13660),
    [aux_sym_integer_literal_token1] = ACTIONS(13660),
    [aux_sym_integer_literal_token2] = ACTIONS(13660),
    [aux_sym_integer_literal_token3] = ACTIONS(13660),
    [aux_sym_integer_literal_token4] = ACTIONS(13660),
    [aux_sym_float_literal_token1] = ACTIONS(13660),
    [aux_sym_float_literal_token3] = ACTIONS(13660),
    [aux_sym_float_literal_token4] = ACTIONS(13660),
    [sym_character_literal] = ACTIONS(13660),
    [sym__pair_operator] = ACTIONS(13660),
    [sym__arrow_operator] = ACTIONS(13660),
    [sym__lazy_or_operator] = ACTIONS(13660),
    [sym__lazy_and_operator] = ACTIONS(13660),
    [sym__comparison_operator] = ACTIONS(13660),
    [sym__pipe_right_operator] = ACTIONS(13660),
    [sym__pipe_left_operator] = ACTIONS(13660),
    [sym__ellipsis_operator] = ACTIONS(13660),
    [sym__plus_operator] = ACTIONS(13660),
    [sym__times_operator] = ACTIONS(13660),
    [sym__rational_operator] = ACTIONS(13660),
    [sym__bitshift_operator] = ACTIONS(13660),
    [sym__power_operator] = ACTIONS(13660),
    [sym__tilde_operator] = ACTIONS(13660),
    [sym__type_order_operator] = ACTIONS(13660),
    [sym__unary_operator] = ACTIONS(13660),
    [sym__unary_plus_operator] = ACTIONS(13660),
    [aux_sym__terminator_token1] = ACTIONS(13660),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13662),
    [sym__command_start] = ACTIONS(13662),
  },
  [7923] = {
    [ts_builtin_sym_end] = ACTIONS(13666),
    [sym__word_identifier] = ACTIONS(13664),
    [anon_sym_EQ] = ACTIONS(13664),
    [anon_sym_COMMA] = ACTIONS(13664),
    [anon_sym_COLON] = ACTIONS(13664),
    [anon_sym_begin] = ACTIONS(13664),
    [anon_sym_module] = ACTIONS(13664),
    [anon_sym_baremodule] = ACTIONS(13664),
    [anon_sym_abstract] = ACTIONS(13664),
    [anon_sym_primitive] = ACTIONS(13664),
    [anon_sym_mutable] = ACTIONS(13664),
    [anon_sym_struct] = ACTIONS(13664),
    [anon_sym_function] = ACTIONS(13664),
    [anon_sym_macro] = ACTIONS(13664),
    [anon_sym_where] = ACTIONS(13664),
    [anon_sym_quote] = ACTIONS(13664),
    [anon_sym_let] = ACTIONS(13664),
    [anon_sym_if] = ACTIONS(13664),
    [anon_sym_try] = ACTIONS(13664),
    [anon_sym_for] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(13664),
    [sym_break_statement] = ACTIONS(13664),
    [sym_continue_statement] = ACTIONS(13664),
    [anon_sym_return] = ACTIONS(13664),
    [anon_sym_const] = ACTIONS(13664),
    [anon_sym_global] = ACTIONS(13664),
    [anon_sym_local] = ACTIONS(13664),
    [anon_sym_LPAREN] = ACTIONS(13664),
    [anon_sym_RPAREN] = ACTIONS(13664),
    [anon_sym_COLON2] = ACTIONS(13664),
    [anon_sym_export] = ACTIONS(13664),
    [anon_sym_import] = ACTIONS(13664),
    [anon_sym_using] = ACTIONS(13664),
    [anon_sym_LBRACK] = ACTIONS(13664),
    [anon_sym_RBRACK] = ACTIONS(13664),
    [anon_sym_LF] = ACTIONS(13666),
    [anon_sym_in] = ACTIONS(13664),
    [anon_sym_LBRACE] = ACTIONS(13664),
    [anon_sym_DOLLAR] = ACTIONS(13664),
    [anon_sym_COLON_COLON] = ACTIONS(13664),
    [anon_sym_isa] = ACTIONS(13664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13664),
    [anon_sym_QMARK] = ACTIONS(13664),
    [anon_sym_AT] = ACTIONS(13664),
    [anon_sym_true] = ACTIONS(13664),
    [anon_sym_false] = ACTIONS(13664),
    [aux_sym_integer_literal_token1] = ACTIONS(13664),
    [aux_sym_integer_literal_token2] = ACTIONS(13664),
    [aux_sym_integer_literal_token3] = ACTIONS(13664),
    [aux_sym_integer_literal_token4] = ACTIONS(13664),
    [aux_sym_float_literal_token1] = ACTIONS(13664),
    [aux_sym_float_literal_token3] = ACTIONS(13664),
    [aux_sym_float_literal_token4] = ACTIONS(13664),
    [sym_character_literal] = ACTIONS(13664),
    [sym__pair_operator] = ACTIONS(13664),
    [sym__arrow_operator] = ACTIONS(13664),
    [sym__lazy_or_operator] = ACTIONS(13664),
    [sym__lazy_and_operator] = ACTIONS(13664),
    [sym__comparison_operator] = ACTIONS(13664),
    [sym__pipe_right_operator] = ACTIONS(13664),
    [sym__pipe_left_operator] = ACTIONS(13664),
    [sym__ellipsis_operator] = ACTIONS(13664),
    [sym__plus_operator] = ACTIONS(13664),
    [sym__times_operator] = ACTIONS(13664),
    [sym__rational_operator] = ACTIONS(13664),
    [sym__bitshift_operator] = ACTIONS(13664),
    [sym__power_operator] = ACTIONS(13664),
    [sym__tilde_operator] = ACTIONS(13664),
    [sym__type_order_operator] = ACTIONS(13664),
    [sym__unary_operator] = ACTIONS(13664),
    [sym__unary_plus_operator] = ACTIONS(13664),
    [aux_sym__terminator_token1] = ACTIONS(13664),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13666),
    [sym__command_start] = ACTIONS(13666),
  },
  [7924] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_catch] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [7925] = {
    [sym__comprehension_clause] = STATE(18276),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17146),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14188),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14190),
    [anon_sym_LF] = ACTIONS(14192),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14195),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7926] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_catch] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [7927] = {
    [sym__comprehension_clause] = STATE(18405),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17195),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14198),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14200),
    [anon_sym_LF] = ACTIONS(14202),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14205),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7928] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_catch] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [7929] = {
    [aux_sym_open_tuple_repeat1] = STATE(7247),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13194),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_else] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13282),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [7930] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_EQ] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_else] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_finally] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [7931] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_EQ] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_else] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_finally] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [7932] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7933] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13108),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7934] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7935] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7936] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7937] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7938] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7939] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7940] = {
    [sym__comprehension_clause] = STATE(18521),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17125),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14208),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14210),
    [anon_sym_LF] = ACTIONS(14212),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14215),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7941] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7942] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_finally] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [7943] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7944] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7945] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [7946] = {
    [sym_identifier] = STATE(8118),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_EQ] = ACTIONS(11992),
    [anon_sym_COMMA] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_COLON2] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_in] = ACTIONS(11992),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_isa] = ACTIONS(11992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11992),
    [anon_sym_QMARK] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__lazy_or_operator] = ACTIONS(11992),
    [sym__lazy_and_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [7947] = {
    [sym_identifier] = STATE(8119),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_EQ] = ACTIONS(11958),
    [anon_sym_COMMA] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_COLON2] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_in] = ACTIONS(11958),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_isa] = ACTIONS(11958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11958),
    [anon_sym_QMARK] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__lazy_or_operator] = ACTIONS(11958),
    [sym__lazy_and_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [7948] = {
    [sym__comprehension_clause] = STATE(18627),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16734),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14218),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14220),
    [anon_sym_LF] = ACTIONS(14222),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14225),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7949] = {
    [sym_identifier] = STATE(8125),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_EQ] = ACTIONS(12002),
    [anon_sym_COMMA] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_COLON2] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_in] = ACTIONS(12002),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_isa] = ACTIONS(12002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12002),
    [anon_sym_QMARK] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__lazy_or_operator] = ACTIONS(12002),
    [sym__lazy_and_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [7950] = {
    [sym_identifier] = STATE(8126),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_EQ] = ACTIONS(12006),
    [anon_sym_COMMA] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_COLON2] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_in] = ACTIONS(12006),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_isa] = ACTIONS(12006),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12006),
    [anon_sym_QMARK] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__lazy_or_operator] = ACTIONS(12006),
    [sym__lazy_and_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [7951] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7952] = {
    [sym__comprehension_clause] = STATE(18748),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17131),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14228),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14230),
    [anon_sym_LF] = ACTIONS(14232),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14235),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7953] = {
    [sym__comprehension_clause] = STATE(18846),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16664),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14238),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14240),
    [anon_sym_LF] = ACTIONS(14242),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14245),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7954] = {
    [aux_sym_export_statement_repeat1] = STATE(8017),
    [sym__word_identifier] = ACTIONS(13144),
    [anon_sym_EQ] = ACTIONS(13144),
    [anon_sym_COMMA] = ACTIONS(14248),
    [anon_sym_COLON] = ACTIONS(13144),
    [anon_sym_begin] = ACTIONS(13144),
    [anon_sym_module] = ACTIONS(13144),
    [anon_sym_baremodule] = ACTIONS(13144),
    [anon_sym_abstract] = ACTIONS(13144),
    [anon_sym_primitive] = ACTIONS(13144),
    [anon_sym_mutable] = ACTIONS(13144),
    [anon_sym_struct] = ACTIONS(13144),
    [anon_sym_function] = ACTIONS(13144),
    [anon_sym_macro] = ACTIONS(13144),
    [anon_sym_where] = ACTIONS(13144),
    [anon_sym_quote] = ACTIONS(13144),
    [anon_sym_let] = ACTIONS(13144),
    [anon_sym_if] = ACTIONS(13144),
    [anon_sym_try] = ACTIONS(13144),
    [anon_sym_for] = ACTIONS(13144),
    [anon_sym_while] = ACTIONS(13144),
    [sym_break_statement] = ACTIONS(13144),
    [sym_continue_statement] = ACTIONS(13144),
    [anon_sym_return] = ACTIONS(13144),
    [anon_sym_const] = ACTIONS(13144),
    [anon_sym_global] = ACTIONS(13144),
    [anon_sym_local] = ACTIONS(13144),
    [anon_sym_LPAREN] = ACTIONS(13146),
    [anon_sym_RPAREN] = ACTIONS(13146),
    [anon_sym_COLON2] = ACTIONS(13144),
    [anon_sym_export] = ACTIONS(13144),
    [anon_sym_import] = ACTIONS(13144),
    [anon_sym_using] = ACTIONS(13144),
    [anon_sym_LBRACK] = ACTIONS(13146),
    [anon_sym_RBRACK] = ACTIONS(13146),
    [anon_sym_in] = ACTIONS(13144),
    [anon_sym_SEMI] = ACTIONS(13146),
    [anon_sym_LBRACE] = ACTIONS(13146),
    [anon_sym_RBRACE] = ACTIONS(13146),
    [anon_sym_DOLLAR] = ACTIONS(13146),
    [anon_sym_COLON_COLON] = ACTIONS(13146),
    [anon_sym_isa] = ACTIONS(13144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13146),
    [anon_sym_QMARK] = ACTIONS(13146),
    [anon_sym_AT] = ACTIONS(13146),
    [anon_sym_true] = ACTIONS(13144),
    [anon_sym_false] = ACTIONS(13144),
    [aux_sym_integer_literal_token1] = ACTIONS(13146),
    [aux_sym_integer_literal_token2] = ACTIONS(13146),
    [aux_sym_integer_literal_token3] = ACTIONS(13144),
    [aux_sym_integer_literal_token4] = ACTIONS(13144),
    [aux_sym_float_literal_token1] = ACTIONS(13146),
    [aux_sym_float_literal_token3] = ACTIONS(13146),
    [aux_sym_float_literal_token4] = ACTIONS(13146),
    [sym_character_literal] = ACTIONS(13146),
    [sym__pair_operator] = ACTIONS(13146),
    [sym__arrow_operator] = ACTIONS(13144),
    [sym__lazy_or_operator] = ACTIONS(13146),
    [sym__lazy_and_operator] = ACTIONS(13146),
    [sym__comparison_operator] = ACTIONS(13144),
    [sym__pipe_right_operator] = ACTIONS(13146),
    [sym__pipe_left_operator] = ACTIONS(13146),
    [sym__ellipsis_operator] = ACTIONS(13144),
    [sym__plus_operator] = ACTIONS(13144),
    [sym__times_operator] = ACTIONS(13144),
    [sym__rational_operator] = ACTIONS(13146),
    [sym__bitshift_operator] = ACTIONS(13146),
    [sym__power_operator] = ACTIONS(13146),
    [sym__tilde_operator] = ACTIONS(13146),
    [sym__type_order_operator] = ACTIONS(13146),
    [sym__unary_operator] = ACTIONS(13144),
    [sym__unary_plus_operator] = ACTIONS(13144),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13146),
    [sym__command_start] = ACTIONS(13146),
  },
  [7955] = {
    [aux_sym__import_list_repeat1] = STATE(8019),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13090),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_LPAREN] = ACTIONS(12868),
    [anon_sym_RPAREN] = ACTIONS(12868),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12868),
    [anon_sym_RBRACK] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_SEMI] = ACTIONS(12868),
    [anon_sym_LBRACE] = ACTIONS(12868),
    [anon_sym_RBRACE] = ACTIONS(12868),
    [anon_sym_DOLLAR] = ACTIONS(12868),
    [anon_sym_COLON_COLON] = ACTIONS(12868),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12868),
    [anon_sym_QMARK] = ACTIONS(12868),
    [anon_sym_AT] = ACTIONS(12868),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12868),
    [aux_sym_integer_literal_token2] = ACTIONS(12868),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12868),
    [aux_sym_float_literal_token3] = ACTIONS(12868),
    [aux_sym_float_literal_token4] = ACTIONS(12868),
    [sym_character_literal] = ACTIONS(12868),
    [sym__pair_operator] = ACTIONS(12868),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12868),
    [sym__lazy_and_operator] = ACTIONS(12868),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12868),
    [sym__pipe_left_operator] = ACTIONS(12868),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12868),
    [sym__bitshift_operator] = ACTIONS(12868),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(12868),
    [sym__type_order_operator] = ACTIONS(12868),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [7956] = {
    [sym__comprehension_clause] = STATE(18949),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16807),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14250),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14252),
    [anon_sym_LF] = ACTIONS(14254),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14257),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7957] = {
    [sym__comprehension_clause] = STATE(19055),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17072),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14260),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14262),
    [anon_sym_LF] = ACTIONS(14264),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14267),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7958] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_catch] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [7959] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_catch] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [7960] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_finally] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [7961] = {
    [sym__comprehension_clause] = STATE(19149),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17246),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14270),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14272),
    [anon_sym_LF] = ACTIONS(14274),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14277),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7962] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_finally] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [7963] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_finally] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [7964] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_catch] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [7965] = {
    [sym__comprehension_clause] = STATE(19260),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16665),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14280),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14282),
    [anon_sym_LF] = ACTIONS(14284),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14287),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7966] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11944),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [7967] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_finally] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [7968] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_finally] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [7969] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_finally] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [7970] = {
    [sym__comprehension_clause] = STATE(19392),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16775),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14290),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14292),
    [anon_sym_LF] = ACTIONS(14294),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14297),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7971] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [7972] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_finally] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [7973] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_finally] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [7974] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_finally] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [7975] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_finally] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [7976] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_finally] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [7977] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_finally] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [7978] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_finally] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [7979] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_finally] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [7980] = {
    [sym__comprehension_clause] = STATE(19532),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16877),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14300),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14302),
    [anon_sym_LF] = ACTIONS(14304),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14307),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7981] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_finally] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [7982] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_finally] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [7983] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_finally] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [7984] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_finally] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [7985] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_finally] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [7986] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_finally] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [7987] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_finally] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [7988] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_finally] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [7989] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_finally] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [7990] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_finally] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [7991] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_finally] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [7992] = {
    [sym__comprehension_clause] = STATE(19656),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16944),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14310),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14312),
    [anon_sym_LF] = ACTIONS(14314),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14317),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [7993] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_finally] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [7994] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_finally] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [7995] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(12450),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_else] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [7996] = {
    [aux_sym_open_tuple_repeat1] = STATE(7247),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(13194),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13096),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_else] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13098),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13102),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13282),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13251),
    [sym__arrow_operator] = ACTIONS(13110),
    [sym__lazy_or_operator] = ACTIONS(13112),
    [sym__lazy_and_operator] = ACTIONS(13114),
    [sym__comparison_operator] = ACTIONS(13102),
    [sym__pipe_right_operator] = ACTIONS(13116),
    [sym__pipe_left_operator] = ACTIONS(13118),
    [sym__ellipsis_operator] = ACTIONS(13120),
    [sym__plus_operator] = ACTIONS(13122),
    [sym__times_operator] = ACTIONS(13124),
    [sym__rational_operator] = ACTIONS(13126),
    [sym__bitshift_operator] = ACTIONS(13128),
    [sym__power_operator] = ACTIONS(13130),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13102),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13122),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [7997] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_finally] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [7998] = {
    [aux_sym_open_tuple_repeat1] = STATE(8001),
    [sym__word_identifier] = ACTIONS(13150),
    [anon_sym_EQ] = ACTIONS(13150),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_COLON] = ACTIONS(13150),
    [anon_sym_begin] = ACTIONS(13150),
    [anon_sym_module] = ACTIONS(13150),
    [anon_sym_baremodule] = ACTIONS(13150),
    [anon_sym_abstract] = ACTIONS(13150),
    [anon_sym_primitive] = ACTIONS(13150),
    [anon_sym_mutable] = ACTIONS(13150),
    [anon_sym_struct] = ACTIONS(13150),
    [anon_sym_function] = ACTIONS(13150),
    [anon_sym_macro] = ACTIONS(13150),
    [anon_sym_where] = ACTIONS(13150),
    [anon_sym_quote] = ACTIONS(13150),
    [anon_sym_let] = ACTIONS(13150),
    [anon_sym_if] = ACTIONS(13150),
    [anon_sym_try] = ACTIONS(13150),
    [anon_sym_catch] = ACTIONS(13150),
    [anon_sym_finally] = ACTIONS(13150),
    [anon_sym_for] = ACTIONS(13150),
    [anon_sym_while] = ACTIONS(13150),
    [sym_break_statement] = ACTIONS(13150),
    [sym_continue_statement] = ACTIONS(13150),
    [anon_sym_return] = ACTIONS(13150),
    [anon_sym_const] = ACTIONS(13150),
    [anon_sym_global] = ACTIONS(13150),
    [anon_sym_local] = ACTIONS(13150),
    [anon_sym_LPAREN] = ACTIONS(13150),
    [anon_sym_COLON2] = ACTIONS(13150),
    [anon_sym_export] = ACTIONS(13150),
    [anon_sym_import] = ACTIONS(13150),
    [anon_sym_using] = ACTIONS(13150),
    [anon_sym_LBRACK] = ACTIONS(13150),
    [anon_sym_LF] = ACTIONS(13148),
    [anon_sym_in] = ACTIONS(13150),
    [anon_sym_LBRACE] = ACTIONS(13150),
    [anon_sym_DOLLAR] = ACTIONS(13150),
    [anon_sym_COLON_COLON] = ACTIONS(13150),
    [anon_sym_isa] = ACTIONS(13150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13150),
    [anon_sym_QMARK] = ACTIONS(13150),
    [anon_sym_AT] = ACTIONS(13150),
    [anon_sym_true] = ACTIONS(13150),
    [anon_sym_false] = ACTIONS(13150),
    [aux_sym_integer_literal_token1] = ACTIONS(13150),
    [aux_sym_integer_literal_token2] = ACTIONS(13150),
    [aux_sym_integer_literal_token3] = ACTIONS(13150),
    [aux_sym_integer_literal_token4] = ACTIONS(13150),
    [aux_sym_float_literal_token1] = ACTIONS(13150),
    [aux_sym_float_literal_token3] = ACTIONS(13150),
    [aux_sym_float_literal_token4] = ACTIONS(13150),
    [sym_character_literal] = ACTIONS(13150),
    [sym__pair_operator] = ACTIONS(13150),
    [sym__arrow_operator] = ACTIONS(13150),
    [sym__lazy_or_operator] = ACTIONS(13150),
    [sym__lazy_and_operator] = ACTIONS(13150),
    [sym__comparison_operator] = ACTIONS(13150),
    [sym__pipe_right_operator] = ACTIONS(13150),
    [sym__pipe_left_operator] = ACTIONS(13150),
    [sym__ellipsis_operator] = ACTIONS(13150),
    [sym__plus_operator] = ACTIONS(13150),
    [sym__times_operator] = ACTIONS(13150),
    [sym__rational_operator] = ACTIONS(13150),
    [sym__bitshift_operator] = ACTIONS(13150),
    [sym__power_operator] = ACTIONS(13150),
    [sym__tilde_operator] = ACTIONS(13150),
    [sym__type_order_operator] = ACTIONS(13150),
    [sym__unary_operator] = ACTIONS(13150),
    [sym__unary_plus_operator] = ACTIONS(13150),
    [aux_sym__terminator_token1] = ACTIONS(13150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13148),
    [sym__command_start] = ACTIONS(13148),
  },
  [7999] = {
    [sym__comprehension_clause] = STATE(19801),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17122),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14322),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14324),
    [anon_sym_LF] = ACTIONS(14326),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14329),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [8000] = {
    [sym__comprehension_clause] = STATE(19759),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17188),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14332),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14334),
    [anon_sym_LF] = ACTIONS(14336),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14339),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [8001] = {
    [aux_sym_open_tuple_repeat1] = STATE(8001),
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(14342),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13070),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_catch] = ACTIONS(13070),
    [anon_sym_finally] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(13070),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13070),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(13070),
    [anon_sym_isa] = ACTIONS(13070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13070),
    [anon_sym_QMARK] = ACTIONS(13070),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(13070),
    [sym__arrow_operator] = ACTIONS(13070),
    [sym__lazy_or_operator] = ACTIONS(13070),
    [sym__lazy_and_operator] = ACTIONS(13070),
    [sym__comparison_operator] = ACTIONS(13070),
    [sym__pipe_right_operator] = ACTIONS(13070),
    [sym__pipe_left_operator] = ACTIONS(13070),
    [sym__ellipsis_operator] = ACTIONS(13070),
    [sym__plus_operator] = ACTIONS(13070),
    [sym__times_operator] = ACTIONS(13070),
    [sym__rational_operator] = ACTIONS(13070),
    [sym__bitshift_operator] = ACTIONS(13070),
    [sym__power_operator] = ACTIONS(13070),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(13070),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13070),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [8002] = {
    [sym__comprehension_clause] = STATE(18406),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17259),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14345),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14347),
    [anon_sym_LF] = ACTIONS(14349),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14352),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [8003] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_finally] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [8004] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_end] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_catch] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_as] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [8005] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_finally] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [8006] = {
    [sym__comprehension_clause] = STATE(19063),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17332),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14355),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14357),
    [anon_sym_LF] = ACTIONS(14359),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14362),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [8007] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_finally] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [8008] = {
    [sym__comprehension_clause] = STATE(19521),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16695),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14365),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14367),
    [anon_sym_LF] = ACTIONS(14369),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14372),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [8009] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_finally] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [8010] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_finally] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [8011] = {
    [sym__comprehension_clause] = STATE(18245),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16743),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14375),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14377),
    [anon_sym_LF] = ACTIONS(14379),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [8012] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_finally] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [8013] = {
    [sym__comprehension_clause] = STATE(18420),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16801),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14385),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14387),
    [anon_sym_LF] = ACTIONS(14389),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14392),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [8014] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_finally] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [8015] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_catch] = ACTIONS(11866),
    [anon_sym_finally] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [8016] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_as] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [8017] = {
    [aux_sym_export_statement_repeat1] = STATE(8075),
    [sym__word_identifier] = ACTIONS(13060),
    [anon_sym_EQ] = ACTIONS(13060),
    [anon_sym_COMMA] = ACTIONS(14248),
    [anon_sym_COLON] = ACTIONS(13060),
    [anon_sym_begin] = ACTIONS(13060),
    [anon_sym_module] = ACTIONS(13060),
    [anon_sym_baremodule] = ACTIONS(13060),
    [anon_sym_abstract] = ACTIONS(13060),
    [anon_sym_primitive] = ACTIONS(13060),
    [anon_sym_mutable] = ACTIONS(13060),
    [anon_sym_struct] = ACTIONS(13060),
    [anon_sym_function] = ACTIONS(13060),
    [anon_sym_macro] = ACTIONS(13060),
    [anon_sym_where] = ACTIONS(13060),
    [anon_sym_quote] = ACTIONS(13060),
    [anon_sym_let] = ACTIONS(13060),
    [anon_sym_if] = ACTIONS(13060),
    [anon_sym_try] = ACTIONS(13060),
    [anon_sym_for] = ACTIONS(13060),
    [anon_sym_while] = ACTIONS(13060),
    [sym_break_statement] = ACTIONS(13060),
    [sym_continue_statement] = ACTIONS(13060),
    [anon_sym_return] = ACTIONS(13060),
    [anon_sym_const] = ACTIONS(13060),
    [anon_sym_global] = ACTIONS(13060),
    [anon_sym_local] = ACTIONS(13060),
    [anon_sym_LPAREN] = ACTIONS(13064),
    [anon_sym_RPAREN] = ACTIONS(13064),
    [anon_sym_COLON2] = ACTIONS(13060),
    [anon_sym_export] = ACTIONS(13060),
    [anon_sym_import] = ACTIONS(13060),
    [anon_sym_using] = ACTIONS(13060),
    [anon_sym_LBRACK] = ACTIONS(13064),
    [anon_sym_RBRACK] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13060),
    [anon_sym_SEMI] = ACTIONS(13064),
    [anon_sym_LBRACE] = ACTIONS(13064),
    [anon_sym_RBRACE] = ACTIONS(13064),
    [anon_sym_DOLLAR] = ACTIONS(13064),
    [anon_sym_COLON_COLON] = ACTIONS(13064),
    [anon_sym_isa] = ACTIONS(13060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13064),
    [anon_sym_QMARK] = ACTIONS(13064),
    [anon_sym_AT] = ACTIONS(13064),
    [anon_sym_true] = ACTIONS(13060),
    [anon_sym_false] = ACTIONS(13060),
    [aux_sym_integer_literal_token1] = ACTIONS(13064),
    [aux_sym_integer_literal_token2] = ACTIONS(13064),
    [aux_sym_integer_literal_token3] = ACTIONS(13060),
    [aux_sym_integer_literal_token4] = ACTIONS(13060),
    [aux_sym_float_literal_token1] = ACTIONS(13064),
    [aux_sym_float_literal_token3] = ACTIONS(13064),
    [aux_sym_float_literal_token4] = ACTIONS(13064),
    [sym_character_literal] = ACTIONS(13064),
    [sym__pair_operator] = ACTIONS(13064),
    [sym__arrow_operator] = ACTIONS(13060),
    [sym__lazy_or_operator] = ACTIONS(13064),
    [sym__lazy_and_operator] = ACTIONS(13064),
    [sym__comparison_operator] = ACTIONS(13060),
    [sym__pipe_right_operator] = ACTIONS(13064),
    [sym__pipe_left_operator] = ACTIONS(13064),
    [sym__ellipsis_operator] = ACTIONS(13060),
    [sym__plus_operator] = ACTIONS(13060),
    [sym__times_operator] = ACTIONS(13060),
    [sym__rational_operator] = ACTIONS(13064),
    [sym__bitshift_operator] = ACTIONS(13064),
    [sym__power_operator] = ACTIONS(13064),
    [sym__tilde_operator] = ACTIONS(13064),
    [sym__type_order_operator] = ACTIONS(13064),
    [sym__unary_operator] = ACTIONS(13060),
    [sym__unary_plus_operator] = ACTIONS(13060),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13064),
    [sym__command_start] = ACTIONS(13064),
  },
  [8018] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_as] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_RPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_SEMI] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [8019] = {
    [aux_sym__import_list_repeat1] = STATE(8077),
    [sym__word_identifier] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13090),
    [anon_sym_COLON] = ACTIONS(13066),
    [anon_sym_begin] = ACTIONS(13066),
    [anon_sym_module] = ACTIONS(13066),
    [anon_sym_baremodule] = ACTIONS(13066),
    [anon_sym_abstract] = ACTIONS(13066),
    [anon_sym_primitive] = ACTIONS(13066),
    [anon_sym_mutable] = ACTIONS(13066),
    [anon_sym_struct] = ACTIONS(13066),
    [anon_sym_function] = ACTIONS(13066),
    [anon_sym_macro] = ACTIONS(13066),
    [anon_sym_where] = ACTIONS(13066),
    [anon_sym_quote] = ACTIONS(13066),
    [anon_sym_let] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13066),
    [anon_sym_try] = ACTIONS(13066),
    [anon_sym_for] = ACTIONS(13066),
    [anon_sym_while] = ACTIONS(13066),
    [sym_break_statement] = ACTIONS(13066),
    [sym_continue_statement] = ACTIONS(13066),
    [anon_sym_return] = ACTIONS(13066),
    [anon_sym_const] = ACTIONS(13066),
    [anon_sym_global] = ACTIONS(13066),
    [anon_sym_local] = ACTIONS(13066),
    [anon_sym_LPAREN] = ACTIONS(13068),
    [anon_sym_RPAREN] = ACTIONS(13068),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_export] = ACTIONS(13066),
    [anon_sym_import] = ACTIONS(13066),
    [anon_sym_using] = ACTIONS(13066),
    [anon_sym_LBRACK] = ACTIONS(13068),
    [anon_sym_RBRACK] = ACTIONS(13068),
    [anon_sym_in] = ACTIONS(13066),
    [anon_sym_SEMI] = ACTIONS(13068),
    [anon_sym_LBRACE] = ACTIONS(13068),
    [anon_sym_RBRACE] = ACTIONS(13068),
    [anon_sym_DOLLAR] = ACTIONS(13068),
    [anon_sym_COLON_COLON] = ACTIONS(13068),
    [anon_sym_isa] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13068),
    [anon_sym_QMARK] = ACTIONS(13068),
    [anon_sym_AT] = ACTIONS(13068),
    [anon_sym_true] = ACTIONS(13066),
    [anon_sym_false] = ACTIONS(13066),
    [aux_sym_integer_literal_token1] = ACTIONS(13068),
    [aux_sym_integer_literal_token2] = ACTIONS(13068),
    [aux_sym_integer_literal_token3] = ACTIONS(13066),
    [aux_sym_integer_literal_token4] = ACTIONS(13066),
    [aux_sym_float_literal_token1] = ACTIONS(13068),
    [aux_sym_float_literal_token3] = ACTIONS(13068),
    [aux_sym_float_literal_token4] = ACTIONS(13068),
    [sym_character_literal] = ACTIONS(13068),
    [sym__pair_operator] = ACTIONS(13068),
    [sym__arrow_operator] = ACTIONS(13066),
    [sym__lazy_or_operator] = ACTIONS(13068),
    [sym__lazy_and_operator] = ACTIONS(13068),
    [sym__comparison_operator] = ACTIONS(13066),
    [sym__pipe_right_operator] = ACTIONS(13068),
    [sym__pipe_left_operator] = ACTIONS(13068),
    [sym__ellipsis_operator] = ACTIONS(13066),
    [sym__plus_operator] = ACTIONS(13066),
    [sym__times_operator] = ACTIONS(13066),
    [sym__rational_operator] = ACTIONS(13068),
    [sym__bitshift_operator] = ACTIONS(13068),
    [sym__power_operator] = ACTIONS(13068),
    [sym__tilde_operator] = ACTIONS(13068),
    [sym__type_order_operator] = ACTIONS(13068),
    [sym__unary_operator] = ACTIONS(13066),
    [sym__unary_plus_operator] = ACTIONS(13066),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13068),
    [sym__command_start] = ACTIONS(13068),
  },
  [8020] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_as] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_RPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_SEMI] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [8021] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_elseif] = ACTIONS(13249),
    [anon_sym_else] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8022] = {
    [sym__primary_expression] = STATE(11436),
    [sym__array] = STATE(11436),
    [sym_comprehension_expression] = STATE(11436),
    [sym_matrix_expression] = STATE(11436),
    [sym_vector_expression] = STATE(11436),
    [sym_parenthesized_expression] = STATE(11436),
    [sym_tuple_expression] = STATE(11436),
    [sym_curly_expression] = STATE(11436),
    [sym_adjoint_expression] = STATE(11436),
    [sym_field_expression] = STATE(11436),
    [sym_index_expression] = STATE(11436),
    [sym_parametrized_type_expression] = STATE(11436),
    [sym_call_expression] = STATE(11436),
    [sym_broadcast_call_expression] = STATE(11436),
    [sym__closed_macrocall_expression] = STATE(11436),
    [sym_interpolation_expression] = STATE(11436),
    [sym_quote_expression] = STATE(11436),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(11024),
    [sym_boolean_literal] = STATE(11436),
    [sym__string] = STATE(11436),
    [sym_string_literal] = STATE(11436),
    [sym_command_literal] = STATE(11436),
    [sym_prefixed_string_literal] = STATE(11436),
    [sym_prefixed_command_literal] = STATE(11436),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(14395),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_finally] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(14397),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(14399),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [8023] = {
    [ts_builtin_sym_end] = ACTIONS(13199),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13342),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_RPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_RBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8024] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13356),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_elseif] = ACTIONS(13239),
    [anon_sym_else] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8025] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13356),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_elseif] = ACTIONS(13243),
    [anon_sym_else] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8026] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(13356),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_elseif] = ACTIONS(12926),
    [anon_sym_else] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8027] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_elseif] = ACTIONS(13308),
    [anon_sym_else] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [8028] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13356),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_elseif] = ACTIONS(13201),
    [anon_sym_else] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8029] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_EQ] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_elseif] = ACTIONS(13467),
    [anon_sym_else] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [8030] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(12956),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(12956),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8031] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(12958),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8032] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(12960),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8033] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(12962),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8034] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(12964),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8035] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_as] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [8036] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13411),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_else] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8037] = {
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11852),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8038] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_as] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_RPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_SEMI] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [8039] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_as] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_RPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_SEMI] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [8040] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_as] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_RPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_SEMI] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [8041] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_as] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_RPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_SEMI] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [8042] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_as] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_RPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_SEMI] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [8043] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_as] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_RPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_SEMI] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [8044] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_as] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_RPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_SEMI] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [8045] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_as] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [8046] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13411),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_else] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8047] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13411),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_else] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8048] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(13411),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_else] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8049] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_as] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [8050] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_as] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [8051] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_as] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_RPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_SEMI] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [8052] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11858),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8053] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_as] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_RPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_SEMI] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [8054] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_as] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_RPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_SEMI] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [8055] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_as] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [8056] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_as] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [8057] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_as] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_RPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_SEMI] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [8058] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_as] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_RPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [8059] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_as] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [8060] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_as] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_RPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_SEMI] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [8061] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_as] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_RPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_SEMI] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [8062] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_as] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_RPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_SEMI] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [8063] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_as] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_RPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_SEMI] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [8064] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_as] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_RPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_SEMI] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [8065] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_as] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_RPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_SEMI] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [8066] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_as] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_RPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_SEMI] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [8067] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_as] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [8068] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_as] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_RPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_SEMI] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [8069] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_as] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_RPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_SEMI] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [8070] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_as] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_RPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_SEMI] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [8071] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_as] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_RPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_SEMI] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [8072] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_as] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_RPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_SEMI] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [8073] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_as] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_RPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_SEMI] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [8074] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11878),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8075] = {
    [aux_sym_export_statement_repeat1] = STATE(8075),
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(14401),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12972),
    [anon_sym_RPAREN] = ACTIONS(12972),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12972),
    [anon_sym_RBRACK] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_SEMI] = ACTIONS(12972),
    [anon_sym_LBRACE] = ACTIONS(12972),
    [anon_sym_RBRACE] = ACTIONS(12972),
    [anon_sym_DOLLAR] = ACTIONS(12972),
    [anon_sym_COLON_COLON] = ACTIONS(12972),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12972),
    [anon_sym_QMARK] = ACTIONS(12972),
    [anon_sym_AT] = ACTIONS(12972),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12972),
    [aux_sym_integer_literal_token2] = ACTIONS(12972),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12972),
    [aux_sym_float_literal_token3] = ACTIONS(12972),
    [aux_sym_float_literal_token4] = ACTIONS(12972),
    [sym_character_literal] = ACTIONS(12972),
    [sym__pair_operator] = ACTIONS(12972),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12972),
    [sym__lazy_and_operator] = ACTIONS(12972),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12972),
    [sym__pipe_left_operator] = ACTIONS(12972),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12972),
    [sym__bitshift_operator] = ACTIONS(12972),
    [sym__power_operator] = ACTIONS(12972),
    [sym__tilde_operator] = ACTIONS(12972),
    [sym__type_order_operator] = ACTIONS(12972),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [8076] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12979),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_as] = ACTIONS(13092),
    [anon_sym_LPAREN] = ACTIONS(12979),
    [anon_sym_RPAREN] = ACTIONS(12979),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12979),
    [anon_sym_RBRACK] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_SEMI] = ACTIONS(12979),
    [anon_sym_LBRACE] = ACTIONS(12979),
    [anon_sym_RBRACE] = ACTIONS(12979),
    [anon_sym_DOLLAR] = ACTIONS(12979),
    [anon_sym_COLON_COLON] = ACTIONS(12979),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12979),
    [anon_sym_QMARK] = ACTIONS(12979),
    [anon_sym_AT] = ACTIONS(12979),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12979),
    [aux_sym_integer_literal_token2] = ACTIONS(12979),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12979),
    [aux_sym_float_literal_token3] = ACTIONS(12979),
    [aux_sym_float_literal_token4] = ACTIONS(12979),
    [sym_character_literal] = ACTIONS(12979),
    [sym__pair_operator] = ACTIONS(12979),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12979),
    [sym__lazy_and_operator] = ACTIONS(12979),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12979),
    [sym__pipe_left_operator] = ACTIONS(12979),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12979),
    [sym__bitshift_operator] = ACTIONS(12979),
    [sym__power_operator] = ACTIONS(12979),
    [sym__tilde_operator] = ACTIONS(12979),
    [sym__type_order_operator] = ACTIONS(12979),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8077] = {
    [aux_sym__import_list_repeat1] = STATE(8077),
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(14404),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12979),
    [anon_sym_RPAREN] = ACTIONS(12979),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12979),
    [anon_sym_RBRACK] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_SEMI] = ACTIONS(12979),
    [anon_sym_LBRACE] = ACTIONS(12979),
    [anon_sym_RBRACE] = ACTIONS(12979),
    [anon_sym_DOLLAR] = ACTIONS(12979),
    [anon_sym_COLON_COLON] = ACTIONS(12979),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12979),
    [anon_sym_QMARK] = ACTIONS(12979),
    [anon_sym_AT] = ACTIONS(12979),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12979),
    [aux_sym_integer_literal_token2] = ACTIONS(12979),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12979),
    [aux_sym_float_literal_token3] = ACTIONS(12979),
    [aux_sym_float_literal_token4] = ACTIONS(12979),
    [sym_character_literal] = ACTIONS(12979),
    [sym__pair_operator] = ACTIONS(12979),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12979),
    [sym__lazy_and_operator] = ACTIONS(12979),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12979),
    [sym__pipe_left_operator] = ACTIONS(12979),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12979),
    [sym__bitshift_operator] = ACTIONS(12979),
    [sym__power_operator] = ACTIONS(12979),
    [sym__tilde_operator] = ACTIONS(12979),
    [sym__type_order_operator] = ACTIONS(12979),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8078] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_as] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [8079] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8080] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_as] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [8081] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_as] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_RPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_SEMI] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [8082] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_as] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_RPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_SEMI] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [8083] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12676),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12676),
    [anon_sym_RPAREN] = ACTIONS(12676),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12676),
    [anon_sym_RBRACK] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12676),
    [anon_sym_LBRACE] = ACTIONS(12676),
    [anon_sym_RBRACE] = ACTIONS(12676),
    [anon_sym_DOLLAR] = ACTIONS(12676),
    [anon_sym_COLON_COLON] = ACTIONS(12676),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12676),
    [anon_sym_QMARK] = ACTIONS(12676),
    [anon_sym_AT] = ACTIONS(12676),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12676),
    [aux_sym_integer_literal_token2] = ACTIONS(12676),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12676),
    [aux_sym_float_literal_token3] = ACTIONS(12676),
    [aux_sym_float_literal_token4] = ACTIONS(12676),
    [sym_character_literal] = ACTIONS(12676),
    [sym__pair_operator] = ACTIONS(12676),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12676),
    [sym__lazy_and_operator] = ACTIONS(12676),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12676),
    [sym__pipe_left_operator] = ACTIONS(12676),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12676),
    [sym__bitshift_operator] = ACTIONS(12676),
    [sym__power_operator] = ACTIONS(12676),
    [sym__tilde_operator] = ACTIONS(12676),
    [sym__type_order_operator] = ACTIONS(12676),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8084] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12676),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12676),
    [anon_sym_RPAREN] = ACTIONS(12676),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12676),
    [anon_sym_RBRACK] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12676),
    [anon_sym_LBRACE] = ACTIONS(12676),
    [anon_sym_RBRACE] = ACTIONS(12676),
    [anon_sym_DOT] = ACTIONS(14407),
    [anon_sym_DOLLAR] = ACTIONS(12676),
    [anon_sym_COLON_COLON] = ACTIONS(12676),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12676),
    [anon_sym_QMARK] = ACTIONS(12676),
    [anon_sym_AT] = ACTIONS(12676),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12676),
    [aux_sym_integer_literal_token2] = ACTIONS(12676),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12676),
    [aux_sym_float_literal_token3] = ACTIONS(12676),
    [aux_sym_float_literal_token4] = ACTIONS(12676),
    [sym_character_literal] = ACTIONS(12676),
    [sym__pair_operator] = ACTIONS(12676),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12676),
    [sym__lazy_and_operator] = ACTIONS(12676),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12676),
    [sym__pipe_left_operator] = ACTIONS(12676),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12676),
    [sym__bitshift_operator] = ACTIONS(12676),
    [sym__power_operator] = ACTIONS(12676),
    [sym__tilde_operator] = ACTIONS(12676),
    [sym__type_order_operator] = ACTIONS(12676),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8085] = {
    [aux_sym_open_tuple_repeat1] = STATE(7998),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_catch] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14419),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8086] = {
    [aux_sym_open_tuple_repeat1] = STATE(7998),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_catch] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14419),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8087] = {
    [aux_sym_open_tuple_repeat1] = STATE(7998),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_catch] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14419),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8088] = {
    [aux_sym_open_tuple_repeat1] = STATE(7998),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_catch] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14419),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8089] = {
    [aux_sym_open_tuple_repeat1] = STATE(7376),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(13394),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_catch] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14455),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8090] = {
    [aux_sym_open_tuple_repeat1] = STATE(7471),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(13497),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8091] = {
    [aux_sym_open_tuple_repeat1] = STATE(7376),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13394),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_catch] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14455),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8092] = {
    [aux_sym_open_tuple_repeat1] = STATE(7376),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13394),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_catch] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14455),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8093] = {
    [aux_sym_open_tuple_repeat1] = STATE(7376),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(13394),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_catch] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14455),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8094] = {
    [aux_sym_open_tuple_repeat1] = STATE(7471),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13497),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8095] = {
    [aux_sym_open_tuple_repeat1] = STATE(7471),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13497),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8096] = {
    [aux_sym_open_tuple_repeat1] = STATE(7471),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(13497),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8097] = {
    [aux_sym_open_tuple_repeat1] = STATE(7998),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_catch] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14419),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8098] = {
    [aux_sym_open_tuple_repeat1] = STATE(7376),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13394),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_catch] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14455),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8099] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_catch] = ACTIONS(13255),
    [anon_sym_finally] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14419),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8100] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_catch] = ACTIONS(13094),
    [anon_sym_finally] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14419),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8101] = {
    [aux_sym_open_tuple_repeat1] = STATE(7471),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13497),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8102] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_catch] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14455),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8103] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_catch] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14455),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8104] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_finally] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8105] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_finally] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8106] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_catch] = ACTIONS(12248),
    [anon_sym_finally] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [8107] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14517),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14519),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14521),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(14521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14523),
    [sym__comparison_operator] = ACTIONS(14521),
    [sym__pipe_right_operator] = ACTIONS(14525),
    [sym__pipe_left_operator] = ACTIONS(14527),
    [sym__ellipsis_operator] = ACTIONS(14529),
    [sym__plus_operator] = ACTIONS(14531),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14521),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14531),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8108] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_finally] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [8109] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [8110] = {
    [sym__word_identifier] = ACTIONS(13628),
    [anon_sym_EQ] = ACTIONS(13628),
    [anon_sym_COMMA] = ACTIONS(13628),
    [anon_sym_COLON] = ACTIONS(13628),
    [anon_sym_begin] = ACTIONS(13628),
    [anon_sym_module] = ACTIONS(13628),
    [anon_sym_baremodule] = ACTIONS(13628),
    [anon_sym_abstract] = ACTIONS(13628),
    [anon_sym_primitive] = ACTIONS(13628),
    [anon_sym_mutable] = ACTIONS(13628),
    [anon_sym_struct] = ACTIONS(13628),
    [anon_sym_function] = ACTIONS(13628),
    [anon_sym_macro] = ACTIONS(13628),
    [anon_sym_where] = ACTIONS(13628),
    [anon_sym_quote] = ACTIONS(13628),
    [anon_sym_let] = ACTIONS(13628),
    [anon_sym_if] = ACTIONS(13628),
    [anon_sym_try] = ACTIONS(13628),
    [anon_sym_catch] = ACTIONS(13628),
    [anon_sym_finally] = ACTIONS(13628),
    [anon_sym_for] = ACTIONS(13628),
    [anon_sym_while] = ACTIONS(13628),
    [sym_break_statement] = ACTIONS(13628),
    [sym_continue_statement] = ACTIONS(13628),
    [anon_sym_return] = ACTIONS(13628),
    [anon_sym_const] = ACTIONS(13628),
    [anon_sym_global] = ACTIONS(13628),
    [anon_sym_local] = ACTIONS(13628),
    [anon_sym_LPAREN] = ACTIONS(13628),
    [anon_sym_COLON2] = ACTIONS(13628),
    [anon_sym_export] = ACTIONS(13628),
    [anon_sym_import] = ACTIONS(13628),
    [anon_sym_using] = ACTIONS(13628),
    [anon_sym_LBRACK] = ACTIONS(13628),
    [anon_sym_LF] = ACTIONS(13630),
    [anon_sym_in] = ACTIONS(13628),
    [anon_sym_LBRACE] = ACTIONS(13628),
    [anon_sym_DOLLAR] = ACTIONS(13628),
    [anon_sym_COLON_COLON] = ACTIONS(13628),
    [anon_sym_isa] = ACTIONS(13628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13628),
    [anon_sym_QMARK] = ACTIONS(13628),
    [anon_sym_AT] = ACTIONS(13628),
    [anon_sym_true] = ACTIONS(13628),
    [anon_sym_false] = ACTIONS(13628),
    [aux_sym_integer_literal_token1] = ACTIONS(13628),
    [aux_sym_integer_literal_token2] = ACTIONS(13628),
    [aux_sym_integer_literal_token3] = ACTIONS(13628),
    [aux_sym_integer_literal_token4] = ACTIONS(13628),
    [aux_sym_float_literal_token1] = ACTIONS(13628),
    [aux_sym_float_literal_token3] = ACTIONS(13628),
    [aux_sym_float_literal_token4] = ACTIONS(13628),
    [sym_character_literal] = ACTIONS(13628),
    [sym__pair_operator] = ACTIONS(13628),
    [sym__arrow_operator] = ACTIONS(13628),
    [sym__lazy_or_operator] = ACTIONS(13628),
    [sym__lazy_and_operator] = ACTIONS(13628),
    [sym__comparison_operator] = ACTIONS(13628),
    [sym__pipe_right_operator] = ACTIONS(13628),
    [sym__pipe_left_operator] = ACTIONS(13628),
    [sym__ellipsis_operator] = ACTIONS(13628),
    [sym__plus_operator] = ACTIONS(13628),
    [sym__times_operator] = ACTIONS(13628),
    [sym__rational_operator] = ACTIONS(13628),
    [sym__bitshift_operator] = ACTIONS(13628),
    [sym__power_operator] = ACTIONS(13628),
    [sym__tilde_operator] = ACTIONS(13628),
    [sym__type_order_operator] = ACTIONS(13628),
    [sym__unary_operator] = ACTIONS(13628),
    [sym__unary_plus_operator] = ACTIONS(13628),
    [aux_sym__terminator_token1] = ACTIONS(13628),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13630),
    [sym__command_start] = ACTIONS(13630),
  },
  [8111] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [8112] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_RPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_SEMI] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [8113] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [8114] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [8115] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [8116] = {
    [sym__word_identifier] = ACTIONS(13632),
    [anon_sym_EQ] = ACTIONS(13632),
    [anon_sym_COMMA] = ACTIONS(13632),
    [anon_sym_COLON] = ACTIONS(13632),
    [anon_sym_begin] = ACTIONS(13632),
    [anon_sym_module] = ACTIONS(13632),
    [anon_sym_baremodule] = ACTIONS(13632),
    [anon_sym_abstract] = ACTIONS(13632),
    [anon_sym_primitive] = ACTIONS(13632),
    [anon_sym_mutable] = ACTIONS(13632),
    [anon_sym_struct] = ACTIONS(13632),
    [anon_sym_function] = ACTIONS(13632),
    [anon_sym_macro] = ACTIONS(13632),
    [anon_sym_where] = ACTIONS(13632),
    [anon_sym_quote] = ACTIONS(13632),
    [anon_sym_let] = ACTIONS(13632),
    [anon_sym_if] = ACTIONS(13632),
    [anon_sym_try] = ACTIONS(13632),
    [anon_sym_catch] = ACTIONS(13632),
    [anon_sym_finally] = ACTIONS(13632),
    [anon_sym_for] = ACTIONS(13632),
    [anon_sym_while] = ACTIONS(13632),
    [sym_break_statement] = ACTIONS(13632),
    [sym_continue_statement] = ACTIONS(13632),
    [anon_sym_return] = ACTIONS(13632),
    [anon_sym_const] = ACTIONS(13632),
    [anon_sym_global] = ACTIONS(13632),
    [anon_sym_local] = ACTIONS(13632),
    [anon_sym_LPAREN] = ACTIONS(13632),
    [anon_sym_COLON2] = ACTIONS(13632),
    [anon_sym_export] = ACTIONS(13632),
    [anon_sym_import] = ACTIONS(13632),
    [anon_sym_using] = ACTIONS(13632),
    [anon_sym_LBRACK] = ACTIONS(13632),
    [anon_sym_LF] = ACTIONS(13634),
    [anon_sym_in] = ACTIONS(13632),
    [anon_sym_LBRACE] = ACTIONS(13632),
    [anon_sym_DOLLAR] = ACTIONS(13632),
    [anon_sym_COLON_COLON] = ACTIONS(13632),
    [anon_sym_isa] = ACTIONS(13632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13632),
    [anon_sym_QMARK] = ACTIONS(13632),
    [anon_sym_AT] = ACTIONS(13632),
    [anon_sym_true] = ACTIONS(13632),
    [anon_sym_false] = ACTIONS(13632),
    [aux_sym_integer_literal_token1] = ACTIONS(13632),
    [aux_sym_integer_literal_token2] = ACTIONS(13632),
    [aux_sym_integer_literal_token3] = ACTIONS(13632),
    [aux_sym_integer_literal_token4] = ACTIONS(13632),
    [aux_sym_float_literal_token1] = ACTIONS(13632),
    [aux_sym_float_literal_token3] = ACTIONS(13632),
    [aux_sym_float_literal_token4] = ACTIONS(13632),
    [sym_character_literal] = ACTIONS(13632),
    [sym__pair_operator] = ACTIONS(13632),
    [sym__arrow_operator] = ACTIONS(13632),
    [sym__lazy_or_operator] = ACTIONS(13632),
    [sym__lazy_and_operator] = ACTIONS(13632),
    [sym__comparison_operator] = ACTIONS(13632),
    [sym__pipe_right_operator] = ACTIONS(13632),
    [sym__pipe_left_operator] = ACTIONS(13632),
    [sym__ellipsis_operator] = ACTIONS(13632),
    [sym__plus_operator] = ACTIONS(13632),
    [sym__times_operator] = ACTIONS(13632),
    [sym__rational_operator] = ACTIONS(13632),
    [sym__bitshift_operator] = ACTIONS(13632),
    [sym__power_operator] = ACTIONS(13632),
    [sym__tilde_operator] = ACTIONS(13632),
    [sym__type_order_operator] = ACTIONS(13632),
    [sym__unary_operator] = ACTIONS(13632),
    [sym__unary_plus_operator] = ACTIONS(13632),
    [aux_sym__terminator_token1] = ACTIONS(13632),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13634),
    [sym__command_start] = ACTIONS(13634),
  },
  [8117] = {
    [sym__word_identifier] = ACTIONS(13346),
    [anon_sym_EQ] = ACTIONS(13346),
    [anon_sym_COMMA] = ACTIONS(13346),
    [anon_sym_COLON] = ACTIONS(13346),
    [anon_sym_begin] = ACTIONS(13346),
    [anon_sym_module] = ACTIONS(13346),
    [anon_sym_baremodule] = ACTIONS(13346),
    [anon_sym_end] = ACTIONS(13346),
    [anon_sym_abstract] = ACTIONS(13346),
    [anon_sym_primitive] = ACTIONS(13346),
    [anon_sym_mutable] = ACTIONS(13346),
    [anon_sym_struct] = ACTIONS(13346),
    [anon_sym_function] = ACTIONS(13346),
    [anon_sym_macro] = ACTIONS(13346),
    [anon_sym_where] = ACTIONS(13346),
    [anon_sym_quote] = ACTIONS(13346),
    [anon_sym_let] = ACTIONS(13346),
    [anon_sym_if] = ACTIONS(13346),
    [anon_sym_try] = ACTIONS(13346),
    [anon_sym_finally] = ACTIONS(13346),
    [anon_sym_for] = ACTIONS(13346),
    [anon_sym_while] = ACTIONS(13346),
    [sym_break_statement] = ACTIONS(13346),
    [sym_continue_statement] = ACTIONS(13346),
    [anon_sym_return] = ACTIONS(13346),
    [anon_sym_const] = ACTIONS(13346),
    [anon_sym_global] = ACTIONS(13346),
    [anon_sym_local] = ACTIONS(13346),
    [anon_sym_LPAREN] = ACTIONS(13346),
    [anon_sym_COLON2] = ACTIONS(13346),
    [anon_sym_export] = ACTIONS(13346),
    [anon_sym_import] = ACTIONS(13346),
    [anon_sym_using] = ACTIONS(13346),
    [anon_sym_LBRACK] = ACTIONS(13346),
    [anon_sym_LF] = ACTIONS(13348),
    [anon_sym_in] = ACTIONS(13346),
    [anon_sym_LBRACE] = ACTIONS(13346),
    [anon_sym_DOLLAR] = ACTIONS(13346),
    [anon_sym_COLON_COLON] = ACTIONS(13346),
    [anon_sym_isa] = ACTIONS(13346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13346),
    [anon_sym_QMARK] = ACTIONS(13346),
    [anon_sym_AT] = ACTIONS(13346),
    [anon_sym_true] = ACTIONS(13346),
    [anon_sym_false] = ACTIONS(13346),
    [aux_sym_integer_literal_token1] = ACTIONS(13346),
    [aux_sym_integer_literal_token2] = ACTIONS(13346),
    [aux_sym_integer_literal_token3] = ACTIONS(13346),
    [aux_sym_integer_literal_token4] = ACTIONS(13346),
    [aux_sym_float_literal_token1] = ACTIONS(13346),
    [aux_sym_float_literal_token3] = ACTIONS(13346),
    [aux_sym_float_literal_token4] = ACTIONS(13346),
    [sym_character_literal] = ACTIONS(13346),
    [sym__pair_operator] = ACTIONS(13346),
    [sym__arrow_operator] = ACTIONS(13346),
    [sym__lazy_or_operator] = ACTIONS(13346),
    [sym__lazy_and_operator] = ACTIONS(13346),
    [sym__comparison_operator] = ACTIONS(13346),
    [sym__pipe_right_operator] = ACTIONS(13346),
    [sym__pipe_left_operator] = ACTIONS(13346),
    [sym__ellipsis_operator] = ACTIONS(13346),
    [sym__plus_operator] = ACTIONS(13346),
    [sym__times_operator] = ACTIONS(13346),
    [sym__rational_operator] = ACTIONS(13346),
    [sym__bitshift_operator] = ACTIONS(13346),
    [sym__power_operator] = ACTIONS(13346),
    [sym__tilde_operator] = ACTIONS(13346),
    [sym__type_order_operator] = ACTIONS(13346),
    [sym__unary_operator] = ACTIONS(13346),
    [sym__unary_plus_operator] = ACTIONS(13346),
    [aux_sym__terminator_token1] = ACTIONS(13346),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13348),
    [sym__command_start] = ACTIONS(13348),
  },
  [8118] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [8119] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [8120] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [8121] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [8122] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [8123] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [8124] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [8125] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [8126] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [8127] = {
    [aux_sym_open_tuple_repeat1] = STATE(8180),
    [sym__word_identifier] = ACTIONS(13150),
    [anon_sym_EQ] = ACTIONS(13150),
    [anon_sym_COMMA] = ACTIONS(14541),
    [anon_sym_COLON] = ACTIONS(13150),
    [anon_sym_begin] = ACTIONS(13150),
    [anon_sym_module] = ACTIONS(13150),
    [anon_sym_baremodule] = ACTIONS(13150),
    [anon_sym_abstract] = ACTIONS(13150),
    [anon_sym_primitive] = ACTIONS(13150),
    [anon_sym_mutable] = ACTIONS(13150),
    [anon_sym_struct] = ACTIONS(13150),
    [anon_sym_function] = ACTIONS(13150),
    [anon_sym_macro] = ACTIONS(13150),
    [anon_sym_where] = ACTIONS(13150),
    [anon_sym_quote] = ACTIONS(13150),
    [anon_sym_let] = ACTIONS(13150),
    [anon_sym_if] = ACTIONS(13150),
    [anon_sym_try] = ACTIONS(13150),
    [anon_sym_for] = ACTIONS(13150),
    [anon_sym_while] = ACTIONS(13150),
    [sym_break_statement] = ACTIONS(13150),
    [sym_continue_statement] = ACTIONS(13150),
    [anon_sym_return] = ACTIONS(13150),
    [anon_sym_const] = ACTIONS(13150),
    [anon_sym_global] = ACTIONS(13150),
    [anon_sym_local] = ACTIONS(13150),
    [anon_sym_LPAREN] = ACTIONS(13148),
    [anon_sym_RPAREN] = ACTIONS(13148),
    [anon_sym_COLON2] = ACTIONS(13150),
    [anon_sym_export] = ACTIONS(13150),
    [anon_sym_import] = ACTIONS(13150),
    [anon_sym_using] = ACTIONS(13150),
    [anon_sym_LBRACK] = ACTIONS(13148),
    [anon_sym_RBRACK] = ACTIONS(13148),
    [anon_sym_in] = ACTIONS(13150),
    [anon_sym_LBRACE] = ACTIONS(13148),
    [anon_sym_RBRACE] = ACTIONS(13148),
    [anon_sym_DOLLAR] = ACTIONS(13148),
    [anon_sym_COLON_COLON] = ACTIONS(13148),
    [anon_sym_isa] = ACTIONS(13150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13148),
    [anon_sym_QMARK] = ACTIONS(13148),
    [anon_sym_AT] = ACTIONS(13148),
    [anon_sym_true] = ACTIONS(13150),
    [anon_sym_false] = ACTIONS(13150),
    [aux_sym_integer_literal_token1] = ACTIONS(13148),
    [aux_sym_integer_literal_token2] = ACTIONS(13148),
    [aux_sym_integer_literal_token3] = ACTIONS(13150),
    [aux_sym_integer_literal_token4] = ACTIONS(13150),
    [aux_sym_float_literal_token1] = ACTIONS(13148),
    [aux_sym_float_literal_token3] = ACTIONS(13148),
    [aux_sym_float_literal_token4] = ACTIONS(13148),
    [sym_character_literal] = ACTIONS(13148),
    [sym__pair_operator] = ACTIONS(13148),
    [sym__arrow_operator] = ACTIONS(13150),
    [sym__lazy_or_operator] = ACTIONS(13148),
    [sym__lazy_and_operator] = ACTIONS(13148),
    [sym__comparison_operator] = ACTIONS(13150),
    [sym__pipe_right_operator] = ACTIONS(13148),
    [sym__pipe_left_operator] = ACTIONS(13148),
    [sym__ellipsis_operator] = ACTIONS(13150),
    [sym__plus_operator] = ACTIONS(13150),
    [sym__times_operator] = ACTIONS(13150),
    [sym__rational_operator] = ACTIONS(13148),
    [sym__bitshift_operator] = ACTIONS(13148),
    [sym__power_operator] = ACTIONS(13148),
    [sym__tilde_operator] = ACTIONS(13148),
    [sym__type_order_operator] = ACTIONS(13148),
    [sym__unary_operator] = ACTIONS(13150),
    [sym__unary_plus_operator] = ACTIONS(13150),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13148),
    [sym__command_start] = ACTIONS(13148),
  },
  [8128] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [8129] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [8130] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [8131] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [8132] = {
    [sym__word_identifier] = ACTIONS(13358),
    [anon_sym_EQ] = ACTIONS(13358),
    [anon_sym_COMMA] = ACTIONS(13358),
    [anon_sym_COLON] = ACTIONS(13358),
    [anon_sym_begin] = ACTIONS(13358),
    [anon_sym_module] = ACTIONS(13358),
    [anon_sym_baremodule] = ACTIONS(13358),
    [anon_sym_end] = ACTIONS(13358),
    [anon_sym_abstract] = ACTIONS(13358),
    [anon_sym_primitive] = ACTIONS(13358),
    [anon_sym_mutable] = ACTIONS(13358),
    [anon_sym_struct] = ACTIONS(13358),
    [anon_sym_function] = ACTIONS(13358),
    [anon_sym_macro] = ACTIONS(13358),
    [anon_sym_where] = ACTIONS(13358),
    [anon_sym_quote] = ACTIONS(13358),
    [anon_sym_let] = ACTIONS(13358),
    [anon_sym_if] = ACTIONS(13358),
    [anon_sym_try] = ACTIONS(13358),
    [anon_sym_finally] = ACTIONS(13358),
    [anon_sym_for] = ACTIONS(13358),
    [anon_sym_while] = ACTIONS(13358),
    [sym_break_statement] = ACTIONS(13358),
    [sym_continue_statement] = ACTIONS(13358),
    [anon_sym_return] = ACTIONS(13358),
    [anon_sym_const] = ACTIONS(13358),
    [anon_sym_global] = ACTIONS(13358),
    [anon_sym_local] = ACTIONS(13358),
    [anon_sym_LPAREN] = ACTIONS(13358),
    [anon_sym_COLON2] = ACTIONS(13358),
    [anon_sym_export] = ACTIONS(13358),
    [anon_sym_import] = ACTIONS(13358),
    [anon_sym_using] = ACTIONS(13358),
    [anon_sym_LBRACK] = ACTIONS(13358),
    [anon_sym_LF] = ACTIONS(13360),
    [anon_sym_in] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(13358),
    [anon_sym_DOLLAR] = ACTIONS(13358),
    [anon_sym_COLON_COLON] = ACTIONS(13358),
    [anon_sym_isa] = ACTIONS(13358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13358),
    [anon_sym_QMARK] = ACTIONS(13358),
    [anon_sym_AT] = ACTIONS(13358),
    [anon_sym_true] = ACTIONS(13358),
    [anon_sym_false] = ACTIONS(13358),
    [aux_sym_integer_literal_token1] = ACTIONS(13358),
    [aux_sym_integer_literal_token2] = ACTIONS(13358),
    [aux_sym_integer_literal_token3] = ACTIONS(13358),
    [aux_sym_integer_literal_token4] = ACTIONS(13358),
    [aux_sym_float_literal_token1] = ACTIONS(13358),
    [aux_sym_float_literal_token3] = ACTIONS(13358),
    [aux_sym_float_literal_token4] = ACTIONS(13358),
    [sym_character_literal] = ACTIONS(13358),
    [sym__pair_operator] = ACTIONS(13358),
    [sym__arrow_operator] = ACTIONS(13358),
    [sym__lazy_or_operator] = ACTIONS(13358),
    [sym__lazy_and_operator] = ACTIONS(13358),
    [sym__comparison_operator] = ACTIONS(13358),
    [sym__pipe_right_operator] = ACTIONS(13358),
    [sym__pipe_left_operator] = ACTIONS(13358),
    [sym__ellipsis_operator] = ACTIONS(13358),
    [sym__plus_operator] = ACTIONS(13358),
    [sym__times_operator] = ACTIONS(13358),
    [sym__rational_operator] = ACTIONS(13358),
    [sym__bitshift_operator] = ACTIONS(13358),
    [sym__power_operator] = ACTIONS(13358),
    [sym__tilde_operator] = ACTIONS(13358),
    [sym__type_order_operator] = ACTIONS(13358),
    [sym__unary_operator] = ACTIONS(13358),
    [sym__unary_plus_operator] = ACTIONS(13358),
    [aux_sym__terminator_token1] = ACTIONS(13358),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13360),
    [sym__command_start] = ACTIONS(13360),
  },
  [8133] = {
    [sym__word_identifier] = ACTIONS(13636),
    [anon_sym_EQ] = ACTIONS(13636),
    [anon_sym_COMMA] = ACTIONS(13636),
    [anon_sym_COLON] = ACTIONS(13636),
    [anon_sym_begin] = ACTIONS(13636),
    [anon_sym_module] = ACTIONS(13636),
    [anon_sym_baremodule] = ACTIONS(13636),
    [anon_sym_abstract] = ACTIONS(13636),
    [anon_sym_primitive] = ACTIONS(13636),
    [anon_sym_mutable] = ACTIONS(13636),
    [anon_sym_struct] = ACTIONS(13636),
    [anon_sym_function] = ACTIONS(13636),
    [anon_sym_macro] = ACTIONS(13636),
    [anon_sym_where] = ACTIONS(13636),
    [anon_sym_quote] = ACTIONS(13636),
    [anon_sym_let] = ACTIONS(13636),
    [anon_sym_if] = ACTIONS(13636),
    [anon_sym_try] = ACTIONS(13636),
    [anon_sym_catch] = ACTIONS(13636),
    [anon_sym_finally] = ACTIONS(13636),
    [anon_sym_for] = ACTIONS(13636),
    [anon_sym_while] = ACTIONS(13636),
    [sym_break_statement] = ACTIONS(13636),
    [sym_continue_statement] = ACTIONS(13636),
    [anon_sym_return] = ACTIONS(13636),
    [anon_sym_const] = ACTIONS(13636),
    [anon_sym_global] = ACTIONS(13636),
    [anon_sym_local] = ACTIONS(13636),
    [anon_sym_LPAREN] = ACTIONS(13636),
    [anon_sym_COLON2] = ACTIONS(13636),
    [anon_sym_export] = ACTIONS(13636),
    [anon_sym_import] = ACTIONS(13636),
    [anon_sym_using] = ACTIONS(13636),
    [anon_sym_LBRACK] = ACTIONS(13636),
    [anon_sym_LF] = ACTIONS(13638),
    [anon_sym_in] = ACTIONS(13636),
    [anon_sym_LBRACE] = ACTIONS(13636),
    [anon_sym_DOLLAR] = ACTIONS(13636),
    [anon_sym_COLON_COLON] = ACTIONS(13636),
    [anon_sym_isa] = ACTIONS(13636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13636),
    [anon_sym_QMARK] = ACTIONS(13636),
    [anon_sym_AT] = ACTIONS(13636),
    [anon_sym_true] = ACTIONS(13636),
    [anon_sym_false] = ACTIONS(13636),
    [aux_sym_integer_literal_token1] = ACTIONS(13636),
    [aux_sym_integer_literal_token2] = ACTIONS(13636),
    [aux_sym_integer_literal_token3] = ACTIONS(13636),
    [aux_sym_integer_literal_token4] = ACTIONS(13636),
    [aux_sym_float_literal_token1] = ACTIONS(13636),
    [aux_sym_float_literal_token3] = ACTIONS(13636),
    [aux_sym_float_literal_token4] = ACTIONS(13636),
    [sym_character_literal] = ACTIONS(13636),
    [sym__pair_operator] = ACTIONS(13636),
    [sym__arrow_operator] = ACTIONS(13636),
    [sym__lazy_or_operator] = ACTIONS(13636),
    [sym__lazy_and_operator] = ACTIONS(13636),
    [sym__comparison_operator] = ACTIONS(13636),
    [sym__pipe_right_operator] = ACTIONS(13636),
    [sym__pipe_left_operator] = ACTIONS(13636),
    [sym__ellipsis_operator] = ACTIONS(13636),
    [sym__plus_operator] = ACTIONS(13636),
    [sym__times_operator] = ACTIONS(13636),
    [sym__rational_operator] = ACTIONS(13636),
    [sym__bitshift_operator] = ACTIONS(13636),
    [sym__power_operator] = ACTIONS(13636),
    [sym__tilde_operator] = ACTIONS(13636),
    [sym__type_order_operator] = ACTIONS(13636),
    [sym__unary_operator] = ACTIONS(13636),
    [sym__unary_plus_operator] = ACTIONS(13636),
    [aux_sym__terminator_token1] = ACTIONS(13636),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13638),
    [sym__command_start] = ACTIONS(13638),
  },
  [8134] = {
    [sym__word_identifier] = ACTIONS(13640),
    [anon_sym_EQ] = ACTIONS(13640),
    [anon_sym_COMMA] = ACTIONS(13640),
    [anon_sym_COLON] = ACTIONS(13640),
    [anon_sym_begin] = ACTIONS(13640),
    [anon_sym_module] = ACTIONS(13640),
    [anon_sym_baremodule] = ACTIONS(13640),
    [anon_sym_abstract] = ACTIONS(13640),
    [anon_sym_primitive] = ACTIONS(13640),
    [anon_sym_mutable] = ACTIONS(13640),
    [anon_sym_struct] = ACTIONS(13640),
    [anon_sym_function] = ACTIONS(13640),
    [anon_sym_macro] = ACTIONS(13640),
    [anon_sym_where] = ACTIONS(13640),
    [anon_sym_quote] = ACTIONS(13640),
    [anon_sym_let] = ACTIONS(13640),
    [anon_sym_if] = ACTIONS(13640),
    [anon_sym_try] = ACTIONS(13640),
    [anon_sym_catch] = ACTIONS(13640),
    [anon_sym_finally] = ACTIONS(13640),
    [anon_sym_for] = ACTIONS(13640),
    [anon_sym_while] = ACTIONS(13640),
    [sym_break_statement] = ACTIONS(13640),
    [sym_continue_statement] = ACTIONS(13640),
    [anon_sym_return] = ACTIONS(13640),
    [anon_sym_const] = ACTIONS(13640),
    [anon_sym_global] = ACTIONS(13640),
    [anon_sym_local] = ACTIONS(13640),
    [anon_sym_LPAREN] = ACTIONS(13640),
    [anon_sym_COLON2] = ACTIONS(13640),
    [anon_sym_export] = ACTIONS(13640),
    [anon_sym_import] = ACTIONS(13640),
    [anon_sym_using] = ACTIONS(13640),
    [anon_sym_LBRACK] = ACTIONS(13640),
    [anon_sym_LF] = ACTIONS(13642),
    [anon_sym_in] = ACTIONS(13640),
    [anon_sym_LBRACE] = ACTIONS(13640),
    [anon_sym_DOLLAR] = ACTIONS(13640),
    [anon_sym_COLON_COLON] = ACTIONS(13640),
    [anon_sym_isa] = ACTIONS(13640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13640),
    [anon_sym_QMARK] = ACTIONS(13640),
    [anon_sym_AT] = ACTIONS(13640),
    [anon_sym_true] = ACTIONS(13640),
    [anon_sym_false] = ACTIONS(13640),
    [aux_sym_integer_literal_token1] = ACTIONS(13640),
    [aux_sym_integer_literal_token2] = ACTIONS(13640),
    [aux_sym_integer_literal_token3] = ACTIONS(13640),
    [aux_sym_integer_literal_token4] = ACTIONS(13640),
    [aux_sym_float_literal_token1] = ACTIONS(13640),
    [aux_sym_float_literal_token3] = ACTIONS(13640),
    [aux_sym_float_literal_token4] = ACTIONS(13640),
    [sym_character_literal] = ACTIONS(13640),
    [sym__pair_operator] = ACTIONS(13640),
    [sym__arrow_operator] = ACTIONS(13640),
    [sym__lazy_or_operator] = ACTIONS(13640),
    [sym__lazy_and_operator] = ACTIONS(13640),
    [sym__comparison_operator] = ACTIONS(13640),
    [sym__pipe_right_operator] = ACTIONS(13640),
    [sym__pipe_left_operator] = ACTIONS(13640),
    [sym__ellipsis_operator] = ACTIONS(13640),
    [sym__plus_operator] = ACTIONS(13640),
    [sym__times_operator] = ACTIONS(13640),
    [sym__rational_operator] = ACTIONS(13640),
    [sym__bitshift_operator] = ACTIONS(13640),
    [sym__power_operator] = ACTIONS(13640),
    [sym__tilde_operator] = ACTIONS(13640),
    [sym__type_order_operator] = ACTIONS(13640),
    [sym__unary_operator] = ACTIONS(13640),
    [sym__unary_plus_operator] = ACTIONS(13640),
    [aux_sym__terminator_token1] = ACTIONS(13640),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13642),
    [sym__command_start] = ACTIONS(13642),
  },
  [8135] = {
    [sym__word_identifier] = ACTIONS(13644),
    [anon_sym_EQ] = ACTIONS(13644),
    [anon_sym_COMMA] = ACTIONS(13644),
    [anon_sym_COLON] = ACTIONS(13644),
    [anon_sym_begin] = ACTIONS(13644),
    [anon_sym_module] = ACTIONS(13644),
    [anon_sym_baremodule] = ACTIONS(13644),
    [anon_sym_abstract] = ACTIONS(13644),
    [anon_sym_primitive] = ACTIONS(13644),
    [anon_sym_mutable] = ACTIONS(13644),
    [anon_sym_struct] = ACTIONS(13644),
    [anon_sym_function] = ACTIONS(13644),
    [anon_sym_macro] = ACTIONS(13644),
    [anon_sym_where] = ACTIONS(13644),
    [anon_sym_quote] = ACTIONS(13644),
    [anon_sym_let] = ACTIONS(13644),
    [anon_sym_if] = ACTIONS(13644),
    [anon_sym_try] = ACTIONS(13644),
    [anon_sym_catch] = ACTIONS(13644),
    [anon_sym_finally] = ACTIONS(13644),
    [anon_sym_for] = ACTIONS(13644),
    [anon_sym_while] = ACTIONS(13644),
    [sym_break_statement] = ACTIONS(13644),
    [sym_continue_statement] = ACTIONS(13644),
    [anon_sym_return] = ACTIONS(13644),
    [anon_sym_const] = ACTIONS(13644),
    [anon_sym_global] = ACTIONS(13644),
    [anon_sym_local] = ACTIONS(13644),
    [anon_sym_LPAREN] = ACTIONS(13644),
    [anon_sym_COLON2] = ACTIONS(13644),
    [anon_sym_export] = ACTIONS(13644),
    [anon_sym_import] = ACTIONS(13644),
    [anon_sym_using] = ACTIONS(13644),
    [anon_sym_LBRACK] = ACTIONS(13644),
    [anon_sym_LF] = ACTIONS(13646),
    [anon_sym_in] = ACTIONS(13644),
    [anon_sym_LBRACE] = ACTIONS(13644),
    [anon_sym_DOLLAR] = ACTIONS(13644),
    [anon_sym_COLON_COLON] = ACTIONS(13644),
    [anon_sym_isa] = ACTIONS(13644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13644),
    [anon_sym_QMARK] = ACTIONS(13644),
    [anon_sym_AT] = ACTIONS(13644),
    [anon_sym_true] = ACTIONS(13644),
    [anon_sym_false] = ACTIONS(13644),
    [aux_sym_integer_literal_token1] = ACTIONS(13644),
    [aux_sym_integer_literal_token2] = ACTIONS(13644),
    [aux_sym_integer_literal_token3] = ACTIONS(13644),
    [aux_sym_integer_literal_token4] = ACTIONS(13644),
    [aux_sym_float_literal_token1] = ACTIONS(13644),
    [aux_sym_float_literal_token3] = ACTIONS(13644),
    [aux_sym_float_literal_token4] = ACTIONS(13644),
    [sym_character_literal] = ACTIONS(13644),
    [sym__pair_operator] = ACTIONS(13644),
    [sym__arrow_operator] = ACTIONS(13644),
    [sym__lazy_or_operator] = ACTIONS(13644),
    [sym__lazy_and_operator] = ACTIONS(13644),
    [sym__comparison_operator] = ACTIONS(13644),
    [sym__pipe_right_operator] = ACTIONS(13644),
    [sym__pipe_left_operator] = ACTIONS(13644),
    [sym__ellipsis_operator] = ACTIONS(13644),
    [sym__plus_operator] = ACTIONS(13644),
    [sym__times_operator] = ACTIONS(13644),
    [sym__rational_operator] = ACTIONS(13644),
    [sym__bitshift_operator] = ACTIONS(13644),
    [sym__power_operator] = ACTIONS(13644),
    [sym__tilde_operator] = ACTIONS(13644),
    [sym__type_order_operator] = ACTIONS(13644),
    [sym__unary_operator] = ACTIONS(13644),
    [sym__unary_plus_operator] = ACTIONS(13644),
    [aux_sym__terminator_token1] = ACTIONS(13644),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13646),
    [sym__command_start] = ACTIONS(13646),
  },
  [8136] = {
    [sym__word_identifier] = ACTIONS(13362),
    [anon_sym_EQ] = ACTIONS(13362),
    [anon_sym_COMMA] = ACTIONS(13362),
    [anon_sym_COLON] = ACTIONS(13362),
    [anon_sym_begin] = ACTIONS(13362),
    [anon_sym_module] = ACTIONS(13362),
    [anon_sym_baremodule] = ACTIONS(13362),
    [anon_sym_end] = ACTIONS(13362),
    [anon_sym_abstract] = ACTIONS(13362),
    [anon_sym_primitive] = ACTIONS(13362),
    [anon_sym_mutable] = ACTIONS(13362),
    [anon_sym_struct] = ACTIONS(13362),
    [anon_sym_function] = ACTIONS(13362),
    [anon_sym_macro] = ACTIONS(13362),
    [anon_sym_where] = ACTIONS(13362),
    [anon_sym_quote] = ACTIONS(13362),
    [anon_sym_let] = ACTIONS(13362),
    [anon_sym_if] = ACTIONS(13362),
    [anon_sym_try] = ACTIONS(13362),
    [anon_sym_finally] = ACTIONS(13362),
    [anon_sym_for] = ACTIONS(13362),
    [anon_sym_while] = ACTIONS(13362),
    [sym_break_statement] = ACTIONS(13362),
    [sym_continue_statement] = ACTIONS(13362),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_const] = ACTIONS(13362),
    [anon_sym_global] = ACTIONS(13362),
    [anon_sym_local] = ACTIONS(13362),
    [anon_sym_LPAREN] = ACTIONS(13362),
    [anon_sym_COLON2] = ACTIONS(13362),
    [anon_sym_export] = ACTIONS(13362),
    [anon_sym_import] = ACTIONS(13362),
    [anon_sym_using] = ACTIONS(13362),
    [anon_sym_LBRACK] = ACTIONS(13362),
    [anon_sym_LF] = ACTIONS(13364),
    [anon_sym_in] = ACTIONS(13362),
    [anon_sym_LBRACE] = ACTIONS(13362),
    [anon_sym_DOLLAR] = ACTIONS(13362),
    [anon_sym_COLON_COLON] = ACTIONS(13362),
    [anon_sym_isa] = ACTIONS(13362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13362),
    [anon_sym_QMARK] = ACTIONS(13362),
    [anon_sym_AT] = ACTIONS(13362),
    [anon_sym_true] = ACTIONS(13362),
    [anon_sym_false] = ACTIONS(13362),
    [aux_sym_integer_literal_token1] = ACTIONS(13362),
    [aux_sym_integer_literal_token2] = ACTIONS(13362),
    [aux_sym_integer_literal_token3] = ACTIONS(13362),
    [aux_sym_integer_literal_token4] = ACTIONS(13362),
    [aux_sym_float_literal_token1] = ACTIONS(13362),
    [aux_sym_float_literal_token3] = ACTIONS(13362),
    [aux_sym_float_literal_token4] = ACTIONS(13362),
    [sym_character_literal] = ACTIONS(13362),
    [sym__pair_operator] = ACTIONS(13362),
    [sym__arrow_operator] = ACTIONS(13362),
    [sym__lazy_or_operator] = ACTIONS(13362),
    [sym__lazy_and_operator] = ACTIONS(13362),
    [sym__comparison_operator] = ACTIONS(13362),
    [sym__pipe_right_operator] = ACTIONS(13362),
    [sym__pipe_left_operator] = ACTIONS(13362),
    [sym__ellipsis_operator] = ACTIONS(13362),
    [sym__plus_operator] = ACTIONS(13362),
    [sym__times_operator] = ACTIONS(13362),
    [sym__rational_operator] = ACTIONS(13362),
    [sym__bitshift_operator] = ACTIONS(13362),
    [sym__power_operator] = ACTIONS(13362),
    [sym__tilde_operator] = ACTIONS(13362),
    [sym__type_order_operator] = ACTIONS(13362),
    [sym__unary_operator] = ACTIONS(13362),
    [sym__unary_plus_operator] = ACTIONS(13362),
    [aux_sym__terminator_token1] = ACTIONS(13362),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13364),
    [sym__command_start] = ACTIONS(13364),
  },
  [8137] = {
    [sym__word_identifier] = ACTIONS(13648),
    [anon_sym_EQ] = ACTIONS(13648),
    [anon_sym_COMMA] = ACTIONS(13648),
    [anon_sym_COLON] = ACTIONS(13648),
    [anon_sym_begin] = ACTIONS(13648),
    [anon_sym_module] = ACTIONS(13648),
    [anon_sym_baremodule] = ACTIONS(13648),
    [anon_sym_abstract] = ACTIONS(13648),
    [anon_sym_primitive] = ACTIONS(13648),
    [anon_sym_mutable] = ACTIONS(13648),
    [anon_sym_struct] = ACTIONS(13648),
    [anon_sym_function] = ACTIONS(13648),
    [anon_sym_macro] = ACTIONS(13648),
    [anon_sym_where] = ACTIONS(13648),
    [anon_sym_quote] = ACTIONS(13648),
    [anon_sym_let] = ACTIONS(13648),
    [anon_sym_if] = ACTIONS(13648),
    [anon_sym_try] = ACTIONS(13648),
    [anon_sym_catch] = ACTIONS(13648),
    [anon_sym_finally] = ACTIONS(13648),
    [anon_sym_for] = ACTIONS(13648),
    [anon_sym_while] = ACTIONS(13648),
    [sym_break_statement] = ACTIONS(13648),
    [sym_continue_statement] = ACTIONS(13648),
    [anon_sym_return] = ACTIONS(13648),
    [anon_sym_const] = ACTIONS(13648),
    [anon_sym_global] = ACTIONS(13648),
    [anon_sym_local] = ACTIONS(13648),
    [anon_sym_LPAREN] = ACTIONS(13648),
    [anon_sym_COLON2] = ACTIONS(13648),
    [anon_sym_export] = ACTIONS(13648),
    [anon_sym_import] = ACTIONS(13648),
    [anon_sym_using] = ACTIONS(13648),
    [anon_sym_LBRACK] = ACTIONS(13648),
    [anon_sym_LF] = ACTIONS(13650),
    [anon_sym_in] = ACTIONS(13648),
    [anon_sym_LBRACE] = ACTIONS(13648),
    [anon_sym_DOLLAR] = ACTIONS(13648),
    [anon_sym_COLON_COLON] = ACTIONS(13648),
    [anon_sym_isa] = ACTIONS(13648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13648),
    [anon_sym_QMARK] = ACTIONS(13648),
    [anon_sym_AT] = ACTIONS(13648),
    [anon_sym_true] = ACTIONS(13648),
    [anon_sym_false] = ACTIONS(13648),
    [aux_sym_integer_literal_token1] = ACTIONS(13648),
    [aux_sym_integer_literal_token2] = ACTIONS(13648),
    [aux_sym_integer_literal_token3] = ACTIONS(13648),
    [aux_sym_integer_literal_token4] = ACTIONS(13648),
    [aux_sym_float_literal_token1] = ACTIONS(13648),
    [aux_sym_float_literal_token3] = ACTIONS(13648),
    [aux_sym_float_literal_token4] = ACTIONS(13648),
    [sym_character_literal] = ACTIONS(13648),
    [sym__pair_operator] = ACTIONS(13648),
    [sym__arrow_operator] = ACTIONS(13648),
    [sym__lazy_or_operator] = ACTIONS(13648),
    [sym__lazy_and_operator] = ACTIONS(13648),
    [sym__comparison_operator] = ACTIONS(13648),
    [sym__pipe_right_operator] = ACTIONS(13648),
    [sym__pipe_left_operator] = ACTIONS(13648),
    [sym__ellipsis_operator] = ACTIONS(13648),
    [sym__plus_operator] = ACTIONS(13648),
    [sym__times_operator] = ACTIONS(13648),
    [sym__rational_operator] = ACTIONS(13648),
    [sym__bitshift_operator] = ACTIONS(13648),
    [sym__power_operator] = ACTIONS(13648),
    [sym__tilde_operator] = ACTIONS(13648),
    [sym__type_order_operator] = ACTIONS(13648),
    [sym__unary_operator] = ACTIONS(13648),
    [sym__unary_plus_operator] = ACTIONS(13648),
    [aux_sym__terminator_token1] = ACTIONS(13648),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13650),
    [sym__command_start] = ACTIONS(13650),
  },
  [8138] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [8139] = {
    [sym__word_identifier] = ACTIONS(13366),
    [anon_sym_EQ] = ACTIONS(13366),
    [anon_sym_COMMA] = ACTIONS(13366),
    [anon_sym_COLON] = ACTIONS(13366),
    [anon_sym_begin] = ACTIONS(13366),
    [anon_sym_module] = ACTIONS(13366),
    [anon_sym_baremodule] = ACTIONS(13366),
    [anon_sym_end] = ACTIONS(13366),
    [anon_sym_abstract] = ACTIONS(13366),
    [anon_sym_primitive] = ACTIONS(13366),
    [anon_sym_mutable] = ACTIONS(13366),
    [anon_sym_struct] = ACTIONS(13366),
    [anon_sym_function] = ACTIONS(13366),
    [anon_sym_macro] = ACTIONS(13366),
    [anon_sym_where] = ACTIONS(13366),
    [anon_sym_quote] = ACTIONS(13366),
    [anon_sym_let] = ACTIONS(13366),
    [anon_sym_if] = ACTIONS(13366),
    [anon_sym_try] = ACTIONS(13366),
    [anon_sym_finally] = ACTIONS(13366),
    [anon_sym_for] = ACTIONS(13366),
    [anon_sym_while] = ACTIONS(13366),
    [sym_break_statement] = ACTIONS(13366),
    [sym_continue_statement] = ACTIONS(13366),
    [anon_sym_return] = ACTIONS(13366),
    [anon_sym_const] = ACTIONS(13366),
    [anon_sym_global] = ACTIONS(13366),
    [anon_sym_local] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(13366),
    [anon_sym_COLON2] = ACTIONS(13366),
    [anon_sym_export] = ACTIONS(13366),
    [anon_sym_import] = ACTIONS(13366),
    [anon_sym_using] = ACTIONS(13366),
    [anon_sym_LBRACK] = ACTIONS(13366),
    [anon_sym_LF] = ACTIONS(13368),
    [anon_sym_in] = ACTIONS(13366),
    [anon_sym_LBRACE] = ACTIONS(13366),
    [anon_sym_DOLLAR] = ACTIONS(13366),
    [anon_sym_COLON_COLON] = ACTIONS(13366),
    [anon_sym_isa] = ACTIONS(13366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13366),
    [anon_sym_QMARK] = ACTIONS(13366),
    [anon_sym_AT] = ACTIONS(13366),
    [anon_sym_true] = ACTIONS(13366),
    [anon_sym_false] = ACTIONS(13366),
    [aux_sym_integer_literal_token1] = ACTIONS(13366),
    [aux_sym_integer_literal_token2] = ACTIONS(13366),
    [aux_sym_integer_literal_token3] = ACTIONS(13366),
    [aux_sym_integer_literal_token4] = ACTIONS(13366),
    [aux_sym_float_literal_token1] = ACTIONS(13366),
    [aux_sym_float_literal_token3] = ACTIONS(13366),
    [aux_sym_float_literal_token4] = ACTIONS(13366),
    [sym_character_literal] = ACTIONS(13366),
    [sym__pair_operator] = ACTIONS(13366),
    [sym__arrow_operator] = ACTIONS(13366),
    [sym__lazy_or_operator] = ACTIONS(13366),
    [sym__lazy_and_operator] = ACTIONS(13366),
    [sym__comparison_operator] = ACTIONS(13366),
    [sym__pipe_right_operator] = ACTIONS(13366),
    [sym__pipe_left_operator] = ACTIONS(13366),
    [sym__ellipsis_operator] = ACTIONS(13366),
    [sym__plus_operator] = ACTIONS(13366),
    [sym__times_operator] = ACTIONS(13366),
    [sym__rational_operator] = ACTIONS(13366),
    [sym__bitshift_operator] = ACTIONS(13366),
    [sym__power_operator] = ACTIONS(13366),
    [sym__tilde_operator] = ACTIONS(13366),
    [sym__type_order_operator] = ACTIONS(13366),
    [sym__unary_operator] = ACTIONS(13366),
    [sym__unary_plus_operator] = ACTIONS(13366),
    [aux_sym__terminator_token1] = ACTIONS(13366),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13368),
    [sym__command_start] = ACTIONS(13368),
  },
  [8140] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8141] = {
    [sym__word_identifier] = ACTIONS(13370),
    [anon_sym_EQ] = ACTIONS(13370),
    [anon_sym_COMMA] = ACTIONS(13370),
    [anon_sym_COLON] = ACTIONS(13370),
    [anon_sym_begin] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(13370),
    [anon_sym_baremodule] = ACTIONS(13370),
    [anon_sym_end] = ACTIONS(13370),
    [anon_sym_abstract] = ACTIONS(13370),
    [anon_sym_primitive] = ACTIONS(13370),
    [anon_sym_mutable] = ACTIONS(13370),
    [anon_sym_struct] = ACTIONS(13370),
    [anon_sym_function] = ACTIONS(13370),
    [anon_sym_macro] = ACTIONS(13370),
    [anon_sym_where] = ACTIONS(13370),
    [anon_sym_quote] = ACTIONS(13370),
    [anon_sym_let] = ACTIONS(13370),
    [anon_sym_if] = ACTIONS(13370),
    [anon_sym_try] = ACTIONS(13370),
    [anon_sym_finally] = ACTIONS(13370),
    [anon_sym_for] = ACTIONS(13370),
    [anon_sym_while] = ACTIONS(13370),
    [sym_break_statement] = ACTIONS(13370),
    [sym_continue_statement] = ACTIONS(13370),
    [anon_sym_return] = ACTIONS(13370),
    [anon_sym_const] = ACTIONS(13370),
    [anon_sym_global] = ACTIONS(13370),
    [anon_sym_local] = ACTIONS(13370),
    [anon_sym_LPAREN] = ACTIONS(13370),
    [anon_sym_COLON2] = ACTIONS(13370),
    [anon_sym_export] = ACTIONS(13370),
    [anon_sym_import] = ACTIONS(13370),
    [anon_sym_using] = ACTIONS(13370),
    [anon_sym_LBRACK] = ACTIONS(13370),
    [anon_sym_LF] = ACTIONS(13372),
    [anon_sym_in] = ACTIONS(13370),
    [anon_sym_LBRACE] = ACTIONS(13370),
    [anon_sym_DOLLAR] = ACTIONS(13370),
    [anon_sym_COLON_COLON] = ACTIONS(13370),
    [anon_sym_isa] = ACTIONS(13370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13370),
    [anon_sym_QMARK] = ACTIONS(13370),
    [anon_sym_AT] = ACTIONS(13370),
    [anon_sym_true] = ACTIONS(13370),
    [anon_sym_false] = ACTIONS(13370),
    [aux_sym_integer_literal_token1] = ACTIONS(13370),
    [aux_sym_integer_literal_token2] = ACTIONS(13370),
    [aux_sym_integer_literal_token3] = ACTIONS(13370),
    [aux_sym_integer_literal_token4] = ACTIONS(13370),
    [aux_sym_float_literal_token1] = ACTIONS(13370),
    [aux_sym_float_literal_token3] = ACTIONS(13370),
    [aux_sym_float_literal_token4] = ACTIONS(13370),
    [sym_character_literal] = ACTIONS(13370),
    [sym__pair_operator] = ACTIONS(13370),
    [sym__arrow_operator] = ACTIONS(13370),
    [sym__lazy_or_operator] = ACTIONS(13370),
    [sym__lazy_and_operator] = ACTIONS(13370),
    [sym__comparison_operator] = ACTIONS(13370),
    [sym__pipe_right_operator] = ACTIONS(13370),
    [sym__pipe_left_operator] = ACTIONS(13370),
    [sym__ellipsis_operator] = ACTIONS(13370),
    [sym__plus_operator] = ACTIONS(13370),
    [sym__times_operator] = ACTIONS(13370),
    [sym__rational_operator] = ACTIONS(13370),
    [sym__bitshift_operator] = ACTIONS(13370),
    [sym__power_operator] = ACTIONS(13370),
    [sym__tilde_operator] = ACTIONS(13370),
    [sym__type_order_operator] = ACTIONS(13370),
    [sym__unary_operator] = ACTIONS(13370),
    [sym__unary_plus_operator] = ACTIONS(13370),
    [aux_sym__terminator_token1] = ACTIONS(13370),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13372),
    [sym__command_start] = ACTIONS(13372),
  },
  [8142] = {
    [sym__word_identifier] = ACTIONS(13374),
    [anon_sym_EQ] = ACTIONS(13374),
    [anon_sym_COMMA] = ACTIONS(13374),
    [anon_sym_COLON] = ACTIONS(13374),
    [anon_sym_begin] = ACTIONS(13374),
    [anon_sym_module] = ACTIONS(13374),
    [anon_sym_baremodule] = ACTIONS(13374),
    [anon_sym_end] = ACTIONS(13374),
    [anon_sym_abstract] = ACTIONS(13374),
    [anon_sym_primitive] = ACTIONS(13374),
    [anon_sym_mutable] = ACTIONS(13374),
    [anon_sym_struct] = ACTIONS(13374),
    [anon_sym_function] = ACTIONS(13374),
    [anon_sym_macro] = ACTIONS(13374),
    [anon_sym_where] = ACTIONS(13374),
    [anon_sym_quote] = ACTIONS(13374),
    [anon_sym_let] = ACTIONS(13374),
    [anon_sym_if] = ACTIONS(13374),
    [anon_sym_try] = ACTIONS(13374),
    [anon_sym_finally] = ACTIONS(13374),
    [anon_sym_for] = ACTIONS(13374),
    [anon_sym_while] = ACTIONS(13374),
    [sym_break_statement] = ACTIONS(13374),
    [sym_continue_statement] = ACTIONS(13374),
    [anon_sym_return] = ACTIONS(13374),
    [anon_sym_const] = ACTIONS(13374),
    [anon_sym_global] = ACTIONS(13374),
    [anon_sym_local] = ACTIONS(13374),
    [anon_sym_LPAREN] = ACTIONS(13374),
    [anon_sym_COLON2] = ACTIONS(13374),
    [anon_sym_export] = ACTIONS(13374),
    [anon_sym_import] = ACTIONS(13374),
    [anon_sym_using] = ACTIONS(13374),
    [anon_sym_LBRACK] = ACTIONS(13374),
    [anon_sym_LF] = ACTIONS(13376),
    [anon_sym_in] = ACTIONS(13374),
    [anon_sym_LBRACE] = ACTIONS(13374),
    [anon_sym_DOLLAR] = ACTIONS(13374),
    [anon_sym_COLON_COLON] = ACTIONS(13374),
    [anon_sym_isa] = ACTIONS(13374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13374),
    [anon_sym_QMARK] = ACTIONS(13374),
    [anon_sym_AT] = ACTIONS(13374),
    [anon_sym_true] = ACTIONS(13374),
    [anon_sym_false] = ACTIONS(13374),
    [aux_sym_integer_literal_token1] = ACTIONS(13374),
    [aux_sym_integer_literal_token2] = ACTIONS(13374),
    [aux_sym_integer_literal_token3] = ACTIONS(13374),
    [aux_sym_integer_literal_token4] = ACTIONS(13374),
    [aux_sym_float_literal_token1] = ACTIONS(13374),
    [aux_sym_float_literal_token3] = ACTIONS(13374),
    [aux_sym_float_literal_token4] = ACTIONS(13374),
    [sym_character_literal] = ACTIONS(13374),
    [sym__pair_operator] = ACTIONS(13374),
    [sym__arrow_operator] = ACTIONS(13374),
    [sym__lazy_or_operator] = ACTIONS(13374),
    [sym__lazy_and_operator] = ACTIONS(13374),
    [sym__comparison_operator] = ACTIONS(13374),
    [sym__pipe_right_operator] = ACTIONS(13374),
    [sym__pipe_left_operator] = ACTIONS(13374),
    [sym__ellipsis_operator] = ACTIONS(13374),
    [sym__plus_operator] = ACTIONS(13374),
    [sym__times_operator] = ACTIONS(13374),
    [sym__rational_operator] = ACTIONS(13374),
    [sym__bitshift_operator] = ACTIONS(13374),
    [sym__power_operator] = ACTIONS(13374),
    [sym__tilde_operator] = ACTIONS(13374),
    [sym__type_order_operator] = ACTIONS(13374),
    [sym__unary_operator] = ACTIONS(13374),
    [sym__unary_plus_operator] = ACTIONS(13374),
    [aux_sym__terminator_token1] = ACTIONS(13374),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13376),
    [sym__command_start] = ACTIONS(13376),
  },
  [8143] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8144] = {
    [sym__word_identifier] = ACTIONS(13652),
    [anon_sym_EQ] = ACTIONS(13652),
    [anon_sym_COMMA] = ACTIONS(13652),
    [anon_sym_COLON] = ACTIONS(13652),
    [anon_sym_begin] = ACTIONS(13652),
    [anon_sym_module] = ACTIONS(13652),
    [anon_sym_baremodule] = ACTIONS(13652),
    [anon_sym_abstract] = ACTIONS(13652),
    [anon_sym_primitive] = ACTIONS(13652),
    [anon_sym_mutable] = ACTIONS(13652),
    [anon_sym_struct] = ACTIONS(13652),
    [anon_sym_function] = ACTIONS(13652),
    [anon_sym_macro] = ACTIONS(13652),
    [anon_sym_where] = ACTIONS(13652),
    [anon_sym_quote] = ACTIONS(13652),
    [anon_sym_let] = ACTIONS(13652),
    [anon_sym_if] = ACTIONS(13652),
    [anon_sym_try] = ACTIONS(13652),
    [anon_sym_catch] = ACTIONS(13652),
    [anon_sym_finally] = ACTIONS(13652),
    [anon_sym_for] = ACTIONS(13652),
    [anon_sym_while] = ACTIONS(13652),
    [sym_break_statement] = ACTIONS(13652),
    [sym_continue_statement] = ACTIONS(13652),
    [anon_sym_return] = ACTIONS(13652),
    [anon_sym_const] = ACTIONS(13652),
    [anon_sym_global] = ACTIONS(13652),
    [anon_sym_local] = ACTIONS(13652),
    [anon_sym_LPAREN] = ACTIONS(13652),
    [anon_sym_COLON2] = ACTIONS(13652),
    [anon_sym_export] = ACTIONS(13652),
    [anon_sym_import] = ACTIONS(13652),
    [anon_sym_using] = ACTIONS(13652),
    [anon_sym_LBRACK] = ACTIONS(13652),
    [anon_sym_LF] = ACTIONS(13654),
    [anon_sym_in] = ACTIONS(13652),
    [anon_sym_LBRACE] = ACTIONS(13652),
    [anon_sym_DOLLAR] = ACTIONS(13652),
    [anon_sym_COLON_COLON] = ACTIONS(13652),
    [anon_sym_isa] = ACTIONS(13652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13652),
    [anon_sym_QMARK] = ACTIONS(13652),
    [anon_sym_AT] = ACTIONS(13652),
    [anon_sym_true] = ACTIONS(13652),
    [anon_sym_false] = ACTIONS(13652),
    [aux_sym_integer_literal_token1] = ACTIONS(13652),
    [aux_sym_integer_literal_token2] = ACTIONS(13652),
    [aux_sym_integer_literal_token3] = ACTIONS(13652),
    [aux_sym_integer_literal_token4] = ACTIONS(13652),
    [aux_sym_float_literal_token1] = ACTIONS(13652),
    [aux_sym_float_literal_token3] = ACTIONS(13652),
    [aux_sym_float_literal_token4] = ACTIONS(13652),
    [sym_character_literal] = ACTIONS(13652),
    [sym__pair_operator] = ACTIONS(13652),
    [sym__arrow_operator] = ACTIONS(13652),
    [sym__lazy_or_operator] = ACTIONS(13652),
    [sym__lazy_and_operator] = ACTIONS(13652),
    [sym__comparison_operator] = ACTIONS(13652),
    [sym__pipe_right_operator] = ACTIONS(13652),
    [sym__pipe_left_operator] = ACTIONS(13652),
    [sym__ellipsis_operator] = ACTIONS(13652),
    [sym__plus_operator] = ACTIONS(13652),
    [sym__times_operator] = ACTIONS(13652),
    [sym__rational_operator] = ACTIONS(13652),
    [sym__bitshift_operator] = ACTIONS(13652),
    [sym__power_operator] = ACTIONS(13652),
    [sym__tilde_operator] = ACTIONS(13652),
    [sym__type_order_operator] = ACTIONS(13652),
    [sym__unary_operator] = ACTIONS(13652),
    [sym__unary_plus_operator] = ACTIONS(13652),
    [aux_sym__terminator_token1] = ACTIONS(13652),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13654),
    [sym__command_start] = ACTIONS(13654),
  },
  [8145] = {
    [sym__word_identifier] = ACTIONS(13378),
    [anon_sym_EQ] = ACTIONS(13378),
    [anon_sym_COMMA] = ACTIONS(13378),
    [anon_sym_COLON] = ACTIONS(13378),
    [anon_sym_begin] = ACTIONS(13378),
    [anon_sym_module] = ACTIONS(13378),
    [anon_sym_baremodule] = ACTIONS(13378),
    [anon_sym_end] = ACTIONS(13378),
    [anon_sym_abstract] = ACTIONS(13378),
    [anon_sym_primitive] = ACTIONS(13378),
    [anon_sym_mutable] = ACTIONS(13378),
    [anon_sym_struct] = ACTIONS(13378),
    [anon_sym_function] = ACTIONS(13378),
    [anon_sym_macro] = ACTIONS(13378),
    [anon_sym_where] = ACTIONS(13378),
    [anon_sym_quote] = ACTIONS(13378),
    [anon_sym_let] = ACTIONS(13378),
    [anon_sym_if] = ACTIONS(13378),
    [anon_sym_try] = ACTIONS(13378),
    [anon_sym_finally] = ACTIONS(13378),
    [anon_sym_for] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(13378),
    [sym_break_statement] = ACTIONS(13378),
    [sym_continue_statement] = ACTIONS(13378),
    [anon_sym_return] = ACTIONS(13378),
    [anon_sym_const] = ACTIONS(13378),
    [anon_sym_global] = ACTIONS(13378),
    [anon_sym_local] = ACTIONS(13378),
    [anon_sym_LPAREN] = ACTIONS(13378),
    [anon_sym_COLON2] = ACTIONS(13378),
    [anon_sym_export] = ACTIONS(13378),
    [anon_sym_import] = ACTIONS(13378),
    [anon_sym_using] = ACTIONS(13378),
    [anon_sym_LBRACK] = ACTIONS(13378),
    [anon_sym_LF] = ACTIONS(13380),
    [anon_sym_in] = ACTIONS(13378),
    [anon_sym_LBRACE] = ACTIONS(13378),
    [anon_sym_DOLLAR] = ACTIONS(13378),
    [anon_sym_COLON_COLON] = ACTIONS(13378),
    [anon_sym_isa] = ACTIONS(13378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13378),
    [anon_sym_QMARK] = ACTIONS(13378),
    [anon_sym_AT] = ACTIONS(13378),
    [anon_sym_true] = ACTIONS(13378),
    [anon_sym_false] = ACTIONS(13378),
    [aux_sym_integer_literal_token1] = ACTIONS(13378),
    [aux_sym_integer_literal_token2] = ACTIONS(13378),
    [aux_sym_integer_literal_token3] = ACTIONS(13378),
    [aux_sym_integer_literal_token4] = ACTIONS(13378),
    [aux_sym_float_literal_token1] = ACTIONS(13378),
    [aux_sym_float_literal_token3] = ACTIONS(13378),
    [aux_sym_float_literal_token4] = ACTIONS(13378),
    [sym_character_literal] = ACTIONS(13378),
    [sym__pair_operator] = ACTIONS(13378),
    [sym__arrow_operator] = ACTIONS(13378),
    [sym__lazy_or_operator] = ACTIONS(13378),
    [sym__lazy_and_operator] = ACTIONS(13378),
    [sym__comparison_operator] = ACTIONS(13378),
    [sym__pipe_right_operator] = ACTIONS(13378),
    [sym__pipe_left_operator] = ACTIONS(13378),
    [sym__ellipsis_operator] = ACTIONS(13378),
    [sym__plus_operator] = ACTIONS(13378),
    [sym__times_operator] = ACTIONS(13378),
    [sym__rational_operator] = ACTIONS(13378),
    [sym__bitshift_operator] = ACTIONS(13378),
    [sym__power_operator] = ACTIONS(13378),
    [sym__tilde_operator] = ACTIONS(13378),
    [sym__type_order_operator] = ACTIONS(13378),
    [sym__unary_operator] = ACTIONS(13378),
    [sym__unary_plus_operator] = ACTIONS(13378),
    [aux_sym__terminator_token1] = ACTIONS(13378),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13380),
    [sym__command_start] = ACTIONS(13380),
  },
  [8146] = {
    [sym__word_identifier] = ACTIONS(13656),
    [anon_sym_EQ] = ACTIONS(13656),
    [anon_sym_COMMA] = ACTIONS(13656),
    [anon_sym_COLON] = ACTIONS(13656),
    [anon_sym_begin] = ACTIONS(13656),
    [anon_sym_module] = ACTIONS(13656),
    [anon_sym_baremodule] = ACTIONS(13656),
    [anon_sym_abstract] = ACTIONS(13656),
    [anon_sym_primitive] = ACTIONS(13656),
    [anon_sym_mutable] = ACTIONS(13656),
    [anon_sym_struct] = ACTIONS(13656),
    [anon_sym_function] = ACTIONS(13656),
    [anon_sym_macro] = ACTIONS(13656),
    [anon_sym_where] = ACTIONS(13656),
    [anon_sym_quote] = ACTIONS(13656),
    [anon_sym_let] = ACTIONS(13656),
    [anon_sym_if] = ACTIONS(13656),
    [anon_sym_try] = ACTIONS(13656),
    [anon_sym_catch] = ACTIONS(13656),
    [anon_sym_finally] = ACTIONS(13656),
    [anon_sym_for] = ACTIONS(13656),
    [anon_sym_while] = ACTIONS(13656),
    [sym_break_statement] = ACTIONS(13656),
    [sym_continue_statement] = ACTIONS(13656),
    [anon_sym_return] = ACTIONS(13656),
    [anon_sym_const] = ACTIONS(13656),
    [anon_sym_global] = ACTIONS(13656),
    [anon_sym_local] = ACTIONS(13656),
    [anon_sym_LPAREN] = ACTIONS(13656),
    [anon_sym_COLON2] = ACTIONS(13656),
    [anon_sym_export] = ACTIONS(13656),
    [anon_sym_import] = ACTIONS(13656),
    [anon_sym_using] = ACTIONS(13656),
    [anon_sym_LBRACK] = ACTIONS(13656),
    [anon_sym_LF] = ACTIONS(13658),
    [anon_sym_in] = ACTIONS(13656),
    [anon_sym_LBRACE] = ACTIONS(13656),
    [anon_sym_DOLLAR] = ACTIONS(13656),
    [anon_sym_COLON_COLON] = ACTIONS(13656),
    [anon_sym_isa] = ACTIONS(13656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13656),
    [anon_sym_QMARK] = ACTIONS(13656),
    [anon_sym_AT] = ACTIONS(13656),
    [anon_sym_true] = ACTIONS(13656),
    [anon_sym_false] = ACTIONS(13656),
    [aux_sym_integer_literal_token1] = ACTIONS(13656),
    [aux_sym_integer_literal_token2] = ACTIONS(13656),
    [aux_sym_integer_literal_token3] = ACTIONS(13656),
    [aux_sym_integer_literal_token4] = ACTIONS(13656),
    [aux_sym_float_literal_token1] = ACTIONS(13656),
    [aux_sym_float_literal_token3] = ACTIONS(13656),
    [aux_sym_float_literal_token4] = ACTIONS(13656),
    [sym_character_literal] = ACTIONS(13656),
    [sym__pair_operator] = ACTIONS(13656),
    [sym__arrow_operator] = ACTIONS(13656),
    [sym__lazy_or_operator] = ACTIONS(13656),
    [sym__lazy_and_operator] = ACTIONS(13656),
    [sym__comparison_operator] = ACTIONS(13656),
    [sym__pipe_right_operator] = ACTIONS(13656),
    [sym__pipe_left_operator] = ACTIONS(13656),
    [sym__ellipsis_operator] = ACTIONS(13656),
    [sym__plus_operator] = ACTIONS(13656),
    [sym__times_operator] = ACTIONS(13656),
    [sym__rational_operator] = ACTIONS(13656),
    [sym__bitshift_operator] = ACTIONS(13656),
    [sym__power_operator] = ACTIONS(13656),
    [sym__tilde_operator] = ACTIONS(13656),
    [sym__type_order_operator] = ACTIONS(13656),
    [sym__unary_operator] = ACTIONS(13656),
    [sym__unary_plus_operator] = ACTIONS(13656),
    [aux_sym__terminator_token1] = ACTIONS(13656),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13658),
    [sym__command_start] = ACTIONS(13658),
  },
  [8147] = {
    [sym__word_identifier] = ACTIONS(13660),
    [anon_sym_EQ] = ACTIONS(13660),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_COLON] = ACTIONS(13660),
    [anon_sym_begin] = ACTIONS(13660),
    [anon_sym_module] = ACTIONS(13660),
    [anon_sym_baremodule] = ACTIONS(13660),
    [anon_sym_abstract] = ACTIONS(13660),
    [anon_sym_primitive] = ACTIONS(13660),
    [anon_sym_mutable] = ACTIONS(13660),
    [anon_sym_struct] = ACTIONS(13660),
    [anon_sym_function] = ACTIONS(13660),
    [anon_sym_macro] = ACTIONS(13660),
    [anon_sym_where] = ACTIONS(13660),
    [anon_sym_quote] = ACTIONS(13660),
    [anon_sym_let] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_try] = ACTIONS(13660),
    [anon_sym_catch] = ACTIONS(13660),
    [anon_sym_finally] = ACTIONS(13660),
    [anon_sym_for] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [sym_break_statement] = ACTIONS(13660),
    [sym_continue_statement] = ACTIONS(13660),
    [anon_sym_return] = ACTIONS(13660),
    [anon_sym_const] = ACTIONS(13660),
    [anon_sym_global] = ACTIONS(13660),
    [anon_sym_local] = ACTIONS(13660),
    [anon_sym_LPAREN] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13660),
    [anon_sym_export] = ACTIONS(13660),
    [anon_sym_import] = ACTIONS(13660),
    [anon_sym_using] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_LF] = ACTIONS(13662),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_DOLLAR] = ACTIONS(13660),
    [anon_sym_COLON_COLON] = ACTIONS(13660),
    [anon_sym_isa] = ACTIONS(13660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_AT] = ACTIONS(13660),
    [anon_sym_true] = ACTIONS(13660),
    [anon_sym_false] = ACTIONS(13660),
    [aux_sym_integer_literal_token1] = ACTIONS(13660),
    [aux_sym_integer_literal_token2] = ACTIONS(13660),
    [aux_sym_integer_literal_token3] = ACTIONS(13660),
    [aux_sym_integer_literal_token4] = ACTIONS(13660),
    [aux_sym_float_literal_token1] = ACTIONS(13660),
    [aux_sym_float_literal_token3] = ACTIONS(13660),
    [aux_sym_float_literal_token4] = ACTIONS(13660),
    [sym_character_literal] = ACTIONS(13660),
    [sym__pair_operator] = ACTIONS(13660),
    [sym__arrow_operator] = ACTIONS(13660),
    [sym__lazy_or_operator] = ACTIONS(13660),
    [sym__lazy_and_operator] = ACTIONS(13660),
    [sym__comparison_operator] = ACTIONS(13660),
    [sym__pipe_right_operator] = ACTIONS(13660),
    [sym__pipe_left_operator] = ACTIONS(13660),
    [sym__ellipsis_operator] = ACTIONS(13660),
    [sym__plus_operator] = ACTIONS(13660),
    [sym__times_operator] = ACTIONS(13660),
    [sym__rational_operator] = ACTIONS(13660),
    [sym__bitshift_operator] = ACTIONS(13660),
    [sym__power_operator] = ACTIONS(13660),
    [sym__tilde_operator] = ACTIONS(13660),
    [sym__type_order_operator] = ACTIONS(13660),
    [sym__unary_operator] = ACTIONS(13660),
    [sym__unary_plus_operator] = ACTIONS(13660),
    [aux_sym__terminator_token1] = ACTIONS(13660),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13662),
    [sym__command_start] = ACTIONS(13662),
  },
  [8148] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [8149] = {
    [sym__word_identifier] = ACTIONS(13382),
    [anon_sym_EQ] = ACTIONS(13382),
    [anon_sym_COMMA] = ACTIONS(13382),
    [anon_sym_COLON] = ACTIONS(13382),
    [anon_sym_begin] = ACTIONS(13382),
    [anon_sym_module] = ACTIONS(13382),
    [anon_sym_baremodule] = ACTIONS(13382),
    [anon_sym_end] = ACTIONS(13382),
    [anon_sym_abstract] = ACTIONS(13382),
    [anon_sym_primitive] = ACTIONS(13382),
    [anon_sym_mutable] = ACTIONS(13382),
    [anon_sym_struct] = ACTIONS(13382),
    [anon_sym_function] = ACTIONS(13382),
    [anon_sym_macro] = ACTIONS(13382),
    [anon_sym_where] = ACTIONS(13382),
    [anon_sym_quote] = ACTIONS(13382),
    [anon_sym_let] = ACTIONS(13382),
    [anon_sym_if] = ACTIONS(13382),
    [anon_sym_try] = ACTIONS(13382),
    [anon_sym_finally] = ACTIONS(13382),
    [anon_sym_for] = ACTIONS(13382),
    [anon_sym_while] = ACTIONS(13382),
    [sym_break_statement] = ACTIONS(13382),
    [sym_continue_statement] = ACTIONS(13382),
    [anon_sym_return] = ACTIONS(13382),
    [anon_sym_const] = ACTIONS(13382),
    [anon_sym_global] = ACTIONS(13382),
    [anon_sym_local] = ACTIONS(13382),
    [anon_sym_LPAREN] = ACTIONS(13382),
    [anon_sym_COLON2] = ACTIONS(13382),
    [anon_sym_export] = ACTIONS(13382),
    [anon_sym_import] = ACTIONS(13382),
    [anon_sym_using] = ACTIONS(13382),
    [anon_sym_LBRACK] = ACTIONS(13382),
    [anon_sym_LF] = ACTIONS(13384),
    [anon_sym_in] = ACTIONS(13382),
    [anon_sym_LBRACE] = ACTIONS(13382),
    [anon_sym_DOLLAR] = ACTIONS(13382),
    [anon_sym_COLON_COLON] = ACTIONS(13382),
    [anon_sym_isa] = ACTIONS(13382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13382),
    [anon_sym_QMARK] = ACTIONS(13382),
    [anon_sym_AT] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(13382),
    [anon_sym_false] = ACTIONS(13382),
    [aux_sym_integer_literal_token1] = ACTIONS(13382),
    [aux_sym_integer_literal_token2] = ACTIONS(13382),
    [aux_sym_integer_literal_token3] = ACTIONS(13382),
    [aux_sym_integer_literal_token4] = ACTIONS(13382),
    [aux_sym_float_literal_token1] = ACTIONS(13382),
    [aux_sym_float_literal_token3] = ACTIONS(13382),
    [aux_sym_float_literal_token4] = ACTIONS(13382),
    [sym_character_literal] = ACTIONS(13382),
    [sym__pair_operator] = ACTIONS(13382),
    [sym__arrow_operator] = ACTIONS(13382),
    [sym__lazy_or_operator] = ACTIONS(13382),
    [sym__lazy_and_operator] = ACTIONS(13382),
    [sym__comparison_operator] = ACTIONS(13382),
    [sym__pipe_right_operator] = ACTIONS(13382),
    [sym__pipe_left_operator] = ACTIONS(13382),
    [sym__ellipsis_operator] = ACTIONS(13382),
    [sym__plus_operator] = ACTIONS(13382),
    [sym__times_operator] = ACTIONS(13382),
    [sym__rational_operator] = ACTIONS(13382),
    [sym__bitshift_operator] = ACTIONS(13382),
    [sym__power_operator] = ACTIONS(13382),
    [sym__tilde_operator] = ACTIONS(13382),
    [sym__type_order_operator] = ACTIONS(13382),
    [sym__unary_operator] = ACTIONS(13382),
    [sym__unary_plus_operator] = ACTIONS(13382),
    [aux_sym__terminator_token1] = ACTIONS(13382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13384),
    [sym__command_start] = ACTIONS(13384),
  },
  [8150] = {
    [sym__word_identifier] = ACTIONS(13386),
    [anon_sym_EQ] = ACTIONS(13386),
    [anon_sym_COMMA] = ACTIONS(13386),
    [anon_sym_COLON] = ACTIONS(13386),
    [anon_sym_begin] = ACTIONS(13386),
    [anon_sym_module] = ACTIONS(13386),
    [anon_sym_baremodule] = ACTIONS(13386),
    [anon_sym_end] = ACTIONS(13386),
    [anon_sym_abstract] = ACTIONS(13386),
    [anon_sym_primitive] = ACTIONS(13386),
    [anon_sym_mutable] = ACTIONS(13386),
    [anon_sym_struct] = ACTIONS(13386),
    [anon_sym_function] = ACTIONS(13386),
    [anon_sym_macro] = ACTIONS(13386),
    [anon_sym_where] = ACTIONS(13386),
    [anon_sym_quote] = ACTIONS(13386),
    [anon_sym_let] = ACTIONS(13386),
    [anon_sym_if] = ACTIONS(13386),
    [anon_sym_try] = ACTIONS(13386),
    [anon_sym_finally] = ACTIONS(13386),
    [anon_sym_for] = ACTIONS(13386),
    [anon_sym_while] = ACTIONS(13386),
    [sym_break_statement] = ACTIONS(13386),
    [sym_continue_statement] = ACTIONS(13386),
    [anon_sym_return] = ACTIONS(13386),
    [anon_sym_const] = ACTIONS(13386),
    [anon_sym_global] = ACTIONS(13386),
    [anon_sym_local] = ACTIONS(13386),
    [anon_sym_LPAREN] = ACTIONS(13386),
    [anon_sym_COLON2] = ACTIONS(13386),
    [anon_sym_export] = ACTIONS(13386),
    [anon_sym_import] = ACTIONS(13386),
    [anon_sym_using] = ACTIONS(13386),
    [anon_sym_LBRACK] = ACTIONS(13386),
    [anon_sym_LF] = ACTIONS(13388),
    [anon_sym_in] = ACTIONS(13386),
    [anon_sym_LBRACE] = ACTIONS(13386),
    [anon_sym_DOLLAR] = ACTIONS(13386),
    [anon_sym_COLON_COLON] = ACTIONS(13386),
    [anon_sym_isa] = ACTIONS(13386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13386),
    [anon_sym_QMARK] = ACTIONS(13386),
    [anon_sym_AT] = ACTIONS(13386),
    [anon_sym_true] = ACTIONS(13386),
    [anon_sym_false] = ACTIONS(13386),
    [aux_sym_integer_literal_token1] = ACTIONS(13386),
    [aux_sym_integer_literal_token2] = ACTIONS(13386),
    [aux_sym_integer_literal_token3] = ACTIONS(13386),
    [aux_sym_integer_literal_token4] = ACTIONS(13386),
    [aux_sym_float_literal_token1] = ACTIONS(13386),
    [aux_sym_float_literal_token3] = ACTIONS(13386),
    [aux_sym_float_literal_token4] = ACTIONS(13386),
    [sym_character_literal] = ACTIONS(13386),
    [sym__pair_operator] = ACTIONS(13386),
    [sym__arrow_operator] = ACTIONS(13386),
    [sym__lazy_or_operator] = ACTIONS(13386),
    [sym__lazy_and_operator] = ACTIONS(13386),
    [sym__comparison_operator] = ACTIONS(13386),
    [sym__pipe_right_operator] = ACTIONS(13386),
    [sym__pipe_left_operator] = ACTIONS(13386),
    [sym__ellipsis_operator] = ACTIONS(13386),
    [sym__plus_operator] = ACTIONS(13386),
    [sym__times_operator] = ACTIONS(13386),
    [sym__rational_operator] = ACTIONS(13386),
    [sym__bitshift_operator] = ACTIONS(13386),
    [sym__power_operator] = ACTIONS(13386),
    [sym__tilde_operator] = ACTIONS(13386),
    [sym__type_order_operator] = ACTIONS(13386),
    [sym__unary_operator] = ACTIONS(13386),
    [sym__unary_plus_operator] = ACTIONS(13386),
    [aux_sym__terminator_token1] = ACTIONS(13386),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13388),
    [sym__command_start] = ACTIONS(13388),
  },
  [8151] = {
    [sym__word_identifier] = ACTIONS(13390),
    [anon_sym_EQ] = ACTIONS(13390),
    [anon_sym_COMMA] = ACTIONS(13390),
    [anon_sym_COLON] = ACTIONS(13390),
    [anon_sym_begin] = ACTIONS(13390),
    [anon_sym_module] = ACTIONS(13390),
    [anon_sym_baremodule] = ACTIONS(13390),
    [anon_sym_end] = ACTIONS(13390),
    [anon_sym_abstract] = ACTIONS(13390),
    [anon_sym_primitive] = ACTIONS(13390),
    [anon_sym_mutable] = ACTIONS(13390),
    [anon_sym_struct] = ACTIONS(13390),
    [anon_sym_function] = ACTIONS(13390),
    [anon_sym_macro] = ACTIONS(13390),
    [anon_sym_where] = ACTIONS(13390),
    [anon_sym_quote] = ACTIONS(13390),
    [anon_sym_let] = ACTIONS(13390),
    [anon_sym_if] = ACTIONS(13390),
    [anon_sym_try] = ACTIONS(13390),
    [anon_sym_finally] = ACTIONS(13390),
    [anon_sym_for] = ACTIONS(13390),
    [anon_sym_while] = ACTIONS(13390),
    [sym_break_statement] = ACTIONS(13390),
    [sym_continue_statement] = ACTIONS(13390),
    [anon_sym_return] = ACTIONS(13390),
    [anon_sym_const] = ACTIONS(13390),
    [anon_sym_global] = ACTIONS(13390),
    [anon_sym_local] = ACTIONS(13390),
    [anon_sym_LPAREN] = ACTIONS(13390),
    [anon_sym_COLON2] = ACTIONS(13390),
    [anon_sym_export] = ACTIONS(13390),
    [anon_sym_import] = ACTIONS(13390),
    [anon_sym_using] = ACTIONS(13390),
    [anon_sym_LBRACK] = ACTIONS(13390),
    [anon_sym_LF] = ACTIONS(13392),
    [anon_sym_in] = ACTIONS(13390),
    [anon_sym_LBRACE] = ACTIONS(13390),
    [anon_sym_DOLLAR] = ACTIONS(13390),
    [anon_sym_COLON_COLON] = ACTIONS(13390),
    [anon_sym_isa] = ACTIONS(13390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13390),
    [anon_sym_QMARK] = ACTIONS(13390),
    [anon_sym_AT] = ACTIONS(13390),
    [anon_sym_true] = ACTIONS(13390),
    [anon_sym_false] = ACTIONS(13390),
    [aux_sym_integer_literal_token1] = ACTIONS(13390),
    [aux_sym_integer_literal_token2] = ACTIONS(13390),
    [aux_sym_integer_literal_token3] = ACTIONS(13390),
    [aux_sym_integer_literal_token4] = ACTIONS(13390),
    [aux_sym_float_literal_token1] = ACTIONS(13390),
    [aux_sym_float_literal_token3] = ACTIONS(13390),
    [aux_sym_float_literal_token4] = ACTIONS(13390),
    [sym_character_literal] = ACTIONS(13390),
    [sym__pair_operator] = ACTIONS(13390),
    [sym__arrow_operator] = ACTIONS(13390),
    [sym__lazy_or_operator] = ACTIONS(13390),
    [sym__lazy_and_operator] = ACTIONS(13390),
    [sym__comparison_operator] = ACTIONS(13390),
    [sym__pipe_right_operator] = ACTIONS(13390),
    [sym__pipe_left_operator] = ACTIONS(13390),
    [sym__ellipsis_operator] = ACTIONS(13390),
    [sym__plus_operator] = ACTIONS(13390),
    [sym__times_operator] = ACTIONS(13390),
    [sym__rational_operator] = ACTIONS(13390),
    [sym__bitshift_operator] = ACTIONS(13390),
    [sym__power_operator] = ACTIONS(13390),
    [sym__tilde_operator] = ACTIONS(13390),
    [sym__type_order_operator] = ACTIONS(13390),
    [sym__unary_operator] = ACTIONS(13390),
    [sym__unary_plus_operator] = ACTIONS(13390),
    [aux_sym__terminator_token1] = ACTIONS(13390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13392),
    [sym__command_start] = ACTIONS(13392),
  },
  [8152] = {
    [sym__word_identifier] = ACTIONS(13396),
    [anon_sym_EQ] = ACTIONS(13396),
    [anon_sym_COMMA] = ACTIONS(13396),
    [anon_sym_COLON] = ACTIONS(13396),
    [anon_sym_begin] = ACTIONS(13396),
    [anon_sym_module] = ACTIONS(13396),
    [anon_sym_baremodule] = ACTIONS(13396),
    [anon_sym_end] = ACTIONS(13396),
    [anon_sym_abstract] = ACTIONS(13396),
    [anon_sym_primitive] = ACTIONS(13396),
    [anon_sym_mutable] = ACTIONS(13396),
    [anon_sym_struct] = ACTIONS(13396),
    [anon_sym_function] = ACTIONS(13396),
    [anon_sym_macro] = ACTIONS(13396),
    [anon_sym_where] = ACTIONS(13396),
    [anon_sym_quote] = ACTIONS(13396),
    [anon_sym_let] = ACTIONS(13396),
    [anon_sym_if] = ACTIONS(13396),
    [anon_sym_try] = ACTIONS(13396),
    [anon_sym_finally] = ACTIONS(13396),
    [anon_sym_for] = ACTIONS(13396),
    [anon_sym_while] = ACTIONS(13396),
    [sym_break_statement] = ACTIONS(13396),
    [sym_continue_statement] = ACTIONS(13396),
    [anon_sym_return] = ACTIONS(13396),
    [anon_sym_const] = ACTIONS(13396),
    [anon_sym_global] = ACTIONS(13396),
    [anon_sym_local] = ACTIONS(13396),
    [anon_sym_LPAREN] = ACTIONS(13396),
    [anon_sym_COLON2] = ACTIONS(13396),
    [anon_sym_export] = ACTIONS(13396),
    [anon_sym_import] = ACTIONS(13396),
    [anon_sym_using] = ACTIONS(13396),
    [anon_sym_LBRACK] = ACTIONS(13396),
    [anon_sym_LF] = ACTIONS(13398),
    [anon_sym_in] = ACTIONS(13396),
    [anon_sym_LBRACE] = ACTIONS(13396),
    [anon_sym_DOLLAR] = ACTIONS(13396),
    [anon_sym_COLON_COLON] = ACTIONS(13396),
    [anon_sym_isa] = ACTIONS(13396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13396),
    [anon_sym_QMARK] = ACTIONS(13396),
    [anon_sym_AT] = ACTIONS(13396),
    [anon_sym_true] = ACTIONS(13396),
    [anon_sym_false] = ACTIONS(13396),
    [aux_sym_integer_literal_token1] = ACTIONS(13396),
    [aux_sym_integer_literal_token2] = ACTIONS(13396),
    [aux_sym_integer_literal_token3] = ACTIONS(13396),
    [aux_sym_integer_literal_token4] = ACTIONS(13396),
    [aux_sym_float_literal_token1] = ACTIONS(13396),
    [aux_sym_float_literal_token3] = ACTIONS(13396),
    [aux_sym_float_literal_token4] = ACTIONS(13396),
    [sym_character_literal] = ACTIONS(13396),
    [sym__pair_operator] = ACTIONS(13396),
    [sym__arrow_operator] = ACTIONS(13396),
    [sym__lazy_or_operator] = ACTIONS(13396),
    [sym__lazy_and_operator] = ACTIONS(13396),
    [sym__comparison_operator] = ACTIONS(13396),
    [sym__pipe_right_operator] = ACTIONS(13396),
    [sym__pipe_left_operator] = ACTIONS(13396),
    [sym__ellipsis_operator] = ACTIONS(13396),
    [sym__plus_operator] = ACTIONS(13396),
    [sym__times_operator] = ACTIONS(13396),
    [sym__rational_operator] = ACTIONS(13396),
    [sym__bitshift_operator] = ACTIONS(13396),
    [sym__power_operator] = ACTIONS(13396),
    [sym__tilde_operator] = ACTIONS(13396),
    [sym__type_order_operator] = ACTIONS(13396),
    [sym__unary_operator] = ACTIONS(13396),
    [sym__unary_plus_operator] = ACTIONS(13396),
    [aux_sym__terminator_token1] = ACTIONS(13396),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13398),
    [sym__command_start] = ACTIONS(13398),
  },
  [8153] = {
    [sym__word_identifier] = ACTIONS(13400),
    [anon_sym_EQ] = ACTIONS(13400),
    [anon_sym_COMMA] = ACTIONS(13400),
    [anon_sym_COLON] = ACTIONS(13400),
    [anon_sym_begin] = ACTIONS(13400),
    [anon_sym_module] = ACTIONS(13400),
    [anon_sym_baremodule] = ACTIONS(13400),
    [anon_sym_end] = ACTIONS(13400),
    [anon_sym_abstract] = ACTIONS(13400),
    [anon_sym_primitive] = ACTIONS(13400),
    [anon_sym_mutable] = ACTIONS(13400),
    [anon_sym_struct] = ACTIONS(13400),
    [anon_sym_function] = ACTIONS(13400),
    [anon_sym_macro] = ACTIONS(13400),
    [anon_sym_where] = ACTIONS(13400),
    [anon_sym_quote] = ACTIONS(13400),
    [anon_sym_let] = ACTIONS(13400),
    [anon_sym_if] = ACTIONS(13400),
    [anon_sym_try] = ACTIONS(13400),
    [anon_sym_finally] = ACTIONS(13400),
    [anon_sym_for] = ACTIONS(13400),
    [anon_sym_while] = ACTIONS(13400),
    [sym_break_statement] = ACTIONS(13400),
    [sym_continue_statement] = ACTIONS(13400),
    [anon_sym_return] = ACTIONS(13400),
    [anon_sym_const] = ACTIONS(13400),
    [anon_sym_global] = ACTIONS(13400),
    [anon_sym_local] = ACTIONS(13400),
    [anon_sym_LPAREN] = ACTIONS(13400),
    [anon_sym_COLON2] = ACTIONS(13400),
    [anon_sym_export] = ACTIONS(13400),
    [anon_sym_import] = ACTIONS(13400),
    [anon_sym_using] = ACTIONS(13400),
    [anon_sym_LBRACK] = ACTIONS(13400),
    [anon_sym_LF] = ACTIONS(13402),
    [anon_sym_in] = ACTIONS(13400),
    [anon_sym_LBRACE] = ACTIONS(13400),
    [anon_sym_DOLLAR] = ACTIONS(13400),
    [anon_sym_COLON_COLON] = ACTIONS(13400),
    [anon_sym_isa] = ACTIONS(13400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13400),
    [anon_sym_QMARK] = ACTIONS(13400),
    [anon_sym_AT] = ACTIONS(13400),
    [anon_sym_true] = ACTIONS(13400),
    [anon_sym_false] = ACTIONS(13400),
    [aux_sym_integer_literal_token1] = ACTIONS(13400),
    [aux_sym_integer_literal_token2] = ACTIONS(13400),
    [aux_sym_integer_literal_token3] = ACTIONS(13400),
    [aux_sym_integer_literal_token4] = ACTIONS(13400),
    [aux_sym_float_literal_token1] = ACTIONS(13400),
    [aux_sym_float_literal_token3] = ACTIONS(13400),
    [aux_sym_float_literal_token4] = ACTIONS(13400),
    [sym_character_literal] = ACTIONS(13400),
    [sym__pair_operator] = ACTIONS(13400),
    [sym__arrow_operator] = ACTIONS(13400),
    [sym__lazy_or_operator] = ACTIONS(13400),
    [sym__lazy_and_operator] = ACTIONS(13400),
    [sym__comparison_operator] = ACTIONS(13400),
    [sym__pipe_right_operator] = ACTIONS(13400),
    [sym__pipe_left_operator] = ACTIONS(13400),
    [sym__ellipsis_operator] = ACTIONS(13400),
    [sym__plus_operator] = ACTIONS(13400),
    [sym__times_operator] = ACTIONS(13400),
    [sym__rational_operator] = ACTIONS(13400),
    [sym__bitshift_operator] = ACTIONS(13400),
    [sym__power_operator] = ACTIONS(13400),
    [sym__tilde_operator] = ACTIONS(13400),
    [sym__type_order_operator] = ACTIONS(13400),
    [sym__unary_operator] = ACTIONS(13400),
    [sym__unary_plus_operator] = ACTIONS(13400),
    [aux_sym__terminator_token1] = ACTIONS(13400),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13402),
    [sym__command_start] = ACTIONS(13402),
  },
  [8154] = {
    [sym__word_identifier] = ACTIONS(13407),
    [anon_sym_EQ] = ACTIONS(13407),
    [anon_sym_COMMA] = ACTIONS(13407),
    [anon_sym_COLON] = ACTIONS(13407),
    [anon_sym_begin] = ACTIONS(13407),
    [anon_sym_module] = ACTIONS(13407),
    [anon_sym_baremodule] = ACTIONS(13407),
    [anon_sym_end] = ACTIONS(13407),
    [anon_sym_abstract] = ACTIONS(13407),
    [anon_sym_primitive] = ACTIONS(13407),
    [anon_sym_mutable] = ACTIONS(13407),
    [anon_sym_struct] = ACTIONS(13407),
    [anon_sym_function] = ACTIONS(13407),
    [anon_sym_macro] = ACTIONS(13407),
    [anon_sym_where] = ACTIONS(13407),
    [anon_sym_quote] = ACTIONS(13407),
    [anon_sym_let] = ACTIONS(13407),
    [anon_sym_if] = ACTIONS(13407),
    [anon_sym_try] = ACTIONS(13407),
    [anon_sym_finally] = ACTIONS(13407),
    [anon_sym_for] = ACTIONS(13407),
    [anon_sym_while] = ACTIONS(13407),
    [sym_break_statement] = ACTIONS(13407),
    [sym_continue_statement] = ACTIONS(13407),
    [anon_sym_return] = ACTIONS(13407),
    [anon_sym_const] = ACTIONS(13407),
    [anon_sym_global] = ACTIONS(13407),
    [anon_sym_local] = ACTIONS(13407),
    [anon_sym_LPAREN] = ACTIONS(13407),
    [anon_sym_COLON2] = ACTIONS(13407),
    [anon_sym_export] = ACTIONS(13407),
    [anon_sym_import] = ACTIONS(13407),
    [anon_sym_using] = ACTIONS(13407),
    [anon_sym_LBRACK] = ACTIONS(13407),
    [anon_sym_LF] = ACTIONS(13409),
    [anon_sym_in] = ACTIONS(13407),
    [anon_sym_LBRACE] = ACTIONS(13407),
    [anon_sym_DOLLAR] = ACTIONS(13407),
    [anon_sym_COLON_COLON] = ACTIONS(13407),
    [anon_sym_isa] = ACTIONS(13407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13407),
    [anon_sym_QMARK] = ACTIONS(13407),
    [anon_sym_AT] = ACTIONS(13407),
    [anon_sym_true] = ACTIONS(13407),
    [anon_sym_false] = ACTIONS(13407),
    [aux_sym_integer_literal_token1] = ACTIONS(13407),
    [aux_sym_integer_literal_token2] = ACTIONS(13407),
    [aux_sym_integer_literal_token3] = ACTIONS(13407),
    [aux_sym_integer_literal_token4] = ACTIONS(13407),
    [aux_sym_float_literal_token1] = ACTIONS(13407),
    [aux_sym_float_literal_token3] = ACTIONS(13407),
    [aux_sym_float_literal_token4] = ACTIONS(13407),
    [sym_character_literal] = ACTIONS(13407),
    [sym__pair_operator] = ACTIONS(13407),
    [sym__arrow_operator] = ACTIONS(13407),
    [sym__lazy_or_operator] = ACTIONS(13407),
    [sym__lazy_and_operator] = ACTIONS(13407),
    [sym__comparison_operator] = ACTIONS(13407),
    [sym__pipe_right_operator] = ACTIONS(13407),
    [sym__pipe_left_operator] = ACTIONS(13407),
    [sym__ellipsis_operator] = ACTIONS(13407),
    [sym__plus_operator] = ACTIONS(13407),
    [sym__times_operator] = ACTIONS(13407),
    [sym__rational_operator] = ACTIONS(13407),
    [sym__bitshift_operator] = ACTIONS(13407),
    [sym__power_operator] = ACTIONS(13407),
    [sym__tilde_operator] = ACTIONS(13407),
    [sym__type_order_operator] = ACTIONS(13407),
    [sym__unary_operator] = ACTIONS(13407),
    [sym__unary_plus_operator] = ACTIONS(13407),
    [aux_sym__terminator_token1] = ACTIONS(13407),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13409),
    [sym__command_start] = ACTIONS(13409),
  },
  [8155] = {
    [sym__word_identifier] = ACTIONS(13664),
    [anon_sym_EQ] = ACTIONS(13664),
    [anon_sym_COMMA] = ACTIONS(13664),
    [anon_sym_COLON] = ACTIONS(13664),
    [anon_sym_begin] = ACTIONS(13664),
    [anon_sym_module] = ACTIONS(13664),
    [anon_sym_baremodule] = ACTIONS(13664),
    [anon_sym_abstract] = ACTIONS(13664),
    [anon_sym_primitive] = ACTIONS(13664),
    [anon_sym_mutable] = ACTIONS(13664),
    [anon_sym_struct] = ACTIONS(13664),
    [anon_sym_function] = ACTIONS(13664),
    [anon_sym_macro] = ACTIONS(13664),
    [anon_sym_where] = ACTIONS(13664),
    [anon_sym_quote] = ACTIONS(13664),
    [anon_sym_let] = ACTIONS(13664),
    [anon_sym_if] = ACTIONS(13664),
    [anon_sym_try] = ACTIONS(13664),
    [anon_sym_catch] = ACTIONS(13664),
    [anon_sym_finally] = ACTIONS(13664),
    [anon_sym_for] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(13664),
    [sym_break_statement] = ACTIONS(13664),
    [sym_continue_statement] = ACTIONS(13664),
    [anon_sym_return] = ACTIONS(13664),
    [anon_sym_const] = ACTIONS(13664),
    [anon_sym_global] = ACTIONS(13664),
    [anon_sym_local] = ACTIONS(13664),
    [anon_sym_LPAREN] = ACTIONS(13664),
    [anon_sym_COLON2] = ACTIONS(13664),
    [anon_sym_export] = ACTIONS(13664),
    [anon_sym_import] = ACTIONS(13664),
    [anon_sym_using] = ACTIONS(13664),
    [anon_sym_LBRACK] = ACTIONS(13664),
    [anon_sym_LF] = ACTIONS(13666),
    [anon_sym_in] = ACTIONS(13664),
    [anon_sym_LBRACE] = ACTIONS(13664),
    [anon_sym_DOLLAR] = ACTIONS(13664),
    [anon_sym_COLON_COLON] = ACTIONS(13664),
    [anon_sym_isa] = ACTIONS(13664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13664),
    [anon_sym_QMARK] = ACTIONS(13664),
    [anon_sym_AT] = ACTIONS(13664),
    [anon_sym_true] = ACTIONS(13664),
    [anon_sym_false] = ACTIONS(13664),
    [aux_sym_integer_literal_token1] = ACTIONS(13664),
    [aux_sym_integer_literal_token2] = ACTIONS(13664),
    [aux_sym_integer_literal_token3] = ACTIONS(13664),
    [aux_sym_integer_literal_token4] = ACTIONS(13664),
    [aux_sym_float_literal_token1] = ACTIONS(13664),
    [aux_sym_float_literal_token3] = ACTIONS(13664),
    [aux_sym_float_literal_token4] = ACTIONS(13664),
    [sym_character_literal] = ACTIONS(13664),
    [sym__pair_operator] = ACTIONS(13664),
    [sym__arrow_operator] = ACTIONS(13664),
    [sym__lazy_or_operator] = ACTIONS(13664),
    [sym__lazy_and_operator] = ACTIONS(13664),
    [sym__comparison_operator] = ACTIONS(13664),
    [sym__pipe_right_operator] = ACTIONS(13664),
    [sym__pipe_left_operator] = ACTIONS(13664),
    [sym__ellipsis_operator] = ACTIONS(13664),
    [sym__plus_operator] = ACTIONS(13664),
    [sym__times_operator] = ACTIONS(13664),
    [sym__rational_operator] = ACTIONS(13664),
    [sym__bitshift_operator] = ACTIONS(13664),
    [sym__power_operator] = ACTIONS(13664),
    [sym__tilde_operator] = ACTIONS(13664),
    [sym__type_order_operator] = ACTIONS(13664),
    [sym__unary_operator] = ACTIONS(13664),
    [sym__unary_plus_operator] = ACTIONS(13664),
    [aux_sym__terminator_token1] = ACTIONS(13664),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13666),
    [sym__command_start] = ACTIONS(13666),
  },
  [8156] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(14543),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_catch] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8157] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_else] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_finally] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14545),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14547),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(14547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14547),
    [sym__pipe_right_operator] = ACTIONS(14549),
    [sym__pipe_left_operator] = ACTIONS(14551),
    [sym__ellipsis_operator] = ACTIONS(14553),
    [sym__plus_operator] = ACTIONS(14555),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14547),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14555),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [8158] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_else] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_finally] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14555),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14555),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [8159] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14545),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14549),
    [sym__pipe_left_operator] = ACTIONS(14551),
    [sym__ellipsis_operator] = ACTIONS(14553),
    [sym__plus_operator] = ACTIONS(14555),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14555),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8160] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [8161] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14565),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14545),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14547),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(14547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13282),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14567),
    [sym__arrow_operator] = ACTIONS(14569),
    [sym__lazy_or_operator] = ACTIONS(14571),
    [sym__lazy_and_operator] = ACTIONS(14573),
    [sym__comparison_operator] = ACTIONS(14547),
    [sym__pipe_right_operator] = ACTIONS(14549),
    [sym__pipe_left_operator] = ACTIONS(14551),
    [sym__ellipsis_operator] = ACTIONS(14553),
    [sym__plus_operator] = ACTIONS(14555),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14547),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14555),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8162] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14565),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14545),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14547),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(14547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14569),
    [sym__lazy_or_operator] = ACTIONS(14571),
    [sym__lazy_and_operator] = ACTIONS(14573),
    [sym__comparison_operator] = ACTIONS(14547),
    [sym__pipe_right_operator] = ACTIONS(14549),
    [sym__pipe_left_operator] = ACTIONS(14551),
    [sym__ellipsis_operator] = ACTIONS(14553),
    [sym__plus_operator] = ACTIONS(14555),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14547),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14555),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8163] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14565),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14545),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14547),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(14547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14573),
    [sym__comparison_operator] = ACTIONS(14547),
    [sym__pipe_right_operator] = ACTIONS(14549),
    [sym__pipe_left_operator] = ACTIONS(14551),
    [sym__ellipsis_operator] = ACTIONS(14553),
    [sym__plus_operator] = ACTIONS(14555),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14547),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14555),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8164] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14565),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14545),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14547),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(14547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14547),
    [sym__pipe_right_operator] = ACTIONS(14549),
    [sym__pipe_left_operator] = ACTIONS(14551),
    [sym__ellipsis_operator] = ACTIONS(14553),
    [sym__plus_operator] = ACTIONS(14555),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14547),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14555),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8165] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14545),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14553),
    [sym__plus_operator] = ACTIONS(14555),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14555),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8166] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14545),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14549),
    [sym__pipe_left_operator] = ACTIONS(14551),
    [sym__ellipsis_operator] = ACTIONS(14553),
    [sym__plus_operator] = ACTIONS(14555),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14555),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8167] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14555),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14555),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8168] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8169] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8170] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [8171] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_catch] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8172] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8173] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8174] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8175] = {
    [sym__word_identifier] = ACTIONS(13554),
    [anon_sym_EQ] = ACTIONS(13554),
    [anon_sym_COMMA] = ACTIONS(13556),
    [anon_sym_COLON] = ACTIONS(13554),
    [anon_sym_begin] = ACTIONS(13554),
    [anon_sym_module] = ACTIONS(13554),
    [anon_sym_baremodule] = ACTIONS(13554),
    [anon_sym_abstract] = ACTIONS(13554),
    [anon_sym_primitive] = ACTIONS(13554),
    [anon_sym_mutable] = ACTIONS(13554),
    [anon_sym_struct] = ACTIONS(13554),
    [anon_sym_function] = ACTIONS(13554),
    [anon_sym_macro] = ACTIONS(13554),
    [anon_sym_where] = ACTIONS(13554),
    [anon_sym_quote] = ACTIONS(13554),
    [anon_sym_let] = ACTIONS(13554),
    [anon_sym_if] = ACTIONS(13554),
    [anon_sym_try] = ACTIONS(13554),
    [anon_sym_for] = ACTIONS(13554),
    [anon_sym_while] = ACTIONS(13554),
    [sym_break_statement] = ACTIONS(13554),
    [sym_continue_statement] = ACTIONS(13554),
    [anon_sym_return] = ACTIONS(13554),
    [anon_sym_const] = ACTIONS(13554),
    [anon_sym_global] = ACTIONS(13554),
    [anon_sym_local] = ACTIONS(13554),
    [anon_sym_LPAREN] = ACTIONS(13556),
    [anon_sym_RPAREN] = ACTIONS(13556),
    [anon_sym_COLON2] = ACTIONS(13554),
    [anon_sym_export] = ACTIONS(13554),
    [anon_sym_import] = ACTIONS(13554),
    [anon_sym_using] = ACTIONS(13554),
    [anon_sym_LBRACK] = ACTIONS(13556),
    [anon_sym_RBRACK] = ACTIONS(13556),
    [anon_sym_in] = ACTIONS(13554),
    [anon_sym_SEMI] = ACTIONS(13556),
    [anon_sym_LBRACE] = ACTIONS(13556),
    [anon_sym_RBRACE] = ACTIONS(13556),
    [anon_sym_DOLLAR] = ACTIONS(13556),
    [anon_sym_COLON_COLON] = ACTIONS(13556),
    [anon_sym_isa] = ACTIONS(13554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13556),
    [anon_sym_QMARK] = ACTIONS(13556),
    [anon_sym_AT] = ACTIONS(13556),
    [anon_sym_true] = ACTIONS(13554),
    [anon_sym_false] = ACTIONS(13554),
    [aux_sym_integer_literal_token1] = ACTIONS(13556),
    [aux_sym_integer_literal_token2] = ACTIONS(13556),
    [aux_sym_integer_literal_token3] = ACTIONS(13554),
    [aux_sym_integer_literal_token4] = ACTIONS(13554),
    [aux_sym_float_literal_token1] = ACTIONS(13556),
    [aux_sym_float_literal_token3] = ACTIONS(13556),
    [aux_sym_float_literal_token4] = ACTIONS(13556),
    [sym_character_literal] = ACTIONS(13556),
    [sym__pair_operator] = ACTIONS(13556),
    [sym__arrow_operator] = ACTIONS(13554),
    [sym__lazy_or_operator] = ACTIONS(13556),
    [sym__lazy_and_operator] = ACTIONS(13556),
    [sym__comparison_operator] = ACTIONS(13554),
    [sym__pipe_right_operator] = ACTIONS(13556),
    [sym__pipe_left_operator] = ACTIONS(13556),
    [sym__ellipsis_operator] = ACTIONS(13554),
    [sym__plus_operator] = ACTIONS(13554),
    [sym__times_operator] = ACTIONS(13554),
    [sym__rational_operator] = ACTIONS(13556),
    [sym__bitshift_operator] = ACTIONS(13556),
    [sym__power_operator] = ACTIONS(13556),
    [sym__tilde_operator] = ACTIONS(13556),
    [sym__type_order_operator] = ACTIONS(13556),
    [sym__unary_operator] = ACTIONS(13554),
    [sym__unary_plus_operator] = ACTIONS(13554),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13556),
    [sym__command_start] = ACTIONS(13556),
  },
  [8176] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8177] = {
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13070),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_catch] = ACTIONS(13070),
    [anon_sym_finally] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14419),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [8178] = {
    [sym__word_identifier] = ACTIONS(13558),
    [anon_sym_EQ] = ACTIONS(13558),
    [anon_sym_COMMA] = ACTIONS(13560),
    [anon_sym_COLON] = ACTIONS(13558),
    [anon_sym_begin] = ACTIONS(13558),
    [anon_sym_module] = ACTIONS(13558),
    [anon_sym_baremodule] = ACTIONS(13558),
    [anon_sym_abstract] = ACTIONS(13558),
    [anon_sym_primitive] = ACTIONS(13558),
    [anon_sym_mutable] = ACTIONS(13558),
    [anon_sym_struct] = ACTIONS(13558),
    [anon_sym_function] = ACTIONS(13558),
    [anon_sym_macro] = ACTIONS(13558),
    [anon_sym_where] = ACTIONS(13558),
    [anon_sym_quote] = ACTIONS(13558),
    [anon_sym_let] = ACTIONS(13558),
    [anon_sym_if] = ACTIONS(13558),
    [anon_sym_try] = ACTIONS(13558),
    [anon_sym_for] = ACTIONS(13558),
    [anon_sym_while] = ACTIONS(13558),
    [sym_break_statement] = ACTIONS(13558),
    [sym_continue_statement] = ACTIONS(13558),
    [anon_sym_return] = ACTIONS(13558),
    [anon_sym_const] = ACTIONS(13558),
    [anon_sym_global] = ACTIONS(13558),
    [anon_sym_local] = ACTIONS(13558),
    [anon_sym_LPAREN] = ACTIONS(13560),
    [anon_sym_RPAREN] = ACTIONS(13560),
    [anon_sym_COLON2] = ACTIONS(13558),
    [anon_sym_export] = ACTIONS(13558),
    [anon_sym_import] = ACTIONS(13558),
    [anon_sym_using] = ACTIONS(13558),
    [anon_sym_LBRACK] = ACTIONS(13560),
    [anon_sym_RBRACK] = ACTIONS(13560),
    [anon_sym_in] = ACTIONS(13558),
    [anon_sym_SEMI] = ACTIONS(13560),
    [anon_sym_LBRACE] = ACTIONS(13560),
    [anon_sym_RBRACE] = ACTIONS(13560),
    [anon_sym_DOLLAR] = ACTIONS(13560),
    [anon_sym_COLON_COLON] = ACTIONS(13560),
    [anon_sym_isa] = ACTIONS(13558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13560),
    [anon_sym_QMARK] = ACTIONS(13560),
    [anon_sym_AT] = ACTIONS(13560),
    [anon_sym_true] = ACTIONS(13558),
    [anon_sym_false] = ACTIONS(13558),
    [aux_sym_integer_literal_token1] = ACTIONS(13560),
    [aux_sym_integer_literal_token2] = ACTIONS(13560),
    [aux_sym_integer_literal_token3] = ACTIONS(13558),
    [aux_sym_integer_literal_token4] = ACTIONS(13558),
    [aux_sym_float_literal_token1] = ACTIONS(13560),
    [aux_sym_float_literal_token3] = ACTIONS(13560),
    [aux_sym_float_literal_token4] = ACTIONS(13560),
    [sym_character_literal] = ACTIONS(13560),
    [sym__pair_operator] = ACTIONS(13560),
    [sym__arrow_operator] = ACTIONS(13558),
    [sym__lazy_or_operator] = ACTIONS(13560),
    [sym__lazy_and_operator] = ACTIONS(13560),
    [sym__comparison_operator] = ACTIONS(13558),
    [sym__pipe_right_operator] = ACTIONS(13560),
    [sym__pipe_left_operator] = ACTIONS(13560),
    [sym__ellipsis_operator] = ACTIONS(13558),
    [sym__plus_operator] = ACTIONS(13558),
    [sym__times_operator] = ACTIONS(13558),
    [sym__rational_operator] = ACTIONS(13560),
    [sym__bitshift_operator] = ACTIONS(13560),
    [sym__power_operator] = ACTIONS(13560),
    [sym__tilde_operator] = ACTIONS(13560),
    [sym__type_order_operator] = ACTIONS(13560),
    [sym__unary_operator] = ACTIONS(13558),
    [sym__unary_plus_operator] = ACTIONS(13558),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13560),
    [sym__command_start] = ACTIONS(13560),
  },
  [8179] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(13306),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8180] = {
    [aux_sym_open_tuple_repeat1] = STATE(8180),
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(14575),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13070),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13075),
    [anon_sym_RPAREN] = ACTIONS(13075),
    [anon_sym_COLON2] = ACTIONS(13070),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13075),
    [anon_sym_RBRACK] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13070),
    [anon_sym_LBRACE] = ACTIONS(13075),
    [anon_sym_RBRACE] = ACTIONS(13075),
    [anon_sym_DOLLAR] = ACTIONS(13075),
    [anon_sym_COLON_COLON] = ACTIONS(13075),
    [anon_sym_isa] = ACTIONS(13070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13075),
    [anon_sym_QMARK] = ACTIONS(13075),
    [anon_sym_AT] = ACTIONS(13075),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13075),
    [aux_sym_integer_literal_token2] = ACTIONS(13075),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13075),
    [aux_sym_float_literal_token3] = ACTIONS(13075),
    [aux_sym_float_literal_token4] = ACTIONS(13075),
    [sym_character_literal] = ACTIONS(13075),
    [sym__pair_operator] = ACTIONS(13075),
    [sym__arrow_operator] = ACTIONS(13070),
    [sym__lazy_or_operator] = ACTIONS(13075),
    [sym__lazy_and_operator] = ACTIONS(13075),
    [sym__comparison_operator] = ACTIONS(13070),
    [sym__pipe_right_operator] = ACTIONS(13075),
    [sym__pipe_left_operator] = ACTIONS(13075),
    [sym__ellipsis_operator] = ACTIONS(13070),
    [sym__plus_operator] = ACTIONS(13070),
    [sym__times_operator] = ACTIONS(13070),
    [sym__rational_operator] = ACTIONS(13075),
    [sym__bitshift_operator] = ACTIONS(13075),
    [sym__power_operator] = ACTIONS(13075),
    [sym__tilde_operator] = ACTIONS(13075),
    [sym__type_order_operator] = ACTIONS(13075),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [8181] = {
    [aux_sym__import_list_repeat1] = STATE(8252),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13742),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_end] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [aux_sym__terminator_token1] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [8182] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [8183] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(14016),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [8184] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [8185] = {
    [sym__word_identifier] = ACTIONS(13562),
    [anon_sym_EQ] = ACTIONS(13562),
    [anon_sym_COMMA] = ACTIONS(13564),
    [anon_sym_COLON] = ACTIONS(13562),
    [anon_sym_begin] = ACTIONS(13562),
    [anon_sym_module] = ACTIONS(13562),
    [anon_sym_baremodule] = ACTIONS(13562),
    [anon_sym_abstract] = ACTIONS(13562),
    [anon_sym_primitive] = ACTIONS(13562),
    [anon_sym_mutable] = ACTIONS(13562),
    [anon_sym_struct] = ACTIONS(13562),
    [anon_sym_function] = ACTIONS(13562),
    [anon_sym_macro] = ACTIONS(13562),
    [anon_sym_where] = ACTIONS(13562),
    [anon_sym_quote] = ACTIONS(13562),
    [anon_sym_let] = ACTIONS(13562),
    [anon_sym_if] = ACTIONS(13562),
    [anon_sym_try] = ACTIONS(13562),
    [anon_sym_for] = ACTIONS(13562),
    [anon_sym_while] = ACTIONS(13562),
    [sym_break_statement] = ACTIONS(13562),
    [sym_continue_statement] = ACTIONS(13562),
    [anon_sym_return] = ACTIONS(13562),
    [anon_sym_const] = ACTIONS(13562),
    [anon_sym_global] = ACTIONS(13562),
    [anon_sym_local] = ACTIONS(13562),
    [anon_sym_LPAREN] = ACTIONS(13564),
    [anon_sym_RPAREN] = ACTIONS(13564),
    [anon_sym_COLON2] = ACTIONS(13562),
    [anon_sym_export] = ACTIONS(13562),
    [anon_sym_import] = ACTIONS(13562),
    [anon_sym_using] = ACTIONS(13562),
    [anon_sym_LBRACK] = ACTIONS(13564),
    [anon_sym_RBRACK] = ACTIONS(13564),
    [anon_sym_in] = ACTIONS(13562),
    [anon_sym_SEMI] = ACTIONS(13564),
    [anon_sym_LBRACE] = ACTIONS(13564),
    [anon_sym_RBRACE] = ACTIONS(13564),
    [anon_sym_DOLLAR] = ACTIONS(13564),
    [anon_sym_COLON_COLON] = ACTIONS(13564),
    [anon_sym_isa] = ACTIONS(13562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13564),
    [anon_sym_QMARK] = ACTIONS(13564),
    [anon_sym_AT] = ACTIONS(13564),
    [anon_sym_true] = ACTIONS(13562),
    [anon_sym_false] = ACTIONS(13562),
    [aux_sym_integer_literal_token1] = ACTIONS(13564),
    [aux_sym_integer_literal_token2] = ACTIONS(13564),
    [aux_sym_integer_literal_token3] = ACTIONS(13562),
    [aux_sym_integer_literal_token4] = ACTIONS(13562),
    [aux_sym_float_literal_token1] = ACTIONS(13564),
    [aux_sym_float_literal_token3] = ACTIONS(13564),
    [aux_sym_float_literal_token4] = ACTIONS(13564),
    [sym_character_literal] = ACTIONS(13564),
    [sym__pair_operator] = ACTIONS(13564),
    [sym__arrow_operator] = ACTIONS(13562),
    [sym__lazy_or_operator] = ACTIONS(13564),
    [sym__lazy_and_operator] = ACTIONS(13564),
    [sym__comparison_operator] = ACTIONS(13562),
    [sym__pipe_right_operator] = ACTIONS(13564),
    [sym__pipe_left_operator] = ACTIONS(13564),
    [sym__ellipsis_operator] = ACTIONS(13562),
    [sym__plus_operator] = ACTIONS(13562),
    [sym__times_operator] = ACTIONS(13562),
    [sym__rational_operator] = ACTIONS(13564),
    [sym__bitshift_operator] = ACTIONS(13564),
    [sym__power_operator] = ACTIONS(13564),
    [sym__tilde_operator] = ACTIONS(13564),
    [sym__type_order_operator] = ACTIONS(13564),
    [sym__unary_operator] = ACTIONS(13562),
    [sym__unary_plus_operator] = ACTIONS(13562),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13564),
    [sym__command_start] = ACTIONS(13564),
  },
  [8186] = {
    [sym__word_identifier] = ACTIONS(13413),
    [anon_sym_EQ] = ACTIONS(13413),
    [anon_sym_COMMA] = ACTIONS(13413),
    [anon_sym_COLON] = ACTIONS(13413),
    [anon_sym_begin] = ACTIONS(13413),
    [anon_sym_module] = ACTIONS(13413),
    [anon_sym_baremodule] = ACTIONS(13413),
    [anon_sym_end] = ACTIONS(13413),
    [anon_sym_abstract] = ACTIONS(13413),
    [anon_sym_primitive] = ACTIONS(13413),
    [anon_sym_mutable] = ACTIONS(13413),
    [anon_sym_struct] = ACTIONS(13413),
    [anon_sym_function] = ACTIONS(13413),
    [anon_sym_macro] = ACTIONS(13413),
    [anon_sym_where] = ACTIONS(13413),
    [anon_sym_quote] = ACTIONS(13413),
    [anon_sym_let] = ACTIONS(13413),
    [anon_sym_if] = ACTIONS(13413),
    [anon_sym_try] = ACTIONS(13413),
    [anon_sym_finally] = ACTIONS(13413),
    [anon_sym_for] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(13413),
    [sym_break_statement] = ACTIONS(13413),
    [sym_continue_statement] = ACTIONS(13413),
    [anon_sym_return] = ACTIONS(13413),
    [anon_sym_const] = ACTIONS(13413),
    [anon_sym_global] = ACTIONS(13413),
    [anon_sym_local] = ACTIONS(13413),
    [anon_sym_LPAREN] = ACTIONS(13413),
    [anon_sym_COLON2] = ACTIONS(13413),
    [anon_sym_export] = ACTIONS(13413),
    [anon_sym_import] = ACTIONS(13413),
    [anon_sym_using] = ACTIONS(13413),
    [anon_sym_LBRACK] = ACTIONS(13413),
    [anon_sym_LF] = ACTIONS(13415),
    [anon_sym_in] = ACTIONS(13413),
    [anon_sym_LBRACE] = ACTIONS(13413),
    [anon_sym_DOLLAR] = ACTIONS(13413),
    [anon_sym_COLON_COLON] = ACTIONS(13413),
    [anon_sym_isa] = ACTIONS(13413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_QMARK] = ACTIONS(13413),
    [anon_sym_AT] = ACTIONS(13413),
    [anon_sym_true] = ACTIONS(13413),
    [anon_sym_false] = ACTIONS(13413),
    [aux_sym_integer_literal_token1] = ACTIONS(13413),
    [aux_sym_integer_literal_token2] = ACTIONS(13413),
    [aux_sym_integer_literal_token3] = ACTIONS(13413),
    [aux_sym_integer_literal_token4] = ACTIONS(13413),
    [aux_sym_float_literal_token1] = ACTIONS(13413),
    [aux_sym_float_literal_token3] = ACTIONS(13413),
    [aux_sym_float_literal_token4] = ACTIONS(13413),
    [sym_character_literal] = ACTIONS(13413),
    [sym__pair_operator] = ACTIONS(13413),
    [sym__arrow_operator] = ACTIONS(13413),
    [sym__lazy_or_operator] = ACTIONS(13413),
    [sym__lazy_and_operator] = ACTIONS(13413),
    [sym__comparison_operator] = ACTIONS(13413),
    [sym__pipe_right_operator] = ACTIONS(13413),
    [sym__pipe_left_operator] = ACTIONS(13413),
    [sym__ellipsis_operator] = ACTIONS(13413),
    [sym__plus_operator] = ACTIONS(13413),
    [sym__times_operator] = ACTIONS(13413),
    [sym__rational_operator] = ACTIONS(13413),
    [sym__bitshift_operator] = ACTIONS(13413),
    [sym__power_operator] = ACTIONS(13413),
    [sym__tilde_operator] = ACTIONS(13413),
    [sym__type_order_operator] = ACTIONS(13413),
    [sym__unary_operator] = ACTIONS(13413),
    [sym__unary_plus_operator] = ACTIONS(13413),
    [aux_sym__terminator_token1] = ACTIONS(13413),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13415),
    [sym__command_start] = ACTIONS(13415),
  },
  [8187] = {
    [sym__word_identifier] = ACTIONS(13417),
    [anon_sym_EQ] = ACTIONS(13417),
    [anon_sym_COMMA] = ACTIONS(13417),
    [anon_sym_COLON] = ACTIONS(13417),
    [anon_sym_begin] = ACTIONS(13417),
    [anon_sym_module] = ACTIONS(13417),
    [anon_sym_baremodule] = ACTIONS(13417),
    [anon_sym_end] = ACTIONS(13417),
    [anon_sym_abstract] = ACTIONS(13417),
    [anon_sym_primitive] = ACTIONS(13417),
    [anon_sym_mutable] = ACTIONS(13417),
    [anon_sym_struct] = ACTIONS(13417),
    [anon_sym_function] = ACTIONS(13417),
    [anon_sym_macro] = ACTIONS(13417),
    [anon_sym_where] = ACTIONS(13417),
    [anon_sym_quote] = ACTIONS(13417),
    [anon_sym_let] = ACTIONS(13417),
    [anon_sym_if] = ACTIONS(13417),
    [anon_sym_try] = ACTIONS(13417),
    [anon_sym_finally] = ACTIONS(13417),
    [anon_sym_for] = ACTIONS(13417),
    [anon_sym_while] = ACTIONS(13417),
    [sym_break_statement] = ACTIONS(13417),
    [sym_continue_statement] = ACTIONS(13417),
    [anon_sym_return] = ACTIONS(13417),
    [anon_sym_const] = ACTIONS(13417),
    [anon_sym_global] = ACTIONS(13417),
    [anon_sym_local] = ACTIONS(13417),
    [anon_sym_LPAREN] = ACTIONS(13417),
    [anon_sym_COLON2] = ACTIONS(13417),
    [anon_sym_export] = ACTIONS(13417),
    [anon_sym_import] = ACTIONS(13417),
    [anon_sym_using] = ACTIONS(13417),
    [anon_sym_LBRACK] = ACTIONS(13417),
    [anon_sym_LF] = ACTIONS(13419),
    [anon_sym_in] = ACTIONS(13417),
    [anon_sym_LBRACE] = ACTIONS(13417),
    [anon_sym_DOLLAR] = ACTIONS(13417),
    [anon_sym_COLON_COLON] = ACTIONS(13417),
    [anon_sym_isa] = ACTIONS(13417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13417),
    [anon_sym_QMARK] = ACTIONS(13417),
    [anon_sym_AT] = ACTIONS(13417),
    [anon_sym_true] = ACTIONS(13417),
    [anon_sym_false] = ACTIONS(13417),
    [aux_sym_integer_literal_token1] = ACTIONS(13417),
    [aux_sym_integer_literal_token2] = ACTIONS(13417),
    [aux_sym_integer_literal_token3] = ACTIONS(13417),
    [aux_sym_integer_literal_token4] = ACTIONS(13417),
    [aux_sym_float_literal_token1] = ACTIONS(13417),
    [aux_sym_float_literal_token3] = ACTIONS(13417),
    [aux_sym_float_literal_token4] = ACTIONS(13417),
    [sym_character_literal] = ACTIONS(13417),
    [sym__pair_operator] = ACTIONS(13417),
    [sym__arrow_operator] = ACTIONS(13417),
    [sym__lazy_or_operator] = ACTIONS(13417),
    [sym__lazy_and_operator] = ACTIONS(13417),
    [sym__comparison_operator] = ACTIONS(13417),
    [sym__pipe_right_operator] = ACTIONS(13417),
    [sym__pipe_left_operator] = ACTIONS(13417),
    [sym__ellipsis_operator] = ACTIONS(13417),
    [sym__plus_operator] = ACTIONS(13417),
    [sym__times_operator] = ACTIONS(13417),
    [sym__rational_operator] = ACTIONS(13417),
    [sym__bitshift_operator] = ACTIONS(13417),
    [sym__power_operator] = ACTIONS(13417),
    [sym__tilde_operator] = ACTIONS(13417),
    [sym__type_order_operator] = ACTIONS(13417),
    [sym__unary_operator] = ACTIONS(13417),
    [sym__unary_plus_operator] = ACTIONS(13417),
    [aux_sym__terminator_token1] = ACTIONS(13417),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13419),
    [sym__command_start] = ACTIONS(13419),
  },
  [8188] = {
    [sym__word_identifier] = ACTIONS(13421),
    [anon_sym_EQ] = ACTIONS(13421),
    [anon_sym_COMMA] = ACTIONS(13421),
    [anon_sym_COLON] = ACTIONS(13421),
    [anon_sym_begin] = ACTIONS(13421),
    [anon_sym_module] = ACTIONS(13421),
    [anon_sym_baremodule] = ACTIONS(13421),
    [anon_sym_end] = ACTIONS(13421),
    [anon_sym_abstract] = ACTIONS(13421),
    [anon_sym_primitive] = ACTIONS(13421),
    [anon_sym_mutable] = ACTIONS(13421),
    [anon_sym_struct] = ACTIONS(13421),
    [anon_sym_function] = ACTIONS(13421),
    [anon_sym_macro] = ACTIONS(13421),
    [anon_sym_where] = ACTIONS(13421),
    [anon_sym_quote] = ACTIONS(13421),
    [anon_sym_let] = ACTIONS(13421),
    [anon_sym_if] = ACTIONS(13421),
    [anon_sym_try] = ACTIONS(13421),
    [anon_sym_finally] = ACTIONS(13421),
    [anon_sym_for] = ACTIONS(13421),
    [anon_sym_while] = ACTIONS(13421),
    [sym_break_statement] = ACTIONS(13421),
    [sym_continue_statement] = ACTIONS(13421),
    [anon_sym_return] = ACTIONS(13421),
    [anon_sym_const] = ACTIONS(13421),
    [anon_sym_global] = ACTIONS(13421),
    [anon_sym_local] = ACTIONS(13421),
    [anon_sym_LPAREN] = ACTIONS(13421),
    [anon_sym_COLON2] = ACTIONS(13421),
    [anon_sym_export] = ACTIONS(13421),
    [anon_sym_import] = ACTIONS(13421),
    [anon_sym_using] = ACTIONS(13421),
    [anon_sym_LBRACK] = ACTIONS(13421),
    [anon_sym_LF] = ACTIONS(13423),
    [anon_sym_in] = ACTIONS(13421),
    [anon_sym_LBRACE] = ACTIONS(13421),
    [anon_sym_DOLLAR] = ACTIONS(13421),
    [anon_sym_COLON_COLON] = ACTIONS(13421),
    [anon_sym_isa] = ACTIONS(13421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13421),
    [anon_sym_QMARK] = ACTIONS(13421),
    [anon_sym_AT] = ACTIONS(13421),
    [anon_sym_true] = ACTIONS(13421),
    [anon_sym_false] = ACTIONS(13421),
    [aux_sym_integer_literal_token1] = ACTIONS(13421),
    [aux_sym_integer_literal_token2] = ACTIONS(13421),
    [aux_sym_integer_literal_token3] = ACTIONS(13421),
    [aux_sym_integer_literal_token4] = ACTIONS(13421),
    [aux_sym_float_literal_token1] = ACTIONS(13421),
    [aux_sym_float_literal_token3] = ACTIONS(13421),
    [aux_sym_float_literal_token4] = ACTIONS(13421),
    [sym_character_literal] = ACTIONS(13421),
    [sym__pair_operator] = ACTIONS(13421),
    [sym__arrow_operator] = ACTIONS(13421),
    [sym__lazy_or_operator] = ACTIONS(13421),
    [sym__lazy_and_operator] = ACTIONS(13421),
    [sym__comparison_operator] = ACTIONS(13421),
    [sym__pipe_right_operator] = ACTIONS(13421),
    [sym__pipe_left_operator] = ACTIONS(13421),
    [sym__ellipsis_operator] = ACTIONS(13421),
    [sym__plus_operator] = ACTIONS(13421),
    [sym__times_operator] = ACTIONS(13421),
    [sym__rational_operator] = ACTIONS(13421),
    [sym__bitshift_operator] = ACTIONS(13421),
    [sym__power_operator] = ACTIONS(13421),
    [sym__tilde_operator] = ACTIONS(13421),
    [sym__type_order_operator] = ACTIONS(13421),
    [sym__unary_operator] = ACTIONS(13421),
    [sym__unary_plus_operator] = ACTIONS(13421),
    [aux_sym__terminator_token1] = ACTIONS(13421),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13423),
    [sym__command_start] = ACTIONS(13423),
  },
  [8189] = {
    [sym__word_identifier] = ACTIONS(13425),
    [anon_sym_EQ] = ACTIONS(13425),
    [anon_sym_COMMA] = ACTIONS(13425),
    [anon_sym_COLON] = ACTIONS(13425),
    [anon_sym_begin] = ACTIONS(13425),
    [anon_sym_module] = ACTIONS(13425),
    [anon_sym_baremodule] = ACTIONS(13425),
    [anon_sym_end] = ACTIONS(13425),
    [anon_sym_abstract] = ACTIONS(13425),
    [anon_sym_primitive] = ACTIONS(13425),
    [anon_sym_mutable] = ACTIONS(13425),
    [anon_sym_struct] = ACTIONS(13425),
    [anon_sym_function] = ACTIONS(13425),
    [anon_sym_macro] = ACTIONS(13425),
    [anon_sym_where] = ACTIONS(13425),
    [anon_sym_quote] = ACTIONS(13425),
    [anon_sym_let] = ACTIONS(13425),
    [anon_sym_if] = ACTIONS(13425),
    [anon_sym_try] = ACTIONS(13425),
    [anon_sym_finally] = ACTIONS(13425),
    [anon_sym_for] = ACTIONS(13425),
    [anon_sym_while] = ACTIONS(13425),
    [sym_break_statement] = ACTIONS(13425),
    [sym_continue_statement] = ACTIONS(13425),
    [anon_sym_return] = ACTIONS(13425),
    [anon_sym_const] = ACTIONS(13425),
    [anon_sym_global] = ACTIONS(13425),
    [anon_sym_local] = ACTIONS(13425),
    [anon_sym_LPAREN] = ACTIONS(13425),
    [anon_sym_COLON2] = ACTIONS(13425),
    [anon_sym_export] = ACTIONS(13425),
    [anon_sym_import] = ACTIONS(13425),
    [anon_sym_using] = ACTIONS(13425),
    [anon_sym_LBRACK] = ACTIONS(13425),
    [anon_sym_LF] = ACTIONS(13427),
    [anon_sym_in] = ACTIONS(13425),
    [anon_sym_LBRACE] = ACTIONS(13425),
    [anon_sym_DOLLAR] = ACTIONS(13425),
    [anon_sym_COLON_COLON] = ACTIONS(13425),
    [anon_sym_isa] = ACTIONS(13425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13425),
    [anon_sym_QMARK] = ACTIONS(13425),
    [anon_sym_AT] = ACTIONS(13425),
    [anon_sym_true] = ACTIONS(13425),
    [anon_sym_false] = ACTIONS(13425),
    [aux_sym_integer_literal_token1] = ACTIONS(13425),
    [aux_sym_integer_literal_token2] = ACTIONS(13425),
    [aux_sym_integer_literal_token3] = ACTIONS(13425),
    [aux_sym_integer_literal_token4] = ACTIONS(13425),
    [aux_sym_float_literal_token1] = ACTIONS(13425),
    [aux_sym_float_literal_token3] = ACTIONS(13425),
    [aux_sym_float_literal_token4] = ACTIONS(13425),
    [sym_character_literal] = ACTIONS(13425),
    [sym__pair_operator] = ACTIONS(13425),
    [sym__arrow_operator] = ACTIONS(13425),
    [sym__lazy_or_operator] = ACTIONS(13425),
    [sym__lazy_and_operator] = ACTIONS(13425),
    [sym__comparison_operator] = ACTIONS(13425),
    [sym__pipe_right_operator] = ACTIONS(13425),
    [sym__pipe_left_operator] = ACTIONS(13425),
    [sym__ellipsis_operator] = ACTIONS(13425),
    [sym__plus_operator] = ACTIONS(13425),
    [sym__times_operator] = ACTIONS(13425),
    [sym__rational_operator] = ACTIONS(13425),
    [sym__bitshift_operator] = ACTIONS(13425),
    [sym__power_operator] = ACTIONS(13425),
    [sym__tilde_operator] = ACTIONS(13425),
    [sym__type_order_operator] = ACTIONS(13425),
    [sym__unary_operator] = ACTIONS(13425),
    [sym__unary_plus_operator] = ACTIONS(13425),
    [aux_sym__terminator_token1] = ACTIONS(13425),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13427),
    [sym__command_start] = ACTIONS(13427),
  },
  [8190] = {
    [sym__word_identifier] = ACTIONS(13429),
    [anon_sym_EQ] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(13429),
    [anon_sym_COLON] = ACTIONS(13429),
    [anon_sym_begin] = ACTIONS(13429),
    [anon_sym_module] = ACTIONS(13429),
    [anon_sym_baremodule] = ACTIONS(13429),
    [anon_sym_end] = ACTIONS(13429),
    [anon_sym_abstract] = ACTIONS(13429),
    [anon_sym_primitive] = ACTIONS(13429),
    [anon_sym_mutable] = ACTIONS(13429),
    [anon_sym_struct] = ACTIONS(13429),
    [anon_sym_function] = ACTIONS(13429),
    [anon_sym_macro] = ACTIONS(13429),
    [anon_sym_where] = ACTIONS(13429),
    [anon_sym_quote] = ACTIONS(13429),
    [anon_sym_let] = ACTIONS(13429),
    [anon_sym_if] = ACTIONS(13429),
    [anon_sym_try] = ACTIONS(13429),
    [anon_sym_finally] = ACTIONS(13429),
    [anon_sym_for] = ACTIONS(13429),
    [anon_sym_while] = ACTIONS(13429),
    [sym_break_statement] = ACTIONS(13429),
    [sym_continue_statement] = ACTIONS(13429),
    [anon_sym_return] = ACTIONS(13429),
    [anon_sym_const] = ACTIONS(13429),
    [anon_sym_global] = ACTIONS(13429),
    [anon_sym_local] = ACTIONS(13429),
    [anon_sym_LPAREN] = ACTIONS(13429),
    [anon_sym_COLON2] = ACTIONS(13429),
    [anon_sym_export] = ACTIONS(13429),
    [anon_sym_import] = ACTIONS(13429),
    [anon_sym_using] = ACTIONS(13429),
    [anon_sym_LBRACK] = ACTIONS(13429),
    [anon_sym_LF] = ACTIONS(13431),
    [anon_sym_in] = ACTIONS(13429),
    [anon_sym_LBRACE] = ACTIONS(13429),
    [anon_sym_DOLLAR] = ACTIONS(13429),
    [anon_sym_COLON_COLON] = ACTIONS(13429),
    [anon_sym_isa] = ACTIONS(13429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13429),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_AT] = ACTIONS(13429),
    [anon_sym_true] = ACTIONS(13429),
    [anon_sym_false] = ACTIONS(13429),
    [aux_sym_integer_literal_token1] = ACTIONS(13429),
    [aux_sym_integer_literal_token2] = ACTIONS(13429),
    [aux_sym_integer_literal_token3] = ACTIONS(13429),
    [aux_sym_integer_literal_token4] = ACTIONS(13429),
    [aux_sym_float_literal_token1] = ACTIONS(13429),
    [aux_sym_float_literal_token3] = ACTIONS(13429),
    [aux_sym_float_literal_token4] = ACTIONS(13429),
    [sym_character_literal] = ACTIONS(13429),
    [sym__pair_operator] = ACTIONS(13429),
    [sym__arrow_operator] = ACTIONS(13429),
    [sym__lazy_or_operator] = ACTIONS(13429),
    [sym__lazy_and_operator] = ACTIONS(13429),
    [sym__comparison_operator] = ACTIONS(13429),
    [sym__pipe_right_operator] = ACTIONS(13429),
    [sym__pipe_left_operator] = ACTIONS(13429),
    [sym__ellipsis_operator] = ACTIONS(13429),
    [sym__plus_operator] = ACTIONS(13429),
    [sym__times_operator] = ACTIONS(13429),
    [sym__rational_operator] = ACTIONS(13429),
    [sym__bitshift_operator] = ACTIONS(13429),
    [sym__power_operator] = ACTIONS(13429),
    [sym__tilde_operator] = ACTIONS(13429),
    [sym__type_order_operator] = ACTIONS(13429),
    [sym__unary_operator] = ACTIONS(13429),
    [sym__unary_plus_operator] = ACTIONS(13429),
    [aux_sym__terminator_token1] = ACTIONS(13429),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13431),
    [sym__command_start] = ACTIONS(13431),
  },
  [8191] = {
    [sym__primary_expression] = STATE(11519),
    [sym__array] = STATE(11519),
    [sym_comprehension_expression] = STATE(11519),
    [sym_matrix_expression] = STATE(11519),
    [sym_vector_expression] = STATE(11519),
    [sym_parenthesized_expression] = STATE(11519),
    [sym_tuple_expression] = STATE(11519),
    [sym_curly_expression] = STATE(11519),
    [sym_adjoint_expression] = STATE(11519),
    [sym_field_expression] = STATE(11519),
    [sym_index_expression] = STATE(11519),
    [sym_parametrized_type_expression] = STATE(11519),
    [sym_call_expression] = STATE(11519),
    [sym_broadcast_call_expression] = STATE(11519),
    [sym__closed_macrocall_expression] = STATE(11519),
    [sym_interpolation_expression] = STATE(11519),
    [sym_quote_expression] = STATE(11519),
    [sym_macro_identifier] = STATE(17273),
    [sym_identifier] = STATE(11204),
    [sym_boolean_literal] = STATE(11519),
    [sym__string] = STATE(11519),
    [sym_string_literal] = STATE(11519),
    [sym_command_literal] = STATE(11519),
    [sym_prefixed_string_literal] = STATE(11519),
    [sym_prefixed_command_literal] = STATE(11519),
    [sym_operator] = STATE(18510),
    [sym__word_identifier] = ACTIONS(13284),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(14578),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(13288),
    [anon_sym_RPAREN] = ACTIONS(171),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(13290),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(171),
    [anon_sym_LBRACE] = ACTIONS(13292),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(14580),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(171),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_AT] = ACTIONS(13296),
    [anon_sym_true] = ACTIONS(13298),
    [anon_sym_false] = ACTIONS(13298),
    [sym_character_literal] = ACTIONS(14582),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(171),
    [sym__lazy_and_operator] = ACTIONS(171),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13302),
    [sym__command_start] = ACTIONS(13304),
  },
  [8192] = {
    [sym__word_identifier] = ACTIONS(13433),
    [anon_sym_EQ] = ACTIONS(13433),
    [anon_sym_COMMA] = ACTIONS(13433),
    [anon_sym_COLON] = ACTIONS(13433),
    [anon_sym_begin] = ACTIONS(13433),
    [anon_sym_module] = ACTIONS(13433),
    [anon_sym_baremodule] = ACTIONS(13433),
    [anon_sym_end] = ACTIONS(13433),
    [anon_sym_abstract] = ACTIONS(13433),
    [anon_sym_primitive] = ACTIONS(13433),
    [anon_sym_mutable] = ACTIONS(13433),
    [anon_sym_struct] = ACTIONS(13433),
    [anon_sym_function] = ACTIONS(13433),
    [anon_sym_macro] = ACTIONS(13433),
    [anon_sym_where] = ACTIONS(13433),
    [anon_sym_quote] = ACTIONS(13433),
    [anon_sym_let] = ACTIONS(13433),
    [anon_sym_if] = ACTIONS(13433),
    [anon_sym_try] = ACTIONS(13433),
    [anon_sym_finally] = ACTIONS(13433),
    [anon_sym_for] = ACTIONS(13433),
    [anon_sym_while] = ACTIONS(13433),
    [sym_break_statement] = ACTIONS(13433),
    [sym_continue_statement] = ACTIONS(13433),
    [anon_sym_return] = ACTIONS(13433),
    [anon_sym_const] = ACTIONS(13433),
    [anon_sym_global] = ACTIONS(13433),
    [anon_sym_local] = ACTIONS(13433),
    [anon_sym_LPAREN] = ACTIONS(13433),
    [anon_sym_COLON2] = ACTIONS(13433),
    [anon_sym_export] = ACTIONS(13433),
    [anon_sym_import] = ACTIONS(13433),
    [anon_sym_using] = ACTIONS(13433),
    [anon_sym_LBRACK] = ACTIONS(13433),
    [anon_sym_LF] = ACTIONS(13435),
    [anon_sym_in] = ACTIONS(13433),
    [anon_sym_LBRACE] = ACTIONS(13433),
    [anon_sym_DOLLAR] = ACTIONS(13433),
    [anon_sym_COLON_COLON] = ACTIONS(13433),
    [anon_sym_isa] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13433),
    [anon_sym_QMARK] = ACTIONS(13433),
    [anon_sym_AT] = ACTIONS(13433),
    [anon_sym_true] = ACTIONS(13433),
    [anon_sym_false] = ACTIONS(13433),
    [aux_sym_integer_literal_token1] = ACTIONS(13433),
    [aux_sym_integer_literal_token2] = ACTIONS(13433),
    [aux_sym_integer_literal_token3] = ACTIONS(13433),
    [aux_sym_integer_literal_token4] = ACTIONS(13433),
    [aux_sym_float_literal_token1] = ACTIONS(13433),
    [aux_sym_float_literal_token3] = ACTIONS(13433),
    [aux_sym_float_literal_token4] = ACTIONS(13433),
    [sym_character_literal] = ACTIONS(13433),
    [sym__pair_operator] = ACTIONS(13433),
    [sym__arrow_operator] = ACTIONS(13433),
    [sym__lazy_or_operator] = ACTIONS(13433),
    [sym__lazy_and_operator] = ACTIONS(13433),
    [sym__comparison_operator] = ACTIONS(13433),
    [sym__pipe_right_operator] = ACTIONS(13433),
    [sym__pipe_left_operator] = ACTIONS(13433),
    [sym__ellipsis_operator] = ACTIONS(13433),
    [sym__plus_operator] = ACTIONS(13433),
    [sym__times_operator] = ACTIONS(13433),
    [sym__rational_operator] = ACTIONS(13433),
    [sym__bitshift_operator] = ACTIONS(13433),
    [sym__power_operator] = ACTIONS(13433),
    [sym__tilde_operator] = ACTIONS(13433),
    [sym__type_order_operator] = ACTIONS(13433),
    [sym__unary_operator] = ACTIONS(13433),
    [sym__unary_plus_operator] = ACTIONS(13433),
    [aux_sym__terminator_token1] = ACTIONS(13433),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13435),
    [sym__command_start] = ACTIONS(13435),
  },
  [8193] = {
    [sym__word_identifier] = ACTIONS(13437),
    [anon_sym_EQ] = ACTIONS(13437),
    [anon_sym_COMMA] = ACTIONS(13437),
    [anon_sym_COLON] = ACTIONS(13437),
    [anon_sym_begin] = ACTIONS(13437),
    [anon_sym_module] = ACTIONS(13437),
    [anon_sym_baremodule] = ACTIONS(13437),
    [anon_sym_end] = ACTIONS(13437),
    [anon_sym_abstract] = ACTIONS(13437),
    [anon_sym_primitive] = ACTIONS(13437),
    [anon_sym_mutable] = ACTIONS(13437),
    [anon_sym_struct] = ACTIONS(13437),
    [anon_sym_function] = ACTIONS(13437),
    [anon_sym_macro] = ACTIONS(13437),
    [anon_sym_where] = ACTIONS(13437),
    [anon_sym_quote] = ACTIONS(13437),
    [anon_sym_let] = ACTIONS(13437),
    [anon_sym_if] = ACTIONS(13437),
    [anon_sym_try] = ACTIONS(13437),
    [anon_sym_finally] = ACTIONS(13437),
    [anon_sym_for] = ACTIONS(13437),
    [anon_sym_while] = ACTIONS(13437),
    [sym_break_statement] = ACTIONS(13437),
    [sym_continue_statement] = ACTIONS(13437),
    [anon_sym_return] = ACTIONS(13437),
    [anon_sym_const] = ACTIONS(13437),
    [anon_sym_global] = ACTIONS(13437),
    [anon_sym_local] = ACTIONS(13437),
    [anon_sym_LPAREN] = ACTIONS(13437),
    [anon_sym_COLON2] = ACTIONS(13437),
    [anon_sym_export] = ACTIONS(13437),
    [anon_sym_import] = ACTIONS(13437),
    [anon_sym_using] = ACTIONS(13437),
    [anon_sym_LBRACK] = ACTIONS(13437),
    [anon_sym_LF] = ACTIONS(13439),
    [anon_sym_in] = ACTIONS(13437),
    [anon_sym_LBRACE] = ACTIONS(13437),
    [anon_sym_DOLLAR] = ACTIONS(13437),
    [anon_sym_COLON_COLON] = ACTIONS(13437),
    [anon_sym_isa] = ACTIONS(13437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13437),
    [anon_sym_QMARK] = ACTIONS(13437),
    [anon_sym_AT] = ACTIONS(13437),
    [anon_sym_true] = ACTIONS(13437),
    [anon_sym_false] = ACTIONS(13437),
    [aux_sym_integer_literal_token1] = ACTIONS(13437),
    [aux_sym_integer_literal_token2] = ACTIONS(13437),
    [aux_sym_integer_literal_token3] = ACTIONS(13437),
    [aux_sym_integer_literal_token4] = ACTIONS(13437),
    [aux_sym_float_literal_token1] = ACTIONS(13437),
    [aux_sym_float_literal_token3] = ACTIONS(13437),
    [aux_sym_float_literal_token4] = ACTIONS(13437),
    [sym_character_literal] = ACTIONS(13437),
    [sym__pair_operator] = ACTIONS(13437),
    [sym__arrow_operator] = ACTIONS(13437),
    [sym__lazy_or_operator] = ACTIONS(13437),
    [sym__lazy_and_operator] = ACTIONS(13437),
    [sym__comparison_operator] = ACTIONS(13437),
    [sym__pipe_right_operator] = ACTIONS(13437),
    [sym__pipe_left_operator] = ACTIONS(13437),
    [sym__ellipsis_operator] = ACTIONS(13437),
    [sym__plus_operator] = ACTIONS(13437),
    [sym__times_operator] = ACTIONS(13437),
    [sym__rational_operator] = ACTIONS(13437),
    [sym__bitshift_operator] = ACTIONS(13437),
    [sym__power_operator] = ACTIONS(13437),
    [sym__tilde_operator] = ACTIONS(13437),
    [sym__type_order_operator] = ACTIONS(13437),
    [sym__unary_operator] = ACTIONS(13437),
    [sym__unary_plus_operator] = ACTIONS(13437),
    [aux_sym__terminator_token1] = ACTIONS(13437),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13439),
    [sym__command_start] = ACTIONS(13439),
  },
  [8194] = {
    [sym__word_identifier] = ACTIONS(13441),
    [anon_sym_EQ] = ACTIONS(13441),
    [anon_sym_COMMA] = ACTIONS(13441),
    [anon_sym_COLON] = ACTIONS(13441),
    [anon_sym_begin] = ACTIONS(13441),
    [anon_sym_module] = ACTIONS(13441),
    [anon_sym_baremodule] = ACTIONS(13441),
    [anon_sym_end] = ACTIONS(13441),
    [anon_sym_abstract] = ACTIONS(13441),
    [anon_sym_primitive] = ACTIONS(13441),
    [anon_sym_mutable] = ACTIONS(13441),
    [anon_sym_struct] = ACTIONS(13441),
    [anon_sym_function] = ACTIONS(13441),
    [anon_sym_macro] = ACTIONS(13441),
    [anon_sym_where] = ACTIONS(13441),
    [anon_sym_quote] = ACTIONS(13441),
    [anon_sym_let] = ACTIONS(13441),
    [anon_sym_if] = ACTIONS(13441),
    [anon_sym_try] = ACTIONS(13441),
    [anon_sym_finally] = ACTIONS(13441),
    [anon_sym_for] = ACTIONS(13441),
    [anon_sym_while] = ACTIONS(13441),
    [sym_break_statement] = ACTIONS(13441),
    [sym_continue_statement] = ACTIONS(13441),
    [anon_sym_return] = ACTIONS(13441),
    [anon_sym_const] = ACTIONS(13441),
    [anon_sym_global] = ACTIONS(13441),
    [anon_sym_local] = ACTIONS(13441),
    [anon_sym_LPAREN] = ACTIONS(13441),
    [anon_sym_COLON2] = ACTIONS(13441),
    [anon_sym_export] = ACTIONS(13441),
    [anon_sym_import] = ACTIONS(13441),
    [anon_sym_using] = ACTIONS(13441),
    [anon_sym_LBRACK] = ACTIONS(13441),
    [anon_sym_LF] = ACTIONS(13443),
    [anon_sym_in] = ACTIONS(13441),
    [anon_sym_LBRACE] = ACTIONS(13441),
    [anon_sym_DOLLAR] = ACTIONS(13441),
    [anon_sym_COLON_COLON] = ACTIONS(13441),
    [anon_sym_isa] = ACTIONS(13441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13441),
    [anon_sym_QMARK] = ACTIONS(13441),
    [anon_sym_AT] = ACTIONS(13441),
    [anon_sym_true] = ACTIONS(13441),
    [anon_sym_false] = ACTIONS(13441),
    [aux_sym_integer_literal_token1] = ACTIONS(13441),
    [aux_sym_integer_literal_token2] = ACTIONS(13441),
    [aux_sym_integer_literal_token3] = ACTIONS(13441),
    [aux_sym_integer_literal_token4] = ACTIONS(13441),
    [aux_sym_float_literal_token1] = ACTIONS(13441),
    [aux_sym_float_literal_token3] = ACTIONS(13441),
    [aux_sym_float_literal_token4] = ACTIONS(13441),
    [sym_character_literal] = ACTIONS(13441),
    [sym__pair_operator] = ACTIONS(13441),
    [sym__arrow_operator] = ACTIONS(13441),
    [sym__lazy_or_operator] = ACTIONS(13441),
    [sym__lazy_and_operator] = ACTIONS(13441),
    [sym__comparison_operator] = ACTIONS(13441),
    [sym__pipe_right_operator] = ACTIONS(13441),
    [sym__pipe_left_operator] = ACTIONS(13441),
    [sym__ellipsis_operator] = ACTIONS(13441),
    [sym__plus_operator] = ACTIONS(13441),
    [sym__times_operator] = ACTIONS(13441),
    [sym__rational_operator] = ACTIONS(13441),
    [sym__bitshift_operator] = ACTIONS(13441),
    [sym__power_operator] = ACTIONS(13441),
    [sym__tilde_operator] = ACTIONS(13441),
    [sym__type_order_operator] = ACTIONS(13441),
    [sym__unary_operator] = ACTIONS(13441),
    [sym__unary_plus_operator] = ACTIONS(13441),
    [aux_sym__terminator_token1] = ACTIONS(13441),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13443),
    [sym__command_start] = ACTIONS(13443),
  },
  [8195] = {
    [sym__word_identifier] = ACTIONS(13445),
    [anon_sym_EQ] = ACTIONS(13445),
    [anon_sym_COMMA] = ACTIONS(13445),
    [anon_sym_COLON] = ACTIONS(13445),
    [anon_sym_begin] = ACTIONS(13445),
    [anon_sym_module] = ACTIONS(13445),
    [anon_sym_baremodule] = ACTIONS(13445),
    [anon_sym_end] = ACTIONS(13445),
    [anon_sym_abstract] = ACTIONS(13445),
    [anon_sym_primitive] = ACTIONS(13445),
    [anon_sym_mutable] = ACTIONS(13445),
    [anon_sym_struct] = ACTIONS(13445),
    [anon_sym_function] = ACTIONS(13445),
    [anon_sym_macro] = ACTIONS(13445),
    [anon_sym_where] = ACTIONS(13445),
    [anon_sym_quote] = ACTIONS(13445),
    [anon_sym_let] = ACTIONS(13445),
    [anon_sym_if] = ACTIONS(13445),
    [anon_sym_try] = ACTIONS(13445),
    [anon_sym_finally] = ACTIONS(13445),
    [anon_sym_for] = ACTIONS(13445),
    [anon_sym_while] = ACTIONS(13445),
    [sym_break_statement] = ACTIONS(13445),
    [sym_continue_statement] = ACTIONS(13445),
    [anon_sym_return] = ACTIONS(13445),
    [anon_sym_const] = ACTIONS(13445),
    [anon_sym_global] = ACTIONS(13445),
    [anon_sym_local] = ACTIONS(13445),
    [anon_sym_LPAREN] = ACTIONS(13445),
    [anon_sym_COLON2] = ACTIONS(13445),
    [anon_sym_export] = ACTIONS(13445),
    [anon_sym_import] = ACTIONS(13445),
    [anon_sym_using] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(13445),
    [anon_sym_LF] = ACTIONS(13447),
    [anon_sym_in] = ACTIONS(13445),
    [anon_sym_LBRACE] = ACTIONS(13445),
    [anon_sym_DOLLAR] = ACTIONS(13445),
    [anon_sym_COLON_COLON] = ACTIONS(13445),
    [anon_sym_isa] = ACTIONS(13445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13445),
    [anon_sym_QMARK] = ACTIONS(13445),
    [anon_sym_AT] = ACTIONS(13445),
    [anon_sym_true] = ACTIONS(13445),
    [anon_sym_false] = ACTIONS(13445),
    [aux_sym_integer_literal_token1] = ACTIONS(13445),
    [aux_sym_integer_literal_token2] = ACTIONS(13445),
    [aux_sym_integer_literal_token3] = ACTIONS(13445),
    [aux_sym_integer_literal_token4] = ACTIONS(13445),
    [aux_sym_float_literal_token1] = ACTIONS(13445),
    [aux_sym_float_literal_token3] = ACTIONS(13445),
    [aux_sym_float_literal_token4] = ACTIONS(13445),
    [sym_character_literal] = ACTIONS(13445),
    [sym__pair_operator] = ACTIONS(13445),
    [sym__arrow_operator] = ACTIONS(13445),
    [sym__lazy_or_operator] = ACTIONS(13445),
    [sym__lazy_and_operator] = ACTIONS(13445),
    [sym__comparison_operator] = ACTIONS(13445),
    [sym__pipe_right_operator] = ACTIONS(13445),
    [sym__pipe_left_operator] = ACTIONS(13445),
    [sym__ellipsis_operator] = ACTIONS(13445),
    [sym__plus_operator] = ACTIONS(13445),
    [sym__times_operator] = ACTIONS(13445),
    [sym__rational_operator] = ACTIONS(13445),
    [sym__bitshift_operator] = ACTIONS(13445),
    [sym__power_operator] = ACTIONS(13445),
    [sym__tilde_operator] = ACTIONS(13445),
    [sym__type_order_operator] = ACTIONS(13445),
    [sym__unary_operator] = ACTIONS(13445),
    [sym__unary_plus_operator] = ACTIONS(13445),
    [aux_sym__terminator_token1] = ACTIONS(13445),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13447),
    [sym__command_start] = ACTIONS(13447),
  },
  [8196] = {
    [sym__word_identifier] = ACTIONS(13449),
    [anon_sym_EQ] = ACTIONS(13449),
    [anon_sym_COMMA] = ACTIONS(13449),
    [anon_sym_COLON] = ACTIONS(13449),
    [anon_sym_begin] = ACTIONS(13449),
    [anon_sym_module] = ACTIONS(13449),
    [anon_sym_baremodule] = ACTIONS(13449),
    [anon_sym_end] = ACTIONS(13449),
    [anon_sym_abstract] = ACTIONS(13449),
    [anon_sym_primitive] = ACTIONS(13449),
    [anon_sym_mutable] = ACTIONS(13449),
    [anon_sym_struct] = ACTIONS(13449),
    [anon_sym_function] = ACTIONS(13449),
    [anon_sym_macro] = ACTIONS(13449),
    [anon_sym_where] = ACTIONS(13449),
    [anon_sym_quote] = ACTIONS(13449),
    [anon_sym_let] = ACTIONS(13449),
    [anon_sym_if] = ACTIONS(13449),
    [anon_sym_try] = ACTIONS(13449),
    [anon_sym_finally] = ACTIONS(13449),
    [anon_sym_for] = ACTIONS(13449),
    [anon_sym_while] = ACTIONS(13449),
    [sym_break_statement] = ACTIONS(13449),
    [sym_continue_statement] = ACTIONS(13449),
    [anon_sym_return] = ACTIONS(13449),
    [anon_sym_const] = ACTIONS(13449),
    [anon_sym_global] = ACTIONS(13449),
    [anon_sym_local] = ACTIONS(13449),
    [anon_sym_LPAREN] = ACTIONS(13449),
    [anon_sym_COLON2] = ACTIONS(13449),
    [anon_sym_export] = ACTIONS(13449),
    [anon_sym_import] = ACTIONS(13449),
    [anon_sym_using] = ACTIONS(13449),
    [anon_sym_LBRACK] = ACTIONS(13449),
    [anon_sym_LF] = ACTIONS(13451),
    [anon_sym_in] = ACTIONS(13449),
    [anon_sym_LBRACE] = ACTIONS(13449),
    [anon_sym_DOLLAR] = ACTIONS(13449),
    [anon_sym_COLON_COLON] = ACTIONS(13449),
    [anon_sym_isa] = ACTIONS(13449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13449),
    [anon_sym_QMARK] = ACTIONS(13449),
    [anon_sym_AT] = ACTIONS(13449),
    [anon_sym_true] = ACTIONS(13449),
    [anon_sym_false] = ACTIONS(13449),
    [aux_sym_integer_literal_token1] = ACTIONS(13449),
    [aux_sym_integer_literal_token2] = ACTIONS(13449),
    [aux_sym_integer_literal_token3] = ACTIONS(13449),
    [aux_sym_integer_literal_token4] = ACTIONS(13449),
    [aux_sym_float_literal_token1] = ACTIONS(13449),
    [aux_sym_float_literal_token3] = ACTIONS(13449),
    [aux_sym_float_literal_token4] = ACTIONS(13449),
    [sym_character_literal] = ACTIONS(13449),
    [sym__pair_operator] = ACTIONS(13449),
    [sym__arrow_operator] = ACTIONS(13449),
    [sym__lazy_or_operator] = ACTIONS(13449),
    [sym__lazy_and_operator] = ACTIONS(13449),
    [sym__comparison_operator] = ACTIONS(13449),
    [sym__pipe_right_operator] = ACTIONS(13449),
    [sym__pipe_left_operator] = ACTIONS(13449),
    [sym__ellipsis_operator] = ACTIONS(13449),
    [sym__plus_operator] = ACTIONS(13449),
    [sym__times_operator] = ACTIONS(13449),
    [sym__rational_operator] = ACTIONS(13449),
    [sym__bitshift_operator] = ACTIONS(13449),
    [sym__power_operator] = ACTIONS(13449),
    [sym__tilde_operator] = ACTIONS(13449),
    [sym__type_order_operator] = ACTIONS(13449),
    [sym__unary_operator] = ACTIONS(13449),
    [sym__unary_plus_operator] = ACTIONS(13449),
    [aux_sym__terminator_token1] = ACTIONS(13449),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13451),
    [sym__command_start] = ACTIONS(13451),
  },
  [8197] = {
    [sym__word_identifier] = ACTIONS(13453),
    [anon_sym_EQ] = ACTIONS(13453),
    [anon_sym_COMMA] = ACTIONS(13453),
    [anon_sym_COLON] = ACTIONS(13453),
    [anon_sym_begin] = ACTIONS(13453),
    [anon_sym_module] = ACTIONS(13453),
    [anon_sym_baremodule] = ACTIONS(13453),
    [anon_sym_end] = ACTIONS(13453),
    [anon_sym_abstract] = ACTIONS(13453),
    [anon_sym_primitive] = ACTIONS(13453),
    [anon_sym_mutable] = ACTIONS(13453),
    [anon_sym_struct] = ACTIONS(13453),
    [anon_sym_function] = ACTIONS(13453),
    [anon_sym_macro] = ACTIONS(13453),
    [anon_sym_where] = ACTIONS(13453),
    [anon_sym_quote] = ACTIONS(13453),
    [anon_sym_let] = ACTIONS(13453),
    [anon_sym_if] = ACTIONS(13453),
    [anon_sym_try] = ACTIONS(13453),
    [anon_sym_finally] = ACTIONS(13453),
    [anon_sym_for] = ACTIONS(13453),
    [anon_sym_while] = ACTIONS(13453),
    [sym_break_statement] = ACTIONS(13453),
    [sym_continue_statement] = ACTIONS(13453),
    [anon_sym_return] = ACTIONS(13453),
    [anon_sym_const] = ACTIONS(13453),
    [anon_sym_global] = ACTIONS(13453),
    [anon_sym_local] = ACTIONS(13453),
    [anon_sym_LPAREN] = ACTIONS(13453),
    [anon_sym_COLON2] = ACTIONS(13453),
    [anon_sym_export] = ACTIONS(13453),
    [anon_sym_import] = ACTIONS(13453),
    [anon_sym_using] = ACTIONS(13453),
    [anon_sym_LBRACK] = ACTIONS(13453),
    [anon_sym_LF] = ACTIONS(13455),
    [anon_sym_in] = ACTIONS(13453),
    [anon_sym_LBRACE] = ACTIONS(13453),
    [anon_sym_DOLLAR] = ACTIONS(13453),
    [anon_sym_COLON_COLON] = ACTIONS(13453),
    [anon_sym_isa] = ACTIONS(13453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13453),
    [anon_sym_QMARK] = ACTIONS(13453),
    [anon_sym_AT] = ACTIONS(13453),
    [anon_sym_true] = ACTIONS(13453),
    [anon_sym_false] = ACTIONS(13453),
    [aux_sym_integer_literal_token1] = ACTIONS(13453),
    [aux_sym_integer_literal_token2] = ACTIONS(13453),
    [aux_sym_integer_literal_token3] = ACTIONS(13453),
    [aux_sym_integer_literal_token4] = ACTIONS(13453),
    [aux_sym_float_literal_token1] = ACTIONS(13453),
    [aux_sym_float_literal_token3] = ACTIONS(13453),
    [aux_sym_float_literal_token4] = ACTIONS(13453),
    [sym_character_literal] = ACTIONS(13453),
    [sym__pair_operator] = ACTIONS(13453),
    [sym__arrow_operator] = ACTIONS(13453),
    [sym__lazy_or_operator] = ACTIONS(13453),
    [sym__lazy_and_operator] = ACTIONS(13453),
    [sym__comparison_operator] = ACTIONS(13453),
    [sym__pipe_right_operator] = ACTIONS(13453),
    [sym__pipe_left_operator] = ACTIONS(13453),
    [sym__ellipsis_operator] = ACTIONS(13453),
    [sym__plus_operator] = ACTIONS(13453),
    [sym__times_operator] = ACTIONS(13453),
    [sym__rational_operator] = ACTIONS(13453),
    [sym__bitshift_operator] = ACTIONS(13453),
    [sym__power_operator] = ACTIONS(13453),
    [sym__tilde_operator] = ACTIONS(13453),
    [sym__type_order_operator] = ACTIONS(13453),
    [sym__unary_operator] = ACTIONS(13453),
    [sym__unary_plus_operator] = ACTIONS(13453),
    [aux_sym__terminator_token1] = ACTIONS(13453),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13455),
    [sym__command_start] = ACTIONS(13455),
  },
  [8198] = {
    [sym__word_identifier] = ACTIONS(13457),
    [anon_sym_EQ] = ACTIONS(13457),
    [anon_sym_COMMA] = ACTIONS(13457),
    [anon_sym_COLON] = ACTIONS(13457),
    [anon_sym_begin] = ACTIONS(13457),
    [anon_sym_module] = ACTIONS(13457),
    [anon_sym_baremodule] = ACTIONS(13457),
    [anon_sym_end] = ACTIONS(13457),
    [anon_sym_abstract] = ACTIONS(13457),
    [anon_sym_primitive] = ACTIONS(13457),
    [anon_sym_mutable] = ACTIONS(13457),
    [anon_sym_struct] = ACTIONS(13457),
    [anon_sym_function] = ACTIONS(13457),
    [anon_sym_macro] = ACTIONS(13457),
    [anon_sym_where] = ACTIONS(13457),
    [anon_sym_quote] = ACTIONS(13457),
    [anon_sym_let] = ACTIONS(13457),
    [anon_sym_if] = ACTIONS(13457),
    [anon_sym_try] = ACTIONS(13457),
    [anon_sym_finally] = ACTIONS(13457),
    [anon_sym_for] = ACTIONS(13457),
    [anon_sym_while] = ACTIONS(13457),
    [sym_break_statement] = ACTIONS(13457),
    [sym_continue_statement] = ACTIONS(13457),
    [anon_sym_return] = ACTIONS(13457),
    [anon_sym_const] = ACTIONS(13457),
    [anon_sym_global] = ACTIONS(13457),
    [anon_sym_local] = ACTIONS(13457),
    [anon_sym_LPAREN] = ACTIONS(13457),
    [anon_sym_COLON2] = ACTIONS(13457),
    [anon_sym_export] = ACTIONS(13457),
    [anon_sym_import] = ACTIONS(13457),
    [anon_sym_using] = ACTIONS(13457),
    [anon_sym_LBRACK] = ACTIONS(13457),
    [anon_sym_LF] = ACTIONS(13459),
    [anon_sym_in] = ACTIONS(13457),
    [anon_sym_LBRACE] = ACTIONS(13457),
    [anon_sym_DOLLAR] = ACTIONS(13457),
    [anon_sym_COLON_COLON] = ACTIONS(13457),
    [anon_sym_isa] = ACTIONS(13457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13457),
    [anon_sym_QMARK] = ACTIONS(13457),
    [anon_sym_AT] = ACTIONS(13457),
    [anon_sym_true] = ACTIONS(13457),
    [anon_sym_false] = ACTIONS(13457),
    [aux_sym_integer_literal_token1] = ACTIONS(13457),
    [aux_sym_integer_literal_token2] = ACTIONS(13457),
    [aux_sym_integer_literal_token3] = ACTIONS(13457),
    [aux_sym_integer_literal_token4] = ACTIONS(13457),
    [aux_sym_float_literal_token1] = ACTIONS(13457),
    [aux_sym_float_literal_token3] = ACTIONS(13457),
    [aux_sym_float_literal_token4] = ACTIONS(13457),
    [sym_character_literal] = ACTIONS(13457),
    [sym__pair_operator] = ACTIONS(13457),
    [sym__arrow_operator] = ACTIONS(13457),
    [sym__lazy_or_operator] = ACTIONS(13457),
    [sym__lazy_and_operator] = ACTIONS(13457),
    [sym__comparison_operator] = ACTIONS(13457),
    [sym__pipe_right_operator] = ACTIONS(13457),
    [sym__pipe_left_operator] = ACTIONS(13457),
    [sym__ellipsis_operator] = ACTIONS(13457),
    [sym__plus_operator] = ACTIONS(13457),
    [sym__times_operator] = ACTIONS(13457),
    [sym__rational_operator] = ACTIONS(13457),
    [sym__bitshift_operator] = ACTIONS(13457),
    [sym__power_operator] = ACTIONS(13457),
    [sym__tilde_operator] = ACTIONS(13457),
    [sym__type_order_operator] = ACTIONS(13457),
    [sym__unary_operator] = ACTIONS(13457),
    [sym__unary_plus_operator] = ACTIONS(13457),
    [aux_sym__terminator_token1] = ACTIONS(13457),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13459),
    [sym__command_start] = ACTIONS(13459),
  },
  [8199] = {
    [sym__word_identifier] = ACTIONS(13461),
    [anon_sym_EQ] = ACTIONS(13461),
    [anon_sym_COMMA] = ACTIONS(13461),
    [anon_sym_COLON] = ACTIONS(13461),
    [anon_sym_begin] = ACTIONS(13461),
    [anon_sym_module] = ACTIONS(13461),
    [anon_sym_baremodule] = ACTIONS(13461),
    [anon_sym_end] = ACTIONS(13461),
    [anon_sym_abstract] = ACTIONS(13461),
    [anon_sym_primitive] = ACTIONS(13461),
    [anon_sym_mutable] = ACTIONS(13461),
    [anon_sym_struct] = ACTIONS(13461),
    [anon_sym_function] = ACTIONS(13461),
    [anon_sym_macro] = ACTIONS(13461),
    [anon_sym_where] = ACTIONS(13461),
    [anon_sym_quote] = ACTIONS(13461),
    [anon_sym_let] = ACTIONS(13461),
    [anon_sym_if] = ACTIONS(13461),
    [anon_sym_try] = ACTIONS(13461),
    [anon_sym_finally] = ACTIONS(13461),
    [anon_sym_for] = ACTIONS(13461),
    [anon_sym_while] = ACTIONS(13461),
    [sym_break_statement] = ACTIONS(13461),
    [sym_continue_statement] = ACTIONS(13461),
    [anon_sym_return] = ACTIONS(13461),
    [anon_sym_const] = ACTIONS(13461),
    [anon_sym_global] = ACTIONS(13461),
    [anon_sym_local] = ACTIONS(13461),
    [anon_sym_LPAREN] = ACTIONS(13461),
    [anon_sym_COLON2] = ACTIONS(13461),
    [anon_sym_export] = ACTIONS(13461),
    [anon_sym_import] = ACTIONS(13461),
    [anon_sym_using] = ACTIONS(13461),
    [anon_sym_LBRACK] = ACTIONS(13461),
    [anon_sym_LF] = ACTIONS(13463),
    [anon_sym_in] = ACTIONS(13461),
    [anon_sym_LBRACE] = ACTIONS(13461),
    [anon_sym_DOLLAR] = ACTIONS(13461),
    [anon_sym_COLON_COLON] = ACTIONS(13461),
    [anon_sym_isa] = ACTIONS(13461),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13461),
    [anon_sym_QMARK] = ACTIONS(13461),
    [anon_sym_AT] = ACTIONS(13461),
    [anon_sym_true] = ACTIONS(13461),
    [anon_sym_false] = ACTIONS(13461),
    [aux_sym_integer_literal_token1] = ACTIONS(13461),
    [aux_sym_integer_literal_token2] = ACTIONS(13461),
    [aux_sym_integer_literal_token3] = ACTIONS(13461),
    [aux_sym_integer_literal_token4] = ACTIONS(13461),
    [aux_sym_float_literal_token1] = ACTIONS(13461),
    [aux_sym_float_literal_token3] = ACTIONS(13461),
    [aux_sym_float_literal_token4] = ACTIONS(13461),
    [sym_character_literal] = ACTIONS(13461),
    [sym__pair_operator] = ACTIONS(13461),
    [sym__arrow_operator] = ACTIONS(13461),
    [sym__lazy_or_operator] = ACTIONS(13461),
    [sym__lazy_and_operator] = ACTIONS(13461),
    [sym__comparison_operator] = ACTIONS(13461),
    [sym__pipe_right_operator] = ACTIONS(13461),
    [sym__pipe_left_operator] = ACTIONS(13461),
    [sym__ellipsis_operator] = ACTIONS(13461),
    [sym__plus_operator] = ACTIONS(13461),
    [sym__times_operator] = ACTIONS(13461),
    [sym__rational_operator] = ACTIONS(13461),
    [sym__bitshift_operator] = ACTIONS(13461),
    [sym__power_operator] = ACTIONS(13461),
    [sym__tilde_operator] = ACTIONS(13461),
    [sym__type_order_operator] = ACTIONS(13461),
    [sym__unary_operator] = ACTIONS(13461),
    [sym__unary_plus_operator] = ACTIONS(13461),
    [aux_sym__terminator_token1] = ACTIONS(13461),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13463),
    [sym__command_start] = ACTIONS(13463),
  },
  [8200] = {
    [sym__word_identifier] = ACTIONS(13481),
    [anon_sym_EQ] = ACTIONS(13481),
    [anon_sym_COMMA] = ACTIONS(13481),
    [anon_sym_COLON] = ACTIONS(13481),
    [anon_sym_begin] = ACTIONS(13481),
    [anon_sym_module] = ACTIONS(13481),
    [anon_sym_baremodule] = ACTIONS(13481),
    [anon_sym_end] = ACTIONS(13481),
    [anon_sym_abstract] = ACTIONS(13481),
    [anon_sym_primitive] = ACTIONS(13481),
    [anon_sym_mutable] = ACTIONS(13481),
    [anon_sym_struct] = ACTIONS(13481),
    [anon_sym_function] = ACTIONS(13481),
    [anon_sym_macro] = ACTIONS(13481),
    [anon_sym_where] = ACTIONS(13481),
    [anon_sym_quote] = ACTIONS(13481),
    [anon_sym_let] = ACTIONS(13481),
    [anon_sym_if] = ACTIONS(13481),
    [anon_sym_try] = ACTIONS(13481),
    [anon_sym_finally] = ACTIONS(13481),
    [anon_sym_for] = ACTIONS(13481),
    [anon_sym_while] = ACTIONS(13481),
    [sym_break_statement] = ACTIONS(13481),
    [sym_continue_statement] = ACTIONS(13481),
    [anon_sym_return] = ACTIONS(13481),
    [anon_sym_const] = ACTIONS(13481),
    [anon_sym_global] = ACTIONS(13481),
    [anon_sym_local] = ACTIONS(13481),
    [anon_sym_LPAREN] = ACTIONS(13481),
    [anon_sym_COLON2] = ACTIONS(13481),
    [anon_sym_export] = ACTIONS(13481),
    [anon_sym_import] = ACTIONS(13481),
    [anon_sym_using] = ACTIONS(13481),
    [anon_sym_LBRACK] = ACTIONS(13481),
    [anon_sym_LF] = ACTIONS(13483),
    [anon_sym_in] = ACTIONS(13481),
    [anon_sym_LBRACE] = ACTIONS(13481),
    [anon_sym_DOLLAR] = ACTIONS(13481),
    [anon_sym_COLON_COLON] = ACTIONS(13481),
    [anon_sym_isa] = ACTIONS(13481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13481),
    [anon_sym_QMARK] = ACTIONS(13481),
    [anon_sym_AT] = ACTIONS(13481),
    [anon_sym_true] = ACTIONS(13481),
    [anon_sym_false] = ACTIONS(13481),
    [aux_sym_integer_literal_token1] = ACTIONS(13481),
    [aux_sym_integer_literal_token2] = ACTIONS(13481),
    [aux_sym_integer_literal_token3] = ACTIONS(13481),
    [aux_sym_integer_literal_token4] = ACTIONS(13481),
    [aux_sym_float_literal_token1] = ACTIONS(13481),
    [aux_sym_float_literal_token3] = ACTIONS(13481),
    [aux_sym_float_literal_token4] = ACTIONS(13481),
    [sym_character_literal] = ACTIONS(13481),
    [sym__pair_operator] = ACTIONS(13481),
    [sym__arrow_operator] = ACTIONS(13481),
    [sym__lazy_or_operator] = ACTIONS(13481),
    [sym__lazy_and_operator] = ACTIONS(13481),
    [sym__comparison_operator] = ACTIONS(13481),
    [sym__pipe_right_operator] = ACTIONS(13481),
    [sym__pipe_left_operator] = ACTIONS(13481),
    [sym__ellipsis_operator] = ACTIONS(13481),
    [sym__plus_operator] = ACTIONS(13481),
    [sym__times_operator] = ACTIONS(13481),
    [sym__rational_operator] = ACTIONS(13481),
    [sym__bitshift_operator] = ACTIONS(13481),
    [sym__power_operator] = ACTIONS(13481),
    [sym__tilde_operator] = ACTIONS(13481),
    [sym__type_order_operator] = ACTIONS(13481),
    [sym__unary_operator] = ACTIONS(13481),
    [sym__unary_plus_operator] = ACTIONS(13481),
    [aux_sym__terminator_token1] = ACTIONS(13481),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13483),
    [sym__command_start] = ACTIONS(13483),
  },
  [8201] = {
    [sym__word_identifier] = ACTIONS(13485),
    [anon_sym_EQ] = ACTIONS(13485),
    [anon_sym_COMMA] = ACTIONS(13485),
    [anon_sym_COLON] = ACTIONS(13485),
    [anon_sym_begin] = ACTIONS(13485),
    [anon_sym_module] = ACTIONS(13485),
    [anon_sym_baremodule] = ACTIONS(13485),
    [anon_sym_end] = ACTIONS(13485),
    [anon_sym_abstract] = ACTIONS(13485),
    [anon_sym_primitive] = ACTIONS(13485),
    [anon_sym_mutable] = ACTIONS(13485),
    [anon_sym_struct] = ACTIONS(13485),
    [anon_sym_function] = ACTIONS(13485),
    [anon_sym_macro] = ACTIONS(13485),
    [anon_sym_where] = ACTIONS(13485),
    [anon_sym_quote] = ACTIONS(13485),
    [anon_sym_let] = ACTIONS(13485),
    [anon_sym_if] = ACTIONS(13485),
    [anon_sym_try] = ACTIONS(13485),
    [anon_sym_finally] = ACTIONS(13485),
    [anon_sym_for] = ACTIONS(13485),
    [anon_sym_while] = ACTIONS(13485),
    [sym_break_statement] = ACTIONS(13485),
    [sym_continue_statement] = ACTIONS(13485),
    [anon_sym_return] = ACTIONS(13485),
    [anon_sym_const] = ACTIONS(13485),
    [anon_sym_global] = ACTIONS(13485),
    [anon_sym_local] = ACTIONS(13485),
    [anon_sym_LPAREN] = ACTIONS(13485),
    [anon_sym_COLON2] = ACTIONS(13485),
    [anon_sym_export] = ACTIONS(13485),
    [anon_sym_import] = ACTIONS(13485),
    [anon_sym_using] = ACTIONS(13485),
    [anon_sym_LBRACK] = ACTIONS(13485),
    [anon_sym_LF] = ACTIONS(13487),
    [anon_sym_in] = ACTIONS(13485),
    [anon_sym_LBRACE] = ACTIONS(13485),
    [anon_sym_DOLLAR] = ACTIONS(13485),
    [anon_sym_COLON_COLON] = ACTIONS(13485),
    [anon_sym_isa] = ACTIONS(13485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13485),
    [anon_sym_QMARK] = ACTIONS(13485),
    [anon_sym_AT] = ACTIONS(13485),
    [anon_sym_true] = ACTIONS(13485),
    [anon_sym_false] = ACTIONS(13485),
    [aux_sym_integer_literal_token1] = ACTIONS(13485),
    [aux_sym_integer_literal_token2] = ACTIONS(13485),
    [aux_sym_integer_literal_token3] = ACTIONS(13485),
    [aux_sym_integer_literal_token4] = ACTIONS(13485),
    [aux_sym_float_literal_token1] = ACTIONS(13485),
    [aux_sym_float_literal_token3] = ACTIONS(13485),
    [aux_sym_float_literal_token4] = ACTIONS(13485),
    [sym_character_literal] = ACTIONS(13485),
    [sym__pair_operator] = ACTIONS(13485),
    [sym__arrow_operator] = ACTIONS(13485),
    [sym__lazy_or_operator] = ACTIONS(13485),
    [sym__lazy_and_operator] = ACTIONS(13485),
    [sym__comparison_operator] = ACTIONS(13485),
    [sym__pipe_right_operator] = ACTIONS(13485),
    [sym__pipe_left_operator] = ACTIONS(13485),
    [sym__ellipsis_operator] = ACTIONS(13485),
    [sym__plus_operator] = ACTIONS(13485),
    [sym__times_operator] = ACTIONS(13485),
    [sym__rational_operator] = ACTIONS(13485),
    [sym__bitshift_operator] = ACTIONS(13485),
    [sym__power_operator] = ACTIONS(13485),
    [sym__tilde_operator] = ACTIONS(13485),
    [sym__type_order_operator] = ACTIONS(13485),
    [sym__unary_operator] = ACTIONS(13485),
    [sym__unary_plus_operator] = ACTIONS(13485),
    [aux_sym__terminator_token1] = ACTIONS(13485),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13487),
    [sym__command_start] = ACTIONS(13487),
  },
  [8202] = {
    [sym__word_identifier] = ACTIONS(13514),
    [anon_sym_EQ] = ACTIONS(13514),
    [anon_sym_COMMA] = ACTIONS(13516),
    [anon_sym_COLON] = ACTIONS(13514),
    [anon_sym_begin] = ACTIONS(13514),
    [anon_sym_module] = ACTIONS(13514),
    [anon_sym_baremodule] = ACTIONS(13514),
    [anon_sym_abstract] = ACTIONS(13514),
    [anon_sym_primitive] = ACTIONS(13514),
    [anon_sym_mutable] = ACTIONS(13514),
    [anon_sym_struct] = ACTIONS(13514),
    [anon_sym_function] = ACTIONS(13514),
    [anon_sym_macro] = ACTIONS(13514),
    [anon_sym_where] = ACTIONS(13514),
    [anon_sym_quote] = ACTIONS(13514),
    [anon_sym_let] = ACTIONS(13514),
    [anon_sym_if] = ACTIONS(13514),
    [anon_sym_try] = ACTIONS(13514),
    [anon_sym_for] = ACTIONS(13514),
    [anon_sym_while] = ACTIONS(13514),
    [sym_break_statement] = ACTIONS(13514),
    [sym_continue_statement] = ACTIONS(13514),
    [anon_sym_return] = ACTIONS(13514),
    [anon_sym_const] = ACTIONS(13514),
    [anon_sym_global] = ACTIONS(13514),
    [anon_sym_local] = ACTIONS(13514),
    [anon_sym_LPAREN] = ACTIONS(13516),
    [anon_sym_RPAREN] = ACTIONS(13516),
    [anon_sym_COLON2] = ACTIONS(13514),
    [anon_sym_export] = ACTIONS(13514),
    [anon_sym_import] = ACTIONS(13514),
    [anon_sym_using] = ACTIONS(13514),
    [anon_sym_LBRACK] = ACTIONS(13516),
    [anon_sym_RBRACK] = ACTIONS(13516),
    [anon_sym_in] = ACTIONS(13514),
    [anon_sym_SEMI] = ACTIONS(13516),
    [anon_sym_LBRACE] = ACTIONS(13516),
    [anon_sym_RBRACE] = ACTIONS(13516),
    [anon_sym_DOLLAR] = ACTIONS(13516),
    [anon_sym_COLON_COLON] = ACTIONS(13516),
    [anon_sym_isa] = ACTIONS(13514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13516),
    [anon_sym_QMARK] = ACTIONS(13516),
    [anon_sym_AT] = ACTIONS(13516),
    [anon_sym_true] = ACTIONS(13514),
    [anon_sym_false] = ACTIONS(13514),
    [aux_sym_integer_literal_token1] = ACTIONS(13516),
    [aux_sym_integer_literal_token2] = ACTIONS(13516),
    [aux_sym_integer_literal_token3] = ACTIONS(13514),
    [aux_sym_integer_literal_token4] = ACTIONS(13514),
    [aux_sym_float_literal_token1] = ACTIONS(13516),
    [aux_sym_float_literal_token3] = ACTIONS(13516),
    [aux_sym_float_literal_token4] = ACTIONS(13516),
    [sym_character_literal] = ACTIONS(13516),
    [sym__pair_operator] = ACTIONS(13516),
    [sym__arrow_operator] = ACTIONS(13514),
    [sym__lazy_or_operator] = ACTIONS(13516),
    [sym__lazy_and_operator] = ACTIONS(13516),
    [sym__comparison_operator] = ACTIONS(13514),
    [sym__pipe_right_operator] = ACTIONS(13516),
    [sym__pipe_left_operator] = ACTIONS(13516),
    [sym__ellipsis_operator] = ACTIONS(13514),
    [sym__plus_operator] = ACTIONS(13514),
    [sym__times_operator] = ACTIONS(13514),
    [sym__rational_operator] = ACTIONS(13516),
    [sym__bitshift_operator] = ACTIONS(13516),
    [sym__power_operator] = ACTIONS(13516),
    [sym__tilde_operator] = ACTIONS(13516),
    [sym__type_order_operator] = ACTIONS(13516),
    [sym__unary_operator] = ACTIONS(13514),
    [sym__unary_plus_operator] = ACTIONS(13514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13516),
    [sym__command_start] = ACTIONS(13516),
  },
  [8203] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12732),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DASH_GT] = ACTIONS(12014),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8204] = {
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(12974),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_end] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_finally] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [8205] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_finally] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8206] = {
    [sym__word_identifier] = ACTIONS(13489),
    [anon_sym_EQ] = ACTIONS(13489),
    [anon_sym_COMMA] = ACTIONS(13489),
    [anon_sym_COLON] = ACTIONS(13489),
    [anon_sym_begin] = ACTIONS(13489),
    [anon_sym_module] = ACTIONS(13489),
    [anon_sym_baremodule] = ACTIONS(13489),
    [anon_sym_end] = ACTIONS(13489),
    [anon_sym_abstract] = ACTIONS(13489),
    [anon_sym_primitive] = ACTIONS(13489),
    [anon_sym_mutable] = ACTIONS(13489),
    [anon_sym_struct] = ACTIONS(13489),
    [anon_sym_function] = ACTIONS(13489),
    [anon_sym_macro] = ACTIONS(13489),
    [anon_sym_where] = ACTIONS(13489),
    [anon_sym_quote] = ACTIONS(13489),
    [anon_sym_let] = ACTIONS(13489),
    [anon_sym_if] = ACTIONS(13489),
    [anon_sym_try] = ACTIONS(13489),
    [anon_sym_finally] = ACTIONS(13489),
    [anon_sym_for] = ACTIONS(13489),
    [anon_sym_while] = ACTIONS(13489),
    [sym_break_statement] = ACTIONS(13489),
    [sym_continue_statement] = ACTIONS(13489),
    [anon_sym_return] = ACTIONS(13489),
    [anon_sym_const] = ACTIONS(13489),
    [anon_sym_global] = ACTIONS(13489),
    [anon_sym_local] = ACTIONS(13489),
    [anon_sym_LPAREN] = ACTIONS(13489),
    [anon_sym_COLON2] = ACTIONS(13489),
    [anon_sym_export] = ACTIONS(13489),
    [anon_sym_import] = ACTIONS(13489),
    [anon_sym_using] = ACTIONS(13489),
    [anon_sym_LBRACK] = ACTIONS(13489),
    [anon_sym_LF] = ACTIONS(13491),
    [anon_sym_in] = ACTIONS(13489),
    [anon_sym_LBRACE] = ACTIONS(13489),
    [anon_sym_DOLLAR] = ACTIONS(13489),
    [anon_sym_COLON_COLON] = ACTIONS(13489),
    [anon_sym_isa] = ACTIONS(13489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13489),
    [anon_sym_QMARK] = ACTIONS(13489),
    [anon_sym_AT] = ACTIONS(13489),
    [anon_sym_true] = ACTIONS(13489),
    [anon_sym_false] = ACTIONS(13489),
    [aux_sym_integer_literal_token1] = ACTIONS(13489),
    [aux_sym_integer_literal_token2] = ACTIONS(13489),
    [aux_sym_integer_literal_token3] = ACTIONS(13489),
    [aux_sym_integer_literal_token4] = ACTIONS(13489),
    [aux_sym_float_literal_token1] = ACTIONS(13489),
    [aux_sym_float_literal_token3] = ACTIONS(13489),
    [aux_sym_float_literal_token4] = ACTIONS(13489),
    [sym_character_literal] = ACTIONS(13489),
    [sym__pair_operator] = ACTIONS(13489),
    [sym__arrow_operator] = ACTIONS(13489),
    [sym__lazy_or_operator] = ACTIONS(13489),
    [sym__lazy_and_operator] = ACTIONS(13489),
    [sym__comparison_operator] = ACTIONS(13489),
    [sym__pipe_right_operator] = ACTIONS(13489),
    [sym__pipe_left_operator] = ACTIONS(13489),
    [sym__ellipsis_operator] = ACTIONS(13489),
    [sym__plus_operator] = ACTIONS(13489),
    [sym__times_operator] = ACTIONS(13489),
    [sym__rational_operator] = ACTIONS(13489),
    [sym__bitshift_operator] = ACTIONS(13489),
    [sym__power_operator] = ACTIONS(13489),
    [sym__tilde_operator] = ACTIONS(13489),
    [sym__type_order_operator] = ACTIONS(13489),
    [sym__unary_operator] = ACTIONS(13489),
    [sym__unary_plus_operator] = ACTIONS(13489),
    [aux_sym__terminator_token1] = ACTIONS(13489),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13491),
    [sym__command_start] = ACTIONS(13491),
  },
  [8207] = {
    [sym__word_identifier] = ACTIONS(13493),
    [anon_sym_EQ] = ACTIONS(13493),
    [anon_sym_COMMA] = ACTIONS(13493),
    [anon_sym_COLON] = ACTIONS(13493),
    [anon_sym_begin] = ACTIONS(13493),
    [anon_sym_module] = ACTIONS(13493),
    [anon_sym_baremodule] = ACTIONS(13493),
    [anon_sym_end] = ACTIONS(13493),
    [anon_sym_abstract] = ACTIONS(13493),
    [anon_sym_primitive] = ACTIONS(13493),
    [anon_sym_mutable] = ACTIONS(13493),
    [anon_sym_struct] = ACTIONS(13493),
    [anon_sym_function] = ACTIONS(13493),
    [anon_sym_macro] = ACTIONS(13493),
    [anon_sym_where] = ACTIONS(13493),
    [anon_sym_quote] = ACTIONS(13493),
    [anon_sym_let] = ACTIONS(13493),
    [anon_sym_if] = ACTIONS(13493),
    [anon_sym_try] = ACTIONS(13493),
    [anon_sym_finally] = ACTIONS(13493),
    [anon_sym_for] = ACTIONS(13493),
    [anon_sym_while] = ACTIONS(13493),
    [sym_break_statement] = ACTIONS(13493),
    [sym_continue_statement] = ACTIONS(13493),
    [anon_sym_return] = ACTIONS(13493),
    [anon_sym_const] = ACTIONS(13493),
    [anon_sym_global] = ACTIONS(13493),
    [anon_sym_local] = ACTIONS(13493),
    [anon_sym_LPAREN] = ACTIONS(13493),
    [anon_sym_COLON2] = ACTIONS(13493),
    [anon_sym_export] = ACTIONS(13493),
    [anon_sym_import] = ACTIONS(13493),
    [anon_sym_using] = ACTIONS(13493),
    [anon_sym_LBRACK] = ACTIONS(13493),
    [anon_sym_LF] = ACTIONS(13495),
    [anon_sym_in] = ACTIONS(13493),
    [anon_sym_LBRACE] = ACTIONS(13493),
    [anon_sym_DOLLAR] = ACTIONS(13493),
    [anon_sym_COLON_COLON] = ACTIONS(13493),
    [anon_sym_isa] = ACTIONS(13493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13493),
    [anon_sym_QMARK] = ACTIONS(13493),
    [anon_sym_AT] = ACTIONS(13493),
    [anon_sym_true] = ACTIONS(13493),
    [anon_sym_false] = ACTIONS(13493),
    [aux_sym_integer_literal_token1] = ACTIONS(13493),
    [aux_sym_integer_literal_token2] = ACTIONS(13493),
    [aux_sym_integer_literal_token3] = ACTIONS(13493),
    [aux_sym_integer_literal_token4] = ACTIONS(13493),
    [aux_sym_float_literal_token1] = ACTIONS(13493),
    [aux_sym_float_literal_token3] = ACTIONS(13493),
    [aux_sym_float_literal_token4] = ACTIONS(13493),
    [sym_character_literal] = ACTIONS(13493),
    [sym__pair_operator] = ACTIONS(13493),
    [sym__arrow_operator] = ACTIONS(13493),
    [sym__lazy_or_operator] = ACTIONS(13493),
    [sym__lazy_and_operator] = ACTIONS(13493),
    [sym__comparison_operator] = ACTIONS(13493),
    [sym__pipe_right_operator] = ACTIONS(13493),
    [sym__pipe_left_operator] = ACTIONS(13493),
    [sym__ellipsis_operator] = ACTIONS(13493),
    [sym__plus_operator] = ACTIONS(13493),
    [sym__times_operator] = ACTIONS(13493),
    [sym__rational_operator] = ACTIONS(13493),
    [sym__bitshift_operator] = ACTIONS(13493),
    [sym__power_operator] = ACTIONS(13493),
    [sym__tilde_operator] = ACTIONS(13493),
    [sym__type_order_operator] = ACTIONS(13493),
    [sym__unary_operator] = ACTIONS(13493),
    [sym__unary_plus_operator] = ACTIONS(13493),
    [aux_sym__terminator_token1] = ACTIONS(13493),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13495),
    [sym__command_start] = ACTIONS(13495),
  },
  [8208] = {
    [sym__word_identifier] = ACTIONS(13499),
    [anon_sym_EQ] = ACTIONS(13499),
    [anon_sym_COMMA] = ACTIONS(13499),
    [anon_sym_COLON] = ACTIONS(13499),
    [anon_sym_begin] = ACTIONS(13499),
    [anon_sym_module] = ACTIONS(13499),
    [anon_sym_baremodule] = ACTIONS(13499),
    [anon_sym_end] = ACTIONS(13499),
    [anon_sym_abstract] = ACTIONS(13499),
    [anon_sym_primitive] = ACTIONS(13499),
    [anon_sym_mutable] = ACTIONS(13499),
    [anon_sym_struct] = ACTIONS(13499),
    [anon_sym_function] = ACTIONS(13499),
    [anon_sym_macro] = ACTIONS(13499),
    [anon_sym_where] = ACTIONS(13499),
    [anon_sym_quote] = ACTIONS(13499),
    [anon_sym_let] = ACTIONS(13499),
    [anon_sym_if] = ACTIONS(13499),
    [anon_sym_try] = ACTIONS(13499),
    [anon_sym_finally] = ACTIONS(13499),
    [anon_sym_for] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(13499),
    [sym_break_statement] = ACTIONS(13499),
    [sym_continue_statement] = ACTIONS(13499),
    [anon_sym_return] = ACTIONS(13499),
    [anon_sym_const] = ACTIONS(13499),
    [anon_sym_global] = ACTIONS(13499),
    [anon_sym_local] = ACTIONS(13499),
    [anon_sym_LPAREN] = ACTIONS(13499),
    [anon_sym_COLON2] = ACTIONS(13499),
    [anon_sym_export] = ACTIONS(13499),
    [anon_sym_import] = ACTIONS(13499),
    [anon_sym_using] = ACTIONS(13499),
    [anon_sym_LBRACK] = ACTIONS(13499),
    [anon_sym_LF] = ACTIONS(13501),
    [anon_sym_in] = ACTIONS(13499),
    [anon_sym_LBRACE] = ACTIONS(13499),
    [anon_sym_DOLLAR] = ACTIONS(13499),
    [anon_sym_COLON_COLON] = ACTIONS(13499),
    [anon_sym_isa] = ACTIONS(13499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13499),
    [anon_sym_QMARK] = ACTIONS(13499),
    [anon_sym_AT] = ACTIONS(13499),
    [anon_sym_true] = ACTIONS(13499),
    [anon_sym_false] = ACTIONS(13499),
    [aux_sym_integer_literal_token1] = ACTIONS(13499),
    [aux_sym_integer_literal_token2] = ACTIONS(13499),
    [aux_sym_integer_literal_token3] = ACTIONS(13499),
    [aux_sym_integer_literal_token4] = ACTIONS(13499),
    [aux_sym_float_literal_token1] = ACTIONS(13499),
    [aux_sym_float_literal_token3] = ACTIONS(13499),
    [aux_sym_float_literal_token4] = ACTIONS(13499),
    [sym_character_literal] = ACTIONS(13499),
    [sym__pair_operator] = ACTIONS(13499),
    [sym__arrow_operator] = ACTIONS(13499),
    [sym__lazy_or_operator] = ACTIONS(13499),
    [sym__lazy_and_operator] = ACTIONS(13499),
    [sym__comparison_operator] = ACTIONS(13499),
    [sym__pipe_right_operator] = ACTIONS(13499),
    [sym__pipe_left_operator] = ACTIONS(13499),
    [sym__ellipsis_operator] = ACTIONS(13499),
    [sym__plus_operator] = ACTIONS(13499),
    [sym__times_operator] = ACTIONS(13499),
    [sym__rational_operator] = ACTIONS(13499),
    [sym__bitshift_operator] = ACTIONS(13499),
    [sym__power_operator] = ACTIONS(13499),
    [sym__tilde_operator] = ACTIONS(13499),
    [sym__type_order_operator] = ACTIONS(13499),
    [sym__unary_operator] = ACTIONS(13499),
    [sym__unary_plus_operator] = ACTIONS(13499),
    [aux_sym__terminator_token1] = ACTIONS(13499),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13501),
    [sym__command_start] = ACTIONS(13501),
  },
  [8209] = {
    [sym__word_identifier] = ACTIONS(13506),
    [anon_sym_EQ] = ACTIONS(13506),
    [anon_sym_COMMA] = ACTIONS(13506),
    [anon_sym_COLON] = ACTIONS(13506),
    [anon_sym_begin] = ACTIONS(13506),
    [anon_sym_module] = ACTIONS(13506),
    [anon_sym_baremodule] = ACTIONS(13506),
    [anon_sym_end] = ACTIONS(13506),
    [anon_sym_abstract] = ACTIONS(13506),
    [anon_sym_primitive] = ACTIONS(13506),
    [anon_sym_mutable] = ACTIONS(13506),
    [anon_sym_struct] = ACTIONS(13506),
    [anon_sym_function] = ACTIONS(13506),
    [anon_sym_macro] = ACTIONS(13506),
    [anon_sym_where] = ACTIONS(13506),
    [anon_sym_quote] = ACTIONS(13506),
    [anon_sym_let] = ACTIONS(13506),
    [anon_sym_if] = ACTIONS(13506),
    [anon_sym_try] = ACTIONS(13506),
    [anon_sym_finally] = ACTIONS(13506),
    [anon_sym_for] = ACTIONS(13506),
    [anon_sym_while] = ACTIONS(13506),
    [sym_break_statement] = ACTIONS(13506),
    [sym_continue_statement] = ACTIONS(13506),
    [anon_sym_return] = ACTIONS(13506),
    [anon_sym_const] = ACTIONS(13506),
    [anon_sym_global] = ACTIONS(13506),
    [anon_sym_local] = ACTIONS(13506),
    [anon_sym_LPAREN] = ACTIONS(13506),
    [anon_sym_COLON2] = ACTIONS(13506),
    [anon_sym_export] = ACTIONS(13506),
    [anon_sym_import] = ACTIONS(13506),
    [anon_sym_using] = ACTIONS(13506),
    [anon_sym_LBRACK] = ACTIONS(13506),
    [anon_sym_LF] = ACTIONS(13508),
    [anon_sym_in] = ACTIONS(13506),
    [anon_sym_LBRACE] = ACTIONS(13506),
    [anon_sym_DOLLAR] = ACTIONS(13506),
    [anon_sym_COLON_COLON] = ACTIONS(13506),
    [anon_sym_isa] = ACTIONS(13506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13506),
    [anon_sym_QMARK] = ACTIONS(13506),
    [anon_sym_AT] = ACTIONS(13506),
    [anon_sym_true] = ACTIONS(13506),
    [anon_sym_false] = ACTIONS(13506),
    [aux_sym_integer_literal_token1] = ACTIONS(13506),
    [aux_sym_integer_literal_token2] = ACTIONS(13506),
    [aux_sym_integer_literal_token3] = ACTIONS(13506),
    [aux_sym_integer_literal_token4] = ACTIONS(13506),
    [aux_sym_float_literal_token1] = ACTIONS(13506),
    [aux_sym_float_literal_token3] = ACTIONS(13506),
    [aux_sym_float_literal_token4] = ACTIONS(13506),
    [sym_character_literal] = ACTIONS(13506),
    [sym__pair_operator] = ACTIONS(13506),
    [sym__arrow_operator] = ACTIONS(13506),
    [sym__lazy_or_operator] = ACTIONS(13506),
    [sym__lazy_and_operator] = ACTIONS(13506),
    [sym__comparison_operator] = ACTIONS(13506),
    [sym__pipe_right_operator] = ACTIONS(13506),
    [sym__pipe_left_operator] = ACTIONS(13506),
    [sym__ellipsis_operator] = ACTIONS(13506),
    [sym__plus_operator] = ACTIONS(13506),
    [sym__times_operator] = ACTIONS(13506),
    [sym__rational_operator] = ACTIONS(13506),
    [sym__bitshift_operator] = ACTIONS(13506),
    [sym__power_operator] = ACTIONS(13506),
    [sym__tilde_operator] = ACTIONS(13506),
    [sym__type_order_operator] = ACTIONS(13506),
    [sym__unary_operator] = ACTIONS(13506),
    [sym__unary_plus_operator] = ACTIONS(13506),
    [aux_sym__terminator_token1] = ACTIONS(13506),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13508),
    [sym__command_start] = ACTIONS(13508),
  },
  [8210] = {
    [sym__word_identifier] = ACTIONS(13510),
    [anon_sym_EQ] = ACTIONS(13510),
    [anon_sym_COMMA] = ACTIONS(13510),
    [anon_sym_COLON] = ACTIONS(13510),
    [anon_sym_begin] = ACTIONS(13510),
    [anon_sym_module] = ACTIONS(13510),
    [anon_sym_baremodule] = ACTIONS(13510),
    [anon_sym_end] = ACTIONS(13510),
    [anon_sym_abstract] = ACTIONS(13510),
    [anon_sym_primitive] = ACTIONS(13510),
    [anon_sym_mutable] = ACTIONS(13510),
    [anon_sym_struct] = ACTIONS(13510),
    [anon_sym_function] = ACTIONS(13510),
    [anon_sym_macro] = ACTIONS(13510),
    [anon_sym_where] = ACTIONS(13510),
    [anon_sym_quote] = ACTIONS(13510),
    [anon_sym_let] = ACTIONS(13510),
    [anon_sym_if] = ACTIONS(13510),
    [anon_sym_try] = ACTIONS(13510),
    [anon_sym_finally] = ACTIONS(13510),
    [anon_sym_for] = ACTIONS(13510),
    [anon_sym_while] = ACTIONS(13510),
    [sym_break_statement] = ACTIONS(13510),
    [sym_continue_statement] = ACTIONS(13510),
    [anon_sym_return] = ACTIONS(13510),
    [anon_sym_const] = ACTIONS(13510),
    [anon_sym_global] = ACTIONS(13510),
    [anon_sym_local] = ACTIONS(13510),
    [anon_sym_LPAREN] = ACTIONS(13510),
    [anon_sym_COLON2] = ACTIONS(13510),
    [anon_sym_export] = ACTIONS(13510),
    [anon_sym_import] = ACTIONS(13510),
    [anon_sym_using] = ACTIONS(13510),
    [anon_sym_LBRACK] = ACTIONS(13510),
    [anon_sym_LF] = ACTIONS(13512),
    [anon_sym_in] = ACTIONS(13510),
    [anon_sym_LBRACE] = ACTIONS(13510),
    [anon_sym_DOLLAR] = ACTIONS(13510),
    [anon_sym_COLON_COLON] = ACTIONS(13510),
    [anon_sym_isa] = ACTIONS(13510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13510),
    [anon_sym_QMARK] = ACTIONS(13510),
    [anon_sym_AT] = ACTIONS(13510),
    [anon_sym_true] = ACTIONS(13510),
    [anon_sym_false] = ACTIONS(13510),
    [aux_sym_integer_literal_token1] = ACTIONS(13510),
    [aux_sym_integer_literal_token2] = ACTIONS(13510),
    [aux_sym_integer_literal_token3] = ACTIONS(13510),
    [aux_sym_integer_literal_token4] = ACTIONS(13510),
    [aux_sym_float_literal_token1] = ACTIONS(13510),
    [aux_sym_float_literal_token3] = ACTIONS(13510),
    [aux_sym_float_literal_token4] = ACTIONS(13510),
    [sym_character_literal] = ACTIONS(13510),
    [sym__pair_operator] = ACTIONS(13510),
    [sym__arrow_operator] = ACTIONS(13510),
    [sym__lazy_or_operator] = ACTIONS(13510),
    [sym__lazy_and_operator] = ACTIONS(13510),
    [sym__comparison_operator] = ACTIONS(13510),
    [sym__pipe_right_operator] = ACTIONS(13510),
    [sym__pipe_left_operator] = ACTIONS(13510),
    [sym__ellipsis_operator] = ACTIONS(13510),
    [sym__plus_operator] = ACTIONS(13510),
    [sym__times_operator] = ACTIONS(13510),
    [sym__rational_operator] = ACTIONS(13510),
    [sym__bitshift_operator] = ACTIONS(13510),
    [sym__power_operator] = ACTIONS(13510),
    [sym__tilde_operator] = ACTIONS(13510),
    [sym__type_order_operator] = ACTIONS(13510),
    [sym__unary_operator] = ACTIONS(13510),
    [sym__unary_plus_operator] = ACTIONS(13510),
    [aux_sym__terminator_token1] = ACTIONS(13510),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13512),
    [sym__command_start] = ACTIONS(13512),
  },
  [8211] = {
    [sym__word_identifier] = ACTIONS(13514),
    [anon_sym_EQ] = ACTIONS(13514),
    [anon_sym_COMMA] = ACTIONS(13514),
    [anon_sym_COLON] = ACTIONS(13514),
    [anon_sym_begin] = ACTIONS(13514),
    [anon_sym_module] = ACTIONS(13514),
    [anon_sym_baremodule] = ACTIONS(13514),
    [anon_sym_end] = ACTIONS(13514),
    [anon_sym_abstract] = ACTIONS(13514),
    [anon_sym_primitive] = ACTIONS(13514),
    [anon_sym_mutable] = ACTIONS(13514),
    [anon_sym_struct] = ACTIONS(13514),
    [anon_sym_function] = ACTIONS(13514),
    [anon_sym_macro] = ACTIONS(13514),
    [anon_sym_where] = ACTIONS(13514),
    [anon_sym_quote] = ACTIONS(13514),
    [anon_sym_let] = ACTIONS(13514),
    [anon_sym_if] = ACTIONS(13514),
    [anon_sym_try] = ACTIONS(13514),
    [anon_sym_finally] = ACTIONS(13514),
    [anon_sym_for] = ACTIONS(13514),
    [anon_sym_while] = ACTIONS(13514),
    [sym_break_statement] = ACTIONS(13514),
    [sym_continue_statement] = ACTIONS(13514),
    [anon_sym_return] = ACTIONS(13514),
    [anon_sym_const] = ACTIONS(13514),
    [anon_sym_global] = ACTIONS(13514),
    [anon_sym_local] = ACTIONS(13514),
    [anon_sym_LPAREN] = ACTIONS(13514),
    [anon_sym_COLON2] = ACTIONS(13514),
    [anon_sym_export] = ACTIONS(13514),
    [anon_sym_import] = ACTIONS(13514),
    [anon_sym_using] = ACTIONS(13514),
    [anon_sym_LBRACK] = ACTIONS(13514),
    [anon_sym_LF] = ACTIONS(13516),
    [anon_sym_in] = ACTIONS(13514),
    [anon_sym_LBRACE] = ACTIONS(13514),
    [anon_sym_DOLLAR] = ACTIONS(13514),
    [anon_sym_COLON_COLON] = ACTIONS(13514),
    [anon_sym_isa] = ACTIONS(13514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13514),
    [anon_sym_QMARK] = ACTIONS(13514),
    [anon_sym_AT] = ACTIONS(13514),
    [anon_sym_true] = ACTIONS(13514),
    [anon_sym_false] = ACTIONS(13514),
    [aux_sym_integer_literal_token1] = ACTIONS(13514),
    [aux_sym_integer_literal_token2] = ACTIONS(13514),
    [aux_sym_integer_literal_token3] = ACTIONS(13514),
    [aux_sym_integer_literal_token4] = ACTIONS(13514),
    [aux_sym_float_literal_token1] = ACTIONS(13514),
    [aux_sym_float_literal_token3] = ACTIONS(13514),
    [aux_sym_float_literal_token4] = ACTIONS(13514),
    [sym_character_literal] = ACTIONS(13514),
    [sym__pair_operator] = ACTIONS(13514),
    [sym__arrow_operator] = ACTIONS(13514),
    [sym__lazy_or_operator] = ACTIONS(13514),
    [sym__lazy_and_operator] = ACTIONS(13514),
    [sym__comparison_operator] = ACTIONS(13514),
    [sym__pipe_right_operator] = ACTIONS(13514),
    [sym__pipe_left_operator] = ACTIONS(13514),
    [sym__ellipsis_operator] = ACTIONS(13514),
    [sym__plus_operator] = ACTIONS(13514),
    [sym__times_operator] = ACTIONS(13514),
    [sym__rational_operator] = ACTIONS(13514),
    [sym__bitshift_operator] = ACTIONS(13514),
    [sym__power_operator] = ACTIONS(13514),
    [sym__tilde_operator] = ACTIONS(13514),
    [sym__type_order_operator] = ACTIONS(13514),
    [sym__unary_operator] = ACTIONS(13514),
    [sym__unary_plus_operator] = ACTIONS(13514),
    [aux_sym__terminator_token1] = ACTIONS(13514),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13516),
    [sym__command_start] = ACTIONS(13516),
  },
  [8212] = {
    [sym__word_identifier] = ACTIONS(13518),
    [anon_sym_EQ] = ACTIONS(13518),
    [anon_sym_COMMA] = ACTIONS(13518),
    [anon_sym_COLON] = ACTIONS(13518),
    [anon_sym_begin] = ACTIONS(13518),
    [anon_sym_module] = ACTIONS(13518),
    [anon_sym_baremodule] = ACTIONS(13518),
    [anon_sym_end] = ACTIONS(13518),
    [anon_sym_abstract] = ACTIONS(13518),
    [anon_sym_primitive] = ACTIONS(13518),
    [anon_sym_mutable] = ACTIONS(13518),
    [anon_sym_struct] = ACTIONS(13518),
    [anon_sym_function] = ACTIONS(13518),
    [anon_sym_macro] = ACTIONS(13518),
    [anon_sym_where] = ACTIONS(13518),
    [anon_sym_quote] = ACTIONS(13518),
    [anon_sym_let] = ACTIONS(13518),
    [anon_sym_if] = ACTIONS(13518),
    [anon_sym_try] = ACTIONS(13518),
    [anon_sym_finally] = ACTIONS(13518),
    [anon_sym_for] = ACTIONS(13518),
    [anon_sym_while] = ACTIONS(13518),
    [sym_break_statement] = ACTIONS(13518),
    [sym_continue_statement] = ACTIONS(13518),
    [anon_sym_return] = ACTIONS(13518),
    [anon_sym_const] = ACTIONS(13518),
    [anon_sym_global] = ACTIONS(13518),
    [anon_sym_local] = ACTIONS(13518),
    [anon_sym_LPAREN] = ACTIONS(13518),
    [anon_sym_COLON2] = ACTIONS(13518),
    [anon_sym_export] = ACTIONS(13518),
    [anon_sym_import] = ACTIONS(13518),
    [anon_sym_using] = ACTIONS(13518),
    [anon_sym_LBRACK] = ACTIONS(13518),
    [anon_sym_LF] = ACTIONS(13520),
    [anon_sym_in] = ACTIONS(13518),
    [anon_sym_LBRACE] = ACTIONS(13518),
    [anon_sym_DOLLAR] = ACTIONS(13518),
    [anon_sym_COLON_COLON] = ACTIONS(13518),
    [anon_sym_isa] = ACTIONS(13518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13518),
    [anon_sym_QMARK] = ACTIONS(13518),
    [anon_sym_AT] = ACTIONS(13518),
    [anon_sym_true] = ACTIONS(13518),
    [anon_sym_false] = ACTIONS(13518),
    [aux_sym_integer_literal_token1] = ACTIONS(13518),
    [aux_sym_integer_literal_token2] = ACTIONS(13518),
    [aux_sym_integer_literal_token3] = ACTIONS(13518),
    [aux_sym_integer_literal_token4] = ACTIONS(13518),
    [aux_sym_float_literal_token1] = ACTIONS(13518),
    [aux_sym_float_literal_token3] = ACTIONS(13518),
    [aux_sym_float_literal_token4] = ACTIONS(13518),
    [sym_character_literal] = ACTIONS(13518),
    [sym__pair_operator] = ACTIONS(13518),
    [sym__arrow_operator] = ACTIONS(13518),
    [sym__lazy_or_operator] = ACTIONS(13518),
    [sym__lazy_and_operator] = ACTIONS(13518),
    [sym__comparison_operator] = ACTIONS(13518),
    [sym__pipe_right_operator] = ACTIONS(13518),
    [sym__pipe_left_operator] = ACTIONS(13518),
    [sym__ellipsis_operator] = ACTIONS(13518),
    [sym__plus_operator] = ACTIONS(13518),
    [sym__times_operator] = ACTIONS(13518),
    [sym__rational_operator] = ACTIONS(13518),
    [sym__bitshift_operator] = ACTIONS(13518),
    [sym__power_operator] = ACTIONS(13518),
    [sym__tilde_operator] = ACTIONS(13518),
    [sym__type_order_operator] = ACTIONS(13518),
    [sym__unary_operator] = ACTIONS(13518),
    [sym__unary_plus_operator] = ACTIONS(13518),
    [aux_sym__terminator_token1] = ACTIONS(13518),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13520),
    [sym__command_start] = ACTIONS(13520),
  },
  [8213] = {
    [sym__word_identifier] = ACTIONS(13257),
    [anon_sym_EQ] = ACTIONS(13257),
    [anon_sym_COMMA] = ACTIONS(13257),
    [anon_sym_COLON] = ACTIONS(13257),
    [anon_sym_begin] = ACTIONS(13257),
    [anon_sym_module] = ACTIONS(13257),
    [anon_sym_baremodule] = ACTIONS(13257),
    [anon_sym_end] = ACTIONS(13257),
    [anon_sym_abstract] = ACTIONS(13257),
    [anon_sym_primitive] = ACTIONS(13257),
    [anon_sym_mutable] = ACTIONS(13257),
    [anon_sym_struct] = ACTIONS(13257),
    [anon_sym_function] = ACTIONS(13257),
    [anon_sym_macro] = ACTIONS(13257),
    [anon_sym_where] = ACTIONS(13257),
    [anon_sym_quote] = ACTIONS(13257),
    [anon_sym_let] = ACTIONS(13257),
    [anon_sym_if] = ACTIONS(13257),
    [anon_sym_try] = ACTIONS(13257),
    [anon_sym_finally] = ACTIONS(13257),
    [anon_sym_for] = ACTIONS(13257),
    [anon_sym_while] = ACTIONS(13257),
    [sym_break_statement] = ACTIONS(13257),
    [sym_continue_statement] = ACTIONS(13257),
    [anon_sym_return] = ACTIONS(13257),
    [anon_sym_const] = ACTIONS(13257),
    [anon_sym_global] = ACTIONS(13257),
    [anon_sym_local] = ACTIONS(13257),
    [anon_sym_LPAREN] = ACTIONS(13257),
    [anon_sym_COLON2] = ACTIONS(13257),
    [anon_sym_export] = ACTIONS(13257),
    [anon_sym_import] = ACTIONS(13257),
    [anon_sym_using] = ACTIONS(13257),
    [anon_sym_LBRACK] = ACTIONS(13257),
    [anon_sym_LF] = ACTIONS(13259),
    [anon_sym_in] = ACTIONS(13257),
    [anon_sym_LBRACE] = ACTIONS(13257),
    [anon_sym_DOLLAR] = ACTIONS(13257),
    [anon_sym_COLON_COLON] = ACTIONS(13257),
    [anon_sym_isa] = ACTIONS(13257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13257),
    [anon_sym_QMARK] = ACTIONS(13257),
    [anon_sym_AT] = ACTIONS(13257),
    [anon_sym_true] = ACTIONS(13257),
    [anon_sym_false] = ACTIONS(13257),
    [aux_sym_integer_literal_token1] = ACTIONS(13257),
    [aux_sym_integer_literal_token2] = ACTIONS(13257),
    [aux_sym_integer_literal_token3] = ACTIONS(13257),
    [aux_sym_integer_literal_token4] = ACTIONS(13257),
    [aux_sym_float_literal_token1] = ACTIONS(13257),
    [aux_sym_float_literal_token3] = ACTIONS(13257),
    [aux_sym_float_literal_token4] = ACTIONS(13257),
    [sym_character_literal] = ACTIONS(13257),
    [sym__pair_operator] = ACTIONS(13257),
    [sym__arrow_operator] = ACTIONS(13257),
    [sym__lazy_or_operator] = ACTIONS(13257),
    [sym__lazy_and_operator] = ACTIONS(13257),
    [sym__comparison_operator] = ACTIONS(13257),
    [sym__pipe_right_operator] = ACTIONS(13257),
    [sym__pipe_left_operator] = ACTIONS(13257),
    [sym__ellipsis_operator] = ACTIONS(13257),
    [sym__plus_operator] = ACTIONS(13257),
    [sym__times_operator] = ACTIONS(13257),
    [sym__rational_operator] = ACTIONS(13257),
    [sym__bitshift_operator] = ACTIONS(13257),
    [sym__power_operator] = ACTIONS(13257),
    [sym__tilde_operator] = ACTIONS(13257),
    [sym__type_order_operator] = ACTIONS(13257),
    [sym__unary_operator] = ACTIONS(13257),
    [sym__unary_plus_operator] = ACTIONS(13257),
    [aux_sym__terminator_token1] = ACTIONS(13257),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13259),
    [sym__command_start] = ACTIONS(13259),
  },
  [8214] = {
    [sym__word_identifier] = ACTIONS(13522),
    [anon_sym_EQ] = ACTIONS(13522),
    [anon_sym_COMMA] = ACTIONS(13522),
    [anon_sym_COLON] = ACTIONS(13522),
    [anon_sym_begin] = ACTIONS(13522),
    [anon_sym_module] = ACTIONS(13522),
    [anon_sym_baremodule] = ACTIONS(13522),
    [anon_sym_end] = ACTIONS(13522),
    [anon_sym_abstract] = ACTIONS(13522),
    [anon_sym_primitive] = ACTIONS(13522),
    [anon_sym_mutable] = ACTIONS(13522),
    [anon_sym_struct] = ACTIONS(13522),
    [anon_sym_function] = ACTIONS(13522),
    [anon_sym_macro] = ACTIONS(13522),
    [anon_sym_where] = ACTIONS(13522),
    [anon_sym_quote] = ACTIONS(13522),
    [anon_sym_let] = ACTIONS(13522),
    [anon_sym_if] = ACTIONS(13522),
    [anon_sym_try] = ACTIONS(13522),
    [anon_sym_finally] = ACTIONS(13522),
    [anon_sym_for] = ACTIONS(13522),
    [anon_sym_while] = ACTIONS(13522),
    [sym_break_statement] = ACTIONS(13522),
    [sym_continue_statement] = ACTIONS(13522),
    [anon_sym_return] = ACTIONS(13522),
    [anon_sym_const] = ACTIONS(13522),
    [anon_sym_global] = ACTIONS(13522),
    [anon_sym_local] = ACTIONS(13522),
    [anon_sym_LPAREN] = ACTIONS(13522),
    [anon_sym_COLON2] = ACTIONS(13522),
    [anon_sym_export] = ACTIONS(13522),
    [anon_sym_import] = ACTIONS(13522),
    [anon_sym_using] = ACTIONS(13522),
    [anon_sym_LBRACK] = ACTIONS(13522),
    [anon_sym_LF] = ACTIONS(13524),
    [anon_sym_in] = ACTIONS(13522),
    [anon_sym_LBRACE] = ACTIONS(13522),
    [anon_sym_DOLLAR] = ACTIONS(13522),
    [anon_sym_COLON_COLON] = ACTIONS(13522),
    [anon_sym_isa] = ACTIONS(13522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13522),
    [anon_sym_QMARK] = ACTIONS(13522),
    [anon_sym_AT] = ACTIONS(13522),
    [anon_sym_true] = ACTIONS(13522),
    [anon_sym_false] = ACTIONS(13522),
    [aux_sym_integer_literal_token1] = ACTIONS(13522),
    [aux_sym_integer_literal_token2] = ACTIONS(13522),
    [aux_sym_integer_literal_token3] = ACTIONS(13522),
    [aux_sym_integer_literal_token4] = ACTIONS(13522),
    [aux_sym_float_literal_token1] = ACTIONS(13522),
    [aux_sym_float_literal_token3] = ACTIONS(13522),
    [aux_sym_float_literal_token4] = ACTIONS(13522),
    [sym_character_literal] = ACTIONS(13522),
    [sym__pair_operator] = ACTIONS(13522),
    [sym__arrow_operator] = ACTIONS(13522),
    [sym__lazy_or_operator] = ACTIONS(13522),
    [sym__lazy_and_operator] = ACTIONS(13522),
    [sym__comparison_operator] = ACTIONS(13522),
    [sym__pipe_right_operator] = ACTIONS(13522),
    [sym__pipe_left_operator] = ACTIONS(13522),
    [sym__ellipsis_operator] = ACTIONS(13522),
    [sym__plus_operator] = ACTIONS(13522),
    [sym__times_operator] = ACTIONS(13522),
    [sym__rational_operator] = ACTIONS(13522),
    [sym__bitshift_operator] = ACTIONS(13522),
    [sym__power_operator] = ACTIONS(13522),
    [sym__tilde_operator] = ACTIONS(13522),
    [sym__type_order_operator] = ACTIONS(13522),
    [sym__unary_operator] = ACTIONS(13522),
    [sym__unary_plus_operator] = ACTIONS(13522),
    [aux_sym__terminator_token1] = ACTIONS(13522),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13524),
    [sym__command_start] = ACTIONS(13524),
  },
  [8215] = {
    [sym__word_identifier] = ACTIONS(13526),
    [anon_sym_EQ] = ACTIONS(13526),
    [anon_sym_COMMA] = ACTIONS(13526),
    [anon_sym_COLON] = ACTIONS(13526),
    [anon_sym_begin] = ACTIONS(13526),
    [anon_sym_module] = ACTIONS(13526),
    [anon_sym_baremodule] = ACTIONS(13526),
    [anon_sym_end] = ACTIONS(13526),
    [anon_sym_abstract] = ACTIONS(13526),
    [anon_sym_primitive] = ACTIONS(13526),
    [anon_sym_mutable] = ACTIONS(13526),
    [anon_sym_struct] = ACTIONS(13526),
    [anon_sym_function] = ACTIONS(13526),
    [anon_sym_macro] = ACTIONS(13526),
    [anon_sym_where] = ACTIONS(13526),
    [anon_sym_quote] = ACTIONS(13526),
    [anon_sym_let] = ACTIONS(13526),
    [anon_sym_if] = ACTIONS(13526),
    [anon_sym_try] = ACTIONS(13526),
    [anon_sym_finally] = ACTIONS(13526),
    [anon_sym_for] = ACTIONS(13526),
    [anon_sym_while] = ACTIONS(13526),
    [sym_break_statement] = ACTIONS(13526),
    [sym_continue_statement] = ACTIONS(13526),
    [anon_sym_return] = ACTIONS(13526),
    [anon_sym_const] = ACTIONS(13526),
    [anon_sym_global] = ACTIONS(13526),
    [anon_sym_local] = ACTIONS(13526),
    [anon_sym_LPAREN] = ACTIONS(13526),
    [anon_sym_COLON2] = ACTIONS(13526),
    [anon_sym_export] = ACTIONS(13526),
    [anon_sym_import] = ACTIONS(13526),
    [anon_sym_using] = ACTIONS(13526),
    [anon_sym_LBRACK] = ACTIONS(13526),
    [anon_sym_LF] = ACTIONS(13528),
    [anon_sym_in] = ACTIONS(13526),
    [anon_sym_LBRACE] = ACTIONS(13526),
    [anon_sym_DOLLAR] = ACTIONS(13526),
    [anon_sym_COLON_COLON] = ACTIONS(13526),
    [anon_sym_isa] = ACTIONS(13526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13526),
    [anon_sym_QMARK] = ACTIONS(13526),
    [anon_sym_AT] = ACTIONS(13526),
    [anon_sym_true] = ACTIONS(13526),
    [anon_sym_false] = ACTIONS(13526),
    [aux_sym_integer_literal_token1] = ACTIONS(13526),
    [aux_sym_integer_literal_token2] = ACTIONS(13526),
    [aux_sym_integer_literal_token3] = ACTIONS(13526),
    [aux_sym_integer_literal_token4] = ACTIONS(13526),
    [aux_sym_float_literal_token1] = ACTIONS(13526),
    [aux_sym_float_literal_token3] = ACTIONS(13526),
    [aux_sym_float_literal_token4] = ACTIONS(13526),
    [sym_character_literal] = ACTIONS(13526),
    [sym__pair_operator] = ACTIONS(13526),
    [sym__arrow_operator] = ACTIONS(13526),
    [sym__lazy_or_operator] = ACTIONS(13526),
    [sym__lazy_and_operator] = ACTIONS(13526),
    [sym__comparison_operator] = ACTIONS(13526),
    [sym__pipe_right_operator] = ACTIONS(13526),
    [sym__pipe_left_operator] = ACTIONS(13526),
    [sym__ellipsis_operator] = ACTIONS(13526),
    [sym__plus_operator] = ACTIONS(13526),
    [sym__times_operator] = ACTIONS(13526),
    [sym__rational_operator] = ACTIONS(13526),
    [sym__bitshift_operator] = ACTIONS(13526),
    [sym__power_operator] = ACTIONS(13526),
    [sym__tilde_operator] = ACTIONS(13526),
    [sym__type_order_operator] = ACTIONS(13526),
    [sym__unary_operator] = ACTIONS(13526),
    [sym__unary_plus_operator] = ACTIONS(13526),
    [aux_sym__terminator_token1] = ACTIONS(13526),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13528),
    [sym__command_start] = ACTIONS(13528),
  },
  [8216] = {
    [sym__word_identifier] = ACTIONS(13530),
    [anon_sym_EQ] = ACTIONS(13530),
    [anon_sym_COMMA] = ACTIONS(13530),
    [anon_sym_COLON] = ACTIONS(13530),
    [anon_sym_begin] = ACTIONS(13530),
    [anon_sym_module] = ACTIONS(13530),
    [anon_sym_baremodule] = ACTIONS(13530),
    [anon_sym_end] = ACTIONS(13530),
    [anon_sym_abstract] = ACTIONS(13530),
    [anon_sym_primitive] = ACTIONS(13530),
    [anon_sym_mutable] = ACTIONS(13530),
    [anon_sym_struct] = ACTIONS(13530),
    [anon_sym_function] = ACTIONS(13530),
    [anon_sym_macro] = ACTIONS(13530),
    [anon_sym_where] = ACTIONS(13530),
    [anon_sym_quote] = ACTIONS(13530),
    [anon_sym_let] = ACTIONS(13530),
    [anon_sym_if] = ACTIONS(13530),
    [anon_sym_try] = ACTIONS(13530),
    [anon_sym_finally] = ACTIONS(13530),
    [anon_sym_for] = ACTIONS(13530),
    [anon_sym_while] = ACTIONS(13530),
    [sym_break_statement] = ACTIONS(13530),
    [sym_continue_statement] = ACTIONS(13530),
    [anon_sym_return] = ACTIONS(13530),
    [anon_sym_const] = ACTIONS(13530),
    [anon_sym_global] = ACTIONS(13530),
    [anon_sym_local] = ACTIONS(13530),
    [anon_sym_LPAREN] = ACTIONS(13530),
    [anon_sym_COLON2] = ACTIONS(13530),
    [anon_sym_export] = ACTIONS(13530),
    [anon_sym_import] = ACTIONS(13530),
    [anon_sym_using] = ACTIONS(13530),
    [anon_sym_LBRACK] = ACTIONS(13530),
    [anon_sym_LF] = ACTIONS(13532),
    [anon_sym_in] = ACTIONS(13530),
    [anon_sym_LBRACE] = ACTIONS(13530),
    [anon_sym_DOLLAR] = ACTIONS(13530),
    [anon_sym_COLON_COLON] = ACTIONS(13530),
    [anon_sym_isa] = ACTIONS(13530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13530),
    [anon_sym_QMARK] = ACTIONS(13530),
    [anon_sym_AT] = ACTIONS(13530),
    [anon_sym_true] = ACTIONS(13530),
    [anon_sym_false] = ACTIONS(13530),
    [aux_sym_integer_literal_token1] = ACTIONS(13530),
    [aux_sym_integer_literal_token2] = ACTIONS(13530),
    [aux_sym_integer_literal_token3] = ACTIONS(13530),
    [aux_sym_integer_literal_token4] = ACTIONS(13530),
    [aux_sym_float_literal_token1] = ACTIONS(13530),
    [aux_sym_float_literal_token3] = ACTIONS(13530),
    [aux_sym_float_literal_token4] = ACTIONS(13530),
    [sym_character_literal] = ACTIONS(13530),
    [sym__pair_operator] = ACTIONS(13530),
    [sym__arrow_operator] = ACTIONS(13530),
    [sym__lazy_or_operator] = ACTIONS(13530),
    [sym__lazy_and_operator] = ACTIONS(13530),
    [sym__comparison_operator] = ACTIONS(13530),
    [sym__pipe_right_operator] = ACTIONS(13530),
    [sym__pipe_left_operator] = ACTIONS(13530),
    [sym__ellipsis_operator] = ACTIONS(13530),
    [sym__plus_operator] = ACTIONS(13530),
    [sym__times_operator] = ACTIONS(13530),
    [sym__rational_operator] = ACTIONS(13530),
    [sym__bitshift_operator] = ACTIONS(13530),
    [sym__power_operator] = ACTIONS(13530),
    [sym__tilde_operator] = ACTIONS(13530),
    [sym__type_order_operator] = ACTIONS(13530),
    [sym__unary_operator] = ACTIONS(13530),
    [sym__unary_plus_operator] = ACTIONS(13530),
    [aux_sym__terminator_token1] = ACTIONS(13530),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13532),
    [sym__command_start] = ACTIONS(13532),
  },
  [8217] = {
    [sym__word_identifier] = ACTIONS(13534),
    [anon_sym_EQ] = ACTIONS(13534),
    [anon_sym_COMMA] = ACTIONS(13534),
    [anon_sym_COLON] = ACTIONS(13534),
    [anon_sym_begin] = ACTIONS(13534),
    [anon_sym_module] = ACTIONS(13534),
    [anon_sym_baremodule] = ACTIONS(13534),
    [anon_sym_end] = ACTIONS(13534),
    [anon_sym_abstract] = ACTIONS(13534),
    [anon_sym_primitive] = ACTIONS(13534),
    [anon_sym_mutable] = ACTIONS(13534),
    [anon_sym_struct] = ACTIONS(13534),
    [anon_sym_function] = ACTIONS(13534),
    [anon_sym_macro] = ACTIONS(13534),
    [anon_sym_where] = ACTIONS(13534),
    [anon_sym_quote] = ACTIONS(13534),
    [anon_sym_let] = ACTIONS(13534),
    [anon_sym_if] = ACTIONS(13534),
    [anon_sym_try] = ACTIONS(13534),
    [anon_sym_finally] = ACTIONS(13534),
    [anon_sym_for] = ACTIONS(13534),
    [anon_sym_while] = ACTIONS(13534),
    [sym_break_statement] = ACTIONS(13534),
    [sym_continue_statement] = ACTIONS(13534),
    [anon_sym_return] = ACTIONS(13534),
    [anon_sym_const] = ACTIONS(13534),
    [anon_sym_global] = ACTIONS(13534),
    [anon_sym_local] = ACTIONS(13534),
    [anon_sym_LPAREN] = ACTIONS(13534),
    [anon_sym_COLON2] = ACTIONS(13534),
    [anon_sym_export] = ACTIONS(13534),
    [anon_sym_import] = ACTIONS(13534),
    [anon_sym_using] = ACTIONS(13534),
    [anon_sym_LBRACK] = ACTIONS(13534),
    [anon_sym_LF] = ACTIONS(13536),
    [anon_sym_in] = ACTIONS(13534),
    [anon_sym_LBRACE] = ACTIONS(13534),
    [anon_sym_DOLLAR] = ACTIONS(13534),
    [anon_sym_COLON_COLON] = ACTIONS(13534),
    [anon_sym_isa] = ACTIONS(13534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13534),
    [anon_sym_QMARK] = ACTIONS(13534),
    [anon_sym_AT] = ACTIONS(13534),
    [anon_sym_true] = ACTIONS(13534),
    [anon_sym_false] = ACTIONS(13534),
    [aux_sym_integer_literal_token1] = ACTIONS(13534),
    [aux_sym_integer_literal_token2] = ACTIONS(13534),
    [aux_sym_integer_literal_token3] = ACTIONS(13534),
    [aux_sym_integer_literal_token4] = ACTIONS(13534),
    [aux_sym_float_literal_token1] = ACTIONS(13534),
    [aux_sym_float_literal_token3] = ACTIONS(13534),
    [aux_sym_float_literal_token4] = ACTIONS(13534),
    [sym_character_literal] = ACTIONS(13534),
    [sym__pair_operator] = ACTIONS(13534),
    [sym__arrow_operator] = ACTIONS(13534),
    [sym__lazy_or_operator] = ACTIONS(13534),
    [sym__lazy_and_operator] = ACTIONS(13534),
    [sym__comparison_operator] = ACTIONS(13534),
    [sym__pipe_right_operator] = ACTIONS(13534),
    [sym__pipe_left_operator] = ACTIONS(13534),
    [sym__ellipsis_operator] = ACTIONS(13534),
    [sym__plus_operator] = ACTIONS(13534),
    [sym__times_operator] = ACTIONS(13534),
    [sym__rational_operator] = ACTIONS(13534),
    [sym__bitshift_operator] = ACTIONS(13534),
    [sym__power_operator] = ACTIONS(13534),
    [sym__tilde_operator] = ACTIONS(13534),
    [sym__type_order_operator] = ACTIONS(13534),
    [sym__unary_operator] = ACTIONS(13534),
    [sym__unary_plus_operator] = ACTIONS(13534),
    [aux_sym__terminator_token1] = ACTIONS(13534),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13536),
    [sym__command_start] = ACTIONS(13536),
  },
  [8218] = {
    [sym__word_identifier] = ACTIONS(13538),
    [anon_sym_EQ] = ACTIONS(13538),
    [anon_sym_COMMA] = ACTIONS(13538),
    [anon_sym_COLON] = ACTIONS(13538),
    [anon_sym_begin] = ACTIONS(13538),
    [anon_sym_module] = ACTIONS(13538),
    [anon_sym_baremodule] = ACTIONS(13538),
    [anon_sym_end] = ACTIONS(13538),
    [anon_sym_abstract] = ACTIONS(13538),
    [anon_sym_primitive] = ACTIONS(13538),
    [anon_sym_mutable] = ACTIONS(13538),
    [anon_sym_struct] = ACTIONS(13538),
    [anon_sym_function] = ACTIONS(13538),
    [anon_sym_macro] = ACTIONS(13538),
    [anon_sym_where] = ACTIONS(13538),
    [anon_sym_quote] = ACTIONS(13538),
    [anon_sym_let] = ACTIONS(13538),
    [anon_sym_if] = ACTIONS(13538),
    [anon_sym_try] = ACTIONS(13538),
    [anon_sym_finally] = ACTIONS(13538),
    [anon_sym_for] = ACTIONS(13538),
    [anon_sym_while] = ACTIONS(13538),
    [sym_break_statement] = ACTIONS(13538),
    [sym_continue_statement] = ACTIONS(13538),
    [anon_sym_return] = ACTIONS(13538),
    [anon_sym_const] = ACTIONS(13538),
    [anon_sym_global] = ACTIONS(13538),
    [anon_sym_local] = ACTIONS(13538),
    [anon_sym_LPAREN] = ACTIONS(13538),
    [anon_sym_COLON2] = ACTIONS(13538),
    [anon_sym_export] = ACTIONS(13538),
    [anon_sym_import] = ACTIONS(13538),
    [anon_sym_using] = ACTIONS(13538),
    [anon_sym_LBRACK] = ACTIONS(13538),
    [anon_sym_LF] = ACTIONS(13540),
    [anon_sym_in] = ACTIONS(13538),
    [anon_sym_LBRACE] = ACTIONS(13538),
    [anon_sym_DOLLAR] = ACTIONS(13538),
    [anon_sym_COLON_COLON] = ACTIONS(13538),
    [anon_sym_isa] = ACTIONS(13538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13538),
    [anon_sym_QMARK] = ACTIONS(13538),
    [anon_sym_AT] = ACTIONS(13538),
    [anon_sym_true] = ACTIONS(13538),
    [anon_sym_false] = ACTIONS(13538),
    [aux_sym_integer_literal_token1] = ACTIONS(13538),
    [aux_sym_integer_literal_token2] = ACTIONS(13538),
    [aux_sym_integer_literal_token3] = ACTIONS(13538),
    [aux_sym_integer_literal_token4] = ACTIONS(13538),
    [aux_sym_float_literal_token1] = ACTIONS(13538),
    [aux_sym_float_literal_token3] = ACTIONS(13538),
    [aux_sym_float_literal_token4] = ACTIONS(13538),
    [sym_character_literal] = ACTIONS(13538),
    [sym__pair_operator] = ACTIONS(13538),
    [sym__arrow_operator] = ACTIONS(13538),
    [sym__lazy_or_operator] = ACTIONS(13538),
    [sym__lazy_and_operator] = ACTIONS(13538),
    [sym__comparison_operator] = ACTIONS(13538),
    [sym__pipe_right_operator] = ACTIONS(13538),
    [sym__pipe_left_operator] = ACTIONS(13538),
    [sym__ellipsis_operator] = ACTIONS(13538),
    [sym__plus_operator] = ACTIONS(13538),
    [sym__times_operator] = ACTIONS(13538),
    [sym__rational_operator] = ACTIONS(13538),
    [sym__bitshift_operator] = ACTIONS(13538),
    [sym__power_operator] = ACTIONS(13538),
    [sym__tilde_operator] = ACTIONS(13538),
    [sym__type_order_operator] = ACTIONS(13538),
    [sym__unary_operator] = ACTIONS(13538),
    [sym__unary_plus_operator] = ACTIONS(13538),
    [aux_sym__terminator_token1] = ACTIONS(13538),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13540),
    [sym__command_start] = ACTIONS(13540),
  },
  [8219] = {
    [sym__word_identifier] = ACTIONS(13542),
    [anon_sym_EQ] = ACTIONS(13542),
    [anon_sym_COMMA] = ACTIONS(13542),
    [anon_sym_COLON] = ACTIONS(13542),
    [anon_sym_begin] = ACTIONS(13542),
    [anon_sym_module] = ACTIONS(13542),
    [anon_sym_baremodule] = ACTIONS(13542),
    [anon_sym_end] = ACTIONS(13542),
    [anon_sym_abstract] = ACTIONS(13542),
    [anon_sym_primitive] = ACTIONS(13542),
    [anon_sym_mutable] = ACTIONS(13542),
    [anon_sym_struct] = ACTIONS(13542),
    [anon_sym_function] = ACTIONS(13542),
    [anon_sym_macro] = ACTIONS(13542),
    [anon_sym_where] = ACTIONS(13542),
    [anon_sym_quote] = ACTIONS(13542),
    [anon_sym_let] = ACTIONS(13542),
    [anon_sym_if] = ACTIONS(13542),
    [anon_sym_try] = ACTIONS(13542),
    [anon_sym_finally] = ACTIONS(13542),
    [anon_sym_for] = ACTIONS(13542),
    [anon_sym_while] = ACTIONS(13542),
    [sym_break_statement] = ACTIONS(13542),
    [sym_continue_statement] = ACTIONS(13542),
    [anon_sym_return] = ACTIONS(13542),
    [anon_sym_const] = ACTIONS(13542),
    [anon_sym_global] = ACTIONS(13542),
    [anon_sym_local] = ACTIONS(13542),
    [anon_sym_LPAREN] = ACTIONS(13542),
    [anon_sym_COLON2] = ACTIONS(13542),
    [anon_sym_export] = ACTIONS(13542),
    [anon_sym_import] = ACTIONS(13542),
    [anon_sym_using] = ACTIONS(13542),
    [anon_sym_LBRACK] = ACTIONS(13542),
    [anon_sym_LF] = ACTIONS(13544),
    [anon_sym_in] = ACTIONS(13542),
    [anon_sym_LBRACE] = ACTIONS(13542),
    [anon_sym_DOLLAR] = ACTIONS(13542),
    [anon_sym_COLON_COLON] = ACTIONS(13542),
    [anon_sym_isa] = ACTIONS(13542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13542),
    [anon_sym_QMARK] = ACTIONS(13542),
    [anon_sym_AT] = ACTIONS(13542),
    [anon_sym_true] = ACTIONS(13542),
    [anon_sym_false] = ACTIONS(13542),
    [aux_sym_integer_literal_token1] = ACTIONS(13542),
    [aux_sym_integer_literal_token2] = ACTIONS(13542),
    [aux_sym_integer_literal_token3] = ACTIONS(13542),
    [aux_sym_integer_literal_token4] = ACTIONS(13542),
    [aux_sym_float_literal_token1] = ACTIONS(13542),
    [aux_sym_float_literal_token3] = ACTIONS(13542),
    [aux_sym_float_literal_token4] = ACTIONS(13542),
    [sym_character_literal] = ACTIONS(13542),
    [sym__pair_operator] = ACTIONS(13542),
    [sym__arrow_operator] = ACTIONS(13542),
    [sym__lazy_or_operator] = ACTIONS(13542),
    [sym__lazy_and_operator] = ACTIONS(13542),
    [sym__comparison_operator] = ACTIONS(13542),
    [sym__pipe_right_operator] = ACTIONS(13542),
    [sym__pipe_left_operator] = ACTIONS(13542),
    [sym__ellipsis_operator] = ACTIONS(13542),
    [sym__plus_operator] = ACTIONS(13542),
    [sym__times_operator] = ACTIONS(13542),
    [sym__rational_operator] = ACTIONS(13542),
    [sym__bitshift_operator] = ACTIONS(13542),
    [sym__power_operator] = ACTIONS(13542),
    [sym__tilde_operator] = ACTIONS(13542),
    [sym__type_order_operator] = ACTIONS(13542),
    [sym__unary_operator] = ACTIONS(13542),
    [sym__unary_plus_operator] = ACTIONS(13542),
    [aux_sym__terminator_token1] = ACTIONS(13542),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13544),
    [sym__command_start] = ACTIONS(13544),
  },
  [8220] = {
    [sym__word_identifier] = ACTIONS(13546),
    [anon_sym_EQ] = ACTIONS(13546),
    [anon_sym_COMMA] = ACTIONS(13546),
    [anon_sym_COLON] = ACTIONS(13546),
    [anon_sym_begin] = ACTIONS(13546),
    [anon_sym_module] = ACTIONS(13546),
    [anon_sym_baremodule] = ACTIONS(13546),
    [anon_sym_end] = ACTIONS(13546),
    [anon_sym_abstract] = ACTIONS(13546),
    [anon_sym_primitive] = ACTIONS(13546),
    [anon_sym_mutable] = ACTIONS(13546),
    [anon_sym_struct] = ACTIONS(13546),
    [anon_sym_function] = ACTIONS(13546),
    [anon_sym_macro] = ACTIONS(13546),
    [anon_sym_where] = ACTIONS(13546),
    [anon_sym_quote] = ACTIONS(13546),
    [anon_sym_let] = ACTIONS(13546),
    [anon_sym_if] = ACTIONS(13546),
    [anon_sym_try] = ACTIONS(13546),
    [anon_sym_finally] = ACTIONS(13546),
    [anon_sym_for] = ACTIONS(13546),
    [anon_sym_while] = ACTIONS(13546),
    [sym_break_statement] = ACTIONS(13546),
    [sym_continue_statement] = ACTIONS(13546),
    [anon_sym_return] = ACTIONS(13546),
    [anon_sym_const] = ACTIONS(13546),
    [anon_sym_global] = ACTIONS(13546),
    [anon_sym_local] = ACTIONS(13546),
    [anon_sym_LPAREN] = ACTIONS(13546),
    [anon_sym_COLON2] = ACTIONS(13546),
    [anon_sym_export] = ACTIONS(13546),
    [anon_sym_import] = ACTIONS(13546),
    [anon_sym_using] = ACTIONS(13546),
    [anon_sym_LBRACK] = ACTIONS(13546),
    [anon_sym_LF] = ACTIONS(13548),
    [anon_sym_in] = ACTIONS(13546),
    [anon_sym_LBRACE] = ACTIONS(13546),
    [anon_sym_DOLLAR] = ACTIONS(13546),
    [anon_sym_COLON_COLON] = ACTIONS(13546),
    [anon_sym_isa] = ACTIONS(13546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13546),
    [anon_sym_QMARK] = ACTIONS(13546),
    [anon_sym_AT] = ACTIONS(13546),
    [anon_sym_true] = ACTIONS(13546),
    [anon_sym_false] = ACTIONS(13546),
    [aux_sym_integer_literal_token1] = ACTIONS(13546),
    [aux_sym_integer_literal_token2] = ACTIONS(13546),
    [aux_sym_integer_literal_token3] = ACTIONS(13546),
    [aux_sym_integer_literal_token4] = ACTIONS(13546),
    [aux_sym_float_literal_token1] = ACTIONS(13546),
    [aux_sym_float_literal_token3] = ACTIONS(13546),
    [aux_sym_float_literal_token4] = ACTIONS(13546),
    [sym_character_literal] = ACTIONS(13546),
    [sym__pair_operator] = ACTIONS(13546),
    [sym__arrow_operator] = ACTIONS(13546),
    [sym__lazy_or_operator] = ACTIONS(13546),
    [sym__lazy_and_operator] = ACTIONS(13546),
    [sym__comparison_operator] = ACTIONS(13546),
    [sym__pipe_right_operator] = ACTIONS(13546),
    [sym__pipe_left_operator] = ACTIONS(13546),
    [sym__ellipsis_operator] = ACTIONS(13546),
    [sym__plus_operator] = ACTIONS(13546),
    [sym__times_operator] = ACTIONS(13546),
    [sym__rational_operator] = ACTIONS(13546),
    [sym__bitshift_operator] = ACTIONS(13546),
    [sym__power_operator] = ACTIONS(13546),
    [sym__tilde_operator] = ACTIONS(13546),
    [sym__type_order_operator] = ACTIONS(13546),
    [sym__unary_operator] = ACTIONS(13546),
    [sym__unary_plus_operator] = ACTIONS(13546),
    [aux_sym__terminator_token1] = ACTIONS(13546),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13548),
    [sym__command_start] = ACTIONS(13548),
  },
  [8221] = {
    [sym__word_identifier] = ACTIONS(13550),
    [anon_sym_EQ] = ACTIONS(13550),
    [anon_sym_COMMA] = ACTIONS(13550),
    [anon_sym_COLON] = ACTIONS(13550),
    [anon_sym_begin] = ACTIONS(13550),
    [anon_sym_module] = ACTIONS(13550),
    [anon_sym_baremodule] = ACTIONS(13550),
    [anon_sym_end] = ACTIONS(13550),
    [anon_sym_abstract] = ACTIONS(13550),
    [anon_sym_primitive] = ACTIONS(13550),
    [anon_sym_mutable] = ACTIONS(13550),
    [anon_sym_struct] = ACTIONS(13550),
    [anon_sym_function] = ACTIONS(13550),
    [anon_sym_macro] = ACTIONS(13550),
    [anon_sym_where] = ACTIONS(13550),
    [anon_sym_quote] = ACTIONS(13550),
    [anon_sym_let] = ACTIONS(13550),
    [anon_sym_if] = ACTIONS(13550),
    [anon_sym_try] = ACTIONS(13550),
    [anon_sym_finally] = ACTIONS(13550),
    [anon_sym_for] = ACTIONS(13550),
    [anon_sym_while] = ACTIONS(13550),
    [sym_break_statement] = ACTIONS(13550),
    [sym_continue_statement] = ACTIONS(13550),
    [anon_sym_return] = ACTIONS(13550),
    [anon_sym_const] = ACTIONS(13550),
    [anon_sym_global] = ACTIONS(13550),
    [anon_sym_local] = ACTIONS(13550),
    [anon_sym_LPAREN] = ACTIONS(13550),
    [anon_sym_COLON2] = ACTIONS(13550),
    [anon_sym_export] = ACTIONS(13550),
    [anon_sym_import] = ACTIONS(13550),
    [anon_sym_using] = ACTIONS(13550),
    [anon_sym_LBRACK] = ACTIONS(13550),
    [anon_sym_LF] = ACTIONS(13552),
    [anon_sym_in] = ACTIONS(13550),
    [anon_sym_LBRACE] = ACTIONS(13550),
    [anon_sym_DOLLAR] = ACTIONS(13550),
    [anon_sym_COLON_COLON] = ACTIONS(13550),
    [anon_sym_isa] = ACTIONS(13550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13550),
    [anon_sym_QMARK] = ACTIONS(13550),
    [anon_sym_AT] = ACTIONS(13550),
    [anon_sym_true] = ACTIONS(13550),
    [anon_sym_false] = ACTIONS(13550),
    [aux_sym_integer_literal_token1] = ACTIONS(13550),
    [aux_sym_integer_literal_token2] = ACTIONS(13550),
    [aux_sym_integer_literal_token3] = ACTIONS(13550),
    [aux_sym_integer_literal_token4] = ACTIONS(13550),
    [aux_sym_float_literal_token1] = ACTIONS(13550),
    [aux_sym_float_literal_token3] = ACTIONS(13550),
    [aux_sym_float_literal_token4] = ACTIONS(13550),
    [sym_character_literal] = ACTIONS(13550),
    [sym__pair_operator] = ACTIONS(13550),
    [sym__arrow_operator] = ACTIONS(13550),
    [sym__lazy_or_operator] = ACTIONS(13550),
    [sym__lazy_and_operator] = ACTIONS(13550),
    [sym__comparison_operator] = ACTIONS(13550),
    [sym__pipe_right_operator] = ACTIONS(13550),
    [sym__pipe_left_operator] = ACTIONS(13550),
    [sym__ellipsis_operator] = ACTIONS(13550),
    [sym__plus_operator] = ACTIONS(13550),
    [sym__times_operator] = ACTIONS(13550),
    [sym__rational_operator] = ACTIONS(13550),
    [sym__bitshift_operator] = ACTIONS(13550),
    [sym__power_operator] = ACTIONS(13550),
    [sym__tilde_operator] = ACTIONS(13550),
    [sym__type_order_operator] = ACTIONS(13550),
    [sym__unary_operator] = ACTIONS(13550),
    [sym__unary_plus_operator] = ACTIONS(13550),
    [aux_sym__terminator_token1] = ACTIONS(13550),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13552),
    [sym__command_start] = ACTIONS(13552),
  },
  [8222] = {
    [sym__word_identifier] = ACTIONS(13554),
    [anon_sym_EQ] = ACTIONS(13554),
    [anon_sym_COMMA] = ACTIONS(13554),
    [anon_sym_COLON] = ACTIONS(13554),
    [anon_sym_begin] = ACTIONS(13554),
    [anon_sym_module] = ACTIONS(13554),
    [anon_sym_baremodule] = ACTIONS(13554),
    [anon_sym_end] = ACTIONS(13554),
    [anon_sym_abstract] = ACTIONS(13554),
    [anon_sym_primitive] = ACTIONS(13554),
    [anon_sym_mutable] = ACTIONS(13554),
    [anon_sym_struct] = ACTIONS(13554),
    [anon_sym_function] = ACTIONS(13554),
    [anon_sym_macro] = ACTIONS(13554),
    [anon_sym_where] = ACTIONS(13554),
    [anon_sym_quote] = ACTIONS(13554),
    [anon_sym_let] = ACTIONS(13554),
    [anon_sym_if] = ACTIONS(13554),
    [anon_sym_try] = ACTIONS(13554),
    [anon_sym_finally] = ACTIONS(13554),
    [anon_sym_for] = ACTIONS(13554),
    [anon_sym_while] = ACTIONS(13554),
    [sym_break_statement] = ACTIONS(13554),
    [sym_continue_statement] = ACTIONS(13554),
    [anon_sym_return] = ACTIONS(13554),
    [anon_sym_const] = ACTIONS(13554),
    [anon_sym_global] = ACTIONS(13554),
    [anon_sym_local] = ACTIONS(13554),
    [anon_sym_LPAREN] = ACTIONS(13554),
    [anon_sym_COLON2] = ACTIONS(13554),
    [anon_sym_export] = ACTIONS(13554),
    [anon_sym_import] = ACTIONS(13554),
    [anon_sym_using] = ACTIONS(13554),
    [anon_sym_LBRACK] = ACTIONS(13554),
    [anon_sym_LF] = ACTIONS(13556),
    [anon_sym_in] = ACTIONS(13554),
    [anon_sym_LBRACE] = ACTIONS(13554),
    [anon_sym_DOLLAR] = ACTIONS(13554),
    [anon_sym_COLON_COLON] = ACTIONS(13554),
    [anon_sym_isa] = ACTIONS(13554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13554),
    [anon_sym_QMARK] = ACTIONS(13554),
    [anon_sym_AT] = ACTIONS(13554),
    [anon_sym_true] = ACTIONS(13554),
    [anon_sym_false] = ACTIONS(13554),
    [aux_sym_integer_literal_token1] = ACTIONS(13554),
    [aux_sym_integer_literal_token2] = ACTIONS(13554),
    [aux_sym_integer_literal_token3] = ACTIONS(13554),
    [aux_sym_integer_literal_token4] = ACTIONS(13554),
    [aux_sym_float_literal_token1] = ACTIONS(13554),
    [aux_sym_float_literal_token3] = ACTIONS(13554),
    [aux_sym_float_literal_token4] = ACTIONS(13554),
    [sym_character_literal] = ACTIONS(13554),
    [sym__pair_operator] = ACTIONS(13554),
    [sym__arrow_operator] = ACTIONS(13554),
    [sym__lazy_or_operator] = ACTIONS(13554),
    [sym__lazy_and_operator] = ACTIONS(13554),
    [sym__comparison_operator] = ACTIONS(13554),
    [sym__pipe_right_operator] = ACTIONS(13554),
    [sym__pipe_left_operator] = ACTIONS(13554),
    [sym__ellipsis_operator] = ACTIONS(13554),
    [sym__plus_operator] = ACTIONS(13554),
    [sym__times_operator] = ACTIONS(13554),
    [sym__rational_operator] = ACTIONS(13554),
    [sym__bitshift_operator] = ACTIONS(13554),
    [sym__power_operator] = ACTIONS(13554),
    [sym__tilde_operator] = ACTIONS(13554),
    [sym__type_order_operator] = ACTIONS(13554),
    [sym__unary_operator] = ACTIONS(13554),
    [sym__unary_plus_operator] = ACTIONS(13554),
    [aux_sym__terminator_token1] = ACTIONS(13554),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13556),
    [sym__command_start] = ACTIONS(13556),
  },
  [8223] = {
    [sym__word_identifier] = ACTIONS(13558),
    [anon_sym_EQ] = ACTIONS(13558),
    [anon_sym_COMMA] = ACTIONS(13558),
    [anon_sym_COLON] = ACTIONS(13558),
    [anon_sym_begin] = ACTIONS(13558),
    [anon_sym_module] = ACTIONS(13558),
    [anon_sym_baremodule] = ACTIONS(13558),
    [anon_sym_end] = ACTIONS(13558),
    [anon_sym_abstract] = ACTIONS(13558),
    [anon_sym_primitive] = ACTIONS(13558),
    [anon_sym_mutable] = ACTIONS(13558),
    [anon_sym_struct] = ACTIONS(13558),
    [anon_sym_function] = ACTIONS(13558),
    [anon_sym_macro] = ACTIONS(13558),
    [anon_sym_where] = ACTIONS(13558),
    [anon_sym_quote] = ACTIONS(13558),
    [anon_sym_let] = ACTIONS(13558),
    [anon_sym_if] = ACTIONS(13558),
    [anon_sym_try] = ACTIONS(13558),
    [anon_sym_finally] = ACTIONS(13558),
    [anon_sym_for] = ACTIONS(13558),
    [anon_sym_while] = ACTIONS(13558),
    [sym_break_statement] = ACTIONS(13558),
    [sym_continue_statement] = ACTIONS(13558),
    [anon_sym_return] = ACTIONS(13558),
    [anon_sym_const] = ACTIONS(13558),
    [anon_sym_global] = ACTIONS(13558),
    [anon_sym_local] = ACTIONS(13558),
    [anon_sym_LPAREN] = ACTIONS(13558),
    [anon_sym_COLON2] = ACTIONS(13558),
    [anon_sym_export] = ACTIONS(13558),
    [anon_sym_import] = ACTIONS(13558),
    [anon_sym_using] = ACTIONS(13558),
    [anon_sym_LBRACK] = ACTIONS(13558),
    [anon_sym_LF] = ACTIONS(13560),
    [anon_sym_in] = ACTIONS(13558),
    [anon_sym_LBRACE] = ACTIONS(13558),
    [anon_sym_DOLLAR] = ACTIONS(13558),
    [anon_sym_COLON_COLON] = ACTIONS(13558),
    [anon_sym_isa] = ACTIONS(13558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13558),
    [anon_sym_QMARK] = ACTIONS(13558),
    [anon_sym_AT] = ACTIONS(13558),
    [anon_sym_true] = ACTIONS(13558),
    [anon_sym_false] = ACTIONS(13558),
    [aux_sym_integer_literal_token1] = ACTIONS(13558),
    [aux_sym_integer_literal_token2] = ACTIONS(13558),
    [aux_sym_integer_literal_token3] = ACTIONS(13558),
    [aux_sym_integer_literal_token4] = ACTIONS(13558),
    [aux_sym_float_literal_token1] = ACTIONS(13558),
    [aux_sym_float_literal_token3] = ACTIONS(13558),
    [aux_sym_float_literal_token4] = ACTIONS(13558),
    [sym_character_literal] = ACTIONS(13558),
    [sym__pair_operator] = ACTIONS(13558),
    [sym__arrow_operator] = ACTIONS(13558),
    [sym__lazy_or_operator] = ACTIONS(13558),
    [sym__lazy_and_operator] = ACTIONS(13558),
    [sym__comparison_operator] = ACTIONS(13558),
    [sym__pipe_right_operator] = ACTIONS(13558),
    [sym__pipe_left_operator] = ACTIONS(13558),
    [sym__ellipsis_operator] = ACTIONS(13558),
    [sym__plus_operator] = ACTIONS(13558),
    [sym__times_operator] = ACTIONS(13558),
    [sym__rational_operator] = ACTIONS(13558),
    [sym__bitshift_operator] = ACTIONS(13558),
    [sym__power_operator] = ACTIONS(13558),
    [sym__tilde_operator] = ACTIONS(13558),
    [sym__type_order_operator] = ACTIONS(13558),
    [sym__unary_operator] = ACTIONS(13558),
    [sym__unary_plus_operator] = ACTIONS(13558),
    [aux_sym__terminator_token1] = ACTIONS(13558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13560),
    [sym__command_start] = ACTIONS(13560),
  },
  [8224] = {
    [sym__word_identifier] = ACTIONS(13562),
    [anon_sym_EQ] = ACTIONS(13562),
    [anon_sym_COMMA] = ACTIONS(13562),
    [anon_sym_COLON] = ACTIONS(13562),
    [anon_sym_begin] = ACTIONS(13562),
    [anon_sym_module] = ACTIONS(13562),
    [anon_sym_baremodule] = ACTIONS(13562),
    [anon_sym_end] = ACTIONS(13562),
    [anon_sym_abstract] = ACTIONS(13562),
    [anon_sym_primitive] = ACTIONS(13562),
    [anon_sym_mutable] = ACTIONS(13562),
    [anon_sym_struct] = ACTIONS(13562),
    [anon_sym_function] = ACTIONS(13562),
    [anon_sym_macro] = ACTIONS(13562),
    [anon_sym_where] = ACTIONS(13562),
    [anon_sym_quote] = ACTIONS(13562),
    [anon_sym_let] = ACTIONS(13562),
    [anon_sym_if] = ACTIONS(13562),
    [anon_sym_try] = ACTIONS(13562),
    [anon_sym_finally] = ACTIONS(13562),
    [anon_sym_for] = ACTIONS(13562),
    [anon_sym_while] = ACTIONS(13562),
    [sym_break_statement] = ACTIONS(13562),
    [sym_continue_statement] = ACTIONS(13562),
    [anon_sym_return] = ACTIONS(13562),
    [anon_sym_const] = ACTIONS(13562),
    [anon_sym_global] = ACTIONS(13562),
    [anon_sym_local] = ACTIONS(13562),
    [anon_sym_LPAREN] = ACTIONS(13562),
    [anon_sym_COLON2] = ACTIONS(13562),
    [anon_sym_export] = ACTIONS(13562),
    [anon_sym_import] = ACTIONS(13562),
    [anon_sym_using] = ACTIONS(13562),
    [anon_sym_LBRACK] = ACTIONS(13562),
    [anon_sym_LF] = ACTIONS(13564),
    [anon_sym_in] = ACTIONS(13562),
    [anon_sym_LBRACE] = ACTIONS(13562),
    [anon_sym_DOLLAR] = ACTIONS(13562),
    [anon_sym_COLON_COLON] = ACTIONS(13562),
    [anon_sym_isa] = ACTIONS(13562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13562),
    [anon_sym_QMARK] = ACTIONS(13562),
    [anon_sym_AT] = ACTIONS(13562),
    [anon_sym_true] = ACTIONS(13562),
    [anon_sym_false] = ACTIONS(13562),
    [aux_sym_integer_literal_token1] = ACTIONS(13562),
    [aux_sym_integer_literal_token2] = ACTIONS(13562),
    [aux_sym_integer_literal_token3] = ACTIONS(13562),
    [aux_sym_integer_literal_token4] = ACTIONS(13562),
    [aux_sym_float_literal_token1] = ACTIONS(13562),
    [aux_sym_float_literal_token3] = ACTIONS(13562),
    [aux_sym_float_literal_token4] = ACTIONS(13562),
    [sym_character_literal] = ACTIONS(13562),
    [sym__pair_operator] = ACTIONS(13562),
    [sym__arrow_operator] = ACTIONS(13562),
    [sym__lazy_or_operator] = ACTIONS(13562),
    [sym__lazy_and_operator] = ACTIONS(13562),
    [sym__comparison_operator] = ACTIONS(13562),
    [sym__pipe_right_operator] = ACTIONS(13562),
    [sym__pipe_left_operator] = ACTIONS(13562),
    [sym__ellipsis_operator] = ACTIONS(13562),
    [sym__plus_operator] = ACTIONS(13562),
    [sym__times_operator] = ACTIONS(13562),
    [sym__rational_operator] = ACTIONS(13562),
    [sym__bitshift_operator] = ACTIONS(13562),
    [sym__power_operator] = ACTIONS(13562),
    [sym__tilde_operator] = ACTIONS(13562),
    [sym__type_order_operator] = ACTIONS(13562),
    [sym__unary_operator] = ACTIONS(13562),
    [sym__unary_plus_operator] = ACTIONS(13562),
    [aux_sym__terminator_token1] = ACTIONS(13562),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13564),
    [sym__command_start] = ACTIONS(13564),
  },
  [8225] = {
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13094),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_finally] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13094),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13094),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13094),
    [anon_sym_isa] = ACTIONS(13094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13094),
    [anon_sym_QMARK] = ACTIONS(13094),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13094),
    [sym__lazy_or_operator] = ACTIONS(13094),
    [sym__lazy_and_operator] = ACTIONS(13094),
    [sym__comparison_operator] = ACTIONS(13094),
    [sym__pipe_right_operator] = ACTIONS(13094),
    [sym__pipe_left_operator] = ACTIONS(13094),
    [sym__ellipsis_operator] = ACTIONS(13094),
    [sym__plus_operator] = ACTIONS(13094),
    [sym__times_operator] = ACTIONS(13094),
    [sym__rational_operator] = ACTIONS(13094),
    [sym__bitshift_operator] = ACTIONS(13094),
    [sym__power_operator] = ACTIONS(13094),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13094),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13094),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8226] = {
    [sym__word_identifier] = ACTIONS(13566),
    [anon_sym_EQ] = ACTIONS(13566),
    [anon_sym_COMMA] = ACTIONS(13566),
    [anon_sym_COLON] = ACTIONS(13566),
    [anon_sym_begin] = ACTIONS(13566),
    [anon_sym_module] = ACTIONS(13566),
    [anon_sym_baremodule] = ACTIONS(13566),
    [anon_sym_end] = ACTIONS(13566),
    [anon_sym_abstract] = ACTIONS(13566),
    [anon_sym_primitive] = ACTIONS(13566),
    [anon_sym_mutable] = ACTIONS(13566),
    [anon_sym_struct] = ACTIONS(13566),
    [anon_sym_function] = ACTIONS(13566),
    [anon_sym_macro] = ACTIONS(13566),
    [anon_sym_where] = ACTIONS(13566),
    [anon_sym_quote] = ACTIONS(13566),
    [anon_sym_let] = ACTIONS(13566),
    [anon_sym_if] = ACTIONS(13566),
    [anon_sym_try] = ACTIONS(13566),
    [anon_sym_finally] = ACTIONS(13566),
    [anon_sym_for] = ACTIONS(13566),
    [anon_sym_while] = ACTIONS(13566),
    [sym_break_statement] = ACTIONS(13566),
    [sym_continue_statement] = ACTIONS(13566),
    [anon_sym_return] = ACTIONS(13566),
    [anon_sym_const] = ACTIONS(13566),
    [anon_sym_global] = ACTIONS(13566),
    [anon_sym_local] = ACTIONS(13566),
    [anon_sym_LPAREN] = ACTIONS(13566),
    [anon_sym_COLON2] = ACTIONS(13566),
    [anon_sym_export] = ACTIONS(13566),
    [anon_sym_import] = ACTIONS(13566),
    [anon_sym_using] = ACTIONS(13566),
    [anon_sym_LBRACK] = ACTIONS(13566),
    [anon_sym_LF] = ACTIONS(13568),
    [anon_sym_in] = ACTIONS(13566),
    [anon_sym_LBRACE] = ACTIONS(13566),
    [anon_sym_DOLLAR] = ACTIONS(13566),
    [anon_sym_COLON_COLON] = ACTIONS(13566),
    [anon_sym_isa] = ACTIONS(13566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13566),
    [anon_sym_QMARK] = ACTIONS(13566),
    [anon_sym_AT] = ACTIONS(13566),
    [anon_sym_true] = ACTIONS(13566),
    [anon_sym_false] = ACTIONS(13566),
    [aux_sym_integer_literal_token1] = ACTIONS(13566),
    [aux_sym_integer_literal_token2] = ACTIONS(13566),
    [aux_sym_integer_literal_token3] = ACTIONS(13566),
    [aux_sym_integer_literal_token4] = ACTIONS(13566),
    [aux_sym_float_literal_token1] = ACTIONS(13566),
    [aux_sym_float_literal_token3] = ACTIONS(13566),
    [aux_sym_float_literal_token4] = ACTIONS(13566),
    [sym_character_literal] = ACTIONS(13566),
    [sym__pair_operator] = ACTIONS(13566),
    [sym__arrow_operator] = ACTIONS(13566),
    [sym__lazy_or_operator] = ACTIONS(13566),
    [sym__lazy_and_operator] = ACTIONS(13566),
    [sym__comparison_operator] = ACTIONS(13566),
    [sym__pipe_right_operator] = ACTIONS(13566),
    [sym__pipe_left_operator] = ACTIONS(13566),
    [sym__ellipsis_operator] = ACTIONS(13566),
    [sym__plus_operator] = ACTIONS(13566),
    [sym__times_operator] = ACTIONS(13566),
    [sym__rational_operator] = ACTIONS(13566),
    [sym__bitshift_operator] = ACTIONS(13566),
    [sym__power_operator] = ACTIONS(13566),
    [sym__tilde_operator] = ACTIONS(13566),
    [sym__type_order_operator] = ACTIONS(13566),
    [sym__unary_operator] = ACTIONS(13566),
    [sym__unary_plus_operator] = ACTIONS(13566),
    [aux_sym__terminator_token1] = ACTIONS(13566),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13568),
    [sym__command_start] = ACTIONS(13568),
  },
  [8227] = {
    [sym__word_identifier] = ACTIONS(13570),
    [anon_sym_EQ] = ACTIONS(13570),
    [anon_sym_COMMA] = ACTIONS(13570),
    [anon_sym_COLON] = ACTIONS(13570),
    [anon_sym_begin] = ACTIONS(13570),
    [anon_sym_module] = ACTIONS(13570),
    [anon_sym_baremodule] = ACTIONS(13570),
    [anon_sym_end] = ACTIONS(13570),
    [anon_sym_abstract] = ACTIONS(13570),
    [anon_sym_primitive] = ACTIONS(13570),
    [anon_sym_mutable] = ACTIONS(13570),
    [anon_sym_struct] = ACTIONS(13570),
    [anon_sym_function] = ACTIONS(13570),
    [anon_sym_macro] = ACTIONS(13570),
    [anon_sym_where] = ACTIONS(13570),
    [anon_sym_quote] = ACTIONS(13570),
    [anon_sym_let] = ACTIONS(13570),
    [anon_sym_if] = ACTIONS(13570),
    [anon_sym_try] = ACTIONS(13570),
    [anon_sym_finally] = ACTIONS(13570),
    [anon_sym_for] = ACTIONS(13570),
    [anon_sym_while] = ACTIONS(13570),
    [sym_break_statement] = ACTIONS(13570),
    [sym_continue_statement] = ACTIONS(13570),
    [anon_sym_return] = ACTIONS(13570),
    [anon_sym_const] = ACTIONS(13570),
    [anon_sym_global] = ACTIONS(13570),
    [anon_sym_local] = ACTIONS(13570),
    [anon_sym_LPAREN] = ACTIONS(13570),
    [anon_sym_COLON2] = ACTIONS(13570),
    [anon_sym_export] = ACTIONS(13570),
    [anon_sym_import] = ACTIONS(13570),
    [anon_sym_using] = ACTIONS(13570),
    [anon_sym_LBRACK] = ACTIONS(13570),
    [anon_sym_LF] = ACTIONS(13572),
    [anon_sym_in] = ACTIONS(13570),
    [anon_sym_LBRACE] = ACTIONS(13570),
    [anon_sym_DOLLAR] = ACTIONS(13570),
    [anon_sym_COLON_COLON] = ACTIONS(13570),
    [anon_sym_isa] = ACTIONS(13570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13570),
    [anon_sym_QMARK] = ACTIONS(13570),
    [anon_sym_AT] = ACTIONS(13570),
    [anon_sym_true] = ACTIONS(13570),
    [anon_sym_false] = ACTIONS(13570),
    [aux_sym_integer_literal_token1] = ACTIONS(13570),
    [aux_sym_integer_literal_token2] = ACTIONS(13570),
    [aux_sym_integer_literal_token3] = ACTIONS(13570),
    [aux_sym_integer_literal_token4] = ACTIONS(13570),
    [aux_sym_float_literal_token1] = ACTIONS(13570),
    [aux_sym_float_literal_token3] = ACTIONS(13570),
    [aux_sym_float_literal_token4] = ACTIONS(13570),
    [sym_character_literal] = ACTIONS(13570),
    [sym__pair_operator] = ACTIONS(13570),
    [sym__arrow_operator] = ACTIONS(13570),
    [sym__lazy_or_operator] = ACTIONS(13570),
    [sym__lazy_and_operator] = ACTIONS(13570),
    [sym__comparison_operator] = ACTIONS(13570),
    [sym__pipe_right_operator] = ACTIONS(13570),
    [sym__pipe_left_operator] = ACTIONS(13570),
    [sym__ellipsis_operator] = ACTIONS(13570),
    [sym__plus_operator] = ACTIONS(13570),
    [sym__times_operator] = ACTIONS(13570),
    [sym__rational_operator] = ACTIONS(13570),
    [sym__bitshift_operator] = ACTIONS(13570),
    [sym__power_operator] = ACTIONS(13570),
    [sym__tilde_operator] = ACTIONS(13570),
    [sym__type_order_operator] = ACTIONS(13570),
    [sym__unary_operator] = ACTIONS(13570),
    [sym__unary_plus_operator] = ACTIONS(13570),
    [aux_sym__terminator_token1] = ACTIONS(13570),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13572),
    [sym__command_start] = ACTIONS(13572),
  },
  [8228] = {
    [sym__word_identifier] = ACTIONS(13574),
    [anon_sym_EQ] = ACTIONS(13574),
    [anon_sym_COMMA] = ACTIONS(13574),
    [anon_sym_COLON] = ACTIONS(13574),
    [anon_sym_begin] = ACTIONS(13574),
    [anon_sym_module] = ACTIONS(13574),
    [anon_sym_baremodule] = ACTIONS(13574),
    [anon_sym_end] = ACTIONS(13574),
    [anon_sym_abstract] = ACTIONS(13574),
    [anon_sym_primitive] = ACTIONS(13574),
    [anon_sym_mutable] = ACTIONS(13574),
    [anon_sym_struct] = ACTIONS(13574),
    [anon_sym_function] = ACTIONS(13574),
    [anon_sym_macro] = ACTIONS(13574),
    [anon_sym_where] = ACTIONS(13574),
    [anon_sym_quote] = ACTIONS(13574),
    [anon_sym_let] = ACTIONS(13574),
    [anon_sym_if] = ACTIONS(13574),
    [anon_sym_try] = ACTIONS(13574),
    [anon_sym_finally] = ACTIONS(13574),
    [anon_sym_for] = ACTIONS(13574),
    [anon_sym_while] = ACTIONS(13574),
    [sym_break_statement] = ACTIONS(13574),
    [sym_continue_statement] = ACTIONS(13574),
    [anon_sym_return] = ACTIONS(13574),
    [anon_sym_const] = ACTIONS(13574),
    [anon_sym_global] = ACTIONS(13574),
    [anon_sym_local] = ACTIONS(13574),
    [anon_sym_LPAREN] = ACTIONS(13574),
    [anon_sym_COLON2] = ACTIONS(13574),
    [anon_sym_export] = ACTIONS(13574),
    [anon_sym_import] = ACTIONS(13574),
    [anon_sym_using] = ACTIONS(13574),
    [anon_sym_LBRACK] = ACTIONS(13574),
    [anon_sym_LF] = ACTIONS(13576),
    [anon_sym_in] = ACTIONS(13574),
    [anon_sym_LBRACE] = ACTIONS(13574),
    [anon_sym_DOLLAR] = ACTIONS(13574),
    [anon_sym_COLON_COLON] = ACTIONS(13574),
    [anon_sym_isa] = ACTIONS(13574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13574),
    [anon_sym_QMARK] = ACTIONS(13574),
    [anon_sym_AT] = ACTIONS(13574),
    [anon_sym_true] = ACTIONS(13574),
    [anon_sym_false] = ACTIONS(13574),
    [aux_sym_integer_literal_token1] = ACTIONS(13574),
    [aux_sym_integer_literal_token2] = ACTIONS(13574),
    [aux_sym_integer_literal_token3] = ACTIONS(13574),
    [aux_sym_integer_literal_token4] = ACTIONS(13574),
    [aux_sym_float_literal_token1] = ACTIONS(13574),
    [aux_sym_float_literal_token3] = ACTIONS(13574),
    [aux_sym_float_literal_token4] = ACTIONS(13574),
    [sym_character_literal] = ACTIONS(13574),
    [sym__pair_operator] = ACTIONS(13574),
    [sym__arrow_operator] = ACTIONS(13574),
    [sym__lazy_or_operator] = ACTIONS(13574),
    [sym__lazy_and_operator] = ACTIONS(13574),
    [sym__comparison_operator] = ACTIONS(13574),
    [sym__pipe_right_operator] = ACTIONS(13574),
    [sym__pipe_left_operator] = ACTIONS(13574),
    [sym__ellipsis_operator] = ACTIONS(13574),
    [sym__plus_operator] = ACTIONS(13574),
    [sym__times_operator] = ACTIONS(13574),
    [sym__rational_operator] = ACTIONS(13574),
    [sym__bitshift_operator] = ACTIONS(13574),
    [sym__power_operator] = ACTIONS(13574),
    [sym__tilde_operator] = ACTIONS(13574),
    [sym__type_order_operator] = ACTIONS(13574),
    [sym__unary_operator] = ACTIONS(13574),
    [sym__unary_plus_operator] = ACTIONS(13574),
    [aux_sym__terminator_token1] = ACTIONS(13574),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13576),
    [sym__command_start] = ACTIONS(13576),
  },
  [8229] = {
    [sym__word_identifier] = ACTIONS(13578),
    [anon_sym_EQ] = ACTIONS(13578),
    [anon_sym_COMMA] = ACTIONS(13578),
    [anon_sym_COLON] = ACTIONS(13578),
    [anon_sym_begin] = ACTIONS(13578),
    [anon_sym_module] = ACTIONS(13578),
    [anon_sym_baremodule] = ACTIONS(13578),
    [anon_sym_end] = ACTIONS(13578),
    [anon_sym_abstract] = ACTIONS(13578),
    [anon_sym_primitive] = ACTIONS(13578),
    [anon_sym_mutable] = ACTIONS(13578),
    [anon_sym_struct] = ACTIONS(13578),
    [anon_sym_function] = ACTIONS(13578),
    [anon_sym_macro] = ACTIONS(13578),
    [anon_sym_where] = ACTIONS(13578),
    [anon_sym_quote] = ACTIONS(13578),
    [anon_sym_let] = ACTIONS(13578),
    [anon_sym_if] = ACTIONS(13578),
    [anon_sym_try] = ACTIONS(13578),
    [anon_sym_finally] = ACTIONS(13578),
    [anon_sym_for] = ACTIONS(13578),
    [anon_sym_while] = ACTIONS(13578),
    [sym_break_statement] = ACTIONS(13578),
    [sym_continue_statement] = ACTIONS(13578),
    [anon_sym_return] = ACTIONS(13578),
    [anon_sym_const] = ACTIONS(13578),
    [anon_sym_global] = ACTIONS(13578),
    [anon_sym_local] = ACTIONS(13578),
    [anon_sym_LPAREN] = ACTIONS(13578),
    [anon_sym_COLON2] = ACTIONS(13578),
    [anon_sym_export] = ACTIONS(13578),
    [anon_sym_import] = ACTIONS(13578),
    [anon_sym_using] = ACTIONS(13578),
    [anon_sym_LBRACK] = ACTIONS(13578),
    [anon_sym_LF] = ACTIONS(13580),
    [anon_sym_in] = ACTIONS(13578),
    [anon_sym_LBRACE] = ACTIONS(13578),
    [anon_sym_DOLLAR] = ACTIONS(13578),
    [anon_sym_COLON_COLON] = ACTIONS(13578),
    [anon_sym_isa] = ACTIONS(13578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13578),
    [anon_sym_QMARK] = ACTIONS(13578),
    [anon_sym_AT] = ACTIONS(13578),
    [anon_sym_true] = ACTIONS(13578),
    [anon_sym_false] = ACTIONS(13578),
    [aux_sym_integer_literal_token1] = ACTIONS(13578),
    [aux_sym_integer_literal_token2] = ACTIONS(13578),
    [aux_sym_integer_literal_token3] = ACTIONS(13578),
    [aux_sym_integer_literal_token4] = ACTIONS(13578),
    [aux_sym_float_literal_token1] = ACTIONS(13578),
    [aux_sym_float_literal_token3] = ACTIONS(13578),
    [aux_sym_float_literal_token4] = ACTIONS(13578),
    [sym_character_literal] = ACTIONS(13578),
    [sym__pair_operator] = ACTIONS(13578),
    [sym__arrow_operator] = ACTIONS(13578),
    [sym__lazy_or_operator] = ACTIONS(13578),
    [sym__lazy_and_operator] = ACTIONS(13578),
    [sym__comparison_operator] = ACTIONS(13578),
    [sym__pipe_right_operator] = ACTIONS(13578),
    [sym__pipe_left_operator] = ACTIONS(13578),
    [sym__ellipsis_operator] = ACTIONS(13578),
    [sym__plus_operator] = ACTIONS(13578),
    [sym__times_operator] = ACTIONS(13578),
    [sym__rational_operator] = ACTIONS(13578),
    [sym__bitshift_operator] = ACTIONS(13578),
    [sym__power_operator] = ACTIONS(13578),
    [sym__tilde_operator] = ACTIONS(13578),
    [sym__type_order_operator] = ACTIONS(13578),
    [sym__unary_operator] = ACTIONS(13578),
    [sym__unary_plus_operator] = ACTIONS(13578),
    [aux_sym__terminator_token1] = ACTIONS(13578),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13580),
    [sym__command_start] = ACTIONS(13580),
  },
  [8230] = {
    [sym__word_identifier] = ACTIONS(13582),
    [anon_sym_EQ] = ACTIONS(13582),
    [anon_sym_COMMA] = ACTIONS(13582),
    [anon_sym_COLON] = ACTIONS(13582),
    [anon_sym_begin] = ACTIONS(13582),
    [anon_sym_module] = ACTIONS(13582),
    [anon_sym_baremodule] = ACTIONS(13582),
    [anon_sym_end] = ACTIONS(13582),
    [anon_sym_abstract] = ACTIONS(13582),
    [anon_sym_primitive] = ACTIONS(13582),
    [anon_sym_mutable] = ACTIONS(13582),
    [anon_sym_struct] = ACTIONS(13582),
    [anon_sym_function] = ACTIONS(13582),
    [anon_sym_macro] = ACTIONS(13582),
    [anon_sym_where] = ACTIONS(13582),
    [anon_sym_quote] = ACTIONS(13582),
    [anon_sym_let] = ACTIONS(13582),
    [anon_sym_if] = ACTIONS(13582),
    [anon_sym_try] = ACTIONS(13582),
    [anon_sym_finally] = ACTIONS(13582),
    [anon_sym_for] = ACTIONS(13582),
    [anon_sym_while] = ACTIONS(13582),
    [sym_break_statement] = ACTIONS(13582),
    [sym_continue_statement] = ACTIONS(13582),
    [anon_sym_return] = ACTIONS(13582),
    [anon_sym_const] = ACTIONS(13582),
    [anon_sym_global] = ACTIONS(13582),
    [anon_sym_local] = ACTIONS(13582),
    [anon_sym_LPAREN] = ACTIONS(13582),
    [anon_sym_COLON2] = ACTIONS(13582),
    [anon_sym_export] = ACTIONS(13582),
    [anon_sym_import] = ACTIONS(13582),
    [anon_sym_using] = ACTIONS(13582),
    [anon_sym_LBRACK] = ACTIONS(13582),
    [anon_sym_LF] = ACTIONS(13584),
    [anon_sym_in] = ACTIONS(13582),
    [anon_sym_LBRACE] = ACTIONS(13582),
    [anon_sym_DOLLAR] = ACTIONS(13582),
    [anon_sym_COLON_COLON] = ACTIONS(13582),
    [anon_sym_isa] = ACTIONS(13582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13582),
    [anon_sym_QMARK] = ACTIONS(13582),
    [anon_sym_AT] = ACTIONS(13582),
    [anon_sym_true] = ACTIONS(13582),
    [anon_sym_false] = ACTIONS(13582),
    [aux_sym_integer_literal_token1] = ACTIONS(13582),
    [aux_sym_integer_literal_token2] = ACTIONS(13582),
    [aux_sym_integer_literal_token3] = ACTIONS(13582),
    [aux_sym_integer_literal_token4] = ACTIONS(13582),
    [aux_sym_float_literal_token1] = ACTIONS(13582),
    [aux_sym_float_literal_token3] = ACTIONS(13582),
    [aux_sym_float_literal_token4] = ACTIONS(13582),
    [sym_character_literal] = ACTIONS(13582),
    [sym__pair_operator] = ACTIONS(13582),
    [sym__arrow_operator] = ACTIONS(13582),
    [sym__lazy_or_operator] = ACTIONS(13582),
    [sym__lazy_and_operator] = ACTIONS(13582),
    [sym__comparison_operator] = ACTIONS(13582),
    [sym__pipe_right_operator] = ACTIONS(13582),
    [sym__pipe_left_operator] = ACTIONS(13582),
    [sym__ellipsis_operator] = ACTIONS(13582),
    [sym__plus_operator] = ACTIONS(13582),
    [sym__times_operator] = ACTIONS(13582),
    [sym__rational_operator] = ACTIONS(13582),
    [sym__bitshift_operator] = ACTIONS(13582),
    [sym__power_operator] = ACTIONS(13582),
    [sym__tilde_operator] = ACTIONS(13582),
    [sym__type_order_operator] = ACTIONS(13582),
    [sym__unary_operator] = ACTIONS(13582),
    [sym__unary_plus_operator] = ACTIONS(13582),
    [aux_sym__terminator_token1] = ACTIONS(13582),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13584),
    [sym__command_start] = ACTIONS(13584),
  },
  [8231] = {
    [sym__word_identifier] = ACTIONS(13586),
    [anon_sym_EQ] = ACTIONS(13586),
    [anon_sym_COMMA] = ACTIONS(13586),
    [anon_sym_COLON] = ACTIONS(13586),
    [anon_sym_begin] = ACTIONS(13586),
    [anon_sym_module] = ACTIONS(13586),
    [anon_sym_baremodule] = ACTIONS(13586),
    [anon_sym_end] = ACTIONS(13586),
    [anon_sym_abstract] = ACTIONS(13586),
    [anon_sym_primitive] = ACTIONS(13586),
    [anon_sym_mutable] = ACTIONS(13586),
    [anon_sym_struct] = ACTIONS(13586),
    [anon_sym_function] = ACTIONS(13586),
    [anon_sym_macro] = ACTIONS(13586),
    [anon_sym_where] = ACTIONS(13586),
    [anon_sym_quote] = ACTIONS(13586),
    [anon_sym_let] = ACTIONS(13586),
    [anon_sym_if] = ACTIONS(13586),
    [anon_sym_try] = ACTIONS(13586),
    [anon_sym_finally] = ACTIONS(13586),
    [anon_sym_for] = ACTIONS(13586),
    [anon_sym_while] = ACTIONS(13586),
    [sym_break_statement] = ACTIONS(13586),
    [sym_continue_statement] = ACTIONS(13586),
    [anon_sym_return] = ACTIONS(13586),
    [anon_sym_const] = ACTIONS(13586),
    [anon_sym_global] = ACTIONS(13586),
    [anon_sym_local] = ACTIONS(13586),
    [anon_sym_LPAREN] = ACTIONS(13586),
    [anon_sym_COLON2] = ACTIONS(13586),
    [anon_sym_export] = ACTIONS(13586),
    [anon_sym_import] = ACTIONS(13586),
    [anon_sym_using] = ACTIONS(13586),
    [anon_sym_LBRACK] = ACTIONS(13586),
    [anon_sym_LF] = ACTIONS(13588),
    [anon_sym_in] = ACTIONS(13586),
    [anon_sym_LBRACE] = ACTIONS(13586),
    [anon_sym_DOLLAR] = ACTIONS(13586),
    [anon_sym_COLON_COLON] = ACTIONS(13586),
    [anon_sym_isa] = ACTIONS(13586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13586),
    [anon_sym_QMARK] = ACTIONS(13586),
    [anon_sym_AT] = ACTIONS(13586),
    [anon_sym_true] = ACTIONS(13586),
    [anon_sym_false] = ACTIONS(13586),
    [aux_sym_integer_literal_token1] = ACTIONS(13586),
    [aux_sym_integer_literal_token2] = ACTIONS(13586),
    [aux_sym_integer_literal_token3] = ACTIONS(13586),
    [aux_sym_integer_literal_token4] = ACTIONS(13586),
    [aux_sym_float_literal_token1] = ACTIONS(13586),
    [aux_sym_float_literal_token3] = ACTIONS(13586),
    [aux_sym_float_literal_token4] = ACTIONS(13586),
    [sym_character_literal] = ACTIONS(13586),
    [sym__pair_operator] = ACTIONS(13586),
    [sym__arrow_operator] = ACTIONS(13586),
    [sym__lazy_or_operator] = ACTIONS(13586),
    [sym__lazy_and_operator] = ACTIONS(13586),
    [sym__comparison_operator] = ACTIONS(13586),
    [sym__pipe_right_operator] = ACTIONS(13586),
    [sym__pipe_left_operator] = ACTIONS(13586),
    [sym__ellipsis_operator] = ACTIONS(13586),
    [sym__plus_operator] = ACTIONS(13586),
    [sym__times_operator] = ACTIONS(13586),
    [sym__rational_operator] = ACTIONS(13586),
    [sym__bitshift_operator] = ACTIONS(13586),
    [sym__power_operator] = ACTIONS(13586),
    [sym__tilde_operator] = ACTIONS(13586),
    [sym__type_order_operator] = ACTIONS(13586),
    [sym__unary_operator] = ACTIONS(13586),
    [sym__unary_plus_operator] = ACTIONS(13586),
    [aux_sym__terminator_token1] = ACTIONS(13586),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13588),
    [sym__command_start] = ACTIONS(13588),
  },
  [8232] = {
    [sym__word_identifier] = ACTIONS(13590),
    [anon_sym_EQ] = ACTIONS(13590),
    [anon_sym_COMMA] = ACTIONS(13590),
    [anon_sym_COLON] = ACTIONS(13590),
    [anon_sym_begin] = ACTIONS(13590),
    [anon_sym_module] = ACTIONS(13590),
    [anon_sym_baremodule] = ACTIONS(13590),
    [anon_sym_end] = ACTIONS(13590),
    [anon_sym_abstract] = ACTIONS(13590),
    [anon_sym_primitive] = ACTIONS(13590),
    [anon_sym_mutable] = ACTIONS(13590),
    [anon_sym_struct] = ACTIONS(13590),
    [anon_sym_function] = ACTIONS(13590),
    [anon_sym_macro] = ACTIONS(13590),
    [anon_sym_where] = ACTIONS(13590),
    [anon_sym_quote] = ACTIONS(13590),
    [anon_sym_let] = ACTIONS(13590),
    [anon_sym_if] = ACTIONS(13590),
    [anon_sym_try] = ACTIONS(13590),
    [anon_sym_finally] = ACTIONS(13590),
    [anon_sym_for] = ACTIONS(13590),
    [anon_sym_while] = ACTIONS(13590),
    [sym_break_statement] = ACTIONS(13590),
    [sym_continue_statement] = ACTIONS(13590),
    [anon_sym_return] = ACTIONS(13590),
    [anon_sym_const] = ACTIONS(13590),
    [anon_sym_global] = ACTIONS(13590),
    [anon_sym_local] = ACTIONS(13590),
    [anon_sym_LPAREN] = ACTIONS(13590),
    [anon_sym_COLON2] = ACTIONS(13590),
    [anon_sym_export] = ACTIONS(13590),
    [anon_sym_import] = ACTIONS(13590),
    [anon_sym_using] = ACTIONS(13590),
    [anon_sym_LBRACK] = ACTIONS(13590),
    [anon_sym_LF] = ACTIONS(13592),
    [anon_sym_in] = ACTIONS(13590),
    [anon_sym_LBRACE] = ACTIONS(13590),
    [anon_sym_DOLLAR] = ACTIONS(13590),
    [anon_sym_COLON_COLON] = ACTIONS(13590),
    [anon_sym_isa] = ACTIONS(13590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13590),
    [anon_sym_QMARK] = ACTIONS(13590),
    [anon_sym_AT] = ACTIONS(13590),
    [anon_sym_true] = ACTIONS(13590),
    [anon_sym_false] = ACTIONS(13590),
    [aux_sym_integer_literal_token1] = ACTIONS(13590),
    [aux_sym_integer_literal_token2] = ACTIONS(13590),
    [aux_sym_integer_literal_token3] = ACTIONS(13590),
    [aux_sym_integer_literal_token4] = ACTIONS(13590),
    [aux_sym_float_literal_token1] = ACTIONS(13590),
    [aux_sym_float_literal_token3] = ACTIONS(13590),
    [aux_sym_float_literal_token4] = ACTIONS(13590),
    [sym_character_literal] = ACTIONS(13590),
    [sym__pair_operator] = ACTIONS(13590),
    [sym__arrow_operator] = ACTIONS(13590),
    [sym__lazy_or_operator] = ACTIONS(13590),
    [sym__lazy_and_operator] = ACTIONS(13590),
    [sym__comparison_operator] = ACTIONS(13590),
    [sym__pipe_right_operator] = ACTIONS(13590),
    [sym__pipe_left_operator] = ACTIONS(13590),
    [sym__ellipsis_operator] = ACTIONS(13590),
    [sym__plus_operator] = ACTIONS(13590),
    [sym__times_operator] = ACTIONS(13590),
    [sym__rational_operator] = ACTIONS(13590),
    [sym__bitshift_operator] = ACTIONS(13590),
    [sym__power_operator] = ACTIONS(13590),
    [sym__tilde_operator] = ACTIONS(13590),
    [sym__type_order_operator] = ACTIONS(13590),
    [sym__unary_operator] = ACTIONS(13590),
    [sym__unary_plus_operator] = ACTIONS(13590),
    [aux_sym__terminator_token1] = ACTIONS(13590),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13592),
    [sym__command_start] = ACTIONS(13592),
  },
  [8233] = {
    [sym__word_identifier] = ACTIONS(13594),
    [anon_sym_EQ] = ACTIONS(13594),
    [anon_sym_COMMA] = ACTIONS(13594),
    [anon_sym_COLON] = ACTIONS(13594),
    [anon_sym_begin] = ACTIONS(13594),
    [anon_sym_module] = ACTIONS(13594),
    [anon_sym_baremodule] = ACTIONS(13594),
    [anon_sym_end] = ACTIONS(13594),
    [anon_sym_abstract] = ACTIONS(13594),
    [anon_sym_primitive] = ACTIONS(13594),
    [anon_sym_mutable] = ACTIONS(13594),
    [anon_sym_struct] = ACTIONS(13594),
    [anon_sym_function] = ACTIONS(13594),
    [anon_sym_macro] = ACTIONS(13594),
    [anon_sym_where] = ACTIONS(13594),
    [anon_sym_quote] = ACTIONS(13594),
    [anon_sym_let] = ACTIONS(13594),
    [anon_sym_if] = ACTIONS(13594),
    [anon_sym_try] = ACTIONS(13594),
    [anon_sym_finally] = ACTIONS(13594),
    [anon_sym_for] = ACTIONS(13594),
    [anon_sym_while] = ACTIONS(13594),
    [sym_break_statement] = ACTIONS(13594),
    [sym_continue_statement] = ACTIONS(13594),
    [anon_sym_return] = ACTIONS(13594),
    [anon_sym_const] = ACTIONS(13594),
    [anon_sym_global] = ACTIONS(13594),
    [anon_sym_local] = ACTIONS(13594),
    [anon_sym_LPAREN] = ACTIONS(13594),
    [anon_sym_COLON2] = ACTIONS(13594),
    [anon_sym_export] = ACTIONS(13594),
    [anon_sym_import] = ACTIONS(13594),
    [anon_sym_using] = ACTIONS(13594),
    [anon_sym_LBRACK] = ACTIONS(13594),
    [anon_sym_LF] = ACTIONS(13596),
    [anon_sym_in] = ACTIONS(13594),
    [anon_sym_LBRACE] = ACTIONS(13594),
    [anon_sym_DOLLAR] = ACTIONS(13594),
    [anon_sym_COLON_COLON] = ACTIONS(13594),
    [anon_sym_isa] = ACTIONS(13594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13594),
    [anon_sym_QMARK] = ACTIONS(13594),
    [anon_sym_AT] = ACTIONS(13594),
    [anon_sym_true] = ACTIONS(13594),
    [anon_sym_false] = ACTIONS(13594),
    [aux_sym_integer_literal_token1] = ACTIONS(13594),
    [aux_sym_integer_literal_token2] = ACTIONS(13594),
    [aux_sym_integer_literal_token3] = ACTIONS(13594),
    [aux_sym_integer_literal_token4] = ACTIONS(13594),
    [aux_sym_float_literal_token1] = ACTIONS(13594),
    [aux_sym_float_literal_token3] = ACTIONS(13594),
    [aux_sym_float_literal_token4] = ACTIONS(13594),
    [sym_character_literal] = ACTIONS(13594),
    [sym__pair_operator] = ACTIONS(13594),
    [sym__arrow_operator] = ACTIONS(13594),
    [sym__lazy_or_operator] = ACTIONS(13594),
    [sym__lazy_and_operator] = ACTIONS(13594),
    [sym__comparison_operator] = ACTIONS(13594),
    [sym__pipe_right_operator] = ACTIONS(13594),
    [sym__pipe_left_operator] = ACTIONS(13594),
    [sym__ellipsis_operator] = ACTIONS(13594),
    [sym__plus_operator] = ACTIONS(13594),
    [sym__times_operator] = ACTIONS(13594),
    [sym__rational_operator] = ACTIONS(13594),
    [sym__bitshift_operator] = ACTIONS(13594),
    [sym__power_operator] = ACTIONS(13594),
    [sym__tilde_operator] = ACTIONS(13594),
    [sym__type_order_operator] = ACTIONS(13594),
    [sym__unary_operator] = ACTIONS(13594),
    [sym__unary_plus_operator] = ACTIONS(13594),
    [aux_sym__terminator_token1] = ACTIONS(13594),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13596),
    [sym__command_start] = ACTIONS(13596),
  },
  [8234] = {
    [sym__word_identifier] = ACTIONS(13598),
    [anon_sym_EQ] = ACTIONS(13598),
    [anon_sym_COMMA] = ACTIONS(13598),
    [anon_sym_COLON] = ACTIONS(13598),
    [anon_sym_begin] = ACTIONS(13598),
    [anon_sym_module] = ACTIONS(13598),
    [anon_sym_baremodule] = ACTIONS(13598),
    [anon_sym_end] = ACTIONS(13598),
    [anon_sym_abstract] = ACTIONS(13598),
    [anon_sym_primitive] = ACTIONS(13598),
    [anon_sym_mutable] = ACTIONS(13598),
    [anon_sym_struct] = ACTIONS(13598),
    [anon_sym_function] = ACTIONS(13598),
    [anon_sym_macro] = ACTIONS(13598),
    [anon_sym_where] = ACTIONS(13598),
    [anon_sym_quote] = ACTIONS(13598),
    [anon_sym_let] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(13598),
    [anon_sym_try] = ACTIONS(13598),
    [anon_sym_finally] = ACTIONS(13598),
    [anon_sym_for] = ACTIONS(13598),
    [anon_sym_while] = ACTIONS(13598),
    [sym_break_statement] = ACTIONS(13598),
    [sym_continue_statement] = ACTIONS(13598),
    [anon_sym_return] = ACTIONS(13598),
    [anon_sym_const] = ACTIONS(13598),
    [anon_sym_global] = ACTIONS(13598),
    [anon_sym_local] = ACTIONS(13598),
    [anon_sym_LPAREN] = ACTIONS(13598),
    [anon_sym_COLON2] = ACTIONS(13598),
    [anon_sym_export] = ACTIONS(13598),
    [anon_sym_import] = ACTIONS(13598),
    [anon_sym_using] = ACTIONS(13598),
    [anon_sym_LBRACK] = ACTIONS(13598),
    [anon_sym_LF] = ACTIONS(13600),
    [anon_sym_in] = ACTIONS(13598),
    [anon_sym_LBRACE] = ACTIONS(13598),
    [anon_sym_DOLLAR] = ACTIONS(13598),
    [anon_sym_COLON_COLON] = ACTIONS(13598),
    [anon_sym_isa] = ACTIONS(13598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13598),
    [anon_sym_QMARK] = ACTIONS(13598),
    [anon_sym_AT] = ACTIONS(13598),
    [anon_sym_true] = ACTIONS(13598),
    [anon_sym_false] = ACTIONS(13598),
    [aux_sym_integer_literal_token1] = ACTIONS(13598),
    [aux_sym_integer_literal_token2] = ACTIONS(13598),
    [aux_sym_integer_literal_token3] = ACTIONS(13598),
    [aux_sym_integer_literal_token4] = ACTIONS(13598),
    [aux_sym_float_literal_token1] = ACTIONS(13598),
    [aux_sym_float_literal_token3] = ACTIONS(13598),
    [aux_sym_float_literal_token4] = ACTIONS(13598),
    [sym_character_literal] = ACTIONS(13598),
    [sym__pair_operator] = ACTIONS(13598),
    [sym__arrow_operator] = ACTIONS(13598),
    [sym__lazy_or_operator] = ACTIONS(13598),
    [sym__lazy_and_operator] = ACTIONS(13598),
    [sym__comparison_operator] = ACTIONS(13598),
    [sym__pipe_right_operator] = ACTIONS(13598),
    [sym__pipe_left_operator] = ACTIONS(13598),
    [sym__ellipsis_operator] = ACTIONS(13598),
    [sym__plus_operator] = ACTIONS(13598),
    [sym__times_operator] = ACTIONS(13598),
    [sym__rational_operator] = ACTIONS(13598),
    [sym__bitshift_operator] = ACTIONS(13598),
    [sym__power_operator] = ACTIONS(13598),
    [sym__tilde_operator] = ACTIONS(13598),
    [sym__type_order_operator] = ACTIONS(13598),
    [sym__unary_operator] = ACTIONS(13598),
    [sym__unary_plus_operator] = ACTIONS(13598),
    [aux_sym__terminator_token1] = ACTIONS(13598),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13600),
    [sym__command_start] = ACTIONS(13600),
  },
  [8235] = {
    [sym__word_identifier] = ACTIONS(13602),
    [anon_sym_EQ] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(13602),
    [anon_sym_COLON] = ACTIONS(13602),
    [anon_sym_begin] = ACTIONS(13602),
    [anon_sym_module] = ACTIONS(13602),
    [anon_sym_baremodule] = ACTIONS(13602),
    [anon_sym_end] = ACTIONS(13602),
    [anon_sym_abstract] = ACTIONS(13602),
    [anon_sym_primitive] = ACTIONS(13602),
    [anon_sym_mutable] = ACTIONS(13602),
    [anon_sym_struct] = ACTIONS(13602),
    [anon_sym_function] = ACTIONS(13602),
    [anon_sym_macro] = ACTIONS(13602),
    [anon_sym_where] = ACTIONS(13602),
    [anon_sym_quote] = ACTIONS(13602),
    [anon_sym_let] = ACTIONS(13602),
    [anon_sym_if] = ACTIONS(13602),
    [anon_sym_try] = ACTIONS(13602),
    [anon_sym_finally] = ACTIONS(13602),
    [anon_sym_for] = ACTIONS(13602),
    [anon_sym_while] = ACTIONS(13602),
    [sym_break_statement] = ACTIONS(13602),
    [sym_continue_statement] = ACTIONS(13602),
    [anon_sym_return] = ACTIONS(13602),
    [anon_sym_const] = ACTIONS(13602),
    [anon_sym_global] = ACTIONS(13602),
    [anon_sym_local] = ACTIONS(13602),
    [anon_sym_LPAREN] = ACTIONS(13602),
    [anon_sym_COLON2] = ACTIONS(13602),
    [anon_sym_export] = ACTIONS(13602),
    [anon_sym_import] = ACTIONS(13602),
    [anon_sym_using] = ACTIONS(13602),
    [anon_sym_LBRACK] = ACTIONS(13602),
    [anon_sym_LF] = ACTIONS(13604),
    [anon_sym_in] = ACTIONS(13602),
    [anon_sym_LBRACE] = ACTIONS(13602),
    [anon_sym_DOLLAR] = ACTIONS(13602),
    [anon_sym_COLON_COLON] = ACTIONS(13602),
    [anon_sym_isa] = ACTIONS(13602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13602),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_AT] = ACTIONS(13602),
    [anon_sym_true] = ACTIONS(13602),
    [anon_sym_false] = ACTIONS(13602),
    [aux_sym_integer_literal_token1] = ACTIONS(13602),
    [aux_sym_integer_literal_token2] = ACTIONS(13602),
    [aux_sym_integer_literal_token3] = ACTIONS(13602),
    [aux_sym_integer_literal_token4] = ACTIONS(13602),
    [aux_sym_float_literal_token1] = ACTIONS(13602),
    [aux_sym_float_literal_token3] = ACTIONS(13602),
    [aux_sym_float_literal_token4] = ACTIONS(13602),
    [sym_character_literal] = ACTIONS(13602),
    [sym__pair_operator] = ACTIONS(13602),
    [sym__arrow_operator] = ACTIONS(13602),
    [sym__lazy_or_operator] = ACTIONS(13602),
    [sym__lazy_and_operator] = ACTIONS(13602),
    [sym__comparison_operator] = ACTIONS(13602),
    [sym__pipe_right_operator] = ACTIONS(13602),
    [sym__pipe_left_operator] = ACTIONS(13602),
    [sym__ellipsis_operator] = ACTIONS(13602),
    [sym__plus_operator] = ACTIONS(13602),
    [sym__times_operator] = ACTIONS(13602),
    [sym__rational_operator] = ACTIONS(13602),
    [sym__bitshift_operator] = ACTIONS(13602),
    [sym__power_operator] = ACTIONS(13602),
    [sym__tilde_operator] = ACTIONS(13602),
    [sym__type_order_operator] = ACTIONS(13602),
    [sym__unary_operator] = ACTIONS(13602),
    [sym__unary_plus_operator] = ACTIONS(13602),
    [aux_sym__terminator_token1] = ACTIONS(13602),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13604),
    [sym__command_start] = ACTIONS(13604),
  },
  [8236] = {
    [sym__word_identifier] = ACTIONS(13606),
    [anon_sym_EQ] = ACTIONS(13606),
    [anon_sym_COMMA] = ACTIONS(13606),
    [anon_sym_COLON] = ACTIONS(13606),
    [anon_sym_begin] = ACTIONS(13606),
    [anon_sym_module] = ACTIONS(13606),
    [anon_sym_baremodule] = ACTIONS(13606),
    [anon_sym_end] = ACTIONS(13606),
    [anon_sym_abstract] = ACTIONS(13606),
    [anon_sym_primitive] = ACTIONS(13606),
    [anon_sym_mutable] = ACTIONS(13606),
    [anon_sym_struct] = ACTIONS(13606),
    [anon_sym_function] = ACTIONS(13606),
    [anon_sym_macro] = ACTIONS(13606),
    [anon_sym_where] = ACTIONS(13606),
    [anon_sym_quote] = ACTIONS(13606),
    [anon_sym_let] = ACTIONS(13606),
    [anon_sym_if] = ACTIONS(13606),
    [anon_sym_try] = ACTIONS(13606),
    [anon_sym_finally] = ACTIONS(13606),
    [anon_sym_for] = ACTIONS(13606),
    [anon_sym_while] = ACTIONS(13606),
    [sym_break_statement] = ACTIONS(13606),
    [sym_continue_statement] = ACTIONS(13606),
    [anon_sym_return] = ACTIONS(13606),
    [anon_sym_const] = ACTIONS(13606),
    [anon_sym_global] = ACTIONS(13606),
    [anon_sym_local] = ACTIONS(13606),
    [anon_sym_LPAREN] = ACTIONS(13606),
    [anon_sym_COLON2] = ACTIONS(13606),
    [anon_sym_export] = ACTIONS(13606),
    [anon_sym_import] = ACTIONS(13606),
    [anon_sym_using] = ACTIONS(13606),
    [anon_sym_LBRACK] = ACTIONS(13606),
    [anon_sym_LF] = ACTIONS(13608),
    [anon_sym_in] = ACTIONS(13606),
    [anon_sym_LBRACE] = ACTIONS(13606),
    [anon_sym_DOLLAR] = ACTIONS(13606),
    [anon_sym_COLON_COLON] = ACTIONS(13606),
    [anon_sym_isa] = ACTIONS(13606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_QMARK] = ACTIONS(13606),
    [anon_sym_AT] = ACTIONS(13606),
    [anon_sym_true] = ACTIONS(13606),
    [anon_sym_false] = ACTIONS(13606),
    [aux_sym_integer_literal_token1] = ACTIONS(13606),
    [aux_sym_integer_literal_token2] = ACTIONS(13606),
    [aux_sym_integer_literal_token3] = ACTIONS(13606),
    [aux_sym_integer_literal_token4] = ACTIONS(13606),
    [aux_sym_float_literal_token1] = ACTIONS(13606),
    [aux_sym_float_literal_token3] = ACTIONS(13606),
    [aux_sym_float_literal_token4] = ACTIONS(13606),
    [sym_character_literal] = ACTIONS(13606),
    [sym__pair_operator] = ACTIONS(13606),
    [sym__arrow_operator] = ACTIONS(13606),
    [sym__lazy_or_operator] = ACTIONS(13606),
    [sym__lazy_and_operator] = ACTIONS(13606),
    [sym__comparison_operator] = ACTIONS(13606),
    [sym__pipe_right_operator] = ACTIONS(13606),
    [sym__pipe_left_operator] = ACTIONS(13606),
    [sym__ellipsis_operator] = ACTIONS(13606),
    [sym__plus_operator] = ACTIONS(13606),
    [sym__times_operator] = ACTIONS(13606),
    [sym__rational_operator] = ACTIONS(13606),
    [sym__bitshift_operator] = ACTIONS(13606),
    [sym__power_operator] = ACTIONS(13606),
    [sym__tilde_operator] = ACTIONS(13606),
    [sym__type_order_operator] = ACTIONS(13606),
    [sym__unary_operator] = ACTIONS(13606),
    [sym__unary_plus_operator] = ACTIONS(13606),
    [aux_sym__terminator_token1] = ACTIONS(13606),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13608),
    [sym__command_start] = ACTIONS(13608),
  },
  [8237] = {
    [sym__word_identifier] = ACTIONS(13620),
    [anon_sym_EQ] = ACTIONS(13620),
    [anon_sym_COMMA] = ACTIONS(13620),
    [anon_sym_COLON] = ACTIONS(13620),
    [anon_sym_begin] = ACTIONS(13620),
    [anon_sym_module] = ACTIONS(13620),
    [anon_sym_baremodule] = ACTIONS(13620),
    [anon_sym_end] = ACTIONS(13620),
    [anon_sym_abstract] = ACTIONS(13620),
    [anon_sym_primitive] = ACTIONS(13620),
    [anon_sym_mutable] = ACTIONS(13620),
    [anon_sym_struct] = ACTIONS(13620),
    [anon_sym_function] = ACTIONS(13620),
    [anon_sym_macro] = ACTIONS(13620),
    [anon_sym_where] = ACTIONS(13620),
    [anon_sym_quote] = ACTIONS(13620),
    [anon_sym_let] = ACTIONS(13620),
    [anon_sym_if] = ACTIONS(13620),
    [anon_sym_try] = ACTIONS(13620),
    [anon_sym_finally] = ACTIONS(13620),
    [anon_sym_for] = ACTIONS(13620),
    [anon_sym_while] = ACTIONS(13620),
    [sym_break_statement] = ACTIONS(13620),
    [sym_continue_statement] = ACTIONS(13620),
    [anon_sym_return] = ACTIONS(13620),
    [anon_sym_const] = ACTIONS(13620),
    [anon_sym_global] = ACTIONS(13620),
    [anon_sym_local] = ACTIONS(13620),
    [anon_sym_LPAREN] = ACTIONS(13620),
    [anon_sym_COLON2] = ACTIONS(13620),
    [anon_sym_export] = ACTIONS(13620),
    [anon_sym_import] = ACTIONS(13620),
    [anon_sym_using] = ACTIONS(13620),
    [anon_sym_LBRACK] = ACTIONS(13620),
    [anon_sym_LF] = ACTIONS(13622),
    [anon_sym_in] = ACTIONS(13620),
    [anon_sym_LBRACE] = ACTIONS(13620),
    [anon_sym_DOLLAR] = ACTIONS(13620),
    [anon_sym_COLON_COLON] = ACTIONS(13620),
    [anon_sym_isa] = ACTIONS(13620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13620),
    [anon_sym_QMARK] = ACTIONS(13620),
    [anon_sym_AT] = ACTIONS(13620),
    [anon_sym_true] = ACTIONS(13620),
    [anon_sym_false] = ACTIONS(13620),
    [aux_sym_integer_literal_token1] = ACTIONS(13620),
    [aux_sym_integer_literal_token2] = ACTIONS(13620),
    [aux_sym_integer_literal_token3] = ACTIONS(13620),
    [aux_sym_integer_literal_token4] = ACTIONS(13620),
    [aux_sym_float_literal_token1] = ACTIONS(13620),
    [aux_sym_float_literal_token3] = ACTIONS(13620),
    [aux_sym_float_literal_token4] = ACTIONS(13620),
    [sym_character_literal] = ACTIONS(13620),
    [sym__pair_operator] = ACTIONS(13620),
    [sym__arrow_operator] = ACTIONS(13620),
    [sym__lazy_or_operator] = ACTIONS(13620),
    [sym__lazy_and_operator] = ACTIONS(13620),
    [sym__comparison_operator] = ACTIONS(13620),
    [sym__pipe_right_operator] = ACTIONS(13620),
    [sym__pipe_left_operator] = ACTIONS(13620),
    [sym__ellipsis_operator] = ACTIONS(13620),
    [sym__plus_operator] = ACTIONS(13620),
    [sym__times_operator] = ACTIONS(13620),
    [sym__rational_operator] = ACTIONS(13620),
    [sym__bitshift_operator] = ACTIONS(13620),
    [sym__power_operator] = ACTIONS(13620),
    [sym__tilde_operator] = ACTIONS(13620),
    [sym__type_order_operator] = ACTIONS(13620),
    [sym__unary_operator] = ACTIONS(13620),
    [sym__unary_plus_operator] = ACTIONS(13620),
    [aux_sym__terminator_token1] = ACTIONS(13620),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13622),
    [sym__command_start] = ACTIONS(13622),
  },
  [8238] = {
    [sym__word_identifier] = ACTIONS(13624),
    [anon_sym_EQ] = ACTIONS(13624),
    [anon_sym_COMMA] = ACTIONS(13624),
    [anon_sym_COLON] = ACTIONS(13624),
    [anon_sym_begin] = ACTIONS(13624),
    [anon_sym_module] = ACTIONS(13624),
    [anon_sym_baremodule] = ACTIONS(13624),
    [anon_sym_end] = ACTIONS(13624),
    [anon_sym_abstract] = ACTIONS(13624),
    [anon_sym_primitive] = ACTIONS(13624),
    [anon_sym_mutable] = ACTIONS(13624),
    [anon_sym_struct] = ACTIONS(13624),
    [anon_sym_function] = ACTIONS(13624),
    [anon_sym_macro] = ACTIONS(13624),
    [anon_sym_where] = ACTIONS(13624),
    [anon_sym_quote] = ACTIONS(13624),
    [anon_sym_let] = ACTIONS(13624),
    [anon_sym_if] = ACTIONS(13624),
    [anon_sym_try] = ACTIONS(13624),
    [anon_sym_finally] = ACTIONS(13624),
    [anon_sym_for] = ACTIONS(13624),
    [anon_sym_while] = ACTIONS(13624),
    [sym_break_statement] = ACTIONS(13624),
    [sym_continue_statement] = ACTIONS(13624),
    [anon_sym_return] = ACTIONS(13624),
    [anon_sym_const] = ACTIONS(13624),
    [anon_sym_global] = ACTIONS(13624),
    [anon_sym_local] = ACTIONS(13624),
    [anon_sym_LPAREN] = ACTIONS(13624),
    [anon_sym_COLON2] = ACTIONS(13624),
    [anon_sym_export] = ACTIONS(13624),
    [anon_sym_import] = ACTIONS(13624),
    [anon_sym_using] = ACTIONS(13624),
    [anon_sym_LBRACK] = ACTIONS(13624),
    [anon_sym_LF] = ACTIONS(13626),
    [anon_sym_in] = ACTIONS(13624),
    [anon_sym_LBRACE] = ACTIONS(13624),
    [anon_sym_DOLLAR] = ACTIONS(13624),
    [anon_sym_COLON_COLON] = ACTIONS(13624),
    [anon_sym_isa] = ACTIONS(13624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13624),
    [anon_sym_QMARK] = ACTIONS(13624),
    [anon_sym_AT] = ACTIONS(13624),
    [anon_sym_true] = ACTIONS(13624),
    [anon_sym_false] = ACTIONS(13624),
    [aux_sym_integer_literal_token1] = ACTIONS(13624),
    [aux_sym_integer_literal_token2] = ACTIONS(13624),
    [aux_sym_integer_literal_token3] = ACTIONS(13624),
    [aux_sym_integer_literal_token4] = ACTIONS(13624),
    [aux_sym_float_literal_token1] = ACTIONS(13624),
    [aux_sym_float_literal_token3] = ACTIONS(13624),
    [aux_sym_float_literal_token4] = ACTIONS(13624),
    [sym_character_literal] = ACTIONS(13624),
    [sym__pair_operator] = ACTIONS(13624),
    [sym__arrow_operator] = ACTIONS(13624),
    [sym__lazy_or_operator] = ACTIONS(13624),
    [sym__lazy_and_operator] = ACTIONS(13624),
    [sym__comparison_operator] = ACTIONS(13624),
    [sym__pipe_right_operator] = ACTIONS(13624),
    [sym__pipe_left_operator] = ACTIONS(13624),
    [sym__ellipsis_operator] = ACTIONS(13624),
    [sym__plus_operator] = ACTIONS(13624),
    [sym__times_operator] = ACTIONS(13624),
    [sym__rational_operator] = ACTIONS(13624),
    [sym__bitshift_operator] = ACTIONS(13624),
    [sym__power_operator] = ACTIONS(13624),
    [sym__tilde_operator] = ACTIONS(13624),
    [sym__type_order_operator] = ACTIONS(13624),
    [sym__unary_operator] = ACTIONS(13624),
    [sym__unary_plus_operator] = ACTIONS(13624),
    [aux_sym__terminator_token1] = ACTIONS(13624),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13626),
    [sym__command_start] = ACTIONS(13626),
  },
  [8239] = {
    [sym__word_identifier] = ACTIONS(13628),
    [anon_sym_EQ] = ACTIONS(13628),
    [anon_sym_COMMA] = ACTIONS(13628),
    [anon_sym_COLON] = ACTIONS(13628),
    [anon_sym_begin] = ACTIONS(13628),
    [anon_sym_module] = ACTIONS(13628),
    [anon_sym_baremodule] = ACTIONS(13628),
    [anon_sym_end] = ACTIONS(13628),
    [anon_sym_abstract] = ACTIONS(13628),
    [anon_sym_primitive] = ACTIONS(13628),
    [anon_sym_mutable] = ACTIONS(13628),
    [anon_sym_struct] = ACTIONS(13628),
    [anon_sym_function] = ACTIONS(13628),
    [anon_sym_macro] = ACTIONS(13628),
    [anon_sym_where] = ACTIONS(13628),
    [anon_sym_quote] = ACTIONS(13628),
    [anon_sym_let] = ACTIONS(13628),
    [anon_sym_if] = ACTIONS(13628),
    [anon_sym_try] = ACTIONS(13628),
    [anon_sym_finally] = ACTIONS(13628),
    [anon_sym_for] = ACTIONS(13628),
    [anon_sym_while] = ACTIONS(13628),
    [sym_break_statement] = ACTIONS(13628),
    [sym_continue_statement] = ACTIONS(13628),
    [anon_sym_return] = ACTIONS(13628),
    [anon_sym_const] = ACTIONS(13628),
    [anon_sym_global] = ACTIONS(13628),
    [anon_sym_local] = ACTIONS(13628),
    [anon_sym_LPAREN] = ACTIONS(13628),
    [anon_sym_COLON2] = ACTIONS(13628),
    [anon_sym_export] = ACTIONS(13628),
    [anon_sym_import] = ACTIONS(13628),
    [anon_sym_using] = ACTIONS(13628),
    [anon_sym_LBRACK] = ACTIONS(13628),
    [anon_sym_LF] = ACTIONS(13630),
    [anon_sym_in] = ACTIONS(13628),
    [anon_sym_LBRACE] = ACTIONS(13628),
    [anon_sym_DOLLAR] = ACTIONS(13628),
    [anon_sym_COLON_COLON] = ACTIONS(13628),
    [anon_sym_isa] = ACTIONS(13628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13628),
    [anon_sym_QMARK] = ACTIONS(13628),
    [anon_sym_AT] = ACTIONS(13628),
    [anon_sym_true] = ACTIONS(13628),
    [anon_sym_false] = ACTIONS(13628),
    [aux_sym_integer_literal_token1] = ACTIONS(13628),
    [aux_sym_integer_literal_token2] = ACTIONS(13628),
    [aux_sym_integer_literal_token3] = ACTIONS(13628),
    [aux_sym_integer_literal_token4] = ACTIONS(13628),
    [aux_sym_float_literal_token1] = ACTIONS(13628),
    [aux_sym_float_literal_token3] = ACTIONS(13628),
    [aux_sym_float_literal_token4] = ACTIONS(13628),
    [sym_character_literal] = ACTIONS(13628),
    [sym__pair_operator] = ACTIONS(13628),
    [sym__arrow_operator] = ACTIONS(13628),
    [sym__lazy_or_operator] = ACTIONS(13628),
    [sym__lazy_and_operator] = ACTIONS(13628),
    [sym__comparison_operator] = ACTIONS(13628),
    [sym__pipe_right_operator] = ACTIONS(13628),
    [sym__pipe_left_operator] = ACTIONS(13628),
    [sym__ellipsis_operator] = ACTIONS(13628),
    [sym__plus_operator] = ACTIONS(13628),
    [sym__times_operator] = ACTIONS(13628),
    [sym__rational_operator] = ACTIONS(13628),
    [sym__bitshift_operator] = ACTIONS(13628),
    [sym__power_operator] = ACTIONS(13628),
    [sym__tilde_operator] = ACTIONS(13628),
    [sym__type_order_operator] = ACTIONS(13628),
    [sym__unary_operator] = ACTIONS(13628),
    [sym__unary_plus_operator] = ACTIONS(13628),
    [aux_sym__terminator_token1] = ACTIONS(13628),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13630),
    [sym__command_start] = ACTIONS(13630),
  },
  [8240] = {
    [sym__word_identifier] = ACTIONS(13632),
    [anon_sym_EQ] = ACTIONS(13632),
    [anon_sym_COMMA] = ACTIONS(13632),
    [anon_sym_COLON] = ACTIONS(13632),
    [anon_sym_begin] = ACTIONS(13632),
    [anon_sym_module] = ACTIONS(13632),
    [anon_sym_baremodule] = ACTIONS(13632),
    [anon_sym_end] = ACTIONS(13632),
    [anon_sym_abstract] = ACTIONS(13632),
    [anon_sym_primitive] = ACTIONS(13632),
    [anon_sym_mutable] = ACTIONS(13632),
    [anon_sym_struct] = ACTIONS(13632),
    [anon_sym_function] = ACTIONS(13632),
    [anon_sym_macro] = ACTIONS(13632),
    [anon_sym_where] = ACTIONS(13632),
    [anon_sym_quote] = ACTIONS(13632),
    [anon_sym_let] = ACTIONS(13632),
    [anon_sym_if] = ACTIONS(13632),
    [anon_sym_try] = ACTIONS(13632),
    [anon_sym_finally] = ACTIONS(13632),
    [anon_sym_for] = ACTIONS(13632),
    [anon_sym_while] = ACTIONS(13632),
    [sym_break_statement] = ACTIONS(13632),
    [sym_continue_statement] = ACTIONS(13632),
    [anon_sym_return] = ACTIONS(13632),
    [anon_sym_const] = ACTIONS(13632),
    [anon_sym_global] = ACTIONS(13632),
    [anon_sym_local] = ACTIONS(13632),
    [anon_sym_LPAREN] = ACTIONS(13632),
    [anon_sym_COLON2] = ACTIONS(13632),
    [anon_sym_export] = ACTIONS(13632),
    [anon_sym_import] = ACTIONS(13632),
    [anon_sym_using] = ACTIONS(13632),
    [anon_sym_LBRACK] = ACTIONS(13632),
    [anon_sym_LF] = ACTIONS(13634),
    [anon_sym_in] = ACTIONS(13632),
    [anon_sym_LBRACE] = ACTIONS(13632),
    [anon_sym_DOLLAR] = ACTIONS(13632),
    [anon_sym_COLON_COLON] = ACTIONS(13632),
    [anon_sym_isa] = ACTIONS(13632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13632),
    [anon_sym_QMARK] = ACTIONS(13632),
    [anon_sym_AT] = ACTIONS(13632),
    [anon_sym_true] = ACTIONS(13632),
    [anon_sym_false] = ACTIONS(13632),
    [aux_sym_integer_literal_token1] = ACTIONS(13632),
    [aux_sym_integer_literal_token2] = ACTIONS(13632),
    [aux_sym_integer_literal_token3] = ACTIONS(13632),
    [aux_sym_integer_literal_token4] = ACTIONS(13632),
    [aux_sym_float_literal_token1] = ACTIONS(13632),
    [aux_sym_float_literal_token3] = ACTIONS(13632),
    [aux_sym_float_literal_token4] = ACTIONS(13632),
    [sym_character_literal] = ACTIONS(13632),
    [sym__pair_operator] = ACTIONS(13632),
    [sym__arrow_operator] = ACTIONS(13632),
    [sym__lazy_or_operator] = ACTIONS(13632),
    [sym__lazy_and_operator] = ACTIONS(13632),
    [sym__comparison_operator] = ACTIONS(13632),
    [sym__pipe_right_operator] = ACTIONS(13632),
    [sym__pipe_left_operator] = ACTIONS(13632),
    [sym__ellipsis_operator] = ACTIONS(13632),
    [sym__plus_operator] = ACTIONS(13632),
    [sym__times_operator] = ACTIONS(13632),
    [sym__rational_operator] = ACTIONS(13632),
    [sym__bitshift_operator] = ACTIONS(13632),
    [sym__power_operator] = ACTIONS(13632),
    [sym__tilde_operator] = ACTIONS(13632),
    [sym__type_order_operator] = ACTIONS(13632),
    [sym__unary_operator] = ACTIONS(13632),
    [sym__unary_plus_operator] = ACTIONS(13632),
    [aux_sym__terminator_token1] = ACTIONS(13632),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13634),
    [sym__command_start] = ACTIONS(13634),
  },
  [8241] = {
    [sym__word_identifier] = ACTIONS(13636),
    [anon_sym_EQ] = ACTIONS(13636),
    [anon_sym_COMMA] = ACTIONS(13636),
    [anon_sym_COLON] = ACTIONS(13636),
    [anon_sym_begin] = ACTIONS(13636),
    [anon_sym_module] = ACTIONS(13636),
    [anon_sym_baremodule] = ACTIONS(13636),
    [anon_sym_end] = ACTIONS(13636),
    [anon_sym_abstract] = ACTIONS(13636),
    [anon_sym_primitive] = ACTIONS(13636),
    [anon_sym_mutable] = ACTIONS(13636),
    [anon_sym_struct] = ACTIONS(13636),
    [anon_sym_function] = ACTIONS(13636),
    [anon_sym_macro] = ACTIONS(13636),
    [anon_sym_where] = ACTIONS(13636),
    [anon_sym_quote] = ACTIONS(13636),
    [anon_sym_let] = ACTIONS(13636),
    [anon_sym_if] = ACTIONS(13636),
    [anon_sym_try] = ACTIONS(13636),
    [anon_sym_finally] = ACTIONS(13636),
    [anon_sym_for] = ACTIONS(13636),
    [anon_sym_while] = ACTIONS(13636),
    [sym_break_statement] = ACTIONS(13636),
    [sym_continue_statement] = ACTIONS(13636),
    [anon_sym_return] = ACTIONS(13636),
    [anon_sym_const] = ACTIONS(13636),
    [anon_sym_global] = ACTIONS(13636),
    [anon_sym_local] = ACTIONS(13636),
    [anon_sym_LPAREN] = ACTIONS(13636),
    [anon_sym_COLON2] = ACTIONS(13636),
    [anon_sym_export] = ACTIONS(13636),
    [anon_sym_import] = ACTIONS(13636),
    [anon_sym_using] = ACTIONS(13636),
    [anon_sym_LBRACK] = ACTIONS(13636),
    [anon_sym_LF] = ACTIONS(13638),
    [anon_sym_in] = ACTIONS(13636),
    [anon_sym_LBRACE] = ACTIONS(13636),
    [anon_sym_DOLLAR] = ACTIONS(13636),
    [anon_sym_COLON_COLON] = ACTIONS(13636),
    [anon_sym_isa] = ACTIONS(13636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13636),
    [anon_sym_QMARK] = ACTIONS(13636),
    [anon_sym_AT] = ACTIONS(13636),
    [anon_sym_true] = ACTIONS(13636),
    [anon_sym_false] = ACTIONS(13636),
    [aux_sym_integer_literal_token1] = ACTIONS(13636),
    [aux_sym_integer_literal_token2] = ACTIONS(13636),
    [aux_sym_integer_literal_token3] = ACTIONS(13636),
    [aux_sym_integer_literal_token4] = ACTIONS(13636),
    [aux_sym_float_literal_token1] = ACTIONS(13636),
    [aux_sym_float_literal_token3] = ACTIONS(13636),
    [aux_sym_float_literal_token4] = ACTIONS(13636),
    [sym_character_literal] = ACTIONS(13636),
    [sym__pair_operator] = ACTIONS(13636),
    [sym__arrow_operator] = ACTIONS(13636),
    [sym__lazy_or_operator] = ACTIONS(13636),
    [sym__lazy_and_operator] = ACTIONS(13636),
    [sym__comparison_operator] = ACTIONS(13636),
    [sym__pipe_right_operator] = ACTIONS(13636),
    [sym__pipe_left_operator] = ACTIONS(13636),
    [sym__ellipsis_operator] = ACTIONS(13636),
    [sym__plus_operator] = ACTIONS(13636),
    [sym__times_operator] = ACTIONS(13636),
    [sym__rational_operator] = ACTIONS(13636),
    [sym__bitshift_operator] = ACTIONS(13636),
    [sym__power_operator] = ACTIONS(13636),
    [sym__tilde_operator] = ACTIONS(13636),
    [sym__type_order_operator] = ACTIONS(13636),
    [sym__unary_operator] = ACTIONS(13636),
    [sym__unary_plus_operator] = ACTIONS(13636),
    [aux_sym__terminator_token1] = ACTIONS(13636),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13638),
    [sym__command_start] = ACTIONS(13638),
  },
  [8242] = {
    [sym__word_identifier] = ACTIONS(13640),
    [anon_sym_EQ] = ACTIONS(13640),
    [anon_sym_COMMA] = ACTIONS(13640),
    [anon_sym_COLON] = ACTIONS(13640),
    [anon_sym_begin] = ACTIONS(13640),
    [anon_sym_module] = ACTIONS(13640),
    [anon_sym_baremodule] = ACTIONS(13640),
    [anon_sym_end] = ACTIONS(13640),
    [anon_sym_abstract] = ACTIONS(13640),
    [anon_sym_primitive] = ACTIONS(13640),
    [anon_sym_mutable] = ACTIONS(13640),
    [anon_sym_struct] = ACTIONS(13640),
    [anon_sym_function] = ACTIONS(13640),
    [anon_sym_macro] = ACTIONS(13640),
    [anon_sym_where] = ACTIONS(13640),
    [anon_sym_quote] = ACTIONS(13640),
    [anon_sym_let] = ACTIONS(13640),
    [anon_sym_if] = ACTIONS(13640),
    [anon_sym_try] = ACTIONS(13640),
    [anon_sym_finally] = ACTIONS(13640),
    [anon_sym_for] = ACTIONS(13640),
    [anon_sym_while] = ACTIONS(13640),
    [sym_break_statement] = ACTIONS(13640),
    [sym_continue_statement] = ACTIONS(13640),
    [anon_sym_return] = ACTIONS(13640),
    [anon_sym_const] = ACTIONS(13640),
    [anon_sym_global] = ACTIONS(13640),
    [anon_sym_local] = ACTIONS(13640),
    [anon_sym_LPAREN] = ACTIONS(13640),
    [anon_sym_COLON2] = ACTIONS(13640),
    [anon_sym_export] = ACTIONS(13640),
    [anon_sym_import] = ACTIONS(13640),
    [anon_sym_using] = ACTIONS(13640),
    [anon_sym_LBRACK] = ACTIONS(13640),
    [anon_sym_LF] = ACTIONS(13642),
    [anon_sym_in] = ACTIONS(13640),
    [anon_sym_LBRACE] = ACTIONS(13640),
    [anon_sym_DOLLAR] = ACTIONS(13640),
    [anon_sym_COLON_COLON] = ACTIONS(13640),
    [anon_sym_isa] = ACTIONS(13640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13640),
    [anon_sym_QMARK] = ACTIONS(13640),
    [anon_sym_AT] = ACTIONS(13640),
    [anon_sym_true] = ACTIONS(13640),
    [anon_sym_false] = ACTIONS(13640),
    [aux_sym_integer_literal_token1] = ACTIONS(13640),
    [aux_sym_integer_literal_token2] = ACTIONS(13640),
    [aux_sym_integer_literal_token3] = ACTIONS(13640),
    [aux_sym_integer_literal_token4] = ACTIONS(13640),
    [aux_sym_float_literal_token1] = ACTIONS(13640),
    [aux_sym_float_literal_token3] = ACTIONS(13640),
    [aux_sym_float_literal_token4] = ACTIONS(13640),
    [sym_character_literal] = ACTIONS(13640),
    [sym__pair_operator] = ACTIONS(13640),
    [sym__arrow_operator] = ACTIONS(13640),
    [sym__lazy_or_operator] = ACTIONS(13640),
    [sym__lazy_and_operator] = ACTIONS(13640),
    [sym__comparison_operator] = ACTIONS(13640),
    [sym__pipe_right_operator] = ACTIONS(13640),
    [sym__pipe_left_operator] = ACTIONS(13640),
    [sym__ellipsis_operator] = ACTIONS(13640),
    [sym__plus_operator] = ACTIONS(13640),
    [sym__times_operator] = ACTIONS(13640),
    [sym__rational_operator] = ACTIONS(13640),
    [sym__bitshift_operator] = ACTIONS(13640),
    [sym__power_operator] = ACTIONS(13640),
    [sym__tilde_operator] = ACTIONS(13640),
    [sym__type_order_operator] = ACTIONS(13640),
    [sym__unary_operator] = ACTIONS(13640),
    [sym__unary_plus_operator] = ACTIONS(13640),
    [aux_sym__terminator_token1] = ACTIONS(13640),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13642),
    [sym__command_start] = ACTIONS(13642),
  },
  [8243] = {
    [sym__word_identifier] = ACTIONS(13644),
    [anon_sym_EQ] = ACTIONS(13644),
    [anon_sym_COMMA] = ACTIONS(13644),
    [anon_sym_COLON] = ACTIONS(13644),
    [anon_sym_begin] = ACTIONS(13644),
    [anon_sym_module] = ACTIONS(13644),
    [anon_sym_baremodule] = ACTIONS(13644),
    [anon_sym_end] = ACTIONS(13644),
    [anon_sym_abstract] = ACTIONS(13644),
    [anon_sym_primitive] = ACTIONS(13644),
    [anon_sym_mutable] = ACTIONS(13644),
    [anon_sym_struct] = ACTIONS(13644),
    [anon_sym_function] = ACTIONS(13644),
    [anon_sym_macro] = ACTIONS(13644),
    [anon_sym_where] = ACTIONS(13644),
    [anon_sym_quote] = ACTIONS(13644),
    [anon_sym_let] = ACTIONS(13644),
    [anon_sym_if] = ACTIONS(13644),
    [anon_sym_try] = ACTIONS(13644),
    [anon_sym_finally] = ACTIONS(13644),
    [anon_sym_for] = ACTIONS(13644),
    [anon_sym_while] = ACTIONS(13644),
    [sym_break_statement] = ACTIONS(13644),
    [sym_continue_statement] = ACTIONS(13644),
    [anon_sym_return] = ACTIONS(13644),
    [anon_sym_const] = ACTIONS(13644),
    [anon_sym_global] = ACTIONS(13644),
    [anon_sym_local] = ACTIONS(13644),
    [anon_sym_LPAREN] = ACTIONS(13644),
    [anon_sym_COLON2] = ACTIONS(13644),
    [anon_sym_export] = ACTIONS(13644),
    [anon_sym_import] = ACTIONS(13644),
    [anon_sym_using] = ACTIONS(13644),
    [anon_sym_LBRACK] = ACTIONS(13644),
    [anon_sym_LF] = ACTIONS(13646),
    [anon_sym_in] = ACTIONS(13644),
    [anon_sym_LBRACE] = ACTIONS(13644),
    [anon_sym_DOLLAR] = ACTIONS(13644),
    [anon_sym_COLON_COLON] = ACTIONS(13644),
    [anon_sym_isa] = ACTIONS(13644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13644),
    [anon_sym_QMARK] = ACTIONS(13644),
    [anon_sym_AT] = ACTIONS(13644),
    [anon_sym_true] = ACTIONS(13644),
    [anon_sym_false] = ACTIONS(13644),
    [aux_sym_integer_literal_token1] = ACTIONS(13644),
    [aux_sym_integer_literal_token2] = ACTIONS(13644),
    [aux_sym_integer_literal_token3] = ACTIONS(13644),
    [aux_sym_integer_literal_token4] = ACTIONS(13644),
    [aux_sym_float_literal_token1] = ACTIONS(13644),
    [aux_sym_float_literal_token3] = ACTIONS(13644),
    [aux_sym_float_literal_token4] = ACTIONS(13644),
    [sym_character_literal] = ACTIONS(13644),
    [sym__pair_operator] = ACTIONS(13644),
    [sym__arrow_operator] = ACTIONS(13644),
    [sym__lazy_or_operator] = ACTIONS(13644),
    [sym__lazy_and_operator] = ACTIONS(13644),
    [sym__comparison_operator] = ACTIONS(13644),
    [sym__pipe_right_operator] = ACTIONS(13644),
    [sym__pipe_left_operator] = ACTIONS(13644),
    [sym__ellipsis_operator] = ACTIONS(13644),
    [sym__plus_operator] = ACTIONS(13644),
    [sym__times_operator] = ACTIONS(13644),
    [sym__rational_operator] = ACTIONS(13644),
    [sym__bitshift_operator] = ACTIONS(13644),
    [sym__power_operator] = ACTIONS(13644),
    [sym__tilde_operator] = ACTIONS(13644),
    [sym__type_order_operator] = ACTIONS(13644),
    [sym__unary_operator] = ACTIONS(13644),
    [sym__unary_plus_operator] = ACTIONS(13644),
    [aux_sym__terminator_token1] = ACTIONS(13644),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13646),
    [sym__command_start] = ACTIONS(13646),
  },
  [8244] = {
    [sym__word_identifier] = ACTIONS(13648),
    [anon_sym_EQ] = ACTIONS(13648),
    [anon_sym_COMMA] = ACTIONS(13648),
    [anon_sym_COLON] = ACTIONS(13648),
    [anon_sym_begin] = ACTIONS(13648),
    [anon_sym_module] = ACTIONS(13648),
    [anon_sym_baremodule] = ACTIONS(13648),
    [anon_sym_end] = ACTIONS(13648),
    [anon_sym_abstract] = ACTIONS(13648),
    [anon_sym_primitive] = ACTIONS(13648),
    [anon_sym_mutable] = ACTIONS(13648),
    [anon_sym_struct] = ACTIONS(13648),
    [anon_sym_function] = ACTIONS(13648),
    [anon_sym_macro] = ACTIONS(13648),
    [anon_sym_where] = ACTIONS(13648),
    [anon_sym_quote] = ACTIONS(13648),
    [anon_sym_let] = ACTIONS(13648),
    [anon_sym_if] = ACTIONS(13648),
    [anon_sym_try] = ACTIONS(13648),
    [anon_sym_finally] = ACTIONS(13648),
    [anon_sym_for] = ACTIONS(13648),
    [anon_sym_while] = ACTIONS(13648),
    [sym_break_statement] = ACTIONS(13648),
    [sym_continue_statement] = ACTIONS(13648),
    [anon_sym_return] = ACTIONS(13648),
    [anon_sym_const] = ACTIONS(13648),
    [anon_sym_global] = ACTIONS(13648),
    [anon_sym_local] = ACTIONS(13648),
    [anon_sym_LPAREN] = ACTIONS(13648),
    [anon_sym_COLON2] = ACTIONS(13648),
    [anon_sym_export] = ACTIONS(13648),
    [anon_sym_import] = ACTIONS(13648),
    [anon_sym_using] = ACTIONS(13648),
    [anon_sym_LBRACK] = ACTIONS(13648),
    [anon_sym_LF] = ACTIONS(13650),
    [anon_sym_in] = ACTIONS(13648),
    [anon_sym_LBRACE] = ACTIONS(13648),
    [anon_sym_DOLLAR] = ACTIONS(13648),
    [anon_sym_COLON_COLON] = ACTIONS(13648),
    [anon_sym_isa] = ACTIONS(13648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13648),
    [anon_sym_QMARK] = ACTIONS(13648),
    [anon_sym_AT] = ACTIONS(13648),
    [anon_sym_true] = ACTIONS(13648),
    [anon_sym_false] = ACTIONS(13648),
    [aux_sym_integer_literal_token1] = ACTIONS(13648),
    [aux_sym_integer_literal_token2] = ACTIONS(13648),
    [aux_sym_integer_literal_token3] = ACTIONS(13648),
    [aux_sym_integer_literal_token4] = ACTIONS(13648),
    [aux_sym_float_literal_token1] = ACTIONS(13648),
    [aux_sym_float_literal_token3] = ACTIONS(13648),
    [aux_sym_float_literal_token4] = ACTIONS(13648),
    [sym_character_literal] = ACTIONS(13648),
    [sym__pair_operator] = ACTIONS(13648),
    [sym__arrow_operator] = ACTIONS(13648),
    [sym__lazy_or_operator] = ACTIONS(13648),
    [sym__lazy_and_operator] = ACTIONS(13648),
    [sym__comparison_operator] = ACTIONS(13648),
    [sym__pipe_right_operator] = ACTIONS(13648),
    [sym__pipe_left_operator] = ACTIONS(13648),
    [sym__ellipsis_operator] = ACTIONS(13648),
    [sym__plus_operator] = ACTIONS(13648),
    [sym__times_operator] = ACTIONS(13648),
    [sym__rational_operator] = ACTIONS(13648),
    [sym__bitshift_operator] = ACTIONS(13648),
    [sym__power_operator] = ACTIONS(13648),
    [sym__tilde_operator] = ACTIONS(13648),
    [sym__type_order_operator] = ACTIONS(13648),
    [sym__unary_operator] = ACTIONS(13648),
    [sym__unary_plus_operator] = ACTIONS(13648),
    [aux_sym__terminator_token1] = ACTIONS(13648),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13650),
    [sym__command_start] = ACTIONS(13650),
  },
  [8245] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_EQ] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_catch] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14455),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [8246] = {
    [sym__word_identifier] = ACTIONS(13652),
    [anon_sym_EQ] = ACTIONS(13652),
    [anon_sym_COMMA] = ACTIONS(13652),
    [anon_sym_COLON] = ACTIONS(13652),
    [anon_sym_begin] = ACTIONS(13652),
    [anon_sym_module] = ACTIONS(13652),
    [anon_sym_baremodule] = ACTIONS(13652),
    [anon_sym_end] = ACTIONS(13652),
    [anon_sym_abstract] = ACTIONS(13652),
    [anon_sym_primitive] = ACTIONS(13652),
    [anon_sym_mutable] = ACTIONS(13652),
    [anon_sym_struct] = ACTIONS(13652),
    [anon_sym_function] = ACTIONS(13652),
    [anon_sym_macro] = ACTIONS(13652),
    [anon_sym_where] = ACTIONS(13652),
    [anon_sym_quote] = ACTIONS(13652),
    [anon_sym_let] = ACTIONS(13652),
    [anon_sym_if] = ACTIONS(13652),
    [anon_sym_try] = ACTIONS(13652),
    [anon_sym_finally] = ACTIONS(13652),
    [anon_sym_for] = ACTIONS(13652),
    [anon_sym_while] = ACTIONS(13652),
    [sym_break_statement] = ACTIONS(13652),
    [sym_continue_statement] = ACTIONS(13652),
    [anon_sym_return] = ACTIONS(13652),
    [anon_sym_const] = ACTIONS(13652),
    [anon_sym_global] = ACTIONS(13652),
    [anon_sym_local] = ACTIONS(13652),
    [anon_sym_LPAREN] = ACTIONS(13652),
    [anon_sym_COLON2] = ACTIONS(13652),
    [anon_sym_export] = ACTIONS(13652),
    [anon_sym_import] = ACTIONS(13652),
    [anon_sym_using] = ACTIONS(13652),
    [anon_sym_LBRACK] = ACTIONS(13652),
    [anon_sym_LF] = ACTIONS(13654),
    [anon_sym_in] = ACTIONS(13652),
    [anon_sym_LBRACE] = ACTIONS(13652),
    [anon_sym_DOLLAR] = ACTIONS(13652),
    [anon_sym_COLON_COLON] = ACTIONS(13652),
    [anon_sym_isa] = ACTIONS(13652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13652),
    [anon_sym_QMARK] = ACTIONS(13652),
    [anon_sym_AT] = ACTIONS(13652),
    [anon_sym_true] = ACTIONS(13652),
    [anon_sym_false] = ACTIONS(13652),
    [aux_sym_integer_literal_token1] = ACTIONS(13652),
    [aux_sym_integer_literal_token2] = ACTIONS(13652),
    [aux_sym_integer_literal_token3] = ACTIONS(13652),
    [aux_sym_integer_literal_token4] = ACTIONS(13652),
    [aux_sym_float_literal_token1] = ACTIONS(13652),
    [aux_sym_float_literal_token3] = ACTIONS(13652),
    [aux_sym_float_literal_token4] = ACTIONS(13652),
    [sym_character_literal] = ACTIONS(13652),
    [sym__pair_operator] = ACTIONS(13652),
    [sym__arrow_operator] = ACTIONS(13652),
    [sym__lazy_or_operator] = ACTIONS(13652),
    [sym__lazy_and_operator] = ACTIONS(13652),
    [sym__comparison_operator] = ACTIONS(13652),
    [sym__pipe_right_operator] = ACTIONS(13652),
    [sym__pipe_left_operator] = ACTIONS(13652),
    [sym__ellipsis_operator] = ACTIONS(13652),
    [sym__plus_operator] = ACTIONS(13652),
    [sym__times_operator] = ACTIONS(13652),
    [sym__rational_operator] = ACTIONS(13652),
    [sym__bitshift_operator] = ACTIONS(13652),
    [sym__power_operator] = ACTIONS(13652),
    [sym__tilde_operator] = ACTIONS(13652),
    [sym__type_order_operator] = ACTIONS(13652),
    [sym__unary_operator] = ACTIONS(13652),
    [sym__unary_plus_operator] = ACTIONS(13652),
    [aux_sym__terminator_token1] = ACTIONS(13652),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13654),
    [sym__command_start] = ACTIONS(13654),
  },
  [8247] = {
    [sym__word_identifier] = ACTIONS(13656),
    [anon_sym_EQ] = ACTIONS(13656),
    [anon_sym_COMMA] = ACTIONS(13656),
    [anon_sym_COLON] = ACTIONS(13656),
    [anon_sym_begin] = ACTIONS(13656),
    [anon_sym_module] = ACTIONS(13656),
    [anon_sym_baremodule] = ACTIONS(13656),
    [anon_sym_end] = ACTIONS(13656),
    [anon_sym_abstract] = ACTIONS(13656),
    [anon_sym_primitive] = ACTIONS(13656),
    [anon_sym_mutable] = ACTIONS(13656),
    [anon_sym_struct] = ACTIONS(13656),
    [anon_sym_function] = ACTIONS(13656),
    [anon_sym_macro] = ACTIONS(13656),
    [anon_sym_where] = ACTIONS(13656),
    [anon_sym_quote] = ACTIONS(13656),
    [anon_sym_let] = ACTIONS(13656),
    [anon_sym_if] = ACTIONS(13656),
    [anon_sym_try] = ACTIONS(13656),
    [anon_sym_finally] = ACTIONS(13656),
    [anon_sym_for] = ACTIONS(13656),
    [anon_sym_while] = ACTIONS(13656),
    [sym_break_statement] = ACTIONS(13656),
    [sym_continue_statement] = ACTIONS(13656),
    [anon_sym_return] = ACTIONS(13656),
    [anon_sym_const] = ACTIONS(13656),
    [anon_sym_global] = ACTIONS(13656),
    [anon_sym_local] = ACTIONS(13656),
    [anon_sym_LPAREN] = ACTIONS(13656),
    [anon_sym_COLON2] = ACTIONS(13656),
    [anon_sym_export] = ACTIONS(13656),
    [anon_sym_import] = ACTIONS(13656),
    [anon_sym_using] = ACTIONS(13656),
    [anon_sym_LBRACK] = ACTIONS(13656),
    [anon_sym_LF] = ACTIONS(13658),
    [anon_sym_in] = ACTIONS(13656),
    [anon_sym_LBRACE] = ACTIONS(13656),
    [anon_sym_DOLLAR] = ACTIONS(13656),
    [anon_sym_COLON_COLON] = ACTIONS(13656),
    [anon_sym_isa] = ACTIONS(13656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13656),
    [anon_sym_QMARK] = ACTIONS(13656),
    [anon_sym_AT] = ACTIONS(13656),
    [anon_sym_true] = ACTIONS(13656),
    [anon_sym_false] = ACTIONS(13656),
    [aux_sym_integer_literal_token1] = ACTIONS(13656),
    [aux_sym_integer_literal_token2] = ACTIONS(13656),
    [aux_sym_integer_literal_token3] = ACTIONS(13656),
    [aux_sym_integer_literal_token4] = ACTIONS(13656),
    [aux_sym_float_literal_token1] = ACTIONS(13656),
    [aux_sym_float_literal_token3] = ACTIONS(13656),
    [aux_sym_float_literal_token4] = ACTIONS(13656),
    [sym_character_literal] = ACTIONS(13656),
    [sym__pair_operator] = ACTIONS(13656),
    [sym__arrow_operator] = ACTIONS(13656),
    [sym__lazy_or_operator] = ACTIONS(13656),
    [sym__lazy_and_operator] = ACTIONS(13656),
    [sym__comparison_operator] = ACTIONS(13656),
    [sym__pipe_right_operator] = ACTIONS(13656),
    [sym__pipe_left_operator] = ACTIONS(13656),
    [sym__ellipsis_operator] = ACTIONS(13656),
    [sym__plus_operator] = ACTIONS(13656),
    [sym__times_operator] = ACTIONS(13656),
    [sym__rational_operator] = ACTIONS(13656),
    [sym__bitshift_operator] = ACTIONS(13656),
    [sym__power_operator] = ACTIONS(13656),
    [sym__tilde_operator] = ACTIONS(13656),
    [sym__type_order_operator] = ACTIONS(13656),
    [sym__unary_operator] = ACTIONS(13656),
    [sym__unary_plus_operator] = ACTIONS(13656),
    [aux_sym__terminator_token1] = ACTIONS(13656),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13658),
    [sym__command_start] = ACTIONS(13658),
  },
  [8248] = {
    [sym__word_identifier] = ACTIONS(13660),
    [anon_sym_EQ] = ACTIONS(13660),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_COLON] = ACTIONS(13660),
    [anon_sym_begin] = ACTIONS(13660),
    [anon_sym_module] = ACTIONS(13660),
    [anon_sym_baremodule] = ACTIONS(13660),
    [anon_sym_end] = ACTIONS(13660),
    [anon_sym_abstract] = ACTIONS(13660),
    [anon_sym_primitive] = ACTIONS(13660),
    [anon_sym_mutable] = ACTIONS(13660),
    [anon_sym_struct] = ACTIONS(13660),
    [anon_sym_function] = ACTIONS(13660),
    [anon_sym_macro] = ACTIONS(13660),
    [anon_sym_where] = ACTIONS(13660),
    [anon_sym_quote] = ACTIONS(13660),
    [anon_sym_let] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_try] = ACTIONS(13660),
    [anon_sym_finally] = ACTIONS(13660),
    [anon_sym_for] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [sym_break_statement] = ACTIONS(13660),
    [sym_continue_statement] = ACTIONS(13660),
    [anon_sym_return] = ACTIONS(13660),
    [anon_sym_const] = ACTIONS(13660),
    [anon_sym_global] = ACTIONS(13660),
    [anon_sym_local] = ACTIONS(13660),
    [anon_sym_LPAREN] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13660),
    [anon_sym_export] = ACTIONS(13660),
    [anon_sym_import] = ACTIONS(13660),
    [anon_sym_using] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_LF] = ACTIONS(13662),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_DOLLAR] = ACTIONS(13660),
    [anon_sym_COLON_COLON] = ACTIONS(13660),
    [anon_sym_isa] = ACTIONS(13660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_AT] = ACTIONS(13660),
    [anon_sym_true] = ACTIONS(13660),
    [anon_sym_false] = ACTIONS(13660),
    [aux_sym_integer_literal_token1] = ACTIONS(13660),
    [aux_sym_integer_literal_token2] = ACTIONS(13660),
    [aux_sym_integer_literal_token3] = ACTIONS(13660),
    [aux_sym_integer_literal_token4] = ACTIONS(13660),
    [aux_sym_float_literal_token1] = ACTIONS(13660),
    [aux_sym_float_literal_token3] = ACTIONS(13660),
    [aux_sym_float_literal_token4] = ACTIONS(13660),
    [sym_character_literal] = ACTIONS(13660),
    [sym__pair_operator] = ACTIONS(13660),
    [sym__arrow_operator] = ACTIONS(13660),
    [sym__lazy_or_operator] = ACTIONS(13660),
    [sym__lazy_and_operator] = ACTIONS(13660),
    [sym__comparison_operator] = ACTIONS(13660),
    [sym__pipe_right_operator] = ACTIONS(13660),
    [sym__pipe_left_operator] = ACTIONS(13660),
    [sym__ellipsis_operator] = ACTIONS(13660),
    [sym__plus_operator] = ACTIONS(13660),
    [sym__times_operator] = ACTIONS(13660),
    [sym__rational_operator] = ACTIONS(13660),
    [sym__bitshift_operator] = ACTIONS(13660),
    [sym__power_operator] = ACTIONS(13660),
    [sym__tilde_operator] = ACTIONS(13660),
    [sym__type_order_operator] = ACTIONS(13660),
    [sym__unary_operator] = ACTIONS(13660),
    [sym__unary_plus_operator] = ACTIONS(13660),
    [aux_sym__terminator_token1] = ACTIONS(13660),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13662),
    [sym__command_start] = ACTIONS(13662),
  },
  [8249] = {
    [sym__word_identifier] = ACTIONS(13664),
    [anon_sym_EQ] = ACTIONS(13664),
    [anon_sym_COMMA] = ACTIONS(13664),
    [anon_sym_COLON] = ACTIONS(13664),
    [anon_sym_begin] = ACTIONS(13664),
    [anon_sym_module] = ACTIONS(13664),
    [anon_sym_baremodule] = ACTIONS(13664),
    [anon_sym_end] = ACTIONS(13664),
    [anon_sym_abstract] = ACTIONS(13664),
    [anon_sym_primitive] = ACTIONS(13664),
    [anon_sym_mutable] = ACTIONS(13664),
    [anon_sym_struct] = ACTIONS(13664),
    [anon_sym_function] = ACTIONS(13664),
    [anon_sym_macro] = ACTIONS(13664),
    [anon_sym_where] = ACTIONS(13664),
    [anon_sym_quote] = ACTIONS(13664),
    [anon_sym_let] = ACTIONS(13664),
    [anon_sym_if] = ACTIONS(13664),
    [anon_sym_try] = ACTIONS(13664),
    [anon_sym_finally] = ACTIONS(13664),
    [anon_sym_for] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(13664),
    [sym_break_statement] = ACTIONS(13664),
    [sym_continue_statement] = ACTIONS(13664),
    [anon_sym_return] = ACTIONS(13664),
    [anon_sym_const] = ACTIONS(13664),
    [anon_sym_global] = ACTIONS(13664),
    [anon_sym_local] = ACTIONS(13664),
    [anon_sym_LPAREN] = ACTIONS(13664),
    [anon_sym_COLON2] = ACTIONS(13664),
    [anon_sym_export] = ACTIONS(13664),
    [anon_sym_import] = ACTIONS(13664),
    [anon_sym_using] = ACTIONS(13664),
    [anon_sym_LBRACK] = ACTIONS(13664),
    [anon_sym_LF] = ACTIONS(13666),
    [anon_sym_in] = ACTIONS(13664),
    [anon_sym_LBRACE] = ACTIONS(13664),
    [anon_sym_DOLLAR] = ACTIONS(13664),
    [anon_sym_COLON_COLON] = ACTIONS(13664),
    [anon_sym_isa] = ACTIONS(13664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13664),
    [anon_sym_QMARK] = ACTIONS(13664),
    [anon_sym_AT] = ACTIONS(13664),
    [anon_sym_true] = ACTIONS(13664),
    [anon_sym_false] = ACTIONS(13664),
    [aux_sym_integer_literal_token1] = ACTIONS(13664),
    [aux_sym_integer_literal_token2] = ACTIONS(13664),
    [aux_sym_integer_literal_token3] = ACTIONS(13664),
    [aux_sym_integer_literal_token4] = ACTIONS(13664),
    [aux_sym_float_literal_token1] = ACTIONS(13664),
    [aux_sym_float_literal_token3] = ACTIONS(13664),
    [aux_sym_float_literal_token4] = ACTIONS(13664),
    [sym_character_literal] = ACTIONS(13664),
    [sym__pair_operator] = ACTIONS(13664),
    [sym__arrow_operator] = ACTIONS(13664),
    [sym__lazy_or_operator] = ACTIONS(13664),
    [sym__lazy_and_operator] = ACTIONS(13664),
    [sym__comparison_operator] = ACTIONS(13664),
    [sym__pipe_right_operator] = ACTIONS(13664),
    [sym__pipe_left_operator] = ACTIONS(13664),
    [sym__ellipsis_operator] = ACTIONS(13664),
    [sym__plus_operator] = ACTIONS(13664),
    [sym__times_operator] = ACTIONS(13664),
    [sym__rational_operator] = ACTIONS(13664),
    [sym__bitshift_operator] = ACTIONS(13664),
    [sym__power_operator] = ACTIONS(13664),
    [sym__tilde_operator] = ACTIONS(13664),
    [sym__type_order_operator] = ACTIONS(13664),
    [sym__unary_operator] = ACTIONS(13664),
    [sym__unary_plus_operator] = ACTIONS(13664),
    [aux_sym__terminator_token1] = ACTIONS(13664),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13666),
    [sym__command_start] = ACTIONS(13666),
  },
  [8250] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(12562),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_catch] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8251] = {
    [aux_sym_export_statement_repeat1] = STATE(8259),
    [sym__word_identifier] = ACTIONS(13060),
    [anon_sym_EQ] = ACTIONS(13060),
    [anon_sym_COMMA] = ACTIONS(14584),
    [anon_sym_COLON] = ACTIONS(13060),
    [anon_sym_begin] = ACTIONS(13060),
    [anon_sym_module] = ACTIONS(13060),
    [anon_sym_baremodule] = ACTIONS(13060),
    [anon_sym_end] = ACTIONS(13060),
    [anon_sym_abstract] = ACTIONS(13060),
    [anon_sym_primitive] = ACTIONS(13060),
    [anon_sym_mutable] = ACTIONS(13060),
    [anon_sym_struct] = ACTIONS(13060),
    [anon_sym_function] = ACTIONS(13060),
    [anon_sym_macro] = ACTIONS(13060),
    [anon_sym_where] = ACTIONS(13060),
    [anon_sym_quote] = ACTIONS(13060),
    [anon_sym_let] = ACTIONS(13060),
    [anon_sym_if] = ACTIONS(13060),
    [anon_sym_try] = ACTIONS(13060),
    [anon_sym_for] = ACTIONS(13060),
    [anon_sym_while] = ACTIONS(13060),
    [sym_break_statement] = ACTIONS(13060),
    [sym_continue_statement] = ACTIONS(13060),
    [anon_sym_return] = ACTIONS(13060),
    [anon_sym_const] = ACTIONS(13060),
    [anon_sym_global] = ACTIONS(13060),
    [anon_sym_local] = ACTIONS(13060),
    [anon_sym_LPAREN] = ACTIONS(13060),
    [anon_sym_COLON2] = ACTIONS(13060),
    [anon_sym_export] = ACTIONS(13060),
    [anon_sym_import] = ACTIONS(13060),
    [anon_sym_using] = ACTIONS(13060),
    [anon_sym_LBRACK] = ACTIONS(13060),
    [anon_sym_LF] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13060),
    [anon_sym_LBRACE] = ACTIONS(13060),
    [anon_sym_DOLLAR] = ACTIONS(13060),
    [anon_sym_COLON_COLON] = ACTIONS(13060),
    [anon_sym_isa] = ACTIONS(13060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13060),
    [anon_sym_QMARK] = ACTIONS(13060),
    [anon_sym_AT] = ACTIONS(13060),
    [anon_sym_true] = ACTIONS(13060),
    [anon_sym_false] = ACTIONS(13060),
    [aux_sym_integer_literal_token1] = ACTIONS(13060),
    [aux_sym_integer_literal_token2] = ACTIONS(13060),
    [aux_sym_integer_literal_token3] = ACTIONS(13060),
    [aux_sym_integer_literal_token4] = ACTIONS(13060),
    [aux_sym_float_literal_token1] = ACTIONS(13060),
    [aux_sym_float_literal_token3] = ACTIONS(13060),
    [aux_sym_float_literal_token4] = ACTIONS(13060),
    [sym_character_literal] = ACTIONS(13060),
    [sym__pair_operator] = ACTIONS(13060),
    [sym__arrow_operator] = ACTIONS(13060),
    [sym__lazy_or_operator] = ACTIONS(13060),
    [sym__lazy_and_operator] = ACTIONS(13060),
    [sym__comparison_operator] = ACTIONS(13060),
    [sym__pipe_right_operator] = ACTIONS(13060),
    [sym__pipe_left_operator] = ACTIONS(13060),
    [sym__ellipsis_operator] = ACTIONS(13060),
    [sym__plus_operator] = ACTIONS(13060),
    [sym__times_operator] = ACTIONS(13060),
    [sym__rational_operator] = ACTIONS(13060),
    [sym__bitshift_operator] = ACTIONS(13060),
    [sym__power_operator] = ACTIONS(13060),
    [sym__tilde_operator] = ACTIONS(13060),
    [sym__type_order_operator] = ACTIONS(13060),
    [sym__unary_operator] = ACTIONS(13060),
    [sym__unary_plus_operator] = ACTIONS(13060),
    [aux_sym__terminator_token1] = ACTIONS(13060),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13064),
    [sym__command_start] = ACTIONS(13064),
  },
  [8252] = {
    [aux_sym__import_list_repeat1] = STATE(8261),
    [sym__word_identifier] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13742),
    [anon_sym_COLON] = ACTIONS(13066),
    [anon_sym_begin] = ACTIONS(13066),
    [anon_sym_module] = ACTIONS(13066),
    [anon_sym_baremodule] = ACTIONS(13066),
    [anon_sym_end] = ACTIONS(13066),
    [anon_sym_abstract] = ACTIONS(13066),
    [anon_sym_primitive] = ACTIONS(13066),
    [anon_sym_mutable] = ACTIONS(13066),
    [anon_sym_struct] = ACTIONS(13066),
    [anon_sym_function] = ACTIONS(13066),
    [anon_sym_macro] = ACTIONS(13066),
    [anon_sym_where] = ACTIONS(13066),
    [anon_sym_quote] = ACTIONS(13066),
    [anon_sym_let] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13066),
    [anon_sym_try] = ACTIONS(13066),
    [anon_sym_for] = ACTIONS(13066),
    [anon_sym_while] = ACTIONS(13066),
    [sym_break_statement] = ACTIONS(13066),
    [sym_continue_statement] = ACTIONS(13066),
    [anon_sym_return] = ACTIONS(13066),
    [anon_sym_const] = ACTIONS(13066),
    [anon_sym_global] = ACTIONS(13066),
    [anon_sym_local] = ACTIONS(13066),
    [anon_sym_LPAREN] = ACTIONS(13066),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_export] = ACTIONS(13066),
    [anon_sym_import] = ACTIONS(13066),
    [anon_sym_using] = ACTIONS(13066),
    [anon_sym_LBRACK] = ACTIONS(13066),
    [anon_sym_LF] = ACTIONS(13068),
    [anon_sym_in] = ACTIONS(13066),
    [anon_sym_LBRACE] = ACTIONS(13066),
    [anon_sym_DOLLAR] = ACTIONS(13066),
    [anon_sym_COLON_COLON] = ACTIONS(13066),
    [anon_sym_isa] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13066),
    [anon_sym_QMARK] = ACTIONS(13066),
    [anon_sym_AT] = ACTIONS(13066),
    [anon_sym_true] = ACTIONS(13066),
    [anon_sym_false] = ACTIONS(13066),
    [aux_sym_integer_literal_token1] = ACTIONS(13066),
    [aux_sym_integer_literal_token2] = ACTIONS(13066),
    [aux_sym_integer_literal_token3] = ACTIONS(13066),
    [aux_sym_integer_literal_token4] = ACTIONS(13066),
    [aux_sym_float_literal_token1] = ACTIONS(13066),
    [aux_sym_float_literal_token3] = ACTIONS(13066),
    [aux_sym_float_literal_token4] = ACTIONS(13066),
    [sym_character_literal] = ACTIONS(13066),
    [sym__pair_operator] = ACTIONS(13066),
    [sym__arrow_operator] = ACTIONS(13066),
    [sym__lazy_or_operator] = ACTIONS(13066),
    [sym__lazy_and_operator] = ACTIONS(13066),
    [sym__comparison_operator] = ACTIONS(13066),
    [sym__pipe_right_operator] = ACTIONS(13066),
    [sym__pipe_left_operator] = ACTIONS(13066),
    [sym__ellipsis_operator] = ACTIONS(13066),
    [sym__plus_operator] = ACTIONS(13066),
    [sym__times_operator] = ACTIONS(13066),
    [sym__rational_operator] = ACTIONS(13066),
    [sym__bitshift_operator] = ACTIONS(13066),
    [sym__power_operator] = ACTIONS(13066),
    [sym__tilde_operator] = ACTIONS(13066),
    [sym__type_order_operator] = ACTIONS(13066),
    [sym__unary_operator] = ACTIONS(13066),
    [sym__unary_plus_operator] = ACTIONS(13066),
    [aux_sym__terminator_token1] = ACTIONS(13066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13068),
    [sym__command_start] = ACTIONS(13068),
  },
  [8253] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(12610),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8254] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(12610),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8255] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12610),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8256] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [8257] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8258] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_catch] = ACTIONS(13038),
    [anon_sym_finally] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [8259] = {
    [aux_sym_export_statement_repeat1] = STATE(8259),
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(14586),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_end] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [8260] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_as] = ACTIONS(13744),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8261] = {
    [aux_sym__import_list_repeat1] = STATE(8261),
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(14589),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8262] = {
    [sym__word_identifier] = ACTIONS(13518),
    [anon_sym_EQ] = ACTIONS(13518),
    [anon_sym_COMMA] = ACTIONS(13520),
    [anon_sym_COLON] = ACTIONS(13518),
    [anon_sym_begin] = ACTIONS(13518),
    [anon_sym_module] = ACTIONS(13518),
    [anon_sym_baremodule] = ACTIONS(13518),
    [anon_sym_abstract] = ACTIONS(13518),
    [anon_sym_primitive] = ACTIONS(13518),
    [anon_sym_mutable] = ACTIONS(13518),
    [anon_sym_struct] = ACTIONS(13518),
    [anon_sym_function] = ACTIONS(13518),
    [anon_sym_macro] = ACTIONS(13518),
    [anon_sym_where] = ACTIONS(13518),
    [anon_sym_quote] = ACTIONS(13518),
    [anon_sym_let] = ACTIONS(13518),
    [anon_sym_if] = ACTIONS(13518),
    [anon_sym_try] = ACTIONS(13518),
    [anon_sym_for] = ACTIONS(13518),
    [anon_sym_while] = ACTIONS(13518),
    [sym_break_statement] = ACTIONS(13518),
    [sym_continue_statement] = ACTIONS(13518),
    [anon_sym_return] = ACTIONS(13518),
    [anon_sym_const] = ACTIONS(13518),
    [anon_sym_global] = ACTIONS(13518),
    [anon_sym_local] = ACTIONS(13518),
    [anon_sym_LPAREN] = ACTIONS(13520),
    [anon_sym_RPAREN] = ACTIONS(13520),
    [anon_sym_COLON2] = ACTIONS(13518),
    [anon_sym_export] = ACTIONS(13518),
    [anon_sym_import] = ACTIONS(13518),
    [anon_sym_using] = ACTIONS(13518),
    [anon_sym_LBRACK] = ACTIONS(13520),
    [anon_sym_RBRACK] = ACTIONS(13520),
    [anon_sym_in] = ACTIONS(13518),
    [anon_sym_SEMI] = ACTIONS(13520),
    [anon_sym_LBRACE] = ACTIONS(13520),
    [anon_sym_RBRACE] = ACTIONS(13520),
    [anon_sym_DOLLAR] = ACTIONS(13520),
    [anon_sym_COLON_COLON] = ACTIONS(13520),
    [anon_sym_isa] = ACTIONS(13518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13520),
    [anon_sym_QMARK] = ACTIONS(13520),
    [anon_sym_AT] = ACTIONS(13520),
    [anon_sym_true] = ACTIONS(13518),
    [anon_sym_false] = ACTIONS(13518),
    [aux_sym_integer_literal_token1] = ACTIONS(13520),
    [aux_sym_integer_literal_token2] = ACTIONS(13520),
    [aux_sym_integer_literal_token3] = ACTIONS(13518),
    [aux_sym_integer_literal_token4] = ACTIONS(13518),
    [aux_sym_float_literal_token1] = ACTIONS(13520),
    [aux_sym_float_literal_token3] = ACTIONS(13520),
    [aux_sym_float_literal_token4] = ACTIONS(13520),
    [sym_character_literal] = ACTIONS(13520),
    [sym__pair_operator] = ACTIONS(13520),
    [sym__arrow_operator] = ACTIONS(13518),
    [sym__lazy_or_operator] = ACTIONS(13520),
    [sym__lazy_and_operator] = ACTIONS(13520),
    [sym__comparison_operator] = ACTIONS(13518),
    [sym__pipe_right_operator] = ACTIONS(13520),
    [sym__pipe_left_operator] = ACTIONS(13520),
    [sym__ellipsis_operator] = ACTIONS(13518),
    [sym__plus_operator] = ACTIONS(13518),
    [sym__times_operator] = ACTIONS(13518),
    [sym__rational_operator] = ACTIONS(13520),
    [sym__bitshift_operator] = ACTIONS(13520),
    [sym__power_operator] = ACTIONS(13520),
    [sym__tilde_operator] = ACTIONS(13520),
    [sym__type_order_operator] = ACTIONS(13520),
    [sym__unary_operator] = ACTIONS(13518),
    [sym__unary_plus_operator] = ACTIONS(13518),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13520),
    [sym__command_start] = ACTIONS(13520),
  },
  [8263] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_finally] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8264] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12732),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8265] = {
    [sym__word_identifier] = ACTIONS(13316),
    [anon_sym_EQ] = ACTIONS(13316),
    [anon_sym_COMMA] = ACTIONS(13316),
    [anon_sym_COLON] = ACTIONS(13316),
    [anon_sym_begin] = ACTIONS(13316),
    [anon_sym_module] = ACTIONS(13316),
    [anon_sym_baremodule] = ACTIONS(13316),
    [anon_sym_abstract] = ACTIONS(13316),
    [anon_sym_primitive] = ACTIONS(13316),
    [anon_sym_mutable] = ACTIONS(13316),
    [anon_sym_struct] = ACTIONS(13316),
    [anon_sym_function] = ACTIONS(13316),
    [anon_sym_macro] = ACTIONS(13316),
    [anon_sym_where] = ACTIONS(13316),
    [anon_sym_quote] = ACTIONS(13316),
    [anon_sym_let] = ACTIONS(13316),
    [anon_sym_if] = ACTIONS(13316),
    [anon_sym_try] = ACTIONS(13316),
    [anon_sym_catch] = ACTIONS(13316),
    [anon_sym_finally] = ACTIONS(13316),
    [anon_sym_for] = ACTIONS(13316),
    [anon_sym_while] = ACTIONS(13316),
    [sym_break_statement] = ACTIONS(13316),
    [sym_continue_statement] = ACTIONS(13316),
    [anon_sym_return] = ACTIONS(13316),
    [anon_sym_const] = ACTIONS(13316),
    [anon_sym_global] = ACTIONS(13316),
    [anon_sym_local] = ACTIONS(13316),
    [anon_sym_LPAREN] = ACTIONS(13316),
    [anon_sym_COLON2] = ACTIONS(13316),
    [anon_sym_export] = ACTIONS(13316),
    [anon_sym_import] = ACTIONS(13316),
    [anon_sym_using] = ACTIONS(13316),
    [anon_sym_LBRACK] = ACTIONS(13316),
    [anon_sym_LF] = ACTIONS(13318),
    [anon_sym_in] = ACTIONS(13316),
    [anon_sym_LBRACE] = ACTIONS(13316),
    [anon_sym_DOLLAR] = ACTIONS(13316),
    [anon_sym_COLON_COLON] = ACTIONS(13316),
    [anon_sym_isa] = ACTIONS(13316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13316),
    [anon_sym_QMARK] = ACTIONS(13316),
    [anon_sym_AT] = ACTIONS(13316),
    [anon_sym_true] = ACTIONS(13316),
    [anon_sym_false] = ACTIONS(13316),
    [aux_sym_integer_literal_token1] = ACTIONS(13316),
    [aux_sym_integer_literal_token2] = ACTIONS(13316),
    [aux_sym_integer_literal_token3] = ACTIONS(13316),
    [aux_sym_integer_literal_token4] = ACTIONS(13316),
    [aux_sym_float_literal_token1] = ACTIONS(13316),
    [aux_sym_float_literal_token3] = ACTIONS(13316),
    [aux_sym_float_literal_token4] = ACTIONS(13316),
    [sym_character_literal] = ACTIONS(13316),
    [sym__pair_operator] = ACTIONS(13316),
    [sym__arrow_operator] = ACTIONS(13316),
    [sym__lazy_or_operator] = ACTIONS(13316),
    [sym__lazy_and_operator] = ACTIONS(13316),
    [sym__comparison_operator] = ACTIONS(13316),
    [sym__pipe_right_operator] = ACTIONS(13316),
    [sym__pipe_left_operator] = ACTIONS(13316),
    [sym__ellipsis_operator] = ACTIONS(13316),
    [sym__plus_operator] = ACTIONS(13316),
    [sym__times_operator] = ACTIONS(13316),
    [sym__rational_operator] = ACTIONS(13316),
    [sym__bitshift_operator] = ACTIONS(13316),
    [sym__power_operator] = ACTIONS(13316),
    [sym__tilde_operator] = ACTIONS(13316),
    [sym__type_order_operator] = ACTIONS(13316),
    [sym__unary_operator] = ACTIONS(13316),
    [sym__unary_plus_operator] = ACTIONS(13316),
    [aux_sym__terminator_token1] = ACTIONS(13316),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13318),
    [sym__command_start] = ACTIONS(13318),
  },
  [8266] = {
    [sym__word_identifier] = ACTIONS(13320),
    [anon_sym_EQ] = ACTIONS(13320),
    [anon_sym_COMMA] = ACTIONS(13320),
    [anon_sym_COLON] = ACTIONS(13320),
    [anon_sym_begin] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(13320),
    [anon_sym_baremodule] = ACTIONS(13320),
    [anon_sym_abstract] = ACTIONS(13320),
    [anon_sym_primitive] = ACTIONS(13320),
    [anon_sym_mutable] = ACTIONS(13320),
    [anon_sym_struct] = ACTIONS(13320),
    [anon_sym_function] = ACTIONS(13320),
    [anon_sym_macro] = ACTIONS(13320),
    [anon_sym_where] = ACTIONS(13320),
    [anon_sym_quote] = ACTIONS(13320),
    [anon_sym_let] = ACTIONS(13320),
    [anon_sym_if] = ACTIONS(13320),
    [anon_sym_try] = ACTIONS(13320),
    [anon_sym_catch] = ACTIONS(13320),
    [anon_sym_finally] = ACTIONS(13320),
    [anon_sym_for] = ACTIONS(13320),
    [anon_sym_while] = ACTIONS(13320),
    [sym_break_statement] = ACTIONS(13320),
    [sym_continue_statement] = ACTIONS(13320),
    [anon_sym_return] = ACTIONS(13320),
    [anon_sym_const] = ACTIONS(13320),
    [anon_sym_global] = ACTIONS(13320),
    [anon_sym_local] = ACTIONS(13320),
    [anon_sym_LPAREN] = ACTIONS(13320),
    [anon_sym_COLON2] = ACTIONS(13320),
    [anon_sym_export] = ACTIONS(13320),
    [anon_sym_import] = ACTIONS(13320),
    [anon_sym_using] = ACTIONS(13320),
    [anon_sym_LBRACK] = ACTIONS(13320),
    [anon_sym_LF] = ACTIONS(13322),
    [anon_sym_in] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(13320),
    [anon_sym_DOLLAR] = ACTIONS(13320),
    [anon_sym_COLON_COLON] = ACTIONS(13320),
    [anon_sym_isa] = ACTIONS(13320),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13320),
    [anon_sym_QMARK] = ACTIONS(13320),
    [anon_sym_AT] = ACTIONS(13320),
    [anon_sym_true] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(13320),
    [aux_sym_integer_literal_token1] = ACTIONS(13320),
    [aux_sym_integer_literal_token2] = ACTIONS(13320),
    [aux_sym_integer_literal_token3] = ACTIONS(13320),
    [aux_sym_integer_literal_token4] = ACTIONS(13320),
    [aux_sym_float_literal_token1] = ACTIONS(13320),
    [aux_sym_float_literal_token3] = ACTIONS(13320),
    [aux_sym_float_literal_token4] = ACTIONS(13320),
    [sym_character_literal] = ACTIONS(13320),
    [sym__pair_operator] = ACTIONS(13320),
    [sym__arrow_operator] = ACTIONS(13320),
    [sym__lazy_or_operator] = ACTIONS(13320),
    [sym__lazy_and_operator] = ACTIONS(13320),
    [sym__comparison_operator] = ACTIONS(13320),
    [sym__pipe_right_operator] = ACTIONS(13320),
    [sym__pipe_left_operator] = ACTIONS(13320),
    [sym__ellipsis_operator] = ACTIONS(13320),
    [sym__plus_operator] = ACTIONS(13320),
    [sym__times_operator] = ACTIONS(13320),
    [sym__rational_operator] = ACTIONS(13320),
    [sym__bitshift_operator] = ACTIONS(13320),
    [sym__power_operator] = ACTIONS(13320),
    [sym__tilde_operator] = ACTIONS(13320),
    [sym__type_order_operator] = ACTIONS(13320),
    [sym__unary_operator] = ACTIONS(13320),
    [sym__unary_plus_operator] = ACTIONS(13320),
    [aux_sym__terminator_token1] = ACTIONS(13320),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13322),
    [sym__command_start] = ACTIONS(13322),
  },
  [8267] = {
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13100),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13094),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13100),
    [anon_sym_RPAREN] = ACTIONS(13100),
    [anon_sym_COLON2] = ACTIONS(13094),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13100),
    [anon_sym_RBRACK] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13094),
    [anon_sym_SEMI] = ACTIONS(13100),
    [anon_sym_LBRACE] = ACTIONS(13100),
    [anon_sym_RBRACE] = ACTIONS(13100),
    [anon_sym_DOLLAR] = ACTIONS(13100),
    [anon_sym_COLON_COLON] = ACTIONS(13100),
    [anon_sym_isa] = ACTIONS(13094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13100),
    [anon_sym_QMARK] = ACTIONS(13100),
    [anon_sym_AT] = ACTIONS(13100),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13100),
    [aux_sym_integer_literal_token2] = ACTIONS(13100),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13100),
    [aux_sym_float_literal_token3] = ACTIONS(13100),
    [aux_sym_float_literal_token4] = ACTIONS(13100),
    [sym_character_literal] = ACTIONS(13100),
    [sym__pair_operator] = ACTIONS(13100),
    [sym__arrow_operator] = ACTIONS(13094),
    [sym__lazy_or_operator] = ACTIONS(13100),
    [sym__lazy_and_operator] = ACTIONS(13100),
    [sym__comparison_operator] = ACTIONS(13094),
    [sym__pipe_right_operator] = ACTIONS(13100),
    [sym__pipe_left_operator] = ACTIONS(13100),
    [sym__ellipsis_operator] = ACTIONS(13094),
    [sym__plus_operator] = ACTIONS(13094),
    [sym__times_operator] = ACTIONS(13094),
    [sym__rational_operator] = ACTIONS(13100),
    [sym__bitshift_operator] = ACTIONS(13100),
    [sym__power_operator] = ACTIONS(13100),
    [sym__tilde_operator] = ACTIONS(13100),
    [sym__type_order_operator] = ACTIONS(13100),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8268] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_catch] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8269] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12562),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8270] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DASH_GT] = ACTIONS(12128),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8271] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_finally] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8272] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12714),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12106),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8273] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12660),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8274] = {
    [aux_sym_export_statement_repeat1] = STATE(8283),
    [sym__word_identifier] = ACTIONS(13144),
    [anon_sym_EQ] = ACTIONS(13144),
    [anon_sym_COMMA] = ACTIONS(14594),
    [anon_sym_COLON] = ACTIONS(13144),
    [anon_sym_begin] = ACTIONS(13144),
    [anon_sym_module] = ACTIONS(13144),
    [anon_sym_baremodule] = ACTIONS(13144),
    [anon_sym_abstract] = ACTIONS(13144),
    [anon_sym_primitive] = ACTIONS(13144),
    [anon_sym_mutable] = ACTIONS(13144),
    [anon_sym_struct] = ACTIONS(13144),
    [anon_sym_function] = ACTIONS(13144),
    [anon_sym_macro] = ACTIONS(13144),
    [anon_sym_where] = ACTIONS(13144),
    [anon_sym_quote] = ACTIONS(13144),
    [anon_sym_let] = ACTIONS(13144),
    [anon_sym_if] = ACTIONS(13144),
    [anon_sym_try] = ACTIONS(13144),
    [anon_sym_for] = ACTIONS(13144),
    [anon_sym_while] = ACTIONS(13144),
    [sym_break_statement] = ACTIONS(13144),
    [sym_continue_statement] = ACTIONS(13144),
    [anon_sym_return] = ACTIONS(13144),
    [anon_sym_const] = ACTIONS(13144),
    [anon_sym_global] = ACTIONS(13144),
    [anon_sym_local] = ACTIONS(13144),
    [anon_sym_LPAREN] = ACTIONS(13144),
    [anon_sym_RPAREN] = ACTIONS(13144),
    [anon_sym_COLON2] = ACTIONS(13144),
    [anon_sym_export] = ACTIONS(13144),
    [anon_sym_import] = ACTIONS(13144),
    [anon_sym_using] = ACTIONS(13144),
    [anon_sym_LBRACK] = ACTIONS(13144),
    [anon_sym_LF] = ACTIONS(13146),
    [anon_sym_in] = ACTIONS(13144),
    [anon_sym_SEMI] = ACTIONS(13144),
    [anon_sym_LBRACE] = ACTIONS(13144),
    [anon_sym_DOLLAR] = ACTIONS(13144),
    [anon_sym_COLON_COLON] = ACTIONS(13144),
    [anon_sym_isa] = ACTIONS(13144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13144),
    [anon_sym_QMARK] = ACTIONS(13144),
    [anon_sym_AT] = ACTIONS(13144),
    [anon_sym_true] = ACTIONS(13144),
    [anon_sym_false] = ACTIONS(13144),
    [aux_sym_integer_literal_token1] = ACTIONS(13144),
    [aux_sym_integer_literal_token2] = ACTIONS(13144),
    [aux_sym_integer_literal_token3] = ACTIONS(13144),
    [aux_sym_integer_literal_token4] = ACTIONS(13144),
    [aux_sym_float_literal_token1] = ACTIONS(13144),
    [aux_sym_float_literal_token3] = ACTIONS(13144),
    [aux_sym_float_literal_token4] = ACTIONS(13144),
    [sym_character_literal] = ACTIONS(13144),
    [sym__pair_operator] = ACTIONS(13144),
    [sym__arrow_operator] = ACTIONS(13144),
    [sym__lazy_or_operator] = ACTIONS(13144),
    [sym__lazy_and_operator] = ACTIONS(13144),
    [sym__comparison_operator] = ACTIONS(13144),
    [sym__pipe_right_operator] = ACTIONS(13144),
    [sym__pipe_left_operator] = ACTIONS(13144),
    [sym__ellipsis_operator] = ACTIONS(13144),
    [sym__plus_operator] = ACTIONS(13144),
    [sym__times_operator] = ACTIONS(13144),
    [sym__rational_operator] = ACTIONS(13144),
    [sym__bitshift_operator] = ACTIONS(13144),
    [sym__power_operator] = ACTIONS(13144),
    [sym__tilde_operator] = ACTIONS(13144),
    [sym__type_order_operator] = ACTIONS(13144),
    [sym__unary_operator] = ACTIONS(13144),
    [sym__unary_plus_operator] = ACTIONS(13144),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13146),
    [sym__command_start] = ACTIONS(13146),
  },
  [8275] = {
    [aux_sym__import_list_repeat1] = STATE(8284),
    [sym__word_identifier] = ACTIONS(12862),
    [anon_sym_EQ] = ACTIONS(12862),
    [anon_sym_COMMA] = ACTIONS(13884),
    [anon_sym_COLON] = ACTIONS(12862),
    [anon_sym_begin] = ACTIONS(12862),
    [anon_sym_module] = ACTIONS(12862),
    [anon_sym_baremodule] = ACTIONS(12862),
    [anon_sym_abstract] = ACTIONS(12862),
    [anon_sym_primitive] = ACTIONS(12862),
    [anon_sym_mutable] = ACTIONS(12862),
    [anon_sym_struct] = ACTIONS(12862),
    [anon_sym_function] = ACTIONS(12862),
    [anon_sym_macro] = ACTIONS(12862),
    [anon_sym_where] = ACTIONS(12862),
    [anon_sym_quote] = ACTIONS(12862),
    [anon_sym_let] = ACTIONS(12862),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_try] = ACTIONS(12862),
    [anon_sym_for] = ACTIONS(12862),
    [anon_sym_while] = ACTIONS(12862),
    [sym_break_statement] = ACTIONS(12862),
    [sym_continue_statement] = ACTIONS(12862),
    [anon_sym_return] = ACTIONS(12862),
    [anon_sym_const] = ACTIONS(12862),
    [anon_sym_global] = ACTIONS(12862),
    [anon_sym_local] = ACTIONS(12862),
    [anon_sym_LPAREN] = ACTIONS(12862),
    [anon_sym_RPAREN] = ACTIONS(12862),
    [anon_sym_COLON2] = ACTIONS(12862),
    [anon_sym_export] = ACTIONS(12862),
    [anon_sym_import] = ACTIONS(12862),
    [anon_sym_using] = ACTIONS(12862),
    [anon_sym_LBRACK] = ACTIONS(12862),
    [anon_sym_LF] = ACTIONS(12868),
    [anon_sym_in] = ACTIONS(12862),
    [anon_sym_SEMI] = ACTIONS(12862),
    [anon_sym_LBRACE] = ACTIONS(12862),
    [anon_sym_DOLLAR] = ACTIONS(12862),
    [anon_sym_COLON_COLON] = ACTIONS(12862),
    [anon_sym_isa] = ACTIONS(12862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12862),
    [anon_sym_QMARK] = ACTIONS(12862),
    [anon_sym_AT] = ACTIONS(12862),
    [anon_sym_true] = ACTIONS(12862),
    [anon_sym_false] = ACTIONS(12862),
    [aux_sym_integer_literal_token1] = ACTIONS(12862),
    [aux_sym_integer_literal_token2] = ACTIONS(12862),
    [aux_sym_integer_literal_token3] = ACTIONS(12862),
    [aux_sym_integer_literal_token4] = ACTIONS(12862),
    [aux_sym_float_literal_token1] = ACTIONS(12862),
    [aux_sym_float_literal_token3] = ACTIONS(12862),
    [aux_sym_float_literal_token4] = ACTIONS(12862),
    [sym_character_literal] = ACTIONS(12862),
    [sym__pair_operator] = ACTIONS(12862),
    [sym__arrow_operator] = ACTIONS(12862),
    [sym__lazy_or_operator] = ACTIONS(12862),
    [sym__lazy_and_operator] = ACTIONS(12862),
    [sym__comparison_operator] = ACTIONS(12862),
    [sym__pipe_right_operator] = ACTIONS(12862),
    [sym__pipe_left_operator] = ACTIONS(12862),
    [sym__ellipsis_operator] = ACTIONS(12862),
    [sym__plus_operator] = ACTIONS(12862),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12862),
    [sym__bitshift_operator] = ACTIONS(12862),
    [sym__power_operator] = ACTIONS(12862),
    [sym__tilde_operator] = ACTIONS(12862),
    [sym__type_order_operator] = ACTIONS(12862),
    [sym__unary_operator] = ACTIONS(12862),
    [sym__unary_plus_operator] = ACTIONS(12862),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12868),
    [sym__command_start] = ACTIONS(12868),
  },
  [8276] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_EQ] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_finally] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [8277] = {
    [sym__word_identifier] = ACTIONS(13257),
    [anon_sym_EQ] = ACTIONS(13257),
    [anon_sym_COMMA] = ACTIONS(13259),
    [anon_sym_COLON] = ACTIONS(13257),
    [anon_sym_begin] = ACTIONS(13257),
    [anon_sym_module] = ACTIONS(13257),
    [anon_sym_baremodule] = ACTIONS(13257),
    [anon_sym_abstract] = ACTIONS(13257),
    [anon_sym_primitive] = ACTIONS(13257),
    [anon_sym_mutable] = ACTIONS(13257),
    [anon_sym_struct] = ACTIONS(13257),
    [anon_sym_function] = ACTIONS(13257),
    [anon_sym_macro] = ACTIONS(13257),
    [anon_sym_where] = ACTIONS(13257),
    [anon_sym_quote] = ACTIONS(13257),
    [anon_sym_let] = ACTIONS(13257),
    [anon_sym_if] = ACTIONS(13257),
    [anon_sym_try] = ACTIONS(13257),
    [anon_sym_for] = ACTIONS(13257),
    [anon_sym_while] = ACTIONS(13257),
    [sym_break_statement] = ACTIONS(13257),
    [sym_continue_statement] = ACTIONS(13257),
    [anon_sym_return] = ACTIONS(13257),
    [anon_sym_const] = ACTIONS(13257),
    [anon_sym_global] = ACTIONS(13257),
    [anon_sym_local] = ACTIONS(13257),
    [anon_sym_LPAREN] = ACTIONS(13259),
    [anon_sym_RPAREN] = ACTIONS(13259),
    [anon_sym_COLON2] = ACTIONS(13257),
    [anon_sym_export] = ACTIONS(13257),
    [anon_sym_import] = ACTIONS(13257),
    [anon_sym_using] = ACTIONS(13257),
    [anon_sym_LBRACK] = ACTIONS(13259),
    [anon_sym_RBRACK] = ACTIONS(13259),
    [anon_sym_in] = ACTIONS(13257),
    [anon_sym_SEMI] = ACTIONS(13259),
    [anon_sym_LBRACE] = ACTIONS(13259),
    [anon_sym_RBRACE] = ACTIONS(13259),
    [anon_sym_DOLLAR] = ACTIONS(13259),
    [anon_sym_COLON_COLON] = ACTIONS(13259),
    [anon_sym_isa] = ACTIONS(13257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13259),
    [anon_sym_QMARK] = ACTIONS(13259),
    [anon_sym_AT] = ACTIONS(13259),
    [anon_sym_true] = ACTIONS(13257),
    [anon_sym_false] = ACTIONS(13257),
    [aux_sym_integer_literal_token1] = ACTIONS(13259),
    [aux_sym_integer_literal_token2] = ACTIONS(13259),
    [aux_sym_integer_literal_token3] = ACTIONS(13257),
    [aux_sym_integer_literal_token4] = ACTIONS(13257),
    [aux_sym_float_literal_token1] = ACTIONS(13259),
    [aux_sym_float_literal_token3] = ACTIONS(13259),
    [aux_sym_float_literal_token4] = ACTIONS(13259),
    [sym_character_literal] = ACTIONS(13259),
    [sym__pair_operator] = ACTIONS(13259),
    [sym__arrow_operator] = ACTIONS(13257),
    [sym__lazy_or_operator] = ACTIONS(13259),
    [sym__lazy_and_operator] = ACTIONS(13259),
    [sym__comparison_operator] = ACTIONS(13257),
    [sym__pipe_right_operator] = ACTIONS(13259),
    [sym__pipe_left_operator] = ACTIONS(13259),
    [sym__ellipsis_operator] = ACTIONS(13257),
    [sym__plus_operator] = ACTIONS(13257),
    [sym__times_operator] = ACTIONS(13257),
    [sym__rational_operator] = ACTIONS(13259),
    [sym__bitshift_operator] = ACTIONS(13259),
    [sym__power_operator] = ACTIONS(13259),
    [sym__tilde_operator] = ACTIONS(13259),
    [sym__type_order_operator] = ACTIONS(13259),
    [sym__unary_operator] = ACTIONS(13257),
    [sym__unary_plus_operator] = ACTIONS(13257),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13259),
    [sym__command_start] = ACTIONS(13259),
  },
  [8278] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8279] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(12462),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_catch] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8280] = {
    [aux_sym_open_tuple_repeat1] = STATE(7998),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_catch] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8281] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [8282] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8283] = {
    [aux_sym_export_statement_repeat1] = STATE(8292),
    [sym__word_identifier] = ACTIONS(13060),
    [anon_sym_EQ] = ACTIONS(13060),
    [anon_sym_COMMA] = ACTIONS(14594),
    [anon_sym_COLON] = ACTIONS(13060),
    [anon_sym_begin] = ACTIONS(13060),
    [anon_sym_module] = ACTIONS(13060),
    [anon_sym_baremodule] = ACTIONS(13060),
    [anon_sym_abstract] = ACTIONS(13060),
    [anon_sym_primitive] = ACTIONS(13060),
    [anon_sym_mutable] = ACTIONS(13060),
    [anon_sym_struct] = ACTIONS(13060),
    [anon_sym_function] = ACTIONS(13060),
    [anon_sym_macro] = ACTIONS(13060),
    [anon_sym_where] = ACTIONS(13060),
    [anon_sym_quote] = ACTIONS(13060),
    [anon_sym_let] = ACTIONS(13060),
    [anon_sym_if] = ACTIONS(13060),
    [anon_sym_try] = ACTIONS(13060),
    [anon_sym_for] = ACTIONS(13060),
    [anon_sym_while] = ACTIONS(13060),
    [sym_break_statement] = ACTIONS(13060),
    [sym_continue_statement] = ACTIONS(13060),
    [anon_sym_return] = ACTIONS(13060),
    [anon_sym_const] = ACTIONS(13060),
    [anon_sym_global] = ACTIONS(13060),
    [anon_sym_local] = ACTIONS(13060),
    [anon_sym_LPAREN] = ACTIONS(13060),
    [anon_sym_RPAREN] = ACTIONS(13060),
    [anon_sym_COLON2] = ACTIONS(13060),
    [anon_sym_export] = ACTIONS(13060),
    [anon_sym_import] = ACTIONS(13060),
    [anon_sym_using] = ACTIONS(13060),
    [anon_sym_LBRACK] = ACTIONS(13060),
    [anon_sym_LF] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13060),
    [anon_sym_SEMI] = ACTIONS(13060),
    [anon_sym_LBRACE] = ACTIONS(13060),
    [anon_sym_DOLLAR] = ACTIONS(13060),
    [anon_sym_COLON_COLON] = ACTIONS(13060),
    [anon_sym_isa] = ACTIONS(13060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13060),
    [anon_sym_QMARK] = ACTIONS(13060),
    [anon_sym_AT] = ACTIONS(13060),
    [anon_sym_true] = ACTIONS(13060),
    [anon_sym_false] = ACTIONS(13060),
    [aux_sym_integer_literal_token1] = ACTIONS(13060),
    [aux_sym_integer_literal_token2] = ACTIONS(13060),
    [aux_sym_integer_literal_token3] = ACTIONS(13060),
    [aux_sym_integer_literal_token4] = ACTIONS(13060),
    [aux_sym_float_literal_token1] = ACTIONS(13060),
    [aux_sym_float_literal_token3] = ACTIONS(13060),
    [aux_sym_float_literal_token4] = ACTIONS(13060),
    [sym_character_literal] = ACTIONS(13060),
    [sym__pair_operator] = ACTIONS(13060),
    [sym__arrow_operator] = ACTIONS(13060),
    [sym__lazy_or_operator] = ACTIONS(13060),
    [sym__lazy_and_operator] = ACTIONS(13060),
    [sym__comparison_operator] = ACTIONS(13060),
    [sym__pipe_right_operator] = ACTIONS(13060),
    [sym__pipe_left_operator] = ACTIONS(13060),
    [sym__ellipsis_operator] = ACTIONS(13060),
    [sym__plus_operator] = ACTIONS(13060),
    [sym__times_operator] = ACTIONS(13060),
    [sym__rational_operator] = ACTIONS(13060),
    [sym__bitshift_operator] = ACTIONS(13060),
    [sym__power_operator] = ACTIONS(13060),
    [sym__tilde_operator] = ACTIONS(13060),
    [sym__type_order_operator] = ACTIONS(13060),
    [sym__unary_operator] = ACTIONS(13060),
    [sym__unary_plus_operator] = ACTIONS(13060),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13064),
    [sym__command_start] = ACTIONS(13064),
  },
  [8284] = {
    [aux_sym__import_list_repeat1] = STATE(8294),
    [sym__word_identifier] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13884),
    [anon_sym_COLON] = ACTIONS(13066),
    [anon_sym_begin] = ACTIONS(13066),
    [anon_sym_module] = ACTIONS(13066),
    [anon_sym_baremodule] = ACTIONS(13066),
    [anon_sym_abstract] = ACTIONS(13066),
    [anon_sym_primitive] = ACTIONS(13066),
    [anon_sym_mutable] = ACTIONS(13066),
    [anon_sym_struct] = ACTIONS(13066),
    [anon_sym_function] = ACTIONS(13066),
    [anon_sym_macro] = ACTIONS(13066),
    [anon_sym_where] = ACTIONS(13066),
    [anon_sym_quote] = ACTIONS(13066),
    [anon_sym_let] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13066),
    [anon_sym_try] = ACTIONS(13066),
    [anon_sym_for] = ACTIONS(13066),
    [anon_sym_while] = ACTIONS(13066),
    [sym_break_statement] = ACTIONS(13066),
    [sym_continue_statement] = ACTIONS(13066),
    [anon_sym_return] = ACTIONS(13066),
    [anon_sym_const] = ACTIONS(13066),
    [anon_sym_global] = ACTIONS(13066),
    [anon_sym_local] = ACTIONS(13066),
    [anon_sym_LPAREN] = ACTIONS(13066),
    [anon_sym_RPAREN] = ACTIONS(13066),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_export] = ACTIONS(13066),
    [anon_sym_import] = ACTIONS(13066),
    [anon_sym_using] = ACTIONS(13066),
    [anon_sym_LBRACK] = ACTIONS(13066),
    [anon_sym_LF] = ACTIONS(13068),
    [anon_sym_in] = ACTIONS(13066),
    [anon_sym_SEMI] = ACTIONS(13066),
    [anon_sym_LBRACE] = ACTIONS(13066),
    [anon_sym_DOLLAR] = ACTIONS(13066),
    [anon_sym_COLON_COLON] = ACTIONS(13066),
    [anon_sym_isa] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13066),
    [anon_sym_QMARK] = ACTIONS(13066),
    [anon_sym_AT] = ACTIONS(13066),
    [anon_sym_true] = ACTIONS(13066),
    [anon_sym_false] = ACTIONS(13066),
    [aux_sym_integer_literal_token1] = ACTIONS(13066),
    [aux_sym_integer_literal_token2] = ACTIONS(13066),
    [aux_sym_integer_literal_token3] = ACTIONS(13066),
    [aux_sym_integer_literal_token4] = ACTIONS(13066),
    [aux_sym_float_literal_token1] = ACTIONS(13066),
    [aux_sym_float_literal_token3] = ACTIONS(13066),
    [aux_sym_float_literal_token4] = ACTIONS(13066),
    [sym_character_literal] = ACTIONS(13066),
    [sym__pair_operator] = ACTIONS(13066),
    [sym__arrow_operator] = ACTIONS(13066),
    [sym__lazy_or_operator] = ACTIONS(13066),
    [sym__lazy_and_operator] = ACTIONS(13066),
    [sym__comparison_operator] = ACTIONS(13066),
    [sym__pipe_right_operator] = ACTIONS(13066),
    [sym__pipe_left_operator] = ACTIONS(13066),
    [sym__ellipsis_operator] = ACTIONS(13066),
    [sym__plus_operator] = ACTIONS(13066),
    [sym__times_operator] = ACTIONS(13066),
    [sym__rational_operator] = ACTIONS(13066),
    [sym__bitshift_operator] = ACTIONS(13066),
    [sym__power_operator] = ACTIONS(13066),
    [sym__tilde_operator] = ACTIONS(13066),
    [sym__type_order_operator] = ACTIONS(13066),
    [sym__unary_operator] = ACTIONS(13066),
    [sym__unary_plus_operator] = ACTIONS(13066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13068),
    [sym__command_start] = ACTIONS(13068),
  },
  [8285] = {
    [sym__word_identifier] = ACTIONS(13326),
    [anon_sym_EQ] = ACTIONS(13326),
    [anon_sym_COMMA] = ACTIONS(13326),
    [anon_sym_COLON] = ACTIONS(13326),
    [anon_sym_begin] = ACTIONS(13326),
    [anon_sym_module] = ACTIONS(13326),
    [anon_sym_baremodule] = ACTIONS(13326),
    [anon_sym_abstract] = ACTIONS(13326),
    [anon_sym_primitive] = ACTIONS(13326),
    [anon_sym_mutable] = ACTIONS(13326),
    [anon_sym_struct] = ACTIONS(13326),
    [anon_sym_function] = ACTIONS(13326),
    [anon_sym_macro] = ACTIONS(13326),
    [anon_sym_where] = ACTIONS(13326),
    [anon_sym_quote] = ACTIONS(13326),
    [anon_sym_let] = ACTIONS(13326),
    [anon_sym_if] = ACTIONS(13326),
    [anon_sym_try] = ACTIONS(13326),
    [anon_sym_catch] = ACTIONS(13326),
    [anon_sym_finally] = ACTIONS(13326),
    [anon_sym_for] = ACTIONS(13326),
    [anon_sym_while] = ACTIONS(13326),
    [sym_break_statement] = ACTIONS(13326),
    [sym_continue_statement] = ACTIONS(13326),
    [anon_sym_return] = ACTIONS(13326),
    [anon_sym_const] = ACTIONS(13326),
    [anon_sym_global] = ACTIONS(13326),
    [anon_sym_local] = ACTIONS(13326),
    [anon_sym_LPAREN] = ACTIONS(13326),
    [anon_sym_COLON2] = ACTIONS(13326),
    [anon_sym_export] = ACTIONS(13326),
    [anon_sym_import] = ACTIONS(13326),
    [anon_sym_using] = ACTIONS(13326),
    [anon_sym_LBRACK] = ACTIONS(13326),
    [anon_sym_LF] = ACTIONS(13328),
    [anon_sym_in] = ACTIONS(13326),
    [anon_sym_LBRACE] = ACTIONS(13326),
    [anon_sym_DOLLAR] = ACTIONS(13326),
    [anon_sym_COLON_COLON] = ACTIONS(13326),
    [anon_sym_isa] = ACTIONS(13326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13326),
    [anon_sym_QMARK] = ACTIONS(13326),
    [anon_sym_AT] = ACTIONS(13326),
    [anon_sym_true] = ACTIONS(13326),
    [anon_sym_false] = ACTIONS(13326),
    [aux_sym_integer_literal_token1] = ACTIONS(13326),
    [aux_sym_integer_literal_token2] = ACTIONS(13326),
    [aux_sym_integer_literal_token3] = ACTIONS(13326),
    [aux_sym_integer_literal_token4] = ACTIONS(13326),
    [aux_sym_float_literal_token1] = ACTIONS(13326),
    [aux_sym_float_literal_token3] = ACTIONS(13326),
    [aux_sym_float_literal_token4] = ACTIONS(13326),
    [sym_character_literal] = ACTIONS(13326),
    [sym__pair_operator] = ACTIONS(13326),
    [sym__arrow_operator] = ACTIONS(13326),
    [sym__lazy_or_operator] = ACTIONS(13326),
    [sym__lazy_and_operator] = ACTIONS(13326),
    [sym__comparison_operator] = ACTIONS(13326),
    [sym__pipe_right_operator] = ACTIONS(13326),
    [sym__pipe_left_operator] = ACTIONS(13326),
    [sym__ellipsis_operator] = ACTIONS(13326),
    [sym__plus_operator] = ACTIONS(13326),
    [sym__times_operator] = ACTIONS(13326),
    [sym__rational_operator] = ACTIONS(13326),
    [sym__bitshift_operator] = ACTIONS(13326),
    [sym__power_operator] = ACTIONS(13326),
    [sym__tilde_operator] = ACTIONS(13326),
    [sym__type_order_operator] = ACTIONS(13326),
    [sym__unary_operator] = ACTIONS(13326),
    [sym__unary_plus_operator] = ACTIONS(13326),
    [aux_sym__terminator_token1] = ACTIONS(13326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13328),
    [sym__command_start] = ACTIONS(13328),
  },
  [8286] = {
    [aux_sym_open_tuple_repeat1] = STATE(7998),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_catch] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8287] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_catch] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8288] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_catch] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8289] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(12462),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_catch] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8290] = {
    [aux_sym_open_tuple_repeat1] = STATE(7998),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_catch] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8291] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_catch] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8292] = {
    [aux_sym_export_statement_repeat1] = STATE(8292),
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(14598),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_RPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_SEMI] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [8293] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_as] = ACTIONS(13886),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_RPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_SEMI] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8294] = {
    [aux_sym__import_list_repeat1] = STATE(8294),
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(14601),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_RPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_SEMI] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8295] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12462),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_catch] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8296] = {
    [aux_sym_open_tuple_repeat1] = STATE(7998),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_catch] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8297] = {
    [sym__word_identifier] = ACTIONS(13566),
    [anon_sym_EQ] = ACTIONS(13566),
    [anon_sym_COMMA] = ACTIONS(13568),
    [anon_sym_COLON] = ACTIONS(13566),
    [anon_sym_begin] = ACTIONS(13566),
    [anon_sym_module] = ACTIONS(13566),
    [anon_sym_baremodule] = ACTIONS(13566),
    [anon_sym_abstract] = ACTIONS(13566),
    [anon_sym_primitive] = ACTIONS(13566),
    [anon_sym_mutable] = ACTIONS(13566),
    [anon_sym_struct] = ACTIONS(13566),
    [anon_sym_function] = ACTIONS(13566),
    [anon_sym_macro] = ACTIONS(13566),
    [anon_sym_where] = ACTIONS(13566),
    [anon_sym_quote] = ACTIONS(13566),
    [anon_sym_let] = ACTIONS(13566),
    [anon_sym_if] = ACTIONS(13566),
    [anon_sym_try] = ACTIONS(13566),
    [anon_sym_for] = ACTIONS(13566),
    [anon_sym_while] = ACTIONS(13566),
    [sym_break_statement] = ACTIONS(13566),
    [sym_continue_statement] = ACTIONS(13566),
    [anon_sym_return] = ACTIONS(13566),
    [anon_sym_const] = ACTIONS(13566),
    [anon_sym_global] = ACTIONS(13566),
    [anon_sym_local] = ACTIONS(13566),
    [anon_sym_LPAREN] = ACTIONS(13568),
    [anon_sym_RPAREN] = ACTIONS(13568),
    [anon_sym_COLON2] = ACTIONS(13566),
    [anon_sym_export] = ACTIONS(13566),
    [anon_sym_import] = ACTIONS(13566),
    [anon_sym_using] = ACTIONS(13566),
    [anon_sym_LBRACK] = ACTIONS(13568),
    [anon_sym_RBRACK] = ACTIONS(13568),
    [anon_sym_in] = ACTIONS(13566),
    [anon_sym_SEMI] = ACTIONS(13568),
    [anon_sym_LBRACE] = ACTIONS(13568),
    [anon_sym_RBRACE] = ACTIONS(13568),
    [anon_sym_DOLLAR] = ACTIONS(13568),
    [anon_sym_COLON_COLON] = ACTIONS(13568),
    [anon_sym_isa] = ACTIONS(13566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13568),
    [anon_sym_QMARK] = ACTIONS(13568),
    [anon_sym_AT] = ACTIONS(13568),
    [anon_sym_true] = ACTIONS(13566),
    [anon_sym_false] = ACTIONS(13566),
    [aux_sym_integer_literal_token1] = ACTIONS(13568),
    [aux_sym_integer_literal_token2] = ACTIONS(13568),
    [aux_sym_integer_literal_token3] = ACTIONS(13566),
    [aux_sym_integer_literal_token4] = ACTIONS(13566),
    [aux_sym_float_literal_token1] = ACTIONS(13568),
    [aux_sym_float_literal_token3] = ACTIONS(13568),
    [aux_sym_float_literal_token4] = ACTIONS(13568),
    [sym_character_literal] = ACTIONS(13568),
    [sym__pair_operator] = ACTIONS(13568),
    [sym__arrow_operator] = ACTIONS(13566),
    [sym__lazy_or_operator] = ACTIONS(13568),
    [sym__lazy_and_operator] = ACTIONS(13568),
    [sym__comparison_operator] = ACTIONS(13566),
    [sym__pipe_right_operator] = ACTIONS(13568),
    [sym__pipe_left_operator] = ACTIONS(13568),
    [sym__ellipsis_operator] = ACTIONS(13566),
    [sym__plus_operator] = ACTIONS(13566),
    [sym__times_operator] = ACTIONS(13566),
    [sym__rational_operator] = ACTIONS(13568),
    [sym__bitshift_operator] = ACTIONS(13568),
    [sym__power_operator] = ACTIONS(13568),
    [sym__tilde_operator] = ACTIONS(13568),
    [sym__type_order_operator] = ACTIONS(13568),
    [sym__unary_operator] = ACTIONS(13566),
    [sym__unary_plus_operator] = ACTIONS(13566),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13568),
    [sym__command_start] = ACTIONS(13568),
  },
  [8298] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [8299] = {
    [aux_sym_open_tuple_repeat1] = STATE(8371),
    [sym__word_identifier] = ACTIONS(13150),
    [anon_sym_EQ] = ACTIONS(13150),
    [anon_sym_COMMA] = ACTIONS(14604),
    [anon_sym_COLON] = ACTIONS(13150),
    [anon_sym_begin] = ACTIONS(13150),
    [anon_sym_module] = ACTIONS(13150),
    [anon_sym_baremodule] = ACTIONS(13150),
    [anon_sym_end] = ACTIONS(13150),
    [anon_sym_abstract] = ACTIONS(13150),
    [anon_sym_primitive] = ACTIONS(13150),
    [anon_sym_mutable] = ACTIONS(13150),
    [anon_sym_struct] = ACTIONS(13150),
    [anon_sym_function] = ACTIONS(13150),
    [anon_sym_macro] = ACTIONS(13150),
    [anon_sym_where] = ACTIONS(13150),
    [anon_sym_quote] = ACTIONS(13150),
    [anon_sym_let] = ACTIONS(13150),
    [anon_sym_if] = ACTIONS(13150),
    [anon_sym_try] = ACTIONS(13150),
    [anon_sym_for] = ACTIONS(13150),
    [anon_sym_while] = ACTIONS(13150),
    [sym_break_statement] = ACTIONS(13150),
    [sym_continue_statement] = ACTIONS(13150),
    [anon_sym_return] = ACTIONS(13150),
    [anon_sym_const] = ACTIONS(13150),
    [anon_sym_global] = ACTIONS(13150),
    [anon_sym_local] = ACTIONS(13150),
    [anon_sym_LPAREN] = ACTIONS(13150),
    [anon_sym_COLON2] = ACTIONS(13150),
    [anon_sym_export] = ACTIONS(13150),
    [anon_sym_import] = ACTIONS(13150),
    [anon_sym_using] = ACTIONS(13150),
    [anon_sym_LBRACK] = ACTIONS(13150),
    [anon_sym_LF] = ACTIONS(13148),
    [anon_sym_in] = ACTIONS(13150),
    [anon_sym_LBRACE] = ACTIONS(13150),
    [anon_sym_DOLLAR] = ACTIONS(13150),
    [anon_sym_COLON_COLON] = ACTIONS(13150),
    [anon_sym_isa] = ACTIONS(13150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13150),
    [anon_sym_QMARK] = ACTIONS(13150),
    [anon_sym_AT] = ACTIONS(13150),
    [anon_sym_true] = ACTIONS(13150),
    [anon_sym_false] = ACTIONS(13150),
    [aux_sym_integer_literal_token1] = ACTIONS(13150),
    [aux_sym_integer_literal_token2] = ACTIONS(13150),
    [aux_sym_integer_literal_token3] = ACTIONS(13150),
    [aux_sym_integer_literal_token4] = ACTIONS(13150),
    [aux_sym_float_literal_token1] = ACTIONS(13150),
    [aux_sym_float_literal_token3] = ACTIONS(13150),
    [aux_sym_float_literal_token4] = ACTIONS(13150),
    [sym_character_literal] = ACTIONS(13150),
    [sym__pair_operator] = ACTIONS(13150),
    [sym__arrow_operator] = ACTIONS(13150),
    [sym__lazy_or_operator] = ACTIONS(13150),
    [sym__lazy_and_operator] = ACTIONS(13150),
    [sym__comparison_operator] = ACTIONS(13150),
    [sym__pipe_right_operator] = ACTIONS(13150),
    [sym__pipe_left_operator] = ACTIONS(13150),
    [sym__ellipsis_operator] = ACTIONS(13150),
    [sym__plus_operator] = ACTIONS(13150),
    [sym__times_operator] = ACTIONS(13150),
    [sym__rational_operator] = ACTIONS(13150),
    [sym__bitshift_operator] = ACTIONS(13150),
    [sym__power_operator] = ACTIONS(13150),
    [sym__tilde_operator] = ACTIONS(13150),
    [sym__type_order_operator] = ACTIONS(13150),
    [sym__unary_operator] = ACTIONS(13150),
    [sym__unary_plus_operator] = ACTIONS(13150),
    [aux_sym__terminator_token1] = ACTIONS(13150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13148),
    [sym__command_start] = ACTIONS(13148),
  },
  [8300] = {
    [sym__primary_expression] = STATE(11513),
    [sym__array] = STATE(11513),
    [sym_comprehension_expression] = STATE(11513),
    [sym_matrix_expression] = STATE(11513),
    [sym_vector_expression] = STATE(11513),
    [sym_parenthesized_expression] = STATE(11513),
    [sym_tuple_expression] = STATE(11513),
    [sym_curly_expression] = STATE(11513),
    [sym_adjoint_expression] = STATE(11513),
    [sym_field_expression] = STATE(11513),
    [sym_index_expression] = STATE(11513),
    [sym_parametrized_type_expression] = STATE(11513),
    [sym_call_expression] = STATE(11513),
    [sym_broadcast_call_expression] = STATE(11513),
    [sym__closed_macrocall_expression] = STATE(11513),
    [sym_interpolation_expression] = STATE(11513),
    [sym_quote_expression] = STATE(11513),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(11201),
    [sym_boolean_literal] = STATE(11513),
    [sym__string] = STATE(11513),
    [sym_string_literal] = STATE(11513),
    [sym_command_literal] = STATE(11513),
    [sym_prefixed_string_literal] = STATE(11513),
    [sym_prefixed_command_literal] = STATE(11513),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(14606),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(14608),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(14610),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [8301] = {
    [sym__word_identifier] = ACTIONS(13522),
    [anon_sym_EQ] = ACTIONS(13522),
    [anon_sym_COMMA] = ACTIONS(13524),
    [anon_sym_COLON] = ACTIONS(13522),
    [anon_sym_begin] = ACTIONS(13522),
    [anon_sym_module] = ACTIONS(13522),
    [anon_sym_baremodule] = ACTIONS(13522),
    [anon_sym_abstract] = ACTIONS(13522),
    [anon_sym_primitive] = ACTIONS(13522),
    [anon_sym_mutable] = ACTIONS(13522),
    [anon_sym_struct] = ACTIONS(13522),
    [anon_sym_function] = ACTIONS(13522),
    [anon_sym_macro] = ACTIONS(13522),
    [anon_sym_where] = ACTIONS(13522),
    [anon_sym_quote] = ACTIONS(13522),
    [anon_sym_let] = ACTIONS(13522),
    [anon_sym_if] = ACTIONS(13522),
    [anon_sym_try] = ACTIONS(13522),
    [anon_sym_for] = ACTIONS(13522),
    [anon_sym_while] = ACTIONS(13522),
    [sym_break_statement] = ACTIONS(13522),
    [sym_continue_statement] = ACTIONS(13522),
    [anon_sym_return] = ACTIONS(13522),
    [anon_sym_const] = ACTIONS(13522),
    [anon_sym_global] = ACTIONS(13522),
    [anon_sym_local] = ACTIONS(13522),
    [anon_sym_LPAREN] = ACTIONS(13524),
    [anon_sym_RPAREN] = ACTIONS(13524),
    [anon_sym_COLON2] = ACTIONS(13522),
    [anon_sym_export] = ACTIONS(13522),
    [anon_sym_import] = ACTIONS(13522),
    [anon_sym_using] = ACTIONS(13522),
    [anon_sym_LBRACK] = ACTIONS(13524),
    [anon_sym_RBRACK] = ACTIONS(13524),
    [anon_sym_in] = ACTIONS(13522),
    [anon_sym_SEMI] = ACTIONS(13524),
    [anon_sym_LBRACE] = ACTIONS(13524),
    [anon_sym_RBRACE] = ACTIONS(13524),
    [anon_sym_DOLLAR] = ACTIONS(13524),
    [anon_sym_COLON_COLON] = ACTIONS(13524),
    [anon_sym_isa] = ACTIONS(13522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13524),
    [anon_sym_QMARK] = ACTIONS(13524),
    [anon_sym_AT] = ACTIONS(13524),
    [anon_sym_true] = ACTIONS(13522),
    [anon_sym_false] = ACTIONS(13522),
    [aux_sym_integer_literal_token1] = ACTIONS(13524),
    [aux_sym_integer_literal_token2] = ACTIONS(13524),
    [aux_sym_integer_literal_token3] = ACTIONS(13522),
    [aux_sym_integer_literal_token4] = ACTIONS(13522),
    [aux_sym_float_literal_token1] = ACTIONS(13524),
    [aux_sym_float_literal_token3] = ACTIONS(13524),
    [aux_sym_float_literal_token4] = ACTIONS(13524),
    [sym_character_literal] = ACTIONS(13524),
    [sym__pair_operator] = ACTIONS(13524),
    [sym__arrow_operator] = ACTIONS(13522),
    [sym__lazy_or_operator] = ACTIONS(13524),
    [sym__lazy_and_operator] = ACTIONS(13524),
    [sym__comparison_operator] = ACTIONS(13522),
    [sym__pipe_right_operator] = ACTIONS(13524),
    [sym__pipe_left_operator] = ACTIONS(13524),
    [sym__ellipsis_operator] = ACTIONS(13522),
    [sym__plus_operator] = ACTIONS(13522),
    [sym__times_operator] = ACTIONS(13522),
    [sym__rational_operator] = ACTIONS(13524),
    [sym__bitshift_operator] = ACTIONS(13524),
    [sym__power_operator] = ACTIONS(13524),
    [sym__tilde_operator] = ACTIONS(13524),
    [sym__type_order_operator] = ACTIONS(13524),
    [sym__unary_operator] = ACTIONS(13522),
    [sym__unary_plus_operator] = ACTIONS(13522),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13524),
    [sym__command_start] = ACTIONS(13524),
  },
  [8302] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12724),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12120),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8303] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12724),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12694),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8304] = {
    [sym__word_identifier] = ACTIONS(13330),
    [anon_sym_EQ] = ACTIONS(13330),
    [anon_sym_COMMA] = ACTIONS(13330),
    [anon_sym_COLON] = ACTIONS(13330),
    [anon_sym_begin] = ACTIONS(13330),
    [anon_sym_module] = ACTIONS(13330),
    [anon_sym_baremodule] = ACTIONS(13330),
    [anon_sym_abstract] = ACTIONS(13330),
    [anon_sym_primitive] = ACTIONS(13330),
    [anon_sym_mutable] = ACTIONS(13330),
    [anon_sym_struct] = ACTIONS(13330),
    [anon_sym_function] = ACTIONS(13330),
    [anon_sym_macro] = ACTIONS(13330),
    [anon_sym_where] = ACTIONS(13330),
    [anon_sym_quote] = ACTIONS(13330),
    [anon_sym_let] = ACTIONS(13330),
    [anon_sym_if] = ACTIONS(13330),
    [anon_sym_try] = ACTIONS(13330),
    [anon_sym_catch] = ACTIONS(13330),
    [anon_sym_finally] = ACTIONS(13330),
    [anon_sym_for] = ACTIONS(13330),
    [anon_sym_while] = ACTIONS(13330),
    [sym_break_statement] = ACTIONS(13330),
    [sym_continue_statement] = ACTIONS(13330),
    [anon_sym_return] = ACTIONS(13330),
    [anon_sym_const] = ACTIONS(13330),
    [anon_sym_global] = ACTIONS(13330),
    [anon_sym_local] = ACTIONS(13330),
    [anon_sym_LPAREN] = ACTIONS(13330),
    [anon_sym_COLON2] = ACTIONS(13330),
    [anon_sym_export] = ACTIONS(13330),
    [anon_sym_import] = ACTIONS(13330),
    [anon_sym_using] = ACTIONS(13330),
    [anon_sym_LBRACK] = ACTIONS(13330),
    [anon_sym_LF] = ACTIONS(13332),
    [anon_sym_in] = ACTIONS(13330),
    [anon_sym_LBRACE] = ACTIONS(13330),
    [anon_sym_DOLLAR] = ACTIONS(13330),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_isa] = ACTIONS(13330),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13330),
    [anon_sym_QMARK] = ACTIONS(13330),
    [anon_sym_AT] = ACTIONS(13330),
    [anon_sym_true] = ACTIONS(13330),
    [anon_sym_false] = ACTIONS(13330),
    [aux_sym_integer_literal_token1] = ACTIONS(13330),
    [aux_sym_integer_literal_token2] = ACTIONS(13330),
    [aux_sym_integer_literal_token3] = ACTIONS(13330),
    [aux_sym_integer_literal_token4] = ACTIONS(13330),
    [aux_sym_float_literal_token1] = ACTIONS(13330),
    [aux_sym_float_literal_token3] = ACTIONS(13330),
    [aux_sym_float_literal_token4] = ACTIONS(13330),
    [sym_character_literal] = ACTIONS(13330),
    [sym__pair_operator] = ACTIONS(13330),
    [sym__arrow_operator] = ACTIONS(13330),
    [sym__lazy_or_operator] = ACTIONS(13330),
    [sym__lazy_and_operator] = ACTIONS(13330),
    [sym__comparison_operator] = ACTIONS(13330),
    [sym__pipe_right_operator] = ACTIONS(13330),
    [sym__pipe_left_operator] = ACTIONS(13330),
    [sym__ellipsis_operator] = ACTIONS(13330),
    [sym__plus_operator] = ACTIONS(13330),
    [sym__times_operator] = ACTIONS(13330),
    [sym__rational_operator] = ACTIONS(13330),
    [sym__bitshift_operator] = ACTIONS(13330),
    [sym__power_operator] = ACTIONS(13330),
    [sym__tilde_operator] = ACTIONS(13330),
    [sym__type_order_operator] = ACTIONS(13330),
    [sym__unary_operator] = ACTIONS(13330),
    [sym__unary_plus_operator] = ACTIONS(13330),
    [aux_sym__terminator_token1] = ACTIONS(13330),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13332),
    [sym__command_start] = ACTIONS(13332),
  },
  [8305] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [8306] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(12610),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8307] = {
    [aux_sym_open_tuple_repeat1] = STATE(7471),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(13497),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8308] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_catch] = ACTIONS(13308),
    [anon_sym_finally] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [8309] = {
    [sym__word_identifier] = ACTIONS(13526),
    [anon_sym_EQ] = ACTIONS(13526),
    [anon_sym_COMMA] = ACTIONS(13528),
    [anon_sym_COLON] = ACTIONS(13526),
    [anon_sym_begin] = ACTIONS(13526),
    [anon_sym_module] = ACTIONS(13526),
    [anon_sym_baremodule] = ACTIONS(13526),
    [anon_sym_abstract] = ACTIONS(13526),
    [anon_sym_primitive] = ACTIONS(13526),
    [anon_sym_mutable] = ACTIONS(13526),
    [anon_sym_struct] = ACTIONS(13526),
    [anon_sym_function] = ACTIONS(13526),
    [anon_sym_macro] = ACTIONS(13526),
    [anon_sym_where] = ACTIONS(13526),
    [anon_sym_quote] = ACTIONS(13526),
    [anon_sym_let] = ACTIONS(13526),
    [anon_sym_if] = ACTIONS(13526),
    [anon_sym_try] = ACTIONS(13526),
    [anon_sym_for] = ACTIONS(13526),
    [anon_sym_while] = ACTIONS(13526),
    [sym_break_statement] = ACTIONS(13526),
    [sym_continue_statement] = ACTIONS(13526),
    [anon_sym_return] = ACTIONS(13526),
    [anon_sym_const] = ACTIONS(13526),
    [anon_sym_global] = ACTIONS(13526),
    [anon_sym_local] = ACTIONS(13526),
    [anon_sym_LPAREN] = ACTIONS(13528),
    [anon_sym_RPAREN] = ACTIONS(13528),
    [anon_sym_COLON2] = ACTIONS(13526),
    [anon_sym_export] = ACTIONS(13526),
    [anon_sym_import] = ACTIONS(13526),
    [anon_sym_using] = ACTIONS(13526),
    [anon_sym_LBRACK] = ACTIONS(13528),
    [anon_sym_RBRACK] = ACTIONS(13528),
    [anon_sym_in] = ACTIONS(13526),
    [anon_sym_SEMI] = ACTIONS(13528),
    [anon_sym_LBRACE] = ACTIONS(13528),
    [anon_sym_RBRACE] = ACTIONS(13528),
    [anon_sym_DOLLAR] = ACTIONS(13528),
    [anon_sym_COLON_COLON] = ACTIONS(13528),
    [anon_sym_isa] = ACTIONS(13526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13528),
    [anon_sym_QMARK] = ACTIONS(13528),
    [anon_sym_AT] = ACTIONS(13528),
    [anon_sym_true] = ACTIONS(13526),
    [anon_sym_false] = ACTIONS(13526),
    [aux_sym_integer_literal_token1] = ACTIONS(13528),
    [aux_sym_integer_literal_token2] = ACTIONS(13528),
    [aux_sym_integer_literal_token3] = ACTIONS(13526),
    [aux_sym_integer_literal_token4] = ACTIONS(13526),
    [aux_sym_float_literal_token1] = ACTIONS(13528),
    [aux_sym_float_literal_token3] = ACTIONS(13528),
    [aux_sym_float_literal_token4] = ACTIONS(13528),
    [sym_character_literal] = ACTIONS(13528),
    [sym__pair_operator] = ACTIONS(13528),
    [sym__arrow_operator] = ACTIONS(13526),
    [sym__lazy_or_operator] = ACTIONS(13528),
    [sym__lazy_and_operator] = ACTIONS(13528),
    [sym__comparison_operator] = ACTIONS(13526),
    [sym__pipe_right_operator] = ACTIONS(13528),
    [sym__pipe_left_operator] = ACTIONS(13528),
    [sym__ellipsis_operator] = ACTIONS(13526),
    [sym__plus_operator] = ACTIONS(13526),
    [sym__times_operator] = ACTIONS(13526),
    [sym__rational_operator] = ACTIONS(13528),
    [sym__bitshift_operator] = ACTIONS(13528),
    [sym__power_operator] = ACTIONS(13528),
    [sym__tilde_operator] = ACTIONS(13528),
    [sym__type_order_operator] = ACTIONS(13528),
    [sym__unary_operator] = ACTIONS(13526),
    [sym__unary_plus_operator] = ACTIONS(13526),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13528),
    [sym__command_start] = ACTIONS(13528),
  },
  [8310] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12694),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8311] = {
    [sym__word_identifier] = ACTIONS(13346),
    [anon_sym_EQ] = ACTIONS(13346),
    [anon_sym_COMMA] = ACTIONS(13346),
    [anon_sym_COLON] = ACTIONS(13346),
    [anon_sym_begin] = ACTIONS(13346),
    [anon_sym_module] = ACTIONS(13346),
    [anon_sym_baremodule] = ACTIONS(13346),
    [anon_sym_abstract] = ACTIONS(13346),
    [anon_sym_primitive] = ACTIONS(13346),
    [anon_sym_mutable] = ACTIONS(13346),
    [anon_sym_struct] = ACTIONS(13346),
    [anon_sym_function] = ACTIONS(13346),
    [anon_sym_macro] = ACTIONS(13346),
    [anon_sym_where] = ACTIONS(13346),
    [anon_sym_quote] = ACTIONS(13346),
    [anon_sym_let] = ACTIONS(13346),
    [anon_sym_if] = ACTIONS(13346),
    [anon_sym_try] = ACTIONS(13346),
    [anon_sym_catch] = ACTIONS(13346),
    [anon_sym_finally] = ACTIONS(13346),
    [anon_sym_for] = ACTIONS(13346),
    [anon_sym_while] = ACTIONS(13346),
    [sym_break_statement] = ACTIONS(13346),
    [sym_continue_statement] = ACTIONS(13346),
    [anon_sym_return] = ACTIONS(13346),
    [anon_sym_const] = ACTIONS(13346),
    [anon_sym_global] = ACTIONS(13346),
    [anon_sym_local] = ACTIONS(13346),
    [anon_sym_LPAREN] = ACTIONS(13346),
    [anon_sym_COLON2] = ACTIONS(13346),
    [anon_sym_export] = ACTIONS(13346),
    [anon_sym_import] = ACTIONS(13346),
    [anon_sym_using] = ACTIONS(13346),
    [anon_sym_LBRACK] = ACTIONS(13346),
    [anon_sym_LF] = ACTIONS(13348),
    [anon_sym_in] = ACTIONS(13346),
    [anon_sym_LBRACE] = ACTIONS(13346),
    [anon_sym_DOLLAR] = ACTIONS(13346),
    [anon_sym_COLON_COLON] = ACTIONS(13346),
    [anon_sym_isa] = ACTIONS(13346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13346),
    [anon_sym_QMARK] = ACTIONS(13346),
    [anon_sym_AT] = ACTIONS(13346),
    [anon_sym_true] = ACTIONS(13346),
    [anon_sym_false] = ACTIONS(13346),
    [aux_sym_integer_literal_token1] = ACTIONS(13346),
    [aux_sym_integer_literal_token2] = ACTIONS(13346),
    [aux_sym_integer_literal_token3] = ACTIONS(13346),
    [aux_sym_integer_literal_token4] = ACTIONS(13346),
    [aux_sym_float_literal_token1] = ACTIONS(13346),
    [aux_sym_float_literal_token3] = ACTIONS(13346),
    [aux_sym_float_literal_token4] = ACTIONS(13346),
    [sym_character_literal] = ACTIONS(13346),
    [sym__pair_operator] = ACTIONS(13346),
    [sym__arrow_operator] = ACTIONS(13346),
    [sym__lazy_or_operator] = ACTIONS(13346),
    [sym__lazy_and_operator] = ACTIONS(13346),
    [sym__comparison_operator] = ACTIONS(13346),
    [sym__pipe_right_operator] = ACTIONS(13346),
    [sym__pipe_left_operator] = ACTIONS(13346),
    [sym__ellipsis_operator] = ACTIONS(13346),
    [sym__plus_operator] = ACTIONS(13346),
    [sym__times_operator] = ACTIONS(13346),
    [sym__rational_operator] = ACTIONS(13346),
    [sym__bitshift_operator] = ACTIONS(13346),
    [sym__power_operator] = ACTIONS(13346),
    [sym__tilde_operator] = ACTIONS(13346),
    [sym__type_order_operator] = ACTIONS(13346),
    [sym__unary_operator] = ACTIONS(13346),
    [sym__unary_plus_operator] = ACTIONS(13346),
    [aux_sym__terminator_token1] = ACTIONS(13346),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13348),
    [sym__command_start] = ACTIONS(13348),
  },
  [8312] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_catch] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14612),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8313] = {
    [sym__word_identifier] = ACTIONS(13570),
    [anon_sym_EQ] = ACTIONS(13570),
    [anon_sym_COMMA] = ACTIONS(13572),
    [anon_sym_COLON] = ACTIONS(13570),
    [anon_sym_begin] = ACTIONS(13570),
    [anon_sym_module] = ACTIONS(13570),
    [anon_sym_baremodule] = ACTIONS(13570),
    [anon_sym_abstract] = ACTIONS(13570),
    [anon_sym_primitive] = ACTIONS(13570),
    [anon_sym_mutable] = ACTIONS(13570),
    [anon_sym_struct] = ACTIONS(13570),
    [anon_sym_function] = ACTIONS(13570),
    [anon_sym_macro] = ACTIONS(13570),
    [anon_sym_where] = ACTIONS(13570),
    [anon_sym_quote] = ACTIONS(13570),
    [anon_sym_let] = ACTIONS(13570),
    [anon_sym_if] = ACTIONS(13570),
    [anon_sym_try] = ACTIONS(13570),
    [anon_sym_for] = ACTIONS(13570),
    [anon_sym_while] = ACTIONS(13570),
    [sym_break_statement] = ACTIONS(13570),
    [sym_continue_statement] = ACTIONS(13570),
    [anon_sym_return] = ACTIONS(13570),
    [anon_sym_const] = ACTIONS(13570),
    [anon_sym_global] = ACTIONS(13570),
    [anon_sym_local] = ACTIONS(13570),
    [anon_sym_LPAREN] = ACTIONS(13572),
    [anon_sym_RPAREN] = ACTIONS(13572),
    [anon_sym_COLON2] = ACTIONS(13570),
    [anon_sym_export] = ACTIONS(13570),
    [anon_sym_import] = ACTIONS(13570),
    [anon_sym_using] = ACTIONS(13570),
    [anon_sym_LBRACK] = ACTIONS(13572),
    [anon_sym_RBRACK] = ACTIONS(13572),
    [anon_sym_in] = ACTIONS(13570),
    [anon_sym_SEMI] = ACTIONS(13572),
    [anon_sym_LBRACE] = ACTIONS(13572),
    [anon_sym_RBRACE] = ACTIONS(13572),
    [anon_sym_DOLLAR] = ACTIONS(13572),
    [anon_sym_COLON_COLON] = ACTIONS(13572),
    [anon_sym_isa] = ACTIONS(13570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13572),
    [anon_sym_QMARK] = ACTIONS(13572),
    [anon_sym_AT] = ACTIONS(13572),
    [anon_sym_true] = ACTIONS(13570),
    [anon_sym_false] = ACTIONS(13570),
    [aux_sym_integer_literal_token1] = ACTIONS(13572),
    [aux_sym_integer_literal_token2] = ACTIONS(13572),
    [aux_sym_integer_literal_token3] = ACTIONS(13570),
    [aux_sym_integer_literal_token4] = ACTIONS(13570),
    [aux_sym_float_literal_token1] = ACTIONS(13572),
    [aux_sym_float_literal_token3] = ACTIONS(13572),
    [aux_sym_float_literal_token4] = ACTIONS(13572),
    [sym_character_literal] = ACTIONS(13572),
    [sym__pair_operator] = ACTIONS(13572),
    [sym__arrow_operator] = ACTIONS(13570),
    [sym__lazy_or_operator] = ACTIONS(13572),
    [sym__lazy_and_operator] = ACTIONS(13572),
    [sym__comparison_operator] = ACTIONS(13570),
    [sym__pipe_right_operator] = ACTIONS(13572),
    [sym__pipe_left_operator] = ACTIONS(13572),
    [sym__ellipsis_operator] = ACTIONS(13570),
    [sym__plus_operator] = ACTIONS(13570),
    [sym__times_operator] = ACTIONS(13570),
    [sym__rational_operator] = ACTIONS(13572),
    [sym__bitshift_operator] = ACTIONS(13572),
    [sym__power_operator] = ACTIONS(13572),
    [sym__tilde_operator] = ACTIONS(13572),
    [sym__type_order_operator] = ACTIONS(13572),
    [sym__unary_operator] = ACTIONS(13570),
    [sym__unary_plus_operator] = ACTIONS(13570),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13572),
    [sym__command_start] = ACTIONS(13572),
  },
  [8314] = {
    [sym__word_identifier] = ACTIONS(13574),
    [anon_sym_EQ] = ACTIONS(13574),
    [anon_sym_COMMA] = ACTIONS(13576),
    [anon_sym_COLON] = ACTIONS(13574),
    [anon_sym_begin] = ACTIONS(13574),
    [anon_sym_module] = ACTIONS(13574),
    [anon_sym_baremodule] = ACTIONS(13574),
    [anon_sym_abstract] = ACTIONS(13574),
    [anon_sym_primitive] = ACTIONS(13574),
    [anon_sym_mutable] = ACTIONS(13574),
    [anon_sym_struct] = ACTIONS(13574),
    [anon_sym_function] = ACTIONS(13574),
    [anon_sym_macro] = ACTIONS(13574),
    [anon_sym_where] = ACTIONS(13574),
    [anon_sym_quote] = ACTIONS(13574),
    [anon_sym_let] = ACTIONS(13574),
    [anon_sym_if] = ACTIONS(13574),
    [anon_sym_try] = ACTIONS(13574),
    [anon_sym_for] = ACTIONS(13574),
    [anon_sym_while] = ACTIONS(13574),
    [sym_break_statement] = ACTIONS(13574),
    [sym_continue_statement] = ACTIONS(13574),
    [anon_sym_return] = ACTIONS(13574),
    [anon_sym_const] = ACTIONS(13574),
    [anon_sym_global] = ACTIONS(13574),
    [anon_sym_local] = ACTIONS(13574),
    [anon_sym_LPAREN] = ACTIONS(13576),
    [anon_sym_RPAREN] = ACTIONS(13576),
    [anon_sym_COLON2] = ACTIONS(13574),
    [anon_sym_export] = ACTIONS(13574),
    [anon_sym_import] = ACTIONS(13574),
    [anon_sym_using] = ACTIONS(13574),
    [anon_sym_LBRACK] = ACTIONS(13576),
    [anon_sym_RBRACK] = ACTIONS(13576),
    [anon_sym_in] = ACTIONS(13574),
    [anon_sym_SEMI] = ACTIONS(13576),
    [anon_sym_LBRACE] = ACTIONS(13576),
    [anon_sym_RBRACE] = ACTIONS(13576),
    [anon_sym_DOLLAR] = ACTIONS(13576),
    [anon_sym_COLON_COLON] = ACTIONS(13576),
    [anon_sym_isa] = ACTIONS(13574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13576),
    [anon_sym_QMARK] = ACTIONS(13576),
    [anon_sym_AT] = ACTIONS(13576),
    [anon_sym_true] = ACTIONS(13574),
    [anon_sym_false] = ACTIONS(13574),
    [aux_sym_integer_literal_token1] = ACTIONS(13576),
    [aux_sym_integer_literal_token2] = ACTIONS(13576),
    [aux_sym_integer_literal_token3] = ACTIONS(13574),
    [aux_sym_integer_literal_token4] = ACTIONS(13574),
    [aux_sym_float_literal_token1] = ACTIONS(13576),
    [aux_sym_float_literal_token3] = ACTIONS(13576),
    [aux_sym_float_literal_token4] = ACTIONS(13576),
    [sym_character_literal] = ACTIONS(13576),
    [sym__pair_operator] = ACTIONS(13576),
    [sym__arrow_operator] = ACTIONS(13574),
    [sym__lazy_or_operator] = ACTIONS(13576),
    [sym__lazy_and_operator] = ACTIONS(13576),
    [sym__comparison_operator] = ACTIONS(13574),
    [sym__pipe_right_operator] = ACTIONS(13576),
    [sym__pipe_left_operator] = ACTIONS(13576),
    [sym__ellipsis_operator] = ACTIONS(13574),
    [sym__plus_operator] = ACTIONS(13574),
    [sym__times_operator] = ACTIONS(13574),
    [sym__rational_operator] = ACTIONS(13576),
    [sym__bitshift_operator] = ACTIONS(13576),
    [sym__power_operator] = ACTIONS(13576),
    [sym__tilde_operator] = ACTIONS(13576),
    [sym__type_order_operator] = ACTIONS(13576),
    [sym__unary_operator] = ACTIONS(13574),
    [sym__unary_plus_operator] = ACTIONS(13574),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13576),
    [sym__command_start] = ACTIONS(13576),
  },
  [8315] = {
    [sym__word_identifier] = ACTIONS(13578),
    [anon_sym_EQ] = ACTIONS(13578),
    [anon_sym_COMMA] = ACTIONS(13580),
    [anon_sym_COLON] = ACTIONS(13578),
    [anon_sym_begin] = ACTIONS(13578),
    [anon_sym_module] = ACTIONS(13578),
    [anon_sym_baremodule] = ACTIONS(13578),
    [anon_sym_abstract] = ACTIONS(13578),
    [anon_sym_primitive] = ACTIONS(13578),
    [anon_sym_mutable] = ACTIONS(13578),
    [anon_sym_struct] = ACTIONS(13578),
    [anon_sym_function] = ACTIONS(13578),
    [anon_sym_macro] = ACTIONS(13578),
    [anon_sym_where] = ACTIONS(13578),
    [anon_sym_quote] = ACTIONS(13578),
    [anon_sym_let] = ACTIONS(13578),
    [anon_sym_if] = ACTIONS(13578),
    [anon_sym_try] = ACTIONS(13578),
    [anon_sym_for] = ACTIONS(13578),
    [anon_sym_while] = ACTIONS(13578),
    [sym_break_statement] = ACTIONS(13578),
    [sym_continue_statement] = ACTIONS(13578),
    [anon_sym_return] = ACTIONS(13578),
    [anon_sym_const] = ACTIONS(13578),
    [anon_sym_global] = ACTIONS(13578),
    [anon_sym_local] = ACTIONS(13578),
    [anon_sym_LPAREN] = ACTIONS(13580),
    [anon_sym_RPAREN] = ACTIONS(13580),
    [anon_sym_COLON2] = ACTIONS(13578),
    [anon_sym_export] = ACTIONS(13578),
    [anon_sym_import] = ACTIONS(13578),
    [anon_sym_using] = ACTIONS(13578),
    [anon_sym_LBRACK] = ACTIONS(13580),
    [anon_sym_RBRACK] = ACTIONS(13580),
    [anon_sym_in] = ACTIONS(13578),
    [anon_sym_SEMI] = ACTIONS(13580),
    [anon_sym_LBRACE] = ACTIONS(13580),
    [anon_sym_RBRACE] = ACTIONS(13580),
    [anon_sym_DOLLAR] = ACTIONS(13580),
    [anon_sym_COLON_COLON] = ACTIONS(13580),
    [anon_sym_isa] = ACTIONS(13578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13580),
    [anon_sym_QMARK] = ACTIONS(13580),
    [anon_sym_AT] = ACTIONS(13580),
    [anon_sym_true] = ACTIONS(13578),
    [anon_sym_false] = ACTIONS(13578),
    [aux_sym_integer_literal_token1] = ACTIONS(13580),
    [aux_sym_integer_literal_token2] = ACTIONS(13580),
    [aux_sym_integer_literal_token3] = ACTIONS(13578),
    [aux_sym_integer_literal_token4] = ACTIONS(13578),
    [aux_sym_float_literal_token1] = ACTIONS(13580),
    [aux_sym_float_literal_token3] = ACTIONS(13580),
    [aux_sym_float_literal_token4] = ACTIONS(13580),
    [sym_character_literal] = ACTIONS(13580),
    [sym__pair_operator] = ACTIONS(13580),
    [sym__arrow_operator] = ACTIONS(13578),
    [sym__lazy_or_operator] = ACTIONS(13580),
    [sym__lazy_and_operator] = ACTIONS(13580),
    [sym__comparison_operator] = ACTIONS(13578),
    [sym__pipe_right_operator] = ACTIONS(13580),
    [sym__pipe_left_operator] = ACTIONS(13580),
    [sym__ellipsis_operator] = ACTIONS(13578),
    [sym__plus_operator] = ACTIONS(13578),
    [sym__times_operator] = ACTIONS(13578),
    [sym__rational_operator] = ACTIONS(13580),
    [sym__bitshift_operator] = ACTIONS(13580),
    [sym__power_operator] = ACTIONS(13580),
    [sym__tilde_operator] = ACTIONS(13580),
    [sym__type_order_operator] = ACTIONS(13580),
    [sym__unary_operator] = ACTIONS(13578),
    [sym__unary_plus_operator] = ACTIONS(13578),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13580),
    [sym__command_start] = ACTIONS(13580),
  },
  [8316] = {
    [sym__word_identifier] = ACTIONS(13530),
    [anon_sym_EQ] = ACTIONS(13530),
    [anon_sym_COMMA] = ACTIONS(13532),
    [anon_sym_COLON] = ACTIONS(13530),
    [anon_sym_begin] = ACTIONS(13530),
    [anon_sym_module] = ACTIONS(13530),
    [anon_sym_baremodule] = ACTIONS(13530),
    [anon_sym_abstract] = ACTIONS(13530),
    [anon_sym_primitive] = ACTIONS(13530),
    [anon_sym_mutable] = ACTIONS(13530),
    [anon_sym_struct] = ACTIONS(13530),
    [anon_sym_function] = ACTIONS(13530),
    [anon_sym_macro] = ACTIONS(13530),
    [anon_sym_where] = ACTIONS(13530),
    [anon_sym_quote] = ACTIONS(13530),
    [anon_sym_let] = ACTIONS(13530),
    [anon_sym_if] = ACTIONS(13530),
    [anon_sym_try] = ACTIONS(13530),
    [anon_sym_for] = ACTIONS(13530),
    [anon_sym_while] = ACTIONS(13530),
    [sym_break_statement] = ACTIONS(13530),
    [sym_continue_statement] = ACTIONS(13530),
    [anon_sym_return] = ACTIONS(13530),
    [anon_sym_const] = ACTIONS(13530),
    [anon_sym_global] = ACTIONS(13530),
    [anon_sym_local] = ACTIONS(13530),
    [anon_sym_LPAREN] = ACTIONS(13532),
    [anon_sym_RPAREN] = ACTIONS(13532),
    [anon_sym_COLON2] = ACTIONS(13530),
    [anon_sym_export] = ACTIONS(13530),
    [anon_sym_import] = ACTIONS(13530),
    [anon_sym_using] = ACTIONS(13530),
    [anon_sym_LBRACK] = ACTIONS(13532),
    [anon_sym_RBRACK] = ACTIONS(13532),
    [anon_sym_in] = ACTIONS(13530),
    [anon_sym_SEMI] = ACTIONS(13532),
    [anon_sym_LBRACE] = ACTIONS(13532),
    [anon_sym_RBRACE] = ACTIONS(13532),
    [anon_sym_DOLLAR] = ACTIONS(13532),
    [anon_sym_COLON_COLON] = ACTIONS(13532),
    [anon_sym_isa] = ACTIONS(13530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13532),
    [anon_sym_QMARK] = ACTIONS(13532),
    [anon_sym_AT] = ACTIONS(13532),
    [anon_sym_true] = ACTIONS(13530),
    [anon_sym_false] = ACTIONS(13530),
    [aux_sym_integer_literal_token1] = ACTIONS(13532),
    [aux_sym_integer_literal_token2] = ACTIONS(13532),
    [aux_sym_integer_literal_token3] = ACTIONS(13530),
    [aux_sym_integer_literal_token4] = ACTIONS(13530),
    [aux_sym_float_literal_token1] = ACTIONS(13532),
    [aux_sym_float_literal_token3] = ACTIONS(13532),
    [aux_sym_float_literal_token4] = ACTIONS(13532),
    [sym_character_literal] = ACTIONS(13532),
    [sym__pair_operator] = ACTIONS(13532),
    [sym__arrow_operator] = ACTIONS(13530),
    [sym__lazy_or_operator] = ACTIONS(13532),
    [sym__lazy_and_operator] = ACTIONS(13532),
    [sym__comparison_operator] = ACTIONS(13530),
    [sym__pipe_right_operator] = ACTIONS(13532),
    [sym__pipe_left_operator] = ACTIONS(13532),
    [sym__ellipsis_operator] = ACTIONS(13530),
    [sym__plus_operator] = ACTIONS(13530),
    [sym__times_operator] = ACTIONS(13530),
    [sym__rational_operator] = ACTIONS(13532),
    [sym__bitshift_operator] = ACTIONS(13532),
    [sym__power_operator] = ACTIONS(13532),
    [sym__tilde_operator] = ACTIONS(13532),
    [sym__type_order_operator] = ACTIONS(13532),
    [sym__unary_operator] = ACTIONS(13530),
    [sym__unary_plus_operator] = ACTIONS(13530),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13532),
    [sym__command_start] = ACTIONS(13532),
  },
  [8317] = {
    [sym__word_identifier] = ACTIONS(13582),
    [anon_sym_EQ] = ACTIONS(13582),
    [anon_sym_COMMA] = ACTIONS(13584),
    [anon_sym_COLON] = ACTIONS(13582),
    [anon_sym_begin] = ACTIONS(13582),
    [anon_sym_module] = ACTIONS(13582),
    [anon_sym_baremodule] = ACTIONS(13582),
    [anon_sym_abstract] = ACTIONS(13582),
    [anon_sym_primitive] = ACTIONS(13582),
    [anon_sym_mutable] = ACTIONS(13582),
    [anon_sym_struct] = ACTIONS(13582),
    [anon_sym_function] = ACTIONS(13582),
    [anon_sym_macro] = ACTIONS(13582),
    [anon_sym_where] = ACTIONS(13582),
    [anon_sym_quote] = ACTIONS(13582),
    [anon_sym_let] = ACTIONS(13582),
    [anon_sym_if] = ACTIONS(13582),
    [anon_sym_try] = ACTIONS(13582),
    [anon_sym_for] = ACTIONS(13582),
    [anon_sym_while] = ACTIONS(13582),
    [sym_break_statement] = ACTIONS(13582),
    [sym_continue_statement] = ACTIONS(13582),
    [anon_sym_return] = ACTIONS(13582),
    [anon_sym_const] = ACTIONS(13582),
    [anon_sym_global] = ACTIONS(13582),
    [anon_sym_local] = ACTIONS(13582),
    [anon_sym_LPAREN] = ACTIONS(13584),
    [anon_sym_RPAREN] = ACTIONS(13584),
    [anon_sym_COLON2] = ACTIONS(13582),
    [anon_sym_export] = ACTIONS(13582),
    [anon_sym_import] = ACTIONS(13582),
    [anon_sym_using] = ACTIONS(13582),
    [anon_sym_LBRACK] = ACTIONS(13584),
    [anon_sym_RBRACK] = ACTIONS(13584),
    [anon_sym_in] = ACTIONS(13582),
    [anon_sym_SEMI] = ACTIONS(13584),
    [anon_sym_LBRACE] = ACTIONS(13584),
    [anon_sym_RBRACE] = ACTIONS(13584),
    [anon_sym_DOLLAR] = ACTIONS(13584),
    [anon_sym_COLON_COLON] = ACTIONS(13584),
    [anon_sym_isa] = ACTIONS(13582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13584),
    [anon_sym_QMARK] = ACTIONS(13584),
    [anon_sym_AT] = ACTIONS(13584),
    [anon_sym_true] = ACTIONS(13582),
    [anon_sym_false] = ACTIONS(13582),
    [aux_sym_integer_literal_token1] = ACTIONS(13584),
    [aux_sym_integer_literal_token2] = ACTIONS(13584),
    [aux_sym_integer_literal_token3] = ACTIONS(13582),
    [aux_sym_integer_literal_token4] = ACTIONS(13582),
    [aux_sym_float_literal_token1] = ACTIONS(13584),
    [aux_sym_float_literal_token3] = ACTIONS(13584),
    [aux_sym_float_literal_token4] = ACTIONS(13584),
    [sym_character_literal] = ACTIONS(13584),
    [sym__pair_operator] = ACTIONS(13584),
    [sym__arrow_operator] = ACTIONS(13582),
    [sym__lazy_or_operator] = ACTIONS(13584),
    [sym__lazy_and_operator] = ACTIONS(13584),
    [sym__comparison_operator] = ACTIONS(13582),
    [sym__pipe_right_operator] = ACTIONS(13584),
    [sym__pipe_left_operator] = ACTIONS(13584),
    [sym__ellipsis_operator] = ACTIONS(13582),
    [sym__plus_operator] = ACTIONS(13582),
    [sym__times_operator] = ACTIONS(13582),
    [sym__rational_operator] = ACTIONS(13584),
    [sym__bitshift_operator] = ACTIONS(13584),
    [sym__power_operator] = ACTIONS(13584),
    [sym__tilde_operator] = ACTIONS(13584),
    [sym__type_order_operator] = ACTIONS(13584),
    [sym__unary_operator] = ACTIONS(13582),
    [sym__unary_plus_operator] = ACTIONS(13582),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13584),
    [sym__command_start] = ACTIONS(13584),
  },
  [8318] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12762),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11852),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8319] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12762),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8320] = {
    [sym__word_identifier] = ACTIONS(13586),
    [anon_sym_EQ] = ACTIONS(13586),
    [anon_sym_COMMA] = ACTIONS(13588),
    [anon_sym_COLON] = ACTIONS(13586),
    [anon_sym_begin] = ACTIONS(13586),
    [anon_sym_module] = ACTIONS(13586),
    [anon_sym_baremodule] = ACTIONS(13586),
    [anon_sym_abstract] = ACTIONS(13586),
    [anon_sym_primitive] = ACTIONS(13586),
    [anon_sym_mutable] = ACTIONS(13586),
    [anon_sym_struct] = ACTIONS(13586),
    [anon_sym_function] = ACTIONS(13586),
    [anon_sym_macro] = ACTIONS(13586),
    [anon_sym_where] = ACTIONS(13586),
    [anon_sym_quote] = ACTIONS(13586),
    [anon_sym_let] = ACTIONS(13586),
    [anon_sym_if] = ACTIONS(13586),
    [anon_sym_try] = ACTIONS(13586),
    [anon_sym_for] = ACTIONS(13586),
    [anon_sym_while] = ACTIONS(13586),
    [sym_break_statement] = ACTIONS(13586),
    [sym_continue_statement] = ACTIONS(13586),
    [anon_sym_return] = ACTIONS(13586),
    [anon_sym_const] = ACTIONS(13586),
    [anon_sym_global] = ACTIONS(13586),
    [anon_sym_local] = ACTIONS(13586),
    [anon_sym_LPAREN] = ACTIONS(13588),
    [anon_sym_RPAREN] = ACTIONS(13588),
    [anon_sym_COLON2] = ACTIONS(13586),
    [anon_sym_export] = ACTIONS(13586),
    [anon_sym_import] = ACTIONS(13586),
    [anon_sym_using] = ACTIONS(13586),
    [anon_sym_LBRACK] = ACTIONS(13588),
    [anon_sym_RBRACK] = ACTIONS(13588),
    [anon_sym_in] = ACTIONS(13586),
    [anon_sym_SEMI] = ACTIONS(13588),
    [anon_sym_LBRACE] = ACTIONS(13588),
    [anon_sym_RBRACE] = ACTIONS(13588),
    [anon_sym_DOLLAR] = ACTIONS(13588),
    [anon_sym_COLON_COLON] = ACTIONS(13588),
    [anon_sym_isa] = ACTIONS(13586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13588),
    [anon_sym_QMARK] = ACTIONS(13588),
    [anon_sym_AT] = ACTIONS(13588),
    [anon_sym_true] = ACTIONS(13586),
    [anon_sym_false] = ACTIONS(13586),
    [aux_sym_integer_literal_token1] = ACTIONS(13588),
    [aux_sym_integer_literal_token2] = ACTIONS(13588),
    [aux_sym_integer_literal_token3] = ACTIONS(13586),
    [aux_sym_integer_literal_token4] = ACTIONS(13586),
    [aux_sym_float_literal_token1] = ACTIONS(13588),
    [aux_sym_float_literal_token3] = ACTIONS(13588),
    [aux_sym_float_literal_token4] = ACTIONS(13588),
    [sym_character_literal] = ACTIONS(13588),
    [sym__pair_operator] = ACTIONS(13588),
    [sym__arrow_operator] = ACTIONS(13586),
    [sym__lazy_or_operator] = ACTIONS(13588),
    [sym__lazy_and_operator] = ACTIONS(13588),
    [sym__comparison_operator] = ACTIONS(13586),
    [sym__pipe_right_operator] = ACTIONS(13588),
    [sym__pipe_left_operator] = ACTIONS(13588),
    [sym__ellipsis_operator] = ACTIONS(13586),
    [sym__plus_operator] = ACTIONS(13586),
    [sym__times_operator] = ACTIONS(13586),
    [sym__rational_operator] = ACTIONS(13588),
    [sym__bitshift_operator] = ACTIONS(13588),
    [sym__power_operator] = ACTIONS(13588),
    [sym__tilde_operator] = ACTIONS(13588),
    [sym__type_order_operator] = ACTIONS(13588),
    [sym__unary_operator] = ACTIONS(13586),
    [sym__unary_plus_operator] = ACTIONS(13586),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13588),
    [sym__command_start] = ACTIONS(13588),
  },
  [8321] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12130),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8322] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [8323] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [8324] = {
    [sym__word_identifier] = ACTIONS(13590),
    [anon_sym_EQ] = ACTIONS(13590),
    [anon_sym_COMMA] = ACTIONS(13592),
    [anon_sym_COLON] = ACTIONS(13590),
    [anon_sym_begin] = ACTIONS(13590),
    [anon_sym_module] = ACTIONS(13590),
    [anon_sym_baremodule] = ACTIONS(13590),
    [anon_sym_abstract] = ACTIONS(13590),
    [anon_sym_primitive] = ACTIONS(13590),
    [anon_sym_mutable] = ACTIONS(13590),
    [anon_sym_struct] = ACTIONS(13590),
    [anon_sym_function] = ACTIONS(13590),
    [anon_sym_macro] = ACTIONS(13590),
    [anon_sym_where] = ACTIONS(13590),
    [anon_sym_quote] = ACTIONS(13590),
    [anon_sym_let] = ACTIONS(13590),
    [anon_sym_if] = ACTIONS(13590),
    [anon_sym_try] = ACTIONS(13590),
    [anon_sym_for] = ACTIONS(13590),
    [anon_sym_while] = ACTIONS(13590),
    [sym_break_statement] = ACTIONS(13590),
    [sym_continue_statement] = ACTIONS(13590),
    [anon_sym_return] = ACTIONS(13590),
    [anon_sym_const] = ACTIONS(13590),
    [anon_sym_global] = ACTIONS(13590),
    [anon_sym_local] = ACTIONS(13590),
    [anon_sym_LPAREN] = ACTIONS(13592),
    [anon_sym_RPAREN] = ACTIONS(13592),
    [anon_sym_COLON2] = ACTIONS(13590),
    [anon_sym_export] = ACTIONS(13590),
    [anon_sym_import] = ACTIONS(13590),
    [anon_sym_using] = ACTIONS(13590),
    [anon_sym_LBRACK] = ACTIONS(13592),
    [anon_sym_RBRACK] = ACTIONS(13592),
    [anon_sym_in] = ACTIONS(13590),
    [anon_sym_SEMI] = ACTIONS(13592),
    [anon_sym_LBRACE] = ACTIONS(13592),
    [anon_sym_RBRACE] = ACTIONS(13592),
    [anon_sym_DOLLAR] = ACTIONS(13592),
    [anon_sym_COLON_COLON] = ACTIONS(13592),
    [anon_sym_isa] = ACTIONS(13590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13592),
    [anon_sym_QMARK] = ACTIONS(13592),
    [anon_sym_AT] = ACTIONS(13592),
    [anon_sym_true] = ACTIONS(13590),
    [anon_sym_false] = ACTIONS(13590),
    [aux_sym_integer_literal_token1] = ACTIONS(13592),
    [aux_sym_integer_literal_token2] = ACTIONS(13592),
    [aux_sym_integer_literal_token3] = ACTIONS(13590),
    [aux_sym_integer_literal_token4] = ACTIONS(13590),
    [aux_sym_float_literal_token1] = ACTIONS(13592),
    [aux_sym_float_literal_token3] = ACTIONS(13592),
    [aux_sym_float_literal_token4] = ACTIONS(13592),
    [sym_character_literal] = ACTIONS(13592),
    [sym__pair_operator] = ACTIONS(13592),
    [sym__arrow_operator] = ACTIONS(13590),
    [sym__lazy_or_operator] = ACTIONS(13592),
    [sym__lazy_and_operator] = ACTIONS(13592),
    [sym__comparison_operator] = ACTIONS(13590),
    [sym__pipe_right_operator] = ACTIONS(13592),
    [sym__pipe_left_operator] = ACTIONS(13592),
    [sym__ellipsis_operator] = ACTIONS(13590),
    [sym__plus_operator] = ACTIONS(13590),
    [sym__times_operator] = ACTIONS(13590),
    [sym__rational_operator] = ACTIONS(13592),
    [sym__bitshift_operator] = ACTIONS(13592),
    [sym__power_operator] = ACTIONS(13592),
    [sym__tilde_operator] = ACTIONS(13592),
    [sym__type_order_operator] = ACTIONS(13592),
    [sym__unary_operator] = ACTIONS(13590),
    [sym__unary_plus_operator] = ACTIONS(13590),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13592),
    [sym__command_start] = ACTIONS(13592),
  },
  [8325] = {
    [sym__word_identifier] = ACTIONS(13534),
    [anon_sym_EQ] = ACTIONS(13534),
    [anon_sym_COMMA] = ACTIONS(13536),
    [anon_sym_COLON] = ACTIONS(13534),
    [anon_sym_begin] = ACTIONS(13534),
    [anon_sym_module] = ACTIONS(13534),
    [anon_sym_baremodule] = ACTIONS(13534),
    [anon_sym_abstract] = ACTIONS(13534),
    [anon_sym_primitive] = ACTIONS(13534),
    [anon_sym_mutable] = ACTIONS(13534),
    [anon_sym_struct] = ACTIONS(13534),
    [anon_sym_function] = ACTIONS(13534),
    [anon_sym_macro] = ACTIONS(13534),
    [anon_sym_where] = ACTIONS(13534),
    [anon_sym_quote] = ACTIONS(13534),
    [anon_sym_let] = ACTIONS(13534),
    [anon_sym_if] = ACTIONS(13534),
    [anon_sym_try] = ACTIONS(13534),
    [anon_sym_for] = ACTIONS(13534),
    [anon_sym_while] = ACTIONS(13534),
    [sym_break_statement] = ACTIONS(13534),
    [sym_continue_statement] = ACTIONS(13534),
    [anon_sym_return] = ACTIONS(13534),
    [anon_sym_const] = ACTIONS(13534),
    [anon_sym_global] = ACTIONS(13534),
    [anon_sym_local] = ACTIONS(13534),
    [anon_sym_LPAREN] = ACTIONS(13536),
    [anon_sym_RPAREN] = ACTIONS(13536),
    [anon_sym_COLON2] = ACTIONS(13534),
    [anon_sym_export] = ACTIONS(13534),
    [anon_sym_import] = ACTIONS(13534),
    [anon_sym_using] = ACTIONS(13534),
    [anon_sym_LBRACK] = ACTIONS(13536),
    [anon_sym_RBRACK] = ACTIONS(13536),
    [anon_sym_in] = ACTIONS(13534),
    [anon_sym_SEMI] = ACTIONS(13536),
    [anon_sym_LBRACE] = ACTIONS(13536),
    [anon_sym_RBRACE] = ACTIONS(13536),
    [anon_sym_DOLLAR] = ACTIONS(13536),
    [anon_sym_COLON_COLON] = ACTIONS(13536),
    [anon_sym_isa] = ACTIONS(13534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13536),
    [anon_sym_QMARK] = ACTIONS(13536),
    [anon_sym_AT] = ACTIONS(13536),
    [anon_sym_true] = ACTIONS(13534),
    [anon_sym_false] = ACTIONS(13534),
    [aux_sym_integer_literal_token1] = ACTIONS(13536),
    [aux_sym_integer_literal_token2] = ACTIONS(13536),
    [aux_sym_integer_literal_token3] = ACTIONS(13534),
    [aux_sym_integer_literal_token4] = ACTIONS(13534),
    [aux_sym_float_literal_token1] = ACTIONS(13536),
    [aux_sym_float_literal_token3] = ACTIONS(13536),
    [aux_sym_float_literal_token4] = ACTIONS(13536),
    [sym_character_literal] = ACTIONS(13536),
    [sym__pair_operator] = ACTIONS(13536),
    [sym__arrow_operator] = ACTIONS(13534),
    [sym__lazy_or_operator] = ACTIONS(13536),
    [sym__lazy_and_operator] = ACTIONS(13536),
    [sym__comparison_operator] = ACTIONS(13534),
    [sym__pipe_right_operator] = ACTIONS(13536),
    [sym__pipe_left_operator] = ACTIONS(13536),
    [sym__ellipsis_operator] = ACTIONS(13534),
    [sym__plus_operator] = ACTIONS(13534),
    [sym__times_operator] = ACTIONS(13534),
    [sym__rational_operator] = ACTIONS(13536),
    [sym__bitshift_operator] = ACTIONS(13536),
    [sym__power_operator] = ACTIONS(13536),
    [sym__tilde_operator] = ACTIONS(13536),
    [sym__type_order_operator] = ACTIONS(13536),
    [sym__unary_operator] = ACTIONS(13534),
    [sym__unary_plus_operator] = ACTIONS(13534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13536),
    [sym__command_start] = ACTIONS(13536),
  },
  [8326] = {
    [sym__word_identifier] = ACTIONS(13594),
    [anon_sym_EQ] = ACTIONS(13594),
    [anon_sym_COMMA] = ACTIONS(13596),
    [anon_sym_COLON] = ACTIONS(13594),
    [anon_sym_begin] = ACTIONS(13594),
    [anon_sym_module] = ACTIONS(13594),
    [anon_sym_baremodule] = ACTIONS(13594),
    [anon_sym_abstract] = ACTIONS(13594),
    [anon_sym_primitive] = ACTIONS(13594),
    [anon_sym_mutable] = ACTIONS(13594),
    [anon_sym_struct] = ACTIONS(13594),
    [anon_sym_function] = ACTIONS(13594),
    [anon_sym_macro] = ACTIONS(13594),
    [anon_sym_where] = ACTIONS(13594),
    [anon_sym_quote] = ACTIONS(13594),
    [anon_sym_let] = ACTIONS(13594),
    [anon_sym_if] = ACTIONS(13594),
    [anon_sym_try] = ACTIONS(13594),
    [anon_sym_for] = ACTIONS(13594),
    [anon_sym_while] = ACTIONS(13594),
    [sym_break_statement] = ACTIONS(13594),
    [sym_continue_statement] = ACTIONS(13594),
    [anon_sym_return] = ACTIONS(13594),
    [anon_sym_const] = ACTIONS(13594),
    [anon_sym_global] = ACTIONS(13594),
    [anon_sym_local] = ACTIONS(13594),
    [anon_sym_LPAREN] = ACTIONS(13596),
    [anon_sym_RPAREN] = ACTIONS(13596),
    [anon_sym_COLON2] = ACTIONS(13594),
    [anon_sym_export] = ACTIONS(13594),
    [anon_sym_import] = ACTIONS(13594),
    [anon_sym_using] = ACTIONS(13594),
    [anon_sym_LBRACK] = ACTIONS(13596),
    [anon_sym_RBRACK] = ACTIONS(13596),
    [anon_sym_in] = ACTIONS(13594),
    [anon_sym_SEMI] = ACTIONS(13596),
    [anon_sym_LBRACE] = ACTIONS(13596),
    [anon_sym_RBRACE] = ACTIONS(13596),
    [anon_sym_DOLLAR] = ACTIONS(13596),
    [anon_sym_COLON_COLON] = ACTIONS(13596),
    [anon_sym_isa] = ACTIONS(13594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13596),
    [anon_sym_QMARK] = ACTIONS(13596),
    [anon_sym_AT] = ACTIONS(13596),
    [anon_sym_true] = ACTIONS(13594),
    [anon_sym_false] = ACTIONS(13594),
    [aux_sym_integer_literal_token1] = ACTIONS(13596),
    [aux_sym_integer_literal_token2] = ACTIONS(13596),
    [aux_sym_integer_literal_token3] = ACTIONS(13594),
    [aux_sym_integer_literal_token4] = ACTIONS(13594),
    [aux_sym_float_literal_token1] = ACTIONS(13596),
    [aux_sym_float_literal_token3] = ACTIONS(13596),
    [aux_sym_float_literal_token4] = ACTIONS(13596),
    [sym_character_literal] = ACTIONS(13596),
    [sym__pair_operator] = ACTIONS(13596),
    [sym__arrow_operator] = ACTIONS(13594),
    [sym__lazy_or_operator] = ACTIONS(13596),
    [sym__lazy_and_operator] = ACTIONS(13596),
    [sym__comparison_operator] = ACTIONS(13594),
    [sym__pipe_right_operator] = ACTIONS(13596),
    [sym__pipe_left_operator] = ACTIONS(13596),
    [sym__ellipsis_operator] = ACTIONS(13594),
    [sym__plus_operator] = ACTIONS(13594),
    [sym__times_operator] = ACTIONS(13594),
    [sym__rational_operator] = ACTIONS(13596),
    [sym__bitshift_operator] = ACTIONS(13596),
    [sym__power_operator] = ACTIONS(13596),
    [sym__tilde_operator] = ACTIONS(13596),
    [sym__type_order_operator] = ACTIONS(13596),
    [sym__unary_operator] = ACTIONS(13594),
    [sym__unary_plus_operator] = ACTIONS(13594),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13596),
    [sym__command_start] = ACTIONS(13596),
  },
  [8327] = {
    [sym__word_identifier] = ACTIONS(13598),
    [anon_sym_EQ] = ACTIONS(13598),
    [anon_sym_COMMA] = ACTIONS(13600),
    [anon_sym_COLON] = ACTIONS(13598),
    [anon_sym_begin] = ACTIONS(13598),
    [anon_sym_module] = ACTIONS(13598),
    [anon_sym_baremodule] = ACTIONS(13598),
    [anon_sym_abstract] = ACTIONS(13598),
    [anon_sym_primitive] = ACTIONS(13598),
    [anon_sym_mutable] = ACTIONS(13598),
    [anon_sym_struct] = ACTIONS(13598),
    [anon_sym_function] = ACTIONS(13598),
    [anon_sym_macro] = ACTIONS(13598),
    [anon_sym_where] = ACTIONS(13598),
    [anon_sym_quote] = ACTIONS(13598),
    [anon_sym_let] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(13598),
    [anon_sym_try] = ACTIONS(13598),
    [anon_sym_for] = ACTIONS(13598),
    [anon_sym_while] = ACTIONS(13598),
    [sym_break_statement] = ACTIONS(13598),
    [sym_continue_statement] = ACTIONS(13598),
    [anon_sym_return] = ACTIONS(13598),
    [anon_sym_const] = ACTIONS(13598),
    [anon_sym_global] = ACTIONS(13598),
    [anon_sym_local] = ACTIONS(13598),
    [anon_sym_LPAREN] = ACTIONS(13600),
    [anon_sym_RPAREN] = ACTIONS(13600),
    [anon_sym_COLON2] = ACTIONS(13598),
    [anon_sym_export] = ACTIONS(13598),
    [anon_sym_import] = ACTIONS(13598),
    [anon_sym_using] = ACTIONS(13598),
    [anon_sym_LBRACK] = ACTIONS(13600),
    [anon_sym_RBRACK] = ACTIONS(13600),
    [anon_sym_in] = ACTIONS(13598),
    [anon_sym_SEMI] = ACTIONS(13600),
    [anon_sym_LBRACE] = ACTIONS(13600),
    [anon_sym_RBRACE] = ACTIONS(13600),
    [anon_sym_DOLLAR] = ACTIONS(13600),
    [anon_sym_COLON_COLON] = ACTIONS(13600),
    [anon_sym_isa] = ACTIONS(13598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13600),
    [anon_sym_QMARK] = ACTIONS(13600),
    [anon_sym_AT] = ACTIONS(13600),
    [anon_sym_true] = ACTIONS(13598),
    [anon_sym_false] = ACTIONS(13598),
    [aux_sym_integer_literal_token1] = ACTIONS(13600),
    [aux_sym_integer_literal_token2] = ACTIONS(13600),
    [aux_sym_integer_literal_token3] = ACTIONS(13598),
    [aux_sym_integer_literal_token4] = ACTIONS(13598),
    [aux_sym_float_literal_token1] = ACTIONS(13600),
    [aux_sym_float_literal_token3] = ACTIONS(13600),
    [aux_sym_float_literal_token4] = ACTIONS(13600),
    [sym_character_literal] = ACTIONS(13600),
    [sym__pair_operator] = ACTIONS(13600),
    [sym__arrow_operator] = ACTIONS(13598),
    [sym__lazy_or_operator] = ACTIONS(13600),
    [sym__lazy_and_operator] = ACTIONS(13600),
    [sym__comparison_operator] = ACTIONS(13598),
    [sym__pipe_right_operator] = ACTIONS(13600),
    [sym__pipe_left_operator] = ACTIONS(13600),
    [sym__ellipsis_operator] = ACTIONS(13598),
    [sym__plus_operator] = ACTIONS(13598),
    [sym__times_operator] = ACTIONS(13598),
    [sym__rational_operator] = ACTIONS(13600),
    [sym__bitshift_operator] = ACTIONS(13600),
    [sym__power_operator] = ACTIONS(13600),
    [sym__tilde_operator] = ACTIONS(13600),
    [sym__type_order_operator] = ACTIONS(13600),
    [sym__unary_operator] = ACTIONS(13598),
    [sym__unary_plus_operator] = ACTIONS(13598),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13600),
    [sym__command_start] = ACTIONS(13600),
  },
  [8328] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [8329] = {
    [sym__word_identifier] = ACTIONS(13602),
    [anon_sym_EQ] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(13604),
    [anon_sym_COLON] = ACTIONS(13602),
    [anon_sym_begin] = ACTIONS(13602),
    [anon_sym_module] = ACTIONS(13602),
    [anon_sym_baremodule] = ACTIONS(13602),
    [anon_sym_abstract] = ACTIONS(13602),
    [anon_sym_primitive] = ACTIONS(13602),
    [anon_sym_mutable] = ACTIONS(13602),
    [anon_sym_struct] = ACTIONS(13602),
    [anon_sym_function] = ACTIONS(13602),
    [anon_sym_macro] = ACTIONS(13602),
    [anon_sym_where] = ACTIONS(13602),
    [anon_sym_quote] = ACTIONS(13602),
    [anon_sym_let] = ACTIONS(13602),
    [anon_sym_if] = ACTIONS(13602),
    [anon_sym_try] = ACTIONS(13602),
    [anon_sym_for] = ACTIONS(13602),
    [anon_sym_while] = ACTIONS(13602),
    [sym_break_statement] = ACTIONS(13602),
    [sym_continue_statement] = ACTIONS(13602),
    [anon_sym_return] = ACTIONS(13602),
    [anon_sym_const] = ACTIONS(13602),
    [anon_sym_global] = ACTIONS(13602),
    [anon_sym_local] = ACTIONS(13602),
    [anon_sym_LPAREN] = ACTIONS(13604),
    [anon_sym_RPAREN] = ACTIONS(13604),
    [anon_sym_COLON2] = ACTIONS(13602),
    [anon_sym_export] = ACTIONS(13602),
    [anon_sym_import] = ACTIONS(13602),
    [anon_sym_using] = ACTIONS(13602),
    [anon_sym_LBRACK] = ACTIONS(13604),
    [anon_sym_RBRACK] = ACTIONS(13604),
    [anon_sym_in] = ACTIONS(13602),
    [anon_sym_SEMI] = ACTIONS(13604),
    [anon_sym_LBRACE] = ACTIONS(13604),
    [anon_sym_RBRACE] = ACTIONS(13604),
    [anon_sym_DOLLAR] = ACTIONS(13604),
    [anon_sym_COLON_COLON] = ACTIONS(13604),
    [anon_sym_isa] = ACTIONS(13602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13604),
    [anon_sym_QMARK] = ACTIONS(13604),
    [anon_sym_AT] = ACTIONS(13604),
    [anon_sym_true] = ACTIONS(13602),
    [anon_sym_false] = ACTIONS(13602),
    [aux_sym_integer_literal_token1] = ACTIONS(13604),
    [aux_sym_integer_literal_token2] = ACTIONS(13604),
    [aux_sym_integer_literal_token3] = ACTIONS(13602),
    [aux_sym_integer_literal_token4] = ACTIONS(13602),
    [aux_sym_float_literal_token1] = ACTIONS(13604),
    [aux_sym_float_literal_token3] = ACTIONS(13604),
    [aux_sym_float_literal_token4] = ACTIONS(13604),
    [sym_character_literal] = ACTIONS(13604),
    [sym__pair_operator] = ACTIONS(13604),
    [sym__arrow_operator] = ACTIONS(13602),
    [sym__lazy_or_operator] = ACTIONS(13604),
    [sym__lazy_and_operator] = ACTIONS(13604),
    [sym__comparison_operator] = ACTIONS(13602),
    [sym__pipe_right_operator] = ACTIONS(13604),
    [sym__pipe_left_operator] = ACTIONS(13604),
    [sym__ellipsis_operator] = ACTIONS(13602),
    [sym__plus_operator] = ACTIONS(13602),
    [sym__times_operator] = ACTIONS(13602),
    [sym__rational_operator] = ACTIONS(13604),
    [sym__bitshift_operator] = ACTIONS(13604),
    [sym__power_operator] = ACTIONS(13604),
    [sym__tilde_operator] = ACTIONS(13604),
    [sym__type_order_operator] = ACTIONS(13604),
    [sym__unary_operator] = ACTIONS(13602),
    [sym__unary_plus_operator] = ACTIONS(13602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13604),
    [sym__command_start] = ACTIONS(13604),
  },
  [8330] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(14614),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8331] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(14616),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_catch] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8332] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(14618),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8333] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_catch] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14612),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8334] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12610),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8335] = {
    [sym__word_identifier] = ACTIONS(13606),
    [anon_sym_EQ] = ACTIONS(13606),
    [anon_sym_COMMA] = ACTIONS(13608),
    [anon_sym_COLON] = ACTIONS(13606),
    [anon_sym_begin] = ACTIONS(13606),
    [anon_sym_module] = ACTIONS(13606),
    [anon_sym_baremodule] = ACTIONS(13606),
    [anon_sym_abstract] = ACTIONS(13606),
    [anon_sym_primitive] = ACTIONS(13606),
    [anon_sym_mutable] = ACTIONS(13606),
    [anon_sym_struct] = ACTIONS(13606),
    [anon_sym_function] = ACTIONS(13606),
    [anon_sym_macro] = ACTIONS(13606),
    [anon_sym_where] = ACTIONS(13606),
    [anon_sym_quote] = ACTIONS(13606),
    [anon_sym_let] = ACTIONS(13606),
    [anon_sym_if] = ACTIONS(13606),
    [anon_sym_try] = ACTIONS(13606),
    [anon_sym_for] = ACTIONS(13606),
    [anon_sym_while] = ACTIONS(13606),
    [sym_break_statement] = ACTIONS(13606),
    [sym_continue_statement] = ACTIONS(13606),
    [anon_sym_return] = ACTIONS(13606),
    [anon_sym_const] = ACTIONS(13606),
    [anon_sym_global] = ACTIONS(13606),
    [anon_sym_local] = ACTIONS(13606),
    [anon_sym_LPAREN] = ACTIONS(13608),
    [anon_sym_RPAREN] = ACTIONS(13608),
    [anon_sym_COLON2] = ACTIONS(13606),
    [anon_sym_export] = ACTIONS(13606),
    [anon_sym_import] = ACTIONS(13606),
    [anon_sym_using] = ACTIONS(13606),
    [anon_sym_LBRACK] = ACTIONS(13608),
    [anon_sym_RBRACK] = ACTIONS(13608),
    [anon_sym_in] = ACTIONS(13606),
    [anon_sym_SEMI] = ACTIONS(13608),
    [anon_sym_LBRACE] = ACTIONS(13608),
    [anon_sym_RBRACE] = ACTIONS(13608),
    [anon_sym_DOLLAR] = ACTIONS(13608),
    [anon_sym_COLON_COLON] = ACTIONS(13608),
    [anon_sym_isa] = ACTIONS(13606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13608),
    [anon_sym_QMARK] = ACTIONS(13608),
    [anon_sym_AT] = ACTIONS(13608),
    [anon_sym_true] = ACTIONS(13606),
    [anon_sym_false] = ACTIONS(13606),
    [aux_sym_integer_literal_token1] = ACTIONS(13608),
    [aux_sym_integer_literal_token2] = ACTIONS(13608),
    [aux_sym_integer_literal_token3] = ACTIONS(13606),
    [aux_sym_integer_literal_token4] = ACTIONS(13606),
    [aux_sym_float_literal_token1] = ACTIONS(13608),
    [aux_sym_float_literal_token3] = ACTIONS(13608),
    [aux_sym_float_literal_token4] = ACTIONS(13608),
    [sym_character_literal] = ACTIONS(13608),
    [sym__pair_operator] = ACTIONS(13608),
    [sym__arrow_operator] = ACTIONS(13606),
    [sym__lazy_or_operator] = ACTIONS(13608),
    [sym__lazy_and_operator] = ACTIONS(13608),
    [sym__comparison_operator] = ACTIONS(13606),
    [sym__pipe_right_operator] = ACTIONS(13608),
    [sym__pipe_left_operator] = ACTIONS(13608),
    [sym__ellipsis_operator] = ACTIONS(13606),
    [sym__plus_operator] = ACTIONS(13606),
    [sym__times_operator] = ACTIONS(13606),
    [sym__rational_operator] = ACTIONS(13608),
    [sym__bitshift_operator] = ACTIONS(13608),
    [sym__power_operator] = ACTIONS(13608),
    [sym__tilde_operator] = ACTIONS(13608),
    [sym__type_order_operator] = ACTIONS(13608),
    [sym__unary_operator] = ACTIONS(13606),
    [sym__unary_plus_operator] = ACTIONS(13606),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13608),
    [sym__command_start] = ACTIONS(13608),
  },
  [8336] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(12562),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_catch] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8337] = {
    [aux_sym_open_tuple_repeat1] = STATE(7376),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(13394),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_catch] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14612),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8338] = {
    [sym__word_identifier] = ACTIONS(13358),
    [anon_sym_EQ] = ACTIONS(13358),
    [anon_sym_COMMA] = ACTIONS(13358),
    [anon_sym_COLON] = ACTIONS(13358),
    [anon_sym_begin] = ACTIONS(13358),
    [anon_sym_module] = ACTIONS(13358),
    [anon_sym_baremodule] = ACTIONS(13358),
    [anon_sym_abstract] = ACTIONS(13358),
    [anon_sym_primitive] = ACTIONS(13358),
    [anon_sym_mutable] = ACTIONS(13358),
    [anon_sym_struct] = ACTIONS(13358),
    [anon_sym_function] = ACTIONS(13358),
    [anon_sym_macro] = ACTIONS(13358),
    [anon_sym_where] = ACTIONS(13358),
    [anon_sym_quote] = ACTIONS(13358),
    [anon_sym_let] = ACTIONS(13358),
    [anon_sym_if] = ACTIONS(13358),
    [anon_sym_try] = ACTIONS(13358),
    [anon_sym_catch] = ACTIONS(13358),
    [anon_sym_finally] = ACTIONS(13358),
    [anon_sym_for] = ACTIONS(13358),
    [anon_sym_while] = ACTIONS(13358),
    [sym_break_statement] = ACTIONS(13358),
    [sym_continue_statement] = ACTIONS(13358),
    [anon_sym_return] = ACTIONS(13358),
    [anon_sym_const] = ACTIONS(13358),
    [anon_sym_global] = ACTIONS(13358),
    [anon_sym_local] = ACTIONS(13358),
    [anon_sym_LPAREN] = ACTIONS(13358),
    [anon_sym_COLON2] = ACTIONS(13358),
    [anon_sym_export] = ACTIONS(13358),
    [anon_sym_import] = ACTIONS(13358),
    [anon_sym_using] = ACTIONS(13358),
    [anon_sym_LBRACK] = ACTIONS(13358),
    [anon_sym_LF] = ACTIONS(13360),
    [anon_sym_in] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(13358),
    [anon_sym_DOLLAR] = ACTIONS(13358),
    [anon_sym_COLON_COLON] = ACTIONS(13358),
    [anon_sym_isa] = ACTIONS(13358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13358),
    [anon_sym_QMARK] = ACTIONS(13358),
    [anon_sym_AT] = ACTIONS(13358),
    [anon_sym_true] = ACTIONS(13358),
    [anon_sym_false] = ACTIONS(13358),
    [aux_sym_integer_literal_token1] = ACTIONS(13358),
    [aux_sym_integer_literal_token2] = ACTIONS(13358),
    [aux_sym_integer_literal_token3] = ACTIONS(13358),
    [aux_sym_integer_literal_token4] = ACTIONS(13358),
    [aux_sym_float_literal_token1] = ACTIONS(13358),
    [aux_sym_float_literal_token3] = ACTIONS(13358),
    [aux_sym_float_literal_token4] = ACTIONS(13358),
    [sym_character_literal] = ACTIONS(13358),
    [sym__pair_operator] = ACTIONS(13358),
    [sym__arrow_operator] = ACTIONS(13358),
    [sym__lazy_or_operator] = ACTIONS(13358),
    [sym__lazy_and_operator] = ACTIONS(13358),
    [sym__comparison_operator] = ACTIONS(13358),
    [sym__pipe_right_operator] = ACTIONS(13358),
    [sym__pipe_left_operator] = ACTIONS(13358),
    [sym__ellipsis_operator] = ACTIONS(13358),
    [sym__plus_operator] = ACTIONS(13358),
    [sym__times_operator] = ACTIONS(13358),
    [sym__rational_operator] = ACTIONS(13358),
    [sym__bitshift_operator] = ACTIONS(13358),
    [sym__power_operator] = ACTIONS(13358),
    [sym__tilde_operator] = ACTIONS(13358),
    [sym__type_order_operator] = ACTIONS(13358),
    [sym__unary_operator] = ACTIONS(13358),
    [sym__unary_plus_operator] = ACTIONS(13358),
    [aux_sym__terminator_token1] = ACTIONS(13358),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13360),
    [sym__command_start] = ACTIONS(13360),
  },
  [8339] = {
    [sym__word_identifier] = ACTIONS(13620),
    [anon_sym_EQ] = ACTIONS(13620),
    [anon_sym_COMMA] = ACTIONS(13622),
    [anon_sym_COLON] = ACTIONS(13620),
    [anon_sym_begin] = ACTIONS(13620),
    [anon_sym_module] = ACTIONS(13620),
    [anon_sym_baremodule] = ACTIONS(13620),
    [anon_sym_abstract] = ACTIONS(13620),
    [anon_sym_primitive] = ACTIONS(13620),
    [anon_sym_mutable] = ACTIONS(13620),
    [anon_sym_struct] = ACTIONS(13620),
    [anon_sym_function] = ACTIONS(13620),
    [anon_sym_macro] = ACTIONS(13620),
    [anon_sym_where] = ACTIONS(13620),
    [anon_sym_quote] = ACTIONS(13620),
    [anon_sym_let] = ACTIONS(13620),
    [anon_sym_if] = ACTIONS(13620),
    [anon_sym_try] = ACTIONS(13620),
    [anon_sym_for] = ACTIONS(13620),
    [anon_sym_while] = ACTIONS(13620),
    [sym_break_statement] = ACTIONS(13620),
    [sym_continue_statement] = ACTIONS(13620),
    [anon_sym_return] = ACTIONS(13620),
    [anon_sym_const] = ACTIONS(13620),
    [anon_sym_global] = ACTIONS(13620),
    [anon_sym_local] = ACTIONS(13620),
    [anon_sym_LPAREN] = ACTIONS(13622),
    [anon_sym_RPAREN] = ACTIONS(13622),
    [anon_sym_COLON2] = ACTIONS(13620),
    [anon_sym_export] = ACTIONS(13620),
    [anon_sym_import] = ACTIONS(13620),
    [anon_sym_using] = ACTIONS(13620),
    [anon_sym_LBRACK] = ACTIONS(13622),
    [anon_sym_RBRACK] = ACTIONS(13622),
    [anon_sym_in] = ACTIONS(13620),
    [anon_sym_SEMI] = ACTIONS(13622),
    [anon_sym_LBRACE] = ACTIONS(13622),
    [anon_sym_RBRACE] = ACTIONS(13622),
    [anon_sym_DOLLAR] = ACTIONS(13622),
    [anon_sym_COLON_COLON] = ACTIONS(13622),
    [anon_sym_isa] = ACTIONS(13620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13622),
    [anon_sym_QMARK] = ACTIONS(13622),
    [anon_sym_AT] = ACTIONS(13622),
    [anon_sym_true] = ACTIONS(13620),
    [anon_sym_false] = ACTIONS(13620),
    [aux_sym_integer_literal_token1] = ACTIONS(13622),
    [aux_sym_integer_literal_token2] = ACTIONS(13622),
    [aux_sym_integer_literal_token3] = ACTIONS(13620),
    [aux_sym_integer_literal_token4] = ACTIONS(13620),
    [aux_sym_float_literal_token1] = ACTIONS(13622),
    [aux_sym_float_literal_token3] = ACTIONS(13622),
    [aux_sym_float_literal_token4] = ACTIONS(13622),
    [sym_character_literal] = ACTIONS(13622),
    [sym__pair_operator] = ACTIONS(13622),
    [sym__arrow_operator] = ACTIONS(13620),
    [sym__lazy_or_operator] = ACTIONS(13622),
    [sym__lazy_and_operator] = ACTIONS(13622),
    [sym__comparison_operator] = ACTIONS(13620),
    [sym__pipe_right_operator] = ACTIONS(13622),
    [sym__pipe_left_operator] = ACTIONS(13622),
    [sym__ellipsis_operator] = ACTIONS(13620),
    [sym__plus_operator] = ACTIONS(13620),
    [sym__times_operator] = ACTIONS(13620),
    [sym__rational_operator] = ACTIONS(13622),
    [sym__bitshift_operator] = ACTIONS(13622),
    [sym__power_operator] = ACTIONS(13622),
    [sym__tilde_operator] = ACTIONS(13622),
    [sym__type_order_operator] = ACTIONS(13622),
    [sym__unary_operator] = ACTIONS(13620),
    [sym__unary_plus_operator] = ACTIONS(13620),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13622),
    [sym__command_start] = ACTIONS(13622),
  },
  [8340] = {
    [sym__word_identifier] = ACTIONS(13538),
    [anon_sym_EQ] = ACTIONS(13538),
    [anon_sym_COMMA] = ACTIONS(13540),
    [anon_sym_COLON] = ACTIONS(13538),
    [anon_sym_begin] = ACTIONS(13538),
    [anon_sym_module] = ACTIONS(13538),
    [anon_sym_baremodule] = ACTIONS(13538),
    [anon_sym_abstract] = ACTIONS(13538),
    [anon_sym_primitive] = ACTIONS(13538),
    [anon_sym_mutable] = ACTIONS(13538),
    [anon_sym_struct] = ACTIONS(13538),
    [anon_sym_function] = ACTIONS(13538),
    [anon_sym_macro] = ACTIONS(13538),
    [anon_sym_where] = ACTIONS(13538),
    [anon_sym_quote] = ACTIONS(13538),
    [anon_sym_let] = ACTIONS(13538),
    [anon_sym_if] = ACTIONS(13538),
    [anon_sym_try] = ACTIONS(13538),
    [anon_sym_for] = ACTIONS(13538),
    [anon_sym_while] = ACTIONS(13538),
    [sym_break_statement] = ACTIONS(13538),
    [sym_continue_statement] = ACTIONS(13538),
    [anon_sym_return] = ACTIONS(13538),
    [anon_sym_const] = ACTIONS(13538),
    [anon_sym_global] = ACTIONS(13538),
    [anon_sym_local] = ACTIONS(13538),
    [anon_sym_LPAREN] = ACTIONS(13540),
    [anon_sym_RPAREN] = ACTIONS(13540),
    [anon_sym_COLON2] = ACTIONS(13538),
    [anon_sym_export] = ACTIONS(13538),
    [anon_sym_import] = ACTIONS(13538),
    [anon_sym_using] = ACTIONS(13538),
    [anon_sym_LBRACK] = ACTIONS(13540),
    [anon_sym_RBRACK] = ACTIONS(13540),
    [anon_sym_in] = ACTIONS(13538),
    [anon_sym_SEMI] = ACTIONS(13540),
    [anon_sym_LBRACE] = ACTIONS(13540),
    [anon_sym_RBRACE] = ACTIONS(13540),
    [anon_sym_DOLLAR] = ACTIONS(13540),
    [anon_sym_COLON_COLON] = ACTIONS(13540),
    [anon_sym_isa] = ACTIONS(13538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13540),
    [anon_sym_QMARK] = ACTIONS(13540),
    [anon_sym_AT] = ACTIONS(13540),
    [anon_sym_true] = ACTIONS(13538),
    [anon_sym_false] = ACTIONS(13538),
    [aux_sym_integer_literal_token1] = ACTIONS(13540),
    [aux_sym_integer_literal_token2] = ACTIONS(13540),
    [aux_sym_integer_literal_token3] = ACTIONS(13538),
    [aux_sym_integer_literal_token4] = ACTIONS(13538),
    [aux_sym_float_literal_token1] = ACTIONS(13540),
    [aux_sym_float_literal_token3] = ACTIONS(13540),
    [aux_sym_float_literal_token4] = ACTIONS(13540),
    [sym_character_literal] = ACTIONS(13540),
    [sym__pair_operator] = ACTIONS(13540),
    [sym__arrow_operator] = ACTIONS(13538),
    [sym__lazy_or_operator] = ACTIONS(13540),
    [sym__lazy_and_operator] = ACTIONS(13540),
    [sym__comparison_operator] = ACTIONS(13538),
    [sym__pipe_right_operator] = ACTIONS(13540),
    [sym__pipe_left_operator] = ACTIONS(13540),
    [sym__ellipsis_operator] = ACTIONS(13538),
    [sym__plus_operator] = ACTIONS(13538),
    [sym__times_operator] = ACTIONS(13538),
    [sym__rational_operator] = ACTIONS(13540),
    [sym__bitshift_operator] = ACTIONS(13540),
    [sym__power_operator] = ACTIONS(13540),
    [sym__tilde_operator] = ACTIONS(13540),
    [sym__type_order_operator] = ACTIONS(13540),
    [sym__unary_operator] = ACTIONS(13538),
    [sym__unary_plus_operator] = ACTIONS(13538),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13540),
    [sym__command_start] = ACTIONS(13540),
  },
  [8341] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(12462),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_catch] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8342] = {
    [sym__word_identifier] = ACTIONS(13542),
    [anon_sym_EQ] = ACTIONS(13542),
    [anon_sym_COMMA] = ACTIONS(13544),
    [anon_sym_COLON] = ACTIONS(13542),
    [anon_sym_begin] = ACTIONS(13542),
    [anon_sym_module] = ACTIONS(13542),
    [anon_sym_baremodule] = ACTIONS(13542),
    [anon_sym_abstract] = ACTIONS(13542),
    [anon_sym_primitive] = ACTIONS(13542),
    [anon_sym_mutable] = ACTIONS(13542),
    [anon_sym_struct] = ACTIONS(13542),
    [anon_sym_function] = ACTIONS(13542),
    [anon_sym_macro] = ACTIONS(13542),
    [anon_sym_where] = ACTIONS(13542),
    [anon_sym_quote] = ACTIONS(13542),
    [anon_sym_let] = ACTIONS(13542),
    [anon_sym_if] = ACTIONS(13542),
    [anon_sym_try] = ACTIONS(13542),
    [anon_sym_for] = ACTIONS(13542),
    [anon_sym_while] = ACTIONS(13542),
    [sym_break_statement] = ACTIONS(13542),
    [sym_continue_statement] = ACTIONS(13542),
    [anon_sym_return] = ACTIONS(13542),
    [anon_sym_const] = ACTIONS(13542),
    [anon_sym_global] = ACTIONS(13542),
    [anon_sym_local] = ACTIONS(13542),
    [anon_sym_LPAREN] = ACTIONS(13544),
    [anon_sym_RPAREN] = ACTIONS(13544),
    [anon_sym_COLON2] = ACTIONS(13542),
    [anon_sym_export] = ACTIONS(13542),
    [anon_sym_import] = ACTIONS(13542),
    [anon_sym_using] = ACTIONS(13542),
    [anon_sym_LBRACK] = ACTIONS(13544),
    [anon_sym_RBRACK] = ACTIONS(13544),
    [anon_sym_in] = ACTIONS(13542),
    [anon_sym_SEMI] = ACTIONS(13544),
    [anon_sym_LBRACE] = ACTIONS(13544),
    [anon_sym_RBRACE] = ACTIONS(13544),
    [anon_sym_DOLLAR] = ACTIONS(13544),
    [anon_sym_COLON_COLON] = ACTIONS(13544),
    [anon_sym_isa] = ACTIONS(13542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13544),
    [anon_sym_QMARK] = ACTIONS(13544),
    [anon_sym_AT] = ACTIONS(13544),
    [anon_sym_true] = ACTIONS(13542),
    [anon_sym_false] = ACTIONS(13542),
    [aux_sym_integer_literal_token1] = ACTIONS(13544),
    [aux_sym_integer_literal_token2] = ACTIONS(13544),
    [aux_sym_integer_literal_token3] = ACTIONS(13542),
    [aux_sym_integer_literal_token4] = ACTIONS(13542),
    [aux_sym_float_literal_token1] = ACTIONS(13544),
    [aux_sym_float_literal_token3] = ACTIONS(13544),
    [aux_sym_float_literal_token4] = ACTIONS(13544),
    [sym_character_literal] = ACTIONS(13544),
    [sym__pair_operator] = ACTIONS(13544),
    [sym__arrow_operator] = ACTIONS(13542),
    [sym__lazy_or_operator] = ACTIONS(13544),
    [sym__lazy_and_operator] = ACTIONS(13544),
    [sym__comparison_operator] = ACTIONS(13542),
    [sym__pipe_right_operator] = ACTIONS(13544),
    [sym__pipe_left_operator] = ACTIONS(13544),
    [sym__ellipsis_operator] = ACTIONS(13542),
    [sym__plus_operator] = ACTIONS(13542),
    [sym__times_operator] = ACTIONS(13542),
    [sym__rational_operator] = ACTIONS(13544),
    [sym__bitshift_operator] = ACTIONS(13544),
    [sym__power_operator] = ACTIONS(13544),
    [sym__tilde_operator] = ACTIONS(13544),
    [sym__type_order_operator] = ACTIONS(13544),
    [sym__unary_operator] = ACTIONS(13542),
    [sym__unary_plus_operator] = ACTIONS(13542),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13544),
    [sym__command_start] = ACTIONS(13544),
  },
  [8343] = {
    [aux_sym_open_tuple_repeat1] = STATE(7998),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_catch] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8344] = {
    [aux_sym_open_tuple_repeat1] = STATE(7471),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13497),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8345] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12072),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8346] = {
    [sym__word_identifier] = ACTIONS(13546),
    [anon_sym_EQ] = ACTIONS(13546),
    [anon_sym_COMMA] = ACTIONS(13548),
    [anon_sym_COLON] = ACTIONS(13546),
    [anon_sym_begin] = ACTIONS(13546),
    [anon_sym_module] = ACTIONS(13546),
    [anon_sym_baremodule] = ACTIONS(13546),
    [anon_sym_abstract] = ACTIONS(13546),
    [anon_sym_primitive] = ACTIONS(13546),
    [anon_sym_mutable] = ACTIONS(13546),
    [anon_sym_struct] = ACTIONS(13546),
    [anon_sym_function] = ACTIONS(13546),
    [anon_sym_macro] = ACTIONS(13546),
    [anon_sym_where] = ACTIONS(13546),
    [anon_sym_quote] = ACTIONS(13546),
    [anon_sym_let] = ACTIONS(13546),
    [anon_sym_if] = ACTIONS(13546),
    [anon_sym_try] = ACTIONS(13546),
    [anon_sym_for] = ACTIONS(13546),
    [anon_sym_while] = ACTIONS(13546),
    [sym_break_statement] = ACTIONS(13546),
    [sym_continue_statement] = ACTIONS(13546),
    [anon_sym_return] = ACTIONS(13546),
    [anon_sym_const] = ACTIONS(13546),
    [anon_sym_global] = ACTIONS(13546),
    [anon_sym_local] = ACTIONS(13546),
    [anon_sym_LPAREN] = ACTIONS(13548),
    [anon_sym_RPAREN] = ACTIONS(13548),
    [anon_sym_COLON2] = ACTIONS(13546),
    [anon_sym_export] = ACTIONS(13546),
    [anon_sym_import] = ACTIONS(13546),
    [anon_sym_using] = ACTIONS(13546),
    [anon_sym_LBRACK] = ACTIONS(13548),
    [anon_sym_RBRACK] = ACTIONS(13548),
    [anon_sym_in] = ACTIONS(13546),
    [anon_sym_SEMI] = ACTIONS(13548),
    [anon_sym_LBRACE] = ACTIONS(13548),
    [anon_sym_RBRACE] = ACTIONS(13548),
    [anon_sym_DOLLAR] = ACTIONS(13548),
    [anon_sym_COLON_COLON] = ACTIONS(13548),
    [anon_sym_isa] = ACTIONS(13546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13548),
    [anon_sym_QMARK] = ACTIONS(13548),
    [anon_sym_AT] = ACTIONS(13548),
    [anon_sym_true] = ACTIONS(13546),
    [anon_sym_false] = ACTIONS(13546),
    [aux_sym_integer_literal_token1] = ACTIONS(13548),
    [aux_sym_integer_literal_token2] = ACTIONS(13548),
    [aux_sym_integer_literal_token3] = ACTIONS(13546),
    [aux_sym_integer_literal_token4] = ACTIONS(13546),
    [aux_sym_float_literal_token1] = ACTIONS(13548),
    [aux_sym_float_literal_token3] = ACTIONS(13548),
    [aux_sym_float_literal_token4] = ACTIONS(13548),
    [sym_character_literal] = ACTIONS(13548),
    [sym__pair_operator] = ACTIONS(13548),
    [sym__arrow_operator] = ACTIONS(13546),
    [sym__lazy_or_operator] = ACTIONS(13548),
    [sym__lazy_and_operator] = ACTIONS(13548),
    [sym__comparison_operator] = ACTIONS(13546),
    [sym__pipe_right_operator] = ACTIONS(13548),
    [sym__pipe_left_operator] = ACTIONS(13548),
    [sym__ellipsis_operator] = ACTIONS(13546),
    [sym__plus_operator] = ACTIONS(13546),
    [sym__times_operator] = ACTIONS(13546),
    [sym__rational_operator] = ACTIONS(13548),
    [sym__bitshift_operator] = ACTIONS(13548),
    [sym__power_operator] = ACTIONS(13548),
    [sym__tilde_operator] = ACTIONS(13548),
    [sym__type_order_operator] = ACTIONS(13548),
    [sym__unary_operator] = ACTIONS(13546),
    [sym__unary_plus_operator] = ACTIONS(13546),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13548),
    [sym__command_start] = ACTIONS(13548),
  },
  [8347] = {
    [sym__word_identifier] = ACTIONS(13510),
    [anon_sym_EQ] = ACTIONS(13510),
    [anon_sym_COMMA] = ACTIONS(13512),
    [anon_sym_COLON] = ACTIONS(13510),
    [anon_sym_begin] = ACTIONS(13510),
    [anon_sym_module] = ACTIONS(13510),
    [anon_sym_baremodule] = ACTIONS(13510),
    [anon_sym_abstract] = ACTIONS(13510),
    [anon_sym_primitive] = ACTIONS(13510),
    [anon_sym_mutable] = ACTIONS(13510),
    [anon_sym_struct] = ACTIONS(13510),
    [anon_sym_function] = ACTIONS(13510),
    [anon_sym_macro] = ACTIONS(13510),
    [anon_sym_where] = ACTIONS(13510),
    [anon_sym_quote] = ACTIONS(13510),
    [anon_sym_let] = ACTIONS(13510),
    [anon_sym_if] = ACTIONS(13510),
    [anon_sym_try] = ACTIONS(13510),
    [anon_sym_for] = ACTIONS(13510),
    [anon_sym_while] = ACTIONS(13510),
    [sym_break_statement] = ACTIONS(13510),
    [sym_continue_statement] = ACTIONS(13510),
    [anon_sym_return] = ACTIONS(13510),
    [anon_sym_const] = ACTIONS(13510),
    [anon_sym_global] = ACTIONS(13510),
    [anon_sym_local] = ACTIONS(13510),
    [anon_sym_LPAREN] = ACTIONS(13512),
    [anon_sym_RPAREN] = ACTIONS(13512),
    [anon_sym_COLON2] = ACTIONS(13510),
    [anon_sym_export] = ACTIONS(13510),
    [anon_sym_import] = ACTIONS(13510),
    [anon_sym_using] = ACTIONS(13510),
    [anon_sym_LBRACK] = ACTIONS(13512),
    [anon_sym_RBRACK] = ACTIONS(13512),
    [anon_sym_in] = ACTIONS(13510),
    [anon_sym_SEMI] = ACTIONS(13512),
    [anon_sym_LBRACE] = ACTIONS(13512),
    [anon_sym_RBRACE] = ACTIONS(13512),
    [anon_sym_DOLLAR] = ACTIONS(13512),
    [anon_sym_COLON_COLON] = ACTIONS(13512),
    [anon_sym_isa] = ACTIONS(13510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13512),
    [anon_sym_QMARK] = ACTIONS(13512),
    [anon_sym_AT] = ACTIONS(13512),
    [anon_sym_true] = ACTIONS(13510),
    [anon_sym_false] = ACTIONS(13510),
    [aux_sym_integer_literal_token1] = ACTIONS(13512),
    [aux_sym_integer_literal_token2] = ACTIONS(13512),
    [aux_sym_integer_literal_token3] = ACTIONS(13510),
    [aux_sym_integer_literal_token4] = ACTIONS(13510),
    [aux_sym_float_literal_token1] = ACTIONS(13512),
    [aux_sym_float_literal_token3] = ACTIONS(13512),
    [aux_sym_float_literal_token4] = ACTIONS(13512),
    [sym_character_literal] = ACTIONS(13512),
    [sym__pair_operator] = ACTIONS(13512),
    [sym__arrow_operator] = ACTIONS(13510),
    [sym__lazy_or_operator] = ACTIONS(13512),
    [sym__lazy_and_operator] = ACTIONS(13512),
    [sym__comparison_operator] = ACTIONS(13510),
    [sym__pipe_right_operator] = ACTIONS(13512),
    [sym__pipe_left_operator] = ACTIONS(13512),
    [sym__ellipsis_operator] = ACTIONS(13510),
    [sym__plus_operator] = ACTIONS(13510),
    [sym__times_operator] = ACTIONS(13510),
    [sym__rational_operator] = ACTIONS(13512),
    [sym__bitshift_operator] = ACTIONS(13512),
    [sym__power_operator] = ACTIONS(13512),
    [sym__tilde_operator] = ACTIONS(13512),
    [sym__type_order_operator] = ACTIONS(13512),
    [sym__unary_operator] = ACTIONS(13510),
    [sym__unary_plus_operator] = ACTIONS(13510),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13512),
    [sym__command_start] = ACTIONS(13512),
  },
  [8348] = {
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13070),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_end] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_catch] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14455),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [8349] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_EQ] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_catch] = ACTIONS(13334),
    [anon_sym_finally] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [8350] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_EQ] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_catch] = ACTIONS(13467),
    [anon_sym_finally] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [8351] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8352] = {
    [sym__word_identifier] = ACTIONS(13624),
    [anon_sym_EQ] = ACTIONS(13624),
    [anon_sym_COMMA] = ACTIONS(13626),
    [anon_sym_COLON] = ACTIONS(13624),
    [anon_sym_begin] = ACTIONS(13624),
    [anon_sym_module] = ACTIONS(13624),
    [anon_sym_baremodule] = ACTIONS(13624),
    [anon_sym_abstract] = ACTIONS(13624),
    [anon_sym_primitive] = ACTIONS(13624),
    [anon_sym_mutable] = ACTIONS(13624),
    [anon_sym_struct] = ACTIONS(13624),
    [anon_sym_function] = ACTIONS(13624),
    [anon_sym_macro] = ACTIONS(13624),
    [anon_sym_where] = ACTIONS(13624),
    [anon_sym_quote] = ACTIONS(13624),
    [anon_sym_let] = ACTIONS(13624),
    [anon_sym_if] = ACTIONS(13624),
    [anon_sym_try] = ACTIONS(13624),
    [anon_sym_for] = ACTIONS(13624),
    [anon_sym_while] = ACTIONS(13624),
    [sym_break_statement] = ACTIONS(13624),
    [sym_continue_statement] = ACTIONS(13624),
    [anon_sym_return] = ACTIONS(13624),
    [anon_sym_const] = ACTIONS(13624),
    [anon_sym_global] = ACTIONS(13624),
    [anon_sym_local] = ACTIONS(13624),
    [anon_sym_LPAREN] = ACTIONS(13626),
    [anon_sym_RPAREN] = ACTIONS(13626),
    [anon_sym_COLON2] = ACTIONS(13624),
    [anon_sym_export] = ACTIONS(13624),
    [anon_sym_import] = ACTIONS(13624),
    [anon_sym_using] = ACTIONS(13624),
    [anon_sym_LBRACK] = ACTIONS(13626),
    [anon_sym_RBRACK] = ACTIONS(13626),
    [anon_sym_in] = ACTIONS(13624),
    [anon_sym_SEMI] = ACTIONS(13626),
    [anon_sym_LBRACE] = ACTIONS(13626),
    [anon_sym_RBRACE] = ACTIONS(13626),
    [anon_sym_DOLLAR] = ACTIONS(13626),
    [anon_sym_COLON_COLON] = ACTIONS(13626),
    [anon_sym_isa] = ACTIONS(13624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13626),
    [anon_sym_QMARK] = ACTIONS(13626),
    [anon_sym_AT] = ACTIONS(13626),
    [anon_sym_true] = ACTIONS(13624),
    [anon_sym_false] = ACTIONS(13624),
    [aux_sym_integer_literal_token1] = ACTIONS(13626),
    [aux_sym_integer_literal_token2] = ACTIONS(13626),
    [aux_sym_integer_literal_token3] = ACTIONS(13624),
    [aux_sym_integer_literal_token4] = ACTIONS(13624),
    [aux_sym_float_literal_token1] = ACTIONS(13626),
    [aux_sym_float_literal_token3] = ACTIONS(13626),
    [aux_sym_float_literal_token4] = ACTIONS(13626),
    [sym_character_literal] = ACTIONS(13626),
    [sym__pair_operator] = ACTIONS(13626),
    [sym__arrow_operator] = ACTIONS(13624),
    [sym__lazy_or_operator] = ACTIONS(13626),
    [sym__lazy_and_operator] = ACTIONS(13626),
    [sym__comparison_operator] = ACTIONS(13624),
    [sym__pipe_right_operator] = ACTIONS(13626),
    [sym__pipe_left_operator] = ACTIONS(13626),
    [sym__ellipsis_operator] = ACTIONS(13624),
    [sym__plus_operator] = ACTIONS(13624),
    [sym__times_operator] = ACTIONS(13624),
    [sym__rational_operator] = ACTIONS(13626),
    [sym__bitshift_operator] = ACTIONS(13626),
    [sym__power_operator] = ACTIONS(13626),
    [sym__tilde_operator] = ACTIONS(13626),
    [sym__type_order_operator] = ACTIONS(13626),
    [sym__unary_operator] = ACTIONS(13624),
    [sym__unary_plus_operator] = ACTIONS(13624),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13626),
    [sym__command_start] = ACTIONS(13626),
  },
  [8353] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14419),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8354] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8355] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8356] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8357] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8358] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8359] = {
    [sym__word_identifier] = ACTIONS(13628),
    [anon_sym_EQ] = ACTIONS(13628),
    [anon_sym_COMMA] = ACTIONS(13630),
    [anon_sym_COLON] = ACTIONS(13628),
    [anon_sym_begin] = ACTIONS(13628),
    [anon_sym_module] = ACTIONS(13628),
    [anon_sym_baremodule] = ACTIONS(13628),
    [anon_sym_abstract] = ACTIONS(13628),
    [anon_sym_primitive] = ACTIONS(13628),
    [anon_sym_mutable] = ACTIONS(13628),
    [anon_sym_struct] = ACTIONS(13628),
    [anon_sym_function] = ACTIONS(13628),
    [anon_sym_macro] = ACTIONS(13628),
    [anon_sym_where] = ACTIONS(13628),
    [anon_sym_quote] = ACTIONS(13628),
    [anon_sym_let] = ACTIONS(13628),
    [anon_sym_if] = ACTIONS(13628),
    [anon_sym_try] = ACTIONS(13628),
    [anon_sym_for] = ACTIONS(13628),
    [anon_sym_while] = ACTIONS(13628),
    [sym_break_statement] = ACTIONS(13628),
    [sym_continue_statement] = ACTIONS(13628),
    [anon_sym_return] = ACTIONS(13628),
    [anon_sym_const] = ACTIONS(13628),
    [anon_sym_global] = ACTIONS(13628),
    [anon_sym_local] = ACTIONS(13628),
    [anon_sym_LPAREN] = ACTIONS(13630),
    [anon_sym_RPAREN] = ACTIONS(13630),
    [anon_sym_COLON2] = ACTIONS(13628),
    [anon_sym_export] = ACTIONS(13628),
    [anon_sym_import] = ACTIONS(13628),
    [anon_sym_using] = ACTIONS(13628),
    [anon_sym_LBRACK] = ACTIONS(13630),
    [anon_sym_RBRACK] = ACTIONS(13630),
    [anon_sym_in] = ACTIONS(13628),
    [anon_sym_SEMI] = ACTIONS(13630),
    [anon_sym_LBRACE] = ACTIONS(13630),
    [anon_sym_RBRACE] = ACTIONS(13630),
    [anon_sym_DOLLAR] = ACTIONS(13630),
    [anon_sym_COLON_COLON] = ACTIONS(13630),
    [anon_sym_isa] = ACTIONS(13628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13630),
    [anon_sym_QMARK] = ACTIONS(13630),
    [anon_sym_AT] = ACTIONS(13630),
    [anon_sym_true] = ACTIONS(13628),
    [anon_sym_false] = ACTIONS(13628),
    [aux_sym_integer_literal_token1] = ACTIONS(13630),
    [aux_sym_integer_literal_token2] = ACTIONS(13630),
    [aux_sym_integer_literal_token3] = ACTIONS(13628),
    [aux_sym_integer_literal_token4] = ACTIONS(13628),
    [aux_sym_float_literal_token1] = ACTIONS(13630),
    [aux_sym_float_literal_token3] = ACTIONS(13630),
    [aux_sym_float_literal_token4] = ACTIONS(13630),
    [sym_character_literal] = ACTIONS(13630),
    [sym__pair_operator] = ACTIONS(13630),
    [sym__arrow_operator] = ACTIONS(13628),
    [sym__lazy_or_operator] = ACTIONS(13630),
    [sym__lazy_and_operator] = ACTIONS(13630),
    [sym__comparison_operator] = ACTIONS(13628),
    [sym__pipe_right_operator] = ACTIONS(13630),
    [sym__pipe_left_operator] = ACTIONS(13630),
    [sym__ellipsis_operator] = ACTIONS(13628),
    [sym__plus_operator] = ACTIONS(13628),
    [sym__times_operator] = ACTIONS(13628),
    [sym__rational_operator] = ACTIONS(13630),
    [sym__bitshift_operator] = ACTIONS(13630),
    [sym__power_operator] = ACTIONS(13630),
    [sym__tilde_operator] = ACTIONS(13630),
    [sym__type_order_operator] = ACTIONS(13630),
    [sym__unary_operator] = ACTIONS(13628),
    [sym__unary_plus_operator] = ACTIONS(13628),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13630),
    [sym__command_start] = ACTIONS(13630),
  },
  [8360] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8361] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8362] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8363] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8364] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8365] = {
    [sym__word_identifier] = ACTIONS(13362),
    [anon_sym_EQ] = ACTIONS(13362),
    [anon_sym_COMMA] = ACTIONS(13362),
    [anon_sym_COLON] = ACTIONS(13362),
    [anon_sym_begin] = ACTIONS(13362),
    [anon_sym_module] = ACTIONS(13362),
    [anon_sym_baremodule] = ACTIONS(13362),
    [anon_sym_abstract] = ACTIONS(13362),
    [anon_sym_primitive] = ACTIONS(13362),
    [anon_sym_mutable] = ACTIONS(13362),
    [anon_sym_struct] = ACTIONS(13362),
    [anon_sym_function] = ACTIONS(13362),
    [anon_sym_macro] = ACTIONS(13362),
    [anon_sym_where] = ACTIONS(13362),
    [anon_sym_quote] = ACTIONS(13362),
    [anon_sym_let] = ACTIONS(13362),
    [anon_sym_if] = ACTIONS(13362),
    [anon_sym_try] = ACTIONS(13362),
    [anon_sym_catch] = ACTIONS(13362),
    [anon_sym_finally] = ACTIONS(13362),
    [anon_sym_for] = ACTIONS(13362),
    [anon_sym_while] = ACTIONS(13362),
    [sym_break_statement] = ACTIONS(13362),
    [sym_continue_statement] = ACTIONS(13362),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_const] = ACTIONS(13362),
    [anon_sym_global] = ACTIONS(13362),
    [anon_sym_local] = ACTIONS(13362),
    [anon_sym_LPAREN] = ACTIONS(13362),
    [anon_sym_COLON2] = ACTIONS(13362),
    [anon_sym_export] = ACTIONS(13362),
    [anon_sym_import] = ACTIONS(13362),
    [anon_sym_using] = ACTIONS(13362),
    [anon_sym_LBRACK] = ACTIONS(13362),
    [anon_sym_LF] = ACTIONS(13364),
    [anon_sym_in] = ACTIONS(13362),
    [anon_sym_LBRACE] = ACTIONS(13362),
    [anon_sym_DOLLAR] = ACTIONS(13362),
    [anon_sym_COLON_COLON] = ACTIONS(13362),
    [anon_sym_isa] = ACTIONS(13362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13362),
    [anon_sym_QMARK] = ACTIONS(13362),
    [anon_sym_AT] = ACTIONS(13362),
    [anon_sym_true] = ACTIONS(13362),
    [anon_sym_false] = ACTIONS(13362),
    [aux_sym_integer_literal_token1] = ACTIONS(13362),
    [aux_sym_integer_literal_token2] = ACTIONS(13362),
    [aux_sym_integer_literal_token3] = ACTIONS(13362),
    [aux_sym_integer_literal_token4] = ACTIONS(13362),
    [aux_sym_float_literal_token1] = ACTIONS(13362),
    [aux_sym_float_literal_token3] = ACTIONS(13362),
    [aux_sym_float_literal_token4] = ACTIONS(13362),
    [sym_character_literal] = ACTIONS(13362),
    [sym__pair_operator] = ACTIONS(13362),
    [sym__arrow_operator] = ACTIONS(13362),
    [sym__lazy_or_operator] = ACTIONS(13362),
    [sym__lazy_and_operator] = ACTIONS(13362),
    [sym__comparison_operator] = ACTIONS(13362),
    [sym__pipe_right_operator] = ACTIONS(13362),
    [sym__pipe_left_operator] = ACTIONS(13362),
    [sym__ellipsis_operator] = ACTIONS(13362),
    [sym__plus_operator] = ACTIONS(13362),
    [sym__times_operator] = ACTIONS(13362),
    [sym__rational_operator] = ACTIONS(13362),
    [sym__bitshift_operator] = ACTIONS(13362),
    [sym__power_operator] = ACTIONS(13362),
    [sym__tilde_operator] = ACTIONS(13362),
    [sym__type_order_operator] = ACTIONS(13362),
    [sym__unary_operator] = ACTIONS(13362),
    [sym__unary_plus_operator] = ACTIONS(13362),
    [aux_sym__terminator_token1] = ACTIONS(13362),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13364),
    [sym__command_start] = ACTIONS(13364),
  },
  [8366] = {
    [sym__word_identifier] = ACTIONS(13366),
    [anon_sym_EQ] = ACTIONS(13366),
    [anon_sym_COMMA] = ACTIONS(13366),
    [anon_sym_COLON] = ACTIONS(13366),
    [anon_sym_begin] = ACTIONS(13366),
    [anon_sym_module] = ACTIONS(13366),
    [anon_sym_baremodule] = ACTIONS(13366),
    [anon_sym_abstract] = ACTIONS(13366),
    [anon_sym_primitive] = ACTIONS(13366),
    [anon_sym_mutable] = ACTIONS(13366),
    [anon_sym_struct] = ACTIONS(13366),
    [anon_sym_function] = ACTIONS(13366),
    [anon_sym_macro] = ACTIONS(13366),
    [anon_sym_where] = ACTIONS(13366),
    [anon_sym_quote] = ACTIONS(13366),
    [anon_sym_let] = ACTIONS(13366),
    [anon_sym_if] = ACTIONS(13366),
    [anon_sym_try] = ACTIONS(13366),
    [anon_sym_catch] = ACTIONS(13366),
    [anon_sym_finally] = ACTIONS(13366),
    [anon_sym_for] = ACTIONS(13366),
    [anon_sym_while] = ACTIONS(13366),
    [sym_break_statement] = ACTIONS(13366),
    [sym_continue_statement] = ACTIONS(13366),
    [anon_sym_return] = ACTIONS(13366),
    [anon_sym_const] = ACTIONS(13366),
    [anon_sym_global] = ACTIONS(13366),
    [anon_sym_local] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(13366),
    [anon_sym_COLON2] = ACTIONS(13366),
    [anon_sym_export] = ACTIONS(13366),
    [anon_sym_import] = ACTIONS(13366),
    [anon_sym_using] = ACTIONS(13366),
    [anon_sym_LBRACK] = ACTIONS(13366),
    [anon_sym_LF] = ACTIONS(13368),
    [anon_sym_in] = ACTIONS(13366),
    [anon_sym_LBRACE] = ACTIONS(13366),
    [anon_sym_DOLLAR] = ACTIONS(13366),
    [anon_sym_COLON_COLON] = ACTIONS(13366),
    [anon_sym_isa] = ACTIONS(13366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13366),
    [anon_sym_QMARK] = ACTIONS(13366),
    [anon_sym_AT] = ACTIONS(13366),
    [anon_sym_true] = ACTIONS(13366),
    [anon_sym_false] = ACTIONS(13366),
    [aux_sym_integer_literal_token1] = ACTIONS(13366),
    [aux_sym_integer_literal_token2] = ACTIONS(13366),
    [aux_sym_integer_literal_token3] = ACTIONS(13366),
    [aux_sym_integer_literal_token4] = ACTIONS(13366),
    [aux_sym_float_literal_token1] = ACTIONS(13366),
    [aux_sym_float_literal_token3] = ACTIONS(13366),
    [aux_sym_float_literal_token4] = ACTIONS(13366),
    [sym_character_literal] = ACTIONS(13366),
    [sym__pair_operator] = ACTIONS(13366),
    [sym__arrow_operator] = ACTIONS(13366),
    [sym__lazy_or_operator] = ACTIONS(13366),
    [sym__lazy_and_operator] = ACTIONS(13366),
    [sym__comparison_operator] = ACTIONS(13366),
    [sym__pipe_right_operator] = ACTIONS(13366),
    [sym__pipe_left_operator] = ACTIONS(13366),
    [sym__ellipsis_operator] = ACTIONS(13366),
    [sym__plus_operator] = ACTIONS(13366),
    [sym__times_operator] = ACTIONS(13366),
    [sym__rational_operator] = ACTIONS(13366),
    [sym__bitshift_operator] = ACTIONS(13366),
    [sym__power_operator] = ACTIONS(13366),
    [sym__tilde_operator] = ACTIONS(13366),
    [sym__type_order_operator] = ACTIONS(13366),
    [sym__unary_operator] = ACTIONS(13366),
    [sym__unary_plus_operator] = ACTIONS(13366),
    [aux_sym__terminator_token1] = ACTIONS(13366),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13368),
    [sym__command_start] = ACTIONS(13368),
  },
  [8367] = {
    [sym__word_identifier] = ACTIONS(13370),
    [anon_sym_EQ] = ACTIONS(13370),
    [anon_sym_COMMA] = ACTIONS(13370),
    [anon_sym_COLON] = ACTIONS(13370),
    [anon_sym_begin] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(13370),
    [anon_sym_baremodule] = ACTIONS(13370),
    [anon_sym_abstract] = ACTIONS(13370),
    [anon_sym_primitive] = ACTIONS(13370),
    [anon_sym_mutable] = ACTIONS(13370),
    [anon_sym_struct] = ACTIONS(13370),
    [anon_sym_function] = ACTIONS(13370),
    [anon_sym_macro] = ACTIONS(13370),
    [anon_sym_where] = ACTIONS(13370),
    [anon_sym_quote] = ACTIONS(13370),
    [anon_sym_let] = ACTIONS(13370),
    [anon_sym_if] = ACTIONS(13370),
    [anon_sym_try] = ACTIONS(13370),
    [anon_sym_catch] = ACTIONS(13370),
    [anon_sym_finally] = ACTIONS(13370),
    [anon_sym_for] = ACTIONS(13370),
    [anon_sym_while] = ACTIONS(13370),
    [sym_break_statement] = ACTIONS(13370),
    [sym_continue_statement] = ACTIONS(13370),
    [anon_sym_return] = ACTIONS(13370),
    [anon_sym_const] = ACTIONS(13370),
    [anon_sym_global] = ACTIONS(13370),
    [anon_sym_local] = ACTIONS(13370),
    [anon_sym_LPAREN] = ACTIONS(13370),
    [anon_sym_COLON2] = ACTIONS(13370),
    [anon_sym_export] = ACTIONS(13370),
    [anon_sym_import] = ACTIONS(13370),
    [anon_sym_using] = ACTIONS(13370),
    [anon_sym_LBRACK] = ACTIONS(13370),
    [anon_sym_LF] = ACTIONS(13372),
    [anon_sym_in] = ACTIONS(13370),
    [anon_sym_LBRACE] = ACTIONS(13370),
    [anon_sym_DOLLAR] = ACTIONS(13370),
    [anon_sym_COLON_COLON] = ACTIONS(13370),
    [anon_sym_isa] = ACTIONS(13370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13370),
    [anon_sym_QMARK] = ACTIONS(13370),
    [anon_sym_AT] = ACTIONS(13370),
    [anon_sym_true] = ACTIONS(13370),
    [anon_sym_false] = ACTIONS(13370),
    [aux_sym_integer_literal_token1] = ACTIONS(13370),
    [aux_sym_integer_literal_token2] = ACTIONS(13370),
    [aux_sym_integer_literal_token3] = ACTIONS(13370),
    [aux_sym_integer_literal_token4] = ACTIONS(13370),
    [aux_sym_float_literal_token1] = ACTIONS(13370),
    [aux_sym_float_literal_token3] = ACTIONS(13370),
    [aux_sym_float_literal_token4] = ACTIONS(13370),
    [sym_character_literal] = ACTIONS(13370),
    [sym__pair_operator] = ACTIONS(13370),
    [sym__arrow_operator] = ACTIONS(13370),
    [sym__lazy_or_operator] = ACTIONS(13370),
    [sym__lazy_and_operator] = ACTIONS(13370),
    [sym__comparison_operator] = ACTIONS(13370),
    [sym__pipe_right_operator] = ACTIONS(13370),
    [sym__pipe_left_operator] = ACTIONS(13370),
    [sym__ellipsis_operator] = ACTIONS(13370),
    [sym__plus_operator] = ACTIONS(13370),
    [sym__times_operator] = ACTIONS(13370),
    [sym__rational_operator] = ACTIONS(13370),
    [sym__bitshift_operator] = ACTIONS(13370),
    [sym__power_operator] = ACTIONS(13370),
    [sym__tilde_operator] = ACTIONS(13370),
    [sym__type_order_operator] = ACTIONS(13370),
    [sym__unary_operator] = ACTIONS(13370),
    [sym__unary_plus_operator] = ACTIONS(13370),
    [aux_sym__terminator_token1] = ACTIONS(13370),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13372),
    [sym__command_start] = ACTIONS(13372),
  },
  [8368] = {
    [sym__word_identifier] = ACTIONS(13374),
    [anon_sym_EQ] = ACTIONS(13374),
    [anon_sym_COMMA] = ACTIONS(13374),
    [anon_sym_COLON] = ACTIONS(13374),
    [anon_sym_begin] = ACTIONS(13374),
    [anon_sym_module] = ACTIONS(13374),
    [anon_sym_baremodule] = ACTIONS(13374),
    [anon_sym_abstract] = ACTIONS(13374),
    [anon_sym_primitive] = ACTIONS(13374),
    [anon_sym_mutable] = ACTIONS(13374),
    [anon_sym_struct] = ACTIONS(13374),
    [anon_sym_function] = ACTIONS(13374),
    [anon_sym_macro] = ACTIONS(13374),
    [anon_sym_where] = ACTIONS(13374),
    [anon_sym_quote] = ACTIONS(13374),
    [anon_sym_let] = ACTIONS(13374),
    [anon_sym_if] = ACTIONS(13374),
    [anon_sym_try] = ACTIONS(13374),
    [anon_sym_catch] = ACTIONS(13374),
    [anon_sym_finally] = ACTIONS(13374),
    [anon_sym_for] = ACTIONS(13374),
    [anon_sym_while] = ACTIONS(13374),
    [sym_break_statement] = ACTIONS(13374),
    [sym_continue_statement] = ACTIONS(13374),
    [anon_sym_return] = ACTIONS(13374),
    [anon_sym_const] = ACTIONS(13374),
    [anon_sym_global] = ACTIONS(13374),
    [anon_sym_local] = ACTIONS(13374),
    [anon_sym_LPAREN] = ACTIONS(13374),
    [anon_sym_COLON2] = ACTIONS(13374),
    [anon_sym_export] = ACTIONS(13374),
    [anon_sym_import] = ACTIONS(13374),
    [anon_sym_using] = ACTIONS(13374),
    [anon_sym_LBRACK] = ACTIONS(13374),
    [anon_sym_LF] = ACTIONS(13376),
    [anon_sym_in] = ACTIONS(13374),
    [anon_sym_LBRACE] = ACTIONS(13374),
    [anon_sym_DOLLAR] = ACTIONS(13374),
    [anon_sym_COLON_COLON] = ACTIONS(13374),
    [anon_sym_isa] = ACTIONS(13374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13374),
    [anon_sym_QMARK] = ACTIONS(13374),
    [anon_sym_AT] = ACTIONS(13374),
    [anon_sym_true] = ACTIONS(13374),
    [anon_sym_false] = ACTIONS(13374),
    [aux_sym_integer_literal_token1] = ACTIONS(13374),
    [aux_sym_integer_literal_token2] = ACTIONS(13374),
    [aux_sym_integer_literal_token3] = ACTIONS(13374),
    [aux_sym_integer_literal_token4] = ACTIONS(13374),
    [aux_sym_float_literal_token1] = ACTIONS(13374),
    [aux_sym_float_literal_token3] = ACTIONS(13374),
    [aux_sym_float_literal_token4] = ACTIONS(13374),
    [sym_character_literal] = ACTIONS(13374),
    [sym__pair_operator] = ACTIONS(13374),
    [sym__arrow_operator] = ACTIONS(13374),
    [sym__lazy_or_operator] = ACTIONS(13374),
    [sym__lazy_and_operator] = ACTIONS(13374),
    [sym__comparison_operator] = ACTIONS(13374),
    [sym__pipe_right_operator] = ACTIONS(13374),
    [sym__pipe_left_operator] = ACTIONS(13374),
    [sym__ellipsis_operator] = ACTIONS(13374),
    [sym__plus_operator] = ACTIONS(13374),
    [sym__times_operator] = ACTIONS(13374),
    [sym__rational_operator] = ACTIONS(13374),
    [sym__bitshift_operator] = ACTIONS(13374),
    [sym__power_operator] = ACTIONS(13374),
    [sym__tilde_operator] = ACTIONS(13374),
    [sym__type_order_operator] = ACTIONS(13374),
    [sym__unary_operator] = ACTIONS(13374),
    [sym__unary_plus_operator] = ACTIONS(13374),
    [aux_sym__terminator_token1] = ACTIONS(13374),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13376),
    [sym__command_start] = ACTIONS(13376),
  },
  [8369] = {
    [sym__word_identifier] = ACTIONS(13632),
    [anon_sym_EQ] = ACTIONS(13632),
    [anon_sym_COMMA] = ACTIONS(13634),
    [anon_sym_COLON] = ACTIONS(13632),
    [anon_sym_begin] = ACTIONS(13632),
    [anon_sym_module] = ACTIONS(13632),
    [anon_sym_baremodule] = ACTIONS(13632),
    [anon_sym_abstract] = ACTIONS(13632),
    [anon_sym_primitive] = ACTIONS(13632),
    [anon_sym_mutable] = ACTIONS(13632),
    [anon_sym_struct] = ACTIONS(13632),
    [anon_sym_function] = ACTIONS(13632),
    [anon_sym_macro] = ACTIONS(13632),
    [anon_sym_where] = ACTIONS(13632),
    [anon_sym_quote] = ACTIONS(13632),
    [anon_sym_let] = ACTIONS(13632),
    [anon_sym_if] = ACTIONS(13632),
    [anon_sym_try] = ACTIONS(13632),
    [anon_sym_for] = ACTIONS(13632),
    [anon_sym_while] = ACTIONS(13632),
    [sym_break_statement] = ACTIONS(13632),
    [sym_continue_statement] = ACTIONS(13632),
    [anon_sym_return] = ACTIONS(13632),
    [anon_sym_const] = ACTIONS(13632),
    [anon_sym_global] = ACTIONS(13632),
    [anon_sym_local] = ACTIONS(13632),
    [anon_sym_LPAREN] = ACTIONS(13634),
    [anon_sym_RPAREN] = ACTIONS(13634),
    [anon_sym_COLON2] = ACTIONS(13632),
    [anon_sym_export] = ACTIONS(13632),
    [anon_sym_import] = ACTIONS(13632),
    [anon_sym_using] = ACTIONS(13632),
    [anon_sym_LBRACK] = ACTIONS(13634),
    [anon_sym_RBRACK] = ACTIONS(13634),
    [anon_sym_in] = ACTIONS(13632),
    [anon_sym_SEMI] = ACTIONS(13634),
    [anon_sym_LBRACE] = ACTIONS(13634),
    [anon_sym_RBRACE] = ACTIONS(13634),
    [anon_sym_DOLLAR] = ACTIONS(13634),
    [anon_sym_COLON_COLON] = ACTIONS(13634),
    [anon_sym_isa] = ACTIONS(13632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13634),
    [anon_sym_QMARK] = ACTIONS(13634),
    [anon_sym_AT] = ACTIONS(13634),
    [anon_sym_true] = ACTIONS(13632),
    [anon_sym_false] = ACTIONS(13632),
    [aux_sym_integer_literal_token1] = ACTIONS(13634),
    [aux_sym_integer_literal_token2] = ACTIONS(13634),
    [aux_sym_integer_literal_token3] = ACTIONS(13632),
    [aux_sym_integer_literal_token4] = ACTIONS(13632),
    [aux_sym_float_literal_token1] = ACTIONS(13634),
    [aux_sym_float_literal_token3] = ACTIONS(13634),
    [aux_sym_float_literal_token4] = ACTIONS(13634),
    [sym_character_literal] = ACTIONS(13634),
    [sym__pair_operator] = ACTIONS(13634),
    [sym__arrow_operator] = ACTIONS(13632),
    [sym__lazy_or_operator] = ACTIONS(13634),
    [sym__lazy_and_operator] = ACTIONS(13634),
    [sym__comparison_operator] = ACTIONS(13632),
    [sym__pipe_right_operator] = ACTIONS(13634),
    [sym__pipe_left_operator] = ACTIONS(13634),
    [sym__ellipsis_operator] = ACTIONS(13632),
    [sym__plus_operator] = ACTIONS(13632),
    [sym__times_operator] = ACTIONS(13632),
    [sym__rational_operator] = ACTIONS(13634),
    [sym__bitshift_operator] = ACTIONS(13634),
    [sym__power_operator] = ACTIONS(13634),
    [sym__tilde_operator] = ACTIONS(13634),
    [sym__type_order_operator] = ACTIONS(13634),
    [sym__unary_operator] = ACTIONS(13632),
    [sym__unary_plus_operator] = ACTIONS(13632),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13634),
    [sym__command_start] = ACTIONS(13634),
  },
  [8370] = {
    [sym__word_identifier] = ACTIONS(13636),
    [anon_sym_EQ] = ACTIONS(13636),
    [anon_sym_COMMA] = ACTIONS(13638),
    [anon_sym_COLON] = ACTIONS(13636),
    [anon_sym_begin] = ACTIONS(13636),
    [anon_sym_module] = ACTIONS(13636),
    [anon_sym_baremodule] = ACTIONS(13636),
    [anon_sym_abstract] = ACTIONS(13636),
    [anon_sym_primitive] = ACTIONS(13636),
    [anon_sym_mutable] = ACTIONS(13636),
    [anon_sym_struct] = ACTIONS(13636),
    [anon_sym_function] = ACTIONS(13636),
    [anon_sym_macro] = ACTIONS(13636),
    [anon_sym_where] = ACTIONS(13636),
    [anon_sym_quote] = ACTIONS(13636),
    [anon_sym_let] = ACTIONS(13636),
    [anon_sym_if] = ACTIONS(13636),
    [anon_sym_try] = ACTIONS(13636),
    [anon_sym_for] = ACTIONS(13636),
    [anon_sym_while] = ACTIONS(13636),
    [sym_break_statement] = ACTIONS(13636),
    [sym_continue_statement] = ACTIONS(13636),
    [anon_sym_return] = ACTIONS(13636),
    [anon_sym_const] = ACTIONS(13636),
    [anon_sym_global] = ACTIONS(13636),
    [anon_sym_local] = ACTIONS(13636),
    [anon_sym_LPAREN] = ACTIONS(13638),
    [anon_sym_RPAREN] = ACTIONS(13638),
    [anon_sym_COLON2] = ACTIONS(13636),
    [anon_sym_export] = ACTIONS(13636),
    [anon_sym_import] = ACTIONS(13636),
    [anon_sym_using] = ACTIONS(13636),
    [anon_sym_LBRACK] = ACTIONS(13638),
    [anon_sym_RBRACK] = ACTIONS(13638),
    [anon_sym_in] = ACTIONS(13636),
    [anon_sym_SEMI] = ACTIONS(13638),
    [anon_sym_LBRACE] = ACTIONS(13638),
    [anon_sym_RBRACE] = ACTIONS(13638),
    [anon_sym_DOLLAR] = ACTIONS(13638),
    [anon_sym_COLON_COLON] = ACTIONS(13638),
    [anon_sym_isa] = ACTIONS(13636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13638),
    [anon_sym_QMARK] = ACTIONS(13638),
    [anon_sym_AT] = ACTIONS(13638),
    [anon_sym_true] = ACTIONS(13636),
    [anon_sym_false] = ACTIONS(13636),
    [aux_sym_integer_literal_token1] = ACTIONS(13638),
    [aux_sym_integer_literal_token2] = ACTIONS(13638),
    [aux_sym_integer_literal_token3] = ACTIONS(13636),
    [aux_sym_integer_literal_token4] = ACTIONS(13636),
    [aux_sym_float_literal_token1] = ACTIONS(13638),
    [aux_sym_float_literal_token3] = ACTIONS(13638),
    [aux_sym_float_literal_token4] = ACTIONS(13638),
    [sym_character_literal] = ACTIONS(13638),
    [sym__pair_operator] = ACTIONS(13638),
    [sym__arrow_operator] = ACTIONS(13636),
    [sym__lazy_or_operator] = ACTIONS(13638),
    [sym__lazy_and_operator] = ACTIONS(13638),
    [sym__comparison_operator] = ACTIONS(13636),
    [sym__pipe_right_operator] = ACTIONS(13638),
    [sym__pipe_left_operator] = ACTIONS(13638),
    [sym__ellipsis_operator] = ACTIONS(13636),
    [sym__plus_operator] = ACTIONS(13636),
    [sym__times_operator] = ACTIONS(13636),
    [sym__rational_operator] = ACTIONS(13638),
    [sym__bitshift_operator] = ACTIONS(13638),
    [sym__power_operator] = ACTIONS(13638),
    [sym__tilde_operator] = ACTIONS(13638),
    [sym__type_order_operator] = ACTIONS(13638),
    [sym__unary_operator] = ACTIONS(13636),
    [sym__unary_plus_operator] = ACTIONS(13636),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13638),
    [sym__command_start] = ACTIONS(13638),
  },
  [8371] = {
    [aux_sym_open_tuple_repeat1] = STATE(8371),
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(14620),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_end] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13070),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(13070),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13070),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(13070),
    [anon_sym_isa] = ACTIONS(13070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13070),
    [anon_sym_QMARK] = ACTIONS(13070),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(13070),
    [sym__arrow_operator] = ACTIONS(13070),
    [sym__lazy_or_operator] = ACTIONS(13070),
    [sym__lazy_and_operator] = ACTIONS(13070),
    [sym__comparison_operator] = ACTIONS(13070),
    [sym__pipe_right_operator] = ACTIONS(13070),
    [sym__pipe_left_operator] = ACTIONS(13070),
    [sym__ellipsis_operator] = ACTIONS(13070),
    [sym__plus_operator] = ACTIONS(13070),
    [sym__times_operator] = ACTIONS(13070),
    [sym__rational_operator] = ACTIONS(13070),
    [sym__bitshift_operator] = ACTIONS(13070),
    [sym__power_operator] = ACTIONS(13070),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(13070),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13070),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [8372] = {
    [sym__primary_expression] = STATE(11491),
    [sym__array] = STATE(11491),
    [sym_comprehension_expression] = STATE(11491),
    [sym_matrix_expression] = STATE(11491),
    [sym_vector_expression] = STATE(11491),
    [sym_parenthesized_expression] = STATE(11491),
    [sym_tuple_expression] = STATE(11491),
    [sym_curly_expression] = STATE(11491),
    [sym_adjoint_expression] = STATE(11491),
    [sym_field_expression] = STATE(11491),
    [sym_index_expression] = STATE(11491),
    [sym_parametrized_type_expression] = STATE(11491),
    [sym_call_expression] = STATE(11491),
    [sym_broadcast_call_expression] = STATE(11491),
    [sym__closed_macrocall_expression] = STATE(11491),
    [sym_interpolation_expression] = STATE(11491),
    [sym_quote_expression] = STATE(11491),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(11326),
    [sym_boolean_literal] = STATE(11491),
    [sym__string] = STATE(11491),
    [sym_string_literal] = STATE(11491),
    [sym_command_literal] = STATE(11491),
    [sym_prefixed_string_literal] = STATE(11491),
    [sym_prefixed_command_literal] = STATE(11491),
    [sym_operator] = STATE(19313),
    [ts_builtin_sym_end] = ACTIONS(171),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(14623),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(14625),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(14627),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11139),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(91),
    [sym__lazy_and_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11139),
    [sym__pipe_left_operator] = ACTIONS(11139),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11139),
    [sym__type_order_operator] = ACTIONS(11139),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [8373] = {
    [sym__word_identifier] = ACTIONS(13640),
    [anon_sym_EQ] = ACTIONS(13640),
    [anon_sym_COMMA] = ACTIONS(13642),
    [anon_sym_COLON] = ACTIONS(13640),
    [anon_sym_begin] = ACTIONS(13640),
    [anon_sym_module] = ACTIONS(13640),
    [anon_sym_baremodule] = ACTIONS(13640),
    [anon_sym_abstract] = ACTIONS(13640),
    [anon_sym_primitive] = ACTIONS(13640),
    [anon_sym_mutable] = ACTIONS(13640),
    [anon_sym_struct] = ACTIONS(13640),
    [anon_sym_function] = ACTIONS(13640),
    [anon_sym_macro] = ACTIONS(13640),
    [anon_sym_where] = ACTIONS(13640),
    [anon_sym_quote] = ACTIONS(13640),
    [anon_sym_let] = ACTIONS(13640),
    [anon_sym_if] = ACTIONS(13640),
    [anon_sym_try] = ACTIONS(13640),
    [anon_sym_for] = ACTIONS(13640),
    [anon_sym_while] = ACTIONS(13640),
    [sym_break_statement] = ACTIONS(13640),
    [sym_continue_statement] = ACTIONS(13640),
    [anon_sym_return] = ACTIONS(13640),
    [anon_sym_const] = ACTIONS(13640),
    [anon_sym_global] = ACTIONS(13640),
    [anon_sym_local] = ACTIONS(13640),
    [anon_sym_LPAREN] = ACTIONS(13642),
    [anon_sym_RPAREN] = ACTIONS(13642),
    [anon_sym_COLON2] = ACTIONS(13640),
    [anon_sym_export] = ACTIONS(13640),
    [anon_sym_import] = ACTIONS(13640),
    [anon_sym_using] = ACTIONS(13640),
    [anon_sym_LBRACK] = ACTIONS(13642),
    [anon_sym_RBRACK] = ACTIONS(13642),
    [anon_sym_in] = ACTIONS(13640),
    [anon_sym_SEMI] = ACTIONS(13642),
    [anon_sym_LBRACE] = ACTIONS(13642),
    [anon_sym_RBRACE] = ACTIONS(13642),
    [anon_sym_DOLLAR] = ACTIONS(13642),
    [anon_sym_COLON_COLON] = ACTIONS(13642),
    [anon_sym_isa] = ACTIONS(13640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13642),
    [anon_sym_QMARK] = ACTIONS(13642),
    [anon_sym_AT] = ACTIONS(13642),
    [anon_sym_true] = ACTIONS(13640),
    [anon_sym_false] = ACTIONS(13640),
    [aux_sym_integer_literal_token1] = ACTIONS(13642),
    [aux_sym_integer_literal_token2] = ACTIONS(13642),
    [aux_sym_integer_literal_token3] = ACTIONS(13640),
    [aux_sym_integer_literal_token4] = ACTIONS(13640),
    [aux_sym_float_literal_token1] = ACTIONS(13642),
    [aux_sym_float_literal_token3] = ACTIONS(13642),
    [aux_sym_float_literal_token4] = ACTIONS(13642),
    [sym_character_literal] = ACTIONS(13642),
    [sym__pair_operator] = ACTIONS(13642),
    [sym__arrow_operator] = ACTIONS(13640),
    [sym__lazy_or_operator] = ACTIONS(13642),
    [sym__lazy_and_operator] = ACTIONS(13642),
    [sym__comparison_operator] = ACTIONS(13640),
    [sym__pipe_right_operator] = ACTIONS(13642),
    [sym__pipe_left_operator] = ACTIONS(13642),
    [sym__ellipsis_operator] = ACTIONS(13640),
    [sym__plus_operator] = ACTIONS(13640),
    [sym__times_operator] = ACTIONS(13640),
    [sym__rational_operator] = ACTIONS(13642),
    [sym__bitshift_operator] = ACTIONS(13642),
    [sym__power_operator] = ACTIONS(13642),
    [sym__tilde_operator] = ACTIONS(13642),
    [sym__type_order_operator] = ACTIONS(13642),
    [sym__unary_operator] = ACTIONS(13640),
    [sym__unary_plus_operator] = ACTIONS(13640),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13642),
    [sym__command_start] = ACTIONS(13642),
  },
  [8374] = {
    [ts_builtin_sym_end] = ACTIONS(13340),
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14517),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_RPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14519),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_RBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14521),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(14521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14629),
    [sym__arrow_operator] = ACTIONS(14631),
    [sym__lazy_or_operator] = ACTIONS(14633),
    [sym__lazy_and_operator] = ACTIONS(14523),
    [sym__comparison_operator] = ACTIONS(14521),
    [sym__pipe_right_operator] = ACTIONS(14525),
    [sym__pipe_left_operator] = ACTIONS(14527),
    [sym__ellipsis_operator] = ACTIONS(14529),
    [sym__plus_operator] = ACTIONS(14531),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14521),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14531),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [8375] = {
    [sym__word_identifier] = ACTIONS(13378),
    [anon_sym_EQ] = ACTIONS(13378),
    [anon_sym_COMMA] = ACTIONS(13378),
    [anon_sym_COLON] = ACTIONS(13378),
    [anon_sym_begin] = ACTIONS(13378),
    [anon_sym_module] = ACTIONS(13378),
    [anon_sym_baremodule] = ACTIONS(13378),
    [anon_sym_abstract] = ACTIONS(13378),
    [anon_sym_primitive] = ACTIONS(13378),
    [anon_sym_mutable] = ACTIONS(13378),
    [anon_sym_struct] = ACTIONS(13378),
    [anon_sym_function] = ACTIONS(13378),
    [anon_sym_macro] = ACTIONS(13378),
    [anon_sym_where] = ACTIONS(13378),
    [anon_sym_quote] = ACTIONS(13378),
    [anon_sym_let] = ACTIONS(13378),
    [anon_sym_if] = ACTIONS(13378),
    [anon_sym_try] = ACTIONS(13378),
    [anon_sym_catch] = ACTIONS(13378),
    [anon_sym_finally] = ACTIONS(13378),
    [anon_sym_for] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(13378),
    [sym_break_statement] = ACTIONS(13378),
    [sym_continue_statement] = ACTIONS(13378),
    [anon_sym_return] = ACTIONS(13378),
    [anon_sym_const] = ACTIONS(13378),
    [anon_sym_global] = ACTIONS(13378),
    [anon_sym_local] = ACTIONS(13378),
    [anon_sym_LPAREN] = ACTIONS(13378),
    [anon_sym_COLON2] = ACTIONS(13378),
    [anon_sym_export] = ACTIONS(13378),
    [anon_sym_import] = ACTIONS(13378),
    [anon_sym_using] = ACTIONS(13378),
    [anon_sym_LBRACK] = ACTIONS(13378),
    [anon_sym_LF] = ACTIONS(13380),
    [anon_sym_in] = ACTIONS(13378),
    [anon_sym_LBRACE] = ACTIONS(13378),
    [anon_sym_DOLLAR] = ACTIONS(13378),
    [anon_sym_COLON_COLON] = ACTIONS(13378),
    [anon_sym_isa] = ACTIONS(13378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13378),
    [anon_sym_QMARK] = ACTIONS(13378),
    [anon_sym_AT] = ACTIONS(13378),
    [anon_sym_true] = ACTIONS(13378),
    [anon_sym_false] = ACTIONS(13378),
    [aux_sym_integer_literal_token1] = ACTIONS(13378),
    [aux_sym_integer_literal_token2] = ACTIONS(13378),
    [aux_sym_integer_literal_token3] = ACTIONS(13378),
    [aux_sym_integer_literal_token4] = ACTIONS(13378),
    [aux_sym_float_literal_token1] = ACTIONS(13378),
    [aux_sym_float_literal_token3] = ACTIONS(13378),
    [aux_sym_float_literal_token4] = ACTIONS(13378),
    [sym_character_literal] = ACTIONS(13378),
    [sym__pair_operator] = ACTIONS(13378),
    [sym__arrow_operator] = ACTIONS(13378),
    [sym__lazy_or_operator] = ACTIONS(13378),
    [sym__lazy_and_operator] = ACTIONS(13378),
    [sym__comparison_operator] = ACTIONS(13378),
    [sym__pipe_right_operator] = ACTIONS(13378),
    [sym__pipe_left_operator] = ACTIONS(13378),
    [sym__ellipsis_operator] = ACTIONS(13378),
    [sym__plus_operator] = ACTIONS(13378),
    [sym__times_operator] = ACTIONS(13378),
    [sym__rational_operator] = ACTIONS(13378),
    [sym__bitshift_operator] = ACTIONS(13378),
    [sym__power_operator] = ACTIONS(13378),
    [sym__tilde_operator] = ACTIONS(13378),
    [sym__type_order_operator] = ACTIONS(13378),
    [sym__unary_operator] = ACTIONS(13378),
    [sym__unary_plus_operator] = ACTIONS(13378),
    [aux_sym__terminator_token1] = ACTIONS(13378),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13380),
    [sym__command_start] = ACTIONS(13380),
  },
  [8376] = {
    [sym__word_identifier] = ACTIONS(13382),
    [anon_sym_EQ] = ACTIONS(13382),
    [anon_sym_COMMA] = ACTIONS(13382),
    [anon_sym_COLON] = ACTIONS(13382),
    [anon_sym_begin] = ACTIONS(13382),
    [anon_sym_module] = ACTIONS(13382),
    [anon_sym_baremodule] = ACTIONS(13382),
    [anon_sym_abstract] = ACTIONS(13382),
    [anon_sym_primitive] = ACTIONS(13382),
    [anon_sym_mutable] = ACTIONS(13382),
    [anon_sym_struct] = ACTIONS(13382),
    [anon_sym_function] = ACTIONS(13382),
    [anon_sym_macro] = ACTIONS(13382),
    [anon_sym_where] = ACTIONS(13382),
    [anon_sym_quote] = ACTIONS(13382),
    [anon_sym_let] = ACTIONS(13382),
    [anon_sym_if] = ACTIONS(13382),
    [anon_sym_try] = ACTIONS(13382),
    [anon_sym_catch] = ACTIONS(13382),
    [anon_sym_finally] = ACTIONS(13382),
    [anon_sym_for] = ACTIONS(13382),
    [anon_sym_while] = ACTIONS(13382),
    [sym_break_statement] = ACTIONS(13382),
    [sym_continue_statement] = ACTIONS(13382),
    [anon_sym_return] = ACTIONS(13382),
    [anon_sym_const] = ACTIONS(13382),
    [anon_sym_global] = ACTIONS(13382),
    [anon_sym_local] = ACTIONS(13382),
    [anon_sym_LPAREN] = ACTIONS(13382),
    [anon_sym_COLON2] = ACTIONS(13382),
    [anon_sym_export] = ACTIONS(13382),
    [anon_sym_import] = ACTIONS(13382),
    [anon_sym_using] = ACTIONS(13382),
    [anon_sym_LBRACK] = ACTIONS(13382),
    [anon_sym_LF] = ACTIONS(13384),
    [anon_sym_in] = ACTIONS(13382),
    [anon_sym_LBRACE] = ACTIONS(13382),
    [anon_sym_DOLLAR] = ACTIONS(13382),
    [anon_sym_COLON_COLON] = ACTIONS(13382),
    [anon_sym_isa] = ACTIONS(13382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13382),
    [anon_sym_QMARK] = ACTIONS(13382),
    [anon_sym_AT] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(13382),
    [anon_sym_false] = ACTIONS(13382),
    [aux_sym_integer_literal_token1] = ACTIONS(13382),
    [aux_sym_integer_literal_token2] = ACTIONS(13382),
    [aux_sym_integer_literal_token3] = ACTIONS(13382),
    [aux_sym_integer_literal_token4] = ACTIONS(13382),
    [aux_sym_float_literal_token1] = ACTIONS(13382),
    [aux_sym_float_literal_token3] = ACTIONS(13382),
    [aux_sym_float_literal_token4] = ACTIONS(13382),
    [sym_character_literal] = ACTIONS(13382),
    [sym__pair_operator] = ACTIONS(13382),
    [sym__arrow_operator] = ACTIONS(13382),
    [sym__lazy_or_operator] = ACTIONS(13382),
    [sym__lazy_and_operator] = ACTIONS(13382),
    [sym__comparison_operator] = ACTIONS(13382),
    [sym__pipe_right_operator] = ACTIONS(13382),
    [sym__pipe_left_operator] = ACTIONS(13382),
    [sym__ellipsis_operator] = ACTIONS(13382),
    [sym__plus_operator] = ACTIONS(13382),
    [sym__times_operator] = ACTIONS(13382),
    [sym__rational_operator] = ACTIONS(13382),
    [sym__bitshift_operator] = ACTIONS(13382),
    [sym__power_operator] = ACTIONS(13382),
    [sym__tilde_operator] = ACTIONS(13382),
    [sym__type_order_operator] = ACTIONS(13382),
    [sym__unary_operator] = ACTIONS(13382),
    [sym__unary_plus_operator] = ACTIONS(13382),
    [aux_sym__terminator_token1] = ACTIONS(13382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13384),
    [sym__command_start] = ACTIONS(13384),
  },
  [8377] = {
    [sym__word_identifier] = ACTIONS(13386),
    [anon_sym_EQ] = ACTIONS(13386),
    [anon_sym_COMMA] = ACTIONS(13386),
    [anon_sym_COLON] = ACTIONS(13386),
    [anon_sym_begin] = ACTIONS(13386),
    [anon_sym_module] = ACTIONS(13386),
    [anon_sym_baremodule] = ACTIONS(13386),
    [anon_sym_abstract] = ACTIONS(13386),
    [anon_sym_primitive] = ACTIONS(13386),
    [anon_sym_mutable] = ACTIONS(13386),
    [anon_sym_struct] = ACTIONS(13386),
    [anon_sym_function] = ACTIONS(13386),
    [anon_sym_macro] = ACTIONS(13386),
    [anon_sym_where] = ACTIONS(13386),
    [anon_sym_quote] = ACTIONS(13386),
    [anon_sym_let] = ACTIONS(13386),
    [anon_sym_if] = ACTIONS(13386),
    [anon_sym_try] = ACTIONS(13386),
    [anon_sym_catch] = ACTIONS(13386),
    [anon_sym_finally] = ACTIONS(13386),
    [anon_sym_for] = ACTIONS(13386),
    [anon_sym_while] = ACTIONS(13386),
    [sym_break_statement] = ACTIONS(13386),
    [sym_continue_statement] = ACTIONS(13386),
    [anon_sym_return] = ACTIONS(13386),
    [anon_sym_const] = ACTIONS(13386),
    [anon_sym_global] = ACTIONS(13386),
    [anon_sym_local] = ACTIONS(13386),
    [anon_sym_LPAREN] = ACTIONS(13386),
    [anon_sym_COLON2] = ACTIONS(13386),
    [anon_sym_export] = ACTIONS(13386),
    [anon_sym_import] = ACTIONS(13386),
    [anon_sym_using] = ACTIONS(13386),
    [anon_sym_LBRACK] = ACTIONS(13386),
    [anon_sym_LF] = ACTIONS(13388),
    [anon_sym_in] = ACTIONS(13386),
    [anon_sym_LBRACE] = ACTIONS(13386),
    [anon_sym_DOLLAR] = ACTIONS(13386),
    [anon_sym_COLON_COLON] = ACTIONS(13386),
    [anon_sym_isa] = ACTIONS(13386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13386),
    [anon_sym_QMARK] = ACTIONS(13386),
    [anon_sym_AT] = ACTIONS(13386),
    [anon_sym_true] = ACTIONS(13386),
    [anon_sym_false] = ACTIONS(13386),
    [aux_sym_integer_literal_token1] = ACTIONS(13386),
    [aux_sym_integer_literal_token2] = ACTIONS(13386),
    [aux_sym_integer_literal_token3] = ACTIONS(13386),
    [aux_sym_integer_literal_token4] = ACTIONS(13386),
    [aux_sym_float_literal_token1] = ACTIONS(13386),
    [aux_sym_float_literal_token3] = ACTIONS(13386),
    [aux_sym_float_literal_token4] = ACTIONS(13386),
    [sym_character_literal] = ACTIONS(13386),
    [sym__pair_operator] = ACTIONS(13386),
    [sym__arrow_operator] = ACTIONS(13386),
    [sym__lazy_or_operator] = ACTIONS(13386),
    [sym__lazy_and_operator] = ACTIONS(13386),
    [sym__comparison_operator] = ACTIONS(13386),
    [sym__pipe_right_operator] = ACTIONS(13386),
    [sym__pipe_left_operator] = ACTIONS(13386),
    [sym__ellipsis_operator] = ACTIONS(13386),
    [sym__plus_operator] = ACTIONS(13386),
    [sym__times_operator] = ACTIONS(13386),
    [sym__rational_operator] = ACTIONS(13386),
    [sym__bitshift_operator] = ACTIONS(13386),
    [sym__power_operator] = ACTIONS(13386),
    [sym__tilde_operator] = ACTIONS(13386),
    [sym__type_order_operator] = ACTIONS(13386),
    [sym__unary_operator] = ACTIONS(13386),
    [sym__unary_plus_operator] = ACTIONS(13386),
    [aux_sym__terminator_token1] = ACTIONS(13386),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13388),
    [sym__command_start] = ACTIONS(13388),
  },
  [8378] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13247),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13247),
    [anon_sym_RPAREN] = ACTIONS(13247),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13247),
    [anon_sym_RBRACK] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_SEMI] = ACTIONS(13247),
    [anon_sym_LBRACE] = ACTIONS(13247),
    [anon_sym_RBRACE] = ACTIONS(13247),
    [anon_sym_DOLLAR] = ACTIONS(13247),
    [anon_sym_COLON_COLON] = ACTIONS(13247),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13247),
    [anon_sym_QMARK] = ACTIONS(13247),
    [anon_sym_AT] = ACTIONS(13247),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13247),
    [aux_sym_integer_literal_token2] = ACTIONS(13247),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13247),
    [aux_sym_float_literal_token3] = ACTIONS(13247),
    [aux_sym_float_literal_token4] = ACTIONS(13247),
    [sym_character_literal] = ACTIONS(13247),
    [sym__pair_operator] = ACTIONS(13247),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13247),
    [sym__lazy_and_operator] = ACTIONS(13247),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13247),
    [sym__pipe_left_operator] = ACTIONS(13247),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13247),
    [sym__bitshift_operator] = ACTIONS(13247),
    [sym__power_operator] = ACTIONS(13247),
    [sym__tilde_operator] = ACTIONS(13247),
    [sym__type_order_operator] = ACTIONS(13247),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8379] = {
    [sym__word_identifier] = ACTIONS(13390),
    [anon_sym_EQ] = ACTIONS(13390),
    [anon_sym_COMMA] = ACTIONS(13390),
    [anon_sym_COLON] = ACTIONS(13390),
    [anon_sym_begin] = ACTIONS(13390),
    [anon_sym_module] = ACTIONS(13390),
    [anon_sym_baremodule] = ACTIONS(13390),
    [anon_sym_abstract] = ACTIONS(13390),
    [anon_sym_primitive] = ACTIONS(13390),
    [anon_sym_mutable] = ACTIONS(13390),
    [anon_sym_struct] = ACTIONS(13390),
    [anon_sym_function] = ACTIONS(13390),
    [anon_sym_macro] = ACTIONS(13390),
    [anon_sym_where] = ACTIONS(13390),
    [anon_sym_quote] = ACTIONS(13390),
    [anon_sym_let] = ACTIONS(13390),
    [anon_sym_if] = ACTIONS(13390),
    [anon_sym_try] = ACTIONS(13390),
    [anon_sym_catch] = ACTIONS(13390),
    [anon_sym_finally] = ACTIONS(13390),
    [anon_sym_for] = ACTIONS(13390),
    [anon_sym_while] = ACTIONS(13390),
    [sym_break_statement] = ACTIONS(13390),
    [sym_continue_statement] = ACTIONS(13390),
    [anon_sym_return] = ACTIONS(13390),
    [anon_sym_const] = ACTIONS(13390),
    [anon_sym_global] = ACTIONS(13390),
    [anon_sym_local] = ACTIONS(13390),
    [anon_sym_LPAREN] = ACTIONS(13390),
    [anon_sym_COLON2] = ACTIONS(13390),
    [anon_sym_export] = ACTIONS(13390),
    [anon_sym_import] = ACTIONS(13390),
    [anon_sym_using] = ACTIONS(13390),
    [anon_sym_LBRACK] = ACTIONS(13390),
    [anon_sym_LF] = ACTIONS(13392),
    [anon_sym_in] = ACTIONS(13390),
    [anon_sym_LBRACE] = ACTIONS(13390),
    [anon_sym_DOLLAR] = ACTIONS(13390),
    [anon_sym_COLON_COLON] = ACTIONS(13390),
    [anon_sym_isa] = ACTIONS(13390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13390),
    [anon_sym_QMARK] = ACTIONS(13390),
    [anon_sym_AT] = ACTIONS(13390),
    [anon_sym_true] = ACTIONS(13390),
    [anon_sym_false] = ACTIONS(13390),
    [aux_sym_integer_literal_token1] = ACTIONS(13390),
    [aux_sym_integer_literal_token2] = ACTIONS(13390),
    [aux_sym_integer_literal_token3] = ACTIONS(13390),
    [aux_sym_integer_literal_token4] = ACTIONS(13390),
    [aux_sym_float_literal_token1] = ACTIONS(13390),
    [aux_sym_float_literal_token3] = ACTIONS(13390),
    [aux_sym_float_literal_token4] = ACTIONS(13390),
    [sym_character_literal] = ACTIONS(13390),
    [sym__pair_operator] = ACTIONS(13390),
    [sym__arrow_operator] = ACTIONS(13390),
    [sym__lazy_or_operator] = ACTIONS(13390),
    [sym__lazy_and_operator] = ACTIONS(13390),
    [sym__comparison_operator] = ACTIONS(13390),
    [sym__pipe_right_operator] = ACTIONS(13390),
    [sym__pipe_left_operator] = ACTIONS(13390),
    [sym__ellipsis_operator] = ACTIONS(13390),
    [sym__plus_operator] = ACTIONS(13390),
    [sym__times_operator] = ACTIONS(13390),
    [sym__rational_operator] = ACTIONS(13390),
    [sym__bitshift_operator] = ACTIONS(13390),
    [sym__power_operator] = ACTIONS(13390),
    [sym__tilde_operator] = ACTIONS(13390),
    [sym__type_order_operator] = ACTIONS(13390),
    [sym__unary_operator] = ACTIONS(13390),
    [sym__unary_plus_operator] = ACTIONS(13390),
    [aux_sym__terminator_token1] = ACTIONS(13390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13392),
    [sym__command_start] = ACTIONS(13392),
  },
  [8380] = {
    [sym__word_identifier] = ACTIONS(13396),
    [anon_sym_EQ] = ACTIONS(13396),
    [anon_sym_COMMA] = ACTIONS(13396),
    [anon_sym_COLON] = ACTIONS(13396),
    [anon_sym_begin] = ACTIONS(13396),
    [anon_sym_module] = ACTIONS(13396),
    [anon_sym_baremodule] = ACTIONS(13396),
    [anon_sym_abstract] = ACTIONS(13396),
    [anon_sym_primitive] = ACTIONS(13396),
    [anon_sym_mutable] = ACTIONS(13396),
    [anon_sym_struct] = ACTIONS(13396),
    [anon_sym_function] = ACTIONS(13396),
    [anon_sym_macro] = ACTIONS(13396),
    [anon_sym_where] = ACTIONS(13396),
    [anon_sym_quote] = ACTIONS(13396),
    [anon_sym_let] = ACTIONS(13396),
    [anon_sym_if] = ACTIONS(13396),
    [anon_sym_try] = ACTIONS(13396),
    [anon_sym_catch] = ACTIONS(13396),
    [anon_sym_finally] = ACTIONS(13396),
    [anon_sym_for] = ACTIONS(13396),
    [anon_sym_while] = ACTIONS(13396),
    [sym_break_statement] = ACTIONS(13396),
    [sym_continue_statement] = ACTIONS(13396),
    [anon_sym_return] = ACTIONS(13396),
    [anon_sym_const] = ACTIONS(13396),
    [anon_sym_global] = ACTIONS(13396),
    [anon_sym_local] = ACTIONS(13396),
    [anon_sym_LPAREN] = ACTIONS(13396),
    [anon_sym_COLON2] = ACTIONS(13396),
    [anon_sym_export] = ACTIONS(13396),
    [anon_sym_import] = ACTIONS(13396),
    [anon_sym_using] = ACTIONS(13396),
    [anon_sym_LBRACK] = ACTIONS(13396),
    [anon_sym_LF] = ACTIONS(13398),
    [anon_sym_in] = ACTIONS(13396),
    [anon_sym_LBRACE] = ACTIONS(13396),
    [anon_sym_DOLLAR] = ACTIONS(13396),
    [anon_sym_COLON_COLON] = ACTIONS(13396),
    [anon_sym_isa] = ACTIONS(13396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13396),
    [anon_sym_QMARK] = ACTIONS(13396),
    [anon_sym_AT] = ACTIONS(13396),
    [anon_sym_true] = ACTIONS(13396),
    [anon_sym_false] = ACTIONS(13396),
    [aux_sym_integer_literal_token1] = ACTIONS(13396),
    [aux_sym_integer_literal_token2] = ACTIONS(13396),
    [aux_sym_integer_literal_token3] = ACTIONS(13396),
    [aux_sym_integer_literal_token4] = ACTIONS(13396),
    [aux_sym_float_literal_token1] = ACTIONS(13396),
    [aux_sym_float_literal_token3] = ACTIONS(13396),
    [aux_sym_float_literal_token4] = ACTIONS(13396),
    [sym_character_literal] = ACTIONS(13396),
    [sym__pair_operator] = ACTIONS(13396),
    [sym__arrow_operator] = ACTIONS(13396),
    [sym__lazy_or_operator] = ACTIONS(13396),
    [sym__lazy_and_operator] = ACTIONS(13396),
    [sym__comparison_operator] = ACTIONS(13396),
    [sym__pipe_right_operator] = ACTIONS(13396),
    [sym__pipe_left_operator] = ACTIONS(13396),
    [sym__ellipsis_operator] = ACTIONS(13396),
    [sym__plus_operator] = ACTIONS(13396),
    [sym__times_operator] = ACTIONS(13396),
    [sym__rational_operator] = ACTIONS(13396),
    [sym__bitshift_operator] = ACTIONS(13396),
    [sym__power_operator] = ACTIONS(13396),
    [sym__tilde_operator] = ACTIONS(13396),
    [sym__type_order_operator] = ACTIONS(13396),
    [sym__unary_operator] = ACTIONS(13396),
    [sym__unary_plus_operator] = ACTIONS(13396),
    [aux_sym__terminator_token1] = ACTIONS(13396),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13398),
    [sym__command_start] = ACTIONS(13398),
  },
  [8381] = {
    [sym__word_identifier] = ACTIONS(13400),
    [anon_sym_EQ] = ACTIONS(13400),
    [anon_sym_COMMA] = ACTIONS(13400),
    [anon_sym_COLON] = ACTIONS(13400),
    [anon_sym_begin] = ACTIONS(13400),
    [anon_sym_module] = ACTIONS(13400),
    [anon_sym_baremodule] = ACTIONS(13400),
    [anon_sym_abstract] = ACTIONS(13400),
    [anon_sym_primitive] = ACTIONS(13400),
    [anon_sym_mutable] = ACTIONS(13400),
    [anon_sym_struct] = ACTIONS(13400),
    [anon_sym_function] = ACTIONS(13400),
    [anon_sym_macro] = ACTIONS(13400),
    [anon_sym_where] = ACTIONS(13400),
    [anon_sym_quote] = ACTIONS(13400),
    [anon_sym_let] = ACTIONS(13400),
    [anon_sym_if] = ACTIONS(13400),
    [anon_sym_try] = ACTIONS(13400),
    [anon_sym_catch] = ACTIONS(13400),
    [anon_sym_finally] = ACTIONS(13400),
    [anon_sym_for] = ACTIONS(13400),
    [anon_sym_while] = ACTIONS(13400),
    [sym_break_statement] = ACTIONS(13400),
    [sym_continue_statement] = ACTIONS(13400),
    [anon_sym_return] = ACTIONS(13400),
    [anon_sym_const] = ACTIONS(13400),
    [anon_sym_global] = ACTIONS(13400),
    [anon_sym_local] = ACTIONS(13400),
    [anon_sym_LPAREN] = ACTIONS(13400),
    [anon_sym_COLON2] = ACTIONS(13400),
    [anon_sym_export] = ACTIONS(13400),
    [anon_sym_import] = ACTIONS(13400),
    [anon_sym_using] = ACTIONS(13400),
    [anon_sym_LBRACK] = ACTIONS(13400),
    [anon_sym_LF] = ACTIONS(13402),
    [anon_sym_in] = ACTIONS(13400),
    [anon_sym_LBRACE] = ACTIONS(13400),
    [anon_sym_DOLLAR] = ACTIONS(13400),
    [anon_sym_COLON_COLON] = ACTIONS(13400),
    [anon_sym_isa] = ACTIONS(13400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13400),
    [anon_sym_QMARK] = ACTIONS(13400),
    [anon_sym_AT] = ACTIONS(13400),
    [anon_sym_true] = ACTIONS(13400),
    [anon_sym_false] = ACTIONS(13400),
    [aux_sym_integer_literal_token1] = ACTIONS(13400),
    [aux_sym_integer_literal_token2] = ACTIONS(13400),
    [aux_sym_integer_literal_token3] = ACTIONS(13400),
    [aux_sym_integer_literal_token4] = ACTIONS(13400),
    [aux_sym_float_literal_token1] = ACTIONS(13400),
    [aux_sym_float_literal_token3] = ACTIONS(13400),
    [aux_sym_float_literal_token4] = ACTIONS(13400),
    [sym_character_literal] = ACTIONS(13400),
    [sym__pair_operator] = ACTIONS(13400),
    [sym__arrow_operator] = ACTIONS(13400),
    [sym__lazy_or_operator] = ACTIONS(13400),
    [sym__lazy_and_operator] = ACTIONS(13400),
    [sym__comparison_operator] = ACTIONS(13400),
    [sym__pipe_right_operator] = ACTIONS(13400),
    [sym__pipe_left_operator] = ACTIONS(13400),
    [sym__ellipsis_operator] = ACTIONS(13400),
    [sym__plus_operator] = ACTIONS(13400),
    [sym__times_operator] = ACTIONS(13400),
    [sym__rational_operator] = ACTIONS(13400),
    [sym__bitshift_operator] = ACTIONS(13400),
    [sym__power_operator] = ACTIONS(13400),
    [sym__tilde_operator] = ACTIONS(13400),
    [sym__type_order_operator] = ACTIONS(13400),
    [sym__unary_operator] = ACTIONS(13400),
    [sym__unary_plus_operator] = ACTIONS(13400),
    [aux_sym__terminator_token1] = ACTIONS(13400),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13402),
    [sym__command_start] = ACTIONS(13402),
  },
  [8382] = {
    [sym__word_identifier] = ACTIONS(13407),
    [anon_sym_EQ] = ACTIONS(13407),
    [anon_sym_COMMA] = ACTIONS(13407),
    [anon_sym_COLON] = ACTIONS(13407),
    [anon_sym_begin] = ACTIONS(13407),
    [anon_sym_module] = ACTIONS(13407),
    [anon_sym_baremodule] = ACTIONS(13407),
    [anon_sym_abstract] = ACTIONS(13407),
    [anon_sym_primitive] = ACTIONS(13407),
    [anon_sym_mutable] = ACTIONS(13407),
    [anon_sym_struct] = ACTIONS(13407),
    [anon_sym_function] = ACTIONS(13407),
    [anon_sym_macro] = ACTIONS(13407),
    [anon_sym_where] = ACTIONS(13407),
    [anon_sym_quote] = ACTIONS(13407),
    [anon_sym_let] = ACTIONS(13407),
    [anon_sym_if] = ACTIONS(13407),
    [anon_sym_try] = ACTIONS(13407),
    [anon_sym_catch] = ACTIONS(13407),
    [anon_sym_finally] = ACTIONS(13407),
    [anon_sym_for] = ACTIONS(13407),
    [anon_sym_while] = ACTIONS(13407),
    [sym_break_statement] = ACTIONS(13407),
    [sym_continue_statement] = ACTIONS(13407),
    [anon_sym_return] = ACTIONS(13407),
    [anon_sym_const] = ACTIONS(13407),
    [anon_sym_global] = ACTIONS(13407),
    [anon_sym_local] = ACTIONS(13407),
    [anon_sym_LPAREN] = ACTIONS(13407),
    [anon_sym_COLON2] = ACTIONS(13407),
    [anon_sym_export] = ACTIONS(13407),
    [anon_sym_import] = ACTIONS(13407),
    [anon_sym_using] = ACTIONS(13407),
    [anon_sym_LBRACK] = ACTIONS(13407),
    [anon_sym_LF] = ACTIONS(13409),
    [anon_sym_in] = ACTIONS(13407),
    [anon_sym_LBRACE] = ACTIONS(13407),
    [anon_sym_DOLLAR] = ACTIONS(13407),
    [anon_sym_COLON_COLON] = ACTIONS(13407),
    [anon_sym_isa] = ACTIONS(13407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13407),
    [anon_sym_QMARK] = ACTIONS(13407),
    [anon_sym_AT] = ACTIONS(13407),
    [anon_sym_true] = ACTIONS(13407),
    [anon_sym_false] = ACTIONS(13407),
    [aux_sym_integer_literal_token1] = ACTIONS(13407),
    [aux_sym_integer_literal_token2] = ACTIONS(13407),
    [aux_sym_integer_literal_token3] = ACTIONS(13407),
    [aux_sym_integer_literal_token4] = ACTIONS(13407),
    [aux_sym_float_literal_token1] = ACTIONS(13407),
    [aux_sym_float_literal_token3] = ACTIONS(13407),
    [aux_sym_float_literal_token4] = ACTIONS(13407),
    [sym_character_literal] = ACTIONS(13407),
    [sym__pair_operator] = ACTIONS(13407),
    [sym__arrow_operator] = ACTIONS(13407),
    [sym__lazy_or_operator] = ACTIONS(13407),
    [sym__lazy_and_operator] = ACTIONS(13407),
    [sym__comparison_operator] = ACTIONS(13407),
    [sym__pipe_right_operator] = ACTIONS(13407),
    [sym__pipe_left_operator] = ACTIONS(13407),
    [sym__ellipsis_operator] = ACTIONS(13407),
    [sym__plus_operator] = ACTIONS(13407),
    [sym__times_operator] = ACTIONS(13407),
    [sym__rational_operator] = ACTIONS(13407),
    [sym__bitshift_operator] = ACTIONS(13407),
    [sym__power_operator] = ACTIONS(13407),
    [sym__tilde_operator] = ACTIONS(13407),
    [sym__type_order_operator] = ACTIONS(13407),
    [sym__unary_operator] = ACTIONS(13407),
    [sym__unary_plus_operator] = ACTIONS(13407),
    [aux_sym__terminator_token1] = ACTIONS(13407),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13409),
    [sym__command_start] = ACTIONS(13409),
  },
  [8383] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8384] = {
    [sym__word_identifier] = ACTIONS(13644),
    [anon_sym_EQ] = ACTIONS(13644),
    [anon_sym_COMMA] = ACTIONS(13646),
    [anon_sym_COLON] = ACTIONS(13644),
    [anon_sym_begin] = ACTIONS(13644),
    [anon_sym_module] = ACTIONS(13644),
    [anon_sym_baremodule] = ACTIONS(13644),
    [anon_sym_abstract] = ACTIONS(13644),
    [anon_sym_primitive] = ACTIONS(13644),
    [anon_sym_mutable] = ACTIONS(13644),
    [anon_sym_struct] = ACTIONS(13644),
    [anon_sym_function] = ACTIONS(13644),
    [anon_sym_macro] = ACTIONS(13644),
    [anon_sym_where] = ACTIONS(13644),
    [anon_sym_quote] = ACTIONS(13644),
    [anon_sym_let] = ACTIONS(13644),
    [anon_sym_if] = ACTIONS(13644),
    [anon_sym_try] = ACTIONS(13644),
    [anon_sym_for] = ACTIONS(13644),
    [anon_sym_while] = ACTIONS(13644),
    [sym_break_statement] = ACTIONS(13644),
    [sym_continue_statement] = ACTIONS(13644),
    [anon_sym_return] = ACTIONS(13644),
    [anon_sym_const] = ACTIONS(13644),
    [anon_sym_global] = ACTIONS(13644),
    [anon_sym_local] = ACTIONS(13644),
    [anon_sym_LPAREN] = ACTIONS(13646),
    [anon_sym_RPAREN] = ACTIONS(13646),
    [anon_sym_COLON2] = ACTIONS(13644),
    [anon_sym_export] = ACTIONS(13644),
    [anon_sym_import] = ACTIONS(13644),
    [anon_sym_using] = ACTIONS(13644),
    [anon_sym_LBRACK] = ACTIONS(13646),
    [anon_sym_RBRACK] = ACTIONS(13646),
    [anon_sym_in] = ACTIONS(13644),
    [anon_sym_SEMI] = ACTIONS(13646),
    [anon_sym_LBRACE] = ACTIONS(13646),
    [anon_sym_RBRACE] = ACTIONS(13646),
    [anon_sym_DOLLAR] = ACTIONS(13646),
    [anon_sym_COLON_COLON] = ACTIONS(13646),
    [anon_sym_isa] = ACTIONS(13644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13646),
    [anon_sym_QMARK] = ACTIONS(13646),
    [anon_sym_AT] = ACTIONS(13646),
    [anon_sym_true] = ACTIONS(13644),
    [anon_sym_false] = ACTIONS(13644),
    [aux_sym_integer_literal_token1] = ACTIONS(13646),
    [aux_sym_integer_literal_token2] = ACTIONS(13646),
    [aux_sym_integer_literal_token3] = ACTIONS(13644),
    [aux_sym_integer_literal_token4] = ACTIONS(13644),
    [aux_sym_float_literal_token1] = ACTIONS(13646),
    [aux_sym_float_literal_token3] = ACTIONS(13646),
    [aux_sym_float_literal_token4] = ACTIONS(13646),
    [sym_character_literal] = ACTIONS(13646),
    [sym__pair_operator] = ACTIONS(13646),
    [sym__arrow_operator] = ACTIONS(13644),
    [sym__lazy_or_operator] = ACTIONS(13646),
    [sym__lazy_and_operator] = ACTIONS(13646),
    [sym__comparison_operator] = ACTIONS(13644),
    [sym__pipe_right_operator] = ACTIONS(13646),
    [sym__pipe_left_operator] = ACTIONS(13646),
    [sym__ellipsis_operator] = ACTIONS(13644),
    [sym__plus_operator] = ACTIONS(13644),
    [sym__times_operator] = ACTIONS(13644),
    [sym__rational_operator] = ACTIONS(13646),
    [sym__bitshift_operator] = ACTIONS(13646),
    [sym__power_operator] = ACTIONS(13646),
    [sym__tilde_operator] = ACTIONS(13646),
    [sym__type_order_operator] = ACTIONS(13646),
    [sym__unary_operator] = ACTIONS(13644),
    [sym__unary_plus_operator] = ACTIONS(13644),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13646),
    [sym__command_start] = ACTIONS(13646),
  },
  [8385] = {
    [sym__word_identifier] = ACTIONS(13648),
    [anon_sym_EQ] = ACTIONS(13648),
    [anon_sym_COMMA] = ACTIONS(13650),
    [anon_sym_COLON] = ACTIONS(13648),
    [anon_sym_begin] = ACTIONS(13648),
    [anon_sym_module] = ACTIONS(13648),
    [anon_sym_baremodule] = ACTIONS(13648),
    [anon_sym_abstract] = ACTIONS(13648),
    [anon_sym_primitive] = ACTIONS(13648),
    [anon_sym_mutable] = ACTIONS(13648),
    [anon_sym_struct] = ACTIONS(13648),
    [anon_sym_function] = ACTIONS(13648),
    [anon_sym_macro] = ACTIONS(13648),
    [anon_sym_where] = ACTIONS(13648),
    [anon_sym_quote] = ACTIONS(13648),
    [anon_sym_let] = ACTIONS(13648),
    [anon_sym_if] = ACTIONS(13648),
    [anon_sym_try] = ACTIONS(13648),
    [anon_sym_for] = ACTIONS(13648),
    [anon_sym_while] = ACTIONS(13648),
    [sym_break_statement] = ACTIONS(13648),
    [sym_continue_statement] = ACTIONS(13648),
    [anon_sym_return] = ACTIONS(13648),
    [anon_sym_const] = ACTIONS(13648),
    [anon_sym_global] = ACTIONS(13648),
    [anon_sym_local] = ACTIONS(13648),
    [anon_sym_LPAREN] = ACTIONS(13650),
    [anon_sym_RPAREN] = ACTIONS(13650),
    [anon_sym_COLON2] = ACTIONS(13648),
    [anon_sym_export] = ACTIONS(13648),
    [anon_sym_import] = ACTIONS(13648),
    [anon_sym_using] = ACTIONS(13648),
    [anon_sym_LBRACK] = ACTIONS(13650),
    [anon_sym_RBRACK] = ACTIONS(13650),
    [anon_sym_in] = ACTIONS(13648),
    [anon_sym_SEMI] = ACTIONS(13650),
    [anon_sym_LBRACE] = ACTIONS(13650),
    [anon_sym_RBRACE] = ACTIONS(13650),
    [anon_sym_DOLLAR] = ACTIONS(13650),
    [anon_sym_COLON_COLON] = ACTIONS(13650),
    [anon_sym_isa] = ACTIONS(13648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13650),
    [anon_sym_QMARK] = ACTIONS(13650),
    [anon_sym_AT] = ACTIONS(13650),
    [anon_sym_true] = ACTIONS(13648),
    [anon_sym_false] = ACTIONS(13648),
    [aux_sym_integer_literal_token1] = ACTIONS(13650),
    [aux_sym_integer_literal_token2] = ACTIONS(13650),
    [aux_sym_integer_literal_token3] = ACTIONS(13648),
    [aux_sym_integer_literal_token4] = ACTIONS(13648),
    [aux_sym_float_literal_token1] = ACTIONS(13650),
    [aux_sym_float_literal_token3] = ACTIONS(13650),
    [aux_sym_float_literal_token4] = ACTIONS(13650),
    [sym_character_literal] = ACTIONS(13650),
    [sym__pair_operator] = ACTIONS(13650),
    [sym__arrow_operator] = ACTIONS(13648),
    [sym__lazy_or_operator] = ACTIONS(13650),
    [sym__lazy_and_operator] = ACTIONS(13650),
    [sym__comparison_operator] = ACTIONS(13648),
    [sym__pipe_right_operator] = ACTIONS(13650),
    [sym__pipe_left_operator] = ACTIONS(13650),
    [sym__ellipsis_operator] = ACTIONS(13648),
    [sym__plus_operator] = ACTIONS(13648),
    [sym__times_operator] = ACTIONS(13648),
    [sym__rational_operator] = ACTIONS(13650),
    [sym__bitshift_operator] = ACTIONS(13650),
    [sym__power_operator] = ACTIONS(13650),
    [sym__tilde_operator] = ACTIONS(13650),
    [sym__type_order_operator] = ACTIONS(13650),
    [sym__unary_operator] = ACTIONS(13648),
    [sym__unary_plus_operator] = ACTIONS(13648),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13650),
    [sym__command_start] = ACTIONS(13650),
  },
  [8386] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11866),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11866),
    [anon_sym_SEMI] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_isa] = ACTIONS(11866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11866),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [8387] = {
    [sym__word_identifier] = ACTIONS(13550),
    [anon_sym_EQ] = ACTIONS(13550),
    [anon_sym_COMMA] = ACTIONS(13552),
    [anon_sym_COLON] = ACTIONS(13550),
    [anon_sym_begin] = ACTIONS(13550),
    [anon_sym_module] = ACTIONS(13550),
    [anon_sym_baremodule] = ACTIONS(13550),
    [anon_sym_abstract] = ACTIONS(13550),
    [anon_sym_primitive] = ACTIONS(13550),
    [anon_sym_mutable] = ACTIONS(13550),
    [anon_sym_struct] = ACTIONS(13550),
    [anon_sym_function] = ACTIONS(13550),
    [anon_sym_macro] = ACTIONS(13550),
    [anon_sym_where] = ACTIONS(13550),
    [anon_sym_quote] = ACTIONS(13550),
    [anon_sym_let] = ACTIONS(13550),
    [anon_sym_if] = ACTIONS(13550),
    [anon_sym_try] = ACTIONS(13550),
    [anon_sym_for] = ACTIONS(13550),
    [anon_sym_while] = ACTIONS(13550),
    [sym_break_statement] = ACTIONS(13550),
    [sym_continue_statement] = ACTIONS(13550),
    [anon_sym_return] = ACTIONS(13550),
    [anon_sym_const] = ACTIONS(13550),
    [anon_sym_global] = ACTIONS(13550),
    [anon_sym_local] = ACTIONS(13550),
    [anon_sym_LPAREN] = ACTIONS(13552),
    [anon_sym_RPAREN] = ACTIONS(13552),
    [anon_sym_COLON2] = ACTIONS(13550),
    [anon_sym_export] = ACTIONS(13550),
    [anon_sym_import] = ACTIONS(13550),
    [anon_sym_using] = ACTIONS(13550),
    [anon_sym_LBRACK] = ACTIONS(13552),
    [anon_sym_RBRACK] = ACTIONS(13552),
    [anon_sym_in] = ACTIONS(13550),
    [anon_sym_SEMI] = ACTIONS(13552),
    [anon_sym_LBRACE] = ACTIONS(13552),
    [anon_sym_RBRACE] = ACTIONS(13552),
    [anon_sym_DOLLAR] = ACTIONS(13552),
    [anon_sym_COLON_COLON] = ACTIONS(13552),
    [anon_sym_isa] = ACTIONS(13550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13552),
    [anon_sym_QMARK] = ACTIONS(13552),
    [anon_sym_AT] = ACTIONS(13552),
    [anon_sym_true] = ACTIONS(13550),
    [anon_sym_false] = ACTIONS(13550),
    [aux_sym_integer_literal_token1] = ACTIONS(13552),
    [aux_sym_integer_literal_token2] = ACTIONS(13552),
    [aux_sym_integer_literal_token3] = ACTIONS(13550),
    [aux_sym_integer_literal_token4] = ACTIONS(13550),
    [aux_sym_float_literal_token1] = ACTIONS(13552),
    [aux_sym_float_literal_token3] = ACTIONS(13552),
    [aux_sym_float_literal_token4] = ACTIONS(13552),
    [sym_character_literal] = ACTIONS(13552),
    [sym__pair_operator] = ACTIONS(13552),
    [sym__arrow_operator] = ACTIONS(13550),
    [sym__lazy_or_operator] = ACTIONS(13552),
    [sym__lazy_and_operator] = ACTIONS(13552),
    [sym__comparison_operator] = ACTIONS(13550),
    [sym__pipe_right_operator] = ACTIONS(13552),
    [sym__pipe_left_operator] = ACTIONS(13552),
    [sym__ellipsis_operator] = ACTIONS(13550),
    [sym__plus_operator] = ACTIONS(13550),
    [sym__times_operator] = ACTIONS(13550),
    [sym__rational_operator] = ACTIONS(13552),
    [sym__bitshift_operator] = ACTIONS(13552),
    [sym__power_operator] = ACTIONS(13552),
    [sym__tilde_operator] = ACTIONS(13552),
    [sym__type_order_operator] = ACTIONS(13552),
    [sym__unary_operator] = ACTIONS(13550),
    [sym__unary_plus_operator] = ACTIONS(13550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13552),
    [sym__command_start] = ACTIONS(13552),
  },
  [8388] = {
    [sym__word_identifier] = ACTIONS(13652),
    [anon_sym_EQ] = ACTIONS(13652),
    [anon_sym_COMMA] = ACTIONS(13654),
    [anon_sym_COLON] = ACTIONS(13652),
    [anon_sym_begin] = ACTIONS(13652),
    [anon_sym_module] = ACTIONS(13652),
    [anon_sym_baremodule] = ACTIONS(13652),
    [anon_sym_abstract] = ACTIONS(13652),
    [anon_sym_primitive] = ACTIONS(13652),
    [anon_sym_mutable] = ACTIONS(13652),
    [anon_sym_struct] = ACTIONS(13652),
    [anon_sym_function] = ACTIONS(13652),
    [anon_sym_macro] = ACTIONS(13652),
    [anon_sym_where] = ACTIONS(13652),
    [anon_sym_quote] = ACTIONS(13652),
    [anon_sym_let] = ACTIONS(13652),
    [anon_sym_if] = ACTIONS(13652),
    [anon_sym_try] = ACTIONS(13652),
    [anon_sym_for] = ACTIONS(13652),
    [anon_sym_while] = ACTIONS(13652),
    [sym_break_statement] = ACTIONS(13652),
    [sym_continue_statement] = ACTIONS(13652),
    [anon_sym_return] = ACTIONS(13652),
    [anon_sym_const] = ACTIONS(13652),
    [anon_sym_global] = ACTIONS(13652),
    [anon_sym_local] = ACTIONS(13652),
    [anon_sym_LPAREN] = ACTIONS(13654),
    [anon_sym_RPAREN] = ACTIONS(13654),
    [anon_sym_COLON2] = ACTIONS(13652),
    [anon_sym_export] = ACTIONS(13652),
    [anon_sym_import] = ACTIONS(13652),
    [anon_sym_using] = ACTIONS(13652),
    [anon_sym_LBRACK] = ACTIONS(13654),
    [anon_sym_RBRACK] = ACTIONS(13654),
    [anon_sym_in] = ACTIONS(13652),
    [anon_sym_SEMI] = ACTIONS(13654),
    [anon_sym_LBRACE] = ACTIONS(13654),
    [anon_sym_RBRACE] = ACTIONS(13654),
    [anon_sym_DOLLAR] = ACTIONS(13654),
    [anon_sym_COLON_COLON] = ACTIONS(13654),
    [anon_sym_isa] = ACTIONS(13652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13654),
    [anon_sym_QMARK] = ACTIONS(13654),
    [anon_sym_AT] = ACTIONS(13654),
    [anon_sym_true] = ACTIONS(13652),
    [anon_sym_false] = ACTIONS(13652),
    [aux_sym_integer_literal_token1] = ACTIONS(13654),
    [aux_sym_integer_literal_token2] = ACTIONS(13654),
    [aux_sym_integer_literal_token3] = ACTIONS(13652),
    [aux_sym_integer_literal_token4] = ACTIONS(13652),
    [aux_sym_float_literal_token1] = ACTIONS(13654),
    [aux_sym_float_literal_token3] = ACTIONS(13654),
    [aux_sym_float_literal_token4] = ACTIONS(13654),
    [sym_character_literal] = ACTIONS(13654),
    [sym__pair_operator] = ACTIONS(13654),
    [sym__arrow_operator] = ACTIONS(13652),
    [sym__lazy_or_operator] = ACTIONS(13654),
    [sym__lazy_and_operator] = ACTIONS(13654),
    [sym__comparison_operator] = ACTIONS(13652),
    [sym__pipe_right_operator] = ACTIONS(13654),
    [sym__pipe_left_operator] = ACTIONS(13654),
    [sym__ellipsis_operator] = ACTIONS(13652),
    [sym__plus_operator] = ACTIONS(13652),
    [sym__times_operator] = ACTIONS(13652),
    [sym__rational_operator] = ACTIONS(13654),
    [sym__bitshift_operator] = ACTIONS(13654),
    [sym__power_operator] = ACTIONS(13654),
    [sym__tilde_operator] = ACTIONS(13654),
    [sym__type_order_operator] = ACTIONS(13654),
    [sym__unary_operator] = ACTIONS(13652),
    [sym__unary_plus_operator] = ACTIONS(13652),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13654),
    [sym__command_start] = ACTIONS(13654),
  },
  [8389] = {
    [sym__word_identifier] = ACTIONS(13656),
    [anon_sym_EQ] = ACTIONS(13656),
    [anon_sym_COMMA] = ACTIONS(13658),
    [anon_sym_COLON] = ACTIONS(13656),
    [anon_sym_begin] = ACTIONS(13656),
    [anon_sym_module] = ACTIONS(13656),
    [anon_sym_baremodule] = ACTIONS(13656),
    [anon_sym_abstract] = ACTIONS(13656),
    [anon_sym_primitive] = ACTIONS(13656),
    [anon_sym_mutable] = ACTIONS(13656),
    [anon_sym_struct] = ACTIONS(13656),
    [anon_sym_function] = ACTIONS(13656),
    [anon_sym_macro] = ACTIONS(13656),
    [anon_sym_where] = ACTIONS(13656),
    [anon_sym_quote] = ACTIONS(13656),
    [anon_sym_let] = ACTIONS(13656),
    [anon_sym_if] = ACTIONS(13656),
    [anon_sym_try] = ACTIONS(13656),
    [anon_sym_for] = ACTIONS(13656),
    [anon_sym_while] = ACTIONS(13656),
    [sym_break_statement] = ACTIONS(13656),
    [sym_continue_statement] = ACTIONS(13656),
    [anon_sym_return] = ACTIONS(13656),
    [anon_sym_const] = ACTIONS(13656),
    [anon_sym_global] = ACTIONS(13656),
    [anon_sym_local] = ACTIONS(13656),
    [anon_sym_LPAREN] = ACTIONS(13658),
    [anon_sym_RPAREN] = ACTIONS(13658),
    [anon_sym_COLON2] = ACTIONS(13656),
    [anon_sym_export] = ACTIONS(13656),
    [anon_sym_import] = ACTIONS(13656),
    [anon_sym_using] = ACTIONS(13656),
    [anon_sym_LBRACK] = ACTIONS(13658),
    [anon_sym_RBRACK] = ACTIONS(13658),
    [anon_sym_in] = ACTIONS(13656),
    [anon_sym_SEMI] = ACTIONS(13658),
    [anon_sym_LBRACE] = ACTIONS(13658),
    [anon_sym_RBRACE] = ACTIONS(13658),
    [anon_sym_DOLLAR] = ACTIONS(13658),
    [anon_sym_COLON_COLON] = ACTIONS(13658),
    [anon_sym_isa] = ACTIONS(13656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13658),
    [anon_sym_QMARK] = ACTIONS(13658),
    [anon_sym_AT] = ACTIONS(13658),
    [anon_sym_true] = ACTIONS(13656),
    [anon_sym_false] = ACTIONS(13656),
    [aux_sym_integer_literal_token1] = ACTIONS(13658),
    [aux_sym_integer_literal_token2] = ACTIONS(13658),
    [aux_sym_integer_literal_token3] = ACTIONS(13656),
    [aux_sym_integer_literal_token4] = ACTIONS(13656),
    [aux_sym_float_literal_token1] = ACTIONS(13658),
    [aux_sym_float_literal_token3] = ACTIONS(13658),
    [aux_sym_float_literal_token4] = ACTIONS(13658),
    [sym_character_literal] = ACTIONS(13658),
    [sym__pair_operator] = ACTIONS(13658),
    [sym__arrow_operator] = ACTIONS(13656),
    [sym__lazy_or_operator] = ACTIONS(13658),
    [sym__lazy_and_operator] = ACTIONS(13658),
    [sym__comparison_operator] = ACTIONS(13656),
    [sym__pipe_right_operator] = ACTIONS(13658),
    [sym__pipe_left_operator] = ACTIONS(13658),
    [sym__ellipsis_operator] = ACTIONS(13656),
    [sym__plus_operator] = ACTIONS(13656),
    [sym__times_operator] = ACTIONS(13656),
    [sym__rational_operator] = ACTIONS(13658),
    [sym__bitshift_operator] = ACTIONS(13658),
    [sym__power_operator] = ACTIONS(13658),
    [sym__tilde_operator] = ACTIONS(13658),
    [sym__type_order_operator] = ACTIONS(13658),
    [sym__unary_operator] = ACTIONS(13656),
    [sym__unary_plus_operator] = ACTIONS(13656),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13658),
    [sym__command_start] = ACTIONS(13658),
  },
  [8390] = {
    [sym__word_identifier] = ACTIONS(13660),
    [anon_sym_EQ] = ACTIONS(13660),
    [anon_sym_COMMA] = ACTIONS(13662),
    [anon_sym_COLON] = ACTIONS(13660),
    [anon_sym_begin] = ACTIONS(13660),
    [anon_sym_module] = ACTIONS(13660),
    [anon_sym_baremodule] = ACTIONS(13660),
    [anon_sym_abstract] = ACTIONS(13660),
    [anon_sym_primitive] = ACTIONS(13660),
    [anon_sym_mutable] = ACTIONS(13660),
    [anon_sym_struct] = ACTIONS(13660),
    [anon_sym_function] = ACTIONS(13660),
    [anon_sym_macro] = ACTIONS(13660),
    [anon_sym_where] = ACTIONS(13660),
    [anon_sym_quote] = ACTIONS(13660),
    [anon_sym_let] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_try] = ACTIONS(13660),
    [anon_sym_for] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [sym_break_statement] = ACTIONS(13660),
    [sym_continue_statement] = ACTIONS(13660),
    [anon_sym_return] = ACTIONS(13660),
    [anon_sym_const] = ACTIONS(13660),
    [anon_sym_global] = ACTIONS(13660),
    [anon_sym_local] = ACTIONS(13660),
    [anon_sym_LPAREN] = ACTIONS(13662),
    [anon_sym_RPAREN] = ACTIONS(13662),
    [anon_sym_COLON2] = ACTIONS(13660),
    [anon_sym_export] = ACTIONS(13660),
    [anon_sym_import] = ACTIONS(13660),
    [anon_sym_using] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13662),
    [anon_sym_RBRACK] = ACTIONS(13662),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(13662),
    [anon_sym_LBRACE] = ACTIONS(13662),
    [anon_sym_RBRACE] = ACTIONS(13662),
    [anon_sym_DOLLAR] = ACTIONS(13662),
    [anon_sym_COLON_COLON] = ACTIONS(13662),
    [anon_sym_isa] = ACTIONS(13660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13662),
    [anon_sym_QMARK] = ACTIONS(13662),
    [anon_sym_AT] = ACTIONS(13662),
    [anon_sym_true] = ACTIONS(13660),
    [anon_sym_false] = ACTIONS(13660),
    [aux_sym_integer_literal_token1] = ACTIONS(13662),
    [aux_sym_integer_literal_token2] = ACTIONS(13662),
    [aux_sym_integer_literal_token3] = ACTIONS(13660),
    [aux_sym_integer_literal_token4] = ACTIONS(13660),
    [aux_sym_float_literal_token1] = ACTIONS(13662),
    [aux_sym_float_literal_token3] = ACTIONS(13662),
    [aux_sym_float_literal_token4] = ACTIONS(13662),
    [sym_character_literal] = ACTIONS(13662),
    [sym__pair_operator] = ACTIONS(13662),
    [sym__arrow_operator] = ACTIONS(13660),
    [sym__lazy_or_operator] = ACTIONS(13662),
    [sym__lazy_and_operator] = ACTIONS(13662),
    [sym__comparison_operator] = ACTIONS(13660),
    [sym__pipe_right_operator] = ACTIONS(13662),
    [sym__pipe_left_operator] = ACTIONS(13662),
    [sym__ellipsis_operator] = ACTIONS(13660),
    [sym__plus_operator] = ACTIONS(13660),
    [sym__times_operator] = ACTIONS(13660),
    [sym__rational_operator] = ACTIONS(13662),
    [sym__bitshift_operator] = ACTIONS(13662),
    [sym__power_operator] = ACTIONS(13662),
    [sym__tilde_operator] = ACTIONS(13662),
    [sym__type_order_operator] = ACTIONS(13662),
    [sym__unary_operator] = ACTIONS(13660),
    [sym__unary_plus_operator] = ACTIONS(13660),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13662),
    [sym__command_start] = ACTIONS(13662),
  },
  [8391] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8392] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(12610),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8393] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_catch] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8394] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(13306),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8395] = {
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13255),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_catch] = ACTIONS(13255),
    [anon_sym_finally] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13255),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13255),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13255),
    [anon_sym_isa] = ACTIONS(13255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13255),
    [anon_sym_QMARK] = ACTIONS(13255),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13255),
    [sym__arrow_operator] = ACTIONS(13255),
    [sym__lazy_or_operator] = ACTIONS(13255),
    [sym__lazy_and_operator] = ACTIONS(13255),
    [sym__comparison_operator] = ACTIONS(13255),
    [sym__pipe_right_operator] = ACTIONS(13255),
    [sym__pipe_left_operator] = ACTIONS(13255),
    [sym__ellipsis_operator] = ACTIONS(13255),
    [sym__plus_operator] = ACTIONS(13255),
    [sym__times_operator] = ACTIONS(13255),
    [sym__rational_operator] = ACTIONS(13255),
    [sym__bitshift_operator] = ACTIONS(13255),
    [sym__power_operator] = ACTIONS(13255),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13255),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13255),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8396] = {
    [sym__word_identifier] = ACTIONS(13413),
    [anon_sym_EQ] = ACTIONS(13413),
    [anon_sym_COMMA] = ACTIONS(13413),
    [anon_sym_COLON] = ACTIONS(13413),
    [anon_sym_begin] = ACTIONS(13413),
    [anon_sym_module] = ACTIONS(13413),
    [anon_sym_baremodule] = ACTIONS(13413),
    [anon_sym_abstract] = ACTIONS(13413),
    [anon_sym_primitive] = ACTIONS(13413),
    [anon_sym_mutable] = ACTIONS(13413),
    [anon_sym_struct] = ACTIONS(13413),
    [anon_sym_function] = ACTIONS(13413),
    [anon_sym_macro] = ACTIONS(13413),
    [anon_sym_where] = ACTIONS(13413),
    [anon_sym_quote] = ACTIONS(13413),
    [anon_sym_let] = ACTIONS(13413),
    [anon_sym_if] = ACTIONS(13413),
    [anon_sym_try] = ACTIONS(13413),
    [anon_sym_catch] = ACTIONS(13413),
    [anon_sym_finally] = ACTIONS(13413),
    [anon_sym_for] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(13413),
    [sym_break_statement] = ACTIONS(13413),
    [sym_continue_statement] = ACTIONS(13413),
    [anon_sym_return] = ACTIONS(13413),
    [anon_sym_const] = ACTIONS(13413),
    [anon_sym_global] = ACTIONS(13413),
    [anon_sym_local] = ACTIONS(13413),
    [anon_sym_LPAREN] = ACTIONS(13413),
    [anon_sym_COLON2] = ACTIONS(13413),
    [anon_sym_export] = ACTIONS(13413),
    [anon_sym_import] = ACTIONS(13413),
    [anon_sym_using] = ACTIONS(13413),
    [anon_sym_LBRACK] = ACTIONS(13413),
    [anon_sym_LF] = ACTIONS(13415),
    [anon_sym_in] = ACTIONS(13413),
    [anon_sym_LBRACE] = ACTIONS(13413),
    [anon_sym_DOLLAR] = ACTIONS(13413),
    [anon_sym_COLON_COLON] = ACTIONS(13413),
    [anon_sym_isa] = ACTIONS(13413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_QMARK] = ACTIONS(13413),
    [anon_sym_AT] = ACTIONS(13413),
    [anon_sym_true] = ACTIONS(13413),
    [anon_sym_false] = ACTIONS(13413),
    [aux_sym_integer_literal_token1] = ACTIONS(13413),
    [aux_sym_integer_literal_token2] = ACTIONS(13413),
    [aux_sym_integer_literal_token3] = ACTIONS(13413),
    [aux_sym_integer_literal_token4] = ACTIONS(13413),
    [aux_sym_float_literal_token1] = ACTIONS(13413),
    [aux_sym_float_literal_token3] = ACTIONS(13413),
    [aux_sym_float_literal_token4] = ACTIONS(13413),
    [sym_character_literal] = ACTIONS(13413),
    [sym__pair_operator] = ACTIONS(13413),
    [sym__arrow_operator] = ACTIONS(13413),
    [sym__lazy_or_operator] = ACTIONS(13413),
    [sym__lazy_and_operator] = ACTIONS(13413),
    [sym__comparison_operator] = ACTIONS(13413),
    [sym__pipe_right_operator] = ACTIONS(13413),
    [sym__pipe_left_operator] = ACTIONS(13413),
    [sym__ellipsis_operator] = ACTIONS(13413),
    [sym__plus_operator] = ACTIONS(13413),
    [sym__times_operator] = ACTIONS(13413),
    [sym__rational_operator] = ACTIONS(13413),
    [sym__bitshift_operator] = ACTIONS(13413),
    [sym__power_operator] = ACTIONS(13413),
    [sym__tilde_operator] = ACTIONS(13413),
    [sym__type_order_operator] = ACTIONS(13413),
    [sym__unary_operator] = ACTIONS(13413),
    [sym__unary_plus_operator] = ACTIONS(13413),
    [aux_sym__terminator_token1] = ACTIONS(13413),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13415),
    [sym__command_start] = ACTIONS(13415),
  },
  [8397] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8398] = {
    [sym__word_identifier] = ACTIONS(13664),
    [anon_sym_EQ] = ACTIONS(13664),
    [anon_sym_COMMA] = ACTIONS(13666),
    [anon_sym_COLON] = ACTIONS(13664),
    [anon_sym_begin] = ACTIONS(13664),
    [anon_sym_module] = ACTIONS(13664),
    [anon_sym_baremodule] = ACTIONS(13664),
    [anon_sym_abstract] = ACTIONS(13664),
    [anon_sym_primitive] = ACTIONS(13664),
    [anon_sym_mutable] = ACTIONS(13664),
    [anon_sym_struct] = ACTIONS(13664),
    [anon_sym_function] = ACTIONS(13664),
    [anon_sym_macro] = ACTIONS(13664),
    [anon_sym_where] = ACTIONS(13664),
    [anon_sym_quote] = ACTIONS(13664),
    [anon_sym_let] = ACTIONS(13664),
    [anon_sym_if] = ACTIONS(13664),
    [anon_sym_try] = ACTIONS(13664),
    [anon_sym_for] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(13664),
    [sym_break_statement] = ACTIONS(13664),
    [sym_continue_statement] = ACTIONS(13664),
    [anon_sym_return] = ACTIONS(13664),
    [anon_sym_const] = ACTIONS(13664),
    [anon_sym_global] = ACTIONS(13664),
    [anon_sym_local] = ACTIONS(13664),
    [anon_sym_LPAREN] = ACTIONS(13666),
    [anon_sym_RPAREN] = ACTIONS(13666),
    [anon_sym_COLON2] = ACTIONS(13664),
    [anon_sym_export] = ACTIONS(13664),
    [anon_sym_import] = ACTIONS(13664),
    [anon_sym_using] = ACTIONS(13664),
    [anon_sym_LBRACK] = ACTIONS(13666),
    [anon_sym_RBRACK] = ACTIONS(13666),
    [anon_sym_in] = ACTIONS(13664),
    [anon_sym_SEMI] = ACTIONS(13666),
    [anon_sym_LBRACE] = ACTIONS(13666),
    [anon_sym_RBRACE] = ACTIONS(13666),
    [anon_sym_DOLLAR] = ACTIONS(13666),
    [anon_sym_COLON_COLON] = ACTIONS(13666),
    [anon_sym_isa] = ACTIONS(13664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13666),
    [anon_sym_QMARK] = ACTIONS(13666),
    [anon_sym_AT] = ACTIONS(13666),
    [anon_sym_true] = ACTIONS(13664),
    [anon_sym_false] = ACTIONS(13664),
    [aux_sym_integer_literal_token1] = ACTIONS(13666),
    [aux_sym_integer_literal_token2] = ACTIONS(13666),
    [aux_sym_integer_literal_token3] = ACTIONS(13664),
    [aux_sym_integer_literal_token4] = ACTIONS(13664),
    [aux_sym_float_literal_token1] = ACTIONS(13666),
    [aux_sym_float_literal_token3] = ACTIONS(13666),
    [aux_sym_float_literal_token4] = ACTIONS(13666),
    [sym_character_literal] = ACTIONS(13666),
    [sym__pair_operator] = ACTIONS(13666),
    [sym__arrow_operator] = ACTIONS(13664),
    [sym__lazy_or_operator] = ACTIONS(13666),
    [sym__lazy_and_operator] = ACTIONS(13666),
    [sym__comparison_operator] = ACTIONS(13664),
    [sym__pipe_right_operator] = ACTIONS(13666),
    [sym__pipe_left_operator] = ACTIONS(13666),
    [sym__ellipsis_operator] = ACTIONS(13664),
    [sym__plus_operator] = ACTIONS(13664),
    [sym__times_operator] = ACTIONS(13664),
    [sym__rational_operator] = ACTIONS(13666),
    [sym__bitshift_operator] = ACTIONS(13666),
    [sym__power_operator] = ACTIONS(13666),
    [sym__tilde_operator] = ACTIONS(13666),
    [sym__type_order_operator] = ACTIONS(13666),
    [sym__unary_operator] = ACTIONS(13664),
    [sym__unary_plus_operator] = ACTIONS(13664),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13666),
    [sym__command_start] = ACTIONS(13666),
  },
  [8399] = {
    [sym__word_identifier] = ACTIONS(13417),
    [anon_sym_EQ] = ACTIONS(13417),
    [anon_sym_COMMA] = ACTIONS(13417),
    [anon_sym_COLON] = ACTIONS(13417),
    [anon_sym_begin] = ACTIONS(13417),
    [anon_sym_module] = ACTIONS(13417),
    [anon_sym_baremodule] = ACTIONS(13417),
    [anon_sym_abstract] = ACTIONS(13417),
    [anon_sym_primitive] = ACTIONS(13417),
    [anon_sym_mutable] = ACTIONS(13417),
    [anon_sym_struct] = ACTIONS(13417),
    [anon_sym_function] = ACTIONS(13417),
    [anon_sym_macro] = ACTIONS(13417),
    [anon_sym_where] = ACTIONS(13417),
    [anon_sym_quote] = ACTIONS(13417),
    [anon_sym_let] = ACTIONS(13417),
    [anon_sym_if] = ACTIONS(13417),
    [anon_sym_try] = ACTIONS(13417),
    [anon_sym_catch] = ACTIONS(13417),
    [anon_sym_finally] = ACTIONS(13417),
    [anon_sym_for] = ACTIONS(13417),
    [anon_sym_while] = ACTIONS(13417),
    [sym_break_statement] = ACTIONS(13417),
    [sym_continue_statement] = ACTIONS(13417),
    [anon_sym_return] = ACTIONS(13417),
    [anon_sym_const] = ACTIONS(13417),
    [anon_sym_global] = ACTIONS(13417),
    [anon_sym_local] = ACTIONS(13417),
    [anon_sym_LPAREN] = ACTIONS(13417),
    [anon_sym_COLON2] = ACTIONS(13417),
    [anon_sym_export] = ACTIONS(13417),
    [anon_sym_import] = ACTIONS(13417),
    [anon_sym_using] = ACTIONS(13417),
    [anon_sym_LBRACK] = ACTIONS(13417),
    [anon_sym_LF] = ACTIONS(13419),
    [anon_sym_in] = ACTIONS(13417),
    [anon_sym_LBRACE] = ACTIONS(13417),
    [anon_sym_DOLLAR] = ACTIONS(13417),
    [anon_sym_COLON_COLON] = ACTIONS(13417),
    [anon_sym_isa] = ACTIONS(13417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13417),
    [anon_sym_QMARK] = ACTIONS(13417),
    [anon_sym_AT] = ACTIONS(13417),
    [anon_sym_true] = ACTIONS(13417),
    [anon_sym_false] = ACTIONS(13417),
    [aux_sym_integer_literal_token1] = ACTIONS(13417),
    [aux_sym_integer_literal_token2] = ACTIONS(13417),
    [aux_sym_integer_literal_token3] = ACTIONS(13417),
    [aux_sym_integer_literal_token4] = ACTIONS(13417),
    [aux_sym_float_literal_token1] = ACTIONS(13417),
    [aux_sym_float_literal_token3] = ACTIONS(13417),
    [aux_sym_float_literal_token4] = ACTIONS(13417),
    [sym_character_literal] = ACTIONS(13417),
    [sym__pair_operator] = ACTIONS(13417),
    [sym__arrow_operator] = ACTIONS(13417),
    [sym__lazy_or_operator] = ACTIONS(13417),
    [sym__lazy_and_operator] = ACTIONS(13417),
    [sym__comparison_operator] = ACTIONS(13417),
    [sym__pipe_right_operator] = ACTIONS(13417),
    [sym__pipe_left_operator] = ACTIONS(13417),
    [sym__ellipsis_operator] = ACTIONS(13417),
    [sym__plus_operator] = ACTIONS(13417),
    [sym__times_operator] = ACTIONS(13417),
    [sym__rational_operator] = ACTIONS(13417),
    [sym__bitshift_operator] = ACTIONS(13417),
    [sym__power_operator] = ACTIONS(13417),
    [sym__tilde_operator] = ACTIONS(13417),
    [sym__type_order_operator] = ACTIONS(13417),
    [sym__unary_operator] = ACTIONS(13417),
    [sym__unary_plus_operator] = ACTIONS(13417),
    [aux_sym__terminator_token1] = ACTIONS(13417),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13419),
    [sym__command_start] = ACTIONS(13419),
  },
  [8400] = {
    [sym__word_identifier] = ACTIONS(13421),
    [anon_sym_EQ] = ACTIONS(13421),
    [anon_sym_COMMA] = ACTIONS(13421),
    [anon_sym_COLON] = ACTIONS(13421),
    [anon_sym_begin] = ACTIONS(13421),
    [anon_sym_module] = ACTIONS(13421),
    [anon_sym_baremodule] = ACTIONS(13421),
    [anon_sym_abstract] = ACTIONS(13421),
    [anon_sym_primitive] = ACTIONS(13421),
    [anon_sym_mutable] = ACTIONS(13421),
    [anon_sym_struct] = ACTIONS(13421),
    [anon_sym_function] = ACTIONS(13421),
    [anon_sym_macro] = ACTIONS(13421),
    [anon_sym_where] = ACTIONS(13421),
    [anon_sym_quote] = ACTIONS(13421),
    [anon_sym_let] = ACTIONS(13421),
    [anon_sym_if] = ACTIONS(13421),
    [anon_sym_try] = ACTIONS(13421),
    [anon_sym_catch] = ACTIONS(13421),
    [anon_sym_finally] = ACTIONS(13421),
    [anon_sym_for] = ACTIONS(13421),
    [anon_sym_while] = ACTIONS(13421),
    [sym_break_statement] = ACTIONS(13421),
    [sym_continue_statement] = ACTIONS(13421),
    [anon_sym_return] = ACTIONS(13421),
    [anon_sym_const] = ACTIONS(13421),
    [anon_sym_global] = ACTIONS(13421),
    [anon_sym_local] = ACTIONS(13421),
    [anon_sym_LPAREN] = ACTIONS(13421),
    [anon_sym_COLON2] = ACTIONS(13421),
    [anon_sym_export] = ACTIONS(13421),
    [anon_sym_import] = ACTIONS(13421),
    [anon_sym_using] = ACTIONS(13421),
    [anon_sym_LBRACK] = ACTIONS(13421),
    [anon_sym_LF] = ACTIONS(13423),
    [anon_sym_in] = ACTIONS(13421),
    [anon_sym_LBRACE] = ACTIONS(13421),
    [anon_sym_DOLLAR] = ACTIONS(13421),
    [anon_sym_COLON_COLON] = ACTIONS(13421),
    [anon_sym_isa] = ACTIONS(13421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13421),
    [anon_sym_QMARK] = ACTIONS(13421),
    [anon_sym_AT] = ACTIONS(13421),
    [anon_sym_true] = ACTIONS(13421),
    [anon_sym_false] = ACTIONS(13421),
    [aux_sym_integer_literal_token1] = ACTIONS(13421),
    [aux_sym_integer_literal_token2] = ACTIONS(13421),
    [aux_sym_integer_literal_token3] = ACTIONS(13421),
    [aux_sym_integer_literal_token4] = ACTIONS(13421),
    [aux_sym_float_literal_token1] = ACTIONS(13421),
    [aux_sym_float_literal_token3] = ACTIONS(13421),
    [aux_sym_float_literal_token4] = ACTIONS(13421),
    [sym_character_literal] = ACTIONS(13421),
    [sym__pair_operator] = ACTIONS(13421),
    [sym__arrow_operator] = ACTIONS(13421),
    [sym__lazy_or_operator] = ACTIONS(13421),
    [sym__lazy_and_operator] = ACTIONS(13421),
    [sym__comparison_operator] = ACTIONS(13421),
    [sym__pipe_right_operator] = ACTIONS(13421),
    [sym__pipe_left_operator] = ACTIONS(13421),
    [sym__ellipsis_operator] = ACTIONS(13421),
    [sym__plus_operator] = ACTIONS(13421),
    [sym__times_operator] = ACTIONS(13421),
    [sym__rational_operator] = ACTIONS(13421),
    [sym__bitshift_operator] = ACTIONS(13421),
    [sym__power_operator] = ACTIONS(13421),
    [sym__tilde_operator] = ACTIONS(13421),
    [sym__type_order_operator] = ACTIONS(13421),
    [sym__unary_operator] = ACTIONS(13421),
    [sym__unary_plus_operator] = ACTIONS(13421),
    [aux_sym__terminator_token1] = ACTIONS(13421),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13423),
    [sym__command_start] = ACTIONS(13423),
  },
  [8401] = {
    [sym__word_identifier] = ACTIONS(13425),
    [anon_sym_EQ] = ACTIONS(13425),
    [anon_sym_COMMA] = ACTIONS(13425),
    [anon_sym_COLON] = ACTIONS(13425),
    [anon_sym_begin] = ACTIONS(13425),
    [anon_sym_module] = ACTIONS(13425),
    [anon_sym_baremodule] = ACTIONS(13425),
    [anon_sym_abstract] = ACTIONS(13425),
    [anon_sym_primitive] = ACTIONS(13425),
    [anon_sym_mutable] = ACTIONS(13425),
    [anon_sym_struct] = ACTIONS(13425),
    [anon_sym_function] = ACTIONS(13425),
    [anon_sym_macro] = ACTIONS(13425),
    [anon_sym_where] = ACTIONS(13425),
    [anon_sym_quote] = ACTIONS(13425),
    [anon_sym_let] = ACTIONS(13425),
    [anon_sym_if] = ACTIONS(13425),
    [anon_sym_try] = ACTIONS(13425),
    [anon_sym_catch] = ACTIONS(13425),
    [anon_sym_finally] = ACTIONS(13425),
    [anon_sym_for] = ACTIONS(13425),
    [anon_sym_while] = ACTIONS(13425),
    [sym_break_statement] = ACTIONS(13425),
    [sym_continue_statement] = ACTIONS(13425),
    [anon_sym_return] = ACTIONS(13425),
    [anon_sym_const] = ACTIONS(13425),
    [anon_sym_global] = ACTIONS(13425),
    [anon_sym_local] = ACTIONS(13425),
    [anon_sym_LPAREN] = ACTIONS(13425),
    [anon_sym_COLON2] = ACTIONS(13425),
    [anon_sym_export] = ACTIONS(13425),
    [anon_sym_import] = ACTIONS(13425),
    [anon_sym_using] = ACTIONS(13425),
    [anon_sym_LBRACK] = ACTIONS(13425),
    [anon_sym_LF] = ACTIONS(13427),
    [anon_sym_in] = ACTIONS(13425),
    [anon_sym_LBRACE] = ACTIONS(13425),
    [anon_sym_DOLLAR] = ACTIONS(13425),
    [anon_sym_COLON_COLON] = ACTIONS(13425),
    [anon_sym_isa] = ACTIONS(13425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13425),
    [anon_sym_QMARK] = ACTIONS(13425),
    [anon_sym_AT] = ACTIONS(13425),
    [anon_sym_true] = ACTIONS(13425),
    [anon_sym_false] = ACTIONS(13425),
    [aux_sym_integer_literal_token1] = ACTIONS(13425),
    [aux_sym_integer_literal_token2] = ACTIONS(13425),
    [aux_sym_integer_literal_token3] = ACTIONS(13425),
    [aux_sym_integer_literal_token4] = ACTIONS(13425),
    [aux_sym_float_literal_token1] = ACTIONS(13425),
    [aux_sym_float_literal_token3] = ACTIONS(13425),
    [aux_sym_float_literal_token4] = ACTIONS(13425),
    [sym_character_literal] = ACTIONS(13425),
    [sym__pair_operator] = ACTIONS(13425),
    [sym__arrow_operator] = ACTIONS(13425),
    [sym__lazy_or_operator] = ACTIONS(13425),
    [sym__lazy_and_operator] = ACTIONS(13425),
    [sym__comparison_operator] = ACTIONS(13425),
    [sym__pipe_right_operator] = ACTIONS(13425),
    [sym__pipe_left_operator] = ACTIONS(13425),
    [sym__ellipsis_operator] = ACTIONS(13425),
    [sym__plus_operator] = ACTIONS(13425),
    [sym__times_operator] = ACTIONS(13425),
    [sym__rational_operator] = ACTIONS(13425),
    [sym__bitshift_operator] = ACTIONS(13425),
    [sym__power_operator] = ACTIONS(13425),
    [sym__tilde_operator] = ACTIONS(13425),
    [sym__type_order_operator] = ACTIONS(13425),
    [sym__unary_operator] = ACTIONS(13425),
    [sym__unary_plus_operator] = ACTIONS(13425),
    [aux_sym__terminator_token1] = ACTIONS(13425),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13427),
    [sym__command_start] = ACTIONS(13427),
  },
  [8402] = {
    [sym__word_identifier] = ACTIONS(13429),
    [anon_sym_EQ] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(13429),
    [anon_sym_COLON] = ACTIONS(13429),
    [anon_sym_begin] = ACTIONS(13429),
    [anon_sym_module] = ACTIONS(13429),
    [anon_sym_baremodule] = ACTIONS(13429),
    [anon_sym_abstract] = ACTIONS(13429),
    [anon_sym_primitive] = ACTIONS(13429),
    [anon_sym_mutable] = ACTIONS(13429),
    [anon_sym_struct] = ACTIONS(13429),
    [anon_sym_function] = ACTIONS(13429),
    [anon_sym_macro] = ACTIONS(13429),
    [anon_sym_where] = ACTIONS(13429),
    [anon_sym_quote] = ACTIONS(13429),
    [anon_sym_let] = ACTIONS(13429),
    [anon_sym_if] = ACTIONS(13429),
    [anon_sym_try] = ACTIONS(13429),
    [anon_sym_catch] = ACTIONS(13429),
    [anon_sym_finally] = ACTIONS(13429),
    [anon_sym_for] = ACTIONS(13429),
    [anon_sym_while] = ACTIONS(13429),
    [sym_break_statement] = ACTIONS(13429),
    [sym_continue_statement] = ACTIONS(13429),
    [anon_sym_return] = ACTIONS(13429),
    [anon_sym_const] = ACTIONS(13429),
    [anon_sym_global] = ACTIONS(13429),
    [anon_sym_local] = ACTIONS(13429),
    [anon_sym_LPAREN] = ACTIONS(13429),
    [anon_sym_COLON2] = ACTIONS(13429),
    [anon_sym_export] = ACTIONS(13429),
    [anon_sym_import] = ACTIONS(13429),
    [anon_sym_using] = ACTIONS(13429),
    [anon_sym_LBRACK] = ACTIONS(13429),
    [anon_sym_LF] = ACTIONS(13431),
    [anon_sym_in] = ACTIONS(13429),
    [anon_sym_LBRACE] = ACTIONS(13429),
    [anon_sym_DOLLAR] = ACTIONS(13429),
    [anon_sym_COLON_COLON] = ACTIONS(13429),
    [anon_sym_isa] = ACTIONS(13429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13429),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_AT] = ACTIONS(13429),
    [anon_sym_true] = ACTIONS(13429),
    [anon_sym_false] = ACTIONS(13429),
    [aux_sym_integer_literal_token1] = ACTIONS(13429),
    [aux_sym_integer_literal_token2] = ACTIONS(13429),
    [aux_sym_integer_literal_token3] = ACTIONS(13429),
    [aux_sym_integer_literal_token4] = ACTIONS(13429),
    [aux_sym_float_literal_token1] = ACTIONS(13429),
    [aux_sym_float_literal_token3] = ACTIONS(13429),
    [aux_sym_float_literal_token4] = ACTIONS(13429),
    [sym_character_literal] = ACTIONS(13429),
    [sym__pair_operator] = ACTIONS(13429),
    [sym__arrow_operator] = ACTIONS(13429),
    [sym__lazy_or_operator] = ACTIONS(13429),
    [sym__lazy_and_operator] = ACTIONS(13429),
    [sym__comparison_operator] = ACTIONS(13429),
    [sym__pipe_right_operator] = ACTIONS(13429),
    [sym__pipe_left_operator] = ACTIONS(13429),
    [sym__ellipsis_operator] = ACTIONS(13429),
    [sym__plus_operator] = ACTIONS(13429),
    [sym__times_operator] = ACTIONS(13429),
    [sym__rational_operator] = ACTIONS(13429),
    [sym__bitshift_operator] = ACTIONS(13429),
    [sym__power_operator] = ACTIONS(13429),
    [sym__tilde_operator] = ACTIONS(13429),
    [sym__type_order_operator] = ACTIONS(13429),
    [sym__unary_operator] = ACTIONS(13429),
    [sym__unary_plus_operator] = ACTIONS(13429),
    [aux_sym__terminator_token1] = ACTIONS(13429),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13431),
    [sym__command_start] = ACTIONS(13431),
  },
  [8403] = {
    [sym__word_identifier] = ACTIONS(13433),
    [anon_sym_EQ] = ACTIONS(13433),
    [anon_sym_COMMA] = ACTIONS(13433),
    [anon_sym_COLON] = ACTIONS(13433),
    [anon_sym_begin] = ACTIONS(13433),
    [anon_sym_module] = ACTIONS(13433),
    [anon_sym_baremodule] = ACTIONS(13433),
    [anon_sym_abstract] = ACTIONS(13433),
    [anon_sym_primitive] = ACTIONS(13433),
    [anon_sym_mutable] = ACTIONS(13433),
    [anon_sym_struct] = ACTIONS(13433),
    [anon_sym_function] = ACTIONS(13433),
    [anon_sym_macro] = ACTIONS(13433),
    [anon_sym_where] = ACTIONS(13433),
    [anon_sym_quote] = ACTIONS(13433),
    [anon_sym_let] = ACTIONS(13433),
    [anon_sym_if] = ACTIONS(13433),
    [anon_sym_try] = ACTIONS(13433),
    [anon_sym_catch] = ACTIONS(13433),
    [anon_sym_finally] = ACTIONS(13433),
    [anon_sym_for] = ACTIONS(13433),
    [anon_sym_while] = ACTIONS(13433),
    [sym_break_statement] = ACTIONS(13433),
    [sym_continue_statement] = ACTIONS(13433),
    [anon_sym_return] = ACTIONS(13433),
    [anon_sym_const] = ACTIONS(13433),
    [anon_sym_global] = ACTIONS(13433),
    [anon_sym_local] = ACTIONS(13433),
    [anon_sym_LPAREN] = ACTIONS(13433),
    [anon_sym_COLON2] = ACTIONS(13433),
    [anon_sym_export] = ACTIONS(13433),
    [anon_sym_import] = ACTIONS(13433),
    [anon_sym_using] = ACTIONS(13433),
    [anon_sym_LBRACK] = ACTIONS(13433),
    [anon_sym_LF] = ACTIONS(13435),
    [anon_sym_in] = ACTIONS(13433),
    [anon_sym_LBRACE] = ACTIONS(13433),
    [anon_sym_DOLLAR] = ACTIONS(13433),
    [anon_sym_COLON_COLON] = ACTIONS(13433),
    [anon_sym_isa] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13433),
    [anon_sym_QMARK] = ACTIONS(13433),
    [anon_sym_AT] = ACTIONS(13433),
    [anon_sym_true] = ACTIONS(13433),
    [anon_sym_false] = ACTIONS(13433),
    [aux_sym_integer_literal_token1] = ACTIONS(13433),
    [aux_sym_integer_literal_token2] = ACTIONS(13433),
    [aux_sym_integer_literal_token3] = ACTIONS(13433),
    [aux_sym_integer_literal_token4] = ACTIONS(13433),
    [aux_sym_float_literal_token1] = ACTIONS(13433),
    [aux_sym_float_literal_token3] = ACTIONS(13433),
    [aux_sym_float_literal_token4] = ACTIONS(13433),
    [sym_character_literal] = ACTIONS(13433),
    [sym__pair_operator] = ACTIONS(13433),
    [sym__arrow_operator] = ACTIONS(13433),
    [sym__lazy_or_operator] = ACTIONS(13433),
    [sym__lazy_and_operator] = ACTIONS(13433),
    [sym__comparison_operator] = ACTIONS(13433),
    [sym__pipe_right_operator] = ACTIONS(13433),
    [sym__pipe_left_operator] = ACTIONS(13433),
    [sym__ellipsis_operator] = ACTIONS(13433),
    [sym__plus_operator] = ACTIONS(13433),
    [sym__times_operator] = ACTIONS(13433),
    [sym__rational_operator] = ACTIONS(13433),
    [sym__bitshift_operator] = ACTIONS(13433),
    [sym__power_operator] = ACTIONS(13433),
    [sym__tilde_operator] = ACTIONS(13433),
    [sym__type_order_operator] = ACTIONS(13433),
    [sym__unary_operator] = ACTIONS(13433),
    [sym__unary_plus_operator] = ACTIONS(13433),
    [aux_sym__terminator_token1] = ACTIONS(13433),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13435),
    [sym__command_start] = ACTIONS(13435),
  },
  [8404] = {
    [sym__word_identifier] = ACTIONS(13437),
    [anon_sym_EQ] = ACTIONS(13437),
    [anon_sym_COMMA] = ACTIONS(13437),
    [anon_sym_COLON] = ACTIONS(13437),
    [anon_sym_begin] = ACTIONS(13437),
    [anon_sym_module] = ACTIONS(13437),
    [anon_sym_baremodule] = ACTIONS(13437),
    [anon_sym_abstract] = ACTIONS(13437),
    [anon_sym_primitive] = ACTIONS(13437),
    [anon_sym_mutable] = ACTIONS(13437),
    [anon_sym_struct] = ACTIONS(13437),
    [anon_sym_function] = ACTIONS(13437),
    [anon_sym_macro] = ACTIONS(13437),
    [anon_sym_where] = ACTIONS(13437),
    [anon_sym_quote] = ACTIONS(13437),
    [anon_sym_let] = ACTIONS(13437),
    [anon_sym_if] = ACTIONS(13437),
    [anon_sym_try] = ACTIONS(13437),
    [anon_sym_catch] = ACTIONS(13437),
    [anon_sym_finally] = ACTIONS(13437),
    [anon_sym_for] = ACTIONS(13437),
    [anon_sym_while] = ACTIONS(13437),
    [sym_break_statement] = ACTIONS(13437),
    [sym_continue_statement] = ACTIONS(13437),
    [anon_sym_return] = ACTIONS(13437),
    [anon_sym_const] = ACTIONS(13437),
    [anon_sym_global] = ACTIONS(13437),
    [anon_sym_local] = ACTIONS(13437),
    [anon_sym_LPAREN] = ACTIONS(13437),
    [anon_sym_COLON2] = ACTIONS(13437),
    [anon_sym_export] = ACTIONS(13437),
    [anon_sym_import] = ACTIONS(13437),
    [anon_sym_using] = ACTIONS(13437),
    [anon_sym_LBRACK] = ACTIONS(13437),
    [anon_sym_LF] = ACTIONS(13439),
    [anon_sym_in] = ACTIONS(13437),
    [anon_sym_LBRACE] = ACTIONS(13437),
    [anon_sym_DOLLAR] = ACTIONS(13437),
    [anon_sym_COLON_COLON] = ACTIONS(13437),
    [anon_sym_isa] = ACTIONS(13437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13437),
    [anon_sym_QMARK] = ACTIONS(13437),
    [anon_sym_AT] = ACTIONS(13437),
    [anon_sym_true] = ACTIONS(13437),
    [anon_sym_false] = ACTIONS(13437),
    [aux_sym_integer_literal_token1] = ACTIONS(13437),
    [aux_sym_integer_literal_token2] = ACTIONS(13437),
    [aux_sym_integer_literal_token3] = ACTIONS(13437),
    [aux_sym_integer_literal_token4] = ACTIONS(13437),
    [aux_sym_float_literal_token1] = ACTIONS(13437),
    [aux_sym_float_literal_token3] = ACTIONS(13437),
    [aux_sym_float_literal_token4] = ACTIONS(13437),
    [sym_character_literal] = ACTIONS(13437),
    [sym__pair_operator] = ACTIONS(13437),
    [sym__arrow_operator] = ACTIONS(13437),
    [sym__lazy_or_operator] = ACTIONS(13437),
    [sym__lazy_and_operator] = ACTIONS(13437),
    [sym__comparison_operator] = ACTIONS(13437),
    [sym__pipe_right_operator] = ACTIONS(13437),
    [sym__pipe_left_operator] = ACTIONS(13437),
    [sym__ellipsis_operator] = ACTIONS(13437),
    [sym__plus_operator] = ACTIONS(13437),
    [sym__times_operator] = ACTIONS(13437),
    [sym__rational_operator] = ACTIONS(13437),
    [sym__bitshift_operator] = ACTIONS(13437),
    [sym__power_operator] = ACTIONS(13437),
    [sym__tilde_operator] = ACTIONS(13437),
    [sym__type_order_operator] = ACTIONS(13437),
    [sym__unary_operator] = ACTIONS(13437),
    [sym__unary_plus_operator] = ACTIONS(13437),
    [aux_sym__terminator_token1] = ACTIONS(13437),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13439),
    [sym__command_start] = ACTIONS(13439),
  },
  [8405] = {
    [sym__word_identifier] = ACTIONS(13441),
    [anon_sym_EQ] = ACTIONS(13441),
    [anon_sym_COMMA] = ACTIONS(13441),
    [anon_sym_COLON] = ACTIONS(13441),
    [anon_sym_begin] = ACTIONS(13441),
    [anon_sym_module] = ACTIONS(13441),
    [anon_sym_baremodule] = ACTIONS(13441),
    [anon_sym_abstract] = ACTIONS(13441),
    [anon_sym_primitive] = ACTIONS(13441),
    [anon_sym_mutable] = ACTIONS(13441),
    [anon_sym_struct] = ACTIONS(13441),
    [anon_sym_function] = ACTIONS(13441),
    [anon_sym_macro] = ACTIONS(13441),
    [anon_sym_where] = ACTIONS(13441),
    [anon_sym_quote] = ACTIONS(13441),
    [anon_sym_let] = ACTIONS(13441),
    [anon_sym_if] = ACTIONS(13441),
    [anon_sym_try] = ACTIONS(13441),
    [anon_sym_catch] = ACTIONS(13441),
    [anon_sym_finally] = ACTIONS(13441),
    [anon_sym_for] = ACTIONS(13441),
    [anon_sym_while] = ACTIONS(13441),
    [sym_break_statement] = ACTIONS(13441),
    [sym_continue_statement] = ACTIONS(13441),
    [anon_sym_return] = ACTIONS(13441),
    [anon_sym_const] = ACTIONS(13441),
    [anon_sym_global] = ACTIONS(13441),
    [anon_sym_local] = ACTIONS(13441),
    [anon_sym_LPAREN] = ACTIONS(13441),
    [anon_sym_COLON2] = ACTIONS(13441),
    [anon_sym_export] = ACTIONS(13441),
    [anon_sym_import] = ACTIONS(13441),
    [anon_sym_using] = ACTIONS(13441),
    [anon_sym_LBRACK] = ACTIONS(13441),
    [anon_sym_LF] = ACTIONS(13443),
    [anon_sym_in] = ACTIONS(13441),
    [anon_sym_LBRACE] = ACTIONS(13441),
    [anon_sym_DOLLAR] = ACTIONS(13441),
    [anon_sym_COLON_COLON] = ACTIONS(13441),
    [anon_sym_isa] = ACTIONS(13441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13441),
    [anon_sym_QMARK] = ACTIONS(13441),
    [anon_sym_AT] = ACTIONS(13441),
    [anon_sym_true] = ACTIONS(13441),
    [anon_sym_false] = ACTIONS(13441),
    [aux_sym_integer_literal_token1] = ACTIONS(13441),
    [aux_sym_integer_literal_token2] = ACTIONS(13441),
    [aux_sym_integer_literal_token3] = ACTIONS(13441),
    [aux_sym_integer_literal_token4] = ACTIONS(13441),
    [aux_sym_float_literal_token1] = ACTIONS(13441),
    [aux_sym_float_literal_token3] = ACTIONS(13441),
    [aux_sym_float_literal_token4] = ACTIONS(13441),
    [sym_character_literal] = ACTIONS(13441),
    [sym__pair_operator] = ACTIONS(13441),
    [sym__arrow_operator] = ACTIONS(13441),
    [sym__lazy_or_operator] = ACTIONS(13441),
    [sym__lazy_and_operator] = ACTIONS(13441),
    [sym__comparison_operator] = ACTIONS(13441),
    [sym__pipe_right_operator] = ACTIONS(13441),
    [sym__pipe_left_operator] = ACTIONS(13441),
    [sym__ellipsis_operator] = ACTIONS(13441),
    [sym__plus_operator] = ACTIONS(13441),
    [sym__times_operator] = ACTIONS(13441),
    [sym__rational_operator] = ACTIONS(13441),
    [sym__bitshift_operator] = ACTIONS(13441),
    [sym__power_operator] = ACTIONS(13441),
    [sym__tilde_operator] = ACTIONS(13441),
    [sym__type_order_operator] = ACTIONS(13441),
    [sym__unary_operator] = ACTIONS(13441),
    [sym__unary_plus_operator] = ACTIONS(13441),
    [aux_sym__terminator_token1] = ACTIONS(13441),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13443),
    [sym__command_start] = ACTIONS(13443),
  },
  [8406] = {
    [sym__word_identifier] = ACTIONS(13445),
    [anon_sym_EQ] = ACTIONS(13445),
    [anon_sym_COMMA] = ACTIONS(13445),
    [anon_sym_COLON] = ACTIONS(13445),
    [anon_sym_begin] = ACTIONS(13445),
    [anon_sym_module] = ACTIONS(13445),
    [anon_sym_baremodule] = ACTIONS(13445),
    [anon_sym_abstract] = ACTIONS(13445),
    [anon_sym_primitive] = ACTIONS(13445),
    [anon_sym_mutable] = ACTIONS(13445),
    [anon_sym_struct] = ACTIONS(13445),
    [anon_sym_function] = ACTIONS(13445),
    [anon_sym_macro] = ACTIONS(13445),
    [anon_sym_where] = ACTIONS(13445),
    [anon_sym_quote] = ACTIONS(13445),
    [anon_sym_let] = ACTIONS(13445),
    [anon_sym_if] = ACTIONS(13445),
    [anon_sym_try] = ACTIONS(13445),
    [anon_sym_catch] = ACTIONS(13445),
    [anon_sym_finally] = ACTIONS(13445),
    [anon_sym_for] = ACTIONS(13445),
    [anon_sym_while] = ACTIONS(13445),
    [sym_break_statement] = ACTIONS(13445),
    [sym_continue_statement] = ACTIONS(13445),
    [anon_sym_return] = ACTIONS(13445),
    [anon_sym_const] = ACTIONS(13445),
    [anon_sym_global] = ACTIONS(13445),
    [anon_sym_local] = ACTIONS(13445),
    [anon_sym_LPAREN] = ACTIONS(13445),
    [anon_sym_COLON2] = ACTIONS(13445),
    [anon_sym_export] = ACTIONS(13445),
    [anon_sym_import] = ACTIONS(13445),
    [anon_sym_using] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(13445),
    [anon_sym_LF] = ACTIONS(13447),
    [anon_sym_in] = ACTIONS(13445),
    [anon_sym_LBRACE] = ACTIONS(13445),
    [anon_sym_DOLLAR] = ACTIONS(13445),
    [anon_sym_COLON_COLON] = ACTIONS(13445),
    [anon_sym_isa] = ACTIONS(13445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13445),
    [anon_sym_QMARK] = ACTIONS(13445),
    [anon_sym_AT] = ACTIONS(13445),
    [anon_sym_true] = ACTIONS(13445),
    [anon_sym_false] = ACTIONS(13445),
    [aux_sym_integer_literal_token1] = ACTIONS(13445),
    [aux_sym_integer_literal_token2] = ACTIONS(13445),
    [aux_sym_integer_literal_token3] = ACTIONS(13445),
    [aux_sym_integer_literal_token4] = ACTIONS(13445),
    [aux_sym_float_literal_token1] = ACTIONS(13445),
    [aux_sym_float_literal_token3] = ACTIONS(13445),
    [aux_sym_float_literal_token4] = ACTIONS(13445),
    [sym_character_literal] = ACTIONS(13445),
    [sym__pair_operator] = ACTIONS(13445),
    [sym__arrow_operator] = ACTIONS(13445),
    [sym__lazy_or_operator] = ACTIONS(13445),
    [sym__lazy_and_operator] = ACTIONS(13445),
    [sym__comparison_operator] = ACTIONS(13445),
    [sym__pipe_right_operator] = ACTIONS(13445),
    [sym__pipe_left_operator] = ACTIONS(13445),
    [sym__ellipsis_operator] = ACTIONS(13445),
    [sym__plus_operator] = ACTIONS(13445),
    [sym__times_operator] = ACTIONS(13445),
    [sym__rational_operator] = ACTIONS(13445),
    [sym__bitshift_operator] = ACTIONS(13445),
    [sym__power_operator] = ACTIONS(13445),
    [sym__tilde_operator] = ACTIONS(13445),
    [sym__type_order_operator] = ACTIONS(13445),
    [sym__unary_operator] = ACTIONS(13445),
    [sym__unary_plus_operator] = ACTIONS(13445),
    [aux_sym__terminator_token1] = ACTIONS(13445),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13447),
    [sym__command_start] = ACTIONS(13447),
  },
  [8407] = {
    [sym__word_identifier] = ACTIONS(13449),
    [anon_sym_EQ] = ACTIONS(13449),
    [anon_sym_COMMA] = ACTIONS(13449),
    [anon_sym_COLON] = ACTIONS(13449),
    [anon_sym_begin] = ACTIONS(13449),
    [anon_sym_module] = ACTIONS(13449),
    [anon_sym_baremodule] = ACTIONS(13449),
    [anon_sym_abstract] = ACTIONS(13449),
    [anon_sym_primitive] = ACTIONS(13449),
    [anon_sym_mutable] = ACTIONS(13449),
    [anon_sym_struct] = ACTIONS(13449),
    [anon_sym_function] = ACTIONS(13449),
    [anon_sym_macro] = ACTIONS(13449),
    [anon_sym_where] = ACTIONS(13449),
    [anon_sym_quote] = ACTIONS(13449),
    [anon_sym_let] = ACTIONS(13449),
    [anon_sym_if] = ACTIONS(13449),
    [anon_sym_try] = ACTIONS(13449),
    [anon_sym_catch] = ACTIONS(13449),
    [anon_sym_finally] = ACTIONS(13449),
    [anon_sym_for] = ACTIONS(13449),
    [anon_sym_while] = ACTIONS(13449),
    [sym_break_statement] = ACTIONS(13449),
    [sym_continue_statement] = ACTIONS(13449),
    [anon_sym_return] = ACTIONS(13449),
    [anon_sym_const] = ACTIONS(13449),
    [anon_sym_global] = ACTIONS(13449),
    [anon_sym_local] = ACTIONS(13449),
    [anon_sym_LPAREN] = ACTIONS(13449),
    [anon_sym_COLON2] = ACTIONS(13449),
    [anon_sym_export] = ACTIONS(13449),
    [anon_sym_import] = ACTIONS(13449),
    [anon_sym_using] = ACTIONS(13449),
    [anon_sym_LBRACK] = ACTIONS(13449),
    [anon_sym_LF] = ACTIONS(13451),
    [anon_sym_in] = ACTIONS(13449),
    [anon_sym_LBRACE] = ACTIONS(13449),
    [anon_sym_DOLLAR] = ACTIONS(13449),
    [anon_sym_COLON_COLON] = ACTIONS(13449),
    [anon_sym_isa] = ACTIONS(13449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13449),
    [anon_sym_QMARK] = ACTIONS(13449),
    [anon_sym_AT] = ACTIONS(13449),
    [anon_sym_true] = ACTIONS(13449),
    [anon_sym_false] = ACTIONS(13449),
    [aux_sym_integer_literal_token1] = ACTIONS(13449),
    [aux_sym_integer_literal_token2] = ACTIONS(13449),
    [aux_sym_integer_literal_token3] = ACTIONS(13449),
    [aux_sym_integer_literal_token4] = ACTIONS(13449),
    [aux_sym_float_literal_token1] = ACTIONS(13449),
    [aux_sym_float_literal_token3] = ACTIONS(13449),
    [aux_sym_float_literal_token4] = ACTIONS(13449),
    [sym_character_literal] = ACTIONS(13449),
    [sym__pair_operator] = ACTIONS(13449),
    [sym__arrow_operator] = ACTIONS(13449),
    [sym__lazy_or_operator] = ACTIONS(13449),
    [sym__lazy_and_operator] = ACTIONS(13449),
    [sym__comparison_operator] = ACTIONS(13449),
    [sym__pipe_right_operator] = ACTIONS(13449),
    [sym__pipe_left_operator] = ACTIONS(13449),
    [sym__ellipsis_operator] = ACTIONS(13449),
    [sym__plus_operator] = ACTIONS(13449),
    [sym__times_operator] = ACTIONS(13449),
    [sym__rational_operator] = ACTIONS(13449),
    [sym__bitshift_operator] = ACTIONS(13449),
    [sym__power_operator] = ACTIONS(13449),
    [sym__tilde_operator] = ACTIONS(13449),
    [sym__type_order_operator] = ACTIONS(13449),
    [sym__unary_operator] = ACTIONS(13449),
    [sym__unary_plus_operator] = ACTIONS(13449),
    [aux_sym__terminator_token1] = ACTIONS(13449),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13451),
    [sym__command_start] = ACTIONS(13451),
  },
  [8408] = {
    [sym__word_identifier] = ACTIONS(13453),
    [anon_sym_EQ] = ACTIONS(13453),
    [anon_sym_COMMA] = ACTIONS(13453),
    [anon_sym_COLON] = ACTIONS(13453),
    [anon_sym_begin] = ACTIONS(13453),
    [anon_sym_module] = ACTIONS(13453),
    [anon_sym_baremodule] = ACTIONS(13453),
    [anon_sym_abstract] = ACTIONS(13453),
    [anon_sym_primitive] = ACTIONS(13453),
    [anon_sym_mutable] = ACTIONS(13453),
    [anon_sym_struct] = ACTIONS(13453),
    [anon_sym_function] = ACTIONS(13453),
    [anon_sym_macro] = ACTIONS(13453),
    [anon_sym_where] = ACTIONS(13453),
    [anon_sym_quote] = ACTIONS(13453),
    [anon_sym_let] = ACTIONS(13453),
    [anon_sym_if] = ACTIONS(13453),
    [anon_sym_try] = ACTIONS(13453),
    [anon_sym_catch] = ACTIONS(13453),
    [anon_sym_finally] = ACTIONS(13453),
    [anon_sym_for] = ACTIONS(13453),
    [anon_sym_while] = ACTIONS(13453),
    [sym_break_statement] = ACTIONS(13453),
    [sym_continue_statement] = ACTIONS(13453),
    [anon_sym_return] = ACTIONS(13453),
    [anon_sym_const] = ACTIONS(13453),
    [anon_sym_global] = ACTIONS(13453),
    [anon_sym_local] = ACTIONS(13453),
    [anon_sym_LPAREN] = ACTIONS(13453),
    [anon_sym_COLON2] = ACTIONS(13453),
    [anon_sym_export] = ACTIONS(13453),
    [anon_sym_import] = ACTIONS(13453),
    [anon_sym_using] = ACTIONS(13453),
    [anon_sym_LBRACK] = ACTIONS(13453),
    [anon_sym_LF] = ACTIONS(13455),
    [anon_sym_in] = ACTIONS(13453),
    [anon_sym_LBRACE] = ACTIONS(13453),
    [anon_sym_DOLLAR] = ACTIONS(13453),
    [anon_sym_COLON_COLON] = ACTIONS(13453),
    [anon_sym_isa] = ACTIONS(13453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13453),
    [anon_sym_QMARK] = ACTIONS(13453),
    [anon_sym_AT] = ACTIONS(13453),
    [anon_sym_true] = ACTIONS(13453),
    [anon_sym_false] = ACTIONS(13453),
    [aux_sym_integer_literal_token1] = ACTIONS(13453),
    [aux_sym_integer_literal_token2] = ACTIONS(13453),
    [aux_sym_integer_literal_token3] = ACTIONS(13453),
    [aux_sym_integer_literal_token4] = ACTIONS(13453),
    [aux_sym_float_literal_token1] = ACTIONS(13453),
    [aux_sym_float_literal_token3] = ACTIONS(13453),
    [aux_sym_float_literal_token4] = ACTIONS(13453),
    [sym_character_literal] = ACTIONS(13453),
    [sym__pair_operator] = ACTIONS(13453),
    [sym__arrow_operator] = ACTIONS(13453),
    [sym__lazy_or_operator] = ACTIONS(13453),
    [sym__lazy_and_operator] = ACTIONS(13453),
    [sym__comparison_operator] = ACTIONS(13453),
    [sym__pipe_right_operator] = ACTIONS(13453),
    [sym__pipe_left_operator] = ACTIONS(13453),
    [sym__ellipsis_operator] = ACTIONS(13453),
    [sym__plus_operator] = ACTIONS(13453),
    [sym__times_operator] = ACTIONS(13453),
    [sym__rational_operator] = ACTIONS(13453),
    [sym__bitshift_operator] = ACTIONS(13453),
    [sym__power_operator] = ACTIONS(13453),
    [sym__tilde_operator] = ACTIONS(13453),
    [sym__type_order_operator] = ACTIONS(13453),
    [sym__unary_operator] = ACTIONS(13453),
    [sym__unary_plus_operator] = ACTIONS(13453),
    [aux_sym__terminator_token1] = ACTIONS(13453),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13455),
    [sym__command_start] = ACTIONS(13455),
  },
  [8409] = {
    [sym__word_identifier] = ACTIONS(13457),
    [anon_sym_EQ] = ACTIONS(13457),
    [anon_sym_COMMA] = ACTIONS(13457),
    [anon_sym_COLON] = ACTIONS(13457),
    [anon_sym_begin] = ACTIONS(13457),
    [anon_sym_module] = ACTIONS(13457),
    [anon_sym_baremodule] = ACTIONS(13457),
    [anon_sym_abstract] = ACTIONS(13457),
    [anon_sym_primitive] = ACTIONS(13457),
    [anon_sym_mutable] = ACTIONS(13457),
    [anon_sym_struct] = ACTIONS(13457),
    [anon_sym_function] = ACTIONS(13457),
    [anon_sym_macro] = ACTIONS(13457),
    [anon_sym_where] = ACTIONS(13457),
    [anon_sym_quote] = ACTIONS(13457),
    [anon_sym_let] = ACTIONS(13457),
    [anon_sym_if] = ACTIONS(13457),
    [anon_sym_try] = ACTIONS(13457),
    [anon_sym_catch] = ACTIONS(13457),
    [anon_sym_finally] = ACTIONS(13457),
    [anon_sym_for] = ACTIONS(13457),
    [anon_sym_while] = ACTIONS(13457),
    [sym_break_statement] = ACTIONS(13457),
    [sym_continue_statement] = ACTIONS(13457),
    [anon_sym_return] = ACTIONS(13457),
    [anon_sym_const] = ACTIONS(13457),
    [anon_sym_global] = ACTIONS(13457),
    [anon_sym_local] = ACTIONS(13457),
    [anon_sym_LPAREN] = ACTIONS(13457),
    [anon_sym_COLON2] = ACTIONS(13457),
    [anon_sym_export] = ACTIONS(13457),
    [anon_sym_import] = ACTIONS(13457),
    [anon_sym_using] = ACTIONS(13457),
    [anon_sym_LBRACK] = ACTIONS(13457),
    [anon_sym_LF] = ACTIONS(13459),
    [anon_sym_in] = ACTIONS(13457),
    [anon_sym_LBRACE] = ACTIONS(13457),
    [anon_sym_DOLLAR] = ACTIONS(13457),
    [anon_sym_COLON_COLON] = ACTIONS(13457),
    [anon_sym_isa] = ACTIONS(13457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13457),
    [anon_sym_QMARK] = ACTIONS(13457),
    [anon_sym_AT] = ACTIONS(13457),
    [anon_sym_true] = ACTIONS(13457),
    [anon_sym_false] = ACTIONS(13457),
    [aux_sym_integer_literal_token1] = ACTIONS(13457),
    [aux_sym_integer_literal_token2] = ACTIONS(13457),
    [aux_sym_integer_literal_token3] = ACTIONS(13457),
    [aux_sym_integer_literal_token4] = ACTIONS(13457),
    [aux_sym_float_literal_token1] = ACTIONS(13457),
    [aux_sym_float_literal_token3] = ACTIONS(13457),
    [aux_sym_float_literal_token4] = ACTIONS(13457),
    [sym_character_literal] = ACTIONS(13457),
    [sym__pair_operator] = ACTIONS(13457),
    [sym__arrow_operator] = ACTIONS(13457),
    [sym__lazy_or_operator] = ACTIONS(13457),
    [sym__lazy_and_operator] = ACTIONS(13457),
    [sym__comparison_operator] = ACTIONS(13457),
    [sym__pipe_right_operator] = ACTIONS(13457),
    [sym__pipe_left_operator] = ACTIONS(13457),
    [sym__ellipsis_operator] = ACTIONS(13457),
    [sym__plus_operator] = ACTIONS(13457),
    [sym__times_operator] = ACTIONS(13457),
    [sym__rational_operator] = ACTIONS(13457),
    [sym__bitshift_operator] = ACTIONS(13457),
    [sym__power_operator] = ACTIONS(13457),
    [sym__tilde_operator] = ACTIONS(13457),
    [sym__type_order_operator] = ACTIONS(13457),
    [sym__unary_operator] = ACTIONS(13457),
    [sym__unary_plus_operator] = ACTIONS(13457),
    [aux_sym__terminator_token1] = ACTIONS(13457),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13459),
    [sym__command_start] = ACTIONS(13459),
  },
  [8410] = {
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13070),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_end] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_finally] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [8411] = {
    [sym__word_identifier] = ACTIONS(13461),
    [anon_sym_EQ] = ACTIONS(13461),
    [anon_sym_COMMA] = ACTIONS(13461),
    [anon_sym_COLON] = ACTIONS(13461),
    [anon_sym_begin] = ACTIONS(13461),
    [anon_sym_module] = ACTIONS(13461),
    [anon_sym_baremodule] = ACTIONS(13461),
    [anon_sym_abstract] = ACTIONS(13461),
    [anon_sym_primitive] = ACTIONS(13461),
    [anon_sym_mutable] = ACTIONS(13461),
    [anon_sym_struct] = ACTIONS(13461),
    [anon_sym_function] = ACTIONS(13461),
    [anon_sym_macro] = ACTIONS(13461),
    [anon_sym_where] = ACTIONS(13461),
    [anon_sym_quote] = ACTIONS(13461),
    [anon_sym_let] = ACTIONS(13461),
    [anon_sym_if] = ACTIONS(13461),
    [anon_sym_try] = ACTIONS(13461),
    [anon_sym_catch] = ACTIONS(13461),
    [anon_sym_finally] = ACTIONS(13461),
    [anon_sym_for] = ACTIONS(13461),
    [anon_sym_while] = ACTIONS(13461),
    [sym_break_statement] = ACTIONS(13461),
    [sym_continue_statement] = ACTIONS(13461),
    [anon_sym_return] = ACTIONS(13461),
    [anon_sym_const] = ACTIONS(13461),
    [anon_sym_global] = ACTIONS(13461),
    [anon_sym_local] = ACTIONS(13461),
    [anon_sym_LPAREN] = ACTIONS(13461),
    [anon_sym_COLON2] = ACTIONS(13461),
    [anon_sym_export] = ACTIONS(13461),
    [anon_sym_import] = ACTIONS(13461),
    [anon_sym_using] = ACTIONS(13461),
    [anon_sym_LBRACK] = ACTIONS(13461),
    [anon_sym_LF] = ACTIONS(13463),
    [anon_sym_in] = ACTIONS(13461),
    [anon_sym_LBRACE] = ACTIONS(13461),
    [anon_sym_DOLLAR] = ACTIONS(13461),
    [anon_sym_COLON_COLON] = ACTIONS(13461),
    [anon_sym_isa] = ACTIONS(13461),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13461),
    [anon_sym_QMARK] = ACTIONS(13461),
    [anon_sym_AT] = ACTIONS(13461),
    [anon_sym_true] = ACTIONS(13461),
    [anon_sym_false] = ACTIONS(13461),
    [aux_sym_integer_literal_token1] = ACTIONS(13461),
    [aux_sym_integer_literal_token2] = ACTIONS(13461),
    [aux_sym_integer_literal_token3] = ACTIONS(13461),
    [aux_sym_integer_literal_token4] = ACTIONS(13461),
    [aux_sym_float_literal_token1] = ACTIONS(13461),
    [aux_sym_float_literal_token3] = ACTIONS(13461),
    [aux_sym_float_literal_token4] = ACTIONS(13461),
    [sym_character_literal] = ACTIONS(13461),
    [sym__pair_operator] = ACTIONS(13461),
    [sym__arrow_operator] = ACTIONS(13461),
    [sym__lazy_or_operator] = ACTIONS(13461),
    [sym__lazy_and_operator] = ACTIONS(13461),
    [sym__comparison_operator] = ACTIONS(13461),
    [sym__pipe_right_operator] = ACTIONS(13461),
    [sym__pipe_left_operator] = ACTIONS(13461),
    [sym__ellipsis_operator] = ACTIONS(13461),
    [sym__plus_operator] = ACTIONS(13461),
    [sym__times_operator] = ACTIONS(13461),
    [sym__rational_operator] = ACTIONS(13461),
    [sym__bitshift_operator] = ACTIONS(13461),
    [sym__power_operator] = ACTIONS(13461),
    [sym__tilde_operator] = ACTIONS(13461),
    [sym__type_order_operator] = ACTIONS(13461),
    [sym__unary_operator] = ACTIONS(13461),
    [sym__unary_plus_operator] = ACTIONS(13461),
    [aux_sym__terminator_token1] = ACTIONS(13461),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13463),
    [sym__command_start] = ACTIONS(13463),
  },
  [8412] = {
    [sym__word_identifier] = ACTIONS(13481),
    [anon_sym_EQ] = ACTIONS(13481),
    [anon_sym_COMMA] = ACTIONS(13481),
    [anon_sym_COLON] = ACTIONS(13481),
    [anon_sym_begin] = ACTIONS(13481),
    [anon_sym_module] = ACTIONS(13481),
    [anon_sym_baremodule] = ACTIONS(13481),
    [anon_sym_abstract] = ACTIONS(13481),
    [anon_sym_primitive] = ACTIONS(13481),
    [anon_sym_mutable] = ACTIONS(13481),
    [anon_sym_struct] = ACTIONS(13481),
    [anon_sym_function] = ACTIONS(13481),
    [anon_sym_macro] = ACTIONS(13481),
    [anon_sym_where] = ACTIONS(13481),
    [anon_sym_quote] = ACTIONS(13481),
    [anon_sym_let] = ACTIONS(13481),
    [anon_sym_if] = ACTIONS(13481),
    [anon_sym_try] = ACTIONS(13481),
    [anon_sym_catch] = ACTIONS(13481),
    [anon_sym_finally] = ACTIONS(13481),
    [anon_sym_for] = ACTIONS(13481),
    [anon_sym_while] = ACTIONS(13481),
    [sym_break_statement] = ACTIONS(13481),
    [sym_continue_statement] = ACTIONS(13481),
    [anon_sym_return] = ACTIONS(13481),
    [anon_sym_const] = ACTIONS(13481),
    [anon_sym_global] = ACTIONS(13481),
    [anon_sym_local] = ACTIONS(13481),
    [anon_sym_LPAREN] = ACTIONS(13481),
    [anon_sym_COLON2] = ACTIONS(13481),
    [anon_sym_export] = ACTIONS(13481),
    [anon_sym_import] = ACTIONS(13481),
    [anon_sym_using] = ACTIONS(13481),
    [anon_sym_LBRACK] = ACTIONS(13481),
    [anon_sym_LF] = ACTIONS(13483),
    [anon_sym_in] = ACTIONS(13481),
    [anon_sym_LBRACE] = ACTIONS(13481),
    [anon_sym_DOLLAR] = ACTIONS(13481),
    [anon_sym_COLON_COLON] = ACTIONS(13481),
    [anon_sym_isa] = ACTIONS(13481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13481),
    [anon_sym_QMARK] = ACTIONS(13481),
    [anon_sym_AT] = ACTIONS(13481),
    [anon_sym_true] = ACTIONS(13481),
    [anon_sym_false] = ACTIONS(13481),
    [aux_sym_integer_literal_token1] = ACTIONS(13481),
    [aux_sym_integer_literal_token2] = ACTIONS(13481),
    [aux_sym_integer_literal_token3] = ACTIONS(13481),
    [aux_sym_integer_literal_token4] = ACTIONS(13481),
    [aux_sym_float_literal_token1] = ACTIONS(13481),
    [aux_sym_float_literal_token3] = ACTIONS(13481),
    [aux_sym_float_literal_token4] = ACTIONS(13481),
    [sym_character_literal] = ACTIONS(13481),
    [sym__pair_operator] = ACTIONS(13481),
    [sym__arrow_operator] = ACTIONS(13481),
    [sym__lazy_or_operator] = ACTIONS(13481),
    [sym__lazy_and_operator] = ACTIONS(13481),
    [sym__comparison_operator] = ACTIONS(13481),
    [sym__pipe_right_operator] = ACTIONS(13481),
    [sym__pipe_left_operator] = ACTIONS(13481),
    [sym__ellipsis_operator] = ACTIONS(13481),
    [sym__plus_operator] = ACTIONS(13481),
    [sym__times_operator] = ACTIONS(13481),
    [sym__rational_operator] = ACTIONS(13481),
    [sym__bitshift_operator] = ACTIONS(13481),
    [sym__power_operator] = ACTIONS(13481),
    [sym__tilde_operator] = ACTIONS(13481),
    [sym__type_order_operator] = ACTIONS(13481),
    [sym__unary_operator] = ACTIONS(13481),
    [sym__unary_plus_operator] = ACTIONS(13481),
    [aux_sym__terminator_token1] = ACTIONS(13481),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13483),
    [sym__command_start] = ACTIONS(13483),
  },
  [8413] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_as] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_RPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_SEMI] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [8414] = {
    [sym__word_identifier] = ACTIONS(13485),
    [anon_sym_EQ] = ACTIONS(13485),
    [anon_sym_COMMA] = ACTIONS(13485),
    [anon_sym_COLON] = ACTIONS(13485),
    [anon_sym_begin] = ACTIONS(13485),
    [anon_sym_module] = ACTIONS(13485),
    [anon_sym_baremodule] = ACTIONS(13485),
    [anon_sym_abstract] = ACTIONS(13485),
    [anon_sym_primitive] = ACTIONS(13485),
    [anon_sym_mutable] = ACTIONS(13485),
    [anon_sym_struct] = ACTIONS(13485),
    [anon_sym_function] = ACTIONS(13485),
    [anon_sym_macro] = ACTIONS(13485),
    [anon_sym_where] = ACTIONS(13485),
    [anon_sym_quote] = ACTIONS(13485),
    [anon_sym_let] = ACTIONS(13485),
    [anon_sym_if] = ACTIONS(13485),
    [anon_sym_try] = ACTIONS(13485),
    [anon_sym_catch] = ACTIONS(13485),
    [anon_sym_finally] = ACTIONS(13485),
    [anon_sym_for] = ACTIONS(13485),
    [anon_sym_while] = ACTIONS(13485),
    [sym_break_statement] = ACTIONS(13485),
    [sym_continue_statement] = ACTIONS(13485),
    [anon_sym_return] = ACTIONS(13485),
    [anon_sym_const] = ACTIONS(13485),
    [anon_sym_global] = ACTIONS(13485),
    [anon_sym_local] = ACTIONS(13485),
    [anon_sym_LPAREN] = ACTIONS(13485),
    [anon_sym_COLON2] = ACTIONS(13485),
    [anon_sym_export] = ACTIONS(13485),
    [anon_sym_import] = ACTIONS(13485),
    [anon_sym_using] = ACTIONS(13485),
    [anon_sym_LBRACK] = ACTIONS(13485),
    [anon_sym_LF] = ACTIONS(13487),
    [anon_sym_in] = ACTIONS(13485),
    [anon_sym_LBRACE] = ACTIONS(13485),
    [anon_sym_DOLLAR] = ACTIONS(13485),
    [anon_sym_COLON_COLON] = ACTIONS(13485),
    [anon_sym_isa] = ACTIONS(13485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13485),
    [anon_sym_QMARK] = ACTIONS(13485),
    [anon_sym_AT] = ACTIONS(13485),
    [anon_sym_true] = ACTIONS(13485),
    [anon_sym_false] = ACTIONS(13485),
    [aux_sym_integer_literal_token1] = ACTIONS(13485),
    [aux_sym_integer_literal_token2] = ACTIONS(13485),
    [aux_sym_integer_literal_token3] = ACTIONS(13485),
    [aux_sym_integer_literal_token4] = ACTIONS(13485),
    [aux_sym_float_literal_token1] = ACTIONS(13485),
    [aux_sym_float_literal_token3] = ACTIONS(13485),
    [aux_sym_float_literal_token4] = ACTIONS(13485),
    [sym_character_literal] = ACTIONS(13485),
    [sym__pair_operator] = ACTIONS(13485),
    [sym__arrow_operator] = ACTIONS(13485),
    [sym__lazy_or_operator] = ACTIONS(13485),
    [sym__lazy_and_operator] = ACTIONS(13485),
    [sym__comparison_operator] = ACTIONS(13485),
    [sym__pipe_right_operator] = ACTIONS(13485),
    [sym__pipe_left_operator] = ACTIONS(13485),
    [sym__ellipsis_operator] = ACTIONS(13485),
    [sym__plus_operator] = ACTIONS(13485),
    [sym__times_operator] = ACTIONS(13485),
    [sym__rational_operator] = ACTIONS(13485),
    [sym__bitshift_operator] = ACTIONS(13485),
    [sym__power_operator] = ACTIONS(13485),
    [sym__tilde_operator] = ACTIONS(13485),
    [sym__type_order_operator] = ACTIONS(13485),
    [sym__unary_operator] = ACTIONS(13485),
    [sym__unary_plus_operator] = ACTIONS(13485),
    [aux_sym__terminator_token1] = ACTIONS(13485),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13487),
    [sym__command_start] = ACTIONS(13487),
  },
  [8415] = {
    [ts_builtin_sym_end] = ACTIONS(13336),
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_RPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14519),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_RBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14521),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(14521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14521),
    [sym__pipe_right_operator] = ACTIONS(14525),
    [sym__pipe_left_operator] = ACTIONS(14527),
    [sym__ellipsis_operator] = ACTIONS(14529),
    [sym__plus_operator] = ACTIONS(14531),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14521),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14531),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [8416] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14519),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14525),
    [sym__pipe_left_operator] = ACTIONS(14527),
    [sym__ellipsis_operator] = ACTIONS(14529),
    [sym__plus_operator] = ACTIONS(14531),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14531),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8417] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14517),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14519),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14521),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(14521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14629),
    [sym__arrow_operator] = ACTIONS(14631),
    [sym__lazy_or_operator] = ACTIONS(14633),
    [sym__lazy_and_operator] = ACTIONS(14523),
    [sym__comparison_operator] = ACTIONS(14521),
    [sym__pipe_right_operator] = ACTIONS(14525),
    [sym__pipe_left_operator] = ACTIONS(14527),
    [sym__ellipsis_operator] = ACTIONS(14529),
    [sym__plus_operator] = ACTIONS(14531),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14521),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14531),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8418] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14517),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14519),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14521),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(14521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14631),
    [sym__lazy_or_operator] = ACTIONS(14633),
    [sym__lazy_and_operator] = ACTIONS(14523),
    [sym__comparison_operator] = ACTIONS(14521),
    [sym__pipe_right_operator] = ACTIONS(14525),
    [sym__pipe_left_operator] = ACTIONS(14527),
    [sym__ellipsis_operator] = ACTIONS(14529),
    [sym__plus_operator] = ACTIONS(14531),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14521),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14531),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8419] = {
    [sym__word_identifier] = ACTIONS(13506),
    [anon_sym_EQ] = ACTIONS(13506),
    [anon_sym_COMMA] = ACTIONS(13508),
    [anon_sym_COLON] = ACTIONS(13506),
    [anon_sym_begin] = ACTIONS(13506),
    [anon_sym_module] = ACTIONS(13506),
    [anon_sym_baremodule] = ACTIONS(13506),
    [anon_sym_abstract] = ACTIONS(13506),
    [anon_sym_primitive] = ACTIONS(13506),
    [anon_sym_mutable] = ACTIONS(13506),
    [anon_sym_struct] = ACTIONS(13506),
    [anon_sym_function] = ACTIONS(13506),
    [anon_sym_macro] = ACTIONS(13506),
    [anon_sym_where] = ACTIONS(13506),
    [anon_sym_quote] = ACTIONS(13506),
    [anon_sym_let] = ACTIONS(13506),
    [anon_sym_if] = ACTIONS(13506),
    [anon_sym_try] = ACTIONS(13506),
    [anon_sym_for] = ACTIONS(13506),
    [anon_sym_while] = ACTIONS(13506),
    [sym_break_statement] = ACTIONS(13506),
    [sym_continue_statement] = ACTIONS(13506),
    [anon_sym_return] = ACTIONS(13506),
    [anon_sym_const] = ACTIONS(13506),
    [anon_sym_global] = ACTIONS(13506),
    [anon_sym_local] = ACTIONS(13506),
    [anon_sym_LPAREN] = ACTIONS(13508),
    [anon_sym_RPAREN] = ACTIONS(13508),
    [anon_sym_COLON2] = ACTIONS(13506),
    [anon_sym_export] = ACTIONS(13506),
    [anon_sym_import] = ACTIONS(13506),
    [anon_sym_using] = ACTIONS(13506),
    [anon_sym_LBRACK] = ACTIONS(13508),
    [anon_sym_RBRACK] = ACTIONS(13508),
    [anon_sym_in] = ACTIONS(13506),
    [anon_sym_SEMI] = ACTIONS(13508),
    [anon_sym_LBRACE] = ACTIONS(13508),
    [anon_sym_RBRACE] = ACTIONS(13508),
    [anon_sym_DOLLAR] = ACTIONS(13508),
    [anon_sym_COLON_COLON] = ACTIONS(13508),
    [anon_sym_isa] = ACTIONS(13506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13508),
    [anon_sym_QMARK] = ACTIONS(13508),
    [anon_sym_AT] = ACTIONS(13508),
    [anon_sym_true] = ACTIONS(13506),
    [anon_sym_false] = ACTIONS(13506),
    [aux_sym_integer_literal_token1] = ACTIONS(13508),
    [aux_sym_integer_literal_token2] = ACTIONS(13508),
    [aux_sym_integer_literal_token3] = ACTIONS(13506),
    [aux_sym_integer_literal_token4] = ACTIONS(13506),
    [aux_sym_float_literal_token1] = ACTIONS(13508),
    [aux_sym_float_literal_token3] = ACTIONS(13508),
    [aux_sym_float_literal_token4] = ACTIONS(13508),
    [sym_character_literal] = ACTIONS(13508),
    [sym__pair_operator] = ACTIONS(13508),
    [sym__arrow_operator] = ACTIONS(13506),
    [sym__lazy_or_operator] = ACTIONS(13508),
    [sym__lazy_and_operator] = ACTIONS(13508),
    [sym__comparison_operator] = ACTIONS(13506),
    [sym__pipe_right_operator] = ACTIONS(13508),
    [sym__pipe_left_operator] = ACTIONS(13508),
    [sym__ellipsis_operator] = ACTIONS(13506),
    [sym__plus_operator] = ACTIONS(13506),
    [sym__times_operator] = ACTIONS(13506),
    [sym__rational_operator] = ACTIONS(13508),
    [sym__bitshift_operator] = ACTIONS(13508),
    [sym__power_operator] = ACTIONS(13508),
    [sym__tilde_operator] = ACTIONS(13508),
    [sym__type_order_operator] = ACTIONS(13508),
    [sym__unary_operator] = ACTIONS(13506),
    [sym__unary_plus_operator] = ACTIONS(13506),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13508),
    [sym__command_start] = ACTIONS(13508),
  },
  [8420] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14517),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14519),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14521),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(14521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14521),
    [sym__pipe_right_operator] = ACTIONS(14525),
    [sym__pipe_left_operator] = ACTIONS(14527),
    [sym__ellipsis_operator] = ACTIONS(14529),
    [sym__plus_operator] = ACTIONS(14531),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14521),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14531),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8421] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14519),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14529),
    [sym__plus_operator] = ACTIONS(14531),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14531),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8422] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14519),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14525),
    [sym__pipe_left_operator] = ACTIONS(14527),
    [sym__ellipsis_operator] = ACTIONS(14529),
    [sym__plus_operator] = ACTIONS(14531),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14531),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8423] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_finally] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8424] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_EQ] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_finally] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [8425] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_EQ] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_finally] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [8426] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8427] = {
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(12974),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_catch] = ACTIONS(12974),
    [anon_sym_finally] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [8428] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8429] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_catch] = ACTIONS(12981),
    [anon_sym_finally] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8430] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8431] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8432] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8433] = {
    [sym__word_identifier] = ACTIONS(13489),
    [anon_sym_EQ] = ACTIONS(13489),
    [anon_sym_COMMA] = ACTIONS(13489),
    [anon_sym_COLON] = ACTIONS(13489),
    [anon_sym_begin] = ACTIONS(13489),
    [anon_sym_module] = ACTIONS(13489),
    [anon_sym_baremodule] = ACTIONS(13489),
    [anon_sym_abstract] = ACTIONS(13489),
    [anon_sym_primitive] = ACTIONS(13489),
    [anon_sym_mutable] = ACTIONS(13489),
    [anon_sym_struct] = ACTIONS(13489),
    [anon_sym_function] = ACTIONS(13489),
    [anon_sym_macro] = ACTIONS(13489),
    [anon_sym_where] = ACTIONS(13489),
    [anon_sym_quote] = ACTIONS(13489),
    [anon_sym_let] = ACTIONS(13489),
    [anon_sym_if] = ACTIONS(13489),
    [anon_sym_try] = ACTIONS(13489),
    [anon_sym_catch] = ACTIONS(13489),
    [anon_sym_finally] = ACTIONS(13489),
    [anon_sym_for] = ACTIONS(13489),
    [anon_sym_while] = ACTIONS(13489),
    [sym_break_statement] = ACTIONS(13489),
    [sym_continue_statement] = ACTIONS(13489),
    [anon_sym_return] = ACTIONS(13489),
    [anon_sym_const] = ACTIONS(13489),
    [anon_sym_global] = ACTIONS(13489),
    [anon_sym_local] = ACTIONS(13489),
    [anon_sym_LPAREN] = ACTIONS(13489),
    [anon_sym_COLON2] = ACTIONS(13489),
    [anon_sym_export] = ACTIONS(13489),
    [anon_sym_import] = ACTIONS(13489),
    [anon_sym_using] = ACTIONS(13489),
    [anon_sym_LBRACK] = ACTIONS(13489),
    [anon_sym_LF] = ACTIONS(13491),
    [anon_sym_in] = ACTIONS(13489),
    [anon_sym_LBRACE] = ACTIONS(13489),
    [anon_sym_DOLLAR] = ACTIONS(13489),
    [anon_sym_COLON_COLON] = ACTIONS(13489),
    [anon_sym_isa] = ACTIONS(13489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13489),
    [anon_sym_QMARK] = ACTIONS(13489),
    [anon_sym_AT] = ACTIONS(13489),
    [anon_sym_true] = ACTIONS(13489),
    [anon_sym_false] = ACTIONS(13489),
    [aux_sym_integer_literal_token1] = ACTIONS(13489),
    [aux_sym_integer_literal_token2] = ACTIONS(13489),
    [aux_sym_integer_literal_token3] = ACTIONS(13489),
    [aux_sym_integer_literal_token4] = ACTIONS(13489),
    [aux_sym_float_literal_token1] = ACTIONS(13489),
    [aux_sym_float_literal_token3] = ACTIONS(13489),
    [aux_sym_float_literal_token4] = ACTIONS(13489),
    [sym_character_literal] = ACTIONS(13489),
    [sym__pair_operator] = ACTIONS(13489),
    [sym__arrow_operator] = ACTIONS(13489),
    [sym__lazy_or_operator] = ACTIONS(13489),
    [sym__lazy_and_operator] = ACTIONS(13489),
    [sym__comparison_operator] = ACTIONS(13489),
    [sym__pipe_right_operator] = ACTIONS(13489),
    [sym__pipe_left_operator] = ACTIONS(13489),
    [sym__ellipsis_operator] = ACTIONS(13489),
    [sym__plus_operator] = ACTIONS(13489),
    [sym__times_operator] = ACTIONS(13489),
    [sym__rational_operator] = ACTIONS(13489),
    [sym__bitshift_operator] = ACTIONS(13489),
    [sym__power_operator] = ACTIONS(13489),
    [sym__tilde_operator] = ACTIONS(13489),
    [sym__type_order_operator] = ACTIONS(13489),
    [sym__unary_operator] = ACTIONS(13489),
    [sym__unary_plus_operator] = ACTIONS(13489),
    [aux_sym__terminator_token1] = ACTIONS(13489),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13491),
    [sym__command_start] = ACTIONS(13491),
  },
  [8434] = {
    [sym__word_identifier] = ACTIONS(13316),
    [anon_sym_EQ] = ACTIONS(13316),
    [anon_sym_COMMA] = ACTIONS(13316),
    [anon_sym_COLON] = ACTIONS(13316),
    [anon_sym_begin] = ACTIONS(13316),
    [anon_sym_module] = ACTIONS(13316),
    [anon_sym_baremodule] = ACTIONS(13316),
    [anon_sym_end] = ACTIONS(13316),
    [anon_sym_abstract] = ACTIONS(13316),
    [anon_sym_primitive] = ACTIONS(13316),
    [anon_sym_mutable] = ACTIONS(13316),
    [anon_sym_struct] = ACTIONS(13316),
    [anon_sym_function] = ACTIONS(13316),
    [anon_sym_macro] = ACTIONS(13316),
    [anon_sym_where] = ACTIONS(13316),
    [anon_sym_quote] = ACTIONS(13316),
    [anon_sym_let] = ACTIONS(13316),
    [anon_sym_if] = ACTIONS(13316),
    [anon_sym_try] = ACTIONS(13316),
    [anon_sym_catch] = ACTIONS(13316),
    [anon_sym_for] = ACTIONS(13316),
    [anon_sym_while] = ACTIONS(13316),
    [sym_break_statement] = ACTIONS(13316),
    [sym_continue_statement] = ACTIONS(13316),
    [anon_sym_return] = ACTIONS(13316),
    [anon_sym_const] = ACTIONS(13316),
    [anon_sym_global] = ACTIONS(13316),
    [anon_sym_local] = ACTIONS(13316),
    [anon_sym_LPAREN] = ACTIONS(13316),
    [anon_sym_COLON2] = ACTIONS(13316),
    [anon_sym_export] = ACTIONS(13316),
    [anon_sym_import] = ACTIONS(13316),
    [anon_sym_using] = ACTIONS(13316),
    [anon_sym_LBRACK] = ACTIONS(13316),
    [anon_sym_LF] = ACTIONS(13318),
    [anon_sym_in] = ACTIONS(13316),
    [anon_sym_LBRACE] = ACTIONS(13316),
    [anon_sym_DOLLAR] = ACTIONS(13316),
    [anon_sym_COLON_COLON] = ACTIONS(13316),
    [anon_sym_isa] = ACTIONS(13316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13316),
    [anon_sym_QMARK] = ACTIONS(13316),
    [anon_sym_AT] = ACTIONS(13316),
    [anon_sym_true] = ACTIONS(13316),
    [anon_sym_false] = ACTIONS(13316),
    [aux_sym_integer_literal_token1] = ACTIONS(13316),
    [aux_sym_integer_literal_token2] = ACTIONS(13316),
    [aux_sym_integer_literal_token3] = ACTIONS(13316),
    [aux_sym_integer_literal_token4] = ACTIONS(13316),
    [aux_sym_float_literal_token1] = ACTIONS(13316),
    [aux_sym_float_literal_token3] = ACTIONS(13316),
    [aux_sym_float_literal_token4] = ACTIONS(13316),
    [sym_character_literal] = ACTIONS(13316),
    [sym__pair_operator] = ACTIONS(13316),
    [sym__arrow_operator] = ACTIONS(13316),
    [sym__lazy_or_operator] = ACTIONS(13316),
    [sym__lazy_and_operator] = ACTIONS(13316),
    [sym__comparison_operator] = ACTIONS(13316),
    [sym__pipe_right_operator] = ACTIONS(13316),
    [sym__pipe_left_operator] = ACTIONS(13316),
    [sym__ellipsis_operator] = ACTIONS(13316),
    [sym__plus_operator] = ACTIONS(13316),
    [sym__times_operator] = ACTIONS(13316),
    [sym__rational_operator] = ACTIONS(13316),
    [sym__bitshift_operator] = ACTIONS(13316),
    [sym__power_operator] = ACTIONS(13316),
    [sym__tilde_operator] = ACTIONS(13316),
    [sym__type_order_operator] = ACTIONS(13316),
    [sym__unary_operator] = ACTIONS(13316),
    [sym__unary_plus_operator] = ACTIONS(13316),
    [aux_sym__terminator_token1] = ACTIONS(13316),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13318),
    [sym__command_start] = ACTIONS(13318),
  },
  [8435] = {
    [sym__word_identifier] = ACTIONS(13320),
    [anon_sym_EQ] = ACTIONS(13320),
    [anon_sym_COMMA] = ACTIONS(13320),
    [anon_sym_COLON] = ACTIONS(13320),
    [anon_sym_begin] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(13320),
    [anon_sym_baremodule] = ACTIONS(13320),
    [anon_sym_end] = ACTIONS(13320),
    [anon_sym_abstract] = ACTIONS(13320),
    [anon_sym_primitive] = ACTIONS(13320),
    [anon_sym_mutable] = ACTIONS(13320),
    [anon_sym_struct] = ACTIONS(13320),
    [anon_sym_function] = ACTIONS(13320),
    [anon_sym_macro] = ACTIONS(13320),
    [anon_sym_where] = ACTIONS(13320),
    [anon_sym_quote] = ACTIONS(13320),
    [anon_sym_let] = ACTIONS(13320),
    [anon_sym_if] = ACTIONS(13320),
    [anon_sym_try] = ACTIONS(13320),
    [anon_sym_catch] = ACTIONS(13320),
    [anon_sym_for] = ACTIONS(13320),
    [anon_sym_while] = ACTIONS(13320),
    [sym_break_statement] = ACTIONS(13320),
    [sym_continue_statement] = ACTIONS(13320),
    [anon_sym_return] = ACTIONS(13320),
    [anon_sym_const] = ACTIONS(13320),
    [anon_sym_global] = ACTIONS(13320),
    [anon_sym_local] = ACTIONS(13320),
    [anon_sym_LPAREN] = ACTIONS(13320),
    [anon_sym_COLON2] = ACTIONS(13320),
    [anon_sym_export] = ACTIONS(13320),
    [anon_sym_import] = ACTIONS(13320),
    [anon_sym_using] = ACTIONS(13320),
    [anon_sym_LBRACK] = ACTIONS(13320),
    [anon_sym_LF] = ACTIONS(13322),
    [anon_sym_in] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(13320),
    [anon_sym_DOLLAR] = ACTIONS(13320),
    [anon_sym_COLON_COLON] = ACTIONS(13320),
    [anon_sym_isa] = ACTIONS(13320),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13320),
    [anon_sym_QMARK] = ACTIONS(13320),
    [anon_sym_AT] = ACTIONS(13320),
    [anon_sym_true] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(13320),
    [aux_sym_integer_literal_token1] = ACTIONS(13320),
    [aux_sym_integer_literal_token2] = ACTIONS(13320),
    [aux_sym_integer_literal_token3] = ACTIONS(13320),
    [aux_sym_integer_literal_token4] = ACTIONS(13320),
    [aux_sym_float_literal_token1] = ACTIONS(13320),
    [aux_sym_float_literal_token3] = ACTIONS(13320),
    [aux_sym_float_literal_token4] = ACTIONS(13320),
    [sym_character_literal] = ACTIONS(13320),
    [sym__pair_operator] = ACTIONS(13320),
    [sym__arrow_operator] = ACTIONS(13320),
    [sym__lazy_or_operator] = ACTIONS(13320),
    [sym__lazy_and_operator] = ACTIONS(13320),
    [sym__comparison_operator] = ACTIONS(13320),
    [sym__pipe_right_operator] = ACTIONS(13320),
    [sym__pipe_left_operator] = ACTIONS(13320),
    [sym__ellipsis_operator] = ACTIONS(13320),
    [sym__plus_operator] = ACTIONS(13320),
    [sym__times_operator] = ACTIONS(13320),
    [sym__rational_operator] = ACTIONS(13320),
    [sym__bitshift_operator] = ACTIONS(13320),
    [sym__power_operator] = ACTIONS(13320),
    [sym__tilde_operator] = ACTIONS(13320),
    [sym__type_order_operator] = ACTIONS(13320),
    [sym__unary_operator] = ACTIONS(13320),
    [sym__unary_plus_operator] = ACTIONS(13320),
    [aux_sym__terminator_token1] = ACTIONS(13320),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13322),
    [sym__command_start] = ACTIONS(13322),
  },
  [8436] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DASH_GT] = ACTIONS(12128),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8437] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_catch] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8438] = {
    [aux_sym_open_tuple_repeat1] = STATE(7376),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13394),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_catch] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14612),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8439] = {
    [sym__word_identifier] = ACTIONS(13326),
    [anon_sym_EQ] = ACTIONS(13326),
    [anon_sym_COMMA] = ACTIONS(13326),
    [anon_sym_COLON] = ACTIONS(13326),
    [anon_sym_begin] = ACTIONS(13326),
    [anon_sym_module] = ACTIONS(13326),
    [anon_sym_baremodule] = ACTIONS(13326),
    [anon_sym_end] = ACTIONS(13326),
    [anon_sym_abstract] = ACTIONS(13326),
    [anon_sym_primitive] = ACTIONS(13326),
    [anon_sym_mutable] = ACTIONS(13326),
    [anon_sym_struct] = ACTIONS(13326),
    [anon_sym_function] = ACTIONS(13326),
    [anon_sym_macro] = ACTIONS(13326),
    [anon_sym_where] = ACTIONS(13326),
    [anon_sym_quote] = ACTIONS(13326),
    [anon_sym_let] = ACTIONS(13326),
    [anon_sym_if] = ACTIONS(13326),
    [anon_sym_try] = ACTIONS(13326),
    [anon_sym_catch] = ACTIONS(13326),
    [anon_sym_for] = ACTIONS(13326),
    [anon_sym_while] = ACTIONS(13326),
    [sym_break_statement] = ACTIONS(13326),
    [sym_continue_statement] = ACTIONS(13326),
    [anon_sym_return] = ACTIONS(13326),
    [anon_sym_const] = ACTIONS(13326),
    [anon_sym_global] = ACTIONS(13326),
    [anon_sym_local] = ACTIONS(13326),
    [anon_sym_LPAREN] = ACTIONS(13326),
    [anon_sym_COLON2] = ACTIONS(13326),
    [anon_sym_export] = ACTIONS(13326),
    [anon_sym_import] = ACTIONS(13326),
    [anon_sym_using] = ACTIONS(13326),
    [anon_sym_LBRACK] = ACTIONS(13326),
    [anon_sym_LF] = ACTIONS(13328),
    [anon_sym_in] = ACTIONS(13326),
    [anon_sym_LBRACE] = ACTIONS(13326),
    [anon_sym_DOLLAR] = ACTIONS(13326),
    [anon_sym_COLON_COLON] = ACTIONS(13326),
    [anon_sym_isa] = ACTIONS(13326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13326),
    [anon_sym_QMARK] = ACTIONS(13326),
    [anon_sym_AT] = ACTIONS(13326),
    [anon_sym_true] = ACTIONS(13326),
    [anon_sym_false] = ACTIONS(13326),
    [aux_sym_integer_literal_token1] = ACTIONS(13326),
    [aux_sym_integer_literal_token2] = ACTIONS(13326),
    [aux_sym_integer_literal_token3] = ACTIONS(13326),
    [aux_sym_integer_literal_token4] = ACTIONS(13326),
    [aux_sym_float_literal_token1] = ACTIONS(13326),
    [aux_sym_float_literal_token3] = ACTIONS(13326),
    [aux_sym_float_literal_token4] = ACTIONS(13326),
    [sym_character_literal] = ACTIONS(13326),
    [sym__pair_operator] = ACTIONS(13326),
    [sym__arrow_operator] = ACTIONS(13326),
    [sym__lazy_or_operator] = ACTIONS(13326),
    [sym__lazy_and_operator] = ACTIONS(13326),
    [sym__comparison_operator] = ACTIONS(13326),
    [sym__pipe_right_operator] = ACTIONS(13326),
    [sym__pipe_left_operator] = ACTIONS(13326),
    [sym__ellipsis_operator] = ACTIONS(13326),
    [sym__plus_operator] = ACTIONS(13326),
    [sym__times_operator] = ACTIONS(13326),
    [sym__rational_operator] = ACTIONS(13326),
    [sym__bitshift_operator] = ACTIONS(13326),
    [sym__power_operator] = ACTIONS(13326),
    [sym__tilde_operator] = ACTIONS(13326),
    [sym__type_order_operator] = ACTIONS(13326),
    [sym__unary_operator] = ACTIONS(13326),
    [sym__unary_plus_operator] = ACTIONS(13326),
    [aux_sym__terminator_token1] = ACTIONS(13326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13328),
    [sym__command_start] = ACTIONS(13328),
  },
  [8440] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_catch] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8441] = {
    [aux_sym_open_tuple_repeat1] = STATE(7376),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13394),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_catch] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14612),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8442] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_catch] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8443] = {
    [aux_sym_open_tuple_repeat1] = STATE(7376),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(13394),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_catch] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14612),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8444] = {
    [sym__word_identifier] = ACTIONS(13493),
    [anon_sym_EQ] = ACTIONS(13493),
    [anon_sym_COMMA] = ACTIONS(13493),
    [anon_sym_COLON] = ACTIONS(13493),
    [anon_sym_begin] = ACTIONS(13493),
    [anon_sym_module] = ACTIONS(13493),
    [anon_sym_baremodule] = ACTIONS(13493),
    [anon_sym_abstract] = ACTIONS(13493),
    [anon_sym_primitive] = ACTIONS(13493),
    [anon_sym_mutable] = ACTIONS(13493),
    [anon_sym_struct] = ACTIONS(13493),
    [anon_sym_function] = ACTIONS(13493),
    [anon_sym_macro] = ACTIONS(13493),
    [anon_sym_where] = ACTIONS(13493),
    [anon_sym_quote] = ACTIONS(13493),
    [anon_sym_let] = ACTIONS(13493),
    [anon_sym_if] = ACTIONS(13493),
    [anon_sym_try] = ACTIONS(13493),
    [anon_sym_catch] = ACTIONS(13493),
    [anon_sym_finally] = ACTIONS(13493),
    [anon_sym_for] = ACTIONS(13493),
    [anon_sym_while] = ACTIONS(13493),
    [sym_break_statement] = ACTIONS(13493),
    [sym_continue_statement] = ACTIONS(13493),
    [anon_sym_return] = ACTIONS(13493),
    [anon_sym_const] = ACTIONS(13493),
    [anon_sym_global] = ACTIONS(13493),
    [anon_sym_local] = ACTIONS(13493),
    [anon_sym_LPAREN] = ACTIONS(13493),
    [anon_sym_COLON2] = ACTIONS(13493),
    [anon_sym_export] = ACTIONS(13493),
    [anon_sym_import] = ACTIONS(13493),
    [anon_sym_using] = ACTIONS(13493),
    [anon_sym_LBRACK] = ACTIONS(13493),
    [anon_sym_LF] = ACTIONS(13495),
    [anon_sym_in] = ACTIONS(13493),
    [anon_sym_LBRACE] = ACTIONS(13493),
    [anon_sym_DOLLAR] = ACTIONS(13493),
    [anon_sym_COLON_COLON] = ACTIONS(13493),
    [anon_sym_isa] = ACTIONS(13493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13493),
    [anon_sym_QMARK] = ACTIONS(13493),
    [anon_sym_AT] = ACTIONS(13493),
    [anon_sym_true] = ACTIONS(13493),
    [anon_sym_false] = ACTIONS(13493),
    [aux_sym_integer_literal_token1] = ACTIONS(13493),
    [aux_sym_integer_literal_token2] = ACTIONS(13493),
    [aux_sym_integer_literal_token3] = ACTIONS(13493),
    [aux_sym_integer_literal_token4] = ACTIONS(13493),
    [aux_sym_float_literal_token1] = ACTIONS(13493),
    [aux_sym_float_literal_token3] = ACTIONS(13493),
    [aux_sym_float_literal_token4] = ACTIONS(13493),
    [sym_character_literal] = ACTIONS(13493),
    [sym__pair_operator] = ACTIONS(13493),
    [sym__arrow_operator] = ACTIONS(13493),
    [sym__lazy_or_operator] = ACTIONS(13493),
    [sym__lazy_and_operator] = ACTIONS(13493),
    [sym__comparison_operator] = ACTIONS(13493),
    [sym__pipe_right_operator] = ACTIONS(13493),
    [sym__pipe_left_operator] = ACTIONS(13493),
    [sym__ellipsis_operator] = ACTIONS(13493),
    [sym__plus_operator] = ACTIONS(13493),
    [sym__times_operator] = ACTIONS(13493),
    [sym__rational_operator] = ACTIONS(13493),
    [sym__bitshift_operator] = ACTIONS(13493),
    [sym__power_operator] = ACTIONS(13493),
    [sym__tilde_operator] = ACTIONS(13493),
    [sym__type_order_operator] = ACTIONS(13493),
    [sym__unary_operator] = ACTIONS(13493),
    [sym__unary_plus_operator] = ACTIONS(13493),
    [aux_sym__terminator_token1] = ACTIONS(13493),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13495),
    [sym__command_start] = ACTIONS(13495),
  },
  [8445] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [8446] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8447] = {
    [sym__word_identifier] = ACTIONS(13330),
    [anon_sym_EQ] = ACTIONS(13330),
    [anon_sym_COMMA] = ACTIONS(13330),
    [anon_sym_COLON] = ACTIONS(13330),
    [anon_sym_begin] = ACTIONS(13330),
    [anon_sym_module] = ACTIONS(13330),
    [anon_sym_baremodule] = ACTIONS(13330),
    [anon_sym_end] = ACTIONS(13330),
    [anon_sym_abstract] = ACTIONS(13330),
    [anon_sym_primitive] = ACTIONS(13330),
    [anon_sym_mutable] = ACTIONS(13330),
    [anon_sym_struct] = ACTIONS(13330),
    [anon_sym_function] = ACTIONS(13330),
    [anon_sym_macro] = ACTIONS(13330),
    [anon_sym_where] = ACTIONS(13330),
    [anon_sym_quote] = ACTIONS(13330),
    [anon_sym_let] = ACTIONS(13330),
    [anon_sym_if] = ACTIONS(13330),
    [anon_sym_try] = ACTIONS(13330),
    [anon_sym_catch] = ACTIONS(13330),
    [anon_sym_for] = ACTIONS(13330),
    [anon_sym_while] = ACTIONS(13330),
    [sym_break_statement] = ACTIONS(13330),
    [sym_continue_statement] = ACTIONS(13330),
    [anon_sym_return] = ACTIONS(13330),
    [anon_sym_const] = ACTIONS(13330),
    [anon_sym_global] = ACTIONS(13330),
    [anon_sym_local] = ACTIONS(13330),
    [anon_sym_LPAREN] = ACTIONS(13330),
    [anon_sym_COLON2] = ACTIONS(13330),
    [anon_sym_export] = ACTIONS(13330),
    [anon_sym_import] = ACTIONS(13330),
    [anon_sym_using] = ACTIONS(13330),
    [anon_sym_LBRACK] = ACTIONS(13330),
    [anon_sym_LF] = ACTIONS(13332),
    [anon_sym_in] = ACTIONS(13330),
    [anon_sym_LBRACE] = ACTIONS(13330),
    [anon_sym_DOLLAR] = ACTIONS(13330),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_isa] = ACTIONS(13330),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13330),
    [anon_sym_QMARK] = ACTIONS(13330),
    [anon_sym_AT] = ACTIONS(13330),
    [anon_sym_true] = ACTIONS(13330),
    [anon_sym_false] = ACTIONS(13330),
    [aux_sym_integer_literal_token1] = ACTIONS(13330),
    [aux_sym_integer_literal_token2] = ACTIONS(13330),
    [aux_sym_integer_literal_token3] = ACTIONS(13330),
    [aux_sym_integer_literal_token4] = ACTIONS(13330),
    [aux_sym_float_literal_token1] = ACTIONS(13330),
    [aux_sym_float_literal_token3] = ACTIONS(13330),
    [aux_sym_float_literal_token4] = ACTIONS(13330),
    [sym_character_literal] = ACTIONS(13330),
    [sym__pair_operator] = ACTIONS(13330),
    [sym__arrow_operator] = ACTIONS(13330),
    [sym__lazy_or_operator] = ACTIONS(13330),
    [sym__lazy_and_operator] = ACTIONS(13330),
    [sym__comparison_operator] = ACTIONS(13330),
    [sym__pipe_right_operator] = ACTIONS(13330),
    [sym__pipe_left_operator] = ACTIONS(13330),
    [sym__ellipsis_operator] = ACTIONS(13330),
    [sym__plus_operator] = ACTIONS(13330),
    [sym__times_operator] = ACTIONS(13330),
    [sym__rational_operator] = ACTIONS(13330),
    [sym__bitshift_operator] = ACTIONS(13330),
    [sym__power_operator] = ACTIONS(13330),
    [sym__tilde_operator] = ACTIONS(13330),
    [sym__type_order_operator] = ACTIONS(13330),
    [sym__unary_operator] = ACTIONS(13330),
    [sym__unary_plus_operator] = ACTIONS(13330),
    [aux_sym__terminator_token1] = ACTIONS(13330),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13332),
    [sym__command_start] = ACTIONS(13332),
  },
  [8448] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8449] = {
    [sym__word_identifier] = ACTIONS(13499),
    [anon_sym_EQ] = ACTIONS(13499),
    [anon_sym_COMMA] = ACTIONS(13499),
    [anon_sym_COLON] = ACTIONS(13499),
    [anon_sym_begin] = ACTIONS(13499),
    [anon_sym_module] = ACTIONS(13499),
    [anon_sym_baremodule] = ACTIONS(13499),
    [anon_sym_abstract] = ACTIONS(13499),
    [anon_sym_primitive] = ACTIONS(13499),
    [anon_sym_mutable] = ACTIONS(13499),
    [anon_sym_struct] = ACTIONS(13499),
    [anon_sym_function] = ACTIONS(13499),
    [anon_sym_macro] = ACTIONS(13499),
    [anon_sym_where] = ACTIONS(13499),
    [anon_sym_quote] = ACTIONS(13499),
    [anon_sym_let] = ACTIONS(13499),
    [anon_sym_if] = ACTIONS(13499),
    [anon_sym_try] = ACTIONS(13499),
    [anon_sym_catch] = ACTIONS(13499),
    [anon_sym_finally] = ACTIONS(13499),
    [anon_sym_for] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(13499),
    [sym_break_statement] = ACTIONS(13499),
    [sym_continue_statement] = ACTIONS(13499),
    [anon_sym_return] = ACTIONS(13499),
    [anon_sym_const] = ACTIONS(13499),
    [anon_sym_global] = ACTIONS(13499),
    [anon_sym_local] = ACTIONS(13499),
    [anon_sym_LPAREN] = ACTIONS(13499),
    [anon_sym_COLON2] = ACTIONS(13499),
    [anon_sym_export] = ACTIONS(13499),
    [anon_sym_import] = ACTIONS(13499),
    [anon_sym_using] = ACTIONS(13499),
    [anon_sym_LBRACK] = ACTIONS(13499),
    [anon_sym_LF] = ACTIONS(13501),
    [anon_sym_in] = ACTIONS(13499),
    [anon_sym_LBRACE] = ACTIONS(13499),
    [anon_sym_DOLLAR] = ACTIONS(13499),
    [anon_sym_COLON_COLON] = ACTIONS(13499),
    [anon_sym_isa] = ACTIONS(13499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13499),
    [anon_sym_QMARK] = ACTIONS(13499),
    [anon_sym_AT] = ACTIONS(13499),
    [anon_sym_true] = ACTIONS(13499),
    [anon_sym_false] = ACTIONS(13499),
    [aux_sym_integer_literal_token1] = ACTIONS(13499),
    [aux_sym_integer_literal_token2] = ACTIONS(13499),
    [aux_sym_integer_literal_token3] = ACTIONS(13499),
    [aux_sym_integer_literal_token4] = ACTIONS(13499),
    [aux_sym_float_literal_token1] = ACTIONS(13499),
    [aux_sym_float_literal_token3] = ACTIONS(13499),
    [aux_sym_float_literal_token4] = ACTIONS(13499),
    [sym_character_literal] = ACTIONS(13499),
    [sym__pair_operator] = ACTIONS(13499),
    [sym__arrow_operator] = ACTIONS(13499),
    [sym__lazy_or_operator] = ACTIONS(13499),
    [sym__lazy_and_operator] = ACTIONS(13499),
    [sym__comparison_operator] = ACTIONS(13499),
    [sym__pipe_right_operator] = ACTIONS(13499),
    [sym__pipe_left_operator] = ACTIONS(13499),
    [sym__ellipsis_operator] = ACTIONS(13499),
    [sym__plus_operator] = ACTIONS(13499),
    [sym__times_operator] = ACTIONS(13499),
    [sym__rational_operator] = ACTIONS(13499),
    [sym__bitshift_operator] = ACTIONS(13499),
    [sym__power_operator] = ACTIONS(13499),
    [sym__tilde_operator] = ACTIONS(13499),
    [sym__type_order_operator] = ACTIONS(13499),
    [sym__unary_operator] = ACTIONS(13499),
    [sym__unary_plus_operator] = ACTIONS(13499),
    [aux_sym__terminator_token1] = ACTIONS(13499),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13501),
    [sym__command_start] = ACTIONS(13501),
  },
  [8450] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8451] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8452] = {
    [sym__word_identifier] = ACTIONS(13506),
    [anon_sym_EQ] = ACTIONS(13506),
    [anon_sym_COMMA] = ACTIONS(13506),
    [anon_sym_COLON] = ACTIONS(13506),
    [anon_sym_begin] = ACTIONS(13506),
    [anon_sym_module] = ACTIONS(13506),
    [anon_sym_baremodule] = ACTIONS(13506),
    [anon_sym_abstract] = ACTIONS(13506),
    [anon_sym_primitive] = ACTIONS(13506),
    [anon_sym_mutable] = ACTIONS(13506),
    [anon_sym_struct] = ACTIONS(13506),
    [anon_sym_function] = ACTIONS(13506),
    [anon_sym_macro] = ACTIONS(13506),
    [anon_sym_where] = ACTIONS(13506),
    [anon_sym_quote] = ACTIONS(13506),
    [anon_sym_let] = ACTIONS(13506),
    [anon_sym_if] = ACTIONS(13506),
    [anon_sym_try] = ACTIONS(13506),
    [anon_sym_catch] = ACTIONS(13506),
    [anon_sym_finally] = ACTIONS(13506),
    [anon_sym_for] = ACTIONS(13506),
    [anon_sym_while] = ACTIONS(13506),
    [sym_break_statement] = ACTIONS(13506),
    [sym_continue_statement] = ACTIONS(13506),
    [anon_sym_return] = ACTIONS(13506),
    [anon_sym_const] = ACTIONS(13506),
    [anon_sym_global] = ACTIONS(13506),
    [anon_sym_local] = ACTIONS(13506),
    [anon_sym_LPAREN] = ACTIONS(13506),
    [anon_sym_COLON2] = ACTIONS(13506),
    [anon_sym_export] = ACTIONS(13506),
    [anon_sym_import] = ACTIONS(13506),
    [anon_sym_using] = ACTIONS(13506),
    [anon_sym_LBRACK] = ACTIONS(13506),
    [anon_sym_LF] = ACTIONS(13508),
    [anon_sym_in] = ACTIONS(13506),
    [anon_sym_LBRACE] = ACTIONS(13506),
    [anon_sym_DOLLAR] = ACTIONS(13506),
    [anon_sym_COLON_COLON] = ACTIONS(13506),
    [anon_sym_isa] = ACTIONS(13506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13506),
    [anon_sym_QMARK] = ACTIONS(13506),
    [anon_sym_AT] = ACTIONS(13506),
    [anon_sym_true] = ACTIONS(13506),
    [anon_sym_false] = ACTIONS(13506),
    [aux_sym_integer_literal_token1] = ACTIONS(13506),
    [aux_sym_integer_literal_token2] = ACTIONS(13506),
    [aux_sym_integer_literal_token3] = ACTIONS(13506),
    [aux_sym_integer_literal_token4] = ACTIONS(13506),
    [aux_sym_float_literal_token1] = ACTIONS(13506),
    [aux_sym_float_literal_token3] = ACTIONS(13506),
    [aux_sym_float_literal_token4] = ACTIONS(13506),
    [sym_character_literal] = ACTIONS(13506),
    [sym__pair_operator] = ACTIONS(13506),
    [sym__arrow_operator] = ACTIONS(13506),
    [sym__lazy_or_operator] = ACTIONS(13506),
    [sym__lazy_and_operator] = ACTIONS(13506),
    [sym__comparison_operator] = ACTIONS(13506),
    [sym__pipe_right_operator] = ACTIONS(13506),
    [sym__pipe_left_operator] = ACTIONS(13506),
    [sym__ellipsis_operator] = ACTIONS(13506),
    [sym__plus_operator] = ACTIONS(13506),
    [sym__times_operator] = ACTIONS(13506),
    [sym__rational_operator] = ACTIONS(13506),
    [sym__bitshift_operator] = ACTIONS(13506),
    [sym__power_operator] = ACTIONS(13506),
    [sym__tilde_operator] = ACTIONS(13506),
    [sym__type_order_operator] = ACTIONS(13506),
    [sym__unary_operator] = ACTIONS(13506),
    [sym__unary_plus_operator] = ACTIONS(13506),
    [aux_sym__terminator_token1] = ACTIONS(13506),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13508),
    [sym__command_start] = ACTIONS(13508),
  },
  [8453] = {
    [sym__word_identifier] = ACTIONS(13510),
    [anon_sym_EQ] = ACTIONS(13510),
    [anon_sym_COMMA] = ACTIONS(13510),
    [anon_sym_COLON] = ACTIONS(13510),
    [anon_sym_begin] = ACTIONS(13510),
    [anon_sym_module] = ACTIONS(13510),
    [anon_sym_baremodule] = ACTIONS(13510),
    [anon_sym_abstract] = ACTIONS(13510),
    [anon_sym_primitive] = ACTIONS(13510),
    [anon_sym_mutable] = ACTIONS(13510),
    [anon_sym_struct] = ACTIONS(13510),
    [anon_sym_function] = ACTIONS(13510),
    [anon_sym_macro] = ACTIONS(13510),
    [anon_sym_where] = ACTIONS(13510),
    [anon_sym_quote] = ACTIONS(13510),
    [anon_sym_let] = ACTIONS(13510),
    [anon_sym_if] = ACTIONS(13510),
    [anon_sym_try] = ACTIONS(13510),
    [anon_sym_catch] = ACTIONS(13510),
    [anon_sym_finally] = ACTIONS(13510),
    [anon_sym_for] = ACTIONS(13510),
    [anon_sym_while] = ACTIONS(13510),
    [sym_break_statement] = ACTIONS(13510),
    [sym_continue_statement] = ACTIONS(13510),
    [anon_sym_return] = ACTIONS(13510),
    [anon_sym_const] = ACTIONS(13510),
    [anon_sym_global] = ACTIONS(13510),
    [anon_sym_local] = ACTIONS(13510),
    [anon_sym_LPAREN] = ACTIONS(13510),
    [anon_sym_COLON2] = ACTIONS(13510),
    [anon_sym_export] = ACTIONS(13510),
    [anon_sym_import] = ACTIONS(13510),
    [anon_sym_using] = ACTIONS(13510),
    [anon_sym_LBRACK] = ACTIONS(13510),
    [anon_sym_LF] = ACTIONS(13512),
    [anon_sym_in] = ACTIONS(13510),
    [anon_sym_LBRACE] = ACTIONS(13510),
    [anon_sym_DOLLAR] = ACTIONS(13510),
    [anon_sym_COLON_COLON] = ACTIONS(13510),
    [anon_sym_isa] = ACTIONS(13510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13510),
    [anon_sym_QMARK] = ACTIONS(13510),
    [anon_sym_AT] = ACTIONS(13510),
    [anon_sym_true] = ACTIONS(13510),
    [anon_sym_false] = ACTIONS(13510),
    [aux_sym_integer_literal_token1] = ACTIONS(13510),
    [aux_sym_integer_literal_token2] = ACTIONS(13510),
    [aux_sym_integer_literal_token3] = ACTIONS(13510),
    [aux_sym_integer_literal_token4] = ACTIONS(13510),
    [aux_sym_float_literal_token1] = ACTIONS(13510),
    [aux_sym_float_literal_token3] = ACTIONS(13510),
    [aux_sym_float_literal_token4] = ACTIONS(13510),
    [sym_character_literal] = ACTIONS(13510),
    [sym__pair_operator] = ACTIONS(13510),
    [sym__arrow_operator] = ACTIONS(13510),
    [sym__lazy_or_operator] = ACTIONS(13510),
    [sym__lazy_and_operator] = ACTIONS(13510),
    [sym__comparison_operator] = ACTIONS(13510),
    [sym__pipe_right_operator] = ACTIONS(13510),
    [sym__pipe_left_operator] = ACTIONS(13510),
    [sym__ellipsis_operator] = ACTIONS(13510),
    [sym__plus_operator] = ACTIONS(13510),
    [sym__times_operator] = ACTIONS(13510),
    [sym__rational_operator] = ACTIONS(13510),
    [sym__bitshift_operator] = ACTIONS(13510),
    [sym__power_operator] = ACTIONS(13510),
    [sym__tilde_operator] = ACTIONS(13510),
    [sym__type_order_operator] = ACTIONS(13510),
    [sym__unary_operator] = ACTIONS(13510),
    [sym__unary_plus_operator] = ACTIONS(13510),
    [aux_sym__terminator_token1] = ACTIONS(13510),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13512),
    [sym__command_start] = ACTIONS(13512),
  },
  [8454] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_catch] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [8455] = {
    [sym__word_identifier] = ACTIONS(13514),
    [anon_sym_EQ] = ACTIONS(13514),
    [anon_sym_COMMA] = ACTIONS(13514),
    [anon_sym_COLON] = ACTIONS(13514),
    [anon_sym_begin] = ACTIONS(13514),
    [anon_sym_module] = ACTIONS(13514),
    [anon_sym_baremodule] = ACTIONS(13514),
    [anon_sym_abstract] = ACTIONS(13514),
    [anon_sym_primitive] = ACTIONS(13514),
    [anon_sym_mutable] = ACTIONS(13514),
    [anon_sym_struct] = ACTIONS(13514),
    [anon_sym_function] = ACTIONS(13514),
    [anon_sym_macro] = ACTIONS(13514),
    [anon_sym_where] = ACTIONS(13514),
    [anon_sym_quote] = ACTIONS(13514),
    [anon_sym_let] = ACTIONS(13514),
    [anon_sym_if] = ACTIONS(13514),
    [anon_sym_try] = ACTIONS(13514),
    [anon_sym_catch] = ACTIONS(13514),
    [anon_sym_finally] = ACTIONS(13514),
    [anon_sym_for] = ACTIONS(13514),
    [anon_sym_while] = ACTIONS(13514),
    [sym_break_statement] = ACTIONS(13514),
    [sym_continue_statement] = ACTIONS(13514),
    [anon_sym_return] = ACTIONS(13514),
    [anon_sym_const] = ACTIONS(13514),
    [anon_sym_global] = ACTIONS(13514),
    [anon_sym_local] = ACTIONS(13514),
    [anon_sym_LPAREN] = ACTIONS(13514),
    [anon_sym_COLON2] = ACTIONS(13514),
    [anon_sym_export] = ACTIONS(13514),
    [anon_sym_import] = ACTIONS(13514),
    [anon_sym_using] = ACTIONS(13514),
    [anon_sym_LBRACK] = ACTIONS(13514),
    [anon_sym_LF] = ACTIONS(13516),
    [anon_sym_in] = ACTIONS(13514),
    [anon_sym_LBRACE] = ACTIONS(13514),
    [anon_sym_DOLLAR] = ACTIONS(13514),
    [anon_sym_COLON_COLON] = ACTIONS(13514),
    [anon_sym_isa] = ACTIONS(13514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13514),
    [anon_sym_QMARK] = ACTIONS(13514),
    [anon_sym_AT] = ACTIONS(13514),
    [anon_sym_true] = ACTIONS(13514),
    [anon_sym_false] = ACTIONS(13514),
    [aux_sym_integer_literal_token1] = ACTIONS(13514),
    [aux_sym_integer_literal_token2] = ACTIONS(13514),
    [aux_sym_integer_literal_token3] = ACTIONS(13514),
    [aux_sym_integer_literal_token4] = ACTIONS(13514),
    [aux_sym_float_literal_token1] = ACTIONS(13514),
    [aux_sym_float_literal_token3] = ACTIONS(13514),
    [aux_sym_float_literal_token4] = ACTIONS(13514),
    [sym_character_literal] = ACTIONS(13514),
    [sym__pair_operator] = ACTIONS(13514),
    [sym__arrow_operator] = ACTIONS(13514),
    [sym__lazy_or_operator] = ACTIONS(13514),
    [sym__lazy_and_operator] = ACTIONS(13514),
    [sym__comparison_operator] = ACTIONS(13514),
    [sym__pipe_right_operator] = ACTIONS(13514),
    [sym__pipe_left_operator] = ACTIONS(13514),
    [sym__ellipsis_operator] = ACTIONS(13514),
    [sym__plus_operator] = ACTIONS(13514),
    [sym__times_operator] = ACTIONS(13514),
    [sym__rational_operator] = ACTIONS(13514),
    [sym__bitshift_operator] = ACTIONS(13514),
    [sym__power_operator] = ACTIONS(13514),
    [sym__tilde_operator] = ACTIONS(13514),
    [sym__type_order_operator] = ACTIONS(13514),
    [sym__unary_operator] = ACTIONS(13514),
    [sym__unary_plus_operator] = ACTIONS(13514),
    [aux_sym__terminator_token1] = ACTIONS(13514),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13516),
    [sym__command_start] = ACTIONS(13516),
  },
  [8456] = {
    [sym__word_identifier] = ACTIONS(13518),
    [anon_sym_EQ] = ACTIONS(13518),
    [anon_sym_COMMA] = ACTIONS(13518),
    [anon_sym_COLON] = ACTIONS(13518),
    [anon_sym_begin] = ACTIONS(13518),
    [anon_sym_module] = ACTIONS(13518),
    [anon_sym_baremodule] = ACTIONS(13518),
    [anon_sym_abstract] = ACTIONS(13518),
    [anon_sym_primitive] = ACTIONS(13518),
    [anon_sym_mutable] = ACTIONS(13518),
    [anon_sym_struct] = ACTIONS(13518),
    [anon_sym_function] = ACTIONS(13518),
    [anon_sym_macro] = ACTIONS(13518),
    [anon_sym_where] = ACTIONS(13518),
    [anon_sym_quote] = ACTIONS(13518),
    [anon_sym_let] = ACTIONS(13518),
    [anon_sym_if] = ACTIONS(13518),
    [anon_sym_try] = ACTIONS(13518),
    [anon_sym_catch] = ACTIONS(13518),
    [anon_sym_finally] = ACTIONS(13518),
    [anon_sym_for] = ACTIONS(13518),
    [anon_sym_while] = ACTIONS(13518),
    [sym_break_statement] = ACTIONS(13518),
    [sym_continue_statement] = ACTIONS(13518),
    [anon_sym_return] = ACTIONS(13518),
    [anon_sym_const] = ACTIONS(13518),
    [anon_sym_global] = ACTIONS(13518),
    [anon_sym_local] = ACTIONS(13518),
    [anon_sym_LPAREN] = ACTIONS(13518),
    [anon_sym_COLON2] = ACTIONS(13518),
    [anon_sym_export] = ACTIONS(13518),
    [anon_sym_import] = ACTIONS(13518),
    [anon_sym_using] = ACTIONS(13518),
    [anon_sym_LBRACK] = ACTIONS(13518),
    [anon_sym_LF] = ACTIONS(13520),
    [anon_sym_in] = ACTIONS(13518),
    [anon_sym_LBRACE] = ACTIONS(13518),
    [anon_sym_DOLLAR] = ACTIONS(13518),
    [anon_sym_COLON_COLON] = ACTIONS(13518),
    [anon_sym_isa] = ACTIONS(13518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13518),
    [anon_sym_QMARK] = ACTIONS(13518),
    [anon_sym_AT] = ACTIONS(13518),
    [anon_sym_true] = ACTIONS(13518),
    [anon_sym_false] = ACTIONS(13518),
    [aux_sym_integer_literal_token1] = ACTIONS(13518),
    [aux_sym_integer_literal_token2] = ACTIONS(13518),
    [aux_sym_integer_literal_token3] = ACTIONS(13518),
    [aux_sym_integer_literal_token4] = ACTIONS(13518),
    [aux_sym_float_literal_token1] = ACTIONS(13518),
    [aux_sym_float_literal_token3] = ACTIONS(13518),
    [aux_sym_float_literal_token4] = ACTIONS(13518),
    [sym_character_literal] = ACTIONS(13518),
    [sym__pair_operator] = ACTIONS(13518),
    [sym__arrow_operator] = ACTIONS(13518),
    [sym__lazy_or_operator] = ACTIONS(13518),
    [sym__lazy_and_operator] = ACTIONS(13518),
    [sym__comparison_operator] = ACTIONS(13518),
    [sym__pipe_right_operator] = ACTIONS(13518),
    [sym__pipe_left_operator] = ACTIONS(13518),
    [sym__ellipsis_operator] = ACTIONS(13518),
    [sym__plus_operator] = ACTIONS(13518),
    [sym__times_operator] = ACTIONS(13518),
    [sym__rational_operator] = ACTIONS(13518),
    [sym__bitshift_operator] = ACTIONS(13518),
    [sym__power_operator] = ACTIONS(13518),
    [sym__tilde_operator] = ACTIONS(13518),
    [sym__type_order_operator] = ACTIONS(13518),
    [sym__unary_operator] = ACTIONS(13518),
    [sym__unary_plus_operator] = ACTIONS(13518),
    [aux_sym__terminator_token1] = ACTIONS(13518),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13520),
    [sym__command_start] = ACTIONS(13520),
  },
  [8457] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12714),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12660),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8458] = {
    [sym__word_identifier] = ACTIONS(13257),
    [anon_sym_EQ] = ACTIONS(13257),
    [anon_sym_COMMA] = ACTIONS(13257),
    [anon_sym_COLON] = ACTIONS(13257),
    [anon_sym_begin] = ACTIONS(13257),
    [anon_sym_module] = ACTIONS(13257),
    [anon_sym_baremodule] = ACTIONS(13257),
    [anon_sym_abstract] = ACTIONS(13257),
    [anon_sym_primitive] = ACTIONS(13257),
    [anon_sym_mutable] = ACTIONS(13257),
    [anon_sym_struct] = ACTIONS(13257),
    [anon_sym_function] = ACTIONS(13257),
    [anon_sym_macro] = ACTIONS(13257),
    [anon_sym_where] = ACTIONS(13257),
    [anon_sym_quote] = ACTIONS(13257),
    [anon_sym_let] = ACTIONS(13257),
    [anon_sym_if] = ACTIONS(13257),
    [anon_sym_try] = ACTIONS(13257),
    [anon_sym_catch] = ACTIONS(13257),
    [anon_sym_finally] = ACTIONS(13257),
    [anon_sym_for] = ACTIONS(13257),
    [anon_sym_while] = ACTIONS(13257),
    [sym_break_statement] = ACTIONS(13257),
    [sym_continue_statement] = ACTIONS(13257),
    [anon_sym_return] = ACTIONS(13257),
    [anon_sym_const] = ACTIONS(13257),
    [anon_sym_global] = ACTIONS(13257),
    [anon_sym_local] = ACTIONS(13257),
    [anon_sym_LPAREN] = ACTIONS(13257),
    [anon_sym_COLON2] = ACTIONS(13257),
    [anon_sym_export] = ACTIONS(13257),
    [anon_sym_import] = ACTIONS(13257),
    [anon_sym_using] = ACTIONS(13257),
    [anon_sym_LBRACK] = ACTIONS(13257),
    [anon_sym_LF] = ACTIONS(13259),
    [anon_sym_in] = ACTIONS(13257),
    [anon_sym_LBRACE] = ACTIONS(13257),
    [anon_sym_DOLLAR] = ACTIONS(13257),
    [anon_sym_COLON_COLON] = ACTIONS(13257),
    [anon_sym_isa] = ACTIONS(13257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13257),
    [anon_sym_QMARK] = ACTIONS(13257),
    [anon_sym_AT] = ACTIONS(13257),
    [anon_sym_true] = ACTIONS(13257),
    [anon_sym_false] = ACTIONS(13257),
    [aux_sym_integer_literal_token1] = ACTIONS(13257),
    [aux_sym_integer_literal_token2] = ACTIONS(13257),
    [aux_sym_integer_literal_token3] = ACTIONS(13257),
    [aux_sym_integer_literal_token4] = ACTIONS(13257),
    [aux_sym_float_literal_token1] = ACTIONS(13257),
    [aux_sym_float_literal_token3] = ACTIONS(13257),
    [aux_sym_float_literal_token4] = ACTIONS(13257),
    [sym_character_literal] = ACTIONS(13257),
    [sym__pair_operator] = ACTIONS(13257),
    [sym__arrow_operator] = ACTIONS(13257),
    [sym__lazy_or_operator] = ACTIONS(13257),
    [sym__lazy_and_operator] = ACTIONS(13257),
    [sym__comparison_operator] = ACTIONS(13257),
    [sym__pipe_right_operator] = ACTIONS(13257),
    [sym__pipe_left_operator] = ACTIONS(13257),
    [sym__ellipsis_operator] = ACTIONS(13257),
    [sym__plus_operator] = ACTIONS(13257),
    [sym__times_operator] = ACTIONS(13257),
    [sym__rational_operator] = ACTIONS(13257),
    [sym__bitshift_operator] = ACTIONS(13257),
    [sym__power_operator] = ACTIONS(13257),
    [sym__tilde_operator] = ACTIONS(13257),
    [sym__type_order_operator] = ACTIONS(13257),
    [sym__unary_operator] = ACTIONS(13257),
    [sym__unary_plus_operator] = ACTIONS(13257),
    [aux_sym__terminator_token1] = ACTIONS(13257),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13259),
    [sym__command_start] = ACTIONS(13259),
  },
  [8459] = {
    [sym__word_identifier] = ACTIONS(13522),
    [anon_sym_EQ] = ACTIONS(13522),
    [anon_sym_COMMA] = ACTIONS(13522),
    [anon_sym_COLON] = ACTIONS(13522),
    [anon_sym_begin] = ACTIONS(13522),
    [anon_sym_module] = ACTIONS(13522),
    [anon_sym_baremodule] = ACTIONS(13522),
    [anon_sym_abstract] = ACTIONS(13522),
    [anon_sym_primitive] = ACTIONS(13522),
    [anon_sym_mutable] = ACTIONS(13522),
    [anon_sym_struct] = ACTIONS(13522),
    [anon_sym_function] = ACTIONS(13522),
    [anon_sym_macro] = ACTIONS(13522),
    [anon_sym_where] = ACTIONS(13522),
    [anon_sym_quote] = ACTIONS(13522),
    [anon_sym_let] = ACTIONS(13522),
    [anon_sym_if] = ACTIONS(13522),
    [anon_sym_try] = ACTIONS(13522),
    [anon_sym_catch] = ACTIONS(13522),
    [anon_sym_finally] = ACTIONS(13522),
    [anon_sym_for] = ACTIONS(13522),
    [anon_sym_while] = ACTIONS(13522),
    [sym_break_statement] = ACTIONS(13522),
    [sym_continue_statement] = ACTIONS(13522),
    [anon_sym_return] = ACTIONS(13522),
    [anon_sym_const] = ACTIONS(13522),
    [anon_sym_global] = ACTIONS(13522),
    [anon_sym_local] = ACTIONS(13522),
    [anon_sym_LPAREN] = ACTIONS(13522),
    [anon_sym_COLON2] = ACTIONS(13522),
    [anon_sym_export] = ACTIONS(13522),
    [anon_sym_import] = ACTIONS(13522),
    [anon_sym_using] = ACTIONS(13522),
    [anon_sym_LBRACK] = ACTIONS(13522),
    [anon_sym_LF] = ACTIONS(13524),
    [anon_sym_in] = ACTIONS(13522),
    [anon_sym_LBRACE] = ACTIONS(13522),
    [anon_sym_DOLLAR] = ACTIONS(13522),
    [anon_sym_COLON_COLON] = ACTIONS(13522),
    [anon_sym_isa] = ACTIONS(13522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13522),
    [anon_sym_QMARK] = ACTIONS(13522),
    [anon_sym_AT] = ACTIONS(13522),
    [anon_sym_true] = ACTIONS(13522),
    [anon_sym_false] = ACTIONS(13522),
    [aux_sym_integer_literal_token1] = ACTIONS(13522),
    [aux_sym_integer_literal_token2] = ACTIONS(13522),
    [aux_sym_integer_literal_token3] = ACTIONS(13522),
    [aux_sym_integer_literal_token4] = ACTIONS(13522),
    [aux_sym_float_literal_token1] = ACTIONS(13522),
    [aux_sym_float_literal_token3] = ACTIONS(13522),
    [aux_sym_float_literal_token4] = ACTIONS(13522),
    [sym_character_literal] = ACTIONS(13522),
    [sym__pair_operator] = ACTIONS(13522),
    [sym__arrow_operator] = ACTIONS(13522),
    [sym__lazy_or_operator] = ACTIONS(13522),
    [sym__lazy_and_operator] = ACTIONS(13522),
    [sym__comparison_operator] = ACTIONS(13522),
    [sym__pipe_right_operator] = ACTIONS(13522),
    [sym__pipe_left_operator] = ACTIONS(13522),
    [sym__ellipsis_operator] = ACTIONS(13522),
    [sym__plus_operator] = ACTIONS(13522),
    [sym__times_operator] = ACTIONS(13522),
    [sym__rational_operator] = ACTIONS(13522),
    [sym__bitshift_operator] = ACTIONS(13522),
    [sym__power_operator] = ACTIONS(13522),
    [sym__tilde_operator] = ACTIONS(13522),
    [sym__type_order_operator] = ACTIONS(13522),
    [sym__unary_operator] = ACTIONS(13522),
    [sym__unary_plus_operator] = ACTIONS(13522),
    [aux_sym__terminator_token1] = ACTIONS(13522),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13524),
    [sym__command_start] = ACTIONS(13524),
  },
  [8460] = {
    [sym__word_identifier] = ACTIONS(13346),
    [anon_sym_EQ] = ACTIONS(13346),
    [anon_sym_COMMA] = ACTIONS(13346),
    [anon_sym_COLON] = ACTIONS(13346),
    [anon_sym_begin] = ACTIONS(13346),
    [anon_sym_module] = ACTIONS(13346),
    [anon_sym_baremodule] = ACTIONS(13346),
    [anon_sym_end] = ACTIONS(13346),
    [anon_sym_abstract] = ACTIONS(13346),
    [anon_sym_primitive] = ACTIONS(13346),
    [anon_sym_mutable] = ACTIONS(13346),
    [anon_sym_struct] = ACTIONS(13346),
    [anon_sym_function] = ACTIONS(13346),
    [anon_sym_macro] = ACTIONS(13346),
    [anon_sym_where] = ACTIONS(13346),
    [anon_sym_quote] = ACTIONS(13346),
    [anon_sym_let] = ACTIONS(13346),
    [anon_sym_if] = ACTIONS(13346),
    [anon_sym_try] = ACTIONS(13346),
    [anon_sym_catch] = ACTIONS(13346),
    [anon_sym_for] = ACTIONS(13346),
    [anon_sym_while] = ACTIONS(13346),
    [sym_break_statement] = ACTIONS(13346),
    [sym_continue_statement] = ACTIONS(13346),
    [anon_sym_return] = ACTIONS(13346),
    [anon_sym_const] = ACTIONS(13346),
    [anon_sym_global] = ACTIONS(13346),
    [anon_sym_local] = ACTIONS(13346),
    [anon_sym_LPAREN] = ACTIONS(13346),
    [anon_sym_COLON2] = ACTIONS(13346),
    [anon_sym_export] = ACTIONS(13346),
    [anon_sym_import] = ACTIONS(13346),
    [anon_sym_using] = ACTIONS(13346),
    [anon_sym_LBRACK] = ACTIONS(13346),
    [anon_sym_LF] = ACTIONS(13348),
    [anon_sym_in] = ACTIONS(13346),
    [anon_sym_LBRACE] = ACTIONS(13346),
    [anon_sym_DOLLAR] = ACTIONS(13346),
    [anon_sym_COLON_COLON] = ACTIONS(13346),
    [anon_sym_isa] = ACTIONS(13346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13346),
    [anon_sym_QMARK] = ACTIONS(13346),
    [anon_sym_AT] = ACTIONS(13346),
    [anon_sym_true] = ACTIONS(13346),
    [anon_sym_false] = ACTIONS(13346),
    [aux_sym_integer_literal_token1] = ACTIONS(13346),
    [aux_sym_integer_literal_token2] = ACTIONS(13346),
    [aux_sym_integer_literal_token3] = ACTIONS(13346),
    [aux_sym_integer_literal_token4] = ACTIONS(13346),
    [aux_sym_float_literal_token1] = ACTIONS(13346),
    [aux_sym_float_literal_token3] = ACTIONS(13346),
    [aux_sym_float_literal_token4] = ACTIONS(13346),
    [sym_character_literal] = ACTIONS(13346),
    [sym__pair_operator] = ACTIONS(13346),
    [sym__arrow_operator] = ACTIONS(13346),
    [sym__lazy_or_operator] = ACTIONS(13346),
    [sym__lazy_and_operator] = ACTIONS(13346),
    [sym__comparison_operator] = ACTIONS(13346),
    [sym__pipe_right_operator] = ACTIONS(13346),
    [sym__pipe_left_operator] = ACTIONS(13346),
    [sym__ellipsis_operator] = ACTIONS(13346),
    [sym__plus_operator] = ACTIONS(13346),
    [sym__times_operator] = ACTIONS(13346),
    [sym__rational_operator] = ACTIONS(13346),
    [sym__bitshift_operator] = ACTIONS(13346),
    [sym__power_operator] = ACTIONS(13346),
    [sym__tilde_operator] = ACTIONS(13346),
    [sym__type_order_operator] = ACTIONS(13346),
    [sym__unary_operator] = ACTIONS(13346),
    [sym__unary_plus_operator] = ACTIONS(13346),
    [aux_sym__terminator_token1] = ACTIONS(13346),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13348),
    [sym__command_start] = ACTIONS(13348),
  },
  [8461] = {
    [sym__word_identifier] = ACTIONS(13526),
    [anon_sym_EQ] = ACTIONS(13526),
    [anon_sym_COMMA] = ACTIONS(13526),
    [anon_sym_COLON] = ACTIONS(13526),
    [anon_sym_begin] = ACTIONS(13526),
    [anon_sym_module] = ACTIONS(13526),
    [anon_sym_baremodule] = ACTIONS(13526),
    [anon_sym_abstract] = ACTIONS(13526),
    [anon_sym_primitive] = ACTIONS(13526),
    [anon_sym_mutable] = ACTIONS(13526),
    [anon_sym_struct] = ACTIONS(13526),
    [anon_sym_function] = ACTIONS(13526),
    [anon_sym_macro] = ACTIONS(13526),
    [anon_sym_where] = ACTIONS(13526),
    [anon_sym_quote] = ACTIONS(13526),
    [anon_sym_let] = ACTIONS(13526),
    [anon_sym_if] = ACTIONS(13526),
    [anon_sym_try] = ACTIONS(13526),
    [anon_sym_catch] = ACTIONS(13526),
    [anon_sym_finally] = ACTIONS(13526),
    [anon_sym_for] = ACTIONS(13526),
    [anon_sym_while] = ACTIONS(13526),
    [sym_break_statement] = ACTIONS(13526),
    [sym_continue_statement] = ACTIONS(13526),
    [anon_sym_return] = ACTIONS(13526),
    [anon_sym_const] = ACTIONS(13526),
    [anon_sym_global] = ACTIONS(13526),
    [anon_sym_local] = ACTIONS(13526),
    [anon_sym_LPAREN] = ACTIONS(13526),
    [anon_sym_COLON2] = ACTIONS(13526),
    [anon_sym_export] = ACTIONS(13526),
    [anon_sym_import] = ACTIONS(13526),
    [anon_sym_using] = ACTIONS(13526),
    [anon_sym_LBRACK] = ACTIONS(13526),
    [anon_sym_LF] = ACTIONS(13528),
    [anon_sym_in] = ACTIONS(13526),
    [anon_sym_LBRACE] = ACTIONS(13526),
    [anon_sym_DOLLAR] = ACTIONS(13526),
    [anon_sym_COLON_COLON] = ACTIONS(13526),
    [anon_sym_isa] = ACTIONS(13526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13526),
    [anon_sym_QMARK] = ACTIONS(13526),
    [anon_sym_AT] = ACTIONS(13526),
    [anon_sym_true] = ACTIONS(13526),
    [anon_sym_false] = ACTIONS(13526),
    [aux_sym_integer_literal_token1] = ACTIONS(13526),
    [aux_sym_integer_literal_token2] = ACTIONS(13526),
    [aux_sym_integer_literal_token3] = ACTIONS(13526),
    [aux_sym_integer_literal_token4] = ACTIONS(13526),
    [aux_sym_float_literal_token1] = ACTIONS(13526),
    [aux_sym_float_literal_token3] = ACTIONS(13526),
    [aux_sym_float_literal_token4] = ACTIONS(13526),
    [sym_character_literal] = ACTIONS(13526),
    [sym__pair_operator] = ACTIONS(13526),
    [sym__arrow_operator] = ACTIONS(13526),
    [sym__lazy_or_operator] = ACTIONS(13526),
    [sym__lazy_and_operator] = ACTIONS(13526),
    [sym__comparison_operator] = ACTIONS(13526),
    [sym__pipe_right_operator] = ACTIONS(13526),
    [sym__pipe_left_operator] = ACTIONS(13526),
    [sym__ellipsis_operator] = ACTIONS(13526),
    [sym__plus_operator] = ACTIONS(13526),
    [sym__times_operator] = ACTIONS(13526),
    [sym__rational_operator] = ACTIONS(13526),
    [sym__bitshift_operator] = ACTIONS(13526),
    [sym__power_operator] = ACTIONS(13526),
    [sym__tilde_operator] = ACTIONS(13526),
    [sym__type_order_operator] = ACTIONS(13526),
    [sym__unary_operator] = ACTIONS(13526),
    [sym__unary_plus_operator] = ACTIONS(13526),
    [aux_sym__terminator_token1] = ACTIONS(13526),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13528),
    [sym__command_start] = ACTIONS(13528),
  },
  [8462] = {
    [sym__word_identifier] = ACTIONS(13530),
    [anon_sym_EQ] = ACTIONS(13530),
    [anon_sym_COMMA] = ACTIONS(13530),
    [anon_sym_COLON] = ACTIONS(13530),
    [anon_sym_begin] = ACTIONS(13530),
    [anon_sym_module] = ACTIONS(13530),
    [anon_sym_baremodule] = ACTIONS(13530),
    [anon_sym_abstract] = ACTIONS(13530),
    [anon_sym_primitive] = ACTIONS(13530),
    [anon_sym_mutable] = ACTIONS(13530),
    [anon_sym_struct] = ACTIONS(13530),
    [anon_sym_function] = ACTIONS(13530),
    [anon_sym_macro] = ACTIONS(13530),
    [anon_sym_where] = ACTIONS(13530),
    [anon_sym_quote] = ACTIONS(13530),
    [anon_sym_let] = ACTIONS(13530),
    [anon_sym_if] = ACTIONS(13530),
    [anon_sym_try] = ACTIONS(13530),
    [anon_sym_catch] = ACTIONS(13530),
    [anon_sym_finally] = ACTIONS(13530),
    [anon_sym_for] = ACTIONS(13530),
    [anon_sym_while] = ACTIONS(13530),
    [sym_break_statement] = ACTIONS(13530),
    [sym_continue_statement] = ACTIONS(13530),
    [anon_sym_return] = ACTIONS(13530),
    [anon_sym_const] = ACTIONS(13530),
    [anon_sym_global] = ACTIONS(13530),
    [anon_sym_local] = ACTIONS(13530),
    [anon_sym_LPAREN] = ACTIONS(13530),
    [anon_sym_COLON2] = ACTIONS(13530),
    [anon_sym_export] = ACTIONS(13530),
    [anon_sym_import] = ACTIONS(13530),
    [anon_sym_using] = ACTIONS(13530),
    [anon_sym_LBRACK] = ACTIONS(13530),
    [anon_sym_LF] = ACTIONS(13532),
    [anon_sym_in] = ACTIONS(13530),
    [anon_sym_LBRACE] = ACTIONS(13530),
    [anon_sym_DOLLAR] = ACTIONS(13530),
    [anon_sym_COLON_COLON] = ACTIONS(13530),
    [anon_sym_isa] = ACTIONS(13530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13530),
    [anon_sym_QMARK] = ACTIONS(13530),
    [anon_sym_AT] = ACTIONS(13530),
    [anon_sym_true] = ACTIONS(13530),
    [anon_sym_false] = ACTIONS(13530),
    [aux_sym_integer_literal_token1] = ACTIONS(13530),
    [aux_sym_integer_literal_token2] = ACTIONS(13530),
    [aux_sym_integer_literal_token3] = ACTIONS(13530),
    [aux_sym_integer_literal_token4] = ACTIONS(13530),
    [aux_sym_float_literal_token1] = ACTIONS(13530),
    [aux_sym_float_literal_token3] = ACTIONS(13530),
    [aux_sym_float_literal_token4] = ACTIONS(13530),
    [sym_character_literal] = ACTIONS(13530),
    [sym__pair_operator] = ACTIONS(13530),
    [sym__arrow_operator] = ACTIONS(13530),
    [sym__lazy_or_operator] = ACTIONS(13530),
    [sym__lazy_and_operator] = ACTIONS(13530),
    [sym__comparison_operator] = ACTIONS(13530),
    [sym__pipe_right_operator] = ACTIONS(13530),
    [sym__pipe_left_operator] = ACTIONS(13530),
    [sym__ellipsis_operator] = ACTIONS(13530),
    [sym__plus_operator] = ACTIONS(13530),
    [sym__times_operator] = ACTIONS(13530),
    [sym__rational_operator] = ACTIONS(13530),
    [sym__bitshift_operator] = ACTIONS(13530),
    [sym__power_operator] = ACTIONS(13530),
    [sym__tilde_operator] = ACTIONS(13530),
    [sym__type_order_operator] = ACTIONS(13530),
    [sym__unary_operator] = ACTIONS(13530),
    [sym__unary_plus_operator] = ACTIONS(13530),
    [aux_sym__terminator_token1] = ACTIONS(13530),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13532),
    [sym__command_start] = ACTIONS(13532),
  },
  [8463] = {
    [sym__word_identifier] = ACTIONS(13534),
    [anon_sym_EQ] = ACTIONS(13534),
    [anon_sym_COMMA] = ACTIONS(13534),
    [anon_sym_COLON] = ACTIONS(13534),
    [anon_sym_begin] = ACTIONS(13534),
    [anon_sym_module] = ACTIONS(13534),
    [anon_sym_baremodule] = ACTIONS(13534),
    [anon_sym_abstract] = ACTIONS(13534),
    [anon_sym_primitive] = ACTIONS(13534),
    [anon_sym_mutable] = ACTIONS(13534),
    [anon_sym_struct] = ACTIONS(13534),
    [anon_sym_function] = ACTIONS(13534),
    [anon_sym_macro] = ACTIONS(13534),
    [anon_sym_where] = ACTIONS(13534),
    [anon_sym_quote] = ACTIONS(13534),
    [anon_sym_let] = ACTIONS(13534),
    [anon_sym_if] = ACTIONS(13534),
    [anon_sym_try] = ACTIONS(13534),
    [anon_sym_catch] = ACTIONS(13534),
    [anon_sym_finally] = ACTIONS(13534),
    [anon_sym_for] = ACTIONS(13534),
    [anon_sym_while] = ACTIONS(13534),
    [sym_break_statement] = ACTIONS(13534),
    [sym_continue_statement] = ACTIONS(13534),
    [anon_sym_return] = ACTIONS(13534),
    [anon_sym_const] = ACTIONS(13534),
    [anon_sym_global] = ACTIONS(13534),
    [anon_sym_local] = ACTIONS(13534),
    [anon_sym_LPAREN] = ACTIONS(13534),
    [anon_sym_COLON2] = ACTIONS(13534),
    [anon_sym_export] = ACTIONS(13534),
    [anon_sym_import] = ACTIONS(13534),
    [anon_sym_using] = ACTIONS(13534),
    [anon_sym_LBRACK] = ACTIONS(13534),
    [anon_sym_LF] = ACTIONS(13536),
    [anon_sym_in] = ACTIONS(13534),
    [anon_sym_LBRACE] = ACTIONS(13534),
    [anon_sym_DOLLAR] = ACTIONS(13534),
    [anon_sym_COLON_COLON] = ACTIONS(13534),
    [anon_sym_isa] = ACTIONS(13534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13534),
    [anon_sym_QMARK] = ACTIONS(13534),
    [anon_sym_AT] = ACTIONS(13534),
    [anon_sym_true] = ACTIONS(13534),
    [anon_sym_false] = ACTIONS(13534),
    [aux_sym_integer_literal_token1] = ACTIONS(13534),
    [aux_sym_integer_literal_token2] = ACTIONS(13534),
    [aux_sym_integer_literal_token3] = ACTIONS(13534),
    [aux_sym_integer_literal_token4] = ACTIONS(13534),
    [aux_sym_float_literal_token1] = ACTIONS(13534),
    [aux_sym_float_literal_token3] = ACTIONS(13534),
    [aux_sym_float_literal_token4] = ACTIONS(13534),
    [sym_character_literal] = ACTIONS(13534),
    [sym__pair_operator] = ACTIONS(13534),
    [sym__arrow_operator] = ACTIONS(13534),
    [sym__lazy_or_operator] = ACTIONS(13534),
    [sym__lazy_and_operator] = ACTIONS(13534),
    [sym__comparison_operator] = ACTIONS(13534),
    [sym__pipe_right_operator] = ACTIONS(13534),
    [sym__pipe_left_operator] = ACTIONS(13534),
    [sym__ellipsis_operator] = ACTIONS(13534),
    [sym__plus_operator] = ACTIONS(13534),
    [sym__times_operator] = ACTIONS(13534),
    [sym__rational_operator] = ACTIONS(13534),
    [sym__bitshift_operator] = ACTIONS(13534),
    [sym__power_operator] = ACTIONS(13534),
    [sym__tilde_operator] = ACTIONS(13534),
    [sym__type_order_operator] = ACTIONS(13534),
    [sym__unary_operator] = ACTIONS(13534),
    [sym__unary_plus_operator] = ACTIONS(13534),
    [aux_sym__terminator_token1] = ACTIONS(13534),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13536),
    [sym__command_start] = ACTIONS(13536),
  },
  [8464] = {
    [sym__word_identifier] = ACTIONS(13538),
    [anon_sym_EQ] = ACTIONS(13538),
    [anon_sym_COMMA] = ACTIONS(13538),
    [anon_sym_COLON] = ACTIONS(13538),
    [anon_sym_begin] = ACTIONS(13538),
    [anon_sym_module] = ACTIONS(13538),
    [anon_sym_baremodule] = ACTIONS(13538),
    [anon_sym_abstract] = ACTIONS(13538),
    [anon_sym_primitive] = ACTIONS(13538),
    [anon_sym_mutable] = ACTIONS(13538),
    [anon_sym_struct] = ACTIONS(13538),
    [anon_sym_function] = ACTIONS(13538),
    [anon_sym_macro] = ACTIONS(13538),
    [anon_sym_where] = ACTIONS(13538),
    [anon_sym_quote] = ACTIONS(13538),
    [anon_sym_let] = ACTIONS(13538),
    [anon_sym_if] = ACTIONS(13538),
    [anon_sym_try] = ACTIONS(13538),
    [anon_sym_catch] = ACTIONS(13538),
    [anon_sym_finally] = ACTIONS(13538),
    [anon_sym_for] = ACTIONS(13538),
    [anon_sym_while] = ACTIONS(13538),
    [sym_break_statement] = ACTIONS(13538),
    [sym_continue_statement] = ACTIONS(13538),
    [anon_sym_return] = ACTIONS(13538),
    [anon_sym_const] = ACTIONS(13538),
    [anon_sym_global] = ACTIONS(13538),
    [anon_sym_local] = ACTIONS(13538),
    [anon_sym_LPAREN] = ACTIONS(13538),
    [anon_sym_COLON2] = ACTIONS(13538),
    [anon_sym_export] = ACTIONS(13538),
    [anon_sym_import] = ACTIONS(13538),
    [anon_sym_using] = ACTIONS(13538),
    [anon_sym_LBRACK] = ACTIONS(13538),
    [anon_sym_LF] = ACTIONS(13540),
    [anon_sym_in] = ACTIONS(13538),
    [anon_sym_LBRACE] = ACTIONS(13538),
    [anon_sym_DOLLAR] = ACTIONS(13538),
    [anon_sym_COLON_COLON] = ACTIONS(13538),
    [anon_sym_isa] = ACTIONS(13538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13538),
    [anon_sym_QMARK] = ACTIONS(13538),
    [anon_sym_AT] = ACTIONS(13538),
    [anon_sym_true] = ACTIONS(13538),
    [anon_sym_false] = ACTIONS(13538),
    [aux_sym_integer_literal_token1] = ACTIONS(13538),
    [aux_sym_integer_literal_token2] = ACTIONS(13538),
    [aux_sym_integer_literal_token3] = ACTIONS(13538),
    [aux_sym_integer_literal_token4] = ACTIONS(13538),
    [aux_sym_float_literal_token1] = ACTIONS(13538),
    [aux_sym_float_literal_token3] = ACTIONS(13538),
    [aux_sym_float_literal_token4] = ACTIONS(13538),
    [sym_character_literal] = ACTIONS(13538),
    [sym__pair_operator] = ACTIONS(13538),
    [sym__arrow_operator] = ACTIONS(13538),
    [sym__lazy_or_operator] = ACTIONS(13538),
    [sym__lazy_and_operator] = ACTIONS(13538),
    [sym__comparison_operator] = ACTIONS(13538),
    [sym__pipe_right_operator] = ACTIONS(13538),
    [sym__pipe_left_operator] = ACTIONS(13538),
    [sym__ellipsis_operator] = ACTIONS(13538),
    [sym__plus_operator] = ACTIONS(13538),
    [sym__times_operator] = ACTIONS(13538),
    [sym__rational_operator] = ACTIONS(13538),
    [sym__bitshift_operator] = ACTIONS(13538),
    [sym__power_operator] = ACTIONS(13538),
    [sym__tilde_operator] = ACTIONS(13538),
    [sym__type_order_operator] = ACTIONS(13538),
    [sym__unary_operator] = ACTIONS(13538),
    [sym__unary_plus_operator] = ACTIONS(13538),
    [aux_sym__terminator_token1] = ACTIONS(13538),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13540),
    [sym__command_start] = ACTIONS(13540),
  },
  [8465] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [8466] = {
    [sym__word_identifier] = ACTIONS(13358),
    [anon_sym_EQ] = ACTIONS(13358),
    [anon_sym_COMMA] = ACTIONS(13358),
    [anon_sym_COLON] = ACTIONS(13358),
    [anon_sym_begin] = ACTIONS(13358),
    [anon_sym_module] = ACTIONS(13358),
    [anon_sym_baremodule] = ACTIONS(13358),
    [anon_sym_end] = ACTIONS(13358),
    [anon_sym_abstract] = ACTIONS(13358),
    [anon_sym_primitive] = ACTIONS(13358),
    [anon_sym_mutable] = ACTIONS(13358),
    [anon_sym_struct] = ACTIONS(13358),
    [anon_sym_function] = ACTIONS(13358),
    [anon_sym_macro] = ACTIONS(13358),
    [anon_sym_where] = ACTIONS(13358),
    [anon_sym_quote] = ACTIONS(13358),
    [anon_sym_let] = ACTIONS(13358),
    [anon_sym_if] = ACTIONS(13358),
    [anon_sym_try] = ACTIONS(13358),
    [anon_sym_catch] = ACTIONS(13358),
    [anon_sym_for] = ACTIONS(13358),
    [anon_sym_while] = ACTIONS(13358),
    [sym_break_statement] = ACTIONS(13358),
    [sym_continue_statement] = ACTIONS(13358),
    [anon_sym_return] = ACTIONS(13358),
    [anon_sym_const] = ACTIONS(13358),
    [anon_sym_global] = ACTIONS(13358),
    [anon_sym_local] = ACTIONS(13358),
    [anon_sym_LPAREN] = ACTIONS(13358),
    [anon_sym_COLON2] = ACTIONS(13358),
    [anon_sym_export] = ACTIONS(13358),
    [anon_sym_import] = ACTIONS(13358),
    [anon_sym_using] = ACTIONS(13358),
    [anon_sym_LBRACK] = ACTIONS(13358),
    [anon_sym_LF] = ACTIONS(13360),
    [anon_sym_in] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(13358),
    [anon_sym_DOLLAR] = ACTIONS(13358),
    [anon_sym_COLON_COLON] = ACTIONS(13358),
    [anon_sym_isa] = ACTIONS(13358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13358),
    [anon_sym_QMARK] = ACTIONS(13358),
    [anon_sym_AT] = ACTIONS(13358),
    [anon_sym_true] = ACTIONS(13358),
    [anon_sym_false] = ACTIONS(13358),
    [aux_sym_integer_literal_token1] = ACTIONS(13358),
    [aux_sym_integer_literal_token2] = ACTIONS(13358),
    [aux_sym_integer_literal_token3] = ACTIONS(13358),
    [aux_sym_integer_literal_token4] = ACTIONS(13358),
    [aux_sym_float_literal_token1] = ACTIONS(13358),
    [aux_sym_float_literal_token3] = ACTIONS(13358),
    [aux_sym_float_literal_token4] = ACTIONS(13358),
    [sym_character_literal] = ACTIONS(13358),
    [sym__pair_operator] = ACTIONS(13358),
    [sym__arrow_operator] = ACTIONS(13358),
    [sym__lazy_or_operator] = ACTIONS(13358),
    [sym__lazy_and_operator] = ACTIONS(13358),
    [sym__comparison_operator] = ACTIONS(13358),
    [sym__pipe_right_operator] = ACTIONS(13358),
    [sym__pipe_left_operator] = ACTIONS(13358),
    [sym__ellipsis_operator] = ACTIONS(13358),
    [sym__plus_operator] = ACTIONS(13358),
    [sym__times_operator] = ACTIONS(13358),
    [sym__rational_operator] = ACTIONS(13358),
    [sym__bitshift_operator] = ACTIONS(13358),
    [sym__power_operator] = ACTIONS(13358),
    [sym__tilde_operator] = ACTIONS(13358),
    [sym__type_order_operator] = ACTIONS(13358),
    [sym__unary_operator] = ACTIONS(13358),
    [sym__unary_plus_operator] = ACTIONS(13358),
    [aux_sym__terminator_token1] = ACTIONS(13358),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13360),
    [sym__command_start] = ACTIONS(13360),
  },
  [8467] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_EQ] = ACTIONS(12384),
    [anon_sym_COMMA] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_RPAREN] = ACTIONS(12384),
    [anon_sym_COLON2] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_in] = ACTIONS(12384),
    [anon_sym_SEMI] = ACTIONS(12384),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_isa] = ACTIONS(12384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12384),
    [anon_sym_QMARK] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__lazy_or_operator] = ACTIONS(12384),
    [sym__lazy_and_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [8468] = {
    [sym__word_identifier] = ACTIONS(13542),
    [anon_sym_EQ] = ACTIONS(13542),
    [anon_sym_COMMA] = ACTIONS(13542),
    [anon_sym_COLON] = ACTIONS(13542),
    [anon_sym_begin] = ACTIONS(13542),
    [anon_sym_module] = ACTIONS(13542),
    [anon_sym_baremodule] = ACTIONS(13542),
    [anon_sym_abstract] = ACTIONS(13542),
    [anon_sym_primitive] = ACTIONS(13542),
    [anon_sym_mutable] = ACTIONS(13542),
    [anon_sym_struct] = ACTIONS(13542),
    [anon_sym_function] = ACTIONS(13542),
    [anon_sym_macro] = ACTIONS(13542),
    [anon_sym_where] = ACTIONS(13542),
    [anon_sym_quote] = ACTIONS(13542),
    [anon_sym_let] = ACTIONS(13542),
    [anon_sym_if] = ACTIONS(13542),
    [anon_sym_try] = ACTIONS(13542),
    [anon_sym_catch] = ACTIONS(13542),
    [anon_sym_finally] = ACTIONS(13542),
    [anon_sym_for] = ACTIONS(13542),
    [anon_sym_while] = ACTIONS(13542),
    [sym_break_statement] = ACTIONS(13542),
    [sym_continue_statement] = ACTIONS(13542),
    [anon_sym_return] = ACTIONS(13542),
    [anon_sym_const] = ACTIONS(13542),
    [anon_sym_global] = ACTIONS(13542),
    [anon_sym_local] = ACTIONS(13542),
    [anon_sym_LPAREN] = ACTIONS(13542),
    [anon_sym_COLON2] = ACTIONS(13542),
    [anon_sym_export] = ACTIONS(13542),
    [anon_sym_import] = ACTIONS(13542),
    [anon_sym_using] = ACTIONS(13542),
    [anon_sym_LBRACK] = ACTIONS(13542),
    [anon_sym_LF] = ACTIONS(13544),
    [anon_sym_in] = ACTIONS(13542),
    [anon_sym_LBRACE] = ACTIONS(13542),
    [anon_sym_DOLLAR] = ACTIONS(13542),
    [anon_sym_COLON_COLON] = ACTIONS(13542),
    [anon_sym_isa] = ACTIONS(13542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13542),
    [anon_sym_QMARK] = ACTIONS(13542),
    [anon_sym_AT] = ACTIONS(13542),
    [anon_sym_true] = ACTIONS(13542),
    [anon_sym_false] = ACTIONS(13542),
    [aux_sym_integer_literal_token1] = ACTIONS(13542),
    [aux_sym_integer_literal_token2] = ACTIONS(13542),
    [aux_sym_integer_literal_token3] = ACTIONS(13542),
    [aux_sym_integer_literal_token4] = ACTIONS(13542),
    [aux_sym_float_literal_token1] = ACTIONS(13542),
    [aux_sym_float_literal_token3] = ACTIONS(13542),
    [aux_sym_float_literal_token4] = ACTIONS(13542),
    [sym_character_literal] = ACTIONS(13542),
    [sym__pair_operator] = ACTIONS(13542),
    [sym__arrow_operator] = ACTIONS(13542),
    [sym__lazy_or_operator] = ACTIONS(13542),
    [sym__lazy_and_operator] = ACTIONS(13542),
    [sym__comparison_operator] = ACTIONS(13542),
    [sym__pipe_right_operator] = ACTIONS(13542),
    [sym__pipe_left_operator] = ACTIONS(13542),
    [sym__ellipsis_operator] = ACTIONS(13542),
    [sym__plus_operator] = ACTIONS(13542),
    [sym__times_operator] = ACTIONS(13542),
    [sym__rational_operator] = ACTIONS(13542),
    [sym__bitshift_operator] = ACTIONS(13542),
    [sym__power_operator] = ACTIONS(13542),
    [sym__tilde_operator] = ACTIONS(13542),
    [sym__type_order_operator] = ACTIONS(13542),
    [sym__unary_operator] = ACTIONS(13542),
    [sym__unary_plus_operator] = ACTIONS(13542),
    [aux_sym__terminator_token1] = ACTIONS(13542),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13544),
    [sym__command_start] = ACTIONS(13544),
  },
  [8469] = {
    [sym__word_identifier] = ACTIONS(13546),
    [anon_sym_EQ] = ACTIONS(13546),
    [anon_sym_COMMA] = ACTIONS(13546),
    [anon_sym_COLON] = ACTIONS(13546),
    [anon_sym_begin] = ACTIONS(13546),
    [anon_sym_module] = ACTIONS(13546),
    [anon_sym_baremodule] = ACTIONS(13546),
    [anon_sym_abstract] = ACTIONS(13546),
    [anon_sym_primitive] = ACTIONS(13546),
    [anon_sym_mutable] = ACTIONS(13546),
    [anon_sym_struct] = ACTIONS(13546),
    [anon_sym_function] = ACTIONS(13546),
    [anon_sym_macro] = ACTIONS(13546),
    [anon_sym_where] = ACTIONS(13546),
    [anon_sym_quote] = ACTIONS(13546),
    [anon_sym_let] = ACTIONS(13546),
    [anon_sym_if] = ACTIONS(13546),
    [anon_sym_try] = ACTIONS(13546),
    [anon_sym_catch] = ACTIONS(13546),
    [anon_sym_finally] = ACTIONS(13546),
    [anon_sym_for] = ACTIONS(13546),
    [anon_sym_while] = ACTIONS(13546),
    [sym_break_statement] = ACTIONS(13546),
    [sym_continue_statement] = ACTIONS(13546),
    [anon_sym_return] = ACTIONS(13546),
    [anon_sym_const] = ACTIONS(13546),
    [anon_sym_global] = ACTIONS(13546),
    [anon_sym_local] = ACTIONS(13546),
    [anon_sym_LPAREN] = ACTIONS(13546),
    [anon_sym_COLON2] = ACTIONS(13546),
    [anon_sym_export] = ACTIONS(13546),
    [anon_sym_import] = ACTIONS(13546),
    [anon_sym_using] = ACTIONS(13546),
    [anon_sym_LBRACK] = ACTIONS(13546),
    [anon_sym_LF] = ACTIONS(13548),
    [anon_sym_in] = ACTIONS(13546),
    [anon_sym_LBRACE] = ACTIONS(13546),
    [anon_sym_DOLLAR] = ACTIONS(13546),
    [anon_sym_COLON_COLON] = ACTIONS(13546),
    [anon_sym_isa] = ACTIONS(13546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13546),
    [anon_sym_QMARK] = ACTIONS(13546),
    [anon_sym_AT] = ACTIONS(13546),
    [anon_sym_true] = ACTIONS(13546),
    [anon_sym_false] = ACTIONS(13546),
    [aux_sym_integer_literal_token1] = ACTIONS(13546),
    [aux_sym_integer_literal_token2] = ACTIONS(13546),
    [aux_sym_integer_literal_token3] = ACTIONS(13546),
    [aux_sym_integer_literal_token4] = ACTIONS(13546),
    [aux_sym_float_literal_token1] = ACTIONS(13546),
    [aux_sym_float_literal_token3] = ACTIONS(13546),
    [aux_sym_float_literal_token4] = ACTIONS(13546),
    [sym_character_literal] = ACTIONS(13546),
    [sym__pair_operator] = ACTIONS(13546),
    [sym__arrow_operator] = ACTIONS(13546),
    [sym__lazy_or_operator] = ACTIONS(13546),
    [sym__lazy_and_operator] = ACTIONS(13546),
    [sym__comparison_operator] = ACTIONS(13546),
    [sym__pipe_right_operator] = ACTIONS(13546),
    [sym__pipe_left_operator] = ACTIONS(13546),
    [sym__ellipsis_operator] = ACTIONS(13546),
    [sym__plus_operator] = ACTIONS(13546),
    [sym__times_operator] = ACTIONS(13546),
    [sym__rational_operator] = ACTIONS(13546),
    [sym__bitshift_operator] = ACTIONS(13546),
    [sym__power_operator] = ACTIONS(13546),
    [sym__tilde_operator] = ACTIONS(13546),
    [sym__type_order_operator] = ACTIONS(13546),
    [sym__unary_operator] = ACTIONS(13546),
    [sym__unary_plus_operator] = ACTIONS(13546),
    [aux_sym__terminator_token1] = ACTIONS(13546),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13548),
    [sym__command_start] = ACTIONS(13548),
  },
  [8470] = {
    [sym__word_identifier] = ACTIONS(13550),
    [anon_sym_EQ] = ACTIONS(13550),
    [anon_sym_COMMA] = ACTIONS(13550),
    [anon_sym_COLON] = ACTIONS(13550),
    [anon_sym_begin] = ACTIONS(13550),
    [anon_sym_module] = ACTIONS(13550),
    [anon_sym_baremodule] = ACTIONS(13550),
    [anon_sym_abstract] = ACTIONS(13550),
    [anon_sym_primitive] = ACTIONS(13550),
    [anon_sym_mutable] = ACTIONS(13550),
    [anon_sym_struct] = ACTIONS(13550),
    [anon_sym_function] = ACTIONS(13550),
    [anon_sym_macro] = ACTIONS(13550),
    [anon_sym_where] = ACTIONS(13550),
    [anon_sym_quote] = ACTIONS(13550),
    [anon_sym_let] = ACTIONS(13550),
    [anon_sym_if] = ACTIONS(13550),
    [anon_sym_try] = ACTIONS(13550),
    [anon_sym_catch] = ACTIONS(13550),
    [anon_sym_finally] = ACTIONS(13550),
    [anon_sym_for] = ACTIONS(13550),
    [anon_sym_while] = ACTIONS(13550),
    [sym_break_statement] = ACTIONS(13550),
    [sym_continue_statement] = ACTIONS(13550),
    [anon_sym_return] = ACTIONS(13550),
    [anon_sym_const] = ACTIONS(13550),
    [anon_sym_global] = ACTIONS(13550),
    [anon_sym_local] = ACTIONS(13550),
    [anon_sym_LPAREN] = ACTIONS(13550),
    [anon_sym_COLON2] = ACTIONS(13550),
    [anon_sym_export] = ACTIONS(13550),
    [anon_sym_import] = ACTIONS(13550),
    [anon_sym_using] = ACTIONS(13550),
    [anon_sym_LBRACK] = ACTIONS(13550),
    [anon_sym_LF] = ACTIONS(13552),
    [anon_sym_in] = ACTIONS(13550),
    [anon_sym_LBRACE] = ACTIONS(13550),
    [anon_sym_DOLLAR] = ACTIONS(13550),
    [anon_sym_COLON_COLON] = ACTIONS(13550),
    [anon_sym_isa] = ACTIONS(13550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13550),
    [anon_sym_QMARK] = ACTIONS(13550),
    [anon_sym_AT] = ACTIONS(13550),
    [anon_sym_true] = ACTIONS(13550),
    [anon_sym_false] = ACTIONS(13550),
    [aux_sym_integer_literal_token1] = ACTIONS(13550),
    [aux_sym_integer_literal_token2] = ACTIONS(13550),
    [aux_sym_integer_literal_token3] = ACTIONS(13550),
    [aux_sym_integer_literal_token4] = ACTIONS(13550),
    [aux_sym_float_literal_token1] = ACTIONS(13550),
    [aux_sym_float_literal_token3] = ACTIONS(13550),
    [aux_sym_float_literal_token4] = ACTIONS(13550),
    [sym_character_literal] = ACTIONS(13550),
    [sym__pair_operator] = ACTIONS(13550),
    [sym__arrow_operator] = ACTIONS(13550),
    [sym__lazy_or_operator] = ACTIONS(13550),
    [sym__lazy_and_operator] = ACTIONS(13550),
    [sym__comparison_operator] = ACTIONS(13550),
    [sym__pipe_right_operator] = ACTIONS(13550),
    [sym__pipe_left_operator] = ACTIONS(13550),
    [sym__ellipsis_operator] = ACTIONS(13550),
    [sym__plus_operator] = ACTIONS(13550),
    [sym__times_operator] = ACTIONS(13550),
    [sym__rational_operator] = ACTIONS(13550),
    [sym__bitshift_operator] = ACTIONS(13550),
    [sym__power_operator] = ACTIONS(13550),
    [sym__tilde_operator] = ACTIONS(13550),
    [sym__type_order_operator] = ACTIONS(13550),
    [sym__unary_operator] = ACTIONS(13550),
    [sym__unary_plus_operator] = ACTIONS(13550),
    [aux_sym__terminator_token1] = ACTIONS(13550),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13552),
    [sym__command_start] = ACTIONS(13552),
  },
  [8471] = {
    [sym__word_identifier] = ACTIONS(13362),
    [anon_sym_EQ] = ACTIONS(13362),
    [anon_sym_COMMA] = ACTIONS(13362),
    [anon_sym_COLON] = ACTIONS(13362),
    [anon_sym_begin] = ACTIONS(13362),
    [anon_sym_module] = ACTIONS(13362),
    [anon_sym_baremodule] = ACTIONS(13362),
    [anon_sym_end] = ACTIONS(13362),
    [anon_sym_abstract] = ACTIONS(13362),
    [anon_sym_primitive] = ACTIONS(13362),
    [anon_sym_mutable] = ACTIONS(13362),
    [anon_sym_struct] = ACTIONS(13362),
    [anon_sym_function] = ACTIONS(13362),
    [anon_sym_macro] = ACTIONS(13362),
    [anon_sym_where] = ACTIONS(13362),
    [anon_sym_quote] = ACTIONS(13362),
    [anon_sym_let] = ACTIONS(13362),
    [anon_sym_if] = ACTIONS(13362),
    [anon_sym_try] = ACTIONS(13362),
    [anon_sym_catch] = ACTIONS(13362),
    [anon_sym_for] = ACTIONS(13362),
    [anon_sym_while] = ACTIONS(13362),
    [sym_break_statement] = ACTIONS(13362),
    [sym_continue_statement] = ACTIONS(13362),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_const] = ACTIONS(13362),
    [anon_sym_global] = ACTIONS(13362),
    [anon_sym_local] = ACTIONS(13362),
    [anon_sym_LPAREN] = ACTIONS(13362),
    [anon_sym_COLON2] = ACTIONS(13362),
    [anon_sym_export] = ACTIONS(13362),
    [anon_sym_import] = ACTIONS(13362),
    [anon_sym_using] = ACTIONS(13362),
    [anon_sym_LBRACK] = ACTIONS(13362),
    [anon_sym_LF] = ACTIONS(13364),
    [anon_sym_in] = ACTIONS(13362),
    [anon_sym_LBRACE] = ACTIONS(13362),
    [anon_sym_DOLLAR] = ACTIONS(13362),
    [anon_sym_COLON_COLON] = ACTIONS(13362),
    [anon_sym_isa] = ACTIONS(13362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13362),
    [anon_sym_QMARK] = ACTIONS(13362),
    [anon_sym_AT] = ACTIONS(13362),
    [anon_sym_true] = ACTIONS(13362),
    [anon_sym_false] = ACTIONS(13362),
    [aux_sym_integer_literal_token1] = ACTIONS(13362),
    [aux_sym_integer_literal_token2] = ACTIONS(13362),
    [aux_sym_integer_literal_token3] = ACTIONS(13362),
    [aux_sym_integer_literal_token4] = ACTIONS(13362),
    [aux_sym_float_literal_token1] = ACTIONS(13362),
    [aux_sym_float_literal_token3] = ACTIONS(13362),
    [aux_sym_float_literal_token4] = ACTIONS(13362),
    [sym_character_literal] = ACTIONS(13362),
    [sym__pair_operator] = ACTIONS(13362),
    [sym__arrow_operator] = ACTIONS(13362),
    [sym__lazy_or_operator] = ACTIONS(13362),
    [sym__lazy_and_operator] = ACTIONS(13362),
    [sym__comparison_operator] = ACTIONS(13362),
    [sym__pipe_right_operator] = ACTIONS(13362),
    [sym__pipe_left_operator] = ACTIONS(13362),
    [sym__ellipsis_operator] = ACTIONS(13362),
    [sym__plus_operator] = ACTIONS(13362),
    [sym__times_operator] = ACTIONS(13362),
    [sym__rational_operator] = ACTIONS(13362),
    [sym__bitshift_operator] = ACTIONS(13362),
    [sym__power_operator] = ACTIONS(13362),
    [sym__tilde_operator] = ACTIONS(13362),
    [sym__type_order_operator] = ACTIONS(13362),
    [sym__unary_operator] = ACTIONS(13362),
    [sym__unary_plus_operator] = ACTIONS(13362),
    [aux_sym__terminator_token1] = ACTIONS(13362),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13364),
    [sym__command_start] = ACTIONS(13364),
  },
  [8472] = {
    [sym__word_identifier] = ACTIONS(13366),
    [anon_sym_EQ] = ACTIONS(13366),
    [anon_sym_COMMA] = ACTIONS(13366),
    [anon_sym_COLON] = ACTIONS(13366),
    [anon_sym_begin] = ACTIONS(13366),
    [anon_sym_module] = ACTIONS(13366),
    [anon_sym_baremodule] = ACTIONS(13366),
    [anon_sym_end] = ACTIONS(13366),
    [anon_sym_abstract] = ACTIONS(13366),
    [anon_sym_primitive] = ACTIONS(13366),
    [anon_sym_mutable] = ACTIONS(13366),
    [anon_sym_struct] = ACTIONS(13366),
    [anon_sym_function] = ACTIONS(13366),
    [anon_sym_macro] = ACTIONS(13366),
    [anon_sym_where] = ACTIONS(13366),
    [anon_sym_quote] = ACTIONS(13366),
    [anon_sym_let] = ACTIONS(13366),
    [anon_sym_if] = ACTIONS(13366),
    [anon_sym_try] = ACTIONS(13366),
    [anon_sym_catch] = ACTIONS(13366),
    [anon_sym_for] = ACTIONS(13366),
    [anon_sym_while] = ACTIONS(13366),
    [sym_break_statement] = ACTIONS(13366),
    [sym_continue_statement] = ACTIONS(13366),
    [anon_sym_return] = ACTIONS(13366),
    [anon_sym_const] = ACTIONS(13366),
    [anon_sym_global] = ACTIONS(13366),
    [anon_sym_local] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(13366),
    [anon_sym_COLON2] = ACTIONS(13366),
    [anon_sym_export] = ACTIONS(13366),
    [anon_sym_import] = ACTIONS(13366),
    [anon_sym_using] = ACTIONS(13366),
    [anon_sym_LBRACK] = ACTIONS(13366),
    [anon_sym_LF] = ACTIONS(13368),
    [anon_sym_in] = ACTIONS(13366),
    [anon_sym_LBRACE] = ACTIONS(13366),
    [anon_sym_DOLLAR] = ACTIONS(13366),
    [anon_sym_COLON_COLON] = ACTIONS(13366),
    [anon_sym_isa] = ACTIONS(13366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13366),
    [anon_sym_QMARK] = ACTIONS(13366),
    [anon_sym_AT] = ACTIONS(13366),
    [anon_sym_true] = ACTIONS(13366),
    [anon_sym_false] = ACTIONS(13366),
    [aux_sym_integer_literal_token1] = ACTIONS(13366),
    [aux_sym_integer_literal_token2] = ACTIONS(13366),
    [aux_sym_integer_literal_token3] = ACTIONS(13366),
    [aux_sym_integer_literal_token4] = ACTIONS(13366),
    [aux_sym_float_literal_token1] = ACTIONS(13366),
    [aux_sym_float_literal_token3] = ACTIONS(13366),
    [aux_sym_float_literal_token4] = ACTIONS(13366),
    [sym_character_literal] = ACTIONS(13366),
    [sym__pair_operator] = ACTIONS(13366),
    [sym__arrow_operator] = ACTIONS(13366),
    [sym__lazy_or_operator] = ACTIONS(13366),
    [sym__lazy_and_operator] = ACTIONS(13366),
    [sym__comparison_operator] = ACTIONS(13366),
    [sym__pipe_right_operator] = ACTIONS(13366),
    [sym__pipe_left_operator] = ACTIONS(13366),
    [sym__ellipsis_operator] = ACTIONS(13366),
    [sym__plus_operator] = ACTIONS(13366),
    [sym__times_operator] = ACTIONS(13366),
    [sym__rational_operator] = ACTIONS(13366),
    [sym__bitshift_operator] = ACTIONS(13366),
    [sym__power_operator] = ACTIONS(13366),
    [sym__tilde_operator] = ACTIONS(13366),
    [sym__type_order_operator] = ACTIONS(13366),
    [sym__unary_operator] = ACTIONS(13366),
    [sym__unary_plus_operator] = ACTIONS(13366),
    [aux_sym__terminator_token1] = ACTIONS(13366),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13368),
    [sym__command_start] = ACTIONS(13368),
  },
  [8473] = {
    [sym__word_identifier] = ACTIONS(13370),
    [anon_sym_EQ] = ACTIONS(13370),
    [anon_sym_COMMA] = ACTIONS(13370),
    [anon_sym_COLON] = ACTIONS(13370),
    [anon_sym_begin] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(13370),
    [anon_sym_baremodule] = ACTIONS(13370),
    [anon_sym_end] = ACTIONS(13370),
    [anon_sym_abstract] = ACTIONS(13370),
    [anon_sym_primitive] = ACTIONS(13370),
    [anon_sym_mutable] = ACTIONS(13370),
    [anon_sym_struct] = ACTIONS(13370),
    [anon_sym_function] = ACTIONS(13370),
    [anon_sym_macro] = ACTIONS(13370),
    [anon_sym_where] = ACTIONS(13370),
    [anon_sym_quote] = ACTIONS(13370),
    [anon_sym_let] = ACTIONS(13370),
    [anon_sym_if] = ACTIONS(13370),
    [anon_sym_try] = ACTIONS(13370),
    [anon_sym_catch] = ACTIONS(13370),
    [anon_sym_for] = ACTIONS(13370),
    [anon_sym_while] = ACTIONS(13370),
    [sym_break_statement] = ACTIONS(13370),
    [sym_continue_statement] = ACTIONS(13370),
    [anon_sym_return] = ACTIONS(13370),
    [anon_sym_const] = ACTIONS(13370),
    [anon_sym_global] = ACTIONS(13370),
    [anon_sym_local] = ACTIONS(13370),
    [anon_sym_LPAREN] = ACTIONS(13370),
    [anon_sym_COLON2] = ACTIONS(13370),
    [anon_sym_export] = ACTIONS(13370),
    [anon_sym_import] = ACTIONS(13370),
    [anon_sym_using] = ACTIONS(13370),
    [anon_sym_LBRACK] = ACTIONS(13370),
    [anon_sym_LF] = ACTIONS(13372),
    [anon_sym_in] = ACTIONS(13370),
    [anon_sym_LBRACE] = ACTIONS(13370),
    [anon_sym_DOLLAR] = ACTIONS(13370),
    [anon_sym_COLON_COLON] = ACTIONS(13370),
    [anon_sym_isa] = ACTIONS(13370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13370),
    [anon_sym_QMARK] = ACTIONS(13370),
    [anon_sym_AT] = ACTIONS(13370),
    [anon_sym_true] = ACTIONS(13370),
    [anon_sym_false] = ACTIONS(13370),
    [aux_sym_integer_literal_token1] = ACTIONS(13370),
    [aux_sym_integer_literal_token2] = ACTIONS(13370),
    [aux_sym_integer_literal_token3] = ACTIONS(13370),
    [aux_sym_integer_literal_token4] = ACTIONS(13370),
    [aux_sym_float_literal_token1] = ACTIONS(13370),
    [aux_sym_float_literal_token3] = ACTIONS(13370),
    [aux_sym_float_literal_token4] = ACTIONS(13370),
    [sym_character_literal] = ACTIONS(13370),
    [sym__pair_operator] = ACTIONS(13370),
    [sym__arrow_operator] = ACTIONS(13370),
    [sym__lazy_or_operator] = ACTIONS(13370),
    [sym__lazy_and_operator] = ACTIONS(13370),
    [sym__comparison_operator] = ACTIONS(13370),
    [sym__pipe_right_operator] = ACTIONS(13370),
    [sym__pipe_left_operator] = ACTIONS(13370),
    [sym__ellipsis_operator] = ACTIONS(13370),
    [sym__plus_operator] = ACTIONS(13370),
    [sym__times_operator] = ACTIONS(13370),
    [sym__rational_operator] = ACTIONS(13370),
    [sym__bitshift_operator] = ACTIONS(13370),
    [sym__power_operator] = ACTIONS(13370),
    [sym__tilde_operator] = ACTIONS(13370),
    [sym__type_order_operator] = ACTIONS(13370),
    [sym__unary_operator] = ACTIONS(13370),
    [sym__unary_plus_operator] = ACTIONS(13370),
    [aux_sym__terminator_token1] = ACTIONS(13370),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13372),
    [sym__command_start] = ACTIONS(13372),
  },
  [8474] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_EQ] = ACTIONS(12388),
    [anon_sym_COMMA] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_RPAREN] = ACTIONS(12388),
    [anon_sym_COLON2] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_in] = ACTIONS(12388),
    [anon_sym_SEMI] = ACTIONS(12388),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_isa] = ACTIONS(12388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12388),
    [anon_sym_QMARK] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__lazy_or_operator] = ACTIONS(12388),
    [sym__lazy_and_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [8475] = {
    [sym__word_identifier] = ACTIONS(13374),
    [anon_sym_EQ] = ACTIONS(13374),
    [anon_sym_COMMA] = ACTIONS(13374),
    [anon_sym_COLON] = ACTIONS(13374),
    [anon_sym_begin] = ACTIONS(13374),
    [anon_sym_module] = ACTIONS(13374),
    [anon_sym_baremodule] = ACTIONS(13374),
    [anon_sym_end] = ACTIONS(13374),
    [anon_sym_abstract] = ACTIONS(13374),
    [anon_sym_primitive] = ACTIONS(13374),
    [anon_sym_mutable] = ACTIONS(13374),
    [anon_sym_struct] = ACTIONS(13374),
    [anon_sym_function] = ACTIONS(13374),
    [anon_sym_macro] = ACTIONS(13374),
    [anon_sym_where] = ACTIONS(13374),
    [anon_sym_quote] = ACTIONS(13374),
    [anon_sym_let] = ACTIONS(13374),
    [anon_sym_if] = ACTIONS(13374),
    [anon_sym_try] = ACTIONS(13374),
    [anon_sym_catch] = ACTIONS(13374),
    [anon_sym_for] = ACTIONS(13374),
    [anon_sym_while] = ACTIONS(13374),
    [sym_break_statement] = ACTIONS(13374),
    [sym_continue_statement] = ACTIONS(13374),
    [anon_sym_return] = ACTIONS(13374),
    [anon_sym_const] = ACTIONS(13374),
    [anon_sym_global] = ACTIONS(13374),
    [anon_sym_local] = ACTIONS(13374),
    [anon_sym_LPAREN] = ACTIONS(13374),
    [anon_sym_COLON2] = ACTIONS(13374),
    [anon_sym_export] = ACTIONS(13374),
    [anon_sym_import] = ACTIONS(13374),
    [anon_sym_using] = ACTIONS(13374),
    [anon_sym_LBRACK] = ACTIONS(13374),
    [anon_sym_LF] = ACTIONS(13376),
    [anon_sym_in] = ACTIONS(13374),
    [anon_sym_LBRACE] = ACTIONS(13374),
    [anon_sym_DOLLAR] = ACTIONS(13374),
    [anon_sym_COLON_COLON] = ACTIONS(13374),
    [anon_sym_isa] = ACTIONS(13374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13374),
    [anon_sym_QMARK] = ACTIONS(13374),
    [anon_sym_AT] = ACTIONS(13374),
    [anon_sym_true] = ACTIONS(13374),
    [anon_sym_false] = ACTIONS(13374),
    [aux_sym_integer_literal_token1] = ACTIONS(13374),
    [aux_sym_integer_literal_token2] = ACTIONS(13374),
    [aux_sym_integer_literal_token3] = ACTIONS(13374),
    [aux_sym_integer_literal_token4] = ACTIONS(13374),
    [aux_sym_float_literal_token1] = ACTIONS(13374),
    [aux_sym_float_literal_token3] = ACTIONS(13374),
    [aux_sym_float_literal_token4] = ACTIONS(13374),
    [sym_character_literal] = ACTIONS(13374),
    [sym__pair_operator] = ACTIONS(13374),
    [sym__arrow_operator] = ACTIONS(13374),
    [sym__lazy_or_operator] = ACTIONS(13374),
    [sym__lazy_and_operator] = ACTIONS(13374),
    [sym__comparison_operator] = ACTIONS(13374),
    [sym__pipe_right_operator] = ACTIONS(13374),
    [sym__pipe_left_operator] = ACTIONS(13374),
    [sym__ellipsis_operator] = ACTIONS(13374),
    [sym__plus_operator] = ACTIONS(13374),
    [sym__times_operator] = ACTIONS(13374),
    [sym__rational_operator] = ACTIONS(13374),
    [sym__bitshift_operator] = ACTIONS(13374),
    [sym__power_operator] = ACTIONS(13374),
    [sym__tilde_operator] = ACTIONS(13374),
    [sym__type_order_operator] = ACTIONS(13374),
    [sym__unary_operator] = ACTIONS(13374),
    [sym__unary_plus_operator] = ACTIONS(13374),
    [aux_sym__terminator_token1] = ACTIONS(13374),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13376),
    [sym__command_start] = ACTIONS(13376),
  },
  [8476] = {
    [sym__word_identifier] = ACTIONS(13378),
    [anon_sym_EQ] = ACTIONS(13378),
    [anon_sym_COMMA] = ACTIONS(13378),
    [anon_sym_COLON] = ACTIONS(13378),
    [anon_sym_begin] = ACTIONS(13378),
    [anon_sym_module] = ACTIONS(13378),
    [anon_sym_baremodule] = ACTIONS(13378),
    [anon_sym_end] = ACTIONS(13378),
    [anon_sym_abstract] = ACTIONS(13378),
    [anon_sym_primitive] = ACTIONS(13378),
    [anon_sym_mutable] = ACTIONS(13378),
    [anon_sym_struct] = ACTIONS(13378),
    [anon_sym_function] = ACTIONS(13378),
    [anon_sym_macro] = ACTIONS(13378),
    [anon_sym_where] = ACTIONS(13378),
    [anon_sym_quote] = ACTIONS(13378),
    [anon_sym_let] = ACTIONS(13378),
    [anon_sym_if] = ACTIONS(13378),
    [anon_sym_try] = ACTIONS(13378),
    [anon_sym_catch] = ACTIONS(13378),
    [anon_sym_for] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(13378),
    [sym_break_statement] = ACTIONS(13378),
    [sym_continue_statement] = ACTIONS(13378),
    [anon_sym_return] = ACTIONS(13378),
    [anon_sym_const] = ACTIONS(13378),
    [anon_sym_global] = ACTIONS(13378),
    [anon_sym_local] = ACTIONS(13378),
    [anon_sym_LPAREN] = ACTIONS(13378),
    [anon_sym_COLON2] = ACTIONS(13378),
    [anon_sym_export] = ACTIONS(13378),
    [anon_sym_import] = ACTIONS(13378),
    [anon_sym_using] = ACTIONS(13378),
    [anon_sym_LBRACK] = ACTIONS(13378),
    [anon_sym_LF] = ACTIONS(13380),
    [anon_sym_in] = ACTIONS(13378),
    [anon_sym_LBRACE] = ACTIONS(13378),
    [anon_sym_DOLLAR] = ACTIONS(13378),
    [anon_sym_COLON_COLON] = ACTIONS(13378),
    [anon_sym_isa] = ACTIONS(13378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13378),
    [anon_sym_QMARK] = ACTIONS(13378),
    [anon_sym_AT] = ACTIONS(13378),
    [anon_sym_true] = ACTIONS(13378),
    [anon_sym_false] = ACTIONS(13378),
    [aux_sym_integer_literal_token1] = ACTIONS(13378),
    [aux_sym_integer_literal_token2] = ACTIONS(13378),
    [aux_sym_integer_literal_token3] = ACTIONS(13378),
    [aux_sym_integer_literal_token4] = ACTIONS(13378),
    [aux_sym_float_literal_token1] = ACTIONS(13378),
    [aux_sym_float_literal_token3] = ACTIONS(13378),
    [aux_sym_float_literal_token4] = ACTIONS(13378),
    [sym_character_literal] = ACTIONS(13378),
    [sym__pair_operator] = ACTIONS(13378),
    [sym__arrow_operator] = ACTIONS(13378),
    [sym__lazy_or_operator] = ACTIONS(13378),
    [sym__lazy_and_operator] = ACTIONS(13378),
    [sym__comparison_operator] = ACTIONS(13378),
    [sym__pipe_right_operator] = ACTIONS(13378),
    [sym__pipe_left_operator] = ACTIONS(13378),
    [sym__ellipsis_operator] = ACTIONS(13378),
    [sym__plus_operator] = ACTIONS(13378),
    [sym__times_operator] = ACTIONS(13378),
    [sym__rational_operator] = ACTIONS(13378),
    [sym__bitshift_operator] = ACTIONS(13378),
    [sym__power_operator] = ACTIONS(13378),
    [sym__tilde_operator] = ACTIONS(13378),
    [sym__type_order_operator] = ACTIONS(13378),
    [sym__unary_operator] = ACTIONS(13378),
    [sym__unary_plus_operator] = ACTIONS(13378),
    [aux_sym__terminator_token1] = ACTIONS(13378),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13380),
    [sym__command_start] = ACTIONS(13380),
  },
  [8477] = {
    [sym__word_identifier] = ACTIONS(13382),
    [anon_sym_EQ] = ACTIONS(13382),
    [anon_sym_COMMA] = ACTIONS(13382),
    [anon_sym_COLON] = ACTIONS(13382),
    [anon_sym_begin] = ACTIONS(13382),
    [anon_sym_module] = ACTIONS(13382),
    [anon_sym_baremodule] = ACTIONS(13382),
    [anon_sym_end] = ACTIONS(13382),
    [anon_sym_abstract] = ACTIONS(13382),
    [anon_sym_primitive] = ACTIONS(13382),
    [anon_sym_mutable] = ACTIONS(13382),
    [anon_sym_struct] = ACTIONS(13382),
    [anon_sym_function] = ACTIONS(13382),
    [anon_sym_macro] = ACTIONS(13382),
    [anon_sym_where] = ACTIONS(13382),
    [anon_sym_quote] = ACTIONS(13382),
    [anon_sym_let] = ACTIONS(13382),
    [anon_sym_if] = ACTIONS(13382),
    [anon_sym_try] = ACTIONS(13382),
    [anon_sym_catch] = ACTIONS(13382),
    [anon_sym_for] = ACTIONS(13382),
    [anon_sym_while] = ACTIONS(13382),
    [sym_break_statement] = ACTIONS(13382),
    [sym_continue_statement] = ACTIONS(13382),
    [anon_sym_return] = ACTIONS(13382),
    [anon_sym_const] = ACTIONS(13382),
    [anon_sym_global] = ACTIONS(13382),
    [anon_sym_local] = ACTIONS(13382),
    [anon_sym_LPAREN] = ACTIONS(13382),
    [anon_sym_COLON2] = ACTIONS(13382),
    [anon_sym_export] = ACTIONS(13382),
    [anon_sym_import] = ACTIONS(13382),
    [anon_sym_using] = ACTIONS(13382),
    [anon_sym_LBRACK] = ACTIONS(13382),
    [anon_sym_LF] = ACTIONS(13384),
    [anon_sym_in] = ACTIONS(13382),
    [anon_sym_LBRACE] = ACTIONS(13382),
    [anon_sym_DOLLAR] = ACTIONS(13382),
    [anon_sym_COLON_COLON] = ACTIONS(13382),
    [anon_sym_isa] = ACTIONS(13382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13382),
    [anon_sym_QMARK] = ACTIONS(13382),
    [anon_sym_AT] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(13382),
    [anon_sym_false] = ACTIONS(13382),
    [aux_sym_integer_literal_token1] = ACTIONS(13382),
    [aux_sym_integer_literal_token2] = ACTIONS(13382),
    [aux_sym_integer_literal_token3] = ACTIONS(13382),
    [aux_sym_integer_literal_token4] = ACTIONS(13382),
    [aux_sym_float_literal_token1] = ACTIONS(13382),
    [aux_sym_float_literal_token3] = ACTIONS(13382),
    [aux_sym_float_literal_token4] = ACTIONS(13382),
    [sym_character_literal] = ACTIONS(13382),
    [sym__pair_operator] = ACTIONS(13382),
    [sym__arrow_operator] = ACTIONS(13382),
    [sym__lazy_or_operator] = ACTIONS(13382),
    [sym__lazy_and_operator] = ACTIONS(13382),
    [sym__comparison_operator] = ACTIONS(13382),
    [sym__pipe_right_operator] = ACTIONS(13382),
    [sym__pipe_left_operator] = ACTIONS(13382),
    [sym__ellipsis_operator] = ACTIONS(13382),
    [sym__plus_operator] = ACTIONS(13382),
    [sym__times_operator] = ACTIONS(13382),
    [sym__rational_operator] = ACTIONS(13382),
    [sym__bitshift_operator] = ACTIONS(13382),
    [sym__power_operator] = ACTIONS(13382),
    [sym__tilde_operator] = ACTIONS(13382),
    [sym__type_order_operator] = ACTIONS(13382),
    [sym__unary_operator] = ACTIONS(13382),
    [sym__unary_plus_operator] = ACTIONS(13382),
    [aux_sym__terminator_token1] = ACTIONS(13382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13384),
    [sym__command_start] = ACTIONS(13384),
  },
  [8478] = {
    [sym__word_identifier] = ACTIONS(13386),
    [anon_sym_EQ] = ACTIONS(13386),
    [anon_sym_COMMA] = ACTIONS(13386),
    [anon_sym_COLON] = ACTIONS(13386),
    [anon_sym_begin] = ACTIONS(13386),
    [anon_sym_module] = ACTIONS(13386),
    [anon_sym_baremodule] = ACTIONS(13386),
    [anon_sym_end] = ACTIONS(13386),
    [anon_sym_abstract] = ACTIONS(13386),
    [anon_sym_primitive] = ACTIONS(13386),
    [anon_sym_mutable] = ACTIONS(13386),
    [anon_sym_struct] = ACTIONS(13386),
    [anon_sym_function] = ACTIONS(13386),
    [anon_sym_macro] = ACTIONS(13386),
    [anon_sym_where] = ACTIONS(13386),
    [anon_sym_quote] = ACTIONS(13386),
    [anon_sym_let] = ACTIONS(13386),
    [anon_sym_if] = ACTIONS(13386),
    [anon_sym_try] = ACTIONS(13386),
    [anon_sym_catch] = ACTIONS(13386),
    [anon_sym_for] = ACTIONS(13386),
    [anon_sym_while] = ACTIONS(13386),
    [sym_break_statement] = ACTIONS(13386),
    [sym_continue_statement] = ACTIONS(13386),
    [anon_sym_return] = ACTIONS(13386),
    [anon_sym_const] = ACTIONS(13386),
    [anon_sym_global] = ACTIONS(13386),
    [anon_sym_local] = ACTIONS(13386),
    [anon_sym_LPAREN] = ACTIONS(13386),
    [anon_sym_COLON2] = ACTIONS(13386),
    [anon_sym_export] = ACTIONS(13386),
    [anon_sym_import] = ACTIONS(13386),
    [anon_sym_using] = ACTIONS(13386),
    [anon_sym_LBRACK] = ACTIONS(13386),
    [anon_sym_LF] = ACTIONS(13388),
    [anon_sym_in] = ACTIONS(13386),
    [anon_sym_LBRACE] = ACTIONS(13386),
    [anon_sym_DOLLAR] = ACTIONS(13386),
    [anon_sym_COLON_COLON] = ACTIONS(13386),
    [anon_sym_isa] = ACTIONS(13386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13386),
    [anon_sym_QMARK] = ACTIONS(13386),
    [anon_sym_AT] = ACTIONS(13386),
    [anon_sym_true] = ACTIONS(13386),
    [anon_sym_false] = ACTIONS(13386),
    [aux_sym_integer_literal_token1] = ACTIONS(13386),
    [aux_sym_integer_literal_token2] = ACTIONS(13386),
    [aux_sym_integer_literal_token3] = ACTIONS(13386),
    [aux_sym_integer_literal_token4] = ACTIONS(13386),
    [aux_sym_float_literal_token1] = ACTIONS(13386),
    [aux_sym_float_literal_token3] = ACTIONS(13386),
    [aux_sym_float_literal_token4] = ACTIONS(13386),
    [sym_character_literal] = ACTIONS(13386),
    [sym__pair_operator] = ACTIONS(13386),
    [sym__arrow_operator] = ACTIONS(13386),
    [sym__lazy_or_operator] = ACTIONS(13386),
    [sym__lazy_and_operator] = ACTIONS(13386),
    [sym__comparison_operator] = ACTIONS(13386),
    [sym__pipe_right_operator] = ACTIONS(13386),
    [sym__pipe_left_operator] = ACTIONS(13386),
    [sym__ellipsis_operator] = ACTIONS(13386),
    [sym__plus_operator] = ACTIONS(13386),
    [sym__times_operator] = ACTIONS(13386),
    [sym__rational_operator] = ACTIONS(13386),
    [sym__bitshift_operator] = ACTIONS(13386),
    [sym__power_operator] = ACTIONS(13386),
    [sym__tilde_operator] = ACTIONS(13386),
    [sym__type_order_operator] = ACTIONS(13386),
    [sym__unary_operator] = ACTIONS(13386),
    [sym__unary_plus_operator] = ACTIONS(13386),
    [aux_sym__terminator_token1] = ACTIONS(13386),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13388),
    [sym__command_start] = ACTIONS(13388),
  },
  [8479] = {
    [sym__word_identifier] = ACTIONS(13390),
    [anon_sym_EQ] = ACTIONS(13390),
    [anon_sym_COMMA] = ACTIONS(13390),
    [anon_sym_COLON] = ACTIONS(13390),
    [anon_sym_begin] = ACTIONS(13390),
    [anon_sym_module] = ACTIONS(13390),
    [anon_sym_baremodule] = ACTIONS(13390),
    [anon_sym_end] = ACTIONS(13390),
    [anon_sym_abstract] = ACTIONS(13390),
    [anon_sym_primitive] = ACTIONS(13390),
    [anon_sym_mutable] = ACTIONS(13390),
    [anon_sym_struct] = ACTIONS(13390),
    [anon_sym_function] = ACTIONS(13390),
    [anon_sym_macro] = ACTIONS(13390),
    [anon_sym_where] = ACTIONS(13390),
    [anon_sym_quote] = ACTIONS(13390),
    [anon_sym_let] = ACTIONS(13390),
    [anon_sym_if] = ACTIONS(13390),
    [anon_sym_try] = ACTIONS(13390),
    [anon_sym_catch] = ACTIONS(13390),
    [anon_sym_for] = ACTIONS(13390),
    [anon_sym_while] = ACTIONS(13390),
    [sym_break_statement] = ACTIONS(13390),
    [sym_continue_statement] = ACTIONS(13390),
    [anon_sym_return] = ACTIONS(13390),
    [anon_sym_const] = ACTIONS(13390),
    [anon_sym_global] = ACTIONS(13390),
    [anon_sym_local] = ACTIONS(13390),
    [anon_sym_LPAREN] = ACTIONS(13390),
    [anon_sym_COLON2] = ACTIONS(13390),
    [anon_sym_export] = ACTIONS(13390),
    [anon_sym_import] = ACTIONS(13390),
    [anon_sym_using] = ACTIONS(13390),
    [anon_sym_LBRACK] = ACTIONS(13390),
    [anon_sym_LF] = ACTIONS(13392),
    [anon_sym_in] = ACTIONS(13390),
    [anon_sym_LBRACE] = ACTIONS(13390),
    [anon_sym_DOLLAR] = ACTIONS(13390),
    [anon_sym_COLON_COLON] = ACTIONS(13390),
    [anon_sym_isa] = ACTIONS(13390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13390),
    [anon_sym_QMARK] = ACTIONS(13390),
    [anon_sym_AT] = ACTIONS(13390),
    [anon_sym_true] = ACTIONS(13390),
    [anon_sym_false] = ACTIONS(13390),
    [aux_sym_integer_literal_token1] = ACTIONS(13390),
    [aux_sym_integer_literal_token2] = ACTIONS(13390),
    [aux_sym_integer_literal_token3] = ACTIONS(13390),
    [aux_sym_integer_literal_token4] = ACTIONS(13390),
    [aux_sym_float_literal_token1] = ACTIONS(13390),
    [aux_sym_float_literal_token3] = ACTIONS(13390),
    [aux_sym_float_literal_token4] = ACTIONS(13390),
    [sym_character_literal] = ACTIONS(13390),
    [sym__pair_operator] = ACTIONS(13390),
    [sym__arrow_operator] = ACTIONS(13390),
    [sym__lazy_or_operator] = ACTIONS(13390),
    [sym__lazy_and_operator] = ACTIONS(13390),
    [sym__comparison_operator] = ACTIONS(13390),
    [sym__pipe_right_operator] = ACTIONS(13390),
    [sym__pipe_left_operator] = ACTIONS(13390),
    [sym__ellipsis_operator] = ACTIONS(13390),
    [sym__plus_operator] = ACTIONS(13390),
    [sym__times_operator] = ACTIONS(13390),
    [sym__rational_operator] = ACTIONS(13390),
    [sym__bitshift_operator] = ACTIONS(13390),
    [sym__power_operator] = ACTIONS(13390),
    [sym__tilde_operator] = ACTIONS(13390),
    [sym__type_order_operator] = ACTIONS(13390),
    [sym__unary_operator] = ACTIONS(13390),
    [sym__unary_plus_operator] = ACTIONS(13390),
    [aux_sym__terminator_token1] = ACTIONS(13390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13392),
    [sym__command_start] = ACTIONS(13392),
  },
  [8480] = {
    [sym__word_identifier] = ACTIONS(13396),
    [anon_sym_EQ] = ACTIONS(13396),
    [anon_sym_COMMA] = ACTIONS(13396),
    [anon_sym_COLON] = ACTIONS(13396),
    [anon_sym_begin] = ACTIONS(13396),
    [anon_sym_module] = ACTIONS(13396),
    [anon_sym_baremodule] = ACTIONS(13396),
    [anon_sym_end] = ACTIONS(13396),
    [anon_sym_abstract] = ACTIONS(13396),
    [anon_sym_primitive] = ACTIONS(13396),
    [anon_sym_mutable] = ACTIONS(13396),
    [anon_sym_struct] = ACTIONS(13396),
    [anon_sym_function] = ACTIONS(13396),
    [anon_sym_macro] = ACTIONS(13396),
    [anon_sym_where] = ACTIONS(13396),
    [anon_sym_quote] = ACTIONS(13396),
    [anon_sym_let] = ACTIONS(13396),
    [anon_sym_if] = ACTIONS(13396),
    [anon_sym_try] = ACTIONS(13396),
    [anon_sym_catch] = ACTIONS(13396),
    [anon_sym_for] = ACTIONS(13396),
    [anon_sym_while] = ACTIONS(13396),
    [sym_break_statement] = ACTIONS(13396),
    [sym_continue_statement] = ACTIONS(13396),
    [anon_sym_return] = ACTIONS(13396),
    [anon_sym_const] = ACTIONS(13396),
    [anon_sym_global] = ACTIONS(13396),
    [anon_sym_local] = ACTIONS(13396),
    [anon_sym_LPAREN] = ACTIONS(13396),
    [anon_sym_COLON2] = ACTIONS(13396),
    [anon_sym_export] = ACTIONS(13396),
    [anon_sym_import] = ACTIONS(13396),
    [anon_sym_using] = ACTIONS(13396),
    [anon_sym_LBRACK] = ACTIONS(13396),
    [anon_sym_LF] = ACTIONS(13398),
    [anon_sym_in] = ACTIONS(13396),
    [anon_sym_LBRACE] = ACTIONS(13396),
    [anon_sym_DOLLAR] = ACTIONS(13396),
    [anon_sym_COLON_COLON] = ACTIONS(13396),
    [anon_sym_isa] = ACTIONS(13396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13396),
    [anon_sym_QMARK] = ACTIONS(13396),
    [anon_sym_AT] = ACTIONS(13396),
    [anon_sym_true] = ACTIONS(13396),
    [anon_sym_false] = ACTIONS(13396),
    [aux_sym_integer_literal_token1] = ACTIONS(13396),
    [aux_sym_integer_literal_token2] = ACTIONS(13396),
    [aux_sym_integer_literal_token3] = ACTIONS(13396),
    [aux_sym_integer_literal_token4] = ACTIONS(13396),
    [aux_sym_float_literal_token1] = ACTIONS(13396),
    [aux_sym_float_literal_token3] = ACTIONS(13396),
    [aux_sym_float_literal_token4] = ACTIONS(13396),
    [sym_character_literal] = ACTIONS(13396),
    [sym__pair_operator] = ACTIONS(13396),
    [sym__arrow_operator] = ACTIONS(13396),
    [sym__lazy_or_operator] = ACTIONS(13396),
    [sym__lazy_and_operator] = ACTIONS(13396),
    [sym__comparison_operator] = ACTIONS(13396),
    [sym__pipe_right_operator] = ACTIONS(13396),
    [sym__pipe_left_operator] = ACTIONS(13396),
    [sym__ellipsis_operator] = ACTIONS(13396),
    [sym__plus_operator] = ACTIONS(13396),
    [sym__times_operator] = ACTIONS(13396),
    [sym__rational_operator] = ACTIONS(13396),
    [sym__bitshift_operator] = ACTIONS(13396),
    [sym__power_operator] = ACTIONS(13396),
    [sym__tilde_operator] = ACTIONS(13396),
    [sym__type_order_operator] = ACTIONS(13396),
    [sym__unary_operator] = ACTIONS(13396),
    [sym__unary_plus_operator] = ACTIONS(13396),
    [aux_sym__terminator_token1] = ACTIONS(13396),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13398),
    [sym__command_start] = ACTIONS(13398),
  },
  [8481] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8482] = {
    [sym__word_identifier] = ACTIONS(13400),
    [anon_sym_EQ] = ACTIONS(13400),
    [anon_sym_COMMA] = ACTIONS(13400),
    [anon_sym_COLON] = ACTIONS(13400),
    [anon_sym_begin] = ACTIONS(13400),
    [anon_sym_module] = ACTIONS(13400),
    [anon_sym_baremodule] = ACTIONS(13400),
    [anon_sym_end] = ACTIONS(13400),
    [anon_sym_abstract] = ACTIONS(13400),
    [anon_sym_primitive] = ACTIONS(13400),
    [anon_sym_mutable] = ACTIONS(13400),
    [anon_sym_struct] = ACTIONS(13400),
    [anon_sym_function] = ACTIONS(13400),
    [anon_sym_macro] = ACTIONS(13400),
    [anon_sym_where] = ACTIONS(13400),
    [anon_sym_quote] = ACTIONS(13400),
    [anon_sym_let] = ACTIONS(13400),
    [anon_sym_if] = ACTIONS(13400),
    [anon_sym_try] = ACTIONS(13400),
    [anon_sym_catch] = ACTIONS(13400),
    [anon_sym_for] = ACTIONS(13400),
    [anon_sym_while] = ACTIONS(13400),
    [sym_break_statement] = ACTIONS(13400),
    [sym_continue_statement] = ACTIONS(13400),
    [anon_sym_return] = ACTIONS(13400),
    [anon_sym_const] = ACTIONS(13400),
    [anon_sym_global] = ACTIONS(13400),
    [anon_sym_local] = ACTIONS(13400),
    [anon_sym_LPAREN] = ACTIONS(13400),
    [anon_sym_COLON2] = ACTIONS(13400),
    [anon_sym_export] = ACTIONS(13400),
    [anon_sym_import] = ACTIONS(13400),
    [anon_sym_using] = ACTIONS(13400),
    [anon_sym_LBRACK] = ACTIONS(13400),
    [anon_sym_LF] = ACTIONS(13402),
    [anon_sym_in] = ACTIONS(13400),
    [anon_sym_LBRACE] = ACTIONS(13400),
    [anon_sym_DOLLAR] = ACTIONS(13400),
    [anon_sym_COLON_COLON] = ACTIONS(13400),
    [anon_sym_isa] = ACTIONS(13400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13400),
    [anon_sym_QMARK] = ACTIONS(13400),
    [anon_sym_AT] = ACTIONS(13400),
    [anon_sym_true] = ACTIONS(13400),
    [anon_sym_false] = ACTIONS(13400),
    [aux_sym_integer_literal_token1] = ACTIONS(13400),
    [aux_sym_integer_literal_token2] = ACTIONS(13400),
    [aux_sym_integer_literal_token3] = ACTIONS(13400),
    [aux_sym_integer_literal_token4] = ACTIONS(13400),
    [aux_sym_float_literal_token1] = ACTIONS(13400),
    [aux_sym_float_literal_token3] = ACTIONS(13400),
    [aux_sym_float_literal_token4] = ACTIONS(13400),
    [sym_character_literal] = ACTIONS(13400),
    [sym__pair_operator] = ACTIONS(13400),
    [sym__arrow_operator] = ACTIONS(13400),
    [sym__lazy_or_operator] = ACTIONS(13400),
    [sym__lazy_and_operator] = ACTIONS(13400),
    [sym__comparison_operator] = ACTIONS(13400),
    [sym__pipe_right_operator] = ACTIONS(13400),
    [sym__pipe_left_operator] = ACTIONS(13400),
    [sym__ellipsis_operator] = ACTIONS(13400),
    [sym__plus_operator] = ACTIONS(13400),
    [sym__times_operator] = ACTIONS(13400),
    [sym__rational_operator] = ACTIONS(13400),
    [sym__bitshift_operator] = ACTIONS(13400),
    [sym__power_operator] = ACTIONS(13400),
    [sym__tilde_operator] = ACTIONS(13400),
    [sym__type_order_operator] = ACTIONS(13400),
    [sym__unary_operator] = ACTIONS(13400),
    [sym__unary_plus_operator] = ACTIONS(13400),
    [aux_sym__terminator_token1] = ACTIONS(13400),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13402),
    [sym__command_start] = ACTIONS(13402),
  },
  [8483] = {
    [sym__word_identifier] = ACTIONS(13407),
    [anon_sym_EQ] = ACTIONS(13407),
    [anon_sym_COMMA] = ACTIONS(13407),
    [anon_sym_COLON] = ACTIONS(13407),
    [anon_sym_begin] = ACTIONS(13407),
    [anon_sym_module] = ACTIONS(13407),
    [anon_sym_baremodule] = ACTIONS(13407),
    [anon_sym_end] = ACTIONS(13407),
    [anon_sym_abstract] = ACTIONS(13407),
    [anon_sym_primitive] = ACTIONS(13407),
    [anon_sym_mutable] = ACTIONS(13407),
    [anon_sym_struct] = ACTIONS(13407),
    [anon_sym_function] = ACTIONS(13407),
    [anon_sym_macro] = ACTIONS(13407),
    [anon_sym_where] = ACTIONS(13407),
    [anon_sym_quote] = ACTIONS(13407),
    [anon_sym_let] = ACTIONS(13407),
    [anon_sym_if] = ACTIONS(13407),
    [anon_sym_try] = ACTIONS(13407),
    [anon_sym_catch] = ACTIONS(13407),
    [anon_sym_for] = ACTIONS(13407),
    [anon_sym_while] = ACTIONS(13407),
    [sym_break_statement] = ACTIONS(13407),
    [sym_continue_statement] = ACTIONS(13407),
    [anon_sym_return] = ACTIONS(13407),
    [anon_sym_const] = ACTIONS(13407),
    [anon_sym_global] = ACTIONS(13407),
    [anon_sym_local] = ACTIONS(13407),
    [anon_sym_LPAREN] = ACTIONS(13407),
    [anon_sym_COLON2] = ACTIONS(13407),
    [anon_sym_export] = ACTIONS(13407),
    [anon_sym_import] = ACTIONS(13407),
    [anon_sym_using] = ACTIONS(13407),
    [anon_sym_LBRACK] = ACTIONS(13407),
    [anon_sym_LF] = ACTIONS(13409),
    [anon_sym_in] = ACTIONS(13407),
    [anon_sym_LBRACE] = ACTIONS(13407),
    [anon_sym_DOLLAR] = ACTIONS(13407),
    [anon_sym_COLON_COLON] = ACTIONS(13407),
    [anon_sym_isa] = ACTIONS(13407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13407),
    [anon_sym_QMARK] = ACTIONS(13407),
    [anon_sym_AT] = ACTIONS(13407),
    [anon_sym_true] = ACTIONS(13407),
    [anon_sym_false] = ACTIONS(13407),
    [aux_sym_integer_literal_token1] = ACTIONS(13407),
    [aux_sym_integer_literal_token2] = ACTIONS(13407),
    [aux_sym_integer_literal_token3] = ACTIONS(13407),
    [aux_sym_integer_literal_token4] = ACTIONS(13407),
    [aux_sym_float_literal_token1] = ACTIONS(13407),
    [aux_sym_float_literal_token3] = ACTIONS(13407),
    [aux_sym_float_literal_token4] = ACTIONS(13407),
    [sym_character_literal] = ACTIONS(13407),
    [sym__pair_operator] = ACTIONS(13407),
    [sym__arrow_operator] = ACTIONS(13407),
    [sym__lazy_or_operator] = ACTIONS(13407),
    [sym__lazy_and_operator] = ACTIONS(13407),
    [sym__comparison_operator] = ACTIONS(13407),
    [sym__pipe_right_operator] = ACTIONS(13407),
    [sym__pipe_left_operator] = ACTIONS(13407),
    [sym__ellipsis_operator] = ACTIONS(13407),
    [sym__plus_operator] = ACTIONS(13407),
    [sym__times_operator] = ACTIONS(13407),
    [sym__rational_operator] = ACTIONS(13407),
    [sym__bitshift_operator] = ACTIONS(13407),
    [sym__power_operator] = ACTIONS(13407),
    [sym__tilde_operator] = ACTIONS(13407),
    [sym__type_order_operator] = ACTIONS(13407),
    [sym__unary_operator] = ACTIONS(13407),
    [sym__unary_plus_operator] = ACTIONS(13407),
    [aux_sym__terminator_token1] = ACTIONS(13407),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13409),
    [sym__command_start] = ACTIONS(13409),
  },
  [8484] = {
    [sym__word_identifier] = ACTIONS(13554),
    [anon_sym_EQ] = ACTIONS(13554),
    [anon_sym_COMMA] = ACTIONS(13554),
    [anon_sym_COLON] = ACTIONS(13554),
    [anon_sym_begin] = ACTIONS(13554),
    [anon_sym_module] = ACTIONS(13554),
    [anon_sym_baremodule] = ACTIONS(13554),
    [anon_sym_abstract] = ACTIONS(13554),
    [anon_sym_primitive] = ACTIONS(13554),
    [anon_sym_mutable] = ACTIONS(13554),
    [anon_sym_struct] = ACTIONS(13554),
    [anon_sym_function] = ACTIONS(13554),
    [anon_sym_macro] = ACTIONS(13554),
    [anon_sym_where] = ACTIONS(13554),
    [anon_sym_quote] = ACTIONS(13554),
    [anon_sym_let] = ACTIONS(13554),
    [anon_sym_if] = ACTIONS(13554),
    [anon_sym_try] = ACTIONS(13554),
    [anon_sym_catch] = ACTIONS(13554),
    [anon_sym_finally] = ACTIONS(13554),
    [anon_sym_for] = ACTIONS(13554),
    [anon_sym_while] = ACTIONS(13554),
    [sym_break_statement] = ACTIONS(13554),
    [sym_continue_statement] = ACTIONS(13554),
    [anon_sym_return] = ACTIONS(13554),
    [anon_sym_const] = ACTIONS(13554),
    [anon_sym_global] = ACTIONS(13554),
    [anon_sym_local] = ACTIONS(13554),
    [anon_sym_LPAREN] = ACTIONS(13554),
    [anon_sym_COLON2] = ACTIONS(13554),
    [anon_sym_export] = ACTIONS(13554),
    [anon_sym_import] = ACTIONS(13554),
    [anon_sym_using] = ACTIONS(13554),
    [anon_sym_LBRACK] = ACTIONS(13554),
    [anon_sym_LF] = ACTIONS(13556),
    [anon_sym_in] = ACTIONS(13554),
    [anon_sym_LBRACE] = ACTIONS(13554),
    [anon_sym_DOLLAR] = ACTIONS(13554),
    [anon_sym_COLON_COLON] = ACTIONS(13554),
    [anon_sym_isa] = ACTIONS(13554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13554),
    [anon_sym_QMARK] = ACTIONS(13554),
    [anon_sym_AT] = ACTIONS(13554),
    [anon_sym_true] = ACTIONS(13554),
    [anon_sym_false] = ACTIONS(13554),
    [aux_sym_integer_literal_token1] = ACTIONS(13554),
    [aux_sym_integer_literal_token2] = ACTIONS(13554),
    [aux_sym_integer_literal_token3] = ACTIONS(13554),
    [aux_sym_integer_literal_token4] = ACTIONS(13554),
    [aux_sym_float_literal_token1] = ACTIONS(13554),
    [aux_sym_float_literal_token3] = ACTIONS(13554),
    [aux_sym_float_literal_token4] = ACTIONS(13554),
    [sym_character_literal] = ACTIONS(13554),
    [sym__pair_operator] = ACTIONS(13554),
    [sym__arrow_operator] = ACTIONS(13554),
    [sym__lazy_or_operator] = ACTIONS(13554),
    [sym__lazy_and_operator] = ACTIONS(13554),
    [sym__comparison_operator] = ACTIONS(13554),
    [sym__pipe_right_operator] = ACTIONS(13554),
    [sym__pipe_left_operator] = ACTIONS(13554),
    [sym__ellipsis_operator] = ACTIONS(13554),
    [sym__plus_operator] = ACTIONS(13554),
    [sym__times_operator] = ACTIONS(13554),
    [sym__rational_operator] = ACTIONS(13554),
    [sym__bitshift_operator] = ACTIONS(13554),
    [sym__power_operator] = ACTIONS(13554),
    [sym__tilde_operator] = ACTIONS(13554),
    [sym__type_order_operator] = ACTIONS(13554),
    [sym__unary_operator] = ACTIONS(13554),
    [sym__unary_plus_operator] = ACTIONS(13554),
    [aux_sym__terminator_token1] = ACTIONS(13554),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13556),
    [sym__command_start] = ACTIONS(13556),
  },
  [8485] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(12462),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_catch] = ACTIONS(13249),
    [anon_sym_finally] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8486] = {
    [sym__word_identifier] = ACTIONS(13558),
    [anon_sym_EQ] = ACTIONS(13558),
    [anon_sym_COMMA] = ACTIONS(13558),
    [anon_sym_COLON] = ACTIONS(13558),
    [anon_sym_begin] = ACTIONS(13558),
    [anon_sym_module] = ACTIONS(13558),
    [anon_sym_baremodule] = ACTIONS(13558),
    [anon_sym_abstract] = ACTIONS(13558),
    [anon_sym_primitive] = ACTIONS(13558),
    [anon_sym_mutable] = ACTIONS(13558),
    [anon_sym_struct] = ACTIONS(13558),
    [anon_sym_function] = ACTIONS(13558),
    [anon_sym_macro] = ACTIONS(13558),
    [anon_sym_where] = ACTIONS(13558),
    [anon_sym_quote] = ACTIONS(13558),
    [anon_sym_let] = ACTIONS(13558),
    [anon_sym_if] = ACTIONS(13558),
    [anon_sym_try] = ACTIONS(13558),
    [anon_sym_catch] = ACTIONS(13558),
    [anon_sym_finally] = ACTIONS(13558),
    [anon_sym_for] = ACTIONS(13558),
    [anon_sym_while] = ACTIONS(13558),
    [sym_break_statement] = ACTIONS(13558),
    [sym_continue_statement] = ACTIONS(13558),
    [anon_sym_return] = ACTIONS(13558),
    [anon_sym_const] = ACTIONS(13558),
    [anon_sym_global] = ACTIONS(13558),
    [anon_sym_local] = ACTIONS(13558),
    [anon_sym_LPAREN] = ACTIONS(13558),
    [anon_sym_COLON2] = ACTIONS(13558),
    [anon_sym_export] = ACTIONS(13558),
    [anon_sym_import] = ACTIONS(13558),
    [anon_sym_using] = ACTIONS(13558),
    [anon_sym_LBRACK] = ACTIONS(13558),
    [anon_sym_LF] = ACTIONS(13560),
    [anon_sym_in] = ACTIONS(13558),
    [anon_sym_LBRACE] = ACTIONS(13558),
    [anon_sym_DOLLAR] = ACTIONS(13558),
    [anon_sym_COLON_COLON] = ACTIONS(13558),
    [anon_sym_isa] = ACTIONS(13558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13558),
    [anon_sym_QMARK] = ACTIONS(13558),
    [anon_sym_AT] = ACTIONS(13558),
    [anon_sym_true] = ACTIONS(13558),
    [anon_sym_false] = ACTIONS(13558),
    [aux_sym_integer_literal_token1] = ACTIONS(13558),
    [aux_sym_integer_literal_token2] = ACTIONS(13558),
    [aux_sym_integer_literal_token3] = ACTIONS(13558),
    [aux_sym_integer_literal_token4] = ACTIONS(13558),
    [aux_sym_float_literal_token1] = ACTIONS(13558),
    [aux_sym_float_literal_token3] = ACTIONS(13558),
    [aux_sym_float_literal_token4] = ACTIONS(13558),
    [sym_character_literal] = ACTIONS(13558),
    [sym__pair_operator] = ACTIONS(13558),
    [sym__arrow_operator] = ACTIONS(13558),
    [sym__lazy_or_operator] = ACTIONS(13558),
    [sym__lazy_and_operator] = ACTIONS(13558),
    [sym__comparison_operator] = ACTIONS(13558),
    [sym__pipe_right_operator] = ACTIONS(13558),
    [sym__pipe_left_operator] = ACTIONS(13558),
    [sym__ellipsis_operator] = ACTIONS(13558),
    [sym__plus_operator] = ACTIONS(13558),
    [sym__times_operator] = ACTIONS(13558),
    [sym__rational_operator] = ACTIONS(13558),
    [sym__bitshift_operator] = ACTIONS(13558),
    [sym__power_operator] = ACTIONS(13558),
    [sym__tilde_operator] = ACTIONS(13558),
    [sym__type_order_operator] = ACTIONS(13558),
    [sym__unary_operator] = ACTIONS(13558),
    [sym__unary_plus_operator] = ACTIONS(13558),
    [aux_sym__terminator_token1] = ACTIONS(13558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13560),
    [sym__command_start] = ACTIONS(13560),
  },
  [8487] = {
    [sym__word_identifier] = ACTIONS(13562),
    [anon_sym_EQ] = ACTIONS(13562),
    [anon_sym_COMMA] = ACTIONS(13562),
    [anon_sym_COLON] = ACTIONS(13562),
    [anon_sym_begin] = ACTIONS(13562),
    [anon_sym_module] = ACTIONS(13562),
    [anon_sym_baremodule] = ACTIONS(13562),
    [anon_sym_abstract] = ACTIONS(13562),
    [anon_sym_primitive] = ACTIONS(13562),
    [anon_sym_mutable] = ACTIONS(13562),
    [anon_sym_struct] = ACTIONS(13562),
    [anon_sym_function] = ACTIONS(13562),
    [anon_sym_macro] = ACTIONS(13562),
    [anon_sym_where] = ACTIONS(13562),
    [anon_sym_quote] = ACTIONS(13562),
    [anon_sym_let] = ACTIONS(13562),
    [anon_sym_if] = ACTIONS(13562),
    [anon_sym_try] = ACTIONS(13562),
    [anon_sym_catch] = ACTIONS(13562),
    [anon_sym_finally] = ACTIONS(13562),
    [anon_sym_for] = ACTIONS(13562),
    [anon_sym_while] = ACTIONS(13562),
    [sym_break_statement] = ACTIONS(13562),
    [sym_continue_statement] = ACTIONS(13562),
    [anon_sym_return] = ACTIONS(13562),
    [anon_sym_const] = ACTIONS(13562),
    [anon_sym_global] = ACTIONS(13562),
    [anon_sym_local] = ACTIONS(13562),
    [anon_sym_LPAREN] = ACTIONS(13562),
    [anon_sym_COLON2] = ACTIONS(13562),
    [anon_sym_export] = ACTIONS(13562),
    [anon_sym_import] = ACTIONS(13562),
    [anon_sym_using] = ACTIONS(13562),
    [anon_sym_LBRACK] = ACTIONS(13562),
    [anon_sym_LF] = ACTIONS(13564),
    [anon_sym_in] = ACTIONS(13562),
    [anon_sym_LBRACE] = ACTIONS(13562),
    [anon_sym_DOLLAR] = ACTIONS(13562),
    [anon_sym_COLON_COLON] = ACTIONS(13562),
    [anon_sym_isa] = ACTIONS(13562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13562),
    [anon_sym_QMARK] = ACTIONS(13562),
    [anon_sym_AT] = ACTIONS(13562),
    [anon_sym_true] = ACTIONS(13562),
    [anon_sym_false] = ACTIONS(13562),
    [aux_sym_integer_literal_token1] = ACTIONS(13562),
    [aux_sym_integer_literal_token2] = ACTIONS(13562),
    [aux_sym_integer_literal_token3] = ACTIONS(13562),
    [aux_sym_integer_literal_token4] = ACTIONS(13562),
    [aux_sym_float_literal_token1] = ACTIONS(13562),
    [aux_sym_float_literal_token3] = ACTIONS(13562),
    [aux_sym_float_literal_token4] = ACTIONS(13562),
    [sym_character_literal] = ACTIONS(13562),
    [sym__pair_operator] = ACTIONS(13562),
    [sym__arrow_operator] = ACTIONS(13562),
    [sym__lazy_or_operator] = ACTIONS(13562),
    [sym__lazy_and_operator] = ACTIONS(13562),
    [sym__comparison_operator] = ACTIONS(13562),
    [sym__pipe_right_operator] = ACTIONS(13562),
    [sym__pipe_left_operator] = ACTIONS(13562),
    [sym__ellipsis_operator] = ACTIONS(13562),
    [sym__plus_operator] = ACTIONS(13562),
    [sym__times_operator] = ACTIONS(13562),
    [sym__rational_operator] = ACTIONS(13562),
    [sym__bitshift_operator] = ACTIONS(13562),
    [sym__power_operator] = ACTIONS(13562),
    [sym__tilde_operator] = ACTIONS(13562),
    [sym__type_order_operator] = ACTIONS(13562),
    [sym__unary_operator] = ACTIONS(13562),
    [sym__unary_plus_operator] = ACTIONS(13562),
    [aux_sym__terminator_token1] = ACTIONS(13562),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13564),
    [sym__command_start] = ACTIONS(13564),
  },
  [8488] = {
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13094),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_catch] = ACTIONS(13094),
    [anon_sym_finally] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13094),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13094),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13094),
    [anon_sym_isa] = ACTIONS(13094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13094),
    [anon_sym_QMARK] = ACTIONS(13094),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13094),
    [sym__lazy_or_operator] = ACTIONS(13094),
    [sym__lazy_and_operator] = ACTIONS(13094),
    [sym__comparison_operator] = ACTIONS(13094),
    [sym__pipe_right_operator] = ACTIONS(13094),
    [sym__pipe_left_operator] = ACTIONS(13094),
    [sym__ellipsis_operator] = ACTIONS(13094),
    [sym__plus_operator] = ACTIONS(13094),
    [sym__times_operator] = ACTIONS(13094),
    [sym__rational_operator] = ACTIONS(13094),
    [sym__bitshift_operator] = ACTIONS(13094),
    [sym__power_operator] = ACTIONS(13094),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13094),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13094),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8489] = {
    [sym__word_identifier] = ACTIONS(13566),
    [anon_sym_EQ] = ACTIONS(13566),
    [anon_sym_COMMA] = ACTIONS(13566),
    [anon_sym_COLON] = ACTIONS(13566),
    [anon_sym_begin] = ACTIONS(13566),
    [anon_sym_module] = ACTIONS(13566),
    [anon_sym_baremodule] = ACTIONS(13566),
    [anon_sym_abstract] = ACTIONS(13566),
    [anon_sym_primitive] = ACTIONS(13566),
    [anon_sym_mutable] = ACTIONS(13566),
    [anon_sym_struct] = ACTIONS(13566),
    [anon_sym_function] = ACTIONS(13566),
    [anon_sym_macro] = ACTIONS(13566),
    [anon_sym_where] = ACTIONS(13566),
    [anon_sym_quote] = ACTIONS(13566),
    [anon_sym_let] = ACTIONS(13566),
    [anon_sym_if] = ACTIONS(13566),
    [anon_sym_try] = ACTIONS(13566),
    [anon_sym_catch] = ACTIONS(13566),
    [anon_sym_finally] = ACTIONS(13566),
    [anon_sym_for] = ACTIONS(13566),
    [anon_sym_while] = ACTIONS(13566),
    [sym_break_statement] = ACTIONS(13566),
    [sym_continue_statement] = ACTIONS(13566),
    [anon_sym_return] = ACTIONS(13566),
    [anon_sym_const] = ACTIONS(13566),
    [anon_sym_global] = ACTIONS(13566),
    [anon_sym_local] = ACTIONS(13566),
    [anon_sym_LPAREN] = ACTIONS(13566),
    [anon_sym_COLON2] = ACTIONS(13566),
    [anon_sym_export] = ACTIONS(13566),
    [anon_sym_import] = ACTIONS(13566),
    [anon_sym_using] = ACTIONS(13566),
    [anon_sym_LBRACK] = ACTIONS(13566),
    [anon_sym_LF] = ACTIONS(13568),
    [anon_sym_in] = ACTIONS(13566),
    [anon_sym_LBRACE] = ACTIONS(13566),
    [anon_sym_DOLLAR] = ACTIONS(13566),
    [anon_sym_COLON_COLON] = ACTIONS(13566),
    [anon_sym_isa] = ACTIONS(13566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13566),
    [anon_sym_QMARK] = ACTIONS(13566),
    [anon_sym_AT] = ACTIONS(13566),
    [anon_sym_true] = ACTIONS(13566),
    [anon_sym_false] = ACTIONS(13566),
    [aux_sym_integer_literal_token1] = ACTIONS(13566),
    [aux_sym_integer_literal_token2] = ACTIONS(13566),
    [aux_sym_integer_literal_token3] = ACTIONS(13566),
    [aux_sym_integer_literal_token4] = ACTIONS(13566),
    [aux_sym_float_literal_token1] = ACTIONS(13566),
    [aux_sym_float_literal_token3] = ACTIONS(13566),
    [aux_sym_float_literal_token4] = ACTIONS(13566),
    [sym_character_literal] = ACTIONS(13566),
    [sym__pair_operator] = ACTIONS(13566),
    [sym__arrow_operator] = ACTIONS(13566),
    [sym__lazy_or_operator] = ACTIONS(13566),
    [sym__lazy_and_operator] = ACTIONS(13566),
    [sym__comparison_operator] = ACTIONS(13566),
    [sym__pipe_right_operator] = ACTIONS(13566),
    [sym__pipe_left_operator] = ACTIONS(13566),
    [sym__ellipsis_operator] = ACTIONS(13566),
    [sym__plus_operator] = ACTIONS(13566),
    [sym__times_operator] = ACTIONS(13566),
    [sym__rational_operator] = ACTIONS(13566),
    [sym__bitshift_operator] = ACTIONS(13566),
    [sym__power_operator] = ACTIONS(13566),
    [sym__tilde_operator] = ACTIONS(13566),
    [sym__type_order_operator] = ACTIONS(13566),
    [sym__unary_operator] = ACTIONS(13566),
    [sym__unary_plus_operator] = ACTIONS(13566),
    [aux_sym__terminator_token1] = ACTIONS(13566),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13568),
    [sym__command_start] = ACTIONS(13568),
  },
  [8490] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_EQ] = ACTIONS(12094),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_RPAREN] = ACTIONS(12094),
    [anon_sym_COLON2] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12094),
    [anon_sym_SEMI] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_isa] = ACTIONS(12094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12094),
    [anon_sym_QMARK] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(13261),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__lazy_or_operator] = ACTIONS(12094),
    [sym__lazy_and_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [8491] = {
    [sym__word_identifier] = ACTIONS(13570),
    [anon_sym_EQ] = ACTIONS(13570),
    [anon_sym_COMMA] = ACTIONS(13570),
    [anon_sym_COLON] = ACTIONS(13570),
    [anon_sym_begin] = ACTIONS(13570),
    [anon_sym_module] = ACTIONS(13570),
    [anon_sym_baremodule] = ACTIONS(13570),
    [anon_sym_abstract] = ACTIONS(13570),
    [anon_sym_primitive] = ACTIONS(13570),
    [anon_sym_mutable] = ACTIONS(13570),
    [anon_sym_struct] = ACTIONS(13570),
    [anon_sym_function] = ACTIONS(13570),
    [anon_sym_macro] = ACTIONS(13570),
    [anon_sym_where] = ACTIONS(13570),
    [anon_sym_quote] = ACTIONS(13570),
    [anon_sym_let] = ACTIONS(13570),
    [anon_sym_if] = ACTIONS(13570),
    [anon_sym_try] = ACTIONS(13570),
    [anon_sym_catch] = ACTIONS(13570),
    [anon_sym_finally] = ACTIONS(13570),
    [anon_sym_for] = ACTIONS(13570),
    [anon_sym_while] = ACTIONS(13570),
    [sym_break_statement] = ACTIONS(13570),
    [sym_continue_statement] = ACTIONS(13570),
    [anon_sym_return] = ACTIONS(13570),
    [anon_sym_const] = ACTIONS(13570),
    [anon_sym_global] = ACTIONS(13570),
    [anon_sym_local] = ACTIONS(13570),
    [anon_sym_LPAREN] = ACTIONS(13570),
    [anon_sym_COLON2] = ACTIONS(13570),
    [anon_sym_export] = ACTIONS(13570),
    [anon_sym_import] = ACTIONS(13570),
    [anon_sym_using] = ACTIONS(13570),
    [anon_sym_LBRACK] = ACTIONS(13570),
    [anon_sym_LF] = ACTIONS(13572),
    [anon_sym_in] = ACTIONS(13570),
    [anon_sym_LBRACE] = ACTIONS(13570),
    [anon_sym_DOLLAR] = ACTIONS(13570),
    [anon_sym_COLON_COLON] = ACTIONS(13570),
    [anon_sym_isa] = ACTIONS(13570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13570),
    [anon_sym_QMARK] = ACTIONS(13570),
    [anon_sym_AT] = ACTIONS(13570),
    [anon_sym_true] = ACTIONS(13570),
    [anon_sym_false] = ACTIONS(13570),
    [aux_sym_integer_literal_token1] = ACTIONS(13570),
    [aux_sym_integer_literal_token2] = ACTIONS(13570),
    [aux_sym_integer_literal_token3] = ACTIONS(13570),
    [aux_sym_integer_literal_token4] = ACTIONS(13570),
    [aux_sym_float_literal_token1] = ACTIONS(13570),
    [aux_sym_float_literal_token3] = ACTIONS(13570),
    [aux_sym_float_literal_token4] = ACTIONS(13570),
    [sym_character_literal] = ACTIONS(13570),
    [sym__pair_operator] = ACTIONS(13570),
    [sym__arrow_operator] = ACTIONS(13570),
    [sym__lazy_or_operator] = ACTIONS(13570),
    [sym__lazy_and_operator] = ACTIONS(13570),
    [sym__comparison_operator] = ACTIONS(13570),
    [sym__pipe_right_operator] = ACTIONS(13570),
    [sym__pipe_left_operator] = ACTIONS(13570),
    [sym__ellipsis_operator] = ACTIONS(13570),
    [sym__plus_operator] = ACTIONS(13570),
    [sym__times_operator] = ACTIONS(13570),
    [sym__rational_operator] = ACTIONS(13570),
    [sym__bitshift_operator] = ACTIONS(13570),
    [sym__power_operator] = ACTIONS(13570),
    [sym__tilde_operator] = ACTIONS(13570),
    [sym__type_order_operator] = ACTIONS(13570),
    [sym__unary_operator] = ACTIONS(13570),
    [sym__unary_plus_operator] = ACTIONS(13570),
    [aux_sym__terminator_token1] = ACTIONS(13570),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13572),
    [sym__command_start] = ACTIONS(13572),
  },
  [8492] = {
    [sym__word_identifier] = ACTIONS(13574),
    [anon_sym_EQ] = ACTIONS(13574),
    [anon_sym_COMMA] = ACTIONS(13574),
    [anon_sym_COLON] = ACTIONS(13574),
    [anon_sym_begin] = ACTIONS(13574),
    [anon_sym_module] = ACTIONS(13574),
    [anon_sym_baremodule] = ACTIONS(13574),
    [anon_sym_abstract] = ACTIONS(13574),
    [anon_sym_primitive] = ACTIONS(13574),
    [anon_sym_mutable] = ACTIONS(13574),
    [anon_sym_struct] = ACTIONS(13574),
    [anon_sym_function] = ACTIONS(13574),
    [anon_sym_macro] = ACTIONS(13574),
    [anon_sym_where] = ACTIONS(13574),
    [anon_sym_quote] = ACTIONS(13574),
    [anon_sym_let] = ACTIONS(13574),
    [anon_sym_if] = ACTIONS(13574),
    [anon_sym_try] = ACTIONS(13574),
    [anon_sym_catch] = ACTIONS(13574),
    [anon_sym_finally] = ACTIONS(13574),
    [anon_sym_for] = ACTIONS(13574),
    [anon_sym_while] = ACTIONS(13574),
    [sym_break_statement] = ACTIONS(13574),
    [sym_continue_statement] = ACTIONS(13574),
    [anon_sym_return] = ACTIONS(13574),
    [anon_sym_const] = ACTIONS(13574),
    [anon_sym_global] = ACTIONS(13574),
    [anon_sym_local] = ACTIONS(13574),
    [anon_sym_LPAREN] = ACTIONS(13574),
    [anon_sym_COLON2] = ACTIONS(13574),
    [anon_sym_export] = ACTIONS(13574),
    [anon_sym_import] = ACTIONS(13574),
    [anon_sym_using] = ACTIONS(13574),
    [anon_sym_LBRACK] = ACTIONS(13574),
    [anon_sym_LF] = ACTIONS(13576),
    [anon_sym_in] = ACTIONS(13574),
    [anon_sym_LBRACE] = ACTIONS(13574),
    [anon_sym_DOLLAR] = ACTIONS(13574),
    [anon_sym_COLON_COLON] = ACTIONS(13574),
    [anon_sym_isa] = ACTIONS(13574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13574),
    [anon_sym_QMARK] = ACTIONS(13574),
    [anon_sym_AT] = ACTIONS(13574),
    [anon_sym_true] = ACTIONS(13574),
    [anon_sym_false] = ACTIONS(13574),
    [aux_sym_integer_literal_token1] = ACTIONS(13574),
    [aux_sym_integer_literal_token2] = ACTIONS(13574),
    [aux_sym_integer_literal_token3] = ACTIONS(13574),
    [aux_sym_integer_literal_token4] = ACTIONS(13574),
    [aux_sym_float_literal_token1] = ACTIONS(13574),
    [aux_sym_float_literal_token3] = ACTIONS(13574),
    [aux_sym_float_literal_token4] = ACTIONS(13574),
    [sym_character_literal] = ACTIONS(13574),
    [sym__pair_operator] = ACTIONS(13574),
    [sym__arrow_operator] = ACTIONS(13574),
    [sym__lazy_or_operator] = ACTIONS(13574),
    [sym__lazy_and_operator] = ACTIONS(13574),
    [sym__comparison_operator] = ACTIONS(13574),
    [sym__pipe_right_operator] = ACTIONS(13574),
    [sym__pipe_left_operator] = ACTIONS(13574),
    [sym__ellipsis_operator] = ACTIONS(13574),
    [sym__plus_operator] = ACTIONS(13574),
    [sym__times_operator] = ACTIONS(13574),
    [sym__rational_operator] = ACTIONS(13574),
    [sym__bitshift_operator] = ACTIONS(13574),
    [sym__power_operator] = ACTIONS(13574),
    [sym__tilde_operator] = ACTIONS(13574),
    [sym__type_order_operator] = ACTIONS(13574),
    [sym__unary_operator] = ACTIONS(13574),
    [sym__unary_plus_operator] = ACTIONS(13574),
    [aux_sym__terminator_token1] = ACTIONS(13574),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13576),
    [sym__command_start] = ACTIONS(13576),
  },
  [8493] = {
    [sym__word_identifier] = ACTIONS(13578),
    [anon_sym_EQ] = ACTIONS(13578),
    [anon_sym_COMMA] = ACTIONS(13578),
    [anon_sym_COLON] = ACTIONS(13578),
    [anon_sym_begin] = ACTIONS(13578),
    [anon_sym_module] = ACTIONS(13578),
    [anon_sym_baremodule] = ACTIONS(13578),
    [anon_sym_abstract] = ACTIONS(13578),
    [anon_sym_primitive] = ACTIONS(13578),
    [anon_sym_mutable] = ACTIONS(13578),
    [anon_sym_struct] = ACTIONS(13578),
    [anon_sym_function] = ACTIONS(13578),
    [anon_sym_macro] = ACTIONS(13578),
    [anon_sym_where] = ACTIONS(13578),
    [anon_sym_quote] = ACTIONS(13578),
    [anon_sym_let] = ACTIONS(13578),
    [anon_sym_if] = ACTIONS(13578),
    [anon_sym_try] = ACTIONS(13578),
    [anon_sym_catch] = ACTIONS(13578),
    [anon_sym_finally] = ACTIONS(13578),
    [anon_sym_for] = ACTIONS(13578),
    [anon_sym_while] = ACTIONS(13578),
    [sym_break_statement] = ACTIONS(13578),
    [sym_continue_statement] = ACTIONS(13578),
    [anon_sym_return] = ACTIONS(13578),
    [anon_sym_const] = ACTIONS(13578),
    [anon_sym_global] = ACTIONS(13578),
    [anon_sym_local] = ACTIONS(13578),
    [anon_sym_LPAREN] = ACTIONS(13578),
    [anon_sym_COLON2] = ACTIONS(13578),
    [anon_sym_export] = ACTIONS(13578),
    [anon_sym_import] = ACTIONS(13578),
    [anon_sym_using] = ACTIONS(13578),
    [anon_sym_LBRACK] = ACTIONS(13578),
    [anon_sym_LF] = ACTIONS(13580),
    [anon_sym_in] = ACTIONS(13578),
    [anon_sym_LBRACE] = ACTIONS(13578),
    [anon_sym_DOLLAR] = ACTIONS(13578),
    [anon_sym_COLON_COLON] = ACTIONS(13578),
    [anon_sym_isa] = ACTIONS(13578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13578),
    [anon_sym_QMARK] = ACTIONS(13578),
    [anon_sym_AT] = ACTIONS(13578),
    [anon_sym_true] = ACTIONS(13578),
    [anon_sym_false] = ACTIONS(13578),
    [aux_sym_integer_literal_token1] = ACTIONS(13578),
    [aux_sym_integer_literal_token2] = ACTIONS(13578),
    [aux_sym_integer_literal_token3] = ACTIONS(13578),
    [aux_sym_integer_literal_token4] = ACTIONS(13578),
    [aux_sym_float_literal_token1] = ACTIONS(13578),
    [aux_sym_float_literal_token3] = ACTIONS(13578),
    [aux_sym_float_literal_token4] = ACTIONS(13578),
    [sym_character_literal] = ACTIONS(13578),
    [sym__pair_operator] = ACTIONS(13578),
    [sym__arrow_operator] = ACTIONS(13578),
    [sym__lazy_or_operator] = ACTIONS(13578),
    [sym__lazy_and_operator] = ACTIONS(13578),
    [sym__comparison_operator] = ACTIONS(13578),
    [sym__pipe_right_operator] = ACTIONS(13578),
    [sym__pipe_left_operator] = ACTIONS(13578),
    [sym__ellipsis_operator] = ACTIONS(13578),
    [sym__plus_operator] = ACTIONS(13578),
    [sym__times_operator] = ACTIONS(13578),
    [sym__rational_operator] = ACTIONS(13578),
    [sym__bitshift_operator] = ACTIONS(13578),
    [sym__power_operator] = ACTIONS(13578),
    [sym__tilde_operator] = ACTIONS(13578),
    [sym__type_order_operator] = ACTIONS(13578),
    [sym__unary_operator] = ACTIONS(13578),
    [sym__unary_plus_operator] = ACTIONS(13578),
    [aux_sym__terminator_token1] = ACTIONS(13578),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13580),
    [sym__command_start] = ACTIONS(13580),
  },
  [8494] = {
    [sym__word_identifier] = ACTIONS(13582),
    [anon_sym_EQ] = ACTIONS(13582),
    [anon_sym_COMMA] = ACTIONS(13582),
    [anon_sym_COLON] = ACTIONS(13582),
    [anon_sym_begin] = ACTIONS(13582),
    [anon_sym_module] = ACTIONS(13582),
    [anon_sym_baremodule] = ACTIONS(13582),
    [anon_sym_abstract] = ACTIONS(13582),
    [anon_sym_primitive] = ACTIONS(13582),
    [anon_sym_mutable] = ACTIONS(13582),
    [anon_sym_struct] = ACTIONS(13582),
    [anon_sym_function] = ACTIONS(13582),
    [anon_sym_macro] = ACTIONS(13582),
    [anon_sym_where] = ACTIONS(13582),
    [anon_sym_quote] = ACTIONS(13582),
    [anon_sym_let] = ACTIONS(13582),
    [anon_sym_if] = ACTIONS(13582),
    [anon_sym_try] = ACTIONS(13582),
    [anon_sym_catch] = ACTIONS(13582),
    [anon_sym_finally] = ACTIONS(13582),
    [anon_sym_for] = ACTIONS(13582),
    [anon_sym_while] = ACTIONS(13582),
    [sym_break_statement] = ACTIONS(13582),
    [sym_continue_statement] = ACTIONS(13582),
    [anon_sym_return] = ACTIONS(13582),
    [anon_sym_const] = ACTIONS(13582),
    [anon_sym_global] = ACTIONS(13582),
    [anon_sym_local] = ACTIONS(13582),
    [anon_sym_LPAREN] = ACTIONS(13582),
    [anon_sym_COLON2] = ACTIONS(13582),
    [anon_sym_export] = ACTIONS(13582),
    [anon_sym_import] = ACTIONS(13582),
    [anon_sym_using] = ACTIONS(13582),
    [anon_sym_LBRACK] = ACTIONS(13582),
    [anon_sym_LF] = ACTIONS(13584),
    [anon_sym_in] = ACTIONS(13582),
    [anon_sym_LBRACE] = ACTIONS(13582),
    [anon_sym_DOLLAR] = ACTIONS(13582),
    [anon_sym_COLON_COLON] = ACTIONS(13582),
    [anon_sym_isa] = ACTIONS(13582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13582),
    [anon_sym_QMARK] = ACTIONS(13582),
    [anon_sym_AT] = ACTIONS(13582),
    [anon_sym_true] = ACTIONS(13582),
    [anon_sym_false] = ACTIONS(13582),
    [aux_sym_integer_literal_token1] = ACTIONS(13582),
    [aux_sym_integer_literal_token2] = ACTIONS(13582),
    [aux_sym_integer_literal_token3] = ACTIONS(13582),
    [aux_sym_integer_literal_token4] = ACTIONS(13582),
    [aux_sym_float_literal_token1] = ACTIONS(13582),
    [aux_sym_float_literal_token3] = ACTIONS(13582),
    [aux_sym_float_literal_token4] = ACTIONS(13582),
    [sym_character_literal] = ACTIONS(13582),
    [sym__pair_operator] = ACTIONS(13582),
    [sym__arrow_operator] = ACTIONS(13582),
    [sym__lazy_or_operator] = ACTIONS(13582),
    [sym__lazy_and_operator] = ACTIONS(13582),
    [sym__comparison_operator] = ACTIONS(13582),
    [sym__pipe_right_operator] = ACTIONS(13582),
    [sym__pipe_left_operator] = ACTIONS(13582),
    [sym__ellipsis_operator] = ACTIONS(13582),
    [sym__plus_operator] = ACTIONS(13582),
    [sym__times_operator] = ACTIONS(13582),
    [sym__rational_operator] = ACTIONS(13582),
    [sym__bitshift_operator] = ACTIONS(13582),
    [sym__power_operator] = ACTIONS(13582),
    [sym__tilde_operator] = ACTIONS(13582),
    [sym__type_order_operator] = ACTIONS(13582),
    [sym__unary_operator] = ACTIONS(13582),
    [sym__unary_plus_operator] = ACTIONS(13582),
    [aux_sym__terminator_token1] = ACTIONS(13582),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13584),
    [sym__command_start] = ACTIONS(13584),
  },
  [8495] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14565),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_else] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_finally] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14545),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14547),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(14547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13106),
    [anon_sym_QMARK] = ACTIONS(13282),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14567),
    [sym__arrow_operator] = ACTIONS(14569),
    [sym__lazy_or_operator] = ACTIONS(14571),
    [sym__lazy_and_operator] = ACTIONS(14573),
    [sym__comparison_operator] = ACTIONS(14547),
    [sym__pipe_right_operator] = ACTIONS(14549),
    [sym__pipe_left_operator] = ACTIONS(14551),
    [sym__ellipsis_operator] = ACTIONS(14553),
    [sym__plus_operator] = ACTIONS(14555),
    [sym__times_operator] = ACTIONS(14557),
    [sym__rational_operator] = ACTIONS(14559),
    [sym__bitshift_operator] = ACTIONS(14561),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14547),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14555),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [8496] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_end] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_catch] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [8497] = {
    [sym__word_identifier] = ACTIONS(13316),
    [anon_sym_EQ] = ACTIONS(13316),
    [anon_sym_COMMA] = ACTIONS(13318),
    [anon_sym_COLON] = ACTIONS(13316),
    [anon_sym_begin] = ACTIONS(13316),
    [anon_sym_module] = ACTIONS(13316),
    [anon_sym_baremodule] = ACTIONS(13316),
    [anon_sym_abstract] = ACTIONS(13316),
    [anon_sym_primitive] = ACTIONS(13316),
    [anon_sym_mutable] = ACTIONS(13316),
    [anon_sym_struct] = ACTIONS(13316),
    [anon_sym_function] = ACTIONS(13316),
    [anon_sym_macro] = ACTIONS(13316),
    [anon_sym_where] = ACTIONS(13316),
    [anon_sym_quote] = ACTIONS(13316),
    [anon_sym_let] = ACTIONS(13316),
    [anon_sym_if] = ACTIONS(13316),
    [anon_sym_try] = ACTIONS(13316),
    [anon_sym_for] = ACTIONS(13316),
    [anon_sym_while] = ACTIONS(13316),
    [sym_break_statement] = ACTIONS(13316),
    [sym_continue_statement] = ACTIONS(13316),
    [anon_sym_return] = ACTIONS(13316),
    [anon_sym_const] = ACTIONS(13316),
    [anon_sym_global] = ACTIONS(13316),
    [anon_sym_local] = ACTIONS(13316),
    [anon_sym_LPAREN] = ACTIONS(13318),
    [anon_sym_RPAREN] = ACTIONS(13318),
    [anon_sym_COLON2] = ACTIONS(13316),
    [anon_sym_export] = ACTIONS(13316),
    [anon_sym_import] = ACTIONS(13316),
    [anon_sym_using] = ACTIONS(13316),
    [anon_sym_LBRACK] = ACTIONS(13318),
    [anon_sym_RBRACK] = ACTIONS(13318),
    [anon_sym_in] = ACTIONS(13316),
    [anon_sym_SEMI] = ACTIONS(13318),
    [anon_sym_LBRACE] = ACTIONS(13318),
    [anon_sym_RBRACE] = ACTIONS(13318),
    [anon_sym_DOLLAR] = ACTIONS(13318),
    [anon_sym_COLON_COLON] = ACTIONS(13318),
    [anon_sym_isa] = ACTIONS(13316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13318),
    [anon_sym_QMARK] = ACTIONS(13318),
    [anon_sym_AT] = ACTIONS(13318),
    [anon_sym_true] = ACTIONS(13316),
    [anon_sym_false] = ACTIONS(13316),
    [aux_sym_integer_literal_token1] = ACTIONS(13318),
    [aux_sym_integer_literal_token2] = ACTIONS(13318),
    [aux_sym_integer_literal_token3] = ACTIONS(13316),
    [aux_sym_integer_literal_token4] = ACTIONS(13316),
    [aux_sym_float_literal_token1] = ACTIONS(13318),
    [aux_sym_float_literal_token3] = ACTIONS(13318),
    [aux_sym_float_literal_token4] = ACTIONS(13318),
    [sym_character_literal] = ACTIONS(13318),
    [sym__pair_operator] = ACTIONS(13318),
    [sym__arrow_operator] = ACTIONS(13316),
    [sym__lazy_or_operator] = ACTIONS(13318),
    [sym__lazy_and_operator] = ACTIONS(13318),
    [sym__comparison_operator] = ACTIONS(13316),
    [sym__pipe_right_operator] = ACTIONS(13318),
    [sym__pipe_left_operator] = ACTIONS(13318),
    [sym__ellipsis_operator] = ACTIONS(13316),
    [sym__plus_operator] = ACTIONS(13316),
    [sym__times_operator] = ACTIONS(13316),
    [sym__rational_operator] = ACTIONS(13318),
    [sym__bitshift_operator] = ACTIONS(13318),
    [sym__power_operator] = ACTIONS(13318),
    [sym__tilde_operator] = ACTIONS(13318),
    [sym__type_order_operator] = ACTIONS(13318),
    [sym__unary_operator] = ACTIONS(13316),
    [sym__unary_plus_operator] = ACTIONS(13316),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13318),
    [sym__command_start] = ACTIONS(13318),
  },
  [8498] = {
    [sym__word_identifier] = ACTIONS(13320),
    [anon_sym_EQ] = ACTIONS(13320),
    [anon_sym_COMMA] = ACTIONS(13322),
    [anon_sym_COLON] = ACTIONS(13320),
    [anon_sym_begin] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(13320),
    [anon_sym_baremodule] = ACTIONS(13320),
    [anon_sym_abstract] = ACTIONS(13320),
    [anon_sym_primitive] = ACTIONS(13320),
    [anon_sym_mutable] = ACTIONS(13320),
    [anon_sym_struct] = ACTIONS(13320),
    [anon_sym_function] = ACTIONS(13320),
    [anon_sym_macro] = ACTIONS(13320),
    [anon_sym_where] = ACTIONS(13320),
    [anon_sym_quote] = ACTIONS(13320),
    [anon_sym_let] = ACTIONS(13320),
    [anon_sym_if] = ACTIONS(13320),
    [anon_sym_try] = ACTIONS(13320),
    [anon_sym_for] = ACTIONS(13320),
    [anon_sym_while] = ACTIONS(13320),
    [sym_break_statement] = ACTIONS(13320),
    [sym_continue_statement] = ACTIONS(13320),
    [anon_sym_return] = ACTIONS(13320),
    [anon_sym_const] = ACTIONS(13320),
    [anon_sym_global] = ACTIONS(13320),
    [anon_sym_local] = ACTIONS(13320),
    [anon_sym_LPAREN] = ACTIONS(13322),
    [anon_sym_RPAREN] = ACTIONS(13322),
    [anon_sym_COLON2] = ACTIONS(13320),
    [anon_sym_export] = ACTIONS(13320),
    [anon_sym_import] = ACTIONS(13320),
    [anon_sym_using] = ACTIONS(13320),
    [anon_sym_LBRACK] = ACTIONS(13322),
    [anon_sym_RBRACK] = ACTIONS(13322),
    [anon_sym_in] = ACTIONS(13320),
    [anon_sym_SEMI] = ACTIONS(13322),
    [anon_sym_LBRACE] = ACTIONS(13322),
    [anon_sym_RBRACE] = ACTIONS(13322),
    [anon_sym_DOLLAR] = ACTIONS(13322),
    [anon_sym_COLON_COLON] = ACTIONS(13322),
    [anon_sym_isa] = ACTIONS(13320),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13322),
    [anon_sym_QMARK] = ACTIONS(13322),
    [anon_sym_AT] = ACTIONS(13322),
    [anon_sym_true] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(13320),
    [aux_sym_integer_literal_token1] = ACTIONS(13322),
    [aux_sym_integer_literal_token2] = ACTIONS(13322),
    [aux_sym_integer_literal_token3] = ACTIONS(13320),
    [aux_sym_integer_literal_token4] = ACTIONS(13320),
    [aux_sym_float_literal_token1] = ACTIONS(13322),
    [aux_sym_float_literal_token3] = ACTIONS(13322),
    [aux_sym_float_literal_token4] = ACTIONS(13322),
    [sym_character_literal] = ACTIONS(13322),
    [sym__pair_operator] = ACTIONS(13322),
    [sym__arrow_operator] = ACTIONS(13320),
    [sym__lazy_or_operator] = ACTIONS(13322),
    [sym__lazy_and_operator] = ACTIONS(13322),
    [sym__comparison_operator] = ACTIONS(13320),
    [sym__pipe_right_operator] = ACTIONS(13322),
    [sym__pipe_left_operator] = ACTIONS(13322),
    [sym__ellipsis_operator] = ACTIONS(13320),
    [sym__plus_operator] = ACTIONS(13320),
    [sym__times_operator] = ACTIONS(13320),
    [sym__rational_operator] = ACTIONS(13322),
    [sym__bitshift_operator] = ACTIONS(13322),
    [sym__power_operator] = ACTIONS(13322),
    [sym__tilde_operator] = ACTIONS(13322),
    [sym__type_order_operator] = ACTIONS(13322),
    [sym__unary_operator] = ACTIONS(13320),
    [sym__unary_plus_operator] = ACTIONS(13320),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13322),
    [sym__command_start] = ACTIONS(13322),
  },
  [8499] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13241),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13241),
    [anon_sym_RPAREN] = ACTIONS(13241),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13241),
    [anon_sym_RBRACK] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_SEMI] = ACTIONS(13241),
    [anon_sym_LBRACE] = ACTIONS(13241),
    [anon_sym_RBRACE] = ACTIONS(13241),
    [anon_sym_DOLLAR] = ACTIONS(13241),
    [anon_sym_COLON_COLON] = ACTIONS(13241),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13241),
    [anon_sym_QMARK] = ACTIONS(13241),
    [anon_sym_AT] = ACTIONS(13241),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13241),
    [aux_sym_integer_literal_token2] = ACTIONS(13241),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13241),
    [aux_sym_float_literal_token3] = ACTIONS(13241),
    [aux_sym_float_literal_token4] = ACTIONS(13241),
    [sym_character_literal] = ACTIONS(13241),
    [sym__pair_operator] = ACTIONS(13241),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13241),
    [sym__lazy_and_operator] = ACTIONS(13241),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13241),
    [sym__pipe_left_operator] = ACTIONS(13241),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13241),
    [sym__bitshift_operator] = ACTIONS(13241),
    [sym__power_operator] = ACTIONS(13241),
    [sym__tilde_operator] = ACTIONS(13241),
    [sym__type_order_operator] = ACTIONS(13241),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8500] = {
    [sym__word_identifier] = ACTIONS(13326),
    [anon_sym_EQ] = ACTIONS(13326),
    [anon_sym_COMMA] = ACTIONS(13328),
    [anon_sym_COLON] = ACTIONS(13326),
    [anon_sym_begin] = ACTIONS(13326),
    [anon_sym_module] = ACTIONS(13326),
    [anon_sym_baremodule] = ACTIONS(13326),
    [anon_sym_abstract] = ACTIONS(13326),
    [anon_sym_primitive] = ACTIONS(13326),
    [anon_sym_mutable] = ACTIONS(13326),
    [anon_sym_struct] = ACTIONS(13326),
    [anon_sym_function] = ACTIONS(13326),
    [anon_sym_macro] = ACTIONS(13326),
    [anon_sym_where] = ACTIONS(13326),
    [anon_sym_quote] = ACTIONS(13326),
    [anon_sym_let] = ACTIONS(13326),
    [anon_sym_if] = ACTIONS(13326),
    [anon_sym_try] = ACTIONS(13326),
    [anon_sym_for] = ACTIONS(13326),
    [anon_sym_while] = ACTIONS(13326),
    [sym_break_statement] = ACTIONS(13326),
    [sym_continue_statement] = ACTIONS(13326),
    [anon_sym_return] = ACTIONS(13326),
    [anon_sym_const] = ACTIONS(13326),
    [anon_sym_global] = ACTIONS(13326),
    [anon_sym_local] = ACTIONS(13326),
    [anon_sym_LPAREN] = ACTIONS(13328),
    [anon_sym_RPAREN] = ACTIONS(13328),
    [anon_sym_COLON2] = ACTIONS(13326),
    [anon_sym_export] = ACTIONS(13326),
    [anon_sym_import] = ACTIONS(13326),
    [anon_sym_using] = ACTIONS(13326),
    [anon_sym_LBRACK] = ACTIONS(13328),
    [anon_sym_RBRACK] = ACTIONS(13328),
    [anon_sym_in] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(13328),
    [anon_sym_LBRACE] = ACTIONS(13328),
    [anon_sym_RBRACE] = ACTIONS(13328),
    [anon_sym_DOLLAR] = ACTIONS(13328),
    [anon_sym_COLON_COLON] = ACTIONS(13328),
    [anon_sym_isa] = ACTIONS(13326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13328),
    [anon_sym_QMARK] = ACTIONS(13328),
    [anon_sym_AT] = ACTIONS(13328),
    [anon_sym_true] = ACTIONS(13326),
    [anon_sym_false] = ACTIONS(13326),
    [aux_sym_integer_literal_token1] = ACTIONS(13328),
    [aux_sym_integer_literal_token2] = ACTIONS(13328),
    [aux_sym_integer_literal_token3] = ACTIONS(13326),
    [aux_sym_integer_literal_token4] = ACTIONS(13326),
    [aux_sym_float_literal_token1] = ACTIONS(13328),
    [aux_sym_float_literal_token3] = ACTIONS(13328),
    [aux_sym_float_literal_token4] = ACTIONS(13328),
    [sym_character_literal] = ACTIONS(13328),
    [sym__pair_operator] = ACTIONS(13328),
    [sym__arrow_operator] = ACTIONS(13326),
    [sym__lazy_or_operator] = ACTIONS(13328),
    [sym__lazy_and_operator] = ACTIONS(13328),
    [sym__comparison_operator] = ACTIONS(13326),
    [sym__pipe_right_operator] = ACTIONS(13328),
    [sym__pipe_left_operator] = ACTIONS(13328),
    [sym__ellipsis_operator] = ACTIONS(13326),
    [sym__plus_operator] = ACTIONS(13326),
    [sym__times_operator] = ACTIONS(13326),
    [sym__rational_operator] = ACTIONS(13328),
    [sym__bitshift_operator] = ACTIONS(13328),
    [sym__power_operator] = ACTIONS(13328),
    [sym__tilde_operator] = ACTIONS(13328),
    [sym__type_order_operator] = ACTIONS(13328),
    [sym__unary_operator] = ACTIONS(13326),
    [sym__unary_plus_operator] = ACTIONS(13326),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13328),
    [sym__command_start] = ACTIONS(13328),
  },
  [8501] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13245),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13245),
    [anon_sym_RPAREN] = ACTIONS(13245),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13245),
    [anon_sym_RBRACK] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_SEMI] = ACTIONS(13245),
    [anon_sym_LBRACE] = ACTIONS(13245),
    [anon_sym_RBRACE] = ACTIONS(13245),
    [anon_sym_DOLLAR] = ACTIONS(13245),
    [anon_sym_COLON_COLON] = ACTIONS(13245),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13245),
    [anon_sym_QMARK] = ACTIONS(13245),
    [anon_sym_AT] = ACTIONS(13245),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13245),
    [aux_sym_integer_literal_token2] = ACTIONS(13245),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13245),
    [aux_sym_float_literal_token3] = ACTIONS(13245),
    [aux_sym_float_literal_token4] = ACTIONS(13245),
    [sym_character_literal] = ACTIONS(13245),
    [sym__pair_operator] = ACTIONS(13245),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13245),
    [sym__lazy_and_operator] = ACTIONS(13245),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13245),
    [sym__pipe_left_operator] = ACTIONS(13245),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13245),
    [sym__bitshift_operator] = ACTIONS(13245),
    [sym__power_operator] = ACTIONS(13245),
    [sym__tilde_operator] = ACTIONS(13245),
    [sym__type_order_operator] = ACTIONS(13245),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8502] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(12934),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12934),
    [anon_sym_RPAREN] = ACTIONS(12934),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12934),
    [anon_sym_RBRACK] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_SEMI] = ACTIONS(12934),
    [anon_sym_LBRACE] = ACTIONS(12934),
    [anon_sym_RBRACE] = ACTIONS(12934),
    [anon_sym_DOLLAR] = ACTIONS(12934),
    [anon_sym_COLON_COLON] = ACTIONS(12934),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12934),
    [anon_sym_QMARK] = ACTIONS(12934),
    [anon_sym_AT] = ACTIONS(12934),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12934),
    [aux_sym_integer_literal_token2] = ACTIONS(12934),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12934),
    [aux_sym_float_literal_token3] = ACTIONS(12934),
    [aux_sym_float_literal_token4] = ACTIONS(12934),
    [sym_character_literal] = ACTIONS(12934),
    [sym__pair_operator] = ACTIONS(12934),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12934),
    [sym__lazy_and_operator] = ACTIONS(12934),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12934),
    [sym__pipe_left_operator] = ACTIONS(12934),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12934),
    [sym__bitshift_operator] = ACTIONS(12934),
    [sym__power_operator] = ACTIONS(12934),
    [sym__tilde_operator] = ACTIONS(12934),
    [sym__type_order_operator] = ACTIONS(12934),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8503] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(13306),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8504] = {
    [sym__word_identifier] = ACTIONS(13586),
    [anon_sym_EQ] = ACTIONS(13586),
    [anon_sym_COMMA] = ACTIONS(13586),
    [anon_sym_COLON] = ACTIONS(13586),
    [anon_sym_begin] = ACTIONS(13586),
    [anon_sym_module] = ACTIONS(13586),
    [anon_sym_baremodule] = ACTIONS(13586),
    [anon_sym_abstract] = ACTIONS(13586),
    [anon_sym_primitive] = ACTIONS(13586),
    [anon_sym_mutable] = ACTIONS(13586),
    [anon_sym_struct] = ACTIONS(13586),
    [anon_sym_function] = ACTIONS(13586),
    [anon_sym_macro] = ACTIONS(13586),
    [anon_sym_where] = ACTIONS(13586),
    [anon_sym_quote] = ACTIONS(13586),
    [anon_sym_let] = ACTIONS(13586),
    [anon_sym_if] = ACTIONS(13586),
    [anon_sym_try] = ACTIONS(13586),
    [anon_sym_catch] = ACTIONS(13586),
    [anon_sym_finally] = ACTIONS(13586),
    [anon_sym_for] = ACTIONS(13586),
    [anon_sym_while] = ACTIONS(13586),
    [sym_break_statement] = ACTIONS(13586),
    [sym_continue_statement] = ACTIONS(13586),
    [anon_sym_return] = ACTIONS(13586),
    [anon_sym_const] = ACTIONS(13586),
    [anon_sym_global] = ACTIONS(13586),
    [anon_sym_local] = ACTIONS(13586),
    [anon_sym_LPAREN] = ACTIONS(13586),
    [anon_sym_COLON2] = ACTIONS(13586),
    [anon_sym_export] = ACTIONS(13586),
    [anon_sym_import] = ACTIONS(13586),
    [anon_sym_using] = ACTIONS(13586),
    [anon_sym_LBRACK] = ACTIONS(13586),
    [anon_sym_LF] = ACTIONS(13588),
    [anon_sym_in] = ACTIONS(13586),
    [anon_sym_LBRACE] = ACTIONS(13586),
    [anon_sym_DOLLAR] = ACTIONS(13586),
    [anon_sym_COLON_COLON] = ACTIONS(13586),
    [anon_sym_isa] = ACTIONS(13586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13586),
    [anon_sym_QMARK] = ACTIONS(13586),
    [anon_sym_AT] = ACTIONS(13586),
    [anon_sym_true] = ACTIONS(13586),
    [anon_sym_false] = ACTIONS(13586),
    [aux_sym_integer_literal_token1] = ACTIONS(13586),
    [aux_sym_integer_literal_token2] = ACTIONS(13586),
    [aux_sym_integer_literal_token3] = ACTIONS(13586),
    [aux_sym_integer_literal_token4] = ACTIONS(13586),
    [aux_sym_float_literal_token1] = ACTIONS(13586),
    [aux_sym_float_literal_token3] = ACTIONS(13586),
    [aux_sym_float_literal_token4] = ACTIONS(13586),
    [sym_character_literal] = ACTIONS(13586),
    [sym__pair_operator] = ACTIONS(13586),
    [sym__arrow_operator] = ACTIONS(13586),
    [sym__lazy_or_operator] = ACTIONS(13586),
    [sym__lazy_and_operator] = ACTIONS(13586),
    [sym__comparison_operator] = ACTIONS(13586),
    [sym__pipe_right_operator] = ACTIONS(13586),
    [sym__pipe_left_operator] = ACTIONS(13586),
    [sym__ellipsis_operator] = ACTIONS(13586),
    [sym__plus_operator] = ACTIONS(13586),
    [sym__times_operator] = ACTIONS(13586),
    [sym__rational_operator] = ACTIONS(13586),
    [sym__bitshift_operator] = ACTIONS(13586),
    [sym__power_operator] = ACTIONS(13586),
    [sym__tilde_operator] = ACTIONS(13586),
    [sym__type_order_operator] = ACTIONS(13586),
    [sym__unary_operator] = ACTIONS(13586),
    [sym__unary_plus_operator] = ACTIONS(13586),
    [aux_sym__terminator_token1] = ACTIONS(13586),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13588),
    [sym__command_start] = ACTIONS(13588),
  },
  [8505] = {
    [sym__word_identifier] = ACTIONS(13590),
    [anon_sym_EQ] = ACTIONS(13590),
    [anon_sym_COMMA] = ACTIONS(13590),
    [anon_sym_COLON] = ACTIONS(13590),
    [anon_sym_begin] = ACTIONS(13590),
    [anon_sym_module] = ACTIONS(13590),
    [anon_sym_baremodule] = ACTIONS(13590),
    [anon_sym_abstract] = ACTIONS(13590),
    [anon_sym_primitive] = ACTIONS(13590),
    [anon_sym_mutable] = ACTIONS(13590),
    [anon_sym_struct] = ACTIONS(13590),
    [anon_sym_function] = ACTIONS(13590),
    [anon_sym_macro] = ACTIONS(13590),
    [anon_sym_where] = ACTIONS(13590),
    [anon_sym_quote] = ACTIONS(13590),
    [anon_sym_let] = ACTIONS(13590),
    [anon_sym_if] = ACTIONS(13590),
    [anon_sym_try] = ACTIONS(13590),
    [anon_sym_catch] = ACTIONS(13590),
    [anon_sym_finally] = ACTIONS(13590),
    [anon_sym_for] = ACTIONS(13590),
    [anon_sym_while] = ACTIONS(13590),
    [sym_break_statement] = ACTIONS(13590),
    [sym_continue_statement] = ACTIONS(13590),
    [anon_sym_return] = ACTIONS(13590),
    [anon_sym_const] = ACTIONS(13590),
    [anon_sym_global] = ACTIONS(13590),
    [anon_sym_local] = ACTIONS(13590),
    [anon_sym_LPAREN] = ACTIONS(13590),
    [anon_sym_COLON2] = ACTIONS(13590),
    [anon_sym_export] = ACTIONS(13590),
    [anon_sym_import] = ACTIONS(13590),
    [anon_sym_using] = ACTIONS(13590),
    [anon_sym_LBRACK] = ACTIONS(13590),
    [anon_sym_LF] = ACTIONS(13592),
    [anon_sym_in] = ACTIONS(13590),
    [anon_sym_LBRACE] = ACTIONS(13590),
    [anon_sym_DOLLAR] = ACTIONS(13590),
    [anon_sym_COLON_COLON] = ACTIONS(13590),
    [anon_sym_isa] = ACTIONS(13590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13590),
    [anon_sym_QMARK] = ACTIONS(13590),
    [anon_sym_AT] = ACTIONS(13590),
    [anon_sym_true] = ACTIONS(13590),
    [anon_sym_false] = ACTIONS(13590),
    [aux_sym_integer_literal_token1] = ACTIONS(13590),
    [aux_sym_integer_literal_token2] = ACTIONS(13590),
    [aux_sym_integer_literal_token3] = ACTIONS(13590),
    [aux_sym_integer_literal_token4] = ACTIONS(13590),
    [aux_sym_float_literal_token1] = ACTIONS(13590),
    [aux_sym_float_literal_token3] = ACTIONS(13590),
    [aux_sym_float_literal_token4] = ACTIONS(13590),
    [sym_character_literal] = ACTIONS(13590),
    [sym__pair_operator] = ACTIONS(13590),
    [sym__arrow_operator] = ACTIONS(13590),
    [sym__lazy_or_operator] = ACTIONS(13590),
    [sym__lazy_and_operator] = ACTIONS(13590),
    [sym__comparison_operator] = ACTIONS(13590),
    [sym__pipe_right_operator] = ACTIONS(13590),
    [sym__pipe_left_operator] = ACTIONS(13590),
    [sym__ellipsis_operator] = ACTIONS(13590),
    [sym__plus_operator] = ACTIONS(13590),
    [sym__times_operator] = ACTIONS(13590),
    [sym__rational_operator] = ACTIONS(13590),
    [sym__bitshift_operator] = ACTIONS(13590),
    [sym__power_operator] = ACTIONS(13590),
    [sym__tilde_operator] = ACTIONS(13590),
    [sym__type_order_operator] = ACTIONS(13590),
    [sym__unary_operator] = ACTIONS(13590),
    [sym__unary_plus_operator] = ACTIONS(13590),
    [aux_sym__terminator_token1] = ACTIONS(13590),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13592),
    [sym__command_start] = ACTIONS(13592),
  },
  [8506] = {
    [sym__word_identifier] = ACTIONS(13330),
    [anon_sym_EQ] = ACTIONS(13330),
    [anon_sym_COMMA] = ACTIONS(13332),
    [anon_sym_COLON] = ACTIONS(13330),
    [anon_sym_begin] = ACTIONS(13330),
    [anon_sym_module] = ACTIONS(13330),
    [anon_sym_baremodule] = ACTIONS(13330),
    [anon_sym_abstract] = ACTIONS(13330),
    [anon_sym_primitive] = ACTIONS(13330),
    [anon_sym_mutable] = ACTIONS(13330),
    [anon_sym_struct] = ACTIONS(13330),
    [anon_sym_function] = ACTIONS(13330),
    [anon_sym_macro] = ACTIONS(13330),
    [anon_sym_where] = ACTIONS(13330),
    [anon_sym_quote] = ACTIONS(13330),
    [anon_sym_let] = ACTIONS(13330),
    [anon_sym_if] = ACTIONS(13330),
    [anon_sym_try] = ACTIONS(13330),
    [anon_sym_for] = ACTIONS(13330),
    [anon_sym_while] = ACTIONS(13330),
    [sym_break_statement] = ACTIONS(13330),
    [sym_continue_statement] = ACTIONS(13330),
    [anon_sym_return] = ACTIONS(13330),
    [anon_sym_const] = ACTIONS(13330),
    [anon_sym_global] = ACTIONS(13330),
    [anon_sym_local] = ACTIONS(13330),
    [anon_sym_LPAREN] = ACTIONS(13332),
    [anon_sym_RPAREN] = ACTIONS(13332),
    [anon_sym_COLON2] = ACTIONS(13330),
    [anon_sym_export] = ACTIONS(13330),
    [anon_sym_import] = ACTIONS(13330),
    [anon_sym_using] = ACTIONS(13330),
    [anon_sym_LBRACK] = ACTIONS(13332),
    [anon_sym_RBRACK] = ACTIONS(13332),
    [anon_sym_in] = ACTIONS(13330),
    [anon_sym_SEMI] = ACTIONS(13332),
    [anon_sym_LBRACE] = ACTIONS(13332),
    [anon_sym_RBRACE] = ACTIONS(13332),
    [anon_sym_DOLLAR] = ACTIONS(13332),
    [anon_sym_COLON_COLON] = ACTIONS(13332),
    [anon_sym_isa] = ACTIONS(13330),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13332),
    [anon_sym_QMARK] = ACTIONS(13332),
    [anon_sym_AT] = ACTIONS(13332),
    [anon_sym_true] = ACTIONS(13330),
    [anon_sym_false] = ACTIONS(13330),
    [aux_sym_integer_literal_token1] = ACTIONS(13332),
    [aux_sym_integer_literal_token2] = ACTIONS(13332),
    [aux_sym_integer_literal_token3] = ACTIONS(13330),
    [aux_sym_integer_literal_token4] = ACTIONS(13330),
    [aux_sym_float_literal_token1] = ACTIONS(13332),
    [aux_sym_float_literal_token3] = ACTIONS(13332),
    [aux_sym_float_literal_token4] = ACTIONS(13332),
    [sym_character_literal] = ACTIONS(13332),
    [sym__pair_operator] = ACTIONS(13332),
    [sym__arrow_operator] = ACTIONS(13330),
    [sym__lazy_or_operator] = ACTIONS(13332),
    [sym__lazy_and_operator] = ACTIONS(13332),
    [sym__comparison_operator] = ACTIONS(13330),
    [sym__pipe_right_operator] = ACTIONS(13332),
    [sym__pipe_left_operator] = ACTIONS(13332),
    [sym__ellipsis_operator] = ACTIONS(13330),
    [sym__plus_operator] = ACTIONS(13330),
    [sym__times_operator] = ACTIONS(13330),
    [sym__rational_operator] = ACTIONS(13332),
    [sym__bitshift_operator] = ACTIONS(13332),
    [sym__power_operator] = ACTIONS(13332),
    [sym__tilde_operator] = ACTIONS(13332),
    [sym__type_order_operator] = ACTIONS(13332),
    [sym__unary_operator] = ACTIONS(13330),
    [sym__unary_plus_operator] = ACTIONS(13330),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13332),
    [sym__command_start] = ACTIONS(13332),
  },
  [8507] = {
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13255),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_catch] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13255),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13255),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13255),
    [anon_sym_isa] = ACTIONS(13255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13255),
    [anon_sym_QMARK] = ACTIONS(13255),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13255),
    [sym__arrow_operator] = ACTIONS(13255),
    [sym__lazy_or_operator] = ACTIONS(13255),
    [sym__lazy_and_operator] = ACTIONS(13255),
    [sym__comparison_operator] = ACTIONS(13255),
    [sym__pipe_right_operator] = ACTIONS(13255),
    [sym__pipe_left_operator] = ACTIONS(13255),
    [sym__ellipsis_operator] = ACTIONS(13255),
    [sym__plus_operator] = ACTIONS(13255),
    [sym__times_operator] = ACTIONS(13255),
    [sym__rational_operator] = ACTIONS(13255),
    [sym__bitshift_operator] = ACTIONS(13255),
    [sym__power_operator] = ACTIONS(13255),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13255),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13255),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8508] = {
    [sym__word_identifier] = ACTIONS(13594),
    [anon_sym_EQ] = ACTIONS(13594),
    [anon_sym_COMMA] = ACTIONS(13594),
    [anon_sym_COLON] = ACTIONS(13594),
    [anon_sym_begin] = ACTIONS(13594),
    [anon_sym_module] = ACTIONS(13594),
    [anon_sym_baremodule] = ACTIONS(13594),
    [anon_sym_abstract] = ACTIONS(13594),
    [anon_sym_primitive] = ACTIONS(13594),
    [anon_sym_mutable] = ACTIONS(13594),
    [anon_sym_struct] = ACTIONS(13594),
    [anon_sym_function] = ACTIONS(13594),
    [anon_sym_macro] = ACTIONS(13594),
    [anon_sym_where] = ACTIONS(13594),
    [anon_sym_quote] = ACTIONS(13594),
    [anon_sym_let] = ACTIONS(13594),
    [anon_sym_if] = ACTIONS(13594),
    [anon_sym_try] = ACTIONS(13594),
    [anon_sym_catch] = ACTIONS(13594),
    [anon_sym_finally] = ACTIONS(13594),
    [anon_sym_for] = ACTIONS(13594),
    [anon_sym_while] = ACTIONS(13594),
    [sym_break_statement] = ACTIONS(13594),
    [sym_continue_statement] = ACTIONS(13594),
    [anon_sym_return] = ACTIONS(13594),
    [anon_sym_const] = ACTIONS(13594),
    [anon_sym_global] = ACTIONS(13594),
    [anon_sym_local] = ACTIONS(13594),
    [anon_sym_LPAREN] = ACTIONS(13594),
    [anon_sym_COLON2] = ACTIONS(13594),
    [anon_sym_export] = ACTIONS(13594),
    [anon_sym_import] = ACTIONS(13594),
    [anon_sym_using] = ACTIONS(13594),
    [anon_sym_LBRACK] = ACTIONS(13594),
    [anon_sym_LF] = ACTIONS(13596),
    [anon_sym_in] = ACTIONS(13594),
    [anon_sym_LBRACE] = ACTIONS(13594),
    [anon_sym_DOLLAR] = ACTIONS(13594),
    [anon_sym_COLON_COLON] = ACTIONS(13594),
    [anon_sym_isa] = ACTIONS(13594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13594),
    [anon_sym_QMARK] = ACTIONS(13594),
    [anon_sym_AT] = ACTIONS(13594),
    [anon_sym_true] = ACTIONS(13594),
    [anon_sym_false] = ACTIONS(13594),
    [aux_sym_integer_literal_token1] = ACTIONS(13594),
    [aux_sym_integer_literal_token2] = ACTIONS(13594),
    [aux_sym_integer_literal_token3] = ACTIONS(13594),
    [aux_sym_integer_literal_token4] = ACTIONS(13594),
    [aux_sym_float_literal_token1] = ACTIONS(13594),
    [aux_sym_float_literal_token3] = ACTIONS(13594),
    [aux_sym_float_literal_token4] = ACTIONS(13594),
    [sym_character_literal] = ACTIONS(13594),
    [sym__pair_operator] = ACTIONS(13594),
    [sym__arrow_operator] = ACTIONS(13594),
    [sym__lazy_or_operator] = ACTIONS(13594),
    [sym__lazy_and_operator] = ACTIONS(13594),
    [sym__comparison_operator] = ACTIONS(13594),
    [sym__pipe_right_operator] = ACTIONS(13594),
    [sym__pipe_left_operator] = ACTIONS(13594),
    [sym__ellipsis_operator] = ACTIONS(13594),
    [sym__plus_operator] = ACTIONS(13594),
    [sym__times_operator] = ACTIONS(13594),
    [sym__rational_operator] = ACTIONS(13594),
    [sym__bitshift_operator] = ACTIONS(13594),
    [sym__power_operator] = ACTIONS(13594),
    [sym__tilde_operator] = ACTIONS(13594),
    [sym__type_order_operator] = ACTIONS(13594),
    [sym__unary_operator] = ACTIONS(13594),
    [sym__unary_plus_operator] = ACTIONS(13594),
    [aux_sym__terminator_token1] = ACTIONS(13594),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13596),
    [sym__command_start] = ACTIONS(13596),
  },
  [8509] = {
    [sym__word_identifier] = ACTIONS(13413),
    [anon_sym_EQ] = ACTIONS(13413),
    [anon_sym_COMMA] = ACTIONS(13413),
    [anon_sym_COLON] = ACTIONS(13413),
    [anon_sym_begin] = ACTIONS(13413),
    [anon_sym_module] = ACTIONS(13413),
    [anon_sym_baremodule] = ACTIONS(13413),
    [anon_sym_end] = ACTIONS(13413),
    [anon_sym_abstract] = ACTIONS(13413),
    [anon_sym_primitive] = ACTIONS(13413),
    [anon_sym_mutable] = ACTIONS(13413),
    [anon_sym_struct] = ACTIONS(13413),
    [anon_sym_function] = ACTIONS(13413),
    [anon_sym_macro] = ACTIONS(13413),
    [anon_sym_where] = ACTIONS(13413),
    [anon_sym_quote] = ACTIONS(13413),
    [anon_sym_let] = ACTIONS(13413),
    [anon_sym_if] = ACTIONS(13413),
    [anon_sym_try] = ACTIONS(13413),
    [anon_sym_catch] = ACTIONS(13413),
    [anon_sym_for] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(13413),
    [sym_break_statement] = ACTIONS(13413),
    [sym_continue_statement] = ACTIONS(13413),
    [anon_sym_return] = ACTIONS(13413),
    [anon_sym_const] = ACTIONS(13413),
    [anon_sym_global] = ACTIONS(13413),
    [anon_sym_local] = ACTIONS(13413),
    [anon_sym_LPAREN] = ACTIONS(13413),
    [anon_sym_COLON2] = ACTIONS(13413),
    [anon_sym_export] = ACTIONS(13413),
    [anon_sym_import] = ACTIONS(13413),
    [anon_sym_using] = ACTIONS(13413),
    [anon_sym_LBRACK] = ACTIONS(13413),
    [anon_sym_LF] = ACTIONS(13415),
    [anon_sym_in] = ACTIONS(13413),
    [anon_sym_LBRACE] = ACTIONS(13413),
    [anon_sym_DOLLAR] = ACTIONS(13413),
    [anon_sym_COLON_COLON] = ACTIONS(13413),
    [anon_sym_isa] = ACTIONS(13413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_QMARK] = ACTIONS(13413),
    [anon_sym_AT] = ACTIONS(13413),
    [anon_sym_true] = ACTIONS(13413),
    [anon_sym_false] = ACTIONS(13413),
    [aux_sym_integer_literal_token1] = ACTIONS(13413),
    [aux_sym_integer_literal_token2] = ACTIONS(13413),
    [aux_sym_integer_literal_token3] = ACTIONS(13413),
    [aux_sym_integer_literal_token4] = ACTIONS(13413),
    [aux_sym_float_literal_token1] = ACTIONS(13413),
    [aux_sym_float_literal_token3] = ACTIONS(13413),
    [aux_sym_float_literal_token4] = ACTIONS(13413),
    [sym_character_literal] = ACTIONS(13413),
    [sym__pair_operator] = ACTIONS(13413),
    [sym__arrow_operator] = ACTIONS(13413),
    [sym__lazy_or_operator] = ACTIONS(13413),
    [sym__lazy_and_operator] = ACTIONS(13413),
    [sym__comparison_operator] = ACTIONS(13413),
    [sym__pipe_right_operator] = ACTIONS(13413),
    [sym__pipe_left_operator] = ACTIONS(13413),
    [sym__ellipsis_operator] = ACTIONS(13413),
    [sym__plus_operator] = ACTIONS(13413),
    [sym__times_operator] = ACTIONS(13413),
    [sym__rational_operator] = ACTIONS(13413),
    [sym__bitshift_operator] = ACTIONS(13413),
    [sym__power_operator] = ACTIONS(13413),
    [sym__tilde_operator] = ACTIONS(13413),
    [sym__type_order_operator] = ACTIONS(13413),
    [sym__unary_operator] = ACTIONS(13413),
    [sym__unary_plus_operator] = ACTIONS(13413),
    [aux_sym__terminator_token1] = ACTIONS(13413),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13415),
    [sym__command_start] = ACTIONS(13415),
  },
  [8510] = {
    [sym__word_identifier] = ACTIONS(13417),
    [anon_sym_EQ] = ACTIONS(13417),
    [anon_sym_COMMA] = ACTIONS(13417),
    [anon_sym_COLON] = ACTIONS(13417),
    [anon_sym_begin] = ACTIONS(13417),
    [anon_sym_module] = ACTIONS(13417),
    [anon_sym_baremodule] = ACTIONS(13417),
    [anon_sym_end] = ACTIONS(13417),
    [anon_sym_abstract] = ACTIONS(13417),
    [anon_sym_primitive] = ACTIONS(13417),
    [anon_sym_mutable] = ACTIONS(13417),
    [anon_sym_struct] = ACTIONS(13417),
    [anon_sym_function] = ACTIONS(13417),
    [anon_sym_macro] = ACTIONS(13417),
    [anon_sym_where] = ACTIONS(13417),
    [anon_sym_quote] = ACTIONS(13417),
    [anon_sym_let] = ACTIONS(13417),
    [anon_sym_if] = ACTIONS(13417),
    [anon_sym_try] = ACTIONS(13417),
    [anon_sym_catch] = ACTIONS(13417),
    [anon_sym_for] = ACTIONS(13417),
    [anon_sym_while] = ACTIONS(13417),
    [sym_break_statement] = ACTIONS(13417),
    [sym_continue_statement] = ACTIONS(13417),
    [anon_sym_return] = ACTIONS(13417),
    [anon_sym_const] = ACTIONS(13417),
    [anon_sym_global] = ACTIONS(13417),
    [anon_sym_local] = ACTIONS(13417),
    [anon_sym_LPAREN] = ACTIONS(13417),
    [anon_sym_COLON2] = ACTIONS(13417),
    [anon_sym_export] = ACTIONS(13417),
    [anon_sym_import] = ACTIONS(13417),
    [anon_sym_using] = ACTIONS(13417),
    [anon_sym_LBRACK] = ACTIONS(13417),
    [anon_sym_LF] = ACTIONS(13419),
    [anon_sym_in] = ACTIONS(13417),
    [anon_sym_LBRACE] = ACTIONS(13417),
    [anon_sym_DOLLAR] = ACTIONS(13417),
    [anon_sym_COLON_COLON] = ACTIONS(13417),
    [anon_sym_isa] = ACTIONS(13417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13417),
    [anon_sym_QMARK] = ACTIONS(13417),
    [anon_sym_AT] = ACTIONS(13417),
    [anon_sym_true] = ACTIONS(13417),
    [anon_sym_false] = ACTIONS(13417),
    [aux_sym_integer_literal_token1] = ACTIONS(13417),
    [aux_sym_integer_literal_token2] = ACTIONS(13417),
    [aux_sym_integer_literal_token3] = ACTIONS(13417),
    [aux_sym_integer_literal_token4] = ACTIONS(13417),
    [aux_sym_float_literal_token1] = ACTIONS(13417),
    [aux_sym_float_literal_token3] = ACTIONS(13417),
    [aux_sym_float_literal_token4] = ACTIONS(13417),
    [sym_character_literal] = ACTIONS(13417),
    [sym__pair_operator] = ACTIONS(13417),
    [sym__arrow_operator] = ACTIONS(13417),
    [sym__lazy_or_operator] = ACTIONS(13417),
    [sym__lazy_and_operator] = ACTIONS(13417),
    [sym__comparison_operator] = ACTIONS(13417),
    [sym__pipe_right_operator] = ACTIONS(13417),
    [sym__pipe_left_operator] = ACTIONS(13417),
    [sym__ellipsis_operator] = ACTIONS(13417),
    [sym__plus_operator] = ACTIONS(13417),
    [sym__times_operator] = ACTIONS(13417),
    [sym__rational_operator] = ACTIONS(13417),
    [sym__bitshift_operator] = ACTIONS(13417),
    [sym__power_operator] = ACTIONS(13417),
    [sym__tilde_operator] = ACTIONS(13417),
    [sym__type_order_operator] = ACTIONS(13417),
    [sym__unary_operator] = ACTIONS(13417),
    [sym__unary_plus_operator] = ACTIONS(13417),
    [aux_sym__terminator_token1] = ACTIONS(13417),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13419),
    [sym__command_start] = ACTIONS(13419),
  },
  [8511] = {
    [sym__word_identifier] = ACTIONS(13346),
    [anon_sym_EQ] = ACTIONS(13346),
    [anon_sym_COMMA] = ACTIONS(13348),
    [anon_sym_COLON] = ACTIONS(13346),
    [anon_sym_begin] = ACTIONS(13346),
    [anon_sym_module] = ACTIONS(13346),
    [anon_sym_baremodule] = ACTIONS(13346),
    [anon_sym_abstract] = ACTIONS(13346),
    [anon_sym_primitive] = ACTIONS(13346),
    [anon_sym_mutable] = ACTIONS(13346),
    [anon_sym_struct] = ACTIONS(13346),
    [anon_sym_function] = ACTIONS(13346),
    [anon_sym_macro] = ACTIONS(13346),
    [anon_sym_where] = ACTIONS(13346),
    [anon_sym_quote] = ACTIONS(13346),
    [anon_sym_let] = ACTIONS(13346),
    [anon_sym_if] = ACTIONS(13346),
    [anon_sym_try] = ACTIONS(13346),
    [anon_sym_for] = ACTIONS(13346),
    [anon_sym_while] = ACTIONS(13346),
    [sym_break_statement] = ACTIONS(13346),
    [sym_continue_statement] = ACTIONS(13346),
    [anon_sym_return] = ACTIONS(13346),
    [anon_sym_const] = ACTIONS(13346),
    [anon_sym_global] = ACTIONS(13346),
    [anon_sym_local] = ACTIONS(13346),
    [anon_sym_LPAREN] = ACTIONS(13348),
    [anon_sym_RPAREN] = ACTIONS(13348),
    [anon_sym_COLON2] = ACTIONS(13346),
    [anon_sym_export] = ACTIONS(13346),
    [anon_sym_import] = ACTIONS(13346),
    [anon_sym_using] = ACTIONS(13346),
    [anon_sym_LBRACK] = ACTIONS(13348),
    [anon_sym_RBRACK] = ACTIONS(13348),
    [anon_sym_in] = ACTIONS(13346),
    [anon_sym_SEMI] = ACTIONS(13348),
    [anon_sym_LBRACE] = ACTIONS(13348),
    [anon_sym_RBRACE] = ACTIONS(13348),
    [anon_sym_DOLLAR] = ACTIONS(13348),
    [anon_sym_COLON_COLON] = ACTIONS(13348),
    [anon_sym_isa] = ACTIONS(13346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13348),
    [anon_sym_QMARK] = ACTIONS(13348),
    [anon_sym_AT] = ACTIONS(13348),
    [anon_sym_true] = ACTIONS(13346),
    [anon_sym_false] = ACTIONS(13346),
    [aux_sym_integer_literal_token1] = ACTIONS(13348),
    [aux_sym_integer_literal_token2] = ACTIONS(13348),
    [aux_sym_integer_literal_token3] = ACTIONS(13346),
    [aux_sym_integer_literal_token4] = ACTIONS(13346),
    [aux_sym_float_literal_token1] = ACTIONS(13348),
    [aux_sym_float_literal_token3] = ACTIONS(13348),
    [aux_sym_float_literal_token4] = ACTIONS(13348),
    [sym_character_literal] = ACTIONS(13348),
    [sym__pair_operator] = ACTIONS(13348),
    [sym__arrow_operator] = ACTIONS(13346),
    [sym__lazy_or_operator] = ACTIONS(13348),
    [sym__lazy_and_operator] = ACTIONS(13348),
    [sym__comparison_operator] = ACTIONS(13346),
    [sym__pipe_right_operator] = ACTIONS(13348),
    [sym__pipe_left_operator] = ACTIONS(13348),
    [sym__ellipsis_operator] = ACTIONS(13346),
    [sym__plus_operator] = ACTIONS(13346),
    [sym__times_operator] = ACTIONS(13346),
    [sym__rational_operator] = ACTIONS(13348),
    [sym__bitshift_operator] = ACTIONS(13348),
    [sym__power_operator] = ACTIONS(13348),
    [sym__tilde_operator] = ACTIONS(13348),
    [sym__type_order_operator] = ACTIONS(13348),
    [sym__unary_operator] = ACTIONS(13346),
    [sym__unary_plus_operator] = ACTIONS(13346),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13348),
    [sym__command_start] = ACTIONS(13348),
  },
  [8512] = {
    [sym__word_identifier] = ACTIONS(13421),
    [anon_sym_EQ] = ACTIONS(13421),
    [anon_sym_COMMA] = ACTIONS(13421),
    [anon_sym_COLON] = ACTIONS(13421),
    [anon_sym_begin] = ACTIONS(13421),
    [anon_sym_module] = ACTIONS(13421),
    [anon_sym_baremodule] = ACTIONS(13421),
    [anon_sym_end] = ACTIONS(13421),
    [anon_sym_abstract] = ACTIONS(13421),
    [anon_sym_primitive] = ACTIONS(13421),
    [anon_sym_mutable] = ACTIONS(13421),
    [anon_sym_struct] = ACTIONS(13421),
    [anon_sym_function] = ACTIONS(13421),
    [anon_sym_macro] = ACTIONS(13421),
    [anon_sym_where] = ACTIONS(13421),
    [anon_sym_quote] = ACTIONS(13421),
    [anon_sym_let] = ACTIONS(13421),
    [anon_sym_if] = ACTIONS(13421),
    [anon_sym_try] = ACTIONS(13421),
    [anon_sym_catch] = ACTIONS(13421),
    [anon_sym_for] = ACTIONS(13421),
    [anon_sym_while] = ACTIONS(13421),
    [sym_break_statement] = ACTIONS(13421),
    [sym_continue_statement] = ACTIONS(13421),
    [anon_sym_return] = ACTIONS(13421),
    [anon_sym_const] = ACTIONS(13421),
    [anon_sym_global] = ACTIONS(13421),
    [anon_sym_local] = ACTIONS(13421),
    [anon_sym_LPAREN] = ACTIONS(13421),
    [anon_sym_COLON2] = ACTIONS(13421),
    [anon_sym_export] = ACTIONS(13421),
    [anon_sym_import] = ACTIONS(13421),
    [anon_sym_using] = ACTIONS(13421),
    [anon_sym_LBRACK] = ACTIONS(13421),
    [anon_sym_LF] = ACTIONS(13423),
    [anon_sym_in] = ACTIONS(13421),
    [anon_sym_LBRACE] = ACTIONS(13421),
    [anon_sym_DOLLAR] = ACTIONS(13421),
    [anon_sym_COLON_COLON] = ACTIONS(13421),
    [anon_sym_isa] = ACTIONS(13421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13421),
    [anon_sym_QMARK] = ACTIONS(13421),
    [anon_sym_AT] = ACTIONS(13421),
    [anon_sym_true] = ACTIONS(13421),
    [anon_sym_false] = ACTIONS(13421),
    [aux_sym_integer_literal_token1] = ACTIONS(13421),
    [aux_sym_integer_literal_token2] = ACTIONS(13421),
    [aux_sym_integer_literal_token3] = ACTIONS(13421),
    [aux_sym_integer_literal_token4] = ACTIONS(13421),
    [aux_sym_float_literal_token1] = ACTIONS(13421),
    [aux_sym_float_literal_token3] = ACTIONS(13421),
    [aux_sym_float_literal_token4] = ACTIONS(13421),
    [sym_character_literal] = ACTIONS(13421),
    [sym__pair_operator] = ACTIONS(13421),
    [sym__arrow_operator] = ACTIONS(13421),
    [sym__lazy_or_operator] = ACTIONS(13421),
    [sym__lazy_and_operator] = ACTIONS(13421),
    [sym__comparison_operator] = ACTIONS(13421),
    [sym__pipe_right_operator] = ACTIONS(13421),
    [sym__pipe_left_operator] = ACTIONS(13421),
    [sym__ellipsis_operator] = ACTIONS(13421),
    [sym__plus_operator] = ACTIONS(13421),
    [sym__times_operator] = ACTIONS(13421),
    [sym__rational_operator] = ACTIONS(13421),
    [sym__bitshift_operator] = ACTIONS(13421),
    [sym__power_operator] = ACTIONS(13421),
    [sym__tilde_operator] = ACTIONS(13421),
    [sym__type_order_operator] = ACTIONS(13421),
    [sym__unary_operator] = ACTIONS(13421),
    [sym__unary_plus_operator] = ACTIONS(13421),
    [aux_sym__terminator_token1] = ACTIONS(13421),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13423),
    [sym__command_start] = ACTIONS(13423),
  },
  [8513] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12694),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8514] = {
    [sym__word_identifier] = ACTIONS(13425),
    [anon_sym_EQ] = ACTIONS(13425),
    [anon_sym_COMMA] = ACTIONS(13425),
    [anon_sym_COLON] = ACTIONS(13425),
    [anon_sym_begin] = ACTIONS(13425),
    [anon_sym_module] = ACTIONS(13425),
    [anon_sym_baremodule] = ACTIONS(13425),
    [anon_sym_end] = ACTIONS(13425),
    [anon_sym_abstract] = ACTIONS(13425),
    [anon_sym_primitive] = ACTIONS(13425),
    [anon_sym_mutable] = ACTIONS(13425),
    [anon_sym_struct] = ACTIONS(13425),
    [anon_sym_function] = ACTIONS(13425),
    [anon_sym_macro] = ACTIONS(13425),
    [anon_sym_where] = ACTIONS(13425),
    [anon_sym_quote] = ACTIONS(13425),
    [anon_sym_let] = ACTIONS(13425),
    [anon_sym_if] = ACTIONS(13425),
    [anon_sym_try] = ACTIONS(13425),
    [anon_sym_catch] = ACTIONS(13425),
    [anon_sym_for] = ACTIONS(13425),
    [anon_sym_while] = ACTIONS(13425),
    [sym_break_statement] = ACTIONS(13425),
    [sym_continue_statement] = ACTIONS(13425),
    [anon_sym_return] = ACTIONS(13425),
    [anon_sym_const] = ACTIONS(13425),
    [anon_sym_global] = ACTIONS(13425),
    [anon_sym_local] = ACTIONS(13425),
    [anon_sym_LPAREN] = ACTIONS(13425),
    [anon_sym_COLON2] = ACTIONS(13425),
    [anon_sym_export] = ACTIONS(13425),
    [anon_sym_import] = ACTIONS(13425),
    [anon_sym_using] = ACTIONS(13425),
    [anon_sym_LBRACK] = ACTIONS(13425),
    [anon_sym_LF] = ACTIONS(13427),
    [anon_sym_in] = ACTIONS(13425),
    [anon_sym_LBRACE] = ACTIONS(13425),
    [anon_sym_DOLLAR] = ACTIONS(13425),
    [anon_sym_COLON_COLON] = ACTIONS(13425),
    [anon_sym_isa] = ACTIONS(13425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13425),
    [anon_sym_QMARK] = ACTIONS(13425),
    [anon_sym_AT] = ACTIONS(13425),
    [anon_sym_true] = ACTIONS(13425),
    [anon_sym_false] = ACTIONS(13425),
    [aux_sym_integer_literal_token1] = ACTIONS(13425),
    [aux_sym_integer_literal_token2] = ACTIONS(13425),
    [aux_sym_integer_literal_token3] = ACTIONS(13425),
    [aux_sym_integer_literal_token4] = ACTIONS(13425),
    [aux_sym_float_literal_token1] = ACTIONS(13425),
    [aux_sym_float_literal_token3] = ACTIONS(13425),
    [aux_sym_float_literal_token4] = ACTIONS(13425),
    [sym_character_literal] = ACTIONS(13425),
    [sym__pair_operator] = ACTIONS(13425),
    [sym__arrow_operator] = ACTIONS(13425),
    [sym__lazy_or_operator] = ACTIONS(13425),
    [sym__lazy_and_operator] = ACTIONS(13425),
    [sym__comparison_operator] = ACTIONS(13425),
    [sym__pipe_right_operator] = ACTIONS(13425),
    [sym__pipe_left_operator] = ACTIONS(13425),
    [sym__ellipsis_operator] = ACTIONS(13425),
    [sym__plus_operator] = ACTIONS(13425),
    [sym__times_operator] = ACTIONS(13425),
    [sym__rational_operator] = ACTIONS(13425),
    [sym__bitshift_operator] = ACTIONS(13425),
    [sym__power_operator] = ACTIONS(13425),
    [sym__tilde_operator] = ACTIONS(13425),
    [sym__type_order_operator] = ACTIONS(13425),
    [sym__unary_operator] = ACTIONS(13425),
    [sym__unary_plus_operator] = ACTIONS(13425),
    [aux_sym__terminator_token1] = ACTIONS(13425),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13427),
    [sym__command_start] = ACTIONS(13427),
  },
  [8515] = {
    [sym__word_identifier] = ACTIONS(13429),
    [anon_sym_EQ] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(13429),
    [anon_sym_COLON] = ACTIONS(13429),
    [anon_sym_begin] = ACTIONS(13429),
    [anon_sym_module] = ACTIONS(13429),
    [anon_sym_baremodule] = ACTIONS(13429),
    [anon_sym_end] = ACTIONS(13429),
    [anon_sym_abstract] = ACTIONS(13429),
    [anon_sym_primitive] = ACTIONS(13429),
    [anon_sym_mutable] = ACTIONS(13429),
    [anon_sym_struct] = ACTIONS(13429),
    [anon_sym_function] = ACTIONS(13429),
    [anon_sym_macro] = ACTIONS(13429),
    [anon_sym_where] = ACTIONS(13429),
    [anon_sym_quote] = ACTIONS(13429),
    [anon_sym_let] = ACTIONS(13429),
    [anon_sym_if] = ACTIONS(13429),
    [anon_sym_try] = ACTIONS(13429),
    [anon_sym_catch] = ACTIONS(13429),
    [anon_sym_for] = ACTIONS(13429),
    [anon_sym_while] = ACTIONS(13429),
    [sym_break_statement] = ACTIONS(13429),
    [sym_continue_statement] = ACTIONS(13429),
    [anon_sym_return] = ACTIONS(13429),
    [anon_sym_const] = ACTIONS(13429),
    [anon_sym_global] = ACTIONS(13429),
    [anon_sym_local] = ACTIONS(13429),
    [anon_sym_LPAREN] = ACTIONS(13429),
    [anon_sym_COLON2] = ACTIONS(13429),
    [anon_sym_export] = ACTIONS(13429),
    [anon_sym_import] = ACTIONS(13429),
    [anon_sym_using] = ACTIONS(13429),
    [anon_sym_LBRACK] = ACTIONS(13429),
    [anon_sym_LF] = ACTIONS(13431),
    [anon_sym_in] = ACTIONS(13429),
    [anon_sym_LBRACE] = ACTIONS(13429),
    [anon_sym_DOLLAR] = ACTIONS(13429),
    [anon_sym_COLON_COLON] = ACTIONS(13429),
    [anon_sym_isa] = ACTIONS(13429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13429),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_AT] = ACTIONS(13429),
    [anon_sym_true] = ACTIONS(13429),
    [anon_sym_false] = ACTIONS(13429),
    [aux_sym_integer_literal_token1] = ACTIONS(13429),
    [aux_sym_integer_literal_token2] = ACTIONS(13429),
    [aux_sym_integer_literal_token3] = ACTIONS(13429),
    [aux_sym_integer_literal_token4] = ACTIONS(13429),
    [aux_sym_float_literal_token1] = ACTIONS(13429),
    [aux_sym_float_literal_token3] = ACTIONS(13429),
    [aux_sym_float_literal_token4] = ACTIONS(13429),
    [sym_character_literal] = ACTIONS(13429),
    [sym__pair_operator] = ACTIONS(13429),
    [sym__arrow_operator] = ACTIONS(13429),
    [sym__lazy_or_operator] = ACTIONS(13429),
    [sym__lazy_and_operator] = ACTIONS(13429),
    [sym__comparison_operator] = ACTIONS(13429),
    [sym__pipe_right_operator] = ACTIONS(13429),
    [sym__pipe_left_operator] = ACTIONS(13429),
    [sym__ellipsis_operator] = ACTIONS(13429),
    [sym__plus_operator] = ACTIONS(13429),
    [sym__times_operator] = ACTIONS(13429),
    [sym__rational_operator] = ACTIONS(13429),
    [sym__bitshift_operator] = ACTIONS(13429),
    [sym__power_operator] = ACTIONS(13429),
    [sym__tilde_operator] = ACTIONS(13429),
    [sym__type_order_operator] = ACTIONS(13429),
    [sym__unary_operator] = ACTIONS(13429),
    [sym__unary_plus_operator] = ACTIONS(13429),
    [aux_sym__terminator_token1] = ACTIONS(13429),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13431),
    [sym__command_start] = ACTIONS(13431),
  },
  [8516] = {
    [sym__word_identifier] = ACTIONS(13433),
    [anon_sym_EQ] = ACTIONS(13433),
    [anon_sym_COMMA] = ACTIONS(13433),
    [anon_sym_COLON] = ACTIONS(13433),
    [anon_sym_begin] = ACTIONS(13433),
    [anon_sym_module] = ACTIONS(13433),
    [anon_sym_baremodule] = ACTIONS(13433),
    [anon_sym_end] = ACTIONS(13433),
    [anon_sym_abstract] = ACTIONS(13433),
    [anon_sym_primitive] = ACTIONS(13433),
    [anon_sym_mutable] = ACTIONS(13433),
    [anon_sym_struct] = ACTIONS(13433),
    [anon_sym_function] = ACTIONS(13433),
    [anon_sym_macro] = ACTIONS(13433),
    [anon_sym_where] = ACTIONS(13433),
    [anon_sym_quote] = ACTIONS(13433),
    [anon_sym_let] = ACTIONS(13433),
    [anon_sym_if] = ACTIONS(13433),
    [anon_sym_try] = ACTIONS(13433),
    [anon_sym_catch] = ACTIONS(13433),
    [anon_sym_for] = ACTIONS(13433),
    [anon_sym_while] = ACTIONS(13433),
    [sym_break_statement] = ACTIONS(13433),
    [sym_continue_statement] = ACTIONS(13433),
    [anon_sym_return] = ACTIONS(13433),
    [anon_sym_const] = ACTIONS(13433),
    [anon_sym_global] = ACTIONS(13433),
    [anon_sym_local] = ACTIONS(13433),
    [anon_sym_LPAREN] = ACTIONS(13433),
    [anon_sym_COLON2] = ACTIONS(13433),
    [anon_sym_export] = ACTIONS(13433),
    [anon_sym_import] = ACTIONS(13433),
    [anon_sym_using] = ACTIONS(13433),
    [anon_sym_LBRACK] = ACTIONS(13433),
    [anon_sym_LF] = ACTIONS(13435),
    [anon_sym_in] = ACTIONS(13433),
    [anon_sym_LBRACE] = ACTIONS(13433),
    [anon_sym_DOLLAR] = ACTIONS(13433),
    [anon_sym_COLON_COLON] = ACTIONS(13433),
    [anon_sym_isa] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13433),
    [anon_sym_QMARK] = ACTIONS(13433),
    [anon_sym_AT] = ACTIONS(13433),
    [anon_sym_true] = ACTIONS(13433),
    [anon_sym_false] = ACTIONS(13433),
    [aux_sym_integer_literal_token1] = ACTIONS(13433),
    [aux_sym_integer_literal_token2] = ACTIONS(13433),
    [aux_sym_integer_literal_token3] = ACTIONS(13433),
    [aux_sym_integer_literal_token4] = ACTIONS(13433),
    [aux_sym_float_literal_token1] = ACTIONS(13433),
    [aux_sym_float_literal_token3] = ACTIONS(13433),
    [aux_sym_float_literal_token4] = ACTIONS(13433),
    [sym_character_literal] = ACTIONS(13433),
    [sym__pair_operator] = ACTIONS(13433),
    [sym__arrow_operator] = ACTIONS(13433),
    [sym__lazy_or_operator] = ACTIONS(13433),
    [sym__lazy_and_operator] = ACTIONS(13433),
    [sym__comparison_operator] = ACTIONS(13433),
    [sym__pipe_right_operator] = ACTIONS(13433),
    [sym__pipe_left_operator] = ACTIONS(13433),
    [sym__ellipsis_operator] = ACTIONS(13433),
    [sym__plus_operator] = ACTIONS(13433),
    [sym__times_operator] = ACTIONS(13433),
    [sym__rational_operator] = ACTIONS(13433),
    [sym__bitshift_operator] = ACTIONS(13433),
    [sym__power_operator] = ACTIONS(13433),
    [sym__tilde_operator] = ACTIONS(13433),
    [sym__type_order_operator] = ACTIONS(13433),
    [sym__unary_operator] = ACTIONS(13433),
    [sym__unary_plus_operator] = ACTIONS(13433),
    [aux_sym__terminator_token1] = ACTIONS(13433),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13435),
    [sym__command_start] = ACTIONS(13435),
  },
  [8517] = {
    [sym__word_identifier] = ACTIONS(13437),
    [anon_sym_EQ] = ACTIONS(13437),
    [anon_sym_COMMA] = ACTIONS(13437),
    [anon_sym_COLON] = ACTIONS(13437),
    [anon_sym_begin] = ACTIONS(13437),
    [anon_sym_module] = ACTIONS(13437),
    [anon_sym_baremodule] = ACTIONS(13437),
    [anon_sym_end] = ACTIONS(13437),
    [anon_sym_abstract] = ACTIONS(13437),
    [anon_sym_primitive] = ACTIONS(13437),
    [anon_sym_mutable] = ACTIONS(13437),
    [anon_sym_struct] = ACTIONS(13437),
    [anon_sym_function] = ACTIONS(13437),
    [anon_sym_macro] = ACTIONS(13437),
    [anon_sym_where] = ACTIONS(13437),
    [anon_sym_quote] = ACTIONS(13437),
    [anon_sym_let] = ACTIONS(13437),
    [anon_sym_if] = ACTIONS(13437),
    [anon_sym_try] = ACTIONS(13437),
    [anon_sym_catch] = ACTIONS(13437),
    [anon_sym_for] = ACTIONS(13437),
    [anon_sym_while] = ACTIONS(13437),
    [sym_break_statement] = ACTIONS(13437),
    [sym_continue_statement] = ACTIONS(13437),
    [anon_sym_return] = ACTIONS(13437),
    [anon_sym_const] = ACTIONS(13437),
    [anon_sym_global] = ACTIONS(13437),
    [anon_sym_local] = ACTIONS(13437),
    [anon_sym_LPAREN] = ACTIONS(13437),
    [anon_sym_COLON2] = ACTIONS(13437),
    [anon_sym_export] = ACTIONS(13437),
    [anon_sym_import] = ACTIONS(13437),
    [anon_sym_using] = ACTIONS(13437),
    [anon_sym_LBRACK] = ACTIONS(13437),
    [anon_sym_LF] = ACTIONS(13439),
    [anon_sym_in] = ACTIONS(13437),
    [anon_sym_LBRACE] = ACTIONS(13437),
    [anon_sym_DOLLAR] = ACTIONS(13437),
    [anon_sym_COLON_COLON] = ACTIONS(13437),
    [anon_sym_isa] = ACTIONS(13437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13437),
    [anon_sym_QMARK] = ACTIONS(13437),
    [anon_sym_AT] = ACTIONS(13437),
    [anon_sym_true] = ACTIONS(13437),
    [anon_sym_false] = ACTIONS(13437),
    [aux_sym_integer_literal_token1] = ACTIONS(13437),
    [aux_sym_integer_literal_token2] = ACTIONS(13437),
    [aux_sym_integer_literal_token3] = ACTIONS(13437),
    [aux_sym_integer_literal_token4] = ACTIONS(13437),
    [aux_sym_float_literal_token1] = ACTIONS(13437),
    [aux_sym_float_literal_token3] = ACTIONS(13437),
    [aux_sym_float_literal_token4] = ACTIONS(13437),
    [sym_character_literal] = ACTIONS(13437),
    [sym__pair_operator] = ACTIONS(13437),
    [sym__arrow_operator] = ACTIONS(13437),
    [sym__lazy_or_operator] = ACTIONS(13437),
    [sym__lazy_and_operator] = ACTIONS(13437),
    [sym__comparison_operator] = ACTIONS(13437),
    [sym__pipe_right_operator] = ACTIONS(13437),
    [sym__pipe_left_operator] = ACTIONS(13437),
    [sym__ellipsis_operator] = ACTIONS(13437),
    [sym__plus_operator] = ACTIONS(13437),
    [sym__times_operator] = ACTIONS(13437),
    [sym__rational_operator] = ACTIONS(13437),
    [sym__bitshift_operator] = ACTIONS(13437),
    [sym__power_operator] = ACTIONS(13437),
    [sym__tilde_operator] = ACTIONS(13437),
    [sym__type_order_operator] = ACTIONS(13437),
    [sym__unary_operator] = ACTIONS(13437),
    [sym__unary_plus_operator] = ACTIONS(13437),
    [aux_sym__terminator_token1] = ACTIONS(13437),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13439),
    [sym__command_start] = ACTIONS(13439),
  },
  [8518] = {
    [sym__word_identifier] = ACTIONS(13441),
    [anon_sym_EQ] = ACTIONS(13441),
    [anon_sym_COMMA] = ACTIONS(13441),
    [anon_sym_COLON] = ACTIONS(13441),
    [anon_sym_begin] = ACTIONS(13441),
    [anon_sym_module] = ACTIONS(13441),
    [anon_sym_baremodule] = ACTIONS(13441),
    [anon_sym_end] = ACTIONS(13441),
    [anon_sym_abstract] = ACTIONS(13441),
    [anon_sym_primitive] = ACTIONS(13441),
    [anon_sym_mutable] = ACTIONS(13441),
    [anon_sym_struct] = ACTIONS(13441),
    [anon_sym_function] = ACTIONS(13441),
    [anon_sym_macro] = ACTIONS(13441),
    [anon_sym_where] = ACTIONS(13441),
    [anon_sym_quote] = ACTIONS(13441),
    [anon_sym_let] = ACTIONS(13441),
    [anon_sym_if] = ACTIONS(13441),
    [anon_sym_try] = ACTIONS(13441),
    [anon_sym_catch] = ACTIONS(13441),
    [anon_sym_for] = ACTIONS(13441),
    [anon_sym_while] = ACTIONS(13441),
    [sym_break_statement] = ACTIONS(13441),
    [sym_continue_statement] = ACTIONS(13441),
    [anon_sym_return] = ACTIONS(13441),
    [anon_sym_const] = ACTIONS(13441),
    [anon_sym_global] = ACTIONS(13441),
    [anon_sym_local] = ACTIONS(13441),
    [anon_sym_LPAREN] = ACTIONS(13441),
    [anon_sym_COLON2] = ACTIONS(13441),
    [anon_sym_export] = ACTIONS(13441),
    [anon_sym_import] = ACTIONS(13441),
    [anon_sym_using] = ACTIONS(13441),
    [anon_sym_LBRACK] = ACTIONS(13441),
    [anon_sym_LF] = ACTIONS(13443),
    [anon_sym_in] = ACTIONS(13441),
    [anon_sym_LBRACE] = ACTIONS(13441),
    [anon_sym_DOLLAR] = ACTIONS(13441),
    [anon_sym_COLON_COLON] = ACTIONS(13441),
    [anon_sym_isa] = ACTIONS(13441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13441),
    [anon_sym_QMARK] = ACTIONS(13441),
    [anon_sym_AT] = ACTIONS(13441),
    [anon_sym_true] = ACTIONS(13441),
    [anon_sym_false] = ACTIONS(13441),
    [aux_sym_integer_literal_token1] = ACTIONS(13441),
    [aux_sym_integer_literal_token2] = ACTIONS(13441),
    [aux_sym_integer_literal_token3] = ACTIONS(13441),
    [aux_sym_integer_literal_token4] = ACTIONS(13441),
    [aux_sym_float_literal_token1] = ACTIONS(13441),
    [aux_sym_float_literal_token3] = ACTIONS(13441),
    [aux_sym_float_literal_token4] = ACTIONS(13441),
    [sym_character_literal] = ACTIONS(13441),
    [sym__pair_operator] = ACTIONS(13441),
    [sym__arrow_operator] = ACTIONS(13441),
    [sym__lazy_or_operator] = ACTIONS(13441),
    [sym__lazy_and_operator] = ACTIONS(13441),
    [sym__comparison_operator] = ACTIONS(13441),
    [sym__pipe_right_operator] = ACTIONS(13441),
    [sym__pipe_left_operator] = ACTIONS(13441),
    [sym__ellipsis_operator] = ACTIONS(13441),
    [sym__plus_operator] = ACTIONS(13441),
    [sym__times_operator] = ACTIONS(13441),
    [sym__rational_operator] = ACTIONS(13441),
    [sym__bitshift_operator] = ACTIONS(13441),
    [sym__power_operator] = ACTIONS(13441),
    [sym__tilde_operator] = ACTIONS(13441),
    [sym__type_order_operator] = ACTIONS(13441),
    [sym__unary_operator] = ACTIONS(13441),
    [sym__unary_plus_operator] = ACTIONS(13441),
    [aux_sym__terminator_token1] = ACTIONS(13441),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13443),
    [sym__command_start] = ACTIONS(13443),
  },
  [8519] = {
    [sym__word_identifier] = ACTIONS(13445),
    [anon_sym_EQ] = ACTIONS(13445),
    [anon_sym_COMMA] = ACTIONS(13445),
    [anon_sym_COLON] = ACTIONS(13445),
    [anon_sym_begin] = ACTIONS(13445),
    [anon_sym_module] = ACTIONS(13445),
    [anon_sym_baremodule] = ACTIONS(13445),
    [anon_sym_end] = ACTIONS(13445),
    [anon_sym_abstract] = ACTIONS(13445),
    [anon_sym_primitive] = ACTIONS(13445),
    [anon_sym_mutable] = ACTIONS(13445),
    [anon_sym_struct] = ACTIONS(13445),
    [anon_sym_function] = ACTIONS(13445),
    [anon_sym_macro] = ACTIONS(13445),
    [anon_sym_where] = ACTIONS(13445),
    [anon_sym_quote] = ACTIONS(13445),
    [anon_sym_let] = ACTIONS(13445),
    [anon_sym_if] = ACTIONS(13445),
    [anon_sym_try] = ACTIONS(13445),
    [anon_sym_catch] = ACTIONS(13445),
    [anon_sym_for] = ACTIONS(13445),
    [anon_sym_while] = ACTIONS(13445),
    [sym_break_statement] = ACTIONS(13445),
    [sym_continue_statement] = ACTIONS(13445),
    [anon_sym_return] = ACTIONS(13445),
    [anon_sym_const] = ACTIONS(13445),
    [anon_sym_global] = ACTIONS(13445),
    [anon_sym_local] = ACTIONS(13445),
    [anon_sym_LPAREN] = ACTIONS(13445),
    [anon_sym_COLON2] = ACTIONS(13445),
    [anon_sym_export] = ACTIONS(13445),
    [anon_sym_import] = ACTIONS(13445),
    [anon_sym_using] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(13445),
    [anon_sym_LF] = ACTIONS(13447),
    [anon_sym_in] = ACTIONS(13445),
    [anon_sym_LBRACE] = ACTIONS(13445),
    [anon_sym_DOLLAR] = ACTIONS(13445),
    [anon_sym_COLON_COLON] = ACTIONS(13445),
    [anon_sym_isa] = ACTIONS(13445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13445),
    [anon_sym_QMARK] = ACTIONS(13445),
    [anon_sym_AT] = ACTIONS(13445),
    [anon_sym_true] = ACTIONS(13445),
    [anon_sym_false] = ACTIONS(13445),
    [aux_sym_integer_literal_token1] = ACTIONS(13445),
    [aux_sym_integer_literal_token2] = ACTIONS(13445),
    [aux_sym_integer_literal_token3] = ACTIONS(13445),
    [aux_sym_integer_literal_token4] = ACTIONS(13445),
    [aux_sym_float_literal_token1] = ACTIONS(13445),
    [aux_sym_float_literal_token3] = ACTIONS(13445),
    [aux_sym_float_literal_token4] = ACTIONS(13445),
    [sym_character_literal] = ACTIONS(13445),
    [sym__pair_operator] = ACTIONS(13445),
    [sym__arrow_operator] = ACTIONS(13445),
    [sym__lazy_or_operator] = ACTIONS(13445),
    [sym__lazy_and_operator] = ACTIONS(13445),
    [sym__comparison_operator] = ACTIONS(13445),
    [sym__pipe_right_operator] = ACTIONS(13445),
    [sym__pipe_left_operator] = ACTIONS(13445),
    [sym__ellipsis_operator] = ACTIONS(13445),
    [sym__plus_operator] = ACTIONS(13445),
    [sym__times_operator] = ACTIONS(13445),
    [sym__rational_operator] = ACTIONS(13445),
    [sym__bitshift_operator] = ACTIONS(13445),
    [sym__power_operator] = ACTIONS(13445),
    [sym__tilde_operator] = ACTIONS(13445),
    [sym__type_order_operator] = ACTIONS(13445),
    [sym__unary_operator] = ACTIONS(13445),
    [sym__unary_plus_operator] = ACTIONS(13445),
    [aux_sym__terminator_token1] = ACTIONS(13445),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13447),
    [sym__command_start] = ACTIONS(13447),
  },
  [8520] = {
    [sym__word_identifier] = ACTIONS(13449),
    [anon_sym_EQ] = ACTIONS(13449),
    [anon_sym_COMMA] = ACTIONS(13449),
    [anon_sym_COLON] = ACTIONS(13449),
    [anon_sym_begin] = ACTIONS(13449),
    [anon_sym_module] = ACTIONS(13449),
    [anon_sym_baremodule] = ACTIONS(13449),
    [anon_sym_end] = ACTIONS(13449),
    [anon_sym_abstract] = ACTIONS(13449),
    [anon_sym_primitive] = ACTIONS(13449),
    [anon_sym_mutable] = ACTIONS(13449),
    [anon_sym_struct] = ACTIONS(13449),
    [anon_sym_function] = ACTIONS(13449),
    [anon_sym_macro] = ACTIONS(13449),
    [anon_sym_where] = ACTIONS(13449),
    [anon_sym_quote] = ACTIONS(13449),
    [anon_sym_let] = ACTIONS(13449),
    [anon_sym_if] = ACTIONS(13449),
    [anon_sym_try] = ACTIONS(13449),
    [anon_sym_catch] = ACTIONS(13449),
    [anon_sym_for] = ACTIONS(13449),
    [anon_sym_while] = ACTIONS(13449),
    [sym_break_statement] = ACTIONS(13449),
    [sym_continue_statement] = ACTIONS(13449),
    [anon_sym_return] = ACTIONS(13449),
    [anon_sym_const] = ACTIONS(13449),
    [anon_sym_global] = ACTIONS(13449),
    [anon_sym_local] = ACTIONS(13449),
    [anon_sym_LPAREN] = ACTIONS(13449),
    [anon_sym_COLON2] = ACTIONS(13449),
    [anon_sym_export] = ACTIONS(13449),
    [anon_sym_import] = ACTIONS(13449),
    [anon_sym_using] = ACTIONS(13449),
    [anon_sym_LBRACK] = ACTIONS(13449),
    [anon_sym_LF] = ACTIONS(13451),
    [anon_sym_in] = ACTIONS(13449),
    [anon_sym_LBRACE] = ACTIONS(13449),
    [anon_sym_DOLLAR] = ACTIONS(13449),
    [anon_sym_COLON_COLON] = ACTIONS(13449),
    [anon_sym_isa] = ACTIONS(13449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13449),
    [anon_sym_QMARK] = ACTIONS(13449),
    [anon_sym_AT] = ACTIONS(13449),
    [anon_sym_true] = ACTIONS(13449),
    [anon_sym_false] = ACTIONS(13449),
    [aux_sym_integer_literal_token1] = ACTIONS(13449),
    [aux_sym_integer_literal_token2] = ACTIONS(13449),
    [aux_sym_integer_literal_token3] = ACTIONS(13449),
    [aux_sym_integer_literal_token4] = ACTIONS(13449),
    [aux_sym_float_literal_token1] = ACTIONS(13449),
    [aux_sym_float_literal_token3] = ACTIONS(13449),
    [aux_sym_float_literal_token4] = ACTIONS(13449),
    [sym_character_literal] = ACTIONS(13449),
    [sym__pair_operator] = ACTIONS(13449),
    [sym__arrow_operator] = ACTIONS(13449),
    [sym__lazy_or_operator] = ACTIONS(13449),
    [sym__lazy_and_operator] = ACTIONS(13449),
    [sym__comparison_operator] = ACTIONS(13449),
    [sym__pipe_right_operator] = ACTIONS(13449),
    [sym__pipe_left_operator] = ACTIONS(13449),
    [sym__ellipsis_operator] = ACTIONS(13449),
    [sym__plus_operator] = ACTIONS(13449),
    [sym__times_operator] = ACTIONS(13449),
    [sym__rational_operator] = ACTIONS(13449),
    [sym__bitshift_operator] = ACTIONS(13449),
    [sym__power_operator] = ACTIONS(13449),
    [sym__tilde_operator] = ACTIONS(13449),
    [sym__type_order_operator] = ACTIONS(13449),
    [sym__unary_operator] = ACTIONS(13449),
    [sym__unary_plus_operator] = ACTIONS(13449),
    [aux_sym__terminator_token1] = ACTIONS(13449),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13451),
    [sym__command_start] = ACTIONS(13451),
  },
  [8521] = {
    [sym__word_identifier] = ACTIONS(13453),
    [anon_sym_EQ] = ACTIONS(13453),
    [anon_sym_COMMA] = ACTIONS(13453),
    [anon_sym_COLON] = ACTIONS(13453),
    [anon_sym_begin] = ACTIONS(13453),
    [anon_sym_module] = ACTIONS(13453),
    [anon_sym_baremodule] = ACTIONS(13453),
    [anon_sym_end] = ACTIONS(13453),
    [anon_sym_abstract] = ACTIONS(13453),
    [anon_sym_primitive] = ACTIONS(13453),
    [anon_sym_mutable] = ACTIONS(13453),
    [anon_sym_struct] = ACTIONS(13453),
    [anon_sym_function] = ACTIONS(13453),
    [anon_sym_macro] = ACTIONS(13453),
    [anon_sym_where] = ACTIONS(13453),
    [anon_sym_quote] = ACTIONS(13453),
    [anon_sym_let] = ACTIONS(13453),
    [anon_sym_if] = ACTIONS(13453),
    [anon_sym_try] = ACTIONS(13453),
    [anon_sym_catch] = ACTIONS(13453),
    [anon_sym_for] = ACTIONS(13453),
    [anon_sym_while] = ACTIONS(13453),
    [sym_break_statement] = ACTIONS(13453),
    [sym_continue_statement] = ACTIONS(13453),
    [anon_sym_return] = ACTIONS(13453),
    [anon_sym_const] = ACTIONS(13453),
    [anon_sym_global] = ACTIONS(13453),
    [anon_sym_local] = ACTIONS(13453),
    [anon_sym_LPAREN] = ACTIONS(13453),
    [anon_sym_COLON2] = ACTIONS(13453),
    [anon_sym_export] = ACTIONS(13453),
    [anon_sym_import] = ACTIONS(13453),
    [anon_sym_using] = ACTIONS(13453),
    [anon_sym_LBRACK] = ACTIONS(13453),
    [anon_sym_LF] = ACTIONS(13455),
    [anon_sym_in] = ACTIONS(13453),
    [anon_sym_LBRACE] = ACTIONS(13453),
    [anon_sym_DOLLAR] = ACTIONS(13453),
    [anon_sym_COLON_COLON] = ACTIONS(13453),
    [anon_sym_isa] = ACTIONS(13453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13453),
    [anon_sym_QMARK] = ACTIONS(13453),
    [anon_sym_AT] = ACTIONS(13453),
    [anon_sym_true] = ACTIONS(13453),
    [anon_sym_false] = ACTIONS(13453),
    [aux_sym_integer_literal_token1] = ACTIONS(13453),
    [aux_sym_integer_literal_token2] = ACTIONS(13453),
    [aux_sym_integer_literal_token3] = ACTIONS(13453),
    [aux_sym_integer_literal_token4] = ACTIONS(13453),
    [aux_sym_float_literal_token1] = ACTIONS(13453),
    [aux_sym_float_literal_token3] = ACTIONS(13453),
    [aux_sym_float_literal_token4] = ACTIONS(13453),
    [sym_character_literal] = ACTIONS(13453),
    [sym__pair_operator] = ACTIONS(13453),
    [sym__arrow_operator] = ACTIONS(13453),
    [sym__lazy_or_operator] = ACTIONS(13453),
    [sym__lazy_and_operator] = ACTIONS(13453),
    [sym__comparison_operator] = ACTIONS(13453),
    [sym__pipe_right_operator] = ACTIONS(13453),
    [sym__pipe_left_operator] = ACTIONS(13453),
    [sym__ellipsis_operator] = ACTIONS(13453),
    [sym__plus_operator] = ACTIONS(13453),
    [sym__times_operator] = ACTIONS(13453),
    [sym__rational_operator] = ACTIONS(13453),
    [sym__bitshift_operator] = ACTIONS(13453),
    [sym__power_operator] = ACTIONS(13453),
    [sym__tilde_operator] = ACTIONS(13453),
    [sym__type_order_operator] = ACTIONS(13453),
    [sym__unary_operator] = ACTIONS(13453),
    [sym__unary_plus_operator] = ACTIONS(13453),
    [aux_sym__terminator_token1] = ACTIONS(13453),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13455),
    [sym__command_start] = ACTIONS(13455),
  },
  [8522] = {
    [sym__word_identifier] = ACTIONS(13457),
    [anon_sym_EQ] = ACTIONS(13457),
    [anon_sym_COMMA] = ACTIONS(13457),
    [anon_sym_COLON] = ACTIONS(13457),
    [anon_sym_begin] = ACTIONS(13457),
    [anon_sym_module] = ACTIONS(13457),
    [anon_sym_baremodule] = ACTIONS(13457),
    [anon_sym_end] = ACTIONS(13457),
    [anon_sym_abstract] = ACTIONS(13457),
    [anon_sym_primitive] = ACTIONS(13457),
    [anon_sym_mutable] = ACTIONS(13457),
    [anon_sym_struct] = ACTIONS(13457),
    [anon_sym_function] = ACTIONS(13457),
    [anon_sym_macro] = ACTIONS(13457),
    [anon_sym_where] = ACTIONS(13457),
    [anon_sym_quote] = ACTIONS(13457),
    [anon_sym_let] = ACTIONS(13457),
    [anon_sym_if] = ACTIONS(13457),
    [anon_sym_try] = ACTIONS(13457),
    [anon_sym_catch] = ACTIONS(13457),
    [anon_sym_for] = ACTIONS(13457),
    [anon_sym_while] = ACTIONS(13457),
    [sym_break_statement] = ACTIONS(13457),
    [sym_continue_statement] = ACTIONS(13457),
    [anon_sym_return] = ACTIONS(13457),
    [anon_sym_const] = ACTIONS(13457),
    [anon_sym_global] = ACTIONS(13457),
    [anon_sym_local] = ACTIONS(13457),
    [anon_sym_LPAREN] = ACTIONS(13457),
    [anon_sym_COLON2] = ACTIONS(13457),
    [anon_sym_export] = ACTIONS(13457),
    [anon_sym_import] = ACTIONS(13457),
    [anon_sym_using] = ACTIONS(13457),
    [anon_sym_LBRACK] = ACTIONS(13457),
    [anon_sym_LF] = ACTIONS(13459),
    [anon_sym_in] = ACTIONS(13457),
    [anon_sym_LBRACE] = ACTIONS(13457),
    [anon_sym_DOLLAR] = ACTIONS(13457),
    [anon_sym_COLON_COLON] = ACTIONS(13457),
    [anon_sym_isa] = ACTIONS(13457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13457),
    [anon_sym_QMARK] = ACTIONS(13457),
    [anon_sym_AT] = ACTIONS(13457),
    [anon_sym_true] = ACTIONS(13457),
    [anon_sym_false] = ACTIONS(13457),
    [aux_sym_integer_literal_token1] = ACTIONS(13457),
    [aux_sym_integer_literal_token2] = ACTIONS(13457),
    [aux_sym_integer_literal_token3] = ACTIONS(13457),
    [aux_sym_integer_literal_token4] = ACTIONS(13457),
    [aux_sym_float_literal_token1] = ACTIONS(13457),
    [aux_sym_float_literal_token3] = ACTIONS(13457),
    [aux_sym_float_literal_token4] = ACTIONS(13457),
    [sym_character_literal] = ACTIONS(13457),
    [sym__pair_operator] = ACTIONS(13457),
    [sym__arrow_operator] = ACTIONS(13457),
    [sym__lazy_or_operator] = ACTIONS(13457),
    [sym__lazy_and_operator] = ACTIONS(13457),
    [sym__comparison_operator] = ACTIONS(13457),
    [sym__pipe_right_operator] = ACTIONS(13457),
    [sym__pipe_left_operator] = ACTIONS(13457),
    [sym__ellipsis_operator] = ACTIONS(13457),
    [sym__plus_operator] = ACTIONS(13457),
    [sym__times_operator] = ACTIONS(13457),
    [sym__rational_operator] = ACTIONS(13457),
    [sym__bitshift_operator] = ACTIONS(13457),
    [sym__power_operator] = ACTIONS(13457),
    [sym__tilde_operator] = ACTIONS(13457),
    [sym__type_order_operator] = ACTIONS(13457),
    [sym__unary_operator] = ACTIONS(13457),
    [sym__unary_plus_operator] = ACTIONS(13457),
    [aux_sym__terminator_token1] = ACTIONS(13457),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13459),
    [sym__command_start] = ACTIONS(13459),
  },
  [8523] = {
    [sym__word_identifier] = ACTIONS(13461),
    [anon_sym_EQ] = ACTIONS(13461),
    [anon_sym_COMMA] = ACTIONS(13461),
    [anon_sym_COLON] = ACTIONS(13461),
    [anon_sym_begin] = ACTIONS(13461),
    [anon_sym_module] = ACTIONS(13461),
    [anon_sym_baremodule] = ACTIONS(13461),
    [anon_sym_end] = ACTIONS(13461),
    [anon_sym_abstract] = ACTIONS(13461),
    [anon_sym_primitive] = ACTIONS(13461),
    [anon_sym_mutable] = ACTIONS(13461),
    [anon_sym_struct] = ACTIONS(13461),
    [anon_sym_function] = ACTIONS(13461),
    [anon_sym_macro] = ACTIONS(13461),
    [anon_sym_where] = ACTIONS(13461),
    [anon_sym_quote] = ACTIONS(13461),
    [anon_sym_let] = ACTIONS(13461),
    [anon_sym_if] = ACTIONS(13461),
    [anon_sym_try] = ACTIONS(13461),
    [anon_sym_catch] = ACTIONS(13461),
    [anon_sym_for] = ACTIONS(13461),
    [anon_sym_while] = ACTIONS(13461),
    [sym_break_statement] = ACTIONS(13461),
    [sym_continue_statement] = ACTIONS(13461),
    [anon_sym_return] = ACTIONS(13461),
    [anon_sym_const] = ACTIONS(13461),
    [anon_sym_global] = ACTIONS(13461),
    [anon_sym_local] = ACTIONS(13461),
    [anon_sym_LPAREN] = ACTIONS(13461),
    [anon_sym_COLON2] = ACTIONS(13461),
    [anon_sym_export] = ACTIONS(13461),
    [anon_sym_import] = ACTIONS(13461),
    [anon_sym_using] = ACTIONS(13461),
    [anon_sym_LBRACK] = ACTIONS(13461),
    [anon_sym_LF] = ACTIONS(13463),
    [anon_sym_in] = ACTIONS(13461),
    [anon_sym_LBRACE] = ACTIONS(13461),
    [anon_sym_DOLLAR] = ACTIONS(13461),
    [anon_sym_COLON_COLON] = ACTIONS(13461),
    [anon_sym_isa] = ACTIONS(13461),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13461),
    [anon_sym_QMARK] = ACTIONS(13461),
    [anon_sym_AT] = ACTIONS(13461),
    [anon_sym_true] = ACTIONS(13461),
    [anon_sym_false] = ACTIONS(13461),
    [aux_sym_integer_literal_token1] = ACTIONS(13461),
    [aux_sym_integer_literal_token2] = ACTIONS(13461),
    [aux_sym_integer_literal_token3] = ACTIONS(13461),
    [aux_sym_integer_literal_token4] = ACTIONS(13461),
    [aux_sym_float_literal_token1] = ACTIONS(13461),
    [aux_sym_float_literal_token3] = ACTIONS(13461),
    [aux_sym_float_literal_token4] = ACTIONS(13461),
    [sym_character_literal] = ACTIONS(13461),
    [sym__pair_operator] = ACTIONS(13461),
    [sym__arrow_operator] = ACTIONS(13461),
    [sym__lazy_or_operator] = ACTIONS(13461),
    [sym__lazy_and_operator] = ACTIONS(13461),
    [sym__comparison_operator] = ACTIONS(13461),
    [sym__pipe_right_operator] = ACTIONS(13461),
    [sym__pipe_left_operator] = ACTIONS(13461),
    [sym__ellipsis_operator] = ACTIONS(13461),
    [sym__plus_operator] = ACTIONS(13461),
    [sym__times_operator] = ACTIONS(13461),
    [sym__rational_operator] = ACTIONS(13461),
    [sym__bitshift_operator] = ACTIONS(13461),
    [sym__power_operator] = ACTIONS(13461),
    [sym__tilde_operator] = ACTIONS(13461),
    [sym__type_order_operator] = ACTIONS(13461),
    [sym__unary_operator] = ACTIONS(13461),
    [sym__unary_plus_operator] = ACTIONS(13461),
    [aux_sym__terminator_token1] = ACTIONS(13461),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13463),
    [sym__command_start] = ACTIONS(13463),
  },
  [8524] = {
    [sym__word_identifier] = ACTIONS(13481),
    [anon_sym_EQ] = ACTIONS(13481),
    [anon_sym_COMMA] = ACTIONS(13481),
    [anon_sym_COLON] = ACTIONS(13481),
    [anon_sym_begin] = ACTIONS(13481),
    [anon_sym_module] = ACTIONS(13481),
    [anon_sym_baremodule] = ACTIONS(13481),
    [anon_sym_end] = ACTIONS(13481),
    [anon_sym_abstract] = ACTIONS(13481),
    [anon_sym_primitive] = ACTIONS(13481),
    [anon_sym_mutable] = ACTIONS(13481),
    [anon_sym_struct] = ACTIONS(13481),
    [anon_sym_function] = ACTIONS(13481),
    [anon_sym_macro] = ACTIONS(13481),
    [anon_sym_where] = ACTIONS(13481),
    [anon_sym_quote] = ACTIONS(13481),
    [anon_sym_let] = ACTIONS(13481),
    [anon_sym_if] = ACTIONS(13481),
    [anon_sym_try] = ACTIONS(13481),
    [anon_sym_catch] = ACTIONS(13481),
    [anon_sym_for] = ACTIONS(13481),
    [anon_sym_while] = ACTIONS(13481),
    [sym_break_statement] = ACTIONS(13481),
    [sym_continue_statement] = ACTIONS(13481),
    [anon_sym_return] = ACTIONS(13481),
    [anon_sym_const] = ACTIONS(13481),
    [anon_sym_global] = ACTIONS(13481),
    [anon_sym_local] = ACTIONS(13481),
    [anon_sym_LPAREN] = ACTIONS(13481),
    [anon_sym_COLON2] = ACTIONS(13481),
    [anon_sym_export] = ACTIONS(13481),
    [anon_sym_import] = ACTIONS(13481),
    [anon_sym_using] = ACTIONS(13481),
    [anon_sym_LBRACK] = ACTIONS(13481),
    [anon_sym_LF] = ACTIONS(13483),
    [anon_sym_in] = ACTIONS(13481),
    [anon_sym_LBRACE] = ACTIONS(13481),
    [anon_sym_DOLLAR] = ACTIONS(13481),
    [anon_sym_COLON_COLON] = ACTIONS(13481),
    [anon_sym_isa] = ACTIONS(13481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13481),
    [anon_sym_QMARK] = ACTIONS(13481),
    [anon_sym_AT] = ACTIONS(13481),
    [anon_sym_true] = ACTIONS(13481),
    [anon_sym_false] = ACTIONS(13481),
    [aux_sym_integer_literal_token1] = ACTIONS(13481),
    [aux_sym_integer_literal_token2] = ACTIONS(13481),
    [aux_sym_integer_literal_token3] = ACTIONS(13481),
    [aux_sym_integer_literal_token4] = ACTIONS(13481),
    [aux_sym_float_literal_token1] = ACTIONS(13481),
    [aux_sym_float_literal_token3] = ACTIONS(13481),
    [aux_sym_float_literal_token4] = ACTIONS(13481),
    [sym_character_literal] = ACTIONS(13481),
    [sym__pair_operator] = ACTIONS(13481),
    [sym__arrow_operator] = ACTIONS(13481),
    [sym__lazy_or_operator] = ACTIONS(13481),
    [sym__lazy_and_operator] = ACTIONS(13481),
    [sym__comparison_operator] = ACTIONS(13481),
    [sym__pipe_right_operator] = ACTIONS(13481),
    [sym__pipe_left_operator] = ACTIONS(13481),
    [sym__ellipsis_operator] = ACTIONS(13481),
    [sym__plus_operator] = ACTIONS(13481),
    [sym__times_operator] = ACTIONS(13481),
    [sym__rational_operator] = ACTIONS(13481),
    [sym__bitshift_operator] = ACTIONS(13481),
    [sym__power_operator] = ACTIONS(13481),
    [sym__tilde_operator] = ACTIONS(13481),
    [sym__type_order_operator] = ACTIONS(13481),
    [sym__unary_operator] = ACTIONS(13481),
    [sym__unary_plus_operator] = ACTIONS(13481),
    [aux_sym__terminator_token1] = ACTIONS(13481),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13483),
    [sym__command_start] = ACTIONS(13483),
  },
  [8525] = {
    [sym__word_identifier] = ACTIONS(13485),
    [anon_sym_EQ] = ACTIONS(13485),
    [anon_sym_COMMA] = ACTIONS(13485),
    [anon_sym_COLON] = ACTIONS(13485),
    [anon_sym_begin] = ACTIONS(13485),
    [anon_sym_module] = ACTIONS(13485),
    [anon_sym_baremodule] = ACTIONS(13485),
    [anon_sym_end] = ACTIONS(13485),
    [anon_sym_abstract] = ACTIONS(13485),
    [anon_sym_primitive] = ACTIONS(13485),
    [anon_sym_mutable] = ACTIONS(13485),
    [anon_sym_struct] = ACTIONS(13485),
    [anon_sym_function] = ACTIONS(13485),
    [anon_sym_macro] = ACTIONS(13485),
    [anon_sym_where] = ACTIONS(13485),
    [anon_sym_quote] = ACTIONS(13485),
    [anon_sym_let] = ACTIONS(13485),
    [anon_sym_if] = ACTIONS(13485),
    [anon_sym_try] = ACTIONS(13485),
    [anon_sym_catch] = ACTIONS(13485),
    [anon_sym_for] = ACTIONS(13485),
    [anon_sym_while] = ACTIONS(13485),
    [sym_break_statement] = ACTIONS(13485),
    [sym_continue_statement] = ACTIONS(13485),
    [anon_sym_return] = ACTIONS(13485),
    [anon_sym_const] = ACTIONS(13485),
    [anon_sym_global] = ACTIONS(13485),
    [anon_sym_local] = ACTIONS(13485),
    [anon_sym_LPAREN] = ACTIONS(13485),
    [anon_sym_COLON2] = ACTIONS(13485),
    [anon_sym_export] = ACTIONS(13485),
    [anon_sym_import] = ACTIONS(13485),
    [anon_sym_using] = ACTIONS(13485),
    [anon_sym_LBRACK] = ACTIONS(13485),
    [anon_sym_LF] = ACTIONS(13487),
    [anon_sym_in] = ACTIONS(13485),
    [anon_sym_LBRACE] = ACTIONS(13485),
    [anon_sym_DOLLAR] = ACTIONS(13485),
    [anon_sym_COLON_COLON] = ACTIONS(13485),
    [anon_sym_isa] = ACTIONS(13485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13485),
    [anon_sym_QMARK] = ACTIONS(13485),
    [anon_sym_AT] = ACTIONS(13485),
    [anon_sym_true] = ACTIONS(13485),
    [anon_sym_false] = ACTIONS(13485),
    [aux_sym_integer_literal_token1] = ACTIONS(13485),
    [aux_sym_integer_literal_token2] = ACTIONS(13485),
    [aux_sym_integer_literal_token3] = ACTIONS(13485),
    [aux_sym_integer_literal_token4] = ACTIONS(13485),
    [aux_sym_float_literal_token1] = ACTIONS(13485),
    [aux_sym_float_literal_token3] = ACTIONS(13485),
    [aux_sym_float_literal_token4] = ACTIONS(13485),
    [sym_character_literal] = ACTIONS(13485),
    [sym__pair_operator] = ACTIONS(13485),
    [sym__arrow_operator] = ACTIONS(13485),
    [sym__lazy_or_operator] = ACTIONS(13485),
    [sym__lazy_and_operator] = ACTIONS(13485),
    [sym__comparison_operator] = ACTIONS(13485),
    [sym__pipe_right_operator] = ACTIONS(13485),
    [sym__pipe_left_operator] = ACTIONS(13485),
    [sym__ellipsis_operator] = ACTIONS(13485),
    [sym__plus_operator] = ACTIONS(13485),
    [sym__times_operator] = ACTIONS(13485),
    [sym__rational_operator] = ACTIONS(13485),
    [sym__bitshift_operator] = ACTIONS(13485),
    [sym__power_operator] = ACTIONS(13485),
    [sym__tilde_operator] = ACTIONS(13485),
    [sym__type_order_operator] = ACTIONS(13485),
    [sym__unary_operator] = ACTIONS(13485),
    [sym__unary_plus_operator] = ACTIONS(13485),
    [aux_sym__terminator_token1] = ACTIONS(13485),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13487),
    [sym__command_start] = ACTIONS(13487),
  },
  [8526] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13036),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13036),
    [anon_sym_RPAREN] = ACTIONS(13036),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13036),
    [anon_sym_RBRACK] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_SEMI] = ACTIONS(13036),
    [anon_sym_LBRACE] = ACTIONS(13036),
    [anon_sym_RBRACE] = ACTIONS(13036),
    [anon_sym_DOLLAR] = ACTIONS(13036),
    [anon_sym_COLON_COLON] = ACTIONS(13036),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13036),
    [anon_sym_QMARK] = ACTIONS(13036),
    [anon_sym_AT] = ACTIONS(13036),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13036),
    [aux_sym_integer_literal_token2] = ACTIONS(13036),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13036),
    [aux_sym_float_literal_token3] = ACTIONS(13036),
    [aux_sym_float_literal_token4] = ACTIONS(13036),
    [sym_character_literal] = ACTIONS(13036),
    [sym__pair_operator] = ACTIONS(13036),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13036),
    [sym__lazy_and_operator] = ACTIONS(13036),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13036),
    [sym__pipe_left_operator] = ACTIONS(13036),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13036),
    [sym__bitshift_operator] = ACTIONS(13036),
    [sym__power_operator] = ACTIONS(13036),
    [sym__tilde_operator] = ACTIONS(13036),
    [sym__type_order_operator] = ACTIONS(13036),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [8527] = {
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(12974),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_end] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_catch] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [8528] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_catch] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8529] = {
    [sym__word_identifier] = ACTIONS(13489),
    [anon_sym_EQ] = ACTIONS(13489),
    [anon_sym_COMMA] = ACTIONS(13489),
    [anon_sym_COLON] = ACTIONS(13489),
    [anon_sym_begin] = ACTIONS(13489),
    [anon_sym_module] = ACTIONS(13489),
    [anon_sym_baremodule] = ACTIONS(13489),
    [anon_sym_end] = ACTIONS(13489),
    [anon_sym_abstract] = ACTIONS(13489),
    [anon_sym_primitive] = ACTIONS(13489),
    [anon_sym_mutable] = ACTIONS(13489),
    [anon_sym_struct] = ACTIONS(13489),
    [anon_sym_function] = ACTIONS(13489),
    [anon_sym_macro] = ACTIONS(13489),
    [anon_sym_where] = ACTIONS(13489),
    [anon_sym_quote] = ACTIONS(13489),
    [anon_sym_let] = ACTIONS(13489),
    [anon_sym_if] = ACTIONS(13489),
    [anon_sym_try] = ACTIONS(13489),
    [anon_sym_catch] = ACTIONS(13489),
    [anon_sym_for] = ACTIONS(13489),
    [anon_sym_while] = ACTIONS(13489),
    [sym_break_statement] = ACTIONS(13489),
    [sym_continue_statement] = ACTIONS(13489),
    [anon_sym_return] = ACTIONS(13489),
    [anon_sym_const] = ACTIONS(13489),
    [anon_sym_global] = ACTIONS(13489),
    [anon_sym_local] = ACTIONS(13489),
    [anon_sym_LPAREN] = ACTIONS(13489),
    [anon_sym_COLON2] = ACTIONS(13489),
    [anon_sym_export] = ACTIONS(13489),
    [anon_sym_import] = ACTIONS(13489),
    [anon_sym_using] = ACTIONS(13489),
    [anon_sym_LBRACK] = ACTIONS(13489),
    [anon_sym_LF] = ACTIONS(13491),
    [anon_sym_in] = ACTIONS(13489),
    [anon_sym_LBRACE] = ACTIONS(13489),
    [anon_sym_DOLLAR] = ACTIONS(13489),
    [anon_sym_COLON_COLON] = ACTIONS(13489),
    [anon_sym_isa] = ACTIONS(13489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13489),
    [anon_sym_QMARK] = ACTIONS(13489),
    [anon_sym_AT] = ACTIONS(13489),
    [anon_sym_true] = ACTIONS(13489),
    [anon_sym_false] = ACTIONS(13489),
    [aux_sym_integer_literal_token1] = ACTIONS(13489),
    [aux_sym_integer_literal_token2] = ACTIONS(13489),
    [aux_sym_integer_literal_token3] = ACTIONS(13489),
    [aux_sym_integer_literal_token4] = ACTIONS(13489),
    [aux_sym_float_literal_token1] = ACTIONS(13489),
    [aux_sym_float_literal_token3] = ACTIONS(13489),
    [aux_sym_float_literal_token4] = ACTIONS(13489),
    [sym_character_literal] = ACTIONS(13489),
    [sym__pair_operator] = ACTIONS(13489),
    [sym__arrow_operator] = ACTIONS(13489),
    [sym__lazy_or_operator] = ACTIONS(13489),
    [sym__lazy_and_operator] = ACTIONS(13489),
    [sym__comparison_operator] = ACTIONS(13489),
    [sym__pipe_right_operator] = ACTIONS(13489),
    [sym__pipe_left_operator] = ACTIONS(13489),
    [sym__ellipsis_operator] = ACTIONS(13489),
    [sym__plus_operator] = ACTIONS(13489),
    [sym__times_operator] = ACTIONS(13489),
    [sym__rational_operator] = ACTIONS(13489),
    [sym__bitshift_operator] = ACTIONS(13489),
    [sym__power_operator] = ACTIONS(13489),
    [sym__tilde_operator] = ACTIONS(13489),
    [sym__type_order_operator] = ACTIONS(13489),
    [sym__unary_operator] = ACTIONS(13489),
    [sym__unary_plus_operator] = ACTIONS(13489),
    [aux_sym__terminator_token1] = ACTIONS(13489),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13491),
    [sym__command_start] = ACTIONS(13491),
  },
  [8530] = {
    [sym__word_identifier] = ACTIONS(13493),
    [anon_sym_EQ] = ACTIONS(13493),
    [anon_sym_COMMA] = ACTIONS(13493),
    [anon_sym_COLON] = ACTIONS(13493),
    [anon_sym_begin] = ACTIONS(13493),
    [anon_sym_module] = ACTIONS(13493),
    [anon_sym_baremodule] = ACTIONS(13493),
    [anon_sym_end] = ACTIONS(13493),
    [anon_sym_abstract] = ACTIONS(13493),
    [anon_sym_primitive] = ACTIONS(13493),
    [anon_sym_mutable] = ACTIONS(13493),
    [anon_sym_struct] = ACTIONS(13493),
    [anon_sym_function] = ACTIONS(13493),
    [anon_sym_macro] = ACTIONS(13493),
    [anon_sym_where] = ACTIONS(13493),
    [anon_sym_quote] = ACTIONS(13493),
    [anon_sym_let] = ACTIONS(13493),
    [anon_sym_if] = ACTIONS(13493),
    [anon_sym_try] = ACTIONS(13493),
    [anon_sym_catch] = ACTIONS(13493),
    [anon_sym_for] = ACTIONS(13493),
    [anon_sym_while] = ACTIONS(13493),
    [sym_break_statement] = ACTIONS(13493),
    [sym_continue_statement] = ACTIONS(13493),
    [anon_sym_return] = ACTIONS(13493),
    [anon_sym_const] = ACTIONS(13493),
    [anon_sym_global] = ACTIONS(13493),
    [anon_sym_local] = ACTIONS(13493),
    [anon_sym_LPAREN] = ACTIONS(13493),
    [anon_sym_COLON2] = ACTIONS(13493),
    [anon_sym_export] = ACTIONS(13493),
    [anon_sym_import] = ACTIONS(13493),
    [anon_sym_using] = ACTIONS(13493),
    [anon_sym_LBRACK] = ACTIONS(13493),
    [anon_sym_LF] = ACTIONS(13495),
    [anon_sym_in] = ACTIONS(13493),
    [anon_sym_LBRACE] = ACTIONS(13493),
    [anon_sym_DOLLAR] = ACTIONS(13493),
    [anon_sym_COLON_COLON] = ACTIONS(13493),
    [anon_sym_isa] = ACTIONS(13493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13493),
    [anon_sym_QMARK] = ACTIONS(13493),
    [anon_sym_AT] = ACTIONS(13493),
    [anon_sym_true] = ACTIONS(13493),
    [anon_sym_false] = ACTIONS(13493),
    [aux_sym_integer_literal_token1] = ACTIONS(13493),
    [aux_sym_integer_literal_token2] = ACTIONS(13493),
    [aux_sym_integer_literal_token3] = ACTIONS(13493),
    [aux_sym_integer_literal_token4] = ACTIONS(13493),
    [aux_sym_float_literal_token1] = ACTIONS(13493),
    [aux_sym_float_literal_token3] = ACTIONS(13493),
    [aux_sym_float_literal_token4] = ACTIONS(13493),
    [sym_character_literal] = ACTIONS(13493),
    [sym__pair_operator] = ACTIONS(13493),
    [sym__arrow_operator] = ACTIONS(13493),
    [sym__lazy_or_operator] = ACTIONS(13493),
    [sym__lazy_and_operator] = ACTIONS(13493),
    [sym__comparison_operator] = ACTIONS(13493),
    [sym__pipe_right_operator] = ACTIONS(13493),
    [sym__pipe_left_operator] = ACTIONS(13493),
    [sym__ellipsis_operator] = ACTIONS(13493),
    [sym__plus_operator] = ACTIONS(13493),
    [sym__times_operator] = ACTIONS(13493),
    [sym__rational_operator] = ACTIONS(13493),
    [sym__bitshift_operator] = ACTIONS(13493),
    [sym__power_operator] = ACTIONS(13493),
    [sym__tilde_operator] = ACTIONS(13493),
    [sym__type_order_operator] = ACTIONS(13493),
    [sym__unary_operator] = ACTIONS(13493),
    [sym__unary_plus_operator] = ACTIONS(13493),
    [aux_sym__terminator_token1] = ACTIONS(13493),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13495),
    [sym__command_start] = ACTIONS(13495),
  },
  [8531] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_EQ] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_catch] = ACTIONS(13338),
    [anon_sym_finally] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14419),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [8532] = {
    [sym__word_identifier] = ACTIONS(13499),
    [anon_sym_EQ] = ACTIONS(13499),
    [anon_sym_COMMA] = ACTIONS(13499),
    [anon_sym_COLON] = ACTIONS(13499),
    [anon_sym_begin] = ACTIONS(13499),
    [anon_sym_module] = ACTIONS(13499),
    [anon_sym_baremodule] = ACTIONS(13499),
    [anon_sym_end] = ACTIONS(13499),
    [anon_sym_abstract] = ACTIONS(13499),
    [anon_sym_primitive] = ACTIONS(13499),
    [anon_sym_mutable] = ACTIONS(13499),
    [anon_sym_struct] = ACTIONS(13499),
    [anon_sym_function] = ACTIONS(13499),
    [anon_sym_macro] = ACTIONS(13499),
    [anon_sym_where] = ACTIONS(13499),
    [anon_sym_quote] = ACTIONS(13499),
    [anon_sym_let] = ACTIONS(13499),
    [anon_sym_if] = ACTIONS(13499),
    [anon_sym_try] = ACTIONS(13499),
    [anon_sym_catch] = ACTIONS(13499),
    [anon_sym_for] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(13499),
    [sym_break_statement] = ACTIONS(13499),
    [sym_continue_statement] = ACTIONS(13499),
    [anon_sym_return] = ACTIONS(13499),
    [anon_sym_const] = ACTIONS(13499),
    [anon_sym_global] = ACTIONS(13499),
    [anon_sym_local] = ACTIONS(13499),
    [anon_sym_LPAREN] = ACTIONS(13499),
    [anon_sym_COLON2] = ACTIONS(13499),
    [anon_sym_export] = ACTIONS(13499),
    [anon_sym_import] = ACTIONS(13499),
    [anon_sym_using] = ACTIONS(13499),
    [anon_sym_LBRACK] = ACTIONS(13499),
    [anon_sym_LF] = ACTIONS(13501),
    [anon_sym_in] = ACTIONS(13499),
    [anon_sym_LBRACE] = ACTIONS(13499),
    [anon_sym_DOLLAR] = ACTIONS(13499),
    [anon_sym_COLON_COLON] = ACTIONS(13499),
    [anon_sym_isa] = ACTIONS(13499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13499),
    [anon_sym_QMARK] = ACTIONS(13499),
    [anon_sym_AT] = ACTIONS(13499),
    [anon_sym_true] = ACTIONS(13499),
    [anon_sym_false] = ACTIONS(13499),
    [aux_sym_integer_literal_token1] = ACTIONS(13499),
    [aux_sym_integer_literal_token2] = ACTIONS(13499),
    [aux_sym_integer_literal_token3] = ACTIONS(13499),
    [aux_sym_integer_literal_token4] = ACTIONS(13499),
    [aux_sym_float_literal_token1] = ACTIONS(13499),
    [aux_sym_float_literal_token3] = ACTIONS(13499),
    [aux_sym_float_literal_token4] = ACTIONS(13499),
    [sym_character_literal] = ACTIONS(13499),
    [sym__pair_operator] = ACTIONS(13499),
    [sym__arrow_operator] = ACTIONS(13499),
    [sym__lazy_or_operator] = ACTIONS(13499),
    [sym__lazy_and_operator] = ACTIONS(13499),
    [sym__comparison_operator] = ACTIONS(13499),
    [sym__pipe_right_operator] = ACTIONS(13499),
    [sym__pipe_left_operator] = ACTIONS(13499),
    [sym__ellipsis_operator] = ACTIONS(13499),
    [sym__plus_operator] = ACTIONS(13499),
    [sym__times_operator] = ACTIONS(13499),
    [sym__rational_operator] = ACTIONS(13499),
    [sym__bitshift_operator] = ACTIONS(13499),
    [sym__power_operator] = ACTIONS(13499),
    [sym__tilde_operator] = ACTIONS(13499),
    [sym__type_order_operator] = ACTIONS(13499),
    [sym__unary_operator] = ACTIONS(13499),
    [sym__unary_plus_operator] = ACTIONS(13499),
    [aux_sym__terminator_token1] = ACTIONS(13499),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13501),
    [sym__command_start] = ACTIONS(13501),
  },
  [8533] = {
    [sym__word_identifier] = ACTIONS(13358),
    [anon_sym_EQ] = ACTIONS(13358),
    [anon_sym_COMMA] = ACTIONS(13360),
    [anon_sym_COLON] = ACTIONS(13358),
    [anon_sym_begin] = ACTIONS(13358),
    [anon_sym_module] = ACTIONS(13358),
    [anon_sym_baremodule] = ACTIONS(13358),
    [anon_sym_abstract] = ACTIONS(13358),
    [anon_sym_primitive] = ACTIONS(13358),
    [anon_sym_mutable] = ACTIONS(13358),
    [anon_sym_struct] = ACTIONS(13358),
    [anon_sym_function] = ACTIONS(13358),
    [anon_sym_macro] = ACTIONS(13358),
    [anon_sym_where] = ACTIONS(13358),
    [anon_sym_quote] = ACTIONS(13358),
    [anon_sym_let] = ACTIONS(13358),
    [anon_sym_if] = ACTIONS(13358),
    [anon_sym_try] = ACTIONS(13358),
    [anon_sym_for] = ACTIONS(13358),
    [anon_sym_while] = ACTIONS(13358),
    [sym_break_statement] = ACTIONS(13358),
    [sym_continue_statement] = ACTIONS(13358),
    [anon_sym_return] = ACTIONS(13358),
    [anon_sym_const] = ACTIONS(13358),
    [anon_sym_global] = ACTIONS(13358),
    [anon_sym_local] = ACTIONS(13358),
    [anon_sym_LPAREN] = ACTIONS(13360),
    [anon_sym_RPAREN] = ACTIONS(13360),
    [anon_sym_COLON2] = ACTIONS(13358),
    [anon_sym_export] = ACTIONS(13358),
    [anon_sym_import] = ACTIONS(13358),
    [anon_sym_using] = ACTIONS(13358),
    [anon_sym_LBRACK] = ACTIONS(13360),
    [anon_sym_RBRACK] = ACTIONS(13360),
    [anon_sym_in] = ACTIONS(13358),
    [anon_sym_SEMI] = ACTIONS(13360),
    [anon_sym_LBRACE] = ACTIONS(13360),
    [anon_sym_RBRACE] = ACTIONS(13360),
    [anon_sym_DOLLAR] = ACTIONS(13360),
    [anon_sym_COLON_COLON] = ACTIONS(13360),
    [anon_sym_isa] = ACTIONS(13358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13360),
    [anon_sym_QMARK] = ACTIONS(13360),
    [anon_sym_AT] = ACTIONS(13360),
    [anon_sym_true] = ACTIONS(13358),
    [anon_sym_false] = ACTIONS(13358),
    [aux_sym_integer_literal_token1] = ACTIONS(13360),
    [aux_sym_integer_literal_token2] = ACTIONS(13360),
    [aux_sym_integer_literal_token3] = ACTIONS(13358),
    [aux_sym_integer_literal_token4] = ACTIONS(13358),
    [aux_sym_float_literal_token1] = ACTIONS(13360),
    [aux_sym_float_literal_token3] = ACTIONS(13360),
    [aux_sym_float_literal_token4] = ACTIONS(13360),
    [sym_character_literal] = ACTIONS(13360),
    [sym__pair_operator] = ACTIONS(13360),
    [sym__arrow_operator] = ACTIONS(13358),
    [sym__lazy_or_operator] = ACTIONS(13360),
    [sym__lazy_and_operator] = ACTIONS(13360),
    [sym__comparison_operator] = ACTIONS(13358),
    [sym__pipe_right_operator] = ACTIONS(13360),
    [sym__pipe_left_operator] = ACTIONS(13360),
    [sym__ellipsis_operator] = ACTIONS(13358),
    [sym__plus_operator] = ACTIONS(13358),
    [sym__times_operator] = ACTIONS(13358),
    [sym__rational_operator] = ACTIONS(13360),
    [sym__bitshift_operator] = ACTIONS(13360),
    [sym__power_operator] = ACTIONS(13360),
    [sym__tilde_operator] = ACTIONS(13360),
    [sym__type_order_operator] = ACTIONS(13360),
    [sym__unary_operator] = ACTIONS(13358),
    [sym__unary_plus_operator] = ACTIONS(13358),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13360),
    [sym__command_start] = ACTIONS(13360),
  },
  [8534] = {
    [sym__word_identifier] = ACTIONS(13506),
    [anon_sym_EQ] = ACTIONS(13506),
    [anon_sym_COMMA] = ACTIONS(13506),
    [anon_sym_COLON] = ACTIONS(13506),
    [anon_sym_begin] = ACTIONS(13506),
    [anon_sym_module] = ACTIONS(13506),
    [anon_sym_baremodule] = ACTIONS(13506),
    [anon_sym_end] = ACTIONS(13506),
    [anon_sym_abstract] = ACTIONS(13506),
    [anon_sym_primitive] = ACTIONS(13506),
    [anon_sym_mutable] = ACTIONS(13506),
    [anon_sym_struct] = ACTIONS(13506),
    [anon_sym_function] = ACTIONS(13506),
    [anon_sym_macro] = ACTIONS(13506),
    [anon_sym_where] = ACTIONS(13506),
    [anon_sym_quote] = ACTIONS(13506),
    [anon_sym_let] = ACTIONS(13506),
    [anon_sym_if] = ACTIONS(13506),
    [anon_sym_try] = ACTIONS(13506),
    [anon_sym_catch] = ACTIONS(13506),
    [anon_sym_for] = ACTIONS(13506),
    [anon_sym_while] = ACTIONS(13506),
    [sym_break_statement] = ACTIONS(13506),
    [sym_continue_statement] = ACTIONS(13506),
    [anon_sym_return] = ACTIONS(13506),
    [anon_sym_const] = ACTIONS(13506),
    [anon_sym_global] = ACTIONS(13506),
    [anon_sym_local] = ACTIONS(13506),
    [anon_sym_LPAREN] = ACTIONS(13506),
    [anon_sym_COLON2] = ACTIONS(13506),
    [anon_sym_export] = ACTIONS(13506),
    [anon_sym_import] = ACTIONS(13506),
    [anon_sym_using] = ACTIONS(13506),
    [anon_sym_LBRACK] = ACTIONS(13506),
    [anon_sym_LF] = ACTIONS(13508),
    [anon_sym_in] = ACTIONS(13506),
    [anon_sym_LBRACE] = ACTIONS(13506),
    [anon_sym_DOLLAR] = ACTIONS(13506),
    [anon_sym_COLON_COLON] = ACTIONS(13506),
    [anon_sym_isa] = ACTIONS(13506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13506),
    [anon_sym_QMARK] = ACTIONS(13506),
    [anon_sym_AT] = ACTIONS(13506),
    [anon_sym_true] = ACTIONS(13506),
    [anon_sym_false] = ACTIONS(13506),
    [aux_sym_integer_literal_token1] = ACTIONS(13506),
    [aux_sym_integer_literal_token2] = ACTIONS(13506),
    [aux_sym_integer_literal_token3] = ACTIONS(13506),
    [aux_sym_integer_literal_token4] = ACTIONS(13506),
    [aux_sym_float_literal_token1] = ACTIONS(13506),
    [aux_sym_float_literal_token3] = ACTIONS(13506),
    [aux_sym_float_literal_token4] = ACTIONS(13506),
    [sym_character_literal] = ACTIONS(13506),
    [sym__pair_operator] = ACTIONS(13506),
    [sym__arrow_operator] = ACTIONS(13506),
    [sym__lazy_or_operator] = ACTIONS(13506),
    [sym__lazy_and_operator] = ACTIONS(13506),
    [sym__comparison_operator] = ACTIONS(13506),
    [sym__pipe_right_operator] = ACTIONS(13506),
    [sym__pipe_left_operator] = ACTIONS(13506),
    [sym__ellipsis_operator] = ACTIONS(13506),
    [sym__plus_operator] = ACTIONS(13506),
    [sym__times_operator] = ACTIONS(13506),
    [sym__rational_operator] = ACTIONS(13506),
    [sym__bitshift_operator] = ACTIONS(13506),
    [sym__power_operator] = ACTIONS(13506),
    [sym__tilde_operator] = ACTIONS(13506),
    [sym__type_order_operator] = ACTIONS(13506),
    [sym__unary_operator] = ACTIONS(13506),
    [sym__unary_plus_operator] = ACTIONS(13506),
    [aux_sym__terminator_token1] = ACTIONS(13506),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13508),
    [sym__command_start] = ACTIONS(13508),
  },
  [8535] = {
    [sym__word_identifier] = ACTIONS(13510),
    [anon_sym_EQ] = ACTIONS(13510),
    [anon_sym_COMMA] = ACTIONS(13510),
    [anon_sym_COLON] = ACTIONS(13510),
    [anon_sym_begin] = ACTIONS(13510),
    [anon_sym_module] = ACTIONS(13510),
    [anon_sym_baremodule] = ACTIONS(13510),
    [anon_sym_end] = ACTIONS(13510),
    [anon_sym_abstract] = ACTIONS(13510),
    [anon_sym_primitive] = ACTIONS(13510),
    [anon_sym_mutable] = ACTIONS(13510),
    [anon_sym_struct] = ACTIONS(13510),
    [anon_sym_function] = ACTIONS(13510),
    [anon_sym_macro] = ACTIONS(13510),
    [anon_sym_where] = ACTIONS(13510),
    [anon_sym_quote] = ACTIONS(13510),
    [anon_sym_let] = ACTIONS(13510),
    [anon_sym_if] = ACTIONS(13510),
    [anon_sym_try] = ACTIONS(13510),
    [anon_sym_catch] = ACTIONS(13510),
    [anon_sym_for] = ACTIONS(13510),
    [anon_sym_while] = ACTIONS(13510),
    [sym_break_statement] = ACTIONS(13510),
    [sym_continue_statement] = ACTIONS(13510),
    [anon_sym_return] = ACTIONS(13510),
    [anon_sym_const] = ACTIONS(13510),
    [anon_sym_global] = ACTIONS(13510),
    [anon_sym_local] = ACTIONS(13510),
    [anon_sym_LPAREN] = ACTIONS(13510),
    [anon_sym_COLON2] = ACTIONS(13510),
    [anon_sym_export] = ACTIONS(13510),
    [anon_sym_import] = ACTIONS(13510),
    [anon_sym_using] = ACTIONS(13510),
    [anon_sym_LBRACK] = ACTIONS(13510),
    [anon_sym_LF] = ACTIONS(13512),
    [anon_sym_in] = ACTIONS(13510),
    [anon_sym_LBRACE] = ACTIONS(13510),
    [anon_sym_DOLLAR] = ACTIONS(13510),
    [anon_sym_COLON_COLON] = ACTIONS(13510),
    [anon_sym_isa] = ACTIONS(13510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13510),
    [anon_sym_QMARK] = ACTIONS(13510),
    [anon_sym_AT] = ACTIONS(13510),
    [anon_sym_true] = ACTIONS(13510),
    [anon_sym_false] = ACTIONS(13510),
    [aux_sym_integer_literal_token1] = ACTIONS(13510),
    [aux_sym_integer_literal_token2] = ACTIONS(13510),
    [aux_sym_integer_literal_token3] = ACTIONS(13510),
    [aux_sym_integer_literal_token4] = ACTIONS(13510),
    [aux_sym_float_literal_token1] = ACTIONS(13510),
    [aux_sym_float_literal_token3] = ACTIONS(13510),
    [aux_sym_float_literal_token4] = ACTIONS(13510),
    [sym_character_literal] = ACTIONS(13510),
    [sym__pair_operator] = ACTIONS(13510),
    [sym__arrow_operator] = ACTIONS(13510),
    [sym__lazy_or_operator] = ACTIONS(13510),
    [sym__lazy_and_operator] = ACTIONS(13510),
    [sym__comparison_operator] = ACTIONS(13510),
    [sym__pipe_right_operator] = ACTIONS(13510),
    [sym__pipe_left_operator] = ACTIONS(13510),
    [sym__ellipsis_operator] = ACTIONS(13510),
    [sym__plus_operator] = ACTIONS(13510),
    [sym__times_operator] = ACTIONS(13510),
    [sym__rational_operator] = ACTIONS(13510),
    [sym__bitshift_operator] = ACTIONS(13510),
    [sym__power_operator] = ACTIONS(13510),
    [sym__tilde_operator] = ACTIONS(13510),
    [sym__type_order_operator] = ACTIONS(13510),
    [sym__unary_operator] = ACTIONS(13510),
    [sym__unary_plus_operator] = ACTIONS(13510),
    [aux_sym__terminator_token1] = ACTIONS(13510),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13512),
    [sym__command_start] = ACTIONS(13512),
  },
  [8536] = {
    [sym__word_identifier] = ACTIONS(13362),
    [anon_sym_EQ] = ACTIONS(13362),
    [anon_sym_COMMA] = ACTIONS(13364),
    [anon_sym_COLON] = ACTIONS(13362),
    [anon_sym_begin] = ACTIONS(13362),
    [anon_sym_module] = ACTIONS(13362),
    [anon_sym_baremodule] = ACTIONS(13362),
    [anon_sym_abstract] = ACTIONS(13362),
    [anon_sym_primitive] = ACTIONS(13362),
    [anon_sym_mutable] = ACTIONS(13362),
    [anon_sym_struct] = ACTIONS(13362),
    [anon_sym_function] = ACTIONS(13362),
    [anon_sym_macro] = ACTIONS(13362),
    [anon_sym_where] = ACTIONS(13362),
    [anon_sym_quote] = ACTIONS(13362),
    [anon_sym_let] = ACTIONS(13362),
    [anon_sym_if] = ACTIONS(13362),
    [anon_sym_try] = ACTIONS(13362),
    [anon_sym_for] = ACTIONS(13362),
    [anon_sym_while] = ACTIONS(13362),
    [sym_break_statement] = ACTIONS(13362),
    [sym_continue_statement] = ACTIONS(13362),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_const] = ACTIONS(13362),
    [anon_sym_global] = ACTIONS(13362),
    [anon_sym_local] = ACTIONS(13362),
    [anon_sym_LPAREN] = ACTIONS(13364),
    [anon_sym_RPAREN] = ACTIONS(13364),
    [anon_sym_COLON2] = ACTIONS(13362),
    [anon_sym_export] = ACTIONS(13362),
    [anon_sym_import] = ACTIONS(13362),
    [anon_sym_using] = ACTIONS(13362),
    [anon_sym_LBRACK] = ACTIONS(13364),
    [anon_sym_RBRACK] = ACTIONS(13364),
    [anon_sym_in] = ACTIONS(13362),
    [anon_sym_SEMI] = ACTIONS(13364),
    [anon_sym_LBRACE] = ACTIONS(13364),
    [anon_sym_RBRACE] = ACTIONS(13364),
    [anon_sym_DOLLAR] = ACTIONS(13364),
    [anon_sym_COLON_COLON] = ACTIONS(13364),
    [anon_sym_isa] = ACTIONS(13362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13364),
    [anon_sym_QMARK] = ACTIONS(13364),
    [anon_sym_AT] = ACTIONS(13364),
    [anon_sym_true] = ACTIONS(13362),
    [anon_sym_false] = ACTIONS(13362),
    [aux_sym_integer_literal_token1] = ACTIONS(13364),
    [aux_sym_integer_literal_token2] = ACTIONS(13364),
    [aux_sym_integer_literal_token3] = ACTIONS(13362),
    [aux_sym_integer_literal_token4] = ACTIONS(13362),
    [aux_sym_float_literal_token1] = ACTIONS(13364),
    [aux_sym_float_literal_token3] = ACTIONS(13364),
    [aux_sym_float_literal_token4] = ACTIONS(13364),
    [sym_character_literal] = ACTIONS(13364),
    [sym__pair_operator] = ACTIONS(13364),
    [sym__arrow_operator] = ACTIONS(13362),
    [sym__lazy_or_operator] = ACTIONS(13364),
    [sym__lazy_and_operator] = ACTIONS(13364),
    [sym__comparison_operator] = ACTIONS(13362),
    [sym__pipe_right_operator] = ACTIONS(13364),
    [sym__pipe_left_operator] = ACTIONS(13364),
    [sym__ellipsis_operator] = ACTIONS(13362),
    [sym__plus_operator] = ACTIONS(13362),
    [sym__times_operator] = ACTIONS(13362),
    [sym__rational_operator] = ACTIONS(13364),
    [sym__bitshift_operator] = ACTIONS(13364),
    [sym__power_operator] = ACTIONS(13364),
    [sym__tilde_operator] = ACTIONS(13364),
    [sym__type_order_operator] = ACTIONS(13364),
    [sym__unary_operator] = ACTIONS(13362),
    [sym__unary_plus_operator] = ACTIONS(13362),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13364),
    [sym__command_start] = ACTIONS(13364),
  },
  [8537] = {
    [sym__word_identifier] = ACTIONS(13366),
    [anon_sym_EQ] = ACTIONS(13366),
    [anon_sym_COMMA] = ACTIONS(13368),
    [anon_sym_COLON] = ACTIONS(13366),
    [anon_sym_begin] = ACTIONS(13366),
    [anon_sym_module] = ACTIONS(13366),
    [anon_sym_baremodule] = ACTIONS(13366),
    [anon_sym_abstract] = ACTIONS(13366),
    [anon_sym_primitive] = ACTIONS(13366),
    [anon_sym_mutable] = ACTIONS(13366),
    [anon_sym_struct] = ACTIONS(13366),
    [anon_sym_function] = ACTIONS(13366),
    [anon_sym_macro] = ACTIONS(13366),
    [anon_sym_where] = ACTIONS(13366),
    [anon_sym_quote] = ACTIONS(13366),
    [anon_sym_let] = ACTIONS(13366),
    [anon_sym_if] = ACTIONS(13366),
    [anon_sym_try] = ACTIONS(13366),
    [anon_sym_for] = ACTIONS(13366),
    [anon_sym_while] = ACTIONS(13366),
    [sym_break_statement] = ACTIONS(13366),
    [sym_continue_statement] = ACTIONS(13366),
    [anon_sym_return] = ACTIONS(13366),
    [anon_sym_const] = ACTIONS(13366),
    [anon_sym_global] = ACTIONS(13366),
    [anon_sym_local] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(13368),
    [anon_sym_RPAREN] = ACTIONS(13368),
    [anon_sym_COLON2] = ACTIONS(13366),
    [anon_sym_export] = ACTIONS(13366),
    [anon_sym_import] = ACTIONS(13366),
    [anon_sym_using] = ACTIONS(13366),
    [anon_sym_LBRACK] = ACTIONS(13368),
    [anon_sym_RBRACK] = ACTIONS(13368),
    [anon_sym_in] = ACTIONS(13366),
    [anon_sym_SEMI] = ACTIONS(13368),
    [anon_sym_LBRACE] = ACTIONS(13368),
    [anon_sym_RBRACE] = ACTIONS(13368),
    [anon_sym_DOLLAR] = ACTIONS(13368),
    [anon_sym_COLON_COLON] = ACTIONS(13368),
    [anon_sym_isa] = ACTIONS(13366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13368),
    [anon_sym_QMARK] = ACTIONS(13368),
    [anon_sym_AT] = ACTIONS(13368),
    [anon_sym_true] = ACTIONS(13366),
    [anon_sym_false] = ACTIONS(13366),
    [aux_sym_integer_literal_token1] = ACTIONS(13368),
    [aux_sym_integer_literal_token2] = ACTIONS(13368),
    [aux_sym_integer_literal_token3] = ACTIONS(13366),
    [aux_sym_integer_literal_token4] = ACTIONS(13366),
    [aux_sym_float_literal_token1] = ACTIONS(13368),
    [aux_sym_float_literal_token3] = ACTIONS(13368),
    [aux_sym_float_literal_token4] = ACTIONS(13368),
    [sym_character_literal] = ACTIONS(13368),
    [sym__pair_operator] = ACTIONS(13368),
    [sym__arrow_operator] = ACTIONS(13366),
    [sym__lazy_or_operator] = ACTIONS(13368),
    [sym__lazy_and_operator] = ACTIONS(13368),
    [sym__comparison_operator] = ACTIONS(13366),
    [sym__pipe_right_operator] = ACTIONS(13368),
    [sym__pipe_left_operator] = ACTIONS(13368),
    [sym__ellipsis_operator] = ACTIONS(13366),
    [sym__plus_operator] = ACTIONS(13366),
    [sym__times_operator] = ACTIONS(13366),
    [sym__rational_operator] = ACTIONS(13368),
    [sym__bitshift_operator] = ACTIONS(13368),
    [sym__power_operator] = ACTIONS(13368),
    [sym__tilde_operator] = ACTIONS(13368),
    [sym__type_order_operator] = ACTIONS(13368),
    [sym__unary_operator] = ACTIONS(13366),
    [sym__unary_plus_operator] = ACTIONS(13366),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13368),
    [sym__command_start] = ACTIONS(13368),
  },
  [8538] = {
    [sym__word_identifier] = ACTIONS(13370),
    [anon_sym_EQ] = ACTIONS(13370),
    [anon_sym_COMMA] = ACTIONS(13372),
    [anon_sym_COLON] = ACTIONS(13370),
    [anon_sym_begin] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(13370),
    [anon_sym_baremodule] = ACTIONS(13370),
    [anon_sym_abstract] = ACTIONS(13370),
    [anon_sym_primitive] = ACTIONS(13370),
    [anon_sym_mutable] = ACTIONS(13370),
    [anon_sym_struct] = ACTIONS(13370),
    [anon_sym_function] = ACTIONS(13370),
    [anon_sym_macro] = ACTIONS(13370),
    [anon_sym_where] = ACTIONS(13370),
    [anon_sym_quote] = ACTIONS(13370),
    [anon_sym_let] = ACTIONS(13370),
    [anon_sym_if] = ACTIONS(13370),
    [anon_sym_try] = ACTIONS(13370),
    [anon_sym_for] = ACTIONS(13370),
    [anon_sym_while] = ACTIONS(13370),
    [sym_break_statement] = ACTIONS(13370),
    [sym_continue_statement] = ACTIONS(13370),
    [anon_sym_return] = ACTIONS(13370),
    [anon_sym_const] = ACTIONS(13370),
    [anon_sym_global] = ACTIONS(13370),
    [anon_sym_local] = ACTIONS(13370),
    [anon_sym_LPAREN] = ACTIONS(13372),
    [anon_sym_RPAREN] = ACTIONS(13372),
    [anon_sym_COLON2] = ACTIONS(13370),
    [anon_sym_export] = ACTIONS(13370),
    [anon_sym_import] = ACTIONS(13370),
    [anon_sym_using] = ACTIONS(13370),
    [anon_sym_LBRACK] = ACTIONS(13372),
    [anon_sym_RBRACK] = ACTIONS(13372),
    [anon_sym_in] = ACTIONS(13370),
    [anon_sym_SEMI] = ACTIONS(13372),
    [anon_sym_LBRACE] = ACTIONS(13372),
    [anon_sym_RBRACE] = ACTIONS(13372),
    [anon_sym_DOLLAR] = ACTIONS(13372),
    [anon_sym_COLON_COLON] = ACTIONS(13372),
    [anon_sym_isa] = ACTIONS(13370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13372),
    [anon_sym_QMARK] = ACTIONS(13372),
    [anon_sym_AT] = ACTIONS(13372),
    [anon_sym_true] = ACTIONS(13370),
    [anon_sym_false] = ACTIONS(13370),
    [aux_sym_integer_literal_token1] = ACTIONS(13372),
    [aux_sym_integer_literal_token2] = ACTIONS(13372),
    [aux_sym_integer_literal_token3] = ACTIONS(13370),
    [aux_sym_integer_literal_token4] = ACTIONS(13370),
    [aux_sym_float_literal_token1] = ACTIONS(13372),
    [aux_sym_float_literal_token3] = ACTIONS(13372),
    [aux_sym_float_literal_token4] = ACTIONS(13372),
    [sym_character_literal] = ACTIONS(13372),
    [sym__pair_operator] = ACTIONS(13372),
    [sym__arrow_operator] = ACTIONS(13370),
    [sym__lazy_or_operator] = ACTIONS(13372),
    [sym__lazy_and_operator] = ACTIONS(13372),
    [sym__comparison_operator] = ACTIONS(13370),
    [sym__pipe_right_operator] = ACTIONS(13372),
    [sym__pipe_left_operator] = ACTIONS(13372),
    [sym__ellipsis_operator] = ACTIONS(13370),
    [sym__plus_operator] = ACTIONS(13370),
    [sym__times_operator] = ACTIONS(13370),
    [sym__rational_operator] = ACTIONS(13372),
    [sym__bitshift_operator] = ACTIONS(13372),
    [sym__power_operator] = ACTIONS(13372),
    [sym__tilde_operator] = ACTIONS(13372),
    [sym__type_order_operator] = ACTIONS(13372),
    [sym__unary_operator] = ACTIONS(13370),
    [sym__unary_plus_operator] = ACTIONS(13370),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13372),
    [sym__command_start] = ACTIONS(13372),
  },
  [8539] = {
    [aux_sym_open_tuple_repeat1] = STATE(7376),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13394),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_catch] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14612),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8540] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_EQ] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_catch] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [8541] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_EQ] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_catch] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [8542] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8543] = {
    [sym__word_identifier] = ACTIONS(13514),
    [anon_sym_EQ] = ACTIONS(13514),
    [anon_sym_COMMA] = ACTIONS(13514),
    [anon_sym_COLON] = ACTIONS(13514),
    [anon_sym_begin] = ACTIONS(13514),
    [anon_sym_module] = ACTIONS(13514),
    [anon_sym_baremodule] = ACTIONS(13514),
    [anon_sym_end] = ACTIONS(13514),
    [anon_sym_abstract] = ACTIONS(13514),
    [anon_sym_primitive] = ACTIONS(13514),
    [anon_sym_mutable] = ACTIONS(13514),
    [anon_sym_struct] = ACTIONS(13514),
    [anon_sym_function] = ACTIONS(13514),
    [anon_sym_macro] = ACTIONS(13514),
    [anon_sym_where] = ACTIONS(13514),
    [anon_sym_quote] = ACTIONS(13514),
    [anon_sym_let] = ACTIONS(13514),
    [anon_sym_if] = ACTIONS(13514),
    [anon_sym_try] = ACTIONS(13514),
    [anon_sym_catch] = ACTIONS(13514),
    [anon_sym_for] = ACTIONS(13514),
    [anon_sym_while] = ACTIONS(13514),
    [sym_break_statement] = ACTIONS(13514),
    [sym_continue_statement] = ACTIONS(13514),
    [anon_sym_return] = ACTIONS(13514),
    [anon_sym_const] = ACTIONS(13514),
    [anon_sym_global] = ACTIONS(13514),
    [anon_sym_local] = ACTIONS(13514),
    [anon_sym_LPAREN] = ACTIONS(13514),
    [anon_sym_COLON2] = ACTIONS(13514),
    [anon_sym_export] = ACTIONS(13514),
    [anon_sym_import] = ACTIONS(13514),
    [anon_sym_using] = ACTIONS(13514),
    [anon_sym_LBRACK] = ACTIONS(13514),
    [anon_sym_LF] = ACTIONS(13516),
    [anon_sym_in] = ACTIONS(13514),
    [anon_sym_LBRACE] = ACTIONS(13514),
    [anon_sym_DOLLAR] = ACTIONS(13514),
    [anon_sym_COLON_COLON] = ACTIONS(13514),
    [anon_sym_isa] = ACTIONS(13514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13514),
    [anon_sym_QMARK] = ACTIONS(13514),
    [anon_sym_AT] = ACTIONS(13514),
    [anon_sym_true] = ACTIONS(13514),
    [anon_sym_false] = ACTIONS(13514),
    [aux_sym_integer_literal_token1] = ACTIONS(13514),
    [aux_sym_integer_literal_token2] = ACTIONS(13514),
    [aux_sym_integer_literal_token3] = ACTIONS(13514),
    [aux_sym_integer_literal_token4] = ACTIONS(13514),
    [aux_sym_float_literal_token1] = ACTIONS(13514),
    [aux_sym_float_literal_token3] = ACTIONS(13514),
    [aux_sym_float_literal_token4] = ACTIONS(13514),
    [sym_character_literal] = ACTIONS(13514),
    [sym__pair_operator] = ACTIONS(13514),
    [sym__arrow_operator] = ACTIONS(13514),
    [sym__lazy_or_operator] = ACTIONS(13514),
    [sym__lazy_and_operator] = ACTIONS(13514),
    [sym__comparison_operator] = ACTIONS(13514),
    [sym__pipe_right_operator] = ACTIONS(13514),
    [sym__pipe_left_operator] = ACTIONS(13514),
    [sym__ellipsis_operator] = ACTIONS(13514),
    [sym__plus_operator] = ACTIONS(13514),
    [sym__times_operator] = ACTIONS(13514),
    [sym__rational_operator] = ACTIONS(13514),
    [sym__bitshift_operator] = ACTIONS(13514),
    [sym__power_operator] = ACTIONS(13514),
    [sym__tilde_operator] = ACTIONS(13514),
    [sym__type_order_operator] = ACTIONS(13514),
    [sym__unary_operator] = ACTIONS(13514),
    [sym__unary_plus_operator] = ACTIONS(13514),
    [aux_sym__terminator_token1] = ACTIONS(13514),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13516),
    [sym__command_start] = ACTIONS(13516),
  },
  [8544] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14455),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14457),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8545] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14459),
    [sym__lazy_or_operator] = ACTIONS(14461),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8546] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14463),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8547] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14445),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14449),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14449),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14449),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8548] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8549] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14447),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14465),
    [sym__pipe_left_operator] = ACTIONS(14467),
    [sym__ellipsis_operator] = ACTIONS(14469),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8550] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14471),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14471),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8551] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14473),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8552] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14475),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8553] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14477),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8554] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14479),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8555] = {
    [sym__word_identifier] = ACTIONS(13518),
    [anon_sym_EQ] = ACTIONS(13518),
    [anon_sym_COMMA] = ACTIONS(13518),
    [anon_sym_COLON] = ACTIONS(13518),
    [anon_sym_begin] = ACTIONS(13518),
    [anon_sym_module] = ACTIONS(13518),
    [anon_sym_baremodule] = ACTIONS(13518),
    [anon_sym_end] = ACTIONS(13518),
    [anon_sym_abstract] = ACTIONS(13518),
    [anon_sym_primitive] = ACTIONS(13518),
    [anon_sym_mutable] = ACTIONS(13518),
    [anon_sym_struct] = ACTIONS(13518),
    [anon_sym_function] = ACTIONS(13518),
    [anon_sym_macro] = ACTIONS(13518),
    [anon_sym_where] = ACTIONS(13518),
    [anon_sym_quote] = ACTIONS(13518),
    [anon_sym_let] = ACTIONS(13518),
    [anon_sym_if] = ACTIONS(13518),
    [anon_sym_try] = ACTIONS(13518),
    [anon_sym_catch] = ACTIONS(13518),
    [anon_sym_for] = ACTIONS(13518),
    [anon_sym_while] = ACTIONS(13518),
    [sym_break_statement] = ACTIONS(13518),
    [sym_continue_statement] = ACTIONS(13518),
    [anon_sym_return] = ACTIONS(13518),
    [anon_sym_const] = ACTIONS(13518),
    [anon_sym_global] = ACTIONS(13518),
    [anon_sym_local] = ACTIONS(13518),
    [anon_sym_LPAREN] = ACTIONS(13518),
    [anon_sym_COLON2] = ACTIONS(13518),
    [anon_sym_export] = ACTIONS(13518),
    [anon_sym_import] = ACTIONS(13518),
    [anon_sym_using] = ACTIONS(13518),
    [anon_sym_LBRACK] = ACTIONS(13518),
    [anon_sym_LF] = ACTIONS(13520),
    [anon_sym_in] = ACTIONS(13518),
    [anon_sym_LBRACE] = ACTIONS(13518),
    [anon_sym_DOLLAR] = ACTIONS(13518),
    [anon_sym_COLON_COLON] = ACTIONS(13518),
    [anon_sym_isa] = ACTIONS(13518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13518),
    [anon_sym_QMARK] = ACTIONS(13518),
    [anon_sym_AT] = ACTIONS(13518),
    [anon_sym_true] = ACTIONS(13518),
    [anon_sym_false] = ACTIONS(13518),
    [aux_sym_integer_literal_token1] = ACTIONS(13518),
    [aux_sym_integer_literal_token2] = ACTIONS(13518),
    [aux_sym_integer_literal_token3] = ACTIONS(13518),
    [aux_sym_integer_literal_token4] = ACTIONS(13518),
    [aux_sym_float_literal_token1] = ACTIONS(13518),
    [aux_sym_float_literal_token3] = ACTIONS(13518),
    [aux_sym_float_literal_token4] = ACTIONS(13518),
    [sym_character_literal] = ACTIONS(13518),
    [sym__pair_operator] = ACTIONS(13518),
    [sym__arrow_operator] = ACTIONS(13518),
    [sym__lazy_or_operator] = ACTIONS(13518),
    [sym__lazy_and_operator] = ACTIONS(13518),
    [sym__comparison_operator] = ACTIONS(13518),
    [sym__pipe_right_operator] = ACTIONS(13518),
    [sym__pipe_left_operator] = ACTIONS(13518),
    [sym__ellipsis_operator] = ACTIONS(13518),
    [sym__plus_operator] = ACTIONS(13518),
    [sym__times_operator] = ACTIONS(13518),
    [sym__rational_operator] = ACTIONS(13518),
    [sym__bitshift_operator] = ACTIONS(13518),
    [sym__power_operator] = ACTIONS(13518),
    [sym__tilde_operator] = ACTIONS(13518),
    [sym__type_order_operator] = ACTIONS(13518),
    [sym__unary_operator] = ACTIONS(13518),
    [sym__unary_plus_operator] = ACTIONS(13518),
    [aux_sym__terminator_token1] = ACTIONS(13518),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13520),
    [sym__command_start] = ACTIONS(13520),
  },
  [8556] = {
    [sym__word_identifier] = ACTIONS(13257),
    [anon_sym_EQ] = ACTIONS(13257),
    [anon_sym_COMMA] = ACTIONS(13257),
    [anon_sym_COLON] = ACTIONS(13257),
    [anon_sym_begin] = ACTIONS(13257),
    [anon_sym_module] = ACTIONS(13257),
    [anon_sym_baremodule] = ACTIONS(13257),
    [anon_sym_end] = ACTIONS(13257),
    [anon_sym_abstract] = ACTIONS(13257),
    [anon_sym_primitive] = ACTIONS(13257),
    [anon_sym_mutable] = ACTIONS(13257),
    [anon_sym_struct] = ACTIONS(13257),
    [anon_sym_function] = ACTIONS(13257),
    [anon_sym_macro] = ACTIONS(13257),
    [anon_sym_where] = ACTIONS(13257),
    [anon_sym_quote] = ACTIONS(13257),
    [anon_sym_let] = ACTIONS(13257),
    [anon_sym_if] = ACTIONS(13257),
    [anon_sym_try] = ACTIONS(13257),
    [anon_sym_catch] = ACTIONS(13257),
    [anon_sym_for] = ACTIONS(13257),
    [anon_sym_while] = ACTIONS(13257),
    [sym_break_statement] = ACTIONS(13257),
    [sym_continue_statement] = ACTIONS(13257),
    [anon_sym_return] = ACTIONS(13257),
    [anon_sym_const] = ACTIONS(13257),
    [anon_sym_global] = ACTIONS(13257),
    [anon_sym_local] = ACTIONS(13257),
    [anon_sym_LPAREN] = ACTIONS(13257),
    [anon_sym_COLON2] = ACTIONS(13257),
    [anon_sym_export] = ACTIONS(13257),
    [anon_sym_import] = ACTIONS(13257),
    [anon_sym_using] = ACTIONS(13257),
    [anon_sym_LBRACK] = ACTIONS(13257),
    [anon_sym_LF] = ACTIONS(13259),
    [anon_sym_in] = ACTIONS(13257),
    [anon_sym_LBRACE] = ACTIONS(13257),
    [anon_sym_DOLLAR] = ACTIONS(13257),
    [anon_sym_COLON_COLON] = ACTIONS(13257),
    [anon_sym_isa] = ACTIONS(13257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13257),
    [anon_sym_QMARK] = ACTIONS(13257),
    [anon_sym_AT] = ACTIONS(13257),
    [anon_sym_true] = ACTIONS(13257),
    [anon_sym_false] = ACTIONS(13257),
    [aux_sym_integer_literal_token1] = ACTIONS(13257),
    [aux_sym_integer_literal_token2] = ACTIONS(13257),
    [aux_sym_integer_literal_token3] = ACTIONS(13257),
    [aux_sym_integer_literal_token4] = ACTIONS(13257),
    [aux_sym_float_literal_token1] = ACTIONS(13257),
    [aux_sym_float_literal_token3] = ACTIONS(13257),
    [aux_sym_float_literal_token4] = ACTIONS(13257),
    [sym_character_literal] = ACTIONS(13257),
    [sym__pair_operator] = ACTIONS(13257),
    [sym__arrow_operator] = ACTIONS(13257),
    [sym__lazy_or_operator] = ACTIONS(13257),
    [sym__lazy_and_operator] = ACTIONS(13257),
    [sym__comparison_operator] = ACTIONS(13257),
    [sym__pipe_right_operator] = ACTIONS(13257),
    [sym__pipe_left_operator] = ACTIONS(13257),
    [sym__ellipsis_operator] = ACTIONS(13257),
    [sym__plus_operator] = ACTIONS(13257),
    [sym__times_operator] = ACTIONS(13257),
    [sym__rational_operator] = ACTIONS(13257),
    [sym__bitshift_operator] = ACTIONS(13257),
    [sym__power_operator] = ACTIONS(13257),
    [sym__tilde_operator] = ACTIONS(13257),
    [sym__type_order_operator] = ACTIONS(13257),
    [sym__unary_operator] = ACTIONS(13257),
    [sym__unary_plus_operator] = ACTIONS(13257),
    [aux_sym__terminator_token1] = ACTIONS(13257),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13259),
    [sym__command_start] = ACTIONS(13259),
  },
  [8557] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_catch] = ACTIONS(13255),
    [anon_sym_finally] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(14421),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8558] = {
    [sym__word_identifier] = ACTIONS(13374),
    [anon_sym_EQ] = ACTIONS(13374),
    [anon_sym_COMMA] = ACTIONS(13376),
    [anon_sym_COLON] = ACTIONS(13374),
    [anon_sym_begin] = ACTIONS(13374),
    [anon_sym_module] = ACTIONS(13374),
    [anon_sym_baremodule] = ACTIONS(13374),
    [anon_sym_abstract] = ACTIONS(13374),
    [anon_sym_primitive] = ACTIONS(13374),
    [anon_sym_mutable] = ACTIONS(13374),
    [anon_sym_struct] = ACTIONS(13374),
    [anon_sym_function] = ACTIONS(13374),
    [anon_sym_macro] = ACTIONS(13374),
    [anon_sym_where] = ACTIONS(13374),
    [anon_sym_quote] = ACTIONS(13374),
    [anon_sym_let] = ACTIONS(13374),
    [anon_sym_if] = ACTIONS(13374),
    [anon_sym_try] = ACTIONS(13374),
    [anon_sym_for] = ACTIONS(13374),
    [anon_sym_while] = ACTIONS(13374),
    [sym_break_statement] = ACTIONS(13374),
    [sym_continue_statement] = ACTIONS(13374),
    [anon_sym_return] = ACTIONS(13374),
    [anon_sym_const] = ACTIONS(13374),
    [anon_sym_global] = ACTIONS(13374),
    [anon_sym_local] = ACTIONS(13374),
    [anon_sym_LPAREN] = ACTIONS(13376),
    [anon_sym_RPAREN] = ACTIONS(13376),
    [anon_sym_COLON2] = ACTIONS(13374),
    [anon_sym_export] = ACTIONS(13374),
    [anon_sym_import] = ACTIONS(13374),
    [anon_sym_using] = ACTIONS(13374),
    [anon_sym_LBRACK] = ACTIONS(13376),
    [anon_sym_RBRACK] = ACTIONS(13376),
    [anon_sym_in] = ACTIONS(13374),
    [anon_sym_SEMI] = ACTIONS(13376),
    [anon_sym_LBRACE] = ACTIONS(13376),
    [anon_sym_RBRACE] = ACTIONS(13376),
    [anon_sym_DOLLAR] = ACTIONS(13376),
    [anon_sym_COLON_COLON] = ACTIONS(13376),
    [anon_sym_isa] = ACTIONS(13374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13376),
    [anon_sym_QMARK] = ACTIONS(13376),
    [anon_sym_AT] = ACTIONS(13376),
    [anon_sym_true] = ACTIONS(13374),
    [anon_sym_false] = ACTIONS(13374),
    [aux_sym_integer_literal_token1] = ACTIONS(13376),
    [aux_sym_integer_literal_token2] = ACTIONS(13376),
    [aux_sym_integer_literal_token3] = ACTIONS(13374),
    [aux_sym_integer_literal_token4] = ACTIONS(13374),
    [aux_sym_float_literal_token1] = ACTIONS(13376),
    [aux_sym_float_literal_token3] = ACTIONS(13376),
    [aux_sym_float_literal_token4] = ACTIONS(13376),
    [sym_character_literal] = ACTIONS(13376),
    [sym__pair_operator] = ACTIONS(13376),
    [sym__arrow_operator] = ACTIONS(13374),
    [sym__lazy_or_operator] = ACTIONS(13376),
    [sym__lazy_and_operator] = ACTIONS(13376),
    [sym__comparison_operator] = ACTIONS(13374),
    [sym__pipe_right_operator] = ACTIONS(13376),
    [sym__pipe_left_operator] = ACTIONS(13376),
    [sym__ellipsis_operator] = ACTIONS(13374),
    [sym__plus_operator] = ACTIONS(13374),
    [sym__times_operator] = ACTIONS(13374),
    [sym__rational_operator] = ACTIONS(13376),
    [sym__bitshift_operator] = ACTIONS(13376),
    [sym__power_operator] = ACTIONS(13376),
    [sym__tilde_operator] = ACTIONS(13376),
    [sym__type_order_operator] = ACTIONS(13376),
    [sym__unary_operator] = ACTIONS(13374),
    [sym__unary_plus_operator] = ACTIONS(13374),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13376),
    [sym__command_start] = ACTIONS(13376),
  },
  [8559] = {
    [sym__word_identifier] = ACTIONS(13522),
    [anon_sym_EQ] = ACTIONS(13522),
    [anon_sym_COMMA] = ACTIONS(13522),
    [anon_sym_COLON] = ACTIONS(13522),
    [anon_sym_begin] = ACTIONS(13522),
    [anon_sym_module] = ACTIONS(13522),
    [anon_sym_baremodule] = ACTIONS(13522),
    [anon_sym_end] = ACTIONS(13522),
    [anon_sym_abstract] = ACTIONS(13522),
    [anon_sym_primitive] = ACTIONS(13522),
    [anon_sym_mutable] = ACTIONS(13522),
    [anon_sym_struct] = ACTIONS(13522),
    [anon_sym_function] = ACTIONS(13522),
    [anon_sym_macro] = ACTIONS(13522),
    [anon_sym_where] = ACTIONS(13522),
    [anon_sym_quote] = ACTIONS(13522),
    [anon_sym_let] = ACTIONS(13522),
    [anon_sym_if] = ACTIONS(13522),
    [anon_sym_try] = ACTIONS(13522),
    [anon_sym_catch] = ACTIONS(13522),
    [anon_sym_for] = ACTIONS(13522),
    [anon_sym_while] = ACTIONS(13522),
    [sym_break_statement] = ACTIONS(13522),
    [sym_continue_statement] = ACTIONS(13522),
    [anon_sym_return] = ACTIONS(13522),
    [anon_sym_const] = ACTIONS(13522),
    [anon_sym_global] = ACTIONS(13522),
    [anon_sym_local] = ACTIONS(13522),
    [anon_sym_LPAREN] = ACTIONS(13522),
    [anon_sym_COLON2] = ACTIONS(13522),
    [anon_sym_export] = ACTIONS(13522),
    [anon_sym_import] = ACTIONS(13522),
    [anon_sym_using] = ACTIONS(13522),
    [anon_sym_LBRACK] = ACTIONS(13522),
    [anon_sym_LF] = ACTIONS(13524),
    [anon_sym_in] = ACTIONS(13522),
    [anon_sym_LBRACE] = ACTIONS(13522),
    [anon_sym_DOLLAR] = ACTIONS(13522),
    [anon_sym_COLON_COLON] = ACTIONS(13522),
    [anon_sym_isa] = ACTIONS(13522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13522),
    [anon_sym_QMARK] = ACTIONS(13522),
    [anon_sym_AT] = ACTIONS(13522),
    [anon_sym_true] = ACTIONS(13522),
    [anon_sym_false] = ACTIONS(13522),
    [aux_sym_integer_literal_token1] = ACTIONS(13522),
    [aux_sym_integer_literal_token2] = ACTIONS(13522),
    [aux_sym_integer_literal_token3] = ACTIONS(13522),
    [aux_sym_integer_literal_token4] = ACTIONS(13522),
    [aux_sym_float_literal_token1] = ACTIONS(13522),
    [aux_sym_float_literal_token3] = ACTIONS(13522),
    [aux_sym_float_literal_token4] = ACTIONS(13522),
    [sym_character_literal] = ACTIONS(13522),
    [sym__pair_operator] = ACTIONS(13522),
    [sym__arrow_operator] = ACTIONS(13522),
    [sym__lazy_or_operator] = ACTIONS(13522),
    [sym__lazy_and_operator] = ACTIONS(13522),
    [sym__comparison_operator] = ACTIONS(13522),
    [sym__pipe_right_operator] = ACTIONS(13522),
    [sym__pipe_left_operator] = ACTIONS(13522),
    [sym__ellipsis_operator] = ACTIONS(13522),
    [sym__plus_operator] = ACTIONS(13522),
    [sym__times_operator] = ACTIONS(13522),
    [sym__rational_operator] = ACTIONS(13522),
    [sym__bitshift_operator] = ACTIONS(13522),
    [sym__power_operator] = ACTIONS(13522),
    [sym__tilde_operator] = ACTIONS(13522),
    [sym__type_order_operator] = ACTIONS(13522),
    [sym__unary_operator] = ACTIONS(13522),
    [sym__unary_plus_operator] = ACTIONS(13522),
    [aux_sym__terminator_token1] = ACTIONS(13522),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13524),
    [sym__command_start] = ACTIONS(13524),
  },
  [8560] = {
    [sym__word_identifier] = ACTIONS(13378),
    [anon_sym_EQ] = ACTIONS(13378),
    [anon_sym_COMMA] = ACTIONS(13380),
    [anon_sym_COLON] = ACTIONS(13378),
    [anon_sym_begin] = ACTIONS(13378),
    [anon_sym_module] = ACTIONS(13378),
    [anon_sym_baremodule] = ACTIONS(13378),
    [anon_sym_abstract] = ACTIONS(13378),
    [anon_sym_primitive] = ACTIONS(13378),
    [anon_sym_mutable] = ACTIONS(13378),
    [anon_sym_struct] = ACTIONS(13378),
    [anon_sym_function] = ACTIONS(13378),
    [anon_sym_macro] = ACTIONS(13378),
    [anon_sym_where] = ACTIONS(13378),
    [anon_sym_quote] = ACTIONS(13378),
    [anon_sym_let] = ACTIONS(13378),
    [anon_sym_if] = ACTIONS(13378),
    [anon_sym_try] = ACTIONS(13378),
    [anon_sym_for] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(13378),
    [sym_break_statement] = ACTIONS(13378),
    [sym_continue_statement] = ACTIONS(13378),
    [anon_sym_return] = ACTIONS(13378),
    [anon_sym_const] = ACTIONS(13378),
    [anon_sym_global] = ACTIONS(13378),
    [anon_sym_local] = ACTIONS(13378),
    [anon_sym_LPAREN] = ACTIONS(13380),
    [anon_sym_RPAREN] = ACTIONS(13380),
    [anon_sym_COLON2] = ACTIONS(13378),
    [anon_sym_export] = ACTIONS(13378),
    [anon_sym_import] = ACTIONS(13378),
    [anon_sym_using] = ACTIONS(13378),
    [anon_sym_LBRACK] = ACTIONS(13380),
    [anon_sym_RBRACK] = ACTIONS(13380),
    [anon_sym_in] = ACTIONS(13378),
    [anon_sym_SEMI] = ACTIONS(13380),
    [anon_sym_LBRACE] = ACTIONS(13380),
    [anon_sym_RBRACE] = ACTIONS(13380),
    [anon_sym_DOLLAR] = ACTIONS(13380),
    [anon_sym_COLON_COLON] = ACTIONS(13380),
    [anon_sym_isa] = ACTIONS(13378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13380),
    [anon_sym_QMARK] = ACTIONS(13380),
    [anon_sym_AT] = ACTIONS(13380),
    [anon_sym_true] = ACTIONS(13378),
    [anon_sym_false] = ACTIONS(13378),
    [aux_sym_integer_literal_token1] = ACTIONS(13380),
    [aux_sym_integer_literal_token2] = ACTIONS(13380),
    [aux_sym_integer_literal_token3] = ACTIONS(13378),
    [aux_sym_integer_literal_token4] = ACTIONS(13378),
    [aux_sym_float_literal_token1] = ACTIONS(13380),
    [aux_sym_float_literal_token3] = ACTIONS(13380),
    [aux_sym_float_literal_token4] = ACTIONS(13380),
    [sym_character_literal] = ACTIONS(13380),
    [sym__pair_operator] = ACTIONS(13380),
    [sym__arrow_operator] = ACTIONS(13378),
    [sym__lazy_or_operator] = ACTIONS(13380),
    [sym__lazy_and_operator] = ACTIONS(13380),
    [sym__comparison_operator] = ACTIONS(13378),
    [sym__pipe_right_operator] = ACTIONS(13380),
    [sym__pipe_left_operator] = ACTIONS(13380),
    [sym__ellipsis_operator] = ACTIONS(13378),
    [sym__plus_operator] = ACTIONS(13378),
    [sym__times_operator] = ACTIONS(13378),
    [sym__rational_operator] = ACTIONS(13380),
    [sym__bitshift_operator] = ACTIONS(13380),
    [sym__power_operator] = ACTIONS(13380),
    [sym__tilde_operator] = ACTIONS(13380),
    [sym__type_order_operator] = ACTIONS(13380),
    [sym__unary_operator] = ACTIONS(13378),
    [sym__unary_plus_operator] = ACTIONS(13378),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13380),
    [sym__command_start] = ACTIONS(13380),
  },
  [8561] = {
    [sym__word_identifier] = ACTIONS(13382),
    [anon_sym_EQ] = ACTIONS(13382),
    [anon_sym_COMMA] = ACTIONS(13384),
    [anon_sym_COLON] = ACTIONS(13382),
    [anon_sym_begin] = ACTIONS(13382),
    [anon_sym_module] = ACTIONS(13382),
    [anon_sym_baremodule] = ACTIONS(13382),
    [anon_sym_abstract] = ACTIONS(13382),
    [anon_sym_primitive] = ACTIONS(13382),
    [anon_sym_mutable] = ACTIONS(13382),
    [anon_sym_struct] = ACTIONS(13382),
    [anon_sym_function] = ACTIONS(13382),
    [anon_sym_macro] = ACTIONS(13382),
    [anon_sym_where] = ACTIONS(13382),
    [anon_sym_quote] = ACTIONS(13382),
    [anon_sym_let] = ACTIONS(13382),
    [anon_sym_if] = ACTIONS(13382),
    [anon_sym_try] = ACTIONS(13382),
    [anon_sym_for] = ACTIONS(13382),
    [anon_sym_while] = ACTIONS(13382),
    [sym_break_statement] = ACTIONS(13382),
    [sym_continue_statement] = ACTIONS(13382),
    [anon_sym_return] = ACTIONS(13382),
    [anon_sym_const] = ACTIONS(13382),
    [anon_sym_global] = ACTIONS(13382),
    [anon_sym_local] = ACTIONS(13382),
    [anon_sym_LPAREN] = ACTIONS(13384),
    [anon_sym_RPAREN] = ACTIONS(13384),
    [anon_sym_COLON2] = ACTIONS(13382),
    [anon_sym_export] = ACTIONS(13382),
    [anon_sym_import] = ACTIONS(13382),
    [anon_sym_using] = ACTIONS(13382),
    [anon_sym_LBRACK] = ACTIONS(13384),
    [anon_sym_RBRACK] = ACTIONS(13384),
    [anon_sym_in] = ACTIONS(13382),
    [anon_sym_SEMI] = ACTIONS(13384),
    [anon_sym_LBRACE] = ACTIONS(13384),
    [anon_sym_RBRACE] = ACTIONS(13384),
    [anon_sym_DOLLAR] = ACTIONS(13384),
    [anon_sym_COLON_COLON] = ACTIONS(13384),
    [anon_sym_isa] = ACTIONS(13382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13384),
    [anon_sym_QMARK] = ACTIONS(13384),
    [anon_sym_AT] = ACTIONS(13384),
    [anon_sym_true] = ACTIONS(13382),
    [anon_sym_false] = ACTIONS(13382),
    [aux_sym_integer_literal_token1] = ACTIONS(13384),
    [aux_sym_integer_literal_token2] = ACTIONS(13384),
    [aux_sym_integer_literal_token3] = ACTIONS(13382),
    [aux_sym_integer_literal_token4] = ACTIONS(13382),
    [aux_sym_float_literal_token1] = ACTIONS(13384),
    [aux_sym_float_literal_token3] = ACTIONS(13384),
    [aux_sym_float_literal_token4] = ACTIONS(13384),
    [sym_character_literal] = ACTIONS(13384),
    [sym__pair_operator] = ACTIONS(13384),
    [sym__arrow_operator] = ACTIONS(13382),
    [sym__lazy_or_operator] = ACTIONS(13384),
    [sym__lazy_and_operator] = ACTIONS(13384),
    [sym__comparison_operator] = ACTIONS(13382),
    [sym__pipe_right_operator] = ACTIONS(13384),
    [sym__pipe_left_operator] = ACTIONS(13384),
    [sym__ellipsis_operator] = ACTIONS(13382),
    [sym__plus_operator] = ACTIONS(13382),
    [sym__times_operator] = ACTIONS(13382),
    [sym__rational_operator] = ACTIONS(13384),
    [sym__bitshift_operator] = ACTIONS(13384),
    [sym__power_operator] = ACTIONS(13384),
    [sym__tilde_operator] = ACTIONS(13384),
    [sym__type_order_operator] = ACTIONS(13384),
    [sym__unary_operator] = ACTIONS(13382),
    [sym__unary_plus_operator] = ACTIONS(13382),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13384),
    [sym__command_start] = ACTIONS(13384),
  },
  [8562] = {
    [sym__word_identifier] = ACTIONS(13386),
    [anon_sym_EQ] = ACTIONS(13386),
    [anon_sym_COMMA] = ACTIONS(13388),
    [anon_sym_COLON] = ACTIONS(13386),
    [anon_sym_begin] = ACTIONS(13386),
    [anon_sym_module] = ACTIONS(13386),
    [anon_sym_baremodule] = ACTIONS(13386),
    [anon_sym_abstract] = ACTIONS(13386),
    [anon_sym_primitive] = ACTIONS(13386),
    [anon_sym_mutable] = ACTIONS(13386),
    [anon_sym_struct] = ACTIONS(13386),
    [anon_sym_function] = ACTIONS(13386),
    [anon_sym_macro] = ACTIONS(13386),
    [anon_sym_where] = ACTIONS(13386),
    [anon_sym_quote] = ACTIONS(13386),
    [anon_sym_let] = ACTIONS(13386),
    [anon_sym_if] = ACTIONS(13386),
    [anon_sym_try] = ACTIONS(13386),
    [anon_sym_for] = ACTIONS(13386),
    [anon_sym_while] = ACTIONS(13386),
    [sym_break_statement] = ACTIONS(13386),
    [sym_continue_statement] = ACTIONS(13386),
    [anon_sym_return] = ACTIONS(13386),
    [anon_sym_const] = ACTIONS(13386),
    [anon_sym_global] = ACTIONS(13386),
    [anon_sym_local] = ACTIONS(13386),
    [anon_sym_LPAREN] = ACTIONS(13388),
    [anon_sym_RPAREN] = ACTIONS(13388),
    [anon_sym_COLON2] = ACTIONS(13386),
    [anon_sym_export] = ACTIONS(13386),
    [anon_sym_import] = ACTIONS(13386),
    [anon_sym_using] = ACTIONS(13386),
    [anon_sym_LBRACK] = ACTIONS(13388),
    [anon_sym_RBRACK] = ACTIONS(13388),
    [anon_sym_in] = ACTIONS(13386),
    [anon_sym_SEMI] = ACTIONS(13388),
    [anon_sym_LBRACE] = ACTIONS(13388),
    [anon_sym_RBRACE] = ACTIONS(13388),
    [anon_sym_DOLLAR] = ACTIONS(13388),
    [anon_sym_COLON_COLON] = ACTIONS(13388),
    [anon_sym_isa] = ACTIONS(13386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13388),
    [anon_sym_QMARK] = ACTIONS(13388),
    [anon_sym_AT] = ACTIONS(13388),
    [anon_sym_true] = ACTIONS(13386),
    [anon_sym_false] = ACTIONS(13386),
    [aux_sym_integer_literal_token1] = ACTIONS(13388),
    [aux_sym_integer_literal_token2] = ACTIONS(13388),
    [aux_sym_integer_literal_token3] = ACTIONS(13386),
    [aux_sym_integer_literal_token4] = ACTIONS(13386),
    [aux_sym_float_literal_token1] = ACTIONS(13388),
    [aux_sym_float_literal_token3] = ACTIONS(13388),
    [aux_sym_float_literal_token4] = ACTIONS(13388),
    [sym_character_literal] = ACTIONS(13388),
    [sym__pair_operator] = ACTIONS(13388),
    [sym__arrow_operator] = ACTIONS(13386),
    [sym__lazy_or_operator] = ACTIONS(13388),
    [sym__lazy_and_operator] = ACTIONS(13388),
    [sym__comparison_operator] = ACTIONS(13386),
    [sym__pipe_right_operator] = ACTIONS(13388),
    [sym__pipe_left_operator] = ACTIONS(13388),
    [sym__ellipsis_operator] = ACTIONS(13386),
    [sym__plus_operator] = ACTIONS(13386),
    [sym__times_operator] = ACTIONS(13386),
    [sym__rational_operator] = ACTIONS(13388),
    [sym__bitshift_operator] = ACTIONS(13388),
    [sym__power_operator] = ACTIONS(13388),
    [sym__tilde_operator] = ACTIONS(13388),
    [sym__type_order_operator] = ACTIONS(13388),
    [sym__unary_operator] = ACTIONS(13386),
    [sym__unary_plus_operator] = ACTIONS(13386),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13388),
    [sym__command_start] = ACTIONS(13388),
  },
  [8563] = {
    [sym__word_identifier] = ACTIONS(13390),
    [anon_sym_EQ] = ACTIONS(13390),
    [anon_sym_COMMA] = ACTIONS(13392),
    [anon_sym_COLON] = ACTIONS(13390),
    [anon_sym_begin] = ACTIONS(13390),
    [anon_sym_module] = ACTIONS(13390),
    [anon_sym_baremodule] = ACTIONS(13390),
    [anon_sym_abstract] = ACTIONS(13390),
    [anon_sym_primitive] = ACTIONS(13390),
    [anon_sym_mutable] = ACTIONS(13390),
    [anon_sym_struct] = ACTIONS(13390),
    [anon_sym_function] = ACTIONS(13390),
    [anon_sym_macro] = ACTIONS(13390),
    [anon_sym_where] = ACTIONS(13390),
    [anon_sym_quote] = ACTIONS(13390),
    [anon_sym_let] = ACTIONS(13390),
    [anon_sym_if] = ACTIONS(13390),
    [anon_sym_try] = ACTIONS(13390),
    [anon_sym_for] = ACTIONS(13390),
    [anon_sym_while] = ACTIONS(13390),
    [sym_break_statement] = ACTIONS(13390),
    [sym_continue_statement] = ACTIONS(13390),
    [anon_sym_return] = ACTIONS(13390),
    [anon_sym_const] = ACTIONS(13390),
    [anon_sym_global] = ACTIONS(13390),
    [anon_sym_local] = ACTIONS(13390),
    [anon_sym_LPAREN] = ACTIONS(13392),
    [anon_sym_RPAREN] = ACTIONS(13392),
    [anon_sym_COLON2] = ACTIONS(13390),
    [anon_sym_export] = ACTIONS(13390),
    [anon_sym_import] = ACTIONS(13390),
    [anon_sym_using] = ACTIONS(13390),
    [anon_sym_LBRACK] = ACTIONS(13392),
    [anon_sym_RBRACK] = ACTIONS(13392),
    [anon_sym_in] = ACTIONS(13390),
    [anon_sym_SEMI] = ACTIONS(13392),
    [anon_sym_LBRACE] = ACTIONS(13392),
    [anon_sym_RBRACE] = ACTIONS(13392),
    [anon_sym_DOLLAR] = ACTIONS(13392),
    [anon_sym_COLON_COLON] = ACTIONS(13392),
    [anon_sym_isa] = ACTIONS(13390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13392),
    [anon_sym_QMARK] = ACTIONS(13392),
    [anon_sym_AT] = ACTIONS(13392),
    [anon_sym_true] = ACTIONS(13390),
    [anon_sym_false] = ACTIONS(13390),
    [aux_sym_integer_literal_token1] = ACTIONS(13392),
    [aux_sym_integer_literal_token2] = ACTIONS(13392),
    [aux_sym_integer_literal_token3] = ACTIONS(13390),
    [aux_sym_integer_literal_token4] = ACTIONS(13390),
    [aux_sym_float_literal_token1] = ACTIONS(13392),
    [aux_sym_float_literal_token3] = ACTIONS(13392),
    [aux_sym_float_literal_token4] = ACTIONS(13392),
    [sym_character_literal] = ACTIONS(13392),
    [sym__pair_operator] = ACTIONS(13392),
    [sym__arrow_operator] = ACTIONS(13390),
    [sym__lazy_or_operator] = ACTIONS(13392),
    [sym__lazy_and_operator] = ACTIONS(13392),
    [sym__comparison_operator] = ACTIONS(13390),
    [sym__pipe_right_operator] = ACTIONS(13392),
    [sym__pipe_left_operator] = ACTIONS(13392),
    [sym__ellipsis_operator] = ACTIONS(13390),
    [sym__plus_operator] = ACTIONS(13390),
    [sym__times_operator] = ACTIONS(13390),
    [sym__rational_operator] = ACTIONS(13392),
    [sym__bitshift_operator] = ACTIONS(13392),
    [sym__power_operator] = ACTIONS(13392),
    [sym__tilde_operator] = ACTIONS(13392),
    [sym__type_order_operator] = ACTIONS(13392),
    [sym__unary_operator] = ACTIONS(13390),
    [sym__unary_plus_operator] = ACTIONS(13390),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13392),
    [sym__command_start] = ACTIONS(13392),
  },
  [8564] = {
    [sym__word_identifier] = ACTIONS(13526),
    [anon_sym_EQ] = ACTIONS(13526),
    [anon_sym_COMMA] = ACTIONS(13526),
    [anon_sym_COLON] = ACTIONS(13526),
    [anon_sym_begin] = ACTIONS(13526),
    [anon_sym_module] = ACTIONS(13526),
    [anon_sym_baremodule] = ACTIONS(13526),
    [anon_sym_end] = ACTIONS(13526),
    [anon_sym_abstract] = ACTIONS(13526),
    [anon_sym_primitive] = ACTIONS(13526),
    [anon_sym_mutable] = ACTIONS(13526),
    [anon_sym_struct] = ACTIONS(13526),
    [anon_sym_function] = ACTIONS(13526),
    [anon_sym_macro] = ACTIONS(13526),
    [anon_sym_where] = ACTIONS(13526),
    [anon_sym_quote] = ACTIONS(13526),
    [anon_sym_let] = ACTIONS(13526),
    [anon_sym_if] = ACTIONS(13526),
    [anon_sym_try] = ACTIONS(13526),
    [anon_sym_catch] = ACTIONS(13526),
    [anon_sym_for] = ACTIONS(13526),
    [anon_sym_while] = ACTIONS(13526),
    [sym_break_statement] = ACTIONS(13526),
    [sym_continue_statement] = ACTIONS(13526),
    [anon_sym_return] = ACTIONS(13526),
    [anon_sym_const] = ACTIONS(13526),
    [anon_sym_global] = ACTIONS(13526),
    [anon_sym_local] = ACTIONS(13526),
    [anon_sym_LPAREN] = ACTIONS(13526),
    [anon_sym_COLON2] = ACTIONS(13526),
    [anon_sym_export] = ACTIONS(13526),
    [anon_sym_import] = ACTIONS(13526),
    [anon_sym_using] = ACTIONS(13526),
    [anon_sym_LBRACK] = ACTIONS(13526),
    [anon_sym_LF] = ACTIONS(13528),
    [anon_sym_in] = ACTIONS(13526),
    [anon_sym_LBRACE] = ACTIONS(13526),
    [anon_sym_DOLLAR] = ACTIONS(13526),
    [anon_sym_COLON_COLON] = ACTIONS(13526),
    [anon_sym_isa] = ACTIONS(13526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13526),
    [anon_sym_QMARK] = ACTIONS(13526),
    [anon_sym_AT] = ACTIONS(13526),
    [anon_sym_true] = ACTIONS(13526),
    [anon_sym_false] = ACTIONS(13526),
    [aux_sym_integer_literal_token1] = ACTIONS(13526),
    [aux_sym_integer_literal_token2] = ACTIONS(13526),
    [aux_sym_integer_literal_token3] = ACTIONS(13526),
    [aux_sym_integer_literal_token4] = ACTIONS(13526),
    [aux_sym_float_literal_token1] = ACTIONS(13526),
    [aux_sym_float_literal_token3] = ACTIONS(13526),
    [aux_sym_float_literal_token4] = ACTIONS(13526),
    [sym_character_literal] = ACTIONS(13526),
    [sym__pair_operator] = ACTIONS(13526),
    [sym__arrow_operator] = ACTIONS(13526),
    [sym__lazy_or_operator] = ACTIONS(13526),
    [sym__lazy_and_operator] = ACTIONS(13526),
    [sym__comparison_operator] = ACTIONS(13526),
    [sym__pipe_right_operator] = ACTIONS(13526),
    [sym__pipe_left_operator] = ACTIONS(13526),
    [sym__ellipsis_operator] = ACTIONS(13526),
    [sym__plus_operator] = ACTIONS(13526),
    [sym__times_operator] = ACTIONS(13526),
    [sym__rational_operator] = ACTIONS(13526),
    [sym__bitshift_operator] = ACTIONS(13526),
    [sym__power_operator] = ACTIONS(13526),
    [sym__tilde_operator] = ACTIONS(13526),
    [sym__type_order_operator] = ACTIONS(13526),
    [sym__unary_operator] = ACTIONS(13526),
    [sym__unary_plus_operator] = ACTIONS(13526),
    [aux_sym__terminator_token1] = ACTIONS(13526),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13528),
    [sym__command_start] = ACTIONS(13528),
  },
  [8565] = {
    [sym__word_identifier] = ACTIONS(13396),
    [anon_sym_EQ] = ACTIONS(13396),
    [anon_sym_COMMA] = ACTIONS(13398),
    [anon_sym_COLON] = ACTIONS(13396),
    [anon_sym_begin] = ACTIONS(13396),
    [anon_sym_module] = ACTIONS(13396),
    [anon_sym_baremodule] = ACTIONS(13396),
    [anon_sym_abstract] = ACTIONS(13396),
    [anon_sym_primitive] = ACTIONS(13396),
    [anon_sym_mutable] = ACTIONS(13396),
    [anon_sym_struct] = ACTIONS(13396),
    [anon_sym_function] = ACTIONS(13396),
    [anon_sym_macro] = ACTIONS(13396),
    [anon_sym_where] = ACTIONS(13396),
    [anon_sym_quote] = ACTIONS(13396),
    [anon_sym_let] = ACTIONS(13396),
    [anon_sym_if] = ACTIONS(13396),
    [anon_sym_try] = ACTIONS(13396),
    [anon_sym_for] = ACTIONS(13396),
    [anon_sym_while] = ACTIONS(13396),
    [sym_break_statement] = ACTIONS(13396),
    [sym_continue_statement] = ACTIONS(13396),
    [anon_sym_return] = ACTIONS(13396),
    [anon_sym_const] = ACTIONS(13396),
    [anon_sym_global] = ACTIONS(13396),
    [anon_sym_local] = ACTIONS(13396),
    [anon_sym_LPAREN] = ACTIONS(13398),
    [anon_sym_RPAREN] = ACTIONS(13398),
    [anon_sym_COLON2] = ACTIONS(13396),
    [anon_sym_export] = ACTIONS(13396),
    [anon_sym_import] = ACTIONS(13396),
    [anon_sym_using] = ACTIONS(13396),
    [anon_sym_LBRACK] = ACTIONS(13398),
    [anon_sym_RBRACK] = ACTIONS(13398),
    [anon_sym_in] = ACTIONS(13396),
    [anon_sym_SEMI] = ACTIONS(13398),
    [anon_sym_LBRACE] = ACTIONS(13398),
    [anon_sym_RBRACE] = ACTIONS(13398),
    [anon_sym_DOLLAR] = ACTIONS(13398),
    [anon_sym_COLON_COLON] = ACTIONS(13398),
    [anon_sym_isa] = ACTIONS(13396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13398),
    [anon_sym_QMARK] = ACTIONS(13398),
    [anon_sym_AT] = ACTIONS(13398),
    [anon_sym_true] = ACTIONS(13396),
    [anon_sym_false] = ACTIONS(13396),
    [aux_sym_integer_literal_token1] = ACTIONS(13398),
    [aux_sym_integer_literal_token2] = ACTIONS(13398),
    [aux_sym_integer_literal_token3] = ACTIONS(13396),
    [aux_sym_integer_literal_token4] = ACTIONS(13396),
    [aux_sym_float_literal_token1] = ACTIONS(13398),
    [aux_sym_float_literal_token3] = ACTIONS(13398),
    [aux_sym_float_literal_token4] = ACTIONS(13398),
    [sym_character_literal] = ACTIONS(13398),
    [sym__pair_operator] = ACTIONS(13398),
    [sym__arrow_operator] = ACTIONS(13396),
    [sym__lazy_or_operator] = ACTIONS(13398),
    [sym__lazy_and_operator] = ACTIONS(13398),
    [sym__comparison_operator] = ACTIONS(13396),
    [sym__pipe_right_operator] = ACTIONS(13398),
    [sym__pipe_left_operator] = ACTIONS(13398),
    [sym__ellipsis_operator] = ACTIONS(13396),
    [sym__plus_operator] = ACTIONS(13396),
    [sym__times_operator] = ACTIONS(13396),
    [sym__rational_operator] = ACTIONS(13398),
    [sym__bitshift_operator] = ACTIONS(13398),
    [sym__power_operator] = ACTIONS(13398),
    [sym__tilde_operator] = ACTIONS(13398),
    [sym__type_order_operator] = ACTIONS(13398),
    [sym__unary_operator] = ACTIONS(13396),
    [sym__unary_plus_operator] = ACTIONS(13396),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13398),
    [sym__command_start] = ACTIONS(13398),
  },
  [8566] = {
    [sym__word_identifier] = ACTIONS(13530),
    [anon_sym_EQ] = ACTIONS(13530),
    [anon_sym_COMMA] = ACTIONS(13530),
    [anon_sym_COLON] = ACTIONS(13530),
    [anon_sym_begin] = ACTIONS(13530),
    [anon_sym_module] = ACTIONS(13530),
    [anon_sym_baremodule] = ACTIONS(13530),
    [anon_sym_end] = ACTIONS(13530),
    [anon_sym_abstract] = ACTIONS(13530),
    [anon_sym_primitive] = ACTIONS(13530),
    [anon_sym_mutable] = ACTIONS(13530),
    [anon_sym_struct] = ACTIONS(13530),
    [anon_sym_function] = ACTIONS(13530),
    [anon_sym_macro] = ACTIONS(13530),
    [anon_sym_where] = ACTIONS(13530),
    [anon_sym_quote] = ACTIONS(13530),
    [anon_sym_let] = ACTIONS(13530),
    [anon_sym_if] = ACTIONS(13530),
    [anon_sym_try] = ACTIONS(13530),
    [anon_sym_catch] = ACTIONS(13530),
    [anon_sym_for] = ACTIONS(13530),
    [anon_sym_while] = ACTIONS(13530),
    [sym_break_statement] = ACTIONS(13530),
    [sym_continue_statement] = ACTIONS(13530),
    [anon_sym_return] = ACTIONS(13530),
    [anon_sym_const] = ACTIONS(13530),
    [anon_sym_global] = ACTIONS(13530),
    [anon_sym_local] = ACTIONS(13530),
    [anon_sym_LPAREN] = ACTIONS(13530),
    [anon_sym_COLON2] = ACTIONS(13530),
    [anon_sym_export] = ACTIONS(13530),
    [anon_sym_import] = ACTIONS(13530),
    [anon_sym_using] = ACTIONS(13530),
    [anon_sym_LBRACK] = ACTIONS(13530),
    [anon_sym_LF] = ACTIONS(13532),
    [anon_sym_in] = ACTIONS(13530),
    [anon_sym_LBRACE] = ACTIONS(13530),
    [anon_sym_DOLLAR] = ACTIONS(13530),
    [anon_sym_COLON_COLON] = ACTIONS(13530),
    [anon_sym_isa] = ACTIONS(13530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13530),
    [anon_sym_QMARK] = ACTIONS(13530),
    [anon_sym_AT] = ACTIONS(13530),
    [anon_sym_true] = ACTIONS(13530),
    [anon_sym_false] = ACTIONS(13530),
    [aux_sym_integer_literal_token1] = ACTIONS(13530),
    [aux_sym_integer_literal_token2] = ACTIONS(13530),
    [aux_sym_integer_literal_token3] = ACTIONS(13530),
    [aux_sym_integer_literal_token4] = ACTIONS(13530),
    [aux_sym_float_literal_token1] = ACTIONS(13530),
    [aux_sym_float_literal_token3] = ACTIONS(13530),
    [aux_sym_float_literal_token4] = ACTIONS(13530),
    [sym_character_literal] = ACTIONS(13530),
    [sym__pair_operator] = ACTIONS(13530),
    [sym__arrow_operator] = ACTIONS(13530),
    [sym__lazy_or_operator] = ACTIONS(13530),
    [sym__lazy_and_operator] = ACTIONS(13530),
    [sym__comparison_operator] = ACTIONS(13530),
    [sym__pipe_right_operator] = ACTIONS(13530),
    [sym__pipe_left_operator] = ACTIONS(13530),
    [sym__ellipsis_operator] = ACTIONS(13530),
    [sym__plus_operator] = ACTIONS(13530),
    [sym__times_operator] = ACTIONS(13530),
    [sym__rational_operator] = ACTIONS(13530),
    [sym__bitshift_operator] = ACTIONS(13530),
    [sym__power_operator] = ACTIONS(13530),
    [sym__tilde_operator] = ACTIONS(13530),
    [sym__type_order_operator] = ACTIONS(13530),
    [sym__unary_operator] = ACTIONS(13530),
    [sym__unary_plus_operator] = ACTIONS(13530),
    [aux_sym__terminator_token1] = ACTIONS(13530),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13532),
    [sym__command_start] = ACTIONS(13532),
  },
  [8567] = {
    [sym__word_identifier] = ACTIONS(13534),
    [anon_sym_EQ] = ACTIONS(13534),
    [anon_sym_COMMA] = ACTIONS(13534),
    [anon_sym_COLON] = ACTIONS(13534),
    [anon_sym_begin] = ACTIONS(13534),
    [anon_sym_module] = ACTIONS(13534),
    [anon_sym_baremodule] = ACTIONS(13534),
    [anon_sym_end] = ACTIONS(13534),
    [anon_sym_abstract] = ACTIONS(13534),
    [anon_sym_primitive] = ACTIONS(13534),
    [anon_sym_mutable] = ACTIONS(13534),
    [anon_sym_struct] = ACTIONS(13534),
    [anon_sym_function] = ACTIONS(13534),
    [anon_sym_macro] = ACTIONS(13534),
    [anon_sym_where] = ACTIONS(13534),
    [anon_sym_quote] = ACTIONS(13534),
    [anon_sym_let] = ACTIONS(13534),
    [anon_sym_if] = ACTIONS(13534),
    [anon_sym_try] = ACTIONS(13534),
    [anon_sym_catch] = ACTIONS(13534),
    [anon_sym_for] = ACTIONS(13534),
    [anon_sym_while] = ACTIONS(13534),
    [sym_break_statement] = ACTIONS(13534),
    [sym_continue_statement] = ACTIONS(13534),
    [anon_sym_return] = ACTIONS(13534),
    [anon_sym_const] = ACTIONS(13534),
    [anon_sym_global] = ACTIONS(13534),
    [anon_sym_local] = ACTIONS(13534),
    [anon_sym_LPAREN] = ACTIONS(13534),
    [anon_sym_COLON2] = ACTIONS(13534),
    [anon_sym_export] = ACTIONS(13534),
    [anon_sym_import] = ACTIONS(13534),
    [anon_sym_using] = ACTIONS(13534),
    [anon_sym_LBRACK] = ACTIONS(13534),
    [anon_sym_LF] = ACTIONS(13536),
    [anon_sym_in] = ACTIONS(13534),
    [anon_sym_LBRACE] = ACTIONS(13534),
    [anon_sym_DOLLAR] = ACTIONS(13534),
    [anon_sym_COLON_COLON] = ACTIONS(13534),
    [anon_sym_isa] = ACTIONS(13534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13534),
    [anon_sym_QMARK] = ACTIONS(13534),
    [anon_sym_AT] = ACTIONS(13534),
    [anon_sym_true] = ACTIONS(13534),
    [anon_sym_false] = ACTIONS(13534),
    [aux_sym_integer_literal_token1] = ACTIONS(13534),
    [aux_sym_integer_literal_token2] = ACTIONS(13534),
    [aux_sym_integer_literal_token3] = ACTIONS(13534),
    [aux_sym_integer_literal_token4] = ACTIONS(13534),
    [aux_sym_float_literal_token1] = ACTIONS(13534),
    [aux_sym_float_literal_token3] = ACTIONS(13534),
    [aux_sym_float_literal_token4] = ACTIONS(13534),
    [sym_character_literal] = ACTIONS(13534),
    [sym__pair_operator] = ACTIONS(13534),
    [sym__arrow_operator] = ACTIONS(13534),
    [sym__lazy_or_operator] = ACTIONS(13534),
    [sym__lazy_and_operator] = ACTIONS(13534),
    [sym__comparison_operator] = ACTIONS(13534),
    [sym__pipe_right_operator] = ACTIONS(13534),
    [sym__pipe_left_operator] = ACTIONS(13534),
    [sym__ellipsis_operator] = ACTIONS(13534),
    [sym__plus_operator] = ACTIONS(13534),
    [sym__times_operator] = ACTIONS(13534),
    [sym__rational_operator] = ACTIONS(13534),
    [sym__bitshift_operator] = ACTIONS(13534),
    [sym__power_operator] = ACTIONS(13534),
    [sym__tilde_operator] = ACTIONS(13534),
    [sym__type_order_operator] = ACTIONS(13534),
    [sym__unary_operator] = ACTIONS(13534),
    [sym__unary_plus_operator] = ACTIONS(13534),
    [aux_sym__terminator_token1] = ACTIONS(13534),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13536),
    [sym__command_start] = ACTIONS(13536),
  },
  [8568] = {
    [sym__word_identifier] = ACTIONS(13538),
    [anon_sym_EQ] = ACTIONS(13538),
    [anon_sym_COMMA] = ACTIONS(13538),
    [anon_sym_COLON] = ACTIONS(13538),
    [anon_sym_begin] = ACTIONS(13538),
    [anon_sym_module] = ACTIONS(13538),
    [anon_sym_baremodule] = ACTIONS(13538),
    [anon_sym_end] = ACTIONS(13538),
    [anon_sym_abstract] = ACTIONS(13538),
    [anon_sym_primitive] = ACTIONS(13538),
    [anon_sym_mutable] = ACTIONS(13538),
    [anon_sym_struct] = ACTIONS(13538),
    [anon_sym_function] = ACTIONS(13538),
    [anon_sym_macro] = ACTIONS(13538),
    [anon_sym_where] = ACTIONS(13538),
    [anon_sym_quote] = ACTIONS(13538),
    [anon_sym_let] = ACTIONS(13538),
    [anon_sym_if] = ACTIONS(13538),
    [anon_sym_try] = ACTIONS(13538),
    [anon_sym_catch] = ACTIONS(13538),
    [anon_sym_for] = ACTIONS(13538),
    [anon_sym_while] = ACTIONS(13538),
    [sym_break_statement] = ACTIONS(13538),
    [sym_continue_statement] = ACTIONS(13538),
    [anon_sym_return] = ACTIONS(13538),
    [anon_sym_const] = ACTIONS(13538),
    [anon_sym_global] = ACTIONS(13538),
    [anon_sym_local] = ACTIONS(13538),
    [anon_sym_LPAREN] = ACTIONS(13538),
    [anon_sym_COLON2] = ACTIONS(13538),
    [anon_sym_export] = ACTIONS(13538),
    [anon_sym_import] = ACTIONS(13538),
    [anon_sym_using] = ACTIONS(13538),
    [anon_sym_LBRACK] = ACTIONS(13538),
    [anon_sym_LF] = ACTIONS(13540),
    [anon_sym_in] = ACTIONS(13538),
    [anon_sym_LBRACE] = ACTIONS(13538),
    [anon_sym_DOLLAR] = ACTIONS(13538),
    [anon_sym_COLON_COLON] = ACTIONS(13538),
    [anon_sym_isa] = ACTIONS(13538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13538),
    [anon_sym_QMARK] = ACTIONS(13538),
    [anon_sym_AT] = ACTIONS(13538),
    [anon_sym_true] = ACTIONS(13538),
    [anon_sym_false] = ACTIONS(13538),
    [aux_sym_integer_literal_token1] = ACTIONS(13538),
    [aux_sym_integer_literal_token2] = ACTIONS(13538),
    [aux_sym_integer_literal_token3] = ACTIONS(13538),
    [aux_sym_integer_literal_token4] = ACTIONS(13538),
    [aux_sym_float_literal_token1] = ACTIONS(13538),
    [aux_sym_float_literal_token3] = ACTIONS(13538),
    [aux_sym_float_literal_token4] = ACTIONS(13538),
    [sym_character_literal] = ACTIONS(13538),
    [sym__pair_operator] = ACTIONS(13538),
    [sym__arrow_operator] = ACTIONS(13538),
    [sym__lazy_or_operator] = ACTIONS(13538),
    [sym__lazy_and_operator] = ACTIONS(13538),
    [sym__comparison_operator] = ACTIONS(13538),
    [sym__pipe_right_operator] = ACTIONS(13538),
    [sym__pipe_left_operator] = ACTIONS(13538),
    [sym__ellipsis_operator] = ACTIONS(13538),
    [sym__plus_operator] = ACTIONS(13538),
    [sym__times_operator] = ACTIONS(13538),
    [sym__rational_operator] = ACTIONS(13538),
    [sym__bitshift_operator] = ACTIONS(13538),
    [sym__power_operator] = ACTIONS(13538),
    [sym__tilde_operator] = ACTIONS(13538),
    [sym__type_order_operator] = ACTIONS(13538),
    [sym__unary_operator] = ACTIONS(13538),
    [sym__unary_plus_operator] = ACTIONS(13538),
    [aux_sym__terminator_token1] = ACTIONS(13538),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13540),
    [sym__command_start] = ACTIONS(13540),
  },
  [8569] = {
    [sym__word_identifier] = ACTIONS(13400),
    [anon_sym_EQ] = ACTIONS(13400),
    [anon_sym_COMMA] = ACTIONS(13402),
    [anon_sym_COLON] = ACTIONS(13400),
    [anon_sym_begin] = ACTIONS(13400),
    [anon_sym_module] = ACTIONS(13400),
    [anon_sym_baremodule] = ACTIONS(13400),
    [anon_sym_abstract] = ACTIONS(13400),
    [anon_sym_primitive] = ACTIONS(13400),
    [anon_sym_mutable] = ACTIONS(13400),
    [anon_sym_struct] = ACTIONS(13400),
    [anon_sym_function] = ACTIONS(13400),
    [anon_sym_macro] = ACTIONS(13400),
    [anon_sym_where] = ACTIONS(13400),
    [anon_sym_quote] = ACTIONS(13400),
    [anon_sym_let] = ACTIONS(13400),
    [anon_sym_if] = ACTIONS(13400),
    [anon_sym_try] = ACTIONS(13400),
    [anon_sym_for] = ACTIONS(13400),
    [anon_sym_while] = ACTIONS(13400),
    [sym_break_statement] = ACTIONS(13400),
    [sym_continue_statement] = ACTIONS(13400),
    [anon_sym_return] = ACTIONS(13400),
    [anon_sym_const] = ACTIONS(13400),
    [anon_sym_global] = ACTIONS(13400),
    [anon_sym_local] = ACTIONS(13400),
    [anon_sym_LPAREN] = ACTIONS(13402),
    [anon_sym_RPAREN] = ACTIONS(13402),
    [anon_sym_COLON2] = ACTIONS(13400),
    [anon_sym_export] = ACTIONS(13400),
    [anon_sym_import] = ACTIONS(13400),
    [anon_sym_using] = ACTIONS(13400),
    [anon_sym_LBRACK] = ACTIONS(13402),
    [anon_sym_RBRACK] = ACTIONS(13402),
    [anon_sym_in] = ACTIONS(13400),
    [anon_sym_SEMI] = ACTIONS(13402),
    [anon_sym_LBRACE] = ACTIONS(13402),
    [anon_sym_RBRACE] = ACTIONS(13402),
    [anon_sym_DOLLAR] = ACTIONS(13402),
    [anon_sym_COLON_COLON] = ACTIONS(13402),
    [anon_sym_isa] = ACTIONS(13400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13402),
    [anon_sym_QMARK] = ACTIONS(13402),
    [anon_sym_AT] = ACTIONS(13402),
    [anon_sym_true] = ACTIONS(13400),
    [anon_sym_false] = ACTIONS(13400),
    [aux_sym_integer_literal_token1] = ACTIONS(13402),
    [aux_sym_integer_literal_token2] = ACTIONS(13402),
    [aux_sym_integer_literal_token3] = ACTIONS(13400),
    [aux_sym_integer_literal_token4] = ACTIONS(13400),
    [aux_sym_float_literal_token1] = ACTIONS(13402),
    [aux_sym_float_literal_token3] = ACTIONS(13402),
    [aux_sym_float_literal_token4] = ACTIONS(13402),
    [sym_character_literal] = ACTIONS(13402),
    [sym__pair_operator] = ACTIONS(13402),
    [sym__arrow_operator] = ACTIONS(13400),
    [sym__lazy_or_operator] = ACTIONS(13402),
    [sym__lazy_and_operator] = ACTIONS(13402),
    [sym__comparison_operator] = ACTIONS(13400),
    [sym__pipe_right_operator] = ACTIONS(13402),
    [sym__pipe_left_operator] = ACTIONS(13402),
    [sym__ellipsis_operator] = ACTIONS(13400),
    [sym__plus_operator] = ACTIONS(13400),
    [sym__times_operator] = ACTIONS(13400),
    [sym__rational_operator] = ACTIONS(13402),
    [sym__bitshift_operator] = ACTIONS(13402),
    [sym__power_operator] = ACTIONS(13402),
    [sym__tilde_operator] = ACTIONS(13402),
    [sym__type_order_operator] = ACTIONS(13402),
    [sym__unary_operator] = ACTIONS(13400),
    [sym__unary_plus_operator] = ACTIONS(13400),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13402),
    [sym__command_start] = ACTIONS(13402),
  },
  [8570] = {
    [sym__word_identifier] = ACTIONS(13542),
    [anon_sym_EQ] = ACTIONS(13542),
    [anon_sym_COMMA] = ACTIONS(13542),
    [anon_sym_COLON] = ACTIONS(13542),
    [anon_sym_begin] = ACTIONS(13542),
    [anon_sym_module] = ACTIONS(13542),
    [anon_sym_baremodule] = ACTIONS(13542),
    [anon_sym_end] = ACTIONS(13542),
    [anon_sym_abstract] = ACTIONS(13542),
    [anon_sym_primitive] = ACTIONS(13542),
    [anon_sym_mutable] = ACTIONS(13542),
    [anon_sym_struct] = ACTIONS(13542),
    [anon_sym_function] = ACTIONS(13542),
    [anon_sym_macro] = ACTIONS(13542),
    [anon_sym_where] = ACTIONS(13542),
    [anon_sym_quote] = ACTIONS(13542),
    [anon_sym_let] = ACTIONS(13542),
    [anon_sym_if] = ACTIONS(13542),
    [anon_sym_try] = ACTIONS(13542),
    [anon_sym_catch] = ACTIONS(13542),
    [anon_sym_for] = ACTIONS(13542),
    [anon_sym_while] = ACTIONS(13542),
    [sym_break_statement] = ACTIONS(13542),
    [sym_continue_statement] = ACTIONS(13542),
    [anon_sym_return] = ACTIONS(13542),
    [anon_sym_const] = ACTIONS(13542),
    [anon_sym_global] = ACTIONS(13542),
    [anon_sym_local] = ACTIONS(13542),
    [anon_sym_LPAREN] = ACTIONS(13542),
    [anon_sym_COLON2] = ACTIONS(13542),
    [anon_sym_export] = ACTIONS(13542),
    [anon_sym_import] = ACTIONS(13542),
    [anon_sym_using] = ACTIONS(13542),
    [anon_sym_LBRACK] = ACTIONS(13542),
    [anon_sym_LF] = ACTIONS(13544),
    [anon_sym_in] = ACTIONS(13542),
    [anon_sym_LBRACE] = ACTIONS(13542),
    [anon_sym_DOLLAR] = ACTIONS(13542),
    [anon_sym_COLON_COLON] = ACTIONS(13542),
    [anon_sym_isa] = ACTIONS(13542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13542),
    [anon_sym_QMARK] = ACTIONS(13542),
    [anon_sym_AT] = ACTIONS(13542),
    [anon_sym_true] = ACTIONS(13542),
    [anon_sym_false] = ACTIONS(13542),
    [aux_sym_integer_literal_token1] = ACTIONS(13542),
    [aux_sym_integer_literal_token2] = ACTIONS(13542),
    [aux_sym_integer_literal_token3] = ACTIONS(13542),
    [aux_sym_integer_literal_token4] = ACTIONS(13542),
    [aux_sym_float_literal_token1] = ACTIONS(13542),
    [aux_sym_float_literal_token3] = ACTIONS(13542),
    [aux_sym_float_literal_token4] = ACTIONS(13542),
    [sym_character_literal] = ACTIONS(13542),
    [sym__pair_operator] = ACTIONS(13542),
    [sym__arrow_operator] = ACTIONS(13542),
    [sym__lazy_or_operator] = ACTIONS(13542),
    [sym__lazy_and_operator] = ACTIONS(13542),
    [sym__comparison_operator] = ACTIONS(13542),
    [sym__pipe_right_operator] = ACTIONS(13542),
    [sym__pipe_left_operator] = ACTIONS(13542),
    [sym__ellipsis_operator] = ACTIONS(13542),
    [sym__plus_operator] = ACTIONS(13542),
    [sym__times_operator] = ACTIONS(13542),
    [sym__rational_operator] = ACTIONS(13542),
    [sym__bitshift_operator] = ACTIONS(13542),
    [sym__power_operator] = ACTIONS(13542),
    [sym__tilde_operator] = ACTIONS(13542),
    [sym__type_order_operator] = ACTIONS(13542),
    [sym__unary_operator] = ACTIONS(13542),
    [sym__unary_plus_operator] = ACTIONS(13542),
    [aux_sym__terminator_token1] = ACTIONS(13542),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13544),
    [sym__command_start] = ACTIONS(13544),
  },
  [8571] = {
    [sym__word_identifier] = ACTIONS(13407),
    [anon_sym_EQ] = ACTIONS(13407),
    [anon_sym_COMMA] = ACTIONS(13409),
    [anon_sym_COLON] = ACTIONS(13407),
    [anon_sym_begin] = ACTIONS(13407),
    [anon_sym_module] = ACTIONS(13407),
    [anon_sym_baremodule] = ACTIONS(13407),
    [anon_sym_abstract] = ACTIONS(13407),
    [anon_sym_primitive] = ACTIONS(13407),
    [anon_sym_mutable] = ACTIONS(13407),
    [anon_sym_struct] = ACTIONS(13407),
    [anon_sym_function] = ACTIONS(13407),
    [anon_sym_macro] = ACTIONS(13407),
    [anon_sym_where] = ACTIONS(13407),
    [anon_sym_quote] = ACTIONS(13407),
    [anon_sym_let] = ACTIONS(13407),
    [anon_sym_if] = ACTIONS(13407),
    [anon_sym_try] = ACTIONS(13407),
    [anon_sym_for] = ACTIONS(13407),
    [anon_sym_while] = ACTIONS(13407),
    [sym_break_statement] = ACTIONS(13407),
    [sym_continue_statement] = ACTIONS(13407),
    [anon_sym_return] = ACTIONS(13407),
    [anon_sym_const] = ACTIONS(13407),
    [anon_sym_global] = ACTIONS(13407),
    [anon_sym_local] = ACTIONS(13407),
    [anon_sym_LPAREN] = ACTIONS(13409),
    [anon_sym_RPAREN] = ACTIONS(13409),
    [anon_sym_COLON2] = ACTIONS(13407),
    [anon_sym_export] = ACTIONS(13407),
    [anon_sym_import] = ACTIONS(13407),
    [anon_sym_using] = ACTIONS(13407),
    [anon_sym_LBRACK] = ACTIONS(13409),
    [anon_sym_RBRACK] = ACTIONS(13409),
    [anon_sym_in] = ACTIONS(13407),
    [anon_sym_SEMI] = ACTIONS(13409),
    [anon_sym_LBRACE] = ACTIONS(13409),
    [anon_sym_RBRACE] = ACTIONS(13409),
    [anon_sym_DOLLAR] = ACTIONS(13409),
    [anon_sym_COLON_COLON] = ACTIONS(13409),
    [anon_sym_isa] = ACTIONS(13407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13409),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_AT] = ACTIONS(13409),
    [anon_sym_true] = ACTIONS(13407),
    [anon_sym_false] = ACTIONS(13407),
    [aux_sym_integer_literal_token1] = ACTIONS(13409),
    [aux_sym_integer_literal_token2] = ACTIONS(13409),
    [aux_sym_integer_literal_token3] = ACTIONS(13407),
    [aux_sym_integer_literal_token4] = ACTIONS(13407),
    [aux_sym_float_literal_token1] = ACTIONS(13409),
    [aux_sym_float_literal_token3] = ACTIONS(13409),
    [aux_sym_float_literal_token4] = ACTIONS(13409),
    [sym_character_literal] = ACTIONS(13409),
    [sym__pair_operator] = ACTIONS(13409),
    [sym__arrow_operator] = ACTIONS(13407),
    [sym__lazy_or_operator] = ACTIONS(13409),
    [sym__lazy_and_operator] = ACTIONS(13409),
    [sym__comparison_operator] = ACTIONS(13407),
    [sym__pipe_right_operator] = ACTIONS(13409),
    [sym__pipe_left_operator] = ACTIONS(13409),
    [sym__ellipsis_operator] = ACTIONS(13407),
    [sym__plus_operator] = ACTIONS(13407),
    [sym__times_operator] = ACTIONS(13407),
    [sym__rational_operator] = ACTIONS(13409),
    [sym__bitshift_operator] = ACTIONS(13409),
    [sym__power_operator] = ACTIONS(13409),
    [sym__tilde_operator] = ACTIONS(13409),
    [sym__type_order_operator] = ACTIONS(13409),
    [sym__unary_operator] = ACTIONS(13407),
    [sym__unary_plus_operator] = ACTIONS(13407),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13409),
    [sym__command_start] = ACTIONS(13409),
  },
  [8572] = {
    [sym__word_identifier] = ACTIONS(13546),
    [anon_sym_EQ] = ACTIONS(13546),
    [anon_sym_COMMA] = ACTIONS(13546),
    [anon_sym_COLON] = ACTIONS(13546),
    [anon_sym_begin] = ACTIONS(13546),
    [anon_sym_module] = ACTIONS(13546),
    [anon_sym_baremodule] = ACTIONS(13546),
    [anon_sym_end] = ACTIONS(13546),
    [anon_sym_abstract] = ACTIONS(13546),
    [anon_sym_primitive] = ACTIONS(13546),
    [anon_sym_mutable] = ACTIONS(13546),
    [anon_sym_struct] = ACTIONS(13546),
    [anon_sym_function] = ACTIONS(13546),
    [anon_sym_macro] = ACTIONS(13546),
    [anon_sym_where] = ACTIONS(13546),
    [anon_sym_quote] = ACTIONS(13546),
    [anon_sym_let] = ACTIONS(13546),
    [anon_sym_if] = ACTIONS(13546),
    [anon_sym_try] = ACTIONS(13546),
    [anon_sym_catch] = ACTIONS(13546),
    [anon_sym_for] = ACTIONS(13546),
    [anon_sym_while] = ACTIONS(13546),
    [sym_break_statement] = ACTIONS(13546),
    [sym_continue_statement] = ACTIONS(13546),
    [anon_sym_return] = ACTIONS(13546),
    [anon_sym_const] = ACTIONS(13546),
    [anon_sym_global] = ACTIONS(13546),
    [anon_sym_local] = ACTIONS(13546),
    [anon_sym_LPAREN] = ACTIONS(13546),
    [anon_sym_COLON2] = ACTIONS(13546),
    [anon_sym_export] = ACTIONS(13546),
    [anon_sym_import] = ACTIONS(13546),
    [anon_sym_using] = ACTIONS(13546),
    [anon_sym_LBRACK] = ACTIONS(13546),
    [anon_sym_LF] = ACTIONS(13548),
    [anon_sym_in] = ACTIONS(13546),
    [anon_sym_LBRACE] = ACTIONS(13546),
    [anon_sym_DOLLAR] = ACTIONS(13546),
    [anon_sym_COLON_COLON] = ACTIONS(13546),
    [anon_sym_isa] = ACTIONS(13546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13546),
    [anon_sym_QMARK] = ACTIONS(13546),
    [anon_sym_AT] = ACTIONS(13546),
    [anon_sym_true] = ACTIONS(13546),
    [anon_sym_false] = ACTIONS(13546),
    [aux_sym_integer_literal_token1] = ACTIONS(13546),
    [aux_sym_integer_literal_token2] = ACTIONS(13546),
    [aux_sym_integer_literal_token3] = ACTIONS(13546),
    [aux_sym_integer_literal_token4] = ACTIONS(13546),
    [aux_sym_float_literal_token1] = ACTIONS(13546),
    [aux_sym_float_literal_token3] = ACTIONS(13546),
    [aux_sym_float_literal_token4] = ACTIONS(13546),
    [sym_character_literal] = ACTIONS(13546),
    [sym__pair_operator] = ACTIONS(13546),
    [sym__arrow_operator] = ACTIONS(13546),
    [sym__lazy_or_operator] = ACTIONS(13546),
    [sym__lazy_and_operator] = ACTIONS(13546),
    [sym__comparison_operator] = ACTIONS(13546),
    [sym__pipe_right_operator] = ACTIONS(13546),
    [sym__pipe_left_operator] = ACTIONS(13546),
    [sym__ellipsis_operator] = ACTIONS(13546),
    [sym__plus_operator] = ACTIONS(13546),
    [sym__times_operator] = ACTIONS(13546),
    [sym__rational_operator] = ACTIONS(13546),
    [sym__bitshift_operator] = ACTIONS(13546),
    [sym__power_operator] = ACTIONS(13546),
    [sym__tilde_operator] = ACTIONS(13546),
    [sym__type_order_operator] = ACTIONS(13546),
    [sym__unary_operator] = ACTIONS(13546),
    [sym__unary_plus_operator] = ACTIONS(13546),
    [aux_sym__terminator_token1] = ACTIONS(13546),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13548),
    [sym__command_start] = ACTIONS(13548),
  },
  [8573] = {
    [sym__word_identifier] = ACTIONS(13598),
    [anon_sym_EQ] = ACTIONS(13598),
    [anon_sym_COMMA] = ACTIONS(13598),
    [anon_sym_COLON] = ACTIONS(13598),
    [anon_sym_begin] = ACTIONS(13598),
    [anon_sym_module] = ACTIONS(13598),
    [anon_sym_baremodule] = ACTIONS(13598),
    [anon_sym_abstract] = ACTIONS(13598),
    [anon_sym_primitive] = ACTIONS(13598),
    [anon_sym_mutable] = ACTIONS(13598),
    [anon_sym_struct] = ACTIONS(13598),
    [anon_sym_function] = ACTIONS(13598),
    [anon_sym_macro] = ACTIONS(13598),
    [anon_sym_where] = ACTIONS(13598),
    [anon_sym_quote] = ACTIONS(13598),
    [anon_sym_let] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(13598),
    [anon_sym_try] = ACTIONS(13598),
    [anon_sym_catch] = ACTIONS(13598),
    [anon_sym_finally] = ACTIONS(13598),
    [anon_sym_for] = ACTIONS(13598),
    [anon_sym_while] = ACTIONS(13598),
    [sym_break_statement] = ACTIONS(13598),
    [sym_continue_statement] = ACTIONS(13598),
    [anon_sym_return] = ACTIONS(13598),
    [anon_sym_const] = ACTIONS(13598),
    [anon_sym_global] = ACTIONS(13598),
    [anon_sym_local] = ACTIONS(13598),
    [anon_sym_LPAREN] = ACTIONS(13598),
    [anon_sym_COLON2] = ACTIONS(13598),
    [anon_sym_export] = ACTIONS(13598),
    [anon_sym_import] = ACTIONS(13598),
    [anon_sym_using] = ACTIONS(13598),
    [anon_sym_LBRACK] = ACTIONS(13598),
    [anon_sym_LF] = ACTIONS(13600),
    [anon_sym_in] = ACTIONS(13598),
    [anon_sym_LBRACE] = ACTIONS(13598),
    [anon_sym_DOLLAR] = ACTIONS(13598),
    [anon_sym_COLON_COLON] = ACTIONS(13598),
    [anon_sym_isa] = ACTIONS(13598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13598),
    [anon_sym_QMARK] = ACTIONS(13598),
    [anon_sym_AT] = ACTIONS(13598),
    [anon_sym_true] = ACTIONS(13598),
    [anon_sym_false] = ACTIONS(13598),
    [aux_sym_integer_literal_token1] = ACTIONS(13598),
    [aux_sym_integer_literal_token2] = ACTIONS(13598),
    [aux_sym_integer_literal_token3] = ACTIONS(13598),
    [aux_sym_integer_literal_token4] = ACTIONS(13598),
    [aux_sym_float_literal_token1] = ACTIONS(13598),
    [aux_sym_float_literal_token3] = ACTIONS(13598),
    [aux_sym_float_literal_token4] = ACTIONS(13598),
    [sym_character_literal] = ACTIONS(13598),
    [sym__pair_operator] = ACTIONS(13598),
    [sym__arrow_operator] = ACTIONS(13598),
    [sym__lazy_or_operator] = ACTIONS(13598),
    [sym__lazy_and_operator] = ACTIONS(13598),
    [sym__comparison_operator] = ACTIONS(13598),
    [sym__pipe_right_operator] = ACTIONS(13598),
    [sym__pipe_left_operator] = ACTIONS(13598),
    [sym__ellipsis_operator] = ACTIONS(13598),
    [sym__plus_operator] = ACTIONS(13598),
    [sym__times_operator] = ACTIONS(13598),
    [sym__rational_operator] = ACTIONS(13598),
    [sym__bitshift_operator] = ACTIONS(13598),
    [sym__power_operator] = ACTIONS(13598),
    [sym__tilde_operator] = ACTIONS(13598),
    [sym__type_order_operator] = ACTIONS(13598),
    [sym__unary_operator] = ACTIONS(13598),
    [sym__unary_plus_operator] = ACTIONS(13598),
    [aux_sym__terminator_token1] = ACTIONS(13598),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13600),
    [sym__command_start] = ACTIONS(13600),
  },
  [8574] = {
    [sym__word_identifier] = ACTIONS(13550),
    [anon_sym_EQ] = ACTIONS(13550),
    [anon_sym_COMMA] = ACTIONS(13550),
    [anon_sym_COLON] = ACTIONS(13550),
    [anon_sym_begin] = ACTIONS(13550),
    [anon_sym_module] = ACTIONS(13550),
    [anon_sym_baremodule] = ACTIONS(13550),
    [anon_sym_end] = ACTIONS(13550),
    [anon_sym_abstract] = ACTIONS(13550),
    [anon_sym_primitive] = ACTIONS(13550),
    [anon_sym_mutable] = ACTIONS(13550),
    [anon_sym_struct] = ACTIONS(13550),
    [anon_sym_function] = ACTIONS(13550),
    [anon_sym_macro] = ACTIONS(13550),
    [anon_sym_where] = ACTIONS(13550),
    [anon_sym_quote] = ACTIONS(13550),
    [anon_sym_let] = ACTIONS(13550),
    [anon_sym_if] = ACTIONS(13550),
    [anon_sym_try] = ACTIONS(13550),
    [anon_sym_catch] = ACTIONS(13550),
    [anon_sym_for] = ACTIONS(13550),
    [anon_sym_while] = ACTIONS(13550),
    [sym_break_statement] = ACTIONS(13550),
    [sym_continue_statement] = ACTIONS(13550),
    [anon_sym_return] = ACTIONS(13550),
    [anon_sym_const] = ACTIONS(13550),
    [anon_sym_global] = ACTIONS(13550),
    [anon_sym_local] = ACTIONS(13550),
    [anon_sym_LPAREN] = ACTIONS(13550),
    [anon_sym_COLON2] = ACTIONS(13550),
    [anon_sym_export] = ACTIONS(13550),
    [anon_sym_import] = ACTIONS(13550),
    [anon_sym_using] = ACTIONS(13550),
    [anon_sym_LBRACK] = ACTIONS(13550),
    [anon_sym_LF] = ACTIONS(13552),
    [anon_sym_in] = ACTIONS(13550),
    [anon_sym_LBRACE] = ACTIONS(13550),
    [anon_sym_DOLLAR] = ACTIONS(13550),
    [anon_sym_COLON_COLON] = ACTIONS(13550),
    [anon_sym_isa] = ACTIONS(13550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13550),
    [anon_sym_QMARK] = ACTIONS(13550),
    [anon_sym_AT] = ACTIONS(13550),
    [anon_sym_true] = ACTIONS(13550),
    [anon_sym_false] = ACTIONS(13550),
    [aux_sym_integer_literal_token1] = ACTIONS(13550),
    [aux_sym_integer_literal_token2] = ACTIONS(13550),
    [aux_sym_integer_literal_token3] = ACTIONS(13550),
    [aux_sym_integer_literal_token4] = ACTIONS(13550),
    [aux_sym_float_literal_token1] = ACTIONS(13550),
    [aux_sym_float_literal_token3] = ACTIONS(13550),
    [aux_sym_float_literal_token4] = ACTIONS(13550),
    [sym_character_literal] = ACTIONS(13550),
    [sym__pair_operator] = ACTIONS(13550),
    [sym__arrow_operator] = ACTIONS(13550),
    [sym__lazy_or_operator] = ACTIONS(13550),
    [sym__lazy_and_operator] = ACTIONS(13550),
    [sym__comparison_operator] = ACTIONS(13550),
    [sym__pipe_right_operator] = ACTIONS(13550),
    [sym__pipe_left_operator] = ACTIONS(13550),
    [sym__ellipsis_operator] = ACTIONS(13550),
    [sym__plus_operator] = ACTIONS(13550),
    [sym__times_operator] = ACTIONS(13550),
    [sym__rational_operator] = ACTIONS(13550),
    [sym__bitshift_operator] = ACTIONS(13550),
    [sym__power_operator] = ACTIONS(13550),
    [sym__tilde_operator] = ACTIONS(13550),
    [sym__type_order_operator] = ACTIONS(13550),
    [sym__unary_operator] = ACTIONS(13550),
    [sym__unary_plus_operator] = ACTIONS(13550),
    [aux_sym__terminator_token1] = ACTIONS(13550),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13552),
    [sym__command_start] = ACTIONS(13552),
  },
  [8575] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14409),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_catch] = ACTIONS(13094),
    [anon_sym_finally] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(14411),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14413),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(14423),
    [sym__lazy_or_operator] = ACTIONS(14425),
    [sym__lazy_and_operator] = ACTIONS(14427),
    [sym__comparison_operator] = ACTIONS(14413),
    [sym__pipe_right_operator] = ACTIONS(14429),
    [sym__pipe_left_operator] = ACTIONS(14431),
    [sym__ellipsis_operator] = ACTIONS(14433),
    [sym__plus_operator] = ACTIONS(14435),
    [sym__times_operator] = ACTIONS(14437),
    [sym__rational_operator] = ACTIONS(14439),
    [sym__bitshift_operator] = ACTIONS(14441),
    [sym__power_operator] = ACTIONS(14443),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(14413),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14435),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8576] = {
    [sym__word_identifier] = ACTIONS(13554),
    [anon_sym_EQ] = ACTIONS(13554),
    [anon_sym_COMMA] = ACTIONS(13554),
    [anon_sym_COLON] = ACTIONS(13554),
    [anon_sym_begin] = ACTIONS(13554),
    [anon_sym_module] = ACTIONS(13554),
    [anon_sym_baremodule] = ACTIONS(13554),
    [anon_sym_end] = ACTIONS(13554),
    [anon_sym_abstract] = ACTIONS(13554),
    [anon_sym_primitive] = ACTIONS(13554),
    [anon_sym_mutable] = ACTIONS(13554),
    [anon_sym_struct] = ACTIONS(13554),
    [anon_sym_function] = ACTIONS(13554),
    [anon_sym_macro] = ACTIONS(13554),
    [anon_sym_where] = ACTIONS(13554),
    [anon_sym_quote] = ACTIONS(13554),
    [anon_sym_let] = ACTIONS(13554),
    [anon_sym_if] = ACTIONS(13554),
    [anon_sym_try] = ACTIONS(13554),
    [anon_sym_catch] = ACTIONS(13554),
    [anon_sym_for] = ACTIONS(13554),
    [anon_sym_while] = ACTIONS(13554),
    [sym_break_statement] = ACTIONS(13554),
    [sym_continue_statement] = ACTIONS(13554),
    [anon_sym_return] = ACTIONS(13554),
    [anon_sym_const] = ACTIONS(13554),
    [anon_sym_global] = ACTIONS(13554),
    [anon_sym_local] = ACTIONS(13554),
    [anon_sym_LPAREN] = ACTIONS(13554),
    [anon_sym_COLON2] = ACTIONS(13554),
    [anon_sym_export] = ACTIONS(13554),
    [anon_sym_import] = ACTIONS(13554),
    [anon_sym_using] = ACTIONS(13554),
    [anon_sym_LBRACK] = ACTIONS(13554),
    [anon_sym_LF] = ACTIONS(13556),
    [anon_sym_in] = ACTIONS(13554),
    [anon_sym_LBRACE] = ACTIONS(13554),
    [anon_sym_DOLLAR] = ACTIONS(13554),
    [anon_sym_COLON_COLON] = ACTIONS(13554),
    [anon_sym_isa] = ACTIONS(13554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13554),
    [anon_sym_QMARK] = ACTIONS(13554),
    [anon_sym_AT] = ACTIONS(13554),
    [anon_sym_true] = ACTIONS(13554),
    [anon_sym_false] = ACTIONS(13554),
    [aux_sym_integer_literal_token1] = ACTIONS(13554),
    [aux_sym_integer_literal_token2] = ACTIONS(13554),
    [aux_sym_integer_literal_token3] = ACTIONS(13554),
    [aux_sym_integer_literal_token4] = ACTIONS(13554),
    [aux_sym_float_literal_token1] = ACTIONS(13554),
    [aux_sym_float_literal_token3] = ACTIONS(13554),
    [aux_sym_float_literal_token4] = ACTIONS(13554),
    [sym_character_literal] = ACTIONS(13554),
    [sym__pair_operator] = ACTIONS(13554),
    [sym__arrow_operator] = ACTIONS(13554),
    [sym__lazy_or_operator] = ACTIONS(13554),
    [sym__lazy_and_operator] = ACTIONS(13554),
    [sym__comparison_operator] = ACTIONS(13554),
    [sym__pipe_right_operator] = ACTIONS(13554),
    [sym__pipe_left_operator] = ACTIONS(13554),
    [sym__ellipsis_operator] = ACTIONS(13554),
    [sym__plus_operator] = ACTIONS(13554),
    [sym__times_operator] = ACTIONS(13554),
    [sym__rational_operator] = ACTIONS(13554),
    [sym__bitshift_operator] = ACTIONS(13554),
    [sym__power_operator] = ACTIONS(13554),
    [sym__tilde_operator] = ACTIONS(13554),
    [sym__type_order_operator] = ACTIONS(13554),
    [sym__unary_operator] = ACTIONS(13554),
    [sym__unary_plus_operator] = ACTIONS(13554),
    [aux_sym__terminator_token1] = ACTIONS(13554),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13556),
    [sym__command_start] = ACTIONS(13556),
  },
  [8577] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12660),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8578] = {
    [sym__word_identifier] = ACTIONS(13558),
    [anon_sym_EQ] = ACTIONS(13558),
    [anon_sym_COMMA] = ACTIONS(13558),
    [anon_sym_COLON] = ACTIONS(13558),
    [anon_sym_begin] = ACTIONS(13558),
    [anon_sym_module] = ACTIONS(13558),
    [anon_sym_baremodule] = ACTIONS(13558),
    [anon_sym_end] = ACTIONS(13558),
    [anon_sym_abstract] = ACTIONS(13558),
    [anon_sym_primitive] = ACTIONS(13558),
    [anon_sym_mutable] = ACTIONS(13558),
    [anon_sym_struct] = ACTIONS(13558),
    [anon_sym_function] = ACTIONS(13558),
    [anon_sym_macro] = ACTIONS(13558),
    [anon_sym_where] = ACTIONS(13558),
    [anon_sym_quote] = ACTIONS(13558),
    [anon_sym_let] = ACTIONS(13558),
    [anon_sym_if] = ACTIONS(13558),
    [anon_sym_try] = ACTIONS(13558),
    [anon_sym_catch] = ACTIONS(13558),
    [anon_sym_for] = ACTIONS(13558),
    [anon_sym_while] = ACTIONS(13558),
    [sym_break_statement] = ACTIONS(13558),
    [sym_continue_statement] = ACTIONS(13558),
    [anon_sym_return] = ACTIONS(13558),
    [anon_sym_const] = ACTIONS(13558),
    [anon_sym_global] = ACTIONS(13558),
    [anon_sym_local] = ACTIONS(13558),
    [anon_sym_LPAREN] = ACTIONS(13558),
    [anon_sym_COLON2] = ACTIONS(13558),
    [anon_sym_export] = ACTIONS(13558),
    [anon_sym_import] = ACTIONS(13558),
    [anon_sym_using] = ACTIONS(13558),
    [anon_sym_LBRACK] = ACTIONS(13558),
    [anon_sym_LF] = ACTIONS(13560),
    [anon_sym_in] = ACTIONS(13558),
    [anon_sym_LBRACE] = ACTIONS(13558),
    [anon_sym_DOLLAR] = ACTIONS(13558),
    [anon_sym_COLON_COLON] = ACTIONS(13558),
    [anon_sym_isa] = ACTIONS(13558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13558),
    [anon_sym_QMARK] = ACTIONS(13558),
    [anon_sym_AT] = ACTIONS(13558),
    [anon_sym_true] = ACTIONS(13558),
    [anon_sym_false] = ACTIONS(13558),
    [aux_sym_integer_literal_token1] = ACTIONS(13558),
    [aux_sym_integer_literal_token2] = ACTIONS(13558),
    [aux_sym_integer_literal_token3] = ACTIONS(13558),
    [aux_sym_integer_literal_token4] = ACTIONS(13558),
    [aux_sym_float_literal_token1] = ACTIONS(13558),
    [aux_sym_float_literal_token3] = ACTIONS(13558),
    [aux_sym_float_literal_token4] = ACTIONS(13558),
    [sym_character_literal] = ACTIONS(13558),
    [sym__pair_operator] = ACTIONS(13558),
    [sym__arrow_operator] = ACTIONS(13558),
    [sym__lazy_or_operator] = ACTIONS(13558),
    [sym__lazy_and_operator] = ACTIONS(13558),
    [sym__comparison_operator] = ACTIONS(13558),
    [sym__pipe_right_operator] = ACTIONS(13558),
    [sym__pipe_left_operator] = ACTIONS(13558),
    [sym__ellipsis_operator] = ACTIONS(13558),
    [sym__plus_operator] = ACTIONS(13558),
    [sym__times_operator] = ACTIONS(13558),
    [sym__rational_operator] = ACTIONS(13558),
    [sym__bitshift_operator] = ACTIONS(13558),
    [sym__power_operator] = ACTIONS(13558),
    [sym__tilde_operator] = ACTIONS(13558),
    [sym__type_order_operator] = ACTIONS(13558),
    [sym__unary_operator] = ACTIONS(13558),
    [sym__unary_plus_operator] = ACTIONS(13558),
    [aux_sym__terminator_token1] = ACTIONS(13558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13560),
    [sym__command_start] = ACTIONS(13560),
  },
  [8579] = {
    [sym__word_identifier] = ACTIONS(13562),
    [anon_sym_EQ] = ACTIONS(13562),
    [anon_sym_COMMA] = ACTIONS(13562),
    [anon_sym_COLON] = ACTIONS(13562),
    [anon_sym_begin] = ACTIONS(13562),
    [anon_sym_module] = ACTIONS(13562),
    [anon_sym_baremodule] = ACTIONS(13562),
    [anon_sym_end] = ACTIONS(13562),
    [anon_sym_abstract] = ACTIONS(13562),
    [anon_sym_primitive] = ACTIONS(13562),
    [anon_sym_mutable] = ACTIONS(13562),
    [anon_sym_struct] = ACTIONS(13562),
    [anon_sym_function] = ACTIONS(13562),
    [anon_sym_macro] = ACTIONS(13562),
    [anon_sym_where] = ACTIONS(13562),
    [anon_sym_quote] = ACTIONS(13562),
    [anon_sym_let] = ACTIONS(13562),
    [anon_sym_if] = ACTIONS(13562),
    [anon_sym_try] = ACTIONS(13562),
    [anon_sym_catch] = ACTIONS(13562),
    [anon_sym_for] = ACTIONS(13562),
    [anon_sym_while] = ACTIONS(13562),
    [sym_break_statement] = ACTIONS(13562),
    [sym_continue_statement] = ACTIONS(13562),
    [anon_sym_return] = ACTIONS(13562),
    [anon_sym_const] = ACTIONS(13562),
    [anon_sym_global] = ACTIONS(13562),
    [anon_sym_local] = ACTIONS(13562),
    [anon_sym_LPAREN] = ACTIONS(13562),
    [anon_sym_COLON2] = ACTIONS(13562),
    [anon_sym_export] = ACTIONS(13562),
    [anon_sym_import] = ACTIONS(13562),
    [anon_sym_using] = ACTIONS(13562),
    [anon_sym_LBRACK] = ACTIONS(13562),
    [anon_sym_LF] = ACTIONS(13564),
    [anon_sym_in] = ACTIONS(13562),
    [anon_sym_LBRACE] = ACTIONS(13562),
    [anon_sym_DOLLAR] = ACTIONS(13562),
    [anon_sym_COLON_COLON] = ACTIONS(13562),
    [anon_sym_isa] = ACTIONS(13562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13562),
    [anon_sym_QMARK] = ACTIONS(13562),
    [anon_sym_AT] = ACTIONS(13562),
    [anon_sym_true] = ACTIONS(13562),
    [anon_sym_false] = ACTIONS(13562),
    [aux_sym_integer_literal_token1] = ACTIONS(13562),
    [aux_sym_integer_literal_token2] = ACTIONS(13562),
    [aux_sym_integer_literal_token3] = ACTIONS(13562),
    [aux_sym_integer_literal_token4] = ACTIONS(13562),
    [aux_sym_float_literal_token1] = ACTIONS(13562),
    [aux_sym_float_literal_token3] = ACTIONS(13562),
    [aux_sym_float_literal_token4] = ACTIONS(13562),
    [sym_character_literal] = ACTIONS(13562),
    [sym__pair_operator] = ACTIONS(13562),
    [sym__arrow_operator] = ACTIONS(13562),
    [sym__lazy_or_operator] = ACTIONS(13562),
    [sym__lazy_and_operator] = ACTIONS(13562),
    [sym__comparison_operator] = ACTIONS(13562),
    [sym__pipe_right_operator] = ACTIONS(13562),
    [sym__pipe_left_operator] = ACTIONS(13562),
    [sym__ellipsis_operator] = ACTIONS(13562),
    [sym__plus_operator] = ACTIONS(13562),
    [sym__times_operator] = ACTIONS(13562),
    [sym__rational_operator] = ACTIONS(13562),
    [sym__bitshift_operator] = ACTIONS(13562),
    [sym__power_operator] = ACTIONS(13562),
    [sym__tilde_operator] = ACTIONS(13562),
    [sym__type_order_operator] = ACTIONS(13562),
    [sym__unary_operator] = ACTIONS(13562),
    [sym__unary_plus_operator] = ACTIONS(13562),
    [aux_sym__terminator_token1] = ACTIONS(13562),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13564),
    [sym__command_start] = ACTIONS(13564),
  },
  [8580] = {
    [sym__word_identifier] = ACTIONS(13602),
    [anon_sym_EQ] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(13602),
    [anon_sym_COLON] = ACTIONS(13602),
    [anon_sym_begin] = ACTIONS(13602),
    [anon_sym_module] = ACTIONS(13602),
    [anon_sym_baremodule] = ACTIONS(13602),
    [anon_sym_abstract] = ACTIONS(13602),
    [anon_sym_primitive] = ACTIONS(13602),
    [anon_sym_mutable] = ACTIONS(13602),
    [anon_sym_struct] = ACTIONS(13602),
    [anon_sym_function] = ACTIONS(13602),
    [anon_sym_macro] = ACTIONS(13602),
    [anon_sym_where] = ACTIONS(13602),
    [anon_sym_quote] = ACTIONS(13602),
    [anon_sym_let] = ACTIONS(13602),
    [anon_sym_if] = ACTIONS(13602),
    [anon_sym_try] = ACTIONS(13602),
    [anon_sym_catch] = ACTIONS(13602),
    [anon_sym_finally] = ACTIONS(13602),
    [anon_sym_for] = ACTIONS(13602),
    [anon_sym_while] = ACTIONS(13602),
    [sym_break_statement] = ACTIONS(13602),
    [sym_continue_statement] = ACTIONS(13602),
    [anon_sym_return] = ACTIONS(13602),
    [anon_sym_const] = ACTIONS(13602),
    [anon_sym_global] = ACTIONS(13602),
    [anon_sym_local] = ACTIONS(13602),
    [anon_sym_LPAREN] = ACTIONS(13602),
    [anon_sym_COLON2] = ACTIONS(13602),
    [anon_sym_export] = ACTIONS(13602),
    [anon_sym_import] = ACTIONS(13602),
    [anon_sym_using] = ACTIONS(13602),
    [anon_sym_LBRACK] = ACTIONS(13602),
    [anon_sym_LF] = ACTIONS(13604),
    [anon_sym_in] = ACTIONS(13602),
    [anon_sym_LBRACE] = ACTIONS(13602),
    [anon_sym_DOLLAR] = ACTIONS(13602),
    [anon_sym_COLON_COLON] = ACTIONS(13602),
    [anon_sym_isa] = ACTIONS(13602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13602),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_AT] = ACTIONS(13602),
    [anon_sym_true] = ACTIONS(13602),
    [anon_sym_false] = ACTIONS(13602),
    [aux_sym_integer_literal_token1] = ACTIONS(13602),
    [aux_sym_integer_literal_token2] = ACTIONS(13602),
    [aux_sym_integer_literal_token3] = ACTIONS(13602),
    [aux_sym_integer_literal_token4] = ACTIONS(13602),
    [aux_sym_float_literal_token1] = ACTIONS(13602),
    [aux_sym_float_literal_token3] = ACTIONS(13602),
    [aux_sym_float_literal_token4] = ACTIONS(13602),
    [sym_character_literal] = ACTIONS(13602),
    [sym__pair_operator] = ACTIONS(13602),
    [sym__arrow_operator] = ACTIONS(13602),
    [sym__lazy_or_operator] = ACTIONS(13602),
    [sym__lazy_and_operator] = ACTIONS(13602),
    [sym__comparison_operator] = ACTIONS(13602),
    [sym__pipe_right_operator] = ACTIONS(13602),
    [sym__pipe_left_operator] = ACTIONS(13602),
    [sym__ellipsis_operator] = ACTIONS(13602),
    [sym__plus_operator] = ACTIONS(13602),
    [sym__times_operator] = ACTIONS(13602),
    [sym__rational_operator] = ACTIONS(13602),
    [sym__bitshift_operator] = ACTIONS(13602),
    [sym__power_operator] = ACTIONS(13602),
    [sym__tilde_operator] = ACTIONS(13602),
    [sym__type_order_operator] = ACTIONS(13602),
    [sym__unary_operator] = ACTIONS(13602),
    [sym__unary_plus_operator] = ACTIONS(13602),
    [aux_sym__terminator_token1] = ACTIONS(13602),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13604),
    [sym__command_start] = ACTIONS(13604),
  },
  [8581] = {
    [aux_sym_open_tuple_repeat1] = STATE(8591),
    [sym__word_identifier] = ACTIONS(13150),
    [anon_sym_EQ] = ACTIONS(13150),
    [anon_sym_COMMA] = ACTIONS(14635),
    [anon_sym_COLON] = ACTIONS(13150),
    [anon_sym_begin] = ACTIONS(13150),
    [anon_sym_module] = ACTIONS(13150),
    [anon_sym_baremodule] = ACTIONS(13150),
    [anon_sym_abstract] = ACTIONS(13150),
    [anon_sym_primitive] = ACTIONS(13150),
    [anon_sym_mutable] = ACTIONS(13150),
    [anon_sym_struct] = ACTIONS(13150),
    [anon_sym_function] = ACTIONS(13150),
    [anon_sym_macro] = ACTIONS(13150),
    [anon_sym_where] = ACTIONS(13150),
    [anon_sym_quote] = ACTIONS(13150),
    [anon_sym_let] = ACTIONS(13150),
    [anon_sym_if] = ACTIONS(13150),
    [anon_sym_try] = ACTIONS(13150),
    [anon_sym_for] = ACTIONS(13150),
    [anon_sym_while] = ACTIONS(13150),
    [sym_break_statement] = ACTIONS(13150),
    [sym_continue_statement] = ACTIONS(13150),
    [anon_sym_return] = ACTIONS(13150),
    [anon_sym_const] = ACTIONS(13150),
    [anon_sym_global] = ACTIONS(13150),
    [anon_sym_local] = ACTIONS(13150),
    [anon_sym_LPAREN] = ACTIONS(13150),
    [anon_sym_RPAREN] = ACTIONS(13150),
    [anon_sym_COLON2] = ACTIONS(13150),
    [anon_sym_export] = ACTIONS(13150),
    [anon_sym_import] = ACTIONS(13150),
    [anon_sym_using] = ACTIONS(13150),
    [anon_sym_LBRACK] = ACTIONS(13150),
    [anon_sym_LF] = ACTIONS(13148),
    [anon_sym_in] = ACTIONS(13150),
    [anon_sym_SEMI] = ACTIONS(13150),
    [anon_sym_LBRACE] = ACTIONS(13150),
    [anon_sym_DOLLAR] = ACTIONS(13150),
    [anon_sym_COLON_COLON] = ACTIONS(13150),
    [anon_sym_isa] = ACTIONS(13150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13150),
    [anon_sym_QMARK] = ACTIONS(13150),
    [anon_sym_AT] = ACTIONS(13150),
    [anon_sym_true] = ACTIONS(13150),
    [anon_sym_false] = ACTIONS(13150),
    [aux_sym_integer_literal_token1] = ACTIONS(13150),
    [aux_sym_integer_literal_token2] = ACTIONS(13150),
    [aux_sym_integer_literal_token3] = ACTIONS(13150),
    [aux_sym_integer_literal_token4] = ACTIONS(13150),
    [aux_sym_float_literal_token1] = ACTIONS(13150),
    [aux_sym_float_literal_token3] = ACTIONS(13150),
    [aux_sym_float_literal_token4] = ACTIONS(13150),
    [sym_character_literal] = ACTIONS(13150),
    [sym__pair_operator] = ACTIONS(13150),
    [sym__arrow_operator] = ACTIONS(13150),
    [sym__lazy_or_operator] = ACTIONS(13150),
    [sym__lazy_and_operator] = ACTIONS(13150),
    [sym__comparison_operator] = ACTIONS(13150),
    [sym__pipe_right_operator] = ACTIONS(13150),
    [sym__pipe_left_operator] = ACTIONS(13150),
    [sym__ellipsis_operator] = ACTIONS(13150),
    [sym__plus_operator] = ACTIONS(13150),
    [sym__times_operator] = ACTIONS(13150),
    [sym__rational_operator] = ACTIONS(13150),
    [sym__bitshift_operator] = ACTIONS(13150),
    [sym__power_operator] = ACTIONS(13150),
    [sym__tilde_operator] = ACTIONS(13150),
    [sym__type_order_operator] = ACTIONS(13150),
    [sym__unary_operator] = ACTIONS(13150),
    [sym__unary_plus_operator] = ACTIONS(13150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13148),
    [sym__command_start] = ACTIONS(13148),
  },
  [8582] = {
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13094),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_catch] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13094),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13094),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13094),
    [anon_sym_isa] = ACTIONS(13094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13094),
    [anon_sym_QMARK] = ACTIONS(13094),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13094),
    [sym__lazy_or_operator] = ACTIONS(13094),
    [sym__lazy_and_operator] = ACTIONS(13094),
    [sym__comparison_operator] = ACTIONS(13094),
    [sym__pipe_right_operator] = ACTIONS(13094),
    [sym__pipe_left_operator] = ACTIONS(13094),
    [sym__ellipsis_operator] = ACTIONS(13094),
    [sym__plus_operator] = ACTIONS(13094),
    [sym__times_operator] = ACTIONS(13094),
    [sym__rational_operator] = ACTIONS(13094),
    [sym__bitshift_operator] = ACTIONS(13094),
    [sym__power_operator] = ACTIONS(13094),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13094),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13094),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8583] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_EQ] = ACTIONS(11888),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_RPAREN] = ACTIONS(11888),
    [anon_sym_COLON2] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11888),
    [anon_sym_SEMI] = ACTIONS(11888),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_isa] = ACTIONS(11888),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11888),
    [anon_sym_QMARK] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__lazy_or_operator] = ACTIONS(11888),
    [sym__lazy_and_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [8584] = {
    [sym__word_identifier] = ACTIONS(13606),
    [anon_sym_EQ] = ACTIONS(13606),
    [anon_sym_COMMA] = ACTIONS(13606),
    [anon_sym_COLON] = ACTIONS(13606),
    [anon_sym_begin] = ACTIONS(13606),
    [anon_sym_module] = ACTIONS(13606),
    [anon_sym_baremodule] = ACTIONS(13606),
    [anon_sym_abstract] = ACTIONS(13606),
    [anon_sym_primitive] = ACTIONS(13606),
    [anon_sym_mutable] = ACTIONS(13606),
    [anon_sym_struct] = ACTIONS(13606),
    [anon_sym_function] = ACTIONS(13606),
    [anon_sym_macro] = ACTIONS(13606),
    [anon_sym_where] = ACTIONS(13606),
    [anon_sym_quote] = ACTIONS(13606),
    [anon_sym_let] = ACTIONS(13606),
    [anon_sym_if] = ACTIONS(13606),
    [anon_sym_try] = ACTIONS(13606),
    [anon_sym_catch] = ACTIONS(13606),
    [anon_sym_finally] = ACTIONS(13606),
    [anon_sym_for] = ACTIONS(13606),
    [anon_sym_while] = ACTIONS(13606),
    [sym_break_statement] = ACTIONS(13606),
    [sym_continue_statement] = ACTIONS(13606),
    [anon_sym_return] = ACTIONS(13606),
    [anon_sym_const] = ACTIONS(13606),
    [anon_sym_global] = ACTIONS(13606),
    [anon_sym_local] = ACTIONS(13606),
    [anon_sym_LPAREN] = ACTIONS(13606),
    [anon_sym_COLON2] = ACTIONS(13606),
    [anon_sym_export] = ACTIONS(13606),
    [anon_sym_import] = ACTIONS(13606),
    [anon_sym_using] = ACTIONS(13606),
    [anon_sym_LBRACK] = ACTIONS(13606),
    [anon_sym_LF] = ACTIONS(13608),
    [anon_sym_in] = ACTIONS(13606),
    [anon_sym_LBRACE] = ACTIONS(13606),
    [anon_sym_DOLLAR] = ACTIONS(13606),
    [anon_sym_COLON_COLON] = ACTIONS(13606),
    [anon_sym_isa] = ACTIONS(13606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_QMARK] = ACTIONS(13606),
    [anon_sym_AT] = ACTIONS(13606),
    [anon_sym_true] = ACTIONS(13606),
    [anon_sym_false] = ACTIONS(13606),
    [aux_sym_integer_literal_token1] = ACTIONS(13606),
    [aux_sym_integer_literal_token2] = ACTIONS(13606),
    [aux_sym_integer_literal_token3] = ACTIONS(13606),
    [aux_sym_integer_literal_token4] = ACTIONS(13606),
    [aux_sym_float_literal_token1] = ACTIONS(13606),
    [aux_sym_float_literal_token3] = ACTIONS(13606),
    [aux_sym_float_literal_token4] = ACTIONS(13606),
    [sym_character_literal] = ACTIONS(13606),
    [sym__pair_operator] = ACTIONS(13606),
    [sym__arrow_operator] = ACTIONS(13606),
    [sym__lazy_or_operator] = ACTIONS(13606),
    [sym__lazy_and_operator] = ACTIONS(13606),
    [sym__comparison_operator] = ACTIONS(13606),
    [sym__pipe_right_operator] = ACTIONS(13606),
    [sym__pipe_left_operator] = ACTIONS(13606),
    [sym__ellipsis_operator] = ACTIONS(13606),
    [sym__plus_operator] = ACTIONS(13606),
    [sym__times_operator] = ACTIONS(13606),
    [sym__rational_operator] = ACTIONS(13606),
    [sym__bitshift_operator] = ACTIONS(13606),
    [sym__power_operator] = ACTIONS(13606),
    [sym__tilde_operator] = ACTIONS(13606),
    [sym__type_order_operator] = ACTIONS(13606),
    [sym__unary_operator] = ACTIONS(13606),
    [sym__unary_plus_operator] = ACTIONS(13606),
    [aux_sym__terminator_token1] = ACTIONS(13606),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13608),
    [sym__command_start] = ACTIONS(13608),
  },
  [8585] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [8586] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_EQ] = ACTIONS(12322),
    [anon_sym_COMMA] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_RPAREN] = ACTIONS(12322),
    [anon_sym_COLON2] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_in] = ACTIONS(12322),
    [anon_sym_SEMI] = ACTIONS(12322),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_isa] = ACTIONS(12322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12322),
    [anon_sym_QMARK] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__lazy_or_operator] = ACTIONS(12322),
    [sym__lazy_and_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [8587] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12130),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8588] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12676),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12676),
    [anon_sym_RPAREN] = ACTIONS(12676),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12676),
    [anon_sym_RBRACK] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12676),
    [anon_sym_LBRACE] = ACTIONS(12676),
    [anon_sym_RBRACE] = ACTIONS(12676),
    [anon_sym_DOLLAR] = ACTIONS(12676),
    [anon_sym_COLON_COLON] = ACTIONS(12676),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12676),
    [anon_sym_QMARK] = ACTIONS(12676),
    [anon_sym_AT] = ACTIONS(12676),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12676),
    [aux_sym_integer_literal_token2] = ACTIONS(12676),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12676),
    [aux_sym_float_literal_token3] = ACTIONS(12676),
    [aux_sym_float_literal_token4] = ACTIONS(12676),
    [sym_character_literal] = ACTIONS(12676),
    [sym__pair_operator] = ACTIONS(12676),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12676),
    [sym__lazy_and_operator] = ACTIONS(12676),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12676),
    [sym__pipe_left_operator] = ACTIONS(12676),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12676),
    [sym__bitshift_operator] = ACTIONS(12676),
    [sym__power_operator] = ACTIONS(12676),
    [sym__tilde_operator] = ACTIONS(12676),
    [sym__type_order_operator] = ACTIONS(12676),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8589] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_EQ] = ACTIONS(12334),
    [anon_sym_COMMA] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_RPAREN] = ACTIONS(12334),
    [anon_sym_COLON2] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_in] = ACTIONS(12334),
    [anon_sym_SEMI] = ACTIONS(12334),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_isa] = ACTIONS(12334),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12334),
    [anon_sym_QMARK] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__lazy_or_operator] = ACTIONS(12334),
    [sym__lazy_and_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [8590] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12134),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8591] = {
    [aux_sym_open_tuple_repeat1] = STATE(8591),
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(14637),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13070),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_RPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(13070),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13070),
    [anon_sym_SEMI] = ACTIONS(13070),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(13070),
    [anon_sym_isa] = ACTIONS(13070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13070),
    [anon_sym_QMARK] = ACTIONS(13070),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(13070),
    [sym__arrow_operator] = ACTIONS(13070),
    [sym__lazy_or_operator] = ACTIONS(13070),
    [sym__lazy_and_operator] = ACTIONS(13070),
    [sym__comparison_operator] = ACTIONS(13070),
    [sym__pipe_right_operator] = ACTIONS(13070),
    [sym__pipe_left_operator] = ACTIONS(13070),
    [sym__ellipsis_operator] = ACTIONS(13070),
    [sym__plus_operator] = ACTIONS(13070),
    [sym__times_operator] = ACTIONS(13070),
    [sym__rational_operator] = ACTIONS(13070),
    [sym__bitshift_operator] = ACTIONS(13070),
    [sym__power_operator] = ACTIONS(13070),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(13070),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [8592] = {
    [sym__word_identifier] = ACTIONS(13620),
    [anon_sym_EQ] = ACTIONS(13620),
    [anon_sym_COMMA] = ACTIONS(13620),
    [anon_sym_COLON] = ACTIONS(13620),
    [anon_sym_begin] = ACTIONS(13620),
    [anon_sym_module] = ACTIONS(13620),
    [anon_sym_baremodule] = ACTIONS(13620),
    [anon_sym_abstract] = ACTIONS(13620),
    [anon_sym_primitive] = ACTIONS(13620),
    [anon_sym_mutable] = ACTIONS(13620),
    [anon_sym_struct] = ACTIONS(13620),
    [anon_sym_function] = ACTIONS(13620),
    [anon_sym_macro] = ACTIONS(13620),
    [anon_sym_where] = ACTIONS(13620),
    [anon_sym_quote] = ACTIONS(13620),
    [anon_sym_let] = ACTIONS(13620),
    [anon_sym_if] = ACTIONS(13620),
    [anon_sym_try] = ACTIONS(13620),
    [anon_sym_catch] = ACTIONS(13620),
    [anon_sym_finally] = ACTIONS(13620),
    [anon_sym_for] = ACTIONS(13620),
    [anon_sym_while] = ACTIONS(13620),
    [sym_break_statement] = ACTIONS(13620),
    [sym_continue_statement] = ACTIONS(13620),
    [anon_sym_return] = ACTIONS(13620),
    [anon_sym_const] = ACTIONS(13620),
    [anon_sym_global] = ACTIONS(13620),
    [anon_sym_local] = ACTIONS(13620),
    [anon_sym_LPAREN] = ACTIONS(13620),
    [anon_sym_COLON2] = ACTIONS(13620),
    [anon_sym_export] = ACTIONS(13620),
    [anon_sym_import] = ACTIONS(13620),
    [anon_sym_using] = ACTIONS(13620),
    [anon_sym_LBRACK] = ACTIONS(13620),
    [anon_sym_LF] = ACTIONS(13622),
    [anon_sym_in] = ACTIONS(13620),
    [anon_sym_LBRACE] = ACTIONS(13620),
    [anon_sym_DOLLAR] = ACTIONS(13620),
    [anon_sym_COLON_COLON] = ACTIONS(13620),
    [anon_sym_isa] = ACTIONS(13620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13620),
    [anon_sym_QMARK] = ACTIONS(13620),
    [anon_sym_AT] = ACTIONS(13620),
    [anon_sym_true] = ACTIONS(13620),
    [anon_sym_false] = ACTIONS(13620),
    [aux_sym_integer_literal_token1] = ACTIONS(13620),
    [aux_sym_integer_literal_token2] = ACTIONS(13620),
    [aux_sym_integer_literal_token3] = ACTIONS(13620),
    [aux_sym_integer_literal_token4] = ACTIONS(13620),
    [aux_sym_float_literal_token1] = ACTIONS(13620),
    [aux_sym_float_literal_token3] = ACTIONS(13620),
    [aux_sym_float_literal_token4] = ACTIONS(13620),
    [sym_character_literal] = ACTIONS(13620),
    [sym__pair_operator] = ACTIONS(13620),
    [sym__arrow_operator] = ACTIONS(13620),
    [sym__lazy_or_operator] = ACTIONS(13620),
    [sym__lazy_and_operator] = ACTIONS(13620),
    [sym__comparison_operator] = ACTIONS(13620),
    [sym__pipe_right_operator] = ACTIONS(13620),
    [sym__pipe_left_operator] = ACTIONS(13620),
    [sym__ellipsis_operator] = ACTIONS(13620),
    [sym__plus_operator] = ACTIONS(13620),
    [sym__times_operator] = ACTIONS(13620),
    [sym__rational_operator] = ACTIONS(13620),
    [sym__bitshift_operator] = ACTIONS(13620),
    [sym__power_operator] = ACTIONS(13620),
    [sym__tilde_operator] = ACTIONS(13620),
    [sym__type_order_operator] = ACTIONS(13620),
    [sym__unary_operator] = ACTIONS(13620),
    [sym__unary_plus_operator] = ACTIONS(13620),
    [aux_sym__terminator_token1] = ACTIONS(13620),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13622),
    [sym__command_start] = ACTIONS(13622),
  },
  [8593] = {
    [sym__word_identifier] = ACTIONS(13566),
    [anon_sym_EQ] = ACTIONS(13566),
    [anon_sym_COMMA] = ACTIONS(13566),
    [anon_sym_COLON] = ACTIONS(13566),
    [anon_sym_begin] = ACTIONS(13566),
    [anon_sym_module] = ACTIONS(13566),
    [anon_sym_baremodule] = ACTIONS(13566),
    [anon_sym_end] = ACTIONS(13566),
    [anon_sym_abstract] = ACTIONS(13566),
    [anon_sym_primitive] = ACTIONS(13566),
    [anon_sym_mutable] = ACTIONS(13566),
    [anon_sym_struct] = ACTIONS(13566),
    [anon_sym_function] = ACTIONS(13566),
    [anon_sym_macro] = ACTIONS(13566),
    [anon_sym_where] = ACTIONS(13566),
    [anon_sym_quote] = ACTIONS(13566),
    [anon_sym_let] = ACTIONS(13566),
    [anon_sym_if] = ACTIONS(13566),
    [anon_sym_try] = ACTIONS(13566),
    [anon_sym_catch] = ACTIONS(13566),
    [anon_sym_for] = ACTIONS(13566),
    [anon_sym_while] = ACTIONS(13566),
    [sym_break_statement] = ACTIONS(13566),
    [sym_continue_statement] = ACTIONS(13566),
    [anon_sym_return] = ACTIONS(13566),
    [anon_sym_const] = ACTIONS(13566),
    [anon_sym_global] = ACTIONS(13566),
    [anon_sym_local] = ACTIONS(13566),
    [anon_sym_LPAREN] = ACTIONS(13566),
    [anon_sym_COLON2] = ACTIONS(13566),
    [anon_sym_export] = ACTIONS(13566),
    [anon_sym_import] = ACTIONS(13566),
    [anon_sym_using] = ACTIONS(13566),
    [anon_sym_LBRACK] = ACTIONS(13566),
    [anon_sym_LF] = ACTIONS(13568),
    [anon_sym_in] = ACTIONS(13566),
    [anon_sym_LBRACE] = ACTIONS(13566),
    [anon_sym_DOLLAR] = ACTIONS(13566),
    [anon_sym_COLON_COLON] = ACTIONS(13566),
    [anon_sym_isa] = ACTIONS(13566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13566),
    [anon_sym_QMARK] = ACTIONS(13566),
    [anon_sym_AT] = ACTIONS(13566),
    [anon_sym_true] = ACTIONS(13566),
    [anon_sym_false] = ACTIONS(13566),
    [aux_sym_integer_literal_token1] = ACTIONS(13566),
    [aux_sym_integer_literal_token2] = ACTIONS(13566),
    [aux_sym_integer_literal_token3] = ACTIONS(13566),
    [aux_sym_integer_literal_token4] = ACTIONS(13566),
    [aux_sym_float_literal_token1] = ACTIONS(13566),
    [aux_sym_float_literal_token3] = ACTIONS(13566),
    [aux_sym_float_literal_token4] = ACTIONS(13566),
    [sym_character_literal] = ACTIONS(13566),
    [sym__pair_operator] = ACTIONS(13566),
    [sym__arrow_operator] = ACTIONS(13566),
    [sym__lazy_or_operator] = ACTIONS(13566),
    [sym__lazy_and_operator] = ACTIONS(13566),
    [sym__comparison_operator] = ACTIONS(13566),
    [sym__pipe_right_operator] = ACTIONS(13566),
    [sym__pipe_left_operator] = ACTIONS(13566),
    [sym__ellipsis_operator] = ACTIONS(13566),
    [sym__plus_operator] = ACTIONS(13566),
    [sym__times_operator] = ACTIONS(13566),
    [sym__rational_operator] = ACTIONS(13566),
    [sym__bitshift_operator] = ACTIONS(13566),
    [sym__power_operator] = ACTIONS(13566),
    [sym__tilde_operator] = ACTIONS(13566),
    [sym__type_order_operator] = ACTIONS(13566),
    [sym__unary_operator] = ACTIONS(13566),
    [sym__unary_plus_operator] = ACTIONS(13566),
    [aux_sym__terminator_token1] = ACTIONS(13566),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13568),
    [sym__command_start] = ACTIONS(13568),
  },
  [8594] = {
    [sym__word_identifier] = ACTIONS(13570),
    [anon_sym_EQ] = ACTIONS(13570),
    [anon_sym_COMMA] = ACTIONS(13570),
    [anon_sym_COLON] = ACTIONS(13570),
    [anon_sym_begin] = ACTIONS(13570),
    [anon_sym_module] = ACTIONS(13570),
    [anon_sym_baremodule] = ACTIONS(13570),
    [anon_sym_end] = ACTIONS(13570),
    [anon_sym_abstract] = ACTIONS(13570),
    [anon_sym_primitive] = ACTIONS(13570),
    [anon_sym_mutable] = ACTIONS(13570),
    [anon_sym_struct] = ACTIONS(13570),
    [anon_sym_function] = ACTIONS(13570),
    [anon_sym_macro] = ACTIONS(13570),
    [anon_sym_where] = ACTIONS(13570),
    [anon_sym_quote] = ACTIONS(13570),
    [anon_sym_let] = ACTIONS(13570),
    [anon_sym_if] = ACTIONS(13570),
    [anon_sym_try] = ACTIONS(13570),
    [anon_sym_catch] = ACTIONS(13570),
    [anon_sym_for] = ACTIONS(13570),
    [anon_sym_while] = ACTIONS(13570),
    [sym_break_statement] = ACTIONS(13570),
    [sym_continue_statement] = ACTIONS(13570),
    [anon_sym_return] = ACTIONS(13570),
    [anon_sym_const] = ACTIONS(13570),
    [anon_sym_global] = ACTIONS(13570),
    [anon_sym_local] = ACTIONS(13570),
    [anon_sym_LPAREN] = ACTIONS(13570),
    [anon_sym_COLON2] = ACTIONS(13570),
    [anon_sym_export] = ACTIONS(13570),
    [anon_sym_import] = ACTIONS(13570),
    [anon_sym_using] = ACTIONS(13570),
    [anon_sym_LBRACK] = ACTIONS(13570),
    [anon_sym_LF] = ACTIONS(13572),
    [anon_sym_in] = ACTIONS(13570),
    [anon_sym_LBRACE] = ACTIONS(13570),
    [anon_sym_DOLLAR] = ACTIONS(13570),
    [anon_sym_COLON_COLON] = ACTIONS(13570),
    [anon_sym_isa] = ACTIONS(13570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13570),
    [anon_sym_QMARK] = ACTIONS(13570),
    [anon_sym_AT] = ACTIONS(13570),
    [anon_sym_true] = ACTIONS(13570),
    [anon_sym_false] = ACTIONS(13570),
    [aux_sym_integer_literal_token1] = ACTIONS(13570),
    [aux_sym_integer_literal_token2] = ACTIONS(13570),
    [aux_sym_integer_literal_token3] = ACTIONS(13570),
    [aux_sym_integer_literal_token4] = ACTIONS(13570),
    [aux_sym_float_literal_token1] = ACTIONS(13570),
    [aux_sym_float_literal_token3] = ACTIONS(13570),
    [aux_sym_float_literal_token4] = ACTIONS(13570),
    [sym_character_literal] = ACTIONS(13570),
    [sym__pair_operator] = ACTIONS(13570),
    [sym__arrow_operator] = ACTIONS(13570),
    [sym__lazy_or_operator] = ACTIONS(13570),
    [sym__lazy_and_operator] = ACTIONS(13570),
    [sym__comparison_operator] = ACTIONS(13570),
    [sym__pipe_right_operator] = ACTIONS(13570),
    [sym__pipe_left_operator] = ACTIONS(13570),
    [sym__ellipsis_operator] = ACTIONS(13570),
    [sym__plus_operator] = ACTIONS(13570),
    [sym__times_operator] = ACTIONS(13570),
    [sym__rational_operator] = ACTIONS(13570),
    [sym__bitshift_operator] = ACTIONS(13570),
    [sym__power_operator] = ACTIONS(13570),
    [sym__tilde_operator] = ACTIONS(13570),
    [sym__type_order_operator] = ACTIONS(13570),
    [sym__unary_operator] = ACTIONS(13570),
    [sym__unary_plus_operator] = ACTIONS(13570),
    [aux_sym__terminator_token1] = ACTIONS(13570),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13572),
    [sym__command_start] = ACTIONS(13572),
  },
  [8595] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13312),
    [sym__bitshift_operator] = ACTIONS(13312),
    [sym__power_operator] = ACTIONS(13312),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8596] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_EQ] = ACTIONS(11892),
    [anon_sym_COMMA] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_RPAREN] = ACTIONS(11892),
    [anon_sym_COLON2] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_in] = ACTIONS(11892),
    [anon_sym_SEMI] = ACTIONS(11892),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_isa] = ACTIONS(11892),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11892),
    [anon_sym_QMARK] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__lazy_or_operator] = ACTIONS(11892),
    [sym__lazy_and_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [8597] = {
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13253),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13255),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13253),
    [anon_sym_RPAREN] = ACTIONS(13253),
    [anon_sym_COLON2] = ACTIONS(13255),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13253),
    [anon_sym_RBRACK] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13255),
    [anon_sym_SEMI] = ACTIONS(13253),
    [anon_sym_LBRACE] = ACTIONS(13253),
    [anon_sym_RBRACE] = ACTIONS(13253),
    [anon_sym_DOLLAR] = ACTIONS(13253),
    [anon_sym_COLON_COLON] = ACTIONS(13253),
    [anon_sym_isa] = ACTIONS(13255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13253),
    [anon_sym_QMARK] = ACTIONS(13253),
    [anon_sym_AT] = ACTIONS(13253),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13253),
    [aux_sym_integer_literal_token2] = ACTIONS(13253),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13253),
    [aux_sym_float_literal_token3] = ACTIONS(13253),
    [aux_sym_float_literal_token4] = ACTIONS(13253),
    [sym_character_literal] = ACTIONS(13253),
    [sym__pair_operator] = ACTIONS(13253),
    [sym__arrow_operator] = ACTIONS(13255),
    [sym__lazy_or_operator] = ACTIONS(13253),
    [sym__lazy_and_operator] = ACTIONS(13253),
    [sym__comparison_operator] = ACTIONS(13255),
    [sym__pipe_right_operator] = ACTIONS(13253),
    [sym__pipe_left_operator] = ACTIONS(13253),
    [sym__ellipsis_operator] = ACTIONS(13255),
    [sym__plus_operator] = ACTIONS(13255),
    [sym__times_operator] = ACTIONS(13255),
    [sym__rational_operator] = ACTIONS(13253),
    [sym__bitshift_operator] = ACTIONS(13253),
    [sym__power_operator] = ACTIONS(13253),
    [sym__tilde_operator] = ACTIONS(13253),
    [sym__type_order_operator] = ACTIONS(13253),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8598] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [8599] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_RPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_SEMI] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [8600] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_RPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_SEMI] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [8601] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_elseif] = ACTIONS(13334),
    [anon_sym_else] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14642),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14644),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(14644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14644),
    [sym__pipe_right_operator] = ACTIONS(14646),
    [sym__pipe_left_operator] = ACTIONS(14648),
    [sym__ellipsis_operator] = ACTIONS(14650),
    [sym__plus_operator] = ACTIONS(14652),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14644),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14652),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [8602] = {
    [sym__word_identifier] = ACTIONS(13574),
    [anon_sym_EQ] = ACTIONS(13574),
    [anon_sym_COMMA] = ACTIONS(13574),
    [anon_sym_COLON] = ACTIONS(13574),
    [anon_sym_begin] = ACTIONS(13574),
    [anon_sym_module] = ACTIONS(13574),
    [anon_sym_baremodule] = ACTIONS(13574),
    [anon_sym_end] = ACTIONS(13574),
    [anon_sym_abstract] = ACTIONS(13574),
    [anon_sym_primitive] = ACTIONS(13574),
    [anon_sym_mutable] = ACTIONS(13574),
    [anon_sym_struct] = ACTIONS(13574),
    [anon_sym_function] = ACTIONS(13574),
    [anon_sym_macro] = ACTIONS(13574),
    [anon_sym_where] = ACTIONS(13574),
    [anon_sym_quote] = ACTIONS(13574),
    [anon_sym_let] = ACTIONS(13574),
    [anon_sym_if] = ACTIONS(13574),
    [anon_sym_try] = ACTIONS(13574),
    [anon_sym_catch] = ACTIONS(13574),
    [anon_sym_for] = ACTIONS(13574),
    [anon_sym_while] = ACTIONS(13574),
    [sym_break_statement] = ACTIONS(13574),
    [sym_continue_statement] = ACTIONS(13574),
    [anon_sym_return] = ACTIONS(13574),
    [anon_sym_const] = ACTIONS(13574),
    [anon_sym_global] = ACTIONS(13574),
    [anon_sym_local] = ACTIONS(13574),
    [anon_sym_LPAREN] = ACTIONS(13574),
    [anon_sym_COLON2] = ACTIONS(13574),
    [anon_sym_export] = ACTIONS(13574),
    [anon_sym_import] = ACTIONS(13574),
    [anon_sym_using] = ACTIONS(13574),
    [anon_sym_LBRACK] = ACTIONS(13574),
    [anon_sym_LF] = ACTIONS(13576),
    [anon_sym_in] = ACTIONS(13574),
    [anon_sym_LBRACE] = ACTIONS(13574),
    [anon_sym_DOLLAR] = ACTIONS(13574),
    [anon_sym_COLON_COLON] = ACTIONS(13574),
    [anon_sym_isa] = ACTIONS(13574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13574),
    [anon_sym_QMARK] = ACTIONS(13574),
    [anon_sym_AT] = ACTIONS(13574),
    [anon_sym_true] = ACTIONS(13574),
    [anon_sym_false] = ACTIONS(13574),
    [aux_sym_integer_literal_token1] = ACTIONS(13574),
    [aux_sym_integer_literal_token2] = ACTIONS(13574),
    [aux_sym_integer_literal_token3] = ACTIONS(13574),
    [aux_sym_integer_literal_token4] = ACTIONS(13574),
    [aux_sym_float_literal_token1] = ACTIONS(13574),
    [aux_sym_float_literal_token3] = ACTIONS(13574),
    [aux_sym_float_literal_token4] = ACTIONS(13574),
    [sym_character_literal] = ACTIONS(13574),
    [sym__pair_operator] = ACTIONS(13574),
    [sym__arrow_operator] = ACTIONS(13574),
    [sym__lazy_or_operator] = ACTIONS(13574),
    [sym__lazy_and_operator] = ACTIONS(13574),
    [sym__comparison_operator] = ACTIONS(13574),
    [sym__pipe_right_operator] = ACTIONS(13574),
    [sym__pipe_left_operator] = ACTIONS(13574),
    [sym__ellipsis_operator] = ACTIONS(13574),
    [sym__plus_operator] = ACTIONS(13574),
    [sym__times_operator] = ACTIONS(13574),
    [sym__rational_operator] = ACTIONS(13574),
    [sym__bitshift_operator] = ACTIONS(13574),
    [sym__power_operator] = ACTIONS(13574),
    [sym__tilde_operator] = ACTIONS(13574),
    [sym__type_order_operator] = ACTIONS(13574),
    [sym__unary_operator] = ACTIONS(13574),
    [sym__unary_plus_operator] = ACTIONS(13574),
    [aux_sym__terminator_token1] = ACTIONS(13574),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13576),
    [sym__command_start] = ACTIONS(13576),
  },
  [8603] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14642),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14646),
    [sym__pipe_left_operator] = ACTIONS(14648),
    [sym__ellipsis_operator] = ACTIONS(14650),
    [sym__plus_operator] = ACTIONS(14652),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14652),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8604] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14662),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14642),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14644),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(14644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13324),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14664),
    [sym__arrow_operator] = ACTIONS(14666),
    [sym__lazy_or_operator] = ACTIONS(14668),
    [sym__lazy_and_operator] = ACTIONS(14670),
    [sym__comparison_operator] = ACTIONS(14644),
    [sym__pipe_right_operator] = ACTIONS(14646),
    [sym__pipe_left_operator] = ACTIONS(14648),
    [sym__ellipsis_operator] = ACTIONS(14650),
    [sym__plus_operator] = ACTIONS(14652),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14644),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14652),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8605] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14662),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14642),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14644),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(14644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14666),
    [sym__lazy_or_operator] = ACTIONS(14668),
    [sym__lazy_and_operator] = ACTIONS(14670),
    [sym__comparison_operator] = ACTIONS(14644),
    [sym__pipe_right_operator] = ACTIONS(14646),
    [sym__pipe_left_operator] = ACTIONS(14648),
    [sym__ellipsis_operator] = ACTIONS(14650),
    [sym__plus_operator] = ACTIONS(14652),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14644),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14652),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8606] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14662),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14642),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14644),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(14644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14670),
    [sym__comparison_operator] = ACTIONS(14644),
    [sym__pipe_right_operator] = ACTIONS(14646),
    [sym__pipe_left_operator] = ACTIONS(14648),
    [sym__ellipsis_operator] = ACTIONS(14650),
    [sym__plus_operator] = ACTIONS(14652),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14644),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14652),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8607] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14662),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14642),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14644),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(14644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14644),
    [sym__pipe_right_operator] = ACTIONS(14646),
    [sym__pipe_left_operator] = ACTIONS(14648),
    [sym__ellipsis_operator] = ACTIONS(14650),
    [sym__plus_operator] = ACTIONS(14652),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14644),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14652),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8608] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14642),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14650),
    [sym__plus_operator] = ACTIONS(14652),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14652),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8609] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14642),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14646),
    [sym__pipe_left_operator] = ACTIONS(14648),
    [sym__ellipsis_operator] = ACTIONS(14650),
    [sym__plus_operator] = ACTIONS(14652),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14652),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8610] = {
    [sym__word_identifier] = ACTIONS(13578),
    [anon_sym_EQ] = ACTIONS(13578),
    [anon_sym_COMMA] = ACTIONS(13578),
    [anon_sym_COLON] = ACTIONS(13578),
    [anon_sym_begin] = ACTIONS(13578),
    [anon_sym_module] = ACTIONS(13578),
    [anon_sym_baremodule] = ACTIONS(13578),
    [anon_sym_end] = ACTIONS(13578),
    [anon_sym_abstract] = ACTIONS(13578),
    [anon_sym_primitive] = ACTIONS(13578),
    [anon_sym_mutable] = ACTIONS(13578),
    [anon_sym_struct] = ACTIONS(13578),
    [anon_sym_function] = ACTIONS(13578),
    [anon_sym_macro] = ACTIONS(13578),
    [anon_sym_where] = ACTIONS(13578),
    [anon_sym_quote] = ACTIONS(13578),
    [anon_sym_let] = ACTIONS(13578),
    [anon_sym_if] = ACTIONS(13578),
    [anon_sym_try] = ACTIONS(13578),
    [anon_sym_catch] = ACTIONS(13578),
    [anon_sym_for] = ACTIONS(13578),
    [anon_sym_while] = ACTIONS(13578),
    [sym_break_statement] = ACTIONS(13578),
    [sym_continue_statement] = ACTIONS(13578),
    [anon_sym_return] = ACTIONS(13578),
    [anon_sym_const] = ACTIONS(13578),
    [anon_sym_global] = ACTIONS(13578),
    [anon_sym_local] = ACTIONS(13578),
    [anon_sym_LPAREN] = ACTIONS(13578),
    [anon_sym_COLON2] = ACTIONS(13578),
    [anon_sym_export] = ACTIONS(13578),
    [anon_sym_import] = ACTIONS(13578),
    [anon_sym_using] = ACTIONS(13578),
    [anon_sym_LBRACK] = ACTIONS(13578),
    [anon_sym_LF] = ACTIONS(13580),
    [anon_sym_in] = ACTIONS(13578),
    [anon_sym_LBRACE] = ACTIONS(13578),
    [anon_sym_DOLLAR] = ACTIONS(13578),
    [anon_sym_COLON_COLON] = ACTIONS(13578),
    [anon_sym_isa] = ACTIONS(13578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13578),
    [anon_sym_QMARK] = ACTIONS(13578),
    [anon_sym_AT] = ACTIONS(13578),
    [anon_sym_true] = ACTIONS(13578),
    [anon_sym_false] = ACTIONS(13578),
    [aux_sym_integer_literal_token1] = ACTIONS(13578),
    [aux_sym_integer_literal_token2] = ACTIONS(13578),
    [aux_sym_integer_literal_token3] = ACTIONS(13578),
    [aux_sym_integer_literal_token4] = ACTIONS(13578),
    [aux_sym_float_literal_token1] = ACTIONS(13578),
    [aux_sym_float_literal_token3] = ACTIONS(13578),
    [aux_sym_float_literal_token4] = ACTIONS(13578),
    [sym_character_literal] = ACTIONS(13578),
    [sym__pair_operator] = ACTIONS(13578),
    [sym__arrow_operator] = ACTIONS(13578),
    [sym__lazy_or_operator] = ACTIONS(13578),
    [sym__lazy_and_operator] = ACTIONS(13578),
    [sym__comparison_operator] = ACTIONS(13578),
    [sym__pipe_right_operator] = ACTIONS(13578),
    [sym__pipe_left_operator] = ACTIONS(13578),
    [sym__ellipsis_operator] = ACTIONS(13578),
    [sym__plus_operator] = ACTIONS(13578),
    [sym__times_operator] = ACTIONS(13578),
    [sym__rational_operator] = ACTIONS(13578),
    [sym__bitshift_operator] = ACTIONS(13578),
    [sym__power_operator] = ACTIONS(13578),
    [sym__tilde_operator] = ACTIONS(13578),
    [sym__type_order_operator] = ACTIONS(13578),
    [sym__unary_operator] = ACTIONS(13578),
    [sym__unary_plus_operator] = ACTIONS(13578),
    [aux_sym__terminator_token1] = ACTIONS(13578),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13580),
    [sym__command_start] = ACTIONS(13580),
  },
  [8611] = {
    [sym__word_identifier] = ACTIONS(13582),
    [anon_sym_EQ] = ACTIONS(13582),
    [anon_sym_COMMA] = ACTIONS(13582),
    [anon_sym_COLON] = ACTIONS(13582),
    [anon_sym_begin] = ACTIONS(13582),
    [anon_sym_module] = ACTIONS(13582),
    [anon_sym_baremodule] = ACTIONS(13582),
    [anon_sym_end] = ACTIONS(13582),
    [anon_sym_abstract] = ACTIONS(13582),
    [anon_sym_primitive] = ACTIONS(13582),
    [anon_sym_mutable] = ACTIONS(13582),
    [anon_sym_struct] = ACTIONS(13582),
    [anon_sym_function] = ACTIONS(13582),
    [anon_sym_macro] = ACTIONS(13582),
    [anon_sym_where] = ACTIONS(13582),
    [anon_sym_quote] = ACTIONS(13582),
    [anon_sym_let] = ACTIONS(13582),
    [anon_sym_if] = ACTIONS(13582),
    [anon_sym_try] = ACTIONS(13582),
    [anon_sym_catch] = ACTIONS(13582),
    [anon_sym_for] = ACTIONS(13582),
    [anon_sym_while] = ACTIONS(13582),
    [sym_break_statement] = ACTIONS(13582),
    [sym_continue_statement] = ACTIONS(13582),
    [anon_sym_return] = ACTIONS(13582),
    [anon_sym_const] = ACTIONS(13582),
    [anon_sym_global] = ACTIONS(13582),
    [anon_sym_local] = ACTIONS(13582),
    [anon_sym_LPAREN] = ACTIONS(13582),
    [anon_sym_COLON2] = ACTIONS(13582),
    [anon_sym_export] = ACTIONS(13582),
    [anon_sym_import] = ACTIONS(13582),
    [anon_sym_using] = ACTIONS(13582),
    [anon_sym_LBRACK] = ACTIONS(13582),
    [anon_sym_LF] = ACTIONS(13584),
    [anon_sym_in] = ACTIONS(13582),
    [anon_sym_LBRACE] = ACTIONS(13582),
    [anon_sym_DOLLAR] = ACTIONS(13582),
    [anon_sym_COLON_COLON] = ACTIONS(13582),
    [anon_sym_isa] = ACTIONS(13582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13582),
    [anon_sym_QMARK] = ACTIONS(13582),
    [anon_sym_AT] = ACTIONS(13582),
    [anon_sym_true] = ACTIONS(13582),
    [anon_sym_false] = ACTIONS(13582),
    [aux_sym_integer_literal_token1] = ACTIONS(13582),
    [aux_sym_integer_literal_token2] = ACTIONS(13582),
    [aux_sym_integer_literal_token3] = ACTIONS(13582),
    [aux_sym_integer_literal_token4] = ACTIONS(13582),
    [aux_sym_float_literal_token1] = ACTIONS(13582),
    [aux_sym_float_literal_token3] = ACTIONS(13582),
    [aux_sym_float_literal_token4] = ACTIONS(13582),
    [sym_character_literal] = ACTIONS(13582),
    [sym__pair_operator] = ACTIONS(13582),
    [sym__arrow_operator] = ACTIONS(13582),
    [sym__lazy_or_operator] = ACTIONS(13582),
    [sym__lazy_and_operator] = ACTIONS(13582),
    [sym__comparison_operator] = ACTIONS(13582),
    [sym__pipe_right_operator] = ACTIONS(13582),
    [sym__pipe_left_operator] = ACTIONS(13582),
    [sym__ellipsis_operator] = ACTIONS(13582),
    [sym__plus_operator] = ACTIONS(13582),
    [sym__times_operator] = ACTIONS(13582),
    [sym__rational_operator] = ACTIONS(13582),
    [sym__bitshift_operator] = ACTIONS(13582),
    [sym__power_operator] = ACTIONS(13582),
    [sym__tilde_operator] = ACTIONS(13582),
    [sym__type_order_operator] = ACTIONS(13582),
    [sym__unary_operator] = ACTIONS(13582),
    [sym__unary_plus_operator] = ACTIONS(13582),
    [aux_sym__terminator_token1] = ACTIONS(13582),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13584),
    [sym__command_start] = ACTIONS(13584),
  },
  [8612] = {
    [sym__word_identifier] = ACTIONS(13586),
    [anon_sym_EQ] = ACTIONS(13586),
    [anon_sym_COMMA] = ACTIONS(13586),
    [anon_sym_COLON] = ACTIONS(13586),
    [anon_sym_begin] = ACTIONS(13586),
    [anon_sym_module] = ACTIONS(13586),
    [anon_sym_baremodule] = ACTIONS(13586),
    [anon_sym_end] = ACTIONS(13586),
    [anon_sym_abstract] = ACTIONS(13586),
    [anon_sym_primitive] = ACTIONS(13586),
    [anon_sym_mutable] = ACTIONS(13586),
    [anon_sym_struct] = ACTIONS(13586),
    [anon_sym_function] = ACTIONS(13586),
    [anon_sym_macro] = ACTIONS(13586),
    [anon_sym_where] = ACTIONS(13586),
    [anon_sym_quote] = ACTIONS(13586),
    [anon_sym_let] = ACTIONS(13586),
    [anon_sym_if] = ACTIONS(13586),
    [anon_sym_try] = ACTIONS(13586),
    [anon_sym_catch] = ACTIONS(13586),
    [anon_sym_for] = ACTIONS(13586),
    [anon_sym_while] = ACTIONS(13586),
    [sym_break_statement] = ACTIONS(13586),
    [sym_continue_statement] = ACTIONS(13586),
    [anon_sym_return] = ACTIONS(13586),
    [anon_sym_const] = ACTIONS(13586),
    [anon_sym_global] = ACTIONS(13586),
    [anon_sym_local] = ACTIONS(13586),
    [anon_sym_LPAREN] = ACTIONS(13586),
    [anon_sym_COLON2] = ACTIONS(13586),
    [anon_sym_export] = ACTIONS(13586),
    [anon_sym_import] = ACTIONS(13586),
    [anon_sym_using] = ACTIONS(13586),
    [anon_sym_LBRACK] = ACTIONS(13586),
    [anon_sym_LF] = ACTIONS(13588),
    [anon_sym_in] = ACTIONS(13586),
    [anon_sym_LBRACE] = ACTIONS(13586),
    [anon_sym_DOLLAR] = ACTIONS(13586),
    [anon_sym_COLON_COLON] = ACTIONS(13586),
    [anon_sym_isa] = ACTIONS(13586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13586),
    [anon_sym_QMARK] = ACTIONS(13586),
    [anon_sym_AT] = ACTIONS(13586),
    [anon_sym_true] = ACTIONS(13586),
    [anon_sym_false] = ACTIONS(13586),
    [aux_sym_integer_literal_token1] = ACTIONS(13586),
    [aux_sym_integer_literal_token2] = ACTIONS(13586),
    [aux_sym_integer_literal_token3] = ACTIONS(13586),
    [aux_sym_integer_literal_token4] = ACTIONS(13586),
    [aux_sym_float_literal_token1] = ACTIONS(13586),
    [aux_sym_float_literal_token3] = ACTIONS(13586),
    [aux_sym_float_literal_token4] = ACTIONS(13586),
    [sym_character_literal] = ACTIONS(13586),
    [sym__pair_operator] = ACTIONS(13586),
    [sym__arrow_operator] = ACTIONS(13586),
    [sym__lazy_or_operator] = ACTIONS(13586),
    [sym__lazy_and_operator] = ACTIONS(13586),
    [sym__comparison_operator] = ACTIONS(13586),
    [sym__pipe_right_operator] = ACTIONS(13586),
    [sym__pipe_left_operator] = ACTIONS(13586),
    [sym__ellipsis_operator] = ACTIONS(13586),
    [sym__plus_operator] = ACTIONS(13586),
    [sym__times_operator] = ACTIONS(13586),
    [sym__rational_operator] = ACTIONS(13586),
    [sym__bitshift_operator] = ACTIONS(13586),
    [sym__power_operator] = ACTIONS(13586),
    [sym__tilde_operator] = ACTIONS(13586),
    [sym__type_order_operator] = ACTIONS(13586),
    [sym__unary_operator] = ACTIONS(13586),
    [sym__unary_plus_operator] = ACTIONS(13586),
    [aux_sym__terminator_token1] = ACTIONS(13586),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13588),
    [sym__command_start] = ACTIONS(13588),
  },
  [8613] = {
    [sym__word_identifier] = ACTIONS(13590),
    [anon_sym_EQ] = ACTIONS(13590),
    [anon_sym_COMMA] = ACTIONS(13590),
    [anon_sym_COLON] = ACTIONS(13590),
    [anon_sym_begin] = ACTIONS(13590),
    [anon_sym_module] = ACTIONS(13590),
    [anon_sym_baremodule] = ACTIONS(13590),
    [anon_sym_end] = ACTIONS(13590),
    [anon_sym_abstract] = ACTIONS(13590),
    [anon_sym_primitive] = ACTIONS(13590),
    [anon_sym_mutable] = ACTIONS(13590),
    [anon_sym_struct] = ACTIONS(13590),
    [anon_sym_function] = ACTIONS(13590),
    [anon_sym_macro] = ACTIONS(13590),
    [anon_sym_where] = ACTIONS(13590),
    [anon_sym_quote] = ACTIONS(13590),
    [anon_sym_let] = ACTIONS(13590),
    [anon_sym_if] = ACTIONS(13590),
    [anon_sym_try] = ACTIONS(13590),
    [anon_sym_catch] = ACTIONS(13590),
    [anon_sym_for] = ACTIONS(13590),
    [anon_sym_while] = ACTIONS(13590),
    [sym_break_statement] = ACTIONS(13590),
    [sym_continue_statement] = ACTIONS(13590),
    [anon_sym_return] = ACTIONS(13590),
    [anon_sym_const] = ACTIONS(13590),
    [anon_sym_global] = ACTIONS(13590),
    [anon_sym_local] = ACTIONS(13590),
    [anon_sym_LPAREN] = ACTIONS(13590),
    [anon_sym_COLON2] = ACTIONS(13590),
    [anon_sym_export] = ACTIONS(13590),
    [anon_sym_import] = ACTIONS(13590),
    [anon_sym_using] = ACTIONS(13590),
    [anon_sym_LBRACK] = ACTIONS(13590),
    [anon_sym_LF] = ACTIONS(13592),
    [anon_sym_in] = ACTIONS(13590),
    [anon_sym_LBRACE] = ACTIONS(13590),
    [anon_sym_DOLLAR] = ACTIONS(13590),
    [anon_sym_COLON_COLON] = ACTIONS(13590),
    [anon_sym_isa] = ACTIONS(13590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13590),
    [anon_sym_QMARK] = ACTIONS(13590),
    [anon_sym_AT] = ACTIONS(13590),
    [anon_sym_true] = ACTIONS(13590),
    [anon_sym_false] = ACTIONS(13590),
    [aux_sym_integer_literal_token1] = ACTIONS(13590),
    [aux_sym_integer_literal_token2] = ACTIONS(13590),
    [aux_sym_integer_literal_token3] = ACTIONS(13590),
    [aux_sym_integer_literal_token4] = ACTIONS(13590),
    [aux_sym_float_literal_token1] = ACTIONS(13590),
    [aux_sym_float_literal_token3] = ACTIONS(13590),
    [aux_sym_float_literal_token4] = ACTIONS(13590),
    [sym_character_literal] = ACTIONS(13590),
    [sym__pair_operator] = ACTIONS(13590),
    [sym__arrow_operator] = ACTIONS(13590),
    [sym__lazy_or_operator] = ACTIONS(13590),
    [sym__lazy_and_operator] = ACTIONS(13590),
    [sym__comparison_operator] = ACTIONS(13590),
    [sym__pipe_right_operator] = ACTIONS(13590),
    [sym__pipe_left_operator] = ACTIONS(13590),
    [sym__ellipsis_operator] = ACTIONS(13590),
    [sym__plus_operator] = ACTIONS(13590),
    [sym__times_operator] = ACTIONS(13590),
    [sym__rational_operator] = ACTIONS(13590),
    [sym__bitshift_operator] = ACTIONS(13590),
    [sym__power_operator] = ACTIONS(13590),
    [sym__tilde_operator] = ACTIONS(13590),
    [sym__type_order_operator] = ACTIONS(13590),
    [sym__unary_operator] = ACTIONS(13590),
    [sym__unary_plus_operator] = ACTIONS(13590),
    [aux_sym__terminator_token1] = ACTIONS(13590),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13592),
    [sym__command_start] = ACTIONS(13592),
  },
  [8614] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14662),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_elseif] = ACTIONS(13338),
    [anon_sym_else] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14642),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14644),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(14644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13324),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14664),
    [sym__arrow_operator] = ACTIONS(14666),
    [sym__lazy_or_operator] = ACTIONS(14668),
    [sym__lazy_and_operator] = ACTIONS(14670),
    [sym__comparison_operator] = ACTIONS(14644),
    [sym__pipe_right_operator] = ACTIONS(14646),
    [sym__pipe_left_operator] = ACTIONS(14648),
    [sym__ellipsis_operator] = ACTIONS(14650),
    [sym__plus_operator] = ACTIONS(14652),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14644),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14652),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [8615] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_RPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_SEMI] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [8616] = {
    [sym__word_identifier] = ACTIONS(13594),
    [anon_sym_EQ] = ACTIONS(13594),
    [anon_sym_COMMA] = ACTIONS(13594),
    [anon_sym_COLON] = ACTIONS(13594),
    [anon_sym_begin] = ACTIONS(13594),
    [anon_sym_module] = ACTIONS(13594),
    [anon_sym_baremodule] = ACTIONS(13594),
    [anon_sym_end] = ACTIONS(13594),
    [anon_sym_abstract] = ACTIONS(13594),
    [anon_sym_primitive] = ACTIONS(13594),
    [anon_sym_mutable] = ACTIONS(13594),
    [anon_sym_struct] = ACTIONS(13594),
    [anon_sym_function] = ACTIONS(13594),
    [anon_sym_macro] = ACTIONS(13594),
    [anon_sym_where] = ACTIONS(13594),
    [anon_sym_quote] = ACTIONS(13594),
    [anon_sym_let] = ACTIONS(13594),
    [anon_sym_if] = ACTIONS(13594),
    [anon_sym_try] = ACTIONS(13594),
    [anon_sym_catch] = ACTIONS(13594),
    [anon_sym_for] = ACTIONS(13594),
    [anon_sym_while] = ACTIONS(13594),
    [sym_break_statement] = ACTIONS(13594),
    [sym_continue_statement] = ACTIONS(13594),
    [anon_sym_return] = ACTIONS(13594),
    [anon_sym_const] = ACTIONS(13594),
    [anon_sym_global] = ACTIONS(13594),
    [anon_sym_local] = ACTIONS(13594),
    [anon_sym_LPAREN] = ACTIONS(13594),
    [anon_sym_COLON2] = ACTIONS(13594),
    [anon_sym_export] = ACTIONS(13594),
    [anon_sym_import] = ACTIONS(13594),
    [anon_sym_using] = ACTIONS(13594),
    [anon_sym_LBRACK] = ACTIONS(13594),
    [anon_sym_LF] = ACTIONS(13596),
    [anon_sym_in] = ACTIONS(13594),
    [anon_sym_LBRACE] = ACTIONS(13594),
    [anon_sym_DOLLAR] = ACTIONS(13594),
    [anon_sym_COLON_COLON] = ACTIONS(13594),
    [anon_sym_isa] = ACTIONS(13594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13594),
    [anon_sym_QMARK] = ACTIONS(13594),
    [anon_sym_AT] = ACTIONS(13594),
    [anon_sym_true] = ACTIONS(13594),
    [anon_sym_false] = ACTIONS(13594),
    [aux_sym_integer_literal_token1] = ACTIONS(13594),
    [aux_sym_integer_literal_token2] = ACTIONS(13594),
    [aux_sym_integer_literal_token3] = ACTIONS(13594),
    [aux_sym_integer_literal_token4] = ACTIONS(13594),
    [aux_sym_float_literal_token1] = ACTIONS(13594),
    [aux_sym_float_literal_token3] = ACTIONS(13594),
    [aux_sym_float_literal_token4] = ACTIONS(13594),
    [sym_character_literal] = ACTIONS(13594),
    [sym__pair_operator] = ACTIONS(13594),
    [sym__arrow_operator] = ACTIONS(13594),
    [sym__lazy_or_operator] = ACTIONS(13594),
    [sym__lazy_and_operator] = ACTIONS(13594),
    [sym__comparison_operator] = ACTIONS(13594),
    [sym__pipe_right_operator] = ACTIONS(13594),
    [sym__pipe_left_operator] = ACTIONS(13594),
    [sym__ellipsis_operator] = ACTIONS(13594),
    [sym__plus_operator] = ACTIONS(13594),
    [sym__times_operator] = ACTIONS(13594),
    [sym__rational_operator] = ACTIONS(13594),
    [sym__bitshift_operator] = ACTIONS(13594),
    [sym__power_operator] = ACTIONS(13594),
    [sym__tilde_operator] = ACTIONS(13594),
    [sym__type_order_operator] = ACTIONS(13594),
    [sym__unary_operator] = ACTIONS(13594),
    [sym__unary_plus_operator] = ACTIONS(13594),
    [aux_sym__terminator_token1] = ACTIONS(13594),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13596),
    [sym__command_start] = ACTIONS(13596),
  },
  [8617] = {
    [sym__word_identifier] = ACTIONS(13413),
    [anon_sym_EQ] = ACTIONS(13413),
    [anon_sym_COMMA] = ACTIONS(13415),
    [anon_sym_COLON] = ACTIONS(13413),
    [anon_sym_begin] = ACTIONS(13413),
    [anon_sym_module] = ACTIONS(13413),
    [anon_sym_baremodule] = ACTIONS(13413),
    [anon_sym_abstract] = ACTIONS(13413),
    [anon_sym_primitive] = ACTIONS(13413),
    [anon_sym_mutable] = ACTIONS(13413),
    [anon_sym_struct] = ACTIONS(13413),
    [anon_sym_function] = ACTIONS(13413),
    [anon_sym_macro] = ACTIONS(13413),
    [anon_sym_where] = ACTIONS(13413),
    [anon_sym_quote] = ACTIONS(13413),
    [anon_sym_let] = ACTIONS(13413),
    [anon_sym_if] = ACTIONS(13413),
    [anon_sym_try] = ACTIONS(13413),
    [anon_sym_for] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(13413),
    [sym_break_statement] = ACTIONS(13413),
    [sym_continue_statement] = ACTIONS(13413),
    [anon_sym_return] = ACTIONS(13413),
    [anon_sym_const] = ACTIONS(13413),
    [anon_sym_global] = ACTIONS(13413),
    [anon_sym_local] = ACTIONS(13413),
    [anon_sym_LPAREN] = ACTIONS(13415),
    [anon_sym_RPAREN] = ACTIONS(13415),
    [anon_sym_COLON2] = ACTIONS(13413),
    [anon_sym_export] = ACTIONS(13413),
    [anon_sym_import] = ACTIONS(13413),
    [anon_sym_using] = ACTIONS(13413),
    [anon_sym_LBRACK] = ACTIONS(13415),
    [anon_sym_RBRACK] = ACTIONS(13415),
    [anon_sym_in] = ACTIONS(13413),
    [anon_sym_SEMI] = ACTIONS(13415),
    [anon_sym_LBRACE] = ACTIONS(13415),
    [anon_sym_RBRACE] = ACTIONS(13415),
    [anon_sym_DOLLAR] = ACTIONS(13415),
    [anon_sym_COLON_COLON] = ACTIONS(13415),
    [anon_sym_isa] = ACTIONS(13413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13415),
    [anon_sym_QMARK] = ACTIONS(13415),
    [anon_sym_AT] = ACTIONS(13415),
    [anon_sym_true] = ACTIONS(13413),
    [anon_sym_false] = ACTIONS(13413),
    [aux_sym_integer_literal_token1] = ACTIONS(13415),
    [aux_sym_integer_literal_token2] = ACTIONS(13415),
    [aux_sym_integer_literal_token3] = ACTIONS(13413),
    [aux_sym_integer_literal_token4] = ACTIONS(13413),
    [aux_sym_float_literal_token1] = ACTIONS(13415),
    [aux_sym_float_literal_token3] = ACTIONS(13415),
    [aux_sym_float_literal_token4] = ACTIONS(13415),
    [sym_character_literal] = ACTIONS(13415),
    [sym__pair_operator] = ACTIONS(13415),
    [sym__arrow_operator] = ACTIONS(13413),
    [sym__lazy_or_operator] = ACTIONS(13415),
    [sym__lazy_and_operator] = ACTIONS(13415),
    [sym__comparison_operator] = ACTIONS(13413),
    [sym__pipe_right_operator] = ACTIONS(13415),
    [sym__pipe_left_operator] = ACTIONS(13415),
    [sym__ellipsis_operator] = ACTIONS(13413),
    [sym__plus_operator] = ACTIONS(13413),
    [sym__times_operator] = ACTIONS(13413),
    [sym__rational_operator] = ACTIONS(13415),
    [sym__bitshift_operator] = ACTIONS(13415),
    [sym__power_operator] = ACTIONS(13415),
    [sym__tilde_operator] = ACTIONS(13415),
    [sym__type_order_operator] = ACTIONS(13415),
    [sym__unary_operator] = ACTIONS(13413),
    [sym__unary_plus_operator] = ACTIONS(13413),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13415),
    [sym__command_start] = ACTIONS(13415),
  },
  [8618] = {
    [sym__word_identifier] = ACTIONS(13417),
    [anon_sym_EQ] = ACTIONS(13417),
    [anon_sym_COMMA] = ACTIONS(13419),
    [anon_sym_COLON] = ACTIONS(13417),
    [anon_sym_begin] = ACTIONS(13417),
    [anon_sym_module] = ACTIONS(13417),
    [anon_sym_baremodule] = ACTIONS(13417),
    [anon_sym_abstract] = ACTIONS(13417),
    [anon_sym_primitive] = ACTIONS(13417),
    [anon_sym_mutable] = ACTIONS(13417),
    [anon_sym_struct] = ACTIONS(13417),
    [anon_sym_function] = ACTIONS(13417),
    [anon_sym_macro] = ACTIONS(13417),
    [anon_sym_where] = ACTIONS(13417),
    [anon_sym_quote] = ACTIONS(13417),
    [anon_sym_let] = ACTIONS(13417),
    [anon_sym_if] = ACTIONS(13417),
    [anon_sym_try] = ACTIONS(13417),
    [anon_sym_for] = ACTIONS(13417),
    [anon_sym_while] = ACTIONS(13417),
    [sym_break_statement] = ACTIONS(13417),
    [sym_continue_statement] = ACTIONS(13417),
    [anon_sym_return] = ACTIONS(13417),
    [anon_sym_const] = ACTIONS(13417),
    [anon_sym_global] = ACTIONS(13417),
    [anon_sym_local] = ACTIONS(13417),
    [anon_sym_LPAREN] = ACTIONS(13419),
    [anon_sym_RPAREN] = ACTIONS(13419),
    [anon_sym_COLON2] = ACTIONS(13417),
    [anon_sym_export] = ACTIONS(13417),
    [anon_sym_import] = ACTIONS(13417),
    [anon_sym_using] = ACTIONS(13417),
    [anon_sym_LBRACK] = ACTIONS(13419),
    [anon_sym_RBRACK] = ACTIONS(13419),
    [anon_sym_in] = ACTIONS(13417),
    [anon_sym_SEMI] = ACTIONS(13419),
    [anon_sym_LBRACE] = ACTIONS(13419),
    [anon_sym_RBRACE] = ACTIONS(13419),
    [anon_sym_DOLLAR] = ACTIONS(13419),
    [anon_sym_COLON_COLON] = ACTIONS(13419),
    [anon_sym_isa] = ACTIONS(13417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13419),
    [anon_sym_QMARK] = ACTIONS(13419),
    [anon_sym_AT] = ACTIONS(13419),
    [anon_sym_true] = ACTIONS(13417),
    [anon_sym_false] = ACTIONS(13417),
    [aux_sym_integer_literal_token1] = ACTIONS(13419),
    [aux_sym_integer_literal_token2] = ACTIONS(13419),
    [aux_sym_integer_literal_token3] = ACTIONS(13417),
    [aux_sym_integer_literal_token4] = ACTIONS(13417),
    [aux_sym_float_literal_token1] = ACTIONS(13419),
    [aux_sym_float_literal_token3] = ACTIONS(13419),
    [aux_sym_float_literal_token4] = ACTIONS(13419),
    [sym_character_literal] = ACTIONS(13419),
    [sym__pair_operator] = ACTIONS(13419),
    [sym__arrow_operator] = ACTIONS(13417),
    [sym__lazy_or_operator] = ACTIONS(13419),
    [sym__lazy_and_operator] = ACTIONS(13419),
    [sym__comparison_operator] = ACTIONS(13417),
    [sym__pipe_right_operator] = ACTIONS(13419),
    [sym__pipe_left_operator] = ACTIONS(13419),
    [sym__ellipsis_operator] = ACTIONS(13417),
    [sym__plus_operator] = ACTIONS(13417),
    [sym__times_operator] = ACTIONS(13417),
    [sym__rational_operator] = ACTIONS(13419),
    [sym__bitshift_operator] = ACTIONS(13419),
    [sym__power_operator] = ACTIONS(13419),
    [sym__tilde_operator] = ACTIONS(13419),
    [sym__type_order_operator] = ACTIONS(13419),
    [sym__unary_operator] = ACTIONS(13417),
    [sym__unary_plus_operator] = ACTIONS(13417),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13419),
    [sym__command_start] = ACTIONS(13419),
  },
  [8619] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_RPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_SEMI] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [8620] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_RPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_SEMI] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [8621] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_RPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_SEMI] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [8622] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_RPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_SEMI] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [8623] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(14543),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_catch] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8624] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_EQ] = ACTIONS(12058),
    [anon_sym_COMMA] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_RPAREN] = ACTIONS(12058),
    [anon_sym_COLON2] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_in] = ACTIONS(12058),
    [anon_sym_SEMI] = ACTIONS(12058),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_isa] = ACTIONS(12058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12058),
    [anon_sym_QMARK] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__lazy_or_operator] = ACTIONS(12058),
    [sym__lazy_and_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [8625] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_EQ] = ACTIONS(12066),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_RPAREN] = ACTIONS(12066),
    [anon_sym_COLON2] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_in] = ACTIONS(12066),
    [anon_sym_SEMI] = ACTIONS(12066),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_isa] = ACTIONS(12066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12066),
    [anon_sym_QMARK] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__lazy_or_operator] = ACTIONS(12066),
    [sym__lazy_and_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [8626] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12054),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12054),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [8627] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_EQ] = ACTIONS(12264),
    [anon_sym_COMMA] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_RPAREN] = ACTIONS(12264),
    [anon_sym_COLON2] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_in] = ACTIONS(12264),
    [anon_sym_SEMI] = ACTIONS(12264),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_isa] = ACTIONS(12264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12264),
    [anon_sym_QMARK] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__lazy_or_operator] = ACTIONS(12264),
    [sym__lazy_and_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [8628] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_EQ] = ACTIONS(12268),
    [anon_sym_COMMA] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_RPAREN] = ACTIONS(12268),
    [anon_sym_COLON2] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_in] = ACTIONS(12268),
    [anon_sym_SEMI] = ACTIONS(12268),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_isa] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12268),
    [anon_sym_QMARK] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__lazy_or_operator] = ACTIONS(12268),
    [sym__lazy_and_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [8629] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_EQ] = ACTIONS(12272),
    [anon_sym_COMMA] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_RPAREN] = ACTIONS(12272),
    [anon_sym_COLON2] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_in] = ACTIONS(12272),
    [anon_sym_SEMI] = ACTIONS(12272),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_isa] = ACTIONS(12272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12272),
    [anon_sym_QMARK] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__lazy_or_operator] = ACTIONS(12272),
    [sym__lazy_and_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [8630] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_RPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_SEMI] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [8631] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_RPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_SEMI] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [8632] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_EQ] = ACTIONS(12276),
    [anon_sym_COMMA] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_RPAREN] = ACTIONS(12276),
    [anon_sym_COLON2] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_in] = ACTIONS(12276),
    [anon_sym_SEMI] = ACTIONS(12276),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_isa] = ACTIONS(12276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12276),
    [anon_sym_QMARK] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__lazy_or_operator] = ACTIONS(12276),
    [sym__lazy_and_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [8633] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_EQ] = ACTIONS(12280),
    [anon_sym_COMMA] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_RPAREN] = ACTIONS(12280),
    [anon_sym_COLON2] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_in] = ACTIONS(12280),
    [anon_sym_SEMI] = ACTIONS(12280),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_isa] = ACTIONS(12280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12280),
    [anon_sym_QMARK] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__lazy_or_operator] = ACTIONS(12280),
    [sym__lazy_and_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [8634] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_EQ] = ACTIONS(12070),
    [anon_sym_COMMA] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_RPAREN] = ACTIONS(12070),
    [anon_sym_COLON2] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_in] = ACTIONS(12070),
    [anon_sym_SEMI] = ACTIONS(12070),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_isa] = ACTIONS(12070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12070),
    [anon_sym_QMARK] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__lazy_or_operator] = ACTIONS(12070),
    [sym__lazy_and_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [8635] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_COMMA] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_RPAREN] = ACTIONS(12284),
    [anon_sym_COLON2] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_in] = ACTIONS(12284),
    [anon_sym_SEMI] = ACTIONS(12284),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_isa] = ACTIONS(12284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12284),
    [anon_sym_QMARK] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__lazy_or_operator] = ACTIONS(12284),
    [sym__lazy_and_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [8636] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_EQ] = ACTIONS(12142),
    [anon_sym_COMMA] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_RPAREN] = ACTIONS(12142),
    [anon_sym_COLON2] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_in] = ACTIONS(12142),
    [anon_sym_SEMI] = ACTIONS(12142),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_isa] = ACTIONS(12142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__lazy_or_operator] = ACTIONS(12142),
    [sym__lazy_and_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [8637] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_EQ] = ACTIONS(12146),
    [anon_sym_COMMA] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_RPAREN] = ACTIONS(12146),
    [anon_sym_COLON2] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_in] = ACTIONS(12146),
    [anon_sym_SEMI] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_isa] = ACTIONS(12146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12146),
    [anon_sym_QMARK] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__lazy_or_operator] = ACTIONS(12146),
    [sym__lazy_and_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [8638] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_EQ] = ACTIONS(12150),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_RPAREN] = ACTIONS(12150),
    [anon_sym_COLON2] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_in] = ACTIONS(12150),
    [anon_sym_SEMI] = ACTIONS(12150),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_isa] = ACTIONS(12150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12150),
    [anon_sym_QMARK] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__lazy_or_operator] = ACTIONS(12150),
    [sym__lazy_and_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [8639] = {
    [sym__word_identifier] = ACTIONS(13598),
    [anon_sym_EQ] = ACTIONS(13598),
    [anon_sym_COMMA] = ACTIONS(13598),
    [anon_sym_COLON] = ACTIONS(13598),
    [anon_sym_begin] = ACTIONS(13598),
    [anon_sym_module] = ACTIONS(13598),
    [anon_sym_baremodule] = ACTIONS(13598),
    [anon_sym_end] = ACTIONS(13598),
    [anon_sym_abstract] = ACTIONS(13598),
    [anon_sym_primitive] = ACTIONS(13598),
    [anon_sym_mutable] = ACTIONS(13598),
    [anon_sym_struct] = ACTIONS(13598),
    [anon_sym_function] = ACTIONS(13598),
    [anon_sym_macro] = ACTIONS(13598),
    [anon_sym_where] = ACTIONS(13598),
    [anon_sym_quote] = ACTIONS(13598),
    [anon_sym_let] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(13598),
    [anon_sym_try] = ACTIONS(13598),
    [anon_sym_catch] = ACTIONS(13598),
    [anon_sym_for] = ACTIONS(13598),
    [anon_sym_while] = ACTIONS(13598),
    [sym_break_statement] = ACTIONS(13598),
    [sym_continue_statement] = ACTIONS(13598),
    [anon_sym_return] = ACTIONS(13598),
    [anon_sym_const] = ACTIONS(13598),
    [anon_sym_global] = ACTIONS(13598),
    [anon_sym_local] = ACTIONS(13598),
    [anon_sym_LPAREN] = ACTIONS(13598),
    [anon_sym_COLON2] = ACTIONS(13598),
    [anon_sym_export] = ACTIONS(13598),
    [anon_sym_import] = ACTIONS(13598),
    [anon_sym_using] = ACTIONS(13598),
    [anon_sym_LBRACK] = ACTIONS(13598),
    [anon_sym_LF] = ACTIONS(13600),
    [anon_sym_in] = ACTIONS(13598),
    [anon_sym_LBRACE] = ACTIONS(13598),
    [anon_sym_DOLLAR] = ACTIONS(13598),
    [anon_sym_COLON_COLON] = ACTIONS(13598),
    [anon_sym_isa] = ACTIONS(13598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13598),
    [anon_sym_QMARK] = ACTIONS(13598),
    [anon_sym_AT] = ACTIONS(13598),
    [anon_sym_true] = ACTIONS(13598),
    [anon_sym_false] = ACTIONS(13598),
    [aux_sym_integer_literal_token1] = ACTIONS(13598),
    [aux_sym_integer_literal_token2] = ACTIONS(13598),
    [aux_sym_integer_literal_token3] = ACTIONS(13598),
    [aux_sym_integer_literal_token4] = ACTIONS(13598),
    [aux_sym_float_literal_token1] = ACTIONS(13598),
    [aux_sym_float_literal_token3] = ACTIONS(13598),
    [aux_sym_float_literal_token4] = ACTIONS(13598),
    [sym_character_literal] = ACTIONS(13598),
    [sym__pair_operator] = ACTIONS(13598),
    [sym__arrow_operator] = ACTIONS(13598),
    [sym__lazy_or_operator] = ACTIONS(13598),
    [sym__lazy_and_operator] = ACTIONS(13598),
    [sym__comparison_operator] = ACTIONS(13598),
    [sym__pipe_right_operator] = ACTIONS(13598),
    [sym__pipe_left_operator] = ACTIONS(13598),
    [sym__ellipsis_operator] = ACTIONS(13598),
    [sym__plus_operator] = ACTIONS(13598),
    [sym__times_operator] = ACTIONS(13598),
    [sym__rational_operator] = ACTIONS(13598),
    [sym__bitshift_operator] = ACTIONS(13598),
    [sym__power_operator] = ACTIONS(13598),
    [sym__tilde_operator] = ACTIONS(13598),
    [sym__type_order_operator] = ACTIONS(13598),
    [sym__unary_operator] = ACTIONS(13598),
    [sym__unary_plus_operator] = ACTIONS(13598),
    [aux_sym__terminator_token1] = ACTIONS(13598),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13600),
    [sym__command_start] = ACTIONS(13600),
  },
  [8640] = {
    [sym__word_identifier] = ACTIONS(13421),
    [anon_sym_EQ] = ACTIONS(13421),
    [anon_sym_COMMA] = ACTIONS(13423),
    [anon_sym_COLON] = ACTIONS(13421),
    [anon_sym_begin] = ACTIONS(13421),
    [anon_sym_module] = ACTIONS(13421),
    [anon_sym_baremodule] = ACTIONS(13421),
    [anon_sym_abstract] = ACTIONS(13421),
    [anon_sym_primitive] = ACTIONS(13421),
    [anon_sym_mutable] = ACTIONS(13421),
    [anon_sym_struct] = ACTIONS(13421),
    [anon_sym_function] = ACTIONS(13421),
    [anon_sym_macro] = ACTIONS(13421),
    [anon_sym_where] = ACTIONS(13421),
    [anon_sym_quote] = ACTIONS(13421),
    [anon_sym_let] = ACTIONS(13421),
    [anon_sym_if] = ACTIONS(13421),
    [anon_sym_try] = ACTIONS(13421),
    [anon_sym_for] = ACTIONS(13421),
    [anon_sym_while] = ACTIONS(13421),
    [sym_break_statement] = ACTIONS(13421),
    [sym_continue_statement] = ACTIONS(13421),
    [anon_sym_return] = ACTIONS(13421),
    [anon_sym_const] = ACTIONS(13421),
    [anon_sym_global] = ACTIONS(13421),
    [anon_sym_local] = ACTIONS(13421),
    [anon_sym_LPAREN] = ACTIONS(13423),
    [anon_sym_RPAREN] = ACTIONS(13423),
    [anon_sym_COLON2] = ACTIONS(13421),
    [anon_sym_export] = ACTIONS(13421),
    [anon_sym_import] = ACTIONS(13421),
    [anon_sym_using] = ACTIONS(13421),
    [anon_sym_LBRACK] = ACTIONS(13423),
    [anon_sym_RBRACK] = ACTIONS(13423),
    [anon_sym_in] = ACTIONS(13421),
    [anon_sym_SEMI] = ACTIONS(13423),
    [anon_sym_LBRACE] = ACTIONS(13423),
    [anon_sym_RBRACE] = ACTIONS(13423),
    [anon_sym_DOLLAR] = ACTIONS(13423),
    [anon_sym_COLON_COLON] = ACTIONS(13423),
    [anon_sym_isa] = ACTIONS(13421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13423),
    [anon_sym_QMARK] = ACTIONS(13423),
    [anon_sym_AT] = ACTIONS(13423),
    [anon_sym_true] = ACTIONS(13421),
    [anon_sym_false] = ACTIONS(13421),
    [aux_sym_integer_literal_token1] = ACTIONS(13423),
    [aux_sym_integer_literal_token2] = ACTIONS(13423),
    [aux_sym_integer_literal_token3] = ACTIONS(13421),
    [aux_sym_integer_literal_token4] = ACTIONS(13421),
    [aux_sym_float_literal_token1] = ACTIONS(13423),
    [aux_sym_float_literal_token3] = ACTIONS(13423),
    [aux_sym_float_literal_token4] = ACTIONS(13423),
    [sym_character_literal] = ACTIONS(13423),
    [sym__pair_operator] = ACTIONS(13423),
    [sym__arrow_operator] = ACTIONS(13421),
    [sym__lazy_or_operator] = ACTIONS(13423),
    [sym__lazy_and_operator] = ACTIONS(13423),
    [sym__comparison_operator] = ACTIONS(13421),
    [sym__pipe_right_operator] = ACTIONS(13423),
    [sym__pipe_left_operator] = ACTIONS(13423),
    [sym__ellipsis_operator] = ACTIONS(13421),
    [sym__plus_operator] = ACTIONS(13421),
    [sym__times_operator] = ACTIONS(13421),
    [sym__rational_operator] = ACTIONS(13423),
    [sym__bitshift_operator] = ACTIONS(13423),
    [sym__power_operator] = ACTIONS(13423),
    [sym__tilde_operator] = ACTIONS(13423),
    [sym__type_order_operator] = ACTIONS(13423),
    [sym__unary_operator] = ACTIONS(13421),
    [sym__unary_plus_operator] = ACTIONS(13421),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13423),
    [sym__command_start] = ACTIONS(13423),
  },
  [8641] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_EQ] = ACTIONS(12158),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_RPAREN] = ACTIONS(12158),
    [anon_sym_COLON2] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_in] = ACTIONS(12158),
    [anon_sym_SEMI] = ACTIONS(12158),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_isa] = ACTIONS(12158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12158),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__lazy_or_operator] = ACTIONS(12158),
    [sym__lazy_and_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [8642] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_EQ] = ACTIONS(12162),
    [anon_sym_COMMA] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_RPAREN] = ACTIONS(12162),
    [anon_sym_COLON2] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_in] = ACTIONS(12162),
    [anon_sym_SEMI] = ACTIONS(12162),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_isa] = ACTIONS(12162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12162),
    [anon_sym_QMARK] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__lazy_or_operator] = ACTIONS(12162),
    [sym__lazy_and_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [8643] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(14543),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_catch] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8644] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(14543),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_catch] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8645] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(14543),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_catch] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8646] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_RPAREN] = ACTIONS(12210),
    [anon_sym_COLON2] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_in] = ACTIONS(12210),
    [anon_sym_SEMI] = ACTIONS(12210),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_isa] = ACTIONS(12210),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12210),
    [anon_sym_QMARK] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__lazy_or_operator] = ACTIONS(12210),
    [sym__lazy_and_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [8647] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_isa] = ACTIONS(12166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__lazy_or_operator] = ACTIONS(12166),
    [sym__lazy_and_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [8648] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(12170),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_RPAREN] = ACTIONS(12170),
    [anon_sym_COLON2] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_in] = ACTIONS(12170),
    [anon_sym_SEMI] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_isa] = ACTIONS(12170),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12170),
    [anon_sym_QMARK] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__lazy_or_operator] = ACTIONS(12170),
    [sym__lazy_and_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [8649] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_EQ] = ACTIONS(12178),
    [anon_sym_COMMA] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_RPAREN] = ACTIONS(12178),
    [anon_sym_COLON2] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_in] = ACTIONS(12178),
    [anon_sym_SEMI] = ACTIONS(12178),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_isa] = ACTIONS(12178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12178),
    [anon_sym_QMARK] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__lazy_or_operator] = ACTIONS(12178),
    [sym__lazy_and_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [8650] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(14616),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_catch] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8651] = {
    [sym__word_identifier] = ACTIONS(13602),
    [anon_sym_EQ] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(13602),
    [anon_sym_COLON] = ACTIONS(13602),
    [anon_sym_begin] = ACTIONS(13602),
    [anon_sym_module] = ACTIONS(13602),
    [anon_sym_baremodule] = ACTIONS(13602),
    [anon_sym_end] = ACTIONS(13602),
    [anon_sym_abstract] = ACTIONS(13602),
    [anon_sym_primitive] = ACTIONS(13602),
    [anon_sym_mutable] = ACTIONS(13602),
    [anon_sym_struct] = ACTIONS(13602),
    [anon_sym_function] = ACTIONS(13602),
    [anon_sym_macro] = ACTIONS(13602),
    [anon_sym_where] = ACTIONS(13602),
    [anon_sym_quote] = ACTIONS(13602),
    [anon_sym_let] = ACTIONS(13602),
    [anon_sym_if] = ACTIONS(13602),
    [anon_sym_try] = ACTIONS(13602),
    [anon_sym_catch] = ACTIONS(13602),
    [anon_sym_for] = ACTIONS(13602),
    [anon_sym_while] = ACTIONS(13602),
    [sym_break_statement] = ACTIONS(13602),
    [sym_continue_statement] = ACTIONS(13602),
    [anon_sym_return] = ACTIONS(13602),
    [anon_sym_const] = ACTIONS(13602),
    [anon_sym_global] = ACTIONS(13602),
    [anon_sym_local] = ACTIONS(13602),
    [anon_sym_LPAREN] = ACTIONS(13602),
    [anon_sym_COLON2] = ACTIONS(13602),
    [anon_sym_export] = ACTIONS(13602),
    [anon_sym_import] = ACTIONS(13602),
    [anon_sym_using] = ACTIONS(13602),
    [anon_sym_LBRACK] = ACTIONS(13602),
    [anon_sym_LF] = ACTIONS(13604),
    [anon_sym_in] = ACTIONS(13602),
    [anon_sym_LBRACE] = ACTIONS(13602),
    [anon_sym_DOLLAR] = ACTIONS(13602),
    [anon_sym_COLON_COLON] = ACTIONS(13602),
    [anon_sym_isa] = ACTIONS(13602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13602),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_AT] = ACTIONS(13602),
    [anon_sym_true] = ACTIONS(13602),
    [anon_sym_false] = ACTIONS(13602),
    [aux_sym_integer_literal_token1] = ACTIONS(13602),
    [aux_sym_integer_literal_token2] = ACTIONS(13602),
    [aux_sym_integer_literal_token3] = ACTIONS(13602),
    [aux_sym_integer_literal_token4] = ACTIONS(13602),
    [aux_sym_float_literal_token1] = ACTIONS(13602),
    [aux_sym_float_literal_token3] = ACTIONS(13602),
    [aux_sym_float_literal_token4] = ACTIONS(13602),
    [sym_character_literal] = ACTIONS(13602),
    [sym__pair_operator] = ACTIONS(13602),
    [sym__arrow_operator] = ACTIONS(13602),
    [sym__lazy_or_operator] = ACTIONS(13602),
    [sym__lazy_and_operator] = ACTIONS(13602),
    [sym__comparison_operator] = ACTIONS(13602),
    [sym__pipe_right_operator] = ACTIONS(13602),
    [sym__pipe_left_operator] = ACTIONS(13602),
    [sym__ellipsis_operator] = ACTIONS(13602),
    [sym__plus_operator] = ACTIONS(13602),
    [sym__times_operator] = ACTIONS(13602),
    [sym__rational_operator] = ACTIONS(13602),
    [sym__bitshift_operator] = ACTIONS(13602),
    [sym__power_operator] = ACTIONS(13602),
    [sym__tilde_operator] = ACTIONS(13602),
    [sym__type_order_operator] = ACTIONS(13602),
    [sym__unary_operator] = ACTIONS(13602),
    [sym__unary_plus_operator] = ACTIONS(13602),
    [aux_sym__terminator_token1] = ACTIONS(13602),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13604),
    [sym__command_start] = ACTIONS(13604),
  },
  [8652] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_else] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_finally] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(13104),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14563),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [8653] = {
    [sym__word_identifier] = ACTIONS(13606),
    [anon_sym_EQ] = ACTIONS(13606),
    [anon_sym_COMMA] = ACTIONS(13606),
    [anon_sym_COLON] = ACTIONS(13606),
    [anon_sym_begin] = ACTIONS(13606),
    [anon_sym_module] = ACTIONS(13606),
    [anon_sym_baremodule] = ACTIONS(13606),
    [anon_sym_end] = ACTIONS(13606),
    [anon_sym_abstract] = ACTIONS(13606),
    [anon_sym_primitive] = ACTIONS(13606),
    [anon_sym_mutable] = ACTIONS(13606),
    [anon_sym_struct] = ACTIONS(13606),
    [anon_sym_function] = ACTIONS(13606),
    [anon_sym_macro] = ACTIONS(13606),
    [anon_sym_where] = ACTIONS(13606),
    [anon_sym_quote] = ACTIONS(13606),
    [anon_sym_let] = ACTIONS(13606),
    [anon_sym_if] = ACTIONS(13606),
    [anon_sym_try] = ACTIONS(13606),
    [anon_sym_catch] = ACTIONS(13606),
    [anon_sym_for] = ACTIONS(13606),
    [anon_sym_while] = ACTIONS(13606),
    [sym_break_statement] = ACTIONS(13606),
    [sym_continue_statement] = ACTIONS(13606),
    [anon_sym_return] = ACTIONS(13606),
    [anon_sym_const] = ACTIONS(13606),
    [anon_sym_global] = ACTIONS(13606),
    [anon_sym_local] = ACTIONS(13606),
    [anon_sym_LPAREN] = ACTIONS(13606),
    [anon_sym_COLON2] = ACTIONS(13606),
    [anon_sym_export] = ACTIONS(13606),
    [anon_sym_import] = ACTIONS(13606),
    [anon_sym_using] = ACTIONS(13606),
    [anon_sym_LBRACK] = ACTIONS(13606),
    [anon_sym_LF] = ACTIONS(13608),
    [anon_sym_in] = ACTIONS(13606),
    [anon_sym_LBRACE] = ACTIONS(13606),
    [anon_sym_DOLLAR] = ACTIONS(13606),
    [anon_sym_COLON_COLON] = ACTIONS(13606),
    [anon_sym_isa] = ACTIONS(13606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_QMARK] = ACTIONS(13606),
    [anon_sym_AT] = ACTIONS(13606),
    [anon_sym_true] = ACTIONS(13606),
    [anon_sym_false] = ACTIONS(13606),
    [aux_sym_integer_literal_token1] = ACTIONS(13606),
    [aux_sym_integer_literal_token2] = ACTIONS(13606),
    [aux_sym_integer_literal_token3] = ACTIONS(13606),
    [aux_sym_integer_literal_token4] = ACTIONS(13606),
    [aux_sym_float_literal_token1] = ACTIONS(13606),
    [aux_sym_float_literal_token3] = ACTIONS(13606),
    [aux_sym_float_literal_token4] = ACTIONS(13606),
    [sym_character_literal] = ACTIONS(13606),
    [sym__pair_operator] = ACTIONS(13606),
    [sym__arrow_operator] = ACTIONS(13606),
    [sym__lazy_or_operator] = ACTIONS(13606),
    [sym__lazy_and_operator] = ACTIONS(13606),
    [sym__comparison_operator] = ACTIONS(13606),
    [sym__pipe_right_operator] = ACTIONS(13606),
    [sym__pipe_left_operator] = ACTIONS(13606),
    [sym__ellipsis_operator] = ACTIONS(13606),
    [sym__plus_operator] = ACTIONS(13606),
    [sym__times_operator] = ACTIONS(13606),
    [sym__rational_operator] = ACTIONS(13606),
    [sym__bitshift_operator] = ACTIONS(13606),
    [sym__power_operator] = ACTIONS(13606),
    [sym__tilde_operator] = ACTIONS(13606),
    [sym__type_order_operator] = ACTIONS(13606),
    [sym__unary_operator] = ACTIONS(13606),
    [sym__unary_plus_operator] = ACTIONS(13606),
    [aux_sym__terminator_token1] = ACTIONS(13606),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13608),
    [sym__command_start] = ACTIONS(13608),
  },
  [8654] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_EQ] = ACTIONS(12062),
    [anon_sym_COMMA] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_COLON2] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_in] = ACTIONS(12062),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_isa] = ACTIONS(12062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12062),
    [anon_sym_QMARK] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__lazy_or_operator] = ACTIONS(12062),
    [sym__lazy_and_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [8655] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_EQ] = ACTIONS(12046),
    [anon_sym_COMMA] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_COLON2] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_in] = ACTIONS(12046),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_isa] = ACTIONS(12046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12046),
    [anon_sym_QMARK] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__lazy_or_operator] = ACTIONS(12046),
    [sym__lazy_and_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [8656] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_EQ] = ACTIONS(12292),
    [anon_sym_COMMA] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_RPAREN] = ACTIONS(12292),
    [anon_sym_COLON2] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_in] = ACTIONS(12292),
    [anon_sym_SEMI] = ACTIONS(12292),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_isa] = ACTIONS(12292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12292),
    [anon_sym_QMARK] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__lazy_or_operator] = ACTIONS(12292),
    [sym__lazy_and_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [8657] = {
    [sym__word_identifier] = ACTIONS(13620),
    [anon_sym_EQ] = ACTIONS(13620),
    [anon_sym_COMMA] = ACTIONS(13620),
    [anon_sym_COLON] = ACTIONS(13620),
    [anon_sym_begin] = ACTIONS(13620),
    [anon_sym_module] = ACTIONS(13620),
    [anon_sym_baremodule] = ACTIONS(13620),
    [anon_sym_end] = ACTIONS(13620),
    [anon_sym_abstract] = ACTIONS(13620),
    [anon_sym_primitive] = ACTIONS(13620),
    [anon_sym_mutable] = ACTIONS(13620),
    [anon_sym_struct] = ACTIONS(13620),
    [anon_sym_function] = ACTIONS(13620),
    [anon_sym_macro] = ACTIONS(13620),
    [anon_sym_where] = ACTIONS(13620),
    [anon_sym_quote] = ACTIONS(13620),
    [anon_sym_let] = ACTIONS(13620),
    [anon_sym_if] = ACTIONS(13620),
    [anon_sym_try] = ACTIONS(13620),
    [anon_sym_catch] = ACTIONS(13620),
    [anon_sym_for] = ACTIONS(13620),
    [anon_sym_while] = ACTIONS(13620),
    [sym_break_statement] = ACTIONS(13620),
    [sym_continue_statement] = ACTIONS(13620),
    [anon_sym_return] = ACTIONS(13620),
    [anon_sym_const] = ACTIONS(13620),
    [anon_sym_global] = ACTIONS(13620),
    [anon_sym_local] = ACTIONS(13620),
    [anon_sym_LPAREN] = ACTIONS(13620),
    [anon_sym_COLON2] = ACTIONS(13620),
    [anon_sym_export] = ACTIONS(13620),
    [anon_sym_import] = ACTIONS(13620),
    [anon_sym_using] = ACTIONS(13620),
    [anon_sym_LBRACK] = ACTIONS(13620),
    [anon_sym_LF] = ACTIONS(13622),
    [anon_sym_in] = ACTIONS(13620),
    [anon_sym_LBRACE] = ACTIONS(13620),
    [anon_sym_DOLLAR] = ACTIONS(13620),
    [anon_sym_COLON_COLON] = ACTIONS(13620),
    [anon_sym_isa] = ACTIONS(13620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13620),
    [anon_sym_QMARK] = ACTIONS(13620),
    [anon_sym_AT] = ACTIONS(13620),
    [anon_sym_true] = ACTIONS(13620),
    [anon_sym_false] = ACTIONS(13620),
    [aux_sym_integer_literal_token1] = ACTIONS(13620),
    [aux_sym_integer_literal_token2] = ACTIONS(13620),
    [aux_sym_integer_literal_token3] = ACTIONS(13620),
    [aux_sym_integer_literal_token4] = ACTIONS(13620),
    [aux_sym_float_literal_token1] = ACTIONS(13620),
    [aux_sym_float_literal_token3] = ACTIONS(13620),
    [aux_sym_float_literal_token4] = ACTIONS(13620),
    [sym_character_literal] = ACTIONS(13620),
    [sym__pair_operator] = ACTIONS(13620),
    [sym__arrow_operator] = ACTIONS(13620),
    [sym__lazy_or_operator] = ACTIONS(13620),
    [sym__lazy_and_operator] = ACTIONS(13620),
    [sym__comparison_operator] = ACTIONS(13620),
    [sym__pipe_right_operator] = ACTIONS(13620),
    [sym__pipe_left_operator] = ACTIONS(13620),
    [sym__ellipsis_operator] = ACTIONS(13620),
    [sym__plus_operator] = ACTIONS(13620),
    [sym__times_operator] = ACTIONS(13620),
    [sym__rational_operator] = ACTIONS(13620),
    [sym__bitshift_operator] = ACTIONS(13620),
    [sym__power_operator] = ACTIONS(13620),
    [sym__tilde_operator] = ACTIONS(13620),
    [sym__type_order_operator] = ACTIONS(13620),
    [sym__unary_operator] = ACTIONS(13620),
    [sym__unary_plus_operator] = ACTIONS(13620),
    [aux_sym__terminator_token1] = ACTIONS(13620),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13622),
    [sym__command_start] = ACTIONS(13622),
  },
  [8658] = {
    [sym__word_identifier] = ACTIONS(13624),
    [anon_sym_EQ] = ACTIONS(13624),
    [anon_sym_COMMA] = ACTIONS(13624),
    [anon_sym_COLON] = ACTIONS(13624),
    [anon_sym_begin] = ACTIONS(13624),
    [anon_sym_module] = ACTIONS(13624),
    [anon_sym_baremodule] = ACTIONS(13624),
    [anon_sym_end] = ACTIONS(13624),
    [anon_sym_abstract] = ACTIONS(13624),
    [anon_sym_primitive] = ACTIONS(13624),
    [anon_sym_mutable] = ACTIONS(13624),
    [anon_sym_struct] = ACTIONS(13624),
    [anon_sym_function] = ACTIONS(13624),
    [anon_sym_macro] = ACTIONS(13624),
    [anon_sym_where] = ACTIONS(13624),
    [anon_sym_quote] = ACTIONS(13624),
    [anon_sym_let] = ACTIONS(13624),
    [anon_sym_if] = ACTIONS(13624),
    [anon_sym_try] = ACTIONS(13624),
    [anon_sym_catch] = ACTIONS(13624),
    [anon_sym_for] = ACTIONS(13624),
    [anon_sym_while] = ACTIONS(13624),
    [sym_break_statement] = ACTIONS(13624),
    [sym_continue_statement] = ACTIONS(13624),
    [anon_sym_return] = ACTIONS(13624),
    [anon_sym_const] = ACTIONS(13624),
    [anon_sym_global] = ACTIONS(13624),
    [anon_sym_local] = ACTIONS(13624),
    [anon_sym_LPAREN] = ACTIONS(13624),
    [anon_sym_COLON2] = ACTIONS(13624),
    [anon_sym_export] = ACTIONS(13624),
    [anon_sym_import] = ACTIONS(13624),
    [anon_sym_using] = ACTIONS(13624),
    [anon_sym_LBRACK] = ACTIONS(13624),
    [anon_sym_LF] = ACTIONS(13626),
    [anon_sym_in] = ACTIONS(13624),
    [anon_sym_LBRACE] = ACTIONS(13624),
    [anon_sym_DOLLAR] = ACTIONS(13624),
    [anon_sym_COLON_COLON] = ACTIONS(13624),
    [anon_sym_isa] = ACTIONS(13624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13624),
    [anon_sym_QMARK] = ACTIONS(13624),
    [anon_sym_AT] = ACTIONS(13624),
    [anon_sym_true] = ACTIONS(13624),
    [anon_sym_false] = ACTIONS(13624),
    [aux_sym_integer_literal_token1] = ACTIONS(13624),
    [aux_sym_integer_literal_token2] = ACTIONS(13624),
    [aux_sym_integer_literal_token3] = ACTIONS(13624),
    [aux_sym_integer_literal_token4] = ACTIONS(13624),
    [aux_sym_float_literal_token1] = ACTIONS(13624),
    [aux_sym_float_literal_token3] = ACTIONS(13624),
    [aux_sym_float_literal_token4] = ACTIONS(13624),
    [sym_character_literal] = ACTIONS(13624),
    [sym__pair_operator] = ACTIONS(13624),
    [sym__arrow_operator] = ACTIONS(13624),
    [sym__lazy_or_operator] = ACTIONS(13624),
    [sym__lazy_and_operator] = ACTIONS(13624),
    [sym__comparison_operator] = ACTIONS(13624),
    [sym__pipe_right_operator] = ACTIONS(13624),
    [sym__pipe_left_operator] = ACTIONS(13624),
    [sym__ellipsis_operator] = ACTIONS(13624),
    [sym__plus_operator] = ACTIONS(13624),
    [sym__times_operator] = ACTIONS(13624),
    [sym__rational_operator] = ACTIONS(13624),
    [sym__bitshift_operator] = ACTIONS(13624),
    [sym__power_operator] = ACTIONS(13624),
    [sym__tilde_operator] = ACTIONS(13624),
    [sym__type_order_operator] = ACTIONS(13624),
    [sym__unary_operator] = ACTIONS(13624),
    [sym__unary_plus_operator] = ACTIONS(13624),
    [aux_sym__terminator_token1] = ACTIONS(13624),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13626),
    [sym__command_start] = ACTIONS(13626),
  },
  [8659] = {
    [sym__word_identifier] = ACTIONS(13628),
    [anon_sym_EQ] = ACTIONS(13628),
    [anon_sym_COMMA] = ACTIONS(13628),
    [anon_sym_COLON] = ACTIONS(13628),
    [anon_sym_begin] = ACTIONS(13628),
    [anon_sym_module] = ACTIONS(13628),
    [anon_sym_baremodule] = ACTIONS(13628),
    [anon_sym_end] = ACTIONS(13628),
    [anon_sym_abstract] = ACTIONS(13628),
    [anon_sym_primitive] = ACTIONS(13628),
    [anon_sym_mutable] = ACTIONS(13628),
    [anon_sym_struct] = ACTIONS(13628),
    [anon_sym_function] = ACTIONS(13628),
    [anon_sym_macro] = ACTIONS(13628),
    [anon_sym_where] = ACTIONS(13628),
    [anon_sym_quote] = ACTIONS(13628),
    [anon_sym_let] = ACTIONS(13628),
    [anon_sym_if] = ACTIONS(13628),
    [anon_sym_try] = ACTIONS(13628),
    [anon_sym_catch] = ACTIONS(13628),
    [anon_sym_for] = ACTIONS(13628),
    [anon_sym_while] = ACTIONS(13628),
    [sym_break_statement] = ACTIONS(13628),
    [sym_continue_statement] = ACTIONS(13628),
    [anon_sym_return] = ACTIONS(13628),
    [anon_sym_const] = ACTIONS(13628),
    [anon_sym_global] = ACTIONS(13628),
    [anon_sym_local] = ACTIONS(13628),
    [anon_sym_LPAREN] = ACTIONS(13628),
    [anon_sym_COLON2] = ACTIONS(13628),
    [anon_sym_export] = ACTIONS(13628),
    [anon_sym_import] = ACTIONS(13628),
    [anon_sym_using] = ACTIONS(13628),
    [anon_sym_LBRACK] = ACTIONS(13628),
    [anon_sym_LF] = ACTIONS(13630),
    [anon_sym_in] = ACTIONS(13628),
    [anon_sym_LBRACE] = ACTIONS(13628),
    [anon_sym_DOLLAR] = ACTIONS(13628),
    [anon_sym_COLON_COLON] = ACTIONS(13628),
    [anon_sym_isa] = ACTIONS(13628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13628),
    [anon_sym_QMARK] = ACTIONS(13628),
    [anon_sym_AT] = ACTIONS(13628),
    [anon_sym_true] = ACTIONS(13628),
    [anon_sym_false] = ACTIONS(13628),
    [aux_sym_integer_literal_token1] = ACTIONS(13628),
    [aux_sym_integer_literal_token2] = ACTIONS(13628),
    [aux_sym_integer_literal_token3] = ACTIONS(13628),
    [aux_sym_integer_literal_token4] = ACTIONS(13628),
    [aux_sym_float_literal_token1] = ACTIONS(13628),
    [aux_sym_float_literal_token3] = ACTIONS(13628),
    [aux_sym_float_literal_token4] = ACTIONS(13628),
    [sym_character_literal] = ACTIONS(13628),
    [sym__pair_operator] = ACTIONS(13628),
    [sym__arrow_operator] = ACTIONS(13628),
    [sym__lazy_or_operator] = ACTIONS(13628),
    [sym__lazy_and_operator] = ACTIONS(13628),
    [sym__comparison_operator] = ACTIONS(13628),
    [sym__pipe_right_operator] = ACTIONS(13628),
    [sym__pipe_left_operator] = ACTIONS(13628),
    [sym__ellipsis_operator] = ACTIONS(13628),
    [sym__plus_operator] = ACTIONS(13628),
    [sym__times_operator] = ACTIONS(13628),
    [sym__rational_operator] = ACTIONS(13628),
    [sym__bitshift_operator] = ACTIONS(13628),
    [sym__power_operator] = ACTIONS(13628),
    [sym__tilde_operator] = ACTIONS(13628),
    [sym__type_order_operator] = ACTIONS(13628),
    [sym__unary_operator] = ACTIONS(13628),
    [sym__unary_plus_operator] = ACTIONS(13628),
    [aux_sym__terminator_token1] = ACTIONS(13628),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13630),
    [sym__command_start] = ACTIONS(13630),
  },
  [8660] = {
    [sym__word_identifier] = ACTIONS(13632),
    [anon_sym_EQ] = ACTIONS(13632),
    [anon_sym_COMMA] = ACTIONS(13632),
    [anon_sym_COLON] = ACTIONS(13632),
    [anon_sym_begin] = ACTIONS(13632),
    [anon_sym_module] = ACTIONS(13632),
    [anon_sym_baremodule] = ACTIONS(13632),
    [anon_sym_end] = ACTIONS(13632),
    [anon_sym_abstract] = ACTIONS(13632),
    [anon_sym_primitive] = ACTIONS(13632),
    [anon_sym_mutable] = ACTIONS(13632),
    [anon_sym_struct] = ACTIONS(13632),
    [anon_sym_function] = ACTIONS(13632),
    [anon_sym_macro] = ACTIONS(13632),
    [anon_sym_where] = ACTIONS(13632),
    [anon_sym_quote] = ACTIONS(13632),
    [anon_sym_let] = ACTIONS(13632),
    [anon_sym_if] = ACTIONS(13632),
    [anon_sym_try] = ACTIONS(13632),
    [anon_sym_catch] = ACTIONS(13632),
    [anon_sym_for] = ACTIONS(13632),
    [anon_sym_while] = ACTIONS(13632),
    [sym_break_statement] = ACTIONS(13632),
    [sym_continue_statement] = ACTIONS(13632),
    [anon_sym_return] = ACTIONS(13632),
    [anon_sym_const] = ACTIONS(13632),
    [anon_sym_global] = ACTIONS(13632),
    [anon_sym_local] = ACTIONS(13632),
    [anon_sym_LPAREN] = ACTIONS(13632),
    [anon_sym_COLON2] = ACTIONS(13632),
    [anon_sym_export] = ACTIONS(13632),
    [anon_sym_import] = ACTIONS(13632),
    [anon_sym_using] = ACTIONS(13632),
    [anon_sym_LBRACK] = ACTIONS(13632),
    [anon_sym_LF] = ACTIONS(13634),
    [anon_sym_in] = ACTIONS(13632),
    [anon_sym_LBRACE] = ACTIONS(13632),
    [anon_sym_DOLLAR] = ACTIONS(13632),
    [anon_sym_COLON_COLON] = ACTIONS(13632),
    [anon_sym_isa] = ACTIONS(13632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13632),
    [anon_sym_QMARK] = ACTIONS(13632),
    [anon_sym_AT] = ACTIONS(13632),
    [anon_sym_true] = ACTIONS(13632),
    [anon_sym_false] = ACTIONS(13632),
    [aux_sym_integer_literal_token1] = ACTIONS(13632),
    [aux_sym_integer_literal_token2] = ACTIONS(13632),
    [aux_sym_integer_literal_token3] = ACTIONS(13632),
    [aux_sym_integer_literal_token4] = ACTIONS(13632),
    [aux_sym_float_literal_token1] = ACTIONS(13632),
    [aux_sym_float_literal_token3] = ACTIONS(13632),
    [aux_sym_float_literal_token4] = ACTIONS(13632),
    [sym_character_literal] = ACTIONS(13632),
    [sym__pair_operator] = ACTIONS(13632),
    [sym__arrow_operator] = ACTIONS(13632),
    [sym__lazy_or_operator] = ACTIONS(13632),
    [sym__lazy_and_operator] = ACTIONS(13632),
    [sym__comparison_operator] = ACTIONS(13632),
    [sym__pipe_right_operator] = ACTIONS(13632),
    [sym__pipe_left_operator] = ACTIONS(13632),
    [sym__ellipsis_operator] = ACTIONS(13632),
    [sym__plus_operator] = ACTIONS(13632),
    [sym__times_operator] = ACTIONS(13632),
    [sym__rational_operator] = ACTIONS(13632),
    [sym__bitshift_operator] = ACTIONS(13632),
    [sym__power_operator] = ACTIONS(13632),
    [sym__tilde_operator] = ACTIONS(13632),
    [sym__type_order_operator] = ACTIONS(13632),
    [sym__unary_operator] = ACTIONS(13632),
    [sym__unary_plus_operator] = ACTIONS(13632),
    [aux_sym__terminator_token1] = ACTIONS(13632),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13634),
    [sym__command_start] = ACTIONS(13634),
  },
  [8661] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_EQ] = ACTIONS(12300),
    [anon_sym_COMMA] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_RPAREN] = ACTIONS(12300),
    [anon_sym_COLON2] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_in] = ACTIONS(12300),
    [anon_sym_SEMI] = ACTIONS(12300),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_isa] = ACTIONS(12300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12300),
    [anon_sym_QMARK] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__lazy_or_operator] = ACTIONS(12300),
    [sym__lazy_and_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [8662] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(14618),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_finally] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8663] = {
    [sym__word_identifier] = ACTIONS(13636),
    [anon_sym_EQ] = ACTIONS(13636),
    [anon_sym_COMMA] = ACTIONS(13636),
    [anon_sym_COLON] = ACTIONS(13636),
    [anon_sym_begin] = ACTIONS(13636),
    [anon_sym_module] = ACTIONS(13636),
    [anon_sym_baremodule] = ACTIONS(13636),
    [anon_sym_end] = ACTIONS(13636),
    [anon_sym_abstract] = ACTIONS(13636),
    [anon_sym_primitive] = ACTIONS(13636),
    [anon_sym_mutable] = ACTIONS(13636),
    [anon_sym_struct] = ACTIONS(13636),
    [anon_sym_function] = ACTIONS(13636),
    [anon_sym_macro] = ACTIONS(13636),
    [anon_sym_where] = ACTIONS(13636),
    [anon_sym_quote] = ACTIONS(13636),
    [anon_sym_let] = ACTIONS(13636),
    [anon_sym_if] = ACTIONS(13636),
    [anon_sym_try] = ACTIONS(13636),
    [anon_sym_catch] = ACTIONS(13636),
    [anon_sym_for] = ACTIONS(13636),
    [anon_sym_while] = ACTIONS(13636),
    [sym_break_statement] = ACTIONS(13636),
    [sym_continue_statement] = ACTIONS(13636),
    [anon_sym_return] = ACTIONS(13636),
    [anon_sym_const] = ACTIONS(13636),
    [anon_sym_global] = ACTIONS(13636),
    [anon_sym_local] = ACTIONS(13636),
    [anon_sym_LPAREN] = ACTIONS(13636),
    [anon_sym_COLON2] = ACTIONS(13636),
    [anon_sym_export] = ACTIONS(13636),
    [anon_sym_import] = ACTIONS(13636),
    [anon_sym_using] = ACTIONS(13636),
    [anon_sym_LBRACK] = ACTIONS(13636),
    [anon_sym_LF] = ACTIONS(13638),
    [anon_sym_in] = ACTIONS(13636),
    [anon_sym_LBRACE] = ACTIONS(13636),
    [anon_sym_DOLLAR] = ACTIONS(13636),
    [anon_sym_COLON_COLON] = ACTIONS(13636),
    [anon_sym_isa] = ACTIONS(13636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13636),
    [anon_sym_QMARK] = ACTIONS(13636),
    [anon_sym_AT] = ACTIONS(13636),
    [anon_sym_true] = ACTIONS(13636),
    [anon_sym_false] = ACTIONS(13636),
    [aux_sym_integer_literal_token1] = ACTIONS(13636),
    [aux_sym_integer_literal_token2] = ACTIONS(13636),
    [aux_sym_integer_literal_token3] = ACTIONS(13636),
    [aux_sym_integer_literal_token4] = ACTIONS(13636),
    [aux_sym_float_literal_token1] = ACTIONS(13636),
    [aux_sym_float_literal_token3] = ACTIONS(13636),
    [aux_sym_float_literal_token4] = ACTIONS(13636),
    [sym_character_literal] = ACTIONS(13636),
    [sym__pair_operator] = ACTIONS(13636),
    [sym__arrow_operator] = ACTIONS(13636),
    [sym__lazy_or_operator] = ACTIONS(13636),
    [sym__lazy_and_operator] = ACTIONS(13636),
    [sym__comparison_operator] = ACTIONS(13636),
    [sym__pipe_right_operator] = ACTIONS(13636),
    [sym__pipe_left_operator] = ACTIONS(13636),
    [sym__ellipsis_operator] = ACTIONS(13636),
    [sym__plus_operator] = ACTIONS(13636),
    [sym__times_operator] = ACTIONS(13636),
    [sym__rational_operator] = ACTIONS(13636),
    [sym__bitshift_operator] = ACTIONS(13636),
    [sym__power_operator] = ACTIONS(13636),
    [sym__tilde_operator] = ACTIONS(13636),
    [sym__type_order_operator] = ACTIONS(13636),
    [sym__unary_operator] = ACTIONS(13636),
    [sym__unary_plus_operator] = ACTIONS(13636),
    [aux_sym__terminator_token1] = ACTIONS(13636),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13638),
    [sym__command_start] = ACTIONS(13638),
  },
  [8664] = {
    [sym__word_identifier] = ACTIONS(13640),
    [anon_sym_EQ] = ACTIONS(13640),
    [anon_sym_COMMA] = ACTIONS(13640),
    [anon_sym_COLON] = ACTIONS(13640),
    [anon_sym_begin] = ACTIONS(13640),
    [anon_sym_module] = ACTIONS(13640),
    [anon_sym_baremodule] = ACTIONS(13640),
    [anon_sym_end] = ACTIONS(13640),
    [anon_sym_abstract] = ACTIONS(13640),
    [anon_sym_primitive] = ACTIONS(13640),
    [anon_sym_mutable] = ACTIONS(13640),
    [anon_sym_struct] = ACTIONS(13640),
    [anon_sym_function] = ACTIONS(13640),
    [anon_sym_macro] = ACTIONS(13640),
    [anon_sym_where] = ACTIONS(13640),
    [anon_sym_quote] = ACTIONS(13640),
    [anon_sym_let] = ACTIONS(13640),
    [anon_sym_if] = ACTIONS(13640),
    [anon_sym_try] = ACTIONS(13640),
    [anon_sym_catch] = ACTIONS(13640),
    [anon_sym_for] = ACTIONS(13640),
    [anon_sym_while] = ACTIONS(13640),
    [sym_break_statement] = ACTIONS(13640),
    [sym_continue_statement] = ACTIONS(13640),
    [anon_sym_return] = ACTIONS(13640),
    [anon_sym_const] = ACTIONS(13640),
    [anon_sym_global] = ACTIONS(13640),
    [anon_sym_local] = ACTIONS(13640),
    [anon_sym_LPAREN] = ACTIONS(13640),
    [anon_sym_COLON2] = ACTIONS(13640),
    [anon_sym_export] = ACTIONS(13640),
    [anon_sym_import] = ACTIONS(13640),
    [anon_sym_using] = ACTIONS(13640),
    [anon_sym_LBRACK] = ACTIONS(13640),
    [anon_sym_LF] = ACTIONS(13642),
    [anon_sym_in] = ACTIONS(13640),
    [anon_sym_LBRACE] = ACTIONS(13640),
    [anon_sym_DOLLAR] = ACTIONS(13640),
    [anon_sym_COLON_COLON] = ACTIONS(13640),
    [anon_sym_isa] = ACTIONS(13640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13640),
    [anon_sym_QMARK] = ACTIONS(13640),
    [anon_sym_AT] = ACTIONS(13640),
    [anon_sym_true] = ACTIONS(13640),
    [anon_sym_false] = ACTIONS(13640),
    [aux_sym_integer_literal_token1] = ACTIONS(13640),
    [aux_sym_integer_literal_token2] = ACTIONS(13640),
    [aux_sym_integer_literal_token3] = ACTIONS(13640),
    [aux_sym_integer_literal_token4] = ACTIONS(13640),
    [aux_sym_float_literal_token1] = ACTIONS(13640),
    [aux_sym_float_literal_token3] = ACTIONS(13640),
    [aux_sym_float_literal_token4] = ACTIONS(13640),
    [sym_character_literal] = ACTIONS(13640),
    [sym__pair_operator] = ACTIONS(13640),
    [sym__arrow_operator] = ACTIONS(13640),
    [sym__lazy_or_operator] = ACTIONS(13640),
    [sym__lazy_and_operator] = ACTIONS(13640),
    [sym__comparison_operator] = ACTIONS(13640),
    [sym__pipe_right_operator] = ACTIONS(13640),
    [sym__pipe_left_operator] = ACTIONS(13640),
    [sym__ellipsis_operator] = ACTIONS(13640),
    [sym__plus_operator] = ACTIONS(13640),
    [sym__times_operator] = ACTIONS(13640),
    [sym__rational_operator] = ACTIONS(13640),
    [sym__bitshift_operator] = ACTIONS(13640),
    [sym__power_operator] = ACTIONS(13640),
    [sym__tilde_operator] = ACTIONS(13640),
    [sym__type_order_operator] = ACTIONS(13640),
    [sym__unary_operator] = ACTIONS(13640),
    [sym__unary_plus_operator] = ACTIONS(13640),
    [aux_sym__terminator_token1] = ACTIONS(13640),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13642),
    [sym__command_start] = ACTIONS(13642),
  },
  [8665] = {
    [sym__word_identifier] = ACTIONS(13644),
    [anon_sym_EQ] = ACTIONS(13644),
    [anon_sym_COMMA] = ACTIONS(13644),
    [anon_sym_COLON] = ACTIONS(13644),
    [anon_sym_begin] = ACTIONS(13644),
    [anon_sym_module] = ACTIONS(13644),
    [anon_sym_baremodule] = ACTIONS(13644),
    [anon_sym_end] = ACTIONS(13644),
    [anon_sym_abstract] = ACTIONS(13644),
    [anon_sym_primitive] = ACTIONS(13644),
    [anon_sym_mutable] = ACTIONS(13644),
    [anon_sym_struct] = ACTIONS(13644),
    [anon_sym_function] = ACTIONS(13644),
    [anon_sym_macro] = ACTIONS(13644),
    [anon_sym_where] = ACTIONS(13644),
    [anon_sym_quote] = ACTIONS(13644),
    [anon_sym_let] = ACTIONS(13644),
    [anon_sym_if] = ACTIONS(13644),
    [anon_sym_try] = ACTIONS(13644),
    [anon_sym_catch] = ACTIONS(13644),
    [anon_sym_for] = ACTIONS(13644),
    [anon_sym_while] = ACTIONS(13644),
    [sym_break_statement] = ACTIONS(13644),
    [sym_continue_statement] = ACTIONS(13644),
    [anon_sym_return] = ACTIONS(13644),
    [anon_sym_const] = ACTIONS(13644),
    [anon_sym_global] = ACTIONS(13644),
    [anon_sym_local] = ACTIONS(13644),
    [anon_sym_LPAREN] = ACTIONS(13644),
    [anon_sym_COLON2] = ACTIONS(13644),
    [anon_sym_export] = ACTIONS(13644),
    [anon_sym_import] = ACTIONS(13644),
    [anon_sym_using] = ACTIONS(13644),
    [anon_sym_LBRACK] = ACTIONS(13644),
    [anon_sym_LF] = ACTIONS(13646),
    [anon_sym_in] = ACTIONS(13644),
    [anon_sym_LBRACE] = ACTIONS(13644),
    [anon_sym_DOLLAR] = ACTIONS(13644),
    [anon_sym_COLON_COLON] = ACTIONS(13644),
    [anon_sym_isa] = ACTIONS(13644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13644),
    [anon_sym_QMARK] = ACTIONS(13644),
    [anon_sym_AT] = ACTIONS(13644),
    [anon_sym_true] = ACTIONS(13644),
    [anon_sym_false] = ACTIONS(13644),
    [aux_sym_integer_literal_token1] = ACTIONS(13644),
    [aux_sym_integer_literal_token2] = ACTIONS(13644),
    [aux_sym_integer_literal_token3] = ACTIONS(13644),
    [aux_sym_integer_literal_token4] = ACTIONS(13644),
    [aux_sym_float_literal_token1] = ACTIONS(13644),
    [aux_sym_float_literal_token3] = ACTIONS(13644),
    [aux_sym_float_literal_token4] = ACTIONS(13644),
    [sym_character_literal] = ACTIONS(13644),
    [sym__pair_operator] = ACTIONS(13644),
    [sym__arrow_operator] = ACTIONS(13644),
    [sym__lazy_or_operator] = ACTIONS(13644),
    [sym__lazy_and_operator] = ACTIONS(13644),
    [sym__comparison_operator] = ACTIONS(13644),
    [sym__pipe_right_operator] = ACTIONS(13644),
    [sym__pipe_left_operator] = ACTIONS(13644),
    [sym__ellipsis_operator] = ACTIONS(13644),
    [sym__plus_operator] = ACTIONS(13644),
    [sym__times_operator] = ACTIONS(13644),
    [sym__rational_operator] = ACTIONS(13644),
    [sym__bitshift_operator] = ACTIONS(13644),
    [sym__power_operator] = ACTIONS(13644),
    [sym__tilde_operator] = ACTIONS(13644),
    [sym__type_order_operator] = ACTIONS(13644),
    [sym__unary_operator] = ACTIONS(13644),
    [sym__unary_plus_operator] = ACTIONS(13644),
    [aux_sym__terminator_token1] = ACTIONS(13644),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13646),
    [sym__command_start] = ACTIONS(13646),
  },
  [8666] = {
    [sym__word_identifier] = ACTIONS(13648),
    [anon_sym_EQ] = ACTIONS(13648),
    [anon_sym_COMMA] = ACTIONS(13648),
    [anon_sym_COLON] = ACTIONS(13648),
    [anon_sym_begin] = ACTIONS(13648),
    [anon_sym_module] = ACTIONS(13648),
    [anon_sym_baremodule] = ACTIONS(13648),
    [anon_sym_end] = ACTIONS(13648),
    [anon_sym_abstract] = ACTIONS(13648),
    [anon_sym_primitive] = ACTIONS(13648),
    [anon_sym_mutable] = ACTIONS(13648),
    [anon_sym_struct] = ACTIONS(13648),
    [anon_sym_function] = ACTIONS(13648),
    [anon_sym_macro] = ACTIONS(13648),
    [anon_sym_where] = ACTIONS(13648),
    [anon_sym_quote] = ACTIONS(13648),
    [anon_sym_let] = ACTIONS(13648),
    [anon_sym_if] = ACTIONS(13648),
    [anon_sym_try] = ACTIONS(13648),
    [anon_sym_catch] = ACTIONS(13648),
    [anon_sym_for] = ACTIONS(13648),
    [anon_sym_while] = ACTIONS(13648),
    [sym_break_statement] = ACTIONS(13648),
    [sym_continue_statement] = ACTIONS(13648),
    [anon_sym_return] = ACTIONS(13648),
    [anon_sym_const] = ACTIONS(13648),
    [anon_sym_global] = ACTIONS(13648),
    [anon_sym_local] = ACTIONS(13648),
    [anon_sym_LPAREN] = ACTIONS(13648),
    [anon_sym_COLON2] = ACTIONS(13648),
    [anon_sym_export] = ACTIONS(13648),
    [anon_sym_import] = ACTIONS(13648),
    [anon_sym_using] = ACTIONS(13648),
    [anon_sym_LBRACK] = ACTIONS(13648),
    [anon_sym_LF] = ACTIONS(13650),
    [anon_sym_in] = ACTIONS(13648),
    [anon_sym_LBRACE] = ACTIONS(13648),
    [anon_sym_DOLLAR] = ACTIONS(13648),
    [anon_sym_COLON_COLON] = ACTIONS(13648),
    [anon_sym_isa] = ACTIONS(13648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13648),
    [anon_sym_QMARK] = ACTIONS(13648),
    [anon_sym_AT] = ACTIONS(13648),
    [anon_sym_true] = ACTIONS(13648),
    [anon_sym_false] = ACTIONS(13648),
    [aux_sym_integer_literal_token1] = ACTIONS(13648),
    [aux_sym_integer_literal_token2] = ACTIONS(13648),
    [aux_sym_integer_literal_token3] = ACTIONS(13648),
    [aux_sym_integer_literal_token4] = ACTIONS(13648),
    [aux_sym_float_literal_token1] = ACTIONS(13648),
    [aux_sym_float_literal_token3] = ACTIONS(13648),
    [aux_sym_float_literal_token4] = ACTIONS(13648),
    [sym_character_literal] = ACTIONS(13648),
    [sym__pair_operator] = ACTIONS(13648),
    [sym__arrow_operator] = ACTIONS(13648),
    [sym__lazy_or_operator] = ACTIONS(13648),
    [sym__lazy_and_operator] = ACTIONS(13648),
    [sym__comparison_operator] = ACTIONS(13648),
    [sym__pipe_right_operator] = ACTIONS(13648),
    [sym__pipe_left_operator] = ACTIONS(13648),
    [sym__ellipsis_operator] = ACTIONS(13648),
    [sym__plus_operator] = ACTIONS(13648),
    [sym__times_operator] = ACTIONS(13648),
    [sym__rational_operator] = ACTIONS(13648),
    [sym__bitshift_operator] = ACTIONS(13648),
    [sym__power_operator] = ACTIONS(13648),
    [sym__tilde_operator] = ACTIONS(13648),
    [sym__type_order_operator] = ACTIONS(13648),
    [sym__unary_operator] = ACTIONS(13648),
    [sym__unary_plus_operator] = ACTIONS(13648),
    [aux_sym__terminator_token1] = ACTIONS(13648),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13650),
    [sym__command_start] = ACTIONS(13650),
  },
  [8667] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(14616),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_catch] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8668] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(14616),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_catch] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8669] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(14616),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_catch] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8670] = {
    [sym__word_identifier] = ACTIONS(13652),
    [anon_sym_EQ] = ACTIONS(13652),
    [anon_sym_COMMA] = ACTIONS(13652),
    [anon_sym_COLON] = ACTIONS(13652),
    [anon_sym_begin] = ACTIONS(13652),
    [anon_sym_module] = ACTIONS(13652),
    [anon_sym_baremodule] = ACTIONS(13652),
    [anon_sym_end] = ACTIONS(13652),
    [anon_sym_abstract] = ACTIONS(13652),
    [anon_sym_primitive] = ACTIONS(13652),
    [anon_sym_mutable] = ACTIONS(13652),
    [anon_sym_struct] = ACTIONS(13652),
    [anon_sym_function] = ACTIONS(13652),
    [anon_sym_macro] = ACTIONS(13652),
    [anon_sym_where] = ACTIONS(13652),
    [anon_sym_quote] = ACTIONS(13652),
    [anon_sym_let] = ACTIONS(13652),
    [anon_sym_if] = ACTIONS(13652),
    [anon_sym_try] = ACTIONS(13652),
    [anon_sym_catch] = ACTIONS(13652),
    [anon_sym_for] = ACTIONS(13652),
    [anon_sym_while] = ACTIONS(13652),
    [sym_break_statement] = ACTIONS(13652),
    [sym_continue_statement] = ACTIONS(13652),
    [anon_sym_return] = ACTIONS(13652),
    [anon_sym_const] = ACTIONS(13652),
    [anon_sym_global] = ACTIONS(13652),
    [anon_sym_local] = ACTIONS(13652),
    [anon_sym_LPAREN] = ACTIONS(13652),
    [anon_sym_COLON2] = ACTIONS(13652),
    [anon_sym_export] = ACTIONS(13652),
    [anon_sym_import] = ACTIONS(13652),
    [anon_sym_using] = ACTIONS(13652),
    [anon_sym_LBRACK] = ACTIONS(13652),
    [anon_sym_LF] = ACTIONS(13654),
    [anon_sym_in] = ACTIONS(13652),
    [anon_sym_LBRACE] = ACTIONS(13652),
    [anon_sym_DOLLAR] = ACTIONS(13652),
    [anon_sym_COLON_COLON] = ACTIONS(13652),
    [anon_sym_isa] = ACTIONS(13652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13652),
    [anon_sym_QMARK] = ACTIONS(13652),
    [anon_sym_AT] = ACTIONS(13652),
    [anon_sym_true] = ACTIONS(13652),
    [anon_sym_false] = ACTIONS(13652),
    [aux_sym_integer_literal_token1] = ACTIONS(13652),
    [aux_sym_integer_literal_token2] = ACTIONS(13652),
    [aux_sym_integer_literal_token3] = ACTIONS(13652),
    [aux_sym_integer_literal_token4] = ACTIONS(13652),
    [aux_sym_float_literal_token1] = ACTIONS(13652),
    [aux_sym_float_literal_token3] = ACTIONS(13652),
    [aux_sym_float_literal_token4] = ACTIONS(13652),
    [sym_character_literal] = ACTIONS(13652),
    [sym__pair_operator] = ACTIONS(13652),
    [sym__arrow_operator] = ACTIONS(13652),
    [sym__lazy_or_operator] = ACTIONS(13652),
    [sym__lazy_and_operator] = ACTIONS(13652),
    [sym__comparison_operator] = ACTIONS(13652),
    [sym__pipe_right_operator] = ACTIONS(13652),
    [sym__pipe_left_operator] = ACTIONS(13652),
    [sym__ellipsis_operator] = ACTIONS(13652),
    [sym__plus_operator] = ACTIONS(13652),
    [sym__times_operator] = ACTIONS(13652),
    [sym__rational_operator] = ACTIONS(13652),
    [sym__bitshift_operator] = ACTIONS(13652),
    [sym__power_operator] = ACTIONS(13652),
    [sym__tilde_operator] = ACTIONS(13652),
    [sym__type_order_operator] = ACTIONS(13652),
    [sym__unary_operator] = ACTIONS(13652),
    [sym__unary_plus_operator] = ACTIONS(13652),
    [aux_sym__terminator_token1] = ACTIONS(13652),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13654),
    [sym__command_start] = ACTIONS(13654),
  },
  [8671] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(14618),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8672] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(14618),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8673] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(14618),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8674] = {
    [sym__word_identifier] = ACTIONS(13656),
    [anon_sym_EQ] = ACTIONS(13656),
    [anon_sym_COMMA] = ACTIONS(13656),
    [anon_sym_COLON] = ACTIONS(13656),
    [anon_sym_begin] = ACTIONS(13656),
    [anon_sym_module] = ACTIONS(13656),
    [anon_sym_baremodule] = ACTIONS(13656),
    [anon_sym_end] = ACTIONS(13656),
    [anon_sym_abstract] = ACTIONS(13656),
    [anon_sym_primitive] = ACTIONS(13656),
    [anon_sym_mutable] = ACTIONS(13656),
    [anon_sym_struct] = ACTIONS(13656),
    [anon_sym_function] = ACTIONS(13656),
    [anon_sym_macro] = ACTIONS(13656),
    [anon_sym_where] = ACTIONS(13656),
    [anon_sym_quote] = ACTIONS(13656),
    [anon_sym_let] = ACTIONS(13656),
    [anon_sym_if] = ACTIONS(13656),
    [anon_sym_try] = ACTIONS(13656),
    [anon_sym_catch] = ACTIONS(13656),
    [anon_sym_for] = ACTIONS(13656),
    [anon_sym_while] = ACTIONS(13656),
    [sym_break_statement] = ACTIONS(13656),
    [sym_continue_statement] = ACTIONS(13656),
    [anon_sym_return] = ACTIONS(13656),
    [anon_sym_const] = ACTIONS(13656),
    [anon_sym_global] = ACTIONS(13656),
    [anon_sym_local] = ACTIONS(13656),
    [anon_sym_LPAREN] = ACTIONS(13656),
    [anon_sym_COLON2] = ACTIONS(13656),
    [anon_sym_export] = ACTIONS(13656),
    [anon_sym_import] = ACTIONS(13656),
    [anon_sym_using] = ACTIONS(13656),
    [anon_sym_LBRACK] = ACTIONS(13656),
    [anon_sym_LF] = ACTIONS(13658),
    [anon_sym_in] = ACTIONS(13656),
    [anon_sym_LBRACE] = ACTIONS(13656),
    [anon_sym_DOLLAR] = ACTIONS(13656),
    [anon_sym_COLON_COLON] = ACTIONS(13656),
    [anon_sym_isa] = ACTIONS(13656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13656),
    [anon_sym_QMARK] = ACTIONS(13656),
    [anon_sym_AT] = ACTIONS(13656),
    [anon_sym_true] = ACTIONS(13656),
    [anon_sym_false] = ACTIONS(13656),
    [aux_sym_integer_literal_token1] = ACTIONS(13656),
    [aux_sym_integer_literal_token2] = ACTIONS(13656),
    [aux_sym_integer_literal_token3] = ACTIONS(13656),
    [aux_sym_integer_literal_token4] = ACTIONS(13656),
    [aux_sym_float_literal_token1] = ACTIONS(13656),
    [aux_sym_float_literal_token3] = ACTIONS(13656),
    [aux_sym_float_literal_token4] = ACTIONS(13656),
    [sym_character_literal] = ACTIONS(13656),
    [sym__pair_operator] = ACTIONS(13656),
    [sym__arrow_operator] = ACTIONS(13656),
    [sym__lazy_or_operator] = ACTIONS(13656),
    [sym__lazy_and_operator] = ACTIONS(13656),
    [sym__comparison_operator] = ACTIONS(13656),
    [sym__pipe_right_operator] = ACTIONS(13656),
    [sym__pipe_left_operator] = ACTIONS(13656),
    [sym__ellipsis_operator] = ACTIONS(13656),
    [sym__plus_operator] = ACTIONS(13656),
    [sym__times_operator] = ACTIONS(13656),
    [sym__rational_operator] = ACTIONS(13656),
    [sym__bitshift_operator] = ACTIONS(13656),
    [sym__power_operator] = ACTIONS(13656),
    [sym__tilde_operator] = ACTIONS(13656),
    [sym__type_order_operator] = ACTIONS(13656),
    [sym__unary_operator] = ACTIONS(13656),
    [sym__unary_plus_operator] = ACTIONS(13656),
    [aux_sym__terminator_token1] = ACTIONS(13656),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13658),
    [sym__command_start] = ACTIONS(13658),
  },
  [8675] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11952),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8676] = {
    [sym__word_identifier] = ACTIONS(13660),
    [anon_sym_EQ] = ACTIONS(13660),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_COLON] = ACTIONS(13660),
    [anon_sym_begin] = ACTIONS(13660),
    [anon_sym_module] = ACTIONS(13660),
    [anon_sym_baremodule] = ACTIONS(13660),
    [anon_sym_end] = ACTIONS(13660),
    [anon_sym_abstract] = ACTIONS(13660),
    [anon_sym_primitive] = ACTIONS(13660),
    [anon_sym_mutable] = ACTIONS(13660),
    [anon_sym_struct] = ACTIONS(13660),
    [anon_sym_function] = ACTIONS(13660),
    [anon_sym_macro] = ACTIONS(13660),
    [anon_sym_where] = ACTIONS(13660),
    [anon_sym_quote] = ACTIONS(13660),
    [anon_sym_let] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_try] = ACTIONS(13660),
    [anon_sym_catch] = ACTIONS(13660),
    [anon_sym_for] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [sym_break_statement] = ACTIONS(13660),
    [sym_continue_statement] = ACTIONS(13660),
    [anon_sym_return] = ACTIONS(13660),
    [anon_sym_const] = ACTIONS(13660),
    [anon_sym_global] = ACTIONS(13660),
    [anon_sym_local] = ACTIONS(13660),
    [anon_sym_LPAREN] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13660),
    [anon_sym_export] = ACTIONS(13660),
    [anon_sym_import] = ACTIONS(13660),
    [anon_sym_using] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_LF] = ACTIONS(13662),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_DOLLAR] = ACTIONS(13660),
    [anon_sym_COLON_COLON] = ACTIONS(13660),
    [anon_sym_isa] = ACTIONS(13660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_AT] = ACTIONS(13660),
    [anon_sym_true] = ACTIONS(13660),
    [anon_sym_false] = ACTIONS(13660),
    [aux_sym_integer_literal_token1] = ACTIONS(13660),
    [aux_sym_integer_literal_token2] = ACTIONS(13660),
    [aux_sym_integer_literal_token3] = ACTIONS(13660),
    [aux_sym_integer_literal_token4] = ACTIONS(13660),
    [aux_sym_float_literal_token1] = ACTIONS(13660),
    [aux_sym_float_literal_token3] = ACTIONS(13660),
    [aux_sym_float_literal_token4] = ACTIONS(13660),
    [sym_character_literal] = ACTIONS(13660),
    [sym__pair_operator] = ACTIONS(13660),
    [sym__arrow_operator] = ACTIONS(13660),
    [sym__lazy_or_operator] = ACTIONS(13660),
    [sym__lazy_and_operator] = ACTIONS(13660),
    [sym__comparison_operator] = ACTIONS(13660),
    [sym__pipe_right_operator] = ACTIONS(13660),
    [sym__pipe_left_operator] = ACTIONS(13660),
    [sym__ellipsis_operator] = ACTIONS(13660),
    [sym__plus_operator] = ACTIONS(13660),
    [sym__times_operator] = ACTIONS(13660),
    [sym__rational_operator] = ACTIONS(13660),
    [sym__bitshift_operator] = ACTIONS(13660),
    [sym__power_operator] = ACTIONS(13660),
    [sym__tilde_operator] = ACTIONS(13660),
    [sym__type_order_operator] = ACTIONS(13660),
    [sym__unary_operator] = ACTIONS(13660),
    [sym__unary_plus_operator] = ACTIONS(13660),
    [aux_sym__terminator_token1] = ACTIONS(13660),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13662),
    [sym__command_start] = ACTIONS(13662),
  },
  [8677] = {
    [sym__word_identifier] = ACTIONS(13664),
    [anon_sym_EQ] = ACTIONS(13664),
    [anon_sym_COMMA] = ACTIONS(13664),
    [anon_sym_COLON] = ACTIONS(13664),
    [anon_sym_begin] = ACTIONS(13664),
    [anon_sym_module] = ACTIONS(13664),
    [anon_sym_baremodule] = ACTIONS(13664),
    [anon_sym_end] = ACTIONS(13664),
    [anon_sym_abstract] = ACTIONS(13664),
    [anon_sym_primitive] = ACTIONS(13664),
    [anon_sym_mutable] = ACTIONS(13664),
    [anon_sym_struct] = ACTIONS(13664),
    [anon_sym_function] = ACTIONS(13664),
    [anon_sym_macro] = ACTIONS(13664),
    [anon_sym_where] = ACTIONS(13664),
    [anon_sym_quote] = ACTIONS(13664),
    [anon_sym_let] = ACTIONS(13664),
    [anon_sym_if] = ACTIONS(13664),
    [anon_sym_try] = ACTIONS(13664),
    [anon_sym_catch] = ACTIONS(13664),
    [anon_sym_for] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(13664),
    [sym_break_statement] = ACTIONS(13664),
    [sym_continue_statement] = ACTIONS(13664),
    [anon_sym_return] = ACTIONS(13664),
    [anon_sym_const] = ACTIONS(13664),
    [anon_sym_global] = ACTIONS(13664),
    [anon_sym_local] = ACTIONS(13664),
    [anon_sym_LPAREN] = ACTIONS(13664),
    [anon_sym_COLON2] = ACTIONS(13664),
    [anon_sym_export] = ACTIONS(13664),
    [anon_sym_import] = ACTIONS(13664),
    [anon_sym_using] = ACTIONS(13664),
    [anon_sym_LBRACK] = ACTIONS(13664),
    [anon_sym_LF] = ACTIONS(13666),
    [anon_sym_in] = ACTIONS(13664),
    [anon_sym_LBRACE] = ACTIONS(13664),
    [anon_sym_DOLLAR] = ACTIONS(13664),
    [anon_sym_COLON_COLON] = ACTIONS(13664),
    [anon_sym_isa] = ACTIONS(13664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13664),
    [anon_sym_QMARK] = ACTIONS(13664),
    [anon_sym_AT] = ACTIONS(13664),
    [anon_sym_true] = ACTIONS(13664),
    [anon_sym_false] = ACTIONS(13664),
    [aux_sym_integer_literal_token1] = ACTIONS(13664),
    [aux_sym_integer_literal_token2] = ACTIONS(13664),
    [aux_sym_integer_literal_token3] = ACTIONS(13664),
    [aux_sym_integer_literal_token4] = ACTIONS(13664),
    [aux_sym_float_literal_token1] = ACTIONS(13664),
    [aux_sym_float_literal_token3] = ACTIONS(13664),
    [aux_sym_float_literal_token4] = ACTIONS(13664),
    [sym_character_literal] = ACTIONS(13664),
    [sym__pair_operator] = ACTIONS(13664),
    [sym__arrow_operator] = ACTIONS(13664),
    [sym__lazy_or_operator] = ACTIONS(13664),
    [sym__lazy_and_operator] = ACTIONS(13664),
    [sym__comparison_operator] = ACTIONS(13664),
    [sym__pipe_right_operator] = ACTIONS(13664),
    [sym__pipe_left_operator] = ACTIONS(13664),
    [sym__ellipsis_operator] = ACTIONS(13664),
    [sym__plus_operator] = ACTIONS(13664),
    [sym__times_operator] = ACTIONS(13664),
    [sym__rational_operator] = ACTIONS(13664),
    [sym__bitshift_operator] = ACTIONS(13664),
    [sym__power_operator] = ACTIONS(13664),
    [sym__tilde_operator] = ACTIONS(13664),
    [sym__type_order_operator] = ACTIONS(13664),
    [sym__unary_operator] = ACTIONS(13664),
    [sym__unary_plus_operator] = ACTIONS(13664),
    [aux_sym__terminator_token1] = ACTIONS(13664),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13666),
    [sym__command_start] = ACTIONS(13666),
  },
  [8678] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8679] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11954),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8680] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_EQ] = ACTIONS(12304),
    [anon_sym_COMMA] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_RPAREN] = ACTIONS(12304),
    [anon_sym_COLON2] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_in] = ACTIONS(12304),
    [anon_sym_SEMI] = ACTIONS(12304),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_isa] = ACTIONS(12304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12304),
    [anon_sym_QMARK] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__lazy_or_operator] = ACTIONS(12304),
    [sym__lazy_and_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [8681] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(11922),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8682] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12462),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8683] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8684] = {
    [sym__word_identifier] = ACTIONS(13425),
    [anon_sym_EQ] = ACTIONS(13425),
    [anon_sym_COMMA] = ACTIONS(13427),
    [anon_sym_COLON] = ACTIONS(13425),
    [anon_sym_begin] = ACTIONS(13425),
    [anon_sym_module] = ACTIONS(13425),
    [anon_sym_baremodule] = ACTIONS(13425),
    [anon_sym_abstract] = ACTIONS(13425),
    [anon_sym_primitive] = ACTIONS(13425),
    [anon_sym_mutable] = ACTIONS(13425),
    [anon_sym_struct] = ACTIONS(13425),
    [anon_sym_function] = ACTIONS(13425),
    [anon_sym_macro] = ACTIONS(13425),
    [anon_sym_where] = ACTIONS(13425),
    [anon_sym_quote] = ACTIONS(13425),
    [anon_sym_let] = ACTIONS(13425),
    [anon_sym_if] = ACTIONS(13425),
    [anon_sym_try] = ACTIONS(13425),
    [anon_sym_for] = ACTIONS(13425),
    [anon_sym_while] = ACTIONS(13425),
    [sym_break_statement] = ACTIONS(13425),
    [sym_continue_statement] = ACTIONS(13425),
    [anon_sym_return] = ACTIONS(13425),
    [anon_sym_const] = ACTIONS(13425),
    [anon_sym_global] = ACTIONS(13425),
    [anon_sym_local] = ACTIONS(13425),
    [anon_sym_LPAREN] = ACTIONS(13427),
    [anon_sym_RPAREN] = ACTIONS(13427),
    [anon_sym_COLON2] = ACTIONS(13425),
    [anon_sym_export] = ACTIONS(13425),
    [anon_sym_import] = ACTIONS(13425),
    [anon_sym_using] = ACTIONS(13425),
    [anon_sym_LBRACK] = ACTIONS(13427),
    [anon_sym_RBRACK] = ACTIONS(13427),
    [anon_sym_in] = ACTIONS(13425),
    [anon_sym_SEMI] = ACTIONS(13427),
    [anon_sym_LBRACE] = ACTIONS(13427),
    [anon_sym_RBRACE] = ACTIONS(13427),
    [anon_sym_DOLLAR] = ACTIONS(13427),
    [anon_sym_COLON_COLON] = ACTIONS(13427),
    [anon_sym_isa] = ACTIONS(13425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13427),
    [anon_sym_QMARK] = ACTIONS(13427),
    [anon_sym_AT] = ACTIONS(13427),
    [anon_sym_true] = ACTIONS(13425),
    [anon_sym_false] = ACTIONS(13425),
    [aux_sym_integer_literal_token1] = ACTIONS(13427),
    [aux_sym_integer_literal_token2] = ACTIONS(13427),
    [aux_sym_integer_literal_token3] = ACTIONS(13425),
    [aux_sym_integer_literal_token4] = ACTIONS(13425),
    [aux_sym_float_literal_token1] = ACTIONS(13427),
    [aux_sym_float_literal_token3] = ACTIONS(13427),
    [aux_sym_float_literal_token4] = ACTIONS(13427),
    [sym_character_literal] = ACTIONS(13427),
    [sym__pair_operator] = ACTIONS(13427),
    [sym__arrow_operator] = ACTIONS(13425),
    [sym__lazy_or_operator] = ACTIONS(13427),
    [sym__lazy_and_operator] = ACTIONS(13427),
    [sym__comparison_operator] = ACTIONS(13425),
    [sym__pipe_right_operator] = ACTIONS(13427),
    [sym__pipe_left_operator] = ACTIONS(13427),
    [sym__ellipsis_operator] = ACTIONS(13425),
    [sym__plus_operator] = ACTIONS(13425),
    [sym__times_operator] = ACTIONS(13425),
    [sym__rational_operator] = ACTIONS(13427),
    [sym__bitshift_operator] = ACTIONS(13427),
    [sym__power_operator] = ACTIONS(13427),
    [sym__tilde_operator] = ACTIONS(13427),
    [sym__type_order_operator] = ACTIONS(13427),
    [sym__unary_operator] = ACTIONS(13425),
    [sym__unary_plus_operator] = ACTIONS(13425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13427),
    [sym__command_start] = ACTIONS(13427),
  },
  [8685] = {
    [sym__word_identifier] = ACTIONS(13624),
    [anon_sym_EQ] = ACTIONS(13624),
    [anon_sym_COMMA] = ACTIONS(13624),
    [anon_sym_COLON] = ACTIONS(13624),
    [anon_sym_begin] = ACTIONS(13624),
    [anon_sym_module] = ACTIONS(13624),
    [anon_sym_baremodule] = ACTIONS(13624),
    [anon_sym_abstract] = ACTIONS(13624),
    [anon_sym_primitive] = ACTIONS(13624),
    [anon_sym_mutable] = ACTIONS(13624),
    [anon_sym_struct] = ACTIONS(13624),
    [anon_sym_function] = ACTIONS(13624),
    [anon_sym_macro] = ACTIONS(13624),
    [anon_sym_where] = ACTIONS(13624),
    [anon_sym_quote] = ACTIONS(13624),
    [anon_sym_let] = ACTIONS(13624),
    [anon_sym_if] = ACTIONS(13624),
    [anon_sym_try] = ACTIONS(13624),
    [anon_sym_catch] = ACTIONS(13624),
    [anon_sym_finally] = ACTIONS(13624),
    [anon_sym_for] = ACTIONS(13624),
    [anon_sym_while] = ACTIONS(13624),
    [sym_break_statement] = ACTIONS(13624),
    [sym_continue_statement] = ACTIONS(13624),
    [anon_sym_return] = ACTIONS(13624),
    [anon_sym_const] = ACTIONS(13624),
    [anon_sym_global] = ACTIONS(13624),
    [anon_sym_local] = ACTIONS(13624),
    [anon_sym_LPAREN] = ACTIONS(13624),
    [anon_sym_COLON2] = ACTIONS(13624),
    [anon_sym_export] = ACTIONS(13624),
    [anon_sym_import] = ACTIONS(13624),
    [anon_sym_using] = ACTIONS(13624),
    [anon_sym_LBRACK] = ACTIONS(13624),
    [anon_sym_LF] = ACTIONS(13626),
    [anon_sym_in] = ACTIONS(13624),
    [anon_sym_LBRACE] = ACTIONS(13624),
    [anon_sym_DOLLAR] = ACTIONS(13624),
    [anon_sym_COLON_COLON] = ACTIONS(13624),
    [anon_sym_isa] = ACTIONS(13624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13624),
    [anon_sym_QMARK] = ACTIONS(13624),
    [anon_sym_AT] = ACTIONS(13624),
    [anon_sym_true] = ACTIONS(13624),
    [anon_sym_false] = ACTIONS(13624),
    [aux_sym_integer_literal_token1] = ACTIONS(13624),
    [aux_sym_integer_literal_token2] = ACTIONS(13624),
    [aux_sym_integer_literal_token3] = ACTIONS(13624),
    [aux_sym_integer_literal_token4] = ACTIONS(13624),
    [aux_sym_float_literal_token1] = ACTIONS(13624),
    [aux_sym_float_literal_token3] = ACTIONS(13624),
    [aux_sym_float_literal_token4] = ACTIONS(13624),
    [sym_character_literal] = ACTIONS(13624),
    [sym__pair_operator] = ACTIONS(13624),
    [sym__arrow_operator] = ACTIONS(13624),
    [sym__lazy_or_operator] = ACTIONS(13624),
    [sym__lazy_and_operator] = ACTIONS(13624),
    [sym__comparison_operator] = ACTIONS(13624),
    [sym__pipe_right_operator] = ACTIONS(13624),
    [sym__pipe_left_operator] = ACTIONS(13624),
    [sym__ellipsis_operator] = ACTIONS(13624),
    [sym__plus_operator] = ACTIONS(13624),
    [sym__times_operator] = ACTIONS(13624),
    [sym__rational_operator] = ACTIONS(13624),
    [sym__bitshift_operator] = ACTIONS(13624),
    [sym__power_operator] = ACTIONS(13624),
    [sym__tilde_operator] = ACTIONS(13624),
    [sym__type_order_operator] = ACTIONS(13624),
    [sym__unary_operator] = ACTIONS(13624),
    [sym__unary_plus_operator] = ACTIONS(13624),
    [aux_sym__terminator_token1] = ACTIONS(13624),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13626),
    [sym__command_start] = ACTIONS(13626),
  },
  [8686] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_as] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8687] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOT] = ACTIONS(14672),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8688] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_EQ] = ACTIONS(12154),
    [anon_sym_COMMA] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_RPAREN] = ACTIONS(12154),
    [anon_sym_COLON2] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_in] = ACTIONS(12154),
    [anon_sym_SEMI] = ACTIONS(12154),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_isa] = ACTIONS(12154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12154),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__lazy_or_operator] = ACTIONS(12154),
    [sym__lazy_and_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [8689] = {
    [sym__word_identifier] = ACTIONS(13316),
    [anon_sym_EQ] = ACTIONS(13316),
    [anon_sym_COMMA] = ACTIONS(13316),
    [anon_sym_COLON] = ACTIONS(13316),
    [anon_sym_begin] = ACTIONS(13316),
    [anon_sym_module] = ACTIONS(13316),
    [anon_sym_baremodule] = ACTIONS(13316),
    [anon_sym_end] = ACTIONS(13316),
    [anon_sym_abstract] = ACTIONS(13316),
    [anon_sym_primitive] = ACTIONS(13316),
    [anon_sym_mutable] = ACTIONS(13316),
    [anon_sym_struct] = ACTIONS(13316),
    [anon_sym_function] = ACTIONS(13316),
    [anon_sym_macro] = ACTIONS(13316),
    [anon_sym_where] = ACTIONS(13316),
    [anon_sym_quote] = ACTIONS(13316),
    [anon_sym_let] = ACTIONS(13316),
    [anon_sym_if] = ACTIONS(13316),
    [anon_sym_try] = ACTIONS(13316),
    [anon_sym_finally] = ACTIONS(13316),
    [anon_sym_for] = ACTIONS(13316),
    [anon_sym_while] = ACTIONS(13316),
    [sym_break_statement] = ACTIONS(13316),
    [sym_continue_statement] = ACTIONS(13316),
    [anon_sym_return] = ACTIONS(13316),
    [anon_sym_const] = ACTIONS(13316),
    [anon_sym_global] = ACTIONS(13316),
    [anon_sym_local] = ACTIONS(13316),
    [anon_sym_LPAREN] = ACTIONS(13316),
    [anon_sym_COLON2] = ACTIONS(13316),
    [anon_sym_export] = ACTIONS(13316),
    [anon_sym_import] = ACTIONS(13316),
    [anon_sym_using] = ACTIONS(13316),
    [anon_sym_LBRACK] = ACTIONS(13316),
    [anon_sym_LF] = ACTIONS(13318),
    [anon_sym_in] = ACTIONS(13316),
    [anon_sym_LBRACE] = ACTIONS(13316),
    [anon_sym_DOLLAR] = ACTIONS(13316),
    [anon_sym_COLON_COLON] = ACTIONS(13316),
    [anon_sym_isa] = ACTIONS(13316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13316),
    [anon_sym_QMARK] = ACTIONS(13316),
    [anon_sym_AT] = ACTIONS(13316),
    [anon_sym_true] = ACTIONS(13316),
    [anon_sym_false] = ACTIONS(13316),
    [aux_sym_integer_literal_token1] = ACTIONS(13316),
    [aux_sym_integer_literal_token2] = ACTIONS(13316),
    [aux_sym_integer_literal_token3] = ACTIONS(13316),
    [aux_sym_integer_literal_token4] = ACTIONS(13316),
    [aux_sym_float_literal_token1] = ACTIONS(13316),
    [aux_sym_float_literal_token3] = ACTIONS(13316),
    [aux_sym_float_literal_token4] = ACTIONS(13316),
    [sym_character_literal] = ACTIONS(13316),
    [sym__pair_operator] = ACTIONS(13316),
    [sym__arrow_operator] = ACTIONS(13316),
    [sym__lazy_or_operator] = ACTIONS(13316),
    [sym__lazy_and_operator] = ACTIONS(13316),
    [sym__comparison_operator] = ACTIONS(13316),
    [sym__pipe_right_operator] = ACTIONS(13316),
    [sym__pipe_left_operator] = ACTIONS(13316),
    [sym__ellipsis_operator] = ACTIONS(13316),
    [sym__plus_operator] = ACTIONS(13316),
    [sym__times_operator] = ACTIONS(13316),
    [sym__rational_operator] = ACTIONS(13316),
    [sym__bitshift_operator] = ACTIONS(13316),
    [sym__power_operator] = ACTIONS(13316),
    [sym__tilde_operator] = ACTIONS(13316),
    [sym__type_order_operator] = ACTIONS(13316),
    [sym__unary_operator] = ACTIONS(13316),
    [sym__unary_plus_operator] = ACTIONS(13316),
    [aux_sym__terminator_token1] = ACTIONS(13316),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13318),
    [sym__command_start] = ACTIONS(13318),
  },
  [8690] = {
    [sym__word_identifier] = ACTIONS(13320),
    [anon_sym_EQ] = ACTIONS(13320),
    [anon_sym_COMMA] = ACTIONS(13320),
    [anon_sym_COLON] = ACTIONS(13320),
    [anon_sym_begin] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(13320),
    [anon_sym_baremodule] = ACTIONS(13320),
    [anon_sym_end] = ACTIONS(13320),
    [anon_sym_abstract] = ACTIONS(13320),
    [anon_sym_primitive] = ACTIONS(13320),
    [anon_sym_mutable] = ACTIONS(13320),
    [anon_sym_struct] = ACTIONS(13320),
    [anon_sym_function] = ACTIONS(13320),
    [anon_sym_macro] = ACTIONS(13320),
    [anon_sym_where] = ACTIONS(13320),
    [anon_sym_quote] = ACTIONS(13320),
    [anon_sym_let] = ACTIONS(13320),
    [anon_sym_if] = ACTIONS(13320),
    [anon_sym_try] = ACTIONS(13320),
    [anon_sym_finally] = ACTIONS(13320),
    [anon_sym_for] = ACTIONS(13320),
    [anon_sym_while] = ACTIONS(13320),
    [sym_break_statement] = ACTIONS(13320),
    [sym_continue_statement] = ACTIONS(13320),
    [anon_sym_return] = ACTIONS(13320),
    [anon_sym_const] = ACTIONS(13320),
    [anon_sym_global] = ACTIONS(13320),
    [anon_sym_local] = ACTIONS(13320),
    [anon_sym_LPAREN] = ACTIONS(13320),
    [anon_sym_COLON2] = ACTIONS(13320),
    [anon_sym_export] = ACTIONS(13320),
    [anon_sym_import] = ACTIONS(13320),
    [anon_sym_using] = ACTIONS(13320),
    [anon_sym_LBRACK] = ACTIONS(13320),
    [anon_sym_LF] = ACTIONS(13322),
    [anon_sym_in] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(13320),
    [anon_sym_DOLLAR] = ACTIONS(13320),
    [anon_sym_COLON_COLON] = ACTIONS(13320),
    [anon_sym_isa] = ACTIONS(13320),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13320),
    [anon_sym_QMARK] = ACTIONS(13320),
    [anon_sym_AT] = ACTIONS(13320),
    [anon_sym_true] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(13320),
    [aux_sym_integer_literal_token1] = ACTIONS(13320),
    [aux_sym_integer_literal_token2] = ACTIONS(13320),
    [aux_sym_integer_literal_token3] = ACTIONS(13320),
    [aux_sym_integer_literal_token4] = ACTIONS(13320),
    [aux_sym_float_literal_token1] = ACTIONS(13320),
    [aux_sym_float_literal_token3] = ACTIONS(13320),
    [aux_sym_float_literal_token4] = ACTIONS(13320),
    [sym_character_literal] = ACTIONS(13320),
    [sym__pair_operator] = ACTIONS(13320),
    [sym__arrow_operator] = ACTIONS(13320),
    [sym__lazy_or_operator] = ACTIONS(13320),
    [sym__lazy_and_operator] = ACTIONS(13320),
    [sym__comparison_operator] = ACTIONS(13320),
    [sym__pipe_right_operator] = ACTIONS(13320),
    [sym__pipe_left_operator] = ACTIONS(13320),
    [sym__ellipsis_operator] = ACTIONS(13320),
    [sym__plus_operator] = ACTIONS(13320),
    [sym__times_operator] = ACTIONS(13320),
    [sym__rational_operator] = ACTIONS(13320),
    [sym__bitshift_operator] = ACTIONS(13320),
    [sym__power_operator] = ACTIONS(13320),
    [sym__tilde_operator] = ACTIONS(13320),
    [sym__type_order_operator] = ACTIONS(13320),
    [sym__unary_operator] = ACTIONS(13320),
    [sym__unary_plus_operator] = ACTIONS(13320),
    [aux_sym__terminator_token1] = ACTIONS(13320),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13322),
    [sym__command_start] = ACTIONS(13322),
  },
  [8691] = {
    [sym__word_identifier] = ACTIONS(13429),
    [anon_sym_EQ] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(13431),
    [anon_sym_COLON] = ACTIONS(13429),
    [anon_sym_begin] = ACTIONS(13429),
    [anon_sym_module] = ACTIONS(13429),
    [anon_sym_baremodule] = ACTIONS(13429),
    [anon_sym_abstract] = ACTIONS(13429),
    [anon_sym_primitive] = ACTIONS(13429),
    [anon_sym_mutable] = ACTIONS(13429),
    [anon_sym_struct] = ACTIONS(13429),
    [anon_sym_function] = ACTIONS(13429),
    [anon_sym_macro] = ACTIONS(13429),
    [anon_sym_where] = ACTIONS(13429),
    [anon_sym_quote] = ACTIONS(13429),
    [anon_sym_let] = ACTIONS(13429),
    [anon_sym_if] = ACTIONS(13429),
    [anon_sym_try] = ACTIONS(13429),
    [anon_sym_for] = ACTIONS(13429),
    [anon_sym_while] = ACTIONS(13429),
    [sym_break_statement] = ACTIONS(13429),
    [sym_continue_statement] = ACTIONS(13429),
    [anon_sym_return] = ACTIONS(13429),
    [anon_sym_const] = ACTIONS(13429),
    [anon_sym_global] = ACTIONS(13429),
    [anon_sym_local] = ACTIONS(13429),
    [anon_sym_LPAREN] = ACTIONS(13431),
    [anon_sym_RPAREN] = ACTIONS(13431),
    [anon_sym_COLON2] = ACTIONS(13429),
    [anon_sym_export] = ACTIONS(13429),
    [anon_sym_import] = ACTIONS(13429),
    [anon_sym_using] = ACTIONS(13429),
    [anon_sym_LBRACK] = ACTIONS(13431),
    [anon_sym_RBRACK] = ACTIONS(13431),
    [anon_sym_in] = ACTIONS(13429),
    [anon_sym_SEMI] = ACTIONS(13431),
    [anon_sym_LBRACE] = ACTIONS(13431),
    [anon_sym_RBRACE] = ACTIONS(13431),
    [anon_sym_DOLLAR] = ACTIONS(13431),
    [anon_sym_COLON_COLON] = ACTIONS(13431),
    [anon_sym_isa] = ACTIONS(13429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13431),
    [anon_sym_QMARK] = ACTIONS(13431),
    [anon_sym_AT] = ACTIONS(13431),
    [anon_sym_true] = ACTIONS(13429),
    [anon_sym_false] = ACTIONS(13429),
    [aux_sym_integer_literal_token1] = ACTIONS(13431),
    [aux_sym_integer_literal_token2] = ACTIONS(13431),
    [aux_sym_integer_literal_token3] = ACTIONS(13429),
    [aux_sym_integer_literal_token4] = ACTIONS(13429),
    [aux_sym_float_literal_token1] = ACTIONS(13431),
    [aux_sym_float_literal_token3] = ACTIONS(13431),
    [aux_sym_float_literal_token4] = ACTIONS(13431),
    [sym_character_literal] = ACTIONS(13431),
    [sym__pair_operator] = ACTIONS(13431),
    [sym__arrow_operator] = ACTIONS(13429),
    [sym__lazy_or_operator] = ACTIONS(13431),
    [sym__lazy_and_operator] = ACTIONS(13431),
    [sym__comparison_operator] = ACTIONS(13429),
    [sym__pipe_right_operator] = ACTIONS(13431),
    [sym__pipe_left_operator] = ACTIONS(13431),
    [sym__ellipsis_operator] = ACTIONS(13429),
    [sym__plus_operator] = ACTIONS(13429),
    [sym__times_operator] = ACTIONS(13429),
    [sym__rational_operator] = ACTIONS(13431),
    [sym__bitshift_operator] = ACTIONS(13431),
    [sym__power_operator] = ACTIONS(13431),
    [sym__tilde_operator] = ACTIONS(13431),
    [sym__type_order_operator] = ACTIONS(13431),
    [sym__unary_operator] = ACTIONS(13429),
    [sym__unary_plus_operator] = ACTIONS(13429),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13431),
    [sym__command_start] = ACTIONS(13431),
  },
  [8692] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_end] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_finally] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [8693] = {
    [sym__word_identifier] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(12618),
    [anon_sym_COMMA] = ACTIONS(12618),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_begin] = ACTIONS(12618),
    [anon_sym_module] = ACTIONS(12618),
    [anon_sym_baremodule] = ACTIONS(12618),
    [anon_sym_end] = ACTIONS(12618),
    [anon_sym_abstract] = ACTIONS(12618),
    [anon_sym_primitive] = ACTIONS(12618),
    [anon_sym_mutable] = ACTIONS(12618),
    [anon_sym_struct] = ACTIONS(12618),
    [anon_sym_function] = ACTIONS(12618),
    [anon_sym_macro] = ACTIONS(12618),
    [anon_sym_where] = ACTIONS(12618),
    [anon_sym_quote] = ACTIONS(12618),
    [anon_sym_let] = ACTIONS(12618),
    [anon_sym_if] = ACTIONS(12618),
    [anon_sym_try] = ACTIONS(12618),
    [anon_sym_for] = ACTIONS(12618),
    [anon_sym_while] = ACTIONS(12618),
    [sym_break_statement] = ACTIONS(12618),
    [sym_continue_statement] = ACTIONS(12618),
    [anon_sym_return] = ACTIONS(12618),
    [anon_sym_const] = ACTIONS(12618),
    [anon_sym_global] = ACTIONS(12618),
    [anon_sym_local] = ACTIONS(12618),
    [anon_sym_LPAREN] = ACTIONS(12618),
    [anon_sym_COLON2] = ACTIONS(12618),
    [anon_sym_export] = ACTIONS(12618),
    [anon_sym_import] = ACTIONS(12618),
    [anon_sym_using] = ACTIONS(12618),
    [anon_sym_LBRACK] = ACTIONS(12618),
    [anon_sym_LF] = ACTIONS(12620),
    [anon_sym_in] = ACTIONS(12618),
    [anon_sym_LBRACE] = ACTIONS(12618),
    [anon_sym_DOT] = ACTIONS(12618),
    [anon_sym_DOLLAR] = ACTIONS(12618),
    [anon_sym_COLON_COLON] = ACTIONS(12618),
    [anon_sym_isa] = ACTIONS(12618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12618),
    [anon_sym_QMARK] = ACTIONS(12618),
    [anon_sym_AT] = ACTIONS(12618),
    [anon_sym_true] = ACTIONS(12618),
    [anon_sym_false] = ACTIONS(12618),
    [aux_sym_integer_literal_token1] = ACTIONS(12618),
    [aux_sym_integer_literal_token2] = ACTIONS(12618),
    [aux_sym_integer_literal_token3] = ACTIONS(12618),
    [aux_sym_integer_literal_token4] = ACTIONS(12618),
    [aux_sym_float_literal_token1] = ACTIONS(12618),
    [aux_sym_float_literal_token3] = ACTIONS(12618),
    [aux_sym_float_literal_token4] = ACTIONS(12618),
    [sym_character_literal] = ACTIONS(12618),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12618),
    [sym__lazy_or_operator] = ACTIONS(12618),
    [sym__lazy_and_operator] = ACTIONS(12618),
    [sym__comparison_operator] = ACTIONS(12618),
    [sym__pipe_right_operator] = ACTIONS(12618),
    [sym__pipe_left_operator] = ACTIONS(12618),
    [sym__ellipsis_operator] = ACTIONS(12618),
    [sym__plus_operator] = ACTIONS(12618),
    [sym__times_operator] = ACTIONS(12618),
    [sym__rational_operator] = ACTIONS(12618),
    [sym__bitshift_operator] = ACTIONS(12618),
    [sym__power_operator] = ACTIONS(12618),
    [sym__tilde_operator] = ACTIONS(12618),
    [sym__type_order_operator] = ACTIONS(12618),
    [sym__unary_operator] = ACTIONS(12618),
    [sym__unary_plus_operator] = ACTIONS(12618),
    [aux_sym__terminator_token1] = ACTIONS(12618),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12620),
    [sym__command_start] = ACTIONS(12620),
  },
  [8694] = {
    [sym__word_identifier] = ACTIONS(13433),
    [anon_sym_EQ] = ACTIONS(13433),
    [anon_sym_COMMA] = ACTIONS(13435),
    [anon_sym_COLON] = ACTIONS(13433),
    [anon_sym_begin] = ACTIONS(13433),
    [anon_sym_module] = ACTIONS(13433),
    [anon_sym_baremodule] = ACTIONS(13433),
    [anon_sym_abstract] = ACTIONS(13433),
    [anon_sym_primitive] = ACTIONS(13433),
    [anon_sym_mutable] = ACTIONS(13433),
    [anon_sym_struct] = ACTIONS(13433),
    [anon_sym_function] = ACTIONS(13433),
    [anon_sym_macro] = ACTIONS(13433),
    [anon_sym_where] = ACTIONS(13433),
    [anon_sym_quote] = ACTIONS(13433),
    [anon_sym_let] = ACTIONS(13433),
    [anon_sym_if] = ACTIONS(13433),
    [anon_sym_try] = ACTIONS(13433),
    [anon_sym_for] = ACTIONS(13433),
    [anon_sym_while] = ACTIONS(13433),
    [sym_break_statement] = ACTIONS(13433),
    [sym_continue_statement] = ACTIONS(13433),
    [anon_sym_return] = ACTIONS(13433),
    [anon_sym_const] = ACTIONS(13433),
    [anon_sym_global] = ACTIONS(13433),
    [anon_sym_local] = ACTIONS(13433),
    [anon_sym_LPAREN] = ACTIONS(13435),
    [anon_sym_RPAREN] = ACTIONS(13435),
    [anon_sym_COLON2] = ACTIONS(13433),
    [anon_sym_export] = ACTIONS(13433),
    [anon_sym_import] = ACTIONS(13433),
    [anon_sym_using] = ACTIONS(13433),
    [anon_sym_LBRACK] = ACTIONS(13435),
    [anon_sym_RBRACK] = ACTIONS(13435),
    [anon_sym_in] = ACTIONS(13433),
    [anon_sym_SEMI] = ACTIONS(13435),
    [anon_sym_LBRACE] = ACTIONS(13435),
    [anon_sym_RBRACE] = ACTIONS(13435),
    [anon_sym_DOLLAR] = ACTIONS(13435),
    [anon_sym_COLON_COLON] = ACTIONS(13435),
    [anon_sym_isa] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13435),
    [anon_sym_QMARK] = ACTIONS(13435),
    [anon_sym_AT] = ACTIONS(13435),
    [anon_sym_true] = ACTIONS(13433),
    [anon_sym_false] = ACTIONS(13433),
    [aux_sym_integer_literal_token1] = ACTIONS(13435),
    [aux_sym_integer_literal_token2] = ACTIONS(13435),
    [aux_sym_integer_literal_token3] = ACTIONS(13433),
    [aux_sym_integer_literal_token4] = ACTIONS(13433),
    [aux_sym_float_literal_token1] = ACTIONS(13435),
    [aux_sym_float_literal_token3] = ACTIONS(13435),
    [aux_sym_float_literal_token4] = ACTIONS(13435),
    [sym_character_literal] = ACTIONS(13435),
    [sym__pair_operator] = ACTIONS(13435),
    [sym__arrow_operator] = ACTIONS(13433),
    [sym__lazy_or_operator] = ACTIONS(13435),
    [sym__lazy_and_operator] = ACTIONS(13435),
    [sym__comparison_operator] = ACTIONS(13433),
    [sym__pipe_right_operator] = ACTIONS(13435),
    [sym__pipe_left_operator] = ACTIONS(13435),
    [sym__ellipsis_operator] = ACTIONS(13433),
    [sym__plus_operator] = ACTIONS(13433),
    [sym__times_operator] = ACTIONS(13433),
    [sym__rational_operator] = ACTIONS(13435),
    [sym__bitshift_operator] = ACTIONS(13435),
    [sym__power_operator] = ACTIONS(13435),
    [sym__tilde_operator] = ACTIONS(13435),
    [sym__type_order_operator] = ACTIONS(13435),
    [sym__unary_operator] = ACTIONS(13433),
    [sym__unary_plus_operator] = ACTIONS(13433),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13435),
    [sym__command_start] = ACTIONS(13435),
  },
  [8695] = {
    [sym__word_identifier] = ACTIONS(13437),
    [anon_sym_EQ] = ACTIONS(13437),
    [anon_sym_COMMA] = ACTIONS(13439),
    [anon_sym_COLON] = ACTIONS(13437),
    [anon_sym_begin] = ACTIONS(13437),
    [anon_sym_module] = ACTIONS(13437),
    [anon_sym_baremodule] = ACTIONS(13437),
    [anon_sym_abstract] = ACTIONS(13437),
    [anon_sym_primitive] = ACTIONS(13437),
    [anon_sym_mutable] = ACTIONS(13437),
    [anon_sym_struct] = ACTIONS(13437),
    [anon_sym_function] = ACTIONS(13437),
    [anon_sym_macro] = ACTIONS(13437),
    [anon_sym_where] = ACTIONS(13437),
    [anon_sym_quote] = ACTIONS(13437),
    [anon_sym_let] = ACTIONS(13437),
    [anon_sym_if] = ACTIONS(13437),
    [anon_sym_try] = ACTIONS(13437),
    [anon_sym_for] = ACTIONS(13437),
    [anon_sym_while] = ACTIONS(13437),
    [sym_break_statement] = ACTIONS(13437),
    [sym_continue_statement] = ACTIONS(13437),
    [anon_sym_return] = ACTIONS(13437),
    [anon_sym_const] = ACTIONS(13437),
    [anon_sym_global] = ACTIONS(13437),
    [anon_sym_local] = ACTIONS(13437),
    [anon_sym_LPAREN] = ACTIONS(13439),
    [anon_sym_RPAREN] = ACTIONS(13439),
    [anon_sym_COLON2] = ACTIONS(13437),
    [anon_sym_export] = ACTIONS(13437),
    [anon_sym_import] = ACTIONS(13437),
    [anon_sym_using] = ACTIONS(13437),
    [anon_sym_LBRACK] = ACTIONS(13439),
    [anon_sym_RBRACK] = ACTIONS(13439),
    [anon_sym_in] = ACTIONS(13437),
    [anon_sym_SEMI] = ACTIONS(13439),
    [anon_sym_LBRACE] = ACTIONS(13439),
    [anon_sym_RBRACE] = ACTIONS(13439),
    [anon_sym_DOLLAR] = ACTIONS(13439),
    [anon_sym_COLON_COLON] = ACTIONS(13439),
    [anon_sym_isa] = ACTIONS(13437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13439),
    [anon_sym_QMARK] = ACTIONS(13439),
    [anon_sym_AT] = ACTIONS(13439),
    [anon_sym_true] = ACTIONS(13437),
    [anon_sym_false] = ACTIONS(13437),
    [aux_sym_integer_literal_token1] = ACTIONS(13439),
    [aux_sym_integer_literal_token2] = ACTIONS(13439),
    [aux_sym_integer_literal_token3] = ACTIONS(13437),
    [aux_sym_integer_literal_token4] = ACTIONS(13437),
    [aux_sym_float_literal_token1] = ACTIONS(13439),
    [aux_sym_float_literal_token3] = ACTIONS(13439),
    [aux_sym_float_literal_token4] = ACTIONS(13439),
    [sym_character_literal] = ACTIONS(13439),
    [sym__pair_operator] = ACTIONS(13439),
    [sym__arrow_operator] = ACTIONS(13437),
    [sym__lazy_or_operator] = ACTIONS(13439),
    [sym__lazy_and_operator] = ACTIONS(13439),
    [sym__comparison_operator] = ACTIONS(13437),
    [sym__pipe_right_operator] = ACTIONS(13439),
    [sym__pipe_left_operator] = ACTIONS(13439),
    [sym__ellipsis_operator] = ACTIONS(13437),
    [sym__plus_operator] = ACTIONS(13437),
    [sym__times_operator] = ACTIONS(13437),
    [sym__rational_operator] = ACTIONS(13439),
    [sym__bitshift_operator] = ACTIONS(13439),
    [sym__power_operator] = ACTIONS(13439),
    [sym__tilde_operator] = ACTIONS(13439),
    [sym__type_order_operator] = ACTIONS(13439),
    [sym__unary_operator] = ACTIONS(13437),
    [sym__unary_plus_operator] = ACTIONS(13437),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13439),
    [sym__command_start] = ACTIONS(13439),
  },
  [8696] = {
    [sym__word_identifier] = ACTIONS(13441),
    [anon_sym_EQ] = ACTIONS(13441),
    [anon_sym_COMMA] = ACTIONS(13443),
    [anon_sym_COLON] = ACTIONS(13441),
    [anon_sym_begin] = ACTIONS(13441),
    [anon_sym_module] = ACTIONS(13441),
    [anon_sym_baremodule] = ACTIONS(13441),
    [anon_sym_abstract] = ACTIONS(13441),
    [anon_sym_primitive] = ACTIONS(13441),
    [anon_sym_mutable] = ACTIONS(13441),
    [anon_sym_struct] = ACTIONS(13441),
    [anon_sym_function] = ACTIONS(13441),
    [anon_sym_macro] = ACTIONS(13441),
    [anon_sym_where] = ACTIONS(13441),
    [anon_sym_quote] = ACTIONS(13441),
    [anon_sym_let] = ACTIONS(13441),
    [anon_sym_if] = ACTIONS(13441),
    [anon_sym_try] = ACTIONS(13441),
    [anon_sym_for] = ACTIONS(13441),
    [anon_sym_while] = ACTIONS(13441),
    [sym_break_statement] = ACTIONS(13441),
    [sym_continue_statement] = ACTIONS(13441),
    [anon_sym_return] = ACTIONS(13441),
    [anon_sym_const] = ACTIONS(13441),
    [anon_sym_global] = ACTIONS(13441),
    [anon_sym_local] = ACTIONS(13441),
    [anon_sym_LPAREN] = ACTIONS(13443),
    [anon_sym_RPAREN] = ACTIONS(13443),
    [anon_sym_COLON2] = ACTIONS(13441),
    [anon_sym_export] = ACTIONS(13441),
    [anon_sym_import] = ACTIONS(13441),
    [anon_sym_using] = ACTIONS(13441),
    [anon_sym_LBRACK] = ACTIONS(13443),
    [anon_sym_RBRACK] = ACTIONS(13443),
    [anon_sym_in] = ACTIONS(13441),
    [anon_sym_SEMI] = ACTIONS(13443),
    [anon_sym_LBRACE] = ACTIONS(13443),
    [anon_sym_RBRACE] = ACTIONS(13443),
    [anon_sym_DOLLAR] = ACTIONS(13443),
    [anon_sym_COLON_COLON] = ACTIONS(13443),
    [anon_sym_isa] = ACTIONS(13441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13443),
    [anon_sym_QMARK] = ACTIONS(13443),
    [anon_sym_AT] = ACTIONS(13443),
    [anon_sym_true] = ACTIONS(13441),
    [anon_sym_false] = ACTIONS(13441),
    [aux_sym_integer_literal_token1] = ACTIONS(13443),
    [aux_sym_integer_literal_token2] = ACTIONS(13443),
    [aux_sym_integer_literal_token3] = ACTIONS(13441),
    [aux_sym_integer_literal_token4] = ACTIONS(13441),
    [aux_sym_float_literal_token1] = ACTIONS(13443),
    [aux_sym_float_literal_token3] = ACTIONS(13443),
    [aux_sym_float_literal_token4] = ACTIONS(13443),
    [sym_character_literal] = ACTIONS(13443),
    [sym__pair_operator] = ACTIONS(13443),
    [sym__arrow_operator] = ACTIONS(13441),
    [sym__lazy_or_operator] = ACTIONS(13443),
    [sym__lazy_and_operator] = ACTIONS(13443),
    [sym__comparison_operator] = ACTIONS(13441),
    [sym__pipe_right_operator] = ACTIONS(13443),
    [sym__pipe_left_operator] = ACTIONS(13443),
    [sym__ellipsis_operator] = ACTIONS(13441),
    [sym__plus_operator] = ACTIONS(13441),
    [sym__times_operator] = ACTIONS(13441),
    [sym__rational_operator] = ACTIONS(13443),
    [sym__bitshift_operator] = ACTIONS(13443),
    [sym__power_operator] = ACTIONS(13443),
    [sym__tilde_operator] = ACTIONS(13443),
    [sym__type_order_operator] = ACTIONS(13443),
    [sym__unary_operator] = ACTIONS(13441),
    [sym__unary_plus_operator] = ACTIONS(13441),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13443),
    [sym__command_start] = ACTIONS(13443),
  },
  [8697] = {
    [sym__word_identifier] = ACTIONS(13445),
    [anon_sym_EQ] = ACTIONS(13445),
    [anon_sym_COMMA] = ACTIONS(13447),
    [anon_sym_COLON] = ACTIONS(13445),
    [anon_sym_begin] = ACTIONS(13445),
    [anon_sym_module] = ACTIONS(13445),
    [anon_sym_baremodule] = ACTIONS(13445),
    [anon_sym_abstract] = ACTIONS(13445),
    [anon_sym_primitive] = ACTIONS(13445),
    [anon_sym_mutable] = ACTIONS(13445),
    [anon_sym_struct] = ACTIONS(13445),
    [anon_sym_function] = ACTIONS(13445),
    [anon_sym_macro] = ACTIONS(13445),
    [anon_sym_where] = ACTIONS(13445),
    [anon_sym_quote] = ACTIONS(13445),
    [anon_sym_let] = ACTIONS(13445),
    [anon_sym_if] = ACTIONS(13445),
    [anon_sym_try] = ACTIONS(13445),
    [anon_sym_for] = ACTIONS(13445),
    [anon_sym_while] = ACTIONS(13445),
    [sym_break_statement] = ACTIONS(13445),
    [sym_continue_statement] = ACTIONS(13445),
    [anon_sym_return] = ACTIONS(13445),
    [anon_sym_const] = ACTIONS(13445),
    [anon_sym_global] = ACTIONS(13445),
    [anon_sym_local] = ACTIONS(13445),
    [anon_sym_LPAREN] = ACTIONS(13447),
    [anon_sym_RPAREN] = ACTIONS(13447),
    [anon_sym_COLON2] = ACTIONS(13445),
    [anon_sym_export] = ACTIONS(13445),
    [anon_sym_import] = ACTIONS(13445),
    [anon_sym_using] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(13447),
    [anon_sym_RBRACK] = ACTIONS(13447),
    [anon_sym_in] = ACTIONS(13445),
    [anon_sym_SEMI] = ACTIONS(13447),
    [anon_sym_LBRACE] = ACTIONS(13447),
    [anon_sym_RBRACE] = ACTIONS(13447),
    [anon_sym_DOLLAR] = ACTIONS(13447),
    [anon_sym_COLON_COLON] = ACTIONS(13447),
    [anon_sym_isa] = ACTIONS(13445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13447),
    [anon_sym_QMARK] = ACTIONS(13447),
    [anon_sym_AT] = ACTIONS(13447),
    [anon_sym_true] = ACTIONS(13445),
    [anon_sym_false] = ACTIONS(13445),
    [aux_sym_integer_literal_token1] = ACTIONS(13447),
    [aux_sym_integer_literal_token2] = ACTIONS(13447),
    [aux_sym_integer_literal_token3] = ACTIONS(13445),
    [aux_sym_integer_literal_token4] = ACTIONS(13445),
    [aux_sym_float_literal_token1] = ACTIONS(13447),
    [aux_sym_float_literal_token3] = ACTIONS(13447),
    [aux_sym_float_literal_token4] = ACTIONS(13447),
    [sym_character_literal] = ACTIONS(13447),
    [sym__pair_operator] = ACTIONS(13447),
    [sym__arrow_operator] = ACTIONS(13445),
    [sym__lazy_or_operator] = ACTIONS(13447),
    [sym__lazy_and_operator] = ACTIONS(13447),
    [sym__comparison_operator] = ACTIONS(13445),
    [sym__pipe_right_operator] = ACTIONS(13447),
    [sym__pipe_left_operator] = ACTIONS(13447),
    [sym__ellipsis_operator] = ACTIONS(13445),
    [sym__plus_operator] = ACTIONS(13445),
    [sym__times_operator] = ACTIONS(13445),
    [sym__rational_operator] = ACTIONS(13447),
    [sym__bitshift_operator] = ACTIONS(13447),
    [sym__power_operator] = ACTIONS(13447),
    [sym__tilde_operator] = ACTIONS(13447),
    [sym__type_order_operator] = ACTIONS(13447),
    [sym__unary_operator] = ACTIONS(13445),
    [sym__unary_plus_operator] = ACTIONS(13445),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13447),
    [sym__command_start] = ACTIONS(13447),
  },
  [8698] = {
    [sym__word_identifier] = ACTIONS(13449),
    [anon_sym_EQ] = ACTIONS(13449),
    [anon_sym_COMMA] = ACTIONS(13451),
    [anon_sym_COLON] = ACTIONS(13449),
    [anon_sym_begin] = ACTIONS(13449),
    [anon_sym_module] = ACTIONS(13449),
    [anon_sym_baremodule] = ACTIONS(13449),
    [anon_sym_abstract] = ACTIONS(13449),
    [anon_sym_primitive] = ACTIONS(13449),
    [anon_sym_mutable] = ACTIONS(13449),
    [anon_sym_struct] = ACTIONS(13449),
    [anon_sym_function] = ACTIONS(13449),
    [anon_sym_macro] = ACTIONS(13449),
    [anon_sym_where] = ACTIONS(13449),
    [anon_sym_quote] = ACTIONS(13449),
    [anon_sym_let] = ACTIONS(13449),
    [anon_sym_if] = ACTIONS(13449),
    [anon_sym_try] = ACTIONS(13449),
    [anon_sym_for] = ACTIONS(13449),
    [anon_sym_while] = ACTIONS(13449),
    [sym_break_statement] = ACTIONS(13449),
    [sym_continue_statement] = ACTIONS(13449),
    [anon_sym_return] = ACTIONS(13449),
    [anon_sym_const] = ACTIONS(13449),
    [anon_sym_global] = ACTIONS(13449),
    [anon_sym_local] = ACTIONS(13449),
    [anon_sym_LPAREN] = ACTIONS(13451),
    [anon_sym_RPAREN] = ACTIONS(13451),
    [anon_sym_COLON2] = ACTIONS(13449),
    [anon_sym_export] = ACTIONS(13449),
    [anon_sym_import] = ACTIONS(13449),
    [anon_sym_using] = ACTIONS(13449),
    [anon_sym_LBRACK] = ACTIONS(13451),
    [anon_sym_RBRACK] = ACTIONS(13451),
    [anon_sym_in] = ACTIONS(13449),
    [anon_sym_SEMI] = ACTIONS(13451),
    [anon_sym_LBRACE] = ACTIONS(13451),
    [anon_sym_RBRACE] = ACTIONS(13451),
    [anon_sym_DOLLAR] = ACTIONS(13451),
    [anon_sym_COLON_COLON] = ACTIONS(13451),
    [anon_sym_isa] = ACTIONS(13449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13451),
    [anon_sym_QMARK] = ACTIONS(13451),
    [anon_sym_AT] = ACTIONS(13451),
    [anon_sym_true] = ACTIONS(13449),
    [anon_sym_false] = ACTIONS(13449),
    [aux_sym_integer_literal_token1] = ACTIONS(13451),
    [aux_sym_integer_literal_token2] = ACTIONS(13451),
    [aux_sym_integer_literal_token3] = ACTIONS(13449),
    [aux_sym_integer_literal_token4] = ACTIONS(13449),
    [aux_sym_float_literal_token1] = ACTIONS(13451),
    [aux_sym_float_literal_token3] = ACTIONS(13451),
    [aux_sym_float_literal_token4] = ACTIONS(13451),
    [sym_character_literal] = ACTIONS(13451),
    [sym__pair_operator] = ACTIONS(13451),
    [sym__arrow_operator] = ACTIONS(13449),
    [sym__lazy_or_operator] = ACTIONS(13451),
    [sym__lazy_and_operator] = ACTIONS(13451),
    [sym__comparison_operator] = ACTIONS(13449),
    [sym__pipe_right_operator] = ACTIONS(13451),
    [sym__pipe_left_operator] = ACTIONS(13451),
    [sym__ellipsis_operator] = ACTIONS(13449),
    [sym__plus_operator] = ACTIONS(13449),
    [sym__times_operator] = ACTIONS(13449),
    [sym__rational_operator] = ACTIONS(13451),
    [sym__bitshift_operator] = ACTIONS(13451),
    [sym__power_operator] = ACTIONS(13451),
    [sym__tilde_operator] = ACTIONS(13451),
    [sym__type_order_operator] = ACTIONS(13451),
    [sym__unary_operator] = ACTIONS(13449),
    [sym__unary_plus_operator] = ACTIONS(13449),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13451),
    [sym__command_start] = ACTIONS(13451),
  },
  [8699] = {
    [sym__word_identifier] = ACTIONS(13453),
    [anon_sym_EQ] = ACTIONS(13453),
    [anon_sym_COMMA] = ACTIONS(13455),
    [anon_sym_COLON] = ACTIONS(13453),
    [anon_sym_begin] = ACTIONS(13453),
    [anon_sym_module] = ACTIONS(13453),
    [anon_sym_baremodule] = ACTIONS(13453),
    [anon_sym_abstract] = ACTIONS(13453),
    [anon_sym_primitive] = ACTIONS(13453),
    [anon_sym_mutable] = ACTIONS(13453),
    [anon_sym_struct] = ACTIONS(13453),
    [anon_sym_function] = ACTIONS(13453),
    [anon_sym_macro] = ACTIONS(13453),
    [anon_sym_where] = ACTIONS(13453),
    [anon_sym_quote] = ACTIONS(13453),
    [anon_sym_let] = ACTIONS(13453),
    [anon_sym_if] = ACTIONS(13453),
    [anon_sym_try] = ACTIONS(13453),
    [anon_sym_for] = ACTIONS(13453),
    [anon_sym_while] = ACTIONS(13453),
    [sym_break_statement] = ACTIONS(13453),
    [sym_continue_statement] = ACTIONS(13453),
    [anon_sym_return] = ACTIONS(13453),
    [anon_sym_const] = ACTIONS(13453),
    [anon_sym_global] = ACTIONS(13453),
    [anon_sym_local] = ACTIONS(13453),
    [anon_sym_LPAREN] = ACTIONS(13455),
    [anon_sym_RPAREN] = ACTIONS(13455),
    [anon_sym_COLON2] = ACTIONS(13453),
    [anon_sym_export] = ACTIONS(13453),
    [anon_sym_import] = ACTIONS(13453),
    [anon_sym_using] = ACTIONS(13453),
    [anon_sym_LBRACK] = ACTIONS(13455),
    [anon_sym_RBRACK] = ACTIONS(13455),
    [anon_sym_in] = ACTIONS(13453),
    [anon_sym_SEMI] = ACTIONS(13455),
    [anon_sym_LBRACE] = ACTIONS(13455),
    [anon_sym_RBRACE] = ACTIONS(13455),
    [anon_sym_DOLLAR] = ACTIONS(13455),
    [anon_sym_COLON_COLON] = ACTIONS(13455),
    [anon_sym_isa] = ACTIONS(13453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13455),
    [anon_sym_QMARK] = ACTIONS(13455),
    [anon_sym_AT] = ACTIONS(13455),
    [anon_sym_true] = ACTIONS(13453),
    [anon_sym_false] = ACTIONS(13453),
    [aux_sym_integer_literal_token1] = ACTIONS(13455),
    [aux_sym_integer_literal_token2] = ACTIONS(13455),
    [aux_sym_integer_literal_token3] = ACTIONS(13453),
    [aux_sym_integer_literal_token4] = ACTIONS(13453),
    [aux_sym_float_literal_token1] = ACTIONS(13455),
    [aux_sym_float_literal_token3] = ACTIONS(13455),
    [aux_sym_float_literal_token4] = ACTIONS(13455),
    [sym_character_literal] = ACTIONS(13455),
    [sym__pair_operator] = ACTIONS(13455),
    [sym__arrow_operator] = ACTIONS(13453),
    [sym__lazy_or_operator] = ACTIONS(13455),
    [sym__lazy_and_operator] = ACTIONS(13455),
    [sym__comparison_operator] = ACTIONS(13453),
    [sym__pipe_right_operator] = ACTIONS(13455),
    [sym__pipe_left_operator] = ACTIONS(13455),
    [sym__ellipsis_operator] = ACTIONS(13453),
    [sym__plus_operator] = ACTIONS(13453),
    [sym__times_operator] = ACTIONS(13453),
    [sym__rational_operator] = ACTIONS(13455),
    [sym__bitshift_operator] = ACTIONS(13455),
    [sym__power_operator] = ACTIONS(13455),
    [sym__tilde_operator] = ACTIONS(13455),
    [sym__type_order_operator] = ACTIONS(13455),
    [sym__unary_operator] = ACTIONS(13453),
    [sym__unary_plus_operator] = ACTIONS(13453),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13455),
    [sym__command_start] = ACTIONS(13455),
  },
  [8700] = {
    [sym__word_identifier] = ACTIONS(13457),
    [anon_sym_EQ] = ACTIONS(13457),
    [anon_sym_COMMA] = ACTIONS(13459),
    [anon_sym_COLON] = ACTIONS(13457),
    [anon_sym_begin] = ACTIONS(13457),
    [anon_sym_module] = ACTIONS(13457),
    [anon_sym_baremodule] = ACTIONS(13457),
    [anon_sym_abstract] = ACTIONS(13457),
    [anon_sym_primitive] = ACTIONS(13457),
    [anon_sym_mutable] = ACTIONS(13457),
    [anon_sym_struct] = ACTIONS(13457),
    [anon_sym_function] = ACTIONS(13457),
    [anon_sym_macro] = ACTIONS(13457),
    [anon_sym_where] = ACTIONS(13457),
    [anon_sym_quote] = ACTIONS(13457),
    [anon_sym_let] = ACTIONS(13457),
    [anon_sym_if] = ACTIONS(13457),
    [anon_sym_try] = ACTIONS(13457),
    [anon_sym_for] = ACTIONS(13457),
    [anon_sym_while] = ACTIONS(13457),
    [sym_break_statement] = ACTIONS(13457),
    [sym_continue_statement] = ACTIONS(13457),
    [anon_sym_return] = ACTIONS(13457),
    [anon_sym_const] = ACTIONS(13457),
    [anon_sym_global] = ACTIONS(13457),
    [anon_sym_local] = ACTIONS(13457),
    [anon_sym_LPAREN] = ACTIONS(13459),
    [anon_sym_RPAREN] = ACTIONS(13459),
    [anon_sym_COLON2] = ACTIONS(13457),
    [anon_sym_export] = ACTIONS(13457),
    [anon_sym_import] = ACTIONS(13457),
    [anon_sym_using] = ACTIONS(13457),
    [anon_sym_LBRACK] = ACTIONS(13459),
    [anon_sym_RBRACK] = ACTIONS(13459),
    [anon_sym_in] = ACTIONS(13457),
    [anon_sym_SEMI] = ACTIONS(13459),
    [anon_sym_LBRACE] = ACTIONS(13459),
    [anon_sym_RBRACE] = ACTIONS(13459),
    [anon_sym_DOLLAR] = ACTIONS(13459),
    [anon_sym_COLON_COLON] = ACTIONS(13459),
    [anon_sym_isa] = ACTIONS(13457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13459),
    [anon_sym_QMARK] = ACTIONS(13459),
    [anon_sym_AT] = ACTIONS(13459),
    [anon_sym_true] = ACTIONS(13457),
    [anon_sym_false] = ACTIONS(13457),
    [aux_sym_integer_literal_token1] = ACTIONS(13459),
    [aux_sym_integer_literal_token2] = ACTIONS(13459),
    [aux_sym_integer_literal_token3] = ACTIONS(13457),
    [aux_sym_integer_literal_token4] = ACTIONS(13457),
    [aux_sym_float_literal_token1] = ACTIONS(13459),
    [aux_sym_float_literal_token3] = ACTIONS(13459),
    [aux_sym_float_literal_token4] = ACTIONS(13459),
    [sym_character_literal] = ACTIONS(13459),
    [sym__pair_operator] = ACTIONS(13459),
    [sym__arrow_operator] = ACTIONS(13457),
    [sym__lazy_or_operator] = ACTIONS(13459),
    [sym__lazy_and_operator] = ACTIONS(13459),
    [sym__comparison_operator] = ACTIONS(13457),
    [sym__pipe_right_operator] = ACTIONS(13459),
    [sym__pipe_left_operator] = ACTIONS(13459),
    [sym__ellipsis_operator] = ACTIONS(13457),
    [sym__plus_operator] = ACTIONS(13457),
    [sym__times_operator] = ACTIONS(13457),
    [sym__rational_operator] = ACTIONS(13459),
    [sym__bitshift_operator] = ACTIONS(13459),
    [sym__power_operator] = ACTIONS(13459),
    [sym__tilde_operator] = ACTIONS(13459),
    [sym__type_order_operator] = ACTIONS(13459),
    [sym__unary_operator] = ACTIONS(13457),
    [sym__unary_plus_operator] = ACTIONS(13457),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13459),
    [sym__command_start] = ACTIONS(13459),
  },
  [8701] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8702] = {
    [sym__word_identifier] = ACTIONS(13461),
    [anon_sym_EQ] = ACTIONS(13461),
    [anon_sym_COMMA] = ACTIONS(13463),
    [anon_sym_COLON] = ACTIONS(13461),
    [anon_sym_begin] = ACTIONS(13461),
    [anon_sym_module] = ACTIONS(13461),
    [anon_sym_baremodule] = ACTIONS(13461),
    [anon_sym_abstract] = ACTIONS(13461),
    [anon_sym_primitive] = ACTIONS(13461),
    [anon_sym_mutable] = ACTIONS(13461),
    [anon_sym_struct] = ACTIONS(13461),
    [anon_sym_function] = ACTIONS(13461),
    [anon_sym_macro] = ACTIONS(13461),
    [anon_sym_where] = ACTIONS(13461),
    [anon_sym_quote] = ACTIONS(13461),
    [anon_sym_let] = ACTIONS(13461),
    [anon_sym_if] = ACTIONS(13461),
    [anon_sym_try] = ACTIONS(13461),
    [anon_sym_for] = ACTIONS(13461),
    [anon_sym_while] = ACTIONS(13461),
    [sym_break_statement] = ACTIONS(13461),
    [sym_continue_statement] = ACTIONS(13461),
    [anon_sym_return] = ACTIONS(13461),
    [anon_sym_const] = ACTIONS(13461),
    [anon_sym_global] = ACTIONS(13461),
    [anon_sym_local] = ACTIONS(13461),
    [anon_sym_LPAREN] = ACTIONS(13463),
    [anon_sym_RPAREN] = ACTIONS(13463),
    [anon_sym_COLON2] = ACTIONS(13461),
    [anon_sym_export] = ACTIONS(13461),
    [anon_sym_import] = ACTIONS(13461),
    [anon_sym_using] = ACTIONS(13461),
    [anon_sym_LBRACK] = ACTIONS(13463),
    [anon_sym_RBRACK] = ACTIONS(13463),
    [anon_sym_in] = ACTIONS(13461),
    [anon_sym_SEMI] = ACTIONS(13463),
    [anon_sym_LBRACE] = ACTIONS(13463),
    [anon_sym_RBRACE] = ACTIONS(13463),
    [anon_sym_DOLLAR] = ACTIONS(13463),
    [anon_sym_COLON_COLON] = ACTIONS(13463),
    [anon_sym_isa] = ACTIONS(13461),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13463),
    [anon_sym_QMARK] = ACTIONS(13463),
    [anon_sym_AT] = ACTIONS(13463),
    [anon_sym_true] = ACTIONS(13461),
    [anon_sym_false] = ACTIONS(13461),
    [aux_sym_integer_literal_token1] = ACTIONS(13463),
    [aux_sym_integer_literal_token2] = ACTIONS(13463),
    [aux_sym_integer_literal_token3] = ACTIONS(13461),
    [aux_sym_integer_literal_token4] = ACTIONS(13461),
    [aux_sym_float_literal_token1] = ACTIONS(13463),
    [aux_sym_float_literal_token3] = ACTIONS(13463),
    [aux_sym_float_literal_token4] = ACTIONS(13463),
    [sym_character_literal] = ACTIONS(13463),
    [sym__pair_operator] = ACTIONS(13463),
    [sym__arrow_operator] = ACTIONS(13461),
    [sym__lazy_or_operator] = ACTIONS(13463),
    [sym__lazy_and_operator] = ACTIONS(13463),
    [sym__comparison_operator] = ACTIONS(13461),
    [sym__pipe_right_operator] = ACTIONS(13463),
    [sym__pipe_left_operator] = ACTIONS(13463),
    [sym__ellipsis_operator] = ACTIONS(13461),
    [sym__plus_operator] = ACTIONS(13461),
    [sym__times_operator] = ACTIONS(13461),
    [sym__rational_operator] = ACTIONS(13463),
    [sym__bitshift_operator] = ACTIONS(13463),
    [sym__power_operator] = ACTIONS(13463),
    [sym__tilde_operator] = ACTIONS(13463),
    [sym__type_order_operator] = ACTIONS(13463),
    [sym__unary_operator] = ACTIONS(13461),
    [sym__unary_plus_operator] = ACTIONS(13461),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13463),
    [sym__command_start] = ACTIONS(13463),
  },
  [8703] = {
    [sym__word_identifier] = ACTIONS(13481),
    [anon_sym_EQ] = ACTIONS(13481),
    [anon_sym_COMMA] = ACTIONS(13483),
    [anon_sym_COLON] = ACTIONS(13481),
    [anon_sym_begin] = ACTIONS(13481),
    [anon_sym_module] = ACTIONS(13481),
    [anon_sym_baremodule] = ACTIONS(13481),
    [anon_sym_abstract] = ACTIONS(13481),
    [anon_sym_primitive] = ACTIONS(13481),
    [anon_sym_mutable] = ACTIONS(13481),
    [anon_sym_struct] = ACTIONS(13481),
    [anon_sym_function] = ACTIONS(13481),
    [anon_sym_macro] = ACTIONS(13481),
    [anon_sym_where] = ACTIONS(13481),
    [anon_sym_quote] = ACTIONS(13481),
    [anon_sym_let] = ACTIONS(13481),
    [anon_sym_if] = ACTIONS(13481),
    [anon_sym_try] = ACTIONS(13481),
    [anon_sym_for] = ACTIONS(13481),
    [anon_sym_while] = ACTIONS(13481),
    [sym_break_statement] = ACTIONS(13481),
    [sym_continue_statement] = ACTIONS(13481),
    [anon_sym_return] = ACTIONS(13481),
    [anon_sym_const] = ACTIONS(13481),
    [anon_sym_global] = ACTIONS(13481),
    [anon_sym_local] = ACTIONS(13481),
    [anon_sym_LPAREN] = ACTIONS(13483),
    [anon_sym_RPAREN] = ACTIONS(13483),
    [anon_sym_COLON2] = ACTIONS(13481),
    [anon_sym_export] = ACTIONS(13481),
    [anon_sym_import] = ACTIONS(13481),
    [anon_sym_using] = ACTIONS(13481),
    [anon_sym_LBRACK] = ACTIONS(13483),
    [anon_sym_RBRACK] = ACTIONS(13483),
    [anon_sym_in] = ACTIONS(13481),
    [anon_sym_SEMI] = ACTIONS(13483),
    [anon_sym_LBRACE] = ACTIONS(13483),
    [anon_sym_RBRACE] = ACTIONS(13483),
    [anon_sym_DOLLAR] = ACTIONS(13483),
    [anon_sym_COLON_COLON] = ACTIONS(13483),
    [anon_sym_isa] = ACTIONS(13481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13483),
    [anon_sym_QMARK] = ACTIONS(13483),
    [anon_sym_AT] = ACTIONS(13483),
    [anon_sym_true] = ACTIONS(13481),
    [anon_sym_false] = ACTIONS(13481),
    [aux_sym_integer_literal_token1] = ACTIONS(13483),
    [aux_sym_integer_literal_token2] = ACTIONS(13483),
    [aux_sym_integer_literal_token3] = ACTIONS(13481),
    [aux_sym_integer_literal_token4] = ACTIONS(13481),
    [aux_sym_float_literal_token1] = ACTIONS(13483),
    [aux_sym_float_literal_token3] = ACTIONS(13483),
    [aux_sym_float_literal_token4] = ACTIONS(13483),
    [sym_character_literal] = ACTIONS(13483),
    [sym__pair_operator] = ACTIONS(13483),
    [sym__arrow_operator] = ACTIONS(13481),
    [sym__lazy_or_operator] = ACTIONS(13483),
    [sym__lazy_and_operator] = ACTIONS(13483),
    [sym__comparison_operator] = ACTIONS(13481),
    [sym__pipe_right_operator] = ACTIONS(13483),
    [sym__pipe_left_operator] = ACTIONS(13483),
    [sym__ellipsis_operator] = ACTIONS(13481),
    [sym__plus_operator] = ACTIONS(13481),
    [sym__times_operator] = ACTIONS(13481),
    [sym__rational_operator] = ACTIONS(13483),
    [sym__bitshift_operator] = ACTIONS(13483),
    [sym__power_operator] = ACTIONS(13483),
    [sym__tilde_operator] = ACTIONS(13483),
    [sym__type_order_operator] = ACTIONS(13483),
    [sym__unary_operator] = ACTIONS(13481),
    [sym__unary_plus_operator] = ACTIONS(13481),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13483),
    [sym__command_start] = ACTIONS(13483),
  },
  [8704] = {
    [sym__word_identifier] = ACTIONS(13485),
    [anon_sym_EQ] = ACTIONS(13485),
    [anon_sym_COMMA] = ACTIONS(13487),
    [anon_sym_COLON] = ACTIONS(13485),
    [anon_sym_begin] = ACTIONS(13485),
    [anon_sym_module] = ACTIONS(13485),
    [anon_sym_baremodule] = ACTIONS(13485),
    [anon_sym_abstract] = ACTIONS(13485),
    [anon_sym_primitive] = ACTIONS(13485),
    [anon_sym_mutable] = ACTIONS(13485),
    [anon_sym_struct] = ACTIONS(13485),
    [anon_sym_function] = ACTIONS(13485),
    [anon_sym_macro] = ACTIONS(13485),
    [anon_sym_where] = ACTIONS(13485),
    [anon_sym_quote] = ACTIONS(13485),
    [anon_sym_let] = ACTIONS(13485),
    [anon_sym_if] = ACTIONS(13485),
    [anon_sym_try] = ACTIONS(13485),
    [anon_sym_for] = ACTIONS(13485),
    [anon_sym_while] = ACTIONS(13485),
    [sym_break_statement] = ACTIONS(13485),
    [sym_continue_statement] = ACTIONS(13485),
    [anon_sym_return] = ACTIONS(13485),
    [anon_sym_const] = ACTIONS(13485),
    [anon_sym_global] = ACTIONS(13485),
    [anon_sym_local] = ACTIONS(13485),
    [anon_sym_LPAREN] = ACTIONS(13487),
    [anon_sym_RPAREN] = ACTIONS(13487),
    [anon_sym_COLON2] = ACTIONS(13485),
    [anon_sym_export] = ACTIONS(13485),
    [anon_sym_import] = ACTIONS(13485),
    [anon_sym_using] = ACTIONS(13485),
    [anon_sym_LBRACK] = ACTIONS(13487),
    [anon_sym_RBRACK] = ACTIONS(13487),
    [anon_sym_in] = ACTIONS(13485),
    [anon_sym_SEMI] = ACTIONS(13487),
    [anon_sym_LBRACE] = ACTIONS(13487),
    [anon_sym_RBRACE] = ACTIONS(13487),
    [anon_sym_DOLLAR] = ACTIONS(13487),
    [anon_sym_COLON_COLON] = ACTIONS(13487),
    [anon_sym_isa] = ACTIONS(13485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13487),
    [anon_sym_QMARK] = ACTIONS(13487),
    [anon_sym_AT] = ACTIONS(13487),
    [anon_sym_true] = ACTIONS(13485),
    [anon_sym_false] = ACTIONS(13485),
    [aux_sym_integer_literal_token1] = ACTIONS(13487),
    [aux_sym_integer_literal_token2] = ACTIONS(13487),
    [aux_sym_integer_literal_token3] = ACTIONS(13485),
    [aux_sym_integer_literal_token4] = ACTIONS(13485),
    [aux_sym_float_literal_token1] = ACTIONS(13487),
    [aux_sym_float_literal_token3] = ACTIONS(13487),
    [aux_sym_float_literal_token4] = ACTIONS(13487),
    [sym_character_literal] = ACTIONS(13487),
    [sym__pair_operator] = ACTIONS(13487),
    [sym__arrow_operator] = ACTIONS(13485),
    [sym__lazy_or_operator] = ACTIONS(13487),
    [sym__lazy_and_operator] = ACTIONS(13487),
    [sym__comparison_operator] = ACTIONS(13485),
    [sym__pipe_right_operator] = ACTIONS(13487),
    [sym__pipe_left_operator] = ACTIONS(13487),
    [sym__ellipsis_operator] = ACTIONS(13485),
    [sym__plus_operator] = ACTIONS(13485),
    [sym__times_operator] = ACTIONS(13485),
    [sym__rational_operator] = ACTIONS(13487),
    [sym__bitshift_operator] = ACTIONS(13487),
    [sym__power_operator] = ACTIONS(13487),
    [sym__tilde_operator] = ACTIONS(13487),
    [sym__type_order_operator] = ACTIONS(13487),
    [sym__unary_operator] = ACTIONS(13485),
    [sym__unary_plus_operator] = ACTIONS(13485),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13487),
    [sym__command_start] = ACTIONS(13487),
  },
  [8705] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(12562),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_catch] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8706] = {
    [aux_sym_open_tuple_repeat1] = STATE(7471),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13497),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_finally] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8707] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_end] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_as] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [8708] = {
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(12972),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12972),
    [anon_sym_RPAREN] = ACTIONS(12972),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12972),
    [anon_sym_RBRACK] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_SEMI] = ACTIONS(12972),
    [anon_sym_LBRACE] = ACTIONS(12972),
    [anon_sym_RBRACE] = ACTIONS(12972),
    [anon_sym_DOLLAR] = ACTIONS(12972),
    [anon_sym_COLON_COLON] = ACTIONS(12972),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12972),
    [anon_sym_QMARK] = ACTIONS(12972),
    [anon_sym_AT] = ACTIONS(12972),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12972),
    [aux_sym_integer_literal_token2] = ACTIONS(12972),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12972),
    [aux_sym_float_literal_token3] = ACTIONS(12972),
    [aux_sym_float_literal_token4] = ACTIONS(12972),
    [sym_character_literal] = ACTIONS(12972),
    [sym__pair_operator] = ACTIONS(12972),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12972),
    [sym__lazy_and_operator] = ACTIONS(12972),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12972),
    [sym__pipe_left_operator] = ACTIONS(12972),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12972),
    [sym__bitshift_operator] = ACTIONS(12972),
    [sym__power_operator] = ACTIONS(12972),
    [sym__tilde_operator] = ACTIONS(12972),
    [sym__type_order_operator] = ACTIONS(12972),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [8709] = {
    [sym__word_identifier] = ACTIONS(13326),
    [anon_sym_EQ] = ACTIONS(13326),
    [anon_sym_COMMA] = ACTIONS(13326),
    [anon_sym_COLON] = ACTIONS(13326),
    [anon_sym_begin] = ACTIONS(13326),
    [anon_sym_module] = ACTIONS(13326),
    [anon_sym_baremodule] = ACTIONS(13326),
    [anon_sym_end] = ACTIONS(13326),
    [anon_sym_abstract] = ACTIONS(13326),
    [anon_sym_primitive] = ACTIONS(13326),
    [anon_sym_mutable] = ACTIONS(13326),
    [anon_sym_struct] = ACTIONS(13326),
    [anon_sym_function] = ACTIONS(13326),
    [anon_sym_macro] = ACTIONS(13326),
    [anon_sym_where] = ACTIONS(13326),
    [anon_sym_quote] = ACTIONS(13326),
    [anon_sym_let] = ACTIONS(13326),
    [anon_sym_if] = ACTIONS(13326),
    [anon_sym_try] = ACTIONS(13326),
    [anon_sym_finally] = ACTIONS(13326),
    [anon_sym_for] = ACTIONS(13326),
    [anon_sym_while] = ACTIONS(13326),
    [sym_break_statement] = ACTIONS(13326),
    [sym_continue_statement] = ACTIONS(13326),
    [anon_sym_return] = ACTIONS(13326),
    [anon_sym_const] = ACTIONS(13326),
    [anon_sym_global] = ACTIONS(13326),
    [anon_sym_local] = ACTIONS(13326),
    [anon_sym_LPAREN] = ACTIONS(13326),
    [anon_sym_COLON2] = ACTIONS(13326),
    [anon_sym_export] = ACTIONS(13326),
    [anon_sym_import] = ACTIONS(13326),
    [anon_sym_using] = ACTIONS(13326),
    [anon_sym_LBRACK] = ACTIONS(13326),
    [anon_sym_LF] = ACTIONS(13328),
    [anon_sym_in] = ACTIONS(13326),
    [anon_sym_LBRACE] = ACTIONS(13326),
    [anon_sym_DOLLAR] = ACTIONS(13326),
    [anon_sym_COLON_COLON] = ACTIONS(13326),
    [anon_sym_isa] = ACTIONS(13326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13326),
    [anon_sym_QMARK] = ACTIONS(13326),
    [anon_sym_AT] = ACTIONS(13326),
    [anon_sym_true] = ACTIONS(13326),
    [anon_sym_false] = ACTIONS(13326),
    [aux_sym_integer_literal_token1] = ACTIONS(13326),
    [aux_sym_integer_literal_token2] = ACTIONS(13326),
    [aux_sym_integer_literal_token3] = ACTIONS(13326),
    [aux_sym_integer_literal_token4] = ACTIONS(13326),
    [aux_sym_float_literal_token1] = ACTIONS(13326),
    [aux_sym_float_literal_token3] = ACTIONS(13326),
    [aux_sym_float_literal_token4] = ACTIONS(13326),
    [sym_character_literal] = ACTIONS(13326),
    [sym__pair_operator] = ACTIONS(13326),
    [sym__arrow_operator] = ACTIONS(13326),
    [sym__lazy_or_operator] = ACTIONS(13326),
    [sym__lazy_and_operator] = ACTIONS(13326),
    [sym__comparison_operator] = ACTIONS(13326),
    [sym__pipe_right_operator] = ACTIONS(13326),
    [sym__pipe_left_operator] = ACTIONS(13326),
    [sym__ellipsis_operator] = ACTIONS(13326),
    [sym__plus_operator] = ACTIONS(13326),
    [sym__times_operator] = ACTIONS(13326),
    [sym__rational_operator] = ACTIONS(13326),
    [sym__bitshift_operator] = ACTIONS(13326),
    [sym__power_operator] = ACTIONS(13326),
    [sym__tilde_operator] = ACTIONS(13326),
    [sym__type_order_operator] = ACTIONS(13326),
    [sym__unary_operator] = ACTIONS(13326),
    [sym__unary_plus_operator] = ACTIONS(13326),
    [aux_sym__terminator_token1] = ACTIONS(13326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13328),
    [sym__command_start] = ACTIONS(13328),
  },
  [8710] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8711] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12979),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12979),
    [anon_sym_RPAREN] = ACTIONS(12979),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12979),
    [anon_sym_RBRACK] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_SEMI] = ACTIONS(12979),
    [anon_sym_LBRACE] = ACTIONS(12979),
    [anon_sym_RBRACE] = ACTIONS(12979),
    [anon_sym_DOLLAR] = ACTIONS(12979),
    [anon_sym_COLON_COLON] = ACTIONS(12979),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12979),
    [anon_sym_QMARK] = ACTIONS(12979),
    [anon_sym_AT] = ACTIONS(12979),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12979),
    [aux_sym_integer_literal_token2] = ACTIONS(12979),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12979),
    [aux_sym_float_literal_token3] = ACTIONS(12979),
    [aux_sym_float_literal_token4] = ACTIONS(12979),
    [sym_character_literal] = ACTIONS(12979),
    [sym__pair_operator] = ACTIONS(12979),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12979),
    [sym__lazy_and_operator] = ACTIONS(12979),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12979),
    [sym__pipe_left_operator] = ACTIONS(12979),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12979),
    [sym__bitshift_operator] = ACTIONS(12979),
    [sym__power_operator] = ACTIONS(12979),
    [sym__tilde_operator] = ACTIONS(12979),
    [sym__type_order_operator] = ACTIONS(12979),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8712] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(12562),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_catch] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8713] = {
    [aux_sym_open_tuple_repeat1] = STATE(7471),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13497),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_finally] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8714] = {
    [sym__word_identifier] = ACTIONS(13489),
    [anon_sym_EQ] = ACTIONS(13489),
    [anon_sym_COMMA] = ACTIONS(13491),
    [anon_sym_COLON] = ACTIONS(13489),
    [anon_sym_begin] = ACTIONS(13489),
    [anon_sym_module] = ACTIONS(13489),
    [anon_sym_baremodule] = ACTIONS(13489),
    [anon_sym_abstract] = ACTIONS(13489),
    [anon_sym_primitive] = ACTIONS(13489),
    [anon_sym_mutable] = ACTIONS(13489),
    [anon_sym_struct] = ACTIONS(13489),
    [anon_sym_function] = ACTIONS(13489),
    [anon_sym_macro] = ACTIONS(13489),
    [anon_sym_where] = ACTIONS(13489),
    [anon_sym_quote] = ACTIONS(13489),
    [anon_sym_let] = ACTIONS(13489),
    [anon_sym_if] = ACTIONS(13489),
    [anon_sym_try] = ACTIONS(13489),
    [anon_sym_for] = ACTIONS(13489),
    [anon_sym_while] = ACTIONS(13489),
    [sym_break_statement] = ACTIONS(13489),
    [sym_continue_statement] = ACTIONS(13489),
    [anon_sym_return] = ACTIONS(13489),
    [anon_sym_const] = ACTIONS(13489),
    [anon_sym_global] = ACTIONS(13489),
    [anon_sym_local] = ACTIONS(13489),
    [anon_sym_LPAREN] = ACTIONS(13491),
    [anon_sym_RPAREN] = ACTIONS(13491),
    [anon_sym_COLON2] = ACTIONS(13489),
    [anon_sym_export] = ACTIONS(13489),
    [anon_sym_import] = ACTIONS(13489),
    [anon_sym_using] = ACTIONS(13489),
    [anon_sym_LBRACK] = ACTIONS(13491),
    [anon_sym_RBRACK] = ACTIONS(13491),
    [anon_sym_in] = ACTIONS(13489),
    [anon_sym_SEMI] = ACTIONS(13491),
    [anon_sym_LBRACE] = ACTIONS(13491),
    [anon_sym_RBRACE] = ACTIONS(13491),
    [anon_sym_DOLLAR] = ACTIONS(13491),
    [anon_sym_COLON_COLON] = ACTIONS(13491),
    [anon_sym_isa] = ACTIONS(13489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13491),
    [anon_sym_QMARK] = ACTIONS(13491),
    [anon_sym_AT] = ACTIONS(13491),
    [anon_sym_true] = ACTIONS(13489),
    [anon_sym_false] = ACTIONS(13489),
    [aux_sym_integer_literal_token1] = ACTIONS(13491),
    [aux_sym_integer_literal_token2] = ACTIONS(13491),
    [aux_sym_integer_literal_token3] = ACTIONS(13489),
    [aux_sym_integer_literal_token4] = ACTIONS(13489),
    [aux_sym_float_literal_token1] = ACTIONS(13491),
    [aux_sym_float_literal_token3] = ACTIONS(13491),
    [aux_sym_float_literal_token4] = ACTIONS(13491),
    [sym_character_literal] = ACTIONS(13491),
    [sym__pair_operator] = ACTIONS(13491),
    [sym__arrow_operator] = ACTIONS(13489),
    [sym__lazy_or_operator] = ACTIONS(13491),
    [sym__lazy_and_operator] = ACTIONS(13491),
    [sym__comparison_operator] = ACTIONS(13489),
    [sym__pipe_right_operator] = ACTIONS(13491),
    [sym__pipe_left_operator] = ACTIONS(13491),
    [sym__ellipsis_operator] = ACTIONS(13489),
    [sym__plus_operator] = ACTIONS(13489),
    [sym__times_operator] = ACTIONS(13489),
    [sym__rational_operator] = ACTIONS(13491),
    [sym__bitshift_operator] = ACTIONS(13491),
    [sym__power_operator] = ACTIONS(13491),
    [sym__tilde_operator] = ACTIONS(13491),
    [sym__type_order_operator] = ACTIONS(13491),
    [sym__unary_operator] = ACTIONS(13489),
    [sym__unary_plus_operator] = ACTIONS(13489),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13491),
    [sym__command_start] = ACTIONS(13491),
  },
  [8715] = {
    [ts_builtin_sym_end] = ACTIONS(13465),
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_RPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_RBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14531),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14531),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [8716] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14531),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14531),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8717] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14533),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8718] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14535),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8719] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14537),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8720] = {
    [ts_builtin_sym_end] = ACTIONS(13312),
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8721] = {
    [sym__word_identifier] = ACTIONS(13493),
    [anon_sym_EQ] = ACTIONS(13493),
    [anon_sym_COMMA] = ACTIONS(13495),
    [anon_sym_COLON] = ACTIONS(13493),
    [anon_sym_begin] = ACTIONS(13493),
    [anon_sym_module] = ACTIONS(13493),
    [anon_sym_baremodule] = ACTIONS(13493),
    [anon_sym_abstract] = ACTIONS(13493),
    [anon_sym_primitive] = ACTIONS(13493),
    [anon_sym_mutable] = ACTIONS(13493),
    [anon_sym_struct] = ACTIONS(13493),
    [anon_sym_function] = ACTIONS(13493),
    [anon_sym_macro] = ACTIONS(13493),
    [anon_sym_where] = ACTIONS(13493),
    [anon_sym_quote] = ACTIONS(13493),
    [anon_sym_let] = ACTIONS(13493),
    [anon_sym_if] = ACTIONS(13493),
    [anon_sym_try] = ACTIONS(13493),
    [anon_sym_for] = ACTIONS(13493),
    [anon_sym_while] = ACTIONS(13493),
    [sym_break_statement] = ACTIONS(13493),
    [sym_continue_statement] = ACTIONS(13493),
    [anon_sym_return] = ACTIONS(13493),
    [anon_sym_const] = ACTIONS(13493),
    [anon_sym_global] = ACTIONS(13493),
    [anon_sym_local] = ACTIONS(13493),
    [anon_sym_LPAREN] = ACTIONS(13495),
    [anon_sym_RPAREN] = ACTIONS(13495),
    [anon_sym_COLON2] = ACTIONS(13493),
    [anon_sym_export] = ACTIONS(13493),
    [anon_sym_import] = ACTIONS(13493),
    [anon_sym_using] = ACTIONS(13493),
    [anon_sym_LBRACK] = ACTIONS(13495),
    [anon_sym_RBRACK] = ACTIONS(13495),
    [anon_sym_in] = ACTIONS(13493),
    [anon_sym_SEMI] = ACTIONS(13495),
    [anon_sym_LBRACE] = ACTIONS(13495),
    [anon_sym_RBRACE] = ACTIONS(13495),
    [anon_sym_DOLLAR] = ACTIONS(13495),
    [anon_sym_COLON_COLON] = ACTIONS(13495),
    [anon_sym_isa] = ACTIONS(13493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13495),
    [anon_sym_QMARK] = ACTIONS(13495),
    [anon_sym_AT] = ACTIONS(13495),
    [anon_sym_true] = ACTIONS(13493),
    [anon_sym_false] = ACTIONS(13493),
    [aux_sym_integer_literal_token1] = ACTIONS(13495),
    [aux_sym_integer_literal_token2] = ACTIONS(13495),
    [aux_sym_integer_literal_token3] = ACTIONS(13493),
    [aux_sym_integer_literal_token4] = ACTIONS(13493),
    [aux_sym_float_literal_token1] = ACTIONS(13495),
    [aux_sym_float_literal_token3] = ACTIONS(13495),
    [aux_sym_float_literal_token4] = ACTIONS(13495),
    [sym_character_literal] = ACTIONS(13495),
    [sym__pair_operator] = ACTIONS(13495),
    [sym__arrow_operator] = ACTIONS(13493),
    [sym__lazy_or_operator] = ACTIONS(13495),
    [sym__lazy_and_operator] = ACTIONS(13495),
    [sym__comparison_operator] = ACTIONS(13493),
    [sym__pipe_right_operator] = ACTIONS(13495),
    [sym__pipe_left_operator] = ACTIONS(13495),
    [sym__ellipsis_operator] = ACTIONS(13493),
    [sym__plus_operator] = ACTIONS(13493),
    [sym__times_operator] = ACTIONS(13493),
    [sym__rational_operator] = ACTIONS(13495),
    [sym__bitshift_operator] = ACTIONS(13495),
    [sym__power_operator] = ACTIONS(13495),
    [sym__tilde_operator] = ACTIONS(13495),
    [sym__type_order_operator] = ACTIONS(13495),
    [sym__unary_operator] = ACTIONS(13493),
    [sym__unary_plus_operator] = ACTIONS(13493),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13495),
    [sym__command_start] = ACTIONS(13495),
  },
  [8722] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COLON2] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2186),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_isa] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2186),
    [anon_sym_QMARK] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__lazy_or_operator] = ACTIONS(2186),
    [sym__lazy_and_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [8723] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8724] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12134),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8725] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8726] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12562),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_catch] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8727] = {
    [aux_sym_open_tuple_repeat1] = STATE(7471),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(13497),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14481),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_finally] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(14483),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14485),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(14493),
    [sym__arrow_operator] = ACTIONS(14495),
    [sym__lazy_or_operator] = ACTIONS(14497),
    [sym__lazy_and_operator] = ACTIONS(14499),
    [sym__comparison_operator] = ACTIONS(14485),
    [sym__pipe_right_operator] = ACTIONS(14501),
    [sym__pipe_left_operator] = ACTIONS(14503),
    [sym__ellipsis_operator] = ACTIONS(14505),
    [sym__plus_operator] = ACTIONS(14507),
    [sym__times_operator] = ACTIONS(14509),
    [sym__rational_operator] = ACTIONS(14511),
    [sym__bitshift_operator] = ACTIONS(14513),
    [sym__power_operator] = ACTIONS(14515),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(14485),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14507),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8728] = {
    [aux_sym_open_tuple_repeat1] = STATE(8299),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(14604),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14682),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8729] = {
    [sym__word_identifier] = ACTIONS(13499),
    [anon_sym_EQ] = ACTIONS(13499),
    [anon_sym_COMMA] = ACTIONS(13501),
    [anon_sym_COLON] = ACTIONS(13499),
    [anon_sym_begin] = ACTIONS(13499),
    [anon_sym_module] = ACTIONS(13499),
    [anon_sym_baremodule] = ACTIONS(13499),
    [anon_sym_abstract] = ACTIONS(13499),
    [anon_sym_primitive] = ACTIONS(13499),
    [anon_sym_mutable] = ACTIONS(13499),
    [anon_sym_struct] = ACTIONS(13499),
    [anon_sym_function] = ACTIONS(13499),
    [anon_sym_macro] = ACTIONS(13499),
    [anon_sym_where] = ACTIONS(13499),
    [anon_sym_quote] = ACTIONS(13499),
    [anon_sym_let] = ACTIONS(13499),
    [anon_sym_if] = ACTIONS(13499),
    [anon_sym_try] = ACTIONS(13499),
    [anon_sym_for] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(13499),
    [sym_break_statement] = ACTIONS(13499),
    [sym_continue_statement] = ACTIONS(13499),
    [anon_sym_return] = ACTIONS(13499),
    [anon_sym_const] = ACTIONS(13499),
    [anon_sym_global] = ACTIONS(13499),
    [anon_sym_local] = ACTIONS(13499),
    [anon_sym_LPAREN] = ACTIONS(13501),
    [anon_sym_RPAREN] = ACTIONS(13501),
    [anon_sym_COLON2] = ACTIONS(13499),
    [anon_sym_export] = ACTIONS(13499),
    [anon_sym_import] = ACTIONS(13499),
    [anon_sym_using] = ACTIONS(13499),
    [anon_sym_LBRACK] = ACTIONS(13501),
    [anon_sym_RBRACK] = ACTIONS(13501),
    [anon_sym_in] = ACTIONS(13499),
    [anon_sym_SEMI] = ACTIONS(13501),
    [anon_sym_LBRACE] = ACTIONS(13501),
    [anon_sym_RBRACE] = ACTIONS(13501),
    [anon_sym_DOLLAR] = ACTIONS(13501),
    [anon_sym_COLON_COLON] = ACTIONS(13501),
    [anon_sym_isa] = ACTIONS(13499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13501),
    [anon_sym_QMARK] = ACTIONS(13501),
    [anon_sym_AT] = ACTIONS(13501),
    [anon_sym_true] = ACTIONS(13499),
    [anon_sym_false] = ACTIONS(13499),
    [aux_sym_integer_literal_token1] = ACTIONS(13501),
    [aux_sym_integer_literal_token2] = ACTIONS(13501),
    [aux_sym_integer_literal_token3] = ACTIONS(13499),
    [aux_sym_integer_literal_token4] = ACTIONS(13499),
    [aux_sym_float_literal_token1] = ACTIONS(13501),
    [aux_sym_float_literal_token3] = ACTIONS(13501),
    [aux_sym_float_literal_token4] = ACTIONS(13501),
    [sym_character_literal] = ACTIONS(13501),
    [sym__pair_operator] = ACTIONS(13501),
    [sym__arrow_operator] = ACTIONS(13499),
    [sym__lazy_or_operator] = ACTIONS(13501),
    [sym__lazy_and_operator] = ACTIONS(13501),
    [sym__comparison_operator] = ACTIONS(13499),
    [sym__pipe_right_operator] = ACTIONS(13501),
    [sym__pipe_left_operator] = ACTIONS(13501),
    [sym__ellipsis_operator] = ACTIONS(13499),
    [sym__plus_operator] = ACTIONS(13499),
    [sym__times_operator] = ACTIONS(13499),
    [sym__rational_operator] = ACTIONS(13501),
    [sym__bitshift_operator] = ACTIONS(13501),
    [sym__power_operator] = ACTIONS(13501),
    [sym__tilde_operator] = ACTIONS(13501),
    [sym__type_order_operator] = ACTIONS(13501),
    [sym__unary_operator] = ACTIONS(13499),
    [sym__unary_plus_operator] = ACTIONS(13499),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13501),
    [sym__command_start] = ACTIONS(13501),
  },
  [8730] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_elseif] = ACTIONS(13308),
    [anon_sym_else] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [8731] = {
    [aux_sym_open_tuple_repeat1] = STATE(8127),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(14541),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13199),
    [anon_sym_RPAREN] = ACTIONS(13199),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13199),
    [anon_sym_RBRACK] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13199),
    [anon_sym_RBRACE] = ACTIONS(13199),
    [anon_sym_DOLLAR] = ACTIONS(13199),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14716),
    [anon_sym_AT] = ACTIONS(13199),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13199),
    [aux_sym_integer_literal_token2] = ACTIONS(13199),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13199),
    [aux_sym_float_literal_token3] = ACTIONS(13199),
    [aux_sym_float_literal_token4] = ACTIONS(13199),
    [sym_character_literal] = ACTIONS(13199),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13199),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8732] = {
    [aux_sym_open_tuple_repeat1] = STATE(8299),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(14604),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14682),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8733] = {
    [aux_sym_open_tuple_repeat1] = STATE(8299),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(14604),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14682),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8734] = {
    [aux_sym_open_tuple_repeat1] = STATE(8299),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(14604),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14682),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8735] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_elseif] = ACTIONS(13467),
    [anon_sym_else] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14652),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14652),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [8736] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14652),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14652),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8737] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14654),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8738] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14656),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8739] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14658),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8740] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14660),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8741] = {
    [aux_sym_open_tuple_repeat1] = STATE(8299),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(14604),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14682),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8742] = {
    [aux_sym_open_tuple_repeat1] = STATE(8127),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(14541),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13241),
    [anon_sym_RPAREN] = ACTIONS(13241),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13241),
    [anon_sym_RBRACK] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13241),
    [anon_sym_RBRACE] = ACTIONS(13241),
    [anon_sym_DOLLAR] = ACTIONS(13241),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14716),
    [anon_sym_AT] = ACTIONS(13241),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13241),
    [aux_sym_integer_literal_token2] = ACTIONS(13241),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13241),
    [aux_sym_float_literal_token3] = ACTIONS(13241),
    [aux_sym_float_literal_token4] = ACTIONS(13241),
    [sym_character_literal] = ACTIONS(13241),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13241),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8743] = {
    [aux_sym_open_tuple_repeat1] = STATE(8127),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(14541),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13245),
    [anon_sym_RPAREN] = ACTIONS(13245),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13245),
    [anon_sym_RBRACK] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13245),
    [anon_sym_RBRACE] = ACTIONS(13245),
    [anon_sym_DOLLAR] = ACTIONS(13245),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14716),
    [anon_sym_AT] = ACTIONS(13245),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13245),
    [aux_sym_integer_literal_token2] = ACTIONS(13245),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13245),
    [aux_sym_float_literal_token3] = ACTIONS(13245),
    [aux_sym_float_literal_token4] = ACTIONS(13245),
    [sym_character_literal] = ACTIONS(13245),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13245),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8744] = {
    [aux_sym_open_tuple_repeat1] = STATE(8127),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(14541),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12934),
    [anon_sym_RPAREN] = ACTIONS(12934),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12934),
    [anon_sym_RBRACK] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(12934),
    [anon_sym_RBRACE] = ACTIONS(12934),
    [anon_sym_DOLLAR] = ACTIONS(12934),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14716),
    [anon_sym_AT] = ACTIONS(12934),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12934),
    [aux_sym_integer_literal_token2] = ACTIONS(12934),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12934),
    [aux_sym_float_literal_token3] = ACTIONS(12934),
    [aux_sym_float_literal_token4] = ACTIONS(12934),
    [sym_character_literal] = ACTIONS(12934),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(12934),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8745] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_EQ] = ACTIONS(12236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_COLON2] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_in] = ACTIONS(12236),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_isa] = ACTIONS(12236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12236),
    [anon_sym_QMARK] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__lazy_or_operator] = ACTIONS(12236),
    [sym__lazy_and_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [8746] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_COMMA] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_COLON2] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_in] = ACTIONS(12240),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_isa] = ACTIONS(12240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12240),
    [anon_sym_QMARK] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__lazy_or_operator] = ACTIONS(12240),
    [sym__lazy_and_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [8747] = {
    [aux_sym_open_tuple_repeat1] = STATE(8127),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(14541),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13247),
    [anon_sym_RPAREN] = ACTIONS(13247),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13247),
    [anon_sym_RBRACK] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13247),
    [anon_sym_RBRACE] = ACTIONS(13247),
    [anon_sym_DOLLAR] = ACTIONS(13247),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14716),
    [anon_sym_AT] = ACTIONS(13247),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13247),
    [aux_sym_integer_literal_token2] = ACTIONS(13247),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13247),
    [aux_sym_float_literal_token3] = ACTIONS(13247),
    [aux_sym_float_literal_token4] = ACTIONS(13247),
    [sym_character_literal] = ACTIONS(13247),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13247),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8748] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_EQ] = ACTIONS(12244),
    [anon_sym_COMMA] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_COLON2] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_in] = ACTIONS(12244),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_isa] = ACTIONS(12244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12244),
    [anon_sym_QMARK] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__lazy_or_operator] = ACTIONS(12244),
    [sym__lazy_and_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [8749] = {
    [sym__word_identifier] = ACTIONS(13330),
    [anon_sym_EQ] = ACTIONS(13330),
    [anon_sym_COMMA] = ACTIONS(13330),
    [anon_sym_COLON] = ACTIONS(13330),
    [anon_sym_begin] = ACTIONS(13330),
    [anon_sym_module] = ACTIONS(13330),
    [anon_sym_baremodule] = ACTIONS(13330),
    [anon_sym_end] = ACTIONS(13330),
    [anon_sym_abstract] = ACTIONS(13330),
    [anon_sym_primitive] = ACTIONS(13330),
    [anon_sym_mutable] = ACTIONS(13330),
    [anon_sym_struct] = ACTIONS(13330),
    [anon_sym_function] = ACTIONS(13330),
    [anon_sym_macro] = ACTIONS(13330),
    [anon_sym_where] = ACTIONS(13330),
    [anon_sym_quote] = ACTIONS(13330),
    [anon_sym_let] = ACTIONS(13330),
    [anon_sym_if] = ACTIONS(13330),
    [anon_sym_try] = ACTIONS(13330),
    [anon_sym_finally] = ACTIONS(13330),
    [anon_sym_for] = ACTIONS(13330),
    [anon_sym_while] = ACTIONS(13330),
    [sym_break_statement] = ACTIONS(13330),
    [sym_continue_statement] = ACTIONS(13330),
    [anon_sym_return] = ACTIONS(13330),
    [anon_sym_const] = ACTIONS(13330),
    [anon_sym_global] = ACTIONS(13330),
    [anon_sym_local] = ACTIONS(13330),
    [anon_sym_LPAREN] = ACTIONS(13330),
    [anon_sym_COLON2] = ACTIONS(13330),
    [anon_sym_export] = ACTIONS(13330),
    [anon_sym_import] = ACTIONS(13330),
    [anon_sym_using] = ACTIONS(13330),
    [anon_sym_LBRACK] = ACTIONS(13330),
    [anon_sym_LF] = ACTIONS(13332),
    [anon_sym_in] = ACTIONS(13330),
    [anon_sym_LBRACE] = ACTIONS(13330),
    [anon_sym_DOLLAR] = ACTIONS(13330),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_isa] = ACTIONS(13330),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13330),
    [anon_sym_QMARK] = ACTIONS(13330),
    [anon_sym_AT] = ACTIONS(13330),
    [anon_sym_true] = ACTIONS(13330),
    [anon_sym_false] = ACTIONS(13330),
    [aux_sym_integer_literal_token1] = ACTIONS(13330),
    [aux_sym_integer_literal_token2] = ACTIONS(13330),
    [aux_sym_integer_literal_token3] = ACTIONS(13330),
    [aux_sym_integer_literal_token4] = ACTIONS(13330),
    [aux_sym_float_literal_token1] = ACTIONS(13330),
    [aux_sym_float_literal_token3] = ACTIONS(13330),
    [aux_sym_float_literal_token4] = ACTIONS(13330),
    [sym_character_literal] = ACTIONS(13330),
    [sym__pair_operator] = ACTIONS(13330),
    [sym__arrow_operator] = ACTIONS(13330),
    [sym__lazy_or_operator] = ACTIONS(13330),
    [sym__lazy_and_operator] = ACTIONS(13330),
    [sym__comparison_operator] = ACTIONS(13330),
    [sym__pipe_right_operator] = ACTIONS(13330),
    [sym__pipe_left_operator] = ACTIONS(13330),
    [sym__ellipsis_operator] = ACTIONS(13330),
    [sym__plus_operator] = ACTIONS(13330),
    [sym__times_operator] = ACTIONS(13330),
    [sym__rational_operator] = ACTIONS(13330),
    [sym__bitshift_operator] = ACTIONS(13330),
    [sym__power_operator] = ACTIONS(13330),
    [sym__tilde_operator] = ACTIONS(13330),
    [sym__type_order_operator] = ACTIONS(13330),
    [sym__unary_operator] = ACTIONS(13330),
    [sym__unary_plus_operator] = ACTIONS(13330),
    [aux_sym__terminator_token1] = ACTIONS(13330),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13332),
    [sym__command_start] = ACTIONS(13332),
  },
  [8750] = {
    [aux_sym_open_tuple_repeat1] = STATE(8581),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(14635),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_RPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14754),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8751] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14682),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8752] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14682),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8753] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13253),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13253),
    [anon_sym_RPAREN] = ACTIONS(13253),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13253),
    [anon_sym_RBRACK] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13253),
    [anon_sym_RBRACE] = ACTIONS(13253),
    [anon_sym_DOLLAR] = ACTIONS(13253),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14716),
    [anon_sym_AT] = ACTIONS(13253),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13253),
    [aux_sym_integer_literal_token2] = ACTIONS(13253),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13253),
    [aux_sym_float_literal_token3] = ACTIONS(13253),
    [aux_sym_float_literal_token4] = ACTIONS(13253),
    [sym_character_literal] = ACTIONS(13253),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13253),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8754] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13100),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13100),
    [anon_sym_RPAREN] = ACTIONS(13100),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13100),
    [anon_sym_RBRACK] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13100),
    [anon_sym_RBRACE] = ACTIONS(13100),
    [anon_sym_DOLLAR] = ACTIONS(13100),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14716),
    [anon_sym_AT] = ACTIONS(13100),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13100),
    [aux_sym_integer_literal_token2] = ACTIONS(13100),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13100),
    [aux_sym_float_literal_token3] = ACTIONS(13100),
    [aux_sym_float_literal_token4] = ACTIONS(13100),
    [sym_character_literal] = ACTIONS(13100),
    [sym__pair_operator] = ACTIONS(13100),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13100),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8755] = {
    [aux_sym_open_tuple_repeat1] = STATE(8581),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(14635),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_RPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14754),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8756] = {
    [aux_sym_open_tuple_repeat1] = STATE(8581),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(14635),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_RPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14754),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8757] = {
    [aux_sym_open_tuple_repeat1] = STATE(8581),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(14635),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_RPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14754),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8758] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_EQ] = ACTIONS(12248),
    [anon_sym_COMMA] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_COLON2] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_in] = ACTIONS(12248),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_isa] = ACTIONS(12248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12248),
    [anon_sym_QMARK] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__lazy_or_operator] = ACTIONS(12248),
    [sym__lazy_and_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [8759] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_EQ] = ACTIONS(12252),
    [anon_sym_COMMA] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_in] = ACTIONS(12252),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_isa] = ACTIONS(12252),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12252),
    [anon_sym_QMARK] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__lazy_or_operator] = ACTIONS(12252),
    [sym__lazy_and_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [8760] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_EQ] = ACTIONS(12256),
    [anon_sym_COMMA] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_COLON2] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_in] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_isa] = ACTIONS(12256),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12256),
    [anon_sym_QMARK] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__lazy_or_operator] = ACTIONS(12256),
    [sym__lazy_and_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [8761] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_EQ] = ACTIONS(12260),
    [anon_sym_COMMA] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_COLON2] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_in] = ACTIONS(12260),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_isa] = ACTIONS(12260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12260),
    [anon_sym_QMARK] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__lazy_or_operator] = ACTIONS(12260),
    [sym__lazy_and_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [8762] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13806),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_RBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8763] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13806),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_RBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13213),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8764] = {
    [aux_sym_open_tuple_repeat1] = STATE(8581),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(14635),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_RPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14754),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8765] = {
    [aux_sym_export_statement_repeat1] = STATE(8251),
    [sym__word_identifier] = ACTIONS(13144),
    [anon_sym_EQ] = ACTIONS(13144),
    [anon_sym_COMMA] = ACTIONS(14584),
    [anon_sym_COLON] = ACTIONS(13144),
    [anon_sym_begin] = ACTIONS(13144),
    [anon_sym_module] = ACTIONS(13144),
    [anon_sym_baremodule] = ACTIONS(13144),
    [anon_sym_end] = ACTIONS(13144),
    [anon_sym_abstract] = ACTIONS(13144),
    [anon_sym_primitive] = ACTIONS(13144),
    [anon_sym_mutable] = ACTIONS(13144),
    [anon_sym_struct] = ACTIONS(13144),
    [anon_sym_function] = ACTIONS(13144),
    [anon_sym_macro] = ACTIONS(13144),
    [anon_sym_where] = ACTIONS(13144),
    [anon_sym_quote] = ACTIONS(13144),
    [anon_sym_let] = ACTIONS(13144),
    [anon_sym_if] = ACTIONS(13144),
    [anon_sym_try] = ACTIONS(13144),
    [anon_sym_for] = ACTIONS(13144),
    [anon_sym_while] = ACTIONS(13144),
    [sym_break_statement] = ACTIONS(13144),
    [sym_continue_statement] = ACTIONS(13144),
    [anon_sym_return] = ACTIONS(13144),
    [anon_sym_const] = ACTIONS(13144),
    [anon_sym_global] = ACTIONS(13144),
    [anon_sym_local] = ACTIONS(13144),
    [anon_sym_LPAREN] = ACTIONS(13144),
    [anon_sym_COLON2] = ACTIONS(13144),
    [anon_sym_export] = ACTIONS(13144),
    [anon_sym_import] = ACTIONS(13144),
    [anon_sym_using] = ACTIONS(13144),
    [anon_sym_LBRACK] = ACTIONS(13144),
    [anon_sym_LF] = ACTIONS(13146),
    [anon_sym_in] = ACTIONS(13144),
    [anon_sym_LBRACE] = ACTIONS(13144),
    [anon_sym_DOLLAR] = ACTIONS(13144),
    [anon_sym_COLON_COLON] = ACTIONS(13144),
    [anon_sym_isa] = ACTIONS(13144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13144),
    [anon_sym_QMARK] = ACTIONS(13144),
    [anon_sym_AT] = ACTIONS(13144),
    [anon_sym_true] = ACTIONS(13144),
    [anon_sym_false] = ACTIONS(13144),
    [aux_sym_integer_literal_token1] = ACTIONS(13144),
    [aux_sym_integer_literal_token2] = ACTIONS(13144),
    [aux_sym_integer_literal_token3] = ACTIONS(13144),
    [aux_sym_integer_literal_token4] = ACTIONS(13144),
    [aux_sym_float_literal_token1] = ACTIONS(13144),
    [aux_sym_float_literal_token3] = ACTIONS(13144),
    [aux_sym_float_literal_token4] = ACTIONS(13144),
    [sym_character_literal] = ACTIONS(13144),
    [sym__pair_operator] = ACTIONS(13144),
    [sym__arrow_operator] = ACTIONS(13144),
    [sym__lazy_or_operator] = ACTIONS(13144),
    [sym__lazy_and_operator] = ACTIONS(13144),
    [sym__comparison_operator] = ACTIONS(13144),
    [sym__pipe_right_operator] = ACTIONS(13144),
    [sym__pipe_left_operator] = ACTIONS(13144),
    [sym__ellipsis_operator] = ACTIONS(13144),
    [sym__plus_operator] = ACTIONS(13144),
    [sym__times_operator] = ACTIONS(13144),
    [sym__rational_operator] = ACTIONS(13144),
    [sym__bitshift_operator] = ACTIONS(13144),
    [sym__power_operator] = ACTIONS(13144),
    [sym__tilde_operator] = ACTIONS(13144),
    [sym__type_order_operator] = ACTIONS(13144),
    [sym__unary_operator] = ACTIONS(13144),
    [sym__unary_plus_operator] = ACTIONS(13144),
    [aux_sym__terminator_token1] = ACTIONS(13144),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13146),
    [sym__command_start] = ACTIONS(13146),
  },
  [8766] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_RPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13255),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14754),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8767] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_RPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13094),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14754),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8768] = {
    [ts_builtin_sym_end] = ACTIONS(13310),
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_RPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_RBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14539),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [8769] = {
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13255),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_finally] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13255),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13255),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13255),
    [anon_sym_isa] = ACTIONS(13255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13255),
    [anon_sym_QMARK] = ACTIONS(13255),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13255),
    [sym__arrow_operator] = ACTIONS(13255),
    [sym__lazy_or_operator] = ACTIONS(13255),
    [sym__lazy_and_operator] = ACTIONS(13255),
    [sym__comparison_operator] = ACTIONS(13255),
    [sym__pipe_right_operator] = ACTIONS(13255),
    [sym__pipe_left_operator] = ACTIONS(13255),
    [sym__ellipsis_operator] = ACTIONS(13255),
    [sym__plus_operator] = ACTIONS(13255),
    [sym__times_operator] = ACTIONS(13255),
    [sym__rational_operator] = ACTIONS(13255),
    [sym__bitshift_operator] = ACTIONS(13255),
    [sym__power_operator] = ACTIONS(13255),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13255),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13255),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8770] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8771] = {
    [sym__word_identifier] = ACTIONS(13330),
    [anon_sym_EQ] = ACTIONS(13330),
    [anon_sym_COMMA] = ACTIONS(13330),
    [anon_sym_COLON] = ACTIONS(13330),
    [anon_sym_begin] = ACTIONS(13330),
    [anon_sym_module] = ACTIONS(13330),
    [anon_sym_baremodule] = ACTIONS(13330),
    [anon_sym_end] = ACTIONS(13330),
    [anon_sym_abstract] = ACTIONS(13330),
    [anon_sym_primitive] = ACTIONS(13330),
    [anon_sym_mutable] = ACTIONS(13330),
    [anon_sym_struct] = ACTIONS(13330),
    [anon_sym_function] = ACTIONS(13330),
    [anon_sym_macro] = ACTIONS(13330),
    [anon_sym_where] = ACTIONS(13330),
    [anon_sym_quote] = ACTIONS(13330),
    [anon_sym_let] = ACTIONS(13330),
    [anon_sym_if] = ACTIONS(13330),
    [anon_sym_try] = ACTIONS(13330),
    [anon_sym_for] = ACTIONS(13330),
    [anon_sym_while] = ACTIONS(13330),
    [sym_break_statement] = ACTIONS(13330),
    [sym_continue_statement] = ACTIONS(13330),
    [anon_sym_return] = ACTIONS(13330),
    [anon_sym_const] = ACTIONS(13330),
    [anon_sym_global] = ACTIONS(13330),
    [anon_sym_local] = ACTIONS(13330),
    [anon_sym_LPAREN] = ACTIONS(13330),
    [anon_sym_COLON2] = ACTIONS(13330),
    [anon_sym_export] = ACTIONS(13330),
    [anon_sym_import] = ACTIONS(13330),
    [anon_sym_using] = ACTIONS(13330),
    [anon_sym_LBRACK] = ACTIONS(13330),
    [anon_sym_LF] = ACTIONS(13332),
    [anon_sym_in] = ACTIONS(13330),
    [anon_sym_LBRACE] = ACTIONS(13330),
    [anon_sym_DOLLAR] = ACTIONS(13330),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_isa] = ACTIONS(13330),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13330),
    [anon_sym_QMARK] = ACTIONS(13330),
    [anon_sym_AT] = ACTIONS(13330),
    [anon_sym_true] = ACTIONS(13330),
    [anon_sym_false] = ACTIONS(13330),
    [aux_sym_integer_literal_token1] = ACTIONS(13330),
    [aux_sym_integer_literal_token2] = ACTIONS(13330),
    [aux_sym_integer_literal_token3] = ACTIONS(13330),
    [aux_sym_integer_literal_token4] = ACTIONS(13330),
    [aux_sym_float_literal_token1] = ACTIONS(13330),
    [aux_sym_float_literal_token3] = ACTIONS(13330),
    [aux_sym_float_literal_token4] = ACTIONS(13330),
    [sym_character_literal] = ACTIONS(13330),
    [sym__pair_operator] = ACTIONS(13330),
    [sym__arrow_operator] = ACTIONS(13330),
    [sym__lazy_or_operator] = ACTIONS(13330),
    [sym__lazy_and_operator] = ACTIONS(13330),
    [sym__comparison_operator] = ACTIONS(13330),
    [sym__pipe_right_operator] = ACTIONS(13330),
    [sym__pipe_left_operator] = ACTIONS(13330),
    [sym__ellipsis_operator] = ACTIONS(13330),
    [sym__plus_operator] = ACTIONS(13330),
    [sym__times_operator] = ACTIONS(13330),
    [sym__rational_operator] = ACTIONS(13330),
    [sym__bitshift_operator] = ACTIONS(13330),
    [sym__power_operator] = ACTIONS(13330),
    [sym__tilde_operator] = ACTIONS(13330),
    [sym__type_order_operator] = ACTIONS(13330),
    [sym__unary_operator] = ACTIONS(13330),
    [sym__unary_plus_operator] = ACTIONS(13330),
    [aux_sym__terminator_token1] = ACTIONS(13330),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13332),
    [sym__command_start] = ACTIONS(13332),
  },
  [8772] = {
    [sym__word_identifier] = ACTIONS(13386),
    [anon_sym_EQ] = ACTIONS(13386),
    [anon_sym_COMMA] = ACTIONS(13386),
    [anon_sym_COLON] = ACTIONS(13386),
    [anon_sym_begin] = ACTIONS(13386),
    [anon_sym_module] = ACTIONS(13386),
    [anon_sym_baremodule] = ACTIONS(13386),
    [anon_sym_abstract] = ACTIONS(13386),
    [anon_sym_primitive] = ACTIONS(13386),
    [anon_sym_mutable] = ACTIONS(13386),
    [anon_sym_struct] = ACTIONS(13386),
    [anon_sym_function] = ACTIONS(13386),
    [anon_sym_macro] = ACTIONS(13386),
    [anon_sym_where] = ACTIONS(13386),
    [anon_sym_quote] = ACTIONS(13386),
    [anon_sym_let] = ACTIONS(13386),
    [anon_sym_if] = ACTIONS(13386),
    [anon_sym_try] = ACTIONS(13386),
    [anon_sym_for] = ACTIONS(13386),
    [anon_sym_while] = ACTIONS(13386),
    [sym_break_statement] = ACTIONS(13386),
    [sym_continue_statement] = ACTIONS(13386),
    [anon_sym_return] = ACTIONS(13386),
    [anon_sym_const] = ACTIONS(13386),
    [anon_sym_global] = ACTIONS(13386),
    [anon_sym_local] = ACTIONS(13386),
    [anon_sym_LPAREN] = ACTIONS(13386),
    [anon_sym_RPAREN] = ACTIONS(13386),
    [anon_sym_COLON2] = ACTIONS(13386),
    [anon_sym_export] = ACTIONS(13386),
    [anon_sym_import] = ACTIONS(13386),
    [anon_sym_using] = ACTIONS(13386),
    [anon_sym_LBRACK] = ACTIONS(13386),
    [anon_sym_LF] = ACTIONS(13388),
    [anon_sym_in] = ACTIONS(13386),
    [anon_sym_SEMI] = ACTIONS(13386),
    [anon_sym_LBRACE] = ACTIONS(13386),
    [anon_sym_DOLLAR] = ACTIONS(13386),
    [anon_sym_COLON_COLON] = ACTIONS(13386),
    [anon_sym_isa] = ACTIONS(13386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13386),
    [anon_sym_QMARK] = ACTIONS(13386),
    [anon_sym_AT] = ACTIONS(13386),
    [anon_sym_true] = ACTIONS(13386),
    [anon_sym_false] = ACTIONS(13386),
    [aux_sym_integer_literal_token1] = ACTIONS(13386),
    [aux_sym_integer_literal_token2] = ACTIONS(13386),
    [aux_sym_integer_literal_token3] = ACTIONS(13386),
    [aux_sym_integer_literal_token4] = ACTIONS(13386),
    [aux_sym_float_literal_token1] = ACTIONS(13386),
    [aux_sym_float_literal_token3] = ACTIONS(13386),
    [aux_sym_float_literal_token4] = ACTIONS(13386),
    [sym_character_literal] = ACTIONS(13386),
    [sym__pair_operator] = ACTIONS(13386),
    [sym__arrow_operator] = ACTIONS(13386),
    [sym__lazy_or_operator] = ACTIONS(13386),
    [sym__lazy_and_operator] = ACTIONS(13386),
    [sym__comparison_operator] = ACTIONS(13386),
    [sym__pipe_right_operator] = ACTIONS(13386),
    [sym__pipe_left_operator] = ACTIONS(13386),
    [sym__ellipsis_operator] = ACTIONS(13386),
    [sym__plus_operator] = ACTIONS(13386),
    [sym__times_operator] = ACTIONS(13386),
    [sym__rational_operator] = ACTIONS(13386),
    [sym__bitshift_operator] = ACTIONS(13386),
    [sym__power_operator] = ACTIONS(13386),
    [sym__tilde_operator] = ACTIONS(13386),
    [sym__type_order_operator] = ACTIONS(13386),
    [sym__unary_operator] = ACTIONS(13386),
    [sym__unary_plus_operator] = ACTIONS(13386),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13388),
    [sym__command_start] = ACTIONS(13388),
  },
  [8773] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_EQ] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13340),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13340),
    [anon_sym_RPAREN] = ACTIONS(13340),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13340),
    [anon_sym_RBRACK] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13340),
    [anon_sym_RBRACE] = ACTIONS(13340),
    [anon_sym_DOLLAR] = ACTIONS(13340),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14716),
    [anon_sym_AT] = ACTIONS(13340),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13340),
    [aux_sym_integer_literal_token2] = ACTIONS(13340),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13340),
    [aux_sym_float_literal_token3] = ACTIONS(13340),
    [aux_sym_float_literal_token4] = ACTIONS(13340),
    [sym_character_literal] = ACTIONS(13340),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13340),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [8774] = {
    [sym__word_identifier] = ACTIONS(13390),
    [anon_sym_EQ] = ACTIONS(13390),
    [anon_sym_COMMA] = ACTIONS(13390),
    [anon_sym_COLON] = ACTIONS(13390),
    [anon_sym_begin] = ACTIONS(13390),
    [anon_sym_module] = ACTIONS(13390),
    [anon_sym_baremodule] = ACTIONS(13390),
    [anon_sym_abstract] = ACTIONS(13390),
    [anon_sym_primitive] = ACTIONS(13390),
    [anon_sym_mutable] = ACTIONS(13390),
    [anon_sym_struct] = ACTIONS(13390),
    [anon_sym_function] = ACTIONS(13390),
    [anon_sym_macro] = ACTIONS(13390),
    [anon_sym_where] = ACTIONS(13390),
    [anon_sym_quote] = ACTIONS(13390),
    [anon_sym_let] = ACTIONS(13390),
    [anon_sym_if] = ACTIONS(13390),
    [anon_sym_try] = ACTIONS(13390),
    [anon_sym_for] = ACTIONS(13390),
    [anon_sym_while] = ACTIONS(13390),
    [sym_break_statement] = ACTIONS(13390),
    [sym_continue_statement] = ACTIONS(13390),
    [anon_sym_return] = ACTIONS(13390),
    [anon_sym_const] = ACTIONS(13390),
    [anon_sym_global] = ACTIONS(13390),
    [anon_sym_local] = ACTIONS(13390),
    [anon_sym_LPAREN] = ACTIONS(13390),
    [anon_sym_RPAREN] = ACTIONS(13390),
    [anon_sym_COLON2] = ACTIONS(13390),
    [anon_sym_export] = ACTIONS(13390),
    [anon_sym_import] = ACTIONS(13390),
    [anon_sym_using] = ACTIONS(13390),
    [anon_sym_LBRACK] = ACTIONS(13390),
    [anon_sym_LF] = ACTIONS(13392),
    [anon_sym_in] = ACTIONS(13390),
    [anon_sym_SEMI] = ACTIONS(13390),
    [anon_sym_LBRACE] = ACTIONS(13390),
    [anon_sym_DOLLAR] = ACTIONS(13390),
    [anon_sym_COLON_COLON] = ACTIONS(13390),
    [anon_sym_isa] = ACTIONS(13390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13390),
    [anon_sym_QMARK] = ACTIONS(13390),
    [anon_sym_AT] = ACTIONS(13390),
    [anon_sym_true] = ACTIONS(13390),
    [anon_sym_false] = ACTIONS(13390),
    [aux_sym_integer_literal_token1] = ACTIONS(13390),
    [aux_sym_integer_literal_token2] = ACTIONS(13390),
    [aux_sym_integer_literal_token3] = ACTIONS(13390),
    [aux_sym_integer_literal_token4] = ACTIONS(13390),
    [aux_sym_float_literal_token1] = ACTIONS(13390),
    [aux_sym_float_literal_token3] = ACTIONS(13390),
    [aux_sym_float_literal_token4] = ACTIONS(13390),
    [sym_character_literal] = ACTIONS(13390),
    [sym__pair_operator] = ACTIONS(13390),
    [sym__arrow_operator] = ACTIONS(13390),
    [sym__lazy_or_operator] = ACTIONS(13390),
    [sym__lazy_and_operator] = ACTIONS(13390),
    [sym__comparison_operator] = ACTIONS(13390),
    [sym__pipe_right_operator] = ACTIONS(13390),
    [sym__pipe_left_operator] = ACTIONS(13390),
    [sym__ellipsis_operator] = ACTIONS(13390),
    [sym__plus_operator] = ACTIONS(13390),
    [sym__times_operator] = ACTIONS(13390),
    [sym__rational_operator] = ACTIONS(13390),
    [sym__bitshift_operator] = ACTIONS(13390),
    [sym__power_operator] = ACTIONS(13390),
    [sym__tilde_operator] = ACTIONS(13390),
    [sym__type_order_operator] = ACTIONS(13390),
    [sym__unary_operator] = ACTIONS(13390),
    [sym__unary_plus_operator] = ACTIONS(13390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13392),
    [sym__command_start] = ACTIONS(13392),
  },
  [8775] = {
    [sym__word_identifier] = ACTIONS(13396),
    [anon_sym_EQ] = ACTIONS(13396),
    [anon_sym_COMMA] = ACTIONS(13396),
    [anon_sym_COLON] = ACTIONS(13396),
    [anon_sym_begin] = ACTIONS(13396),
    [anon_sym_module] = ACTIONS(13396),
    [anon_sym_baremodule] = ACTIONS(13396),
    [anon_sym_abstract] = ACTIONS(13396),
    [anon_sym_primitive] = ACTIONS(13396),
    [anon_sym_mutable] = ACTIONS(13396),
    [anon_sym_struct] = ACTIONS(13396),
    [anon_sym_function] = ACTIONS(13396),
    [anon_sym_macro] = ACTIONS(13396),
    [anon_sym_where] = ACTIONS(13396),
    [anon_sym_quote] = ACTIONS(13396),
    [anon_sym_let] = ACTIONS(13396),
    [anon_sym_if] = ACTIONS(13396),
    [anon_sym_try] = ACTIONS(13396),
    [anon_sym_for] = ACTIONS(13396),
    [anon_sym_while] = ACTIONS(13396),
    [sym_break_statement] = ACTIONS(13396),
    [sym_continue_statement] = ACTIONS(13396),
    [anon_sym_return] = ACTIONS(13396),
    [anon_sym_const] = ACTIONS(13396),
    [anon_sym_global] = ACTIONS(13396),
    [anon_sym_local] = ACTIONS(13396),
    [anon_sym_LPAREN] = ACTIONS(13396),
    [anon_sym_RPAREN] = ACTIONS(13396),
    [anon_sym_COLON2] = ACTIONS(13396),
    [anon_sym_export] = ACTIONS(13396),
    [anon_sym_import] = ACTIONS(13396),
    [anon_sym_using] = ACTIONS(13396),
    [anon_sym_LBRACK] = ACTIONS(13396),
    [anon_sym_LF] = ACTIONS(13398),
    [anon_sym_in] = ACTIONS(13396),
    [anon_sym_SEMI] = ACTIONS(13396),
    [anon_sym_LBRACE] = ACTIONS(13396),
    [anon_sym_DOLLAR] = ACTIONS(13396),
    [anon_sym_COLON_COLON] = ACTIONS(13396),
    [anon_sym_isa] = ACTIONS(13396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13396),
    [anon_sym_QMARK] = ACTIONS(13396),
    [anon_sym_AT] = ACTIONS(13396),
    [anon_sym_true] = ACTIONS(13396),
    [anon_sym_false] = ACTIONS(13396),
    [aux_sym_integer_literal_token1] = ACTIONS(13396),
    [aux_sym_integer_literal_token2] = ACTIONS(13396),
    [aux_sym_integer_literal_token3] = ACTIONS(13396),
    [aux_sym_integer_literal_token4] = ACTIONS(13396),
    [aux_sym_float_literal_token1] = ACTIONS(13396),
    [aux_sym_float_literal_token3] = ACTIONS(13396),
    [aux_sym_float_literal_token4] = ACTIONS(13396),
    [sym_character_literal] = ACTIONS(13396),
    [sym__pair_operator] = ACTIONS(13396),
    [sym__arrow_operator] = ACTIONS(13396),
    [sym__lazy_or_operator] = ACTIONS(13396),
    [sym__lazy_and_operator] = ACTIONS(13396),
    [sym__comparison_operator] = ACTIONS(13396),
    [sym__pipe_right_operator] = ACTIONS(13396),
    [sym__pipe_left_operator] = ACTIONS(13396),
    [sym__ellipsis_operator] = ACTIONS(13396),
    [sym__plus_operator] = ACTIONS(13396),
    [sym__times_operator] = ACTIONS(13396),
    [sym__rational_operator] = ACTIONS(13396),
    [sym__bitshift_operator] = ACTIONS(13396),
    [sym__power_operator] = ACTIONS(13396),
    [sym__tilde_operator] = ACTIONS(13396),
    [sym__type_order_operator] = ACTIONS(13396),
    [sym__unary_operator] = ACTIONS(13396),
    [sym__unary_plus_operator] = ACTIONS(13396),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13398),
    [sym__command_start] = ACTIONS(13398),
  },
  [8776] = {
    [sym__word_identifier] = ACTIONS(13400),
    [anon_sym_EQ] = ACTIONS(13400),
    [anon_sym_COMMA] = ACTIONS(13400),
    [anon_sym_COLON] = ACTIONS(13400),
    [anon_sym_begin] = ACTIONS(13400),
    [anon_sym_module] = ACTIONS(13400),
    [anon_sym_baremodule] = ACTIONS(13400),
    [anon_sym_abstract] = ACTIONS(13400),
    [anon_sym_primitive] = ACTIONS(13400),
    [anon_sym_mutable] = ACTIONS(13400),
    [anon_sym_struct] = ACTIONS(13400),
    [anon_sym_function] = ACTIONS(13400),
    [anon_sym_macro] = ACTIONS(13400),
    [anon_sym_where] = ACTIONS(13400),
    [anon_sym_quote] = ACTIONS(13400),
    [anon_sym_let] = ACTIONS(13400),
    [anon_sym_if] = ACTIONS(13400),
    [anon_sym_try] = ACTIONS(13400),
    [anon_sym_for] = ACTIONS(13400),
    [anon_sym_while] = ACTIONS(13400),
    [sym_break_statement] = ACTIONS(13400),
    [sym_continue_statement] = ACTIONS(13400),
    [anon_sym_return] = ACTIONS(13400),
    [anon_sym_const] = ACTIONS(13400),
    [anon_sym_global] = ACTIONS(13400),
    [anon_sym_local] = ACTIONS(13400),
    [anon_sym_LPAREN] = ACTIONS(13400),
    [anon_sym_RPAREN] = ACTIONS(13400),
    [anon_sym_COLON2] = ACTIONS(13400),
    [anon_sym_export] = ACTIONS(13400),
    [anon_sym_import] = ACTIONS(13400),
    [anon_sym_using] = ACTIONS(13400),
    [anon_sym_LBRACK] = ACTIONS(13400),
    [anon_sym_LF] = ACTIONS(13402),
    [anon_sym_in] = ACTIONS(13400),
    [anon_sym_SEMI] = ACTIONS(13400),
    [anon_sym_LBRACE] = ACTIONS(13400),
    [anon_sym_DOLLAR] = ACTIONS(13400),
    [anon_sym_COLON_COLON] = ACTIONS(13400),
    [anon_sym_isa] = ACTIONS(13400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13400),
    [anon_sym_QMARK] = ACTIONS(13400),
    [anon_sym_AT] = ACTIONS(13400),
    [anon_sym_true] = ACTIONS(13400),
    [anon_sym_false] = ACTIONS(13400),
    [aux_sym_integer_literal_token1] = ACTIONS(13400),
    [aux_sym_integer_literal_token2] = ACTIONS(13400),
    [aux_sym_integer_literal_token3] = ACTIONS(13400),
    [aux_sym_integer_literal_token4] = ACTIONS(13400),
    [aux_sym_float_literal_token1] = ACTIONS(13400),
    [aux_sym_float_literal_token3] = ACTIONS(13400),
    [aux_sym_float_literal_token4] = ACTIONS(13400),
    [sym_character_literal] = ACTIONS(13400),
    [sym__pair_operator] = ACTIONS(13400),
    [sym__arrow_operator] = ACTIONS(13400),
    [sym__lazy_or_operator] = ACTIONS(13400),
    [sym__lazy_and_operator] = ACTIONS(13400),
    [sym__comparison_operator] = ACTIONS(13400),
    [sym__pipe_right_operator] = ACTIONS(13400),
    [sym__pipe_left_operator] = ACTIONS(13400),
    [sym__ellipsis_operator] = ACTIONS(13400),
    [sym__plus_operator] = ACTIONS(13400),
    [sym__times_operator] = ACTIONS(13400),
    [sym__rational_operator] = ACTIONS(13400),
    [sym__bitshift_operator] = ACTIONS(13400),
    [sym__power_operator] = ACTIONS(13400),
    [sym__tilde_operator] = ACTIONS(13400),
    [sym__type_order_operator] = ACTIONS(13400),
    [sym__unary_operator] = ACTIONS(13400),
    [sym__unary_plus_operator] = ACTIONS(13400),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13402),
    [sym__command_start] = ACTIONS(13402),
  },
  [8777] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14780),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14782),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14784),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14786),
    [sym__lazy_or_operator] = ACTIONS(14788),
    [sym__lazy_and_operator] = ACTIONS(14790),
    [sym__comparison_operator] = ACTIONS(14784),
    [sym__pipe_right_operator] = ACTIONS(14792),
    [sym__pipe_left_operator] = ACTIONS(14794),
    [sym__ellipsis_operator] = ACTIONS(14796),
    [sym__plus_operator] = ACTIONS(14798),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14784),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14798),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8778] = {
    [sym__word_identifier] = ACTIONS(13407),
    [anon_sym_EQ] = ACTIONS(13407),
    [anon_sym_COMMA] = ACTIONS(13407),
    [anon_sym_COLON] = ACTIONS(13407),
    [anon_sym_begin] = ACTIONS(13407),
    [anon_sym_module] = ACTIONS(13407),
    [anon_sym_baremodule] = ACTIONS(13407),
    [anon_sym_abstract] = ACTIONS(13407),
    [anon_sym_primitive] = ACTIONS(13407),
    [anon_sym_mutable] = ACTIONS(13407),
    [anon_sym_struct] = ACTIONS(13407),
    [anon_sym_function] = ACTIONS(13407),
    [anon_sym_macro] = ACTIONS(13407),
    [anon_sym_where] = ACTIONS(13407),
    [anon_sym_quote] = ACTIONS(13407),
    [anon_sym_let] = ACTIONS(13407),
    [anon_sym_if] = ACTIONS(13407),
    [anon_sym_try] = ACTIONS(13407),
    [anon_sym_for] = ACTIONS(13407),
    [anon_sym_while] = ACTIONS(13407),
    [sym_break_statement] = ACTIONS(13407),
    [sym_continue_statement] = ACTIONS(13407),
    [anon_sym_return] = ACTIONS(13407),
    [anon_sym_const] = ACTIONS(13407),
    [anon_sym_global] = ACTIONS(13407),
    [anon_sym_local] = ACTIONS(13407),
    [anon_sym_LPAREN] = ACTIONS(13407),
    [anon_sym_RPAREN] = ACTIONS(13407),
    [anon_sym_COLON2] = ACTIONS(13407),
    [anon_sym_export] = ACTIONS(13407),
    [anon_sym_import] = ACTIONS(13407),
    [anon_sym_using] = ACTIONS(13407),
    [anon_sym_LBRACK] = ACTIONS(13407),
    [anon_sym_LF] = ACTIONS(13409),
    [anon_sym_in] = ACTIONS(13407),
    [anon_sym_SEMI] = ACTIONS(13407),
    [anon_sym_LBRACE] = ACTIONS(13407),
    [anon_sym_DOLLAR] = ACTIONS(13407),
    [anon_sym_COLON_COLON] = ACTIONS(13407),
    [anon_sym_isa] = ACTIONS(13407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13407),
    [anon_sym_QMARK] = ACTIONS(13407),
    [anon_sym_AT] = ACTIONS(13407),
    [anon_sym_true] = ACTIONS(13407),
    [anon_sym_false] = ACTIONS(13407),
    [aux_sym_integer_literal_token1] = ACTIONS(13407),
    [aux_sym_integer_literal_token2] = ACTIONS(13407),
    [aux_sym_integer_literal_token3] = ACTIONS(13407),
    [aux_sym_integer_literal_token4] = ACTIONS(13407),
    [aux_sym_float_literal_token1] = ACTIONS(13407),
    [aux_sym_float_literal_token3] = ACTIONS(13407),
    [aux_sym_float_literal_token4] = ACTIONS(13407),
    [sym_character_literal] = ACTIONS(13407),
    [sym__pair_operator] = ACTIONS(13407),
    [sym__arrow_operator] = ACTIONS(13407),
    [sym__lazy_or_operator] = ACTIONS(13407),
    [sym__lazy_and_operator] = ACTIONS(13407),
    [sym__comparison_operator] = ACTIONS(13407),
    [sym__pipe_right_operator] = ACTIONS(13407),
    [sym__pipe_left_operator] = ACTIONS(13407),
    [sym__ellipsis_operator] = ACTIONS(13407),
    [sym__plus_operator] = ACTIONS(13407),
    [sym__times_operator] = ACTIONS(13407),
    [sym__rational_operator] = ACTIONS(13407),
    [sym__bitshift_operator] = ACTIONS(13407),
    [sym__power_operator] = ACTIONS(13407),
    [sym__tilde_operator] = ACTIONS(13407),
    [sym__type_order_operator] = ACTIONS(13407),
    [sym__unary_operator] = ACTIONS(13407),
    [sym__unary_plus_operator] = ACTIONS(13407),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13409),
    [sym__command_start] = ACTIONS(13409),
  },
  [8779] = {
    [sym__word_identifier] = ACTIONS(13620),
    [anon_sym_EQ] = ACTIONS(13620),
    [anon_sym_COMMA] = ACTIONS(13620),
    [anon_sym_COLON] = ACTIONS(13620),
    [anon_sym_begin] = ACTIONS(13620),
    [anon_sym_module] = ACTIONS(13620),
    [anon_sym_baremodule] = ACTIONS(13620),
    [anon_sym_end] = ACTIONS(13620),
    [anon_sym_abstract] = ACTIONS(13620),
    [anon_sym_primitive] = ACTIONS(13620),
    [anon_sym_mutable] = ACTIONS(13620),
    [anon_sym_struct] = ACTIONS(13620),
    [anon_sym_function] = ACTIONS(13620),
    [anon_sym_macro] = ACTIONS(13620),
    [anon_sym_where] = ACTIONS(13620),
    [anon_sym_quote] = ACTIONS(13620),
    [anon_sym_let] = ACTIONS(13620),
    [anon_sym_if] = ACTIONS(13620),
    [anon_sym_try] = ACTIONS(13620),
    [anon_sym_for] = ACTIONS(13620),
    [anon_sym_while] = ACTIONS(13620),
    [sym_break_statement] = ACTIONS(13620),
    [sym_continue_statement] = ACTIONS(13620),
    [anon_sym_return] = ACTIONS(13620),
    [anon_sym_const] = ACTIONS(13620),
    [anon_sym_global] = ACTIONS(13620),
    [anon_sym_local] = ACTIONS(13620),
    [anon_sym_LPAREN] = ACTIONS(13620),
    [anon_sym_COLON2] = ACTIONS(13620),
    [anon_sym_export] = ACTIONS(13620),
    [anon_sym_import] = ACTIONS(13620),
    [anon_sym_using] = ACTIONS(13620),
    [anon_sym_LBRACK] = ACTIONS(13620),
    [anon_sym_LF] = ACTIONS(13622),
    [anon_sym_in] = ACTIONS(13620),
    [anon_sym_LBRACE] = ACTIONS(13620),
    [anon_sym_DOLLAR] = ACTIONS(13620),
    [anon_sym_COLON_COLON] = ACTIONS(13620),
    [anon_sym_isa] = ACTIONS(13620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13620),
    [anon_sym_QMARK] = ACTIONS(13620),
    [anon_sym_AT] = ACTIONS(13620),
    [anon_sym_true] = ACTIONS(13620),
    [anon_sym_false] = ACTIONS(13620),
    [aux_sym_integer_literal_token1] = ACTIONS(13620),
    [aux_sym_integer_literal_token2] = ACTIONS(13620),
    [aux_sym_integer_literal_token3] = ACTIONS(13620),
    [aux_sym_integer_literal_token4] = ACTIONS(13620),
    [aux_sym_float_literal_token1] = ACTIONS(13620),
    [aux_sym_float_literal_token3] = ACTIONS(13620),
    [aux_sym_float_literal_token4] = ACTIONS(13620),
    [sym_character_literal] = ACTIONS(13620),
    [sym__pair_operator] = ACTIONS(13620),
    [sym__arrow_operator] = ACTIONS(13620),
    [sym__lazy_or_operator] = ACTIONS(13620),
    [sym__lazy_and_operator] = ACTIONS(13620),
    [sym__comparison_operator] = ACTIONS(13620),
    [sym__pipe_right_operator] = ACTIONS(13620),
    [sym__pipe_left_operator] = ACTIONS(13620),
    [sym__ellipsis_operator] = ACTIONS(13620),
    [sym__plus_operator] = ACTIONS(13620),
    [sym__times_operator] = ACTIONS(13620),
    [sym__rational_operator] = ACTIONS(13620),
    [sym__bitshift_operator] = ACTIONS(13620),
    [sym__power_operator] = ACTIONS(13620),
    [sym__tilde_operator] = ACTIONS(13620),
    [sym__type_order_operator] = ACTIONS(13620),
    [sym__unary_operator] = ACTIONS(13620),
    [sym__unary_plus_operator] = ACTIONS(13620),
    [aux_sym__terminator_token1] = ACTIONS(13620),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13622),
    [sym__command_start] = ACTIONS(13622),
  },
  [8780] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14780),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14782),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14784),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14790),
    [sym__comparison_operator] = ACTIONS(14784),
    [sym__pipe_right_operator] = ACTIONS(14792),
    [sym__pipe_left_operator] = ACTIONS(14794),
    [sym__ellipsis_operator] = ACTIONS(14796),
    [sym__plus_operator] = ACTIONS(14798),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14784),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14798),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8781] = {
    [sym__word_identifier] = ACTIONS(13362),
    [anon_sym_EQ] = ACTIONS(13362),
    [anon_sym_COMMA] = ACTIONS(13362),
    [anon_sym_COLON] = ACTIONS(13362),
    [anon_sym_begin] = ACTIONS(13362),
    [anon_sym_module] = ACTIONS(13362),
    [anon_sym_baremodule] = ACTIONS(13362),
    [anon_sym_end] = ACTIONS(13362),
    [anon_sym_abstract] = ACTIONS(13362),
    [anon_sym_primitive] = ACTIONS(13362),
    [anon_sym_mutable] = ACTIONS(13362),
    [anon_sym_struct] = ACTIONS(13362),
    [anon_sym_function] = ACTIONS(13362),
    [anon_sym_macro] = ACTIONS(13362),
    [anon_sym_where] = ACTIONS(13362),
    [anon_sym_quote] = ACTIONS(13362),
    [anon_sym_let] = ACTIONS(13362),
    [anon_sym_if] = ACTIONS(13362),
    [anon_sym_try] = ACTIONS(13362),
    [anon_sym_for] = ACTIONS(13362),
    [anon_sym_while] = ACTIONS(13362),
    [sym_break_statement] = ACTIONS(13362),
    [sym_continue_statement] = ACTIONS(13362),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_const] = ACTIONS(13362),
    [anon_sym_global] = ACTIONS(13362),
    [anon_sym_local] = ACTIONS(13362),
    [anon_sym_LPAREN] = ACTIONS(13362),
    [anon_sym_COLON2] = ACTIONS(13362),
    [anon_sym_export] = ACTIONS(13362),
    [anon_sym_import] = ACTIONS(13362),
    [anon_sym_using] = ACTIONS(13362),
    [anon_sym_LBRACK] = ACTIONS(13362),
    [anon_sym_LF] = ACTIONS(13364),
    [anon_sym_in] = ACTIONS(13362),
    [anon_sym_LBRACE] = ACTIONS(13362),
    [anon_sym_DOLLAR] = ACTIONS(13362),
    [anon_sym_COLON_COLON] = ACTIONS(13362),
    [anon_sym_isa] = ACTIONS(13362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13362),
    [anon_sym_QMARK] = ACTIONS(13362),
    [anon_sym_AT] = ACTIONS(13362),
    [anon_sym_true] = ACTIONS(13362),
    [anon_sym_false] = ACTIONS(13362),
    [aux_sym_integer_literal_token1] = ACTIONS(13362),
    [aux_sym_integer_literal_token2] = ACTIONS(13362),
    [aux_sym_integer_literal_token3] = ACTIONS(13362),
    [aux_sym_integer_literal_token4] = ACTIONS(13362),
    [aux_sym_float_literal_token1] = ACTIONS(13362),
    [aux_sym_float_literal_token3] = ACTIONS(13362),
    [aux_sym_float_literal_token4] = ACTIONS(13362),
    [sym_character_literal] = ACTIONS(13362),
    [sym__pair_operator] = ACTIONS(13362),
    [sym__arrow_operator] = ACTIONS(13362),
    [sym__lazy_or_operator] = ACTIONS(13362),
    [sym__lazy_and_operator] = ACTIONS(13362),
    [sym__comparison_operator] = ACTIONS(13362),
    [sym__pipe_right_operator] = ACTIONS(13362),
    [sym__pipe_left_operator] = ACTIONS(13362),
    [sym__ellipsis_operator] = ACTIONS(13362),
    [sym__plus_operator] = ACTIONS(13362),
    [sym__times_operator] = ACTIONS(13362),
    [sym__rational_operator] = ACTIONS(13362),
    [sym__bitshift_operator] = ACTIONS(13362),
    [sym__power_operator] = ACTIONS(13362),
    [sym__tilde_operator] = ACTIONS(13362),
    [sym__type_order_operator] = ACTIONS(13362),
    [sym__unary_operator] = ACTIONS(13362),
    [sym__unary_plus_operator] = ACTIONS(13362),
    [aux_sym__terminator_token1] = ACTIONS(13362),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13364),
    [sym__command_start] = ACTIONS(13364),
  },
  [8782] = {
    [sym__word_identifier] = ACTIONS(13407),
    [anon_sym_EQ] = ACTIONS(13407),
    [anon_sym_COMMA] = ACTIONS(13407),
    [anon_sym_COLON] = ACTIONS(13407),
    [anon_sym_begin] = ACTIONS(13407),
    [anon_sym_module] = ACTIONS(13407),
    [anon_sym_baremodule] = ACTIONS(13407),
    [anon_sym_end] = ACTIONS(13407),
    [anon_sym_abstract] = ACTIONS(13407),
    [anon_sym_primitive] = ACTIONS(13407),
    [anon_sym_mutable] = ACTIONS(13407),
    [anon_sym_struct] = ACTIONS(13407),
    [anon_sym_function] = ACTIONS(13407),
    [anon_sym_macro] = ACTIONS(13407),
    [anon_sym_where] = ACTIONS(13407),
    [anon_sym_quote] = ACTIONS(13407),
    [anon_sym_let] = ACTIONS(13407),
    [anon_sym_if] = ACTIONS(13407),
    [anon_sym_try] = ACTIONS(13407),
    [anon_sym_for] = ACTIONS(13407),
    [anon_sym_while] = ACTIONS(13407),
    [sym_break_statement] = ACTIONS(13407),
    [sym_continue_statement] = ACTIONS(13407),
    [anon_sym_return] = ACTIONS(13407),
    [anon_sym_const] = ACTIONS(13407),
    [anon_sym_global] = ACTIONS(13407),
    [anon_sym_local] = ACTIONS(13407),
    [anon_sym_LPAREN] = ACTIONS(13407),
    [anon_sym_COLON2] = ACTIONS(13407),
    [anon_sym_export] = ACTIONS(13407),
    [anon_sym_import] = ACTIONS(13407),
    [anon_sym_using] = ACTIONS(13407),
    [anon_sym_LBRACK] = ACTIONS(13407),
    [anon_sym_LF] = ACTIONS(13409),
    [anon_sym_in] = ACTIONS(13407),
    [anon_sym_LBRACE] = ACTIONS(13407),
    [anon_sym_DOLLAR] = ACTIONS(13407),
    [anon_sym_COLON_COLON] = ACTIONS(13407),
    [anon_sym_isa] = ACTIONS(13407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13407),
    [anon_sym_QMARK] = ACTIONS(13407),
    [anon_sym_AT] = ACTIONS(13407),
    [anon_sym_true] = ACTIONS(13407),
    [anon_sym_false] = ACTIONS(13407),
    [aux_sym_integer_literal_token1] = ACTIONS(13407),
    [aux_sym_integer_literal_token2] = ACTIONS(13407),
    [aux_sym_integer_literal_token3] = ACTIONS(13407),
    [aux_sym_integer_literal_token4] = ACTIONS(13407),
    [aux_sym_float_literal_token1] = ACTIONS(13407),
    [aux_sym_float_literal_token3] = ACTIONS(13407),
    [aux_sym_float_literal_token4] = ACTIONS(13407),
    [sym_character_literal] = ACTIONS(13407),
    [sym__pair_operator] = ACTIONS(13407),
    [sym__arrow_operator] = ACTIONS(13407),
    [sym__lazy_or_operator] = ACTIONS(13407),
    [sym__lazy_and_operator] = ACTIONS(13407),
    [sym__comparison_operator] = ACTIONS(13407),
    [sym__pipe_right_operator] = ACTIONS(13407),
    [sym__pipe_left_operator] = ACTIONS(13407),
    [sym__ellipsis_operator] = ACTIONS(13407),
    [sym__plus_operator] = ACTIONS(13407),
    [sym__times_operator] = ACTIONS(13407),
    [sym__rational_operator] = ACTIONS(13407),
    [sym__bitshift_operator] = ACTIONS(13407),
    [sym__power_operator] = ACTIONS(13407),
    [sym__tilde_operator] = ACTIONS(13407),
    [sym__type_order_operator] = ACTIONS(13407),
    [sym__unary_operator] = ACTIONS(13407),
    [sym__unary_plus_operator] = ACTIONS(13407),
    [aux_sym__terminator_token1] = ACTIONS(13407),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13409),
    [sym__command_start] = ACTIONS(13409),
  },
  [8783] = {
    [sym__word_identifier] = ACTIONS(13374),
    [anon_sym_EQ] = ACTIONS(13374),
    [anon_sym_COMMA] = ACTIONS(13374),
    [anon_sym_COLON] = ACTIONS(13374),
    [anon_sym_begin] = ACTIONS(13374),
    [anon_sym_module] = ACTIONS(13374),
    [anon_sym_baremodule] = ACTIONS(13374),
    [anon_sym_end] = ACTIONS(13374),
    [anon_sym_abstract] = ACTIONS(13374),
    [anon_sym_primitive] = ACTIONS(13374),
    [anon_sym_mutable] = ACTIONS(13374),
    [anon_sym_struct] = ACTIONS(13374),
    [anon_sym_function] = ACTIONS(13374),
    [anon_sym_macro] = ACTIONS(13374),
    [anon_sym_where] = ACTIONS(13374),
    [anon_sym_quote] = ACTIONS(13374),
    [anon_sym_let] = ACTIONS(13374),
    [anon_sym_if] = ACTIONS(13374),
    [anon_sym_try] = ACTIONS(13374),
    [anon_sym_for] = ACTIONS(13374),
    [anon_sym_while] = ACTIONS(13374),
    [sym_break_statement] = ACTIONS(13374),
    [sym_continue_statement] = ACTIONS(13374),
    [anon_sym_return] = ACTIONS(13374),
    [anon_sym_const] = ACTIONS(13374),
    [anon_sym_global] = ACTIONS(13374),
    [anon_sym_local] = ACTIONS(13374),
    [anon_sym_LPAREN] = ACTIONS(13374),
    [anon_sym_COLON2] = ACTIONS(13374),
    [anon_sym_export] = ACTIONS(13374),
    [anon_sym_import] = ACTIONS(13374),
    [anon_sym_using] = ACTIONS(13374),
    [anon_sym_LBRACK] = ACTIONS(13374),
    [anon_sym_LF] = ACTIONS(13376),
    [anon_sym_in] = ACTIONS(13374),
    [anon_sym_LBRACE] = ACTIONS(13374),
    [anon_sym_DOLLAR] = ACTIONS(13374),
    [anon_sym_COLON_COLON] = ACTIONS(13374),
    [anon_sym_isa] = ACTIONS(13374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13374),
    [anon_sym_QMARK] = ACTIONS(13374),
    [anon_sym_AT] = ACTIONS(13374),
    [anon_sym_true] = ACTIONS(13374),
    [anon_sym_false] = ACTIONS(13374),
    [aux_sym_integer_literal_token1] = ACTIONS(13374),
    [aux_sym_integer_literal_token2] = ACTIONS(13374),
    [aux_sym_integer_literal_token3] = ACTIONS(13374),
    [aux_sym_integer_literal_token4] = ACTIONS(13374),
    [aux_sym_float_literal_token1] = ACTIONS(13374),
    [aux_sym_float_literal_token3] = ACTIONS(13374),
    [aux_sym_float_literal_token4] = ACTIONS(13374),
    [sym_character_literal] = ACTIONS(13374),
    [sym__pair_operator] = ACTIONS(13374),
    [sym__arrow_operator] = ACTIONS(13374),
    [sym__lazy_or_operator] = ACTIONS(13374),
    [sym__lazy_and_operator] = ACTIONS(13374),
    [sym__comparison_operator] = ACTIONS(13374),
    [sym__pipe_right_operator] = ACTIONS(13374),
    [sym__pipe_left_operator] = ACTIONS(13374),
    [sym__ellipsis_operator] = ACTIONS(13374),
    [sym__plus_operator] = ACTIONS(13374),
    [sym__times_operator] = ACTIONS(13374),
    [sym__rational_operator] = ACTIONS(13374),
    [sym__bitshift_operator] = ACTIONS(13374),
    [sym__power_operator] = ACTIONS(13374),
    [sym__tilde_operator] = ACTIONS(13374),
    [sym__type_order_operator] = ACTIONS(13374),
    [sym__unary_operator] = ACTIONS(13374),
    [sym__unary_plus_operator] = ACTIONS(13374),
    [aux_sym__terminator_token1] = ACTIONS(13374),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13376),
    [sym__command_start] = ACTIONS(13376),
  },
  [8784] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8785] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(13306),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8786] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12714),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8787] = {
    [sym__word_identifier] = ACTIONS(13624),
    [anon_sym_EQ] = ACTIONS(13624),
    [anon_sym_COMMA] = ACTIONS(13624),
    [anon_sym_COLON] = ACTIONS(13624),
    [anon_sym_begin] = ACTIONS(13624),
    [anon_sym_module] = ACTIONS(13624),
    [anon_sym_baremodule] = ACTIONS(13624),
    [anon_sym_end] = ACTIONS(13624),
    [anon_sym_abstract] = ACTIONS(13624),
    [anon_sym_primitive] = ACTIONS(13624),
    [anon_sym_mutable] = ACTIONS(13624),
    [anon_sym_struct] = ACTIONS(13624),
    [anon_sym_function] = ACTIONS(13624),
    [anon_sym_macro] = ACTIONS(13624),
    [anon_sym_where] = ACTIONS(13624),
    [anon_sym_quote] = ACTIONS(13624),
    [anon_sym_let] = ACTIONS(13624),
    [anon_sym_if] = ACTIONS(13624),
    [anon_sym_try] = ACTIONS(13624),
    [anon_sym_for] = ACTIONS(13624),
    [anon_sym_while] = ACTIONS(13624),
    [sym_break_statement] = ACTIONS(13624),
    [sym_continue_statement] = ACTIONS(13624),
    [anon_sym_return] = ACTIONS(13624),
    [anon_sym_const] = ACTIONS(13624),
    [anon_sym_global] = ACTIONS(13624),
    [anon_sym_local] = ACTIONS(13624),
    [anon_sym_LPAREN] = ACTIONS(13624),
    [anon_sym_COLON2] = ACTIONS(13624),
    [anon_sym_export] = ACTIONS(13624),
    [anon_sym_import] = ACTIONS(13624),
    [anon_sym_using] = ACTIONS(13624),
    [anon_sym_LBRACK] = ACTIONS(13624),
    [anon_sym_LF] = ACTIONS(13626),
    [anon_sym_in] = ACTIONS(13624),
    [anon_sym_LBRACE] = ACTIONS(13624),
    [anon_sym_DOLLAR] = ACTIONS(13624),
    [anon_sym_COLON_COLON] = ACTIONS(13624),
    [anon_sym_isa] = ACTIONS(13624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13624),
    [anon_sym_QMARK] = ACTIONS(13624),
    [anon_sym_AT] = ACTIONS(13624),
    [anon_sym_true] = ACTIONS(13624),
    [anon_sym_false] = ACTIONS(13624),
    [aux_sym_integer_literal_token1] = ACTIONS(13624),
    [aux_sym_integer_literal_token2] = ACTIONS(13624),
    [aux_sym_integer_literal_token3] = ACTIONS(13624),
    [aux_sym_integer_literal_token4] = ACTIONS(13624),
    [aux_sym_float_literal_token1] = ACTIONS(13624),
    [aux_sym_float_literal_token3] = ACTIONS(13624),
    [aux_sym_float_literal_token4] = ACTIONS(13624),
    [sym_character_literal] = ACTIONS(13624),
    [sym__pair_operator] = ACTIONS(13624),
    [sym__arrow_operator] = ACTIONS(13624),
    [sym__lazy_or_operator] = ACTIONS(13624),
    [sym__lazy_and_operator] = ACTIONS(13624),
    [sym__comparison_operator] = ACTIONS(13624),
    [sym__pipe_right_operator] = ACTIONS(13624),
    [sym__pipe_left_operator] = ACTIONS(13624),
    [sym__ellipsis_operator] = ACTIONS(13624),
    [sym__plus_operator] = ACTIONS(13624),
    [sym__times_operator] = ACTIONS(13624),
    [sym__rational_operator] = ACTIONS(13624),
    [sym__bitshift_operator] = ACTIONS(13624),
    [sym__power_operator] = ACTIONS(13624),
    [sym__tilde_operator] = ACTIONS(13624),
    [sym__type_order_operator] = ACTIONS(13624),
    [sym__unary_operator] = ACTIONS(13624),
    [sym__unary_plus_operator] = ACTIONS(13624),
    [aux_sym__terminator_token1] = ACTIONS(13624),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13626),
    [sym__command_start] = ACTIONS(13626),
  },
  [8788] = {
    [sym__word_identifier] = ACTIONS(13628),
    [anon_sym_EQ] = ACTIONS(13628),
    [anon_sym_COMMA] = ACTIONS(13628),
    [anon_sym_COLON] = ACTIONS(13628),
    [anon_sym_begin] = ACTIONS(13628),
    [anon_sym_module] = ACTIONS(13628),
    [anon_sym_baremodule] = ACTIONS(13628),
    [anon_sym_end] = ACTIONS(13628),
    [anon_sym_abstract] = ACTIONS(13628),
    [anon_sym_primitive] = ACTIONS(13628),
    [anon_sym_mutable] = ACTIONS(13628),
    [anon_sym_struct] = ACTIONS(13628),
    [anon_sym_function] = ACTIONS(13628),
    [anon_sym_macro] = ACTIONS(13628),
    [anon_sym_where] = ACTIONS(13628),
    [anon_sym_quote] = ACTIONS(13628),
    [anon_sym_let] = ACTIONS(13628),
    [anon_sym_if] = ACTIONS(13628),
    [anon_sym_try] = ACTIONS(13628),
    [anon_sym_for] = ACTIONS(13628),
    [anon_sym_while] = ACTIONS(13628),
    [sym_break_statement] = ACTIONS(13628),
    [sym_continue_statement] = ACTIONS(13628),
    [anon_sym_return] = ACTIONS(13628),
    [anon_sym_const] = ACTIONS(13628),
    [anon_sym_global] = ACTIONS(13628),
    [anon_sym_local] = ACTIONS(13628),
    [anon_sym_LPAREN] = ACTIONS(13628),
    [anon_sym_COLON2] = ACTIONS(13628),
    [anon_sym_export] = ACTIONS(13628),
    [anon_sym_import] = ACTIONS(13628),
    [anon_sym_using] = ACTIONS(13628),
    [anon_sym_LBRACK] = ACTIONS(13628),
    [anon_sym_LF] = ACTIONS(13630),
    [anon_sym_in] = ACTIONS(13628),
    [anon_sym_LBRACE] = ACTIONS(13628),
    [anon_sym_DOLLAR] = ACTIONS(13628),
    [anon_sym_COLON_COLON] = ACTIONS(13628),
    [anon_sym_isa] = ACTIONS(13628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13628),
    [anon_sym_QMARK] = ACTIONS(13628),
    [anon_sym_AT] = ACTIONS(13628),
    [anon_sym_true] = ACTIONS(13628),
    [anon_sym_false] = ACTIONS(13628),
    [aux_sym_integer_literal_token1] = ACTIONS(13628),
    [aux_sym_integer_literal_token2] = ACTIONS(13628),
    [aux_sym_integer_literal_token3] = ACTIONS(13628),
    [aux_sym_integer_literal_token4] = ACTIONS(13628),
    [aux_sym_float_literal_token1] = ACTIONS(13628),
    [aux_sym_float_literal_token3] = ACTIONS(13628),
    [aux_sym_float_literal_token4] = ACTIONS(13628),
    [sym_character_literal] = ACTIONS(13628),
    [sym__pair_operator] = ACTIONS(13628),
    [sym__arrow_operator] = ACTIONS(13628),
    [sym__lazy_or_operator] = ACTIONS(13628),
    [sym__lazy_and_operator] = ACTIONS(13628),
    [sym__comparison_operator] = ACTIONS(13628),
    [sym__pipe_right_operator] = ACTIONS(13628),
    [sym__pipe_left_operator] = ACTIONS(13628),
    [sym__ellipsis_operator] = ACTIONS(13628),
    [sym__plus_operator] = ACTIONS(13628),
    [sym__times_operator] = ACTIONS(13628),
    [sym__rational_operator] = ACTIONS(13628),
    [sym__bitshift_operator] = ACTIONS(13628),
    [sym__power_operator] = ACTIONS(13628),
    [sym__tilde_operator] = ACTIONS(13628),
    [sym__type_order_operator] = ACTIONS(13628),
    [sym__unary_operator] = ACTIONS(13628),
    [sym__unary_plus_operator] = ACTIONS(13628),
    [aux_sym__terminator_token1] = ACTIONS(13628),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13630),
    [sym__command_start] = ACTIONS(13630),
  },
  [8789] = {
    [sym__word_identifier] = ACTIONS(13632),
    [anon_sym_EQ] = ACTIONS(13632),
    [anon_sym_COMMA] = ACTIONS(13632),
    [anon_sym_COLON] = ACTIONS(13632),
    [anon_sym_begin] = ACTIONS(13632),
    [anon_sym_module] = ACTIONS(13632),
    [anon_sym_baremodule] = ACTIONS(13632),
    [anon_sym_end] = ACTIONS(13632),
    [anon_sym_abstract] = ACTIONS(13632),
    [anon_sym_primitive] = ACTIONS(13632),
    [anon_sym_mutable] = ACTIONS(13632),
    [anon_sym_struct] = ACTIONS(13632),
    [anon_sym_function] = ACTIONS(13632),
    [anon_sym_macro] = ACTIONS(13632),
    [anon_sym_where] = ACTIONS(13632),
    [anon_sym_quote] = ACTIONS(13632),
    [anon_sym_let] = ACTIONS(13632),
    [anon_sym_if] = ACTIONS(13632),
    [anon_sym_try] = ACTIONS(13632),
    [anon_sym_for] = ACTIONS(13632),
    [anon_sym_while] = ACTIONS(13632),
    [sym_break_statement] = ACTIONS(13632),
    [sym_continue_statement] = ACTIONS(13632),
    [anon_sym_return] = ACTIONS(13632),
    [anon_sym_const] = ACTIONS(13632),
    [anon_sym_global] = ACTIONS(13632),
    [anon_sym_local] = ACTIONS(13632),
    [anon_sym_LPAREN] = ACTIONS(13632),
    [anon_sym_COLON2] = ACTIONS(13632),
    [anon_sym_export] = ACTIONS(13632),
    [anon_sym_import] = ACTIONS(13632),
    [anon_sym_using] = ACTIONS(13632),
    [anon_sym_LBRACK] = ACTIONS(13632),
    [anon_sym_LF] = ACTIONS(13634),
    [anon_sym_in] = ACTIONS(13632),
    [anon_sym_LBRACE] = ACTIONS(13632),
    [anon_sym_DOLLAR] = ACTIONS(13632),
    [anon_sym_COLON_COLON] = ACTIONS(13632),
    [anon_sym_isa] = ACTIONS(13632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13632),
    [anon_sym_QMARK] = ACTIONS(13632),
    [anon_sym_AT] = ACTIONS(13632),
    [anon_sym_true] = ACTIONS(13632),
    [anon_sym_false] = ACTIONS(13632),
    [aux_sym_integer_literal_token1] = ACTIONS(13632),
    [aux_sym_integer_literal_token2] = ACTIONS(13632),
    [aux_sym_integer_literal_token3] = ACTIONS(13632),
    [aux_sym_integer_literal_token4] = ACTIONS(13632),
    [aux_sym_float_literal_token1] = ACTIONS(13632),
    [aux_sym_float_literal_token3] = ACTIONS(13632),
    [aux_sym_float_literal_token4] = ACTIONS(13632),
    [sym_character_literal] = ACTIONS(13632),
    [sym__pair_operator] = ACTIONS(13632),
    [sym__arrow_operator] = ACTIONS(13632),
    [sym__lazy_or_operator] = ACTIONS(13632),
    [sym__lazy_and_operator] = ACTIONS(13632),
    [sym__comparison_operator] = ACTIONS(13632),
    [sym__pipe_right_operator] = ACTIONS(13632),
    [sym__pipe_left_operator] = ACTIONS(13632),
    [sym__ellipsis_operator] = ACTIONS(13632),
    [sym__plus_operator] = ACTIONS(13632),
    [sym__times_operator] = ACTIONS(13632),
    [sym__rational_operator] = ACTIONS(13632),
    [sym__bitshift_operator] = ACTIONS(13632),
    [sym__power_operator] = ACTIONS(13632),
    [sym__tilde_operator] = ACTIONS(13632),
    [sym__type_order_operator] = ACTIONS(13632),
    [sym__unary_operator] = ACTIONS(13632),
    [sym__unary_plus_operator] = ACTIONS(13632),
    [aux_sym__terminator_token1] = ACTIONS(13632),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13634),
    [sym__command_start] = ACTIONS(13634),
  },
  [8790] = {
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13255),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_RPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13255),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13255),
    [anon_sym_SEMI] = ACTIONS(13255),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13255),
    [anon_sym_isa] = ACTIONS(13255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13255),
    [anon_sym_QMARK] = ACTIONS(13255),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13255),
    [sym__arrow_operator] = ACTIONS(13255),
    [sym__lazy_or_operator] = ACTIONS(13255),
    [sym__lazy_and_operator] = ACTIONS(13255),
    [sym__comparison_operator] = ACTIONS(13255),
    [sym__pipe_right_operator] = ACTIONS(13255),
    [sym__pipe_left_operator] = ACTIONS(13255),
    [sym__ellipsis_operator] = ACTIONS(13255),
    [sym__plus_operator] = ACTIONS(13255),
    [sym__times_operator] = ACTIONS(13255),
    [sym__rational_operator] = ACTIONS(13255),
    [sym__bitshift_operator] = ACTIONS(13255),
    [sym__power_operator] = ACTIONS(13255),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13255),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8791] = {
    [sym__word_identifier] = ACTIONS(13636),
    [anon_sym_EQ] = ACTIONS(13636),
    [anon_sym_COMMA] = ACTIONS(13636),
    [anon_sym_COLON] = ACTIONS(13636),
    [anon_sym_begin] = ACTIONS(13636),
    [anon_sym_module] = ACTIONS(13636),
    [anon_sym_baremodule] = ACTIONS(13636),
    [anon_sym_end] = ACTIONS(13636),
    [anon_sym_abstract] = ACTIONS(13636),
    [anon_sym_primitive] = ACTIONS(13636),
    [anon_sym_mutable] = ACTIONS(13636),
    [anon_sym_struct] = ACTIONS(13636),
    [anon_sym_function] = ACTIONS(13636),
    [anon_sym_macro] = ACTIONS(13636),
    [anon_sym_where] = ACTIONS(13636),
    [anon_sym_quote] = ACTIONS(13636),
    [anon_sym_let] = ACTIONS(13636),
    [anon_sym_if] = ACTIONS(13636),
    [anon_sym_try] = ACTIONS(13636),
    [anon_sym_for] = ACTIONS(13636),
    [anon_sym_while] = ACTIONS(13636),
    [sym_break_statement] = ACTIONS(13636),
    [sym_continue_statement] = ACTIONS(13636),
    [anon_sym_return] = ACTIONS(13636),
    [anon_sym_const] = ACTIONS(13636),
    [anon_sym_global] = ACTIONS(13636),
    [anon_sym_local] = ACTIONS(13636),
    [anon_sym_LPAREN] = ACTIONS(13636),
    [anon_sym_COLON2] = ACTIONS(13636),
    [anon_sym_export] = ACTIONS(13636),
    [anon_sym_import] = ACTIONS(13636),
    [anon_sym_using] = ACTIONS(13636),
    [anon_sym_LBRACK] = ACTIONS(13636),
    [anon_sym_LF] = ACTIONS(13638),
    [anon_sym_in] = ACTIONS(13636),
    [anon_sym_LBRACE] = ACTIONS(13636),
    [anon_sym_DOLLAR] = ACTIONS(13636),
    [anon_sym_COLON_COLON] = ACTIONS(13636),
    [anon_sym_isa] = ACTIONS(13636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13636),
    [anon_sym_QMARK] = ACTIONS(13636),
    [anon_sym_AT] = ACTIONS(13636),
    [anon_sym_true] = ACTIONS(13636),
    [anon_sym_false] = ACTIONS(13636),
    [aux_sym_integer_literal_token1] = ACTIONS(13636),
    [aux_sym_integer_literal_token2] = ACTIONS(13636),
    [aux_sym_integer_literal_token3] = ACTIONS(13636),
    [aux_sym_integer_literal_token4] = ACTIONS(13636),
    [aux_sym_float_literal_token1] = ACTIONS(13636),
    [aux_sym_float_literal_token3] = ACTIONS(13636),
    [aux_sym_float_literal_token4] = ACTIONS(13636),
    [sym_character_literal] = ACTIONS(13636),
    [sym__pair_operator] = ACTIONS(13636),
    [sym__arrow_operator] = ACTIONS(13636),
    [sym__lazy_or_operator] = ACTIONS(13636),
    [sym__lazy_and_operator] = ACTIONS(13636),
    [sym__comparison_operator] = ACTIONS(13636),
    [sym__pipe_right_operator] = ACTIONS(13636),
    [sym__pipe_left_operator] = ACTIONS(13636),
    [sym__ellipsis_operator] = ACTIONS(13636),
    [sym__plus_operator] = ACTIONS(13636),
    [sym__times_operator] = ACTIONS(13636),
    [sym__rational_operator] = ACTIONS(13636),
    [sym__bitshift_operator] = ACTIONS(13636),
    [sym__power_operator] = ACTIONS(13636),
    [sym__tilde_operator] = ACTIONS(13636),
    [sym__type_order_operator] = ACTIONS(13636),
    [sym__unary_operator] = ACTIONS(13636),
    [sym__unary_plus_operator] = ACTIONS(13636),
    [aux_sym__terminator_token1] = ACTIONS(13636),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13638),
    [sym__command_start] = ACTIONS(13638),
  },
  [8792] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_EQ] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_RPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13334),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [8793] = {
    [sym__word_identifier] = ACTIONS(13640),
    [anon_sym_EQ] = ACTIONS(13640),
    [anon_sym_COMMA] = ACTIONS(13640),
    [anon_sym_COLON] = ACTIONS(13640),
    [anon_sym_begin] = ACTIONS(13640),
    [anon_sym_module] = ACTIONS(13640),
    [anon_sym_baremodule] = ACTIONS(13640),
    [anon_sym_end] = ACTIONS(13640),
    [anon_sym_abstract] = ACTIONS(13640),
    [anon_sym_primitive] = ACTIONS(13640),
    [anon_sym_mutable] = ACTIONS(13640),
    [anon_sym_struct] = ACTIONS(13640),
    [anon_sym_function] = ACTIONS(13640),
    [anon_sym_macro] = ACTIONS(13640),
    [anon_sym_where] = ACTIONS(13640),
    [anon_sym_quote] = ACTIONS(13640),
    [anon_sym_let] = ACTIONS(13640),
    [anon_sym_if] = ACTIONS(13640),
    [anon_sym_try] = ACTIONS(13640),
    [anon_sym_for] = ACTIONS(13640),
    [anon_sym_while] = ACTIONS(13640),
    [sym_break_statement] = ACTIONS(13640),
    [sym_continue_statement] = ACTIONS(13640),
    [anon_sym_return] = ACTIONS(13640),
    [anon_sym_const] = ACTIONS(13640),
    [anon_sym_global] = ACTIONS(13640),
    [anon_sym_local] = ACTIONS(13640),
    [anon_sym_LPAREN] = ACTIONS(13640),
    [anon_sym_COLON2] = ACTIONS(13640),
    [anon_sym_export] = ACTIONS(13640),
    [anon_sym_import] = ACTIONS(13640),
    [anon_sym_using] = ACTIONS(13640),
    [anon_sym_LBRACK] = ACTIONS(13640),
    [anon_sym_LF] = ACTIONS(13642),
    [anon_sym_in] = ACTIONS(13640),
    [anon_sym_LBRACE] = ACTIONS(13640),
    [anon_sym_DOLLAR] = ACTIONS(13640),
    [anon_sym_COLON_COLON] = ACTIONS(13640),
    [anon_sym_isa] = ACTIONS(13640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13640),
    [anon_sym_QMARK] = ACTIONS(13640),
    [anon_sym_AT] = ACTIONS(13640),
    [anon_sym_true] = ACTIONS(13640),
    [anon_sym_false] = ACTIONS(13640),
    [aux_sym_integer_literal_token1] = ACTIONS(13640),
    [aux_sym_integer_literal_token2] = ACTIONS(13640),
    [aux_sym_integer_literal_token3] = ACTIONS(13640),
    [aux_sym_integer_literal_token4] = ACTIONS(13640),
    [aux_sym_float_literal_token1] = ACTIONS(13640),
    [aux_sym_float_literal_token3] = ACTIONS(13640),
    [aux_sym_float_literal_token4] = ACTIONS(13640),
    [sym_character_literal] = ACTIONS(13640),
    [sym__pair_operator] = ACTIONS(13640),
    [sym__arrow_operator] = ACTIONS(13640),
    [sym__lazy_or_operator] = ACTIONS(13640),
    [sym__lazy_and_operator] = ACTIONS(13640),
    [sym__comparison_operator] = ACTIONS(13640),
    [sym__pipe_right_operator] = ACTIONS(13640),
    [sym__pipe_left_operator] = ACTIONS(13640),
    [sym__ellipsis_operator] = ACTIONS(13640),
    [sym__plus_operator] = ACTIONS(13640),
    [sym__times_operator] = ACTIONS(13640),
    [sym__rational_operator] = ACTIONS(13640),
    [sym__bitshift_operator] = ACTIONS(13640),
    [sym__power_operator] = ACTIONS(13640),
    [sym__tilde_operator] = ACTIONS(13640),
    [sym__type_order_operator] = ACTIONS(13640),
    [sym__unary_operator] = ACTIONS(13640),
    [sym__unary_plus_operator] = ACTIONS(13640),
    [aux_sym__terminator_token1] = ACTIONS(13640),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13642),
    [sym__command_start] = ACTIONS(13642),
  },
  [8794] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(12714),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_RPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_SEMI] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8795] = {
    [aux_sym_open_tuple_repeat1] = STATE(8581),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(14635),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_RPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14808),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8796] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8797] = {
    [sym__word_identifier] = ACTIONS(13413),
    [anon_sym_EQ] = ACTIONS(13413),
    [anon_sym_COMMA] = ACTIONS(13413),
    [anon_sym_COLON] = ACTIONS(13413),
    [anon_sym_begin] = ACTIONS(13413),
    [anon_sym_module] = ACTIONS(13413),
    [anon_sym_baremodule] = ACTIONS(13413),
    [anon_sym_abstract] = ACTIONS(13413),
    [anon_sym_primitive] = ACTIONS(13413),
    [anon_sym_mutable] = ACTIONS(13413),
    [anon_sym_struct] = ACTIONS(13413),
    [anon_sym_function] = ACTIONS(13413),
    [anon_sym_macro] = ACTIONS(13413),
    [anon_sym_where] = ACTIONS(13413),
    [anon_sym_quote] = ACTIONS(13413),
    [anon_sym_let] = ACTIONS(13413),
    [anon_sym_if] = ACTIONS(13413),
    [anon_sym_try] = ACTIONS(13413),
    [anon_sym_for] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(13413),
    [sym_break_statement] = ACTIONS(13413),
    [sym_continue_statement] = ACTIONS(13413),
    [anon_sym_return] = ACTIONS(13413),
    [anon_sym_const] = ACTIONS(13413),
    [anon_sym_global] = ACTIONS(13413),
    [anon_sym_local] = ACTIONS(13413),
    [anon_sym_LPAREN] = ACTIONS(13413),
    [anon_sym_RPAREN] = ACTIONS(13413),
    [anon_sym_COLON2] = ACTIONS(13413),
    [anon_sym_export] = ACTIONS(13413),
    [anon_sym_import] = ACTIONS(13413),
    [anon_sym_using] = ACTIONS(13413),
    [anon_sym_LBRACK] = ACTIONS(13413),
    [anon_sym_LF] = ACTIONS(13415),
    [anon_sym_in] = ACTIONS(13413),
    [anon_sym_SEMI] = ACTIONS(13413),
    [anon_sym_LBRACE] = ACTIONS(13413),
    [anon_sym_DOLLAR] = ACTIONS(13413),
    [anon_sym_COLON_COLON] = ACTIONS(13413),
    [anon_sym_isa] = ACTIONS(13413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_QMARK] = ACTIONS(13413),
    [anon_sym_AT] = ACTIONS(13413),
    [anon_sym_true] = ACTIONS(13413),
    [anon_sym_false] = ACTIONS(13413),
    [aux_sym_integer_literal_token1] = ACTIONS(13413),
    [aux_sym_integer_literal_token2] = ACTIONS(13413),
    [aux_sym_integer_literal_token3] = ACTIONS(13413),
    [aux_sym_integer_literal_token4] = ACTIONS(13413),
    [aux_sym_float_literal_token1] = ACTIONS(13413),
    [aux_sym_float_literal_token3] = ACTIONS(13413),
    [aux_sym_float_literal_token4] = ACTIONS(13413),
    [sym_character_literal] = ACTIONS(13413),
    [sym__pair_operator] = ACTIONS(13413),
    [sym__arrow_operator] = ACTIONS(13413),
    [sym__lazy_or_operator] = ACTIONS(13413),
    [sym__lazy_and_operator] = ACTIONS(13413),
    [sym__comparison_operator] = ACTIONS(13413),
    [sym__pipe_right_operator] = ACTIONS(13413),
    [sym__pipe_left_operator] = ACTIONS(13413),
    [sym__ellipsis_operator] = ACTIONS(13413),
    [sym__plus_operator] = ACTIONS(13413),
    [sym__times_operator] = ACTIONS(13413),
    [sym__rational_operator] = ACTIONS(13413),
    [sym__bitshift_operator] = ACTIONS(13413),
    [sym__power_operator] = ACTIONS(13413),
    [sym__tilde_operator] = ACTIONS(13413),
    [sym__type_order_operator] = ACTIONS(13413),
    [sym__unary_operator] = ACTIONS(13413),
    [sym__unary_plus_operator] = ACTIONS(13413),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13415),
    [sym__command_start] = ACTIONS(13415),
  },
  [8798] = {
    [sym__word_identifier] = ACTIONS(13417),
    [anon_sym_EQ] = ACTIONS(13417),
    [anon_sym_COMMA] = ACTIONS(13417),
    [anon_sym_COLON] = ACTIONS(13417),
    [anon_sym_begin] = ACTIONS(13417),
    [anon_sym_module] = ACTIONS(13417),
    [anon_sym_baremodule] = ACTIONS(13417),
    [anon_sym_abstract] = ACTIONS(13417),
    [anon_sym_primitive] = ACTIONS(13417),
    [anon_sym_mutable] = ACTIONS(13417),
    [anon_sym_struct] = ACTIONS(13417),
    [anon_sym_function] = ACTIONS(13417),
    [anon_sym_macro] = ACTIONS(13417),
    [anon_sym_where] = ACTIONS(13417),
    [anon_sym_quote] = ACTIONS(13417),
    [anon_sym_let] = ACTIONS(13417),
    [anon_sym_if] = ACTIONS(13417),
    [anon_sym_try] = ACTIONS(13417),
    [anon_sym_for] = ACTIONS(13417),
    [anon_sym_while] = ACTIONS(13417),
    [sym_break_statement] = ACTIONS(13417),
    [sym_continue_statement] = ACTIONS(13417),
    [anon_sym_return] = ACTIONS(13417),
    [anon_sym_const] = ACTIONS(13417),
    [anon_sym_global] = ACTIONS(13417),
    [anon_sym_local] = ACTIONS(13417),
    [anon_sym_LPAREN] = ACTIONS(13417),
    [anon_sym_RPAREN] = ACTIONS(13417),
    [anon_sym_COLON2] = ACTIONS(13417),
    [anon_sym_export] = ACTIONS(13417),
    [anon_sym_import] = ACTIONS(13417),
    [anon_sym_using] = ACTIONS(13417),
    [anon_sym_LBRACK] = ACTIONS(13417),
    [anon_sym_LF] = ACTIONS(13419),
    [anon_sym_in] = ACTIONS(13417),
    [anon_sym_SEMI] = ACTIONS(13417),
    [anon_sym_LBRACE] = ACTIONS(13417),
    [anon_sym_DOLLAR] = ACTIONS(13417),
    [anon_sym_COLON_COLON] = ACTIONS(13417),
    [anon_sym_isa] = ACTIONS(13417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13417),
    [anon_sym_QMARK] = ACTIONS(13417),
    [anon_sym_AT] = ACTIONS(13417),
    [anon_sym_true] = ACTIONS(13417),
    [anon_sym_false] = ACTIONS(13417),
    [aux_sym_integer_literal_token1] = ACTIONS(13417),
    [aux_sym_integer_literal_token2] = ACTIONS(13417),
    [aux_sym_integer_literal_token3] = ACTIONS(13417),
    [aux_sym_integer_literal_token4] = ACTIONS(13417),
    [aux_sym_float_literal_token1] = ACTIONS(13417),
    [aux_sym_float_literal_token3] = ACTIONS(13417),
    [aux_sym_float_literal_token4] = ACTIONS(13417),
    [sym_character_literal] = ACTIONS(13417),
    [sym__pair_operator] = ACTIONS(13417),
    [sym__arrow_operator] = ACTIONS(13417),
    [sym__lazy_or_operator] = ACTIONS(13417),
    [sym__lazy_and_operator] = ACTIONS(13417),
    [sym__comparison_operator] = ACTIONS(13417),
    [sym__pipe_right_operator] = ACTIONS(13417),
    [sym__pipe_left_operator] = ACTIONS(13417),
    [sym__ellipsis_operator] = ACTIONS(13417),
    [sym__plus_operator] = ACTIONS(13417),
    [sym__times_operator] = ACTIONS(13417),
    [sym__rational_operator] = ACTIONS(13417),
    [sym__bitshift_operator] = ACTIONS(13417),
    [sym__power_operator] = ACTIONS(13417),
    [sym__tilde_operator] = ACTIONS(13417),
    [sym__type_order_operator] = ACTIONS(13417),
    [sym__unary_operator] = ACTIONS(13417),
    [sym__unary_plus_operator] = ACTIONS(13417),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13419),
    [sym__command_start] = ACTIONS(13419),
  },
  [8799] = {
    [sym__word_identifier] = ACTIONS(13421),
    [anon_sym_EQ] = ACTIONS(13421),
    [anon_sym_COMMA] = ACTIONS(13421),
    [anon_sym_COLON] = ACTIONS(13421),
    [anon_sym_begin] = ACTIONS(13421),
    [anon_sym_module] = ACTIONS(13421),
    [anon_sym_baremodule] = ACTIONS(13421),
    [anon_sym_abstract] = ACTIONS(13421),
    [anon_sym_primitive] = ACTIONS(13421),
    [anon_sym_mutable] = ACTIONS(13421),
    [anon_sym_struct] = ACTIONS(13421),
    [anon_sym_function] = ACTIONS(13421),
    [anon_sym_macro] = ACTIONS(13421),
    [anon_sym_where] = ACTIONS(13421),
    [anon_sym_quote] = ACTIONS(13421),
    [anon_sym_let] = ACTIONS(13421),
    [anon_sym_if] = ACTIONS(13421),
    [anon_sym_try] = ACTIONS(13421),
    [anon_sym_for] = ACTIONS(13421),
    [anon_sym_while] = ACTIONS(13421),
    [sym_break_statement] = ACTIONS(13421),
    [sym_continue_statement] = ACTIONS(13421),
    [anon_sym_return] = ACTIONS(13421),
    [anon_sym_const] = ACTIONS(13421),
    [anon_sym_global] = ACTIONS(13421),
    [anon_sym_local] = ACTIONS(13421),
    [anon_sym_LPAREN] = ACTIONS(13421),
    [anon_sym_RPAREN] = ACTIONS(13421),
    [anon_sym_COLON2] = ACTIONS(13421),
    [anon_sym_export] = ACTIONS(13421),
    [anon_sym_import] = ACTIONS(13421),
    [anon_sym_using] = ACTIONS(13421),
    [anon_sym_LBRACK] = ACTIONS(13421),
    [anon_sym_LF] = ACTIONS(13423),
    [anon_sym_in] = ACTIONS(13421),
    [anon_sym_SEMI] = ACTIONS(13421),
    [anon_sym_LBRACE] = ACTIONS(13421),
    [anon_sym_DOLLAR] = ACTIONS(13421),
    [anon_sym_COLON_COLON] = ACTIONS(13421),
    [anon_sym_isa] = ACTIONS(13421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13421),
    [anon_sym_QMARK] = ACTIONS(13421),
    [anon_sym_AT] = ACTIONS(13421),
    [anon_sym_true] = ACTIONS(13421),
    [anon_sym_false] = ACTIONS(13421),
    [aux_sym_integer_literal_token1] = ACTIONS(13421),
    [aux_sym_integer_literal_token2] = ACTIONS(13421),
    [aux_sym_integer_literal_token3] = ACTIONS(13421),
    [aux_sym_integer_literal_token4] = ACTIONS(13421),
    [aux_sym_float_literal_token1] = ACTIONS(13421),
    [aux_sym_float_literal_token3] = ACTIONS(13421),
    [aux_sym_float_literal_token4] = ACTIONS(13421),
    [sym_character_literal] = ACTIONS(13421),
    [sym__pair_operator] = ACTIONS(13421),
    [sym__arrow_operator] = ACTIONS(13421),
    [sym__lazy_or_operator] = ACTIONS(13421),
    [sym__lazy_and_operator] = ACTIONS(13421),
    [sym__comparison_operator] = ACTIONS(13421),
    [sym__pipe_right_operator] = ACTIONS(13421),
    [sym__pipe_left_operator] = ACTIONS(13421),
    [sym__ellipsis_operator] = ACTIONS(13421),
    [sym__plus_operator] = ACTIONS(13421),
    [sym__times_operator] = ACTIONS(13421),
    [sym__rational_operator] = ACTIONS(13421),
    [sym__bitshift_operator] = ACTIONS(13421),
    [sym__power_operator] = ACTIONS(13421),
    [sym__tilde_operator] = ACTIONS(13421),
    [sym__type_order_operator] = ACTIONS(13421),
    [sym__unary_operator] = ACTIONS(13421),
    [sym__unary_plus_operator] = ACTIONS(13421),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13423),
    [sym__command_start] = ACTIONS(13423),
  },
  [8800] = {
    [sym__word_identifier] = ACTIONS(13425),
    [anon_sym_EQ] = ACTIONS(13425),
    [anon_sym_COMMA] = ACTIONS(13425),
    [anon_sym_COLON] = ACTIONS(13425),
    [anon_sym_begin] = ACTIONS(13425),
    [anon_sym_module] = ACTIONS(13425),
    [anon_sym_baremodule] = ACTIONS(13425),
    [anon_sym_abstract] = ACTIONS(13425),
    [anon_sym_primitive] = ACTIONS(13425),
    [anon_sym_mutable] = ACTIONS(13425),
    [anon_sym_struct] = ACTIONS(13425),
    [anon_sym_function] = ACTIONS(13425),
    [anon_sym_macro] = ACTIONS(13425),
    [anon_sym_where] = ACTIONS(13425),
    [anon_sym_quote] = ACTIONS(13425),
    [anon_sym_let] = ACTIONS(13425),
    [anon_sym_if] = ACTIONS(13425),
    [anon_sym_try] = ACTIONS(13425),
    [anon_sym_for] = ACTIONS(13425),
    [anon_sym_while] = ACTIONS(13425),
    [sym_break_statement] = ACTIONS(13425),
    [sym_continue_statement] = ACTIONS(13425),
    [anon_sym_return] = ACTIONS(13425),
    [anon_sym_const] = ACTIONS(13425),
    [anon_sym_global] = ACTIONS(13425),
    [anon_sym_local] = ACTIONS(13425),
    [anon_sym_LPAREN] = ACTIONS(13425),
    [anon_sym_RPAREN] = ACTIONS(13425),
    [anon_sym_COLON2] = ACTIONS(13425),
    [anon_sym_export] = ACTIONS(13425),
    [anon_sym_import] = ACTIONS(13425),
    [anon_sym_using] = ACTIONS(13425),
    [anon_sym_LBRACK] = ACTIONS(13425),
    [anon_sym_LF] = ACTIONS(13427),
    [anon_sym_in] = ACTIONS(13425),
    [anon_sym_SEMI] = ACTIONS(13425),
    [anon_sym_LBRACE] = ACTIONS(13425),
    [anon_sym_DOLLAR] = ACTIONS(13425),
    [anon_sym_COLON_COLON] = ACTIONS(13425),
    [anon_sym_isa] = ACTIONS(13425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13425),
    [anon_sym_QMARK] = ACTIONS(13425),
    [anon_sym_AT] = ACTIONS(13425),
    [anon_sym_true] = ACTIONS(13425),
    [anon_sym_false] = ACTIONS(13425),
    [aux_sym_integer_literal_token1] = ACTIONS(13425),
    [aux_sym_integer_literal_token2] = ACTIONS(13425),
    [aux_sym_integer_literal_token3] = ACTIONS(13425),
    [aux_sym_integer_literal_token4] = ACTIONS(13425),
    [aux_sym_float_literal_token1] = ACTIONS(13425),
    [aux_sym_float_literal_token3] = ACTIONS(13425),
    [aux_sym_float_literal_token4] = ACTIONS(13425),
    [sym_character_literal] = ACTIONS(13425),
    [sym__pair_operator] = ACTIONS(13425),
    [sym__arrow_operator] = ACTIONS(13425),
    [sym__lazy_or_operator] = ACTIONS(13425),
    [sym__lazy_and_operator] = ACTIONS(13425),
    [sym__comparison_operator] = ACTIONS(13425),
    [sym__pipe_right_operator] = ACTIONS(13425),
    [sym__pipe_left_operator] = ACTIONS(13425),
    [sym__ellipsis_operator] = ACTIONS(13425),
    [sym__plus_operator] = ACTIONS(13425),
    [sym__times_operator] = ACTIONS(13425),
    [sym__rational_operator] = ACTIONS(13425),
    [sym__bitshift_operator] = ACTIONS(13425),
    [sym__power_operator] = ACTIONS(13425),
    [sym__tilde_operator] = ACTIONS(13425),
    [sym__type_order_operator] = ACTIONS(13425),
    [sym__unary_operator] = ACTIONS(13425),
    [sym__unary_plus_operator] = ACTIONS(13425),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13427),
    [sym__command_start] = ACTIONS(13427),
  },
  [8801] = {
    [sym__word_identifier] = ACTIONS(13429),
    [anon_sym_EQ] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(13429),
    [anon_sym_COLON] = ACTIONS(13429),
    [anon_sym_begin] = ACTIONS(13429),
    [anon_sym_module] = ACTIONS(13429),
    [anon_sym_baremodule] = ACTIONS(13429),
    [anon_sym_abstract] = ACTIONS(13429),
    [anon_sym_primitive] = ACTIONS(13429),
    [anon_sym_mutable] = ACTIONS(13429),
    [anon_sym_struct] = ACTIONS(13429),
    [anon_sym_function] = ACTIONS(13429),
    [anon_sym_macro] = ACTIONS(13429),
    [anon_sym_where] = ACTIONS(13429),
    [anon_sym_quote] = ACTIONS(13429),
    [anon_sym_let] = ACTIONS(13429),
    [anon_sym_if] = ACTIONS(13429),
    [anon_sym_try] = ACTIONS(13429),
    [anon_sym_for] = ACTIONS(13429),
    [anon_sym_while] = ACTIONS(13429),
    [sym_break_statement] = ACTIONS(13429),
    [sym_continue_statement] = ACTIONS(13429),
    [anon_sym_return] = ACTIONS(13429),
    [anon_sym_const] = ACTIONS(13429),
    [anon_sym_global] = ACTIONS(13429),
    [anon_sym_local] = ACTIONS(13429),
    [anon_sym_LPAREN] = ACTIONS(13429),
    [anon_sym_RPAREN] = ACTIONS(13429),
    [anon_sym_COLON2] = ACTIONS(13429),
    [anon_sym_export] = ACTIONS(13429),
    [anon_sym_import] = ACTIONS(13429),
    [anon_sym_using] = ACTIONS(13429),
    [anon_sym_LBRACK] = ACTIONS(13429),
    [anon_sym_LF] = ACTIONS(13431),
    [anon_sym_in] = ACTIONS(13429),
    [anon_sym_SEMI] = ACTIONS(13429),
    [anon_sym_LBRACE] = ACTIONS(13429),
    [anon_sym_DOLLAR] = ACTIONS(13429),
    [anon_sym_COLON_COLON] = ACTIONS(13429),
    [anon_sym_isa] = ACTIONS(13429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13429),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_AT] = ACTIONS(13429),
    [anon_sym_true] = ACTIONS(13429),
    [anon_sym_false] = ACTIONS(13429),
    [aux_sym_integer_literal_token1] = ACTIONS(13429),
    [aux_sym_integer_literal_token2] = ACTIONS(13429),
    [aux_sym_integer_literal_token3] = ACTIONS(13429),
    [aux_sym_integer_literal_token4] = ACTIONS(13429),
    [aux_sym_float_literal_token1] = ACTIONS(13429),
    [aux_sym_float_literal_token3] = ACTIONS(13429),
    [aux_sym_float_literal_token4] = ACTIONS(13429),
    [sym_character_literal] = ACTIONS(13429),
    [sym__pair_operator] = ACTIONS(13429),
    [sym__arrow_operator] = ACTIONS(13429),
    [sym__lazy_or_operator] = ACTIONS(13429),
    [sym__lazy_and_operator] = ACTIONS(13429),
    [sym__comparison_operator] = ACTIONS(13429),
    [sym__pipe_right_operator] = ACTIONS(13429),
    [sym__pipe_left_operator] = ACTIONS(13429),
    [sym__ellipsis_operator] = ACTIONS(13429),
    [sym__plus_operator] = ACTIONS(13429),
    [sym__times_operator] = ACTIONS(13429),
    [sym__rational_operator] = ACTIONS(13429),
    [sym__bitshift_operator] = ACTIONS(13429),
    [sym__power_operator] = ACTIONS(13429),
    [sym__tilde_operator] = ACTIONS(13429),
    [sym__type_order_operator] = ACTIONS(13429),
    [sym__unary_operator] = ACTIONS(13429),
    [sym__unary_plus_operator] = ACTIONS(13429),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13431),
    [sym__command_start] = ACTIONS(13431),
  },
  [8802] = {
    [sym__word_identifier] = ACTIONS(13433),
    [anon_sym_EQ] = ACTIONS(13433),
    [anon_sym_COMMA] = ACTIONS(13433),
    [anon_sym_COLON] = ACTIONS(13433),
    [anon_sym_begin] = ACTIONS(13433),
    [anon_sym_module] = ACTIONS(13433),
    [anon_sym_baremodule] = ACTIONS(13433),
    [anon_sym_abstract] = ACTIONS(13433),
    [anon_sym_primitive] = ACTIONS(13433),
    [anon_sym_mutable] = ACTIONS(13433),
    [anon_sym_struct] = ACTIONS(13433),
    [anon_sym_function] = ACTIONS(13433),
    [anon_sym_macro] = ACTIONS(13433),
    [anon_sym_where] = ACTIONS(13433),
    [anon_sym_quote] = ACTIONS(13433),
    [anon_sym_let] = ACTIONS(13433),
    [anon_sym_if] = ACTIONS(13433),
    [anon_sym_try] = ACTIONS(13433),
    [anon_sym_for] = ACTIONS(13433),
    [anon_sym_while] = ACTIONS(13433),
    [sym_break_statement] = ACTIONS(13433),
    [sym_continue_statement] = ACTIONS(13433),
    [anon_sym_return] = ACTIONS(13433),
    [anon_sym_const] = ACTIONS(13433),
    [anon_sym_global] = ACTIONS(13433),
    [anon_sym_local] = ACTIONS(13433),
    [anon_sym_LPAREN] = ACTIONS(13433),
    [anon_sym_RPAREN] = ACTIONS(13433),
    [anon_sym_COLON2] = ACTIONS(13433),
    [anon_sym_export] = ACTIONS(13433),
    [anon_sym_import] = ACTIONS(13433),
    [anon_sym_using] = ACTIONS(13433),
    [anon_sym_LBRACK] = ACTIONS(13433),
    [anon_sym_LF] = ACTIONS(13435),
    [anon_sym_in] = ACTIONS(13433),
    [anon_sym_SEMI] = ACTIONS(13433),
    [anon_sym_LBRACE] = ACTIONS(13433),
    [anon_sym_DOLLAR] = ACTIONS(13433),
    [anon_sym_COLON_COLON] = ACTIONS(13433),
    [anon_sym_isa] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13433),
    [anon_sym_QMARK] = ACTIONS(13433),
    [anon_sym_AT] = ACTIONS(13433),
    [anon_sym_true] = ACTIONS(13433),
    [anon_sym_false] = ACTIONS(13433),
    [aux_sym_integer_literal_token1] = ACTIONS(13433),
    [aux_sym_integer_literal_token2] = ACTIONS(13433),
    [aux_sym_integer_literal_token3] = ACTIONS(13433),
    [aux_sym_integer_literal_token4] = ACTIONS(13433),
    [aux_sym_float_literal_token1] = ACTIONS(13433),
    [aux_sym_float_literal_token3] = ACTIONS(13433),
    [aux_sym_float_literal_token4] = ACTIONS(13433),
    [sym_character_literal] = ACTIONS(13433),
    [sym__pair_operator] = ACTIONS(13433),
    [sym__arrow_operator] = ACTIONS(13433),
    [sym__lazy_or_operator] = ACTIONS(13433),
    [sym__lazy_and_operator] = ACTIONS(13433),
    [sym__comparison_operator] = ACTIONS(13433),
    [sym__pipe_right_operator] = ACTIONS(13433),
    [sym__pipe_left_operator] = ACTIONS(13433),
    [sym__ellipsis_operator] = ACTIONS(13433),
    [sym__plus_operator] = ACTIONS(13433),
    [sym__times_operator] = ACTIONS(13433),
    [sym__rational_operator] = ACTIONS(13433),
    [sym__bitshift_operator] = ACTIONS(13433),
    [sym__power_operator] = ACTIONS(13433),
    [sym__tilde_operator] = ACTIONS(13433),
    [sym__type_order_operator] = ACTIONS(13433),
    [sym__unary_operator] = ACTIONS(13433),
    [sym__unary_plus_operator] = ACTIONS(13433),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13435),
    [sym__command_start] = ACTIONS(13435),
  },
  [8803] = {
    [sym__word_identifier] = ACTIONS(13437),
    [anon_sym_EQ] = ACTIONS(13437),
    [anon_sym_COMMA] = ACTIONS(13437),
    [anon_sym_COLON] = ACTIONS(13437),
    [anon_sym_begin] = ACTIONS(13437),
    [anon_sym_module] = ACTIONS(13437),
    [anon_sym_baremodule] = ACTIONS(13437),
    [anon_sym_abstract] = ACTIONS(13437),
    [anon_sym_primitive] = ACTIONS(13437),
    [anon_sym_mutable] = ACTIONS(13437),
    [anon_sym_struct] = ACTIONS(13437),
    [anon_sym_function] = ACTIONS(13437),
    [anon_sym_macro] = ACTIONS(13437),
    [anon_sym_where] = ACTIONS(13437),
    [anon_sym_quote] = ACTIONS(13437),
    [anon_sym_let] = ACTIONS(13437),
    [anon_sym_if] = ACTIONS(13437),
    [anon_sym_try] = ACTIONS(13437),
    [anon_sym_for] = ACTIONS(13437),
    [anon_sym_while] = ACTIONS(13437),
    [sym_break_statement] = ACTIONS(13437),
    [sym_continue_statement] = ACTIONS(13437),
    [anon_sym_return] = ACTIONS(13437),
    [anon_sym_const] = ACTIONS(13437),
    [anon_sym_global] = ACTIONS(13437),
    [anon_sym_local] = ACTIONS(13437),
    [anon_sym_LPAREN] = ACTIONS(13437),
    [anon_sym_RPAREN] = ACTIONS(13437),
    [anon_sym_COLON2] = ACTIONS(13437),
    [anon_sym_export] = ACTIONS(13437),
    [anon_sym_import] = ACTIONS(13437),
    [anon_sym_using] = ACTIONS(13437),
    [anon_sym_LBRACK] = ACTIONS(13437),
    [anon_sym_LF] = ACTIONS(13439),
    [anon_sym_in] = ACTIONS(13437),
    [anon_sym_SEMI] = ACTIONS(13437),
    [anon_sym_LBRACE] = ACTIONS(13437),
    [anon_sym_DOLLAR] = ACTIONS(13437),
    [anon_sym_COLON_COLON] = ACTIONS(13437),
    [anon_sym_isa] = ACTIONS(13437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13437),
    [anon_sym_QMARK] = ACTIONS(13437),
    [anon_sym_AT] = ACTIONS(13437),
    [anon_sym_true] = ACTIONS(13437),
    [anon_sym_false] = ACTIONS(13437),
    [aux_sym_integer_literal_token1] = ACTIONS(13437),
    [aux_sym_integer_literal_token2] = ACTIONS(13437),
    [aux_sym_integer_literal_token3] = ACTIONS(13437),
    [aux_sym_integer_literal_token4] = ACTIONS(13437),
    [aux_sym_float_literal_token1] = ACTIONS(13437),
    [aux_sym_float_literal_token3] = ACTIONS(13437),
    [aux_sym_float_literal_token4] = ACTIONS(13437),
    [sym_character_literal] = ACTIONS(13437),
    [sym__pair_operator] = ACTIONS(13437),
    [sym__arrow_operator] = ACTIONS(13437),
    [sym__lazy_or_operator] = ACTIONS(13437),
    [sym__lazy_and_operator] = ACTIONS(13437),
    [sym__comparison_operator] = ACTIONS(13437),
    [sym__pipe_right_operator] = ACTIONS(13437),
    [sym__pipe_left_operator] = ACTIONS(13437),
    [sym__ellipsis_operator] = ACTIONS(13437),
    [sym__plus_operator] = ACTIONS(13437),
    [sym__times_operator] = ACTIONS(13437),
    [sym__rational_operator] = ACTIONS(13437),
    [sym__bitshift_operator] = ACTIONS(13437),
    [sym__power_operator] = ACTIONS(13437),
    [sym__tilde_operator] = ACTIONS(13437),
    [sym__type_order_operator] = ACTIONS(13437),
    [sym__unary_operator] = ACTIONS(13437),
    [sym__unary_plus_operator] = ACTIONS(13437),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13439),
    [sym__command_start] = ACTIONS(13439),
  },
  [8804] = {
    [sym__word_identifier] = ACTIONS(13441),
    [anon_sym_EQ] = ACTIONS(13441),
    [anon_sym_COMMA] = ACTIONS(13441),
    [anon_sym_COLON] = ACTIONS(13441),
    [anon_sym_begin] = ACTIONS(13441),
    [anon_sym_module] = ACTIONS(13441),
    [anon_sym_baremodule] = ACTIONS(13441),
    [anon_sym_abstract] = ACTIONS(13441),
    [anon_sym_primitive] = ACTIONS(13441),
    [anon_sym_mutable] = ACTIONS(13441),
    [anon_sym_struct] = ACTIONS(13441),
    [anon_sym_function] = ACTIONS(13441),
    [anon_sym_macro] = ACTIONS(13441),
    [anon_sym_where] = ACTIONS(13441),
    [anon_sym_quote] = ACTIONS(13441),
    [anon_sym_let] = ACTIONS(13441),
    [anon_sym_if] = ACTIONS(13441),
    [anon_sym_try] = ACTIONS(13441),
    [anon_sym_for] = ACTIONS(13441),
    [anon_sym_while] = ACTIONS(13441),
    [sym_break_statement] = ACTIONS(13441),
    [sym_continue_statement] = ACTIONS(13441),
    [anon_sym_return] = ACTIONS(13441),
    [anon_sym_const] = ACTIONS(13441),
    [anon_sym_global] = ACTIONS(13441),
    [anon_sym_local] = ACTIONS(13441),
    [anon_sym_LPAREN] = ACTIONS(13441),
    [anon_sym_RPAREN] = ACTIONS(13441),
    [anon_sym_COLON2] = ACTIONS(13441),
    [anon_sym_export] = ACTIONS(13441),
    [anon_sym_import] = ACTIONS(13441),
    [anon_sym_using] = ACTIONS(13441),
    [anon_sym_LBRACK] = ACTIONS(13441),
    [anon_sym_LF] = ACTIONS(13443),
    [anon_sym_in] = ACTIONS(13441),
    [anon_sym_SEMI] = ACTIONS(13441),
    [anon_sym_LBRACE] = ACTIONS(13441),
    [anon_sym_DOLLAR] = ACTIONS(13441),
    [anon_sym_COLON_COLON] = ACTIONS(13441),
    [anon_sym_isa] = ACTIONS(13441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13441),
    [anon_sym_QMARK] = ACTIONS(13441),
    [anon_sym_AT] = ACTIONS(13441),
    [anon_sym_true] = ACTIONS(13441),
    [anon_sym_false] = ACTIONS(13441),
    [aux_sym_integer_literal_token1] = ACTIONS(13441),
    [aux_sym_integer_literal_token2] = ACTIONS(13441),
    [aux_sym_integer_literal_token3] = ACTIONS(13441),
    [aux_sym_integer_literal_token4] = ACTIONS(13441),
    [aux_sym_float_literal_token1] = ACTIONS(13441),
    [aux_sym_float_literal_token3] = ACTIONS(13441),
    [aux_sym_float_literal_token4] = ACTIONS(13441),
    [sym_character_literal] = ACTIONS(13441),
    [sym__pair_operator] = ACTIONS(13441),
    [sym__arrow_operator] = ACTIONS(13441),
    [sym__lazy_or_operator] = ACTIONS(13441),
    [sym__lazy_and_operator] = ACTIONS(13441),
    [sym__comparison_operator] = ACTIONS(13441),
    [sym__pipe_right_operator] = ACTIONS(13441),
    [sym__pipe_left_operator] = ACTIONS(13441),
    [sym__ellipsis_operator] = ACTIONS(13441),
    [sym__plus_operator] = ACTIONS(13441),
    [sym__times_operator] = ACTIONS(13441),
    [sym__rational_operator] = ACTIONS(13441),
    [sym__bitshift_operator] = ACTIONS(13441),
    [sym__power_operator] = ACTIONS(13441),
    [sym__tilde_operator] = ACTIONS(13441),
    [sym__type_order_operator] = ACTIONS(13441),
    [sym__unary_operator] = ACTIONS(13441),
    [sym__unary_plus_operator] = ACTIONS(13441),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13443),
    [sym__command_start] = ACTIONS(13443),
  },
  [8805] = {
    [sym__word_identifier] = ACTIONS(13445),
    [anon_sym_EQ] = ACTIONS(13445),
    [anon_sym_COMMA] = ACTIONS(13445),
    [anon_sym_COLON] = ACTIONS(13445),
    [anon_sym_begin] = ACTIONS(13445),
    [anon_sym_module] = ACTIONS(13445),
    [anon_sym_baremodule] = ACTIONS(13445),
    [anon_sym_abstract] = ACTIONS(13445),
    [anon_sym_primitive] = ACTIONS(13445),
    [anon_sym_mutable] = ACTIONS(13445),
    [anon_sym_struct] = ACTIONS(13445),
    [anon_sym_function] = ACTIONS(13445),
    [anon_sym_macro] = ACTIONS(13445),
    [anon_sym_where] = ACTIONS(13445),
    [anon_sym_quote] = ACTIONS(13445),
    [anon_sym_let] = ACTIONS(13445),
    [anon_sym_if] = ACTIONS(13445),
    [anon_sym_try] = ACTIONS(13445),
    [anon_sym_for] = ACTIONS(13445),
    [anon_sym_while] = ACTIONS(13445),
    [sym_break_statement] = ACTIONS(13445),
    [sym_continue_statement] = ACTIONS(13445),
    [anon_sym_return] = ACTIONS(13445),
    [anon_sym_const] = ACTIONS(13445),
    [anon_sym_global] = ACTIONS(13445),
    [anon_sym_local] = ACTIONS(13445),
    [anon_sym_LPAREN] = ACTIONS(13445),
    [anon_sym_RPAREN] = ACTIONS(13445),
    [anon_sym_COLON2] = ACTIONS(13445),
    [anon_sym_export] = ACTIONS(13445),
    [anon_sym_import] = ACTIONS(13445),
    [anon_sym_using] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(13445),
    [anon_sym_LF] = ACTIONS(13447),
    [anon_sym_in] = ACTIONS(13445),
    [anon_sym_SEMI] = ACTIONS(13445),
    [anon_sym_LBRACE] = ACTIONS(13445),
    [anon_sym_DOLLAR] = ACTIONS(13445),
    [anon_sym_COLON_COLON] = ACTIONS(13445),
    [anon_sym_isa] = ACTIONS(13445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13445),
    [anon_sym_QMARK] = ACTIONS(13445),
    [anon_sym_AT] = ACTIONS(13445),
    [anon_sym_true] = ACTIONS(13445),
    [anon_sym_false] = ACTIONS(13445),
    [aux_sym_integer_literal_token1] = ACTIONS(13445),
    [aux_sym_integer_literal_token2] = ACTIONS(13445),
    [aux_sym_integer_literal_token3] = ACTIONS(13445),
    [aux_sym_integer_literal_token4] = ACTIONS(13445),
    [aux_sym_float_literal_token1] = ACTIONS(13445),
    [aux_sym_float_literal_token3] = ACTIONS(13445),
    [aux_sym_float_literal_token4] = ACTIONS(13445),
    [sym_character_literal] = ACTIONS(13445),
    [sym__pair_operator] = ACTIONS(13445),
    [sym__arrow_operator] = ACTIONS(13445),
    [sym__lazy_or_operator] = ACTIONS(13445),
    [sym__lazy_and_operator] = ACTIONS(13445),
    [sym__comparison_operator] = ACTIONS(13445),
    [sym__pipe_right_operator] = ACTIONS(13445),
    [sym__pipe_left_operator] = ACTIONS(13445),
    [sym__ellipsis_operator] = ACTIONS(13445),
    [sym__plus_operator] = ACTIONS(13445),
    [sym__times_operator] = ACTIONS(13445),
    [sym__rational_operator] = ACTIONS(13445),
    [sym__bitshift_operator] = ACTIONS(13445),
    [sym__power_operator] = ACTIONS(13445),
    [sym__tilde_operator] = ACTIONS(13445),
    [sym__type_order_operator] = ACTIONS(13445),
    [sym__unary_operator] = ACTIONS(13445),
    [sym__unary_plus_operator] = ACTIONS(13445),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13447),
    [sym__command_start] = ACTIONS(13447),
  },
  [8806] = {
    [sym__word_identifier] = ACTIONS(13449),
    [anon_sym_EQ] = ACTIONS(13449),
    [anon_sym_COMMA] = ACTIONS(13449),
    [anon_sym_COLON] = ACTIONS(13449),
    [anon_sym_begin] = ACTIONS(13449),
    [anon_sym_module] = ACTIONS(13449),
    [anon_sym_baremodule] = ACTIONS(13449),
    [anon_sym_abstract] = ACTIONS(13449),
    [anon_sym_primitive] = ACTIONS(13449),
    [anon_sym_mutable] = ACTIONS(13449),
    [anon_sym_struct] = ACTIONS(13449),
    [anon_sym_function] = ACTIONS(13449),
    [anon_sym_macro] = ACTIONS(13449),
    [anon_sym_where] = ACTIONS(13449),
    [anon_sym_quote] = ACTIONS(13449),
    [anon_sym_let] = ACTIONS(13449),
    [anon_sym_if] = ACTIONS(13449),
    [anon_sym_try] = ACTIONS(13449),
    [anon_sym_for] = ACTIONS(13449),
    [anon_sym_while] = ACTIONS(13449),
    [sym_break_statement] = ACTIONS(13449),
    [sym_continue_statement] = ACTIONS(13449),
    [anon_sym_return] = ACTIONS(13449),
    [anon_sym_const] = ACTIONS(13449),
    [anon_sym_global] = ACTIONS(13449),
    [anon_sym_local] = ACTIONS(13449),
    [anon_sym_LPAREN] = ACTIONS(13449),
    [anon_sym_RPAREN] = ACTIONS(13449),
    [anon_sym_COLON2] = ACTIONS(13449),
    [anon_sym_export] = ACTIONS(13449),
    [anon_sym_import] = ACTIONS(13449),
    [anon_sym_using] = ACTIONS(13449),
    [anon_sym_LBRACK] = ACTIONS(13449),
    [anon_sym_LF] = ACTIONS(13451),
    [anon_sym_in] = ACTIONS(13449),
    [anon_sym_SEMI] = ACTIONS(13449),
    [anon_sym_LBRACE] = ACTIONS(13449),
    [anon_sym_DOLLAR] = ACTIONS(13449),
    [anon_sym_COLON_COLON] = ACTIONS(13449),
    [anon_sym_isa] = ACTIONS(13449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13449),
    [anon_sym_QMARK] = ACTIONS(13449),
    [anon_sym_AT] = ACTIONS(13449),
    [anon_sym_true] = ACTIONS(13449),
    [anon_sym_false] = ACTIONS(13449),
    [aux_sym_integer_literal_token1] = ACTIONS(13449),
    [aux_sym_integer_literal_token2] = ACTIONS(13449),
    [aux_sym_integer_literal_token3] = ACTIONS(13449),
    [aux_sym_integer_literal_token4] = ACTIONS(13449),
    [aux_sym_float_literal_token1] = ACTIONS(13449),
    [aux_sym_float_literal_token3] = ACTIONS(13449),
    [aux_sym_float_literal_token4] = ACTIONS(13449),
    [sym_character_literal] = ACTIONS(13449),
    [sym__pair_operator] = ACTIONS(13449),
    [sym__arrow_operator] = ACTIONS(13449),
    [sym__lazy_or_operator] = ACTIONS(13449),
    [sym__lazy_and_operator] = ACTIONS(13449),
    [sym__comparison_operator] = ACTIONS(13449),
    [sym__pipe_right_operator] = ACTIONS(13449),
    [sym__pipe_left_operator] = ACTIONS(13449),
    [sym__ellipsis_operator] = ACTIONS(13449),
    [sym__plus_operator] = ACTIONS(13449),
    [sym__times_operator] = ACTIONS(13449),
    [sym__rational_operator] = ACTIONS(13449),
    [sym__bitshift_operator] = ACTIONS(13449),
    [sym__power_operator] = ACTIONS(13449),
    [sym__tilde_operator] = ACTIONS(13449),
    [sym__type_order_operator] = ACTIONS(13449),
    [sym__unary_operator] = ACTIONS(13449),
    [sym__unary_plus_operator] = ACTIONS(13449),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13451),
    [sym__command_start] = ACTIONS(13451),
  },
  [8807] = {
    [sym__word_identifier] = ACTIONS(13453),
    [anon_sym_EQ] = ACTIONS(13453),
    [anon_sym_COMMA] = ACTIONS(13453),
    [anon_sym_COLON] = ACTIONS(13453),
    [anon_sym_begin] = ACTIONS(13453),
    [anon_sym_module] = ACTIONS(13453),
    [anon_sym_baremodule] = ACTIONS(13453),
    [anon_sym_abstract] = ACTIONS(13453),
    [anon_sym_primitive] = ACTIONS(13453),
    [anon_sym_mutable] = ACTIONS(13453),
    [anon_sym_struct] = ACTIONS(13453),
    [anon_sym_function] = ACTIONS(13453),
    [anon_sym_macro] = ACTIONS(13453),
    [anon_sym_where] = ACTIONS(13453),
    [anon_sym_quote] = ACTIONS(13453),
    [anon_sym_let] = ACTIONS(13453),
    [anon_sym_if] = ACTIONS(13453),
    [anon_sym_try] = ACTIONS(13453),
    [anon_sym_for] = ACTIONS(13453),
    [anon_sym_while] = ACTIONS(13453),
    [sym_break_statement] = ACTIONS(13453),
    [sym_continue_statement] = ACTIONS(13453),
    [anon_sym_return] = ACTIONS(13453),
    [anon_sym_const] = ACTIONS(13453),
    [anon_sym_global] = ACTIONS(13453),
    [anon_sym_local] = ACTIONS(13453),
    [anon_sym_LPAREN] = ACTIONS(13453),
    [anon_sym_RPAREN] = ACTIONS(13453),
    [anon_sym_COLON2] = ACTIONS(13453),
    [anon_sym_export] = ACTIONS(13453),
    [anon_sym_import] = ACTIONS(13453),
    [anon_sym_using] = ACTIONS(13453),
    [anon_sym_LBRACK] = ACTIONS(13453),
    [anon_sym_LF] = ACTIONS(13455),
    [anon_sym_in] = ACTIONS(13453),
    [anon_sym_SEMI] = ACTIONS(13453),
    [anon_sym_LBRACE] = ACTIONS(13453),
    [anon_sym_DOLLAR] = ACTIONS(13453),
    [anon_sym_COLON_COLON] = ACTIONS(13453),
    [anon_sym_isa] = ACTIONS(13453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13453),
    [anon_sym_QMARK] = ACTIONS(13453),
    [anon_sym_AT] = ACTIONS(13453),
    [anon_sym_true] = ACTIONS(13453),
    [anon_sym_false] = ACTIONS(13453),
    [aux_sym_integer_literal_token1] = ACTIONS(13453),
    [aux_sym_integer_literal_token2] = ACTIONS(13453),
    [aux_sym_integer_literal_token3] = ACTIONS(13453),
    [aux_sym_integer_literal_token4] = ACTIONS(13453),
    [aux_sym_float_literal_token1] = ACTIONS(13453),
    [aux_sym_float_literal_token3] = ACTIONS(13453),
    [aux_sym_float_literal_token4] = ACTIONS(13453),
    [sym_character_literal] = ACTIONS(13453),
    [sym__pair_operator] = ACTIONS(13453),
    [sym__arrow_operator] = ACTIONS(13453),
    [sym__lazy_or_operator] = ACTIONS(13453),
    [sym__lazy_and_operator] = ACTIONS(13453),
    [sym__comparison_operator] = ACTIONS(13453),
    [sym__pipe_right_operator] = ACTIONS(13453),
    [sym__pipe_left_operator] = ACTIONS(13453),
    [sym__ellipsis_operator] = ACTIONS(13453),
    [sym__plus_operator] = ACTIONS(13453),
    [sym__times_operator] = ACTIONS(13453),
    [sym__rational_operator] = ACTIONS(13453),
    [sym__bitshift_operator] = ACTIONS(13453),
    [sym__power_operator] = ACTIONS(13453),
    [sym__tilde_operator] = ACTIONS(13453),
    [sym__type_order_operator] = ACTIONS(13453),
    [sym__unary_operator] = ACTIONS(13453),
    [sym__unary_plus_operator] = ACTIONS(13453),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13455),
    [sym__command_start] = ACTIONS(13455),
  },
  [8808] = {
    [sym__word_identifier] = ACTIONS(13457),
    [anon_sym_EQ] = ACTIONS(13457),
    [anon_sym_COMMA] = ACTIONS(13457),
    [anon_sym_COLON] = ACTIONS(13457),
    [anon_sym_begin] = ACTIONS(13457),
    [anon_sym_module] = ACTIONS(13457),
    [anon_sym_baremodule] = ACTIONS(13457),
    [anon_sym_abstract] = ACTIONS(13457),
    [anon_sym_primitive] = ACTIONS(13457),
    [anon_sym_mutable] = ACTIONS(13457),
    [anon_sym_struct] = ACTIONS(13457),
    [anon_sym_function] = ACTIONS(13457),
    [anon_sym_macro] = ACTIONS(13457),
    [anon_sym_where] = ACTIONS(13457),
    [anon_sym_quote] = ACTIONS(13457),
    [anon_sym_let] = ACTIONS(13457),
    [anon_sym_if] = ACTIONS(13457),
    [anon_sym_try] = ACTIONS(13457),
    [anon_sym_for] = ACTIONS(13457),
    [anon_sym_while] = ACTIONS(13457),
    [sym_break_statement] = ACTIONS(13457),
    [sym_continue_statement] = ACTIONS(13457),
    [anon_sym_return] = ACTIONS(13457),
    [anon_sym_const] = ACTIONS(13457),
    [anon_sym_global] = ACTIONS(13457),
    [anon_sym_local] = ACTIONS(13457),
    [anon_sym_LPAREN] = ACTIONS(13457),
    [anon_sym_RPAREN] = ACTIONS(13457),
    [anon_sym_COLON2] = ACTIONS(13457),
    [anon_sym_export] = ACTIONS(13457),
    [anon_sym_import] = ACTIONS(13457),
    [anon_sym_using] = ACTIONS(13457),
    [anon_sym_LBRACK] = ACTIONS(13457),
    [anon_sym_LF] = ACTIONS(13459),
    [anon_sym_in] = ACTIONS(13457),
    [anon_sym_SEMI] = ACTIONS(13457),
    [anon_sym_LBRACE] = ACTIONS(13457),
    [anon_sym_DOLLAR] = ACTIONS(13457),
    [anon_sym_COLON_COLON] = ACTIONS(13457),
    [anon_sym_isa] = ACTIONS(13457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13457),
    [anon_sym_QMARK] = ACTIONS(13457),
    [anon_sym_AT] = ACTIONS(13457),
    [anon_sym_true] = ACTIONS(13457),
    [anon_sym_false] = ACTIONS(13457),
    [aux_sym_integer_literal_token1] = ACTIONS(13457),
    [aux_sym_integer_literal_token2] = ACTIONS(13457),
    [aux_sym_integer_literal_token3] = ACTIONS(13457),
    [aux_sym_integer_literal_token4] = ACTIONS(13457),
    [aux_sym_float_literal_token1] = ACTIONS(13457),
    [aux_sym_float_literal_token3] = ACTIONS(13457),
    [aux_sym_float_literal_token4] = ACTIONS(13457),
    [sym_character_literal] = ACTIONS(13457),
    [sym__pair_operator] = ACTIONS(13457),
    [sym__arrow_operator] = ACTIONS(13457),
    [sym__lazy_or_operator] = ACTIONS(13457),
    [sym__lazy_and_operator] = ACTIONS(13457),
    [sym__comparison_operator] = ACTIONS(13457),
    [sym__pipe_right_operator] = ACTIONS(13457),
    [sym__pipe_left_operator] = ACTIONS(13457),
    [sym__ellipsis_operator] = ACTIONS(13457),
    [sym__plus_operator] = ACTIONS(13457),
    [sym__times_operator] = ACTIONS(13457),
    [sym__rational_operator] = ACTIONS(13457),
    [sym__bitshift_operator] = ACTIONS(13457),
    [sym__power_operator] = ACTIONS(13457),
    [sym__tilde_operator] = ACTIONS(13457),
    [sym__type_order_operator] = ACTIONS(13457),
    [sym__unary_operator] = ACTIONS(13457),
    [sym__unary_plus_operator] = ACTIONS(13457),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13459),
    [sym__command_start] = ACTIONS(13459),
  },
  [8809] = {
    [sym__word_identifier] = ACTIONS(13461),
    [anon_sym_EQ] = ACTIONS(13461),
    [anon_sym_COMMA] = ACTIONS(13461),
    [anon_sym_COLON] = ACTIONS(13461),
    [anon_sym_begin] = ACTIONS(13461),
    [anon_sym_module] = ACTIONS(13461),
    [anon_sym_baremodule] = ACTIONS(13461),
    [anon_sym_abstract] = ACTIONS(13461),
    [anon_sym_primitive] = ACTIONS(13461),
    [anon_sym_mutable] = ACTIONS(13461),
    [anon_sym_struct] = ACTIONS(13461),
    [anon_sym_function] = ACTIONS(13461),
    [anon_sym_macro] = ACTIONS(13461),
    [anon_sym_where] = ACTIONS(13461),
    [anon_sym_quote] = ACTIONS(13461),
    [anon_sym_let] = ACTIONS(13461),
    [anon_sym_if] = ACTIONS(13461),
    [anon_sym_try] = ACTIONS(13461),
    [anon_sym_for] = ACTIONS(13461),
    [anon_sym_while] = ACTIONS(13461),
    [sym_break_statement] = ACTIONS(13461),
    [sym_continue_statement] = ACTIONS(13461),
    [anon_sym_return] = ACTIONS(13461),
    [anon_sym_const] = ACTIONS(13461),
    [anon_sym_global] = ACTIONS(13461),
    [anon_sym_local] = ACTIONS(13461),
    [anon_sym_LPAREN] = ACTIONS(13461),
    [anon_sym_RPAREN] = ACTIONS(13461),
    [anon_sym_COLON2] = ACTIONS(13461),
    [anon_sym_export] = ACTIONS(13461),
    [anon_sym_import] = ACTIONS(13461),
    [anon_sym_using] = ACTIONS(13461),
    [anon_sym_LBRACK] = ACTIONS(13461),
    [anon_sym_LF] = ACTIONS(13463),
    [anon_sym_in] = ACTIONS(13461),
    [anon_sym_SEMI] = ACTIONS(13461),
    [anon_sym_LBRACE] = ACTIONS(13461),
    [anon_sym_DOLLAR] = ACTIONS(13461),
    [anon_sym_COLON_COLON] = ACTIONS(13461),
    [anon_sym_isa] = ACTIONS(13461),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13461),
    [anon_sym_QMARK] = ACTIONS(13461),
    [anon_sym_AT] = ACTIONS(13461),
    [anon_sym_true] = ACTIONS(13461),
    [anon_sym_false] = ACTIONS(13461),
    [aux_sym_integer_literal_token1] = ACTIONS(13461),
    [aux_sym_integer_literal_token2] = ACTIONS(13461),
    [aux_sym_integer_literal_token3] = ACTIONS(13461),
    [aux_sym_integer_literal_token4] = ACTIONS(13461),
    [aux_sym_float_literal_token1] = ACTIONS(13461),
    [aux_sym_float_literal_token3] = ACTIONS(13461),
    [aux_sym_float_literal_token4] = ACTIONS(13461),
    [sym_character_literal] = ACTIONS(13461),
    [sym__pair_operator] = ACTIONS(13461),
    [sym__arrow_operator] = ACTIONS(13461),
    [sym__lazy_or_operator] = ACTIONS(13461),
    [sym__lazy_and_operator] = ACTIONS(13461),
    [sym__comparison_operator] = ACTIONS(13461),
    [sym__pipe_right_operator] = ACTIONS(13461),
    [sym__pipe_left_operator] = ACTIONS(13461),
    [sym__ellipsis_operator] = ACTIONS(13461),
    [sym__plus_operator] = ACTIONS(13461),
    [sym__times_operator] = ACTIONS(13461),
    [sym__rational_operator] = ACTIONS(13461),
    [sym__bitshift_operator] = ACTIONS(13461),
    [sym__power_operator] = ACTIONS(13461),
    [sym__tilde_operator] = ACTIONS(13461),
    [sym__type_order_operator] = ACTIONS(13461),
    [sym__unary_operator] = ACTIONS(13461),
    [sym__unary_plus_operator] = ACTIONS(13461),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13463),
    [sym__command_start] = ACTIONS(13463),
  },
  [8810] = {
    [sym__word_identifier] = ACTIONS(13481),
    [anon_sym_EQ] = ACTIONS(13481),
    [anon_sym_COMMA] = ACTIONS(13481),
    [anon_sym_COLON] = ACTIONS(13481),
    [anon_sym_begin] = ACTIONS(13481),
    [anon_sym_module] = ACTIONS(13481),
    [anon_sym_baremodule] = ACTIONS(13481),
    [anon_sym_abstract] = ACTIONS(13481),
    [anon_sym_primitive] = ACTIONS(13481),
    [anon_sym_mutable] = ACTIONS(13481),
    [anon_sym_struct] = ACTIONS(13481),
    [anon_sym_function] = ACTIONS(13481),
    [anon_sym_macro] = ACTIONS(13481),
    [anon_sym_where] = ACTIONS(13481),
    [anon_sym_quote] = ACTIONS(13481),
    [anon_sym_let] = ACTIONS(13481),
    [anon_sym_if] = ACTIONS(13481),
    [anon_sym_try] = ACTIONS(13481),
    [anon_sym_for] = ACTIONS(13481),
    [anon_sym_while] = ACTIONS(13481),
    [sym_break_statement] = ACTIONS(13481),
    [sym_continue_statement] = ACTIONS(13481),
    [anon_sym_return] = ACTIONS(13481),
    [anon_sym_const] = ACTIONS(13481),
    [anon_sym_global] = ACTIONS(13481),
    [anon_sym_local] = ACTIONS(13481),
    [anon_sym_LPAREN] = ACTIONS(13481),
    [anon_sym_RPAREN] = ACTIONS(13481),
    [anon_sym_COLON2] = ACTIONS(13481),
    [anon_sym_export] = ACTIONS(13481),
    [anon_sym_import] = ACTIONS(13481),
    [anon_sym_using] = ACTIONS(13481),
    [anon_sym_LBRACK] = ACTIONS(13481),
    [anon_sym_LF] = ACTIONS(13483),
    [anon_sym_in] = ACTIONS(13481),
    [anon_sym_SEMI] = ACTIONS(13481),
    [anon_sym_LBRACE] = ACTIONS(13481),
    [anon_sym_DOLLAR] = ACTIONS(13481),
    [anon_sym_COLON_COLON] = ACTIONS(13481),
    [anon_sym_isa] = ACTIONS(13481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13481),
    [anon_sym_QMARK] = ACTIONS(13481),
    [anon_sym_AT] = ACTIONS(13481),
    [anon_sym_true] = ACTIONS(13481),
    [anon_sym_false] = ACTIONS(13481),
    [aux_sym_integer_literal_token1] = ACTIONS(13481),
    [aux_sym_integer_literal_token2] = ACTIONS(13481),
    [aux_sym_integer_literal_token3] = ACTIONS(13481),
    [aux_sym_integer_literal_token4] = ACTIONS(13481),
    [aux_sym_float_literal_token1] = ACTIONS(13481),
    [aux_sym_float_literal_token3] = ACTIONS(13481),
    [aux_sym_float_literal_token4] = ACTIONS(13481),
    [sym_character_literal] = ACTIONS(13481),
    [sym__pair_operator] = ACTIONS(13481),
    [sym__arrow_operator] = ACTIONS(13481),
    [sym__lazy_or_operator] = ACTIONS(13481),
    [sym__lazy_and_operator] = ACTIONS(13481),
    [sym__comparison_operator] = ACTIONS(13481),
    [sym__pipe_right_operator] = ACTIONS(13481),
    [sym__pipe_left_operator] = ACTIONS(13481),
    [sym__ellipsis_operator] = ACTIONS(13481),
    [sym__plus_operator] = ACTIONS(13481),
    [sym__times_operator] = ACTIONS(13481),
    [sym__rational_operator] = ACTIONS(13481),
    [sym__bitshift_operator] = ACTIONS(13481),
    [sym__power_operator] = ACTIONS(13481),
    [sym__tilde_operator] = ACTIONS(13481),
    [sym__type_order_operator] = ACTIONS(13481),
    [sym__unary_operator] = ACTIONS(13481),
    [sym__unary_plus_operator] = ACTIONS(13481),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13483),
    [sym__command_start] = ACTIONS(13483),
  },
  [8811] = {
    [sym__word_identifier] = ACTIONS(13485),
    [anon_sym_EQ] = ACTIONS(13485),
    [anon_sym_COMMA] = ACTIONS(13485),
    [anon_sym_COLON] = ACTIONS(13485),
    [anon_sym_begin] = ACTIONS(13485),
    [anon_sym_module] = ACTIONS(13485),
    [anon_sym_baremodule] = ACTIONS(13485),
    [anon_sym_abstract] = ACTIONS(13485),
    [anon_sym_primitive] = ACTIONS(13485),
    [anon_sym_mutable] = ACTIONS(13485),
    [anon_sym_struct] = ACTIONS(13485),
    [anon_sym_function] = ACTIONS(13485),
    [anon_sym_macro] = ACTIONS(13485),
    [anon_sym_where] = ACTIONS(13485),
    [anon_sym_quote] = ACTIONS(13485),
    [anon_sym_let] = ACTIONS(13485),
    [anon_sym_if] = ACTIONS(13485),
    [anon_sym_try] = ACTIONS(13485),
    [anon_sym_for] = ACTIONS(13485),
    [anon_sym_while] = ACTIONS(13485),
    [sym_break_statement] = ACTIONS(13485),
    [sym_continue_statement] = ACTIONS(13485),
    [anon_sym_return] = ACTIONS(13485),
    [anon_sym_const] = ACTIONS(13485),
    [anon_sym_global] = ACTIONS(13485),
    [anon_sym_local] = ACTIONS(13485),
    [anon_sym_LPAREN] = ACTIONS(13485),
    [anon_sym_RPAREN] = ACTIONS(13485),
    [anon_sym_COLON2] = ACTIONS(13485),
    [anon_sym_export] = ACTIONS(13485),
    [anon_sym_import] = ACTIONS(13485),
    [anon_sym_using] = ACTIONS(13485),
    [anon_sym_LBRACK] = ACTIONS(13485),
    [anon_sym_LF] = ACTIONS(13487),
    [anon_sym_in] = ACTIONS(13485),
    [anon_sym_SEMI] = ACTIONS(13485),
    [anon_sym_LBRACE] = ACTIONS(13485),
    [anon_sym_DOLLAR] = ACTIONS(13485),
    [anon_sym_COLON_COLON] = ACTIONS(13485),
    [anon_sym_isa] = ACTIONS(13485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13485),
    [anon_sym_QMARK] = ACTIONS(13485),
    [anon_sym_AT] = ACTIONS(13485),
    [anon_sym_true] = ACTIONS(13485),
    [anon_sym_false] = ACTIONS(13485),
    [aux_sym_integer_literal_token1] = ACTIONS(13485),
    [aux_sym_integer_literal_token2] = ACTIONS(13485),
    [aux_sym_integer_literal_token3] = ACTIONS(13485),
    [aux_sym_integer_literal_token4] = ACTIONS(13485),
    [aux_sym_float_literal_token1] = ACTIONS(13485),
    [aux_sym_float_literal_token3] = ACTIONS(13485),
    [aux_sym_float_literal_token4] = ACTIONS(13485),
    [sym_character_literal] = ACTIONS(13485),
    [sym__pair_operator] = ACTIONS(13485),
    [sym__arrow_operator] = ACTIONS(13485),
    [sym__lazy_or_operator] = ACTIONS(13485),
    [sym__lazy_and_operator] = ACTIONS(13485),
    [sym__comparison_operator] = ACTIONS(13485),
    [sym__pipe_right_operator] = ACTIONS(13485),
    [sym__pipe_left_operator] = ACTIONS(13485),
    [sym__ellipsis_operator] = ACTIONS(13485),
    [sym__plus_operator] = ACTIONS(13485),
    [sym__times_operator] = ACTIONS(13485),
    [sym__rational_operator] = ACTIONS(13485),
    [sym__bitshift_operator] = ACTIONS(13485),
    [sym__power_operator] = ACTIONS(13485),
    [sym__tilde_operator] = ACTIONS(13485),
    [sym__type_order_operator] = ACTIONS(13485),
    [sym__unary_operator] = ACTIONS(13485),
    [sym__unary_plus_operator] = ACTIONS(13485),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13487),
    [sym__command_start] = ACTIONS(13487),
  },
  [8812] = {
    [sym__word_identifier] = ACTIONS(13644),
    [anon_sym_EQ] = ACTIONS(13644),
    [anon_sym_COMMA] = ACTIONS(13644),
    [anon_sym_COLON] = ACTIONS(13644),
    [anon_sym_begin] = ACTIONS(13644),
    [anon_sym_module] = ACTIONS(13644),
    [anon_sym_baremodule] = ACTIONS(13644),
    [anon_sym_end] = ACTIONS(13644),
    [anon_sym_abstract] = ACTIONS(13644),
    [anon_sym_primitive] = ACTIONS(13644),
    [anon_sym_mutable] = ACTIONS(13644),
    [anon_sym_struct] = ACTIONS(13644),
    [anon_sym_function] = ACTIONS(13644),
    [anon_sym_macro] = ACTIONS(13644),
    [anon_sym_where] = ACTIONS(13644),
    [anon_sym_quote] = ACTIONS(13644),
    [anon_sym_let] = ACTIONS(13644),
    [anon_sym_if] = ACTIONS(13644),
    [anon_sym_try] = ACTIONS(13644),
    [anon_sym_for] = ACTIONS(13644),
    [anon_sym_while] = ACTIONS(13644),
    [sym_break_statement] = ACTIONS(13644),
    [sym_continue_statement] = ACTIONS(13644),
    [anon_sym_return] = ACTIONS(13644),
    [anon_sym_const] = ACTIONS(13644),
    [anon_sym_global] = ACTIONS(13644),
    [anon_sym_local] = ACTIONS(13644),
    [anon_sym_LPAREN] = ACTIONS(13644),
    [anon_sym_COLON2] = ACTIONS(13644),
    [anon_sym_export] = ACTIONS(13644),
    [anon_sym_import] = ACTIONS(13644),
    [anon_sym_using] = ACTIONS(13644),
    [anon_sym_LBRACK] = ACTIONS(13644),
    [anon_sym_LF] = ACTIONS(13646),
    [anon_sym_in] = ACTIONS(13644),
    [anon_sym_LBRACE] = ACTIONS(13644),
    [anon_sym_DOLLAR] = ACTIONS(13644),
    [anon_sym_COLON_COLON] = ACTIONS(13644),
    [anon_sym_isa] = ACTIONS(13644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13644),
    [anon_sym_QMARK] = ACTIONS(13644),
    [anon_sym_AT] = ACTIONS(13644),
    [anon_sym_true] = ACTIONS(13644),
    [anon_sym_false] = ACTIONS(13644),
    [aux_sym_integer_literal_token1] = ACTIONS(13644),
    [aux_sym_integer_literal_token2] = ACTIONS(13644),
    [aux_sym_integer_literal_token3] = ACTIONS(13644),
    [aux_sym_integer_literal_token4] = ACTIONS(13644),
    [aux_sym_float_literal_token1] = ACTIONS(13644),
    [aux_sym_float_literal_token3] = ACTIONS(13644),
    [aux_sym_float_literal_token4] = ACTIONS(13644),
    [sym_character_literal] = ACTIONS(13644),
    [sym__pair_operator] = ACTIONS(13644),
    [sym__arrow_operator] = ACTIONS(13644),
    [sym__lazy_or_operator] = ACTIONS(13644),
    [sym__lazy_and_operator] = ACTIONS(13644),
    [sym__comparison_operator] = ACTIONS(13644),
    [sym__pipe_right_operator] = ACTIONS(13644),
    [sym__pipe_left_operator] = ACTIONS(13644),
    [sym__ellipsis_operator] = ACTIONS(13644),
    [sym__plus_operator] = ACTIONS(13644),
    [sym__times_operator] = ACTIONS(13644),
    [sym__rational_operator] = ACTIONS(13644),
    [sym__bitshift_operator] = ACTIONS(13644),
    [sym__power_operator] = ACTIONS(13644),
    [sym__tilde_operator] = ACTIONS(13644),
    [sym__type_order_operator] = ACTIONS(13644),
    [sym__unary_operator] = ACTIONS(13644),
    [sym__unary_plus_operator] = ACTIONS(13644),
    [aux_sym__terminator_token1] = ACTIONS(13644),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13646),
    [sym__command_start] = ACTIONS(13646),
  },
  [8813] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_EQ] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_RPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_SEMI] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [8814] = {
    [sym__word_identifier] = ACTIONS(13648),
    [anon_sym_EQ] = ACTIONS(13648),
    [anon_sym_COMMA] = ACTIONS(13648),
    [anon_sym_COLON] = ACTIONS(13648),
    [anon_sym_begin] = ACTIONS(13648),
    [anon_sym_module] = ACTIONS(13648),
    [anon_sym_baremodule] = ACTIONS(13648),
    [anon_sym_end] = ACTIONS(13648),
    [anon_sym_abstract] = ACTIONS(13648),
    [anon_sym_primitive] = ACTIONS(13648),
    [anon_sym_mutable] = ACTIONS(13648),
    [anon_sym_struct] = ACTIONS(13648),
    [anon_sym_function] = ACTIONS(13648),
    [anon_sym_macro] = ACTIONS(13648),
    [anon_sym_where] = ACTIONS(13648),
    [anon_sym_quote] = ACTIONS(13648),
    [anon_sym_let] = ACTIONS(13648),
    [anon_sym_if] = ACTIONS(13648),
    [anon_sym_try] = ACTIONS(13648),
    [anon_sym_for] = ACTIONS(13648),
    [anon_sym_while] = ACTIONS(13648),
    [sym_break_statement] = ACTIONS(13648),
    [sym_continue_statement] = ACTIONS(13648),
    [anon_sym_return] = ACTIONS(13648),
    [anon_sym_const] = ACTIONS(13648),
    [anon_sym_global] = ACTIONS(13648),
    [anon_sym_local] = ACTIONS(13648),
    [anon_sym_LPAREN] = ACTIONS(13648),
    [anon_sym_COLON2] = ACTIONS(13648),
    [anon_sym_export] = ACTIONS(13648),
    [anon_sym_import] = ACTIONS(13648),
    [anon_sym_using] = ACTIONS(13648),
    [anon_sym_LBRACK] = ACTIONS(13648),
    [anon_sym_LF] = ACTIONS(13650),
    [anon_sym_in] = ACTIONS(13648),
    [anon_sym_LBRACE] = ACTIONS(13648),
    [anon_sym_DOLLAR] = ACTIONS(13648),
    [anon_sym_COLON_COLON] = ACTIONS(13648),
    [anon_sym_isa] = ACTIONS(13648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13648),
    [anon_sym_QMARK] = ACTIONS(13648),
    [anon_sym_AT] = ACTIONS(13648),
    [anon_sym_true] = ACTIONS(13648),
    [anon_sym_false] = ACTIONS(13648),
    [aux_sym_integer_literal_token1] = ACTIONS(13648),
    [aux_sym_integer_literal_token2] = ACTIONS(13648),
    [aux_sym_integer_literal_token3] = ACTIONS(13648),
    [aux_sym_integer_literal_token4] = ACTIONS(13648),
    [aux_sym_float_literal_token1] = ACTIONS(13648),
    [aux_sym_float_literal_token3] = ACTIONS(13648),
    [aux_sym_float_literal_token4] = ACTIONS(13648),
    [sym_character_literal] = ACTIONS(13648),
    [sym__pair_operator] = ACTIONS(13648),
    [sym__arrow_operator] = ACTIONS(13648),
    [sym__lazy_or_operator] = ACTIONS(13648),
    [sym__lazy_and_operator] = ACTIONS(13648),
    [sym__comparison_operator] = ACTIONS(13648),
    [sym__pipe_right_operator] = ACTIONS(13648),
    [sym__pipe_left_operator] = ACTIONS(13648),
    [sym__ellipsis_operator] = ACTIONS(13648),
    [sym__plus_operator] = ACTIONS(13648),
    [sym__times_operator] = ACTIONS(13648),
    [sym__rational_operator] = ACTIONS(13648),
    [sym__bitshift_operator] = ACTIONS(13648),
    [sym__power_operator] = ACTIONS(13648),
    [sym__tilde_operator] = ACTIONS(13648),
    [sym__type_order_operator] = ACTIONS(13648),
    [sym__unary_operator] = ACTIONS(13648),
    [sym__unary_plus_operator] = ACTIONS(13648),
    [aux_sym__terminator_token1] = ACTIONS(13648),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13650),
    [sym__command_start] = ACTIONS(13650),
  },
  [8815] = {
    [sym__word_identifier] = ACTIONS(13652),
    [anon_sym_EQ] = ACTIONS(13652),
    [anon_sym_COMMA] = ACTIONS(13652),
    [anon_sym_COLON] = ACTIONS(13652),
    [anon_sym_begin] = ACTIONS(13652),
    [anon_sym_module] = ACTIONS(13652),
    [anon_sym_baremodule] = ACTIONS(13652),
    [anon_sym_end] = ACTIONS(13652),
    [anon_sym_abstract] = ACTIONS(13652),
    [anon_sym_primitive] = ACTIONS(13652),
    [anon_sym_mutable] = ACTIONS(13652),
    [anon_sym_struct] = ACTIONS(13652),
    [anon_sym_function] = ACTIONS(13652),
    [anon_sym_macro] = ACTIONS(13652),
    [anon_sym_where] = ACTIONS(13652),
    [anon_sym_quote] = ACTIONS(13652),
    [anon_sym_let] = ACTIONS(13652),
    [anon_sym_if] = ACTIONS(13652),
    [anon_sym_try] = ACTIONS(13652),
    [anon_sym_for] = ACTIONS(13652),
    [anon_sym_while] = ACTIONS(13652),
    [sym_break_statement] = ACTIONS(13652),
    [sym_continue_statement] = ACTIONS(13652),
    [anon_sym_return] = ACTIONS(13652),
    [anon_sym_const] = ACTIONS(13652),
    [anon_sym_global] = ACTIONS(13652),
    [anon_sym_local] = ACTIONS(13652),
    [anon_sym_LPAREN] = ACTIONS(13652),
    [anon_sym_COLON2] = ACTIONS(13652),
    [anon_sym_export] = ACTIONS(13652),
    [anon_sym_import] = ACTIONS(13652),
    [anon_sym_using] = ACTIONS(13652),
    [anon_sym_LBRACK] = ACTIONS(13652),
    [anon_sym_LF] = ACTIONS(13654),
    [anon_sym_in] = ACTIONS(13652),
    [anon_sym_LBRACE] = ACTIONS(13652),
    [anon_sym_DOLLAR] = ACTIONS(13652),
    [anon_sym_COLON_COLON] = ACTIONS(13652),
    [anon_sym_isa] = ACTIONS(13652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13652),
    [anon_sym_QMARK] = ACTIONS(13652),
    [anon_sym_AT] = ACTIONS(13652),
    [anon_sym_true] = ACTIONS(13652),
    [anon_sym_false] = ACTIONS(13652),
    [aux_sym_integer_literal_token1] = ACTIONS(13652),
    [aux_sym_integer_literal_token2] = ACTIONS(13652),
    [aux_sym_integer_literal_token3] = ACTIONS(13652),
    [aux_sym_integer_literal_token4] = ACTIONS(13652),
    [aux_sym_float_literal_token1] = ACTIONS(13652),
    [aux_sym_float_literal_token3] = ACTIONS(13652),
    [aux_sym_float_literal_token4] = ACTIONS(13652),
    [sym_character_literal] = ACTIONS(13652),
    [sym__pair_operator] = ACTIONS(13652),
    [sym__arrow_operator] = ACTIONS(13652),
    [sym__lazy_or_operator] = ACTIONS(13652),
    [sym__lazy_and_operator] = ACTIONS(13652),
    [sym__comparison_operator] = ACTIONS(13652),
    [sym__pipe_right_operator] = ACTIONS(13652),
    [sym__pipe_left_operator] = ACTIONS(13652),
    [sym__ellipsis_operator] = ACTIONS(13652),
    [sym__plus_operator] = ACTIONS(13652),
    [sym__times_operator] = ACTIONS(13652),
    [sym__rational_operator] = ACTIONS(13652),
    [sym__bitshift_operator] = ACTIONS(13652),
    [sym__power_operator] = ACTIONS(13652),
    [sym__tilde_operator] = ACTIONS(13652),
    [sym__type_order_operator] = ACTIONS(13652),
    [sym__unary_operator] = ACTIONS(13652),
    [sym__unary_plus_operator] = ACTIONS(13652),
    [aux_sym__terminator_token1] = ACTIONS(13652),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13654),
    [sym__command_start] = ACTIONS(13654),
  },
  [8816] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8817] = {
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(12974),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_RPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_SEMI] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [8818] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14754),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8819] = {
    [aux_sym_open_tuple_repeat1] = STATE(8581),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(14635),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_RPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14808),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8820] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_RPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_SEMI] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8821] = {
    [sym__word_identifier] = ACTIONS(13378),
    [anon_sym_EQ] = ACTIONS(13378),
    [anon_sym_COMMA] = ACTIONS(13378),
    [anon_sym_COLON] = ACTIONS(13378),
    [anon_sym_begin] = ACTIONS(13378),
    [anon_sym_module] = ACTIONS(13378),
    [anon_sym_baremodule] = ACTIONS(13378),
    [anon_sym_end] = ACTIONS(13378),
    [anon_sym_abstract] = ACTIONS(13378),
    [anon_sym_primitive] = ACTIONS(13378),
    [anon_sym_mutable] = ACTIONS(13378),
    [anon_sym_struct] = ACTIONS(13378),
    [anon_sym_function] = ACTIONS(13378),
    [anon_sym_macro] = ACTIONS(13378),
    [anon_sym_where] = ACTIONS(13378),
    [anon_sym_quote] = ACTIONS(13378),
    [anon_sym_let] = ACTIONS(13378),
    [anon_sym_if] = ACTIONS(13378),
    [anon_sym_try] = ACTIONS(13378),
    [anon_sym_for] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(13378),
    [sym_break_statement] = ACTIONS(13378),
    [sym_continue_statement] = ACTIONS(13378),
    [anon_sym_return] = ACTIONS(13378),
    [anon_sym_const] = ACTIONS(13378),
    [anon_sym_global] = ACTIONS(13378),
    [anon_sym_local] = ACTIONS(13378),
    [anon_sym_LPAREN] = ACTIONS(13378),
    [anon_sym_COLON2] = ACTIONS(13378),
    [anon_sym_export] = ACTIONS(13378),
    [anon_sym_import] = ACTIONS(13378),
    [anon_sym_using] = ACTIONS(13378),
    [anon_sym_LBRACK] = ACTIONS(13378),
    [anon_sym_LF] = ACTIONS(13380),
    [anon_sym_in] = ACTIONS(13378),
    [anon_sym_LBRACE] = ACTIONS(13378),
    [anon_sym_DOLLAR] = ACTIONS(13378),
    [anon_sym_COLON_COLON] = ACTIONS(13378),
    [anon_sym_isa] = ACTIONS(13378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13378),
    [anon_sym_QMARK] = ACTIONS(13378),
    [anon_sym_AT] = ACTIONS(13378),
    [anon_sym_true] = ACTIONS(13378),
    [anon_sym_false] = ACTIONS(13378),
    [aux_sym_integer_literal_token1] = ACTIONS(13378),
    [aux_sym_integer_literal_token2] = ACTIONS(13378),
    [aux_sym_integer_literal_token3] = ACTIONS(13378),
    [aux_sym_integer_literal_token4] = ACTIONS(13378),
    [aux_sym_float_literal_token1] = ACTIONS(13378),
    [aux_sym_float_literal_token3] = ACTIONS(13378),
    [aux_sym_float_literal_token4] = ACTIONS(13378),
    [sym_character_literal] = ACTIONS(13378),
    [sym__pair_operator] = ACTIONS(13378),
    [sym__arrow_operator] = ACTIONS(13378),
    [sym__lazy_or_operator] = ACTIONS(13378),
    [sym__lazy_and_operator] = ACTIONS(13378),
    [sym__comparison_operator] = ACTIONS(13378),
    [sym__pipe_right_operator] = ACTIONS(13378),
    [sym__pipe_left_operator] = ACTIONS(13378),
    [sym__ellipsis_operator] = ACTIONS(13378),
    [sym__plus_operator] = ACTIONS(13378),
    [sym__times_operator] = ACTIONS(13378),
    [sym__rational_operator] = ACTIONS(13378),
    [sym__bitshift_operator] = ACTIONS(13378),
    [sym__power_operator] = ACTIONS(13378),
    [sym__tilde_operator] = ACTIONS(13378),
    [sym__type_order_operator] = ACTIONS(13378),
    [sym__unary_operator] = ACTIONS(13378),
    [sym__unary_plus_operator] = ACTIONS(13378),
    [aux_sym__terminator_token1] = ACTIONS(13378),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13380),
    [sym__command_start] = ACTIONS(13380),
  },
  [8822] = {
    [sym__word_identifier] = ACTIONS(13382),
    [anon_sym_EQ] = ACTIONS(13382),
    [anon_sym_COMMA] = ACTIONS(13382),
    [anon_sym_COLON] = ACTIONS(13382),
    [anon_sym_begin] = ACTIONS(13382),
    [anon_sym_module] = ACTIONS(13382),
    [anon_sym_baremodule] = ACTIONS(13382),
    [anon_sym_end] = ACTIONS(13382),
    [anon_sym_abstract] = ACTIONS(13382),
    [anon_sym_primitive] = ACTIONS(13382),
    [anon_sym_mutable] = ACTIONS(13382),
    [anon_sym_struct] = ACTIONS(13382),
    [anon_sym_function] = ACTIONS(13382),
    [anon_sym_macro] = ACTIONS(13382),
    [anon_sym_where] = ACTIONS(13382),
    [anon_sym_quote] = ACTIONS(13382),
    [anon_sym_let] = ACTIONS(13382),
    [anon_sym_if] = ACTIONS(13382),
    [anon_sym_try] = ACTIONS(13382),
    [anon_sym_for] = ACTIONS(13382),
    [anon_sym_while] = ACTIONS(13382),
    [sym_break_statement] = ACTIONS(13382),
    [sym_continue_statement] = ACTIONS(13382),
    [anon_sym_return] = ACTIONS(13382),
    [anon_sym_const] = ACTIONS(13382),
    [anon_sym_global] = ACTIONS(13382),
    [anon_sym_local] = ACTIONS(13382),
    [anon_sym_LPAREN] = ACTIONS(13382),
    [anon_sym_COLON2] = ACTIONS(13382),
    [anon_sym_export] = ACTIONS(13382),
    [anon_sym_import] = ACTIONS(13382),
    [anon_sym_using] = ACTIONS(13382),
    [anon_sym_LBRACK] = ACTIONS(13382),
    [anon_sym_LF] = ACTIONS(13384),
    [anon_sym_in] = ACTIONS(13382),
    [anon_sym_LBRACE] = ACTIONS(13382),
    [anon_sym_DOLLAR] = ACTIONS(13382),
    [anon_sym_COLON_COLON] = ACTIONS(13382),
    [anon_sym_isa] = ACTIONS(13382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13382),
    [anon_sym_QMARK] = ACTIONS(13382),
    [anon_sym_AT] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(13382),
    [anon_sym_false] = ACTIONS(13382),
    [aux_sym_integer_literal_token1] = ACTIONS(13382),
    [aux_sym_integer_literal_token2] = ACTIONS(13382),
    [aux_sym_integer_literal_token3] = ACTIONS(13382),
    [aux_sym_integer_literal_token4] = ACTIONS(13382),
    [aux_sym_float_literal_token1] = ACTIONS(13382),
    [aux_sym_float_literal_token3] = ACTIONS(13382),
    [aux_sym_float_literal_token4] = ACTIONS(13382),
    [sym_character_literal] = ACTIONS(13382),
    [sym__pair_operator] = ACTIONS(13382),
    [sym__arrow_operator] = ACTIONS(13382),
    [sym__lazy_or_operator] = ACTIONS(13382),
    [sym__lazy_and_operator] = ACTIONS(13382),
    [sym__comparison_operator] = ACTIONS(13382),
    [sym__pipe_right_operator] = ACTIONS(13382),
    [sym__pipe_left_operator] = ACTIONS(13382),
    [sym__ellipsis_operator] = ACTIONS(13382),
    [sym__plus_operator] = ACTIONS(13382),
    [sym__times_operator] = ACTIONS(13382),
    [sym__rational_operator] = ACTIONS(13382),
    [sym__bitshift_operator] = ACTIONS(13382),
    [sym__power_operator] = ACTIONS(13382),
    [sym__tilde_operator] = ACTIONS(13382),
    [sym__type_order_operator] = ACTIONS(13382),
    [sym__unary_operator] = ACTIONS(13382),
    [sym__unary_plus_operator] = ACTIONS(13382),
    [aux_sym__terminator_token1] = ACTIONS(13382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13384),
    [sym__command_start] = ACTIONS(13384),
  },
  [8823] = {
    [sym__word_identifier] = ACTIONS(13489),
    [anon_sym_EQ] = ACTIONS(13489),
    [anon_sym_COMMA] = ACTIONS(13489),
    [anon_sym_COLON] = ACTIONS(13489),
    [anon_sym_begin] = ACTIONS(13489),
    [anon_sym_module] = ACTIONS(13489),
    [anon_sym_baremodule] = ACTIONS(13489),
    [anon_sym_abstract] = ACTIONS(13489),
    [anon_sym_primitive] = ACTIONS(13489),
    [anon_sym_mutable] = ACTIONS(13489),
    [anon_sym_struct] = ACTIONS(13489),
    [anon_sym_function] = ACTIONS(13489),
    [anon_sym_macro] = ACTIONS(13489),
    [anon_sym_where] = ACTIONS(13489),
    [anon_sym_quote] = ACTIONS(13489),
    [anon_sym_let] = ACTIONS(13489),
    [anon_sym_if] = ACTIONS(13489),
    [anon_sym_try] = ACTIONS(13489),
    [anon_sym_for] = ACTIONS(13489),
    [anon_sym_while] = ACTIONS(13489),
    [sym_break_statement] = ACTIONS(13489),
    [sym_continue_statement] = ACTIONS(13489),
    [anon_sym_return] = ACTIONS(13489),
    [anon_sym_const] = ACTIONS(13489),
    [anon_sym_global] = ACTIONS(13489),
    [anon_sym_local] = ACTIONS(13489),
    [anon_sym_LPAREN] = ACTIONS(13489),
    [anon_sym_RPAREN] = ACTIONS(13489),
    [anon_sym_COLON2] = ACTIONS(13489),
    [anon_sym_export] = ACTIONS(13489),
    [anon_sym_import] = ACTIONS(13489),
    [anon_sym_using] = ACTIONS(13489),
    [anon_sym_LBRACK] = ACTIONS(13489),
    [anon_sym_LF] = ACTIONS(13491),
    [anon_sym_in] = ACTIONS(13489),
    [anon_sym_SEMI] = ACTIONS(13489),
    [anon_sym_LBRACE] = ACTIONS(13489),
    [anon_sym_DOLLAR] = ACTIONS(13489),
    [anon_sym_COLON_COLON] = ACTIONS(13489),
    [anon_sym_isa] = ACTIONS(13489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13489),
    [anon_sym_QMARK] = ACTIONS(13489),
    [anon_sym_AT] = ACTIONS(13489),
    [anon_sym_true] = ACTIONS(13489),
    [anon_sym_false] = ACTIONS(13489),
    [aux_sym_integer_literal_token1] = ACTIONS(13489),
    [aux_sym_integer_literal_token2] = ACTIONS(13489),
    [aux_sym_integer_literal_token3] = ACTIONS(13489),
    [aux_sym_integer_literal_token4] = ACTIONS(13489),
    [aux_sym_float_literal_token1] = ACTIONS(13489),
    [aux_sym_float_literal_token3] = ACTIONS(13489),
    [aux_sym_float_literal_token4] = ACTIONS(13489),
    [sym_character_literal] = ACTIONS(13489),
    [sym__pair_operator] = ACTIONS(13489),
    [sym__arrow_operator] = ACTIONS(13489),
    [sym__lazy_or_operator] = ACTIONS(13489),
    [sym__lazy_and_operator] = ACTIONS(13489),
    [sym__comparison_operator] = ACTIONS(13489),
    [sym__pipe_right_operator] = ACTIONS(13489),
    [sym__pipe_left_operator] = ACTIONS(13489),
    [sym__ellipsis_operator] = ACTIONS(13489),
    [sym__plus_operator] = ACTIONS(13489),
    [sym__times_operator] = ACTIONS(13489),
    [sym__rational_operator] = ACTIONS(13489),
    [sym__bitshift_operator] = ACTIONS(13489),
    [sym__power_operator] = ACTIONS(13489),
    [sym__tilde_operator] = ACTIONS(13489),
    [sym__type_order_operator] = ACTIONS(13489),
    [sym__unary_operator] = ACTIONS(13489),
    [sym__unary_plus_operator] = ACTIONS(13489),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13491),
    [sym__command_start] = ACTIONS(13491),
  },
  [8824] = {
    [sym__word_identifier] = ACTIONS(13386),
    [anon_sym_EQ] = ACTIONS(13386),
    [anon_sym_COMMA] = ACTIONS(13386),
    [anon_sym_COLON] = ACTIONS(13386),
    [anon_sym_begin] = ACTIONS(13386),
    [anon_sym_module] = ACTIONS(13386),
    [anon_sym_baremodule] = ACTIONS(13386),
    [anon_sym_end] = ACTIONS(13386),
    [anon_sym_abstract] = ACTIONS(13386),
    [anon_sym_primitive] = ACTIONS(13386),
    [anon_sym_mutable] = ACTIONS(13386),
    [anon_sym_struct] = ACTIONS(13386),
    [anon_sym_function] = ACTIONS(13386),
    [anon_sym_macro] = ACTIONS(13386),
    [anon_sym_where] = ACTIONS(13386),
    [anon_sym_quote] = ACTIONS(13386),
    [anon_sym_let] = ACTIONS(13386),
    [anon_sym_if] = ACTIONS(13386),
    [anon_sym_try] = ACTIONS(13386),
    [anon_sym_for] = ACTIONS(13386),
    [anon_sym_while] = ACTIONS(13386),
    [sym_break_statement] = ACTIONS(13386),
    [sym_continue_statement] = ACTIONS(13386),
    [anon_sym_return] = ACTIONS(13386),
    [anon_sym_const] = ACTIONS(13386),
    [anon_sym_global] = ACTIONS(13386),
    [anon_sym_local] = ACTIONS(13386),
    [anon_sym_LPAREN] = ACTIONS(13386),
    [anon_sym_COLON2] = ACTIONS(13386),
    [anon_sym_export] = ACTIONS(13386),
    [anon_sym_import] = ACTIONS(13386),
    [anon_sym_using] = ACTIONS(13386),
    [anon_sym_LBRACK] = ACTIONS(13386),
    [anon_sym_LF] = ACTIONS(13388),
    [anon_sym_in] = ACTIONS(13386),
    [anon_sym_LBRACE] = ACTIONS(13386),
    [anon_sym_DOLLAR] = ACTIONS(13386),
    [anon_sym_COLON_COLON] = ACTIONS(13386),
    [anon_sym_isa] = ACTIONS(13386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13386),
    [anon_sym_QMARK] = ACTIONS(13386),
    [anon_sym_AT] = ACTIONS(13386),
    [anon_sym_true] = ACTIONS(13386),
    [anon_sym_false] = ACTIONS(13386),
    [aux_sym_integer_literal_token1] = ACTIONS(13386),
    [aux_sym_integer_literal_token2] = ACTIONS(13386),
    [aux_sym_integer_literal_token3] = ACTIONS(13386),
    [aux_sym_integer_literal_token4] = ACTIONS(13386),
    [aux_sym_float_literal_token1] = ACTIONS(13386),
    [aux_sym_float_literal_token3] = ACTIONS(13386),
    [aux_sym_float_literal_token4] = ACTIONS(13386),
    [sym_character_literal] = ACTIONS(13386),
    [sym__pair_operator] = ACTIONS(13386),
    [sym__arrow_operator] = ACTIONS(13386),
    [sym__lazy_or_operator] = ACTIONS(13386),
    [sym__lazy_and_operator] = ACTIONS(13386),
    [sym__comparison_operator] = ACTIONS(13386),
    [sym__pipe_right_operator] = ACTIONS(13386),
    [sym__pipe_left_operator] = ACTIONS(13386),
    [sym__ellipsis_operator] = ACTIONS(13386),
    [sym__plus_operator] = ACTIONS(13386),
    [sym__times_operator] = ACTIONS(13386),
    [sym__rational_operator] = ACTIONS(13386),
    [sym__bitshift_operator] = ACTIONS(13386),
    [sym__power_operator] = ACTIONS(13386),
    [sym__tilde_operator] = ACTIONS(13386),
    [sym__type_order_operator] = ACTIONS(13386),
    [sym__unary_operator] = ACTIONS(13386),
    [sym__unary_plus_operator] = ACTIONS(13386),
    [aux_sym__terminator_token1] = ACTIONS(13386),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13388),
    [sym__command_start] = ACTIONS(13388),
  },
  [8825] = {
    [sym__word_identifier] = ACTIONS(13493),
    [anon_sym_EQ] = ACTIONS(13493),
    [anon_sym_COMMA] = ACTIONS(13493),
    [anon_sym_COLON] = ACTIONS(13493),
    [anon_sym_begin] = ACTIONS(13493),
    [anon_sym_module] = ACTIONS(13493),
    [anon_sym_baremodule] = ACTIONS(13493),
    [anon_sym_abstract] = ACTIONS(13493),
    [anon_sym_primitive] = ACTIONS(13493),
    [anon_sym_mutable] = ACTIONS(13493),
    [anon_sym_struct] = ACTIONS(13493),
    [anon_sym_function] = ACTIONS(13493),
    [anon_sym_macro] = ACTIONS(13493),
    [anon_sym_where] = ACTIONS(13493),
    [anon_sym_quote] = ACTIONS(13493),
    [anon_sym_let] = ACTIONS(13493),
    [anon_sym_if] = ACTIONS(13493),
    [anon_sym_try] = ACTIONS(13493),
    [anon_sym_for] = ACTIONS(13493),
    [anon_sym_while] = ACTIONS(13493),
    [sym_break_statement] = ACTIONS(13493),
    [sym_continue_statement] = ACTIONS(13493),
    [anon_sym_return] = ACTIONS(13493),
    [anon_sym_const] = ACTIONS(13493),
    [anon_sym_global] = ACTIONS(13493),
    [anon_sym_local] = ACTIONS(13493),
    [anon_sym_LPAREN] = ACTIONS(13493),
    [anon_sym_RPAREN] = ACTIONS(13493),
    [anon_sym_COLON2] = ACTIONS(13493),
    [anon_sym_export] = ACTIONS(13493),
    [anon_sym_import] = ACTIONS(13493),
    [anon_sym_using] = ACTIONS(13493),
    [anon_sym_LBRACK] = ACTIONS(13493),
    [anon_sym_LF] = ACTIONS(13495),
    [anon_sym_in] = ACTIONS(13493),
    [anon_sym_SEMI] = ACTIONS(13493),
    [anon_sym_LBRACE] = ACTIONS(13493),
    [anon_sym_DOLLAR] = ACTIONS(13493),
    [anon_sym_COLON_COLON] = ACTIONS(13493),
    [anon_sym_isa] = ACTIONS(13493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13493),
    [anon_sym_QMARK] = ACTIONS(13493),
    [anon_sym_AT] = ACTIONS(13493),
    [anon_sym_true] = ACTIONS(13493),
    [anon_sym_false] = ACTIONS(13493),
    [aux_sym_integer_literal_token1] = ACTIONS(13493),
    [aux_sym_integer_literal_token2] = ACTIONS(13493),
    [aux_sym_integer_literal_token3] = ACTIONS(13493),
    [aux_sym_integer_literal_token4] = ACTIONS(13493),
    [aux_sym_float_literal_token1] = ACTIONS(13493),
    [aux_sym_float_literal_token3] = ACTIONS(13493),
    [aux_sym_float_literal_token4] = ACTIONS(13493),
    [sym_character_literal] = ACTIONS(13493),
    [sym__pair_operator] = ACTIONS(13493),
    [sym__arrow_operator] = ACTIONS(13493),
    [sym__lazy_or_operator] = ACTIONS(13493),
    [sym__lazy_and_operator] = ACTIONS(13493),
    [sym__comparison_operator] = ACTIONS(13493),
    [sym__pipe_right_operator] = ACTIONS(13493),
    [sym__pipe_left_operator] = ACTIONS(13493),
    [sym__ellipsis_operator] = ACTIONS(13493),
    [sym__plus_operator] = ACTIONS(13493),
    [sym__times_operator] = ACTIONS(13493),
    [sym__rational_operator] = ACTIONS(13493),
    [sym__bitshift_operator] = ACTIONS(13493),
    [sym__power_operator] = ACTIONS(13493),
    [sym__tilde_operator] = ACTIONS(13493),
    [sym__type_order_operator] = ACTIONS(13493),
    [sym__unary_operator] = ACTIONS(13493),
    [sym__unary_plus_operator] = ACTIONS(13493),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13495),
    [sym__command_start] = ACTIONS(13495),
  },
  [8826] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(12732),
    [anon_sym_COMMA] = ACTIONS(13247),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13247),
    [anon_sym_RPAREN] = ACTIONS(13247),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13247),
    [anon_sym_RBRACK] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13247),
    [anon_sym_RBRACE] = ACTIONS(13247),
    [anon_sym_DOLLAR] = ACTIONS(13247),
    [anon_sym_COLON_COLON] = ACTIONS(13247),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13247),
    [anon_sym_QMARK] = ACTIONS(13247),
    [anon_sym_AT] = ACTIONS(13247),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13247),
    [aux_sym_integer_literal_token2] = ACTIONS(13247),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13247),
    [aux_sym_float_literal_token3] = ACTIONS(13247),
    [aux_sym_float_literal_token4] = ACTIONS(13247),
    [sym_character_literal] = ACTIONS(13247),
    [sym__pair_operator] = ACTIONS(13247),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13247),
    [sym__lazy_and_operator] = ACTIONS(13247),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13247),
    [sym__pipe_left_operator] = ACTIONS(13247),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13247),
    [sym__bitshift_operator] = ACTIONS(13247),
    [sym__power_operator] = ACTIONS(13247),
    [sym__tilde_operator] = ACTIONS(13247),
    [sym__type_order_operator] = ACTIONS(13247),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8827] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_EQ] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13336),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13336),
    [anon_sym_RPAREN] = ACTIONS(13336),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13336),
    [anon_sym_RBRACK] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13336),
    [anon_sym_RBRACE] = ACTIONS(13336),
    [anon_sym_DOLLAR] = ACTIONS(13336),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13336),
    [anon_sym_AT] = ACTIONS(13336),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13336),
    [aux_sym_integer_literal_token2] = ACTIONS(13336),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13336),
    [aux_sym_float_literal_token3] = ACTIONS(13336),
    [aux_sym_float_literal_token4] = ACTIONS(13336),
    [sym_character_literal] = ACTIONS(13336),
    [sym__pair_operator] = ACTIONS(13336),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13336),
    [sym__lazy_and_operator] = ACTIONS(13336),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13336),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [8828] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_EQ] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13465),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13465),
    [anon_sym_RPAREN] = ACTIONS(13465),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13465),
    [anon_sym_RBRACK] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13465),
    [anon_sym_RBRACE] = ACTIONS(13465),
    [anon_sym_DOLLAR] = ACTIONS(13465),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13465),
    [anon_sym_QMARK] = ACTIONS(13465),
    [anon_sym_AT] = ACTIONS(13465),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13465),
    [aux_sym_integer_literal_token2] = ACTIONS(13465),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13465),
    [aux_sym_float_literal_token3] = ACTIONS(13465),
    [aux_sym_float_literal_token4] = ACTIONS(13465),
    [sym_character_literal] = ACTIONS(13465),
    [sym__pair_operator] = ACTIONS(13465),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13465),
    [sym__lazy_and_operator] = ACTIONS(13465),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13465),
    [sym__pipe_left_operator] = ACTIONS(13465),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13465),
    [sym__type_order_operator] = ACTIONS(13465),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [8829] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8830] = {
    [sym__word_identifier] = ACTIONS(13656),
    [anon_sym_EQ] = ACTIONS(13656),
    [anon_sym_COMMA] = ACTIONS(13656),
    [anon_sym_COLON] = ACTIONS(13656),
    [anon_sym_begin] = ACTIONS(13656),
    [anon_sym_module] = ACTIONS(13656),
    [anon_sym_baremodule] = ACTIONS(13656),
    [anon_sym_end] = ACTIONS(13656),
    [anon_sym_abstract] = ACTIONS(13656),
    [anon_sym_primitive] = ACTIONS(13656),
    [anon_sym_mutable] = ACTIONS(13656),
    [anon_sym_struct] = ACTIONS(13656),
    [anon_sym_function] = ACTIONS(13656),
    [anon_sym_macro] = ACTIONS(13656),
    [anon_sym_where] = ACTIONS(13656),
    [anon_sym_quote] = ACTIONS(13656),
    [anon_sym_let] = ACTIONS(13656),
    [anon_sym_if] = ACTIONS(13656),
    [anon_sym_try] = ACTIONS(13656),
    [anon_sym_for] = ACTIONS(13656),
    [anon_sym_while] = ACTIONS(13656),
    [sym_break_statement] = ACTIONS(13656),
    [sym_continue_statement] = ACTIONS(13656),
    [anon_sym_return] = ACTIONS(13656),
    [anon_sym_const] = ACTIONS(13656),
    [anon_sym_global] = ACTIONS(13656),
    [anon_sym_local] = ACTIONS(13656),
    [anon_sym_LPAREN] = ACTIONS(13656),
    [anon_sym_COLON2] = ACTIONS(13656),
    [anon_sym_export] = ACTIONS(13656),
    [anon_sym_import] = ACTIONS(13656),
    [anon_sym_using] = ACTIONS(13656),
    [anon_sym_LBRACK] = ACTIONS(13656),
    [anon_sym_LF] = ACTIONS(13658),
    [anon_sym_in] = ACTIONS(13656),
    [anon_sym_LBRACE] = ACTIONS(13656),
    [anon_sym_DOLLAR] = ACTIONS(13656),
    [anon_sym_COLON_COLON] = ACTIONS(13656),
    [anon_sym_isa] = ACTIONS(13656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13656),
    [anon_sym_QMARK] = ACTIONS(13656),
    [anon_sym_AT] = ACTIONS(13656),
    [anon_sym_true] = ACTIONS(13656),
    [anon_sym_false] = ACTIONS(13656),
    [aux_sym_integer_literal_token1] = ACTIONS(13656),
    [aux_sym_integer_literal_token2] = ACTIONS(13656),
    [aux_sym_integer_literal_token3] = ACTIONS(13656),
    [aux_sym_integer_literal_token4] = ACTIONS(13656),
    [aux_sym_float_literal_token1] = ACTIONS(13656),
    [aux_sym_float_literal_token3] = ACTIONS(13656),
    [aux_sym_float_literal_token4] = ACTIONS(13656),
    [sym_character_literal] = ACTIONS(13656),
    [sym__pair_operator] = ACTIONS(13656),
    [sym__arrow_operator] = ACTIONS(13656),
    [sym__lazy_or_operator] = ACTIONS(13656),
    [sym__lazy_and_operator] = ACTIONS(13656),
    [sym__comparison_operator] = ACTIONS(13656),
    [sym__pipe_right_operator] = ACTIONS(13656),
    [sym__pipe_left_operator] = ACTIONS(13656),
    [sym__ellipsis_operator] = ACTIONS(13656),
    [sym__plus_operator] = ACTIONS(13656),
    [sym__times_operator] = ACTIONS(13656),
    [sym__rational_operator] = ACTIONS(13656),
    [sym__bitshift_operator] = ACTIONS(13656),
    [sym__power_operator] = ACTIONS(13656),
    [sym__tilde_operator] = ACTIONS(13656),
    [sym__type_order_operator] = ACTIONS(13656),
    [sym__unary_operator] = ACTIONS(13656),
    [sym__unary_plus_operator] = ACTIONS(13656),
    [aux_sym__terminator_token1] = ACTIONS(13656),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13658),
    [sym__command_start] = ACTIONS(13658),
  },
  [8831] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14716),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8832] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8833] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8834] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8835] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8836] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8837] = {
    [sym__word_identifier] = ACTIONS(13660),
    [anon_sym_EQ] = ACTIONS(13660),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_COLON] = ACTIONS(13660),
    [anon_sym_begin] = ACTIONS(13660),
    [anon_sym_module] = ACTIONS(13660),
    [anon_sym_baremodule] = ACTIONS(13660),
    [anon_sym_end] = ACTIONS(13660),
    [anon_sym_abstract] = ACTIONS(13660),
    [anon_sym_primitive] = ACTIONS(13660),
    [anon_sym_mutable] = ACTIONS(13660),
    [anon_sym_struct] = ACTIONS(13660),
    [anon_sym_function] = ACTIONS(13660),
    [anon_sym_macro] = ACTIONS(13660),
    [anon_sym_where] = ACTIONS(13660),
    [anon_sym_quote] = ACTIONS(13660),
    [anon_sym_let] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_try] = ACTIONS(13660),
    [anon_sym_for] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [sym_break_statement] = ACTIONS(13660),
    [sym_continue_statement] = ACTIONS(13660),
    [anon_sym_return] = ACTIONS(13660),
    [anon_sym_const] = ACTIONS(13660),
    [anon_sym_global] = ACTIONS(13660),
    [anon_sym_local] = ACTIONS(13660),
    [anon_sym_LPAREN] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13660),
    [anon_sym_export] = ACTIONS(13660),
    [anon_sym_import] = ACTIONS(13660),
    [anon_sym_using] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_LF] = ACTIONS(13662),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_DOLLAR] = ACTIONS(13660),
    [anon_sym_COLON_COLON] = ACTIONS(13660),
    [anon_sym_isa] = ACTIONS(13660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_AT] = ACTIONS(13660),
    [anon_sym_true] = ACTIONS(13660),
    [anon_sym_false] = ACTIONS(13660),
    [aux_sym_integer_literal_token1] = ACTIONS(13660),
    [aux_sym_integer_literal_token2] = ACTIONS(13660),
    [aux_sym_integer_literal_token3] = ACTIONS(13660),
    [aux_sym_integer_literal_token4] = ACTIONS(13660),
    [aux_sym_float_literal_token1] = ACTIONS(13660),
    [aux_sym_float_literal_token3] = ACTIONS(13660),
    [aux_sym_float_literal_token4] = ACTIONS(13660),
    [sym_character_literal] = ACTIONS(13660),
    [sym__pair_operator] = ACTIONS(13660),
    [sym__arrow_operator] = ACTIONS(13660),
    [sym__lazy_or_operator] = ACTIONS(13660),
    [sym__lazy_and_operator] = ACTIONS(13660),
    [sym__comparison_operator] = ACTIONS(13660),
    [sym__pipe_right_operator] = ACTIONS(13660),
    [sym__pipe_left_operator] = ACTIONS(13660),
    [sym__ellipsis_operator] = ACTIONS(13660),
    [sym__plus_operator] = ACTIONS(13660),
    [sym__times_operator] = ACTIONS(13660),
    [sym__rational_operator] = ACTIONS(13660),
    [sym__bitshift_operator] = ACTIONS(13660),
    [sym__power_operator] = ACTIONS(13660),
    [sym__tilde_operator] = ACTIONS(13660),
    [sym__type_order_operator] = ACTIONS(13660),
    [sym__unary_operator] = ACTIONS(13660),
    [sym__unary_plus_operator] = ACTIONS(13660),
    [aux_sym__terminator_token1] = ACTIONS(13660),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13662),
    [sym__command_start] = ACTIONS(13662),
  },
  [8838] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8839] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8840] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8841] = {
    [sym__word_identifier] = ACTIONS(13664),
    [anon_sym_EQ] = ACTIONS(13664),
    [anon_sym_COMMA] = ACTIONS(13664),
    [anon_sym_COLON] = ACTIONS(13664),
    [anon_sym_begin] = ACTIONS(13664),
    [anon_sym_module] = ACTIONS(13664),
    [anon_sym_baremodule] = ACTIONS(13664),
    [anon_sym_end] = ACTIONS(13664),
    [anon_sym_abstract] = ACTIONS(13664),
    [anon_sym_primitive] = ACTIONS(13664),
    [anon_sym_mutable] = ACTIONS(13664),
    [anon_sym_struct] = ACTIONS(13664),
    [anon_sym_function] = ACTIONS(13664),
    [anon_sym_macro] = ACTIONS(13664),
    [anon_sym_where] = ACTIONS(13664),
    [anon_sym_quote] = ACTIONS(13664),
    [anon_sym_let] = ACTIONS(13664),
    [anon_sym_if] = ACTIONS(13664),
    [anon_sym_try] = ACTIONS(13664),
    [anon_sym_for] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(13664),
    [sym_break_statement] = ACTIONS(13664),
    [sym_continue_statement] = ACTIONS(13664),
    [anon_sym_return] = ACTIONS(13664),
    [anon_sym_const] = ACTIONS(13664),
    [anon_sym_global] = ACTIONS(13664),
    [anon_sym_local] = ACTIONS(13664),
    [anon_sym_LPAREN] = ACTIONS(13664),
    [anon_sym_COLON2] = ACTIONS(13664),
    [anon_sym_export] = ACTIONS(13664),
    [anon_sym_import] = ACTIONS(13664),
    [anon_sym_using] = ACTIONS(13664),
    [anon_sym_LBRACK] = ACTIONS(13664),
    [anon_sym_LF] = ACTIONS(13666),
    [anon_sym_in] = ACTIONS(13664),
    [anon_sym_LBRACE] = ACTIONS(13664),
    [anon_sym_DOLLAR] = ACTIONS(13664),
    [anon_sym_COLON_COLON] = ACTIONS(13664),
    [anon_sym_isa] = ACTIONS(13664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13664),
    [anon_sym_QMARK] = ACTIONS(13664),
    [anon_sym_AT] = ACTIONS(13664),
    [anon_sym_true] = ACTIONS(13664),
    [anon_sym_false] = ACTIONS(13664),
    [aux_sym_integer_literal_token1] = ACTIONS(13664),
    [aux_sym_integer_literal_token2] = ACTIONS(13664),
    [aux_sym_integer_literal_token3] = ACTIONS(13664),
    [aux_sym_integer_literal_token4] = ACTIONS(13664),
    [aux_sym_float_literal_token1] = ACTIONS(13664),
    [aux_sym_float_literal_token3] = ACTIONS(13664),
    [aux_sym_float_literal_token4] = ACTIONS(13664),
    [sym_character_literal] = ACTIONS(13664),
    [sym__pair_operator] = ACTIONS(13664),
    [sym__arrow_operator] = ACTIONS(13664),
    [sym__lazy_or_operator] = ACTIONS(13664),
    [sym__lazy_and_operator] = ACTIONS(13664),
    [sym__comparison_operator] = ACTIONS(13664),
    [sym__pipe_right_operator] = ACTIONS(13664),
    [sym__pipe_left_operator] = ACTIONS(13664),
    [sym__ellipsis_operator] = ACTIONS(13664),
    [sym__plus_operator] = ACTIONS(13664),
    [sym__times_operator] = ACTIONS(13664),
    [sym__rational_operator] = ACTIONS(13664),
    [sym__bitshift_operator] = ACTIONS(13664),
    [sym__power_operator] = ACTIONS(13664),
    [sym__tilde_operator] = ACTIONS(13664),
    [sym__type_order_operator] = ACTIONS(13664),
    [sym__unary_operator] = ACTIONS(13664),
    [sym__unary_plus_operator] = ACTIONS(13664),
    [aux_sym__terminator_token1] = ACTIONS(13664),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13666),
    [sym__command_start] = ACTIONS(13666),
  },
  [8842] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8843] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_elseif] = ACTIONS(13334),
    [anon_sym_else] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(1211),
    [sym__pipe_right_operator] = ACTIONS(14812),
    [sym__pipe_left_operator] = ACTIONS(14814),
    [sym__ellipsis_operator] = ACTIONS(14816),
    [sym__plus_operator] = ACTIONS(14818),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(1211),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14818),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [8844] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13312),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8845] = {
    [sym__word_identifier] = ACTIONS(13499),
    [anon_sym_EQ] = ACTIONS(13499),
    [anon_sym_COMMA] = ACTIONS(13499),
    [anon_sym_COLON] = ACTIONS(13499),
    [anon_sym_begin] = ACTIONS(13499),
    [anon_sym_module] = ACTIONS(13499),
    [anon_sym_baremodule] = ACTIONS(13499),
    [anon_sym_abstract] = ACTIONS(13499),
    [anon_sym_primitive] = ACTIONS(13499),
    [anon_sym_mutable] = ACTIONS(13499),
    [anon_sym_struct] = ACTIONS(13499),
    [anon_sym_function] = ACTIONS(13499),
    [anon_sym_macro] = ACTIONS(13499),
    [anon_sym_where] = ACTIONS(13499),
    [anon_sym_quote] = ACTIONS(13499),
    [anon_sym_let] = ACTIONS(13499),
    [anon_sym_if] = ACTIONS(13499),
    [anon_sym_try] = ACTIONS(13499),
    [anon_sym_for] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(13499),
    [sym_break_statement] = ACTIONS(13499),
    [sym_continue_statement] = ACTIONS(13499),
    [anon_sym_return] = ACTIONS(13499),
    [anon_sym_const] = ACTIONS(13499),
    [anon_sym_global] = ACTIONS(13499),
    [anon_sym_local] = ACTIONS(13499),
    [anon_sym_LPAREN] = ACTIONS(13499),
    [anon_sym_RPAREN] = ACTIONS(13499),
    [anon_sym_COLON2] = ACTIONS(13499),
    [anon_sym_export] = ACTIONS(13499),
    [anon_sym_import] = ACTIONS(13499),
    [anon_sym_using] = ACTIONS(13499),
    [anon_sym_LBRACK] = ACTIONS(13499),
    [anon_sym_LF] = ACTIONS(13501),
    [anon_sym_in] = ACTIONS(13499),
    [anon_sym_SEMI] = ACTIONS(13499),
    [anon_sym_LBRACE] = ACTIONS(13499),
    [anon_sym_DOLLAR] = ACTIONS(13499),
    [anon_sym_COLON_COLON] = ACTIONS(13499),
    [anon_sym_isa] = ACTIONS(13499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13499),
    [anon_sym_QMARK] = ACTIONS(13499),
    [anon_sym_AT] = ACTIONS(13499),
    [anon_sym_true] = ACTIONS(13499),
    [anon_sym_false] = ACTIONS(13499),
    [aux_sym_integer_literal_token1] = ACTIONS(13499),
    [aux_sym_integer_literal_token2] = ACTIONS(13499),
    [aux_sym_integer_literal_token3] = ACTIONS(13499),
    [aux_sym_integer_literal_token4] = ACTIONS(13499),
    [aux_sym_float_literal_token1] = ACTIONS(13499),
    [aux_sym_float_literal_token3] = ACTIONS(13499),
    [aux_sym_float_literal_token4] = ACTIONS(13499),
    [sym_character_literal] = ACTIONS(13499),
    [sym__pair_operator] = ACTIONS(13499),
    [sym__arrow_operator] = ACTIONS(13499),
    [sym__lazy_or_operator] = ACTIONS(13499),
    [sym__lazy_and_operator] = ACTIONS(13499),
    [sym__comparison_operator] = ACTIONS(13499),
    [sym__pipe_right_operator] = ACTIONS(13499),
    [sym__pipe_left_operator] = ACTIONS(13499),
    [sym__ellipsis_operator] = ACTIONS(13499),
    [sym__plus_operator] = ACTIONS(13499),
    [sym__times_operator] = ACTIONS(13499),
    [sym__rational_operator] = ACTIONS(13499),
    [sym__bitshift_operator] = ACTIONS(13499),
    [sym__power_operator] = ACTIONS(13499),
    [sym__tilde_operator] = ACTIONS(13499),
    [sym__type_order_operator] = ACTIONS(13499),
    [sym__unary_operator] = ACTIONS(13499),
    [sym__unary_plus_operator] = ACTIONS(13499),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13501),
    [sym__command_start] = ACTIONS(13501),
  },
  [8846] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(12732),
    [anon_sym_COMMA] = ACTIONS(13241),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13241),
    [anon_sym_RPAREN] = ACTIONS(13241),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13241),
    [anon_sym_RBRACK] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13241),
    [anon_sym_RBRACE] = ACTIONS(13241),
    [anon_sym_DOLLAR] = ACTIONS(13241),
    [anon_sym_COLON_COLON] = ACTIONS(13241),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13241),
    [anon_sym_QMARK] = ACTIONS(13241),
    [anon_sym_AT] = ACTIONS(13241),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13241),
    [aux_sym_integer_literal_token2] = ACTIONS(13241),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13241),
    [aux_sym_float_literal_token3] = ACTIONS(13241),
    [aux_sym_float_literal_token4] = ACTIONS(13241),
    [sym_character_literal] = ACTIONS(13241),
    [sym__pair_operator] = ACTIONS(13241),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13241),
    [sym__lazy_and_operator] = ACTIONS(13241),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13241),
    [sym__pipe_left_operator] = ACTIONS(13241),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13241),
    [sym__bitshift_operator] = ACTIONS(13241),
    [sym__power_operator] = ACTIONS(13241),
    [sym__tilde_operator] = ACTIONS(13241),
    [sym__type_order_operator] = ACTIONS(13241),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8847] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13312),
    [sym__bitshift_operator] = ACTIONS(13312),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8848] = {
    [aux_sym_open_tuple_repeat1] = STATE(8127),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(14541),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13241),
    [anon_sym_RPAREN] = ACTIONS(13241),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13241),
    [anon_sym_RBRACK] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13241),
    [anon_sym_RBRACE] = ACTIONS(13241),
    [anon_sym_DOLLAR] = ACTIONS(13241),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14828),
    [anon_sym_AT] = ACTIONS(13241),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13241),
    [aux_sym_integer_literal_token2] = ACTIONS(13241),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13241),
    [aux_sym_float_literal_token3] = ACTIONS(13241),
    [aux_sym_float_literal_token4] = ACTIONS(13241),
    [sym_character_literal] = ACTIONS(13241),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13241),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8849] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_elseif] = ACTIONS(13467),
    [anon_sym_else] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14818),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14818),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [8850] = {
    [sym__word_identifier] = ACTIONS(13506),
    [anon_sym_EQ] = ACTIONS(13506),
    [anon_sym_COMMA] = ACTIONS(13506),
    [anon_sym_COLON] = ACTIONS(13506),
    [anon_sym_begin] = ACTIONS(13506),
    [anon_sym_module] = ACTIONS(13506),
    [anon_sym_baremodule] = ACTIONS(13506),
    [anon_sym_abstract] = ACTIONS(13506),
    [anon_sym_primitive] = ACTIONS(13506),
    [anon_sym_mutable] = ACTIONS(13506),
    [anon_sym_struct] = ACTIONS(13506),
    [anon_sym_function] = ACTIONS(13506),
    [anon_sym_macro] = ACTIONS(13506),
    [anon_sym_where] = ACTIONS(13506),
    [anon_sym_quote] = ACTIONS(13506),
    [anon_sym_let] = ACTIONS(13506),
    [anon_sym_if] = ACTIONS(13506),
    [anon_sym_try] = ACTIONS(13506),
    [anon_sym_for] = ACTIONS(13506),
    [anon_sym_while] = ACTIONS(13506),
    [sym_break_statement] = ACTIONS(13506),
    [sym_continue_statement] = ACTIONS(13506),
    [anon_sym_return] = ACTIONS(13506),
    [anon_sym_const] = ACTIONS(13506),
    [anon_sym_global] = ACTIONS(13506),
    [anon_sym_local] = ACTIONS(13506),
    [anon_sym_LPAREN] = ACTIONS(13506),
    [anon_sym_RPAREN] = ACTIONS(13506),
    [anon_sym_COLON2] = ACTIONS(13506),
    [anon_sym_export] = ACTIONS(13506),
    [anon_sym_import] = ACTIONS(13506),
    [anon_sym_using] = ACTIONS(13506),
    [anon_sym_LBRACK] = ACTIONS(13506),
    [anon_sym_LF] = ACTIONS(13508),
    [anon_sym_in] = ACTIONS(13506),
    [anon_sym_SEMI] = ACTIONS(13506),
    [anon_sym_LBRACE] = ACTIONS(13506),
    [anon_sym_DOLLAR] = ACTIONS(13506),
    [anon_sym_COLON_COLON] = ACTIONS(13506),
    [anon_sym_isa] = ACTIONS(13506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13506),
    [anon_sym_QMARK] = ACTIONS(13506),
    [anon_sym_AT] = ACTIONS(13506),
    [anon_sym_true] = ACTIONS(13506),
    [anon_sym_false] = ACTIONS(13506),
    [aux_sym_integer_literal_token1] = ACTIONS(13506),
    [aux_sym_integer_literal_token2] = ACTIONS(13506),
    [aux_sym_integer_literal_token3] = ACTIONS(13506),
    [aux_sym_integer_literal_token4] = ACTIONS(13506),
    [aux_sym_float_literal_token1] = ACTIONS(13506),
    [aux_sym_float_literal_token3] = ACTIONS(13506),
    [aux_sym_float_literal_token4] = ACTIONS(13506),
    [sym_character_literal] = ACTIONS(13506),
    [sym__pair_operator] = ACTIONS(13506),
    [sym__arrow_operator] = ACTIONS(13506),
    [sym__lazy_or_operator] = ACTIONS(13506),
    [sym__lazy_and_operator] = ACTIONS(13506),
    [sym__comparison_operator] = ACTIONS(13506),
    [sym__pipe_right_operator] = ACTIONS(13506),
    [sym__pipe_left_operator] = ACTIONS(13506),
    [sym__ellipsis_operator] = ACTIONS(13506),
    [sym__plus_operator] = ACTIONS(13506),
    [sym__times_operator] = ACTIONS(13506),
    [sym__rational_operator] = ACTIONS(13506),
    [sym__bitshift_operator] = ACTIONS(13506),
    [sym__power_operator] = ACTIONS(13506),
    [sym__tilde_operator] = ACTIONS(13506),
    [sym__type_order_operator] = ACTIONS(13506),
    [sym__unary_operator] = ACTIONS(13506),
    [sym__unary_plus_operator] = ACTIONS(13506),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13508),
    [sym__command_start] = ACTIONS(13508),
  },
  [8851] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(12732),
    [anon_sym_COMMA] = ACTIONS(13245),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13245),
    [anon_sym_RPAREN] = ACTIONS(13245),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13245),
    [anon_sym_RBRACK] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13245),
    [anon_sym_RBRACE] = ACTIONS(13245),
    [anon_sym_DOLLAR] = ACTIONS(13245),
    [anon_sym_COLON_COLON] = ACTIONS(13245),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13245),
    [anon_sym_QMARK] = ACTIONS(13245),
    [anon_sym_AT] = ACTIONS(13245),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13245),
    [aux_sym_integer_literal_token2] = ACTIONS(13245),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13245),
    [aux_sym_float_literal_token3] = ACTIONS(13245),
    [aux_sym_float_literal_token4] = ACTIONS(13245),
    [sym_character_literal] = ACTIONS(13245),
    [sym__pair_operator] = ACTIONS(13245),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13245),
    [sym__lazy_and_operator] = ACTIONS(13245),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13245),
    [sym__pipe_left_operator] = ACTIONS(13245),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13245),
    [sym__bitshift_operator] = ACTIONS(13245),
    [sym__power_operator] = ACTIONS(13245),
    [sym__tilde_operator] = ACTIONS(13245),
    [sym__type_order_operator] = ACTIONS(13245),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8852] = {
    [aux_sym_open_tuple_repeat1] = STATE(8127),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(14541),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13245),
    [anon_sym_RPAREN] = ACTIONS(13245),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13245),
    [anon_sym_RBRACK] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13245),
    [anon_sym_RBRACE] = ACTIONS(13245),
    [anon_sym_DOLLAR] = ACTIONS(13245),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14828),
    [anon_sym_AT] = ACTIONS(13245),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13245),
    [aux_sym_integer_literal_token2] = ACTIONS(13245),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13245),
    [aux_sym_float_literal_token3] = ACTIONS(13245),
    [aux_sym_float_literal_token4] = ACTIONS(13245),
    [sym_character_literal] = ACTIONS(13245),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13245),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8853] = {
    [sym__word_identifier] = ACTIONS(13510),
    [anon_sym_EQ] = ACTIONS(13510),
    [anon_sym_COMMA] = ACTIONS(13510),
    [anon_sym_COLON] = ACTIONS(13510),
    [anon_sym_begin] = ACTIONS(13510),
    [anon_sym_module] = ACTIONS(13510),
    [anon_sym_baremodule] = ACTIONS(13510),
    [anon_sym_abstract] = ACTIONS(13510),
    [anon_sym_primitive] = ACTIONS(13510),
    [anon_sym_mutable] = ACTIONS(13510),
    [anon_sym_struct] = ACTIONS(13510),
    [anon_sym_function] = ACTIONS(13510),
    [anon_sym_macro] = ACTIONS(13510),
    [anon_sym_where] = ACTIONS(13510),
    [anon_sym_quote] = ACTIONS(13510),
    [anon_sym_let] = ACTIONS(13510),
    [anon_sym_if] = ACTIONS(13510),
    [anon_sym_try] = ACTIONS(13510),
    [anon_sym_for] = ACTIONS(13510),
    [anon_sym_while] = ACTIONS(13510),
    [sym_break_statement] = ACTIONS(13510),
    [sym_continue_statement] = ACTIONS(13510),
    [anon_sym_return] = ACTIONS(13510),
    [anon_sym_const] = ACTIONS(13510),
    [anon_sym_global] = ACTIONS(13510),
    [anon_sym_local] = ACTIONS(13510),
    [anon_sym_LPAREN] = ACTIONS(13510),
    [anon_sym_RPAREN] = ACTIONS(13510),
    [anon_sym_COLON2] = ACTIONS(13510),
    [anon_sym_export] = ACTIONS(13510),
    [anon_sym_import] = ACTIONS(13510),
    [anon_sym_using] = ACTIONS(13510),
    [anon_sym_LBRACK] = ACTIONS(13510),
    [anon_sym_LF] = ACTIONS(13512),
    [anon_sym_in] = ACTIONS(13510),
    [anon_sym_SEMI] = ACTIONS(13510),
    [anon_sym_LBRACE] = ACTIONS(13510),
    [anon_sym_DOLLAR] = ACTIONS(13510),
    [anon_sym_COLON_COLON] = ACTIONS(13510),
    [anon_sym_isa] = ACTIONS(13510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13510),
    [anon_sym_QMARK] = ACTIONS(13510),
    [anon_sym_AT] = ACTIONS(13510),
    [anon_sym_true] = ACTIONS(13510),
    [anon_sym_false] = ACTIONS(13510),
    [aux_sym_integer_literal_token1] = ACTIONS(13510),
    [aux_sym_integer_literal_token2] = ACTIONS(13510),
    [aux_sym_integer_literal_token3] = ACTIONS(13510),
    [aux_sym_integer_literal_token4] = ACTIONS(13510),
    [aux_sym_float_literal_token1] = ACTIONS(13510),
    [aux_sym_float_literal_token3] = ACTIONS(13510),
    [aux_sym_float_literal_token4] = ACTIONS(13510),
    [sym_character_literal] = ACTIONS(13510),
    [sym__pair_operator] = ACTIONS(13510),
    [sym__arrow_operator] = ACTIONS(13510),
    [sym__lazy_or_operator] = ACTIONS(13510),
    [sym__lazy_and_operator] = ACTIONS(13510),
    [sym__comparison_operator] = ACTIONS(13510),
    [sym__pipe_right_operator] = ACTIONS(13510),
    [sym__pipe_left_operator] = ACTIONS(13510),
    [sym__ellipsis_operator] = ACTIONS(13510),
    [sym__plus_operator] = ACTIONS(13510),
    [sym__times_operator] = ACTIONS(13510),
    [sym__rational_operator] = ACTIONS(13510),
    [sym__bitshift_operator] = ACTIONS(13510),
    [sym__power_operator] = ACTIONS(13510),
    [sym__tilde_operator] = ACTIONS(13510),
    [sym__type_order_operator] = ACTIONS(13510),
    [sym__unary_operator] = ACTIONS(13510),
    [sym__unary_plus_operator] = ACTIONS(13510),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13512),
    [sym__command_start] = ACTIONS(13512),
  },
  [8854] = {
    [sym__word_identifier] = ACTIONS(13514),
    [anon_sym_EQ] = ACTIONS(13514),
    [anon_sym_COMMA] = ACTIONS(13514),
    [anon_sym_COLON] = ACTIONS(13514),
    [anon_sym_begin] = ACTIONS(13514),
    [anon_sym_module] = ACTIONS(13514),
    [anon_sym_baremodule] = ACTIONS(13514),
    [anon_sym_abstract] = ACTIONS(13514),
    [anon_sym_primitive] = ACTIONS(13514),
    [anon_sym_mutable] = ACTIONS(13514),
    [anon_sym_struct] = ACTIONS(13514),
    [anon_sym_function] = ACTIONS(13514),
    [anon_sym_macro] = ACTIONS(13514),
    [anon_sym_where] = ACTIONS(13514),
    [anon_sym_quote] = ACTIONS(13514),
    [anon_sym_let] = ACTIONS(13514),
    [anon_sym_if] = ACTIONS(13514),
    [anon_sym_try] = ACTIONS(13514),
    [anon_sym_for] = ACTIONS(13514),
    [anon_sym_while] = ACTIONS(13514),
    [sym_break_statement] = ACTIONS(13514),
    [sym_continue_statement] = ACTIONS(13514),
    [anon_sym_return] = ACTIONS(13514),
    [anon_sym_const] = ACTIONS(13514),
    [anon_sym_global] = ACTIONS(13514),
    [anon_sym_local] = ACTIONS(13514),
    [anon_sym_LPAREN] = ACTIONS(13514),
    [anon_sym_RPAREN] = ACTIONS(13514),
    [anon_sym_COLON2] = ACTIONS(13514),
    [anon_sym_export] = ACTIONS(13514),
    [anon_sym_import] = ACTIONS(13514),
    [anon_sym_using] = ACTIONS(13514),
    [anon_sym_LBRACK] = ACTIONS(13514),
    [anon_sym_LF] = ACTIONS(13516),
    [anon_sym_in] = ACTIONS(13514),
    [anon_sym_SEMI] = ACTIONS(13514),
    [anon_sym_LBRACE] = ACTIONS(13514),
    [anon_sym_DOLLAR] = ACTIONS(13514),
    [anon_sym_COLON_COLON] = ACTIONS(13514),
    [anon_sym_isa] = ACTIONS(13514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13514),
    [anon_sym_QMARK] = ACTIONS(13514),
    [anon_sym_AT] = ACTIONS(13514),
    [anon_sym_true] = ACTIONS(13514),
    [anon_sym_false] = ACTIONS(13514),
    [aux_sym_integer_literal_token1] = ACTIONS(13514),
    [aux_sym_integer_literal_token2] = ACTIONS(13514),
    [aux_sym_integer_literal_token3] = ACTIONS(13514),
    [aux_sym_integer_literal_token4] = ACTIONS(13514),
    [aux_sym_float_literal_token1] = ACTIONS(13514),
    [aux_sym_float_literal_token3] = ACTIONS(13514),
    [aux_sym_float_literal_token4] = ACTIONS(13514),
    [sym_character_literal] = ACTIONS(13514),
    [sym__pair_operator] = ACTIONS(13514),
    [sym__arrow_operator] = ACTIONS(13514),
    [sym__lazy_or_operator] = ACTIONS(13514),
    [sym__lazy_and_operator] = ACTIONS(13514),
    [sym__comparison_operator] = ACTIONS(13514),
    [sym__pipe_right_operator] = ACTIONS(13514),
    [sym__pipe_left_operator] = ACTIONS(13514),
    [sym__ellipsis_operator] = ACTIONS(13514),
    [sym__plus_operator] = ACTIONS(13514),
    [sym__times_operator] = ACTIONS(13514),
    [sym__rational_operator] = ACTIONS(13514),
    [sym__bitshift_operator] = ACTIONS(13514),
    [sym__power_operator] = ACTIONS(13514),
    [sym__tilde_operator] = ACTIONS(13514),
    [sym__type_order_operator] = ACTIONS(13514),
    [sym__unary_operator] = ACTIONS(13514),
    [sym__unary_plus_operator] = ACTIONS(13514),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13516),
    [sym__command_start] = ACTIONS(13516),
  },
  [8855] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12732),
    [anon_sym_COMMA] = ACTIONS(12934),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12934),
    [anon_sym_RPAREN] = ACTIONS(12934),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12934),
    [anon_sym_RBRACK] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12934),
    [anon_sym_RBRACE] = ACTIONS(12934),
    [anon_sym_DOLLAR] = ACTIONS(12934),
    [anon_sym_COLON_COLON] = ACTIONS(12934),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12934),
    [anon_sym_QMARK] = ACTIONS(12934),
    [anon_sym_AT] = ACTIONS(12934),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12934),
    [aux_sym_integer_literal_token2] = ACTIONS(12934),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12934),
    [aux_sym_float_literal_token3] = ACTIONS(12934),
    [aux_sym_float_literal_token4] = ACTIONS(12934),
    [sym_character_literal] = ACTIONS(12934),
    [sym__pair_operator] = ACTIONS(12934),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12934),
    [sym__lazy_and_operator] = ACTIONS(12934),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12934),
    [sym__pipe_left_operator] = ACTIONS(12934),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12934),
    [sym__bitshift_operator] = ACTIONS(12934),
    [sym__power_operator] = ACTIONS(12934),
    [sym__tilde_operator] = ACTIONS(12934),
    [sym__type_order_operator] = ACTIONS(12934),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8856] = {
    [aux_sym_open_tuple_repeat1] = STATE(8127),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(14541),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12934),
    [anon_sym_RPAREN] = ACTIONS(12934),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12934),
    [anon_sym_RBRACK] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(12934),
    [anon_sym_RBRACE] = ACTIONS(12934),
    [anon_sym_DOLLAR] = ACTIONS(12934),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14828),
    [anon_sym_AT] = ACTIONS(12934),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12934),
    [aux_sym_integer_literal_token2] = ACTIONS(12934),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12934),
    [aux_sym_float_literal_token3] = ACTIONS(12934),
    [aux_sym_float_literal_token4] = ACTIONS(12934),
    [sym_character_literal] = ACTIONS(12934),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(12934),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8857] = {
    [sym__word_identifier] = ACTIONS(13518),
    [anon_sym_EQ] = ACTIONS(13518),
    [anon_sym_COMMA] = ACTIONS(13518),
    [anon_sym_COLON] = ACTIONS(13518),
    [anon_sym_begin] = ACTIONS(13518),
    [anon_sym_module] = ACTIONS(13518),
    [anon_sym_baremodule] = ACTIONS(13518),
    [anon_sym_abstract] = ACTIONS(13518),
    [anon_sym_primitive] = ACTIONS(13518),
    [anon_sym_mutable] = ACTIONS(13518),
    [anon_sym_struct] = ACTIONS(13518),
    [anon_sym_function] = ACTIONS(13518),
    [anon_sym_macro] = ACTIONS(13518),
    [anon_sym_where] = ACTIONS(13518),
    [anon_sym_quote] = ACTIONS(13518),
    [anon_sym_let] = ACTIONS(13518),
    [anon_sym_if] = ACTIONS(13518),
    [anon_sym_try] = ACTIONS(13518),
    [anon_sym_for] = ACTIONS(13518),
    [anon_sym_while] = ACTIONS(13518),
    [sym_break_statement] = ACTIONS(13518),
    [sym_continue_statement] = ACTIONS(13518),
    [anon_sym_return] = ACTIONS(13518),
    [anon_sym_const] = ACTIONS(13518),
    [anon_sym_global] = ACTIONS(13518),
    [anon_sym_local] = ACTIONS(13518),
    [anon_sym_LPAREN] = ACTIONS(13518),
    [anon_sym_RPAREN] = ACTIONS(13518),
    [anon_sym_COLON2] = ACTIONS(13518),
    [anon_sym_export] = ACTIONS(13518),
    [anon_sym_import] = ACTIONS(13518),
    [anon_sym_using] = ACTIONS(13518),
    [anon_sym_LBRACK] = ACTIONS(13518),
    [anon_sym_LF] = ACTIONS(13520),
    [anon_sym_in] = ACTIONS(13518),
    [anon_sym_SEMI] = ACTIONS(13518),
    [anon_sym_LBRACE] = ACTIONS(13518),
    [anon_sym_DOLLAR] = ACTIONS(13518),
    [anon_sym_COLON_COLON] = ACTIONS(13518),
    [anon_sym_isa] = ACTIONS(13518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13518),
    [anon_sym_QMARK] = ACTIONS(13518),
    [anon_sym_AT] = ACTIONS(13518),
    [anon_sym_true] = ACTIONS(13518),
    [anon_sym_false] = ACTIONS(13518),
    [aux_sym_integer_literal_token1] = ACTIONS(13518),
    [aux_sym_integer_literal_token2] = ACTIONS(13518),
    [aux_sym_integer_literal_token3] = ACTIONS(13518),
    [aux_sym_integer_literal_token4] = ACTIONS(13518),
    [aux_sym_float_literal_token1] = ACTIONS(13518),
    [aux_sym_float_literal_token3] = ACTIONS(13518),
    [aux_sym_float_literal_token4] = ACTIONS(13518),
    [sym_character_literal] = ACTIONS(13518),
    [sym__pair_operator] = ACTIONS(13518),
    [sym__arrow_operator] = ACTIONS(13518),
    [sym__lazy_or_operator] = ACTIONS(13518),
    [sym__lazy_and_operator] = ACTIONS(13518),
    [sym__comparison_operator] = ACTIONS(13518),
    [sym__pipe_right_operator] = ACTIONS(13518),
    [sym__pipe_left_operator] = ACTIONS(13518),
    [sym__ellipsis_operator] = ACTIONS(13518),
    [sym__plus_operator] = ACTIONS(13518),
    [sym__times_operator] = ACTIONS(13518),
    [sym__rational_operator] = ACTIONS(13518),
    [sym__bitshift_operator] = ACTIONS(13518),
    [sym__power_operator] = ACTIONS(13518),
    [sym__tilde_operator] = ACTIONS(13518),
    [sym__type_order_operator] = ACTIONS(13518),
    [sym__unary_operator] = ACTIONS(13518),
    [sym__unary_plus_operator] = ACTIONS(13518),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13520),
    [sym__command_start] = ACTIONS(13520),
  },
  [8858] = {
    [sym__word_identifier] = ACTIONS(13257),
    [anon_sym_EQ] = ACTIONS(13257),
    [anon_sym_COMMA] = ACTIONS(13257),
    [anon_sym_COLON] = ACTIONS(13257),
    [anon_sym_begin] = ACTIONS(13257),
    [anon_sym_module] = ACTIONS(13257),
    [anon_sym_baremodule] = ACTIONS(13257),
    [anon_sym_abstract] = ACTIONS(13257),
    [anon_sym_primitive] = ACTIONS(13257),
    [anon_sym_mutable] = ACTIONS(13257),
    [anon_sym_struct] = ACTIONS(13257),
    [anon_sym_function] = ACTIONS(13257),
    [anon_sym_macro] = ACTIONS(13257),
    [anon_sym_where] = ACTIONS(13257),
    [anon_sym_quote] = ACTIONS(13257),
    [anon_sym_let] = ACTIONS(13257),
    [anon_sym_if] = ACTIONS(13257),
    [anon_sym_try] = ACTIONS(13257),
    [anon_sym_for] = ACTIONS(13257),
    [anon_sym_while] = ACTIONS(13257),
    [sym_break_statement] = ACTIONS(13257),
    [sym_continue_statement] = ACTIONS(13257),
    [anon_sym_return] = ACTIONS(13257),
    [anon_sym_const] = ACTIONS(13257),
    [anon_sym_global] = ACTIONS(13257),
    [anon_sym_local] = ACTIONS(13257),
    [anon_sym_LPAREN] = ACTIONS(13257),
    [anon_sym_RPAREN] = ACTIONS(13257),
    [anon_sym_COLON2] = ACTIONS(13257),
    [anon_sym_export] = ACTIONS(13257),
    [anon_sym_import] = ACTIONS(13257),
    [anon_sym_using] = ACTIONS(13257),
    [anon_sym_LBRACK] = ACTIONS(13257),
    [anon_sym_LF] = ACTIONS(13259),
    [anon_sym_in] = ACTIONS(13257),
    [anon_sym_SEMI] = ACTIONS(13257),
    [anon_sym_LBRACE] = ACTIONS(13257),
    [anon_sym_DOLLAR] = ACTIONS(13257),
    [anon_sym_COLON_COLON] = ACTIONS(13257),
    [anon_sym_isa] = ACTIONS(13257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13257),
    [anon_sym_QMARK] = ACTIONS(13257),
    [anon_sym_AT] = ACTIONS(13257),
    [anon_sym_true] = ACTIONS(13257),
    [anon_sym_false] = ACTIONS(13257),
    [aux_sym_integer_literal_token1] = ACTIONS(13257),
    [aux_sym_integer_literal_token2] = ACTIONS(13257),
    [aux_sym_integer_literal_token3] = ACTIONS(13257),
    [aux_sym_integer_literal_token4] = ACTIONS(13257),
    [aux_sym_float_literal_token1] = ACTIONS(13257),
    [aux_sym_float_literal_token3] = ACTIONS(13257),
    [aux_sym_float_literal_token4] = ACTIONS(13257),
    [sym_character_literal] = ACTIONS(13257),
    [sym__pair_operator] = ACTIONS(13257),
    [sym__arrow_operator] = ACTIONS(13257),
    [sym__lazy_or_operator] = ACTIONS(13257),
    [sym__lazy_and_operator] = ACTIONS(13257),
    [sym__comparison_operator] = ACTIONS(13257),
    [sym__pipe_right_operator] = ACTIONS(13257),
    [sym__pipe_left_operator] = ACTIONS(13257),
    [sym__ellipsis_operator] = ACTIONS(13257),
    [sym__plus_operator] = ACTIONS(13257),
    [sym__times_operator] = ACTIONS(13257),
    [sym__rational_operator] = ACTIONS(13257),
    [sym__bitshift_operator] = ACTIONS(13257),
    [sym__power_operator] = ACTIONS(13257),
    [sym__tilde_operator] = ACTIONS(13257),
    [sym__type_order_operator] = ACTIONS(13257),
    [sym__unary_operator] = ACTIONS(13257),
    [sym__unary_plus_operator] = ACTIONS(13257),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13259),
    [sym__command_start] = ACTIONS(13259),
  },
  [8859] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8860] = {
    [sym__word_identifier] = ACTIONS(13522),
    [anon_sym_EQ] = ACTIONS(13522),
    [anon_sym_COMMA] = ACTIONS(13522),
    [anon_sym_COLON] = ACTIONS(13522),
    [anon_sym_begin] = ACTIONS(13522),
    [anon_sym_module] = ACTIONS(13522),
    [anon_sym_baremodule] = ACTIONS(13522),
    [anon_sym_abstract] = ACTIONS(13522),
    [anon_sym_primitive] = ACTIONS(13522),
    [anon_sym_mutable] = ACTIONS(13522),
    [anon_sym_struct] = ACTIONS(13522),
    [anon_sym_function] = ACTIONS(13522),
    [anon_sym_macro] = ACTIONS(13522),
    [anon_sym_where] = ACTIONS(13522),
    [anon_sym_quote] = ACTIONS(13522),
    [anon_sym_let] = ACTIONS(13522),
    [anon_sym_if] = ACTIONS(13522),
    [anon_sym_try] = ACTIONS(13522),
    [anon_sym_for] = ACTIONS(13522),
    [anon_sym_while] = ACTIONS(13522),
    [sym_break_statement] = ACTIONS(13522),
    [sym_continue_statement] = ACTIONS(13522),
    [anon_sym_return] = ACTIONS(13522),
    [anon_sym_const] = ACTIONS(13522),
    [anon_sym_global] = ACTIONS(13522),
    [anon_sym_local] = ACTIONS(13522),
    [anon_sym_LPAREN] = ACTIONS(13522),
    [anon_sym_RPAREN] = ACTIONS(13522),
    [anon_sym_COLON2] = ACTIONS(13522),
    [anon_sym_export] = ACTIONS(13522),
    [anon_sym_import] = ACTIONS(13522),
    [anon_sym_using] = ACTIONS(13522),
    [anon_sym_LBRACK] = ACTIONS(13522),
    [anon_sym_LF] = ACTIONS(13524),
    [anon_sym_in] = ACTIONS(13522),
    [anon_sym_SEMI] = ACTIONS(13522),
    [anon_sym_LBRACE] = ACTIONS(13522),
    [anon_sym_DOLLAR] = ACTIONS(13522),
    [anon_sym_COLON_COLON] = ACTIONS(13522),
    [anon_sym_isa] = ACTIONS(13522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13522),
    [anon_sym_QMARK] = ACTIONS(13522),
    [anon_sym_AT] = ACTIONS(13522),
    [anon_sym_true] = ACTIONS(13522),
    [anon_sym_false] = ACTIONS(13522),
    [aux_sym_integer_literal_token1] = ACTIONS(13522),
    [aux_sym_integer_literal_token2] = ACTIONS(13522),
    [aux_sym_integer_literal_token3] = ACTIONS(13522),
    [aux_sym_integer_literal_token4] = ACTIONS(13522),
    [aux_sym_float_literal_token1] = ACTIONS(13522),
    [aux_sym_float_literal_token3] = ACTIONS(13522),
    [aux_sym_float_literal_token4] = ACTIONS(13522),
    [sym_character_literal] = ACTIONS(13522),
    [sym__pair_operator] = ACTIONS(13522),
    [sym__arrow_operator] = ACTIONS(13522),
    [sym__lazy_or_operator] = ACTIONS(13522),
    [sym__lazy_and_operator] = ACTIONS(13522),
    [sym__comparison_operator] = ACTIONS(13522),
    [sym__pipe_right_operator] = ACTIONS(13522),
    [sym__pipe_left_operator] = ACTIONS(13522),
    [sym__ellipsis_operator] = ACTIONS(13522),
    [sym__plus_operator] = ACTIONS(13522),
    [sym__times_operator] = ACTIONS(13522),
    [sym__rational_operator] = ACTIONS(13522),
    [sym__bitshift_operator] = ACTIONS(13522),
    [sym__power_operator] = ACTIONS(13522),
    [sym__tilde_operator] = ACTIONS(13522),
    [sym__type_order_operator] = ACTIONS(13522),
    [sym__unary_operator] = ACTIONS(13522),
    [sym__unary_plus_operator] = ACTIONS(13522),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13524),
    [sym__command_start] = ACTIONS(13524),
  },
  [8861] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8862] = {
    [sym__word_identifier] = ACTIONS(13526),
    [anon_sym_EQ] = ACTIONS(13526),
    [anon_sym_COMMA] = ACTIONS(13526),
    [anon_sym_COLON] = ACTIONS(13526),
    [anon_sym_begin] = ACTIONS(13526),
    [anon_sym_module] = ACTIONS(13526),
    [anon_sym_baremodule] = ACTIONS(13526),
    [anon_sym_abstract] = ACTIONS(13526),
    [anon_sym_primitive] = ACTIONS(13526),
    [anon_sym_mutable] = ACTIONS(13526),
    [anon_sym_struct] = ACTIONS(13526),
    [anon_sym_function] = ACTIONS(13526),
    [anon_sym_macro] = ACTIONS(13526),
    [anon_sym_where] = ACTIONS(13526),
    [anon_sym_quote] = ACTIONS(13526),
    [anon_sym_let] = ACTIONS(13526),
    [anon_sym_if] = ACTIONS(13526),
    [anon_sym_try] = ACTIONS(13526),
    [anon_sym_for] = ACTIONS(13526),
    [anon_sym_while] = ACTIONS(13526),
    [sym_break_statement] = ACTIONS(13526),
    [sym_continue_statement] = ACTIONS(13526),
    [anon_sym_return] = ACTIONS(13526),
    [anon_sym_const] = ACTIONS(13526),
    [anon_sym_global] = ACTIONS(13526),
    [anon_sym_local] = ACTIONS(13526),
    [anon_sym_LPAREN] = ACTIONS(13526),
    [anon_sym_RPAREN] = ACTIONS(13526),
    [anon_sym_COLON2] = ACTIONS(13526),
    [anon_sym_export] = ACTIONS(13526),
    [anon_sym_import] = ACTIONS(13526),
    [anon_sym_using] = ACTIONS(13526),
    [anon_sym_LBRACK] = ACTIONS(13526),
    [anon_sym_LF] = ACTIONS(13528),
    [anon_sym_in] = ACTIONS(13526),
    [anon_sym_SEMI] = ACTIONS(13526),
    [anon_sym_LBRACE] = ACTIONS(13526),
    [anon_sym_DOLLAR] = ACTIONS(13526),
    [anon_sym_COLON_COLON] = ACTIONS(13526),
    [anon_sym_isa] = ACTIONS(13526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13526),
    [anon_sym_QMARK] = ACTIONS(13526),
    [anon_sym_AT] = ACTIONS(13526),
    [anon_sym_true] = ACTIONS(13526),
    [anon_sym_false] = ACTIONS(13526),
    [aux_sym_integer_literal_token1] = ACTIONS(13526),
    [aux_sym_integer_literal_token2] = ACTIONS(13526),
    [aux_sym_integer_literal_token3] = ACTIONS(13526),
    [aux_sym_integer_literal_token4] = ACTIONS(13526),
    [aux_sym_float_literal_token1] = ACTIONS(13526),
    [aux_sym_float_literal_token3] = ACTIONS(13526),
    [aux_sym_float_literal_token4] = ACTIONS(13526),
    [sym_character_literal] = ACTIONS(13526),
    [sym__pair_operator] = ACTIONS(13526),
    [sym__arrow_operator] = ACTIONS(13526),
    [sym__lazy_or_operator] = ACTIONS(13526),
    [sym__lazy_and_operator] = ACTIONS(13526),
    [sym__comparison_operator] = ACTIONS(13526),
    [sym__pipe_right_operator] = ACTIONS(13526),
    [sym__pipe_left_operator] = ACTIONS(13526),
    [sym__ellipsis_operator] = ACTIONS(13526),
    [sym__plus_operator] = ACTIONS(13526),
    [sym__times_operator] = ACTIONS(13526),
    [sym__rational_operator] = ACTIONS(13526),
    [sym__bitshift_operator] = ACTIONS(13526),
    [sym__power_operator] = ACTIONS(13526),
    [sym__tilde_operator] = ACTIONS(13526),
    [sym__type_order_operator] = ACTIONS(13526),
    [sym__unary_operator] = ACTIONS(13526),
    [sym__unary_plus_operator] = ACTIONS(13526),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13528),
    [sym__command_start] = ACTIONS(13528),
  },
  [8863] = {
    [sym__word_identifier] = ACTIONS(13530),
    [anon_sym_EQ] = ACTIONS(13530),
    [anon_sym_COMMA] = ACTIONS(13530),
    [anon_sym_COLON] = ACTIONS(13530),
    [anon_sym_begin] = ACTIONS(13530),
    [anon_sym_module] = ACTIONS(13530),
    [anon_sym_baremodule] = ACTIONS(13530),
    [anon_sym_abstract] = ACTIONS(13530),
    [anon_sym_primitive] = ACTIONS(13530),
    [anon_sym_mutable] = ACTIONS(13530),
    [anon_sym_struct] = ACTIONS(13530),
    [anon_sym_function] = ACTIONS(13530),
    [anon_sym_macro] = ACTIONS(13530),
    [anon_sym_where] = ACTIONS(13530),
    [anon_sym_quote] = ACTIONS(13530),
    [anon_sym_let] = ACTIONS(13530),
    [anon_sym_if] = ACTIONS(13530),
    [anon_sym_try] = ACTIONS(13530),
    [anon_sym_for] = ACTIONS(13530),
    [anon_sym_while] = ACTIONS(13530),
    [sym_break_statement] = ACTIONS(13530),
    [sym_continue_statement] = ACTIONS(13530),
    [anon_sym_return] = ACTIONS(13530),
    [anon_sym_const] = ACTIONS(13530),
    [anon_sym_global] = ACTIONS(13530),
    [anon_sym_local] = ACTIONS(13530),
    [anon_sym_LPAREN] = ACTIONS(13530),
    [anon_sym_RPAREN] = ACTIONS(13530),
    [anon_sym_COLON2] = ACTIONS(13530),
    [anon_sym_export] = ACTIONS(13530),
    [anon_sym_import] = ACTIONS(13530),
    [anon_sym_using] = ACTIONS(13530),
    [anon_sym_LBRACK] = ACTIONS(13530),
    [anon_sym_LF] = ACTIONS(13532),
    [anon_sym_in] = ACTIONS(13530),
    [anon_sym_SEMI] = ACTIONS(13530),
    [anon_sym_LBRACE] = ACTIONS(13530),
    [anon_sym_DOLLAR] = ACTIONS(13530),
    [anon_sym_COLON_COLON] = ACTIONS(13530),
    [anon_sym_isa] = ACTIONS(13530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13530),
    [anon_sym_QMARK] = ACTIONS(13530),
    [anon_sym_AT] = ACTIONS(13530),
    [anon_sym_true] = ACTIONS(13530),
    [anon_sym_false] = ACTIONS(13530),
    [aux_sym_integer_literal_token1] = ACTIONS(13530),
    [aux_sym_integer_literal_token2] = ACTIONS(13530),
    [aux_sym_integer_literal_token3] = ACTIONS(13530),
    [aux_sym_integer_literal_token4] = ACTIONS(13530),
    [aux_sym_float_literal_token1] = ACTIONS(13530),
    [aux_sym_float_literal_token3] = ACTIONS(13530),
    [aux_sym_float_literal_token4] = ACTIONS(13530),
    [sym_character_literal] = ACTIONS(13530),
    [sym__pair_operator] = ACTIONS(13530),
    [sym__arrow_operator] = ACTIONS(13530),
    [sym__lazy_or_operator] = ACTIONS(13530),
    [sym__lazy_and_operator] = ACTIONS(13530),
    [sym__comparison_operator] = ACTIONS(13530),
    [sym__pipe_right_operator] = ACTIONS(13530),
    [sym__pipe_left_operator] = ACTIONS(13530),
    [sym__ellipsis_operator] = ACTIONS(13530),
    [sym__plus_operator] = ACTIONS(13530),
    [sym__times_operator] = ACTIONS(13530),
    [sym__rational_operator] = ACTIONS(13530),
    [sym__bitshift_operator] = ACTIONS(13530),
    [sym__power_operator] = ACTIONS(13530),
    [sym__tilde_operator] = ACTIONS(13530),
    [sym__type_order_operator] = ACTIONS(13530),
    [sym__unary_operator] = ACTIONS(13530),
    [sym__unary_plus_operator] = ACTIONS(13530),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13532),
    [sym__command_start] = ACTIONS(13532),
  },
  [8864] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_catch] = ACTIONS(13334),
    [anon_sym_finally] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14830),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14832),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14832),
    [sym__pipe_right_operator] = ACTIONS(14834),
    [sym__pipe_left_operator] = ACTIONS(14836),
    [sym__ellipsis_operator] = ACTIONS(14838),
    [sym__plus_operator] = ACTIONS(14840),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14832),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14840),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [8865] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13310),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13310),
    [anon_sym_RPAREN] = ACTIONS(13310),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13310),
    [anon_sym_RBRACK] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13310),
    [anon_sym_RBRACE] = ACTIONS(13310),
    [anon_sym_DOLLAR] = ACTIONS(13310),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13310),
    [anon_sym_QMARK] = ACTIONS(13310),
    [anon_sym_AT] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13310),
    [aux_sym_integer_literal_token2] = ACTIONS(13310),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13310),
    [aux_sym_float_literal_token3] = ACTIONS(13310),
    [aux_sym_float_literal_token4] = ACTIONS(13310),
    [sym_character_literal] = ACTIONS(13310),
    [sym__pair_operator] = ACTIONS(13310),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13310),
    [sym__lazy_and_operator] = ACTIONS(13310),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13310),
    [sym__pipe_left_operator] = ACTIONS(13310),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13310),
    [sym__bitshift_operator] = ACTIONS(13310),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13310),
    [sym__type_order_operator] = ACTIONS(13310),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [8866] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_catch] = ACTIONS(13467),
    [anon_sym_finally] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14840),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14840),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [8867] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14830),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14834),
    [sym__pipe_left_operator] = ACTIONS(14836),
    [sym__ellipsis_operator] = ACTIONS(14838),
    [sym__plus_operator] = ACTIONS(14840),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14840),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8868] = {
    [sym__word_identifier] = ACTIONS(13534),
    [anon_sym_EQ] = ACTIONS(13534),
    [anon_sym_COMMA] = ACTIONS(13534),
    [anon_sym_COLON] = ACTIONS(13534),
    [anon_sym_begin] = ACTIONS(13534),
    [anon_sym_module] = ACTIONS(13534),
    [anon_sym_baremodule] = ACTIONS(13534),
    [anon_sym_abstract] = ACTIONS(13534),
    [anon_sym_primitive] = ACTIONS(13534),
    [anon_sym_mutable] = ACTIONS(13534),
    [anon_sym_struct] = ACTIONS(13534),
    [anon_sym_function] = ACTIONS(13534),
    [anon_sym_macro] = ACTIONS(13534),
    [anon_sym_where] = ACTIONS(13534),
    [anon_sym_quote] = ACTIONS(13534),
    [anon_sym_let] = ACTIONS(13534),
    [anon_sym_if] = ACTIONS(13534),
    [anon_sym_try] = ACTIONS(13534),
    [anon_sym_for] = ACTIONS(13534),
    [anon_sym_while] = ACTIONS(13534),
    [sym_break_statement] = ACTIONS(13534),
    [sym_continue_statement] = ACTIONS(13534),
    [anon_sym_return] = ACTIONS(13534),
    [anon_sym_const] = ACTIONS(13534),
    [anon_sym_global] = ACTIONS(13534),
    [anon_sym_local] = ACTIONS(13534),
    [anon_sym_LPAREN] = ACTIONS(13534),
    [anon_sym_RPAREN] = ACTIONS(13534),
    [anon_sym_COLON2] = ACTIONS(13534),
    [anon_sym_export] = ACTIONS(13534),
    [anon_sym_import] = ACTIONS(13534),
    [anon_sym_using] = ACTIONS(13534),
    [anon_sym_LBRACK] = ACTIONS(13534),
    [anon_sym_LF] = ACTIONS(13536),
    [anon_sym_in] = ACTIONS(13534),
    [anon_sym_SEMI] = ACTIONS(13534),
    [anon_sym_LBRACE] = ACTIONS(13534),
    [anon_sym_DOLLAR] = ACTIONS(13534),
    [anon_sym_COLON_COLON] = ACTIONS(13534),
    [anon_sym_isa] = ACTIONS(13534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13534),
    [anon_sym_QMARK] = ACTIONS(13534),
    [anon_sym_AT] = ACTIONS(13534),
    [anon_sym_true] = ACTIONS(13534),
    [anon_sym_false] = ACTIONS(13534),
    [aux_sym_integer_literal_token1] = ACTIONS(13534),
    [aux_sym_integer_literal_token2] = ACTIONS(13534),
    [aux_sym_integer_literal_token3] = ACTIONS(13534),
    [aux_sym_integer_literal_token4] = ACTIONS(13534),
    [aux_sym_float_literal_token1] = ACTIONS(13534),
    [aux_sym_float_literal_token3] = ACTIONS(13534),
    [aux_sym_float_literal_token4] = ACTIONS(13534),
    [sym_character_literal] = ACTIONS(13534),
    [sym__pair_operator] = ACTIONS(13534),
    [sym__arrow_operator] = ACTIONS(13534),
    [sym__lazy_or_operator] = ACTIONS(13534),
    [sym__lazy_and_operator] = ACTIONS(13534),
    [sym__comparison_operator] = ACTIONS(13534),
    [sym__pipe_right_operator] = ACTIONS(13534),
    [sym__pipe_left_operator] = ACTIONS(13534),
    [sym__ellipsis_operator] = ACTIONS(13534),
    [sym__plus_operator] = ACTIONS(13534),
    [sym__times_operator] = ACTIONS(13534),
    [sym__rational_operator] = ACTIONS(13534),
    [sym__bitshift_operator] = ACTIONS(13534),
    [sym__power_operator] = ACTIONS(13534),
    [sym__tilde_operator] = ACTIONS(13534),
    [sym__type_order_operator] = ACTIONS(13534),
    [sym__unary_operator] = ACTIONS(13534),
    [sym__unary_plus_operator] = ACTIONS(13534),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13536),
    [sym__command_start] = ACTIONS(13536),
  },
  [8869] = {
    [sym__word_identifier] = ACTIONS(13538),
    [anon_sym_EQ] = ACTIONS(13538),
    [anon_sym_COMMA] = ACTIONS(13538),
    [anon_sym_COLON] = ACTIONS(13538),
    [anon_sym_begin] = ACTIONS(13538),
    [anon_sym_module] = ACTIONS(13538),
    [anon_sym_baremodule] = ACTIONS(13538),
    [anon_sym_abstract] = ACTIONS(13538),
    [anon_sym_primitive] = ACTIONS(13538),
    [anon_sym_mutable] = ACTIONS(13538),
    [anon_sym_struct] = ACTIONS(13538),
    [anon_sym_function] = ACTIONS(13538),
    [anon_sym_macro] = ACTIONS(13538),
    [anon_sym_where] = ACTIONS(13538),
    [anon_sym_quote] = ACTIONS(13538),
    [anon_sym_let] = ACTIONS(13538),
    [anon_sym_if] = ACTIONS(13538),
    [anon_sym_try] = ACTIONS(13538),
    [anon_sym_for] = ACTIONS(13538),
    [anon_sym_while] = ACTIONS(13538),
    [sym_break_statement] = ACTIONS(13538),
    [sym_continue_statement] = ACTIONS(13538),
    [anon_sym_return] = ACTIONS(13538),
    [anon_sym_const] = ACTIONS(13538),
    [anon_sym_global] = ACTIONS(13538),
    [anon_sym_local] = ACTIONS(13538),
    [anon_sym_LPAREN] = ACTIONS(13538),
    [anon_sym_RPAREN] = ACTIONS(13538),
    [anon_sym_COLON2] = ACTIONS(13538),
    [anon_sym_export] = ACTIONS(13538),
    [anon_sym_import] = ACTIONS(13538),
    [anon_sym_using] = ACTIONS(13538),
    [anon_sym_LBRACK] = ACTIONS(13538),
    [anon_sym_LF] = ACTIONS(13540),
    [anon_sym_in] = ACTIONS(13538),
    [anon_sym_SEMI] = ACTIONS(13538),
    [anon_sym_LBRACE] = ACTIONS(13538),
    [anon_sym_DOLLAR] = ACTIONS(13538),
    [anon_sym_COLON_COLON] = ACTIONS(13538),
    [anon_sym_isa] = ACTIONS(13538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13538),
    [anon_sym_QMARK] = ACTIONS(13538),
    [anon_sym_AT] = ACTIONS(13538),
    [anon_sym_true] = ACTIONS(13538),
    [anon_sym_false] = ACTIONS(13538),
    [aux_sym_integer_literal_token1] = ACTIONS(13538),
    [aux_sym_integer_literal_token2] = ACTIONS(13538),
    [aux_sym_integer_literal_token3] = ACTIONS(13538),
    [aux_sym_integer_literal_token4] = ACTIONS(13538),
    [aux_sym_float_literal_token1] = ACTIONS(13538),
    [aux_sym_float_literal_token3] = ACTIONS(13538),
    [aux_sym_float_literal_token4] = ACTIONS(13538),
    [sym_character_literal] = ACTIONS(13538),
    [sym__pair_operator] = ACTIONS(13538),
    [sym__arrow_operator] = ACTIONS(13538),
    [sym__lazy_or_operator] = ACTIONS(13538),
    [sym__lazy_and_operator] = ACTIONS(13538),
    [sym__comparison_operator] = ACTIONS(13538),
    [sym__pipe_right_operator] = ACTIONS(13538),
    [sym__pipe_left_operator] = ACTIONS(13538),
    [sym__ellipsis_operator] = ACTIONS(13538),
    [sym__plus_operator] = ACTIONS(13538),
    [sym__times_operator] = ACTIONS(13538),
    [sym__rational_operator] = ACTIONS(13538),
    [sym__bitshift_operator] = ACTIONS(13538),
    [sym__power_operator] = ACTIONS(13538),
    [sym__tilde_operator] = ACTIONS(13538),
    [sym__type_order_operator] = ACTIONS(13538),
    [sym__unary_operator] = ACTIONS(13538),
    [sym__unary_plus_operator] = ACTIONS(13538),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13540),
    [sym__command_start] = ACTIONS(13540),
  },
  [8870] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8871] = {
    [sym__word_identifier] = ACTIONS(13542),
    [anon_sym_EQ] = ACTIONS(13542),
    [anon_sym_COMMA] = ACTIONS(13542),
    [anon_sym_COLON] = ACTIONS(13542),
    [anon_sym_begin] = ACTIONS(13542),
    [anon_sym_module] = ACTIONS(13542),
    [anon_sym_baremodule] = ACTIONS(13542),
    [anon_sym_abstract] = ACTIONS(13542),
    [anon_sym_primitive] = ACTIONS(13542),
    [anon_sym_mutable] = ACTIONS(13542),
    [anon_sym_struct] = ACTIONS(13542),
    [anon_sym_function] = ACTIONS(13542),
    [anon_sym_macro] = ACTIONS(13542),
    [anon_sym_where] = ACTIONS(13542),
    [anon_sym_quote] = ACTIONS(13542),
    [anon_sym_let] = ACTIONS(13542),
    [anon_sym_if] = ACTIONS(13542),
    [anon_sym_try] = ACTIONS(13542),
    [anon_sym_for] = ACTIONS(13542),
    [anon_sym_while] = ACTIONS(13542),
    [sym_break_statement] = ACTIONS(13542),
    [sym_continue_statement] = ACTIONS(13542),
    [anon_sym_return] = ACTIONS(13542),
    [anon_sym_const] = ACTIONS(13542),
    [anon_sym_global] = ACTIONS(13542),
    [anon_sym_local] = ACTIONS(13542),
    [anon_sym_LPAREN] = ACTIONS(13542),
    [anon_sym_RPAREN] = ACTIONS(13542),
    [anon_sym_COLON2] = ACTIONS(13542),
    [anon_sym_export] = ACTIONS(13542),
    [anon_sym_import] = ACTIONS(13542),
    [anon_sym_using] = ACTIONS(13542),
    [anon_sym_LBRACK] = ACTIONS(13542),
    [anon_sym_LF] = ACTIONS(13544),
    [anon_sym_in] = ACTIONS(13542),
    [anon_sym_SEMI] = ACTIONS(13542),
    [anon_sym_LBRACE] = ACTIONS(13542),
    [anon_sym_DOLLAR] = ACTIONS(13542),
    [anon_sym_COLON_COLON] = ACTIONS(13542),
    [anon_sym_isa] = ACTIONS(13542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13542),
    [anon_sym_QMARK] = ACTIONS(13542),
    [anon_sym_AT] = ACTIONS(13542),
    [anon_sym_true] = ACTIONS(13542),
    [anon_sym_false] = ACTIONS(13542),
    [aux_sym_integer_literal_token1] = ACTIONS(13542),
    [aux_sym_integer_literal_token2] = ACTIONS(13542),
    [aux_sym_integer_literal_token3] = ACTIONS(13542),
    [aux_sym_integer_literal_token4] = ACTIONS(13542),
    [aux_sym_float_literal_token1] = ACTIONS(13542),
    [aux_sym_float_literal_token3] = ACTIONS(13542),
    [aux_sym_float_literal_token4] = ACTIONS(13542),
    [sym_character_literal] = ACTIONS(13542),
    [sym__pair_operator] = ACTIONS(13542),
    [sym__arrow_operator] = ACTIONS(13542),
    [sym__lazy_or_operator] = ACTIONS(13542),
    [sym__lazy_and_operator] = ACTIONS(13542),
    [sym__comparison_operator] = ACTIONS(13542),
    [sym__pipe_right_operator] = ACTIONS(13542),
    [sym__pipe_left_operator] = ACTIONS(13542),
    [sym__ellipsis_operator] = ACTIONS(13542),
    [sym__plus_operator] = ACTIONS(13542),
    [sym__times_operator] = ACTIONS(13542),
    [sym__rational_operator] = ACTIONS(13542),
    [sym__bitshift_operator] = ACTIONS(13542),
    [sym__power_operator] = ACTIONS(13542),
    [sym__tilde_operator] = ACTIONS(13542),
    [sym__type_order_operator] = ACTIONS(13542),
    [sym__unary_operator] = ACTIONS(13542),
    [sym__unary_plus_operator] = ACTIONS(13542),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13544),
    [sym__command_start] = ACTIONS(13544),
  },
  [8872] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14812),
    [sym__pipe_left_operator] = ACTIONS(14814),
    [sym__ellipsis_operator] = ACTIONS(14816),
    [sym__plus_operator] = ACTIONS(14818),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14818),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8873] = {
    [sym__word_identifier] = ACTIONS(13546),
    [anon_sym_EQ] = ACTIONS(13546),
    [anon_sym_COMMA] = ACTIONS(13546),
    [anon_sym_COLON] = ACTIONS(13546),
    [anon_sym_begin] = ACTIONS(13546),
    [anon_sym_module] = ACTIONS(13546),
    [anon_sym_baremodule] = ACTIONS(13546),
    [anon_sym_abstract] = ACTIONS(13546),
    [anon_sym_primitive] = ACTIONS(13546),
    [anon_sym_mutable] = ACTIONS(13546),
    [anon_sym_struct] = ACTIONS(13546),
    [anon_sym_function] = ACTIONS(13546),
    [anon_sym_macro] = ACTIONS(13546),
    [anon_sym_where] = ACTIONS(13546),
    [anon_sym_quote] = ACTIONS(13546),
    [anon_sym_let] = ACTIONS(13546),
    [anon_sym_if] = ACTIONS(13546),
    [anon_sym_try] = ACTIONS(13546),
    [anon_sym_for] = ACTIONS(13546),
    [anon_sym_while] = ACTIONS(13546),
    [sym_break_statement] = ACTIONS(13546),
    [sym_continue_statement] = ACTIONS(13546),
    [anon_sym_return] = ACTIONS(13546),
    [anon_sym_const] = ACTIONS(13546),
    [anon_sym_global] = ACTIONS(13546),
    [anon_sym_local] = ACTIONS(13546),
    [anon_sym_LPAREN] = ACTIONS(13546),
    [anon_sym_RPAREN] = ACTIONS(13546),
    [anon_sym_COLON2] = ACTIONS(13546),
    [anon_sym_export] = ACTIONS(13546),
    [anon_sym_import] = ACTIONS(13546),
    [anon_sym_using] = ACTIONS(13546),
    [anon_sym_LBRACK] = ACTIONS(13546),
    [anon_sym_LF] = ACTIONS(13548),
    [anon_sym_in] = ACTIONS(13546),
    [anon_sym_SEMI] = ACTIONS(13546),
    [anon_sym_LBRACE] = ACTIONS(13546),
    [anon_sym_DOLLAR] = ACTIONS(13546),
    [anon_sym_COLON_COLON] = ACTIONS(13546),
    [anon_sym_isa] = ACTIONS(13546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13546),
    [anon_sym_QMARK] = ACTIONS(13546),
    [anon_sym_AT] = ACTIONS(13546),
    [anon_sym_true] = ACTIONS(13546),
    [anon_sym_false] = ACTIONS(13546),
    [aux_sym_integer_literal_token1] = ACTIONS(13546),
    [aux_sym_integer_literal_token2] = ACTIONS(13546),
    [aux_sym_integer_literal_token3] = ACTIONS(13546),
    [aux_sym_integer_literal_token4] = ACTIONS(13546),
    [aux_sym_float_literal_token1] = ACTIONS(13546),
    [aux_sym_float_literal_token3] = ACTIONS(13546),
    [aux_sym_float_literal_token4] = ACTIONS(13546),
    [sym_character_literal] = ACTIONS(13546),
    [sym__pair_operator] = ACTIONS(13546),
    [sym__arrow_operator] = ACTIONS(13546),
    [sym__lazy_or_operator] = ACTIONS(13546),
    [sym__lazy_and_operator] = ACTIONS(13546),
    [sym__comparison_operator] = ACTIONS(13546),
    [sym__pipe_right_operator] = ACTIONS(13546),
    [sym__pipe_left_operator] = ACTIONS(13546),
    [sym__ellipsis_operator] = ACTIONS(13546),
    [sym__plus_operator] = ACTIONS(13546),
    [sym__times_operator] = ACTIONS(13546),
    [sym__rational_operator] = ACTIONS(13546),
    [sym__bitshift_operator] = ACTIONS(13546),
    [sym__power_operator] = ACTIONS(13546),
    [sym__tilde_operator] = ACTIONS(13546),
    [sym__type_order_operator] = ACTIONS(13546),
    [sym__unary_operator] = ACTIONS(13546),
    [sym__unary_plus_operator] = ACTIONS(13546),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13548),
    [sym__command_start] = ACTIONS(13548),
  },
  [8874] = {
    [sym__word_identifier] = ACTIONS(13550),
    [anon_sym_EQ] = ACTIONS(13550),
    [anon_sym_COMMA] = ACTIONS(13550),
    [anon_sym_COLON] = ACTIONS(13550),
    [anon_sym_begin] = ACTIONS(13550),
    [anon_sym_module] = ACTIONS(13550),
    [anon_sym_baremodule] = ACTIONS(13550),
    [anon_sym_abstract] = ACTIONS(13550),
    [anon_sym_primitive] = ACTIONS(13550),
    [anon_sym_mutable] = ACTIONS(13550),
    [anon_sym_struct] = ACTIONS(13550),
    [anon_sym_function] = ACTIONS(13550),
    [anon_sym_macro] = ACTIONS(13550),
    [anon_sym_where] = ACTIONS(13550),
    [anon_sym_quote] = ACTIONS(13550),
    [anon_sym_let] = ACTIONS(13550),
    [anon_sym_if] = ACTIONS(13550),
    [anon_sym_try] = ACTIONS(13550),
    [anon_sym_for] = ACTIONS(13550),
    [anon_sym_while] = ACTIONS(13550),
    [sym_break_statement] = ACTIONS(13550),
    [sym_continue_statement] = ACTIONS(13550),
    [anon_sym_return] = ACTIONS(13550),
    [anon_sym_const] = ACTIONS(13550),
    [anon_sym_global] = ACTIONS(13550),
    [anon_sym_local] = ACTIONS(13550),
    [anon_sym_LPAREN] = ACTIONS(13550),
    [anon_sym_RPAREN] = ACTIONS(13550),
    [anon_sym_COLON2] = ACTIONS(13550),
    [anon_sym_export] = ACTIONS(13550),
    [anon_sym_import] = ACTIONS(13550),
    [anon_sym_using] = ACTIONS(13550),
    [anon_sym_LBRACK] = ACTIONS(13550),
    [anon_sym_LF] = ACTIONS(13552),
    [anon_sym_in] = ACTIONS(13550),
    [anon_sym_SEMI] = ACTIONS(13550),
    [anon_sym_LBRACE] = ACTIONS(13550),
    [anon_sym_DOLLAR] = ACTIONS(13550),
    [anon_sym_COLON_COLON] = ACTIONS(13550),
    [anon_sym_isa] = ACTIONS(13550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13550),
    [anon_sym_QMARK] = ACTIONS(13550),
    [anon_sym_AT] = ACTIONS(13550),
    [anon_sym_true] = ACTIONS(13550),
    [anon_sym_false] = ACTIONS(13550),
    [aux_sym_integer_literal_token1] = ACTIONS(13550),
    [aux_sym_integer_literal_token2] = ACTIONS(13550),
    [aux_sym_integer_literal_token3] = ACTIONS(13550),
    [aux_sym_integer_literal_token4] = ACTIONS(13550),
    [aux_sym_float_literal_token1] = ACTIONS(13550),
    [aux_sym_float_literal_token3] = ACTIONS(13550),
    [aux_sym_float_literal_token4] = ACTIONS(13550),
    [sym_character_literal] = ACTIONS(13550),
    [sym__pair_operator] = ACTIONS(13550),
    [sym__arrow_operator] = ACTIONS(13550),
    [sym__lazy_or_operator] = ACTIONS(13550),
    [sym__lazy_and_operator] = ACTIONS(13550),
    [sym__comparison_operator] = ACTIONS(13550),
    [sym__pipe_right_operator] = ACTIONS(13550),
    [sym__pipe_left_operator] = ACTIONS(13550),
    [sym__ellipsis_operator] = ACTIONS(13550),
    [sym__plus_operator] = ACTIONS(13550),
    [sym__times_operator] = ACTIONS(13550),
    [sym__rational_operator] = ACTIONS(13550),
    [sym__bitshift_operator] = ACTIONS(13550),
    [sym__power_operator] = ACTIONS(13550),
    [sym__tilde_operator] = ACTIONS(13550),
    [sym__type_order_operator] = ACTIONS(13550),
    [sym__unary_operator] = ACTIONS(13550),
    [sym__unary_plus_operator] = ACTIONS(13550),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13552),
    [sym__command_start] = ACTIONS(13552),
  },
  [8875] = {
    [sym__word_identifier] = ACTIONS(13554),
    [anon_sym_EQ] = ACTIONS(13554),
    [anon_sym_COMMA] = ACTIONS(13554),
    [anon_sym_COLON] = ACTIONS(13554),
    [anon_sym_begin] = ACTIONS(13554),
    [anon_sym_module] = ACTIONS(13554),
    [anon_sym_baremodule] = ACTIONS(13554),
    [anon_sym_abstract] = ACTIONS(13554),
    [anon_sym_primitive] = ACTIONS(13554),
    [anon_sym_mutable] = ACTIONS(13554),
    [anon_sym_struct] = ACTIONS(13554),
    [anon_sym_function] = ACTIONS(13554),
    [anon_sym_macro] = ACTIONS(13554),
    [anon_sym_where] = ACTIONS(13554),
    [anon_sym_quote] = ACTIONS(13554),
    [anon_sym_let] = ACTIONS(13554),
    [anon_sym_if] = ACTIONS(13554),
    [anon_sym_try] = ACTIONS(13554),
    [anon_sym_for] = ACTIONS(13554),
    [anon_sym_while] = ACTIONS(13554),
    [sym_break_statement] = ACTIONS(13554),
    [sym_continue_statement] = ACTIONS(13554),
    [anon_sym_return] = ACTIONS(13554),
    [anon_sym_const] = ACTIONS(13554),
    [anon_sym_global] = ACTIONS(13554),
    [anon_sym_local] = ACTIONS(13554),
    [anon_sym_LPAREN] = ACTIONS(13554),
    [anon_sym_RPAREN] = ACTIONS(13554),
    [anon_sym_COLON2] = ACTIONS(13554),
    [anon_sym_export] = ACTIONS(13554),
    [anon_sym_import] = ACTIONS(13554),
    [anon_sym_using] = ACTIONS(13554),
    [anon_sym_LBRACK] = ACTIONS(13554),
    [anon_sym_LF] = ACTIONS(13556),
    [anon_sym_in] = ACTIONS(13554),
    [anon_sym_SEMI] = ACTIONS(13554),
    [anon_sym_LBRACE] = ACTIONS(13554),
    [anon_sym_DOLLAR] = ACTIONS(13554),
    [anon_sym_COLON_COLON] = ACTIONS(13554),
    [anon_sym_isa] = ACTIONS(13554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13554),
    [anon_sym_QMARK] = ACTIONS(13554),
    [anon_sym_AT] = ACTIONS(13554),
    [anon_sym_true] = ACTIONS(13554),
    [anon_sym_false] = ACTIONS(13554),
    [aux_sym_integer_literal_token1] = ACTIONS(13554),
    [aux_sym_integer_literal_token2] = ACTIONS(13554),
    [aux_sym_integer_literal_token3] = ACTIONS(13554),
    [aux_sym_integer_literal_token4] = ACTIONS(13554),
    [aux_sym_float_literal_token1] = ACTIONS(13554),
    [aux_sym_float_literal_token3] = ACTIONS(13554),
    [aux_sym_float_literal_token4] = ACTIONS(13554),
    [sym_character_literal] = ACTIONS(13554),
    [sym__pair_operator] = ACTIONS(13554),
    [sym__arrow_operator] = ACTIONS(13554),
    [sym__lazy_or_operator] = ACTIONS(13554),
    [sym__lazy_and_operator] = ACTIONS(13554),
    [sym__comparison_operator] = ACTIONS(13554),
    [sym__pipe_right_operator] = ACTIONS(13554),
    [sym__pipe_left_operator] = ACTIONS(13554),
    [sym__ellipsis_operator] = ACTIONS(13554),
    [sym__plus_operator] = ACTIONS(13554),
    [sym__times_operator] = ACTIONS(13554),
    [sym__rational_operator] = ACTIONS(13554),
    [sym__bitshift_operator] = ACTIONS(13554),
    [sym__power_operator] = ACTIONS(13554),
    [sym__tilde_operator] = ACTIONS(13554),
    [sym__type_order_operator] = ACTIONS(13554),
    [sym__unary_operator] = ACTIONS(13554),
    [sym__unary_plus_operator] = ACTIONS(13554),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13556),
    [sym__command_start] = ACTIONS(13556),
  },
  [8876] = {
    [sym__word_identifier] = ACTIONS(13558),
    [anon_sym_EQ] = ACTIONS(13558),
    [anon_sym_COMMA] = ACTIONS(13558),
    [anon_sym_COLON] = ACTIONS(13558),
    [anon_sym_begin] = ACTIONS(13558),
    [anon_sym_module] = ACTIONS(13558),
    [anon_sym_baremodule] = ACTIONS(13558),
    [anon_sym_abstract] = ACTIONS(13558),
    [anon_sym_primitive] = ACTIONS(13558),
    [anon_sym_mutable] = ACTIONS(13558),
    [anon_sym_struct] = ACTIONS(13558),
    [anon_sym_function] = ACTIONS(13558),
    [anon_sym_macro] = ACTIONS(13558),
    [anon_sym_where] = ACTIONS(13558),
    [anon_sym_quote] = ACTIONS(13558),
    [anon_sym_let] = ACTIONS(13558),
    [anon_sym_if] = ACTIONS(13558),
    [anon_sym_try] = ACTIONS(13558),
    [anon_sym_for] = ACTIONS(13558),
    [anon_sym_while] = ACTIONS(13558),
    [sym_break_statement] = ACTIONS(13558),
    [sym_continue_statement] = ACTIONS(13558),
    [anon_sym_return] = ACTIONS(13558),
    [anon_sym_const] = ACTIONS(13558),
    [anon_sym_global] = ACTIONS(13558),
    [anon_sym_local] = ACTIONS(13558),
    [anon_sym_LPAREN] = ACTIONS(13558),
    [anon_sym_RPAREN] = ACTIONS(13558),
    [anon_sym_COLON2] = ACTIONS(13558),
    [anon_sym_export] = ACTIONS(13558),
    [anon_sym_import] = ACTIONS(13558),
    [anon_sym_using] = ACTIONS(13558),
    [anon_sym_LBRACK] = ACTIONS(13558),
    [anon_sym_LF] = ACTIONS(13560),
    [anon_sym_in] = ACTIONS(13558),
    [anon_sym_SEMI] = ACTIONS(13558),
    [anon_sym_LBRACE] = ACTIONS(13558),
    [anon_sym_DOLLAR] = ACTIONS(13558),
    [anon_sym_COLON_COLON] = ACTIONS(13558),
    [anon_sym_isa] = ACTIONS(13558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13558),
    [anon_sym_QMARK] = ACTIONS(13558),
    [anon_sym_AT] = ACTIONS(13558),
    [anon_sym_true] = ACTIONS(13558),
    [anon_sym_false] = ACTIONS(13558),
    [aux_sym_integer_literal_token1] = ACTIONS(13558),
    [aux_sym_integer_literal_token2] = ACTIONS(13558),
    [aux_sym_integer_literal_token3] = ACTIONS(13558),
    [aux_sym_integer_literal_token4] = ACTIONS(13558),
    [aux_sym_float_literal_token1] = ACTIONS(13558),
    [aux_sym_float_literal_token3] = ACTIONS(13558),
    [aux_sym_float_literal_token4] = ACTIONS(13558),
    [sym_character_literal] = ACTIONS(13558),
    [sym__pair_operator] = ACTIONS(13558),
    [sym__arrow_operator] = ACTIONS(13558),
    [sym__lazy_or_operator] = ACTIONS(13558),
    [sym__lazy_and_operator] = ACTIONS(13558),
    [sym__comparison_operator] = ACTIONS(13558),
    [sym__pipe_right_operator] = ACTIONS(13558),
    [sym__pipe_left_operator] = ACTIONS(13558),
    [sym__ellipsis_operator] = ACTIONS(13558),
    [sym__plus_operator] = ACTIONS(13558),
    [sym__times_operator] = ACTIONS(13558),
    [sym__rational_operator] = ACTIONS(13558),
    [sym__bitshift_operator] = ACTIONS(13558),
    [sym__power_operator] = ACTIONS(13558),
    [sym__tilde_operator] = ACTIONS(13558),
    [sym__type_order_operator] = ACTIONS(13558),
    [sym__unary_operator] = ACTIONS(13558),
    [sym__unary_plus_operator] = ACTIONS(13558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13560),
    [sym__command_start] = ACTIONS(13560),
  },
  [8877] = {
    [sym__word_identifier] = ACTIONS(13562),
    [anon_sym_EQ] = ACTIONS(13562),
    [anon_sym_COMMA] = ACTIONS(13562),
    [anon_sym_COLON] = ACTIONS(13562),
    [anon_sym_begin] = ACTIONS(13562),
    [anon_sym_module] = ACTIONS(13562),
    [anon_sym_baremodule] = ACTIONS(13562),
    [anon_sym_abstract] = ACTIONS(13562),
    [anon_sym_primitive] = ACTIONS(13562),
    [anon_sym_mutable] = ACTIONS(13562),
    [anon_sym_struct] = ACTIONS(13562),
    [anon_sym_function] = ACTIONS(13562),
    [anon_sym_macro] = ACTIONS(13562),
    [anon_sym_where] = ACTIONS(13562),
    [anon_sym_quote] = ACTIONS(13562),
    [anon_sym_let] = ACTIONS(13562),
    [anon_sym_if] = ACTIONS(13562),
    [anon_sym_try] = ACTIONS(13562),
    [anon_sym_for] = ACTIONS(13562),
    [anon_sym_while] = ACTIONS(13562),
    [sym_break_statement] = ACTIONS(13562),
    [sym_continue_statement] = ACTIONS(13562),
    [anon_sym_return] = ACTIONS(13562),
    [anon_sym_const] = ACTIONS(13562),
    [anon_sym_global] = ACTIONS(13562),
    [anon_sym_local] = ACTIONS(13562),
    [anon_sym_LPAREN] = ACTIONS(13562),
    [anon_sym_RPAREN] = ACTIONS(13562),
    [anon_sym_COLON2] = ACTIONS(13562),
    [anon_sym_export] = ACTIONS(13562),
    [anon_sym_import] = ACTIONS(13562),
    [anon_sym_using] = ACTIONS(13562),
    [anon_sym_LBRACK] = ACTIONS(13562),
    [anon_sym_LF] = ACTIONS(13564),
    [anon_sym_in] = ACTIONS(13562),
    [anon_sym_SEMI] = ACTIONS(13562),
    [anon_sym_LBRACE] = ACTIONS(13562),
    [anon_sym_DOLLAR] = ACTIONS(13562),
    [anon_sym_COLON_COLON] = ACTIONS(13562),
    [anon_sym_isa] = ACTIONS(13562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13562),
    [anon_sym_QMARK] = ACTIONS(13562),
    [anon_sym_AT] = ACTIONS(13562),
    [anon_sym_true] = ACTIONS(13562),
    [anon_sym_false] = ACTIONS(13562),
    [aux_sym_integer_literal_token1] = ACTIONS(13562),
    [aux_sym_integer_literal_token2] = ACTIONS(13562),
    [aux_sym_integer_literal_token3] = ACTIONS(13562),
    [aux_sym_integer_literal_token4] = ACTIONS(13562),
    [aux_sym_float_literal_token1] = ACTIONS(13562),
    [aux_sym_float_literal_token3] = ACTIONS(13562),
    [aux_sym_float_literal_token4] = ACTIONS(13562),
    [sym_character_literal] = ACTIONS(13562),
    [sym__pair_operator] = ACTIONS(13562),
    [sym__arrow_operator] = ACTIONS(13562),
    [sym__lazy_or_operator] = ACTIONS(13562),
    [sym__lazy_and_operator] = ACTIONS(13562),
    [sym__comparison_operator] = ACTIONS(13562),
    [sym__pipe_right_operator] = ACTIONS(13562),
    [sym__pipe_left_operator] = ACTIONS(13562),
    [sym__ellipsis_operator] = ACTIONS(13562),
    [sym__plus_operator] = ACTIONS(13562),
    [sym__times_operator] = ACTIONS(13562),
    [sym__rational_operator] = ACTIONS(13562),
    [sym__bitshift_operator] = ACTIONS(13562),
    [sym__power_operator] = ACTIONS(13562),
    [sym__tilde_operator] = ACTIONS(13562),
    [sym__type_order_operator] = ACTIONS(13562),
    [sym__unary_operator] = ACTIONS(13562),
    [sym__unary_plus_operator] = ACTIONS(13562),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13564),
    [sym__command_start] = ACTIONS(13564),
  },
  [8878] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8879] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14850),
    [sym__arrow_operator] = ACTIONS(14852),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1211),
    [sym__pipe_right_operator] = ACTIONS(14812),
    [sym__pipe_left_operator] = ACTIONS(14814),
    [sym__ellipsis_operator] = ACTIONS(14816),
    [sym__plus_operator] = ACTIONS(14818),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(1211),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14818),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8880] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12724),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8881] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14852),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1211),
    [sym__pipe_right_operator] = ACTIONS(14812),
    [sym__pipe_left_operator] = ACTIONS(14814),
    [sym__ellipsis_operator] = ACTIONS(14816),
    [sym__plus_operator] = ACTIONS(14818),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(1211),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14818),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8882] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1211),
    [sym__pipe_right_operator] = ACTIONS(14812),
    [sym__pipe_left_operator] = ACTIONS(14814),
    [sym__ellipsis_operator] = ACTIONS(14816),
    [sym__plus_operator] = ACTIONS(14818),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(1211),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14818),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8883] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_RPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13255),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14808),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8884] = {
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13094),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_RPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13094),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13094),
    [anon_sym_SEMI] = ACTIONS(13094),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13094),
    [anon_sym_isa] = ACTIONS(13094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13094),
    [anon_sym_QMARK] = ACTIONS(13094),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13094),
    [sym__lazy_or_operator] = ACTIONS(13094),
    [sym__lazy_and_operator] = ACTIONS(13094),
    [sym__comparison_operator] = ACTIONS(13094),
    [sym__pipe_right_operator] = ACTIONS(13094),
    [sym__pipe_left_operator] = ACTIONS(13094),
    [sym__ellipsis_operator] = ACTIONS(13094),
    [sym__plus_operator] = ACTIONS(13094),
    [sym__times_operator] = ACTIONS(13094),
    [sym__rational_operator] = ACTIONS(13094),
    [sym__bitshift_operator] = ACTIONS(13094),
    [sym__power_operator] = ACTIONS(13094),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13094),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8885] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(1211),
    [sym__pipe_right_operator] = ACTIONS(14812),
    [sym__pipe_left_operator] = ACTIONS(14814),
    [sym__ellipsis_operator] = ACTIONS(14816),
    [sym__plus_operator] = ACTIONS(14818),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(1211),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14818),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8886] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14816),
    [sym__plus_operator] = ACTIONS(14818),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14818),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8887] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14854),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14830),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14832),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14856),
    [sym__arrow_operator] = ACTIONS(14858),
    [sym__lazy_or_operator] = ACTIONS(14860),
    [sym__lazy_and_operator] = ACTIONS(14862),
    [sym__comparison_operator] = ACTIONS(14832),
    [sym__pipe_right_operator] = ACTIONS(14834),
    [sym__pipe_left_operator] = ACTIONS(14836),
    [sym__ellipsis_operator] = ACTIONS(14838),
    [sym__plus_operator] = ACTIONS(14840),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14832),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14840),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8888] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14854),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14830),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14832),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14858),
    [sym__lazy_or_operator] = ACTIONS(14860),
    [sym__lazy_and_operator] = ACTIONS(14862),
    [sym__comparison_operator] = ACTIONS(14832),
    [sym__pipe_right_operator] = ACTIONS(14834),
    [sym__pipe_left_operator] = ACTIONS(14836),
    [sym__ellipsis_operator] = ACTIONS(14838),
    [sym__plus_operator] = ACTIONS(14840),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14832),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14840),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8889] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14854),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14830),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14832),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14862),
    [sym__comparison_operator] = ACTIONS(14832),
    [sym__pipe_right_operator] = ACTIONS(14834),
    [sym__pipe_left_operator] = ACTIONS(14836),
    [sym__ellipsis_operator] = ACTIONS(14838),
    [sym__plus_operator] = ACTIONS(14840),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14832),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14840),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8890] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14854),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14830),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14832),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14832),
    [sym__pipe_right_operator] = ACTIONS(14834),
    [sym__pipe_left_operator] = ACTIONS(14836),
    [sym__ellipsis_operator] = ACTIONS(14838),
    [sym__plus_operator] = ACTIONS(14840),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14832),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14840),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8891] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14812),
    [sym__pipe_left_operator] = ACTIONS(14814),
    [sym__ellipsis_operator] = ACTIONS(14816),
    [sym__plus_operator] = ACTIONS(14818),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14818),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8892] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14830),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14838),
    [sym__plus_operator] = ACTIONS(14840),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14840),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8893] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14818),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14818),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8894] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14830),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14834),
    [sym__pipe_left_operator] = ACTIONS(14836),
    [sym__ellipsis_operator] = ACTIONS(14838),
    [sym__plus_operator] = ACTIONS(14840),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14840),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8895] = {
    [sym__word_identifier] = ACTIONS(13566),
    [anon_sym_EQ] = ACTIONS(13566),
    [anon_sym_COMMA] = ACTIONS(13566),
    [anon_sym_COLON] = ACTIONS(13566),
    [anon_sym_begin] = ACTIONS(13566),
    [anon_sym_module] = ACTIONS(13566),
    [anon_sym_baremodule] = ACTIONS(13566),
    [anon_sym_abstract] = ACTIONS(13566),
    [anon_sym_primitive] = ACTIONS(13566),
    [anon_sym_mutable] = ACTIONS(13566),
    [anon_sym_struct] = ACTIONS(13566),
    [anon_sym_function] = ACTIONS(13566),
    [anon_sym_macro] = ACTIONS(13566),
    [anon_sym_where] = ACTIONS(13566),
    [anon_sym_quote] = ACTIONS(13566),
    [anon_sym_let] = ACTIONS(13566),
    [anon_sym_if] = ACTIONS(13566),
    [anon_sym_try] = ACTIONS(13566),
    [anon_sym_for] = ACTIONS(13566),
    [anon_sym_while] = ACTIONS(13566),
    [sym_break_statement] = ACTIONS(13566),
    [sym_continue_statement] = ACTIONS(13566),
    [anon_sym_return] = ACTIONS(13566),
    [anon_sym_const] = ACTIONS(13566),
    [anon_sym_global] = ACTIONS(13566),
    [anon_sym_local] = ACTIONS(13566),
    [anon_sym_LPAREN] = ACTIONS(13566),
    [anon_sym_RPAREN] = ACTIONS(13566),
    [anon_sym_COLON2] = ACTIONS(13566),
    [anon_sym_export] = ACTIONS(13566),
    [anon_sym_import] = ACTIONS(13566),
    [anon_sym_using] = ACTIONS(13566),
    [anon_sym_LBRACK] = ACTIONS(13566),
    [anon_sym_LF] = ACTIONS(13568),
    [anon_sym_in] = ACTIONS(13566),
    [anon_sym_SEMI] = ACTIONS(13566),
    [anon_sym_LBRACE] = ACTIONS(13566),
    [anon_sym_DOLLAR] = ACTIONS(13566),
    [anon_sym_COLON_COLON] = ACTIONS(13566),
    [anon_sym_isa] = ACTIONS(13566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13566),
    [anon_sym_QMARK] = ACTIONS(13566),
    [anon_sym_AT] = ACTIONS(13566),
    [anon_sym_true] = ACTIONS(13566),
    [anon_sym_false] = ACTIONS(13566),
    [aux_sym_integer_literal_token1] = ACTIONS(13566),
    [aux_sym_integer_literal_token2] = ACTIONS(13566),
    [aux_sym_integer_literal_token3] = ACTIONS(13566),
    [aux_sym_integer_literal_token4] = ACTIONS(13566),
    [aux_sym_float_literal_token1] = ACTIONS(13566),
    [aux_sym_float_literal_token3] = ACTIONS(13566),
    [aux_sym_float_literal_token4] = ACTIONS(13566),
    [sym_character_literal] = ACTIONS(13566),
    [sym__pair_operator] = ACTIONS(13566),
    [sym__arrow_operator] = ACTIONS(13566),
    [sym__lazy_or_operator] = ACTIONS(13566),
    [sym__lazy_and_operator] = ACTIONS(13566),
    [sym__comparison_operator] = ACTIONS(13566),
    [sym__pipe_right_operator] = ACTIONS(13566),
    [sym__pipe_left_operator] = ACTIONS(13566),
    [sym__ellipsis_operator] = ACTIONS(13566),
    [sym__plus_operator] = ACTIONS(13566),
    [sym__times_operator] = ACTIONS(13566),
    [sym__rational_operator] = ACTIONS(13566),
    [sym__bitshift_operator] = ACTIONS(13566),
    [sym__power_operator] = ACTIONS(13566),
    [sym__tilde_operator] = ACTIONS(13566),
    [sym__type_order_operator] = ACTIONS(13566),
    [sym__unary_operator] = ACTIONS(13566),
    [sym__unary_plus_operator] = ACTIONS(13566),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13568),
    [sym__command_start] = ACTIONS(13568),
  },
  [8896] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14840),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14840),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8897] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8898] = {
    [sym__word_identifier] = ACTIONS(13570),
    [anon_sym_EQ] = ACTIONS(13570),
    [anon_sym_COMMA] = ACTIONS(13570),
    [anon_sym_COLON] = ACTIONS(13570),
    [anon_sym_begin] = ACTIONS(13570),
    [anon_sym_module] = ACTIONS(13570),
    [anon_sym_baremodule] = ACTIONS(13570),
    [anon_sym_abstract] = ACTIONS(13570),
    [anon_sym_primitive] = ACTIONS(13570),
    [anon_sym_mutable] = ACTIONS(13570),
    [anon_sym_struct] = ACTIONS(13570),
    [anon_sym_function] = ACTIONS(13570),
    [anon_sym_macro] = ACTIONS(13570),
    [anon_sym_where] = ACTIONS(13570),
    [anon_sym_quote] = ACTIONS(13570),
    [anon_sym_let] = ACTIONS(13570),
    [anon_sym_if] = ACTIONS(13570),
    [anon_sym_try] = ACTIONS(13570),
    [anon_sym_for] = ACTIONS(13570),
    [anon_sym_while] = ACTIONS(13570),
    [sym_break_statement] = ACTIONS(13570),
    [sym_continue_statement] = ACTIONS(13570),
    [anon_sym_return] = ACTIONS(13570),
    [anon_sym_const] = ACTIONS(13570),
    [anon_sym_global] = ACTIONS(13570),
    [anon_sym_local] = ACTIONS(13570),
    [anon_sym_LPAREN] = ACTIONS(13570),
    [anon_sym_RPAREN] = ACTIONS(13570),
    [anon_sym_COLON2] = ACTIONS(13570),
    [anon_sym_export] = ACTIONS(13570),
    [anon_sym_import] = ACTIONS(13570),
    [anon_sym_using] = ACTIONS(13570),
    [anon_sym_LBRACK] = ACTIONS(13570),
    [anon_sym_LF] = ACTIONS(13572),
    [anon_sym_in] = ACTIONS(13570),
    [anon_sym_SEMI] = ACTIONS(13570),
    [anon_sym_LBRACE] = ACTIONS(13570),
    [anon_sym_DOLLAR] = ACTIONS(13570),
    [anon_sym_COLON_COLON] = ACTIONS(13570),
    [anon_sym_isa] = ACTIONS(13570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13570),
    [anon_sym_QMARK] = ACTIONS(13570),
    [anon_sym_AT] = ACTIONS(13570),
    [anon_sym_true] = ACTIONS(13570),
    [anon_sym_false] = ACTIONS(13570),
    [aux_sym_integer_literal_token1] = ACTIONS(13570),
    [aux_sym_integer_literal_token2] = ACTIONS(13570),
    [aux_sym_integer_literal_token3] = ACTIONS(13570),
    [aux_sym_integer_literal_token4] = ACTIONS(13570),
    [aux_sym_float_literal_token1] = ACTIONS(13570),
    [aux_sym_float_literal_token3] = ACTIONS(13570),
    [aux_sym_float_literal_token4] = ACTIONS(13570),
    [sym_character_literal] = ACTIONS(13570),
    [sym__pair_operator] = ACTIONS(13570),
    [sym__arrow_operator] = ACTIONS(13570),
    [sym__lazy_or_operator] = ACTIONS(13570),
    [sym__lazy_and_operator] = ACTIONS(13570),
    [sym__comparison_operator] = ACTIONS(13570),
    [sym__pipe_right_operator] = ACTIONS(13570),
    [sym__pipe_left_operator] = ACTIONS(13570),
    [sym__ellipsis_operator] = ACTIONS(13570),
    [sym__plus_operator] = ACTIONS(13570),
    [sym__times_operator] = ACTIONS(13570),
    [sym__rational_operator] = ACTIONS(13570),
    [sym__bitshift_operator] = ACTIONS(13570),
    [sym__power_operator] = ACTIONS(13570),
    [sym__tilde_operator] = ACTIONS(13570),
    [sym__type_order_operator] = ACTIONS(13570),
    [sym__unary_operator] = ACTIONS(13570),
    [sym__unary_plus_operator] = ACTIONS(13570),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13572),
    [sym__command_start] = ACTIONS(13572),
  },
  [8899] = {
    [sym__word_identifier] = ACTIONS(13574),
    [anon_sym_EQ] = ACTIONS(13574),
    [anon_sym_COMMA] = ACTIONS(13574),
    [anon_sym_COLON] = ACTIONS(13574),
    [anon_sym_begin] = ACTIONS(13574),
    [anon_sym_module] = ACTIONS(13574),
    [anon_sym_baremodule] = ACTIONS(13574),
    [anon_sym_abstract] = ACTIONS(13574),
    [anon_sym_primitive] = ACTIONS(13574),
    [anon_sym_mutable] = ACTIONS(13574),
    [anon_sym_struct] = ACTIONS(13574),
    [anon_sym_function] = ACTIONS(13574),
    [anon_sym_macro] = ACTIONS(13574),
    [anon_sym_where] = ACTIONS(13574),
    [anon_sym_quote] = ACTIONS(13574),
    [anon_sym_let] = ACTIONS(13574),
    [anon_sym_if] = ACTIONS(13574),
    [anon_sym_try] = ACTIONS(13574),
    [anon_sym_for] = ACTIONS(13574),
    [anon_sym_while] = ACTIONS(13574),
    [sym_break_statement] = ACTIONS(13574),
    [sym_continue_statement] = ACTIONS(13574),
    [anon_sym_return] = ACTIONS(13574),
    [anon_sym_const] = ACTIONS(13574),
    [anon_sym_global] = ACTIONS(13574),
    [anon_sym_local] = ACTIONS(13574),
    [anon_sym_LPAREN] = ACTIONS(13574),
    [anon_sym_RPAREN] = ACTIONS(13574),
    [anon_sym_COLON2] = ACTIONS(13574),
    [anon_sym_export] = ACTIONS(13574),
    [anon_sym_import] = ACTIONS(13574),
    [anon_sym_using] = ACTIONS(13574),
    [anon_sym_LBRACK] = ACTIONS(13574),
    [anon_sym_LF] = ACTIONS(13576),
    [anon_sym_in] = ACTIONS(13574),
    [anon_sym_SEMI] = ACTIONS(13574),
    [anon_sym_LBRACE] = ACTIONS(13574),
    [anon_sym_DOLLAR] = ACTIONS(13574),
    [anon_sym_COLON_COLON] = ACTIONS(13574),
    [anon_sym_isa] = ACTIONS(13574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13574),
    [anon_sym_QMARK] = ACTIONS(13574),
    [anon_sym_AT] = ACTIONS(13574),
    [anon_sym_true] = ACTIONS(13574),
    [anon_sym_false] = ACTIONS(13574),
    [aux_sym_integer_literal_token1] = ACTIONS(13574),
    [aux_sym_integer_literal_token2] = ACTIONS(13574),
    [aux_sym_integer_literal_token3] = ACTIONS(13574),
    [aux_sym_integer_literal_token4] = ACTIONS(13574),
    [aux_sym_float_literal_token1] = ACTIONS(13574),
    [aux_sym_float_literal_token3] = ACTIONS(13574),
    [aux_sym_float_literal_token4] = ACTIONS(13574),
    [sym_character_literal] = ACTIONS(13574),
    [sym__pair_operator] = ACTIONS(13574),
    [sym__arrow_operator] = ACTIONS(13574),
    [sym__lazy_or_operator] = ACTIONS(13574),
    [sym__lazy_and_operator] = ACTIONS(13574),
    [sym__comparison_operator] = ACTIONS(13574),
    [sym__pipe_right_operator] = ACTIONS(13574),
    [sym__pipe_left_operator] = ACTIONS(13574),
    [sym__ellipsis_operator] = ACTIONS(13574),
    [sym__plus_operator] = ACTIONS(13574),
    [sym__times_operator] = ACTIONS(13574),
    [sym__rational_operator] = ACTIONS(13574),
    [sym__bitshift_operator] = ACTIONS(13574),
    [sym__power_operator] = ACTIONS(13574),
    [sym__tilde_operator] = ACTIONS(13574),
    [sym__type_order_operator] = ACTIONS(13574),
    [sym__unary_operator] = ACTIONS(13574),
    [sym__unary_plus_operator] = ACTIONS(13574),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13576),
    [sym__command_start] = ACTIONS(13576),
  },
  [8900] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8901] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8902] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8903] = {
    [sym__word_identifier] = ACTIONS(13578),
    [anon_sym_EQ] = ACTIONS(13578),
    [anon_sym_COMMA] = ACTIONS(13578),
    [anon_sym_COLON] = ACTIONS(13578),
    [anon_sym_begin] = ACTIONS(13578),
    [anon_sym_module] = ACTIONS(13578),
    [anon_sym_baremodule] = ACTIONS(13578),
    [anon_sym_abstract] = ACTIONS(13578),
    [anon_sym_primitive] = ACTIONS(13578),
    [anon_sym_mutable] = ACTIONS(13578),
    [anon_sym_struct] = ACTIONS(13578),
    [anon_sym_function] = ACTIONS(13578),
    [anon_sym_macro] = ACTIONS(13578),
    [anon_sym_where] = ACTIONS(13578),
    [anon_sym_quote] = ACTIONS(13578),
    [anon_sym_let] = ACTIONS(13578),
    [anon_sym_if] = ACTIONS(13578),
    [anon_sym_try] = ACTIONS(13578),
    [anon_sym_for] = ACTIONS(13578),
    [anon_sym_while] = ACTIONS(13578),
    [sym_break_statement] = ACTIONS(13578),
    [sym_continue_statement] = ACTIONS(13578),
    [anon_sym_return] = ACTIONS(13578),
    [anon_sym_const] = ACTIONS(13578),
    [anon_sym_global] = ACTIONS(13578),
    [anon_sym_local] = ACTIONS(13578),
    [anon_sym_LPAREN] = ACTIONS(13578),
    [anon_sym_RPAREN] = ACTIONS(13578),
    [anon_sym_COLON2] = ACTIONS(13578),
    [anon_sym_export] = ACTIONS(13578),
    [anon_sym_import] = ACTIONS(13578),
    [anon_sym_using] = ACTIONS(13578),
    [anon_sym_LBRACK] = ACTIONS(13578),
    [anon_sym_LF] = ACTIONS(13580),
    [anon_sym_in] = ACTIONS(13578),
    [anon_sym_SEMI] = ACTIONS(13578),
    [anon_sym_LBRACE] = ACTIONS(13578),
    [anon_sym_DOLLAR] = ACTIONS(13578),
    [anon_sym_COLON_COLON] = ACTIONS(13578),
    [anon_sym_isa] = ACTIONS(13578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13578),
    [anon_sym_QMARK] = ACTIONS(13578),
    [anon_sym_AT] = ACTIONS(13578),
    [anon_sym_true] = ACTIONS(13578),
    [anon_sym_false] = ACTIONS(13578),
    [aux_sym_integer_literal_token1] = ACTIONS(13578),
    [aux_sym_integer_literal_token2] = ACTIONS(13578),
    [aux_sym_integer_literal_token3] = ACTIONS(13578),
    [aux_sym_integer_literal_token4] = ACTIONS(13578),
    [aux_sym_float_literal_token1] = ACTIONS(13578),
    [aux_sym_float_literal_token3] = ACTIONS(13578),
    [aux_sym_float_literal_token4] = ACTIONS(13578),
    [sym_character_literal] = ACTIONS(13578),
    [sym__pair_operator] = ACTIONS(13578),
    [sym__arrow_operator] = ACTIONS(13578),
    [sym__lazy_or_operator] = ACTIONS(13578),
    [sym__lazy_and_operator] = ACTIONS(13578),
    [sym__comparison_operator] = ACTIONS(13578),
    [sym__pipe_right_operator] = ACTIONS(13578),
    [sym__pipe_left_operator] = ACTIONS(13578),
    [sym__ellipsis_operator] = ACTIONS(13578),
    [sym__plus_operator] = ACTIONS(13578),
    [sym__times_operator] = ACTIONS(13578),
    [sym__rational_operator] = ACTIONS(13578),
    [sym__bitshift_operator] = ACTIONS(13578),
    [sym__power_operator] = ACTIONS(13578),
    [sym__tilde_operator] = ACTIONS(13578),
    [sym__type_order_operator] = ACTIONS(13578),
    [sym__unary_operator] = ACTIONS(13578),
    [sym__unary_plus_operator] = ACTIONS(13578),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13580),
    [sym__command_start] = ACTIONS(13580),
  },
  [8904] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_RPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13094),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14808),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8905] = {
    [sym__word_identifier] = ACTIONS(13582),
    [anon_sym_EQ] = ACTIONS(13582),
    [anon_sym_COMMA] = ACTIONS(13582),
    [anon_sym_COLON] = ACTIONS(13582),
    [anon_sym_begin] = ACTIONS(13582),
    [anon_sym_module] = ACTIONS(13582),
    [anon_sym_baremodule] = ACTIONS(13582),
    [anon_sym_abstract] = ACTIONS(13582),
    [anon_sym_primitive] = ACTIONS(13582),
    [anon_sym_mutable] = ACTIONS(13582),
    [anon_sym_struct] = ACTIONS(13582),
    [anon_sym_function] = ACTIONS(13582),
    [anon_sym_macro] = ACTIONS(13582),
    [anon_sym_where] = ACTIONS(13582),
    [anon_sym_quote] = ACTIONS(13582),
    [anon_sym_let] = ACTIONS(13582),
    [anon_sym_if] = ACTIONS(13582),
    [anon_sym_try] = ACTIONS(13582),
    [anon_sym_for] = ACTIONS(13582),
    [anon_sym_while] = ACTIONS(13582),
    [sym_break_statement] = ACTIONS(13582),
    [sym_continue_statement] = ACTIONS(13582),
    [anon_sym_return] = ACTIONS(13582),
    [anon_sym_const] = ACTIONS(13582),
    [anon_sym_global] = ACTIONS(13582),
    [anon_sym_local] = ACTIONS(13582),
    [anon_sym_LPAREN] = ACTIONS(13582),
    [anon_sym_RPAREN] = ACTIONS(13582),
    [anon_sym_COLON2] = ACTIONS(13582),
    [anon_sym_export] = ACTIONS(13582),
    [anon_sym_import] = ACTIONS(13582),
    [anon_sym_using] = ACTIONS(13582),
    [anon_sym_LBRACK] = ACTIONS(13582),
    [anon_sym_LF] = ACTIONS(13584),
    [anon_sym_in] = ACTIONS(13582),
    [anon_sym_SEMI] = ACTIONS(13582),
    [anon_sym_LBRACE] = ACTIONS(13582),
    [anon_sym_DOLLAR] = ACTIONS(13582),
    [anon_sym_COLON_COLON] = ACTIONS(13582),
    [anon_sym_isa] = ACTIONS(13582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13582),
    [anon_sym_QMARK] = ACTIONS(13582),
    [anon_sym_AT] = ACTIONS(13582),
    [anon_sym_true] = ACTIONS(13582),
    [anon_sym_false] = ACTIONS(13582),
    [aux_sym_integer_literal_token1] = ACTIONS(13582),
    [aux_sym_integer_literal_token2] = ACTIONS(13582),
    [aux_sym_integer_literal_token3] = ACTIONS(13582),
    [aux_sym_integer_literal_token4] = ACTIONS(13582),
    [aux_sym_float_literal_token1] = ACTIONS(13582),
    [aux_sym_float_literal_token3] = ACTIONS(13582),
    [aux_sym_float_literal_token4] = ACTIONS(13582),
    [sym_character_literal] = ACTIONS(13582),
    [sym__pair_operator] = ACTIONS(13582),
    [sym__arrow_operator] = ACTIONS(13582),
    [sym__lazy_or_operator] = ACTIONS(13582),
    [sym__lazy_and_operator] = ACTIONS(13582),
    [sym__comparison_operator] = ACTIONS(13582),
    [sym__pipe_right_operator] = ACTIONS(13582),
    [sym__pipe_left_operator] = ACTIONS(13582),
    [sym__ellipsis_operator] = ACTIONS(13582),
    [sym__plus_operator] = ACTIONS(13582),
    [sym__times_operator] = ACTIONS(13582),
    [sym__rational_operator] = ACTIONS(13582),
    [sym__bitshift_operator] = ACTIONS(13582),
    [sym__power_operator] = ACTIONS(13582),
    [sym__tilde_operator] = ACTIONS(13582),
    [sym__type_order_operator] = ACTIONS(13582),
    [sym__unary_operator] = ACTIONS(13582),
    [sym__unary_plus_operator] = ACTIONS(13582),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13584),
    [sym__command_start] = ACTIONS(13584),
  },
  [8906] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8907] = {
    [sym__word_identifier] = ACTIONS(13586),
    [anon_sym_EQ] = ACTIONS(13586),
    [anon_sym_COMMA] = ACTIONS(13586),
    [anon_sym_COLON] = ACTIONS(13586),
    [anon_sym_begin] = ACTIONS(13586),
    [anon_sym_module] = ACTIONS(13586),
    [anon_sym_baremodule] = ACTIONS(13586),
    [anon_sym_abstract] = ACTIONS(13586),
    [anon_sym_primitive] = ACTIONS(13586),
    [anon_sym_mutable] = ACTIONS(13586),
    [anon_sym_struct] = ACTIONS(13586),
    [anon_sym_function] = ACTIONS(13586),
    [anon_sym_macro] = ACTIONS(13586),
    [anon_sym_where] = ACTIONS(13586),
    [anon_sym_quote] = ACTIONS(13586),
    [anon_sym_let] = ACTIONS(13586),
    [anon_sym_if] = ACTIONS(13586),
    [anon_sym_try] = ACTIONS(13586),
    [anon_sym_for] = ACTIONS(13586),
    [anon_sym_while] = ACTIONS(13586),
    [sym_break_statement] = ACTIONS(13586),
    [sym_continue_statement] = ACTIONS(13586),
    [anon_sym_return] = ACTIONS(13586),
    [anon_sym_const] = ACTIONS(13586),
    [anon_sym_global] = ACTIONS(13586),
    [anon_sym_local] = ACTIONS(13586),
    [anon_sym_LPAREN] = ACTIONS(13586),
    [anon_sym_RPAREN] = ACTIONS(13586),
    [anon_sym_COLON2] = ACTIONS(13586),
    [anon_sym_export] = ACTIONS(13586),
    [anon_sym_import] = ACTIONS(13586),
    [anon_sym_using] = ACTIONS(13586),
    [anon_sym_LBRACK] = ACTIONS(13586),
    [anon_sym_LF] = ACTIONS(13588),
    [anon_sym_in] = ACTIONS(13586),
    [anon_sym_SEMI] = ACTIONS(13586),
    [anon_sym_LBRACE] = ACTIONS(13586),
    [anon_sym_DOLLAR] = ACTIONS(13586),
    [anon_sym_COLON_COLON] = ACTIONS(13586),
    [anon_sym_isa] = ACTIONS(13586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13586),
    [anon_sym_QMARK] = ACTIONS(13586),
    [anon_sym_AT] = ACTIONS(13586),
    [anon_sym_true] = ACTIONS(13586),
    [anon_sym_false] = ACTIONS(13586),
    [aux_sym_integer_literal_token1] = ACTIONS(13586),
    [aux_sym_integer_literal_token2] = ACTIONS(13586),
    [aux_sym_integer_literal_token3] = ACTIONS(13586),
    [aux_sym_integer_literal_token4] = ACTIONS(13586),
    [aux_sym_float_literal_token1] = ACTIONS(13586),
    [aux_sym_float_literal_token3] = ACTIONS(13586),
    [aux_sym_float_literal_token4] = ACTIONS(13586),
    [sym_character_literal] = ACTIONS(13586),
    [sym__pair_operator] = ACTIONS(13586),
    [sym__arrow_operator] = ACTIONS(13586),
    [sym__lazy_or_operator] = ACTIONS(13586),
    [sym__lazy_and_operator] = ACTIONS(13586),
    [sym__comparison_operator] = ACTIONS(13586),
    [sym__pipe_right_operator] = ACTIONS(13586),
    [sym__pipe_left_operator] = ACTIONS(13586),
    [sym__ellipsis_operator] = ACTIONS(13586),
    [sym__plus_operator] = ACTIONS(13586),
    [sym__times_operator] = ACTIONS(13586),
    [sym__rational_operator] = ACTIONS(13586),
    [sym__bitshift_operator] = ACTIONS(13586),
    [sym__power_operator] = ACTIONS(13586),
    [sym__tilde_operator] = ACTIONS(13586),
    [sym__type_order_operator] = ACTIONS(13586),
    [sym__unary_operator] = ACTIONS(13586),
    [sym__unary_plus_operator] = ACTIONS(13586),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13588),
    [sym__command_start] = ACTIONS(13588),
  },
  [8908] = {
    [sym__word_identifier] = ACTIONS(13590),
    [anon_sym_EQ] = ACTIONS(13590),
    [anon_sym_COMMA] = ACTIONS(13590),
    [anon_sym_COLON] = ACTIONS(13590),
    [anon_sym_begin] = ACTIONS(13590),
    [anon_sym_module] = ACTIONS(13590),
    [anon_sym_baremodule] = ACTIONS(13590),
    [anon_sym_abstract] = ACTIONS(13590),
    [anon_sym_primitive] = ACTIONS(13590),
    [anon_sym_mutable] = ACTIONS(13590),
    [anon_sym_struct] = ACTIONS(13590),
    [anon_sym_function] = ACTIONS(13590),
    [anon_sym_macro] = ACTIONS(13590),
    [anon_sym_where] = ACTIONS(13590),
    [anon_sym_quote] = ACTIONS(13590),
    [anon_sym_let] = ACTIONS(13590),
    [anon_sym_if] = ACTIONS(13590),
    [anon_sym_try] = ACTIONS(13590),
    [anon_sym_for] = ACTIONS(13590),
    [anon_sym_while] = ACTIONS(13590),
    [sym_break_statement] = ACTIONS(13590),
    [sym_continue_statement] = ACTIONS(13590),
    [anon_sym_return] = ACTIONS(13590),
    [anon_sym_const] = ACTIONS(13590),
    [anon_sym_global] = ACTIONS(13590),
    [anon_sym_local] = ACTIONS(13590),
    [anon_sym_LPAREN] = ACTIONS(13590),
    [anon_sym_RPAREN] = ACTIONS(13590),
    [anon_sym_COLON2] = ACTIONS(13590),
    [anon_sym_export] = ACTIONS(13590),
    [anon_sym_import] = ACTIONS(13590),
    [anon_sym_using] = ACTIONS(13590),
    [anon_sym_LBRACK] = ACTIONS(13590),
    [anon_sym_LF] = ACTIONS(13592),
    [anon_sym_in] = ACTIONS(13590),
    [anon_sym_SEMI] = ACTIONS(13590),
    [anon_sym_LBRACE] = ACTIONS(13590),
    [anon_sym_DOLLAR] = ACTIONS(13590),
    [anon_sym_COLON_COLON] = ACTIONS(13590),
    [anon_sym_isa] = ACTIONS(13590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13590),
    [anon_sym_QMARK] = ACTIONS(13590),
    [anon_sym_AT] = ACTIONS(13590),
    [anon_sym_true] = ACTIONS(13590),
    [anon_sym_false] = ACTIONS(13590),
    [aux_sym_integer_literal_token1] = ACTIONS(13590),
    [aux_sym_integer_literal_token2] = ACTIONS(13590),
    [aux_sym_integer_literal_token3] = ACTIONS(13590),
    [aux_sym_integer_literal_token4] = ACTIONS(13590),
    [aux_sym_float_literal_token1] = ACTIONS(13590),
    [aux_sym_float_literal_token3] = ACTIONS(13590),
    [aux_sym_float_literal_token4] = ACTIONS(13590),
    [sym_character_literal] = ACTIONS(13590),
    [sym__pair_operator] = ACTIONS(13590),
    [sym__arrow_operator] = ACTIONS(13590),
    [sym__lazy_or_operator] = ACTIONS(13590),
    [sym__lazy_and_operator] = ACTIONS(13590),
    [sym__comparison_operator] = ACTIONS(13590),
    [sym__pipe_right_operator] = ACTIONS(13590),
    [sym__pipe_left_operator] = ACTIONS(13590),
    [sym__ellipsis_operator] = ACTIONS(13590),
    [sym__plus_operator] = ACTIONS(13590),
    [sym__times_operator] = ACTIONS(13590),
    [sym__rational_operator] = ACTIONS(13590),
    [sym__bitshift_operator] = ACTIONS(13590),
    [sym__power_operator] = ACTIONS(13590),
    [sym__tilde_operator] = ACTIONS(13590),
    [sym__type_order_operator] = ACTIONS(13590),
    [sym__unary_operator] = ACTIONS(13590),
    [sym__unary_plus_operator] = ACTIONS(13590),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13592),
    [sym__command_start] = ACTIONS(13592),
  },
  [8909] = {
    [sym__word_identifier] = ACTIONS(13594),
    [anon_sym_EQ] = ACTIONS(13594),
    [anon_sym_COMMA] = ACTIONS(13594),
    [anon_sym_COLON] = ACTIONS(13594),
    [anon_sym_begin] = ACTIONS(13594),
    [anon_sym_module] = ACTIONS(13594),
    [anon_sym_baremodule] = ACTIONS(13594),
    [anon_sym_abstract] = ACTIONS(13594),
    [anon_sym_primitive] = ACTIONS(13594),
    [anon_sym_mutable] = ACTIONS(13594),
    [anon_sym_struct] = ACTIONS(13594),
    [anon_sym_function] = ACTIONS(13594),
    [anon_sym_macro] = ACTIONS(13594),
    [anon_sym_where] = ACTIONS(13594),
    [anon_sym_quote] = ACTIONS(13594),
    [anon_sym_let] = ACTIONS(13594),
    [anon_sym_if] = ACTIONS(13594),
    [anon_sym_try] = ACTIONS(13594),
    [anon_sym_for] = ACTIONS(13594),
    [anon_sym_while] = ACTIONS(13594),
    [sym_break_statement] = ACTIONS(13594),
    [sym_continue_statement] = ACTIONS(13594),
    [anon_sym_return] = ACTIONS(13594),
    [anon_sym_const] = ACTIONS(13594),
    [anon_sym_global] = ACTIONS(13594),
    [anon_sym_local] = ACTIONS(13594),
    [anon_sym_LPAREN] = ACTIONS(13594),
    [anon_sym_RPAREN] = ACTIONS(13594),
    [anon_sym_COLON2] = ACTIONS(13594),
    [anon_sym_export] = ACTIONS(13594),
    [anon_sym_import] = ACTIONS(13594),
    [anon_sym_using] = ACTIONS(13594),
    [anon_sym_LBRACK] = ACTIONS(13594),
    [anon_sym_LF] = ACTIONS(13596),
    [anon_sym_in] = ACTIONS(13594),
    [anon_sym_SEMI] = ACTIONS(13594),
    [anon_sym_LBRACE] = ACTIONS(13594),
    [anon_sym_DOLLAR] = ACTIONS(13594),
    [anon_sym_COLON_COLON] = ACTIONS(13594),
    [anon_sym_isa] = ACTIONS(13594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13594),
    [anon_sym_QMARK] = ACTIONS(13594),
    [anon_sym_AT] = ACTIONS(13594),
    [anon_sym_true] = ACTIONS(13594),
    [anon_sym_false] = ACTIONS(13594),
    [aux_sym_integer_literal_token1] = ACTIONS(13594),
    [aux_sym_integer_literal_token2] = ACTIONS(13594),
    [aux_sym_integer_literal_token3] = ACTIONS(13594),
    [aux_sym_integer_literal_token4] = ACTIONS(13594),
    [aux_sym_float_literal_token1] = ACTIONS(13594),
    [aux_sym_float_literal_token3] = ACTIONS(13594),
    [aux_sym_float_literal_token4] = ACTIONS(13594),
    [sym_character_literal] = ACTIONS(13594),
    [sym__pair_operator] = ACTIONS(13594),
    [sym__arrow_operator] = ACTIONS(13594),
    [sym__lazy_or_operator] = ACTIONS(13594),
    [sym__lazy_and_operator] = ACTIONS(13594),
    [sym__comparison_operator] = ACTIONS(13594),
    [sym__pipe_right_operator] = ACTIONS(13594),
    [sym__pipe_left_operator] = ACTIONS(13594),
    [sym__ellipsis_operator] = ACTIONS(13594),
    [sym__plus_operator] = ACTIONS(13594),
    [sym__times_operator] = ACTIONS(13594),
    [sym__rational_operator] = ACTIONS(13594),
    [sym__bitshift_operator] = ACTIONS(13594),
    [sym__power_operator] = ACTIONS(13594),
    [sym__tilde_operator] = ACTIONS(13594),
    [sym__type_order_operator] = ACTIONS(13594),
    [sym__unary_operator] = ACTIONS(13594),
    [sym__unary_plus_operator] = ACTIONS(13594),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13596),
    [sym__command_start] = ACTIONS(13596),
  },
  [8910] = {
    [sym__word_identifier] = ACTIONS(13598),
    [anon_sym_EQ] = ACTIONS(13598),
    [anon_sym_COMMA] = ACTIONS(13598),
    [anon_sym_COLON] = ACTIONS(13598),
    [anon_sym_begin] = ACTIONS(13598),
    [anon_sym_module] = ACTIONS(13598),
    [anon_sym_baremodule] = ACTIONS(13598),
    [anon_sym_abstract] = ACTIONS(13598),
    [anon_sym_primitive] = ACTIONS(13598),
    [anon_sym_mutable] = ACTIONS(13598),
    [anon_sym_struct] = ACTIONS(13598),
    [anon_sym_function] = ACTIONS(13598),
    [anon_sym_macro] = ACTIONS(13598),
    [anon_sym_where] = ACTIONS(13598),
    [anon_sym_quote] = ACTIONS(13598),
    [anon_sym_let] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(13598),
    [anon_sym_try] = ACTIONS(13598),
    [anon_sym_for] = ACTIONS(13598),
    [anon_sym_while] = ACTIONS(13598),
    [sym_break_statement] = ACTIONS(13598),
    [sym_continue_statement] = ACTIONS(13598),
    [anon_sym_return] = ACTIONS(13598),
    [anon_sym_const] = ACTIONS(13598),
    [anon_sym_global] = ACTIONS(13598),
    [anon_sym_local] = ACTIONS(13598),
    [anon_sym_LPAREN] = ACTIONS(13598),
    [anon_sym_RPAREN] = ACTIONS(13598),
    [anon_sym_COLON2] = ACTIONS(13598),
    [anon_sym_export] = ACTIONS(13598),
    [anon_sym_import] = ACTIONS(13598),
    [anon_sym_using] = ACTIONS(13598),
    [anon_sym_LBRACK] = ACTIONS(13598),
    [anon_sym_LF] = ACTIONS(13600),
    [anon_sym_in] = ACTIONS(13598),
    [anon_sym_SEMI] = ACTIONS(13598),
    [anon_sym_LBRACE] = ACTIONS(13598),
    [anon_sym_DOLLAR] = ACTIONS(13598),
    [anon_sym_COLON_COLON] = ACTIONS(13598),
    [anon_sym_isa] = ACTIONS(13598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13598),
    [anon_sym_QMARK] = ACTIONS(13598),
    [anon_sym_AT] = ACTIONS(13598),
    [anon_sym_true] = ACTIONS(13598),
    [anon_sym_false] = ACTIONS(13598),
    [aux_sym_integer_literal_token1] = ACTIONS(13598),
    [aux_sym_integer_literal_token2] = ACTIONS(13598),
    [aux_sym_integer_literal_token3] = ACTIONS(13598),
    [aux_sym_integer_literal_token4] = ACTIONS(13598),
    [aux_sym_float_literal_token1] = ACTIONS(13598),
    [aux_sym_float_literal_token3] = ACTIONS(13598),
    [aux_sym_float_literal_token4] = ACTIONS(13598),
    [sym_character_literal] = ACTIONS(13598),
    [sym__pair_operator] = ACTIONS(13598),
    [sym__arrow_operator] = ACTIONS(13598),
    [sym__lazy_or_operator] = ACTIONS(13598),
    [sym__lazy_and_operator] = ACTIONS(13598),
    [sym__comparison_operator] = ACTIONS(13598),
    [sym__pipe_right_operator] = ACTIONS(13598),
    [sym__pipe_left_operator] = ACTIONS(13598),
    [sym__ellipsis_operator] = ACTIONS(13598),
    [sym__plus_operator] = ACTIONS(13598),
    [sym__times_operator] = ACTIONS(13598),
    [sym__rational_operator] = ACTIONS(13598),
    [sym__bitshift_operator] = ACTIONS(13598),
    [sym__power_operator] = ACTIONS(13598),
    [sym__tilde_operator] = ACTIONS(13598),
    [sym__type_order_operator] = ACTIONS(13598),
    [sym__unary_operator] = ACTIONS(13598),
    [sym__unary_plus_operator] = ACTIONS(13598),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13600),
    [sym__command_start] = ACTIONS(13600),
  },
  [8911] = {
    [sym__word_identifier] = ACTIONS(13602),
    [anon_sym_EQ] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(13602),
    [anon_sym_COLON] = ACTIONS(13602),
    [anon_sym_begin] = ACTIONS(13602),
    [anon_sym_module] = ACTIONS(13602),
    [anon_sym_baremodule] = ACTIONS(13602),
    [anon_sym_abstract] = ACTIONS(13602),
    [anon_sym_primitive] = ACTIONS(13602),
    [anon_sym_mutable] = ACTIONS(13602),
    [anon_sym_struct] = ACTIONS(13602),
    [anon_sym_function] = ACTIONS(13602),
    [anon_sym_macro] = ACTIONS(13602),
    [anon_sym_where] = ACTIONS(13602),
    [anon_sym_quote] = ACTIONS(13602),
    [anon_sym_let] = ACTIONS(13602),
    [anon_sym_if] = ACTIONS(13602),
    [anon_sym_try] = ACTIONS(13602),
    [anon_sym_for] = ACTIONS(13602),
    [anon_sym_while] = ACTIONS(13602),
    [sym_break_statement] = ACTIONS(13602),
    [sym_continue_statement] = ACTIONS(13602),
    [anon_sym_return] = ACTIONS(13602),
    [anon_sym_const] = ACTIONS(13602),
    [anon_sym_global] = ACTIONS(13602),
    [anon_sym_local] = ACTIONS(13602),
    [anon_sym_LPAREN] = ACTIONS(13602),
    [anon_sym_RPAREN] = ACTIONS(13602),
    [anon_sym_COLON2] = ACTIONS(13602),
    [anon_sym_export] = ACTIONS(13602),
    [anon_sym_import] = ACTIONS(13602),
    [anon_sym_using] = ACTIONS(13602),
    [anon_sym_LBRACK] = ACTIONS(13602),
    [anon_sym_LF] = ACTIONS(13604),
    [anon_sym_in] = ACTIONS(13602),
    [anon_sym_SEMI] = ACTIONS(13602),
    [anon_sym_LBRACE] = ACTIONS(13602),
    [anon_sym_DOLLAR] = ACTIONS(13602),
    [anon_sym_COLON_COLON] = ACTIONS(13602),
    [anon_sym_isa] = ACTIONS(13602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13602),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_AT] = ACTIONS(13602),
    [anon_sym_true] = ACTIONS(13602),
    [anon_sym_false] = ACTIONS(13602),
    [aux_sym_integer_literal_token1] = ACTIONS(13602),
    [aux_sym_integer_literal_token2] = ACTIONS(13602),
    [aux_sym_integer_literal_token3] = ACTIONS(13602),
    [aux_sym_integer_literal_token4] = ACTIONS(13602),
    [aux_sym_float_literal_token1] = ACTIONS(13602),
    [aux_sym_float_literal_token3] = ACTIONS(13602),
    [aux_sym_float_literal_token4] = ACTIONS(13602),
    [sym_character_literal] = ACTIONS(13602),
    [sym__pair_operator] = ACTIONS(13602),
    [sym__arrow_operator] = ACTIONS(13602),
    [sym__lazy_or_operator] = ACTIONS(13602),
    [sym__lazy_and_operator] = ACTIONS(13602),
    [sym__comparison_operator] = ACTIONS(13602),
    [sym__pipe_right_operator] = ACTIONS(13602),
    [sym__pipe_left_operator] = ACTIONS(13602),
    [sym__ellipsis_operator] = ACTIONS(13602),
    [sym__plus_operator] = ACTIONS(13602),
    [sym__times_operator] = ACTIONS(13602),
    [sym__rational_operator] = ACTIONS(13602),
    [sym__bitshift_operator] = ACTIONS(13602),
    [sym__power_operator] = ACTIONS(13602),
    [sym__tilde_operator] = ACTIONS(13602),
    [sym__type_order_operator] = ACTIONS(13602),
    [sym__unary_operator] = ACTIONS(13602),
    [sym__unary_plus_operator] = ACTIONS(13602),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13604),
    [sym__command_start] = ACTIONS(13604),
  },
  [8912] = {
    [sym__word_identifier] = ACTIONS(13606),
    [anon_sym_EQ] = ACTIONS(13606),
    [anon_sym_COMMA] = ACTIONS(13606),
    [anon_sym_COLON] = ACTIONS(13606),
    [anon_sym_begin] = ACTIONS(13606),
    [anon_sym_module] = ACTIONS(13606),
    [anon_sym_baremodule] = ACTIONS(13606),
    [anon_sym_abstract] = ACTIONS(13606),
    [anon_sym_primitive] = ACTIONS(13606),
    [anon_sym_mutable] = ACTIONS(13606),
    [anon_sym_struct] = ACTIONS(13606),
    [anon_sym_function] = ACTIONS(13606),
    [anon_sym_macro] = ACTIONS(13606),
    [anon_sym_where] = ACTIONS(13606),
    [anon_sym_quote] = ACTIONS(13606),
    [anon_sym_let] = ACTIONS(13606),
    [anon_sym_if] = ACTIONS(13606),
    [anon_sym_try] = ACTIONS(13606),
    [anon_sym_for] = ACTIONS(13606),
    [anon_sym_while] = ACTIONS(13606),
    [sym_break_statement] = ACTIONS(13606),
    [sym_continue_statement] = ACTIONS(13606),
    [anon_sym_return] = ACTIONS(13606),
    [anon_sym_const] = ACTIONS(13606),
    [anon_sym_global] = ACTIONS(13606),
    [anon_sym_local] = ACTIONS(13606),
    [anon_sym_LPAREN] = ACTIONS(13606),
    [anon_sym_RPAREN] = ACTIONS(13606),
    [anon_sym_COLON2] = ACTIONS(13606),
    [anon_sym_export] = ACTIONS(13606),
    [anon_sym_import] = ACTIONS(13606),
    [anon_sym_using] = ACTIONS(13606),
    [anon_sym_LBRACK] = ACTIONS(13606),
    [anon_sym_LF] = ACTIONS(13608),
    [anon_sym_in] = ACTIONS(13606),
    [anon_sym_SEMI] = ACTIONS(13606),
    [anon_sym_LBRACE] = ACTIONS(13606),
    [anon_sym_DOLLAR] = ACTIONS(13606),
    [anon_sym_COLON_COLON] = ACTIONS(13606),
    [anon_sym_isa] = ACTIONS(13606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_QMARK] = ACTIONS(13606),
    [anon_sym_AT] = ACTIONS(13606),
    [anon_sym_true] = ACTIONS(13606),
    [anon_sym_false] = ACTIONS(13606),
    [aux_sym_integer_literal_token1] = ACTIONS(13606),
    [aux_sym_integer_literal_token2] = ACTIONS(13606),
    [aux_sym_integer_literal_token3] = ACTIONS(13606),
    [aux_sym_integer_literal_token4] = ACTIONS(13606),
    [aux_sym_float_literal_token1] = ACTIONS(13606),
    [aux_sym_float_literal_token3] = ACTIONS(13606),
    [aux_sym_float_literal_token4] = ACTIONS(13606),
    [sym_character_literal] = ACTIONS(13606),
    [sym__pair_operator] = ACTIONS(13606),
    [sym__arrow_operator] = ACTIONS(13606),
    [sym__lazy_or_operator] = ACTIONS(13606),
    [sym__lazy_and_operator] = ACTIONS(13606),
    [sym__comparison_operator] = ACTIONS(13606),
    [sym__pipe_right_operator] = ACTIONS(13606),
    [sym__pipe_left_operator] = ACTIONS(13606),
    [sym__ellipsis_operator] = ACTIONS(13606),
    [sym__plus_operator] = ACTIONS(13606),
    [sym__times_operator] = ACTIONS(13606),
    [sym__rational_operator] = ACTIONS(13606),
    [sym__bitshift_operator] = ACTIONS(13606),
    [sym__power_operator] = ACTIONS(13606),
    [sym__tilde_operator] = ACTIONS(13606),
    [sym__type_order_operator] = ACTIONS(13606),
    [sym__unary_operator] = ACTIONS(13606),
    [sym__unary_plus_operator] = ACTIONS(13606),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13608),
    [sym__command_start] = ACTIONS(13608),
  },
  [8913] = {
    [sym__word_identifier] = ACTIONS(13620),
    [anon_sym_EQ] = ACTIONS(13620),
    [anon_sym_COMMA] = ACTIONS(13620),
    [anon_sym_COLON] = ACTIONS(13620),
    [anon_sym_begin] = ACTIONS(13620),
    [anon_sym_module] = ACTIONS(13620),
    [anon_sym_baremodule] = ACTIONS(13620),
    [anon_sym_abstract] = ACTIONS(13620),
    [anon_sym_primitive] = ACTIONS(13620),
    [anon_sym_mutable] = ACTIONS(13620),
    [anon_sym_struct] = ACTIONS(13620),
    [anon_sym_function] = ACTIONS(13620),
    [anon_sym_macro] = ACTIONS(13620),
    [anon_sym_where] = ACTIONS(13620),
    [anon_sym_quote] = ACTIONS(13620),
    [anon_sym_let] = ACTIONS(13620),
    [anon_sym_if] = ACTIONS(13620),
    [anon_sym_try] = ACTIONS(13620),
    [anon_sym_for] = ACTIONS(13620),
    [anon_sym_while] = ACTIONS(13620),
    [sym_break_statement] = ACTIONS(13620),
    [sym_continue_statement] = ACTIONS(13620),
    [anon_sym_return] = ACTIONS(13620),
    [anon_sym_const] = ACTIONS(13620),
    [anon_sym_global] = ACTIONS(13620),
    [anon_sym_local] = ACTIONS(13620),
    [anon_sym_LPAREN] = ACTIONS(13620),
    [anon_sym_RPAREN] = ACTIONS(13620),
    [anon_sym_COLON2] = ACTIONS(13620),
    [anon_sym_export] = ACTIONS(13620),
    [anon_sym_import] = ACTIONS(13620),
    [anon_sym_using] = ACTIONS(13620),
    [anon_sym_LBRACK] = ACTIONS(13620),
    [anon_sym_LF] = ACTIONS(13622),
    [anon_sym_in] = ACTIONS(13620),
    [anon_sym_SEMI] = ACTIONS(13620),
    [anon_sym_LBRACE] = ACTIONS(13620),
    [anon_sym_DOLLAR] = ACTIONS(13620),
    [anon_sym_COLON_COLON] = ACTIONS(13620),
    [anon_sym_isa] = ACTIONS(13620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13620),
    [anon_sym_QMARK] = ACTIONS(13620),
    [anon_sym_AT] = ACTIONS(13620),
    [anon_sym_true] = ACTIONS(13620),
    [anon_sym_false] = ACTIONS(13620),
    [aux_sym_integer_literal_token1] = ACTIONS(13620),
    [aux_sym_integer_literal_token2] = ACTIONS(13620),
    [aux_sym_integer_literal_token3] = ACTIONS(13620),
    [aux_sym_integer_literal_token4] = ACTIONS(13620),
    [aux_sym_float_literal_token1] = ACTIONS(13620),
    [aux_sym_float_literal_token3] = ACTIONS(13620),
    [aux_sym_float_literal_token4] = ACTIONS(13620),
    [sym_character_literal] = ACTIONS(13620),
    [sym__pair_operator] = ACTIONS(13620),
    [sym__arrow_operator] = ACTIONS(13620),
    [sym__lazy_or_operator] = ACTIONS(13620),
    [sym__lazy_and_operator] = ACTIONS(13620),
    [sym__comparison_operator] = ACTIONS(13620),
    [sym__pipe_right_operator] = ACTIONS(13620),
    [sym__pipe_left_operator] = ACTIONS(13620),
    [sym__ellipsis_operator] = ACTIONS(13620),
    [sym__plus_operator] = ACTIONS(13620),
    [sym__times_operator] = ACTIONS(13620),
    [sym__rational_operator] = ACTIONS(13620),
    [sym__bitshift_operator] = ACTIONS(13620),
    [sym__power_operator] = ACTIONS(13620),
    [sym__tilde_operator] = ACTIONS(13620),
    [sym__type_order_operator] = ACTIONS(13620),
    [sym__unary_operator] = ACTIONS(13620),
    [sym__unary_plus_operator] = ACTIONS(13620),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13622),
    [sym__command_start] = ACTIONS(13622),
  },
  [8914] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8915] = {
    [aux_sym_open_tuple_repeat1] = STATE(8986),
    [sym__word_identifier] = ACTIONS(13150),
    [anon_sym_EQ] = ACTIONS(13150),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_COLON] = ACTIONS(13150),
    [anon_sym_begin] = ACTIONS(13150),
    [anon_sym_module] = ACTIONS(13150),
    [anon_sym_baremodule] = ACTIONS(13150),
    [anon_sym_abstract] = ACTIONS(13150),
    [anon_sym_primitive] = ACTIONS(13150),
    [anon_sym_mutable] = ACTIONS(13150),
    [anon_sym_struct] = ACTIONS(13150),
    [anon_sym_function] = ACTIONS(13150),
    [anon_sym_macro] = ACTIONS(13150),
    [anon_sym_where] = ACTIONS(13150),
    [anon_sym_quote] = ACTIONS(13150),
    [anon_sym_let] = ACTIONS(13150),
    [anon_sym_if] = ACTIONS(13150),
    [anon_sym_try] = ACTIONS(13150),
    [anon_sym_for] = ACTIONS(13150),
    [anon_sym_while] = ACTIONS(13150),
    [sym_break_statement] = ACTIONS(13150),
    [sym_continue_statement] = ACTIONS(13150),
    [anon_sym_return] = ACTIONS(13150),
    [anon_sym_const] = ACTIONS(13150),
    [anon_sym_global] = ACTIONS(13150),
    [anon_sym_local] = ACTIONS(13150),
    [anon_sym_LPAREN] = ACTIONS(13148),
    [anon_sym_RPAREN] = ACTIONS(13148),
    [anon_sym_COLON2] = ACTIONS(13150),
    [anon_sym_export] = ACTIONS(13150),
    [anon_sym_import] = ACTIONS(13150),
    [anon_sym_using] = ACTIONS(13150),
    [anon_sym_LBRACK] = ACTIONS(13148),
    [anon_sym_in] = ACTIONS(13150),
    [anon_sym_SEMI] = ACTIONS(13148),
    [anon_sym_LBRACE] = ACTIONS(13148),
    [anon_sym_DOLLAR] = ACTIONS(13148),
    [anon_sym_COLON_COLON] = ACTIONS(13148),
    [anon_sym_isa] = ACTIONS(13150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13148),
    [anon_sym_QMARK] = ACTIONS(13148),
    [anon_sym_AT] = ACTIONS(13148),
    [anon_sym_true] = ACTIONS(13150),
    [anon_sym_false] = ACTIONS(13150),
    [aux_sym_integer_literal_token1] = ACTIONS(13148),
    [aux_sym_integer_literal_token2] = ACTIONS(13148),
    [aux_sym_integer_literal_token3] = ACTIONS(13150),
    [aux_sym_integer_literal_token4] = ACTIONS(13150),
    [aux_sym_float_literal_token1] = ACTIONS(13148),
    [aux_sym_float_literal_token3] = ACTIONS(13148),
    [aux_sym_float_literal_token4] = ACTIONS(13148),
    [sym_character_literal] = ACTIONS(13148),
    [sym__pair_operator] = ACTIONS(13148),
    [sym__arrow_operator] = ACTIONS(13150),
    [sym__lazy_or_operator] = ACTIONS(13148),
    [sym__lazy_and_operator] = ACTIONS(13148),
    [sym__comparison_operator] = ACTIONS(13150),
    [sym__pipe_right_operator] = ACTIONS(13148),
    [sym__pipe_left_operator] = ACTIONS(13148),
    [sym__ellipsis_operator] = ACTIONS(13150),
    [sym__plus_operator] = ACTIONS(13150),
    [sym__times_operator] = ACTIONS(13150),
    [sym__rational_operator] = ACTIONS(13148),
    [sym__bitshift_operator] = ACTIONS(13148),
    [sym__power_operator] = ACTIONS(13148),
    [sym__tilde_operator] = ACTIONS(13148),
    [sym__type_order_operator] = ACTIONS(13148),
    [sym__unary_operator] = ACTIONS(13150),
    [sym__unary_plus_operator] = ACTIONS(13150),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13148),
    [sym__command_start] = ACTIONS(13148),
  },
  [8916] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8917] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8918] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_elseif] = ACTIONS(13306),
    [anon_sym_else] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8919] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(13306),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8920] = {
    [sym__word_identifier] = ACTIONS(13624),
    [anon_sym_EQ] = ACTIONS(13624),
    [anon_sym_COMMA] = ACTIONS(13624),
    [anon_sym_COLON] = ACTIONS(13624),
    [anon_sym_begin] = ACTIONS(13624),
    [anon_sym_module] = ACTIONS(13624),
    [anon_sym_baremodule] = ACTIONS(13624),
    [anon_sym_abstract] = ACTIONS(13624),
    [anon_sym_primitive] = ACTIONS(13624),
    [anon_sym_mutable] = ACTIONS(13624),
    [anon_sym_struct] = ACTIONS(13624),
    [anon_sym_function] = ACTIONS(13624),
    [anon_sym_macro] = ACTIONS(13624),
    [anon_sym_where] = ACTIONS(13624),
    [anon_sym_quote] = ACTIONS(13624),
    [anon_sym_let] = ACTIONS(13624),
    [anon_sym_if] = ACTIONS(13624),
    [anon_sym_try] = ACTIONS(13624),
    [anon_sym_for] = ACTIONS(13624),
    [anon_sym_while] = ACTIONS(13624),
    [sym_break_statement] = ACTIONS(13624),
    [sym_continue_statement] = ACTIONS(13624),
    [anon_sym_return] = ACTIONS(13624),
    [anon_sym_const] = ACTIONS(13624),
    [anon_sym_global] = ACTIONS(13624),
    [anon_sym_local] = ACTIONS(13624),
    [anon_sym_LPAREN] = ACTIONS(13624),
    [anon_sym_RPAREN] = ACTIONS(13624),
    [anon_sym_COLON2] = ACTIONS(13624),
    [anon_sym_export] = ACTIONS(13624),
    [anon_sym_import] = ACTIONS(13624),
    [anon_sym_using] = ACTIONS(13624),
    [anon_sym_LBRACK] = ACTIONS(13624),
    [anon_sym_LF] = ACTIONS(13626),
    [anon_sym_in] = ACTIONS(13624),
    [anon_sym_SEMI] = ACTIONS(13624),
    [anon_sym_LBRACE] = ACTIONS(13624),
    [anon_sym_DOLLAR] = ACTIONS(13624),
    [anon_sym_COLON_COLON] = ACTIONS(13624),
    [anon_sym_isa] = ACTIONS(13624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13624),
    [anon_sym_QMARK] = ACTIONS(13624),
    [anon_sym_AT] = ACTIONS(13624),
    [anon_sym_true] = ACTIONS(13624),
    [anon_sym_false] = ACTIONS(13624),
    [aux_sym_integer_literal_token1] = ACTIONS(13624),
    [aux_sym_integer_literal_token2] = ACTIONS(13624),
    [aux_sym_integer_literal_token3] = ACTIONS(13624),
    [aux_sym_integer_literal_token4] = ACTIONS(13624),
    [aux_sym_float_literal_token1] = ACTIONS(13624),
    [aux_sym_float_literal_token3] = ACTIONS(13624),
    [aux_sym_float_literal_token4] = ACTIONS(13624),
    [sym_character_literal] = ACTIONS(13624),
    [sym__pair_operator] = ACTIONS(13624),
    [sym__arrow_operator] = ACTIONS(13624),
    [sym__lazy_or_operator] = ACTIONS(13624),
    [sym__lazy_and_operator] = ACTIONS(13624),
    [sym__comparison_operator] = ACTIONS(13624),
    [sym__pipe_right_operator] = ACTIONS(13624),
    [sym__pipe_left_operator] = ACTIONS(13624),
    [sym__ellipsis_operator] = ACTIONS(13624),
    [sym__plus_operator] = ACTIONS(13624),
    [sym__times_operator] = ACTIONS(13624),
    [sym__rational_operator] = ACTIONS(13624),
    [sym__bitshift_operator] = ACTIONS(13624),
    [sym__power_operator] = ACTIONS(13624),
    [sym__tilde_operator] = ACTIONS(13624),
    [sym__type_order_operator] = ACTIONS(13624),
    [sym__unary_operator] = ACTIONS(13624),
    [sym__unary_plus_operator] = ACTIONS(13624),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13626),
    [sym__command_start] = ACTIONS(13626),
  },
  [8921] = {
    [sym__word_identifier] = ACTIONS(13628),
    [anon_sym_EQ] = ACTIONS(13628),
    [anon_sym_COMMA] = ACTIONS(13628),
    [anon_sym_COLON] = ACTIONS(13628),
    [anon_sym_begin] = ACTIONS(13628),
    [anon_sym_module] = ACTIONS(13628),
    [anon_sym_baremodule] = ACTIONS(13628),
    [anon_sym_abstract] = ACTIONS(13628),
    [anon_sym_primitive] = ACTIONS(13628),
    [anon_sym_mutable] = ACTIONS(13628),
    [anon_sym_struct] = ACTIONS(13628),
    [anon_sym_function] = ACTIONS(13628),
    [anon_sym_macro] = ACTIONS(13628),
    [anon_sym_where] = ACTIONS(13628),
    [anon_sym_quote] = ACTIONS(13628),
    [anon_sym_let] = ACTIONS(13628),
    [anon_sym_if] = ACTIONS(13628),
    [anon_sym_try] = ACTIONS(13628),
    [anon_sym_for] = ACTIONS(13628),
    [anon_sym_while] = ACTIONS(13628),
    [sym_break_statement] = ACTIONS(13628),
    [sym_continue_statement] = ACTIONS(13628),
    [anon_sym_return] = ACTIONS(13628),
    [anon_sym_const] = ACTIONS(13628),
    [anon_sym_global] = ACTIONS(13628),
    [anon_sym_local] = ACTIONS(13628),
    [anon_sym_LPAREN] = ACTIONS(13628),
    [anon_sym_RPAREN] = ACTIONS(13628),
    [anon_sym_COLON2] = ACTIONS(13628),
    [anon_sym_export] = ACTIONS(13628),
    [anon_sym_import] = ACTIONS(13628),
    [anon_sym_using] = ACTIONS(13628),
    [anon_sym_LBRACK] = ACTIONS(13628),
    [anon_sym_LF] = ACTIONS(13630),
    [anon_sym_in] = ACTIONS(13628),
    [anon_sym_SEMI] = ACTIONS(13628),
    [anon_sym_LBRACE] = ACTIONS(13628),
    [anon_sym_DOLLAR] = ACTIONS(13628),
    [anon_sym_COLON_COLON] = ACTIONS(13628),
    [anon_sym_isa] = ACTIONS(13628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13628),
    [anon_sym_QMARK] = ACTIONS(13628),
    [anon_sym_AT] = ACTIONS(13628),
    [anon_sym_true] = ACTIONS(13628),
    [anon_sym_false] = ACTIONS(13628),
    [aux_sym_integer_literal_token1] = ACTIONS(13628),
    [aux_sym_integer_literal_token2] = ACTIONS(13628),
    [aux_sym_integer_literal_token3] = ACTIONS(13628),
    [aux_sym_integer_literal_token4] = ACTIONS(13628),
    [aux_sym_float_literal_token1] = ACTIONS(13628),
    [aux_sym_float_literal_token3] = ACTIONS(13628),
    [aux_sym_float_literal_token4] = ACTIONS(13628),
    [sym_character_literal] = ACTIONS(13628),
    [sym__pair_operator] = ACTIONS(13628),
    [sym__arrow_operator] = ACTIONS(13628),
    [sym__lazy_or_operator] = ACTIONS(13628),
    [sym__lazy_and_operator] = ACTIONS(13628),
    [sym__comparison_operator] = ACTIONS(13628),
    [sym__pipe_right_operator] = ACTIONS(13628),
    [sym__pipe_left_operator] = ACTIONS(13628),
    [sym__ellipsis_operator] = ACTIONS(13628),
    [sym__plus_operator] = ACTIONS(13628),
    [sym__times_operator] = ACTIONS(13628),
    [sym__rational_operator] = ACTIONS(13628),
    [sym__bitshift_operator] = ACTIONS(13628),
    [sym__power_operator] = ACTIONS(13628),
    [sym__tilde_operator] = ACTIONS(13628),
    [sym__type_order_operator] = ACTIONS(13628),
    [sym__unary_operator] = ACTIONS(13628),
    [sym__unary_plus_operator] = ACTIONS(13628),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13630),
    [sym__command_start] = ACTIONS(13630),
  },
  [8922] = {
    [sym__word_identifier] = ACTIONS(13632),
    [anon_sym_EQ] = ACTIONS(13632),
    [anon_sym_COMMA] = ACTIONS(13632),
    [anon_sym_COLON] = ACTIONS(13632),
    [anon_sym_begin] = ACTIONS(13632),
    [anon_sym_module] = ACTIONS(13632),
    [anon_sym_baremodule] = ACTIONS(13632),
    [anon_sym_abstract] = ACTIONS(13632),
    [anon_sym_primitive] = ACTIONS(13632),
    [anon_sym_mutable] = ACTIONS(13632),
    [anon_sym_struct] = ACTIONS(13632),
    [anon_sym_function] = ACTIONS(13632),
    [anon_sym_macro] = ACTIONS(13632),
    [anon_sym_where] = ACTIONS(13632),
    [anon_sym_quote] = ACTIONS(13632),
    [anon_sym_let] = ACTIONS(13632),
    [anon_sym_if] = ACTIONS(13632),
    [anon_sym_try] = ACTIONS(13632),
    [anon_sym_for] = ACTIONS(13632),
    [anon_sym_while] = ACTIONS(13632),
    [sym_break_statement] = ACTIONS(13632),
    [sym_continue_statement] = ACTIONS(13632),
    [anon_sym_return] = ACTIONS(13632),
    [anon_sym_const] = ACTIONS(13632),
    [anon_sym_global] = ACTIONS(13632),
    [anon_sym_local] = ACTIONS(13632),
    [anon_sym_LPAREN] = ACTIONS(13632),
    [anon_sym_RPAREN] = ACTIONS(13632),
    [anon_sym_COLON2] = ACTIONS(13632),
    [anon_sym_export] = ACTIONS(13632),
    [anon_sym_import] = ACTIONS(13632),
    [anon_sym_using] = ACTIONS(13632),
    [anon_sym_LBRACK] = ACTIONS(13632),
    [anon_sym_LF] = ACTIONS(13634),
    [anon_sym_in] = ACTIONS(13632),
    [anon_sym_SEMI] = ACTIONS(13632),
    [anon_sym_LBRACE] = ACTIONS(13632),
    [anon_sym_DOLLAR] = ACTIONS(13632),
    [anon_sym_COLON_COLON] = ACTIONS(13632),
    [anon_sym_isa] = ACTIONS(13632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13632),
    [anon_sym_QMARK] = ACTIONS(13632),
    [anon_sym_AT] = ACTIONS(13632),
    [anon_sym_true] = ACTIONS(13632),
    [anon_sym_false] = ACTIONS(13632),
    [aux_sym_integer_literal_token1] = ACTIONS(13632),
    [aux_sym_integer_literal_token2] = ACTIONS(13632),
    [aux_sym_integer_literal_token3] = ACTIONS(13632),
    [aux_sym_integer_literal_token4] = ACTIONS(13632),
    [aux_sym_float_literal_token1] = ACTIONS(13632),
    [aux_sym_float_literal_token3] = ACTIONS(13632),
    [aux_sym_float_literal_token4] = ACTIONS(13632),
    [sym_character_literal] = ACTIONS(13632),
    [sym__pair_operator] = ACTIONS(13632),
    [sym__arrow_operator] = ACTIONS(13632),
    [sym__lazy_or_operator] = ACTIONS(13632),
    [sym__lazy_and_operator] = ACTIONS(13632),
    [sym__comparison_operator] = ACTIONS(13632),
    [sym__pipe_right_operator] = ACTIONS(13632),
    [sym__pipe_left_operator] = ACTIONS(13632),
    [sym__ellipsis_operator] = ACTIONS(13632),
    [sym__plus_operator] = ACTIONS(13632),
    [sym__times_operator] = ACTIONS(13632),
    [sym__rational_operator] = ACTIONS(13632),
    [sym__bitshift_operator] = ACTIONS(13632),
    [sym__power_operator] = ACTIONS(13632),
    [sym__tilde_operator] = ACTIONS(13632),
    [sym__type_order_operator] = ACTIONS(13632),
    [sym__unary_operator] = ACTIONS(13632),
    [sym__unary_plus_operator] = ACTIONS(13632),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13634),
    [sym__command_start] = ACTIONS(13634),
  },
  [8923] = {
    [sym__word_identifier] = ACTIONS(13636),
    [anon_sym_EQ] = ACTIONS(13636),
    [anon_sym_COMMA] = ACTIONS(13636),
    [anon_sym_COLON] = ACTIONS(13636),
    [anon_sym_begin] = ACTIONS(13636),
    [anon_sym_module] = ACTIONS(13636),
    [anon_sym_baremodule] = ACTIONS(13636),
    [anon_sym_abstract] = ACTIONS(13636),
    [anon_sym_primitive] = ACTIONS(13636),
    [anon_sym_mutable] = ACTIONS(13636),
    [anon_sym_struct] = ACTIONS(13636),
    [anon_sym_function] = ACTIONS(13636),
    [anon_sym_macro] = ACTIONS(13636),
    [anon_sym_where] = ACTIONS(13636),
    [anon_sym_quote] = ACTIONS(13636),
    [anon_sym_let] = ACTIONS(13636),
    [anon_sym_if] = ACTIONS(13636),
    [anon_sym_try] = ACTIONS(13636),
    [anon_sym_for] = ACTIONS(13636),
    [anon_sym_while] = ACTIONS(13636),
    [sym_break_statement] = ACTIONS(13636),
    [sym_continue_statement] = ACTIONS(13636),
    [anon_sym_return] = ACTIONS(13636),
    [anon_sym_const] = ACTIONS(13636),
    [anon_sym_global] = ACTIONS(13636),
    [anon_sym_local] = ACTIONS(13636),
    [anon_sym_LPAREN] = ACTIONS(13636),
    [anon_sym_RPAREN] = ACTIONS(13636),
    [anon_sym_COLON2] = ACTIONS(13636),
    [anon_sym_export] = ACTIONS(13636),
    [anon_sym_import] = ACTIONS(13636),
    [anon_sym_using] = ACTIONS(13636),
    [anon_sym_LBRACK] = ACTIONS(13636),
    [anon_sym_LF] = ACTIONS(13638),
    [anon_sym_in] = ACTIONS(13636),
    [anon_sym_SEMI] = ACTIONS(13636),
    [anon_sym_LBRACE] = ACTIONS(13636),
    [anon_sym_DOLLAR] = ACTIONS(13636),
    [anon_sym_COLON_COLON] = ACTIONS(13636),
    [anon_sym_isa] = ACTIONS(13636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13636),
    [anon_sym_QMARK] = ACTIONS(13636),
    [anon_sym_AT] = ACTIONS(13636),
    [anon_sym_true] = ACTIONS(13636),
    [anon_sym_false] = ACTIONS(13636),
    [aux_sym_integer_literal_token1] = ACTIONS(13636),
    [aux_sym_integer_literal_token2] = ACTIONS(13636),
    [aux_sym_integer_literal_token3] = ACTIONS(13636),
    [aux_sym_integer_literal_token4] = ACTIONS(13636),
    [aux_sym_float_literal_token1] = ACTIONS(13636),
    [aux_sym_float_literal_token3] = ACTIONS(13636),
    [aux_sym_float_literal_token4] = ACTIONS(13636),
    [sym_character_literal] = ACTIONS(13636),
    [sym__pair_operator] = ACTIONS(13636),
    [sym__arrow_operator] = ACTIONS(13636),
    [sym__lazy_or_operator] = ACTIONS(13636),
    [sym__lazy_and_operator] = ACTIONS(13636),
    [sym__comparison_operator] = ACTIONS(13636),
    [sym__pipe_right_operator] = ACTIONS(13636),
    [sym__pipe_left_operator] = ACTIONS(13636),
    [sym__ellipsis_operator] = ACTIONS(13636),
    [sym__plus_operator] = ACTIONS(13636),
    [sym__times_operator] = ACTIONS(13636),
    [sym__rational_operator] = ACTIONS(13636),
    [sym__bitshift_operator] = ACTIONS(13636),
    [sym__power_operator] = ACTIONS(13636),
    [sym__tilde_operator] = ACTIONS(13636),
    [sym__type_order_operator] = ACTIONS(13636),
    [sym__unary_operator] = ACTIONS(13636),
    [sym__unary_plus_operator] = ACTIONS(13636),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13638),
    [sym__command_start] = ACTIONS(13638),
  },
  [8924] = {
    [sym__word_identifier] = ACTIONS(13640),
    [anon_sym_EQ] = ACTIONS(13640),
    [anon_sym_COMMA] = ACTIONS(13640),
    [anon_sym_COLON] = ACTIONS(13640),
    [anon_sym_begin] = ACTIONS(13640),
    [anon_sym_module] = ACTIONS(13640),
    [anon_sym_baremodule] = ACTIONS(13640),
    [anon_sym_abstract] = ACTIONS(13640),
    [anon_sym_primitive] = ACTIONS(13640),
    [anon_sym_mutable] = ACTIONS(13640),
    [anon_sym_struct] = ACTIONS(13640),
    [anon_sym_function] = ACTIONS(13640),
    [anon_sym_macro] = ACTIONS(13640),
    [anon_sym_where] = ACTIONS(13640),
    [anon_sym_quote] = ACTIONS(13640),
    [anon_sym_let] = ACTIONS(13640),
    [anon_sym_if] = ACTIONS(13640),
    [anon_sym_try] = ACTIONS(13640),
    [anon_sym_for] = ACTIONS(13640),
    [anon_sym_while] = ACTIONS(13640),
    [sym_break_statement] = ACTIONS(13640),
    [sym_continue_statement] = ACTIONS(13640),
    [anon_sym_return] = ACTIONS(13640),
    [anon_sym_const] = ACTIONS(13640),
    [anon_sym_global] = ACTIONS(13640),
    [anon_sym_local] = ACTIONS(13640),
    [anon_sym_LPAREN] = ACTIONS(13640),
    [anon_sym_RPAREN] = ACTIONS(13640),
    [anon_sym_COLON2] = ACTIONS(13640),
    [anon_sym_export] = ACTIONS(13640),
    [anon_sym_import] = ACTIONS(13640),
    [anon_sym_using] = ACTIONS(13640),
    [anon_sym_LBRACK] = ACTIONS(13640),
    [anon_sym_LF] = ACTIONS(13642),
    [anon_sym_in] = ACTIONS(13640),
    [anon_sym_SEMI] = ACTIONS(13640),
    [anon_sym_LBRACE] = ACTIONS(13640),
    [anon_sym_DOLLAR] = ACTIONS(13640),
    [anon_sym_COLON_COLON] = ACTIONS(13640),
    [anon_sym_isa] = ACTIONS(13640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13640),
    [anon_sym_QMARK] = ACTIONS(13640),
    [anon_sym_AT] = ACTIONS(13640),
    [anon_sym_true] = ACTIONS(13640),
    [anon_sym_false] = ACTIONS(13640),
    [aux_sym_integer_literal_token1] = ACTIONS(13640),
    [aux_sym_integer_literal_token2] = ACTIONS(13640),
    [aux_sym_integer_literal_token3] = ACTIONS(13640),
    [aux_sym_integer_literal_token4] = ACTIONS(13640),
    [aux_sym_float_literal_token1] = ACTIONS(13640),
    [aux_sym_float_literal_token3] = ACTIONS(13640),
    [aux_sym_float_literal_token4] = ACTIONS(13640),
    [sym_character_literal] = ACTIONS(13640),
    [sym__pair_operator] = ACTIONS(13640),
    [sym__arrow_operator] = ACTIONS(13640),
    [sym__lazy_or_operator] = ACTIONS(13640),
    [sym__lazy_and_operator] = ACTIONS(13640),
    [sym__comparison_operator] = ACTIONS(13640),
    [sym__pipe_right_operator] = ACTIONS(13640),
    [sym__pipe_left_operator] = ACTIONS(13640),
    [sym__ellipsis_operator] = ACTIONS(13640),
    [sym__plus_operator] = ACTIONS(13640),
    [sym__times_operator] = ACTIONS(13640),
    [sym__rational_operator] = ACTIONS(13640),
    [sym__bitshift_operator] = ACTIONS(13640),
    [sym__power_operator] = ACTIONS(13640),
    [sym__tilde_operator] = ACTIONS(13640),
    [sym__type_order_operator] = ACTIONS(13640),
    [sym__unary_operator] = ACTIONS(13640),
    [sym__unary_plus_operator] = ACTIONS(13640),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13642),
    [sym__command_start] = ACTIONS(13642),
  },
  [8925] = {
    [sym__word_identifier] = ACTIONS(13644),
    [anon_sym_EQ] = ACTIONS(13644),
    [anon_sym_COMMA] = ACTIONS(13644),
    [anon_sym_COLON] = ACTIONS(13644),
    [anon_sym_begin] = ACTIONS(13644),
    [anon_sym_module] = ACTIONS(13644),
    [anon_sym_baremodule] = ACTIONS(13644),
    [anon_sym_abstract] = ACTIONS(13644),
    [anon_sym_primitive] = ACTIONS(13644),
    [anon_sym_mutable] = ACTIONS(13644),
    [anon_sym_struct] = ACTIONS(13644),
    [anon_sym_function] = ACTIONS(13644),
    [anon_sym_macro] = ACTIONS(13644),
    [anon_sym_where] = ACTIONS(13644),
    [anon_sym_quote] = ACTIONS(13644),
    [anon_sym_let] = ACTIONS(13644),
    [anon_sym_if] = ACTIONS(13644),
    [anon_sym_try] = ACTIONS(13644),
    [anon_sym_for] = ACTIONS(13644),
    [anon_sym_while] = ACTIONS(13644),
    [sym_break_statement] = ACTIONS(13644),
    [sym_continue_statement] = ACTIONS(13644),
    [anon_sym_return] = ACTIONS(13644),
    [anon_sym_const] = ACTIONS(13644),
    [anon_sym_global] = ACTIONS(13644),
    [anon_sym_local] = ACTIONS(13644),
    [anon_sym_LPAREN] = ACTIONS(13644),
    [anon_sym_RPAREN] = ACTIONS(13644),
    [anon_sym_COLON2] = ACTIONS(13644),
    [anon_sym_export] = ACTIONS(13644),
    [anon_sym_import] = ACTIONS(13644),
    [anon_sym_using] = ACTIONS(13644),
    [anon_sym_LBRACK] = ACTIONS(13644),
    [anon_sym_LF] = ACTIONS(13646),
    [anon_sym_in] = ACTIONS(13644),
    [anon_sym_SEMI] = ACTIONS(13644),
    [anon_sym_LBRACE] = ACTIONS(13644),
    [anon_sym_DOLLAR] = ACTIONS(13644),
    [anon_sym_COLON_COLON] = ACTIONS(13644),
    [anon_sym_isa] = ACTIONS(13644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13644),
    [anon_sym_QMARK] = ACTIONS(13644),
    [anon_sym_AT] = ACTIONS(13644),
    [anon_sym_true] = ACTIONS(13644),
    [anon_sym_false] = ACTIONS(13644),
    [aux_sym_integer_literal_token1] = ACTIONS(13644),
    [aux_sym_integer_literal_token2] = ACTIONS(13644),
    [aux_sym_integer_literal_token3] = ACTIONS(13644),
    [aux_sym_integer_literal_token4] = ACTIONS(13644),
    [aux_sym_float_literal_token1] = ACTIONS(13644),
    [aux_sym_float_literal_token3] = ACTIONS(13644),
    [aux_sym_float_literal_token4] = ACTIONS(13644),
    [sym_character_literal] = ACTIONS(13644),
    [sym__pair_operator] = ACTIONS(13644),
    [sym__arrow_operator] = ACTIONS(13644),
    [sym__lazy_or_operator] = ACTIONS(13644),
    [sym__lazy_and_operator] = ACTIONS(13644),
    [sym__comparison_operator] = ACTIONS(13644),
    [sym__pipe_right_operator] = ACTIONS(13644),
    [sym__pipe_left_operator] = ACTIONS(13644),
    [sym__ellipsis_operator] = ACTIONS(13644),
    [sym__plus_operator] = ACTIONS(13644),
    [sym__times_operator] = ACTIONS(13644),
    [sym__rational_operator] = ACTIONS(13644),
    [sym__bitshift_operator] = ACTIONS(13644),
    [sym__power_operator] = ACTIONS(13644),
    [sym__tilde_operator] = ACTIONS(13644),
    [sym__type_order_operator] = ACTIONS(13644),
    [sym__unary_operator] = ACTIONS(13644),
    [sym__unary_plus_operator] = ACTIONS(13644),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13646),
    [sym__command_start] = ACTIONS(13646),
  },
  [8926] = {
    [sym__word_identifier] = ACTIONS(13648),
    [anon_sym_EQ] = ACTIONS(13648),
    [anon_sym_COMMA] = ACTIONS(13648),
    [anon_sym_COLON] = ACTIONS(13648),
    [anon_sym_begin] = ACTIONS(13648),
    [anon_sym_module] = ACTIONS(13648),
    [anon_sym_baremodule] = ACTIONS(13648),
    [anon_sym_abstract] = ACTIONS(13648),
    [anon_sym_primitive] = ACTIONS(13648),
    [anon_sym_mutable] = ACTIONS(13648),
    [anon_sym_struct] = ACTIONS(13648),
    [anon_sym_function] = ACTIONS(13648),
    [anon_sym_macro] = ACTIONS(13648),
    [anon_sym_where] = ACTIONS(13648),
    [anon_sym_quote] = ACTIONS(13648),
    [anon_sym_let] = ACTIONS(13648),
    [anon_sym_if] = ACTIONS(13648),
    [anon_sym_try] = ACTIONS(13648),
    [anon_sym_for] = ACTIONS(13648),
    [anon_sym_while] = ACTIONS(13648),
    [sym_break_statement] = ACTIONS(13648),
    [sym_continue_statement] = ACTIONS(13648),
    [anon_sym_return] = ACTIONS(13648),
    [anon_sym_const] = ACTIONS(13648),
    [anon_sym_global] = ACTIONS(13648),
    [anon_sym_local] = ACTIONS(13648),
    [anon_sym_LPAREN] = ACTIONS(13648),
    [anon_sym_RPAREN] = ACTIONS(13648),
    [anon_sym_COLON2] = ACTIONS(13648),
    [anon_sym_export] = ACTIONS(13648),
    [anon_sym_import] = ACTIONS(13648),
    [anon_sym_using] = ACTIONS(13648),
    [anon_sym_LBRACK] = ACTIONS(13648),
    [anon_sym_LF] = ACTIONS(13650),
    [anon_sym_in] = ACTIONS(13648),
    [anon_sym_SEMI] = ACTIONS(13648),
    [anon_sym_LBRACE] = ACTIONS(13648),
    [anon_sym_DOLLAR] = ACTIONS(13648),
    [anon_sym_COLON_COLON] = ACTIONS(13648),
    [anon_sym_isa] = ACTIONS(13648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13648),
    [anon_sym_QMARK] = ACTIONS(13648),
    [anon_sym_AT] = ACTIONS(13648),
    [anon_sym_true] = ACTIONS(13648),
    [anon_sym_false] = ACTIONS(13648),
    [aux_sym_integer_literal_token1] = ACTIONS(13648),
    [aux_sym_integer_literal_token2] = ACTIONS(13648),
    [aux_sym_integer_literal_token3] = ACTIONS(13648),
    [aux_sym_integer_literal_token4] = ACTIONS(13648),
    [aux_sym_float_literal_token1] = ACTIONS(13648),
    [aux_sym_float_literal_token3] = ACTIONS(13648),
    [aux_sym_float_literal_token4] = ACTIONS(13648),
    [sym_character_literal] = ACTIONS(13648),
    [sym__pair_operator] = ACTIONS(13648),
    [sym__arrow_operator] = ACTIONS(13648),
    [sym__lazy_or_operator] = ACTIONS(13648),
    [sym__lazy_and_operator] = ACTIONS(13648),
    [sym__comparison_operator] = ACTIONS(13648),
    [sym__pipe_right_operator] = ACTIONS(13648),
    [sym__pipe_left_operator] = ACTIONS(13648),
    [sym__ellipsis_operator] = ACTIONS(13648),
    [sym__plus_operator] = ACTIONS(13648),
    [sym__times_operator] = ACTIONS(13648),
    [sym__rational_operator] = ACTIONS(13648),
    [sym__bitshift_operator] = ACTIONS(13648),
    [sym__power_operator] = ACTIONS(13648),
    [sym__tilde_operator] = ACTIONS(13648),
    [sym__type_order_operator] = ACTIONS(13648),
    [sym__unary_operator] = ACTIONS(13648),
    [sym__unary_plus_operator] = ACTIONS(13648),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13650),
    [sym__command_start] = ACTIONS(13650),
  },
  [8927] = {
    [sym__word_identifier] = ACTIONS(13366),
    [anon_sym_EQ] = ACTIONS(13366),
    [anon_sym_COMMA] = ACTIONS(13366),
    [anon_sym_COLON] = ACTIONS(13366),
    [anon_sym_begin] = ACTIONS(13366),
    [anon_sym_module] = ACTIONS(13366),
    [anon_sym_baremodule] = ACTIONS(13366),
    [anon_sym_end] = ACTIONS(13366),
    [anon_sym_abstract] = ACTIONS(13366),
    [anon_sym_primitive] = ACTIONS(13366),
    [anon_sym_mutable] = ACTIONS(13366),
    [anon_sym_struct] = ACTIONS(13366),
    [anon_sym_function] = ACTIONS(13366),
    [anon_sym_macro] = ACTIONS(13366),
    [anon_sym_where] = ACTIONS(13366),
    [anon_sym_quote] = ACTIONS(13366),
    [anon_sym_let] = ACTIONS(13366),
    [anon_sym_if] = ACTIONS(13366),
    [anon_sym_try] = ACTIONS(13366),
    [anon_sym_for] = ACTIONS(13366),
    [anon_sym_while] = ACTIONS(13366),
    [sym_break_statement] = ACTIONS(13366),
    [sym_continue_statement] = ACTIONS(13366),
    [anon_sym_return] = ACTIONS(13366),
    [anon_sym_const] = ACTIONS(13366),
    [anon_sym_global] = ACTIONS(13366),
    [anon_sym_local] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(13366),
    [anon_sym_COLON2] = ACTIONS(13366),
    [anon_sym_export] = ACTIONS(13366),
    [anon_sym_import] = ACTIONS(13366),
    [anon_sym_using] = ACTIONS(13366),
    [anon_sym_LBRACK] = ACTIONS(13366),
    [anon_sym_LF] = ACTIONS(13368),
    [anon_sym_in] = ACTIONS(13366),
    [anon_sym_LBRACE] = ACTIONS(13366),
    [anon_sym_DOLLAR] = ACTIONS(13366),
    [anon_sym_COLON_COLON] = ACTIONS(13366),
    [anon_sym_isa] = ACTIONS(13366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13366),
    [anon_sym_QMARK] = ACTIONS(13366),
    [anon_sym_AT] = ACTIONS(13366),
    [anon_sym_true] = ACTIONS(13366),
    [anon_sym_false] = ACTIONS(13366),
    [aux_sym_integer_literal_token1] = ACTIONS(13366),
    [aux_sym_integer_literal_token2] = ACTIONS(13366),
    [aux_sym_integer_literal_token3] = ACTIONS(13366),
    [aux_sym_integer_literal_token4] = ACTIONS(13366),
    [aux_sym_float_literal_token1] = ACTIONS(13366),
    [aux_sym_float_literal_token3] = ACTIONS(13366),
    [aux_sym_float_literal_token4] = ACTIONS(13366),
    [sym_character_literal] = ACTIONS(13366),
    [sym__pair_operator] = ACTIONS(13366),
    [sym__arrow_operator] = ACTIONS(13366),
    [sym__lazy_or_operator] = ACTIONS(13366),
    [sym__lazy_and_operator] = ACTIONS(13366),
    [sym__comparison_operator] = ACTIONS(13366),
    [sym__pipe_right_operator] = ACTIONS(13366),
    [sym__pipe_left_operator] = ACTIONS(13366),
    [sym__ellipsis_operator] = ACTIONS(13366),
    [sym__plus_operator] = ACTIONS(13366),
    [sym__times_operator] = ACTIONS(13366),
    [sym__rational_operator] = ACTIONS(13366),
    [sym__bitshift_operator] = ACTIONS(13366),
    [sym__power_operator] = ACTIONS(13366),
    [sym__tilde_operator] = ACTIONS(13366),
    [sym__type_order_operator] = ACTIONS(13366),
    [sym__unary_operator] = ACTIONS(13366),
    [sym__unary_plus_operator] = ACTIONS(13366),
    [aux_sym__terminator_token1] = ACTIONS(13366),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13368),
    [sym__command_start] = ACTIONS(13368),
  },
  [8928] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8929] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(1189),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_elseif] = ACTIONS(13338),
    [anon_sym_else] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(1211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1217),
    [anon_sym_QMARK] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14850),
    [sym__arrow_operator] = ACTIONS(14852),
    [sym__lazy_or_operator] = ACTIONS(1233),
    [sym__lazy_and_operator] = ACTIONS(1235),
    [sym__comparison_operator] = ACTIONS(1211),
    [sym__pipe_right_operator] = ACTIONS(14812),
    [sym__pipe_left_operator] = ACTIONS(14814),
    [sym__ellipsis_operator] = ACTIONS(14816),
    [sym__plus_operator] = ACTIONS(14818),
    [sym__times_operator] = ACTIONS(14820),
    [sym__rational_operator] = ACTIONS(14822),
    [sym__bitshift_operator] = ACTIONS(14824),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(1211),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14818),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [8930] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14780),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_catch] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14782),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14784),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14612),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14866),
    [sym__arrow_operator] = ACTIONS(14786),
    [sym__lazy_or_operator] = ACTIONS(14788),
    [sym__lazy_and_operator] = ACTIONS(14790),
    [sym__comparison_operator] = ACTIONS(14784),
    [sym__pipe_right_operator] = ACTIONS(14792),
    [sym__pipe_left_operator] = ACTIONS(14794),
    [sym__ellipsis_operator] = ACTIONS(14796),
    [sym__plus_operator] = ACTIONS(14798),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14784),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14798),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [8931] = {
    [sym__word_identifier] = ACTIONS(13652),
    [anon_sym_EQ] = ACTIONS(13652),
    [anon_sym_COMMA] = ACTIONS(13652),
    [anon_sym_COLON] = ACTIONS(13652),
    [anon_sym_begin] = ACTIONS(13652),
    [anon_sym_module] = ACTIONS(13652),
    [anon_sym_baremodule] = ACTIONS(13652),
    [anon_sym_abstract] = ACTIONS(13652),
    [anon_sym_primitive] = ACTIONS(13652),
    [anon_sym_mutable] = ACTIONS(13652),
    [anon_sym_struct] = ACTIONS(13652),
    [anon_sym_function] = ACTIONS(13652),
    [anon_sym_macro] = ACTIONS(13652),
    [anon_sym_where] = ACTIONS(13652),
    [anon_sym_quote] = ACTIONS(13652),
    [anon_sym_let] = ACTIONS(13652),
    [anon_sym_if] = ACTIONS(13652),
    [anon_sym_try] = ACTIONS(13652),
    [anon_sym_for] = ACTIONS(13652),
    [anon_sym_while] = ACTIONS(13652),
    [sym_break_statement] = ACTIONS(13652),
    [sym_continue_statement] = ACTIONS(13652),
    [anon_sym_return] = ACTIONS(13652),
    [anon_sym_const] = ACTIONS(13652),
    [anon_sym_global] = ACTIONS(13652),
    [anon_sym_local] = ACTIONS(13652),
    [anon_sym_LPAREN] = ACTIONS(13652),
    [anon_sym_RPAREN] = ACTIONS(13652),
    [anon_sym_COLON2] = ACTIONS(13652),
    [anon_sym_export] = ACTIONS(13652),
    [anon_sym_import] = ACTIONS(13652),
    [anon_sym_using] = ACTIONS(13652),
    [anon_sym_LBRACK] = ACTIONS(13652),
    [anon_sym_LF] = ACTIONS(13654),
    [anon_sym_in] = ACTIONS(13652),
    [anon_sym_SEMI] = ACTIONS(13652),
    [anon_sym_LBRACE] = ACTIONS(13652),
    [anon_sym_DOLLAR] = ACTIONS(13652),
    [anon_sym_COLON_COLON] = ACTIONS(13652),
    [anon_sym_isa] = ACTIONS(13652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13652),
    [anon_sym_QMARK] = ACTIONS(13652),
    [anon_sym_AT] = ACTIONS(13652),
    [anon_sym_true] = ACTIONS(13652),
    [anon_sym_false] = ACTIONS(13652),
    [aux_sym_integer_literal_token1] = ACTIONS(13652),
    [aux_sym_integer_literal_token2] = ACTIONS(13652),
    [aux_sym_integer_literal_token3] = ACTIONS(13652),
    [aux_sym_integer_literal_token4] = ACTIONS(13652),
    [aux_sym_float_literal_token1] = ACTIONS(13652),
    [aux_sym_float_literal_token3] = ACTIONS(13652),
    [aux_sym_float_literal_token4] = ACTIONS(13652),
    [sym_character_literal] = ACTIONS(13652),
    [sym__pair_operator] = ACTIONS(13652),
    [sym__arrow_operator] = ACTIONS(13652),
    [sym__lazy_or_operator] = ACTIONS(13652),
    [sym__lazy_and_operator] = ACTIONS(13652),
    [sym__comparison_operator] = ACTIONS(13652),
    [sym__pipe_right_operator] = ACTIONS(13652),
    [sym__pipe_left_operator] = ACTIONS(13652),
    [sym__ellipsis_operator] = ACTIONS(13652),
    [sym__plus_operator] = ACTIONS(13652),
    [sym__times_operator] = ACTIONS(13652),
    [sym__rational_operator] = ACTIONS(13652),
    [sym__bitshift_operator] = ACTIONS(13652),
    [sym__power_operator] = ACTIONS(13652),
    [sym__tilde_operator] = ACTIONS(13652),
    [sym__type_order_operator] = ACTIONS(13652),
    [sym__unary_operator] = ACTIONS(13652),
    [sym__unary_plus_operator] = ACTIONS(13652),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13654),
    [sym__command_start] = ACTIONS(13654),
  },
  [8932] = {
    [sym__word_identifier] = ACTIONS(13656),
    [anon_sym_EQ] = ACTIONS(13656),
    [anon_sym_COMMA] = ACTIONS(13656),
    [anon_sym_COLON] = ACTIONS(13656),
    [anon_sym_begin] = ACTIONS(13656),
    [anon_sym_module] = ACTIONS(13656),
    [anon_sym_baremodule] = ACTIONS(13656),
    [anon_sym_abstract] = ACTIONS(13656),
    [anon_sym_primitive] = ACTIONS(13656),
    [anon_sym_mutable] = ACTIONS(13656),
    [anon_sym_struct] = ACTIONS(13656),
    [anon_sym_function] = ACTIONS(13656),
    [anon_sym_macro] = ACTIONS(13656),
    [anon_sym_where] = ACTIONS(13656),
    [anon_sym_quote] = ACTIONS(13656),
    [anon_sym_let] = ACTIONS(13656),
    [anon_sym_if] = ACTIONS(13656),
    [anon_sym_try] = ACTIONS(13656),
    [anon_sym_for] = ACTIONS(13656),
    [anon_sym_while] = ACTIONS(13656),
    [sym_break_statement] = ACTIONS(13656),
    [sym_continue_statement] = ACTIONS(13656),
    [anon_sym_return] = ACTIONS(13656),
    [anon_sym_const] = ACTIONS(13656),
    [anon_sym_global] = ACTIONS(13656),
    [anon_sym_local] = ACTIONS(13656),
    [anon_sym_LPAREN] = ACTIONS(13656),
    [anon_sym_RPAREN] = ACTIONS(13656),
    [anon_sym_COLON2] = ACTIONS(13656),
    [anon_sym_export] = ACTIONS(13656),
    [anon_sym_import] = ACTIONS(13656),
    [anon_sym_using] = ACTIONS(13656),
    [anon_sym_LBRACK] = ACTIONS(13656),
    [anon_sym_LF] = ACTIONS(13658),
    [anon_sym_in] = ACTIONS(13656),
    [anon_sym_SEMI] = ACTIONS(13656),
    [anon_sym_LBRACE] = ACTIONS(13656),
    [anon_sym_DOLLAR] = ACTIONS(13656),
    [anon_sym_COLON_COLON] = ACTIONS(13656),
    [anon_sym_isa] = ACTIONS(13656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13656),
    [anon_sym_QMARK] = ACTIONS(13656),
    [anon_sym_AT] = ACTIONS(13656),
    [anon_sym_true] = ACTIONS(13656),
    [anon_sym_false] = ACTIONS(13656),
    [aux_sym_integer_literal_token1] = ACTIONS(13656),
    [aux_sym_integer_literal_token2] = ACTIONS(13656),
    [aux_sym_integer_literal_token3] = ACTIONS(13656),
    [aux_sym_integer_literal_token4] = ACTIONS(13656),
    [aux_sym_float_literal_token1] = ACTIONS(13656),
    [aux_sym_float_literal_token3] = ACTIONS(13656),
    [aux_sym_float_literal_token4] = ACTIONS(13656),
    [sym_character_literal] = ACTIONS(13656),
    [sym__pair_operator] = ACTIONS(13656),
    [sym__arrow_operator] = ACTIONS(13656),
    [sym__lazy_or_operator] = ACTIONS(13656),
    [sym__lazy_and_operator] = ACTIONS(13656),
    [sym__comparison_operator] = ACTIONS(13656),
    [sym__pipe_right_operator] = ACTIONS(13656),
    [sym__pipe_left_operator] = ACTIONS(13656),
    [sym__ellipsis_operator] = ACTIONS(13656),
    [sym__plus_operator] = ACTIONS(13656),
    [sym__times_operator] = ACTIONS(13656),
    [sym__rational_operator] = ACTIONS(13656),
    [sym__bitshift_operator] = ACTIONS(13656),
    [sym__power_operator] = ACTIONS(13656),
    [sym__tilde_operator] = ACTIONS(13656),
    [sym__type_order_operator] = ACTIONS(13656),
    [sym__unary_operator] = ACTIONS(13656),
    [sym__unary_plus_operator] = ACTIONS(13656),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13658),
    [sym__command_start] = ACTIONS(13658),
  },
  [8933] = {
    [sym__word_identifier] = ACTIONS(13660),
    [anon_sym_EQ] = ACTIONS(13660),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_COLON] = ACTIONS(13660),
    [anon_sym_begin] = ACTIONS(13660),
    [anon_sym_module] = ACTIONS(13660),
    [anon_sym_baremodule] = ACTIONS(13660),
    [anon_sym_abstract] = ACTIONS(13660),
    [anon_sym_primitive] = ACTIONS(13660),
    [anon_sym_mutable] = ACTIONS(13660),
    [anon_sym_struct] = ACTIONS(13660),
    [anon_sym_function] = ACTIONS(13660),
    [anon_sym_macro] = ACTIONS(13660),
    [anon_sym_where] = ACTIONS(13660),
    [anon_sym_quote] = ACTIONS(13660),
    [anon_sym_let] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_try] = ACTIONS(13660),
    [anon_sym_for] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [sym_break_statement] = ACTIONS(13660),
    [sym_continue_statement] = ACTIONS(13660),
    [anon_sym_return] = ACTIONS(13660),
    [anon_sym_const] = ACTIONS(13660),
    [anon_sym_global] = ACTIONS(13660),
    [anon_sym_local] = ACTIONS(13660),
    [anon_sym_LPAREN] = ACTIONS(13660),
    [anon_sym_RPAREN] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13660),
    [anon_sym_export] = ACTIONS(13660),
    [anon_sym_import] = ACTIONS(13660),
    [anon_sym_using] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_LF] = ACTIONS(13662),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_SEMI] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_DOLLAR] = ACTIONS(13660),
    [anon_sym_COLON_COLON] = ACTIONS(13660),
    [anon_sym_isa] = ACTIONS(13660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_AT] = ACTIONS(13660),
    [anon_sym_true] = ACTIONS(13660),
    [anon_sym_false] = ACTIONS(13660),
    [aux_sym_integer_literal_token1] = ACTIONS(13660),
    [aux_sym_integer_literal_token2] = ACTIONS(13660),
    [aux_sym_integer_literal_token3] = ACTIONS(13660),
    [aux_sym_integer_literal_token4] = ACTIONS(13660),
    [aux_sym_float_literal_token1] = ACTIONS(13660),
    [aux_sym_float_literal_token3] = ACTIONS(13660),
    [aux_sym_float_literal_token4] = ACTIONS(13660),
    [sym_character_literal] = ACTIONS(13660),
    [sym__pair_operator] = ACTIONS(13660),
    [sym__arrow_operator] = ACTIONS(13660),
    [sym__lazy_or_operator] = ACTIONS(13660),
    [sym__lazy_and_operator] = ACTIONS(13660),
    [sym__comparison_operator] = ACTIONS(13660),
    [sym__pipe_right_operator] = ACTIONS(13660),
    [sym__pipe_left_operator] = ACTIONS(13660),
    [sym__ellipsis_operator] = ACTIONS(13660),
    [sym__plus_operator] = ACTIONS(13660),
    [sym__times_operator] = ACTIONS(13660),
    [sym__rational_operator] = ACTIONS(13660),
    [sym__bitshift_operator] = ACTIONS(13660),
    [sym__power_operator] = ACTIONS(13660),
    [sym__tilde_operator] = ACTIONS(13660),
    [sym__type_order_operator] = ACTIONS(13660),
    [sym__unary_operator] = ACTIONS(13660),
    [sym__unary_plus_operator] = ACTIONS(13660),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13662),
    [sym__command_start] = ACTIONS(13662),
  },
  [8934] = {
    [sym__word_identifier] = ACTIONS(13664),
    [anon_sym_EQ] = ACTIONS(13664),
    [anon_sym_COMMA] = ACTIONS(13664),
    [anon_sym_COLON] = ACTIONS(13664),
    [anon_sym_begin] = ACTIONS(13664),
    [anon_sym_module] = ACTIONS(13664),
    [anon_sym_baremodule] = ACTIONS(13664),
    [anon_sym_abstract] = ACTIONS(13664),
    [anon_sym_primitive] = ACTIONS(13664),
    [anon_sym_mutable] = ACTIONS(13664),
    [anon_sym_struct] = ACTIONS(13664),
    [anon_sym_function] = ACTIONS(13664),
    [anon_sym_macro] = ACTIONS(13664),
    [anon_sym_where] = ACTIONS(13664),
    [anon_sym_quote] = ACTIONS(13664),
    [anon_sym_let] = ACTIONS(13664),
    [anon_sym_if] = ACTIONS(13664),
    [anon_sym_try] = ACTIONS(13664),
    [anon_sym_for] = ACTIONS(13664),
    [anon_sym_while] = ACTIONS(13664),
    [sym_break_statement] = ACTIONS(13664),
    [sym_continue_statement] = ACTIONS(13664),
    [anon_sym_return] = ACTIONS(13664),
    [anon_sym_const] = ACTIONS(13664),
    [anon_sym_global] = ACTIONS(13664),
    [anon_sym_local] = ACTIONS(13664),
    [anon_sym_LPAREN] = ACTIONS(13664),
    [anon_sym_RPAREN] = ACTIONS(13664),
    [anon_sym_COLON2] = ACTIONS(13664),
    [anon_sym_export] = ACTIONS(13664),
    [anon_sym_import] = ACTIONS(13664),
    [anon_sym_using] = ACTIONS(13664),
    [anon_sym_LBRACK] = ACTIONS(13664),
    [anon_sym_LF] = ACTIONS(13666),
    [anon_sym_in] = ACTIONS(13664),
    [anon_sym_SEMI] = ACTIONS(13664),
    [anon_sym_LBRACE] = ACTIONS(13664),
    [anon_sym_DOLLAR] = ACTIONS(13664),
    [anon_sym_COLON_COLON] = ACTIONS(13664),
    [anon_sym_isa] = ACTIONS(13664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13664),
    [anon_sym_QMARK] = ACTIONS(13664),
    [anon_sym_AT] = ACTIONS(13664),
    [anon_sym_true] = ACTIONS(13664),
    [anon_sym_false] = ACTIONS(13664),
    [aux_sym_integer_literal_token1] = ACTIONS(13664),
    [aux_sym_integer_literal_token2] = ACTIONS(13664),
    [aux_sym_integer_literal_token3] = ACTIONS(13664),
    [aux_sym_integer_literal_token4] = ACTIONS(13664),
    [aux_sym_float_literal_token1] = ACTIONS(13664),
    [aux_sym_float_literal_token3] = ACTIONS(13664),
    [aux_sym_float_literal_token4] = ACTIONS(13664),
    [sym_character_literal] = ACTIONS(13664),
    [sym__pair_operator] = ACTIONS(13664),
    [sym__arrow_operator] = ACTIONS(13664),
    [sym__lazy_or_operator] = ACTIONS(13664),
    [sym__lazy_and_operator] = ACTIONS(13664),
    [sym__comparison_operator] = ACTIONS(13664),
    [sym__pipe_right_operator] = ACTIONS(13664),
    [sym__pipe_left_operator] = ACTIONS(13664),
    [sym__ellipsis_operator] = ACTIONS(13664),
    [sym__plus_operator] = ACTIONS(13664),
    [sym__times_operator] = ACTIONS(13664),
    [sym__rational_operator] = ACTIONS(13664),
    [sym__bitshift_operator] = ACTIONS(13664),
    [sym__power_operator] = ACTIONS(13664),
    [sym__tilde_operator] = ACTIONS(13664),
    [sym__type_order_operator] = ACTIONS(13664),
    [sym__unary_operator] = ACTIONS(13664),
    [sym__unary_plus_operator] = ACTIONS(13664),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13666),
    [sym__command_start] = ACTIONS(13666),
  },
  [8935] = {
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13255),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13255),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13255),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13255),
    [anon_sym_isa] = ACTIONS(13255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13255),
    [anon_sym_QMARK] = ACTIONS(13255),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13255),
    [sym__arrow_operator] = ACTIONS(13255),
    [sym__lazy_or_operator] = ACTIONS(13255),
    [sym__lazy_and_operator] = ACTIONS(13255),
    [sym__comparison_operator] = ACTIONS(13255),
    [sym__pipe_right_operator] = ACTIONS(13255),
    [sym__pipe_left_operator] = ACTIONS(13255),
    [sym__ellipsis_operator] = ACTIONS(13255),
    [sym__plus_operator] = ACTIONS(13255),
    [sym__times_operator] = ACTIONS(13255),
    [sym__rational_operator] = ACTIONS(13255),
    [sym__bitshift_operator] = ACTIONS(13255),
    [sym__power_operator] = ACTIONS(13255),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13255),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13255),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8936] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12762),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8937] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8938] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_RPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_SEMI] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [8939] = {
    [sym__word_identifier] = ACTIONS(13413),
    [anon_sym_EQ] = ACTIONS(13413),
    [anon_sym_COMMA] = ACTIONS(13413),
    [anon_sym_COLON] = ACTIONS(13413),
    [anon_sym_begin] = ACTIONS(13413),
    [anon_sym_module] = ACTIONS(13413),
    [anon_sym_baremodule] = ACTIONS(13413),
    [anon_sym_end] = ACTIONS(13413),
    [anon_sym_abstract] = ACTIONS(13413),
    [anon_sym_primitive] = ACTIONS(13413),
    [anon_sym_mutable] = ACTIONS(13413),
    [anon_sym_struct] = ACTIONS(13413),
    [anon_sym_function] = ACTIONS(13413),
    [anon_sym_macro] = ACTIONS(13413),
    [anon_sym_where] = ACTIONS(13413),
    [anon_sym_quote] = ACTIONS(13413),
    [anon_sym_let] = ACTIONS(13413),
    [anon_sym_if] = ACTIONS(13413),
    [anon_sym_try] = ACTIONS(13413),
    [anon_sym_for] = ACTIONS(13413),
    [anon_sym_while] = ACTIONS(13413),
    [sym_break_statement] = ACTIONS(13413),
    [sym_continue_statement] = ACTIONS(13413),
    [anon_sym_return] = ACTIONS(13413),
    [anon_sym_const] = ACTIONS(13413),
    [anon_sym_global] = ACTIONS(13413),
    [anon_sym_local] = ACTIONS(13413),
    [anon_sym_LPAREN] = ACTIONS(13413),
    [anon_sym_COLON2] = ACTIONS(13413),
    [anon_sym_export] = ACTIONS(13413),
    [anon_sym_import] = ACTIONS(13413),
    [anon_sym_using] = ACTIONS(13413),
    [anon_sym_LBRACK] = ACTIONS(13413),
    [anon_sym_LF] = ACTIONS(13415),
    [anon_sym_in] = ACTIONS(13413),
    [anon_sym_LBRACE] = ACTIONS(13413),
    [anon_sym_DOLLAR] = ACTIONS(13413),
    [anon_sym_COLON_COLON] = ACTIONS(13413),
    [anon_sym_isa] = ACTIONS(13413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_QMARK] = ACTIONS(13413),
    [anon_sym_AT] = ACTIONS(13413),
    [anon_sym_true] = ACTIONS(13413),
    [anon_sym_false] = ACTIONS(13413),
    [aux_sym_integer_literal_token1] = ACTIONS(13413),
    [aux_sym_integer_literal_token2] = ACTIONS(13413),
    [aux_sym_integer_literal_token3] = ACTIONS(13413),
    [aux_sym_integer_literal_token4] = ACTIONS(13413),
    [aux_sym_float_literal_token1] = ACTIONS(13413),
    [aux_sym_float_literal_token3] = ACTIONS(13413),
    [aux_sym_float_literal_token4] = ACTIONS(13413),
    [sym_character_literal] = ACTIONS(13413),
    [sym__pair_operator] = ACTIONS(13413),
    [sym__arrow_operator] = ACTIONS(13413),
    [sym__lazy_or_operator] = ACTIONS(13413),
    [sym__lazy_and_operator] = ACTIONS(13413),
    [sym__comparison_operator] = ACTIONS(13413),
    [sym__pipe_right_operator] = ACTIONS(13413),
    [sym__pipe_left_operator] = ACTIONS(13413),
    [sym__ellipsis_operator] = ACTIONS(13413),
    [sym__plus_operator] = ACTIONS(13413),
    [sym__times_operator] = ACTIONS(13413),
    [sym__rational_operator] = ACTIONS(13413),
    [sym__bitshift_operator] = ACTIONS(13413),
    [sym__power_operator] = ACTIONS(13413),
    [sym__tilde_operator] = ACTIONS(13413),
    [sym__type_order_operator] = ACTIONS(13413),
    [sym__unary_operator] = ACTIONS(13413),
    [sym__unary_plus_operator] = ACTIONS(13413),
    [aux_sym__terminator_token1] = ACTIONS(13413),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13415),
    [sym__command_start] = ACTIONS(13415),
  },
  [8940] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8941] = {
    [sym__word_identifier] = ACTIONS(13417),
    [anon_sym_EQ] = ACTIONS(13417),
    [anon_sym_COMMA] = ACTIONS(13417),
    [anon_sym_COLON] = ACTIONS(13417),
    [anon_sym_begin] = ACTIONS(13417),
    [anon_sym_module] = ACTIONS(13417),
    [anon_sym_baremodule] = ACTIONS(13417),
    [anon_sym_end] = ACTIONS(13417),
    [anon_sym_abstract] = ACTIONS(13417),
    [anon_sym_primitive] = ACTIONS(13417),
    [anon_sym_mutable] = ACTIONS(13417),
    [anon_sym_struct] = ACTIONS(13417),
    [anon_sym_function] = ACTIONS(13417),
    [anon_sym_macro] = ACTIONS(13417),
    [anon_sym_where] = ACTIONS(13417),
    [anon_sym_quote] = ACTIONS(13417),
    [anon_sym_let] = ACTIONS(13417),
    [anon_sym_if] = ACTIONS(13417),
    [anon_sym_try] = ACTIONS(13417),
    [anon_sym_for] = ACTIONS(13417),
    [anon_sym_while] = ACTIONS(13417),
    [sym_break_statement] = ACTIONS(13417),
    [sym_continue_statement] = ACTIONS(13417),
    [anon_sym_return] = ACTIONS(13417),
    [anon_sym_const] = ACTIONS(13417),
    [anon_sym_global] = ACTIONS(13417),
    [anon_sym_local] = ACTIONS(13417),
    [anon_sym_LPAREN] = ACTIONS(13417),
    [anon_sym_COLON2] = ACTIONS(13417),
    [anon_sym_export] = ACTIONS(13417),
    [anon_sym_import] = ACTIONS(13417),
    [anon_sym_using] = ACTIONS(13417),
    [anon_sym_LBRACK] = ACTIONS(13417),
    [anon_sym_LF] = ACTIONS(13419),
    [anon_sym_in] = ACTIONS(13417),
    [anon_sym_LBRACE] = ACTIONS(13417),
    [anon_sym_DOLLAR] = ACTIONS(13417),
    [anon_sym_COLON_COLON] = ACTIONS(13417),
    [anon_sym_isa] = ACTIONS(13417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13417),
    [anon_sym_QMARK] = ACTIONS(13417),
    [anon_sym_AT] = ACTIONS(13417),
    [anon_sym_true] = ACTIONS(13417),
    [anon_sym_false] = ACTIONS(13417),
    [aux_sym_integer_literal_token1] = ACTIONS(13417),
    [aux_sym_integer_literal_token2] = ACTIONS(13417),
    [aux_sym_integer_literal_token3] = ACTIONS(13417),
    [aux_sym_integer_literal_token4] = ACTIONS(13417),
    [aux_sym_float_literal_token1] = ACTIONS(13417),
    [aux_sym_float_literal_token3] = ACTIONS(13417),
    [aux_sym_float_literal_token4] = ACTIONS(13417),
    [sym_character_literal] = ACTIONS(13417),
    [sym__pair_operator] = ACTIONS(13417),
    [sym__arrow_operator] = ACTIONS(13417),
    [sym__lazy_or_operator] = ACTIONS(13417),
    [sym__lazy_and_operator] = ACTIONS(13417),
    [sym__comparison_operator] = ACTIONS(13417),
    [sym__pipe_right_operator] = ACTIONS(13417),
    [sym__pipe_left_operator] = ACTIONS(13417),
    [sym__ellipsis_operator] = ACTIONS(13417),
    [sym__plus_operator] = ACTIONS(13417),
    [sym__times_operator] = ACTIONS(13417),
    [sym__rational_operator] = ACTIONS(13417),
    [sym__bitshift_operator] = ACTIONS(13417),
    [sym__power_operator] = ACTIONS(13417),
    [sym__tilde_operator] = ACTIONS(13417),
    [sym__type_order_operator] = ACTIONS(13417),
    [sym__unary_operator] = ACTIONS(13417),
    [sym__unary_plus_operator] = ACTIONS(13417),
    [aux_sym__terminator_token1] = ACTIONS(13417),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13419),
    [sym__command_start] = ACTIONS(13419),
  },
  [8942] = {
    [sym__word_identifier] = ACTIONS(13421),
    [anon_sym_EQ] = ACTIONS(13421),
    [anon_sym_COMMA] = ACTIONS(13421),
    [anon_sym_COLON] = ACTIONS(13421),
    [anon_sym_begin] = ACTIONS(13421),
    [anon_sym_module] = ACTIONS(13421),
    [anon_sym_baremodule] = ACTIONS(13421),
    [anon_sym_end] = ACTIONS(13421),
    [anon_sym_abstract] = ACTIONS(13421),
    [anon_sym_primitive] = ACTIONS(13421),
    [anon_sym_mutable] = ACTIONS(13421),
    [anon_sym_struct] = ACTIONS(13421),
    [anon_sym_function] = ACTIONS(13421),
    [anon_sym_macro] = ACTIONS(13421),
    [anon_sym_where] = ACTIONS(13421),
    [anon_sym_quote] = ACTIONS(13421),
    [anon_sym_let] = ACTIONS(13421),
    [anon_sym_if] = ACTIONS(13421),
    [anon_sym_try] = ACTIONS(13421),
    [anon_sym_for] = ACTIONS(13421),
    [anon_sym_while] = ACTIONS(13421),
    [sym_break_statement] = ACTIONS(13421),
    [sym_continue_statement] = ACTIONS(13421),
    [anon_sym_return] = ACTIONS(13421),
    [anon_sym_const] = ACTIONS(13421),
    [anon_sym_global] = ACTIONS(13421),
    [anon_sym_local] = ACTIONS(13421),
    [anon_sym_LPAREN] = ACTIONS(13421),
    [anon_sym_COLON2] = ACTIONS(13421),
    [anon_sym_export] = ACTIONS(13421),
    [anon_sym_import] = ACTIONS(13421),
    [anon_sym_using] = ACTIONS(13421),
    [anon_sym_LBRACK] = ACTIONS(13421),
    [anon_sym_LF] = ACTIONS(13423),
    [anon_sym_in] = ACTIONS(13421),
    [anon_sym_LBRACE] = ACTIONS(13421),
    [anon_sym_DOLLAR] = ACTIONS(13421),
    [anon_sym_COLON_COLON] = ACTIONS(13421),
    [anon_sym_isa] = ACTIONS(13421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13421),
    [anon_sym_QMARK] = ACTIONS(13421),
    [anon_sym_AT] = ACTIONS(13421),
    [anon_sym_true] = ACTIONS(13421),
    [anon_sym_false] = ACTIONS(13421),
    [aux_sym_integer_literal_token1] = ACTIONS(13421),
    [aux_sym_integer_literal_token2] = ACTIONS(13421),
    [aux_sym_integer_literal_token3] = ACTIONS(13421),
    [aux_sym_integer_literal_token4] = ACTIONS(13421),
    [aux_sym_float_literal_token1] = ACTIONS(13421),
    [aux_sym_float_literal_token3] = ACTIONS(13421),
    [aux_sym_float_literal_token4] = ACTIONS(13421),
    [sym_character_literal] = ACTIONS(13421),
    [sym__pair_operator] = ACTIONS(13421),
    [sym__arrow_operator] = ACTIONS(13421),
    [sym__lazy_or_operator] = ACTIONS(13421),
    [sym__lazy_and_operator] = ACTIONS(13421),
    [sym__comparison_operator] = ACTIONS(13421),
    [sym__pipe_right_operator] = ACTIONS(13421),
    [sym__pipe_left_operator] = ACTIONS(13421),
    [sym__ellipsis_operator] = ACTIONS(13421),
    [sym__plus_operator] = ACTIONS(13421),
    [sym__times_operator] = ACTIONS(13421),
    [sym__rational_operator] = ACTIONS(13421),
    [sym__bitshift_operator] = ACTIONS(13421),
    [sym__power_operator] = ACTIONS(13421),
    [sym__tilde_operator] = ACTIONS(13421),
    [sym__type_order_operator] = ACTIONS(13421),
    [sym__unary_operator] = ACTIONS(13421),
    [sym__unary_plus_operator] = ACTIONS(13421),
    [aux_sym__terminator_token1] = ACTIONS(13421),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13423),
    [sym__command_start] = ACTIONS(13423),
  },
  [8943] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12790),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DASH_GT] = ACTIONS(12426),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8944] = {
    [sym__word_identifier] = ACTIONS(13425),
    [anon_sym_EQ] = ACTIONS(13425),
    [anon_sym_COMMA] = ACTIONS(13425),
    [anon_sym_COLON] = ACTIONS(13425),
    [anon_sym_begin] = ACTIONS(13425),
    [anon_sym_module] = ACTIONS(13425),
    [anon_sym_baremodule] = ACTIONS(13425),
    [anon_sym_end] = ACTIONS(13425),
    [anon_sym_abstract] = ACTIONS(13425),
    [anon_sym_primitive] = ACTIONS(13425),
    [anon_sym_mutable] = ACTIONS(13425),
    [anon_sym_struct] = ACTIONS(13425),
    [anon_sym_function] = ACTIONS(13425),
    [anon_sym_macro] = ACTIONS(13425),
    [anon_sym_where] = ACTIONS(13425),
    [anon_sym_quote] = ACTIONS(13425),
    [anon_sym_let] = ACTIONS(13425),
    [anon_sym_if] = ACTIONS(13425),
    [anon_sym_try] = ACTIONS(13425),
    [anon_sym_for] = ACTIONS(13425),
    [anon_sym_while] = ACTIONS(13425),
    [sym_break_statement] = ACTIONS(13425),
    [sym_continue_statement] = ACTIONS(13425),
    [anon_sym_return] = ACTIONS(13425),
    [anon_sym_const] = ACTIONS(13425),
    [anon_sym_global] = ACTIONS(13425),
    [anon_sym_local] = ACTIONS(13425),
    [anon_sym_LPAREN] = ACTIONS(13425),
    [anon_sym_COLON2] = ACTIONS(13425),
    [anon_sym_export] = ACTIONS(13425),
    [anon_sym_import] = ACTIONS(13425),
    [anon_sym_using] = ACTIONS(13425),
    [anon_sym_LBRACK] = ACTIONS(13425),
    [anon_sym_LF] = ACTIONS(13427),
    [anon_sym_in] = ACTIONS(13425),
    [anon_sym_LBRACE] = ACTIONS(13425),
    [anon_sym_DOLLAR] = ACTIONS(13425),
    [anon_sym_COLON_COLON] = ACTIONS(13425),
    [anon_sym_isa] = ACTIONS(13425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13425),
    [anon_sym_QMARK] = ACTIONS(13425),
    [anon_sym_AT] = ACTIONS(13425),
    [anon_sym_true] = ACTIONS(13425),
    [anon_sym_false] = ACTIONS(13425),
    [aux_sym_integer_literal_token1] = ACTIONS(13425),
    [aux_sym_integer_literal_token2] = ACTIONS(13425),
    [aux_sym_integer_literal_token3] = ACTIONS(13425),
    [aux_sym_integer_literal_token4] = ACTIONS(13425),
    [aux_sym_float_literal_token1] = ACTIONS(13425),
    [aux_sym_float_literal_token3] = ACTIONS(13425),
    [aux_sym_float_literal_token4] = ACTIONS(13425),
    [sym_character_literal] = ACTIONS(13425),
    [sym__pair_operator] = ACTIONS(13425),
    [sym__arrow_operator] = ACTIONS(13425),
    [sym__lazy_or_operator] = ACTIONS(13425),
    [sym__lazy_and_operator] = ACTIONS(13425),
    [sym__comparison_operator] = ACTIONS(13425),
    [sym__pipe_right_operator] = ACTIONS(13425),
    [sym__pipe_left_operator] = ACTIONS(13425),
    [sym__ellipsis_operator] = ACTIONS(13425),
    [sym__plus_operator] = ACTIONS(13425),
    [sym__times_operator] = ACTIONS(13425),
    [sym__rational_operator] = ACTIONS(13425),
    [sym__bitshift_operator] = ACTIONS(13425),
    [sym__power_operator] = ACTIONS(13425),
    [sym__tilde_operator] = ACTIONS(13425),
    [sym__type_order_operator] = ACTIONS(13425),
    [sym__unary_operator] = ACTIONS(13425),
    [sym__unary_plus_operator] = ACTIONS(13425),
    [aux_sym__terminator_token1] = ACTIONS(13425),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13427),
    [sym__command_start] = ACTIONS(13427),
  },
  [8945] = {
    [sym__word_identifier] = ACTIONS(13429),
    [anon_sym_EQ] = ACTIONS(13429),
    [anon_sym_COMMA] = ACTIONS(13429),
    [anon_sym_COLON] = ACTIONS(13429),
    [anon_sym_begin] = ACTIONS(13429),
    [anon_sym_module] = ACTIONS(13429),
    [anon_sym_baremodule] = ACTIONS(13429),
    [anon_sym_end] = ACTIONS(13429),
    [anon_sym_abstract] = ACTIONS(13429),
    [anon_sym_primitive] = ACTIONS(13429),
    [anon_sym_mutable] = ACTIONS(13429),
    [anon_sym_struct] = ACTIONS(13429),
    [anon_sym_function] = ACTIONS(13429),
    [anon_sym_macro] = ACTIONS(13429),
    [anon_sym_where] = ACTIONS(13429),
    [anon_sym_quote] = ACTIONS(13429),
    [anon_sym_let] = ACTIONS(13429),
    [anon_sym_if] = ACTIONS(13429),
    [anon_sym_try] = ACTIONS(13429),
    [anon_sym_for] = ACTIONS(13429),
    [anon_sym_while] = ACTIONS(13429),
    [sym_break_statement] = ACTIONS(13429),
    [sym_continue_statement] = ACTIONS(13429),
    [anon_sym_return] = ACTIONS(13429),
    [anon_sym_const] = ACTIONS(13429),
    [anon_sym_global] = ACTIONS(13429),
    [anon_sym_local] = ACTIONS(13429),
    [anon_sym_LPAREN] = ACTIONS(13429),
    [anon_sym_COLON2] = ACTIONS(13429),
    [anon_sym_export] = ACTIONS(13429),
    [anon_sym_import] = ACTIONS(13429),
    [anon_sym_using] = ACTIONS(13429),
    [anon_sym_LBRACK] = ACTIONS(13429),
    [anon_sym_LF] = ACTIONS(13431),
    [anon_sym_in] = ACTIONS(13429),
    [anon_sym_LBRACE] = ACTIONS(13429),
    [anon_sym_DOLLAR] = ACTIONS(13429),
    [anon_sym_COLON_COLON] = ACTIONS(13429),
    [anon_sym_isa] = ACTIONS(13429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13429),
    [anon_sym_QMARK] = ACTIONS(13429),
    [anon_sym_AT] = ACTIONS(13429),
    [anon_sym_true] = ACTIONS(13429),
    [anon_sym_false] = ACTIONS(13429),
    [aux_sym_integer_literal_token1] = ACTIONS(13429),
    [aux_sym_integer_literal_token2] = ACTIONS(13429),
    [aux_sym_integer_literal_token3] = ACTIONS(13429),
    [aux_sym_integer_literal_token4] = ACTIONS(13429),
    [aux_sym_float_literal_token1] = ACTIONS(13429),
    [aux_sym_float_literal_token3] = ACTIONS(13429),
    [aux_sym_float_literal_token4] = ACTIONS(13429),
    [sym_character_literal] = ACTIONS(13429),
    [sym__pair_operator] = ACTIONS(13429),
    [sym__arrow_operator] = ACTIONS(13429),
    [sym__lazy_or_operator] = ACTIONS(13429),
    [sym__lazy_and_operator] = ACTIONS(13429),
    [sym__comparison_operator] = ACTIONS(13429),
    [sym__pipe_right_operator] = ACTIONS(13429),
    [sym__pipe_left_operator] = ACTIONS(13429),
    [sym__ellipsis_operator] = ACTIONS(13429),
    [sym__plus_operator] = ACTIONS(13429),
    [sym__times_operator] = ACTIONS(13429),
    [sym__rational_operator] = ACTIONS(13429),
    [sym__bitshift_operator] = ACTIONS(13429),
    [sym__power_operator] = ACTIONS(13429),
    [sym__tilde_operator] = ACTIONS(13429),
    [sym__type_order_operator] = ACTIONS(13429),
    [sym__unary_operator] = ACTIONS(13429),
    [sym__unary_plus_operator] = ACTIONS(13429),
    [aux_sym__terminator_token1] = ACTIONS(13429),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13431),
    [sym__command_start] = ACTIONS(13431),
  },
  [8946] = {
    [sym__word_identifier] = ACTIONS(13433),
    [anon_sym_EQ] = ACTIONS(13433),
    [anon_sym_COMMA] = ACTIONS(13433),
    [anon_sym_COLON] = ACTIONS(13433),
    [anon_sym_begin] = ACTIONS(13433),
    [anon_sym_module] = ACTIONS(13433),
    [anon_sym_baremodule] = ACTIONS(13433),
    [anon_sym_end] = ACTIONS(13433),
    [anon_sym_abstract] = ACTIONS(13433),
    [anon_sym_primitive] = ACTIONS(13433),
    [anon_sym_mutable] = ACTIONS(13433),
    [anon_sym_struct] = ACTIONS(13433),
    [anon_sym_function] = ACTIONS(13433),
    [anon_sym_macro] = ACTIONS(13433),
    [anon_sym_where] = ACTIONS(13433),
    [anon_sym_quote] = ACTIONS(13433),
    [anon_sym_let] = ACTIONS(13433),
    [anon_sym_if] = ACTIONS(13433),
    [anon_sym_try] = ACTIONS(13433),
    [anon_sym_for] = ACTIONS(13433),
    [anon_sym_while] = ACTIONS(13433),
    [sym_break_statement] = ACTIONS(13433),
    [sym_continue_statement] = ACTIONS(13433),
    [anon_sym_return] = ACTIONS(13433),
    [anon_sym_const] = ACTIONS(13433),
    [anon_sym_global] = ACTIONS(13433),
    [anon_sym_local] = ACTIONS(13433),
    [anon_sym_LPAREN] = ACTIONS(13433),
    [anon_sym_COLON2] = ACTIONS(13433),
    [anon_sym_export] = ACTIONS(13433),
    [anon_sym_import] = ACTIONS(13433),
    [anon_sym_using] = ACTIONS(13433),
    [anon_sym_LBRACK] = ACTIONS(13433),
    [anon_sym_LF] = ACTIONS(13435),
    [anon_sym_in] = ACTIONS(13433),
    [anon_sym_LBRACE] = ACTIONS(13433),
    [anon_sym_DOLLAR] = ACTIONS(13433),
    [anon_sym_COLON_COLON] = ACTIONS(13433),
    [anon_sym_isa] = ACTIONS(13433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13433),
    [anon_sym_QMARK] = ACTIONS(13433),
    [anon_sym_AT] = ACTIONS(13433),
    [anon_sym_true] = ACTIONS(13433),
    [anon_sym_false] = ACTIONS(13433),
    [aux_sym_integer_literal_token1] = ACTIONS(13433),
    [aux_sym_integer_literal_token2] = ACTIONS(13433),
    [aux_sym_integer_literal_token3] = ACTIONS(13433),
    [aux_sym_integer_literal_token4] = ACTIONS(13433),
    [aux_sym_float_literal_token1] = ACTIONS(13433),
    [aux_sym_float_literal_token3] = ACTIONS(13433),
    [aux_sym_float_literal_token4] = ACTIONS(13433),
    [sym_character_literal] = ACTIONS(13433),
    [sym__pair_operator] = ACTIONS(13433),
    [sym__arrow_operator] = ACTIONS(13433),
    [sym__lazy_or_operator] = ACTIONS(13433),
    [sym__lazy_and_operator] = ACTIONS(13433),
    [sym__comparison_operator] = ACTIONS(13433),
    [sym__pipe_right_operator] = ACTIONS(13433),
    [sym__pipe_left_operator] = ACTIONS(13433),
    [sym__ellipsis_operator] = ACTIONS(13433),
    [sym__plus_operator] = ACTIONS(13433),
    [sym__times_operator] = ACTIONS(13433),
    [sym__rational_operator] = ACTIONS(13433),
    [sym__bitshift_operator] = ACTIONS(13433),
    [sym__power_operator] = ACTIONS(13433),
    [sym__tilde_operator] = ACTIONS(13433),
    [sym__type_order_operator] = ACTIONS(13433),
    [sym__unary_operator] = ACTIONS(13433),
    [sym__unary_plus_operator] = ACTIONS(13433),
    [aux_sym__terminator_token1] = ACTIONS(13433),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13435),
    [sym__command_start] = ACTIONS(13435),
  },
  [8947] = {
    [sym__word_identifier] = ACTIONS(13437),
    [anon_sym_EQ] = ACTIONS(13437),
    [anon_sym_COMMA] = ACTIONS(13437),
    [anon_sym_COLON] = ACTIONS(13437),
    [anon_sym_begin] = ACTIONS(13437),
    [anon_sym_module] = ACTIONS(13437),
    [anon_sym_baremodule] = ACTIONS(13437),
    [anon_sym_end] = ACTIONS(13437),
    [anon_sym_abstract] = ACTIONS(13437),
    [anon_sym_primitive] = ACTIONS(13437),
    [anon_sym_mutable] = ACTIONS(13437),
    [anon_sym_struct] = ACTIONS(13437),
    [anon_sym_function] = ACTIONS(13437),
    [anon_sym_macro] = ACTIONS(13437),
    [anon_sym_where] = ACTIONS(13437),
    [anon_sym_quote] = ACTIONS(13437),
    [anon_sym_let] = ACTIONS(13437),
    [anon_sym_if] = ACTIONS(13437),
    [anon_sym_try] = ACTIONS(13437),
    [anon_sym_for] = ACTIONS(13437),
    [anon_sym_while] = ACTIONS(13437),
    [sym_break_statement] = ACTIONS(13437),
    [sym_continue_statement] = ACTIONS(13437),
    [anon_sym_return] = ACTIONS(13437),
    [anon_sym_const] = ACTIONS(13437),
    [anon_sym_global] = ACTIONS(13437),
    [anon_sym_local] = ACTIONS(13437),
    [anon_sym_LPAREN] = ACTIONS(13437),
    [anon_sym_COLON2] = ACTIONS(13437),
    [anon_sym_export] = ACTIONS(13437),
    [anon_sym_import] = ACTIONS(13437),
    [anon_sym_using] = ACTIONS(13437),
    [anon_sym_LBRACK] = ACTIONS(13437),
    [anon_sym_LF] = ACTIONS(13439),
    [anon_sym_in] = ACTIONS(13437),
    [anon_sym_LBRACE] = ACTIONS(13437),
    [anon_sym_DOLLAR] = ACTIONS(13437),
    [anon_sym_COLON_COLON] = ACTIONS(13437),
    [anon_sym_isa] = ACTIONS(13437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13437),
    [anon_sym_QMARK] = ACTIONS(13437),
    [anon_sym_AT] = ACTIONS(13437),
    [anon_sym_true] = ACTIONS(13437),
    [anon_sym_false] = ACTIONS(13437),
    [aux_sym_integer_literal_token1] = ACTIONS(13437),
    [aux_sym_integer_literal_token2] = ACTIONS(13437),
    [aux_sym_integer_literal_token3] = ACTIONS(13437),
    [aux_sym_integer_literal_token4] = ACTIONS(13437),
    [aux_sym_float_literal_token1] = ACTIONS(13437),
    [aux_sym_float_literal_token3] = ACTIONS(13437),
    [aux_sym_float_literal_token4] = ACTIONS(13437),
    [sym_character_literal] = ACTIONS(13437),
    [sym__pair_operator] = ACTIONS(13437),
    [sym__arrow_operator] = ACTIONS(13437),
    [sym__lazy_or_operator] = ACTIONS(13437),
    [sym__lazy_and_operator] = ACTIONS(13437),
    [sym__comparison_operator] = ACTIONS(13437),
    [sym__pipe_right_operator] = ACTIONS(13437),
    [sym__pipe_left_operator] = ACTIONS(13437),
    [sym__ellipsis_operator] = ACTIONS(13437),
    [sym__plus_operator] = ACTIONS(13437),
    [sym__times_operator] = ACTIONS(13437),
    [sym__rational_operator] = ACTIONS(13437),
    [sym__bitshift_operator] = ACTIONS(13437),
    [sym__power_operator] = ACTIONS(13437),
    [sym__tilde_operator] = ACTIONS(13437),
    [sym__type_order_operator] = ACTIONS(13437),
    [sym__unary_operator] = ACTIONS(13437),
    [sym__unary_plus_operator] = ACTIONS(13437),
    [aux_sym__terminator_token1] = ACTIONS(13437),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13439),
    [sym__command_start] = ACTIONS(13439),
  },
  [8948] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(12714),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_RPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_SEMI] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8949] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8950] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(12714),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_RPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_SEMI] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8951] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12714),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_RPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_SEMI] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8952] = {
    [sym__word_identifier] = ACTIONS(13370),
    [anon_sym_EQ] = ACTIONS(13370),
    [anon_sym_COMMA] = ACTIONS(13370),
    [anon_sym_COLON] = ACTIONS(13370),
    [anon_sym_begin] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(13370),
    [anon_sym_baremodule] = ACTIONS(13370),
    [anon_sym_end] = ACTIONS(13370),
    [anon_sym_abstract] = ACTIONS(13370),
    [anon_sym_primitive] = ACTIONS(13370),
    [anon_sym_mutable] = ACTIONS(13370),
    [anon_sym_struct] = ACTIONS(13370),
    [anon_sym_function] = ACTIONS(13370),
    [anon_sym_macro] = ACTIONS(13370),
    [anon_sym_where] = ACTIONS(13370),
    [anon_sym_quote] = ACTIONS(13370),
    [anon_sym_let] = ACTIONS(13370),
    [anon_sym_if] = ACTIONS(13370),
    [anon_sym_try] = ACTIONS(13370),
    [anon_sym_for] = ACTIONS(13370),
    [anon_sym_while] = ACTIONS(13370),
    [sym_break_statement] = ACTIONS(13370),
    [sym_continue_statement] = ACTIONS(13370),
    [anon_sym_return] = ACTIONS(13370),
    [anon_sym_const] = ACTIONS(13370),
    [anon_sym_global] = ACTIONS(13370),
    [anon_sym_local] = ACTIONS(13370),
    [anon_sym_LPAREN] = ACTIONS(13370),
    [anon_sym_COLON2] = ACTIONS(13370),
    [anon_sym_export] = ACTIONS(13370),
    [anon_sym_import] = ACTIONS(13370),
    [anon_sym_using] = ACTIONS(13370),
    [anon_sym_LBRACK] = ACTIONS(13370),
    [anon_sym_LF] = ACTIONS(13372),
    [anon_sym_in] = ACTIONS(13370),
    [anon_sym_LBRACE] = ACTIONS(13370),
    [anon_sym_DOLLAR] = ACTIONS(13370),
    [anon_sym_COLON_COLON] = ACTIONS(13370),
    [anon_sym_isa] = ACTIONS(13370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13370),
    [anon_sym_QMARK] = ACTIONS(13370),
    [anon_sym_AT] = ACTIONS(13370),
    [anon_sym_true] = ACTIONS(13370),
    [anon_sym_false] = ACTIONS(13370),
    [aux_sym_integer_literal_token1] = ACTIONS(13370),
    [aux_sym_integer_literal_token2] = ACTIONS(13370),
    [aux_sym_integer_literal_token3] = ACTIONS(13370),
    [aux_sym_integer_literal_token4] = ACTIONS(13370),
    [aux_sym_float_literal_token1] = ACTIONS(13370),
    [aux_sym_float_literal_token3] = ACTIONS(13370),
    [aux_sym_float_literal_token4] = ACTIONS(13370),
    [sym_character_literal] = ACTIONS(13370),
    [sym__pair_operator] = ACTIONS(13370),
    [sym__arrow_operator] = ACTIONS(13370),
    [sym__lazy_or_operator] = ACTIONS(13370),
    [sym__lazy_and_operator] = ACTIONS(13370),
    [sym__comparison_operator] = ACTIONS(13370),
    [sym__pipe_right_operator] = ACTIONS(13370),
    [sym__pipe_left_operator] = ACTIONS(13370),
    [sym__ellipsis_operator] = ACTIONS(13370),
    [sym__plus_operator] = ACTIONS(13370),
    [sym__times_operator] = ACTIONS(13370),
    [sym__rational_operator] = ACTIONS(13370),
    [sym__bitshift_operator] = ACTIONS(13370),
    [sym__power_operator] = ACTIONS(13370),
    [sym__tilde_operator] = ACTIONS(13370),
    [sym__type_order_operator] = ACTIONS(13370),
    [sym__unary_operator] = ACTIONS(13370),
    [sym__unary_plus_operator] = ACTIONS(13370),
    [aux_sym__terminator_token1] = ACTIONS(13370),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13372),
    [sym__command_start] = ACTIONS(13372),
  },
  [8953] = {
    [sym__word_identifier] = ACTIONS(13441),
    [anon_sym_EQ] = ACTIONS(13441),
    [anon_sym_COMMA] = ACTIONS(13441),
    [anon_sym_COLON] = ACTIONS(13441),
    [anon_sym_begin] = ACTIONS(13441),
    [anon_sym_module] = ACTIONS(13441),
    [anon_sym_baremodule] = ACTIONS(13441),
    [anon_sym_end] = ACTIONS(13441),
    [anon_sym_abstract] = ACTIONS(13441),
    [anon_sym_primitive] = ACTIONS(13441),
    [anon_sym_mutable] = ACTIONS(13441),
    [anon_sym_struct] = ACTIONS(13441),
    [anon_sym_function] = ACTIONS(13441),
    [anon_sym_macro] = ACTIONS(13441),
    [anon_sym_where] = ACTIONS(13441),
    [anon_sym_quote] = ACTIONS(13441),
    [anon_sym_let] = ACTIONS(13441),
    [anon_sym_if] = ACTIONS(13441),
    [anon_sym_try] = ACTIONS(13441),
    [anon_sym_for] = ACTIONS(13441),
    [anon_sym_while] = ACTIONS(13441),
    [sym_break_statement] = ACTIONS(13441),
    [sym_continue_statement] = ACTIONS(13441),
    [anon_sym_return] = ACTIONS(13441),
    [anon_sym_const] = ACTIONS(13441),
    [anon_sym_global] = ACTIONS(13441),
    [anon_sym_local] = ACTIONS(13441),
    [anon_sym_LPAREN] = ACTIONS(13441),
    [anon_sym_COLON2] = ACTIONS(13441),
    [anon_sym_export] = ACTIONS(13441),
    [anon_sym_import] = ACTIONS(13441),
    [anon_sym_using] = ACTIONS(13441),
    [anon_sym_LBRACK] = ACTIONS(13441),
    [anon_sym_LF] = ACTIONS(13443),
    [anon_sym_in] = ACTIONS(13441),
    [anon_sym_LBRACE] = ACTIONS(13441),
    [anon_sym_DOLLAR] = ACTIONS(13441),
    [anon_sym_COLON_COLON] = ACTIONS(13441),
    [anon_sym_isa] = ACTIONS(13441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13441),
    [anon_sym_QMARK] = ACTIONS(13441),
    [anon_sym_AT] = ACTIONS(13441),
    [anon_sym_true] = ACTIONS(13441),
    [anon_sym_false] = ACTIONS(13441),
    [aux_sym_integer_literal_token1] = ACTIONS(13441),
    [aux_sym_integer_literal_token2] = ACTIONS(13441),
    [aux_sym_integer_literal_token3] = ACTIONS(13441),
    [aux_sym_integer_literal_token4] = ACTIONS(13441),
    [aux_sym_float_literal_token1] = ACTIONS(13441),
    [aux_sym_float_literal_token3] = ACTIONS(13441),
    [aux_sym_float_literal_token4] = ACTIONS(13441),
    [sym_character_literal] = ACTIONS(13441),
    [sym__pair_operator] = ACTIONS(13441),
    [sym__arrow_operator] = ACTIONS(13441),
    [sym__lazy_or_operator] = ACTIONS(13441),
    [sym__lazy_and_operator] = ACTIONS(13441),
    [sym__comparison_operator] = ACTIONS(13441),
    [sym__pipe_right_operator] = ACTIONS(13441),
    [sym__pipe_left_operator] = ACTIONS(13441),
    [sym__ellipsis_operator] = ACTIONS(13441),
    [sym__plus_operator] = ACTIONS(13441),
    [sym__times_operator] = ACTIONS(13441),
    [sym__rational_operator] = ACTIONS(13441),
    [sym__bitshift_operator] = ACTIONS(13441),
    [sym__power_operator] = ACTIONS(13441),
    [sym__tilde_operator] = ACTIONS(13441),
    [sym__type_order_operator] = ACTIONS(13441),
    [sym__unary_operator] = ACTIONS(13441),
    [sym__unary_plus_operator] = ACTIONS(13441),
    [aux_sym__terminator_token1] = ACTIONS(13441),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13443),
    [sym__command_start] = ACTIONS(13443),
  },
  [8954] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_RPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_SEMI] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8955] = {
    [sym__word_identifier] = ACTIONS(13445),
    [anon_sym_EQ] = ACTIONS(13445),
    [anon_sym_COMMA] = ACTIONS(13445),
    [anon_sym_COLON] = ACTIONS(13445),
    [anon_sym_begin] = ACTIONS(13445),
    [anon_sym_module] = ACTIONS(13445),
    [anon_sym_baremodule] = ACTIONS(13445),
    [anon_sym_end] = ACTIONS(13445),
    [anon_sym_abstract] = ACTIONS(13445),
    [anon_sym_primitive] = ACTIONS(13445),
    [anon_sym_mutable] = ACTIONS(13445),
    [anon_sym_struct] = ACTIONS(13445),
    [anon_sym_function] = ACTIONS(13445),
    [anon_sym_macro] = ACTIONS(13445),
    [anon_sym_where] = ACTIONS(13445),
    [anon_sym_quote] = ACTIONS(13445),
    [anon_sym_let] = ACTIONS(13445),
    [anon_sym_if] = ACTIONS(13445),
    [anon_sym_try] = ACTIONS(13445),
    [anon_sym_for] = ACTIONS(13445),
    [anon_sym_while] = ACTIONS(13445),
    [sym_break_statement] = ACTIONS(13445),
    [sym_continue_statement] = ACTIONS(13445),
    [anon_sym_return] = ACTIONS(13445),
    [anon_sym_const] = ACTIONS(13445),
    [anon_sym_global] = ACTIONS(13445),
    [anon_sym_local] = ACTIONS(13445),
    [anon_sym_LPAREN] = ACTIONS(13445),
    [anon_sym_COLON2] = ACTIONS(13445),
    [anon_sym_export] = ACTIONS(13445),
    [anon_sym_import] = ACTIONS(13445),
    [anon_sym_using] = ACTIONS(13445),
    [anon_sym_LBRACK] = ACTIONS(13445),
    [anon_sym_LF] = ACTIONS(13447),
    [anon_sym_in] = ACTIONS(13445),
    [anon_sym_LBRACE] = ACTIONS(13445),
    [anon_sym_DOLLAR] = ACTIONS(13445),
    [anon_sym_COLON_COLON] = ACTIONS(13445),
    [anon_sym_isa] = ACTIONS(13445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13445),
    [anon_sym_QMARK] = ACTIONS(13445),
    [anon_sym_AT] = ACTIONS(13445),
    [anon_sym_true] = ACTIONS(13445),
    [anon_sym_false] = ACTIONS(13445),
    [aux_sym_integer_literal_token1] = ACTIONS(13445),
    [aux_sym_integer_literal_token2] = ACTIONS(13445),
    [aux_sym_integer_literal_token3] = ACTIONS(13445),
    [aux_sym_integer_literal_token4] = ACTIONS(13445),
    [aux_sym_float_literal_token1] = ACTIONS(13445),
    [aux_sym_float_literal_token3] = ACTIONS(13445),
    [aux_sym_float_literal_token4] = ACTIONS(13445),
    [sym_character_literal] = ACTIONS(13445),
    [sym__pair_operator] = ACTIONS(13445),
    [sym__arrow_operator] = ACTIONS(13445),
    [sym__lazy_or_operator] = ACTIONS(13445),
    [sym__lazy_and_operator] = ACTIONS(13445),
    [sym__comparison_operator] = ACTIONS(13445),
    [sym__pipe_right_operator] = ACTIONS(13445),
    [sym__pipe_left_operator] = ACTIONS(13445),
    [sym__ellipsis_operator] = ACTIONS(13445),
    [sym__plus_operator] = ACTIONS(13445),
    [sym__times_operator] = ACTIONS(13445),
    [sym__rational_operator] = ACTIONS(13445),
    [sym__bitshift_operator] = ACTIONS(13445),
    [sym__power_operator] = ACTIONS(13445),
    [sym__tilde_operator] = ACTIONS(13445),
    [sym__type_order_operator] = ACTIONS(13445),
    [sym__unary_operator] = ACTIONS(13445),
    [sym__unary_plus_operator] = ACTIONS(13445),
    [aux_sym__terminator_token1] = ACTIONS(13445),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13447),
    [sym__command_start] = ACTIONS(13447),
  },
  [8956] = {
    [sym__word_identifier] = ACTIONS(12678),
    [anon_sym_EQ] = ACTIONS(12678),
    [anon_sym_COMMA] = ACTIONS(12678),
    [anon_sym_COLON] = ACTIONS(12678),
    [anon_sym_begin] = ACTIONS(12678),
    [anon_sym_module] = ACTIONS(12678),
    [anon_sym_baremodule] = ACTIONS(12678),
    [anon_sym_end] = ACTIONS(12678),
    [anon_sym_abstract] = ACTIONS(12678),
    [anon_sym_primitive] = ACTIONS(12678),
    [anon_sym_mutable] = ACTIONS(12678),
    [anon_sym_struct] = ACTIONS(12678),
    [anon_sym_function] = ACTIONS(12678),
    [anon_sym_macro] = ACTIONS(12678),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_quote] = ACTIONS(12678),
    [anon_sym_let] = ACTIONS(12678),
    [anon_sym_if] = ACTIONS(12678),
    [anon_sym_try] = ACTIONS(12678),
    [anon_sym_for] = ACTIONS(12678),
    [anon_sym_while] = ACTIONS(12678),
    [sym_break_statement] = ACTIONS(12678),
    [sym_continue_statement] = ACTIONS(12678),
    [anon_sym_return] = ACTIONS(12678),
    [anon_sym_const] = ACTIONS(12678),
    [anon_sym_global] = ACTIONS(12678),
    [anon_sym_local] = ACTIONS(12678),
    [anon_sym_LPAREN] = ACTIONS(12678),
    [anon_sym_COLON2] = ACTIONS(12678),
    [anon_sym_export] = ACTIONS(12678),
    [anon_sym_import] = ACTIONS(12678),
    [anon_sym_using] = ACTIONS(12678),
    [anon_sym_LBRACK] = ACTIONS(12678),
    [anon_sym_LF] = ACTIONS(12676),
    [anon_sym_in] = ACTIONS(12678),
    [anon_sym_LBRACE] = ACTIONS(12678),
    [anon_sym_DOLLAR] = ACTIONS(12678),
    [anon_sym_COLON_COLON] = ACTIONS(12678),
    [anon_sym_isa] = ACTIONS(12678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12678),
    [anon_sym_QMARK] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(12678),
    [anon_sym_true] = ACTIONS(12678),
    [anon_sym_false] = ACTIONS(12678),
    [aux_sym_integer_literal_token1] = ACTIONS(12678),
    [aux_sym_integer_literal_token2] = ACTIONS(12678),
    [aux_sym_integer_literal_token3] = ACTIONS(12678),
    [aux_sym_integer_literal_token4] = ACTIONS(12678),
    [aux_sym_float_literal_token1] = ACTIONS(12678),
    [aux_sym_float_literal_token3] = ACTIONS(12678),
    [aux_sym_float_literal_token4] = ACTIONS(12678),
    [sym_character_literal] = ACTIONS(12678),
    [sym__pair_operator] = ACTIONS(12678),
    [sym__arrow_operator] = ACTIONS(12678),
    [sym__lazy_or_operator] = ACTIONS(12678),
    [sym__lazy_and_operator] = ACTIONS(12678),
    [sym__comparison_operator] = ACTIONS(12678),
    [sym__pipe_right_operator] = ACTIONS(12678),
    [sym__pipe_left_operator] = ACTIONS(12678),
    [sym__ellipsis_operator] = ACTIONS(12678),
    [sym__plus_operator] = ACTIONS(12678),
    [sym__times_operator] = ACTIONS(12678),
    [sym__rational_operator] = ACTIONS(12678),
    [sym__bitshift_operator] = ACTIONS(12678),
    [sym__power_operator] = ACTIONS(12678),
    [sym__tilde_operator] = ACTIONS(12678),
    [sym__type_order_operator] = ACTIONS(12678),
    [sym__unary_operator] = ACTIONS(12678),
    [sym__unary_plus_operator] = ACTIONS(12678),
    [aux_sym__terminator_token1] = ACTIONS(12678),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12676),
    [sym__command_start] = ACTIONS(12676),
  },
  [8957] = {
    [sym__word_identifier] = ACTIONS(13449),
    [anon_sym_EQ] = ACTIONS(13449),
    [anon_sym_COMMA] = ACTIONS(13449),
    [anon_sym_COLON] = ACTIONS(13449),
    [anon_sym_begin] = ACTIONS(13449),
    [anon_sym_module] = ACTIONS(13449),
    [anon_sym_baremodule] = ACTIONS(13449),
    [anon_sym_end] = ACTIONS(13449),
    [anon_sym_abstract] = ACTIONS(13449),
    [anon_sym_primitive] = ACTIONS(13449),
    [anon_sym_mutable] = ACTIONS(13449),
    [anon_sym_struct] = ACTIONS(13449),
    [anon_sym_function] = ACTIONS(13449),
    [anon_sym_macro] = ACTIONS(13449),
    [anon_sym_where] = ACTIONS(13449),
    [anon_sym_quote] = ACTIONS(13449),
    [anon_sym_let] = ACTIONS(13449),
    [anon_sym_if] = ACTIONS(13449),
    [anon_sym_try] = ACTIONS(13449),
    [anon_sym_for] = ACTIONS(13449),
    [anon_sym_while] = ACTIONS(13449),
    [sym_break_statement] = ACTIONS(13449),
    [sym_continue_statement] = ACTIONS(13449),
    [anon_sym_return] = ACTIONS(13449),
    [anon_sym_const] = ACTIONS(13449),
    [anon_sym_global] = ACTIONS(13449),
    [anon_sym_local] = ACTIONS(13449),
    [anon_sym_LPAREN] = ACTIONS(13449),
    [anon_sym_COLON2] = ACTIONS(13449),
    [anon_sym_export] = ACTIONS(13449),
    [anon_sym_import] = ACTIONS(13449),
    [anon_sym_using] = ACTIONS(13449),
    [anon_sym_LBRACK] = ACTIONS(13449),
    [anon_sym_LF] = ACTIONS(13451),
    [anon_sym_in] = ACTIONS(13449),
    [anon_sym_LBRACE] = ACTIONS(13449),
    [anon_sym_DOLLAR] = ACTIONS(13449),
    [anon_sym_COLON_COLON] = ACTIONS(13449),
    [anon_sym_isa] = ACTIONS(13449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13449),
    [anon_sym_QMARK] = ACTIONS(13449),
    [anon_sym_AT] = ACTIONS(13449),
    [anon_sym_true] = ACTIONS(13449),
    [anon_sym_false] = ACTIONS(13449),
    [aux_sym_integer_literal_token1] = ACTIONS(13449),
    [aux_sym_integer_literal_token2] = ACTIONS(13449),
    [aux_sym_integer_literal_token3] = ACTIONS(13449),
    [aux_sym_integer_literal_token4] = ACTIONS(13449),
    [aux_sym_float_literal_token1] = ACTIONS(13449),
    [aux_sym_float_literal_token3] = ACTIONS(13449),
    [aux_sym_float_literal_token4] = ACTIONS(13449),
    [sym_character_literal] = ACTIONS(13449),
    [sym__pair_operator] = ACTIONS(13449),
    [sym__arrow_operator] = ACTIONS(13449),
    [sym__lazy_or_operator] = ACTIONS(13449),
    [sym__lazy_and_operator] = ACTIONS(13449),
    [sym__comparison_operator] = ACTIONS(13449),
    [sym__pipe_right_operator] = ACTIONS(13449),
    [sym__pipe_left_operator] = ACTIONS(13449),
    [sym__ellipsis_operator] = ACTIONS(13449),
    [sym__plus_operator] = ACTIONS(13449),
    [sym__times_operator] = ACTIONS(13449),
    [sym__rational_operator] = ACTIONS(13449),
    [sym__bitshift_operator] = ACTIONS(13449),
    [sym__power_operator] = ACTIONS(13449),
    [sym__tilde_operator] = ACTIONS(13449),
    [sym__type_order_operator] = ACTIONS(13449),
    [sym__unary_operator] = ACTIONS(13449),
    [sym__unary_plus_operator] = ACTIONS(13449),
    [aux_sym__terminator_token1] = ACTIONS(13449),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13451),
    [sym__command_start] = ACTIONS(13451),
  },
  [8958] = {
    [sym__word_identifier] = ACTIONS(13453),
    [anon_sym_EQ] = ACTIONS(13453),
    [anon_sym_COMMA] = ACTIONS(13453),
    [anon_sym_COLON] = ACTIONS(13453),
    [anon_sym_begin] = ACTIONS(13453),
    [anon_sym_module] = ACTIONS(13453),
    [anon_sym_baremodule] = ACTIONS(13453),
    [anon_sym_end] = ACTIONS(13453),
    [anon_sym_abstract] = ACTIONS(13453),
    [anon_sym_primitive] = ACTIONS(13453),
    [anon_sym_mutable] = ACTIONS(13453),
    [anon_sym_struct] = ACTIONS(13453),
    [anon_sym_function] = ACTIONS(13453),
    [anon_sym_macro] = ACTIONS(13453),
    [anon_sym_where] = ACTIONS(13453),
    [anon_sym_quote] = ACTIONS(13453),
    [anon_sym_let] = ACTIONS(13453),
    [anon_sym_if] = ACTIONS(13453),
    [anon_sym_try] = ACTIONS(13453),
    [anon_sym_for] = ACTIONS(13453),
    [anon_sym_while] = ACTIONS(13453),
    [sym_break_statement] = ACTIONS(13453),
    [sym_continue_statement] = ACTIONS(13453),
    [anon_sym_return] = ACTIONS(13453),
    [anon_sym_const] = ACTIONS(13453),
    [anon_sym_global] = ACTIONS(13453),
    [anon_sym_local] = ACTIONS(13453),
    [anon_sym_LPAREN] = ACTIONS(13453),
    [anon_sym_COLON2] = ACTIONS(13453),
    [anon_sym_export] = ACTIONS(13453),
    [anon_sym_import] = ACTIONS(13453),
    [anon_sym_using] = ACTIONS(13453),
    [anon_sym_LBRACK] = ACTIONS(13453),
    [anon_sym_LF] = ACTIONS(13455),
    [anon_sym_in] = ACTIONS(13453),
    [anon_sym_LBRACE] = ACTIONS(13453),
    [anon_sym_DOLLAR] = ACTIONS(13453),
    [anon_sym_COLON_COLON] = ACTIONS(13453),
    [anon_sym_isa] = ACTIONS(13453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13453),
    [anon_sym_QMARK] = ACTIONS(13453),
    [anon_sym_AT] = ACTIONS(13453),
    [anon_sym_true] = ACTIONS(13453),
    [anon_sym_false] = ACTIONS(13453),
    [aux_sym_integer_literal_token1] = ACTIONS(13453),
    [aux_sym_integer_literal_token2] = ACTIONS(13453),
    [aux_sym_integer_literal_token3] = ACTIONS(13453),
    [aux_sym_integer_literal_token4] = ACTIONS(13453),
    [aux_sym_float_literal_token1] = ACTIONS(13453),
    [aux_sym_float_literal_token3] = ACTIONS(13453),
    [aux_sym_float_literal_token4] = ACTIONS(13453),
    [sym_character_literal] = ACTIONS(13453),
    [sym__pair_operator] = ACTIONS(13453),
    [sym__arrow_operator] = ACTIONS(13453),
    [sym__lazy_or_operator] = ACTIONS(13453),
    [sym__lazy_and_operator] = ACTIONS(13453),
    [sym__comparison_operator] = ACTIONS(13453),
    [sym__pipe_right_operator] = ACTIONS(13453),
    [sym__pipe_left_operator] = ACTIONS(13453),
    [sym__ellipsis_operator] = ACTIONS(13453),
    [sym__plus_operator] = ACTIONS(13453),
    [sym__times_operator] = ACTIONS(13453),
    [sym__rational_operator] = ACTIONS(13453),
    [sym__bitshift_operator] = ACTIONS(13453),
    [sym__power_operator] = ACTIONS(13453),
    [sym__tilde_operator] = ACTIONS(13453),
    [sym__type_order_operator] = ACTIONS(13453),
    [sym__unary_operator] = ACTIONS(13453),
    [sym__unary_plus_operator] = ACTIONS(13453),
    [aux_sym__terminator_token1] = ACTIONS(13453),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13455),
    [sym__command_start] = ACTIONS(13455),
  },
  [8959] = {
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13070),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_end] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14682),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [8960] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(12714),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_RPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_SEMI] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8961] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12838),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12442),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8962] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(14868),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8963] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(14870),
    [anon_sym_COMMA] = ACTIONS(13199),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13199),
    [anon_sym_RPAREN] = ACTIONS(13199),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13199),
    [anon_sym_RBRACK] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13199),
    [anon_sym_RBRACE] = ACTIONS(13199),
    [anon_sym_DOLLAR] = ACTIONS(13199),
    [anon_sym_COLON_COLON] = ACTIONS(13199),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13199),
    [anon_sym_QMARK] = ACTIONS(13199),
    [anon_sym_AT] = ACTIONS(13199),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13199),
    [aux_sym_integer_literal_token2] = ACTIONS(13199),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13199),
    [aux_sym_float_literal_token3] = ACTIONS(13199),
    [aux_sym_float_literal_token4] = ACTIONS(13199),
    [sym_character_literal] = ACTIONS(13199),
    [sym__pair_operator] = ACTIONS(13199),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13199),
    [sym__lazy_and_operator] = ACTIONS(13199),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13199),
    [sym__pipe_left_operator] = ACTIONS(13199),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13199),
    [sym__bitshift_operator] = ACTIONS(13199),
    [sym__power_operator] = ACTIONS(13199),
    [sym__tilde_operator] = ACTIONS(13199),
    [sym__type_order_operator] = ACTIONS(13199),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8964] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(14868),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8965] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(14868),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8966] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(14868),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8967] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [8968] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13806),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8969] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_EQ] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_RPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13338),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14754),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [8970] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(12732),
    [anon_sym_COMMA] = ACTIONS(13199),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13199),
    [anon_sym_RPAREN] = ACTIONS(13199),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13199),
    [anon_sym_RBRACK] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13199),
    [anon_sym_RBRACE] = ACTIONS(13199),
    [anon_sym_DOLLAR] = ACTIONS(13199),
    [anon_sym_COLON_COLON] = ACTIONS(13199),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13199),
    [anon_sym_QMARK] = ACTIONS(13199),
    [anon_sym_AT] = ACTIONS(13199),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13199),
    [aux_sym_integer_literal_token2] = ACTIONS(13199),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13199),
    [aux_sym_float_literal_token3] = ACTIONS(13199),
    [aux_sym_float_literal_token4] = ACTIONS(13199),
    [sym_character_literal] = ACTIONS(13199),
    [sym__pair_operator] = ACTIONS(13199),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13199),
    [sym__lazy_and_operator] = ACTIONS(13199),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13199),
    [sym__pipe_left_operator] = ACTIONS(13199),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13199),
    [sym__bitshift_operator] = ACTIONS(13199),
    [sym__power_operator] = ACTIONS(13199),
    [sym__tilde_operator] = ACTIONS(13199),
    [sym__type_order_operator] = ACTIONS(13199),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8971] = {
    [sym__word_identifier] = ACTIONS(13457),
    [anon_sym_EQ] = ACTIONS(13457),
    [anon_sym_COMMA] = ACTIONS(13457),
    [anon_sym_COLON] = ACTIONS(13457),
    [anon_sym_begin] = ACTIONS(13457),
    [anon_sym_module] = ACTIONS(13457),
    [anon_sym_baremodule] = ACTIONS(13457),
    [anon_sym_end] = ACTIONS(13457),
    [anon_sym_abstract] = ACTIONS(13457),
    [anon_sym_primitive] = ACTIONS(13457),
    [anon_sym_mutable] = ACTIONS(13457),
    [anon_sym_struct] = ACTIONS(13457),
    [anon_sym_function] = ACTIONS(13457),
    [anon_sym_macro] = ACTIONS(13457),
    [anon_sym_where] = ACTIONS(13457),
    [anon_sym_quote] = ACTIONS(13457),
    [anon_sym_let] = ACTIONS(13457),
    [anon_sym_if] = ACTIONS(13457),
    [anon_sym_try] = ACTIONS(13457),
    [anon_sym_for] = ACTIONS(13457),
    [anon_sym_while] = ACTIONS(13457),
    [sym_break_statement] = ACTIONS(13457),
    [sym_continue_statement] = ACTIONS(13457),
    [anon_sym_return] = ACTIONS(13457),
    [anon_sym_const] = ACTIONS(13457),
    [anon_sym_global] = ACTIONS(13457),
    [anon_sym_local] = ACTIONS(13457),
    [anon_sym_LPAREN] = ACTIONS(13457),
    [anon_sym_COLON2] = ACTIONS(13457),
    [anon_sym_export] = ACTIONS(13457),
    [anon_sym_import] = ACTIONS(13457),
    [anon_sym_using] = ACTIONS(13457),
    [anon_sym_LBRACK] = ACTIONS(13457),
    [anon_sym_LF] = ACTIONS(13459),
    [anon_sym_in] = ACTIONS(13457),
    [anon_sym_LBRACE] = ACTIONS(13457),
    [anon_sym_DOLLAR] = ACTIONS(13457),
    [anon_sym_COLON_COLON] = ACTIONS(13457),
    [anon_sym_isa] = ACTIONS(13457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13457),
    [anon_sym_QMARK] = ACTIONS(13457),
    [anon_sym_AT] = ACTIONS(13457),
    [anon_sym_true] = ACTIONS(13457),
    [anon_sym_false] = ACTIONS(13457),
    [aux_sym_integer_literal_token1] = ACTIONS(13457),
    [aux_sym_integer_literal_token2] = ACTIONS(13457),
    [aux_sym_integer_literal_token3] = ACTIONS(13457),
    [aux_sym_integer_literal_token4] = ACTIONS(13457),
    [aux_sym_float_literal_token1] = ACTIONS(13457),
    [aux_sym_float_literal_token3] = ACTIONS(13457),
    [aux_sym_float_literal_token4] = ACTIONS(13457),
    [sym_character_literal] = ACTIONS(13457),
    [sym__pair_operator] = ACTIONS(13457),
    [sym__arrow_operator] = ACTIONS(13457),
    [sym__lazy_or_operator] = ACTIONS(13457),
    [sym__lazy_and_operator] = ACTIONS(13457),
    [sym__comparison_operator] = ACTIONS(13457),
    [sym__pipe_right_operator] = ACTIONS(13457),
    [sym__pipe_left_operator] = ACTIONS(13457),
    [sym__ellipsis_operator] = ACTIONS(13457),
    [sym__plus_operator] = ACTIONS(13457),
    [sym__times_operator] = ACTIONS(13457),
    [sym__rational_operator] = ACTIONS(13457),
    [sym__bitshift_operator] = ACTIONS(13457),
    [sym__power_operator] = ACTIONS(13457),
    [sym__tilde_operator] = ACTIONS(13457),
    [sym__type_order_operator] = ACTIONS(13457),
    [sym__unary_operator] = ACTIONS(13457),
    [sym__unary_plus_operator] = ACTIONS(13457),
    [aux_sym__terminator_token1] = ACTIONS(13457),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13459),
    [sym__command_start] = ACTIONS(13459),
  },
  [8972] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(14872),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_RPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_SEMI] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8973] = {
    [sym__word_identifier] = ACTIONS(13461),
    [anon_sym_EQ] = ACTIONS(13461),
    [anon_sym_COMMA] = ACTIONS(13461),
    [anon_sym_COLON] = ACTIONS(13461),
    [anon_sym_begin] = ACTIONS(13461),
    [anon_sym_module] = ACTIONS(13461),
    [anon_sym_baremodule] = ACTIONS(13461),
    [anon_sym_end] = ACTIONS(13461),
    [anon_sym_abstract] = ACTIONS(13461),
    [anon_sym_primitive] = ACTIONS(13461),
    [anon_sym_mutable] = ACTIONS(13461),
    [anon_sym_struct] = ACTIONS(13461),
    [anon_sym_function] = ACTIONS(13461),
    [anon_sym_macro] = ACTIONS(13461),
    [anon_sym_where] = ACTIONS(13461),
    [anon_sym_quote] = ACTIONS(13461),
    [anon_sym_let] = ACTIONS(13461),
    [anon_sym_if] = ACTIONS(13461),
    [anon_sym_try] = ACTIONS(13461),
    [anon_sym_for] = ACTIONS(13461),
    [anon_sym_while] = ACTIONS(13461),
    [sym_break_statement] = ACTIONS(13461),
    [sym_continue_statement] = ACTIONS(13461),
    [anon_sym_return] = ACTIONS(13461),
    [anon_sym_const] = ACTIONS(13461),
    [anon_sym_global] = ACTIONS(13461),
    [anon_sym_local] = ACTIONS(13461),
    [anon_sym_LPAREN] = ACTIONS(13461),
    [anon_sym_COLON2] = ACTIONS(13461),
    [anon_sym_export] = ACTIONS(13461),
    [anon_sym_import] = ACTIONS(13461),
    [anon_sym_using] = ACTIONS(13461),
    [anon_sym_LBRACK] = ACTIONS(13461),
    [anon_sym_LF] = ACTIONS(13463),
    [anon_sym_in] = ACTIONS(13461),
    [anon_sym_LBRACE] = ACTIONS(13461),
    [anon_sym_DOLLAR] = ACTIONS(13461),
    [anon_sym_COLON_COLON] = ACTIONS(13461),
    [anon_sym_isa] = ACTIONS(13461),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13461),
    [anon_sym_QMARK] = ACTIONS(13461),
    [anon_sym_AT] = ACTIONS(13461),
    [anon_sym_true] = ACTIONS(13461),
    [anon_sym_false] = ACTIONS(13461),
    [aux_sym_integer_literal_token1] = ACTIONS(13461),
    [aux_sym_integer_literal_token2] = ACTIONS(13461),
    [aux_sym_integer_literal_token3] = ACTIONS(13461),
    [aux_sym_integer_literal_token4] = ACTIONS(13461),
    [aux_sym_float_literal_token1] = ACTIONS(13461),
    [aux_sym_float_literal_token3] = ACTIONS(13461),
    [aux_sym_float_literal_token4] = ACTIONS(13461),
    [sym_character_literal] = ACTIONS(13461),
    [sym__pair_operator] = ACTIONS(13461),
    [sym__arrow_operator] = ACTIONS(13461),
    [sym__lazy_or_operator] = ACTIONS(13461),
    [sym__lazy_and_operator] = ACTIONS(13461),
    [sym__comparison_operator] = ACTIONS(13461),
    [sym__pipe_right_operator] = ACTIONS(13461),
    [sym__pipe_left_operator] = ACTIONS(13461),
    [sym__ellipsis_operator] = ACTIONS(13461),
    [sym__plus_operator] = ACTIONS(13461),
    [sym__times_operator] = ACTIONS(13461),
    [sym__rational_operator] = ACTIONS(13461),
    [sym__bitshift_operator] = ACTIONS(13461),
    [sym__power_operator] = ACTIONS(13461),
    [sym__tilde_operator] = ACTIONS(13461),
    [sym__type_order_operator] = ACTIONS(13461),
    [sym__unary_operator] = ACTIONS(13461),
    [sym__unary_plus_operator] = ACTIONS(13461),
    [aux_sym__terminator_token1] = ACTIONS(13461),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13463),
    [sym__command_start] = ACTIONS(13463),
  },
  [8974] = {
    [sym__word_identifier] = ACTIONS(13481),
    [anon_sym_EQ] = ACTIONS(13481),
    [anon_sym_COMMA] = ACTIONS(13481),
    [anon_sym_COLON] = ACTIONS(13481),
    [anon_sym_begin] = ACTIONS(13481),
    [anon_sym_module] = ACTIONS(13481),
    [anon_sym_baremodule] = ACTIONS(13481),
    [anon_sym_end] = ACTIONS(13481),
    [anon_sym_abstract] = ACTIONS(13481),
    [anon_sym_primitive] = ACTIONS(13481),
    [anon_sym_mutable] = ACTIONS(13481),
    [anon_sym_struct] = ACTIONS(13481),
    [anon_sym_function] = ACTIONS(13481),
    [anon_sym_macro] = ACTIONS(13481),
    [anon_sym_where] = ACTIONS(13481),
    [anon_sym_quote] = ACTIONS(13481),
    [anon_sym_let] = ACTIONS(13481),
    [anon_sym_if] = ACTIONS(13481),
    [anon_sym_try] = ACTIONS(13481),
    [anon_sym_for] = ACTIONS(13481),
    [anon_sym_while] = ACTIONS(13481),
    [sym_break_statement] = ACTIONS(13481),
    [sym_continue_statement] = ACTIONS(13481),
    [anon_sym_return] = ACTIONS(13481),
    [anon_sym_const] = ACTIONS(13481),
    [anon_sym_global] = ACTIONS(13481),
    [anon_sym_local] = ACTIONS(13481),
    [anon_sym_LPAREN] = ACTIONS(13481),
    [anon_sym_COLON2] = ACTIONS(13481),
    [anon_sym_export] = ACTIONS(13481),
    [anon_sym_import] = ACTIONS(13481),
    [anon_sym_using] = ACTIONS(13481),
    [anon_sym_LBRACK] = ACTIONS(13481),
    [anon_sym_LF] = ACTIONS(13483),
    [anon_sym_in] = ACTIONS(13481),
    [anon_sym_LBRACE] = ACTIONS(13481),
    [anon_sym_DOLLAR] = ACTIONS(13481),
    [anon_sym_COLON_COLON] = ACTIONS(13481),
    [anon_sym_isa] = ACTIONS(13481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13481),
    [anon_sym_QMARK] = ACTIONS(13481),
    [anon_sym_AT] = ACTIONS(13481),
    [anon_sym_true] = ACTIONS(13481),
    [anon_sym_false] = ACTIONS(13481),
    [aux_sym_integer_literal_token1] = ACTIONS(13481),
    [aux_sym_integer_literal_token2] = ACTIONS(13481),
    [aux_sym_integer_literal_token3] = ACTIONS(13481),
    [aux_sym_integer_literal_token4] = ACTIONS(13481),
    [aux_sym_float_literal_token1] = ACTIONS(13481),
    [aux_sym_float_literal_token3] = ACTIONS(13481),
    [aux_sym_float_literal_token4] = ACTIONS(13481),
    [sym_character_literal] = ACTIONS(13481),
    [sym__pair_operator] = ACTIONS(13481),
    [sym__arrow_operator] = ACTIONS(13481),
    [sym__lazy_or_operator] = ACTIONS(13481),
    [sym__lazy_and_operator] = ACTIONS(13481),
    [sym__comparison_operator] = ACTIONS(13481),
    [sym__pipe_right_operator] = ACTIONS(13481),
    [sym__pipe_left_operator] = ACTIONS(13481),
    [sym__ellipsis_operator] = ACTIONS(13481),
    [sym__plus_operator] = ACTIONS(13481),
    [sym__times_operator] = ACTIONS(13481),
    [sym__rational_operator] = ACTIONS(13481),
    [sym__bitshift_operator] = ACTIONS(13481),
    [sym__power_operator] = ACTIONS(13481),
    [sym__tilde_operator] = ACTIONS(13481),
    [sym__type_order_operator] = ACTIONS(13481),
    [sym__unary_operator] = ACTIONS(13481),
    [sym__unary_plus_operator] = ACTIONS(13481),
    [aux_sym__terminator_token1] = ACTIONS(13481),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13483),
    [sym__command_start] = ACTIONS(13483),
  },
  [8975] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13253),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13253),
    [anon_sym_RPAREN] = ACTIONS(13253),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13253),
    [anon_sym_RBRACK] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13253),
    [anon_sym_RBRACE] = ACTIONS(13253),
    [anon_sym_DOLLAR] = ACTIONS(13253),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14828),
    [anon_sym_AT] = ACTIONS(13253),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13253),
    [aux_sym_integer_literal_token2] = ACTIONS(13253),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13253),
    [aux_sym_float_literal_token3] = ACTIONS(13253),
    [aux_sym_float_literal_token4] = ACTIONS(13253),
    [sym_character_literal] = ACTIONS(13253),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13253),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [8976] = {
    [sym__word_identifier] = ACTIONS(13485),
    [anon_sym_EQ] = ACTIONS(13485),
    [anon_sym_COMMA] = ACTIONS(13485),
    [anon_sym_COLON] = ACTIONS(13485),
    [anon_sym_begin] = ACTIONS(13485),
    [anon_sym_module] = ACTIONS(13485),
    [anon_sym_baremodule] = ACTIONS(13485),
    [anon_sym_end] = ACTIONS(13485),
    [anon_sym_abstract] = ACTIONS(13485),
    [anon_sym_primitive] = ACTIONS(13485),
    [anon_sym_mutable] = ACTIONS(13485),
    [anon_sym_struct] = ACTIONS(13485),
    [anon_sym_function] = ACTIONS(13485),
    [anon_sym_macro] = ACTIONS(13485),
    [anon_sym_where] = ACTIONS(13485),
    [anon_sym_quote] = ACTIONS(13485),
    [anon_sym_let] = ACTIONS(13485),
    [anon_sym_if] = ACTIONS(13485),
    [anon_sym_try] = ACTIONS(13485),
    [anon_sym_for] = ACTIONS(13485),
    [anon_sym_while] = ACTIONS(13485),
    [sym_break_statement] = ACTIONS(13485),
    [sym_continue_statement] = ACTIONS(13485),
    [anon_sym_return] = ACTIONS(13485),
    [anon_sym_const] = ACTIONS(13485),
    [anon_sym_global] = ACTIONS(13485),
    [anon_sym_local] = ACTIONS(13485),
    [anon_sym_LPAREN] = ACTIONS(13485),
    [anon_sym_COLON2] = ACTIONS(13485),
    [anon_sym_export] = ACTIONS(13485),
    [anon_sym_import] = ACTIONS(13485),
    [anon_sym_using] = ACTIONS(13485),
    [anon_sym_LBRACK] = ACTIONS(13485),
    [anon_sym_LF] = ACTIONS(13487),
    [anon_sym_in] = ACTIONS(13485),
    [anon_sym_LBRACE] = ACTIONS(13485),
    [anon_sym_DOLLAR] = ACTIONS(13485),
    [anon_sym_COLON_COLON] = ACTIONS(13485),
    [anon_sym_isa] = ACTIONS(13485),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13485),
    [anon_sym_QMARK] = ACTIONS(13485),
    [anon_sym_AT] = ACTIONS(13485),
    [anon_sym_true] = ACTIONS(13485),
    [anon_sym_false] = ACTIONS(13485),
    [aux_sym_integer_literal_token1] = ACTIONS(13485),
    [aux_sym_integer_literal_token2] = ACTIONS(13485),
    [aux_sym_integer_literal_token3] = ACTIONS(13485),
    [aux_sym_integer_literal_token4] = ACTIONS(13485),
    [aux_sym_float_literal_token1] = ACTIONS(13485),
    [aux_sym_float_literal_token3] = ACTIONS(13485),
    [aux_sym_float_literal_token4] = ACTIONS(13485),
    [sym_character_literal] = ACTIONS(13485),
    [sym__pair_operator] = ACTIONS(13485),
    [sym__arrow_operator] = ACTIONS(13485),
    [sym__lazy_or_operator] = ACTIONS(13485),
    [sym__lazy_and_operator] = ACTIONS(13485),
    [sym__comparison_operator] = ACTIONS(13485),
    [sym__pipe_right_operator] = ACTIONS(13485),
    [sym__pipe_left_operator] = ACTIONS(13485),
    [sym__ellipsis_operator] = ACTIONS(13485),
    [sym__plus_operator] = ACTIONS(13485),
    [sym__times_operator] = ACTIONS(13485),
    [sym__rational_operator] = ACTIONS(13485),
    [sym__bitshift_operator] = ACTIONS(13485),
    [sym__power_operator] = ACTIONS(13485),
    [sym__tilde_operator] = ACTIONS(13485),
    [sym__type_order_operator] = ACTIONS(13485),
    [sym__unary_operator] = ACTIONS(13485),
    [sym__unary_plus_operator] = ACTIONS(13485),
    [aux_sym__terminator_token1] = ACTIONS(13485),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13487),
    [sym__command_start] = ACTIONS(13487),
  },
  [8977] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8978] = {
    [sym__word_identifier] = ACTIONS(13346),
    [anon_sym_EQ] = ACTIONS(13346),
    [anon_sym_COMMA] = ACTIONS(13346),
    [anon_sym_COLON] = ACTIONS(13346),
    [anon_sym_begin] = ACTIONS(13346),
    [anon_sym_module] = ACTIONS(13346),
    [anon_sym_baremodule] = ACTIONS(13346),
    [anon_sym_end] = ACTIONS(13346),
    [anon_sym_abstract] = ACTIONS(13346),
    [anon_sym_primitive] = ACTIONS(13346),
    [anon_sym_mutable] = ACTIONS(13346),
    [anon_sym_struct] = ACTIONS(13346),
    [anon_sym_function] = ACTIONS(13346),
    [anon_sym_macro] = ACTIONS(13346),
    [anon_sym_where] = ACTIONS(13346),
    [anon_sym_quote] = ACTIONS(13346),
    [anon_sym_let] = ACTIONS(13346),
    [anon_sym_if] = ACTIONS(13346),
    [anon_sym_try] = ACTIONS(13346),
    [anon_sym_for] = ACTIONS(13346),
    [anon_sym_while] = ACTIONS(13346),
    [sym_break_statement] = ACTIONS(13346),
    [sym_continue_statement] = ACTIONS(13346),
    [anon_sym_return] = ACTIONS(13346),
    [anon_sym_const] = ACTIONS(13346),
    [anon_sym_global] = ACTIONS(13346),
    [anon_sym_local] = ACTIONS(13346),
    [anon_sym_LPAREN] = ACTIONS(13346),
    [anon_sym_COLON2] = ACTIONS(13346),
    [anon_sym_export] = ACTIONS(13346),
    [anon_sym_import] = ACTIONS(13346),
    [anon_sym_using] = ACTIONS(13346),
    [anon_sym_LBRACK] = ACTIONS(13346),
    [anon_sym_LF] = ACTIONS(13348),
    [anon_sym_in] = ACTIONS(13346),
    [anon_sym_LBRACE] = ACTIONS(13346),
    [anon_sym_DOLLAR] = ACTIONS(13346),
    [anon_sym_COLON_COLON] = ACTIONS(13346),
    [anon_sym_isa] = ACTIONS(13346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13346),
    [anon_sym_QMARK] = ACTIONS(13346),
    [anon_sym_AT] = ACTIONS(13346),
    [anon_sym_true] = ACTIONS(13346),
    [anon_sym_false] = ACTIONS(13346),
    [aux_sym_integer_literal_token1] = ACTIONS(13346),
    [aux_sym_integer_literal_token2] = ACTIONS(13346),
    [aux_sym_integer_literal_token3] = ACTIONS(13346),
    [aux_sym_integer_literal_token4] = ACTIONS(13346),
    [aux_sym_float_literal_token1] = ACTIONS(13346),
    [aux_sym_float_literal_token3] = ACTIONS(13346),
    [aux_sym_float_literal_token4] = ACTIONS(13346),
    [sym_character_literal] = ACTIONS(13346),
    [sym__pair_operator] = ACTIONS(13346),
    [sym__arrow_operator] = ACTIONS(13346),
    [sym__lazy_or_operator] = ACTIONS(13346),
    [sym__lazy_and_operator] = ACTIONS(13346),
    [sym__comparison_operator] = ACTIONS(13346),
    [sym__pipe_right_operator] = ACTIONS(13346),
    [sym__pipe_left_operator] = ACTIONS(13346),
    [sym__ellipsis_operator] = ACTIONS(13346),
    [sym__plus_operator] = ACTIONS(13346),
    [sym__times_operator] = ACTIONS(13346),
    [sym__rational_operator] = ACTIONS(13346),
    [sym__bitshift_operator] = ACTIONS(13346),
    [sym__power_operator] = ACTIONS(13346),
    [sym__tilde_operator] = ACTIONS(13346),
    [sym__type_order_operator] = ACTIONS(13346),
    [sym__unary_operator] = ACTIONS(13346),
    [sym__unary_plus_operator] = ACTIONS(13346),
    [aux_sym__terminator_token1] = ACTIONS(13346),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13348),
    [sym__command_start] = ACTIONS(13348),
  },
  [8979] = {
    [sym__word_identifier] = ACTIONS(12974),
    [anon_sym_EQ] = ACTIONS(12974),
    [anon_sym_COMMA] = ACTIONS(12974),
    [anon_sym_COLON] = ACTIONS(12974),
    [anon_sym_begin] = ACTIONS(12974),
    [anon_sym_module] = ACTIONS(12974),
    [anon_sym_baremodule] = ACTIONS(12974),
    [anon_sym_end] = ACTIONS(12974),
    [anon_sym_abstract] = ACTIONS(12974),
    [anon_sym_primitive] = ACTIONS(12974),
    [anon_sym_mutable] = ACTIONS(12974),
    [anon_sym_struct] = ACTIONS(12974),
    [anon_sym_function] = ACTIONS(12974),
    [anon_sym_macro] = ACTIONS(12974),
    [anon_sym_where] = ACTIONS(12974),
    [anon_sym_quote] = ACTIONS(12974),
    [anon_sym_let] = ACTIONS(12974),
    [anon_sym_if] = ACTIONS(12974),
    [anon_sym_try] = ACTIONS(12974),
    [anon_sym_for] = ACTIONS(12974),
    [anon_sym_while] = ACTIONS(12974),
    [sym_break_statement] = ACTIONS(12974),
    [sym_continue_statement] = ACTIONS(12974),
    [anon_sym_return] = ACTIONS(12974),
    [anon_sym_const] = ACTIONS(12974),
    [anon_sym_global] = ACTIONS(12974),
    [anon_sym_local] = ACTIONS(12974),
    [anon_sym_LPAREN] = ACTIONS(12974),
    [anon_sym_COLON2] = ACTIONS(12974),
    [anon_sym_export] = ACTIONS(12974),
    [anon_sym_import] = ACTIONS(12974),
    [anon_sym_using] = ACTIONS(12974),
    [anon_sym_LBRACK] = ACTIONS(12974),
    [anon_sym_LF] = ACTIONS(12972),
    [anon_sym_in] = ACTIONS(12974),
    [anon_sym_LBRACE] = ACTIONS(12974),
    [anon_sym_DOLLAR] = ACTIONS(12974),
    [anon_sym_COLON_COLON] = ACTIONS(12974),
    [anon_sym_isa] = ACTIONS(12974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12974),
    [anon_sym_QMARK] = ACTIONS(12974),
    [anon_sym_AT] = ACTIONS(12974),
    [anon_sym_true] = ACTIONS(12974),
    [anon_sym_false] = ACTIONS(12974),
    [aux_sym_integer_literal_token1] = ACTIONS(12974),
    [aux_sym_integer_literal_token2] = ACTIONS(12974),
    [aux_sym_integer_literal_token3] = ACTIONS(12974),
    [aux_sym_integer_literal_token4] = ACTIONS(12974),
    [aux_sym_float_literal_token1] = ACTIONS(12974),
    [aux_sym_float_literal_token3] = ACTIONS(12974),
    [aux_sym_float_literal_token4] = ACTIONS(12974),
    [sym_character_literal] = ACTIONS(12974),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(12974),
    [sym__lazy_or_operator] = ACTIONS(12974),
    [sym__lazy_and_operator] = ACTIONS(12974),
    [sym__comparison_operator] = ACTIONS(12974),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(12974),
    [sym__plus_operator] = ACTIONS(12974),
    [sym__times_operator] = ACTIONS(12974),
    [sym__rational_operator] = ACTIONS(12974),
    [sym__bitshift_operator] = ACTIONS(12974),
    [sym__power_operator] = ACTIONS(12974),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(12974),
    [sym__unary_plus_operator] = ACTIONS(12974),
    [aux_sym__terminator_token1] = ACTIONS(12974),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12972),
    [sym__command_start] = ACTIONS(12972),
  },
  [8980] = {
    [sym__word_identifier] = ACTIONS(12981),
    [anon_sym_EQ] = ACTIONS(12981),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_COLON] = ACTIONS(12981),
    [anon_sym_begin] = ACTIONS(12981),
    [anon_sym_module] = ACTIONS(12981),
    [anon_sym_baremodule] = ACTIONS(12981),
    [anon_sym_end] = ACTIONS(12981),
    [anon_sym_abstract] = ACTIONS(12981),
    [anon_sym_primitive] = ACTIONS(12981),
    [anon_sym_mutable] = ACTIONS(12981),
    [anon_sym_struct] = ACTIONS(12981),
    [anon_sym_function] = ACTIONS(12981),
    [anon_sym_macro] = ACTIONS(12981),
    [anon_sym_where] = ACTIONS(12981),
    [anon_sym_quote] = ACTIONS(12981),
    [anon_sym_let] = ACTIONS(12981),
    [anon_sym_if] = ACTIONS(12981),
    [anon_sym_try] = ACTIONS(12981),
    [anon_sym_for] = ACTIONS(12981),
    [anon_sym_while] = ACTIONS(12981),
    [sym_break_statement] = ACTIONS(12981),
    [sym_continue_statement] = ACTIONS(12981),
    [anon_sym_return] = ACTIONS(12981),
    [anon_sym_const] = ACTIONS(12981),
    [anon_sym_global] = ACTIONS(12981),
    [anon_sym_local] = ACTIONS(12981),
    [anon_sym_LPAREN] = ACTIONS(12981),
    [anon_sym_COLON2] = ACTIONS(12981),
    [anon_sym_export] = ACTIONS(12981),
    [anon_sym_import] = ACTIONS(12981),
    [anon_sym_using] = ACTIONS(12981),
    [anon_sym_LBRACK] = ACTIONS(12981),
    [anon_sym_LF] = ACTIONS(12979),
    [anon_sym_in] = ACTIONS(12981),
    [anon_sym_LBRACE] = ACTIONS(12981),
    [anon_sym_DOLLAR] = ACTIONS(12981),
    [anon_sym_COLON_COLON] = ACTIONS(12981),
    [anon_sym_isa] = ACTIONS(12981),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12981),
    [anon_sym_QMARK] = ACTIONS(12981),
    [anon_sym_AT] = ACTIONS(12981),
    [anon_sym_true] = ACTIONS(12981),
    [anon_sym_false] = ACTIONS(12981),
    [aux_sym_integer_literal_token1] = ACTIONS(12981),
    [aux_sym_integer_literal_token2] = ACTIONS(12981),
    [aux_sym_integer_literal_token3] = ACTIONS(12981),
    [aux_sym_integer_literal_token4] = ACTIONS(12981),
    [aux_sym_float_literal_token1] = ACTIONS(12981),
    [aux_sym_float_literal_token3] = ACTIONS(12981),
    [aux_sym_float_literal_token4] = ACTIONS(12981),
    [sym_character_literal] = ACTIONS(12981),
    [sym__pair_operator] = ACTIONS(12981),
    [sym__arrow_operator] = ACTIONS(12981),
    [sym__lazy_or_operator] = ACTIONS(12981),
    [sym__lazy_and_operator] = ACTIONS(12981),
    [sym__comparison_operator] = ACTIONS(12981),
    [sym__pipe_right_operator] = ACTIONS(12981),
    [sym__pipe_left_operator] = ACTIONS(12981),
    [sym__ellipsis_operator] = ACTIONS(12981),
    [sym__plus_operator] = ACTIONS(12981),
    [sym__times_operator] = ACTIONS(12981),
    [sym__rational_operator] = ACTIONS(12981),
    [sym__bitshift_operator] = ACTIONS(12981),
    [sym__power_operator] = ACTIONS(12981),
    [sym__tilde_operator] = ACTIONS(12981),
    [sym__type_order_operator] = ACTIONS(12981),
    [sym__unary_operator] = ACTIONS(12981),
    [sym__unary_plus_operator] = ACTIONS(12981),
    [aux_sym__terminator_token1] = ACTIONS(12981),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12979),
    [sym__command_start] = ACTIONS(12979),
  },
  [8981] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12732),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [8982] = {
    [aux_sym_open_tuple_repeat1] = STATE(8127),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(14541),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13199),
    [anon_sym_RPAREN] = ACTIONS(13199),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13199),
    [anon_sym_RBRACK] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13199),
    [anon_sym_RBRACE] = ACTIONS(13199),
    [anon_sym_DOLLAR] = ACTIONS(13199),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14828),
    [anon_sym_AT] = ACTIONS(13199),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13199),
    [aux_sym_integer_literal_token2] = ACTIONS(13199),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13199),
    [aux_sym_float_literal_token3] = ACTIONS(13199),
    [aux_sym_float_literal_token4] = ACTIONS(13199),
    [sym_character_literal] = ACTIONS(13199),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13199),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [8983] = {
    [sym__word_identifier] = ACTIONS(13358),
    [anon_sym_EQ] = ACTIONS(13358),
    [anon_sym_COMMA] = ACTIONS(13358),
    [anon_sym_COLON] = ACTIONS(13358),
    [anon_sym_begin] = ACTIONS(13358),
    [anon_sym_module] = ACTIONS(13358),
    [anon_sym_baremodule] = ACTIONS(13358),
    [anon_sym_end] = ACTIONS(13358),
    [anon_sym_abstract] = ACTIONS(13358),
    [anon_sym_primitive] = ACTIONS(13358),
    [anon_sym_mutable] = ACTIONS(13358),
    [anon_sym_struct] = ACTIONS(13358),
    [anon_sym_function] = ACTIONS(13358),
    [anon_sym_macro] = ACTIONS(13358),
    [anon_sym_where] = ACTIONS(13358),
    [anon_sym_quote] = ACTIONS(13358),
    [anon_sym_let] = ACTIONS(13358),
    [anon_sym_if] = ACTIONS(13358),
    [anon_sym_try] = ACTIONS(13358),
    [anon_sym_for] = ACTIONS(13358),
    [anon_sym_while] = ACTIONS(13358),
    [sym_break_statement] = ACTIONS(13358),
    [sym_continue_statement] = ACTIONS(13358),
    [anon_sym_return] = ACTIONS(13358),
    [anon_sym_const] = ACTIONS(13358),
    [anon_sym_global] = ACTIONS(13358),
    [anon_sym_local] = ACTIONS(13358),
    [anon_sym_LPAREN] = ACTIONS(13358),
    [anon_sym_COLON2] = ACTIONS(13358),
    [anon_sym_export] = ACTIONS(13358),
    [anon_sym_import] = ACTIONS(13358),
    [anon_sym_using] = ACTIONS(13358),
    [anon_sym_LBRACK] = ACTIONS(13358),
    [anon_sym_LF] = ACTIONS(13360),
    [anon_sym_in] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(13358),
    [anon_sym_DOLLAR] = ACTIONS(13358),
    [anon_sym_COLON_COLON] = ACTIONS(13358),
    [anon_sym_isa] = ACTIONS(13358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13358),
    [anon_sym_QMARK] = ACTIONS(13358),
    [anon_sym_AT] = ACTIONS(13358),
    [anon_sym_true] = ACTIONS(13358),
    [anon_sym_false] = ACTIONS(13358),
    [aux_sym_integer_literal_token1] = ACTIONS(13358),
    [aux_sym_integer_literal_token2] = ACTIONS(13358),
    [aux_sym_integer_literal_token3] = ACTIONS(13358),
    [aux_sym_integer_literal_token4] = ACTIONS(13358),
    [aux_sym_float_literal_token1] = ACTIONS(13358),
    [aux_sym_float_literal_token3] = ACTIONS(13358),
    [aux_sym_float_literal_token4] = ACTIONS(13358),
    [sym_character_literal] = ACTIONS(13358),
    [sym__pair_operator] = ACTIONS(13358),
    [sym__arrow_operator] = ACTIONS(13358),
    [sym__lazy_or_operator] = ACTIONS(13358),
    [sym__lazy_and_operator] = ACTIONS(13358),
    [sym__comparison_operator] = ACTIONS(13358),
    [sym__pipe_right_operator] = ACTIONS(13358),
    [sym__pipe_left_operator] = ACTIONS(13358),
    [sym__ellipsis_operator] = ACTIONS(13358),
    [sym__plus_operator] = ACTIONS(13358),
    [sym__times_operator] = ACTIONS(13358),
    [sym__rational_operator] = ACTIONS(13358),
    [sym__bitshift_operator] = ACTIONS(13358),
    [sym__power_operator] = ACTIONS(13358),
    [sym__tilde_operator] = ACTIONS(13358),
    [sym__type_order_operator] = ACTIONS(13358),
    [sym__unary_operator] = ACTIONS(13358),
    [sym__unary_plus_operator] = ACTIONS(13358),
    [aux_sym__terminator_token1] = ACTIONS(13358),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13360),
    [sym__command_start] = ACTIONS(13360),
  },
  [8984] = {
    [sym__word_identifier] = ACTIONS(13489),
    [anon_sym_EQ] = ACTIONS(13489),
    [anon_sym_COMMA] = ACTIONS(13489),
    [anon_sym_COLON] = ACTIONS(13489),
    [anon_sym_begin] = ACTIONS(13489),
    [anon_sym_module] = ACTIONS(13489),
    [anon_sym_baremodule] = ACTIONS(13489),
    [anon_sym_end] = ACTIONS(13489),
    [anon_sym_abstract] = ACTIONS(13489),
    [anon_sym_primitive] = ACTIONS(13489),
    [anon_sym_mutable] = ACTIONS(13489),
    [anon_sym_struct] = ACTIONS(13489),
    [anon_sym_function] = ACTIONS(13489),
    [anon_sym_macro] = ACTIONS(13489),
    [anon_sym_where] = ACTIONS(13489),
    [anon_sym_quote] = ACTIONS(13489),
    [anon_sym_let] = ACTIONS(13489),
    [anon_sym_if] = ACTIONS(13489),
    [anon_sym_try] = ACTIONS(13489),
    [anon_sym_for] = ACTIONS(13489),
    [anon_sym_while] = ACTIONS(13489),
    [sym_break_statement] = ACTIONS(13489),
    [sym_continue_statement] = ACTIONS(13489),
    [anon_sym_return] = ACTIONS(13489),
    [anon_sym_const] = ACTIONS(13489),
    [anon_sym_global] = ACTIONS(13489),
    [anon_sym_local] = ACTIONS(13489),
    [anon_sym_LPAREN] = ACTIONS(13489),
    [anon_sym_COLON2] = ACTIONS(13489),
    [anon_sym_export] = ACTIONS(13489),
    [anon_sym_import] = ACTIONS(13489),
    [anon_sym_using] = ACTIONS(13489),
    [anon_sym_LBRACK] = ACTIONS(13489),
    [anon_sym_LF] = ACTIONS(13491),
    [anon_sym_in] = ACTIONS(13489),
    [anon_sym_LBRACE] = ACTIONS(13489),
    [anon_sym_DOLLAR] = ACTIONS(13489),
    [anon_sym_COLON_COLON] = ACTIONS(13489),
    [anon_sym_isa] = ACTIONS(13489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13489),
    [anon_sym_QMARK] = ACTIONS(13489),
    [anon_sym_AT] = ACTIONS(13489),
    [anon_sym_true] = ACTIONS(13489),
    [anon_sym_false] = ACTIONS(13489),
    [aux_sym_integer_literal_token1] = ACTIONS(13489),
    [aux_sym_integer_literal_token2] = ACTIONS(13489),
    [aux_sym_integer_literal_token3] = ACTIONS(13489),
    [aux_sym_integer_literal_token4] = ACTIONS(13489),
    [aux_sym_float_literal_token1] = ACTIONS(13489),
    [aux_sym_float_literal_token3] = ACTIONS(13489),
    [aux_sym_float_literal_token4] = ACTIONS(13489),
    [sym_character_literal] = ACTIONS(13489),
    [sym__pair_operator] = ACTIONS(13489),
    [sym__arrow_operator] = ACTIONS(13489),
    [sym__lazy_or_operator] = ACTIONS(13489),
    [sym__lazy_and_operator] = ACTIONS(13489),
    [sym__comparison_operator] = ACTIONS(13489),
    [sym__pipe_right_operator] = ACTIONS(13489),
    [sym__pipe_left_operator] = ACTIONS(13489),
    [sym__ellipsis_operator] = ACTIONS(13489),
    [sym__plus_operator] = ACTIONS(13489),
    [sym__times_operator] = ACTIONS(13489),
    [sym__rational_operator] = ACTIONS(13489),
    [sym__bitshift_operator] = ACTIONS(13489),
    [sym__power_operator] = ACTIONS(13489),
    [sym__tilde_operator] = ACTIONS(13489),
    [sym__type_order_operator] = ACTIONS(13489),
    [sym__unary_operator] = ACTIONS(13489),
    [sym__unary_plus_operator] = ACTIONS(13489),
    [aux_sym__terminator_token1] = ACTIONS(13489),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13491),
    [sym__command_start] = ACTIONS(13491),
  },
  [8985] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8986] = {
    [aux_sym_open_tuple_repeat1] = STATE(8986),
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(14874),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(13070),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13075),
    [anon_sym_RPAREN] = ACTIONS(13075),
    [anon_sym_COLON2] = ACTIONS(13070),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(13070),
    [anon_sym_SEMI] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(13075),
    [anon_sym_DOLLAR] = ACTIONS(13075),
    [anon_sym_COLON_COLON] = ACTIONS(13075),
    [anon_sym_isa] = ACTIONS(13070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13075),
    [anon_sym_QMARK] = ACTIONS(13075),
    [anon_sym_AT] = ACTIONS(13075),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13075),
    [aux_sym_integer_literal_token2] = ACTIONS(13075),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13075),
    [aux_sym_float_literal_token3] = ACTIONS(13075),
    [aux_sym_float_literal_token4] = ACTIONS(13075),
    [sym_character_literal] = ACTIONS(13075),
    [sym__pair_operator] = ACTIONS(13075),
    [sym__arrow_operator] = ACTIONS(13070),
    [sym__lazy_or_operator] = ACTIONS(13075),
    [sym__lazy_and_operator] = ACTIONS(13075),
    [sym__comparison_operator] = ACTIONS(13070),
    [sym__pipe_right_operator] = ACTIONS(13075),
    [sym__pipe_left_operator] = ACTIONS(13075),
    [sym__ellipsis_operator] = ACTIONS(13070),
    [sym__plus_operator] = ACTIONS(13070),
    [sym__times_operator] = ACTIONS(13070),
    [sym__rational_operator] = ACTIONS(13075),
    [sym__bitshift_operator] = ACTIONS(13075),
    [sym__power_operator] = ACTIONS(13075),
    [sym__tilde_operator] = ACTIONS(13075),
    [sym__type_order_operator] = ACTIONS(13075),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(13070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [8987] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8988] = {
    [sym__word_identifier] = ACTIONS(13493),
    [anon_sym_EQ] = ACTIONS(13493),
    [anon_sym_COMMA] = ACTIONS(13493),
    [anon_sym_COLON] = ACTIONS(13493),
    [anon_sym_begin] = ACTIONS(13493),
    [anon_sym_module] = ACTIONS(13493),
    [anon_sym_baremodule] = ACTIONS(13493),
    [anon_sym_end] = ACTIONS(13493),
    [anon_sym_abstract] = ACTIONS(13493),
    [anon_sym_primitive] = ACTIONS(13493),
    [anon_sym_mutable] = ACTIONS(13493),
    [anon_sym_struct] = ACTIONS(13493),
    [anon_sym_function] = ACTIONS(13493),
    [anon_sym_macro] = ACTIONS(13493),
    [anon_sym_where] = ACTIONS(13493),
    [anon_sym_quote] = ACTIONS(13493),
    [anon_sym_let] = ACTIONS(13493),
    [anon_sym_if] = ACTIONS(13493),
    [anon_sym_try] = ACTIONS(13493),
    [anon_sym_for] = ACTIONS(13493),
    [anon_sym_while] = ACTIONS(13493),
    [sym_break_statement] = ACTIONS(13493),
    [sym_continue_statement] = ACTIONS(13493),
    [anon_sym_return] = ACTIONS(13493),
    [anon_sym_const] = ACTIONS(13493),
    [anon_sym_global] = ACTIONS(13493),
    [anon_sym_local] = ACTIONS(13493),
    [anon_sym_LPAREN] = ACTIONS(13493),
    [anon_sym_COLON2] = ACTIONS(13493),
    [anon_sym_export] = ACTIONS(13493),
    [anon_sym_import] = ACTIONS(13493),
    [anon_sym_using] = ACTIONS(13493),
    [anon_sym_LBRACK] = ACTIONS(13493),
    [anon_sym_LF] = ACTIONS(13495),
    [anon_sym_in] = ACTIONS(13493),
    [anon_sym_LBRACE] = ACTIONS(13493),
    [anon_sym_DOLLAR] = ACTIONS(13493),
    [anon_sym_COLON_COLON] = ACTIONS(13493),
    [anon_sym_isa] = ACTIONS(13493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13493),
    [anon_sym_QMARK] = ACTIONS(13493),
    [anon_sym_AT] = ACTIONS(13493),
    [anon_sym_true] = ACTIONS(13493),
    [anon_sym_false] = ACTIONS(13493),
    [aux_sym_integer_literal_token1] = ACTIONS(13493),
    [aux_sym_integer_literal_token2] = ACTIONS(13493),
    [aux_sym_integer_literal_token3] = ACTIONS(13493),
    [aux_sym_integer_literal_token4] = ACTIONS(13493),
    [aux_sym_float_literal_token1] = ACTIONS(13493),
    [aux_sym_float_literal_token3] = ACTIONS(13493),
    [aux_sym_float_literal_token4] = ACTIONS(13493),
    [sym_character_literal] = ACTIONS(13493),
    [sym__pair_operator] = ACTIONS(13493),
    [sym__arrow_operator] = ACTIONS(13493),
    [sym__lazy_or_operator] = ACTIONS(13493),
    [sym__lazy_and_operator] = ACTIONS(13493),
    [sym__comparison_operator] = ACTIONS(13493),
    [sym__pipe_right_operator] = ACTIONS(13493),
    [sym__pipe_left_operator] = ACTIONS(13493),
    [sym__ellipsis_operator] = ACTIONS(13493),
    [sym__plus_operator] = ACTIONS(13493),
    [sym__times_operator] = ACTIONS(13493),
    [sym__rational_operator] = ACTIONS(13493),
    [sym__bitshift_operator] = ACTIONS(13493),
    [sym__power_operator] = ACTIONS(13493),
    [sym__tilde_operator] = ACTIONS(13493),
    [sym__type_order_operator] = ACTIONS(13493),
    [sym__unary_operator] = ACTIONS(13493),
    [sym__unary_plus_operator] = ACTIONS(13493),
    [aux_sym__terminator_token1] = ACTIONS(13493),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13495),
    [sym__command_start] = ACTIONS(13495),
  },
  [8989] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_RPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_SEMI] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [8990] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8991] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8992] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14780),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14782),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14784),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14784),
    [sym__pipe_right_operator] = ACTIONS(14792),
    [sym__pipe_left_operator] = ACTIONS(14794),
    [sym__ellipsis_operator] = ACTIONS(14796),
    [sym__plus_operator] = ACTIONS(14798),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14784),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14798),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8993] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(14870),
    [anon_sym_COMMA] = ACTIONS(13241),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13241),
    [anon_sym_RPAREN] = ACTIONS(13241),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13241),
    [anon_sym_RBRACK] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13241),
    [anon_sym_RBRACE] = ACTIONS(13241),
    [anon_sym_DOLLAR] = ACTIONS(13241),
    [anon_sym_COLON_COLON] = ACTIONS(13241),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13241),
    [anon_sym_QMARK] = ACTIONS(13241),
    [anon_sym_AT] = ACTIONS(13241),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13241),
    [aux_sym_integer_literal_token2] = ACTIONS(13241),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13241),
    [aux_sym_float_literal_token3] = ACTIONS(13241),
    [aux_sym_float_literal_token4] = ACTIONS(13241),
    [sym_character_literal] = ACTIONS(13241),
    [sym__pair_operator] = ACTIONS(13241),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13241),
    [sym__lazy_and_operator] = ACTIONS(13241),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13241),
    [sym__pipe_left_operator] = ACTIONS(13241),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13241),
    [sym__bitshift_operator] = ACTIONS(13241),
    [sym__power_operator] = ACTIONS(13241),
    [sym__tilde_operator] = ACTIONS(13241),
    [sym__type_order_operator] = ACTIONS(13241),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [8994] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(14870),
    [anon_sym_COMMA] = ACTIONS(13245),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13245),
    [anon_sym_RPAREN] = ACTIONS(13245),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13245),
    [anon_sym_RBRACK] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13245),
    [anon_sym_RBRACE] = ACTIONS(13245),
    [anon_sym_DOLLAR] = ACTIONS(13245),
    [anon_sym_COLON_COLON] = ACTIONS(13245),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13245),
    [anon_sym_QMARK] = ACTIONS(13245),
    [anon_sym_AT] = ACTIONS(13245),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13245),
    [aux_sym_integer_literal_token2] = ACTIONS(13245),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13245),
    [aux_sym_float_literal_token3] = ACTIONS(13245),
    [aux_sym_float_literal_token4] = ACTIONS(13245),
    [sym_character_literal] = ACTIONS(13245),
    [sym__pair_operator] = ACTIONS(13245),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13245),
    [sym__lazy_and_operator] = ACTIONS(13245),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13245),
    [sym__pipe_left_operator] = ACTIONS(13245),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13245),
    [sym__bitshift_operator] = ACTIONS(13245),
    [sym__power_operator] = ACTIONS(13245),
    [sym__tilde_operator] = ACTIONS(13245),
    [sym__type_order_operator] = ACTIONS(13245),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [8995] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(14870),
    [anon_sym_COMMA] = ACTIONS(12934),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12934),
    [anon_sym_RPAREN] = ACTIONS(12934),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12934),
    [anon_sym_RBRACK] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12934),
    [anon_sym_RBRACE] = ACTIONS(12934),
    [anon_sym_DOLLAR] = ACTIONS(12934),
    [anon_sym_COLON_COLON] = ACTIONS(12934),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12934),
    [anon_sym_QMARK] = ACTIONS(12934),
    [anon_sym_AT] = ACTIONS(12934),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12934),
    [aux_sym_integer_literal_token2] = ACTIONS(12934),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12934),
    [aux_sym_float_literal_token3] = ACTIONS(12934),
    [aux_sym_float_literal_token4] = ACTIONS(12934),
    [sym_character_literal] = ACTIONS(12934),
    [sym__pair_operator] = ACTIONS(12934),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12934),
    [sym__lazy_and_operator] = ACTIONS(12934),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12934),
    [sym__pipe_left_operator] = ACTIONS(12934),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12934),
    [sym__bitshift_operator] = ACTIONS(12934),
    [sym__power_operator] = ACTIONS(12934),
    [sym__tilde_operator] = ACTIONS(12934),
    [sym__type_order_operator] = ACTIONS(12934),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [8996] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14782),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14796),
    [sym__plus_operator] = ACTIONS(14798),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14798),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8997] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13806),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_RBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [8998] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14782),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14792),
    [sym__pipe_left_operator] = ACTIONS(14794),
    [sym__ellipsis_operator] = ACTIONS(14796),
    [sym__plus_operator] = ACTIONS(14798),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14798),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [8999] = {
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13070),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13070),
    [anon_sym_RPAREN] = ACTIONS(13070),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13070),
    [anon_sym_LF] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13070),
    [anon_sym_LBRACE] = ACTIONS(13070),
    [anon_sym_DOLLAR] = ACTIONS(13070),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14754),
    [anon_sym_AT] = ACTIONS(13070),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13070),
    [aux_sym_integer_literal_token2] = ACTIONS(13070),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13070),
    [aux_sym_float_literal_token3] = ACTIONS(13070),
    [aux_sym_float_literal_token4] = ACTIONS(13070),
    [sym_character_literal] = ACTIONS(13070),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13070),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [9000] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14798),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14798),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9001] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13100),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13100),
    [anon_sym_RPAREN] = ACTIONS(13100),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13100),
    [anon_sym_RBRACK] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13100),
    [anon_sym_RBRACE] = ACTIONS(13100),
    [anon_sym_DOLLAR] = ACTIONS(13100),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14828),
    [anon_sym_AT] = ACTIONS(13100),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13100),
    [aux_sym_integer_literal_token2] = ACTIONS(13100),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13100),
    [aux_sym_float_literal_token3] = ACTIONS(13100),
    [aux_sym_float_literal_token4] = ACTIONS(13100),
    [sym_character_literal] = ACTIONS(13100),
    [sym__pair_operator] = ACTIONS(13100),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13100),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [9002] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9003] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13806),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_RBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [9004] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13806),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [9005] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9006] = {
    [sym__word_identifier] = ACTIONS(13499),
    [anon_sym_EQ] = ACTIONS(13499),
    [anon_sym_COMMA] = ACTIONS(13499),
    [anon_sym_COLON] = ACTIONS(13499),
    [anon_sym_begin] = ACTIONS(13499),
    [anon_sym_module] = ACTIONS(13499),
    [anon_sym_baremodule] = ACTIONS(13499),
    [anon_sym_end] = ACTIONS(13499),
    [anon_sym_abstract] = ACTIONS(13499),
    [anon_sym_primitive] = ACTIONS(13499),
    [anon_sym_mutable] = ACTIONS(13499),
    [anon_sym_struct] = ACTIONS(13499),
    [anon_sym_function] = ACTIONS(13499),
    [anon_sym_macro] = ACTIONS(13499),
    [anon_sym_where] = ACTIONS(13499),
    [anon_sym_quote] = ACTIONS(13499),
    [anon_sym_let] = ACTIONS(13499),
    [anon_sym_if] = ACTIONS(13499),
    [anon_sym_try] = ACTIONS(13499),
    [anon_sym_for] = ACTIONS(13499),
    [anon_sym_while] = ACTIONS(13499),
    [sym_break_statement] = ACTIONS(13499),
    [sym_continue_statement] = ACTIONS(13499),
    [anon_sym_return] = ACTIONS(13499),
    [anon_sym_const] = ACTIONS(13499),
    [anon_sym_global] = ACTIONS(13499),
    [anon_sym_local] = ACTIONS(13499),
    [anon_sym_LPAREN] = ACTIONS(13499),
    [anon_sym_COLON2] = ACTIONS(13499),
    [anon_sym_export] = ACTIONS(13499),
    [anon_sym_import] = ACTIONS(13499),
    [anon_sym_using] = ACTIONS(13499),
    [anon_sym_LBRACK] = ACTIONS(13499),
    [anon_sym_LF] = ACTIONS(13501),
    [anon_sym_in] = ACTIONS(13499),
    [anon_sym_LBRACE] = ACTIONS(13499),
    [anon_sym_DOLLAR] = ACTIONS(13499),
    [anon_sym_COLON_COLON] = ACTIONS(13499),
    [anon_sym_isa] = ACTIONS(13499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13499),
    [anon_sym_QMARK] = ACTIONS(13499),
    [anon_sym_AT] = ACTIONS(13499),
    [anon_sym_true] = ACTIONS(13499),
    [anon_sym_false] = ACTIONS(13499),
    [aux_sym_integer_literal_token1] = ACTIONS(13499),
    [aux_sym_integer_literal_token2] = ACTIONS(13499),
    [aux_sym_integer_literal_token3] = ACTIONS(13499),
    [aux_sym_integer_literal_token4] = ACTIONS(13499),
    [aux_sym_float_literal_token1] = ACTIONS(13499),
    [aux_sym_float_literal_token3] = ACTIONS(13499),
    [aux_sym_float_literal_token4] = ACTIONS(13499),
    [sym_character_literal] = ACTIONS(13499),
    [sym__pair_operator] = ACTIONS(13499),
    [sym__arrow_operator] = ACTIONS(13499),
    [sym__lazy_or_operator] = ACTIONS(13499),
    [sym__lazy_and_operator] = ACTIONS(13499),
    [sym__comparison_operator] = ACTIONS(13499),
    [sym__pipe_right_operator] = ACTIONS(13499),
    [sym__pipe_left_operator] = ACTIONS(13499),
    [sym__ellipsis_operator] = ACTIONS(13499),
    [sym__plus_operator] = ACTIONS(13499),
    [sym__times_operator] = ACTIONS(13499),
    [sym__rational_operator] = ACTIONS(13499),
    [sym__bitshift_operator] = ACTIONS(13499),
    [sym__power_operator] = ACTIONS(13499),
    [sym__tilde_operator] = ACTIONS(13499),
    [sym__type_order_operator] = ACTIONS(13499),
    [sym__unary_operator] = ACTIONS(13499),
    [sym__unary_plus_operator] = ACTIONS(13499),
    [aux_sym__terminator_token1] = ACTIONS(13499),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13501),
    [sym__command_start] = ACTIONS(13501),
  },
  [9007] = {
    [sym__word_identifier] = ACTIONS(13390),
    [anon_sym_EQ] = ACTIONS(13390),
    [anon_sym_COMMA] = ACTIONS(13390),
    [anon_sym_COLON] = ACTIONS(13390),
    [anon_sym_begin] = ACTIONS(13390),
    [anon_sym_module] = ACTIONS(13390),
    [anon_sym_baremodule] = ACTIONS(13390),
    [anon_sym_end] = ACTIONS(13390),
    [anon_sym_abstract] = ACTIONS(13390),
    [anon_sym_primitive] = ACTIONS(13390),
    [anon_sym_mutable] = ACTIONS(13390),
    [anon_sym_struct] = ACTIONS(13390),
    [anon_sym_function] = ACTIONS(13390),
    [anon_sym_macro] = ACTIONS(13390),
    [anon_sym_where] = ACTIONS(13390),
    [anon_sym_quote] = ACTIONS(13390),
    [anon_sym_let] = ACTIONS(13390),
    [anon_sym_if] = ACTIONS(13390),
    [anon_sym_try] = ACTIONS(13390),
    [anon_sym_for] = ACTIONS(13390),
    [anon_sym_while] = ACTIONS(13390),
    [sym_break_statement] = ACTIONS(13390),
    [sym_continue_statement] = ACTIONS(13390),
    [anon_sym_return] = ACTIONS(13390),
    [anon_sym_const] = ACTIONS(13390),
    [anon_sym_global] = ACTIONS(13390),
    [anon_sym_local] = ACTIONS(13390),
    [anon_sym_LPAREN] = ACTIONS(13390),
    [anon_sym_COLON2] = ACTIONS(13390),
    [anon_sym_export] = ACTIONS(13390),
    [anon_sym_import] = ACTIONS(13390),
    [anon_sym_using] = ACTIONS(13390),
    [anon_sym_LBRACK] = ACTIONS(13390),
    [anon_sym_LF] = ACTIONS(13392),
    [anon_sym_in] = ACTIONS(13390),
    [anon_sym_LBRACE] = ACTIONS(13390),
    [anon_sym_DOLLAR] = ACTIONS(13390),
    [anon_sym_COLON_COLON] = ACTIONS(13390),
    [anon_sym_isa] = ACTIONS(13390),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13390),
    [anon_sym_QMARK] = ACTIONS(13390),
    [anon_sym_AT] = ACTIONS(13390),
    [anon_sym_true] = ACTIONS(13390),
    [anon_sym_false] = ACTIONS(13390),
    [aux_sym_integer_literal_token1] = ACTIONS(13390),
    [aux_sym_integer_literal_token2] = ACTIONS(13390),
    [aux_sym_integer_literal_token3] = ACTIONS(13390),
    [aux_sym_integer_literal_token4] = ACTIONS(13390),
    [aux_sym_float_literal_token1] = ACTIONS(13390),
    [aux_sym_float_literal_token3] = ACTIONS(13390),
    [aux_sym_float_literal_token4] = ACTIONS(13390),
    [sym_character_literal] = ACTIONS(13390),
    [sym__pair_operator] = ACTIONS(13390),
    [sym__arrow_operator] = ACTIONS(13390),
    [sym__lazy_or_operator] = ACTIONS(13390),
    [sym__lazy_and_operator] = ACTIONS(13390),
    [sym__comparison_operator] = ACTIONS(13390),
    [sym__pipe_right_operator] = ACTIONS(13390),
    [sym__pipe_left_operator] = ACTIONS(13390),
    [sym__ellipsis_operator] = ACTIONS(13390),
    [sym__plus_operator] = ACTIONS(13390),
    [sym__times_operator] = ACTIONS(13390),
    [sym__rational_operator] = ACTIONS(13390),
    [sym__bitshift_operator] = ACTIONS(13390),
    [sym__power_operator] = ACTIONS(13390),
    [sym__tilde_operator] = ACTIONS(13390),
    [sym__type_order_operator] = ACTIONS(13390),
    [sym__unary_operator] = ACTIONS(13390),
    [sym__unary_plus_operator] = ACTIONS(13390),
    [aux_sym__terminator_token1] = ACTIONS(13390),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13392),
    [sym__command_start] = ACTIONS(13392),
  },
  [9008] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_EQ] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [9009] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9010] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9011] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9012] = {
    [sym__word_identifier] = ACTIONS(13382),
    [anon_sym_EQ] = ACTIONS(13382),
    [anon_sym_COMMA] = ACTIONS(13382),
    [anon_sym_COLON] = ACTIONS(13382),
    [anon_sym_begin] = ACTIONS(13382),
    [anon_sym_module] = ACTIONS(13382),
    [anon_sym_baremodule] = ACTIONS(13382),
    [anon_sym_abstract] = ACTIONS(13382),
    [anon_sym_primitive] = ACTIONS(13382),
    [anon_sym_mutable] = ACTIONS(13382),
    [anon_sym_struct] = ACTIONS(13382),
    [anon_sym_function] = ACTIONS(13382),
    [anon_sym_macro] = ACTIONS(13382),
    [anon_sym_where] = ACTIONS(13382),
    [anon_sym_quote] = ACTIONS(13382),
    [anon_sym_let] = ACTIONS(13382),
    [anon_sym_if] = ACTIONS(13382),
    [anon_sym_try] = ACTIONS(13382),
    [anon_sym_for] = ACTIONS(13382),
    [anon_sym_while] = ACTIONS(13382),
    [sym_break_statement] = ACTIONS(13382),
    [sym_continue_statement] = ACTIONS(13382),
    [anon_sym_return] = ACTIONS(13382),
    [anon_sym_const] = ACTIONS(13382),
    [anon_sym_global] = ACTIONS(13382),
    [anon_sym_local] = ACTIONS(13382),
    [anon_sym_LPAREN] = ACTIONS(13382),
    [anon_sym_RPAREN] = ACTIONS(13382),
    [anon_sym_COLON2] = ACTIONS(13382),
    [anon_sym_export] = ACTIONS(13382),
    [anon_sym_import] = ACTIONS(13382),
    [anon_sym_using] = ACTIONS(13382),
    [anon_sym_LBRACK] = ACTIONS(13382),
    [anon_sym_LF] = ACTIONS(13384),
    [anon_sym_in] = ACTIONS(13382),
    [anon_sym_SEMI] = ACTIONS(13382),
    [anon_sym_LBRACE] = ACTIONS(13382),
    [anon_sym_DOLLAR] = ACTIONS(13382),
    [anon_sym_COLON_COLON] = ACTIONS(13382),
    [anon_sym_isa] = ACTIONS(13382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13382),
    [anon_sym_QMARK] = ACTIONS(13382),
    [anon_sym_AT] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(13382),
    [anon_sym_false] = ACTIONS(13382),
    [aux_sym_integer_literal_token1] = ACTIONS(13382),
    [aux_sym_integer_literal_token2] = ACTIONS(13382),
    [aux_sym_integer_literal_token3] = ACTIONS(13382),
    [aux_sym_integer_literal_token4] = ACTIONS(13382),
    [aux_sym_float_literal_token1] = ACTIONS(13382),
    [aux_sym_float_literal_token3] = ACTIONS(13382),
    [aux_sym_float_literal_token4] = ACTIONS(13382),
    [sym_character_literal] = ACTIONS(13382),
    [sym__pair_operator] = ACTIONS(13382),
    [sym__arrow_operator] = ACTIONS(13382),
    [sym__lazy_or_operator] = ACTIONS(13382),
    [sym__lazy_and_operator] = ACTIONS(13382),
    [sym__comparison_operator] = ACTIONS(13382),
    [sym__pipe_right_operator] = ACTIONS(13382),
    [sym__pipe_left_operator] = ACTIONS(13382),
    [sym__ellipsis_operator] = ACTIONS(13382),
    [sym__plus_operator] = ACTIONS(13382),
    [sym__times_operator] = ACTIONS(13382),
    [sym__rational_operator] = ACTIONS(13382),
    [sym__bitshift_operator] = ACTIONS(13382),
    [sym__power_operator] = ACTIONS(13382),
    [sym__tilde_operator] = ACTIONS(13382),
    [sym__type_order_operator] = ACTIONS(13382),
    [sym__unary_operator] = ACTIONS(13382),
    [sym__unary_plus_operator] = ACTIONS(13382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13384),
    [sym__command_start] = ACTIONS(13384),
  },
  [9013] = {
    [sym__word_identifier] = ACTIONS(13396),
    [anon_sym_EQ] = ACTIONS(13396),
    [anon_sym_COMMA] = ACTIONS(13396),
    [anon_sym_COLON] = ACTIONS(13396),
    [anon_sym_begin] = ACTIONS(13396),
    [anon_sym_module] = ACTIONS(13396),
    [anon_sym_baremodule] = ACTIONS(13396),
    [anon_sym_end] = ACTIONS(13396),
    [anon_sym_abstract] = ACTIONS(13396),
    [anon_sym_primitive] = ACTIONS(13396),
    [anon_sym_mutable] = ACTIONS(13396),
    [anon_sym_struct] = ACTIONS(13396),
    [anon_sym_function] = ACTIONS(13396),
    [anon_sym_macro] = ACTIONS(13396),
    [anon_sym_where] = ACTIONS(13396),
    [anon_sym_quote] = ACTIONS(13396),
    [anon_sym_let] = ACTIONS(13396),
    [anon_sym_if] = ACTIONS(13396),
    [anon_sym_try] = ACTIONS(13396),
    [anon_sym_for] = ACTIONS(13396),
    [anon_sym_while] = ACTIONS(13396),
    [sym_break_statement] = ACTIONS(13396),
    [sym_continue_statement] = ACTIONS(13396),
    [anon_sym_return] = ACTIONS(13396),
    [anon_sym_const] = ACTIONS(13396),
    [anon_sym_global] = ACTIONS(13396),
    [anon_sym_local] = ACTIONS(13396),
    [anon_sym_LPAREN] = ACTIONS(13396),
    [anon_sym_COLON2] = ACTIONS(13396),
    [anon_sym_export] = ACTIONS(13396),
    [anon_sym_import] = ACTIONS(13396),
    [anon_sym_using] = ACTIONS(13396),
    [anon_sym_LBRACK] = ACTIONS(13396),
    [anon_sym_LF] = ACTIONS(13398),
    [anon_sym_in] = ACTIONS(13396),
    [anon_sym_LBRACE] = ACTIONS(13396),
    [anon_sym_DOLLAR] = ACTIONS(13396),
    [anon_sym_COLON_COLON] = ACTIONS(13396),
    [anon_sym_isa] = ACTIONS(13396),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13396),
    [anon_sym_QMARK] = ACTIONS(13396),
    [anon_sym_AT] = ACTIONS(13396),
    [anon_sym_true] = ACTIONS(13396),
    [anon_sym_false] = ACTIONS(13396),
    [aux_sym_integer_literal_token1] = ACTIONS(13396),
    [aux_sym_integer_literal_token2] = ACTIONS(13396),
    [aux_sym_integer_literal_token3] = ACTIONS(13396),
    [aux_sym_integer_literal_token4] = ACTIONS(13396),
    [aux_sym_float_literal_token1] = ACTIONS(13396),
    [aux_sym_float_literal_token3] = ACTIONS(13396),
    [aux_sym_float_literal_token4] = ACTIONS(13396),
    [sym_character_literal] = ACTIONS(13396),
    [sym__pair_operator] = ACTIONS(13396),
    [sym__arrow_operator] = ACTIONS(13396),
    [sym__lazy_or_operator] = ACTIONS(13396),
    [sym__lazy_and_operator] = ACTIONS(13396),
    [sym__comparison_operator] = ACTIONS(13396),
    [sym__pipe_right_operator] = ACTIONS(13396),
    [sym__pipe_left_operator] = ACTIONS(13396),
    [sym__ellipsis_operator] = ACTIONS(13396),
    [sym__plus_operator] = ACTIONS(13396),
    [sym__times_operator] = ACTIONS(13396),
    [sym__rational_operator] = ACTIONS(13396),
    [sym__bitshift_operator] = ACTIONS(13396),
    [sym__power_operator] = ACTIONS(13396),
    [sym__tilde_operator] = ACTIONS(13396),
    [sym__type_order_operator] = ACTIONS(13396),
    [sym__unary_operator] = ACTIONS(13396),
    [sym__unary_plus_operator] = ACTIONS(13396),
    [aux_sym__terminator_token1] = ACTIONS(13396),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13398),
    [sym__command_start] = ACTIONS(13398),
  },
  [9014] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14877),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_finally] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14879),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14881),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14883),
    [sym__arrow_operator] = ACTIONS(14885),
    [sym__lazy_or_operator] = ACTIONS(14887),
    [sym__lazy_and_operator] = ACTIONS(14889),
    [sym__comparison_operator] = ACTIONS(14881),
    [sym__pipe_right_operator] = ACTIONS(14891),
    [sym__pipe_left_operator] = ACTIONS(14893),
    [sym__ellipsis_operator] = ACTIONS(14895),
    [sym__plus_operator] = ACTIONS(14897),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14881),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14897),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [9015] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_finally] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14879),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14881),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14881),
    [sym__pipe_right_operator] = ACTIONS(14891),
    [sym__pipe_left_operator] = ACTIONS(14893),
    [sym__ellipsis_operator] = ACTIONS(14895),
    [sym__plus_operator] = ACTIONS(14897),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14881),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14897),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [9016] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14854),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_catch] = ACTIONS(13338),
    [anon_sym_finally] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14830),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14832),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(14832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14417),
    [anon_sym_QMARK] = ACTIONS(14596),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14856),
    [sym__arrow_operator] = ACTIONS(14858),
    [sym__lazy_or_operator] = ACTIONS(14860),
    [sym__lazy_and_operator] = ACTIONS(14862),
    [sym__comparison_operator] = ACTIONS(14832),
    [sym__pipe_right_operator] = ACTIONS(14834),
    [sym__pipe_left_operator] = ACTIONS(14836),
    [sym__ellipsis_operator] = ACTIONS(14838),
    [sym__plus_operator] = ACTIONS(14840),
    [sym__times_operator] = ACTIONS(14842),
    [sym__rational_operator] = ACTIONS(14844),
    [sym__bitshift_operator] = ACTIONS(14846),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14832),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14840),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [9017] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_finally] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14897),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14897),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [9018] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_catch] = ACTIONS(13308),
    [anon_sym_finally] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(14415),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14848),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9019] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14879),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14891),
    [sym__pipe_left_operator] = ACTIONS(14893),
    [sym__ellipsis_operator] = ACTIONS(14895),
    [sym__plus_operator] = ACTIONS(14897),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14897),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9020] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14877),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14879),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14881),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14883),
    [sym__arrow_operator] = ACTIONS(14885),
    [sym__lazy_or_operator] = ACTIONS(14887),
    [sym__lazy_and_operator] = ACTIONS(14889),
    [sym__comparison_operator] = ACTIONS(14881),
    [sym__pipe_right_operator] = ACTIONS(14891),
    [sym__pipe_left_operator] = ACTIONS(14893),
    [sym__ellipsis_operator] = ACTIONS(14895),
    [sym__plus_operator] = ACTIONS(14897),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14881),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14897),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9021] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14877),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14879),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14881),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14885),
    [sym__lazy_or_operator] = ACTIONS(14887),
    [sym__lazy_and_operator] = ACTIONS(14889),
    [sym__comparison_operator] = ACTIONS(14881),
    [sym__pipe_right_operator] = ACTIONS(14891),
    [sym__pipe_left_operator] = ACTIONS(14893),
    [sym__ellipsis_operator] = ACTIONS(14895),
    [sym__plus_operator] = ACTIONS(14897),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14881),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14897),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9022] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14877),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14879),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14881),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14889),
    [sym__comparison_operator] = ACTIONS(14881),
    [sym__pipe_right_operator] = ACTIONS(14891),
    [sym__pipe_left_operator] = ACTIONS(14893),
    [sym__ellipsis_operator] = ACTIONS(14895),
    [sym__plus_operator] = ACTIONS(14897),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14881),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14897),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9023] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14877),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14879),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14881),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(14881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14881),
    [sym__pipe_right_operator] = ACTIONS(14891),
    [sym__pipe_left_operator] = ACTIONS(14893),
    [sym__ellipsis_operator] = ACTIONS(14895),
    [sym__plus_operator] = ACTIONS(14897),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14881),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14897),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9024] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14879),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14895),
    [sym__plus_operator] = ACTIONS(14897),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14897),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9025] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14879),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14489),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14891),
    [sym__pipe_left_operator] = ACTIONS(14893),
    [sym__ellipsis_operator] = ACTIONS(14895),
    [sym__plus_operator] = ACTIONS(14897),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14897),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9026] = {
    [sym__word_identifier] = ACTIONS(13506),
    [anon_sym_EQ] = ACTIONS(13506),
    [anon_sym_COMMA] = ACTIONS(13506),
    [anon_sym_COLON] = ACTIONS(13506),
    [anon_sym_begin] = ACTIONS(13506),
    [anon_sym_module] = ACTIONS(13506),
    [anon_sym_baremodule] = ACTIONS(13506),
    [anon_sym_end] = ACTIONS(13506),
    [anon_sym_abstract] = ACTIONS(13506),
    [anon_sym_primitive] = ACTIONS(13506),
    [anon_sym_mutable] = ACTIONS(13506),
    [anon_sym_struct] = ACTIONS(13506),
    [anon_sym_function] = ACTIONS(13506),
    [anon_sym_macro] = ACTIONS(13506),
    [anon_sym_where] = ACTIONS(13506),
    [anon_sym_quote] = ACTIONS(13506),
    [anon_sym_let] = ACTIONS(13506),
    [anon_sym_if] = ACTIONS(13506),
    [anon_sym_try] = ACTIONS(13506),
    [anon_sym_for] = ACTIONS(13506),
    [anon_sym_while] = ACTIONS(13506),
    [sym_break_statement] = ACTIONS(13506),
    [sym_continue_statement] = ACTIONS(13506),
    [anon_sym_return] = ACTIONS(13506),
    [anon_sym_const] = ACTIONS(13506),
    [anon_sym_global] = ACTIONS(13506),
    [anon_sym_local] = ACTIONS(13506),
    [anon_sym_LPAREN] = ACTIONS(13506),
    [anon_sym_COLON2] = ACTIONS(13506),
    [anon_sym_export] = ACTIONS(13506),
    [anon_sym_import] = ACTIONS(13506),
    [anon_sym_using] = ACTIONS(13506),
    [anon_sym_LBRACK] = ACTIONS(13506),
    [anon_sym_LF] = ACTIONS(13508),
    [anon_sym_in] = ACTIONS(13506),
    [anon_sym_LBRACE] = ACTIONS(13506),
    [anon_sym_DOLLAR] = ACTIONS(13506),
    [anon_sym_COLON_COLON] = ACTIONS(13506),
    [anon_sym_isa] = ACTIONS(13506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13506),
    [anon_sym_QMARK] = ACTIONS(13506),
    [anon_sym_AT] = ACTIONS(13506),
    [anon_sym_true] = ACTIONS(13506),
    [anon_sym_false] = ACTIONS(13506),
    [aux_sym_integer_literal_token1] = ACTIONS(13506),
    [aux_sym_integer_literal_token2] = ACTIONS(13506),
    [aux_sym_integer_literal_token3] = ACTIONS(13506),
    [aux_sym_integer_literal_token4] = ACTIONS(13506),
    [aux_sym_float_literal_token1] = ACTIONS(13506),
    [aux_sym_float_literal_token3] = ACTIONS(13506),
    [aux_sym_float_literal_token4] = ACTIONS(13506),
    [sym_character_literal] = ACTIONS(13506),
    [sym__pair_operator] = ACTIONS(13506),
    [sym__arrow_operator] = ACTIONS(13506),
    [sym__lazy_or_operator] = ACTIONS(13506),
    [sym__lazy_and_operator] = ACTIONS(13506),
    [sym__comparison_operator] = ACTIONS(13506),
    [sym__pipe_right_operator] = ACTIONS(13506),
    [sym__pipe_left_operator] = ACTIONS(13506),
    [sym__ellipsis_operator] = ACTIONS(13506),
    [sym__plus_operator] = ACTIONS(13506),
    [sym__times_operator] = ACTIONS(13506),
    [sym__rational_operator] = ACTIONS(13506),
    [sym__bitshift_operator] = ACTIONS(13506),
    [sym__power_operator] = ACTIONS(13506),
    [sym__tilde_operator] = ACTIONS(13506),
    [sym__type_order_operator] = ACTIONS(13506),
    [sym__unary_operator] = ACTIONS(13506),
    [sym__unary_plus_operator] = ACTIONS(13506),
    [aux_sym__terminator_token1] = ACTIONS(13506),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13508),
    [sym__command_start] = ACTIONS(13508),
  },
  [9027] = {
    [sym__word_identifier] = ACTIONS(13510),
    [anon_sym_EQ] = ACTIONS(13510),
    [anon_sym_COMMA] = ACTIONS(13510),
    [anon_sym_COLON] = ACTIONS(13510),
    [anon_sym_begin] = ACTIONS(13510),
    [anon_sym_module] = ACTIONS(13510),
    [anon_sym_baremodule] = ACTIONS(13510),
    [anon_sym_end] = ACTIONS(13510),
    [anon_sym_abstract] = ACTIONS(13510),
    [anon_sym_primitive] = ACTIONS(13510),
    [anon_sym_mutable] = ACTIONS(13510),
    [anon_sym_struct] = ACTIONS(13510),
    [anon_sym_function] = ACTIONS(13510),
    [anon_sym_macro] = ACTIONS(13510),
    [anon_sym_where] = ACTIONS(13510),
    [anon_sym_quote] = ACTIONS(13510),
    [anon_sym_let] = ACTIONS(13510),
    [anon_sym_if] = ACTIONS(13510),
    [anon_sym_try] = ACTIONS(13510),
    [anon_sym_for] = ACTIONS(13510),
    [anon_sym_while] = ACTIONS(13510),
    [sym_break_statement] = ACTIONS(13510),
    [sym_continue_statement] = ACTIONS(13510),
    [anon_sym_return] = ACTIONS(13510),
    [anon_sym_const] = ACTIONS(13510),
    [anon_sym_global] = ACTIONS(13510),
    [anon_sym_local] = ACTIONS(13510),
    [anon_sym_LPAREN] = ACTIONS(13510),
    [anon_sym_COLON2] = ACTIONS(13510),
    [anon_sym_export] = ACTIONS(13510),
    [anon_sym_import] = ACTIONS(13510),
    [anon_sym_using] = ACTIONS(13510),
    [anon_sym_LBRACK] = ACTIONS(13510),
    [anon_sym_LF] = ACTIONS(13512),
    [anon_sym_in] = ACTIONS(13510),
    [anon_sym_LBRACE] = ACTIONS(13510),
    [anon_sym_DOLLAR] = ACTIONS(13510),
    [anon_sym_COLON_COLON] = ACTIONS(13510),
    [anon_sym_isa] = ACTIONS(13510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13510),
    [anon_sym_QMARK] = ACTIONS(13510),
    [anon_sym_AT] = ACTIONS(13510),
    [anon_sym_true] = ACTIONS(13510),
    [anon_sym_false] = ACTIONS(13510),
    [aux_sym_integer_literal_token1] = ACTIONS(13510),
    [aux_sym_integer_literal_token2] = ACTIONS(13510),
    [aux_sym_integer_literal_token3] = ACTIONS(13510),
    [aux_sym_integer_literal_token4] = ACTIONS(13510),
    [aux_sym_float_literal_token1] = ACTIONS(13510),
    [aux_sym_float_literal_token3] = ACTIONS(13510),
    [aux_sym_float_literal_token4] = ACTIONS(13510),
    [sym_character_literal] = ACTIONS(13510),
    [sym__pair_operator] = ACTIONS(13510),
    [sym__arrow_operator] = ACTIONS(13510),
    [sym__lazy_or_operator] = ACTIONS(13510),
    [sym__lazy_and_operator] = ACTIONS(13510),
    [sym__comparison_operator] = ACTIONS(13510),
    [sym__pipe_right_operator] = ACTIONS(13510),
    [sym__pipe_left_operator] = ACTIONS(13510),
    [sym__ellipsis_operator] = ACTIONS(13510),
    [sym__plus_operator] = ACTIONS(13510),
    [sym__times_operator] = ACTIONS(13510),
    [sym__rational_operator] = ACTIONS(13510),
    [sym__bitshift_operator] = ACTIONS(13510),
    [sym__power_operator] = ACTIONS(13510),
    [sym__tilde_operator] = ACTIONS(13510),
    [sym__type_order_operator] = ACTIONS(13510),
    [sym__unary_operator] = ACTIONS(13510),
    [sym__unary_plus_operator] = ACTIONS(13510),
    [aux_sym__terminator_token1] = ACTIONS(13510),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13512),
    [sym__command_start] = ACTIONS(13512),
  },
  [9028] = {
    [aux_sym_open_tuple_repeat1] = STATE(8299),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(14604),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [9029] = {
    [sym__word_identifier] = ACTIONS(13514),
    [anon_sym_EQ] = ACTIONS(13514),
    [anon_sym_COMMA] = ACTIONS(13514),
    [anon_sym_COLON] = ACTIONS(13514),
    [anon_sym_begin] = ACTIONS(13514),
    [anon_sym_module] = ACTIONS(13514),
    [anon_sym_baremodule] = ACTIONS(13514),
    [anon_sym_end] = ACTIONS(13514),
    [anon_sym_abstract] = ACTIONS(13514),
    [anon_sym_primitive] = ACTIONS(13514),
    [anon_sym_mutable] = ACTIONS(13514),
    [anon_sym_struct] = ACTIONS(13514),
    [anon_sym_function] = ACTIONS(13514),
    [anon_sym_macro] = ACTIONS(13514),
    [anon_sym_where] = ACTIONS(13514),
    [anon_sym_quote] = ACTIONS(13514),
    [anon_sym_let] = ACTIONS(13514),
    [anon_sym_if] = ACTIONS(13514),
    [anon_sym_try] = ACTIONS(13514),
    [anon_sym_for] = ACTIONS(13514),
    [anon_sym_while] = ACTIONS(13514),
    [sym_break_statement] = ACTIONS(13514),
    [sym_continue_statement] = ACTIONS(13514),
    [anon_sym_return] = ACTIONS(13514),
    [anon_sym_const] = ACTIONS(13514),
    [anon_sym_global] = ACTIONS(13514),
    [anon_sym_local] = ACTIONS(13514),
    [anon_sym_LPAREN] = ACTIONS(13514),
    [anon_sym_COLON2] = ACTIONS(13514),
    [anon_sym_export] = ACTIONS(13514),
    [anon_sym_import] = ACTIONS(13514),
    [anon_sym_using] = ACTIONS(13514),
    [anon_sym_LBRACK] = ACTIONS(13514),
    [anon_sym_LF] = ACTIONS(13516),
    [anon_sym_in] = ACTIONS(13514),
    [anon_sym_LBRACE] = ACTIONS(13514),
    [anon_sym_DOLLAR] = ACTIONS(13514),
    [anon_sym_COLON_COLON] = ACTIONS(13514),
    [anon_sym_isa] = ACTIONS(13514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13514),
    [anon_sym_QMARK] = ACTIONS(13514),
    [anon_sym_AT] = ACTIONS(13514),
    [anon_sym_true] = ACTIONS(13514),
    [anon_sym_false] = ACTIONS(13514),
    [aux_sym_integer_literal_token1] = ACTIONS(13514),
    [aux_sym_integer_literal_token2] = ACTIONS(13514),
    [aux_sym_integer_literal_token3] = ACTIONS(13514),
    [aux_sym_integer_literal_token4] = ACTIONS(13514),
    [aux_sym_float_literal_token1] = ACTIONS(13514),
    [aux_sym_float_literal_token3] = ACTIONS(13514),
    [aux_sym_float_literal_token4] = ACTIONS(13514),
    [sym_character_literal] = ACTIONS(13514),
    [sym__pair_operator] = ACTIONS(13514),
    [sym__arrow_operator] = ACTIONS(13514),
    [sym__lazy_or_operator] = ACTIONS(13514),
    [sym__lazy_and_operator] = ACTIONS(13514),
    [sym__comparison_operator] = ACTIONS(13514),
    [sym__pipe_right_operator] = ACTIONS(13514),
    [sym__pipe_left_operator] = ACTIONS(13514),
    [sym__ellipsis_operator] = ACTIONS(13514),
    [sym__plus_operator] = ACTIONS(13514),
    [sym__times_operator] = ACTIONS(13514),
    [sym__rational_operator] = ACTIONS(13514),
    [sym__bitshift_operator] = ACTIONS(13514),
    [sym__power_operator] = ACTIONS(13514),
    [sym__tilde_operator] = ACTIONS(13514),
    [sym__type_order_operator] = ACTIONS(13514),
    [sym__unary_operator] = ACTIONS(13514),
    [sym__unary_plus_operator] = ACTIONS(13514),
    [aux_sym__terminator_token1] = ACTIONS(13514),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13516),
    [sym__command_start] = ACTIONS(13516),
  },
  [9030] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_catch] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14782),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14784),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14784),
    [sym__pipe_right_operator] = ACTIONS(14792),
    [sym__pipe_left_operator] = ACTIONS(14794),
    [sym__ellipsis_operator] = ACTIONS(14796),
    [sym__plus_operator] = ACTIONS(14798),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14784),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14798),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [9031] = {
    [sym__word_identifier] = ACTIONS(13518),
    [anon_sym_EQ] = ACTIONS(13518),
    [anon_sym_COMMA] = ACTIONS(13518),
    [anon_sym_COLON] = ACTIONS(13518),
    [anon_sym_begin] = ACTIONS(13518),
    [anon_sym_module] = ACTIONS(13518),
    [anon_sym_baremodule] = ACTIONS(13518),
    [anon_sym_end] = ACTIONS(13518),
    [anon_sym_abstract] = ACTIONS(13518),
    [anon_sym_primitive] = ACTIONS(13518),
    [anon_sym_mutable] = ACTIONS(13518),
    [anon_sym_struct] = ACTIONS(13518),
    [anon_sym_function] = ACTIONS(13518),
    [anon_sym_macro] = ACTIONS(13518),
    [anon_sym_where] = ACTIONS(13518),
    [anon_sym_quote] = ACTIONS(13518),
    [anon_sym_let] = ACTIONS(13518),
    [anon_sym_if] = ACTIONS(13518),
    [anon_sym_try] = ACTIONS(13518),
    [anon_sym_for] = ACTIONS(13518),
    [anon_sym_while] = ACTIONS(13518),
    [sym_break_statement] = ACTIONS(13518),
    [sym_continue_statement] = ACTIONS(13518),
    [anon_sym_return] = ACTIONS(13518),
    [anon_sym_const] = ACTIONS(13518),
    [anon_sym_global] = ACTIONS(13518),
    [anon_sym_local] = ACTIONS(13518),
    [anon_sym_LPAREN] = ACTIONS(13518),
    [anon_sym_COLON2] = ACTIONS(13518),
    [anon_sym_export] = ACTIONS(13518),
    [anon_sym_import] = ACTIONS(13518),
    [anon_sym_using] = ACTIONS(13518),
    [anon_sym_LBRACK] = ACTIONS(13518),
    [anon_sym_LF] = ACTIONS(13520),
    [anon_sym_in] = ACTIONS(13518),
    [anon_sym_LBRACE] = ACTIONS(13518),
    [anon_sym_DOLLAR] = ACTIONS(13518),
    [anon_sym_COLON_COLON] = ACTIONS(13518),
    [anon_sym_isa] = ACTIONS(13518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13518),
    [anon_sym_QMARK] = ACTIONS(13518),
    [anon_sym_AT] = ACTIONS(13518),
    [anon_sym_true] = ACTIONS(13518),
    [anon_sym_false] = ACTIONS(13518),
    [aux_sym_integer_literal_token1] = ACTIONS(13518),
    [aux_sym_integer_literal_token2] = ACTIONS(13518),
    [aux_sym_integer_literal_token3] = ACTIONS(13518),
    [aux_sym_integer_literal_token4] = ACTIONS(13518),
    [aux_sym_float_literal_token1] = ACTIONS(13518),
    [aux_sym_float_literal_token3] = ACTIONS(13518),
    [aux_sym_float_literal_token4] = ACTIONS(13518),
    [sym_character_literal] = ACTIONS(13518),
    [sym__pair_operator] = ACTIONS(13518),
    [sym__arrow_operator] = ACTIONS(13518),
    [sym__lazy_or_operator] = ACTIONS(13518),
    [sym__lazy_and_operator] = ACTIONS(13518),
    [sym__comparison_operator] = ACTIONS(13518),
    [sym__pipe_right_operator] = ACTIONS(13518),
    [sym__pipe_left_operator] = ACTIONS(13518),
    [sym__ellipsis_operator] = ACTIONS(13518),
    [sym__plus_operator] = ACTIONS(13518),
    [sym__times_operator] = ACTIONS(13518),
    [sym__rational_operator] = ACTIONS(13518),
    [sym__bitshift_operator] = ACTIONS(13518),
    [sym__power_operator] = ACTIONS(13518),
    [sym__tilde_operator] = ACTIONS(13518),
    [sym__type_order_operator] = ACTIONS(13518),
    [sym__unary_operator] = ACTIONS(13518),
    [sym__unary_plus_operator] = ACTIONS(13518),
    [aux_sym__terminator_token1] = ACTIONS(13518),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13520),
    [sym__command_start] = ACTIONS(13520),
  },
  [9032] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(12724),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [9033] = {
    [aux_sym_open_tuple_repeat1] = STATE(8299),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(14604),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_end] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [9034] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9035] = {
    [sym__word_identifier] = ACTIONS(13257),
    [anon_sym_EQ] = ACTIONS(13257),
    [anon_sym_COMMA] = ACTIONS(13257),
    [anon_sym_COLON] = ACTIONS(13257),
    [anon_sym_begin] = ACTIONS(13257),
    [anon_sym_module] = ACTIONS(13257),
    [anon_sym_baremodule] = ACTIONS(13257),
    [anon_sym_end] = ACTIONS(13257),
    [anon_sym_abstract] = ACTIONS(13257),
    [anon_sym_primitive] = ACTIONS(13257),
    [anon_sym_mutable] = ACTIONS(13257),
    [anon_sym_struct] = ACTIONS(13257),
    [anon_sym_function] = ACTIONS(13257),
    [anon_sym_macro] = ACTIONS(13257),
    [anon_sym_where] = ACTIONS(13257),
    [anon_sym_quote] = ACTIONS(13257),
    [anon_sym_let] = ACTIONS(13257),
    [anon_sym_if] = ACTIONS(13257),
    [anon_sym_try] = ACTIONS(13257),
    [anon_sym_for] = ACTIONS(13257),
    [anon_sym_while] = ACTIONS(13257),
    [sym_break_statement] = ACTIONS(13257),
    [sym_continue_statement] = ACTIONS(13257),
    [anon_sym_return] = ACTIONS(13257),
    [anon_sym_const] = ACTIONS(13257),
    [anon_sym_global] = ACTIONS(13257),
    [anon_sym_local] = ACTIONS(13257),
    [anon_sym_LPAREN] = ACTIONS(13257),
    [anon_sym_COLON2] = ACTIONS(13257),
    [anon_sym_export] = ACTIONS(13257),
    [anon_sym_import] = ACTIONS(13257),
    [anon_sym_using] = ACTIONS(13257),
    [anon_sym_LBRACK] = ACTIONS(13257),
    [anon_sym_LF] = ACTIONS(13259),
    [anon_sym_in] = ACTIONS(13257),
    [anon_sym_LBRACE] = ACTIONS(13257),
    [anon_sym_DOLLAR] = ACTIONS(13257),
    [anon_sym_COLON_COLON] = ACTIONS(13257),
    [anon_sym_isa] = ACTIONS(13257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13257),
    [anon_sym_QMARK] = ACTIONS(13257),
    [anon_sym_AT] = ACTIONS(13257),
    [anon_sym_true] = ACTIONS(13257),
    [anon_sym_false] = ACTIONS(13257),
    [aux_sym_integer_literal_token1] = ACTIONS(13257),
    [aux_sym_integer_literal_token2] = ACTIONS(13257),
    [aux_sym_integer_literal_token3] = ACTIONS(13257),
    [aux_sym_integer_literal_token4] = ACTIONS(13257),
    [aux_sym_float_literal_token1] = ACTIONS(13257),
    [aux_sym_float_literal_token3] = ACTIONS(13257),
    [aux_sym_float_literal_token4] = ACTIONS(13257),
    [sym_character_literal] = ACTIONS(13257),
    [sym__pair_operator] = ACTIONS(13257),
    [sym__arrow_operator] = ACTIONS(13257),
    [sym__lazy_or_operator] = ACTIONS(13257),
    [sym__lazy_and_operator] = ACTIONS(13257),
    [sym__comparison_operator] = ACTIONS(13257),
    [sym__pipe_right_operator] = ACTIONS(13257),
    [sym__pipe_left_operator] = ACTIONS(13257),
    [sym__ellipsis_operator] = ACTIONS(13257),
    [sym__plus_operator] = ACTIONS(13257),
    [sym__times_operator] = ACTIONS(13257),
    [sym__rational_operator] = ACTIONS(13257),
    [sym__bitshift_operator] = ACTIONS(13257),
    [sym__power_operator] = ACTIONS(13257),
    [sym__tilde_operator] = ACTIONS(13257),
    [sym__type_order_operator] = ACTIONS(13257),
    [sym__unary_operator] = ACTIONS(13257),
    [sym__unary_plus_operator] = ACTIONS(13257),
    [aux_sym__terminator_token1] = ACTIONS(13257),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13259),
    [sym__command_start] = ACTIONS(13259),
  },
  [9036] = {
    [sym__word_identifier] = ACTIONS(13522),
    [anon_sym_EQ] = ACTIONS(13522),
    [anon_sym_COMMA] = ACTIONS(13522),
    [anon_sym_COLON] = ACTIONS(13522),
    [anon_sym_begin] = ACTIONS(13522),
    [anon_sym_module] = ACTIONS(13522),
    [anon_sym_baremodule] = ACTIONS(13522),
    [anon_sym_end] = ACTIONS(13522),
    [anon_sym_abstract] = ACTIONS(13522),
    [anon_sym_primitive] = ACTIONS(13522),
    [anon_sym_mutable] = ACTIONS(13522),
    [anon_sym_struct] = ACTIONS(13522),
    [anon_sym_function] = ACTIONS(13522),
    [anon_sym_macro] = ACTIONS(13522),
    [anon_sym_where] = ACTIONS(13522),
    [anon_sym_quote] = ACTIONS(13522),
    [anon_sym_let] = ACTIONS(13522),
    [anon_sym_if] = ACTIONS(13522),
    [anon_sym_try] = ACTIONS(13522),
    [anon_sym_for] = ACTIONS(13522),
    [anon_sym_while] = ACTIONS(13522),
    [sym_break_statement] = ACTIONS(13522),
    [sym_continue_statement] = ACTIONS(13522),
    [anon_sym_return] = ACTIONS(13522),
    [anon_sym_const] = ACTIONS(13522),
    [anon_sym_global] = ACTIONS(13522),
    [anon_sym_local] = ACTIONS(13522),
    [anon_sym_LPAREN] = ACTIONS(13522),
    [anon_sym_COLON2] = ACTIONS(13522),
    [anon_sym_export] = ACTIONS(13522),
    [anon_sym_import] = ACTIONS(13522),
    [anon_sym_using] = ACTIONS(13522),
    [anon_sym_LBRACK] = ACTIONS(13522),
    [anon_sym_LF] = ACTIONS(13524),
    [anon_sym_in] = ACTIONS(13522),
    [anon_sym_LBRACE] = ACTIONS(13522),
    [anon_sym_DOLLAR] = ACTIONS(13522),
    [anon_sym_COLON_COLON] = ACTIONS(13522),
    [anon_sym_isa] = ACTIONS(13522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13522),
    [anon_sym_QMARK] = ACTIONS(13522),
    [anon_sym_AT] = ACTIONS(13522),
    [anon_sym_true] = ACTIONS(13522),
    [anon_sym_false] = ACTIONS(13522),
    [aux_sym_integer_literal_token1] = ACTIONS(13522),
    [aux_sym_integer_literal_token2] = ACTIONS(13522),
    [aux_sym_integer_literal_token3] = ACTIONS(13522),
    [aux_sym_integer_literal_token4] = ACTIONS(13522),
    [aux_sym_float_literal_token1] = ACTIONS(13522),
    [aux_sym_float_literal_token3] = ACTIONS(13522),
    [aux_sym_float_literal_token4] = ACTIONS(13522),
    [sym_character_literal] = ACTIONS(13522),
    [sym__pair_operator] = ACTIONS(13522),
    [sym__arrow_operator] = ACTIONS(13522),
    [sym__lazy_or_operator] = ACTIONS(13522),
    [sym__lazy_and_operator] = ACTIONS(13522),
    [sym__comparison_operator] = ACTIONS(13522),
    [sym__pipe_right_operator] = ACTIONS(13522),
    [sym__pipe_left_operator] = ACTIONS(13522),
    [sym__ellipsis_operator] = ACTIONS(13522),
    [sym__plus_operator] = ACTIONS(13522),
    [sym__times_operator] = ACTIONS(13522),
    [sym__rational_operator] = ACTIONS(13522),
    [sym__bitshift_operator] = ACTIONS(13522),
    [sym__power_operator] = ACTIONS(13522),
    [sym__tilde_operator] = ACTIONS(13522),
    [sym__type_order_operator] = ACTIONS(13522),
    [sym__unary_operator] = ACTIONS(13522),
    [sym__unary_plus_operator] = ACTIONS(13522),
    [aux_sym__terminator_token1] = ACTIONS(13522),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13524),
    [sym__command_start] = ACTIONS(13524),
  },
  [9037] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DASH_GT] = ACTIONS(12014),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9038] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14897),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14897),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9039] = {
    [sym__word_identifier] = ACTIONS(13526),
    [anon_sym_EQ] = ACTIONS(13526),
    [anon_sym_COMMA] = ACTIONS(13526),
    [anon_sym_COLON] = ACTIONS(13526),
    [anon_sym_begin] = ACTIONS(13526),
    [anon_sym_module] = ACTIONS(13526),
    [anon_sym_baremodule] = ACTIONS(13526),
    [anon_sym_end] = ACTIONS(13526),
    [anon_sym_abstract] = ACTIONS(13526),
    [anon_sym_primitive] = ACTIONS(13526),
    [anon_sym_mutable] = ACTIONS(13526),
    [anon_sym_struct] = ACTIONS(13526),
    [anon_sym_function] = ACTIONS(13526),
    [anon_sym_macro] = ACTIONS(13526),
    [anon_sym_where] = ACTIONS(13526),
    [anon_sym_quote] = ACTIONS(13526),
    [anon_sym_let] = ACTIONS(13526),
    [anon_sym_if] = ACTIONS(13526),
    [anon_sym_try] = ACTIONS(13526),
    [anon_sym_for] = ACTIONS(13526),
    [anon_sym_while] = ACTIONS(13526),
    [sym_break_statement] = ACTIONS(13526),
    [sym_continue_statement] = ACTIONS(13526),
    [anon_sym_return] = ACTIONS(13526),
    [anon_sym_const] = ACTIONS(13526),
    [anon_sym_global] = ACTIONS(13526),
    [anon_sym_local] = ACTIONS(13526),
    [anon_sym_LPAREN] = ACTIONS(13526),
    [anon_sym_COLON2] = ACTIONS(13526),
    [anon_sym_export] = ACTIONS(13526),
    [anon_sym_import] = ACTIONS(13526),
    [anon_sym_using] = ACTIONS(13526),
    [anon_sym_LBRACK] = ACTIONS(13526),
    [anon_sym_LF] = ACTIONS(13528),
    [anon_sym_in] = ACTIONS(13526),
    [anon_sym_LBRACE] = ACTIONS(13526),
    [anon_sym_DOLLAR] = ACTIONS(13526),
    [anon_sym_COLON_COLON] = ACTIONS(13526),
    [anon_sym_isa] = ACTIONS(13526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13526),
    [anon_sym_QMARK] = ACTIONS(13526),
    [anon_sym_AT] = ACTIONS(13526),
    [anon_sym_true] = ACTIONS(13526),
    [anon_sym_false] = ACTIONS(13526),
    [aux_sym_integer_literal_token1] = ACTIONS(13526),
    [aux_sym_integer_literal_token2] = ACTIONS(13526),
    [aux_sym_integer_literal_token3] = ACTIONS(13526),
    [aux_sym_integer_literal_token4] = ACTIONS(13526),
    [aux_sym_float_literal_token1] = ACTIONS(13526),
    [aux_sym_float_literal_token3] = ACTIONS(13526),
    [aux_sym_float_literal_token4] = ACTIONS(13526),
    [sym_character_literal] = ACTIONS(13526),
    [sym__pair_operator] = ACTIONS(13526),
    [sym__arrow_operator] = ACTIONS(13526),
    [sym__lazy_or_operator] = ACTIONS(13526),
    [sym__lazy_and_operator] = ACTIONS(13526),
    [sym__comparison_operator] = ACTIONS(13526),
    [sym__pipe_right_operator] = ACTIONS(13526),
    [sym__pipe_left_operator] = ACTIONS(13526),
    [sym__ellipsis_operator] = ACTIONS(13526),
    [sym__plus_operator] = ACTIONS(13526),
    [sym__times_operator] = ACTIONS(13526),
    [sym__rational_operator] = ACTIONS(13526),
    [sym__bitshift_operator] = ACTIONS(13526),
    [sym__power_operator] = ACTIONS(13526),
    [sym__tilde_operator] = ACTIONS(13526),
    [sym__type_order_operator] = ACTIONS(13526),
    [sym__unary_operator] = ACTIONS(13526),
    [sym__unary_plus_operator] = ACTIONS(13526),
    [aux_sym__terminator_token1] = ACTIONS(13526),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13528),
    [sym__command_start] = ACTIONS(13528),
  },
  [9040] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_catch] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9041] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(14872),
    [anon_sym_COMMA] = ACTIONS(13201),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13201),
    [anon_sym_RPAREN] = ACTIONS(13201),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13201),
    [anon_sym_LF] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_SEMI] = ACTIONS(13201),
    [anon_sym_LBRACE] = ACTIONS(13201),
    [anon_sym_DOLLAR] = ACTIONS(13201),
    [anon_sym_COLON_COLON] = ACTIONS(13201),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13201),
    [anon_sym_QMARK] = ACTIONS(13201),
    [anon_sym_AT] = ACTIONS(13201),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13201),
    [aux_sym_integer_literal_token2] = ACTIONS(13201),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13201),
    [aux_sym_float_literal_token3] = ACTIONS(13201),
    [aux_sym_float_literal_token4] = ACTIONS(13201),
    [sym_character_literal] = ACTIONS(13201),
    [sym__pair_operator] = ACTIONS(13201),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13201),
    [sym__lazy_and_operator] = ACTIONS(13201),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13201),
    [sym__pipe_left_operator] = ACTIONS(13201),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13201),
    [sym__bitshift_operator] = ACTIONS(13201),
    [sym__power_operator] = ACTIONS(13201),
    [sym__tilde_operator] = ACTIONS(13201),
    [sym__type_order_operator] = ACTIONS(13201),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [9042] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(14870),
    [anon_sym_COMMA] = ACTIONS(13247),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13247),
    [anon_sym_RPAREN] = ACTIONS(13247),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13247),
    [anon_sym_RBRACK] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13247),
    [anon_sym_RBRACE] = ACTIONS(13247),
    [anon_sym_DOLLAR] = ACTIONS(13247),
    [anon_sym_COLON_COLON] = ACTIONS(13247),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13247),
    [anon_sym_QMARK] = ACTIONS(13247),
    [anon_sym_AT] = ACTIONS(13247),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13247),
    [aux_sym_integer_literal_token2] = ACTIONS(13247),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13247),
    [aux_sym_float_literal_token3] = ACTIONS(13247),
    [aux_sym_float_literal_token4] = ACTIONS(13247),
    [sym_character_literal] = ACTIONS(13247),
    [sym__pair_operator] = ACTIONS(13247),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13247),
    [sym__lazy_and_operator] = ACTIONS(13247),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13247),
    [sym__pipe_left_operator] = ACTIONS(13247),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13247),
    [sym__bitshift_operator] = ACTIONS(13247),
    [sym__power_operator] = ACTIONS(13247),
    [sym__tilde_operator] = ACTIONS(13247),
    [sym__type_order_operator] = ACTIONS(13247),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [9043] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_finally] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9044] = {
    [sym__word_identifier] = ACTIONS(13530),
    [anon_sym_EQ] = ACTIONS(13530),
    [anon_sym_COMMA] = ACTIONS(13530),
    [anon_sym_COLON] = ACTIONS(13530),
    [anon_sym_begin] = ACTIONS(13530),
    [anon_sym_module] = ACTIONS(13530),
    [anon_sym_baremodule] = ACTIONS(13530),
    [anon_sym_end] = ACTIONS(13530),
    [anon_sym_abstract] = ACTIONS(13530),
    [anon_sym_primitive] = ACTIONS(13530),
    [anon_sym_mutable] = ACTIONS(13530),
    [anon_sym_struct] = ACTIONS(13530),
    [anon_sym_function] = ACTIONS(13530),
    [anon_sym_macro] = ACTIONS(13530),
    [anon_sym_where] = ACTIONS(13530),
    [anon_sym_quote] = ACTIONS(13530),
    [anon_sym_let] = ACTIONS(13530),
    [anon_sym_if] = ACTIONS(13530),
    [anon_sym_try] = ACTIONS(13530),
    [anon_sym_for] = ACTIONS(13530),
    [anon_sym_while] = ACTIONS(13530),
    [sym_break_statement] = ACTIONS(13530),
    [sym_continue_statement] = ACTIONS(13530),
    [anon_sym_return] = ACTIONS(13530),
    [anon_sym_const] = ACTIONS(13530),
    [anon_sym_global] = ACTIONS(13530),
    [anon_sym_local] = ACTIONS(13530),
    [anon_sym_LPAREN] = ACTIONS(13530),
    [anon_sym_COLON2] = ACTIONS(13530),
    [anon_sym_export] = ACTIONS(13530),
    [anon_sym_import] = ACTIONS(13530),
    [anon_sym_using] = ACTIONS(13530),
    [anon_sym_LBRACK] = ACTIONS(13530),
    [anon_sym_LF] = ACTIONS(13532),
    [anon_sym_in] = ACTIONS(13530),
    [anon_sym_LBRACE] = ACTIONS(13530),
    [anon_sym_DOLLAR] = ACTIONS(13530),
    [anon_sym_COLON_COLON] = ACTIONS(13530),
    [anon_sym_isa] = ACTIONS(13530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13530),
    [anon_sym_QMARK] = ACTIONS(13530),
    [anon_sym_AT] = ACTIONS(13530),
    [anon_sym_true] = ACTIONS(13530),
    [anon_sym_false] = ACTIONS(13530),
    [aux_sym_integer_literal_token1] = ACTIONS(13530),
    [aux_sym_integer_literal_token2] = ACTIONS(13530),
    [aux_sym_integer_literal_token3] = ACTIONS(13530),
    [aux_sym_integer_literal_token4] = ACTIONS(13530),
    [aux_sym_float_literal_token1] = ACTIONS(13530),
    [aux_sym_float_literal_token3] = ACTIONS(13530),
    [aux_sym_float_literal_token4] = ACTIONS(13530),
    [sym_character_literal] = ACTIONS(13530),
    [sym__pair_operator] = ACTIONS(13530),
    [sym__arrow_operator] = ACTIONS(13530),
    [sym__lazy_or_operator] = ACTIONS(13530),
    [sym__lazy_and_operator] = ACTIONS(13530),
    [sym__comparison_operator] = ACTIONS(13530),
    [sym__pipe_right_operator] = ACTIONS(13530),
    [sym__pipe_left_operator] = ACTIONS(13530),
    [sym__ellipsis_operator] = ACTIONS(13530),
    [sym__plus_operator] = ACTIONS(13530),
    [sym__times_operator] = ACTIONS(13530),
    [sym__rational_operator] = ACTIONS(13530),
    [sym__bitshift_operator] = ACTIONS(13530),
    [sym__power_operator] = ACTIONS(13530),
    [sym__tilde_operator] = ACTIONS(13530),
    [sym__type_order_operator] = ACTIONS(13530),
    [sym__unary_operator] = ACTIONS(13530),
    [sym__unary_plus_operator] = ACTIONS(13530),
    [aux_sym__terminator_token1] = ACTIONS(13530),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13532),
    [sym__command_start] = ACTIONS(13532),
  },
  [9045] = {
    [sym__word_identifier] = ACTIONS(13534),
    [anon_sym_EQ] = ACTIONS(13534),
    [anon_sym_COMMA] = ACTIONS(13534),
    [anon_sym_COLON] = ACTIONS(13534),
    [anon_sym_begin] = ACTIONS(13534),
    [anon_sym_module] = ACTIONS(13534),
    [anon_sym_baremodule] = ACTIONS(13534),
    [anon_sym_end] = ACTIONS(13534),
    [anon_sym_abstract] = ACTIONS(13534),
    [anon_sym_primitive] = ACTIONS(13534),
    [anon_sym_mutable] = ACTIONS(13534),
    [anon_sym_struct] = ACTIONS(13534),
    [anon_sym_function] = ACTIONS(13534),
    [anon_sym_macro] = ACTIONS(13534),
    [anon_sym_where] = ACTIONS(13534),
    [anon_sym_quote] = ACTIONS(13534),
    [anon_sym_let] = ACTIONS(13534),
    [anon_sym_if] = ACTIONS(13534),
    [anon_sym_try] = ACTIONS(13534),
    [anon_sym_for] = ACTIONS(13534),
    [anon_sym_while] = ACTIONS(13534),
    [sym_break_statement] = ACTIONS(13534),
    [sym_continue_statement] = ACTIONS(13534),
    [anon_sym_return] = ACTIONS(13534),
    [anon_sym_const] = ACTIONS(13534),
    [anon_sym_global] = ACTIONS(13534),
    [anon_sym_local] = ACTIONS(13534),
    [anon_sym_LPAREN] = ACTIONS(13534),
    [anon_sym_COLON2] = ACTIONS(13534),
    [anon_sym_export] = ACTIONS(13534),
    [anon_sym_import] = ACTIONS(13534),
    [anon_sym_using] = ACTIONS(13534),
    [anon_sym_LBRACK] = ACTIONS(13534),
    [anon_sym_LF] = ACTIONS(13536),
    [anon_sym_in] = ACTIONS(13534),
    [anon_sym_LBRACE] = ACTIONS(13534),
    [anon_sym_DOLLAR] = ACTIONS(13534),
    [anon_sym_COLON_COLON] = ACTIONS(13534),
    [anon_sym_isa] = ACTIONS(13534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13534),
    [anon_sym_QMARK] = ACTIONS(13534),
    [anon_sym_AT] = ACTIONS(13534),
    [anon_sym_true] = ACTIONS(13534),
    [anon_sym_false] = ACTIONS(13534),
    [aux_sym_integer_literal_token1] = ACTIONS(13534),
    [aux_sym_integer_literal_token2] = ACTIONS(13534),
    [aux_sym_integer_literal_token3] = ACTIONS(13534),
    [aux_sym_integer_literal_token4] = ACTIONS(13534),
    [aux_sym_float_literal_token1] = ACTIONS(13534),
    [aux_sym_float_literal_token3] = ACTIONS(13534),
    [aux_sym_float_literal_token4] = ACTIONS(13534),
    [sym_character_literal] = ACTIONS(13534),
    [sym__pair_operator] = ACTIONS(13534),
    [sym__arrow_operator] = ACTIONS(13534),
    [sym__lazy_or_operator] = ACTIONS(13534),
    [sym__lazy_and_operator] = ACTIONS(13534),
    [sym__comparison_operator] = ACTIONS(13534),
    [sym__pipe_right_operator] = ACTIONS(13534),
    [sym__pipe_left_operator] = ACTIONS(13534),
    [sym__ellipsis_operator] = ACTIONS(13534),
    [sym__plus_operator] = ACTIONS(13534),
    [sym__times_operator] = ACTIONS(13534),
    [sym__rational_operator] = ACTIONS(13534),
    [sym__bitshift_operator] = ACTIONS(13534),
    [sym__power_operator] = ACTIONS(13534),
    [sym__tilde_operator] = ACTIONS(13534),
    [sym__type_order_operator] = ACTIONS(13534),
    [sym__unary_operator] = ACTIONS(13534),
    [sym__unary_plus_operator] = ACTIONS(13534),
    [aux_sym__terminator_token1] = ACTIONS(13534),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13536),
    [sym__command_start] = ACTIONS(13536),
  },
  [9046] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14899),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9047] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DASH_GT] = ACTIONS(12382),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9048] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_EQ] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [9049] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(14872),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_RPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_SEMI] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [9050] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(14872),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_RPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_SEMI] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [9051] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(14872),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_RPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_SEMI] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [9052] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9053] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14682),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9054] = {
    [sym__word_identifier] = ACTIONS(13316),
    [anon_sym_EQ] = ACTIONS(13316),
    [anon_sym_COMMA] = ACTIONS(13316),
    [anon_sym_COLON] = ACTIONS(13316),
    [anon_sym_begin] = ACTIONS(13316),
    [anon_sym_module] = ACTIONS(13316),
    [anon_sym_baremodule] = ACTIONS(13316),
    [anon_sym_end] = ACTIONS(13316),
    [anon_sym_abstract] = ACTIONS(13316),
    [anon_sym_primitive] = ACTIONS(13316),
    [anon_sym_mutable] = ACTIONS(13316),
    [anon_sym_struct] = ACTIONS(13316),
    [anon_sym_function] = ACTIONS(13316),
    [anon_sym_macro] = ACTIONS(13316),
    [anon_sym_where] = ACTIONS(13316),
    [anon_sym_quote] = ACTIONS(13316),
    [anon_sym_let] = ACTIONS(13316),
    [anon_sym_if] = ACTIONS(13316),
    [anon_sym_try] = ACTIONS(13316),
    [anon_sym_for] = ACTIONS(13316),
    [anon_sym_while] = ACTIONS(13316),
    [sym_break_statement] = ACTIONS(13316),
    [sym_continue_statement] = ACTIONS(13316),
    [anon_sym_return] = ACTIONS(13316),
    [anon_sym_const] = ACTIONS(13316),
    [anon_sym_global] = ACTIONS(13316),
    [anon_sym_local] = ACTIONS(13316),
    [anon_sym_LPAREN] = ACTIONS(13316),
    [anon_sym_COLON2] = ACTIONS(13316),
    [anon_sym_export] = ACTIONS(13316),
    [anon_sym_import] = ACTIONS(13316),
    [anon_sym_using] = ACTIONS(13316),
    [anon_sym_LBRACK] = ACTIONS(13316),
    [anon_sym_LF] = ACTIONS(13318),
    [anon_sym_in] = ACTIONS(13316),
    [anon_sym_LBRACE] = ACTIONS(13316),
    [anon_sym_DOLLAR] = ACTIONS(13316),
    [anon_sym_COLON_COLON] = ACTIONS(13316),
    [anon_sym_isa] = ACTIONS(13316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13316),
    [anon_sym_QMARK] = ACTIONS(13316),
    [anon_sym_AT] = ACTIONS(13316),
    [anon_sym_true] = ACTIONS(13316),
    [anon_sym_false] = ACTIONS(13316),
    [aux_sym_integer_literal_token1] = ACTIONS(13316),
    [aux_sym_integer_literal_token2] = ACTIONS(13316),
    [aux_sym_integer_literal_token3] = ACTIONS(13316),
    [aux_sym_integer_literal_token4] = ACTIONS(13316),
    [aux_sym_float_literal_token1] = ACTIONS(13316),
    [aux_sym_float_literal_token3] = ACTIONS(13316),
    [aux_sym_float_literal_token4] = ACTIONS(13316),
    [sym_character_literal] = ACTIONS(13316),
    [sym__pair_operator] = ACTIONS(13316),
    [sym__arrow_operator] = ACTIONS(13316),
    [sym__lazy_or_operator] = ACTIONS(13316),
    [sym__lazy_and_operator] = ACTIONS(13316),
    [sym__comparison_operator] = ACTIONS(13316),
    [sym__pipe_right_operator] = ACTIONS(13316),
    [sym__pipe_left_operator] = ACTIONS(13316),
    [sym__ellipsis_operator] = ACTIONS(13316),
    [sym__plus_operator] = ACTIONS(13316),
    [sym__times_operator] = ACTIONS(13316),
    [sym__rational_operator] = ACTIONS(13316),
    [sym__bitshift_operator] = ACTIONS(13316),
    [sym__power_operator] = ACTIONS(13316),
    [sym__tilde_operator] = ACTIONS(13316),
    [sym__type_order_operator] = ACTIONS(13316),
    [sym__unary_operator] = ACTIONS(13316),
    [sym__unary_plus_operator] = ACTIONS(13316),
    [aux_sym__terminator_token1] = ACTIONS(13316),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13318),
    [sym__command_start] = ACTIONS(13318),
  },
  [9055] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9056] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9057] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12106),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9058] = {
    [sym__word_identifier] = ACTIONS(13320),
    [anon_sym_EQ] = ACTIONS(13320),
    [anon_sym_COMMA] = ACTIONS(13320),
    [anon_sym_COLON] = ACTIONS(13320),
    [anon_sym_begin] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(13320),
    [anon_sym_baremodule] = ACTIONS(13320),
    [anon_sym_end] = ACTIONS(13320),
    [anon_sym_abstract] = ACTIONS(13320),
    [anon_sym_primitive] = ACTIONS(13320),
    [anon_sym_mutable] = ACTIONS(13320),
    [anon_sym_struct] = ACTIONS(13320),
    [anon_sym_function] = ACTIONS(13320),
    [anon_sym_macro] = ACTIONS(13320),
    [anon_sym_where] = ACTIONS(13320),
    [anon_sym_quote] = ACTIONS(13320),
    [anon_sym_let] = ACTIONS(13320),
    [anon_sym_if] = ACTIONS(13320),
    [anon_sym_try] = ACTIONS(13320),
    [anon_sym_for] = ACTIONS(13320),
    [anon_sym_while] = ACTIONS(13320),
    [sym_break_statement] = ACTIONS(13320),
    [sym_continue_statement] = ACTIONS(13320),
    [anon_sym_return] = ACTIONS(13320),
    [anon_sym_const] = ACTIONS(13320),
    [anon_sym_global] = ACTIONS(13320),
    [anon_sym_local] = ACTIONS(13320),
    [anon_sym_LPAREN] = ACTIONS(13320),
    [anon_sym_COLON2] = ACTIONS(13320),
    [anon_sym_export] = ACTIONS(13320),
    [anon_sym_import] = ACTIONS(13320),
    [anon_sym_using] = ACTIONS(13320),
    [anon_sym_LBRACK] = ACTIONS(13320),
    [anon_sym_LF] = ACTIONS(13322),
    [anon_sym_in] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(13320),
    [anon_sym_DOLLAR] = ACTIONS(13320),
    [anon_sym_COLON_COLON] = ACTIONS(13320),
    [anon_sym_isa] = ACTIONS(13320),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13320),
    [anon_sym_QMARK] = ACTIONS(13320),
    [anon_sym_AT] = ACTIONS(13320),
    [anon_sym_true] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(13320),
    [aux_sym_integer_literal_token1] = ACTIONS(13320),
    [aux_sym_integer_literal_token2] = ACTIONS(13320),
    [aux_sym_integer_literal_token3] = ACTIONS(13320),
    [aux_sym_integer_literal_token4] = ACTIONS(13320),
    [aux_sym_float_literal_token1] = ACTIONS(13320),
    [aux_sym_float_literal_token3] = ACTIONS(13320),
    [aux_sym_float_literal_token4] = ACTIONS(13320),
    [sym_character_literal] = ACTIONS(13320),
    [sym__pair_operator] = ACTIONS(13320),
    [sym__arrow_operator] = ACTIONS(13320),
    [sym__lazy_or_operator] = ACTIONS(13320),
    [sym__lazy_and_operator] = ACTIONS(13320),
    [sym__comparison_operator] = ACTIONS(13320),
    [sym__pipe_right_operator] = ACTIONS(13320),
    [sym__pipe_left_operator] = ACTIONS(13320),
    [sym__ellipsis_operator] = ACTIONS(13320),
    [sym__plus_operator] = ACTIONS(13320),
    [sym__times_operator] = ACTIONS(13320),
    [sym__rational_operator] = ACTIONS(13320),
    [sym__bitshift_operator] = ACTIONS(13320),
    [sym__power_operator] = ACTIONS(13320),
    [sym__tilde_operator] = ACTIONS(13320),
    [sym__type_order_operator] = ACTIONS(13320),
    [sym__unary_operator] = ACTIONS(13320),
    [sym__unary_plus_operator] = ACTIONS(13320),
    [aux_sym__terminator_token1] = ACTIONS(13320),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13322),
    [sym__command_start] = ACTIONS(13322),
  },
  [9059] = {
    [sym__word_identifier] = ACTIONS(13038),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_COMMA] = ACTIONS(13038),
    [anon_sym_COLON] = ACTIONS(13038),
    [anon_sym_begin] = ACTIONS(13038),
    [anon_sym_module] = ACTIONS(13038),
    [anon_sym_baremodule] = ACTIONS(13038),
    [anon_sym_end] = ACTIONS(13038),
    [anon_sym_abstract] = ACTIONS(13038),
    [anon_sym_primitive] = ACTIONS(13038),
    [anon_sym_mutable] = ACTIONS(13038),
    [anon_sym_struct] = ACTIONS(13038),
    [anon_sym_function] = ACTIONS(13038),
    [anon_sym_macro] = ACTIONS(13038),
    [anon_sym_where] = ACTIONS(13038),
    [anon_sym_quote] = ACTIONS(13038),
    [anon_sym_let] = ACTIONS(13038),
    [anon_sym_if] = ACTIONS(13038),
    [anon_sym_try] = ACTIONS(13038),
    [anon_sym_for] = ACTIONS(13038),
    [anon_sym_while] = ACTIONS(13038),
    [sym_break_statement] = ACTIONS(13038),
    [sym_continue_statement] = ACTIONS(13038),
    [anon_sym_return] = ACTIONS(13038),
    [anon_sym_const] = ACTIONS(13038),
    [anon_sym_global] = ACTIONS(13038),
    [anon_sym_local] = ACTIONS(13038),
    [anon_sym_LPAREN] = ACTIONS(13038),
    [anon_sym_COLON2] = ACTIONS(13038),
    [anon_sym_export] = ACTIONS(13038),
    [anon_sym_import] = ACTIONS(13038),
    [anon_sym_using] = ACTIONS(13038),
    [anon_sym_LBRACK] = ACTIONS(13038),
    [anon_sym_LF] = ACTIONS(13036),
    [anon_sym_in] = ACTIONS(13038),
    [anon_sym_LBRACE] = ACTIONS(13038),
    [anon_sym_DOLLAR] = ACTIONS(13038),
    [anon_sym_COLON_COLON] = ACTIONS(13038),
    [anon_sym_isa] = ACTIONS(13038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13038),
    [anon_sym_QMARK] = ACTIONS(13038),
    [anon_sym_AT] = ACTIONS(13038),
    [anon_sym_true] = ACTIONS(13038),
    [anon_sym_false] = ACTIONS(13038),
    [aux_sym_integer_literal_token1] = ACTIONS(13038),
    [aux_sym_integer_literal_token2] = ACTIONS(13038),
    [aux_sym_integer_literal_token3] = ACTIONS(13038),
    [aux_sym_integer_literal_token4] = ACTIONS(13038),
    [aux_sym_float_literal_token1] = ACTIONS(13038),
    [aux_sym_float_literal_token3] = ACTIONS(13038),
    [aux_sym_float_literal_token4] = ACTIONS(13038),
    [sym_character_literal] = ACTIONS(13038),
    [sym__pair_operator] = ACTIONS(13038),
    [sym__arrow_operator] = ACTIONS(13038),
    [sym__lazy_or_operator] = ACTIONS(13038),
    [sym__lazy_and_operator] = ACTIONS(13038),
    [sym__comparison_operator] = ACTIONS(13038),
    [sym__pipe_right_operator] = ACTIONS(13038),
    [sym__pipe_left_operator] = ACTIONS(13038),
    [sym__ellipsis_operator] = ACTIONS(13038),
    [sym__plus_operator] = ACTIONS(13038),
    [sym__times_operator] = ACTIONS(13038),
    [sym__rational_operator] = ACTIONS(13038),
    [sym__bitshift_operator] = ACTIONS(13038),
    [sym__power_operator] = ACTIONS(13038),
    [sym__tilde_operator] = ACTIONS(13038),
    [sym__type_order_operator] = ACTIONS(13038),
    [sym__unary_operator] = ACTIONS(13038),
    [sym__unary_plus_operator] = ACTIONS(13038),
    [aux_sym__terminator_token1] = ACTIONS(13038),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13036),
    [sym__command_start] = ACTIONS(13036),
  },
  [9060] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9061] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [9062] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9063] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9064] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12790),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12628),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9065] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(12724),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [9066] = {
    [aux_sym_open_tuple_repeat1] = STATE(8299),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(14604),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_end] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [9067] = {
    [sym__word_identifier] = ACTIONS(13538),
    [anon_sym_EQ] = ACTIONS(13538),
    [anon_sym_COMMA] = ACTIONS(13538),
    [anon_sym_COLON] = ACTIONS(13538),
    [anon_sym_begin] = ACTIONS(13538),
    [anon_sym_module] = ACTIONS(13538),
    [anon_sym_baremodule] = ACTIONS(13538),
    [anon_sym_end] = ACTIONS(13538),
    [anon_sym_abstract] = ACTIONS(13538),
    [anon_sym_primitive] = ACTIONS(13538),
    [anon_sym_mutable] = ACTIONS(13538),
    [anon_sym_struct] = ACTIONS(13538),
    [anon_sym_function] = ACTIONS(13538),
    [anon_sym_macro] = ACTIONS(13538),
    [anon_sym_where] = ACTIONS(13538),
    [anon_sym_quote] = ACTIONS(13538),
    [anon_sym_let] = ACTIONS(13538),
    [anon_sym_if] = ACTIONS(13538),
    [anon_sym_try] = ACTIONS(13538),
    [anon_sym_for] = ACTIONS(13538),
    [anon_sym_while] = ACTIONS(13538),
    [sym_break_statement] = ACTIONS(13538),
    [sym_continue_statement] = ACTIONS(13538),
    [anon_sym_return] = ACTIONS(13538),
    [anon_sym_const] = ACTIONS(13538),
    [anon_sym_global] = ACTIONS(13538),
    [anon_sym_local] = ACTIONS(13538),
    [anon_sym_LPAREN] = ACTIONS(13538),
    [anon_sym_COLON2] = ACTIONS(13538),
    [anon_sym_export] = ACTIONS(13538),
    [anon_sym_import] = ACTIONS(13538),
    [anon_sym_using] = ACTIONS(13538),
    [anon_sym_LBRACK] = ACTIONS(13538),
    [anon_sym_LF] = ACTIONS(13540),
    [anon_sym_in] = ACTIONS(13538),
    [anon_sym_LBRACE] = ACTIONS(13538),
    [anon_sym_DOLLAR] = ACTIONS(13538),
    [anon_sym_COLON_COLON] = ACTIONS(13538),
    [anon_sym_isa] = ACTIONS(13538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13538),
    [anon_sym_QMARK] = ACTIONS(13538),
    [anon_sym_AT] = ACTIONS(13538),
    [anon_sym_true] = ACTIONS(13538),
    [anon_sym_false] = ACTIONS(13538),
    [aux_sym_integer_literal_token1] = ACTIONS(13538),
    [aux_sym_integer_literal_token2] = ACTIONS(13538),
    [aux_sym_integer_literal_token3] = ACTIONS(13538),
    [aux_sym_integer_literal_token4] = ACTIONS(13538),
    [aux_sym_float_literal_token1] = ACTIONS(13538),
    [aux_sym_float_literal_token3] = ACTIONS(13538),
    [aux_sym_float_literal_token4] = ACTIONS(13538),
    [sym_character_literal] = ACTIONS(13538),
    [sym__pair_operator] = ACTIONS(13538),
    [sym__arrow_operator] = ACTIONS(13538),
    [sym__lazy_or_operator] = ACTIONS(13538),
    [sym__lazy_and_operator] = ACTIONS(13538),
    [sym__comparison_operator] = ACTIONS(13538),
    [sym__pipe_right_operator] = ACTIONS(13538),
    [sym__pipe_left_operator] = ACTIONS(13538),
    [sym__ellipsis_operator] = ACTIONS(13538),
    [sym__plus_operator] = ACTIONS(13538),
    [sym__times_operator] = ACTIONS(13538),
    [sym__rational_operator] = ACTIONS(13538),
    [sym__bitshift_operator] = ACTIONS(13538),
    [sym__power_operator] = ACTIONS(13538),
    [sym__tilde_operator] = ACTIONS(13538),
    [sym__type_order_operator] = ACTIONS(13538),
    [sym__unary_operator] = ACTIONS(13538),
    [sym__unary_plus_operator] = ACTIONS(13538),
    [aux_sym__terminator_token1] = ACTIONS(13538),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13540),
    [sym__command_start] = ACTIONS(13540),
  },
  [9068] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_EQ] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14682),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [9069] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(12724),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [9070] = {
    [aux_sym_open_tuple_repeat1] = STATE(8127),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(14541),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13247),
    [anon_sym_RPAREN] = ACTIONS(13247),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13247),
    [anon_sym_RBRACK] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13247),
    [anon_sym_RBRACE] = ACTIONS(13247),
    [anon_sym_DOLLAR] = ACTIONS(13247),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14828),
    [anon_sym_AT] = ACTIONS(13247),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13247),
    [aux_sym_integer_literal_token2] = ACTIONS(13247),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13247),
    [aux_sym_float_literal_token3] = ACTIONS(13247),
    [aux_sym_float_literal_token4] = ACTIONS(13247),
    [sym_character_literal] = ACTIONS(13247),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13247),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [9071] = {
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13075),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(14708),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13075),
    [anon_sym_RPAREN] = ACTIONS(13075),
    [anon_sym_COLON2] = ACTIONS(14710),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13075),
    [anon_sym_RBRACK] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(14712),
    [anon_sym_LBRACE] = ACTIONS(13075),
    [anon_sym_RBRACE] = ACTIONS(13075),
    [anon_sym_DOLLAR] = ACTIONS(13075),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14716),
    [anon_sym_AT] = ACTIONS(13075),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13075),
    [aux_sym_integer_literal_token2] = ACTIONS(13075),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13075),
    [aux_sym_float_literal_token3] = ACTIONS(13075),
    [aux_sym_float_literal_token4] = ACTIONS(13075),
    [sym_character_literal] = ACTIONS(13075),
    [sym__pair_operator] = ACTIONS(14718),
    [sym__arrow_operator] = ACTIONS(14720),
    [sym__lazy_or_operator] = ACTIONS(14722),
    [sym__lazy_and_operator] = ACTIONS(14724),
    [sym__comparison_operator] = ACTIONS(14712),
    [sym__pipe_right_operator] = ACTIONS(14726),
    [sym__pipe_left_operator] = ACTIONS(14728),
    [sym__ellipsis_operator] = ACTIONS(14730),
    [sym__plus_operator] = ACTIONS(14732),
    [sym__times_operator] = ACTIONS(14734),
    [sym__rational_operator] = ACTIONS(14736),
    [sym__bitshift_operator] = ACTIONS(14738),
    [sym__power_operator] = ACTIONS(14740),
    [sym__tilde_operator] = ACTIONS(13075),
    [sym__type_order_operator] = ACTIONS(14742),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(14732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [9072] = {
    [sym__word_identifier] = ACTIONS(13542),
    [anon_sym_EQ] = ACTIONS(13542),
    [anon_sym_COMMA] = ACTIONS(13542),
    [anon_sym_COLON] = ACTIONS(13542),
    [anon_sym_begin] = ACTIONS(13542),
    [anon_sym_module] = ACTIONS(13542),
    [anon_sym_baremodule] = ACTIONS(13542),
    [anon_sym_end] = ACTIONS(13542),
    [anon_sym_abstract] = ACTIONS(13542),
    [anon_sym_primitive] = ACTIONS(13542),
    [anon_sym_mutable] = ACTIONS(13542),
    [anon_sym_struct] = ACTIONS(13542),
    [anon_sym_function] = ACTIONS(13542),
    [anon_sym_macro] = ACTIONS(13542),
    [anon_sym_where] = ACTIONS(13542),
    [anon_sym_quote] = ACTIONS(13542),
    [anon_sym_let] = ACTIONS(13542),
    [anon_sym_if] = ACTIONS(13542),
    [anon_sym_try] = ACTIONS(13542),
    [anon_sym_for] = ACTIONS(13542),
    [anon_sym_while] = ACTIONS(13542),
    [sym_break_statement] = ACTIONS(13542),
    [sym_continue_statement] = ACTIONS(13542),
    [anon_sym_return] = ACTIONS(13542),
    [anon_sym_const] = ACTIONS(13542),
    [anon_sym_global] = ACTIONS(13542),
    [anon_sym_local] = ACTIONS(13542),
    [anon_sym_LPAREN] = ACTIONS(13542),
    [anon_sym_COLON2] = ACTIONS(13542),
    [anon_sym_export] = ACTIONS(13542),
    [anon_sym_import] = ACTIONS(13542),
    [anon_sym_using] = ACTIONS(13542),
    [anon_sym_LBRACK] = ACTIONS(13542),
    [anon_sym_LF] = ACTIONS(13544),
    [anon_sym_in] = ACTIONS(13542),
    [anon_sym_LBRACE] = ACTIONS(13542),
    [anon_sym_DOLLAR] = ACTIONS(13542),
    [anon_sym_COLON_COLON] = ACTIONS(13542),
    [anon_sym_isa] = ACTIONS(13542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13542),
    [anon_sym_QMARK] = ACTIONS(13542),
    [anon_sym_AT] = ACTIONS(13542),
    [anon_sym_true] = ACTIONS(13542),
    [anon_sym_false] = ACTIONS(13542),
    [aux_sym_integer_literal_token1] = ACTIONS(13542),
    [aux_sym_integer_literal_token2] = ACTIONS(13542),
    [aux_sym_integer_literal_token3] = ACTIONS(13542),
    [aux_sym_integer_literal_token4] = ACTIONS(13542),
    [aux_sym_float_literal_token1] = ACTIONS(13542),
    [aux_sym_float_literal_token3] = ACTIONS(13542),
    [aux_sym_float_literal_token4] = ACTIONS(13542),
    [sym_character_literal] = ACTIONS(13542),
    [sym__pair_operator] = ACTIONS(13542),
    [sym__arrow_operator] = ACTIONS(13542),
    [sym__lazy_or_operator] = ACTIONS(13542),
    [sym__lazy_and_operator] = ACTIONS(13542),
    [sym__comparison_operator] = ACTIONS(13542),
    [sym__pipe_right_operator] = ACTIONS(13542),
    [sym__pipe_left_operator] = ACTIONS(13542),
    [sym__ellipsis_operator] = ACTIONS(13542),
    [sym__plus_operator] = ACTIONS(13542),
    [sym__times_operator] = ACTIONS(13542),
    [sym__rational_operator] = ACTIONS(13542),
    [sym__bitshift_operator] = ACTIONS(13542),
    [sym__power_operator] = ACTIONS(13542),
    [sym__tilde_operator] = ACTIONS(13542),
    [sym__type_order_operator] = ACTIONS(13542),
    [sym__unary_operator] = ACTIONS(13542),
    [sym__unary_plus_operator] = ACTIONS(13542),
    [aux_sym__terminator_token1] = ACTIONS(13542),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13544),
    [sym__command_start] = ACTIONS(13544),
  },
  [9073] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_elseif] = ACTIONS(13308),
    [anon_sym_else] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(12938),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14826),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9074] = {
    [sym__word_identifier] = ACTIONS(13546),
    [anon_sym_EQ] = ACTIONS(13546),
    [anon_sym_COMMA] = ACTIONS(13546),
    [anon_sym_COLON] = ACTIONS(13546),
    [anon_sym_begin] = ACTIONS(13546),
    [anon_sym_module] = ACTIONS(13546),
    [anon_sym_baremodule] = ACTIONS(13546),
    [anon_sym_end] = ACTIONS(13546),
    [anon_sym_abstract] = ACTIONS(13546),
    [anon_sym_primitive] = ACTIONS(13546),
    [anon_sym_mutable] = ACTIONS(13546),
    [anon_sym_struct] = ACTIONS(13546),
    [anon_sym_function] = ACTIONS(13546),
    [anon_sym_macro] = ACTIONS(13546),
    [anon_sym_where] = ACTIONS(13546),
    [anon_sym_quote] = ACTIONS(13546),
    [anon_sym_let] = ACTIONS(13546),
    [anon_sym_if] = ACTIONS(13546),
    [anon_sym_try] = ACTIONS(13546),
    [anon_sym_for] = ACTIONS(13546),
    [anon_sym_while] = ACTIONS(13546),
    [sym_break_statement] = ACTIONS(13546),
    [sym_continue_statement] = ACTIONS(13546),
    [anon_sym_return] = ACTIONS(13546),
    [anon_sym_const] = ACTIONS(13546),
    [anon_sym_global] = ACTIONS(13546),
    [anon_sym_local] = ACTIONS(13546),
    [anon_sym_LPAREN] = ACTIONS(13546),
    [anon_sym_COLON2] = ACTIONS(13546),
    [anon_sym_export] = ACTIONS(13546),
    [anon_sym_import] = ACTIONS(13546),
    [anon_sym_using] = ACTIONS(13546),
    [anon_sym_LBRACK] = ACTIONS(13546),
    [anon_sym_LF] = ACTIONS(13548),
    [anon_sym_in] = ACTIONS(13546),
    [anon_sym_LBRACE] = ACTIONS(13546),
    [anon_sym_DOLLAR] = ACTIONS(13546),
    [anon_sym_COLON_COLON] = ACTIONS(13546),
    [anon_sym_isa] = ACTIONS(13546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13546),
    [anon_sym_QMARK] = ACTIONS(13546),
    [anon_sym_AT] = ACTIONS(13546),
    [anon_sym_true] = ACTIONS(13546),
    [anon_sym_false] = ACTIONS(13546),
    [aux_sym_integer_literal_token1] = ACTIONS(13546),
    [aux_sym_integer_literal_token2] = ACTIONS(13546),
    [aux_sym_integer_literal_token3] = ACTIONS(13546),
    [aux_sym_integer_literal_token4] = ACTIONS(13546),
    [aux_sym_float_literal_token1] = ACTIONS(13546),
    [aux_sym_float_literal_token3] = ACTIONS(13546),
    [aux_sym_float_literal_token4] = ACTIONS(13546),
    [sym_character_literal] = ACTIONS(13546),
    [sym__pair_operator] = ACTIONS(13546),
    [sym__arrow_operator] = ACTIONS(13546),
    [sym__lazy_or_operator] = ACTIONS(13546),
    [sym__lazy_and_operator] = ACTIONS(13546),
    [sym__comparison_operator] = ACTIONS(13546),
    [sym__pipe_right_operator] = ACTIONS(13546),
    [sym__pipe_left_operator] = ACTIONS(13546),
    [sym__ellipsis_operator] = ACTIONS(13546),
    [sym__plus_operator] = ACTIONS(13546),
    [sym__times_operator] = ACTIONS(13546),
    [sym__rational_operator] = ACTIONS(13546),
    [sym__bitshift_operator] = ACTIONS(13546),
    [sym__power_operator] = ACTIONS(13546),
    [sym__tilde_operator] = ACTIONS(13546),
    [sym__type_order_operator] = ACTIONS(13546),
    [sym__unary_operator] = ACTIONS(13546),
    [sym__unary_plus_operator] = ACTIONS(13546),
    [aux_sym__terminator_token1] = ACTIONS(13546),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13548),
    [sym__command_start] = ACTIONS(13548),
  },
  [9075] = {
    [sym__word_identifier] = ACTIONS(13550),
    [anon_sym_EQ] = ACTIONS(13550),
    [anon_sym_COMMA] = ACTIONS(13550),
    [anon_sym_COLON] = ACTIONS(13550),
    [anon_sym_begin] = ACTIONS(13550),
    [anon_sym_module] = ACTIONS(13550),
    [anon_sym_baremodule] = ACTIONS(13550),
    [anon_sym_end] = ACTIONS(13550),
    [anon_sym_abstract] = ACTIONS(13550),
    [anon_sym_primitive] = ACTIONS(13550),
    [anon_sym_mutable] = ACTIONS(13550),
    [anon_sym_struct] = ACTIONS(13550),
    [anon_sym_function] = ACTIONS(13550),
    [anon_sym_macro] = ACTIONS(13550),
    [anon_sym_where] = ACTIONS(13550),
    [anon_sym_quote] = ACTIONS(13550),
    [anon_sym_let] = ACTIONS(13550),
    [anon_sym_if] = ACTIONS(13550),
    [anon_sym_try] = ACTIONS(13550),
    [anon_sym_for] = ACTIONS(13550),
    [anon_sym_while] = ACTIONS(13550),
    [sym_break_statement] = ACTIONS(13550),
    [sym_continue_statement] = ACTIONS(13550),
    [anon_sym_return] = ACTIONS(13550),
    [anon_sym_const] = ACTIONS(13550),
    [anon_sym_global] = ACTIONS(13550),
    [anon_sym_local] = ACTIONS(13550),
    [anon_sym_LPAREN] = ACTIONS(13550),
    [anon_sym_COLON2] = ACTIONS(13550),
    [anon_sym_export] = ACTIONS(13550),
    [anon_sym_import] = ACTIONS(13550),
    [anon_sym_using] = ACTIONS(13550),
    [anon_sym_LBRACK] = ACTIONS(13550),
    [anon_sym_LF] = ACTIONS(13552),
    [anon_sym_in] = ACTIONS(13550),
    [anon_sym_LBRACE] = ACTIONS(13550),
    [anon_sym_DOLLAR] = ACTIONS(13550),
    [anon_sym_COLON_COLON] = ACTIONS(13550),
    [anon_sym_isa] = ACTIONS(13550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13550),
    [anon_sym_QMARK] = ACTIONS(13550),
    [anon_sym_AT] = ACTIONS(13550),
    [anon_sym_true] = ACTIONS(13550),
    [anon_sym_false] = ACTIONS(13550),
    [aux_sym_integer_literal_token1] = ACTIONS(13550),
    [aux_sym_integer_literal_token2] = ACTIONS(13550),
    [aux_sym_integer_literal_token3] = ACTIONS(13550),
    [aux_sym_integer_literal_token4] = ACTIONS(13550),
    [aux_sym_float_literal_token1] = ACTIONS(13550),
    [aux_sym_float_literal_token3] = ACTIONS(13550),
    [aux_sym_float_literal_token4] = ACTIONS(13550),
    [sym_character_literal] = ACTIONS(13550),
    [sym__pair_operator] = ACTIONS(13550),
    [sym__arrow_operator] = ACTIONS(13550),
    [sym__lazy_or_operator] = ACTIONS(13550),
    [sym__lazy_and_operator] = ACTIONS(13550),
    [sym__comparison_operator] = ACTIONS(13550),
    [sym__pipe_right_operator] = ACTIONS(13550),
    [sym__pipe_left_operator] = ACTIONS(13550),
    [sym__ellipsis_operator] = ACTIONS(13550),
    [sym__plus_operator] = ACTIONS(13550),
    [sym__times_operator] = ACTIONS(13550),
    [sym__rational_operator] = ACTIONS(13550),
    [sym__bitshift_operator] = ACTIONS(13550),
    [sym__power_operator] = ACTIONS(13550),
    [sym__tilde_operator] = ACTIONS(13550),
    [sym__type_order_operator] = ACTIONS(13550),
    [sym__unary_operator] = ACTIONS(13550),
    [sym__unary_plus_operator] = ACTIONS(13550),
    [aux_sym__terminator_token1] = ACTIONS(13550),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13552),
    [sym__command_start] = ACTIONS(13552),
  },
  [9076] = {
    [sym__word_identifier] = ACTIONS(13316),
    [anon_sym_EQ] = ACTIONS(13316),
    [anon_sym_COMMA] = ACTIONS(13316),
    [anon_sym_COLON] = ACTIONS(13316),
    [anon_sym_begin] = ACTIONS(13316),
    [anon_sym_module] = ACTIONS(13316),
    [anon_sym_baremodule] = ACTIONS(13316),
    [anon_sym_abstract] = ACTIONS(13316),
    [anon_sym_primitive] = ACTIONS(13316),
    [anon_sym_mutable] = ACTIONS(13316),
    [anon_sym_struct] = ACTIONS(13316),
    [anon_sym_function] = ACTIONS(13316),
    [anon_sym_macro] = ACTIONS(13316),
    [anon_sym_where] = ACTIONS(13316),
    [anon_sym_quote] = ACTIONS(13316),
    [anon_sym_let] = ACTIONS(13316),
    [anon_sym_if] = ACTIONS(13316),
    [anon_sym_try] = ACTIONS(13316),
    [anon_sym_for] = ACTIONS(13316),
    [anon_sym_while] = ACTIONS(13316),
    [sym_break_statement] = ACTIONS(13316),
    [sym_continue_statement] = ACTIONS(13316),
    [anon_sym_return] = ACTIONS(13316),
    [anon_sym_const] = ACTIONS(13316),
    [anon_sym_global] = ACTIONS(13316),
    [anon_sym_local] = ACTIONS(13316),
    [anon_sym_LPAREN] = ACTIONS(13316),
    [anon_sym_RPAREN] = ACTIONS(13316),
    [anon_sym_COLON2] = ACTIONS(13316),
    [anon_sym_export] = ACTIONS(13316),
    [anon_sym_import] = ACTIONS(13316),
    [anon_sym_using] = ACTIONS(13316),
    [anon_sym_LBRACK] = ACTIONS(13316),
    [anon_sym_LF] = ACTIONS(13318),
    [anon_sym_in] = ACTIONS(13316),
    [anon_sym_SEMI] = ACTIONS(13316),
    [anon_sym_LBRACE] = ACTIONS(13316),
    [anon_sym_DOLLAR] = ACTIONS(13316),
    [anon_sym_COLON_COLON] = ACTIONS(13316),
    [anon_sym_isa] = ACTIONS(13316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13316),
    [anon_sym_QMARK] = ACTIONS(13316),
    [anon_sym_AT] = ACTIONS(13316),
    [anon_sym_true] = ACTIONS(13316),
    [anon_sym_false] = ACTIONS(13316),
    [aux_sym_integer_literal_token1] = ACTIONS(13316),
    [aux_sym_integer_literal_token2] = ACTIONS(13316),
    [aux_sym_integer_literal_token3] = ACTIONS(13316),
    [aux_sym_integer_literal_token4] = ACTIONS(13316),
    [aux_sym_float_literal_token1] = ACTIONS(13316),
    [aux_sym_float_literal_token3] = ACTIONS(13316),
    [aux_sym_float_literal_token4] = ACTIONS(13316),
    [sym_character_literal] = ACTIONS(13316),
    [sym__pair_operator] = ACTIONS(13316),
    [sym__arrow_operator] = ACTIONS(13316),
    [sym__lazy_or_operator] = ACTIONS(13316),
    [sym__lazy_and_operator] = ACTIONS(13316),
    [sym__comparison_operator] = ACTIONS(13316),
    [sym__pipe_right_operator] = ACTIONS(13316),
    [sym__pipe_left_operator] = ACTIONS(13316),
    [sym__ellipsis_operator] = ACTIONS(13316),
    [sym__plus_operator] = ACTIONS(13316),
    [sym__times_operator] = ACTIONS(13316),
    [sym__rational_operator] = ACTIONS(13316),
    [sym__bitshift_operator] = ACTIONS(13316),
    [sym__power_operator] = ACTIONS(13316),
    [sym__tilde_operator] = ACTIONS(13316),
    [sym__type_order_operator] = ACTIONS(13316),
    [sym__unary_operator] = ACTIONS(13316),
    [sym__unary_plus_operator] = ACTIONS(13316),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13318),
    [sym__command_start] = ACTIONS(13318),
  },
  [9077] = {
    [sym__word_identifier] = ACTIONS(13320),
    [anon_sym_EQ] = ACTIONS(13320),
    [anon_sym_COMMA] = ACTIONS(13320),
    [anon_sym_COLON] = ACTIONS(13320),
    [anon_sym_begin] = ACTIONS(13320),
    [anon_sym_module] = ACTIONS(13320),
    [anon_sym_baremodule] = ACTIONS(13320),
    [anon_sym_abstract] = ACTIONS(13320),
    [anon_sym_primitive] = ACTIONS(13320),
    [anon_sym_mutable] = ACTIONS(13320),
    [anon_sym_struct] = ACTIONS(13320),
    [anon_sym_function] = ACTIONS(13320),
    [anon_sym_macro] = ACTIONS(13320),
    [anon_sym_where] = ACTIONS(13320),
    [anon_sym_quote] = ACTIONS(13320),
    [anon_sym_let] = ACTIONS(13320),
    [anon_sym_if] = ACTIONS(13320),
    [anon_sym_try] = ACTIONS(13320),
    [anon_sym_for] = ACTIONS(13320),
    [anon_sym_while] = ACTIONS(13320),
    [sym_break_statement] = ACTIONS(13320),
    [sym_continue_statement] = ACTIONS(13320),
    [anon_sym_return] = ACTIONS(13320),
    [anon_sym_const] = ACTIONS(13320),
    [anon_sym_global] = ACTIONS(13320),
    [anon_sym_local] = ACTIONS(13320),
    [anon_sym_LPAREN] = ACTIONS(13320),
    [anon_sym_RPAREN] = ACTIONS(13320),
    [anon_sym_COLON2] = ACTIONS(13320),
    [anon_sym_export] = ACTIONS(13320),
    [anon_sym_import] = ACTIONS(13320),
    [anon_sym_using] = ACTIONS(13320),
    [anon_sym_LBRACK] = ACTIONS(13320),
    [anon_sym_LF] = ACTIONS(13322),
    [anon_sym_in] = ACTIONS(13320),
    [anon_sym_SEMI] = ACTIONS(13320),
    [anon_sym_LBRACE] = ACTIONS(13320),
    [anon_sym_DOLLAR] = ACTIONS(13320),
    [anon_sym_COLON_COLON] = ACTIONS(13320),
    [anon_sym_isa] = ACTIONS(13320),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13320),
    [anon_sym_QMARK] = ACTIONS(13320),
    [anon_sym_AT] = ACTIONS(13320),
    [anon_sym_true] = ACTIONS(13320),
    [anon_sym_false] = ACTIONS(13320),
    [aux_sym_integer_literal_token1] = ACTIONS(13320),
    [aux_sym_integer_literal_token2] = ACTIONS(13320),
    [aux_sym_integer_literal_token3] = ACTIONS(13320),
    [aux_sym_integer_literal_token4] = ACTIONS(13320),
    [aux_sym_float_literal_token1] = ACTIONS(13320),
    [aux_sym_float_literal_token3] = ACTIONS(13320),
    [aux_sym_float_literal_token4] = ACTIONS(13320),
    [sym_character_literal] = ACTIONS(13320),
    [sym__pair_operator] = ACTIONS(13320),
    [sym__arrow_operator] = ACTIONS(13320),
    [sym__lazy_or_operator] = ACTIONS(13320),
    [sym__lazy_and_operator] = ACTIONS(13320),
    [sym__comparison_operator] = ACTIONS(13320),
    [sym__pipe_right_operator] = ACTIONS(13320),
    [sym__pipe_left_operator] = ACTIONS(13320),
    [sym__ellipsis_operator] = ACTIONS(13320),
    [sym__plus_operator] = ACTIONS(13320),
    [sym__times_operator] = ACTIONS(13320),
    [sym__rational_operator] = ACTIONS(13320),
    [sym__bitshift_operator] = ACTIONS(13320),
    [sym__power_operator] = ACTIONS(13320),
    [sym__tilde_operator] = ACTIONS(13320),
    [sym__type_order_operator] = ACTIONS(13320),
    [sym__unary_operator] = ACTIONS(13320),
    [sym__unary_plus_operator] = ACTIONS(13320),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13322),
    [sym__command_start] = ACTIONS(13322),
  },
  [9078] = {
    [sym__word_identifier] = ACTIONS(13554),
    [anon_sym_EQ] = ACTIONS(13554),
    [anon_sym_COMMA] = ACTIONS(13554),
    [anon_sym_COLON] = ACTIONS(13554),
    [anon_sym_begin] = ACTIONS(13554),
    [anon_sym_module] = ACTIONS(13554),
    [anon_sym_baremodule] = ACTIONS(13554),
    [anon_sym_end] = ACTIONS(13554),
    [anon_sym_abstract] = ACTIONS(13554),
    [anon_sym_primitive] = ACTIONS(13554),
    [anon_sym_mutable] = ACTIONS(13554),
    [anon_sym_struct] = ACTIONS(13554),
    [anon_sym_function] = ACTIONS(13554),
    [anon_sym_macro] = ACTIONS(13554),
    [anon_sym_where] = ACTIONS(13554),
    [anon_sym_quote] = ACTIONS(13554),
    [anon_sym_let] = ACTIONS(13554),
    [anon_sym_if] = ACTIONS(13554),
    [anon_sym_try] = ACTIONS(13554),
    [anon_sym_for] = ACTIONS(13554),
    [anon_sym_while] = ACTIONS(13554),
    [sym_break_statement] = ACTIONS(13554),
    [sym_continue_statement] = ACTIONS(13554),
    [anon_sym_return] = ACTIONS(13554),
    [anon_sym_const] = ACTIONS(13554),
    [anon_sym_global] = ACTIONS(13554),
    [anon_sym_local] = ACTIONS(13554),
    [anon_sym_LPAREN] = ACTIONS(13554),
    [anon_sym_COLON2] = ACTIONS(13554),
    [anon_sym_export] = ACTIONS(13554),
    [anon_sym_import] = ACTIONS(13554),
    [anon_sym_using] = ACTIONS(13554),
    [anon_sym_LBRACK] = ACTIONS(13554),
    [anon_sym_LF] = ACTIONS(13556),
    [anon_sym_in] = ACTIONS(13554),
    [anon_sym_LBRACE] = ACTIONS(13554),
    [anon_sym_DOLLAR] = ACTIONS(13554),
    [anon_sym_COLON_COLON] = ACTIONS(13554),
    [anon_sym_isa] = ACTIONS(13554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13554),
    [anon_sym_QMARK] = ACTIONS(13554),
    [anon_sym_AT] = ACTIONS(13554),
    [anon_sym_true] = ACTIONS(13554),
    [anon_sym_false] = ACTIONS(13554),
    [aux_sym_integer_literal_token1] = ACTIONS(13554),
    [aux_sym_integer_literal_token2] = ACTIONS(13554),
    [aux_sym_integer_literal_token3] = ACTIONS(13554),
    [aux_sym_integer_literal_token4] = ACTIONS(13554),
    [aux_sym_float_literal_token1] = ACTIONS(13554),
    [aux_sym_float_literal_token3] = ACTIONS(13554),
    [aux_sym_float_literal_token4] = ACTIONS(13554),
    [sym_character_literal] = ACTIONS(13554),
    [sym__pair_operator] = ACTIONS(13554),
    [sym__arrow_operator] = ACTIONS(13554),
    [sym__lazy_or_operator] = ACTIONS(13554),
    [sym__lazy_and_operator] = ACTIONS(13554),
    [sym__comparison_operator] = ACTIONS(13554),
    [sym__pipe_right_operator] = ACTIONS(13554),
    [sym__pipe_left_operator] = ACTIONS(13554),
    [sym__ellipsis_operator] = ACTIONS(13554),
    [sym__plus_operator] = ACTIONS(13554),
    [sym__times_operator] = ACTIONS(13554),
    [sym__rational_operator] = ACTIONS(13554),
    [sym__bitshift_operator] = ACTIONS(13554),
    [sym__power_operator] = ACTIONS(13554),
    [sym__tilde_operator] = ACTIONS(13554),
    [sym__type_order_operator] = ACTIONS(13554),
    [sym__unary_operator] = ACTIONS(13554),
    [sym__unary_plus_operator] = ACTIONS(13554),
    [aux_sym__terminator_token1] = ACTIONS(13554),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13556),
    [sym__command_start] = ACTIONS(13556),
  },
  [9079] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(14868),
    [anon_sym_COMMA] = ACTIONS(13249),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_end] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13249),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13249),
    [anon_sym_LF] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_LBRACE] = ACTIONS(13249),
    [anon_sym_DOLLAR] = ACTIONS(13249),
    [anon_sym_COLON_COLON] = ACTIONS(13249),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13249),
    [anon_sym_QMARK] = ACTIONS(13249),
    [anon_sym_AT] = ACTIONS(13249),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13249),
    [aux_sym_integer_literal_token2] = ACTIONS(13249),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13249),
    [aux_sym_float_literal_token3] = ACTIONS(13249),
    [aux_sym_float_literal_token4] = ACTIONS(13249),
    [sym_character_literal] = ACTIONS(13249),
    [sym__pair_operator] = ACTIONS(13249),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13249),
    [sym__lazy_and_operator] = ACTIONS(13249),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13249),
    [sym__pipe_left_operator] = ACTIONS(13249),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13249),
    [sym__bitshift_operator] = ACTIONS(13249),
    [sym__power_operator] = ACTIONS(13249),
    [sym__tilde_operator] = ACTIONS(13249),
    [sym__type_order_operator] = ACTIONS(13249),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [aux_sym__terminator_token1] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [9080] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14901),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9081] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13255),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_end] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13255),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13255),
    [anon_sym_LF] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13255),
    [anon_sym_DOLLAR] = ACTIONS(13255),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(13255),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13255),
    [aux_sym_integer_literal_token2] = ACTIONS(13255),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13255),
    [aux_sym_float_literal_token3] = ACTIONS(13255),
    [aux_sym_float_literal_token4] = ACTIONS(13255),
    [sym_character_literal] = ACTIONS(13255),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13255),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13255),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [9082] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(13239),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_RPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_SEMI] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(13239),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13239),
    [anon_sym_QMARK] = ACTIONS(13239),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(13239),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13239),
    [sym__lazy_and_operator] = ACTIONS(13239),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13239),
    [sym__pipe_left_operator] = ACTIONS(13239),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13239),
    [sym__bitshift_operator] = ACTIONS(13239),
    [sym__power_operator] = ACTIONS(13239),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(13239),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [9083] = {
    [aux_sym_open_tuple_repeat1] = STATE(8581),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(14635),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13239),
    [anon_sym_RPAREN] = ACTIONS(13239),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13239),
    [anon_sym_LF] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13239),
    [anon_sym_LBRACE] = ACTIONS(13239),
    [anon_sym_DOLLAR] = ACTIONS(13239),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14808),
    [anon_sym_AT] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13239),
    [aux_sym_integer_literal_token2] = ACTIONS(13239),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13239),
    [aux_sym_float_literal_token3] = ACTIONS(13239),
    [aux_sym_float_literal_token4] = ACTIONS(13239),
    [sym_character_literal] = ACTIONS(13239),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13239),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [9084] = {
    [sym__word_identifier] = ACTIONS(13326),
    [anon_sym_EQ] = ACTIONS(13326),
    [anon_sym_COMMA] = ACTIONS(13326),
    [anon_sym_COLON] = ACTIONS(13326),
    [anon_sym_begin] = ACTIONS(13326),
    [anon_sym_module] = ACTIONS(13326),
    [anon_sym_baremodule] = ACTIONS(13326),
    [anon_sym_abstract] = ACTIONS(13326),
    [anon_sym_primitive] = ACTIONS(13326),
    [anon_sym_mutable] = ACTIONS(13326),
    [anon_sym_struct] = ACTIONS(13326),
    [anon_sym_function] = ACTIONS(13326),
    [anon_sym_macro] = ACTIONS(13326),
    [anon_sym_where] = ACTIONS(13326),
    [anon_sym_quote] = ACTIONS(13326),
    [anon_sym_let] = ACTIONS(13326),
    [anon_sym_if] = ACTIONS(13326),
    [anon_sym_try] = ACTIONS(13326),
    [anon_sym_for] = ACTIONS(13326),
    [anon_sym_while] = ACTIONS(13326),
    [sym_break_statement] = ACTIONS(13326),
    [sym_continue_statement] = ACTIONS(13326),
    [anon_sym_return] = ACTIONS(13326),
    [anon_sym_const] = ACTIONS(13326),
    [anon_sym_global] = ACTIONS(13326),
    [anon_sym_local] = ACTIONS(13326),
    [anon_sym_LPAREN] = ACTIONS(13326),
    [anon_sym_RPAREN] = ACTIONS(13326),
    [anon_sym_COLON2] = ACTIONS(13326),
    [anon_sym_export] = ACTIONS(13326),
    [anon_sym_import] = ACTIONS(13326),
    [anon_sym_using] = ACTIONS(13326),
    [anon_sym_LBRACK] = ACTIONS(13326),
    [anon_sym_LF] = ACTIONS(13328),
    [anon_sym_in] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(13326),
    [anon_sym_LBRACE] = ACTIONS(13326),
    [anon_sym_DOLLAR] = ACTIONS(13326),
    [anon_sym_COLON_COLON] = ACTIONS(13326),
    [anon_sym_isa] = ACTIONS(13326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13326),
    [anon_sym_QMARK] = ACTIONS(13326),
    [anon_sym_AT] = ACTIONS(13326),
    [anon_sym_true] = ACTIONS(13326),
    [anon_sym_false] = ACTIONS(13326),
    [aux_sym_integer_literal_token1] = ACTIONS(13326),
    [aux_sym_integer_literal_token2] = ACTIONS(13326),
    [aux_sym_integer_literal_token3] = ACTIONS(13326),
    [aux_sym_integer_literal_token4] = ACTIONS(13326),
    [aux_sym_float_literal_token1] = ACTIONS(13326),
    [aux_sym_float_literal_token3] = ACTIONS(13326),
    [aux_sym_float_literal_token4] = ACTIONS(13326),
    [sym_character_literal] = ACTIONS(13326),
    [sym__pair_operator] = ACTIONS(13326),
    [sym__arrow_operator] = ACTIONS(13326),
    [sym__lazy_or_operator] = ACTIONS(13326),
    [sym__lazy_and_operator] = ACTIONS(13326),
    [sym__comparison_operator] = ACTIONS(13326),
    [sym__pipe_right_operator] = ACTIONS(13326),
    [sym__pipe_left_operator] = ACTIONS(13326),
    [sym__ellipsis_operator] = ACTIONS(13326),
    [sym__plus_operator] = ACTIONS(13326),
    [sym__times_operator] = ACTIONS(13326),
    [sym__rational_operator] = ACTIONS(13326),
    [sym__bitshift_operator] = ACTIONS(13326),
    [sym__power_operator] = ACTIONS(13326),
    [sym__tilde_operator] = ACTIONS(13326),
    [sym__type_order_operator] = ACTIONS(13326),
    [sym__unary_operator] = ACTIONS(13326),
    [sym__unary_plus_operator] = ACTIONS(13326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13328),
    [sym__command_start] = ACTIONS(13328),
  },
  [9085] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_RPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_SEMI] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [9086] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12120),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9087] = {
    [aux_sym_open_tuple_repeat1] = STATE(8581),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(14635),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_RPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14808),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [9088] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_RPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_SEMI] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [9089] = {
    [aux_sym_open_tuple_repeat1] = STATE(8581),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(14635),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14744),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_RPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(14746),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14748),
    [anon_sym_SEMI] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(14748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14808),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(14756),
    [sym__arrow_operator] = ACTIONS(14758),
    [sym__lazy_or_operator] = ACTIONS(14760),
    [sym__lazy_and_operator] = ACTIONS(14762),
    [sym__comparison_operator] = ACTIONS(14748),
    [sym__pipe_right_operator] = ACTIONS(14764),
    [sym__pipe_left_operator] = ACTIONS(14766),
    [sym__ellipsis_operator] = ACTIONS(14768),
    [sym__plus_operator] = ACTIONS(14770),
    [sym__times_operator] = ACTIONS(14772),
    [sym__rational_operator] = ACTIONS(14774),
    [sym__bitshift_operator] = ACTIONS(14776),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(14748),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14770),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [9090] = {
    [sym__word_identifier] = ACTIONS(13558),
    [anon_sym_EQ] = ACTIONS(13558),
    [anon_sym_COMMA] = ACTIONS(13558),
    [anon_sym_COLON] = ACTIONS(13558),
    [anon_sym_begin] = ACTIONS(13558),
    [anon_sym_module] = ACTIONS(13558),
    [anon_sym_baremodule] = ACTIONS(13558),
    [anon_sym_end] = ACTIONS(13558),
    [anon_sym_abstract] = ACTIONS(13558),
    [anon_sym_primitive] = ACTIONS(13558),
    [anon_sym_mutable] = ACTIONS(13558),
    [anon_sym_struct] = ACTIONS(13558),
    [anon_sym_function] = ACTIONS(13558),
    [anon_sym_macro] = ACTIONS(13558),
    [anon_sym_where] = ACTIONS(13558),
    [anon_sym_quote] = ACTIONS(13558),
    [anon_sym_let] = ACTIONS(13558),
    [anon_sym_if] = ACTIONS(13558),
    [anon_sym_try] = ACTIONS(13558),
    [anon_sym_for] = ACTIONS(13558),
    [anon_sym_while] = ACTIONS(13558),
    [sym_break_statement] = ACTIONS(13558),
    [sym_continue_statement] = ACTIONS(13558),
    [anon_sym_return] = ACTIONS(13558),
    [anon_sym_const] = ACTIONS(13558),
    [anon_sym_global] = ACTIONS(13558),
    [anon_sym_local] = ACTIONS(13558),
    [anon_sym_LPAREN] = ACTIONS(13558),
    [anon_sym_COLON2] = ACTIONS(13558),
    [anon_sym_export] = ACTIONS(13558),
    [anon_sym_import] = ACTIONS(13558),
    [anon_sym_using] = ACTIONS(13558),
    [anon_sym_LBRACK] = ACTIONS(13558),
    [anon_sym_LF] = ACTIONS(13560),
    [anon_sym_in] = ACTIONS(13558),
    [anon_sym_LBRACE] = ACTIONS(13558),
    [anon_sym_DOLLAR] = ACTIONS(13558),
    [anon_sym_COLON_COLON] = ACTIONS(13558),
    [anon_sym_isa] = ACTIONS(13558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13558),
    [anon_sym_QMARK] = ACTIONS(13558),
    [anon_sym_AT] = ACTIONS(13558),
    [anon_sym_true] = ACTIONS(13558),
    [anon_sym_false] = ACTIONS(13558),
    [aux_sym_integer_literal_token1] = ACTIONS(13558),
    [aux_sym_integer_literal_token2] = ACTIONS(13558),
    [aux_sym_integer_literal_token3] = ACTIONS(13558),
    [aux_sym_integer_literal_token4] = ACTIONS(13558),
    [aux_sym_float_literal_token1] = ACTIONS(13558),
    [aux_sym_float_literal_token3] = ACTIONS(13558),
    [aux_sym_float_literal_token4] = ACTIONS(13558),
    [sym_character_literal] = ACTIONS(13558),
    [sym__pair_operator] = ACTIONS(13558),
    [sym__arrow_operator] = ACTIONS(13558),
    [sym__lazy_or_operator] = ACTIONS(13558),
    [sym__lazy_and_operator] = ACTIONS(13558),
    [sym__comparison_operator] = ACTIONS(13558),
    [sym__pipe_right_operator] = ACTIONS(13558),
    [sym__pipe_left_operator] = ACTIONS(13558),
    [sym__ellipsis_operator] = ACTIONS(13558),
    [sym__plus_operator] = ACTIONS(13558),
    [sym__times_operator] = ACTIONS(13558),
    [sym__rational_operator] = ACTIONS(13558),
    [sym__bitshift_operator] = ACTIONS(13558),
    [sym__power_operator] = ACTIONS(13558),
    [sym__tilde_operator] = ACTIONS(13558),
    [sym__type_order_operator] = ACTIONS(13558),
    [sym__unary_operator] = ACTIONS(13558),
    [sym__unary_plus_operator] = ACTIONS(13558),
    [aux_sym__terminator_token1] = ACTIONS(13558),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13560),
    [sym__command_start] = ACTIONS(13560),
  },
  [9091] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12446),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9092] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14903),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9093] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9094] = {
    [sym__word_identifier] = ACTIONS(13326),
    [anon_sym_EQ] = ACTIONS(13326),
    [anon_sym_COMMA] = ACTIONS(13326),
    [anon_sym_COLON] = ACTIONS(13326),
    [anon_sym_begin] = ACTIONS(13326),
    [anon_sym_module] = ACTIONS(13326),
    [anon_sym_baremodule] = ACTIONS(13326),
    [anon_sym_end] = ACTIONS(13326),
    [anon_sym_abstract] = ACTIONS(13326),
    [anon_sym_primitive] = ACTIONS(13326),
    [anon_sym_mutable] = ACTIONS(13326),
    [anon_sym_struct] = ACTIONS(13326),
    [anon_sym_function] = ACTIONS(13326),
    [anon_sym_macro] = ACTIONS(13326),
    [anon_sym_where] = ACTIONS(13326),
    [anon_sym_quote] = ACTIONS(13326),
    [anon_sym_let] = ACTIONS(13326),
    [anon_sym_if] = ACTIONS(13326),
    [anon_sym_try] = ACTIONS(13326),
    [anon_sym_for] = ACTIONS(13326),
    [anon_sym_while] = ACTIONS(13326),
    [sym_break_statement] = ACTIONS(13326),
    [sym_continue_statement] = ACTIONS(13326),
    [anon_sym_return] = ACTIONS(13326),
    [anon_sym_const] = ACTIONS(13326),
    [anon_sym_global] = ACTIONS(13326),
    [anon_sym_local] = ACTIONS(13326),
    [anon_sym_LPAREN] = ACTIONS(13326),
    [anon_sym_COLON2] = ACTIONS(13326),
    [anon_sym_export] = ACTIONS(13326),
    [anon_sym_import] = ACTIONS(13326),
    [anon_sym_using] = ACTIONS(13326),
    [anon_sym_LBRACK] = ACTIONS(13326),
    [anon_sym_LF] = ACTIONS(13328),
    [anon_sym_in] = ACTIONS(13326),
    [anon_sym_LBRACE] = ACTIONS(13326),
    [anon_sym_DOLLAR] = ACTIONS(13326),
    [anon_sym_COLON_COLON] = ACTIONS(13326),
    [anon_sym_isa] = ACTIONS(13326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13326),
    [anon_sym_QMARK] = ACTIONS(13326),
    [anon_sym_AT] = ACTIONS(13326),
    [anon_sym_true] = ACTIONS(13326),
    [anon_sym_false] = ACTIONS(13326),
    [aux_sym_integer_literal_token1] = ACTIONS(13326),
    [aux_sym_integer_literal_token2] = ACTIONS(13326),
    [aux_sym_integer_literal_token3] = ACTIONS(13326),
    [aux_sym_integer_literal_token4] = ACTIONS(13326),
    [aux_sym_float_literal_token1] = ACTIONS(13326),
    [aux_sym_float_literal_token3] = ACTIONS(13326),
    [aux_sym_float_literal_token4] = ACTIONS(13326),
    [sym_character_literal] = ACTIONS(13326),
    [sym__pair_operator] = ACTIONS(13326),
    [sym__arrow_operator] = ACTIONS(13326),
    [sym__lazy_or_operator] = ACTIONS(13326),
    [sym__lazy_and_operator] = ACTIONS(13326),
    [sym__comparison_operator] = ACTIONS(13326),
    [sym__pipe_right_operator] = ACTIONS(13326),
    [sym__pipe_left_operator] = ACTIONS(13326),
    [sym__ellipsis_operator] = ACTIONS(13326),
    [sym__plus_operator] = ACTIONS(13326),
    [sym__times_operator] = ACTIONS(13326),
    [sym__rational_operator] = ACTIONS(13326),
    [sym__bitshift_operator] = ACTIONS(13326),
    [sym__power_operator] = ACTIONS(13326),
    [sym__tilde_operator] = ACTIONS(13326),
    [sym__type_order_operator] = ACTIONS(13326),
    [sym__unary_operator] = ACTIONS(13326),
    [sym__unary_plus_operator] = ACTIONS(13326),
    [aux_sym__terminator_token1] = ACTIONS(13326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13328),
    [sym__command_start] = ACTIONS(13328),
  },
  [9095] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12838),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12186),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9096] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_catch] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14798),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14798),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [9097] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_finally] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14487),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14905),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9098] = {
    [sym__word_identifier] = ACTIONS(13330),
    [anon_sym_EQ] = ACTIONS(13330),
    [anon_sym_COMMA] = ACTIONS(13330),
    [anon_sym_COLON] = ACTIONS(13330),
    [anon_sym_begin] = ACTIONS(13330),
    [anon_sym_module] = ACTIONS(13330),
    [anon_sym_baremodule] = ACTIONS(13330),
    [anon_sym_abstract] = ACTIONS(13330),
    [anon_sym_primitive] = ACTIONS(13330),
    [anon_sym_mutable] = ACTIONS(13330),
    [anon_sym_struct] = ACTIONS(13330),
    [anon_sym_function] = ACTIONS(13330),
    [anon_sym_macro] = ACTIONS(13330),
    [anon_sym_where] = ACTIONS(13330),
    [anon_sym_quote] = ACTIONS(13330),
    [anon_sym_let] = ACTIONS(13330),
    [anon_sym_if] = ACTIONS(13330),
    [anon_sym_try] = ACTIONS(13330),
    [anon_sym_for] = ACTIONS(13330),
    [anon_sym_while] = ACTIONS(13330),
    [sym_break_statement] = ACTIONS(13330),
    [sym_continue_statement] = ACTIONS(13330),
    [anon_sym_return] = ACTIONS(13330),
    [anon_sym_const] = ACTIONS(13330),
    [anon_sym_global] = ACTIONS(13330),
    [anon_sym_local] = ACTIONS(13330),
    [anon_sym_LPAREN] = ACTIONS(13330),
    [anon_sym_RPAREN] = ACTIONS(13330),
    [anon_sym_COLON2] = ACTIONS(13330),
    [anon_sym_export] = ACTIONS(13330),
    [anon_sym_import] = ACTIONS(13330),
    [anon_sym_using] = ACTIONS(13330),
    [anon_sym_LBRACK] = ACTIONS(13330),
    [anon_sym_LF] = ACTIONS(13332),
    [anon_sym_in] = ACTIONS(13330),
    [anon_sym_SEMI] = ACTIONS(13330),
    [anon_sym_LBRACE] = ACTIONS(13330),
    [anon_sym_DOLLAR] = ACTIONS(13330),
    [anon_sym_COLON_COLON] = ACTIONS(13330),
    [anon_sym_isa] = ACTIONS(13330),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13330),
    [anon_sym_QMARK] = ACTIONS(13330),
    [anon_sym_AT] = ACTIONS(13330),
    [anon_sym_true] = ACTIONS(13330),
    [anon_sym_false] = ACTIONS(13330),
    [aux_sym_integer_literal_token1] = ACTIONS(13330),
    [aux_sym_integer_literal_token2] = ACTIONS(13330),
    [aux_sym_integer_literal_token3] = ACTIONS(13330),
    [aux_sym_integer_literal_token4] = ACTIONS(13330),
    [aux_sym_float_literal_token1] = ACTIONS(13330),
    [aux_sym_float_literal_token3] = ACTIONS(13330),
    [aux_sym_float_literal_token4] = ACTIONS(13330),
    [sym_character_literal] = ACTIONS(13330),
    [sym__pair_operator] = ACTIONS(13330),
    [sym__arrow_operator] = ACTIONS(13330),
    [sym__lazy_or_operator] = ACTIONS(13330),
    [sym__lazy_and_operator] = ACTIONS(13330),
    [sym__comparison_operator] = ACTIONS(13330),
    [sym__pipe_right_operator] = ACTIONS(13330),
    [sym__pipe_left_operator] = ACTIONS(13330),
    [sym__ellipsis_operator] = ACTIONS(13330),
    [sym__plus_operator] = ACTIONS(13330),
    [sym__times_operator] = ACTIONS(13330),
    [sym__rational_operator] = ACTIONS(13330),
    [sym__bitshift_operator] = ACTIONS(13330),
    [sym__power_operator] = ACTIONS(13330),
    [sym__tilde_operator] = ACTIONS(13330),
    [sym__type_order_operator] = ACTIONS(13330),
    [sym__unary_operator] = ACTIONS(13330),
    [sym__unary_plus_operator] = ACTIONS(13330),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13332),
    [sym__command_start] = ACTIONS(13332),
  },
  [9099] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14782),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14792),
    [sym__pipe_left_operator] = ACTIONS(14794),
    [sym__ellipsis_operator] = ACTIONS(14796),
    [sym__plus_operator] = ACTIONS(14798),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14798),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9100] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9101] = {
    [sym__word_identifier] = ACTIONS(13562),
    [anon_sym_EQ] = ACTIONS(13562),
    [anon_sym_COMMA] = ACTIONS(13562),
    [anon_sym_COLON] = ACTIONS(13562),
    [anon_sym_begin] = ACTIONS(13562),
    [anon_sym_module] = ACTIONS(13562),
    [anon_sym_baremodule] = ACTIONS(13562),
    [anon_sym_end] = ACTIONS(13562),
    [anon_sym_abstract] = ACTIONS(13562),
    [anon_sym_primitive] = ACTIONS(13562),
    [anon_sym_mutable] = ACTIONS(13562),
    [anon_sym_struct] = ACTIONS(13562),
    [anon_sym_function] = ACTIONS(13562),
    [anon_sym_macro] = ACTIONS(13562),
    [anon_sym_where] = ACTIONS(13562),
    [anon_sym_quote] = ACTIONS(13562),
    [anon_sym_let] = ACTIONS(13562),
    [anon_sym_if] = ACTIONS(13562),
    [anon_sym_try] = ACTIONS(13562),
    [anon_sym_for] = ACTIONS(13562),
    [anon_sym_while] = ACTIONS(13562),
    [sym_break_statement] = ACTIONS(13562),
    [sym_continue_statement] = ACTIONS(13562),
    [anon_sym_return] = ACTIONS(13562),
    [anon_sym_const] = ACTIONS(13562),
    [anon_sym_global] = ACTIONS(13562),
    [anon_sym_local] = ACTIONS(13562),
    [anon_sym_LPAREN] = ACTIONS(13562),
    [anon_sym_COLON2] = ACTIONS(13562),
    [anon_sym_export] = ACTIONS(13562),
    [anon_sym_import] = ACTIONS(13562),
    [anon_sym_using] = ACTIONS(13562),
    [anon_sym_LBRACK] = ACTIONS(13562),
    [anon_sym_LF] = ACTIONS(13564),
    [anon_sym_in] = ACTIONS(13562),
    [anon_sym_LBRACE] = ACTIONS(13562),
    [anon_sym_DOLLAR] = ACTIONS(13562),
    [anon_sym_COLON_COLON] = ACTIONS(13562),
    [anon_sym_isa] = ACTIONS(13562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13562),
    [anon_sym_QMARK] = ACTIONS(13562),
    [anon_sym_AT] = ACTIONS(13562),
    [anon_sym_true] = ACTIONS(13562),
    [anon_sym_false] = ACTIONS(13562),
    [aux_sym_integer_literal_token1] = ACTIONS(13562),
    [aux_sym_integer_literal_token2] = ACTIONS(13562),
    [aux_sym_integer_literal_token3] = ACTIONS(13562),
    [aux_sym_integer_literal_token4] = ACTIONS(13562),
    [aux_sym_float_literal_token1] = ACTIONS(13562),
    [aux_sym_float_literal_token3] = ACTIONS(13562),
    [aux_sym_float_literal_token4] = ACTIONS(13562),
    [sym_character_literal] = ACTIONS(13562),
    [sym__pair_operator] = ACTIONS(13562),
    [sym__arrow_operator] = ACTIONS(13562),
    [sym__lazy_or_operator] = ACTIONS(13562),
    [sym__lazy_and_operator] = ACTIONS(13562),
    [sym__comparison_operator] = ACTIONS(13562),
    [sym__pipe_right_operator] = ACTIONS(13562),
    [sym__pipe_left_operator] = ACTIONS(13562),
    [sym__ellipsis_operator] = ACTIONS(13562),
    [sym__plus_operator] = ACTIONS(13562),
    [sym__times_operator] = ACTIONS(13562),
    [sym__rational_operator] = ACTIONS(13562),
    [sym__bitshift_operator] = ACTIONS(13562),
    [sym__power_operator] = ACTIONS(13562),
    [sym__tilde_operator] = ACTIONS(13562),
    [sym__type_order_operator] = ACTIONS(13562),
    [sym__unary_operator] = ACTIONS(13562),
    [sym__unary_plus_operator] = ACTIONS(13562),
    [aux_sym__terminator_token1] = ACTIONS(13562),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13564),
    [sym__command_start] = ACTIONS(13564),
  },
  [9102] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_RPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_SEMI] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14778),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9103] = {
    [sym__word_identifier] = ACTIONS(13346),
    [anon_sym_EQ] = ACTIONS(13346),
    [anon_sym_COMMA] = ACTIONS(13346),
    [anon_sym_COLON] = ACTIONS(13346),
    [anon_sym_begin] = ACTIONS(13346),
    [anon_sym_module] = ACTIONS(13346),
    [anon_sym_baremodule] = ACTIONS(13346),
    [anon_sym_abstract] = ACTIONS(13346),
    [anon_sym_primitive] = ACTIONS(13346),
    [anon_sym_mutable] = ACTIONS(13346),
    [anon_sym_struct] = ACTIONS(13346),
    [anon_sym_function] = ACTIONS(13346),
    [anon_sym_macro] = ACTIONS(13346),
    [anon_sym_where] = ACTIONS(13346),
    [anon_sym_quote] = ACTIONS(13346),
    [anon_sym_let] = ACTIONS(13346),
    [anon_sym_if] = ACTIONS(13346),
    [anon_sym_try] = ACTIONS(13346),
    [anon_sym_for] = ACTIONS(13346),
    [anon_sym_while] = ACTIONS(13346),
    [sym_break_statement] = ACTIONS(13346),
    [sym_continue_statement] = ACTIONS(13346),
    [anon_sym_return] = ACTIONS(13346),
    [anon_sym_const] = ACTIONS(13346),
    [anon_sym_global] = ACTIONS(13346),
    [anon_sym_local] = ACTIONS(13346),
    [anon_sym_LPAREN] = ACTIONS(13346),
    [anon_sym_RPAREN] = ACTIONS(13346),
    [anon_sym_COLON2] = ACTIONS(13346),
    [anon_sym_export] = ACTIONS(13346),
    [anon_sym_import] = ACTIONS(13346),
    [anon_sym_using] = ACTIONS(13346),
    [anon_sym_LBRACK] = ACTIONS(13346),
    [anon_sym_LF] = ACTIONS(13348),
    [anon_sym_in] = ACTIONS(13346),
    [anon_sym_SEMI] = ACTIONS(13346),
    [anon_sym_LBRACE] = ACTIONS(13346),
    [anon_sym_DOLLAR] = ACTIONS(13346),
    [anon_sym_COLON_COLON] = ACTIONS(13346),
    [anon_sym_isa] = ACTIONS(13346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13346),
    [anon_sym_QMARK] = ACTIONS(13346),
    [anon_sym_AT] = ACTIONS(13346),
    [anon_sym_true] = ACTIONS(13346),
    [anon_sym_false] = ACTIONS(13346),
    [aux_sym_integer_literal_token1] = ACTIONS(13346),
    [aux_sym_integer_literal_token2] = ACTIONS(13346),
    [aux_sym_integer_literal_token3] = ACTIONS(13346),
    [aux_sym_integer_literal_token4] = ACTIONS(13346),
    [aux_sym_float_literal_token1] = ACTIONS(13346),
    [aux_sym_float_literal_token3] = ACTIONS(13346),
    [aux_sym_float_literal_token4] = ACTIONS(13346),
    [sym_character_literal] = ACTIONS(13346),
    [sym__pair_operator] = ACTIONS(13346),
    [sym__arrow_operator] = ACTIONS(13346),
    [sym__lazy_or_operator] = ACTIONS(13346),
    [sym__lazy_and_operator] = ACTIONS(13346),
    [sym__comparison_operator] = ACTIONS(13346),
    [sym__pipe_right_operator] = ACTIONS(13346),
    [sym__pipe_left_operator] = ACTIONS(13346),
    [sym__ellipsis_operator] = ACTIONS(13346),
    [sym__plus_operator] = ACTIONS(13346),
    [sym__times_operator] = ACTIONS(13346),
    [sym__rational_operator] = ACTIONS(13346),
    [sym__bitshift_operator] = ACTIONS(13346),
    [sym__power_operator] = ACTIONS(13346),
    [sym__tilde_operator] = ACTIONS(13346),
    [sym__type_order_operator] = ACTIONS(13346),
    [sym__unary_operator] = ACTIONS(13346),
    [sym__unary_plus_operator] = ACTIONS(13346),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13348),
    [sym__command_start] = ACTIONS(13348),
  },
  [9104] = {
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13094),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_end] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(13094),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13094),
    [anon_sym_COLON2] = ACTIONS(13094),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13094),
    [anon_sym_LF] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(13094),
    [anon_sym_LBRACE] = ACTIONS(13094),
    [anon_sym_DOLLAR] = ACTIONS(13094),
    [anon_sym_COLON_COLON] = ACTIONS(13094),
    [anon_sym_isa] = ACTIONS(13094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13094),
    [anon_sym_QMARK] = ACTIONS(13094),
    [anon_sym_AT] = ACTIONS(13094),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13094),
    [aux_sym_integer_literal_token2] = ACTIONS(13094),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13094),
    [aux_sym_float_literal_token3] = ACTIONS(13094),
    [aux_sym_float_literal_token4] = ACTIONS(13094),
    [sym_character_literal] = ACTIONS(13094),
    [sym__pair_operator] = ACTIONS(13094),
    [sym__arrow_operator] = ACTIONS(13094),
    [sym__lazy_or_operator] = ACTIONS(13094),
    [sym__lazy_and_operator] = ACTIONS(13094),
    [sym__comparison_operator] = ACTIONS(13094),
    [sym__pipe_right_operator] = ACTIONS(13094),
    [sym__pipe_left_operator] = ACTIONS(13094),
    [sym__ellipsis_operator] = ACTIONS(13094),
    [sym__plus_operator] = ACTIONS(13094),
    [sym__times_operator] = ACTIONS(13094),
    [sym__rational_operator] = ACTIONS(13094),
    [sym__bitshift_operator] = ACTIONS(13094),
    [sym__power_operator] = ACTIONS(13094),
    [sym__tilde_operator] = ACTIONS(13094),
    [sym__type_order_operator] = ACTIONS(13094),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(13094),
    [aux_sym__terminator_token1] = ACTIONS(13094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [9105] = {
    [sym__word_identifier] = ACTIONS(13566),
    [anon_sym_EQ] = ACTIONS(13566),
    [anon_sym_COMMA] = ACTIONS(13566),
    [anon_sym_COLON] = ACTIONS(13566),
    [anon_sym_begin] = ACTIONS(13566),
    [anon_sym_module] = ACTIONS(13566),
    [anon_sym_baremodule] = ACTIONS(13566),
    [anon_sym_end] = ACTIONS(13566),
    [anon_sym_abstract] = ACTIONS(13566),
    [anon_sym_primitive] = ACTIONS(13566),
    [anon_sym_mutable] = ACTIONS(13566),
    [anon_sym_struct] = ACTIONS(13566),
    [anon_sym_function] = ACTIONS(13566),
    [anon_sym_macro] = ACTIONS(13566),
    [anon_sym_where] = ACTIONS(13566),
    [anon_sym_quote] = ACTIONS(13566),
    [anon_sym_let] = ACTIONS(13566),
    [anon_sym_if] = ACTIONS(13566),
    [anon_sym_try] = ACTIONS(13566),
    [anon_sym_for] = ACTIONS(13566),
    [anon_sym_while] = ACTIONS(13566),
    [sym_break_statement] = ACTIONS(13566),
    [sym_continue_statement] = ACTIONS(13566),
    [anon_sym_return] = ACTIONS(13566),
    [anon_sym_const] = ACTIONS(13566),
    [anon_sym_global] = ACTIONS(13566),
    [anon_sym_local] = ACTIONS(13566),
    [anon_sym_LPAREN] = ACTIONS(13566),
    [anon_sym_COLON2] = ACTIONS(13566),
    [anon_sym_export] = ACTIONS(13566),
    [anon_sym_import] = ACTIONS(13566),
    [anon_sym_using] = ACTIONS(13566),
    [anon_sym_LBRACK] = ACTIONS(13566),
    [anon_sym_LF] = ACTIONS(13568),
    [anon_sym_in] = ACTIONS(13566),
    [anon_sym_LBRACE] = ACTIONS(13566),
    [anon_sym_DOLLAR] = ACTIONS(13566),
    [anon_sym_COLON_COLON] = ACTIONS(13566),
    [anon_sym_isa] = ACTIONS(13566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13566),
    [anon_sym_QMARK] = ACTIONS(13566),
    [anon_sym_AT] = ACTIONS(13566),
    [anon_sym_true] = ACTIONS(13566),
    [anon_sym_false] = ACTIONS(13566),
    [aux_sym_integer_literal_token1] = ACTIONS(13566),
    [aux_sym_integer_literal_token2] = ACTIONS(13566),
    [aux_sym_integer_literal_token3] = ACTIONS(13566),
    [aux_sym_integer_literal_token4] = ACTIONS(13566),
    [aux_sym_float_literal_token1] = ACTIONS(13566),
    [aux_sym_float_literal_token3] = ACTIONS(13566),
    [aux_sym_float_literal_token4] = ACTIONS(13566),
    [sym_character_literal] = ACTIONS(13566),
    [sym__pair_operator] = ACTIONS(13566),
    [sym__arrow_operator] = ACTIONS(13566),
    [sym__lazy_or_operator] = ACTIONS(13566),
    [sym__lazy_and_operator] = ACTIONS(13566),
    [sym__comparison_operator] = ACTIONS(13566),
    [sym__pipe_right_operator] = ACTIONS(13566),
    [sym__pipe_left_operator] = ACTIONS(13566),
    [sym__ellipsis_operator] = ACTIONS(13566),
    [sym__plus_operator] = ACTIONS(13566),
    [sym__times_operator] = ACTIONS(13566),
    [sym__rational_operator] = ACTIONS(13566),
    [sym__bitshift_operator] = ACTIONS(13566),
    [sym__power_operator] = ACTIONS(13566),
    [sym__tilde_operator] = ACTIONS(13566),
    [sym__type_order_operator] = ACTIONS(13566),
    [sym__unary_operator] = ACTIONS(13566),
    [sym__unary_plus_operator] = ACTIONS(13566),
    [aux_sym__terminator_token1] = ACTIONS(13566),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13568),
    [sym__command_start] = ACTIONS(13568),
  },
  [9106] = {
    [sym__word_identifier] = ACTIONS(13570),
    [anon_sym_EQ] = ACTIONS(13570),
    [anon_sym_COMMA] = ACTIONS(13570),
    [anon_sym_COLON] = ACTIONS(13570),
    [anon_sym_begin] = ACTIONS(13570),
    [anon_sym_module] = ACTIONS(13570),
    [anon_sym_baremodule] = ACTIONS(13570),
    [anon_sym_end] = ACTIONS(13570),
    [anon_sym_abstract] = ACTIONS(13570),
    [anon_sym_primitive] = ACTIONS(13570),
    [anon_sym_mutable] = ACTIONS(13570),
    [anon_sym_struct] = ACTIONS(13570),
    [anon_sym_function] = ACTIONS(13570),
    [anon_sym_macro] = ACTIONS(13570),
    [anon_sym_where] = ACTIONS(13570),
    [anon_sym_quote] = ACTIONS(13570),
    [anon_sym_let] = ACTIONS(13570),
    [anon_sym_if] = ACTIONS(13570),
    [anon_sym_try] = ACTIONS(13570),
    [anon_sym_for] = ACTIONS(13570),
    [anon_sym_while] = ACTIONS(13570),
    [sym_break_statement] = ACTIONS(13570),
    [sym_continue_statement] = ACTIONS(13570),
    [anon_sym_return] = ACTIONS(13570),
    [anon_sym_const] = ACTIONS(13570),
    [anon_sym_global] = ACTIONS(13570),
    [anon_sym_local] = ACTIONS(13570),
    [anon_sym_LPAREN] = ACTIONS(13570),
    [anon_sym_COLON2] = ACTIONS(13570),
    [anon_sym_export] = ACTIONS(13570),
    [anon_sym_import] = ACTIONS(13570),
    [anon_sym_using] = ACTIONS(13570),
    [anon_sym_LBRACK] = ACTIONS(13570),
    [anon_sym_LF] = ACTIONS(13572),
    [anon_sym_in] = ACTIONS(13570),
    [anon_sym_LBRACE] = ACTIONS(13570),
    [anon_sym_DOLLAR] = ACTIONS(13570),
    [anon_sym_COLON_COLON] = ACTIONS(13570),
    [anon_sym_isa] = ACTIONS(13570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13570),
    [anon_sym_QMARK] = ACTIONS(13570),
    [anon_sym_AT] = ACTIONS(13570),
    [anon_sym_true] = ACTIONS(13570),
    [anon_sym_false] = ACTIONS(13570),
    [aux_sym_integer_literal_token1] = ACTIONS(13570),
    [aux_sym_integer_literal_token2] = ACTIONS(13570),
    [aux_sym_integer_literal_token3] = ACTIONS(13570),
    [aux_sym_integer_literal_token4] = ACTIONS(13570),
    [aux_sym_float_literal_token1] = ACTIONS(13570),
    [aux_sym_float_literal_token3] = ACTIONS(13570),
    [aux_sym_float_literal_token4] = ACTIONS(13570),
    [sym_character_literal] = ACTIONS(13570),
    [sym__pair_operator] = ACTIONS(13570),
    [sym__arrow_operator] = ACTIONS(13570),
    [sym__lazy_or_operator] = ACTIONS(13570),
    [sym__lazy_and_operator] = ACTIONS(13570),
    [sym__comparison_operator] = ACTIONS(13570),
    [sym__pipe_right_operator] = ACTIONS(13570),
    [sym__pipe_left_operator] = ACTIONS(13570),
    [sym__ellipsis_operator] = ACTIONS(13570),
    [sym__plus_operator] = ACTIONS(13570),
    [sym__times_operator] = ACTIONS(13570),
    [sym__rational_operator] = ACTIONS(13570),
    [sym__bitshift_operator] = ACTIONS(13570),
    [sym__power_operator] = ACTIONS(13570),
    [sym__tilde_operator] = ACTIONS(13570),
    [sym__type_order_operator] = ACTIONS(13570),
    [sym__unary_operator] = ACTIONS(13570),
    [sym__unary_plus_operator] = ACTIONS(13570),
    [aux_sym__terminator_token1] = ACTIONS(13570),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13572),
    [sym__command_start] = ACTIONS(13572),
  },
  [9107] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14780),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_catch] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14782),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14784),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_isa] = ACTIONS(14784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14453),
    [anon_sym_QMARK] = ACTIONS(14612),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14866),
    [sym__arrow_operator] = ACTIONS(14786),
    [sym__lazy_or_operator] = ACTIONS(14788),
    [sym__lazy_and_operator] = ACTIONS(14790),
    [sym__comparison_operator] = ACTIONS(14784),
    [sym__pipe_right_operator] = ACTIONS(14792),
    [sym__pipe_left_operator] = ACTIONS(14794),
    [sym__ellipsis_operator] = ACTIONS(14796),
    [sym__plus_operator] = ACTIONS(14798),
    [sym__times_operator] = ACTIONS(14800),
    [sym__rational_operator] = ACTIONS(14802),
    [sym__bitshift_operator] = ACTIONS(14804),
    [sym__power_operator] = ACTIONS(14806),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14784),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14798),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9108] = {
    [sym__word_identifier] = ACTIONS(13574),
    [anon_sym_EQ] = ACTIONS(13574),
    [anon_sym_COMMA] = ACTIONS(13574),
    [anon_sym_COLON] = ACTIONS(13574),
    [anon_sym_begin] = ACTIONS(13574),
    [anon_sym_module] = ACTIONS(13574),
    [anon_sym_baremodule] = ACTIONS(13574),
    [anon_sym_end] = ACTIONS(13574),
    [anon_sym_abstract] = ACTIONS(13574),
    [anon_sym_primitive] = ACTIONS(13574),
    [anon_sym_mutable] = ACTIONS(13574),
    [anon_sym_struct] = ACTIONS(13574),
    [anon_sym_function] = ACTIONS(13574),
    [anon_sym_macro] = ACTIONS(13574),
    [anon_sym_where] = ACTIONS(13574),
    [anon_sym_quote] = ACTIONS(13574),
    [anon_sym_let] = ACTIONS(13574),
    [anon_sym_if] = ACTIONS(13574),
    [anon_sym_try] = ACTIONS(13574),
    [anon_sym_for] = ACTIONS(13574),
    [anon_sym_while] = ACTIONS(13574),
    [sym_break_statement] = ACTIONS(13574),
    [sym_continue_statement] = ACTIONS(13574),
    [anon_sym_return] = ACTIONS(13574),
    [anon_sym_const] = ACTIONS(13574),
    [anon_sym_global] = ACTIONS(13574),
    [anon_sym_local] = ACTIONS(13574),
    [anon_sym_LPAREN] = ACTIONS(13574),
    [anon_sym_COLON2] = ACTIONS(13574),
    [anon_sym_export] = ACTIONS(13574),
    [anon_sym_import] = ACTIONS(13574),
    [anon_sym_using] = ACTIONS(13574),
    [anon_sym_LBRACK] = ACTIONS(13574),
    [anon_sym_LF] = ACTIONS(13576),
    [anon_sym_in] = ACTIONS(13574),
    [anon_sym_LBRACE] = ACTIONS(13574),
    [anon_sym_DOLLAR] = ACTIONS(13574),
    [anon_sym_COLON_COLON] = ACTIONS(13574),
    [anon_sym_isa] = ACTIONS(13574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13574),
    [anon_sym_QMARK] = ACTIONS(13574),
    [anon_sym_AT] = ACTIONS(13574),
    [anon_sym_true] = ACTIONS(13574),
    [anon_sym_false] = ACTIONS(13574),
    [aux_sym_integer_literal_token1] = ACTIONS(13574),
    [aux_sym_integer_literal_token2] = ACTIONS(13574),
    [aux_sym_integer_literal_token3] = ACTIONS(13574),
    [aux_sym_integer_literal_token4] = ACTIONS(13574),
    [aux_sym_float_literal_token1] = ACTIONS(13574),
    [aux_sym_float_literal_token3] = ACTIONS(13574),
    [aux_sym_float_literal_token4] = ACTIONS(13574),
    [sym_character_literal] = ACTIONS(13574),
    [sym__pair_operator] = ACTIONS(13574),
    [sym__arrow_operator] = ACTIONS(13574),
    [sym__lazy_or_operator] = ACTIONS(13574),
    [sym__lazy_and_operator] = ACTIONS(13574),
    [sym__comparison_operator] = ACTIONS(13574),
    [sym__pipe_right_operator] = ACTIONS(13574),
    [sym__pipe_left_operator] = ACTIONS(13574),
    [sym__ellipsis_operator] = ACTIONS(13574),
    [sym__plus_operator] = ACTIONS(13574),
    [sym__times_operator] = ACTIONS(13574),
    [sym__rational_operator] = ACTIONS(13574),
    [sym__bitshift_operator] = ACTIONS(13574),
    [sym__power_operator] = ACTIONS(13574),
    [sym__tilde_operator] = ACTIONS(13574),
    [sym__type_order_operator] = ACTIONS(13574),
    [sym__unary_operator] = ACTIONS(13574),
    [sym__unary_plus_operator] = ACTIONS(13574),
    [aux_sym__terminator_token1] = ACTIONS(13574),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13576),
    [sym__command_start] = ACTIONS(13576),
  },
  [9109] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DASH_GT] = ACTIONS(12382),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9110] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [9111] = {
    [sym__word_identifier] = ACTIONS(13578),
    [anon_sym_EQ] = ACTIONS(13578),
    [anon_sym_COMMA] = ACTIONS(13578),
    [anon_sym_COLON] = ACTIONS(13578),
    [anon_sym_begin] = ACTIONS(13578),
    [anon_sym_module] = ACTIONS(13578),
    [anon_sym_baremodule] = ACTIONS(13578),
    [anon_sym_end] = ACTIONS(13578),
    [anon_sym_abstract] = ACTIONS(13578),
    [anon_sym_primitive] = ACTIONS(13578),
    [anon_sym_mutable] = ACTIONS(13578),
    [anon_sym_struct] = ACTIONS(13578),
    [anon_sym_function] = ACTIONS(13578),
    [anon_sym_macro] = ACTIONS(13578),
    [anon_sym_where] = ACTIONS(13578),
    [anon_sym_quote] = ACTIONS(13578),
    [anon_sym_let] = ACTIONS(13578),
    [anon_sym_if] = ACTIONS(13578),
    [anon_sym_try] = ACTIONS(13578),
    [anon_sym_for] = ACTIONS(13578),
    [anon_sym_while] = ACTIONS(13578),
    [sym_break_statement] = ACTIONS(13578),
    [sym_continue_statement] = ACTIONS(13578),
    [anon_sym_return] = ACTIONS(13578),
    [anon_sym_const] = ACTIONS(13578),
    [anon_sym_global] = ACTIONS(13578),
    [anon_sym_local] = ACTIONS(13578),
    [anon_sym_LPAREN] = ACTIONS(13578),
    [anon_sym_COLON2] = ACTIONS(13578),
    [anon_sym_export] = ACTIONS(13578),
    [anon_sym_import] = ACTIONS(13578),
    [anon_sym_using] = ACTIONS(13578),
    [anon_sym_LBRACK] = ACTIONS(13578),
    [anon_sym_LF] = ACTIONS(13580),
    [anon_sym_in] = ACTIONS(13578),
    [anon_sym_LBRACE] = ACTIONS(13578),
    [anon_sym_DOLLAR] = ACTIONS(13578),
    [anon_sym_COLON_COLON] = ACTIONS(13578),
    [anon_sym_isa] = ACTIONS(13578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13578),
    [anon_sym_QMARK] = ACTIONS(13578),
    [anon_sym_AT] = ACTIONS(13578),
    [anon_sym_true] = ACTIONS(13578),
    [anon_sym_false] = ACTIONS(13578),
    [aux_sym_integer_literal_token1] = ACTIONS(13578),
    [aux_sym_integer_literal_token2] = ACTIONS(13578),
    [aux_sym_integer_literal_token3] = ACTIONS(13578),
    [aux_sym_integer_literal_token4] = ACTIONS(13578),
    [aux_sym_float_literal_token1] = ACTIONS(13578),
    [aux_sym_float_literal_token3] = ACTIONS(13578),
    [aux_sym_float_literal_token4] = ACTIONS(13578),
    [sym_character_literal] = ACTIONS(13578),
    [sym__pair_operator] = ACTIONS(13578),
    [sym__arrow_operator] = ACTIONS(13578),
    [sym__lazy_or_operator] = ACTIONS(13578),
    [sym__lazy_and_operator] = ACTIONS(13578),
    [sym__comparison_operator] = ACTIONS(13578),
    [sym__pipe_right_operator] = ACTIONS(13578),
    [sym__pipe_left_operator] = ACTIONS(13578),
    [sym__ellipsis_operator] = ACTIONS(13578),
    [sym__plus_operator] = ACTIONS(13578),
    [sym__times_operator] = ACTIONS(13578),
    [sym__rational_operator] = ACTIONS(13578),
    [sym__bitshift_operator] = ACTIONS(13578),
    [sym__power_operator] = ACTIONS(13578),
    [sym__tilde_operator] = ACTIONS(13578),
    [sym__type_order_operator] = ACTIONS(13578),
    [sym__unary_operator] = ACTIONS(13578),
    [sym__unary_plus_operator] = ACTIONS(13578),
    [aux_sym__terminator_token1] = ACTIONS(13578),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13580),
    [sym__command_start] = ACTIONS(13580),
  },
  [9112] = {
    [sym__word_identifier] = ACTIONS(13582),
    [anon_sym_EQ] = ACTIONS(13582),
    [anon_sym_COMMA] = ACTIONS(13582),
    [anon_sym_COLON] = ACTIONS(13582),
    [anon_sym_begin] = ACTIONS(13582),
    [anon_sym_module] = ACTIONS(13582),
    [anon_sym_baremodule] = ACTIONS(13582),
    [anon_sym_end] = ACTIONS(13582),
    [anon_sym_abstract] = ACTIONS(13582),
    [anon_sym_primitive] = ACTIONS(13582),
    [anon_sym_mutable] = ACTIONS(13582),
    [anon_sym_struct] = ACTIONS(13582),
    [anon_sym_function] = ACTIONS(13582),
    [anon_sym_macro] = ACTIONS(13582),
    [anon_sym_where] = ACTIONS(13582),
    [anon_sym_quote] = ACTIONS(13582),
    [anon_sym_let] = ACTIONS(13582),
    [anon_sym_if] = ACTIONS(13582),
    [anon_sym_try] = ACTIONS(13582),
    [anon_sym_for] = ACTIONS(13582),
    [anon_sym_while] = ACTIONS(13582),
    [sym_break_statement] = ACTIONS(13582),
    [sym_continue_statement] = ACTIONS(13582),
    [anon_sym_return] = ACTIONS(13582),
    [anon_sym_const] = ACTIONS(13582),
    [anon_sym_global] = ACTIONS(13582),
    [anon_sym_local] = ACTIONS(13582),
    [anon_sym_LPAREN] = ACTIONS(13582),
    [anon_sym_COLON2] = ACTIONS(13582),
    [anon_sym_export] = ACTIONS(13582),
    [anon_sym_import] = ACTIONS(13582),
    [anon_sym_using] = ACTIONS(13582),
    [anon_sym_LBRACK] = ACTIONS(13582),
    [anon_sym_LF] = ACTIONS(13584),
    [anon_sym_in] = ACTIONS(13582),
    [anon_sym_LBRACE] = ACTIONS(13582),
    [anon_sym_DOLLAR] = ACTIONS(13582),
    [anon_sym_COLON_COLON] = ACTIONS(13582),
    [anon_sym_isa] = ACTIONS(13582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13582),
    [anon_sym_QMARK] = ACTIONS(13582),
    [anon_sym_AT] = ACTIONS(13582),
    [anon_sym_true] = ACTIONS(13582),
    [anon_sym_false] = ACTIONS(13582),
    [aux_sym_integer_literal_token1] = ACTIONS(13582),
    [aux_sym_integer_literal_token2] = ACTIONS(13582),
    [aux_sym_integer_literal_token3] = ACTIONS(13582),
    [aux_sym_integer_literal_token4] = ACTIONS(13582),
    [aux_sym_float_literal_token1] = ACTIONS(13582),
    [aux_sym_float_literal_token3] = ACTIONS(13582),
    [aux_sym_float_literal_token4] = ACTIONS(13582),
    [sym_character_literal] = ACTIONS(13582),
    [sym__pair_operator] = ACTIONS(13582),
    [sym__arrow_operator] = ACTIONS(13582),
    [sym__lazy_or_operator] = ACTIONS(13582),
    [sym__lazy_and_operator] = ACTIONS(13582),
    [sym__comparison_operator] = ACTIONS(13582),
    [sym__pipe_right_operator] = ACTIONS(13582),
    [sym__pipe_left_operator] = ACTIONS(13582),
    [sym__ellipsis_operator] = ACTIONS(13582),
    [sym__plus_operator] = ACTIONS(13582),
    [sym__times_operator] = ACTIONS(13582),
    [sym__rational_operator] = ACTIONS(13582),
    [sym__bitshift_operator] = ACTIONS(13582),
    [sym__power_operator] = ACTIONS(13582),
    [sym__tilde_operator] = ACTIONS(13582),
    [sym__type_order_operator] = ACTIONS(13582),
    [sym__unary_operator] = ACTIONS(13582),
    [sym__unary_plus_operator] = ACTIONS(13582),
    [aux_sym__terminator_token1] = ACTIONS(13582),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13584),
    [sym__command_start] = ACTIONS(13584),
  },
  [9113] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(12724),
    [anon_sym_COMMA] = ACTIONS(13243),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(13243),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13243),
    [anon_sym_QMARK] = ACTIONS(13243),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(13243),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13243),
    [sym__lazy_and_operator] = ACTIONS(13243),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13243),
    [sym__pipe_left_operator] = ACTIONS(13243),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13243),
    [sym__bitshift_operator] = ACTIONS(13243),
    [sym__power_operator] = ACTIONS(13243),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(13243),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [9114] = {
    [sym__word_identifier] = ACTIONS(13586),
    [anon_sym_EQ] = ACTIONS(13586),
    [anon_sym_COMMA] = ACTIONS(13586),
    [anon_sym_COLON] = ACTIONS(13586),
    [anon_sym_begin] = ACTIONS(13586),
    [anon_sym_module] = ACTIONS(13586),
    [anon_sym_baremodule] = ACTIONS(13586),
    [anon_sym_end] = ACTIONS(13586),
    [anon_sym_abstract] = ACTIONS(13586),
    [anon_sym_primitive] = ACTIONS(13586),
    [anon_sym_mutable] = ACTIONS(13586),
    [anon_sym_struct] = ACTIONS(13586),
    [anon_sym_function] = ACTIONS(13586),
    [anon_sym_macro] = ACTIONS(13586),
    [anon_sym_where] = ACTIONS(13586),
    [anon_sym_quote] = ACTIONS(13586),
    [anon_sym_let] = ACTIONS(13586),
    [anon_sym_if] = ACTIONS(13586),
    [anon_sym_try] = ACTIONS(13586),
    [anon_sym_for] = ACTIONS(13586),
    [anon_sym_while] = ACTIONS(13586),
    [sym_break_statement] = ACTIONS(13586),
    [sym_continue_statement] = ACTIONS(13586),
    [anon_sym_return] = ACTIONS(13586),
    [anon_sym_const] = ACTIONS(13586),
    [anon_sym_global] = ACTIONS(13586),
    [anon_sym_local] = ACTIONS(13586),
    [anon_sym_LPAREN] = ACTIONS(13586),
    [anon_sym_COLON2] = ACTIONS(13586),
    [anon_sym_export] = ACTIONS(13586),
    [anon_sym_import] = ACTIONS(13586),
    [anon_sym_using] = ACTIONS(13586),
    [anon_sym_LBRACK] = ACTIONS(13586),
    [anon_sym_LF] = ACTIONS(13588),
    [anon_sym_in] = ACTIONS(13586),
    [anon_sym_LBRACE] = ACTIONS(13586),
    [anon_sym_DOLLAR] = ACTIONS(13586),
    [anon_sym_COLON_COLON] = ACTIONS(13586),
    [anon_sym_isa] = ACTIONS(13586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13586),
    [anon_sym_QMARK] = ACTIONS(13586),
    [anon_sym_AT] = ACTIONS(13586),
    [anon_sym_true] = ACTIONS(13586),
    [anon_sym_false] = ACTIONS(13586),
    [aux_sym_integer_literal_token1] = ACTIONS(13586),
    [aux_sym_integer_literal_token2] = ACTIONS(13586),
    [aux_sym_integer_literal_token3] = ACTIONS(13586),
    [aux_sym_integer_literal_token4] = ACTIONS(13586),
    [aux_sym_float_literal_token1] = ACTIONS(13586),
    [aux_sym_float_literal_token3] = ACTIONS(13586),
    [aux_sym_float_literal_token4] = ACTIONS(13586),
    [sym_character_literal] = ACTIONS(13586),
    [sym__pair_operator] = ACTIONS(13586),
    [sym__arrow_operator] = ACTIONS(13586),
    [sym__lazy_or_operator] = ACTIONS(13586),
    [sym__lazy_and_operator] = ACTIONS(13586),
    [sym__comparison_operator] = ACTIONS(13586),
    [sym__pipe_right_operator] = ACTIONS(13586),
    [sym__pipe_left_operator] = ACTIONS(13586),
    [sym__ellipsis_operator] = ACTIONS(13586),
    [sym__plus_operator] = ACTIONS(13586),
    [sym__times_operator] = ACTIONS(13586),
    [sym__rational_operator] = ACTIONS(13586),
    [sym__bitshift_operator] = ACTIONS(13586),
    [sym__power_operator] = ACTIONS(13586),
    [sym__tilde_operator] = ACTIONS(13586),
    [sym__type_order_operator] = ACTIONS(13586),
    [sym__unary_operator] = ACTIONS(13586),
    [sym__unary_plus_operator] = ACTIONS(13586),
    [aux_sym__terminator_token1] = ACTIONS(13586),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13588),
    [sym__command_start] = ACTIONS(13588),
  },
  [9115] = {
    [aux_sym_open_tuple_repeat1] = STATE(8299),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(14604),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_end] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13243),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13243),
    [anon_sym_LF] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(13243),
    [anon_sym_DOLLAR] = ACTIONS(13243),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(13243),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13243),
    [aux_sym_integer_literal_token2] = ACTIONS(13243),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13243),
    [aux_sym_float_literal_token3] = ACTIONS(13243),
    [aux_sym_float_literal_token4] = ACTIONS(13243),
    [sym_character_literal] = ACTIONS(13243),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13243),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [9116] = {
    [sym__word_identifier] = ACTIONS(13590),
    [anon_sym_EQ] = ACTIONS(13590),
    [anon_sym_COMMA] = ACTIONS(13590),
    [anon_sym_COLON] = ACTIONS(13590),
    [anon_sym_begin] = ACTIONS(13590),
    [anon_sym_module] = ACTIONS(13590),
    [anon_sym_baremodule] = ACTIONS(13590),
    [anon_sym_end] = ACTIONS(13590),
    [anon_sym_abstract] = ACTIONS(13590),
    [anon_sym_primitive] = ACTIONS(13590),
    [anon_sym_mutable] = ACTIONS(13590),
    [anon_sym_struct] = ACTIONS(13590),
    [anon_sym_function] = ACTIONS(13590),
    [anon_sym_macro] = ACTIONS(13590),
    [anon_sym_where] = ACTIONS(13590),
    [anon_sym_quote] = ACTIONS(13590),
    [anon_sym_let] = ACTIONS(13590),
    [anon_sym_if] = ACTIONS(13590),
    [anon_sym_try] = ACTIONS(13590),
    [anon_sym_for] = ACTIONS(13590),
    [anon_sym_while] = ACTIONS(13590),
    [sym_break_statement] = ACTIONS(13590),
    [sym_continue_statement] = ACTIONS(13590),
    [anon_sym_return] = ACTIONS(13590),
    [anon_sym_const] = ACTIONS(13590),
    [anon_sym_global] = ACTIONS(13590),
    [anon_sym_local] = ACTIONS(13590),
    [anon_sym_LPAREN] = ACTIONS(13590),
    [anon_sym_COLON2] = ACTIONS(13590),
    [anon_sym_export] = ACTIONS(13590),
    [anon_sym_import] = ACTIONS(13590),
    [anon_sym_using] = ACTIONS(13590),
    [anon_sym_LBRACK] = ACTIONS(13590),
    [anon_sym_LF] = ACTIONS(13592),
    [anon_sym_in] = ACTIONS(13590),
    [anon_sym_LBRACE] = ACTIONS(13590),
    [anon_sym_DOLLAR] = ACTIONS(13590),
    [anon_sym_COLON_COLON] = ACTIONS(13590),
    [anon_sym_isa] = ACTIONS(13590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13590),
    [anon_sym_QMARK] = ACTIONS(13590),
    [anon_sym_AT] = ACTIONS(13590),
    [anon_sym_true] = ACTIONS(13590),
    [anon_sym_false] = ACTIONS(13590),
    [aux_sym_integer_literal_token1] = ACTIONS(13590),
    [aux_sym_integer_literal_token2] = ACTIONS(13590),
    [aux_sym_integer_literal_token3] = ACTIONS(13590),
    [aux_sym_integer_literal_token4] = ACTIONS(13590),
    [aux_sym_float_literal_token1] = ACTIONS(13590),
    [aux_sym_float_literal_token3] = ACTIONS(13590),
    [aux_sym_float_literal_token4] = ACTIONS(13590),
    [sym_character_literal] = ACTIONS(13590),
    [sym__pair_operator] = ACTIONS(13590),
    [sym__arrow_operator] = ACTIONS(13590),
    [sym__lazy_or_operator] = ACTIONS(13590),
    [sym__lazy_and_operator] = ACTIONS(13590),
    [sym__comparison_operator] = ACTIONS(13590),
    [sym__pipe_right_operator] = ACTIONS(13590),
    [sym__pipe_left_operator] = ACTIONS(13590),
    [sym__ellipsis_operator] = ACTIONS(13590),
    [sym__plus_operator] = ACTIONS(13590),
    [sym__times_operator] = ACTIONS(13590),
    [sym__rational_operator] = ACTIONS(13590),
    [sym__bitshift_operator] = ACTIONS(13590),
    [sym__power_operator] = ACTIONS(13590),
    [sym__tilde_operator] = ACTIONS(13590),
    [sym__type_order_operator] = ACTIONS(13590),
    [sym__unary_operator] = ACTIONS(13590),
    [sym__unary_plus_operator] = ACTIONS(13590),
    [aux_sym__terminator_token1] = ACTIONS(13590),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13592),
    [sym__command_start] = ACTIONS(13592),
  },
  [9117] = {
    [sym__word_identifier] = ACTIONS(13358),
    [anon_sym_EQ] = ACTIONS(13358),
    [anon_sym_COMMA] = ACTIONS(13358),
    [anon_sym_COLON] = ACTIONS(13358),
    [anon_sym_begin] = ACTIONS(13358),
    [anon_sym_module] = ACTIONS(13358),
    [anon_sym_baremodule] = ACTIONS(13358),
    [anon_sym_abstract] = ACTIONS(13358),
    [anon_sym_primitive] = ACTIONS(13358),
    [anon_sym_mutable] = ACTIONS(13358),
    [anon_sym_struct] = ACTIONS(13358),
    [anon_sym_function] = ACTIONS(13358),
    [anon_sym_macro] = ACTIONS(13358),
    [anon_sym_where] = ACTIONS(13358),
    [anon_sym_quote] = ACTIONS(13358),
    [anon_sym_let] = ACTIONS(13358),
    [anon_sym_if] = ACTIONS(13358),
    [anon_sym_try] = ACTIONS(13358),
    [anon_sym_for] = ACTIONS(13358),
    [anon_sym_while] = ACTIONS(13358),
    [sym_break_statement] = ACTIONS(13358),
    [sym_continue_statement] = ACTIONS(13358),
    [anon_sym_return] = ACTIONS(13358),
    [anon_sym_const] = ACTIONS(13358),
    [anon_sym_global] = ACTIONS(13358),
    [anon_sym_local] = ACTIONS(13358),
    [anon_sym_LPAREN] = ACTIONS(13358),
    [anon_sym_RPAREN] = ACTIONS(13358),
    [anon_sym_COLON2] = ACTIONS(13358),
    [anon_sym_export] = ACTIONS(13358),
    [anon_sym_import] = ACTIONS(13358),
    [anon_sym_using] = ACTIONS(13358),
    [anon_sym_LBRACK] = ACTIONS(13358),
    [anon_sym_LF] = ACTIONS(13360),
    [anon_sym_in] = ACTIONS(13358),
    [anon_sym_SEMI] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(13358),
    [anon_sym_DOLLAR] = ACTIONS(13358),
    [anon_sym_COLON_COLON] = ACTIONS(13358),
    [anon_sym_isa] = ACTIONS(13358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13358),
    [anon_sym_QMARK] = ACTIONS(13358),
    [anon_sym_AT] = ACTIONS(13358),
    [anon_sym_true] = ACTIONS(13358),
    [anon_sym_false] = ACTIONS(13358),
    [aux_sym_integer_literal_token1] = ACTIONS(13358),
    [aux_sym_integer_literal_token2] = ACTIONS(13358),
    [aux_sym_integer_literal_token3] = ACTIONS(13358),
    [aux_sym_integer_literal_token4] = ACTIONS(13358),
    [aux_sym_float_literal_token1] = ACTIONS(13358),
    [aux_sym_float_literal_token3] = ACTIONS(13358),
    [aux_sym_float_literal_token4] = ACTIONS(13358),
    [sym_character_literal] = ACTIONS(13358),
    [sym__pair_operator] = ACTIONS(13358),
    [sym__arrow_operator] = ACTIONS(13358),
    [sym__lazy_or_operator] = ACTIONS(13358),
    [sym__lazy_and_operator] = ACTIONS(13358),
    [sym__comparison_operator] = ACTIONS(13358),
    [sym__pipe_right_operator] = ACTIONS(13358),
    [sym__pipe_left_operator] = ACTIONS(13358),
    [sym__ellipsis_operator] = ACTIONS(13358),
    [sym__plus_operator] = ACTIONS(13358),
    [sym__times_operator] = ACTIONS(13358),
    [sym__rational_operator] = ACTIONS(13358),
    [sym__bitshift_operator] = ACTIONS(13358),
    [sym__power_operator] = ACTIONS(13358),
    [sym__tilde_operator] = ACTIONS(13358),
    [sym__type_order_operator] = ACTIONS(13358),
    [sym__unary_operator] = ACTIONS(13358),
    [sym__unary_plus_operator] = ACTIONS(13358),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13360),
    [sym__command_start] = ACTIONS(13360),
  },
  [9118] = {
    [sym__word_identifier] = ACTIONS(13594),
    [anon_sym_EQ] = ACTIONS(13594),
    [anon_sym_COMMA] = ACTIONS(13594),
    [anon_sym_COLON] = ACTIONS(13594),
    [anon_sym_begin] = ACTIONS(13594),
    [anon_sym_module] = ACTIONS(13594),
    [anon_sym_baremodule] = ACTIONS(13594),
    [anon_sym_end] = ACTIONS(13594),
    [anon_sym_abstract] = ACTIONS(13594),
    [anon_sym_primitive] = ACTIONS(13594),
    [anon_sym_mutable] = ACTIONS(13594),
    [anon_sym_struct] = ACTIONS(13594),
    [anon_sym_function] = ACTIONS(13594),
    [anon_sym_macro] = ACTIONS(13594),
    [anon_sym_where] = ACTIONS(13594),
    [anon_sym_quote] = ACTIONS(13594),
    [anon_sym_let] = ACTIONS(13594),
    [anon_sym_if] = ACTIONS(13594),
    [anon_sym_try] = ACTIONS(13594),
    [anon_sym_for] = ACTIONS(13594),
    [anon_sym_while] = ACTIONS(13594),
    [sym_break_statement] = ACTIONS(13594),
    [sym_continue_statement] = ACTIONS(13594),
    [anon_sym_return] = ACTIONS(13594),
    [anon_sym_const] = ACTIONS(13594),
    [anon_sym_global] = ACTIONS(13594),
    [anon_sym_local] = ACTIONS(13594),
    [anon_sym_LPAREN] = ACTIONS(13594),
    [anon_sym_COLON2] = ACTIONS(13594),
    [anon_sym_export] = ACTIONS(13594),
    [anon_sym_import] = ACTIONS(13594),
    [anon_sym_using] = ACTIONS(13594),
    [anon_sym_LBRACK] = ACTIONS(13594),
    [anon_sym_LF] = ACTIONS(13596),
    [anon_sym_in] = ACTIONS(13594),
    [anon_sym_LBRACE] = ACTIONS(13594),
    [anon_sym_DOLLAR] = ACTIONS(13594),
    [anon_sym_COLON_COLON] = ACTIONS(13594),
    [anon_sym_isa] = ACTIONS(13594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13594),
    [anon_sym_QMARK] = ACTIONS(13594),
    [anon_sym_AT] = ACTIONS(13594),
    [anon_sym_true] = ACTIONS(13594),
    [anon_sym_false] = ACTIONS(13594),
    [aux_sym_integer_literal_token1] = ACTIONS(13594),
    [aux_sym_integer_literal_token2] = ACTIONS(13594),
    [aux_sym_integer_literal_token3] = ACTIONS(13594),
    [aux_sym_integer_literal_token4] = ACTIONS(13594),
    [aux_sym_float_literal_token1] = ACTIONS(13594),
    [aux_sym_float_literal_token3] = ACTIONS(13594),
    [aux_sym_float_literal_token4] = ACTIONS(13594),
    [sym_character_literal] = ACTIONS(13594),
    [sym__pair_operator] = ACTIONS(13594),
    [sym__arrow_operator] = ACTIONS(13594),
    [sym__lazy_or_operator] = ACTIONS(13594),
    [sym__lazy_and_operator] = ACTIONS(13594),
    [sym__comparison_operator] = ACTIONS(13594),
    [sym__pipe_right_operator] = ACTIONS(13594),
    [sym__pipe_left_operator] = ACTIONS(13594),
    [sym__ellipsis_operator] = ACTIONS(13594),
    [sym__plus_operator] = ACTIONS(13594),
    [sym__times_operator] = ACTIONS(13594),
    [sym__rational_operator] = ACTIONS(13594),
    [sym__bitshift_operator] = ACTIONS(13594),
    [sym__power_operator] = ACTIONS(13594),
    [sym__tilde_operator] = ACTIONS(13594),
    [sym__type_order_operator] = ACTIONS(13594),
    [sym__unary_operator] = ACTIONS(13594),
    [sym__unary_plus_operator] = ACTIONS(13594),
    [aux_sym__terminator_token1] = ACTIONS(13594),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13596),
    [sym__command_start] = ACTIONS(13596),
  },
  [9119] = {
    [sym__word_identifier] = ACTIONS(13598),
    [anon_sym_EQ] = ACTIONS(13598),
    [anon_sym_COMMA] = ACTIONS(13598),
    [anon_sym_COLON] = ACTIONS(13598),
    [anon_sym_begin] = ACTIONS(13598),
    [anon_sym_module] = ACTIONS(13598),
    [anon_sym_baremodule] = ACTIONS(13598),
    [anon_sym_end] = ACTIONS(13598),
    [anon_sym_abstract] = ACTIONS(13598),
    [anon_sym_primitive] = ACTIONS(13598),
    [anon_sym_mutable] = ACTIONS(13598),
    [anon_sym_struct] = ACTIONS(13598),
    [anon_sym_function] = ACTIONS(13598),
    [anon_sym_macro] = ACTIONS(13598),
    [anon_sym_where] = ACTIONS(13598),
    [anon_sym_quote] = ACTIONS(13598),
    [anon_sym_let] = ACTIONS(13598),
    [anon_sym_if] = ACTIONS(13598),
    [anon_sym_try] = ACTIONS(13598),
    [anon_sym_for] = ACTIONS(13598),
    [anon_sym_while] = ACTIONS(13598),
    [sym_break_statement] = ACTIONS(13598),
    [sym_continue_statement] = ACTIONS(13598),
    [anon_sym_return] = ACTIONS(13598),
    [anon_sym_const] = ACTIONS(13598),
    [anon_sym_global] = ACTIONS(13598),
    [anon_sym_local] = ACTIONS(13598),
    [anon_sym_LPAREN] = ACTIONS(13598),
    [anon_sym_COLON2] = ACTIONS(13598),
    [anon_sym_export] = ACTIONS(13598),
    [anon_sym_import] = ACTIONS(13598),
    [anon_sym_using] = ACTIONS(13598),
    [anon_sym_LBRACK] = ACTIONS(13598),
    [anon_sym_LF] = ACTIONS(13600),
    [anon_sym_in] = ACTIONS(13598),
    [anon_sym_LBRACE] = ACTIONS(13598),
    [anon_sym_DOLLAR] = ACTIONS(13598),
    [anon_sym_COLON_COLON] = ACTIONS(13598),
    [anon_sym_isa] = ACTIONS(13598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13598),
    [anon_sym_QMARK] = ACTIONS(13598),
    [anon_sym_AT] = ACTIONS(13598),
    [anon_sym_true] = ACTIONS(13598),
    [anon_sym_false] = ACTIONS(13598),
    [aux_sym_integer_literal_token1] = ACTIONS(13598),
    [aux_sym_integer_literal_token2] = ACTIONS(13598),
    [aux_sym_integer_literal_token3] = ACTIONS(13598),
    [aux_sym_integer_literal_token4] = ACTIONS(13598),
    [aux_sym_float_literal_token1] = ACTIONS(13598),
    [aux_sym_float_literal_token3] = ACTIONS(13598),
    [aux_sym_float_literal_token4] = ACTIONS(13598),
    [sym_character_literal] = ACTIONS(13598),
    [sym__pair_operator] = ACTIONS(13598),
    [sym__arrow_operator] = ACTIONS(13598),
    [sym__lazy_or_operator] = ACTIONS(13598),
    [sym__lazy_and_operator] = ACTIONS(13598),
    [sym__comparison_operator] = ACTIONS(13598),
    [sym__pipe_right_operator] = ACTIONS(13598),
    [sym__pipe_left_operator] = ACTIONS(13598),
    [sym__ellipsis_operator] = ACTIONS(13598),
    [sym__plus_operator] = ACTIONS(13598),
    [sym__times_operator] = ACTIONS(13598),
    [sym__rational_operator] = ACTIONS(13598),
    [sym__bitshift_operator] = ACTIONS(13598),
    [sym__power_operator] = ACTIONS(13598),
    [sym__tilde_operator] = ACTIONS(13598),
    [sym__type_order_operator] = ACTIONS(13598),
    [sym__unary_operator] = ACTIONS(13598),
    [sym__unary_plus_operator] = ACTIONS(13598),
    [aux_sym__terminator_token1] = ACTIONS(13598),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13600),
    [sym__command_start] = ACTIONS(13600),
  },
  [9120] = {
    [sym__word_identifier] = ACTIONS(13400),
    [anon_sym_EQ] = ACTIONS(13400),
    [anon_sym_COMMA] = ACTIONS(13400),
    [anon_sym_COLON] = ACTIONS(13400),
    [anon_sym_begin] = ACTIONS(13400),
    [anon_sym_module] = ACTIONS(13400),
    [anon_sym_baremodule] = ACTIONS(13400),
    [anon_sym_end] = ACTIONS(13400),
    [anon_sym_abstract] = ACTIONS(13400),
    [anon_sym_primitive] = ACTIONS(13400),
    [anon_sym_mutable] = ACTIONS(13400),
    [anon_sym_struct] = ACTIONS(13400),
    [anon_sym_function] = ACTIONS(13400),
    [anon_sym_macro] = ACTIONS(13400),
    [anon_sym_where] = ACTIONS(13400),
    [anon_sym_quote] = ACTIONS(13400),
    [anon_sym_let] = ACTIONS(13400),
    [anon_sym_if] = ACTIONS(13400),
    [anon_sym_try] = ACTIONS(13400),
    [anon_sym_for] = ACTIONS(13400),
    [anon_sym_while] = ACTIONS(13400),
    [sym_break_statement] = ACTIONS(13400),
    [sym_continue_statement] = ACTIONS(13400),
    [anon_sym_return] = ACTIONS(13400),
    [anon_sym_const] = ACTIONS(13400),
    [anon_sym_global] = ACTIONS(13400),
    [anon_sym_local] = ACTIONS(13400),
    [anon_sym_LPAREN] = ACTIONS(13400),
    [anon_sym_COLON2] = ACTIONS(13400),
    [anon_sym_export] = ACTIONS(13400),
    [anon_sym_import] = ACTIONS(13400),
    [anon_sym_using] = ACTIONS(13400),
    [anon_sym_LBRACK] = ACTIONS(13400),
    [anon_sym_LF] = ACTIONS(13402),
    [anon_sym_in] = ACTIONS(13400),
    [anon_sym_LBRACE] = ACTIONS(13400),
    [anon_sym_DOLLAR] = ACTIONS(13400),
    [anon_sym_COLON_COLON] = ACTIONS(13400),
    [anon_sym_isa] = ACTIONS(13400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13400),
    [anon_sym_QMARK] = ACTIONS(13400),
    [anon_sym_AT] = ACTIONS(13400),
    [anon_sym_true] = ACTIONS(13400),
    [anon_sym_false] = ACTIONS(13400),
    [aux_sym_integer_literal_token1] = ACTIONS(13400),
    [aux_sym_integer_literal_token2] = ACTIONS(13400),
    [aux_sym_integer_literal_token3] = ACTIONS(13400),
    [aux_sym_integer_literal_token4] = ACTIONS(13400),
    [aux_sym_float_literal_token1] = ACTIONS(13400),
    [aux_sym_float_literal_token3] = ACTIONS(13400),
    [aux_sym_float_literal_token4] = ACTIONS(13400),
    [sym_character_literal] = ACTIONS(13400),
    [sym__pair_operator] = ACTIONS(13400),
    [sym__arrow_operator] = ACTIONS(13400),
    [sym__lazy_or_operator] = ACTIONS(13400),
    [sym__lazy_and_operator] = ACTIONS(13400),
    [sym__comparison_operator] = ACTIONS(13400),
    [sym__pipe_right_operator] = ACTIONS(13400),
    [sym__pipe_left_operator] = ACTIONS(13400),
    [sym__ellipsis_operator] = ACTIONS(13400),
    [sym__plus_operator] = ACTIONS(13400),
    [sym__times_operator] = ACTIONS(13400),
    [sym__rational_operator] = ACTIONS(13400),
    [sym__bitshift_operator] = ACTIONS(13400),
    [sym__power_operator] = ACTIONS(13400),
    [sym__tilde_operator] = ACTIONS(13400),
    [sym__type_order_operator] = ACTIONS(13400),
    [sym__unary_operator] = ACTIONS(13400),
    [sym__unary_plus_operator] = ACTIONS(13400),
    [aux_sym__terminator_token1] = ACTIONS(13400),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13402),
    [sym__command_start] = ACTIONS(13402),
  },
  [9121] = {
    [aux_sym_open_tuple_repeat1] = STATE(8915),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13247),
    [anon_sym_RPAREN] = ACTIONS(13247),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13247),
    [anon_sym_LBRACE] = ACTIONS(13247),
    [anon_sym_DOLLAR] = ACTIONS(13247),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14913),
    [anon_sym_AT] = ACTIONS(13247),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13247),
    [aux_sym_integer_literal_token2] = ACTIONS(13247),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13247),
    [aux_sym_float_literal_token3] = ACTIONS(13247),
    [aux_sym_float_literal_token4] = ACTIONS(13247),
    [sym_character_literal] = ACTIONS(13247),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13247),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [9122] = {
    [sym__word_identifier] = ACTIONS(13602),
    [anon_sym_EQ] = ACTIONS(13602),
    [anon_sym_COMMA] = ACTIONS(13602),
    [anon_sym_COLON] = ACTIONS(13602),
    [anon_sym_begin] = ACTIONS(13602),
    [anon_sym_module] = ACTIONS(13602),
    [anon_sym_baremodule] = ACTIONS(13602),
    [anon_sym_end] = ACTIONS(13602),
    [anon_sym_abstract] = ACTIONS(13602),
    [anon_sym_primitive] = ACTIONS(13602),
    [anon_sym_mutable] = ACTIONS(13602),
    [anon_sym_struct] = ACTIONS(13602),
    [anon_sym_function] = ACTIONS(13602),
    [anon_sym_macro] = ACTIONS(13602),
    [anon_sym_where] = ACTIONS(13602),
    [anon_sym_quote] = ACTIONS(13602),
    [anon_sym_let] = ACTIONS(13602),
    [anon_sym_if] = ACTIONS(13602),
    [anon_sym_try] = ACTIONS(13602),
    [anon_sym_for] = ACTIONS(13602),
    [anon_sym_while] = ACTIONS(13602),
    [sym_break_statement] = ACTIONS(13602),
    [sym_continue_statement] = ACTIONS(13602),
    [anon_sym_return] = ACTIONS(13602),
    [anon_sym_const] = ACTIONS(13602),
    [anon_sym_global] = ACTIONS(13602),
    [anon_sym_local] = ACTIONS(13602),
    [anon_sym_LPAREN] = ACTIONS(13602),
    [anon_sym_COLON2] = ACTIONS(13602),
    [anon_sym_export] = ACTIONS(13602),
    [anon_sym_import] = ACTIONS(13602),
    [anon_sym_using] = ACTIONS(13602),
    [anon_sym_LBRACK] = ACTIONS(13602),
    [anon_sym_LF] = ACTIONS(13604),
    [anon_sym_in] = ACTIONS(13602),
    [anon_sym_LBRACE] = ACTIONS(13602),
    [anon_sym_DOLLAR] = ACTIONS(13602),
    [anon_sym_COLON_COLON] = ACTIONS(13602),
    [anon_sym_isa] = ACTIONS(13602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13602),
    [anon_sym_QMARK] = ACTIONS(13602),
    [anon_sym_AT] = ACTIONS(13602),
    [anon_sym_true] = ACTIONS(13602),
    [anon_sym_false] = ACTIONS(13602),
    [aux_sym_integer_literal_token1] = ACTIONS(13602),
    [aux_sym_integer_literal_token2] = ACTIONS(13602),
    [aux_sym_integer_literal_token3] = ACTIONS(13602),
    [aux_sym_integer_literal_token4] = ACTIONS(13602),
    [aux_sym_float_literal_token1] = ACTIONS(13602),
    [aux_sym_float_literal_token3] = ACTIONS(13602),
    [aux_sym_float_literal_token4] = ACTIONS(13602),
    [sym_character_literal] = ACTIONS(13602),
    [sym__pair_operator] = ACTIONS(13602),
    [sym__arrow_operator] = ACTIONS(13602),
    [sym__lazy_or_operator] = ACTIONS(13602),
    [sym__lazy_and_operator] = ACTIONS(13602),
    [sym__comparison_operator] = ACTIONS(13602),
    [sym__pipe_right_operator] = ACTIONS(13602),
    [sym__pipe_left_operator] = ACTIONS(13602),
    [sym__ellipsis_operator] = ACTIONS(13602),
    [sym__plus_operator] = ACTIONS(13602),
    [sym__times_operator] = ACTIONS(13602),
    [sym__rational_operator] = ACTIONS(13602),
    [sym__bitshift_operator] = ACTIONS(13602),
    [sym__power_operator] = ACTIONS(13602),
    [sym__tilde_operator] = ACTIONS(13602),
    [sym__type_order_operator] = ACTIONS(13602),
    [sym__unary_operator] = ACTIONS(13602),
    [sym__unary_plus_operator] = ACTIONS(13602),
    [aux_sym__terminator_token1] = ACTIONS(13602),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13604),
    [sym__command_start] = ACTIONS(13604),
  },
  [9123] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_EQ] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13253),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13253),
    [anon_sym_RPAREN] = ACTIONS(13253),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13253),
    [anon_sym_LBRACE] = ACTIONS(13253),
    [anon_sym_DOLLAR] = ACTIONS(13253),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14913),
    [anon_sym_AT] = ACTIONS(13253),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13253),
    [aux_sym_integer_literal_token2] = ACTIONS(13253),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13253),
    [aux_sym_float_literal_token3] = ACTIONS(13253),
    [aux_sym_float_literal_token4] = ACTIONS(13253),
    [sym_character_literal] = ACTIONS(13253),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13253),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [9124] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_EQ] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13100),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13100),
    [anon_sym_RPAREN] = ACTIONS(13100),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13100),
    [anon_sym_LBRACE] = ACTIONS(13100),
    [anon_sym_DOLLAR] = ACTIONS(13100),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14913),
    [anon_sym_AT] = ACTIONS(13100),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13100),
    [aux_sym_integer_literal_token2] = ACTIONS(13100),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13100),
    [aux_sym_float_literal_token3] = ACTIONS(13100),
    [aux_sym_float_literal_token4] = ACTIONS(13100),
    [sym_character_literal] = ACTIONS(13100),
    [sym__pair_operator] = ACTIONS(13100),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13100),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [9125] = {
    [sym__word_identifier] = ACTIONS(13606),
    [anon_sym_EQ] = ACTIONS(13606),
    [anon_sym_COMMA] = ACTIONS(13606),
    [anon_sym_COLON] = ACTIONS(13606),
    [anon_sym_begin] = ACTIONS(13606),
    [anon_sym_module] = ACTIONS(13606),
    [anon_sym_baremodule] = ACTIONS(13606),
    [anon_sym_end] = ACTIONS(13606),
    [anon_sym_abstract] = ACTIONS(13606),
    [anon_sym_primitive] = ACTIONS(13606),
    [anon_sym_mutable] = ACTIONS(13606),
    [anon_sym_struct] = ACTIONS(13606),
    [anon_sym_function] = ACTIONS(13606),
    [anon_sym_macro] = ACTIONS(13606),
    [anon_sym_where] = ACTIONS(13606),
    [anon_sym_quote] = ACTIONS(13606),
    [anon_sym_let] = ACTIONS(13606),
    [anon_sym_if] = ACTIONS(13606),
    [anon_sym_try] = ACTIONS(13606),
    [anon_sym_for] = ACTIONS(13606),
    [anon_sym_while] = ACTIONS(13606),
    [sym_break_statement] = ACTIONS(13606),
    [sym_continue_statement] = ACTIONS(13606),
    [anon_sym_return] = ACTIONS(13606),
    [anon_sym_const] = ACTIONS(13606),
    [anon_sym_global] = ACTIONS(13606),
    [anon_sym_local] = ACTIONS(13606),
    [anon_sym_LPAREN] = ACTIONS(13606),
    [anon_sym_COLON2] = ACTIONS(13606),
    [anon_sym_export] = ACTIONS(13606),
    [anon_sym_import] = ACTIONS(13606),
    [anon_sym_using] = ACTIONS(13606),
    [anon_sym_LBRACK] = ACTIONS(13606),
    [anon_sym_LF] = ACTIONS(13608),
    [anon_sym_in] = ACTIONS(13606),
    [anon_sym_LBRACE] = ACTIONS(13606),
    [anon_sym_DOLLAR] = ACTIONS(13606),
    [anon_sym_COLON_COLON] = ACTIONS(13606),
    [anon_sym_isa] = ACTIONS(13606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13606),
    [anon_sym_QMARK] = ACTIONS(13606),
    [anon_sym_AT] = ACTIONS(13606),
    [anon_sym_true] = ACTIONS(13606),
    [anon_sym_false] = ACTIONS(13606),
    [aux_sym_integer_literal_token1] = ACTIONS(13606),
    [aux_sym_integer_literal_token2] = ACTIONS(13606),
    [aux_sym_integer_literal_token3] = ACTIONS(13606),
    [aux_sym_integer_literal_token4] = ACTIONS(13606),
    [aux_sym_float_literal_token1] = ACTIONS(13606),
    [aux_sym_float_literal_token3] = ACTIONS(13606),
    [aux_sym_float_literal_token4] = ACTIONS(13606),
    [sym_character_literal] = ACTIONS(13606),
    [sym__pair_operator] = ACTIONS(13606),
    [sym__arrow_operator] = ACTIONS(13606),
    [sym__lazy_or_operator] = ACTIONS(13606),
    [sym__lazy_and_operator] = ACTIONS(13606),
    [sym__comparison_operator] = ACTIONS(13606),
    [sym__pipe_right_operator] = ACTIONS(13606),
    [sym__pipe_left_operator] = ACTIONS(13606),
    [sym__ellipsis_operator] = ACTIONS(13606),
    [sym__plus_operator] = ACTIONS(13606),
    [sym__times_operator] = ACTIONS(13606),
    [sym__rational_operator] = ACTIONS(13606),
    [sym__bitshift_operator] = ACTIONS(13606),
    [sym__power_operator] = ACTIONS(13606),
    [sym__tilde_operator] = ACTIONS(13606),
    [sym__type_order_operator] = ACTIONS(13606),
    [sym__unary_operator] = ACTIONS(13606),
    [sym__unary_plus_operator] = ACTIONS(13606),
    [aux_sym__terminator_token1] = ACTIONS(13606),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13608),
    [sym__command_start] = ACTIONS(13608),
  },
  [9126] = {
    [sym__word_identifier] = ACTIONS(13362),
    [anon_sym_EQ] = ACTIONS(13362),
    [anon_sym_COMMA] = ACTIONS(13362),
    [anon_sym_COLON] = ACTIONS(13362),
    [anon_sym_begin] = ACTIONS(13362),
    [anon_sym_module] = ACTIONS(13362),
    [anon_sym_baremodule] = ACTIONS(13362),
    [anon_sym_abstract] = ACTIONS(13362),
    [anon_sym_primitive] = ACTIONS(13362),
    [anon_sym_mutable] = ACTIONS(13362),
    [anon_sym_struct] = ACTIONS(13362),
    [anon_sym_function] = ACTIONS(13362),
    [anon_sym_macro] = ACTIONS(13362),
    [anon_sym_where] = ACTIONS(13362),
    [anon_sym_quote] = ACTIONS(13362),
    [anon_sym_let] = ACTIONS(13362),
    [anon_sym_if] = ACTIONS(13362),
    [anon_sym_try] = ACTIONS(13362),
    [anon_sym_for] = ACTIONS(13362),
    [anon_sym_while] = ACTIONS(13362),
    [sym_break_statement] = ACTIONS(13362),
    [sym_continue_statement] = ACTIONS(13362),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_const] = ACTIONS(13362),
    [anon_sym_global] = ACTIONS(13362),
    [anon_sym_local] = ACTIONS(13362),
    [anon_sym_LPAREN] = ACTIONS(13362),
    [anon_sym_RPAREN] = ACTIONS(13362),
    [anon_sym_COLON2] = ACTIONS(13362),
    [anon_sym_export] = ACTIONS(13362),
    [anon_sym_import] = ACTIONS(13362),
    [anon_sym_using] = ACTIONS(13362),
    [anon_sym_LBRACK] = ACTIONS(13362),
    [anon_sym_LF] = ACTIONS(13364),
    [anon_sym_in] = ACTIONS(13362),
    [anon_sym_SEMI] = ACTIONS(13362),
    [anon_sym_LBRACE] = ACTIONS(13362),
    [anon_sym_DOLLAR] = ACTIONS(13362),
    [anon_sym_COLON_COLON] = ACTIONS(13362),
    [anon_sym_isa] = ACTIONS(13362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13362),
    [anon_sym_QMARK] = ACTIONS(13362),
    [anon_sym_AT] = ACTIONS(13362),
    [anon_sym_true] = ACTIONS(13362),
    [anon_sym_false] = ACTIONS(13362),
    [aux_sym_integer_literal_token1] = ACTIONS(13362),
    [aux_sym_integer_literal_token2] = ACTIONS(13362),
    [aux_sym_integer_literal_token3] = ACTIONS(13362),
    [aux_sym_integer_literal_token4] = ACTIONS(13362),
    [aux_sym_float_literal_token1] = ACTIONS(13362),
    [aux_sym_float_literal_token3] = ACTIONS(13362),
    [aux_sym_float_literal_token4] = ACTIONS(13362),
    [sym_character_literal] = ACTIONS(13362),
    [sym__pair_operator] = ACTIONS(13362),
    [sym__arrow_operator] = ACTIONS(13362),
    [sym__lazy_or_operator] = ACTIONS(13362),
    [sym__lazy_and_operator] = ACTIONS(13362),
    [sym__comparison_operator] = ACTIONS(13362),
    [sym__pipe_right_operator] = ACTIONS(13362),
    [sym__pipe_left_operator] = ACTIONS(13362),
    [sym__ellipsis_operator] = ACTIONS(13362),
    [sym__plus_operator] = ACTIONS(13362),
    [sym__times_operator] = ACTIONS(13362),
    [sym__rational_operator] = ACTIONS(13362),
    [sym__bitshift_operator] = ACTIONS(13362),
    [sym__power_operator] = ACTIONS(13362),
    [sym__tilde_operator] = ACTIONS(13362),
    [sym__type_order_operator] = ACTIONS(13362),
    [sym__unary_operator] = ACTIONS(13362),
    [sym__unary_plus_operator] = ACTIONS(13362),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13364),
    [sym__command_start] = ACTIONS(13364),
  },
  [9127] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [9128] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12724),
    [anon_sym_COMMA] = ACTIONS(12926),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(12926),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12926),
    [anon_sym_QMARK] = ACTIONS(12926),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(12926),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12926),
    [sym__lazy_and_operator] = ACTIONS(12926),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12926),
    [sym__pipe_left_operator] = ACTIONS(12926),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12926),
    [sym__bitshift_operator] = ACTIONS(12926),
    [sym__power_operator] = ACTIONS(12926),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(12926),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [9129] = {
    [sym__word_identifier] = ACTIONS(13366),
    [anon_sym_EQ] = ACTIONS(13366),
    [anon_sym_COMMA] = ACTIONS(13366),
    [anon_sym_COLON] = ACTIONS(13366),
    [anon_sym_begin] = ACTIONS(13366),
    [anon_sym_module] = ACTIONS(13366),
    [anon_sym_baremodule] = ACTIONS(13366),
    [anon_sym_abstract] = ACTIONS(13366),
    [anon_sym_primitive] = ACTIONS(13366),
    [anon_sym_mutable] = ACTIONS(13366),
    [anon_sym_struct] = ACTIONS(13366),
    [anon_sym_function] = ACTIONS(13366),
    [anon_sym_macro] = ACTIONS(13366),
    [anon_sym_where] = ACTIONS(13366),
    [anon_sym_quote] = ACTIONS(13366),
    [anon_sym_let] = ACTIONS(13366),
    [anon_sym_if] = ACTIONS(13366),
    [anon_sym_try] = ACTIONS(13366),
    [anon_sym_for] = ACTIONS(13366),
    [anon_sym_while] = ACTIONS(13366),
    [sym_break_statement] = ACTIONS(13366),
    [sym_continue_statement] = ACTIONS(13366),
    [anon_sym_return] = ACTIONS(13366),
    [anon_sym_const] = ACTIONS(13366),
    [anon_sym_global] = ACTIONS(13366),
    [anon_sym_local] = ACTIONS(13366),
    [anon_sym_LPAREN] = ACTIONS(13366),
    [anon_sym_RPAREN] = ACTIONS(13366),
    [anon_sym_COLON2] = ACTIONS(13366),
    [anon_sym_export] = ACTIONS(13366),
    [anon_sym_import] = ACTIONS(13366),
    [anon_sym_using] = ACTIONS(13366),
    [anon_sym_LBRACK] = ACTIONS(13366),
    [anon_sym_LF] = ACTIONS(13368),
    [anon_sym_in] = ACTIONS(13366),
    [anon_sym_SEMI] = ACTIONS(13366),
    [anon_sym_LBRACE] = ACTIONS(13366),
    [anon_sym_DOLLAR] = ACTIONS(13366),
    [anon_sym_COLON_COLON] = ACTIONS(13366),
    [anon_sym_isa] = ACTIONS(13366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13366),
    [anon_sym_QMARK] = ACTIONS(13366),
    [anon_sym_AT] = ACTIONS(13366),
    [anon_sym_true] = ACTIONS(13366),
    [anon_sym_false] = ACTIONS(13366),
    [aux_sym_integer_literal_token1] = ACTIONS(13366),
    [aux_sym_integer_literal_token2] = ACTIONS(13366),
    [aux_sym_integer_literal_token3] = ACTIONS(13366),
    [aux_sym_integer_literal_token4] = ACTIONS(13366),
    [aux_sym_float_literal_token1] = ACTIONS(13366),
    [aux_sym_float_literal_token3] = ACTIONS(13366),
    [aux_sym_float_literal_token4] = ACTIONS(13366),
    [sym_character_literal] = ACTIONS(13366),
    [sym__pair_operator] = ACTIONS(13366),
    [sym__arrow_operator] = ACTIONS(13366),
    [sym__lazy_or_operator] = ACTIONS(13366),
    [sym__lazy_and_operator] = ACTIONS(13366),
    [sym__comparison_operator] = ACTIONS(13366),
    [sym__pipe_right_operator] = ACTIONS(13366),
    [sym__pipe_left_operator] = ACTIONS(13366),
    [sym__ellipsis_operator] = ACTIONS(13366),
    [sym__plus_operator] = ACTIONS(13366),
    [sym__times_operator] = ACTIONS(13366),
    [sym__rational_operator] = ACTIONS(13366),
    [sym__bitshift_operator] = ACTIONS(13366),
    [sym__power_operator] = ACTIONS(13366),
    [sym__tilde_operator] = ACTIONS(13366),
    [sym__type_order_operator] = ACTIONS(13366),
    [sym__unary_operator] = ACTIONS(13366),
    [sym__unary_plus_operator] = ACTIONS(13366),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13368),
    [sym__command_start] = ACTIONS(13368),
  },
  [9130] = {
    [aux_sym_open_tuple_repeat1] = STATE(8299),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(14604),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_end] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14674),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12926),
    [anon_sym_COLON2] = ACTIONS(14676),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12926),
    [anon_sym_LF] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14678),
    [anon_sym_LBRACE] = ACTIONS(12926),
    [anon_sym_DOLLAR] = ACTIONS(12926),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(12926),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12926),
    [aux_sym_integer_literal_token2] = ACTIONS(12926),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12926),
    [aux_sym_float_literal_token3] = ACTIONS(12926),
    [aux_sym_float_literal_token4] = ACTIONS(12926),
    [sym_character_literal] = ACTIONS(12926),
    [sym__pair_operator] = ACTIONS(14684),
    [sym__arrow_operator] = ACTIONS(14686),
    [sym__lazy_or_operator] = ACTIONS(14688),
    [sym__lazy_and_operator] = ACTIONS(14690),
    [sym__comparison_operator] = ACTIONS(14678),
    [sym__pipe_right_operator] = ACTIONS(14692),
    [sym__pipe_left_operator] = ACTIONS(14694),
    [sym__ellipsis_operator] = ACTIONS(14696),
    [sym__plus_operator] = ACTIONS(14698),
    [sym__times_operator] = ACTIONS(14700),
    [sym__rational_operator] = ACTIONS(14702),
    [sym__bitshift_operator] = ACTIONS(14704),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(12926),
    [sym__type_order_operator] = ACTIONS(14678),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14698),
    [aux_sym__terminator_token1] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [9131] = {
    [sym__word_identifier] = ACTIONS(13370),
    [anon_sym_EQ] = ACTIONS(13370),
    [anon_sym_COMMA] = ACTIONS(13370),
    [anon_sym_COLON] = ACTIONS(13370),
    [anon_sym_begin] = ACTIONS(13370),
    [anon_sym_module] = ACTIONS(13370),
    [anon_sym_baremodule] = ACTIONS(13370),
    [anon_sym_abstract] = ACTIONS(13370),
    [anon_sym_primitive] = ACTIONS(13370),
    [anon_sym_mutable] = ACTIONS(13370),
    [anon_sym_struct] = ACTIONS(13370),
    [anon_sym_function] = ACTIONS(13370),
    [anon_sym_macro] = ACTIONS(13370),
    [anon_sym_where] = ACTIONS(13370),
    [anon_sym_quote] = ACTIONS(13370),
    [anon_sym_let] = ACTIONS(13370),
    [anon_sym_if] = ACTIONS(13370),
    [anon_sym_try] = ACTIONS(13370),
    [anon_sym_for] = ACTIONS(13370),
    [anon_sym_while] = ACTIONS(13370),
    [sym_break_statement] = ACTIONS(13370),
    [sym_continue_statement] = ACTIONS(13370),
    [anon_sym_return] = ACTIONS(13370),
    [anon_sym_const] = ACTIONS(13370),
    [anon_sym_global] = ACTIONS(13370),
    [anon_sym_local] = ACTIONS(13370),
    [anon_sym_LPAREN] = ACTIONS(13370),
    [anon_sym_RPAREN] = ACTIONS(13370),
    [anon_sym_COLON2] = ACTIONS(13370),
    [anon_sym_export] = ACTIONS(13370),
    [anon_sym_import] = ACTIONS(13370),
    [anon_sym_using] = ACTIONS(13370),
    [anon_sym_LBRACK] = ACTIONS(13370),
    [anon_sym_LF] = ACTIONS(13372),
    [anon_sym_in] = ACTIONS(13370),
    [anon_sym_SEMI] = ACTIONS(13370),
    [anon_sym_LBRACE] = ACTIONS(13370),
    [anon_sym_DOLLAR] = ACTIONS(13370),
    [anon_sym_COLON_COLON] = ACTIONS(13370),
    [anon_sym_isa] = ACTIONS(13370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13370),
    [anon_sym_QMARK] = ACTIONS(13370),
    [anon_sym_AT] = ACTIONS(13370),
    [anon_sym_true] = ACTIONS(13370),
    [anon_sym_false] = ACTIONS(13370),
    [aux_sym_integer_literal_token1] = ACTIONS(13370),
    [aux_sym_integer_literal_token2] = ACTIONS(13370),
    [aux_sym_integer_literal_token3] = ACTIONS(13370),
    [aux_sym_integer_literal_token4] = ACTIONS(13370),
    [aux_sym_float_literal_token1] = ACTIONS(13370),
    [aux_sym_float_literal_token3] = ACTIONS(13370),
    [aux_sym_float_literal_token4] = ACTIONS(13370),
    [sym_character_literal] = ACTIONS(13370),
    [sym__pair_operator] = ACTIONS(13370),
    [sym__arrow_operator] = ACTIONS(13370),
    [sym__lazy_or_operator] = ACTIONS(13370),
    [sym__lazy_and_operator] = ACTIONS(13370),
    [sym__comparison_operator] = ACTIONS(13370),
    [sym__pipe_right_operator] = ACTIONS(13370),
    [sym__pipe_left_operator] = ACTIONS(13370),
    [sym__ellipsis_operator] = ACTIONS(13370),
    [sym__plus_operator] = ACTIONS(13370),
    [sym__times_operator] = ACTIONS(13370),
    [sym__rational_operator] = ACTIONS(13370),
    [sym__bitshift_operator] = ACTIONS(13370),
    [sym__power_operator] = ACTIONS(13370),
    [sym__tilde_operator] = ACTIONS(13370),
    [sym__type_order_operator] = ACTIONS(13370),
    [sym__unary_operator] = ACTIONS(13370),
    [sym__unary_plus_operator] = ACTIONS(13370),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13372),
    [sym__command_start] = ACTIONS(13372),
  },
  [9132] = {
    [sym__word_identifier] = ACTIONS(13374),
    [anon_sym_EQ] = ACTIONS(13374),
    [anon_sym_COMMA] = ACTIONS(13374),
    [anon_sym_COLON] = ACTIONS(13374),
    [anon_sym_begin] = ACTIONS(13374),
    [anon_sym_module] = ACTIONS(13374),
    [anon_sym_baremodule] = ACTIONS(13374),
    [anon_sym_abstract] = ACTIONS(13374),
    [anon_sym_primitive] = ACTIONS(13374),
    [anon_sym_mutable] = ACTIONS(13374),
    [anon_sym_struct] = ACTIONS(13374),
    [anon_sym_function] = ACTIONS(13374),
    [anon_sym_macro] = ACTIONS(13374),
    [anon_sym_where] = ACTIONS(13374),
    [anon_sym_quote] = ACTIONS(13374),
    [anon_sym_let] = ACTIONS(13374),
    [anon_sym_if] = ACTIONS(13374),
    [anon_sym_try] = ACTIONS(13374),
    [anon_sym_for] = ACTIONS(13374),
    [anon_sym_while] = ACTIONS(13374),
    [sym_break_statement] = ACTIONS(13374),
    [sym_continue_statement] = ACTIONS(13374),
    [anon_sym_return] = ACTIONS(13374),
    [anon_sym_const] = ACTIONS(13374),
    [anon_sym_global] = ACTIONS(13374),
    [anon_sym_local] = ACTIONS(13374),
    [anon_sym_LPAREN] = ACTIONS(13374),
    [anon_sym_RPAREN] = ACTIONS(13374),
    [anon_sym_COLON2] = ACTIONS(13374),
    [anon_sym_export] = ACTIONS(13374),
    [anon_sym_import] = ACTIONS(13374),
    [anon_sym_using] = ACTIONS(13374),
    [anon_sym_LBRACK] = ACTIONS(13374),
    [anon_sym_LF] = ACTIONS(13376),
    [anon_sym_in] = ACTIONS(13374),
    [anon_sym_SEMI] = ACTIONS(13374),
    [anon_sym_LBRACE] = ACTIONS(13374),
    [anon_sym_DOLLAR] = ACTIONS(13374),
    [anon_sym_COLON_COLON] = ACTIONS(13374),
    [anon_sym_isa] = ACTIONS(13374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13374),
    [anon_sym_QMARK] = ACTIONS(13374),
    [anon_sym_AT] = ACTIONS(13374),
    [anon_sym_true] = ACTIONS(13374),
    [anon_sym_false] = ACTIONS(13374),
    [aux_sym_integer_literal_token1] = ACTIONS(13374),
    [aux_sym_integer_literal_token2] = ACTIONS(13374),
    [aux_sym_integer_literal_token3] = ACTIONS(13374),
    [aux_sym_integer_literal_token4] = ACTIONS(13374),
    [aux_sym_float_literal_token1] = ACTIONS(13374),
    [aux_sym_float_literal_token3] = ACTIONS(13374),
    [aux_sym_float_literal_token4] = ACTIONS(13374),
    [sym_character_literal] = ACTIONS(13374),
    [sym__pair_operator] = ACTIONS(13374),
    [sym__arrow_operator] = ACTIONS(13374),
    [sym__lazy_or_operator] = ACTIONS(13374),
    [sym__lazy_and_operator] = ACTIONS(13374),
    [sym__comparison_operator] = ACTIONS(13374),
    [sym__pipe_right_operator] = ACTIONS(13374),
    [sym__pipe_left_operator] = ACTIONS(13374),
    [sym__ellipsis_operator] = ACTIONS(13374),
    [sym__plus_operator] = ACTIONS(13374),
    [sym__times_operator] = ACTIONS(13374),
    [sym__rational_operator] = ACTIONS(13374),
    [sym__bitshift_operator] = ACTIONS(13374),
    [sym__power_operator] = ACTIONS(13374),
    [sym__tilde_operator] = ACTIONS(13374),
    [sym__type_order_operator] = ACTIONS(13374),
    [sym__unary_operator] = ACTIONS(13374),
    [sym__unary_plus_operator] = ACTIONS(13374),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13376),
    [sym__command_start] = ACTIONS(13376),
  },
  [9133] = {
    [aux_sym_open_tuple_repeat1] = STATE(8915),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13199),
    [anon_sym_RPAREN] = ACTIONS(13199),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13199),
    [anon_sym_LBRACE] = ACTIONS(13199),
    [anon_sym_DOLLAR] = ACTIONS(13199),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14913),
    [anon_sym_AT] = ACTIONS(13199),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13199),
    [aux_sym_integer_literal_token2] = ACTIONS(13199),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13199),
    [aux_sym_float_literal_token3] = ACTIONS(13199),
    [aux_sym_float_literal_token4] = ACTIONS(13199),
    [sym_character_literal] = ACTIONS(13199),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13199),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [9134] = {
    [aux_sym_open_tuple_repeat1] = STATE(8915),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13241),
    [anon_sym_RPAREN] = ACTIONS(13241),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13241),
    [anon_sym_LBRACE] = ACTIONS(13241),
    [anon_sym_DOLLAR] = ACTIONS(13241),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14913),
    [anon_sym_AT] = ACTIONS(13241),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13241),
    [aux_sym_integer_literal_token2] = ACTIONS(13241),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13241),
    [aux_sym_float_literal_token3] = ACTIONS(13241),
    [aux_sym_float_literal_token4] = ACTIONS(13241),
    [sym_character_literal] = ACTIONS(13241),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13241),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [9135] = {
    [aux_sym_open_tuple_repeat1] = STATE(8915),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13245),
    [anon_sym_RPAREN] = ACTIONS(13245),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13245),
    [anon_sym_LBRACE] = ACTIONS(13245),
    [anon_sym_DOLLAR] = ACTIONS(13245),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14913),
    [anon_sym_AT] = ACTIONS(13245),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13245),
    [aux_sym_integer_literal_token2] = ACTIONS(13245),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13245),
    [aux_sym_float_literal_token3] = ACTIONS(13245),
    [aux_sym_float_literal_token4] = ACTIONS(13245),
    [sym_character_literal] = ACTIONS(13245),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13245),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [9136] = {
    [aux_sym_open_tuple_repeat1] = STATE(8915),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12934),
    [anon_sym_RPAREN] = ACTIONS(12934),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(12934),
    [anon_sym_LBRACE] = ACTIONS(12934),
    [anon_sym_DOLLAR] = ACTIONS(12934),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14913),
    [anon_sym_AT] = ACTIONS(12934),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12934),
    [aux_sym_integer_literal_token2] = ACTIONS(12934),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12934),
    [aux_sym_float_literal_token3] = ACTIONS(12934),
    [aux_sym_float_literal_token4] = ACTIONS(12934),
    [sym_character_literal] = ACTIONS(12934),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(12934),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [9137] = {
    [sym__word_identifier] = ACTIONS(13378),
    [anon_sym_EQ] = ACTIONS(13378),
    [anon_sym_COMMA] = ACTIONS(13378),
    [anon_sym_COLON] = ACTIONS(13378),
    [anon_sym_begin] = ACTIONS(13378),
    [anon_sym_module] = ACTIONS(13378),
    [anon_sym_baremodule] = ACTIONS(13378),
    [anon_sym_abstract] = ACTIONS(13378),
    [anon_sym_primitive] = ACTIONS(13378),
    [anon_sym_mutable] = ACTIONS(13378),
    [anon_sym_struct] = ACTIONS(13378),
    [anon_sym_function] = ACTIONS(13378),
    [anon_sym_macro] = ACTIONS(13378),
    [anon_sym_where] = ACTIONS(13378),
    [anon_sym_quote] = ACTIONS(13378),
    [anon_sym_let] = ACTIONS(13378),
    [anon_sym_if] = ACTIONS(13378),
    [anon_sym_try] = ACTIONS(13378),
    [anon_sym_for] = ACTIONS(13378),
    [anon_sym_while] = ACTIONS(13378),
    [sym_break_statement] = ACTIONS(13378),
    [sym_continue_statement] = ACTIONS(13378),
    [anon_sym_return] = ACTIONS(13378),
    [anon_sym_const] = ACTIONS(13378),
    [anon_sym_global] = ACTIONS(13378),
    [anon_sym_local] = ACTIONS(13378),
    [anon_sym_LPAREN] = ACTIONS(13378),
    [anon_sym_RPAREN] = ACTIONS(13378),
    [anon_sym_COLON2] = ACTIONS(13378),
    [anon_sym_export] = ACTIONS(13378),
    [anon_sym_import] = ACTIONS(13378),
    [anon_sym_using] = ACTIONS(13378),
    [anon_sym_LBRACK] = ACTIONS(13378),
    [anon_sym_LF] = ACTIONS(13380),
    [anon_sym_in] = ACTIONS(13378),
    [anon_sym_SEMI] = ACTIONS(13378),
    [anon_sym_LBRACE] = ACTIONS(13378),
    [anon_sym_DOLLAR] = ACTIONS(13378),
    [anon_sym_COLON_COLON] = ACTIONS(13378),
    [anon_sym_isa] = ACTIONS(13378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13378),
    [anon_sym_QMARK] = ACTIONS(13378),
    [anon_sym_AT] = ACTIONS(13378),
    [anon_sym_true] = ACTIONS(13378),
    [anon_sym_false] = ACTIONS(13378),
    [aux_sym_integer_literal_token1] = ACTIONS(13378),
    [aux_sym_integer_literal_token2] = ACTIONS(13378),
    [aux_sym_integer_literal_token3] = ACTIONS(13378),
    [aux_sym_integer_literal_token4] = ACTIONS(13378),
    [aux_sym_float_literal_token1] = ACTIONS(13378),
    [aux_sym_float_literal_token3] = ACTIONS(13378),
    [aux_sym_float_literal_token4] = ACTIONS(13378),
    [sym_character_literal] = ACTIONS(13378),
    [sym__pair_operator] = ACTIONS(13378),
    [sym__arrow_operator] = ACTIONS(13378),
    [sym__lazy_or_operator] = ACTIONS(13378),
    [sym__lazy_and_operator] = ACTIONS(13378),
    [sym__comparison_operator] = ACTIONS(13378),
    [sym__pipe_right_operator] = ACTIONS(13378),
    [sym__pipe_left_operator] = ACTIONS(13378),
    [sym__ellipsis_operator] = ACTIONS(13378),
    [sym__plus_operator] = ACTIONS(13378),
    [sym__times_operator] = ACTIONS(13378),
    [sym__rational_operator] = ACTIONS(13378),
    [sym__bitshift_operator] = ACTIONS(13378),
    [sym__power_operator] = ACTIONS(13378),
    [sym__tilde_operator] = ACTIONS(13378),
    [sym__type_order_operator] = ACTIONS(13378),
    [sym__unary_operator] = ACTIONS(13378),
    [sym__unary_plus_operator] = ACTIONS(13378),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13380),
    [sym__command_start] = ACTIONS(13380),
  },
  [9138] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14706),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9139] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9140] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12790),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9141] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_RPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_SEMI] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9142] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14943),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14945),
    [sym__plus_operator] = ACTIONS(14947),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9143] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14943),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14955),
    [sym__pipe_left_operator] = ACTIONS(14957),
    [sym__ellipsis_operator] = ACTIONS(14945),
    [sym__plus_operator] = ACTIONS(14947),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9144] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14947),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9145] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9146] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(12790),
    [anon_sym_COMMA] = ACTIONS(13241),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13241),
    [anon_sym_RPAREN] = ACTIONS(13241),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_SEMI] = ACTIONS(13241),
    [anon_sym_LBRACE] = ACTIONS(13241),
    [anon_sym_DOLLAR] = ACTIONS(13241),
    [anon_sym_COLON_COLON] = ACTIONS(13241),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13241),
    [anon_sym_QMARK] = ACTIONS(13241),
    [anon_sym_AT] = ACTIONS(13241),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13241),
    [aux_sym_integer_literal_token2] = ACTIONS(13241),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13241),
    [aux_sym_float_literal_token3] = ACTIONS(13241),
    [aux_sym_float_literal_token4] = ACTIONS(13241),
    [sym_character_literal] = ACTIONS(13241),
    [sym__pair_operator] = ACTIONS(13241),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13241),
    [sym__lazy_and_operator] = ACTIONS(13241),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13241),
    [sym__pipe_left_operator] = ACTIONS(13241),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13241),
    [sym__bitshift_operator] = ACTIONS(13241),
    [sym__power_operator] = ACTIONS(13241),
    [sym__tilde_operator] = ACTIONS(13241),
    [sym__type_order_operator] = ACTIONS(13241),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [9147] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9148] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9149] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(12790),
    [anon_sym_COMMA] = ACTIONS(13245),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13245),
    [anon_sym_RPAREN] = ACTIONS(13245),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_SEMI] = ACTIONS(13245),
    [anon_sym_LBRACE] = ACTIONS(13245),
    [anon_sym_DOLLAR] = ACTIONS(13245),
    [anon_sym_COLON_COLON] = ACTIONS(13245),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13245),
    [anon_sym_QMARK] = ACTIONS(13245),
    [anon_sym_AT] = ACTIONS(13245),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13245),
    [aux_sym_integer_literal_token2] = ACTIONS(13245),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13245),
    [aux_sym_float_literal_token3] = ACTIONS(13245),
    [aux_sym_float_literal_token4] = ACTIONS(13245),
    [sym_character_literal] = ACTIONS(13245),
    [sym__pair_operator] = ACTIONS(13245),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13245),
    [sym__lazy_and_operator] = ACTIONS(13245),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13245),
    [sym__pipe_left_operator] = ACTIONS(13245),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13245),
    [sym__bitshift_operator] = ACTIONS(13245),
    [sym__power_operator] = ACTIONS(13245),
    [sym__tilde_operator] = ACTIONS(13245),
    [sym__type_order_operator] = ACTIONS(13245),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [9150] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_EQ] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13340),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13340),
    [anon_sym_RPAREN] = ACTIONS(13340),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13340),
    [anon_sym_LBRACE] = ACTIONS(13340),
    [anon_sym_DOLLAR] = ACTIONS(13340),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14913),
    [anon_sym_AT] = ACTIONS(13340),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13340),
    [aux_sym_integer_literal_token2] = ACTIONS(13340),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13340),
    [aux_sym_float_literal_token3] = ACTIONS(13340),
    [aux_sym_float_literal_token4] = ACTIONS(13340),
    [sym_character_literal] = ACTIONS(13340),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13340),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [9151] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14959),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14961),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(14961),
    [sym__pipe_right_operator] = ACTIONS(14963),
    [sym__pipe_left_operator] = ACTIONS(14965),
    [sym__ellipsis_operator] = ACTIONS(14967),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(14961),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [9152] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(14979),
    [anon_sym_COMMA] = ACTIONS(13199),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13199),
    [anon_sym_RPAREN] = ACTIONS(13199),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_SEMI] = ACTIONS(13199),
    [anon_sym_LBRACE] = ACTIONS(13199),
    [anon_sym_DOLLAR] = ACTIONS(13199),
    [anon_sym_COLON_COLON] = ACTIONS(13199),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13199),
    [anon_sym_QMARK] = ACTIONS(13199),
    [anon_sym_AT] = ACTIONS(13199),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13199),
    [aux_sym_integer_literal_token2] = ACTIONS(13199),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13199),
    [aux_sym_float_literal_token3] = ACTIONS(13199),
    [aux_sym_float_literal_token4] = ACTIONS(13199),
    [sym_character_literal] = ACTIONS(13199),
    [sym__pair_operator] = ACTIONS(13199),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13199),
    [sym__lazy_and_operator] = ACTIONS(13199),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13199),
    [sym__pipe_left_operator] = ACTIONS(13199),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13199),
    [sym__bitshift_operator] = ACTIONS(13199),
    [sym__power_operator] = ACTIONS(13199),
    [sym__tilde_operator] = ACTIONS(13199),
    [sym__type_order_operator] = ACTIONS(13199),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [9153] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14959),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14963),
    [sym__pipe_left_operator] = ACTIONS(14965),
    [sym__ellipsis_operator] = ACTIONS(14967),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9154] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14981),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14959),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14961),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(14983),
    [sym__arrow_operator] = ACTIONS(14985),
    [sym__lazy_or_operator] = ACTIONS(14987),
    [sym__lazy_and_operator] = ACTIONS(14989),
    [sym__comparison_operator] = ACTIONS(14961),
    [sym__pipe_right_operator] = ACTIONS(14963),
    [sym__pipe_left_operator] = ACTIONS(14965),
    [sym__ellipsis_operator] = ACTIONS(14967),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14961),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9155] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14981),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14959),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14961),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(14985),
    [sym__lazy_or_operator] = ACTIONS(14987),
    [sym__lazy_and_operator] = ACTIONS(14989),
    [sym__comparison_operator] = ACTIONS(14961),
    [sym__pipe_right_operator] = ACTIONS(14963),
    [sym__pipe_left_operator] = ACTIONS(14965),
    [sym__ellipsis_operator] = ACTIONS(14967),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14961),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9156] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14981),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14959),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14961),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(14989),
    [sym__comparison_operator] = ACTIONS(14961),
    [sym__pipe_right_operator] = ACTIONS(14963),
    [sym__pipe_left_operator] = ACTIONS(14965),
    [sym__ellipsis_operator] = ACTIONS(14967),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14961),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9157] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14981),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14959),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14961),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(14961),
    [sym__pipe_right_operator] = ACTIONS(14963),
    [sym__pipe_left_operator] = ACTIONS(14965),
    [sym__ellipsis_operator] = ACTIONS(14967),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(14961),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9158] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14959),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(14967),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9159] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14959),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14963),
    [sym__pipe_left_operator] = ACTIONS(14965),
    [sym__ellipsis_operator] = ACTIONS(14967),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9160] = {
    [sym__word_identifier] = ACTIONS(14991),
    [anon_sym_COMMA] = ACTIONS(14991),
    [anon_sym_COLON] = ACTIONS(14991),
    [anon_sym_begin] = ACTIONS(14991),
    [anon_sym_module] = ACTIONS(14991),
    [anon_sym_baremodule] = ACTIONS(14991),
    [anon_sym_abstract] = ACTIONS(14991),
    [anon_sym_primitive] = ACTIONS(14991),
    [anon_sym_mutable] = ACTIONS(14991),
    [anon_sym_struct] = ACTIONS(14991),
    [anon_sym_function] = ACTIONS(14991),
    [anon_sym_macro] = ACTIONS(14991),
    [anon_sym_where] = ACTIONS(13203),
    [anon_sym_quote] = ACTIONS(14991),
    [anon_sym_let] = ACTIONS(14991),
    [anon_sym_if] = ACTIONS(14991),
    [anon_sym_try] = ACTIONS(14991),
    [anon_sym_for] = ACTIONS(14991),
    [anon_sym_while] = ACTIONS(14991),
    [sym_break_statement] = ACTIONS(14991),
    [sym_continue_statement] = ACTIONS(14991),
    [anon_sym_return] = ACTIONS(14991),
    [anon_sym_const] = ACTIONS(14991),
    [anon_sym_global] = ACTIONS(14991),
    [anon_sym_local] = ACTIONS(14991),
    [anon_sym_LPAREN] = ACTIONS(14991),
    [anon_sym_COLON2] = ACTIONS(13205),
    [anon_sym_export] = ACTIONS(14991),
    [anon_sym_import] = ACTIONS(14991),
    [anon_sym_using] = ACTIONS(14991),
    [anon_sym_LBRACK] = ACTIONS(14991),
    [anon_sym_RBRACK] = ACTIONS(14991),
    [anon_sym_LF] = ACTIONS(14993),
    [anon_sym_in] = ACTIONS(13207),
    [anon_sym_LBRACE] = ACTIONS(14991),
    [anon_sym_DOLLAR] = ACTIONS(14991),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13275),
    [anon_sym_AT] = ACTIONS(14991),
    [anon_sym_true] = ACTIONS(14991),
    [anon_sym_false] = ACTIONS(14991),
    [aux_sym_integer_literal_token1] = ACTIONS(14991),
    [aux_sym_integer_literal_token2] = ACTIONS(14991),
    [aux_sym_integer_literal_token3] = ACTIONS(14991),
    [aux_sym_integer_literal_token4] = ACTIONS(14991),
    [aux_sym_float_literal_token1] = ACTIONS(14991),
    [aux_sym_float_literal_token3] = ACTIONS(14991),
    [aux_sym_float_literal_token4] = ACTIONS(14991),
    [sym_character_literal] = ACTIONS(14991),
    [sym__pair_operator] = ACTIONS(13215),
    [sym__arrow_operator] = ACTIONS(13217),
    [sym__lazy_or_operator] = ACTIONS(13219),
    [sym__lazy_and_operator] = ACTIONS(13221),
    [sym__comparison_operator] = ACTIONS(13207),
    [sym__pipe_right_operator] = ACTIONS(13223),
    [sym__pipe_left_operator] = ACTIONS(13225),
    [sym__ellipsis_operator] = ACTIONS(13227),
    [sym__plus_operator] = ACTIONS(13229),
    [sym__times_operator] = ACTIONS(13231),
    [sym__rational_operator] = ACTIONS(13233),
    [sym__bitshift_operator] = ACTIONS(13235),
    [sym__power_operator] = ACTIONS(13237),
    [sym__tilde_operator] = ACTIONS(14991),
    [sym__type_order_operator] = ACTIONS(13207),
    [sym__unary_operator] = ACTIONS(14991),
    [sym__unary_plus_operator] = ACTIONS(13229),
    [aux_sym__terminator_token1] = ACTIONS(14991),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(14993),
    [sym__command_start] = ACTIONS(14993),
  },
  [9161] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12546),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9162] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14995),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(14997),
    [sym__plus_operator] = ACTIONS(14999),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9163] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9164] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(14981),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14959),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(14961),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(14983),
    [sym__arrow_operator] = ACTIONS(14985),
    [sym__lazy_or_operator] = ACTIONS(14987),
    [sym__lazy_and_operator] = ACTIONS(14989),
    [sym__comparison_operator] = ACTIONS(14961),
    [sym__pipe_right_operator] = ACTIONS(14963),
    [sym__pipe_left_operator] = ACTIONS(14965),
    [sym__ellipsis_operator] = ACTIONS(14967),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(14961),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [9165] = {
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_EQ] = ACTIONS(12790),
    [anon_sym_COMMA] = ACTIONS(13199),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(13201),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13199),
    [anon_sym_RPAREN] = ACTIONS(13199),
    [anon_sym_COLON2] = ACTIONS(13201),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(13201),
    [anon_sym_SEMI] = ACTIONS(13199),
    [anon_sym_LBRACE] = ACTIONS(13199),
    [anon_sym_DOLLAR] = ACTIONS(13199),
    [anon_sym_COLON_COLON] = ACTIONS(13199),
    [anon_sym_isa] = ACTIONS(13201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13199),
    [anon_sym_QMARK] = ACTIONS(13199),
    [anon_sym_AT] = ACTIONS(13199),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13199),
    [aux_sym_integer_literal_token2] = ACTIONS(13199),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13199),
    [aux_sym_float_literal_token3] = ACTIONS(13199),
    [aux_sym_float_literal_token4] = ACTIONS(13199),
    [sym_character_literal] = ACTIONS(13199),
    [sym__pair_operator] = ACTIONS(13199),
    [sym__arrow_operator] = ACTIONS(13201),
    [sym__lazy_or_operator] = ACTIONS(13199),
    [sym__lazy_and_operator] = ACTIONS(13199),
    [sym__comparison_operator] = ACTIONS(13201),
    [sym__pipe_right_operator] = ACTIONS(13199),
    [sym__pipe_left_operator] = ACTIONS(13199),
    [sym__ellipsis_operator] = ACTIONS(13201),
    [sym__plus_operator] = ACTIONS(13201),
    [sym__times_operator] = ACTIONS(13201),
    [sym__rational_operator] = ACTIONS(13199),
    [sym__bitshift_operator] = ACTIONS(13199),
    [sym__power_operator] = ACTIONS(13199),
    [sym__tilde_operator] = ACTIONS(13199),
    [sym__type_order_operator] = ACTIONS(13199),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(13201),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [9166] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(12790),
    [anon_sym_COMMA] = ACTIONS(12934),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12934),
    [anon_sym_RPAREN] = ACTIONS(12934),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_SEMI] = ACTIONS(12934),
    [anon_sym_LBRACE] = ACTIONS(12934),
    [anon_sym_DOLLAR] = ACTIONS(12934),
    [anon_sym_COLON_COLON] = ACTIONS(12934),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12934),
    [anon_sym_QMARK] = ACTIONS(12934),
    [anon_sym_AT] = ACTIONS(12934),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12934),
    [aux_sym_integer_literal_token2] = ACTIONS(12934),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12934),
    [aux_sym_float_literal_token3] = ACTIONS(12934),
    [aux_sym_float_literal_token4] = ACTIONS(12934),
    [sym_character_literal] = ACTIONS(12934),
    [sym__pair_operator] = ACTIONS(12934),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12934),
    [sym__lazy_and_operator] = ACTIONS(12934),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12934),
    [sym__pipe_left_operator] = ACTIONS(12934),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12934),
    [sym__bitshift_operator] = ACTIONS(12934),
    [sym__power_operator] = ACTIONS(12934),
    [sym__tilde_operator] = ACTIONS(12934),
    [sym__type_order_operator] = ACTIONS(12934),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [9167] = {
    [sym__word_identifier] = ACTIONS(13070),
    [anon_sym_EQ] = ACTIONS(13070),
    [anon_sym_COMMA] = ACTIONS(13075),
    [anon_sym_COLON] = ACTIONS(13070),
    [anon_sym_begin] = ACTIONS(13070),
    [anon_sym_module] = ACTIONS(13070),
    [anon_sym_baremodule] = ACTIONS(13070),
    [anon_sym_abstract] = ACTIONS(13070),
    [anon_sym_primitive] = ACTIONS(13070),
    [anon_sym_mutable] = ACTIONS(13070),
    [anon_sym_struct] = ACTIONS(13070),
    [anon_sym_function] = ACTIONS(13070),
    [anon_sym_macro] = ACTIONS(13070),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13070),
    [anon_sym_let] = ACTIONS(13070),
    [anon_sym_if] = ACTIONS(13070),
    [anon_sym_try] = ACTIONS(13070),
    [anon_sym_for] = ACTIONS(13070),
    [anon_sym_while] = ACTIONS(13070),
    [sym_break_statement] = ACTIONS(13070),
    [sym_continue_statement] = ACTIONS(13070),
    [anon_sym_return] = ACTIONS(13070),
    [anon_sym_const] = ACTIONS(13070),
    [anon_sym_global] = ACTIONS(13070),
    [anon_sym_local] = ACTIONS(13070),
    [anon_sym_LPAREN] = ACTIONS(13075),
    [anon_sym_RPAREN] = ACTIONS(13075),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13070),
    [anon_sym_import] = ACTIONS(13070),
    [anon_sym_using] = ACTIONS(13070),
    [anon_sym_LBRACK] = ACTIONS(13075),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(13075),
    [anon_sym_DOLLAR] = ACTIONS(13075),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14913),
    [anon_sym_AT] = ACTIONS(13075),
    [anon_sym_true] = ACTIONS(13070),
    [anon_sym_false] = ACTIONS(13070),
    [aux_sym_integer_literal_token1] = ACTIONS(13075),
    [aux_sym_integer_literal_token2] = ACTIONS(13075),
    [aux_sym_integer_literal_token3] = ACTIONS(13070),
    [aux_sym_integer_literal_token4] = ACTIONS(13070),
    [aux_sym_float_literal_token1] = ACTIONS(13075),
    [aux_sym_float_literal_token3] = ACTIONS(13075),
    [aux_sym_float_literal_token4] = ACTIONS(13075),
    [sym_character_literal] = ACTIONS(13075),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13075),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13070),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13075),
    [sym__command_start] = ACTIONS(13075),
  },
  [9168] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14995),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(15009),
    [sym__pipe_left_operator] = ACTIONS(15011),
    [sym__ellipsis_operator] = ACTIONS(14997),
    [sym__plus_operator] = ACTIONS(14999),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9169] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13094),
    [anon_sym_COMMA] = ACTIONS(13100),
    [anon_sym_COLON] = ACTIONS(13094),
    [anon_sym_begin] = ACTIONS(13094),
    [anon_sym_module] = ACTIONS(13094),
    [anon_sym_baremodule] = ACTIONS(13094),
    [anon_sym_abstract] = ACTIONS(13094),
    [anon_sym_primitive] = ACTIONS(13094),
    [anon_sym_mutable] = ACTIONS(13094),
    [anon_sym_struct] = ACTIONS(13094),
    [anon_sym_function] = ACTIONS(13094),
    [anon_sym_macro] = ACTIONS(13094),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13094),
    [anon_sym_let] = ACTIONS(13094),
    [anon_sym_if] = ACTIONS(13094),
    [anon_sym_try] = ACTIONS(13094),
    [anon_sym_for] = ACTIONS(13094),
    [anon_sym_while] = ACTIONS(13094),
    [sym_break_statement] = ACTIONS(13094),
    [sym_continue_statement] = ACTIONS(13094),
    [anon_sym_return] = ACTIONS(13094),
    [anon_sym_const] = ACTIONS(13094),
    [anon_sym_global] = ACTIONS(13094),
    [anon_sym_local] = ACTIONS(13094),
    [anon_sym_LPAREN] = ACTIONS(13100),
    [anon_sym_RPAREN] = ACTIONS(13100),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13094),
    [anon_sym_import] = ACTIONS(13094),
    [anon_sym_using] = ACTIONS(13094),
    [anon_sym_LBRACK] = ACTIONS(13100),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13100),
    [anon_sym_LBRACE] = ACTIONS(13100),
    [anon_sym_DOLLAR] = ACTIONS(13100),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(15013),
    [anon_sym_AT] = ACTIONS(13100),
    [anon_sym_true] = ACTIONS(13094),
    [anon_sym_false] = ACTIONS(13094),
    [aux_sym_integer_literal_token1] = ACTIONS(13100),
    [aux_sym_integer_literal_token2] = ACTIONS(13100),
    [aux_sym_integer_literal_token3] = ACTIONS(13094),
    [aux_sym_integer_literal_token4] = ACTIONS(13094),
    [aux_sym_float_literal_token1] = ACTIONS(13100),
    [aux_sym_float_literal_token3] = ACTIONS(13100),
    [aux_sym_float_literal_token4] = ACTIONS(13100),
    [sym_character_literal] = ACTIONS(13100),
    [sym__pair_operator] = ACTIONS(13100),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13100),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13094),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13100),
    [sym__command_start] = ACTIONS(13100),
  },
  [9170] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_EQ] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(15015),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(15017),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_RBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(15019),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(15021),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(15023),
    [sym__arrow_operator] = ACTIONS(15025),
    [sym__lazy_or_operator] = ACTIONS(15027),
    [sym__lazy_and_operator] = ACTIONS(15029),
    [sym__comparison_operator] = ACTIONS(15019),
    [sym__pipe_right_operator] = ACTIONS(15031),
    [sym__pipe_left_operator] = ACTIONS(15033),
    [sym__ellipsis_operator] = ACTIONS(15035),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(15019),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [9171] = {
    [aux_sym_open_tuple_repeat1] = STATE(8915),
    [sym__word_identifier] = ACTIONS(13201),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_COLON] = ACTIONS(13201),
    [anon_sym_begin] = ACTIONS(13201),
    [anon_sym_module] = ACTIONS(13201),
    [anon_sym_baremodule] = ACTIONS(13201),
    [anon_sym_abstract] = ACTIONS(13201),
    [anon_sym_primitive] = ACTIONS(13201),
    [anon_sym_mutable] = ACTIONS(13201),
    [anon_sym_struct] = ACTIONS(13201),
    [anon_sym_function] = ACTIONS(13201),
    [anon_sym_macro] = ACTIONS(13201),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13201),
    [anon_sym_let] = ACTIONS(13201),
    [anon_sym_if] = ACTIONS(13201),
    [anon_sym_try] = ACTIONS(13201),
    [anon_sym_for] = ACTIONS(13201),
    [anon_sym_while] = ACTIONS(13201),
    [sym_break_statement] = ACTIONS(13201),
    [sym_continue_statement] = ACTIONS(13201),
    [anon_sym_return] = ACTIONS(13201),
    [anon_sym_const] = ACTIONS(13201),
    [anon_sym_global] = ACTIONS(13201),
    [anon_sym_local] = ACTIONS(13201),
    [anon_sym_LPAREN] = ACTIONS(13199),
    [anon_sym_RPAREN] = ACTIONS(13199),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13201),
    [anon_sym_import] = ACTIONS(13201),
    [anon_sym_using] = ACTIONS(13201),
    [anon_sym_LBRACK] = ACTIONS(13199),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13199),
    [anon_sym_LBRACE] = ACTIONS(13199),
    [anon_sym_DOLLAR] = ACTIONS(13199),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(15013),
    [anon_sym_AT] = ACTIONS(13199),
    [anon_sym_true] = ACTIONS(13201),
    [anon_sym_false] = ACTIONS(13201),
    [aux_sym_integer_literal_token1] = ACTIONS(13199),
    [aux_sym_integer_literal_token2] = ACTIONS(13199),
    [aux_sym_integer_literal_token3] = ACTIONS(13201),
    [aux_sym_integer_literal_token4] = ACTIONS(13201),
    [aux_sym_float_literal_token1] = ACTIONS(13199),
    [aux_sym_float_literal_token3] = ACTIONS(13199),
    [aux_sym_float_literal_token4] = ACTIONS(13199),
    [sym_character_literal] = ACTIONS(13199),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13199),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13201),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13199),
    [sym__command_start] = ACTIONS(13199),
  },
  [9172] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_RPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(14943),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(15047),
    [anon_sym_SEMI] = ACTIONS(13334),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(15047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(15047),
    [sym__pipe_right_operator] = ACTIONS(14955),
    [sym__pipe_left_operator] = ACTIONS(14957),
    [sym__ellipsis_operator] = ACTIONS(14945),
    [sym__plus_operator] = ACTIONS(14947),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(15047),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [9173] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11408),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(11408),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DASH_GT] = ACTIONS(12426),
    [anon_sym_AT] = ACTIONS(11408),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11408),
    [aux_sym_integer_literal_token2] = ACTIONS(11408),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11408),
    [aux_sym_float_literal_token3] = ACTIONS(11408),
    [aux_sym_float_literal_token4] = ACTIONS(11408),
    [sym_character_literal] = ACTIONS(11408),
    [sym__pair_operator] = ACTIONS(11408),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11408),
    [sym__pipe_left_operator] = ACTIONS(11408),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11408),
    [sym__bitshift_operator] = ACTIONS(11408),
    [sym__power_operator] = ACTIONS(11408),
    [sym__tilde_operator] = ACTIONS(11408),
    [sym__type_order_operator] = ACTIONS(11408),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9174] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_RPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_SEMI] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14947),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [9175] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14943),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14955),
    [sym__pipe_left_operator] = ACTIONS(14957),
    [sym__ellipsis_operator] = ACTIONS(14945),
    [sym__plus_operator] = ACTIONS(14947),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9176] = {
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_EQ] = ACTIONS(14979),
    [anon_sym_COMMA] = ACTIONS(13241),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(13239),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13241),
    [anon_sym_RPAREN] = ACTIONS(13241),
    [anon_sym_COLON2] = ACTIONS(13239),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(13239),
    [anon_sym_SEMI] = ACTIONS(13241),
    [anon_sym_LBRACE] = ACTIONS(13241),
    [anon_sym_DOLLAR] = ACTIONS(13241),
    [anon_sym_COLON_COLON] = ACTIONS(13241),
    [anon_sym_isa] = ACTIONS(13239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13241),
    [anon_sym_QMARK] = ACTIONS(13241),
    [anon_sym_AT] = ACTIONS(13241),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13241),
    [aux_sym_integer_literal_token2] = ACTIONS(13241),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13241),
    [aux_sym_float_literal_token3] = ACTIONS(13241),
    [aux_sym_float_literal_token4] = ACTIONS(13241),
    [sym_character_literal] = ACTIONS(13241),
    [sym__pair_operator] = ACTIONS(13241),
    [sym__arrow_operator] = ACTIONS(13239),
    [sym__lazy_or_operator] = ACTIONS(13241),
    [sym__lazy_and_operator] = ACTIONS(13241),
    [sym__comparison_operator] = ACTIONS(13239),
    [sym__pipe_right_operator] = ACTIONS(13241),
    [sym__pipe_left_operator] = ACTIONS(13241),
    [sym__ellipsis_operator] = ACTIONS(13239),
    [sym__plus_operator] = ACTIONS(13239),
    [sym__times_operator] = ACTIONS(13239),
    [sym__rational_operator] = ACTIONS(13241),
    [sym__bitshift_operator] = ACTIONS(13241),
    [sym__power_operator] = ACTIONS(13241),
    [sym__tilde_operator] = ACTIONS(13241),
    [sym__type_order_operator] = ACTIONS(13241),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(13239),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [9177] = {
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_EQ] = ACTIONS(14979),
    [anon_sym_COMMA] = ACTIONS(13245),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(13243),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13245),
    [anon_sym_RPAREN] = ACTIONS(13245),
    [anon_sym_COLON2] = ACTIONS(13243),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(13243),
    [anon_sym_SEMI] = ACTIONS(13245),
    [anon_sym_LBRACE] = ACTIONS(13245),
    [anon_sym_DOLLAR] = ACTIONS(13245),
    [anon_sym_COLON_COLON] = ACTIONS(13245),
    [anon_sym_isa] = ACTIONS(13243),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13245),
    [anon_sym_QMARK] = ACTIONS(13245),
    [anon_sym_AT] = ACTIONS(13245),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13245),
    [aux_sym_integer_literal_token2] = ACTIONS(13245),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13245),
    [aux_sym_float_literal_token3] = ACTIONS(13245),
    [aux_sym_float_literal_token4] = ACTIONS(13245),
    [sym_character_literal] = ACTIONS(13245),
    [sym__pair_operator] = ACTIONS(13245),
    [sym__arrow_operator] = ACTIONS(13243),
    [sym__lazy_or_operator] = ACTIONS(13245),
    [sym__lazy_and_operator] = ACTIONS(13245),
    [sym__comparison_operator] = ACTIONS(13243),
    [sym__pipe_right_operator] = ACTIONS(13245),
    [sym__pipe_left_operator] = ACTIONS(13245),
    [sym__ellipsis_operator] = ACTIONS(13243),
    [sym__plus_operator] = ACTIONS(13243),
    [sym__times_operator] = ACTIONS(13243),
    [sym__rational_operator] = ACTIONS(13245),
    [sym__bitshift_operator] = ACTIONS(13245),
    [sym__power_operator] = ACTIONS(13245),
    [sym__tilde_operator] = ACTIONS(13245),
    [sym__type_order_operator] = ACTIONS(13245),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(13243),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [9178] = {
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_EQ] = ACTIONS(14979),
    [anon_sym_COMMA] = ACTIONS(12934),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(12926),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12934),
    [anon_sym_RPAREN] = ACTIONS(12934),
    [anon_sym_COLON2] = ACTIONS(12926),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(12926),
    [anon_sym_SEMI] = ACTIONS(12934),
    [anon_sym_LBRACE] = ACTIONS(12934),
    [anon_sym_DOLLAR] = ACTIONS(12934),
    [anon_sym_COLON_COLON] = ACTIONS(12934),
    [anon_sym_isa] = ACTIONS(12926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12934),
    [anon_sym_QMARK] = ACTIONS(12934),
    [anon_sym_AT] = ACTIONS(12934),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12934),
    [aux_sym_integer_literal_token2] = ACTIONS(12934),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12934),
    [aux_sym_float_literal_token3] = ACTIONS(12934),
    [aux_sym_float_literal_token4] = ACTIONS(12934),
    [sym_character_literal] = ACTIONS(12934),
    [sym__pair_operator] = ACTIONS(12934),
    [sym__arrow_operator] = ACTIONS(12926),
    [sym__lazy_or_operator] = ACTIONS(12934),
    [sym__lazy_and_operator] = ACTIONS(12934),
    [sym__comparison_operator] = ACTIONS(12926),
    [sym__pipe_right_operator] = ACTIONS(12934),
    [sym__pipe_left_operator] = ACTIONS(12934),
    [sym__ellipsis_operator] = ACTIONS(12926),
    [sym__plus_operator] = ACTIONS(12926),
    [sym__times_operator] = ACTIONS(12926),
    [sym__rational_operator] = ACTIONS(12934),
    [sym__bitshift_operator] = ACTIONS(12934),
    [sym__power_operator] = ACTIONS(12934),
    [sym__tilde_operator] = ACTIONS(12934),
    [sym__type_order_operator] = ACTIONS(12934),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(12926),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [9179] = {
    [aux_sym_open_tuple_repeat1] = STATE(8915),
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13247),
    [anon_sym_RPAREN] = ACTIONS(13247),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13247),
    [anon_sym_LBRACE] = ACTIONS(13247),
    [anon_sym_DOLLAR] = ACTIONS(13247),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(15013),
    [anon_sym_AT] = ACTIONS(13247),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13247),
    [aux_sym_integer_literal_token2] = ACTIONS(13247),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13247),
    [aux_sym_float_literal_token3] = ACTIONS(13247),
    [aux_sym_float_literal_token4] = ACTIONS(13247),
    [sym_character_literal] = ACTIONS(13247),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13247),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [9180] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_EQ] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13336),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13336),
    [anon_sym_RPAREN] = ACTIONS(13336),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13336),
    [anon_sym_LBRACE] = ACTIONS(13336),
    [anon_sym_DOLLAR] = ACTIONS(13336),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13336),
    [anon_sym_AT] = ACTIONS(13336),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13336),
    [aux_sym_integer_literal_token2] = ACTIONS(13336),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13336),
    [aux_sym_float_literal_token3] = ACTIONS(13336),
    [aux_sym_float_literal_token4] = ACTIONS(13336),
    [sym_character_literal] = ACTIONS(13336),
    [sym__pair_operator] = ACTIONS(13336),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13336),
    [sym__lazy_and_operator] = ACTIONS(13336),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13336),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [9181] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_EQ] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13465),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13465),
    [anon_sym_RPAREN] = ACTIONS(13465),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_SEMI] = ACTIONS(13465),
    [anon_sym_LBRACE] = ACTIONS(13465),
    [anon_sym_DOLLAR] = ACTIONS(13465),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13465),
    [anon_sym_QMARK] = ACTIONS(13465),
    [anon_sym_AT] = ACTIONS(13465),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13465),
    [aux_sym_integer_literal_token2] = ACTIONS(13465),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13465),
    [aux_sym_float_literal_token3] = ACTIONS(13465),
    [aux_sym_float_literal_token4] = ACTIONS(13465),
    [sym_character_literal] = ACTIONS(13465),
    [sym__pair_operator] = ACTIONS(13465),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13465),
    [sym__lazy_and_operator] = ACTIONS(13465),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13465),
    [sym__pipe_left_operator] = ACTIONS(13465),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13465),
    [sym__type_order_operator] = ACTIONS(13465),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [9182] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9183] = {
    [aux_sym_open_tuple_repeat1] = STATE(16971),
    [sym__word_identifier] = ACTIONS(13255),
    [anon_sym_COMMA] = ACTIONS(13253),
    [anon_sym_COLON] = ACTIONS(13255),
    [anon_sym_begin] = ACTIONS(13255),
    [anon_sym_module] = ACTIONS(13255),
    [anon_sym_baremodule] = ACTIONS(13255),
    [anon_sym_abstract] = ACTIONS(13255),
    [anon_sym_primitive] = ACTIONS(13255),
    [anon_sym_mutable] = ACTIONS(13255),
    [anon_sym_struct] = ACTIONS(13255),
    [anon_sym_function] = ACTIONS(13255),
    [anon_sym_macro] = ACTIONS(13255),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13255),
    [anon_sym_let] = ACTIONS(13255),
    [anon_sym_if] = ACTIONS(13255),
    [anon_sym_try] = ACTIONS(13255),
    [anon_sym_for] = ACTIONS(13255),
    [anon_sym_while] = ACTIONS(13255),
    [sym_break_statement] = ACTIONS(13255),
    [sym_continue_statement] = ACTIONS(13255),
    [anon_sym_return] = ACTIONS(13255),
    [anon_sym_const] = ACTIONS(13255),
    [anon_sym_global] = ACTIONS(13255),
    [anon_sym_local] = ACTIONS(13255),
    [anon_sym_LPAREN] = ACTIONS(13253),
    [anon_sym_RPAREN] = ACTIONS(13253),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13255),
    [anon_sym_import] = ACTIONS(13255),
    [anon_sym_using] = ACTIONS(13255),
    [anon_sym_LBRACK] = ACTIONS(13253),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13253),
    [anon_sym_LBRACE] = ACTIONS(13253),
    [anon_sym_DOLLAR] = ACTIONS(13253),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(15013),
    [anon_sym_AT] = ACTIONS(13253),
    [anon_sym_true] = ACTIONS(13255),
    [anon_sym_false] = ACTIONS(13255),
    [aux_sym_integer_literal_token1] = ACTIONS(13253),
    [aux_sym_integer_literal_token2] = ACTIONS(13253),
    [aux_sym_integer_literal_token3] = ACTIONS(13255),
    [aux_sym_integer_literal_token4] = ACTIONS(13255),
    [aux_sym_float_literal_token1] = ACTIONS(13253),
    [aux_sym_float_literal_token3] = ACTIONS(13253),
    [aux_sym_float_literal_token4] = ACTIONS(13253),
    [sym_character_literal] = ACTIONS(13253),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13253),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13255),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13253),
    [sym__command_start] = ACTIONS(13253),
  },
  [9184] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_DASH_GT] = ACTIONS(12442),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9185] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14913),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9186] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15049),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14943),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15047),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(15047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(15047),
    [sym__pipe_right_operator] = ACTIONS(14955),
    [sym__pipe_left_operator] = ACTIONS(14957),
    [sym__ellipsis_operator] = ACTIONS(14945),
    [sym__plus_operator] = ACTIONS(14947),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15047),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9187] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9188] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9189] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9190] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9191] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9192] = {
    [sym__word_identifier] = ACTIONS(11397),
    [anon_sym_EQ] = ACTIONS(12838),
    [anon_sym_COLON] = ACTIONS(11397),
    [anon_sym_begin] = ACTIONS(11397),
    [anon_sym_module] = ACTIONS(11397),
    [anon_sym_baremodule] = ACTIONS(11397),
    [anon_sym_abstract] = ACTIONS(11397),
    [anon_sym_primitive] = ACTIONS(11397),
    [anon_sym_mutable] = ACTIONS(11397),
    [anon_sym_struct] = ACTIONS(11397),
    [anon_sym_function] = ACTIONS(11397),
    [anon_sym_macro] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_quote] = ACTIONS(11397),
    [anon_sym_let] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_try] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_while] = ACTIONS(11397),
    [sym_break_statement] = ACTIONS(11397),
    [sym_continue_statement] = ACTIONS(11397),
    [anon_sym_return] = ACTIONS(11397),
    [anon_sym_const] = ACTIONS(11397),
    [anon_sym_global] = ACTIONS(11397),
    [anon_sym_local] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_export] = ACTIONS(11397),
    [anon_sym_import] = ACTIONS(11397),
    [anon_sym_using] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(11397),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(11397),
    [anon_sym_DOLLAR] = ACTIONS(11397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(11397),
    [anon_sym_true] = ACTIONS(11397),
    [anon_sym_false] = ACTIONS(11397),
    [aux_sym_integer_literal_token1] = ACTIONS(11397),
    [aux_sym_integer_literal_token2] = ACTIONS(11397),
    [aux_sym_integer_literal_token3] = ACTIONS(11397),
    [aux_sym_integer_literal_token4] = ACTIONS(11397),
    [aux_sym_float_literal_token1] = ACTIONS(11397),
    [aux_sym_float_literal_token3] = ACTIONS(11397),
    [aux_sym_float_literal_token4] = ACTIONS(11397),
    [sym_character_literal] = ACTIONS(11397),
    [sym__pair_operator] = ACTIONS(11397),
    [sym__arrow_operator] = ACTIONS(11397),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11397),
    [sym__pipe_right_operator] = ACTIONS(11397),
    [sym__pipe_left_operator] = ACTIONS(11397),
    [sym__ellipsis_operator] = ACTIONS(11397),
    [sym__plus_operator] = ACTIONS(11397),
    [sym__times_operator] = ACTIONS(11397),
    [sym__rational_operator] = ACTIONS(11397),
    [sym__bitshift_operator] = ACTIONS(11397),
    [sym__power_operator] = ACTIONS(11397),
    [sym__tilde_operator] = ACTIONS(11397),
    [sym__type_order_operator] = ACTIONS(11397),
    [sym__unary_operator] = ACTIONS(11397),
    [sym__unary_plus_operator] = ACTIONS(11397),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11408),
    [sym__command_start] = ACTIONS(11408),
  },
  [9193] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(14979),
    [anon_sym_COMMA] = ACTIONS(13247),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13247),
    [anon_sym_RPAREN] = ACTIONS(13247),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_SEMI] = ACTIONS(13247),
    [anon_sym_LBRACE] = ACTIONS(13247),
    [anon_sym_DOLLAR] = ACTIONS(13247),
    [anon_sym_COLON_COLON] = ACTIONS(13247),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13247),
    [anon_sym_QMARK] = ACTIONS(13247),
    [anon_sym_AT] = ACTIONS(13247),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13247),
    [aux_sym_integer_literal_token2] = ACTIONS(13247),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13247),
    [aux_sym_float_literal_token3] = ACTIONS(13247),
    [aux_sym_float_literal_token4] = ACTIONS(13247),
    [sym_character_literal] = ACTIONS(13247),
    [sym__pair_operator] = ACTIONS(13247),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13247),
    [sym__lazy_and_operator] = ACTIONS(13247),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13247),
    [sym__pipe_left_operator] = ACTIONS(13247),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13247),
    [sym__bitshift_operator] = ACTIONS(13247),
    [sym__power_operator] = ACTIONS(13247),
    [sym__tilde_operator] = ACTIONS(13247),
    [sym__type_order_operator] = ACTIONS(13247),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [9194] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9195] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(15049),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_RPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(14943),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(15047),
    [anon_sym_SEMI] = ACTIONS(13338),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(15047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14808),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(15051),
    [sym__arrow_operator] = ACTIONS(15053),
    [sym__lazy_or_operator] = ACTIONS(15055),
    [sym__lazy_and_operator] = ACTIONS(15057),
    [sym__comparison_operator] = ACTIONS(15047),
    [sym__pipe_right_operator] = ACTIONS(14955),
    [sym__pipe_left_operator] = ACTIONS(14957),
    [sym__ellipsis_operator] = ACTIONS(14945),
    [sym__plus_operator] = ACTIONS(14947),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(15047),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [9196] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13312),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9197] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13312),
    [sym__bitshift_operator] = ACTIONS(13312),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9198] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9199] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13340),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(15059),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13340),
    [anon_sym_RPAREN] = ACTIONS(13340),
    [anon_sym_COLON2] = ACTIONS(14995),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13340),
    [anon_sym_RBRACK] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(13340),
    [anon_sym_RBRACE] = ACTIONS(13340),
    [anon_sym_DOLLAR] = ACTIONS(13340),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14828),
    [anon_sym_AT] = ACTIONS(13340),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13340),
    [aux_sym_integer_literal_token2] = ACTIONS(13340),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13340),
    [aux_sym_float_literal_token3] = ACTIONS(13340),
    [aux_sym_float_literal_token4] = ACTIONS(13340),
    [sym_character_literal] = ACTIONS(13340),
    [sym__pair_operator] = ACTIONS(15063),
    [sym__arrow_operator] = ACTIONS(15065),
    [sym__lazy_or_operator] = ACTIONS(15067),
    [sym__lazy_and_operator] = ACTIONS(15069),
    [sym__comparison_operator] = ACTIONS(15061),
    [sym__pipe_right_operator] = ACTIONS(15009),
    [sym__pipe_left_operator] = ACTIONS(15011),
    [sym__ellipsis_operator] = ACTIONS(14997),
    [sym__plus_operator] = ACTIONS(14999),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13340),
    [sym__type_order_operator] = ACTIONS(15071),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(14999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [9200] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15049),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14943),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15047),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(15047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(14808),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(15051),
    [sym__arrow_operator] = ACTIONS(15053),
    [sym__lazy_or_operator] = ACTIONS(15055),
    [sym__lazy_and_operator] = ACTIONS(15057),
    [sym__comparison_operator] = ACTIONS(15047),
    [sym__pipe_right_operator] = ACTIONS(14955),
    [sym__pipe_left_operator] = ACTIONS(14957),
    [sym__ellipsis_operator] = ACTIONS(14945),
    [sym__plus_operator] = ACTIONS(14947),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15047),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9201] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15049),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14943),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15047),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(15047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(15053),
    [sym__lazy_or_operator] = ACTIONS(15055),
    [sym__lazy_and_operator] = ACTIONS(15057),
    [sym__comparison_operator] = ACTIONS(15047),
    [sym__pipe_right_operator] = ACTIONS(14955),
    [sym__pipe_left_operator] = ACTIONS(14957),
    [sym__ellipsis_operator] = ACTIONS(14945),
    [sym__plus_operator] = ACTIONS(14947),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15047),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9202] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_RBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9203] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_EQ] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(15017),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_RBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(15019),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(15019),
    [sym__pipe_right_operator] = ACTIONS(15031),
    [sym__pipe_left_operator] = ACTIONS(15033),
    [sym__ellipsis_operator] = ACTIONS(15035),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(15019),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [9204] = {
    [sym__word_identifier] = ACTIONS(15073),
    [anon_sym_COMMA] = ACTIONS(15073),
    [anon_sym_COLON] = ACTIONS(15073),
    [anon_sym_begin] = ACTIONS(15073),
    [anon_sym_module] = ACTIONS(15073),
    [anon_sym_baremodule] = ACTIONS(15073),
    [anon_sym_end] = ACTIONS(15073),
    [anon_sym_abstract] = ACTIONS(15073),
    [anon_sym_primitive] = ACTIONS(15073),
    [anon_sym_mutable] = ACTIONS(15073),
    [anon_sym_struct] = ACTIONS(15073),
    [anon_sym_function] = ACTIONS(15073),
    [anon_sym_macro] = ACTIONS(15073),
    [anon_sym_where] = ACTIONS(14981),
    [anon_sym_quote] = ACTIONS(15073),
    [anon_sym_let] = ACTIONS(15073),
    [anon_sym_if] = ACTIONS(15073),
    [anon_sym_try] = ACTIONS(15073),
    [anon_sym_for] = ACTIONS(15073),
    [anon_sym_while] = ACTIONS(15073),
    [sym_break_statement] = ACTIONS(15073),
    [sym_continue_statement] = ACTIONS(15073),
    [anon_sym_return] = ACTIONS(15073),
    [anon_sym_const] = ACTIONS(15073),
    [anon_sym_global] = ACTIONS(15073),
    [anon_sym_local] = ACTIONS(15073),
    [anon_sym_LPAREN] = ACTIONS(15073),
    [anon_sym_COLON2] = ACTIONS(14959),
    [anon_sym_export] = ACTIONS(15073),
    [anon_sym_import] = ACTIONS(15073),
    [anon_sym_using] = ACTIONS(15073),
    [anon_sym_LBRACK] = ACTIONS(15073),
    [anon_sym_LF] = ACTIONS(15075),
    [anon_sym_in] = ACTIONS(14961),
    [anon_sym_LBRACE] = ACTIONS(15073),
    [anon_sym_DOLLAR] = ACTIONS(15073),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(15073),
    [anon_sym_true] = ACTIONS(15073),
    [anon_sym_false] = ACTIONS(15073),
    [aux_sym_integer_literal_token1] = ACTIONS(15073),
    [aux_sym_integer_literal_token2] = ACTIONS(15073),
    [aux_sym_integer_literal_token3] = ACTIONS(15073),
    [aux_sym_integer_literal_token4] = ACTIONS(15073),
    [aux_sym_float_literal_token1] = ACTIONS(15073),
    [aux_sym_float_literal_token3] = ACTIONS(15073),
    [aux_sym_float_literal_token4] = ACTIONS(15073),
    [sym_character_literal] = ACTIONS(15073),
    [sym__pair_operator] = ACTIONS(14983),
    [sym__arrow_operator] = ACTIONS(14985),
    [sym__lazy_or_operator] = ACTIONS(14987),
    [sym__lazy_and_operator] = ACTIONS(14989),
    [sym__comparison_operator] = ACTIONS(14961),
    [sym__pipe_right_operator] = ACTIONS(14963),
    [sym__pipe_left_operator] = ACTIONS(14965),
    [sym__ellipsis_operator] = ACTIONS(14967),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(15073),
    [sym__type_order_operator] = ACTIONS(14961),
    [sym__unary_operator] = ACTIONS(15073),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(15073),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(15075),
    [sym__command_start] = ACTIONS(15075),
  },
  [9205] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_EQ] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_RBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [9206] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15017),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(15031),
    [sym__pipe_left_operator] = ACTIONS(15033),
    [sym__ellipsis_operator] = ACTIONS(15035),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9207] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13310),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13310),
    [anon_sym_RPAREN] = ACTIONS(13310),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13310),
    [anon_sym_RBRACK] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13310),
    [anon_sym_RBRACE] = ACTIONS(13310),
    [anon_sym_DOLLAR] = ACTIONS(13310),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13310),
    [anon_sym_QMARK] = ACTIONS(13310),
    [anon_sym_AT] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13310),
    [aux_sym_integer_literal_token2] = ACTIONS(13310),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13310),
    [aux_sym_float_literal_token3] = ACTIONS(13310),
    [aux_sym_float_literal_token4] = ACTIONS(13310),
    [sym_character_literal] = ACTIONS(13310),
    [sym__pair_operator] = ACTIONS(13310),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13310),
    [sym__lazy_and_operator] = ACTIONS(13310),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13310),
    [sym__pipe_left_operator] = ACTIONS(13310),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13310),
    [sym__bitshift_operator] = ACTIONS(13310),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13310),
    [sym__type_order_operator] = ACTIONS(13310),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9208] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [9209] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9210] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9211] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9212] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9213] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9214] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15015),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15017),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15019),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(15021),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(15023),
    [sym__arrow_operator] = ACTIONS(15025),
    [sym__lazy_or_operator] = ACTIONS(15027),
    [sym__lazy_and_operator] = ACTIONS(15029),
    [sym__comparison_operator] = ACTIONS(15019),
    [sym__pipe_right_operator] = ACTIONS(15031),
    [sym__pipe_left_operator] = ACTIONS(15033),
    [sym__ellipsis_operator] = ACTIONS(15035),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15019),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9215] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15015),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15017),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15019),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(15025),
    [sym__lazy_or_operator] = ACTIONS(15027),
    [sym__lazy_and_operator] = ACTIONS(15029),
    [sym__comparison_operator] = ACTIONS(15019),
    [sym__pipe_right_operator] = ACTIONS(15031),
    [sym__pipe_left_operator] = ACTIONS(15033),
    [sym__ellipsis_operator] = ACTIONS(15035),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15019),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9216] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15015),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15017),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15019),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(15029),
    [sym__comparison_operator] = ACTIONS(15019),
    [sym__pipe_right_operator] = ACTIONS(15031),
    [sym__pipe_left_operator] = ACTIONS(15033),
    [sym__ellipsis_operator] = ACTIONS(15035),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15019),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9217] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15015),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15017),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15019),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(15019),
    [sym__pipe_right_operator] = ACTIONS(15031),
    [sym__pipe_left_operator] = ACTIONS(15033),
    [sym__ellipsis_operator] = ACTIONS(15035),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15019),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9218] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15017),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(15035),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9219] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15017),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(15031),
    [sym__pipe_left_operator] = ACTIONS(15033),
    [sym__ellipsis_operator] = ACTIONS(15035),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9220] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9221] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9222] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9223] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9224] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9225] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13336),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13336),
    [anon_sym_RPAREN] = ACTIONS(13336),
    [anon_sym_COLON2] = ACTIONS(14995),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13336),
    [anon_sym_RBRACK] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(13336),
    [anon_sym_RBRACE] = ACTIONS(13336),
    [anon_sym_DOLLAR] = ACTIONS(13336),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13336),
    [anon_sym_AT] = ACTIONS(13336),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13336),
    [aux_sym_integer_literal_token2] = ACTIONS(13336),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13336),
    [aux_sym_float_literal_token3] = ACTIONS(13336),
    [aux_sym_float_literal_token4] = ACTIONS(13336),
    [sym_character_literal] = ACTIONS(13336),
    [sym__pair_operator] = ACTIONS(13336),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13336),
    [sym__lazy_and_operator] = ACTIONS(13336),
    [sym__comparison_operator] = ACTIONS(15061),
    [sym__pipe_right_operator] = ACTIONS(15009),
    [sym__pipe_left_operator] = ACTIONS(15011),
    [sym__ellipsis_operator] = ACTIONS(14997),
    [sym__plus_operator] = ACTIONS(14999),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13336),
    [sym__type_order_operator] = ACTIONS(15071),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(14999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [9226] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14995),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(15009),
    [sym__pipe_left_operator] = ACTIONS(15011),
    [sym__ellipsis_operator] = ACTIONS(14997),
    [sym__plus_operator] = ACTIONS(14999),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9227] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15049),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_RPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(14943),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15047),
    [anon_sym_SEMI] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14750),
    [anon_sym_isa] = ACTIONS(15047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14752),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(15057),
    [sym__comparison_operator] = ACTIONS(15047),
    [sym__pipe_right_operator] = ACTIONS(14955),
    [sym__pipe_left_operator] = ACTIONS(14957),
    [sym__ellipsis_operator] = ACTIONS(14945),
    [sym__plus_operator] = ACTIONS(14947),
    [sym__times_operator] = ACTIONS(14949),
    [sym__rational_operator] = ACTIONS(14951),
    [sym__bitshift_operator] = ACTIONS(14953),
    [sym__power_operator] = ACTIONS(14941),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15047),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9228] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15059),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14995),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(14828),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(15063),
    [sym__arrow_operator] = ACTIONS(15065),
    [sym__lazy_or_operator] = ACTIONS(15067),
    [sym__lazy_and_operator] = ACTIONS(15069),
    [sym__comparison_operator] = ACTIONS(15061),
    [sym__pipe_right_operator] = ACTIONS(15009),
    [sym__pipe_left_operator] = ACTIONS(15011),
    [sym__ellipsis_operator] = ACTIONS(14997),
    [sym__plus_operator] = ACTIONS(14999),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(15071),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9229] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15059),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14995),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(15065),
    [sym__lazy_or_operator] = ACTIONS(15067),
    [sym__lazy_and_operator] = ACTIONS(15069),
    [sym__comparison_operator] = ACTIONS(15061),
    [sym__pipe_right_operator] = ACTIONS(15009),
    [sym__pipe_left_operator] = ACTIONS(15011),
    [sym__ellipsis_operator] = ACTIONS(14997),
    [sym__plus_operator] = ACTIONS(14999),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(15071),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9230] = {
    [sym__word_identifier] = ACTIONS(13249),
    [anon_sym_EQ] = ACTIONS(12790),
    [anon_sym_COMMA] = ACTIONS(13247),
    [anon_sym_COLON] = ACTIONS(13249),
    [anon_sym_begin] = ACTIONS(13249),
    [anon_sym_module] = ACTIONS(13249),
    [anon_sym_baremodule] = ACTIONS(13249),
    [anon_sym_abstract] = ACTIONS(13249),
    [anon_sym_primitive] = ACTIONS(13249),
    [anon_sym_mutable] = ACTIONS(13249),
    [anon_sym_struct] = ACTIONS(13249),
    [anon_sym_function] = ACTIONS(13249),
    [anon_sym_macro] = ACTIONS(13249),
    [anon_sym_where] = ACTIONS(13249),
    [anon_sym_quote] = ACTIONS(13249),
    [anon_sym_let] = ACTIONS(13249),
    [anon_sym_if] = ACTIONS(13249),
    [anon_sym_try] = ACTIONS(13249),
    [anon_sym_for] = ACTIONS(13249),
    [anon_sym_while] = ACTIONS(13249),
    [sym_break_statement] = ACTIONS(13249),
    [sym_continue_statement] = ACTIONS(13249),
    [anon_sym_return] = ACTIONS(13249),
    [anon_sym_const] = ACTIONS(13249),
    [anon_sym_global] = ACTIONS(13249),
    [anon_sym_local] = ACTIONS(13249),
    [anon_sym_LPAREN] = ACTIONS(13247),
    [anon_sym_RPAREN] = ACTIONS(13247),
    [anon_sym_COLON2] = ACTIONS(13249),
    [anon_sym_export] = ACTIONS(13249),
    [anon_sym_import] = ACTIONS(13249),
    [anon_sym_using] = ACTIONS(13249),
    [anon_sym_LBRACK] = ACTIONS(13247),
    [anon_sym_in] = ACTIONS(13249),
    [anon_sym_SEMI] = ACTIONS(13247),
    [anon_sym_LBRACE] = ACTIONS(13247),
    [anon_sym_DOLLAR] = ACTIONS(13247),
    [anon_sym_COLON_COLON] = ACTIONS(13247),
    [anon_sym_isa] = ACTIONS(13249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13247),
    [anon_sym_QMARK] = ACTIONS(13247),
    [anon_sym_AT] = ACTIONS(13247),
    [anon_sym_true] = ACTIONS(13249),
    [anon_sym_false] = ACTIONS(13249),
    [aux_sym_integer_literal_token1] = ACTIONS(13247),
    [aux_sym_integer_literal_token2] = ACTIONS(13247),
    [aux_sym_integer_literal_token3] = ACTIONS(13249),
    [aux_sym_integer_literal_token4] = ACTIONS(13249),
    [aux_sym_float_literal_token1] = ACTIONS(13247),
    [aux_sym_float_literal_token3] = ACTIONS(13247),
    [aux_sym_float_literal_token4] = ACTIONS(13247),
    [sym_character_literal] = ACTIONS(13247),
    [sym__pair_operator] = ACTIONS(13247),
    [sym__arrow_operator] = ACTIONS(13249),
    [sym__lazy_or_operator] = ACTIONS(13247),
    [sym__lazy_and_operator] = ACTIONS(13247),
    [sym__comparison_operator] = ACTIONS(13249),
    [sym__pipe_right_operator] = ACTIONS(13247),
    [sym__pipe_left_operator] = ACTIONS(13247),
    [sym__ellipsis_operator] = ACTIONS(13249),
    [sym__plus_operator] = ACTIONS(13249),
    [sym__times_operator] = ACTIONS(13249),
    [sym__rational_operator] = ACTIONS(13247),
    [sym__bitshift_operator] = ACTIONS(13247),
    [sym__power_operator] = ACTIONS(13247),
    [sym__tilde_operator] = ACTIONS(13247),
    [sym__type_order_operator] = ACTIONS(13247),
    [sym__unary_operator] = ACTIONS(13249),
    [sym__unary_plus_operator] = ACTIONS(13249),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13247),
    [sym__command_start] = ACTIONS(13247),
  },
  [9231] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13465),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13465),
    [anon_sym_RPAREN] = ACTIONS(13465),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13465),
    [anon_sym_RBRACK] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13465),
    [anon_sym_RBRACE] = ACTIONS(13465),
    [anon_sym_DOLLAR] = ACTIONS(13465),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13465),
    [anon_sym_QMARK] = ACTIONS(13465),
    [anon_sym_AT] = ACTIONS(13465),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13465),
    [aux_sym_integer_literal_token2] = ACTIONS(13465),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13465),
    [aux_sym_float_literal_token3] = ACTIONS(13465),
    [aux_sym_float_literal_token4] = ACTIONS(13465),
    [sym_character_literal] = ACTIONS(13465),
    [sym__pair_operator] = ACTIONS(13465),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13465),
    [sym__lazy_and_operator] = ACTIONS(13465),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13465),
    [sym__pipe_left_operator] = ACTIONS(13465),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(14999),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13465),
    [sym__type_order_operator] = ACTIONS(13465),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(14999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [9232] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15059),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14995),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(15069),
    [sym__comparison_operator] = ACTIONS(15061),
    [sym__pipe_right_operator] = ACTIONS(15009),
    [sym__pipe_left_operator] = ACTIONS(15011),
    [sym__ellipsis_operator] = ACTIONS(14997),
    [sym__plus_operator] = ACTIONS(14999),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(15071),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9233] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(14999),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9234] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9235] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9236] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13312),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9237] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15059),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(14995),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15061),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(15061),
    [sym__pipe_right_operator] = ACTIONS(15009),
    [sym__pipe_left_operator] = ACTIONS(15011),
    [sym__ellipsis_operator] = ACTIONS(14997),
    [sym__plus_operator] = ACTIONS(14999),
    [sym__times_operator] = ACTIONS(15001),
    [sym__rational_operator] = ACTIONS(15003),
    [sym__bitshift_operator] = ACTIONS(15005),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(15071),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(14999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9238] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_RBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_RBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13312),
    [sym__bitshift_operator] = ACTIONS(13312),
    [sym__power_operator] = ACTIONS(15007),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9239] = {
    [aux_sym_open_tuple_repeat1] = STATE(8915),
    [sym__word_identifier] = ACTIONS(13239),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_COLON] = ACTIONS(13239),
    [anon_sym_begin] = ACTIONS(13239),
    [anon_sym_module] = ACTIONS(13239),
    [anon_sym_baremodule] = ACTIONS(13239),
    [anon_sym_abstract] = ACTIONS(13239),
    [anon_sym_primitive] = ACTIONS(13239),
    [anon_sym_mutable] = ACTIONS(13239),
    [anon_sym_struct] = ACTIONS(13239),
    [anon_sym_function] = ACTIONS(13239),
    [anon_sym_macro] = ACTIONS(13239),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13239),
    [anon_sym_let] = ACTIONS(13239),
    [anon_sym_if] = ACTIONS(13239),
    [anon_sym_try] = ACTIONS(13239),
    [anon_sym_for] = ACTIONS(13239),
    [anon_sym_while] = ACTIONS(13239),
    [sym_break_statement] = ACTIONS(13239),
    [sym_continue_statement] = ACTIONS(13239),
    [anon_sym_return] = ACTIONS(13239),
    [anon_sym_const] = ACTIONS(13239),
    [anon_sym_global] = ACTIONS(13239),
    [anon_sym_local] = ACTIONS(13239),
    [anon_sym_LPAREN] = ACTIONS(13241),
    [anon_sym_RPAREN] = ACTIONS(13241),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13239),
    [anon_sym_import] = ACTIONS(13239),
    [anon_sym_using] = ACTIONS(13239),
    [anon_sym_LBRACK] = ACTIONS(13241),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13241),
    [anon_sym_LBRACE] = ACTIONS(13241),
    [anon_sym_DOLLAR] = ACTIONS(13241),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(15013),
    [anon_sym_AT] = ACTIONS(13241),
    [anon_sym_true] = ACTIONS(13239),
    [anon_sym_false] = ACTIONS(13239),
    [aux_sym_integer_literal_token1] = ACTIONS(13241),
    [aux_sym_integer_literal_token2] = ACTIONS(13241),
    [aux_sym_integer_literal_token3] = ACTIONS(13239),
    [aux_sym_integer_literal_token4] = ACTIONS(13239),
    [aux_sym_float_literal_token1] = ACTIONS(13241),
    [aux_sym_float_literal_token3] = ACTIONS(13241),
    [aux_sym_float_literal_token4] = ACTIONS(13241),
    [sym_character_literal] = ACTIONS(13241),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13241),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13239),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13241),
    [sym__command_start] = ACTIONS(13241),
  },
  [9240] = {
    [aux_sym_open_tuple_repeat1] = STATE(8915),
    [sym__word_identifier] = ACTIONS(13243),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_COLON] = ACTIONS(13243),
    [anon_sym_begin] = ACTIONS(13243),
    [anon_sym_module] = ACTIONS(13243),
    [anon_sym_baremodule] = ACTIONS(13243),
    [anon_sym_abstract] = ACTIONS(13243),
    [anon_sym_primitive] = ACTIONS(13243),
    [anon_sym_mutable] = ACTIONS(13243),
    [anon_sym_struct] = ACTIONS(13243),
    [anon_sym_function] = ACTIONS(13243),
    [anon_sym_macro] = ACTIONS(13243),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(13243),
    [anon_sym_let] = ACTIONS(13243),
    [anon_sym_if] = ACTIONS(13243),
    [anon_sym_try] = ACTIONS(13243),
    [anon_sym_for] = ACTIONS(13243),
    [anon_sym_while] = ACTIONS(13243),
    [sym_break_statement] = ACTIONS(13243),
    [sym_continue_statement] = ACTIONS(13243),
    [anon_sym_return] = ACTIONS(13243),
    [anon_sym_const] = ACTIONS(13243),
    [anon_sym_global] = ACTIONS(13243),
    [anon_sym_local] = ACTIONS(13243),
    [anon_sym_LPAREN] = ACTIONS(13245),
    [anon_sym_RPAREN] = ACTIONS(13245),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(13243),
    [anon_sym_import] = ACTIONS(13243),
    [anon_sym_using] = ACTIONS(13243),
    [anon_sym_LBRACK] = ACTIONS(13245),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(13245),
    [anon_sym_LBRACE] = ACTIONS(13245),
    [anon_sym_DOLLAR] = ACTIONS(13245),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(15013),
    [anon_sym_AT] = ACTIONS(13245),
    [anon_sym_true] = ACTIONS(13243),
    [anon_sym_false] = ACTIONS(13243),
    [aux_sym_integer_literal_token1] = ACTIONS(13245),
    [aux_sym_integer_literal_token2] = ACTIONS(13245),
    [aux_sym_integer_literal_token3] = ACTIONS(13243),
    [aux_sym_integer_literal_token4] = ACTIONS(13243),
    [aux_sym_float_literal_token1] = ACTIONS(13245),
    [aux_sym_float_literal_token3] = ACTIONS(13245),
    [aux_sym_float_literal_token4] = ACTIONS(13245),
    [sym_character_literal] = ACTIONS(13245),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13245),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(13243),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13245),
    [sym__command_start] = ACTIONS(13245),
  },
  [9241] = {
    [aux_sym_open_tuple_repeat1] = STATE(8915),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_COLON] = ACTIONS(12926),
    [anon_sym_begin] = ACTIONS(12926),
    [anon_sym_module] = ACTIONS(12926),
    [anon_sym_baremodule] = ACTIONS(12926),
    [anon_sym_abstract] = ACTIONS(12926),
    [anon_sym_primitive] = ACTIONS(12926),
    [anon_sym_mutable] = ACTIONS(12926),
    [anon_sym_struct] = ACTIONS(12926),
    [anon_sym_function] = ACTIONS(12926),
    [anon_sym_macro] = ACTIONS(12926),
    [anon_sym_where] = ACTIONS(14907),
    [anon_sym_quote] = ACTIONS(12926),
    [anon_sym_let] = ACTIONS(12926),
    [anon_sym_if] = ACTIONS(12926),
    [anon_sym_try] = ACTIONS(12926),
    [anon_sym_for] = ACTIONS(12926),
    [anon_sym_while] = ACTIONS(12926),
    [sym_break_statement] = ACTIONS(12926),
    [sym_continue_statement] = ACTIONS(12926),
    [anon_sym_return] = ACTIONS(12926),
    [anon_sym_const] = ACTIONS(12926),
    [anon_sym_global] = ACTIONS(12926),
    [anon_sym_local] = ACTIONS(12926),
    [anon_sym_LPAREN] = ACTIONS(12934),
    [anon_sym_RPAREN] = ACTIONS(12934),
    [anon_sym_COLON2] = ACTIONS(14909),
    [anon_sym_export] = ACTIONS(12926),
    [anon_sym_import] = ACTIONS(12926),
    [anon_sym_using] = ACTIONS(12926),
    [anon_sym_LBRACK] = ACTIONS(12934),
    [anon_sym_in] = ACTIONS(14911),
    [anon_sym_SEMI] = ACTIONS(12934),
    [anon_sym_LBRACE] = ACTIONS(12934),
    [anon_sym_DOLLAR] = ACTIONS(12934),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(14911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(15013),
    [anon_sym_AT] = ACTIONS(12934),
    [anon_sym_true] = ACTIONS(12926),
    [anon_sym_false] = ACTIONS(12926),
    [aux_sym_integer_literal_token1] = ACTIONS(12934),
    [aux_sym_integer_literal_token2] = ACTIONS(12934),
    [aux_sym_integer_literal_token3] = ACTIONS(12926),
    [aux_sym_integer_literal_token4] = ACTIONS(12926),
    [aux_sym_float_literal_token1] = ACTIONS(12934),
    [aux_sym_float_literal_token3] = ACTIONS(12934),
    [aux_sym_float_literal_token4] = ACTIONS(12934),
    [sym_character_literal] = ACTIONS(12934),
    [sym__pair_operator] = ACTIONS(14915),
    [sym__arrow_operator] = ACTIONS(14917),
    [sym__lazy_or_operator] = ACTIONS(14919),
    [sym__lazy_and_operator] = ACTIONS(14921),
    [sym__comparison_operator] = ACTIONS(14911),
    [sym__pipe_right_operator] = ACTIONS(14923),
    [sym__pipe_left_operator] = ACTIONS(14925),
    [sym__ellipsis_operator] = ACTIONS(14927),
    [sym__plus_operator] = ACTIONS(14929),
    [sym__times_operator] = ACTIONS(14931),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(12934),
    [sym__type_order_operator] = ACTIONS(14939),
    [sym__unary_operator] = ACTIONS(12926),
    [sym__unary_plus_operator] = ACTIONS(14929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12934),
    [sym__command_start] = ACTIONS(12934),
  },
  [9242] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_EQ] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13310),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13310),
    [anon_sym_RPAREN] = ACTIONS(13310),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_SEMI] = ACTIONS(13310),
    [anon_sym_LBRACE] = ACTIONS(13310),
    [anon_sym_DOLLAR] = ACTIONS(13310),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13310),
    [anon_sym_QMARK] = ACTIONS(13310),
    [anon_sym_AT] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13310),
    [aux_sym_integer_literal_token2] = ACTIONS(13310),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13310),
    [aux_sym_float_literal_token3] = ACTIONS(13310),
    [aux_sym_float_literal_token4] = ACTIONS(13310),
    [sym_character_literal] = ACTIONS(13310),
    [sym__pair_operator] = ACTIONS(13310),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13310),
    [sym__lazy_and_operator] = ACTIONS(13310),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13310),
    [sym__pipe_left_operator] = ACTIONS(13310),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13310),
    [sym__bitshift_operator] = ACTIONS(13310),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13310),
    [sym__type_order_operator] = ACTIONS(13310),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9243] = {
    [sym__word_identifier] = ACTIONS(15077),
    [anon_sym_COMMA] = ACTIONS(15077),
    [anon_sym_COLON] = ACTIONS(15077),
    [anon_sym_begin] = ACTIONS(15077),
    [anon_sym_module] = ACTIONS(15077),
    [anon_sym_baremodule] = ACTIONS(15077),
    [anon_sym_end] = ACTIONS(15077),
    [anon_sym_abstract] = ACTIONS(15077),
    [anon_sym_primitive] = ACTIONS(15077),
    [anon_sym_mutable] = ACTIONS(15077),
    [anon_sym_struct] = ACTIONS(15077),
    [anon_sym_function] = ACTIONS(15077),
    [anon_sym_macro] = ACTIONS(15077),
    [anon_sym_where] = ACTIONS(14981),
    [anon_sym_quote] = ACTIONS(15077),
    [anon_sym_let] = ACTIONS(15077),
    [anon_sym_if] = ACTIONS(15077),
    [anon_sym_try] = ACTIONS(15077),
    [anon_sym_for] = ACTIONS(15077),
    [anon_sym_while] = ACTIONS(15077),
    [sym_break_statement] = ACTIONS(15077),
    [sym_continue_statement] = ACTIONS(15077),
    [anon_sym_return] = ACTIONS(15077),
    [anon_sym_const] = ACTIONS(15077),
    [anon_sym_global] = ACTIONS(15077),
    [anon_sym_local] = ACTIONS(15077),
    [anon_sym_LPAREN] = ACTIONS(15077),
    [anon_sym_COLON2] = ACTIONS(14959),
    [anon_sym_export] = ACTIONS(15077),
    [anon_sym_import] = ACTIONS(15077),
    [anon_sym_using] = ACTIONS(15077),
    [anon_sym_LBRACK] = ACTIONS(15077),
    [anon_sym_LF] = ACTIONS(15079),
    [anon_sym_in] = ACTIONS(14961),
    [anon_sym_LBRACE] = ACTIONS(15077),
    [anon_sym_DOLLAR] = ACTIONS(15077),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(14961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(14810),
    [anon_sym_AT] = ACTIONS(15077),
    [anon_sym_true] = ACTIONS(15077),
    [anon_sym_false] = ACTIONS(15077),
    [aux_sym_integer_literal_token1] = ACTIONS(15077),
    [aux_sym_integer_literal_token2] = ACTIONS(15077),
    [aux_sym_integer_literal_token3] = ACTIONS(15077),
    [aux_sym_integer_literal_token4] = ACTIONS(15077),
    [aux_sym_float_literal_token1] = ACTIONS(15077),
    [aux_sym_float_literal_token3] = ACTIONS(15077),
    [aux_sym_float_literal_token4] = ACTIONS(15077),
    [sym_character_literal] = ACTIONS(15077),
    [sym__pair_operator] = ACTIONS(14983),
    [sym__arrow_operator] = ACTIONS(14985),
    [sym__lazy_or_operator] = ACTIONS(14987),
    [sym__lazy_and_operator] = ACTIONS(14989),
    [sym__comparison_operator] = ACTIONS(14961),
    [sym__pipe_right_operator] = ACTIONS(14963),
    [sym__pipe_left_operator] = ACTIONS(14965),
    [sym__ellipsis_operator] = ACTIONS(14967),
    [sym__plus_operator] = ACTIONS(14969),
    [sym__times_operator] = ACTIONS(14971),
    [sym__rational_operator] = ACTIONS(14973),
    [sym__bitshift_operator] = ACTIONS(14975),
    [sym__power_operator] = ACTIONS(14977),
    [sym__tilde_operator] = ACTIONS(15077),
    [sym__type_order_operator] = ACTIONS(14961),
    [sym__unary_operator] = ACTIONS(15077),
    [sym__unary_plus_operator] = ACTIONS(14969),
    [aux_sym__terminator_token1] = ACTIONS(15077),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(15079),
    [sym__command_start] = ACTIONS(15079),
  },
  [9244] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_EQ] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(14933),
    [sym__bitshift_operator] = ACTIONS(14935),
    [sym__power_operator] = ACTIONS(14937),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9245] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(15081),
    [sym__pipe_left_operator] = ACTIONS(15083),
    [sym__ellipsis_operator] = ACTIONS(15085),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9246] = {
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_where] = ACTIONS(15015),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13263),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_COLON2] = ACTIONS(15017),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13263),
    [anon_sym_LF] = ACTIONS(13280),
    [anon_sym_in] = ACTIONS(15019),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(15097),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(15023),
    [sym__arrow_operator] = ACTIONS(15025),
    [sym__lazy_or_operator] = ACTIONS(15027),
    [sym__lazy_and_operator] = ACTIONS(15029),
    [sym__comparison_operator] = ACTIONS(15019),
    [sym__pipe_right_operator] = ACTIONS(15031),
    [sym__pipe_left_operator] = ACTIONS(15033),
    [sym__ellipsis_operator] = ACTIONS(15035),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(15019),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(13263),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9247] = {
    [sym_do_clause] = STATE(9356),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_where] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(15099),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [9248] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(3069),
    [sym__pipe_right_operator] = ACTIONS(15081),
    [sym__pipe_left_operator] = ACTIONS(15083),
    [sym__ellipsis_operator] = ACTIONS(15085),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(3069),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9249] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_end] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(3069),
    [sym__pipe_right_operator] = ACTIONS(15081),
    [sym__pipe_left_operator] = ACTIONS(15083),
    [sym__ellipsis_operator] = ACTIONS(15085),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(3069),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [9250] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(15101),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(15103),
    [sym__pipe_left_operator] = ACTIONS(15105),
    [sym__ellipsis_operator] = ACTIONS(15107),
    [sym__plus_operator] = ACTIONS(15109),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9251] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_end] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(15119),
    [sym__arrow_operator] = ACTIONS(15121),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3069),
    [sym__pipe_right_operator] = ACTIONS(15081),
    [sym__pipe_left_operator] = ACTIONS(15083),
    [sym__ellipsis_operator] = ACTIONS(15085),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(3069),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [9252] = {
    [sym_do_clause] = STATE(9378),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(15099),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [9253] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15123),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(15101),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15125),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(15127),
    [sym__lazy_or_operator] = ACTIONS(15129),
    [sym__lazy_and_operator] = ACTIONS(15131),
    [sym__comparison_operator] = ACTIONS(15125),
    [sym__pipe_right_operator] = ACTIONS(15103),
    [sym__pipe_left_operator] = ACTIONS(15105),
    [sym__ellipsis_operator] = ACTIONS(15107),
    [sym__plus_operator] = ACTIONS(15109),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(15133),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9254] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COMMA] = ACTIONS(13310),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13310),
    [anon_sym_RPAREN] = ACTIONS(13310),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_SEMI] = ACTIONS(13310),
    [anon_sym_LBRACE] = ACTIONS(13310),
    [anon_sym_DOLLAR] = ACTIONS(13310),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13310),
    [anon_sym_QMARK] = ACTIONS(13310),
    [anon_sym_AT] = ACTIONS(13310),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13310),
    [aux_sym_integer_literal_token2] = ACTIONS(13310),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13310),
    [aux_sym_float_literal_token3] = ACTIONS(13310),
    [aux_sym_float_literal_token4] = ACTIONS(13310),
    [sym_character_literal] = ACTIONS(13310),
    [sym__pair_operator] = ACTIONS(13310),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13310),
    [sym__lazy_and_operator] = ACTIONS(13310),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13310),
    [sym__pipe_left_operator] = ACTIONS(13310),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13310),
    [sym__bitshift_operator] = ACTIONS(13310),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13310),
    [sym__type_order_operator] = ACTIONS(13310),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9255] = {
    [sym_do_clause] = STATE(9371),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(15099),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [9256] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_end] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [9257] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COMMA] = ACTIONS(13336),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13336),
    [anon_sym_RPAREN] = ACTIONS(13336),
    [anon_sym_COLON2] = ACTIONS(15101),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(15125),
    [anon_sym_SEMI] = ACTIONS(13336),
    [anon_sym_LBRACE] = ACTIONS(13336),
    [anon_sym_DOLLAR] = ACTIONS(13336),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13336),
    [anon_sym_AT] = ACTIONS(13336),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13336),
    [aux_sym_integer_literal_token2] = ACTIONS(13336),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13336),
    [aux_sym_float_literal_token3] = ACTIONS(13336),
    [aux_sym_float_literal_token4] = ACTIONS(13336),
    [sym_character_literal] = ACTIONS(13336),
    [sym__pair_operator] = ACTIONS(13336),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13336),
    [sym__lazy_and_operator] = ACTIONS(13336),
    [sym__comparison_operator] = ACTIONS(15125),
    [sym__pipe_right_operator] = ACTIONS(15103),
    [sym__pipe_left_operator] = ACTIONS(15105),
    [sym__ellipsis_operator] = ACTIONS(15107),
    [sym__plus_operator] = ACTIONS(15109),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13336),
    [sym__type_order_operator] = ACTIONS(15133),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(15109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [9258] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COMMA] = ACTIONS(13465),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13465),
    [anon_sym_RPAREN] = ACTIONS(13465),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_SEMI] = ACTIONS(13465),
    [anon_sym_LBRACE] = ACTIONS(13465),
    [anon_sym_DOLLAR] = ACTIONS(13465),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13465),
    [anon_sym_QMARK] = ACTIONS(13465),
    [anon_sym_AT] = ACTIONS(13465),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13465),
    [aux_sym_integer_literal_token2] = ACTIONS(13465),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13465),
    [aux_sym_float_literal_token3] = ACTIONS(13465),
    [aux_sym_float_literal_token4] = ACTIONS(13465),
    [sym_character_literal] = ACTIONS(13465),
    [sym__pair_operator] = ACTIONS(13465),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13465),
    [sym__lazy_and_operator] = ACTIONS(13465),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13465),
    [sym__pipe_left_operator] = ACTIONS(13465),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(15109),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13465),
    [sym__type_order_operator] = ACTIONS(13465),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(15109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [9259] = {
    [sym_do_clause] = STATE(9375),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_where] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(15099),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [9260] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(15135),
    [sym__immediate_command_start] = ACTIONS(15137),
  },
  [9261] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(15101),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(15103),
    [sym__pipe_left_operator] = ACTIONS(15105),
    [sym__ellipsis_operator] = ACTIONS(15107),
    [sym__plus_operator] = ACTIONS(15109),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9262] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(15109),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9263] = {
    [sym__word_identifier] = ACTIONS(13467),
    [anon_sym_COLON] = ACTIONS(13467),
    [anon_sym_begin] = ACTIONS(13467),
    [anon_sym_module] = ACTIONS(13467),
    [anon_sym_baremodule] = ACTIONS(13467),
    [anon_sym_abstract] = ACTIONS(13467),
    [anon_sym_primitive] = ACTIONS(13467),
    [anon_sym_mutable] = ACTIONS(13467),
    [anon_sym_struct] = ACTIONS(13467),
    [anon_sym_function] = ACTIONS(13467),
    [anon_sym_macro] = ACTIONS(13467),
    [anon_sym_where] = ACTIONS(13467),
    [anon_sym_quote] = ACTIONS(13467),
    [anon_sym_let] = ACTIONS(13467),
    [anon_sym_if] = ACTIONS(13467),
    [anon_sym_try] = ACTIONS(13467),
    [anon_sym_for] = ACTIONS(13467),
    [anon_sym_while] = ACTIONS(13467),
    [sym_break_statement] = ACTIONS(13467),
    [sym_continue_statement] = ACTIONS(13467),
    [anon_sym_return] = ACTIONS(13467),
    [anon_sym_const] = ACTIONS(13467),
    [anon_sym_global] = ACTIONS(13467),
    [anon_sym_local] = ACTIONS(13467),
    [anon_sym_LPAREN] = ACTIONS(13467),
    [anon_sym_COLON2] = ACTIONS(13467),
    [anon_sym_export] = ACTIONS(13467),
    [anon_sym_import] = ACTIONS(13467),
    [anon_sym_using] = ACTIONS(13467),
    [anon_sym_LBRACK] = ACTIONS(13467),
    [anon_sym_RBRACK] = ACTIONS(13467),
    [anon_sym_LF] = ACTIONS(13465),
    [anon_sym_in] = ACTIONS(13467),
    [anon_sym_LBRACE] = ACTIONS(13467),
    [anon_sym_DOLLAR] = ACTIONS(13467),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13467),
    [anon_sym_QMARK] = ACTIONS(13467),
    [anon_sym_AT] = ACTIONS(13467),
    [anon_sym_true] = ACTIONS(13467),
    [anon_sym_false] = ACTIONS(13467),
    [aux_sym_integer_literal_token1] = ACTIONS(13467),
    [aux_sym_integer_literal_token2] = ACTIONS(13467),
    [aux_sym_integer_literal_token3] = ACTIONS(13467),
    [aux_sym_integer_literal_token4] = ACTIONS(13467),
    [aux_sym_float_literal_token1] = ACTIONS(13467),
    [aux_sym_float_literal_token3] = ACTIONS(13467),
    [aux_sym_float_literal_token4] = ACTIONS(13467),
    [sym_character_literal] = ACTIONS(13467),
    [sym__pair_operator] = ACTIONS(13467),
    [sym__arrow_operator] = ACTIONS(13467),
    [sym__lazy_or_operator] = ACTIONS(13467),
    [sym__lazy_and_operator] = ACTIONS(13467),
    [sym__comparison_operator] = ACTIONS(13467),
    [sym__pipe_right_operator] = ACTIONS(13467),
    [sym__pipe_left_operator] = ACTIONS(13467),
    [sym__ellipsis_operator] = ACTIONS(13467),
    [sym__plus_operator] = ACTIONS(15139),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13467),
    [sym__type_order_operator] = ACTIONS(13467),
    [sym__unary_operator] = ACTIONS(13467),
    [sym__unary_plus_operator] = ACTIONS(15139),
    [aux_sym__terminator_token1] = ACTIONS(13467),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13465),
    [sym__command_start] = ACTIONS(13465),
  },
  [9264] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(15139),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15139),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9265] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9266] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9267] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9268] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(15149),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13338),
    [anon_sym_COLON2] = ACTIONS(15151),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13338),
    [anon_sym_RBRACK] = ACTIONS(13338),
    [anon_sym_LF] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(15153),
    [anon_sym_LBRACE] = ACTIONS(13338),
    [anon_sym_DOLLAR] = ACTIONS(13338),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(15097),
    [anon_sym_AT] = ACTIONS(13338),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13338),
    [aux_sym_integer_literal_token2] = ACTIONS(13338),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13338),
    [aux_sym_float_literal_token3] = ACTIONS(13338),
    [aux_sym_float_literal_token4] = ACTIONS(13338),
    [sym_character_literal] = ACTIONS(13338),
    [sym__pair_operator] = ACTIONS(15155),
    [sym__arrow_operator] = ACTIONS(15157),
    [sym__lazy_or_operator] = ACTIONS(15159),
    [sym__lazy_and_operator] = ACTIONS(15161),
    [sym__comparison_operator] = ACTIONS(15153),
    [sym__pipe_right_operator] = ACTIONS(15163),
    [sym__pipe_left_operator] = ACTIONS(15165),
    [sym__ellipsis_operator] = ACTIONS(15167),
    [sym__plus_operator] = ACTIONS(15139),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13338),
    [sym__type_order_operator] = ACTIONS(15153),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(15139),
    [aux_sym__terminator_token1] = ACTIONS(13338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [9269] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9270] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9271] = {
    [sym__word_identifier] = ACTIONS(15169),
    [anon_sym_COLON] = ACTIONS(15169),
    [anon_sym_begin] = ACTIONS(15169),
    [anon_sym_module] = ACTIONS(15169),
    [anon_sym_baremodule] = ACTIONS(15169),
    [anon_sym_end] = ACTIONS(15169),
    [anon_sym_abstract] = ACTIONS(15169),
    [anon_sym_primitive] = ACTIONS(15169),
    [anon_sym_mutable] = ACTIONS(15169),
    [anon_sym_struct] = ACTIONS(15169),
    [anon_sym_function] = ACTIONS(15169),
    [anon_sym_macro] = ACTIONS(15169),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(15169),
    [anon_sym_let] = ACTIONS(15169),
    [anon_sym_if] = ACTIONS(15169),
    [anon_sym_try] = ACTIONS(15169),
    [anon_sym_for] = ACTIONS(15169),
    [anon_sym_while] = ACTIONS(15169),
    [sym_break_statement] = ACTIONS(15169),
    [sym_continue_statement] = ACTIONS(15169),
    [anon_sym_return] = ACTIONS(15169),
    [anon_sym_const] = ACTIONS(15169),
    [anon_sym_global] = ACTIONS(15169),
    [anon_sym_local] = ACTIONS(15169),
    [anon_sym_LPAREN] = ACTIONS(15169),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(15169),
    [anon_sym_import] = ACTIONS(15169),
    [anon_sym_using] = ACTIONS(15169),
    [anon_sym_LBRACK] = ACTIONS(15169),
    [anon_sym_LF] = ACTIONS(15171),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(15169),
    [anon_sym_DOLLAR] = ACTIONS(15169),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(15169),
    [anon_sym_true] = ACTIONS(15169),
    [anon_sym_false] = ACTIONS(15169),
    [aux_sym_integer_literal_token1] = ACTIONS(15169),
    [aux_sym_integer_literal_token2] = ACTIONS(15169),
    [aux_sym_integer_literal_token3] = ACTIONS(15169),
    [aux_sym_integer_literal_token4] = ACTIONS(15169),
    [aux_sym_float_literal_token1] = ACTIONS(15169),
    [aux_sym_float_literal_token3] = ACTIONS(15169),
    [aux_sym_float_literal_token4] = ACTIONS(15169),
    [sym_character_literal] = ACTIONS(15169),
    [sym__pair_operator] = ACTIONS(15119),
    [sym__arrow_operator] = ACTIONS(15121),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3069),
    [sym__pipe_right_operator] = ACTIONS(15081),
    [sym__pipe_left_operator] = ACTIONS(15083),
    [sym__ellipsis_operator] = ACTIONS(15085),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(15169),
    [sym__type_order_operator] = ACTIONS(3069),
    [sym__unary_operator] = ACTIONS(15169),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(15169),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(15171),
    [sym__command_start] = ACTIONS(15171),
  },
  [9272] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15123),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(15101),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15125),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(15013),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(15173),
    [sym__arrow_operator] = ACTIONS(15127),
    [sym__lazy_or_operator] = ACTIONS(15129),
    [sym__lazy_and_operator] = ACTIONS(15131),
    [sym__comparison_operator] = ACTIONS(15125),
    [sym__pipe_right_operator] = ACTIONS(15103),
    [sym__pipe_left_operator] = ACTIONS(15105),
    [sym__ellipsis_operator] = ACTIONS(15107),
    [sym__plus_operator] = ACTIONS(15109),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(15133),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9273] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3069),
    [sym__pipe_right_operator] = ACTIONS(15081),
    [sym__pipe_left_operator] = ACTIONS(15083),
    [sym__ellipsis_operator] = ACTIONS(15085),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(3069),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9274] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13312),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9275] = {
    [sym__word_identifier] = ACTIONS(13334),
    [anon_sym_COLON] = ACTIONS(13334),
    [anon_sym_begin] = ACTIONS(13334),
    [anon_sym_module] = ACTIONS(13334),
    [anon_sym_baremodule] = ACTIONS(13334),
    [anon_sym_abstract] = ACTIONS(13334),
    [anon_sym_primitive] = ACTIONS(13334),
    [anon_sym_mutable] = ACTIONS(13334),
    [anon_sym_struct] = ACTIONS(13334),
    [anon_sym_function] = ACTIONS(13334),
    [anon_sym_macro] = ACTIONS(13334),
    [anon_sym_where] = ACTIONS(13334),
    [anon_sym_quote] = ACTIONS(13334),
    [anon_sym_let] = ACTIONS(13334),
    [anon_sym_if] = ACTIONS(13334),
    [anon_sym_try] = ACTIONS(13334),
    [anon_sym_for] = ACTIONS(13334),
    [anon_sym_while] = ACTIONS(13334),
    [sym_break_statement] = ACTIONS(13334),
    [sym_continue_statement] = ACTIONS(13334),
    [anon_sym_return] = ACTIONS(13334),
    [anon_sym_const] = ACTIONS(13334),
    [anon_sym_global] = ACTIONS(13334),
    [anon_sym_local] = ACTIONS(13334),
    [anon_sym_LPAREN] = ACTIONS(13334),
    [anon_sym_COLON2] = ACTIONS(15151),
    [anon_sym_export] = ACTIONS(13334),
    [anon_sym_import] = ACTIONS(13334),
    [anon_sym_using] = ACTIONS(13334),
    [anon_sym_LBRACK] = ACTIONS(13334),
    [anon_sym_RBRACK] = ACTIONS(13334),
    [anon_sym_LF] = ACTIONS(13336),
    [anon_sym_in] = ACTIONS(15153),
    [anon_sym_LBRACE] = ACTIONS(13334),
    [anon_sym_DOLLAR] = ACTIONS(13334),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_AT] = ACTIONS(13334),
    [anon_sym_true] = ACTIONS(13334),
    [anon_sym_false] = ACTIONS(13334),
    [aux_sym_integer_literal_token1] = ACTIONS(13334),
    [aux_sym_integer_literal_token2] = ACTIONS(13334),
    [aux_sym_integer_literal_token3] = ACTIONS(13334),
    [aux_sym_integer_literal_token4] = ACTIONS(13334),
    [aux_sym_float_literal_token1] = ACTIONS(13334),
    [aux_sym_float_literal_token3] = ACTIONS(13334),
    [aux_sym_float_literal_token4] = ACTIONS(13334),
    [sym_character_literal] = ACTIONS(13334),
    [sym__pair_operator] = ACTIONS(13334),
    [sym__arrow_operator] = ACTIONS(13334),
    [sym__lazy_or_operator] = ACTIONS(13334),
    [sym__lazy_and_operator] = ACTIONS(13334),
    [sym__comparison_operator] = ACTIONS(15153),
    [sym__pipe_right_operator] = ACTIONS(15163),
    [sym__pipe_left_operator] = ACTIONS(15165),
    [sym__ellipsis_operator] = ACTIONS(15167),
    [sym__plus_operator] = ACTIONS(15139),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13334),
    [sym__type_order_operator] = ACTIONS(15153),
    [sym__unary_operator] = ACTIONS(13334),
    [sym__unary_plus_operator] = ACTIONS(15139),
    [aux_sym__terminator_token1] = ACTIONS(13334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13336),
    [sym__command_start] = ACTIONS(13336),
  },
  [9276] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15151),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(15163),
    [sym__pipe_left_operator] = ACTIONS(15165),
    [sym__ellipsis_operator] = ACTIONS(15167),
    [sym__plus_operator] = ACTIONS(15139),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15139),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9277] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15149),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15151),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15153),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(15097),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(15155),
    [sym__arrow_operator] = ACTIONS(15157),
    [sym__lazy_or_operator] = ACTIONS(15159),
    [sym__lazy_and_operator] = ACTIONS(15161),
    [sym__comparison_operator] = ACTIONS(15153),
    [sym__pipe_right_operator] = ACTIONS(15163),
    [sym__pipe_left_operator] = ACTIONS(15165),
    [sym__ellipsis_operator] = ACTIONS(15167),
    [sym__plus_operator] = ACTIONS(15139),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15153),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15139),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9278] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(15085),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9279] = {
    [sym_where_clause] = STATE(9632),
    [sym_unary_typed_expression] = STATE(9565),
    [sym__word_identifier] = ACTIONS(15175),
    [anon_sym_COLON] = ACTIONS(15175),
    [anon_sym_begin] = ACTIONS(15175),
    [anon_sym_module] = ACTIONS(15175),
    [anon_sym_baremodule] = ACTIONS(15175),
    [anon_sym_end] = ACTIONS(15175),
    [anon_sym_abstract] = ACTIONS(15175),
    [anon_sym_primitive] = ACTIONS(15175),
    [anon_sym_mutable] = ACTIONS(15175),
    [anon_sym_struct] = ACTIONS(15175),
    [anon_sym_function] = ACTIONS(15175),
    [anon_sym_macro] = ACTIONS(15175),
    [anon_sym_where] = ACTIONS(15177),
    [anon_sym_quote] = ACTIONS(15175),
    [anon_sym_let] = ACTIONS(15175),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_try] = ACTIONS(15175),
    [anon_sym_for] = ACTIONS(15175),
    [anon_sym_while] = ACTIONS(15175),
    [sym_break_statement] = ACTIONS(15175),
    [sym_continue_statement] = ACTIONS(15175),
    [anon_sym_return] = ACTIONS(15175),
    [anon_sym_const] = ACTIONS(15175),
    [anon_sym_global] = ACTIONS(15175),
    [anon_sym_local] = ACTIONS(15175),
    [anon_sym_LPAREN] = ACTIONS(15175),
    [anon_sym_export] = ACTIONS(15175),
    [anon_sym_import] = ACTIONS(15175),
    [anon_sym_using] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [anon_sym_LF] = ACTIONS(15179),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(15175),
    [anon_sym_COLON_COLON] = ACTIONS(15181),
    [anon_sym_AT] = ACTIONS(15175),
    [anon_sym_true] = ACTIONS(15175),
    [anon_sym_false] = ACTIONS(15175),
    [aux_sym_integer_literal_token1] = ACTIONS(15175),
    [aux_sym_integer_literal_token2] = ACTIONS(15175),
    [aux_sym_integer_literal_token3] = ACTIONS(15175),
    [aux_sym_integer_literal_token4] = ACTIONS(15175),
    [aux_sym_float_literal_token1] = ACTIONS(15175),
    [aux_sym_float_literal_token3] = ACTIONS(15175),
    [aux_sym_float_literal_token4] = ACTIONS(15175),
    [sym_character_literal] = ACTIONS(15175),
    [sym__pair_operator] = ACTIONS(15175),
    [sym__arrow_operator] = ACTIONS(15175),
    [sym__comparison_operator] = ACTIONS(15175),
    [sym__pipe_right_operator] = ACTIONS(15175),
    [sym__pipe_left_operator] = ACTIONS(15175),
    [sym__ellipsis_operator] = ACTIONS(15175),
    [sym__plus_operator] = ACTIONS(15175),
    [sym__times_operator] = ACTIONS(15175),
    [sym__rational_operator] = ACTIONS(15175),
    [sym__bitshift_operator] = ACTIONS(15175),
    [sym__power_operator] = ACTIONS(15175),
    [sym__tilde_operator] = ACTIONS(15175),
    [sym__type_order_operator] = ACTIONS(15175),
    [sym__unary_operator] = ACTIONS(15175),
    [sym__unary_plus_operator] = ACTIONS(15175),
    [aux_sym__terminator_token1] = ACTIONS(15175),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(15179),
    [sym__command_start] = ACTIONS(15179),
  },
  [9280] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [9281] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15149),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15151),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15153),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(15157),
    [sym__lazy_or_operator] = ACTIONS(15159),
    [sym__lazy_and_operator] = ACTIONS(15161),
    [sym__comparison_operator] = ACTIONS(15153),
    [sym__pipe_right_operator] = ACTIONS(15163),
    [sym__pipe_left_operator] = ACTIONS(15165),
    [sym__ellipsis_operator] = ACTIONS(15167),
    [sym__plus_operator] = ACTIONS(15139),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15153),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15139),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9282] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15149),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15151),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15153),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(15161),
    [sym__comparison_operator] = ACTIONS(15153),
    [sym__pipe_right_operator] = ACTIONS(15163),
    [sym__pipe_left_operator] = ACTIONS(15165),
    [sym__ellipsis_operator] = ACTIONS(15167),
    [sym__plus_operator] = ACTIONS(15139),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15153),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15139),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9283] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13312),
    [sym__bitshift_operator] = ACTIONS(13312),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9284] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15123),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(15101),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15125),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(15131),
    [sym__comparison_operator] = ACTIONS(15125),
    [sym__pipe_right_operator] = ACTIONS(15103),
    [sym__pipe_left_operator] = ACTIONS(15105),
    [sym__ellipsis_operator] = ACTIONS(15107),
    [sym__plus_operator] = ACTIONS(15109),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(15133),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9285] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15123),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(15101),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15125),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(15125),
    [sym__pipe_right_operator] = ACTIONS(15103),
    [sym__pipe_left_operator] = ACTIONS(15105),
    [sym__ellipsis_operator] = ACTIONS(15107),
    [sym__plus_operator] = ACTIONS(15109),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(15133),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9286] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(15101),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(15107),
    [sym__plus_operator] = ACTIONS(15109),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9287] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(15135),
    [sym__immediate_command_start] = ACTIONS(15137),
  },
  [9288] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9289] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(15081),
    [sym__pipe_left_operator] = ACTIONS(15083),
    [sym__ellipsis_operator] = ACTIONS(15085),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9290] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9291] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(15149),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15151),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(15153),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(15153),
    [sym__pipe_right_operator] = ACTIONS(15163),
    [sym__pipe_left_operator] = ACTIONS(15165),
    [sym__ellipsis_operator] = ACTIONS(15167),
    [sym__plus_operator] = ACTIONS(15139),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(15153),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15139),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9292] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15151),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(15167),
    [sym__plus_operator] = ACTIONS(15139),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15139),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9293] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(15151),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_RBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(15163),
    [sym__pipe_left_operator] = ACTIONS(15165),
    [sym__ellipsis_operator] = ACTIONS(15167),
    [sym__plus_operator] = ACTIONS(15139),
    [sym__times_operator] = ACTIONS(15141),
    [sym__rational_operator] = ACTIONS(15143),
    [sym__bitshift_operator] = ACTIONS(15145),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15139),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9294] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9295] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9296] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(15135),
    [sym__immediate_command_start] = ACTIONS(15137),
  },
  [9297] = {
    [sym__word_identifier] = ACTIONS(14991),
    [anon_sym_COLON] = ACTIONS(14991),
    [anon_sym_begin] = ACTIONS(14991),
    [anon_sym_module] = ACTIONS(14991),
    [anon_sym_baremodule] = ACTIONS(14991),
    [anon_sym_abstract] = ACTIONS(14991),
    [anon_sym_primitive] = ACTIONS(14991),
    [anon_sym_mutable] = ACTIONS(14991),
    [anon_sym_struct] = ACTIONS(14991),
    [anon_sym_function] = ACTIONS(14991),
    [anon_sym_macro] = ACTIONS(14991),
    [anon_sym_where] = ACTIONS(15015),
    [anon_sym_quote] = ACTIONS(14991),
    [anon_sym_let] = ACTIONS(14991),
    [anon_sym_if] = ACTIONS(14991),
    [anon_sym_try] = ACTIONS(14991),
    [anon_sym_for] = ACTIONS(14991),
    [anon_sym_while] = ACTIONS(14991),
    [sym_break_statement] = ACTIONS(14991),
    [sym_continue_statement] = ACTIONS(14991),
    [anon_sym_return] = ACTIONS(14991),
    [anon_sym_const] = ACTIONS(14991),
    [anon_sym_global] = ACTIONS(14991),
    [anon_sym_local] = ACTIONS(14991),
    [anon_sym_LPAREN] = ACTIONS(14991),
    [anon_sym_COLON2] = ACTIONS(15017),
    [anon_sym_export] = ACTIONS(14991),
    [anon_sym_import] = ACTIONS(14991),
    [anon_sym_using] = ACTIONS(14991),
    [anon_sym_LBRACK] = ACTIONS(14991),
    [anon_sym_RBRACK] = ACTIONS(14991),
    [anon_sym_LF] = ACTIONS(14993),
    [anon_sym_in] = ACTIONS(15019),
    [anon_sym_LBRACE] = ACTIONS(14991),
    [anon_sym_DOLLAR] = ACTIONS(14991),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(15019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13211),
    [anon_sym_QMARK] = ACTIONS(15097),
    [anon_sym_AT] = ACTIONS(14991),
    [anon_sym_true] = ACTIONS(14991),
    [anon_sym_false] = ACTIONS(14991),
    [aux_sym_integer_literal_token1] = ACTIONS(14991),
    [aux_sym_integer_literal_token2] = ACTIONS(14991),
    [aux_sym_integer_literal_token3] = ACTIONS(14991),
    [aux_sym_integer_literal_token4] = ACTIONS(14991),
    [aux_sym_float_literal_token1] = ACTIONS(14991),
    [aux_sym_float_literal_token3] = ACTIONS(14991),
    [aux_sym_float_literal_token4] = ACTIONS(14991),
    [sym_character_literal] = ACTIONS(14991),
    [sym__pair_operator] = ACTIONS(15023),
    [sym__arrow_operator] = ACTIONS(15025),
    [sym__lazy_or_operator] = ACTIONS(15027),
    [sym__lazy_and_operator] = ACTIONS(15029),
    [sym__comparison_operator] = ACTIONS(15019),
    [sym__pipe_right_operator] = ACTIONS(15031),
    [sym__pipe_left_operator] = ACTIONS(15033),
    [sym__ellipsis_operator] = ACTIONS(15035),
    [sym__plus_operator] = ACTIONS(15037),
    [sym__times_operator] = ACTIONS(15039),
    [sym__rational_operator] = ACTIONS(15041),
    [sym__bitshift_operator] = ACTIONS(15043),
    [sym__power_operator] = ACTIONS(15045),
    [sym__tilde_operator] = ACTIONS(14991),
    [sym__type_order_operator] = ACTIONS(15019),
    [sym__unary_operator] = ACTIONS(14991),
    [sym__unary_plus_operator] = ACTIONS(15037),
    [aux_sym__terminator_token1] = ACTIONS(14991),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(14993),
    [sym__command_start] = ACTIONS(14993),
  },
  [9298] = {
    [sym__word_identifier] = ACTIONS(13338),
    [anon_sym_COMMA] = ACTIONS(13340),
    [anon_sym_COLON] = ACTIONS(13338),
    [anon_sym_begin] = ACTIONS(13338),
    [anon_sym_module] = ACTIONS(13338),
    [anon_sym_baremodule] = ACTIONS(13338),
    [anon_sym_abstract] = ACTIONS(13338),
    [anon_sym_primitive] = ACTIONS(13338),
    [anon_sym_mutable] = ACTIONS(13338),
    [anon_sym_struct] = ACTIONS(13338),
    [anon_sym_function] = ACTIONS(13338),
    [anon_sym_macro] = ACTIONS(13338),
    [anon_sym_where] = ACTIONS(15123),
    [anon_sym_quote] = ACTIONS(13338),
    [anon_sym_let] = ACTIONS(13338),
    [anon_sym_if] = ACTIONS(13338),
    [anon_sym_try] = ACTIONS(13338),
    [anon_sym_for] = ACTIONS(13338),
    [anon_sym_while] = ACTIONS(13338),
    [sym_break_statement] = ACTIONS(13338),
    [sym_continue_statement] = ACTIONS(13338),
    [anon_sym_return] = ACTIONS(13338),
    [anon_sym_const] = ACTIONS(13338),
    [anon_sym_global] = ACTIONS(13338),
    [anon_sym_local] = ACTIONS(13338),
    [anon_sym_LPAREN] = ACTIONS(13340),
    [anon_sym_RPAREN] = ACTIONS(13340),
    [anon_sym_COLON2] = ACTIONS(15101),
    [anon_sym_export] = ACTIONS(13338),
    [anon_sym_import] = ACTIONS(13338),
    [anon_sym_using] = ACTIONS(13338),
    [anon_sym_LBRACK] = ACTIONS(13340),
    [anon_sym_in] = ACTIONS(15125),
    [anon_sym_SEMI] = ACTIONS(13340),
    [anon_sym_LBRACE] = ACTIONS(13340),
    [anon_sym_DOLLAR] = ACTIONS(13340),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(15125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14714),
    [anon_sym_QMARK] = ACTIONS(15013),
    [anon_sym_AT] = ACTIONS(13340),
    [anon_sym_true] = ACTIONS(13338),
    [anon_sym_false] = ACTIONS(13338),
    [aux_sym_integer_literal_token1] = ACTIONS(13340),
    [aux_sym_integer_literal_token2] = ACTIONS(13340),
    [aux_sym_integer_literal_token3] = ACTIONS(13338),
    [aux_sym_integer_literal_token4] = ACTIONS(13338),
    [aux_sym_float_literal_token1] = ACTIONS(13340),
    [aux_sym_float_literal_token3] = ACTIONS(13340),
    [aux_sym_float_literal_token4] = ACTIONS(13340),
    [sym_character_literal] = ACTIONS(13340),
    [sym__pair_operator] = ACTIONS(15173),
    [sym__arrow_operator] = ACTIONS(15127),
    [sym__lazy_or_operator] = ACTIONS(15129),
    [sym__lazy_and_operator] = ACTIONS(15131),
    [sym__comparison_operator] = ACTIONS(15125),
    [sym__pipe_right_operator] = ACTIONS(15103),
    [sym__pipe_left_operator] = ACTIONS(15105),
    [sym__ellipsis_operator] = ACTIONS(15107),
    [sym__plus_operator] = ACTIONS(15109),
    [sym__times_operator] = ACTIONS(15111),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13340),
    [sym__type_order_operator] = ACTIONS(15133),
    [sym__unary_operator] = ACTIONS(13338),
    [sym__unary_plus_operator] = ACTIONS(15109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13340),
    [sym__command_start] = ACTIONS(13340),
  },
  [9299] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(15119),
    [sym__arrow_operator] = ACTIONS(15121),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3069),
    [sym__pipe_right_operator] = ACTIONS(15081),
    [sym__pipe_left_operator] = ACTIONS(15083),
    [sym__ellipsis_operator] = ACTIONS(15085),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(3069),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9300] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(3065),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(15121),
    [sym__lazy_or_operator] = ACTIONS(3081),
    [sym__lazy_and_operator] = ACTIONS(3083),
    [sym__comparison_operator] = ACTIONS(3069),
    [sym__pipe_right_operator] = ACTIONS(15081),
    [sym__pipe_left_operator] = ACTIONS(15083),
    [sym__ellipsis_operator] = ACTIONS(15085),
    [sym__plus_operator] = ACTIONS(15087),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(3069),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(15087),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9301] = {
    [sym__primary_expression] = STATE(11359),
    [sym__array] = STATE(11359),
    [sym_comprehension_expression] = STATE(11359),
    [sym_matrix_expression] = STATE(11359),
    [sym_vector_expression] = STATE(11359),
    [sym_parenthesized_expression] = STATE(11359),
    [sym_tuple_expression] = STATE(11359),
    [sym_curly_expression] = STATE(11359),
    [sym_adjoint_expression] = STATE(11359),
    [sym_field_expression] = STATE(11359),
    [sym_index_expression] = STATE(11359),
    [sym_parametrized_type_expression] = STATE(11359),
    [sym_call_expression] = STATE(11359),
    [sym_broadcast_call_expression] = STATE(11359),
    [sym__closed_macrocall_expression] = STATE(11359),
    [sym_interpolation_expression] = STATE(11359),
    [sym_quote_expression] = STATE(11359),
    [sym_macro_identifier] = STATE(17273),
    [sym_identifier] = STATE(10579),
    [sym_boolean_literal] = STATE(11359),
    [sym__string] = STATE(11359),
    [sym_string_literal] = STATE(11359),
    [sym_command_literal] = STATE(11359),
    [sym_prefixed_string_literal] = STATE(11359),
    [sym_prefixed_command_literal] = STATE(11359),
    [sym_operator] = STATE(18510),
    [sym__word_identifier] = ACTIONS(13284),
    [anon_sym_EQ] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(15183),
    [anon_sym_where] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(13288),
    [anon_sym_COLON2] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(13290),
    [anon_sym_in] = ACTIONS(91),
    [anon_sym_LBRACE] = ACTIONS(13292),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(13294),
    [anon_sym_COLON_COLON] = ACTIONS(171),
    [anon_sym_isa] = ACTIONS(91),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(171),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_AT] = ACTIONS(13296),
    [anon_sym_true] = ACTIONS(13298),
    [anon_sym_false] = ACTIONS(13298),
    [sym_character_literal] = ACTIONS(13300),
    [sym__assignment_operator] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11139),
    [sym__lazy_or_operator] = ACTIONS(171),
    [sym__lazy_and_operator] = ACTIONS(171),
    [sym__comparison_operator] = ACTIONS(11139),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11139),
    [sym__plus_operator] = ACTIONS(11139),
    [sym__times_operator] = ACTIONS(11139),
    [sym__rational_operator] = ACTIONS(11139),
    [sym__bitshift_operator] = ACTIONS(11139),
    [sym__power_operator] = ACTIONS(11139),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11139),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(13302),
    [sym__command_start] = ACTIONS(13304),
  },
  [9302] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(15089),
    [sym__rational_operator] = ACTIONS(15091),
    [sym__bitshift_operator] = ACTIONS(15093),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9303] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(15135),
    [sym__immediate_command_start] = ACTIONS(15137),
  },
  [9304] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_end] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13306),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13306),
    [anon_sym_LF] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_LBRACE] = ACTIONS(13306),
    [anon_sym_DOLLAR] = ACTIONS(13306),
    [anon_sym_COLON_COLON] = ACTIONS(14680),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13306),
    [anon_sym_QMARK] = ACTIONS(13306),
    [anon_sym_AT] = ACTIONS(13306),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13306),
    [aux_sym_integer_literal_token2] = ACTIONS(13306),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13306),
    [aux_sym_float_literal_token3] = ACTIONS(13306),
    [aux_sym_float_literal_token4] = ACTIONS(13306),
    [sym_character_literal] = ACTIONS(13306),
    [sym__pair_operator] = ACTIONS(13306),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13306),
    [sym__lazy_and_operator] = ACTIONS(13306),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13306),
    [sym__pipe_left_operator] = ACTIONS(13306),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(13306),
    [sym__bitshift_operator] = ACTIONS(13306),
    [sym__power_operator] = ACTIONS(15095),
    [sym__tilde_operator] = ACTIONS(13306),
    [sym__type_order_operator] = ACTIONS(13306),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [aux_sym__terminator_token1] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9305] = {
    [sym__word_identifier] = ACTIONS(13308),
    [anon_sym_COLON] = ACTIONS(13308),
    [anon_sym_begin] = ACTIONS(13308),
    [anon_sym_module] = ACTIONS(13308),
    [anon_sym_baremodule] = ACTIONS(13308),
    [anon_sym_abstract] = ACTIONS(13308),
    [anon_sym_primitive] = ACTIONS(13308),
    [anon_sym_mutable] = ACTIONS(13308),
    [anon_sym_struct] = ACTIONS(13308),
    [anon_sym_function] = ACTIONS(13308),
    [anon_sym_macro] = ACTIONS(13308),
    [anon_sym_where] = ACTIONS(13308),
    [anon_sym_quote] = ACTIONS(13308),
    [anon_sym_let] = ACTIONS(13308),
    [anon_sym_if] = ACTIONS(13308),
    [anon_sym_try] = ACTIONS(13308),
    [anon_sym_for] = ACTIONS(13308),
    [anon_sym_while] = ACTIONS(13308),
    [sym_break_statement] = ACTIONS(13308),
    [sym_continue_statement] = ACTIONS(13308),
    [anon_sym_return] = ACTIONS(13308),
    [anon_sym_const] = ACTIONS(13308),
    [anon_sym_global] = ACTIONS(13308),
    [anon_sym_local] = ACTIONS(13308),
    [anon_sym_LPAREN] = ACTIONS(13308),
    [anon_sym_COLON2] = ACTIONS(13308),
    [anon_sym_export] = ACTIONS(13308),
    [anon_sym_import] = ACTIONS(13308),
    [anon_sym_using] = ACTIONS(13308),
    [anon_sym_LBRACK] = ACTIONS(13308),
    [anon_sym_RBRACK] = ACTIONS(13308),
    [anon_sym_LF] = ACTIONS(13310),
    [anon_sym_in] = ACTIONS(13308),
    [anon_sym_LBRACE] = ACTIONS(13308),
    [anon_sym_DOLLAR] = ACTIONS(13308),
    [anon_sym_COLON_COLON] = ACTIONS(13209),
    [anon_sym_isa] = ACTIONS(13308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13308),
    [anon_sym_QMARK] = ACTIONS(13308),
    [anon_sym_AT] = ACTIONS(13308),
    [anon_sym_true] = ACTIONS(13308),
    [anon_sym_false] = ACTIONS(13308),
    [aux_sym_integer_literal_token1] = ACTIONS(13308),
    [aux_sym_integer_literal_token2] = ACTIONS(13308),
    [aux_sym_integer_literal_token3] = ACTIONS(13308),
    [aux_sym_integer_literal_token4] = ACTIONS(13308),
    [aux_sym_float_literal_token1] = ACTIONS(13308),
    [aux_sym_float_literal_token3] = ACTIONS(13308),
    [aux_sym_float_literal_token4] = ACTIONS(13308),
    [sym_character_literal] = ACTIONS(13308),
    [sym__pair_operator] = ACTIONS(13308),
    [sym__arrow_operator] = ACTIONS(13308),
    [sym__lazy_or_operator] = ACTIONS(13308),
    [sym__lazy_and_operator] = ACTIONS(13308),
    [sym__comparison_operator] = ACTIONS(13308),
    [sym__pipe_right_operator] = ACTIONS(13308),
    [sym__pipe_left_operator] = ACTIONS(13308),
    [sym__ellipsis_operator] = ACTIONS(13308),
    [sym__plus_operator] = ACTIONS(13308),
    [sym__times_operator] = ACTIONS(13308),
    [sym__rational_operator] = ACTIONS(13308),
    [sym__bitshift_operator] = ACTIONS(13308),
    [sym__power_operator] = ACTIONS(15147),
    [sym__tilde_operator] = ACTIONS(13308),
    [sym__type_order_operator] = ACTIONS(13308),
    [sym__unary_operator] = ACTIONS(13308),
    [sym__unary_plus_operator] = ACTIONS(13308),
    [aux_sym__terminator_token1] = ACTIONS(13308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13310),
    [sym__command_start] = ACTIONS(13310),
  },
  [9306] = {
    [sym__word_identifier] = ACTIONS(13306),
    [anon_sym_COMMA] = ACTIONS(13312),
    [anon_sym_COLON] = ACTIONS(13306),
    [anon_sym_begin] = ACTIONS(13306),
    [anon_sym_module] = ACTIONS(13306),
    [anon_sym_baremodule] = ACTIONS(13306),
    [anon_sym_abstract] = ACTIONS(13306),
    [anon_sym_primitive] = ACTIONS(13306),
    [anon_sym_mutable] = ACTIONS(13306),
    [anon_sym_struct] = ACTIONS(13306),
    [anon_sym_function] = ACTIONS(13306),
    [anon_sym_macro] = ACTIONS(13306),
    [anon_sym_where] = ACTIONS(13306),
    [anon_sym_quote] = ACTIONS(13306),
    [anon_sym_let] = ACTIONS(13306),
    [anon_sym_if] = ACTIONS(13306),
    [anon_sym_try] = ACTIONS(13306),
    [anon_sym_for] = ACTIONS(13306),
    [anon_sym_while] = ACTIONS(13306),
    [sym_break_statement] = ACTIONS(13306),
    [sym_continue_statement] = ACTIONS(13306),
    [anon_sym_return] = ACTIONS(13306),
    [anon_sym_const] = ACTIONS(13306),
    [anon_sym_global] = ACTIONS(13306),
    [anon_sym_local] = ACTIONS(13306),
    [anon_sym_LPAREN] = ACTIONS(13312),
    [anon_sym_RPAREN] = ACTIONS(13312),
    [anon_sym_COLON2] = ACTIONS(13306),
    [anon_sym_export] = ACTIONS(13306),
    [anon_sym_import] = ACTIONS(13306),
    [anon_sym_using] = ACTIONS(13306),
    [anon_sym_LBRACK] = ACTIONS(13312),
    [anon_sym_in] = ACTIONS(13306),
    [anon_sym_SEMI] = ACTIONS(13312),
    [anon_sym_LBRACE] = ACTIONS(13312),
    [anon_sym_DOLLAR] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(14640),
    [anon_sym_isa] = ACTIONS(13306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13312),
    [anon_sym_QMARK] = ACTIONS(13312),
    [anon_sym_AT] = ACTIONS(13312),
    [anon_sym_true] = ACTIONS(13306),
    [anon_sym_false] = ACTIONS(13306),
    [aux_sym_integer_literal_token1] = ACTIONS(13312),
    [aux_sym_integer_literal_token2] = ACTIONS(13312),
    [aux_sym_integer_literal_token3] = ACTIONS(13306),
    [aux_sym_integer_literal_token4] = ACTIONS(13306),
    [aux_sym_float_literal_token1] = ACTIONS(13312),
    [aux_sym_float_literal_token3] = ACTIONS(13312),
    [aux_sym_float_literal_token4] = ACTIONS(13312),
    [sym_character_literal] = ACTIONS(13312),
    [sym__pair_operator] = ACTIONS(13312),
    [sym__arrow_operator] = ACTIONS(13306),
    [sym__lazy_or_operator] = ACTIONS(13312),
    [sym__lazy_and_operator] = ACTIONS(13312),
    [sym__comparison_operator] = ACTIONS(13306),
    [sym__pipe_right_operator] = ACTIONS(13312),
    [sym__pipe_left_operator] = ACTIONS(13312),
    [sym__ellipsis_operator] = ACTIONS(13306),
    [sym__plus_operator] = ACTIONS(13306),
    [sym__times_operator] = ACTIONS(13306),
    [sym__rational_operator] = ACTIONS(15113),
    [sym__bitshift_operator] = ACTIONS(15115),
    [sym__power_operator] = ACTIONS(15117),
    [sym__tilde_operator] = ACTIONS(13312),
    [sym__type_order_operator] = ACTIONS(13312),
    [sym__unary_operator] = ACTIONS(13306),
    [sym__unary_plus_operator] = ACTIONS(13306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13312),
    [sym__command_start] = ACTIONS(13312),
  },
  [9307] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [9308] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [9309] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
    [sym__immediate_string_start] = ACTIONS(15186),
    [sym__immediate_command_start] = ACTIONS(15188),
  },
  [9310] = {
    [sym__primary_expression] = STATE(11344),
    [sym__array] = STATE(11344),
    [sym_comprehension_expression] = STATE(11344),
    [sym_matrix_expression] = STATE(11344),
    [sym_vector_expression] = STATE(11344),
    [sym_parenthesized_expression] = STATE(11344),
    [sym_tuple_expression] = STATE(11344),
    [sym_curly_expression] = STATE(11344),
    [sym_adjoint_expression] = STATE(11344),
    [sym_field_expression] = STATE(11344),
    [sym_index_expression] = STATE(11344),
    [sym_parametrized_type_expression] = STATE(11344),
    [sym_call_expression] = STATE(11344),
    [sym_broadcast_call_expression] = STATE(11344),
    [sym__closed_macrocall_expression] = STATE(11344),
    [sym_interpolation_expression] = STATE(11344),
    [sym_quote_expression] = STATE(11344),
    [sym_macro_identifier] = STATE(17042),
    [sym_identifier] = STATE(10822),
    [sym_boolean_literal] = STATE(11344),
    [sym__string] = STATE(11344),
    [sym_string_literal] = STATE(11344),
    [sym_command_literal] = STATE(11344),
    [sym_prefixed_string_literal] = STATE(11344),
    [sym_prefixed_command_literal] = STATE(11344),
    [sym_operator] = STATE(19221),
    [sym__word_identifier] = ACTIONS(13040),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(13042),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(13044),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(13046),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(13048),
    [anon_sym_DOLLAR] = ACTIONS(13050),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(13052),
    [anon_sym_false] = ACTIONS(13052),
    [sym_character_literal] = ACTIONS(13054),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(2926),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13056),
    [sym__command_start] = ACTIONS(13058),
  },
  [9311] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [9312] = {
    [sym_do_clause] = STATE(9455),
    [sym__word_identifier] = ACTIONS(11896),
    [anon_sym_COLON] = ACTIONS(11896),
    [anon_sym_begin] = ACTIONS(11896),
    [anon_sym_module] = ACTIONS(11896),
    [anon_sym_baremodule] = ACTIONS(11896),
    [anon_sym_end] = ACTIONS(11896),
    [anon_sym_abstract] = ACTIONS(11896),
    [anon_sym_primitive] = ACTIONS(11896),
    [anon_sym_mutable] = ACTIONS(11896),
    [anon_sym_struct] = ACTIONS(11896),
    [anon_sym_function] = ACTIONS(11896),
    [anon_sym_macro] = ACTIONS(11896),
    [anon_sym_quote] = ACTIONS(11896),
    [anon_sym_let] = ACTIONS(11896),
    [anon_sym_if] = ACTIONS(11896),
    [anon_sym_try] = ACTIONS(11896),
    [anon_sym_for] = ACTIONS(11896),
    [anon_sym_while] = ACTIONS(11896),
    [sym_break_statement] = ACTIONS(11896),
    [sym_continue_statement] = ACTIONS(11896),
    [anon_sym_return] = ACTIONS(11896),
    [anon_sym_const] = ACTIONS(11896),
    [anon_sym_global] = ACTIONS(11896),
    [anon_sym_local] = ACTIONS(11896),
    [anon_sym_LPAREN] = ACTIONS(11896),
    [anon_sym_export] = ACTIONS(11896),
    [anon_sym_import] = ACTIONS(11896),
    [anon_sym_using] = ACTIONS(11896),
    [anon_sym_LBRACK] = ACTIONS(11896),
    [anon_sym_LF] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11896),
    [anon_sym_SQUOTE] = ACTIONS(11896),
    [anon_sym_DOT] = ACTIONS(11896),
    [anon_sym_do] = ACTIONS(15190),
    [anon_sym_DOLLAR] = ACTIONS(11896),
    [anon_sym_COLON_COLON] = ACTIONS(11896),
    [anon_sym_AT] = ACTIONS(11896),
    [anon_sym_true] = ACTIONS(11896),
    [anon_sym_false] = ACTIONS(11896),
    [aux_sym_integer_literal_token1] = ACTIONS(11896),
    [aux_sym_integer_literal_token2] = ACTIONS(11896),
    [aux_sym_integer_literal_token3] = ACTIONS(11896),
    [aux_sym_integer_literal_token4] = ACTIONS(11896),
    [aux_sym_float_literal_token1] = ACTIONS(11896),
    [aux_sym_float_literal_token3] = ACTIONS(11896),
    [aux_sym_float_literal_token4] = ACTIONS(11896),
    [sym_character_literal] = ACTIONS(11896),
    [sym__pair_operator] = ACTIONS(11896),
    [sym__arrow_operator] = ACTIONS(11896),
    [sym__comparison_operator] = ACTIONS(11896),
    [sym__pipe_right_operator] = ACTIONS(11896),
    [sym__pipe_left_operator] = ACTIONS(11896),
    [sym__ellipsis_operator] = ACTIONS(11896),
    [sym__plus_operator] = ACTIONS(11896),
    [sym__times_operator] = ACTIONS(11896),
    [sym__rational_operator] = ACTIONS(11896),
    [sym__bitshift_operator] = ACTIONS(11896),
    [sym__power_operator] = ACTIONS(11896),
    [sym__tilde_operator] = ACTIONS(11896),
    [sym__type_order_operator] = ACTIONS(11896),
    [sym__unary_operator] = ACTIONS(11896),
    [sym__unary_plus_operator] = ACTIONS(11896),
    [aux_sym__terminator_token1] = ACTIONS(11896),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11898),
    [sym__immediate_bracket] = ACTIONS(11898),
    [sym__immediate_brace] = ACTIONS(11898),
    [sym__string_start] = ACTIONS(11898),
    [sym__command_start] = ACTIONS(11898),
  },
  [9313] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
    [sym__immediate_string_start] = ACTIONS(15186),
    [sym__immediate_command_start] = ACTIONS(15188),
  },
  [9314] = {
    [sym_do_clause] = STATE(9466),
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_do] = ACTIONS(15190),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [9315] = {
    [sym_do_clause] = STATE(9422),
    [sym__word_identifier] = ACTIONS(11902),
    [anon_sym_COLON] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11902),
    [anon_sym_module] = ACTIONS(11902),
    [anon_sym_baremodule] = ACTIONS(11902),
    [anon_sym_end] = ACTIONS(11902),
    [anon_sym_abstract] = ACTIONS(11902),
    [anon_sym_primitive] = ACTIONS(11902),
    [anon_sym_mutable] = ACTIONS(11902),
    [anon_sym_struct] = ACTIONS(11902),
    [anon_sym_function] = ACTIONS(11902),
    [anon_sym_macro] = ACTIONS(11902),
    [anon_sym_quote] = ACTIONS(11902),
    [anon_sym_let] = ACTIONS(11902),
    [anon_sym_if] = ACTIONS(11902),
    [anon_sym_try] = ACTIONS(11902),
    [anon_sym_for] = ACTIONS(11902),
    [anon_sym_while] = ACTIONS(11902),
    [sym_break_statement] = ACTIONS(11902),
    [sym_continue_statement] = ACTIONS(11902),
    [anon_sym_return] = ACTIONS(11902),
    [anon_sym_const] = ACTIONS(11902),
    [anon_sym_global] = ACTIONS(11902),
    [anon_sym_local] = ACTIONS(11902),
    [anon_sym_LPAREN] = ACTIONS(11902),
    [anon_sym_export] = ACTIONS(11902),
    [anon_sym_import] = ACTIONS(11902),
    [anon_sym_using] = ACTIONS(11902),
    [anon_sym_LBRACK] = ACTIONS(11902),
    [anon_sym_LF] = ACTIONS(11904),
    [anon_sym_LBRACE] = ACTIONS(11902),
    [anon_sym_SQUOTE] = ACTIONS(11902),
    [anon_sym_DOT] = ACTIONS(11902),
    [anon_sym_do] = ACTIONS(15190),
    [anon_sym_DOLLAR] = ACTIONS(11902),
    [anon_sym_COLON_COLON] = ACTIONS(11902),
    [anon_sym_AT] = ACTIONS(11902),
    [anon_sym_true] = ACTIONS(11902),
    [anon_sym_false] = ACTIONS(11902),
    [aux_sym_integer_literal_token1] = ACTIONS(11902),
    [aux_sym_integer_literal_token2] = ACTIONS(11902),
    [aux_sym_integer_literal_token3] = ACTIONS(11902),
    [aux_sym_integer_literal_token4] = ACTIONS(11902),
    [aux_sym_float_literal_token1] = ACTIONS(11902),
    [aux_sym_float_literal_token3] = ACTIONS(11902),
    [aux_sym_float_literal_token4] = ACTIONS(11902),
    [sym_character_literal] = ACTIONS(11902),
    [sym__pair_operator] = ACTIONS(11902),
    [sym__arrow_operator] = ACTIONS(11902),
    [sym__comparison_operator] = ACTIONS(11902),
    [sym__pipe_right_operator] = ACTIONS(11902),
    [sym__pipe_left_operator] = ACTIONS(11902),
    [sym__ellipsis_operator] = ACTIONS(11902),
    [sym__plus_operator] = ACTIONS(11902),
    [sym__times_operator] = ACTIONS(11902),
    [sym__rational_operator] = ACTIONS(11902),
    [sym__bitshift_operator] = ACTIONS(11902),
    [sym__power_operator] = ACTIONS(11902),
    [sym__tilde_operator] = ACTIONS(11902),
    [sym__type_order_operator] = ACTIONS(11902),
    [sym__unary_operator] = ACTIONS(11902),
    [sym__unary_plus_operator] = ACTIONS(11902),
    [aux_sym__terminator_token1] = ACTIONS(11902),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11904),
    [sym__immediate_bracket] = ACTIONS(11904),
    [sym__immediate_brace] = ACTIONS(11904),
    [sym__string_start] = ACTIONS(11904),
    [sym__command_start] = ACTIONS(11904),
  },
  [9316] = {
    [sym_do_clause] = STATE(9425),
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_do] = ACTIONS(15190),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [9317] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [9318] = {
    [sym__word_identifier] = ACTIONS(15175),
    [anon_sym_COLON] = ACTIONS(15175),
    [anon_sym_begin] = ACTIONS(15175),
    [anon_sym_module] = ACTIONS(15175),
    [anon_sym_baremodule] = ACTIONS(15175),
    [anon_sym_end] = ACTIONS(15175),
    [anon_sym_abstract] = ACTIONS(15175),
    [anon_sym_primitive] = ACTIONS(15175),
    [anon_sym_mutable] = ACTIONS(15175),
    [anon_sym_struct] = ACTIONS(15175),
    [anon_sym_function] = ACTIONS(15175),
    [anon_sym_macro] = ACTIONS(15175),
    [anon_sym_quote] = ACTIONS(15175),
    [anon_sym_let] = ACTIONS(15175),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_try] = ACTIONS(15175),
    [anon_sym_for] = ACTIONS(15175),
    [anon_sym_while] = ACTIONS(15175),
    [sym_break_statement] = ACTIONS(15175),
    [sym_continue_statement] = ACTIONS(15175),
    [anon_sym_return] = ACTIONS(15175),
    [anon_sym_const] = ACTIONS(15175),
    [anon_sym_global] = ACTIONS(15175),
    [anon_sym_local] = ACTIONS(15175),
    [anon_sym_LPAREN] = ACTIONS(15175),
    [anon_sym_export] = ACTIONS(15175),
    [anon_sym_import] = ACTIONS(15175),
    [anon_sym_using] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [anon_sym_LF] = ACTIONS(15179),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(15175),
    [anon_sym_COLON_COLON] = ACTIONS(15175),
    [anon_sym_AT] = ACTIONS(15175),
    [anon_sym_true] = ACTIONS(15175),
    [anon_sym_false] = ACTIONS(15175),
    [aux_sym_integer_literal_token1] = ACTIONS(15175),
    [aux_sym_integer_literal_token2] = ACTIONS(15175),
    [aux_sym_integer_literal_token3] = ACTIONS(15175),
    [aux_sym_integer_literal_token4] = ACTIONS(15175),
    [aux_sym_float_literal_token1] = ACTIONS(15175),
    [aux_sym_float_literal_token3] = ACTIONS(15175),
    [aux_sym_float_literal_token4] = ACTIONS(15175),
    [sym_character_literal] = ACTIONS(15175),
    [sym__pair_operator] = ACTIONS(15175),
    [sym__arrow_operator] = ACTIONS(15175),
    [sym__comparison_operator] = ACTIONS(15175),
    [sym__pipe_right_operator] = ACTIONS(15175),
    [sym__pipe_left_operator] = ACTIONS(15175),
    [sym__ellipsis_operator] = ACTIONS(15175),
    [sym__plus_operator] = ACTIONS(15175),
    [sym__times_operator] = ACTIONS(15175),
    [sym__rational_operator] = ACTIONS(15175),
    [sym__bitshift_operator] = ACTIONS(15175),
    [sym__power_operator] = ACTIONS(15175),
    [sym__tilde_operator] = ACTIONS(15175),
    [sym__type_order_operator] = ACTIONS(15175),
    [sym__unary_operator] = ACTIONS(15175),
    [sym__unary_plus_operator] = ACTIONS(15175),
    [aux_sym__terminator_token1] = ACTIONS(15175),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(15179),
    [sym__command_start] = ACTIONS(15179),
    [sym__immediate_string_start] = ACTIONS(15192),
    [sym__immediate_command_start] = ACTIONS(15194),
  },
  [9319] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_SQUOTE] = ACTIONS(11866),
    [anon_sym_DOT] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11864),
    [sym__immediate_bracket] = ACTIONS(11864),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [9320] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [9321] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(15196),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [9322] = {
    [sym_identifier] = STATE(9379),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_where] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [9323] = {
    [sym_identifier] = STATE(9338),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_where] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [9324] = {
    [sym_identifier] = STATE(9391),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_where] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [9325] = {
    [sym_identifier] = STATE(9393),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_where] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [9326] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(15186),
    [sym__immediate_command_start] = ACTIONS(15188),
  },
  [9327] = {
    [sym__word_identifier] = ACTIONS(91),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_begin] = ACTIONS(91),
    [anon_sym_module] = ACTIONS(91),
    [anon_sym_baremodule] = ACTIONS(91),
    [anon_sym_end] = ACTIONS(91),
    [anon_sym_abstract] = ACTIONS(91),
    [anon_sym_primitive] = ACTIONS(91),
    [anon_sym_mutable] = ACTIONS(91),
    [anon_sym_struct] = ACTIONS(91),
    [anon_sym_function] = ACTIONS(91),
    [anon_sym_macro] = ACTIONS(91),
    [anon_sym_quote] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_while] = ACTIONS(91),
    [sym_break_statement] = ACTIONS(91),
    [sym_continue_statement] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_const] = ACTIONS(91),
    [anon_sym_global] = ACTIONS(91),
    [anon_sym_local] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(91),
    [anon_sym_import] = ACTIONS(91),
    [anon_sym_using] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(171),
    [anon_sym_LBRACE] = ACTIONS(91),
    [anon_sym_SQUOTE] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(91),
    [anon_sym_COLON_COLON] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(91),
    [aux_sym_integer_literal_token1] = ACTIONS(91),
    [aux_sym_integer_literal_token2] = ACTIONS(91),
    [aux_sym_integer_literal_token3] = ACTIONS(91),
    [aux_sym_integer_literal_token4] = ACTIONS(91),
    [aux_sym_float_literal_token1] = ACTIONS(91),
    [aux_sym_float_literal_token3] = ACTIONS(91),
    [aux_sym_float_literal_token4] = ACTIONS(91),
    [sym_character_literal] = ACTIONS(91),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(91),
    [sym__comparison_operator] = ACTIONS(91),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(91),
    [sym__times_operator] = ACTIONS(91),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(91),
    [sym__type_order_operator] = ACTIONS(91),
    [sym__unary_operator] = ACTIONS(91),
    [sym__unary_plus_operator] = ACTIONS(91),
    [aux_sym__terminator_token1] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(171),
    [sym__immediate_bracket] = ACTIONS(171),
    [sym__immediate_brace] = ACTIONS(171),
    [sym__string_start] = ACTIONS(171),
    [sym__command_start] = ACTIONS(171),
    [sym__immediate_string_start] = ACTIONS(15186),
    [sym__immediate_command_start] = ACTIONS(15188),
  },
  [9328] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [9329] = {
    [sym__primary_expression] = STATE(11232),
    [sym__array] = STATE(11232),
    [sym_comprehension_expression] = STATE(11232),
    [sym_matrix_expression] = STATE(11232),
    [sym_vector_expression] = STATE(11232),
    [sym_parenthesized_expression] = STATE(11232),
    [sym_tuple_expression] = STATE(11232),
    [sym_curly_expression] = STATE(11232),
    [sym_adjoint_expression] = STATE(11232),
    [sym_field_expression] = STATE(11232),
    [sym_index_expression] = STATE(11232),
    [sym_parametrized_type_expression] = STATE(11232),
    [sym_call_expression] = STATE(11232),
    [sym_broadcast_call_expression] = STATE(11232),
    [sym__closed_macrocall_expression] = STATE(11232),
    [sym_interpolation_expression] = STATE(11232),
    [sym_quote_expression] = STATE(11232),
    [sym_macro_identifier] = STATE(16973),
    [sym_identifier] = STATE(10685),
    [sym_boolean_literal] = STATE(11232),
    [sym__string] = STATE(11232),
    [sym_string_literal] = STATE(11232),
    [sym_command_literal] = STATE(11232),
    [sym_prefixed_string_literal] = STATE(11232),
    [sym_prefixed_command_literal] = STATE(11232),
    [sym_operator] = STATE(19061),
    [sym__word_identifier] = ACTIONS(13170),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(13172),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(13174),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(13176),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(13178),
    [anon_sym_DOLLAR] = ACTIONS(13180),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(13182),
    [anon_sym_false] = ACTIONS(13182),
    [sym_character_literal] = ACTIONS(13184),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(2926),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13186),
    [sym__command_start] = ACTIONS(13188),
  },
  [9330] = {
    [sym__primary_expression] = STATE(11363),
    [sym__array] = STATE(11363),
    [sym_comprehension_expression] = STATE(11363),
    [sym_matrix_expression] = STATE(11363),
    [sym_vector_expression] = STATE(11363),
    [sym_parenthesized_expression] = STATE(11363),
    [sym_tuple_expression] = STATE(11363),
    [sym_curly_expression] = STATE(11363),
    [sym_adjoint_expression] = STATE(11363),
    [sym_field_expression] = STATE(11363),
    [sym_index_expression] = STATE(11363),
    [sym_parametrized_type_expression] = STATE(11363),
    [sym_call_expression] = STATE(11363),
    [sym_broadcast_call_expression] = STATE(11363),
    [sym__closed_macrocall_expression] = STATE(11363),
    [sym_interpolation_expression] = STATE(11363),
    [sym_quote_expression] = STATE(11363),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(10801),
    [sym_boolean_literal] = STATE(11363),
    [sym__string] = STATE(11363),
    [sym_string_literal] = STATE(11363),
    [sym_command_literal] = STATE(11363),
    [sym_prefixed_string_literal] = STATE(11363),
    [sym_prefixed_command_literal] = STATE(11363),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(12987),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_elseif] = ACTIONS(11397),
    [anon_sym_else] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_DOLLAR] = ACTIONS(12995),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(13001),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(2926),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [9331] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [9332] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [9333] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [9334] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [9335] = {
    [sym__primary_expression] = STATE(11287),
    [sym__array] = STATE(11287),
    [sym_comprehension_expression] = STATE(11287),
    [sym_matrix_expression] = STATE(11287),
    [sym_vector_expression] = STATE(11287),
    [sym_parenthesized_expression] = STATE(11287),
    [sym_tuple_expression] = STATE(11287),
    [sym_curly_expression] = STATE(11287),
    [sym_adjoint_expression] = STATE(11287),
    [sym_field_expression] = STATE(11287),
    [sym_index_expression] = STATE(11287),
    [sym_parametrized_type_expression] = STATE(11287),
    [sym_call_expression] = STATE(11287),
    [sym_broadcast_call_expression] = STATE(11287),
    [sym__closed_macrocall_expression] = STATE(11287),
    [sym_interpolation_expression] = STATE(11287),
    [sym_quote_expression] = STATE(11287),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(10846),
    [sym_boolean_literal] = STATE(11287),
    [sym__string] = STATE(11287),
    [sym_string_literal] = STATE(11287),
    [sym_command_literal] = STATE(11287),
    [sym_prefixed_string_literal] = STATE(11287),
    [sym_prefixed_command_literal] = STATE(11287),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(13136),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_if] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_RPAREN] = ACTIONS(11397),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_RBRACK] = ACTIONS(11397),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_DOLLAR] = ACTIONS(13138),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(13140),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(2926),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [9336] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [9337] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [9338] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_where] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [9339] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_where] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [9340] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_where] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [9341] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(15198),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [9342] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_where] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [9343] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_where] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [9344] = {
    [sym__word_identifier] = ACTIONS(12410),
    [anon_sym_COLON] = ACTIONS(12410),
    [anon_sym_begin] = ACTIONS(12410),
    [anon_sym_module] = ACTIONS(12410),
    [anon_sym_baremodule] = ACTIONS(12410),
    [anon_sym_end] = ACTIONS(12410),
    [anon_sym_abstract] = ACTIONS(12410),
    [anon_sym_primitive] = ACTIONS(12410),
    [anon_sym_mutable] = ACTIONS(12410),
    [anon_sym_struct] = ACTIONS(12410),
    [anon_sym_function] = ACTIONS(12410),
    [anon_sym_macro] = ACTIONS(12410),
    [anon_sym_where] = ACTIONS(12410),
    [anon_sym_quote] = ACTIONS(12410),
    [anon_sym_let] = ACTIONS(12410),
    [anon_sym_if] = ACTIONS(12410),
    [anon_sym_try] = ACTIONS(12410),
    [anon_sym_for] = ACTIONS(12410),
    [anon_sym_while] = ACTIONS(12410),
    [sym_break_statement] = ACTIONS(12410),
    [sym_continue_statement] = ACTIONS(12410),
    [anon_sym_return] = ACTIONS(12410),
    [anon_sym_const] = ACTIONS(12410),
    [anon_sym_global] = ACTIONS(12410),
    [anon_sym_local] = ACTIONS(12410),
    [anon_sym_LPAREN] = ACTIONS(12410),
    [anon_sym_export] = ACTIONS(12410),
    [anon_sym_import] = ACTIONS(12410),
    [anon_sym_using] = ACTIONS(12410),
    [anon_sym_LBRACK] = ACTIONS(12410),
    [anon_sym_LF] = ACTIONS(12476),
    [anon_sym_LBRACE] = ACTIONS(12410),
    [anon_sym_SQUOTE] = ACTIONS(15200),
    [anon_sym_DOT] = ACTIONS(15202),
    [anon_sym_DOLLAR] = ACTIONS(12410),
    [anon_sym_COLON_COLON] = ACTIONS(12410),
    [anon_sym_AT] = ACTIONS(12410),
    [anon_sym_true] = ACTIONS(12410),
    [anon_sym_false] = ACTIONS(12410),
    [aux_sym_integer_literal_token1] = ACTIONS(12410),
    [aux_sym_integer_literal_token2] = ACTIONS(12410),
    [aux_sym_integer_literal_token3] = ACTIONS(12410),
    [aux_sym_integer_literal_token4] = ACTIONS(12410),
    [aux_sym_float_literal_token1] = ACTIONS(12410),
    [aux_sym_float_literal_token3] = ACTIONS(12410),
    [aux_sym_float_literal_token4] = ACTIONS(12410),
    [sym_character_literal] = ACTIONS(12410),
    [sym__pair_operator] = ACTIONS(12410),
    [sym__arrow_operator] = ACTIONS(12410),
    [sym__comparison_operator] = ACTIONS(12410),
    [sym__pipe_right_operator] = ACTIONS(12410),
    [sym__pipe_left_operator] = ACTIONS(12410),
    [sym__ellipsis_operator] = ACTIONS(12410),
    [sym__plus_operator] = ACTIONS(12410),
    [sym__times_operator] = ACTIONS(12410),
    [sym__rational_operator] = ACTIONS(12410),
    [sym__bitshift_operator] = ACTIONS(12410),
    [sym__power_operator] = ACTIONS(12410),
    [sym__tilde_operator] = ACTIONS(12410),
    [sym__type_order_operator] = ACTIONS(12410),
    [sym__unary_operator] = ACTIONS(12410),
    [sym__unary_plus_operator] = ACTIONS(12410),
    [aux_sym__terminator_token1] = ACTIONS(12410),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(15204),
    [sym__immediate_bracket] = ACTIONS(15206),
    [sym__immediate_brace] = ACTIONS(15208),
    [sym__string_start] = ACTIONS(12476),
    [sym__command_start] = ACTIONS(12476),
  },
  [9345] = {
    [sym_identifier] = STATE(9450),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_SQUOTE] = ACTIONS(11992),
    [anon_sym_DOT] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11994),
    [sym__immediate_bracket] = ACTIONS(11994),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [9346] = {
    [sym_identifier] = STATE(9453),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_SQUOTE] = ACTIONS(11958),
    [anon_sym_DOT] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11956),
    [sym__immediate_bracket] = ACTIONS(11956),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [9347] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [9348] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_where] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [9349] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_where] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [9350] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [9351] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_where] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [9352] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_where] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [9353] = {
    [sym_identifier] = STATE(9427),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_SQUOTE] = ACTIONS(12002),
    [anon_sym_DOT] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12004),
    [sym__immediate_bracket] = ACTIONS(12004),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [9354] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [9355] = {
    [sym_identifier] = STATE(9435),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_SQUOTE] = ACTIONS(12006),
    [anon_sym_DOT] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12008),
    [sym__immediate_bracket] = ACTIONS(12008),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [9356] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_where] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [9357] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_SQUOTE] = ACTIONS(11980),
    [anon_sym_DOT] = ACTIONS(11980),
    [anon_sym_do] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11982),
    [sym__immediate_bracket] = ACTIONS(11982),
    [sym__immediate_brace] = ACTIONS(11982),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [9358] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_SQUOTE] = ACTIONS(11988),
    [anon_sym_DOT] = ACTIONS(11988),
    [anon_sym_do] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11990),
    [sym__immediate_bracket] = ACTIONS(11990),
    [sym__immediate_brace] = ACTIONS(11990),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [9359] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_where] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [9360] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_SQUOTE] = ACTIONS(12036),
    [anon_sym_DOT] = ACTIONS(12036),
    [anon_sym_do] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12038),
    [sym__immediate_bracket] = ACTIONS(12038),
    [sym__immediate_brace] = ACTIONS(12038),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [9361] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_where] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [9362] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_where] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [9363] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_where] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [9364] = {
    [sym__primary_expression] = STATE(11430),
    [sym__array] = STATE(11430),
    [sym_comprehension_expression] = STATE(11430),
    [sym_matrix_expression] = STATE(11430),
    [sym_vector_expression] = STATE(11430),
    [sym_parenthesized_expression] = STATE(11430),
    [sym_tuple_expression] = STATE(11430),
    [sym_curly_expression] = STATE(11430),
    [sym_adjoint_expression] = STATE(11430),
    [sym_field_expression] = STATE(11430),
    [sym_index_expression] = STATE(11430),
    [sym_parametrized_type_expression] = STATE(11430),
    [sym_call_expression] = STATE(11430),
    [sym_broadcast_call_expression] = STATE(11430),
    [sym__closed_macrocall_expression] = STATE(11430),
    [sym_interpolation_expression] = STATE(11430),
    [sym_quote_expression] = STATE(11430),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(11172),
    [sym_boolean_literal] = STATE(11430),
    [sym__string] = STATE(11430),
    [sym_string_literal] = STATE(11430),
    [sym_command_literal] = STATE(11430),
    [sym_prefixed_string_literal] = STATE(11430),
    [sym_prefixed_command_literal] = STATE(11430),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(13950),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_DOLLAR] = ACTIONS(13952),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(13954),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(2926),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [9365] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_where] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [9366] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_where] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [9367] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_where] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [9368] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_where] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [9369] = {
    [sym__primary_expression] = STATE(11359),
    [sym__array] = STATE(11359),
    [sym_comprehension_expression] = STATE(11359),
    [sym_matrix_expression] = STATE(11359),
    [sym_vector_expression] = STATE(11359),
    [sym_parenthesized_expression] = STATE(11359),
    [sym_tuple_expression] = STATE(11359),
    [sym_curly_expression] = STATE(11359),
    [sym_adjoint_expression] = STATE(11359),
    [sym_field_expression] = STATE(11359),
    [sym_index_expression] = STATE(11359),
    [sym_parametrized_type_expression] = STATE(11359),
    [sym_call_expression] = STATE(11359),
    [sym_broadcast_call_expression] = STATE(11359),
    [sym__closed_macrocall_expression] = STATE(11359),
    [sym_interpolation_expression] = STATE(11359),
    [sym_quote_expression] = STATE(11359),
    [sym_macro_identifier] = STATE(17273),
    [sym_identifier] = STATE(10579),
    [sym_boolean_literal] = STATE(11359),
    [sym__string] = STATE(11359),
    [sym_string_literal] = STATE(11359),
    [sym_command_literal] = STATE(11359),
    [sym_prefixed_string_literal] = STATE(11359),
    [sym_prefixed_command_literal] = STATE(11359),
    [sym_operator] = STATE(18510),
    [sym__word_identifier] = ACTIONS(13284),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(13286),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(13288),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(13290),
    [anon_sym_RBRACK] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(13292),
    [anon_sym_RBRACE] = ACTIONS(11408),
    [anon_sym_DOLLAR] = ACTIONS(15210),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(13296),
    [anon_sym_true] = ACTIONS(13298),
    [anon_sym_false] = ACTIONS(13298),
    [sym_character_literal] = ACTIONS(13300),
    [sym__pair_operator] = ACTIONS(11581),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11581),
    [sym__pipe_left_operator] = ACTIONS(11581),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11581),
    [sym__bitshift_operator] = ACTIONS(11581),
    [sym__power_operator] = ACTIONS(11581),
    [sym__tilde_operator] = ACTIONS(2924),
    [sym__type_order_operator] = ACTIONS(11581),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13302),
    [sym__command_start] = ACTIONS(13304),
  },
  [9370] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(11976),
    [anon_sym_DOT] = ACTIONS(11976),
    [anon_sym_do] = ACTIONS(11976),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11978),
    [sym__immediate_bracket] = ACTIONS(11978),
    [sym__immediate_brace] = ACTIONS(11978),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [9371] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [9372] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_where] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [9373] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_SQUOTE] = ACTIONS(12040),
    [anon_sym_DOT] = ACTIONS(12040),
    [anon_sym_do] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12042),
    [sym__immediate_bracket] = ACTIONS(12042),
    [sym__immediate_brace] = ACTIONS(12042),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [9374] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(11984),
    [anon_sym_DOT] = ACTIONS(11984),
    [anon_sym_do] = ACTIONS(11984),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11986),
    [sym__immediate_bracket] = ACTIONS(11986),
    [sym__immediate_brace] = ACTIONS(11986),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [9375] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_where] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [9376] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_where] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [9377] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_where] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [9378] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_where] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [9379] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_where] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [9380] = {
    [sym__primary_expression] = STATE(11436),
    [sym__array] = STATE(11436),
    [sym_comprehension_expression] = STATE(11436),
    [sym_matrix_expression] = STATE(11436),
    [sym_vector_expression] = STATE(11436),
    [sym_parenthesized_expression] = STATE(11436),
    [sym_tuple_expression] = STATE(11436),
    [sym_curly_expression] = STATE(11436),
    [sym_adjoint_expression] = STATE(11436),
    [sym_field_expression] = STATE(11436),
    [sym_index_expression] = STATE(11436),
    [sym_parametrized_type_expression] = STATE(11436),
    [sym_call_expression] = STATE(11436),
    [sym_broadcast_call_expression] = STATE(11436),
    [sym__closed_macrocall_expression] = STATE(11436),
    [sym_interpolation_expression] = STATE(11436),
    [sym_quote_expression] = STATE(11436),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(11024),
    [sym_boolean_literal] = STATE(11436),
    [sym__string] = STATE(11436),
    [sym_string_literal] = STATE(11436),
    [sym_command_literal] = STATE(11436),
    [sym_prefixed_string_literal] = STATE(11436),
    [sym_prefixed_command_literal] = STATE(11436),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(14395),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_finally] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_DOLLAR] = ACTIONS(14397),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(14399),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(2926),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [9381] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_SQUOTE] = ACTIONS(12048),
    [anon_sym_DOT] = ACTIONS(12048),
    [anon_sym_do] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12050),
    [sym__immediate_bracket] = ACTIONS(12050),
    [sym__immediate_brace] = ACTIONS(12050),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [9382] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [9383] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_where] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [9384] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_where] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [9385] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_where] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [9386] = {
    [sym__word_identifier] = ACTIONS(11976),
    [anon_sym_COLON] = ACTIONS(11976),
    [anon_sym_begin] = ACTIONS(11976),
    [anon_sym_module] = ACTIONS(11976),
    [anon_sym_baremodule] = ACTIONS(11976),
    [anon_sym_end] = ACTIONS(11976),
    [anon_sym_abstract] = ACTIONS(11976),
    [anon_sym_primitive] = ACTIONS(11976),
    [anon_sym_mutable] = ACTIONS(11976),
    [anon_sym_struct] = ACTIONS(11976),
    [anon_sym_function] = ACTIONS(11976),
    [anon_sym_macro] = ACTIONS(11976),
    [anon_sym_where] = ACTIONS(11976),
    [anon_sym_quote] = ACTIONS(11976),
    [anon_sym_let] = ACTIONS(11976),
    [anon_sym_if] = ACTIONS(11976),
    [anon_sym_try] = ACTIONS(11976),
    [anon_sym_for] = ACTIONS(11976),
    [anon_sym_while] = ACTIONS(11976),
    [sym_break_statement] = ACTIONS(11976),
    [sym_continue_statement] = ACTIONS(11976),
    [anon_sym_return] = ACTIONS(11976),
    [anon_sym_const] = ACTIONS(11976),
    [anon_sym_global] = ACTIONS(11976),
    [anon_sym_local] = ACTIONS(11976),
    [anon_sym_LPAREN] = ACTIONS(11976),
    [anon_sym_export] = ACTIONS(11976),
    [anon_sym_import] = ACTIONS(11976),
    [anon_sym_using] = ACTIONS(11976),
    [anon_sym_LBRACK] = ACTIONS(11976),
    [anon_sym_LF] = ACTIONS(11978),
    [anon_sym_LBRACE] = ACTIONS(11976),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(11976),
    [anon_sym_COLON_COLON] = ACTIONS(11976),
    [anon_sym_AT] = ACTIONS(11976),
    [anon_sym_true] = ACTIONS(11976),
    [anon_sym_false] = ACTIONS(11976),
    [aux_sym_integer_literal_token1] = ACTIONS(11976),
    [aux_sym_integer_literal_token2] = ACTIONS(11976),
    [aux_sym_integer_literal_token3] = ACTIONS(11976),
    [aux_sym_integer_literal_token4] = ACTIONS(11976),
    [aux_sym_float_literal_token1] = ACTIONS(11976),
    [aux_sym_float_literal_token3] = ACTIONS(11976),
    [aux_sym_float_literal_token4] = ACTIONS(11976),
    [sym_character_literal] = ACTIONS(11976),
    [sym__pair_operator] = ACTIONS(11976),
    [sym__arrow_operator] = ACTIONS(11976),
    [sym__comparison_operator] = ACTIONS(11976),
    [sym__pipe_right_operator] = ACTIONS(11976),
    [sym__pipe_left_operator] = ACTIONS(11976),
    [sym__ellipsis_operator] = ACTIONS(11976),
    [sym__plus_operator] = ACTIONS(11976),
    [sym__times_operator] = ACTIONS(11976),
    [sym__rational_operator] = ACTIONS(11976),
    [sym__bitshift_operator] = ACTIONS(11976),
    [sym__power_operator] = ACTIONS(11976),
    [sym__tilde_operator] = ACTIONS(11976),
    [sym__type_order_operator] = ACTIONS(11976),
    [sym__unary_operator] = ACTIONS(11976),
    [sym__unary_plus_operator] = ACTIONS(11976),
    [aux_sym__terminator_token1] = ACTIONS(11976),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(11978),
    [sym__command_start] = ACTIONS(11978),
  },
  [9387] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_where] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [9388] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [9389] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_where] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [9390] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_SQUOTE] = ACTIONS(11996),
    [anon_sym_DOT] = ACTIONS(11996),
    [anon_sym_do] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11998),
    [sym__immediate_bracket] = ACTIONS(11998),
    [sym__immediate_brace] = ACTIONS(11998),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [9391] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [9392] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_where] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [9393] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_where] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [9394] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_where] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [9395] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_where] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [9396] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_where] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [9397] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_where] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [9398] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_where] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [9399] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_where] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [9400] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_where] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [9401] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_where] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [9402] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12020),
    [anon_sym_DOT] = ACTIONS(12020),
    [anon_sym_do] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12022),
    [sym__immediate_bracket] = ACTIONS(12022),
    [sym__immediate_brace] = ACTIONS(12022),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [9403] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_SQUOTE] = ACTIONS(12024),
    [anon_sym_DOT] = ACTIONS(12024),
    [anon_sym_do] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12026),
    [sym__immediate_bracket] = ACTIONS(12026),
    [sym__immediate_brace] = ACTIONS(12026),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [9404] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [9405] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_SQUOTE] = ACTIONS(12028),
    [anon_sym_DOT] = ACTIONS(12028),
    [anon_sym_do] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12030),
    [sym__immediate_bracket] = ACTIONS(12030),
    [sym__immediate_brace] = ACTIONS(12030),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [9406] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_where] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [9407] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_where] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [9408] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_where] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [9409] = {
    [sym__primary_expression] = STATE(11435),
    [sym__array] = STATE(11435),
    [sym_comprehension_expression] = STATE(11435),
    [sym_matrix_expression] = STATE(11435),
    [sym_vector_expression] = STATE(11435),
    [sym_parenthesized_expression] = STATE(11435),
    [sym_tuple_expression] = STATE(11435),
    [sym_curly_expression] = STATE(11435),
    [sym_adjoint_expression] = STATE(11435),
    [sym_field_expression] = STATE(11435),
    [sym_index_expression] = STATE(11435),
    [sym_parametrized_type_expression] = STATE(11435),
    [sym_call_expression] = STATE(11435),
    [sym_broadcast_call_expression] = STATE(11435),
    [sym__closed_macrocall_expression] = STATE(11435),
    [sym_interpolation_expression] = STATE(11435),
    [sym_quote_expression] = STATE(11435),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(11008),
    [sym_boolean_literal] = STATE(11435),
    [sym__string] = STATE(11435),
    [sym_string_literal] = STATE(11435),
    [sym_command_literal] = STATE(11435),
    [sym_prefixed_string_literal] = STATE(11435),
    [sym_prefixed_command_literal] = STATE(11435),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(13868),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_catch] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_DOLLAR] = ACTIONS(13870),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(13872),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(2926),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [9410] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_where] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [9411] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_SQUOTE] = ACTIONS(12032),
    [anon_sym_DOT] = ACTIONS(12032),
    [anon_sym_do] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12034),
    [sym__immediate_bracket] = ACTIONS(12034),
    [sym__immediate_brace] = ACTIONS(12034),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [9412] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_where] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [9413] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_where] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [9414] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_where] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [9415] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_where] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [9416] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_where] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [9417] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [9418] = {
    [sym__word_identifier] = ACTIONS(11984),
    [anon_sym_COLON] = ACTIONS(11984),
    [anon_sym_begin] = ACTIONS(11984),
    [anon_sym_module] = ACTIONS(11984),
    [anon_sym_baremodule] = ACTIONS(11984),
    [anon_sym_end] = ACTIONS(11984),
    [anon_sym_abstract] = ACTIONS(11984),
    [anon_sym_primitive] = ACTIONS(11984),
    [anon_sym_mutable] = ACTIONS(11984),
    [anon_sym_struct] = ACTIONS(11984),
    [anon_sym_function] = ACTIONS(11984),
    [anon_sym_macro] = ACTIONS(11984),
    [anon_sym_where] = ACTIONS(11984),
    [anon_sym_quote] = ACTIONS(11984),
    [anon_sym_let] = ACTIONS(11984),
    [anon_sym_if] = ACTIONS(11984),
    [anon_sym_try] = ACTIONS(11984),
    [anon_sym_for] = ACTIONS(11984),
    [anon_sym_while] = ACTIONS(11984),
    [sym_break_statement] = ACTIONS(11984),
    [sym_continue_statement] = ACTIONS(11984),
    [anon_sym_return] = ACTIONS(11984),
    [anon_sym_const] = ACTIONS(11984),
    [anon_sym_global] = ACTIONS(11984),
    [anon_sym_local] = ACTIONS(11984),
    [anon_sym_LPAREN] = ACTIONS(11984),
    [anon_sym_export] = ACTIONS(11984),
    [anon_sym_import] = ACTIONS(11984),
    [anon_sym_using] = ACTIONS(11984),
    [anon_sym_LBRACK] = ACTIONS(11984),
    [anon_sym_LF] = ACTIONS(11986),
    [anon_sym_LBRACE] = ACTIONS(11984),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(11984),
    [anon_sym_COLON_COLON] = ACTIONS(11984),
    [anon_sym_AT] = ACTIONS(11984),
    [anon_sym_true] = ACTIONS(11984),
    [anon_sym_false] = ACTIONS(11984),
    [aux_sym_integer_literal_token1] = ACTIONS(11984),
    [aux_sym_integer_literal_token2] = ACTIONS(11984),
    [aux_sym_integer_literal_token3] = ACTIONS(11984),
    [aux_sym_integer_literal_token4] = ACTIONS(11984),
    [aux_sym_float_literal_token1] = ACTIONS(11984),
    [aux_sym_float_literal_token3] = ACTIONS(11984),
    [aux_sym_float_literal_token4] = ACTIONS(11984),
    [sym_character_literal] = ACTIONS(11984),
    [sym__pair_operator] = ACTIONS(11984),
    [sym__arrow_operator] = ACTIONS(11984),
    [sym__comparison_operator] = ACTIONS(11984),
    [sym__pipe_right_operator] = ACTIONS(11984),
    [sym__pipe_left_operator] = ACTIONS(11984),
    [sym__ellipsis_operator] = ACTIONS(11984),
    [sym__plus_operator] = ACTIONS(11984),
    [sym__times_operator] = ACTIONS(11984),
    [sym__rational_operator] = ACTIONS(11984),
    [sym__bitshift_operator] = ACTIONS(11984),
    [sym__power_operator] = ACTIONS(11984),
    [sym__tilde_operator] = ACTIONS(11984),
    [sym__type_order_operator] = ACTIONS(11984),
    [sym__unary_operator] = ACTIONS(11984),
    [sym__unary_plus_operator] = ACTIONS(11984),
    [aux_sym__terminator_token1] = ACTIONS(11984),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(11986),
    [sym__command_start] = ACTIONS(11986),
  },
  [9419] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_where] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [9420] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_SQUOTE] = ACTIONS(12240),
    [anon_sym_DOT] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12238),
    [sym__immediate_bracket] = ACTIONS(12238),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [9421] = {
    [sym__word_identifier] = ACTIONS(11916),
    [anon_sym_COLON] = ACTIONS(11916),
    [anon_sym_begin] = ACTIONS(11916),
    [anon_sym_module] = ACTIONS(11916),
    [anon_sym_baremodule] = ACTIONS(11916),
    [anon_sym_end] = ACTIONS(11916),
    [anon_sym_abstract] = ACTIONS(11916),
    [anon_sym_primitive] = ACTIONS(11916),
    [anon_sym_mutable] = ACTIONS(11916),
    [anon_sym_struct] = ACTIONS(11916),
    [anon_sym_function] = ACTIONS(11916),
    [anon_sym_macro] = ACTIONS(11916),
    [anon_sym_quote] = ACTIONS(11916),
    [anon_sym_let] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11916),
    [anon_sym_try] = ACTIONS(11916),
    [anon_sym_for] = ACTIONS(11916),
    [anon_sym_while] = ACTIONS(11916),
    [sym_break_statement] = ACTIONS(11916),
    [sym_continue_statement] = ACTIONS(11916),
    [anon_sym_return] = ACTIONS(11916),
    [anon_sym_const] = ACTIONS(11916),
    [anon_sym_global] = ACTIONS(11916),
    [anon_sym_local] = ACTIONS(11916),
    [anon_sym_LPAREN] = ACTIONS(11916),
    [anon_sym_export] = ACTIONS(11916),
    [anon_sym_import] = ACTIONS(11916),
    [anon_sym_using] = ACTIONS(11916),
    [anon_sym_LBRACK] = ACTIONS(11916),
    [anon_sym_LF] = ACTIONS(11914),
    [anon_sym_LBRACE] = ACTIONS(11916),
    [anon_sym_SQUOTE] = ACTIONS(11916),
    [anon_sym_DOT] = ACTIONS(11916),
    [anon_sym_DOLLAR] = ACTIONS(11916),
    [anon_sym_COLON_COLON] = ACTIONS(11916),
    [anon_sym_AT] = ACTIONS(11916),
    [anon_sym_true] = ACTIONS(11916),
    [anon_sym_false] = ACTIONS(11916),
    [aux_sym_integer_literal_token1] = ACTIONS(11916),
    [aux_sym_integer_literal_token2] = ACTIONS(11916),
    [aux_sym_integer_literal_token3] = ACTIONS(11916),
    [aux_sym_integer_literal_token4] = ACTIONS(11916),
    [aux_sym_float_literal_token1] = ACTIONS(11916),
    [aux_sym_float_literal_token3] = ACTIONS(11916),
    [aux_sym_float_literal_token4] = ACTIONS(11916),
    [sym_character_literal] = ACTIONS(11916),
    [sym__pair_operator] = ACTIONS(11916),
    [sym__arrow_operator] = ACTIONS(11916),
    [sym__comparison_operator] = ACTIONS(11916),
    [sym__pipe_right_operator] = ACTIONS(11916),
    [sym__pipe_left_operator] = ACTIONS(11916),
    [sym__ellipsis_operator] = ACTIONS(11916),
    [sym__plus_operator] = ACTIONS(11916),
    [sym__times_operator] = ACTIONS(11916),
    [sym__rational_operator] = ACTIONS(11916),
    [sym__bitshift_operator] = ACTIONS(11916),
    [sym__power_operator] = ACTIONS(11916),
    [sym__tilde_operator] = ACTIONS(11916),
    [sym__type_order_operator] = ACTIONS(11916),
    [sym__unary_operator] = ACTIONS(11916),
    [sym__unary_plus_operator] = ACTIONS(11916),
    [aux_sym__terminator_token1] = ACTIONS(11916),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11914),
    [sym__immediate_bracket] = ACTIONS(11914),
    [sym__immediate_brace] = ACTIONS(11914),
    [sym__string_start] = ACTIONS(11914),
    [sym__command_start] = ACTIONS(11914),
  },
  [9422] = {
    [sym__word_identifier] = ACTIONS(12136),
    [anon_sym_COLON] = ACTIONS(12136),
    [anon_sym_begin] = ACTIONS(12136),
    [anon_sym_module] = ACTIONS(12136),
    [anon_sym_baremodule] = ACTIONS(12136),
    [anon_sym_end] = ACTIONS(12136),
    [anon_sym_abstract] = ACTIONS(12136),
    [anon_sym_primitive] = ACTIONS(12136),
    [anon_sym_mutable] = ACTIONS(12136),
    [anon_sym_struct] = ACTIONS(12136),
    [anon_sym_function] = ACTIONS(12136),
    [anon_sym_macro] = ACTIONS(12136),
    [anon_sym_quote] = ACTIONS(12136),
    [anon_sym_let] = ACTIONS(12136),
    [anon_sym_if] = ACTIONS(12136),
    [anon_sym_try] = ACTIONS(12136),
    [anon_sym_for] = ACTIONS(12136),
    [anon_sym_while] = ACTIONS(12136),
    [sym_break_statement] = ACTIONS(12136),
    [sym_continue_statement] = ACTIONS(12136),
    [anon_sym_return] = ACTIONS(12136),
    [anon_sym_const] = ACTIONS(12136),
    [anon_sym_global] = ACTIONS(12136),
    [anon_sym_local] = ACTIONS(12136),
    [anon_sym_LPAREN] = ACTIONS(12136),
    [anon_sym_export] = ACTIONS(12136),
    [anon_sym_import] = ACTIONS(12136),
    [anon_sym_using] = ACTIONS(12136),
    [anon_sym_LBRACK] = ACTIONS(12136),
    [anon_sym_LF] = ACTIONS(12138),
    [anon_sym_LBRACE] = ACTIONS(12136),
    [anon_sym_SQUOTE] = ACTIONS(12136),
    [anon_sym_DOT] = ACTIONS(12136),
    [anon_sym_DOLLAR] = ACTIONS(12136),
    [anon_sym_COLON_COLON] = ACTIONS(12136),
    [anon_sym_AT] = ACTIONS(12136),
    [anon_sym_true] = ACTIONS(12136),
    [anon_sym_false] = ACTIONS(12136),
    [aux_sym_integer_literal_token1] = ACTIONS(12136),
    [aux_sym_integer_literal_token2] = ACTIONS(12136),
    [aux_sym_integer_literal_token3] = ACTIONS(12136),
    [aux_sym_integer_literal_token4] = ACTIONS(12136),
    [aux_sym_float_literal_token1] = ACTIONS(12136),
    [aux_sym_float_literal_token3] = ACTIONS(12136),
    [aux_sym_float_literal_token4] = ACTIONS(12136),
    [sym_character_literal] = ACTIONS(12136),
    [sym__pair_operator] = ACTIONS(12136),
    [sym__arrow_operator] = ACTIONS(12136),
    [sym__comparison_operator] = ACTIONS(12136),
    [sym__pipe_right_operator] = ACTIONS(12136),
    [sym__pipe_left_operator] = ACTIONS(12136),
    [sym__ellipsis_operator] = ACTIONS(12136),
    [sym__plus_operator] = ACTIONS(12136),
    [sym__times_operator] = ACTIONS(12136),
    [sym__rational_operator] = ACTIONS(12136),
    [sym__bitshift_operator] = ACTIONS(12136),
    [sym__power_operator] = ACTIONS(12136),
    [sym__tilde_operator] = ACTIONS(12136),
    [sym__type_order_operator] = ACTIONS(12136),
    [sym__unary_operator] = ACTIONS(12136),
    [sym__unary_plus_operator] = ACTIONS(12136),
    [aux_sym__terminator_token1] = ACTIONS(12136),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12138),
    [sym__immediate_bracket] = ACTIONS(12138),
    [sym__immediate_brace] = ACTIONS(12138),
    [sym__string_start] = ACTIONS(12138),
    [sym__command_start] = ACTIONS(12138),
  },
  [9423] = {
    [sym__word_identifier] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2186),
    [anon_sym_begin] = ACTIONS(2186),
    [anon_sym_module] = ACTIONS(2186),
    [anon_sym_baremodule] = ACTIONS(2186),
    [anon_sym_end] = ACTIONS(2186),
    [anon_sym_abstract] = ACTIONS(2186),
    [anon_sym_primitive] = ACTIONS(2186),
    [anon_sym_mutable] = ACTIONS(2186),
    [anon_sym_struct] = ACTIONS(2186),
    [anon_sym_function] = ACTIONS(2186),
    [anon_sym_macro] = ACTIONS(2186),
    [anon_sym_quote] = ACTIONS(2186),
    [anon_sym_let] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(2186),
    [anon_sym_try] = ACTIONS(2186),
    [anon_sym_for] = ACTIONS(2186),
    [anon_sym_while] = ACTIONS(2186),
    [sym_break_statement] = ACTIONS(2186),
    [sym_continue_statement] = ACTIONS(2186),
    [anon_sym_return] = ACTIONS(2186),
    [anon_sym_const] = ACTIONS(2186),
    [anon_sym_global] = ACTIONS(2186),
    [anon_sym_local] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_export] = ACTIONS(2186),
    [anon_sym_import] = ACTIONS(2186),
    [anon_sym_using] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LF] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [anon_sym_DOT] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2186),
    [anon_sym_COLON_COLON] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_true] = ACTIONS(2186),
    [anon_sym_false] = ACTIONS(2186),
    [aux_sym_integer_literal_token1] = ACTIONS(2186),
    [aux_sym_integer_literal_token2] = ACTIONS(2186),
    [aux_sym_integer_literal_token3] = ACTIONS(2186),
    [aux_sym_integer_literal_token4] = ACTIONS(2186),
    [aux_sym_float_literal_token1] = ACTIONS(2186),
    [aux_sym_float_literal_token3] = ACTIONS(2186),
    [aux_sym_float_literal_token4] = ACTIONS(2186),
    [sym_character_literal] = ACTIONS(2186),
    [sym__pair_operator] = ACTIONS(2186),
    [sym__arrow_operator] = ACTIONS(2186),
    [sym__comparison_operator] = ACTIONS(2186),
    [sym__pipe_right_operator] = ACTIONS(2186),
    [sym__pipe_left_operator] = ACTIONS(2186),
    [sym__ellipsis_operator] = ACTIONS(2186),
    [sym__plus_operator] = ACTIONS(2186),
    [sym__times_operator] = ACTIONS(2186),
    [sym__rational_operator] = ACTIONS(2186),
    [sym__bitshift_operator] = ACTIONS(2186),
    [sym__power_operator] = ACTIONS(2186),
    [sym__tilde_operator] = ACTIONS(2186),
    [sym__type_order_operator] = ACTIONS(2186),
    [sym__unary_operator] = ACTIONS(2186),
    [sym__unary_plus_operator] = ACTIONS(2186),
    [aux_sym__terminator_token1] = ACTIONS(2186),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2188),
    [sym__immediate_bracket] = ACTIONS(2188),
    [sym__immediate_brace] = ACTIONS(2188),
    [sym__string_start] = ACTIONS(2188),
    [sym__command_start] = ACTIONS(2188),
  },
  [9424] = {
    [sym__word_identifier] = ACTIONS(12214),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_begin] = ACTIONS(12214),
    [anon_sym_module] = ACTIONS(12214),
    [anon_sym_baremodule] = ACTIONS(12214),
    [anon_sym_end] = ACTIONS(12214),
    [anon_sym_abstract] = ACTIONS(12214),
    [anon_sym_primitive] = ACTIONS(12214),
    [anon_sym_mutable] = ACTIONS(12214),
    [anon_sym_struct] = ACTIONS(12214),
    [anon_sym_function] = ACTIONS(12214),
    [anon_sym_macro] = ACTIONS(12214),
    [anon_sym_quote] = ACTIONS(12214),
    [anon_sym_let] = ACTIONS(12214),
    [anon_sym_if] = ACTIONS(12214),
    [anon_sym_try] = ACTIONS(12214),
    [anon_sym_for] = ACTIONS(12214),
    [anon_sym_while] = ACTIONS(12214),
    [sym_break_statement] = ACTIONS(12214),
    [sym_continue_statement] = ACTIONS(12214),
    [anon_sym_return] = ACTIONS(12214),
    [anon_sym_const] = ACTIONS(12214),
    [anon_sym_global] = ACTIONS(12214),
    [anon_sym_local] = ACTIONS(12214),
    [anon_sym_LPAREN] = ACTIONS(12214),
    [anon_sym_export] = ACTIONS(12214),
    [anon_sym_import] = ACTIONS(12214),
    [anon_sym_using] = ACTIONS(12214),
    [anon_sym_LBRACK] = ACTIONS(12214),
    [anon_sym_LF] = ACTIONS(12212),
    [anon_sym_LBRACE] = ACTIONS(12214),
    [anon_sym_SQUOTE] = ACTIONS(12214),
    [anon_sym_DOT] = ACTIONS(12214),
    [anon_sym_DOLLAR] = ACTIONS(12214),
    [anon_sym_COLON_COLON] = ACTIONS(12214),
    [anon_sym_AT] = ACTIONS(12214),
    [anon_sym_true] = ACTIONS(12214),
    [anon_sym_false] = ACTIONS(12214),
    [aux_sym_integer_literal_token1] = ACTIONS(12214),
    [aux_sym_integer_literal_token2] = ACTIONS(12214),
    [aux_sym_integer_literal_token3] = ACTIONS(12214),
    [aux_sym_integer_literal_token4] = ACTIONS(12214),
    [aux_sym_float_literal_token1] = ACTIONS(12214),
    [aux_sym_float_literal_token3] = ACTIONS(12214),
    [aux_sym_float_literal_token4] = ACTIONS(12214),
    [sym_character_literal] = ACTIONS(12214),
    [sym__pair_operator] = ACTIONS(12214),
    [sym__arrow_operator] = ACTIONS(12214),
    [sym__comparison_operator] = ACTIONS(12214),
    [sym__pipe_right_operator] = ACTIONS(12214),
    [sym__pipe_left_operator] = ACTIONS(12214),
    [sym__ellipsis_operator] = ACTIONS(12214),
    [sym__plus_operator] = ACTIONS(12214),
    [sym__times_operator] = ACTIONS(12214),
    [sym__rational_operator] = ACTIONS(12214),
    [sym__bitshift_operator] = ACTIONS(12214),
    [sym__power_operator] = ACTIONS(12214),
    [sym__tilde_operator] = ACTIONS(12214),
    [sym__type_order_operator] = ACTIONS(12214),
    [sym__unary_operator] = ACTIONS(12214),
    [sym__unary_plus_operator] = ACTIONS(12214),
    [aux_sym__terminator_token1] = ACTIONS(12214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12212),
    [sym__immediate_bracket] = ACTIONS(12212),
    [sym__immediate_brace] = ACTIONS(12212),
    [sym__string_start] = ACTIONS(12212),
    [sym__command_start] = ACTIONS(12212),
  },
  [9425] = {
    [sym__word_identifier] = ACTIONS(12174),
    [anon_sym_COLON] = ACTIONS(12174),
    [anon_sym_begin] = ACTIONS(12174),
    [anon_sym_module] = ACTIONS(12174),
    [anon_sym_baremodule] = ACTIONS(12174),
    [anon_sym_end] = ACTIONS(12174),
    [anon_sym_abstract] = ACTIONS(12174),
    [anon_sym_primitive] = ACTIONS(12174),
    [anon_sym_mutable] = ACTIONS(12174),
    [anon_sym_struct] = ACTIONS(12174),
    [anon_sym_function] = ACTIONS(12174),
    [anon_sym_macro] = ACTIONS(12174),
    [anon_sym_quote] = ACTIONS(12174),
    [anon_sym_let] = ACTIONS(12174),
    [anon_sym_if] = ACTIONS(12174),
    [anon_sym_try] = ACTIONS(12174),
    [anon_sym_for] = ACTIONS(12174),
    [anon_sym_while] = ACTIONS(12174),
    [sym_break_statement] = ACTIONS(12174),
    [sym_continue_statement] = ACTIONS(12174),
    [anon_sym_return] = ACTIONS(12174),
    [anon_sym_const] = ACTIONS(12174),
    [anon_sym_global] = ACTIONS(12174),
    [anon_sym_local] = ACTIONS(12174),
    [anon_sym_LPAREN] = ACTIONS(12174),
    [anon_sym_export] = ACTIONS(12174),
    [anon_sym_import] = ACTIONS(12174),
    [anon_sym_using] = ACTIONS(12174),
    [anon_sym_LBRACK] = ACTIONS(12174),
    [anon_sym_LF] = ACTIONS(12172),
    [anon_sym_LBRACE] = ACTIONS(12174),
    [anon_sym_SQUOTE] = ACTIONS(12174),
    [anon_sym_DOT] = ACTIONS(12174),
    [anon_sym_DOLLAR] = ACTIONS(12174),
    [anon_sym_COLON_COLON] = ACTIONS(12174),
    [anon_sym_AT] = ACTIONS(12174),
    [anon_sym_true] = ACTIONS(12174),
    [anon_sym_false] = ACTIONS(12174),
    [aux_sym_integer_literal_token1] = ACTIONS(12174),
    [aux_sym_integer_literal_token2] = ACTIONS(12174),
    [aux_sym_integer_literal_token3] = ACTIONS(12174),
    [aux_sym_integer_literal_token4] = ACTIONS(12174),
    [aux_sym_float_literal_token1] = ACTIONS(12174),
    [aux_sym_float_literal_token3] = ACTIONS(12174),
    [aux_sym_float_literal_token4] = ACTIONS(12174),
    [sym_character_literal] = ACTIONS(12174),
    [sym__pair_operator] = ACTIONS(12174),
    [sym__arrow_operator] = ACTIONS(12174),
    [sym__comparison_operator] = ACTIONS(12174),
    [sym__pipe_right_operator] = ACTIONS(12174),
    [sym__pipe_left_operator] = ACTIONS(12174),
    [sym__ellipsis_operator] = ACTIONS(12174),
    [sym__plus_operator] = ACTIONS(12174),
    [sym__times_operator] = ACTIONS(12174),
    [sym__rational_operator] = ACTIONS(12174),
    [sym__bitshift_operator] = ACTIONS(12174),
    [sym__power_operator] = ACTIONS(12174),
    [sym__tilde_operator] = ACTIONS(12174),
    [sym__type_order_operator] = ACTIONS(12174),
    [sym__unary_operator] = ACTIONS(12174),
    [sym__unary_plus_operator] = ACTIONS(12174),
    [aux_sym__terminator_token1] = ACTIONS(12174),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12172),
    [sym__immediate_bracket] = ACTIONS(12172),
    [sym__immediate_brace] = ACTIONS(12172),
    [sym__string_start] = ACTIONS(12172),
    [sym__command_start] = ACTIONS(12172),
  },
  [9426] = {
    [sym__word_identifier] = ACTIONS(12218),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_begin] = ACTIONS(12218),
    [anon_sym_module] = ACTIONS(12218),
    [anon_sym_baremodule] = ACTIONS(12218),
    [anon_sym_end] = ACTIONS(12218),
    [anon_sym_abstract] = ACTIONS(12218),
    [anon_sym_primitive] = ACTIONS(12218),
    [anon_sym_mutable] = ACTIONS(12218),
    [anon_sym_struct] = ACTIONS(12218),
    [anon_sym_function] = ACTIONS(12218),
    [anon_sym_macro] = ACTIONS(12218),
    [anon_sym_quote] = ACTIONS(12218),
    [anon_sym_let] = ACTIONS(12218),
    [anon_sym_if] = ACTIONS(12218),
    [anon_sym_try] = ACTIONS(12218),
    [anon_sym_for] = ACTIONS(12218),
    [anon_sym_while] = ACTIONS(12218),
    [sym_break_statement] = ACTIONS(12218),
    [sym_continue_statement] = ACTIONS(12218),
    [anon_sym_return] = ACTIONS(12218),
    [anon_sym_const] = ACTIONS(12218),
    [anon_sym_global] = ACTIONS(12218),
    [anon_sym_local] = ACTIONS(12218),
    [anon_sym_LPAREN] = ACTIONS(12218),
    [anon_sym_export] = ACTIONS(12218),
    [anon_sym_import] = ACTIONS(12218),
    [anon_sym_using] = ACTIONS(12218),
    [anon_sym_LBRACK] = ACTIONS(12218),
    [anon_sym_LF] = ACTIONS(12216),
    [anon_sym_LBRACE] = ACTIONS(12218),
    [anon_sym_SQUOTE] = ACTIONS(12218),
    [anon_sym_DOT] = ACTIONS(12218),
    [anon_sym_DOLLAR] = ACTIONS(12218),
    [anon_sym_COLON_COLON] = ACTIONS(12218),
    [anon_sym_AT] = ACTIONS(12218),
    [anon_sym_true] = ACTIONS(12218),
    [anon_sym_false] = ACTIONS(12218),
    [aux_sym_integer_literal_token1] = ACTIONS(12218),
    [aux_sym_integer_literal_token2] = ACTIONS(12218),
    [aux_sym_integer_literal_token3] = ACTIONS(12218),
    [aux_sym_integer_literal_token4] = ACTIONS(12218),
    [aux_sym_float_literal_token1] = ACTIONS(12218),
    [aux_sym_float_literal_token3] = ACTIONS(12218),
    [aux_sym_float_literal_token4] = ACTIONS(12218),
    [sym_character_literal] = ACTIONS(12218),
    [sym__pair_operator] = ACTIONS(12218),
    [sym__arrow_operator] = ACTIONS(12218),
    [sym__comparison_operator] = ACTIONS(12218),
    [sym__pipe_right_operator] = ACTIONS(12218),
    [sym__pipe_left_operator] = ACTIONS(12218),
    [sym__ellipsis_operator] = ACTIONS(12218),
    [sym__plus_operator] = ACTIONS(12218),
    [sym__times_operator] = ACTIONS(12218),
    [sym__rational_operator] = ACTIONS(12218),
    [sym__bitshift_operator] = ACTIONS(12218),
    [sym__power_operator] = ACTIONS(12218),
    [sym__tilde_operator] = ACTIONS(12218),
    [sym__type_order_operator] = ACTIONS(12218),
    [sym__unary_operator] = ACTIONS(12218),
    [sym__unary_plus_operator] = ACTIONS(12218),
    [aux_sym__terminator_token1] = ACTIONS(12218),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12216),
    [sym__immediate_bracket] = ACTIONS(12216),
    [sym__immediate_brace] = ACTIONS(12216),
    [sym__string_start] = ACTIONS(12216),
    [sym__command_start] = ACTIONS(12216),
  },
  [9427] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_SQUOTE] = ACTIONS(12158),
    [anon_sym_DOT] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12156),
    [sym__immediate_bracket] = ACTIONS(12156),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [9428] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_SQUOTE] = ACTIONS(12236),
    [anon_sym_DOT] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12234),
    [sym__immediate_bracket] = ACTIONS(12234),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [9429] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_SQUOTE] = ACTIONS(12178),
    [anon_sym_DOT] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12176),
    [sym__immediate_bracket] = ACTIONS(12176),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [9430] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_SQUOTE] = ACTIONS(12292),
    [anon_sym_DOT] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12290),
    [sym__immediate_bracket] = ACTIONS(12290),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [9431] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_SQUOTE] = ACTIONS(12244),
    [anon_sym_DOT] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12242),
    [sym__immediate_bracket] = ACTIONS(12242),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [9432] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_SQUOTE] = ACTIONS(12388),
    [anon_sym_DOT] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12390),
    [sym__immediate_bracket] = ACTIONS(12390),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [9433] = {
    [sym__word_identifier] = ACTIONS(11932),
    [anon_sym_COLON] = ACTIONS(11932),
    [anon_sym_begin] = ACTIONS(11932),
    [anon_sym_module] = ACTIONS(11932),
    [anon_sym_baremodule] = ACTIONS(11932),
    [anon_sym_end] = ACTIONS(11932),
    [anon_sym_abstract] = ACTIONS(11932),
    [anon_sym_primitive] = ACTIONS(11932),
    [anon_sym_mutable] = ACTIONS(11932),
    [anon_sym_struct] = ACTIONS(11932),
    [anon_sym_function] = ACTIONS(11932),
    [anon_sym_macro] = ACTIONS(11932),
    [anon_sym_quote] = ACTIONS(11932),
    [anon_sym_let] = ACTIONS(11932),
    [anon_sym_if] = ACTIONS(11932),
    [anon_sym_try] = ACTIONS(11932),
    [anon_sym_for] = ACTIONS(11932),
    [anon_sym_while] = ACTIONS(11932),
    [sym_break_statement] = ACTIONS(11932),
    [sym_continue_statement] = ACTIONS(11932),
    [anon_sym_return] = ACTIONS(11932),
    [anon_sym_const] = ACTIONS(11932),
    [anon_sym_global] = ACTIONS(11932),
    [anon_sym_local] = ACTIONS(11932),
    [anon_sym_LPAREN] = ACTIONS(11932),
    [anon_sym_export] = ACTIONS(11932),
    [anon_sym_import] = ACTIONS(11932),
    [anon_sym_using] = ACTIONS(11932),
    [anon_sym_LBRACK] = ACTIONS(11932),
    [anon_sym_LF] = ACTIONS(11934),
    [anon_sym_LBRACE] = ACTIONS(11932),
    [anon_sym_SQUOTE] = ACTIONS(11932),
    [anon_sym_DOT] = ACTIONS(11932),
    [anon_sym_DOLLAR] = ACTIONS(11932),
    [anon_sym_COLON_COLON] = ACTIONS(11932),
    [anon_sym_AT] = ACTIONS(11932),
    [anon_sym_true] = ACTIONS(11932),
    [anon_sym_false] = ACTIONS(11932),
    [aux_sym_integer_literal_token1] = ACTIONS(11932),
    [aux_sym_integer_literal_token2] = ACTIONS(11932),
    [aux_sym_integer_literal_token3] = ACTIONS(11932),
    [aux_sym_integer_literal_token4] = ACTIONS(11932),
    [aux_sym_float_literal_token1] = ACTIONS(11932),
    [aux_sym_float_literal_token3] = ACTIONS(11932),
    [aux_sym_float_literal_token4] = ACTIONS(11932),
    [sym_character_literal] = ACTIONS(11932),
    [sym__pair_operator] = ACTIONS(11932),
    [sym__arrow_operator] = ACTIONS(11932),
    [sym__comparison_operator] = ACTIONS(11932),
    [sym__pipe_right_operator] = ACTIONS(11932),
    [sym__pipe_left_operator] = ACTIONS(11932),
    [sym__ellipsis_operator] = ACTIONS(11932),
    [sym__plus_operator] = ACTIONS(11932),
    [sym__times_operator] = ACTIONS(11932),
    [sym__rational_operator] = ACTIONS(11932),
    [sym__bitshift_operator] = ACTIONS(11932),
    [sym__power_operator] = ACTIONS(11932),
    [sym__tilde_operator] = ACTIONS(11932),
    [sym__type_order_operator] = ACTIONS(11932),
    [sym__unary_operator] = ACTIONS(11932),
    [sym__unary_plus_operator] = ACTIONS(11932),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11934),
    [sym__immediate_bracket] = ACTIONS(11934),
    [sym__immediate_brace] = ACTIONS(11934),
    [sym__string_start] = ACTIONS(11934),
    [sym__command_start] = ACTIONS(11934),
  },
  [9434] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_SQUOTE] = ACTIONS(12170),
    [anon_sym_DOT] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12168),
    [sym__immediate_bracket] = ACTIONS(12168),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [9435] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_SQUOTE] = ACTIONS(12162),
    [anon_sym_DOT] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12160),
    [sym__immediate_bracket] = ACTIONS(12160),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [9436] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_SQUOTE] = ACTIONS(12210),
    [anon_sym_DOT] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12208),
    [sym__immediate_bracket] = ACTIONS(12208),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [9437] = {
    [sym__primary_expression] = STATE(11519),
    [sym__array] = STATE(11519),
    [sym_comprehension_expression] = STATE(11519),
    [sym_matrix_expression] = STATE(11519),
    [sym_vector_expression] = STATE(11519),
    [sym_parenthesized_expression] = STATE(11519),
    [sym_tuple_expression] = STATE(11519),
    [sym_curly_expression] = STATE(11519),
    [sym_adjoint_expression] = STATE(11519),
    [sym_field_expression] = STATE(11519),
    [sym_index_expression] = STATE(11519),
    [sym_parametrized_type_expression] = STATE(11519),
    [sym_call_expression] = STATE(11519),
    [sym_broadcast_call_expression] = STATE(11519),
    [sym__closed_macrocall_expression] = STATE(11519),
    [sym_interpolation_expression] = STATE(11519),
    [sym_quote_expression] = STATE(11519),
    [sym_macro_identifier] = STATE(17273),
    [sym_identifier] = STATE(11204),
    [sym_boolean_literal] = STATE(11519),
    [sym__string] = STATE(11519),
    [sym_string_literal] = STATE(11519),
    [sym_command_literal] = STATE(11519),
    [sym_prefixed_string_literal] = STATE(11519),
    [sym_prefixed_command_literal] = STATE(11519),
    [sym_operator] = STATE(18510),
    [sym__word_identifier] = ACTIONS(13284),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(14578),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_for] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(13288),
    [anon_sym_RPAREN] = ACTIONS(11408),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(13290),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_SEMI] = ACTIONS(11408),
    [anon_sym_LBRACE] = ACTIONS(13292),
    [anon_sym_DOLLAR] = ACTIONS(15212),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(13296),
    [anon_sym_true] = ACTIONS(13298),
    [anon_sym_false] = ACTIONS(13298),
    [sym_character_literal] = ACTIONS(14582),
    [sym__pair_operator] = ACTIONS(11581),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11581),
    [sym__pipe_left_operator] = ACTIONS(11581),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11581),
    [sym__bitshift_operator] = ACTIONS(11581),
    [sym__power_operator] = ACTIONS(11581),
    [sym__tilde_operator] = ACTIONS(2924),
    [sym__type_order_operator] = ACTIONS(11581),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13302),
    [sym__command_start] = ACTIONS(13304),
  },
  [9438] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_SQUOTE] = ACTIONS(12062),
    [anon_sym_DOT] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12060),
    [sym__immediate_bracket] = ACTIONS(12060),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [9439] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_SQUOTE] = ACTIONS(12066),
    [anon_sym_DOT] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12064),
    [sym__immediate_bracket] = ACTIONS(12064),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [9440] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_SQUOTE] = ACTIONS(12046),
    [anon_sym_DOT] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12044),
    [sym__immediate_bracket] = ACTIONS(12044),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [9441] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_SQUOTE] = ACTIONS(12054),
    [anon_sym_DOT] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12052),
    [sym__immediate_bracket] = ACTIONS(12052),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [9442] = {
    [sym__word_identifier] = ACTIONS(12338),
    [anon_sym_COLON] = ACTIONS(12338),
    [anon_sym_begin] = ACTIONS(12338),
    [anon_sym_module] = ACTIONS(12338),
    [anon_sym_baremodule] = ACTIONS(12338),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_abstract] = ACTIONS(12338),
    [anon_sym_primitive] = ACTIONS(12338),
    [anon_sym_mutable] = ACTIONS(12338),
    [anon_sym_struct] = ACTIONS(12338),
    [anon_sym_function] = ACTIONS(12338),
    [anon_sym_macro] = ACTIONS(12338),
    [anon_sym_quote] = ACTIONS(12338),
    [anon_sym_let] = ACTIONS(12338),
    [anon_sym_if] = ACTIONS(12338),
    [anon_sym_try] = ACTIONS(12338),
    [anon_sym_for] = ACTIONS(12338),
    [anon_sym_while] = ACTIONS(12338),
    [sym_break_statement] = ACTIONS(12338),
    [sym_continue_statement] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(12338),
    [anon_sym_const] = ACTIONS(12338),
    [anon_sym_global] = ACTIONS(12338),
    [anon_sym_local] = ACTIONS(12338),
    [anon_sym_LPAREN] = ACTIONS(12338),
    [anon_sym_export] = ACTIONS(12338),
    [anon_sym_import] = ACTIONS(12338),
    [anon_sym_using] = ACTIONS(12338),
    [anon_sym_LBRACK] = ACTIONS(12338),
    [anon_sym_LF] = ACTIONS(12340),
    [anon_sym_LBRACE] = ACTIONS(12338),
    [anon_sym_SQUOTE] = ACTIONS(12338),
    [anon_sym_DOT] = ACTIONS(12338),
    [anon_sym_DOLLAR] = ACTIONS(12338),
    [anon_sym_COLON_COLON] = ACTIONS(12338),
    [anon_sym_AT] = ACTIONS(12338),
    [anon_sym_true] = ACTIONS(12338),
    [anon_sym_false] = ACTIONS(12338),
    [aux_sym_integer_literal_token1] = ACTIONS(12338),
    [aux_sym_integer_literal_token2] = ACTIONS(12338),
    [aux_sym_integer_literal_token3] = ACTIONS(12338),
    [aux_sym_integer_literal_token4] = ACTIONS(12338),
    [aux_sym_float_literal_token1] = ACTIONS(12338),
    [aux_sym_float_literal_token3] = ACTIONS(12338),
    [aux_sym_float_literal_token4] = ACTIONS(12338),
    [sym_character_literal] = ACTIONS(12338),
    [sym__pair_operator] = ACTIONS(12338),
    [sym__arrow_operator] = ACTIONS(12338),
    [sym__comparison_operator] = ACTIONS(12338),
    [sym__pipe_right_operator] = ACTIONS(12338),
    [sym__pipe_left_operator] = ACTIONS(12338),
    [sym__ellipsis_operator] = ACTIONS(12338),
    [sym__plus_operator] = ACTIONS(12338),
    [sym__times_operator] = ACTIONS(12338),
    [sym__rational_operator] = ACTIONS(12338),
    [sym__bitshift_operator] = ACTIONS(12338),
    [sym__power_operator] = ACTIONS(12338),
    [sym__tilde_operator] = ACTIONS(12338),
    [sym__type_order_operator] = ACTIONS(12338),
    [sym__unary_operator] = ACTIONS(12338),
    [sym__unary_plus_operator] = ACTIONS(12338),
    [aux_sym__terminator_token1] = ACTIONS(12338),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12340),
    [sym__immediate_bracket] = ACTIONS(12340),
    [sym__immediate_brace] = ACTIONS(12340),
    [sym__string_start] = ACTIONS(12340),
    [sym__command_start] = ACTIONS(12340),
  },
  [9443] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_SQUOTE] = ACTIONS(12304),
    [anon_sym_DOT] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12302),
    [sym__immediate_bracket] = ACTIONS(12302),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [9444] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_SQUOTE] = ACTIONS(12264),
    [anon_sym_DOT] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12262),
    [sym__immediate_bracket] = ACTIONS(12262),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [9445] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_SQUOTE] = ACTIONS(12268),
    [anon_sym_DOT] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12266),
    [sym__immediate_bracket] = ACTIONS(12266),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [9446] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_SQUOTE] = ACTIONS(12272),
    [anon_sym_DOT] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12270),
    [sym__immediate_bracket] = ACTIONS(12270),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [9447] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_SQUOTE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12164),
    [sym__immediate_bracket] = ACTIONS(12164),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [9448] = {
    [sym__word_identifier] = ACTIONS(12334),
    [anon_sym_COLON] = ACTIONS(12334),
    [anon_sym_begin] = ACTIONS(12334),
    [anon_sym_module] = ACTIONS(12334),
    [anon_sym_baremodule] = ACTIONS(12334),
    [anon_sym_end] = ACTIONS(12334),
    [anon_sym_abstract] = ACTIONS(12334),
    [anon_sym_primitive] = ACTIONS(12334),
    [anon_sym_mutable] = ACTIONS(12334),
    [anon_sym_struct] = ACTIONS(12334),
    [anon_sym_function] = ACTIONS(12334),
    [anon_sym_macro] = ACTIONS(12334),
    [anon_sym_quote] = ACTIONS(12334),
    [anon_sym_let] = ACTIONS(12334),
    [anon_sym_if] = ACTIONS(12334),
    [anon_sym_try] = ACTIONS(12334),
    [anon_sym_for] = ACTIONS(12334),
    [anon_sym_while] = ACTIONS(12334),
    [sym_break_statement] = ACTIONS(12334),
    [sym_continue_statement] = ACTIONS(12334),
    [anon_sym_return] = ACTIONS(12334),
    [anon_sym_const] = ACTIONS(12334),
    [anon_sym_global] = ACTIONS(12334),
    [anon_sym_local] = ACTIONS(12334),
    [anon_sym_LPAREN] = ACTIONS(12334),
    [anon_sym_export] = ACTIONS(12334),
    [anon_sym_import] = ACTIONS(12334),
    [anon_sym_using] = ACTIONS(12334),
    [anon_sym_LBRACK] = ACTIONS(12334),
    [anon_sym_LF] = ACTIONS(12336),
    [anon_sym_LBRACE] = ACTIONS(12334),
    [anon_sym_SQUOTE] = ACTIONS(12334),
    [anon_sym_DOT] = ACTIONS(12334),
    [anon_sym_DOLLAR] = ACTIONS(12334),
    [anon_sym_COLON_COLON] = ACTIONS(12334),
    [anon_sym_AT] = ACTIONS(12334),
    [anon_sym_true] = ACTIONS(12334),
    [anon_sym_false] = ACTIONS(12334),
    [aux_sym_integer_literal_token1] = ACTIONS(12334),
    [aux_sym_integer_literal_token2] = ACTIONS(12334),
    [aux_sym_integer_literal_token3] = ACTIONS(12334),
    [aux_sym_integer_literal_token4] = ACTIONS(12334),
    [aux_sym_float_literal_token1] = ACTIONS(12334),
    [aux_sym_float_literal_token3] = ACTIONS(12334),
    [aux_sym_float_literal_token4] = ACTIONS(12334),
    [sym_character_literal] = ACTIONS(12334),
    [sym__pair_operator] = ACTIONS(12334),
    [sym__arrow_operator] = ACTIONS(12334),
    [sym__comparison_operator] = ACTIONS(12334),
    [sym__pipe_right_operator] = ACTIONS(12334),
    [sym__pipe_left_operator] = ACTIONS(12334),
    [sym__ellipsis_operator] = ACTIONS(12334),
    [sym__plus_operator] = ACTIONS(12334),
    [sym__times_operator] = ACTIONS(12334),
    [sym__rational_operator] = ACTIONS(12334),
    [sym__bitshift_operator] = ACTIONS(12334),
    [sym__power_operator] = ACTIONS(12334),
    [sym__tilde_operator] = ACTIONS(12334),
    [sym__type_order_operator] = ACTIONS(12334),
    [sym__unary_operator] = ACTIONS(12334),
    [sym__unary_plus_operator] = ACTIONS(12334),
    [aux_sym__terminator_token1] = ACTIONS(12334),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12336),
    [sym__immediate_bracket] = ACTIONS(12336),
    [sym__immediate_brace] = ACTIONS(12336),
    [sym__string_start] = ACTIONS(12336),
    [sym__command_start] = ACTIONS(12336),
  },
  [9449] = {
    [sym__word_identifier] = ACTIONS(15214),
    [anon_sym_COLON] = ACTIONS(15214),
    [anon_sym_begin] = ACTIONS(15214),
    [anon_sym_module] = ACTIONS(15214),
    [anon_sym_baremodule] = ACTIONS(15214),
    [anon_sym_end] = ACTIONS(15214),
    [anon_sym_abstract] = ACTIONS(15214),
    [anon_sym_primitive] = ACTIONS(15214),
    [anon_sym_mutable] = ACTIONS(15214),
    [anon_sym_struct] = ACTIONS(15214),
    [anon_sym_function] = ACTIONS(15214),
    [anon_sym_macro] = ACTIONS(15214),
    [anon_sym_quote] = ACTIONS(15214),
    [anon_sym_let] = ACTIONS(15214),
    [anon_sym_if] = ACTIONS(15214),
    [anon_sym_try] = ACTIONS(15214),
    [anon_sym_for] = ACTIONS(15214),
    [anon_sym_while] = ACTIONS(15214),
    [sym_break_statement] = ACTIONS(15214),
    [sym_continue_statement] = ACTIONS(15214),
    [anon_sym_return] = ACTIONS(15214),
    [anon_sym_const] = ACTIONS(15214),
    [anon_sym_global] = ACTIONS(15214),
    [anon_sym_local] = ACTIONS(15214),
    [anon_sym_LPAREN] = ACTIONS(15214),
    [anon_sym_export] = ACTIONS(15214),
    [anon_sym_import] = ACTIONS(15214),
    [anon_sym_using] = ACTIONS(15214),
    [anon_sym_LBRACK] = ACTIONS(15214),
    [anon_sym_LF] = ACTIONS(15216),
    [anon_sym_LBRACE] = ACTIONS(15214),
    [anon_sym_SQUOTE] = ACTIONS(15218),
    [anon_sym_DOT] = ACTIONS(15220),
    [anon_sym_DOLLAR] = ACTIONS(15214),
    [anon_sym_COLON_COLON] = ACTIONS(15214),
    [anon_sym_AT] = ACTIONS(15214),
    [anon_sym_true] = ACTIONS(15214),
    [anon_sym_false] = ACTIONS(15214),
    [aux_sym_integer_literal_token1] = ACTIONS(15214),
    [aux_sym_integer_literal_token2] = ACTIONS(15214),
    [aux_sym_integer_literal_token3] = ACTIONS(15214),
    [aux_sym_integer_literal_token4] = ACTIONS(15214),
    [aux_sym_float_literal_token1] = ACTIONS(15214),
    [aux_sym_float_literal_token3] = ACTIONS(15214),
    [aux_sym_float_literal_token4] = ACTIONS(15214),
    [sym_character_literal] = ACTIONS(15214),
    [sym__pair_operator] = ACTIONS(15214),
    [sym__arrow_operator] = ACTIONS(15214),
    [sym__comparison_operator] = ACTIONS(15214),
    [sym__pipe_right_operator] = ACTIONS(15214),
    [sym__pipe_left_operator] = ACTIONS(15214),
    [sym__ellipsis_operator] = ACTIONS(15214),
    [sym__plus_operator] = ACTIONS(15214),
    [sym__times_operator] = ACTIONS(15214),
    [sym__rational_operator] = ACTIONS(15214),
    [sym__bitshift_operator] = ACTIONS(15214),
    [sym__power_operator] = ACTIONS(15214),
    [sym__tilde_operator] = ACTIONS(15214),
    [sym__type_order_operator] = ACTIONS(15214),
    [sym__unary_operator] = ACTIONS(15214),
    [sym__unary_plus_operator] = ACTIONS(15214),
    [aux_sym__terminator_token1] = ACTIONS(15214),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(15222),
    [sym__immediate_bracket] = ACTIONS(15224),
    [sym__immediate_brace] = ACTIONS(15226),
    [sym__string_start] = ACTIONS(15216),
    [sym__command_start] = ACTIONS(15216),
  },
  [9450] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_SQUOTE] = ACTIONS(12276),
    [anon_sym_DOT] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12274),
    [sym__immediate_bracket] = ACTIONS(12274),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [9451] = {
    [sym__primary_expression] = STATE(11513),
    [sym__array] = STATE(11513),
    [sym_comprehension_expression] = STATE(11513),
    [sym_matrix_expression] = STATE(11513),
    [sym_vector_expression] = STATE(11513),
    [sym_parenthesized_expression] = STATE(11513),
    [sym_tuple_expression] = STATE(11513),
    [sym_curly_expression] = STATE(11513),
    [sym_adjoint_expression] = STATE(11513),
    [sym_field_expression] = STATE(11513),
    [sym_index_expression] = STATE(11513),
    [sym_parametrized_type_expression] = STATE(11513),
    [sym_call_expression] = STATE(11513),
    [sym_broadcast_call_expression] = STATE(11513),
    [sym__closed_macrocall_expression] = STATE(11513),
    [sym_interpolation_expression] = STATE(11513),
    [sym_quote_expression] = STATE(11513),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(11201),
    [sym_boolean_literal] = STATE(11513),
    [sym__string] = STATE(11513),
    [sym_string_literal] = STATE(11513),
    [sym_command_literal] = STATE(11513),
    [sym_prefixed_string_literal] = STATE(11513),
    [sym_prefixed_command_literal] = STATE(11513),
    [sym_operator] = STATE(19313),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(14606),
    [anon_sym_end] = ACTIONS(11397),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_DOLLAR] = ACTIONS(14608),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(14610),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(2926),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [9452] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_SQUOTE] = ACTIONS(12154),
    [anon_sym_DOT] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12152),
    [sym__immediate_bracket] = ACTIONS(12152),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [9453] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_SQUOTE] = ACTIONS(12280),
    [anon_sym_DOT] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12278),
    [sym__immediate_bracket] = ACTIONS(12278),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [9454] = {
    [sym__word_identifier] = ACTIONS(12342),
    [anon_sym_COLON] = ACTIONS(12342),
    [anon_sym_begin] = ACTIONS(12342),
    [anon_sym_module] = ACTIONS(12342),
    [anon_sym_baremodule] = ACTIONS(12342),
    [anon_sym_end] = ACTIONS(12342),
    [anon_sym_abstract] = ACTIONS(12342),
    [anon_sym_primitive] = ACTIONS(12342),
    [anon_sym_mutable] = ACTIONS(12342),
    [anon_sym_struct] = ACTIONS(12342),
    [anon_sym_function] = ACTIONS(12342),
    [anon_sym_macro] = ACTIONS(12342),
    [anon_sym_quote] = ACTIONS(12342),
    [anon_sym_let] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12342),
    [anon_sym_try] = ACTIONS(12342),
    [anon_sym_for] = ACTIONS(12342),
    [anon_sym_while] = ACTIONS(12342),
    [sym_break_statement] = ACTIONS(12342),
    [sym_continue_statement] = ACTIONS(12342),
    [anon_sym_return] = ACTIONS(12342),
    [anon_sym_const] = ACTIONS(12342),
    [anon_sym_global] = ACTIONS(12342),
    [anon_sym_local] = ACTIONS(12342),
    [anon_sym_LPAREN] = ACTIONS(12342),
    [anon_sym_export] = ACTIONS(12342),
    [anon_sym_import] = ACTIONS(12342),
    [anon_sym_using] = ACTIONS(12342),
    [anon_sym_LBRACK] = ACTIONS(12342),
    [anon_sym_LF] = ACTIONS(12344),
    [anon_sym_LBRACE] = ACTIONS(12342),
    [anon_sym_SQUOTE] = ACTIONS(12342),
    [anon_sym_DOT] = ACTIONS(12342),
    [anon_sym_DOLLAR] = ACTIONS(12342),
    [anon_sym_COLON_COLON] = ACTIONS(12342),
    [anon_sym_AT] = ACTIONS(12342),
    [anon_sym_true] = ACTIONS(12342),
    [anon_sym_false] = ACTIONS(12342),
    [aux_sym_integer_literal_token1] = ACTIONS(12342),
    [aux_sym_integer_literal_token2] = ACTIONS(12342),
    [aux_sym_integer_literal_token3] = ACTIONS(12342),
    [aux_sym_integer_literal_token4] = ACTIONS(12342),
    [aux_sym_float_literal_token1] = ACTIONS(12342),
    [aux_sym_float_literal_token3] = ACTIONS(12342),
    [aux_sym_float_literal_token4] = ACTIONS(12342),
    [sym_character_literal] = ACTIONS(12342),
    [sym__pair_operator] = ACTIONS(12342),
    [sym__arrow_operator] = ACTIONS(12342),
    [sym__comparison_operator] = ACTIONS(12342),
    [sym__pipe_right_operator] = ACTIONS(12342),
    [sym__pipe_left_operator] = ACTIONS(12342),
    [sym__ellipsis_operator] = ACTIONS(12342),
    [sym__plus_operator] = ACTIONS(12342),
    [sym__times_operator] = ACTIONS(12342),
    [sym__rational_operator] = ACTIONS(12342),
    [sym__bitshift_operator] = ACTIONS(12342),
    [sym__power_operator] = ACTIONS(12342),
    [sym__tilde_operator] = ACTIONS(12342),
    [sym__type_order_operator] = ACTIONS(12342),
    [sym__unary_operator] = ACTIONS(12342),
    [sym__unary_plus_operator] = ACTIONS(12342),
    [aux_sym__terminator_token1] = ACTIONS(12342),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12344),
    [sym__immediate_bracket] = ACTIONS(12344),
    [sym__immediate_brace] = ACTIONS(12344),
    [sym__string_start] = ACTIONS(12344),
    [sym__command_start] = ACTIONS(12344),
  },
  [9455] = {
    [sym__word_identifier] = ACTIONS(12360),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_begin] = ACTIONS(12360),
    [anon_sym_module] = ACTIONS(12360),
    [anon_sym_baremodule] = ACTIONS(12360),
    [anon_sym_end] = ACTIONS(12360),
    [anon_sym_abstract] = ACTIONS(12360),
    [anon_sym_primitive] = ACTIONS(12360),
    [anon_sym_mutable] = ACTIONS(12360),
    [anon_sym_struct] = ACTIONS(12360),
    [anon_sym_function] = ACTIONS(12360),
    [anon_sym_macro] = ACTIONS(12360),
    [anon_sym_quote] = ACTIONS(12360),
    [anon_sym_let] = ACTIONS(12360),
    [anon_sym_if] = ACTIONS(12360),
    [anon_sym_try] = ACTIONS(12360),
    [anon_sym_for] = ACTIONS(12360),
    [anon_sym_while] = ACTIONS(12360),
    [sym_break_statement] = ACTIONS(12360),
    [sym_continue_statement] = ACTIONS(12360),
    [anon_sym_return] = ACTIONS(12360),
    [anon_sym_const] = ACTIONS(12360),
    [anon_sym_global] = ACTIONS(12360),
    [anon_sym_local] = ACTIONS(12360),
    [anon_sym_LPAREN] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(12360),
    [anon_sym_import] = ACTIONS(12360),
    [anon_sym_using] = ACTIONS(12360),
    [anon_sym_LBRACK] = ACTIONS(12360),
    [anon_sym_LF] = ACTIONS(12362),
    [anon_sym_LBRACE] = ACTIONS(12360),
    [anon_sym_SQUOTE] = ACTIONS(12360),
    [anon_sym_DOT] = ACTIONS(12360),
    [anon_sym_DOLLAR] = ACTIONS(12360),
    [anon_sym_COLON_COLON] = ACTIONS(12360),
    [anon_sym_AT] = ACTIONS(12360),
    [anon_sym_true] = ACTIONS(12360),
    [anon_sym_false] = ACTIONS(12360),
    [aux_sym_integer_literal_token1] = ACTIONS(12360),
    [aux_sym_integer_literal_token2] = ACTIONS(12360),
    [aux_sym_integer_literal_token3] = ACTIONS(12360),
    [aux_sym_integer_literal_token4] = ACTIONS(12360),
    [aux_sym_float_literal_token1] = ACTIONS(12360),
    [aux_sym_float_literal_token3] = ACTIONS(12360),
    [aux_sym_float_literal_token4] = ACTIONS(12360),
    [sym_character_literal] = ACTIONS(12360),
    [sym__pair_operator] = ACTIONS(12360),
    [sym__arrow_operator] = ACTIONS(12360),
    [sym__comparison_operator] = ACTIONS(12360),
    [sym__pipe_right_operator] = ACTIONS(12360),
    [sym__pipe_left_operator] = ACTIONS(12360),
    [sym__ellipsis_operator] = ACTIONS(12360),
    [sym__plus_operator] = ACTIONS(12360),
    [sym__times_operator] = ACTIONS(12360),
    [sym__rational_operator] = ACTIONS(12360),
    [sym__bitshift_operator] = ACTIONS(12360),
    [sym__power_operator] = ACTIONS(12360),
    [sym__tilde_operator] = ACTIONS(12360),
    [sym__type_order_operator] = ACTIONS(12360),
    [sym__unary_operator] = ACTIONS(12360),
    [sym__unary_plus_operator] = ACTIONS(12360),
    [aux_sym__terminator_token1] = ACTIONS(12360),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12362),
    [sym__immediate_bracket] = ACTIONS(12362),
    [sym__immediate_brace] = ACTIONS(12362),
    [sym__string_start] = ACTIONS(12362),
    [sym__command_start] = ACTIONS(12362),
  },
  [9456] = {
    [sym__word_identifier] = ACTIONS(11928),
    [anon_sym_COLON] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11928),
    [anon_sym_module] = ACTIONS(11928),
    [anon_sym_baremodule] = ACTIONS(11928),
    [anon_sym_end] = ACTIONS(11928),
    [anon_sym_abstract] = ACTIONS(11928),
    [anon_sym_primitive] = ACTIONS(11928),
    [anon_sym_mutable] = ACTIONS(11928),
    [anon_sym_struct] = ACTIONS(11928),
    [anon_sym_function] = ACTIONS(11928),
    [anon_sym_macro] = ACTIONS(11928),
    [anon_sym_quote] = ACTIONS(11928),
    [anon_sym_let] = ACTIONS(11928),
    [anon_sym_if] = ACTIONS(11928),
    [anon_sym_try] = ACTIONS(11928),
    [anon_sym_for] = ACTIONS(11928),
    [anon_sym_while] = ACTIONS(11928),
    [sym_break_statement] = ACTIONS(11928),
    [sym_continue_statement] = ACTIONS(11928),
    [anon_sym_return] = ACTIONS(11928),
    [anon_sym_const] = ACTIONS(11928),
    [anon_sym_global] = ACTIONS(11928),
    [anon_sym_local] = ACTIONS(11928),
    [anon_sym_LPAREN] = ACTIONS(11928),
    [anon_sym_export] = ACTIONS(11928),
    [anon_sym_import] = ACTIONS(11928),
    [anon_sym_using] = ACTIONS(11928),
    [anon_sym_LBRACK] = ACTIONS(11928),
    [anon_sym_LF] = ACTIONS(11930),
    [anon_sym_LBRACE] = ACTIONS(11928),
    [anon_sym_SQUOTE] = ACTIONS(11928),
    [anon_sym_DOT] = ACTIONS(11928),
    [anon_sym_DOLLAR] = ACTIONS(11928),
    [anon_sym_COLON_COLON] = ACTIONS(11928),
    [anon_sym_AT] = ACTIONS(11928),
    [anon_sym_true] = ACTIONS(11928),
    [anon_sym_false] = ACTIONS(11928),
    [aux_sym_integer_literal_token1] = ACTIONS(11928),
    [aux_sym_integer_literal_token2] = ACTIONS(11928),
    [aux_sym_integer_literal_token3] = ACTIONS(11928),
    [aux_sym_integer_literal_token4] = ACTIONS(11928),
    [aux_sym_float_literal_token1] = ACTIONS(11928),
    [aux_sym_float_literal_token3] = ACTIONS(11928),
    [aux_sym_float_literal_token4] = ACTIONS(11928),
    [sym_character_literal] = ACTIONS(11928),
    [sym__pair_operator] = ACTIONS(11928),
    [sym__arrow_operator] = ACTIONS(11928),
    [sym__comparison_operator] = ACTIONS(11928),
    [sym__pipe_right_operator] = ACTIONS(11928),
    [sym__pipe_left_operator] = ACTIONS(11928),
    [sym__ellipsis_operator] = ACTIONS(11928),
    [sym__plus_operator] = ACTIONS(11928),
    [sym__times_operator] = ACTIONS(11928),
    [sym__rational_operator] = ACTIONS(11928),
    [sym__bitshift_operator] = ACTIONS(11928),
    [sym__power_operator] = ACTIONS(11928),
    [sym__tilde_operator] = ACTIONS(11928),
    [sym__type_order_operator] = ACTIONS(11928),
    [sym__unary_operator] = ACTIONS(11928),
    [sym__unary_plus_operator] = ACTIONS(11928),
    [aux_sym__terminator_token1] = ACTIONS(11928),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11930),
    [sym__immediate_bracket] = ACTIONS(11930),
    [sym__immediate_brace] = ACTIONS(11930),
    [sym__string_start] = ACTIONS(11930),
    [sym__command_start] = ACTIONS(11930),
  },
  [9457] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_SQUOTE] = ACTIONS(12070),
    [anon_sym_DOT] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12068),
    [sym__immediate_bracket] = ACTIONS(12068),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [9458] = {
    [sym__word_identifier] = ACTIONS(12308),
    [anon_sym_COLON] = ACTIONS(12308),
    [anon_sym_begin] = ACTIONS(12308),
    [anon_sym_module] = ACTIONS(12308),
    [anon_sym_baremodule] = ACTIONS(12308),
    [anon_sym_end] = ACTIONS(12308),
    [anon_sym_abstract] = ACTIONS(12308),
    [anon_sym_primitive] = ACTIONS(12308),
    [anon_sym_mutable] = ACTIONS(12308),
    [anon_sym_struct] = ACTIONS(12308),
    [anon_sym_function] = ACTIONS(12308),
    [anon_sym_macro] = ACTIONS(12308),
    [anon_sym_quote] = ACTIONS(12308),
    [anon_sym_let] = ACTIONS(12308),
    [anon_sym_if] = ACTIONS(12308),
    [anon_sym_try] = ACTIONS(12308),
    [anon_sym_for] = ACTIONS(12308),
    [anon_sym_while] = ACTIONS(12308),
    [sym_break_statement] = ACTIONS(12308),
    [sym_continue_statement] = ACTIONS(12308),
    [anon_sym_return] = ACTIONS(12308),
    [anon_sym_const] = ACTIONS(12308),
    [anon_sym_global] = ACTIONS(12308),
    [anon_sym_local] = ACTIONS(12308),
    [anon_sym_LPAREN] = ACTIONS(12308),
    [anon_sym_export] = ACTIONS(12308),
    [anon_sym_import] = ACTIONS(12308),
    [anon_sym_using] = ACTIONS(12308),
    [anon_sym_LBRACK] = ACTIONS(12308),
    [anon_sym_LF] = ACTIONS(12306),
    [anon_sym_LBRACE] = ACTIONS(12308),
    [anon_sym_SQUOTE] = ACTIONS(12308),
    [anon_sym_DOT] = ACTIONS(12308),
    [anon_sym_DOLLAR] = ACTIONS(12308),
    [anon_sym_COLON_COLON] = ACTIONS(12308),
    [anon_sym_AT] = ACTIONS(12308),
    [anon_sym_true] = ACTIONS(12308),
    [anon_sym_false] = ACTIONS(12308),
    [aux_sym_integer_literal_token1] = ACTIONS(12308),
    [aux_sym_integer_literal_token2] = ACTIONS(12308),
    [aux_sym_integer_literal_token3] = ACTIONS(12308),
    [aux_sym_integer_literal_token4] = ACTIONS(12308),
    [aux_sym_float_literal_token1] = ACTIONS(12308),
    [aux_sym_float_literal_token3] = ACTIONS(12308),
    [aux_sym_float_literal_token4] = ACTIONS(12308),
    [sym_character_literal] = ACTIONS(12308),
    [sym__pair_operator] = ACTIONS(12308),
    [sym__arrow_operator] = ACTIONS(12308),
    [sym__comparison_operator] = ACTIONS(12308),
    [sym__pipe_right_operator] = ACTIONS(12308),
    [sym__pipe_left_operator] = ACTIONS(12308),
    [sym__ellipsis_operator] = ACTIONS(12308),
    [sym__plus_operator] = ACTIONS(12308),
    [sym__times_operator] = ACTIONS(12308),
    [sym__rational_operator] = ACTIONS(12308),
    [sym__bitshift_operator] = ACTIONS(12308),
    [sym__power_operator] = ACTIONS(12308),
    [sym__tilde_operator] = ACTIONS(12308),
    [sym__type_order_operator] = ACTIONS(12308),
    [sym__unary_operator] = ACTIONS(12308),
    [sym__unary_plus_operator] = ACTIONS(12308),
    [aux_sym__terminator_token1] = ACTIONS(12308),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12306),
    [sym__immediate_bracket] = ACTIONS(12306),
    [sym__immediate_brace] = ACTIONS(12306),
    [sym__string_start] = ACTIONS(12306),
    [sym__command_start] = ACTIONS(12306),
  },
  [9459] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_SQUOTE] = ACTIONS(12248),
    [anon_sym_DOT] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12246),
    [sym__immediate_bracket] = ACTIONS(12246),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [9460] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_SQUOTE] = ACTIONS(12252),
    [anon_sym_DOT] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12250),
    [sym__immediate_bracket] = ACTIONS(12250),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [9461] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_SQUOTE] = ACTIONS(12284),
    [anon_sym_DOT] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12282),
    [sym__immediate_bracket] = ACTIONS(12282),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [9462] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_SQUOTE] = ACTIONS(12384),
    [anon_sym_DOT] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12386),
    [sym__immediate_bracket] = ACTIONS(12386),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [9463] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_SQUOTE] = ACTIONS(12058),
    [anon_sym_DOT] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12056),
    [sym__immediate_bracket] = ACTIONS(12056),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [9464] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_SQUOTE] = ACTIONS(12300),
    [anon_sym_DOT] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12298),
    [sym__immediate_bracket] = ACTIONS(12298),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [9465] = {
    [sym__word_identifier] = ACTIONS(11888),
    [anon_sym_COLON] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11888),
    [anon_sym_module] = ACTIONS(11888),
    [anon_sym_baremodule] = ACTIONS(11888),
    [anon_sym_end] = ACTIONS(11888),
    [anon_sym_abstract] = ACTIONS(11888),
    [anon_sym_primitive] = ACTIONS(11888),
    [anon_sym_mutable] = ACTIONS(11888),
    [anon_sym_struct] = ACTIONS(11888),
    [anon_sym_function] = ACTIONS(11888),
    [anon_sym_macro] = ACTIONS(11888),
    [anon_sym_quote] = ACTIONS(11888),
    [anon_sym_let] = ACTIONS(11888),
    [anon_sym_if] = ACTIONS(11888),
    [anon_sym_try] = ACTIONS(11888),
    [anon_sym_for] = ACTIONS(11888),
    [anon_sym_while] = ACTIONS(11888),
    [sym_break_statement] = ACTIONS(11888),
    [sym_continue_statement] = ACTIONS(11888),
    [anon_sym_return] = ACTIONS(11888),
    [anon_sym_const] = ACTIONS(11888),
    [anon_sym_global] = ACTIONS(11888),
    [anon_sym_local] = ACTIONS(11888),
    [anon_sym_LPAREN] = ACTIONS(11888),
    [anon_sym_export] = ACTIONS(11888),
    [anon_sym_import] = ACTIONS(11888),
    [anon_sym_using] = ACTIONS(11888),
    [anon_sym_LBRACK] = ACTIONS(11888),
    [anon_sym_LF] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11888),
    [anon_sym_SQUOTE] = ACTIONS(11888),
    [anon_sym_DOT] = ACTIONS(11888),
    [anon_sym_DOLLAR] = ACTIONS(11888),
    [anon_sym_COLON_COLON] = ACTIONS(11888),
    [anon_sym_AT] = ACTIONS(11888),
    [anon_sym_true] = ACTIONS(11888),
    [anon_sym_false] = ACTIONS(11888),
    [aux_sym_integer_literal_token1] = ACTIONS(11888),
    [aux_sym_integer_literal_token2] = ACTIONS(11888),
    [aux_sym_integer_literal_token3] = ACTIONS(11888),
    [aux_sym_integer_literal_token4] = ACTIONS(11888),
    [aux_sym_float_literal_token1] = ACTIONS(11888),
    [aux_sym_float_literal_token3] = ACTIONS(11888),
    [aux_sym_float_literal_token4] = ACTIONS(11888),
    [sym_character_literal] = ACTIONS(11888),
    [sym__pair_operator] = ACTIONS(11888),
    [sym__arrow_operator] = ACTIONS(11888),
    [sym__comparison_operator] = ACTIONS(11888),
    [sym__pipe_right_operator] = ACTIONS(11888),
    [sym__pipe_left_operator] = ACTIONS(11888),
    [sym__ellipsis_operator] = ACTIONS(11888),
    [sym__plus_operator] = ACTIONS(11888),
    [sym__times_operator] = ACTIONS(11888),
    [sym__rational_operator] = ACTIONS(11888),
    [sym__bitshift_operator] = ACTIONS(11888),
    [sym__power_operator] = ACTIONS(11888),
    [sym__tilde_operator] = ACTIONS(11888),
    [sym__type_order_operator] = ACTIONS(11888),
    [sym__unary_operator] = ACTIONS(11888),
    [sym__unary_plus_operator] = ACTIONS(11888),
    [aux_sym__terminator_token1] = ACTIONS(11888),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11890),
    [sym__immediate_bracket] = ACTIONS(11890),
    [sym__immediate_brace] = ACTIONS(11890),
    [sym__string_start] = ACTIONS(11890),
    [sym__command_start] = ACTIONS(11890),
  },
  [9466] = {
    [sym__word_identifier] = ACTIONS(12364),
    [anon_sym_COLON] = ACTIONS(12364),
    [anon_sym_begin] = ACTIONS(12364),
    [anon_sym_module] = ACTIONS(12364),
    [anon_sym_baremodule] = ACTIONS(12364),
    [anon_sym_end] = ACTIONS(12364),
    [anon_sym_abstract] = ACTIONS(12364),
    [anon_sym_primitive] = ACTIONS(12364),
    [anon_sym_mutable] = ACTIONS(12364),
    [anon_sym_struct] = ACTIONS(12364),
    [anon_sym_function] = ACTIONS(12364),
    [anon_sym_macro] = ACTIONS(12364),
    [anon_sym_quote] = ACTIONS(12364),
    [anon_sym_let] = ACTIONS(12364),
    [anon_sym_if] = ACTIONS(12364),
    [anon_sym_try] = ACTIONS(12364),
    [anon_sym_for] = ACTIONS(12364),
    [anon_sym_while] = ACTIONS(12364),
    [sym_break_statement] = ACTIONS(12364),
    [sym_continue_statement] = ACTIONS(12364),
    [anon_sym_return] = ACTIONS(12364),
    [anon_sym_const] = ACTIONS(12364),
    [anon_sym_global] = ACTIONS(12364),
    [anon_sym_local] = ACTIONS(12364),
    [anon_sym_LPAREN] = ACTIONS(12364),
    [anon_sym_export] = ACTIONS(12364),
    [anon_sym_import] = ACTIONS(12364),
    [anon_sym_using] = ACTIONS(12364),
    [anon_sym_LBRACK] = ACTIONS(12364),
    [anon_sym_LF] = ACTIONS(12366),
    [anon_sym_LBRACE] = ACTIONS(12364),
    [anon_sym_SQUOTE] = ACTIONS(12364),
    [anon_sym_DOT] = ACTIONS(12364),
    [anon_sym_DOLLAR] = ACTIONS(12364),
    [anon_sym_COLON_COLON] = ACTIONS(12364),
    [anon_sym_AT] = ACTIONS(12364),
    [anon_sym_true] = ACTIONS(12364),
    [anon_sym_false] = ACTIONS(12364),
    [aux_sym_integer_literal_token1] = ACTIONS(12364),
    [aux_sym_integer_literal_token2] = ACTIONS(12364),
    [aux_sym_integer_literal_token3] = ACTIONS(12364),
    [aux_sym_integer_literal_token4] = ACTIONS(12364),
    [aux_sym_float_literal_token1] = ACTIONS(12364),
    [aux_sym_float_literal_token3] = ACTIONS(12364),
    [aux_sym_float_literal_token4] = ACTIONS(12364),
    [sym_character_literal] = ACTIONS(12364),
    [sym__pair_operator] = ACTIONS(12364),
    [sym__arrow_operator] = ACTIONS(12364),
    [sym__comparison_operator] = ACTIONS(12364),
    [sym__pipe_right_operator] = ACTIONS(12364),
    [sym__pipe_left_operator] = ACTIONS(12364),
    [sym__ellipsis_operator] = ACTIONS(12364),
    [sym__plus_operator] = ACTIONS(12364),
    [sym__times_operator] = ACTIONS(12364),
    [sym__rational_operator] = ACTIONS(12364),
    [sym__bitshift_operator] = ACTIONS(12364),
    [sym__power_operator] = ACTIONS(12364),
    [sym__tilde_operator] = ACTIONS(12364),
    [sym__type_order_operator] = ACTIONS(12364),
    [sym__unary_operator] = ACTIONS(12364),
    [sym__unary_plus_operator] = ACTIONS(12364),
    [aux_sym__terminator_token1] = ACTIONS(12364),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12366),
    [sym__immediate_bracket] = ACTIONS(12366),
    [sym__immediate_brace] = ACTIONS(12366),
    [sym__string_start] = ACTIONS(12366),
    [sym__command_start] = ACTIONS(12366),
  },
  [9467] = {
    [sym__primary_expression] = STATE(11491),
    [sym__array] = STATE(11491),
    [sym_comprehension_expression] = STATE(11491),
    [sym_matrix_expression] = STATE(11491),
    [sym_vector_expression] = STATE(11491),
    [sym_parenthesized_expression] = STATE(11491),
    [sym_tuple_expression] = STATE(11491),
    [sym_curly_expression] = STATE(11491),
    [sym_adjoint_expression] = STATE(11491),
    [sym_field_expression] = STATE(11491),
    [sym_index_expression] = STATE(11491),
    [sym_parametrized_type_expression] = STATE(11491),
    [sym_call_expression] = STATE(11491),
    [sym_broadcast_call_expression] = STATE(11491),
    [sym__closed_macrocall_expression] = STATE(11491),
    [sym_interpolation_expression] = STATE(11491),
    [sym_quote_expression] = STATE(11491),
    [sym_macro_identifier] = STATE(16735),
    [sym_identifier] = STATE(11326),
    [sym_boolean_literal] = STATE(11491),
    [sym__string] = STATE(11491),
    [sym_string_literal] = STATE(11491),
    [sym_command_literal] = STATE(11491),
    [sym_prefixed_string_literal] = STATE(11491),
    [sym_prefixed_command_literal] = STATE(11491),
    [sym_operator] = STATE(19313),
    [ts_builtin_sym_end] = ACTIONS(11408),
    [sym__word_identifier] = ACTIONS(12985),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11397),
    [anon_sym_COLON] = ACTIONS(14623),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(12989),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(12991),
    [anon_sym_LF] = ACTIONS(11408),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(12993),
    [anon_sym_DOLLAR] = ACTIONS(14625),
    [anon_sym_COLON_COLON] = ACTIONS(11397),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11397),
    [anon_sym_QMARK] = ACTIONS(11397),
    [anon_sym_AT] = ACTIONS(12997),
    [anon_sym_true] = ACTIONS(12999),
    [anon_sym_false] = ACTIONS(12999),
    [sym_character_literal] = ACTIONS(14627),
    [sym__pair_operator] = ACTIONS(11425),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11397),
    [sym__lazy_and_operator] = ACTIONS(11397),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11425),
    [sym__pipe_left_operator] = ACTIONS(11425),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11425),
    [sym__bitshift_operator] = ACTIONS(11425),
    [sym__power_operator] = ACTIONS(11425),
    [sym__tilde_operator] = ACTIONS(2926),
    [sym__type_order_operator] = ACTIONS(11425),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [aux_sym__terminator_token1] = ACTIONS(11397),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13003),
    [sym__command_start] = ACTIONS(13005),
  },
  [9468] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_SQUOTE] = ACTIONS(12256),
    [anon_sym_DOT] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12254),
    [sym__immediate_bracket] = ACTIONS(12254),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [9469] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_SQUOTE] = ACTIONS(12260),
    [anon_sym_DOT] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12258),
    [sym__immediate_bracket] = ACTIONS(12258),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [9470] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_SQUOTE] = ACTIONS(11892),
    [anon_sym_DOT] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(11894),
    [sym__immediate_bracket] = ACTIONS(11894),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [9471] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_SQUOTE] = ACTIONS(12142),
    [anon_sym_DOT] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12140),
    [sym__immediate_bracket] = ACTIONS(12140),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [9472] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_SQUOTE] = ACTIONS(12094),
    [anon_sym_DOT] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12096),
    [sym__immediate_bracket] = ACTIONS(12096),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [9473] = {
    [sym__word_identifier] = ACTIONS(12326),
    [anon_sym_COLON] = ACTIONS(12326),
    [anon_sym_begin] = ACTIONS(12326),
    [anon_sym_module] = ACTIONS(12326),
    [anon_sym_baremodule] = ACTIONS(12326),
    [anon_sym_end] = ACTIONS(12326),
    [anon_sym_abstract] = ACTIONS(12326),
    [anon_sym_primitive] = ACTIONS(12326),
    [anon_sym_mutable] = ACTIONS(12326),
    [anon_sym_struct] = ACTIONS(12326),
    [anon_sym_function] = ACTIONS(12326),
    [anon_sym_macro] = ACTIONS(12326),
    [anon_sym_quote] = ACTIONS(12326),
    [anon_sym_let] = ACTIONS(12326),
    [anon_sym_if] = ACTIONS(12326),
    [anon_sym_try] = ACTIONS(12326),
    [anon_sym_for] = ACTIONS(12326),
    [anon_sym_while] = ACTIONS(12326),
    [sym_break_statement] = ACTIONS(12326),
    [sym_continue_statement] = ACTIONS(12326),
    [anon_sym_return] = ACTIONS(12326),
    [anon_sym_const] = ACTIONS(12326),
    [anon_sym_global] = ACTIONS(12326),
    [anon_sym_local] = ACTIONS(12326),
    [anon_sym_LPAREN] = ACTIONS(12326),
    [anon_sym_export] = ACTIONS(12326),
    [anon_sym_import] = ACTIONS(12326),
    [anon_sym_using] = ACTIONS(12326),
    [anon_sym_LBRACK] = ACTIONS(12326),
    [anon_sym_LF] = ACTIONS(12328),
    [anon_sym_LBRACE] = ACTIONS(12326),
    [anon_sym_SQUOTE] = ACTIONS(12326),
    [anon_sym_DOT] = ACTIONS(12326),
    [anon_sym_DOLLAR] = ACTIONS(12326),
    [anon_sym_COLON_COLON] = ACTIONS(12326),
    [anon_sym_AT] = ACTIONS(12326),
    [anon_sym_true] = ACTIONS(12326),
    [anon_sym_false] = ACTIONS(12326),
    [aux_sym_integer_literal_token1] = ACTIONS(12326),
    [aux_sym_integer_literal_token2] = ACTIONS(12326),
    [aux_sym_integer_literal_token3] = ACTIONS(12326),
    [aux_sym_integer_literal_token4] = ACTIONS(12326),
    [aux_sym_float_literal_token1] = ACTIONS(12326),
    [aux_sym_float_literal_token3] = ACTIONS(12326),
    [aux_sym_float_literal_token4] = ACTIONS(12326),
    [sym_character_literal] = ACTIONS(12326),
    [sym__pair_operator] = ACTIONS(12326),
    [sym__arrow_operator] = ACTIONS(12326),
    [sym__comparison_operator] = ACTIONS(12326),
    [sym__pipe_right_operator] = ACTIONS(12326),
    [sym__pipe_left_operator] = ACTIONS(12326),
    [sym__ellipsis_operator] = ACTIONS(12326),
    [sym__plus_operator] = ACTIONS(12326),
    [sym__times_operator] = ACTIONS(12326),
    [sym__rational_operator] = ACTIONS(12326),
    [sym__bitshift_operator] = ACTIONS(12326),
    [sym__power_operator] = ACTIONS(12326),
    [sym__tilde_operator] = ACTIONS(12326),
    [sym__type_order_operator] = ACTIONS(12326),
    [sym__unary_operator] = ACTIONS(12326),
    [sym__unary_plus_operator] = ACTIONS(12326),
    [aux_sym__terminator_token1] = ACTIONS(12326),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12328),
    [sym__immediate_bracket] = ACTIONS(12328),
    [sym__immediate_brace] = ACTIONS(12328),
    [sym__string_start] = ACTIONS(12328),
    [sym__command_start] = ACTIONS(12328),
  },
  [9474] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_SQUOTE] = ACTIONS(12146),
    [anon_sym_DOT] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12144),
    [sym__immediate_bracket] = ACTIONS(12144),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [9475] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_SQUOTE] = ACTIONS(12150),
    [anon_sym_DOT] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12148),
    [sym__immediate_bracket] = ACTIONS(12148),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [9476] = {
    [sym__word_identifier] = ACTIONS(12322),
    [anon_sym_COLON] = ACTIONS(12322),
    [anon_sym_begin] = ACTIONS(12322),
    [anon_sym_module] = ACTIONS(12322),
    [anon_sym_baremodule] = ACTIONS(12322),
    [anon_sym_end] = ACTIONS(12322),
    [anon_sym_abstract] = ACTIONS(12322),
    [anon_sym_primitive] = ACTIONS(12322),
    [anon_sym_mutable] = ACTIONS(12322),
    [anon_sym_struct] = ACTIONS(12322),
    [anon_sym_function] = ACTIONS(12322),
    [anon_sym_macro] = ACTIONS(12322),
    [anon_sym_quote] = ACTIONS(12322),
    [anon_sym_let] = ACTIONS(12322),
    [anon_sym_if] = ACTIONS(12322),
    [anon_sym_try] = ACTIONS(12322),
    [anon_sym_for] = ACTIONS(12322),
    [anon_sym_while] = ACTIONS(12322),
    [sym_break_statement] = ACTIONS(12322),
    [sym_continue_statement] = ACTIONS(12322),
    [anon_sym_return] = ACTIONS(12322),
    [anon_sym_const] = ACTIONS(12322),
    [anon_sym_global] = ACTIONS(12322),
    [anon_sym_local] = ACTIONS(12322),
    [anon_sym_LPAREN] = ACTIONS(12322),
    [anon_sym_export] = ACTIONS(12322),
    [anon_sym_import] = ACTIONS(12322),
    [anon_sym_using] = ACTIONS(12322),
    [anon_sym_LBRACK] = ACTIONS(12322),
    [anon_sym_LF] = ACTIONS(12324),
    [anon_sym_LBRACE] = ACTIONS(12322),
    [anon_sym_SQUOTE] = ACTIONS(12322),
    [anon_sym_DOT] = ACTIONS(12322),
    [anon_sym_DOLLAR] = ACTIONS(12322),
    [anon_sym_COLON_COLON] = ACTIONS(12322),
    [anon_sym_AT] = ACTIONS(12322),
    [anon_sym_true] = ACTIONS(12322),
    [anon_sym_false] = ACTIONS(12322),
    [aux_sym_integer_literal_token1] = ACTIONS(12322),
    [aux_sym_integer_literal_token2] = ACTIONS(12322),
    [aux_sym_integer_literal_token3] = ACTIONS(12322),
    [aux_sym_integer_literal_token4] = ACTIONS(12322),
    [aux_sym_float_literal_token1] = ACTIONS(12322),
    [aux_sym_float_literal_token3] = ACTIONS(12322),
    [aux_sym_float_literal_token4] = ACTIONS(12322),
    [sym_character_literal] = ACTIONS(12322),
    [sym__pair_operator] = ACTIONS(12322),
    [sym__arrow_operator] = ACTIONS(12322),
    [sym__comparison_operator] = ACTIONS(12322),
    [sym__pipe_right_operator] = ACTIONS(12322),
    [sym__pipe_left_operator] = ACTIONS(12322),
    [sym__ellipsis_operator] = ACTIONS(12322),
    [sym__plus_operator] = ACTIONS(12322),
    [sym__times_operator] = ACTIONS(12322),
    [sym__rational_operator] = ACTIONS(12322),
    [sym__bitshift_operator] = ACTIONS(12322),
    [sym__power_operator] = ACTIONS(12322),
    [sym__tilde_operator] = ACTIONS(12322),
    [sym__type_order_operator] = ACTIONS(12322),
    [sym__unary_operator] = ACTIONS(12322),
    [sym__unary_plus_operator] = ACTIONS(12322),
    [aux_sym__terminator_token1] = ACTIONS(12322),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(12324),
    [sym__immediate_bracket] = ACTIONS(12324),
    [sym__immediate_brace] = ACTIONS(12324),
    [sym__string_start] = ACTIONS(12324),
    [sym__command_start] = ACTIONS(12324),
  },
  [9477] = {
    [sym__comprehension_clause] = STATE(18220),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16942),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13718),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13720),
    [anon_sym_LF] = ACTIONS(13722),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13725),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9478] = {
    [sym__comprehension_clause] = STATE(19380),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17120),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13930),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13932),
    [anon_sym_LF] = ACTIONS(13934),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13937),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9479] = {
    [sym__comprehension_clause] = STATE(19532),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16877),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14300),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14302),
    [anon_sym_LF] = ACTIONS(14304),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14307),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9480] = {
    [sym__comprehension_clause] = STATE(19656),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16944),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14310),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14312),
    [anon_sym_LF] = ACTIONS(14314),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14317),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9481] = {
    [sym__comprehension_clause] = STATE(19555),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17245),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14168),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14170),
    [anon_sym_LF] = ACTIONS(14172),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14175),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9482] = {
    [sym__comprehension_clause] = STATE(19580),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17207),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13940),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13942),
    [anon_sym_LF] = ACTIONS(13944),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13947),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9483] = {
    [sym__comprehension_clause] = STATE(18521),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17125),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14208),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14210),
    [anon_sym_LF] = ACTIONS(14212),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14215),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9484] = {
    [sym__comprehension_clause] = STATE(19759),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17188),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14332),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14334),
    [anon_sym_LF] = ACTIONS(14336),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14339),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9485] = {
    [sym__comprehension_clause] = STATE(19087),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17145),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13682),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13684),
    [anon_sym_LF] = ACTIONS(13686),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13689),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9486] = {
    [sym__comprehension_clause] = STATE(19650),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17244),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13760),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13762),
    [anon_sym_LF] = ACTIONS(13764),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13767),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9487] = {
    [sym__comprehension_clause] = STATE(19835),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16841),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13776),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13778),
    [anon_sym_LF] = ACTIONS(13780),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13783),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9488] = {
    [sym__comprehension_clause] = STATE(18406),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17259),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14345),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14347),
    [anon_sym_LF] = ACTIONS(14349),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14352),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9489] = {
    [sym__comprehension_clause] = STATE(19796),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17304),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13956),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13958),
    [anon_sym_LF] = ACTIONS(13960),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13963),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9490] = {
    [sym__comprehension_clause] = STATE(19797),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17274),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13610),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13612),
    [anon_sym_LF] = ACTIONS(13614),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13617),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9491] = {
    [sym__comprehension_clause] = STATE(18543),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17309),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13910),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13912),
    [anon_sym_LF] = ACTIONS(13914),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13917),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9492] = {
    [sym__comprehension_clause] = STATE(19063),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17332),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14355),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14357),
    [anon_sym_LF] = ACTIONS(14359),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14362),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9493] = {
    [sym__comprehension_clause] = STATE(19521),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16695),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14365),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14367),
    [anon_sym_LF] = ACTIONS(14369),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14372),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9494] = {
    [sym__comprehension_clause] = STATE(18517),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17329),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13966),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13968),
    [anon_sym_LF] = ACTIONS(13970),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13973),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9495] = {
    [sym__comprehension_clause] = STATE(18627),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16734),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14218),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14220),
    [anon_sym_LF] = ACTIONS(14222),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14225),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9496] = {
    [sym__comprehension_clause] = STATE(18245),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16743),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14375),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14377),
    [anon_sym_LF] = ACTIONS(14379),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14382),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9497] = {
    [sym__comprehension_clause] = STATE(18420),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16801),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14385),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14387),
    [anon_sym_LF] = ACTIONS(14389),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14392),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9498] = {
    [sym__comprehension_clause] = STATE(18457),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16825),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13708),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13710),
    [anon_sym_LF] = ACTIONS(13712),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13715),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9499] = {
    [sym__comprehension_clause] = STATE(18748),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17131),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14228),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14230),
    [anon_sym_LF] = ACTIONS(14232),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14235),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9500] = {
    [sym__comprehension_clause] = STATE(18271),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17127),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13265),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13270),
    [anon_sym_LF] = ACTIONS(13272),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13277),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9501] = {
    [sym__comprehension_clause] = STATE(18965),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17184),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13976),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13978),
    [anon_sym_LF] = ACTIONS(13980),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13983),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9502] = {
    [sym__comprehension_clause] = STATE(18659),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16836),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13786),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13788),
    [anon_sym_LF] = ACTIONS(13790),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13793),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9503] = {
    [sym__comprehension_clause] = STATE(19506),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16813),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13986),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13988),
    [anon_sym_LF] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13993),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9504] = {
    [sym__comprehension_clause] = STATE(19454),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16798),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13996),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13998),
    [anon_sym_LF] = ACTIONS(14000),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14003),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9505] = {
    [sym__comprehension_clause] = STATE(18937),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16748),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14006),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14008),
    [anon_sym_LF] = ACTIONS(14010),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14013),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9506] = {
    [sym__comprehension_clause] = STATE(18583),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17161),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14018),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14020),
    [anon_sym_LF] = ACTIONS(14022),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14025),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9507] = {
    [sym__comprehension_clause] = STATE(19224),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16987),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14028),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14030),
    [anon_sym_LF] = ACTIONS(14032),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14035),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9508] = {
    [sym__comprehension_clause] = STATE(18446),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17226),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13796),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13798),
    [anon_sym_LF] = ACTIONS(13800),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13803),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9509] = {
    [sym__comprehension_clause] = STATE(18846),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16664),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14238),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14240),
    [anon_sym_LF] = ACTIONS(14242),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14245),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9510] = {
    [sym__comprehension_clause] = STATE(18276),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17146),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14188),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14190),
    [anon_sym_LF] = ACTIONS(14192),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14195),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9511] = {
    [sym__comprehension_clause] = STATE(18200),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16927),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14038),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14040),
    [anon_sym_LF] = ACTIONS(14042),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14045),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9512] = {
    [sym__comprehension_clause] = STATE(18949),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16807),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14250),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14252),
    [anon_sym_LF] = ACTIONS(14254),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14257),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9513] = {
    [sym__comprehension_clause] = STATE(18413),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16690),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13808),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13810),
    [anon_sym_LF] = ACTIONS(13812),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13815),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9514] = {
    [sym__comprehension_clause] = STATE(19196),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16787),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13698),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13700),
    [anon_sym_LF] = ACTIONS(13702),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13705),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9515] = {
    [sym__comprehension_clause] = STATE(18697),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16896),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14048),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14050),
    [anon_sym_LF] = ACTIONS(14052),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14055),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9516] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_LT_COLON] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(15228),
    [sym__immediate_command_start] = ACTIONS(15230),
  },
  [9517] = {
    [sym__comprehension_clause] = STATE(19448),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17165),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14058),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14060),
    [anon_sym_LF] = ACTIONS(14062),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14065),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9518] = {
    [sym__comprehension_clause] = STATE(19055),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17072),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14260),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14262),
    [anon_sym_LF] = ACTIONS(14264),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14267),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9519] = {
    [sym__comprehension_clause] = STATE(19088),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17166),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13818),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13820),
    [anon_sym_LF] = ACTIONS(13822),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13825),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9520] = {
    [sym__comprehension_clause] = STATE(18811),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16797),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13920),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13922),
    [anon_sym_LF] = ACTIONS(13924),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13927),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9521] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_LT_COLON] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [9522] = {
    [sym__comprehension_clause] = STATE(18386),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16881),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14068),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14070),
    [anon_sym_LF] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14075),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9523] = {
    [sym__comprehension_clause] = STATE(19033),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16712),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13828),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13830),
    [anon_sym_LF] = ACTIONS(13832),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13835),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9524] = {
    [sym__comprehension_clause] = STATE(18587),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16667),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13732),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13734),
    [anon_sym_LF] = ACTIONS(13736),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13739),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9525] = {
    [sym__comprehension_clause] = STATE(18742),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17281),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14078),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14080),
    [anon_sym_LF] = ACTIONS(14082),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14085),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9526] = {
    [sym__comprehension_clause] = STATE(19045),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16809),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14088),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14090),
    [anon_sym_LF] = ACTIONS(14092),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14095),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9527] = {
    [sym__comprehension_clause] = STATE(19345),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16812),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13838),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13840),
    [anon_sym_LF] = ACTIONS(13842),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13845),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9528] = {
    [sym__comprehension_clause] = STATE(18405),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17195),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14198),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14200),
    [anon_sym_LF] = ACTIONS(14202),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14205),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9529] = {
    [sym__comprehension_clause] = STATE(18619),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16819),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13672),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13674),
    [anon_sym_LF] = ACTIONS(13676),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13679),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9530] = {
    [sym__comprehension_clause] = STATE(18359),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17143),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13900),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13902),
    [anon_sym_LF] = ACTIONS(13904),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13907),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9531] = {
    [sym__comprehension_clause] = STATE(19385),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16839),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14098),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14100),
    [anon_sym_LF] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14105),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9532] = {
    [sym__comprehension_clause] = STATE(18897),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16844),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13471),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13473),
    [anon_sym_LF] = ACTIONS(13475),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13478),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9533] = {
    [sym__comprehension_clause] = STATE(19863),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17303),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14178),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14180),
    [anon_sym_LF] = ACTIONS(14182),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14185),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9534] = {
    [sym__comprehension_clause] = STATE(18332),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17263),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13848),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13850),
    [anon_sym_LF] = ACTIONS(13852),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13855),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9535] = {
    [sym__comprehension_clause] = STATE(19872),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16997),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14108),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14110),
    [anon_sym_LF] = ACTIONS(14112),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14115),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9536] = {
    [sym__comprehension_clause] = STATE(19149),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17246),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14270),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14272),
    [anon_sym_LF] = ACTIONS(14274),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14277),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9537] = {
    [sym__comprehension_clause] = STATE(19500),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16855),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13858),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13860),
    [anon_sym_LF] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13865),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9538] = {
    [sym__comprehension_clause] = STATE(19353),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17286),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14118),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14120),
    [anon_sym_LF] = ACTIONS(14122),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14125),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9539] = {
    [sym__comprehension_clause] = STATE(18486),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16757),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14128),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14130),
    [anon_sym_LF] = ACTIONS(14132),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14135),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9540] = {
    [sym__comprehension_clause] = STATE(19090),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16967),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13750),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13752),
    [anon_sym_LF] = ACTIONS(13754),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13757),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9541] = {
    [sym__comprehension_clause] = STATE(18786),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16910),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14138),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14140),
    [anon_sym_LF] = ACTIONS(14142),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14145),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9542] = {
    [sym__comprehension_clause] = STATE(18850),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17171),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13874),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13876),
    [anon_sym_LF] = ACTIONS(13878),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13881),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9543] = {
    [sym__comprehension_clause] = STATE(19012),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17021),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14148),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14150),
    [anon_sym_LF] = ACTIONS(14152),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14155),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9544] = {
    [sym__comprehension_clause] = STATE(19260),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16665),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14280),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14282),
    [anon_sym_LF] = ACTIONS(14284),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14287),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9545] = {
    [sym__comprehension_clause] = STATE(19191),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17168),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14158),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14160),
    [anon_sym_LF] = ACTIONS(14162),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14165),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9546] = {
    [sym__comprehension_clause] = STATE(19749),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16857),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(13890),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(13892),
    [anon_sym_LF] = ACTIONS(13894),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(13897),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9547] = {
    [sym__comprehension_clause] = STATE(19392),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(16775),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14290),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14292),
    [anon_sym_LF] = ACTIONS(14294),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14297),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9548] = {
    [sym__comprehension_clause] = STATE(19801),
    [sym_for_clause] = STATE(14542),
    [aux_sym_vector_expression_repeat1] = STATE(17122),
    [sym__word_identifier] = ACTIONS(13263),
    [anon_sym_COMMA] = ACTIONS(14322),
    [anon_sym_COLON] = ACTIONS(13263),
    [anon_sym_begin] = ACTIONS(13263),
    [anon_sym_module] = ACTIONS(13263),
    [anon_sym_baremodule] = ACTIONS(13263),
    [anon_sym_abstract] = ACTIONS(13263),
    [anon_sym_primitive] = ACTIONS(13263),
    [anon_sym_mutable] = ACTIONS(13263),
    [anon_sym_struct] = ACTIONS(13263),
    [anon_sym_function] = ACTIONS(13263),
    [anon_sym_macro] = ACTIONS(13263),
    [anon_sym_quote] = ACTIONS(13263),
    [anon_sym_let] = ACTIONS(13263),
    [anon_sym_if] = ACTIONS(13263),
    [anon_sym_try] = ACTIONS(13263),
    [anon_sym_for] = ACTIONS(13267),
    [anon_sym_while] = ACTIONS(13263),
    [sym_break_statement] = ACTIONS(13263),
    [sym_continue_statement] = ACTIONS(13263),
    [anon_sym_return] = ACTIONS(13263),
    [anon_sym_const] = ACTIONS(13263),
    [anon_sym_global] = ACTIONS(13263),
    [anon_sym_local] = ACTIONS(13263),
    [anon_sym_LPAREN] = ACTIONS(13263),
    [anon_sym_export] = ACTIONS(13263),
    [anon_sym_import] = ACTIONS(13263),
    [anon_sym_using] = ACTIONS(13263),
    [anon_sym_LBRACK] = ACTIONS(13263),
    [anon_sym_RBRACK] = ACTIONS(14324),
    [anon_sym_LF] = ACTIONS(14326),
    [anon_sym_LBRACE] = ACTIONS(13263),
    [anon_sym_DOLLAR] = ACTIONS(13263),
    [anon_sym_COLON_COLON] = ACTIONS(13263),
    [anon_sym_AT] = ACTIONS(13263),
    [anon_sym_true] = ACTIONS(13263),
    [anon_sym_false] = ACTIONS(13263),
    [aux_sym_integer_literal_token1] = ACTIONS(13263),
    [aux_sym_integer_literal_token2] = ACTIONS(13263),
    [aux_sym_integer_literal_token3] = ACTIONS(13263),
    [aux_sym_integer_literal_token4] = ACTIONS(13263),
    [aux_sym_float_literal_token1] = ACTIONS(13263),
    [aux_sym_float_literal_token3] = ACTIONS(13263),
    [aux_sym_float_literal_token4] = ACTIONS(13263),
    [sym_character_literal] = ACTIONS(13263),
    [sym__pair_operator] = ACTIONS(13263),
    [sym__arrow_operator] = ACTIONS(13263),
    [sym__comparison_operator] = ACTIONS(13263),
    [sym__pipe_right_operator] = ACTIONS(13263),
    [sym__pipe_left_operator] = ACTIONS(13263),
    [sym__ellipsis_operator] = ACTIONS(13263),
    [sym__plus_operator] = ACTIONS(13263),
    [sym__times_operator] = ACTIONS(13263),
    [sym__rational_operator] = ACTIONS(13263),
    [sym__bitshift_operator] = ACTIONS(13263),
    [sym__power_operator] = ACTIONS(13263),
    [sym__tilde_operator] = ACTIONS(13263),
    [sym__type_order_operator] = ACTIONS(13263),
    [sym__unary_operator] = ACTIONS(13263),
    [sym__unary_plus_operator] = ACTIONS(13263),
    [aux_sym__terminator_token1] = ACTIONS(14329),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13280),
    [sym__command_start] = ACTIONS(13280),
  },
  [9549] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_LT_COLON] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(15232),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [9550] = {
    [sym_where_clause] = STATE(9632),
    [sym_unary_typed_expression] = STATE(9565),
    [sym__word_identifier] = ACTIONS(15175),
    [anon_sym_COLON] = ACTIONS(15175),
    [anon_sym_begin] = ACTIONS(15175),
    [anon_sym_module] = ACTIONS(15175),
    [anon_sym_baremodule] = ACTIONS(15175),
    [anon_sym_end] = ACTIONS(15175),
    [anon_sym_abstract] = ACTIONS(15175),
    [anon_sym_primitive] = ACTIONS(15175),
    [anon_sym_mutable] = ACTIONS(15175),
    [anon_sym_struct] = ACTIONS(15175),
    [anon_sym_function] = ACTIONS(15175),
    [anon_sym_macro] = ACTIONS(15175),
    [anon_sym_where] = ACTIONS(15177),
    [anon_sym_quote] = ACTIONS(15175),
    [anon_sym_let] = ACTIONS(15175),
    [anon_sym_if] = ACTIONS(15175),
    [anon_sym_try] = ACTIONS(15175),
    [anon_sym_for] = ACTIONS(15175),
    [anon_sym_while] = ACTIONS(15175),
    [sym_break_statement] = ACTIONS(15175),
    [sym_continue_statement] = ACTIONS(15175),
    [anon_sym_return] = ACTIONS(15175),
    [anon_sym_const] = ACTIONS(15175),
    [anon_sym_global] = ACTIONS(15175),
    [anon_sym_local] = ACTIONS(15175),
    [anon_sym_LPAREN] = ACTIONS(15175),
    [anon_sym_export] = ACTIONS(15175),
    [anon_sym_import] = ACTIONS(15175),
    [anon_sym_using] = ACTIONS(15175),
    [anon_sym_LBRACK] = ACTIONS(15175),
    [anon_sym_LF] = ACTIONS(15179),
    [anon_sym_LBRACE] = ACTIONS(15175),
    [anon_sym_DOLLAR] = ACTIONS(15175),
    [anon_sym_COLON_COLON] = ACTIONS(15181),
    [anon_sym_AT] = ACTIONS(15175),
    [anon_sym_true] = ACTIONS(15175),
    [anon_sym_false] = ACTIONS(15175),
    [aux_sym_integer_literal_token1] = ACTIONS(15175),
    [aux_sym_integer_literal_token2] = ACTIONS(15175),
    [aux_sym_integer_literal_token3] = ACTIONS(15175),
    [aux_sym_integer_literal_token4] = ACTIONS(15175),
    [aux_sym_float_literal_token1] = ACTIONS(15175),
    [aux_sym_float_literal_token3] = ACTIONS(15175),
    [aux_sym_float_literal_token4] = ACTIONS(15175),
    [sym_character_literal] = ACTIONS(15175),
    [sym__pair_operator] = ACTIONS(15175),
    [sym__arrow_operator] = ACTIONS(15175),
    [sym__comparison_operator] = ACTIONS(15175),
    [sym__pipe_right_operator] = ACTIONS(15175),
    [sym__pipe_left_operator] = ACTIONS(15175),
    [sym__ellipsis_operator] = ACTIONS(15175),
    [sym__plus_operator] = ACTIONS(15175),
    [sym__times_operator] = ACTIONS(15175),
    [sym__rational_operator] = ACTIONS(15175),
    [sym__bitshift_operator] = ACTIONS(15175),
    [sym__power_operator] = ACTIONS(15175),
    [sym__tilde_operator] = ACTIONS(15175),
    [sym__type_order_operator] = ACTIONS(15175),
    [sym__unary_operator] = ACTIONS(15175),
    [sym__unary_plus_operator] = ACTIONS(15175),
    [aux_sym__terminator_token1] = ACTIONS(15175),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(15179),
    [sym__command_start] = ACTIONS(15179),
  },
  [9551] = {
    [sym_identifier] = STATE(9591),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_LT_COLON] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(11994),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [9552] = {
    [sym_identifier] = STATE(9569),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_LT_COLON] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12004),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [9553] = {
    [sym_identifier] = STATE(9570),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_LT_COLON] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12008),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [9554] = {
    [sym_identifier] = STATE(9593),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_LT_COLON] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(11956),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [9555] = {
    [sym__word_identifier] = ACTIONS(12388),
    [anon_sym_COLON] = ACTIONS(12388),
    [anon_sym_begin] = ACTIONS(12388),
    [anon_sym_module] = ACTIONS(12388),
    [anon_sym_baremodule] = ACTIONS(12388),
    [anon_sym_end] = ACTIONS(12388),
    [anon_sym_abstract] = ACTIONS(12388),
    [anon_sym_primitive] = ACTIONS(12388),
    [anon_sym_mutable] = ACTIONS(12388),
    [anon_sym_struct] = ACTIONS(12388),
    [anon_sym_LT_COLON] = ACTIONS(12388),
    [anon_sym_function] = ACTIONS(12388),
    [anon_sym_macro] = ACTIONS(12388),
    [anon_sym_quote] = ACTIONS(12388),
    [anon_sym_let] = ACTIONS(12388),
    [anon_sym_if] = ACTIONS(12388),
    [anon_sym_try] = ACTIONS(12388),
    [anon_sym_for] = ACTIONS(12388),
    [anon_sym_while] = ACTIONS(12388),
    [sym_break_statement] = ACTIONS(12388),
    [sym_continue_statement] = ACTIONS(12388),
    [anon_sym_return] = ACTIONS(12388),
    [anon_sym_const] = ACTIONS(12388),
    [anon_sym_global] = ACTIONS(12388),
    [anon_sym_local] = ACTIONS(12388),
    [anon_sym_LPAREN] = ACTIONS(12388),
    [anon_sym_export] = ACTIONS(12388),
    [anon_sym_import] = ACTIONS(12388),
    [anon_sym_using] = ACTIONS(12388),
    [anon_sym_LBRACK] = ACTIONS(12388),
    [anon_sym_LF] = ACTIONS(12390),
    [anon_sym_LBRACE] = ACTIONS(12388),
    [anon_sym_DOLLAR] = ACTIONS(12388),
    [anon_sym_COLON_COLON] = ACTIONS(12388),
    [anon_sym_AT] = ACTIONS(12388),
    [anon_sym_true] = ACTIONS(12388),
    [anon_sym_false] = ACTIONS(12388),
    [aux_sym_integer_literal_token1] = ACTIONS(12388),
    [aux_sym_integer_literal_token2] = ACTIONS(12388),
    [aux_sym_integer_literal_token3] = ACTIONS(12388),
    [aux_sym_integer_literal_token4] = ACTIONS(12388),
    [aux_sym_float_literal_token1] = ACTIONS(12388),
    [aux_sym_float_literal_token3] = ACTIONS(12388),
    [aux_sym_float_literal_token4] = ACTIONS(12388),
    [sym_character_literal] = ACTIONS(12388),
    [sym__pair_operator] = ACTIONS(12388),
    [sym__arrow_operator] = ACTIONS(12388),
    [sym__comparison_operator] = ACTIONS(12388),
    [sym__pipe_right_operator] = ACTIONS(12388),
    [sym__pipe_left_operator] = ACTIONS(12388),
    [sym__ellipsis_operator] = ACTIONS(12388),
    [sym__plus_operator] = ACTIONS(12388),
    [sym__times_operator] = ACTIONS(12388),
    [sym__rational_operator] = ACTIONS(12388),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12388),
    [sym__tilde_operator] = ACTIONS(12388),
    [sym__type_order_operator] = ACTIONS(12388),
    [sym__unary_operator] = ACTIONS(12388),
    [sym__unary_plus_operator] = ACTIONS(12388),
    [aux_sym__terminator_token1] = ACTIONS(12388),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12390),
    [sym__string_start] = ACTIONS(12390),
    [sym__command_start] = ACTIONS(12390),
  },
  [9556] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_LT_COLON] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12096),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [9557] = {
    [sym__word_identifier] = ACTIONS(12384),
    [anon_sym_COLON] = ACTIONS(12384),
    [anon_sym_begin] = ACTIONS(12384),
    [anon_sym_module] = ACTIONS(12384),
    [anon_sym_baremodule] = ACTIONS(12384),
    [anon_sym_end] = ACTIONS(12384),
    [anon_sym_abstract] = ACTIONS(12384),
    [anon_sym_primitive] = ACTIONS(12384),
    [anon_sym_mutable] = ACTIONS(12384),
    [anon_sym_struct] = ACTIONS(12384),
    [anon_sym_LT_COLON] = ACTIONS(12384),
    [anon_sym_function] = ACTIONS(12384),
    [anon_sym_macro] = ACTIONS(12384),
    [anon_sym_quote] = ACTIONS(12384),
    [anon_sym_let] = ACTIONS(12384),
    [anon_sym_if] = ACTIONS(12384),
    [anon_sym_try] = ACTIONS(12384),
    [anon_sym_for] = ACTIONS(12384),
    [anon_sym_while] = ACTIONS(12384),
    [sym_break_statement] = ACTIONS(12384),
    [sym_continue_statement] = ACTIONS(12384),
    [anon_sym_return] = ACTIONS(12384),
    [anon_sym_const] = ACTIONS(12384),
    [anon_sym_global] = ACTIONS(12384),
    [anon_sym_local] = ACTIONS(12384),
    [anon_sym_LPAREN] = ACTIONS(12384),
    [anon_sym_export] = ACTIONS(12384),
    [anon_sym_import] = ACTIONS(12384),
    [anon_sym_using] = ACTIONS(12384),
    [anon_sym_LBRACK] = ACTIONS(12384),
    [anon_sym_LF] = ACTIONS(12386),
    [anon_sym_LBRACE] = ACTIONS(12384),
    [anon_sym_DOLLAR] = ACTIONS(12384),
    [anon_sym_COLON_COLON] = ACTIONS(12384),
    [anon_sym_AT] = ACTIONS(12384),
    [anon_sym_true] = ACTIONS(12384),
    [anon_sym_false] = ACTIONS(12384),
    [aux_sym_integer_literal_token1] = ACTIONS(12384),
    [aux_sym_integer_literal_token2] = ACTIONS(12384),
    [aux_sym_integer_literal_token3] = ACTIONS(12384),
    [aux_sym_integer_literal_token4] = ACTIONS(12384),
    [aux_sym_float_literal_token1] = ACTIONS(12384),
    [aux_sym_float_literal_token3] = ACTIONS(12384),
    [aux_sym_float_literal_token4] = ACTIONS(12384),
    [sym_character_literal] = ACTIONS(12384),
    [sym__pair_operator] = ACTIONS(12384),
    [sym__arrow_operator] = ACTIONS(12384),
    [sym__comparison_operator] = ACTIONS(12384),
    [sym__pipe_right_operator] = ACTIONS(12384),
    [sym__pipe_left_operator] = ACTIONS(12384),
    [sym__ellipsis_operator] = ACTIONS(12384),
    [sym__plus_operator] = ACTIONS(12384),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12384),
    [sym__bitshift_operator] = ACTIONS(12384),
    [sym__power_operator] = ACTIONS(12384),
    [sym__tilde_operator] = ACTIONS(12384),
    [sym__type_order_operator] = ACTIONS(12384),
    [sym__unary_operator] = ACTIONS(12384),
    [sym__unary_plus_operator] = ACTIONS(12384),
    [aux_sym__terminator_token1] = ACTIONS(12384),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12386),
    [sym__string_start] = ACTIONS(12386),
    [sym__command_start] = ACTIONS(12386),
  },
  [9558] = {
    [sym__word_identifier] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12054),
    [anon_sym_begin] = ACTIONS(12054),
    [anon_sym_module] = ACTIONS(12054),
    [anon_sym_baremodule] = ACTIONS(12054),
    [anon_sym_end] = ACTIONS(12054),
    [anon_sym_abstract] = ACTIONS(12054),
    [anon_sym_primitive] = ACTIONS(12054),
    [anon_sym_mutable] = ACTIONS(12054),
    [anon_sym_struct] = ACTIONS(12054),
    [anon_sym_LT_COLON] = ACTIONS(12054),
    [anon_sym_function] = ACTIONS(12054),
    [anon_sym_macro] = ACTIONS(12054),
    [anon_sym_quote] = ACTIONS(12054),
    [anon_sym_let] = ACTIONS(12054),
    [anon_sym_if] = ACTIONS(12054),
    [anon_sym_try] = ACTIONS(12054),
    [anon_sym_for] = ACTIONS(12054),
    [anon_sym_while] = ACTIONS(12054),
    [sym_break_statement] = ACTIONS(12054),
    [sym_continue_statement] = ACTIONS(12054),
    [anon_sym_return] = ACTIONS(12054),
    [anon_sym_const] = ACTIONS(12054),
    [anon_sym_global] = ACTIONS(12054),
    [anon_sym_local] = ACTIONS(12054),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_export] = ACTIONS(12054),
    [anon_sym_import] = ACTIONS(12054),
    [anon_sym_using] = ACTIONS(12054),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_LF] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12054),
    [anon_sym_false] = ACTIONS(12054),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12054),
    [aux_sym_integer_literal_token4] = ACTIONS(12054),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12054),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12054),
    [sym__plus_operator] = ACTIONS(12054),
    [sym__times_operator] = ACTIONS(12054),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12054),
    [sym__unary_plus_operator] = ACTIONS(12054),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12052),
    [sym__string_start] = ACTIONS(12052),
    [sym__command_start] = ACTIONS(12052),
  },
  [9559] = {
    [sym__word_identifier] = ACTIONS(12268),
    [anon_sym_COLON] = ACTIONS(12268),
    [anon_sym_begin] = ACTIONS(12268),
    [anon_sym_module] = ACTIONS(12268),
    [anon_sym_baremodule] = ACTIONS(12268),
    [anon_sym_end] = ACTIONS(12268),
    [anon_sym_abstract] = ACTIONS(12268),
    [anon_sym_primitive] = ACTIONS(12268),
    [anon_sym_mutable] = ACTIONS(12268),
    [anon_sym_struct] = ACTIONS(12268),
    [anon_sym_LT_COLON] = ACTIONS(12268),
    [anon_sym_function] = ACTIONS(12268),
    [anon_sym_macro] = ACTIONS(12268),
    [anon_sym_quote] = ACTIONS(12268),
    [anon_sym_let] = ACTIONS(12268),
    [anon_sym_if] = ACTIONS(12268),
    [anon_sym_try] = ACTIONS(12268),
    [anon_sym_for] = ACTIONS(12268),
    [anon_sym_while] = ACTIONS(12268),
    [sym_break_statement] = ACTIONS(12268),
    [sym_continue_statement] = ACTIONS(12268),
    [anon_sym_return] = ACTIONS(12268),
    [anon_sym_const] = ACTIONS(12268),
    [anon_sym_global] = ACTIONS(12268),
    [anon_sym_local] = ACTIONS(12268),
    [anon_sym_LPAREN] = ACTIONS(12268),
    [anon_sym_export] = ACTIONS(12268),
    [anon_sym_import] = ACTIONS(12268),
    [anon_sym_using] = ACTIONS(12268),
    [anon_sym_LBRACK] = ACTIONS(12268),
    [anon_sym_LF] = ACTIONS(12266),
    [anon_sym_LBRACE] = ACTIONS(12268),
    [anon_sym_DOLLAR] = ACTIONS(12268),
    [anon_sym_COLON_COLON] = ACTIONS(12268),
    [anon_sym_AT] = ACTIONS(12268),
    [anon_sym_true] = ACTIONS(12268),
    [anon_sym_false] = ACTIONS(12268),
    [aux_sym_integer_literal_token1] = ACTIONS(12268),
    [aux_sym_integer_literal_token2] = ACTIONS(12268),
    [aux_sym_integer_literal_token3] = ACTIONS(12268),
    [aux_sym_integer_literal_token4] = ACTIONS(12268),
    [aux_sym_float_literal_token1] = ACTIONS(12268),
    [aux_sym_float_literal_token3] = ACTIONS(12268),
    [aux_sym_float_literal_token4] = ACTIONS(12268),
    [sym_character_literal] = ACTIONS(12268),
    [sym__pair_operator] = ACTIONS(12268),
    [sym__arrow_operator] = ACTIONS(12268),
    [sym__comparison_operator] = ACTIONS(12268),
    [sym__pipe_right_operator] = ACTIONS(12268),
    [sym__pipe_left_operator] = ACTIONS(12268),
    [sym__ellipsis_operator] = ACTIONS(12268),
    [sym__plus_operator] = ACTIONS(12268),
    [sym__times_operator] = ACTIONS(12268),
    [sym__rational_operator] = ACTIONS(12268),
    [sym__bitshift_operator] = ACTIONS(12268),
    [sym__power_operator] = ACTIONS(12268),
    [sym__tilde_operator] = ACTIONS(12268),
    [sym__type_order_operator] = ACTIONS(12268),
    [sym__unary_operator] = ACTIONS(12268),
    [sym__unary_plus_operator] = ACTIONS(12268),
    [aux_sym__terminator_token1] = ACTIONS(12268),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12266),
    [sym__string_start] = ACTIONS(12266),
    [sym__command_start] = ACTIONS(12266),
  },
  [9560] = {
    [sym__word_identifier] = ACTIONS(12058),
    [anon_sym_COLON] = ACTIONS(12058),
    [anon_sym_begin] = ACTIONS(12058),
    [anon_sym_module] = ACTIONS(12058),
    [anon_sym_baremodule] = ACTIONS(12058),
    [anon_sym_end] = ACTIONS(12058),
    [anon_sym_abstract] = ACTIONS(12058),
    [anon_sym_primitive] = ACTIONS(12058),
    [anon_sym_mutable] = ACTIONS(12058),
    [anon_sym_struct] = ACTIONS(12058),
    [anon_sym_LT_COLON] = ACTIONS(12058),
    [anon_sym_function] = ACTIONS(12058),
    [anon_sym_macro] = ACTIONS(12058),
    [anon_sym_quote] = ACTIONS(12058),
    [anon_sym_let] = ACTIONS(12058),
    [anon_sym_if] = ACTIONS(12058),
    [anon_sym_try] = ACTIONS(12058),
    [anon_sym_for] = ACTIONS(12058),
    [anon_sym_while] = ACTIONS(12058),
    [sym_break_statement] = ACTIONS(12058),
    [sym_continue_statement] = ACTIONS(12058),
    [anon_sym_return] = ACTIONS(12058),
    [anon_sym_const] = ACTIONS(12058),
    [anon_sym_global] = ACTIONS(12058),
    [anon_sym_local] = ACTIONS(12058),
    [anon_sym_LPAREN] = ACTIONS(12058),
    [anon_sym_export] = ACTIONS(12058),
    [anon_sym_import] = ACTIONS(12058),
    [anon_sym_using] = ACTIONS(12058),
    [anon_sym_LBRACK] = ACTIONS(12058),
    [anon_sym_LF] = ACTIONS(12056),
    [anon_sym_LBRACE] = ACTIONS(12058),
    [anon_sym_DOLLAR] = ACTIONS(12058),
    [anon_sym_COLON_COLON] = ACTIONS(12058),
    [anon_sym_AT] = ACTIONS(12058),
    [anon_sym_true] = ACTIONS(12058),
    [anon_sym_false] = ACTIONS(12058),
    [aux_sym_integer_literal_token1] = ACTIONS(12058),
    [aux_sym_integer_literal_token2] = ACTIONS(12058),
    [aux_sym_integer_literal_token3] = ACTIONS(12058),
    [aux_sym_integer_literal_token4] = ACTIONS(12058),
    [aux_sym_float_literal_token1] = ACTIONS(12058),
    [aux_sym_float_literal_token3] = ACTIONS(12058),
    [aux_sym_float_literal_token4] = ACTIONS(12058),
    [sym_character_literal] = ACTIONS(12058),
    [sym__pair_operator] = ACTIONS(12058),
    [sym__arrow_operator] = ACTIONS(12058),
    [sym__comparison_operator] = ACTIONS(12058),
    [sym__pipe_right_operator] = ACTIONS(12058),
    [sym__pipe_left_operator] = ACTIONS(12058),
    [sym__ellipsis_operator] = ACTIONS(12058),
    [sym__plus_operator] = ACTIONS(12058),
    [sym__times_operator] = ACTIONS(12058),
    [sym__rational_operator] = ACTIONS(12058),
    [sym__bitshift_operator] = ACTIONS(12058),
    [sym__power_operator] = ACTIONS(12058),
    [sym__tilde_operator] = ACTIONS(12058),
    [sym__type_order_operator] = ACTIONS(12058),
    [sym__unary_operator] = ACTIONS(12058),
    [sym__unary_plus_operator] = ACTIONS(12058),
    [aux_sym__terminator_token1] = ACTIONS(12058),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12056),
    [sym__string_start] = ACTIONS(12056),
    [sym__command_start] = ACTIONS(12056),
  },
  [9561] = {
    [sym__word_identifier] = ACTIONS(12272),
    [anon_sym_COLON] = ACTIONS(12272),
    [anon_sym_begin] = ACTIONS(12272),
    [anon_sym_module] = ACTIONS(12272),
    [anon_sym_baremodule] = ACTIONS(12272),
    [anon_sym_end] = ACTIONS(12272),
    [anon_sym_abstract] = ACTIONS(12272),
    [anon_sym_primitive] = ACTIONS(12272),
    [anon_sym_mutable] = ACTIONS(12272),
    [anon_sym_struct] = ACTIONS(12272),
    [anon_sym_LT_COLON] = ACTIONS(12272),
    [anon_sym_function] = ACTIONS(12272),
    [anon_sym_macro] = ACTIONS(12272),
    [anon_sym_quote] = ACTIONS(12272),
    [anon_sym_let] = ACTIONS(12272),
    [anon_sym_if] = ACTIONS(12272),
    [anon_sym_try] = ACTIONS(12272),
    [anon_sym_for] = ACTIONS(12272),
    [anon_sym_while] = ACTIONS(12272),
    [sym_break_statement] = ACTIONS(12272),
    [sym_continue_statement] = ACTIONS(12272),
    [anon_sym_return] = ACTIONS(12272),
    [anon_sym_const] = ACTIONS(12272),
    [anon_sym_global] = ACTIONS(12272),
    [anon_sym_local] = ACTIONS(12272),
    [anon_sym_LPAREN] = ACTIONS(12272),
    [anon_sym_export] = ACTIONS(12272),
    [anon_sym_import] = ACTIONS(12272),
    [anon_sym_using] = ACTIONS(12272),
    [anon_sym_LBRACK] = ACTIONS(12272),
    [anon_sym_LF] = ACTIONS(12270),
    [anon_sym_LBRACE] = ACTIONS(12272),
    [anon_sym_DOLLAR] = ACTIONS(12272),
    [anon_sym_COLON_COLON] = ACTIONS(12272),
    [anon_sym_AT] = ACTIONS(12272),
    [anon_sym_true] = ACTIONS(12272),
    [anon_sym_false] = ACTIONS(12272),
    [aux_sym_integer_literal_token1] = ACTIONS(12272),
    [aux_sym_integer_literal_token2] = ACTIONS(12272),
    [aux_sym_integer_literal_token3] = ACTIONS(12272),
    [aux_sym_integer_literal_token4] = ACTIONS(12272),
    [aux_sym_float_literal_token1] = ACTIONS(12272),
    [aux_sym_float_literal_token3] = ACTIONS(12272),
    [aux_sym_float_literal_token4] = ACTIONS(12272),
    [sym_character_literal] = ACTIONS(12272),
    [sym__pair_operator] = ACTIONS(12272),
    [sym__arrow_operator] = ACTIONS(12272),
    [sym__comparison_operator] = ACTIONS(12272),
    [sym__pipe_right_operator] = ACTIONS(12272),
    [sym__pipe_left_operator] = ACTIONS(12272),
    [sym__ellipsis_operator] = ACTIONS(12272),
    [sym__plus_operator] = ACTIONS(12272),
    [sym__times_operator] = ACTIONS(12272),
    [sym__rational_operator] = ACTIONS(12272),
    [sym__bitshift_operator] = ACTIONS(12272),
    [sym__power_operator] = ACTIONS(12272),
    [sym__tilde_operator] = ACTIONS(12272),
    [sym__type_order_operator] = ACTIONS(12272),
    [sym__unary_operator] = ACTIONS(12272),
    [sym__unary_plus_operator] = ACTIONS(12272),
    [aux_sym__terminator_token1] = ACTIONS(12272),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12270),
    [sym__string_start] = ACTIONS(12270),
    [sym__command_start] = ACTIONS(12270),
  },
  [9562] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_LT_COLON] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12302),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [9563] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_LT_COLON] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(11894),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
  },
  [9564] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_LT_COLON] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(11864),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
  },
  [9565] = {
    [sym_where_clause] = STATE(9623),
    [sym__word_identifier] = ACTIONS(15234),
    [anon_sym_COLON] = ACTIONS(15234),
    [anon_sym_begin] = ACTIONS(15234),
    [anon_sym_module] = ACTIONS(15234),
    [anon_sym_baremodule] = ACTIONS(15234),
    [anon_sym_end] = ACTIONS(15234),
    [anon_sym_abstract] = ACTIONS(15234),
    [anon_sym_primitive] = ACTIONS(15234),
    [anon_sym_mutable] = ACTIONS(15234),
    [anon_sym_struct] = ACTIONS(15234),
    [anon_sym_function] = ACTIONS(15234),
    [anon_sym_macro] = ACTIONS(15234),
    [anon_sym_where] = ACTIONS(15177),
    [anon_sym_quote] = ACTIONS(15234),
    [anon_sym_let] = ACTIONS(15234),
    [anon_sym_if] = ACTIONS(15234),
    [anon_sym_try] = ACTIONS(15234),
    [anon_sym_for] = ACTIONS(15234),
    [anon_sym_while] = ACTIONS(15234),
    [sym_break_statement] = ACTIONS(15234),
    [sym_continue_statement] = ACTIONS(15234),
    [anon_sym_return] = ACTIONS(15234),
    [anon_sym_const] = ACTIONS(15234),
    [anon_sym_global] = ACTIONS(15234),
    [anon_sym_local] = ACTIONS(15234),
    [anon_sym_LPAREN] = ACTIONS(15234),
    [anon_sym_export] = ACTIONS(15234),
    [anon_sym_import] = ACTIONS(15234),
    [anon_sym_using] = ACTIONS(15234),
    [anon_sym_LBRACK] = ACTIONS(15234),
    [anon_sym_LF] = ACTIONS(15236),
    [anon_sym_LBRACE] = ACTIONS(15234),
    [anon_sym_DOLLAR] = ACTIONS(15234),
    [anon_sym_COLON_COLON] = ACTIONS(15234),
    [anon_sym_AT] = ACTIONS(15234),
    [anon_sym_true] = ACTIONS(15234),
    [anon_sym_false] = ACTIONS(15234),
    [aux_sym_integer_literal_token1] = ACTIONS(15234),
    [aux_sym_integer_literal_token2] = ACTIONS(15234),
    [aux_sym_integer_literal_token3] = ACTIONS(15234),
    [aux_sym_integer_literal_token4] = ACTIONS(15234),
    [aux_sym_float_literal_token1] = ACTIONS(15234),
    [aux_sym_float_literal_token3] = ACTIONS(15234),
    [aux_sym_float_literal_token4] = ACTIONS(15234),
    [sym_character_literal] = ACTIONS(15234),
    [sym__pair_operator] = ACTIONS(15234),
    [sym__arrow_operator] = ACTIONS(15234),
    [sym__comparison_operator] = ACTIONS(15234),
    [sym__pipe_right_operator] = ACTIONS(15234),
    [sym__pipe_left_operator] = ACTIONS(15234),
    [sym__ellipsis_operator] = ACTIONS(15234),
    [sym__plus_operator] = ACTIONS(15234),
    [sym__times_operator] = ACTIONS(15234),
    [sym__rational_operator] = ACTIONS(15234),
    [sym__bitshift_operator] = ACTIONS(15234),
    [sym__power_operator] = ACTIONS(15234),
    [sym__tilde_operator] = ACTIONS(15234),
    [sym__type_order_operator] = ACTIONS(15234),
    [sym__unary_operator] = ACTIONS(15234),
    [sym__unary_plus_operator] = ACTIONS(15234),
    [aux_sym__terminator_token1] = ACTIONS(15234),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(15236),
    [sym__command_start] = ACTIONS(15236),
  },
  [9566] = {
    [sym__word_identifier] = ACTIONS(12070),
    [anon_sym_COLON] = ACTIONS(12070),
    [anon_sym_begin] = ACTIONS(12070),
    [anon_sym_module] = ACTIONS(12070),
    [anon_sym_baremodule] = ACTIONS(12070),
    [anon_sym_end] = ACTIONS(12070),
    [anon_sym_abstract] = ACTIONS(12070),
    [anon_sym_primitive] = ACTIONS(12070),
    [anon_sym_mutable] = ACTIONS(12070),
    [anon_sym_struct] = ACTIONS(12070),
    [anon_sym_LT_COLON] = ACTIONS(12070),
    [anon_sym_function] = ACTIONS(12070),
    [anon_sym_macro] = ACTIONS(12070),
    [anon_sym_quote] = ACTIONS(12070),
    [anon_sym_let] = ACTIONS(12070),
    [anon_sym_if] = ACTIONS(12070),
    [anon_sym_try] = ACTIONS(12070),
    [anon_sym_for] = ACTIONS(12070),
    [anon_sym_while] = ACTIONS(12070),
    [sym_break_statement] = ACTIONS(12070),
    [sym_continue_statement] = ACTIONS(12070),
    [anon_sym_return] = ACTIONS(12070),
    [anon_sym_const] = ACTIONS(12070),
    [anon_sym_global] = ACTIONS(12070),
    [anon_sym_local] = ACTIONS(12070),
    [anon_sym_LPAREN] = ACTIONS(12070),
    [anon_sym_export] = ACTIONS(12070),
    [anon_sym_import] = ACTIONS(12070),
    [anon_sym_using] = ACTIONS(12070),
    [anon_sym_LBRACK] = ACTIONS(12070),
    [anon_sym_LF] = ACTIONS(12068),
    [anon_sym_LBRACE] = ACTIONS(12070),
    [anon_sym_DOLLAR] = ACTIONS(12070),
    [anon_sym_COLON_COLON] = ACTIONS(12070),
    [anon_sym_AT] = ACTIONS(12070),
    [anon_sym_true] = ACTIONS(12070),
    [anon_sym_false] = ACTIONS(12070),
    [aux_sym_integer_literal_token1] = ACTIONS(12070),
    [aux_sym_integer_literal_token2] = ACTIONS(12070),
    [aux_sym_integer_literal_token3] = ACTIONS(12070),
    [aux_sym_integer_literal_token4] = ACTIONS(12070),
    [aux_sym_float_literal_token1] = ACTIONS(12070),
    [aux_sym_float_literal_token3] = ACTIONS(12070),
    [aux_sym_float_literal_token4] = ACTIONS(12070),
    [sym_character_literal] = ACTIONS(12070),
    [sym__pair_operator] = ACTIONS(12070),
    [sym__arrow_operator] = ACTIONS(12070),
    [sym__comparison_operator] = ACTIONS(12070),
    [sym__pipe_right_operator] = ACTIONS(12070),
    [sym__pipe_left_operator] = ACTIONS(12070),
    [sym__ellipsis_operator] = ACTIONS(12070),
    [sym__plus_operator] = ACTIONS(12070),
    [sym__times_operator] = ACTIONS(12070),
    [sym__rational_operator] = ACTIONS(12070),
    [sym__bitshift_operator] = ACTIONS(12070),
    [sym__power_operator] = ACTIONS(12070),
    [sym__tilde_operator] = ACTIONS(12070),
    [sym__type_order_operator] = ACTIONS(12070),
    [sym__unary_operator] = ACTIONS(12070),
    [sym__unary_plus_operator] = ACTIONS(12070),
    [aux_sym__terminator_token1] = ACTIONS(12070),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12068),
    [sym__string_start] = ACTIONS(12068),
    [sym__command_start] = ACTIONS(12068),
  },
  [9567] = {
    [sym__word_identifier] = ACTIONS(12244),
    [anon_sym_COLON] = ACTIONS(12244),
    [anon_sym_begin] = ACTIONS(12244),
    [anon_sym_module] = ACTIONS(12244),
    [anon_sym_baremodule] = ACTIONS(12244),
    [anon_sym_end] = ACTIONS(12244),
    [anon_sym_abstract] = ACTIONS(12244),
    [anon_sym_primitive] = ACTIONS(12244),
    [anon_sym_mutable] = ACTIONS(12244),
    [anon_sym_struct] = ACTIONS(12244),
    [anon_sym_LT_COLON] = ACTIONS(12244),
    [anon_sym_function] = ACTIONS(12244),
    [anon_sym_macro] = ACTIONS(12244),
    [anon_sym_quote] = ACTIONS(12244),
    [anon_sym_let] = ACTIONS(12244),
    [anon_sym_if] = ACTIONS(12244),
    [anon_sym_try] = ACTIONS(12244),
    [anon_sym_for] = ACTIONS(12244),
    [anon_sym_while] = ACTIONS(12244),
    [sym_break_statement] = ACTIONS(12244),
    [sym_continue_statement] = ACTIONS(12244),
    [anon_sym_return] = ACTIONS(12244),
    [anon_sym_const] = ACTIONS(12244),
    [anon_sym_global] = ACTIONS(12244),
    [anon_sym_local] = ACTIONS(12244),
    [anon_sym_LPAREN] = ACTIONS(12244),
    [anon_sym_export] = ACTIONS(12244),
    [anon_sym_import] = ACTIONS(12244),
    [anon_sym_using] = ACTIONS(12244),
    [anon_sym_LBRACK] = ACTIONS(12244),
    [anon_sym_LF] = ACTIONS(12242),
    [anon_sym_LBRACE] = ACTIONS(12244),
    [anon_sym_DOLLAR] = ACTIONS(12244),
    [anon_sym_COLON_COLON] = ACTIONS(12244),
    [anon_sym_AT] = ACTIONS(12244),
    [anon_sym_true] = ACTIONS(12244),
    [anon_sym_false] = ACTIONS(12244),
    [aux_sym_integer_literal_token1] = ACTIONS(12244),
    [aux_sym_integer_literal_token2] = ACTIONS(12244),
    [aux_sym_integer_literal_token3] = ACTIONS(12244),
    [aux_sym_integer_literal_token4] = ACTIONS(12244),
    [aux_sym_float_literal_token1] = ACTIONS(12244),
    [aux_sym_float_literal_token3] = ACTIONS(12244),
    [aux_sym_float_literal_token4] = ACTIONS(12244),
    [sym_character_literal] = ACTIONS(12244),
    [sym__pair_operator] = ACTIONS(12244),
    [sym__arrow_operator] = ACTIONS(12244),
    [sym__comparison_operator] = ACTIONS(12244),
    [sym__pipe_right_operator] = ACTIONS(12244),
    [sym__pipe_left_operator] = ACTIONS(12244),
    [sym__ellipsis_operator] = ACTIONS(12244),
    [sym__plus_operator] = ACTIONS(12244),
    [sym__times_operator] = ACTIONS(12244),
    [sym__rational_operator] = ACTIONS(12244),
    [sym__bitshift_operator] = ACTIONS(12244),
    [sym__power_operator] = ACTIONS(12244),
    [sym__tilde_operator] = ACTIONS(12244),
    [sym__type_order_operator] = ACTIONS(12244),
    [sym__unary_operator] = ACTIONS(12244),
    [sym__unary_plus_operator] = ACTIONS(12244),
    [aux_sym__terminator_token1] = ACTIONS(12244),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12242),
    [sym__string_start] = ACTIONS(12242),
    [sym__command_start] = ACTIONS(12242),
  },
  [9568] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_LT_COLON] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12290),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [9569] = {
    [sym__word_identifier] = ACTIONS(12158),
    [anon_sym_COLON] = ACTIONS(12158),
    [anon_sym_begin] = ACTIONS(12158),
    [anon_sym_module] = ACTIONS(12158),
    [anon_sym_baremodule] = ACTIONS(12158),
    [anon_sym_end] = ACTIONS(12158),
    [anon_sym_abstract] = ACTIONS(12158),
    [anon_sym_primitive] = ACTIONS(12158),
    [anon_sym_mutable] = ACTIONS(12158),
    [anon_sym_struct] = ACTIONS(12158),
    [anon_sym_LT_COLON] = ACTIONS(12158),
    [anon_sym_function] = ACTIONS(12158),
    [anon_sym_macro] = ACTIONS(12158),
    [anon_sym_quote] = ACTIONS(12158),
    [anon_sym_let] = ACTIONS(12158),
    [anon_sym_if] = ACTIONS(12158),
    [anon_sym_try] = ACTIONS(12158),
    [anon_sym_for] = ACTIONS(12158),
    [anon_sym_while] = ACTIONS(12158),
    [sym_break_statement] = ACTIONS(12158),
    [sym_continue_statement] = ACTIONS(12158),
    [anon_sym_return] = ACTIONS(12158),
    [anon_sym_const] = ACTIONS(12158),
    [anon_sym_global] = ACTIONS(12158),
    [anon_sym_local] = ACTIONS(12158),
    [anon_sym_LPAREN] = ACTIONS(12158),
    [anon_sym_export] = ACTIONS(12158),
    [anon_sym_import] = ACTIONS(12158),
    [anon_sym_using] = ACTIONS(12158),
    [anon_sym_LBRACK] = ACTIONS(12158),
    [anon_sym_LF] = ACTIONS(12156),
    [anon_sym_LBRACE] = ACTIONS(12158),
    [anon_sym_DOLLAR] = ACTIONS(12158),
    [anon_sym_COLON_COLON] = ACTIONS(12158),
    [anon_sym_AT] = ACTIONS(12158),
    [anon_sym_true] = ACTIONS(12158),
    [anon_sym_false] = ACTIONS(12158),
    [aux_sym_integer_literal_token1] = ACTIONS(12158),
    [aux_sym_integer_literal_token2] = ACTIONS(12158),
    [aux_sym_integer_literal_token3] = ACTIONS(12158),
    [aux_sym_integer_literal_token4] = ACTIONS(12158),
    [aux_sym_float_literal_token1] = ACTIONS(12158),
    [aux_sym_float_literal_token3] = ACTIONS(12158),
    [aux_sym_float_literal_token4] = ACTIONS(12158),
    [sym_character_literal] = ACTIONS(12158),
    [sym__pair_operator] = ACTIONS(12158),
    [sym__arrow_operator] = ACTIONS(12158),
    [sym__comparison_operator] = ACTIONS(12158),
    [sym__pipe_right_operator] = ACTIONS(12158),
    [sym__pipe_left_operator] = ACTIONS(12158),
    [sym__ellipsis_operator] = ACTIONS(12158),
    [sym__plus_operator] = ACTIONS(12158),
    [sym__times_operator] = ACTIONS(12158),
    [sym__rational_operator] = ACTIONS(12158),
    [sym__bitshift_operator] = ACTIONS(12158),
    [sym__power_operator] = ACTIONS(12158),
    [sym__tilde_operator] = ACTIONS(12158),
    [sym__type_order_operator] = ACTIONS(12158),
    [sym__unary_operator] = ACTIONS(12158),
    [sym__unary_plus_operator] = ACTIONS(12158),
    [aux_sym__terminator_token1] = ACTIONS(12158),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12156),
    [sym__string_start] = ACTIONS(12156),
    [sym__command_start] = ACTIONS(12156),
  },
  [9570] = {
    [sym__word_identifier] = ACTIONS(12162),
    [anon_sym_COLON] = ACTIONS(12162),
    [anon_sym_begin] = ACTIONS(12162),
    [anon_sym_module] = ACTIONS(12162),
    [anon_sym_baremodule] = ACTIONS(12162),
    [anon_sym_end] = ACTIONS(12162),
    [anon_sym_abstract] = ACTIONS(12162),
    [anon_sym_primitive] = ACTIONS(12162),
    [anon_sym_mutable] = ACTIONS(12162),
    [anon_sym_struct] = ACTIONS(12162),
    [anon_sym_LT_COLON] = ACTIONS(12162),
    [anon_sym_function] = ACTIONS(12162),
    [anon_sym_macro] = ACTIONS(12162),
    [anon_sym_quote] = ACTIONS(12162),
    [anon_sym_let] = ACTIONS(12162),
    [anon_sym_if] = ACTIONS(12162),
    [anon_sym_try] = ACTIONS(12162),
    [anon_sym_for] = ACTIONS(12162),
    [anon_sym_while] = ACTIONS(12162),
    [sym_break_statement] = ACTIONS(12162),
    [sym_continue_statement] = ACTIONS(12162),
    [anon_sym_return] = ACTIONS(12162),
    [anon_sym_const] = ACTIONS(12162),
    [anon_sym_global] = ACTIONS(12162),
    [anon_sym_local] = ACTIONS(12162),
    [anon_sym_LPAREN] = ACTIONS(12162),
    [anon_sym_export] = ACTIONS(12162),
    [anon_sym_import] = ACTIONS(12162),
    [anon_sym_using] = ACTIONS(12162),
    [anon_sym_LBRACK] = ACTIONS(12162),
    [anon_sym_LF] = ACTIONS(12160),
    [anon_sym_LBRACE] = ACTIONS(12162),
    [anon_sym_DOLLAR] = ACTIONS(12162),
    [anon_sym_COLON_COLON] = ACTIONS(12162),
    [anon_sym_AT] = ACTIONS(12162),
    [anon_sym_true] = ACTIONS(12162),
    [anon_sym_false] = ACTIONS(12162),
    [aux_sym_integer_literal_token1] = ACTIONS(12162),
    [aux_sym_integer_literal_token2] = ACTIONS(12162),
    [aux_sym_integer_literal_token3] = ACTIONS(12162),
    [aux_sym_integer_literal_token4] = ACTIONS(12162),
    [aux_sym_float_literal_token1] = ACTIONS(12162),
    [aux_sym_float_literal_token3] = ACTIONS(12162),
    [aux_sym_float_literal_token4] = ACTIONS(12162),
    [sym_character_literal] = ACTIONS(12162),
    [sym__pair_operator] = ACTIONS(12162),
    [sym__arrow_operator] = ACTIONS(12162),
    [sym__comparison_operator] = ACTIONS(12162),
    [sym__pipe_right_operator] = ACTIONS(12162),
    [sym__pipe_left_operator] = ACTIONS(12162),
    [sym__ellipsis_operator] = ACTIONS(12162),
    [sym__plus_operator] = ACTIONS(12162),
    [sym__times_operator] = ACTIONS(12162),
    [sym__rational_operator] = ACTIONS(12162),
    [sym__bitshift_operator] = ACTIONS(12162),
    [sym__power_operator] = ACTIONS(12162),
    [sym__tilde_operator] = ACTIONS(12162),
    [sym__type_order_operator] = ACTIONS(12162),
    [sym__unary_operator] = ACTIONS(12162),
    [sym__unary_plus_operator] = ACTIONS(12162),
    [aux_sym__terminator_token1] = ACTIONS(12162),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12160),
    [sym__string_start] = ACTIONS(12160),
    [sym__command_start] = ACTIONS(12160),
  },
  [9571] = {
    [sym__word_identifier] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11866),
    [anon_sym_module] = ACTIONS(11866),
    [anon_sym_baremodule] = ACTIONS(11866),
    [anon_sym_end] = ACTIONS(11866),
    [anon_sym_abstract] = ACTIONS(11866),
    [anon_sym_primitive] = ACTIONS(11866),
    [anon_sym_mutable] = ACTIONS(11866),
    [anon_sym_struct] = ACTIONS(11866),
    [anon_sym_function] = ACTIONS(11866),
    [anon_sym_macro] = ACTIONS(11866),
    [anon_sym_quote] = ACTIONS(11866),
    [anon_sym_let] = ACTIONS(11866),
    [anon_sym_if] = ACTIONS(11866),
    [anon_sym_try] = ACTIONS(11866),
    [anon_sym_for] = ACTIONS(11866),
    [anon_sym_while] = ACTIONS(11866),
    [sym_break_statement] = ACTIONS(11866),
    [sym_continue_statement] = ACTIONS(11866),
    [anon_sym_return] = ACTIONS(11866),
    [anon_sym_const] = ACTIONS(11866),
    [anon_sym_global] = ACTIONS(11866),
    [anon_sym_local] = ACTIONS(11866),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_export] = ACTIONS(11866),
    [anon_sym_import] = ACTIONS(11866),
    [anon_sym_using] = ACTIONS(11866),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_LF] = ACTIONS(11864),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON_COLON] = ACTIONS(11866),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11866),
    [anon_sym_false] = ACTIONS(11866),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11866),
    [aux_sym_integer_literal_token4] = ACTIONS(11866),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(11866),
    [sym__pipe_right_operator] = ACTIONS(11866),
    [sym__pipe_left_operator] = ACTIONS(11866),
    [sym__ellipsis_operator] = ACTIONS(11866),
    [sym__plus_operator] = ACTIONS(11866),
    [sym__times_operator] = ACTIONS(11866),
    [sym__rational_operator] = ACTIONS(11866),
    [sym__bitshift_operator] = ACTIONS(11866),
    [sym__power_operator] = ACTIONS(11866),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(11866),
    [sym__unary_operator] = ACTIONS(11866),
    [sym__unary_plus_operator] = ACTIONS(11866),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11864),
    [sym__command_start] = ACTIONS(11864),
    [sym__immediate_string_start] = ACTIONS(11864),
    [sym__immediate_command_start] = ACTIONS(11864),
  },
  [9572] = {
    [sym__word_identifier] = ACTIONS(12284),
    [anon_sym_COLON] = ACTIONS(12284),
    [anon_sym_begin] = ACTIONS(12284),
    [anon_sym_module] = ACTIONS(12284),
    [anon_sym_baremodule] = ACTIONS(12284),
    [anon_sym_end] = ACTIONS(12284),
    [anon_sym_abstract] = ACTIONS(12284),
    [anon_sym_primitive] = ACTIONS(12284),
    [anon_sym_mutable] = ACTIONS(12284),
    [anon_sym_struct] = ACTIONS(12284),
    [anon_sym_LT_COLON] = ACTIONS(12284),
    [anon_sym_function] = ACTIONS(12284),
    [anon_sym_macro] = ACTIONS(12284),
    [anon_sym_quote] = ACTIONS(12284),
    [anon_sym_let] = ACTIONS(12284),
    [anon_sym_if] = ACTIONS(12284),
    [anon_sym_try] = ACTIONS(12284),
    [anon_sym_for] = ACTIONS(12284),
    [anon_sym_while] = ACTIONS(12284),
    [sym_break_statement] = ACTIONS(12284),
    [sym_continue_statement] = ACTIONS(12284),
    [anon_sym_return] = ACTIONS(12284),
    [anon_sym_const] = ACTIONS(12284),
    [anon_sym_global] = ACTIONS(12284),
    [anon_sym_local] = ACTIONS(12284),
    [anon_sym_LPAREN] = ACTIONS(12284),
    [anon_sym_export] = ACTIONS(12284),
    [anon_sym_import] = ACTIONS(12284),
    [anon_sym_using] = ACTIONS(12284),
    [anon_sym_LBRACK] = ACTIONS(12284),
    [anon_sym_LF] = ACTIONS(12282),
    [anon_sym_LBRACE] = ACTIONS(12284),
    [anon_sym_DOLLAR] = ACTIONS(12284),
    [anon_sym_COLON_COLON] = ACTIONS(12284),
    [anon_sym_AT] = ACTIONS(12284),
    [anon_sym_true] = ACTIONS(12284),
    [anon_sym_false] = ACTIONS(12284),
    [aux_sym_integer_literal_token1] = ACTIONS(12284),
    [aux_sym_integer_literal_token2] = ACTIONS(12284),
    [aux_sym_integer_literal_token3] = ACTIONS(12284),
    [aux_sym_integer_literal_token4] = ACTIONS(12284),
    [aux_sym_float_literal_token1] = ACTIONS(12284),
    [aux_sym_float_literal_token3] = ACTIONS(12284),
    [aux_sym_float_literal_token4] = ACTIONS(12284),
    [sym_character_literal] = ACTIONS(12284),
    [sym__pair_operator] = ACTIONS(12284),
    [sym__arrow_operator] = ACTIONS(12284),
    [sym__comparison_operator] = ACTIONS(12284),
    [sym__pipe_right_operator] = ACTIONS(12284),
    [sym__pipe_left_operator] = ACTIONS(12284),
    [sym__ellipsis_operator] = ACTIONS(12284),
    [sym__plus_operator] = ACTIONS(12284),
    [sym__times_operator] = ACTIONS(12284),
    [sym__rational_operator] = ACTIONS(12284),
    [sym__bitshift_operator] = ACTIONS(12284),
    [sym__power_operator] = ACTIONS(12284),
    [sym__tilde_operator] = ACTIONS(12284),
    [sym__type_order_operator] = ACTIONS(12284),
    [sym__unary_operator] = ACTIONS(12284),
    [sym__unary_plus_operator] = ACTIONS(12284),
    [aux_sym__terminator_token1] = ACTIONS(12284),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12282),
    [sym__string_start] = ACTIONS(12282),
    [sym__command_start] = ACTIONS(12282),
  },
  [9573] = {
    [sym__word_identifier] = ACTIONS(12062),
    [anon_sym_COLON] = ACTIONS(12062),
    [anon_sym_begin] = ACTIONS(12062),
    [anon_sym_module] = ACTIONS(12062),
    [anon_sym_baremodule] = ACTIONS(12062),
    [anon_sym_end] = ACTIONS(12062),
    [anon_sym_abstract] = ACTIONS(12062),
    [anon_sym_primitive] = ACTIONS(12062),
    [anon_sym_mutable] = ACTIONS(12062),
    [anon_sym_struct] = ACTIONS(12062),
    [anon_sym_LT_COLON] = ACTIONS(12062),
    [anon_sym_function] = ACTIONS(12062),
    [anon_sym_macro] = ACTIONS(12062),
    [anon_sym_quote] = ACTIONS(12062),
    [anon_sym_let] = ACTIONS(12062),
    [anon_sym_if] = ACTIONS(12062),
    [anon_sym_try] = ACTIONS(12062),
    [anon_sym_for] = ACTIONS(12062),
    [anon_sym_while] = ACTIONS(12062),
    [sym_break_statement] = ACTIONS(12062),
    [sym_continue_statement] = ACTIONS(12062),
    [anon_sym_return] = ACTIONS(12062),
    [anon_sym_const] = ACTIONS(12062),
    [anon_sym_global] = ACTIONS(12062),
    [anon_sym_local] = ACTIONS(12062),
    [anon_sym_LPAREN] = ACTIONS(12062),
    [anon_sym_export] = ACTIONS(12062),
    [anon_sym_import] = ACTIONS(12062),
    [anon_sym_using] = ACTIONS(12062),
    [anon_sym_LBRACK] = ACTIONS(12062),
    [anon_sym_LF] = ACTIONS(12060),
    [anon_sym_LBRACE] = ACTIONS(12062),
    [anon_sym_DOLLAR] = ACTIONS(12062),
    [anon_sym_COLON_COLON] = ACTIONS(12062),
    [anon_sym_AT] = ACTIONS(12062),
    [anon_sym_true] = ACTIONS(12062),
    [anon_sym_false] = ACTIONS(12062),
    [aux_sym_integer_literal_token1] = ACTIONS(12062),
    [aux_sym_integer_literal_token2] = ACTIONS(12062),
    [aux_sym_integer_literal_token3] = ACTIONS(12062),
    [aux_sym_integer_literal_token4] = ACTIONS(12062),
    [aux_sym_float_literal_token1] = ACTIONS(12062),
    [aux_sym_float_literal_token3] = ACTIONS(12062),
    [aux_sym_float_literal_token4] = ACTIONS(12062),
    [sym_character_literal] = ACTIONS(12062),
    [sym__pair_operator] = ACTIONS(12062),
    [sym__arrow_operator] = ACTIONS(12062),
    [sym__comparison_operator] = ACTIONS(12062),
    [sym__pipe_right_operator] = ACTIONS(12062),
    [sym__pipe_left_operator] = ACTIONS(12062),
    [sym__ellipsis_operator] = ACTIONS(12062),
    [sym__plus_operator] = ACTIONS(12062),
    [sym__times_operator] = ACTIONS(12062),
    [sym__rational_operator] = ACTIONS(12062),
    [sym__bitshift_operator] = ACTIONS(12062),
    [sym__power_operator] = ACTIONS(12062),
    [sym__tilde_operator] = ACTIONS(12062),
    [sym__type_order_operator] = ACTIONS(12062),
    [sym__unary_operator] = ACTIONS(12062),
    [sym__unary_plus_operator] = ACTIONS(12062),
    [aux_sym__terminator_token1] = ACTIONS(12062),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12060),
    [sym__string_start] = ACTIONS(12060),
    [sym__command_start] = ACTIONS(12060),
  },
  [9574] = {
    [sym__word_identifier] = ACTIONS(12046),
    [anon_sym_COLON] = ACTIONS(12046),
    [anon_sym_begin] = ACTIONS(12046),
    [anon_sym_module] = ACTIONS(12046),
    [anon_sym_baremodule] = ACTIONS(12046),
    [anon_sym_end] = ACTIONS(12046),
    [anon_sym_abstract] = ACTIONS(12046),
    [anon_sym_primitive] = ACTIONS(12046),
    [anon_sym_mutable] = ACTIONS(12046),
    [anon_sym_struct] = ACTIONS(12046),
    [anon_sym_LT_COLON] = ACTIONS(12046),
    [anon_sym_function] = ACTIONS(12046),
    [anon_sym_macro] = ACTIONS(12046),
    [anon_sym_quote] = ACTIONS(12046),
    [anon_sym_let] = ACTIONS(12046),
    [anon_sym_if] = ACTIONS(12046),
    [anon_sym_try] = ACTIONS(12046),
    [anon_sym_for] = ACTIONS(12046),
    [anon_sym_while] = ACTIONS(12046),
    [sym_break_statement] = ACTIONS(12046),
    [sym_continue_statement] = ACTIONS(12046),
    [anon_sym_return] = ACTIONS(12046),
    [anon_sym_const] = ACTIONS(12046),
    [anon_sym_global] = ACTIONS(12046),
    [anon_sym_local] = ACTIONS(12046),
    [anon_sym_LPAREN] = ACTIONS(12046),
    [anon_sym_export] = ACTIONS(12046),
    [anon_sym_import] = ACTIONS(12046),
    [anon_sym_using] = ACTIONS(12046),
    [anon_sym_LBRACK] = ACTIONS(12046),
    [anon_sym_LF] = ACTIONS(12044),
    [anon_sym_LBRACE] = ACTIONS(12046),
    [anon_sym_DOLLAR] = ACTIONS(12046),
    [anon_sym_COLON_COLON] = ACTIONS(12046),
    [anon_sym_AT] = ACTIONS(12046),
    [anon_sym_true] = ACTIONS(12046),
    [anon_sym_false] = ACTIONS(12046),
    [aux_sym_integer_literal_token1] = ACTIONS(12046),
    [aux_sym_integer_literal_token2] = ACTIONS(12046),
    [aux_sym_integer_literal_token3] = ACTIONS(12046),
    [aux_sym_integer_literal_token4] = ACTIONS(12046),
    [aux_sym_float_literal_token1] = ACTIONS(12046),
    [aux_sym_float_literal_token3] = ACTIONS(12046),
    [aux_sym_float_literal_token4] = ACTIONS(12046),
    [sym_character_literal] = ACTIONS(12046),
    [sym__pair_operator] = ACTIONS(12046),
    [sym__arrow_operator] = ACTIONS(12046),
    [sym__comparison_operator] = ACTIONS(12046),
    [sym__pipe_right_operator] = ACTIONS(12046),
    [sym__pipe_left_operator] = ACTIONS(12046),
    [sym__ellipsis_operator] = ACTIONS(12046),
    [sym__plus_operator] = ACTIONS(12046),
    [sym__times_operator] = ACTIONS(12046),
    [sym__rational_operator] = ACTIONS(12046),
    [sym__bitshift_operator] = ACTIONS(12046),
    [sym__power_operator] = ACTIONS(12046),
    [sym__tilde_operator] = ACTIONS(12046),
    [sym__type_order_operator] = ACTIONS(12046),
    [sym__unary_operator] = ACTIONS(12046),
    [sym__unary_plus_operator] = ACTIONS(12046),
    [aux_sym__terminator_token1] = ACTIONS(12046),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12044),
    [sym__string_start] = ACTIONS(12044),
    [sym__command_start] = ACTIONS(12044),
  },
  [9575] = {
    [sym__primary_expression] = STATE(11359),
    [sym__array] = STATE(11359),
    [sym_comprehension_expression] = STATE(11359),
    [sym_matrix_expression] = STATE(11359),
    [sym_vector_expression] = STATE(11359),
    [sym_parenthesized_expression] = STATE(11359),
    [sym_tuple_expression] = STATE(11359),
    [sym_curly_expression] = STATE(11359),
    [sym_adjoint_expression] = STATE(11359),
    [sym_field_expression] = STATE(11359),
    [sym_index_expression] = STATE(11359),
    [sym_parametrized_type_expression] = STATE(11359),
    [sym_call_expression] = STATE(11359),
    [sym_broadcast_call_expression] = STATE(11359),
    [sym__closed_macrocall_expression] = STATE(11359),
    [sym_interpolation_expression] = STATE(11359),
    [sym_quote_expression] = STATE(11359),
    [sym_macro_identifier] = STATE(17273),
    [sym_identifier] = STATE(10579),
    [sym_boolean_literal] = STATE(11359),
    [sym__string] = STATE(11359),
    [sym_string_literal] = STATE(11359),
    [sym_command_literal] = STATE(11359),
    [sym_prefixed_string_literal] = STATE(11359),
    [sym_prefixed_command_literal] = STATE(11359),
    [sym_operator] = STATE(18510),
    [sym__word_identifier] = ACTIONS(13284),
    [anon_sym_EQ] = ACTIONS(11397),
    [anon_sym_COMMA] = ACTIONS(11408),
    [anon_sym_COLON] = ACTIONS(15238),
    [anon_sym_where] = ACTIONS(11397),
    [anon_sym_LPAREN] = ACTIONS(13288),
    [anon_sym_COLON2] = ACTIONS(11397),
    [anon_sym_LBRACK] = ACTIONS(13290),
    [anon_sym_in] = ACTIONS(11397),
    [anon_sym_LBRACE] = ACTIONS(13292),
    [anon_sym_DOLLAR] = ACTIONS(15210),
    [anon_sym_COLON_COLON] = ACTIONS(11408),
    [anon_sym_isa] = ACTIONS(11397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11408),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_AT] = ACTIONS(13296),
    [anon_sym_true] = ACTIONS(13298),
    [anon_sym_false] = ACTIONS(13298),
    [sym_character_literal] = ACTIONS(13300),
    [sym__pair_operator] = ACTIONS(11581),
    [sym__arrow_operator] = ACTIONS(11425),
    [sym__lazy_or_operator] = ACTIONS(11408),
    [sym__lazy_and_operator] = ACTIONS(11408),
    [sym__comparison_operator] = ACTIONS(11425),
    [sym__pipe_right_operator] = ACTIONS(11581),
    [sym__pipe_left_operator] = ACTIONS(11581),
    [sym__ellipsis_operator] = ACTIONS(11425),
    [sym__plus_operator] = ACTIONS(11425),
    [sym__times_operator] = ACTIONS(11425),
    [sym__rational_operator] = ACTIONS(11581),
    [sym__bitshift_operator] = ACTIONS(11581),
    [sym__power_operator] = ACTIONS(11581),
    [sym__tilde_operator] = ACTIONS(2924),
    [sym__type_order_operator] = ACTIONS(11581),
    [sym__unary_operator] = ACTIONS(2926),
    [sym__unary_plus_operator] = ACTIONS(11425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(13302),
    [sym__command_start] = ACTIONS(13304),
  },
  [9576] = {
    [sym__word_identifier] = ACTIONS(12210),
    [anon_sym_COLON] = ACTIONS(12210),
    [anon_sym_begin] = ACTIONS(12210),
    [anon_sym_module] = ACTIONS(12210),
    [anon_sym_baremodule] = ACTIONS(12210),
    [anon_sym_end] = ACTIONS(12210),
    [anon_sym_abstract] = ACTIONS(12210),
    [anon_sym_primitive] = ACTIONS(12210),
    [anon_sym_mutable] = ACTIONS(12210),
    [anon_sym_struct] = ACTIONS(12210),
    [anon_sym_LT_COLON] = ACTIONS(12210),
    [anon_sym_function] = ACTIONS(12210),
    [anon_sym_macro] = ACTIONS(12210),
    [anon_sym_quote] = ACTIONS(12210),
    [anon_sym_let] = ACTIONS(12210),
    [anon_sym_if] = ACTIONS(12210),
    [anon_sym_try] = ACTIONS(12210),
    [anon_sym_for] = ACTIONS(12210),
    [anon_sym_while] = ACTIONS(12210),
    [sym_break_statement] = ACTIONS(12210),
    [sym_continue_statement] = ACTIONS(12210),
    [anon_sym_return] = ACTIONS(12210),
    [anon_sym_const] = ACTIONS(12210),
    [anon_sym_global] = ACTIONS(12210),
    [anon_sym_local] = ACTIONS(12210),
    [anon_sym_LPAREN] = ACTIONS(12210),
    [anon_sym_export] = ACTIONS(12210),
    [anon_sym_import] = ACTIONS(12210),
    [anon_sym_using] = ACTIONS(12210),
    [anon_sym_LBRACK] = ACTIONS(12210),
    [anon_sym_LF] = ACTIONS(12208),
    [anon_sym_LBRACE] = ACTIONS(12210),
    [anon_sym_DOLLAR] = ACTIONS(12210),
    [anon_sym_COLON_COLON] = ACTIONS(12210),
    [anon_sym_AT] = ACTIONS(12210),
    [anon_sym_true] = ACTIONS(12210),
    [anon_sym_false] = ACTIONS(12210),
    [aux_sym_integer_literal_token1] = ACTIONS(12210),
    [aux_sym_integer_literal_token2] = ACTIONS(12210),
    [aux_sym_integer_literal_token3] = ACTIONS(12210),
    [aux_sym_integer_literal_token4] = ACTIONS(12210),
    [aux_sym_float_literal_token1] = ACTIONS(12210),
    [aux_sym_float_literal_token3] = ACTIONS(12210),
    [aux_sym_float_literal_token4] = ACTIONS(12210),
    [sym_character_literal] = ACTIONS(12210),
    [sym__pair_operator] = ACTIONS(12210),
    [sym__arrow_operator] = ACTIONS(12210),
    [sym__comparison_operator] = ACTIONS(12210),
    [sym__pipe_right_operator] = ACTIONS(12210),
    [sym__pipe_left_operator] = ACTIONS(12210),
    [sym__ellipsis_operator] = ACTIONS(12210),
    [sym__plus_operator] = ACTIONS(12210),
    [sym__times_operator] = ACTIONS(12210),
    [sym__rational_operator] = ACTIONS(12210),
    [sym__bitshift_operator] = ACTIONS(12210),
    [sym__power_operator] = ACTIONS(12210),
    [sym__tilde_operator] = ACTIONS(12210),
    [sym__type_order_operator] = ACTIONS(12210),
    [sym__unary_operator] = ACTIONS(12210),
    [sym__unary_plus_operator] = ACTIONS(12210),
    [aux_sym__terminator_token1] = ACTIONS(12210),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12208),
    [sym__string_start] = ACTIONS(12208),
    [sym__command_start] = ACTIONS(12208),
  },
  [9577] = {
    [sym__word_identifier] = ACTIONS(12142),
    [anon_sym_COLON] = ACTIONS(12142),
    [anon_sym_begin] = ACTIONS(12142),
    [anon_sym_module] = ACTIONS(12142),
    [anon_sym_baremodule] = ACTIONS(12142),
    [anon_sym_end] = ACTIONS(12142),
    [anon_sym_abstract] = ACTIONS(12142),
    [anon_sym_primitive] = ACTIONS(12142),
    [anon_sym_mutable] = ACTIONS(12142),
    [anon_sym_struct] = ACTIONS(12142),
    [anon_sym_LT_COLON] = ACTIONS(12142),
    [anon_sym_function] = ACTIONS(12142),
    [anon_sym_macro] = ACTIONS(12142),
    [anon_sym_quote] = ACTIONS(12142),
    [anon_sym_let] = ACTIONS(12142),
    [anon_sym_if] = ACTIONS(12142),
    [anon_sym_try] = ACTIONS(12142),
    [anon_sym_for] = ACTIONS(12142),
    [anon_sym_while] = ACTIONS(12142),
    [sym_break_statement] = ACTIONS(12142),
    [sym_continue_statement] = ACTIONS(12142),
    [anon_sym_return] = ACTIONS(12142),
    [anon_sym_const] = ACTIONS(12142),
    [anon_sym_global] = ACTIONS(12142),
    [anon_sym_local] = ACTIONS(12142),
    [anon_sym_LPAREN] = ACTIONS(12142),
    [anon_sym_export] = ACTIONS(12142),
    [anon_sym_import] = ACTIONS(12142),
    [anon_sym_using] = ACTIONS(12142),
    [anon_sym_LBRACK] = ACTIONS(12142),
    [anon_sym_LF] = ACTIONS(12140),
    [anon_sym_LBRACE] = ACTIONS(12142),
    [anon_sym_DOLLAR] = ACTIONS(12142),
    [anon_sym_COLON_COLON] = ACTIONS(12142),
    [anon_sym_AT] = ACTIONS(12142),
    [anon_sym_true] = ACTIONS(12142),
    [anon_sym_false] = ACTIONS(12142),
    [aux_sym_integer_literal_token1] = ACTIONS(12142),
    [aux_sym_integer_literal_token2] = ACTIONS(12142),
    [aux_sym_integer_literal_token3] = ACTIONS(12142),
    [aux_sym_integer_literal_token4] = ACTIONS(12142),
    [aux_sym_float_literal_token1] = ACTIONS(12142),
    [aux_sym_float_literal_token3] = ACTIONS(12142),
    [aux_sym_float_literal_token4] = ACTIONS(12142),
    [sym_character_literal] = ACTIONS(12142),
    [sym__pair_operator] = ACTIONS(12142),
    [sym__arrow_operator] = ACTIONS(12142),
    [sym__comparison_operator] = ACTIONS(12142),
    [sym__pipe_right_operator] = ACTIONS(12142),
    [sym__pipe_left_operator] = ACTIONS(12142),
    [sym__ellipsis_operator] = ACTIONS(12142),
    [sym__plus_operator] = ACTIONS(12142),
    [sym__times_operator] = ACTIONS(12142),
    [sym__rational_operator] = ACTIONS(12142),
    [sym__bitshift_operator] = ACTIONS(12142),
    [sym__power_operator] = ACTIONS(12142),
    [sym__tilde_operator] = ACTIONS(12142),
    [sym__type_order_operator] = ACTIONS(12142),
    [sym__unary_operator] = ACTIONS(12142),
    [sym__unary_plus_operator] = ACTIONS(12142),
    [aux_sym__terminator_token1] = ACTIONS(12142),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12140),
    [sym__string_start] = ACTIONS(12140),
    [sym__command_start] = ACTIONS(12140),
  },
  [9578] = {
    [sym__word_identifier] = ACTIONS(12248),
    [anon_sym_COLON] = ACTIONS(12248),
    [anon_sym_begin] = ACTIONS(12248),
    [anon_sym_module] = ACTIONS(12248),
    [anon_sym_baremodule] = ACTIONS(12248),
    [anon_sym_end] = ACTIONS(12248),
    [anon_sym_abstract] = ACTIONS(12248),
    [anon_sym_primitive] = ACTIONS(12248),
    [anon_sym_mutable] = ACTIONS(12248),
    [anon_sym_struct] = ACTIONS(12248),
    [anon_sym_LT_COLON] = ACTIONS(12248),
    [anon_sym_function] = ACTIONS(12248),
    [anon_sym_macro] = ACTIONS(12248),
    [anon_sym_quote] = ACTIONS(12248),
    [anon_sym_let] = ACTIONS(12248),
    [anon_sym_if] = ACTIONS(12248),
    [anon_sym_try] = ACTIONS(12248),
    [anon_sym_for] = ACTIONS(12248),
    [anon_sym_while] = ACTIONS(12248),
    [sym_break_statement] = ACTIONS(12248),
    [sym_continue_statement] = ACTIONS(12248),
    [anon_sym_return] = ACTIONS(12248),
    [anon_sym_const] = ACTIONS(12248),
    [anon_sym_global] = ACTIONS(12248),
    [anon_sym_local] = ACTIONS(12248),
    [anon_sym_LPAREN] = ACTIONS(12248),
    [anon_sym_export] = ACTIONS(12248),
    [anon_sym_import] = ACTIONS(12248),
    [anon_sym_using] = ACTIONS(12248),
    [anon_sym_LBRACK] = ACTIONS(12248),
    [anon_sym_LF] = ACTIONS(12246),
    [anon_sym_LBRACE] = ACTIONS(12248),
    [anon_sym_DOLLAR] = ACTIONS(12248),
    [anon_sym_COLON_COLON] = ACTIONS(12248),
    [anon_sym_AT] = ACTIONS(12248),
    [anon_sym_true] = ACTIONS(12248),
    [anon_sym_false] = ACTIONS(12248),
    [aux_sym_integer_literal_token1] = ACTIONS(12248),
    [aux_sym_integer_literal_token2] = ACTIONS(12248),
    [aux_sym_integer_literal_token3] = ACTIONS(12248),
    [aux_sym_integer_literal_token4] = ACTIONS(12248),
    [aux_sym_float_literal_token1] = ACTIONS(12248),
    [aux_sym_float_literal_token3] = ACTIONS(12248),
    [aux_sym_float_literal_token4] = ACTIONS(12248),
    [sym_character_literal] = ACTIONS(12248),
    [sym__pair_operator] = ACTIONS(12248),
    [sym__arrow_operator] = ACTIONS(12248),
    [sym__comparison_operator] = ACTIONS(12248),
    [sym__pipe_right_operator] = ACTIONS(12248),
    [sym__pipe_left_operator] = ACTIONS(12248),
    [sym__ellipsis_operator] = ACTIONS(12248),
    [sym__plus_operator] = ACTIONS(12248),
    [sym__times_operator] = ACTIONS(12248),
    [sym__rational_operator] = ACTIONS(12248),
    [sym__bitshift_operator] = ACTIONS(12248),
    [sym__power_operator] = ACTIONS(12248),
    [sym__tilde_operator] = ACTIONS(12248),
    [sym__type_order_operator] = ACTIONS(12248),
    [sym__unary_operator] = ACTIONS(12248),
    [sym__unary_plus_operator] = ACTIONS(12248),
    [aux_sym__terminator_token1] = ACTIONS(12248),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12246),
    [sym__string_start] = ACTIONS(12246),
    [sym__command_start] = ACTIONS(12246),
  },
  [9579] = {
    [sym__word_identifier] = ACTIONS(12252),
    [anon_sym_COLON] = ACTIONS(12252),
    [anon_sym_begin] = ACTIONS(12252),
    [anon_sym_module] = ACTIONS(12252),
    [anon_sym_baremodule] = ACTIONS(12252),
    [anon_sym_end] = ACTIONS(12252),
    [anon_sym_abstract] = ACTIONS(12252),
    [anon_sym_primitive] = ACTIONS(12252),
    [anon_sym_mutable] = ACTIONS(12252),
    [anon_sym_struct] = ACTIONS(12252),
    [anon_sym_LT_COLON] = ACTIONS(12252),
    [anon_sym_function] = ACTIONS(12252),
    [anon_sym_macro] = ACTIONS(12252),
    [anon_sym_quote] = ACTIONS(12252),
    [anon_sym_let] = ACTIONS(12252),
    [anon_sym_if] = ACTIONS(12252),
    [anon_sym_try] = ACTIONS(12252),
    [anon_sym_for] = ACTIONS(12252),
    [anon_sym_while] = ACTIONS(12252),
    [sym_break_statement] = ACTIONS(12252),
    [sym_continue_statement] = ACTIONS(12252),
    [anon_sym_return] = ACTIONS(12252),
    [anon_sym_const] = ACTIONS(12252),
    [anon_sym_global] = ACTIONS(12252),
    [anon_sym_local] = ACTIONS(12252),
    [anon_sym_LPAREN] = ACTIONS(12252),
    [anon_sym_export] = ACTIONS(12252),
    [anon_sym_import] = ACTIONS(12252),
    [anon_sym_using] = ACTIONS(12252),
    [anon_sym_LBRACK] = ACTIONS(12252),
    [anon_sym_LF] = ACTIONS(12250),
    [anon_sym_LBRACE] = ACTIONS(12252),
    [anon_sym_DOLLAR] = ACTIONS(12252),
    [anon_sym_COLON_COLON] = ACTIONS(12252),
    [anon_sym_AT] = ACTIONS(12252),
    [anon_sym_true] = ACTIONS(12252),
    [anon_sym_false] = ACTIONS(12252),
    [aux_sym_integer_literal_token1] = ACTIONS(12252),
    [aux_sym_integer_literal_token2] = ACTIONS(12252),
    [aux_sym_integer_literal_token3] = ACTIONS(12252),
    [aux_sym_integer_literal_token4] = ACTIONS(12252),
    [aux_sym_float_literal_token1] = ACTIONS(12252),
    [aux_sym_float_literal_token3] = ACTIONS(12252),
    [aux_sym_float_literal_token4] = ACTIONS(12252),
    [sym_character_literal] = ACTIONS(12252),
    [sym__pair_operator] = ACTIONS(12252),
    [sym__arrow_operator] = ACTIONS(12252),
    [sym__comparison_operator] = ACTIONS(12252),
    [sym__pipe_right_operator] = ACTIONS(12252),
    [sym__pipe_left_operator] = ACTIONS(12252),
    [sym__ellipsis_operator] = ACTIONS(12252),
    [sym__plus_operator] = ACTIONS(12252),
    [sym__times_operator] = ACTIONS(12252),
    [sym__rational_operator] = ACTIONS(12252),
    [sym__bitshift_operator] = ACTIONS(12252),
    [sym__power_operator] = ACTIONS(12252),
    [sym__tilde_operator] = ACTIONS(12252),
    [sym__type_order_operator] = ACTIONS(12252),
    [sym__unary_operator] = ACTIONS(12252),
    [sym__unary_plus_operator] = ACTIONS(12252),
    [aux_sym__terminator_token1] = ACTIONS(12252),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12250),
    [sym__string_start] = ACTIONS(12250),
    [sym__command_start] = ACTIONS(12250),
  },
  [9580] = {
    [sym__word_identifier] = ACTIONS(12166),
    [anon_sym_COLON] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(12166),
    [anon_sym_module] = ACTIONS(12166),
    [anon_sym_baremodule] = ACTIONS(12166),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_abstract] = ACTIONS(12166),
    [anon_sym_primitive] = ACTIONS(12166),
    [anon_sym_mutable] = ACTIONS(12166),
    [anon_sym_struct] = ACTIONS(12166),
    [anon_sym_LT_COLON] = ACTIONS(12166),
    [anon_sym_function] = ACTIONS(12166),
    [anon_sym_macro] = ACTIONS(12166),
    [anon_sym_quote] = ACTIONS(12166),
    [anon_sym_let] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_try] = ACTIONS(12166),
    [anon_sym_for] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [sym_break_statement] = ACTIONS(12166),
    [sym_continue_statement] = ACTIONS(12166),
    [anon_sym_return] = ACTIONS(12166),
    [anon_sym_const] = ACTIONS(12166),
    [anon_sym_global] = ACTIONS(12166),
    [anon_sym_local] = ACTIONS(12166),
    [anon_sym_LPAREN] = ACTIONS(12166),
    [anon_sym_export] = ACTIONS(12166),
    [anon_sym_import] = ACTIONS(12166),
    [anon_sym_using] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_LF] = ACTIONS(12164),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOLLAR] = ACTIONS(12166),
    [anon_sym_COLON_COLON] = ACTIONS(12166),
    [anon_sym_AT] = ACTIONS(12166),
    [anon_sym_true] = ACTIONS(12166),
    [anon_sym_false] = ACTIONS(12166),
    [aux_sym_integer_literal_token1] = ACTIONS(12166),
    [aux_sym_integer_literal_token2] = ACTIONS(12166),
    [aux_sym_integer_literal_token3] = ACTIONS(12166),
    [aux_sym_integer_literal_token4] = ACTIONS(12166),
    [aux_sym_float_literal_token1] = ACTIONS(12166),
    [aux_sym_float_literal_token3] = ACTIONS(12166),
    [aux_sym_float_literal_token4] = ACTIONS(12166),
    [sym_character_literal] = ACTIONS(12166),
    [sym__pair_operator] = ACTIONS(12166),
    [sym__arrow_operator] = ACTIONS(12166),
    [sym__comparison_operator] = ACTIONS(12166),
    [sym__pipe_right_operator] = ACTIONS(12166),
    [sym__pipe_left_operator] = ACTIONS(12166),
    [sym__ellipsis_operator] = ACTIONS(12166),
    [sym__plus_operator] = ACTIONS(12166),
    [sym__times_operator] = ACTIONS(12166),
    [sym__rational_operator] = ACTIONS(12166),
    [sym__bitshift_operator] = ACTIONS(12166),
    [sym__power_operator] = ACTIONS(12166),
    [sym__tilde_operator] = ACTIONS(12166),
    [sym__type_order_operator] = ACTIONS(12166),
    [sym__unary_operator] = ACTIONS(12166),
    [sym__unary_plus_operator] = ACTIONS(12166),
    [aux_sym__terminator_token1] = ACTIONS(12166),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12164),
    [sym__string_start] = ACTIONS(12164),
    [sym__command_start] = ACTIONS(12164),
  },
  [9581] = {
    [sym__word_identifier] = ACTIONS(12146),
    [anon_sym_COLON] = ACTIONS(12146),
    [anon_sym_begin] = ACTIONS(12146),
    [anon_sym_module] = ACTIONS(12146),
    [anon_sym_baremodule] = ACTIONS(12146),
    [anon_sym_end] = ACTIONS(12146),
    [anon_sym_abstract] = ACTIONS(12146),
    [anon_sym_primitive] = ACTIONS(12146),
    [anon_sym_mutable] = ACTIONS(12146),
    [anon_sym_struct] = ACTIONS(12146),
    [anon_sym_LT_COLON] = ACTIONS(12146),
    [anon_sym_function] = ACTIONS(12146),
    [anon_sym_macro] = ACTIONS(12146),
    [anon_sym_quote] = ACTIONS(12146),
    [anon_sym_let] = ACTIONS(12146),
    [anon_sym_if] = ACTIONS(12146),
    [anon_sym_try] = ACTIONS(12146),
    [anon_sym_for] = ACTIONS(12146),
    [anon_sym_while] = ACTIONS(12146),
    [sym_break_statement] = ACTIONS(12146),
    [sym_continue_statement] = ACTIONS(12146),
    [anon_sym_return] = ACTIONS(12146),
    [anon_sym_const] = ACTIONS(12146),
    [anon_sym_global] = ACTIONS(12146),
    [anon_sym_local] = ACTIONS(12146),
    [anon_sym_LPAREN] = ACTIONS(12146),
    [anon_sym_export] = ACTIONS(12146),
    [anon_sym_import] = ACTIONS(12146),
    [anon_sym_using] = ACTIONS(12146),
    [anon_sym_LBRACK] = ACTIONS(12146),
    [anon_sym_LF] = ACTIONS(12144),
    [anon_sym_LBRACE] = ACTIONS(12146),
    [anon_sym_DOLLAR] = ACTIONS(12146),
    [anon_sym_COLON_COLON] = ACTIONS(12146),
    [anon_sym_AT] = ACTIONS(12146),
    [anon_sym_true] = ACTIONS(12146),
    [anon_sym_false] = ACTIONS(12146),
    [aux_sym_integer_literal_token1] = ACTIONS(12146),
    [aux_sym_integer_literal_token2] = ACTIONS(12146),
    [aux_sym_integer_literal_token3] = ACTIONS(12146),
    [aux_sym_integer_literal_token4] = ACTIONS(12146),
    [aux_sym_float_literal_token1] = ACTIONS(12146),
    [aux_sym_float_literal_token3] = ACTIONS(12146),
    [aux_sym_float_literal_token4] = ACTIONS(12146),
    [sym_character_literal] = ACTIONS(12146),
    [sym__pair_operator] = ACTIONS(12146),
    [sym__arrow_operator] = ACTIONS(12146),
    [sym__comparison_operator] = ACTIONS(12146),
    [sym__pipe_right_operator] = ACTIONS(12146),
    [sym__pipe_left_operator] = ACTIONS(12146),
    [sym__ellipsis_operator] = ACTIONS(12146),
    [sym__plus_operator] = ACTIONS(12146),
    [sym__times_operator] = ACTIONS(12146),
    [sym__rational_operator] = ACTIONS(12146),
    [sym__bitshift_operator] = ACTIONS(12146),
    [sym__power_operator] = ACTIONS(12146),
    [sym__tilde_operator] = ACTIONS(12146),
    [sym__type_order_operator] = ACTIONS(12146),
    [sym__unary_operator] = ACTIONS(12146),
    [sym__unary_plus_operator] = ACTIONS(12146),
    [aux_sym__terminator_token1] = ACTIONS(12146),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12144),
    [sym__string_start] = ACTIONS(12144),
    [sym__command_start] = ACTIONS(12144),
  },
  [9582] = {
    [sym__word_identifier] = ACTIONS(12170),
    [anon_sym_COLON] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(12170),
    [anon_sym_module] = ACTIONS(12170),
    [anon_sym_baremodule] = ACTIONS(12170),
    [anon_sym_end] = ACTIONS(12170),
    [anon_sym_abstract] = ACTIONS(12170),
    [anon_sym_primitive] = ACTIONS(12170),
    [anon_sym_mutable] = ACTIONS(12170),
    [anon_sym_struct] = ACTIONS(12170),
    [anon_sym_LT_COLON] = ACTIONS(12170),
    [anon_sym_function] = ACTIONS(12170),
    [anon_sym_macro] = ACTIONS(12170),
    [anon_sym_quote] = ACTIONS(12170),
    [anon_sym_let] = ACTIONS(12170),
    [anon_sym_if] = ACTIONS(12170),
    [anon_sym_try] = ACTIONS(12170),
    [anon_sym_for] = ACTIONS(12170),
    [anon_sym_while] = ACTIONS(12170),
    [sym_break_statement] = ACTIONS(12170),
    [sym_continue_statement] = ACTIONS(12170),
    [anon_sym_return] = ACTIONS(12170),
    [anon_sym_const] = ACTIONS(12170),
    [anon_sym_global] = ACTIONS(12170),
    [anon_sym_local] = ACTIONS(12170),
    [anon_sym_LPAREN] = ACTIONS(12170),
    [anon_sym_export] = ACTIONS(12170),
    [anon_sym_import] = ACTIONS(12170),
    [anon_sym_using] = ACTIONS(12170),
    [anon_sym_LBRACK] = ACTIONS(12170),
    [anon_sym_LF] = ACTIONS(12168),
    [anon_sym_LBRACE] = ACTIONS(12170),
    [anon_sym_DOLLAR] = ACTIONS(12170),
    [anon_sym_COLON_COLON] = ACTIONS(12170),
    [anon_sym_AT] = ACTIONS(12170),
    [anon_sym_true] = ACTIONS(12170),
    [anon_sym_false] = ACTIONS(12170),
    [aux_sym_integer_literal_token1] = ACTIONS(12170),
    [aux_sym_integer_literal_token2] = ACTIONS(12170),
    [aux_sym_integer_literal_token3] = ACTIONS(12170),
    [aux_sym_integer_literal_token4] = ACTIONS(12170),
    [aux_sym_float_literal_token1] = ACTIONS(12170),
    [aux_sym_float_literal_token3] = ACTIONS(12170),
    [aux_sym_float_literal_token4] = ACTIONS(12170),
    [sym_character_literal] = ACTIONS(12170),
    [sym__pair_operator] = ACTIONS(12170),
    [sym__arrow_operator] = ACTIONS(12170),
    [sym__comparison_operator] = ACTIONS(12170),
    [sym__pipe_right_operator] = ACTIONS(12170),
    [sym__pipe_left_operator] = ACTIONS(12170),
    [sym__ellipsis_operator] = ACTIONS(12170),
    [sym__plus_operator] = ACTIONS(12170),
    [sym__times_operator] = ACTIONS(12170),
    [sym__rational_operator] = ACTIONS(12170),
    [sym__bitshift_operator] = ACTIONS(12170),
    [sym__power_operator] = ACTIONS(12170),
    [sym__tilde_operator] = ACTIONS(12170),
    [sym__type_order_operator] = ACTIONS(12170),
    [sym__unary_operator] = ACTIONS(12170),
    [sym__unary_plus_operator] = ACTIONS(12170),
    [aux_sym__terminator_token1] = ACTIONS(12170),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12168),
    [sym__string_start] = ACTIONS(12168),
    [sym__command_start] = ACTIONS(12168),
  },
  [9583] = {
    [sym__word_identifier] = ACTIONS(12150),
    [anon_sym_COLON] = ACTIONS(12150),
    [anon_sym_begin] = ACTIONS(12150),
    [anon_sym_module] = ACTIONS(12150),
    [anon_sym_baremodule] = ACTIONS(12150),
    [anon_sym_end] = ACTIONS(12150),
    [anon_sym_abstract] = ACTIONS(12150),
    [anon_sym_primitive] = ACTIONS(12150),
    [anon_sym_mutable] = ACTIONS(12150),
    [anon_sym_struct] = ACTIONS(12150),
    [anon_sym_LT_COLON] = ACTIONS(12150),
    [anon_sym_function] = ACTIONS(12150),
    [anon_sym_macro] = ACTIONS(12150),
    [anon_sym_quote] = ACTIONS(12150),
    [anon_sym_let] = ACTIONS(12150),
    [anon_sym_if] = ACTIONS(12150),
    [anon_sym_try] = ACTIONS(12150),
    [anon_sym_for] = ACTIONS(12150),
    [anon_sym_while] = ACTIONS(12150),
    [sym_break_statement] = ACTIONS(12150),
    [sym_continue_statement] = ACTIONS(12150),
    [anon_sym_return] = ACTIONS(12150),
    [anon_sym_const] = ACTIONS(12150),
    [anon_sym_global] = ACTIONS(12150),
    [anon_sym_local] = ACTIONS(12150),
    [anon_sym_LPAREN] = ACTIONS(12150),
    [anon_sym_export] = ACTIONS(12150),
    [anon_sym_import] = ACTIONS(12150),
    [anon_sym_using] = ACTIONS(12150),
    [anon_sym_LBRACK] = ACTIONS(12150),
    [anon_sym_LF] = ACTIONS(12148),
    [anon_sym_LBRACE] = ACTIONS(12150),
    [anon_sym_DOLLAR] = ACTIONS(12150),
    [anon_sym_COLON_COLON] = ACTIONS(12150),
    [anon_sym_AT] = ACTIONS(12150),
    [anon_sym_true] = ACTIONS(12150),
    [anon_sym_false] = ACTIONS(12150),
    [aux_sym_integer_literal_token1] = ACTIONS(12150),
    [aux_sym_integer_literal_token2] = ACTIONS(12150),
    [aux_sym_integer_literal_token3] = ACTIONS(12150),
    [aux_sym_integer_literal_token4] = ACTIONS(12150),
    [aux_sym_float_literal_token1] = ACTIONS(12150),
    [aux_sym_float_literal_token3] = ACTIONS(12150),
    [aux_sym_float_literal_token4] = ACTIONS(12150),
    [sym_character_literal] = ACTIONS(12150),
    [sym__pair_operator] = ACTIONS(12150),
    [sym__arrow_operator] = ACTIONS(12150),
    [sym__comparison_operator] = ACTIONS(12150),
    [sym__pipe_right_operator] = ACTIONS(12150),
    [sym__pipe_left_operator] = ACTIONS(12150),
    [sym__ellipsis_operator] = ACTIONS(12150),
    [sym__plus_operator] = ACTIONS(12150),
    [sym__times_operator] = ACTIONS(12150),
    [sym__rational_operator] = ACTIONS(12150),
    [sym__bitshift_operator] = ACTIONS(12150),
    [sym__power_operator] = ACTIONS(12150),
    [sym__tilde_operator] = ACTIONS(12150),
    [sym__type_order_operator] = ACTIONS(12150),
    [sym__unary_operator] = ACTIONS(12150),
    [sym__unary_plus_operator] = ACTIONS(12150),
    [aux_sym__terminator_token1] = ACTIONS(12150),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12148),
    [sym__string_start] = ACTIONS(12148),
    [sym__command_start] = ACTIONS(12148),
  },
  [9584] = {
    [sym__word_identifier] = ACTIONS(12256),
    [anon_sym_COLON] = ACTIONS(12256),
    [anon_sym_begin] = ACTIONS(12256),
    [anon_sym_module] = ACTIONS(12256),
    [anon_sym_baremodule] = ACTIONS(12256),
    [anon_sym_end] = ACTIONS(12256),
    [anon_sym_abstract] = ACTIONS(12256),
    [anon_sym_primitive] = ACTIONS(12256),
    [anon_sym_mutable] = ACTIONS(12256),
    [anon_sym_struct] = ACTIONS(12256),
    [anon_sym_LT_COLON] = ACTIONS(12256),
    [anon_sym_function] = ACTIONS(12256),
    [anon_sym_macro] = ACTIONS(12256),
    [anon_sym_quote] = ACTIONS(12256),
    [anon_sym_let] = ACTIONS(12256),
    [anon_sym_if] = ACTIONS(12256),
    [anon_sym_try] = ACTIONS(12256),
    [anon_sym_for] = ACTIONS(12256),
    [anon_sym_while] = ACTIONS(12256),
    [sym_break_statement] = ACTIONS(12256),
    [sym_continue_statement] = ACTIONS(12256),
    [anon_sym_return] = ACTIONS(12256),
    [anon_sym_const] = ACTIONS(12256),
    [anon_sym_global] = ACTIONS(12256),
    [anon_sym_local] = ACTIONS(12256),
    [anon_sym_LPAREN] = ACTIONS(12256),
    [anon_sym_export] = ACTIONS(12256),
    [anon_sym_import] = ACTIONS(12256),
    [anon_sym_using] = ACTIONS(12256),
    [anon_sym_LBRACK] = ACTIONS(12256),
    [anon_sym_LF] = ACTIONS(12254),
    [anon_sym_LBRACE] = ACTIONS(12256),
    [anon_sym_DOLLAR] = ACTIONS(12256),
    [anon_sym_COLON_COLON] = ACTIONS(12256),
    [anon_sym_AT] = ACTIONS(12256),
    [anon_sym_true] = ACTIONS(12256),
    [anon_sym_false] = ACTIONS(12256),
    [aux_sym_integer_literal_token1] = ACTIONS(12256),
    [aux_sym_integer_literal_token2] = ACTIONS(12256),
    [aux_sym_integer_literal_token3] = ACTIONS(12256),
    [aux_sym_integer_literal_token4] = ACTIONS(12256),
    [aux_sym_float_literal_token1] = ACTIONS(12256),
    [aux_sym_float_literal_token3] = ACTIONS(12256),
    [aux_sym_float_literal_token4] = ACTIONS(12256),
    [sym_character_literal] = ACTIONS(12256),
    [sym__pair_operator] = ACTIONS(12256),
    [sym__arrow_operator] = ACTIONS(12256),
    [sym__comparison_operator] = ACTIONS(12256),
    [sym__pipe_right_operator] = ACTIONS(12256),
    [sym__pipe_left_operator] = ACTIONS(12256),
    [sym__ellipsis_operator] = ACTIONS(12256),
    [sym__plus_operator] = ACTIONS(12256),
    [sym__times_operator] = ACTIONS(12256),
    [sym__rational_operator] = ACTIONS(12256),
    [sym__bitshift_operator] = ACTIONS(12256),
    [sym__power_operator] = ACTIONS(12256),
    [sym__tilde_operator] = ACTIONS(12256),
    [sym__type_order_operator] = ACTIONS(12256),
    [sym__unary_operator] = ACTIONS(12256),
    [sym__unary_plus_operator] = ACTIONS(12256),
    [aux_sym__terminator_token1] = ACTIONS(12256),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12254),
    [sym__string_start] = ACTIONS(12254),
    [sym__command_start] = ACTIONS(12254),
  },
  [9585] = {
    [sym__word_identifier] = ACTIONS(12260),
    [anon_sym_COLON] = ACTIONS(12260),
    [anon_sym_begin] = ACTIONS(12260),
    [anon_sym_module] = ACTIONS(12260),
    [anon_sym_baremodule] = ACTIONS(12260),
    [anon_sym_end] = ACTIONS(12260),
    [anon_sym_abstract] = ACTIONS(12260),
    [anon_sym_primitive] = ACTIONS(12260),
    [anon_sym_mutable] = ACTIONS(12260),
    [anon_sym_struct] = ACTIONS(12260),
    [anon_sym_LT_COLON] = ACTIONS(12260),
    [anon_sym_function] = ACTIONS(12260),
    [anon_sym_macro] = ACTIONS(12260),
    [anon_sym_quote] = ACTIONS(12260),
    [anon_sym_let] = ACTIONS(12260),
    [anon_sym_if] = ACTIONS(12260),
    [anon_sym_try] = ACTIONS(12260),
    [anon_sym_for] = ACTIONS(12260),
    [anon_sym_while] = ACTIONS(12260),
    [sym_break_statement] = ACTIONS(12260),
    [sym_continue_statement] = ACTIONS(12260),
    [anon_sym_return] = ACTIONS(12260),
    [anon_sym_const] = ACTIONS(12260),
    [anon_sym_global] = ACTIONS(12260),
    [anon_sym_local] = ACTIONS(12260),
    [anon_sym_LPAREN] = ACTIONS(12260),
    [anon_sym_export] = ACTIONS(12260),
    [anon_sym_import] = ACTIONS(12260),
    [anon_sym_using] = ACTIONS(12260),
    [anon_sym_LBRACK] = ACTIONS(12260),
    [anon_sym_LF] = ACTIONS(12258),
    [anon_sym_LBRACE] = ACTIONS(12260),
    [anon_sym_DOLLAR] = ACTIONS(12260),
    [anon_sym_COLON_COLON] = ACTIONS(12260),
    [anon_sym_AT] = ACTIONS(12260),
    [anon_sym_true] = ACTIONS(12260),
    [anon_sym_false] = ACTIONS(12260),
    [aux_sym_integer_literal_token1] = ACTIONS(12260),
    [aux_sym_integer_literal_token2] = ACTIONS(12260),
    [aux_sym_integer_literal_token3] = ACTIONS(12260),
    [aux_sym_integer_literal_token4] = ACTIONS(12260),
    [aux_sym_float_literal_token1] = ACTIONS(12260),
    [aux_sym_float_literal_token3] = ACTIONS(12260),
    [aux_sym_float_literal_token4] = ACTIONS(12260),
    [sym_character_literal] = ACTIONS(12260),
    [sym__pair_operator] = ACTIONS(12260),
    [sym__arrow_operator] = ACTIONS(12260),
    [sym__comparison_operator] = ACTIONS(12260),
    [sym__pipe_right_operator] = ACTIONS(12260),
    [sym__pipe_left_operator] = ACTIONS(12260),
    [sym__ellipsis_operator] = ACTIONS(12260),
    [sym__plus_operator] = ACTIONS(12260),
    [sym__times_operator] = ACTIONS(12260),
    [sym__rational_operator] = ACTIONS(12260),
    [sym__bitshift_operator] = ACTIONS(12260),
    [sym__power_operator] = ACTIONS(12260),
    [sym__tilde_operator] = ACTIONS(12260),
    [sym__type_order_operator] = ACTIONS(12260),
    [sym__unary_operator] = ACTIONS(12260),
    [sym__unary_plus_operator] = ACTIONS(12260),
    [aux_sym__terminator_token1] = ACTIONS(12260),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12258),
    [sym__string_start] = ACTIONS(12258),
    [sym__command_start] = ACTIONS(12258),
  },
  [9586] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_LT_COLON] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12298),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [9587] = {
    [aux_sym_for_statement_repeat1] = STATE(9587),
    [sym__word_identifier] = ACTIONS(15241),
    [anon_sym_COMMA] = ACTIONS(15243),
    [anon_sym_COLON] = ACTIONS(15241),
    [anon_sym_begin] = ACTIONS(15241),
    [anon_sym_module] = ACTIONS(15241),
    [anon_sym_baremodule] = ACTIONS(15241),
    [anon_sym_end] = ACTIONS(15241),
    [anon_sym_abstract] = ACTIONS(15241),
    [anon_sym_primitive] = ACTIONS(15241),
    [anon_sym_mutable] = ACTIONS(15241),
    [anon_sym_struct] = ACTIONS(15241),
    [anon_sym_function] = ACTIONS(15241),
    [anon_sym_macro] = ACTIONS(15241),
    [anon_sym_quote] = ACTIONS(15241),
    [anon_sym_let] = ACTIONS(15241),
    [anon_sym_if] = ACTIONS(15241),
    [anon_sym_try] = ACTIONS(15241),
    [anon_sym_for] = ACTIONS(15241),
    [anon_sym_while] = ACTIONS(15241),
    [sym_break_statement] = ACTIONS(15241),
    [sym_continue_statement] = ACTIONS(15241),
    [anon_sym_return] = ACTIONS(15241),
    [anon_sym_const] = ACTIONS(15241),
    [anon_sym_global] = ACTIONS(15241),
    [anon_sym_local] = ACTIONS(15241),
    [anon_sym_LPAREN] = ACTIONS(15241),
    [anon_sym_export] = ACTIONS(15241),
    [anon_sym_import] = ACTIONS(15241),
    [anon_sym_using] = ACTIONS(15241),
    [anon_sym_LBRACK] = ACTIONS(15241),
    [anon_sym_LF] = ACTIONS(15246),
    [anon_sym_LBRACE] = ACTIONS(15241),
    [anon_sym_DOLLAR] = ACTIONS(15241),
    [anon_sym_COLON_COLON] = ACTIONS(15241),
    [anon_sym_AT] = ACTIONS(15241),
    [anon_sym_true] = ACTIONS(15241),
    [anon_sym_false] = ACTIONS(15241),
    [aux_sym_integer_literal_token1] = ACTIONS(15241),
    [aux_sym_integer_literal_token2] = ACTIONS(15241),
    [aux_sym_integer_literal_token3] = ACTIONS(15241),
    [aux_sym_integer_literal_token4] = ACTIONS(15241),
    [aux_sym_float_literal_token1] = ACTIONS(15241),
    [aux_sym_float_literal_token3] = ACTIONS(15241),
    [aux_sym_float_literal_token4] = ACTIONS(15241),
    [sym_character_literal] = ACTIONS(15241),
    [sym__pair_operator] = ACTIONS(15241),
    [sym__arrow_operator] = ACTIONS(15241),
    [sym__comparison_operator] = ACTIONS(15241),
    [sym__pipe_right_operator] = ACTIONS(15241),
    [sym__pipe_left_operator] = ACTIONS(15241),
    [sym__ellipsis_operator] = ACTIONS(15241),
    [sym__plus_operator] = ACTIONS(15241),
    [sym__times_operator] = ACTIONS(15241),
    [sym__rational_operator] = ACTIONS(15241),
    [sym__bitshift_operator] = ACTIONS(15241),
    [sym__power_operator] = ACTIONS(15241),
    [sym__tilde_operator] = ACTIONS(15241),
    [sym__type_order_operator] = ACTIONS(15241),
    [sym__unary_operator] = ACTIONS(15241),
    [sym__unary_plus_operator] = ACTIONS(15241),
    [aux_sym__terminator_token1] = ACTIONS(15241),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(15246),
    [sym__command_start] = ACTIONS(15246),
  },
  [9588] = {
    [sym__word_identifier] = ACTIONS(12264),
    [anon_sym_COLON] = ACTIONS(12264),
    [anon_sym_begin] = ACTIONS(12264),
    [anon_sym_module] = ACTIONS(12264),
    [anon_sym_baremodule] = ACTIONS(12264),
    [anon_sym_end] = ACTIONS(12264),
    [anon_sym_abstract] = ACTIONS(12264),
    [anon_sym_primitive] = ACTIONS(12264),
    [anon_sym_mutable] = ACTIONS(12264),
    [anon_sym_struct] = ACTIONS(12264),
    [anon_sym_LT_COLON] = ACTIONS(12264),
    [anon_sym_function] = ACTIONS(12264),
    [anon_sym_macro] = ACTIONS(12264),
    [anon_sym_quote] = ACTIONS(12264),
    [anon_sym_let] = ACTIONS(12264),
    [anon_sym_if] = ACTIONS(12264),
    [anon_sym_try] = ACTIONS(12264),
    [anon_sym_for] = ACTIONS(12264),
    [anon_sym_while] = ACTIONS(12264),
    [sym_break_statement] = ACTIONS(12264),
    [sym_continue_statement] = ACTIONS(12264),
    [anon_sym_return] = ACTIONS(12264),
    [anon_sym_const] = ACTIONS(12264),
    [anon_sym_global] = ACTIONS(12264),
    [anon_sym_local] = ACTIONS(12264),
    [anon_sym_LPAREN] = ACTIONS(12264),
    [anon_sym_export] = ACTIONS(12264),
    [anon_sym_import] = ACTIONS(12264),
    [anon_sym_using] = ACTIONS(12264),
    [anon_sym_LBRACK] = ACTIONS(12264),
    [anon_sym_LF] = ACTIONS(12262),
    [anon_sym_LBRACE] = ACTIONS(12264),
    [anon_sym_DOLLAR] = ACTIONS(12264),
    [anon_sym_COLON_COLON] = ACTIONS(12264),
    [anon_sym_AT] = ACTIONS(12264),
    [anon_sym_true] = ACTIONS(12264),
    [anon_sym_false] = ACTIONS(12264),
    [aux_sym_integer_literal_token1] = ACTIONS(12264),
    [aux_sym_integer_literal_token2] = ACTIONS(12264),
    [aux_sym_integer_literal_token3] = ACTIONS(12264),
    [aux_sym_integer_literal_token4] = ACTIONS(12264),
    [aux_sym_float_literal_token1] = ACTIONS(12264),
    [aux_sym_float_literal_token3] = ACTIONS(12264),
    [aux_sym_float_literal_token4] = ACTIONS(12264),
    [sym_character_literal] = ACTIONS(12264),
    [sym__pair_operator] = ACTIONS(12264),
    [sym__arrow_operator] = ACTIONS(12264),
    [sym__comparison_operator] = ACTIONS(12264),
    [sym__pipe_right_operator] = ACTIONS(12264),
    [sym__pipe_left_operator] = ACTIONS(12264),
    [sym__ellipsis_operator] = ACTIONS(12264),
    [sym__plus_operator] = ACTIONS(12264),
    [sym__times_operator] = ACTIONS(12264),
    [sym__rational_operator] = ACTIONS(12264),
    [sym__bitshift_operator] = ACTIONS(12264),
    [sym__power_operator] = ACTIONS(12264),
    [sym__tilde_operator] = ACTIONS(12264),
    [sym__type_order_operator] = ACTIONS(12264),
    [sym__unary_operator] = ACTIONS(12264),
    [sym__unary_plus_operator] = ACTIONS(12264),
    [aux_sym__terminator_token1] = ACTIONS(12264),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12262),
    [sym__string_start] = ACTIONS(12262),
    [sym__command_start] = ACTIONS(12262),
  },
  [9589] = {
    [sym__word_identifier] = ACTIONS(12178),
    [anon_sym_COLON] = ACTIONS(12178),
    [anon_sym_begin] = ACTIONS(12178),
    [anon_sym_module] = ACTIONS(12178),
    [anon_sym_baremodule] = ACTIONS(12178),
    [anon_sym_end] = ACTIONS(12178),
    [anon_sym_abstract] = ACTIONS(12178),
    [anon_sym_primitive] = ACTIONS(12178),
    [anon_sym_mutable] = ACTIONS(12178),
    [anon_sym_struct] = ACTIONS(12178),
    [anon_sym_LT_COLON] = ACTIONS(12178),
    [anon_sym_function] = ACTIONS(12178),
    [anon_sym_macro] = ACTIONS(12178),
    [anon_sym_quote] = ACTIONS(12178),
    [anon_sym_let] = ACTIONS(12178),
    [anon_sym_if] = ACTIONS(12178),
    [anon_sym_try] = ACTIONS(12178),
    [anon_sym_for] = ACTIONS(12178),
    [anon_sym_while] = ACTIONS(12178),
    [sym_break_statement] = ACTIONS(12178),
    [sym_continue_statement] = ACTIONS(12178),
    [anon_sym_return] = ACTIONS(12178),
    [anon_sym_const] = ACTIONS(12178),
    [anon_sym_global] = ACTIONS(12178),
    [anon_sym_local] = ACTIONS(12178),
    [anon_sym_LPAREN] = ACTIONS(12178),
    [anon_sym_export] = ACTIONS(12178),
    [anon_sym_import] = ACTIONS(12178),
    [anon_sym_using] = ACTIONS(12178),
    [anon_sym_LBRACK] = ACTIONS(12178),
    [anon_sym_LF] = ACTIONS(12176),
    [anon_sym_LBRACE] = ACTIONS(12178),
    [anon_sym_DOLLAR] = ACTIONS(12178),
    [anon_sym_COLON_COLON] = ACTIONS(12178),
    [anon_sym_AT] = ACTIONS(12178),
    [anon_sym_true] = ACTIONS(12178),
    [anon_sym_false] = ACTIONS(12178),
    [aux_sym_integer_literal_token1] = ACTIONS(12178),
    [aux_sym_integer_literal_token2] = ACTIONS(12178),
    [aux_sym_integer_literal_token3] = ACTIONS(12178),
    [aux_sym_integer_literal_token4] = ACTIONS(12178),
    [aux_sym_float_literal_token1] = ACTIONS(12178),
    [aux_sym_float_literal_token3] = ACTIONS(12178),
    [aux_sym_float_literal_token4] = ACTIONS(12178),
    [sym_character_literal] = ACTIONS(12178),
    [sym__pair_operator] = ACTIONS(12178),
    [sym__arrow_operator] = ACTIONS(12178),
    [sym__comparison_operator] = ACTIONS(12178),
    [sym__pipe_right_operator] = ACTIONS(12178),
    [sym__pipe_left_operator] = ACTIONS(12178),
    [sym__ellipsis_operator] = ACTIONS(12178),
    [sym__plus_operator] = ACTIONS(12178),
    [sym__times_operator] = ACTIONS(12178),
    [sym__rational_operator] = ACTIONS(12178),
    [sym__bitshift_operator] = ACTIONS(12178),
    [sym__power_operator] = ACTIONS(12178),
    [sym__tilde_operator] = ACTIONS(12178),
    [sym__type_order_operator] = ACTIONS(12178),
    [sym__unary_operator] = ACTIONS(12178),
    [sym__unary_plus_operator] = ACTIONS(12178),
    [aux_sym__terminator_token1] = ACTIONS(12178),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12176),
    [sym__string_start] = ACTIONS(12176),
    [sym__command_start] = ACTIONS(12176),
  },
  [9590] = {
    [sym__word_identifier] = ACTIONS(12066),
    [anon_sym_COLON] = ACTIONS(12066),
    [anon_sym_begin] = ACTIONS(12066),
    [anon_sym_module] = ACTIONS(12066),
    [anon_sym_baremodule] = ACTIONS(12066),
    [anon_sym_end] = ACTIONS(12066),
    [anon_sym_abstract] = ACTIONS(12066),
    [anon_sym_primitive] = ACTIONS(12066),
    [anon_sym_mutable] = ACTIONS(12066),
    [anon_sym_struct] = ACTIONS(12066),
    [anon_sym_LT_COLON] = ACTIONS(12066),
    [anon_sym_function] = ACTIONS(12066),
    [anon_sym_macro] = ACTIONS(12066),
    [anon_sym_quote] = ACTIONS(12066),
    [anon_sym_let] = ACTIONS(12066),
    [anon_sym_if] = ACTIONS(12066),
    [anon_sym_try] = ACTIONS(12066),
    [anon_sym_for] = ACTIONS(12066),
    [anon_sym_while] = ACTIONS(12066),
    [sym_break_statement] = ACTIONS(12066),
    [sym_continue_statement] = ACTIONS(12066),
    [anon_sym_return] = ACTIONS(12066),
    [anon_sym_const] = ACTIONS(12066),
    [anon_sym_global] = ACTIONS(12066),
    [anon_sym_local] = ACTIONS(12066),
    [anon_sym_LPAREN] = ACTIONS(12066),
    [anon_sym_export] = ACTIONS(12066),
    [anon_sym_import] = ACTIONS(12066),
    [anon_sym_using] = ACTIONS(12066),
    [anon_sym_LBRACK] = ACTIONS(12066),
    [anon_sym_LF] = ACTIONS(12064),
    [anon_sym_LBRACE] = ACTIONS(12066),
    [anon_sym_DOLLAR] = ACTIONS(12066),
    [anon_sym_COLON_COLON] = ACTIONS(12066),
    [anon_sym_AT] = ACTIONS(12066),
    [anon_sym_true] = ACTIONS(12066),
    [anon_sym_false] = ACTIONS(12066),
    [aux_sym_integer_literal_token1] = ACTIONS(12066),
    [aux_sym_integer_literal_token2] = ACTIONS(12066),
    [aux_sym_integer_literal_token3] = ACTIONS(12066),
    [aux_sym_integer_literal_token4] = ACTIONS(12066),
    [aux_sym_float_literal_token1] = ACTIONS(12066),
    [aux_sym_float_literal_token3] = ACTIONS(12066),
    [aux_sym_float_literal_token4] = ACTIONS(12066),
    [sym_character_literal] = ACTIONS(12066),
    [sym__pair_operator] = ACTIONS(12066),
    [sym__arrow_operator] = ACTIONS(12066),
    [sym__comparison_operator] = ACTIONS(12066),
    [sym__pipe_right_operator] = ACTIONS(12066),
    [sym__pipe_left_operator] = ACTIONS(12066),
    [sym__ellipsis_operator] = ACTIONS(12066),
    [sym__plus_operator] = ACTIONS(12066),
    [sym__times_operator] = ACTIONS(12066),
    [sym__rational_operator] = ACTIONS(12066),
    [sym__bitshift_operator] = ACTIONS(12066),
    [sym__power_operator] = ACTIONS(12066),
    [sym__tilde_operator] = ACTIONS(12066),
    [sym__type_order_operator] = ACTIONS(12066),
    [sym__unary_operator] = ACTIONS(12066),
    [sym__unary_plus_operator] = ACTIONS(12066),
    [aux_sym__terminator_token1] = ACTIONS(12066),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12064),
    [sym__string_start] = ACTIONS(12064),
    [sym__command_start] = ACTIONS(12064),
  },
  [9591] = {
    [sym__word_identifier] = ACTIONS(12276),
    [anon_sym_COLON] = ACTIONS(12276),
    [anon_sym_begin] = ACTIONS(12276),
    [anon_sym_module] = ACTIONS(12276),
    [anon_sym_baremodule] = ACTIONS(12276),
    [anon_sym_end] = ACTIONS(12276),
    [anon_sym_abstract] = ACTIONS(12276),
    [anon_sym_primitive] = ACTIONS(12276),
    [anon_sym_mutable] = ACTIONS(12276),
    [anon_sym_struct] = ACTIONS(12276),
    [anon_sym_LT_COLON] = ACTIONS(12276),
    [anon_sym_function] = ACTIONS(12276),
    [anon_sym_macro] = ACTIONS(12276),
    [anon_sym_quote] = ACTIONS(12276),
    [anon_sym_let] = ACTIONS(12276),
    [anon_sym_if] = ACTIONS(12276),
    [anon_sym_try] = ACTIONS(12276),
    [anon_sym_for] = ACTIONS(12276),
    [anon_sym_while] = ACTIONS(12276),
    [sym_break_statement] = ACTIONS(12276),
    [sym_continue_statement] = ACTIONS(12276),
    [anon_sym_return] = ACTIONS(12276),
    [anon_sym_const] = ACTIONS(12276),
    [anon_sym_global] = ACTIONS(12276),
    [anon_sym_local] = ACTIONS(12276),
    [anon_sym_LPAREN] = ACTIONS(12276),
    [anon_sym_export] = ACTIONS(12276),
    [anon_sym_import] = ACTIONS(12276),
    [anon_sym_using] = ACTIONS(12276),
    [anon_sym_LBRACK] = ACTIONS(12276),
    [anon_sym_LF] = ACTIONS(12274),
    [anon_sym_LBRACE] = ACTIONS(12276),
    [anon_sym_DOLLAR] = ACTIONS(12276),
    [anon_sym_COLON_COLON] = ACTIONS(12276),
    [anon_sym_AT] = ACTIONS(12276),
    [anon_sym_true] = ACTIONS(12276),
    [anon_sym_false] = ACTIONS(12276),
    [aux_sym_integer_literal_token1] = ACTIONS(12276),
    [aux_sym_integer_literal_token2] = ACTIONS(12276),
    [aux_sym_integer_literal_token3] = ACTIONS(12276),
    [aux_sym_integer_literal_token4] = ACTIONS(12276),
    [aux_sym_float_literal_token1] = ACTIONS(12276),
    [aux_sym_float_literal_token3] = ACTIONS(12276),
    [aux_sym_float_literal_token4] = ACTIONS(12276),
    [sym_character_literal] = ACTIONS(12276),
    [sym__pair_operator] = ACTIONS(12276),
    [sym__arrow_operator] = ACTIONS(12276),
    [sym__comparison_operator] = ACTIONS(12276),
    [sym__pipe_right_operator] = ACTIONS(12276),
    [sym__pipe_left_operator] = ACTIONS(12276),
    [sym__ellipsis_operator] = ACTIONS(12276),
    [sym__plus_operator] = ACTIONS(12276),
    [sym__times_operator] = ACTIONS(12276),
    [sym__rational_operator] = ACTIONS(12276),
    [sym__bitshift_operator] = ACTIONS(12276),
    [sym__power_operator] = ACTIONS(12276),
    [sym__tilde_operator] = ACTIONS(12276),
    [sym__type_order_operator] = ACTIONS(12276),
    [sym__unary_operator] = ACTIONS(12276),
    [sym__unary_plus_operator] = ACTIONS(12276),
    [aux_sym__terminator_token1] = ACTIONS(12276),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12274),
    [sym__string_start] = ACTIONS(12274),
    [sym__command_start] = ACTIONS(12274),
  },
  [9592] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_LT_COLON] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12152),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
  [9593] = {
    [sym__word_identifier] = ACTIONS(12280),
    [anon_sym_COLON] = ACTIONS(12280),
    [anon_sym_begin] = ACTIONS(12280),
    [anon_sym_module] = ACTIONS(12280),
    [anon_sym_baremodule] = ACTIONS(12280),
    [anon_sym_end] = ACTIONS(12280),
    [anon_sym_abstract] = ACTIONS(12280),
    [anon_sym_primitive] = ACTIONS(12280),
    [anon_sym_mutable] = ACTIONS(12280),
    [anon_sym_struct] = ACTIONS(12280),
    [anon_sym_LT_COLON] = ACTIONS(12280),
    [anon_sym_function] = ACTIONS(12280),
    [anon_sym_macro] = ACTIONS(12280),
    [anon_sym_quote] = ACTIONS(12280),
    [anon_sym_let] = ACTIONS(12280),
    [anon_sym_if] = ACTIONS(12280),
    [anon_sym_try] = ACTIONS(12280),
    [anon_sym_for] = ACTIONS(12280),
    [anon_sym_while] = ACTIONS(12280),
    [sym_break_statement] = ACTIONS(12280),
    [sym_continue_statement] = ACTIONS(12280),
    [anon_sym_return] = ACTIONS(12280),
    [anon_sym_const] = ACTIONS(12280),
    [anon_sym_global] = ACTIONS(12280),
    [anon_sym_local] = ACTIONS(12280),
    [anon_sym_LPAREN] = ACTIONS(12280),
    [anon_sym_export] = ACTIONS(12280),
    [anon_sym_import] = ACTIONS(12280),
    [anon_sym_using] = ACTIONS(12280),
    [anon_sym_LBRACK] = ACTIONS(12280),
    [anon_sym_LF] = ACTIONS(12278),
    [anon_sym_LBRACE] = ACTIONS(12280),
    [anon_sym_DOLLAR] = ACTIONS(12280),
    [anon_sym_COLON_COLON] = ACTIONS(12280),
    [anon_sym_AT] = ACTIONS(12280),
    [anon_sym_true] = ACTIONS(12280),
    [anon_sym_false] = ACTIONS(12280),
    [aux_sym_integer_literal_token1] = ACTIONS(12280),
    [aux_sym_integer_literal_token2] = ACTIONS(12280),
    [aux_sym_integer_literal_token3] = ACTIONS(12280),
    [aux_sym_integer_literal_token4] = ACTIONS(12280),
    [aux_sym_float_literal_token1] = ACTIONS(12280),
    [aux_sym_float_literal_token3] = ACTIONS(12280),
    [aux_sym_float_literal_token4] = ACTIONS(12280),
    [sym_character_literal] = ACTIONS(12280),
    [sym__pair_operator] = ACTIONS(12280),
    [sym__arrow_operator] = ACTIONS(12280),
    [sym__comparison_operator] = ACTIONS(12280),
    [sym__pipe_right_operator] = ACTIONS(12280),
    [sym__pipe_left_operator] = ACTIONS(12280),
    [sym__ellipsis_operator] = ACTIONS(12280),
    [sym__plus_operator] = ACTIONS(12280),
    [sym__times_operator] = ACTIONS(12280),
    [sym__rational_operator] = ACTIONS(12280),
    [sym__bitshift_operator] = ACTIONS(12280),
    [sym__power_operator] = ACTIONS(12280),
    [sym__tilde_operator] = ACTIONS(12280),
    [sym__type_order_operator] = ACTIONS(12280),
    [sym__unary_operator] = ACTIONS(12280),
    [sym__unary_plus_operator] = ACTIONS(12280),
    [aux_sym__terminator_token1] = ACTIONS(12280),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12278),
    [sym__string_start] = ACTIONS(12278),
    [sym__command_start] = ACTIONS(12278),
  },
  [9594] = {
    [sym__word_identifier] = ACTIONS(11892),
    [anon_sym_COLON] = ACTIONS(11892),
    [anon_sym_begin] = ACTIONS(11892),
    [anon_sym_module] = ACTIONS(11892),
    [anon_sym_baremodule] = ACTIONS(11892),
    [anon_sym_end] = ACTIONS(11892),
    [anon_sym_abstract] = ACTIONS(11892),
    [anon_sym_primitive] = ACTIONS(11892),
    [anon_sym_mutable] = ACTIONS(11892),
    [anon_sym_struct] = ACTIONS(11892),
    [anon_sym_function] = ACTIONS(11892),
    [anon_sym_macro] = ACTIONS(11892),
    [anon_sym_quote] = ACTIONS(11892),
    [anon_sym_let] = ACTIONS(11892),
    [anon_sym_if] = ACTIONS(11892),
    [anon_sym_try] = ACTIONS(11892),
    [anon_sym_for] = ACTIONS(11892),
    [anon_sym_while] = ACTIONS(11892),
    [sym_break_statement] = ACTIONS(11892),
    [sym_continue_statement] = ACTIONS(11892),
    [anon_sym_return] = ACTIONS(11892),
    [anon_sym_const] = ACTIONS(11892),
    [anon_sym_global] = ACTIONS(11892),
    [anon_sym_local] = ACTIONS(11892),
    [anon_sym_LPAREN] = ACTIONS(11892),
    [anon_sym_export] = ACTIONS(11892),
    [anon_sym_import] = ACTIONS(11892),
    [anon_sym_using] = ACTIONS(11892),
    [anon_sym_LBRACK] = ACTIONS(11892),
    [anon_sym_LF] = ACTIONS(11894),
    [anon_sym_LBRACE] = ACTIONS(11892),
    [anon_sym_DOLLAR] = ACTIONS(11892),
    [anon_sym_COLON_COLON] = ACTIONS(11892),
    [anon_sym_AT] = ACTIONS(11892),
    [anon_sym_true] = ACTIONS(11892),
    [anon_sym_false] = ACTIONS(11892),
    [aux_sym_integer_literal_token1] = ACTIONS(11892),
    [aux_sym_integer_literal_token2] = ACTIONS(11892),
    [aux_sym_integer_literal_token3] = ACTIONS(11892),
    [aux_sym_integer_literal_token4] = ACTIONS(11892),
    [aux_sym_float_literal_token1] = ACTIONS(11892),
    [aux_sym_float_literal_token3] = ACTIONS(11892),
    [aux_sym_float_literal_token4] = ACTIONS(11892),
    [sym_character_literal] = ACTIONS(11892),
    [sym__pair_operator] = ACTIONS(11892),
    [sym__arrow_operator] = ACTIONS(11892),
    [sym__comparison_operator] = ACTIONS(11892),
    [sym__pipe_right_operator] = ACTIONS(11892),
    [sym__pipe_left_operator] = ACTIONS(11892),
    [sym__ellipsis_operator] = ACTIONS(11892),
    [sym__plus_operator] = ACTIONS(11892),
    [sym__times_operator] = ACTIONS(11892),
    [sym__rational_operator] = ACTIONS(11892),
    [sym__bitshift_operator] = ACTIONS(11892),
    [sym__power_operator] = ACTIONS(11892),
    [sym__tilde_operator] = ACTIONS(11892),
    [sym__type_order_operator] = ACTIONS(11892),
    [sym__unary_operator] = ACTIONS(11892),
    [sym__unary_plus_operator] = ACTIONS(11892),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11894),
    [sym__command_start] = ACTIONS(11894),
    [sym__immediate_string_start] = ACTIONS(15248),
    [sym__immediate_command_start] = ACTIONS(15250),
  },
  [9595] = {
    [sym__word_identifier] = ACTIONS(12236),
    [anon_sym_COLON] = ACTIONS(12236),
    [anon_sym_begin] = ACTIONS(12236),
    [anon_sym_module] = ACTIONS(12236),
    [anon_sym_baremodule] = ACTIONS(12236),
    [anon_sym_end] = ACTIONS(12236),
    [anon_sym_abstract] = ACTIONS(12236),
    [anon_sym_primitive] = ACTIONS(12236),
    [anon_sym_mutable] = ACTIONS(12236),
    [anon_sym_struct] = ACTIONS(12236),
    [anon_sym_LT_COLON] = ACTIONS(12236),
    [anon_sym_function] = ACTIONS(12236),
    [anon_sym_macro] = ACTIONS(12236),
    [anon_sym_quote] = ACTIONS(12236),
    [anon_sym_let] = ACTIONS(12236),
    [anon_sym_if] = ACTIONS(12236),
    [anon_sym_try] = ACTIONS(12236),
    [anon_sym_for] = ACTIONS(12236),
    [anon_sym_while] = ACTIONS(12236),
    [sym_break_statement] = ACTIONS(12236),
    [sym_continue_statement] = ACTIONS(12236),
    [anon_sym_return] = ACTIONS(12236),
    [anon_sym_const] = ACTIONS(12236),
    [anon_sym_global] = ACTIONS(12236),
    [anon_sym_local] = ACTIONS(12236),
    [anon_sym_LPAREN] = ACTIONS(12236),
    [anon_sym_export] = ACTIONS(12236),
    [anon_sym_import] = ACTIONS(12236),
    [anon_sym_using] = ACTIONS(12236),
    [anon_sym_LBRACK] = ACTIONS(12236),
    [anon_sym_LF] = ACTIONS(12234),
    [anon_sym_LBRACE] = ACTIONS(12236),
    [anon_sym_DOLLAR] = ACTIONS(12236),
    [anon_sym_COLON_COLON] = ACTIONS(12236),
    [anon_sym_AT] = ACTIONS(12236),
    [anon_sym_true] = ACTIONS(12236),
    [anon_sym_false] = ACTIONS(12236),
    [aux_sym_integer_literal_token1] = ACTIONS(12236),
    [aux_sym_integer_literal_token2] = ACTIONS(12236),
    [aux_sym_integer_literal_token3] = ACTIONS(12236),
    [aux_sym_integer_literal_token4] = ACTIONS(12236),
    [aux_sym_float_literal_token1] = ACTIONS(12236),
    [aux_sym_float_literal_token3] = ACTIONS(12236),
    [aux_sym_float_literal_token4] = ACTIONS(12236),
    [sym_character_literal] = ACTIONS(12236),
    [sym__pair_operator] = ACTIONS(12236),
    [sym__arrow_operator] = ACTIONS(12236),
    [sym__comparison_operator] = ACTIONS(12236),
    [sym__pipe_right_operator] = ACTIONS(12236),
    [sym__pipe_left_operator] = ACTIONS(12236),
    [sym__ellipsis_operator] = ACTIONS(12236),
    [sym__plus_operator] = ACTIONS(12236),
    [sym__times_operator] = ACTIONS(12236),
    [sym__rational_operator] = ACTIONS(12236),
    [sym__bitshift_operator] = ACTIONS(12236),
    [sym__power_operator] = ACTIONS(12236),
    [sym__tilde_operator] = ACTIONS(12236),
    [sym__type_order_operator] = ACTIONS(12236),
    [sym__unary_operator] = ACTIONS(12236),
    [sym__unary_plus_operator] = ACTIONS(12236),
    [aux_sym__terminator_token1] = ACTIONS(12236),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12234),
    [sym__string_start] = ACTIONS(12234),
    [sym__command_start] = ACTIONS(12234),
  },
  [9596] = {
    [sym__word_identifier] = ACTIONS(12240),
    [anon_sym_COLON] = ACTIONS(12240),
    [anon_sym_begin] = ACTIONS(12240),
    [anon_sym_module] = ACTIONS(12240),
    [anon_sym_baremodule] = ACTIONS(12240),
    [anon_sym_end] = ACTIONS(12240),
    [anon_sym_abstract] = ACTIONS(12240),
    [anon_sym_primitive] = ACTIONS(12240),
    [anon_sym_mutable] = ACTIONS(12240),
    [anon_sym_struct] = ACTIONS(12240),
    [anon_sym_LT_COLON] = ACTIONS(12240),
    [anon_sym_function] = ACTIONS(12240),
    [anon_sym_macro] = ACTIONS(12240),
    [anon_sym_quote] = ACTIONS(12240),
    [anon_sym_let] = ACTIONS(12240),
    [anon_sym_if] = ACTIONS(12240),
    [anon_sym_try] = ACTIONS(12240),
    [anon_sym_for] = ACTIONS(12240),
    [anon_sym_while] = ACTIONS(12240),
    [sym_break_statement] = ACTIONS(12240),
    [sym_continue_statement] = ACTIONS(12240),
    [anon_sym_return] = ACTIONS(12240),
    [anon_sym_const] = ACTIONS(12240),
    [anon_sym_global] = ACTIONS(12240),
    [anon_sym_local] = ACTIONS(12240),
    [anon_sym_LPAREN] = ACTIONS(12240),
    [anon_sym_export] = ACTIONS(12240),
    [anon_sym_import] = ACTIONS(12240),
    [anon_sym_using] = ACTIONS(12240),
    [anon_sym_LBRACK] = ACTIONS(12240),
    [anon_sym_LF] = ACTIONS(12238),
    [anon_sym_LBRACE] = ACTIONS(12240),
    [anon_sym_DOLLAR] = ACTIONS(12240),
    [anon_sym_COLON_COLON] = ACTIONS(12240),
    [anon_sym_AT] = ACTIONS(12240),
    [anon_sym_true] = ACTIONS(12240),
    [anon_sym_false] = ACTIONS(12240),
    [aux_sym_integer_literal_token1] = ACTIONS(12240),
    [aux_sym_integer_literal_token2] = ACTIONS(12240),
    [aux_sym_integer_literal_token3] = ACTIONS(12240),
    [aux_sym_integer_literal_token4] = ACTIONS(12240),
    [aux_sym_float_literal_token1] = ACTIONS(12240),
    [aux_sym_float_literal_token3] = ACTIONS(12240),
    [aux_sym_float_literal_token4] = ACTIONS(12240),
    [sym_character_literal] = ACTIONS(12240),
    [sym__pair_operator] = ACTIONS(12240),
    [sym__arrow_operator] = ACTIONS(12240),
    [sym__comparison_operator] = ACTIONS(12240),
    [sym__pipe_right_operator] = ACTIONS(12240),
    [sym__pipe_left_operator] = ACTIONS(12240),
    [sym__ellipsis_operator] = ACTIONS(12240),
    [sym__plus_operator] = ACTIONS(12240),
    [sym__times_operator] = ACTIONS(12240),
    [sym__rational_operator] = ACTIONS(12240),
    [sym__bitshift_operator] = ACTIONS(12240),
    [sym__power_operator] = ACTIONS(12240),
    [sym__tilde_operator] = ACTIONS(12240),
    [sym__type_order_operator] = ACTIONS(12240),
    [sym__unary_operator] = ACTIONS(12240),
    [sym__unary_plus_operator] = ACTIONS(12240),
    [aux_sym__terminator_token1] = ACTIONS(12240),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_brace] = ACTIONS(12238),
    [sym__string_start] = ACTIONS(12238),
    [sym__command_start] = ACTIONS(12238),
  },
  [9597] = {
    [sym__word_identifier] = ACTIONS(12292),
    [anon_sym_COLON] = ACTIONS(12292),
    [anon_sym_begin] = ACTIONS(12292),
    [anon_sym_module] = ACTIONS(12292),
    [anon_sym_baremodule] = ACTIONS(12292),
    [anon_sym_end] = ACTIONS(12292),
    [anon_sym_abstract] = ACTIONS(12292),
    [anon_sym_primitive] = ACTIONS(12292),
    [anon_sym_mutable] = ACTIONS(12292),
    [anon_sym_struct] = ACTIONS(12292),
    [anon_sym_LT_COLON] = ACTIONS(12292),
    [anon_sym_function] = ACTIONS(12292),
    [anon_sym_macro] = ACTIONS(12292),
    [anon_sym_quote] = ACTIONS(12292),
    [anon_sym_let] = ACTIONS(12292),
    [anon_sym_if] = ACTIONS(12292),
    [anon_sym_try] = ACTIONS(12292),
    [anon_sym_for] = ACTIONS(12292),
    [anon_sym_while] = ACTIONS(12292),
    [sym_break_statement] = ACTIONS(12292),
    [sym_continue_statement] = ACTIONS(12292),
    [anon_sym_return] = ACTIONS(12292),
    [anon_sym_const] = ACTIONS(12292),
    [anon_sym_global] = ACTIONS(12292),
    [anon_sym_local] = ACTIONS(12292),
    [anon_sym_LPAREN] = ACTIONS(12292),
    [anon_sym_export] = ACTIONS(12292),
    [anon_sym_import] = ACTIONS(12292),
    [anon_sym_using] = ACTIONS(12292),
    [anon_sym_LBRACK] = ACTIONS(12292),
    [anon_sym_LF] = ACTIONS(12290),
    [anon_sym_LBRACE] = ACTIONS(12292),
    [anon_sym_DOLLAR] = ACTIONS(12292),
    [anon_sym_COLON_COLON] = ACTIONS(12292),
    [anon_sym_AT] = ACTIONS(12292),
    [anon_sym_true] = ACTIONS(12292),
    [anon_sym_false] = ACTIONS(12292),
    [aux_sym_integer_literal_token1] = ACTIONS(12292),
    [aux_sym_integer_literal_token2] = ACTIONS(12292),
    [aux_sym_integer_literal_token3] = ACTIONS(12292),
    [aux_sym_integer_literal_token4] = ACTIONS(12292),
    [aux_sym_float_literal_token1] = ACTIONS(12292),
    [aux_sym_float_literal_token3] = ACTIONS(12292),
    [aux_sym_float_literal_token4] = ACTIONS(12292),
    [sym_character_literal] = ACTIONS(12292),
    [sym__pair_operator] = ACTIONS(12292),
    [sym__arrow_operator] = ACTIONS(12292),
    [sym__comparison_operator] = ACTIONS(12292),
    [sym__pipe_right_operator] = ACTIONS(12292),
    [sym__pipe_left_operator] = ACTIONS(12292),
    [sym__ellipsis_operator] = ACTIONS(12292),
    [sym__plus_operator] = ACTIONS(12292),
    [sym__times_operator] = ACTIONS(12292),
    [sym__rational_operator] = ACTIONS(12292),
    [sym__bitshift_operator] = ACTIONS(12292),
    [sym__power_operator] = ACTIONS(12292),
    [sym__tilde_operator] = ACTIONS(12292),
    [sym__type_order_operator] = ACTIONS(12292),
    [sym__unary_operator] = ACTIONS(12292),
    [sym__unary_plus_operator] = ACTIONS(12292),
    [aux_sym__terminator_token1] = ACTIONS(12292),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12290),
    [sym__command_start] = ACTIONS(12290),
  },
  [9598] = {
    [sym_identifier] = STATE(9647),
    [sym__word_identifier] = ACTIONS(12006),
    [anon_sym_COLON] = ACTIONS(12006),
    [anon_sym_begin] = ACTIONS(12006),
    [anon_sym_module] = ACTIONS(12006),
    [anon_sym_baremodule] = ACTIONS(12006),
    [anon_sym_end] = ACTIONS(12006),
    [anon_sym_abstract] = ACTIONS(12006),
    [anon_sym_primitive] = ACTIONS(12006),
    [anon_sym_mutable] = ACTIONS(12006),
    [anon_sym_struct] = ACTIONS(12006),
    [anon_sym_function] = ACTIONS(12006),
    [anon_sym_macro] = ACTIONS(12006),
    [anon_sym_quote] = ACTIONS(12006),
    [anon_sym_let] = ACTIONS(12006),
    [anon_sym_if] = ACTIONS(12006),
    [anon_sym_try] = ACTIONS(12006),
    [anon_sym_for] = ACTIONS(12006),
    [anon_sym_while] = ACTIONS(12006),
    [sym_break_statement] = ACTIONS(12006),
    [sym_continue_statement] = ACTIONS(12006),
    [anon_sym_return] = ACTIONS(12006),
    [anon_sym_const] = ACTIONS(12006),
    [anon_sym_global] = ACTIONS(12006),
    [anon_sym_local] = ACTIONS(12006),
    [anon_sym_LPAREN] = ACTIONS(12006),
    [anon_sym_export] = ACTIONS(12006),
    [anon_sym_import] = ACTIONS(12006),
    [anon_sym_using] = ACTIONS(12006),
    [anon_sym_LBRACK] = ACTIONS(12006),
    [anon_sym_LF] = ACTIONS(12008),
    [anon_sym_LBRACE] = ACTIONS(12006),
    [anon_sym_DOLLAR] = ACTIONS(12006),
    [anon_sym_COLON_COLON] = ACTIONS(12006),
    [anon_sym_AT] = ACTIONS(12006),
    [anon_sym_true] = ACTIONS(12006),
    [anon_sym_false] = ACTIONS(12006),
    [aux_sym_integer_literal_token1] = ACTIONS(12006),
    [aux_sym_integer_literal_token2] = ACTIONS(12006),
    [aux_sym_integer_literal_token3] = ACTIONS(12006),
    [aux_sym_integer_literal_token4] = ACTIONS(12006),
    [aux_sym_float_literal_token1] = ACTIONS(12006),
    [aux_sym_float_literal_token3] = ACTIONS(12006),
    [aux_sym_float_literal_token4] = ACTIONS(12006),
    [sym_character_literal] = ACTIONS(12006),
    [sym__pair_operator] = ACTIONS(12006),
    [sym__arrow_operator] = ACTIONS(12006),
    [sym__comparison_operator] = ACTIONS(12006),
    [sym__pipe_right_operator] = ACTIONS(12006),
    [sym__pipe_left_operator] = ACTIONS(12006),
    [sym__ellipsis_operator] = ACTIONS(12006),
    [sym__plus_operator] = ACTIONS(12006),
    [sym__times_operator] = ACTIONS(12006),
    [sym__rational_operator] = ACTIONS(12006),
    [sym__bitshift_operator] = ACTIONS(12006),
    [sym__power_operator] = ACTIONS(12006),
    [sym__tilde_operator] = ACTIONS(12006),
    [sym__type_order_operator] = ACTIONS(12006),
    [sym__unary_operator] = ACTIONS(12006),
    [sym__unary_plus_operator] = ACTIONS(12006),
    [aux_sym__terminator_token1] = ACTIONS(12006),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12008),
    [sym__command_start] = ACTIONS(12008),
  },
  [9599] = {
    [sym_identifier] = STATE(9656),
    [sym__word_identifier] = ACTIONS(12002),
    [anon_sym_COLON] = ACTIONS(12002),
    [anon_sym_begin] = ACTIONS(12002),
    [anon_sym_module] = ACTIONS(12002),
    [anon_sym_baremodule] = ACTIONS(12002),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_abstract] = ACTIONS(12002),
    [anon_sym_primitive] = ACTIONS(12002),
    [anon_sym_mutable] = ACTIONS(12002),
    [anon_sym_struct] = ACTIONS(12002),
    [anon_sym_function] = ACTIONS(12002),
    [anon_sym_macro] = ACTIONS(12002),
    [anon_sym_quote] = ACTIONS(12002),
    [anon_sym_let] = ACTIONS(12002),
    [anon_sym_if] = ACTIONS(12002),
    [anon_sym_try] = ACTIONS(12002),
    [anon_sym_for] = ACTIONS(12002),
    [anon_sym_while] = ACTIONS(12002),
    [sym_break_statement] = ACTIONS(12002),
    [sym_continue_statement] = ACTIONS(12002),
    [anon_sym_return] = ACTIONS(12002),
    [anon_sym_const] = ACTIONS(12002),
    [anon_sym_global] = ACTIONS(12002),
    [anon_sym_local] = ACTIONS(12002),
    [anon_sym_LPAREN] = ACTIONS(12002),
    [anon_sym_export] = ACTIONS(12002),
    [anon_sym_import] = ACTIONS(12002),
    [anon_sym_using] = ACTIONS(12002),
    [anon_sym_LBRACK] = ACTIONS(12002),
    [anon_sym_LF] = ACTIONS(12004),
    [anon_sym_LBRACE] = ACTIONS(12002),
    [anon_sym_DOLLAR] = ACTIONS(12002),
    [anon_sym_COLON_COLON] = ACTIONS(12002),
    [anon_sym_AT] = ACTIONS(12002),
    [anon_sym_true] = ACTIONS(12002),
    [anon_sym_false] = ACTIONS(12002),
    [aux_sym_integer_literal_token1] = ACTIONS(12002),
    [aux_sym_integer_literal_token2] = ACTIONS(12002),
    [aux_sym_integer_literal_token3] = ACTIONS(12002),
    [aux_sym_integer_literal_token4] = ACTIONS(12002),
    [aux_sym_float_literal_token1] = ACTIONS(12002),
    [aux_sym_float_literal_token3] = ACTIONS(12002),
    [aux_sym_float_literal_token4] = ACTIONS(12002),
    [sym_character_literal] = ACTIONS(12002),
    [sym__pair_operator] = ACTIONS(12002),
    [sym__arrow_operator] = ACTIONS(12002),
    [sym__comparison_operator] = ACTIONS(12002),
    [sym__pipe_right_operator] = ACTIONS(12002),
    [sym__pipe_left_operator] = ACTIONS(12002),
    [sym__ellipsis_operator] = ACTIONS(12002),
    [sym__plus_operator] = ACTIONS(12002),
    [sym__times_operator] = ACTIONS(12002),
    [sym__rational_operator] = ACTIONS(12002),
    [sym__bitshift_operator] = ACTIONS(12002),
    [sym__power_operator] = ACTIONS(12002),
    [sym__tilde_operator] = ACTIONS(12002),
    [sym__type_order_operator] = ACTIONS(12002),
    [sym__unary_operator] = ACTIONS(12002),
    [sym__unary_plus_operator] = ACTIONS(12002),
    [aux_sym__terminator_token1] = ACTIONS(12002),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12004),
    [sym__command_start] = ACTIONS(12004),
  },
  [9600] = {
    [sym__word_identifier] = ACTIONS(11980),
    [anon_sym_COLON] = ACTIONS(11980),
    [anon_sym_begin] = ACTIONS(11980),
    [anon_sym_module] = ACTIONS(11980),
    [anon_sym_baremodule] = ACTIONS(11980),
    [anon_sym_end] = ACTIONS(11980),
    [anon_sym_abstract] = ACTIONS(11980),
    [anon_sym_primitive] = ACTIONS(11980),
    [anon_sym_mutable] = ACTIONS(11980),
    [anon_sym_struct] = ACTIONS(11980),
    [anon_sym_function] = ACTIONS(11980),
    [anon_sym_macro] = ACTIONS(11980),
    [anon_sym_where] = ACTIONS(11980),
    [anon_sym_quote] = ACTIONS(11980),
    [anon_sym_let] = ACTIONS(11980),
    [anon_sym_if] = ACTIONS(11980),
    [anon_sym_try] = ACTIONS(11980),
    [anon_sym_for] = ACTIONS(11980),
    [anon_sym_while] = ACTIONS(11980),
    [sym_break_statement] = ACTIONS(11980),
    [sym_continue_statement] = ACTIONS(11980),
    [anon_sym_return] = ACTIONS(11980),
    [anon_sym_const] = ACTIONS(11980),
    [anon_sym_global] = ACTIONS(11980),
    [anon_sym_local] = ACTIONS(11980),
    [anon_sym_LPAREN] = ACTIONS(11980),
    [anon_sym_export] = ACTIONS(11980),
    [anon_sym_import] = ACTIONS(11980),
    [anon_sym_using] = ACTIONS(11980),
    [anon_sym_LBRACK] = ACTIONS(11980),
    [anon_sym_LF] = ACTIONS(11982),
    [anon_sym_LBRACE] = ACTIONS(11980),
    [anon_sym_DOLLAR] = ACTIONS(11980),
    [anon_sym_COLON_COLON] = ACTIONS(11980),
    [anon_sym_AT] = ACTIONS(11980),
    [anon_sym_true] = ACTIONS(11980),
    [anon_sym_false] = ACTIONS(11980),
    [aux_sym_integer_literal_token1] = ACTIONS(11980),
    [aux_sym_integer_literal_token2] = ACTIONS(11980),
    [aux_sym_integer_literal_token3] = ACTIONS(11980),
    [aux_sym_integer_literal_token4] = ACTIONS(11980),
    [aux_sym_float_literal_token1] = ACTIONS(11980),
    [aux_sym_float_literal_token3] = ACTIONS(11980),
    [aux_sym_float_literal_token4] = ACTIONS(11980),
    [sym_character_literal] = ACTIONS(11980),
    [sym__pair_operator] = ACTIONS(11980),
    [sym__arrow_operator] = ACTIONS(11980),
    [sym__comparison_operator] = ACTIONS(11980),
    [sym__pipe_right_operator] = ACTIONS(11980),
    [sym__pipe_left_operator] = ACTIONS(11980),
    [sym__ellipsis_operator] = ACTIONS(11980),
    [sym__plus_operator] = ACTIONS(11980),
    [sym__times_operator] = ACTIONS(11980),
    [sym__rational_operator] = ACTIONS(11980),
    [sym__bitshift_operator] = ACTIONS(11980),
    [sym__power_operator] = ACTIONS(11980),
    [sym__tilde_operator] = ACTIONS(11980),
    [sym__type_order_operator] = ACTIONS(11980),
    [sym__unary_operator] = ACTIONS(11980),
    [sym__unary_plus_operator] = ACTIONS(11980),
    [aux_sym__terminator_token1] = ACTIONS(11980),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11982),
    [sym__command_start] = ACTIONS(11982),
  },
  [9601] = {
    [sym__word_identifier] = ACTIONS(12300),
    [anon_sym_COLON] = ACTIONS(12300),
    [anon_sym_begin] = ACTIONS(12300),
    [anon_sym_module] = ACTIONS(12300),
    [anon_sym_baremodule] = ACTIONS(12300),
    [anon_sym_end] = ACTIONS(12300),
    [anon_sym_abstract] = ACTIONS(12300),
    [anon_sym_primitive] = ACTIONS(12300),
    [anon_sym_mutable] = ACTIONS(12300),
    [anon_sym_struct] = ACTIONS(12300),
    [anon_sym_LT_COLON] = ACTIONS(12300),
    [anon_sym_function] = ACTIONS(12300),
    [anon_sym_macro] = ACTIONS(12300),
    [anon_sym_quote] = ACTIONS(12300),
    [anon_sym_let] = ACTIONS(12300),
    [anon_sym_if] = ACTIONS(12300),
    [anon_sym_try] = ACTIONS(12300),
    [anon_sym_for] = ACTIONS(12300),
    [anon_sym_while] = ACTIONS(12300),
    [sym_break_statement] = ACTIONS(12300),
    [sym_continue_statement] = ACTIONS(12300),
    [anon_sym_return] = ACTIONS(12300),
    [anon_sym_const] = ACTIONS(12300),
    [anon_sym_global] = ACTIONS(12300),
    [anon_sym_local] = ACTIONS(12300),
    [anon_sym_LPAREN] = ACTIONS(12300),
    [anon_sym_export] = ACTIONS(12300),
    [anon_sym_import] = ACTIONS(12300),
    [anon_sym_using] = ACTIONS(12300),
    [anon_sym_LBRACK] = ACTIONS(12300),
    [anon_sym_LF] = ACTIONS(12298),
    [anon_sym_LBRACE] = ACTIONS(12300),
    [anon_sym_DOLLAR] = ACTIONS(12300),
    [anon_sym_COLON_COLON] = ACTIONS(12300),
    [anon_sym_AT] = ACTIONS(12300),
    [anon_sym_true] = ACTIONS(12300),
    [anon_sym_false] = ACTIONS(12300),
    [aux_sym_integer_literal_token1] = ACTIONS(12300),
    [aux_sym_integer_literal_token2] = ACTIONS(12300),
    [aux_sym_integer_literal_token3] = ACTIONS(12300),
    [aux_sym_integer_literal_token4] = ACTIONS(12300),
    [aux_sym_float_literal_token1] = ACTIONS(12300),
    [aux_sym_float_literal_token3] = ACTIONS(12300),
    [aux_sym_float_literal_token4] = ACTIONS(12300),
    [sym_character_literal] = ACTIONS(12300),
    [sym__pair_operator] = ACTIONS(12300),
    [sym__arrow_operator] = ACTIONS(12300),
    [sym__comparison_operator] = ACTIONS(12300),
    [sym__pipe_right_operator] = ACTIONS(12300),
    [sym__pipe_left_operator] = ACTIONS(12300),
    [sym__ellipsis_operator] = ACTIONS(12300),
    [sym__plus_operator] = ACTIONS(12300),
    [sym__times_operator] = ACTIONS(12300),
    [sym__rational_operator] = ACTIONS(12300),
    [sym__bitshift_operator] = ACTIONS(12300),
    [sym__power_operator] = ACTIONS(12300),
    [sym__tilde_operator] = ACTIONS(12300),
    [sym__type_order_operator] = ACTIONS(12300),
    [sym__unary_operator] = ACTIONS(12300),
    [sym__unary_plus_operator] = ACTIONS(12300),
    [aux_sym__terminator_token1] = ACTIONS(12300),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12298),
    [sym__command_start] = ACTIONS(12298),
  },
  [9602] = {
    [sym__word_identifier] = ACTIONS(12094),
    [anon_sym_COLON] = ACTIONS(12094),
    [anon_sym_begin] = ACTIONS(12094),
    [anon_sym_module] = ACTIONS(12094),
    [anon_sym_baremodule] = ACTIONS(12094),
    [anon_sym_end] = ACTIONS(12094),
    [anon_sym_abstract] = ACTIONS(12094),
    [anon_sym_primitive] = ACTIONS(12094),
    [anon_sym_mutable] = ACTIONS(12094),
    [anon_sym_struct] = ACTIONS(12094),
    [anon_sym_function] = ACTIONS(12094),
    [anon_sym_macro] = ACTIONS(12094),
    [anon_sym_quote] = ACTIONS(12094),
    [anon_sym_let] = ACTIONS(12094),
    [anon_sym_if] = ACTIONS(12094),
    [anon_sym_try] = ACTIONS(12094),
    [anon_sym_for] = ACTIONS(12094),
    [anon_sym_while] = ACTIONS(12094),
    [sym_break_statement] = ACTIONS(12094),
    [sym_continue_statement] = ACTIONS(12094),
    [anon_sym_return] = ACTIONS(12094),
    [anon_sym_const] = ACTIONS(12094),
    [anon_sym_global] = ACTIONS(12094),
    [anon_sym_local] = ACTIONS(12094),
    [anon_sym_LPAREN] = ACTIONS(12094),
    [anon_sym_export] = ACTIONS(12094),
    [anon_sym_import] = ACTIONS(12094),
    [anon_sym_using] = ACTIONS(12094),
    [anon_sym_LBRACK] = ACTIONS(12094),
    [anon_sym_LF] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12094),
    [anon_sym_DOLLAR] = ACTIONS(12094),
    [anon_sym_COLON_COLON] = ACTIONS(12094),
    [anon_sym_AT] = ACTIONS(12094),
    [anon_sym_true] = ACTIONS(12094),
    [anon_sym_false] = ACTIONS(12094),
    [aux_sym_integer_literal_token1] = ACTIONS(12094),
    [aux_sym_integer_literal_token2] = ACTIONS(12094),
    [aux_sym_integer_literal_token3] = ACTIONS(12094),
    [aux_sym_integer_literal_token4] = ACTIONS(12094),
    [aux_sym_float_literal_token1] = ACTIONS(12094),
    [aux_sym_float_literal_token2] = ACTIONS(15252),
    [aux_sym_float_literal_token3] = ACTIONS(12094),
    [aux_sym_float_literal_token4] = ACTIONS(12094),
    [sym_character_literal] = ACTIONS(12094),
    [sym__pair_operator] = ACTIONS(12094),
    [sym__arrow_operator] = ACTIONS(12094),
    [sym__comparison_operator] = ACTIONS(12094),
    [sym__pipe_right_operator] = ACTIONS(12094),
    [sym__pipe_left_operator] = ACTIONS(12094),
    [sym__ellipsis_operator] = ACTIONS(12094),
    [sym__plus_operator] = ACTIONS(12094),
    [sym__times_operator] = ACTIONS(12094),
    [sym__rational_operator] = ACTIONS(12094),
    [sym__bitshift_operator] = ACTIONS(12094),
    [sym__power_operator] = ACTIONS(12094),
    [sym__tilde_operator] = ACTIONS(12094),
    [sym__type_order_operator] = ACTIONS(12094),
    [sym__unary_operator] = ACTIONS(12094),
    [sym__unary_plus_operator] = ACTIONS(12094),
    [aux_sym__terminator_token1] = ACTIONS(12094),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12096),
    [sym__command_start] = ACTIONS(12096),
  },
  [9603] = {
    [sym__word_identifier] = ACTIONS(11988),
    [anon_sym_COLON] = ACTIONS(11988),
    [anon_sym_begin] = ACTIONS(11988),
    [anon_sym_module] = ACTIONS(11988),
    [anon_sym_baremodule] = ACTIONS(11988),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_abstract] = ACTIONS(11988),
    [anon_sym_primitive] = ACTIONS(11988),
    [anon_sym_mutable] = ACTIONS(11988),
    [anon_sym_struct] = ACTIONS(11988),
    [anon_sym_function] = ACTIONS(11988),
    [anon_sym_macro] = ACTIONS(11988),
    [anon_sym_where] = ACTIONS(11988),
    [anon_sym_quote] = ACTIONS(11988),
    [anon_sym_let] = ACTIONS(11988),
    [anon_sym_if] = ACTIONS(11988),
    [anon_sym_try] = ACTIONS(11988),
    [anon_sym_for] = ACTIONS(11988),
    [anon_sym_while] = ACTIONS(11988),
    [sym_break_statement] = ACTIONS(11988),
    [sym_continue_statement] = ACTIONS(11988),
    [anon_sym_return] = ACTIONS(11988),
    [anon_sym_const] = ACTIONS(11988),
    [anon_sym_global] = ACTIONS(11988),
    [anon_sym_local] = ACTIONS(11988),
    [anon_sym_LPAREN] = ACTIONS(11988),
    [anon_sym_export] = ACTIONS(11988),
    [anon_sym_import] = ACTIONS(11988),
    [anon_sym_using] = ACTIONS(11988),
    [anon_sym_LBRACK] = ACTIONS(11988),
    [anon_sym_LF] = ACTIONS(11990),
    [anon_sym_LBRACE] = ACTIONS(11988),
    [anon_sym_DOLLAR] = ACTIONS(11988),
    [anon_sym_COLON_COLON] = ACTIONS(11988),
    [anon_sym_AT] = ACTIONS(11988),
    [anon_sym_true] = ACTIONS(11988),
    [anon_sym_false] = ACTIONS(11988),
    [aux_sym_integer_literal_token1] = ACTIONS(11988),
    [aux_sym_integer_literal_token2] = ACTIONS(11988),
    [aux_sym_integer_literal_token3] = ACTIONS(11988),
    [aux_sym_integer_literal_token4] = ACTIONS(11988),
    [aux_sym_float_literal_token1] = ACTIONS(11988),
    [aux_sym_float_literal_token3] = ACTIONS(11988),
    [aux_sym_float_literal_token4] = ACTIONS(11988),
    [sym_character_literal] = ACTIONS(11988),
    [sym__pair_operator] = ACTIONS(11988),
    [sym__arrow_operator] = ACTIONS(11988),
    [sym__comparison_operator] = ACTIONS(11988),
    [sym__pipe_right_operator] = ACTIONS(11988),
    [sym__pipe_left_operator] = ACTIONS(11988),
    [sym__ellipsis_operator] = ACTIONS(11988),
    [sym__plus_operator] = ACTIONS(11988),
    [sym__times_operator] = ACTIONS(11988),
    [sym__rational_operator] = ACTIONS(11988),
    [sym__bitshift_operator] = ACTIONS(11988),
    [sym__power_operator] = ACTIONS(11988),
    [sym__tilde_operator] = ACTIONS(11988),
    [sym__type_order_operator] = ACTIONS(11988),
    [sym__unary_operator] = ACTIONS(11988),
    [sym__unary_plus_operator] = ACTIONS(11988),
    [aux_sym__terminator_token1] = ACTIONS(11988),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11990),
    [sym__command_start] = ACTIONS(11990),
  },
  [9604] = {
    [sym__word_identifier] = ACTIONS(12304),
    [anon_sym_COLON] = ACTIONS(12304),
    [anon_sym_begin] = ACTIONS(12304),
    [anon_sym_module] = ACTIONS(12304),
    [anon_sym_baremodule] = ACTIONS(12304),
    [anon_sym_end] = ACTIONS(12304),
    [anon_sym_abstract] = ACTIONS(12304),
    [anon_sym_primitive] = ACTIONS(12304),
    [anon_sym_mutable] = ACTIONS(12304),
    [anon_sym_struct] = ACTIONS(12304),
    [anon_sym_LT_COLON] = ACTIONS(12304),
    [anon_sym_function] = ACTIONS(12304),
    [anon_sym_macro] = ACTIONS(12304),
    [anon_sym_quote] = ACTIONS(12304),
    [anon_sym_let] = ACTIONS(12304),
    [anon_sym_if] = ACTIONS(12304),
    [anon_sym_try] = ACTIONS(12304),
    [anon_sym_for] = ACTIONS(12304),
    [anon_sym_while] = ACTIONS(12304),
    [sym_break_statement] = ACTIONS(12304),
    [sym_continue_statement] = ACTIONS(12304),
    [anon_sym_return] = ACTIONS(12304),
    [anon_sym_const] = ACTIONS(12304),
    [anon_sym_global] = ACTIONS(12304),
    [anon_sym_local] = ACTIONS(12304),
    [anon_sym_LPAREN] = ACTIONS(12304),
    [anon_sym_export] = ACTIONS(12304),
    [anon_sym_import] = ACTIONS(12304),
    [anon_sym_using] = ACTIONS(12304),
    [anon_sym_LBRACK] = ACTIONS(12304),
    [anon_sym_LF] = ACTIONS(12302),
    [anon_sym_LBRACE] = ACTIONS(12304),
    [anon_sym_DOLLAR] = ACTIONS(12304),
    [anon_sym_COLON_COLON] = ACTIONS(12304),
    [anon_sym_AT] = ACTIONS(12304),
    [anon_sym_true] = ACTIONS(12304),
    [anon_sym_false] = ACTIONS(12304),
    [aux_sym_integer_literal_token1] = ACTIONS(12304),
    [aux_sym_integer_literal_token2] = ACTIONS(12304),
    [aux_sym_integer_literal_token3] = ACTIONS(12304),
    [aux_sym_integer_literal_token4] = ACTIONS(12304),
    [aux_sym_float_literal_token1] = ACTIONS(12304),
    [aux_sym_float_literal_token3] = ACTIONS(12304),
    [aux_sym_float_literal_token4] = ACTIONS(12304),
    [sym_character_literal] = ACTIONS(12304),
    [sym__pair_operator] = ACTIONS(12304),
    [sym__arrow_operator] = ACTIONS(12304),
    [sym__comparison_operator] = ACTIONS(12304),
    [sym__pipe_right_operator] = ACTIONS(12304),
    [sym__pipe_left_operator] = ACTIONS(12304),
    [sym__ellipsis_operator] = ACTIONS(12304),
    [sym__plus_operator] = ACTIONS(12304),
    [sym__times_operator] = ACTIONS(12304),
    [sym__rational_operator] = ACTIONS(12304),
    [sym__bitshift_operator] = ACTIONS(12304),
    [sym__power_operator] = ACTIONS(12304),
    [sym__tilde_operator] = ACTIONS(12304),
    [sym__type_order_operator] = ACTIONS(12304),
    [sym__unary_operator] = ACTIONS(12304),
    [sym__unary_plus_operator] = ACTIONS(12304),
    [aux_sym__terminator_token1] = ACTIONS(12304),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12302),
    [sym__command_start] = ACTIONS(12302),
  },
  [9605] = {
    [sym__word_identifier] = ACTIONS(12024),
    [anon_sym_COLON] = ACTIONS(12024),
    [anon_sym_begin] = ACTIONS(12024),
    [anon_sym_module] = ACTIONS(12024),
    [anon_sym_baremodule] = ACTIONS(12024),
    [anon_sym_end] = ACTIONS(12024),
    [anon_sym_abstract] = ACTIONS(12024),
    [anon_sym_primitive] = ACTIONS(12024),
    [anon_sym_mutable] = ACTIONS(12024),
    [anon_sym_struct] = ACTIONS(12024),
    [anon_sym_function] = ACTIONS(12024),
    [anon_sym_macro] = ACTIONS(12024),
    [anon_sym_where] = ACTIONS(12024),
    [anon_sym_quote] = ACTIONS(12024),
    [anon_sym_let] = ACTIONS(12024),
    [anon_sym_if] = ACTIONS(12024),
    [anon_sym_try] = ACTIONS(12024),
    [anon_sym_for] = ACTIONS(12024),
    [anon_sym_while] = ACTIONS(12024),
    [sym_break_statement] = ACTIONS(12024),
    [sym_continue_statement] = ACTIONS(12024),
    [anon_sym_return] = ACTIONS(12024),
    [anon_sym_const] = ACTIONS(12024),
    [anon_sym_global] = ACTIONS(12024),
    [anon_sym_local] = ACTIONS(12024),
    [anon_sym_LPAREN] = ACTIONS(12024),
    [anon_sym_export] = ACTIONS(12024),
    [anon_sym_import] = ACTIONS(12024),
    [anon_sym_using] = ACTIONS(12024),
    [anon_sym_LBRACK] = ACTIONS(12024),
    [anon_sym_LF] = ACTIONS(12026),
    [anon_sym_LBRACE] = ACTIONS(12024),
    [anon_sym_DOLLAR] = ACTIONS(12024),
    [anon_sym_COLON_COLON] = ACTIONS(12024),
    [anon_sym_AT] = ACTIONS(12024),
    [anon_sym_true] = ACTIONS(12024),
    [anon_sym_false] = ACTIONS(12024),
    [aux_sym_integer_literal_token1] = ACTIONS(12024),
    [aux_sym_integer_literal_token2] = ACTIONS(12024),
    [aux_sym_integer_literal_token3] = ACTIONS(12024),
    [aux_sym_integer_literal_token4] = ACTIONS(12024),
    [aux_sym_float_literal_token1] = ACTIONS(12024),
    [aux_sym_float_literal_token3] = ACTIONS(12024),
    [aux_sym_float_literal_token4] = ACTIONS(12024),
    [sym_character_literal] = ACTIONS(12024),
    [sym__pair_operator] = ACTIONS(12024),
    [sym__arrow_operator] = ACTIONS(12024),
    [sym__comparison_operator] = ACTIONS(12024),
    [sym__pipe_right_operator] = ACTIONS(12024),
    [sym__pipe_left_operator] = ACTIONS(12024),
    [sym__ellipsis_operator] = ACTIONS(12024),
    [sym__plus_operator] = ACTIONS(12024),
    [sym__times_operator] = ACTIONS(12024),
    [sym__rational_operator] = ACTIONS(12024),
    [sym__bitshift_operator] = ACTIONS(12024),
    [sym__power_operator] = ACTIONS(12024),
    [sym__tilde_operator] = ACTIONS(12024),
    [sym__type_order_operator] = ACTIONS(12024),
    [sym__unary_operator] = ACTIONS(12024),
    [sym__unary_plus_operator] = ACTIONS(12024),
    [aux_sym__terminator_token1] = ACTIONS(12024),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12026),
    [sym__command_start] = ACTIONS(12026),
  },
  [9606] = {
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_LF] = ACTIONS(12050),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12048),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12050),
    [sym__command_start] = ACTIONS(12050),
  },
  [9607] = {
    [sym__word_identifier] = ACTIONS(12036),
    [anon_sym_COLON] = ACTIONS(12036),
    [anon_sym_begin] = ACTIONS(12036),
    [anon_sym_module] = ACTIONS(12036),
    [anon_sym_baremodule] = ACTIONS(12036),
    [anon_sym_end] = ACTIONS(12036),
    [anon_sym_abstract] = ACTIONS(12036),
    [anon_sym_primitive] = ACTIONS(12036),
    [anon_sym_mutable] = ACTIONS(12036),
    [anon_sym_struct] = ACTIONS(12036),
    [anon_sym_function] = ACTIONS(12036),
    [anon_sym_macro] = ACTIONS(12036),
    [anon_sym_where] = ACTIONS(12036),
    [anon_sym_quote] = ACTIONS(12036),
    [anon_sym_let] = ACTIONS(12036),
    [anon_sym_if] = ACTIONS(12036),
    [anon_sym_try] = ACTIONS(12036),
    [anon_sym_for] = ACTIONS(12036),
    [anon_sym_while] = ACTIONS(12036),
    [sym_break_statement] = ACTIONS(12036),
    [sym_continue_statement] = ACTIONS(12036),
    [anon_sym_return] = ACTIONS(12036),
    [anon_sym_const] = ACTIONS(12036),
    [anon_sym_global] = ACTIONS(12036),
    [anon_sym_local] = ACTIONS(12036),
    [anon_sym_LPAREN] = ACTIONS(12036),
    [anon_sym_export] = ACTIONS(12036),
    [anon_sym_import] = ACTIONS(12036),
    [anon_sym_using] = ACTIONS(12036),
    [anon_sym_LBRACK] = ACTIONS(12036),
    [anon_sym_LF] = ACTIONS(12038),
    [anon_sym_LBRACE] = ACTIONS(12036),
    [anon_sym_DOLLAR] = ACTIONS(12036),
    [anon_sym_COLON_COLON] = ACTIONS(12036),
    [anon_sym_AT] = ACTIONS(12036),
    [anon_sym_true] = ACTIONS(12036),
    [anon_sym_false] = ACTIONS(12036),
    [aux_sym_integer_literal_token1] = ACTIONS(12036),
    [aux_sym_integer_literal_token2] = ACTIONS(12036),
    [aux_sym_integer_literal_token3] = ACTIONS(12036),
    [aux_sym_integer_literal_token4] = ACTIONS(12036),
    [aux_sym_float_literal_token1] = ACTIONS(12036),
    [aux_sym_float_literal_token3] = ACTIONS(12036),
    [aux_sym_float_literal_token4] = ACTIONS(12036),
    [sym_character_literal] = ACTIONS(12036),
    [sym__pair_operator] = ACTIONS(12036),
    [sym__arrow_operator] = ACTIONS(12036),
    [sym__comparison_operator] = ACTIONS(12036),
    [sym__pipe_right_operator] = ACTIONS(12036),
    [sym__pipe_left_operator] = ACTIONS(12036),
    [sym__ellipsis_operator] = ACTIONS(12036),
    [sym__plus_operator] = ACTIONS(12036),
    [sym__times_operator] = ACTIONS(12036),
    [sym__rational_operator] = ACTIONS(12036),
    [sym__bitshift_operator] = ACTIONS(12036),
    [sym__power_operator] = ACTIONS(12036),
    [sym__tilde_operator] = ACTIONS(12036),
    [sym__type_order_operator] = ACTIONS(12036),
    [sym__unary_operator] = ACTIONS(12036),
    [sym__unary_plus_operator] = ACTIONS(12036),
    [aux_sym__terminator_token1] = ACTIONS(12036),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12038),
    [sym__command_start] = ACTIONS(12038),
  },
  [9608] = {
    [sym__word_identifier] = ACTIONS(12040),
    [anon_sym_COLON] = ACTIONS(12040),
    [anon_sym_begin] = ACTIONS(12040),
    [anon_sym_module] = ACTIONS(12040),
    [anon_sym_baremodule] = ACTIONS(12040),
    [anon_sym_end] = ACTIONS(12040),
    [anon_sym_abstract] = ACTIONS(12040),
    [anon_sym_primitive] = ACTIONS(12040),
    [anon_sym_mutable] = ACTIONS(12040),
    [anon_sym_struct] = ACTIONS(12040),
    [anon_sym_function] = ACTIONS(12040),
    [anon_sym_macro] = ACTIONS(12040),
    [anon_sym_where] = ACTIONS(12040),
    [anon_sym_quote] = ACTIONS(12040),
    [anon_sym_let] = ACTIONS(12040),
    [anon_sym_if] = ACTIONS(12040),
    [anon_sym_try] = ACTIONS(12040),
    [anon_sym_for] = ACTIONS(12040),
    [anon_sym_while] = ACTIONS(12040),
    [sym_break_statement] = ACTIONS(12040),
    [sym_continue_statement] = ACTIONS(12040),
    [anon_sym_return] = ACTIONS(12040),
    [anon_sym_const] = ACTIONS(12040),
    [anon_sym_global] = ACTIONS(12040),
    [anon_sym_local] = ACTIONS(12040),
    [anon_sym_LPAREN] = ACTIONS(12040),
    [anon_sym_export] = ACTIONS(12040),
    [anon_sym_import] = ACTIONS(12040),
    [anon_sym_using] = ACTIONS(12040),
    [anon_sym_LBRACK] = ACTIONS(12040),
    [anon_sym_LF] = ACTIONS(12042),
    [anon_sym_LBRACE] = ACTIONS(12040),
    [anon_sym_DOLLAR] = ACTIONS(12040),
    [anon_sym_COLON_COLON] = ACTIONS(12040),
    [anon_sym_AT] = ACTIONS(12040),
    [anon_sym_true] = ACTIONS(12040),
    [anon_sym_false] = ACTIONS(12040),
    [aux_sym_integer_literal_token1] = ACTIONS(12040),
    [aux_sym_integer_literal_token2] = ACTIONS(12040),
    [aux_sym_integer_literal_token3] = ACTIONS(12040),
    [aux_sym_integer_literal_token4] = ACTIONS(12040),
    [aux_sym_float_literal_token1] = ACTIONS(12040),
    [aux_sym_float_literal_token3] = ACTIONS(12040),
    [aux_sym_float_literal_token4] = ACTIONS(12040),
    [sym_character_literal] = ACTIONS(12040),
    [sym__pair_operator] = ACTIONS(12040),
    [sym__arrow_operator] = ACTIONS(12040),
    [sym__comparison_operator] = ACTIONS(12040),
    [sym__pipe_right_operator] = ACTIONS(12040),
    [sym__pipe_left_operator] = ACTIONS(12040),
    [sym__ellipsis_operator] = ACTIONS(12040),
    [sym__plus_operator] = ACTIONS(12040),
    [sym__times_operator] = ACTIONS(12040),
    [sym__rational_operator] = ACTIONS(12040),
    [sym__bitshift_operator] = ACTIONS(12040),
    [sym__power_operator] = ACTIONS(12040),
    [sym__tilde_operator] = ACTIONS(12040),
    [sym__type_order_operator] = ACTIONS(12040),
    [sym__unary_operator] = ACTIONS(12040),
    [sym__unary_plus_operator] = ACTIONS(12040),
    [aux_sym__terminator_token1] = ACTIONS(12040),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12042),
    [sym__command_start] = ACTIONS(12042),
  },
  [9609] = {
    [sym__word_identifier] = ACTIONS(15241),
    [anon_sym_COMMA] = ACTIONS(15241),
    [anon_sym_COLON] = ACTIONS(15241),
    [anon_sym_begin] = ACTIONS(15241),
    [anon_sym_module] = ACTIONS(15241),
    [anon_sym_baremodule] = ACTIONS(15241),
    [anon_sym_end] = ACTIONS(15241),
    [anon_sym_abstract] = ACTIONS(15241),
    [anon_sym_primitive] = ACTIONS(15241),
    [anon_sym_mutable] = ACTIONS(15241),
    [anon_sym_struct] = ACTIONS(15241),
    [anon_sym_function] = ACTIONS(15241),
    [anon_sym_macro] = ACTIONS(15241),
    [anon_sym_quote] = ACTIONS(15241),
    [anon_sym_let] = ACTIONS(15241),
    [anon_sym_if] = ACTIONS(15241),
    [anon_sym_try] = ACTIONS(15241),
    [anon_sym_for] = ACTIONS(15241),
    [anon_sym_while] = ACTIONS(15241),
    [sym_break_statement] = ACTIONS(15241),
    [sym_continue_statement] = ACTIONS(15241),
    [anon_sym_return] = ACTIONS(15241),
    [anon_sym_const] = ACTIONS(15241),
    [anon_sym_global] = ACTIONS(15241),
    [anon_sym_local] = ACTIONS(15241),
    [anon_sym_LPAREN] = ACTIONS(15241),
    [anon_sym_export] = ACTIONS(15241),
    [anon_sym_import] = ACTIONS(15241),
    [anon_sym_using] = ACTIONS(15241),
    [anon_sym_LBRACK] = ACTIONS(15241),
    [anon_sym_LF] = ACTIONS(15246),
    [anon_sym_LBRACE] = ACTIONS(15241),
    [anon_sym_DOLLAR] = ACTIONS(15241),
    [anon_sym_COLON_COLON] = ACTIONS(15241),
    [anon_sym_AT] = ACTIONS(15241),
    [anon_sym_true] = ACTIONS(15241),
    [anon_sym_false] = ACTIONS(15241),
    [aux_sym_integer_literal_token1] = ACTIONS(15241),
    [aux_sym_integer_literal_token2] = ACTIONS(15241),
    [aux_sym_integer_literal_token3] = ACTIONS(15241),
    [aux_sym_integer_literal_token4] = ACTIONS(15241),
    [aux_sym_float_literal_token1] = ACTIONS(15241),
    [aux_sym_float_literal_token3] = ACTIONS(15241),
    [aux_sym_float_literal_token4] = ACTIONS(15241),
    [sym_character_literal] = ACTIONS(15241),
    [sym__pair_operator] = ACTIONS(15241),
    [sym__arrow_operator] = ACTIONS(15241),
    [sym__comparison_operator] = ACTIONS(15241),
    [sym__pipe_right_operator] = ACTIONS(15241),
    [sym__pipe_left_operator] = ACTIONS(15241),
    [sym__ellipsis_operator] = ACTIONS(15241),
    [sym__plus_operator] = ACTIONS(15241),
    [sym__times_operator] = ACTIONS(15241),
    [sym__rational_operator] = ACTIONS(15241),
    [sym__bitshift_operator] = ACTIONS(15241),
    [sym__power_operator] = ACTIONS(15241),
    [sym__tilde_operator] = ACTIONS(15241),
    [sym__type_order_operator] = ACTIONS(15241),
    [sym__unary_operator] = ACTIONS(15241),
    [sym__unary_plus_operator] = ACTIONS(15241),
    [aux_sym__terminator_token1] = ACTIONS(15241),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(15246),
    [sym__command_start] = ACTIONS(15246),
  },
  [9610] = {
    [sym_identifier] = STATE(9642),
    [sym__word_identifier] = ACTIONS(11992),
    [anon_sym_COLON] = ACTIONS(11992),
    [anon_sym_begin] = ACTIONS(11992),
    [anon_sym_module] = ACTIONS(11992),
    [anon_sym_baremodule] = ACTIONS(11992),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_abstract] = ACTIONS(11992),
    [anon_sym_primitive] = ACTIONS(11992),
    [anon_sym_mutable] = ACTIONS(11992),
    [anon_sym_struct] = ACTIONS(11992),
    [anon_sym_function] = ACTIONS(11992),
    [anon_sym_macro] = ACTIONS(11992),
    [anon_sym_quote] = ACTIONS(11992),
    [anon_sym_let] = ACTIONS(11992),
    [anon_sym_if] = ACTIONS(11992),
    [anon_sym_try] = ACTIONS(11992),
    [anon_sym_for] = ACTIONS(11992),
    [anon_sym_while] = ACTIONS(11992),
    [sym_break_statement] = ACTIONS(11992),
    [sym_continue_statement] = ACTIONS(11992),
    [anon_sym_return] = ACTIONS(11992),
    [anon_sym_const] = ACTIONS(11992),
    [anon_sym_global] = ACTIONS(11992),
    [anon_sym_local] = ACTIONS(11992),
    [anon_sym_LPAREN] = ACTIONS(11992),
    [anon_sym_export] = ACTIONS(11992),
    [anon_sym_import] = ACTIONS(11992),
    [anon_sym_using] = ACTIONS(11992),
    [anon_sym_LBRACK] = ACTIONS(11992),
    [anon_sym_LF] = ACTIONS(11994),
    [anon_sym_LBRACE] = ACTIONS(11992),
    [anon_sym_DOLLAR] = ACTIONS(11992),
    [anon_sym_COLON_COLON] = ACTIONS(11992),
    [anon_sym_AT] = ACTIONS(11992),
    [anon_sym_true] = ACTIONS(11992),
    [anon_sym_false] = ACTIONS(11992),
    [aux_sym_integer_literal_token1] = ACTIONS(11992),
    [aux_sym_integer_literal_token2] = ACTIONS(11992),
    [aux_sym_integer_literal_token3] = ACTIONS(11992),
    [aux_sym_integer_literal_token4] = ACTIONS(11992),
    [aux_sym_float_literal_token1] = ACTIONS(11992),
    [aux_sym_float_literal_token3] = ACTIONS(11992),
    [aux_sym_float_literal_token4] = ACTIONS(11992),
    [sym_character_literal] = ACTIONS(11992),
    [sym__pair_operator] = ACTIONS(11992),
    [sym__arrow_operator] = ACTIONS(11992),
    [sym__comparison_operator] = ACTIONS(11992),
    [sym__pipe_right_operator] = ACTIONS(11992),
    [sym__pipe_left_operator] = ACTIONS(11992),
    [sym__ellipsis_operator] = ACTIONS(11992),
    [sym__plus_operator] = ACTIONS(11992),
    [sym__times_operator] = ACTIONS(11992),
    [sym__rational_operator] = ACTIONS(11992),
    [sym__bitshift_operator] = ACTIONS(11992),
    [sym__power_operator] = ACTIONS(11992),
    [sym__tilde_operator] = ACTIONS(11992),
    [sym__type_order_operator] = ACTIONS(11992),
    [sym__unary_operator] = ACTIONS(11992),
    [sym__unary_plus_operator] = ACTIONS(11992),
    [aux_sym__terminator_token1] = ACTIONS(11992),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11994),
    [sym__command_start] = ACTIONS(11994),
  },
  [9611] = {
    [sym__word_identifier] = ACTIONS(11996),
    [anon_sym_COLON] = ACTIONS(11996),
    [anon_sym_begin] = ACTIONS(11996),
    [anon_sym_module] = ACTIONS(11996),
    [anon_sym_baremodule] = ACTIONS(11996),
    [anon_sym_end] = ACTIONS(11996),
    [anon_sym_abstract] = ACTIONS(11996),
    [anon_sym_primitive] = ACTIONS(11996),
    [anon_sym_mutable] = ACTIONS(11996),
    [anon_sym_struct] = ACTIONS(11996),
    [anon_sym_function] = ACTIONS(11996),
    [anon_sym_macro] = ACTIONS(11996),
    [anon_sym_where] = ACTIONS(11996),
    [anon_sym_quote] = ACTIONS(11996),
    [anon_sym_let] = ACTIONS(11996),
    [anon_sym_if] = ACTIONS(11996),
    [anon_sym_try] = ACTIONS(11996),
    [anon_sym_for] = ACTIONS(11996),
    [anon_sym_while] = ACTIONS(11996),
    [sym_break_statement] = ACTIONS(11996),
    [sym_continue_statement] = ACTIONS(11996),
    [anon_sym_return] = ACTIONS(11996),
    [anon_sym_const] = ACTIONS(11996),
    [anon_sym_global] = ACTIONS(11996),
    [anon_sym_local] = ACTIONS(11996),
    [anon_sym_LPAREN] = ACTIONS(11996),
    [anon_sym_export] = ACTIONS(11996),
    [anon_sym_import] = ACTIONS(11996),
    [anon_sym_using] = ACTIONS(11996),
    [anon_sym_LBRACK] = ACTIONS(11996),
    [anon_sym_LF] = ACTIONS(11998),
    [anon_sym_LBRACE] = ACTIONS(11996),
    [anon_sym_DOLLAR] = ACTIONS(11996),
    [anon_sym_COLON_COLON] = ACTIONS(11996),
    [anon_sym_AT] = ACTIONS(11996),
    [anon_sym_true] = ACTIONS(11996),
    [anon_sym_false] = ACTIONS(11996),
    [aux_sym_integer_literal_token1] = ACTIONS(11996),
    [aux_sym_integer_literal_token2] = ACTIONS(11996),
    [aux_sym_integer_literal_token3] = ACTIONS(11996),
    [aux_sym_integer_literal_token4] = ACTIONS(11996),
    [aux_sym_float_literal_token1] = ACTIONS(11996),
    [aux_sym_float_literal_token3] = ACTIONS(11996),
    [aux_sym_float_literal_token4] = ACTIONS(11996),
    [sym_character_literal] = ACTIONS(11996),
    [sym__pair_operator] = ACTIONS(11996),
    [sym__arrow_operator] = ACTIONS(11996),
    [sym__comparison_operator] = ACTIONS(11996),
    [sym__pipe_right_operator] = ACTIONS(11996),
    [sym__pipe_left_operator] = ACTIONS(11996),
    [sym__ellipsis_operator] = ACTIONS(11996),
    [sym__plus_operator] = ACTIONS(11996),
    [sym__times_operator] = ACTIONS(11996),
    [sym__rational_operator] = ACTIONS(11996),
    [sym__bitshift_operator] = ACTIONS(11996),
    [sym__power_operator] = ACTIONS(11996),
    [sym__tilde_operator] = ACTIONS(11996),
    [sym__type_order_operator] = ACTIONS(11996),
    [sym__unary_operator] = ACTIONS(11996),
    [sym__unary_plus_operator] = ACTIONS(11996),
    [aux_sym__terminator_token1] = ACTIONS(11996),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11998),
    [sym__command_start] = ACTIONS(11998),
  },
  [9612] = {
    [sym__word_identifier] = ACTIONS(12028),
    [anon_sym_COLON] = ACTIONS(12028),
    [anon_sym_begin] = ACTIONS(12028),
    [anon_sym_module] = ACTIONS(12028),
    [anon_sym_baremodule] = ACTIONS(12028),
    [anon_sym_end] = ACTIONS(12028),
    [anon_sym_abstract] = ACTIONS(12028),
    [anon_sym_primitive] = ACTIONS(12028),
    [anon_sym_mutable] = ACTIONS(12028),
    [anon_sym_struct] = ACTIONS(12028),
    [anon_sym_function] = ACTIONS(12028),
    [anon_sym_macro] = ACTIONS(12028),
    [anon_sym_where] = ACTIONS(12028),
    [anon_sym_quote] = ACTIONS(12028),
    [anon_sym_let] = ACTIONS(12028),
    [anon_sym_if] = ACTIONS(12028),
    [anon_sym_try] = ACTIONS(12028),
    [anon_sym_for] = ACTIONS(12028),
    [anon_sym_while] = ACTIONS(12028),
    [sym_break_statement] = ACTIONS(12028),
    [sym_continue_statement] = ACTIONS(12028),
    [anon_sym_return] = ACTIONS(12028),
    [anon_sym_const] = ACTIONS(12028),
    [anon_sym_global] = ACTIONS(12028),
    [anon_sym_local] = ACTIONS(12028),
    [anon_sym_LPAREN] = ACTIONS(12028),
    [anon_sym_export] = ACTIONS(12028),
    [anon_sym_import] = ACTIONS(12028),
    [anon_sym_using] = ACTIONS(12028),
    [anon_sym_LBRACK] = ACTIONS(12028),
    [anon_sym_LF] = ACTIONS(12030),
    [anon_sym_LBRACE] = ACTIONS(12028),
    [anon_sym_DOLLAR] = ACTIONS(12028),
    [anon_sym_COLON_COLON] = ACTIONS(12028),
    [anon_sym_AT] = ACTIONS(12028),
    [anon_sym_true] = ACTIONS(12028),
    [anon_sym_false] = ACTIONS(12028),
    [aux_sym_integer_literal_token1] = ACTIONS(12028),
    [aux_sym_integer_literal_token2] = ACTIONS(12028),
    [aux_sym_integer_literal_token3] = ACTIONS(12028),
    [aux_sym_integer_literal_token4] = ACTIONS(12028),
    [aux_sym_float_literal_token1] = ACTIONS(12028),
    [aux_sym_float_literal_token3] = ACTIONS(12028),
    [aux_sym_float_literal_token4] = ACTIONS(12028),
    [sym_character_literal] = ACTIONS(12028),
    [sym__pair_operator] = ACTIONS(12028),
    [sym__arrow_operator] = ACTIONS(12028),
    [sym__comparison_operator] = ACTIONS(12028),
    [sym__pipe_right_operator] = ACTIONS(12028),
    [sym__pipe_left_operator] = ACTIONS(12028),
    [sym__ellipsis_operator] = ACTIONS(12028),
    [sym__plus_operator] = ACTIONS(12028),
    [sym__times_operator] = ACTIONS(12028),
    [sym__rational_operator] = ACTIONS(12028),
    [sym__bitshift_operator] = ACTIONS(12028),
    [sym__power_operator] = ACTIONS(12028),
    [sym__tilde_operator] = ACTIONS(12028),
    [sym__type_order_operator] = ACTIONS(12028),
    [sym__unary_operator] = ACTIONS(12028),
    [sym__unary_plus_operator] = ACTIONS(12028),
    [aux_sym__terminator_token1] = ACTIONS(12028),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12030),
    [sym__command_start] = ACTIONS(12030),
  },
  [9613] = {
    [sym__word_identifier] = ACTIONS(12032),
    [anon_sym_COLON] = ACTIONS(12032),
    [anon_sym_begin] = ACTIONS(12032),
    [anon_sym_module] = ACTIONS(12032),
    [anon_sym_baremodule] = ACTIONS(12032),
    [anon_sym_end] = ACTIONS(12032),
    [anon_sym_abstract] = ACTIONS(12032),
    [anon_sym_primitive] = ACTIONS(12032),
    [anon_sym_mutable] = ACTIONS(12032),
    [anon_sym_struct] = ACTIONS(12032),
    [anon_sym_function] = ACTIONS(12032),
    [anon_sym_macro] = ACTIONS(12032),
    [anon_sym_where] = ACTIONS(12032),
    [anon_sym_quote] = ACTIONS(12032),
    [anon_sym_let] = ACTIONS(12032),
    [anon_sym_if] = ACTIONS(12032),
    [anon_sym_try] = ACTIONS(12032),
    [anon_sym_for] = ACTIONS(12032),
    [anon_sym_while] = ACTIONS(12032),
    [sym_break_statement] = ACTIONS(12032),
    [sym_continue_statement] = ACTIONS(12032),
    [anon_sym_return] = ACTIONS(12032),
    [anon_sym_const] = ACTIONS(12032),
    [anon_sym_global] = ACTIONS(12032),
    [anon_sym_local] = ACTIONS(12032),
    [anon_sym_LPAREN] = ACTIONS(12032),
    [anon_sym_export] = ACTIONS(12032),
    [anon_sym_import] = ACTIONS(12032),
    [anon_sym_using] = ACTIONS(12032),
    [anon_sym_LBRACK] = ACTIONS(12032),
    [anon_sym_LF] = ACTIONS(12034),
    [anon_sym_LBRACE] = ACTIONS(12032),
    [anon_sym_DOLLAR] = ACTIONS(12032),
    [anon_sym_COLON_COLON] = ACTIONS(12032),
    [anon_sym_AT] = ACTIONS(12032),
    [anon_sym_true] = ACTIONS(12032),
    [anon_sym_false] = ACTIONS(12032),
    [aux_sym_integer_literal_token1] = ACTIONS(12032),
    [aux_sym_integer_literal_token2] = ACTIONS(12032),
    [aux_sym_integer_literal_token3] = ACTIONS(12032),
    [aux_sym_integer_literal_token4] = ACTIONS(12032),
    [aux_sym_float_literal_token1] = ACTIONS(12032),
    [aux_sym_float_literal_token3] = ACTIONS(12032),
    [aux_sym_float_literal_token4] = ACTIONS(12032),
    [sym_character_literal] = ACTIONS(12032),
    [sym__pair_operator] = ACTIONS(12032),
    [sym__arrow_operator] = ACTIONS(12032),
    [sym__comparison_operator] = ACTIONS(12032),
    [sym__pipe_right_operator] = ACTIONS(12032),
    [sym__pipe_left_operator] = ACTIONS(12032),
    [sym__ellipsis_operator] = ACTIONS(12032),
    [sym__plus_operator] = ACTIONS(12032),
    [sym__times_operator] = ACTIONS(12032),
    [sym__rational_operator] = ACTIONS(12032),
    [sym__bitshift_operator] = ACTIONS(12032),
    [sym__power_operator] = ACTIONS(12032),
    [sym__tilde_operator] = ACTIONS(12032),
    [sym__type_order_operator] = ACTIONS(12032),
    [sym__unary_operator] = ACTIONS(12032),
    [sym__unary_plus_operator] = ACTIONS(12032),
    [aux_sym__terminator_token1] = ACTIONS(12032),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12034),
    [sym__command_start] = ACTIONS(12034),
  },
  [9614] = {
    [sym__word_identifier] = ACTIONS(14991),
    [anon_sym_COMMA] = ACTIONS(14991),
    [anon_sym_COLON] = ACTIONS(14991),
    [anon_sym_begin] = ACTIONS(14991),
    [anon_sym_module] = ACTIONS(14991),
    [anon_sym_baremodule] = ACTIONS(14991),
    [anon_sym_abstract] = ACTIONS(14991),
    [anon_sym_primitive] = ACTIONS(14991),
    [anon_sym_mutable] = ACTIONS(14991),
    [anon_sym_struct] = ACTIONS(14991),
    [anon_sym_function] = ACTIONS(14991),
    [anon_sym_macro] = ACTIONS(14991),
    [anon_sym_quote] = ACTIONS(14991),
    [anon_sym_let] = ACTIONS(14991),
    [anon_sym_if] = ACTIONS(14991),
    [anon_sym_try] = ACTIONS(14991),
    [anon_sym_for] = ACTIONS(14991),
    [anon_sym_while] = ACTIONS(14991),
    [sym_break_statement] = ACTIONS(14991),
    [sym_continue_statement] = ACTIONS(14991),
    [anon_sym_return] = ACTIONS(14991),
    [anon_sym_const] = ACTIONS(14991),
    [anon_sym_global] = ACTIONS(14991),
    [anon_sym_local] = ACTIONS(14991),
    [anon_sym_LPAREN] = ACTIONS(14991),
    [anon_sym_export] = ACTIONS(14991),
    [anon_sym_import] = ACTIONS(14991),
    [anon_sym_using] = ACTIONS(14991),
    [anon_sym_LBRACK] = ACTIONS(14991),
    [anon_sym_RBRACK] = ACTIONS(14991),
    [anon_sym_LF] = ACTIONS(14993),
    [anon_sym_LBRACE] = ACTIONS(14991),
    [anon_sym_DOLLAR] = ACTIONS(14991),
    [anon_sym_COLON_COLON] = ACTIONS(14991),
    [anon_sym_AT] = ACTIONS(14991),
    [anon_sym_true] = ACTIONS(14991),
    [anon_sym_false] = ACTIONS(14991),
    [aux_sym_integer_literal_token1] = ACTIONS(14991),
    [aux_sym_integer_literal_token2] = ACTIONS(14991),
    [aux_sym_integer_literal_token3] = ACTIONS(14991),
    [aux_sym_integer_literal_token4] = ACTIONS(14991),
    [aux_sym_float_literal_token1] = ACTIONS(14991),
    [aux_sym_float_literal_token3] = ACTIONS(14991),
    [aux_sym_float_literal_token4] = ACTIONS(14991),
    [sym_character_literal] = ACTIONS(14991),
    [sym__pair_operator] = ACTIONS(14991),
    [sym__arrow_operator] = ACTIONS(14991),
    [sym__comparison_operator] = ACTIONS(14991),
    [sym__pipe_right_operator] = ACTIONS(14991),
    [sym__pipe_left_operator] = ACTIONS(14991),
    [sym__ellipsis_operator] = ACTIONS(14991),
    [sym__plus_operator] = ACTIONS(14991),
    [sym__times_operator] = ACTIONS(14991),
    [sym__rational_operator] = ACTIONS(14991),
    [sym__bitshift_operator] = ACTIONS(14991),
    [sym__power_operator] = ACTIONS(14991),
    [sym__tilde_operator] = ACTIONS(14991),
    [sym__type_order_operator] = ACTIONS(14991),
    [sym__unary_operator] = ACTIONS(14991),
    [sym__unary_plus_operator] = ACTIONS(14991),
    [aux_sym__terminator_token1] = ACTIONS(14991),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(14993),
    [sym__command_start] = ACTIONS(14993),
  },
  [9615] = {
    [sym_identifier] = STATE(9644),
    [sym__word_identifier] = ACTIONS(11958),
    [anon_sym_COLON] = ACTIONS(11958),
    [anon_sym_begin] = ACTIONS(11958),
    [anon_sym_module] = ACTIONS(11958),
    [anon_sym_baremodule] = ACTIONS(11958),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_abstract] = ACTIONS(11958),
    [anon_sym_primitive] = ACTIONS(11958),
    [anon_sym_mutable] = ACTIONS(11958),
    [anon_sym_struct] = ACTIONS(11958),
    [anon_sym_function] = ACTIONS(11958),
    [anon_sym_macro] = ACTIONS(11958),
    [anon_sym_quote] = ACTIONS(11958),
    [anon_sym_let] = ACTIONS(11958),
    [anon_sym_if] = ACTIONS(11958),
    [anon_sym_try] = ACTIONS(11958),
    [anon_sym_for] = ACTIONS(11958),
    [anon_sym_while] = ACTIONS(11958),
    [sym_break_statement] = ACTIONS(11958),
    [sym_continue_statement] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(11958),
    [anon_sym_const] = ACTIONS(11958),
    [anon_sym_global] = ACTIONS(11958),
    [anon_sym_local] = ACTIONS(11958),
    [anon_sym_LPAREN] = ACTIONS(11958),
    [anon_sym_export] = ACTIONS(11958),
    [anon_sym_import] = ACTIONS(11958),
    [anon_sym_using] = ACTIONS(11958),
    [anon_sym_LBRACK] = ACTIONS(11958),
    [anon_sym_LF] = ACTIONS(11956),
    [anon_sym_LBRACE] = ACTIONS(11958),
    [anon_sym_DOLLAR] = ACTIONS(11958),
    [anon_sym_COLON_COLON] = ACTIONS(11958),
    [anon_sym_AT] = ACTIONS(11958),
    [anon_sym_true] = ACTIONS(11958),
    [anon_sym_false] = ACTIONS(11958),
    [aux_sym_integer_literal_token1] = ACTIONS(11958),
    [aux_sym_integer_literal_token2] = ACTIONS(11958),
    [aux_sym_integer_literal_token3] = ACTIONS(11958),
    [aux_sym_integer_literal_token4] = ACTIONS(11958),
    [aux_sym_float_literal_token1] = ACTIONS(11958),
    [aux_sym_float_literal_token3] = ACTIONS(11958),
    [aux_sym_float_literal_token4] = ACTIONS(11958),
    [sym_character_literal] = ACTIONS(11958),
    [sym__pair_operator] = ACTIONS(11958),
    [sym__arrow_operator] = ACTIONS(11958),
    [sym__comparison_operator] = ACTIONS(11958),
    [sym__pipe_right_operator] = ACTIONS(11958),
    [sym__pipe_left_operator] = ACTIONS(11958),
    [sym__ellipsis_operator] = ACTIONS(11958),
    [sym__plus_operator] = ACTIONS(11958),
    [sym__times_operator] = ACTIONS(11958),
    [sym__rational_operator] = ACTIONS(11958),
    [sym__bitshift_operator] = ACTIONS(11958),
    [sym__power_operator] = ACTIONS(11958),
    [sym__tilde_operator] = ACTIONS(11958),
    [sym__type_order_operator] = ACTIONS(11958),
    [sym__unary_operator] = ACTIONS(11958),
    [sym__unary_plus_operator] = ACTIONS(11958),
    [aux_sym__terminator_token1] = ACTIONS(11958),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(11956),
    [sym__command_start] = ACTIONS(11956),
  },
  [9616] = {
    [sym__word_identifier] = ACTIONS(12020),
    [anon_sym_COLON] = ACTIONS(12020),
    [anon_sym_begin] = ACTIONS(12020),
    [anon_sym_module] = ACTIONS(12020),
    [anon_sym_baremodule] = ACTIONS(12020),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_abstract] = ACTIONS(12020),
    [anon_sym_primitive] = ACTIONS(12020),
    [anon_sym_mutable] = ACTIONS(12020),
    [anon_sym_struct] = ACTIONS(12020),
    [anon_sym_function] = ACTIONS(12020),
    [anon_sym_macro] = ACTIONS(12020),
    [anon_sym_where] = ACTIONS(12020),
    [anon_sym_quote] = ACTIONS(12020),
    [anon_sym_let] = ACTIONS(12020),
    [anon_sym_if] = ACTIONS(12020),
    [anon_sym_try] = ACTIONS(12020),
    [anon_sym_for] = ACTIONS(12020),
    [anon_sym_while] = ACTIONS(12020),
    [sym_break_statement] = ACTIONS(12020),
    [sym_continue_statement] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(12020),
    [anon_sym_const] = ACTIONS(12020),
    [anon_sym_global] = ACTIONS(12020),
    [anon_sym_local] = ACTIONS(12020),
    [anon_sym_LPAREN] = ACTIONS(12020),
    [anon_sym_export] = ACTIONS(12020),
    [anon_sym_import] = ACTIONS(12020),
    [anon_sym_using] = ACTIONS(12020),
    [anon_sym_LBRACK] = ACTIONS(12020),
    [anon_sym_LF] = ACTIONS(12022),
    [anon_sym_LBRACE] = ACTIONS(12020),
    [anon_sym_DOLLAR] = ACTIONS(12020),
    [anon_sym_COLON_COLON] = ACTIONS(12020),
    [anon_sym_AT] = ACTIONS(12020),
    [anon_sym_true] = ACTIONS(12020),
    [anon_sym_false] = ACTIONS(12020),
    [aux_sym_integer_literal_token1] = ACTIONS(12020),
    [aux_sym_integer_literal_token2] = ACTIONS(12020),
    [aux_sym_integer_literal_token3] = ACTIONS(12020),
    [aux_sym_integer_literal_token4] = ACTIONS(12020),
    [aux_sym_float_literal_token1] = ACTIONS(12020),
    [aux_sym_float_literal_token3] = ACTIONS(12020),
    [aux_sym_float_literal_token4] = ACTIONS(12020),
    [sym_character_literal] = ACTIONS(12020),
    [sym__pair_operator] = ACTIONS(12020),
    [sym__arrow_operator] = ACTIONS(12020),
    [sym__comparison_operator] = ACTIONS(12020),
    [sym__pipe_right_operator] = ACTIONS(12020),
    [sym__pipe_left_operator] = ACTIONS(12020),
    [sym__ellipsis_operator] = ACTIONS(12020),
    [sym__plus_operator] = ACTIONS(12020),
    [sym__times_operator] = ACTIONS(12020),
    [sym__rational_operator] = ACTIONS(12020),
    [sym__bitshift_operator] = ACTIONS(12020),
    [sym__power_operator] = ACTIONS(12020),
    [sym__tilde_operator] = ACTIONS(12020),
    [sym__type_order_operator] = ACTIONS(12020),
    [sym__unary_operator] = ACTIONS(12020),
    [sym__unary_plus_operator] = ACTIONS(12020),
    [aux_sym__terminator_token1] = ACTIONS(12020),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12022),
    [sym__command_start] = ACTIONS(12022),
  },
  [9617] = {
    [sym__word_identifier] = ACTIONS(12154),
    [anon_sym_COLON] = ACTIONS(12154),
    [anon_sym_begin] = ACTIONS(12154),
    [anon_sym_module] = ACTIONS(12154),
    [anon_sym_baremodule] = ACTIONS(12154),
    [anon_sym_end] = ACTIONS(12154),
    [anon_sym_abstract] = ACTIONS(12154),
    [anon_sym_primitive] = ACTIONS(12154),
    [anon_sym_mutable] = ACTIONS(12154),
    [anon_sym_struct] = ACTIONS(12154),
    [anon_sym_LT_COLON] = ACTIONS(12154),
    [anon_sym_function] = ACTIONS(12154),
    [anon_sym_macro] = ACTIONS(12154),
    [anon_sym_quote] = ACTIONS(12154),
    [anon_sym_let] = ACTIONS(12154),
    [anon_sym_if] = ACTIONS(12154),
    [anon_sym_try] = ACTIONS(12154),
    [anon_sym_for] = ACTIONS(12154),
    [anon_sym_while] = ACTIONS(12154),
    [sym_break_statement] = ACTIONS(12154),
    [sym_continue_statement] = ACTIONS(12154),
    [anon_sym_return] = ACTIONS(12154),
    [anon_sym_const] = ACTIONS(12154),
    [anon_sym_global] = ACTIONS(12154),
    [anon_sym_local] = ACTIONS(12154),
    [anon_sym_LPAREN] = ACTIONS(12154),
    [anon_sym_export] = ACTIONS(12154),
    [anon_sym_import] = ACTIONS(12154),
    [anon_sym_using] = ACTIONS(12154),
    [anon_sym_LBRACK] = ACTIONS(12154),
    [anon_sym_LF] = ACTIONS(12152),
    [anon_sym_LBRACE] = ACTIONS(12154),
    [anon_sym_DOLLAR] = ACTIONS(12154),
    [anon_sym_COLON_COLON] = ACTIONS(12154),
    [anon_sym_AT] = ACTIONS(12154),
    [anon_sym_true] = ACTIONS(12154),
    [anon_sym_false] = ACTIONS(12154),
    [aux_sym_integer_literal_token1] = ACTIONS(12154),
    [aux_sym_integer_literal_token2] = ACTIONS(12154),
    [aux_sym_integer_literal_token3] = ACTIONS(12154),
    [aux_sym_integer_literal_token4] = ACTIONS(12154),
    [aux_sym_float_literal_token1] = ACTIONS(12154),
    [aux_sym_float_literal_token3] = ACTIONS(12154),
    [aux_sym_float_literal_token4] = ACTIONS(12154),
    [sym_character_literal] = ACTIONS(12154),
    [sym__pair_operator] = ACTIONS(12154),
    [sym__arrow_operator] = ACTIONS(12154),
    [sym__comparison_operator] = ACTIONS(12154),
    [sym__pipe_right_operator] = ACTIONS(12154),
    [sym__pipe_left_operator] = ACTIONS(12154),
    [sym__ellipsis_operator] = ACTIONS(12154),
    [sym__plus_operator] = ACTIONS(12154),
    [sym__times_operator] = ACTIONS(12154),
    [sym__rational_operator] = ACTIONS(12154),
    [sym__bitshift_operator] = ACTIONS(12154),
    [sym__power_operator] = ACTIONS(12154),
    [sym__tilde_operator] = ACTIONS(12154),
    [sym__type_order_operator] = ACTIONS(12154),
    [sym__unary_operator] = ACTIONS(12154),
    [sym__unary_plus_operator] = ACTIONS(12154),
    [aux_sym__terminator_token1] = ACTIONS(12154),
    [sym_line_comment] = ACTIONS(169),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(12152),
    [sym__command_start] = ACTIONS(12152),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12054), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12210), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [146] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12236), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [219] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12272), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [292] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12150), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [365] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(15256), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(15254), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [438] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12252), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [511] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12046), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [584] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(11866), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [657] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12244), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [730] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12070), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [803] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12384), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [876] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12292), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [949] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12178), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1022] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(15260), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(15258), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1095] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12142), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1168] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1241] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12240), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1314] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12256), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1387] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12146), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1460] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12066), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1533] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12058), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1606] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12260), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1679] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12300), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1752] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12276), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1825] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12166), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1898] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12280), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [1971] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12154), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2044] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12388), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2117] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12162), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2190] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12170), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2263] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12264), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2336] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12248), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2409] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12284), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2482] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12062), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2555] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(11892), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2628] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12304), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2701] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12268), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2774] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12158), 59,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_LPAREN,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [2847] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15264), 23,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(15262), 37,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [2916] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15268), 23,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(15266), 37,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [2985] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15272), 23,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
      sym_character_literal,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(15270), 37,
      anon_sym_COLON,
      anon_sym_begin,
      anon_sym_module,
      anon_sym_baremodule,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_function,
      anon_sym_macro,
      anon_sym_quote,
      anon_sym_let,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_const,
      anon_sym_global,
      anon_sym_local,
      anon_sym_export,
      anon_sym_import,
      anon_sym_using,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token3,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [3054] = 19,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(15274), 1,
      sym__word_identifier,
    ACTIONS(15280), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15282), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15292), 1,
      sym__immediate_paren,
    ACTIONS(15294), 1,
      sym__immediate_bracket,
    ACTIONS(15296), 1,
      sym__immediate_brace,
    STATE(10250), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15278), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15276), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(15284), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15286), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(15288), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(11684), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(11680), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
    STATE(10385), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15290), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [3152] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(173), 1,
      sym__string_start,
    ACTIONS(175), 1,
      sym__command_start,
    ACTIONS(11680), 1,
      anon_sym_LF,
    ACTIONS(15298), 1,
      sym__word_identifier,
    ACTIONS(15304), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15310), 1,
      sym__immediate_paren,
    ACTIONS(15312), 1,
      sym__immediate_bracket,
    ACTIONS(15314), 1,
      sym__immediate_brace,
    STATE(10239), 1,
      sym_identifier,
    ACTIONS(15302), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(15306), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15300), 6,
      aux_sym_quote_expression_token1,
      sym_character_literal,
      sym__assignment_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__syntactic_operator,
    STATE(10623), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11684), 13,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym__terminator_token1,
    ACTIONS(15308), 15,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [3246] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11680), 1,
      anon_sym_LF,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10289), 1,
      sym_identifier,
    ACTIONS(15320), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(15324), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15318), 6,
      aux_sym_quote_expression_token1,
      sym_character_literal,
      sym__assignment_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__syntactic_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11684), 13,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym__terminator_token1,
    ACTIONS(15326), 15,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [3340] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11680), 1,
      anon_sym_LF,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10294), 1,
      sym_identifier,
    ACTIONS(15320), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(15324), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15318), 6,
      aux_sym_quote_expression_token1,
      sym_character_literal,
      sym__assignment_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__syntactic_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11684), 13,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
    ACTIONS(15326), 15,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [3434] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2786), 1,
      sym__string_start,
    ACTIONS(2788), 1,
      sym__command_start,
    ACTIONS(11680), 1,
      anon_sym_LF,
    ACTIONS(15334), 1,
      sym__word_identifier,
    ACTIONS(15340), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15346), 1,
      sym__immediate_paren,
    ACTIONS(15348), 1,
      sym__immediate_bracket,
    ACTIONS(15350), 1,
      sym__immediate_brace,
    STATE(10206), 1,
      sym_identifier,
    ACTIONS(15338), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(15342), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15336), 6,
      aux_sym_quote_expression_token1,
      sym_character_literal,
      sym__assignment_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__syntactic_operator,
    STATE(10703), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11684), 13,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
    ACTIONS(15344), 15,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [3528] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11680), 1,
      anon_sym_LF,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10481), 1,
      sym_identifier,
    ACTIONS(15320), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(15324), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15318), 6,
      aux_sym_quote_expression_token1,
      sym_character_literal,
      sym__assignment_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__syntactic_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11684), 12,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym__terminator_token1,
    ACTIONS(15326), 15,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [3621] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11680), 1,
      anon_sym_LF,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10453), 1,
      sym_identifier,
    ACTIONS(15320), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(15324), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15318), 6,
      aux_sym_quote_expression_token1,
      sym_character_literal,
      sym__assignment_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__syntactic_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11684), 12,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym__terminator_token1,
    ACTIONS(15326), 15,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [3714] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11680), 1,
      anon_sym_LF,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10477), 1,
      sym_identifier,
    ACTIONS(15320), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(15324), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15318), 6,
      aux_sym_quote_expression_token1,
      sym_character_literal,
      sym__assignment_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__syntactic_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11684), 12,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym__terminator_token1,
    ACTIONS(15326), 15,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [3807] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(537), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [3907] = 19,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(15274), 1,
      sym__word_identifier,
    ACTIONS(15280), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15282), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15292), 1,
      sym__immediate_paren,
    ACTIONS(15294), 1,
      sym__immediate_bracket,
    ACTIONS(15296), 1,
      sym__immediate_brace,
    STATE(10620), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15278), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15276), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(15284), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15286), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(15288), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(11680), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
    ACTIONS(11684), 6,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
    STATE(10385), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15290), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [4003] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(559), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [4103] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11680), 1,
      anon_sym_LF,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10613), 1,
      sym_identifier,
    ACTIONS(15320), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(15324), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15318), 6,
      aux_sym_quote_expression_token1,
      sym_character_literal,
      sym__assignment_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__syntactic_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11684), 11,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym__terminator_token1,
    ACTIONS(15326), 15,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [4195] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(674), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [4295] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(685), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [4395] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(668), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [4495] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(605), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [4595] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(608), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [4695] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10584), 1,
      sym_identifier,
    ACTIONS(11680), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(15320), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(15324), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15318), 6,
      aux_sym_quote_expression_token1,
      sym_character_literal,
      sym__assignment_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__syntactic_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11684), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym__terminator_token1,
    ACTIONS(15326), 15,
      sym__pair_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [4787] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(711), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [4887] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(541), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [4987] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(542), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [5087] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(592), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [5187] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(593), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [5287] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(781), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [5387] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(662), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [5487] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(729), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [5587] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(732), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [5687] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(769), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [5787] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(770), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [5887] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(726), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [5987] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(538), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [6087] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(555), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [6187] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(556), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [6287] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(572), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [6387] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(573), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [6487] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(588), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [6587] = 21,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15356), 1,
      anon_sym_LPAREN,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15366), 1,
      sym_character_literal,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    STATE(589), 1,
      sym_signature,
    STATE(9279), 1,
      sym_call_expression,
    STATE(9318), 1,
      sym_identifier,
    STATE(9550), 1,
      sym_argument_list,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15416), 22,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [6687] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15374), 1,
      anon_sym_RPAREN,
    ACTIONS(15376), 1,
      sym_character_literal,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [6782] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15378), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [6877] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15380), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [6972] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15382), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [7067] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15384), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [7162] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15386), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [7257] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15388), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [7352] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15390), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [7447] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15392), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [7542] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15394), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [7637] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15396), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [7732] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15398), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [7827] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15400), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [7922] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15402), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [8017] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15404), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [8112] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15406), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [8207] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15408), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [8302] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15410), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [8397] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15412), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [8492] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15414), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [8587] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15416), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [8682] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15418), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [8777] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15420), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [8872] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15422), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [8967] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15424), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [9062] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15426), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [9157] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15428), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [9252] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15430), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [9347] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15432), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [9442] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15434), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [9537] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15436), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [9632] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15438), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [9727] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15440), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [9822] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15442), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [9917] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15444), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [10012] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15446), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [10107] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15448), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [10202] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15450), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [10297] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15452), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [10392] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15454), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [10487] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15456), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [10582] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15458), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [10677] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15460), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [10772] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15462), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [10867] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15464), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [10962] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15466), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [11057] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15468), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [11152] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15470), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [11247] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15472), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [11342] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15474), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [11437] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15476), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [11532] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15478), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [11627] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15480), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [11722] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15482), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [11817] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15484), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [11912] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15486), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [12007] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15488), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [12102] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15490), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [12197] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15492), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [12292] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15494), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [12387] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15496), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [12482] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15498), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [12577] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15500), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [12672] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15502), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [12767] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15504), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [12862] = 19,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    ACTIONS(15506), 1,
      anon_sym_RPAREN,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [12957] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15508), 1,
      sym__word_identifier,
    ACTIONS(15510), 1,
      anon_sym_COLON,
    ACTIONS(15512), 1,
      anon_sym_LPAREN,
    ACTIONS(15514), 1,
      anon_sym_LBRACK,
    ACTIONS(15516), 1,
      anon_sym_LBRACE,
    ACTIONS(15518), 1,
      anon_sym_DOLLAR,
    ACTIONS(15522), 1,
      sym_character_literal,
    ACTIONS(15524), 1,
      sym__string_start,
    ACTIONS(15526), 1,
      sym__command_start,
    STATE(9296), 1,
      sym_identifier,
    STATE(16878), 1,
      sym_macro_identifier,
    STATE(19029), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15520), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9344), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [13049] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15530), 1,
      anon_sym_COLON,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15538), 1,
      anon_sym_DOLLAR,
    ACTIONS(15542), 1,
      sym_character_literal,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    STATE(10838), 1,
      sym_identifier,
    STATE(16824), 1,
      sym_macro_identifier,
    STATE(18860), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15540), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11368), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [13141] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15548), 1,
      sym__word_identifier,
    ACTIONS(15550), 1,
      anon_sym_COLON,
    ACTIONS(15552), 1,
      anon_sym_LPAREN,
    ACTIONS(15554), 1,
      anon_sym_LBRACK,
    ACTIONS(15556), 1,
      anon_sym_LBRACE,
    ACTIONS(15558), 1,
      anon_sym_DOLLAR,
    ACTIONS(15562), 1,
      sym_character_literal,
    ACTIONS(15564), 1,
      sym__string_start,
    ACTIONS(15566), 1,
      sym__command_start,
    STATE(4280), 1,
      sym_identifier,
    STATE(17004), 1,
      sym_macro_identifier,
    STATE(19144), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15560), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5024), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [13233] = 18,
    ACTIONS(13040), 1,
      sym__word_identifier,
    ACTIONS(13056), 1,
      sym__string_start,
    ACTIONS(13058), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15568), 1,
      anon_sym_COLON,
    ACTIONS(15570), 1,
      anon_sym_LPAREN,
    ACTIONS(15572), 1,
      anon_sym_LBRACK,
    ACTIONS(15574), 1,
      anon_sym_LBRACE,
    ACTIONS(15576), 1,
      anon_sym_DOLLAR,
    ACTIONS(15578), 1,
      sym_character_literal,
    STATE(10822), 1,
      sym_identifier,
    STATE(17042), 1,
      sym_macro_identifier,
    STATE(19221), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13052), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11240), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [13325] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15580), 1,
      sym__word_identifier,
    ACTIONS(15582), 1,
      anon_sym_COLON,
    ACTIONS(15584), 1,
      anon_sym_LPAREN,
    ACTIONS(15586), 1,
      anon_sym_LBRACK,
    ACTIONS(15588), 1,
      anon_sym_LBRACE,
    ACTIONS(15590), 1,
      anon_sym_DOLLAR,
    ACTIONS(15594), 1,
      sym_character_literal,
    ACTIONS(15596), 1,
      sym__string_start,
    ACTIONS(15598), 1,
      sym__command_start,
    STATE(4279), 1,
      sym_identifier,
    STATE(16946), 1,
      sym_macro_identifier,
    STATE(19024), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15592), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4596), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [13417] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15600), 1,
      sym__word_identifier,
    ACTIONS(15602), 1,
      anon_sym_COLON,
    ACTIONS(15604), 1,
      anon_sym_LPAREN,
    ACTIONS(15606), 1,
      anon_sym_LBRACK,
    ACTIONS(15608), 1,
      anon_sym_LBRACE,
    ACTIONS(15610), 1,
      anon_sym_DOLLAR,
    ACTIONS(15614), 1,
      sym_character_literal,
    ACTIONS(15616), 1,
      sym__string_start,
    ACTIONS(15618), 1,
      sym__command_start,
    STATE(4685), 1,
      sym_identifier,
    STATE(16921), 1,
      sym_macro_identifier,
    STATE(18987), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15612), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6369), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [13509] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15620), 1,
      sym__word_identifier,
    ACTIONS(15622), 1,
      anon_sym_COLON,
    ACTIONS(15624), 1,
      anon_sym_LPAREN,
    ACTIONS(15626), 1,
      anon_sym_LBRACK,
    ACTIONS(15628), 1,
      anon_sym_LBRACE,
    ACTIONS(15630), 1,
      anon_sym_DOLLAR,
    ACTIONS(15634), 1,
      sym_character_literal,
    ACTIONS(15636), 1,
      sym__string_start,
    ACTIONS(15638), 1,
      sym__command_start,
    STATE(4348), 1,
      sym_identifier,
    STATE(16783), 1,
      sym_macro_identifier,
    STATE(18804), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15632), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5213), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [13601] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15640), 1,
      sym__word_identifier,
    ACTIONS(15642), 1,
      anon_sym_COLON,
    ACTIONS(15644), 1,
      anon_sym_LPAREN,
    ACTIONS(15646), 1,
      anon_sym_LBRACK,
    ACTIONS(15648), 1,
      anon_sym_LBRACE,
    ACTIONS(15650), 1,
      anon_sym_DOLLAR,
    ACTIONS(15654), 1,
      sym_character_literal,
    ACTIONS(15656), 1,
      sym__string_start,
    ACTIONS(15658), 1,
      sym__command_start,
    STATE(5099), 1,
      sym_identifier,
    STATE(17057), 1,
      sym_macro_identifier,
    STATE(19249), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15652), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6376), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [13693] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15660), 1,
      sym__word_identifier,
    ACTIONS(15662), 1,
      anon_sym_COLON,
    ACTIONS(15664), 1,
      anon_sym_LPAREN,
    ACTIONS(15666), 1,
      anon_sym_LBRACK,
    ACTIONS(15668), 1,
      anon_sym_LBRACE,
    ACTIONS(15670), 1,
      anon_sym_DOLLAR,
    ACTIONS(15674), 1,
      sym_character_literal,
    ACTIONS(15676), 1,
      sym__string_start,
    ACTIONS(15678), 1,
      sym__command_start,
    STATE(4557), 1,
      sym_identifier,
    STATE(17024), 1,
      sym_macro_identifier,
    STATE(19192), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15672), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5828), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [13785] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15680), 1,
      sym__word_identifier,
    ACTIONS(15682), 1,
      anon_sym_COLON,
    ACTIONS(15684), 1,
      anon_sym_LPAREN,
    ACTIONS(15686), 1,
      anon_sym_LBRACK,
    ACTIONS(15688), 1,
      anon_sym_LBRACE,
    ACTIONS(15690), 1,
      anon_sym_DOLLAR,
    ACTIONS(15694), 1,
      sym_character_literal,
    ACTIONS(15696), 1,
      sym__string_start,
    ACTIONS(15698), 1,
      sym__command_start,
    STATE(4483), 1,
      sym_identifier,
    STATE(17008), 1,
      sym_macro_identifier,
    STATE(19160), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15692), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5754), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [13877] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15700), 1,
      anon_sym_COLON,
    ACTIONS(15702), 1,
      anon_sym_LPAREN,
    ACTIONS(15704), 1,
      anon_sym_LBRACK,
    ACTIONS(15706), 1,
      anon_sym_LBRACE,
    ACTIONS(15708), 1,
      anon_sym_DOLLAR,
    ACTIONS(15712), 1,
      sym_character_literal,
    ACTIONS(15714), 1,
      sym__string_start,
    ACTIONS(15716), 1,
      sym__command_start,
    STATE(9327), 1,
      sym_identifier,
    STATE(16854), 1,
      sym_macro_identifier,
    STATE(18913), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15710), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9449), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [13969] = 18,
    ACTIONS(13170), 1,
      sym__word_identifier,
    ACTIONS(13186), 1,
      sym__string_start,
    ACTIONS(13188), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15718), 1,
      anon_sym_COLON,
    ACTIONS(15720), 1,
      anon_sym_LPAREN,
    ACTIONS(15722), 1,
      anon_sym_LBRACK,
    ACTIONS(15724), 1,
      anon_sym_LBRACE,
    ACTIONS(15726), 1,
      anon_sym_DOLLAR,
    ACTIONS(15728), 1,
      sym_character_literal,
    STATE(10685), 1,
      sym_identifier,
    STATE(16973), 1,
      sym_macro_identifier,
    STATE(19061), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13182), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11223), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [14061] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15730), 1,
      sym__word_identifier,
    ACTIONS(15732), 1,
      anon_sym_COLON,
    ACTIONS(15734), 1,
      anon_sym_LPAREN,
    ACTIONS(15736), 1,
      anon_sym_LBRACK,
    ACTIONS(15738), 1,
      anon_sym_LBRACE,
    ACTIONS(15740), 1,
      anon_sym_DOLLAR,
    ACTIONS(15744), 1,
      sym_character_literal,
    ACTIONS(15746), 1,
      sym__string_start,
    ACTIONS(15748), 1,
      sym__command_start,
    STATE(4951), 1,
      sym_identifier,
    STATE(17020), 1,
      sym_macro_identifier,
    STATE(19184), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15742), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6368), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [14153] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15750), 1,
      sym__word_identifier,
    ACTIONS(15752), 1,
      anon_sym_COLON,
    ACTIONS(15754), 1,
      anon_sym_LPAREN,
    ACTIONS(15756), 1,
      anon_sym_LBRACK,
    ACTIONS(15758), 1,
      anon_sym_LBRACE,
    ACTIONS(15760), 1,
      anon_sym_DOLLAR,
    ACTIONS(15764), 1,
      sym_character_literal,
    ACTIONS(15766), 1,
      sym__string_start,
    ACTIONS(15768), 1,
      sym__command_start,
    STATE(10476), 1,
      sym_identifier,
    STATE(17013), 1,
      sym_macro_identifier,
    STATE(19168), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15762), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11187), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [14245] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15770), 1,
      sym__word_identifier,
    ACTIONS(15772), 1,
      anon_sym_COLON,
    ACTIONS(15774), 1,
      anon_sym_LPAREN,
    ACTIONS(15776), 1,
      anon_sym_LBRACK,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(15780), 1,
      anon_sym_DOLLAR,
    ACTIONS(15784), 1,
      sym_character_literal,
    ACTIONS(15786), 1,
      sym__string_start,
    ACTIONS(15788), 1,
      sym__command_start,
    STATE(4820), 1,
      sym_identifier,
    STATE(17000), 1,
      sym_macro_identifier,
    STATE(19136), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15782), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6277), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [14337] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15790), 1,
      sym__word_identifier,
    ACTIONS(15792), 1,
      anon_sym_COLON,
    ACTIONS(15794), 1,
      anon_sym_LPAREN,
    ACTIONS(15796), 1,
      anon_sym_LBRACK,
    ACTIONS(15798), 1,
      anon_sym_LBRACE,
    ACTIONS(15800), 1,
      anon_sym_DOLLAR,
    ACTIONS(15804), 1,
      sym_character_literal,
    ACTIONS(15806), 1,
      sym__string_start,
    ACTIONS(15808), 1,
      sym__command_start,
    STATE(4522), 1,
      sym_identifier,
    STATE(17033), 1,
      sym_macro_identifier,
    STATE(19207), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15802), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5252), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [14429] = 18,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15810), 1,
      anon_sym_COLON,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(15818), 1,
      anon_sym_DOLLAR,
    ACTIONS(15820), 1,
      sym_character_literal,
    STATE(11326), 1,
      sym_identifier,
    STATE(16735), 1,
      sym_macro_identifier,
    STATE(19313), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12999), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11490), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [14521] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15822), 1,
      sym__word_identifier,
    ACTIONS(15824), 1,
      anon_sym_COLON,
    ACTIONS(15826), 1,
      anon_sym_LPAREN,
    ACTIONS(15828), 1,
      anon_sym_LBRACK,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(15832), 1,
      anon_sym_DOLLAR,
    ACTIONS(15836), 1,
      sym_character_literal,
    ACTIONS(15838), 1,
      sym__string_start,
    ACTIONS(15840), 1,
      sym__command_start,
    STATE(4943), 1,
      sym_identifier,
    STATE(17037), 1,
      sym_macro_identifier,
    STATE(19214), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15834), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6435), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [14613] = 18,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(15842), 1,
      anon_sym_COLON,
    ACTIONS(15844), 1,
      anon_sym_DOLLAR,
    ACTIONS(15846), 1,
      sym_character_literal,
    STATE(11201), 1,
      sym_identifier,
    STATE(16735), 1,
      sym_macro_identifier,
    STATE(19313), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12999), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11511), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [14705] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(15848), 1,
      anon_sym_COLON,
    ACTIONS(15850), 1,
      anon_sym_DOLLAR,
    ACTIONS(15852), 1,
      sym_character_literal,
    STATE(11186), 1,
      sym_identifier,
    STATE(16824), 1,
      sym_macro_identifier,
    STATE(18860), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15540), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11419), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [14797] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(15854), 1,
      anon_sym_COLON,
    ACTIONS(15856), 1,
      anon_sym_DOLLAR,
    ACTIONS(15858), 1,
      sym_character_literal,
    STATE(11063), 1,
      sym_identifier,
    STATE(16824), 1,
      sym_macro_identifier,
    STATE(18860), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15540), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11425), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [14889] = 18,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15210), 1,
      anon_sym_DOLLAR,
    ACTIONS(15860), 1,
      anon_sym_COLON,
    ACTIONS(15862), 1,
      sym_character_literal,
    STATE(10579), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11345), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [14981] = 18,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(15376), 1,
      sym_character_literal,
    STATE(11204), 1,
      sym_identifier,
    STATE(17273), 1,
      sym_macro_identifier,
    STATE(18510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11518), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [15073] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15580), 1,
      sym__word_identifier,
    ACTIONS(15582), 1,
      anon_sym_COLON,
    ACTIONS(15584), 1,
      anon_sym_LPAREN,
    ACTIONS(15586), 1,
      anon_sym_LBRACK,
    ACTIONS(15588), 1,
      anon_sym_LBRACE,
    ACTIONS(15590), 1,
      anon_sym_DOLLAR,
    ACTIONS(15596), 1,
      sym__string_start,
    ACTIONS(15598), 1,
      sym__command_start,
    ACTIONS(15864), 1,
      sym_character_literal,
    STATE(4279), 1,
      sym_identifier,
    STATE(16946), 1,
      sym_macro_identifier,
    STATE(19024), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15592), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4914), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [15165] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15866), 1,
      sym__word_identifier,
    ACTIONS(15868), 1,
      anon_sym_COLON,
    ACTIONS(15870), 1,
      anon_sym_LPAREN,
    ACTIONS(15872), 1,
      anon_sym_LBRACK,
    ACTIONS(15874), 1,
      anon_sym_LBRACE,
    ACTIONS(15876), 1,
      anon_sym_DOLLAR,
    ACTIONS(15880), 1,
      sym_character_literal,
    ACTIONS(15882), 1,
      sym__string_start,
    ACTIONS(15884), 1,
      sym__command_start,
    STATE(10998), 1,
      sym_identifier,
    STATE(16898), 1,
      sym_macro_identifier,
    STATE(18950), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15878), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11422), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [15257] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    ACTIONS(15886), 1,
      sym__word_identifier,
    ACTIONS(15888), 1,
      anon_sym_LPAREN,
    ACTIONS(15890), 1,
      sym_character_literal,
    STATE(14340), 1,
      sym_identifier,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19152), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(14409), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [15349] = 18,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(15892), 1,
      anon_sym_COLON,
    ACTIONS(15894), 1,
      anon_sym_DOLLAR,
    ACTIONS(15896), 1,
      sym_character_literal,
    STATE(10801), 1,
      sym_identifier,
    STATE(16735), 1,
      sym_macro_identifier,
    STATE(19313), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12999), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11270), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [15441] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15898), 1,
      sym__word_identifier,
    ACTIONS(15900), 1,
      anon_sym_COLON,
    ACTIONS(15902), 1,
      anon_sym_LPAREN,
    ACTIONS(15904), 1,
      anon_sym_LBRACK,
    ACTIONS(15906), 1,
      anon_sym_LBRACE,
    ACTIONS(15908), 1,
      anon_sym_DOLLAR,
    ACTIONS(15912), 1,
      sym_character_literal,
    ACTIONS(15914), 1,
      sym__string_start,
    ACTIONS(15916), 1,
      sym__command_start,
    STATE(4293), 1,
      sym_identifier,
    STATE(17029), 1,
      sym_macro_identifier,
    STATE(19200), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15910), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4659), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [15533] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(15918), 1,
      anon_sym_COLON,
    ACTIONS(15920), 1,
      anon_sym_DOLLAR,
    ACTIONS(15922), 1,
      sym_character_literal,
    STATE(10485), 1,
      sym_identifier,
    STATE(16824), 1,
      sym_macro_identifier,
    STATE(18860), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15540), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11193), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [15625] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15924), 1,
      sym__word_identifier,
    ACTIONS(15926), 1,
      anon_sym_COLON,
    ACTIONS(15928), 1,
      anon_sym_LPAREN,
    ACTIONS(15930), 1,
      anon_sym_LBRACK,
    ACTIONS(15932), 1,
      anon_sym_LBRACE,
    ACTIONS(15934), 1,
      anon_sym_DOLLAR,
    ACTIONS(15938), 1,
      sym_character_literal,
    ACTIONS(15940), 1,
      sym__string_start,
    ACTIONS(15942), 1,
      sym__command_start,
    STATE(4521), 1,
      sym_identifier,
    STATE(17045), 1,
      sym_macro_identifier,
    STATE(19228), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15936), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5483), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [15717] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    ACTIONS(15886), 1,
      sym__word_identifier,
    ACTIONS(15888), 1,
      anon_sym_LPAREN,
    ACTIONS(15944), 1,
      anon_sym_COLON,
    ACTIONS(15946), 1,
      anon_sym_DOLLAR,
    ACTIONS(15948), 1,
      sym_character_literal,
    STATE(14412), 1,
      sym_identifier,
    STATE(16925), 1,
      sym_macro_identifier,
    STATE(19152), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15364), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15015), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [15809] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15950), 1,
      sym__word_identifier,
    ACTIONS(15952), 1,
      anon_sym_COLON,
    ACTIONS(15954), 1,
      anon_sym_LPAREN,
    ACTIONS(15956), 1,
      anon_sym_LBRACK,
    ACTIONS(15958), 1,
      anon_sym_LBRACE,
    ACTIONS(15960), 1,
      anon_sym_DOLLAR,
    ACTIONS(15964), 1,
      sym_character_literal,
    ACTIONS(15966), 1,
      sym__string_start,
    ACTIONS(15968), 1,
      sym__command_start,
    STATE(4731), 1,
      sym_identifier,
    STATE(16989), 1,
      sym_macro_identifier,
    STATE(19098), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15962), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6016), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [15901] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15970), 1,
      sym__word_identifier,
    ACTIONS(15972), 1,
      anon_sym_COLON,
    ACTIONS(15974), 1,
      anon_sym_LPAREN,
    ACTIONS(15976), 1,
      anon_sym_LBRACK,
    ACTIONS(15978), 1,
      anon_sym_LBRACE,
    ACTIONS(15980), 1,
      anon_sym_DOLLAR,
    ACTIONS(15984), 1,
      sym_character_literal,
    ACTIONS(15986), 1,
      sym__string_start,
    ACTIONS(15988), 1,
      sym__command_start,
    STATE(4495), 1,
      sym_identifier,
    STATE(17017), 1,
      sym_macro_identifier,
    STATE(19176), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15982), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5466), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [15993] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15990), 1,
      sym__word_identifier,
    ACTIONS(15992), 1,
      anon_sym_COLON,
    ACTIONS(15994), 1,
      anon_sym_LPAREN,
    ACTIONS(15996), 1,
      anon_sym_LBRACK,
    ACTIONS(15998), 1,
      anon_sym_LBRACE,
    ACTIONS(16000), 1,
      anon_sym_DOLLAR,
    ACTIONS(16004), 1,
      sym_character_literal,
    ACTIONS(16006), 1,
      sym__string_start,
    ACTIONS(16008), 1,
      sym__command_start,
    STATE(11556), 1,
      sym_identifier,
    STATE(16996), 1,
      sym_macro_identifier,
    STATE(19124), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16002), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11889), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [16085] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16010), 1,
      sym__word_identifier,
    ACTIONS(16012), 1,
      anon_sym_COLON,
    ACTIONS(16014), 1,
      anon_sym_LPAREN,
    ACTIONS(16016), 1,
      anon_sym_LBRACK,
    ACTIONS(16018), 1,
      anon_sym_LBRACE,
    ACTIONS(16020), 1,
      anon_sym_DOLLAR,
    ACTIONS(16024), 1,
      sym_character_literal,
    ACTIONS(16026), 1,
      sym__string_start,
    ACTIONS(16028), 1,
      sym__command_start,
    STATE(10334), 1,
      sym_identifier,
    STATE(17049), 1,
      sym_macro_identifier,
    STATE(19235), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16022), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11163), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [16177] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16030), 1,
      sym__word_identifier,
    ACTIONS(16032), 1,
      anon_sym_COLON,
    ACTIONS(16034), 1,
      anon_sym_LPAREN,
    ACTIONS(16036), 1,
      anon_sym_LBRACK,
    ACTIONS(16038), 1,
      anon_sym_LBRACE,
    ACTIONS(16040), 1,
      anon_sym_DOLLAR,
    ACTIONS(16044), 1,
      sym_character_literal,
    ACTIONS(16046), 1,
      sym__string_start,
    ACTIONS(16048), 1,
      sym__command_start,
    STATE(5644), 1,
      sym_identifier,
    STATE(16744), 1,
      sym_macro_identifier,
    STATE(18740), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16042), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6571), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [16269] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16050), 1,
      sym__word_identifier,
    ACTIONS(16052), 1,
      anon_sym_COLON,
    ACTIONS(16054), 1,
      anon_sym_LPAREN,
    ACTIONS(16056), 1,
      anon_sym_LBRACK,
    ACTIONS(16058), 1,
      anon_sym_LBRACE,
    ACTIONS(16060), 1,
      anon_sym_DOLLAR,
    ACTIONS(16064), 1,
      sym_character_literal,
    ACTIONS(16066), 1,
      sym__string_start,
    ACTIONS(16068), 1,
      sym__command_start,
    STATE(5743), 1,
      sym_identifier,
    STATE(17053), 1,
      sym_macro_identifier,
    STATE(19242), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16062), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6580), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [16361] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15866), 1,
      sym__word_identifier,
    ACTIONS(15870), 1,
      anon_sym_LPAREN,
    ACTIONS(15872), 1,
      anon_sym_LBRACK,
    ACTIONS(15874), 1,
      anon_sym_LBRACE,
    ACTIONS(15882), 1,
      sym__string_start,
    ACTIONS(15884), 1,
      sym__command_start,
    ACTIONS(16070), 1,
      anon_sym_COLON,
    ACTIONS(16072), 1,
      anon_sym_DOLLAR,
    ACTIONS(16074), 1,
      sym_character_literal,
    STATE(10384), 1,
      sym_identifier,
    STATE(16898), 1,
      sym_macro_identifier,
    STATE(18950), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15878), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11022), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [16453] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16076), 1,
      sym__word_identifier,
    ACTIONS(16078), 1,
      anon_sym_COLON,
    ACTIONS(16080), 1,
      anon_sym_LPAREN,
    ACTIONS(16082), 1,
      anon_sym_LBRACK,
    ACTIONS(16084), 1,
      anon_sym_LBRACE,
    ACTIONS(16086), 1,
      anon_sym_DOLLAR,
    ACTIONS(16090), 1,
      sym_character_literal,
    ACTIONS(16092), 1,
      sym__string_start,
    ACTIONS(16094), 1,
      sym__command_start,
    STATE(4498), 1,
      sym_identifier,
    STATE(16688), 1,
      sym_macro_identifier,
    STATE(18630), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16088), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5548), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [16545] = 18,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(16096), 1,
      anon_sym_COLON,
    ACTIONS(16098), 1,
      anon_sym_DOLLAR,
    ACTIONS(16100), 1,
      sym_character_literal,
    STATE(11172), 1,
      sym_identifier,
    STATE(16735), 1,
      sym_macro_identifier,
    STATE(19313), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12999), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11429), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [16637] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16102), 1,
      anon_sym_COLON,
    ACTIONS(16104), 1,
      anon_sym_DOLLAR,
    ACTIONS(16106), 1,
      sym_character_literal,
    STATE(10770), 1,
      sym_identifier,
    STATE(16824), 1,
      sym_macro_identifier,
    STATE(18860), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15540), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11361), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [16729] = 18,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(16108), 1,
      anon_sym_COLON,
    ACTIONS(16110), 1,
      anon_sym_DOLLAR,
    ACTIONS(16112), 1,
      sym_character_literal,
    STATE(11008), 1,
      sym_identifier,
    STATE(16735), 1,
      sym_macro_identifier,
    STATE(19313), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12999), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11433), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [16821] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16114), 1,
      anon_sym_COLON,
    ACTIONS(16116), 1,
      anon_sym_DOLLAR,
    ACTIONS(16118), 1,
      sym_character_literal,
    STATE(10469), 1,
      sym_identifier,
    STATE(16824), 1,
      sym_macro_identifier,
    STATE(18860), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15540), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11190), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [16913] = 18,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(16120), 1,
      anon_sym_COLON,
    ACTIONS(16122), 1,
      anon_sym_DOLLAR,
    ACTIONS(16124), 1,
      sym_character_literal,
    STATE(11024), 1,
      sym_identifier,
    STATE(16735), 1,
      sym_macro_identifier,
    STATE(19313), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12999), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11434), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [17005] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16126), 1,
      anon_sym_COLON,
    ACTIONS(16128), 1,
      anon_sym_DOLLAR,
    ACTIONS(16130), 1,
      sym_character_literal,
    STATE(10828), 1,
      sym_identifier,
    STATE(16824), 1,
      sym_macro_identifier,
    STATE(18860), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15540), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11366), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [17097] = 18,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(16132), 1,
      anon_sym_COLON,
    ACTIONS(16134), 1,
      anon_sym_DOLLAR,
    ACTIONS(16136), 1,
      sym_character_literal,
    STATE(10846), 1,
      sym_identifier,
    STATE(16735), 1,
      sym_macro_identifier,
    STATE(19313), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12999), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11367), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [17189] = 18,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15770), 1,
      sym__word_identifier,
    ACTIONS(15772), 1,
      anon_sym_COLON,
    ACTIONS(15774), 1,
      anon_sym_LPAREN,
    ACTIONS(15776), 1,
      anon_sym_LBRACK,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(15780), 1,
      anon_sym_DOLLAR,
    ACTIONS(15786), 1,
      sym__string_start,
    ACTIONS(15788), 1,
      sym__command_start,
    ACTIONS(16138), 1,
      sym_character_literal,
    STATE(4820), 1,
      sym_identifier,
    STATE(17000), 1,
      sym_macro_identifier,
    STATE(19136), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15782), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2926), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(2924), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6037), 23,
      sym__primary_expression,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [17281] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12308), 43,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [17341] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12308), 43,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [17401] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12308), 42,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [17460] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12308), 23,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_isa,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(12306), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__string_start,
      sym__command_start,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [17517] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12308), 42,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [17576] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12308), 42,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [17635] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12306), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__string_start,
      sym__command_start,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(12308), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_isa,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [17691] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12308), 40,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [17749] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12308), 41,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [17807] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [17864] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [17920] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16140), 1,
      anon_sym_do,
    STATE(9989), 1,
      sym_do_clause,
    ACTIONS(11914), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [17980] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16140), 1,
      anon_sym_do,
    STATE(9980), 1,
      sym_do_clause,
    ACTIONS(11934), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18040] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16140), 1,
      anon_sym_do,
    STATE(10008), 1,
      sym_do_clause,
    ACTIONS(11898), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11896), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18100] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16140), 1,
      anon_sym_do,
    STATE(9883), 1,
      sym_do_clause,
    ACTIONS(11904), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11902), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18160] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11976), 1,
      anon_sym_DASH_GT,
    ACTIONS(12056), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18217] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16142), 1,
      anon_sym_do,
    STATE(10062), 1,
      sym_do_clause,
    ACTIONS(11914), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18276] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11986), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11984), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18331] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11982), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11980), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18386] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12038), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12036), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18441] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12026), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12024), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18496] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12020), 1,
      anon_sym_DASH_GT,
    ACTIONS(12044), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18553] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16142), 1,
      anon_sym_do,
    STATE(10056), 1,
      sym_do_clause,
    ACTIONS(11934), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18612] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12022), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12020), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18667] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11978), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11976), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18722] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12042), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12040), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18777] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12050), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12048), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18832] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11980), 1,
      anon_sym_DASH_GT,
    ACTIONS(12052), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18889] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12030), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12028), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [18944] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12028), 1,
      anon_sym_DASH_GT,
    ACTIONS(12068), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19001] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12020), 1,
      anon_sym_DASH_GT,
    ACTIONS(12060), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19058] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16144), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19115] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11984), 1,
      anon_sym_DASH_GT,
    ACTIONS(12044), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19172] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12034), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12032), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19227] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16142), 1,
      anon_sym_do,
    STATE(10059), 1,
      sym_do_clause,
    ACTIONS(11904), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11902), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19286] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16146), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 40,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19343] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11980), 1,
      anon_sym_DASH_GT,
    ACTIONS(12064), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19400] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16148), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 40,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19457] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19512] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11990), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11988), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19567] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11998), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11996), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19622] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16142), 1,
      anon_sym_do,
    STATE(10055), 1,
      sym_do_clause,
    ACTIONS(11898), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11896), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [19681] = 17,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16166), 1,
      sym__immediate_paren,
    ACTIONS(16168), 1,
      sym__immediate_bracket,
    ACTIONS(16170), 1,
      sym__immediate_brace,
    STATE(10786), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16150), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16160), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16162), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10046), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16164), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [19761] = 17,
    ACTIONS(15352), 1,
      sym__word_identifier,
    ACTIONS(15714), 1,
      sym__string_start,
    ACTIONS(15716), 1,
      sym__command_start,
    ACTIONS(16176), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16178), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16188), 1,
      sym__immediate_paren,
    ACTIONS(16190), 1,
      sym__immediate_bracket,
    ACTIONS(16192), 1,
      sym__immediate_brace,
    STATE(9309), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16174), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16172), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16180), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16182), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16184), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9465), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16186), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [19841] = 17,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(16198), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16200), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16210), 1,
      sym__immediate_paren,
    ACTIONS(16212), 1,
      sym__immediate_bracket,
    ACTIONS(16214), 1,
      sym__immediate_brace,
    STATE(11227), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16196), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16194), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16202), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16204), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16206), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10966), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16208), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [19921] = 17,
    ACTIONS(16010), 1,
      sym__word_identifier,
    ACTIONS(16026), 1,
      sym__string_start,
    ACTIONS(16028), 1,
      sym__command_start,
    ACTIONS(16220), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16222), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16232), 1,
      sym__immediate_paren,
    ACTIONS(16234), 1,
      sym__immediate_bracket,
    ACTIONS(16236), 1,
      sym__immediate_brace,
    STATE(10349), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16218), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16216), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16224), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16226), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16228), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11136), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16230), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20001] = 17,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16166), 1,
      sym__immediate_paren,
    ACTIONS(16168), 1,
      sym__immediate_bracket,
    ACTIONS(16170), 1,
      sym__immediate_brace,
    STATE(11029), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16150), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16160), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16162), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10046), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16164), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20081] = 17,
    ACTIONS(15866), 1,
      sym__word_identifier,
    ACTIONS(15882), 1,
      sym__string_start,
    ACTIONS(15884), 1,
      sym__command_start,
    ACTIONS(16242), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16244), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16254), 1,
      sym__immediate_paren,
    ACTIONS(16256), 1,
      sym__immediate_bracket,
    ACTIONS(16258), 1,
      sym__immediate_brace,
    STATE(11034), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16240), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16238), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16246), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16248), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16250), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10611), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16252), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20161] = 17,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(15274), 1,
      sym__word_identifier,
    ACTIONS(15280), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15282), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15292), 1,
      sym__immediate_paren,
    ACTIONS(15294), 1,
      sym__immediate_bracket,
    ACTIONS(15296), 1,
      sym__immediate_brace,
    STATE(10620), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15278), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15276), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(15284), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15286), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(15288), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10385), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15290), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20241] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11568), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20321] = 17,
    ACTIONS(16288), 1,
      sym__word_identifier,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16296), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16306), 1,
      sym__immediate_paren,
    ACTIONS(16308), 1,
      sym__immediate_bracket,
    ACTIONS(16310), 1,
      sym__immediate_brace,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    STATE(11570), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16290), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16300), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16302), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11520), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16304), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20401] = 17,
    ACTIONS(16316), 1,
      sym__word_identifier,
    ACTIONS(16322), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16324), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16334), 1,
      sym__immediate_paren,
    ACTIONS(16336), 1,
      sym__immediate_bracket,
    ACTIONS(16338), 1,
      sym__immediate_brace,
    ACTIONS(16340), 1,
      sym__string_start,
    ACTIONS(16342), 1,
      sym__command_start,
    STATE(11439), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16320), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16318), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16326), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16328), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16330), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11563), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16332), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20481] = 17,
    ACTIONS(16344), 1,
      sym__word_identifier,
    ACTIONS(16350), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16352), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16362), 1,
      sym__immediate_paren,
    ACTIONS(16364), 1,
      sym__immediate_bracket,
    ACTIONS(16366), 1,
      sym__immediate_brace,
    ACTIONS(16368), 1,
      sym__string_start,
    ACTIONS(16370), 1,
      sym__command_start,
    STATE(11560), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16348), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16346), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16354), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16356), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16358), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11684), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16360), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20561] = 17,
    ACTIONS(15620), 1,
      sym__word_identifier,
    ACTIONS(15636), 1,
      sym__string_start,
    ACTIONS(15638), 1,
      sym__command_start,
    ACTIONS(16376), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16378), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16388), 1,
      sym__immediate_paren,
    ACTIONS(16390), 1,
      sym__immediate_bracket,
    ACTIONS(16392), 1,
      sym__immediate_brace,
    STATE(4459), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16374), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16372), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16380), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16382), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16384), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5851), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16386), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20641] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12292), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [20695] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12050), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12048), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [20749] = 17,
    ACTIONS(1087), 1,
      sym__string_start,
    ACTIONS(1089), 1,
      sym__command_start,
    ACTIONS(11834), 1,
      sym__word_identifier,
    ACTIONS(11838), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11840), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(11846), 1,
      sym__immediate_paren,
    ACTIONS(11848), 1,
      sym__immediate_bracket,
    ACTIONS(11850), 1,
      sym__immediate_brace,
    STATE(4601), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16394), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(11836), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16396), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16398), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16400), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6403), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11844), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20829] = 17,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10613), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15318), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16406), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16408), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15326), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20909] = 17,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10453), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15318), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16406), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16408), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15326), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20989] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16410), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [21045] = 17,
    ACTIONS(749), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16412), 1,
      sym__word_identifier,
    ACTIONS(16416), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16424), 1,
      sym__immediate_paren,
    ACTIONS(16426), 1,
      sym__immediate_bracket,
    ACTIONS(16428), 1,
      sym__immediate_brace,
    ACTIONS(16430), 1,
      sym__string_start,
    ACTIONS(16432), 1,
      sym__command_start,
    STATE(6715), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8770), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8772), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16414), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16418), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16420), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7958), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16422), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21125] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11978), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11976), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [21179] = 17,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16450), 1,
      sym__immediate_paren,
    ACTIONS(16452), 1,
      sym__immediate_bracket,
    ACTIONS(16454), 1,
      sym__immediate_brace,
    STATE(11351), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16434), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16444), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16446), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10181), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16448), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21259] = 17,
    ACTIONS(16456), 1,
      sym__word_identifier,
    ACTIONS(16462), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16464), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16474), 1,
      sym__immediate_paren,
    ACTIONS(16476), 1,
      sym__immediate_bracket,
    ACTIONS(16478), 1,
      sym__immediate_brace,
    ACTIONS(16480), 1,
      sym__string_start,
    ACTIONS(16482), 1,
      sym__command_start,
    STATE(6564), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16460), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16458), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16466), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16468), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16470), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7138), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16472), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21339] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(2186), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [21393] = 17,
    ACTIONS(15898), 1,
      sym__word_identifier,
    ACTIONS(15914), 1,
      sym__string_start,
    ACTIONS(15916), 1,
      sym__command_start,
    ACTIONS(16488), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16490), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16500), 1,
      sym__immediate_paren,
    ACTIONS(16502), 1,
      sym__immediate_bracket,
    ACTIONS(16504), 1,
      sym__immediate_brace,
    STATE(4336), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16486), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16484), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16492), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16494), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16496), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4660), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16498), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21473] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12322), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [21527] = 17,
    ACTIONS(673), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16506), 1,
      sym__word_identifier,
    ACTIONS(16510), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16518), 1,
      sym__immediate_paren,
    ACTIONS(16520), 1,
      sym__immediate_bracket,
    ACTIONS(16522), 1,
      sym__immediate_brace,
    ACTIONS(16524), 1,
      sym__string_start,
    ACTIONS(16526), 1,
      sym__command_start,
    STATE(6802), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8728), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8730), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16508), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16512), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16514), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7890), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16516), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21607] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [21661] = 17,
    ACTIONS(16528), 1,
      sym__word_identifier,
    ACTIONS(16534), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16536), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16546), 1,
      sym__immediate_paren,
    ACTIONS(16548), 1,
      sym__immediate_bracket,
    ACTIONS(16550), 1,
      sym__immediate_brace,
    ACTIONS(16552), 1,
      sym__string_start,
    ACTIONS(16554), 1,
      sym__command_start,
    STATE(6562), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16532), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16530), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16538), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16540), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16542), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7112), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16544), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21741] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [21795] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12146), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [21849] = 17,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16450), 1,
      sym__immediate_paren,
    ACTIONS(16452), 1,
      sym__immediate_bracket,
    ACTIONS(16454), 1,
      sym__immediate_brace,
    STATE(10944), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16434), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16444), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16446), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10181), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16448), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21929] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12138), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12136), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [21983] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11482), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22063] = 17,
    ACTIONS(16288), 1,
      sym__word_identifier,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16296), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16306), 1,
      sym__immediate_paren,
    ACTIONS(16308), 1,
      sym__immediate_bracket,
    ACTIONS(16310), 1,
      sym__immediate_brace,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    STATE(11547), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16290), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16300), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16302), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11520), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16304), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22143] = 17,
    ACTIONS(15950), 1,
      sym__word_identifier,
    ACTIONS(15966), 1,
      sym__string_start,
    ACTIONS(15968), 1,
      sym__command_start,
    ACTIONS(16560), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16562), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16572), 1,
      sym__immediate_paren,
    ACTIONS(16574), 1,
      sym__immediate_bracket,
    ACTIONS(16576), 1,
      sym__immediate_brace,
    STATE(4952), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16558), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16556), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16564), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16566), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16568), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6281), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16570), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22223] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12154), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [22277] = 17,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10289), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15318), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16406), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16408), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15326), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22357] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16578), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [22413] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12268), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [22467] = 17,
    ACTIONS(1001), 1,
      sym__string_start,
    ACTIONS(1003), 1,
      sym__command_start,
    ACTIONS(11816), 1,
      sym__word_identifier,
    ACTIONS(11820), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11822), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(11828), 1,
      sym__immediate_paren,
    ACTIONS(11830), 1,
      sym__immediate_bracket,
    ACTIONS(11832), 1,
      sym__immediate_brace,
    STATE(4752), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16580), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(11818), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16582), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16584), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16586), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6258), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11826), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22547] = 4,
    ACTIONS(16588), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 16,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 26,
      sym__string_start,
      sym__command_start,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [22601] = 17,
    ACTIONS(381), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16590), 1,
      sym__word_identifier,
    ACTIONS(16594), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16602), 1,
      sym__immediate_paren,
    ACTIONS(16604), 1,
      sym__immediate_bracket,
    ACTIONS(16606), 1,
      sym__immediate_brace,
    ACTIONS(16608), 1,
      sym__string_start,
    ACTIONS(16610), 1,
      sym__command_start,
    STATE(6489), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8654), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8656), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16592), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16596), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16598), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7030), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16600), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22681] = 17,
    ACTIONS(899), 1,
      sym__string_start,
    ACTIONS(901), 1,
      sym__command_start,
    ACTIONS(11738), 1,
      sym__word_identifier,
    ACTIONS(11744), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11746), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(11756), 1,
      sym__immediate_paren,
    ACTIONS(11758), 1,
      sym__immediate_bracket,
    ACTIONS(11760), 1,
      sym__immediate_brace,
    STATE(4406), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11742), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(11740), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(11748), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(11750), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(11752), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5438), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11754), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22761] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12210), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [22815] = 17,
    ACTIONS(16050), 1,
      sym__word_identifier,
    ACTIONS(16066), 1,
      sym__string_start,
    ACTIONS(16068), 1,
      sym__command_start,
    ACTIONS(16616), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16618), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16628), 1,
      sym__immediate_paren,
    ACTIONS(16630), 1,
      sym__immediate_bracket,
    ACTIONS(16632), 1,
      sym__immediate_brace,
    STATE(5296), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16614), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16612), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16620), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16622), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16624), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6486), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16626), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22895] = 17,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16450), 1,
      sym__immediate_paren,
    ACTIONS(16452), 1,
      sym__immediate_bracket,
    ACTIONS(16454), 1,
      sym__immediate_brace,
    STATE(10811), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16434), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16444), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16446), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10181), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16448), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22975] = 17,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16166), 1,
      sym__immediate_paren,
    ACTIONS(16168), 1,
      sym__immediate_bracket,
    ACTIONS(16170), 1,
      sym__immediate_brace,
    STATE(10471), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16150), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16160), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16162), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10046), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16164), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23055] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(12019), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23135] = 17,
    ACTIONS(16288), 1,
      sym__word_identifier,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16296), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16306), 1,
      sym__immediate_paren,
    ACTIONS(16308), 1,
      sym__immediate_bracket,
    ACTIONS(16310), 1,
      sym__immediate_brace,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    STATE(12027), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16290), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16300), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16302), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11520), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16304), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23215] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11982), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11980), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [23269] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12328), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12326), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [23323] = 17,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10477), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15318), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16406), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16408), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15326), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23403] = 17,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16450), 1,
      sym__immediate_paren,
    ACTIONS(16452), 1,
      sym__immediate_bracket,
    ACTIONS(16454), 1,
      sym__immediate_brace,
    STATE(11011), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16434), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16444), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16446), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10181), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16448), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23483] = 17,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16166), 1,
      sym__immediate_paren,
    ACTIONS(16168), 1,
      sym__immediate_bracket,
    ACTIONS(16170), 1,
      sym__immediate_brace,
    STATE(10829), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16150), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16160), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16162), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10046), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16164), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23563] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(12096), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23643] = 17,
    ACTIONS(15508), 1,
      sym__word_identifier,
    ACTIONS(15524), 1,
      sym__string_start,
    ACTIONS(15526), 1,
      sym__command_start,
    ACTIONS(16638), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16640), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16650), 1,
      sym__immediate_paren,
    ACTIONS(16652), 1,
      sym__immediate_bracket,
    ACTIONS(16654), 1,
      sym__immediate_brace,
    STATE(9303), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16636), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16634), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16642), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16644), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16646), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9352), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16648), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23723] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 40,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [23777] = 17,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10481), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15318), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16406), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16408), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15326), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23857] = 17,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16450), 1,
      sym__immediate_paren,
    ACTIONS(16452), 1,
      sym__immediate_bracket,
    ACTIONS(16454), 1,
      sym__immediate_brace,
    STATE(11026), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16434), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16444), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16446), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10181), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16448), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23937] = 17,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16166), 1,
      sym__immediate_paren,
    ACTIONS(16168), 1,
      sym__immediate_bracket,
    ACTIONS(16170), 1,
      sym__immediate_brace,
    STATE(10839), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16150), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16160), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16162), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10046), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16164), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24017] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11390), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24097] = 17,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16166), 1,
      sym__immediate_paren,
    ACTIONS(16168), 1,
      sym__immediate_bracket,
    ACTIONS(16170), 1,
      sym__immediate_brace,
    STATE(11152), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16150), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16160), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16162), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10046), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16164), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24177] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12158), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [24231] = 17,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10294), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15318), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16406), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16408), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15326), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24311] = 17,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16450), 1,
      sym__immediate_paren,
    ACTIONS(16452), 1,
      sym__immediate_bracket,
    ACTIONS(16454), 1,
      sym__immediate_brace,
    STATE(10849), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16434), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16444), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16446), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10181), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16448), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24391] = 17,
    ACTIONS(15528), 1,
      sym__word_identifier,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16166), 1,
      sym__immediate_paren,
    ACTIONS(16168), 1,
      sym__immediate_bracket,
    ACTIONS(16170), 1,
      sym__immediate_brace,
    STATE(10486), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16150), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16160), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16162), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10046), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16164), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24471] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11453), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24551] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12384), 40,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [24605] = 17,
    ACTIONS(307), 1,
      sym__string_start,
    ACTIONS(309), 1,
      sym__command_start,
    ACTIONS(11720), 1,
      sym__word_identifier,
    ACTIONS(11724), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11726), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(11732), 1,
      sym__immediate_paren,
    ACTIONS(11734), 1,
      sym__immediate_bracket,
    ACTIONS(11736), 1,
      sym__immediate_brace,
    STATE(4285), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16656), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(11722), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16658), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16660), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16662), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5091), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11730), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24685] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12264), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [24739] = 17,
    ACTIONS(2786), 1,
      sym__string_start,
    ACTIONS(2788), 1,
      sym__command_start,
    ACTIONS(15334), 1,
      sym__word_identifier,
    ACTIONS(15338), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15340), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15346), 1,
      sym__immediate_paren,
    ACTIONS(15348), 1,
      sym__immediate_bracket,
    ACTIONS(15350), 1,
      sym__immediate_brace,
    STATE(10206), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16664), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15336), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16666), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16668), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16670), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10703), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15344), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24819] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11688), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24899] = 17,
    ACTIONS(16672), 1,
      sym__word_identifier,
    ACTIONS(16678), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16680), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16690), 1,
      sym__immediate_paren,
    ACTIONS(16692), 1,
      sym__immediate_bracket,
    ACTIONS(16694), 1,
      sym__immediate_brace,
    ACTIONS(16696), 1,
      sym__string_start,
    ACTIONS(16698), 1,
      sym__command_start,
    STATE(6375), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16676), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16674), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16682), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16684), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16686), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6707), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16688), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24979] = 17,
    ACTIONS(289), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16700), 1,
      sym__word_identifier,
    ACTIONS(16704), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16712), 1,
      sym__immediate_paren,
    ACTIONS(16714), 1,
      sym__immediate_bracket,
    ACTIONS(16716), 1,
      sym__immediate_brace,
    ACTIONS(16718), 1,
      sym__string_start,
    ACTIONS(16720), 1,
      sym__command_start,
    STATE(6619), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8750), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8752), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16702), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16706), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16708), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7185), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16710), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25059] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11463), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25139] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12166), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [25193] = 17,
    ACTIONS(15990), 1,
      sym__word_identifier,
    ACTIONS(16006), 1,
      sym__string_start,
    ACTIONS(16008), 1,
      sym__command_start,
    ACTIONS(16726), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16728), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16738), 1,
      sym__immediate_paren,
    ACTIONS(16740), 1,
      sym__immediate_bracket,
    ACTIONS(16742), 1,
      sym__immediate_brace,
    STATE(11508), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16724), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16722), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16730), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16732), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16734), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(12083), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16736), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25273] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11706), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25353] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12256), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [25407] = 17,
    ACTIONS(399), 1,
      sym__string_start,
    ACTIONS(401), 1,
      sym__command_start,
    ACTIONS(11702), 1,
      sym__word_identifier,
    ACTIONS(11706), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11708), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(11714), 1,
      sym__immediate_paren,
    ACTIONS(11716), 1,
      sym__immediate_bracket,
    ACTIONS(11718), 1,
      sym__immediate_brace,
    STATE(4281), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16744), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(11704), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16746), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16748), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16750), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4972), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11712), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25487] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11473), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25567] = 17,
    ACTIONS(15600), 1,
      sym__word_identifier,
    ACTIONS(15616), 1,
      sym__string_start,
    ACTIONS(15618), 1,
      sym__command_start,
    ACTIONS(16756), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16758), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16768), 1,
      sym__immediate_paren,
    ACTIONS(16770), 1,
      sym__immediate_bracket,
    ACTIONS(16772), 1,
      sym__immediate_brace,
    STATE(4920), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16754), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16752), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16760), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16762), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16764), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6223), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16766), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25647] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12170), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [25701] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11724), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25781] = 17,
    ACTIONS(16774), 1,
      sym__word_identifier,
    ACTIONS(16780), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16782), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16792), 1,
      sym__immediate_paren,
    ACTIONS(16794), 1,
      sym__immediate_bracket,
    ACTIONS(16796), 1,
      sym__immediate_brace,
    ACTIONS(16798), 1,
      sym__string_start,
    ACTIONS(16800), 1,
      sym__command_start,
    STATE(6606), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16778), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16776), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16784), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16786), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16788), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7114), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16790), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25861] = 17,
    ACTIONS(15790), 1,
      sym__word_identifier,
    ACTIONS(15806), 1,
      sym__string_start,
    ACTIONS(15808), 1,
      sym__command_start,
    ACTIONS(16806), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16808), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16818), 1,
      sym__immediate_paren,
    ACTIONS(16820), 1,
      sym__immediate_bracket,
    ACTIONS(16822), 1,
      sym__immediate_brace,
    STATE(4435), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16804), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16802), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16810), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16812), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16814), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5302), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16816), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25941] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16824), 1,
      anon_sym_do,
    STATE(10167), 1,
      sym_do_clause,
    ACTIONS(11914), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [25999] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [26053] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11608), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26133] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11406), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26213] = 17,
    ACTIONS(16260), 1,
      sym__word_identifier,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16278), 1,
      sym__immediate_paren,
    ACTIONS(16280), 1,
      sym__immediate_bracket,
    ACTIONS(16282), 1,
      sym__immediate_brace,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    STATE(11483), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16262), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16272), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16274), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10224), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16276), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26293] = 17,
    ACTIONS(591), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16826), 1,
      sym__word_identifier,
    ACTIONS(16830), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16838), 1,
      sym__immediate_paren,
    ACTIONS(16840), 1,
      sym__immediate_bracket,
    ACTIONS(16842), 1,
      sym__immediate_brace,
    ACTIONS(16844), 1,
      sym__string_start,
    ACTIONS(16846), 1,
      sym__command_start,
    STATE(6815), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8794), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8796), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16828), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16832), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16834), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(8010), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16836), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26373] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [26427] = 17,
    ACTIONS(13284), 1,
      sym__word_identifier,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(16198), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16200), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16210), 1,
      sym__immediate_paren,
    ACTIONS(16212), 1,
      sym__immediate_bracket,
    ACTIONS(16214), 1,
      sym__immediate_brace,
    STATE(10672), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16196), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16194), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16202), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16204), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16206), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10966), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16208), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26507] = 17,
    ACTIONS(1069), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16848), 1,
      sym__word_identifier,
    ACTIONS(16852), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16860), 1,
      sym__immediate_paren,
    ACTIONS(16862), 1,
      sym__immediate_bracket,
    ACTIONS(16864), 1,
      sym__immediate_brace,
    ACTIONS(16866), 1,
      sym__string_start,
    ACTIONS(16868), 1,
      sym__command_start,
    STATE(7133), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8692), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8694), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16850), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16854), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16856), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(8322), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16858), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26587] = 17,
    ACTIONS(15660), 1,
      sym__word_identifier,
    ACTIONS(15676), 1,
      sym__string_start,
    ACTIONS(15678), 1,
      sym__command_start,
    ACTIONS(16874), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16876), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16886), 1,
      sym__immediate_paren,
    ACTIONS(16888), 1,
      sym__immediate_bracket,
    ACTIONS(16890), 1,
      sym__immediate_brace,
    STATE(4357), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16872), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16870), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16880), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16882), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5190), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16884), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26667] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12248), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [26721] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [26775] = 17,
    ACTIONS(13170), 1,
      sym__word_identifier,
    ACTIONS(13186), 1,
      sym__string_start,
    ACTIONS(13188), 1,
      sym__command_start,
    ACTIONS(16896), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16898), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16908), 1,
      sym__immediate_paren,
    ACTIONS(16910), 1,
      sym__immediate_bracket,
    ACTIONS(16912), 1,
      sym__immediate_brace,
    STATE(10638), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16894), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16892), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16900), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16902), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16904), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11215), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16906), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26855] = 17,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    ACTIONS(15886), 1,
      sym__word_identifier,
    ACTIONS(16918), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16920), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16930), 1,
      sym__immediate_paren,
    ACTIONS(16932), 1,
      sym__immediate_bracket,
    ACTIONS(16934), 1,
      sym__immediate_brace,
    STATE(14441), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16916), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16914), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16922), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16924), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16926), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(14383), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16928), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26935] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12042), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12040), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [26989] = 17,
    ACTIONS(16936), 1,
      sym__word_identifier,
    ACTIONS(16942), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16944), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16954), 1,
      sym__immediate_paren,
    ACTIONS(16956), 1,
      sym__immediate_bracket,
    ACTIONS(16958), 1,
      sym__immediate_brace,
    ACTIONS(16960), 1,
      sym__string_start,
    ACTIONS(16962), 1,
      sym__command_start,
    STATE(6645), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16940), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16938), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16946), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16948), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16950), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(8016), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16952), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27069] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12240), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [27123] = 17,
    ACTIONS(16030), 1,
      sym__word_identifier,
    ACTIONS(16046), 1,
      sym__string_start,
    ACTIONS(16048), 1,
      sym__command_start,
    ACTIONS(16968), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16970), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16980), 1,
      sym__immediate_paren,
    ACTIONS(16982), 1,
      sym__immediate_bracket,
    ACTIONS(16984), 1,
      sym__immediate_brace,
    STATE(5611), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16966), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16964), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16972), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16974), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16976), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6480), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16978), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27203] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [27257] = 17,
    ACTIONS(983), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16986), 1,
      sym__word_identifier,
    ACTIONS(16990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16998), 1,
      sym__immediate_paren,
    ACTIONS(17000), 1,
      sym__immediate_bracket,
    ACTIONS(17002), 1,
      sym__immediate_brace,
    ACTIONS(17004), 1,
      sym__string_start,
    ACTIONS(17006), 1,
      sym__command_start,
    STATE(6858), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8548), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8550), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16988), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16992), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16994), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(8583), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16996), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27337] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12340), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12338), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [27391] = 17,
    ACTIONS(609), 1,
      sym__string_start,
    ACTIONS(611), 1,
      sym__command_start,
    ACTIONS(11762), 1,
      sym__word_identifier,
    ACTIONS(11766), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11768), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(11774), 1,
      sym__immediate_paren,
    ACTIONS(11776), 1,
      sym__immediate_bracket,
    ACTIONS(11778), 1,
      sym__immediate_brace,
    STATE(4350), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17008), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(11764), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17010), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17012), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17014), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5911), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11772), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27471] = 17,
    ACTIONS(16288), 1,
      sym__word_identifier,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16296), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16306), 1,
      sym__immediate_paren,
    ACTIONS(16308), 1,
      sym__immediate_bracket,
    ACTIONS(16310), 1,
      sym__immediate_brace,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    STATE(11386), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16290), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16300), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16302), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11520), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16304), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27551] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12150), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [27605] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 40,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [27659] = 17,
    ACTIONS(15750), 1,
      sym__word_identifier,
    ACTIONS(15766), 1,
      sym__string_start,
    ACTIONS(15768), 1,
      sym__command_start,
    ACTIONS(17020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17032), 1,
      sym__immediate_paren,
    ACTIONS(17034), 1,
      sym__immediate_bracket,
    ACTIONS(17036), 1,
      sym__immediate_brace,
    STATE(10430), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17016), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17026), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10968), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17030), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27739] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12212), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12214), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [27793] = 17,
    ACTIONS(13040), 1,
      sym__word_identifier,
    ACTIONS(13056), 1,
      sym__string_start,
    ACTIONS(13058), 1,
      sym__command_start,
    ACTIONS(17042), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17044), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17054), 1,
      sym__immediate_paren,
    ACTIONS(17056), 1,
      sym__immediate_bracket,
    ACTIONS(17058), 1,
      sym__immediate_brace,
    STATE(10577), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17040), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17038), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17046), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17048), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17050), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11338), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17052), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27873] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12384), 40,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [27927] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12272), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [27981] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17060), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [28037] = 17,
    ACTIONS(15770), 1,
      sym__word_identifier,
    ACTIONS(15786), 1,
      sym__string_start,
    ACTIONS(15788), 1,
      sym__command_start,
    ACTIONS(17066), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17068), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17078), 1,
      sym__immediate_paren,
    ACTIONS(17080), 1,
      sym__immediate_bracket,
    ACTIONS(17082), 1,
      sym__immediate_brace,
    STATE(4967), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17064), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17062), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17070), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17072), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17074), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6300), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17076), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [28117] = 17,
    ACTIONS(15866), 1,
      sym__word_identifier,
    ACTIONS(15882), 1,
      sym__string_start,
    ACTIONS(15884), 1,
      sym__command_start,
    ACTIONS(16242), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16244), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16254), 1,
      sym__immediate_paren,
    ACTIONS(16256), 1,
      sym__immediate_bracket,
    ACTIONS(16258), 1,
      sym__immediate_brace,
    STATE(10408), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16240), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16238), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16246), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16248), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16250), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10611), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16252), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [28197] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12142), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [28251] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16824), 1,
      anon_sym_do,
    STATE(10137), 1,
      sym_do_clause,
    ACTIONS(11898), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11896), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [28309] = 17,
    ACTIONS(761), 1,
      sym__string_start,
    ACTIONS(763), 1,
      sym__command_start,
    ACTIONS(11780), 1,
      sym__word_identifier,
    ACTIONS(11784), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11786), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(11792), 1,
      sym__immediate_paren,
    ACTIONS(11794), 1,
      sym__immediate_bracket,
    ACTIONS(11796), 1,
      sym__immediate_brace,
    STATE(4414), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17084), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(11782), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17086), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17088), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17090), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5946), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11790), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [28389] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11998), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11996), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [28443] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [28497] = 17,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(15274), 1,
      sym__word_identifier,
    ACTIONS(15280), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15282), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15292), 1,
      sym__immediate_paren,
    ACTIONS(15294), 1,
      sym__immediate_bracket,
    ACTIONS(15296), 1,
      sym__immediate_brace,
    STATE(10250), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15278), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15276), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(15284), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15286), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(15288), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10385), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15290), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [28577] = 17,
    ACTIONS(16076), 1,
      sym__word_identifier,
    ACTIONS(16092), 1,
      sym__string_start,
    ACTIONS(16094), 1,
      sym__command_start,
    ACTIONS(17096), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17098), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17108), 1,
      sym__immediate_paren,
    ACTIONS(17110), 1,
      sym__immediate_bracket,
    ACTIONS(17112), 1,
      sym__immediate_brace,
    STATE(4429), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17094), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17092), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17100), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17102), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17104), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5208), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17106), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [28657] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16824), 1,
      anon_sym_do,
    STATE(10152), 1,
      sym_do_clause,
    ACTIONS(11934), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [28715] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12384), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [28769] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12366), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12364), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [28823] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12244), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [28877] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12280), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [28931] = 17,
    ACTIONS(17114), 1,
      sym__word_identifier,
    ACTIONS(17120), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17122), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17132), 1,
      sym__immediate_paren,
    ACTIONS(17134), 1,
      sym__immediate_bracket,
    ACTIONS(17136), 1,
      sym__immediate_brace,
    ACTIONS(17138), 1,
      sym__string_start,
    ACTIONS(17140), 1,
      sym__command_start,
    STATE(16588), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17118), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17116), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17124), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17126), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17128), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(18072), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17130), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29011] = 17,
    ACTIONS(685), 1,
      sym__string_start,
    ACTIONS(687), 1,
      sym__command_start,
    ACTIONS(11798), 1,
      sym__word_identifier,
    ACTIONS(11802), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11804), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(11810), 1,
      sym__immediate_paren,
    ACTIONS(11812), 1,
      sym__immediate_bracket,
    ACTIONS(11814), 1,
      sym__immediate_brace,
    STATE(4440), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17142), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(11800), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17144), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17146), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17148), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5411), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11808), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29091] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12344), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12342), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [29145] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12236), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [29199] = 17,
    ACTIONS(15548), 1,
      sym__word_identifier,
    ACTIONS(15564), 1,
      sym__string_start,
    ACTIONS(15566), 1,
      sym__command_start,
    ACTIONS(17154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17166), 1,
      sym__immediate_paren,
    ACTIONS(17168), 1,
      sym__immediate_bracket,
    ACTIONS(17170), 1,
      sym__immediate_brace,
    STATE(4337), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17150), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17160), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17162), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5012), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17164), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29279] = 17,
    ACTIONS(15580), 1,
      sym__word_identifier,
    ACTIONS(15596), 1,
      sym__string_start,
    ACTIONS(15598), 1,
      sym__command_start,
    ACTIONS(17176), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17178), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17188), 1,
      sym__immediate_paren,
    ACTIONS(17190), 1,
      sym__immediate_bracket,
    ACTIONS(17192), 1,
      sym__immediate_brace,
    STATE(4323), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17174), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17172), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17180), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17182), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17184), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4948), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17186), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29359] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12172), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12174), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [29413] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12300), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [29467] = 17,
    ACTIONS(173), 1,
      sym__string_start,
    ACTIONS(175), 1,
      sym__command_start,
    ACTIONS(15298), 1,
      sym__word_identifier,
    ACTIONS(15302), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15304), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15310), 1,
      sym__immediate_paren,
    ACTIONS(15312), 1,
      sym__immediate_bracket,
    ACTIONS(15314), 1,
      sym__immediate_brace,
    STATE(10239), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17194), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15300), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17196), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17198), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17200), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10623), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15308), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29547] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12304), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [29601] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11930), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [29655] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [29709] = 17,
    ACTIONS(12985), 1,
      sym__word_identifier,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16450), 1,
      sym__immediate_paren,
    ACTIONS(16452), 1,
      sym__immediate_bracket,
    ACTIONS(16454), 1,
      sym__immediate_brace,
    STATE(11224), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16434), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16444), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16446), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10181), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16448), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29789] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [29843] = 17,
    ACTIONS(16344), 1,
      sym__word_identifier,
    ACTIONS(16350), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16352), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16362), 1,
      sym__immediate_paren,
    ACTIONS(16364), 1,
      sym__immediate_bracket,
    ACTIONS(16366), 1,
      sym__immediate_brace,
    ACTIONS(16368), 1,
      sym__string_start,
    ACTIONS(16370), 1,
      sym__command_start,
    STATE(11401), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16348), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16346), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16354), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16356), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16358), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11684), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16360), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29923] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12252), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [29977] = 17,
    ACTIONS(469), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17202), 1,
      sym__word_identifier,
    ACTIONS(17206), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17214), 1,
      sym__immediate_paren,
    ACTIONS(17216), 1,
      sym__immediate_bracket,
    ACTIONS(17218), 1,
      sym__immediate_brace,
    ACTIONS(17220), 1,
      sym__string_start,
    ACTIONS(17222), 1,
      sym__command_start,
    STATE(6582), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6320), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(6322), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17204), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17208), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17210), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6896), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17212), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30057] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12260), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [30111] = 17,
    ACTIONS(15730), 1,
      sym__word_identifier,
    ACTIONS(15746), 1,
      sym__string_start,
    ACTIONS(15748), 1,
      sym__command_start,
    ACTIONS(17228), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17230), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17240), 1,
      sym__immediate_paren,
    ACTIONS(17242), 1,
      sym__immediate_bracket,
    ACTIONS(17244), 1,
      sym__immediate_brace,
    STATE(4639), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17226), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17224), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17232), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17234), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17236), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6176), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17238), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30191] = 17,
    ACTIONS(16316), 1,
      sym__word_identifier,
    ACTIONS(16322), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16324), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16334), 1,
      sym__immediate_paren,
    ACTIONS(16336), 1,
      sym__immediate_bracket,
    ACTIONS(16338), 1,
      sym__immediate_brace,
    ACTIONS(16340), 1,
      sym__string_start,
    ACTIONS(16342), 1,
      sym__command_start,
    STATE(11388), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16320), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16318), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16326), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16328), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16330), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11563), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16332), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30271] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17246), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [30327] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12026), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12024), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [30381] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12030), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12028), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [30435] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11934), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [30489] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12162), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [30543] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12362), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12360), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [30597] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12034), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12032), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [30651] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11914), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [30705] = 17,
    ACTIONS(877), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17248), 1,
      sym__word_identifier,
    ACTIONS(17252), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17260), 1,
      sym__immediate_paren,
    ACTIONS(17262), 1,
      sym__immediate_bracket,
    ACTIONS(17264), 1,
      sym__immediate_brace,
    ACTIONS(17266), 1,
      sym__string_start,
    ACTIONS(17268), 1,
      sym__command_start,
    STATE(6674), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(875), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(881), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17250), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17254), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17256), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7819), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17258), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30785] = 17,
    ACTIONS(17270), 1,
      sym__word_identifier,
    ACTIONS(17276), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17278), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17288), 1,
      sym__immediate_paren,
    ACTIONS(17290), 1,
      sym__immediate_bracket,
    ACTIONS(17292), 1,
      sym__immediate_brace,
    ACTIONS(17294), 1,
      sym__string_start,
    ACTIONS(17296), 1,
      sym__command_start,
    STATE(6433), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17274), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17272), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17280), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17282), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17284), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6807), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17286), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30865] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12178), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [30919] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12388), 40,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [30973] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12022), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12020), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [31027] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12334), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [31081] = 17,
    ACTIONS(15680), 1,
      sym__word_identifier,
    ACTIONS(15696), 1,
      sym__string_start,
    ACTIONS(15698), 1,
      sym__command_start,
    ACTIONS(17302), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17304), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17314), 1,
      sym__immediate_paren,
    ACTIONS(17316), 1,
      sym__immediate_bracket,
    ACTIONS(17318), 1,
      sym__immediate_brace,
    STATE(4556), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17300), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17298), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17306), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17308), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17310), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5820), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17312), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [31161] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11986), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11984), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [31215] = 17,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    ACTIONS(15886), 1,
      sym__word_identifier,
    ACTIONS(16918), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16920), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16930), 1,
      sym__immediate_paren,
    ACTIONS(16932), 1,
      sym__immediate_bracket,
    ACTIONS(16934), 1,
      sym__immediate_brace,
    STATE(14332), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16916), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16914), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16922), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16924), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16926), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(14383), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(16928), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [31295] = 17,
    ACTIONS(15640), 1,
      sym__word_identifier,
    ACTIONS(15656), 1,
      sym__string_start,
    ACTIONS(15658), 1,
      sym__command_start,
    ACTIONS(17324), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17326), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17336), 1,
      sym__immediate_paren,
    ACTIONS(17338), 1,
      sym__immediate_bracket,
    ACTIONS(17340), 1,
      sym__immediate_brace,
    STATE(4851), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17322), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17320), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17328), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17330), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17332), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6061), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17334), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [31375] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12216), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12218), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [31429] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12284), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [31483] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12276), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [31537] = 17,
    ACTIONS(487), 1,
      sym__string_start,
    ACTIONS(489), 1,
      sym__command_start,
    ACTIONS(11682), 1,
      sym__word_identifier,
    ACTIONS(11688), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11690), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(11696), 1,
      sym__immediate_paren,
    ACTIONS(11698), 1,
      sym__immediate_bracket,
    ACTIONS(11700), 1,
      sym__immediate_brace,
    STATE(4286), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17342), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(11686), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17344), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17346), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17348), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4934), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(11694), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [31617] = 17,
    ACTIONS(15924), 1,
      sym__word_identifier,
    ACTIONS(15940), 1,
      sym__string_start,
    ACTIONS(15942), 1,
      sym__command_start,
    ACTIONS(17354), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17356), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17366), 1,
      sym__immediate_paren,
    ACTIONS(17368), 1,
      sym__immediate_bracket,
    ACTIONS(17370), 1,
      sym__immediate_brace,
    STATE(4469), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17352), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17350), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17358), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17360), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17362), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5231), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17364), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [31697] = 17,
    ACTIONS(15822), 1,
      sym__word_identifier,
    ACTIONS(15838), 1,
      sym__string_start,
    ACTIONS(15840), 1,
      sym__command_start,
    ACTIONS(17376), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17378), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17388), 1,
      sym__immediate_paren,
    ACTIONS(17390), 1,
      sym__immediate_bracket,
    ACTIONS(17392), 1,
      sym__immediate_brace,
    STATE(4716), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17374), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17372), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17380), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17382), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17384), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5966), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17386), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [31777] = 17,
    ACTIONS(17394), 1,
      sym__word_identifier,
    ACTIONS(17400), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17402), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17412), 1,
      sym__immediate_paren,
    ACTIONS(17414), 1,
      sym__immediate_bracket,
    ACTIONS(17416), 1,
      sym__immediate_brace,
    ACTIONS(17418), 1,
      sym__string_start,
    ACTIONS(17420), 1,
      sym__command_start,
    STATE(6824), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17398), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17396), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17406), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17408), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7631), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17410), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [31857] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12388), 40,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [31911] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [31965] = 17,
    ACTIONS(17422), 1,
      sym__word_identifier,
    ACTIONS(17428), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17430), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17440), 1,
      sym__immediate_paren,
    ACTIONS(17442), 1,
      sym__immediate_bracket,
    ACTIONS(17444), 1,
      sym__immediate_brace,
    ACTIONS(17446), 1,
      sym__string_start,
    ACTIONS(17448), 1,
      sym__command_start,
    STATE(6374), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17426), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17424), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17432), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17434), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17436), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6703), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17438), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [32045] = 17,
    ACTIONS(15970), 1,
      sym__word_identifier,
    ACTIONS(15986), 1,
      sym__string_start,
    ACTIONS(15988), 1,
      sym__command_start,
    ACTIONS(17454), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17456), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17466), 1,
      sym__immediate_paren,
    ACTIONS(17468), 1,
      sym__immediate_bracket,
    ACTIONS(17470), 1,
      sym__immediate_brace,
    STATE(4342), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17452), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17450), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17458), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17460), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17462), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5410), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17464), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [32125] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(16824), 1,
      anon_sym_do,
    STATE(10159), 1,
      sym_do_clause,
    ACTIONS(11904), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11902), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32183] = 17,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15316), 1,
      sym__word_identifier,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15328), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      sym__immediate_bracket,
    ACTIONS(15332), 1,
      sym__immediate_brace,
    STATE(10584), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15318), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(16406), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(16408), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10036), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(15326), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [32263] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12388), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32317] = 17,
    ACTIONS(17472), 1,
      sym__word_identifier,
    ACTIONS(17478), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17480), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17490), 1,
      sym__immediate_paren,
    ACTIONS(17492), 1,
      sym__immediate_bracket,
    ACTIONS(17494), 1,
      sym__immediate_brace,
    ACTIONS(17496), 1,
      sym__string_start,
    ACTIONS(17498), 1,
      sym__command_start,
    STATE(6596), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17476), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17474), 3,
      aux_sym_quote_expression_token1,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(17482), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(17484), 3,
      sym_character_literal,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    ACTIONS(17486), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7069), 8,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
      sym_operator,
    ACTIONS(17488), 10,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [32397] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32451] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12038), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12036), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32505] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11990), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11988), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32559] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12260), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32612] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17500), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12094), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32667] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12308), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32720] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12388), 16,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(12390), 26,
      sym__string_start,
      sym__command_start,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32771] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32824] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12384), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32877] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12328), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12326), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32930] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [32983] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12388), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33036] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12022), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12020), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33089] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12322), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33142] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12340), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12338), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33195] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12344), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12342), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33248] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11930), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33301] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11934), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33354] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33407] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12362), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12360), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33460] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12366), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12364), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33513] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12334), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33566] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11978), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11976), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33619] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12138), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12136), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33672] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33725] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11914), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33778] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12172), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12174), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33831] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11982), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11980), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33884] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11990), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11988), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33937] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11998), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11996), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [33990] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34043] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12264), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34096] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11986), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11984), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34149] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34202] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12268), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34255] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12384), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34308] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12272), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34361] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12026), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12024), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34414] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12030), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12028), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34467] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12034), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12032), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34520] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12304), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34573] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12038), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12036), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34626] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12042), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12040), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34679] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34732] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12212), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12214), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34785] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12216), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12218), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34838] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12388), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34891] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12388), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34944] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12276), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [34997] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12178), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35050] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12280), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35103] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35156] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12248), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35209] = 4,
    ACTIONS(17502), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 17,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 24,
      sym__string_start,
      sym__command_start,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35262] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35315] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35368] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35421] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12284), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35474] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12252), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35527] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12142), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35580] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12146), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35633] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12150), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35686] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12154), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35739] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12256), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35792] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17504), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35847] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35900] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12384), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [35953] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(2186), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36006] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12388), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36059] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12300), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36112] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12158), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36165] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12162), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36218] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17506), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36273] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12210), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36326] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36379] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 16,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 26,
      sym__string_start,
      sym__command_start,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36430] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12384), 39,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36483] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12166), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36536] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12170), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36589] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12384), 16,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(12386), 26,
      sym__string_start,
      sym__command_start,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36640] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12236), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36693] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12240), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36746] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12244), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36799] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12292), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36852] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12050), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12048), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36905] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12094), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [36957] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12162), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37009] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12264), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37061] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12272), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37113] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12178), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37165] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37217] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37269] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37321] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12248), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37373] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12252), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37425] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12322), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37477] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12304), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37529] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12384), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37581] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 17,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 24,
      sym__string_start,
      sym__command_start,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [37631] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12284), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37683] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12384), 17,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(12386), 24,
      sym__string_start,
      sym__command_start,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [37733] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12362), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12360), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37785] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37837] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12244), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37889] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37941] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12142), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [37993] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38045] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12146), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38097] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12150), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38149] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12154), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38201] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12256), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38253] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12260), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38305] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12300), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38357] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12292), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38409] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12384), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38461] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(12388), 38,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_end,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38513] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12366), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12364), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38565] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12340), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12338), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38617] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12166), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38669] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12344), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12342), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38721] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11930), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38773] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12276), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38825] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38877] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12138), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12136), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38929] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11934), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [38981] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12328), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12326), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39033] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12280), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39085] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(2186), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39137] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39189] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12210), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39241] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12384), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39293] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12172), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12174), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39345] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12212), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12214), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39397] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12388), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39449] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12388), 17,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(12390), 24,
      sym__string_start,
      sym__command_start,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [39499] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12334), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39551] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11914), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39603] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12268), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39655] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12094), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39707] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12216), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12218), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39759] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12308), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39811] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12158), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39863] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12236), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39915] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12388), 37,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [39967] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12240), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [40019] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [40071] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [40123] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12170), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [40175] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 4,
      sym__immediate_string_start,
      sym__immediate_command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11866), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [40226] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [40275] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17508), 1,
      anon_sym_DASH_GT,
    ACTIONS(17510), 1,
      sym__immediate_string_start,
    ACTIONS(17512), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [40331] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17514), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12094), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [40383] = 5,
    ACTIONS(17516), 1,
      anon_sym_do,
    STATE(10434), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11916), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11914), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [40435] = 5,
    ACTIONS(17516), 1,
      anon_sym_do,
    STATE(10407), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11902), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11904), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [40487] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [40537] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17518), 1,
      anon_sym_DASH_GT,
    ACTIONS(17520), 1,
      sym__immediate_string_start,
    ACTIONS(17522), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [40593] = 5,
    ACTIONS(17516), 1,
      anon_sym_do,
    STATE(10371), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11896), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11898), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [40645] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17524), 1,
      anon_sym_DASH_GT,
    ACTIONS(17526), 1,
      sym__immediate_string_start,
    ACTIONS(17528), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [40701] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [40749] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(177), 1,
      sym__immediate_string_start,
    ACTIONS(179), 1,
      sym__immediate_command_start,
    ACTIONS(17530), 1,
      anon_sym_DASH_GT,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [40805] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17510), 1,
      sym__immediate_string_start,
    ACTIONS(17512), 1,
      sym__immediate_command_start,
    ACTIONS(17532), 1,
      anon_sym_DASH_GT,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [40861] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [40911] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17520), 1,
      sym__immediate_string_start,
    ACTIONS(17522), 1,
      sym__immediate_command_start,
    ACTIONS(17534), 1,
      anon_sym_DASH_GT,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [40967] = 5,
    ACTIONS(17516), 1,
      anon_sym_do,
    STATE(10373), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11932), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11934), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [41019] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(151), 1,
      anon_sym_DASH_GT,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(177), 1,
      sym__immediate_string_start,
    ACTIONS(179), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41075] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17526), 1,
      sym__immediate_string_start,
    ACTIONS(17528), 1,
      sym__immediate_command_start,
    ACTIONS(17536), 1,
      anon_sym_DASH_GT,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [41131] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12066), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41180] = 4,
    ACTIONS(12030), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12070), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12068), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [41229] = 4,
    ACTIONS(11982), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12054), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12052), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [41278] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12036), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12038), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [41325] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17520), 1,
      sym__immediate_string_start,
    ACTIONS(17522), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [41378] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11866), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41427] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12054), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41476] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12264), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41525] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12268), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41574] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12272), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41623] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12304), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41672] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2186), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41721] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12040), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12042), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [41768] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12058), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41817] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17538), 1,
      anon_sym_DASH_GT,
    ACTIONS(17540), 1,
      sym__immediate_string_start,
    ACTIONS(17542), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41872] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12276), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41921] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12280), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [41970] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12020), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12022), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [42017] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12070), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42066] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12284), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42115] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12142), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42164] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12146), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42213] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11888), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42262] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12150), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42311] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12154), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42360] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17544), 1,
      sym__word_identifier,
    STATE(10675), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [42413] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12158), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42462] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12162), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42511] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12210), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42560] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12166), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42609] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12170), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42658] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12178), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42707] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17520), 1,
      sym__immediate_string_start,
    ACTIONS(17522), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [42760] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17546), 1,
      anon_sym_do,
    STATE(10576), 1,
      sym_do_clause,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [42813] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12322), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42862] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17548), 1,
      sym__word_identifier,
    STATE(10778), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42915] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12388), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [42964] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(177), 1,
      sym__immediate_string_start,
    ACTIONS(179), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [43017] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17548), 1,
      sym__word_identifier,
    STATE(10779), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [43070] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12062), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [43119] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12046), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [43168] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17544), 1,
      sym__word_identifier,
    STATE(10661), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [43221] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11976), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11978), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [43268] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17550), 1,
      anon_sym_DASH_GT,
    ACTIONS(17552), 1,
      sym__immediate_string_start,
    ACTIONS(17554), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [43323] = 5,
    ACTIONS(17556), 1,
      sym__word_identifier,
    STATE(10409), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12002), 17,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12004), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [43374] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10023), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [43427] = 5,
    ACTIONS(17556), 1,
      sym__word_identifier,
    STATE(10412), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12006), 17,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12008), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [43478] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12028), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12030), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [43525] = 5,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [43576] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17546), 1,
      anon_sym_do,
    STATE(10716), 1,
      sym_do_clause,
    ACTIONS(11904), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11902), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [43629] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12032), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12034), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [43676] = 4,
    ACTIONS(17564), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [43725] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17520), 1,
      sym__immediate_string_start,
    ACTIONS(17522), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [43778] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9914), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [43831] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [43884] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17552), 1,
      sym__immediate_string_start,
    ACTIONS(17554), 1,
      sym__immediate_command_start,
    ACTIONS(17566), 1,
      anon_sym_DASH_GT,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [43939] = 5,
    ACTIONS(17568), 1,
      anon_sym_do,
    STATE(10718), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11932), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11934), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [43990] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10023), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44043] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12094), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44092] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17514), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12094), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44143] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12024), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12026), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [44190] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12334), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44239] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9982), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44292] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17548), 1,
      sym__word_identifier,
    STATE(10799), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44345] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12236), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44394] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17570), 1,
      anon_sym_DASH_GT,
    ACTIONS(17572), 1,
      sym__immediate_string_start,
    ACTIONS(17574), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44449] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11984), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11986), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [44496] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12240), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44545] = 5,
    ACTIONS(17568), 1,
      anon_sym_do,
    STATE(10736), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11902), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11904), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44596] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9914), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44649] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44702] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11980), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11982), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [44749] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11988), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11990), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [44796] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12048), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12050), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [44843] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12244), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [44892] = 5,
    ACTIONS(17568), 1,
      anon_sym_do,
    STATE(10751), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11916), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11914), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44943] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11996), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11998), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [44990] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17510), 1,
      sym__immediate_string_start,
    ACTIONS(17512), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [45043] = 4,
    ACTIONS(11986), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12046), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12044), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [45092] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(177), 1,
      sym__immediate_string_start,
    ACTIONS(179), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [45145] = 4,
    ACTIONS(12022), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12046), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12044), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [45194] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12292), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [45243] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9982), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [45296] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17546), 1,
      anon_sym_do,
    STATE(10827), 1,
      sym_do_clause,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [45349] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17546), 1,
      anon_sym_do,
    STATE(10560), 1,
      sym_do_clause,
    ACTIONS(11898), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11896), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [45402] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [45451] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12384), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [45500] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17510), 1,
      sym__immediate_string_start,
    ACTIONS(17512), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [45553] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17510), 1,
      sym__immediate_string_start,
    ACTIONS(17512), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [45606] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12620), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12618), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [45655] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17526), 1,
      sym__immediate_string_start,
    ACTIONS(17528), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [45708] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 29,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45755] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17526), 1,
      sym__immediate_string_start,
    ACTIONS(17528), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [45808] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17526), 1,
      sym__immediate_string_start,
    ACTIONS(17528), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [45861] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17544), 1,
      sym__word_identifier,
    STATE(10662), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [45914] = 4,
    ACTIONS(11982), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12066), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12064), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [45963] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17572), 1,
      sym__immediate_string_start,
    ACTIONS(17574), 1,
      sym__immediate_command_start,
    ACTIONS(17576), 1,
      anon_sym_DASH_GT,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46018] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17540), 1,
      sym__immediate_string_start,
    ACTIONS(17542), 1,
      sym__immediate_command_start,
    ACTIONS(17578), 1,
      anon_sym_DASH_GT,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46073] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46122] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11892), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46171] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12248), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46220] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17580), 1,
      anon_sym_do,
    STATE(10892), 1,
      sym_do_clause,
    ACTIONS(11898), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11896), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46273] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(177), 1,
      sym__immediate_string_start,
    ACTIONS(179), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46326] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17580), 1,
      anon_sym_do,
    STATE(10894), 1,
      sym_do_clause,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46379] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12252), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46428] = 4,
    ACTIONS(11978), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12058), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12056), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [46477] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17548), 1,
      sym__word_identifier,
    STATE(10802), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46530] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12256), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46579] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12260), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46628] = 5,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11928), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11930), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [46679] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12300), 36,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46728] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17544), 1,
      sym__word_identifier,
    STATE(10673), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [46781] = 5,
    ACTIONS(17556), 1,
      sym__word_identifier,
    STATE(10374), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11992), 17,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11994), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [46832] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17580), 1,
      anon_sym_do,
    STATE(10899), 1,
      sym_do_clause,
    ACTIONS(11904), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11902), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46885] = 5,
    ACTIONS(17556), 1,
      sym__word_identifier,
    STATE(10375), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11958), 17,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11956), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [46936] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17580), 1,
      anon_sym_do,
    STATE(10908), 1,
      sym_do_clause,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [46989] = 5,
    ACTIONS(17568), 1,
      anon_sym_do,
    STATE(10582), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11896), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11898), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [47040] = 5,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [47091] = 4,
    ACTIONS(12022), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12062), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12060), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [47140] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11916), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11914), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [47186] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12026), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12024), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [47234] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12030), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12028), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [47282] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12034), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12032), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [47330] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17582), 1,
      sym__word_identifier,
    STATE(10960), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [47382] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12026), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12024), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [47430] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12030), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12028), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [47478] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12034), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12032), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [47526] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17582), 1,
      sym__word_identifier,
    STATE(10973), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [47578] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12038), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12036), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [47626] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12042), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12040), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [47674] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17582), 1,
      sym__word_identifier,
    STATE(10974), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [47726] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11980), 1,
      anon_sym_DASH_GT,
    ACTIONS(12052), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [47776] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17584), 1,
      sym__immediate_string_start,
    ACTIONS(17586), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [47828] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12050), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12048), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [47876] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17588), 1,
      anon_sym_do,
    STATE(11067), 1,
      sym_do_clause,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [47928] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12038), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12036), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [47976] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12042), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12040), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [48024] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11978), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11976), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [48072] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12388), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12390), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [48118] = 5,
    ACTIONS(17590), 1,
      anon_sym_do,
    STATE(11062), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11902), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11904), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [48168] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10023), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [48220] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9982), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [48272] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12050), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12048), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [48320] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9914), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [48372] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [48424] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12264), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12262), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [48470] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11976), 1,
      anon_sym_DASH_GT,
    ACTIONS(12056), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [48520] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17584), 1,
      sym__immediate_string_start,
    ACTIONS(17586), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [48572] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17526), 1,
      sym__immediate_string_start,
    ACTIONS(17528), 1,
      sym__immediate_command_start,
    ACTIONS(17592), 1,
      anon_sym_DASH_GT,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 29,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [48626] = 5,
    ACTIONS(17590), 1,
      anon_sym_do,
    STATE(11004), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11916), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11914), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [48676] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [48726] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(223), 1,
      sym__immediate_string_start,
    ACTIONS(225), 1,
      sym__immediate_command_start,
    ACTIONS(17596), 1,
      anon_sym_DASH_GT,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [48780] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12020), 1,
      anon_sym_DASH_GT,
    ACTIONS(12060), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [48830] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11986), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11984), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [48878] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17600), 1,
      anon_sym_LF,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17604), 1,
      aux_sym__terminator_token1,
    STATE(16499), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [48940] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17606), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [48990] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12268), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12266), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49036] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12272), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12270), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49082] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11980), 1,
      anon_sym_DASH_GT,
    ACTIONS(12064), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [49132] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12028), 1,
      anon_sym_DASH_GT,
    ACTIONS(12068), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [49182] = 4,
    ACTIONS(17608), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [49230] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10084), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [49282] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12304), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12302), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49328] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10086), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [49380] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10106), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [49432] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10107), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [49484] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [49532] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49578] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12236), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12234), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49624] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12360), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12362), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49670] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12240), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12238), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49716] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12364), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12366), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49762] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12276), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12274), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49808] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12280), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12278), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49854] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12334), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12336), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49900] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12020), 1,
      anon_sym_DASH_GT,
    ACTIONS(12060), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [49950] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12384), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12386), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49996] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12326), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12328), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50042] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2186), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(2188), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50088] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12248), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12246), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50134] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50180] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [50228] = 5,
    ACTIONS(17612), 1,
      sym__immediate_string_start,
    ACTIONS(17614), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50278] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50324] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17520), 1,
      sym__immediate_string_start,
    ACTIONS(17522), 1,
      sym__immediate_command_start,
    ACTIONS(17616), 1,
      anon_sym_DASH_GT,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 29,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [50378] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13036), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13038), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [50426] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12252), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12250), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50472] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12322), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12324), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50518] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12244), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12242), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50564] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12020), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12022), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50610] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11980), 1,
      anon_sym_DASH_GT,
    ACTIONS(12064), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [50660] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12022), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12020), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [50708] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12678), 35,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [50756] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12070), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12068), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50802] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12292), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12290), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50848] = 5,
    ACTIONS(17590), 1,
      anon_sym_do,
    STATE(11072), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11896), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11898), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50898] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12284), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12282), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50944] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12142), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12140), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50990] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12146), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12144), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [51036] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17588), 1,
      anon_sym_do,
    STATE(11133), 1,
      sym_do_clause,
    ACTIONS(11898), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11896), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [51088] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12028), 1,
      anon_sym_DASH_GT,
    ACTIONS(12068), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [51138] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12150), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12148), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [51184] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12058), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12056), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [51230] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12154), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12152), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [51276] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17584), 1,
      sym__immediate_string_start,
    ACTIONS(17586), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [51328] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12136), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12138), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [51374] = 5,
    ACTIONS(17612), 1,
      sym__immediate_string_start,
    ACTIONS(17614), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [51424] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12158), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12156), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [51470] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17618), 1,
      anon_sym_DASH_GT,
    ACTIONS(17620), 1,
      sym__immediate_string_start,
    ACTIONS(17622), 1,
      sym__immediate_command_start,
    ACTIONS(171), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [51524] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17624), 1,
      anon_sym_LF,
    ACTIONS(17626), 1,
      aux_sym__terminator_token1,
    STATE(16059), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [51586] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12162), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12160), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [51632] = 7,
    ACTIONS(17628), 1,
      anon_sym_EQ,
    ACTIONS(17631), 1,
      anon_sym_DASH_GT,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [51686] = 6,
    ACTIONS(17631), 1,
      anon_sym_DASH_GT,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [51738] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(207), 1,
      anon_sym_DASH_GT,
    ACTIONS(223), 1,
      sym__immediate_string_start,
    ACTIONS(225), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [51792] = 5,
    ACTIONS(17590), 1,
      anon_sym_do,
    STATE(11124), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11932), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11934), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [51842] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17637), 1,
      anon_sym_do,
    STATE(11177), 1,
      sym_do_clause,
    ACTIONS(11898), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11896), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [51894] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10023), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [51946] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17584), 1,
      sym__immediate_string_start,
    ACTIONS(17586), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [51998] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17637), 1,
      anon_sym_do,
    STATE(11181), 1,
      sym_do_clause,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [52050] = 5,
    ACTIONS(17639), 1,
      sym__word_identifier,
    STATE(10695), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11992), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11994), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52100] = 5,
    ACTIONS(17639), 1,
      sym__word_identifier,
    STATE(10698), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11958), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11956), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52150] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17540), 1,
      sym__immediate_string_start,
    ACTIONS(17542), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [52202] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9982), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [52254] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17637), 1,
      anon_sym_do,
    STATE(10936), 1,
      sym_do_clause,
    ACTIONS(11904), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11902), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [52306] = 5,
    ACTIONS(17639), 1,
      sym__word_identifier,
    STATE(10713), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12002), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12004), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52356] = 5,
    ACTIONS(17639), 1,
      sym__word_identifier,
    STATE(10714), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12006), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12008), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52406] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17637), 1,
      anon_sym_do,
    STATE(10945), 1,
      sym_do_clause,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [52458] = 5,
    ACTIONS(17612), 1,
      sym__immediate_string_start,
    ACTIONS(17614), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11928), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11930), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52508] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17641), 1,
      sym__immediate_string_start,
    ACTIONS(17643), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [52560] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12210), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12208), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [52606] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12166), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12164), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [52652] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12170), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12168), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [52698] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12174), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12172), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [52744] = 5,
    ACTIONS(17612), 1,
      sym__immediate_string_start,
    ACTIONS(17614), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52794] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10023), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [52846] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17588), 1,
      anon_sym_do,
    STATE(11122), 1,
      sym_do_clause,
    ACTIONS(11904), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11902), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [52898] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11980), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11982), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52944] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11988), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11990), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52990] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11996), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11998), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53036] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11976), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11978), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53082] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12178), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12176), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [53128] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17641), 1,
      sym__immediate_string_start,
    ACTIONS(17643), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [53180] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17588), 1,
      anon_sym_do,
    STATE(11007), 1,
      sym_do_clause,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [53232] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11984), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11986), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53278] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9914), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [53330] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [53382] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11984), 1,
      anon_sym_DASH_GT,
    ACTIONS(12044), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [53432] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12020), 1,
      anon_sym_DASH_GT,
    ACTIONS(12044), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [53482] = 6,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(17645), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [53534] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [53584] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12024), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12026), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53630] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17540), 1,
      sym__immediate_string_start,
    ACTIONS(17542), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [53682] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17647), 1,
      anon_sym_LF,
    ACTIONS(17649), 1,
      aux_sym__terminator_token1,
    STATE(16252), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [53744] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12214), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12212), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [53790] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17540), 1,
      sym__immediate_string_start,
    ACTIONS(17542), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [53842] = 6,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17651), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [53894] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53940] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12028), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12030), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53986] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12032), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12034), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54032] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12022), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12020), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [54080] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17572), 1,
      sym__immediate_string_start,
    ACTIONS(17574), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [54132] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12256), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12254), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [54178] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11982), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11980), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [54226] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11990), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11988), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [54274] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17653), 1,
      anon_sym_LF,
    ACTIONS(17655), 1,
      aux_sym__terminator_token1,
    STATE(16298), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [54336] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17620), 1,
      sym__immediate_string_start,
    ACTIONS(17622), 1,
      sym__immediate_command_start,
    ACTIONS(17657), 1,
      anon_sym_DASH_GT,
    ACTIONS(171), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [54390] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17659), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [54440] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17661), 1,
      sym__immediate_string_start,
    ACTIONS(17663), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [54492] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12260), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12258), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [54538] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17661), 1,
      sym__immediate_string_start,
    ACTIONS(17663), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [54590] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17661), 1,
      sym__immediate_string_start,
    ACTIONS(17663), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [54642] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17661), 1,
      sym__immediate_string_start,
    ACTIONS(17663), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [54694] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12300), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12298), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [54740] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17552), 1,
      sym__immediate_string_start,
    ACTIONS(17554), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [54792] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17641), 1,
      sym__immediate_string_start,
    ACTIONS(17643), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [54844] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17572), 1,
      sym__immediate_string_start,
    ACTIONS(17574), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [54896] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17665), 1,
      anon_sym_LF,
    ACTIONS(17667), 1,
      aux_sym__terminator_token1,
    STATE(16337), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [54958] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17572), 1,
      sym__immediate_string_start,
    ACTIONS(17574), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [55010] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11998), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11996), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [55058] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17552), 1,
      sym__immediate_string_start,
    ACTIONS(17554), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [55110] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17669), 1,
      anon_sym_LF,
    ACTIONS(17671), 1,
      aux_sym__terminator_token1,
    STATE(16365), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55172] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17552), 1,
      sym__immediate_string_start,
    ACTIONS(17554), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [55224] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17673), 1,
      anon_sym_LF,
    ACTIONS(17675), 1,
      aux_sym__terminator_token1,
    STATE(16390), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55286] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17677), 1,
      sym__immediate_string_start,
    ACTIONS(17679), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55338] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17677), 1,
      sym__immediate_string_start,
    ACTIONS(17679), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55390] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17677), 1,
      sym__immediate_string_start,
    ACTIONS(17679), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55442] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17677), 1,
      sym__immediate_string_start,
    ACTIONS(17679), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55494] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12036), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12038), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55540] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12040), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12042), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55586] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12218), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12216), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [55632] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11980), 1,
      anon_sym_DASH_GT,
    ACTIONS(12052), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55682] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11976), 1,
      anon_sym_DASH_GT,
    ACTIONS(12056), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55732] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17681), 1,
      anon_sym_LF,
    ACTIONS(17683), 1,
      aux_sym__terminator_token1,
    STATE(16406), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55794] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17685), 1,
      anon_sym_LF,
    ACTIONS(17687), 1,
      aux_sym__terminator_token1,
    STATE(16424), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55856] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17689), 1,
      anon_sym_LF,
    ACTIONS(17691), 1,
      aux_sym__terminator_token1,
    STATE(16439), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55918] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11982), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11980), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [55966] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17693), 1,
      anon_sym_LF,
    ACTIONS(17695), 1,
      aux_sym__terminator_token1,
    STATE(16455), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [56028] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12048), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12050), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [56074] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12338), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12340), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [56120] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11990), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11988), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [56168] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17697), 1,
      anon_sym_LF,
    ACTIONS(17699), 1,
      aux_sym__terminator_token1,
    STATE(16471), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [56230] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17701), 1,
      anon_sym_LF,
    ACTIONS(17703), 1,
      aux_sym__terminator_token1,
    STATE(16489), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [56292] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12342), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12344), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [56338] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11928), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11930), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [56384] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17641), 1,
      sym__immediate_string_start,
    ACTIONS(17643), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [56436] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10084), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [56488] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10086), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [56540] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10106), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [56592] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10107), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [56644] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11998), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11996), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [56692] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12062), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12060), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [56738] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17705), 1,
      sym__word_identifier,
    STATE(11096), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [56790] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17705), 1,
      sym__word_identifier,
    STATE(11098), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [56842] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17705), 1,
      sym__word_identifier,
    STATE(11105), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [56894] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17705), 1,
      sym__word_identifier,
    STATE(11106), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [56946] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12046), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12044), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [56992] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12066), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12064), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [57038] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11984), 1,
      anon_sym_DASH_GT,
    ACTIONS(12044), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [57088] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11932), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11934), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [57134] = 7,
    ACTIONS(17631), 1,
      anon_sym_DASH_GT,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(17707), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [57188] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11978), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11976), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [57236] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12020), 1,
      anon_sym_DASH_GT,
    ACTIONS(12044), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [57286] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12054), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12052), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [57332] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9914), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [57384] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11986), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11984), 32,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [57432] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17582), 1,
      sym__word_identifier,
    STATE(10959), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [57484] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [57530] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [57582] = 6,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [57634] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9982), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [57686] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [57731] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17712), 1,
      anon_sym_SQUOTE,
    ACTIONS(17714), 1,
      anon_sym_DOT,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17716), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [57790] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13568), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13566), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [57837] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12344), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12342), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [57884] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12236), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12234), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [57929] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12240), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12238), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [57974] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13447), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13445), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58021] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12244), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12242), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [58066] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17724), 1,
      anon_sym_LF,
    ACTIONS(17722), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [58123] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13451), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13449), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58170] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [58217] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11982), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11980), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58264] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11990), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11988), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58311] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11998), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11996), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58358] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13332), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13330), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58405] = 5,
    ACTIONS(17556), 1,
      sym__word_identifier,
    STATE(10412), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12006), 17,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12008), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [58454] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13576), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13574), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58501] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [58548] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58595] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17726), 1,
      anon_sym_SQUOTE,
    ACTIONS(17728), 1,
      anon_sym_DOT,
    ACTIONS(17730), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [58654] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9914), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58705] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58756] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17732), 1,
      sym__immediate_string_start,
    ACTIONS(17734), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [58807] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58854] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12026), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12024), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58901] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12030), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12028), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58948] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12034), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12032), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [58995] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13532), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13530), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59042] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12362), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12360), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [59089] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12038), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12036), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59136] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10107), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59187] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13580), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13578), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59234] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13584), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13582), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59281] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13588), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13586), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59328] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17712), 1,
      anon_sym_SQUOTE,
    ACTIONS(17714), 1,
      anon_sym_DOT,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17716), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59387] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13592), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13590), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59434] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13596), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13594), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59481] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13600), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13598), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59528] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12042), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12040), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59575] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12020), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12022), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [59620] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17712), 1,
      anon_sym_SQUOTE,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(17738), 1,
      anon_sym_DOT,
    ACTIONS(17740), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59681] = 6,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(17742), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [59732] = 6,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(17744), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [59783] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12050), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12048), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59830] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12366), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12364), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [59877] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17732), 1,
      sym__immediate_string_start,
    ACTIONS(17734), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [59928] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13249), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [59975] = 5,
    ACTIONS(17746), 1,
      sym__immediate_string_start,
    ACTIONS(17748), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [60024] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13536), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13534), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60071] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13540), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13538), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60118] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12360), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12362), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [60163] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [60210] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17620), 1,
      sym__immediate_string_start,
    ACTIONS(17622), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60261] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13380), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13378), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60308] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13544), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13542), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60355] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13548), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13546), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60402] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17750), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60451] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13552), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13550), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60498] = 6,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(17752), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [60549] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17712), 1,
      anon_sym_SQUOTE,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17738), 1,
      anon_sym_DOT,
    ACTIONS(17754), 1,
      anon_sym_EQ,
    ACTIONS(17740), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60610] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13556), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13554), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60657] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11980), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11982), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [60702] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11988), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11990), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [60747] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13560), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13558), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60794] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13564), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13562), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [60841] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(2186), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [60888] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12236), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [60935] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12240), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [60982] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12244), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [61029] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11996), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11998), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [61074] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13604), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13602), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [61121] = 5,
    ACTIONS(17746), 1,
      sym__immediate_string_start,
    ACTIONS(17748), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11928), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11930), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [61170] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13608), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13606), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [61217] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12326), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12328), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [61262] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [61309] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12384), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [61356] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12388), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [61403] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13622), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13620), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [61450] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13398), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13396), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [61497] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [61542] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17756), 1,
      anon_sym_do,
    STATE(11253), 1,
      sym_do_clause,
    ACTIONS(11904), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11902), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [61593] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(223), 1,
      sym__immediate_string_start,
    ACTIONS(225), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [61644] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(223), 1,
      sym__immediate_string_start,
    ACTIONS(225), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [61695] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12308), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12306), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [61740] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12248), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [61787] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12248), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12246), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [61832] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12252), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12250), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [61877] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(17760), 1,
      anon_sym_SQUOTE,
    ACTIONS(17762), 1,
      anon_sym_DOT,
    ACTIONS(17766), 1,
      sym__immediate_paren,
    ACTIONS(17768), 1,
      sym__immediate_bracket,
    ACTIONS(17770), 1,
      sym__immediate_brace,
    ACTIONS(17764), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [61938] = 5,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [61987] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12252), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [62034] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12024), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12026), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [62079] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [62126] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12256), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [62173] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12028), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12030), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [62218] = 5,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11928), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11930), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [62267] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12322), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [62314] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12032), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12034), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [62359] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12260), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [62406] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17726), 1,
      anon_sym_SQUOTE,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(17774), 1,
      anon_sym_DOT,
    ACTIONS(17776), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [62467] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12334), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [62514] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12322), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12324), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [62559] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10177), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [62610] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10106), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [62661] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17620), 1,
      sym__immediate_string_start,
    ACTIONS(17622), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [62712] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [62759] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13388), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13386), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [62806] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17780), 1,
      sym__immediate_string_start,
    ACTIONS(17782), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [62857] = 5,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [62906] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12256), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12254), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [62951] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13626), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13624), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [62998] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13630), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13628), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [63045] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11978), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11976), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [63092] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10107), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [63143] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12260), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12258), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [63188] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13431), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13429), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [63235] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10023), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [63286] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13634), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13632), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [63333] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [63380] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12036), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12038), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [63425] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13487), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13485), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [63472] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12040), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12042), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [63517] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11986), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11984), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [63564] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9982), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [63615] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12264), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [63662] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12268), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [63709] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12272), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [63756] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13638), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13636), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [63803] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13455), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13453), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [63850] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12048), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12050), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [63895] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12276), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [63942] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12280), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [63989] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [64036] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12284), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [64083] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12142), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [64130] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12338), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12340), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [64175] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12342), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12344), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [64220] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11928), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11930), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [64265] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13372), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13370), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [64312] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12146), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [64359] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12150), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [64406] = 5,
    ACTIONS(17746), 1,
      sym__immediate_string_start,
    ACTIONS(17748), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [64455] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12158), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [64502] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11932), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11934), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [64547] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12162), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [64594] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17784), 1,
      sym__word_identifier,
    STATE(11311), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [64645] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17786), 1,
      anon_sym_SQUOTE,
    ACTIONS(17788), 1,
      anon_sym_DOT,
    ACTIONS(17792), 1,
      sym__immediate_paren,
    ACTIONS(17794), 1,
      sym__immediate_bracket,
    ACTIONS(17796), 1,
      sym__immediate_brace,
    ACTIONS(17790), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [64704] = 6,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17798), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [64755] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12210), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [64802] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12066), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12064), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [64847] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12166), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [64894] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17784), 1,
      sym__word_identifier,
    STATE(11312), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [64945] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10122), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [64996] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12328), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12326), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [65043] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17780), 1,
      sym__immediate_string_start,
    ACTIONS(17782), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [65094] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12054), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12052), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [65139] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12264), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12262), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [65184] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12268), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12266), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [65229] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12272), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12270), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [65274] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12170), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [65321] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12178), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [65368] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13239), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [65415] = 5,
    ACTIONS(17556), 1,
      sym__word_identifier,
    STATE(10374), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11992), 17,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11994), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [65464] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13328), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13326), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [65511] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12276), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12274), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [65556] = 6,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17800), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [65607] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13642), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13640), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [65654] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12280), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12278), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [65699] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13646), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13644), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [65746] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13650), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13648), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [65793] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17760), 1,
      anon_sym_SQUOTE,
    ACTIONS(17766), 1,
      sym__immediate_paren,
    ACTIONS(17768), 1,
      sym__immediate_bracket,
    ACTIONS(17770), 1,
      sym__immediate_brace,
    ACTIONS(17802), 1,
      anon_sym_DOT,
    ACTIONS(17804), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [65852] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13376), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13374), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [65899] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [65946] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13654), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13652), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [65993] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13658), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13656), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [66040] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13662), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13660), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [66087] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13666), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13664), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [66134] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12070), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12068), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [66179] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12284), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12282), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [66224] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12142), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12140), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [66269] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12146), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12144), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [66314] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12150), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12148), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [66359] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12158), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12156), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [66404] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12162), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12160), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [66449] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12058), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12056), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [66494] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12138), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12136), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [66541] = 5,
    ACTIONS(17556), 1,
      sym__word_identifier,
    STATE(10375), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11956), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(11958), 17,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
  [66590] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12364), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12366), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [66635] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10084), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [66686] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10086), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [66737] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12322), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [66784] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10106), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [66835] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12022), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12020), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [66882] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12334), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12336), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [66927] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10107), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [66978] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [67025] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [67072] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12972), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12974), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [67119] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13483), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13481), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [67166] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11976), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11978), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [67211] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17806), 1,
      anon_sym_do,
    STATE(11244), 1,
      sym_do_clause,
    ACTIONS(11898), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11896), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [67262] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9914), 1,
      sym_identifier,
    ACTIONS(12004), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [67313] = 5,
    ACTIONS(17808), 1,
      sym__word_identifier,
    STATE(10999), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12002), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12004), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [67362] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17732), 1,
      sym__immediate_string_start,
    ACTIONS(17734), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [67413] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17806), 1,
      anon_sym_do,
    STATE(11245), 1,
      sym_do_clause,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [67464] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12136), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12138), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [67509] = 5,
    ACTIONS(17808), 1,
      sym__word_identifier,
    STATE(11001), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12006), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12008), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [67558] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11916), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11914), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [67603] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10157), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [67654] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11982), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11980), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [67701] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11990), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11988), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [67748] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10084), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [67799] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11998), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11996), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [67846] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12210), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12208), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [67891] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12166), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12164), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [67936] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    ACTIONS(12008), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [67987] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13402), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13400), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68034] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12170), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12168), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [68079] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13508), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13506), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68126] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12214), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12212), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [68171] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12174), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12172), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [68216] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17784), 1,
      sym__word_identifier,
    STATE(11320), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68267] = 4,
    ACTIONS(17810), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [68314] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [68361] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12236), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68408] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12240), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68455] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12244), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68502] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13348), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13346), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68549] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12178), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12176), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [68594] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68641] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17786), 1,
      anon_sym_SQUOTE,
    ACTIONS(17792), 1,
      sym__immediate_paren,
    ACTIONS(17794), 1,
      sym__immediate_bracket,
    ACTIONS(17796), 1,
      sym__immediate_brace,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(17814), 1,
      anon_sym_DOT,
    ACTIONS(17816), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68702] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10162), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68753] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12248), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68800] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12252), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68847] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12256), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68894] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12260), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [68941] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12218), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12216), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [68986] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69033] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69080] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17818), 1,
      sym__immediate_string_start,
    ACTIONS(17820), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69131] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69178] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12264), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69225] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12268), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69272] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12272), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69319] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12026), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12024), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [69366] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69413] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69460] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12276), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69507] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12280), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69554] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12030), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12028), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [69601] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12981), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69648] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13491), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13489), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69695] = 5,
    ACTIONS(17746), 1,
      sym__immediate_string_start,
    ACTIONS(17748), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [69744] = 6,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(17822), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [69795] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12034), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12032), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [69842] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17818), 1,
      sym__immediate_string_start,
    ACTIONS(17820), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69893] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17818), 1,
      sym__immediate_string_start,
    ACTIONS(17820), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69944] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17818), 1,
      sym__immediate_string_start,
    ACTIONS(17820), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [69995] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10086), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70046] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70093] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13495), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13493), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70140] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17784), 1,
      sym__word_identifier,
    STATE(11321), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70191] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12284), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70238] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12142), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70285] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12146), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70332] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12150), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70379] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [70426] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [70473] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12158), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70520] = 7,
    ACTIONS(17633), 1,
      sym__immediate_string_start,
    ACTIONS(17635), 1,
      sym__immediate_command_start,
    ACTIONS(17822), 1,
      anon_sym_DASH_GT,
    ACTIONS(17824), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [70573] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17826), 1,
      sym__immediate_string_start,
    ACTIONS(17828), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70624] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12162), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70671] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12210), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70718] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12166), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70765] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12170), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70812] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12178), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70859] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17830), 1,
      sym__word_identifier,
    STATE(11268), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [70910] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12292), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [70957] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17806), 1,
      anon_sym_do,
    STATE(11250), 1,
      sym_do_clause,
    ACTIONS(11904), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11902), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [71008] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12300), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [71055] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17826), 1,
      sym__immediate_string_start,
    ACTIONS(17828), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [71106] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17826), 1,
      sym__immediate_string_start,
    ACTIONS(17828), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [71157] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17830), 1,
      sym__word_identifier,
    STATE(11269), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [71208] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12292), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12290), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [71253] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13512), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13510), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [71300] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12038), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12036), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [71347] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12042), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12040), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [71394] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17620), 1,
      sym__immediate_string_start,
    ACTIONS(17622), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [71445] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17826), 1,
      sym__immediate_string_start,
    ACTIONS(17828), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [71496] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12334), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [71543] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17832), 1,
      anon_sym_COMMA,
    ACTIONS(17834), 1,
      anon_sym_LF,
    ACTIONS(17836), 1,
      aux_sym__terminator_token1,
    STATE(16534), 1,
      aux_sym__do_parameter_list_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 25,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [71604] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17732), 1,
      sym__immediate_string_start,
    ACTIONS(17734), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [71655] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12050), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12048), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [71702] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17830), 1,
      sym__word_identifier,
    STATE(11279), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [71753] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12212), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12214), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [71800] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12304), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [71847] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12172), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12174), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [71894] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17838), 1,
      sym__immediate_string_start,
    ACTIONS(17840), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [71945] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17838), 1,
      sym__immediate_string_start,
    ACTIONS(17840), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [71996] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17838), 1,
      sym__immediate_string_start,
    ACTIONS(17840), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72047] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17838), 1,
      sym__immediate_string_start,
    ACTIONS(17840), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72098] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12328), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12326), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72145] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [72192] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17830), 1,
      sym__word_identifier,
    STATE(11280), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [72243] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13255), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72290] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17806), 1,
      anon_sym_do,
    STATE(11272), 1,
      sym_do_clause,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [72341] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11986), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11984), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72388] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17842), 1,
      sym__immediate_string_start,
    ACTIONS(17844), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72439] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17842), 1,
      sym__immediate_string_start,
    ACTIONS(17844), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72490] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17842), 1,
      sym__immediate_string_start,
    ACTIONS(17844), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72541] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17842), 1,
      sym__immediate_string_start,
    ACTIONS(17844), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72592] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12154), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72639] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(10023), 1,
      sym_identifier,
    ACTIONS(11994), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72690] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13364), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13362), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72737] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17558), 1,
      sym__word_identifier,
    STATE(9982), 1,
      sym_identifier,
    ACTIONS(11956), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72788] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17846), 1,
      sym__immediate_string_start,
    ACTIONS(17848), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [72839] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17786), 1,
      anon_sym_SQUOTE,
    ACTIONS(17788), 1,
      anon_sym_DOT,
    ACTIONS(17792), 1,
      sym__immediate_paren,
    ACTIONS(17794), 1,
      sym__immediate_bracket,
    ACTIONS(17796), 1,
      sym__immediate_brace,
    ACTIONS(17790), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72898] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13368), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13366), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [72945] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17846), 1,
      sym__immediate_string_start,
    ACTIONS(17848), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [72996] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17846), 1,
      sym__immediate_string_start,
    ACTIONS(17848), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [73047] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17846), 1,
      sym__immediate_string_start,
    ACTIONS(17848), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [73098] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13435), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13433), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73145] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12216), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12218), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [73192] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11984), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11986), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [73237] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12292), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [73284] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73331] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12300), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12298), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [73376] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17780), 1,
      sym__immediate_string_start,
    ACTIONS(17782), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73427] = 5,
    ACTIONS(17808), 1,
      sym__word_identifier,
    STATE(11040), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11992), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11994), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [73476] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13415), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13413), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73523] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13419), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13417), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73570] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [73615] = 5,
    ACTIONS(17808), 1,
      sym__word_identifier,
    STATE(11053), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11958), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11956), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [73664] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13423), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13421), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73711] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13516), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13514), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73758] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [73805] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12340), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12338), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73852] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12344), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12342), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73899] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73946] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17756), 1,
      anon_sym_do,
    STATE(11341), 1,
      sym_do_clause,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [73997] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13427), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13425), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74044] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74091] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 3,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2186), 33,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74138] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17786), 1,
      anon_sym_SQUOTE,
    ACTIONS(17792), 1,
      sym__immediate_paren,
    ACTIONS(17794), 1,
      sym__immediate_bracket,
    ACTIONS(17796), 1,
      sym__immediate_brace,
    ACTIONS(17814), 1,
      anon_sym_DOT,
    ACTIONS(17850), 1,
      anon_sym_EQ,
    ACTIONS(17816), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74199] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13501), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13499), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74246] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13392), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13390), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74293] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17726), 1,
      anon_sym_SQUOTE,
    ACTIONS(17728), 1,
      anon_sym_DOT,
    ACTIONS(17730), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [74352] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13360), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13358), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74399] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12300), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [74446] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10084), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74497] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11978), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11976), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74544] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13439), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13437), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74591] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13094), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74638] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10086), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74689] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17852), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [74738] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13463), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13461), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [74785] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12304), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [74832] = 5,
    ACTIONS(17556), 1,
      sym__word_identifier,
    STATE(10409), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12002), 17,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12004), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [74881] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12062), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12060), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [74926] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12046), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12044), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [74971] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75018] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12362), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12360), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75065] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13384), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13382), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75112] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12366), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12364), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75159] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13409), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13407), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75206] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13243), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75253] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12304), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12302), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [75298] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13520), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13518), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75345] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12138), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12136), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75392] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12022), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12020), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75439] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75486] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(223), 1,
      sym__immediate_string_start,
    ACTIONS(225), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75537] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13318), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13316), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75584] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12926), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75631] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12340), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12338), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [75678] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10106), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75729] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12212), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12214), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75776] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12172), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12174), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75823] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12384), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75870] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(2186), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75917] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12216), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12218), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [75964] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76009] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13443), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13441), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [76056] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12384), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12386), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76101] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2186), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(2188), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76146] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17760), 1,
      anon_sym_SQUOTE,
    ACTIONS(17766), 1,
      sym__immediate_paren,
    ACTIONS(17768), 1,
      sym__immediate_bracket,
    ACTIONS(17770), 1,
      sym__immediate_brace,
    ACTIONS(17802), 1,
      anon_sym_DOT,
    ACTIONS(17804), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [76205] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12388), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [76252] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12154), 31,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [76299] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13322), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13320), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [76346] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13459), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13457), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [76393] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12154), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12152), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76438] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10157), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [76489] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12388), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12390), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76534] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13259), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13257), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [76581] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10162), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [76632] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10177), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [76683] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10122), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [76734] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13524), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13522), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [76781] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13528), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13526), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [76828] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17756), 1,
      anon_sym_do,
    STATE(11217), 1,
      sym_do_clause,
    ACTIONS(11898), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11896), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [76879] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17780), 1,
      sym__immediate_string_start,
    ACTIONS(17782), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [76930] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17756), 1,
      anon_sym_do,
    STATE(11246), 1,
      sym_do_clause,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [76981] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13572), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13570), 34,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [77028] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12240), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [77074] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12256), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [77120] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12138), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12136), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [77166] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12260), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [77212] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [77258] = 5,
    ACTIONS(17639), 1,
      sym__word_identifier,
    STATE(10695), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11992), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11994), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [77306] = 5,
    ACTIONS(17639), 1,
      sym__word_identifier,
    STATE(10698), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11958), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11956), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [77354] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12034), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12032), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [77400] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10084), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [77450] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12212), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12214), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [77496] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17854), 1,
      sym__immediate_string_start,
    ACTIONS(17856), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [77546] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12172), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12174), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [77592] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17854), 1,
      sym__immediate_string_start,
    ACTIONS(17856), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [77642] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10122), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [77692] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12216), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12218), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [77738] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [77784] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [77830] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12146), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12144), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [77874] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12264), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [77920] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12150), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12148), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [77964] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17854), 1,
      sym__immediate_string_start,
    ACTIONS(17856), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [78014] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12154), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12152), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [78058] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12268), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78104] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12272), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78150] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12236), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12234), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [78194] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12276), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78240] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12280), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78286] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12384), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12386), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [78330] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12268), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12266), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [78374] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12272), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12270), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [78418] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78464] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12284), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78510] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [78554] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12142), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78600] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [78646] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17858), 1,
      anon_sym_SQUOTE,
    ACTIONS(17860), 1,
      anon_sym_DOT,
    ACTIONS(17862), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [78704] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12026), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12024), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [78750] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12146), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78796] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12150), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78842] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12158), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78888] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12162), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78934] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12210), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78980] = 6,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17864), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [79030] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12322), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [79076] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12166), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [79122] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12334), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [79168] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11978), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11976), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [79214] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12170), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [79260] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12178), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [79306] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12338), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12340), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [79350] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10157), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [79400] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10162), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [79450] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12340), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12338), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [79496] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [79542] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11982), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11980), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [79588] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12304), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12302), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [79632] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11982), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11980), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [79678] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17712), 1,
      anon_sym_SQUOTE,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17738), 1,
      anon_sym_DOT,
    ACTIONS(17740), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [79736] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10177), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [79786] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12030), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12028), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [79832] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12292), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12290), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [79876] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17866), 1,
      anon_sym_SQUOTE,
    ACTIONS(17868), 1,
      anon_sym_DOT,
    ACTIONS(17870), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [79934] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12034), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12032), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [79980] = 5,
    ACTIONS(17639), 1,
      sym__word_identifier,
    STATE(10713), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12002), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12004), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [80028] = 5,
    ACTIONS(17872), 1,
      sym__immediate_string_start,
    ACTIONS(17874), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [80076] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12158), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12156), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [80120] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12038), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12036), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [80166] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12162), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12160), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [80210] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12042), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12040), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [80256] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12344), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12342), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [80302] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12174), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12172), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [80346] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11990), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11988), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [80392] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17786), 1,
      anon_sym_SQUOTE,
    ACTIONS(17792), 1,
      sym__immediate_paren,
    ACTIONS(17794), 1,
      sym__immediate_bracket,
    ACTIONS(17796), 1,
      sym__immediate_brace,
    ACTIONS(17814), 1,
      anon_sym_DOT,
    ACTIONS(17816), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [80450] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12366), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12364), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [80496] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17876), 1,
      sym__immediate_string_start,
    ACTIONS(17878), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [80546] = 6,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17880), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [80596] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12384), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [80642] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17876), 1,
      sym__immediate_string_start,
    ACTIONS(17878), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [80692] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17876), 1,
      sym__immediate_string_start,
    ACTIONS(17878), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [80742] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17876), 1,
      sym__immediate_string_start,
    ACTIONS(17878), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [80792] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17858), 1,
      anon_sym_SQUOTE,
    ACTIONS(17882), 1,
      anon_sym_EQ,
    ACTIONS(17884), 1,
      anon_sym_DOT,
    ACTIONS(17886), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [80852] = 5,
    ACTIONS(17639), 1,
      sym__word_identifier,
    STATE(10714), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12006), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12008), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [80900] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17888), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [80948] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10177), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [80998] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10122), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81048] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10086), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81098] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11990), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11988), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81144] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11986), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11984), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [81190] = 8,
    ACTIONS(17890), 1,
      anon_sym_SQUOTE,
    ACTIONS(17892), 1,
      anon_sym_DOT,
    ACTIONS(17894), 1,
      sym__immediate_paren,
    ACTIONS(17896), 1,
      sym__immediate_bracket,
    ACTIONS(17898), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12194), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12196), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [81244] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17900), 1,
      anon_sym_EQ,
    ACTIONS(17902), 1,
      anon_sym_SQUOTE,
    ACTIONS(17904), 1,
      anon_sym_DOT,
    ACTIONS(17906), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81304] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17908), 1,
      sym__immediate_string_start,
    ACTIONS(17910), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81354] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17914), 1,
      anon_sym_LF,
    ACTIONS(17912), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 25,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [81410] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17908), 1,
      sym__immediate_string_start,
    ACTIONS(17910), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81460] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17908), 1,
      sym__immediate_string_start,
    ACTIONS(17910), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81510] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17908), 1,
      sym__immediate_string_start,
    ACTIONS(17910), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81560] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17916), 1,
      sym__immediate_string_start,
    ACTIONS(17918), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81610] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12022), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12020), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81656] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11998), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11996), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [81702] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17916), 1,
      sym__immediate_string_start,
    ACTIONS(17918), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81752] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11986), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11984), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [81798] = 5,
    ACTIONS(17872), 1,
      sym__immediate_string_start,
    ACTIONS(17874), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [81846] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12248), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12246), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [81890] = 5,
    ACTIONS(17872), 1,
      sym__immediate_string_start,
    ACTIONS(17874), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11928), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11930), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [81938] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12050), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12048), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [81984] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12308), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [82030] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12240), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12238), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82074] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12276), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12274), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82118] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12328), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12326), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [82164] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12062), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12060), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82208] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12334), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [82254] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12388), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12390), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82298] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12388), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [82344] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12038), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12036), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [82390] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12166), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12164), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82434] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [82480] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11998), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11996), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [82526] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12042), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12040), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [82572] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12170), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12168), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82616] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10084), 1,
      sym_identifier,
    ACTIONS(11994), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [82666] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12280), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12278), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82710] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17866), 1,
      anon_sym_SQUOTE,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(17922), 1,
      anon_sym_DOT,
    ACTIONS(17924), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [82770] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12334), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12336), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82814] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12252), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12250), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82858] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12328), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12326), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [82904] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12256), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12254), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82948] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10086), 1,
      sym_identifier,
    ACTIONS(11956), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [82998] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83044] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11978), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11976), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83090] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12136), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12138), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [83134] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17926), 1,
      sym__immediate_string_start,
    ACTIONS(17928), 1,
      sym__immediate_command_start,
    ACTIONS(171), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83184] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12212), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12214), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83230] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12050), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12048), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83276] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17930), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [83324] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12172), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12174), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83370] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17916), 1,
      sym__immediate_string_start,
    ACTIONS(17918), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83420] = 5,
    ACTIONS(17872), 1,
      sym__immediate_string_start,
    ACTIONS(17874), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [83468] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10177), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83518] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10122), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83568] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12360), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12362), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [83612] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17858), 1,
      anon_sym_SQUOTE,
    ACTIONS(17884), 1,
      anon_sym_DOT,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(17886), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83672] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12292), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [83718] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12022), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12020), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [83764] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12236), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83810] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12030), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12028), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [83856] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12210), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12208), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [83900] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12244), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83946] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [83992] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12070), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12068), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [84036] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12248), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84082] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12252), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84128] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12256), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84174] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12260), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84220] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84266] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12046), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12044), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [84310] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10157), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84360] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84406] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84452] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12264), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84498] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12268), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84544] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12272), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84590] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84636] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84682] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12276), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84728] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12260), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12258), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [84772] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12280), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84818] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2186), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(2188), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [84862] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84908] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12284), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [84954] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12142), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85000] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12146), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85046] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12150), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85092] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12158), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85138] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12162), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85184] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12210), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85230] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12166), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85276] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12170), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85322] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12178), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85368] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [85414] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12342), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12344), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [85458] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [85502] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12292), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85548] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12300), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85594] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12304), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85640] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12154), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85686] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12384), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [85732] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12388), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [85778] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12308), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85824] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85870] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12138), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12136), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [85916] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(2186), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [85962] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12364), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12366), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [86006] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [86052] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12300), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [86098] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10157), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [86148] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10162), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [86198] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12304), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [86244] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12326), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12328), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [86288] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17902), 1,
      anon_sym_SQUOTE,
    ACTIONS(17904), 1,
      anon_sym_DOT,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(17906), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [86348] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12244), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12242), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [86392] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12362), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12360), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [86438] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10162), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [86488] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12154), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [86534] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [86580] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17902), 1,
      anon_sym_SQUOTE,
    ACTIONS(17936), 1,
      anon_sym_DOT,
    ACTIONS(17938), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [86638] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12300), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12298), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [86682] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12340), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12338), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [86728] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12344), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12342), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [86774] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [86820] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12216), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12218), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [86866] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17926), 1,
      sym__immediate_string_start,
    ACTIONS(17928), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [86916] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17858), 1,
      anon_sym_SQUOTE,
    ACTIONS(17860), 1,
      anon_sym_DOT,
    ACTIONS(17862), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [86974] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [87020] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17866), 1,
      anon_sym_SQUOTE,
    ACTIONS(17868), 1,
      anon_sym_DOT,
    ACTIONS(17870), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [87078] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [87124] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17902), 1,
      anon_sym_SQUOTE,
    ACTIONS(17936), 1,
      anon_sym_DOT,
    ACTIONS(17938), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [87182] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11932), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11934), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87226] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(2186), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [87272] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87316] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17926), 1,
      sym__immediate_string_start,
    ACTIONS(17928), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [87366] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [87412] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17726), 1,
      anon_sym_SQUOTE,
    ACTIONS(17774), 1,
      anon_sym_DOT,
    ACTIONS(17776), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [87470] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12214), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12212), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87514] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11916), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11914), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87558] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17866), 1,
      anon_sym_SQUOTE,
    ACTIONS(17922), 1,
      anon_sym_DOT,
    ACTIONS(17940), 1,
      anon_sym_EQ,
    ACTIONS(17924), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [87618] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17926), 1,
      sym__immediate_string_start,
    ACTIONS(17928), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [87668] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [87714] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12058), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12056), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87758] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12264), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12262), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87802] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10106), 1,
      sym_identifier,
    ACTIONS(12004), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [87852] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12196), 1,
      anon_sym_LF,
    ACTIONS(17942), 1,
      anon_sym_SQUOTE,
    ACTIONS(17944), 1,
      anon_sym_DOT,
    ACTIONS(17946), 1,
      sym__immediate_paren,
    ACTIONS(17948), 1,
      sym__immediate_bracket,
    ACTIONS(17950), 1,
      sym__immediate_brace,
    ACTIONS(12194), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [87908] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11928), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11930), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87952] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12322), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12324), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87996] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [88042] = 7,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(17952), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [88094] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12322), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [88140] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10107), 1,
      sym_identifier,
    ACTIONS(12008), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [88190] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10106), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [88240] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12284), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12282), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88284] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17854), 1,
      sym__immediate_string_start,
    ACTIONS(17856), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [88334] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17760), 1,
      anon_sym_SQUOTE,
    ACTIONS(17762), 1,
      anon_sym_DOT,
    ACTIONS(17766), 1,
      sym__immediate_paren,
    ACTIONS(17768), 1,
      sym__immediate_bracket,
    ACTIONS(17770), 1,
      sym__immediate_brace,
    ACTIONS(17764), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [88392] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12236), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [88438] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12218), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12216), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88482] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12240), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [88528] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12362), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12360), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [88574] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [88620] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88664] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12066), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12064), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88708] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12366), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12364), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [88754] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12026), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12024), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [88800] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12244), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [88846] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12308), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12306), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88890] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12054), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12052), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88934] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17916), 1,
      sym__immediate_string_start,
    ACTIONS(17918), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [88984] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12196), 1,
      anon_sym_LF,
    ACTIONS(17954), 1,
      anon_sym_SQUOTE,
    ACTIONS(17956), 1,
      anon_sym_DOT,
    ACTIONS(17958), 1,
      sym__immediate_paren,
    ACTIONS(17960), 1,
      sym__immediate_bracket,
    ACTIONS(17962), 1,
      sym__immediate_brace,
    ACTIONS(12194), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89040] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17610), 1,
      sym__word_identifier,
    STATE(10107), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89090] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12248), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [89136] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12196), 1,
      anon_sym_LF,
    ACTIONS(17964), 1,
      anon_sym_SQUOTE,
    ACTIONS(17966), 1,
      anon_sym_DOT,
    ACTIONS(17968), 1,
      sym__immediate_paren,
    ACTIONS(17970), 1,
      sym__immediate_bracket,
    ACTIONS(17972), 1,
      sym__immediate_brace,
    ACTIONS(12194), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89192] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12252), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [89238] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12142), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12140), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89282] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12196), 1,
      anon_sym_LF,
    ACTIONS(17964), 1,
      anon_sym_SQUOTE,
    ACTIONS(17968), 1,
      sym__immediate_paren,
    ACTIONS(17970), 1,
      sym__immediate_bracket,
    ACTIONS(17972), 1,
      sym__immediate_brace,
    ACTIONS(17974), 1,
      anon_sym_DOT,
    ACTIONS(12194), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [89338] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12178), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12176), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89382] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12328), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12326), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89427] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10157), 1,
      sym_identifier,
    ACTIONS(11994), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89476] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10162), 1,
      sym_identifier,
    ACTIONS(11956), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89525] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17976), 1,
      anon_sym_SQUOTE,
    ACTIONS(17978), 1,
      anon_sym_DOT,
    ACTIONS(17980), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89582] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17976), 1,
      anon_sym_SQUOTE,
    ACTIONS(17982), 1,
      anon_sym_EQ,
    ACTIONS(17984), 1,
      anon_sym_DOT,
    ACTIONS(17986), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89641] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(17990), 1,
      anon_sym_SQUOTE,
    ACTIONS(17992), 1,
      anon_sym_DOT,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(17994), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89700] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17996), 1,
      sym__immediate_string_start,
    ACTIONS(17998), 1,
      sym__immediate_command_start,
    ACTIONS(171), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89749] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17902), 1,
      anon_sym_SQUOTE,
    ACTIONS(17904), 1,
      anon_sym_DOT,
    ACTIONS(17906), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89806] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17990), 1,
      anon_sym_SQUOTE,
    ACTIONS(18000), 1,
      anon_sym_DOT,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(18002), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89863] = 5,
    ACTIONS(18004), 1,
      sym__immediate_string_start,
    ACTIONS(18006), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89910] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10177), 1,
      sym_identifier,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [89959] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10122), 1,
      sym_identifier,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90008] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17866), 1,
      anon_sym_SQUOTE,
    ACTIONS(17922), 1,
      anon_sym_DOT,
    ACTIONS(17924), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90065] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17990), 1,
      anon_sym_SQUOTE,
    ACTIONS(18000), 1,
      anon_sym_DOT,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(18002), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90122] = 8,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(18008), 1,
      anon_sym_EQ,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18010), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [90175] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12308), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90220] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12388), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90265] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12334), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [90310] = 11,
    ACTIONS(18014), 1,
      anon_sym_EQ,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18018), 1,
      anon_sym_DOT,
    ACTIONS(18020), 1,
      sym__assignment_operator,
    ACTIONS(18022), 1,
      sym__tilde_operator,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [90369] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10177), 1,
      sym_identifier,
    ACTIONS(12004), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12002), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90418] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90463] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10122), 1,
      sym_identifier,
    ACTIONS(12008), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12006), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90512] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12362), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12360), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90557] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12322), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90602] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12328), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12326), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [90647] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17976), 1,
      anon_sym_SQUOTE,
    ACTIONS(17984), 1,
      anon_sym_DOT,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(17986), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90706] = 8,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18032), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18034), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [90759] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12334), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90804] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12476), 1,
      anon_sym_LF,
    ACTIONS(18036), 1,
      anon_sym_SQUOTE,
    ACTIONS(18038), 1,
      anon_sym_DOT,
    ACTIONS(18040), 1,
      sym__immediate_paren,
    ACTIONS(18042), 1,
      sym__immediate_bracket,
    ACTIONS(18044), 1,
      sym__immediate_brace,
    ACTIONS(12410), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90859] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17996), 1,
      sym__immediate_string_start,
    ACTIONS(17998), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [90908] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18046), 1,
      anon_sym_EQ,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [90967] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17996), 1,
      sym__immediate_string_start,
    ACTIONS(17998), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [91016] = 5,
    ACTIONS(18004), 1,
      sym__immediate_string_start,
    ACTIONS(18006), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [91063] = 11,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18018), 1,
      anon_sym_DOT,
    ACTIONS(18020), 1,
      sym__assignment_operator,
    ACTIONS(18022), 1,
      sym__tilde_operator,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18056), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [91122] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18058), 1,
      sym__immediate_string_start,
    ACTIONS(18060), 1,
      sym__immediate_command_start,
    ACTIONS(11930), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [91171] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 25,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [91214] = 11,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18018), 1,
      anon_sym_DOT,
    ACTIONS(18020), 1,
      sym__assignment_operator,
    ACTIONS(18022), 1,
      sym__tilde_operator,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18062), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [91273] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12560), 1,
      anon_sym_LF,
    ACTIONS(18036), 1,
      anon_sym_SQUOTE,
    ACTIONS(18038), 1,
      anon_sym_DOT,
    ACTIONS(18040), 1,
      sym__immediate_paren,
    ACTIONS(18042), 1,
      sym__immediate_bracket,
    ACTIONS(18044), 1,
      sym__immediate_brace,
    ACTIONS(12558), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [91328] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12340), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12338), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [91373] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12344), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12342), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [91418] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [91463] = 5,
    ACTIONS(18004), 1,
      sym__immediate_string_start,
    ACTIONS(18006), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11928), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11930), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [91510] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [91553] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [91598] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17726), 1,
      anon_sym_SQUOTE,
    ACTIONS(17774), 1,
      anon_sym_DOT,
    ACTIONS(18064), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [91655] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12476), 1,
      anon_sym_LF,
    ACTIONS(18066), 1,
      anon_sym_SQUOTE,
    ACTIONS(18068), 1,
      anon_sym_DOT,
    ACTIONS(18070), 1,
      sym__immediate_paren,
    ACTIONS(18072), 1,
      sym__immediate_bracket,
    ACTIONS(18074), 1,
      sym__immediate_brace,
    ACTIONS(12410), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [91710] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17996), 1,
      sym__immediate_string_start,
    ACTIONS(17998), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [91759] = 10,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18076), 1,
      anon_sym_DOT,
    ACTIONS(18078), 1,
      sym__assignment_operator,
    ACTIONS(18080), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [91816] = 5,
    ACTIONS(18004), 1,
      sym__immediate_string_start,
    ACTIONS(18006), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [91863] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12362), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12360), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [91908] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12366), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12364), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [91953] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12366), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12364), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [91998] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17760), 1,
      anon_sym_SQUOTE,
    ACTIONS(17762), 1,
      anon_sym_DOT,
    ACTIONS(17766), 1,
      sym__immediate_paren,
    ACTIONS(17768), 1,
      sym__immediate_bracket,
    ACTIONS(17770), 1,
      sym__immediate_brace,
    ACTIONS(18082), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92055] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12236), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92100] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12240), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92145] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12138), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12136), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92190] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12244), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92235] = 11,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18018), 1,
      anon_sym_DOT,
    ACTIONS(18020), 1,
      sym__assignment_operator,
    ACTIONS(18022), 1,
      sym__tilde_operator,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18084), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [92294] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12138), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12136), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [92339] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92384] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12248), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92429] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12252), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92474] = 8,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18086), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18088), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [92527] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12256), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92572] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12260), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92617] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92662] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92707] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92752] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12264), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92797] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12268), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92842] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12272), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92887] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92932] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [92977] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12276), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93022] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12280), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93067] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12476), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18092), 1,
      anon_sym_DOT,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(12410), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [93122] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12212), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12214), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93167] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12172), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12174), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93212] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93257] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12284), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93302] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12142), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93347] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12146), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93392] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12150), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93437] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12216), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12218), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93482] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12158), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93527] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12162), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93572] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(2186), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93617] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12210), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93662] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12166), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93707] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12170), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93752] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12178), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93797] = 10,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18100), 1,
      anon_sym_DOT,
    ACTIONS(18102), 1,
      sym__assignment_operator,
    ACTIONS(18104), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [93854] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12560), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18106), 1,
      anon_sym_DOT,
    ACTIONS(12558), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [93909] = 10,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18100), 1,
      anon_sym_DOT,
    ACTIONS(18102), 1,
      sym__assignment_operator,
    ACTIONS(18104), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [93966] = 8,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18108), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18110), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [94019] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [94064] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12384), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [94109] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12236), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94154] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12240), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94199] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12244), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94244] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12388), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [94289] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12248), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94334] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12252), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94379] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12256), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94424] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12260), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94469] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12058), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94514] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12292), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [94559] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12066), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94604] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12054), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94649] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12264), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94694] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12268), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94739] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12272), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94784] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12300), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [94829] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12062), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94874] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12046), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [94919] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12304), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [94964] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12276), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95009] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12280), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95054] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12070), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95099] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12284), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95144] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12142), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95189] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12146), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95234] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17858), 1,
      anon_sym_SQUOTE,
    ACTIONS(17884), 1,
      anon_sym_DOT,
    ACTIONS(17886), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95291] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12150), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95336] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18058), 1,
      sym__immediate_string_start,
    ACTIONS(18060), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95385] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12158), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95430] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12162), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95475] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12210), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95520] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12154), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [95565] = 8,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18112), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18114), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [95618] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12166), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95663] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18058), 1,
      sym__immediate_string_start,
    ACTIONS(18060), 1,
      sym__immediate_command_start,
    ACTIONS(171), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(91), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95712] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [95757] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12170), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95802] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12178), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95847] = 7,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18116), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [95898] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12292), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95943] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [95988] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [96033] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12300), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [96078] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12304), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [96123] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11866), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [96168] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12154), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [96213] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [96258] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12212), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12214), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [96303] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17990), 1,
      anon_sym_SQUOTE,
    ACTIONS(17992), 1,
      anon_sym_DOT,
    ACTIONS(18118), 1,
      anon_sym_EQ,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(17994), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [96362] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12172), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12174), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [96407] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12384), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [96452] = 10,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18076), 1,
      anon_sym_DOT,
    ACTIONS(18078), 1,
      sym__assignment_operator,
    ACTIONS(18080), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [96509] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12560), 1,
      anon_sym_LF,
    ACTIONS(18066), 1,
      anon_sym_SQUOTE,
    ACTIONS(18068), 1,
      anon_sym_DOT,
    ACTIONS(18070), 1,
      sym__immediate_paren,
    ACTIONS(18072), 1,
      sym__immediate_bracket,
    ACTIONS(18074), 1,
      sym__immediate_brace,
    ACTIONS(12558), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [96564] = 8,
    ACTIONS(18120), 1,
      anon_sym_SQUOTE,
    ACTIONS(18122), 1,
      anon_sym_DOT,
    ACTIONS(18124), 1,
      sym__immediate_paren,
    ACTIONS(18126), 1,
      sym__immediate_bracket,
    ACTIONS(18128), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12410), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12476), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [96617] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(2186), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [96662] = 5,
    ACTIONS(17808), 1,
      sym__word_identifier,
    STATE(11040), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11992), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11994), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [96709] = 5,
    ACTIONS(17808), 1,
      sym__word_identifier,
    STATE(11053), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11958), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11956), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [96756] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12216), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12218), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [96801] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12322), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [96846] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18058), 1,
      sym__immediate_string_start,
    ACTIONS(18060), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11888), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [96895] = 5,
    ACTIONS(17808), 1,
      sym__word_identifier,
    STATE(10999), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12002), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12004), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [96942] = 5,
    ACTIONS(17808), 1,
      sym__word_identifier,
    STATE(11001), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12006), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12008), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [96989] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12094), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97034] = 8,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18130), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18132), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [97087] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10157), 1,
      sym_identifier,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11992), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97136] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17778), 1,
      sym__word_identifier,
    STATE(10162), 1,
      sym_identifier,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11958), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97185] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12306), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12308), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [97230] = 8,
    ACTIONS(18120), 1,
      anon_sym_SQUOTE,
    ACTIONS(18122), 1,
      anon_sym_DOT,
    ACTIONS(18124), 1,
      sym__immediate_paren,
    ACTIONS(18126), 1,
      sym__immediate_bracket,
    ACTIONS(18128), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12558), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12560), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [97283] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17976), 1,
      anon_sym_SQUOTE,
    ACTIONS(17978), 1,
      anon_sym_DOT,
    ACTIONS(17980), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97340] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12196), 1,
      anon_sym_LF,
    ACTIONS(17964), 1,
      anon_sym_SQUOTE,
    ACTIONS(17968), 1,
      sym__immediate_paren,
    ACTIONS(17970), 1,
      sym__immediate_bracket,
    ACTIONS(17972), 1,
      sym__immediate_brace,
    ACTIONS(18134), 1,
      anon_sym_DOT,
    ACTIONS(12194), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97395] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12340), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12338), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97440] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12560), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18092), 1,
      anon_sym_DOT,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(12558), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97495] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12344), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(12342), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97540] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11930), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11928), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97585] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12196), 1,
      anon_sym_LF,
    ACTIONS(17964), 1,
      anon_sym_SQUOTE,
    ACTIONS(17968), 1,
      sym__immediate_paren,
    ACTIONS(17970), 1,
      sym__immediate_bracket,
    ACTIONS(17972), 1,
      sym__immediate_brace,
    ACTIONS(18136), 1,
      anon_sym_DOT,
    ACTIONS(12194), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97640] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12476), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18106), 1,
      anon_sym_DOT,
    ACTIONS(12410), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [97695] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12196), 1,
      anon_sym_LF,
    ACTIONS(17964), 1,
      anon_sym_SQUOTE,
    ACTIONS(17968), 1,
      sym__immediate_paren,
    ACTIONS(17970), 1,
      sym__immediate_bracket,
    ACTIONS(17972), 1,
      sym__immediate_brace,
    ACTIONS(18138), 1,
      anon_sym_DOT,
    ACTIONS(12194), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97750] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11934), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11932), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97795] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_LF,
      anon_sym_SQUOTE,
    ACTIONS(11916), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [97840] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11505), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11958), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11956), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [97886] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18142), 1,
      sym__word_identifier,
    STATE(11843), 1,
      sym_identifier,
    ACTIONS(11992), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [97934] = 11,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18018), 1,
      anon_sym_DOT,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18084), 1,
      anon_sym_EQ,
    ACTIONS(18144), 1,
      sym__assignment_operator,
    ACTIONS(18146), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [97992] = 5,
    ACTIONS(18148), 1,
      sym__immediate_string_start,
    ACTIONS(18150), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [98038] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18152), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [98096] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18142), 1,
      sym__word_identifier,
    STATE(11621), 1,
      sym_identifier,
    ACTIONS(12002), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [98144] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18142), 1,
      sym__word_identifier,
    STATE(11622), 1,
      sym_identifier,
    ACTIONS(12006), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [98192] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [98240] = 5,
    ACTIONS(18156), 1,
      sym__word_identifier,
    STATE(11628), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12004), 15,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(12002), 16,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
  [98286] = 4,
    ACTIONS(18158), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [98330] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [98378] = 10,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18160), 1,
      anon_sym_DOT,
    ACTIONS(18162), 1,
      sym__assignment_operator,
    ACTIONS(18164), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [98434] = 5,
    ACTIONS(18166), 1,
      sym__immediate_string_start,
    ACTIONS(18168), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [98480] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [98522] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [98570] = 5,
    ACTIONS(18166), 1,
      sym__immediate_string_start,
    ACTIONS(18168), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [98616] = 10,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18170), 1,
      anon_sym_DOT,
    ACTIONS(18172), 1,
      sym__assignment_operator,
    ACTIONS(18174), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [98672] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18176), 1,
      sym__immediate_string_start,
    ACTIONS(18178), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [98720] = 5,
    ACTIONS(18156), 1,
      sym__word_identifier,
    STATE(11631), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12008), 15,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(12006), 16,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
  [98766] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18180), 1,
      sym__immediate_string_start,
    ACTIONS(18182), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [98814] = 10,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18160), 1,
      anon_sym_DOT,
    ACTIONS(18162), 1,
      sym__assignment_operator,
    ACTIONS(18164), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [98870] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18184), 1,
      sym__immediate_string_start,
    ACTIONS(18186), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [98918] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18176), 1,
      sym__immediate_string_start,
    ACTIONS(18178), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [98966] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18142), 1,
      sym__word_identifier,
    STATE(11671), 1,
      sym_identifier,
    ACTIONS(11958), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [99014] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17990), 1,
      anon_sym_SQUOTE,
    ACTIONS(17992), 1,
      anon_sym_DOT,
    ACTIONS(18188), 1,
      anon_sym_EQ,
    ACTIONS(17994), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [99072] = 10,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18018), 1,
      anon_sym_DOT,
    ACTIONS(18020), 1,
      sym__assignment_operator,
    ACTIONS(18022), 1,
      sym__tilde_operator,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [99128] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17976), 1,
      anon_sym_SQUOTE,
    ACTIONS(17984), 1,
      anon_sym_DOT,
    ACTIONS(17986), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [99184] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 3,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_LF,
    ACTIONS(11866), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [99228] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [99270] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18180), 1,
      sym__immediate_string_start,
    ACTIONS(18182), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [99318] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18184), 1,
      sym__immediate_string_start,
    ACTIONS(18186), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [99366] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [99414] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [99462] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [99510] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [99558] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18190), 1,
      sym__immediate_string_start,
    ACTIONS(18192), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [99606] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 3,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_LF,
    ACTIONS(11866), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [99650] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18194), 1,
      anon_sym_EQ,
    ACTIONS(18196), 1,
      anon_sym_DOT,
    ACTIONS(18198), 1,
      sym__assignment_operator,
    ACTIONS(18200), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [99708] = 6,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [99756] = 5,
    ACTIONS(18156), 1,
      sym__word_identifier,
    STATE(11776), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11994), 15,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(11992), 16,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
  [99802] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [99850] = 5,
    ACTIONS(18156), 1,
      sym__word_identifier,
    STATE(11779), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11956), 15,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(11958), 16,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__assignment_operator,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
  [99896] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18202), 1,
      sym__word_identifier,
    STATE(11711), 1,
      sym_identifier,
    ACTIONS(11992), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [99944] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18202), 1,
      sym__word_identifier,
    STATE(11712), 1,
      sym_identifier,
    ACTIONS(11958), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [99992] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18202), 1,
      sym__word_identifier,
    STATE(11857), 1,
      sym_identifier,
    ACTIONS(12002), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [100040] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18202), 1,
      sym__word_identifier,
    STATE(11723), 1,
      sym_identifier,
    ACTIONS(12006), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [100088] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11526), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11992), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11994), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [100134] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11507), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12006), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12008), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [100180] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12196), 1,
      anon_sym_LF,
    ACTIONS(17964), 1,
      anon_sym_SQUOTE,
    ACTIONS(17968), 1,
      sym__immediate_paren,
    ACTIONS(17970), 1,
      sym__immediate_bracket,
    ACTIONS(17972), 1,
      sym__immediate_brace,
    ACTIONS(18204), 1,
      anon_sym_DOT,
    ACTIONS(12194), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [100234] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17718), 1,
      sym__immediate_bracket,
    ACTIONS(17720), 1,
      sym__immediate_brace,
    ACTIONS(17990), 1,
      anon_sym_SQUOTE,
    ACTIONS(17992), 1,
      anon_sym_DOT,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(17994), 2,
      sym__assignment_operator,
      sym__tilde_operator,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [100290] = 10,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [100346] = 8,
    ACTIONS(17890), 1,
      anon_sym_SQUOTE,
    ACTIONS(17894), 1,
      sym__immediate_paren,
    ACTIONS(17896), 1,
      sym__immediate_bracket,
    ACTIONS(17898), 1,
      sym__immediate_brace,
    ACTIONS(18206), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12194), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12196), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [100398] = 11,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18208), 1,
      anon_sym_EQ,
    ACTIONS(18210), 1,
      anon_sym_DOT,
    ACTIONS(18212), 1,
      sym__assignment_operator,
    ACTIONS(18214), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [100456] = 6,
    ACTIONS(17560), 1,
      sym__immediate_string_start,
    ACTIONS(17562), 1,
      sym__immediate_command_start,
    ACTIONS(18216), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [100504] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17964), 1,
      anon_sym_SQUOTE,
    ACTIONS(17968), 1,
      sym__immediate_paren,
    ACTIONS(17970), 1,
      sym__immediate_bracket,
    ACTIONS(17972), 1,
      sym__immediate_brace,
    ACTIONS(18218), 1,
      anon_sym_DOT,
    ACTIONS(12196), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12194), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [100558] = 10,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18170), 1,
      anon_sym_DOT,
    ACTIONS(18172), 1,
      sym__assignment_operator,
    ACTIONS(18174), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [100614] = 10,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18076), 1,
      anon_sym_DOT,
    ACTIONS(18220), 1,
      sym__assignment_operator,
    ACTIONS(18222), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [100670] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18056), 1,
      anon_sym_EQ,
    ACTIONS(18196), 1,
      anon_sym_DOT,
    ACTIONS(18198), 1,
      sym__assignment_operator,
    ACTIONS(18200), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [100728] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12476), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18224), 1,
      anon_sym_DOT,
    ACTIONS(12410), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [100782] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12560), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18224), 1,
      anon_sym_DOT,
    ACTIONS(12558), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [100836] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11489), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12002), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12004), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [100882] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17832), 1,
      anon_sym_COMMA,
    ACTIONS(17834), 1,
      anon_sym_LF,
    ACTIONS(17836), 1,
      aux_sym__terminator_token1,
    STATE(16534), 1,
      aux_sym__do_parameter_list_repeat1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 25,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [100934] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12476), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18226), 1,
      anon_sym_DOT,
    ACTIONS(12410), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [100988] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12476), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18228), 1,
      anon_sym_DOT,
    ACTIONS(12410), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [101042] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12560), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18226), 1,
      anon_sym_DOT,
    ACTIONS(12558), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [101096] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12560), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18228), 1,
      anon_sym_DOT,
    ACTIONS(12558), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [101150] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18190), 1,
      sym__immediate_string_start,
    ACTIONS(18192), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [101198] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [101245] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18230), 1,
      sym__immediate_string_start,
    ACTIONS(18232), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [101292] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18230), 1,
      sym__immediate_string_start,
    ACTIONS(18232), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [101339] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12300), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12298), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [101380] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12146), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12144), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [101421] = 5,
    ACTIONS(18234), 1,
      sym__word_identifier,
    STATE(11963), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11958), 12,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11956), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [101466] = 5,
    ACTIONS(18236), 1,
      sym__immediate_string_start,
    ACTIONS(18238), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [101511] = 4,
    ACTIONS(11982), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12066), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12064), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [101554] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12150), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12148), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [101595] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18142), 1,
      sym__word_identifier,
    STATE(11622), 1,
      sym_identifier,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [101642] = 5,
    ACTIONS(18240), 1,
      anon_sym_do,
    STATE(12200), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11902), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11904), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [101687] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18142), 1,
      sym__word_identifier,
    STATE(11843), 1,
      sym_identifier,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [101734] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12046), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12044), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [101775] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18242), 1,
      sym__immediate_string_start,
    ACTIONS(18244), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [101822] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [101869] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18246), 1,
      sym__immediate_string_start,
    ACTIONS(18248), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [101916] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12236), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12234), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [101957] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12284), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12282), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [101998] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [102039] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12240), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12238), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [102080] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [102127] = 4,
    ACTIONS(18158), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [102170] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 1,
      anon_sym_LF,
    ACTIONS(18250), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12094), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [102215] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [102262] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [102309] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18242), 1,
      sym__immediate_string_start,
    ACTIONS(18244), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [102356] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [102403] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12244), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12242), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [102444] = 10,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18210), 1,
      anon_sym_DOT,
    ACTIONS(18212), 1,
      sym__assignment_operator,
    ACTIONS(18214), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [102499] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12384), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12386), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [102540] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18246), 1,
      sym__immediate_string_start,
    ACTIONS(18248), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [102587] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [102634] = 5,
    ACTIONS(18234), 1,
      sym__word_identifier,
    STATE(12209), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12002), 12,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12004), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [102679] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17914), 1,
      anon_sym_LF,
    ACTIONS(17912), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(171), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(91), 25,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__assignment_operator,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [102726] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18252), 1,
      sym__immediate_string_start,
    ACTIONS(18254), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [102773] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18256), 1,
      sym__immediate_string_start,
    ACTIONS(18258), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [102820] = 5,
    ACTIONS(18240), 1,
      anon_sym_do,
    STATE(12017), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11896), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11898), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [102865] = 5,
    ACTIONS(18234), 1,
      sym__word_identifier,
    STATE(11868), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12006), 12,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12008), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [102910] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18256), 1,
      sym__immediate_string_start,
    ACTIONS(18258), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [102957] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12272), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12270), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [102998] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18260), 1,
      sym__immediate_string_start,
    ACTIONS(18262), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [103045] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [103092] = 4,
    ACTIONS(11978), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12058), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12056), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [103135] = 5,
    ACTIONS(18264), 1,
      sym__immediate_string_start,
    ACTIONS(18266), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11928), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11930), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [103180] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18268), 1,
      sym__immediate_string_start,
    ACTIONS(18270), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [103227] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18260), 1,
      sym__immediate_string_start,
    ACTIONS(18262), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [103274] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18272), 1,
      anon_sym_EQ,
    ACTIONS(18274), 1,
      anon_sym_DOT,
    ACTIONS(18276), 1,
      sym__assignment_operator,
    ACTIONS(18278), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [103331] = 4,
    ACTIONS(12022), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12062), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12060), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [103374] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [103421] = 10,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18196), 1,
      anon_sym_DOT,
    ACTIONS(18198), 1,
      sym__assignment_operator,
    ACTIONS(18200), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [103476] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11526), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11992), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11994), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [103521] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12158), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12156), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [103562] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18280), 1,
      anon_sym_DOT,
    ACTIONS(12476), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12410), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [103615] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18280), 1,
      anon_sym_DOT,
    ACTIONS(12560), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12558), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [103668] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12142), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12140), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [103709] = 10,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18282), 1,
      anon_sym_DOT,
    ACTIONS(18284), 1,
      sym__assignment_operator,
    ACTIONS(18286), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [103764] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18142), 1,
      sym__word_identifier,
    STATE(11671), 1,
      sym_identifier,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [103811] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18142), 1,
      sym__word_identifier,
    STATE(11621), 1,
      sym_identifier,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [103858] = 10,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18282), 1,
      anon_sym_DOT,
    ACTIONS(18284), 1,
      sym__assignment_operator,
    ACTIONS(18286), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [103913] = 10,
    ACTIONS(18016), 1,
      anon_sym_SQUOTE,
    ACTIONS(18018), 1,
      anon_sym_DOT,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18144), 1,
      sym__assignment_operator,
    ACTIONS(18146), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [103968] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18202), 1,
      sym__word_identifier,
    STATE(11711), 1,
      sym_identifier,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [104015] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18202), 1,
      sym__word_identifier,
    STATE(11712), 1,
      sym_identifier,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [104062] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18202), 1,
      sym__word_identifier,
    STATE(11857), 1,
      sym_identifier,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [104109] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18202), 1,
      sym__word_identifier,
    STATE(11723), 1,
      sym_identifier,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [104156] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104197] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12334), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12336), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104238] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12178), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12176), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104279] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12280), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12278), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104320] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [104367] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12162), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12160), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104408] = 5,
    ACTIONS(18264), 1,
      sym__immediate_string_start,
    ACTIONS(18266), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104453] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [104500] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [104547] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12476), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18288), 1,
      anon_sym_DOT,
    ACTIONS(12410), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [104600] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12066), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12064), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104641] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12560), 1,
      anon_sym_LF,
    ACTIONS(18090), 1,
      anon_sym_SQUOTE,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(18096), 1,
      sym__immediate_bracket,
    ACTIONS(18098), 1,
      sym__immediate_brace,
    ACTIONS(18288), 1,
      anon_sym_DOT,
    ACTIONS(12558), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [104694] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12292), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12290), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104735] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12388), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12390), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104776] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11489), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12002), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12004), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104821] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11507), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12006), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12008), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104866] = 8,
    ACTIONS(18120), 1,
      anon_sym_SQUOTE,
    ACTIONS(18124), 1,
      sym__immediate_paren,
    ACTIONS(18126), 1,
      sym__immediate_bracket,
    ACTIONS(18128), 1,
      sym__immediate_brace,
    ACTIONS(18290), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12410), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12476), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104917] = 8,
    ACTIONS(18120), 1,
      anon_sym_SQUOTE,
    ACTIONS(18124), 1,
      sym__immediate_paren,
    ACTIONS(18126), 1,
      sym__immediate_bracket,
    ACTIONS(18128), 1,
      sym__immediate_brace,
    ACTIONS(18290), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12558), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12560), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [104968] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105009] = 5,
    ACTIONS(18240), 1,
      anon_sym_do,
    STATE(12025), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11932), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11934), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105054] = 5,
    ACTIONS(18264), 1,
      sym__immediate_string_start,
    ACTIONS(18266), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105099] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12054), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12052), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105140] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12264), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12262), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105181] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12210), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12208), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105222] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12276), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12274), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105263] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [105310] = 4,
    ACTIONS(12030), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12070), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12068), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [105353] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12268), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12266), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105394] = 4,
    ACTIONS(18292), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [105437] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [105484] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12166), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12164), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105525] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [105572] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2186), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(2188), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105613] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [105660] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12170), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12168), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105701] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [105748] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [105795] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [105842] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12062), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12060), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105883] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12154), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12152), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105924] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [105971] = 5,
    ACTIONS(18240), 1,
      anon_sym_do,
    STATE(12049), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11916), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11914), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106016] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18274), 1,
      anon_sym_DOT,
    ACTIONS(18276), 1,
      sym__assignment_operator,
    ACTIONS(18278), 1,
      sym__tilde_operator,
    ACTIONS(18294), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [106073] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11505), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11958), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11956), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106118] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106159] = 5,
    ACTIONS(18236), 1,
      sym__immediate_string_start,
    ACTIONS(18238), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106204] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18268), 1,
      sym__immediate_string_start,
    ACTIONS(18270), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [106251] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12260), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12258), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106292] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12070), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12068), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106333] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12248), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12246), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106374] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12304), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12302), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106415] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12322), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12324), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106456] = 5,
    ACTIONS(18234), 1,
      sym__word_identifier,
    STATE(11950), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11992), 12,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11994), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106501] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12252), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12250), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106542] = 5,
    ACTIONS(18264), 1,
      sym__immediate_string_start,
    ACTIONS(18266), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(91), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106587] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12058), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12056), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106628] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12256), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12254), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106669] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12618), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12620), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106710] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18252), 1,
      sym__immediate_string_start,
    ACTIONS(18254), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [106757] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 1,
      anon_sym_LF,
    ACTIONS(18296), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12094), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [106802] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18298), 1,
      anon_sym_COMMA,
    ACTIONS(18300), 1,
      anon_sym_as,
    STATE(11992), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [106850] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [106892] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 1,
      anon_sym_LF,
    ACTIONS(12154), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [106934] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12244), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12242), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [106974] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12292), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12290), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [107014] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [107060] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18302), 1,
      sym__immediate_string_start,
    ACTIONS(18304), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [107106] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12388), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12390), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [107146] = 5,
    ACTIONS(18306), 1,
      sym__immediate_string_start,
    ACTIONS(18308), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [107190] = 11,
    ACTIONS(13356), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [107246] = 5,
    ACTIONS(18008), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18010), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [107290] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18062), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [107346] = 11,
    ACTIONS(13342), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [107402] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 1,
      anon_sym_LF,
    ACTIONS(12322), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [107444] = 13,
    ACTIONS(18310), 1,
      sym__word_identifier,
    ACTIONS(18312), 1,
      aux_sym_import_path_token1,
    ACTIONS(18314), 1,
      anon_sym_LPAREN,
    ACTIONS(18316), 1,
      anon_sym_DOLLAR,
    ACTIONS(18318), 1,
      anon_sym_AT,
    STATE(7701), 1,
      sym_scoped_identifier,
    STATE(7702), 1,
      sym_identifier,
    STATE(8275), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9098), 2,
      sym__import_list,
      sym_selected_import,
    STATE(7700), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16952), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16950), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [107504] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11988), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11990), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [107544] = 11,
    ACTIONS(13411), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [107600] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [107646] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 1,
      anon_sym_LF,
    ACTIONS(12384), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [107688] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12848), 1,
      anon_sym_LF,
    ACTIONS(18320), 1,
      anon_sym_DOT,
    ACTIONS(12846), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [107732] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12062), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12060), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [107772] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 1,
      anon_sym_LF,
    ACTIONS(2186), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [107814] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 1,
      anon_sym_LF,
    ACTIONS(12334), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [107856] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18322), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [107912] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12620), 1,
      anon_sym_LF,
    ACTIONS(12618), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [107954] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12046), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12044), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [107994] = 29,
    ACTIONS(18324), 1,
      anon_sym_COMMA,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18330), 1,
      anon_sym_RPAREN,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18336), 1,
      anon_sym_SEMI,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14685), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15083), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    STATE(16372), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [108086] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12210), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12208), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [108126] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [108172] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [108218] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11994), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11992), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [108264] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 1,
      anon_sym_LF,
    ACTIONS(12094), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [108306] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12386), 1,
      anon_sym_LF,
    ACTIONS(12384), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [108348] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18370), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [108404] = 11,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [108460] = 11,
    ACTIONS(12562), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [108516] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18372), 1,
      anon_sym_COMMA,
    ACTIONS(18374), 1,
      anon_sym_RPAREN,
    ACTIONS(18376), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14747), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14748), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    STATE(16215), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [108608] = 13,
    ACTIONS(18378), 1,
      sym__word_identifier,
    ACTIONS(18380), 1,
      aux_sym_import_path_token1,
    ACTIONS(18382), 1,
      anon_sym_LPAREN,
    ACTIONS(18384), 1,
      anon_sym_DOLLAR,
    ACTIONS(18386), 1,
      anon_sym_AT,
    STATE(11659), 1,
      sym_scoped_identifier,
    STATE(11663), 1,
      sym_identifier,
    STATE(12106), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12804), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11657), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16360), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16358), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [108668] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11956), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11958), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [108714] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 1,
      anon_sym_LF,
    ACTIONS(12388), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [108756] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18388), 1,
      anon_sym_COMMA,
    ACTIONS(18390), 1,
      anon_sym_as,
    ACTIONS(18392), 1,
      anon_sym_COLON2,
    STATE(12056), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [108806] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18294), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [108862] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [108902] = 11,
    ACTIONS(14616), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [108958] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12036), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12038), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [108998] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12040), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12042), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [109038] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18394), 1,
      sym__immediate_string_start,
    ACTIONS(18396), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11888), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [109084] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 1,
      anon_sym_LF,
    ACTIONS(12150), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [109126] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13038), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13036), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [109166] = 11,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109222] = 5,
    ACTIONS(18108), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18110), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [109266] = 13,
    ACTIONS(18398), 1,
      sym__word_identifier,
    ACTIONS(18400), 1,
      aux_sym_import_path_token1,
    ACTIONS(18402), 1,
      anon_sym_LPAREN,
    ACTIONS(18404), 1,
      anon_sym_DOLLAR,
    ACTIONS(18406), 1,
      anon_sym_AT,
    STATE(7599), 1,
      sym_scoped_identifier,
    STATE(7600), 1,
      sym_identifier,
    STATE(8181), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8771), 2,
      sym__import_list,
      sym_selected_import,
    STATE(7598), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17410), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17408), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [109326] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18408), 1,
      anon_sym_COMMA,
    ACTIONS(18410), 1,
      anon_sym_RPAREN,
    ACTIONS(18412), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14549), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14600), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15628), 1,
      sym__comprehension_clause,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [109418] = 13,
    ACTIONS(18414), 1,
      sym__word_identifier,
    ACTIONS(18416), 1,
      aux_sym_import_path_token1,
    ACTIONS(18418), 1,
      anon_sym_LPAREN,
    ACTIONS(18420), 1,
      anon_sym_DOLLAR,
    ACTIONS(18422), 1,
      anon_sym_AT,
    STATE(6931), 1,
      sym_scoped_identifier,
    STATE(6934), 1,
      sym_identifier,
    STATE(7529), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8447), 2,
      sym__import_list,
      sym_selected_import,
    STATE(6925), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17488), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17486), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [109478] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18424), 1,
      anon_sym_COMMA,
    ACTIONS(18426), 1,
      anon_sym_RPAREN,
    ACTIONS(18428), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14979), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15037), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    STATE(16267), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [109570] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18430), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109626] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12248), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12246), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [109666] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 1,
      anon_sym_LF,
    ACTIONS(18296), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12094), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [109710] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 1,
      anon_sym_LF,
    ACTIONS(12070), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [109752] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 1,
      anon_sym_LF,
    ACTIONS(12158), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [109794] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 1,
      anon_sym_LF,
    ACTIONS(12162), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [109836] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18432), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109892] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18434), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109948] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [109990] = 11,
    ACTIONS(12732), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [110046] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 1,
      anon_sym_LF,
    ACTIONS(12210), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [110088] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12158), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12156), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [110128] = 4,
    ACTIONS(18436), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [110170] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18438), 1,
      anon_sym_COMMA,
    ACTIONS(18440), 1,
      anon_sym_RPAREN,
    ACTIONS(18442), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14707), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14708), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15594), 1,
      sym__comprehension_clause,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [110262] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12162), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12160), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [110302] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [110348] = 11,
    ACTIONS(12724), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [110404] = 6,
    ACTIONS(18444), 1,
      anon_sym_COMMA,
    ACTIONS(18446), 1,
      anon_sym_as,
    STATE(11959), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12862), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12868), 20,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [110450] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12252), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12250), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [110490] = 7,
    ACTIONS(18444), 1,
      anon_sym_COMMA,
    ACTIONS(18446), 1,
      anon_sym_as,
    ACTIONS(18448), 1,
      anon_sym_COLON2,
    STATE(11959), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12862), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12868), 20,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [110538] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12620), 1,
      anon_sym_LF,
    ACTIONS(12618), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [110580] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18302), 1,
      sym__immediate_string_start,
    ACTIONS(18304), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [110626] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [110672] = 5,
    ACTIONS(18306), 1,
      sym__immediate_string_start,
    ACTIONS(18308), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [110716] = 11,
    ACTIONS(14543), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [110772] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(11892), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [110814] = 5,
    ACTIONS(18032), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18034), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [110858] = 5,
    ACTIONS(18112), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18114), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [110902] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12048), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12050), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [110942] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12390), 1,
      anon_sym_LF,
    ACTIONS(12388), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [110984] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18450), 1,
      anon_sym_COMMA,
    ACTIONS(18452), 1,
      anon_sym_RPAREN,
    ACTIONS(18454), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14727), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14732), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(16609), 1,
      sym__comprehension_clause,
    STATE(16612), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [111076] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12066), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12064), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [111116] = 4,
    ACTIONS(18456), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12882), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12884), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [111158] = 10,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18274), 1,
      anon_sym_DOT,
    ACTIONS(18276), 1,
      sym__assignment_operator,
    ACTIONS(18278), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [111212] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 1,
      anon_sym_LF,
    ACTIONS(12166), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [111254] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18458), 1,
      sym__immediate_string_start,
    ACTIONS(18460), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [111300] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12256), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12254), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [111340] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 1,
      anon_sym_LF,
    ACTIONS(2186), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [111382] = 11,
    ACTIONS(12714), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [111438] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2186), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(2188), 23,
      sym__immediate_paren,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [111478] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18298), 1,
      anon_sym_COMMA,
    ACTIONS(18300), 1,
      anon_sym_as,
    ACTIONS(18462), 1,
      anon_sym_COLON2,
    STATE(11992), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [111528] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 1,
      anon_sym_LF,
    ACTIONS(11866), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [111570] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12884), 1,
      anon_sym_LF,
    ACTIONS(18464), 1,
      anon_sym_DOT,
    ACTIONS(12882), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [111614] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12884), 1,
      anon_sym_LF,
    ACTIONS(18320), 1,
      anon_sym_DOT,
    ACTIONS(12882), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [111658] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12888), 1,
      anon_sym_LF,
    ACTIONS(18320), 1,
      anon_sym_DOT,
    ACTIONS(12886), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [111702] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18466), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [111758] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12888), 1,
      anon_sym_LF,
    ACTIONS(18464), 1,
      anon_sym_DOT,
    ACTIONS(12886), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [111802] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12260), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12258), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [111842] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18468), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [111898] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12300), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12298), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [111938] = 4,
    ACTIONS(18456), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12886), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12888), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [111980] = 4,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [112022] = 11,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [112078] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12678), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12676), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [112118] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 1,
      anon_sym_LF,
    ACTIONS(12280), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [112160] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 1,
      anon_sym_LF,
    ACTIONS(12292), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [112202] = 11,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [112258] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 1,
      anon_sym_LF,
    ACTIONS(12170), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [112300] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 1,
      anon_sym_LF,
    ACTIONS(12178), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [112342] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12166), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12164), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [112382] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12142), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12140), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [112422] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18470), 1,
      anon_sym_COMMA,
    ACTIONS(18472), 1,
      anon_sym_RPAREN,
    ACTIONS(18474), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14842), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14843), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    STATE(16207), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [112514] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12170), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12168), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [112554] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18476), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [112610] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11864), 1,
      anon_sym_LF,
    ACTIONS(11866), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [112652] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [112708] = 13,
    ACTIONS(18480), 1,
      sym__word_identifier,
    ACTIONS(18482), 1,
      aux_sym_import_path_token1,
    ACTIONS(18484), 1,
      anon_sym_LPAREN,
    ACTIONS(18486), 1,
      anon_sym_DOLLAR,
    ACTIONS(18488), 1,
      anon_sym_AT,
    STATE(11660), 1,
      sym_scoped_identifier,
    STATE(11661), 1,
      sym_identifier,
    STATE(12014), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12505), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11602), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16332), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16330), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [112768] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(11888), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [112810] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 1,
      anon_sym_LF,
    ACTIONS(12236), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [112852] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 1,
      anon_sym_LF,
    ACTIONS(12240), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [112894] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 1,
      anon_sym_LF,
    ACTIONS(12244), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [112936] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18458), 1,
      sym__immediate_string_start,
    ACTIONS(18460), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [112982] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 1,
      anon_sym_LF,
    ACTIONS(12300), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [113024] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18490), 1,
      anon_sym_COMMA,
    ACTIONS(18492), 1,
      anon_sym_RPAREN,
    ACTIONS(18494), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14563), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14564), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    STATE(16569), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [113116] = 4,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [113158] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18330), 1,
      anon_sym_RPAREN,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18336), 1,
      anon_sym_SEMI,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18496), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15083), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15085), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    STATE(16372), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [113250] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 1,
      anon_sym_LF,
    ACTIONS(12248), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113292] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 1,
      anon_sym_LF,
    ACTIONS(12252), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113334] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 1,
      anon_sym_LF,
    ACTIONS(12256), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113376] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 1,
      anon_sym_LF,
    ACTIONS(12260), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113418] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18498), 1,
      sym__immediate_string_start,
    ACTIONS(18500), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113464] = 11,
    ACTIONS(14868), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [113520] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 1,
      anon_sym_LF,
    ACTIONS(12058), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113562] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12178), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12176), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [113602] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 1,
      anon_sym_LF,
    ACTIONS(12066), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113644] = 13,
    ACTIONS(18502), 1,
      sym__word_identifier,
    ACTIONS(18504), 1,
      aux_sym_import_path_token1,
    ACTIONS(18506), 1,
      anon_sym_LPAREN,
    ACTIONS(18508), 1,
      anon_sym_DOLLAR,
    ACTIONS(18510), 1,
      anon_sym_AT,
    STATE(6947), 1,
      sym_scoped_identifier,
    STATE(6953), 1,
      sym_identifier,
    STATE(7317), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8304), 2,
      sym__import_list,
      sym_selected_import,
    STATE(6921), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16472), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16470), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [113704] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 1,
      anon_sym_LF,
    ACTIONS(12054), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113746] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 1,
      anon_sym_LF,
    ACTIONS(12264), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113788] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 1,
      anon_sym_LF,
    ACTIONS(12268), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113830] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18498), 1,
      sym__immediate_string_start,
    ACTIONS(18500), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113876] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 1,
      anon_sym_LF,
    ACTIONS(12272), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [113918] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [113958] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 1,
      anon_sym_LF,
    ACTIONS(12062), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114000] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 1,
      anon_sym_LF,
    ACTIONS(12046), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114042] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 1,
      anon_sym_LF,
    ACTIONS(12276), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114084] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12278), 1,
      anon_sym_LF,
    ACTIONS(12280), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114126] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18512), 1,
      sym__immediate_string_start,
    ACTIONS(18514), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114172] = 11,
    ACTIONS(12462), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [114228] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12324), 1,
      anon_sym_LF,
    ACTIONS(12322), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [114270] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12068), 1,
      anon_sym_LF,
    ACTIONS(12070), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114312] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 1,
      anon_sym_LF,
    ACTIONS(12284), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114354] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 1,
      anon_sym_LF,
    ACTIONS(12142), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114396] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 1,
      anon_sym_LF,
    ACTIONS(12146), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114438] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12148), 1,
      anon_sym_LF,
    ACTIONS(12150), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114480] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12146), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12144), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [114520] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(18516), 1,
      anon_sym_DOT,
    ACTIONS(12678), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [114564] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12160), 1,
      anon_sym_LF,
    ACTIONS(12162), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114606] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18512), 1,
      sym__immediate_string_start,
    ACTIONS(18514), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114652] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11526), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11992), 14,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11994), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [114696] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11505), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11958), 14,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11956), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [114740] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12208), 1,
      anon_sym_LF,
    ACTIONS(12210), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114782] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12164), 1,
      anon_sym_LF,
    ACTIONS(12166), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114824] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12168), 1,
      anon_sym_LF,
    ACTIONS(12170), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114866] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12176), 1,
      anon_sym_LF,
    ACTIONS(12178), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [114908] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12058), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12056), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [114948] = 11,
    ACTIONS(14872), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [115004] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12020), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12022), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [115044] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12290), 1,
      anon_sym_LF,
    ACTIONS(12292), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [115086] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11489), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12002), 14,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12004), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [115130] = 4,
    ACTIONS(18456), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12846), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12848), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [115172] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18518), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [115228] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12298), 1,
      anon_sym_LF,
    ACTIONS(12300), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [115270] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11507), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12006), 14,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12008), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [115314] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12336), 1,
      anon_sym_LF,
    ACTIONS(12334), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [115356] = 11,
    ACTIONS(14618), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [115412] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 1,
      anon_sym_LF,
    ACTIONS(12304), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [115454] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12302), 1,
      anon_sym_LF,
    ACTIONS(12304), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [115496] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18520), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [115552] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18394), 1,
      sym__immediate_string_start,
    ACTIONS(18396), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11892), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [115598] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12282), 1,
      anon_sym_LF,
    ACTIONS(12284), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [115640] = 11,
    ACTIONS(14979), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [115696] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12152), 1,
      anon_sym_LF,
    ACTIONS(12154), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [115738] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12054), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12052), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [115778] = 11,
    ACTIONS(12790), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [115834] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18388), 1,
      anon_sym_COMMA,
    ACTIONS(18390), 1,
      anon_sym_as,
    STATE(12056), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [115882] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12848), 1,
      anon_sym_LF,
    ACTIONS(18464), 1,
      anon_sym_DOT,
    ACTIONS(12846), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [115926] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11976), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11978), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [115966] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12264), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12262), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [116006] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [116052] = 11,
    ACTIONS(12610), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [116108] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12268), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12266), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [116148] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12272), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12270), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [116188] = 11,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [116244] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12304), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12302), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [116284] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [116330] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18522), 1,
      anon_sym_COMMA,
    ACTIONS(18524), 1,
      anon_sym_RPAREN,
    ACTIONS(18526), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14818), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15148), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    STATE(15828), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [116422] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18530), 1,
      aux_sym_import_path_token1,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18534), 1,
      anon_sym_DOLLAR,
    ACTIONS(18536), 1,
      anon_sym_AT,
    STATE(12289), 1,
      sym_scoped_identifier,
    STATE(12306), 1,
      sym_identifier,
    STATE(12939), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10546), 2,
      sym__import_list,
      sym_selected_import,
    STATE(12288), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [116482] = 11,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [116538] = 11,
    ACTIONS(14870), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [116594] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12056), 1,
      anon_sym_LF,
    ACTIONS(12058), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [116636] = 13,
    ACTIONS(18538), 1,
      sym__word_identifier,
    ACTIONS(18540), 1,
      aux_sym_import_path_token1,
    ACTIONS(18542), 1,
      anon_sym_LPAREN,
    ACTIONS(18544), 1,
      anon_sym_DOLLAR,
    ACTIONS(18546), 1,
      anon_sym_AT,
    STATE(6933), 1,
      sym_scoped_identifier,
    STATE(6946), 1,
      sym_identifier,
    STATE(7594), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8749), 2,
      sym__import_list,
      sym_selected_import,
    STATE(6928), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16544), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16542), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [116696] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18548), 1,
      aux_sym_import_path_token1,
    ACTIONS(18550), 1,
      anon_sym_DOLLAR,
    ACTIONS(18552), 1,
      anon_sym_AT,
    STATE(12883), 1,
      sym_scoped_identifier,
    STATE(12884), 1,
      sym_identifier,
    STATE(13135), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10546), 2,
      sym__import_list,
      sym_selected_import,
    STATE(12882), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [116756] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12024), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12026), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [116796] = 13,
    ACTIONS(18554), 1,
      sym__word_identifier,
    ACTIONS(18556), 1,
      aux_sym_import_path_token1,
    ACTIONS(18558), 1,
      anon_sym_LPAREN,
    ACTIONS(18560), 1,
      anon_sym_DOLLAR,
    ACTIONS(18562), 1,
      anon_sym_AT,
    STATE(7240), 1,
      sym_scoped_identifier,
    STATE(7241), 1,
      sym_identifier,
    STATE(7955), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8506), 2,
      sym__import_list,
      sym_selected_import,
    STATE(7238), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16790), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16788), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [116856] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11980), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11982), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [116896] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18564), 1,
      anon_sym_COMMA,
    ACTIONS(18566), 1,
      anon_sym_RPAREN,
    ACTIONS(18568), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14784), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14795), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    STATE(16464), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [116988] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18570), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [117044] = 5,
    ACTIONS(18086), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18088), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [117088] = 11,
    ACTIONS(12418), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [117144] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12276), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12274), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [117184] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12060), 1,
      anon_sym_LF,
    ACTIONS(12062), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [117226] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12044), 1,
      anon_sym_LF,
    ACTIONS(12046), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [117268] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12280), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12278), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [117308] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18572), 1,
      anon_sym_COMMA,
    ACTIONS(18574), 1,
      anon_sym_RPAREN,
    ACTIONS(18576), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14665), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15038), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    STATE(16136), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [117400] = 13,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18580), 1,
      aux_sym_import_path_token1,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(18584), 1,
      anon_sym_DOLLAR,
    ACTIONS(18586), 1,
      anon_sym_AT,
    STATE(11649), 1,
      sym_scoped_identifier,
    STATE(11667), 1,
      sym_identifier,
    STATE(11925), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12010), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11636), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16304), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [117460] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12028), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12030), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [117500] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [117556] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [117602] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [117648] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [117694] = 13,
    ACTIONS(18588), 1,
      sym__word_identifier,
    ACTIONS(18590), 1,
      aux_sym_import_path_token1,
    ACTIONS(18592), 1,
      anon_sym_LPAREN,
    ACTIONS(18594), 1,
      anon_sym_DOLLAR,
    ACTIONS(18596), 1,
      anon_sym_AT,
    STATE(6799), 1,
      sym_scoped_identifier,
    STATE(6806), 1,
      sym_identifier,
    STATE(7148), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7737), 2,
      sym__import_list,
      sym_selected_import,
    STATE(6783), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16688), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16686), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [117754] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18194), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [117810] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [117856] = 5,
    ACTIONS(18130), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18132), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(91), 11,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(171), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [117900] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [117946] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [117986] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11996), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11998), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [118026] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [118072] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 1,
      anon_sym_LF,
    ACTIONS(12094), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [118114] = 11,
    ACTIONS(12220), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [118170] = 13,
    ACTIONS(18598), 1,
      sym__word_identifier,
    ACTIONS(18600), 1,
      aux_sym_import_path_token1,
    ACTIONS(18602), 1,
      anon_sym_LPAREN,
    ACTIONS(18604), 1,
      anon_sym_DOLLAR,
    ACTIONS(18606), 1,
      anon_sym_AT,
    STATE(6769), 1,
      sym_scoped_identifier,
    STATE(6771), 1,
      sym_identifier,
    STATE(7194), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7392), 2,
      sym__import_list,
      sym_selected_import,
    STATE(6819), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17438), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17436), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [118230] = 11,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [118286] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12070), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12068), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [118326] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12032), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12034), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [118366] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12284), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12282), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [118406] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12234), 1,
      anon_sym_LF,
    ACTIONS(12236), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [118448] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12384), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12386), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [118488] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12238), 1,
      anon_sym_LF,
    ACTIONS(12240), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [118530] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18608), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [118586] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18610), 1,
      anon_sym_COMMA,
    ACTIONS(18612), 1,
      anon_sym_RPAREN,
    ACTIONS(18614), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14683), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14826), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    STATE(16358), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [118678] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12242), 1,
      anon_sym_LF,
    ACTIONS(12244), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [118720] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12246), 1,
      anon_sym_LF,
    ACTIONS(12248), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [118762] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12250), 1,
      anon_sym_LF,
    ACTIONS(12252), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [118804] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12254), 1,
      anon_sym_LF,
    ACTIONS(12256), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [118846] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12258), 1,
      anon_sym_LF,
    ACTIONS(12260), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [118888] = 13,
    ACTIONS(18616), 1,
      sym__word_identifier,
    ACTIONS(18618), 1,
      aux_sym_import_path_token1,
    ACTIONS(18620), 1,
      anon_sym_LPAREN,
    ACTIONS(18622), 1,
      anon_sym_DOLLAR,
    ACTIONS(18624), 1,
      anon_sym_AT,
    STATE(6752), 1,
      sym_scoped_identifier,
    STATE(6753), 1,
      sym_identifier,
    STATE(7070), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7331), 2,
      sym__import_list,
      sym_selected_import,
    STATE(6843), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17286), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17284), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [118948] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12004), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12002), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [118994] = 11,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [119050] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12140), 1,
      anon_sym_LF,
    ACTIONS(12142), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [119092] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12064), 1,
      anon_sym_LF,
    ACTIONS(12066), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [119134] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12052), 1,
      anon_sym_LF,
    ACTIONS(12054), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [119176] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12262), 1,
      anon_sym_LF,
    ACTIONS(12264), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [119218] = 13,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(18626), 1,
      aux_sym_import_path_token1,
    ACTIONS(18628), 1,
      anon_sym_DOLLAR,
    ACTIONS(18630), 1,
      anon_sym_AT,
    STATE(12887), 1,
      sym_scoped_identifier,
    STATE(12888), 1,
      sym_identifier,
    STATE(13141), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12010), 2,
      sym__import_list,
      sym_selected_import,
    STATE(12886), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16304), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [119278] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [119324] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12266), 1,
      anon_sym_LF,
    ACTIONS(12268), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [119366] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12270), 1,
      anon_sym_LF,
    ACTIONS(12272), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [119408] = 11,
    ACTIONS(12450), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [119464] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18632), 1,
      aux_sym_import_path_token1,
    ACTIONS(18634), 1,
      anon_sym_DOLLAR,
    ACTIONS(18636), 1,
      anon_sym_AT,
    STATE(12214), 1,
      sym_scoped_identifier,
    STATE(12215), 1,
      sym_identifier,
    STATE(12892), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10546), 2,
      sym__import_list,
      sym_selected_import,
    STATE(12213), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [119524] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [119570] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18208), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [119626] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12236), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12234), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [119666] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18638), 1,
      aux_sym_import_path_token1,
    ACTIONS(18640), 1,
      anon_sym_DOLLAR,
    ACTIONS(18642), 1,
      anon_sym_AT,
    STATE(11849), 1,
      sym_scoped_identifier,
    STATE(11850), 1,
      sym_identifier,
    STATE(12218), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10546), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11848), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [119726] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12240), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12238), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [119766] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12144), 1,
      anon_sym_LF,
    ACTIONS(12146), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [119808] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18644), 1,
      anon_sym_COMMA,
    ACTIONS(18646), 1,
      anon_sym_as,
    STATE(12175), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [119856] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12150), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12148), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [119896] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18648), 1,
      aux_sym_import_path_token1,
    ACTIONS(18650), 1,
      anon_sym_DOLLAR,
    ACTIONS(18652), 1,
      anon_sym_AT,
    STATE(12224), 1,
      sym_scoped_identifier,
    STATE(12225), 1,
      sym_identifier,
    STATE(12897), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10546), 2,
      sym__import_list,
      sym_selected_import,
    STATE(12223), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [119956] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12096), 1,
      anon_sym_LF,
    ACTIONS(18250), 1,
      aux_sym_float_literal_token2,
    ACTIONS(12094), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [120000] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12154), 12,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__assignment_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(12152), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [120040] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12008), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12006), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [120086] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18052), 1,
      sym__assignment_operator,
    ACTIONS(18054), 1,
      sym__tilde_operator,
    ACTIONS(18654), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [120142] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18656), 1,
      aux_sym_import_path_token1,
    ACTIONS(18658), 1,
      anon_sym_DOLLAR,
    ACTIONS(18660), 1,
      anon_sym_AT,
    STATE(12229), 1,
      sym_scoped_identifier,
    STATE(12230), 1,
      sym_identifier,
    STATE(12899), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10546), 2,
      sym__import_list,
      sym_selected_import,
    STATE(12228), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [120202] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18662), 1,
      anon_sym_COMMA,
    ACTIONS(18664), 1,
      anon_sym_RPAREN,
    ACTIONS(18666), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14957), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14958), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    STATE(16585), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [120294] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11984), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11986), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [120334] = 29,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18668), 1,
      anon_sym_COMMA,
    ACTIONS(18670), 1,
      anon_sym_RPAREN,
    ACTIONS(18672), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(14823), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14936), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15619), 1,
      sym__comprehension_clause,
    STATE(15648), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [120426] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18674), 1,
      aux_sym_import_path_token1,
    ACTIONS(18676), 1,
      anon_sym_DOLLAR,
    ACTIONS(18678), 1,
      anon_sym_AT,
    STATE(11853), 1,
      sym_scoped_identifier,
    STATE(11854), 1,
      sym_identifier,
    STATE(12234), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10546), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11852), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [120486] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12274), 1,
      anon_sym_LF,
    ACTIONS(12276), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [120528] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18680), 1,
      anon_sym_COMMA,
    ACTIONS(18682), 1,
      anon_sym_as,
    STATE(12203), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [120576] = 4,
    ACTIONS(18456), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12678), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12676), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [120618] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(18464), 1,
      anon_sym_DOT,
    ACTIONS(12678), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [120662] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(18320), 1,
      anon_sym_DOT,
    ACTIONS(12678), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [120706] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18644), 1,
      anon_sym_COMMA,
    ACTIONS(18646), 1,
      anon_sym_as,
    ACTIONS(18684), 1,
      anon_sym_COLON2,
    STATE(12175), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [120756] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12884), 1,
      anon_sym_LF,
    ACTIONS(18686), 1,
      anon_sym_DOT,
    ACTIONS(12882), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [120800] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12888), 1,
      anon_sym_LF,
    ACTIONS(18686), 1,
      anon_sym_DOT,
    ACTIONS(12886), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [120844] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12848), 1,
      anon_sym_LF,
    ACTIONS(18686), 1,
      anon_sym_DOT,
    ACTIONS(12846), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [120888] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18680), 1,
      anon_sym_COMMA,
    ACTIONS(18682), 1,
      anon_sym_as,
    ACTIONS(18688), 1,
      anon_sym_COLON2,
    STATE(12203), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [120938] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12884), 1,
      anon_sym_LF,
    ACTIONS(18516), 1,
      anon_sym_DOT,
    ACTIONS(12882), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [120982] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12888), 1,
      anon_sym_LF,
    ACTIONS(18516), 1,
      anon_sym_DOT,
    ACTIONS(12886), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [121026] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12848), 1,
      anon_sym_LF,
    ACTIONS(18516), 1,
      anon_sym_DOT,
    ACTIONS(12846), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [121070] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(18686), 1,
      anon_sym_DOT,
    ACTIONS(12678), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [121114] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12156), 1,
      anon_sym_LF,
    ACTIONS(12158), 30,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [121156] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18674), 1,
      aux_sym_import_path_token1,
    ACTIONS(18676), 1,
      anon_sym_DOLLAR,
    ACTIONS(18678), 1,
      anon_sym_AT,
    STATE(10791), 1,
      sym__import_list,
    STATE(11853), 1,
      sym_scoped_identifier,
    STATE(11854), 1,
      sym_identifier,
    STATE(12234), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11844), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [121215] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12170), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12168), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [121254] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12292), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12290), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [121293] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11932), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11934), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [121332] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18690), 1,
      anon_sym_COMMA,
    ACTIONS(18692), 1,
      anon_sym_RPAREN,
    ACTIONS(18694), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14877), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14878), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18124), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [121421] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18696), 1,
      anon_sym_COMMA,
    ACTIONS(18698), 1,
      anon_sym_RPAREN,
    ACTIONS(18700), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14780), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14781), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17716), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [121510] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13574), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13576), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [121549] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12054), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12052), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [121588] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13578), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13580), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [121627] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13499), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13501), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [121666] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12162), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12160), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [121705] = 28,
    ACTIONS(8016), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18702), 1,
      anon_sym_COMMA,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(16685), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [121794] = 13,
    ACTIONS(18554), 1,
      sym__word_identifier,
    ACTIONS(18556), 1,
      aux_sym_import_path_token1,
    ACTIONS(18558), 1,
      anon_sym_LPAREN,
    ACTIONS(18560), 1,
      anon_sym_DOLLAR,
    ACTIONS(18562), 1,
      anon_sym_AT,
    STATE(7240), 1,
      sym_scoped_identifier,
    STATE(7241), 1,
      sym_identifier,
    STATE(7955), 1,
      sym_import_alias,
    STATE(8721), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7024), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16790), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16788), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [121853] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13628), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13630), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [121892] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17766), 1,
      sym__immediate_paren,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [121935] = 28,
    ACTIONS(8284), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(18706), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(17119), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [122024] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [122069] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18708), 1,
      anon_sym_COMMA,
    ACTIONS(18710), 1,
      anon_sym_RPAREN,
    ACTIONS(18712), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15138), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15139), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18053), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [122158] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12150), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12148), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [122197] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12322), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12324), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [122236] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12326), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12328), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [122275] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12248), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12246), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [122314] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13582), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13584), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [122353] = 13,
    ACTIONS(18310), 1,
      sym__word_identifier,
    ACTIONS(18312), 1,
      aux_sym_import_path_token1,
    ACTIONS(18314), 1,
      anon_sym_LPAREN,
    ACTIONS(18316), 1,
      anon_sym_DOLLAR,
    ACTIONS(18318), 1,
      anon_sym_AT,
    STATE(7701), 1,
      sym_scoped_identifier,
    STATE(7702), 1,
      sym_identifier,
    STATE(8275), 1,
      sym_import_alias,
    STATE(8825), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7716), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16952), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16950), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [122412] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17754), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [122457] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [122496] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [122535] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11894), 1,
      anon_sym_LF,
    ACTIONS(18714), 1,
      sym__immediate_string_start,
    ACTIONS(18716), 1,
      sym__immediate_command_start,
    ACTIONS(11892), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [122580] = 13,
    ACTIONS(18414), 1,
      sym__word_identifier,
    ACTIONS(18416), 1,
      aux_sym_import_path_token1,
    ACTIONS(18418), 1,
      anon_sym_LPAREN,
    ACTIONS(18420), 1,
      anon_sym_DOLLAR,
    ACTIONS(18422), 1,
      anon_sym_AT,
    STATE(6931), 1,
      sym_scoped_identifier,
    STATE(6934), 1,
      sym_identifier,
    STATE(7529), 1,
      sym_import_alias,
    STATE(8530), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7117), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17488), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17486), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [122639] = 28,
    ACTIONS(8190), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(18718), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(16966), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [122728] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17792), 1,
      sym__immediate_paren,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [122773] = 8,
    ACTIONS(18720), 1,
      anon_sym_SQUOTE,
    ACTIONS(18722), 1,
      anon_sym_DOT,
    ACTIONS(18724), 1,
      sym__immediate_paren,
    ACTIONS(18726), 1,
      sym__immediate_bracket,
    ACTIONS(18728), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12194), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12196), 18,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [122822] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12240), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12238), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [122861] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 2,
      sym__immediate_paren,
      anon_sym_LF,
    ACTIONS(2186), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [122902] = 5,
    ACTIONS(18730), 1,
      sym__immediate_string_start,
    ACTIONS(18732), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [122945] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13378), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13380), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [122984] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18734), 1,
      anon_sym_COMMA,
    ACTIONS(18736), 1,
      anon_sym_RPAREN,
    ACTIONS(18738), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14834), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14835), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17889), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [123073] = 13,
    ACTIONS(18588), 1,
      sym__word_identifier,
    ACTIONS(18590), 1,
      aux_sym_import_path_token1,
    ACTIONS(18592), 1,
      anon_sym_LPAREN,
    ACTIONS(18594), 1,
      anon_sym_DOLLAR,
    ACTIONS(18596), 1,
      anon_sym_AT,
    STATE(6799), 1,
      sym_scoped_identifier,
    STATE(6806), 1,
      sym_identifier,
    STATE(7148), 1,
      sym_import_alias,
    STATE(7833), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6758), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16688), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16686), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [123132] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17534), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [123175] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [123220] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18740), 1,
      anon_sym_COMMA,
    ACTIONS(18742), 1,
      anon_sym_RPAREN,
    ACTIONS(18744), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14586), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14587), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17459), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [123309] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18746), 1,
      anon_sym_COMMA,
    ACTIONS(18748), 1,
      anon_sym_RPAREN,
    ACTIONS(18750), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14757), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14758), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17633), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [123398] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18530), 1,
      aux_sym_import_path_token1,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18534), 1,
      anon_sym_DOLLAR,
    ACTIONS(18536), 1,
      anon_sym_AT,
    STATE(10791), 1,
      sym__import_list,
    STATE(12289), 1,
      sym_scoped_identifier,
    STATE(12306), 1,
      sym_identifier,
    STATE(12939), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12448), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [123457] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(12678), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [123498] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13506), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13508), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [123537] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18752), 1,
      sym__immediate_string_start,
    ACTIONS(18754), 1,
      sym__immediate_command_start,
    ACTIONS(11894), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11892), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [123582] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18756), 1,
      anon_sym_COMMA,
    ACTIONS(18758), 1,
      anon_sym_RPAREN,
    ACTIONS(18760), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14823), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14936), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17845), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [123671] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18762), 1,
      anon_sym_COMMA,
    ACTIONS(18764), 1,
      anon_sym_RPAREN,
    ACTIONS(18766), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14946), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14947), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17455), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [123760] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18768), 1,
      anon_sym_COMMA,
    ACTIONS(18770), 1,
      anon_sym_RPAREN,
    ACTIONS(18772), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14583), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14584), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17450), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [123849] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11916), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11914), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [123888] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18774), 1,
      anon_sym_COMMA,
    ACTIONS(18776), 1,
      anon_sym_RPAREN,
    ACTIONS(18778), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14707), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14708), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17479), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [123977] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18780), 1,
      anon_sym_COMMA,
    ACTIONS(18782), 1,
      anon_sym_RPAREN,
    ACTIONS(18784), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15083), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15085), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17773), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [124066] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18786), 1,
      anon_sym_COMMA,
    ACTIONS(18788), 1,
      anon_sym_RPAREN,
    ACTIONS(18790), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15026), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15027), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17624), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [124155] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17530), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [124198] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18792), 1,
      anon_sym_COMMA,
    ACTIONS(18794), 1,
      anon_sym_RPAREN,
    ACTIONS(18796), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14848), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14851), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17973), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [124287] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17766), 1,
      sym__immediate_paren,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [124330] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13036), 1,
      anon_sym_LF,
    ACTIONS(13038), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [124371] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18798), 1,
      anon_sym_COMMA,
    ACTIONS(18800), 1,
      anon_sym_RPAREN,
    ACTIONS(18802), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14696), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14697), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17460), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [124460] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12252), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12250), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [124499] = 13,
    ACTIONS(18378), 1,
      sym__word_identifier,
    ACTIONS(18380), 1,
      aux_sym_import_path_token1,
    ACTIONS(18382), 1,
      anon_sym_LPAREN,
    ACTIONS(18384), 1,
      anon_sym_DOLLAR,
    ACTIONS(18386), 1,
      anon_sym_AT,
    STATE(11659), 1,
      sym_scoped_identifier,
    STATE(11663), 1,
      sym_identifier,
    STATE(12106), 1,
      sym_import_alias,
    STATE(12313), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11562), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16360), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16358), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [124558] = 28,
    ACTIONS(8208), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(18804), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(16768), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [124647] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12974), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12972), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [124686] = 10,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18806), 1,
      sym__assignment_operator,
    ACTIONS(18808), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 14,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [124739] = 28,
    ACTIONS(8202), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(18810), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(17182), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [124828] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18812), 1,
      anon_sym_COMMA,
    ACTIONS(18814), 1,
      anon_sym_RPAREN,
    ACTIONS(18816), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14570), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14685), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17917), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [124917] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12264), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12262), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [124956] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    STATE(11996), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [125001] = 5,
    ACTIONS(18444), 1,
      anon_sym_COMMA,
    STATE(11959), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12862), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12868), 20,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [125044] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18820), 1,
      anon_sym_COMMA,
    ACTIONS(18822), 1,
      anon_sym_RPAREN,
    ACTIONS(18824), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14979), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15037), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17637), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [125133] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18826), 1,
      anon_sym_COMMA,
    ACTIONS(18828), 1,
      anon_sym_RPAREN,
    ACTIONS(18830), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15001), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15003), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17978), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [125222] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13146), 1,
      anon_sym_LF,
    ACTIONS(18832), 1,
      anon_sym_COMMA,
    STATE(12130), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13144), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [125267] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18834), 1,
      anon_sym_COMMA,
    ACTIONS(18836), 1,
      anon_sym_RPAREN,
    ACTIONS(18838), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15057), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15102), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17701), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [125356] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18840), 1,
      anon_sym_COMMA,
    ACTIONS(18842), 1,
      anon_sym_RPAREN,
    ACTIONS(18844), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14784), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14795), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17764), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [125445] = 5,
    ACTIONS(18846), 1,
      anon_sym_COMMA,
    STATE(11931), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12974), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12972), 20,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [125488] = 26,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18857), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18865), 1,
      anon_sym_QMARK,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(18891), 1,
      aux_sym__terminator_token1,
    STATE(14432), 1,
      aux_sym_open_tuple_repeat1,
    STATE(15120), 1,
      aux_sym__block_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18851), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [125573] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18893), 1,
      anon_sym_COMMA,
    ACTIONS(18895), 1,
      anon_sym_RPAREN,
    ACTIONS(18897), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15113), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15114), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17940), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [125662] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18899), 1,
      anon_sym_COMMA,
    ACTIONS(18901), 1,
      anon_sym_RPAREN,
    ACTIONS(18903), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14727), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14732), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17529), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [125751] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18905), 1,
      anon_sym_COMMA,
    ACTIONS(18907), 1,
      anon_sym_RPAREN,
    ACTIONS(18909), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14632), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14633), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17846), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [125840] = 13,
    ACTIONS(18538), 1,
      sym__word_identifier,
    ACTIONS(18540), 1,
      aux_sym_import_path_token1,
    ACTIONS(18542), 1,
      anon_sym_LPAREN,
    ACTIONS(18544), 1,
      anon_sym_DOLLAR,
    ACTIONS(18546), 1,
      anon_sym_AT,
    STATE(6933), 1,
      sym_scoped_identifier,
    STATE(6946), 1,
      sym_identifier,
    STATE(7594), 1,
      sym_import_alias,
    STATE(8207), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7110), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16544), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16542), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125899] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18911), 1,
      anon_sym_COMMA,
    ACTIONS(18913), 1,
      anon_sym_RPAREN,
    ACTIONS(18915), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14885), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14886), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17349), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [125988] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12256), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12254), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126027] = 28,
    ACTIONS(8152), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(18917), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(16727), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [126116] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13586), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13588), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126155] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13648), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13650), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126194] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18919), 1,
      anon_sym_COMMA,
    ACTIONS(18921), 1,
      anon_sym_RPAREN,
    ACTIONS(18923), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14939), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14940), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17428), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [126283] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13632), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13634), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126322] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18925), 1,
      anon_sym_COMMA,
    ACTIONS(18927), 1,
      anon_sym_RPAREN,
    ACTIONS(18929), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14972), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14975), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18153), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [126411] = 5,
    ACTIONS(18931), 1,
      anon_sym_COMMA,
    STATE(11931), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13060), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13064), 20,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126454] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12981), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12979), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126493] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18933), 1,
      anon_sym_COMMA,
    ACTIONS(18935), 1,
      anon_sym_RPAREN,
    ACTIONS(18937), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14852), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14853), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18001), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [126582] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(151), 1,
      anon_sym_DASH_GT,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17850), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [126627] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12004), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12002), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [126672] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12276), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12274), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126711] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13566), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13568), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126750] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(12678), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [126791] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13346), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13348), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126830] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13370), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13372), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126869] = 4,
    ACTIONS(18446), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12981), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12979), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126910] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13255), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13253), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [126949] = 13,
    ACTIONS(18598), 1,
      sym__word_identifier,
    ACTIONS(18600), 1,
      aux_sym_import_path_token1,
    ACTIONS(18602), 1,
      anon_sym_LPAREN,
    ACTIONS(18604), 1,
      anon_sym_DOLLAR,
    ACTIONS(18606), 1,
      anon_sym_AT,
    STATE(6769), 1,
      sym_scoped_identifier,
    STATE(6771), 1,
      sym_identifier,
    STATE(7194), 1,
      sym_import_alias,
    STATE(7469), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6834), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17438), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17436), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [127008] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18939), 1,
      anon_sym_COMMA,
    ACTIONS(18941), 1,
      anon_sym_RPAREN,
    ACTIONS(18943), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14745), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14746), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17592), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [127097] = 5,
    ACTIONS(18444), 1,
      anon_sym_COMMA,
    STATE(11961), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13066), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13068), 20,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127140] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13358), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13360), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127179] = 5,
    ACTIONS(18945), 1,
      anon_sym_COMMA,
    STATE(11961), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12981), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12979), 20,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127222] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13542), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13544), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127261] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12280), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12278), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127300] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13489), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13491), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127339] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(18948), 1,
      anon_sym_COMMA,
    STATE(12006), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [127384] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17532), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [127427] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18950), 1,
      anon_sym_COMMA,
    ACTIONS(18952), 1,
      anon_sym_RPAREN,
    ACTIONS(18954), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15077), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15078), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17766), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [127516] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18956), 1,
      anon_sym_COMMA,
    ACTIONS(18958), 1,
      anon_sym_RPAREN,
    ACTIONS(18960), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14842), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14843), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17932), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [127605] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18962), 1,
      anon_sym_COMMA,
    ACTIONS(18964), 1,
      anon_sym_RPAREN,
    ACTIONS(18966), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14789), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14790), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17750), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [127694] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12260), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12258), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127733] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13538), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13540), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127772] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18968), 1,
      anon_sym_COMMA,
    ACTIONS(18970), 1,
      anon_sym_RPAREN,
    ACTIONS(18972), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14670), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(14793), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17743), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [127861] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13570), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13572), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127900] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17536), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [127943] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13546), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13548), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127982] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(151), 1,
      anon_sym_DASH_GT,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [128027] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18974), 1,
      anon_sym_COMMA,
    ACTIONS(18976), 1,
      anon_sym_RPAREN,
    ACTIONS(18978), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14616), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14617), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17744), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [128116] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12066), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12064), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [128155] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18980), 1,
      anon_sym_COMMA,
    ACTIONS(18982), 1,
      anon_sym_RPAREN,
    ACTIONS(18984), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14737), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14738), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17569), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [128244] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12008), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12006), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [128289] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12304), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12302), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [128328] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12972), 1,
      anon_sym_LF,
    ACTIONS(18986), 1,
      anon_sym_COMMA,
    STATE(11982), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(12974), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [128373] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12154), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12152), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [128412] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(18390), 1,
      anon_sym_as,
    ACTIONS(12981), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [128455] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(18989), 1,
      anon_sym_COMMA,
    STATE(11985), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12981), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [128500] = 13,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18580), 1,
      aux_sym_import_path_token1,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(18584), 1,
      anon_sym_DOLLAR,
    ACTIONS(18586), 1,
      anon_sym_AT,
    STATE(11649), 1,
      sym_scoped_identifier,
    STATE(11667), 1,
      sym_identifier,
    STATE(11925), 1,
      sym_import_alias,
    STATE(12002), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11634), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16304), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [128559] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13390), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13392), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [128598] = 28,
    ACTIONS(8230), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(18992), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(16687), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [128687] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13064), 1,
      anon_sym_LF,
    ACTIONS(18994), 1,
      anon_sym_COMMA,
    STATE(12076), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13060), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [128732] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13550), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13552), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [128771] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13590), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13592), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [128810] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13068), 1,
      anon_sym_LF,
    ACTIONS(18298), 1,
      anon_sym_COMMA,
    STATE(12123), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(13066), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [128855] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12142), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12140), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [128894] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10228), 1,
      sym_identifier,
    ACTIONS(12004), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12002), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [128939] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18996), 1,
      anon_sym_COMMA,
    ACTIONS(18998), 1,
      anon_sym_RPAREN,
    ACTIONS(19000), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14895), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14896), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17372), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [129028] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19002), 1,
      anon_sym_COMMA,
    STATE(11996), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [129073] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12062), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12060), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [129112] = 5,
    ACTIONS(18931), 1,
      anon_sym_COMMA,
    STATE(11945), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13144), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13146), 20,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [129155] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19005), 1,
      anon_sym_COMMA,
    ACTIONS(19007), 1,
      anon_sym_RPAREN,
    ACTIONS(19009), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15000), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15058), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17582), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [129244] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19011), 1,
      anon_sym_COMMA,
    ACTIONS(19013), 1,
      anon_sym_RPAREN,
    ACTIONS(19015), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14671), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14672), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17401), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [129333] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12058), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12056), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [129372] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13493), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13495), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [129411] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13594), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13596), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [129450] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2186), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(2188), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [129489] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12146), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12144), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [129528] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19017), 1,
      anon_sym_COMMA,
    STATE(12006), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [129573] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10229), 1,
      sym_identifier,
    ACTIONS(12008), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12006), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [129618] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11994), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11992), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [129663] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19020), 1,
      anon_sym_COMMA,
    ACTIONS(19022), 1,
      anon_sym_RPAREN,
    ACTIONS(19024), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14549), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14600), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17630), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [129752] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13330), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13332), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [129791] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19026), 1,
      anon_sym_COMMA,
    ACTIONS(19028), 1,
      anon_sym_RPAREN,
    ACTIONS(19030), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14641), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14642), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17920), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [129880] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13362), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13364), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [129919] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19032), 1,
      anon_sym_COMMA,
    ACTIONS(19034), 1,
      anon_sym_RPAREN,
    ACTIONS(19036), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14681), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14682), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17429), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [130008] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18388), 1,
      anon_sym_COMMA,
    STATE(12056), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [130053] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130092] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12214), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12212), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130131] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12360), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12362), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130170] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13366), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13368), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130209] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18752), 1,
      sym__immediate_string_start,
    ACTIONS(18754), 1,
      sym__immediate_command_start,
    ACTIONS(11890), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11888), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [130254] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13598), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13600), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130293] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19038), 1,
      anon_sym_COMMA,
    ACTIONS(19040), 1,
      anon_sym_RPAREN,
    ACTIONS(19042), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14647), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14648), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17990), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [130382] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19044), 1,
      anon_sym_COMMA,
    ACTIONS(19046), 1,
      anon_sym_RPAREN,
    ACTIONS(19048), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14728), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14729), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17539), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [130471] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19050), 1,
      anon_sym_COMMA,
    ACTIONS(19052), 1,
      anon_sym_RPAREN,
    ACTIONS(19054), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14824), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14825), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17851), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [130560] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11956), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11958), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [130605] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12364), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12366), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130644] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19056), 1,
      anon_sym_COMMA,
    ACTIONS(19058), 1,
      anon_sym_RPAREN,
    ACTIONS(19060), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14605), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14606), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17626), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [130733] = 5,
    ACTIONS(18730), 1,
      sym__immediate_string_start,
    ACTIONS(18732), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130776] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13429), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13431), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130815] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13602), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13604), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130854] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19062), 1,
      anon_sym_COMMA,
    ACTIONS(19064), 1,
      anon_sym_RPAREN,
    ACTIONS(19066), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15048), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15049), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17675), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [130943] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13606), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13608), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130982] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18548), 1,
      aux_sym_import_path_token1,
    ACTIONS(18550), 1,
      anon_sym_DOLLAR,
    ACTIONS(18552), 1,
      anon_sym_AT,
    STATE(10791), 1,
      sym__import_list,
    STATE(12883), 1,
      sym_scoped_identifier,
    STATE(12884), 1,
      sym_identifier,
    STATE(13135), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12808), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [131041] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13257), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13259), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131080] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13620), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13622), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131119] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19068), 1,
      anon_sym_COMMA,
    ACTIONS(19070), 1,
      anon_sym_RPAREN,
    ACTIONS(19072), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14563), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14564), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18008), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [131208] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19074), 1,
      anon_sym_COMMA,
    ACTIONS(19076), 1,
      anon_sym_RPAREN,
    ACTIONS(19078), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14718), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14719), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17497), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [131297] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13433), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13435), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131336] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19080), 1,
      anon_sym_COMMA,
    ACTIONS(19082), 1,
      anon_sym_RPAREN,
    ACTIONS(19084), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15118), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15119), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17688), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [131425] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131464] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13554), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13556), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131503] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19086), 1,
      anon_sym_COMMA,
    ACTIONS(19088), 1,
      anon_sym_RPAREN,
    ACTIONS(19090), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14860), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14861), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18038), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [131592] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19092), 1,
      anon_sym_COMMA,
    ACTIONS(19094), 1,
      anon_sym_RPAREN,
    ACTIONS(19096), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14558), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14559), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17897), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [131681] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19098), 1,
      anon_sym_COMMA,
    ACTIONS(19100), 1,
      anon_sym_RPAREN,
    ACTIONS(19102), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14906), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14907), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17390), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [131770] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12300), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12298), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131809] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17508), 1,
      anon_sym_DASH_GT,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [131854] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19104), 1,
      anon_sym_COMMA,
    ACTIONS(19106), 1,
      anon_sym_RPAREN,
    ACTIONS(19108), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14683), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14826), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17435), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [131943] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19110), 1,
      anon_sym_COMMA,
    ACTIONS(19112), 1,
      anon_sym_RPAREN,
    ACTIONS(19114), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15176), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15177), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18121), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [132032] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19116), 1,
      anon_sym_COMMA,
    STATE(12048), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [132077] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12174), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12172), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [132116] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19119), 1,
      anon_sym_COMMA,
    STATE(12050), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [132161] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13437), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13439), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [132200] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13558), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13560), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [132239] = 26,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19126), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19134), 1,
      anon_sym_QMARK,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19160), 1,
      aux_sym__terminator_token1,
    STATE(14423), 1,
      aux_sym_open_tuple_repeat1,
    STATE(14887), 1,
      aux_sym__block_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18851), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [132324] = 28,
    ACTIONS(8240), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19162), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(16899), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [132413] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12070), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12068), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [132452] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13068), 1,
      anon_sym_LF,
    ACTIONS(18388), 1,
      anon_sym_COMMA,
    STATE(11985), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(13066), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [132497] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19164), 1,
      anon_sym_COMMA,
    ACTIONS(19166), 1,
      anon_sym_RPAREN,
    ACTIONS(19168), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14933), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15002), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17423), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [132586] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12096), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [132625] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19170), 1,
      anon_sym_COMMA,
    ACTIONS(19172), 1,
      anon_sym_RPAREN,
    ACTIONS(19174), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14768), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14769), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17677), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [132714] = 28,
    ACTIONS(8332), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19176), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(16674), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [132803] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(2188), 2,
      sym__immediate_paren,
      anon_sym_LF,
    ACTIONS(2186), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [132844] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13624), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13626), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [132883] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17530), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [132926] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12284), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12282), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [132965] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13652), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13654), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133004] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13656), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13658), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133043] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13382), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13384), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133082] = 13,
    ACTIONS(18480), 1,
      sym__word_identifier,
    ACTIONS(18482), 1,
      aux_sym_import_path_token1,
    ACTIONS(18484), 1,
      anon_sym_LPAREN,
    ACTIONS(18486), 1,
      anon_sym_DOLLAR,
    ACTIONS(18488), 1,
      anon_sym_AT,
    STATE(11660), 1,
      sym_scoped_identifier,
    STATE(11661), 1,
      sym_identifier,
    STATE(12014), 1,
      sym_import_alias,
    STATE(12653), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11751), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16332), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16330), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [133141] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(19178), 1,
      anon_sym_COMMA,
    STATE(12048), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [133186] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13036), 1,
      anon_sym_LF,
    ACTIONS(13038), 29,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [133227] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13522), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13524), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133266] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11526), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11992), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11994), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133309] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13413), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13415), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133348] = 13,
    ACTIONS(18616), 1,
      sym__word_identifier,
    ACTIONS(18618), 1,
      aux_sym_import_path_token1,
    ACTIONS(18620), 1,
      anon_sym_LPAREN,
    ACTIONS(18622), 1,
      anon_sym_DOLLAR,
    ACTIONS(18624), 1,
      anon_sym_AT,
    STATE(6752), 1,
      sym_scoped_identifier,
    STATE(6753), 1,
      sym_identifier,
    STATE(7070), 1,
      sym_import_alias,
    STATE(7492), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6721), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17286), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17284), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [133407] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12384), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12386), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133446] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12972), 1,
      anon_sym_LF,
    ACTIONS(19180), 1,
      anon_sym_COMMA,
    STATE(12076), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(12974), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [133491] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(19183), 1,
      anon_sym_DOT,
    ACTIONS(12678), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [133534] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13526), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13528), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133573] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12334), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12336), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133612] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19185), 1,
      anon_sym_COMMA,
    ACTIONS(19187), 1,
      anon_sym_RPAREN,
    ACTIONS(19189), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15100), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15149), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17852), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [133701] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13441), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13443), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133740] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11505), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11958), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11956), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133783] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11888), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11890), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133822] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13562), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13564), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133861] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19191), 1,
      anon_sym_COMMA,
    ACTIONS(19193), 1,
      anon_sym_RPAREN,
    ACTIONS(19195), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14916), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14917), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17404), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [133950] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13417), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13419), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [133989] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13510), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13512), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [134028] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13514), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13516), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [134067] = 13,
    ACTIONS(18398), 1,
      sym__word_identifier,
    ACTIONS(18400), 1,
      aux_sym_import_path_token1,
    ACTIONS(18402), 1,
      anon_sym_LPAREN,
    ACTIONS(18404), 1,
      anon_sym_DOLLAR,
    ACTIONS(18406), 1,
      anon_sym_AT,
    STATE(7599), 1,
      sym_scoped_identifier,
    STATE(7600), 1,
      sym_identifier,
    STATE(8181), 1,
      sym_import_alias,
    STATE(8988), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7666), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17410), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17408), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [134126] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13421), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13423), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [134165] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13518), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13520), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [134204] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19197), 1,
      anon_sym_COMMA,
    ACTIONS(19199), 1,
      anon_sym_RPAREN,
    ACTIONS(19201), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14984), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14985), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17551), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [134293] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19203), 1,
      anon_sym_COMMA,
    ACTIONS(19205), 1,
      anon_sym_RPAREN,
    ACTIONS(19207), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14665), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15038), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17356), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [134382] = 28,
    ACTIONS(8334), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19209), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(16718), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [134471] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17792), 1,
      sym__immediate_paren,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [134514] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11890), 1,
      anon_sym_LF,
    ACTIONS(18714), 1,
      sym__immediate_string_start,
    ACTIONS(18716), 1,
      sym__immediate_command_start,
    ACTIONS(11888), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [134559] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13530), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13532), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [134598] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13146), 1,
      anon_sym_LF,
    ACTIONS(18994), 1,
      anon_sym_COMMA,
    STATE(11989), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13144), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [134643] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13407), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13409), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [134682] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19211), 1,
      anon_sym_COMMA,
    ACTIONS(19213), 1,
      anon_sym_RPAREN,
    ACTIONS(19215), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14804), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14805), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17783), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [134771] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18948), 1,
      anon_sym_COMMA,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19227), 1,
      anon_sym_QMARK,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    STATE(11965), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13239), 5,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [134852] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18948), 1,
      anon_sym_COMMA,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19227), 1,
      anon_sym_QMARK,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    STATE(11965), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13243), 5,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [134933] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18948), 1,
      anon_sym_COMMA,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19227), 1,
      anon_sym_QMARK,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    STATE(11965), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(12926), 5,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [135014] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(18300), 1,
      anon_sym_as,
    ACTIONS(12981), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [135057] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19253), 1,
      anon_sym_COMMA,
    ACTIONS(19255), 1,
      anon_sym_RPAREN,
    ACTIONS(19257), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14957), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14958), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17496), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [135146] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18298), 1,
      anon_sym_COMMA,
    STATE(11992), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [135191] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12308), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12306), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [135230] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13445), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13447), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [135269] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17534), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [135312] = 28,
    ACTIONS(8196), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19259), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15608), 1,
      sym__comprehension_clause,
    STATE(15617), 1,
      aux_sym_argument_list_repeat1,
    STATE(16938), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [135401] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11994), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10217), 1,
      sym_identifier,
    ACTIONS(11992), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [135446] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19261), 1,
      anon_sym_QMARK,
    STATE(11924), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13239), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [135527] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19261), 1,
      anon_sym_QMARK,
    STATE(11924), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13243), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [135608] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19261), 1,
      anon_sym_QMARK,
    STATE(11924), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(12926), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [135689] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(19263), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13255), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [135768] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(19263), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [135845] = 11,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18050), 1,
      anon_sym_DOT,
    ACTIONS(18188), 1,
      anon_sym_EQ,
    ACTIONS(18806), 1,
      sym__assignment_operator,
    ACTIONS(18808), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 9,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 13,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [135900] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11956), 1,
      anon_sym_LF,
    ACTIONS(18154), 1,
      sym__word_identifier,
    STATE(10218), 1,
      sym_identifier,
    ACTIONS(11958), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [135945] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19261), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13255), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [136024] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19261), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [136101] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13449), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13451), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136140] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12178), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12176), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136179] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(19265), 1,
      anon_sym_COMMA,
    STATE(12123), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12981), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [136224] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12388), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12390), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136263] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13660), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13662), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136302] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19268), 1,
      anon_sym_COMMA,
    ACTIONS(19270), 1,
      anon_sym_RPAREN,
    ACTIONS(19272), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14929), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14930), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17417), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [136391] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17792), 1,
      sym__immediate_paren,
    ACTIONS(17850), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [136436] = 28,
    ACTIONS(8440), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19274), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(16703), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [136525] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19276), 1,
      anon_sym_COMMA,
    ACTIONS(19278), 1,
      anon_sym_RPAREN,
    ACTIONS(19280), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15066), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15067), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17464), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [136614] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13064), 1,
      anon_sym_LF,
    ACTIONS(18832), 1,
      anon_sym_COMMA,
    STATE(11982), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13060), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [136659] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12244), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12242), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136698] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11489), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12002), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12004), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136741] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13636), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13638), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136780] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18948), 1,
      anon_sym_COMMA,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19227), 1,
      anon_sym_QMARK,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    STATE(11965), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13249), 5,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [136861] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13453), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13455), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136900] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19178), 1,
      anon_sym_COMMA,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19290), 1,
      anon_sym_QMARK,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    STATE(12069), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13249), 5,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [136981] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13316), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13318), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137020] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12046), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12044), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137059] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19227), 1,
      anon_sym_QMARK,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13255), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [137138] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19227), 1,
      anon_sym_QMARK,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [137215] = 5,
    ACTIONS(18140), 1,
      sym__word_identifier,
    STATE(11507), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12006), 13,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12008), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137258] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13457), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13459), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137297] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19290), 1,
      anon_sym_QMARK,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13255), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [137376] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19290), 1,
      anon_sym_QMARK,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      sym__pair_operator,
  [137453] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12210), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12208), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137492] = 13,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(18626), 1,
      aux_sym_import_path_token1,
    ACTIONS(18628), 1,
      anon_sym_DOLLAR,
    ACTIONS(18630), 1,
      anon_sym_AT,
    STATE(12002), 1,
      sym__import_list,
    STATE(12887), 1,
      sym_scoped_identifier,
    STATE(12888), 1,
      sym_identifier,
    STATE(13141), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12890), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16304), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [137551] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19316), 1,
      anon_sym_COMMA,
    ACTIONS(19318), 1,
      anon_sym_RPAREN,
    ACTIONS(19320), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14813), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14814), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17819), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [137640] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19322), 1,
      anon_sym_COMMA,
    ACTIONS(19324), 1,
      anon_sym_RPAREN,
    ACTIONS(19326), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14869), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14870), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18081), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [137729] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13320), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13322), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137768] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19328), 1,
      anon_sym_COMMA,
    ACTIONS(19330), 1,
      anon_sym_RPAREN,
    ACTIONS(19332), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14659), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14660), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18132), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [137857] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17532), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [137900] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(19263), 1,
      anon_sym_QMARK,
    STATE(12164), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13249), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [137981] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19261), 1,
      anon_sym_QMARK,
    STATE(11924), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13249), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [138062] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(19263), 1,
      anon_sym_QMARK,
    STATE(12164), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13239), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [138143] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(19263), 1,
      anon_sym_QMARK,
    STATE(12164), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13243), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [138224] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(19263), 1,
      anon_sym_QMARK,
    STATE(12164), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(12926), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [138305] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19178), 1,
      anon_sym_COMMA,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19290), 1,
      anon_sym_QMARK,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    STATE(12069), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13239), 5,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [138386] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19178), 1,
      anon_sym_COMMA,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19290), 1,
      anon_sym_QMARK,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    STATE(12069), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13243), 5,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [138467] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19178), 1,
      anon_sym_COMMA,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19290), 1,
      anon_sym_QMARK,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    STATE(12069), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(12926), 5,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [138548] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13534), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13536), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [138587] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(17766), 1,
      sym__immediate_paren,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [138632] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12166), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12164), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [138671] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13664), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13666), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [138710] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    STATE(12050), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [138755] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18632), 1,
      aux_sym_import_path_token1,
    ACTIONS(18634), 1,
      anon_sym_DOLLAR,
    ACTIONS(18636), 1,
      anon_sym_AT,
    STATE(10791), 1,
      sym__import_list,
    STATE(12214), 1,
      sym_scoped_identifier,
    STATE(12215), 1,
      sym_identifier,
    STATE(12892), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12167), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [138814] = 10,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18026), 1,
      sym__immediate_bracket,
    ACTIONS(18028), 1,
      sym__immediate_brace,
    ACTIONS(18048), 1,
      anon_sym_SQUOTE,
    ACTIONS(18100), 1,
      anon_sym_DOT,
    ACTIONS(19334), 1,
      sym__assignment_operator,
    ACTIONS(19336), 1,
      sym__tilde_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 10,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 13,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [138867] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(19338), 1,
      anon_sym_COMMA,
    ACTIONS(19340), 1,
      anon_sym_as,
    STATE(12845), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [138914] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13461), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13463), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [138953] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13386), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13388), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [138992] = 28,
    ACTIONS(8312), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19342), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(17134), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [139081] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [139120] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19344), 1,
      anon_sym_COMMA,
    ACTIONS(19346), 1,
      anon_sym_RPAREN,
    ACTIONS(19348), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15091), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15092), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17994), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [139209] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12236), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12234), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [139248] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13064), 1,
      anon_sym_LF,
    ACTIONS(19350), 1,
      anon_sym_COMMA,
    STATE(12178), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13060), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [139293] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13068), 1,
      anon_sym_LF,
    ACTIONS(18644), 1,
      anon_sym_COMMA,
    STATE(12180), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(13066), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [139338] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18638), 1,
      aux_sym_import_path_token1,
    ACTIONS(18640), 1,
      anon_sym_DOLLAR,
    ACTIONS(18642), 1,
      anon_sym_AT,
    STATE(10791), 1,
      sym__import_list,
    STATE(11849), 1,
      sym_scoped_identifier,
    STATE(11850), 1,
      sym_identifier,
    STATE(12218), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11831), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [139397] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17508), 1,
      anon_sym_DASH_GT,
    ACTIONS(17754), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [139442] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12972), 1,
      anon_sym_LF,
    ACTIONS(19352), 1,
      anon_sym_COMMA,
    STATE(12178), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(12974), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [139487] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(18646), 1,
      anon_sym_as,
    ACTIONS(12981), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [139530] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(19355), 1,
      anon_sym_COMMA,
    STATE(12180), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12981), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [139575] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13481), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13483), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [139614] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13640), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13642), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [139653] = 4,
    ACTIONS(19358), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12678), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12676), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [139694] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12268), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12266), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [139733] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12272), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12270), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [139772] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12338), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12340), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [139811] = 13,
    ACTIONS(18502), 1,
      sym__word_identifier,
    ACTIONS(18504), 1,
      aux_sym_import_path_token1,
    ACTIONS(18506), 1,
      anon_sym_LPAREN,
    ACTIONS(18508), 1,
      anon_sym_DOLLAR,
    ACTIONS(18510), 1,
      anon_sym_AT,
    STATE(6947), 1,
      sym_scoped_identifier,
    STATE(6953), 1,
      sym_identifier,
    STATE(7317), 1,
      sym_import_alias,
    STATE(8444), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7196), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16472), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16470), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [139870] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18648), 1,
      aux_sym_import_path_token1,
    ACTIONS(18650), 1,
      anon_sym_DOLLAR,
    ACTIONS(18652), 1,
      anon_sym_AT,
    STATE(10791), 1,
      sym__import_list,
    STATE(12224), 1,
      sym_scoped_identifier,
    STATE(12225), 1,
      sym_identifier,
    STATE(12897), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12190), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [139929] = 28,
    ACTIONS(8352), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19360), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(17180), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [140018] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(19362), 1,
      anon_sym_COMMA,
    ACTIONS(19364), 1,
      anon_sym_as,
    STATE(12859), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [140065] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12342), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12344), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [140104] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13396), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13398), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [140143] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(19366), 1,
      anon_sym_DOT,
    ACTIONS(12678), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [140186] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11928), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11930), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [140225] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12218), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12216), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [140264] = 13,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18656), 1,
      aux_sym_import_path_token1,
    ACTIONS(18658), 1,
      anon_sym_DOLLAR,
    ACTIONS(18660), 1,
      anon_sym_AT,
    STATE(10791), 1,
      sym__import_list,
    STATE(12229), 1,
      sym_scoped_identifier,
    STATE(12230), 1,
      sym_identifier,
    STATE(12899), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12198), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [140323] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13425), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13427), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [140362] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(19368), 1,
      anon_sym_COMMA,
    ACTIONS(19370), 1,
      anon_sym_as,
    STATE(12867), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [140409] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13400), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13402), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [140448] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12136), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12138), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [140487] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17518), 1,
      anon_sym_DASH_GT,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [140532] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13064), 1,
      anon_sym_LF,
    ACTIONS(19372), 1,
      anon_sym_COMMA,
    STATE(12206), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13060), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [140577] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13068), 1,
      anon_sym_LF,
    ACTIONS(18680), 1,
      anon_sym_COMMA,
    STATE(12208), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(13066), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [140622] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19374), 1,
      anon_sym_COMMA,
    ACTIONS(19376), 1,
      anon_sym_RPAREN,
    ACTIONS(19378), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14818), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15148), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18068), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [140711] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19380), 1,
      anon_sym_COMMA,
    ACTIONS(19382), 1,
      anon_sym_RPAREN,
    ACTIONS(19384), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14747), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14748), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17597), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [140800] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12972), 1,
      anon_sym_LF,
    ACTIONS(19386), 1,
      anon_sym_COMMA,
    STATE(12206), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(12974), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [140845] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(18682), 1,
      anon_sym_as,
    ACTIONS(12981), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [140888] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(19389), 1,
      anon_sym_COMMA,
    STATE(12208), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12981), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [140933] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12158), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12156), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [140972] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17524), 1,
      anon_sym_DASH_GT,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [141017] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13094), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13100), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [141056] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13644), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13646), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [141095] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(19338), 1,
      anon_sym_COMMA,
    ACTIONS(19340), 1,
      anon_sym_as,
    ACTIONS(19392), 1,
      anon_sym_COLON2,
    STATE(12845), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 25,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141144] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12884), 1,
      anon_sym_LF,
    ACTIONS(19394), 1,
      anon_sym_DOT,
    ACTIONS(12882), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141187] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12888), 1,
      anon_sym_LF,
    ACTIONS(19394), 1,
      anon_sym_DOT,
    ACTIONS(12886), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141230] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12848), 1,
      anon_sym_LF,
    ACTIONS(19394), 1,
      anon_sym_DOT,
    ACTIONS(12846), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141273] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13146), 1,
      anon_sym_LF,
    ACTIONS(19350), 1,
      anon_sym_COMMA,
    STATE(12174), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13144), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141318] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18644), 1,
      anon_sym_COMMA,
    STATE(12175), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141363] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13485), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13487), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [141402] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19396), 1,
      anon_sym_COMMA,
    ACTIONS(19398), 1,
      anon_sym_RPAREN,
    ACTIONS(19400), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14595), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14596), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17527), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [141491] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11866), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11864), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [141530] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13374), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13376), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [141569] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(19362), 1,
      anon_sym_COMMA,
    ACTIONS(19364), 1,
      anon_sym_as,
    ACTIONS(19402), 1,
      anon_sym_COLON2,
    STATE(12859), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141618] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12884), 1,
      anon_sym_LF,
    ACTIONS(19404), 1,
      anon_sym_DOT,
    ACTIONS(12882), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141661] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12888), 1,
      anon_sym_LF,
    ACTIONS(19404), 1,
      anon_sym_DOT,
    ACTIONS(12886), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141704] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12848), 1,
      anon_sym_LF,
    ACTIONS(19404), 1,
      anon_sym_DOT,
    ACTIONS(12846), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141747] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(19394), 1,
      anon_sym_DOT,
    ACTIONS(12678), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141790] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(19368), 1,
      anon_sym_COMMA,
    ACTIONS(19370), 1,
      anon_sym_as,
    ACTIONS(19406), 1,
      anon_sym_COLON2,
    STATE(12867), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141839] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12884), 1,
      anon_sym_LF,
    ACTIONS(19408), 1,
      anon_sym_DOT,
    ACTIONS(12882), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141882] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12888), 1,
      anon_sym_LF,
    ACTIONS(19408), 1,
      anon_sym_DOT,
    ACTIONS(12886), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141925] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12848), 1,
      anon_sym_LF,
    ACTIONS(19408), 1,
      anon_sym_DOT,
    ACTIONS(12846), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [141968] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(19410), 1,
      anon_sym_DOT,
    ACTIONS(12678), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [142011] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13146), 1,
      anon_sym_LF,
    ACTIONS(19372), 1,
      anon_sym_COMMA,
    STATE(12202), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13144), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [142056] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(18680), 1,
      anon_sym_COMMA,
    STATE(12203), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 27,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [142101] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11892), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11894), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_where,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [142140] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13326), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13328), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [142179] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17536), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [142222] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [142261] = 28,
    ACTIONS(8394), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19412), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16053), 1,
      sym__comprehension_clause,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    STATE(16911), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [142350] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(19404), 1,
      anon_sym_DOT,
    ACTIONS(12678), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [142393] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(19408), 1,
      anon_sym_DOT,
    ACTIONS(12678), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [142436] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(19414), 1,
      anon_sym_DOT,
    ACTIONS(12678), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [142479] = 28,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(19416), 1,
      anon_sym_COMMA,
    ACTIONS(19418), 1,
      anon_sym_RPAREN,
    ACTIONS(19420), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14571), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14572), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17353), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [142568] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17792), 1,
      sym__immediate_paren,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [142611] = 14,
    ACTIONS(15826), 1,
      anon_sym_LPAREN,
    ACTIONS(15828), 1,
      anon_sym_LBRACK,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    ACTIONS(15838), 1,
      sym__string_start,
    ACTIONS(15840), 1,
      sym__command_start,
    ACTIONS(17376), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17378), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19422), 1,
      sym__word_identifier,
    ACTIONS(19424), 1,
      sym_character_literal,
    STATE(4843), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17374), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17380), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6015), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [142671] = 14,
    ACTIONS(19426), 1,
      sym__word_identifier,
    ACTIONS(19428), 1,
      anon_sym_LPAREN,
    ACTIONS(19430), 1,
      anon_sym_LBRACK,
    ACTIONS(19432), 1,
      anon_sym_LBRACE,
    ACTIONS(19436), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(19438), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19442), 1,
      sym_character_literal,
    ACTIONS(19444), 1,
      sym__string_start,
    ACTIONS(19446), 1,
      sym__command_start,
    STATE(15332), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19434), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(19440), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(14523), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [142731] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [142773] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13364), 1,
      anon_sym_LF,
    ACTIONS(13362), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [142813] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18430), 1,
      anon_sym_EQ,
    ACTIONS(13239), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [142855] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18430), 1,
      anon_sym_EQ,
    ACTIONS(13243), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [142897] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18430), 1,
      anon_sym_EQ,
    ACTIONS(12926), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [142939] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13368), 1,
      anon_sym_LF,
    ACTIONS(13366), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [142979] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13372), 1,
      anon_sym_LF,
    ACTIONS(13370), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [143019] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13376), 1,
      anon_sym_LF,
    ACTIONS(13374), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [143059] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(13308), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [143103] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13380), 1,
      anon_sym_LF,
    ACTIONS(13378), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [143143] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13384), 1,
      anon_sym_LF,
    ACTIONS(13382), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [143183] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13388), 1,
      anon_sym_LF,
    ACTIONS(13386), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [143223] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17850), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [143265] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17576), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [143307] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18948), 1,
      anon_sym_COMMA,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    STATE(11965), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [143387] = 12,
    ACTIONS(18378), 1,
      sym__word_identifier,
    ACTIONS(18380), 1,
      aux_sym_import_path_token1,
    ACTIONS(18382), 1,
      anon_sym_LPAREN,
    ACTIONS(18384), 1,
      anon_sym_DOLLAR,
    ACTIONS(18386), 1,
      anon_sym_AT,
    STATE(11659), 1,
      sym_scoped_identifier,
    STATE(11663), 1,
      sym_identifier,
    STATE(12310), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12104), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16360), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16358), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [143443] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13392), 1,
      anon_sym_LF,
    ACTIONS(13390), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [143483] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13398), 1,
      anon_sym_LF,
    ACTIONS(13396), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [143523] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13402), 1,
      anon_sym_LF,
    ACTIONS(13400), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [143563] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13409), 1,
      anon_sym_LF,
    ACTIONS(13407), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [143603] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19134), 1,
      anon_sym_QMARK,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 6,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [143679] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(13249), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [143721] = 27,
    ACTIONS(8244), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19450), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15576), 1,
      sym__comprehension_clause,
    STATE(16213), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [143807] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 12,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [143871] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 21,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [143923] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [143985] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19261), 1,
      anon_sym_QMARK,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [144061] = 27,
    ACTIONS(9216), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19452), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16335), 1,
      sym__comprehension_clause,
    STATE(16346), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [144147] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [144219] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [144287] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 11,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [144353] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 18,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [144411] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [144473] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 21,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [144525] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [144575] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [144623] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(13306), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [144669] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(13306), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [144713] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13306), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [144755] = 14,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    ACTIONS(19454), 1,
      sym__word_identifier,
    ACTIONS(19456), 1,
      anon_sym_LPAREN,
    ACTIONS(19458), 1,
      anon_sym_LBRACK,
    ACTIONS(19460), 1,
      anon_sym_LBRACE,
    ACTIONS(19462), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19464), 1,
      sym_character_literal,
    STATE(11444), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11546), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [144815] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(13255), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [144855] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19466), 1,
      anon_sym_COMMA,
    ACTIONS(19468), 1,
      anon_sym_as,
    ACTIONS(19470), 1,
      anon_sym_COLON2,
    STATE(13075), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12868), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12862), 23,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [144903] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19472), 1,
      anon_sym_DOT,
    ACTIONS(12884), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12882), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [144945] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13415), 1,
      anon_sym_LF,
    ACTIONS(13413), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [144985] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13419), 1,
      anon_sym_LF,
    ACTIONS(13417), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145025] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13423), 1,
      anon_sym_LF,
    ACTIONS(13421), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145065] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13427), 1,
      anon_sym_LF,
    ACTIONS(13425), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145105] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13431), 1,
      anon_sym_LF,
    ACTIONS(13429), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145145] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13360), 1,
      anon_sym_LF,
    ACTIONS(13358), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145185] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13439), 1,
      anon_sym_LF,
    ACTIONS(13437), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145225] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13443), 1,
      anon_sym_LF,
    ACTIONS(13441), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145265] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13447), 1,
      anon_sym_LF,
    ACTIONS(13445), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145305] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13451), 1,
      anon_sym_LF,
    ACTIONS(13449), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145345] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13455), 1,
      anon_sym_LF,
    ACTIONS(13453), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145385] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13459), 1,
      anon_sym_LF,
    ACTIONS(13457), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145425] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13463), 1,
      anon_sym_LF,
    ACTIONS(13461), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145465] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13483), 1,
      anon_sym_LF,
    ACTIONS(13481), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145505] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [145545] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13487), 1,
      anon_sym_LF,
    ACTIONS(13485), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145585] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19472), 1,
      anon_sym_DOT,
    ACTIONS(12888), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12886), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [145627] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    STATE(12317), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [145671] = 12,
    ACTIONS(18310), 1,
      sym__word_identifier,
    ACTIONS(18312), 1,
      aux_sym_import_path_token1,
    ACTIONS(18314), 1,
      anon_sym_LPAREN,
    ACTIONS(18316), 1,
      anon_sym_DOLLAR,
    ACTIONS(18318), 1,
      anon_sym_AT,
    STATE(7701), 1,
      sym_scoped_identifier,
    STATE(7702), 1,
      sym_identifier,
    STATE(8820), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8293), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16952), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16950), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [145727] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12972), 1,
      anon_sym_LF,
    ACTIONS(12974), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145767] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(12981), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145807] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(19478), 1,
      anon_sym_LPAREN,
    ACTIONS(19480), 1,
      sym_character_literal,
    STATE(10635), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9939), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [145867] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13491), 1,
      anon_sym_LF,
    ACTIONS(13489), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145907] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13495), 1,
      anon_sym_LF,
    ACTIONS(13493), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145947] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13501), 1,
      anon_sym_LF,
    ACTIONS(13499), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [145987] = 27,
    ACTIONS(8024), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19482), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15744), 1,
      aux_sym_argument_list_repeat1,
    STATE(15950), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [146073] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    STATE(12328), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [146117] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19486), 1,
      anon_sym_COMMA,
    STATE(12317), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [146161] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13508), 1,
      anon_sym_LF,
    ACTIONS(13506), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146201] = 27,
    ACTIONS(9254), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19489), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15493), 1,
      sym__comprehension_clause,
    STATE(15497), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [146287] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13512), 1,
      anon_sym_LF,
    ACTIONS(13510), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146327] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13516), 1,
      anon_sym_LF,
    ACTIONS(13514), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146367] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13520), 1,
      anon_sym_LF,
    ACTIONS(13518), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146407] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13259), 1,
      anon_sym_LF,
    ACTIONS(13257), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146447] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13524), 1,
      anon_sym_LF,
    ACTIONS(13522), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146487] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13528), 1,
      anon_sym_LF,
    ACTIONS(13526), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146527] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13532), 1,
      anon_sym_LF,
    ACTIONS(13530), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146567] = 14,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(16198), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16200), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19491), 1,
      sym__word_identifier,
    ACTIONS(19493), 1,
      sym_character_literal,
    STATE(10783), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16196), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16202), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11179), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [146627] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19495), 1,
      anon_sym_COMMA,
    STATE(12328), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [146671] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13536), 1,
      anon_sym_LF,
    ACTIONS(13534), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146711] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13540), 1,
      anon_sym_LF,
    ACTIONS(13538), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146751] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13544), 1,
      anon_sym_LF,
    ACTIONS(13542), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146791] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13548), 1,
      anon_sym_LF,
    ACTIONS(13546), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146831] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13552), 1,
      anon_sym_LF,
    ACTIONS(13550), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146871] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13556), 1,
      anon_sym_LF,
    ACTIONS(13554), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146911] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13560), 1,
      anon_sym_LF,
    ACTIONS(13558), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146951] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13564), 1,
      anon_sym_LF,
    ACTIONS(13562), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [146991] = 27,
    ACTIONS(7970), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19498), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15486), 1,
      aux_sym_argument_list_repeat1,
    STATE(16542), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [147077] = 27,
    ACTIONS(9292), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19500), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15741), 1,
      sym__comprehension_clause,
    STATE(15742), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [147163] = 14,
    ACTIONS(863), 1,
      anon_sym_LBRACK,
    ACTIONS(865), 1,
      anon_sym_LBRACE,
    ACTIONS(899), 1,
      sym__string_start,
    ACTIONS(901), 1,
      sym__command_start,
    ACTIONS(11744), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11746), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19502), 1,
      sym__word_identifier,
    ACTIONS(19504), 1,
      anon_sym_LPAREN,
    ACTIONS(19506), 1,
      sym_character_literal,
    STATE(4474), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11742), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(11748), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5342), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [147223] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(13094), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147263] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13568), 1,
      anon_sym_LF,
    ACTIONS(13566), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147303] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13572), 1,
      anon_sym_LF,
    ACTIONS(13570), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147343] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13576), 1,
      anon_sym_LF,
    ACTIONS(13574), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147383] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13580), 1,
      anon_sym_LF,
    ACTIONS(13578), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147423] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13584), 1,
      anon_sym_LF,
    ACTIONS(13582), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147463] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13588), 1,
      anon_sym_LF,
    ACTIONS(13586), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147503] = 27,
    ACTIONS(8456), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19508), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15573), 1,
      aux_sym_argument_list_repeat1,
    STATE(16070), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [147589] = 27,
    ACTIONS(9332), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19510), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15692), 1,
      sym__comprehension_clause,
    STATE(15708), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [147675] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13592), 1,
      anon_sym_LF,
    ACTIONS(13590), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147715] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13596), 1,
      anon_sym_LF,
    ACTIONS(13594), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147755] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13600), 1,
      anon_sym_LF,
    ACTIONS(13598), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147795] = 14,
    ACTIONS(381), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(383), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16608), 1,
      sym__string_start,
    ACTIONS(16610), 1,
      sym__command_start,
    ACTIONS(19512), 1,
      sym__word_identifier,
    ACTIONS(19514), 1,
      anon_sym_LPAREN,
    ACTIONS(19516), 1,
      anon_sym_LBRACK,
    ACTIONS(19518), 1,
      anon_sym_LBRACE,
    ACTIONS(19520), 1,
      sym_character_literal,
    STATE(6565), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8654), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8656), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7150), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [147855] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13604), 1,
      anon_sym_LF,
    ACTIONS(13602), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147895] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13608), 1,
      anon_sym_LF,
    ACTIONS(13606), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147935] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13622), 1,
      anon_sym_LF,
    ACTIONS(13620), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [147975] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13626), 1,
      anon_sym_LF,
    ACTIONS(13624), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [148015] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13630), 1,
      anon_sym_LF,
    ACTIONS(13628), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [148055] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13634), 1,
      anon_sym_LF,
    ACTIONS(13632), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [148095] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13638), 1,
      anon_sym_LF,
    ACTIONS(13636), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [148135] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13642), 1,
      anon_sym_LF,
    ACTIONS(13640), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [148175] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13646), 1,
      anon_sym_LF,
    ACTIONS(13644), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [148215] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13650), 1,
      anon_sym_LF,
    ACTIONS(13648), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [148255] = 27,
    ACTIONS(8068), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19522), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16075), 1,
      aux_sym_argument_list_repeat1,
    STATE(16180), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [148341] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13654), 1,
      anon_sym_LF,
    ACTIONS(13652), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [148381] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13658), 1,
      anon_sym_LF,
    ACTIONS(13656), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [148421] = 27,
    ACTIONS(9368), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19524), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16130), 1,
      sym__comprehension_clause,
    STATE(16133), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [148507] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13662), 1,
      anon_sym_LF,
    ACTIONS(13660), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [148547] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13666), 1,
      anon_sym_LF,
    ACTIONS(13664), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [148587] = 14,
    ACTIONS(17276), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17294), 1,
      sym__string_start,
    ACTIONS(17296), 1,
      sym__command_start,
    ACTIONS(19526), 1,
      sym__word_identifier,
    ACTIONS(19528), 1,
      anon_sym_LPAREN,
    ACTIONS(19530), 1,
      anon_sym_LBRACK,
    ACTIONS(19532), 1,
      anon_sym_LBRACE,
    ACTIONS(19534), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19536), 1,
      sym_character_literal,
    STATE(6185), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17274), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17280), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6817), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [148647] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17578), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [148689] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18865), 1,
      anon_sym_QMARK,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    STATE(14432), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [148769] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19261), 1,
      anon_sym_QMARK,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13070), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [148845] = 27,
    ACTIONS(8276), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19538), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15482), 1,
      aux_sym_argument_list_repeat1,
    STATE(15777), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [148931] = 27,
    ACTIONS(9406), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19540), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15508), 1,
      sym__comprehension_clause,
    STATE(15511), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [149017] = 14,
    ACTIONS(16080), 1,
      anon_sym_LPAREN,
    ACTIONS(16082), 1,
      anon_sym_LBRACK,
    ACTIONS(16084), 1,
      anon_sym_LBRACE,
    ACTIONS(16092), 1,
      sym__string_start,
    ACTIONS(16094), 1,
      sym__command_start,
    ACTIONS(17096), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17098), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19542), 1,
      sym__word_identifier,
    ACTIONS(19544), 1,
      sym_character_literal,
    STATE(4494), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17094), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17100), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5532), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [149077] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19134), 1,
      anon_sym_QMARK,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19548), 1,
      anon_sym_LF,
    STATE(14423), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(19546), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [149157] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(13239), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [149199] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(13243), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [149241] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(12926), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [149283] = 27,
    ACTIONS(7956), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19550), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15688), 1,
      aux_sym_argument_list_repeat1,
    STATE(16301), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [149369] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 12,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [149433] = 27,
    ACTIONS(9442), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19552), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15734), 1,
      sym__comprehension_clause,
    STATE(15736), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [149519] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 21,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [149571] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [149633] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19227), 1,
      anon_sym_QMARK,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [149709] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [149781] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [149849] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 11,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [149915] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 18,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [149973] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [150035] = 14,
    ACTIONS(173), 1,
      sym__string_start,
    ACTIONS(175), 1,
      sym__command_start,
    ACTIONS(4988), 1,
      anon_sym_LBRACK,
    ACTIONS(4990), 1,
      anon_sym_LBRACE,
    ACTIONS(15302), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15304), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19554), 1,
      sym__word_identifier,
    ACTIONS(19556), 1,
      anon_sym_LPAREN,
    ACTIONS(19558), 1,
      sym_character_literal,
    STATE(10281), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17194), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17196), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10760), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [150095] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 21,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [150147] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [150197] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [150245] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(13306), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [150291] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(13306), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [150335] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19227), 1,
      anon_sym_QMARK,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13338), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [150411] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19178), 1,
      anon_sym_COMMA,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    STATE(12069), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [150491] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19227), 1,
      anon_sym_QMARK,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13070), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [150567] = 27,
    ACTIONS(8086), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19562), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15533), 1,
      sym__comprehension_clause,
    STATE(15911), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [150653] = 27,
    ACTIONS(9480), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19564), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16039), 1,
      sym__comprehension_clause,
    STATE(16041), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [150739] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 12,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [150803] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 21,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [150855] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [150917] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19290), 1,
      anon_sym_QMARK,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [150993] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
  [151065] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [151133] = 14,
    ACTIONS(685), 1,
      sym__string_start,
    ACTIONS(687), 1,
      sym__command_start,
    ACTIONS(8720), 1,
      anon_sym_LBRACK,
    ACTIONS(8722), 1,
      anon_sym_LBRACE,
    ACTIONS(11802), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11804), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19566), 1,
      sym__word_identifier,
    ACTIONS(19568), 1,
      anon_sym_LPAREN,
    ACTIONS(19570), 1,
      sym_character_literal,
    STATE(4517), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17142), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17144), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5596), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [151193] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 11,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [151259] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 18,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [151317] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [151379] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 21,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [151431] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [151481] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [151529] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(13306), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [151575] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(13306), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [151619] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19290), 1,
      anon_sym_QMARK,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13338), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [151695] = 27,
    ACTIONS(8234), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19572), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15775), 1,
      sym__comprehension_clause,
    STATE(16104), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [151781] = 27,
    ACTIONS(9516), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19574), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16116), 1,
      sym__comprehension_clause,
    STATE(16117), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [151867] = 14,
    ACTIONS(1069), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(1071), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16866), 1,
      sym__string_start,
    ACTIONS(16868), 1,
      sym__command_start,
    ACTIONS(19576), 1,
      sym__word_identifier,
    ACTIONS(19578), 1,
      anon_sym_LPAREN,
    ACTIONS(19580), 1,
      anon_sym_LBRACK,
    ACTIONS(19582), 1,
      anon_sym_LBRACE,
    ACTIONS(19584), 1,
      sym_character_literal,
    STATE(7091), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8692), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8694), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8281), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [151927] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17550), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [151969] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(13249), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [152009] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18654), 1,
      anon_sym_EQ,
    ACTIONS(13249), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [152051] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [152093] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18430), 1,
      anon_sym_EQ,
    ACTIONS(13249), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [152135] = 27,
    ACTIONS(8452), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19586), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16069), 1,
      sym__comprehension_clause,
    STATE(16181), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [152221] = 27,
    ACTIONS(9554), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19588), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16195), 1,
      sym__comprehension_clause,
    STATE(16196), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [152307] = 14,
    ACTIONS(17400), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17418), 1,
      sym__string_start,
    ACTIONS(17420), 1,
      sym__command_start,
    ACTIONS(19590), 1,
      sym__word_identifier,
    ACTIONS(19592), 1,
      anon_sym_LPAREN,
    ACTIONS(19594), 1,
      anon_sym_LBRACK,
    ACTIONS(19596), 1,
      anon_sym_LBRACE,
    ACTIONS(19598), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19600), 1,
      sym_character_literal,
    STATE(6751), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17398), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7347), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [152367] = 14,
    ACTIONS(19602), 1,
      sym__word_identifier,
    ACTIONS(19604), 1,
      anon_sym_LPAREN,
    ACTIONS(19606), 1,
      anon_sym_LBRACK,
    ACTIONS(19608), 1,
      anon_sym_LBRACE,
    ACTIONS(19612), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(19614), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19618), 1,
      sym_character_literal,
    ACTIONS(19620), 1,
      sym__string_start,
    ACTIONS(19622), 1,
      sym__command_start,
    STATE(9516), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19610), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(19616), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9563), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [152427] = 26,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19628), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19634), 1,
      anon_sym_QMARK,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(19660), 1,
      aux_sym__terminator_token1,
    STATE(14481), 1,
      aux_sym_open_tuple_repeat1,
    STATE(15226), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 2,
      anon_sym_catch,
      anon_sym_finally,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [152511] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17538), 1,
      anon_sym_DASH_GT,
    ACTIONS(17940), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [152555] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17940), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [152599] = 27,
    ACTIONS(7984), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19662), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16141), 1,
      sym__comprehension_clause,
    STATE(16250), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [152685] = 27,
    ACTIONS(9592), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19664), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16275), 1,
      sym__comprehension_clause,
    STATE(16276), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [152771] = 14,
    ACTIONS(16034), 1,
      anon_sym_LPAREN,
    ACTIONS(16036), 1,
      anon_sym_LBRACK,
    ACTIONS(16038), 1,
      anon_sym_LBRACE,
    ACTIONS(16046), 1,
      sym__string_start,
    ACTIONS(16048), 1,
      sym__command_start,
    ACTIONS(16968), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16970), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19666), 1,
      sym__word_identifier,
    ACTIONS(19668), 1,
      sym_character_literal,
    STATE(5619), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16966), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16972), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6551), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [152831] = 27,
    ACTIONS(8098), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19670), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16208), 1,
      sym__comprehension_clause,
    STATE(16353), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [152917] = 27,
    ACTIONS(9630), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19672), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16379), 1,
      sym__comprehension_clause,
    STATE(16383), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153003] = 14,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    ACTIONS(19454), 1,
      sym__word_identifier,
    ACTIONS(19456), 1,
      anon_sym_LPAREN,
    ACTIONS(19458), 1,
      anon_sym_LBRACK,
    ACTIONS(19460), 1,
      anon_sym_LBRACE,
    ACTIONS(19464), 1,
      sym_character_literal,
    ACTIONS(19674), 1,
      aux_sym_integer_literal_token4,
    STATE(16766), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11546), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [153063] = 27,
    ACTIONS(8228), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19676), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16309), 1,
      sym__comprehension_clause,
    STATE(16510), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153149] = 27,
    ACTIONS(9666), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19678), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16528), 1,
      sym__comprehension_clause,
    STATE(16529), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153235] = 14,
    ACTIONS(469), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(471), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17220), 1,
      sym__string_start,
    ACTIONS(17222), 1,
      sym__command_start,
    ACTIONS(19680), 1,
      sym__word_identifier,
    ACTIONS(19682), 1,
      anon_sym_LPAREN,
    ACTIONS(19684), 1,
      anon_sym_LBRACK,
    ACTIONS(19686), 1,
      anon_sym_LBRACE,
    ACTIONS(19688), 1,
      sym_character_literal,
    STATE(6525), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6320), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(6322), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6913), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [153295] = 12,
    ACTIONS(18616), 1,
      sym__word_identifier,
    ACTIONS(18618), 1,
      aux_sym_import_path_token1,
    ACTIONS(18620), 1,
      anon_sym_LPAREN,
    ACTIONS(18622), 1,
      anon_sym_DOLLAR,
    ACTIONS(18624), 1,
      anon_sym_AT,
    STATE(6752), 1,
      sym_scoped_identifier,
    STATE(6753), 1,
      sym_identifier,
    STATE(7470), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7004), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17286), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17284), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [153351] = 27,
    ACTIONS(8346), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19690), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16431), 1,
      sym__comprehension_clause,
    STATE(16568), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153437] = 27,
    ACTIONS(9706), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19692), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16581), 1,
      sym__comprehension_clause,
    STATE(16582), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153523] = 14,
    ACTIONS(16678), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16696), 1,
      sym__string_start,
    ACTIONS(16698), 1,
      sym__command_start,
    ACTIONS(19694), 1,
      sym__word_identifier,
    ACTIONS(19696), 1,
      anon_sym_LPAREN,
    ACTIONS(19698), 1,
      anon_sym_LBRACK,
    ACTIONS(19700), 1,
      anon_sym_LBRACE,
    ACTIONS(19702), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19704), 1,
      sym_character_literal,
    STATE(6302), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16676), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16682), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6796), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [153583] = 27,
    ACTIONS(8522), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19706), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16540), 1,
      sym__comprehension_clause,
    STATE(16636), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153669] = 27,
    ACTIONS(9740), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19708), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16647), 1,
      sym__comprehension_clause,
    STATE(16648), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153755] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19466), 1,
      anon_sym_COMMA,
    ACTIONS(19468), 1,
      anon_sym_as,
    STATE(13075), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12868), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12862), 24,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [153801] = 14,
    ACTIONS(15624), 1,
      anon_sym_LPAREN,
    ACTIONS(15626), 1,
      anon_sym_LBRACK,
    ACTIONS(15628), 1,
      anon_sym_LBRACE,
    ACTIONS(15636), 1,
      sym__string_start,
    ACTIONS(15638), 1,
      sym__command_start,
    ACTIONS(16376), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16378), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19710), 1,
      sym__word_identifier,
    ACTIONS(19712), 1,
      sym_character_literal,
    STATE(4520), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16374), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16380), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5652), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [153861] = 27,
    ACTIONS(8072), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19714), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16369), 1,
      aux_sym_argument_list_repeat1,
    STATE(16644), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153947] = 27,
    ACTIONS(8010), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19716), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15526), 1,
      aux_sym_argument_list_repeat1,
    STATE(16603), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154033] = 27,
    ACTIONS(9778), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19718), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16103), 1,
      sym__comprehension_clause,
    STATE(16114), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154119] = 14,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(19722), 1,
      sym_character_literal,
    STATE(11143), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10054), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [154179] = 27,
    ACTIONS(8848), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19724), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16521), 1,
      sym__comprehension_clause,
    STATE(16532), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154265] = 27,
    ACTIONS(8082), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19726), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15743), 1,
      aux_sym_argument_list_repeat1,
    STATE(16084), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154351] = 27,
    ACTIONS(9812), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19728), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15800), 1,
      sym__comprehension_clause,
    STATE(15811), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154437] = 14,
    ACTIONS(15702), 1,
      anon_sym_LPAREN,
    ACTIONS(15704), 1,
      anon_sym_LBRACK,
    ACTIONS(15706), 1,
      anon_sym_LBRACE,
    ACTIONS(15714), 1,
      sym__string_start,
    ACTIONS(15716), 1,
      sym__command_start,
    ACTIONS(16176), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16178), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19730), 1,
      sym__word_identifier,
    ACTIONS(19732), 1,
      sym_character_literal,
    STATE(9326), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16174), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16180), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9470), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [154497] = 27,
    ACTIONS(8160), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19734), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16368), 1,
      aux_sym_argument_list_repeat1,
    STATE(16596), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154583] = 27,
    ACTIONS(9850), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19736), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16475), 1,
      sym__comprehension_clause,
    STATE(16506), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154669] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    STATE(12462), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [154713] = 14,
    ACTIONS(15512), 1,
      anon_sym_LPAREN,
    ACTIONS(15514), 1,
      anon_sym_LBRACK,
    ACTIONS(15516), 1,
      anon_sym_LBRACE,
    ACTIONS(15524), 1,
      sym__string_start,
    ACTIONS(15526), 1,
      sym__command_start,
    ACTIONS(16638), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16640), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19740), 1,
      sym__word_identifier,
    ACTIONS(19742), 1,
      sym_character_literal,
    STATE(9287), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16636), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16642), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9401), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [154773] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19744), 1,
      anon_sym_COMMA,
    STATE(12462), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [154817] = 27,
    ACTIONS(8268), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19747), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15586), 1,
      aux_sym_argument_list_repeat1,
    STATE(16076), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154903] = 27,
    ACTIONS(9884), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19749), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15647), 1,
      sym__comprehension_clause,
    STATE(15661), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154989] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(13806), 1,
      anon_sym_COMMA,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13255), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [155069] = 14,
    ACTIONS(15870), 1,
      anon_sym_LPAREN,
    ACTIONS(15872), 1,
      anon_sym_LBRACK,
    ACTIONS(15874), 1,
      anon_sym_LBRACE,
    ACTIONS(15882), 1,
      sym__string_start,
    ACTIONS(15884), 1,
      sym__command_start,
    ACTIONS(16242), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16244), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19751), 1,
      sym__word_identifier,
    ACTIONS(19753), 1,
      sym_character_literal,
    STATE(10435), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16240), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16246), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10532), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [155129] = 4,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155169] = 27,
    ACTIONS(8380), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19757), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15812), 1,
      aux_sym_argument_list_repeat1,
    STATE(16616), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [155255] = 27,
    ACTIONS(9922), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19759), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16066), 1,
      sym__comprehension_clause,
    STATE(16067), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [155341] = 14,
    ACTIONS(877), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(879), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17266), 1,
      sym__string_start,
    ACTIONS(17268), 1,
      sym__command_start,
    ACTIONS(19761), 1,
      sym__word_identifier,
    ACTIONS(19763), 1,
      anon_sym_LPAREN,
    ACTIONS(19765), 1,
      anon_sym_LBRACK,
    ACTIONS(19767), 1,
      anon_sym_LBRACE,
    ACTIONS(19769), 1,
      sym_character_literal,
    STATE(6805), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(875), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(881), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7577), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [155401] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(13806), 1,
      anon_sym_COMMA,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 5,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [155479] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17578), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [155521] = 14,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    ACTIONS(15888), 1,
      anon_sym_LPAREN,
    ACTIONS(16918), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16920), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19771), 1,
      sym__word_identifier,
    ACTIONS(19773), 1,
      sym_character_literal,
    STATE(14347), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16916), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16922), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(14376), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [155581] = 27,
    ACTIONS(8494), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19775), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15727), 1,
      sym__comprehension_clause,
    STATE(16178), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [155667] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [155707] = 27,
    ACTIONS(9958), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19777), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16217), 1,
      sym__comprehension_clause,
    STATE(16229), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [155793] = 27,
    ACTIONS(8256), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19779), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16362), 1,
      sym__comprehension_clause,
    STATE(16377), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [155879] = 14,
    ACTIONS(16780), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16798), 1,
      sym__string_start,
    ACTIONS(16800), 1,
      sym__command_start,
    ACTIONS(19781), 1,
      sym__word_identifier,
    ACTIONS(19783), 1,
      anon_sym_LPAREN,
    ACTIONS(19785), 1,
      anon_sym_LBRACK,
    ACTIONS(19787), 1,
      anon_sym_LBRACE,
    ACTIONS(19789), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19791), 1,
      sym_character_literal,
    STATE(6621), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16778), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16784), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7209), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [155939] = 27,
    ACTIONS(7974), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19793), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16091), 1,
      sym__comprehension_clause,
    STATE(16476), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [156025] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(13239), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [156067] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18865), 1,
      anon_sym_QMARK,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    STATE(12164), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13239), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [156147] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(13243), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [156189] = 27,
    ACTIONS(9998), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19795), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16522), 1,
      sym__comprehension_clause,
    STATE(16531), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [156275] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18865), 1,
      anon_sym_QMARK,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    STATE(12164), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13243), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [156355] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(12926), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [156397] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18865), 1,
      anon_sym_QMARK,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    STATE(12164), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12926), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [156477] = 14,
    ACTIONS(15604), 1,
      anon_sym_LPAREN,
    ACTIONS(15606), 1,
      anon_sym_LBRACK,
    ACTIONS(15608), 1,
      anon_sym_LBRACE,
    ACTIONS(15616), 1,
      sym__string_start,
    ACTIONS(15618), 1,
      sym__command_start,
    ACTIONS(16756), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16758), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19797), 1,
      sym__word_identifier,
    ACTIONS(19799), 1,
      sym_character_literal,
    STATE(4676), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16754), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16760), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6413), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [156537] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(13308), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [156581] = 27,
    ACTIONS(8040), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19801), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15481), 1,
      aux_sym_argument_list_repeat1,
    STATE(16321), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [156667] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13318), 1,
      anon_sym_LF,
    ACTIONS(13316), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [156707] = 27,
    ACTIONS(10034), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19803), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15502), 1,
      sym__comprehension_clause,
    STATE(15506), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [156793] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13322), 1,
      anon_sym_LF,
    ACTIONS(13320), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [156833] = 14,
    ACTIONS(15584), 1,
      anon_sym_LPAREN,
    ACTIONS(15586), 1,
      anon_sym_LBRACK,
    ACTIONS(15588), 1,
      anon_sym_LBRACE,
    ACTIONS(15596), 1,
      sym__string_start,
    ACTIONS(15598), 1,
      sym__command_start,
    ACTIONS(17176), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17178), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19805), 1,
      sym__word_identifier,
    ACTIONS(19807), 1,
      sym_character_literal,
    STATE(4282), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17174), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17180), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4812), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [156893] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(13239), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [156933] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19134), 1,
      anon_sym_QMARK,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    STATE(11924), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13239), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [157013] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13328), 1,
      anon_sym_LF,
    ACTIONS(13326), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [157053] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(13243), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [157093] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19134), 1,
      anon_sym_QMARK,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    STATE(11924), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13243), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [157173] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(12926), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [157213] = 27,
    ACTIONS(8102), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19809), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15549), 1,
      aux_sym_argument_list_repeat1,
    STATE(16576), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [157299] = 27,
    ACTIONS(10072), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19811), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15569), 1,
      sym__comprehension_clause,
    STATE(15570), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [157385] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19134), 1,
      anon_sym_QMARK,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    STATE(11924), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12926), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [157465] = 12,
    ACTIONS(18398), 1,
      sym__word_identifier,
    ACTIONS(18400), 1,
      aux_sym_import_path_token1,
    ACTIONS(18402), 1,
      anon_sym_LPAREN,
    ACTIONS(18404), 1,
      anon_sym_DOLLAR,
    ACTIONS(18406), 1,
      anon_sym_AT,
    STATE(7599), 1,
      sym_scoped_identifier,
    STATE(7600), 1,
      sym_identifier,
    STATE(8980), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8260), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17410), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17408), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [157521] = 14,
    ACTIONS(16322), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16340), 1,
      sym__string_start,
    ACTIONS(16342), 1,
      sym__command_start,
    ACTIONS(19813), 1,
      sym__word_identifier,
    ACTIONS(19815), 1,
      anon_sym_LPAREN,
    ACTIONS(19817), 1,
      anon_sym_LBRACK,
    ACTIONS(19819), 1,
      anon_sym_LBRACE,
    ACTIONS(19821), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19823), 1,
      sym_character_literal,
    STATE(11440), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16320), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16326), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11625), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [157581] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13332), 1,
      anon_sym_LF,
    ACTIONS(13330), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [157621] = 27,
    ACTIONS(8156), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19825), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15523), 1,
      sym__comprehension_clause,
    STATE(15626), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [157707] = 27,
    ACTIONS(10108), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19827), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15639), 1,
      sym__comprehension_clause,
    STATE(15643), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [157793] = 14,
    ACTIONS(13186), 1,
      sym__string_start,
    ACTIONS(13188), 1,
      sym__command_start,
    ACTIONS(15720), 1,
      anon_sym_LPAREN,
    ACTIONS(15722), 1,
      anon_sym_LBRACK,
    ACTIONS(15724), 1,
      anon_sym_LBRACE,
    ACTIONS(16896), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16898), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19829), 1,
      sym__word_identifier,
    ACTIONS(19831), 1,
      sym_character_literal,
    STATE(10858), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16894), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16900), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11332), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [157853] = 27,
    ACTIONS(8252), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19833), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15587), 1,
      sym__comprehension_clause,
    STATE(15698), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [157939] = 27,
    ACTIONS(10148), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19835), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15716), 1,
      sym__comprehension_clause,
    STATE(15720), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [158025] = 27,
    ACTIONS(8430), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19837), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15621), 1,
      aux_sym_argument_list_repeat1,
    STATE(15657), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [158111] = 14,
    ACTIONS(307), 1,
      sym__string_start,
    ACTIONS(309), 1,
      sym__command_start,
    ACTIONS(8742), 1,
      anon_sym_LBRACK,
    ACTIONS(8744), 1,
      anon_sym_LBRACE,
    ACTIONS(11724), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11726), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19839), 1,
      sym__word_identifier,
    ACTIONS(19841), 1,
      anon_sym_LPAREN,
    ACTIONS(19843), 1,
      sym_character_literal,
    STATE(4283), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16656), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16658), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4935), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [158171] = 27,
    ACTIONS(8318), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19845), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15658), 1,
      sym__comprehension_clause,
    STATE(15772), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [158257] = 14,
    ACTIONS(19847), 1,
      sym__word_identifier,
    ACTIONS(19849), 1,
      anon_sym_LPAREN,
    ACTIONS(19851), 1,
      anon_sym_LBRACK,
    ACTIONS(19853), 1,
      anon_sym_LBRACE,
    ACTIONS(19857), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(19859), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19863), 1,
      sym_character_literal,
    ACTIONS(19865), 1,
      sym__string_start,
    ACTIONS(19867), 1,
      sym__command_start,
    STATE(9594), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19855), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(19861), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9653), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [158317] = 27,
    ACTIONS(8890), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19869), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15668), 1,
      sym__comprehension_clause,
    STATE(15670), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [158403] = 27,
    ACTIONS(10184), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19871), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15786), 1,
      sym__comprehension_clause,
    STATE(15789), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [158489] = 14,
    ACTIONS(761), 1,
      sym__string_start,
    ACTIONS(763), 1,
      sym__command_start,
    ACTIONS(8762), 1,
      anon_sym_LBRACK,
    ACTIONS(8764), 1,
      anon_sym_LBRACE,
    ACTIONS(11784), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11786), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19873), 1,
      sym__word_identifier,
    ACTIONS(19875), 1,
      anon_sym_LPAREN,
    ACTIONS(19877), 1,
      sym_character_literal,
    STATE(4382), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17084), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17086), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5784), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [158549] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(13308), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [158593] = 27,
    ACTIONS(8384), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19879), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15740), 1,
      sym__comprehension_clause,
    STATE(15839), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [158679] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19134), 1,
      anon_sym_QMARK,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    STATE(14423), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [158759] = 27,
    ACTIONS(10222), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19881), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15949), 1,
      sym__comprehension_clause,
    STATE(15967), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [158845] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 12,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [158909] = 14,
    ACTIONS(673), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(675), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16524), 1,
      sym__string_start,
    ACTIONS(16526), 1,
      sym__command_start,
    ACTIONS(19883), 1,
      sym__word_identifier,
    ACTIONS(19885), 1,
      anon_sym_LPAREN,
    ACTIONS(19887), 1,
      anon_sym_LBRACK,
    ACTIONS(19889), 1,
      anon_sym_LBRACE,
    ACTIONS(19891), 1,
      sym_character_literal,
    STATE(6735), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8728), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8730), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7654), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [158969] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 21,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [159021] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [159083] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13348), 1,
      anon_sym_LF,
    ACTIONS(13346), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [159123] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(19263), 1,
      anon_sym_QMARK,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [159199] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [159271] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [159339] = 27,
    ACTIONS(8466), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19893), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15801), 1,
      sym__comprehension_clause,
    STATE(16096), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [159425] = 27,
    ACTIONS(10258), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19895), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16109), 1,
      sym__comprehension_clause,
    STATE(16110), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [159511] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 11,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [159577] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 18,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [159635] = 14,
    ACTIONS(16462), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16480), 1,
      sym__string_start,
    ACTIONS(16482), 1,
      sym__command_start,
    ACTIONS(19897), 1,
      sym__word_identifier,
    ACTIONS(19899), 1,
      anon_sym_LPAREN,
    ACTIONS(19901), 1,
      anon_sym_LBRACK,
    ACTIONS(19903), 1,
      anon_sym_LBRACE,
    ACTIONS(19905), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19907), 1,
      sym_character_literal,
    STATE(6629), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16460), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16466), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7171), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [159695] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [159757] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 21,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [159809] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [159859] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [159907] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(13306), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [159953] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(13306), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [159997] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17550), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [160039] = 27,
    ACTIONS(7952), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19909), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16065), 1,
      sym__comprehension_clause,
    STATE(16156), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [160125] = 27,
    ACTIONS(10296), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19911), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16169), 1,
      sym__comprehension_clause,
    STATE(16171), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [160211] = 14,
    ACTIONS(15954), 1,
      anon_sym_LPAREN,
    ACTIONS(15956), 1,
      anon_sym_LBRACK,
    ACTIONS(15958), 1,
      anon_sym_LBRACE,
    ACTIONS(15966), 1,
      sym__string_start,
    ACTIONS(15968), 1,
      sym__command_start,
    ACTIONS(16560), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16562), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19913), 1,
      sym__word_identifier,
    ACTIONS(19915), 1,
      sym_character_literal,
    STATE(4649), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16558), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16564), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6212), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [160271] = 14,
    ACTIONS(2904), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      anon_sym_LBRACE,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(15280), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15282), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(19919), 1,
      anon_sym_LPAREN,
    ACTIONS(19921), 1,
      sym_character_literal,
    STATE(10319), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15278), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15284), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10382), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [160331] = 26,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19927), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19933), 1,
      anon_sym_QMARK,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(19959), 1,
      aux_sym__terminator_token1,
    STATE(14532), 1,
      aux_sym_open_tuple_repeat1,
    STATE(15258), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 2,
      anon_sym_end,
      anon_sym_catch,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [160415] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13360), 1,
      anon_sym_LF,
    ACTIONS(13358), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [160455] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17754), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [160497] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13364), 1,
      anon_sym_LF,
    ACTIONS(13362), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [160537] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13368), 1,
      anon_sym_LF,
    ACTIONS(13366), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [160577] = 27,
    ACTIONS(7996), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19961), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16127), 1,
      sym__comprehension_clause,
    STATE(16232), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [160663] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13372), 1,
      anon_sym_LF,
    ACTIONS(13370), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [160703] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13376), 1,
      anon_sym_LF,
    ACTIONS(13374), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [160743] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13380), 1,
      anon_sym_LF,
    ACTIONS(13378), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [160783] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [160825] = 27,
    ACTIONS(10330), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19963), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16264), 1,
      sym__comprehension_clause,
    STATE(16265), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [160911] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13384), 1,
      anon_sym_LF,
    ACTIONS(13382), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [160951] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13388), 1,
      anon_sym_LF,
    ACTIONS(13386), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [160991] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13392), 1,
      anon_sym_LF,
    ACTIONS(13390), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [161031] = 14,
    ACTIONS(15994), 1,
      anon_sym_LPAREN,
    ACTIONS(15996), 1,
      anon_sym_LBRACK,
    ACTIONS(15998), 1,
      anon_sym_LBRACE,
    ACTIONS(16006), 1,
      sym__string_start,
    ACTIONS(16008), 1,
      sym__command_start,
    ACTIONS(16726), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16728), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19965), 1,
      sym__word_identifier,
    ACTIONS(19967), 1,
      sym_character_literal,
    STATE(11522), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16724), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16730), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(12235), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [161091] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13398), 1,
      anon_sym_LF,
    ACTIONS(13396), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [161131] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13402), 1,
      anon_sym_LF,
    ACTIONS(13400), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [161171] = 27,
    ACTIONS(8048), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19969), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16200), 1,
      sym__comprehension_clause,
    STATE(16324), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [161257] = 27,
    ACTIONS(10366), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19971), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16363), 1,
      sym__comprehension_clause,
    STATE(16367), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [161343] = 14,
    ACTIONS(15774), 1,
      anon_sym_LPAREN,
    ACTIONS(15776), 1,
      anon_sym_LBRACK,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    ACTIONS(15786), 1,
      sym__string_start,
    ACTIONS(15788), 1,
      sym__command_start,
    ACTIONS(17066), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17068), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19973), 1,
      sym__word_identifier,
    ACTIONS(19975), 1,
      sym_character_literal,
    STATE(4704), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17064), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17070), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6402), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [161403] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13409), 1,
      anon_sym_LF,
    ACTIONS(13407), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [161443] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19472), 1,
      anon_sym_DOT,
    ACTIONS(12848), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12846), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [161485] = 12,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18530), 1,
      aux_sym_import_path_token1,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18534), 1,
      anon_sym_DOLLAR,
    ACTIONS(18536), 1,
      anon_sym_AT,
    STATE(10781), 1,
      sym_import_alias,
    STATE(12289), 1,
      sym_scoped_identifier,
    STATE(12306), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12947), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [161541] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11745), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [161601] = 12,
    ACTIONS(18588), 1,
      sym__word_identifier,
    ACTIONS(18590), 1,
      aux_sym_import_path_token1,
    ACTIONS(18592), 1,
      anon_sym_LPAREN,
    ACTIONS(18594), 1,
      anon_sym_DOLLAR,
    ACTIONS(18596), 1,
      anon_sym_AT,
    STATE(6799), 1,
      sym_scoped_identifier,
    STATE(6806), 1,
      sym_identifier,
    STATE(7826), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6862), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16688), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16686), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [161657] = 14,
    ACTIONS(15552), 1,
      anon_sym_LPAREN,
    ACTIONS(15554), 1,
      anon_sym_LBRACK,
    ACTIONS(15556), 1,
      anon_sym_LBRACE,
    ACTIONS(15564), 1,
      sym__string_start,
    ACTIONS(15566), 1,
      sym__command_start,
    ACTIONS(17154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19987), 1,
      sym__word_identifier,
    ACTIONS(19989), 1,
      sym_character_literal,
    STATE(4316), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4719), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [161717] = 14,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16296), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    ACTIONS(19454), 1,
      sym__word_identifier,
    ACTIONS(19456), 1,
      anon_sym_LPAREN,
    ACTIONS(19458), 1,
      anon_sym_LBRACK,
    ACTIONS(19460), 1,
      anon_sym_LBRACE,
    ACTIONS(19464), 1,
      sym_character_literal,
    STATE(11383), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11546), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [161777] = 14,
    ACTIONS(15684), 1,
      anon_sym_LPAREN,
    ACTIONS(15686), 1,
      anon_sym_LBRACK,
    ACTIONS(15688), 1,
      anon_sym_LBRACE,
    ACTIONS(15696), 1,
      sym__string_start,
    ACTIONS(15698), 1,
      sym__command_start,
    ACTIONS(17302), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17304), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19991), 1,
      sym__word_identifier,
    ACTIONS(19993), 1,
      sym_character_literal,
    STATE(4447), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17300), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17306), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5636), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [161837] = 27,
    ACTIONS(8486), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19995), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15831), 1,
      aux_sym_argument_list_repeat1,
    STATE(16621), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [161923] = 14,
    ACTIONS(17276), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17278), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17294), 1,
      sym__string_start,
    ACTIONS(17296), 1,
      sym__command_start,
    ACTIONS(19526), 1,
      sym__word_identifier,
    ACTIONS(19528), 1,
      anon_sym_LPAREN,
    ACTIONS(19530), 1,
      anon_sym_LBRACK,
    ACTIONS(19532), 1,
      anon_sym_LBRACE,
    ACTIONS(19536), 1,
      sym_character_literal,
    STATE(6185), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17274), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17280), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6817), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [161983] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18865), 1,
      anon_sym_QMARK,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(19548), 1,
      anon_sym_LF,
    STATE(14432), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(19546), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [162063] = 27,
    ACTIONS(8932), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19997), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16009), 1,
      sym__comprehension_clause,
    STATE(16018), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [162149] = 14,
    ACTIONS(15754), 1,
      anon_sym_LPAREN,
    ACTIONS(15756), 1,
      anon_sym_LBRACK,
    ACTIONS(15758), 1,
      anon_sym_LBRACE,
    ACTIONS(15766), 1,
      sym__string_start,
    ACTIONS(15768), 1,
      sym__command_start,
    ACTIONS(17020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19999), 1,
      sym__word_identifier,
    ACTIONS(20001), 1,
      sym_character_literal,
    STATE(10506), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11080), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [162209] = 12,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18580), 1,
      aux_sym_import_path_token1,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(18584), 1,
      anon_sym_DOLLAR,
    ACTIONS(18586), 1,
      anon_sym_AT,
    STATE(11649), 1,
      sym_scoped_identifier,
    STATE(11667), 1,
      sym_identifier,
    STATE(11946), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11955), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16304), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [162265] = 14,
    ACTIONS(289), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(291), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16718), 1,
      sym__string_start,
    ACTIONS(16720), 1,
      sym__command_start,
    ACTIONS(20003), 1,
      sym__word_identifier,
    ACTIONS(20005), 1,
      anon_sym_LPAREN,
    ACTIONS(20007), 1,
      anon_sym_LBRACK,
    ACTIONS(20009), 1,
      anon_sym_LBRACE,
    ACTIONS(20011), 1,
      sym_character_literal,
    STATE(6482), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8750), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8752), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6874), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [162325] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13255), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [162403] = 14,
    ACTIONS(17428), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17446), 1,
      sym__string_start,
    ACTIONS(17448), 1,
      sym__command_start,
    ACTIONS(20013), 1,
      sym__word_identifier,
    ACTIONS(20015), 1,
      anon_sym_LPAREN,
    ACTIONS(20017), 1,
      anon_sym_LBRACK,
    ACTIONS(20019), 1,
      anon_sym_LBRACE,
    ACTIONS(20021), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20023), 1,
      sym_character_literal,
    STATE(6236), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17426), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17432), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6684), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [162463] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19290), 1,
      anon_sym_QMARK,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13070), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [162539] = 14,
    ACTIONS(15974), 1,
      anon_sym_LPAREN,
    ACTIONS(15976), 1,
      anon_sym_LBRACK,
    ACTIONS(15978), 1,
      anon_sym_LBRACE,
    ACTIONS(15986), 1,
      sym__string_start,
    ACTIONS(15988), 1,
      sym__command_start,
    ACTIONS(17454), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17456), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20025), 1,
      sym__word_identifier,
    ACTIONS(20027), 1,
      sym_character_literal,
    STATE(4453), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17452), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17458), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5790), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [162599] = 14,
    ACTIONS(399), 1,
      sym__string_start,
    ACTIONS(401), 1,
      sym__command_start,
    ACTIONS(8646), 1,
      anon_sym_LBRACK,
    ACTIONS(8648), 1,
      anon_sym_LBRACE,
    ACTIONS(11706), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11708), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20029), 1,
      sym__word_identifier,
    ACTIONS(20031), 1,
      anon_sym_LPAREN,
    ACTIONS(20033), 1,
      sym_character_literal,
    STATE(4311), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16744), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16746), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4946), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [162659] = 26,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20039), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20045), 1,
      anon_sym_QMARK,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20071), 1,
      aux_sym__terminator_token1,
    STATE(14507), 1,
      aux_sym_open_tuple_repeat1,
    STATE(15224), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 2,
      anon_sym_end,
      anon_sym_finally,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [162743] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17570), 1,
      anon_sym_DASH_GT,
    ACTIONS(17900), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [162787] = 14,
    ACTIONS(749), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(751), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16430), 1,
      sym__string_start,
    ACTIONS(16432), 1,
      sym__command_start,
    ACTIONS(20073), 1,
      sym__word_identifier,
    ACTIONS(20075), 1,
      anon_sym_LPAREN,
    ACTIONS(20077), 1,
      anon_sym_LBRACK,
    ACTIONS(20079), 1,
      anon_sym_LBRACE,
    ACTIONS(20081), 1,
      sym_character_literal,
    STATE(6837), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8770), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8772), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7789), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [162847] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17900), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [162891] = 14,
    ACTIONS(17478), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17496), 1,
      sym__string_start,
    ACTIONS(17498), 1,
      sym__command_start,
    ACTIONS(20083), 1,
      sym__word_identifier,
    ACTIONS(20085), 1,
      anon_sym_LPAREN,
    ACTIONS(20087), 1,
      anon_sym_LBRACK,
    ACTIONS(20089), 1,
      anon_sym_LBRACE,
    ACTIONS(20091), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20093), 1,
      sym_character_literal,
    STATE(6585), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17476), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17482), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6904), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [162951] = 14,
    ACTIONS(15734), 1,
      anon_sym_LPAREN,
    ACTIONS(15736), 1,
      anon_sym_LBRACK,
    ACTIONS(15738), 1,
      anon_sym_LBRACE,
    ACTIONS(15746), 1,
      sym__string_start,
    ACTIONS(15748), 1,
      sym__command_start,
    ACTIONS(17228), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17230), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20095), 1,
      sym__word_identifier,
    ACTIONS(20097), 1,
      sym_character_literal,
    STATE(4774), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17226), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17232), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6367), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [163011] = 14,
    ACTIONS(609), 1,
      sym__string_start,
    ACTIONS(611), 1,
      sym__command_start,
    ACTIONS(8786), 1,
      anon_sym_LBRACK,
    ACTIONS(8788), 1,
      anon_sym_LBRACE,
    ACTIONS(11766), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11768), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20099), 1,
      sym__word_identifier,
    ACTIONS(20101), 1,
      anon_sym_LPAREN,
    ACTIONS(20103), 1,
      sym_character_literal,
    STATE(4461), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17008), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17010), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5909), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [163071] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13306), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [163113] = 14,
    ACTIONS(15664), 1,
      anon_sym_LPAREN,
    ACTIONS(15666), 1,
      anon_sym_LBRACK,
    ACTIONS(15668), 1,
      anon_sym_LBRACE,
    ACTIONS(15676), 1,
      sym__string_start,
    ACTIONS(15678), 1,
      sym__command_start,
    ACTIONS(16874), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16876), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20105), 1,
      sym__word_identifier,
    ACTIONS(20107), 1,
      sym_character_literal,
    STATE(4466), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16872), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5189), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [163173] = 12,
    ACTIONS(18554), 1,
      sym__word_identifier,
    ACTIONS(18556), 1,
      aux_sym_import_path_token1,
    ACTIONS(18558), 1,
      anon_sym_LPAREN,
    ACTIONS(18560), 1,
      anon_sym_DOLLAR,
    ACTIONS(18562), 1,
      anon_sym_AT,
    STATE(7240), 1,
      sym_scoped_identifier,
    STATE(7241), 1,
      sym_identifier,
    STATE(8711), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8076), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16790), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16788), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [163229] = 14,
    ACTIONS(17400), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17402), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17418), 1,
      sym__string_start,
    ACTIONS(17420), 1,
      sym__command_start,
    ACTIONS(19590), 1,
      sym__word_identifier,
    ACTIONS(19592), 1,
      anon_sym_LPAREN,
    ACTIONS(19594), 1,
      anon_sym_LBRACK,
    ACTIONS(19596), 1,
      anon_sym_LBRACE,
    ACTIONS(19600), 1,
      sym_character_literal,
    STATE(6751), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17398), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7347), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [163289] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(13255), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [163329] = 14,
    ACTIONS(2786), 1,
      sym__string_start,
    ACTIONS(2788), 1,
      sym__command_start,
    ACTIONS(8560), 1,
      anon_sym_LBRACK,
    ACTIONS(8562), 1,
      anon_sym_LBRACE,
    ACTIONS(15338), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15340), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20109), 1,
      sym__word_identifier,
    ACTIONS(20111), 1,
      anon_sym_LPAREN,
    ACTIONS(20113), 1,
      sym_character_literal,
    STATE(10254), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16664), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16666), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10866), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [163389] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18865), 1,
      anon_sym_QMARK,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13255), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [163467] = 27,
    ACTIONS(8322), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20115), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15739), 1,
      sym__comprehension_clause,
    STATE(16575), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [163553] = 14,
    ACTIONS(16678), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16680), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16696), 1,
      sym__string_start,
    ACTIONS(16698), 1,
      sym__command_start,
    ACTIONS(19694), 1,
      sym__word_identifier,
    ACTIONS(19696), 1,
      anon_sym_LPAREN,
    ACTIONS(19698), 1,
      anon_sym_LBRACK,
    ACTIONS(19700), 1,
      anon_sym_LBRACE,
    ACTIONS(19704), 1,
      sym_character_literal,
    STATE(6302), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16676), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16682), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6796), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [163613] = 27,
    ACTIONS(8110), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20117), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15707), 1,
      sym__comprehension_clause,
    STATE(16137), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [163699] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13415), 1,
      anon_sym_LF,
    ACTIONS(13413), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [163739] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13419), 1,
      anon_sym_LF,
    ACTIONS(13417), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [163779] = 14,
    ACTIONS(16780), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16782), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16798), 1,
      sym__string_start,
    ACTIONS(16800), 1,
      sym__command_start,
    ACTIONS(19781), 1,
      sym__word_identifier,
    ACTIONS(19783), 1,
      anon_sym_LPAREN,
    ACTIONS(19785), 1,
      anon_sym_LBRACK,
    ACTIONS(19787), 1,
      anon_sym_LBRACE,
    ACTIONS(19791), 1,
      sym_character_literal,
    STATE(6621), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16778), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16784), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7209), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [163839] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13423), 1,
      anon_sym_LF,
    ACTIONS(13421), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [163879] = 27,
    ACTIONS(8970), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20119), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16158), 1,
      sym__comprehension_clause,
    STATE(16159), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [163965] = 14,
    ACTIONS(381), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16594), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16608), 1,
      sym__string_start,
    ACTIONS(16610), 1,
      sym__command_start,
    ACTIONS(19512), 1,
      sym__word_identifier,
    ACTIONS(19514), 1,
      anon_sym_LPAREN,
    ACTIONS(19516), 1,
      anon_sym_LBRACK,
    ACTIONS(19518), 1,
      anon_sym_LBRACE,
    ACTIONS(19520), 1,
      sym_character_literal,
    STATE(6565), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8654), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8656), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7150), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [164025] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13427), 1,
      anon_sym_LF,
    ACTIONS(13425), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164065] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13431), 1,
      anon_sym_LF,
    ACTIONS(13429), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164105] = 14,
    ACTIONS(16322), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16324), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16340), 1,
      sym__string_start,
    ACTIONS(16342), 1,
      sym__command_start,
    ACTIONS(19813), 1,
      sym__word_identifier,
    ACTIONS(19815), 1,
      anon_sym_LPAREN,
    ACTIONS(19817), 1,
      anon_sym_LBRACK,
    ACTIONS(19819), 1,
      anon_sym_LBRACE,
    ACTIONS(19823), 1,
      sym_character_literal,
    STATE(11393), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16320), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16326), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11625), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [164165] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13435), 1,
      anon_sym_LF,
    ACTIONS(13433), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164205] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13439), 1,
      anon_sym_LF,
    ACTIONS(13437), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164245] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [164321] = 27,
    ACTIONS(8642), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20121), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15563), 1,
      sym__comprehension_clause,
    STATE(15571), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [164407] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13443), 1,
      anon_sym_LF,
    ACTIONS(13441), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164447] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13447), 1,
      anon_sym_LF,
    ACTIONS(13445), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164487] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13451), 1,
      anon_sym_LF,
    ACTIONS(13449), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164527] = 14,
    ACTIONS(15902), 1,
      anon_sym_LPAREN,
    ACTIONS(15904), 1,
      anon_sym_LBRACK,
    ACTIONS(15906), 1,
      anon_sym_LBRACE,
    ACTIONS(15914), 1,
      sym__string_start,
    ACTIONS(15916), 1,
      sym__command_start,
    ACTIONS(16488), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16490), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20123), 1,
      sym__word_identifier,
    ACTIONS(20125), 1,
      sym_character_literal,
    STATE(4317), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16486), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16492), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4817), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [164587] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13455), 1,
      anon_sym_LF,
    ACTIONS(13453), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164627] = 14,
    ACTIONS(20127), 1,
      sym__word_identifier,
    ACTIONS(20129), 1,
      anon_sym_LPAREN,
    ACTIONS(20131), 1,
      anon_sym_LBRACK,
    ACTIONS(20133), 1,
      anon_sym_LBRACE,
    ACTIONS(20137), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(20139), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20143), 1,
      sym_character_literal,
    ACTIONS(20145), 1,
      sym__string_start,
    ACTIONS(20147), 1,
      sym__command_start,
    STATE(11374), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20135), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(20141), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11604), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [164687] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17538), 1,
      anon_sym_DASH_GT,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164731] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164775] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13459), 1,
      anon_sym_LF,
    ACTIONS(13457), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164815] = 14,
    ACTIONS(15794), 1,
      anon_sym_LPAREN,
    ACTIONS(15796), 1,
      anon_sym_LBRACK,
    ACTIONS(15798), 1,
      anon_sym_LBRACE,
    ACTIONS(15806), 1,
      sym__string_start,
    ACTIONS(15808), 1,
      sym__command_start,
    ACTIONS(16806), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16808), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20149), 1,
      sym__word_identifier,
    ACTIONS(20151), 1,
      sym_character_literal,
    STATE(4471), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16804), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16810), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5270), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [164875] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13463), 1,
      anon_sym_LF,
    ACTIONS(13461), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164915] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13483), 1,
      anon_sym_LF,
    ACTIONS(13481), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164955] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18468), 1,
      anon_sym_EQ,
    ACTIONS(13239), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [164997] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19178), 1,
      anon_sym_COMMA,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    STATE(12069), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13239), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [165077] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18468), 1,
      anon_sym_EQ,
    ACTIONS(13243), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [165119] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19178), 1,
      anon_sym_COMMA,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    STATE(12069), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13243), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [165199] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18468), 1,
      anon_sym_EQ,
    ACTIONS(12926), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [165241] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19178), 1,
      anon_sym_COMMA,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    STATE(12069), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12926), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [165321] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13487), 1,
      anon_sym_LF,
    ACTIONS(13485), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [165361] = 14,
    ACTIONS(591), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(593), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16844), 1,
      sym__string_start,
    ACTIONS(16846), 1,
      sym__command_start,
    ACTIONS(20153), 1,
      sym__word_identifier,
    ACTIONS(20155), 1,
      anon_sym_LPAREN,
    ACTIONS(20157), 1,
      anon_sym_LBRACK,
    ACTIONS(20159), 1,
      anon_sym_LBRACE,
    ACTIONS(20161), 1,
      sym_character_literal,
    STATE(6754), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8794), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8796), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7942), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [165421] = 14,
    ACTIONS(16534), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16552), 1,
      sym__string_start,
    ACTIONS(16554), 1,
      sym__command_start,
    ACTIONS(20163), 1,
      sym__word_identifier,
    ACTIONS(20165), 1,
      anon_sym_LPAREN,
    ACTIONS(20167), 1,
      anon_sym_LBRACK,
    ACTIONS(20169), 1,
      anon_sym_LBRACE,
    ACTIONS(20171), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20173), 1,
      sym_character_literal,
    STATE(6623), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16532), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16538), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7228), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [165481] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(13249), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [165523] = 14,
    ACTIONS(16462), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16464), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16480), 1,
      sym__string_start,
    ACTIONS(16482), 1,
      sym__command_start,
    ACTIONS(19897), 1,
      sym__word_identifier,
    ACTIONS(19899), 1,
      anon_sym_LPAREN,
    ACTIONS(19901), 1,
      anon_sym_LBRACK,
    ACTIONS(19903), 1,
      anon_sym_LBRACE,
    ACTIONS(19907), 1,
      sym_character_literal,
    STATE(6629), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16460), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16466), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7171), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [165583] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12972), 1,
      anon_sym_LF,
    ACTIONS(12974), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [165623] = 12,
    ACTIONS(18480), 1,
      sym__word_identifier,
    ACTIONS(18482), 1,
      aux_sym_import_path_token1,
    ACTIONS(18484), 1,
      anon_sym_LPAREN,
    ACTIONS(18486), 1,
      anon_sym_DOLLAR,
    ACTIONS(18488), 1,
      anon_sym_AT,
    STATE(11660), 1,
      sym_scoped_identifier,
    STATE(11661), 1,
      sym_identifier,
    STATE(12641), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11984), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16332), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16330), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [165679] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(12981), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [165719] = 14,
    ACTIONS(1069), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16852), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16866), 1,
      sym__string_start,
    ACTIONS(16868), 1,
      sym__command_start,
    ACTIONS(19576), 1,
      sym__word_identifier,
    ACTIONS(19578), 1,
      anon_sym_LPAREN,
    ACTIONS(19580), 1,
      anon_sym_LBRACK,
    ACTIONS(19582), 1,
      anon_sym_LBRACE,
    ACTIONS(19584), 1,
      sym_character_literal,
    STATE(7091), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8692), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8694), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8281), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [165779] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13491), 1,
      anon_sym_LF,
    ACTIONS(13489), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [165819] = 14,
    ACTIONS(16350), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16368), 1,
      sym__string_start,
    ACTIONS(16370), 1,
      sym__command_start,
    ACTIONS(20175), 1,
      sym__word_identifier,
    ACTIONS(20177), 1,
      anon_sym_LPAREN,
    ACTIONS(20179), 1,
      anon_sym_LBRACK,
    ACTIONS(20181), 1,
      anon_sym_LBRACE,
    ACTIONS(20183), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20185), 1,
      sym_character_literal,
    STATE(11472), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16348), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16354), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11642), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [165879] = 14,
    ACTIONS(13056), 1,
      sym__string_start,
    ACTIONS(13058), 1,
      sym__command_start,
    ACTIONS(15570), 1,
      anon_sym_LPAREN,
    ACTIONS(15572), 1,
      anon_sym_LBRACK,
    ACTIONS(15574), 1,
      anon_sym_LBRACE,
    ACTIONS(17042), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17044), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20187), 1,
      sym__word_identifier,
    ACTIONS(20189), 1,
      sym_character_literal,
    STATE(10554), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17040), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17046), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11333), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [165939] = 14,
    ACTIONS(1001), 1,
      sym__string_start,
    ACTIONS(1003), 1,
      sym__command_start,
    ACTIONS(8538), 1,
      anon_sym_LBRACK,
    ACTIONS(8540), 1,
      anon_sym_LBRACE,
    ACTIONS(11820), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11822), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20191), 1,
      sym__word_identifier,
    ACTIONS(20193), 1,
      anon_sym_LPAREN,
    ACTIONS(20195), 1,
      sym_character_literal,
    STATE(4852), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16580), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16582), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6063), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [165999] = 14,
    ACTIONS(17120), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17122), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17138), 1,
      sym__string_start,
    ACTIONS(17140), 1,
      sym__command_start,
    ACTIONS(20197), 1,
      sym__word_identifier,
    ACTIONS(20199), 1,
      anon_sym_LPAREN,
    ACTIONS(20201), 1,
      anon_sym_LBRACK,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    ACTIONS(20205), 1,
      sym_character_literal,
    STATE(16241), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17118), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17124), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(17674), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166059] = 14,
    ACTIONS(469), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17206), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17220), 1,
      sym__string_start,
    ACTIONS(17222), 1,
      sym__command_start,
    ACTIONS(19680), 1,
      sym__word_identifier,
    ACTIONS(19682), 1,
      anon_sym_LPAREN,
    ACTIONS(19684), 1,
      anon_sym_LBRACK,
    ACTIONS(19686), 1,
      anon_sym_LBRACE,
    ACTIONS(19688), 1,
      sym_character_literal,
    STATE(6525), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6320), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(6322), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6913), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166119] = 14,
    ACTIONS(877), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17252), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17266), 1,
      sym__string_start,
    ACTIONS(17268), 1,
      sym__command_start,
    ACTIONS(19761), 1,
      sym__word_identifier,
    ACTIONS(19763), 1,
      anon_sym_LPAREN,
    ACTIONS(19765), 1,
      anon_sym_LBRACK,
    ACTIONS(19767), 1,
      anon_sym_LBRACE,
    ACTIONS(19769), 1,
      sym_character_literal,
    STATE(6805), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(875), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(881), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7577), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166179] = 14,
    ACTIONS(17428), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17430), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17446), 1,
      sym__string_start,
    ACTIONS(17448), 1,
      sym__command_start,
    ACTIONS(20013), 1,
      sym__word_identifier,
    ACTIONS(20015), 1,
      anon_sym_LPAREN,
    ACTIONS(20017), 1,
      anon_sym_LBRACK,
    ACTIONS(20019), 1,
      anon_sym_LBRACE,
    ACTIONS(20023), 1,
      sym_character_literal,
    STATE(6236), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17426), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17432), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6684), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166239] = 14,
    ACTIONS(17478), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17480), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17496), 1,
      sym__string_start,
    ACTIONS(17498), 1,
      sym__command_start,
    ACTIONS(20083), 1,
      sym__word_identifier,
    ACTIONS(20085), 1,
      anon_sym_LPAREN,
    ACTIONS(20087), 1,
      anon_sym_LBRACK,
    ACTIONS(20089), 1,
      anon_sym_LBRACE,
    ACTIONS(20093), 1,
      sym_character_literal,
    STATE(6585), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17476), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17482), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6904), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166299] = 14,
    ACTIONS(15928), 1,
      anon_sym_LPAREN,
    ACTIONS(15930), 1,
      anon_sym_LBRACK,
    ACTIONS(15932), 1,
      anon_sym_LBRACE,
    ACTIONS(15940), 1,
      sym__string_start,
    ACTIONS(15942), 1,
      sym__command_start,
    ACTIONS(17354), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17356), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20207), 1,
      sym__word_identifier,
    ACTIONS(20209), 1,
      sym_character_literal,
    STATE(4476), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17352), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17358), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5396), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166359] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13495), 1,
      anon_sym_LF,
    ACTIONS(13493), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [166399] = 14,
    ACTIONS(673), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16510), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16524), 1,
      sym__string_start,
    ACTIONS(16526), 1,
      sym__command_start,
    ACTIONS(19883), 1,
      sym__word_identifier,
    ACTIONS(19885), 1,
      anon_sym_LPAREN,
    ACTIONS(19887), 1,
      anon_sym_LBRACK,
    ACTIONS(19889), 1,
      anon_sym_LBRACE,
    ACTIONS(19891), 1,
      sym_character_literal,
    STATE(6735), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8728), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8730), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7654), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166459] = 14,
    ACTIONS(16014), 1,
      anon_sym_LPAREN,
    ACTIONS(16016), 1,
      anon_sym_LBRACK,
    ACTIONS(16018), 1,
      anon_sym_LBRACE,
    ACTIONS(16026), 1,
      sym__string_start,
    ACTIONS(16028), 1,
      sym__command_start,
    ACTIONS(16220), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16222), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20211), 1,
      sym__word_identifier,
    ACTIONS(20213), 1,
      sym_character_literal,
    STATE(10406), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16218), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16224), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10987), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166519] = 14,
    ACTIONS(983), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(985), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17004), 1,
      sym__string_start,
    ACTIONS(17006), 1,
      sym__command_start,
    ACTIONS(20215), 1,
      sym__word_identifier,
    ACTIONS(20217), 1,
      anon_sym_LPAREN,
    ACTIONS(20219), 1,
      anon_sym_LBRACK,
    ACTIONS(20221), 1,
      anon_sym_LBRACE,
    ACTIONS(20223), 1,
      sym_character_literal,
    STATE(7108), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8548), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8550), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8596), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166579] = 14,
    ACTIONS(16942), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16960), 1,
      sym__string_start,
    ACTIONS(16962), 1,
      sym__command_start,
    ACTIONS(20225), 1,
      sym__word_identifier,
    ACTIONS(20227), 1,
      anon_sym_LPAREN,
    ACTIONS(20229), 1,
      anon_sym_LBRACK,
    ACTIONS(20231), 1,
      anon_sym_LBRACE,
    ACTIONS(20233), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20235), 1,
      sym_character_literal,
    STATE(6838), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16940), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16946), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8035), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166639] = 14,
    ACTIONS(16054), 1,
      anon_sym_LPAREN,
    ACTIONS(16056), 1,
      anon_sym_LBRACK,
    ACTIONS(16058), 1,
      anon_sym_LBRACE,
    ACTIONS(16066), 1,
      sym__string_start,
    ACTIONS(16068), 1,
      sym__command_start,
    ACTIONS(16616), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16618), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20237), 1,
      sym__word_identifier,
    ACTIONS(20239), 1,
      sym_character_literal,
    STATE(5419), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16614), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16620), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6573), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166699] = 14,
    ACTIONS(289), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16704), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16718), 1,
      sym__string_start,
    ACTIONS(16720), 1,
      sym__command_start,
    ACTIONS(20003), 1,
      sym__word_identifier,
    ACTIONS(20005), 1,
      anon_sym_LPAREN,
    ACTIONS(20007), 1,
      anon_sym_LBRACK,
    ACTIONS(20009), 1,
      anon_sym_LBRACE,
    ACTIONS(20011), 1,
      sym_character_literal,
    STATE(6482), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8750), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8752), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6874), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166759] = 14,
    ACTIONS(749), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16416), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16430), 1,
      sym__string_start,
    ACTIONS(16432), 1,
      sym__command_start,
    ACTIONS(20073), 1,
      sym__word_identifier,
    ACTIONS(20075), 1,
      anon_sym_LPAREN,
    ACTIONS(20077), 1,
      anon_sym_LBRACK,
    ACTIONS(20079), 1,
      anon_sym_LBRACE,
    ACTIONS(20081), 1,
      sym_character_literal,
    STATE(6837), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8770), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8772), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7789), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166819] = 14,
    ACTIONS(16534), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16536), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16552), 1,
      sym__string_start,
    ACTIONS(16554), 1,
      sym__command_start,
    ACTIONS(20163), 1,
      sym__word_identifier,
    ACTIONS(20165), 1,
      anon_sym_LPAREN,
    ACTIONS(20167), 1,
      anon_sym_LBRACK,
    ACTIONS(20169), 1,
      anon_sym_LBRACE,
    ACTIONS(20173), 1,
      sym_character_literal,
    STATE(6623), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16532), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16538), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7228), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166879] = 14,
    ACTIONS(16350), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16352), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16368), 1,
      sym__string_start,
    ACTIONS(16370), 1,
      sym__command_start,
    ACTIONS(20175), 1,
      sym__word_identifier,
    ACTIONS(20177), 1,
      anon_sym_LPAREN,
    ACTIONS(20179), 1,
      anon_sym_LBRACK,
    ACTIONS(20181), 1,
      anon_sym_LBRACE,
    ACTIONS(20185), 1,
      sym_character_literal,
    STATE(11392), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16348), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16354), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11642), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166939] = 14,
    ACTIONS(15644), 1,
      anon_sym_LPAREN,
    ACTIONS(15646), 1,
      anon_sym_LBRACK,
    ACTIONS(15648), 1,
      anon_sym_LBRACE,
    ACTIONS(15656), 1,
      sym__string_start,
    ACTIONS(15658), 1,
      sym__command_start,
    ACTIONS(17324), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(17326), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20241), 1,
      sym__word_identifier,
    ACTIONS(20243), 1,
      sym_character_literal,
    STATE(4869), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17322), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17328), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6121), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [166999] = 14,
    ACTIONS(591), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16830), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16844), 1,
      sym__string_start,
    ACTIONS(16846), 1,
      sym__command_start,
    ACTIONS(20153), 1,
      sym__word_identifier,
    ACTIONS(20155), 1,
      anon_sym_LPAREN,
    ACTIONS(20157), 1,
      anon_sym_LBRACK,
    ACTIONS(20159), 1,
      anon_sym_LBRACE,
    ACTIONS(20161), 1,
      sym_character_literal,
    STATE(6754), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8794), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8796), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7942), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [167059] = 14,
    ACTIONS(16942), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16944), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16960), 1,
      sym__string_start,
    ACTIONS(16962), 1,
      sym__command_start,
    ACTIONS(20225), 1,
      sym__word_identifier,
    ACTIONS(20227), 1,
      anon_sym_LPAREN,
    ACTIONS(20229), 1,
      anon_sym_LBRACK,
    ACTIONS(20231), 1,
      anon_sym_LBRACE,
    ACTIONS(20235), 1,
      sym_character_literal,
    STATE(6838), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16940), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16946), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8035), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [167119] = 14,
    ACTIONS(983), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(17004), 1,
      sym__string_start,
    ACTIONS(17006), 1,
      sym__command_start,
    ACTIONS(20215), 1,
      sym__word_identifier,
    ACTIONS(20217), 1,
      anon_sym_LPAREN,
    ACTIONS(20219), 1,
      anon_sym_LBRACK,
    ACTIONS(20221), 1,
      anon_sym_LBRACE,
    ACTIONS(20223), 1,
      sym_character_literal,
    STATE(7108), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8548), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(8550), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8596), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [167179] = 27,
    ACTIONS(8052), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20245), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16055), 1,
      sym__comprehension_clause,
    STATE(16269), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [167265] = 27,
    ACTIONS(9012), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20247), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16307), 1,
      sym__comprehension_clause,
    STATE(16308), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [167351] = 27,
    ACTIONS(9174), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20249), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15552), 1,
      sym__comprehension_clause,
    STATE(15556), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [167437] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13501), 1,
      anon_sym_LF,
    ACTIONS(13499), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [167477] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17524), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [167519] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(13806), 1,
      anon_sym_COMMA,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13255), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [167599] = 14,
    ACTIONS(1087), 1,
      sym__string_start,
    ACTIONS(1089), 1,
      sym__command_start,
    ACTIONS(8684), 1,
      anon_sym_LBRACK,
    ACTIONS(8686), 1,
      anon_sym_LBRACE,
    ACTIONS(11838), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11840), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20251), 1,
      sym__word_identifier,
    ACTIONS(20253), 1,
      anon_sym_LPAREN,
    ACTIONS(20255), 1,
      sym_character_literal,
    STATE(4609), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16394), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16396), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6006), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [167659] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [167701] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13508), 1,
      anon_sym_LF,
    ACTIONS(13506), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [167741] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13512), 1,
      anon_sym_LF,
    ACTIONS(13510), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [167781] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13516), 1,
      anon_sym_LF,
    ACTIONS(13514), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [167821] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(19263), 1,
      anon_sym_QMARK,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13070), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [167897] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13520), 1,
      anon_sym_LF,
    ACTIONS(13518), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [167937] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13259), 1,
      anon_sym_LF,
    ACTIONS(13257), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [167977] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13524), 1,
      anon_sym_LF,
    ACTIONS(13522), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168017] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13528), 1,
      anon_sym_LF,
    ACTIONS(13526), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168057] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13532), 1,
      anon_sym_LF,
    ACTIONS(13530), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168097] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13536), 1,
      anon_sym_LF,
    ACTIONS(13534), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168137] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13540), 1,
      anon_sym_LF,
    ACTIONS(13538), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168177] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13544), 1,
      anon_sym_LF,
    ACTIONS(13542), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168217] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13548), 1,
      anon_sym_LF,
    ACTIONS(13546), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168257] = 12,
    ACTIONS(18502), 1,
      sym__word_identifier,
    ACTIONS(18504), 1,
      aux_sym_import_path_token1,
    ACTIONS(18506), 1,
      anon_sym_LPAREN,
    ACTIONS(18508), 1,
      anon_sym_DOLLAR,
    ACTIONS(18510), 1,
      anon_sym_AT,
    STATE(6947), 1,
      sym_scoped_identifier,
    STATE(6953), 1,
      sym_identifier,
    STATE(8429), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7356), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16472), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16470), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [168313] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13552), 1,
      anon_sym_LF,
    ACTIONS(13550), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168353] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13556), 1,
      anon_sym_LF,
    ACTIONS(13554), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168393] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13560), 1,
      anon_sym_LF,
    ACTIONS(13558), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168433] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13564), 1,
      anon_sym_LF,
    ACTIONS(13562), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168473] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(13806), 1,
      anon_sym_COMMA,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 5,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      sym__pair_operator,
  [168551] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17508), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168593] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(13094), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168633] = 27,
    ACTIONS(8356), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20257), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16176), 1,
      sym__comprehension_clause,
    STATE(16468), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [168719] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(151), 1,
      anon_sym_DASH_GT,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [168761] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(13308), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [168805] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18865), 1,
      anon_sym_QMARK,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 6,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [168881] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18654), 1,
      anon_sym_EQ,
    ACTIONS(13239), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [168923] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18654), 1,
      anon_sym_EQ,
    ACTIONS(13243), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [168965] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18654), 1,
      anon_sym_EQ,
    ACTIONS(12926), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [169007] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18520), 1,
      anon_sym_EQ,
    ACTIONS(13239), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169049] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18520), 1,
      anon_sym_EQ,
    ACTIONS(13243), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169091] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18520), 1,
      anon_sym_EQ,
    ACTIONS(12926), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169133] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17518), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [169175] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18468), 1,
      anon_sym_EQ,
    ACTIONS(13249), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169217] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18520), 1,
      anon_sym_EQ,
    ACTIONS(13249), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169259] = 27,
    ACTIONS(9054), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20259), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16503), 1,
      sym__comprehension_clause,
    STATE(16504), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [169345] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13568), 1,
      anon_sym_LF,
    ACTIONS(13566), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169385] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13572), 1,
      anon_sym_LF,
    ACTIONS(13570), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169425] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13576), 1,
      anon_sym_LF,
    ACTIONS(13574), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169465] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13580), 1,
      anon_sym_LF,
    ACTIONS(13578), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169505] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13584), 1,
      anon_sym_LF,
    ACTIONS(13582), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169545] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [169585] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13588), 1,
      anon_sym_LF,
    ACTIONS(13586), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169625] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11903), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [169685] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13592), 1,
      anon_sym_LF,
    ACTIONS(13590), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169725] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13596), 1,
      anon_sym_LF,
    ACTIONS(13594), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169765] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17570), 1,
      anon_sym_DASH_GT,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169809] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13600), 1,
      anon_sym_LF,
    ACTIONS(13598), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169849] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169893] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13604), 1,
      anon_sym_LF,
    ACTIONS(13602), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169933] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13608), 1,
      anon_sym_LF,
    ACTIONS(13606), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [169973] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13622), 1,
      anon_sym_LF,
    ACTIONS(13620), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [170013] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13626), 1,
      anon_sym_LF,
    ACTIONS(13624), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [170053] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13630), 1,
      anon_sym_LF,
    ACTIONS(13628), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [170093] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13634), 1,
      anon_sym_LF,
    ACTIONS(13632), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [170133] = 14,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    ACTIONS(15888), 1,
      anon_sym_LPAREN,
    ACTIONS(16918), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16920), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19771), 1,
      sym__word_identifier,
    ACTIONS(19773), 1,
      sym_character_literal,
    STATE(14443), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16916), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16922), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(14376), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170193] = 14,
    ACTIONS(2904), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      anon_sym_LBRACE,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(15280), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15282), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(19919), 1,
      anon_sym_LPAREN,
    ACTIONS(19921), 1,
      sym_character_literal,
    STATE(10639), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15278), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15284), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10382), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170253] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11745), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170313] = 14,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(20265), 1,
      sym_character_literal,
    STATE(11241), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10128), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170373] = 14,
    ACTIONS(19426), 1,
      sym__word_identifier,
    ACTIONS(19428), 1,
      anon_sym_LPAREN,
    ACTIONS(19430), 1,
      anon_sym_LBRACK,
    ACTIONS(19432), 1,
      anon_sym_LBRACE,
    ACTIONS(19436), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(19438), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19442), 1,
      sym_character_literal,
    ACTIONS(19444), 1,
      sym__string_start,
    ACTIONS(19446), 1,
      sym__command_start,
    STATE(14449), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19434), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(19440), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(14523), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170433] = 14,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    ACTIONS(19454), 1,
      sym__word_identifier,
    ACTIONS(19456), 1,
      anon_sym_LPAREN,
    ACTIONS(19458), 1,
      anon_sym_LBRACK,
    ACTIONS(19460), 1,
      anon_sym_LBRACE,
    ACTIONS(19462), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19464), 1,
      sym_character_literal,
    STATE(11383), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11546), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170493] = 14,
    ACTIONS(13288), 1,
      anon_sym_LPAREN,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(16198), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16200), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19491), 1,
      sym__word_identifier,
    ACTIONS(19493), 1,
      sym_character_literal,
    STATE(11243), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16196), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16202), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11179), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170553] = 14,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(19722), 1,
      sym_character_literal,
    STATE(11068), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10054), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170613] = 14,
    ACTIONS(15870), 1,
      anon_sym_LPAREN,
    ACTIONS(15872), 1,
      anon_sym_LBRACK,
    ACTIONS(15874), 1,
      anon_sym_LBRACE,
    ACTIONS(15882), 1,
      sym__string_start,
    ACTIONS(15884), 1,
      sym__command_start,
    ACTIONS(16242), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16244), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19751), 1,
      sym__word_identifier,
    ACTIONS(19753), 1,
      sym_character_literal,
    STATE(11069), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16240), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16246), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10532), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170673] = 14,
    ACTIONS(16322), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16340), 1,
      sym__string_start,
    ACTIONS(16342), 1,
      sym__command_start,
    ACTIONS(19813), 1,
      sym__word_identifier,
    ACTIONS(19815), 1,
      anon_sym_LPAREN,
    ACTIONS(19817), 1,
      anon_sym_LBRACK,
    ACTIONS(19819), 1,
      anon_sym_LBRACE,
    ACTIONS(19821), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19823), 1,
      sym_character_literal,
    STATE(11393), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16320), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16326), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11625), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170733] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13638), 1,
      anon_sym_LF,
    ACTIONS(13636), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [170773] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11903), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170833] = 14,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16296), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    ACTIONS(19454), 1,
      sym__word_identifier,
    ACTIONS(19456), 1,
      anon_sym_LPAREN,
    ACTIONS(19458), 1,
      anon_sym_LBRACK,
    ACTIONS(19460), 1,
      anon_sym_LBRACE,
    ACTIONS(19464), 1,
      sym_character_literal,
    STATE(11444), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11546), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170893] = 14,
    ACTIONS(16322), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16324), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16340), 1,
      sym__string_start,
    ACTIONS(16342), 1,
      sym__command_start,
    ACTIONS(19813), 1,
      sym__word_identifier,
    ACTIONS(19815), 1,
      anon_sym_LPAREN,
    ACTIONS(19817), 1,
      anon_sym_LBRACK,
    ACTIONS(19819), 1,
      anon_sym_LBRACE,
    ACTIONS(19823), 1,
      sym_character_literal,
    STATE(11440), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16320), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16326), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11625), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [170953] = 14,
    ACTIONS(16350), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16368), 1,
      sym__string_start,
    ACTIONS(16370), 1,
      sym__command_start,
    ACTIONS(20175), 1,
      sym__word_identifier,
    ACTIONS(20177), 1,
      anon_sym_LPAREN,
    ACTIONS(20179), 1,
      anon_sym_LBRACK,
    ACTIONS(20181), 1,
      anon_sym_LBRACE,
    ACTIONS(20183), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20185), 1,
      sym_character_literal,
    STATE(11392), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16348), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16354), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11642), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [171013] = 14,
    ACTIONS(16350), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16352), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16368), 1,
      sym__string_start,
    ACTIONS(16370), 1,
      sym__command_start,
    ACTIONS(20175), 1,
      sym__word_identifier,
    ACTIONS(20177), 1,
      anon_sym_LPAREN,
    ACTIONS(20179), 1,
      anon_sym_LBRACK,
    ACTIONS(20181), 1,
      anon_sym_LBRACE,
    ACTIONS(20185), 1,
      sym_character_literal,
    STATE(11472), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16348), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16354), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11642), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [171073] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13642), 1,
      anon_sym_LF,
    ACTIONS(13640), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [171113] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13646), 1,
      anon_sym_LF,
    ACTIONS(13644), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [171153] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13650), 1,
      anon_sym_LF,
    ACTIONS(13648), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [171193] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(13249), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [171235] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13654), 1,
      anon_sym_LF,
    ACTIONS(13652), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [171275] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13658), 1,
      anon_sym_LF,
    ACTIONS(13656), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [171315] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13662), 1,
      anon_sym_LF,
    ACTIONS(13660), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [171355] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13666), 1,
      anon_sym_LF,
    ACTIONS(13664), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [171395] = 12,
    ACTIONS(18598), 1,
      sym__word_identifier,
    ACTIONS(18600), 1,
      aux_sym_import_path_token1,
    ACTIONS(18602), 1,
      anon_sym_LPAREN,
    ACTIONS(18604), 1,
      anon_sym_DOLLAR,
    ACTIONS(18606), 1,
      anon_sym_AT,
    STATE(6769), 1,
      sym_scoped_identifier,
    STATE(6771), 1,
      sym_identifier,
    STATE(7464), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7037), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17438), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17436), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [171451] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11885), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [171511] = 14,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(20265), 1,
      sym_character_literal,
    STATE(10954), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10128), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [171571] = 14,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    ACTIONS(19454), 1,
      sym__word_identifier,
    ACTIONS(19456), 1,
      anon_sym_LPAREN,
    ACTIONS(19458), 1,
      anon_sym_LBRACK,
    ACTIONS(19460), 1,
      anon_sym_LBRACE,
    ACTIONS(19462), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19464), 1,
      sym_character_literal,
    STATE(11892), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11546), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [171631] = 14,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(19722), 1,
      sym_character_literal,
    STATE(10788), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10054), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [171691] = 27,
    ACTIONS(8872), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20267), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15465), 1,
      sym__comprehension_clause,
    STATE(16557), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [171777] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(13249), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [171819] = 27,
    ACTIONS(8306), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20269), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16334), 1,
      sym__comprehension_clause,
    STATE(16589), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [171905] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11638), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [171965] = 14,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(20265), 1,
      sym_character_literal,
    STATE(10819), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10128), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172025] = 14,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    ACTIONS(19454), 1,
      sym__word_identifier,
    ACTIONS(19456), 1,
      anon_sym_LPAREN,
    ACTIONS(19458), 1,
      anon_sym_LBRACK,
    ACTIONS(19460), 1,
      anon_sym_LBRACE,
    ACTIONS(19462), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19464), 1,
      sym_character_literal,
    STATE(11640), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11546), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172085] = 14,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(19722), 1,
      sym_character_literal,
    STATE(10473), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10054), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172145] = 27,
    ACTIONS(9096), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20271), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16642), 1,
      sym__comprehension_clause,
    STATE(16643), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [172231] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11652), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172291] = 14,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(20265), 1,
      sym_character_literal,
    STATE(11013), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10128), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172351] = 14,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(19722), 1,
      sym_character_literal,
    STATE(10831), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10054), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172411] = 14,
    ACTIONS(487), 1,
      sym__string_start,
    ACTIONS(489), 1,
      sym__command_start,
    ACTIONS(6310), 1,
      anon_sym_LBRACK,
    ACTIONS(6314), 1,
      anon_sym_LBRACE,
    ACTIONS(11688), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(11690), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20273), 1,
      sym__word_identifier,
    ACTIONS(20275), 1,
      anon_sym_LPAREN,
    ACTIONS(20277), 1,
      sym_character_literal,
    STATE(4306), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17342), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(17344), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4684), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172471] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17566), 1,
      anon_sym_DASH_GT,
    ACTIONS(17882), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [172515] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17882), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [172559] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11548), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172619] = 14,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(20265), 1,
      sym_character_literal,
    STATE(11028), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10128), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172679] = 14,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(19722), 1,
      sym_character_literal,
    STATE(10841), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10054), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172739] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(13239), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [172781] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(13243), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [172823] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(12926), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [172865] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11451), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172925] = 14,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(20265), 1,
      sym_character_literal,
    STATE(10851), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10128), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [172985] = 14,
    ACTIONS(15532), 1,
      anon_sym_LPAREN,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16154), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16156), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(19722), 1,
      sym_character_literal,
    STATE(10488), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16152), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16158), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10054), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [173045] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(11397), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [173085] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11400), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [173145] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11697), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [173205] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11468), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [173265] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11713), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [173325] = 12,
    ACTIONS(18414), 1,
      sym__word_identifier,
    ACTIONS(18416), 1,
      aux_sym_import_path_token1,
    ACTIONS(18418), 1,
      anon_sym_LPAREN,
    ACTIONS(18420), 1,
      anon_sym_DOLLAR,
    ACTIONS(18422), 1,
      anon_sym_AT,
    STATE(6931), 1,
      sym_scoped_identifier,
    STATE(6934), 1,
      sym_identifier,
    STATE(8528), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7570), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(17488), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17486), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [173381] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11476), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [173441] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13318), 1,
      anon_sym_LF,
    ACTIONS(13316), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [173481] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13322), 1,
      anon_sym_LF,
    ACTIONS(13320), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [173521] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11478), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [173581] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    ACTIONS(20261), 1,
      aux_sym_integer_literal_token4,
    STATE(11437), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [173641] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18865), 1,
      anon_sym_QMARK,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    STATE(12164), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [173721] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(13239), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [173761] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18948), 1,
      anon_sym_COMMA,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    STATE(11965), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13239), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [173841] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13328), 1,
      anon_sym_LF,
    ACTIONS(13326), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [173881] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(13243), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [173921] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(13249), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [173961] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18948), 1,
      anon_sym_COMMA,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    STATE(11965), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13243), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [174041] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(12926), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [174081] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19292), 1,
      sym__pair_operator,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13255), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [174159] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18948), 1,
      anon_sym_COMMA,
    ACTIONS(19217), 1,
      anon_sym_where,
    ACTIONS(19219), 1,
      anon_sym_COLON2,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19229), 1,
      sym__pair_operator,
    ACTIONS(19231), 1,
      sym__arrow_operator,
    ACTIONS(19233), 1,
      sym__lazy_or_operator,
    ACTIONS(19235), 1,
      sym__lazy_and_operator,
    ACTIONS(19237), 1,
      sym__pipe_right_operator,
    ACTIONS(19239), 1,
      sym__pipe_left_operator,
    ACTIONS(19241), 1,
      sym__ellipsis_operator,
    ACTIONS(19245), 1,
      sym__times_operator,
    ACTIONS(19247), 1,
      sym__rational_operator,
    ACTIONS(19249), 1,
      sym__bitshift_operator,
    ACTIONS(19251), 1,
      sym__power_operator,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    STATE(11965), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19243), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12926), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(19221), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [174239] = 27,
    ACTIONS(8090), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20279), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(15669), 1,
      aux_sym_argument_list_repeat1,
    STATE(16518), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [174325] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17576), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [174367] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13332), 1,
      anon_sym_LF,
    ACTIONS(13330), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [174407] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(19478), 1,
      anon_sym_LPAREN,
    ACTIONS(19480), 1,
      sym_character_literal,
    STATE(10614), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9939), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [174467] = 27,
    ACTIONS(9134), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20281), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16314), 1,
      sym__comprehension_clause,
    STATE(16320), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [174553] = 12,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18548), 1,
      aux_sym_import_path_token1,
    ACTIONS(18550), 1,
      anon_sym_DOLLAR,
    ACTIONS(18552), 1,
      anon_sym_AT,
    STATE(10781), 1,
      sym_import_alias,
    STATE(12883), 1,
      sym_scoped_identifier,
    STATE(12884), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(13006), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [174609] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(20283), 1,
      anon_sym_COMMA,
    ACTIONS(20285), 1,
      anon_sym_as,
    STATE(13003), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [174655] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19134), 1,
      anon_sym_QMARK,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13255), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [174733] = 14,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    ACTIONS(16438), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16440), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(20265), 1,
      sym_character_literal,
    STATE(11319), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16436), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16442), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10128), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [174793] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19134), 1,
      anon_sym_QMARK,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    STATE(11924), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [174873] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(20287), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13255), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [174951] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(20287), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [175027] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17566), 1,
      anon_sym_DASH_GT,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [175071] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [175115] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19472), 1,
      anon_sym_DOT,
    ACTIONS(12676), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12678), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [175157] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(13239), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [175199] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(13243), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [175241] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(12926), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [175283] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18853), 1,
      anon_sym_where,
    ACTIONS(18855), 1,
      anon_sym_COLON2,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18867), 1,
      sym__pair_operator,
    ACTIONS(18869), 1,
      sym__arrow_operator,
    ACTIONS(18871), 1,
      sym__lazy_or_operator,
    ACTIONS(18873), 1,
      sym__lazy_and_operator,
    ACTIONS(18875), 1,
      sym__pipe_right_operator,
    ACTIONS(18877), 1,
      sym__pipe_left_operator,
    ACTIONS(18879), 1,
      sym__ellipsis_operator,
    ACTIONS(18883), 1,
      sym__times_operator,
    ACTIONS(18885), 1,
      sym__rational_operator,
    ACTIONS(18887), 1,
      sym__bitshift_operator,
    ACTIONS(18889), 1,
      sym__power_operator,
    ACTIONS(19263), 1,
      anon_sym_QMARK,
    ACTIONS(18881), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18859), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13338), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [175359] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13348), 1,
      anon_sym_LF,
    ACTIONS(13346), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [175399] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(20289), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13255), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
  [175477] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(20289), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [175553] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20291), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13255), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [175631] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20291), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [175707] = 12,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(18626), 1,
      aux_sym_import_path_token1,
    ACTIONS(18628), 1,
      anon_sym_DOLLAR,
    ACTIONS(18630), 1,
      anon_sym_AT,
    STATE(11946), 1,
      sym_import_alias,
    STATE(12887), 1,
      sym_scoped_identifier,
    STATE(12888), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(13149), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16304), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [175763] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19282), 1,
      anon_sym_where,
    ACTIONS(19284), 1,
      anon_sym_COLON2,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19294), 1,
      sym__arrow_operator,
    ACTIONS(19296), 1,
      sym__lazy_or_operator,
    ACTIONS(19298), 1,
      sym__lazy_and_operator,
    ACTIONS(19300), 1,
      sym__pipe_right_operator,
    ACTIONS(19302), 1,
      sym__pipe_left_operator,
    ACTIONS(19304), 1,
      sym__ellipsis_operator,
    ACTIONS(19308), 1,
      sym__times_operator,
    ACTIONS(19310), 1,
      sym__rational_operator,
    ACTIONS(19312), 1,
      sym__bitshift_operator,
    ACTIONS(19314), 1,
      sym__power_operator,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19306), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19286), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      sym__pair_operator,
  [175839] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(20287), 1,
      anon_sym_QMARK,
    STATE(12307), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [175919] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(20289), 1,
      anon_sym_QMARK,
    STATE(12316), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [175999] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20291), 1,
      anon_sym_QMARK,
    STATE(12460), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176079] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(20287), 1,
      anon_sym_QMARK,
    STATE(12307), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13239), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176159] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(20287), 1,
      anon_sym_QMARK,
    STATE(12307), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13243), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176239] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(20287), 1,
      anon_sym_QMARK,
    STATE(12307), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12926), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176319] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(20289), 1,
      anon_sym_QMARK,
    STATE(12316), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13239), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176399] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(20289), 1,
      anon_sym_QMARK,
    STATE(12316), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13243), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176479] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(20289), 1,
      anon_sym_QMARK,
    STATE(12316), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12926), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176559] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20291), 1,
      anon_sym_QMARK,
    STATE(12460), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13239), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176639] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20291), 1,
      anon_sym_QMARK,
    STATE(12460), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13243), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176719] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20291), 1,
      anon_sym_QMARK,
    STATE(12460), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12926), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176799] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11638), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [176859] = 14,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16296), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    ACTIONS(19454), 1,
      sym__word_identifier,
    ACTIONS(19456), 1,
      anon_sym_LPAREN,
    ACTIONS(19458), 1,
      anon_sym_LBRACK,
    ACTIONS(19460), 1,
      anon_sym_LBRACE,
    ACTIONS(19464), 1,
      sym_character_literal,
    STATE(11640), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11546), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [176919] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(19478), 1,
      anon_sym_LPAREN,
    ACTIONS(19480), 1,
      sym_character_literal,
    STATE(10456), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9939), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [176979] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13064), 1,
      anon_sym_LF,
    ACTIONS(20293), 1,
      anon_sym_COMMA,
    STATE(12846), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13060), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [177023] = 12,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18632), 1,
      aux_sym_import_path_token1,
    ACTIONS(18634), 1,
      anon_sym_DOLLAR,
    ACTIONS(18636), 1,
      anon_sym_AT,
    STATE(10781), 1,
      sym_import_alias,
    STATE(12214), 1,
      sym_scoped_identifier,
    STATE(12215), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12847), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [177079] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13068), 1,
      anon_sym_LF,
    ACTIONS(19338), 1,
      anon_sym_COMMA,
    STATE(12848), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(13066), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [177123] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12972), 1,
      anon_sym_LF,
    ACTIONS(20295), 1,
      anon_sym_COMMA,
    STATE(12846), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(12974), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [177167] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(19340), 1,
      anon_sym_as,
    ACTIONS(12981), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [177209] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(20298), 1,
      anon_sym_COMMA,
    STATE(12848), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12981), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [177253] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11548), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [177313] = 14,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16296), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16312), 1,
      sym__string_start,
    ACTIONS(16314), 1,
      sym__command_start,
    ACTIONS(19454), 1,
      sym__word_identifier,
    ACTIONS(19456), 1,
      anon_sym_LPAREN,
    ACTIONS(19458), 1,
      anon_sym_LBRACK,
    ACTIONS(19460), 1,
      anon_sym_LBRACE,
    ACTIONS(19464), 1,
      sym_character_literal,
    STATE(11892), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11546), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [177373] = 12,
    ACTIONS(18538), 1,
      sym__word_identifier,
    ACTIONS(18540), 1,
      aux_sym_import_path_token1,
    ACTIONS(18542), 1,
      anon_sym_LPAREN,
    ACTIONS(18544), 1,
      anon_sym_DOLLAR,
    ACTIONS(18546), 1,
      anon_sym_AT,
    STATE(6933), 1,
      sym_scoped_identifier,
    STATE(6946), 1,
      sym_identifier,
    STATE(8205), 1,
      sym_import_alias,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7641), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16544), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16542), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [177429] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(19478), 1,
      anon_sym_LPAREN,
    ACTIONS(19480), 1,
      sym_character_literal,
    STATE(10290), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9939), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [177489] = 12,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18638), 1,
      aux_sym_import_path_token1,
    ACTIONS(18640), 1,
      anon_sym_DOLLAR,
    ACTIONS(18642), 1,
      anon_sym_AT,
    STATE(10781), 1,
      sym_import_alias,
    STATE(11849), 1,
      sym_scoped_identifier,
    STATE(11850), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12179), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [177545] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13306), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [177587] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11885), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [177647] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(19478), 1,
      anon_sym_LPAREN,
    ACTIONS(19480), 1,
      sym_character_literal,
    STATE(10479), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9939), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [177707] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13064), 1,
      anon_sym_LF,
    ACTIONS(20301), 1,
      anon_sym_COMMA,
    STATE(12860), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13060), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [177751] = 12,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18648), 1,
      aux_sym_import_path_token1,
    ACTIONS(18650), 1,
      anon_sym_DOLLAR,
    ACTIONS(18652), 1,
      anon_sym_AT,
    STATE(10781), 1,
      sym_import_alias,
    STATE(12224), 1,
      sym_scoped_identifier,
    STATE(12225), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12861), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [177807] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13068), 1,
      anon_sym_LF,
    ACTIONS(19362), 1,
      anon_sym_COMMA,
    STATE(12862), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(13066), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [177851] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12972), 1,
      anon_sym_LF,
    ACTIONS(20303), 1,
      anon_sym_COMMA,
    STATE(12860), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(12974), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [177895] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(19364), 1,
      anon_sym_as,
    ACTIONS(12981), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [177937] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(20306), 1,
      anon_sym_COMMA,
    STATE(12862), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12981), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [177981] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11400), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [178041] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(19478), 1,
      anon_sym_LPAREN,
    ACTIONS(19480), 1,
      sym_character_literal,
    STATE(10483), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9939), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [178101] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13064), 1,
      anon_sym_LF,
    ACTIONS(20309), 1,
      anon_sym_COMMA,
    STATE(12868), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13060), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [178145] = 12,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18656), 1,
      aux_sym_import_path_token1,
    ACTIONS(18658), 1,
      anon_sym_DOLLAR,
    ACTIONS(18660), 1,
      anon_sym_AT,
    STATE(10781), 1,
      sym_import_alias,
    STATE(12229), 1,
      sym_scoped_identifier,
    STATE(12230), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12869), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [178201] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13068), 1,
      anon_sym_LF,
    ACTIONS(19368), 1,
      anon_sym_COMMA,
    STATE(12870), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(13066), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [178245] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12972), 1,
      anon_sym_LF,
    ACTIONS(20311), 1,
      anon_sym_COMMA,
    STATE(12868), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(12974), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [178289] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(19370), 1,
      anon_sym_as,
    ACTIONS(12981), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [178331] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(20314), 1,
      anon_sym_COMMA,
    STATE(12870), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12981), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [178375] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11468), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [178435] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(15320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(19478), 1,
      anon_sym_LPAREN,
    ACTIONS(19480), 1,
      sym_character_literal,
    STATE(10295), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16402), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9939), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [178495] = 12,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(18674), 1,
      aux_sym_import_path_token1,
    ACTIONS(18676), 1,
      anon_sym_DOLLAR,
    ACTIONS(18678), 1,
      anon_sym_AT,
    STATE(10781), 1,
      sym_import_alias,
    STATE(11853), 1,
      sym_scoped_identifier,
    STATE(11854), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12207), 6,
      sym_import_path,
      sym__exportable,
      sym__importable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [178551] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13306), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [178593] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11652), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [178653] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11451), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [178713] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11697), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [178773] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11476), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [178833] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11713), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [178893] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11437), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [178953] = 14,
    ACTIONS(16266), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16284), 1,
      sym__string_start,
    ACTIONS(16286), 1,
      sym__command_start,
    ACTIONS(19977), 1,
      sym__word_identifier,
    ACTIONS(19979), 1,
      anon_sym_LPAREN,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    ACTIONS(19985), 1,
      sym_character_literal,
    STATE(11478), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16264), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(16270), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10301), 14,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [179013] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(20283), 1,
      anon_sym_COMMA,
    ACTIONS(20285), 1,
      anon_sym_as,
    ACTIONS(20317), 1,
      anon_sym_COLON2,
    STATE(13003), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 24,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179061] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12884), 1,
      anon_sym_LF,
    ACTIONS(20319), 1,
      anon_sym_DOT,
    ACTIONS(12882), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179103] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12888), 1,
      anon_sym_LF,
    ACTIONS(20319), 1,
      anon_sym_DOT,
    ACTIONS(12886), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179145] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12848), 1,
      anon_sym_LF,
    ACTIONS(20319), 1,
      anon_sym_DOT,
    ACTIONS(12846), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179187] = 7,
    ACTIONS(20321), 1,
      anon_sym_COMMA,
    ACTIONS(20323), 1,
      anon_sym_as,
    ACTIONS(20325), 1,
      anon_sym_COLON2,
    STATE(13147), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12862), 6,
      anon_sym_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12868), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [179233] = 4,
    ACTIONS(20327), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12882), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12884), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [179273] = 4,
    ACTIONS(20327), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12886), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12888), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [179313] = 4,
    ACTIONS(20327), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12846), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12848), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [179353] = 6,
    ACTIONS(20321), 1,
      anon_sym_COMMA,
    ACTIONS(20323), 1,
      anon_sym_as,
    STATE(13147), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12862), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12868), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [179397] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13146), 1,
      anon_sym_LF,
    ACTIONS(20293), 1,
      anon_sym_COMMA,
    STATE(12843), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13144), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179441] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(19338), 1,
      anon_sym_COMMA,
    STATE(12845), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 26,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179485] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(20319), 1,
      anon_sym_DOT,
    ACTIONS(12678), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_as,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179527] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(20329), 1,
      anon_sym_DOT,
    ACTIONS(12678), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179569] = 4,
    ACTIONS(20327), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12678), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12676), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [179609] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13146), 1,
      anon_sym_LF,
    ACTIONS(20301), 1,
      anon_sym_COMMA,
    STATE(12857), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13144), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179653] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(19362), 1,
      anon_sym_COMMA,
    STATE(12859), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179697] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13146), 1,
      anon_sym_LF,
    ACTIONS(20309), 1,
      anon_sym_COMMA,
    STATE(12865), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13144), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179741] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(19368), 1,
      anon_sym_COMMA,
    STATE(12867), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179785] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(19122), 1,
      anon_sym_where,
    ACTIONS(19124), 1,
      anon_sym_COLON2,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19136), 1,
      sym__pair_operator,
    ACTIONS(19138), 1,
      sym__arrow_operator,
    ACTIONS(19140), 1,
      sym__lazy_or_operator,
    ACTIONS(19142), 1,
      sym__lazy_and_operator,
    ACTIONS(19144), 1,
      sym__pipe_right_operator,
    ACTIONS(19146), 1,
      sym__pipe_left_operator,
    ACTIONS(19148), 1,
      sym__ellipsis_operator,
    ACTIONS(19152), 1,
      sym__times_operator,
    ACTIONS(19154), 1,
      sym__rational_operator,
    ACTIONS(19156), 1,
      sym__bitshift_operator,
    ACTIONS(19158), 1,
      sym__power_operator,
    ACTIONS(19261), 1,
      anon_sym_QMARK,
    ACTIONS(19150), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19128), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13338), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [179861] = 27,
    ACTIONS(8402), 1,
      anon_sym_RPAREN,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20331), 1,
      anon_sym_COMMA,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16284), 1,
      aux_sym_argument_list_repeat1,
    STATE(16373), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [179947] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(20333), 1,
      anon_sym_DOT,
    ACTIONS(12678), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [179989] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(20335), 1,
      anon_sym_DOT,
    ACTIONS(12678), 27,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [180031] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13435), 1,
      anon_sym_LF,
    ACTIONS(13433), 28,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [180071] = 23,
    ACTIONS(13094), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20339), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13100), 4,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [180148] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(20289), 1,
      anon_sym_QMARK,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13338), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
  [180223] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17940), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [180264] = 5,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    STATE(12941), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13150), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13148), 19,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [180305] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17538), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [180346] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(13239), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [180387] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(13243), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [180428] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(12926), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [180469] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(15079), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    ACTIONS(20341), 1,
      anon_sym_where,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20347), 1,
      sym__pair_operator,
    ACTIONS(20349), 1,
      sym__arrow_operator,
    ACTIONS(20351), 1,
      sym__lazy_or_operator,
    ACTIONS(20353), 1,
      sym__lazy_and_operator,
    ACTIONS(20355), 1,
      sym__pipe_right_operator,
    ACTIONS(20357), 1,
      sym__pipe_left_operator,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20345), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(15077), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [180544] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 17,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [180601] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20371), 1,
      anon_sym_DOT,
    ACTIONS(12676), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12678), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [180642] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20045), 1,
      anon_sym_QMARK,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    STATE(12460), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [180721] = 24,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16961), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(20373), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [180800] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [180861] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(13308), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [180904] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(15075), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    ACTIONS(20341), 1,
      anon_sym_where,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20347), 1,
      sym__pair_operator,
    ACTIONS(20349), 1,
      sym__arrow_operator,
    ACTIONS(20351), 1,
      sym__lazy_or_operator,
    ACTIONS(20353), 1,
      sym__lazy_and_operator,
    ACTIONS(20355), 1,
      sym__pipe_right_operator,
    ACTIONS(20357), 1,
      sym__pipe_left_operator,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20345), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(15073), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [180979] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(15075), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20377), 1,
      anon_sym_where,
    ACTIONS(20379), 1,
      anon_sym_COLON2,
    ACTIONS(20383), 1,
      sym__pair_operator,
    ACTIONS(20385), 1,
      sym__arrow_operator,
    ACTIONS(20387), 1,
      sym__lazy_or_operator,
    ACTIONS(20389), 1,
      sym__lazy_and_operator,
    ACTIONS(20391), 1,
      sym__pipe_right_operator,
    ACTIONS(20393), 1,
      sym__pipe_left_operator,
    ACTIONS(20395), 1,
      sym__ellipsis_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20381), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(15073), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [181054] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(13239), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [181095] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19634), 1,
      anon_sym_QMARK,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    STATE(12307), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13239), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [181174] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(13243), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [181215] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19634), 1,
      anon_sym_QMARK,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    STATE(12307), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13243), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [181294] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(12926), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [181335] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19634), 1,
      anon_sym_QMARK,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    STATE(12307), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12926), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [181414] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17596), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [181455] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(20405), 1,
      anon_sym_COMMA,
    STATE(12929), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [181498] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(13308), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [181541] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    STATE(12963), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13148), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13150), 24,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [181584] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 20,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [181635] = 25,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20373), 1,
      anon_sym_SEMI,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16961), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20410), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [181716] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [181765] = 25,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20373), 1,
      anon_sym_COMMA,
    ACTIONS(20413), 1,
      anon_sym_for,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16961), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20416), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [181846] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17657), 1,
      anon_sym_DASH_GT,
    ACTIONS(18118), 1,
      anon_sym_EQ,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [181889] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [181936] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17566), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [181977] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19466), 1,
      anon_sym_COMMA,
    STATE(13075), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12868), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12862), 24,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [182020] = 25,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20373), 1,
      anon_sym_SEMI,
    ACTIONS(20419), 1,
      anon_sym_for,
    STATE(14470), 1,
      sym_for_clause,
    STATE(16961), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20410), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [182101] = 5,
    ACTIONS(20422), 1,
      anon_sym_COMMA,
    STATE(12941), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13070), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13075), 19,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [182142] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19933), 1,
      anon_sym_QMARK,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13255), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [182219] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20291), 1,
      anon_sym_QMARK,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13338), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [182294] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [182335] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 11,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [182398] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20425), 1,
      anon_sym_COMMA,
    STATE(12946), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(12972), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12974), 24,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [182441] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19468), 1,
      anon_sym_as,
    ACTIONS(12979), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12981), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [182482] = 26,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18851), 1,
      anon_sym_end,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20434), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20440), 1,
      anon_sym_QMARK,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20466), 1,
      aux_sym__terminator_token1,
    STATE(14991), 1,
      aux_sym_open_tuple_repeat1,
    STATE(16078), 1,
      aux_sym__block_repeat1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [182565] = 5,
    ACTIONS(20468), 1,
      anon_sym_COMMA,
    STATE(12989), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13150), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13148), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [182606] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(207), 1,
      anon_sym_DASH_GT,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17982), 1,
      anon_sym_EQ,
    ACTIONS(11397), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [182649] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20470), 1,
      anon_sym_COMMA,
    STATE(12951), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12979), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12981), 24,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [182692] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 20,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [182743] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17982), 1,
      anon_sym_EQ,
    ACTIONS(11397), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [182786] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [182847] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(20287), 1,
      anon_sym_QMARK,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [182922] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [182993] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20045), 1,
      anon_sym_QMARK,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    STATE(14507), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [183072] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17882), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [183113] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19634), 1,
      anon_sym_QMARK,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 5,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [183188] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(13308), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [183231] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 11,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [183294] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 20,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [183345] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20473), 1,
      anon_sym_COMMA,
    STATE(12963), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13075), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13070), 24,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [183388] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [183455] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [183520] = 5,
    ACTIONS(17631), 1,
      anon_sym_DASH_GT,
    ACTIONS(18014), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [183561] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18466), 1,
      anon_sym_EQ,
    ACTIONS(13239), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [183602] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18466), 1,
      anon_sym_EQ,
    ACTIONS(13243), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [183643] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18466), 1,
      anon_sym_EQ,
    ACTIONS(12926), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [183684] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20291), 1,
      anon_sym_QMARK,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13070), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [183759] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [183820] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20291), 1,
      anon_sym_QMARK,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [183895] = 5,
    ACTIONS(18014), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [183936] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20045), 1,
      anon_sym_QMARK,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13255), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [184013] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [184084] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    ACTIONS(19548), 1,
      anon_sym_LF,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19634), 1,
      anon_sym_QMARK,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    STATE(14481), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19546), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [184163] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17618), 1,
      anon_sym_DASH_GT,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [184204] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [184271] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [184336] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 17,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [184393] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [184454] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(13249), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [184495] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 20,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [184546] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [184595] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [184642] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [184687] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20069), 1,
      sym__power_operator,
    ACTIONS(13306), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [184730] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19634), 1,
      anon_sym_QMARK,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    STATE(14481), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [184809] = 5,
    ACTIONS(20476), 1,
      anon_sym_COMMA,
    STATE(12989), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13070), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13075), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [184850] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    STATE(12929), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [184893] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(13249), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [184934] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [184979] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20479), 1,
      anon_sym_COMMA,
    STATE(12946), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13064), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13060), 24,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [185022] = 4,
    ACTIONS(17645), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [185061] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(13306), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [185104] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(20287), 1,
      anon_sym_QMARK,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13070), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [185179] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19634), 1,
      anon_sym_QMARK,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13255), 4,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [185256] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20045), 1,
      anon_sym_QMARK,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [185331] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17657), 1,
      anon_sym_DASH_GT,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [185374] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [185417] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13064), 1,
      anon_sym_LF,
    ACTIONS(20481), 1,
      anon_sym_COMMA,
    STATE(13005), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13060), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [185460] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(20289), 1,
      anon_sym_QMARK,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13070), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
  [185535] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13068), 1,
      anon_sym_LF,
    ACTIONS(20283), 1,
      anon_sym_COMMA,
    STATE(13007), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(13066), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [185578] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20491), 1,
      anon_sym_QMARK,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13255), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [185655] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12972), 1,
      anon_sym_LF,
    ACTIONS(20517), 1,
      anon_sym_COMMA,
    STATE(13005), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(12974), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [185698] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(20285), 1,
      anon_sym_as,
    ACTIONS(12981), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [185739] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12979), 1,
      anon_sym_LF,
    ACTIONS(20520), 1,
      anon_sym_COMMA,
    STATE(13007), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12981), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [185782] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(13249), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [185823] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    ACTIONS(20341), 1,
      anon_sym_where,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20347), 1,
      sym__pair_operator,
    ACTIONS(20349), 1,
      sym__arrow_operator,
    ACTIONS(20351), 1,
      sym__lazy_or_operator,
    ACTIONS(20353), 1,
      sym__lazy_and_operator,
    ACTIONS(20355), 1,
      sym__pipe_right_operator,
    ACTIONS(20357), 1,
      sym__pipe_left_operator,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20525), 1,
      anon_sym_LF,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20345), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(20523), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [185898] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20491), 1,
      anon_sym_QMARK,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13100), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13094), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      sym__pair_operator,
      aux_sym__terminator_token1,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [185973] = 24,
    ACTIONS(13239), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20533), 1,
      anon_sym_QMARK,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    STATE(12908), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [186052] = 24,
    ACTIONS(13243), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20533), 1,
      anon_sym_QMARK,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    STATE(12908), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [186131] = 24,
    ACTIONS(12926), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20533), 1,
      anon_sym_QMARK,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    STATE(12908), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [186210] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20561), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13255), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [186287] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20561), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [186362] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19548), 1,
      anon_sym_LF,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20045), 1,
      anon_sym_QMARK,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    STATE(14507), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19546), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [186441] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19134), 1,
      anon_sym_QMARK,
    ACTIONS(20563), 1,
      anon_sym_where,
    ACTIONS(20565), 1,
      anon_sym_COLON2,
    ACTIONS(20569), 1,
      sym__pair_operator,
    ACTIONS(20571), 1,
      sym__arrow_operator,
    ACTIONS(20573), 1,
      sym__lazy_or_operator,
    ACTIONS(20575), 1,
      sym__lazy_and_operator,
    ACTIONS(20577), 1,
      sym__pipe_right_operator,
    ACTIONS(20579), 1,
      sym__pipe_left_operator,
    ACTIONS(20581), 1,
      sym__ellipsis_operator,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(20583), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20567), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13338), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [186516] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(18118), 1,
      anon_sym_EQ,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [186559] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17616), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 26,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [186600] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20479), 1,
      anon_sym_COMMA,
    STATE(12993), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13146), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13144), 24,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [186643] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20593), 1,
      anon_sym_COLON2,
    ACTIONS(20597), 1,
      sym__pipe_right_operator,
    ACTIONS(20599), 1,
      sym__pipe_left_operator,
    ACTIONS(20601), 1,
      sym__ellipsis_operator,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(20603), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20595), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 11,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [186706] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [186747] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(13239), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [186788] = 24,
    ACTIONS(13249), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20533), 1,
      anon_sym_QMARK,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    STATE(12908), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [186867] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(20603), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 20,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [186918] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19933), 1,
      anon_sym_QMARK,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    STATE(12316), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13239), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [186997] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20593), 1,
      anon_sym_COLON2,
    ACTIONS(20597), 1,
      sym__pipe_right_operator,
    ACTIONS(20599), 1,
      sym__pipe_left_operator,
    ACTIONS(20601), 1,
      sym__ellipsis_operator,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(20603), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [187058] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18865), 1,
      anon_sym_QMARK,
    ACTIONS(20593), 1,
      anon_sym_COLON2,
    ACTIONS(20597), 1,
      sym__pipe_right_operator,
    ACTIONS(20599), 1,
      sym__pipe_left_operator,
    ACTIONS(20601), 1,
      sym__ellipsis_operator,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(20613), 1,
      anon_sym_where,
    ACTIONS(20615), 1,
      sym__pair_operator,
    ACTIONS(20617), 1,
      sym__arrow_operator,
    ACTIONS(20619), 1,
      sym__lazy_or_operator,
    ACTIONS(20621), 1,
      sym__lazy_and_operator,
    ACTIONS(20603), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20595), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [187133] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(13243), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [187174] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20593), 1,
      anon_sym_COLON2,
    ACTIONS(20597), 1,
      sym__pipe_right_operator,
    ACTIONS(20599), 1,
      sym__pipe_left_operator,
    ACTIONS(20601), 1,
      sym__ellipsis_operator,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(20613), 1,
      anon_sym_where,
    ACTIONS(20617), 1,
      sym__arrow_operator,
    ACTIONS(20619), 1,
      sym__lazy_or_operator,
    ACTIONS(20621), 1,
      sym__lazy_and_operator,
    ACTIONS(20603), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20595), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 7,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [187245] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20593), 1,
      anon_sym_COLON2,
    ACTIONS(20597), 1,
      sym__pipe_right_operator,
    ACTIONS(20599), 1,
      sym__pipe_left_operator,
    ACTIONS(20601), 1,
      sym__ellipsis_operator,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(20613), 1,
      anon_sym_where,
    ACTIONS(20621), 1,
      sym__lazy_and_operator,
    ACTIONS(20603), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20595), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [187312] = 23,
    ACTIONS(13255), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20533), 1,
      anon_sym_QMARK,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13253), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [187389] = 22,
    ACTIONS(13094), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20533), 1,
      anon_sym_QMARK,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13100), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym__pair_operator,
  [187464] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20593), 1,
      anon_sym_COLON2,
    ACTIONS(20597), 1,
      sym__pipe_right_operator,
    ACTIONS(20599), 1,
      sym__pipe_left_operator,
    ACTIONS(20601), 1,
      sym__ellipsis_operator,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(20613), 1,
      anon_sym_where,
    ACTIONS(20603), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20595), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 10,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [187529] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20593), 1,
      anon_sym_COLON2,
    ACTIONS(20601), 1,
      sym__ellipsis_operator,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(20603), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 17,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [187586] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20593), 1,
      anon_sym_COLON2,
    ACTIONS(20597), 1,
      sym__pipe_right_operator,
    ACTIONS(20599), 1,
      sym__pipe_left_operator,
    ACTIONS(20601), 1,
      sym__ellipsis_operator,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(20603), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [187647] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(20603), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 20,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [187698] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [187747] = 23,
    ACTIONS(13255), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20339), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13253), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [187824] = 22,
    ACTIONS(13094), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20339), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13100), 5,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [187899] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [187946] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [187991] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19634), 1,
      anon_sym_QMARK,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    STATE(12307), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [188070] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19933), 1,
      anon_sym_QMARK,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    STATE(12316), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13243), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [188149] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18570), 1,
      anon_sym_EQ,
    ACTIONS(13239), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [188190] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(13306), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [188233] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(13308), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [188276] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18570), 1,
      anon_sym_EQ,
    ACTIONS(13243), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [188317] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18570), 1,
      anon_sym_EQ,
    ACTIONS(12926), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [188358] = 24,
    ACTIONS(13249), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20339), 1,
      anon_sym_QMARK,
    ACTIONS(20468), 1,
      anon_sym_COMMA,
    STATE(12949), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [188437] = 4,
    ACTIONS(17651), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [188476] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(13308), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [188519] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20045), 1,
      anon_sym_QMARK,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    STATE(12460), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12926), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [188598] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19933), 1,
      anon_sym_QMARK,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    STATE(12316), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12926), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [188677] = 24,
    ACTIONS(13255), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20339), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13253), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [188756] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18518), 1,
      anon_sym_EQ,
    ACTIONS(12926), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [188797] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20561), 1,
      anon_sym_QMARK,
    STATE(12990), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13239), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [188876] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20561), 1,
      anon_sym_QMARK,
    STATE(12990), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13243), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [188955] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20561), 1,
      anon_sym_QMARK,
    STATE(12990), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12926), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [189034] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18062), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [189075] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20491), 1,
      anon_sym_QMARK,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    STATE(12931), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13247), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13249), 2,
      anon_sym_EQ,
      aux_sym__terminator_token1,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [189154] = 24,
    ACTIONS(13239), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20339), 1,
      anon_sym_QMARK,
    ACTIONS(20468), 1,
      anon_sym_COMMA,
    STATE(12949), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [189233] = 24,
    ACTIONS(13243), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20339), 1,
      anon_sym_QMARK,
    ACTIONS(20468), 1,
      anon_sym_COMMA,
    STATE(12949), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [189312] = 24,
    ACTIONS(12926), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20339), 1,
      anon_sym_QMARK,
    ACTIONS(20468), 1,
      anon_sym_COMMA,
    STATE(12949), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [189391] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20561), 1,
      anon_sym_QMARK,
    STATE(12990), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [189470] = 4,
    ACTIONS(17645), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [189509] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(13308), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [189552] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(13308), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [189595] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 11,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [189658] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17596), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [189699] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19933), 1,
      anon_sym_QMARK,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    STATE(14532), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [189778] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18861), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18865), 1,
      anon_sym_QMARK,
    ACTIONS(20593), 1,
      anon_sym_COLON2,
    ACTIONS(20597), 1,
      sym__pipe_right_operator,
    ACTIONS(20599), 1,
      sym__pipe_left_operator,
    ACTIONS(20601), 1,
      sym__ellipsis_operator,
    ACTIONS(20605), 1,
      sym__times_operator,
    ACTIONS(20607), 1,
      sym__rational_operator,
    ACTIONS(20609), 1,
      sym__bitshift_operator,
    ACTIONS(20611), 1,
      sym__power_operator,
    ACTIONS(20613), 1,
      anon_sym_where,
    ACTIONS(20615), 1,
      sym__pair_operator,
    ACTIONS(20617), 1,
      sym__arrow_operator,
    ACTIONS(20619), 1,
      sym__lazy_or_operator,
    ACTIONS(20621), 1,
      sym__lazy_and_operator,
    ACTIONS(20603), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20595), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13338), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [189853] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 20,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [189904] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17570), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [189945] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19466), 1,
      anon_sym_COMMA,
    STATE(12951), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(13068), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13066), 24,
      anon_sym_EQ,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [189988] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    ACTIONS(19548), 1,
      anon_sym_LF,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19933), 1,
      anon_sym_QMARK,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    STATE(14532), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19546), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [190067] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18046), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [190108] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18046), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [190149] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [190210] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17618), 1,
      anon_sym_DASH_GT,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [190251] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(20289), 1,
      anon_sym_QMARK,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
  [190326] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [190397] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [190464] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19933), 1,
      anon_sym_QMARK,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13094), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [190539] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13306), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [190580] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [190645] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(207), 1,
      anon_sym_DASH_GT,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(11397), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [190688] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(11397), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [190731] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 17,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [190788] = 5,
    ACTIONS(17631), 1,
      anon_sym_DASH_GT,
    ACTIONS(18056), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [190829] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18056), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [190870] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18518), 1,
      anon_sym_EQ,
    ACTIONS(13249), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [190911] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [190972] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 20,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [191023] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17592), 1,
      anon_sym_DASH_GT,
    ACTIONS(11397), 26,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [191064] = 4,
    ACTIONS(17651), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [191103] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [191152] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [191199] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17900), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [191240] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13306), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [191281] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20355), 1,
      sym__pipe_right_operator,
    ACTIONS(20357), 1,
      sym__pipe_left_operator,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20345), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [191344] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [191395] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20355), 1,
      sym__pipe_right_operator,
    ACTIONS(20357), 1,
      sym__pipe_left_operator,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [191456] = 26,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(20623), 1,
      ts_builtin_sym_end,
    ACTIONS(20625), 1,
      anon_sym_LF,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    ACTIONS(20629), 1,
      aux_sym__terminator_token1,
    STATE(15090), 1,
      aux_sym_open_tuple_repeat1,
    STATE(15805), 1,
      aux_sym__block_repeat1,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [191539] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    ACTIONS(20341), 1,
      anon_sym_where,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20347), 1,
      sym__pair_operator,
    ACTIONS(20349), 1,
      sym__arrow_operator,
    ACTIONS(20351), 1,
      sym__lazy_or_operator,
    ACTIONS(20353), 1,
      sym__lazy_and_operator,
    ACTIONS(20355), 1,
      sym__pipe_right_operator,
    ACTIONS(20357), 1,
      sym__pipe_left_operator,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20345), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [191614] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20341), 1,
      anon_sym_where,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20349), 1,
      sym__arrow_operator,
    ACTIONS(20351), 1,
      sym__lazy_or_operator,
    ACTIONS(20353), 1,
      sym__lazy_and_operator,
    ACTIONS(20355), 1,
      sym__pipe_right_operator,
    ACTIONS(20357), 1,
      sym__pipe_left_operator,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20345), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [191685] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    ACTIONS(19923), 1,
      anon_sym_where,
    ACTIONS(19925), 1,
      anon_sym_COLON2,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19933), 1,
      anon_sym_QMARK,
    ACTIONS(19935), 1,
      sym__pair_operator,
    ACTIONS(19937), 1,
      sym__arrow_operator,
    ACTIONS(19939), 1,
      sym__lazy_or_operator,
    ACTIONS(19941), 1,
      sym__lazy_and_operator,
    ACTIONS(19943), 1,
      sym__pipe_right_operator,
    ACTIONS(19945), 1,
      sym__pipe_left_operator,
    ACTIONS(19947), 1,
      sym__ellipsis_operator,
    ACTIONS(19951), 1,
      sym__times_operator,
    ACTIONS(19953), 1,
      sym__rational_operator,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    STATE(12316), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19949), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13249), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(19929), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [191764] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20341), 1,
      anon_sym_where,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20353), 1,
      sym__lazy_and_operator,
    ACTIONS(20355), 1,
      sym__pipe_right_operator,
    ACTIONS(20357), 1,
      sym__pipe_left_operator,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20345), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [191831] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20341), 1,
      anon_sym_where,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20355), 1,
      sym__pipe_right_operator,
    ACTIONS(20357), 1,
      sym__pipe_left_operator,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20345), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 10,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [191896] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [191953] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20565), 1,
      anon_sym_COLON2,
    ACTIONS(20577), 1,
      sym__pipe_right_operator,
    ACTIONS(20579), 1,
      sym__pipe_left_operator,
    ACTIONS(20581), 1,
      sym__ellipsis_operator,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(20583), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20567), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 11,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [192016] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(20583), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 20,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [192067] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13306), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [192108] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20355), 1,
      sym__pipe_right_operator,
    ACTIONS(20357), 1,
      sym__pipe_left_operator,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [192169] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [192220] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [192269] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [192316] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20565), 1,
      anon_sym_COLON2,
    ACTIONS(20577), 1,
      sym__pipe_right_operator,
    ACTIONS(20579), 1,
      sym__pipe_left_operator,
    ACTIONS(20581), 1,
      sym__ellipsis_operator,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(20583), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [192377] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [192422] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(13306), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [192465] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19134), 1,
      anon_sym_QMARK,
    ACTIONS(20563), 1,
      anon_sym_where,
    ACTIONS(20565), 1,
      anon_sym_COLON2,
    ACTIONS(20569), 1,
      sym__pair_operator,
    ACTIONS(20571), 1,
      sym__arrow_operator,
    ACTIONS(20573), 1,
      sym__lazy_or_operator,
    ACTIONS(20575), 1,
      sym__lazy_and_operator,
    ACTIONS(20577), 1,
      sym__pipe_right_operator,
    ACTIONS(20579), 1,
      sym__pipe_left_operator,
    ACTIONS(20581), 1,
      sym__ellipsis_operator,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(20583), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20567), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [192540] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20563), 1,
      anon_sym_where,
    ACTIONS(20565), 1,
      anon_sym_COLON2,
    ACTIONS(20571), 1,
      sym__arrow_operator,
    ACTIONS(20573), 1,
      sym__lazy_or_operator,
    ACTIONS(20575), 1,
      sym__lazy_and_operator,
    ACTIONS(20577), 1,
      sym__pipe_right_operator,
    ACTIONS(20579), 1,
      sym__pipe_left_operator,
    ACTIONS(20581), 1,
      sym__ellipsis_operator,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(20583), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20567), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 7,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [192611] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19448), 1,
      anon_sym_QMARK,
    ACTIONS(20341), 1,
      anon_sym_where,
    ACTIONS(20343), 1,
      anon_sym_COLON2,
    ACTIONS(20347), 1,
      sym__pair_operator,
    ACTIONS(20349), 1,
      sym__arrow_operator,
    ACTIONS(20351), 1,
      sym__lazy_or_operator,
    ACTIONS(20353), 1,
      sym__lazy_and_operator,
    ACTIONS(20355), 1,
      sym__pipe_right_operator,
    ACTIONS(20357), 1,
      sym__pipe_left_operator,
    ACTIONS(20359), 1,
      sym__ellipsis_operator,
    ACTIONS(20363), 1,
      sym__times_operator,
    ACTIONS(20365), 1,
      sym__rational_operator,
    ACTIONS(20367), 1,
      sym__bitshift_operator,
    ACTIONS(20369), 1,
      sym__power_operator,
    ACTIONS(20361), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20345), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13338), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [192686] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18570), 1,
      anon_sym_EQ,
    ACTIONS(13249), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [192727] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20379), 1,
      anon_sym_COLON2,
    ACTIONS(20391), 1,
      sym__pipe_right_operator,
    ACTIONS(20393), 1,
      sym__pipe_left_operator,
    ACTIONS(20395), 1,
      sym__ellipsis_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20381), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [192790] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [192841] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20379), 1,
      anon_sym_COLON2,
    ACTIONS(20391), 1,
      sym__pipe_right_operator,
    ACTIONS(20393), 1,
      sym__pipe_left_operator,
    ACTIONS(20395), 1,
      sym__ellipsis_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [192902] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20377), 1,
      anon_sym_where,
    ACTIONS(20379), 1,
      anon_sym_COLON2,
    ACTIONS(20383), 1,
      sym__pair_operator,
    ACTIONS(20385), 1,
      sym__arrow_operator,
    ACTIONS(20387), 1,
      sym__lazy_or_operator,
    ACTIONS(20389), 1,
      sym__lazy_and_operator,
    ACTIONS(20391), 1,
      sym__pipe_right_operator,
    ACTIONS(20393), 1,
      sym__pipe_left_operator,
    ACTIONS(20395), 1,
      sym__ellipsis_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20381), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [192977] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20377), 1,
      anon_sym_where,
    ACTIONS(20379), 1,
      anon_sym_COLON2,
    ACTIONS(20385), 1,
      sym__arrow_operator,
    ACTIONS(20387), 1,
      sym__lazy_or_operator,
    ACTIONS(20389), 1,
      sym__lazy_and_operator,
    ACTIONS(20391), 1,
      sym__pipe_right_operator,
    ACTIONS(20393), 1,
      sym__pipe_left_operator,
    ACTIONS(20395), 1,
      sym__ellipsis_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20381), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
  [193048] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20377), 1,
      anon_sym_where,
    ACTIONS(20379), 1,
      anon_sym_COLON2,
    ACTIONS(20389), 1,
      sym__lazy_and_operator,
    ACTIONS(20391), 1,
      sym__pipe_right_operator,
    ACTIONS(20393), 1,
      sym__pipe_left_operator,
    ACTIONS(20395), 1,
      sym__ellipsis_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20381), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [193115] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20491), 1,
      anon_sym_QMARK,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    STATE(12931), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13239), 2,
      anon_sym_EQ,
      aux_sym__terminator_token1,
    ACTIONS(13241), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [193194] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20491), 1,
      anon_sym_QMARK,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    STATE(12931), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13243), 2,
      anon_sym_EQ,
      aux_sym__terminator_token1,
    ACTIONS(13245), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [193273] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20491), 1,
      anon_sym_QMARK,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    STATE(12931), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(12926), 2,
      anon_sym_EQ,
      aux_sym__terminator_token1,
    ACTIONS(12934), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [193352] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13146), 1,
      anon_sym_LF,
    ACTIONS(20481), 1,
      anon_sym_COMMA,
    STATE(13001), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(13144), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [193395] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12868), 1,
      anon_sym_LF,
    ACTIONS(20283), 1,
      anon_sym_COMMA,
    STATE(13003), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(12862), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [193438] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20377), 1,
      anon_sym_where,
    ACTIONS(20379), 1,
      anon_sym_COLON2,
    ACTIONS(20391), 1,
      sym__pipe_right_operator,
    ACTIONS(20393), 1,
      sym__pipe_left_operator,
    ACTIONS(20395), 1,
      sym__ellipsis_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20381), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 10,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [193503] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20379), 1,
      anon_sym_COLON2,
    ACTIONS(20395), 1,
      sym__ellipsis_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [193560] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20379), 1,
      anon_sym_COLON2,
    ACTIONS(20391), 1,
      sym__pipe_right_operator,
    ACTIONS(20393), 1,
      sym__pipe_left_operator,
    ACTIONS(20395), 1,
      sym__ellipsis_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [193621] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [193672] = 5,
    ACTIONS(20631), 1,
      anon_sym_COMMA,
    STATE(13145), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13144), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13146), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [193713] = 5,
    ACTIONS(20321), 1,
      anon_sym_COMMA,
    STATE(13147), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12862), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12868), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [193754] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(13306), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [193803] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(13306), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [193850] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(13306), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [193895] = 5,
    ACTIONS(20631), 1,
      anon_sym_COMMA,
    STATE(13148), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13060), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13064), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [193936] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(13306), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [193979] = 5,
    ACTIONS(20321), 1,
      anon_sym_COMMA,
    STATE(13150), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13066), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13068), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [194020] = 5,
    ACTIONS(20633), 1,
      anon_sym_COMMA,
    STATE(13148), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12974), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12972), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [194061] = 4,
    ACTIONS(20323), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12981), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12979), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [194100] = 5,
    ACTIONS(20636), 1,
      anon_sym_COMMA,
    STATE(13150), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12981), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12979), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [194141] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20377), 1,
      anon_sym_where,
    ACTIONS(20379), 1,
      anon_sym_COLON2,
    ACTIONS(20383), 1,
      sym__pair_operator,
    ACTIONS(20385), 1,
      sym__arrow_operator,
    ACTIONS(20387), 1,
      sym__lazy_or_operator,
    ACTIONS(20389), 1,
      sym__lazy_and_operator,
    ACTIONS(20391), 1,
      sym__pipe_right_operator,
    ACTIONS(20393), 1,
      sym__pipe_left_operator,
    ACTIONS(20395), 1,
      sym__ellipsis_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20381), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13338), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [194216] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12676), 1,
      anon_sym_LF,
    ACTIONS(20639), 1,
      anon_sym_DOT,
    ACTIONS(12678), 26,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [194257] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18466), 1,
      anon_sym_EQ,
    ACTIONS(13249), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [194298] = 5,
    ACTIONS(17631), 1,
      anon_sym_DASH_GT,
    ACTIONS(18062), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [194339] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20563), 1,
      anon_sym_where,
    ACTIONS(20565), 1,
      anon_sym_COLON2,
    ACTIONS(20575), 1,
      sym__lazy_and_operator,
    ACTIONS(20577), 1,
      sym__pipe_right_operator,
    ACTIONS(20579), 1,
      sym__pipe_left_operator,
    ACTIONS(20581), 1,
      sym__ellipsis_operator,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(20583), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20567), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [194406] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19624), 1,
      anon_sym_where,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19636), 1,
      sym__pair_operator,
    ACTIONS(19638), 1,
      sym__arrow_operator,
    ACTIONS(19640), 1,
      sym__lazy_or_operator,
    ACTIONS(19642), 1,
      sym__lazy_and_operator,
    ACTIONS(19644), 1,
      sym__pipe_right_operator,
    ACTIONS(19646), 1,
      sym__pipe_left_operator,
    ACTIONS(19648), 1,
      sym__ellipsis_operator,
    ACTIONS(19652), 1,
      sym__times_operator,
    ACTIONS(19654), 1,
      sym__rational_operator,
    ACTIONS(19656), 1,
      sym__bitshift_operator,
    ACTIONS(19658), 1,
      sym__power_operator,
    ACTIONS(20287), 1,
      anon_sym_QMARK,
    ACTIONS(19650), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19630), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13338), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [194481] = 4,
    ACTIONS(20641), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12678), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12676), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [194520] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20563), 1,
      anon_sym_where,
    ACTIONS(20565), 1,
      anon_sym_COLON2,
    ACTIONS(20577), 1,
      sym__pipe_right_operator,
    ACTIONS(20579), 1,
      sym__pipe_left_operator,
    ACTIONS(20581), 1,
      sym__ellipsis_operator,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(20583), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20567), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 10,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [194585] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20565), 1,
      anon_sym_COLON2,
    ACTIONS(20581), 1,
      sym__ellipsis_operator,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(20583), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 17,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [194642] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19955), 1,
      sym__bitshift_operator,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [194687] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(15079), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19560), 1,
      anon_sym_QMARK,
    ACTIONS(20375), 1,
      sym__power_operator,
    ACTIONS(20377), 1,
      anon_sym_where,
    ACTIONS(20379), 1,
      anon_sym_COLON2,
    ACTIONS(20383), 1,
      sym__pair_operator,
    ACTIONS(20385), 1,
      sym__arrow_operator,
    ACTIONS(20387), 1,
      sym__lazy_or_operator,
    ACTIONS(20389), 1,
      sym__lazy_and_operator,
    ACTIONS(20391), 1,
      sym__pipe_right_operator,
    ACTIONS(20393), 1,
      sym__pipe_left_operator,
    ACTIONS(20395), 1,
      sym__ellipsis_operator,
    ACTIONS(20399), 1,
      sym__times_operator,
    ACTIONS(20401), 1,
      sym__rational_operator,
    ACTIONS(20403), 1,
      sym__bitshift_operator,
    ACTIONS(20397), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20381), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(15077), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [194762] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19957), 1,
      sym__power_operator,
    ACTIONS(13306), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [194805] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18518), 1,
      anon_sym_EQ,
    ACTIONS(13239), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [194846] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19132), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20565), 1,
      anon_sym_COLON2,
    ACTIONS(20577), 1,
      sym__pipe_right_operator,
    ACTIONS(20579), 1,
      sym__pipe_left_operator,
    ACTIONS(20581), 1,
      sym__ellipsis_operator,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(20583), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [194907] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(20583), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 20,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [194958] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20585), 1,
      sym__times_operator,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [195007] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20045), 1,
      anon_sym_QMARK,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    STATE(12460), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13239), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [195086] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18518), 1,
      anon_sym_EQ,
    ACTIONS(13243), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [195127] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20587), 1,
      sym__rational_operator,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [195174] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20589), 1,
      sym__bitshift_operator,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [195219] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20591), 1,
      sym__power_operator,
    ACTIONS(13306), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [195262] = 5,
    ACTIONS(17631), 1,
      anon_sym_DASH_GT,
    ACTIONS(18084), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [195303] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18084), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [195344] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(11397), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [195385] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    ACTIONS(20035), 1,
      anon_sym_where,
    ACTIONS(20037), 1,
      anon_sym_COLON2,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20045), 1,
      anon_sym_QMARK,
    ACTIONS(20047), 1,
      sym__pair_operator,
    ACTIONS(20049), 1,
      sym__arrow_operator,
    ACTIONS(20051), 1,
      sym__lazy_or_operator,
    ACTIONS(20053), 1,
      sym__lazy_and_operator,
    ACTIONS(20055), 1,
      sym__pipe_right_operator,
    ACTIONS(20057), 1,
      sym__pipe_left_operator,
    ACTIONS(20059), 1,
      sym__ellipsis_operator,
    ACTIONS(20063), 1,
      sym__times_operator,
    ACTIONS(20065), 1,
      sym__rational_operator,
    ACTIONS(20067), 1,
      sym__bitshift_operator,
    ACTIONS(20069), 1,
      sym__power_operator,
    STATE(12460), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20061), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13243), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20041), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [195464] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(12926), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [195505] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17657), 1,
      anon_sym_DASH_GT,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [195545] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20643), 1,
      anon_sym_COLON2,
    ACTIONS(20645), 1,
      sym__pipe_right_operator,
    ACTIONS(20647), 1,
      sym__pipe_left_operator,
    ACTIONS(20649), 1,
      sym__ellipsis_operator,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(20651), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [195605] = 5,
    ACTIONS(17798), 1,
      anon_sym_DASH_GT,
    ACTIONS(18056), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [195645] = 4,
    ACTIONS(18370), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [195683] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20045), 1,
      anon_sym_QMARK,
    ACTIONS(20661), 1,
      anon_sym_where,
    ACTIONS(20663), 1,
      anon_sym_COLON2,
    ACTIONS(20667), 1,
      sym__pair_operator,
    ACTIONS(20669), 1,
      sym__arrow_operator,
    ACTIONS(20671), 1,
      sym__lazy_or_operator,
    ACTIONS(20673), 1,
      sym__lazy_and_operator,
    ACTIONS(20675), 1,
      sym__pipe_right_operator,
    ACTIONS(20677), 1,
      sym__pipe_left_operator,
    ACTIONS(20679), 1,
      sym__ellipsis_operator,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(20681), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13338), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20665), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [195757] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18208), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [195797] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19548), 1,
      anon_sym_LF,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20440), 1,
      anon_sym_QMARK,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    STATE(14991), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19546), 2,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [195875] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20440), 1,
      anon_sym_QMARK,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    STATE(14991), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13249), 2,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [195953] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20561), 1,
      anon_sym_QMARK,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13070), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [196027] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19634), 1,
      anon_sym_QMARK,
    ACTIONS(20643), 1,
      anon_sym_COLON2,
    ACTIONS(20645), 1,
      sym__pipe_right_operator,
    ACTIONS(20647), 1,
      sym__pipe_left_operator,
    ACTIONS(20649), 1,
      sym__ellipsis_operator,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(20691), 1,
      anon_sym_where,
    ACTIONS(20695), 1,
      sym__pair_operator,
    ACTIONS(20697), 1,
      sym__arrow_operator,
    ACTIONS(20699), 1,
      sym__lazy_or_operator,
    ACTIONS(20701), 1,
      sym__lazy_and_operator,
    ACTIONS(20651), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20693), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [196101] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20643), 1,
      anon_sym_COLON2,
    ACTIONS(20645), 1,
      sym__pipe_right_operator,
    ACTIONS(20647), 1,
      sym__pipe_left_operator,
    ACTIONS(20649), 1,
      sym__ellipsis_operator,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(20691), 1,
      anon_sym_where,
    ACTIONS(20697), 1,
      sym__arrow_operator,
    ACTIONS(20699), 1,
      sym__lazy_or_operator,
    ACTIONS(20701), 1,
      sym__lazy_and_operator,
    ACTIONS(20651), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20693), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 6,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [196171] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20643), 1,
      anon_sym_COLON2,
    ACTIONS(20645), 1,
      sym__pipe_right_operator,
    ACTIONS(20647), 1,
      sym__pipe_left_operator,
    ACTIONS(20649), 1,
      sym__ellipsis_operator,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(20691), 1,
      anon_sym_where,
    ACTIONS(20701), 1,
      sym__lazy_and_operator,
    ACTIONS(20651), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20693), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [196237] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20643), 1,
      anon_sym_COLON2,
    ACTIONS(20645), 1,
      sym__pipe_right_operator,
    ACTIONS(20647), 1,
      sym__pipe_left_operator,
    ACTIONS(20649), 1,
      sym__ellipsis_operator,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(20691), 1,
      anon_sym_where,
    ACTIONS(20651), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20693), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [196301] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20643), 1,
      anon_sym_COLON2,
    ACTIONS(20649), 1,
      sym__ellipsis_operator,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(20651), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [196357] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20643), 1,
      anon_sym_COLON2,
    ACTIONS(20645), 1,
      sym__pipe_right_operator,
    ACTIONS(20647), 1,
      sym__pipe_left_operator,
    ACTIONS(20649), 1,
      sym__ellipsis_operator,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(20651), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [196417] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [196479] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [196523] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 19,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [196573] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [196633] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20561), 1,
      anon_sym_QMARK,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [196707] = 22,
    ACTIONS(13070), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20339), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13075), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [196781] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [196823] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(20707), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [196873] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(20713), 1,
      anon_sym_COLON2,
    ACTIONS(20715), 1,
      sym__pipe_right_operator,
    ACTIONS(20717), 1,
      sym__pipe_left_operator,
    ACTIONS(20719), 1,
      sym__ellipsis_operator,
    ACTIONS(20707), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [196933] = 5,
    ACTIONS(20721), 1,
      anon_sym_COMMA,
    STATE(13206), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13150), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13148), 18,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [196973] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [197043] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [197109] = 23,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20468), 1,
      anon_sym_COMMA,
    STATE(12949), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [197185] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [197249] = 5,
    ACTIONS(20723), 1,
      anon_sym_COMMA,
    STATE(13206), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13070), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13075), 18,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [197289] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20726), 1,
      anon_sym_COLON2,
    ACTIONS(20730), 1,
      sym__pipe_right_operator,
    ACTIONS(20732), 1,
      sym__pipe_left_operator,
    ACTIONS(20734), 1,
      sym__ellipsis_operator,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20728), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 10,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [197351] = 4,
    ACTIONS(18062), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [197389] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [197445] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 19,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [197495] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20726), 1,
      anon_sym_COLON2,
    ACTIONS(20730), 1,
      sym__pipe_right_operator,
    ACTIONS(20732), 1,
      sym__pipe_left_operator,
    ACTIONS(20734), 1,
      sym__ellipsis_operator,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [197555] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [197615] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(13247), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13249), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [197655] = 4,
    ACTIONS(18084), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [197693] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 19,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [197743] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18322), 1,
      anon_sym_EQ,
    ACTIONS(13239), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [197783] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18322), 1,
      anon_sym_EQ,
    ACTIONS(13243), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [197823] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18322), 1,
      anon_sym_EQ,
    ACTIONS(12926), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [197863] = 4,
    ACTIONS(18046), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [197901] = 22,
    ACTIONS(13338), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20533), 1,
      anon_sym_QMARK,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13340), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [197975] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13249), 1,
      aux_sym__terminator_token1,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    STATE(12931), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13247), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [198053] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(13306), 21,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [198101] = 4,
    ACTIONS(17800), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [198139] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(13308), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [198181] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(13308), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [198223] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [198269] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [198313] = 22,
    ACTIONS(13070), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20533), 1,
      anon_sym_QMARK,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13075), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [198387] = 5,
    ACTIONS(17798), 1,
      anon_sym_DASH_GT,
    ACTIONS(18194), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [198427] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [198469] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20491), 1,
      anon_sym_QMARK,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13340), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13338), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [198543] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20746), 1,
      anon_sym_COLON2,
    ACTIONS(20750), 1,
      sym__pipe_right_operator,
    ACTIONS(20752), 1,
      sym__pipe_left_operator,
    ACTIONS(20754), 1,
      sym__ellipsis_operator,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20748), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 10,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [198605] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20726), 1,
      anon_sym_COLON2,
    ACTIONS(20730), 1,
      sym__pipe_right_operator,
    ACTIONS(20732), 1,
      sym__pipe_left_operator,
    ACTIONS(20734), 1,
      sym__ellipsis_operator,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20766), 1,
      anon_sym_where,
    ACTIONS(20768), 1,
      anon_sym_QMARK,
    ACTIONS(20770), 1,
      sym__pair_operator,
    ACTIONS(20772), 1,
      sym__arrow_operator,
    ACTIONS(20774), 1,
      sym__lazy_or_operator,
    ACTIONS(20776), 1,
      sym__lazy_and_operator,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20728), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [198679] = 22,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13253), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [198753] = 5,
    ACTIONS(17742), 1,
      anon_sym_DASH_GT,
    ACTIONS(18084), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [198793] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13253), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20440), 1,
      anon_sym_QMARK,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13255), 3,
      anon_sym_COMMA,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [198869] = 4,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [198907] = 4,
    ACTIONS(18046), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [198945] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19634), 1,
      anon_sym_QMARK,
    ACTIONS(20643), 1,
      anon_sym_COLON2,
    ACTIONS(20645), 1,
      sym__pipe_right_operator,
    ACTIONS(20647), 1,
      sym__pipe_left_operator,
    ACTIONS(20649), 1,
      sym__ellipsis_operator,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(20691), 1,
      anon_sym_where,
    ACTIONS(20695), 1,
      sym__pair_operator,
    ACTIONS(20697), 1,
      sym__arrow_operator,
    ACTIONS(20699), 1,
      sym__lazy_or_operator,
    ACTIONS(20701), 1,
      sym__lazy_and_operator,
    ACTIONS(20651), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13338), 4,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20693), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [199019] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 19,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [199069] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20746), 1,
      anon_sym_COLON2,
    ACTIONS(20750), 1,
      sym__pipe_right_operator,
    ACTIONS(20752), 1,
      sym__pipe_left_operator,
    ACTIONS(20754), 1,
      sym__ellipsis_operator,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [199129] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20746), 1,
      anon_sym_COLON2,
    ACTIONS(20750), 1,
      sym__pipe_right_operator,
    ACTIONS(20752), 1,
      sym__pipe_left_operator,
    ACTIONS(20754), 1,
      sym__ellipsis_operator,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20780), 1,
      anon_sym_where,
    ACTIONS(20782), 1,
      anon_sym_QMARK,
    ACTIONS(20784), 1,
      sym__pair_operator,
    ACTIONS(20786), 1,
      sym__arrow_operator,
    ACTIONS(20788), 1,
      sym__lazy_or_operator,
    ACTIONS(20790), 1,
      sym__lazy_and_operator,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(20748), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [199203] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13310), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13308), 23,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [199245] = 4,
    ACTIONS(17744), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [199283] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20746), 1,
      anon_sym_COLON2,
    ACTIONS(20750), 1,
      sym__pipe_right_operator,
    ACTIONS(20752), 1,
      sym__pipe_left_operator,
    ACTIONS(20754), 1,
      sym__ellipsis_operator,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20780), 1,
      anon_sym_where,
    ACTIONS(20786), 1,
      sym__arrow_operator,
    ACTIONS(20788), 1,
      sym__lazy_or_operator,
    ACTIONS(20790), 1,
      sym__lazy_and_operator,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20748), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 6,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
  [199353] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20746), 1,
      anon_sym_COLON2,
    ACTIONS(20750), 1,
      sym__pipe_right_operator,
    ACTIONS(20752), 1,
      sym__pipe_left_operator,
    ACTIONS(20754), 1,
      sym__ellipsis_operator,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20780), 1,
      anon_sym_where,
    ACTIONS(20790), 1,
      sym__lazy_and_operator,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20748), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [199419] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20746), 1,
      anon_sym_COLON2,
    ACTIONS(20750), 1,
      sym__pipe_right_operator,
    ACTIONS(20752), 1,
      sym__pipe_left_operator,
    ACTIONS(20754), 1,
      sym__ellipsis_operator,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20780), 1,
      anon_sym_where,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20748), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [199483] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19546), 1,
      aux_sym__terminator_token1,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    STATE(15090), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(19548), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [199561] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13100), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13094), 3,
      anon_sym_COMMA,
      sym__pair_operator,
      aux_sym__terminator_token1,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [199635] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20746), 1,
      anon_sym_COLON2,
    ACTIONS(20754), 1,
      sym__ellipsis_operator,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [199691] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(11397), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [199731] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20746), 1,
      anon_sym_COLON2,
    ACTIONS(20750), 1,
      sym__pipe_right_operator,
    ACTIONS(20752), 1,
      sym__pipe_left_operator,
    ACTIONS(20754), 1,
      sym__ellipsis_operator,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [199791] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 19,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [199841] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(13306), 21,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [199889] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(13249), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [199929] = 22,
    ACTIONS(13338), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20339), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13340), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [200003] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    STATE(12908), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [200079] = 4,
    ACTIONS(18056), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [200117] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13249), 1,
      aux_sym__terminator_token1,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    STATE(15090), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13247), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [200195] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20491), 1,
      anon_sym_QMARK,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13075), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13070), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [200269] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [200315] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13336), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [200377] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [200421] = 4,
    ACTIONS(18046), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [200459] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17832), 1,
      anon_sym_COMMA,
    ACTIONS(17834), 1,
      anon_sym_LF,
    ACTIONS(17836), 1,
      aux_sym__terminator_token1,
    STATE(16534), 1,
      aux_sym__do_parameter_list_repeat1,
    ACTIONS(11397), 22,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [200505] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    STATE(12908), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [200581] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [200623] = 4,
    ACTIONS(18046), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [200661] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20726), 1,
      anon_sym_COLON2,
    ACTIONS(20730), 1,
      sym__pipe_right_operator,
    ACTIONS(20732), 1,
      sym__pipe_left_operator,
    ACTIONS(20734), 1,
      sym__ellipsis_operator,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20766), 1,
      anon_sym_where,
    ACTIONS(20772), 1,
      sym__arrow_operator,
    ACTIONS(20774), 1,
      sym__lazy_or_operator,
    ACTIONS(20776), 1,
      sym__lazy_and_operator,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20728), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 6,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [200731] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13465), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 18,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [200781] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 13,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [200841] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    STATE(12908), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [200917] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20726), 1,
      anon_sym_COLON2,
    ACTIONS(20730), 1,
      sym__pipe_right_operator,
    ACTIONS(20732), 1,
      sym__pipe_left_operator,
    ACTIONS(20734), 1,
      sym__ellipsis_operator,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20766), 1,
      anon_sym_where,
    ACTIONS(20776), 1,
      sym__lazy_and_operator,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20728), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [200983] = 4,
    ACTIONS(18432), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [201021] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20491), 1,
      anon_sym_QMARK,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [201095] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20726), 1,
      anon_sym_COLON2,
    ACTIONS(20730), 1,
      sym__pipe_right_operator,
    ACTIONS(20732), 1,
      sym__pipe_left_operator,
    ACTIONS(20734), 1,
      sym__ellipsis_operator,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20766), 1,
      anon_sym_where,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20728), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [201159] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20726), 1,
      anon_sym_COLON2,
    ACTIONS(20734), 1,
      sym__ellipsis_operator,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [201215] = 4,
    ACTIONS(18046), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [201253] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [201323] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    STATE(12908), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [201399] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(13308), 24,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [201441] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18118), 1,
      anon_sym_EQ,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [201481] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [201547] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [201611] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [201667] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20726), 1,
      anon_sym_COLON2,
    ACTIONS(20730), 1,
      sym__pipe_right_operator,
    ACTIONS(20732), 1,
      sym__pipe_left_operator,
    ACTIONS(20734), 1,
      sym__ellipsis_operator,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
  [201727] = 21,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13100), 5,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [201799] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 13,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [201859] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 18,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [201909] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17657), 1,
      anon_sym_DASH_GT,
    ACTIONS(18188), 1,
      anon_sym_EQ,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [201951] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17594), 1,
      sym__immediate_paren,
    ACTIONS(18188), 1,
      anon_sym_EQ,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [201993] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20746), 1,
      anon_sym_COLON2,
    ACTIONS(20750), 1,
      sym__pipe_right_operator,
    ACTIONS(20752), 1,
      sym__pipe_left_operator,
    ACTIONS(20754), 1,
      sym__ellipsis_operator,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20780), 1,
      anon_sym_where,
    ACTIONS(20782), 1,
      anon_sym_QMARK,
    ACTIONS(20784), 1,
      sym__pair_operator,
    ACTIONS(20786), 1,
      sym__arrow_operator,
    ACTIONS(20788), 1,
      sym__lazy_or_operator,
    ACTIONS(20790), 1,
      sym__lazy_and_operator,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13338), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(20748), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [202067] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13306), 20,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [202115] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 19,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
  [202165] = 5,
    ACTIONS(17822), 1,
      anon_sym_DASH_GT,
    ACTIONS(18208), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [202205] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13306), 21,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [202251] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13306), 22,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [202295] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13306), 23,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [202337] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13306), 24,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [202377] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(20713), 1,
      anon_sym_COLON2,
    ACTIONS(20715), 1,
      sym__pipe_right_operator,
    ACTIONS(20717), 1,
      sym__pipe_left_operator,
    ACTIONS(20719), 1,
      sym__ellipsis_operator,
    ACTIONS(20707), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20792), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 10,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [202439] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(13306), 21,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [202487] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19933), 1,
      anon_sym_QMARK,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(20713), 1,
      anon_sym_COLON2,
    ACTIONS(20715), 1,
      sym__pipe_right_operator,
    ACTIONS(20717), 1,
      sym__pipe_left_operator,
    ACTIONS(20719), 1,
      sym__ellipsis_operator,
    ACTIONS(20794), 1,
      anon_sym_where,
    ACTIONS(20796), 1,
      sym__pair_operator,
    ACTIONS(20798), 1,
      sym__arrow_operator,
    ACTIONS(20800), 1,
      sym__lazy_or_operator,
    ACTIONS(20802), 1,
      sym__lazy_and_operator,
    ACTIONS(20707), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13338), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(20792), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [202561] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [202607] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18152), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [202647] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(12934), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12926), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [202687] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18152), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [202727] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [202771] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [202813] = 4,
    ACTIONS(18370), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [202851] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(20681), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [202901] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12926), 1,
      aux_sym__terminator_token1,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    STATE(12931), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(12934), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [202979] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20663), 1,
      anon_sym_COLON2,
    ACTIONS(20675), 1,
      sym__pipe_right_operator,
    ACTIONS(20677), 1,
      sym__pipe_left_operator,
    ACTIONS(20679), 1,
      sym__ellipsis_operator,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(20681), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [203039] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(13241), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13239), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [203079] = 23,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13253), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [203155] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20045), 1,
      anon_sym_QMARK,
    ACTIONS(20661), 1,
      anon_sym_where,
    ACTIONS(20663), 1,
      anon_sym_COLON2,
    ACTIONS(20667), 1,
      sym__pair_operator,
    ACTIONS(20669), 1,
      sym__arrow_operator,
    ACTIONS(20671), 1,
      sym__lazy_or_operator,
    ACTIONS(20673), 1,
      sym__lazy_and_operator,
    ACTIONS(20675), 1,
      sym__pipe_right_operator,
    ACTIONS(20677), 1,
      sym__pipe_left_operator,
    ACTIONS(20679), 1,
      sym__ellipsis_operator,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(20681), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
    ACTIONS(20665), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [203229] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19933), 1,
      anon_sym_QMARK,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(20713), 1,
      anon_sym_COLON2,
    ACTIONS(20715), 1,
      sym__pipe_right_operator,
    ACTIONS(20717), 1,
      sym__pipe_left_operator,
    ACTIONS(20719), 1,
      sym__ellipsis_operator,
    ACTIONS(20794), 1,
      anon_sym_where,
    ACTIONS(20796), 1,
      sym__pair_operator,
    ACTIONS(20798), 1,
      sym__arrow_operator,
    ACTIONS(20800), 1,
      sym__lazy_or_operator,
    ACTIONS(20802), 1,
      sym__lazy_and_operator,
    ACTIONS(20707), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
    ACTIONS(20792), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [203303] = 4,
    ACTIONS(18062), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [203341] = 23,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20468), 1,
      anon_sym_COMMA,
    STATE(12949), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [203417] = 4,
    ACTIONS(18062), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [203455] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20661), 1,
      anon_sym_where,
    ACTIONS(20663), 1,
      anon_sym_COLON2,
    ACTIONS(20669), 1,
      sym__arrow_operator,
    ACTIONS(20671), 1,
      sym__lazy_or_operator,
    ACTIONS(20673), 1,
      sym__lazy_and_operator,
    ACTIONS(20675), 1,
      sym__pipe_right_operator,
    ACTIONS(20677), 1,
      sym__pipe_left_operator,
    ACTIONS(20679), 1,
      sym__ellipsis_operator,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(20681), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20665), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 6,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [203525] = 23,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20468), 1,
      anon_sym_COMMA,
    STATE(12949), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [203601] = 4,
    ACTIONS(18062), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [203639] = 23,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20468), 1,
      anon_sym_COMMA,
    STATE(12949), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [203715] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13306), 25,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [203755] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 18,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [203795] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20661), 1,
      anon_sym_where,
    ACTIONS(20663), 1,
      anon_sym_COLON2,
    ACTIONS(20673), 1,
      sym__lazy_and_operator,
    ACTIONS(20675), 1,
      sym__pipe_right_operator,
    ACTIONS(20677), 1,
      sym__pipe_left_operator,
    ACTIONS(20679), 1,
      sym__ellipsis_operator,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(20681), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20665), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [203861] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20661), 1,
      anon_sym_where,
    ACTIONS(20663), 1,
      anon_sym_COLON2,
    ACTIONS(20675), 1,
      sym__pipe_right_operator,
    ACTIONS(20677), 1,
      sym__pipe_left_operator,
    ACTIONS(20679), 1,
      sym__ellipsis_operator,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(20681), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20665), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [203925] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19288), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20525), 1,
      anon_sym_LF,
    ACTIONS(20746), 1,
      anon_sym_COLON2,
    ACTIONS(20750), 1,
      sym__pipe_right_operator,
    ACTIONS(20752), 1,
      sym__pipe_left_operator,
    ACTIONS(20754), 1,
      sym__ellipsis_operator,
    ACTIONS(20758), 1,
      sym__times_operator,
    ACTIONS(20760), 1,
      sym__rational_operator,
    ACTIONS(20762), 1,
      sym__bitshift_operator,
    ACTIONS(20764), 1,
      sym__power_operator,
    ACTIONS(20780), 1,
      anon_sym_where,
    ACTIONS(20782), 1,
      anon_sym_QMARK,
    ACTIONS(20784), 1,
      sym__pair_operator,
    ACTIONS(20786), 1,
      sym__arrow_operator,
    ACTIONS(20788), 1,
      sym__lazy_or_operator,
    ACTIONS(20790), 1,
      sym__lazy_and_operator,
    ACTIONS(20756), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20523), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(20748), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [203999] = 16,
    ACTIONS(13334), 1,
      anon_sym_EQ,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [204061] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [204109] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20663), 1,
      anon_sym_COLON2,
    ACTIONS(20679), 1,
      sym__ellipsis_operator,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(20681), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [204165] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(20713), 1,
      anon_sym_COLON2,
    ACTIONS(20715), 1,
      sym__pipe_right_operator,
    ACTIONS(20717), 1,
      sym__pipe_left_operator,
    ACTIONS(20719), 1,
      sym__ellipsis_operator,
    ACTIONS(20794), 1,
      anon_sym_where,
    ACTIONS(20798), 1,
      sym__arrow_operator,
    ACTIONS(20800), 1,
      sym__lazy_or_operator,
    ACTIONS(20802), 1,
      sym__lazy_and_operator,
    ACTIONS(20707), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20792), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 6,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [204235] = 4,
    ACTIONS(17800), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [204273] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 18,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [204313] = 4,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [204351] = 22,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13253), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [204425] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20663), 1,
      anon_sym_COLON2,
    ACTIONS(20675), 1,
      sym__pipe_right_operator,
    ACTIONS(20677), 1,
      sym__pipe_left_operator,
    ACTIONS(20679), 1,
      sym__ellipsis_operator,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(20681), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [204485] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(13308), 24,
      anon_sym_where,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [204527] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(20681), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [204577] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13253), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13255), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [204653] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(13306), 21,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [204701] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(17982), 1,
      anon_sym_EQ,
    ACTIONS(11397), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [204741] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18194), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [204781] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [204827] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20440), 1,
      anon_sym_QMARK,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    STATE(12990), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13249), 2,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [204905] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13239), 1,
      aux_sym__terminator_token1,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    STATE(12931), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13241), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [204983] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [205027] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [205069] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(20713), 1,
      anon_sym_COLON2,
    ACTIONS(20715), 1,
      sym__pipe_right_operator,
    ACTIONS(20717), 1,
      sym__pipe_left_operator,
    ACTIONS(20719), 1,
      sym__ellipsis_operator,
    ACTIONS(20794), 1,
      anon_sym_where,
    ACTIONS(20802), 1,
      sym__lazy_and_operator,
    ACTIONS(20707), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20792), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [205135] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(20713), 1,
      anon_sym_COLON2,
    ACTIONS(20715), 1,
      sym__pipe_right_operator,
    ACTIONS(20717), 1,
      sym__pipe_left_operator,
    ACTIONS(20719), 1,
      sym__ellipsis_operator,
    ACTIONS(20794), 1,
      anon_sym_where,
    ACTIONS(20707), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20792), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 9,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [205199] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(20713), 1,
      anon_sym_COLON2,
    ACTIONS(20719), 1,
      sym__ellipsis_operator,
    ACTIONS(20707), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 16,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [205255] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20726), 1,
      anon_sym_COLON2,
    ACTIONS(20730), 1,
      sym__pipe_right_operator,
    ACTIONS(20732), 1,
      sym__pipe_left_operator,
    ACTIONS(20734), 1,
      sym__ellipsis_operator,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20766), 1,
      anon_sym_where,
    ACTIONS(20768), 1,
      anon_sym_QMARK,
    ACTIONS(20770), 1,
      sym__pair_operator,
    ACTIONS(20772), 1,
      sym__arrow_operator,
    ACTIONS(20774), 1,
      sym__lazy_or_operator,
    ACTIONS(20776), 1,
      sym__lazy_and_operator,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13338), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20728), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [205329] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(20713), 1,
      anon_sym_COLON2,
    ACTIONS(20715), 1,
      sym__pipe_right_operator,
    ACTIONS(20717), 1,
      sym__pipe_left_operator,
    ACTIONS(20719), 1,
      sym__ellipsis_operator,
    ACTIONS(20707), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [205389] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13100), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym__pair_operator,
  [205461] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(13308), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [205503] = 24,
    ACTIONS(13249), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20721), 1,
      anon_sym_COMMA,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20810), 1,
      anon_sym_QMARK,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    STATE(13201), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13247), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [205581] = 24,
    ACTIONS(13249), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20838), 1,
      anon_sym_COMMA,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20846), 1,
      anon_sym_QMARK,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    STATE(13367), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13247), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [205659] = 23,
    ACTIONS(13255), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20810), 1,
      anon_sym_QMARK,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13253), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [205735] = 22,
    ACTIONS(13094), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20810), 1,
      anon_sym_QMARK,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13100), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      sym__pair_operator,
  [205809] = 23,
    ACTIONS(13255), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20846), 1,
      anon_sym_QMARK,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13253), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [205885] = 22,
    ACTIONS(13094), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20846), 1,
      anon_sym_QMARK,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13100), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [205959] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(20561), 1,
      anon_sym_QMARK,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13338), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [206033] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(20707), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [206083] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(11408), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [206123] = 4,
    ACTIONS(18014), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [206161] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13100), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20440), 1,
      anon_sym_QMARK,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13094), 4,
      anon_sym_COMMA,
      anon_sym_end,
      sym__pair_operator,
      aux_sym__terminator_token1,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [206235] = 5,
    ACTIONS(20838), 1,
      anon_sym_COMMA,
    STATE(13381), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13150), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13148), 18,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [206275] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20709), 1,
      sym__times_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(13306), 21,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [206323] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18608), 1,
      anon_sym_EQ,
    ACTIONS(13241), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13239), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [206363] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18608), 1,
      anon_sym_EQ,
    ACTIONS(13245), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13243), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [206403] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18608), 1,
      anon_sym_EQ,
    ACTIONS(12934), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(12926), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [206443] = 4,
    ACTIONS(18432), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [206481] = 4,
    ACTIONS(18432), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [206519] = 4,
    ACTIONS(18432), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [206557] = 24,
    ACTIONS(13239), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20721), 1,
      anon_sym_COMMA,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20810), 1,
      anon_sym_QMARK,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    STATE(13201), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13241), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [206635] = 24,
    ACTIONS(13243), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20721), 1,
      anon_sym_COMMA,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20810), 1,
      anon_sym_QMARK,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    STATE(13201), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13245), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [206713] = 24,
    ACTIONS(12926), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20721), 1,
      anon_sym_COMMA,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20810), 1,
      anon_sym_QMARK,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    STATE(13201), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12934), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [206791] = 24,
    ACTIONS(13239), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20838), 1,
      anon_sym_COMMA,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20846), 1,
      anon_sym_QMARK,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    STATE(13367), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13241), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [206869] = 24,
    ACTIONS(13243), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20838), 1,
      anon_sym_COMMA,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20846), 1,
      anon_sym_QMARK,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    STATE(13367), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13245), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [206947] = 24,
    ACTIONS(12926), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20838), 1,
      anon_sym_COMMA,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20846), 1,
      anon_sym_QMARK,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    STATE(13367), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12934), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [207025] = 5,
    ACTIONS(20874), 1,
      anon_sym_COMMA,
    STATE(13381), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13070), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13075), 18,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [207065] = 16,
    ACTIONS(13334), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [207127] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [207175] = 14,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [207233] = 22,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20533), 1,
      anon_sym_QMARK,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [207307] = 20,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
  [207377] = 18,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [207443] = 17,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [207507] = 12,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [207561] = 14,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [207619] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [207667] = 8,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [207713] = 7,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [207757] = 6,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [207799] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 18,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [207839] = 14,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [207897] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18608), 1,
      anon_sym_EQ,
    ACTIONS(13247), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13249), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [207937] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(20651), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [207987] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(20651), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [208037] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(13306), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [208085] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [208131] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [208175] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(13306), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [208217] = 22,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13100), 4,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [208291] = 4,
    ACTIONS(18062), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [208329] = 22,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(20339), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [208403] = 20,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 6,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [208473] = 18,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 8,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [208539] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(13239), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [208579] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(18322), 1,
      anon_sym_EQ,
    ACTIONS(13249), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [208619] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(207), 1,
      anon_sym_DASH_GT,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(11397), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [208659] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13241), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20440), 1,
      anon_sym_QMARK,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    STATE(12990), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13239), 2,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [208737] = 4,
    ACTIONS(17631), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [208775] = 4,
    ACTIONS(17752), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [208813] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(13243), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [208853] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13245), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20440), 1,
      anon_sym_QMARK,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    STATE(12990), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13243), 2,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [208931] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(12926), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [208971] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(12934), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    ACTIONS(20430), 1,
      anon_sym_where,
    ACTIONS(20432), 1,
      anon_sym_COLON2,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20440), 1,
      anon_sym_QMARK,
    ACTIONS(20442), 1,
      sym__pair_operator,
    ACTIONS(20444), 1,
      sym__arrow_operator,
    ACTIONS(20446), 1,
      sym__lazy_or_operator,
    ACTIONS(20448), 1,
      sym__lazy_and_operator,
    ACTIONS(20450), 1,
      sym__pipe_right_operator,
    ACTIONS(20452), 1,
      sym__pipe_left_operator,
    ACTIONS(20454), 1,
      sym__ellipsis_operator,
    ACTIONS(20458), 1,
      sym__times_operator,
    ACTIONS(20460), 1,
      sym__rational_operator,
    ACTIONS(20462), 1,
      sym__bitshift_operator,
    ACTIONS(20464), 1,
      sym__power_operator,
    STATE(12990), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(12926), 2,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20456), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20436), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [209049] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(13245), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13243), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [209089] = 17,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 9,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [209153] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13243), 1,
      aux_sym__terminator_token1,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    STATE(12931), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13245), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [209231] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19223), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19225), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20525), 1,
      anon_sym_LF,
    ACTIONS(20726), 1,
      anon_sym_COLON2,
    ACTIONS(20730), 1,
      sym__pipe_right_operator,
    ACTIONS(20732), 1,
      sym__pipe_left_operator,
    ACTIONS(20734), 1,
      sym__ellipsis_operator,
    ACTIONS(20738), 1,
      sym__times_operator,
    ACTIONS(20740), 1,
      sym__rational_operator,
    ACTIONS(20742), 1,
      sym__bitshift_operator,
    ACTIONS(20744), 1,
      sym__power_operator,
    ACTIONS(20766), 1,
      anon_sym_where,
    ACTIONS(20768), 1,
      anon_sym_QMARK,
    ACTIONS(20770), 1,
      sym__pair_operator,
    ACTIONS(20772), 1,
      sym__arrow_operator,
    ACTIONS(20774), 1,
      sym__lazy_or_operator,
    ACTIONS(20776), 1,
      sym__lazy_and_operator,
    ACTIONS(20736), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20523), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20728), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [209305] = 12,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [209359] = 14,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [209417] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [209465] = 8,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [209511] = 7,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [209555] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20464), 1,
      sym__power_operator,
    ACTIONS(13308), 24,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [209597] = 6,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [209639] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 18,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [209679] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(19931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20703), 1,
      sym__bitshift_operator,
    ACTIONS(20705), 1,
      sym__power_operator,
    ACTIONS(20711), 1,
      sym__rational_operator,
    ACTIONS(13306), 22,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [209725] = 4,
    ACTIONS(17752), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [209763] = 4,
    ACTIONS(18370), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [209801] = 4,
    ACTIONS(18370), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [209839] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19632), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20643), 1,
      anon_sym_COLON2,
    ACTIONS(20645), 1,
      sym__pipe_right_operator,
    ACTIONS(20647), 1,
      sym__pipe_left_operator,
    ACTIONS(20649), 1,
      sym__ellipsis_operator,
    ACTIONS(20653), 1,
      sym__times_operator,
    ACTIONS(20655), 1,
      sym__rational_operator,
    ACTIONS(20657), 1,
      sym__bitshift_operator,
    ACTIONS(20659), 1,
      sym__power_operator,
    ACTIONS(20651), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20693), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [209901] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20043), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20663), 1,
      anon_sym_COLON2,
    ACTIONS(20675), 1,
      sym__pipe_right_operator,
    ACTIONS(20677), 1,
      sym__pipe_left_operator,
    ACTIONS(20679), 1,
      sym__ellipsis_operator,
    ACTIONS(20683), 1,
      sym__times_operator,
    ACTIONS(20685), 1,
      sym__rational_operator,
    ACTIONS(20687), 1,
      sym__bitshift_operator,
    ACTIONS(20689), 1,
      sym__power_operator,
    ACTIONS(20681), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20665), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 10,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [209963] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [210020] = 4,
    ACTIONS(18194), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [210057] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 15,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [210104] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13336), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20905), 1,
      anon_sym_COLON2,
    ACTIONS(20909), 1,
      sym__pipe_right_operator,
    ACTIONS(20911), 1,
      sym__pipe_left_operator,
    ACTIONS(20913), 1,
      sym__ellipsis_operator,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(20915), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20907), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 9,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [210165] = 4,
    ACTIONS(18476), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [210202] = 22,
    ACTIONS(13070), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20810), 1,
      anon_sym_QMARK,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13075), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [210275] = 4,
    ACTIONS(18476), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [210312] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 15,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [210359] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13465), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(20915), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [210408] = 8,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [210453] = 7,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [210496] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20905), 1,
      anon_sym_COLON2,
    ACTIONS(20909), 1,
      sym__pipe_right_operator,
    ACTIONS(20911), 1,
      sym__pipe_left_operator,
    ACTIONS(20913), 1,
      sym__ellipsis_operator,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(20915), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 13,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [210555] = 6,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [210596] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 17,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [210635] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20440), 1,
      anon_sym_QMARK,
    ACTIONS(20905), 1,
      anon_sym_COLON2,
    ACTIONS(20909), 1,
      sym__pipe_right_operator,
    ACTIONS(20911), 1,
      sym__pipe_left_operator,
    ACTIONS(20913), 1,
      sym__ellipsis_operator,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(20925), 1,
      anon_sym_where,
    ACTIONS(20927), 1,
      sym__pair_operator,
    ACTIONS(20929), 1,
      sym__arrow_operator,
    ACTIONS(20931), 1,
      sym__lazy_or_operator,
    ACTIONS(20933), 1,
      sym__lazy_and_operator,
    ACTIONS(20915), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 3,
      anon_sym_COMMA,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20907), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [210708] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20905), 1,
      anon_sym_COLON2,
    ACTIONS(20909), 1,
      sym__pipe_right_operator,
    ACTIONS(20911), 1,
      sym__pipe_left_operator,
    ACTIONS(20913), 1,
      sym__ellipsis_operator,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(20925), 1,
      anon_sym_where,
    ACTIONS(20929), 1,
      sym__arrow_operator,
    ACTIONS(20931), 1,
      sym__lazy_or_operator,
    ACTIONS(20933), 1,
      sym__lazy_and_operator,
    ACTIONS(20915), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20907), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
  [210777] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20905), 1,
      anon_sym_COLON2,
    ACTIONS(20909), 1,
      sym__pipe_right_operator,
    ACTIONS(20911), 1,
      sym__pipe_left_operator,
    ACTIONS(20913), 1,
      sym__ellipsis_operator,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(20925), 1,
      anon_sym_where,
    ACTIONS(20933), 1,
      sym__lazy_and_operator,
    ACTIONS(20915), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20907), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 7,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [210842] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20905), 1,
      anon_sym_COLON2,
    ACTIONS(20909), 1,
      sym__pipe_right_operator,
    ACTIONS(20911), 1,
      sym__pipe_left_operator,
    ACTIONS(20913), 1,
      sym__ellipsis_operator,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(20925), 1,
      anon_sym_where,
    ACTIONS(20915), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20907), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 8,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [210905] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20905), 1,
      anon_sym_COLON2,
    ACTIONS(20913), 1,
      sym__ellipsis_operator,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(20915), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [210960] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20905), 1,
      anon_sym_COLON2,
    ACTIONS(20909), 1,
      sym__pipe_right_operator,
    ACTIONS(20911), 1,
      sym__pipe_left_operator,
    ACTIONS(20913), 1,
      sym__ellipsis_operator,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(20915), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 13,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [211019] = 4,
    ACTIONS(17822), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [211056] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(20915), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [211105] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(13306), 20,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [211152] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(13306), 21,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [211197] = 22,
    ACTIONS(13070), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20846), 1,
      anon_sym_QMARK,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13075), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [211270] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 17,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [211309] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(13306), 22,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [211352] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13312), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(13306), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [211393] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13310), 1,
      anon_sym_LF,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(13308), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [211434] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20935), 1,
      anon_sym_COLON2,
    ACTIONS(20937), 1,
      sym__ellipsis_operator,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20939), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [211489] = 22,
    ACTIONS(13338), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20810), 1,
      anon_sym_QMARK,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13340), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [211562] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20935), 1,
      anon_sym_COLON2,
    ACTIONS(20937), 1,
      sym__ellipsis_operator,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(20949), 1,
      sym__pipe_right_operator,
    ACTIONS(20951), 1,
      sym__pipe_left_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20939), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [211621] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20939), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [211670] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 18,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [211709] = 4,
    ACTIONS(17880), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [211746] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(11408), 1,
      anon_sym_LF,
    ACTIONS(18188), 1,
      anon_sym_EQ,
    ACTIONS(11397), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [211785] = 4,
    ACTIONS(18208), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [211822] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17602), 1,
      anon_sym_DASH_GT,
    ACTIONS(17914), 1,
      anon_sym_LF,
    ACTIONS(17912), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(11397), 22,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [211863] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13306), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [211910] = 4,
    ACTIONS(18478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [211947] = 22,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(20953), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13253), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [212020] = 22,
    ACTIONS(13338), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20846), 1,
      anon_sym_QMARK,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13340), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [212093] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20838), 1,
      anon_sym_COMMA,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(20955), 1,
      anon_sym_QMARK,
    STATE(13367), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13247), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [212168] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(13310), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13308), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [212209] = 15,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [212268] = 23,
    ACTIONS(13253), 1,
      anon_sym_COMMA,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20967), 1,
      anon_sym_QMARK,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13255), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [212343] = 22,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20967), 1,
      anon_sym_QMARK,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13094), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(13100), 2,
      anon_sym_COMMA,
      sym__pair_operator,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [212416] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [212463] = 5,
    ACTIONS(17864), 1,
      anon_sym_DASH_GT,
    ACTIONS(18294), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [212502] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18294), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [212541] = 16,
    ACTIONS(13334), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 9,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [212602] = 4,
    ACTIONS(18478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [212639] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [212686] = 14,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [212743] = 22,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20846), 1,
      anon_sym_QMARK,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [212816] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20967), 1,
      anon_sym_QMARK,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(20995), 1,
      anon_sym_COMMA,
    STATE(13499), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [212891] = 20,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [212960] = 18,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [213025] = 17,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [213088] = 4,
    ACTIONS(18478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [213125] = 4,
    ACTIONS(18478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [213162] = 4,
    ACTIONS(18194), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [213199] = 5,
    ACTIONS(20995), 1,
      anon_sym_COMMA,
    STATE(13516), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13150), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13148), 16,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [213238] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [213295] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [213366] = 19,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
  [213433] = 12,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [213486] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20967), 1,
      anon_sym_QMARK,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(20995), 1,
      anon_sym_COMMA,
    STATE(13499), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [213561] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20967), 1,
      anon_sym_QMARK,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(20995), 1,
      anon_sym_COMMA,
    STATE(13499), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [213636] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20967), 1,
      anon_sym_QMARK,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(20995), 1,
      anon_sym_COMMA,
    STATE(13499), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [213711] = 4,
    ACTIONS(18152), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [213748] = 4,
    ACTIONS(17742), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [213785] = 14,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [213842] = 4,
    ACTIONS(18476), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [213879] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [213926] = 15,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21007), 1,
      anon_sym_COLON2,
    ACTIONS(21011), 1,
      sym__comparison_operator,
    ACTIONS(21013), 1,
      sym__pipe_right_operator,
    ACTIONS(21015), 1,
      sym__pipe_left_operator,
    ACTIONS(21017), 1,
      sym__ellipsis_operator,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21009), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [213985] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21007), 1,
      anon_sym_COLON2,
    ACTIONS(21013), 1,
      sym__pipe_right_operator,
    ACTIONS(21015), 1,
      sym__pipe_left_operator,
    ACTIONS(21017), 1,
      sym__ellipsis_operator,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [214042] = 21,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(21007), 1,
      anon_sym_COLON2,
    ACTIONS(21011), 1,
      sym__comparison_operator,
    ACTIONS(21013), 1,
      sym__pipe_right_operator,
    ACTIONS(21015), 1,
      sym__pipe_left_operator,
    ACTIONS(21017), 1,
      sym__ellipsis_operator,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(21029), 1,
      anon_sym_where,
    ACTIONS(21031), 1,
      sym__pair_operator,
    ACTIONS(21033), 1,
      sym__arrow_operator,
    ACTIONS(21035), 1,
      sym__lazy_or_operator,
    ACTIONS(21037), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21009), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [214113] = 4,
    ACTIONS(17798), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [214150] = 5,
    ACTIONS(21039), 1,
      anon_sym_COMMA,
    STATE(13516), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13070), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13075), 16,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [214189] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13306), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [214234] = 6,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [214275] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13306), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [214318] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13340), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [214389] = 17,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [214452] = 16,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [214513] = 12,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [214566] = 23,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20721), 1,
      anon_sym_COMMA,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(20953), 1,
      anon_sym_QMARK,
    STATE(13201), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13245), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [214641] = 4,
    ACTIONS(18476), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [214678] = 19,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21007), 1,
      anon_sym_COLON2,
    ACTIONS(21011), 1,
      sym__comparison_operator,
    ACTIONS(21013), 1,
      sym__pipe_right_operator,
    ACTIONS(21015), 1,
      sym__pipe_left_operator,
    ACTIONS(21017), 1,
      sym__ellipsis_operator,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(21029), 1,
      anon_sym_where,
    ACTIONS(21033), 1,
      sym__arrow_operator,
    ACTIONS(21035), 1,
      sym__lazy_or_operator,
    ACTIONS(21037), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21009), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 6,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [214745] = 17,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21007), 1,
      anon_sym_COLON2,
    ACTIONS(21011), 1,
      sym__comparison_operator,
    ACTIONS(21013), 1,
      sym__pipe_right_operator,
    ACTIONS(21015), 1,
      sym__pipe_left_operator,
    ACTIONS(21017), 1,
      sym__ellipsis_operator,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(21029), 1,
      anon_sym_where,
    ACTIONS(21037), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21009), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 8,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [214808] = 8,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 5,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [214853] = 7,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [214896] = 6,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [214937] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 18,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [214976] = 16,
    ACTIONS(13334), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 9,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [215037] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [215084] = 16,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21007), 1,
      anon_sym_COLON2,
    ACTIONS(21011), 1,
      sym__comparison_operator,
    ACTIONS(21013), 1,
      sym__pipe_right_operator,
    ACTIONS(21015), 1,
      sym__pipe_left_operator,
    ACTIONS(21017), 1,
      sym__ellipsis_operator,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(21029), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21009), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 9,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [215145] = 12,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21007), 1,
      anon_sym_COLON2,
    ACTIONS(21017), 1,
      sym__ellipsis_operator,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [215198] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13306), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token1,
  [215239] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21007), 1,
      anon_sym_COLON2,
    ACTIONS(21013), 1,
      sym__pipe_right_operator,
    ACTIONS(21015), 1,
      sym__pipe_left_operator,
    ACTIONS(21017), 1,
      sym__ellipsis_operator,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [215296] = 8,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [215341] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [215380] = 5,
    ACTIONS(17864), 1,
      anon_sym_DASH_GT,
    ACTIONS(18272), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [215419] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18272), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [215458] = 7,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [215501] = 6,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [215542] = 21,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(20953), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13100), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      sym__pair_operator,
  [215613] = 14,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [215670] = 21,
    ACTIONS(18326), 1,
      anon_sym_where,
    ACTIONS(18332), 1,
      anon_sym_COLON2,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(18344), 1,
      sym__pair_operator,
    ACTIONS(18346), 1,
      sym__arrow_operator,
    ACTIONS(18348), 1,
      sym__lazy_or_operator,
    ACTIONS(18350), 1,
      sym__lazy_and_operator,
    ACTIONS(18352), 1,
      sym__comparison_operator,
    ACTIONS(18354), 1,
      sym__pipe_right_operator,
    ACTIONS(18356), 1,
      sym__pipe_left_operator,
    ACTIONS(18358), 1,
      sym__ellipsis_operator,
    ACTIONS(18362), 1,
      sym__times_operator,
    ACTIONS(18364), 1,
      sym__rational_operator,
    ACTIONS(18366), 1,
      sym__bitshift_operator,
    ACTIONS(18368), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18360), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(18334), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(14993), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [215741] = 23,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20721), 1,
      anon_sym_COMMA,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(20953), 1,
      anon_sym_QMARK,
    STATE(13201), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13247), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [215816] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 18,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [215855] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [215894] = 23,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20721), 1,
      anon_sym_COMMA,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(20953), 1,
      anon_sym_QMARK,
    STATE(13201), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12934), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [215969] = 4,
    ACTIONS(18194), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [216006] = 4,
    ACTIONS(18194), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [216043] = 21,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18342), 1,
      anon_sym_QMARK,
    ACTIONS(21007), 1,
      anon_sym_COLON2,
    ACTIONS(21011), 1,
      sym__comparison_operator,
    ACTIONS(21013), 1,
      sym__pipe_right_operator,
    ACTIONS(21015), 1,
      sym__pipe_left_operator,
    ACTIONS(21017), 1,
      sym__ellipsis_operator,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(21029), 1,
      anon_sym_where,
    ACTIONS(21031), 1,
      sym__pair_operator,
    ACTIONS(21033), 1,
      sym__arrow_operator,
    ACTIONS(21035), 1,
      sym__lazy_or_operator,
    ACTIONS(21037), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21009), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13340), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [216114] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17832), 1,
      anon_sym_COMMA,
    ACTIONS(17834), 1,
      anon_sym_LF,
    ACTIONS(17836), 1,
      aux_sym__terminator_token1,
    STATE(16534), 1,
      aux_sym__do_parameter_list_repeat1,
    ACTIONS(11397), 22,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [216157] = 16,
    ACTIONS(13334), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(21042), 1,
      anon_sym_COLON2,
    ACTIONS(21046), 1,
      sym__comparison_operator,
    ACTIONS(21048), 1,
      sym__pipe_right_operator,
    ACTIONS(21050), 1,
      sym__pipe_left_operator,
    ACTIONS(21052), 1,
      sym__ellipsis_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21044), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 9,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [216218] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [216265] = 14,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(21042), 1,
      anon_sym_COLON2,
    ACTIONS(21048), 1,
      sym__pipe_right_operator,
    ACTIONS(21050), 1,
      sym__pipe_left_operator,
    ACTIONS(21052), 1,
      sym__ellipsis_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [216322] = 22,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(21042), 1,
      anon_sym_COLON2,
    ACTIONS(21046), 1,
      sym__comparison_operator,
    ACTIONS(21048), 1,
      sym__pipe_right_operator,
    ACTIONS(21050), 1,
      sym__pipe_left_operator,
    ACTIONS(21052), 1,
      sym__ellipsis_operator,
    ACTIONS(21054), 1,
      anon_sym_where,
    ACTIONS(21056), 1,
      anon_sym_QMARK,
    ACTIONS(21058), 1,
      sym__pair_operator,
    ACTIONS(21060), 1,
      sym__arrow_operator,
    ACTIONS(21062), 1,
      sym__lazy_or_operator,
    ACTIONS(21064), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(21044), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [216395] = 20,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(21042), 1,
      anon_sym_COLON2,
    ACTIONS(21046), 1,
      sym__comparison_operator,
    ACTIONS(21048), 1,
      sym__pipe_right_operator,
    ACTIONS(21050), 1,
      sym__pipe_left_operator,
    ACTIONS(21052), 1,
      sym__ellipsis_operator,
    ACTIONS(21054), 1,
      anon_sym_where,
    ACTIONS(21060), 1,
      sym__arrow_operator,
    ACTIONS(21062), 1,
      sym__lazy_or_operator,
    ACTIONS(21064), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21044), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 5,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [216464] = 18,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(21042), 1,
      anon_sym_COLON2,
    ACTIONS(21046), 1,
      sym__comparison_operator,
    ACTIONS(21048), 1,
      sym__pipe_right_operator,
    ACTIONS(21050), 1,
      sym__pipe_left_operator,
    ACTIONS(21052), 1,
      sym__ellipsis_operator,
    ACTIONS(21054), 1,
      anon_sym_where,
    ACTIONS(21064), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21044), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 7,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [216529] = 17,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(21042), 1,
      anon_sym_COLON2,
    ACTIONS(21046), 1,
      sym__comparison_operator,
    ACTIONS(21048), 1,
      sym__pipe_right_operator,
    ACTIONS(21050), 1,
      sym__pipe_left_operator,
    ACTIONS(21052), 1,
      sym__ellipsis_operator,
    ACTIONS(21054), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21044), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 8,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [216592] = 12,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(21042), 1,
      anon_sym_COLON2,
    ACTIONS(21052), 1,
      sym__ellipsis_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 14,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [216645] = 14,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(21042), 1,
      anon_sym_COLON2,
    ACTIONS(21048), 1,
      sym__pipe_right_operator,
    ACTIONS(21050), 1,
      sym__pipe_left_operator,
    ACTIONS(21052), 1,
      sym__ellipsis_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [216702] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [216749] = 8,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21021), 1,
      sym__times_operator,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 5,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [216794] = 7,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21023), 1,
      sym__rational_operator,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [216837] = 6,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21025), 1,
      sym__bitshift_operator,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [216878] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21027), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 18,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [216917] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20935), 1,
      anon_sym_COLON2,
    ACTIONS(20937), 1,
      sym__ellipsis_operator,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(20949), 1,
      sym__pipe_right_operator,
    ACTIONS(20951), 1,
      sym__pipe_left_operator,
    ACTIONS(13336), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20939), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21066), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13334), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [216978] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13340), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20438), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20440), 1,
      anon_sym_QMARK,
    ACTIONS(20905), 1,
      anon_sym_COLON2,
    ACTIONS(20909), 1,
      sym__pipe_right_operator,
    ACTIONS(20911), 1,
      sym__pipe_left_operator,
    ACTIONS(20913), 1,
      sym__ellipsis_operator,
    ACTIONS(20917), 1,
      sym__times_operator,
    ACTIONS(20919), 1,
      sym__rational_operator,
    ACTIONS(20921), 1,
      sym__bitshift_operator,
    ACTIONS(20923), 1,
      sym__power_operator,
    ACTIONS(20925), 1,
      anon_sym_where,
    ACTIONS(20927), 1,
      sym__pair_operator,
    ACTIONS(20929), 1,
      sym__arrow_operator,
    ACTIONS(20931), 1,
      sym__lazy_or_operator,
    ACTIONS(20933), 1,
      sym__lazy_and_operator,
    ACTIONS(20915), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13338), 3,
      anon_sym_COMMA,
      anon_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(20907), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [217051] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(13465), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20939), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [217100] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(20955), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13100), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [217171] = 22,
    ACTIONS(13338), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(21042), 1,
      anon_sym_COLON2,
    ACTIONS(21046), 1,
      sym__comparison_operator,
    ACTIONS(21048), 1,
      sym__pipe_right_operator,
    ACTIONS(21050), 1,
      sym__pipe_left_operator,
    ACTIONS(21052), 1,
      sym__ellipsis_operator,
    ACTIONS(21054), 1,
      anon_sym_where,
    ACTIONS(21056), 1,
      anon_sym_QMARK,
    ACTIONS(21058), 1,
      sym__pair_operator,
    ACTIONS(21060), 1,
      sym__arrow_operator,
    ACTIONS(21062), 1,
      sym__lazy_or_operator,
    ACTIONS(21064), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13340), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(21044), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [217244] = 15,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20935), 1,
      anon_sym_COLON2,
    ACTIONS(20937), 1,
      sym__ellipsis_operator,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(20949), 1,
      sym__pipe_right_operator,
    ACTIONS(20951), 1,
      sym__pipe_left_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20939), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token1,
  [217303] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    ACTIONS(20935), 1,
      anon_sym_COLON2,
    ACTIONS(20937), 1,
      sym__ellipsis_operator,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(20949), 1,
      sym__pipe_right_operator,
    ACTIONS(20951), 1,
      sym__pipe_left_operator,
    ACTIONS(21068), 1,
      anon_sym_where,
    ACTIONS(21070), 1,
      sym__pair_operator,
    ACTIONS(21072), 1,
      sym__arrow_operator,
    ACTIONS(21074), 1,
      sym__lazy_or_operator,
    ACTIONS(21076), 1,
      sym__lazy_and_operator,
    ACTIONS(13338), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(13340), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20939), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21066), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [217376] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    ACTIONS(20935), 1,
      anon_sym_COLON2,
    ACTIONS(20937), 1,
      sym__ellipsis_operator,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(20949), 1,
      sym__pipe_right_operator,
    ACTIONS(20951), 1,
      sym__pipe_left_operator,
    ACTIONS(21068), 1,
      anon_sym_where,
    ACTIONS(21070), 1,
      sym__pair_operator,
    ACTIONS(21072), 1,
      sym__arrow_operator,
    ACTIONS(21074), 1,
      sym__lazy_or_operator,
    ACTIONS(21076), 1,
      sym__lazy_and_operator,
    ACTIONS(13306), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20939), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21066), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [217449] = 20,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20935), 1,
      anon_sym_COLON2,
    ACTIONS(20937), 1,
      sym__ellipsis_operator,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(20949), 1,
      sym__pipe_right_operator,
    ACTIONS(20951), 1,
      sym__pipe_left_operator,
    ACTIONS(21068), 1,
      anon_sym_where,
    ACTIONS(21072), 1,
      sym__arrow_operator,
    ACTIONS(21074), 1,
      sym__lazy_or_operator,
    ACTIONS(21076), 1,
      sym__lazy_and_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20939), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token1,
    ACTIONS(21066), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [217518] = 7,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [217561] = 4,
    ACTIONS(18194), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217598] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [217637] = 4,
    ACTIONS(18208), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217674] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20838), 1,
      anon_sym_COMMA,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(20955), 1,
      anon_sym_QMARK,
    STATE(13367), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13241), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [217749] = 4,
    ACTIONS(18208), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217786] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20838), 1,
      anon_sym_COMMA,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(20955), 1,
      anon_sym_QMARK,
    STATE(13367), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13245), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [217861] = 22,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20810), 1,
      anon_sym_QMARK,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [217934] = 20,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 5,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
  [218003] = 18,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 7,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [218068] = 17,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 8,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [218131] = 4,
    ACTIONS(18208), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [218168] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20838), 1,
      anon_sym_COMMA,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(20955), 1,
      anon_sym_QMARK,
    STATE(13367), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12934), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [218243] = 12,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [218296] = 4,
    ACTIONS(17880), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [218333] = 14,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [218390] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [218437] = 8,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [218482] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [218521] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20935), 1,
      anon_sym_COLON2,
    ACTIONS(20937), 1,
      sym__ellipsis_operator,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(20949), 1,
      sym__pipe_right_operator,
    ACTIONS(20951), 1,
      sym__pipe_left_operator,
    ACTIONS(21068), 1,
      anon_sym_where,
    ACTIONS(21076), 1,
      sym__lazy_and_operator,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20939), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21066), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token1,
  [218586] = 4,
    ACTIONS(18208), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [218623] = 22,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(20955), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13253), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [218696] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20935), 1,
      anon_sym_COLON2,
    ACTIONS(20937), 1,
      sym__ellipsis_operator,
    ACTIONS(20941), 1,
      sym__times_operator,
    ACTIONS(20943), 1,
      sym__rational_operator,
    ACTIONS(20945), 1,
      sym__bitshift_operator,
    ACTIONS(20947), 1,
      sym__power_operator,
    ACTIONS(20949), 1,
      sym__pipe_right_operator,
    ACTIONS(20951), 1,
      sym__pipe_left_operator,
    ACTIONS(21068), 1,
      anon_sym_where,
    ACTIONS(13312), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(20939), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21066), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(13306), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token1,
  [218759] = 23,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20721), 1,
      anon_sym_COMMA,
    ACTIONS(20804), 1,
      anon_sym_where,
    ACTIONS(20806), 1,
      anon_sym_COLON2,
    ACTIONS(20812), 1,
      sym__pair_operator,
    ACTIONS(20814), 1,
      sym__arrow_operator,
    ACTIONS(20816), 1,
      sym__lazy_or_operator,
    ACTIONS(20818), 1,
      sym__lazy_and_operator,
    ACTIONS(20820), 1,
      sym__comparison_operator,
    ACTIONS(20822), 1,
      sym__pipe_right_operator,
    ACTIONS(20824), 1,
      sym__pipe_left_operator,
    ACTIONS(20826), 1,
      sym__ellipsis_operator,
    ACTIONS(20830), 1,
      sym__times_operator,
    ACTIONS(20832), 1,
      sym__rational_operator,
    ACTIONS(20834), 1,
      sym__bitshift_operator,
    ACTIONS(20836), 1,
      sym__power_operator,
    ACTIONS(20953), 1,
      anon_sym_QMARK,
    STATE(13201), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13241), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(20828), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20808), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [218834] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [218881] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21078), 1,
      anon_sym_COMMA,
    ACTIONS(21080), 1,
      anon_sym_RBRACE,
    STATE(17255), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [218955] = 5,
    ACTIONS(14543), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [218993] = 23,
    ACTIONS(10044), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21082), 1,
      anon_sym_COMMA,
    STATE(17140), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [219067] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18654), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [219105] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18654), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [219143] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21084), 1,
      anon_sym_COMMA,
    ACTIONS(21086), 1,
      anon_sym_RBRACE,
    STATE(16949), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [219217] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21088), 1,
      anon_sym_COMMA,
    ACTIONS(21090), 1,
      anon_sym_RBRACE,
    STATE(16904), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [219291] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(14993), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [219361] = 23,
    ACTIONS(9066), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21092), 1,
      anon_sym_COMMA,
    STATE(16716), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [219435] = 5,
    ACTIONS(13342), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [219473] = 23,
    ACTIONS(9020), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21094), 1,
      anon_sym_COMMA,
    STATE(16899), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [219547] = 5,
    ACTIONS(13342), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [219585] = 23,
    ACTIONS(8610), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21096), 1,
      anon_sym_COMMA,
    STATE(16938), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [219659] = 6,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18086), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18088), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 15,
      anon_sym_where,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [219699] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21098), 1,
      anon_sym_COLON,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [219773] = 23,
    ACTIONS(9188), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21102), 1,
      anon_sym_COMMA,
    STATE(16727), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [219847] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21104), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [219921] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18608), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [219959] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18608), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [219997] = 5,
    ACTIONS(13411), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [220035] = 23,
    ACTIONS(13239), 1,
      anon_sym_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(20995), 1,
      anon_sym_COMMA,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    STATE(13499), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [220109] = 5,
    ACTIONS(13411), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [220147] = 23,
    ACTIONS(13243), 1,
      anon_sym_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(20995), 1,
      anon_sym_COMMA,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    STATE(13499), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [220221] = 23,
    ACTIONS(12926), 1,
      anon_sym_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(20995), 1,
      anon_sym_COMMA,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    STATE(13499), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [220295] = 23,
    ACTIONS(10082), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21106), 1,
      anon_sym_COMMA,
    STATE(17010), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [220369] = 23,
    ACTIONS(9226), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21108), 1,
      anon_sym_COMMA,
    STATE(16964), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [220443] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21110), 1,
      anon_sym_COMMA,
    ACTIONS(21112), 1,
      anon_sym_RBRACE,
    STATE(16774), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [220517] = 5,
    ACTIONS(12462), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [220555] = 5,
    ACTIONS(12462), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [220593] = 5,
    ACTIONS(14872), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [220631] = 5,
    ACTIONS(14872), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [220669] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21114), 1,
      anon_sym_COMMA,
    ACTIONS(21116), 1,
      anon_sym_RBRACE,
    STATE(16833), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [220743] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21118), 1,
      anon_sym_COMMA,
    ACTIONS(21120), 1,
      anon_sym_RBRACE,
    STATE(17202), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [220817] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21122), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [220891] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21124), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [220965] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18322), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [221003] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18322), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [221041] = 23,
    ACTIONS(10118), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21126), 1,
      anon_sym_COMMA,
    STATE(17247), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [221115] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18430), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [221153] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18430), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [221191] = 23,
    ACTIONS(9378), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21128), 1,
      anon_sym_COMMA,
    STATE(16901), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [221265] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21130), 1,
      anon_sym_COMMA,
    ACTIONS(21132), 1,
      anon_sym_RBRACE,
    STATE(17186), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [221339] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21134), 1,
      anon_sym_COMMA,
    ACTIONS(21136), 1,
      anon_sym_RBRACE,
    STATE(17290), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [221413] = 5,
    ACTIONS(12418), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [221451] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21138), 1,
      anon_sym_COMMA,
    ACTIONS(21140), 1,
      anon_sym_RBRACE,
    STATE(16947), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [221525] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21142), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [221599] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21144), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [221673] = 23,
    ACTIONS(9452), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21146), 1,
      anon_sym_COMMA,
    STATE(16659), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [221747] = 4,
    ACTIONS(18272), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [221783] = 23,
    ACTIONS(10158), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21148), 1,
      anon_sym_COMMA,
    STATE(17240), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [221857] = 23,
    ACTIONS(8982), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21150), 1,
      anon_sym_COMMA,
    STATE(16674), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [221931] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21152), 1,
      anon_sym_COMMA,
    ACTIONS(21154), 1,
      anon_sym_RBRACE,
    STATE(17014), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [222005] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21156), 1,
      anon_sym_COMMA,
    ACTIONS(21158), 1,
      anon_sym_RBRACE,
    STATE(17224), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [222079] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21160), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [222153] = 15,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21162), 1,
      anon_sym_COLON2,
    ACTIONS(21166), 1,
      sym__comparison_operator,
    ACTIONS(21168), 1,
      sym__pipe_right_operator,
    ACTIONS(21170), 1,
      sym__pipe_left_operator,
    ACTIONS(21172), 1,
      sym__ellipsis_operator,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21174), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21164), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 9,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [222211] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18570), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [222249] = 23,
    ACTIONS(9678), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21184), 1,
      anon_sym_COMMA,
    STATE(16820), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [222323] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21174), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [222369] = 23,
    ACTIONS(10194), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21186), 1,
      anon_sym_COMMA,
    STATE(16959), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [222443] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21162), 1,
      anon_sym_COLON2,
    ACTIONS(21168), 1,
      sym__pipe_right_operator,
    ACTIONS(21170), 1,
      sym__pipe_left_operator,
    ACTIONS(21172), 1,
      sym__ellipsis_operator,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21174), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [222499] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21188), 1,
      anon_sym_COMMA,
    ACTIONS(21190), 1,
      anon_sym_RBRACE,
    STATE(17305), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [222573] = 5,
    ACTIONS(14616), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [222611] = 5,
    ACTIONS(14616), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [222649] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21192), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [222723] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21194), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [222797] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20955), 1,
      anon_sym_QMARK,
    ACTIONS(21162), 1,
      anon_sym_COLON2,
    ACTIONS(21166), 1,
      sym__comparison_operator,
    ACTIONS(21168), 1,
      sym__pipe_right_operator,
    ACTIONS(21170), 1,
      sym__pipe_left_operator,
    ACTIONS(21172), 1,
      sym__ellipsis_operator,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(21196), 1,
      anon_sym_where,
    ACTIONS(21198), 1,
      sym__pair_operator,
    ACTIONS(21200), 1,
      sym__arrow_operator,
    ACTIONS(21202), 1,
      sym__lazy_or_operator,
    ACTIONS(21204), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21174), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(21164), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [222867] = 19,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21162), 1,
      anon_sym_COLON2,
    ACTIONS(21166), 1,
      sym__comparison_operator,
    ACTIONS(21168), 1,
      sym__pipe_right_operator,
    ACTIONS(21170), 1,
      sym__pipe_left_operator,
    ACTIONS(21172), 1,
      sym__ellipsis_operator,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(21196), 1,
      anon_sym_where,
    ACTIONS(21200), 1,
      sym__arrow_operator,
    ACTIONS(21202), 1,
      sym__lazy_or_operator,
    ACTIONS(21204), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21174), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21164), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [222933] = 21,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21206), 1,
      anon_sym_where,
    ACTIONS(21208), 1,
      anon_sym_COLON2,
    ACTIONS(21212), 1,
      anon_sym_QMARK,
    ACTIONS(21214), 1,
      sym__pair_operator,
    ACTIONS(21216), 1,
      sym__arrow_operator,
    ACTIONS(21218), 1,
      sym__lazy_or_operator,
    ACTIONS(21220), 1,
      sym__lazy_and_operator,
    ACTIONS(21222), 1,
      sym__comparison_operator,
    ACTIONS(21224), 1,
      sym__pipe_right_operator,
    ACTIONS(21226), 1,
      sym__pipe_left_operator,
    ACTIONS(21228), 1,
      sym__ellipsis_operator,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21230), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13340), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(21210), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [223003] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18570), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [223041] = 15,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21240), 1,
      anon_sym_COLON2,
    ACTIONS(21244), 1,
      sym__comparison_operator,
    ACTIONS(21246), 1,
      sym__pipe_right_operator,
    ACTIONS(21248), 1,
      sym__pipe_left_operator,
    ACTIONS(21250), 1,
      sym__ellipsis_operator,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21242), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 9,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [223099] = 22,
    ACTIONS(13075), 1,
      anon_sym_COMMA,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20967), 1,
      anon_sym_QMARK,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13070), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [223171] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21262), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [223245] = 23,
    ACTIONS(10232), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21264), 1,
      anon_sym_COMMA,
    STATE(16662), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [223319] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18518), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [223357] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [223403] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18518), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [223441] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21240), 1,
      anon_sym_COLON2,
    ACTIONS(21246), 1,
      sym__pipe_right_operator,
    ACTIONS(21248), 1,
      sym__pipe_left_operator,
    ACTIONS(21250), 1,
      sym__ellipsis_operator,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [223497] = 17,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21162), 1,
      anon_sym_COLON2,
    ACTIONS(21166), 1,
      sym__comparison_operator,
    ACTIONS(21168), 1,
      sym__pipe_right_operator,
    ACTIONS(21170), 1,
      sym__pipe_left_operator,
    ACTIONS(21172), 1,
      sym__ellipsis_operator,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(21196), 1,
      anon_sym_where,
    ACTIONS(21204), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21174), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21164), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [223559] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21266), 1,
      anon_sym_COMMA,
    ACTIONS(21268), 1,
      anon_sym_RBRACE,
    STATE(16950), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [223633] = 21,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20953), 1,
      anon_sym_QMARK,
    ACTIONS(21240), 1,
      anon_sym_COLON2,
    ACTIONS(21244), 1,
      sym__comparison_operator,
    ACTIONS(21246), 1,
      sym__pipe_right_operator,
    ACTIONS(21248), 1,
      sym__pipe_left_operator,
    ACTIONS(21250), 1,
      sym__ellipsis_operator,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(21270), 1,
      anon_sym_where,
    ACTIONS(21272), 1,
      sym__pair_operator,
    ACTIONS(21274), 1,
      sym__arrow_operator,
    ACTIONS(21276), 1,
      sym__lazy_or_operator,
    ACTIONS(21278), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(21242), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [223703] = 19,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21240), 1,
      anon_sym_COLON2,
    ACTIONS(21244), 1,
      sym__comparison_operator,
    ACTIONS(21246), 1,
      sym__pipe_right_operator,
    ACTIONS(21248), 1,
      sym__pipe_left_operator,
    ACTIONS(21250), 1,
      sym__ellipsis_operator,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(21270), 1,
      anon_sym_where,
    ACTIONS(21274), 1,
      sym__arrow_operator,
    ACTIONS(21276), 1,
      sym__lazy_or_operator,
    ACTIONS(21278), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21242), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 5,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
  [223769] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21280), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [223843] = 17,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21240), 1,
      anon_sym_COLON2,
    ACTIONS(21244), 1,
      sym__comparison_operator,
    ACTIONS(21246), 1,
      sym__pipe_right_operator,
    ACTIONS(21248), 1,
      sym__pipe_left_operator,
    ACTIONS(21250), 1,
      sym__ellipsis_operator,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(21270), 1,
      anon_sym_where,
    ACTIONS(21278), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21242), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 7,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [223905] = 16,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21240), 1,
      anon_sym_COLON2,
    ACTIONS(21244), 1,
      sym__comparison_operator,
    ACTIONS(21246), 1,
      sym__pipe_right_operator,
    ACTIONS(21248), 1,
      sym__pipe_left_operator,
    ACTIONS(21250), 1,
      sym__ellipsis_operator,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(21270), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21242), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 8,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [223965] = 12,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21240), 1,
      anon_sym_COLON2,
    ACTIONS(21250), 1,
      sym__ellipsis_operator,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [224017] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21240), 1,
      anon_sym_COLON2,
    ACTIONS(21246), 1,
      sym__pipe_right_operator,
    ACTIONS(21248), 1,
      sym__pipe_left_operator,
    ACTIONS(21250), 1,
      sym__ellipsis_operator,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [224073] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [224119] = 21,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(21042), 1,
      anon_sym_COLON2,
    ACTIONS(21046), 1,
      sym__comparison_operator,
    ACTIONS(21048), 1,
      sym__pipe_right_operator,
    ACTIONS(21050), 1,
      sym__pipe_left_operator,
    ACTIONS(21052), 1,
      sym__ellipsis_operator,
    ACTIONS(21054), 1,
      anon_sym_where,
    ACTIONS(21058), 1,
      sym__pair_operator,
    ACTIONS(21060), 1,
      sym__arrow_operator,
    ACTIONS(21062), 1,
      sym__lazy_or_operator,
    ACTIONS(21064), 1,
      sym__lazy_and_operator,
    ACTIONS(21212), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21044), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(21282), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [224189] = 16,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21162), 1,
      anon_sym_COLON2,
    ACTIONS(21166), 1,
      sym__comparison_operator,
    ACTIONS(21168), 1,
      sym__pipe_right_operator,
    ACTIONS(21170), 1,
      sym__pipe_left_operator,
    ACTIONS(21172), 1,
      sym__ellipsis_operator,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(21196), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21174), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21164), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [224249] = 8,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 5,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [224293] = 12,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21162), 1,
      anon_sym_COLON2,
    ACTIONS(21172), 1,
      sym__ellipsis_operator,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21174), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [224345] = 7,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [224387] = 6,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [224427] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [224465] = 23,
    ACTIONS(10268), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21284), 1,
      anon_sym_COMMA,
    STATE(17233), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [224539] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21286), 1,
      anon_sym_COMMA,
    ACTIONS(21288), 1,
      anon_sym_RBRACE,
    STATE(16863), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [224613] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21290), 1,
      anon_sym_COMMA,
    ACTIONS(21292), 1,
      anon_sym_RBRACE,
    STATE(17185), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [224687] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21294), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [224761] = 21,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20953), 1,
      anon_sym_QMARK,
    ACTIONS(21240), 1,
      anon_sym_COLON2,
    ACTIONS(21244), 1,
      sym__comparison_operator,
    ACTIONS(21246), 1,
      sym__pipe_right_operator,
    ACTIONS(21248), 1,
      sym__pipe_left_operator,
    ACTIONS(21250), 1,
      sym__ellipsis_operator,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(21270), 1,
      anon_sym_where,
    ACTIONS(21272), 1,
      sym__pair_operator,
    ACTIONS(21274), 1,
      sym__arrow_operator,
    ACTIONS(21276), 1,
      sym__lazy_or_operator,
    ACTIONS(21278), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13340), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(21242), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [224831] = 23,
    ACTIONS(9566), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21296), 1,
      anon_sym_COMMA,
    STATE(16884), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [224905] = 23,
    ACTIONS(10304), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21298), 1,
      anon_sym_COMMA,
    STATE(16869), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [224979] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21162), 1,
      anon_sym_COLON2,
    ACTIONS(21168), 1,
      sym__pipe_right_operator,
    ACTIONS(21170), 1,
      sym__pipe_left_operator,
    ACTIONS(21172), 1,
      sym__ellipsis_operator,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21174), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [225035] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21300), 1,
      anon_sym_COMMA,
    ACTIONS(21302), 1,
      anon_sym_RBRACE,
    STATE(16900), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225109] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21304), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225183] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21174), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [225229] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21306), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225303] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [225341] = 5,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [225379] = 8,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 5,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [225423] = 23,
    ACTIONS(8904), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21308), 1,
      anon_sym_COMMA,
    STATE(17134), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225497] = 23,
    ACTIONS(9714), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21310), 1,
      anon_sym_COMMA,
    STATE(17136), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225571] = 7,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [225613] = 6,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [225653] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18370), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [225691] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18370), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [225729] = 23,
    ACTIONS(8818), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21312), 1,
      anon_sym_COMMA,
    STATE(17182), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225803] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18466), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [225841] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18466), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [225879] = 23,
    ACTIONS(10338), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21314), 1,
      anon_sym_COMMA,
    STATE(17102), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225953] = 6,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18112), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18114), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 15,
      anon_sym_where,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [225993] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21316), 1,
      anon_sym_COMMA,
    ACTIONS(21318), 1,
      anon_sym_RBRACE,
    STATE(17151), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [226067] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21320), 1,
      anon_sym_COMMA,
    ACTIONS(21322), 1,
      anon_sym_RBRACE,
    STATE(17283), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [226141] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [226179] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21324), 1,
      anon_sym_COMMA,
    ACTIONS(21326), 1,
      anon_sym_RBRACE,
    STATE(17321), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [226253] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21328), 1,
      anon_sym_COMMA,
    ACTIONS(21330), 1,
      anon_sym_RBRACE,
    STATE(16853), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [226327] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21332), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [226401] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21334), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [226475] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21336), 1,
      anon_sym_COMMA,
    ACTIONS(21338), 1,
      anon_sym_RBRACE,
    STATE(16891), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [226549] = 23,
    ACTIONS(9750), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21340), 1,
      anon_sym_COMMA,
    STATE(17225), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [226623] = 5,
    ACTIONS(12610), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [226661] = 5,
    ACTIONS(12610), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [226699] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21342), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [226773] = 23,
    ACTIONS(10372), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21344), 1,
      anon_sym_COMMA,
    STATE(17326), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [226847] = 5,
    ACTIONS(12220), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [226885] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21346), 1,
      anon_sym_COMMA,
    ACTIONS(21348), 1,
      anon_sym_RBRACE,
    STATE(17319), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [226959] = 5,
    ACTIONS(12220), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [226997] = 6,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18032), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18034), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 15,
      anon_sym_where,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [227037] = 4,
    ACTIONS(18294), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [227073] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [227111] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21350), 1,
      anon_sym_COMMA,
    ACTIONS(21352), 1,
      anon_sym_RBRACE,
    STATE(16671), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [227185] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21354), 1,
      anon_sym_COMMA,
    ACTIONS(21356), 1,
      anon_sym_RBRACE,
    STATE(16860), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [227259] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21358), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [227333] = 5,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [227371] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21360), 1,
      anon_sym_COMMA,
    ACTIONS(21362), 1,
      anon_sym_RBRACE,
    STATE(16822), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [227445] = 6,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18130), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18132), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 15,
      anon_sym_where,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [227485] = 23,
    ACTIONS(9786), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21364), 1,
      anon_sym_COMMA,
    STATE(17324), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [227559] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21366), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [227633] = 22,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13100), 2,
      anon_sym_RPAREN,
      sym__pair_operator,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [227705] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18194), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [227743] = 23,
    ACTIONS(9416), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21368), 1,
      anon_sym_COMMA,
    STATE(16913), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [227817] = 5,
    ACTIONS(14870), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [227855] = 5,
    ACTIONS(14870), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [227893] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21370), 1,
      anon_sym_COMMA,
    ACTIONS(21372), 1,
      anon_sym_RBRACE,
    STATE(16785), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [227967] = 23,
    ACTIONS(9860), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21374), 1,
      anon_sym_COMMA,
    STATE(16718), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228041] = 23,
    ACTIONS(13249), 1,
      anon_sym_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(20995), 1,
      anon_sym_COMMA,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    STATE(16172), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228115] = 4,
    ACTIONS(18294), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228151] = 4,
    ACTIONS(18294), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228187] = 4,
    ACTIONS(18294), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228223] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [228261] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21376), 1,
      anon_sym_COMMA,
    ACTIONS(21378), 1,
      anon_sym_RBRACE,
    STATE(16803), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228335] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18432), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228373] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18432), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228411] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21380), 1,
      anon_sym_COMMA,
    ACTIONS(21382), 1,
      anon_sym_RBRACE,
    STATE(16846), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228485] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21384), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228559] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21386), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228633] = 23,
    ACTIONS(9026), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21388), 1,
      anon_sym_COMMA,
    STATE(16984), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228707] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21390), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228781] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21392), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228855] = 4,
    ACTIONS(18434), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13249), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13247), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228891] = 21,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20953), 1,
      anon_sym_QMARK,
    ACTIONS(21240), 1,
      anon_sym_COLON2,
    ACTIONS(21244), 1,
      sym__comparison_operator,
    ACTIONS(21246), 1,
      sym__pipe_right_operator,
    ACTIONS(21248), 1,
      sym__pipe_left_operator,
    ACTIONS(21250), 1,
      sym__ellipsis_operator,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(21270), 1,
      anon_sym_where,
    ACTIONS(21272), 1,
      sym__pair_operator,
    ACTIONS(21274), 1,
      sym__arrow_operator,
    ACTIONS(21276), 1,
      sym__lazy_or_operator,
    ACTIONS(21278), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21242), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(21394), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
  [228961] = 4,
    ACTIONS(18434), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13239), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13241), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228997] = 4,
    ACTIONS(18434), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13243), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13245), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [229033] = 4,
    ACTIONS(18434), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12926), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12934), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [229069] = 22,
    ACTIONS(13340), 1,
      anon_sym_COMMA,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20967), 1,
      anon_sym_QMARK,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13338), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [229141] = 23,
    ACTIONS(9266), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21396), 1,
      anon_sym_COMMA,
    STATE(16768), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [229215] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [229253] = 5,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [229291] = 23,
    ACTIONS(10404), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21398), 1,
      anon_sym_COMMA,
    STATE(16795), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [229365] = 4,
    ACTIONS(18294), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [229401] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21400), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [229475] = 5,
    ACTIONS(12450), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [229513] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21402), 1,
      anon_sym_COMMA,
    ACTIONS(21404), 1,
      anon_sym_RBRACE,
    STATE(17028), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [229587] = 5,
    ACTIONS(12450), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [229625] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21406), 1,
      anon_sym_COMMA,
    ACTIONS(21408), 1,
      anon_sym_RBRACE,
    STATE(17126), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [229699] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18520), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [229737] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21410), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [229811] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21412), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [229885] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21230), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 15,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [229931] = 9,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21230), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 15,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [229977] = 8,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 5,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [230021] = 7,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [230063] = 6,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 16,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [230103] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 17,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [230141] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18520), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [230179] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21414), 1,
      anon_sym_COMMA,
    ACTIONS(21416), 1,
      anon_sym_RBRACE,
    STATE(16837), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [230253] = 5,
    ACTIONS(12732), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [230291] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 17,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [230329] = 23,
    ACTIONS(9894), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21418), 1,
      anon_sym_COMMA,
    STATE(16966), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [230403] = 23,
    ACTIONS(9602), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21420), 1,
      anon_sym_COMMA,
    STATE(17173), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [230477] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21422), 1,
      anon_sym_COMMA,
    ACTIONS(21424), 1,
      anon_sym_RBRACE,
    STATE(17298), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [230551] = 23,
    ACTIONS(9822), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21426), 1,
      anon_sym_COMMA,
    STATE(16874), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [230625] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21428), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [230699] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17914), 1,
      anon_sym_LF,
    ACTIONS(17912), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(11397), 22,
      anon_sym_where,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [230737] = 23,
    ACTIONS(10436), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21430), 1,
      anon_sym_COMMA,
    STATE(16933), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [230811] = 4,
    ACTIONS(17864), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [230847] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18294), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [230885] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18434), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [230923] = 23,
    ACTIONS(13253), 1,
      anon_sym_COMMA,
    ACTIONS(13255), 1,
      anon_sym_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [230997] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [231035] = 5,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [231073] = 22,
    ACTIONS(13094), 1,
      anon_sym_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13100), 2,
      anon_sym_COMMA,
      sym__pair_operator,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [231145] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21432), 1,
      anon_sym_COMMA,
    ACTIONS(21434), 1,
      anon_sym_RBRACE,
    STATE(16760), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [231219] = 23,
    ACTIONS(8944), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21436), 1,
      anon_sym_COMMA,
    STATE(16703), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [231293] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21438), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [231367] = 5,
    ACTIONS(12790), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [231405] = 5,
    ACTIONS(12790), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [231443] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21440), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [231517] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18434), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [231555] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20955), 1,
      anon_sym_QMARK,
    ACTIONS(21162), 1,
      anon_sym_COLON2,
    ACTIONS(21166), 1,
      sym__comparison_operator,
    ACTIONS(21168), 1,
      sym__pipe_right_operator,
    ACTIONS(21170), 1,
      sym__pipe_left_operator,
    ACTIONS(21172), 1,
      sym__ellipsis_operator,
    ACTIONS(21176), 1,
      sym__times_operator,
    ACTIONS(21178), 1,
      sym__rational_operator,
    ACTIONS(21180), 1,
      sym__bitshift_operator,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(21196), 1,
      anon_sym_where,
    ACTIONS(21198), 1,
      sym__pair_operator,
    ACTIONS(21200), 1,
      sym__arrow_operator,
    ACTIONS(21202), 1,
      sym__lazy_or_operator,
    ACTIONS(21204), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21174), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13340), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(21164), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [231625] = 23,
    ACTIONS(10472), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21442), 1,
      anon_sym_COMMA,
    STATE(17190), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [231699] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21444), 1,
      anon_sym_COMMA,
    ACTIONS(21446), 1,
      anon_sym_RBRACE,
    STATE(16912), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [231773] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21448), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [231847] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21450), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [231921] = 23,
    ACTIONS(10490), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21452), 1,
      anon_sym_COMMA,
    STATE(17262), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [231995] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21454), 1,
      anon_sym_COMMA,
    ACTIONS(21456), 1,
      anon_sym_RBRACE,
    STATE(17210), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [232069] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21458), 1,
      anon_sym_COMMA,
    ACTIONS(21460), 1,
      anon_sym_RBRACE,
    STATE(17036), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [232143] = 6,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18108), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18110), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 15,
      anon_sym_where,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [232183] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21462), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [232257] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21464), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [232331] = 23,
    ACTIONS(10510), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21466), 1,
      anon_sym_COMMA,
    STATE(17038), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [232405] = 6,
    ACTIONS(18008), 1,
      anon_sym_EQ,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18010), 2,
      anon_sym_in,
      anon_sym_u2208,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 15,
      anon_sym_where,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [232445] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21468), 1,
      anon_sym_COMMA,
    ACTIONS(21470), 1,
      anon_sym_RBRACE,
    STATE(17176), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [232519] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21472), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [232593] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21474), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [232667] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21476), 1,
      anon_sym_COMMA,
    ACTIONS(21478), 1,
      anon_sym_RBRACE,
    STATE(16975), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [232741] = 23,
    ACTIONS(10548), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21480), 1,
      anon_sym_COMMA,
    STATE(16660), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [232815] = 5,
    ACTIONS(14979), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [232853] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21482), 1,
      anon_sym_COMMA,
    ACTIONS(21484), 1,
      anon_sym_RBRACE,
    STATE(17253), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [232927] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21486), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [233001] = 5,
    ACTIONS(14979), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [233039] = 23,
    ACTIONS(10566), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21488), 1,
      anon_sym_COMMA,
    STATE(17230), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [233113] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21490), 1,
      anon_sym_COMMA,
    ACTIONS(21492), 1,
      anon_sym_RBRACE,
    STATE(17312), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [233187] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18468), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [233225] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21494), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [233299] = 5,
    ACTIONS(12732), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [233337] = 5,
    ACTIONS(12724), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [233375] = 23,
    ACTIONS(10586), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21496), 1,
      anon_sym_COMMA,
    STATE(16817), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [233449] = 5,
    ACTIONS(12724), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [233487] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18468), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [233525] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21498), 1,
      anon_sym_COMMA,
    ACTIONS(21500), 1,
      anon_sym_RBRACE,
    STATE(17327), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [233599] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21502), 1,
      anon_sym_COMMA,
    ACTIONS(21504), 1,
      anon_sym_RBRACE,
    STATE(16686), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [233673] = 23,
    ACTIONS(9146), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21506), 1,
      anon_sym_COMMA,
    STATE(17318), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [233747] = 23,
    ACTIONS(9302), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21508), 1,
      anon_sym_COMMA,
    STATE(16685), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [233821] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21510), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [233895] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21512), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [233969] = 5,
    ACTIONS(14618), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234007] = 5,
    ACTIONS(14618), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234045] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21514), 1,
      anon_sym_COMMA,
    ACTIONS(21516), 1,
      anon_sym_RBRACE,
    STATE(16656), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [234119] = 23,
    ACTIONS(10602), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21518), 1,
      anon_sym_COMMA,
    STATE(17205), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [234193] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21520), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [234267] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21522), 1,
      anon_sym_COMMA,
    ACTIONS(21524), 1,
      anon_sym_RBRACE,
    STATE(17310), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [234341] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21526), 1,
      anon_sym_COMMA,
    ACTIONS(21528), 1,
      anon_sym_RBRACE,
    STATE(17221), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [234415] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21530), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [234489] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234527] = 23,
    ACTIONS(10622), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21532), 1,
      anon_sym_COMMA,
    STATE(16704), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [234601] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21534), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [234675] = 5,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234713] = 23,
    ACTIONS(9490), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21536), 1,
      anon_sym_COMMA,
    STATE(17129), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [234787] = 21,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20897), 1,
      sym__times_operator,
    ACTIONS(20899), 1,
      sym__rational_operator,
    ACTIONS(20901), 1,
      sym__bitshift_operator,
    ACTIONS(20903), 1,
      sym__power_operator,
    ACTIONS(21042), 1,
      anon_sym_COLON2,
    ACTIONS(21046), 1,
      sym__comparison_operator,
    ACTIONS(21048), 1,
      sym__pipe_right_operator,
    ACTIONS(21050), 1,
      sym__pipe_left_operator,
    ACTIONS(21052), 1,
      sym__ellipsis_operator,
    ACTIONS(21054), 1,
      anon_sym_where,
    ACTIONS(21058), 1,
      sym__pair_operator,
    ACTIONS(21060), 1,
      sym__arrow_operator,
    ACTIONS(21062), 1,
      sym__lazy_or_operator,
    ACTIONS(21064), 1,
      sym__lazy_and_operator,
    ACTIONS(21212), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20895), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(14993), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(21044), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [234857] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21538), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [234931] = 23,
    ACTIONS(13255), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20533), 1,
      anon_sym_QMARK,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235005] = 23,
    ACTIONS(13094), 1,
      anon_sym_EQ,
    ACTIONS(13100), 1,
      sym__pair_operator,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20533), 1,
      anon_sym_QMARK,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235079] = 23,
    ACTIONS(9342), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21540), 1,
      anon_sym_COMMA,
    STATE(17154), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235153] = 5,
    ACTIONS(13356), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [235191] = 5,
    ACTIONS(13356), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [235229] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21542), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235303] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21544), 1,
      anon_sym_COMMA,
    ACTIONS(21546), 1,
      anon_sym_RBRACE,
    STATE(17137), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235377] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [235415] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(21548), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [235485] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21550), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235559] = 23,
    ACTIONS(9932), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21552), 1,
      anon_sym_COMMA,
    STATE(17301), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235633] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18476), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [235671] = 23,
    ACTIONS(10638), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21554), 1,
      anon_sym_COMMA,
    STATE(16889), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235745] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18476), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [235783] = 5,
    ACTIONS(12562), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [235821] = 5,
    ACTIONS(12562), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [235859] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21556), 1,
      anon_sym_COMMA,
    ACTIONS(21558), 1,
      anon_sym_RBRACE,
    STATE(16746), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235933] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21560), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236007] = 23,
    ACTIONS(10454), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21562), 1,
      anon_sym_COMMA,
    STATE(17119), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236081] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [236119] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21564), 1,
      anon_sym_COMMA,
    ACTIONS(21566), 1,
      anon_sym_RBRACE,
    STATE(16936), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236193] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21568), 1,
      anon_sym_COMMA,
    ACTIONS(21570), 1,
      anon_sym_RBRACE,
    STATE(17157), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236267] = 5,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [236305] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21572), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236379] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21574), 1,
      anon_sym_COMMA,
    ACTIONS(21576), 1,
      anon_sym_RBRACE,
    STATE(17175), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236453] = 23,
    ACTIONS(10658), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21578), 1,
      anon_sym_COMMA,
    STATE(17135), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236527] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21580), 1,
      anon_sym_COMMA,
    ACTIONS(21582), 1,
      anon_sym_RBRACE,
    STATE(16680), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236601] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21584), 1,
      anon_sym_COMMA,
    ACTIONS(21586), 1,
      anon_sym_RBRACE,
    STATE(17248), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236675] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21588), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236749] = 23,
    ACTIONS(10530), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21590), 1,
      anon_sym_COMMA,
    STATE(16911), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236823] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20840), 1,
      anon_sym_where,
    ACTIONS(20842), 1,
      anon_sym_COLON2,
    ACTIONS(20848), 1,
      sym__pair_operator,
    ACTIONS(20850), 1,
      sym__arrow_operator,
    ACTIONS(20852), 1,
      sym__lazy_or_operator,
    ACTIONS(20854), 1,
      sym__lazy_and_operator,
    ACTIONS(20856), 1,
      sym__comparison_operator,
    ACTIONS(20858), 1,
      sym__pipe_right_operator,
    ACTIONS(20860), 1,
      sym__pipe_left_operator,
    ACTIONS(20862), 1,
      sym__ellipsis_operator,
    ACTIONS(20866), 1,
      sym__times_operator,
    ACTIONS(20868), 1,
      sym__rational_operator,
    ACTIONS(20870), 1,
      sym__bitshift_operator,
    ACTIONS(20872), 1,
      sym__power_operator,
    ACTIONS(20955), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20864), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(14993), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(20844), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236893] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21592), 1,
      anon_sym_COMMA,
    ACTIONS(21594), 1,
      anon_sym_RBRACE,
    STATE(16847), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236967] = 5,
    ACTIONS(14868), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [237005] = 23,
    ACTIONS(9106), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21596), 1,
      anon_sym_COMMA,
    STATE(17058), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237079] = 5,
    ACTIONS(14868), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [237117] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21598), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237191] = 23,
    ACTIONS(10676), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21600), 1,
      anon_sym_COMMA,
    STATE(17278), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237265] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21602), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237339] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21604), 1,
      anon_sym_COMMA,
    ACTIONS(21606), 1,
      anon_sym_RBRACE,
    STATE(17121), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237413] = 5,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [237451] = 23,
    ACTIONS(10712), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21608), 1,
      anon_sym_COMMA,
    STATE(16790), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237525] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21610), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237599] = 21,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20953), 1,
      anon_sym_QMARK,
    ACTIONS(21240), 1,
      anon_sym_COLON2,
    ACTIONS(21244), 1,
      sym__comparison_operator,
    ACTIONS(21246), 1,
      sym__pipe_right_operator,
    ACTIONS(21248), 1,
      sym__pipe_left_operator,
    ACTIONS(21250), 1,
      sym__ellipsis_operator,
    ACTIONS(21254), 1,
      sym__times_operator,
    ACTIONS(21256), 1,
      sym__rational_operator,
    ACTIONS(21258), 1,
      sym__bitshift_operator,
    ACTIONS(21260), 1,
      sym__power_operator,
    ACTIONS(21270), 1,
      anon_sym_where,
    ACTIONS(21272), 1,
      sym__pair_operator,
    ACTIONS(21274), 1,
      sym__arrow_operator,
    ACTIONS(21276), 1,
      sym__lazy_or_operator,
    ACTIONS(21278), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21252), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21242), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(21612), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
  [237669] = 23,
    ACTIONS(10732), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21614), 1,
      anon_sym_COMMA,
    STATE(16894), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237743] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21616), 1,
      anon_sym_COMMA,
    ACTIONS(21618), 1,
      anon_sym_RBRACE,
    STATE(16675), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237817] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21620), 1,
      anon_sym_COMMA,
    ACTIONS(21622), 1,
      anon_sym_RBRACE,
    STATE(16737), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237891] = 23,
    ACTIONS(10750), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21624), 1,
      anon_sym_COMMA,
    STATE(16958), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237965] = 23,
    ACTIONS(13253), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238039] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21626), 1,
      anon_sym_COMMA,
    ACTIONS(21628), 1,
      anon_sym_RBRACE,
    STATE(16780), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238113] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21630), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238187] = 23,
    ACTIONS(10768), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21632), 1,
      anon_sym_COMMA,
    STATE(17139), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238261] = 23,
    ACTIONS(9970), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21634), 1,
      anon_sym_COMMA,
    STATE(16773), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238335] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21636), 1,
      anon_sym_COMMA,
    ACTIONS(21638), 1,
      anon_sym_RBRACE,
    STATE(16883), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238409] = 23,
    ACTIONS(10786), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21640), 1,
      anon_sym_COMMA,
    STATE(17212), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238483] = 5,
    ACTIONS(12714), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [238521] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21642), 1,
      anon_sym_COMMA,
    ACTIONS(21644), 1,
      anon_sym_RBRACE,
    STATE(16948), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238595] = 5,
    ACTIONS(12714), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [238633] = 23,
    ACTIONS(10696), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21646), 1,
      anon_sym_COMMA,
    STATE(16687), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238707] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21648), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238781] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21182), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [238819] = 23,
    ACTIONS(8862), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21650), 1,
      anon_sym_COMMA,
    STATE(17180), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238893] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21652), 1,
      anon_sym_COMMA,
    ACTIONS(21654), 1,
      anon_sym_RBRACE,
    STATE(17128), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238967] = 16,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13334), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 7,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [239027] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21656), 1,
      anon_sym_COMMA,
    ACTIONS(21658), 1,
      anon_sym_RBRACE,
    STATE(17204), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [239101] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [239147] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [239185] = 14,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
    ACTIONS(13312), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [239241] = 5,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [239279] = 22,
    ACTIONS(13312), 1,
      anon_sym_COMMA,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20967), 1,
      anon_sym_QMARK,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [239351] = 20,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 3,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [239419] = 23,
    ACTIONS(10806), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21660), 1,
      anon_sym_COMMA,
    STATE(17275), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [239493] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21662), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [239567] = 18,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [239631] = 17,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [239693] = 12,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
    ACTIONS(13312), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [239745] = 14,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
    ACTIONS(13312), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [239801] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21664), 1,
      anon_sym_COMMA,
    ACTIONS(21666), 1,
      anon_sym_RBRACE,
    STATE(17198), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [239875] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [239921] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21668), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [239995] = 8,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [240039] = 7,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [240081] = 23,
    ACTIONS(10824), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21670), 1,
      anon_sym_COMMA,
    STATE(16661), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [240155] = 6,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [240195] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21672), 1,
      anon_sym_COMMA,
    ACTIONS(21674), 1,
      anon_sym_RBRACE,
    STATE(17264), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [240269] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [240307] = 23,
    ACTIONS(9640), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21676), 1,
      anon_sym_COMMA,
    STATE(16663), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [240381] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18208), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [240419] = 5,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [240457] = 23,
    ACTIONS(10844), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21678), 1,
      anon_sym_COMMA,
    STATE(16709), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [240531] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21680), 1,
      anon_sym_COMMA,
    ACTIONS(21682), 1,
      anon_sym_RBRACE,
    STATE(16657), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [240605] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21684), 1,
      anon_sym_COMMA,
    ACTIONS(21686), 1,
      anon_sym_RBRACE,
    STATE(16829), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [240679] = 23,
    ACTIONS(10862), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21688), 1,
      anon_sym_COMMA,
    STATE(16763), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [240753] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(14993), 1,
      anon_sym_LF,
    ACTIONS(18863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(20483), 1,
      anon_sym_where,
    ACTIONS(20485), 1,
      anon_sym_COLON2,
    ACTIONS(20489), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20493), 1,
      sym__pair_operator,
    ACTIONS(20495), 1,
      sym__arrow_operator,
    ACTIONS(20497), 1,
      sym__lazy_or_operator,
    ACTIONS(20499), 1,
      sym__lazy_and_operator,
    ACTIONS(20501), 1,
      sym__pipe_right_operator,
    ACTIONS(20503), 1,
      sym__pipe_left_operator,
    ACTIONS(20505), 1,
      sym__ellipsis_operator,
    ACTIONS(20509), 1,
      sym__times_operator,
    ACTIONS(20511), 1,
      sym__rational_operator,
    ACTIONS(20513), 1,
      sym__bitshift_operator,
    ACTIONS(20515), 1,
      sym__power_operator,
    ACTIONS(20627), 1,
      anon_sym_QMARK,
    ACTIONS(14991), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
    ACTIONS(20507), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20487), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [240825] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18062), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [240863] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21690), 1,
      anon_sym_COMMA,
    ACTIONS(21692), 1,
      anon_sym_RBRACE,
    STATE(16698), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [240937] = 23,
    ACTIONS(10008), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21694), 1,
      anon_sym_COMMA,
    STATE(17243), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [241011] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21696), 1,
      anon_sym_COMMA,
    ACTIONS(21698), 1,
      anon_sym_RBRACE,
    STATE(16923), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [241085] = 23,
    ACTIONS(10880), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21700), 1,
      anon_sym_COMMA,
    STATE(16823), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [241159] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21702), 1,
      anon_sym_COMMA,
    ACTIONS(21704), 1,
      anon_sym_RBRACE,
    STATE(16747), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [241233] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241271] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241309] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21706), 1,
      anon_sym_COMMA,
    ACTIONS(21708), 1,
      anon_sym_RBRACE,
    STATE(16808), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [241383] = 23,
    ACTIONS(13249), 1,
      anon_sym_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(20995), 1,
      anon_sym_COMMA,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    STATE(13499), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [241457] = 5,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241495] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21710), 1,
      anon_sym_COMMA,
    ACTIONS(21712), 1,
      anon_sym_RBRACE,
    STATE(16852), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [241569] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21714), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [241643] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(21716), 1,
      anon_sym_COMMA,
    ACTIONS(21718), 1,
      anon_sym_RBRACE,
    STATE(16835), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [241717] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21720), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [241791] = 23,
    ACTIONS(9524), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(21722), 1,
      anon_sym_COMMA,
    STATE(16719), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [241865] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241903] = 5,
    ACTIONS(14543), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241941] = 23,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20961), 1,
      anon_sym_where,
    ACTIONS(20963), 1,
      anon_sym_COLON2,
    ACTIONS(20969), 1,
      sym__pair_operator,
    ACTIONS(20971), 1,
      sym__arrow_operator,
    ACTIONS(20973), 1,
      sym__lazy_or_operator,
    ACTIONS(20975), 1,
      sym__lazy_and_operator,
    ACTIONS(20977), 1,
      sym__comparison_operator,
    ACTIONS(20979), 1,
      sym__pipe_right_operator,
    ACTIONS(20981), 1,
      sym__pipe_left_operator,
    ACTIONS(20983), 1,
      sym__ellipsis_operator,
    ACTIONS(20987), 1,
      sym__times_operator,
    ACTIONS(20989), 1,
      sym__rational_operator,
    ACTIONS(20991), 1,
      sym__bitshift_operator,
    ACTIONS(20993), 1,
      sym__power_operator,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21724), 1,
      anon_sym_COLON,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20985), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20965), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [242015] = 15,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21208), 1,
      anon_sym_COLON2,
    ACTIONS(21222), 1,
      sym__comparison_operator,
    ACTIONS(21224), 1,
      sym__pipe_right_operator,
    ACTIONS(21226), 1,
      sym__pipe_left_operator,
    ACTIONS(21228), 1,
      sym__ellipsis_operator,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21230), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21210), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 9,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [242073] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21208), 1,
      anon_sym_COLON2,
    ACTIONS(21224), 1,
      sym__pipe_right_operator,
    ACTIONS(21226), 1,
      sym__pipe_left_operator,
    ACTIONS(21228), 1,
      sym__ellipsis_operator,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21230), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [242129] = 21,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21206), 1,
      anon_sym_where,
    ACTIONS(21208), 1,
      anon_sym_COLON2,
    ACTIONS(21212), 1,
      anon_sym_QMARK,
    ACTIONS(21214), 1,
      sym__pair_operator,
    ACTIONS(21216), 1,
      sym__arrow_operator,
    ACTIONS(21218), 1,
      sym__lazy_or_operator,
    ACTIONS(21220), 1,
      sym__lazy_and_operator,
    ACTIONS(21222), 1,
      sym__comparison_operator,
    ACTIONS(21224), 1,
      sym__pipe_right_operator,
    ACTIONS(21226), 1,
      sym__pipe_left_operator,
    ACTIONS(21228), 1,
      sym__ellipsis_operator,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21230), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(21210), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [242199] = 19,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21206), 1,
      anon_sym_where,
    ACTIONS(21208), 1,
      anon_sym_COLON2,
    ACTIONS(21216), 1,
      sym__arrow_operator,
    ACTIONS(21218), 1,
      sym__lazy_or_operator,
    ACTIONS(21220), 1,
      sym__lazy_and_operator,
    ACTIONS(21222), 1,
      sym__comparison_operator,
    ACTIONS(21224), 1,
      sym__pipe_right_operator,
    ACTIONS(21226), 1,
      sym__pipe_left_operator,
    ACTIONS(21228), 1,
      sym__ellipsis_operator,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21230), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21210), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 5,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [242265] = 17,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21206), 1,
      anon_sym_where,
    ACTIONS(21208), 1,
      anon_sym_COLON2,
    ACTIONS(21220), 1,
      sym__lazy_and_operator,
    ACTIONS(21222), 1,
      sym__comparison_operator,
    ACTIONS(21224), 1,
      sym__pipe_right_operator,
    ACTIONS(21226), 1,
      sym__pipe_left_operator,
    ACTIONS(21228), 1,
      sym__ellipsis_operator,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21230), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21210), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 7,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [242327] = 16,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21206), 1,
      anon_sym_where,
    ACTIONS(21208), 1,
      anon_sym_COLON2,
    ACTIONS(21222), 1,
      sym__comparison_operator,
    ACTIONS(21224), 1,
      sym__pipe_right_operator,
    ACTIONS(21226), 1,
      sym__pipe_left_operator,
    ACTIONS(21228), 1,
      sym__ellipsis_operator,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21230), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21210), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 8,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [242387] = 12,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21208), 1,
      anon_sym_COLON2,
    ACTIONS(21228), 1,
      sym__ellipsis_operator,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21230), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 14,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [242439] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18338), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21208), 1,
      anon_sym_COLON2,
    ACTIONS(21224), 1,
      sym__pipe_right_operator,
    ACTIONS(21226), 1,
      sym__pipe_left_operator,
    ACTIONS(21228), 1,
      sym__ellipsis_operator,
    ACTIONS(21232), 1,
      sym__times_operator,
    ACTIONS(21234), 1,
      sym__rational_operator,
    ACTIONS(21236), 1,
      sym__bitshift_operator,
    ACTIONS(21238), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21230), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_where,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [242495] = 5,
    ACTIONS(12418), 1,
      anon_sym_EQ,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [242533] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21726), 1,
      anon_sym_DOLLAR,
    ACTIONS(21728), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11919), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [242576] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18700), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [242619] = 5,
    ACTIONS(18024), 1,
      sym__immediate_paren,
    ACTIONS(18188), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [242656] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18576), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [242699] = 4,
    ACTIONS(17772), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [242734] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [242771] = 4,
    ACTIONS(18434), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [242806] = 4,
    ACTIONS(18322), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [242841] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21726), 1,
      anon_sym_DOLLAR,
    ACTIONS(21728), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11998), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [242884] = 8,
    ACTIONS(21736), 1,
      sym__word_identifier,
    ACTIONS(21738), 1,
      anon_sym_LPAREN,
    ACTIONS(21740), 1,
      anon_sym_DOLLAR,
    ACTIONS(21742), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8765), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16858), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16856), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [242927] = 4,
    ACTIONS(12790), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [242962] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(19062), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243005] = 8,
    ACTIONS(21744), 1,
      sym__word_identifier,
    ACTIONS(21746), 1,
      anon_sym_LPAREN,
    ACTIONS(21748), 1,
      anon_sym_DOLLAR,
    ACTIONS(21750), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7528), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16422), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16420), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243048] = 4,
    ACTIONS(12418), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [243083] = 8,
    ACTIONS(21752), 1,
      sym__word_identifier,
    ACTIONS(21754), 1,
      anon_sym_LPAREN,
    ACTIONS(21756), 1,
      anon_sym_DOLLAR,
    ACTIONS(21758), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7818), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(17212), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17210), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243126] = 4,
    ACTIONS(18430), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [243161] = 8,
    ACTIONS(21752), 1,
      sym__word_identifier,
    ACTIONS(21754), 1,
      anon_sym_LPAREN,
    ACTIONS(21756), 1,
      anon_sym_DOLLAR,
    ACTIONS(21758), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7832), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(17212), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17210), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243204] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(19845), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243247] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21760), 1,
      anon_sym_DOLLAR,
    ACTIONS(21762), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10782), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243290] = 4,
    ACTIONS(17932), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [243325] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18398), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243368] = 4,
    ACTIONS(18370), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [243403] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18198), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243446] = 4,
    ACTIONS(14979), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [243481] = 4,
    ACTIONS(18466), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [243516] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18573), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243559] = 4,
    ACTIONS(13411), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [243594] = 4,
    ACTIONS(12732), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [243629] = 8,
    ACTIONS(21764), 1,
      sym__word_identifier,
    ACTIONS(21766), 1,
      anon_sym_LPAREN,
    ACTIONS(21768), 1,
      anon_sym_DOLLAR,
    ACTIONS(21770), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8274), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16996), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16994), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243672] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(19068), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243715] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21726), 1,
      anon_sym_DOLLAR,
    ACTIONS(21728), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11964), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243758] = 4,
    ACTIONS(12724), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [243793] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(19634), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243836] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(19485), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243879] = 8,
    ACTIONS(21744), 1,
      sym__word_identifier,
    ACTIONS(21746), 1,
      anon_sym_LPAREN,
    ACTIONS(21748), 1,
      anon_sym_DOLLAR,
    ACTIONS(21750), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8527), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16422), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16420), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243922] = 8,
    ACTIONS(21764), 1,
      sym__word_identifier,
    ACTIONS(21766), 1,
      anon_sym_LPAREN,
    ACTIONS(21768), 1,
      anon_sym_DOLLAR,
    ACTIONS(21770), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8817), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16996), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16994), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243965] = 8,
    ACTIONS(21744), 1,
      sym__word_identifier,
    ACTIONS(21746), 1,
      anon_sym_LPAREN,
    ACTIONS(21748), 1,
      anon_sym_DOLLAR,
    ACTIONS(21750), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8529), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16422), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16420), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244008] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18316), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244051] = 4,
    ACTIONS(14618), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [244086] = 4,
    ACTIONS(17920), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [244121] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18434), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244164] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18851), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244207] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(19022), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244250] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18959), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244293] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(19280), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244336] = 8,
    ACTIONS(21772), 1,
      sym__word_identifier,
    ACTIONS(21774), 1,
      anon_sym_LPAREN,
    ACTIONS(21776), 1,
      anon_sym_DOLLAR,
    ACTIONS(21778), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7165), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16710), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16708), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244379] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18290), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244422] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(19471), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244465] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18806), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244508] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(19734), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244551] = 8,
    ACTIONS(21764), 1,
      sym__word_identifier,
    ACTIONS(21766), 1,
      anon_sym_LPAREN,
    ACTIONS(21768), 1,
      anon_sym_DOLLAR,
    ACTIONS(21770), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8823), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16996), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16994), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244594] = 4,
    ACTIONS(18216), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [244629] = 16,
    ACTIONS(13334), 1,
      anon_sym_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21780), 1,
      anon_sym_COLON2,
    ACTIONS(21784), 1,
      sym__comparison_operator,
    ACTIONS(21786), 1,
      sym__pipe_right_operator,
    ACTIONS(21788), 1,
      sym__pipe_left_operator,
    ACTIONS(21790), 1,
      sym__ellipsis_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21792), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21782), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 7,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [244688] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21792), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 4,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [244733] = 14,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21780), 1,
      anon_sym_COLON2,
    ACTIONS(21786), 1,
      sym__pipe_right_operator,
    ACTIONS(21788), 1,
      sym__pipe_left_operator,
    ACTIONS(21790), 1,
      sym__ellipsis_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_COLON,
      sym__comparison_operator,
    ACTIONS(21792), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [244788] = 22,
    ACTIONS(13306), 1,
      anon_sym_COLON,
    ACTIONS(13312), 1,
      anon_sym_COMMA,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21780), 1,
      anon_sym_COLON2,
    ACTIONS(21784), 1,
      sym__comparison_operator,
    ACTIONS(21786), 1,
      sym__pipe_right_operator,
    ACTIONS(21788), 1,
      sym__pipe_left_operator,
    ACTIONS(21790), 1,
      sym__ellipsis_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(21800), 1,
      anon_sym_where,
    ACTIONS(21802), 1,
      sym__pair_operator,
    ACTIONS(21804), 1,
      sym__arrow_operator,
    ACTIONS(21806), 1,
      sym__lazy_or_operator,
    ACTIONS(21808), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21792), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21782), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [244859] = 20,
    ACTIONS(13306), 1,
      anon_sym_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21780), 1,
      anon_sym_COLON2,
    ACTIONS(21784), 1,
      sym__comparison_operator,
    ACTIONS(21786), 1,
      sym__pipe_right_operator,
    ACTIONS(21788), 1,
      sym__pipe_left_operator,
    ACTIONS(21790), 1,
      sym__ellipsis_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(21800), 1,
      anon_sym_where,
    ACTIONS(21804), 1,
      sym__arrow_operator,
    ACTIONS(21806), 1,
      sym__lazy_or_operator,
    ACTIONS(21808), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21792), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 3,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
    ACTIONS(21782), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [244926] = 18,
    ACTIONS(13306), 1,
      anon_sym_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21780), 1,
      anon_sym_COLON2,
    ACTIONS(21784), 1,
      sym__comparison_operator,
    ACTIONS(21786), 1,
      sym__pipe_right_operator,
    ACTIONS(21788), 1,
      sym__pipe_left_operator,
    ACTIONS(21790), 1,
      sym__ellipsis_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(21800), 1,
      anon_sym_where,
    ACTIONS(21808), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21792), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21782), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [244989] = 17,
    ACTIONS(13306), 1,
      anon_sym_COLON,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21780), 1,
      anon_sym_COLON2,
    ACTIONS(21784), 1,
      sym__comparison_operator,
    ACTIONS(21786), 1,
      sym__pipe_right_operator,
    ACTIONS(21788), 1,
      sym__pipe_left_operator,
    ACTIONS(21790), 1,
      sym__ellipsis_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(21800), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21792), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21782), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [245050] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21810), 1,
      anon_sym_DOLLAR,
    ACTIONS(21812), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(13134), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [245093] = 12,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21780), 1,
      anon_sym_COLON2,
    ACTIONS(21790), 1,
      sym__ellipsis_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_COLON,
      sym__comparison_operator,
    ACTIONS(21792), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [245144] = 14,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21780), 1,
      anon_sym_COLON2,
    ACTIONS(21786), 1,
      sym__pipe_right_operator,
    ACTIONS(21788), 1,
      sym__pipe_left_operator,
    ACTIONS(21790), 1,
      sym__ellipsis_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_COLON,
      sym__comparison_operator,
    ACTIONS(21792), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [245199] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21810), 1,
      anon_sym_DOLLAR,
    ACTIONS(21812), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10728), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [245242] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21792), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [245287] = 8,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [245330] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21810), 1,
      anon_sym_DOLLAR,
    ACTIONS(21812), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10782), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [245373] = 7,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [245414] = 6,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [245453] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [245490] = 4,
    ACTIONS(17988), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [245525] = 4,
    ACTIONS(17812), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [245560] = 4,
    ACTIONS(13356), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [245595] = 4,
    ACTIONS(12610), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [245630] = 4,
    ACTIONS(18468), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [245665] = 8,
    ACTIONS(21814), 1,
      sym__word_identifier,
    ACTIONS(21816), 1,
      anon_sym_LPAREN,
    ACTIONS(21818), 1,
      anon_sym_DOLLAR,
    ACTIONS(21820), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7592), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16836), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16834), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [245708] = 4,
    ACTIONS(12562), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [245743] = 8,
    ACTIONS(21822), 1,
      sym__word_identifier,
    ACTIONS(21824), 1,
      anon_sym_LPAREN,
    ACTIONS(21826), 1,
      anon_sym_DOLLAR,
    ACTIONS(21828), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7954), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(17258), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17256), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [245786] = 4,
    ACTIONS(12220), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [245821] = 4,
    ACTIONS(18476), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [245856] = 4,
    ACTIONS(17736), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [245891] = 8,
    ACTIONS(18378), 1,
      sym__word_identifier,
    ACTIONS(18382), 1,
      anon_sym_LPAREN,
    ACTIONS(21830), 1,
      anon_sym_DOLLAR,
    ACTIONS(21832), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12312), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16360), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16358), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [245934] = 4,
    ACTIONS(18608), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [245969] = 4,
    ACTIONS(14868), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [246004] = 4,
    ACTIONS(18570), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [246039] = 8,
    ACTIONS(21822), 1,
      sym__word_identifier,
    ACTIONS(21824), 1,
      anon_sym_LPAREN,
    ACTIONS(21826), 1,
      anon_sym_DOLLAR,
    ACTIONS(21828), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8708), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(17258), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17256), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246082] = 8,
    ACTIONS(21822), 1,
      sym__word_identifier,
    ACTIONS(21824), 1,
      anon_sym_LPAREN,
    ACTIONS(21826), 1,
      anon_sym_DOLLAR,
    ACTIONS(21828), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8714), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(17258), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17256), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246125] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21834), 1,
      anon_sym_DOLLAR,
    ACTIONS(21836), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(13140), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246168] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21834), 1,
      anon_sym_DOLLAR,
    ACTIONS(21836), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11919), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246211] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21394), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [246280] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21834), 1,
      anon_sym_DOLLAR,
    ACTIONS(21836), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11964), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246323] = 4,
    ACTIONS(14870), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [246358] = 8,
    ACTIONS(21838), 1,
      sym__word_identifier,
    ACTIONS(21840), 1,
      anon_sym_LPAREN,
    ACTIONS(21842), 1,
      anon_sym_DOLLAR,
    ACTIONS(21844), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8427), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16516), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16514), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246401] = 8,
    ACTIONS(21838), 1,
      sym__word_identifier,
    ACTIONS(21840), 1,
      anon_sym_LPAREN,
    ACTIONS(21842), 1,
      anon_sym_DOLLAR,
    ACTIONS(21844), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8433), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16516), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16514), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246444] = 4,
    ACTIONS(12714), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [246479] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18856), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246522] = 8,
    ACTIONS(21736), 1,
      sym__word_identifier,
    ACTIONS(21738), 1,
      anon_sym_LPAREN,
    ACTIONS(21740), 1,
      anon_sym_DOLLAR,
    ACTIONS(21742), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8979), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16858), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16856), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246565] = 4,
    ACTIONS(13342), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [246600] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21846), 1,
      anon_sym_DOLLAR,
    ACTIONS(21848), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12891), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246643] = 8,
    ACTIONS(21736), 1,
      sym__word_identifier,
    ACTIONS(21738), 1,
      anon_sym_LPAREN,
    ACTIONS(21740), 1,
      anon_sym_DOLLAR,
    ACTIONS(21742), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8984), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16858), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16856), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246686] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21846), 1,
      anon_sym_DOLLAR,
    ACTIONS(21848), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10728), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246729] = 22,
    ACTIONS(13338), 1,
      anon_sym_COLON,
    ACTIONS(13340), 1,
      anon_sym_COMMA,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21100), 1,
      anon_sym_QMARK,
    ACTIONS(21734), 1,
      sym__power_operator,
    ACTIONS(21780), 1,
      anon_sym_COLON2,
    ACTIONS(21784), 1,
      sym__comparison_operator,
    ACTIONS(21786), 1,
      sym__pipe_right_operator,
    ACTIONS(21788), 1,
      sym__pipe_left_operator,
    ACTIONS(21790), 1,
      sym__ellipsis_operator,
    ACTIONS(21794), 1,
      sym__times_operator,
    ACTIONS(21796), 1,
      sym__rational_operator,
    ACTIONS(21798), 1,
      sym__bitshift_operator,
    ACTIONS(21800), 1,
      anon_sym_where,
    ACTIONS(21802), 1,
      sym__pair_operator,
    ACTIONS(21804), 1,
      sym__arrow_operator,
    ACTIONS(21806), 1,
      sym__lazy_or_operator,
    ACTIONS(21808), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21792), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21782), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [246800] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21846), 1,
      anon_sym_DOLLAR,
    ACTIONS(21848), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10782), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246843] = 8,
    ACTIONS(21752), 1,
      sym__word_identifier,
    ACTIONS(21754), 1,
      anon_sym_LPAREN,
    ACTIONS(21756), 1,
      anon_sym_DOLLAR,
    ACTIONS(21758), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7143), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(17212), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17210), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246886] = 4,
    ACTIONS(17934), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [246921] = 8,
    ACTIONS(21814), 1,
      sym__word_identifier,
    ACTIONS(21816), 1,
      anon_sym_LPAREN,
    ACTIONS(21818), 1,
      anon_sym_DOLLAR,
    ACTIONS(21820), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8204), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16836), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16834), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246964] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21850), 1,
      anon_sym_DOLLAR,
    ACTIONS(21852), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12217), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247007] = 4,
    ACTIONS(18432), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [247042] = 8,
    ACTIONS(21814), 1,
      sym__word_identifier,
    ACTIONS(21816), 1,
      anon_sym_LPAREN,
    ACTIONS(21818), 1,
      anon_sym_DOLLAR,
    ACTIONS(21820), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8206), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16836), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16834), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247085] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21850), 1,
      anon_sym_DOLLAR,
    ACTIONS(21852), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10728), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247128] = 4,
    ACTIONS(14616), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [247163] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21850), 1,
      anon_sym_DOLLAR,
    ACTIONS(21852), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10782), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247206] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21854), 1,
      anon_sym_DOLLAR,
    ACTIONS(21856), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12896), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247249] = 8,
    ACTIONS(18480), 1,
      sym__word_identifier,
    ACTIONS(18484), 1,
      anon_sym_LPAREN,
    ACTIONS(21858), 1,
      anon_sym_DOLLAR,
    ACTIONS(21860), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11928), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16332), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16330), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247292] = 8,
    ACTIONS(21772), 1,
      sym__word_identifier,
    ACTIONS(21774), 1,
      anon_sym_LPAREN,
    ACTIONS(21776), 1,
      anon_sym_DOLLAR,
    ACTIONS(21778), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7463), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16710), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16708), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247335] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21854), 1,
      anon_sym_DOLLAR,
    ACTIONS(21856), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10728), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247378] = 8,
    ACTIONS(21772), 1,
      sym__word_identifier,
    ACTIONS(21774), 1,
      anon_sym_LPAREN,
    ACTIONS(21776), 1,
      anon_sym_DOLLAR,
    ACTIONS(21778), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7468), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16710), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16708), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247421] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21854), 1,
      anon_sym_DOLLAR,
    ACTIONS(21856), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10782), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247464] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21760), 1,
      anon_sym_DOLLAR,
    ACTIONS(21762), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(13020), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247507] = 8,
    ACTIONS(21862), 1,
      sym__word_identifier,
    ACTIONS(21864), 1,
      anon_sym_LPAREN,
    ACTIONS(21866), 1,
      anon_sym_DOLLAR,
    ACTIONS(21868), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7467), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16600), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16598), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247550] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21870), 1,
      anon_sym_DOLLAR,
    ACTIONS(21872), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12898), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247593] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21870), 1,
      anon_sym_DOLLAR,
    ACTIONS(21872), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10728), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247636] = 8,
    ACTIONS(21862), 1,
      sym__word_identifier,
    ACTIONS(21864), 1,
      anon_sym_LPAREN,
    ACTIONS(21866), 1,
      anon_sym_DOLLAR,
    ACTIONS(21868), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7067), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16600), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16598), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247679] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21760), 1,
      anon_sym_DOLLAR,
    ACTIONS(21762), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10728), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247722] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21870), 1,
      anon_sym_DOLLAR,
    ACTIONS(21872), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10782), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247765] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21874), 1,
      anon_sym_DOLLAR,
    ACTIONS(21876), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12233), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247808] = 8,
    ACTIONS(21862), 1,
      sym__word_identifier,
    ACTIONS(21864), 1,
      anon_sym_LPAREN,
    ACTIONS(21866), 1,
      anon_sym_DOLLAR,
    ACTIONS(21868), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7472), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16600), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16598), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247851] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21874), 1,
      anon_sym_DOLLAR,
    ACTIONS(21876), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10728), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247894] = 8,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(18532), 1,
      anon_sym_LPAREN,
    ACTIONS(21874), 1,
      anon_sym_DOLLAR,
    ACTIONS(21876), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10782), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16276), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [247937] = 4,
    ACTIONS(12450), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [247972] = 8,
    ACTIONS(18378), 1,
      sym__word_identifier,
    ACTIONS(18382), 1,
      anon_sym_LPAREN,
    ACTIONS(21830), 1,
      anon_sym_DOLLAR,
    ACTIONS(21832), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12098), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16360), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16358), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [248015] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    ACTIONS(20877), 1,
      anon_sym_COLON2,
    ACTIONS(20879), 1,
      sym__pipe_right_operator,
    ACTIONS(20881), 1,
      sym__pipe_left_operator,
    ACTIONS(20883), 1,
      sym__ellipsis_operator,
    ACTIONS(20887), 1,
      sym__times_operator,
    ACTIONS(20889), 1,
      sym__rational_operator,
    ACTIONS(20891), 1,
      sym__bitshift_operator,
    ACTIONS(20893), 1,
      sym__power_operator,
    ACTIONS(20959), 1,
      sym__comparison_operator,
    ACTIONS(20997), 1,
      anon_sym_where,
    ACTIONS(20999), 1,
      sym__pair_operator,
    ACTIONS(21001), 1,
      sym__arrow_operator,
    ACTIONS(21003), 1,
      sym__lazy_or_operator,
    ACTIONS(21005), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20885), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21612), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(20957), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [248084] = 8,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(18582), 1,
      anon_sym_LPAREN,
    ACTIONS(21730), 1,
      anon_sym_DOLLAR,
    ACTIONS(21732), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(19626), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16304), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [248127] = 4,
    ACTIONS(18478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248162] = 4,
    ACTIONS(18030), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248197] = 8,
    ACTIONS(18480), 1,
      sym__word_identifier,
    ACTIONS(18484), 1,
      anon_sym_LPAREN,
    ACTIONS(21858), 1,
      anon_sym_DOLLAR,
    ACTIONS(21860), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12639), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16332), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16330), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [248240] = 8,
    ACTIONS(18480), 1,
      sym__word_identifier,
    ACTIONS(18484), 1,
      anon_sym_LPAREN,
    ACTIONS(21858), 1,
      anon_sym_DOLLAR,
    ACTIONS(21860), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12643), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16332), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16330), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [248283] = 4,
    ACTIONS(17758), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248318] = 4,
    ACTIONS(14872), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248353] = 4,
    ACTIONS(18518), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248388] = 4,
    ACTIONS(12462), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248423] = 22,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    ACTIONS(20527), 1,
      anon_sym_where,
    ACTIONS(20529), 1,
      anon_sym_COLON2,
    ACTIONS(20535), 1,
      sym__pair_operator,
    ACTIONS(20537), 1,
      sym__arrow_operator,
    ACTIONS(20539), 1,
      sym__lazy_or_operator,
    ACTIONS(20541), 1,
      sym__lazy_and_operator,
    ACTIONS(20543), 1,
      sym__comparison_operator,
    ACTIONS(20545), 1,
      sym__pipe_right_operator,
    ACTIONS(20547), 1,
      sym__pipe_left_operator,
    ACTIONS(20549), 1,
      sym__ellipsis_operator,
    ACTIONS(20553), 1,
      sym__times_operator,
    ACTIONS(20555), 1,
      sym__rational_operator,
    ACTIONS(20557), 1,
      sym__bitshift_operator,
    ACTIONS(20559), 1,
      sym__power_operator,
    ACTIONS(20778), 1,
      anon_sym_QMARK,
    STATE(16971), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20551), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(20531), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [248494] = 4,
    ACTIONS(18654), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248529] = 4,
    ACTIONS(14543), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248564] = 8,
    ACTIONS(21838), 1,
      sym__word_identifier,
    ACTIONS(21840), 1,
      anon_sym_LPAREN,
    ACTIONS(21842), 1,
      anon_sym_DOLLAR,
    ACTIONS(21844), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7316), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16516), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16514), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [248607] = 4,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248642] = 4,
    ACTIONS(18520), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248677] = 5,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(18188), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248714] = 8,
    ACTIONS(18378), 1,
      sym__word_identifier,
    ACTIONS(18382), 1,
      anon_sym_LPAREN,
    ACTIONS(21830), 1,
      anon_sym_DOLLAR,
    ACTIONS(21832), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12309), 5,
      sym__exportable,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(16360), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16358), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [248757] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 14,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [248793] = 12,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [248843] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21612), 1,
      anon_sym_RPAREN,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21894), 1,
      anon_sym_where,
    ACTIONS(21898), 1,
      anon_sym_QMARK,
    ACTIONS(21900), 1,
      sym__pair_operator,
    ACTIONS(21902), 1,
      sym__arrow_operator,
    ACTIONS(21904), 1,
      sym__lazy_or_operator,
    ACTIONS(21906), 1,
      sym__lazy_and_operator,
    ACTIONS(21908), 1,
      sym__comparison_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21896), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [248911] = 8,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 5,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [248953] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 13,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [248997] = 16,
    ACTIONS(13334), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21914), 1,
      anon_sym_COLON2,
    ACTIONS(21918), 1,
      sym__comparison_operator,
    ACTIONS(21920), 1,
      sym__pipe_right_operator,
    ACTIONS(21922), 1,
      sym__pipe_left_operator,
    ACTIONS(21924), 1,
      sym__ellipsis_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21916), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 6,
      anon_sym_where,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [249055] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13467), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13465), 12,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [249099] = 14,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21914), 1,
      anon_sym_COLON2,
    ACTIONS(21920), 1,
      sym__pipe_right_operator,
    ACTIONS(21922), 1,
      sym__pipe_left_operator,
    ACTIONS(21924), 1,
      sym__ellipsis_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 9,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [249153] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 10,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [249207] = 21,
    ACTIONS(13338), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21914), 1,
      anon_sym_COLON2,
    ACTIONS(21918), 1,
      sym__comparison_operator,
    ACTIONS(21920), 1,
      sym__pipe_right_operator,
    ACTIONS(21922), 1,
      sym__pipe_left_operator,
    ACTIONS(21924), 1,
      sym__ellipsis_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(21934), 1,
      anon_sym_where,
    ACTIONS(21936), 1,
      anon_sym_QMARK,
    ACTIONS(21938), 1,
      sym__pair_operator,
    ACTIONS(21940), 1,
      sym__arrow_operator,
    ACTIONS(21942), 1,
      sym__lazy_or_operator,
    ACTIONS(21944), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21916), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [249275] = 8,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [249317] = 7,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [249357] = 6,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 14,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [249395] = 21,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21914), 1,
      anon_sym_COLON2,
    ACTIONS(21918), 1,
      sym__comparison_operator,
    ACTIONS(21920), 1,
      sym__pipe_right_operator,
    ACTIONS(21922), 1,
      sym__pipe_left_operator,
    ACTIONS(21924), 1,
      sym__ellipsis_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(21934), 1,
      anon_sym_where,
    ACTIONS(21936), 1,
      anon_sym_QMARK,
    ACTIONS(21938), 1,
      sym__pair_operator,
    ACTIONS(21940), 1,
      sym__arrow_operator,
    ACTIONS(21942), 1,
      sym__lazy_or_operator,
    ACTIONS(21944), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21916), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [249463] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21894), 1,
      anon_sym_where,
    ACTIONS(21898), 1,
      anon_sym_QMARK,
    ACTIONS(21900), 1,
      sym__pair_operator,
    ACTIONS(21902), 1,
      sym__arrow_operator,
    ACTIONS(21904), 1,
      sym__lazy_or_operator,
    ACTIONS(21906), 1,
      sym__lazy_and_operator,
    ACTIONS(21908), 1,
      sym__comparison_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(21946), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21896), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [249531] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 3,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 13,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [249575] = 14,
    ACTIONS(13306), 1,
      sym__comparison_operator,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 10,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [249629] = 20,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21914), 1,
      anon_sym_COLON2,
    ACTIONS(21918), 1,
      sym__comparison_operator,
    ACTIONS(21920), 1,
      sym__pipe_right_operator,
    ACTIONS(21922), 1,
      sym__pipe_left_operator,
    ACTIONS(21924), 1,
      sym__ellipsis_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(21934), 1,
      anon_sym_where,
    ACTIONS(21940), 1,
      sym__arrow_operator,
    ACTIONS(21942), 1,
      sym__lazy_or_operator,
    ACTIONS(21944), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13312), 2,
      anon_sym_QMARK,
      sym__pair_operator,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21916), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [249695] = 21,
    ACTIONS(13312), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21894), 1,
      anon_sym_where,
    ACTIONS(21898), 1,
      anon_sym_QMARK,
    ACTIONS(21900), 1,
      sym__pair_operator,
    ACTIONS(21902), 1,
      sym__arrow_operator,
    ACTIONS(21904), 1,
      sym__lazy_or_operator,
    ACTIONS(21906), 1,
      sym__lazy_and_operator,
    ACTIONS(21908), 1,
      sym__comparison_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21896), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [249763] = 18,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21914), 1,
      anon_sym_COLON2,
    ACTIONS(21918), 1,
      sym__comparison_operator,
    ACTIONS(21920), 1,
      sym__pipe_right_operator,
    ACTIONS(21922), 1,
      sym__pipe_left_operator,
    ACTIONS(21924), 1,
      sym__ellipsis_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(21934), 1,
      anon_sym_where,
    ACTIONS(21944), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21916), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 4,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [249825] = 17,
    ACTIONS(13306), 1,
      anon_sym_EQ,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21914), 1,
      anon_sym_COLON2,
    ACTIONS(21918), 1,
      sym__comparison_operator,
    ACTIONS(21920), 1,
      sym__pipe_right_operator,
    ACTIONS(21922), 1,
      sym__pipe_left_operator,
    ACTIONS(21924), 1,
      sym__ellipsis_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(21934), 1,
      anon_sym_where,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21916), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 5,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [249885] = 15,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21908), 1,
      sym__comparison_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21896), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13336), 7,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [249941] = 6,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 13,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [249979] = 19,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21894), 1,
      anon_sym_where,
    ACTIONS(21902), 1,
      sym__arrow_operator,
    ACTIONS(21904), 1,
      sym__lazy_or_operator,
    ACTIONS(21906), 1,
      sym__lazy_and_operator,
    ACTIONS(21908), 1,
      sym__comparison_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 3,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
    ACTIONS(21896), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [250043] = 4,
    ACTIONS(18188), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11397), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11408), 16,
      anon_sym_where,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [250077] = 17,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21894), 1,
      anon_sym_where,
    ACTIONS(21906), 1,
      sym__lazy_and_operator,
    ACTIONS(21908), 1,
      sym__comparison_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21896), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 5,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [250137] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 14,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [250173] = 14,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21914), 1,
      anon_sym_COLON2,
    ACTIONS(21920), 1,
      sym__pipe_right_operator,
    ACTIONS(21922), 1,
      sym__pipe_left_operator,
    ACTIONS(21924), 1,
      sym__ellipsis_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 9,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [250227] = 12,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21914), 1,
      anon_sym_COLON2,
    ACTIONS(21924), 1,
      sym__ellipsis_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 11,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [250277] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 15,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [250313] = 21,
    ACTIONS(13340), 1,
      anon_sym_RPAREN,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21894), 1,
      anon_sym_where,
    ACTIONS(21898), 1,
      anon_sym_QMARK,
    ACTIONS(21900), 1,
      sym__pair_operator,
    ACTIONS(21902), 1,
      sym__arrow_operator,
    ACTIONS(21904), 1,
      sym__lazy_or_operator,
    ACTIONS(21906), 1,
      sym__lazy_and_operator,
    ACTIONS(21908), 1,
      sym__comparison_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21896), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [250381] = 16,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21894), 1,
      anon_sym_where,
    ACTIONS(21908), 1,
      sym__comparison_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21896), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(13312), 6,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [250439] = 21,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21894), 1,
      anon_sym_where,
    ACTIONS(21898), 1,
      anon_sym_QMARK,
    ACTIONS(21900), 1,
      sym__pair_operator,
    ACTIONS(21902), 1,
      sym__arrow_operator,
    ACTIONS(21904), 1,
      sym__lazy_or_operator,
    ACTIONS(21906), 1,
      sym__lazy_and_operator,
    ACTIONS(21908), 1,
      sym__comparison_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(21948), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21896), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [250507] = 5,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13308), 6,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13310), 15,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [250543] = 9,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(13306), 4,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(13312), 12,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [250587] = 7,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13306), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(13312), 12,
      anon_sym_where,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [250627] = 20,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21894), 1,
      anon_sym_where,
    ACTIONS(21898), 1,
      anon_sym_QMARK,
    ACTIONS(21900), 1,
      sym__pair_operator,
    ACTIONS(21902), 1,
      sym__arrow_operator,
    ACTIONS(21904), 1,
      sym__lazy_or_operator,
    ACTIONS(21906), 1,
      sym__lazy_and_operator,
    ACTIONS(21908), 1,
      sym__comparison_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(21950), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21896), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [250692] = 20,
    ACTIONS(21880), 1,
      anon_sym_COLON2,
    ACTIONS(21882), 1,
      sym__ellipsis_operator,
    ACTIONS(21886), 1,
      sym__times_operator,
    ACTIONS(21888), 1,
      sym__rational_operator,
    ACTIONS(21890), 1,
      sym__bitshift_operator,
    ACTIONS(21892), 1,
      sym__power_operator,
    ACTIONS(21894), 1,
      anon_sym_where,
    ACTIONS(21898), 1,
      anon_sym_QMARK,
    ACTIONS(21900), 1,
      sym__pair_operator,
    ACTIONS(21902), 1,
      sym__arrow_operator,
    ACTIONS(21904), 1,
      sym__lazy_or_operator,
    ACTIONS(21906), 1,
      sym__lazy_and_operator,
    ACTIONS(21908), 1,
      sym__comparison_operator,
    ACTIONS(21910), 1,
      sym__pipe_right_operator,
    ACTIONS(21912), 1,
      sym__pipe_left_operator,
    ACTIONS(21952), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21954), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21884), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21896), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [250757] = 20,
    ACTIONS(18340), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19755), 1,
      anon_sym_COLON_COLON,
    ACTIONS(21878), 1,
      sym__power_operator,
    ACTIONS(21898), 1,
      anon_sym_QMARK,
    ACTIONS(21914), 1,
      anon_sym_COLON2,
    ACTIONS(21918), 1,
      sym__comparison_operator,
    ACTIONS(21920), 1,
      sym__pipe_right_operator,
    ACTIONS(21922), 1,
      sym__pipe_left_operator,
    ACTIONS(21924), 1,
      sym__ellipsis_operator,
    ACTIONS(21928), 1,
      sym__times_operator,
    ACTIONS(21930), 1,
      sym__rational_operator,
    ACTIONS(21932), 1,
      sym__bitshift_operator,
    ACTIONS(21934), 1,
      anon_sym_where,
    ACTIONS(21938), 1,
      sym__pair_operator,
    ACTIONS(21940), 1,
      sym__arrow_operator,
    ACTIONS(21942), 1,
      sym__lazy_or_operator,
    ACTIONS(21944), 1,
      sym__lazy_and_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21926), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(21916), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [250822] = 7,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(21956), 1,
      sym__syntactic_operator,
    STATE(11670), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(13157), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16304), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [250859] = 7,
    ACTIONS(21958), 1,
      sym__word_identifier,
    ACTIONS(21960), 1,
      sym__syntactic_operator,
    STATE(6641), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6498), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(17238), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17236), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [250896] = 7,
    ACTIONS(21962), 1,
      sym__word_identifier,
    ACTIONS(21964), 1,
      sym__syntactic_operator,
    STATE(6620), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6437), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(17464), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17462), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [250933] = 7,
    ACTIONS(21966), 1,
      sym__word_identifier,
    ACTIONS(21968), 1,
      sym__syntactic_operator,
    STATE(6836), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6628), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16570), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16568), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [250970] = 7,
    ACTIONS(21772), 1,
      sym__word_identifier,
    ACTIONS(21970), 1,
      sym__syntactic_operator,
    STATE(7361), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6935), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16710), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16708), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251007] = 7,
    ACTIONS(21814), 1,
      sym__word_identifier,
    ACTIONS(21972), 1,
      sym__syntactic_operator,
    STATE(8423), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7542), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16836), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16834), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251044] = 7,
    ACTIONS(21822), 1,
      sym__word_identifier,
    ACTIONS(21974), 1,
      sym__syntactic_operator,
    STATE(8588), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8084), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(17258), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17256), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251081] = 7,
    ACTIONS(21752), 1,
      sym__word_identifier,
    ACTIONS(21976), 1,
      sym__syntactic_operator,
    STATE(7910), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7168), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(17212), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17210), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251118] = 7,
    ACTIONS(18502), 1,
      sym__word_identifier,
    ACTIONS(21978), 1,
      sym__syntactic_operator,
    STATE(7349), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6850), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16472), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16470), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251155] = 7,
    ACTIONS(21980), 1,
      sym__word_identifier,
    ACTIONS(21982), 1,
      sym__syntactic_operator,
    STATE(7183), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6792), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16978), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16976), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251192] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11722), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251229] = 7,
    ACTIONS(18554), 1,
      sym__word_identifier,
    ACTIONS(21986), 1,
      sym__syntactic_operator,
    STATE(8083), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7014), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16790), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16788), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251266] = 7,
    ACTIONS(18588), 1,
      sym__word_identifier,
    ACTIONS(21988), 1,
      sym__syntactic_operator,
    STATE(7161), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6818), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16688), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16686), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251303] = 7,
    ACTIONS(18598), 1,
      sym__word_identifier,
    ACTIONS(21990), 1,
      sym__syntactic_operator,
    STATE(6922), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6797), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(17438), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17436), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251340] = 7,
    ACTIONS(21992), 1,
      sym__word_identifier,
    ACTIONS(21994), 1,
      sym__syntactic_operator,
    STATE(6636), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6572), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16766), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16764), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251377] = 7,
    ACTIONS(21764), 1,
      sym__word_identifier,
    ACTIONS(21996), 1,
      sym__syntactic_operator,
    STATE(8954), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8687), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16996), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16994), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251414] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12816), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251451] = 7,
    ACTIONS(18538), 1,
      sym__word_identifier,
    ACTIONS(21998), 1,
      sym__syntactic_operator,
    STATE(7541), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7190), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16544), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16542), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251488] = 7,
    ACTIONS(18616), 1,
      sym__word_identifier,
    ACTIONS(22000), 1,
      sym__syntactic_operator,
    STATE(6987), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6698), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(17286), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17284), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251525] = 7,
    ACTIONS(18398), 1,
      sym__word_identifier,
    ACTIONS(22002), 1,
      sym__syntactic_operator,
    STATE(8397), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7830), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(17410), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17408), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251562] = 7,
    ACTIONS(18414), 1,
      sym__word_identifier,
    ACTIONS(22004), 1,
      sym__syntactic_operator,
    STATE(7433), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6910), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(17488), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17486), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251599] = 7,
    ACTIONS(22006), 1,
      sym__word_identifier,
    ACTIONS(22008), 1,
      sym__syntactic_operator,
    STATE(6909), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6702), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16626), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16624), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251636] = 7,
    ACTIONS(21956), 1,
      sym__syntactic_operator,
    ACTIONS(22010), 1,
      sym__word_identifier,
    STATE(11670), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(17383), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16304), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251673] = 7,
    ACTIONS(22012), 1,
      sym__word_identifier,
    ACTIONS(22014), 1,
      sym__syntactic_operator,
    STATE(6622), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6450), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(17106), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17104), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251710] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12242), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251747] = 7,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(21956), 1,
      sym__syntactic_operator,
    STATE(11670), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12183), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16304), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251784] = 7,
    ACTIONS(22016), 1,
      sym__word_identifier,
    ACTIONS(22018), 1,
      sym__syntactic_operator,
    STATE(17138), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16530), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16928), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16926), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251821] = 7,
    ACTIONS(21862), 1,
      sym__word_identifier,
    ACTIONS(22020), 1,
      sym__syntactic_operator,
    STATE(7534), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7015), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16600), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16598), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251858] = 7,
    ACTIONS(18480), 1,
      sym__word_identifier,
    ACTIONS(22022), 1,
      sym__syntactic_operator,
    STATE(11901), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12193), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16332), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16330), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251895] = 7,
    ACTIONS(21838), 1,
      sym__word_identifier,
    ACTIONS(22024), 1,
      sym__syntactic_operator,
    STATE(8288), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7350), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16516), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16514), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251932] = 7,
    ACTIONS(18378), 1,
      sym__word_identifier,
    ACTIONS(22026), 1,
      sym__syntactic_operator,
    STATE(11952), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12077), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16360), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16358), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251969] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(13152), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252006] = 7,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(21956), 1,
      sym__syntactic_operator,
    STATE(11670), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11845), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16304), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252043] = 7,
    ACTIONS(18480), 1,
      sym__word_identifier,
    ACTIONS(22022), 1,
      sym__syntactic_operator,
    STATE(11901), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11847), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16332), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16330), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252080] = 7,
    ACTIONS(18378), 1,
      sym__word_identifier,
    ACTIONS(22026), 1,
      sym__syntactic_operator,
    STATE(11952), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11846), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16360), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16358), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252117] = 7,
    ACTIONS(21736), 1,
      sym__word_identifier,
    ACTIONS(22028), 1,
      sym__syntactic_operator,
    STATE(8956), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8330), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16858), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16856), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252154] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12893), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252191] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12894), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252228] = 7,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(21956), 1,
      sym__syntactic_operator,
    STATE(11670), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12895), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16304), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16302), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252265] = 7,
    ACTIONS(21744), 1,
      sym__word_identifier,
    ACTIONS(22030), 1,
      sym__syntactic_operator,
    STATE(8282), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7434), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16422), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16420), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252302] = 7,
    ACTIONS(22032), 1,
      sym__word_identifier,
    ACTIONS(22034), 1,
      sym__syntactic_operator,
    STATE(6557), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6174), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16386), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16384), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252339] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12227), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252376] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12232), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252413] = 7,
    ACTIONS(22036), 1,
      sym__word_identifier,
    ACTIONS(22038), 1,
      sym__syntactic_operator,
    STATE(6695), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6603), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(17386), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(17384), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252450] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11856), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252487] = 7,
    ACTIONS(18310), 1,
      sym__word_identifier,
    ACTIONS(22040), 1,
      sym__syntactic_operator,
    STATE(8686), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7595), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16952), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16950), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252524] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12902), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252561] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12240), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252598] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12903), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252635] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12241), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252672] = 7,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(21984), 1,
      sym__syntactic_operator,
    STATE(10394), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12915), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(16276), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(16274), 8,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252709] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16012), 1,
      anon_sym_COLON,
    ACTIONS(16020), 1,
      anon_sym_DOLLAR,
    ACTIONS(16026), 1,
      sym__string_start,
    ACTIONS(16028), 1,
      sym__command_start,
    ACTIONS(20211), 1,
      sym__word_identifier,
    ACTIONS(22042), 1,
      sym_character_literal,
    ACTIONS(22044), 1,
      sym__immediate_paren,
    STATE(10419), 1,
      sym_identifier,
    STATE(17051), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11141), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [252753] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15868), 1,
      anon_sym_COLON,
    ACTIONS(15876), 1,
      anon_sym_DOLLAR,
    ACTIONS(15882), 1,
      sym__string_start,
    ACTIONS(15884), 1,
      sym__command_start,
    ACTIONS(19751), 1,
      sym__word_identifier,
    ACTIONS(22046), 1,
      sym_character_literal,
    ACTIONS(22048), 1,
      sym__immediate_paren,
    STATE(11036), 1,
      sym_identifier,
    STATE(16907), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10668), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [252797] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16114), 1,
      anon_sym_COLON,
    ACTIONS(16116), 1,
      anon_sym_DOLLAR,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(22050), 1,
      sym_character_literal,
    ACTIONS(22052), 1,
      sym__immediate_paren,
    STATE(10472), 1,
      sym_identifier,
    STATE(16834), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10052), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [252841] = 12,
    ACTIONS(59), 1,
      anon_sym_DOLLAR,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22054), 1,
      anon_sym_COLON,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    STATE(84), 1,
      sym_macro_identifier,
    STATE(10818), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [252885] = 12,
    ACTIONS(2786), 1,
      sym__string_start,
    ACTIONS(2788), 1,
      sym__command_start,
    ACTIONS(8546), 1,
      anon_sym_AT,
    ACTIONS(8564), 1,
      anon_sym_DOLLAR,
    ACTIONS(20109), 1,
      sym__word_identifier,
    ACTIONS(22060), 1,
      anon_sym_COLON,
    ACTIONS(22062), 1,
      sym_character_literal,
    ACTIONS(22064), 1,
      sym__immediate_paren,
    STATE(43), 1,
      sym_macro_identifier,
    STATE(10234), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10549), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [252929] = 12,
    ACTIONS(685), 1,
      sym__string_start,
    ACTIONS(687), 1,
      sym__command_start,
    ACTIONS(4776), 1,
      anon_sym_AT,
    ACTIONS(8724), 1,
      anon_sym_DOLLAR,
    ACTIONS(19566), 1,
      sym__word_identifier,
    ACTIONS(22066), 1,
      anon_sym_COLON,
    ACTIONS(22068), 1,
      sym_character_literal,
    ACTIONS(22070), 1,
      sym__immediate_paren,
    STATE(30), 1,
      sym_macro_identifier,
    STATE(4443), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5498), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [252973] = 12,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(4162), 1,
      anon_sym_DOLLAR,
    ACTIONS(4166), 1,
      anon_sym_AT,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22072), 1,
      anon_sym_COLON,
    STATE(17), 1,
      sym_macro_identifier,
    STATE(10279), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253017] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15992), 1,
      anon_sym_COLON,
    ACTIONS(16000), 1,
      anon_sym_DOLLAR,
    ACTIONS(16006), 1,
      sym__string_start,
    ACTIONS(16008), 1,
      sym__command_start,
    ACTIONS(19965), 1,
      sym__word_identifier,
    ACTIONS(22074), 1,
      sym_character_literal,
    ACTIONS(22076), 1,
      sym__immediate_paren,
    STATE(11481), 1,
      sym_identifier,
    STATE(16999), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12194), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253061] = 12,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(487), 1,
      sym__string_start,
    ACTIONS(489), 1,
      sym__command_start,
    ACTIONS(6316), 1,
      anon_sym_DOLLAR,
    ACTIONS(20273), 1,
      sym__word_identifier,
    ACTIONS(22078), 1,
      anon_sym_COLON,
    ACTIONS(22080), 1,
      sym_character_literal,
    ACTIONS(22082), 1,
      sym__immediate_paren,
    STATE(9), 1,
      sym_macro_identifier,
    STATE(4314), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5053), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253105] = 12,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(3152), 1,
      anon_sym_DOLLAR,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(22084), 1,
      anon_sym_COLON,
    ACTIONS(22086), 1,
      sym_character_literal,
    ACTIONS(22088), 1,
      sym__immediate_paren,
    STATE(124), 1,
      sym_macro_identifier,
    STATE(10626), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10505), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253149] = 12,
    ACTIONS(761), 1,
      sym__string_start,
    ACTIONS(763), 1,
      sym__command_start,
    ACTIONS(6640), 1,
      anon_sym_AT,
    ACTIONS(8766), 1,
      anon_sym_DOLLAR,
    ACTIONS(19873), 1,
      sym__word_identifier,
    ACTIONS(22090), 1,
      anon_sym_COLON,
    ACTIONS(22092), 1,
      sym_character_literal,
    ACTIONS(22094), 1,
      sym__immediate_paren,
    STATE(33), 1,
      sym_macro_identifier,
    STATE(4537), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5685), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253193] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15772), 1,
      anon_sym_COLON,
    ACTIONS(15780), 1,
      anon_sym_DOLLAR,
    ACTIONS(15786), 1,
      sym__string_start,
    ACTIONS(15788), 1,
      sym__command_start,
    ACTIONS(19973), 1,
      sym__word_identifier,
    ACTIONS(22096), 1,
      sym_character_literal,
    ACTIONS(22098), 1,
      sym__immediate_paren,
    STATE(4973), 1,
      sym_identifier,
    STATE(17002), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6311), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253237] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15882), 1,
      sym__string_start,
    ACTIONS(15884), 1,
      sym__command_start,
    ACTIONS(16070), 1,
      anon_sym_COLON,
    ACTIONS(16072), 1,
      anon_sym_DOLLAR,
    ACTIONS(19751), 1,
      sym__word_identifier,
    ACTIONS(22046), 1,
      sym_character_literal,
    ACTIONS(22048), 1,
      sym__immediate_paren,
    STATE(10429), 1,
      sym_identifier,
    STATE(16907), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10668), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253281] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15900), 1,
      anon_sym_COLON,
    ACTIONS(15908), 1,
      anon_sym_DOLLAR,
    ACTIONS(15914), 1,
      sym__string_start,
    ACTIONS(15916), 1,
      sym__command_start,
    ACTIONS(20123), 1,
      sym__word_identifier,
    ACTIONS(22100), 1,
      sym_character_literal,
    ACTIONS(22102), 1,
      sym__immediate_paren,
    STATE(4299), 1,
      sym_identifier,
    STATE(17031), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4697), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253325] = 12,
    ACTIONS(399), 1,
      sym__string_start,
    ACTIONS(401), 1,
      sym__command_start,
    ACTIONS(4166), 1,
      anon_sym_AT,
    ACTIONS(8650), 1,
      anon_sym_DOLLAR,
    ACTIONS(20029), 1,
      sym__word_identifier,
    ACTIONS(22104), 1,
      anon_sym_COLON,
    ACTIONS(22106), 1,
      sym_character_literal,
    ACTIONS(22108), 1,
      sym__immediate_paren,
    STATE(7), 1,
      sym_macro_identifier,
    STATE(4331), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5028), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253369] = 12,
    ACTIONS(1001), 1,
      sym__string_start,
    ACTIONS(1003), 1,
      sym__command_start,
    ACTIONS(8542), 1,
      anon_sym_DOLLAR,
    ACTIONS(8546), 1,
      anon_sym_AT,
    ACTIONS(20191), 1,
      sym__word_identifier,
    ACTIONS(22110), 1,
      anon_sym_COLON,
    ACTIONS(22112), 1,
      sym_character_literal,
    ACTIONS(22114), 1,
      sym__immediate_paren,
    STATE(59), 1,
      sym_macro_identifier,
    STATE(4591), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6391), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253413] = 12,
    ACTIONS(1001), 1,
      sym__string_start,
    ACTIONS(1003), 1,
      sym__command_start,
    ACTIONS(8542), 1,
      anon_sym_DOLLAR,
    ACTIONS(8546), 1,
      anon_sym_AT,
    ACTIONS(20191), 1,
      sym__word_identifier,
    ACTIONS(22110), 1,
      anon_sym_COLON,
    ACTIONS(22112), 1,
      sym_character_literal,
    ACTIONS(22114), 1,
      sym__immediate_paren,
    STATE(68), 1,
      sym_macro_identifier,
    STATE(4591), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6391), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253457] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15510), 1,
      anon_sym_COLON,
    ACTIONS(15518), 1,
      anon_sym_DOLLAR,
    ACTIONS(15524), 1,
      sym__string_start,
    ACTIONS(15526), 1,
      sym__command_start,
    ACTIONS(19740), 1,
      sym__word_identifier,
    ACTIONS(22116), 1,
      sym_character_literal,
    ACTIONS(22118), 1,
      sym__immediate_paren,
    STATE(9260), 1,
      sym_identifier,
    STATE(16887), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9367), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253501] = 12,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(487), 1,
      sym__string_start,
    ACTIONS(489), 1,
      sym__command_start,
    ACTIONS(6316), 1,
      anon_sym_DOLLAR,
    ACTIONS(20273), 1,
      sym__word_identifier,
    ACTIONS(22078), 1,
      anon_sym_COLON,
    ACTIONS(22080), 1,
      sym_character_literal,
    ACTIONS(22082), 1,
      sym__immediate_paren,
    STATE(35), 1,
      sym_macro_identifier,
    STATE(4314), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5053), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253545] = 12,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(8578), 1,
      anon_sym_DOLLAR,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22120), 1,
      anon_sym_COLON,
    STATE(89), 1,
      sym_macro_identifier,
    STATE(10292), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253589] = 12,
    ACTIONS(867), 1,
      anon_sym_DOLLAR,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(899), 1,
      sym__string_start,
    ACTIONS(901), 1,
      sym__command_start,
    ACTIONS(19502), 1,
      sym__word_identifier,
    ACTIONS(22122), 1,
      anon_sym_COLON,
    ACTIONS(22124), 1,
      sym_character_literal,
    ACTIONS(22126), 1,
      sym__immediate_paren,
    STATE(83), 1,
      sym_macro_identifier,
    STATE(4411), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5787), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253633] = 12,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(2908), 1,
      anon_sym_DOLLAR,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(22086), 1,
      sym_character_literal,
    ACTIONS(22088), 1,
      sym__immediate_paren,
    ACTIONS(22128), 1,
      anon_sym_COLON,
    STATE(93), 1,
      sym_macro_identifier,
    STATE(10311), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10505), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253677] = 12,
    ACTIONS(867), 1,
      anon_sym_DOLLAR,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(899), 1,
      sym__string_start,
    ACTIONS(901), 1,
      sym__command_start,
    ACTIONS(19502), 1,
      sym__word_identifier,
    ACTIONS(22122), 1,
      anon_sym_COLON,
    ACTIONS(22124), 1,
      sym_character_literal,
    ACTIONS(22126), 1,
      sym__immediate_paren,
    STATE(61), 1,
      sym_macro_identifier,
    STATE(4411), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5787), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253721] = 12,
    ACTIONS(867), 1,
      anon_sym_DOLLAR,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(899), 1,
      sym__string_start,
    ACTIONS(901), 1,
      sym__command_start,
    ACTIONS(19502), 1,
      sym__word_identifier,
    ACTIONS(22122), 1,
      anon_sym_COLON,
    ACTIONS(22124), 1,
      sym_character_literal,
    ACTIONS(22126), 1,
      sym__immediate_paren,
    STATE(72), 1,
      sym_macro_identifier,
    STATE(4411), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5787), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253765] = 12,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(2908), 1,
      anon_sym_DOLLAR,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(22086), 1,
      sym_character_literal,
    ACTIONS(22088), 1,
      sym__immediate_paren,
    ACTIONS(22128), 1,
      anon_sym_COLON,
    STATE(186), 1,
      sym_macro_identifier,
    STATE(10311), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10505), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253809] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15682), 1,
      anon_sym_COLON,
    ACTIONS(15690), 1,
      anon_sym_DOLLAR,
    ACTIONS(15696), 1,
      sym__string_start,
    ACTIONS(15698), 1,
      sym__command_start,
    ACTIONS(19991), 1,
      sym__word_identifier,
    ACTIONS(22130), 1,
      sym_character_literal,
    ACTIONS(22132), 1,
      sym__immediate_paren,
    STATE(4531), 1,
      sym_identifier,
    STATE(17012), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5699), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253853] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15824), 1,
      anon_sym_COLON,
    ACTIONS(15832), 1,
      anon_sym_DOLLAR,
    ACTIONS(15838), 1,
      sym__string_start,
    ACTIONS(15840), 1,
      sym__command_start,
    ACTIONS(19422), 1,
      sym__word_identifier,
    ACTIONS(22134), 1,
      sym_character_literal,
    ACTIONS(22136), 1,
      sym__immediate_paren,
    STATE(4950), 1,
      sym_identifier,
    STATE(17040), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6021), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253897] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15550), 1,
      anon_sym_COLON,
    ACTIONS(15558), 1,
      anon_sym_DOLLAR,
    ACTIONS(15564), 1,
      sym__string_start,
    ACTIONS(15566), 1,
      sym__command_start,
    ACTIONS(19987), 1,
      sym__word_identifier,
    ACTIONS(22138), 1,
      sym_character_literal,
    ACTIONS(22140), 1,
      sym__immediate_paren,
    STATE(4300), 1,
      sym_identifier,
    STATE(17007), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4992), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253941] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16126), 1,
      anon_sym_COLON,
    ACTIONS(16128), 1,
      anon_sym_DOLLAR,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(22050), 1,
      sym_character_literal,
    ACTIONS(22052), 1,
      sym__immediate_paren,
    STATE(10830), 1,
      sym_identifier,
    STATE(16834), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10052), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [253985] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15642), 1,
      anon_sym_COLON,
    ACTIONS(15650), 1,
      anon_sym_DOLLAR,
    ACTIONS(15656), 1,
      sym__string_start,
    ACTIONS(15658), 1,
      sym__command_start,
    ACTIONS(20241), 1,
      sym__word_identifier,
    ACTIONS(22142), 1,
      sym_character_literal,
    ACTIONS(22144), 1,
      sym__immediate_paren,
    STATE(4709), 1,
      sym_identifier,
    STATE(17060), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6420), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254029] = 12,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16120), 1,
      anon_sym_COLON,
    ACTIONS(16122), 1,
      anon_sym_DOLLAR,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(22146), 1,
      sym_character_literal,
    ACTIONS(22148), 1,
      sym__immediate_paren,
    STATE(11027), 1,
      sym_identifier,
    STATE(16755), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10156), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254073] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15530), 1,
      anon_sym_COLON,
    ACTIONS(15538), 1,
      anon_sym_DOLLAR,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(22050), 1,
      sym_character_literal,
    ACTIONS(22052), 1,
      sym__immediate_paren,
    STATE(10840), 1,
      sym_identifier,
    STATE(16834), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10052), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254117] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16032), 1,
      anon_sym_COLON,
    ACTIONS(16040), 1,
      anon_sym_DOLLAR,
    ACTIONS(16046), 1,
      sym__string_start,
    ACTIONS(16048), 1,
      sym__command_start,
    ACTIONS(19666), 1,
      sym__word_identifier,
    ACTIONS(22150), 1,
      sym_character_literal,
    ACTIONS(22152), 1,
      sym__immediate_paren,
    STATE(5684), 1,
      sym_identifier,
    STATE(16758), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6476), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254161] = 12,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(2908), 1,
      anon_sym_DOLLAR,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(22086), 1,
      sym_character_literal,
    ACTIONS(22088), 1,
      sym__immediate_paren,
    ACTIONS(22128), 1,
      anon_sym_COLON,
    STATE(69), 1,
      sym_macro_identifier,
    STATE(10311), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10505), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254205] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16078), 1,
      anon_sym_COLON,
    ACTIONS(16086), 1,
      anon_sym_DOLLAR,
    ACTIONS(16092), 1,
      sym__string_start,
    ACTIONS(16094), 1,
      sym__command_start,
    ACTIONS(19542), 1,
      sym__word_identifier,
    ACTIONS(22154), 1,
      sym_character_literal,
    ACTIONS(22156), 1,
      sym__immediate_paren,
    STATE(4433), 1,
      sym_identifier,
    STATE(16701), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5265), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254249] = 12,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(6970), 1,
      anon_sym_DOLLAR,
    ACTIONS(6974), 1,
      anon_sym_AT,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22158), 1,
      anon_sym_COLON,
    STATE(64), 1,
      sym_macro_identifier,
    STATE(10902), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254293] = 12,
    ACTIONS(307), 1,
      sym__string_start,
    ACTIONS(309), 1,
      sym__command_start,
    ACTIONS(4996), 1,
      anon_sym_AT,
    ACTIONS(8746), 1,
      anon_sym_DOLLAR,
    ACTIONS(19839), 1,
      sym__word_identifier,
    ACTIONS(22160), 1,
      anon_sym_COLON,
    ACTIONS(22162), 1,
      sym_character_literal,
    ACTIONS(22164), 1,
      sym__immediate_paren,
    STATE(13), 1,
      sym_macro_identifier,
    STATE(4318), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5151), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254337] = 12,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(4772), 1,
      anon_sym_DOLLAR,
    ACTIONS(4776), 1,
      anon_sym_AT,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22166), 1,
      anon_sym_COLON,
    STATE(53), 1,
      sym_macro_identifier,
    STATE(10423), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254381] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    ACTIONS(19771), 1,
      sym__word_identifier,
    ACTIONS(22168), 1,
      sym_character_literal,
    ACTIONS(22170), 1,
      sym__immediate_paren,
    STATE(14331), 1,
      sym_identifier,
    STATE(16827), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14369), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254425] = 12,
    ACTIONS(609), 1,
      sym__string_start,
    ACTIONS(611), 1,
      sym__command_start,
    ACTIONS(6478), 1,
      anon_sym_AT,
    ACTIONS(8790), 1,
      anon_sym_DOLLAR,
    ACTIONS(20099), 1,
      sym__word_identifier,
    ACTIONS(22172), 1,
      anon_sym_COLON,
    ACTIONS(22174), 1,
      sym_character_literal,
    ACTIONS(22176), 1,
      sym__immediate_paren,
    STATE(41), 1,
      sym_macro_identifier,
    STATE(4563), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5924), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254469] = 12,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(2908), 1,
      anon_sym_DOLLAR,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(22086), 1,
      sym_character_literal,
    ACTIONS(22088), 1,
      sym__immediate_paren,
    ACTIONS(22128), 1,
      anon_sym_COLON,
    STATE(54), 1,
      sym_macro_identifier,
    STATE(10311), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10505), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254513] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15732), 1,
      anon_sym_COLON,
    ACTIONS(15740), 1,
      anon_sym_DOLLAR,
    ACTIONS(15746), 1,
      sym__string_start,
    ACTIONS(15748), 1,
      sym__command_start,
    ACTIONS(20095), 1,
      sym__word_identifier,
    ACTIONS(22178), 1,
      sym_character_literal,
    ACTIONS(22180), 1,
      sym__immediate_paren,
    STATE(5108), 1,
      sym_identifier,
    STATE(17023), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6400), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254557] = 12,
    ACTIONS(685), 1,
      sym__string_start,
    ACTIONS(687), 1,
      sym__command_start,
    ACTIONS(4776), 1,
      anon_sym_AT,
    ACTIONS(8724), 1,
      anon_sym_DOLLAR,
    ACTIONS(19566), 1,
      sym__word_identifier,
    ACTIONS(22066), 1,
      anon_sym_COLON,
    ACTIONS(22068), 1,
      sym_character_literal,
    ACTIONS(22070), 1,
      sym__immediate_paren,
    STATE(56), 1,
      sym_macro_identifier,
    STATE(4443), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5498), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254601] = 12,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16096), 1,
      anon_sym_COLON,
    ACTIONS(16098), 1,
      anon_sym_DOLLAR,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(22146), 1,
      sym_character_literal,
    ACTIONS(22148), 1,
      sym__immediate_paren,
    STATE(10946), 1,
      sym_identifier,
    STATE(16755), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10156), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254645] = 12,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(2908), 1,
      anon_sym_DOLLAR,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(22086), 1,
      sym_character_literal,
    ACTIONS(22088), 1,
      sym__immediate_paren,
    ACTIONS(22128), 1,
      anon_sym_COLON,
    STATE(148), 1,
      sym_macro_identifier,
    STATE(10311), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10505), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254689] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15926), 1,
      anon_sym_COLON,
    ACTIONS(15934), 1,
      anon_sym_DOLLAR,
    ACTIONS(15940), 1,
      sym__string_start,
    ACTIONS(15942), 1,
      sym__command_start,
    ACTIONS(20207), 1,
      sym__word_identifier,
    ACTIONS(22182), 1,
      sym_character_literal,
    ACTIONS(22184), 1,
      sym__immediate_paren,
    STATE(4402), 1,
      sym_identifier,
    STATE(17048), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5768), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254733] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15792), 1,
      anon_sym_COLON,
    ACTIONS(15800), 1,
      anon_sym_DOLLAR,
    ACTIONS(15806), 1,
      sym__string_start,
    ACTIONS(15808), 1,
      sym__command_start,
    ACTIONS(20149), 1,
      sym__word_identifier,
    ACTIONS(22186), 1,
      sym_character_literal,
    ACTIONS(22188), 1,
      sym__immediate_paren,
    STATE(4364), 1,
      sym_identifier,
    STATE(17035), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5457), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254777] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(16102), 1,
      anon_sym_COLON,
    ACTIONS(16104), 1,
      anon_sym_DOLLAR,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(22050), 1,
      sym_character_literal,
    ACTIONS(22052), 1,
      sym__immediate_paren,
    STATE(10787), 1,
      sym_identifier,
    STATE(16834), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10052), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254821] = 12,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16132), 1,
      anon_sym_COLON,
    ACTIONS(16134), 1,
      anon_sym_DOLLAR,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(22146), 1,
      sym_character_literal,
    ACTIONS(22148), 1,
      sym__immediate_paren,
    STATE(10850), 1,
      sym_identifier,
    STATE(16755), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10156), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254865] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15368), 1,
      sym__string_start,
    ACTIONS(15370), 1,
      sym__command_start,
    ACTIONS(15944), 1,
      anon_sym_COLON,
    ACTIONS(15946), 1,
      anon_sym_DOLLAR,
    ACTIONS(19771), 1,
      sym__word_identifier,
    ACTIONS(22168), 1,
      sym_character_literal,
    ACTIONS(22170), 1,
      sym__immediate_paren,
    STATE(14442), 1,
      sym_identifier,
    STATE(16827), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14369), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254909] = 12,
    ACTIONS(2786), 1,
      sym__string_start,
    ACTIONS(2788), 1,
      sym__command_start,
    ACTIONS(8546), 1,
      anon_sym_AT,
    ACTIONS(8564), 1,
      anon_sym_DOLLAR,
    ACTIONS(20109), 1,
      sym__word_identifier,
    ACTIONS(22060), 1,
      anon_sym_COLON,
    ACTIONS(22062), 1,
      sym_character_literal,
    ACTIONS(22064), 1,
      sym__immediate_paren,
    STATE(74), 1,
      sym_macro_identifier,
    STATE(10234), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10549), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254953] = 12,
    ACTIONS(13186), 1,
      sym__string_start,
    ACTIONS(13188), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15718), 1,
      anon_sym_COLON,
    ACTIONS(15726), 1,
      anon_sym_DOLLAR,
    ACTIONS(19829), 1,
      sym__word_identifier,
    ACTIONS(22190), 1,
      sym_character_literal,
    ACTIONS(22192), 1,
      sym__immediate_paren,
    STATE(10931), 1,
      sym_identifier,
    STATE(16985), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11365), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [254997] = 12,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(3152), 1,
      anon_sym_DOLLAR,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(22084), 1,
      anon_sym_COLON,
    ACTIONS(22086), 1,
      sym_character_literal,
    ACTIONS(22088), 1,
      sym__immediate_paren,
    STATE(103), 1,
      sym_macro_identifier,
    STATE(10626), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10505), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255041] = 12,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(4772), 1,
      anon_sym_DOLLAR,
    ACTIONS(4776), 1,
      anon_sym_AT,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22166), 1,
      anon_sym_COLON,
    STATE(19), 1,
      sym_macro_identifier,
    STATE(10423), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255085] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15582), 1,
      anon_sym_COLON,
    ACTIONS(15590), 1,
      anon_sym_DOLLAR,
    ACTIONS(15596), 1,
      sym__string_start,
    ACTIONS(15598), 1,
      sym__command_start,
    ACTIONS(19805), 1,
      sym__word_identifier,
    ACTIONS(22194), 1,
      sym_character_literal,
    ACTIONS(22196), 1,
      sym__immediate_paren,
    STATE(4338), 1,
      sym_identifier,
    STATE(16957), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4976), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255129] = 12,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15810), 1,
      anon_sym_COLON,
    ACTIONS(15818), 1,
      anon_sym_DOLLAR,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(22146), 1,
      sym_character_literal,
    ACTIONS(22148), 1,
      sym__immediate_paren,
    STATE(11229), 1,
      sym_identifier,
    STATE(16755), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10156), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255173] = 12,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(8578), 1,
      anon_sym_DOLLAR,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22120), 1,
      anon_sym_COLON,
    STATE(63), 1,
      sym_macro_identifier,
    STATE(10292), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255217] = 12,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15892), 1,
      anon_sym_COLON,
    ACTIONS(15894), 1,
      anon_sym_DOLLAR,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(22146), 1,
      sym_character_literal,
    ACTIONS(22148), 1,
      sym__immediate_paren,
    STATE(10812), 1,
      sym_identifier,
    STATE(16755), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10156), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255261] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(15854), 1,
      anon_sym_COLON,
    ACTIONS(15856), 1,
      anon_sym_DOLLAR,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(22050), 1,
      sym_character_literal,
    ACTIONS(22052), 1,
      sym__immediate_paren,
    STATE(11158), 1,
      sym_identifier,
    STATE(16834), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10052), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255305] = 12,
    ACTIONS(173), 1,
      sym__string_start,
    ACTIONS(175), 1,
      sym__command_start,
    ACTIONS(4992), 1,
      anon_sym_DOLLAR,
    ACTIONS(4996), 1,
      anon_sym_AT,
    ACTIONS(19554), 1,
      sym__word_identifier,
    ACTIONS(22198), 1,
      anon_sym_COLON,
    ACTIONS(22200), 1,
      sym_character_literal,
    ACTIONS(22202), 1,
      sym__immediate_paren,
    STATE(28), 1,
      sym_macro_identifier,
    STATE(10304), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10869), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255349] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15752), 1,
      anon_sym_COLON,
    ACTIONS(15760), 1,
      anon_sym_DOLLAR,
    ACTIONS(15766), 1,
      sym__string_start,
    ACTIONS(15768), 1,
      sym__command_start,
    ACTIONS(19999), 1,
      sym__word_identifier,
    ACTIONS(22204), 1,
      sym_character_literal,
    ACTIONS(22206), 1,
      sym__immediate_paren,
    STATE(10443), 1,
      sym_identifier,
    STATE(17016), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11125), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255393] = 12,
    ACTIONS(609), 1,
      sym__string_start,
    ACTIONS(611), 1,
      sym__command_start,
    ACTIONS(6478), 1,
      anon_sym_AT,
    ACTIONS(8790), 1,
      anon_sym_DOLLAR,
    ACTIONS(20099), 1,
      sym__word_identifier,
    ACTIONS(22172), 1,
      anon_sym_COLON,
    ACTIONS(22174), 1,
      sym_character_literal,
    ACTIONS(22176), 1,
      sym__immediate_paren,
    STATE(15), 1,
      sym_macro_identifier,
    STATE(4563), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5924), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255437] = 12,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(3152), 1,
      anon_sym_DOLLAR,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(22084), 1,
      anon_sym_COLON,
    ACTIONS(22086), 1,
      sym_character_literal,
    ACTIONS(22088), 1,
      sym__immediate_paren,
    STATE(143), 1,
      sym_macro_identifier,
    STATE(10626), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10505), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255481] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15662), 1,
      anon_sym_COLON,
    ACTIONS(15670), 1,
      anon_sym_DOLLAR,
    ACTIONS(15676), 1,
      sym__string_start,
    ACTIONS(15678), 1,
      sym__command_start,
    ACTIONS(20105), 1,
      sym__word_identifier,
    ACTIONS(22208), 1,
      sym_character_literal,
    ACTIONS(22210), 1,
      sym__immediate_paren,
    STATE(4344), 1,
      sym_identifier,
    STATE(17027), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5666), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255525] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15952), 1,
      anon_sym_COLON,
    ACTIONS(15960), 1,
      anon_sym_DOLLAR,
    ACTIONS(15966), 1,
      sym__string_start,
    ACTIONS(15968), 1,
      sym__command_start,
    ACTIONS(19913), 1,
      sym__word_identifier,
    ACTIONS(22212), 1,
      sym_character_literal,
    ACTIONS(22214), 1,
      sym__immediate_paren,
    STATE(4925), 1,
      sym_identifier,
    STATE(16991), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6237), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255569] = 12,
    ACTIONS(761), 1,
      sym__string_start,
    ACTIONS(763), 1,
      sym__command_start,
    ACTIONS(6640), 1,
      anon_sym_AT,
    ACTIONS(8766), 1,
      anon_sym_DOLLAR,
    ACTIONS(19873), 1,
      sym__word_identifier,
    ACTIONS(22090), 1,
      anon_sym_COLON,
    ACTIONS(22092), 1,
      sym_character_literal,
    ACTIONS(22094), 1,
      sym__immediate_paren,
    STATE(39), 1,
      sym_macro_identifier,
    STATE(4537), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5685), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255613] = 12,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(3152), 1,
      anon_sym_DOLLAR,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(22084), 1,
      anon_sym_COLON,
    ACTIONS(22086), 1,
      sym_character_literal,
    ACTIONS(22088), 1,
      sym__immediate_paren,
    STATE(65), 1,
      sym_macro_identifier,
    STATE(10626), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10505), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255657] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15972), 1,
      anon_sym_COLON,
    ACTIONS(15980), 1,
      anon_sym_DOLLAR,
    ACTIONS(15986), 1,
      sym__string_start,
    ACTIONS(15988), 1,
      sym__command_start,
    ACTIONS(20025), 1,
      sym__word_identifier,
    ACTIONS(22216), 1,
      sym_character_literal,
    ACTIONS(22218), 1,
      sym__immediate_paren,
    STATE(4541), 1,
      sym_identifier,
    STATE(17019), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5757), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255701] = 12,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(4162), 1,
      anon_sym_DOLLAR,
    ACTIONS(4166), 1,
      anon_sym_AT,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22072), 1,
      anon_sym_COLON,
    STATE(11), 1,
      sym_macro_identifier,
    STATE(10279), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255745] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16052), 1,
      anon_sym_COLON,
    ACTIONS(16060), 1,
      anon_sym_DOLLAR,
    ACTIONS(16066), 1,
      sym__string_start,
    ACTIONS(16068), 1,
      sym__command_start,
    ACTIONS(20237), 1,
      sym__word_identifier,
    ACTIONS(22220), 1,
      sym_character_literal,
    ACTIONS(22222), 1,
      sym__immediate_paren,
    STATE(5194), 1,
      sym_identifier,
    STATE(17055), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6577), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255789] = 12,
    ACTIONS(1087), 1,
      sym__string_start,
    ACTIONS(1089), 1,
      sym__command_start,
    ACTIONS(6974), 1,
      anon_sym_AT,
    ACTIONS(8688), 1,
      anon_sym_DOLLAR,
    ACTIONS(20251), 1,
      sym__word_identifier,
    ACTIONS(22224), 1,
      anon_sym_COLON,
    ACTIONS(22226), 1,
      sym_character_literal,
    ACTIONS(22228), 1,
      sym__immediate_paren,
    STATE(47), 1,
      sym_macro_identifier,
    STATE(4744), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6080), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255833] = 12,
    ACTIONS(59), 1,
      anon_sym_DOLLAR,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22054), 1,
      anon_sym_COLON,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    STATE(44), 1,
      sym_macro_identifier,
    STATE(10818), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255877] = 12,
    ACTIONS(399), 1,
      sym__string_start,
    ACTIONS(401), 1,
      sym__command_start,
    ACTIONS(4166), 1,
      anon_sym_AT,
    ACTIONS(8650), 1,
      anon_sym_DOLLAR,
    ACTIONS(20029), 1,
      sym__word_identifier,
    ACTIONS(22104), 1,
      anon_sym_COLON,
    ACTIONS(22106), 1,
      sym_character_literal,
    ACTIONS(22108), 1,
      sym__immediate_paren,
    STATE(20), 1,
      sym_macro_identifier,
    STATE(4331), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5028), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255921] = 12,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(16108), 1,
      anon_sym_COLON,
    ACTIONS(16110), 1,
      anon_sym_DOLLAR,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(22146), 1,
      sym_character_literal,
    ACTIONS(22148), 1,
      sym__immediate_paren,
    STATE(11012), 1,
      sym_identifier,
    STATE(16755), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10156), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [255965] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15700), 1,
      anon_sym_COLON,
    ACTIONS(15708), 1,
      anon_sym_DOLLAR,
    ACTIONS(15714), 1,
      sym__string_start,
    ACTIONS(15716), 1,
      sym__command_start,
    ACTIONS(19730), 1,
      sym__word_identifier,
    ACTIONS(22230), 1,
      sym_character_literal,
    ACTIONS(22232), 1,
      sym__immediate_paren,
    STATE(9313), 1,
      sym_identifier,
    STATE(16864), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9456), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256009] = 12,
    ACTIONS(173), 1,
      sym__string_start,
    ACTIONS(175), 1,
      sym__command_start,
    ACTIONS(4992), 1,
      anon_sym_DOLLAR,
    ACTIONS(4996), 1,
      anon_sym_AT,
    ACTIONS(19554), 1,
      sym__word_identifier,
    ACTIONS(22198), 1,
      anon_sym_COLON,
    ACTIONS(22200), 1,
      sym_character_literal,
    ACTIONS(22202), 1,
      sym__immediate_paren,
    STATE(5), 1,
      sym_macro_identifier,
    STATE(10304), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10869), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256053] = 12,
    ACTIONS(307), 1,
      sym__string_start,
    ACTIONS(309), 1,
      sym__command_start,
    ACTIONS(4996), 1,
      anon_sym_AT,
    ACTIONS(8746), 1,
      anon_sym_DOLLAR,
    ACTIONS(19839), 1,
      sym__word_identifier,
    ACTIONS(22160), 1,
      anon_sym_COLON,
    ACTIONS(22162), 1,
      sym_character_literal,
    ACTIONS(22164), 1,
      sym__immediate_paren,
    STATE(27), 1,
      sym_macro_identifier,
    STATE(4318), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5151), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256097] = 12,
    ACTIONS(1087), 1,
      sym__string_start,
    ACTIONS(1089), 1,
      sym__command_start,
    ACTIONS(6974), 1,
      anon_sym_AT,
    ACTIONS(8688), 1,
      anon_sym_DOLLAR,
    ACTIONS(20251), 1,
      sym__word_identifier,
    ACTIONS(22224), 1,
      anon_sym_COLON,
    ACTIONS(22226), 1,
      sym_character_literal,
    ACTIONS(22228), 1,
      sym__immediate_paren,
    STATE(81), 1,
      sym_macro_identifier,
    STATE(4744), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6080), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256141] = 12,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(6636), 1,
      anon_sym_DOLLAR,
    ACTIONS(6640), 1,
      anon_sym_AT,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22234), 1,
      anon_sym_COLON,
    STATE(48), 1,
      sym_macro_identifier,
    STATE(10462), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256185] = 12,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(2908), 1,
      anon_sym_DOLLAR,
    ACTIONS(2932), 1,
      sym__string_start,
    ACTIONS(2934), 1,
      sym__command_start,
    ACTIONS(19917), 1,
      sym__word_identifier,
    ACTIONS(22086), 1,
      sym_character_literal,
    ACTIONS(22088), 1,
      sym__immediate_paren,
    ACTIONS(22128), 1,
      anon_sym_COLON,
    STATE(119), 1,
      sym_macro_identifier,
    STATE(10311), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10505), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256229] = 12,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(6970), 1,
      anon_sym_DOLLAR,
    ACTIONS(6974), 1,
      anon_sym_AT,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22158), 1,
      anon_sym_COLON,
    STATE(51), 1,
      sym_macro_identifier,
    STATE(10902), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256273] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15210), 1,
      anon_sym_DOLLAR,
    ACTIONS(15860), 1,
      anon_sym_COLON,
    ACTIONS(19491), 1,
      sym__word_identifier,
    ACTIONS(22236), 1,
      sym_character_literal,
    ACTIONS(22238), 1,
      sym__immediate_paren,
    STATE(10603), 1,
      sym_identifier,
    STATE(17295), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11164), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256317] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(13302), 1,
      sym__string_start,
    ACTIONS(13304), 1,
      sym__command_start,
    ACTIONS(15212), 1,
      anon_sym_DOLLAR,
    ACTIONS(15372), 1,
      anon_sym_COLON,
    ACTIONS(19491), 1,
      sym__word_identifier,
    ACTIONS(22236), 1,
      sym_character_literal,
    ACTIONS(22238), 1,
      sym__immediate_paren,
    STATE(11236), 1,
      sym_identifier,
    STATE(17295), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11164), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256361] = 12,
    ACTIONS(867), 1,
      anon_sym_DOLLAR,
    ACTIONS(871), 1,
      anon_sym_AT,
    ACTIONS(899), 1,
      sym__string_start,
    ACTIONS(901), 1,
      sym__command_start,
    ACTIONS(19502), 1,
      sym__word_identifier,
    ACTIONS(22122), 1,
      anon_sym_COLON,
    ACTIONS(22124), 1,
      sym_character_literal,
    ACTIONS(22126), 1,
      sym__immediate_paren,
    STATE(104), 1,
      sym_macro_identifier,
    STATE(4411), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5787), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256405] = 12,
    ACTIONS(13056), 1,
      sym__string_start,
    ACTIONS(13058), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15568), 1,
      anon_sym_COLON,
    ACTIONS(15576), 1,
      anon_sym_DOLLAR,
    ACTIONS(20187), 1,
      sym__word_identifier,
    ACTIONS(22240), 1,
      sym_character_literal,
    ACTIONS(22242), 1,
      sym__immediate_paren,
    STATE(10734), 1,
      sym_identifier,
    STATE(17044), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11235), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256449] = 12,
    ACTIONS(13003), 1,
      sym__string_start,
    ACTIONS(13005), 1,
      sym__command_start,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15842), 1,
      anon_sym_COLON,
    ACTIONS(15844), 1,
      anon_sym_DOLLAR,
    ACTIONS(20263), 1,
      sym__word_identifier,
    ACTIONS(22146), 1,
      sym_character_literal,
    ACTIONS(22148), 1,
      sym__immediate_paren,
    STATE(11226), 1,
      sym_identifier,
    STATE(16755), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10156), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256493] = 12,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(6474), 1,
      anon_sym_DOLLAR,
    ACTIONS(6478), 1,
      anon_sym_AT,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22244), 1,
      anon_sym_COLON,
    STATE(24), 1,
      sym_macro_identifier,
    STATE(10475), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256537] = 12,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(6474), 1,
      anon_sym_DOLLAR,
    ACTIONS(6478), 1,
      anon_sym_AT,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22244), 1,
      anon_sym_COLON,
    STATE(52), 1,
      sym_macro_identifier,
    STATE(10475), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256581] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15622), 1,
      anon_sym_COLON,
    ACTIONS(15630), 1,
      anon_sym_DOLLAR,
    ACTIONS(15636), 1,
      sym__string_start,
    ACTIONS(15638), 1,
      sym__command_start,
    ACTIONS(19710), 1,
      sym__word_identifier,
    ACTIONS(22246), 1,
      sym_character_literal,
    ACTIONS(22248), 1,
      sym__immediate_paren,
    STATE(4463), 1,
      sym_identifier,
    STATE(16796), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5925), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256625] = 12,
    ACTIONS(85), 1,
      sym__string_start,
    ACTIONS(87), 1,
      sym__command_start,
    ACTIONS(6636), 1,
      anon_sym_DOLLAR,
    ACTIONS(6640), 1,
      anon_sym_AT,
    ACTIONS(19476), 1,
      sym__word_identifier,
    ACTIONS(22056), 1,
      sym_character_literal,
    ACTIONS(22058), 1,
      sym__immediate_paren,
    ACTIONS(22234), 1,
      anon_sym_COLON,
    STATE(22), 1,
      sym_macro_identifier,
    STATE(10462), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9993), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256669] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(15848), 1,
      anon_sym_COLON,
    ACTIONS(15850), 1,
      anon_sym_DOLLAR,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(22050), 1,
      sym_character_literal,
    ACTIONS(22052), 1,
      sym__immediate_paren,
    STATE(11032), 1,
      sym_identifier,
    STATE(16834), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10052), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256713] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15602), 1,
      anon_sym_COLON,
    ACTIONS(15610), 1,
      anon_sym_DOLLAR,
    ACTIONS(15616), 1,
      sym__string_start,
    ACTIONS(15618), 1,
      sym__command_start,
    ACTIONS(19797), 1,
      sym__word_identifier,
    ACTIONS(22250), 1,
      sym_character_literal,
    ACTIONS(22252), 1,
      sym__immediate_paren,
    STATE(4930), 1,
      sym_identifier,
    STATE(16930), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6252), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256757] = 12,
    ACTIONS(13296), 1,
      anon_sym_AT,
    ACTIONS(15544), 1,
      sym__string_start,
    ACTIONS(15546), 1,
      sym__command_start,
    ACTIONS(15918), 1,
      anon_sym_COLON,
    ACTIONS(15920), 1,
      anon_sym_DOLLAR,
    ACTIONS(19720), 1,
      sym__word_identifier,
    ACTIONS(22050), 1,
      sym_character_literal,
    ACTIONS(22052), 1,
      sym__immediate_paren,
    STATE(10487), 1,
      sym_identifier,
    STATE(16834), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10052), 7,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [256801] = 5,
    ACTIONS(11932), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22254), 1,
      anon_sym_do,
    STATE(14393), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11934), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [256826] = 5,
    ACTIONS(11896), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22254), 1,
      anon_sym_do,
    STATE(14388), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11898), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [256851] = 5,
    ACTIONS(11902), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22254), 1,
      anon_sym_do,
    STATE(14371), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11904), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [256876] = 3,
    ACTIONS(11866), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11864), 11,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [256897] = 5,
    ACTIONS(11916), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22254), 1,
      anon_sym_do,
    STATE(14384), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11914), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [256922] = 3,
    ACTIONS(11988), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11990), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [256942] = 5,
    ACTIONS(11928), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15192), 1,
      sym__immediate_string_start,
    ACTIONS(15194), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11930), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [256966] = 5,
    ACTIONS(11888), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15192), 1,
      sym__immediate_string_start,
    ACTIONS(15194), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11890), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [256990] = 3,
    ACTIONS(12032), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12034), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257010] = 3,
    ACTIONS(11980), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11982), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257030] = 5,
    ACTIONS(12002), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22016), 1,
      sym__word_identifier,
    STATE(14390), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12004), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257054] = 3,
    ACTIONS(12028), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12030), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257074] = 3,
    ACTIONS(12020), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12022), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257094] = 3,
    ACTIONS(11976), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11978), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257114] = 3,
    ACTIONS(11984), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11986), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257134] = 5,
    ACTIONS(91), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15192), 1,
      sym__immediate_string_start,
    ACTIONS(15194), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(171), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257158] = 5,
    ACTIONS(11992), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22016), 1,
      sym__word_identifier,
    STATE(14357), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11994), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257182] = 3,
    ACTIONS(12048), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12050), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257202] = 3,
    ACTIONS(12036), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12038), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257222] = 3,
    ACTIONS(12024), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12026), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257242] = 3,
    ACTIONS(11996), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11998), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257262] = 3,
    ACTIONS(12040), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12042), 10,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_do,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257282] = 5,
    ACTIONS(11892), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15192), 1,
      sym__immediate_string_start,
    ACTIONS(15194), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11894), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257306] = 4,
    ACTIONS(22256), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12094), 2,
      anon_sym_DOT,
      aux_sym_integer_literal_token4,
    ACTIONS(12096), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257328] = 5,
    ACTIONS(11958), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22016), 1,
      sym__word_identifier,
    STATE(14379), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11956), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257352] = 5,
    ACTIONS(12006), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22016), 1,
      sym__word_identifier,
    STATE(14399), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12008), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257376] = 3,
    ACTIONS(12240), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12238), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257395] = 3,
    ACTIONS(12308), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12306), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257414] = 3,
    ACTIONS(12066), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12064), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257433] = 3,
    ACTIONS(12268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12266), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257452] = 3,
    ACTIONS(12272), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12270), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257471] = 3,
    ACTIONS(12150), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12148), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257490] = 3,
    ACTIONS(12276), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12274), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257509] = 3,
    ACTIONS(12384), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12386), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257528] = 3,
    ACTIONS(12154), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12152), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257547] = 3,
    ACTIONS(12070), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12068), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257566] = 3,
    ACTIONS(12284), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12282), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257585] = 3,
    ACTIONS(11916), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11914), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257604] = 3,
    ACTIONS(12248), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12246), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257623] = 3,
    ACTIONS(12334), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12336), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257642] = 3,
    ACTIONS(12058), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12056), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257661] = 3,
    ACTIONS(12322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12324), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257680] = 3,
    ACTIONS(12300), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12298), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257699] = 3,
    ACTIONS(12292), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12290), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257718] = 3,
    ACTIONS(11928), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11930), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257737] = 3,
    ACTIONS(12244), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12242), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257756] = 3,
    ACTIONS(12136), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12138), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257775] = 3,
    ACTIONS(12214), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12212), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257794] = 3,
    ACTIONS(12142), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12140), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257813] = 3,
    ACTIONS(12388), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12390), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257832] = 3,
    ACTIONS(12264), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12262), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257851] = 3,
    ACTIONS(11892), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11894), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257870] = 3,
    ACTIONS(12062), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12060), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257889] = 3,
    ACTIONS(12256), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12254), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257908] = 3,
    ACTIONS(12280), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12278), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257927] = 3,
    ACTIONS(12236), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12234), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257946] = 3,
    ACTIONS(12342), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12344), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257965] = 3,
    ACTIONS(12046), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12044), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [257984] = 3,
    ACTIONS(11888), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11890), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258003] = 3,
    ACTIONS(12174), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12172), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258022] = 3,
    ACTIONS(12054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12052), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258041] = 3,
    ACTIONS(12218), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12216), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258060] = 3,
    ACTIONS(11932), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11934), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258079] = 3,
    ACTIONS(12360), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12362), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258098] = 3,
    ACTIONS(12252), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12250), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258117] = 3,
    ACTIONS(12158), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12156), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258136] = 3,
    ACTIONS(12178), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12176), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258155] = 3,
    ACTIONS(12260), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12258), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258174] = 3,
    ACTIONS(12364), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12366), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258193] = 3,
    ACTIONS(11866), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11864), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258212] = 3,
    ACTIONS(12094), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12096), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258231] = 3,
    ACTIONS(2186), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2188), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258250] = 3,
    ACTIONS(12146), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12144), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258269] = 3,
    ACTIONS(12210), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12208), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258288] = 3,
    ACTIONS(12162), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12160), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258307] = 3,
    ACTIONS(12170), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12168), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258326] = 3,
    ACTIONS(12338), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12340), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258345] = 3,
    ACTIONS(12166), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12164), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258364] = 3,
    ACTIONS(12326), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12328), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258383] = 3,
    ACTIONS(12304), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12302), 9,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258402] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22260), 1,
      anon_sym_if,
    ACTIONS(22263), 1,
      anon_sym_for,
    ACTIONS(22266), 1,
      anon_sym_LF,
    ACTIONS(22258), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14405), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [258428] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22271), 1,
      anon_sym_if,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22275), 1,
      anon_sym_LF,
    ACTIONS(22269), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14405), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [258454] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22271), 1,
      anon_sym_if,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22279), 1,
      anon_sym_LF,
    ACTIONS(22277), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14405), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [258480] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22271), 1,
      anon_sym_if,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22279), 1,
      anon_sym_LF,
    ACTIONS(22277), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14406), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [258506] = 8,
    ACTIONS(15214), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22281), 1,
      anon_sym_SQUOTE,
    ACTIONS(22283), 1,
      anon_sym_DOT,
    ACTIONS(22285), 1,
      sym__immediate_paren,
    ACTIONS(22287), 1,
      sym__immediate_bracket,
    ACTIONS(22289), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15216), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258534] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22271), 1,
      anon_sym_if,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22293), 1,
      anon_sym_LF,
    ACTIONS(22291), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14407), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [258560] = 3,
    ACTIONS(11866), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11864), 8,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258578] = 4,
    ACTIONS(22295), 1,
      sym__immediate_string_start,
    ACTIONS(22297), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(171), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
  [258597] = 4,
    ACTIONS(12094), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22299), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12096), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258616] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18442), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22303), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14707), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(17479), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [258645] = 5,
    ACTIONS(11992), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    STATE(14484), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11994), 5,
      sym__immediate_brace,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258666] = 5,
    ACTIONS(11958), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    STATE(14485), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11956), 5,
      sym__immediate_brace,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258687] = 5,
    ACTIONS(12002), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    STATE(14493), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12004), 5,
      sym__immediate_brace,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258708] = 5,
    ACTIONS(12006), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    STATE(14494), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12008), 5,
      sym__immediate_brace,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258729] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18494), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22307), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14563), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(18008), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [258758] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18376), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22309), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14747), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(17597), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [258787] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22311), 1,
      anon_sym_if,
    ACTIONS(22313), 1,
      anon_sym_for,
    ACTIONS(22315), 1,
      anon_sym_LF,
    ACTIONS(22291), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14436), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [258812] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18454), 1,
      anon_sym_SEMI,
    ACTIONS(22317), 1,
      anon_sym_COMMA,
    ACTIONS(22319), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14727), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16586), 1,
      aux_sym_argument_list_repeat1,
    STATE(17529), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [258841] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(18818), 1,
      anon_sym_COMMA,
    STATE(14430), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [258864] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18614), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22321), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14683), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(17435), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [258893] = 5,
    ACTIONS(11992), 1,
      anon_sym_end,
    ACTIONS(22323), 1,
      sym__word_identifier,
    STATE(14357), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11994), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
  [258914] = 5,
    ACTIONS(11958), 1,
      anon_sym_end,
    ACTIONS(22323), 1,
      sym__word_identifier,
    STATE(14379), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
  [258935] = 3,
    ACTIONS(12292), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12290), 7,
      anon_sym_end,
      anon_sym_LT_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258952] = 3,
    ACTIONS(12300), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12298), 7,
      anon_sym_end,
      anon_sym_LT_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [258969] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18672), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22325), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14823), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(17845), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [258998] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19002), 1,
      anon_sym_COMMA,
    STATE(14430), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [259021] = 3,
    ACTIONS(12304), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12302), 7,
      anon_sym_end,
      anon_sym_LT_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259038] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(18849), 1,
      anon_sym_COMMA,
    STATE(14445), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [259061] = 3,
    ACTIONS(12154), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12152), 7,
      anon_sym_end,
      anon_sym_LT_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259078] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18526), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22327), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15148), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(18068), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [259107] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22311), 1,
      anon_sym_if,
    ACTIONS(22313), 1,
      anon_sym_for,
    ACTIONS(22329), 1,
      anon_sym_LF,
    ACTIONS(22277), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14450), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [259132] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22311), 1,
      anon_sym_if,
    ACTIONS(22313), 1,
      anon_sym_for,
    ACTIONS(22329), 1,
      anon_sym_LF,
    ACTIONS(22277), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14451), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [259157] = 5,
    ACTIONS(12002), 1,
      anon_sym_end,
    ACTIONS(22323), 1,
      sym__word_identifier,
    STATE(14390), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12004), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
  [259178] = 5,
    ACTIONS(12006), 1,
      anon_sym_end,
    ACTIONS(22323), 1,
      sym__word_identifier,
    STATE(14399), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12008), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_DOT,
  [259199] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22333), 1,
      sym__immediate_brace,
    STATE(15352), 1,
      sym_type_clause,
    STATE(18654), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259224] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22335), 1,
      sym__immediate_brace,
    STATE(15392), 1,
      sym_type_clause,
    STATE(19141), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259249] = 4,
    ACTIONS(22295), 1,
      sym__immediate_string_start,
    ACTIONS(22297), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11890), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
  [259268] = 4,
    ACTIONS(22295), 1,
      sym__immediate_string_start,
    ACTIONS(22297), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11930), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
  [259287] = 4,
    ACTIONS(22295), 1,
      sym__immediate_string_start,
    ACTIONS(22297), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11894), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_SQUOTE,
      anon_sym_DOT,
  [259306] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18576), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22337), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14665), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(17356), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [259335] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19119), 1,
      anon_sym_COMMA,
    STATE(14445), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [259358] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18474), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22339), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14842), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(17932), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [259387] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22341), 1,
      anon_sym_if,
    ACTIONS(22343), 1,
      anon_sym_LF,
    ACTIONS(22277), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14468), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [259412] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22341), 1,
      anon_sym_if,
    ACTIONS(22343), 1,
      anon_sym_LF,
    ACTIONS(22277), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14469), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [259437] = 5,
    ACTIONS(11892), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22345), 1,
      sym__immediate_string_start,
    ACTIONS(22347), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11894), 5,
      sym__immediate_brace,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259458] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22311), 1,
      anon_sym_if,
    ACTIONS(22313), 1,
      anon_sym_for,
    ACTIONS(22349), 1,
      anon_sym_LF,
    ACTIONS(22269), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14451), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [259483] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22351), 1,
      anon_sym_if,
    ACTIONS(22354), 1,
      anon_sym_for,
    ACTIONS(22357), 1,
      anon_sym_LF,
    ACTIONS(22258), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14451), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [259508] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18336), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22360), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15083), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(17773), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [259537] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18428), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22362), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15037), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(17637), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [259566] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22364), 1,
      sym__immediate_brace,
    STATE(15249), 1,
      sym_type_clause,
    STATE(19391), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259591] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19548), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(19546), 6,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [259610] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22341), 1,
      anon_sym_if,
    ACTIONS(22366), 1,
      anon_sym_LF,
    ACTIONS(22291), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14448), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [259635] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22368), 1,
      sym__immediate_brace,
    STATE(15273), 1,
      sym_type_clause,
    STATE(19369), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259660] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22370), 1,
      sym__immediate_brace,
    STATE(15289), 1,
      sym_type_clause,
    STATE(18867), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259685] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22372), 1,
      sym__immediate_brace,
    STATE(15300), 1,
      sym_type_clause,
    STATE(19188), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259710] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22374), 1,
      sym__immediate_brace,
    STATE(15311), 1,
      sym_type_clause,
    STATE(18683), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259735] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18568), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22376), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14784), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(17764), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [259764] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22378), 1,
      sym__immediate_brace,
    STATE(15320), 1,
      sym_type_clause,
    STATE(18239), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259789] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22380), 1,
      sym__immediate_brace,
    STATE(15326), 1,
      sym_type_clause,
    STATE(18609), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259814] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22382), 1,
      sym__immediate_brace,
    STATE(15331), 1,
      sym_type_clause,
    STATE(19147), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259839] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22384), 1,
      sym__immediate_brace,
    STATE(15339), 1,
      sym_type_clause,
    STATE(19698), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259864] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22386), 1,
      sym__immediate_brace,
    STATE(15348), 1,
      sym_type_clause,
    STATE(19600), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259889] = 7,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    ACTIONS(22388), 1,
      sym__immediate_brace,
    STATE(15358), 1,
      sym_type_clause,
    STATE(18360), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [259914] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22341), 1,
      anon_sym_if,
    ACTIONS(22390), 1,
      anon_sym_LF,
    ACTIONS(22269), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14469), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [259939] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22263), 1,
      anon_sym_for,
    ACTIONS(22392), 1,
      anon_sym_if,
    ACTIONS(22395), 1,
      anon_sym_LF,
    ACTIONS(22258), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14469), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [259964] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22271), 1,
      anon_sym_if,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22400), 1,
      anon_sym_LF,
    STATE(14410), 2,
      sym_if_clause,
      sym_for_clause,
    ACTIONS(22398), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [259989] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18412), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22402), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14549), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(17630), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [260018] = 9,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18666), 1,
      anon_sym_SEMI,
    ACTIONS(22301), 1,
      anon_sym_COMMA,
    ACTIONS(22404), 1,
      anon_sym_RPAREN,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14957), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16567), 1,
      aux_sym_argument_list_repeat1,
    STATE(17496), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [260047] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22271), 1,
      anon_sym_if,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22406), 1,
      anon_sym_LF,
    STATE(14408), 2,
      sym_if_clause,
      sym_for_clause,
    ACTIONS(22291), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [260072] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22408), 1,
      anon_sym_LF,
    ACTIONS(22258), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
  [260090] = 3,
    ACTIONS(12066), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12064), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260106] = 3,
    ACTIONS(12054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12052), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260122] = 3,
    ACTIONS(12264), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12262), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260138] = 3,
    ACTIONS(12268), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12266), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260154] = 3,
    ACTIONS(12272), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12270), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260170] = 3,
    ACTIONS(12304), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12302), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260186] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(19474), 1,
      anon_sym_COMMA,
    STATE(14538), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [260208] = 3,
    ACTIONS(12236), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12234), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260224] = 3,
    ACTIONS(12240), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12238), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260240] = 3,
    ACTIONS(12276), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12274), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260256] = 3,
    ACTIONS(12280), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12278), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260272] = 3,
    ACTIONS(12070), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12068), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260288] = 3,
    ACTIONS(12284), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12282), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260304] = 3,
    ACTIONS(12142), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12140), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260320] = 3,
    ACTIONS(12146), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12144), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260336] = 3,
    ACTIONS(12150), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12148), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260352] = 3,
    ACTIONS(12154), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12152), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260368] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22311), 1,
      anon_sym_if,
    ACTIONS(22313), 1,
      anon_sym_for,
    ACTIONS(22406), 1,
      anon_sym_LF,
    ACTIONS(22291), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14435), 2,
      sym_if_clause,
      sym_for_clause,
  [260392] = 3,
    ACTIONS(12158), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12156), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260408] = 3,
    ACTIONS(12162), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12160), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260424] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22410), 1,
      anon_sym_COMMA,
    ACTIONS(22414), 1,
      anon_sym_LF,
    STATE(14530), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(22412), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [260446] = 3,
    ACTIONS(12210), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12208), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260462] = 3,
    ACTIONS(12166), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12164), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260478] = 3,
    ACTIONS(12170), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12168), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260494] = 3,
    ACTIONS(12178), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12176), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260510] = 3,
    ACTIONS(12244), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12242), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260526] = 3,
    ACTIONS(12292), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12290), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260542] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22410), 1,
      anon_sym_COMMA,
    ACTIONS(22418), 1,
      anon_sym_LF,
    STATE(14495), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(22416), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [260564] = 3,
    ACTIONS(12062), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12060), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260580] = 3,
    ACTIONS(11866), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11864), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260596] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15317), 1,
      sym_type_clause,
    STATE(18916), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260618] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17754), 1,
      anon_sym_EQ,
    ACTIONS(18857), 1,
      anon_sym_LF,
    ACTIONS(18891), 1,
      aux_sym__terminator_token1,
    STATE(15120), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
  [260642] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(19738), 1,
      anon_sym_COMMA,
    STATE(14546), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [260664] = 3,
    ACTIONS(12248), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12246), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260680] = 3,
    ACTIONS(12046), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12044), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260696] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15252), 1,
      sym_type_clause,
    STATE(19836), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260718] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22341), 1,
      anon_sym_if,
    ACTIONS(22406), 1,
      anon_sym_LF,
    ACTIONS(22291), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14447), 2,
      sym_if_clause,
      sym_for_clause,
  [260742] = 3,
    ACTIONS(12252), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12250), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260758] = 3,
    ACTIONS(12256), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12254), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260774] = 3,
    ACTIONS(12094), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12096), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260790] = 3,
    ACTIONS(12260), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12258), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260806] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15275), 1,
      sym_type_clause,
    STATE(18233), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260828] = 3,
    ACTIONS(12300), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12298), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260844] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15291), 1,
      sym_type_clause,
    STATE(19820), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260866] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17850), 1,
      anon_sym_EQ,
    ACTIONS(19126), 1,
      anon_sym_LF,
    ACTIONS(19160), 1,
      aux_sym__terminator_token1,
    STATE(14887), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [260890] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15302), 1,
      sym_type_clause,
    STATE(19620), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260912] = 3,
    ACTIONS(12384), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12386), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260928] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15313), 1,
      sym_type_clause,
    STATE(19349), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260950] = 3,
    ACTIONS(11892), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11894), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260966] = 3,
    ACTIONS(12388), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12390), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [260982] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15322), 1,
      sym_type_clause,
    STATE(18338), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [261004] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(15246), 1,
      anon_sym_LF,
    ACTIONS(15241), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
  [261022] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15328), 1,
      sym_type_clause,
    STATE(18763), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [261044] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22418), 1,
      anon_sym_LF,
    ACTIONS(22420), 1,
      anon_sym_COMMA,
    STATE(14535), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(22416), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [261066] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15333), 1,
      sym_type_clause,
    STATE(19398), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [261088] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(15246), 1,
      anon_sym_LF,
    ACTIONS(22422), 1,
      anon_sym_COMMA,
    STATE(14530), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(15241), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [261110] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15341), 1,
      sym_type_clause,
    STATE(19579), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [261132] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(19484), 1,
      anon_sym_COMMA,
    STATE(14541), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
  [261154] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15368), 1,
      sym_type_clause,
    STATE(18780), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [261176] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15351), 1,
      sym_type_clause,
    STATE(18589), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [261198] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22414), 1,
      anon_sym_LF,
    ACTIONS(22420), 1,
      anon_sym_COMMA,
    STATE(14544), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(22412), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [261220] = 6,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(22331), 1,
      anon_sym_LT_COLON,
    STATE(15360), 1,
      sym_type_clause,
    STATE(19217), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [261242] = 5,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22427), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
    ACTIONS(22425), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [261262] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19486), 1,
      anon_sym_COMMA,
    STATE(14538), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [261284] = 5,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22427), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
    ACTIONS(22429), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [261304] = 5,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22427), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
    ACTIONS(22431), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [261324] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19495), 1,
      anon_sym_COMMA,
    STATE(14541), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
  [261346] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22311), 1,
      anon_sym_if,
    ACTIONS(22313), 1,
      anon_sym_for,
    ACTIONS(22433), 1,
      anon_sym_LF,
    ACTIONS(22398), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14421), 2,
      sym_if_clause,
      sym_for_clause,
  [261370] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22273), 1,
      anon_sym_for,
    ACTIONS(22341), 1,
      anon_sym_if,
    ACTIONS(22435), 1,
      anon_sym_LF,
    ACTIONS(22398), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14456), 2,
      sym_if_clause,
      sym_for_clause,
  [261394] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(15246), 1,
      anon_sym_LF,
    ACTIONS(22437), 1,
      anon_sym_COMMA,
    STATE(14544), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(15241), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [261416] = 3,
    ACTIONS(12058), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12056), 6,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [261432] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(19744), 1,
      anon_sym_COMMA,
    STATE(14546), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [261454] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22444), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22442), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14889), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261473] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19346), 1,
      anon_sym_RPAREN,
    ACTIONS(19348), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15091), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17994), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [261496] = 7,
    ACTIONS(8670), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22446), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17731), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [261519] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22450), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22448), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14553), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261538] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22456), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22454), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14554), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261557] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22460), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22458), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14561), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261576] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22464), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261595] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22468), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261614] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22472), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22470), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14562), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261633] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22474), 1,
      anon_sym_end,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    STATE(18465), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14582), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [261654] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22478), 1,
      anon_sym_end,
    STATE(18514), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [261675] = 7,
    ACTIONS(9926), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22480), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17998), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [261698] = 7,
    ACTIONS(10044), 1,
      anon_sym_RPAREN,
    ACTIONS(22482), 1,
      anon_sym_COMMA,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19382), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [261721] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18770), 1,
      anon_sym_RPAREN,
    ACTIONS(18772), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14583), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17450), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [261744] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22486), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261763] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22488), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261782] = 7,
    ACTIONS(8860), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22490), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17470), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [261805] = 7,
    ACTIONS(8862), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22492), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18934), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [261828] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22496), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22494), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14568), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261847] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22500), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22498), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14569), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261866] = 5,
    ACTIONS(15354), 1,
      anon_sym_COLON,
    ACTIONS(15362), 1,
      anon_sym_DOLLAR,
    ACTIONS(22016), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16220), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [261885] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22502), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261904] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22504), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [261923] = 7,
    ACTIONS(9058), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22506), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17532), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [261946] = 7,
    ACTIONS(9962), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22508), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17398), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [261969] = 7,
    ACTIONS(10082), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22510), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19334), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [261992] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19028), 1,
      anon_sym_RPAREN,
    ACTIONS(19030), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14641), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17920), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262015] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18836), 1,
      anon_sym_RPAREN,
    ACTIONS(18838), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15057), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17701), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262038] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22512), 1,
      anon_sym_LF,
    ACTIONS(22515), 1,
      aux_sym__terminator_token1,
    STATE(14575), 1,
      aux_sym__block_repeat1,
    ACTIONS(19546), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
  [262059] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19398), 1,
      anon_sym_RPAREN,
    ACTIONS(19400), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14595), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17527), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262082] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22520), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22518), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14580), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262101] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22524), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22522), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14581), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262120] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22526), 1,
      anon_sym_end,
    STATE(19560), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14599), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [262141] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22528), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262160] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22530), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262179] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22532), 1,
      anon_sym_end,
    STATE(19601), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [262200] = 7,
    ACTIONS(10002), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22534), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17466), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262223] = 7,
    ACTIONS(10118), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22536), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18896), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262246] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19058), 1,
      anon_sym_RPAREN,
    ACTIONS(19060), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14605), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17626), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262269] = 7,
    ACTIONS(9178), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22538), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17671), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262292] = 7,
    ACTIONS(9378), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22540), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18505), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262315] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22544), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22542), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14610), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262334] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22548), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22546), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14611), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262353] = 5,
    ACTIONS(18502), 1,
      sym__word_identifier,
    ACTIONS(22550), 1,
      anon_sym_COLON,
    ACTIONS(22552), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7086), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [262372] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22556), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22554), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14593), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262391] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22560), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22558), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14594), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262410] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22562), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262429] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22564), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262448] = 7,
    ACTIONS(10038), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22566), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17557), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262471] = 7,
    ACTIONS(10158), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22568), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19774), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262494] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18794), 1,
      anon_sym_RPAREN,
    ACTIONS(18796), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14848), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17973), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262517] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18976), 1,
      anon_sym_RPAREN,
    ACTIONS(18978), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14616), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17744), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262540] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22570), 1,
      anon_sym_end,
    STATE(18294), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [262561] = 7,
    ACTIONS(9020), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22572), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18931), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262584] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22576), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22574), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14603), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262603] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22580), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22578), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14604), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262622] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22582), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262641] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22584), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262660] = 7,
    ACTIONS(10076), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22586), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17667), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262683] = 7,
    ACTIONS(10194), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22588), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18496), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262706] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18907), 1,
      anon_sym_RPAREN,
    ACTIONS(18909), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14632), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17846), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262729] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22590), 1,
      anon_sym_end,
    STATE(18567), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14783), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [262750] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22592), 1,
      anon_sym_end,
    STATE(18709), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [262771] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22594), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262790] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22596), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262809] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22600), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22598), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14614), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262828] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22604), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22602), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14615), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262847] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22606), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262866] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22608), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262885] = 7,
    ACTIONS(10112), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22610), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17775), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262908] = 7,
    ACTIONS(10232), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22612), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18827), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262931] = 5,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22614), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22431), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
  [262950] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19040), 1,
      anon_sym_RPAREN,
    ACTIONS(19042), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14647), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17990), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [262973] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22618), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22616), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14624), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [262992] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22622), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22620), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14627), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263011] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22626), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22624), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14967), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263030] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22630), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22628), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14978), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263049] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22632), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263068] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22636), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22634), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14628), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263087] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22640), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22638), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14629), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263106] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22642), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263125] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22644), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263144] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22646), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263163] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22648), 1,
      anon_sym_end,
    STATE(18492), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14766), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [263184] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17850), 1,
      anon_sym_EQ,
    ACTIONS(19548), 1,
      anon_sym_LF,
    ACTIONS(19546), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [263203] = 7,
    ACTIONS(10152), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22650), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17875), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263226] = 7,
    ACTIONS(10268), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22652), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19110), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263249] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22654), 1,
      anon_sym_end,
    STATE(18526), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [263270] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19330), 1,
      anon_sym_RPAREN,
    ACTIONS(19332), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14659), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18132), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263293] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22658), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22656), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14652), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263312] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22662), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22660), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14653), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263331] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(22664), 1,
      anon_sym_LF,
    ACTIONS(22667), 1,
      aux_sym__terminator_token1,
    STATE(14638), 1,
      aux_sym__block_repeat1,
    ACTIONS(19546), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [263352] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22672), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22670), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14643), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263371] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22676), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22674), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14644), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263390] = 7,
    ACTIONS(9258), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22678), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18129), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263413] = 7,
    ACTIONS(9416), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22680), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18336), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263436] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22682), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263455] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22684), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263474] = 5,
    ACTIONS(21736), 1,
      sym__word_identifier,
    ACTIONS(22686), 1,
      anon_sym_COLON,
    ACTIONS(22688), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8693), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [263493] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22690), 1,
      anon_sym_end,
    STATE(18367), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15035), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [263514] = 7,
    ACTIONS(10188), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22692), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18033), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263537] = 7,
    ACTIONS(10304), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22694), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19518), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263560] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17900), 1,
      anon_sym_EQ,
    ACTIONS(19927), 1,
      anon_sym_LF,
    ACTIONS(19959), 1,
      aux_sym__terminator_token1,
    STATE(15258), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 2,
      anon_sym_end,
      anon_sym_catch,
  [263583] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19013), 1,
      anon_sym_RPAREN,
    ACTIONS(19015), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14671), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17401), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263606] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18764), 1,
      anon_sym_RPAREN,
    ACTIONS(18766), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14946), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17455), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263629] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22696), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263648] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22698), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263667] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22702), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22700), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14656), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263686] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22706), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22704), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14657), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263705] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22708), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263724] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22710), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263743] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19126), 1,
      anon_sym_LF,
    ACTIONS(19160), 1,
      aux_sym__terminator_token1,
    STATE(14887), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [263764] = 7,
    ACTIONS(10226), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22712), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17355), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263787] = 7,
    ACTIONS(10338), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22714), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18688), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263810] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22716), 1,
      anon_sym_end,
    STATE(18395), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [263831] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18842), 1,
      anon_sym_RPAREN,
    ACTIONS(18844), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14784), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17764), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263854] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22718), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263873] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22722), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22720), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14720), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263892] = 7,
    ACTIONS(9024), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22724), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17769), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [263915] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22728), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22726), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14668), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263934] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22732), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22730), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14669), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263953] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22734), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263972] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22736), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [263991] = 7,
    ACTIONS(9226), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22738), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19016), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264014] = 7,
    ACTIONS(10262), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22740), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17413), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264037] = 7,
    ACTIONS(10372), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22742), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19864), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264060] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19034), 1,
      anon_sym_RPAREN,
    ACTIONS(19036), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14681), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17429), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264083] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22746), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22744), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14726), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264102] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22748), 1,
      anon_sym_end,
    STATE(19011), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14710), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [264123] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22750), 1,
      anon_sym_end,
    STATE(19030), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [264144] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22754), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22752), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14679), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264163] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22758), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22756), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14680), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264182] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22760), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264201] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22762), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264220] = 7,
    ACTIONS(10334), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22764), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17445), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264243] = 7,
    ACTIONS(10404), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22766), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18582), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264266] = 7,
    ACTIONS(8902), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22768), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17495), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264289] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19255), 1,
      anon_sym_RPAREN,
    ACTIONS(19257), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14957), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17496), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264312] = 7,
    ACTIONS(8904), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22770), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19186), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264335] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22772), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264354] = 5,
    ACTIONS(21862), 1,
      sym__word_identifier,
    ACTIONS(22774), 1,
      anon_sym_COLON,
    ACTIONS(22776), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7056), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [264373] = 5,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(22778), 1,
      anon_sym_COLON,
    ACTIONS(22780), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11559), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [264392] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22784), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22782), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14691), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264411] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22788), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22786), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14692), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264430] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22790), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264449] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22792), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264468] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22796), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22794), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14706), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264487] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18901), 1,
      anon_sym_RPAREN,
    ACTIONS(18903), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14727), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17529), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264510] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22800), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22798), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14712), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264529] = 7,
    ACTIONS(10400), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22802), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17467), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264552] = 7,
    ACTIONS(10436), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22804), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18861), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264575] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22806), 1,
      anon_sym_end,
    STATE(18873), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14808), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [264596] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18800), 1,
      anon_sym_RPAREN,
    ACTIONS(18802), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14696), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17460), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264619] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22808), 1,
      anon_sym_end,
    STATE(18887), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [264640] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22812), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22810), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14703), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264659] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22816), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22814), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14704), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264678] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22818), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264697] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22820), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264716] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18742), 1,
      anon_sym_RPAREN,
    ACTIONS(18744), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14586), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17459), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264739] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22822), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264758] = 7,
    ACTIONS(9186), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22824), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17485), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264781] = 7,
    ACTIONS(10454), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22826), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19075), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264804] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22828), 1,
      anon_sym_end,
    STATE(19557), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14730), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [264825] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22830), 1,
      anon_sym_end,
    STATE(19572), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [264846] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19076), 1,
      anon_sym_RPAREN,
    ACTIONS(19078), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14718), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17497), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [264869] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22832), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264888] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22836), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22834), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14715), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264907] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22840), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22838), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14716), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264926] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22842), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264945] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22844), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [264964] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17754), 1,
      anon_sym_EQ,
    ACTIONS(19548), 1,
      anon_sym_LF,
    ACTIONS(19546), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [264983] = 7,
    ACTIONS(10434), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22846), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17514), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265006] = 7,
    ACTIONS(10472), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22848), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19310), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265029] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22850), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265048] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19046), 1,
      anon_sym_RPAREN,
    ACTIONS(19048), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14728), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17539), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265071] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22854), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22852), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14724), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265090] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22858), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22856), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14725), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265109] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22860), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265128] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22862), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265147] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22864), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265166] = 7,
    ACTIONS(8608), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22866), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17867), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265189] = 7,
    ACTIONS(10452), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22868), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17549), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265212] = 7,
    ACTIONS(10490), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22870), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19643), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265235] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22872), 1,
      anon_sym_end,
    STATE(18172), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [265256] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18982), 1,
      anon_sym_RPAREN,
    ACTIONS(18984), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14737), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17569), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265279] = 7,
    ACTIONS(8610), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22874), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19143), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265302] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22878), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22876), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14735), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265321] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22882), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22880), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14736), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265340] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22884), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265359] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22886), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265378] = 7,
    ACTIONS(10470), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22888), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17581), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265401] = 7,
    ACTIONS(10510), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22890), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18190), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265424] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18748), 1,
      anon_sym_RPAREN,
    ACTIONS(18750), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14757), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17633), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265447] = 5,
    ACTIONS(15622), 1,
      anon_sym_COLON,
    ACTIONS(15630), 1,
      anon_sym_DOLLAR,
    ACTIONS(22032), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6422), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [265466] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22894), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22892), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14743), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265485] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22898), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22896), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14744), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265504] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22900), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265523] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22902), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265542] = 7,
    ACTIONS(9296), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22904), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17655), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265565] = 7,
    ACTIONS(9452), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22906), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18459), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265588] = 7,
    ACTIONS(9224), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22908), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17611), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265611] = 7,
    ACTIONS(10530), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22910), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18320), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265634] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19172), 1,
      anon_sym_RPAREN,
    ACTIONS(19174), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14768), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17677), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265657] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19166), 1,
      anon_sym_RPAREN,
    ACTIONS(19168), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14933), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17423), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265680] = 5,
    ACTIONS(22010), 1,
      sym__word_identifier,
    ACTIONS(22912), 1,
      anon_sym_COLON,
    ACTIONS(22914), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(17751), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [265699] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22918), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22916), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14754), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265718] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22922), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22920), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14755), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265737] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22924), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265756] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22926), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265775] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19199), 1,
      anon_sym_RPAREN,
    ACTIONS(19201), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14984), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17551), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265798] = 7,
    ACTIONS(10488), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22928), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17651), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265821] = 7,
    ACTIONS(10548), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22930), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18441), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265844] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18698), 1,
      anon_sym_RPAREN,
    ACTIONS(18700), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14780), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17716), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [265867] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22932), 1,
      anon_sym_end,
    STATE(19766), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [265888] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22936), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22934), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14763), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265907] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22940), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22938), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14764), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265926] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22942), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265945] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22944), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [265964] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22946), 1,
      anon_sym_end,
    STATE(19309), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14912), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [265985] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22948), 1,
      anon_sym_end,
    STATE(19337), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [266006] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22952), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22950), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14778), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266025] = 7,
    ACTIONS(10508), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22954), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17695), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266048] = 7,
    ACTIONS(10566), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22956), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18549), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266071] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22960), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22958), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14779), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266090] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18964), 1,
      anon_sym_RPAREN,
    ACTIONS(18966), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14789), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17750), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266113] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(22962), 1,
      anon_sym_COLON,
    ACTIONS(22964), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [266132] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17882), 1,
      anon_sym_EQ,
    ACTIONS(20039), 1,
      anon_sym_LF,
    ACTIONS(20071), 1,
      aux_sym__terminator_token1,
    STATE(15224), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 2,
      anon_sym_end,
      anon_sym_finally,
  [266155] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22968), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22966), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14776), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266174] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22972), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22970), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14777), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266193] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22974), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266212] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22976), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266231] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22978), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266250] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22980), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266269] = 7,
    ACTIONS(10526), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22982), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17724), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266292] = 7,
    ACTIONS(10586), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(22984), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18656), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266315] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19213), 1,
      anon_sym_RPAREN,
    ACTIONS(19215), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14804), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17783), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266338] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(22986), 1,
      anon_sym_end,
    STATE(19158), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [266359] = 7,
    ACTIONS(9104), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22988), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18002), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266382] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22992), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22990), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14787), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266401] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(22996), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22994), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14788), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266420] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(22998), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266439] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23000), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266458] = 7,
    ACTIONS(10546), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23002), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17765), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266481] = 7,
    ACTIONS(10602), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23004), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18787), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266504] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23008), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23006), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14802), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266523] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23012), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23010), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14803), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266542] = 7,
    ACTIONS(9016), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23014), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17826), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266565] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19318), 1,
      anon_sym_RPAREN,
    ACTIONS(19320), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14813), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17819), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266588] = 7,
    ACTIONS(9860), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23016), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19459), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266611] = 5,
    ACTIONS(16052), 1,
      anon_sym_COLON,
    ACTIONS(16060), 1,
      anon_sym_DOLLAR,
    ACTIONS(22006), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6823), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [266630] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23020), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23018), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14799), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266649] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23024), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23022), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14800), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266668] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23026), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266687] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23028), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266706] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18828), 1,
      anon_sym_RPAREN,
    ACTIONS(18830), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15001), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17978), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266729] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23030), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266748] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23032), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266767] = 7,
    ACTIONS(10564), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23034), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17798), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266790] = 7,
    ACTIONS(10622), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23036), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18879), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266813] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18776), 1,
      anon_sym_RPAREN,
    ACTIONS(18778), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14707), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17479), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266836] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23038), 1,
      anon_sym_end,
    STATE(19590), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14866), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [266857] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23040), 1,
      anon_sym_end,
    STATE(19616), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [266878] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23044), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23042), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14811), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266897] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23048), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23046), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14812), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266916] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23050), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266935] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23052), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [266954] = 7,
    ACTIONS(10584), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23054), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17827), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [266977] = 7,
    ACTIONS(10638), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23056), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18986), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267000] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23058), 1,
      anon_sym_end,
    STATE(19254), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14844), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [267021] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23060), 1,
      anon_sym_end,
    STATE(19264), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [267042] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19052), 1,
      anon_sym_RPAREN,
    ACTIONS(19054), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14824), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17851), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267065] = 7,
    ACTIONS(9188), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23062), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19047), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267088] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23066), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23064), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14821), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267107] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23070), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23068), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14822), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267126] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23072), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267145] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23074), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267164] = 7,
    ACTIONS(8942), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23076), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17987), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267187] = 7,
    ACTIONS(10620), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23078), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17863), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267210] = 7,
    ACTIONS(10658), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23080), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19080), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267233] = 7,
    ACTIONS(8944), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23082), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19387), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267256] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19382), 1,
      anon_sym_RPAREN,
    ACTIONS(19384), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14747), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17597), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267279] = 5,
    ACTIONS(15602), 1,
      anon_sym_COLON,
    ACTIONS(15610), 1,
      anon_sym_DOLLAR,
    ACTIONS(21992), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6492), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [267298] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23086), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23084), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14831), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267317] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23090), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23088), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14832), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267336] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23092), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267355] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23094), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267374] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18782), 1,
      anon_sym_RPAREN,
    ACTIONS(18784), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15083), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17773), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267397] = 7,
    ACTIONS(10656), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23096), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17906), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267420] = 7,
    ACTIONS(10676), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23098), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19183), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267443] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18736), 1,
      anon_sym_RPAREN,
    ACTIONS(18738), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14834), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17889), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267466] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23102), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23100), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14839), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267485] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23106), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23104), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14840), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267504] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23108), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267523] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23110), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267542] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23112), 1,
      anon_sym_end,
    STATE(19525), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14862), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [267563] = 7,
    ACTIONS(9264), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23114), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17950), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267586] = 7,
    ACTIONS(10696), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23116), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19296), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267609] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23118), 1,
      anon_sym_end,
    STATE(19545), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [267630] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18935), 1,
      anon_sym_RPAREN,
    ACTIONS(18937), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14852), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18001), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267653] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23122), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23120), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14849), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267672] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23126), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23124), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14850), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267691] = 7,
    ACTIONS(9336), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23128), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18145), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267714] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23130), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267733] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23132), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267752] = 7,
    ACTIONS(9490), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23134), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18923), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267775] = 7,
    ACTIONS(10674), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23136), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18012), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267798] = 7,
    ACTIONS(10712), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23138), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19444), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267821] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19088), 1,
      anon_sym_RPAREN,
    ACTIONS(19090), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14860), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18038), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267844] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23142), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23140), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14858), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267863] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23146), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23144), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14859), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267882] = 5,
    ACTIONS(21752), 1,
      sym__word_identifier,
    ACTIONS(23148), 1,
      anon_sym_COLON,
    ACTIONS(23150), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7144), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [267901] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23152), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267920] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23154), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [267939] = 7,
    ACTIONS(10694), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23156), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18054), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267962] = 7,
    ACTIONS(10732), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23158), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19569), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [267985] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23160), 1,
      anon_sym_end,
    STATE(19675), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [268006] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19324), 1,
      anon_sym_RPAREN,
    ACTIONS(19326), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14869), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18081), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268029] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23164), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23162), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14867), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268048] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23168), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23166), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14868), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268067] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23170), 1,
      anon_sym_end,
    STATE(19006), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [268088] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23172), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268107] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23174), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268126] = 7,
    ACTIONS(10710), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23176), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18096), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268149] = 7,
    ACTIONS(10750), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23178), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19707), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268172] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18692), 1,
      anon_sym_RPAREN,
    ACTIONS(18694), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14877), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18124), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268195] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18788), 1,
      anon_sym_RPAREN,
    ACTIONS(18790), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15026), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17624), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268218] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23182), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23180), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14875), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268237] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23186), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23184), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14876), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268256] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23188), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268275] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23190), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268294] = 7,
    ACTIONS(10730), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23192), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18135), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268317] = 7,
    ACTIONS(10768), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23194), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19831), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268340] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18913), 1,
      anon_sym_RPAREN,
    ACTIONS(18915), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14885), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17349), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268363] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23198), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23196), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14890), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268382] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23202), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23200), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14883), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268401] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23206), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23204), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14884), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268420] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23208), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268439] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23210), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268458] = 7,
    ACTIONS(10748), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23212), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17358), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268481] = 7,
    ACTIONS(10786), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23214), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18765), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268504] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(23216), 1,
      anon_sym_LF,
    ACTIONS(23218), 1,
      aux_sym__terminator_token1,
    STATE(14638), 1,
      aux_sym__block_repeat1,
    ACTIONS(6788), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [268525] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18958), 1,
      anon_sym_RPAREN,
    ACTIONS(18960), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14842), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17932), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268548] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23220), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268567] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23222), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268586] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23226), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23224), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14893), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268605] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23230), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23228), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14894), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268624] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23232), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268643] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23234), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268662] = 7,
    ACTIONS(10784), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23236), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17380), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268685] = 7,
    ACTIONS(10806), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23238), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18599), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268708] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18998), 1,
      anon_sym_RPAREN,
    ACTIONS(19000), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14895), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17372), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268731] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23242), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23240), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14949), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268750] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23246), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23244), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14956), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268769] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23250), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23248), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14921), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268788] = 5,
    ACTIONS(18554), 1,
      sym__word_identifier,
    ACTIONS(23252), 1,
      anon_sym_COLON,
    ACTIONS(23254), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7018), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [268807] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23258), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23256), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14904), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268826] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23262), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23260), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14905), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268845] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23264), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268864] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23266), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268883] = 7,
    ACTIONS(10804), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23268), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17395), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268906] = 7,
    ACTIONS(10824), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23270), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19194), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268929] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23274), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23272), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14941), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268948] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19100), 1,
      anon_sym_RPAREN,
    ACTIONS(19102), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14906), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17390), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [268971] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23278), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23276), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14913), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [268990] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23282), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23280), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14914), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269009] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23284), 1,
      anon_sym_end,
    STATE(19326), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [269030] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23286), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269049] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23288), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269068] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23292), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23290), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14928), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269087] = 7,
    ACTIONS(10822), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23294), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17409), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269110] = 7,
    ACTIONS(10844), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23296), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19695), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269133] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23300), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23298), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14931), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269152] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23304), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23302), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15025), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269171] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19193), 1,
      anon_sym_RPAREN,
    ACTIONS(19195), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14916), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17404), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269194] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23306), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269213] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23308), 1,
      anon_sym_end,
    STATE(18941), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14951), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [269234] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23312), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23310), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14926), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269253] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23316), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23314), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14663), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269272] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23318), 1,
      anon_sym_end,
    STATE(18985), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [269293] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23320), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269312] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23322), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269331] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23324), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269350] = 7,
    ACTIONS(10842), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23326), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17421), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269373] = 7,
    ACTIONS(10862), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23328), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18302), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269396] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23330), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269415] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19270), 1,
      anon_sym_RPAREN,
    ACTIONS(19272), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14929), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17417), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269438] = 7,
    ACTIONS(10980), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23332), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17501), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269461] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23336), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23334), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14937), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269480] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23340), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23338), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14938), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269499] = 7,
    ACTIONS(8982), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23342), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19211), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269522] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23344), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269541] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23346), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269560] = 7,
    ACTIONS(10860), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23348), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17431), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269583] = 7,
    ACTIONS(10880), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23350), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18469), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269606] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23352), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269625] = 5,
    ACTIONS(18616), 1,
      sym__word_identifier,
    ACTIONS(23354), 1,
      anon_sym_COLON,
    ACTIONS(23356), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6811), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [269644] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18921), 1,
      anon_sym_RPAREN,
    ACTIONS(18923), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14939), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17428), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269667] = 5,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23358), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22425), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
  [269686] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19187), 1,
      anon_sym_RPAREN,
    ACTIONS(19189), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15100), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17852), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269709] = 7,
    ACTIONS(9372), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23360), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17513), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269732] = 7,
    ACTIONS(9524), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23362), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19299), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269755] = 5,
    ACTIONS(21822), 1,
      sym__word_identifier,
    ACTIONS(23364), 1,
      anon_sym_COLON,
    ACTIONS(23366), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7325), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [269774] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23368), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269793] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23370), 1,
      anon_sym_end,
    STATE(19268), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14955), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [269814] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23372), 1,
      anon_sym_end,
    STATE(19279), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [269835] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19064), 1,
      anon_sym_RPAREN,
    ACTIONS(19066), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15048), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17675), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269858] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17850), 1,
      anon_sym_EQ,
    ACTIONS(13249), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [269877] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18927), 1,
      anon_sym_RPAREN,
    ACTIONS(18929), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14972), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18153), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269900] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23374), 1,
      anon_sym_end,
    STATE(19450), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [269921] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23376), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [269940] = 7,
    ACTIONS(9144), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23378), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17660), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269963] = 7,
    ACTIONS(9894), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23380), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18522), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [269986] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23384), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23382), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15034), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270005] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23388), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23386), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14992), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270024] = 5,
    ACTIONS(21814), 1,
      sym__word_identifier,
    ACTIONS(23390), 1,
      anon_sym_COLON,
    ACTIONS(23392), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7581), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [270043] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23396), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23394), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14993), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270062] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19278), 1,
      anon_sym_RPAREN,
    ACTIONS(19280), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15066), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17464), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270085] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23400), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23398), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14970), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270104] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13075), 1,
      anon_sym_LF,
    ACTIONS(20405), 1,
      anon_sym_COMMA,
    STATE(14965), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token1,
  [270125] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23404), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23402), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14971), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270144] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23406), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270163] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23410), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23408), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14987), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270182] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23414), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23412), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14988), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270201] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23416), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270220] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23418), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270239] = 7,
    ACTIONS(9138), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23420), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17426), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270262] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23424), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23422), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14982), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270281] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23428), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23426), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14983), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270300] = 7,
    ACTIONS(9342), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23430), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18438), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270323] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23434), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23432), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14990), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270342] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23438), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23436), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14994), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270361] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23440), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270380] = 7,
    ACTIONS(9302), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23442), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18333), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270403] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17940), 1,
      anon_sym_EQ,
    ACTIONS(19628), 1,
      anon_sym_LF,
    ACTIONS(19660), 1,
      aux_sym__terminator_token1,
    STATE(15226), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 2,
      anon_sym_catch,
      anon_sym_finally,
  [270426] = 5,
    ACTIONS(15732), 1,
      anon_sym_COLON,
    ACTIONS(15740), 1,
      anon_sym_DOLLAR,
    ACTIONS(21958), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6477), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [270445] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23444), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270464] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23446), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270483] = 7,
    ACTIONS(9410), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23448), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17573), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270506] = 7,
    ACTIONS(9566), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23450), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18156), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270529] = 5,
    ACTIONS(18598), 1,
      sym__word_identifier,
    ACTIONS(23452), 1,
      anon_sym_COLON,
    ACTIONS(23454), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6790), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [270548] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23456), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270567] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23458), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270586] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19376), 1,
      anon_sym_RPAREN,
    ACTIONS(19378), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15148), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18068), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270609] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23460), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270628] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13148), 1,
      anon_sym_LF,
    ACTIONS(20428), 1,
      anon_sym_COMMA,
    STATE(14965), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13150), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token1,
  [270649] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23462), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270668] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23464), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270687] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23466), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270706] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23468), 1,
      anon_sym_end,
    STATE(18253), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15014), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [270727] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23470), 1,
      anon_sym_end,
    STATE(18485), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14609), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [270748] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23472), 1,
      anon_sym_end,
    STATE(18255), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [270769] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23476), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23474), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15071), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270788] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23480), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23478), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15112), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270807] = 7,
    ACTIONS(8672), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23482), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17600), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270830] = 7,
    ACTIONS(9816), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23484), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17348), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270853] = 7,
    ACTIONS(9026), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23486), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18279), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270876] = 7,
    ACTIONS(9932), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23488), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18289), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270899] = 5,
    ACTIONS(16078), 1,
      anon_sym_COLON,
    ACTIONS(16086), 1,
      anon_sym_DOLLAR,
    ACTIONS(22012), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6111), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [270918] = 5,
    ACTIONS(18310), 1,
      sym__word_identifier,
    ACTIONS(23490), 1,
      anon_sym_COLON,
    ACTIONS(23492), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7586), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [270937] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19070), 1,
      anon_sym_RPAREN,
    ACTIONS(19072), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14563), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18008), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [270960] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23496), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23494), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15019), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270979] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23500), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23498), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15020), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [270998] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18941), 1,
      anon_sym_RPAREN,
    ACTIONS(18943), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14745), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17592), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271021] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19082), 1,
      anon_sym_RPAREN,
    ACTIONS(19084), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15118), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17688), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271044] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23504), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23502), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15051), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271063] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23508), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23506), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15056), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271082] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23510), 1,
      anon_sym_end,
    STATE(18310), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15022), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [271103] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23512), 1,
      anon_sym_end,
    STATE(18312), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [271124] = 7,
    ACTIONS(15216), 1,
      anon_sym_end,
    ACTIONS(22281), 1,
      anon_sym_SQUOTE,
    ACTIONS(22285), 1,
      sym__immediate_paren,
    ACTIONS(22287), 1,
      sym__immediate_bracket,
    ACTIONS(22289), 1,
      sym__immediate_brace,
    ACTIONS(23514), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271147] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18857), 1,
      anon_sym_LF,
    ACTIONS(18891), 1,
      aux_sym__terminator_token1,
    STATE(15120), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
  [271168] = 5,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22614), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22425), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
  [271187] = 5,
    ACTIONS(15972), 1,
      anon_sym_COLON,
    ACTIONS(15980), 1,
      anon_sym_DOLLAR,
    ACTIONS(21962), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5986), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [271206] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23516), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271225] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23518), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271244] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23522), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23520), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15036), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271263] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23524), 1,
      anon_sym_end,
    STATE(18345), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [271284] = 5,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23358), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22429), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
  [271303] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23528), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23526), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15045), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271322] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23530), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271341] = 7,
    ACTIONS(9446), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23532), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17632), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271364] = 7,
    ACTIONS(9602), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23534), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18393), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271387] = 5,
    ACTIONS(18414), 1,
      sym__word_identifier,
    ACTIONS(23536), 1,
      anon_sym_COLON,
    ACTIONS(23538), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7137), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [271406] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23540), 1,
      anon_sym_end,
    STATE(19709), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15171), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [271427] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18952), 1,
      anon_sym_RPAREN,
    ACTIONS(18954), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15077), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17766), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271450] = 5,
    ACTIONS(23542), 1,
      anon_sym_DOLLAR,
    ACTIONS(23548), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23545), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271469] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23552), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23550), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15039), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271488] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23556), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23554), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15040), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271507] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23558), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271526] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23560), 1,
      anon_sym_end,
    STATE(19809), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [271547] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23562), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271566] = 7,
    ACTIONS(9064), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23564), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17794), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271589] = 7,
    ACTIONS(9266), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23566), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18978), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271612] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23568), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271631] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23570), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271650] = 5,
    ACTIONS(18480), 1,
      sym__word_identifier,
    ACTIONS(23572), 1,
      anon_sym_COLON,
    ACTIONS(23574), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11637), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [271669] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23578), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23576), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15044), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271688] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23582), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23580), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15046), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271707] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23584), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271726] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23586), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271745] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23588), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271764] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23590), 1,
      anon_sym_end,
    STATE(19393), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [271785] = 7,
    ACTIONS(9484), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23592), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17712), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271808] = 7,
    ACTIONS(9640), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23594), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18610), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271831] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19022), 1,
      anon_sym_RPAREN,
    ACTIONS(19024), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14549), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17630), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271854] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23596), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271873] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23598), 1,
      anon_sym_end,
    STATE(18638), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15064), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [271894] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23600), 1,
      anon_sym_end,
    STATE(18651), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [271915] = 5,
    ACTIONS(15824), 1,
      anon_sym_COLON,
    ACTIONS(15832), 1,
      anon_sym_DOLLAR,
    ACTIONS(22036), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6548), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [271934] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18895), 1,
      anon_sym_RPAREN,
    ACTIONS(18897), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15113), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17940), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271957] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23602), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [271976] = 7,
    ACTIONS(8852), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23604), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17732), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [271999] = 7,
    ACTIONS(9066), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23606), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18684), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272022] = 5,
    ACTIONS(15952), 1,
      anon_sym_COLON,
    ACTIONS(15960), 1,
      anon_sym_DOLLAR,
    ACTIONS(21966), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6563), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [272041] = 5,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23358), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22431), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
  [272060] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18970), 1,
      anon_sym_RPAREN,
    ACTIONS(18972), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14793), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17743), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272083] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23608), 1,
      anon_sym_end,
    STATE(19447), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15128), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [272104] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23610), 1,
      anon_sym_end,
    STATE(18717), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15074), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [272125] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23612), 1,
      anon_sym_end,
    STATE(18719), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [272146] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23614), 1,
      anon_sym_end,
    STATE(19456), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [272167] = 7,
    ACTIONS(9854), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23616), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17512), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272190] = 7,
    ACTIONS(9970), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23618), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19355), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272213] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18758), 1,
      anon_sym_RPAREN,
    ACTIONS(18760), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14823), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17845), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272236] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23622), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23620), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15072), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272255] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23626), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23624), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15073), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272274] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23628), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272293] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23630), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272312] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23632), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272331] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23634), 1,
      anon_sym_end,
    STATE(18776), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [272352] = 5,
    ACTIONS(21764), 1,
      sym__word_identifier,
    ACTIONS(23636), 1,
      anon_sym_COLON,
    ACTIONS(23638), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8112), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [272371] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14993), 6,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [272384] = 7,
    ACTIONS(9558), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23640), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17793), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272407] = 7,
    ACTIONS(9678), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23642), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18886), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272430] = 5,
    ACTIONS(21838), 1,
      sym__word_identifier,
    ACTIONS(23644), 1,
      anon_sym_COLON,
    ACTIONS(23646), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7398), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [272449] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23650), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23648), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15086), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272468] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23654), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23652), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15087), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272487] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19094), 1,
      anon_sym_RPAREN,
    ACTIONS(19096), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14558), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17897), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272510] = 7,
    ACTIONS(8816), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23656), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18052), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272533] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18710), 1,
      anon_sym_RPAREN,
    ACTIONS(18712), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15138), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18053), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272556] = 7,
    ACTIONS(8818), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23658), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19584), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272579] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23660), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272598] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23662), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272617] = 5,
    ACTIONS(23548), 1,
      sym__string_end,
    ACTIONS(23664), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23667), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272636] = 5,
    ACTIONS(16032), 1,
      anon_sym_COLON,
    ACTIONS(16040), 1,
      anon_sym_DOLLAR,
    ACTIONS(21980), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6743), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [272655] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20408), 1,
      anon_sym_COMMA,
    STATE(15109), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13148), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(13150), 2,
      anon_sym_EQ,
      aux_sym__terminator_token1,
  [272676] = 7,
    ACTIONS(9744), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23670), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17771), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272699] = 7,
    ACTIONS(9822), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23672), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18939), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272722] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19007), 1,
      anon_sym_RPAREN,
    ACTIONS(19009), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15000), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17582), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272745] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23676), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23674), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15101), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272764] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23680), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23678), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15104), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272783] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23682), 1,
      anon_sym_end,
    STATE(19202), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15111), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [272804] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23684), 1,
      anon_sym_end,
    STATE(19209), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [272825] = 5,
    ACTIONS(18378), 1,
      sym__word_identifier,
    ACTIONS(23686), 1,
      anon_sym_COLON,
    ACTIONS(23688), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11586), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [272844] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23692), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23690), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15106), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272863] = 7,
    ACTIONS(8936), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23694), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17936), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272886] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23696), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272905] = 7,
    ACTIONS(9106), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23698), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19270), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [272928] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23702), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23700), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15107), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272947] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23704), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [272966] = 5,
    ACTIONS(18398), 1,
      sym__word_identifier,
    ACTIONS(23706), 1,
      anon_sym_COLON,
    ACTIONS(23708), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7644), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [272985] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23710), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273004] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23712), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273023] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18814), 1,
      anon_sym_RPAREN,
    ACTIONS(18816), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14570), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17917), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273046] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20473), 1,
      anon_sym_COMMA,
    STATE(15109), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(13070), 2,
      anon_sym_EQ,
      aux_sym__terminator_token1,
    ACTIONS(13075), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [273067] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23714), 1,
      anon_sym_end,
    STATE(19323), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15115), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [273088] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23716), 1,
      anon_sym_end,
    STATE(19329), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [273109] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23718), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273128] = 7,
    ACTIONS(9596), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23720), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18010), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273151] = 7,
    ACTIONS(9714), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23722), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19437), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273174] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23724), 1,
      anon_sym_end,
    STATE(19419), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [273195] = 5,
    ACTIONS(21772), 1,
      sym__word_identifier,
    ACTIONS(23726), 1,
      anon_sym_COLON,
    ACTIONS(23728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6854), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [273214] = 5,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22614), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22429), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
  [273233] = 7,
    ACTIONS(9888), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23730), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17753), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273256] = 7,
    ACTIONS(10008), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23732), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18764), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273279] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(23734), 1,
      anon_sym_LF,
    ACTIONS(23736), 1,
      aux_sym__terminator_token1,
    STATE(14575), 1,
      aux_sym__block_repeat1,
    ACTIONS(6788), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
  [273300] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19112), 1,
      anon_sym_RPAREN,
    ACTIONS(19114), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15176), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18121), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273323] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23738), 1,
      anon_sym_COLON,
    ACTIONS(23740), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [273342] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23744), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23742), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14686), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273361] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19418), 1,
      anon_sym_RPAREN,
    ACTIONS(19420), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14571), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17353), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273384] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23748), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23746), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15129), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273403] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23752), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23750), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15130), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273422] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23754), 1,
      anon_sym_end,
    STATE(19704), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15161), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [273443] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23756), 1,
      anon_sym_end,
    STATE(19706), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [273464] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23758), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273483] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23760), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273502] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23764), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23762), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15133), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273521] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23768), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23766), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15134), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273540] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23770), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273559] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23772), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273578] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23774), 1,
      anon_sym_end,
    STATE(19735), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15167), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [273599] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23776), 1,
      anon_sym_end,
    STATE(19737), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [273620] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17754), 1,
      anon_sym_EQ,
    ACTIONS(13249), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token1,
  [273639] = 7,
    ACTIONS(9634), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23778), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18073), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273662] = 7,
    ACTIONS(9750), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23780), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19625), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273685] = 5,
    ACTIONS(21744), 1,
      sym__word_identifier,
    ACTIONS(23782), 1,
      anon_sym_COLON,
    ACTIONS(23784), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7482), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [273704] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(18822), 1,
      anon_sym_RPAREN,
    ACTIONS(18824), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(15037), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17637), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273727] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19205), 1,
      anon_sym_RPAREN,
    ACTIONS(19207), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14665), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17356), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273750] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23788), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23786), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15156), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273769] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23792), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23790), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15157), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [273788] = 5,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(23794), 1,
      anon_sym_COLON,
    ACTIONS(23796), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11559), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [273807] = 5,
    ACTIONS(18480), 1,
      sym__word_identifier,
    ACTIONS(23798), 1,
      anon_sym_COLON,
    ACTIONS(23800), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11637), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [273826] = 5,
    ACTIONS(18378), 1,
      sym__word_identifier,
    ACTIONS(23802), 1,
      anon_sym_COLON,
    ACTIONS(23804), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11586), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [273845] = 7,
    ACTIONS(8980), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23806), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18136), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273868] = 7,
    ACTIONS(9146), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23808), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19843), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273891] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23810), 1,
      anon_sym_COLON,
    ACTIONS(23812), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [273910] = 5,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(23814), 1,
      anon_sym_COLON,
    ACTIONS(23816), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11559), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [273929] = 5,
    ACTIONS(18588), 1,
      sym__word_identifier,
    ACTIONS(23818), 1,
      anon_sym_COLON,
    ACTIONS(23820), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6729), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [273948] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23822), 1,
      anon_sym_COLON,
    ACTIONS(23824), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [273967] = 7,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(19106), 1,
      anon_sym_RPAREN,
    ACTIONS(19108), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(14683), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17435), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [273990] = 5,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(23826), 1,
      anon_sym_COLON,
    ACTIONS(23828), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11559), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274009] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23830), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [274028] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23832), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [274047] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23834), 1,
      anon_sym_COLON,
    ACTIONS(23836), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274066] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23840), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23838), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15163), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [274085] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23844), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23842), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15164), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [274104] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23846), 1,
      anon_sym_end,
    STATE(19857), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [274125] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23848), 1,
      anon_sym_COLON,
    ACTIONS(23850), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274144] = 5,
    ACTIONS(22440), 1,
      anon_sym_DOLLAR,
    ACTIONS(23852), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22462), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15088), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [274163] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23854), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22466), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [274182] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23856), 1,
      anon_sym_COLON,
    ACTIONS(23858), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274201] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23860), 1,
      anon_sym_end,
    STATE(19145), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14760), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [274222] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23862), 1,
      anon_sym_end,
    STATE(18592), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [274243] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23864), 1,
      anon_sym_COLON,
    ACTIONS(23866), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274262] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23868), 1,
      anon_sym_COLON,
    ACTIONS(23870), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274281] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23872), 1,
      anon_sym_COLON,
    ACTIONS(23874), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274300] = 6,
    ACTIONS(1193), 1,
      anon_sym_else,
    ACTIONS(22476), 1,
      anon_sym_elseif,
    ACTIONS(23876), 1,
      anon_sym_end,
    STATE(19377), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [274321] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23878), 1,
      anon_sym_COLON,
    ACTIONS(23880), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274340] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23882), 1,
      anon_sym_COLON,
    ACTIONS(23884), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274359] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23886), 1,
      anon_sym_COLON,
    ACTIONS(23888), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274378] = 5,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(23890), 1,
      anon_sym_COLON,
    ACTIONS(23892), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274397] = 7,
    ACTIONS(9670), 1,
      anon_sym_RPAREN,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(23894), 1,
      anon_sym_SEMI,
    STATE(14543), 1,
      sym_for_clause,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18137), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [274420] = 7,
    ACTIONS(9786), 1,
      anon_sym_RPAREN,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23896), 1,
      anon_sym_COMMA,
    STATE(14542), 1,
      sym_for_clause,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19841), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [274443] = 5,
    ACTIONS(18538), 1,
      sym__word_identifier,
    ACTIONS(23898), 1,
      anon_sym_COLON,
    ACTIONS(23900), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7029), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [274462] = 5,
    ACTIONS(22452), 1,
      anon_sym_DOLLAR,
    ACTIONS(23904), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23902), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(14927), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [274481] = 6,
    ACTIONS(23906), 1,
      anon_sym_end,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    STATE(17266), 1,
      sym_else_clause,
    STATE(18570), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [274501] = 3,
    ACTIONS(6310), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5023), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274515] = 3,
    ACTIONS(15930), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5779), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274529] = 3,
    ACTIONS(4988), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10901), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274543] = 3,
    ACTIONS(8684), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6372), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274557] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11121), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274571] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23912), 1,
      anon_sym_end,
    STATE(17159), 1,
      sym_else_clause,
    STATE(19102), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [274591] = 3,
    ACTIONS(15976), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5760), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274605] = 3,
    ACTIONS(16056), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6592), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274619] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17940), 1,
      anon_sym_EQ,
    ACTIONS(13249), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [274637] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23914), 1,
      anon_sym_end,
    STATE(16888), 1,
      sym_else_clause,
    STATE(18980), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [274657] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23916), 1,
      anon_sym_end,
    STATE(17079), 1,
      sym_else_clause,
    STATE(18314), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [274677] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23918), 1,
      anon_sym_end,
    STATE(16713), 1,
      sym_else_clause,
    STATE(18677), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [274697] = 3,
    ACTIONS(20229), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8018), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274711] = 3,
    ACTIONS(8786), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5962), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274725] = 5,
    ACTIONS(23920), 1,
      anon_sym_end,
    ACTIONS(23922), 1,
      anon_sym_elseif,
    ACTIONS(23925), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15195), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [274743] = 3,
    ACTIONS(8560), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10721), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274757] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23927), 1,
      anon_sym_end,
    STATE(17257), 1,
      sym_else_clause,
    STATE(19607), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [274777] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23929), 1,
      anon_sym_end,
    STATE(16708), 1,
      sym_else_clause,
    STATE(18501), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [274797] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11060), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274811] = 3,
    ACTIONS(8762), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5594), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274825] = 3,
    ACTIONS(8720), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5488), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274839] = 3,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11156), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274853] = 3,
    ACTIONS(15930), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5233), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274867] = 3,
    ACTIONS(15572), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11233), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274881] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5919), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274895] = 3,
    ACTIONS(8762), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5671), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274909] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10131), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274923] = 3,
    ACTIONS(15586), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5003), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274937] = 3,
    ACTIONS(8762), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5212), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274951] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17900), 1,
      anon_sym_EQ,
    ACTIONS(13249), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
  [274969] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5929), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274983] = 3,
    ACTIONS(15606), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6248), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [274997] = 3,
    ACTIONS(15572), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11238), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275011] = 3,
    ACTIONS(15904), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4666), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275025] = 3,
    ACTIONS(20219), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8586), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275039] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23931), 1,
      anon_sym_end,
    STATE(16676), 1,
      sym_else_clause,
    STATE(18283), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275059] = 3,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14401), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275073] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23933), 1,
      anon_sym_end,
    STATE(16731), 1,
      sym_else_clause,
    STATE(18169), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275093] = 3,
    ACTIONS(15572), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11350), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275107] = 3,
    ACTIONS(15646), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6416), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275121] = 3,
    ACTIONS(15646), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6421), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275135] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23935), 1,
      anon_sym_end,
    STATE(17313), 1,
      sym_else_clause,
    STATE(19819), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275155] = 3,
    ACTIONS(8762), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5585), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275169] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(23937), 1,
      anon_sym_LF,
    ACTIONS(23939), 1,
      aux_sym__terminator_token1,
    STATE(15327), 1,
      aux_sym__block_repeat1,
    ACTIONS(6788), 2,
      anon_sym_end,
      anon_sym_finally,
  [275189] = 3,
    ACTIONS(15796), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5343), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275203] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(23941), 1,
      anon_sym_LF,
    ACTIONS(23943), 1,
      aux_sym__terminator_token1,
    STATE(15337), 1,
      aux_sym__block_repeat1,
    ACTIONS(6788), 2,
      anon_sym_catch,
      anon_sym_finally,
  [275223] = 3,
    ACTIONS(2904), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10500), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275237] = 3,
    ACTIONS(15930), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5309), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275251] = 3,
    ACTIONS(19887), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7893), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275265] = 3,
    ACTIONS(15796), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5470), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275279] = 3,
    ACTIONS(863), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5680), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275293] = 3,
    ACTIONS(6310), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5049), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275307] = 3,
    ACTIONS(8684), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6349), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275321] = 3,
    ACTIONS(19594), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7635), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275335] = 3,
    ACTIONS(2904), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10520), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275349] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23945), 1,
      anon_sym_end,
    STATE(17316), 1,
      sym_else_clause,
    STATE(18550), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275369] = 3,
    ACTIONS(15904), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4758), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275383] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23947), 1,
      anon_sym_end,
    STATE(16943), 1,
      sym_else_clause,
    STATE(18920), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275403] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10153), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275417] = 3,
    ACTIONS(15956), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6172), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275431] = 3,
    ACTIONS(863), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5780), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275445] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10160), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275459] = 3,
    ACTIONS(863), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5803), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275473] = 3,
    ACTIONS(15956), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6218), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275487] = 3,
    ACTIONS(15956), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6240), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275501] = 3,
    ACTIONS(6310), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5055), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275515] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23949), 1,
      anon_sym_end,
    STATE(17272), 1,
      sym_else_clause,
    STATE(19744), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275535] = 3,
    ACTIONS(15976), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5540), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275549] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19638), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [275565] = 3,
    ACTIONS(8538), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6273), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275579] = 3,
    ACTIONS(15828), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6010), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275593] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(18893), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [275609] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23951), 1,
      anon_sym_end,
    STATE(16924), 1,
      sym_else_clause,
    STATE(19652), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275629] = 3,
    ACTIONS(15586), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4968), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275643] = 3,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14387), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275657] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23953), 1,
      anon_sym_end,
    STATE(16710), 1,
      sym_else_clause,
    STATE(18663), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275677] = 3,
    ACTIONS(15646), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6453), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275691] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(23955), 1,
      anon_sym_LF,
    ACTIONS(23957), 1,
      aux_sym__terminator_token1,
    STATE(15419), 1,
      aux_sym__block_repeat1,
    ACTIONS(6788), 2,
      anon_sym_end,
      anon_sym_catch,
  [275711] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23959), 1,
      anon_sym_end,
    STATE(17216), 1,
      sym_else_clause,
    STATE(18436), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275731] = 3,
    ACTIONS(16016), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11168), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275745] = 3,
    ACTIONS(8646), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5010), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275759] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5653), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275773] = 3,
    ACTIONS(8684), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6066), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275787] = 3,
    ACTIONS(55), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10006), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275801] = 3,
    ACTIONS(15872), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10738), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275815] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17882), 1,
      anon_sym_EQ,
    ACTIONS(13249), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [275833] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5688), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275847] = 3,
    ACTIONS(15572), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11254), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275861] = 3,
    ACTIONS(15828), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6042), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275875] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23961), 1,
      anon_sym_end,
    STATE(16681), 1,
      sym_else_clause,
    STATE(19285), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275895] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23963), 1,
      anon_sym_end,
    STATE(17268), 1,
      sym_else_clause,
    STATE(19038), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275915] = 3,
    ACTIONS(15606), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6250), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275929] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19164), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [275945] = 3,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10061), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [275959] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(18392), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [275975] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23965), 1,
      anon_sym_end,
    STATE(16738), 1,
      sym_else_clause,
    STATE(18725), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [275995] = 3,
    ACTIONS(8684), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6175), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276009] = 3,
    ACTIONS(15956), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6255), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276023] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23967), 1,
      anon_sym_end,
    STATE(17155), 1,
      sym_else_clause,
    STATE(19472), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [276043] = 3,
    ACTIONS(15872), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10632), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276057] = 3,
    ACTIONS(20201), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(17853), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276071] = 3,
    ACTIONS(863), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5940), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276085] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23969), 1,
      anon_sym_end,
    STATE(16772), 1,
      sym_else_clause,
    STATE(19277), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [276105] = 3,
    ACTIONS(15796), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5328), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276119] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11218), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276133] = 3,
    ACTIONS(16056), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6597), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276147] = 3,
    ACTIONS(15996), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11877), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276161] = 3,
    ACTIONS(15606), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6259), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276175] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19363), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276191] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23971), 1,
      anon_sym_end,
    STATE(16828), 1,
      sym_else_clause,
    STATE(18691), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [276211] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(18194), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276227] = 3,
    ACTIONS(15996), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12186), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276241] = 3,
    ACTIONS(15996), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11861), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276255] = 3,
    ACTIONS(19516), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7084), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276269] = 3,
    ACTIONS(15904), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4692), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276283] = 3,
    ACTIONS(16016), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11139), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276297] = 3,
    ACTIONS(16016), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11145), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276311] = 5,
    ACTIONS(11992), 1,
      anon_sym_end,
    ACTIONS(23973), 1,
      sym__word_identifier,
    STATE(14484), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11994), 2,
      sym__immediate_brace,
      anon_sym_LT_COLON,
  [276329] = 3,
    ACTIONS(19698), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6746), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276343] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19466), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276359] = 3,
    ACTIONS(16036), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6618), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276373] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19713), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276389] = 3,
    ACTIONS(19684), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6911), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276403] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17982), 1,
      anon_sym_EQ,
    ACTIONS(18851), 1,
      anon_sym_end,
    ACTIONS(20434), 1,
      anon_sym_LF,
    ACTIONS(20466), 1,
      aux_sym__terminator_token1,
    STATE(16078), 1,
      aux_sym__block_repeat1,
  [276425] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23975), 1,
      anon_sym_end,
    STATE(17117), 1,
      sym_else_clause,
    STATE(19065), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [276445] = 3,
    ACTIONS(20007), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7087), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276459] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11362), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276473] = 3,
    ACTIONS(16082), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5242), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276487] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11369), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276501] = 3,
    ACTIONS(55), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10010), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276515] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19247), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276531] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23977), 1,
      anon_sym_end,
    STATE(17003), 1,
      sym_else_clause,
    STATE(19245), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [276551] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19483), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276567] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23979), 1,
      anon_sym_end,
    STATE(16917), 1,
      sym_else_clause,
    STATE(19017), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [276587] = 3,
    ACTIONS(19530), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6814), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276601] = 3,
    ACTIONS(8538), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6389), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276615] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19526), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276631] = 3,
    ACTIONS(15996), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11907), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276645] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5205), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276659] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(18296), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276675] = 3,
    ACTIONS(15704), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9421), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276689] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(18365), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276705] = 3,
    ACTIONS(16082), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5263), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276719] = 3,
    ACTIONS(16082), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5300), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276733] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17882), 1,
      anon_sym_EQ,
    ACTIONS(19548), 1,
      anon_sym_LF,
    ACTIONS(19546), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [276751] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(18705), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276767] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(23981), 1,
      anon_sym_LF,
    ACTIONS(23984), 1,
      aux_sym__terminator_token1,
    STATE(15327), 1,
      aux_sym__block_repeat1,
    ACTIONS(19546), 2,
      anon_sym_end,
      anon_sym_finally,
  [276787] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(18782), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276803] = 3,
    ACTIONS(15586), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4970), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276817] = 3,
    ACTIONS(8538), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6393), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276831] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19298), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276847] = 4,
    ACTIONS(23987), 1,
      sym__immediate_string_start,
    ACTIONS(23989), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11894), 3,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_LT_COLON,
  [276863] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19429), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276879] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23991), 1,
      anon_sym_end,
    STATE(16728), 1,
      sym_else_clause,
    STATE(19283), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [276899] = 3,
    ACTIONS(55), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9876), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276913] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17900), 1,
      anon_sym_EQ,
    ACTIONS(19548), 1,
      anon_sym_LF,
    ACTIONS(19546), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token1,
  [276931] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(23993), 1,
      anon_sym_LF,
    ACTIONS(23996), 1,
      aux_sym__terminator_token1,
    STATE(15337), 1,
      aux_sym__block_repeat1,
    ACTIONS(19546), 2,
      anon_sym_catch,
      anon_sym_finally,
  [276951] = 3,
    ACTIONS(15586), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4979), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276965] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(18256), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [276981] = 3,
    ACTIONS(8720), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5526), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [276995] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(18644), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [277011] = 3,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10172), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277025] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19548), 1,
      anon_sym_LF,
    ACTIONS(19546), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [277041] = 3,
    ACTIONS(15686), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5830), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277055] = 3,
    ACTIONS(15828), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6009), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277069] = 3,
    ACTIONS(15722), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11370), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277083] = 3,
    ACTIONS(15704), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9476), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277097] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19539), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [277113] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23999), 1,
      anon_sym_end,
    STATE(17174), 1,
      sym_else_clause,
    STATE(18213), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [277133] = 3,
    ACTIONS(15736), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6198), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277147] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(18847), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [277163] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19411), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [277179] = 3,
    ACTIONS(15736), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6398), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277193] = 3,
    ACTIONS(15736), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6401), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277207] = 3,
    ACTIONS(15776), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6306), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277221] = 3,
    ACTIONS(15872), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10666), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277235] = 3,
    ACTIONS(55), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9958), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277249] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19824), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [277265] = 3,
    ACTIONS(8560), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10905), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277279] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19381), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [277295] = 3,
    ACTIONS(20077), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7959), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277309] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5234), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277323] = 3,
    ACTIONS(15776), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6309), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277337] = 3,
    ACTIONS(15776), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6312), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277351] = 5,
    ACTIONS(11958), 1,
      anon_sym_end,
    ACTIONS(23973), 1,
      sym__word_identifier,
    STATE(14485), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11956), 2,
      sym__immediate_brace,
      anon_sym_LT_COLON,
  [277369] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24001), 1,
      anon_sym_end,
    STATE(17158), 1,
      sym_else_clause,
    STATE(19534), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [277389] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24003), 1,
      anon_sym_end,
    STATE(17095), 1,
      sym_else_clause,
    STATE(19335), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [277409] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19416), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [277425] = 3,
    ACTIONS(15872), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10674), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277439] = 3,
    ACTIONS(16016), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10938), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277453] = 3,
    ACTIONS(16082), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5354), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277467] = 3,
    ACTIONS(19765), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7825), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277481] = 3,
    ACTIONS(15704), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9442), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277495] = 5,
    ACTIONS(12002), 1,
      anon_sym_end,
    ACTIONS(23973), 1,
      sym__word_identifier,
    STATE(14493), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12004), 2,
      sym__immediate_brace,
      anon_sym_LT_COLON,
  [277513] = 3,
    ACTIONS(8560), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10583), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277527] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24005), 1,
      anon_sym_end,
    STATE(16886), 1,
      sym_else_clause,
    STATE(19554), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [277547] = 3,
    ACTIONS(15904), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4700), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277561] = 3,
    ACTIONS(15704), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9433), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277575] = 3,
    ACTIONS(15976), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5755), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277589] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17940), 1,
      anon_sym_EQ,
    ACTIONS(19548), 1,
      anon_sym_LF,
    ACTIONS(19546), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token1,
  [277607] = 3,
    ACTIONS(8786), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5191), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277621] = 3,
    ACTIONS(15828), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6107), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277635] = 5,
    ACTIONS(12006), 1,
      anon_sym_end,
    ACTIONS(23973), 1,
      sym__word_identifier,
    STATE(14494), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12008), 2,
      sym__immediate_brace,
      anon_sym_LT_COLON,
  [277653] = 3,
    ACTIONS(15736), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6419), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277667] = 3,
    ACTIONS(16036), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6470), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277681] = 3,
    ACTIONS(20167), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7164), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277695] = 3,
    ACTIONS(15776), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6335), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277709] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24007), 1,
      anon_sym_end,
    STATE(17269), 1,
      sym_else_clause,
    STATE(19728), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [277729] = 3,
    ACTIONS(8742), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5143), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277743] = 3,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14362), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277757] = 3,
    ACTIONS(4988), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10627), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277771] = 4,
    ACTIONS(16294), 1,
      aux_sym_integer_literal_token4,
    STATE(19361), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16292), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [277787] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24009), 1,
      anon_sym_end,
    STATE(17199), 1,
      sym_else_clause,
    STATE(19564), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [277807] = 3,
    ACTIONS(15514), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9365), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277821] = 3,
    ACTIONS(8538), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5965), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277835] = 3,
    ACTIONS(8720), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5579), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277849] = 3,
    ACTIONS(8646), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5025), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277863] = 3,
    ACTIONS(16036), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6481), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277877] = 3,
    ACTIONS(15796), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5541), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277891] = 3,
    ACTIONS(4988), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10867), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277905] = 3,
    ACTIONS(19981), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10236), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277919] = 3,
    ACTIONS(4988), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10872), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277933] = 3,
    ACTIONS(8646), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5035), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277947] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18118), 1,
      anon_sym_EQ,
    ACTIONS(20623), 1,
      ts_builtin_sym_end,
    ACTIONS(20625), 1,
      anon_sym_LF,
    ACTIONS(20629), 1,
      aux_sym__terminator_token1,
    STATE(15805), 1,
      aux_sym__block_repeat1,
  [277969] = 3,
    ACTIONS(15554), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4989), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277983] = 3,
    ACTIONS(6310), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4575), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [277997] = 3,
    ACTIONS(19901), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7230), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278011] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24011), 1,
      anon_sym_end,
    STATE(17307), 1,
      sym_else_clause,
    STATE(19810), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [278031] = 3,
    ACTIONS(15554), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4993), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278045] = 3,
    ACTIONS(8742), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5147), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278059] = 3,
    ACTIONS(8742), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5153), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278073] = 3,
    ACTIONS(20017), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6712), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278087] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19628), 1,
      anon_sym_LF,
    ACTIONS(19660), 1,
      aux_sym__terminator_token1,
    STATE(15226), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 2,
      anon_sym_catch,
      anon_sym_finally,
  [278107] = 3,
    ACTIONS(15514), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9368), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278121] = 3,
    ACTIONS(19817), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11575), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278135] = 6,
    ACTIONS(15204), 1,
      sym__immediate_paren,
    ACTIONS(22281), 1,
      anon_sym_SQUOTE,
    ACTIONS(22283), 1,
      anon_sym_DOT,
    ACTIONS(22287), 1,
      sym__immediate_bracket,
    ACTIONS(22289), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [278155] = 3,
    ACTIONS(20179), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11715), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278169] = 3,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11165), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278183] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24013), 1,
      anon_sym_LF,
    ACTIONS(24016), 1,
      aux_sym__terminator_token1,
    STATE(15419), 1,
      aux_sym__block_repeat1,
    ACTIONS(19546), 2,
      anon_sym_end,
      anon_sym_catch,
  [278203] = 3,
    ACTIONS(8646), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5179), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278217] = 3,
    ACTIONS(16056), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6575), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278231] = 3,
    ACTIONS(15606), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6268), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278245] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24019), 1,
      anon_sym_end,
    STATE(16908), 1,
      sym_else_clause,
    STATE(18177), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [278265] = 3,
    ACTIONS(2904), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10321), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278279] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24021), 1,
      anon_sym_end,
    STATE(16684), 1,
      sym_else_clause,
    STATE(19566), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [278299] = 3,
    ACTIONS(15554), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5002), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278313] = 3,
    ACTIONS(16056), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6578), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278327] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10986), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278341] = 3,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14366), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278355] = 3,
    ACTIONS(15626), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5903), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278369] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20039), 1,
      anon_sym_LF,
    ACTIONS(20071), 1,
      aux_sym__terminator_token1,
    STATE(15224), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 2,
      anon_sym_end,
      anon_sym_finally,
  [278389] = 3,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10983), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278403] = 3,
    ACTIONS(13290), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11149), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278417] = 3,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10049), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278431] = 3,
    ACTIONS(15514), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9376), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278445] = 3,
    ACTIONS(15646), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6067), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278459] = 3,
    ACTIONS(2904), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10389), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278473] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24023), 1,
      anon_sym_end,
    STATE(16739), 1,
      sym_else_clause,
    STATE(18936), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [278493] = 3,
    ACTIONS(15756), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10977), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278507] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19927), 1,
      anon_sym_LF,
    ACTIONS(19959), 1,
      aux_sym__terminator_token1,
    STATE(15258), 1,
      aux_sym__block_repeat1,
    ACTIONS(18851), 2,
      anon_sym_end,
      anon_sym_catch,
  [278527] = 3,
    ACTIONS(15554), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5018), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278541] = 3,
    ACTIONS(15666), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5330), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278555] = 3,
    ACTIONS(19458), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11553), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278569] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24025), 1,
      anon_sym_end,
    STATE(16976), 1,
      sym_else_clause,
    STATE(18259), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [278589] = 3,
    ACTIONS(16036), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6531), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278603] = 3,
    ACTIONS(20087), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7083), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278617] = 3,
    ACTIONS(8786), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5920), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278631] = 3,
    ACTIONS(8786), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5927), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278645] = 3,
    ACTIONS(15514), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9359), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278659] = 3,
    ACTIONS(19785), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6916), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278673] = 3,
    ACTIONS(15686), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5697), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278687] = 3,
    ACTIONS(19580), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8323), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278701] = 3,
    ACTIONS(20157), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8012), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278715] = 3,
    ACTIONS(15686), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5704), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278729] = 3,
    ACTIONS(8560), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10727), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278743] = 3,
    ACTIONS(8742), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5164), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278757] = 3,
    ACTIONS(15976), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5800), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278771] = 3,
    ACTIONS(8720), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5459), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278785] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24027), 1,
      anon_sym_end,
    STATE(17250), 1,
      sym_else_clause,
    STATE(19469), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [278805] = 3,
    ACTIONS(15930), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5693), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278819] = 3,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10050), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278833] = 3,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10053), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278847] = 3,
    ACTIONS(15686), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5727), 4,
      sym__array,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [278861] = 6,
    ACTIONS(23908), 1,
      anon_sym_else,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24029), 1,
      anon_sym_end,
    STATE(17041), 1,
      sym_else_clause,
    STATE(19223), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [278881] = 5,
    ACTIONS(8834), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24031), 1,
      anon_sym_COMMA,
    STATE(16632), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [278898] = 4,
    ACTIONS(24035), 1,
      sym__string_end,
    STATE(16545), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24033), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [278913] = 4,
    ACTIONS(24039), 1,
      sym__command_end,
    STATE(15504), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24037), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [278928] = 4,
    ACTIONS(24043), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [278943] = 4,
    ACTIONS(24047), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [278958] = 4,
    ACTIONS(24051), 1,
      sym__string_end,
    STATE(15495), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24049), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [278973] = 4,
    ACTIONS(24055), 1,
      sym__command_end,
    STATE(15496), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24053), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [278988] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24057), 1,
      anon_sym_COMMA,
    ACTIONS(24059), 1,
      anon_sym_RPAREN,
    STATE(15507), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279005] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24061), 1,
      anon_sym_COMMA,
    ACTIONS(24063), 1,
      anon_sym_RPAREN,
    STATE(15499), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279022] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15349), 1,
      sym_catch_clause,
    STATE(16986), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279039] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24069), 1,
      anon_sym_RBRACK,
    ACTIONS(24071), 1,
      anon_sym_LF,
    ACTIONS(24073), 1,
      aux_sym__terminator_token1,
    STATE(15483), 1,
      aux_sym_matrix_expression_repeat1,
  [279058] = 5,
    ACTIONS(9450), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24075), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279075] = 5,
    ACTIONS(10080), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24077), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279092] = 4,
    ACTIONS(24081), 1,
      sym__string_end,
    STATE(15487), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24079), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279107] = 4,
    ACTIONS(24085), 1,
      sym__command_end,
    STATE(15488), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24083), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279122] = 5,
    ACTIONS(9340), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24087), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279139] = 5,
    ACTIONS(10034), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19803), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279156] = 5,
    ACTIONS(9406), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19540), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279173] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5852), 1,
      anon_sym_RBRACK,
    ACTIONS(24089), 1,
      anon_sym_LF,
    ACTIONS(24091), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [279192] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6250), 1,
      anon_sym_RBRACK,
    ACTIONS(24093), 1,
      anon_sym_LF,
    ACTIONS(24095), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [279211] = 5,
    ACTIONS(9310), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24097), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279228] = 5,
    ACTIONS(9292), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19500), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279245] = 4,
    ACTIONS(24099), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279260] = 4,
    ACTIONS(24101), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279275] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19546), 1,
      anon_sym_end,
    ACTIONS(24103), 1,
      anon_sym_LF,
    ACTIONS(24106), 1,
      aux_sym__terminator_token1,
    STATE(15489), 1,
      aux_sym__block_repeat1,
  [279294] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5594), 1,
      anon_sym_RBRACK,
    ACTIONS(24109), 1,
      anon_sym_LF,
    ACTIONS(24111), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [279313] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24113), 1,
      anon_sym_COMMA,
    ACTIONS(24115), 1,
      anon_sym_RPAREN,
    STATE(16311), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279330] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5324), 1,
      anon_sym_RBRACK,
    ACTIONS(24117), 1,
      anon_sym_LF,
    ACTIONS(24119), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [279349] = 5,
    ACTIONS(9318), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24121), 1,
      anon_sym_COMMA,
    STATE(15814), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279366] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11864), 4,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [279377] = 4,
    ACTIONS(24123), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279392] = 4,
    ACTIONS(24125), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279407] = 5,
    ACTIONS(9318), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24121), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279424] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24127), 1,
      anon_sym_RBRACK,
    ACTIONS(24129), 1,
      anon_sym_LF,
    ACTIONS(24131), 1,
      aux_sym__terminator_token1,
    STATE(15505), 1,
      aux_sym_matrix_expression_repeat1,
  [279443] = 5,
    ACTIONS(10090), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24133), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279460] = 4,
    ACTIONS(24137), 1,
      sym__string_end,
    STATE(15509), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24135), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279475] = 4,
    ACTIONS(24141), 1,
      sym__command_end,
    STATE(15510), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24139), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279490] = 5,
    ACTIONS(10096), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24143), 1,
      anon_sym_COMMA,
    STATE(15517), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279507] = 4,
    ACTIONS(24145), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279522] = 4,
    ACTIONS(24147), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279537] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5870), 1,
      anon_sym_RBRACK,
    ACTIONS(24149), 1,
      anon_sym_LF,
    ACTIONS(24151), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [279556] = 5,
    ACTIONS(10096), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24143), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279573] = 5,
    ACTIONS(9460), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24153), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279590] = 5,
    ACTIONS(9468), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24155), 1,
      anon_sym_COMMA,
    STATE(15527), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279607] = 4,
    ACTIONS(24157), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279622] = 4,
    ACTIONS(24159), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279637] = 5,
    ACTIONS(9468), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24155), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279654] = 4,
    ACTIONS(24161), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279669] = 4,
    ACTIONS(24163), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279684] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24165), 1,
      anon_sym_COMMA,
    ACTIONS(24167), 1,
      anon_sym_RPAREN,
    STATE(15620), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279701] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24169), 1,
      anon_sym_COMMA,
    ACTIONS(24171), 1,
      anon_sym_RPAREN,
    STATE(15485), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279718] = 5,
    ACTIONS(9820), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24173), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279735] = 5,
    ACTIONS(10104), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24175), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279752] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24177), 1,
      anon_sym_COMMA,
    ACTIONS(24179), 1,
      anon_sym_RPAREN,
    STATE(15905), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279769] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24181), 1,
      anon_sym_RBRACK,
    ACTIONS(24183), 1,
      anon_sym_LF,
    ACTIONS(24185), 1,
      aux_sym__terminator_token1,
    STATE(15525), 1,
      aux_sym_matrix_expression_repeat1,
  [279788] = 4,
    ACTIONS(24189), 1,
      sym__string_end,
    STATE(15656), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24187), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279803] = 4,
    ACTIONS(24193), 1,
      sym__string_end,
    STATE(15528), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24191), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279818] = 4,
    ACTIONS(24197), 1,
      sym__command_end,
    STATE(15529), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24195), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279833] = 5,
    ACTIONS(10108), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19827), 1,
      anon_sym_COMMA,
    STATE(15643), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279850] = 4,
    ACTIONS(24201), 1,
      sym__command_end,
    STATE(15659), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24199), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279865] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5888), 1,
      anon_sym_RBRACK,
    ACTIONS(24203), 1,
      anon_sym_LF,
    ACTIONS(24205), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [279884] = 5,
    ACTIONS(9778), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19718), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279901] = 5,
    ACTIONS(9476), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24207), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [279918] = 4,
    ACTIONS(24209), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279933] = 4,
    ACTIONS(24211), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [279948] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24213), 1,
      anon_sym_RBRACK,
    ACTIONS(24215), 1,
      anon_sym_LF,
    ACTIONS(24217), 1,
      aux_sym__terminator_token1,
    STATE(15607), 1,
      aux_sym_matrix_expression_repeat1,
  [279967] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24219), 1,
      anon_sym_RBRACK,
    ACTIONS(24221), 1,
      anon_sym_LF,
    ACTIONS(24223), 1,
      aux_sym__terminator_token1,
    STATE(15601), 1,
      aux_sym_matrix_expression_repeat1,
  [279986] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24225), 1,
      anon_sym_RBRACK,
    ACTIONS(24227), 1,
      anon_sym_LF,
    ACTIONS(24229), 1,
      aux_sym__terminator_token1,
    STATE(15551), 1,
      aux_sym_matrix_expression_repeat1,
  [280005] = 5,
    ACTIONS(9480), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19564), 1,
      anon_sym_COMMA,
    STATE(16041), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280022] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24231), 1,
      anon_sym_COMMA,
    ACTIONS(24233), 1,
      anon_sym_RPAREN,
    STATE(15681), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280039] = 4,
    ACTIONS(24235), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280054] = 4,
    ACTIONS(24239), 1,
      sym__command_end,
    STATE(16565), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24237), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280069] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24241), 1,
      anon_sym_RBRACK,
    ACTIONS(24243), 1,
      anon_sym_LF,
    ACTIONS(24245), 1,
      aux_sym__terminator_token1,
    STATE(15542), 1,
      aux_sym_matrix_expression_repeat1,
  [280088] = 4,
    ACTIONS(24249), 1,
      sym__string_end,
    STATE(15544), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24247), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280103] = 4,
    ACTIONS(24253), 1,
      sym__command_end,
    STATE(15545), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24251), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280118] = 4,
    ACTIONS(24257), 1,
      sym__string_end,
    STATE(15560), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24255), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280133] = 4,
    ACTIONS(24261), 1,
      sym__command_end,
    STATE(15561), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24259), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280148] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5900), 1,
      anon_sym_RBRACK,
    ACTIONS(24263), 1,
      anon_sym_LF,
    ACTIONS(24265), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [280167] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24267), 1,
      anon_sym_COMMA,
    ACTIONS(24269), 1,
      anon_sym_RPAREN,
    STATE(15566), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280184] = 4,
    ACTIONS(24271), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280199] = 4,
    ACTIONS(24273), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280214] = 4,
    ACTIONS(24277), 1,
      sym__string_end,
    STATE(15618), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24275), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280229] = 5,
    ACTIONS(10116), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24279), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280246] = 4,
    ACTIONS(24283), 1,
      sym__command_end,
    STATE(15623), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24281), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280261] = 5,
    ACTIONS(10072), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19811), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280278] = 5,
    ACTIONS(9234), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24285), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280295] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5612), 1,
      anon_sym_RBRACK,
    ACTIONS(24287), 1,
      anon_sym_LF,
    ACTIONS(24289), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [280314] = 5,
    ACTIONS(9240), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24291), 1,
      anon_sym_COMMA,
    STATE(15837), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280331] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24293), 1,
      anon_sym_RBRACK,
    ACTIONS(24295), 1,
      anon_sym_LF,
    ACTIONS(24297), 1,
      aux_sym__terminator_token1,
    STATE(15562), 1,
      aux_sym_matrix_expression_repeat1,
  [280350] = 4,
    ACTIONS(24301), 1,
      sym__string_end,
    STATE(15564), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24299), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280365] = 4,
    ACTIONS(24305), 1,
      sym__command_end,
    STATE(15565), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24303), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280380] = 5,
    ACTIONS(9240), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24291), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280397] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5272), 1,
      anon_sym_RBRACK,
    ACTIONS(24307), 1,
      anon_sym_LF,
    ACTIONS(24309), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [280416] = 5,
    ACTIONS(8870), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24311), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280433] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24313), 1,
      anon_sym_COMMA,
    ACTIONS(24315), 1,
      anon_sym_RPAREN,
    STATE(15634), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280450] = 4,
    ACTIONS(24317), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280465] = 4,
    ACTIONS(24319), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280480] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5918), 1,
      anon_sym_RBRACK,
    ACTIONS(24321), 1,
      anon_sym_LF,
    ACTIONS(24323), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [280499] = 5,
    ACTIONS(8878), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24325), 1,
      anon_sym_COMMA,
    STATE(15650), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280516] = 4,
    ACTIONS(24327), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280531] = 4,
    ACTIONS(24329), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280546] = 5,
    ACTIONS(10126), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24331), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280563] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24333), 1,
      anon_sym_RBRACK,
    ACTIONS(24335), 1,
      anon_sym_LF,
    ACTIONS(24337), 1,
      aux_sym__terminator_token1,
    STATE(15627), 1,
      aux_sym_matrix_expression_repeat1,
  [280582] = 5,
    ACTIONS(9184), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24339), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280599] = 5,
    ACTIONS(10134), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24341), 1,
      anon_sym_COMMA,
    STATE(15582), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280616] = 5,
    ACTIONS(10134), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24341), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280633] = 5,
    ACTIONS(8878), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24325), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280650] = 5,
    ACTIONS(9376), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24343), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280667] = 5,
    ACTIONS(9332), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19510), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280684] = 5,
    ACTIONS(24345), 1,
      anon_sym_end,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(24349), 1,
      sym__immediate_brace,
    STATE(19588), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280701] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24351), 1,
      anon_sym_RBRACK,
    ACTIONS(24353), 1,
      anon_sym_LF,
    ACTIONS(24355), 1,
      aux_sym__terminator_token1,
    STATE(15583), 1,
      aux_sym_matrix_expression_repeat1,
  [280720] = 5,
    ACTIONS(9216), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19452), 1,
      anon_sym_COMMA,
    STATE(16346), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280737] = 4,
    ACTIONS(24359), 1,
      sym__string_end,
    STATE(15588), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24357), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280752] = 4,
    ACTIONS(24363), 1,
      sym__command_end,
    STATE(15589), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24361), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280767] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24365), 1,
      anon_sym_COMMA,
    ACTIONS(24367), 1,
      anon_sym_RPAREN,
    STATE(15693), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280784] = 5,
    ACTIONS(9930), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24369), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280801] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11864), 4,
      sym__command_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [280812] = 5,
    ACTIONS(10144), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24371), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280829] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5930), 1,
      anon_sym_RBRACK,
    ACTIONS(24373), 1,
      anon_sym_LF,
    ACTIONS(24375), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [280848] = 4,
    ACTIONS(24379), 1,
      sym__string_end,
    STATE(15641), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24377), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280863] = 4,
    ACTIONS(24383), 1,
      sym__command_end,
    STATE(15642), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24381), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280878] = 5,
    ACTIONS(9884), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19749), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280895] = 5,
    ACTIONS(10148), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19835), 1,
      anon_sym_COMMA,
    STATE(15720), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280912] = 4,
    ACTIONS(24385), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280927] = 4,
    ACTIONS(24387), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [280942] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(24389), 1,
      anon_sym_end,
    ACTIONS(24391), 1,
      sym__immediate_brace,
    STATE(19180), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [280959] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24393), 1,
      anon_sym_RBRACK,
    ACTIONS(24395), 1,
      anon_sym_LF,
    ACTIONS(24397), 1,
      aux_sym__terminator_token1,
    STATE(16441), 1,
      aux_sym_matrix_expression_repeat1,
  [280978] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5290), 1,
      anon_sym_RBRACK,
    ACTIONS(24399), 1,
      anon_sym_LF,
    ACTIONS(24401), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [280997] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24403), 1,
      anon_sym_COMMA,
    ACTIONS(24405), 1,
      anon_sym_RPAREN,
    STATE(15614), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281014] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(24409), 1,
      anon_sym_RPAREN,
    ACTIONS(24411), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281031] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24413), 1,
      anon_sym_RBRACK,
    ACTIONS(24415), 1,
      anon_sym_LF,
    ACTIONS(24417), 1,
      aux_sym__terminator_token1,
    STATE(15748), 1,
      aux_sym_matrix_expression_repeat1,
  [281050] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(24419), 1,
      anon_sym_LF,
    ACTIONS(24421), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [281069] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24423), 1,
      anon_sym_RBRACK,
    ACTIONS(24425), 1,
      anon_sym_LF,
    ACTIONS(24427), 1,
      aux_sym__terminator_token1,
    STATE(15600), 1,
      aux_sym_matrix_expression_repeat1,
  [281088] = 4,
    ACTIONS(24431), 1,
      sym__string_end,
    STATE(15603), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24429), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281103] = 4,
    ACTIONS(24435), 1,
      sym__command_end,
    STATE(15604), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24433), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281118] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5942), 1,
      anon_sym_RBRACK,
    ACTIONS(24437), 1,
      anon_sym_LF,
    ACTIONS(24439), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [281137] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5528), 1,
      anon_sym_RBRACK,
    ACTIONS(24441), 1,
      anon_sym_LF,
    ACTIONS(24443), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [281156] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24445), 1,
      anon_sym_RBRACK,
    ACTIONS(24447), 1,
      anon_sym_LF,
    ACTIONS(24449), 1,
      aux_sym__terminator_token1,
    STATE(15630), 1,
      aux_sym_matrix_expression_repeat1,
  [281175] = 4,
    ACTIONS(24451), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281190] = 4,
    ACTIONS(24453), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281205] = 5,
    ACTIONS(8622), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24455), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281222] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24457), 1,
      anon_sym_COMMA,
    ACTIONS(24459), 1,
      anon_sym_RPAREN,
    STATE(15666), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281239] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5486), 1,
      anon_sym_RBRACK,
    ACTIONS(24461), 1,
      anon_sym_LF,
    ACTIONS(24463), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [281258] = 5,
    ACTIONS(8628), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24465), 1,
      anon_sym_COMMA,
    STATE(15719), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281275] = 4,
    ACTIONS(24469), 1,
      sym__string_end,
    STATE(15632), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24467), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281290] = 4,
    ACTIONS(24473), 1,
      sym__command_end,
    STATE(15633), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24471), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281305] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24475), 1,
      anon_sym_COMMA,
    ACTIONS(24477), 1,
      anon_sym_RPAREN,
    STATE(15636), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281322] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24479), 1,
      anon_sym_RBRACK,
    ACTIONS(24481), 1,
      anon_sym_LF,
    ACTIONS(24483), 1,
      aux_sym__terminator_token1,
    STATE(15622), 1,
      aux_sym_matrix_expression_repeat1,
  [281341] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24485), 1,
      anon_sym_RBRACK,
    ACTIONS(24487), 1,
      anon_sym_LF,
    ACTIONS(24489), 1,
      aux_sym__terminator_token1,
    STATE(15705), 1,
      aux_sym_matrix_expression_repeat1,
  [281360] = 5,
    ACTIONS(8940), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24491), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281377] = 4,
    ACTIONS(24495), 1,
      sym__string_end,
    STATE(15624), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24493), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281392] = 4,
    ACTIONS(24499), 1,
      sym__command_end,
    STATE(15625), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24497), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281407] = 5,
    ACTIONS(8628), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24465), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281424] = 4,
    ACTIONS(24501), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281439] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(24503), 1,
      anon_sym_RPAREN,
    ACTIONS(24505), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281456] = 5,
    ACTIONS(10156), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24507), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281473] = 5,
    ACTIONS(8890), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19869), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281490] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5960), 1,
      anon_sym_RBRACK,
    ACTIONS(24509), 1,
      anon_sym_LF,
    ACTIONS(24511), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [281509] = 4,
    ACTIONS(24513), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281524] = 4,
    ACTIONS(24515), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281539] = 4,
    ACTIONS(24517), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281554] = 5,
    ACTIONS(10108), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19827), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281571] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5284), 1,
      anon_sym_RBRACK,
    ACTIONS(24519), 1,
      anon_sym_LF,
    ACTIONS(24521), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [281590] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(24523), 1,
      anon_sym_RPAREN,
    ACTIONS(24525), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281607] = 4,
    ACTIONS(24529), 1,
      sym__string_end,
    STATE(15768), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24527), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281622] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5630), 1,
      anon_sym_RBRACK,
    ACTIONS(24531), 1,
      anon_sym_LF,
    ACTIONS(24533), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [281641] = 4,
    ACTIONS(24537), 1,
      sym__command_end,
    STATE(15793), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24535), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281656] = 4,
    ACTIONS(24539), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281671] = 4,
    ACTIONS(24541), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281686] = 5,
    ACTIONS(9940), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24543), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281703] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24545), 1,
      anon_sym_RBRACK,
    ACTIONS(24547), 1,
      anon_sym_LF,
    ACTIONS(24549), 1,
      aux_sym__terminator_token1,
    STATE(15640), 1,
      aux_sym_matrix_expression_repeat1,
  [281722] = 5,
    ACTIONS(10166), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24551), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281739] = 4,
    ACTIONS(24555), 1,
      sym__string_end,
    STATE(15644), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24553), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281754] = 4,
    ACTIONS(24559), 1,
      sym__command_end,
    STATE(15645), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24557), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281769] = 5,
    ACTIONS(10172), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24561), 1,
      anon_sym_COMMA,
    STATE(15652), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281786] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5978), 1,
      anon_sym_RBRACK,
    ACTIONS(24563), 1,
      anon_sym_LF,
    ACTIONS(24565), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [281805] = 4,
    ACTIONS(24567), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281820] = 4,
    ACTIONS(24569), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281835] = 5,
    ACTIONS(10172), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24561), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281852] = 4,
    ACTIONS(24571), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281867] = 4,
    ACTIONS(24573), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281882] = 4,
    ACTIONS(24577), 1,
      sym__string_end,
    STATE(15724), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24575), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281897] = 5,
    ACTIONS(9946), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24579), 1,
      anon_sym_COMMA,
    STATE(15706), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281914] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(24581), 1,
      anon_sym_RPAREN,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281931] = 4,
    ACTIONS(24585), 1,
      sym__command_end,
    STATE(15725), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24583), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [281946] = 5,
    ACTIONS(8886), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24587), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281963] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24589), 1,
      anon_sym_COMMA,
    ACTIONS(24591), 1,
      anon_sym_RPAREN,
    STATE(15765), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281980] = 5,
    ACTIONS(10180), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24593), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [281997] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24595), 1,
      anon_sym_RBRACK,
    ACTIONS(24597), 1,
      anon_sym_LF,
    ACTIONS(24599), 1,
      aux_sym__terminator_token1,
    STATE(15660), 1,
      aux_sym_matrix_expression_repeat1,
  [282016] = 4,
    ACTIONS(24603), 1,
      sym__string_end,
    STATE(15663), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24601), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282031] = 4,
    ACTIONS(24607), 1,
      sym__command_end,
    STATE(15664), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24605), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282046] = 4,
    ACTIONS(24609), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282061] = 5,
    ACTIONS(8890), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19869), 1,
      anon_sym_COMMA,
    STATE(15670), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282078] = 5,
    ACTIONS(10184), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19871), 1,
      anon_sym_COMMA,
    STATE(15789), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282095] = 4,
    ACTIONS(24611), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282110] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5996), 1,
      anon_sym_RBRACK,
    ACTIONS(24613), 1,
      anon_sym_LF,
    ACTIONS(24615), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [282129] = 5,
    ACTIONS(9946), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24579), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282146] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24617), 1,
      anon_sym_COMMA,
    ACTIONS(24619), 1,
      anon_sym_RPAREN,
    STATE(15797), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282163] = 4,
    ACTIONS(24621), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282178] = 4,
    ACTIONS(24623), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282193] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24625), 1,
      anon_sym_COMMA,
    ACTIONS(24627), 1,
      anon_sym_RPAREN,
    STATE(15732), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282210] = 5,
    ACTIONS(8952), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24629), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282227] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24631), 1,
      anon_sym_COMMA,
    ACTIONS(24633), 1,
      anon_sym_RPAREN,
    STATE(16551), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282244] = 5,
    ACTIONS(8958), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24635), 1,
      anon_sym_COMMA,
    STATE(15703), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282261] = 5,
    ACTIONS(9134), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20281), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282278] = 5,
    ACTIONS(8958), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24635), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282295] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18851), 1,
      anon_sym_end,
    ACTIONS(20434), 1,
      anon_sym_LF,
    ACTIONS(20466), 1,
      aux_sym__terminator_token1,
    STATE(16078), 1,
      aux_sym__block_repeat1,
  [282314] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(745), 2,
      sym_interpolation_expression,
      sym_identifier,
  [282329] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24641), 1,
      anon_sym_COMMA,
    ACTIONS(24643), 1,
      anon_sym_RPAREN,
    STATE(15916), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282346] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24645), 1,
      anon_sym_COMMA,
    ACTIONS(24647), 1,
      anon_sym_RPAREN,
    STATE(16371), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282363] = 4,
    ACTIONS(24649), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282378] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24651), 1,
      anon_sym_RBRACK,
    ACTIONS(24653), 1,
      anon_sym_LF,
    ACTIONS(24655), 1,
      aux_sym__terminator_token1,
    STATE(15700), 1,
      aux_sym_matrix_expression_repeat1,
  [282397] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24657), 1,
      anon_sym_RBRACK,
    ACTIONS(24659), 1,
      anon_sym_LF,
    ACTIONS(24661), 1,
      aux_sym__terminator_token1,
    STATE(15683), 1,
      aux_sym_matrix_expression_repeat1,
  [282416] = 5,
    ACTIONS(9488), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24663), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282433] = 4,
    ACTIONS(24667), 1,
      sym__string_end,
    STATE(15685), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24665), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282448] = 4,
    ACTIONS(24671), 1,
      sym__command_end,
    STATE(15686), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24669), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282463] = 5,
    ACTIONS(9386), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24673), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282480] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24675), 1,
      anon_sym_COMMA,
    ACTIONS(24677), 1,
      anon_sym_RPAREN,
    STATE(16163), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282497] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6014), 1,
      anon_sym_RBRACK,
    ACTIONS(24679), 1,
      anon_sym_LF,
    ACTIONS(24681), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [282516] = 4,
    ACTIONS(24683), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282531] = 4,
    ACTIONS(24685), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282546] = 4,
    ACTIONS(24687), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282561] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24689), 1,
      anon_sym_COMMA,
    ACTIONS(24691), 1,
      anon_sym_RPAREN,
    STATE(16134), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282578] = 5,
    ACTIONS(9442), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19552), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282595] = 4,
    ACTIONS(24695), 1,
      sym__string_end,
    STATE(15709), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24693), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282610] = 4,
    ACTIONS(24699), 1,
      sym__command_end,
    STATE(15710), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24697), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282625] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24701), 1,
      anon_sym_COMMA,
    ACTIONS(24703), 1,
      anon_sym_RPAREN,
    STATE(15714), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282642] = 5,
    ACTIONS(9394), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24705), 1,
      anon_sym_COMMA,
    STATE(15756), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282659] = 5,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24707), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282676] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24709), 1,
      anon_sym_RBRACK,
    ACTIONS(24711), 1,
      anon_sym_LF,
    ACTIONS(24713), 1,
      aux_sym__terminator_token1,
    STATE(15699), 1,
      aux_sym_matrix_expression_repeat1,
  [282695] = 4,
    ACTIONS(24717), 1,
      sym__string_end,
    STATE(15701), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24715), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282710] = 4,
    ACTIONS(24721), 1,
      sym__command_end,
    STATE(15702), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24719), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282725] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17722), 1,
      aux_sym__terminator_token1,
    ACTIONS(17724), 1,
      anon_sym_LF,
    ACTIONS(24723), 1,
      anon_sym_COMMA,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [282744] = 5,
    ACTIONS(10148), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19835), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282761] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6026), 1,
      anon_sym_RBRACK,
    ACTIONS(24726), 1,
      anon_sym_LF,
    ACTIONS(24728), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [282780] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5648), 1,
      anon_sym_RBRACK,
    ACTIONS(24730), 1,
      anon_sym_LF,
    ACTIONS(24732), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [282799] = 4,
    ACTIONS(24734), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282814] = 4,
    ACTIONS(24736), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282829] = 5,
    ACTIONS(8966), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24738), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282846] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24740), 1,
      anon_sym_COMMA,
    ACTIONS(24742), 1,
      anon_sym_RPAREN,
    STATE(16323), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282863] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5342), 1,
      anon_sym_RBRACK,
    ACTIONS(24744), 1,
      anon_sym_LF,
    ACTIONS(24746), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [282882] = 5,
    ACTIONS(9954), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24748), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282899] = 5,
    ACTIONS(8970), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20119), 1,
      anon_sym_COMMA,
    STATE(16159), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282916] = 5,
    ACTIONS(9394), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24705), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [282933] = 4,
    ACTIONS(24750), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282948] = 4,
    ACTIONS(24752), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282963] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24754), 1,
      anon_sym_RBRACK,
    ACTIONS(24756), 1,
      anon_sym_LF,
    ACTIONS(24758), 1,
      aux_sym__terminator_token1,
    STATE(15715), 1,
      aux_sym_matrix_expression_repeat1,
  [282982] = 4,
    ACTIONS(24762), 1,
      sym__string_end,
    STATE(15717), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24760), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [282997] = 4,
    ACTIONS(24766), 1,
      sym__command_end,
    STATE(15718), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24764), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283012] = 5,
    ACTIONS(10202), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24768), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283029] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6044), 1,
      anon_sym_RBRACK,
    ACTIONS(24770), 1,
      anon_sym_LF,
    ACTIONS(24772), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [283048] = 5,
    ACTIONS(10210), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24774), 1,
      anon_sym_COMMA,
    STATE(15730), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283065] = 4,
    ACTIONS(24776), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283080] = 4,
    ACTIONS(24778), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283095] = 5,
    ACTIONS(8638), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24780), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283112] = 5,
    ACTIONS(10210), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24774), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283129] = 5,
    ACTIONS(9858), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24782), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283146] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24784), 1,
      anon_sym_COMMA,
    ACTIONS(24786), 1,
      anon_sym_RPAREN,
    STATE(15835), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283163] = 5,
    ACTIONS(9350), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24788), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283180] = 4,
    ACTIONS(24790), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283195] = 4,
    ACTIONS(24792), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283210] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24794), 1,
      anon_sym_RBRACK,
    ACTIONS(24796), 1,
      anon_sym_LF,
    ACTIONS(24798), 1,
      aux_sym__terminator_token1,
    STATE(15733), 1,
      aux_sym_matrix_expression_repeat1,
  [283229] = 5,
    ACTIONS(9958), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19777), 1,
      anon_sym_COMMA,
    STATE(16229), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283246] = 4,
    ACTIONS(24802), 1,
      sym__string_end,
    STATE(15737), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24800), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283261] = 4,
    ACTIONS(24806), 1,
      sym__command_end,
    STATE(15738), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24804), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283276] = 5,
    ACTIONS(10218), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24808), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283293] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24810), 1,
      anon_sym_COMMA,
    ACTIONS(24812), 1,
      anon_sym_RPAREN,
    STATE(15476), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283310] = 5,
    ACTIONS(9498), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24814), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283327] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6062), 1,
      anon_sym_RBRACK,
    ACTIONS(24816), 1,
      anon_sym_LF,
    ACTIONS(24818), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [283346] = 5,
    ACTIONS(9504), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24820), 1,
      anon_sym_COMMA,
    STATE(15767), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283363] = 4,
    ACTIONS(24824), 1,
      sym__string_end,
    STATE(15468), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24822), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283378] = 5,
    ACTIONS(9504), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24820), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283395] = 4,
    ACTIONS(24826), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283410] = 4,
    ACTIONS(24828), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283425] = 5,
    ACTIONS(8642), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20121), 1,
      anon_sym_COMMA,
    STATE(15571), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283442] = 5,
    ACTIONS(10222), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19881), 1,
      anon_sym_COMMA,
    STATE(15967), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283459] = 5,
    ACTIONS(9356), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24830), 1,
      anon_sym_COMMA,
    STATE(16098), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283476] = 5,
    ACTIONS(9356), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24830), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283493] = 5,
    ACTIONS(9812), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19728), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283510] = 5,
    ACTIONS(9254), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19489), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283527] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24832), 1,
      anon_sym_RBRACK,
    ACTIONS(24834), 1,
      anon_sym_LF,
    ACTIONS(24836), 1,
      aux_sym__terminator_token1,
    STATE(15750), 1,
      aux_sym_matrix_expression_repeat1,
  [283546] = 4,
    ACTIONS(24840), 1,
      sym__string_end,
    STATE(15752), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24838), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283561] = 4,
    ACTIONS(24844), 1,
      sym__command_end,
    STATE(15753), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24842), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283576] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5504), 1,
      anon_sym_RBRACK,
    ACTIONS(24846), 1,
      anon_sym_LF,
    ACTIONS(24848), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [283595] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24850), 1,
      anon_sym_COMMA,
    ACTIONS(24852), 1,
      anon_sym_RPAREN,
    STATE(15572), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283612] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6074), 1,
      anon_sym_RBRACK,
    ACTIONS(24854), 1,
      anon_sym_LF,
    ACTIONS(24856), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [283631] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24858), 1,
      anon_sym_COMMA,
    ACTIONS(24860), 1,
      anon_sym_RPAREN,
    STATE(16102), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283648] = 4,
    ACTIONS(24862), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283663] = 4,
    ACTIONS(24864), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283678] = 4,
    ACTIONS(24868), 1,
      sym__command_end,
    STATE(15469), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24866), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283693] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24870), 1,
      anon_sym_RBRACK,
    ACTIONS(24872), 1,
      anon_sym_LF,
    ACTIONS(24874), 1,
      aux_sym__terminator_token1,
    STATE(15773), 1,
      aux_sym_matrix_expression_repeat1,
  [283712] = 5,
    ACTIONS(9402), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24876), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283729] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5254), 1,
      anon_sym_RBRACK,
    ACTIONS(24878), 1,
      anon_sym_LF,
    ACTIONS(24880), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [283748] = 4,
    ACTIONS(24884), 1,
      sym__string_end,
    STATE(15782), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24882), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283763] = 4,
    ACTIONS(24888), 1,
      sym__command_end,
    STATE(15783), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24886), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283778] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24890), 1,
      anon_sym_COMMA,
    ACTIONS(24892), 1,
      anon_sym_RPAREN,
    STATE(15784), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283795] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24894), 1,
      anon_sym_RBRACK,
    ACTIONS(24896), 1,
      anon_sym_LF,
    ACTIONS(24898), 1,
      aux_sym__terminator_token1,
    STATE(15766), 1,
      aux_sym_matrix_expression_repeat1,
  [283814] = 5,
    ACTIONS(9170), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24900), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283831] = 4,
    ACTIONS(24904), 1,
      sym__string_end,
    STATE(15769), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24902), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283846] = 4,
    ACTIONS(24908), 1,
      sym__command_end,
    STATE(15770), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24906), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283861] = 5,
    ACTIONS(10230), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24910), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283878] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6092), 1,
      anon_sym_RBRACK,
    ACTIONS(24912), 1,
      anon_sym_LF,
    ACTIONS(24914), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [283897] = 5,
    ACTIONS(9512), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24916), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283914] = 4,
    ACTIONS(24918), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283929] = 4,
    ACTIONS(24920), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283944] = 4,
    ACTIONS(24922), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [283959] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(24924), 1,
      anon_sym_LF,
    ACTIONS(24926), 1,
      aux_sym__terminator_token1,
    STATE(15596), 1,
      aux_sym_let_statement_repeat1,
  [283978] = 5,
    ACTIONS(10184), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19871), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [283995] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5666), 1,
      anon_sym_RBRACK,
    ACTIONS(24928), 1,
      anon_sym_LF,
    ACTIONS(24930), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [284014] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24932), 1,
      anon_sym_RBRACK,
    ACTIONS(24934), 1,
      anon_sym_LF,
    ACTIONS(24936), 1,
      aux_sym__terminator_token1,
    STATE(15830), 1,
      aux_sym_matrix_expression_repeat1,
  [284033] = 5,
    ACTIONS(9516), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19574), 1,
      anon_sym_COMMA,
    STATE(16117), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284050] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(24938), 1,
      anon_sym_end,
    ACTIONS(24940), 1,
      sym__immediate_brace,
    STATE(18356), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284067] = 5,
    ACTIONS(9406), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19540), 1,
      anon_sym_COMMA,
    STATE(15511), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284084] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24942), 1,
      anon_sym_RBRACK,
    ACTIONS(24944), 1,
      anon_sym_LF,
    ACTIONS(24946), 1,
      aux_sym__terminator_token1,
    STATE(15844), 1,
      aux_sym_matrix_expression_repeat1,
  [284103] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24948), 1,
      anon_sym_RBRACK,
    ACTIONS(24950), 1,
      anon_sym_LF,
    ACTIONS(24952), 1,
      aux_sym__terminator_token1,
    STATE(15785), 1,
      aux_sym_matrix_expression_repeat1,
  [284122] = 4,
    ACTIONS(24956), 1,
      sym__string_end,
    STATE(15787), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24954), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284137] = 4,
    ACTIONS(24960), 1,
      sym__command_end,
    STATE(15788), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24958), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284152] = 4,
    ACTIONS(24962), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284167] = 4,
    ACTIONS(24964), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284182] = 5,
    ACTIONS(10240), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24966), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284199] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6104), 1,
      anon_sym_RBRACK,
    ACTIONS(24968), 1,
      anon_sym_LF,
    ACTIONS(24970), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [284218] = 5,
    ACTIONS(10246), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24972), 1,
      anon_sym_COMMA,
    STATE(15794), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284235] = 4,
    ACTIONS(24974), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284250] = 4,
    ACTIONS(24976), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284265] = 5,
    ACTIONS(10246), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24972), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284282] = 4,
    ACTIONS(24980), 1,
      sym__string_end,
    STATE(15857), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24978), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284297] = 4,
    ACTIONS(24984), 1,
      sym__command_end,
    STATE(15862), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24982), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284312] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24986), 1,
      anon_sym_COMMA,
    ACTIONS(24988), 1,
      anon_sym_RPAREN,
    STATE(16092), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284329] = 4,
    ACTIONS(24990), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284344] = 5,
    ACTIONS(10254), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24992), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284361] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(24994), 1,
      anon_sym_end,
    ACTIONS(24996), 1,
      sym__immediate_brace,
    STATE(18660), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284378] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(24998), 1,
      anon_sym_RBRACK,
    ACTIONS(25000), 1,
      anon_sym_LF,
    ACTIONS(25002), 1,
      aux_sym__terminator_token1,
    STATE(15803), 1,
      aux_sym_matrix_expression_repeat1,
  [284397] = 5,
    ACTIONS(9868), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25004), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284414] = 4,
    ACTIONS(25008), 1,
      sym__string_end,
    STATE(15806), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25006), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284429] = 4,
    ACTIONS(25012), 1,
      sym__command_end,
    STATE(15807), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25010), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284444] = 5,
    ACTIONS(9872), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25014), 1,
      anon_sym_COMMA,
    STATE(16074), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284461] = 5,
    ACTIONS(10258), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19895), 1,
      anon_sym_COMMA,
    STATE(16110), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284478] = 4,
    ACTIONS(25018), 1,
      sym__string_end,
    STATE(16031), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25016), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284493] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6116), 1,
      anon_sym_RBRACK,
    ACTIONS(25020), 1,
      anon_sym_LF,
    ACTIONS(25022), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [284512] = 4,
    ACTIONS(25026), 1,
      sym__command_end,
    STATE(16057), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25024), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284527] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(8534), 1,
      ts_builtin_sym_end,
    ACTIONS(25028), 1,
      anon_sym_LF,
    ACTIONS(25030), 1,
      aux_sym__terminator_token1,
    STATE(16293), 1,
      aux_sym__block_repeat1,
  [284546] = 4,
    ACTIONS(25032), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284561] = 4,
    ACTIONS(25034), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284576] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25036), 1,
      anon_sym_COMMA,
    ACTIONS(25038), 1,
      anon_sym_RPAREN,
    STATE(16064), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284593] = 4,
    ACTIONS(22010), 1,
      sym__word_identifier,
    STATE(18144), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11994), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [284608] = 5,
    ACTIONS(9968), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25040), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284625] = 5,
    ACTIONS(9872), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25014), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284642] = 5,
    ACTIONS(9922), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19759), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284659] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25042), 1,
      anon_sym_RBRACK,
    ACTIONS(25044), 1,
      anon_sym_LF,
    ACTIONS(25046), 1,
      aux_sym__terminator_token1,
    STATE(15819), 1,
      aux_sym_matrix_expression_repeat1,
  [284678] = 5,
    ACTIONS(9328), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25048), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284695] = 4,
    ACTIONS(25052), 1,
      sym__string_end,
    STATE(15821), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25050), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284710] = 4,
    ACTIONS(25056), 1,
      sym__command_end,
    STATE(15822), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25054), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284725] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25058), 1,
      anon_sym_RBRACK,
    ACTIONS(25060), 1,
      anon_sym_LF,
    ACTIONS(25062), 1,
      aux_sym__terminator_token1,
    STATE(15843), 1,
      aux_sym_matrix_expression_repeat1,
  [284744] = 4,
    ACTIONS(22010), 1,
      sym__word_identifier,
    STATE(18094), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11956), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [284759] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6134), 1,
      anon_sym_RBRACK,
    ACTIONS(25064), 1,
      anon_sym_LF,
    ACTIONS(25066), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [284778] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25068), 1,
      anon_sym_COMMA,
    ACTIONS(25070), 1,
      anon_sym_RPAREN,
    STATE(16000), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284795] = 4,
    ACTIONS(25072), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284810] = 4,
    ACTIONS(25074), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284825] = 4,
    ACTIONS(25078), 1,
      sym__string_end,
    STATE(15906), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25076), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284840] = 4,
    ACTIONS(25082), 1,
      sym__command_end,
    STATE(15921), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25080), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [284855] = 5,
    ACTIONS(8978), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25084), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284872] = 4,
    ACTIONS(22010), 1,
      sym__word_identifier,
    STATE(18079), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12004), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [284887] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25086), 1,
      anon_sym_COMMA,
    ACTIONS(25088), 1,
      anon_sym_RPAREN,
    STATE(15944), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284904] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(25090), 1,
      anon_sym_RPAREN,
    ACTIONS(25092), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284921] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25094), 1,
      anon_sym_RBRACK,
    ACTIONS(25096), 1,
      anon_sym_LF,
    ACTIONS(25098), 1,
      aux_sym__terminator_token1,
    STATE(16101), 1,
      aux_sym_matrix_expression_repeat1,
  [284940] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5546), 1,
      anon_sym_RBRACK,
    ACTIONS(25100), 1,
      anon_sym_LF,
    ACTIONS(25102), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [284959] = 5,
    ACTIONS(8932), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19997), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [284976] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25104), 1,
      anon_sym_RBRACK,
    ACTIONS(25106), 1,
      anon_sym_LF,
    ACTIONS(25108), 1,
      aux_sym__terminator_token1,
    STATE(15838), 1,
      aux_sym_matrix_expression_repeat1,
  [284995] = 4,
    ACTIONS(25112), 1,
      sym__string_end,
    STATE(15841), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25110), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285010] = 4,
    ACTIONS(25116), 1,
      sym__command_end,
    STATE(15842), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25114), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285025] = 5,
    ACTIONS(10266), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25118), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [285042] = 4,
    ACTIONS(22010), 1,
      sym__word_identifier,
    STATE(17473), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12008), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [285057] = 5,
    ACTIONS(9250), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25120), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [285074] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6146), 1,
      anon_sym_RBRACK,
    ACTIONS(25122), 1,
      anon_sym_LF,
    ACTIONS(25124), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [285093] = 5,
    ACTIONS(10222), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19881), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [285110] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25126), 1,
      anon_sym_RBRACK,
    ACTIONS(25128), 1,
      anon_sym_LF,
    ACTIONS(25130), 1,
      aux_sym__terminator_token1,
    STATE(15939), 1,
      aux_sym_matrix_expression_repeat1,
  [285129] = 4,
    ACTIONS(25132), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285144] = 4,
    ACTIONS(25134), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285159] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5684), 1,
      anon_sym_RBRACK,
    ACTIONS(25136), 1,
      anon_sym_LF,
    ACTIONS(25138), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [285178] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5744), 1,
      anon_sym_RBRACK,
    ACTIONS(25140), 1,
      anon_sym_LF,
    ACTIONS(25142), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [285197] = 4,
    ACTIONS(25146), 1,
      sym__string_end,
    STATE(15847), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25144), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285212] = 4,
    ACTIONS(25150), 1,
      sym__command_end,
    STATE(15848), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25148), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285227] = 4,
    ACTIONS(25152), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285242] = 4,
    ACTIONS(25154), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285257] = 4,
    ACTIONS(25158), 1,
      sym__string_end,
    STATE(15851), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25156), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285272] = 4,
    ACTIONS(25162), 1,
      sym__command_end,
    STATE(15852), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25160), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285287] = 4,
    ACTIONS(25164), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285302] = 4,
    ACTIONS(25166), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285317] = 4,
    ACTIONS(25170), 1,
      sym__string_end,
    STATE(15855), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25168), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285332] = 4,
    ACTIONS(25174), 1,
      sym__command_end,
    STATE(15856), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25172), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285347] = 4,
    ACTIONS(25176), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285362] = 4,
    ACTIONS(25178), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285377] = 4,
    ACTIONS(25180), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285392] = 4,
    ACTIONS(25184), 1,
      sym__string_end,
    STATE(15860), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25182), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285407] = 4,
    ACTIONS(25188), 1,
      sym__command_end,
    STATE(15861), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25186), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285422] = 4,
    ACTIONS(25190), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285437] = 4,
    ACTIONS(25192), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285452] = 4,
    ACTIONS(25194), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285467] = 4,
    ACTIONS(25198), 1,
      sym__string_end,
    STATE(16036), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25196), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285482] = 4,
    ACTIONS(25202), 1,
      sym__string_end,
    STATE(15866), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25200), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285497] = 4,
    ACTIONS(25206), 1,
      sym__command_end,
    STATE(15867), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25204), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285512] = 4,
    ACTIONS(25208), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285527] = 4,
    ACTIONS(25210), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285542] = 4,
    ACTIONS(25214), 1,
      sym__command_end,
    STATE(16037), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25212), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285557] = 4,
    ACTIONS(25218), 1,
      sym__string_end,
    STATE(15871), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25216), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285572] = 4,
    ACTIONS(25222), 1,
      sym__command_end,
    STATE(15872), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25220), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285587] = 4,
    ACTIONS(25224), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285602] = 4,
    ACTIONS(25226), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285617] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25228), 1,
      anon_sym_COMMA,
    ACTIONS(25230), 1,
      anon_sym_RPAREN,
    STATE(15580), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [285634] = 4,
    ACTIONS(25234), 1,
      sym__string_end,
    STATE(15876), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25232), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285649] = 4,
    ACTIONS(25238), 1,
      sym__command_end,
    STATE(15877), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25236), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285664] = 4,
    ACTIONS(25240), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285679] = 4,
    ACTIONS(25242), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285694] = 4,
    ACTIONS(25246), 1,
      sym__string_end,
    STATE(15880), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25244), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285709] = 4,
    ACTIONS(25250), 1,
      sym__command_end,
    STATE(15881), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25248), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285724] = 4,
    ACTIONS(25252), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285739] = 4,
    ACTIONS(25254), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285754] = 4,
    ACTIONS(25258), 1,
      sym__string_end,
    STATE(15884), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25256), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285769] = 4,
    ACTIONS(25262), 1,
      sym__command_end,
    STATE(15885), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25260), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285784] = 4,
    ACTIONS(25264), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285799] = 4,
    ACTIONS(25266), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285814] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25268), 1,
      anon_sym_COMMA,
    ACTIONS(25270), 1,
      anon_sym_RPAREN,
    STATE(16038), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [285831] = 4,
    ACTIONS(25274), 1,
      sym__string_end,
    STATE(15889), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25272), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285846] = 4,
    ACTIONS(25278), 1,
      sym__command_end,
    STATE(15890), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25276), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285861] = 4,
    ACTIONS(25280), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285876] = 4,
    ACTIONS(25282), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285891] = 4,
    ACTIONS(25286), 1,
      sym__string_end,
    STATE(15893), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25284), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285906] = 4,
    ACTIONS(25290), 1,
      sym__command_end,
    STATE(15894), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25288), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285921] = 4,
    ACTIONS(25292), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285936] = 4,
    ACTIONS(25294), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285951] = 4,
    ACTIONS(25298), 1,
      sym__string_end,
    STATE(15897), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25296), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285966] = 4,
    ACTIONS(25302), 1,
      sym__command_end,
    STATE(15898), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25300), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285981] = 4,
    ACTIONS(25304), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [285996] = 4,
    ACTIONS(25306), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286011] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5480), 1,
      anon_sym_RBRACK,
    ACTIONS(25308), 1,
      anon_sym_LF,
    ACTIONS(25310), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [286030] = 4,
    ACTIONS(25312), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286045] = 4,
    ACTIONS(25316), 1,
      sym__string_end,
    STATE(15903), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25314), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286060] = 4,
    ACTIONS(25320), 1,
      sym__command_end,
    STATE(15904), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25318), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286075] = 4,
    ACTIONS(25322), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286090] = 4,
    ACTIONS(25324), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286105] = 5,
    ACTIONS(9522), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25326), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [286122] = 4,
    ACTIONS(25328), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286137] = 4,
    ACTIONS(25332), 1,
      sym__string_end,
    STATE(15909), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25330), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286152] = 4,
    ACTIONS(25336), 1,
      sym__command_end,
    STATE(15910), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25334), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286167] = 4,
    ACTIONS(25338), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286182] = 4,
    ACTIONS(25340), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286197] = 5,
    ACTIONS(9480), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19564), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [286214] = 4,
    ACTIONS(25344), 1,
      sym__string_end,
    STATE(15914), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25342), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286229] = 4,
    ACTIONS(25348), 1,
      sym__command_end,
    STATE(15915), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25346), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286244] = 4,
    ACTIONS(25350), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286259] = 4,
    ACTIONS(25352), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286274] = 5,
    ACTIONS(8576), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25354), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [286291] = 4,
    ACTIONS(25358), 1,
      sym__string_end,
    STATE(15919), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25356), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286306] = 4,
    ACTIONS(25362), 1,
      sym__command_end,
    STATE(15920), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25360), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286321] = 4,
    ACTIONS(25364), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286336] = 4,
    ACTIONS(25366), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286351] = 4,
    ACTIONS(25368), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286366] = 4,
    ACTIONS(25372), 1,
      sym__string_end,
    STATE(15924), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25370), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286381] = 4,
    ACTIONS(25376), 1,
      sym__command_end,
    STATE(15925), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25374), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286396] = 4,
    ACTIONS(25378), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286411] = 4,
    ACTIONS(25380), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286426] = 4,
    ACTIONS(25384), 1,
      sym__string_end,
    STATE(15928), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25382), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286441] = 4,
    ACTIONS(25388), 1,
      sym__command_end,
    STATE(15929), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25386), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286456] = 4,
    ACTIONS(25390), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286471] = 4,
    ACTIONS(25392), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286486] = 4,
    ACTIONS(25396), 1,
      sym__string_end,
    STATE(15932), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25394), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286501] = 4,
    ACTIONS(25400), 1,
      sym__command_end,
    STATE(15933), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25398), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286516] = 4,
    ACTIONS(25402), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286531] = 4,
    ACTIONS(25404), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286546] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5106), 1,
      anon_sym_RBRACK,
    ACTIONS(25406), 1,
      anon_sym_LF,
    ACTIONS(25408), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [286565] = 4,
    ACTIONS(25412), 1,
      sym__string_end,
    STATE(15937), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25410), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286580] = 4,
    ACTIONS(25416), 1,
      sym__command_end,
    STATE(15938), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25414), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286595] = 4,
    ACTIONS(25418), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286610] = 4,
    ACTIONS(25420), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286625] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5360), 1,
      anon_sym_RBRACK,
    ACTIONS(25422), 1,
      anon_sym_LF,
    ACTIONS(25424), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [286644] = 4,
    ACTIONS(25428), 1,
      sym__string_end,
    STATE(15942), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25426), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286659] = 4,
    ACTIONS(25432), 1,
      sym__command_end,
    STATE(15943), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25430), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286674] = 4,
    ACTIONS(25434), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286689] = 4,
    ACTIONS(25436), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286704] = 5,
    ACTIONS(10276), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25438), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [286721] = 4,
    ACTIONS(25442), 1,
      sym__string_end,
    STATE(15947), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25440), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286736] = 4,
    ACTIONS(25446), 1,
      sym__command_end,
    STATE(15948), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25444), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286751] = 4,
    ACTIONS(25448), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286766] = 4,
    ACTIONS(25450), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286781] = 5,
    ACTIONS(10284), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25452), 1,
      anon_sym_COMMA,
    STATE(16062), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [286798] = 5,
    ACTIONS(9254), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19489), 1,
      anon_sym_COMMA,
    STATE(15497), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [286815] = 4,
    ACTIONS(25456), 1,
      sym__string_end,
    STATE(15953), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25454), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286830] = 4,
    ACTIONS(25460), 1,
      sym__command_end,
    STATE(15954), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25458), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286845] = 4,
    ACTIONS(25462), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286860] = 4,
    ACTIONS(25464), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286875] = 4,
    ACTIONS(25468), 1,
      sym__string_end,
    STATE(15957), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25466), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286890] = 4,
    ACTIONS(25472), 1,
      sym__command_end,
    STATE(15958), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25470), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286905] = 4,
    ACTIONS(25474), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286920] = 4,
    ACTIONS(25476), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286935] = 4,
    ACTIONS(25480), 1,
      sym__string_end,
    STATE(15961), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25478), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286950] = 4,
    ACTIONS(25484), 1,
      sym__command_end,
    STATE(15962), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25482), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286965] = 4,
    ACTIONS(25486), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286980] = 4,
    ACTIONS(25488), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [286995] = 4,
    ACTIONS(25492), 1,
      sym__string_end,
    STATE(15965), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25490), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287010] = 4,
    ACTIONS(25496), 1,
      sym__command_end,
    STATE(15966), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25494), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287025] = 4,
    ACTIONS(25498), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287040] = 4,
    ACTIONS(25500), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287055] = 5,
    ACTIONS(10284), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25452), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [287072] = 4,
    ACTIONS(25504), 1,
      sym__string_end,
    STATE(15970), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25502), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287087] = 4,
    ACTIONS(25508), 1,
      sym__command_end,
    STATE(15971), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25506), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287102] = 4,
    ACTIONS(25510), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287117] = 4,
    ACTIONS(25512), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287132] = 4,
    ACTIONS(25516), 1,
      sym__string_end,
    STATE(15974), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25514), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287147] = 4,
    ACTIONS(25520), 1,
      sym__command_end,
    STATE(15975), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25518), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287162] = 4,
    ACTIONS(25522), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287177] = 4,
    ACTIONS(25524), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287192] = 4,
    ACTIONS(25528), 1,
      sym__string_end,
    STATE(15978), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25526), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287207] = 4,
    ACTIONS(25532), 1,
      sym__command_end,
    STATE(15979), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25530), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287222] = 4,
    ACTIONS(25534), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287237] = 4,
    ACTIONS(25536), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287252] = 4,
    ACTIONS(25540), 1,
      sym__string_end,
    STATE(15982), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25538), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287267] = 4,
    ACTIONS(25544), 1,
      sym__command_end,
    STATE(15983), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25542), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287282] = 4,
    ACTIONS(25546), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287297] = 4,
    ACTIONS(25548), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287312] = 4,
    ACTIONS(25552), 1,
      sym__string_end,
    STATE(15986), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25550), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287327] = 4,
    ACTIONS(25556), 1,
      sym__command_end,
    STATE(15987), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25554), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287342] = 4,
    ACTIONS(25558), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287357] = 4,
    ACTIONS(25560), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287372] = 4,
    ACTIONS(25564), 1,
      sym__string_end,
    STATE(15990), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25562), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287387] = 4,
    ACTIONS(25568), 1,
      sym__command_end,
    STATE(15991), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25566), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287402] = 4,
    ACTIONS(25570), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287417] = 4,
    ACTIONS(25572), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287432] = 4,
    ACTIONS(25576), 1,
      sym__string_end,
    STATE(15994), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25574), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287447] = 4,
    ACTIONS(25580), 1,
      sym__command_end,
    STATE(15995), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25578), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287462] = 4,
    ACTIONS(25582), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287477] = 4,
    ACTIONS(25584), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287492] = 4,
    ACTIONS(25588), 1,
      sym__string_end,
    STATE(15998), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25586), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287507] = 4,
    ACTIONS(25592), 1,
      sym__command_end,
    STATE(15999), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25590), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287522] = 4,
    ACTIONS(25594), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287537] = 4,
    ACTIONS(25596), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287552] = 5,
    ACTIONS(8990), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25598), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [287569] = 4,
    ACTIONS(25602), 1,
      sym__string_end,
    STATE(16003), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25600), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287584] = 4,
    ACTIONS(25606), 1,
      sym__command_end,
    STATE(16004), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25604), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287599] = 4,
    ACTIONS(25608), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287614] = 4,
    ACTIONS(25610), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287629] = 4,
    ACTIONS(25614), 1,
      sym__string_end,
    STATE(16007), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25612), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287644] = 4,
    ACTIONS(25618), 1,
      sym__command_end,
    STATE(16008), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25616), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287659] = 4,
    ACTIONS(25620), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287674] = 4,
    ACTIONS(25622), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287689] = 5,
    ACTIONS(8998), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25624), 1,
      anon_sym_COMMA,
    STATE(16047), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [287706] = 4,
    ACTIONS(25628), 1,
      sym__string_end,
    STATE(16012), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25626), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287721] = 4,
    ACTIONS(25632), 1,
      sym__command_end,
    STATE(16013), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25630), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287736] = 4,
    ACTIONS(25634), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287751] = 4,
    ACTIONS(25636), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287766] = 4,
    ACTIONS(25640), 1,
      sym__string_end,
    STATE(16016), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25638), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287781] = 4,
    ACTIONS(25644), 1,
      sym__command_end,
    STATE(16017), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25642), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287796] = 4,
    ACTIONS(25646), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287811] = 4,
    ACTIONS(25648), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287826] = 5,
    ACTIONS(8998), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25624), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [287843] = 4,
    ACTIONS(25652), 1,
      sym__string_end,
    STATE(16021), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25650), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287858] = 4,
    ACTIONS(25656), 1,
      sym__command_end,
    STATE(16022), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25654), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287873] = 4,
    ACTIONS(25658), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287888] = 4,
    ACTIONS(25660), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287903] = 4,
    ACTIONS(25664), 1,
      sym__string_end,
    STATE(16025), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25662), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287918] = 4,
    ACTIONS(25668), 1,
      sym__command_end,
    STATE(16026), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25666), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287933] = 4,
    ACTIONS(25670), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287948] = 4,
    ACTIONS(25672), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287963] = 4,
    ACTIONS(25676), 1,
      sym__string_end,
    STATE(16029), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25674), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287978] = 4,
    ACTIONS(25680), 1,
      sym__command_end,
    STATE(16030), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25678), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [287993] = 4,
    ACTIONS(25682), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288008] = 4,
    ACTIONS(25684), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288023] = 4,
    ACTIONS(25686), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288038] = 4,
    ACTIONS(25690), 1,
      sym__string_end,
    STATE(16034), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25688), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288053] = 4,
    ACTIONS(25694), 1,
      sym__command_end,
    STATE(16035), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25692), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288068] = 4,
    ACTIONS(25696), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288083] = 4,
    ACTIONS(25698), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288098] = 4,
    ACTIONS(25700), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288113] = 4,
    ACTIONS(25702), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288128] = 5,
    ACTIONS(9534), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25704), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288145] = 5,
    ACTIONS(9542), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25706), 1,
      anon_sym_COMMA,
    STATE(16061), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288162] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25708), 1,
      anon_sym_COMMA,
    ACTIONS(25710), 1,
      anon_sym_RPAREN,
    STATE(16266), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288179] = 5,
    ACTIONS(9542), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25706), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288196] = 4,
    ACTIONS(25714), 1,
      sym__string_end,
    STATE(16123), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25712), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288211] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(620), 2,
      sym_interpolation_expression,
      sym_identifier,
  [288226] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(428), 2,
      sym_interpolation_expression,
      sym_identifier,
  [288241] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25720), 1,
      anon_sym_RBRACK,
    ACTIONS(25722), 1,
      anon_sym_LF,
    ACTIONS(25724), 1,
      aux_sym__terminator_token1,
    STATE(15484), 1,
      aux_sym_matrix_expression_repeat1,
  [288260] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(419), 2,
      sym_interpolation_expression,
      sym_identifier,
  [288275] = 5,
    ACTIONS(9008), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25726), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288292] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16268), 2,
      sym_interpolation_expression,
      sym_identifier,
  [288307] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(440), 2,
      sym_interpolation_expression,
      sym_identifier,
  [288322] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(25730), 1,
      anon_sym_LF,
    ACTIONS(25732), 1,
      aux_sym__terminator_token1,
    STATE(16058), 1,
      aux_sym_let_statement_repeat1,
  [288341] = 4,
    ACTIONS(25736), 1,
      sym__command_end,
    STATE(16126), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25734), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288356] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15438), 1,
      sym_catch_clause,
    STATE(16941), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288373] = 5,
    ACTIONS(8620), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25738), 1,
      anon_sym_COMMA,
    STATE(16087), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288390] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25740), 1,
      anon_sym_COMMA,
    ACTIONS(25742), 1,
      anon_sym_RPAREN,
    STATE(16179), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288407] = 5,
    ACTIONS(9012), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20247), 1,
      anon_sym_COMMA,
    STATE(16308), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288424] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25744), 1,
      anon_sym_COMMA,
    ACTIONS(25746), 1,
      anon_sym_RPAREN,
    STATE(16155), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288441] = 4,
    ACTIONS(25748), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288456] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(25750), 1,
      anon_sym_LF,
    ACTIONS(25752), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [288475] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(25754), 1,
      anon_sym_LF,
    ACTIONS(25756), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [288494] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15253), 1,
      sym_catch_clause,
    STATE(16722), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288511] = 5,
    ACTIONS(9550), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25758), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288528] = 5,
    ACTIONS(10292), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25760), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288545] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25762), 1,
      anon_sym_COMMA,
    ACTIONS(25764), 1,
      anon_sym_RPAREN,
    STATE(16128), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288562] = 5,
    ACTIONS(9978), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25766), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288579] = 5,
    ACTIONS(10296), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19911), 1,
      anon_sym_COMMA,
    STATE(16171), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288596] = 5,
    ACTIONS(9986), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25768), 1,
      anon_sym_COMMA,
    STATE(16083), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288613] = 5,
    ACTIONS(9986), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25768), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288630] = 4,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22427), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
  [288645] = 5,
    ACTIONS(9554), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19588), 1,
      anon_sym_COMMA,
    STATE(16196), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288662] = 5,
    ACTIONS(9332), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19510), 1,
      anon_sym_COMMA,
    STATE(15708), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288679] = 4,
    ACTIONS(25770), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288694] = 4,
    ACTIONS(25772), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288709] = 5,
    ACTIONS(9414), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25774), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288726] = 5,
    ACTIONS(9880), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25776), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288743] = 5,
    ACTIONS(9368), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19524), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288760] = 5,
    ACTIONS(9884), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19749), 1,
      anon_sym_COMMA,
    STATE(15661), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288777] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25778), 1,
      anon_sym_COMMA,
    ACTIONS(25780), 1,
      anon_sym_RPAREN,
    STATE(16474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288794] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6788), 1,
      anon_sym_end,
    ACTIONS(25782), 1,
      anon_sym_LF,
    ACTIONS(25784), 1,
      aux_sym__terminator_token1,
    STATE(15489), 1,
      aux_sym__block_repeat1,
  [288813] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25786), 1,
      anon_sym_RBRACK,
    ACTIONS(25788), 1,
      anon_sym_LF,
    ACTIONS(25790), 1,
      aux_sym__terminator_token1,
    STATE(16100), 1,
      aux_sym_matrix_expression_repeat1,
  [288832] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25792), 4,
      sym__command_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [288843] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25794), 1,
      anon_sym_COMMA,
    ACTIONS(25796), 1,
      anon_sym_RPAREN,
    STATE(16073), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288860] = 4,
    ACTIONS(25798), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288875] = 5,
    ACTIONS(9994), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25800), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288892] = 5,
    ACTIONS(9812), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19728), 1,
      anon_sym_COMMA,
    STATE(15811), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288909] = 4,
    ACTIONS(25804), 1,
      sym__string_end,
    STATE(16105), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25802), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288924] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25806), 4,
      sym__command_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [288935] = 5,
    ACTIONS(8840), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25808), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288952] = 4,
    ACTIONS(25812), 1,
      sym__command_end,
    STATE(16106), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25810), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [288967] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25814), 1,
      anon_sym_COMMA,
    ACTIONS(25816), 1,
      anon_sym_RPAREN,
    STATE(16108), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [288984] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25818), 1,
      anon_sym_RBRACK,
    ACTIONS(25820), 1,
      anon_sym_LF,
    ACTIONS(25822), 1,
      aux_sym__terminator_token1,
    STATE(16107), 1,
      aux_sym_matrix_expression_repeat1,
  [289003] = 5,
    ACTIONS(9998), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19795), 1,
      anon_sym_COMMA,
    STATE(16531), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289020] = 5,
    ACTIONS(10302), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25824), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289037] = 4,
    ACTIONS(25828), 1,
      sym__string_end,
    STATE(16112), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25826), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289052] = 4,
    ACTIONS(25832), 1,
      sym__command_end,
    STATE(16113), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25830), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289067] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16549), 2,
      sym_interpolation_expression,
      sym_identifier,
  [289082] = 5,
    ACTIONS(10258), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19895), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289099] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25834), 1,
      anon_sym_COMMA,
    ACTIONS(25836), 1,
      anon_sym_RPAREN,
    STATE(16115), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289116] = 5,
    ACTIONS(9364), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25838), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289133] = 5,
    ACTIONS(9830), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25840), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289150] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5702), 1,
      anon_sym_RBRACK,
    ACTIONS(25842), 1,
      anon_sym_LF,
    ACTIONS(25844), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [289169] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5306), 1,
      anon_sym_RBRACK,
    ACTIONS(25846), 1,
      anon_sym_LF,
    ACTIONS(25848), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [289188] = 5,
    ACTIONS(9564), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25850), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289205] = 5,
    ACTIONS(9838), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25852), 1,
      anon_sym_COMMA,
    STATE(16374), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289222] = 5,
    ACTIONS(9516), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19574), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289239] = 4,
    ACTIONS(25854), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289254] = 4,
    ACTIONS(25856), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289269] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5372), 1,
      anon_sym_RBRACK,
    ACTIONS(25858), 1,
      anon_sym_LF,
    ACTIONS(25860), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [289288] = 5,
    ACTIONS(10312), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25862), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289305] = 5,
    ACTIONS(10318), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25864), 1,
      anon_sym_COMMA,
    STATE(16124), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289322] = 5,
    ACTIONS(10318), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25864), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289339] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25866), 1,
      anon_sym_RBRACK,
    ACTIONS(25868), 1,
      anon_sym_LF,
    ACTIONS(25870), 1,
      aux_sym__terminator_token1,
    STATE(16142), 1,
      aux_sym_matrix_expression_repeat1,
  [289358] = 4,
    ACTIONS(25872), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289373] = 4,
    ACTIONS(25874), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289388] = 5,
    ACTIONS(9838), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25852), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289405] = 5,
    ACTIONS(9574), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25876), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289422] = 5,
    ACTIONS(9580), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25878), 1,
      anon_sym_COMMA,
    STATE(16139), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289439] = 5,
    ACTIONS(9580), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25878), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289456] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25880), 1,
      anon_sym_COMMA,
    ACTIONS(25882), 1,
      anon_sym_RPAREN,
    STATE(16228), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289473] = 4,
    ACTIONS(25886), 1,
      sym__string_end,
    STATE(16146), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25884), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289488] = 4,
    ACTIONS(25890), 1,
      sym__command_end,
    STATE(16147), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25888), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289503] = 5,
    ACTIONS(9212), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25892), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289520] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(25894), 1,
      anon_sym_end,
    ACTIONS(25896), 1,
      sym__immediate_brace,
    STATE(18238), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289537] = 4,
    ACTIONS(25898), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289552] = 5,
    ACTIONS(10326), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25900), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289569] = 5,
    ACTIONS(8620), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25738), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289586] = 4,
    ACTIONS(25902), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289601] = 5,
    ACTIONS(10330), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19963), 1,
      anon_sym_COMMA,
    STATE(16265), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289618] = 5,
    ACTIONS(9424), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25904), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289635] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25906), 1,
      anon_sym_COMMA,
    ACTIONS(25908), 1,
      anon_sym_RPAREN,
    STATE(16246), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289652] = 5,
    ACTIONS(9430), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25910), 1,
      anon_sym_COMMA,
    STATE(16254), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289669] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25912), 1,
      anon_sym_COMMA,
    ACTIONS(25914), 1,
      anon_sym_RPAREN,
    STATE(16157), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289686] = 4,
    ACTIONS(25918), 1,
      sym__string_end,
    STATE(15900), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25916), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289701] = 5,
    ACTIONS(9430), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25910), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289718] = 5,
    ACTIONS(9022), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25920), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289735] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25922), 1,
      anon_sym_COMMA,
    ACTIONS(25924), 1,
      anon_sym_RPAREN,
    STATE(15550), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289752] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(25926), 1,
      anon_sym_RPAREN,
    ACTIONS(25928), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289769] = 5,
    ACTIONS(8970), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20119), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289786] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25930), 1,
      anon_sym_RBRACK,
    ACTIONS(25932), 1,
      anon_sym_LF,
    ACTIONS(25934), 1,
      aux_sym__terminator_token1,
    STATE(16193), 1,
      aux_sym_matrix_expression_repeat1,
  [289805] = 5,
    ACTIONS(9588), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25936), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289822] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25938), 1,
      anon_sym_RBRACK,
    ACTIONS(25940), 1,
      anon_sym_LF,
    ACTIONS(25942), 1,
      aux_sym__terminator_token1,
    STATE(16633), 1,
      aux_sym_matrix_expression_repeat1,
  [289841] = 5,
    ACTIONS(9592), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19664), 1,
      anon_sym_COMMA,
    STATE(16276), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [289858] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6170), 1,
      anon_sym_RBRACK,
    ACTIONS(25944), 1,
      anon_sym_LF,
    ACTIONS(25946), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [289877] = 4,
    ACTIONS(25948), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21548), 2,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [289892] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25951), 1,
      anon_sym_RBRACK,
    ACTIONS(25953), 1,
      anon_sym_LF,
    ACTIONS(25955), 1,
      aux_sym__terminator_token1,
    STATE(16236), 1,
      aux_sym_matrix_expression_repeat1,
  [289911] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25957), 1,
      anon_sym_RBRACK,
    ACTIONS(25959), 1,
      anon_sym_LF,
    ACTIONS(25961), 1,
      aux_sym__terminator_token1,
    STATE(16161), 1,
      aux_sym_matrix_expression_repeat1,
  [289930] = 4,
    ACTIONS(25963), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289945] = 4,
    ACTIONS(25965), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289960] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(25967), 1,
      anon_sym_RBRACK,
    ACTIONS(25969), 1,
      anon_sym_LF,
    ACTIONS(25971), 1,
      aux_sym__terminator_token1,
    STATE(16392), 1,
      aux_sym_matrix_expression_repeat1,
  [289979] = 4,
    ACTIONS(25975), 1,
      sym__string_end,
    STATE(16209), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25973), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [289994] = 4,
    ACTIONS(25979), 1,
      sym__string_end,
    STATE(16164), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25977), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290009] = 4,
    ACTIONS(25983), 1,
      sym__command_end,
    STATE(16166), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25981), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290024] = 4,
    ACTIONS(25987), 1,
      sym__command_end,
    STATE(16210), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25985), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290039] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25989), 1,
      anon_sym_COMMA,
    ACTIONS(25991), 1,
      anon_sym_RPAREN,
    STATE(16168), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290056] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25993), 1,
      anon_sym_COMMA,
    ACTIONS(25995), 1,
      anon_sym_RPAREN,
    STATE(16211), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290073] = 5,
    ACTIONS(10336), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25997), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290090] = 5,
    ACTIONS(10296), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19911), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290107] = 5,
    ACTIONS(9034), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(25999), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290124] = 5,
    ACTIONS(9040), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26001), 1,
      anon_sym_COMMA,
    STATE(16170), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290141] = 5,
    ACTIONS(9040), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26001), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290158] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22425), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
  [290169] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5714), 1,
      anon_sym_RBRACK,
    ACTIONS(26003), 1,
      anon_sym_LF,
    ACTIONS(26005), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [290188] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26007), 1,
      anon_sym_COMMA,
    ACTIONS(26009), 1,
      anon_sym_RPAREN,
    STATE(16463), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290205] = 5,
    ACTIONS(10006), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26011), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290222] = 4,
    ACTIONS(26013), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290237] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26015), 4,
      sym__command_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [290248] = 4,
    ACTIONS(26017), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290263] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26019), 1,
      anon_sym_RBRACK,
    ACTIONS(26021), 1,
      anon_sym_LF,
    ACTIONS(26023), 1,
      aux_sym__terminator_token1,
    STATE(16185), 1,
      aux_sym_matrix_expression_repeat1,
  [290282] = 5,
    ACTIONS(10346), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26025), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290299] = 5,
    ACTIONS(10354), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26027), 1,
      anon_sym_COMMA,
    STATE(16192), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290316] = 5,
    ACTIONS(9050), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26029), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290333] = 5,
    ACTIONS(10354), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26027), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290350] = 4,
    ACTIONS(20995), 1,
      anon_sym_COMMA,
    STATE(16199), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13148), 2,
      anon_sym_EQ,
      anon_sym_COLON,
  [290365] = 4,
    ACTIONS(26033), 1,
      sym__string_end,
    STATE(16189), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26031), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290380] = 4,
    ACTIONS(26037), 1,
      sym__command_end,
    STATE(16190), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26035), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290395] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26039), 1,
      anon_sym_RBRACK,
    ACTIONS(26041), 1,
      anon_sym_LF,
    ACTIONS(26043), 1,
      aux_sym__terminator_token1,
    STATE(16388), 1,
      aux_sym_matrix_expression_repeat1,
  [290414] = 5,
    ACTIONS(9054), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20259), 1,
      anon_sym_COMMA,
    STATE(16504), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290431] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26045), 1,
      anon_sym_COMMA,
    ACTIONS(26047), 1,
      anon_sym_RPAREN,
    STATE(16194), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290448] = 5,
    ACTIONS(9958), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19777), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290465] = 5,
    ACTIONS(9600), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26049), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290482] = 5,
    ACTIONS(9368), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19524), 1,
      anon_sym_COMMA,
    STATE(16133), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290499] = 5,
    ACTIONS(9554), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19588), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290516] = 4,
    ACTIONS(26053), 1,
      sym__string_end,
    STATE(16312), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26051), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290531] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26055), 1,
      anon_sym_COMMA,
    ACTIONS(26057), 1,
      anon_sym_RPAREN,
    STATE(16322), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290548] = 4,
    ACTIONS(26061), 1,
      sym__command_end,
    STATE(16313), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26059), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290563] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5390), 1,
      anon_sym_RBRACK,
    ACTIONS(26063), 1,
      anon_sym_LF,
    ACTIONS(26065), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [290582] = 5,
    ACTIONS(9222), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26067), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290599] = 4,
    ACTIONS(26071), 1,
      sym__string_end,
    STATE(16071), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26069), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290614] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26073), 1,
      anon_sym_COMMA,
    ACTIONS(26075), 1,
      anon_sym_RPAREN,
    STATE(16319), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290631] = 4,
    ACTIONS(26077), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290646] = 4,
    ACTIONS(26079), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290661] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26081), 1,
      anon_sym_COMMA,
    ACTIONS(26083), 1,
      anon_sym_RPAREN,
    STATE(15678), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290678] = 5,
    ACTIONS(10362), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26085), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290695] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5564), 1,
      anon_sym_RBRACK,
    ACTIONS(26087), 1,
      anon_sym_LF,
    ACTIONS(26089), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [290714] = 5,
    ACTIONS(9610), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26091), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290731] = 5,
    ACTIONS(9618), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26093), 1,
      anon_sym_COMMA,
    STATE(16204), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290748] = 5,
    ACTIONS(9618), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26093), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290765] = 4,
    ACTIONS(26097), 1,
      sym__command_end,
    STATE(16082), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26095), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290780] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26099), 1,
      anon_sym_RBRACK,
    ACTIONS(26101), 1,
      anon_sym_LF,
    ACTIONS(26103), 1,
      aux_sym__terminator_token1,
    STATE(16411), 1,
      aux_sym_matrix_expression_repeat1,
  [290799] = 4,
    ACTIONS(21039), 1,
      anon_sym_COMMA,
    STATE(16199), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13075), 2,
      anon_sym_EQ,
      anon_sym_COLON,
  [290814] = 5,
    ACTIONS(10366), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19971), 1,
      anon_sym_COMMA,
    STATE(16367), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290831] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26105), 1,
      anon_sym_COMMA,
    ACTIONS(26107), 1,
      anon_sym_RPAREN,
    STATE(16350), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290848] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17982), 1,
      anon_sym_EQ,
    ACTIONS(19548), 1,
      anon_sym_LF,
    ACTIONS(19546), 2,
      anon_sym_end,
      aux_sym__terminator_token1,
  [290865] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26109), 1,
      anon_sym_COMMA,
    ACTIONS(26111), 1,
      anon_sym_RPAREN,
    STATE(16341), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290882] = 5,
    ACTIONS(9626), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26113), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290899] = 4,
    ACTIONS(26117), 1,
      sym__string_end,
    STATE(16432), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26115), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290914] = 5,
    ACTIONS(9262), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26119), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290931] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(26121), 1,
      anon_sym_RPAREN,
    ACTIONS(26123), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290948] = 5,
    ACTIONS(9630), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19672), 1,
      anon_sym_COMMA,
    STATE(16383), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [290965] = 4,
    ACTIONS(26125), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290980] = 4,
    ACTIONS(26127), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [290995] = 5,
    ACTIONS(10016), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26129), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291012] = 4,
    ACTIONS(26133), 1,
      sym__string_end,
    STATE(16447), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26131), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291027] = 5,
    ACTIONS(9216), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19452), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291044] = 4,
    ACTIONS(26137), 1,
      sym__command_end,
    STATE(16453), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26135), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291059] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(26139), 1,
      anon_sym_RPAREN,
    ACTIONS(26141), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291076] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26143), 1,
      anon_sym_RBRACK,
    ACTIONS(26145), 1,
      anon_sym_LF,
    ACTIONS(26147), 1,
      aux_sym__terminator_token1,
    STATE(16255), 1,
      aux_sym_matrix_expression_repeat1,
  [291095] = 5,
    ACTIONS(10022), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26149), 1,
      anon_sym_COMMA,
    STATE(16300), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291112] = 4,
    ACTIONS(26153), 1,
      sym__string_end,
    STATE(16258), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26151), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291127] = 4,
    ACTIONS(26157), 1,
      sym__command_end,
    STATE(16260), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26155), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291142] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12620), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [291153] = 4,
    ACTIONS(26161), 1,
      sym__string_end,
    STATE(16573), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26159), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291168] = 4,
    ACTIONS(26165), 1,
      sym__string_end,
    STATE(15535), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26163), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291183] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26167), 1,
      anon_sym_RBRACK,
    ACTIONS(26169), 1,
      anon_sym_LF,
    ACTIONS(26171), 1,
      aux_sym__terminator_token1,
    STATE(16279), 1,
      aux_sym_matrix_expression_repeat1,
  [291202] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26173), 1,
      anon_sym_COMMA,
    ACTIONS(26175), 1,
      anon_sym_RPAREN,
    STATE(16261), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291219] = 4,
    ACTIONS(26179), 1,
      sym__string_end,
    STATE(16494), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26177), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291234] = 4,
    ACTIONS(26183), 1,
      sym__command_end,
    STATE(16497), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26181), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291249] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26185), 1,
      anon_sym_RBRACK,
    ACTIONS(26187), 1,
      anon_sym_LF,
    ACTIONS(26189), 1,
      aux_sym__terminator_token1,
    STATE(16262), 1,
      aux_sym_matrix_expression_repeat1,
  [291268] = 5,
    ACTIONS(10370), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26191), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291285] = 5,
    ACTIONS(10022), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26149), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291302] = 4,
    ACTIONS(26195), 1,
      sym__string_end,
    STATE(16282), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26193), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291317] = 4,
    ACTIONS(26199), 1,
      sym__command_end,
    STATE(16283), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26197), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291332] = 5,
    ACTIONS(10330), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19963), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291349] = 4,
    ACTIONS(26203), 1,
      sym__string_end,
    STATE(16271), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26201), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291364] = 4,
    ACTIONS(26207), 1,
      sym__command_end,
    STATE(16272), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26205), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291379] = 4,
    ACTIONS(21282), 1,
      anon_sym_for,
    ACTIONS(26209), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26211), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [291394] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5236), 1,
      anon_sym_RBRACK,
    ACTIONS(26214), 1,
      anon_sym_LF,
    ACTIONS(26216), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [291413] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26218), 1,
      anon_sym_COMMA,
    ACTIONS(26220), 1,
      anon_sym_RPAREN,
    STATE(16274), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291430] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(657), 2,
      sym_interpolation_expression,
      sym_identifier,
  [291445] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(451), 2,
      sym_interpolation_expression,
      sym_identifier,
  [291460] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(26222), 1,
      anon_sym_end,
    ACTIONS(26224), 1,
      sym__immediate_brace,
    STATE(18608), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291477] = 4,
    ACTIONS(26226), 1,
      sym__immediate_string_start,
    ACTIONS(26228), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11894), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [291492] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16259), 2,
      sym_interpolation_expression,
      sym_identifier,
  [291507] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(433), 2,
      sym_interpolation_expression,
      sym_identifier,
  [291522] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26230), 1,
      anon_sym_LF,
    ACTIONS(26232), 1,
      aux_sym__terminator_token1,
    STATE(16251), 1,
      aux_sym_let_statement_repeat1,
  [291541] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(26234), 1,
      anon_sym_end,
    ACTIONS(26236), 1,
      sym__immediate_brace,
    STATE(18866), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291558] = 5,
    ACTIONS(9638), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26238), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291575] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15279), 1,
      sym_catch_clause,
    STATE(16711), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291592] = 4,
    ACTIONS(26242), 1,
      sym__command_end,
    STATE(16654), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26240), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291607] = 4,
    ACTIONS(26246), 1,
      sym__command_end,
    STATE(16595), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26244), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291622] = 5,
    ACTIONS(9592), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19664), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291639] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26248), 1,
      anon_sym_LF,
    ACTIONS(26250), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [291658] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26252), 1,
      anon_sym_LF,
    ACTIONS(26254), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [291677] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15388), 1,
      sym_catch_clause,
    STATE(17150), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291694] = 5,
    ACTIONS(9438), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26256), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291711] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5732), 1,
      anon_sym_RBRACK,
    ACTIONS(26258), 1,
      anon_sym_LF,
    ACTIONS(26260), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [291730] = 4,
    ACTIONS(26264), 1,
      sym__command_end,
    STATE(16437), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26262), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291745] = 4,
    ACTIONS(26268), 1,
      sym__string_end,
    STATE(15512), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26266), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291760] = 4,
    ACTIONS(26270), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291775] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(26272), 1,
      anon_sym_end,
    ACTIONS(26274), 1,
      sym__immediate_brace,
    STATE(19378), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291792] = 4,
    ACTIONS(26276), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291807] = 5,
    ACTIONS(10380), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26278), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291824] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5408), 1,
      anon_sym_RBRACK,
    ACTIONS(26280), 1,
      anon_sym_LF,
    ACTIONS(26282), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [291843] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26284), 1,
      anon_sym_COMMA,
    ACTIONS(26286), 1,
      anon_sym_RPAREN,
    STATE(16306), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291860] = 5,
    ACTIONS(10386), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26288), 1,
      anon_sym_COMMA,
    STATE(16277), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291877] = 5,
    ACTIONS(10386), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26288), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291894] = 5,
    ACTIONS(9062), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26290), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291911] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(26292), 1,
      anon_sym_RPAREN,
    ACTIONS(26294), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291928] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(26296), 1,
      anon_sym_end,
    ACTIONS(26298), 1,
      sym__immediate_brace,
    STATE(18652), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291945] = 5,
    ACTIONS(9012), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20247), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [291962] = 4,
    ACTIONS(26302), 1,
      sym__command_end,
    STATE(15513), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26300), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291977] = 4,
    ACTIONS(26304), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [291992] = 4,
    ACTIONS(26306), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [292007] = 4,
    ACTIONS(26311), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26308), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [292022] = 5,
    ACTIONS(9648), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26313), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292039] = 5,
    ACTIONS(9654), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26315), 1,
      anon_sym_COMMA,
    STATE(16305), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292056] = 5,
    ACTIONS(9654), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26315), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292073] = 5,
    ACTIONS(10394), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26317), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292090] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26319), 1,
      anon_sym_COMMA,
    ACTIONS(26321), 1,
      anon_sym_RPAREN,
    STATE(16473), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292107] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6274), 1,
      anon_sym_RBRACK,
    ACTIONS(26323), 1,
      anon_sym_LF,
    ACTIONS(26325), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [292126] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    ACTIONS(23358), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
  [292141] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11864), 4,
      sym__string_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [292152] = 4,
    ACTIONS(26327), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [292167] = 4,
    ACTIONS(26329), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [292182] = 5,
    ACTIONS(9174), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20249), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292199] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(597), 2,
      sym_interpolation_expression,
      sym_identifier,
  [292214] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(412), 2,
      sym_interpolation_expression,
      sym_identifier,
  [292229] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(18118), 1,
      anon_sym_EQ,
    ACTIONS(19546), 1,
      aux_sym__terminator_token1,
    ACTIONS(19548), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [292246] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26331), 1,
      anon_sym_COMMA,
    ACTIONS(26333), 1,
      anon_sym_RPAREN,
    STATE(15477), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292263] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26015), 4,
      sym__string_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [292274] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16296), 2,
      sym_interpolation_expression,
      sym_identifier,
  [292289] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(441), 2,
      sym_interpolation_expression,
      sym_identifier,
  [292304] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26335), 1,
      anon_sym_LF,
    ACTIONS(26337), 1,
      aux_sym__terminator_token1,
    STATE(16297), 1,
      aux_sym_let_statement_repeat1,
  [292323] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(19548), 1,
      ts_builtin_sym_end,
    ACTIONS(26339), 1,
      anon_sym_LF,
    ACTIONS(26342), 1,
      aux_sym__terminator_token1,
    STATE(16293), 1,
      aux_sym__block_repeat1,
  [292342] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15290), 1,
      sym_catch_clause,
    STATE(16968), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292359] = 4,
    ACTIONS(26347), 1,
      sym__command_end,
    STATE(16072), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26345), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [292374] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(26349), 1,
      anon_sym_end,
    ACTIONS(26351), 1,
      sym__immediate_brace,
    STATE(19352), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292391] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26353), 1,
      anon_sym_LF,
    ACTIONS(26355), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [292410] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26357), 1,
      anon_sym_LF,
    ACTIONS(26359), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [292429] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15247), 1,
      sym_catch_clause,
    STATE(16726), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292446] = 5,
    ACTIONS(10030), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26361), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292463] = 5,
    ACTIONS(9442), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19552), 1,
      anon_sym_COMMA,
    STATE(15736), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292480] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26363), 1,
      anon_sym_RBRACK,
    ACTIONS(26365), 1,
      anon_sym_LF,
    ACTIONS(26367), 1,
      aux_sym__terminator_token1,
    STATE(16339), 1,
      aux_sym_matrix_expression_repeat1,
  [292499] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26369), 1,
      anon_sym_COMMA,
    ACTIONS(26371), 1,
      anon_sym_RPAREN,
    STATE(16508), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292516] = 4,
    ACTIONS(26375), 1,
      sym__string_end,
    STATE(16351), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26373), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [292531] = 5,
    ACTIONS(9662), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26377), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292548] = 5,
    ACTIONS(9074), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26379), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292565] = 5,
    ACTIONS(9082), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26381), 1,
      anon_sym_COMMA,
    STATE(16327), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292582] = 5,
    ACTIONS(9082), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26381), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292599] = 5,
    ACTIONS(9666), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19678), 1,
      anon_sym_COMMA,
    STATE(16529), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292616] = 4,
    ACTIONS(26383), 1,
      anon_sym_SEMI,
    STATE(16310), 1,
      aux_sym_parenthesized_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21282), 2,
      anon_sym_for,
      anon_sym_RPAREN,
  [292631] = 5,
    ACTIONS(9196), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26386), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292648] = 4,
    ACTIONS(26388), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [292663] = 4,
    ACTIONS(26390), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [292678] = 5,
    ACTIONS(9202), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26392), 1,
      anon_sym_COMMA,
    STATE(16121), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292695] = 4,
    ACTIONS(26396), 1,
      sym__command_end,
    STATE(16354), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26394), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [292710] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26398), 1,
      anon_sym_COMMA,
    ACTIONS(26400), 1,
      anon_sym_RPAREN,
    STATE(16519), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292727] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26402), 1,
      anon_sym_COMMA,
    ACTIONS(26404), 1,
      anon_sym_RPAREN,
    STATE(16583), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292744] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26406), 1,
      anon_sym_COMMA,
    ACTIONS(26408), 1,
      anon_sym_RPAREN,
    STATE(16359), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292761] = 5,
    ACTIONS(9274), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26410), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292778] = 5,
    ACTIONS(9202), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26392), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292795] = 5,
    ACTIONS(10034), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19803), 1,
      anon_sym_COMMA,
    STATE(15506), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292812] = 5,
    ACTIONS(10402), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26412), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292829] = 5,
    ACTIONS(9300), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26414), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292846] = 5,
    ACTIONS(10366), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19971), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292863] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(540), 2,
      sym_interpolation_expression,
      sym_identifier,
  [292878] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(452), 2,
      sym_interpolation_expression,
      sym_identifier,
  [292893] = 5,
    ACTIONS(9092), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26416), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292910] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16245), 2,
      sym_interpolation_expression,
      sym_identifier,
  [292925] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(435), 2,
      sym_interpolation_expression,
      sym_identifier,
  [292940] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26418), 1,
      anon_sym_LF,
    ACTIONS(26420), 1,
      aux_sym__terminator_token1,
    STATE(16336), 1,
      aux_sym_let_statement_repeat1,
  [292959] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26422), 1,
      anon_sym_COMMA,
    ACTIONS(26424), 1,
      anon_sym_RPAREN,
    STATE(16544), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [292976] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26426), 1,
      anon_sym_RBRACK,
    ACTIONS(26428), 1,
      anon_sym_LF,
    ACTIONS(26430), 1,
      aux_sym__terminator_token1,
    STATE(16370), 1,
      aux_sym_matrix_expression_repeat1,
  [292995] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15305), 1,
      sym_catch_clause,
    STATE(16673), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293012] = 5,
    ACTIONS(9096), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20271), 1,
      anon_sym_COMMA,
    STATE(16643), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293029] = 5,
    ACTIONS(9278), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26432), 1,
      anon_sym_COMMA,
    STATE(16523), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293046] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26434), 1,
      anon_sym_LF,
    ACTIONS(26436), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [293065] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26438), 1,
      anon_sym_LF,
    ACTIONS(26440), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [293084] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15197), 1,
      sym_catch_clause,
    STATE(17074), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293101] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5750), 1,
      anon_sym_RBRACK,
    ACTIONS(26442), 1,
      anon_sym_LF,
    ACTIONS(26444), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [293120] = 4,
    ACTIONS(20373), 1,
      anon_sym_RPAREN,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26446), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [293135] = 5,
    ACTIONS(9892), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26449), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293152] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26451), 1,
      anon_sym_COMMA,
    ACTIONS(26453), 1,
      anon_sym_RPAREN,
    STATE(16099), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293169] = 4,
    ACTIONS(26457), 1,
      sym__string_end,
    STATE(16375), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26455), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [293184] = 4,
    ACTIONS(26461), 1,
      sym__command_end,
    STATE(16376), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26459), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [293199] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26463), 1,
      anon_sym_COMMA,
    ACTIONS(26465), 1,
      anon_sym_RPAREN,
    STATE(16378), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293216] = 5,
    ACTIONS(9278), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26432), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293233] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(590), 2,
      sym_interpolation_expression,
      sym_identifier,
  [293248] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(415), 2,
      sym_interpolation_expression,
      sym_identifier,
  [293263] = 5,
    ACTIONS(8900), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26467), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293280] = 5,
    ACTIONS(9676), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26469), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293297] = 4,
    ACTIONS(26471), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [293312] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14440), 2,
      sym_interpolation_expression,
      sym_identifier,
  [293327] = 5,
    ACTIONS(9630), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19672), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293344] = 4,
    ACTIONS(26475), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [293359] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15590), 2,
      sym_interpolation_expression,
      sym_identifier,
  [293374] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(426), 2,
      sym_interpolation_expression,
      sym_identifier,
  [293389] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26477), 1,
      anon_sym_LF,
    ACTIONS(26479), 1,
      aux_sym__terminator_token1,
    STATE(16364), 1,
      aux_sym_let_statement_repeat1,
  [293408] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(26481), 1,
      anon_sym_RPAREN,
    ACTIONS(26483), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293425] = 5,
    ACTIONS(10412), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26485), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293442] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15270), 1,
      sym_catch_clause,
    STATE(16871), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293459] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13249), 1,
      aux_sym__terminator_token1,
    ACTIONS(18118), 1,
      anon_sym_EQ,
    ACTIONS(13247), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
  [293476] = 5,
    ACTIONS(8872), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20267), 1,
      anon_sym_COMMA,
    STATE(16557), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293493] = 5,
    ACTIONS(10420), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26487), 1,
      anon_sym_COMMA,
    STATE(16382), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293510] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26489), 1,
      anon_sym_LF,
    ACTIONS(26491), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [293529] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26493), 1,
      anon_sym_LF,
    ACTIONS(26495), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [293548] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15376), 1,
      sym_catch_clause,
    STATE(16677), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293565] = 5,
    ACTIONS(10420), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26487), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293582] = 5,
    ACTIONS(9850), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19736), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293599] = 5,
    ACTIONS(8848), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19724), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293616] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5426), 1,
      anon_sym_RBRACK,
    ACTIONS(26497), 1,
      anon_sym_LF,
    ACTIONS(26499), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [293635] = 5,
    ACTIONS(8814), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26501), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293652] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(26503), 1,
      anon_sym_RPAREN,
    ACTIONS(26505), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293669] = 5,
    ACTIONS(9174), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20249), 1,
      anon_sym_COMMA,
    STATE(15556), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293686] = 5,
    ACTIONS(9846), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26507), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293703] = 4,
    ACTIONS(26509), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [293718] = 4,
    ACTIONS(26511), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [293733] = 5,
    ACTIONS(8872), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20267), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293750] = 5,
    ACTIONS(9686), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26513), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293767] = 5,
    ACTIONS(9694), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26515), 1,
      anon_sym_COMMA,
    STATE(16414), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293784] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(654), 2,
      sym_interpolation_expression,
      sym_identifier,
  [293799] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(430), 2,
      sym_interpolation_expression,
      sym_identifier,
  [293814] = 5,
    ACTIONS(10428), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26517), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293831] = 5,
    ACTIONS(9694), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26515), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293848] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15795), 2,
      sym_interpolation_expression,
      sym_identifier,
  [293863] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(431), 2,
      sym_interpolation_expression,
      sym_identifier,
  [293878] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26519), 1,
      anon_sym_LF,
    ACTIONS(26521), 1,
      aux_sym__terminator_token1,
    STATE(16389), 1,
      aux_sym_let_statement_repeat1,
  [293897] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15271), 1,
      sym_catch_clause,
    STATE(16724), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293914] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(4968), 1,
      anon_sym_RBRACK,
    ACTIONS(26523), 1,
      anon_sym_LF,
    ACTIONS(26525), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [293933] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26527), 1,
      anon_sym_LF,
    ACTIONS(26529), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [293952] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26531), 1,
      anon_sym_LF,
    ACTIONS(26533), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [293971] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15334), 1,
      sym_catch_clause,
    STATE(17260), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [293988] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5516), 1,
      anon_sym_RBRACK,
    ACTIONS(26535), 1,
      anon_sym_LF,
    ACTIONS(26537), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [294007] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25792), 4,
      sym__string_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [294018] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(25806), 4,
      sym__string_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [294029] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15186), 1,
      sym_catch_clause,
    STATE(17149), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294046] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26539), 1,
      anon_sym_COMMA,
    ACTIONS(26541), 1,
      anon_sym_RPAREN,
    STATE(16566), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294063] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(723), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294078] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(434), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294093] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26543), 1,
      anon_sym_RBRACK,
    ACTIONS(26545), 1,
      anon_sym_LF,
    ACTIONS(26547), 1,
      aux_sym__terminator_token1,
    STATE(16481), 1,
      aux_sym_matrix_expression_repeat1,
  [294112] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16122), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294127] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(463), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294142] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26549), 1,
      anon_sym_LF,
    ACTIONS(26551), 1,
      aux_sym__terminator_token1,
    STATE(16405), 1,
      aux_sym_let_statement_repeat1,
  [294161] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15444), 1,
      sym_catch_clause,
    STATE(16906), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294178] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26553), 1,
      anon_sym_RBRACK,
    ACTIONS(26555), 1,
      anon_sym_LF,
    ACTIONS(26557), 1,
      aux_sym__terminator_token1,
    STATE(15934), 1,
      aux_sym_matrix_expression_repeat1,
  [294197] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26559), 1,
      anon_sym_LF,
    ACTIONS(26561), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [294216] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26563), 1,
      anon_sym_LF,
    ACTIONS(26565), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [294235] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15191), 1,
      sym_catch_clause,
    STATE(16974), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294252] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26567), 1,
      anon_sym_RBRACK,
    ACTIONS(26569), 1,
      anon_sym_LF,
    ACTIONS(26571), 1,
      aux_sym__terminator_token1,
    STATE(16496), 1,
      aux_sym_matrix_expression_repeat1,
  [294271] = 4,
    ACTIONS(26311), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26573), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [294286] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26576), 1,
      anon_sym_RBRACK,
    ACTIONS(26578), 1,
      anon_sym_LF,
    ACTIONS(26580), 1,
      aux_sym__terminator_token1,
    STATE(16444), 1,
      aux_sym_matrix_expression_repeat1,
  [294305] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6158), 1,
      anon_sym_RBRACK,
    ACTIONS(26582), 1,
      anon_sym_LF,
    ACTIONS(26584), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [294324] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(768), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294339] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(439), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294354] = 5,
    ACTIONS(9702), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26586), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294371] = 4,
    ACTIONS(26590), 1,
      sym__string_end,
    STATE(16492), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26588), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [294386] = 4,
    ACTIONS(26594), 1,
      sym__command_end,
    STATE(16493), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26592), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [294401] = 4,
    ACTIONS(26596), 1,
      anon_sym_COMMA,
    STATE(16417), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21394), 2,
      anon_sym_for,
      anon_sym_RPAREN,
  [294416] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16240), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294431] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(442), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294446] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26599), 1,
      anon_sym_LF,
    ACTIONS(26601), 1,
      aux_sym__terminator_token1,
    STATE(16423), 1,
      aux_sym_let_statement_repeat1,
  [294465] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15256), 1,
      sym_catch_clause,
    STATE(17315), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294482] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26603), 1,
      anon_sym_RBRACK,
    ACTIONS(26605), 1,
      anon_sym_LF,
    ACTIONS(26607), 1,
      aux_sym__terminator_token1,
    STATE(15557), 1,
      aux_sym_matrix_expression_repeat1,
  [294501] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26609), 1,
      anon_sym_LF,
    ACTIONS(26611), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [294520] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26613), 1,
      anon_sym_LF,
    ACTIONS(26615), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [294539] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15276), 1,
      sym_catch_clause,
    STATE(16705), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294556] = 4,
    ACTIONS(26619), 1,
      sym__string_end,
    STATE(16457), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26617), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [294571] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(26621), 1,
      anon_sym_end,
    ACTIONS(26623), 1,
      sym__immediate_brace,
    STATE(19142), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294588] = 4,
    ACTIONS(26627), 1,
      sym__command_end,
    STATE(16459), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26625), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [294603] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(536), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294618] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(444), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294633] = 5,
    ACTIONS(9706), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19692), 1,
      anon_sym_COMMA,
    STATE(16582), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294650] = 4,
    ACTIONS(26629), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [294665] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16427), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294680] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(447), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294695] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26631), 1,
      anon_sym_LF,
    ACTIONS(26633), 1,
      aux_sym__terminator_token1,
    STATE(16438), 1,
      aux_sym_let_statement_repeat1,
  [294714] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15464), 1,
      sym_catch_clause,
    STATE(16916), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294731] = 4,
    ACTIONS(26635), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [294746] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26637), 1,
      anon_sym_LF,
    ACTIONS(26639), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [294765] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26641), 1,
      anon_sym_LF,
    ACTIONS(26643), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [294784] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15367), 1,
      sym_catch_clause,
    STATE(16655), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294801] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5190), 1,
      anon_sym_RBRACK,
    ACTIONS(26645), 1,
      anon_sym_LF,
    ACTIONS(26647), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [294820] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17912), 1,
      aux_sym__terminator_token1,
    ACTIONS(17914), 1,
      anon_sym_LF,
    ACTIONS(26649), 1,
      anon_sym_COMMA,
    STATE(16442), 1,
      aux_sym__do_parameter_list_repeat1,
  [294839] = 4,
    ACTIONS(26654), 1,
      sym__string_end,
    STATE(16507), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26652), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [294854] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5768), 1,
      anon_sym_RBRACK,
    ACTIONS(26656), 1,
      anon_sym_LF,
    ACTIONS(26658), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [294873] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(553), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294888] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(413), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294903] = 4,
    ACTIONS(26660), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [294918] = 4,
    ACTIONS(26664), 1,
      sym__command_end,
    STATE(16511), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26662), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [294933] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16556), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294948] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(416), 2,
      sym_interpolation_expression,
      sym_identifier,
  [294963] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26666), 1,
      anon_sym_LF,
    ACTIONS(26668), 1,
      aux_sym__terminator_token1,
    STATE(16454), 1,
      aux_sym_let_statement_repeat1,
  [294982] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15408), 1,
      sym_catch_clause,
    STATE(17194), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [294999] = 4,
    ACTIONS(26670), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295014] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26672), 1,
      anon_sym_LF,
    ACTIONS(26674), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [295033] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26676), 1,
      anon_sym_LF,
    ACTIONS(26678), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [295052] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15459), 1,
      sym_catch_clause,
    STATE(17306), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295069] = 4,
    ACTIONS(26680), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295084] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26682), 1,
      anon_sym_COMMA,
    ACTIONS(26684), 1,
      anon_sym_RPAREN,
    STATE(16502), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295101] = 4,
    ACTIONS(26686), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295116] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26688), 1,
      anon_sym_COMMA,
    ACTIONS(26690), 1,
      anon_sym_RPAREN,
    STATE(16517), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295133] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(571), 2,
      sym_interpolation_expression,
      sym_identifier,
  [295148] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(418), 2,
      sym_interpolation_expression,
      sym_identifier,
  [295163] = 5,
    ACTIONS(9102), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26692), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295180] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(26694), 1,
      anon_sym_RPAREN,
    ACTIONS(26696), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295197] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15574), 2,
      sym_interpolation_expression,
      sym_identifier,
  [295212] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(420), 2,
      sym_interpolation_expression,
      sym_identifier,
  [295227] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26698), 1,
      anon_sym_LF,
    ACTIONS(26700), 1,
      aux_sym__terminator_token1,
    STATE(16470), 1,
      aux_sym_let_statement_repeat1,
  [295246] = 5,
    ACTIONS(9054), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20259), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295263] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15259), 1,
      sym_catch_clause,
    STATE(16693), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295280] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26702), 1,
      anon_sym_LF,
    ACTIONS(26704), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [295299] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26706), 1,
      anon_sym_LF,
    ACTIONS(26708), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [295318] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15222), 1,
      sym_catch_clause,
    STATE(17200), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295335] = 5,
    ACTIONS(9902), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26710), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295352] = 5,
    ACTIONS(10042), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26712), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295369] = 5,
    ACTIONS(9908), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26714), 1,
      anon_sym_COMMA,
    STATE(16611), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295386] = 5,
    ACTIONS(9998), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19795), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295403] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26716), 1,
      anon_sym_COMMA,
    ACTIONS(26718), 1,
      anon_sym_RPAREN,
    STATE(15480), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295420] = 4,
    ACTIONS(18328), 1,
      anon_sym_for,
    ACTIONS(22614), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14474), 2,
      sym_if_clause,
      sym_for_clause,
  [295435] = 4,
    ACTIONS(24637), 1,
      sym__word_identifier,
    ACTIONS(24639), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(587), 2,
      sym_interpolation_expression,
      sym_identifier,
  [295450] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(422), 2,
      sym_interpolation_expression,
      sym_identifier,
  [295465] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(4882), 1,
      anon_sym_RBRACK,
    ACTIONS(26720), 1,
      anon_sym_LF,
    ACTIONS(26722), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [295484] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(25728), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15776), 2,
      sym_interpolation_expression,
      sym_identifier,
  [295499] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(424), 2,
      sym_interpolation_expression,
      sym_identifier,
  [295514] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26724), 1,
      anon_sym_LF,
    ACTIONS(26726), 1,
      aux_sym__terminator_token1,
    STATE(16488), 1,
      aux_sym_let_statement_repeat1,
  [295533] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26728), 1,
      anon_sym_RBRACK,
    ACTIONS(26730), 1,
      anon_sym_LF,
    ACTIONS(26732), 1,
      aux_sym__terminator_token1,
    STATE(16500), 1,
      aux_sym_matrix_expression_repeat1,
  [295552] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15180), 1,
      sym_catch_clause,
    STATE(16754), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295569] = 4,
    ACTIONS(26736), 1,
      sym__string_end,
    STATE(16513), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26734), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295584] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26738), 1,
      anon_sym_LF,
    ACTIONS(26740), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [295603] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26742), 1,
      anon_sym_LF,
    ACTIONS(26744), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [295622] = 5,
    ACTIONS(24065), 1,
      anon_sym_catch,
    ACTIONS(24067), 1,
      anon_sym_finally,
    STATE(15425), 1,
      sym_catch_clause,
    STATE(17239), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295639] = 4,
    ACTIONS(26748), 1,
      sym__command_end,
    STATE(16514), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26746), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295654] = 4,
    ACTIONS(26750), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295669] = 4,
    ACTIONS(26752), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295684] = 4,
    ACTIONS(26754), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295699] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26756), 1,
      anon_sym_RBRACK,
    ACTIONS(26758), 1,
      anon_sym_LF,
    ACTIONS(26760), 1,
      aux_sym__terminator_token1,
    STATE(16520), 1,
      aux_sym_matrix_expression_repeat1,
  [295718] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5576), 1,
      anon_sym_RBRACK,
    ACTIONS(26762), 1,
      anon_sym_LF,
    ACTIONS(26764), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [295737] = 4,
    ACTIONS(26766), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295752] = 4,
    ACTIONS(26770), 1,
      sym__string_end,
    STATE(16524), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26768), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295767] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17598), 1,
      anon_sym_COMMA,
    ACTIONS(26772), 1,
      anon_sym_LF,
    ACTIONS(26774), 1,
      aux_sym__terminator_token1,
    STATE(15697), 1,
      aux_sym_let_statement_repeat1,
  [295786] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5786), 1,
      anon_sym_RBRACK,
    ACTIONS(26776), 1,
      anon_sym_LF,
    ACTIONS(26778), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [295805] = 4,
    ACTIONS(26782), 1,
      sym__command_end,
    STATE(16525), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26780), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295820] = 5,
    ACTIONS(9114), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26784), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295837] = 5,
    ACTIONS(9120), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26786), 1,
      anon_sym_COMMA,
    STATE(16515), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295854] = 5,
    ACTIONS(9120), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26786), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295871] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26788), 1,
      anon_sym_COMMA,
    ACTIONS(26790), 1,
      anon_sym_RPAREN,
    STATE(16527), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295888] = 5,
    ACTIONS(9908), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26714), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295905] = 4,
    ACTIONS(26792), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295920] = 5,
    ACTIONS(9712), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26794), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295937] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26796), 1,
      anon_sym_COMMA,
    ACTIONS(26798), 1,
      anon_sym_RPAREN,
    STATE(15568), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295954] = 5,
    ACTIONS(9666), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19678), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [295971] = 4,
    ACTIONS(26800), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [295986] = 4,
    ACTIONS(25716), 1,
      sym__word_identifier,
    ACTIONS(25718), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(429), 2,
      sym_interpolation_expression,
      sym_identifier,
  [296001] = 4,
    ACTIONS(26802), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296016] = 4,
    ACTIONS(26804), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296031] = 5,
    ACTIONS(9130), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26806), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296048] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14439), 2,
      sym_interpolation_expression,
      sym_identifier,
  [296063] = 5,
    ACTIONS(10052), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26808), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296080] = 5,
    ACTIONS(9134), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20281), 1,
      anon_sym_COMMA,
    STATE(16320), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296097] = 5,
    ACTIONS(8912), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26810), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296114] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5438), 1,
      anon_sym_RBRACK,
    ACTIONS(26812), 1,
      anon_sym_LF,
    ACTIONS(26814), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [296133] = 5,
    ACTIONS(8920), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26816), 1,
      anon_sym_COMMA,
    STATE(16610), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296150] = 5,
    ACTIONS(10060), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26818), 1,
      anon_sym_COMMA,
    STATE(16570), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296167] = 5,
    ACTIONS(9288), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26820), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296184] = 4,
    ACTIONS(26822), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296199] = 4,
    ACTIONS(26824), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296214] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(20623), 1,
      ts_builtin_sym_end,
    ACTIONS(20625), 1,
      anon_sym_LF,
    ACTIONS(20629), 1,
      aux_sym__terminator_token1,
    STATE(15805), 1,
      aux_sym__block_repeat1,
  [296233] = 5,
    ACTIONS(9722), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26826), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296250] = 5,
    ACTIONS(9728), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26828), 1,
      anon_sym_COMMA,
    STATE(16536), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296267] = 5,
    ACTIONS(9728), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26828), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296284] = 3,
    ACTIONS(26830), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12676), 3,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
  [296297] = 5,
    ACTIONS(10060), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26818), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296314] = 5,
    ACTIONS(8920), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26816), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296331] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26832), 1,
      anon_sym_COMMA,
    ACTIONS(26834), 1,
      anon_sym_RPAREN,
    STATE(15558), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296348] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(17832), 1,
      anon_sym_COMMA,
    ACTIONS(26836), 1,
      anon_sym_LF,
    ACTIONS(26838), 1,
      aux_sym__terminator_token1,
    STATE(16442), 1,
      aux_sym__do_parameter_list_repeat1,
  [296367] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26840), 1,
      anon_sym_COMMA,
    ACTIONS(26842), 1,
      anon_sym_RPAREN,
    STATE(16634), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296384] = 5,
    ACTIONS(9736), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26844), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296401] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26846), 1,
      anon_sym_RBRACK,
    ACTIONS(26848), 1,
      anon_sym_LF,
    ACTIONS(26850), 1,
      aux_sym__terminator_token1,
    STATE(16548), 1,
      aux_sym_matrix_expression_repeat1,
  [296420] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(13247), 1,
      anon_sym_LF,
    ACTIONS(17982), 1,
      anon_sym_EQ,
    ACTIONS(13249), 2,
      anon_sym_end,
      aux_sym__terminator_token1,
  [296437] = 4,
    ACTIONS(26854), 1,
      sym__string_end,
    STATE(16555), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26852), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296452] = 5,
    ACTIONS(9740), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19708), 1,
      anon_sym_COMMA,
    STATE(16648), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296469] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26856), 1,
      anon_sym_COMMA,
    ACTIONS(26858), 1,
      anon_sym_RPAREN,
    STATE(16206), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296486] = 5,
    ACTIONS(9292), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19500), 1,
      anon_sym_COMMA,
    STATE(15742), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296503] = 4,
    ACTIONS(26862), 1,
      sym__command_end,
    STATE(16559), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26860), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296518] = 5,
    ACTIONS(8826), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26864), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296535] = 4,
    ACTIONS(26866), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296550] = 5,
    ACTIONS(9808), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26868), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296567] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26870), 1,
      anon_sym_RBRACK,
    ACTIONS(26872), 1,
      anon_sym_LF,
    ACTIONS(26874), 1,
      aux_sym__terminator_token1,
    STATE(16597), 1,
      aux_sym_matrix_expression_repeat1,
  [296586] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5804), 1,
      anon_sym_RBRACK,
    ACTIONS(26876), 1,
      anon_sym_LF,
    ACTIONS(26878), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [296605] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(26880), 1,
      anon_sym_end,
    ACTIONS(26882), 1,
      sym__immediate_brace,
    STATE(19394), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296622] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26884), 1,
      anon_sym_COMMA,
    ACTIONS(26886), 1,
      anon_sym_RPAREN,
    STATE(15605), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296639] = 5,
    ACTIONS(8858), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26888), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296656] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26890), 1,
      anon_sym_COMMA,
    ACTIONS(26892), 1,
      anon_sym_RPAREN,
    STATE(15547), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296673] = 4,
    ACTIONS(26896), 1,
      sym__string_end,
    STATE(16602), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26894), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296688] = 4,
    ACTIONS(26900), 1,
      sym__command_end,
    STATE(16605), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26898), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296703] = 4,
    ACTIONS(26902), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296718] = 5,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(26904), 1,
      anon_sym_end,
    ACTIONS(26906), 1,
      sym__immediate_brace,
    STATE(19696), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296735] = 5,
    ACTIONS(8834), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(24031), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296752] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26908), 1,
      anon_sym_RBRACK,
    ACTIONS(26910), 1,
      anon_sym_LF,
    ACTIONS(26912), 1,
      aux_sym__terminator_token1,
    STATE(16571), 1,
      aux_sym_matrix_expression_repeat1,
  [296771] = 4,
    ACTIONS(26914), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296786] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26916), 1,
      anon_sym_COMMA,
    ACTIONS(26918), 1,
      anon_sym_RPAREN,
    STATE(15825), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296803] = 4,
    ACTIONS(26922), 1,
      sym__string_end,
    STATE(16577), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26920), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296818] = 4,
    ACTIONS(26926), 1,
      sym__command_end,
    STATE(16578), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26924), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296833] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26928), 1,
      anon_sym_RBRACK,
    ACTIONS(26930), 1,
      anon_sym_LF,
    ACTIONS(26932), 1,
      aux_sym__terminator_token1,
    STATE(15492), 1,
      aux_sym_matrix_expression_repeat1,
  [296852] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26934), 1,
      anon_sym_COMMA,
    ACTIONS(26936), 1,
      anon_sym_RPAREN,
    STATE(16580), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296869] = 4,
    ACTIONS(26938), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [296884] = 5,
    ACTIONS(9748), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26940), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296901] = 5,
    ACTIONS(8972), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26942), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296918] = 5,
    ACTIONS(9706), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19692), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296935] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(26944), 1,
      anon_sym_RPAREN,
    ACTIONS(26946), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296952] = 5,
    ACTIONS(10068), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26948), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [296969] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5450), 1,
      anon_sym_RBRACK,
    ACTIONS(26950), 1,
      anon_sym_LF,
    ACTIONS(26952), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [296988] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26954), 1,
      anon_sym_COMMA,
    ACTIONS(26956), 1,
      anon_sym_RPAREN,
    STATE(16641), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297005] = 4,
    ACTIONS(26958), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297020] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26960), 1,
      anon_sym_COMMA,
    ACTIONS(26962), 1,
      anon_sym_RPAREN,
    STATE(15810), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297037] = 5,
    ACTIONS(8642), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20121), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297054] = 5,
    ACTIONS(10072), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19811), 1,
      anon_sym_COMMA,
    STATE(15570), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297071] = 4,
    ACTIONS(26964), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297086] = 4,
    ACTIONS(26966), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297101] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(26968), 1,
      anon_sym_RBRACK,
    ACTIONS(26970), 1,
      anon_sym_LF,
    ACTIONS(26972), 1,
      aux_sym__terminator_token1,
    STATE(16599), 1,
      aux_sym_matrix_expression_repeat1,
  [297120] = 5,
    ACTIONS(9758), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26974), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297137] = 5,
    ACTIONS(9766), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26976), 1,
      anon_sym_COMMA,
    STATE(16598), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297154] = 5,
    ACTIONS(9766), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26976), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297171] = 5,
    ACTIONS(9142), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26978), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297188] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14454), 2,
      sym_interpolation_expression,
      sym_identifier,
  [297203] = 5,
    ACTIONS(24407), 1,
      anon_sym_COMMA,
    ACTIONS(26980), 1,
      anon_sym_RPAREN,
    ACTIONS(26982), 1,
      anon_sym_SEMI,
    STATE(16125), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297220] = 5,
    ACTIONS(8606), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26984), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297237] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26986), 1,
      anon_sym_COMMA,
    ACTIONS(26988), 1,
      anon_sym_RPAREN,
    STATE(16349), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297254] = 4,
    ACTIONS(26226), 1,
      sym__immediate_string_start,
    ACTIONS(26228), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11890), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [297269] = 5,
    ACTIONS(9096), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(20271), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297286] = 4,
    ACTIONS(26992), 1,
      sym__string_end,
    STATE(16606), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26990), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297301] = 4,
    ACTIONS(26996), 1,
      sym__command_end,
    STATE(16608), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26994), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297316] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(26998), 1,
      anon_sym_COMMA,
    ACTIONS(27000), 1,
      anon_sym_RPAREN,
    STATE(15516), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297333] = 4,
    ACTIONS(27004), 1,
      sym__string_end,
    STATE(15675), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27002), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297348] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14457), 2,
      sym_interpolation_expression,
      sym_identifier,
  [297363] = 4,
    ACTIONS(27006), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297378] = 5,
    ACTIONS(9850), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19736), 1,
      anon_sym_COMMA,
    STATE(16506), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297395] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5006), 1,
      anon_sym_RBRACK,
    ACTIONS(27008), 1,
      anon_sym_LF,
    ACTIONS(27010), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [297414] = 5,
    ACTIONS(9774), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27012), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297431] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5816), 1,
      anon_sym_RBRACK,
    ACTIONS(27014), 1,
      anon_sym_LF,
    ACTIONS(27016), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [297450] = 4,
    ACTIONS(27020), 1,
      sym__command_end,
    STATE(15684), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27018), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297465] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14458), 2,
      sym_interpolation_expression,
      sym_identifier,
  [297480] = 4,
    ACTIONS(27022), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297495] = 5,
    ACTIONS(9778), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19718), 1,
      anon_sym_COMMA,
    STATE(16114), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297512] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(27024), 1,
      anon_sym_RBRACK,
    ACTIONS(27026), 1,
      anon_sym_LF,
    ACTIONS(27028), 1,
      aux_sym__terminator_token1,
    STATE(15592), 1,
      aux_sym_matrix_expression_repeat1,
  [297531] = 4,
    ACTIONS(27030), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297546] = 4,
    ACTIONS(27032), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297561] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14459), 2,
      sym_interpolation_expression,
      sym_identifier,
  [297576] = 4,
    ACTIONS(27034), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297591] = 5,
    ACTIONS(27036), 1,
      anon_sym_COMMA,
    ACTIONS(27038), 1,
      anon_sym_RPAREN,
    ACTIONS(27040), 1,
      anon_sym_SEMI,
    STATE(15617), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297608] = 5,
    ACTIONS(8928), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27042), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297625] = 5,
    ACTIONS(9918), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27044), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297642] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27036), 1,
      anon_sym_COMMA,
    ACTIONS(27046), 1,
      anon_sym_RPAREN,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297659] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27048), 1,
      anon_sym_COMMA,
    ACTIONS(27050), 1,
      anon_sym_RPAREN,
    STATE(15723), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297676] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14460), 2,
      sym_interpolation_expression,
      sym_identifier,
  [297691] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(27052), 1,
      anon_sym_RBRACK,
    ACTIONS(27054), 1,
      anon_sym_LF,
    ACTIONS(27056), 1,
      aux_sym__terminator_token1,
    STATE(16638), 1,
      aux_sym_matrix_expression_repeat1,
  [297710] = 5,
    ACTIONS(9922), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19759), 1,
      anon_sym_COMMA,
    STATE(16067), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297727] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14462), 2,
      sym_interpolation_expression,
      sym_identifier,
  [297742] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14463), 2,
      sym_interpolation_expression,
      sym_identifier,
  [297757] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14464), 2,
      sym_interpolation_expression,
      sym_identifier,
  [297772] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(27058), 1,
      anon_sym_RBRACK,
    ACTIONS(27060), 1,
      anon_sym_LF,
    ACTIONS(27062), 1,
      aux_sym__terminator_token1,
    STATE(15490), 1,
      aux_sym_matrix_expression_repeat1,
  [297791] = 5,
    ACTIONS(8932), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19997), 1,
      anon_sym_COMMA,
    STATE(16018), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297808] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14465), 2,
      sym_interpolation_expression,
      sym_identifier,
  [297823] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14466), 2,
      sym_interpolation_expression,
      sym_identifier,
  [297838] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(27064), 1,
      anon_sym_RBRACK,
    ACTIONS(27066), 1,
      anon_sym_LF,
    ACTIONS(27068), 1,
      aux_sym__terminator_token1,
    STATE(16637), 1,
      aux_sym_matrix_expression_repeat1,
  [297857] = 4,
    ACTIONS(22305), 1,
      sym__word_identifier,
    ACTIONS(26473), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14467), 2,
      sym_interpolation_expression,
      sym_identifier,
  [297872] = 4,
    ACTIONS(27072), 1,
      sym__string_end,
    STATE(16652), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27070), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297887] = 4,
    ACTIONS(27076), 1,
      sym__command_end,
    STATE(16653), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27074), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297902] = 4,
    ACTIONS(27080), 1,
      sym__string_end,
    STATE(16639), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27078), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297917] = 4,
    ACTIONS(27084), 1,
      sym__command_end,
    STATE(16640), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27082), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [297932] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(27086), 1,
      anon_sym_RBRACK,
    ACTIONS(27088), 1,
      anon_sym_LF,
    ACTIONS(27090), 1,
      aux_sym__terminator_token1,
    STATE(15757), 1,
      aux_sym_matrix_expression_repeat1,
  [297951] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27092), 1,
      anon_sym_COMMA,
    ACTIONS(27094), 1,
      anon_sym_RPAREN,
    STATE(16646), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297968] = 5,
    ACTIONS(8844), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27096), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [297985] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5606), 1,
      anon_sym_RBRACK,
    ACTIONS(27098), 1,
      anon_sym_LF,
    ACTIONS(27100), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [298004] = 5,
    ACTIONS(9784), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27102), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298021] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(27104), 1,
      anon_sym_RBRACK,
    ACTIONS(27106), 1,
      anon_sym_LF,
    ACTIONS(27109), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [298040] = 5,
    ACTIONS(9740), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19708), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298057] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5834), 1,
      anon_sym_RBRACK,
    ACTIONS(27112), 1,
      anon_sym_LF,
    ACTIONS(27114), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [298076] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5468), 1,
      anon_sym_RBRACK,
    ACTIONS(27116), 1,
      anon_sym_LF,
    ACTIONS(27118), 1,
      aux_sym__terminator_token1,
    STATE(16635), 1,
      aux_sym_matrix_expression_repeat1,
  [298095] = 4,
    ACTIONS(27120), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [298110] = 4,
    ACTIONS(27122), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [298125] = 5,
    ACTIONS(9154), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27124), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298142] = 5,
    ACTIONS(9160), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27126), 1,
      anon_sym_COMMA,
    STATE(15762), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298159] = 5,
    ACTIONS(9160), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27126), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298176] = 5,
    ACTIONS(8848), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(19724), 1,
      anon_sym_COMMA,
    STATE(16532), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298193] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(27128), 1,
      anon_sym_RBRACK,
    ACTIONS(27130), 1,
      anon_sym_LF,
    ACTIONS(27132), 1,
      aux_sym__terminator_token1,
    STATE(15899), 1,
      aux_sym_matrix_expression_repeat1,
  [298212] = 5,
    ACTIONS(9794), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27134), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298229] = 5,
    ACTIONS(9800), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27136), 1,
      anon_sym_COMMA,
    STATE(16546), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298246] = 5,
    ACTIONS(9800), 1,
      anon_sym_RPAREN,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27136), 1,
      anon_sym_COMMA,
    STATE(16340), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298263] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27138), 1,
      anon_sym_COMMA,
    ACTIONS(27140), 1,
      anon_sym_RPAREN,
    STATE(16186), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298280] = 4,
    ACTIONS(27144), 1,
      sym__string_end,
    STATE(15503), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27142), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [298295] = 5,
    ACTIONS(18704), 1,
      anon_sym_SEMI,
    ACTIONS(27146), 1,
      anon_sym_COMMA,
    ACTIONS(27148), 1,
      anon_sym_RPAREN,
    STATE(15721), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298312] = 4,
    ACTIONS(27150), 1,
      sym__string_end,
    STATE(16273), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24041), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [298327] = 4,
    ACTIONS(27152), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [298342] = 4,
    ACTIONS(27154), 1,
      sym__command_end,
    STATE(16409), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24045), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [298357] = 4,
    ACTIONS(24003), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19335), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298371] = 4,
    ACTIONS(9456), 1,
      anon_sym_RBRACE,
    ACTIONS(27158), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298385] = 4,
    ACTIONS(10828), 1,
      anon_sym_RBRACE,
    ACTIONS(27160), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298399] = 4,
    ACTIONS(10696), 1,
      anon_sym_RPAREN,
    ACTIONS(21646), 1,
      anon_sym_COMMA,
    STATE(16687), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298413] = 4,
    ACTIONS(10128), 1,
      anon_sym_RPAREN,
    ACTIONS(27162), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298427] = 4,
    ACTIONS(10932), 1,
      anon_sym_RPAREN,
    ACTIONS(27164), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298441] = 4,
    ACTIONS(10962), 1,
      anon_sym_RPAREN,
    ACTIONS(27166), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298455] = 4,
    ACTIONS(10908), 1,
      anon_sym_RPAREN,
    ACTIONS(27168), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298469] = 4,
    ACTIONS(10462), 1,
      anon_sym_RPAREN,
    ACTIONS(27170), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298483] = 4,
    ACTIONS(10624), 1,
      anon_sym_RBRACK,
    ACTIONS(27172), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298497] = 4,
    ACTIONS(10698), 1,
      anon_sym_RBRACK,
    ACTIONS(27174), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298511] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(27178), 1,
      anon_sym_LF,
    ACTIONS(27176), 2,
      anon_sym_RBRACK,
      aux_sym__terminator_token1,
  [298525] = 4,
    ACTIONS(9068), 1,
      anon_sym_RBRACK,
    ACTIONS(27180), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298539] = 4,
    ACTIONS(21556), 1,
      anon_sym_COMMA,
    ACTIONS(21558), 1,
      anon_sym_RBRACE,
    STATE(16746), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298553] = 3,
    ACTIONS(27182), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5830), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [298565] = 4,
    ACTIONS(21114), 1,
      anon_sym_COMMA,
    ACTIONS(21116), 1,
      anon_sym_RBRACE,
    STATE(16833), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298579] = 4,
    ACTIONS(9070), 1,
      anon_sym_RBRACE,
    ACTIONS(27184), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298593] = 3,
    ACTIONS(27186), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6618), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [298605] = 4,
    ACTIONS(23975), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19065), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298619] = 4,
    ACTIONS(9236), 1,
      anon_sym_RPAREN,
    ACTIONS(27188), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298633] = 4,
    ACTIONS(10700), 1,
      anon_sym_RBRACE,
    ACTIONS(27190), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298647] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23975), 1,
      anon_sym_end,
    STATE(19065), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298661] = 4,
    ACTIONS(24005), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19554), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298675] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27192), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [298685] = 4,
    ACTIONS(12004), 1,
      anon_sym_RPAREN,
    ACTIONS(18578), 1,
      sym__word_identifier,
    STATE(11489), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298699] = 4,
    ACTIONS(10626), 1,
      anon_sym_RBRACE,
    ACTIONS(27194), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298713] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24005), 1,
      anon_sym_end,
    STATE(19554), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298727] = 4,
    ACTIONS(21690), 1,
      anon_sym_COMMA,
    ACTIONS(21692), 1,
      anon_sym_RBRACE,
    STATE(16698), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298741] = 4,
    ACTIONS(12008), 1,
      anon_sym_RPAREN,
    ACTIONS(18578), 1,
      sym__word_identifier,
    STATE(11507), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298755] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(27196), 1,
      anon_sym_end,
    STATE(19331), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298769] = 4,
    ACTIONS(9832), 1,
      anon_sym_RPAREN,
    ACTIONS(27198), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298783] = 4,
    ACTIONS(10534), 1,
      anon_sym_RBRACE,
    ACTIONS(27200), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298797] = 4,
    ACTIONS(10948), 1,
      anon_sym_RPAREN,
    ACTIONS(27202), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298811] = 4,
    ACTIONS(27204), 1,
      sym__immediate_paren,
    ACTIONS(27206), 1,
      sym__immediate_bracket,
    ACTIONS(27208), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298825] = 4,
    ACTIONS(10844), 1,
      anon_sym_RPAREN,
    ACTIONS(21678), 1,
      anon_sym_COMMA,
    STATE(16709), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298839] = 4,
    ACTIONS(9304), 1,
      anon_sym_RBRACK,
    ACTIONS(27210), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298853] = 4,
    ACTIONS(9490), 1,
      anon_sym_RPAREN,
    ACTIONS(21536), 1,
      anon_sym_COMMA,
    STATE(17129), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298867] = 3,
    ACTIONS(27212), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4968), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [298879] = 4,
    ACTIONS(23959), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18436), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298893] = 4,
    ACTIONS(9894), 1,
      anon_sym_RPAREN,
    ACTIONS(21418), 1,
      anon_sym_COMMA,
    STATE(16966), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298907] = 4,
    ACTIONS(10846), 1,
      anon_sym_RBRACK,
    ACTIONS(27214), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298921] = 4,
    ACTIONS(10586), 1,
      anon_sym_RPAREN,
    ACTIONS(21496), 1,
      anon_sym_COMMA,
    STATE(16817), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298935] = 3,
    ACTIONS(27216), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7825), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [298947] = 4,
    ACTIONS(10848), 1,
      anon_sym_RBRACE,
    ACTIONS(27218), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298961] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18997), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [298975] = 3,
    ACTIONS(27220), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6009), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [298987] = 4,
    ACTIONS(27222), 1,
      sym__immediate_paren,
    ACTIONS(27224), 1,
      sym__immediate_bracket,
    ACTIONS(27226), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299001] = 4,
    ACTIONS(23947), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18920), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299015] = 4,
    ACTIONS(9156), 1,
      anon_sym_RPAREN,
    ACTIONS(27228), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299029] = 4,
    ACTIONS(10940), 1,
      anon_sym_RPAREN,
    ACTIONS(27230), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299043] = 4,
    ACTIONS(23965), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18725), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299057] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(27232), 1,
      anon_sym_end,
    STATE(18905), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299071] = 4,
    ACTIONS(21432), 1,
      anon_sym_COMMA,
    ACTIONS(21434), 1,
      anon_sym_RBRACE,
    STATE(16760), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299085] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23959), 1,
      anon_sym_end,
    STATE(18436), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299099] = 4,
    ACTIONS(10964), 1,
      anon_sym_RPAREN,
    ACTIONS(27234), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299113] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23965), 1,
      anon_sym_end,
    STATE(18725), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299127] = 4,
    ACTIONS(23967), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19472), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299141] = 4,
    ACTIONS(9380), 1,
      anon_sym_RBRACK,
    ACTIONS(27236), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299155] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23967), 1,
      anon_sym_end,
    STATE(19472), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299169] = 4,
    ACTIONS(9970), 1,
      anon_sym_RPAREN,
    ACTIONS(21634), 1,
      anon_sym_COMMA,
    STATE(16773), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299183] = 3,
    ACTIONS(27238), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5023), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [299195] = 4,
    ACTIONS(9388), 1,
      anon_sym_RPAREN,
    ACTIONS(27240), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299209] = 3,
    ACTIONS(27242), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10632), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [299221] = 4,
    ACTIONS(10684), 1,
      anon_sym_RPAREN,
    ACTIONS(27244), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299235] = 4,
    ACTIONS(10278), 1,
      anon_sym_RPAREN,
    ACTIONS(27246), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299249] = 3,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11736), 2,
      sym_scoped_identifier,
      sym_identifier,
  [299261] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(27248), 1,
      anon_sym_end,
    STATE(19346), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299275] = 4,
    ACTIONS(23951), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19652), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299289] = 3,
    ACTIONS(27250), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6746), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [299301] = 4,
    ACTIONS(23963), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19038), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299315] = 3,
    ACTIONS(27252), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7084), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [299327] = 4,
    ACTIONS(23949), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19744), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299341] = 4,
    ACTIONS(9612), 1,
      anon_sym_RPAREN,
    ACTIONS(27254), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299355] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(27256), 1,
      anon_sym_end,
    STATE(19453), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299369] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(27258), 1,
      anon_sym_end,
    STATE(18760), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299383] = 4,
    ACTIONS(10404), 1,
      anon_sym_RPAREN,
    ACTIONS(21398), 1,
      anon_sym_COMMA,
    STATE(16795), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299397] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23963), 1,
      anon_sym_end,
    STATE(19038), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299411] = 3,
    ACTIONS(27260), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7164), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [299423] = 4,
    ACTIONS(21702), 1,
      anon_sym_COMMA,
    ACTIONS(21704), 1,
      anon_sym_RBRACE,
    STATE(16747), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299437] = 4,
    ACTIONS(10588), 1,
      anon_sym_RBRACK,
    ACTIONS(27262), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299451] = 4,
    ACTIONS(27264), 1,
      sym__immediate_paren,
    ACTIONS(27266), 1,
      sym__immediate_bracket,
    ACTIONS(27268), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299465] = 3,
    ACTIONS(27270), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11877), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [299477] = 4,
    ACTIONS(9346), 1,
      anon_sym_RBRACE,
    ACTIONS(27272), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299491] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(27274), 1,
      anon_sym_end,
    STATE(18778), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299505] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23951), 1,
      anon_sym_end,
    STATE(19652), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299519] = 4,
    ACTIONS(10862), 1,
      anon_sym_RPAREN,
    ACTIONS(21688), 1,
      anon_sym_COMMA,
    STATE(16763), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299533] = 4,
    ACTIONS(21626), 1,
      anon_sym_COMMA,
    ACTIONS(21628), 1,
      anon_sym_RBRACE,
    STATE(16780), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299547] = 4,
    ACTIONS(21354), 1,
      anon_sym_COMMA,
    ACTIONS(21356), 1,
      anon_sym_RBRACE,
    STATE(16860), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299561] = 4,
    ACTIONS(10864), 1,
      anon_sym_RBRACK,
    ACTIONS(27276), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299575] = 4,
    ACTIONS(27278), 1,
      sym__immediate_paren,
    ACTIONS(27280), 1,
      sym__immediate_bracket,
    ACTIONS(27282), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299589] = 4,
    ACTIONS(9452), 1,
      anon_sym_RPAREN,
    ACTIONS(21146), 1,
      anon_sym_COMMA,
    STATE(16659), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299603] = 4,
    ACTIONS(10590), 1,
      anon_sym_RBRACE,
    ACTIONS(27284), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299617] = 4,
    ACTIONS(10866), 1,
      anon_sym_RBRACE,
    ACTIONS(27286), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299631] = 4,
    ACTIONS(9972), 1,
      anon_sym_RBRACK,
    ACTIONS(27288), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299645] = 4,
    ACTIONS(21376), 1,
      anon_sym_COMMA,
    ACTIONS(21378), 1,
      anon_sym_RBRACE,
    STATE(16803), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299659] = 4,
    ACTIONS(10530), 1,
      anon_sym_RPAREN,
    ACTIONS(21590), 1,
      anon_sym_COMMA,
    STATE(16911), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299673] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19189), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299687] = 4,
    ACTIONS(8904), 1,
      anon_sym_RPAREN,
    ACTIONS(21308), 1,
      anon_sym_COMMA,
    STATE(17134), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299701] = 4,
    ACTIONS(21300), 1,
      anon_sym_COMMA,
    ACTIONS(21302), 1,
      anon_sym_RBRACE,
    STATE(16900), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299715] = 4,
    ACTIONS(23906), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18570), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299729] = 4,
    ACTIONS(27290), 1,
      sym__immediate_paren,
    ACTIONS(27292), 1,
      sym__immediate_bracket,
    ACTIONS(27294), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299743] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19197), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299757] = 4,
    ACTIONS(10406), 1,
      anon_sym_RBRACK,
    ACTIONS(27296), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299771] = 4,
    ACTIONS(27298), 1,
      sym__immediate_paren,
    ACTIONS(27300), 1,
      sym__immediate_bracket,
    ACTIONS(27302), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299785] = 4,
    ACTIONS(10712), 1,
      anon_sym_RPAREN,
    ACTIONS(21608), 1,
      anon_sym_COMMA,
    STATE(16790), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299799] = 4,
    ACTIONS(10408), 1,
      anon_sym_RBRACE,
    ACTIONS(27304), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299813] = 4,
    ACTIONS(21370), 1,
      anon_sym_COMMA,
    ACTIONS(21372), 1,
      anon_sym_RBRACE,
    STATE(16785), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299827] = 4,
    ACTIONS(21394), 1,
      anon_sym_RPAREN,
    ACTIONS(27306), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299841] = 4,
    ACTIONS(10966), 1,
      anon_sym_RPAREN,
    ACTIONS(27309), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299855] = 4,
    ACTIONS(9416), 1,
      anon_sym_RPAREN,
    ACTIONS(21368), 1,
      anon_sym_COMMA,
    STATE(16913), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299869] = 4,
    ACTIONS(8982), 1,
      anon_sym_RPAREN,
    ACTIONS(21150), 1,
      anon_sym_COMMA,
    STATE(16674), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299883] = 4,
    ACTIONS(11894), 1,
      anon_sym_RPAREN,
    ACTIONS(27311), 1,
      sym__immediate_string_start,
    ACTIONS(27313), 1,
      sym__immediate_command_start,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299897] = 4,
    ACTIONS(8818), 1,
      anon_sym_RPAREN,
    ACTIONS(21312), 1,
      anon_sym_COMMA,
    STATE(17182), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299911] = 4,
    ACTIONS(9760), 1,
      anon_sym_RPAREN,
    ACTIONS(27315), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299925] = 3,
    ACTIONS(27317), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11218), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [299937] = 4,
    ACTIONS(9678), 1,
      anon_sym_RPAREN,
    ACTIONS(21184), 1,
      anon_sym_COMMA,
    STATE(16820), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299951] = 3,
    ACTIONS(27319), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11168), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [299963] = 4,
    ACTIONS(23906), 1,
      anon_sym_end,
    ACTIONS(23910), 1,
      anon_sym_finally,
    STATE(18570), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299977] = 4,
    ACTIONS(10794), 1,
      anon_sym_RPAREN,
    ACTIONS(27321), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [299991] = 4,
    ACTIONS(9382), 1,
      anon_sym_RBRACE,
    ACTIONS(27323), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300005] = 4,
    ACTIONS(10714), 1,
      anon_sym_RBRACK,
    ACTIONS(27325), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300019] = 4,
    ACTIONS(10118), 1,
      anon_sym_RPAREN,
    ACTIONS(21126), 1,
      anon_sym_COMMA,
    STATE(17247), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300033] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(14993), 1,
      anon_sym_LF,
    ACTIONS(14991), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
  [300047] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(27327), 1,
      anon_sym_end,
    STATE(19877), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300061] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21394), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
  [300071] = 4,
    ACTIONS(10716), 1,
      anon_sym_RBRACE,
    ACTIONS(27329), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300085] = 4,
    ACTIONS(10268), 1,
      anon_sym_RPAREN,
    ACTIONS(21284), 1,
      anon_sym_COMMA,
    STATE(17233), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300099] = 4,
    ACTIONS(21592), 1,
      anon_sym_COMMA,
    ACTIONS(21594), 1,
      anon_sym_RBRACE,
    STATE(16847), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300113] = 4,
    ACTIONS(27331), 1,
      sym__immediate_paren,
    ACTIONS(27333), 1,
      sym__immediate_bracket,
    ACTIONS(27335), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300127] = 3,
    ACTIONS(27337), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6712), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [300139] = 4,
    ACTIONS(8614), 1,
      anon_sym_RBRACE,
    ACTIONS(27339), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300153] = 4,
    ACTIONS(23977), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19245), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300167] = 4,
    ACTIONS(9322), 1,
      anon_sym_RBRACK,
    ACTIONS(27341), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300181] = 3,
    ACTIONS(27343), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11575), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [300193] = 4,
    ACTIONS(21706), 1,
      anon_sym_COMMA,
    ACTIONS(21708), 1,
      anon_sym_RBRACE,
    STATE(16808), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300207] = 4,
    ACTIONS(10950), 1,
      anon_sym_RPAREN,
    ACTIONS(27345), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300221] = 4,
    ACTIONS(10638), 1,
      anon_sym_RPAREN,
    ACTIONS(21554), 1,
      anon_sym_COMMA,
    STATE(16889), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300235] = 4,
    ACTIONS(10880), 1,
      anon_sym_RPAREN,
    ACTIONS(21700), 1,
      anon_sym_COMMA,
    STATE(16823), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300249] = 4,
    ACTIONS(21380), 1,
      anon_sym_COMMA,
    ACTIONS(21382), 1,
      anon_sym_RBRACE,
    STATE(16846), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300263] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19388), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300277] = 4,
    ACTIONS(10918), 1,
      anon_sym_RPAREN,
    ACTIONS(27347), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300291] = 4,
    ACTIONS(27349), 1,
      sym__immediate_paren,
    ACTIONS(27351), 1,
      sym__immediate_bracket,
    ACTIONS(27353), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300305] = 4,
    ACTIONS(9680), 1,
      anon_sym_RBRACK,
    ACTIONS(27355), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300319] = 4,
    ACTIONS(9934), 1,
      anon_sym_RBRACK,
    ACTIONS(27357), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300333] = 3,
    ACTIONS(27359), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5143), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [300345] = 4,
    ACTIONS(21656), 1,
      anon_sym_COMMA,
    ACTIONS(21658), 1,
      anon_sym_RBRACE,
    STATE(17204), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300359] = 4,
    ACTIONS(10882), 1,
      anon_sym_RBRACK,
    ACTIONS(27361), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300373] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(27363), 1,
      anon_sym_end,
    STATE(19619), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300387] = 4,
    ACTIONS(9682), 1,
      anon_sym_RBRACE,
    ACTIONS(27365), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300401] = 4,
    ACTIONS(12094), 1,
      anon_sym_DOT,
    ACTIONS(12096), 1,
      anon_sym_RPAREN,
    ACTIONS(27367), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300415] = 4,
    ACTIONS(9822), 1,
      anon_sym_RPAREN,
    ACTIONS(21426), 1,
      anon_sym_COMMA,
    STATE(16874), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300429] = 3,
    ACTIONS(27369), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10721), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [300441] = 4,
    ACTIONS(10640), 1,
      anon_sym_RBRACK,
    ACTIONS(27371), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300455] = 4,
    ACTIONS(10884), 1,
      anon_sym_RBRACE,
    ACTIONS(27373), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300469] = 4,
    ACTIONS(10270), 1,
      anon_sym_RBRACK,
    ACTIONS(27375), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300483] = 4,
    ACTIONS(21328), 1,
      anon_sym_COMMA,
    ACTIONS(21330), 1,
      anon_sym_RBRACE,
    STATE(16853), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300497] = 4,
    ACTIONS(10304), 1,
      anon_sym_RPAREN,
    ACTIONS(21298), 1,
      anon_sym_COMMA,
    STATE(16869), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300511] = 4,
    ACTIONS(9418), 1,
      anon_sym_RBRACK,
    ACTIONS(27377), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300525] = 4,
    ACTIONS(9896), 1,
      anon_sym_RBRACK,
    ACTIONS(27379), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300539] = 4,
    ACTIONS(10194), 1,
      anon_sym_RPAREN,
    ACTIONS(21186), 1,
      anon_sym_COMMA,
    STATE(16959), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300553] = 4,
    ACTIONS(21286), 1,
      anon_sym_COMMA,
    ACTIONS(21288), 1,
      anon_sym_RBRACE,
    STATE(16863), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300567] = 3,
    ACTIONS(27381), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5459), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [300579] = 4,
    ACTIONS(10936), 1,
      anon_sym_RPAREN,
    ACTIONS(27383), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300593] = 3,
    ACTIONS(27385), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5242), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [300605] = 4,
    ACTIONS(8906), 1,
      anon_sym_RBRACK,
    ACTIONS(27387), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300619] = 4,
    ACTIONS(10498), 1,
      anon_sym_RPAREN,
    ACTIONS(27389), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300633] = 4,
    ACTIONS(9860), 1,
      anon_sym_RPAREN,
    ACTIONS(21374), 1,
      anon_sym_COMMA,
    STATE(16718), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300647] = 4,
    ACTIONS(9306), 1,
      anon_sym_RBRACE,
    ACTIONS(27391), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300661] = 4,
    ACTIONS(10968), 1,
      anon_sym_RPAREN,
    ACTIONS(27393), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300675] = 4,
    ACTIONS(27395), 1,
      sym__immediate_paren,
    ACTIONS(27397), 1,
      sym__immediate_bracket,
    ACTIONS(27399), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300689] = 4,
    ACTIONS(8984), 1,
      anon_sym_RBRACK,
    ACTIONS(27401), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300703] = 3,
    ACTIONS(27403), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11715), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [300715] = 4,
    ACTIONS(27405), 1,
      sym__immediate_paren,
    ACTIONS(27407), 1,
      sym__immediate_bracket,
    ACTIONS(27409), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300729] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23949), 1,
      anon_sym_end,
    STATE(19744), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300743] = 4,
    ACTIONS(8986), 1,
      anon_sym_RBRACE,
    ACTIONS(27411), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300757] = 4,
    ACTIONS(9566), 1,
      anon_sym_RPAREN,
    ACTIONS(21296), 1,
      anon_sym_COMMA,
    STATE(16884), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300771] = 4,
    ACTIONS(21118), 1,
      anon_sym_COMMA,
    ACTIONS(21120), 1,
      anon_sym_RBRACE,
    STATE(17202), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300785] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19212), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300799] = 4,
    ACTIONS(9974), 1,
      anon_sym_RBRACE,
    ACTIONS(27413), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300813] = 4,
    ACTIONS(27415), 1,
      sym__immediate_paren,
    ACTIONS(27417), 1,
      sym__immediate_bracket,
    ACTIONS(27419), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300827] = 4,
    ACTIONS(9898), 1,
      anon_sym_RBRACE,
    ACTIONS(27421), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300841] = 4,
    ACTIONS(9228), 1,
      anon_sym_RBRACK,
    ACTIONS(27423), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300855] = 4,
    ACTIONS(8908), 1,
      anon_sym_RBRACE,
    ACTIONS(27425), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300869] = 4,
    ACTIONS(23979), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19017), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300883] = 4,
    ACTIONS(10306), 1,
      anon_sym_RBRACK,
    ACTIONS(27427), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300897] = 3,
    ACTIONS(27429), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5191), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [300909] = 4,
    ACTIONS(9190), 1,
      anon_sym_RBRACK,
    ACTIONS(27431), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300923] = 4,
    ACTIONS(24001), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19534), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300937] = 3,
    ACTIONS(27433), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11165), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [300949] = 4,
    ACTIONS(8820), 1,
      anon_sym_RBRACK,
    ACTIONS(27435), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300963] = 4,
    ACTIONS(21710), 1,
      anon_sym_COMMA,
    ACTIONS(21712), 1,
      anon_sym_RBRACE,
    STATE(16852), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300977] = 4,
    ACTIONS(10308), 1,
      anon_sym_RBRACE,
    ACTIONS(27437), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [300991] = 4,
    ACTIONS(10642), 1,
      anon_sym_RBRACE,
    ACTIONS(27439), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301005] = 3,
    ACTIONS(18414), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7181), 2,
      sym_scoped_identifier,
      sym_identifier,
  [301017] = 3,
    ACTIONS(27441), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7230), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [301029] = 4,
    ACTIONS(21636), 1,
      anon_sym_COMMA,
    ACTIONS(21638), 1,
      anon_sym_RBRACE,
    STATE(16883), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301043] = 4,
    ACTIONS(21476), 1,
      anon_sym_COMMA,
    ACTIONS(21478), 1,
      anon_sym_RBRACE,
    STATE(16975), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301057] = 4,
    ACTIONS(10896), 1,
      anon_sym_RBRACE,
    ACTIONS(27443), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301071] = 4,
    ACTIONS(9420), 1,
      anon_sym_RBRACE,
    ACTIONS(27445), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301085] = 4,
    ACTIONS(27447), 1,
      sym__immediate_paren,
    ACTIONS(27449), 1,
      sym__immediate_bracket,
    ACTIONS(27451), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301099] = 4,
    ACTIONS(9492), 1,
      anon_sym_RBRACK,
    ACTIONS(27453), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301113] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(27455), 1,
      anon_sym_end,
    STATE(18224), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301127] = 4,
    ACTIONS(9568), 1,
      anon_sym_RBRACK,
    ACTIONS(27457), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301141] = 4,
    ACTIONS(23969), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19277), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301155] = 4,
    ACTIONS(24019), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18177), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301169] = 4,
    ACTIONS(10272), 1,
      anon_sym_RBRACE,
    ACTIONS(27459), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301183] = 3,
    ACTIONS(18378), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11752), 2,
      sym_scoped_identifier,
      sym_identifier,
  [301195] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18280), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301209] = 4,
    ACTIONS(9570), 1,
      anon_sym_RBRACE,
    ACTIONS(27461), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301223] = 4,
    ACTIONS(27463), 1,
      sym__immediate_paren,
    ACTIONS(27465), 1,
      sym__immediate_bracket,
    ACTIONS(27467), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301237] = 3,
    ACTIONS(27469), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5903), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [301249] = 4,
    ACTIONS(21110), 1,
      anon_sym_COMMA,
    ACTIONS(21112), 1,
      anon_sym_RBRACE,
    STATE(16774), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301263] = 4,
    ACTIONS(21444), 1,
      anon_sym_COMMA,
    ACTIONS(21446), 1,
      anon_sym_RBRACE,
    STATE(16912), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301277] = 4,
    ACTIONS(10732), 1,
      anon_sym_RPAREN,
    ACTIONS(21614), 1,
      anon_sym_COMMA,
    STATE(16894), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301291] = 4,
    ACTIONS(10912), 1,
      anon_sym_RPAREN,
    ACTIONS(27471), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301305] = 3,
    ACTIONS(18502), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7134), 2,
      sym_scoped_identifier,
      sym_identifier,
  [301317] = 4,
    ACTIONS(23961), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19285), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301331] = 4,
    ACTIONS(21152), 1,
      anon_sym_COMMA,
    ACTIONS(21154), 1,
      anon_sym_RBRACE,
    STATE(17014), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301345] = 4,
    ACTIONS(21526), 1,
      anon_sym_COMMA,
    ACTIONS(21528), 1,
      anon_sym_RBRACE,
    STATE(17221), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301359] = 4,
    ACTIONS(10646), 1,
      anon_sym_RPAREN,
    ACTIONS(27473), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301373] = 4,
    ACTIONS(21138), 1,
      anon_sym_COMMA,
    ACTIONS(21140), 1,
      anon_sym_RBRACE,
    STATE(16947), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301387] = 3,
    ACTIONS(27475), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11553), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [301399] = 4,
    ACTIONS(10734), 1,
      anon_sym_RBRACK,
    ACTIONS(27477), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301413] = 4,
    ACTIONS(27479), 1,
      sym__immediate_paren,
    ACTIONS(27481), 1,
      sym__immediate_bracket,
    ACTIONS(27483), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301427] = 3,
    ACTIONS(18398), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7656), 2,
      sym_scoped_identifier,
      sym_identifier,
  [301439] = 3,
    ACTIONS(27485), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6372), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [301451] = 4,
    ACTIONS(10196), 1,
      anon_sym_RBRACK,
    ACTIONS(27487), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301465] = 4,
    ACTIONS(21502), 1,
      anon_sym_COMMA,
    ACTIONS(21504), 1,
      anon_sym_RBRACE,
    STATE(16686), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301479] = 4,
    ACTIONS(10736), 1,
      anon_sym_RBRACE,
    ACTIONS(27489), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301493] = 4,
    ACTIONS(10348), 1,
      anon_sym_RPAREN,
    ACTIONS(27491), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301507] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18685), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301521] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(27493), 1,
      anon_sym_end,
    STATE(19679), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301535] = 4,
    ACTIONS(27495), 1,
      sym__immediate_paren,
    ACTIONS(27497), 1,
      sym__immediate_bracket,
    ACTIONS(27499), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301549] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23961), 1,
      anon_sym_end,
    STATE(19285), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301563] = 4,
    ACTIONS(10942), 1,
      anon_sym_RPAREN,
    ACTIONS(27501), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301577] = 4,
    ACTIONS(10436), 1,
      anon_sym_RPAREN,
    ACTIONS(21430), 1,
      anon_sym_COMMA,
    STATE(16933), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301591] = 4,
    ACTIONS(8822), 1,
      anon_sym_RBRACE,
    ACTIONS(27503), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301605] = 3,
    ACTIONS(27505), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10389), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [301617] = 4,
    ACTIONS(21290), 1,
      anon_sym_COMMA,
    ACTIONS(21292), 1,
      anon_sym_RBRACE,
    STATE(17185), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301631] = 4,
    ACTIONS(10952), 1,
      anon_sym_RPAREN,
    ACTIONS(27507), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301645] = 4,
    ACTIONS(21544), 1,
      anon_sym_COMMA,
    ACTIONS(21546), 1,
      anon_sym_RBRACE,
    STATE(17137), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301659] = 4,
    ACTIONS(10120), 1,
      anon_sym_RBRACK,
    ACTIONS(27509), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301673] = 4,
    ACTIONS(21084), 1,
      anon_sym_COMMA,
    ACTIONS(21086), 1,
      anon_sym_RBRACE,
    STATE(16949), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301687] = 4,
    ACTIONS(27511), 1,
      sym__immediate_paren,
    ACTIONS(27513), 1,
      sym__immediate_bracket,
    ACTIONS(27515), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301701] = 4,
    ACTIONS(8586), 1,
      anon_sym_RPAREN,
    ACTIONS(27517), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301715] = 4,
    ACTIONS(10198), 1,
      anon_sym_RBRACE,
    ACTIONS(27519), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301729] = 4,
    ACTIONS(9980), 1,
      anon_sym_RPAREN,
    ACTIONS(27521), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301743] = 3,
    ACTIONS(27523), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6814), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [301755] = 4,
    ACTIONS(23914), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18980), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301769] = 4,
    ACTIONS(9936), 1,
      anon_sym_RBRACE,
    ACTIONS(27525), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301783] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19272), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301797] = 4,
    ACTIONS(24025), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18259), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301811] = 4,
    ACTIONS(27527), 1,
      sym__immediate_paren,
    ACTIONS(27529), 1,
      sym__immediate_bracket,
    ACTIONS(27531), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301825] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24025), 1,
      anon_sym_end,
    STATE(18259), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301839] = 4,
    ACTIONS(8944), 1,
      anon_sym_RPAREN,
    ACTIONS(21436), 1,
      anon_sym_COMMA,
    STATE(16703), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301853] = 4,
    ACTIONS(10438), 1,
      anon_sym_RBRACK,
    ACTIONS(27533), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301867] = 4,
    ACTIONS(10930), 1,
      anon_sym_RPAREN,
    ACTIONS(27535), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301881] = 4,
    ACTIONS(10440), 1,
      anon_sym_RBRACE,
    ACTIONS(27537), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301895] = 4,
    ACTIONS(10054), 1,
      anon_sym_RPAREN,
    ACTIONS(27539), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301909] = 3,
    ACTIONS(27541), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6067), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [301921] = 4,
    ACTIONS(9026), 1,
      anon_sym_RPAREN,
    ACTIONS(21388), 1,
      anon_sym_COMMA,
    STATE(16984), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301935] = 4,
    ACTIONS(24029), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19223), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301949] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24029), 1,
      anon_sym_end,
    STATE(19223), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301963] = 3,
    ACTIONS(27543), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6198), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [301975] = 4,
    ACTIONS(21564), 1,
      anon_sym_COMMA,
    ACTIONS(21566), 1,
      anon_sym_RBRACE,
    STATE(16936), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [301989] = 4,
    ACTIONS(9378), 1,
      anon_sym_RPAREN,
    ACTIONS(21128), 1,
      anon_sym_COMMA,
    STATE(16901), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302003] = 4,
    ACTIONS(27545), 1,
      sym__immediate_paren,
    ACTIONS(27547), 1,
      sym__immediate_bracket,
    ACTIONS(27549), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302017] = 4,
    ACTIONS(21642), 1,
      anon_sym_COMMA,
    ACTIONS(21644), 1,
      anon_sym_RBRACE,
    STATE(16948), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302031] = 4,
    ACTIONS(9494), 1,
      anon_sym_RBRACE,
    ACTIONS(27551), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302045] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(27553), 1,
      anon_sym_end,
    STATE(19127), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302059] = 4,
    ACTIONS(27555), 1,
      sym__immediate_paren,
    ACTIONS(27557), 1,
      sym__immediate_bracket,
    ACTIONS(27559), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302073] = 3,
    ACTIONS(27561), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6597), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [302085] = 4,
    ACTIONS(10084), 1,
      anon_sym_RBRACK,
    ACTIONS(27563), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302099] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19844), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302113] = 3,
    ACTIONS(27565), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4666), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [302125] = 4,
    ACTIONS(27567), 1,
      sym__immediate_paren,
    ACTIONS(27569), 1,
      sym__immediate_bracket,
    ACTIONS(27571), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302139] = 4,
    ACTIONS(21130), 1,
      anon_sym_COMMA,
    ACTIONS(21132), 1,
      anon_sym_RBRACE,
    STATE(17186), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302153] = 4,
    ACTIONS(10750), 1,
      anon_sym_RPAREN,
    ACTIONS(21624), 1,
      anon_sym_COMMA,
    STATE(16958), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302167] = 4,
    ACTIONS(10920), 1,
      anon_sym_RPAREN,
    ACTIONS(27573), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302181] = 3,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12567), 2,
      sym_scoped_identifier,
      sym_identifier,
  [302193] = 4,
    ACTIONS(9106), 1,
      anon_sym_RPAREN,
    ACTIONS(21596), 1,
      anon_sym_COMMA,
    STATE(17058), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302207] = 4,
    ACTIONS(9826), 1,
      anon_sym_RBRACE,
    ACTIONS(27575), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302221] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(26209), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [302231] = 4,
    ACTIONS(8828), 1,
      anon_sym_RPAREN,
    ACTIONS(27577), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302245] = 4,
    ACTIONS(10044), 1,
      anon_sym_RPAREN,
    ACTIONS(21082), 1,
      anon_sym_COMMA,
    STATE(17140), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302259] = 4,
    ACTIONS(23931), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18283), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302273] = 4,
    ACTIONS(24023), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18936), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302287] = 4,
    ACTIONS(9028), 1,
      anon_sym_RBRACK,
    ACTIONS(27579), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302301] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24023), 1,
      anon_sym_end,
    STATE(18936), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302315] = 4,
    ACTIONS(10752), 1,
      anon_sym_RBRACK,
    ACTIONS(27581), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302329] = 3,
    ACTIONS(27583), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5233), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [302341] = 4,
    ACTIONS(27585), 1,
      sym__immediate_paren,
    ACTIONS(27587), 1,
      sym__immediate_bracket,
    ACTIONS(27589), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302355] = 4,
    ACTIONS(9030), 1,
      anon_sym_RBRACE,
    ACTIONS(27591), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302369] = 4,
    ACTIONS(10754), 1,
      anon_sym_RBRACE,
    ACTIONS(27593), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302383] = 4,
    ACTIONS(9230), 1,
      anon_sym_RBRACE,
    ACTIONS(27595), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302397] = 4,
    ACTIONS(10122), 1,
      anon_sym_RBRACE,
    ACTIONS(27597), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302411] = 4,
    ACTIONS(21620), 1,
      anon_sym_COMMA,
    ACTIONS(21622), 1,
      anon_sym_RBRACE,
    STATE(16737), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302425] = 4,
    ACTIONS(21498), 1,
      anon_sym_COMMA,
    ACTIONS(21500), 1,
      anon_sym_RBRACE,
    STATE(17327), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302439] = 4,
    ACTIONS(21402), 1,
      anon_sym_COMMA,
    ACTIONS(21404), 1,
      anon_sym_RBRACE,
    STATE(17028), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302453] = 4,
    ACTIONS(21604), 1,
      anon_sym_COMMA,
    ACTIONS(21606), 1,
      anon_sym_RBRACE,
    STATE(17121), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302467] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19067), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302481] = 4,
    ACTIONS(10548), 1,
      anon_sym_RPAREN,
    ACTIONS(21480), 1,
      anon_sym_COMMA,
    STATE(16660), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302495] = 4,
    ACTIONS(27599), 1,
      sym__immediate_paren,
    ACTIONS(27601), 1,
      sym__immediate_bracket,
    ACTIONS(27603), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302509] = 4,
    ACTIONS(10954), 1,
      anon_sym_RPAREN,
    ACTIONS(27605), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302523] = 4,
    ACTIONS(10906), 1,
      anon_sym_RPAREN,
    ACTIONS(27607), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302537] = 4,
    ACTIONS(23929), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18501), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302551] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27609), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [302561] = 4,
    ACTIONS(9524), 1,
      anon_sym_RPAREN,
    ACTIONS(21722), 1,
      anon_sym_COMMA,
    STATE(16719), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302575] = 4,
    ACTIONS(21568), 1,
      anon_sym_COMMA,
    ACTIONS(21570), 1,
      anon_sym_RBRACE,
    STATE(17157), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302589] = 4,
    ACTIONS(9688), 1,
      anon_sym_RPAREN,
    ACTIONS(27611), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302603] = 3,
    ACTIONS(27613), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8323), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [302615] = 4,
    ACTIONS(10720), 1,
      anon_sym_RPAREN,
    ACTIONS(27615), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302629] = 4,
    ACTIONS(9108), 1,
      anon_sym_RBRACK,
    ACTIONS(27617), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302643] = 4,
    ACTIONS(23971), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18691), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302657] = 4,
    ACTIONS(10338), 1,
      anon_sym_RPAREN,
    ACTIONS(21314), 1,
      anon_sym_COMMA,
    STATE(17102), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302671] = 3,
    ACTIONS(27619), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6306), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [302683] = 4,
    ACTIONS(13148), 1,
      anon_sym_EQ,
    ACTIONS(20337), 1,
      anon_sym_COMMA,
    STATE(17063), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302697] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(27621), 1,
      anon_sym_end,
    STATE(19159), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302711] = 4,
    ACTIONS(27623), 1,
      sym__immediate_paren,
    ACTIONS(27625), 1,
      sym__immediate_bracket,
    ACTIONS(27627), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302725] = 4,
    ACTIONS(23916), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18314), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302739] = 4,
    ACTIONS(9110), 1,
      anon_sym_RBRACE,
    ACTIONS(27629), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302753] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23916), 1,
      anon_sym_end,
    STATE(18314), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302767] = 4,
    ACTIONS(10008), 1,
      anon_sym_RPAREN,
    ACTIONS(21694), 1,
      anon_sym_COMMA,
    STATE(17243), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302781] = 4,
    ACTIONS(21458), 1,
      anon_sym_COMMA,
    ACTIONS(21460), 1,
      anon_sym_RBRACE,
    STATE(17036), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302795] = 4,
    ACTIONS(23918), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18677), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302809] = 4,
    ACTIONS(21156), 1,
      anon_sym_COMMA,
    ACTIONS(21158), 1,
      anon_sym_RBRACE,
    STATE(17224), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302823] = 4,
    ACTIONS(10566), 1,
      anon_sym_RPAREN,
    ACTIONS(21488), 1,
      anon_sym_COMMA,
    STATE(17230), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302837] = 3,
    ACTIONS(27631), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8012), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [302849] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19074), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302863] = 4,
    ACTIONS(9312), 1,
      anon_sym_RPAREN,
    ACTIONS(27633), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302877] = 4,
    ACTIONS(27635), 1,
      sym__immediate_paren,
    ACTIONS(27637), 1,
      sym__immediate_bracket,
    ACTIONS(27639), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302891] = 4,
    ACTIONS(23999), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18213), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302905] = 4,
    ACTIONS(10046), 1,
      anon_sym_RBRACK,
    ACTIONS(27641), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302919] = 4,
    ACTIONS(10454), 1,
      anon_sym_RPAREN,
    ACTIONS(21562), 1,
      anon_sym_COMMA,
    STATE(17119), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302933] = 4,
    ACTIONS(27643), 1,
      sym__immediate_paren,
    ACTIONS(27645), 1,
      sym__immediate_bracket,
    ACTIONS(27647), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302947] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18990), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302961] = 4,
    ACTIONS(27649), 1,
      sym__immediate_paren,
    ACTIONS(27651), 1,
      sym__immediate_bracket,
    ACTIONS(27653), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302975] = 4,
    ACTIONS(10658), 1,
      anon_sym_RPAREN,
    ACTIONS(21578), 1,
      anon_sym_COMMA,
    STATE(17135), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [302989] = 4,
    ACTIONS(10158), 1,
      anon_sym_RPAREN,
    ACTIONS(21148), 1,
      anon_sym_COMMA,
    STATE(17240), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303003] = 4,
    ACTIONS(9226), 1,
      anon_sym_RPAREN,
    ACTIONS(21108), 1,
      anon_sym_COMMA,
    STATE(16964), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303017] = 3,
    ACTIONS(27657), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27655), 2,
      anon_sym_end,
      anon_sym_elseif,
  [303029] = 4,
    ACTIONS(27659), 1,
      sym__immediate_paren,
    ACTIONS(27661), 1,
      sym__immediate_bracket,
    ACTIONS(27663), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303043] = 4,
    ACTIONS(10340), 1,
      anon_sym_RBRACK,
    ACTIONS(27665), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303057] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18357), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303071] = 4,
    ACTIONS(27667), 1,
      sym__immediate_paren,
    ACTIONS(27669), 1,
      sym__immediate_bracket,
    ACTIONS(27671), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303085] = 4,
    ACTIONS(27673), 1,
      sym__immediate_paren,
    ACTIONS(27675), 1,
      sym__immediate_bracket,
    ACTIONS(27677), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303099] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18447), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303113] = 4,
    ACTIONS(27679), 1,
      sym__immediate_paren,
    ACTIONS(27681), 1,
      sym__immediate_bracket,
    ACTIONS(27683), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303127] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23971), 1,
      anon_sym_end,
    STATE(18691), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303141] = 4,
    ACTIONS(27685), 1,
      sym__immediate_paren,
    ACTIONS(27687), 1,
      sym__immediate_bracket,
    ACTIONS(27689), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303155] = 4,
    ACTIONS(21406), 1,
      anon_sym_COMMA,
    ACTIONS(21408), 1,
      anon_sym_RBRACE,
    STATE(17126), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303169] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18508), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303183] = 4,
    ACTIONS(27691), 1,
      sym__immediate_paren,
    ACTIONS(27693), 1,
      sym__immediate_bracket,
    ACTIONS(27695), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303197] = 4,
    ACTIONS(27697), 1,
      sym__immediate_paren,
    ACTIONS(27699), 1,
      sym__immediate_bracket,
    ACTIONS(27701), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303211] = 4,
    ACTIONS(21134), 1,
      anon_sym_COMMA,
    ACTIONS(21136), 1,
      anon_sym_RBRACE,
    STATE(17290), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303225] = 4,
    ACTIONS(10898), 1,
      anon_sym_RPAREN,
    ACTIONS(27703), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303239] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18671), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303253] = 4,
    ACTIONS(27705), 1,
      sym__immediate_paren,
    ACTIONS(27707), 1,
      sym__immediate_bracket,
    ACTIONS(27709), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303267] = 4,
    ACTIONS(27711), 1,
      sym__immediate_paren,
    ACTIONS(27713), 1,
      sym__immediate_bracket,
    ACTIONS(27715), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303281] = 4,
    ACTIONS(10048), 1,
      anon_sym_RBRACE,
    ACTIONS(27717), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303295] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18462), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303309] = 4,
    ACTIONS(27719), 1,
      sym__immediate_paren,
    ACTIONS(27721), 1,
      sym__immediate_bracket,
    ACTIONS(27723), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303323] = 4,
    ACTIONS(27725), 1,
      sym__immediate_paren,
    ACTIONS(27727), 1,
      sym__immediate_bracket,
    ACTIONS(27729), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303337] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19250), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303351] = 4,
    ACTIONS(27731), 1,
      sym__immediate_paren,
    ACTIONS(27733), 1,
      sym__immediate_bracket,
    ACTIONS(27735), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303365] = 4,
    ACTIONS(27737), 1,
      sym__immediate_paren,
    ACTIONS(27739), 1,
      sym__immediate_bracket,
    ACTIONS(27741), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303379] = 4,
    ACTIONS(10456), 1,
      anon_sym_RBRACK,
    ACTIONS(27743), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303393] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19303), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303407] = 4,
    ACTIONS(27745), 1,
      sym__immediate_paren,
    ACTIONS(27747), 1,
      sym__immediate_bracket,
    ACTIONS(27749), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303421] = 4,
    ACTIONS(27751), 1,
      sym__immediate_paren,
    ACTIONS(27753), 1,
      sym__immediate_bracket,
    ACTIONS(27755), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303435] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21282), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [303445] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18159), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303459] = 4,
    ACTIONS(27757), 1,
      sym__immediate_paren,
    ACTIONS(27759), 1,
      sym__immediate_bracket,
    ACTIONS(27761), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303473] = 4,
    ACTIONS(10342), 1,
      anon_sym_RBRACE,
    ACTIONS(27763), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303487] = 4,
    ACTIONS(27765), 1,
      sym__immediate_paren,
    ACTIONS(27767), 1,
      sym__immediate_bracket,
    ACTIONS(27769), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303501] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18394), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303515] = 4,
    ACTIONS(27771), 1,
      sym__immediate_paren,
    ACTIONS(27773), 1,
      sym__immediate_bracket,
    ACTIONS(27775), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303529] = 4,
    ACTIONS(21716), 1,
      anon_sym_COMMA,
    ACTIONS(21718), 1,
      anon_sym_RBRACE,
    STATE(16835), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303543] = 4,
    ACTIONS(27777), 1,
      sym__immediate_paren,
    ACTIONS(27779), 1,
      sym__immediate_bracket,
    ACTIONS(27781), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303557] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18611), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303571] = 4,
    ACTIONS(27783), 1,
      sym__immediate_paren,
    ACTIONS(27785), 1,
      sym__immediate_bracket,
    ACTIONS(27787), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303585] = 4,
    ACTIONS(10458), 1,
      anon_sym_RBRACE,
    ACTIONS(27789), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303599] = 4,
    ACTIONS(27791), 1,
      sym__immediate_paren,
    ACTIONS(27793), 1,
      sym__immediate_bracket,
    ACTIONS(27795), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303613] = 4,
    ACTIONS(10928), 1,
      anon_sym_RPAREN,
    ACTIONS(27797), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303627] = 4,
    ACTIONS(10622), 1,
      anon_sym_RPAREN,
    ACTIONS(21532), 1,
      anon_sym_COMMA,
    STATE(16704), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303641] = 4,
    ACTIONS(27799), 1,
      sym__immediate_paren,
    ACTIONS(27801), 1,
      sym__immediate_bracket,
    ACTIONS(27803), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303655] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24003), 1,
      anon_sym_end,
    STATE(19335), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303669] = 4,
    ACTIONS(27805), 1,
      sym__immediate_paren,
    ACTIONS(27807), 1,
      sym__immediate_bracket,
    ACTIONS(27809), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303683] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19440), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303697] = 4,
    ACTIONS(27811), 1,
      sym__immediate_paren,
    ACTIONS(27813), 1,
      sym__immediate_bracket,
    ACTIONS(27815), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303711] = 4,
    ACTIONS(27817), 1,
      sym__immediate_paren,
    ACTIONS(27819), 1,
      sym__immediate_bracket,
    ACTIONS(27821), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303725] = 3,
    ACTIONS(27823), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5594), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [303737] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19629), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303751] = 4,
    ACTIONS(27825), 1,
      sym__immediate_paren,
    ACTIONS(27827), 1,
      sym__immediate_bracket,
    ACTIONS(27829), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303765] = 4,
    ACTIONS(27831), 1,
      sym__immediate_paren,
    ACTIONS(27833), 1,
      sym__immediate_bracket,
    ACTIONS(27835), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303779] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19842), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303793] = 4,
    ACTIONS(27837), 1,
      sym__immediate_paren,
    ACTIONS(27839), 1,
      sym__immediate_bracket,
    ACTIONS(27841), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303807] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27843), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [303817] = 4,
    ACTIONS(27845), 1,
      sym__immediate_paren,
    ACTIONS(27847), 1,
      sym__immediate_bracket,
    ACTIONS(27849), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303831] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18970), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303845] = 4,
    ACTIONS(27851), 1,
      sym__immediate_paren,
    ACTIONS(27853), 1,
      sym__immediate_bracket,
    ACTIONS(27855), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303859] = 3,
    ACTIONS(18310), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7708), 2,
      sym_scoped_identifier,
      sym_identifier,
  [303871] = 4,
    ACTIONS(27857), 1,
      sym__immediate_paren,
    ACTIONS(27859), 1,
      sym__immediate_bracket,
    ACTIONS(27861), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303885] = 4,
    ACTIONS(9462), 1,
      anon_sym_RPAREN,
    ACTIONS(27863), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303899] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19479), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303913] = 4,
    ACTIONS(27865), 1,
      sym__immediate_paren,
    ACTIONS(27867), 1,
      sym__immediate_bracket,
    ACTIONS(27869), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303927] = 4,
    ACTIONS(21652), 1,
      anon_sym_COMMA,
    ACTIONS(21654), 1,
      anon_sym_RBRACE,
    STATE(17128), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303941] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18528), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303955] = 4,
    ACTIONS(13075), 1,
      anon_sym_EQ,
    ACTIONS(20422), 1,
      anon_sym_COMMA,
    STATE(17063), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303969] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18319), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303983] = 4,
    ACTIONS(9714), 1,
      anon_sym_RPAREN,
    ACTIONS(21310), 1,
      anon_sym_COMMA,
    STATE(17136), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [303997] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19370), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304011] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(27871), 1,
      anon_sym_end,
    STATE(18337), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304025] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18766), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304039] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19386), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304053] = 4,
    ACTIONS(10602), 1,
      anon_sym_RPAREN,
    ACTIONS(21518), 1,
      anon_sym_COMMA,
    STATE(17205), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304067] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19339), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304081] = 4,
    ACTIONS(10660), 1,
      anon_sym_RBRACK,
    ACTIONS(27873), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304095] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18909), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304109] = 4,
    ACTIONS(23927), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19607), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304123] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19779), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304137] = 4,
    ACTIONS(9302), 1,
      anon_sym_RPAREN,
    ACTIONS(21508), 1,
      anon_sym_COMMA,
    STATE(16685), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304151] = 3,
    ACTIONS(27875), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9476), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [304163] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18498), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304177] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(27877), 1,
      anon_sym_end,
    STATE(18346), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304191] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18829), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304205] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(27879), 1,
      anon_sym_end,
    STATE(19389), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304219] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19113), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304233] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19520), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304247] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18724), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304261] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19867), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304275] = 4,
    ACTIONS(21316), 1,
      anon_sym_COMMA,
    ACTIONS(21318), 1,
      anon_sym_RBRACE,
    STATE(17151), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304289] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18584), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304303] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18865), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304317] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19079), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304331] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19312), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304345] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19645), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304359] = 4,
    ACTIONS(10768), 1,
      anon_sym_RPAREN,
    ACTIONS(21632), 1,
      anon_sym_COMMA,
    STATE(17139), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304373] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18191), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304387] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18321), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304401] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(27881), 1,
      anon_sym_end,
    STATE(19420), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304415] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18442), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304429] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18553), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304443] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18657), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304457] = 3,
    ACTIONS(27883), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10977), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [304469] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18788), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304483] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18881), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304497] = 4,
    ACTIONS(10914), 1,
      anon_sym_RPAREN,
    ACTIONS(27885), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304511] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18988), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304525] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19081), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304539] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19187), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304553] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19297), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304567] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19446), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304581] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19570), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304595] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19712), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304609] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19853), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304623] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18768), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304637] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18635), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304651] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19199), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304665] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19719), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304679] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18303), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304693] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18471), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304707] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23927), 1,
      anon_sym_end,
    STATE(19607), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304721] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(27887), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [304731] = 4,
    ACTIONS(10922), 1,
      anon_sym_RPAREN,
    ACTIONS(27889), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304745] = 4,
    ACTIONS(9716), 1,
      anon_sym_RBRACK,
    ACTIONS(27891), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304759] = 4,
    ACTIONS(10662), 1,
      anon_sym_RBRACE,
    ACTIONS(27893), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304773] = 4,
    ACTIONS(10770), 1,
      anon_sym_RBRACK,
    ACTIONS(27895), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304787] = 3,
    ACTIONS(27897), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6248), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [304799] = 3,
    ACTIONS(18588), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6761), 2,
      sym_scoped_identifier,
      sym_identifier,
  [304811] = 4,
    ACTIONS(10568), 1,
      anon_sym_RBRACK,
    ACTIONS(27899), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304825] = 4,
    ACTIONS(9718), 1,
      anon_sym_RBRACE,
    ACTIONS(27901), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304839] = 4,
    ACTIONS(8612), 1,
      anon_sym_RBRACK,
    ACTIONS(27903), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304853] = 4,
    ACTIONS(10772), 1,
      anon_sym_RBRACE,
    ACTIONS(27905), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304867] = 4,
    ACTIONS(10204), 1,
      anon_sym_RPAREN,
    ACTIONS(27907), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304881] = 4,
    ACTIONS(21414), 1,
      anon_sym_COMMA,
    ACTIONS(21416), 1,
      anon_sym_RBRACE,
    STATE(16837), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304895] = 4,
    ACTIONS(10604), 1,
      anon_sym_RBRACK,
    ACTIONS(27909), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304909] = 4,
    ACTIONS(9602), 1,
      anon_sym_RPAREN,
    ACTIONS(21420), 1,
      anon_sym_COMMA,
    STATE(17173), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304923] = 4,
    ACTIONS(21696), 1,
      anon_sym_COMMA,
    ACTIONS(21698), 1,
      anon_sym_RBRACE,
    STATE(16923), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304937] = 4,
    ACTIONS(9076), 1,
      anon_sym_RPAREN,
    ACTIONS(27911), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304951] = 4,
    ACTIONS(10944), 1,
      anon_sym_RPAREN,
    ACTIONS(27913), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304965] = 4,
    ACTIONS(10538), 1,
      anon_sym_RPAREN,
    ACTIONS(27915), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304979] = 4,
    ACTIONS(10570), 1,
      anon_sym_RBRACE,
    ACTIONS(27917), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [304993] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12676), 3,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
  [305003] = 4,
    ACTIONS(10956), 1,
      anon_sym_RPAREN,
    ACTIONS(27919), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305017] = 4,
    ACTIONS(10870), 1,
      anon_sym_RPAREN,
    ACTIONS(27921), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305031] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18792), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305045] = 4,
    ACTIONS(27923), 1,
      sym__word_identifier,
    ACTIONS(27925), 1,
      sym__immediate_paren,
    STATE(16165), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305059] = 4,
    ACTIONS(9604), 1,
      anon_sym_RBRACK,
    ACTIONS(27927), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305073] = 4,
    ACTIONS(21324), 1,
      anon_sym_COMMA,
    ACTIONS(21326), 1,
      anon_sym_RBRACE,
    STATE(17321), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305087] = 4,
    ACTIONS(8946), 1,
      anon_sym_RBRACK,
    ACTIONS(27929), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305101] = 4,
    ACTIONS(10532), 1,
      anon_sym_RBRACK,
    ACTIONS(27931), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305115] = 3,
    ACTIONS(27933), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11350), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [305127] = 4,
    ACTIONS(8862), 1,
      anon_sym_RPAREN,
    ACTIONS(21650), 1,
      anon_sym_COMMA,
    STATE(17180), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305141] = 4,
    ACTIONS(23912), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19102), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305155] = 4,
    ACTIONS(24007), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19728), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305169] = 4,
    ACTIONS(9606), 1,
      anon_sym_RBRACE,
    ACTIONS(27935), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305183] = 4,
    ACTIONS(21468), 1,
      anon_sym_COMMA,
    ACTIONS(21470), 1,
      anon_sym_RBRACE,
    STATE(17176), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305197] = 3,
    ACTIONS(27937), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10627), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [305209] = 4,
    ACTIONS(9904), 1,
      anon_sym_RPAREN,
    ACTIONS(27939), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305223] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24007), 1,
      anon_sym_end,
    STATE(19728), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305237] = 3,
    ACTIONS(27941), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14366), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [305249] = 4,
    ACTIONS(10606), 1,
      anon_sym_RBRACE,
    ACTIONS(27943), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305263] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23999), 1,
      anon_sym_end,
    STATE(18213), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305277] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(27945), 1,
      anon_sym_end,
    STATE(19276), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305291] = 3,
    ACTIONS(27947), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8018), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [305303] = 4,
    ACTIONS(10010), 1,
      anon_sym_RBRACK,
    ACTIONS(27949), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305317] = 4,
    ACTIONS(24009), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19564), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305331] = 4,
    ACTIONS(10472), 1,
      anon_sym_RPAREN,
    ACTIONS(21442), 1,
      anon_sym_COMMA,
    STATE(17190), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305345] = 3,
    ACTIONS(27951), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9359), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [305357] = 4,
    ACTIONS(10160), 1,
      anon_sym_RBRACK,
    ACTIONS(27953), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305371] = 4,
    ACTIONS(9344), 1,
      anon_sym_RBRACK,
    ACTIONS(27955), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305385] = 4,
    ACTIONS(21664), 1,
      anon_sym_COMMA,
    ACTIONS(21666), 1,
      anon_sym_RBRACE,
    STATE(17198), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305399] = 4,
    ACTIONS(10474), 1,
      anon_sym_RBRACK,
    ACTIONS(27957), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305413] = 3,
    ACTIONS(18538), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7075), 2,
      sym_scoped_identifier,
      sym_identifier,
  [305425] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(27959), 1,
      anon_sym_end,
    STATE(18585), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305439] = 4,
    ACTIONS(9526), 1,
      anon_sym_RBRACK,
    ACTIONS(27961), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305453] = 4,
    ACTIONS(21584), 1,
      anon_sym_COMMA,
    ACTIONS(21586), 1,
      anon_sym_RBRACE,
    STATE(17248), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305467] = 4,
    ACTIONS(10414), 1,
      anon_sym_RPAREN,
    ACTIONS(27963), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305481] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23912), 1,
      anon_sym_end,
    STATE(19102), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305495] = 4,
    ACTIONS(8948), 1,
      anon_sym_RBRACE,
    ACTIONS(27965), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305509] = 4,
    ACTIONS(10476), 1,
      anon_sym_RBRACE,
    ACTIONS(27967), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305523] = 3,
    ACTIONS(27969), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10236), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [305535] = 3,
    ACTIONS(18616), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6673), 2,
      sym_scoped_identifier,
      sym_identifier,
  [305547] = 4,
    ACTIONS(9266), 1,
      anon_sym_RPAREN,
    ACTIONS(21396), 1,
      anon_sym_COMMA,
    STATE(16768), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305561] = 4,
    ACTIONS(8992), 1,
      anon_sym_RPAREN,
    ACTIONS(27971), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305575] = 4,
    ACTIONS(10786), 1,
      anon_sym_RPAREN,
    ACTIONS(21640), 1,
      anon_sym_COMMA,
    STATE(17212), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305589] = 4,
    ACTIONS(8914), 1,
      anon_sym_RPAREN,
    ACTIONS(27973), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305603] = 4,
    ACTIONS(21336), 1,
      anon_sym_COMMA,
    ACTIONS(21338), 1,
      anon_sym_RBRACE,
    STATE(16891), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305617] = 4,
    ACTIONS(9862), 1,
      anon_sym_RBRACK,
    ACTIONS(27975), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305631] = 4,
    ACTIONS(10162), 1,
      anon_sym_RBRACE,
    ACTIONS(27977), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305645] = 4,
    ACTIONS(10012), 1,
      anon_sym_RBRACE,
    ACTIONS(27979), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305659] = 4,
    ACTIONS(21454), 1,
      anon_sym_COMMA,
    ACTIONS(21456), 1,
      anon_sym_RBRACE,
    STATE(17210), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305673] = 4,
    ACTIONS(10788), 1,
      anon_sym_RBRACK,
    ACTIONS(27981), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305687] = 4,
    ACTIONS(8610), 1,
      anon_sym_RPAREN,
    ACTIONS(21096), 1,
      anon_sym_COMMA,
    STATE(16938), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305701] = 4,
    ACTIONS(10924), 1,
      anon_sym_RPAREN,
    ACTIONS(27983), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305715] = 3,
    ACTIONS(27985), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7087), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [305727] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(27987), 1,
      anon_sym_LF,
    ACTIONS(27104), 2,
      anon_sym_RBRACK,
      aux_sym__terminator_token1,
  [305741] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(27989), 1,
      anon_sym_end,
    STATE(19792), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305755] = 4,
    ACTIONS(24011), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19810), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305769] = 4,
    ACTIONS(10550), 1,
      anon_sym_RBRACK,
    ACTIONS(27991), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305783] = 4,
    ACTIONS(10082), 1,
      anon_sym_RPAREN,
    ACTIONS(21106), 1,
      anon_sym_COMMA,
    STATE(17010), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305797] = 3,
    ACTIONS(27993), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9876), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [305809] = 4,
    ACTIONS(10790), 1,
      anon_sym_RBRACE,
    ACTIONS(27995), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305823] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24011), 1,
      anon_sym_end,
    STATE(19810), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305837] = 4,
    ACTIONS(23935), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19819), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305851] = 4,
    ACTIONS(9750), 1,
      anon_sym_RPAREN,
    ACTIONS(21340), 1,
      anon_sym_COMMA,
    STATE(17225), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305865] = 4,
    ACTIONS(9528), 1,
      anon_sym_RBRACE,
    ACTIONS(27997), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305879] = 3,
    ACTIONS(27999), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6916), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [305891] = 4,
    ACTIONS(9864), 1,
      anon_sym_RBRACE,
    ACTIONS(28001), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305905] = 4,
    ACTIONS(10938), 1,
      anon_sym_RPAREN,
    ACTIONS(28003), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305919] = 3,
    ACTIONS(28005), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5328), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [305931] = 4,
    ACTIONS(9752), 1,
      anon_sym_RBRACK,
    ACTIONS(28007), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305945] = 3,
    ACTIONS(18554), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7186), 2,
      sym_scoped_identifier,
      sym_identifier,
  [305957] = 3,
    ACTIONS(28009), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5680), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [305969] = 4,
    ACTIONS(9754), 1,
      anon_sym_RBRACE,
    ACTIONS(28011), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305983] = 4,
    ACTIONS(9188), 1,
      anon_sym_RPAREN,
    ACTIONS(21102), 1,
      anon_sym_COMMA,
    STATE(16727), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [305997] = 4,
    ACTIONS(10958), 1,
      anon_sym_RPAREN,
    ACTIONS(28013), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306011] = 4,
    ACTIONS(9146), 1,
      anon_sym_RPAREN,
    ACTIONS(21506), 1,
      anon_sym_COMMA,
    STATE(17318), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306025] = 3,
    ACTIONS(28015), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6273), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [306037] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21548), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [306047] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23935), 1,
      anon_sym_end,
    STATE(19819), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306061] = 4,
    ACTIONS(21078), 1,
      anon_sym_COMMA,
    ACTIONS(21080), 1,
      anon_sym_RBRACE,
    STATE(17255), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306075] = 3,
    ACTIONS(28017), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10131), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [306087] = 4,
    ACTIONS(21320), 1,
      anon_sym_COMMA,
    ACTIONS(21322), 1,
      anon_sym_RBRACE,
    STATE(17283), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306101] = 4,
    ACTIONS(21422), 1,
      anon_sym_COMMA,
    ACTIONS(21424), 1,
      anon_sym_RBRACE,
    STATE(17298), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306115] = 4,
    ACTIONS(10552), 1,
      anon_sym_RBRACE,
    ACTIONS(28019), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306129] = 4,
    ACTIONS(21482), 1,
      anon_sym_COMMA,
    ACTIONS(21484), 1,
      anon_sym_RBRACE,
    STATE(17253), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306143] = 4,
    ACTIONS(23945), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18550), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306157] = 4,
    ACTIONS(9562), 1,
      anon_sym_RBRACE,
    ACTIONS(28021), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306171] = 4,
    ACTIONS(10574), 1,
      anon_sym_RPAREN,
    ACTIONS(28023), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306185] = 4,
    ACTIONS(9268), 1,
      anon_sym_RBRACK,
    ACTIONS(28025), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306199] = 4,
    ACTIONS(21514), 1,
      anon_sym_COMMA,
    ACTIONS(21516), 1,
      anon_sym_RBRACE,
    STATE(16656), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306213] = 3,
    ACTIONS(28027), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5540), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [306225] = 4,
    ACTIONS(21574), 1,
      anon_sym_COMMA,
    ACTIONS(21576), 1,
      anon_sym_RBRACE,
    STATE(17175), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306239] = 4,
    ACTIONS(10934), 1,
      anon_sym_RPAREN,
    ACTIONS(28029), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306253] = 3,
    ACTIONS(18598), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6833), 2,
      sym_scoped_identifier,
      sym_identifier,
  [306265] = 4,
    ACTIONS(10676), 1,
      anon_sym_RPAREN,
    ACTIONS(21600), 1,
      anon_sym_COMMA,
    STATE(17278), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306279] = 4,
    ACTIONS(10910), 1,
      anon_sym_RPAREN,
    ACTIONS(28031), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306293] = 3,
    ACTIONS(28033), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8586), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [306305] = 4,
    ACTIONS(21350), 1,
      anon_sym_COMMA,
    ACTIONS(21352), 1,
      anon_sym_RBRACE,
    STATE(16671), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306319] = 3,
    ACTIONS(28035), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6172), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [306331] = 4,
    ACTIONS(10490), 1,
      anon_sym_RPAREN,
    ACTIONS(21452), 1,
      anon_sym_COMMA,
    STATE(17262), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306345] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(28037), 1,
      anon_sym_end,
    STATE(19832), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306359] = 4,
    ACTIONS(24021), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19566), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306373] = 4,
    ACTIONS(10904), 1,
      anon_sym_RPAREN,
    ACTIONS(28039), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306387] = 4,
    ACTIONS(10372), 1,
      anon_sym_RPAREN,
    ACTIONS(21344), 1,
      anon_sym_COMMA,
    STATE(17326), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306401] = 4,
    ACTIONS(21672), 1,
      anon_sym_COMMA,
    ACTIONS(21674), 1,
      anon_sym_RBRACE,
    STATE(17264), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306415] = 4,
    ACTIONS(10832), 1,
      anon_sym_RPAREN,
    ACTIONS(28041), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306429] = 4,
    ACTIONS(9148), 1,
      anon_sym_RBRACK,
    ACTIONS(28043), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306443] = 4,
    ACTIONS(10492), 1,
      anon_sym_RBRACK,
    ACTIONS(28045), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306457] = 4,
    ACTIONS(10678), 1,
      anon_sym_RBRACK,
    ACTIONS(28047), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306471] = 4,
    ACTIONS(10902), 1,
      anon_sym_RPAREN,
    ACTIONS(28049), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306485] = 4,
    ACTIONS(9150), 1,
      anon_sym_RBRACE,
    ACTIONS(28051), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306499] = 4,
    ACTIONS(21346), 1,
      anon_sym_COMMA,
    ACTIONS(21348), 1,
      anon_sym_RBRACE,
    STATE(17319), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306513] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(28053), 1,
      anon_sym_end,
    STATE(19161), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306527] = 4,
    ACTIONS(10806), 1,
      anon_sym_RPAREN,
    ACTIONS(21660), 1,
      anon_sym_COMMA,
    STATE(17275), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306541] = 4,
    ACTIONS(10232), 1,
      anon_sym_RPAREN,
    ACTIONS(21264), 1,
      anon_sym_COMMA,
    STATE(16662), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306555] = 4,
    ACTIONS(10494), 1,
      anon_sym_RBRACE,
    ACTIONS(28055), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306569] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28059), 1,
      anon_sym_LF,
    ACTIONS(28057), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token1,
  [306583] = 4,
    ACTIONS(10680), 1,
      anon_sym_RBRACE,
    ACTIONS(28061), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306597] = 4,
    ACTIONS(23933), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18169), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306611] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(28063), 1,
      anon_sym_end,
    STATE(18180), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306625] = 3,
    ACTIONS(28065), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10049), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [306637] = 4,
    ACTIONS(10808), 1,
      anon_sym_RBRACK,
    ACTIONS(28067), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306651] = 4,
    ACTIONS(23991), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19283), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306665] = 3,
    ACTIONS(28069), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7635), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [306677] = 4,
    ACTIONS(10926), 1,
      anon_sym_RPAREN,
    ACTIONS(28071), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306691] = 4,
    ACTIONS(9454), 1,
      anon_sym_RBRACK,
    ACTIONS(28073), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306705] = 4,
    ACTIONS(10810), 1,
      anon_sym_RBRACE,
    ACTIONS(28075), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306719] = 4,
    ACTIONS(9640), 1,
      anon_sym_RPAREN,
    ACTIONS(21676), 1,
      anon_sym_COMMA,
    STATE(16663), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306733] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24021), 1,
      anon_sym_end,
    STATE(19566), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306747] = 3,
    ACTIONS(28077), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5018), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [306759] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23991), 1,
      anon_sym_end,
    STATE(19283), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306773] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(28079), 1,
      anon_sym_end,
    STATE(19870), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306787] = 3,
    ACTIONS(28081), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7893), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [306799] = 3,
    ACTIONS(28083), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5330), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [306811] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(28085), 1,
      anon_sym_end,
    STATE(18354), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306825] = 4,
    ACTIONS(28087), 1,
      sym__immediate_paren,
    ACTIONS(28089), 1,
      sym__immediate_bracket,
    ACTIONS(28091), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306839] = 4,
    ACTIONS(8864), 1,
      anon_sym_RBRACK,
    ACTIONS(28093), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306853] = 4,
    ACTIONS(10960), 1,
      anon_sym_RPAREN,
    ACTIONS(28095), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306867] = 4,
    ACTIONS(9342), 1,
      anon_sym_RPAREN,
    ACTIONS(21540), 1,
      anon_sym_COMMA,
    STATE(17154), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306881] = 4,
    ACTIONS(21522), 1,
      anon_sym_COMMA,
    ACTIONS(21524), 1,
      anon_sym_RBRACE,
    STATE(17310), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306895] = 4,
    ACTIONS(10946), 1,
      anon_sym_RPAREN,
    ACTIONS(28097), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306909] = 3,
    ACTIONS(28099), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(17853), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [306921] = 4,
    ACTIONS(9932), 1,
      anon_sym_RPAREN,
    ACTIONS(21552), 1,
      anon_sym_COMMA,
    STATE(17301), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306935] = 4,
    ACTIONS(10234), 1,
      anon_sym_RBRACK,
    ACTIONS(28101), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306949] = 4,
    ACTIONS(21088), 1,
      anon_sym_COMMA,
    ACTIONS(21090), 1,
      anon_sym_RBRACE,
    STATE(16904), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306963] = 4,
    ACTIONS(10236), 1,
      anon_sym_RBRACE,
    ACTIONS(28103), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [306977] = 3,
    ACTIONS(4936), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(28105), 2,
      anon_sym_end,
      anon_sym_elseif,
  [306989] = 3,
    ACTIONS(18480), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11581), 2,
      sym_scoped_identifier,
      sym_identifier,
  [307001] = 4,
    ACTIONS(10374), 1,
      anon_sym_RBRACK,
    ACTIONS(28107), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307015] = 4,
    ACTIONS(21490), 1,
      anon_sym_COMMA,
    ACTIONS(21492), 1,
      anon_sym_RBRACE,
    STATE(17312), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307029] = 3,
    ACTIONS(28109), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5010), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [307041] = 3,
    ACTIONS(28111), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6911), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [307053] = 4,
    ACTIONS(8866), 1,
      anon_sym_RBRACE,
    ACTIONS(28113), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307067] = 4,
    ACTIONS(10510), 1,
      anon_sym_RPAREN,
    ACTIONS(21466), 1,
      anon_sym_COMMA,
    STATE(17038), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307081] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(19586), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307095] = 4,
    ACTIONS(9020), 1,
      anon_sym_RPAREN,
    ACTIONS(21094), 1,
      anon_sym_COMMA,
    STATE(16899), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307109] = 4,
    ACTIONS(21188), 1,
      anon_sym_COMMA,
    ACTIONS(21190), 1,
      anon_sym_RBRACE,
    STATE(17305), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307123] = 4,
    ACTIONS(28115), 1,
      sym__immediate_paren,
    ACTIONS(28117), 1,
      sym__immediate_bracket,
    ACTIONS(28119), 1,
      sym__immediate_brace,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307137] = 4,
    ACTIONS(21580), 1,
      anon_sym_COMMA,
    ACTIONS(21582), 1,
      anon_sym_RBRACE,
    STATE(16680), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307151] = 4,
    ACTIONS(9786), 1,
      anon_sym_RPAREN,
    ACTIONS(21364), 1,
      anon_sym_COMMA,
    STATE(17324), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307165] = 4,
    ACTIONS(10376), 1,
      anon_sym_RBRACE,
    ACTIONS(28121), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307179] = 4,
    ACTIONS(21266), 1,
      anon_sym_COMMA,
    ACTIONS(21268), 1,
      anon_sym_RBRACE,
    STATE(16950), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307193] = 3,
    ACTIONS(28123), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7959), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [307205] = 4,
    ACTIONS(10758), 1,
      anon_sym_RPAREN,
    ACTIONS(28125), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307219] = 4,
    ACTIONS(21680), 1,
      anon_sym_COMMA,
    ACTIONS(21682), 1,
      anon_sym_RBRACE,
    STATE(16657), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307233] = 4,
    ACTIONS(10512), 1,
      anon_sym_RBRACK,
    ACTIONS(28127), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307247] = 4,
    ACTIONS(9788), 1,
      anon_sym_RBRACK,
    ACTIONS(28129), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307261] = 4,
    ACTIONS(10086), 1,
      anon_sym_RBRACE,
    ACTIONS(28131), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307275] = 4,
    ACTIONS(24027), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(19469), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307289] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(24027), 1,
      anon_sym_end,
    STATE(19469), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307303] = 3,
    ACTIONS(18578), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12889), 2,
      sym_scoped_identifier,
      sym_identifier,
  [307315] = 4,
    ACTIONS(9642), 1,
      anon_sym_RBRACK,
    ACTIONS(28133), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307329] = 4,
    ACTIONS(9790), 1,
      anon_sym_RBRACE,
    ACTIONS(28135), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307343] = 4,
    ACTIONS(21360), 1,
      anon_sym_COMMA,
    ACTIONS(21362), 1,
      anon_sym_RBRACE,
    STATE(16822), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307357] = 4,
    ACTIONS(10514), 1,
      anon_sym_RBRACE,
    ACTIONS(28137), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307371] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(28139), 1,
      anon_sym_end,
    STATE(19748), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307385] = 3,
    ACTIONS(28141), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7083), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [307397] = 4,
    ACTIONS(23953), 1,
      anon_sym_end,
    ACTIONS(27156), 1,
      anon_sym_catch,
    STATE(18663), 1,
      sym_catch_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307411] = 4,
    ACTIONS(23910), 1,
      anon_sym_finally,
    ACTIONS(23953), 1,
      anon_sym_end,
    STATE(18663), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307425] = 4,
    ACTIONS(10824), 1,
      anon_sym_RPAREN,
    ACTIONS(21670), 1,
      anon_sym_COMMA,
    STATE(16661), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307439] = 4,
    ACTIONS(9536), 1,
      anon_sym_RPAREN,
    ACTIONS(28143), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307453] = 4,
    ACTIONS(9644), 1,
      anon_sym_RBRACE,
    ACTIONS(28145), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307467] = 4,
    ACTIONS(28147), 1,
      sym__word_identifier,
    ACTIONS(28149), 1,
      sym__immediate_paren,
    STATE(16289), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307481] = 4,
    ACTIONS(9192), 1,
      anon_sym_RBRACE,
    ACTIONS(28151), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307495] = 4,
    ACTIONS(21616), 1,
      anon_sym_COMMA,
    ACTIONS(21618), 1,
      anon_sym_RBRACE,
    STATE(16675), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307509] = 4,
    ACTIONS(9066), 1,
      anon_sym_RPAREN,
    ACTIONS(21092), 1,
      anon_sym_COMMA,
    STATE(16716), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307523] = 4,
    ACTIONS(10610), 1,
      anon_sym_RPAREN,
    ACTIONS(28153), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307537] = 4,
    ACTIONS(11994), 1,
      anon_sym_RPAREN,
    ACTIONS(18578), 1,
      sym__word_identifier,
    STATE(11526), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307551] = 4,
    ACTIONS(10916), 1,
      anon_sym_RPAREN,
    ACTIONS(28155), 1,
      anon_sym_COMMA,
    STATE(16762), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307565] = 4,
    ACTIONS(9270), 1,
      anon_sym_RBRACE,
    ACTIONS(28157), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307579] = 4,
    ACTIONS(11956), 1,
      anon_sym_RPAREN,
    ACTIONS(18578), 1,
      sym__word_identifier,
    STATE(11505), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307593] = 4,
    ACTIONS(9824), 1,
      anon_sym_RBRACK,
    ACTIONS(28159), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307607] = 4,
    ACTIONS(21684), 1,
      anon_sym_COMMA,
    ACTIONS(21686), 1,
      anon_sym_RBRACE,
    STATE(16829), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307621] = 4,
    ACTIONS(24347), 1,
      anon_sym_LT_COLON,
    ACTIONS(28161), 1,
      anon_sym_end,
    STATE(19482), 1,
      sym_type_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307635] = 4,
    ACTIONS(10826), 1,
      anon_sym_RBRACK,
    ACTIONS(28163), 1,
      anon_sym_COMMA,
    STATE(16143), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307649] = 3,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12885), 2,
      sym_scoped_identifier,
      sym_identifier,
  [307661] = 3,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12216), 2,
      sym_scoped_identifier,
      sym_identifier,
  [307673] = 3,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11851), 2,
      sym_scoped_identifier,
      sym_identifier,
  [307685] = 3,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12226), 2,
      sym_scoped_identifier,
      sym_identifier,
  [307697] = 3,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(12231), 2,
      sym_scoped_identifier,
      sym_identifier,
  [307709] = 3,
    ACTIONS(18528), 1,
      sym__word_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11855), 2,
      sym_scoped_identifier,
      sym_identifier,
  [307721] = 4,
    ACTIONS(22484), 1,
      anon_sym_for,
    STATE(14542), 1,
      sym_for_clause,
    STATE(18888), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307735] = 3,
    ACTIONS(19197), 1,
      anon_sym_COMMA,
    STATE(14985), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307746] = 3,
    ACTIONS(15798), 1,
      anon_sym_LBRACE,
    STATE(5385), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307757] = 3,
    ACTIONS(28165), 1,
      anon_sym_LPAREN,
    STATE(4365), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307768] = 3,
    ACTIONS(20231), 1,
      anon_sym_LBRACE,
    STATE(8018), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307779] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12068), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [307788] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5348), 1,
      anon_sym_RBRACK,
    ACTIONS(28167), 1,
      anon_sym_LF,
  [307801] = 3,
    ACTIONS(15798), 1,
      anon_sym_LBRACE,
    STATE(5470), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307812] = 3,
    ACTIONS(28169), 1,
      anon_sym_LPAREN,
    STATE(4713), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307823] = 3,
    ACTIONS(9942), 1,
      anon_sym_RPAREN,
    ACTIONS(28171), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307834] = 3,
    ACTIONS(10748), 1,
      anon_sym_RPAREN,
    ACTIONS(28173), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307845] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28175), 1,
      anon_sym_RBRACK,
    ACTIONS(28177), 1,
      anon_sym_LF,
  [307858] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5312), 1,
      anon_sym_RBRACK,
    ACTIONS(28179), 1,
      anon_sym_LF,
  [307871] = 3,
    ACTIONS(28181), 1,
      anon_sym_LPAREN,
    STATE(4442), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307882] = 3,
    ACTIONS(9962), 1,
      anon_sym_RPAREN,
    ACTIONS(28183), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307893] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12282), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [307902] = 3,
    ACTIONS(10350), 1,
      anon_sym_RPAREN,
    ACTIONS(28185), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307913] = 3,
    ACTIONS(9024), 1,
      anon_sym_RPAREN,
    ACTIONS(28187), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307924] = 3,
    ACTIONS(28189), 1,
      anon_sym_LPAREN,
    STATE(14325), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307935] = 3,
    ACTIONS(10796), 1,
      anon_sym_RPAREN,
    ACTIONS(28191), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307946] = 3,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    STATE(10131), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307957] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(4802), 1,
      anon_sym_RBRACK,
    ACTIONS(28193), 1,
      anon_sym_LF,
  [307970] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28195), 1,
      anon_sym_RBRACK,
    ACTIONS(28197), 1,
      anon_sym_LF,
  [307983] = 3,
    ACTIONS(28199), 1,
      anon_sym_LPAREN,
    STATE(4335), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [307994] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5720), 1,
      anon_sym_RBRACK,
    ACTIONS(28201), 1,
      anon_sym_LF,
  [308007] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5534), 1,
      anon_sym_RBRACK,
    ACTIONS(28203), 1,
      anon_sym_LF,
  [308020] = 3,
    ACTIONS(15588), 1,
      anon_sym_LBRACE,
    STATE(5003), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308031] = 3,
    ACTIONS(28205), 1,
      anon_sym_LPAREN,
    STATE(9315), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308042] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28207), 1,
      anon_sym_RBRACK,
    ACTIONS(28209), 1,
      anon_sym_LF,
  [308055] = 3,
    ACTIONS(20221), 1,
      anon_sym_LBRACE,
    STATE(8586), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308066] = 3,
    ACTIONS(28169), 1,
      anon_sym_LPAREN,
    STATE(4714), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308077] = 3,
    ACTIONS(15648), 1,
      anon_sym_LBRACE,
    STATE(6453), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308088] = 3,
    ACTIONS(28211), 1,
      anon_sym_LPAREN,
    STATE(4464), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308099] = 3,
    ACTIONS(10784), 1,
      anon_sym_RPAREN,
    ACTIONS(28213), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308110] = 3,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    STATE(14387), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308121] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28215), 1,
      anon_sym_RBRACK,
    ACTIONS(28217), 1,
      anon_sym_LF,
  [308134] = 3,
    ACTIONS(28219), 1,
      anon_sym_LPAREN,
    STATE(4722), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308145] = 3,
    ACTIONS(8788), 1,
      anon_sym_LBRACE,
    STATE(5962), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308156] = 3,
    ACTIONS(8686), 1,
      anon_sym_LBRACE,
    STATE(6077), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308167] = 3,
    ACTIONS(28221), 1,
      anon_sym_LPAREN,
    STATE(10277), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308178] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28223), 1,
      anon_sym_RBRACK,
    ACTIONS(28225), 1,
      anon_sym_LF,
  [308191] = 3,
    ACTIONS(10814), 1,
      anon_sym_RPAREN,
    ACTIONS(28227), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308202] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6098), 1,
      anon_sym_RBRACK,
    ACTIONS(28229), 1,
      anon_sym_LF,
  [308215] = 3,
    ACTIONS(28219), 1,
      anon_sym_LPAREN,
    STATE(4757), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308226] = 3,
    ACTIONS(12676), 1,
      anon_sym_RPAREN,
    ACTIONS(28231), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308237] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28233), 1,
      anon_sym_RBRACK,
    ACTIONS(28235), 1,
      anon_sym_LF,
  [308250] = 3,
    ACTIONS(28221), 1,
      anon_sym_LPAREN,
    STATE(10318), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308261] = 3,
    ACTIONS(8686), 1,
      anon_sym_LBRACE,
    STATE(6175), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308272] = 3,
    ACTIONS(15874), 1,
      anon_sym_LBRACE,
    STATE(10738), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308283] = 3,
    ACTIONS(28165), 1,
      anon_sym_LPAREN,
    STATE(4366), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308294] = 3,
    ACTIONS(15798), 1,
      anon_sym_LBRACE,
    STATE(5328), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308305] = 3,
    ACTIONS(10804), 1,
      anon_sym_RPAREN,
    ACTIONS(28237), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308316] = 3,
    ACTIONS(28239), 1,
      anon_sym_LPAREN,
    STATE(4288), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308327] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28241), 1,
      anon_sym_RBRACK,
    ACTIONS(28243), 1,
      anon_sym_LF,
  [308340] = 3,
    ACTIONS(28245), 1,
      anon_sym_LPAREN,
    STATE(9972), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308351] = 3,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    STATE(10155), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308362] = 3,
    ACTIONS(10834), 1,
      anon_sym_RPAREN,
    ACTIONS(28247), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308373] = 3,
    ACTIONS(28245), 1,
      anon_sym_LPAREN,
    STATE(9978), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308384] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6110), 1,
      anon_sym_RBRACK,
    ACTIONS(28249), 1,
      anon_sym_LF,
  [308397] = 3,
    ACTIONS(10092), 1,
      anon_sym_RPAREN,
    ACTIONS(28251), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308408] = 3,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    STATE(10160), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308419] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28253), 1,
      anon_sym_RBRACK,
    ACTIONS(28255), 1,
      anon_sym_LF,
  [308432] = 3,
    ACTIONS(10262), 1,
      anon_sym_RPAREN,
    ACTIONS(28257), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308443] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5600), 1,
      anon_sym_RBRACK,
    ACTIONS(28259), 1,
      anon_sym_LF,
  [308456] = 3,
    ACTIONS(13247), 1,
      anon_sym_COLON,
    ACTIONS(28261), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308467] = 3,
    ACTIONS(10822), 1,
      anon_sym_RPAREN,
    ACTIONS(28263), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308478] = 3,
    ACTIONS(15516), 1,
      anon_sym_LBRACE,
    STATE(9366), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308489] = 3,
    ACTIONS(28165), 1,
      anon_sym_LPAREN,
    STATE(4367), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308500] = 3,
    ACTIONS(15798), 1,
      anon_sym_LBRACE,
    STATE(5541), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308511] = 3,
    ACTIONS(28265), 1,
      anon_sym_LPAREN,
    STATE(9255), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308522] = 3,
    ACTIONS(10852), 1,
      anon_sym_RPAREN,
    ACTIONS(28267), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308533] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6122), 1,
      anon_sym_RBRACK,
    ACTIONS(28269), 1,
      anon_sym_LF,
  [308546] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12164), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [308555] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28271), 1,
      anon_sym_RBRACK,
    ACTIONS(28273), 1,
      anon_sym_LF,
  [308568] = 3,
    ACTIONS(10382), 1,
      anon_sym_RPAREN,
    ACTIONS(28275), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308579] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28277), 1,
      anon_sym_RBRACK,
    ACTIONS(28279), 1,
      anon_sym_LF,
  [308592] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5738), 1,
      anon_sym_RBRACK,
    ACTIONS(28281), 1,
      anon_sym_LF,
  [308605] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28283), 1,
      anon_sym_RBRACK,
    ACTIONS(28285), 1,
      anon_sym_LF,
  [308618] = 3,
    ACTIONS(10842), 1,
      anon_sym_RPAREN,
    ACTIONS(28287), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308629] = 3,
    ACTIONS(15516), 1,
      anon_sym_LBRACE,
    STATE(9368), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308640] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28289), 1,
      anon_sym_RBRACK,
    ACTIONS(28291), 1,
      anon_sym_LF,
  [308653] = 3,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(10006), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308664] = 3,
    ACTIONS(10872), 1,
      anon_sym_RPAREN,
    ACTIONS(28293), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308675] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6140), 1,
      anon_sym_RBRACK,
    ACTIONS(28295), 1,
      anon_sym_LF,
  [308688] = 3,
    ACTIONS(10980), 1,
      anon_sym_RPAREN,
    ACTIONS(28297), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308699] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28299), 1,
      anon_sym_RBRACK,
    ACTIONS(28301), 1,
      anon_sym_LF,
  [308712] = 3,
    ACTIONS(15724), 1,
      anon_sym_LBRACE,
    STATE(11218), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308723] = 3,
    ACTIONS(9352), 1,
      anon_sym_RPAREN,
    ACTIONS(28303), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308734] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    STATE(6009), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308745] = 3,
    ACTIONS(10860), 1,
      anon_sym_RPAREN,
    ACTIONS(28305), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308756] = 3,
    ACTIONS(10334), 1,
      anon_sym_RPAREN,
    ACTIONS(28307), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308767] = 3,
    ACTIONS(19596), 1,
      anon_sym_LBRACE,
    STATE(7635), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308778] = 3,
    ACTIONS(10888), 1,
      anon_sym_RPAREN,
    ACTIONS(28309), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308789] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6152), 1,
      anon_sym_RBRACK,
    ACTIONS(28311), 1,
      anon_sym_LF,
  [308802] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28313), 1,
      anon_sym_RBRACK,
    ACTIONS(28315), 1,
      anon_sym_LF,
  [308815] = 3,
    ACTIONS(28317), 1,
      anon_sym_LPAREN,
    STATE(4289), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308826] = 3,
    ACTIONS(8902), 1,
      anon_sym_RPAREN,
    ACTIONS(28319), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308837] = 3,
    ACTIONS(15724), 1,
      anon_sym_LBRACE,
    STATE(11364), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308848] = 3,
    ACTIONS(28321), 1,
      anon_sym_LPAREN,
    STATE(10932), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308859] = 3,
    ACTIONS(28245), 1,
      anon_sym_LPAREN,
    STATE(10032), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308870] = 3,
    ACTIONS(28323), 1,
      anon_sym_LPAREN,
    STATE(4949), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308881] = 3,
    ACTIONS(15978), 1,
      anon_sym_LBRACE,
    STATE(5540), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308892] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    STATE(6017), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308903] = 3,
    ACTIONS(28323), 1,
      anon_sym_LPAREN,
    STATE(4977), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308914] = 3,
    ACTIONS(15724), 1,
      anon_sym_LBRACE,
    STATE(11369), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308925] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    STATE(6042), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308936] = 3,
    ACTIONS(10416), 1,
      anon_sym_RPAREN,
    ACTIONS(28325), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [308947] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5756), 1,
      anon_sym_RBRACK,
    ACTIONS(28327), 1,
      anon_sym_LF,
  [308960] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28329), 1,
      anon_sym_RBRACK,
    ACTIONS(28331), 1,
      anon_sym_LF,
  [308973] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28333), 1,
      anon_sym_RBRACK,
    ACTIONS(28335), 1,
      anon_sym_LF,
  [308986] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28337), 1,
      anon_sym_RBRACK,
    ACTIONS(28339), 1,
      anon_sym_LF,
  [308999] = 3,
    ACTIONS(10002), 1,
      anon_sym_RPAREN,
    ACTIONS(28341), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309010] = 3,
    ACTIONS(19460), 1,
      anon_sym_LBRACE,
    STATE(11553), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309021] = 3,
    ACTIONS(19532), 1,
      anon_sym_LBRACE,
    STATE(6814), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309032] = 3,
    ACTIONS(28343), 1,
      anon_sym_LPAREN,
    STATE(4343), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309043] = 3,
    ACTIONS(19903), 1,
      anon_sym_LBRACE,
    STATE(7230), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309054] = 3,
    ACTIONS(9372), 1,
      anon_sym_RPAREN,
    ACTIONS(28345), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309065] = 3,
    ACTIONS(15668), 1,
      anon_sym_LBRACE,
    STATE(5654), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309076] = 3,
    ACTIONS(28343), 1,
      anon_sym_LPAREN,
    STATE(4345), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309087] = 3,
    ACTIONS(15668), 1,
      anon_sym_LBRACE,
    STATE(5688), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309098] = 3,
    ACTIONS(9178), 1,
      anon_sym_RPAREN,
    ACTIONS(28347), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309109] = 3,
    ACTIONS(10400), 1,
      anon_sym_RPAREN,
    ACTIONS(28349), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309120] = 3,
    ACTIONS(28323), 1,
      anon_sym_LPAREN,
    STATE(4994), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309131] = 3,
    ACTIONS(8648), 1,
      anon_sym_LBRACE,
    STATE(5010), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309142] = 3,
    ACTIONS(28219), 1,
      anon_sym_LPAREN,
    STATE(4864), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309153] = 3,
    ACTIONS(9854), 1,
      anon_sym_RPAREN,
    ACTIONS(28351), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309164] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12140), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [309173] = 3,
    ACTIONS(10130), 1,
      anon_sym_RPAREN,
    ACTIONS(28353), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309184] = 3,
    ACTIONS(10444), 1,
      anon_sym_RPAREN,
    ACTIONS(28355), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309195] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5774), 1,
      anon_sym_RBRACK,
    ACTIONS(28357), 1,
      anon_sym_LF,
  [309208] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28359), 1,
      anon_sym_RBRACK,
    ACTIONS(28361), 1,
      anon_sym_LF,
  [309221] = 3,
    ACTIONS(8874), 1,
      anon_sym_RPAREN,
    ACTIONS(28363), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309232] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5618), 1,
      anon_sym_RBRACK,
    ACTIONS(28365), 1,
      anon_sym_LF,
  [309245] = 3,
    ACTIONS(28367), 1,
      anon_sym_LPAREN,
    STATE(5106), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309256] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12160), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [309265] = 3,
    ACTIONS(19582), 1,
      anon_sym_LBRACE,
    STATE(8323), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309276] = 3,
    ACTIONS(28323), 1,
      anon_sym_LPAREN,
    STATE(5013), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309287] = 3,
    ACTIONS(15738), 1,
      anon_sym_LBRACE,
    STATE(6399), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309298] = 3,
    ACTIONS(15830), 1,
      anon_sym_LBRACE,
    STATE(6107), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309309] = 3,
    ACTIONS(28367), 1,
      anon_sym_LPAREN,
    STATE(5109), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309320] = 3,
    ACTIONS(9186), 1,
      anon_sym_RPAREN,
    ACTIONS(28369), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309331] = 3,
    ACTIONS(15738), 1,
      anon_sym_LBRACE,
    STATE(6401), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309342] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28371), 1,
      anon_sym_RBRACK,
    ACTIONS(28373), 1,
      anon_sym_LF,
  [309355] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5678), 1,
      anon_sym_RBRACK,
    ACTIONS(28375), 1,
      anon_sym_LF,
  [309368] = 3,
    ACTIONS(12096), 1,
      anon_sym_RPAREN,
    ACTIONS(28377), 1,
      aux_sym_float_literal_token2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309379] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5278), 1,
      anon_sym_RBRACK,
    ACTIONS(28379), 1,
      anon_sym_LF,
  [309392] = 3,
    ACTIONS(9204), 1,
      anon_sym_RPAREN,
    ACTIONS(28381), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309403] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5792), 1,
      anon_sym_RBRACK,
    ACTIONS(28383), 1,
      anon_sym_LF,
  [309416] = 3,
    ACTIONS(28239), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309427] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28385), 1,
      anon_sym_RBRACK,
    ACTIONS(28387), 1,
      anon_sym_LF,
  [309440] = 3,
    ACTIONS(28343), 1,
      anon_sym_LPAREN,
    STATE(4346), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309451] = 3,
    ACTIONS(15706), 1,
      anon_sym_LBRACE,
    STATE(9476), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309462] = 3,
    ACTIONS(15608), 1,
      anon_sym_LBRACE,
    STATE(6248), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309473] = 3,
    ACTIONS(8562), 1,
      anon_sym_LBRACE,
    STATE(10721), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309484] = 3,
    ACTIONS(8648), 1,
      anon_sym_LBRACE,
    STATE(5179), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309495] = 3,
    ACTIONS(15574), 1,
      anon_sym_LBRACE,
    STATE(11350), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309506] = 3,
    ACTIONS(8916), 1,
      anon_sym_RPAREN,
    ACTIONS(28389), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309517] = 3,
    ACTIONS(9144), 1,
      anon_sym_RPAREN,
    ACTIONS(28391), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309528] = 3,
    ACTIONS(10434), 1,
      anon_sym_RPAREN,
    ACTIONS(28393), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309539] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28395), 1,
      anon_sym_RBRACK,
    ACTIONS(28397), 1,
      anon_sym_LF,
  [309552] = 3,
    ACTIONS(28399), 1,
      anon_sym_LPAREN,
    STATE(10437), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309563] = 3,
    ACTIONS(28401), 1,
      anon_sym_LPAREN,
    STATE(9821), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309574] = 3,
    ACTIONS(8994), 1,
      anon_sym_RPAREN,
    ACTIONS(28403), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309585] = 3,
    ACTIONS(28321), 1,
      anon_sym_LPAREN,
    STATE(10612), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309596] = 3,
    ACTIONS(28405), 1,
      anon_sym_LPAREN,
    STATE(10731), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309607] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5798), 1,
      anon_sym_RBRACK,
    ACTIONS(28407), 1,
      anon_sym_LF,
  [309620] = 3,
    ACTIONS(15574), 1,
      anon_sym_LBRACE,
    STATE(11234), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309631] = 3,
    ACTIONS(28405), 1,
      anon_sym_LPAREN,
    STATE(10735), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309642] = 3,
    ACTIONS(16038), 1,
      anon_sym_LBRACE,
    STATE(6618), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309653] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5018), 1,
      anon_sym_RBRACK,
    ACTIONS(28409), 1,
      anon_sym_LF,
  [309666] = 3,
    ACTIONS(28245), 1,
      anon_sym_LPAREN,
    STATE(9938), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309677] = 3,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    STATE(10172), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309688] = 3,
    ACTIONS(15574), 1,
      anon_sym_LBRACE,
    STATE(11238), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309699] = 3,
    ACTIONS(9982), 1,
      anon_sym_RPAREN,
    ACTIONS(28411), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309710] = 3,
    ACTIONS(9538), 1,
      anon_sym_RPAREN,
    ACTIONS(28413), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309721] = 3,
    ACTIONS(10480), 1,
      anon_sym_RPAREN,
    ACTIONS(28415), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309732] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28417), 1,
      anon_sym_RBRACK,
    ACTIONS(28419), 1,
      anon_sym_LF,
  [309745] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5366), 1,
      anon_sym_RBRACK,
    ACTIONS(28421), 1,
      anon_sym_LF,
  [309758] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5810), 1,
      anon_sym_RBRACK,
    ACTIONS(28423), 1,
      anon_sym_LF,
  [309771] = 3,
    ACTIONS(28219), 1,
      anon_sym_LPAREN,
    STATE(4889), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309782] = 3,
    ACTIONS(8722), 1,
      anon_sym_LBRACE,
    STATE(5496), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309793] = 3,
    ACTIONS(18899), 1,
      anon_sym_COMMA,
    STATE(14732), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309804] = 3,
    ACTIONS(8686), 1,
      anon_sym_LBRACE,
    STATE(6349), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309815] = 3,
    ACTIONS(28321), 1,
      anon_sym_LPAREN,
    STATE(10870), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309826] = 3,
    ACTIONS(15724), 1,
      anon_sym_LBRACE,
    STATE(11370), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309837] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28425), 1,
      anon_sym_RBRACK,
    ACTIONS(28427), 1,
      anon_sym_LF,
  [309850] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(496), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309861] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(16778), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309872] = 3,
    ACTIONS(10038), 1,
      anon_sym_RPAREN,
    ACTIONS(28431), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309883] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(501), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309894] = 3,
    ACTIONS(8608), 1,
      anon_sym_RPAREN,
    ACTIONS(28433), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309905] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28435), 1,
      anon_sym_RBRACK,
    ACTIONS(28437), 1,
      anon_sym_LF,
  [309918] = 3,
    ACTIONS(15688), 1,
      anon_sym_LBRACE,
    STATE(5830), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309929] = 3,
    ACTIONS(9314), 1,
      anon_sym_RPAREN,
    ACTIONS(28439), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309940] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5552), 1,
      anon_sym_RBRACK,
    ACTIONS(28441), 1,
      anon_sym_LF,
  [309953] = 3,
    ACTIONS(8540), 1,
      anon_sym_LBRACE,
    STATE(6273), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309964] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28443), 1,
      anon_sym_RBRACK,
    ACTIONS(28445), 1,
      anon_sym_LF,
  [309977] = 3,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(10010), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309988] = 3,
    ACTIONS(28181), 1,
      anon_sym_LPAREN,
    STATE(4445), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [309999] = 3,
    ACTIONS(28343), 1,
      anon_sym_LPAREN,
    STATE(4347), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310010] = 3,
    ACTIONS(10452), 1,
      anon_sym_RPAREN,
    ACTIONS(28447), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310021] = 3,
    ACTIONS(28405), 1,
      anon_sym_LPAREN,
    STATE(10809), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310032] = 3,
    ACTIONS(8744), 1,
      anon_sym_LBRACE,
    STATE(5143), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310043] = 3,
    ACTIONS(15668), 1,
      anon_sym_LBRACE,
    STATE(5205), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310054] = 3,
    ACTIONS(28205), 1,
      anon_sym_LPAREN,
    STATE(9316), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310065] = 3,
    ACTIONS(28449), 1,
      anon_sym_LPAREN,
    STATE(4559), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310076] = 3,
    ACTIONS(8744), 1,
      anon_sym_LBRACE,
    STATE(5148), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310087] = 3,
    ACTIONS(28317), 1,
      anon_sym_LPAREN,
    STATE(4319), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310098] = 3,
    ACTIONS(8744), 1,
      anon_sym_LBRACE,
    STATE(5153), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310109] = 3,
    ACTIONS(28451), 1,
      anon_sym_LPAREN,
    STATE(5765), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310120] = 3,
    ACTIONS(10500), 1,
      anon_sym_RPAREN,
    ACTIONS(28453), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310131] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5822), 1,
      anon_sym_RBRACK,
    ACTIONS(28455), 1,
      anon_sym_LF,
  [310144] = 3,
    ACTIONS(9410), 1,
      anon_sym_RPAREN,
    ACTIONS(28457), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310155] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28459), 1,
      anon_sym_RBRACK,
    ACTIONS(28461), 1,
      anon_sym_LF,
  [310168] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28463), 1,
      anon_sym_RBRACK,
    ACTIONS(28465), 1,
      anon_sym_LF,
  [310181] = 3,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    STATE(11165), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310192] = 3,
    ACTIONS(28199), 1,
      anon_sym_LPAREN,
    STATE(4304), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310203] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28467), 1,
      anon_sym_RBRACK,
    ACTIONS(28469), 1,
      anon_sym_LF,
  [310216] = 3,
    ACTIONS(10168), 1,
      anon_sym_RPAREN,
    ACTIONS(28471), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310227] = 3,
    ACTIONS(15608), 1,
      anon_sym_LBRACE,
    STATE(6251), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310238] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(17853), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310249] = 3,
    ACTIONS(15706), 1,
      anon_sym_LBRACE,
    STATE(9421), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310260] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5636), 1,
      anon_sym_RBRACK,
    ACTIONS(28473), 1,
      anon_sym_LF,
  [310273] = 3,
    ACTIONS(28317), 1,
      anon_sym_LPAREN,
    STATE(4287), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310284] = 3,
    ACTIONS(28475), 1,
      anon_sym_LPAREN,
    STATE(4933), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310295] = 3,
    ACTIONS(28477), 1,
      anon_sym_LPAREN,
    STATE(10397), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310306] = 3,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    STATE(11112), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310317] = 3,
    ACTIONS(15628), 1,
      anon_sym_LBRACE,
    STATE(5903), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310328] = 3,
    ACTIONS(28477), 1,
      anon_sym_LPAREN,
    STATE(10416), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310339] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28479), 1,
      anon_sym_RBRACK,
    ACTIONS(28481), 1,
      anon_sym_LF,
  [310352] = 3,
    ACTIONS(10470), 1,
      anon_sym_RPAREN,
    ACTIONS(28483), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310363] = 3,
    ACTIONS(28405), 1,
      anon_sym_LPAREN,
    STATE(10836), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310374] = 3,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    STATE(11149), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310385] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12336), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [310394] = 3,
    ACTIONS(9576), 1,
      anon_sym_RPAREN,
    ACTIONS(28485), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310405] = 3,
    ACTIONS(15574), 1,
      anon_sym_LBRACE,
    STATE(11254), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310416] = 3,
    ACTIONS(2906), 1,
      anon_sym_LBRACE,
    STATE(10389), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310427] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12176), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [310436] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5378), 1,
      anon_sym_RBRACK,
    ACTIONS(28487), 1,
      anon_sym_LF,
  [310449] = 3,
    ACTIONS(15608), 1,
      anon_sym_LBRACE,
    STATE(6259), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310460] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28489), 1,
      anon_sym_RBRACK,
    ACTIONS(28491), 1,
      anon_sym_LF,
  [310473] = 3,
    ACTIONS(28265), 1,
      anon_sym_LPAREN,
    STATE(9259), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310484] = 3,
    ACTIONS(10518), 1,
      anon_sym_RPAREN,
    ACTIONS(28493), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310495] = 3,
    ACTIONS(8672), 1,
      anon_sym_RPAREN,
    ACTIONS(28495), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310506] = 3,
    ACTIONS(28317), 1,
      anon_sym_LPAREN,
    STATE(4296), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310517] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5840), 1,
      anon_sym_RBRACK,
    ACTIONS(28497), 1,
      anon_sym_LF,
  [310530] = 3,
    ACTIONS(8744), 1,
      anon_sym_LBRACE,
    STATE(5164), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310541] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28499), 1,
      anon_sym_RBRACK,
    ACTIONS(28501), 1,
      anon_sym_LF,
  [310554] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28503), 1,
      anon_sym_RBRACK,
    ACTIONS(28505), 1,
      anon_sym_LF,
  [310567] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12096), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [310576] = 3,
    ACTIONS(28181), 1,
      anon_sym_LPAREN,
    STATE(4444), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310587] = 3,
    ACTIONS(28477), 1,
      anon_sym_LPAREN,
    STATE(10341), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310598] = 3,
    ACTIONS(19686), 1,
      anon_sym_LBRACE,
    STATE(6911), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310609] = 3,
    ACTIONS(9296), 1,
      anon_sym_RPAREN,
    ACTIONS(28507), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310620] = 3,
    ACTIONS(28451), 1,
      anon_sym_LPAREN,
    STATE(5677), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310631] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28509), 1,
      anon_sym_RBRACK,
    ACTIONS(28511), 1,
      anon_sym_LF,
  [310644] = 3,
    ACTIONS(8722), 1,
      anon_sym_LBRACE,
    STATE(5459), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310655] = 3,
    ACTIONS(28399), 1,
      anon_sym_LPAREN,
    STATE(10401), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310666] = 3,
    ACTIONS(9224), 1,
      anon_sym_RPAREN,
    ACTIONS(28513), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310677] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12144), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [310686] = 3,
    ACTIONS(19700), 1,
      anon_sym_LBRACE,
    STATE(6746), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310697] = 3,
    ACTIONS(9036), 1,
      anon_sym_RPAREN,
    ACTIONS(28515), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310708] = 3,
    ACTIONS(28367), 1,
      anon_sym_LPAREN,
    STATE(5120), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310719] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6188), 1,
      anon_sym_RBRACK,
    ACTIONS(28517), 1,
      anon_sym_LF,
  [310732] = 3,
    ACTIONS(28401), 1,
      anon_sym_LPAREN,
    STATE(9823), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310743] = 3,
    ACTIONS(8764), 1,
      anon_sym_LBRACE,
    STATE(5594), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310754] = 3,
    ACTIONS(28477), 1,
      anon_sym_LPAREN,
    STATE(10351), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310765] = 3,
    ACTIONS(13292), 1,
      anon_sym_LBRACE,
    STATE(11156), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310776] = 3,
    ACTIONS(28519), 1,
      anon_sym_LPAREN,
    STATE(4462), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310787] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(28521), 2,
      anon_sym_end,
      anon_sym_finally,
  [310796] = 3,
    ACTIONS(28523), 1,
      anon_sym_LPAREN,
    STATE(4590), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310807] = 3,
    ACTIONS(8540), 1,
      anon_sym_LBRACE,
    STATE(6390), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310818] = 3,
    ACTIONS(9242), 1,
      anon_sym_RPAREN,
    ACTIONS(28525), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310829] = 3,
    ACTIONS(15628), 1,
      anon_sym_LBRACE,
    STATE(5923), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310840] = 3,
    ACTIONS(28527), 1,
      anon_sym_LPAREN,
    STATE(4995), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310851] = 3,
    ACTIONS(8764), 1,
      anon_sym_LBRACE,
    STATE(5679), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310862] = 3,
    ACTIONS(28523), 1,
      anon_sym_LPAREN,
    STATE(4592), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310873] = 3,
    ACTIONS(28449), 1,
      anon_sym_LPAREN,
    STATE(4349), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310884] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28529), 1,
      anon_sym_RBRACK,
    ACTIONS(28531), 1,
      anon_sym_LF,
  [310897] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5858), 1,
      anon_sym_RBRACK,
    ACTIONS(28533), 1,
      anon_sym_LF,
  [310910] = 3,
    ACTIONS(8540), 1,
      anon_sym_LBRACE,
    STATE(6393), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310921] = 3,
    ACTIONS(8764), 1,
      anon_sym_LBRACE,
    STATE(5212), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310932] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28535), 1,
      anon_sym_RBRACK,
    ACTIONS(28537), 1,
      anon_sym_LF,
  [310945] = 3,
    ACTIONS(28519), 1,
      anon_sym_LPAREN,
    STATE(4566), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310956] = 3,
    ACTIONS(15628), 1,
      anon_sym_LBRACE,
    STATE(5929), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310967] = 3,
    ACTIONS(9446), 1,
      anon_sym_RPAREN,
    ACTIONS(28539), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310978] = 3,
    ACTIONS(15738), 1,
      anon_sym_LBRACE,
    STATE(6198), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [310989] = 3,
    ACTIONS(10076), 1,
      anon_sym_RPAREN,
    ACTIONS(28541), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311000] = 3,
    ACTIONS(19767), 1,
      anon_sym_LBRACE,
    STATE(7825), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311011] = 3,
    ACTIONS(28449), 1,
      anon_sym_LPAREN,
    STATE(4441), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311022] = 3,
    ACTIONS(28543), 1,
      anon_sym_LPAREN,
    STATE(4540), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311033] = 3,
    ACTIONS(8670), 1,
      anon_sym_RPAREN,
    ACTIONS(28545), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311044] = 3,
    ACTIONS(28475), 1,
      anon_sym_LPAREN,
    STATE(4937), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311055] = 3,
    ACTIONS(9614), 1,
      anon_sym_RPAREN,
    ACTIONS(28547), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311066] = 3,
    ACTIONS(10488), 1,
      anon_sym_RPAREN,
    ACTIONS(28549), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311077] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5396), 1,
      anon_sym_RBRACK,
    ACTIONS(28551), 1,
      anon_sym_LF,
  [311090] = 3,
    ACTIONS(15758), 1,
      anon_sym_LBRACE,
    STATE(11003), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311101] = 3,
    ACTIONS(15978), 1,
      anon_sym_LBRACE,
    STATE(5756), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311112] = 3,
    ACTIONS(9064), 1,
      anon_sym_RPAREN,
    ACTIONS(28553), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311123] = 3,
    ACTIONS(28449), 1,
      anon_sym_LPAREN,
    STATE(4512), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311134] = 3,
    ACTIONS(8764), 1,
      anon_sym_LBRACE,
    STATE(5585), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311145] = 3,
    ACTIONS(8722), 1,
      anon_sym_LBRACE,
    STATE(5526), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311156] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28555), 1,
      anon_sym_RBRACK,
    ACTIONS(28557), 1,
      anon_sym_LF,
  [311169] = 3,
    ACTIONS(28543), 1,
      anon_sym_LPAREN,
    STATE(4542), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311180] = 3,
    ACTIONS(28523), 1,
      anon_sym_LPAREN,
    STATE(4595), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311191] = 3,
    ACTIONS(28559), 1,
      anon_sym_LPAREN,
    STATE(10192), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311202] = 3,
    ACTIONS(28561), 1,
      anon_sym_LPAREN,
    STATE(10286), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311213] = 3,
    ACTIONS(865), 1,
      anon_sym_LBRACE,
    STATE(5680), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311224] = 3,
    ACTIONS(8562), 1,
      anon_sym_LBRACE,
    STATE(10535), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311235] = 3,
    ACTIONS(2906), 1,
      anon_sym_LBRACE,
    STATE(10504), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311246] = 3,
    ACTIONS(28561), 1,
      anon_sym_LPAREN,
    STATE(10235), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311257] = 3,
    ACTIONS(28205), 1,
      anon_sym_LPAREN,
    STATE(9312), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311268] = 3,
    ACTIONS(10556), 1,
      anon_sym_RPAREN,
    ACTIONS(28563), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311279] = 3,
    ACTIONS(28559), 1,
      anon_sym_LPAREN,
    STATE(10199), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311290] = 3,
    ACTIONS(2906), 1,
      anon_sym_LBRACE,
    STATE(10520), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311301] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5876), 1,
      anon_sym_RBRACK,
    ACTIONS(28565), 1,
      anon_sym_LF,
  [311314] = 3,
    ACTIONS(9464), 1,
      anon_sym_RPAREN,
    ACTIONS(28567), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311325] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28569), 1,
      anon_sym_RBRACK,
    ACTIONS(28571), 1,
      anon_sym_LF,
  [311338] = 3,
    ACTIONS(15958), 1,
      anon_sym_LBRACE,
    STATE(6172), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311349] = 3,
    ACTIONS(8562), 1,
      anon_sym_LBRACE,
    STATE(10583), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311360] = 3,
    ACTIONS(28573), 1,
      anon_sym_LPAREN,
    STATE(4410), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311371] = 3,
    ACTIONS(9162), 1,
      anon_sym_RPAREN,
    ACTIONS(28575), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311382] = 3,
    ACTIONS(865), 1,
      anon_sym_LBRACE,
    STATE(5782), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311393] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5330), 1,
      anon_sym_RBRACK,
    ACTIONS(28577), 1,
      anon_sym_LF,
  [311406] = 3,
    ACTIONS(28573), 1,
      anon_sym_LPAREN,
    STATE(4412), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311417] = 3,
    ACTIONS(865), 1,
      anon_sym_LBRACE,
    STATE(5803), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311428] = 3,
    ACTIONS(28579), 1,
      anon_sym_LPAREN,
    STATE(11474), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311439] = 3,
    ACTIONS(15958), 1,
      anon_sym_LBRACE,
    STATE(6235), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311450] = 3,
    ACTIONS(10206), 1,
      anon_sym_RPAREN,
    ACTIONS(28581), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311461] = 3,
    ACTIONS(28527), 1,
      anon_sym_LPAREN,
    STATE(4926), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311472] = 3,
    ACTIONS(20019), 1,
      anon_sym_LBRACE,
    STATE(6712), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311483] = 3,
    ACTIONS(15958), 1,
      anon_sym_LBRACE,
    STATE(6240), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311494] = 3,
    ACTIONS(9390), 1,
      anon_sym_RPAREN,
    ACTIONS(28583), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311505] = 3,
    ACTIONS(28399), 1,
      anon_sym_LPAREN,
    STATE(10444), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311516] = 3,
    ACTIONS(28475), 1,
      anon_sym_LPAREN,
    STATE(4944), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311527] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11894), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [311536] = 3,
    ACTIONS(9484), 1,
      anon_sym_RPAREN,
    ACTIONS(28585), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311547] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5654), 1,
      anon_sym_RBRACK,
    ACTIONS(28587), 1,
      anon_sym_LF,
  [311560] = 3,
    ACTIONS(10508), 1,
      anon_sym_RPAREN,
    ACTIONS(28589), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311571] = 3,
    ACTIONS(16038), 1,
      anon_sym_LBRACE,
    STATE(6471), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311582] = 3,
    ACTIONS(15706), 1,
      anon_sym_LBRACE,
    STATE(9454), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311593] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5296), 1,
      anon_sym_RBRACK,
    ACTIONS(28591), 1,
      anon_sym_LF,
  [311606] = 3,
    ACTIONS(18780), 1,
      anon_sym_COMMA,
    STATE(15085), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311617] = 3,
    ACTIONS(28523), 1,
      anon_sym_LPAREN,
    STATE(4605), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311628] = 3,
    ACTIONS(15608), 1,
      anon_sym_LBRACE,
    STATE(6268), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311639] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(473), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311650] = 3,
    ACTIONS(8540), 1,
      anon_sym_LBRACE,
    STATE(5965), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311661] = 3,
    ACTIONS(28451), 1,
      anon_sym_LPAREN,
    STATE(5687), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311672] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(17238), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311683] = 3,
    ACTIONS(9888), 1,
      anon_sym_RPAREN,
    ACTIONS(28593), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311694] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(488), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311705] = 3,
    ACTIONS(28189), 1,
      anon_sym_LPAREN,
    STATE(14327), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311716] = 3,
    ACTIONS(16038), 1,
      anon_sym_LBRACE,
    STATE(6481), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311727] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28595), 1,
      anon_sym_RBRACK,
    ACTIONS(28597), 1,
      anon_sym_LF,
  [311740] = 3,
    ACTIONS(28205), 1,
      anon_sym_LPAREN,
    STATE(9314), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311751] = 3,
    ACTIONS(15978), 1,
      anon_sym_LBRACE,
    STATE(5760), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311762] = 3,
    ACTIONS(10576), 1,
      anon_sym_RPAREN,
    ACTIONS(28599), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311773] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28601), 1,
      anon_sym_RBRACK,
    ACTIONS(28603), 1,
      anon_sym_LF,
  [311786] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5894), 1,
      anon_sym_RBRACK,
    ACTIONS(28605), 1,
      anon_sym_LF,
  [311799] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5522), 1,
      anon_sym_RBRACK,
    ACTIONS(28607), 1,
      anon_sym_LF,
  [311812] = 3,
    ACTIONS(15758), 1,
      anon_sym_LBRACE,
    STATE(11121), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311823] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28609), 1,
      anon_sym_RBRACK,
    ACTIONS(28611), 1,
      anon_sym_LF,
  [311836] = 3,
    ACTIONS(8852), 1,
      anon_sym_RPAREN,
    ACTIONS(28613), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311847] = 3,
    ACTIONS(15706), 1,
      anon_sym_LBRACE,
    STATE(9433), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311858] = 3,
    ACTIONS(28527), 1,
      anon_sym_LPAREN,
    STATE(4927), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311869] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2188), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [311878] = 3,
    ACTIONS(28265), 1,
      anon_sym_LPAREN,
    STATE(9252), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311889] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28615), 1,
      anon_sym_RBRACK,
    ACTIONS(28617), 1,
      anon_sym_LF,
  [311902] = 3,
    ACTIONS(20089), 1,
      anon_sym_LBRACE,
    STATE(7083), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311913] = 3,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    STATE(14366), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311924] = 3,
    ACTIONS(28367), 1,
      anon_sym_LPAREN,
    STATE(5135), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311935] = 3,
    ACTIONS(28573), 1,
      anon_sym_LPAREN,
    STATE(4419), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311946] = 3,
    ACTIONS(15516), 1,
      anon_sym_LBRACE,
    STATE(9376), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311957] = 3,
    ACTIONS(9650), 1,
      anon_sym_RPAREN,
    ACTIONS(28619), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311968] = 3,
    ACTIONS(15738), 1,
      anon_sym_LBRACE,
    STATE(6419), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [311979] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5414), 1,
      anon_sym_RBRACK,
    ACTIONS(28621), 1,
      anon_sym_LF,
  [311992] = 3,
    ACTIONS(28239), 1,
      anon_sym_LPAREN,
    STATE(4284), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312003] = 3,
    ACTIONS(10526), 1,
      anon_sym_RPAREN,
    ACTIONS(28623), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312014] = 3,
    ACTIONS(19787), 1,
      anon_sym_LBRACE,
    STATE(6916), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312025] = 3,
    ACTIONS(6314), 1,
      anon_sym_LBRACE,
    STATE(5023), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312036] = 3,
    ACTIONS(19068), 1,
      anon_sym_COMMA,
    STATE(14564), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312047] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(503), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312058] = 3,
    ACTIONS(28561), 1,
      anon_sym_LPAREN,
    STATE(10251), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312069] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(16856), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312080] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(505), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312091] = 3,
    ACTIONS(10594), 1,
      anon_sym_RPAREN,
    ACTIONS(28625), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312102] = 3,
    ACTIONS(28527), 1,
      anon_sym_LPAREN,
    STATE(4929), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312113] = 3,
    ACTIONS(28627), 1,
      anon_sym_LPAREN,
    STATE(4401), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312124] = 3,
    ACTIONS(15958), 1,
      anon_sym_LBRACE,
    STATE(6255), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312135] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5906), 1,
      anon_sym_RBRACK,
    ACTIONS(28629), 1,
      anon_sym_LF,
  [312148] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28631), 1,
      anon_sym_RBRACK,
    ACTIONS(28633), 1,
      anon_sym_LF,
  [312161] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28635), 1,
      anon_sym_RBRACK,
    ACTIONS(28637), 1,
      anon_sym_LF,
  [312174] = 3,
    ACTIONS(8602), 1,
      anon_sym_RPAREN,
    ACTIONS(28639), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312185] = 3,
    ACTIONS(9078), 1,
      anon_sym_RPAREN,
    ACTIONS(28641), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312196] = 3,
    ACTIONS(15932), 1,
      anon_sym_LBRACE,
    STATE(5703), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312207] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6292), 1,
      anon_sym_RBRACK,
    ACTIONS(28643), 1,
      anon_sym_LF,
  [312220] = 3,
    ACTIONS(28627), 1,
      anon_sym_LPAREN,
    STATE(4403), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312231] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12148), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [312240] = 3,
    ACTIONS(28519), 1,
      anon_sym_LPAREN,
    STATE(4467), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312251] = 3,
    ACTIONS(15932), 1,
      anon_sym_LBRACE,
    STATE(5779), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312262] = 3,
    ACTIONS(8648), 1,
      anon_sym_LBRACE,
    STATE(5027), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312273] = 3,
    ACTIONS(28573), 1,
      anon_sym_LPAREN,
    STATE(4425), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312284] = 3,
    ACTIONS(865), 1,
      anon_sym_LBRACE,
    STATE(5940), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312295] = 3,
    ACTIONS(15932), 1,
      anon_sym_LBRACE,
    STATE(5233), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312306] = 3,
    ACTIONS(9016), 1,
      anon_sym_RPAREN,
    ACTIONS(28645), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312317] = 3,
    ACTIONS(10112), 1,
      anon_sym_RPAREN,
    ACTIONS(28647), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312328] = 3,
    ACTIONS(15998), 1,
      anon_sym_LBRACE,
    STATE(11877), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312339] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28649), 1,
      anon_sym_RBRACK,
    ACTIONS(28651), 1,
      anon_sym_LF,
  [312352] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28653), 1,
      anon_sym_RBRACK,
    ACTIONS(28655), 1,
      anon_sym_LF,
  [312365] = 3,
    ACTIONS(28239), 1,
      anon_sym_LPAREN,
    STATE(4308), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312376] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28657), 1,
      anon_sym_RBRACK,
    ACTIONS(28659), 1,
      anon_sym_LF,
  [312389] = 3,
    ACTIONS(10546), 1,
      anon_sym_RPAREN,
    ACTIONS(28661), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312400] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12620), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [312409] = 3,
    ACTIONS(18812), 1,
      anon_sym_COMMA,
    STATE(14685), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312420] = 3,
    ACTIONS(10018), 1,
      anon_sym_RPAREN,
    ACTIONS(28663), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312431] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(511), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312442] = 3,
    ACTIONS(8648), 1,
      anon_sym_LBRACE,
    STATE(5035), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312453] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5260), 1,
      anon_sym_RBRACK,
    ACTIONS(28665), 1,
      anon_sym_LF,
  [312466] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(17193), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312477] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(469), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312488] = 3,
    ACTIONS(28667), 1,
      anon_sym_LPAREN,
    STATE(4955), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312499] = 3,
    ACTIONS(15998), 1,
      anon_sym_LBRACE,
    STATE(12191), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312510] = 3,
    ACTIONS(28579), 1,
      anon_sym_LPAREN,
    STATE(11521), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312521] = 3,
    ACTIONS(15998), 1,
      anon_sym_LBRACE,
    STATE(11861), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312532] = 3,
    ACTIONS(28627), 1,
      anon_sym_LPAREN,
    STATE(4404), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312543] = 3,
    ACTIONS(9104), 1,
      anon_sym_RPAREN,
    ACTIONS(28669), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312554] = 3,
    ACTIONS(10612), 1,
      anon_sym_RPAREN,
    ACTIONS(28671), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312565] = 3,
    ACTIONS(9558), 1,
      anon_sym_RPAREN,
    ACTIONS(28673), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312576] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5924), 1,
      anon_sym_RBRACK,
    ACTIONS(28675), 1,
      anon_sym_LF,
  [312589] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28677), 1,
      anon_sym_RBRACK,
    ACTIONS(28679), 1,
      anon_sym_LF,
  [312602] = 3,
    ACTIONS(9042), 1,
      anon_sym_RPAREN,
    ACTIONS(28681), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312613] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5570), 1,
      anon_sym_RBRACK,
    ACTIONS(28683), 1,
      anon_sym_LF,
  [312626] = 3,
    ACTIONS(9834), 1,
      anon_sym_RPAREN,
    ACTIONS(28685), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312637] = 3,
    ACTIONS(19104), 1,
      anon_sym_COMMA,
    STATE(14826), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312648] = 3,
    ACTIONS(8816), 1,
      anon_sym_RPAREN,
    ACTIONS(28687), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312659] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(497), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312670] = 3,
    ACTIONS(10242), 1,
      anon_sym_RPAREN,
    ACTIONS(28689), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312681] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(16802), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312692] = 3,
    ACTIONS(19889), 1,
      anon_sym_LBRACE,
    STATE(7893), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312703] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(502), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312714] = 3,
    ACTIONS(28691), 1,
      anon_sym_LPAREN,
    STATE(4312), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312725] = 3,
    ACTIONS(6314), 1,
      anon_sym_LBRACE,
    STATE(5050), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312736] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5672), 1,
      anon_sym_RBRACK,
    ACTIONS(28693), 1,
      anon_sym_LF,
  [312749] = 3,
    ACTIONS(28579), 1,
      anon_sym_LPAREN,
    STATE(11448), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312760] = 3,
    ACTIONS(10564), 1,
      anon_sym_RPAREN,
    ACTIONS(28695), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312771] = 3,
    ACTIONS(28691), 1,
      anon_sym_LPAREN,
    STATE(4315), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312782] = 3,
    ACTIONS(28627), 1,
      anon_sym_LPAREN,
    STATE(4405), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312793] = 3,
    ACTIONS(6314), 1,
      anon_sym_LBRACE,
    STATE(5055), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312804] = 3,
    ACTIONS(28561), 1,
      anon_sym_LPAREN,
    STATE(10285), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312815] = 3,
    ACTIONS(15932), 1,
      anon_sym_LBRACE,
    STATE(5309), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312826] = 3,
    ACTIONS(16084), 1,
      anon_sym_LBRACE,
    STATE(5242), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312837] = 3,
    ACTIONS(8562), 1,
      anon_sym_LBRACE,
    STATE(10727), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312848] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28697), 1,
      anon_sym_RBRACK,
    ACTIONS(28699), 1,
      anon_sym_LF,
  [312861] = 3,
    ACTIONS(18756), 1,
      anon_sym_COMMA,
    STATE(14936), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312872] = 3,
    ACTIONS(9690), 1,
      anon_sym_RPAREN,
    ACTIONS(28701), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312883] = 3,
    ACTIONS(9084), 1,
      anon_sym_RPAREN,
    ACTIONS(28703), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312894] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(515), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312905] = 3,
    ACTIONS(28165), 1,
      anon_sym_LPAREN,
    STATE(4359), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312916] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(16721), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312927] = 3,
    ACTIONS(10630), 1,
      anon_sym_RPAREN,
    ACTIONS(28705), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312938] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(465), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [312949] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5936), 1,
      anon_sym_RBRACK,
    ACTIONS(28707), 1,
      anon_sym_LF,
  [312962] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(28709), 2,
      anon_sym_end,
      anon_sym_catch,
  [312971] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5432), 1,
      anon_sym_RBRACK,
    ACTIONS(28711), 1,
      anon_sym_LF,
  [312984] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28713), 1,
      anon_sym_RBRACK,
    ACTIONS(28715), 1,
      anon_sym_LF,
  [312997] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11864), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [313006] = 3,
    ACTIONS(15588), 1,
      anon_sym_LBRACE,
    STATE(4968), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313017] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28717), 1,
      anon_sym_RBRACK,
    ACTIONS(28719), 1,
      anon_sym_LF,
  [313030] = 3,
    ACTIONS(28579), 1,
      anon_sym_LPAREN,
    STATE(11543), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313041] = 3,
    ACTIONS(19164), 1,
      anon_sym_COMMA,
    STATE(15002), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313052] = 3,
    ACTIONS(15998), 1,
      anon_sym_LBRACE,
    STATE(11907), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313063] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(475), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313074] = 3,
    ACTIONS(16018), 1,
      anon_sym_LBRACE,
    STATE(11168), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313085] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(17067), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313096] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(476), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313107] = 3,
    ACTIONS(15874), 1,
      anon_sym_LBRACE,
    STATE(10632), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313118] = 3,
    ACTIONS(28721), 1,
      anon_sym_LPAREN,
    STATE(4432), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313129] = 3,
    ACTIONS(16084), 1,
      anon_sym_LBRACE,
    STATE(5264), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313140] = 3,
    ACTIONS(28721), 1,
      anon_sym_LPAREN,
    STATE(4434), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313151] = 3,
    ACTIONS(16084), 1,
      anon_sym_LBRACE,
    STATE(5300), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313162] = 3,
    ACTIONS(10584), 1,
      anon_sym_RPAREN,
    ACTIONS(28723), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313173] = 3,
    ACTIONS(19518), 1,
      anon_sym_LBRACE,
    STATE(7084), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313184] = 3,
    ACTIONS(19005), 1,
      anon_sym_COMMA,
    STATE(15058), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313195] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28725), 1,
      anon_sym_RBRACK,
    ACTIONS(28727), 1,
      anon_sym_LF,
  [313208] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(486), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313219] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(16729), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313230] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(487), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313241] = 3,
    ACTIONS(9198), 1,
      anon_sym_RPAREN,
    ACTIONS(28729), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313252] = 3,
    ACTIONS(10648), 1,
      anon_sym_RPAREN,
    ACTIONS(28731), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313263] = 3,
    ACTIONS(18834), 1,
      anon_sym_COMMA,
    STATE(15102), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313274] = 3,
    ACTIONS(28733), 1,
      anon_sym_LPAREN,
    STATE(10417), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313285] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(499), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313296] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5948), 1,
      anon_sym_RBRACK,
    ACTIONS(28735), 1,
      anon_sym_LF,
  [313309] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(17081), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313320] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(516), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313331] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28737), 1,
      anon_sym_RBRACK,
    ACTIONS(28739), 1,
      anon_sym_LF,
  [313344] = 3,
    ACTIONS(16018), 1,
      anon_sym_LBRACE,
    STATE(11140), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313355] = 3,
    ACTIONS(28733), 1,
      anon_sym_LPAREN,
    STATE(10420), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313366] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(16706), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313377] = 3,
    ACTIONS(28401), 1,
      anon_sym_LPAREN,
    STATE(9822), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313388] = 3,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9876), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313399] = 3,
    ACTIONS(16018), 1,
      anon_sym_LBRACE,
    STATE(11145), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313410] = 3,
    ACTIONS(16058), 1,
      anon_sym_LBRACE,
    STATE(6597), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313421] = 3,
    ACTIONS(19185), 1,
      anon_sym_COMMA,
    STATE(15149), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313432] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5242), 1,
      anon_sym_RBRACK,
    ACTIONS(28741), 1,
      anon_sym_LF,
  [313445] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(507), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313456] = 3,
    ACTIONS(8942), 1,
      anon_sym_RPAREN,
    ACTIONS(28743), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313467] = 3,
    ACTIONS(10152), 1,
      anon_sym_RPAREN,
    ACTIONS(28745), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313478] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(17331), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313489] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(468), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313500] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5492), 1,
      anon_sym_RBRACK,
    ACTIONS(28747), 1,
      anon_sym_LF,
  [313513] = 3,
    ACTIONS(8788), 1,
      anon_sym_LBRACE,
    STATE(5191), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313524] = 3,
    ACTIONS(10620), 1,
      anon_sym_RPAREN,
    ACTIONS(28749), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313535] = 3,
    ACTIONS(8936), 1,
      anon_sym_RPAREN,
    ACTIONS(28751), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313546] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12324), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [313555] = 3,
    ACTIONS(28753), 1,
      anon_sym_LPAREN,
    STATE(9826), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313566] = 3,
    ACTIONS(28475), 1,
      anon_sym_LPAREN,
    STATE(4909), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313577] = 3,
    ACTIONS(15874), 1,
      anon_sym_LBRACE,
    STATE(10667), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313588] = 3,
    ACTIONS(28733), 1,
      anon_sym_LPAREN,
    STATE(10425), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313599] = 3,
    ACTIONS(19374), 1,
      anon_sym_COMMA,
    STATE(14818), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313610] = 3,
    ACTIONS(15758), 1,
      anon_sym_LBRACE,
    STATE(10977), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313621] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(513), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313632] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(17170), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313643] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(467), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313654] = 3,
    ACTIONS(10666), 1,
      anon_sym_RPAREN,
    ACTIONS(28755), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313665] = 3,
    ACTIONS(28559), 1,
      anon_sym_LPAREN,
    STATE(10189), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313676] = 3,
    ACTIONS(28221), 1,
      anon_sym_LPAREN,
    STATE(10258), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313687] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5966), 1,
      anon_sym_RBRACK,
    ACTIONS(28757), 1,
      anon_sym_LF,
  [313700] = 3,
    ACTIONS(8624), 1,
      anon_sym_RPAREN,
    ACTIONS(28759), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313711] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28761), 1,
      anon_sym_RBRACK,
    ACTIONS(28763), 1,
      anon_sym_LF,
  [313724] = 3,
    ACTIONS(28765), 1,
      anon_sym_LPAREN,
    STATE(4297), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313735] = 3,
    ACTIONS(15906), 1,
      anon_sym_LBRACE,
    STATE(4695), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313746] = 3,
    ACTIONS(28765), 1,
      anon_sym_LPAREN,
    STATE(4302), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313757] = 3,
    ACTIONS(18968), 1,
      anon_sym_COMMA,
    STATE(14670), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313768] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    STATE(6306), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313779] = 3,
    ACTIONS(28321), 1,
      anon_sym_LPAREN,
    STATE(10930), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313790] = 3,
    ACTIONS(10280), 1,
      anon_sym_RPAREN,
    ACTIONS(28767), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313801] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(483), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313812] = 3,
    ACTIONS(15906), 1,
      anon_sym_LBRACE,
    STATE(4700), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313823] = 3,
    ACTIONS(20009), 1,
      anon_sym_LBRACE,
    STATE(7087), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313834] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(16972), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313845] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(484), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313856] = 3,
    ACTIONS(15874), 1,
      anon_sym_LBRACE,
    STATE(10674), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313867] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5690), 1,
      anon_sym_RBRACK,
    ACTIONS(28769), 1,
      anon_sym_LF,
  [313880] = 3,
    ACTIONS(19203), 1,
      anon_sym_COMMA,
    STATE(15038), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313891] = 3,
    ACTIONS(28519), 1,
      anon_sym_LPAREN,
    STATE(4468), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313902] = 3,
    ACTIONS(28721), 1,
      anon_sym_LPAREN,
    STATE(4437), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313913] = 3,
    ACTIONS(15588), 1,
      anon_sym_LBRACE,
    STATE(4975), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313924] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12386), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [313933] = 3,
    ACTIONS(18820), 1,
      anon_sym_COMMA,
    STATE(14979), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313944] = 3,
    ACTIONS(10656), 1,
      anon_sym_RPAREN,
    ACTIONS(28771), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313955] = 3,
    ACTIONS(28733), 1,
      anon_sym_LPAREN,
    STATE(10428), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313966] = 3,
    ACTIONS(18925), 1,
      anon_sym_COMMA,
    STATE(14975), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313977] = 3,
    ACTIONS(28691), 1,
      anon_sym_LPAREN,
    STATE(4327), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313988] = 3,
    ACTIONS(16018), 1,
      anon_sym_LBRACE,
    STATE(10938), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [313999] = 3,
    ACTIONS(28199), 1,
      anon_sym_LPAREN,
    STATE(4307), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314010] = 3,
    ACTIONS(18740), 1,
      anon_sym_COMMA,
    STATE(14587), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314021] = 3,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    STATE(10061), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314032] = 3,
    ACTIONS(9926), 1,
      anon_sym_RPAREN,
    ACTIONS(28773), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314043] = 3,
    ACTIONS(19026), 1,
      anon_sym_COMMA,
    STATE(14642), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314054] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28775), 1,
      anon_sym_RBRACK,
    ACTIONS(28777), 1,
      anon_sym_LF,
  [314067] = 3,
    ACTIONS(18939), 1,
      anon_sym_COMMA,
    STATE(14746), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314078] = 3,
    ACTIONS(28779), 1,
      anon_sym_LPAREN,
    STATE(4305), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314089] = 3,
    ACTIONS(28543), 1,
      anon_sym_LPAREN,
    STATE(4547), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314100] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(504), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314111] = 3,
    ACTIONS(18792), 1,
      anon_sym_COMMA,
    STATE(14851), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314122] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    STATE(6310), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314133] = 3,
    ACTIONS(10686), 1,
      anon_sym_RPAREN,
    ACTIONS(28781), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314144] = 3,
    ACTIONS(18762), 1,
      anon_sym_COMMA,
    STATE(14947), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314155] = 3,
    ACTIONS(28667), 1,
      anon_sym_LPAREN,
    STATE(4974), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314166] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5984), 1,
      anon_sym_RBRACK,
    ACTIONS(28783), 1,
      anon_sym_LF,
  [314179] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    STATE(6312), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314190] = 3,
    ACTIONS(15588), 1,
      anon_sym_LBRACE,
    STATE(4979), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314201] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28785), 1,
      anon_sym_RBRACK,
    ACTIONS(28787), 1,
      anon_sym_LF,
  [314214] = 3,
    ACTIONS(18786), 1,
      anon_sym_COMMA,
    STATE(15027), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314225] = 3,
    ACTIONS(19062), 1,
      anon_sym_COMMA,
    STATE(15049), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314236] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(4846), 1,
      anon_sym_RBRACK,
    ACTIONS(28789), 1,
      anon_sym_LF,
  [314249] = 3,
    ACTIONS(28211), 1,
      anon_sym_LPAREN,
    STATE(4562), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314260] = 3,
    ACTIONS(9058), 1,
      anon_sym_RPAREN,
    ACTIONS(28791), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314271] = 3,
    ACTIONS(18950), 1,
      anon_sym_COMMA,
    STATE(15078), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314282] = 3,
    ACTIONS(8788), 1,
      anon_sym_LBRACE,
    STATE(5922), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314293] = 3,
    ACTIONS(9258), 1,
      anon_sym_RPAREN,
    ACTIONS(28793), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314304] = 3,
    ACTIONS(18893), 1,
      anon_sym_COMMA,
    STATE(15114), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314315] = 3,
    ACTIONS(20079), 1,
      anon_sym_LBRACE,
    STATE(7959), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314326] = 3,
    ACTIONS(18708), 1,
      anon_sym_COMMA,
    STATE(15139), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314337] = 3,
    ACTIONS(28211), 1,
      anon_sym_LPAREN,
    STATE(4564), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314348] = 3,
    ACTIONS(19110), 1,
      anon_sym_COMMA,
    STATE(15177), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314359] = 3,
    ACTIONS(8788), 1,
      anon_sym_LBRACE,
    STATE(5927), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314370] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5208), 1,
      anon_sym_RBRACK,
    ACTIONS(28795), 1,
      anon_sym_LF,
  [314383] = 3,
    ACTIONS(19344), 1,
      anon_sym_COMMA,
    STATE(15092), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314394] = 3,
    ACTIONS(15628), 1,
      anon_sym_LBRACE,
    STATE(5234), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314405] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12208), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [314414] = 3,
    ACTIONS(18840), 1,
      anon_sym_COMMA,
    STATE(14795), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314425] = 3,
    ACTIONS(9264), 1,
      anon_sym_RPAREN,
    ACTIONS(28797), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314436] = 3,
    ACTIONS(28753), 1,
      anon_sym_LPAREN,
    STATE(9844), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314447] = 3,
    ACTIONS(19253), 1,
      anon_sym_COMMA,
    STATE(14958), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314458] = 3,
    ACTIONS(18826), 1,
      anon_sym_COMMA,
    STATE(15003), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314469] = 3,
    ACTIONS(9116), 1,
      anon_sym_RPAREN,
    ACTIONS(28799), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314480] = 3,
    ACTIONS(19276), 1,
      anon_sym_COMMA,
    STATE(15067), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314491] = 3,
    ACTIONS(19819), 1,
      anon_sym_LBRACE,
    STATE(11575), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314502] = 3,
    ACTIONS(19080), 1,
      anon_sym_COMMA,
    STATE(15119), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314513] = 3,
    ACTIONS(9596), 1,
      anon_sym_RPAREN,
    ACTIONS(28801), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314524] = 3,
    ACTIONS(19092), 1,
      anon_sym_COMMA,
    STATE(14559), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314535] = 3,
    ACTIONS(19416), 1,
      anon_sym_COMMA,
    STATE(14572), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314546] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(4900), 1,
      anon_sym_RBRACK,
    ACTIONS(28803), 1,
      anon_sym_LF,
  [314559] = 3,
    ACTIONS(18768), 1,
      anon_sym_COMMA,
    STATE(14584), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314570] = 3,
    ACTIONS(28765), 1,
      anon_sym_LPAREN,
    STATE(4309), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314581] = 3,
    ACTIONS(19396), 1,
      anon_sym_COMMA,
    STATE(14596), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314592] = 3,
    ACTIONS(19056), 1,
      anon_sym_COMMA,
    STATE(14606), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314603] = 3,
    ACTIONS(28721), 1,
      anon_sym_LPAREN,
    STATE(4439), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314614] = 3,
    ACTIONS(18974), 1,
      anon_sym_COMMA,
    STATE(14617), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314625] = 3,
    ACTIONS(9280), 1,
      anon_sym_RPAREN,
    ACTIONS(28805), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314636] = 3,
    ACTIONS(16084), 1,
      anon_sym_LBRACE,
    STATE(5354), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314647] = 3,
    ACTIONS(18905), 1,
      anon_sym_COMMA,
    STATE(14633), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314658] = 3,
    ACTIONS(19038), 1,
      anon_sym_COMMA,
    STATE(14648), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314669] = 3,
    ACTIONS(19328), 1,
      anon_sym_COMMA,
    STATE(14660), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314680] = 3,
    ACTIONS(28399), 1,
      anon_sym_LPAREN,
    STATE(10336), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314691] = 3,
    ACTIONS(19011), 1,
      anon_sym_COMMA,
    STATE(14672), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314702] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6002), 1,
      anon_sym_RBRACK,
    ACTIONS(28807), 1,
      anon_sym_LF,
  [314715] = 3,
    ACTIONS(19032), 1,
      anon_sym_COMMA,
    STATE(14682), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314726] = 3,
    ACTIONS(28809), 1,
      anon_sym_LPAREN,
    STATE(5192), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314737] = 3,
    ACTIONS(18798), 1,
      anon_sym_COMMA,
    STATE(14697), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314748] = 3,
    ACTIONS(18774), 1,
      anon_sym_COMMA,
    STATE(14708), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314759] = 3,
    ACTIONS(19074), 1,
      anon_sym_COMMA,
    STATE(14719), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314770] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28811), 1,
      anon_sym_RBRACK,
    ACTIONS(28813), 1,
      anon_sym_LF,
  [314783] = 3,
    ACTIONS(19044), 1,
      anon_sym_COMMA,
    STATE(14729), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314794] = 3,
    ACTIONS(18980), 1,
      anon_sym_COMMA,
    STATE(14738), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314805] = 3,
    ACTIONS(16058), 1,
      anon_sym_LBRACE,
    STATE(6576), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314816] = 3,
    ACTIONS(19380), 1,
      anon_sym_COMMA,
    STATE(14748), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314827] = 3,
    ACTIONS(28809), 1,
      anon_sym_LPAREN,
    STATE(5195), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314838] = 3,
    ACTIONS(18746), 1,
      anon_sym_COMMA,
    STATE(14758), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314849] = 3,
    ACTIONS(16058), 1,
      anon_sym_LBRACE,
    STATE(6578), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314860] = 3,
    ACTIONS(19170), 1,
      anon_sym_COMMA,
    STATE(14769), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314871] = 3,
    ACTIONS(18696), 1,
      anon_sym_COMMA,
    STATE(14781), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314882] = 3,
    ACTIONS(9336), 1,
      anon_sym_RPAREN,
    ACTIONS(28815), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314893] = 3,
    ACTIONS(18962), 1,
      anon_sym_COMMA,
    STATE(14790), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314904] = 3,
    ACTIONS(19211), 1,
      anon_sym_COMMA,
    STATE(14805), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314915] = 3,
    ACTIONS(28401), 1,
      anon_sym_LPAREN,
    STATE(9824), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314926] = 3,
    ACTIONS(19316), 1,
      anon_sym_COMMA,
    STATE(14814), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314937] = 3,
    ACTIONS(9816), 1,
      anon_sym_RPAREN,
    ACTIONS(28817), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314948] = 3,
    ACTIONS(19050), 1,
      anon_sym_COMMA,
    STATE(14825), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314959] = 3,
    ACTIONS(15758), 1,
      anon_sym_LBRACE,
    STATE(11060), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314970] = 3,
    ACTIONS(18734), 1,
      anon_sym_COMMA,
    STATE(14835), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314981] = 3,
    ACTIONS(20169), 1,
      anon_sym_LBRACE,
    STATE(7164), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [314992] = 3,
    ACTIONS(18956), 1,
      anon_sym_COMMA,
    STATE(14843), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315003] = 3,
    ACTIONS(28189), 1,
      anon_sym_LPAREN,
    STATE(14329), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315014] = 3,
    ACTIONS(18933), 1,
      anon_sym_COMMA,
    STATE(14853), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315025] = 3,
    ACTIONS(19086), 1,
      anon_sym_COMMA,
    STATE(14861), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315036] = 3,
    ACTIONS(8954), 1,
      anon_sym_RPAREN,
    ACTIONS(28819), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315047] = 3,
    ACTIONS(19322), 1,
      anon_sym_COMMA,
    STATE(14870), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315058] = 3,
    ACTIONS(18690), 1,
      anon_sym_COMMA,
    STATE(14878), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315069] = 3,
    ACTIONS(10188), 1,
      anon_sym_RPAREN,
    ACTIONS(28821), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315080] = 3,
    ACTIONS(18911), 1,
      anon_sym_COMMA,
    STATE(14886), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315091] = 3,
    ACTIONS(18996), 1,
      anon_sym_COMMA,
    STATE(14896), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315102] = 3,
    ACTIONS(19098), 1,
      anon_sym_COMMA,
    STATE(14907), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315113] = 3,
    ACTIONS(9744), 1,
      anon_sym_RPAREN,
    ACTIONS(28823), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315124] = 3,
    ACTIONS(19191), 1,
      anon_sym_COMMA,
    STATE(14917), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315135] = 3,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    STATE(14362), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315146] = 3,
    ACTIONS(19268), 1,
      anon_sym_COMMA,
    STATE(14930), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315157] = 3,
    ACTIONS(10056), 1,
      anon_sym_RPAREN,
    ACTIONS(28825), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315168] = 3,
    ACTIONS(18919), 1,
      anon_sym_COMMA,
    STATE(14940), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315179] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28827), 1,
      anon_sym_RBRACK,
    ACTIONS(28829), 1,
      anon_sym_LF,
  [315192] = 3,
    ACTIONS(10674), 1,
      anon_sym_RPAREN,
    ACTIONS(28831), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315203] = 3,
    ACTIONS(9122), 1,
      anon_sym_RPAREN,
    ACTIONS(28833), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315214] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5118), 1,
      anon_sym_RBRACK,
    ACTIONS(28835), 1,
      anon_sym_LF,
  [315227] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14533), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315238] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5582), 1,
      anon_sym_RBRACK,
    ACTIONS(28837), 1,
      anon_sym_LF,
  [315251] = 3,
    ACTIONS(28667), 1,
      anon_sym_LPAREN,
    STATE(4983), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315262] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5354), 1,
      anon_sym_RBRACK,
    ACTIONS(28839), 1,
      anon_sym_LF,
  [315275] = 3,
    ACTIONS(8860), 1,
      anon_sym_RPAREN,
    ACTIONS(28841), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315286] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6256), 1,
      anon_sym_RBRACK,
    ACTIONS(28843), 1,
      anon_sym_LF,
  [315299] = 3,
    ACTIONS(9724), 1,
      anon_sym_RPAREN,
    ACTIONS(28845), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315310] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28847), 1,
      anon_sym_RBRACK,
    ACTIONS(28849), 1,
      anon_sym_LF,
  [315323] = 3,
    ACTIONS(10722), 1,
      anon_sym_RPAREN,
    ACTIONS(28851), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315334] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5444), 1,
      anon_sym_RBRACK,
    ACTIONS(28853), 1,
      anon_sym_LF,
  [315347] = 3,
    ACTIONS(28809), 1,
      anon_sym_LPAREN,
    STATE(5216), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315358] = 3,
    ACTIONS(28691), 1,
      anon_sym_LPAREN,
    STATE(4294), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315369] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6020), 1,
      anon_sym_RBRACK,
    ACTIONS(28855), 1,
      anon_sym_LF,
  [315382] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14505), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315393] = 3,
    ACTIONS(28667), 1,
      anon_sym_LPAREN,
    STATE(4986), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315404] = 3,
    ACTIONS(15778), 1,
      anon_sym_LBRACE,
    STATE(6335), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315415] = 3,
    ACTIONS(6314), 1,
      anon_sym_LBRACE,
    STATE(4575), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315426] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28857), 1,
      anon_sym_RBRACK,
    ACTIONS(28859), 1,
      anon_sym_LF,
  [315439] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28861), 1,
      anon_sym_RBRACK,
    ACTIONS(28863), 1,
      anon_sym_LF,
  [315452] = 3,
    ACTIONS(4990), 1,
      anon_sym_LBRACE,
    STATE(10627), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315463] = 3,
    ACTIONS(28181), 1,
      anon_sym_LPAREN,
    STATE(4446), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315474] = 3,
    ACTIONS(28765), 1,
      anon_sym_LPAREN,
    STATE(4332), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315485] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28865), 1,
      anon_sym_RBRACK,
    ACTIONS(28867), 1,
      anon_sym_LF,
  [315498] = 3,
    ACTIONS(15906), 1,
      anon_sym_LBRACE,
    STATE(4758), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315509] = 3,
    ACTIONS(20181), 1,
      anon_sym_LBRACE,
    STATE(11715), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315520] = 3,
    ACTIONS(8722), 1,
      anon_sym_LBRACE,
    STATE(5579), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315531] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5510), 1,
      anon_sym_RBRACK,
    ACTIONS(28869), 1,
      anon_sym_LF,
  [315544] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12234), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [315553] = 3,
    ACTIONS(28871), 1,
      anon_sym_LPAREN,
    STATE(10303), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315564] = 3,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(28873), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315575] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12168), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [315584] = 3,
    ACTIONS(4990), 1,
      anon_sym_LBRACE,
    STATE(10868), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315595] = 3,
    ACTIONS(28871), 1,
      anon_sym_LPAREN,
    STATE(10305), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315606] = 3,
    ACTIONS(4990), 1,
      anon_sym_LBRACE,
    STATE(10872), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315617] = 3,
    ACTIONS(10694), 1,
      anon_sym_RPAREN,
    ACTIONS(28875), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315628] = 3,
    ACTIONS(19983), 1,
      anon_sym_LBRACE,
    STATE(10236), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315639] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12238), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [315648] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12242), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [315657] = 3,
    ACTIONS(8686), 1,
      anon_sym_LBRACE,
    STATE(6372), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315668] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5708), 1,
      anon_sym_RBRACK,
    ACTIONS(28877), 1,
      anon_sym_LF,
  [315681] = 3,
    ACTIONS(28189), 1,
      anon_sym_LPAREN,
    STATE(14326), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315692] = 3,
    ACTIONS(15556), 1,
      anon_sym_LBRACE,
    STATE(4990), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315703] = 3,
    ACTIONS(28779), 1,
      anon_sym_LPAREN,
    STATE(4339), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315714] = 3,
    ACTIONS(28429), 1,
      anon_sym_LBRACE,
    STATE(482), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315725] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28879), 1,
      anon_sym_RBRACK,
    ACTIONS(28881), 1,
      anon_sym_LF,
  [315738] = 3,
    ACTIONS(15556), 1,
      anon_sym_LBRACE,
    STATE(4993), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315749] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12390), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [315758] = 3,
    ACTIONS(28809), 1,
      anon_sym_LPAREN,
    STATE(5229), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315769] = 3,
    ACTIONS(8830), 1,
      anon_sym_RPAREN,
    ACTIONS(28883), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315780] = 3,
    ACTIONS(9634), 1,
      anon_sym_RPAREN,
    ACTIONS(28885), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315791] = 3,
    ACTIONS(10740), 1,
      anon_sym_RPAREN,
    ACTIONS(28887), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315802] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12246), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [315811] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12250), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [315820] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6032), 1,
      anon_sym_RBRACK,
    ACTIONS(28889), 1,
      anon_sym_LF,
  [315833] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28891), 1,
      anon_sym_RBRACK,
    ACTIONS(28893), 1,
      anon_sym_LF,
  [315846] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28895), 1,
      anon_sym_RBRACK,
    ACTIONS(28897), 1,
      anon_sym_LF,
  [315859] = 3,
    ACTIONS(16058), 1,
      anon_sym_LBRACE,
    STATE(6592), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315870] = 3,
    ACTIONS(28221), 1,
      anon_sym_LPAREN,
    STATE(10270), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315881] = 3,
    ACTIONS(28779), 1,
      anon_sym_LPAREN,
    STATE(4310), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315892] = 3,
    ACTIONS(15516), 1,
      anon_sym_LBRACE,
    STATE(9359), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315903] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(28899), 2,
      anon_sym_end,
      anon_sym_finally,
  [315912] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6208), 1,
      anon_sym_RBRACK,
    ACTIONS(28901), 1,
      anon_sym_LF,
  [315925] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12254), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [315934] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12258), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [315943] = 3,
    ACTIONS(8980), 1,
      anon_sym_RPAREN,
    ACTIONS(28903), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315954] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28905), 1,
      anon_sym_RBRACK,
    ACTIONS(28907), 1,
      anon_sym_LF,
  [315967] = 3,
    ACTIONS(15648), 1,
      anon_sym_LBRACE,
    STATE(6067), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315978] = 3,
    ACTIONS(19020), 1,
      anon_sym_COMMA,
    STATE(14600), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [315989] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11890), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [315998] = 3,
    ACTIONS(9762), 1,
      anon_sym_RPAREN,
    ACTIONS(28909), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316009] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12056), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [316018] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14510), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316029] = 3,
    ACTIONS(28559), 1,
      anon_sym_LPAREN,
    STATE(10188), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316040] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5456), 1,
      anon_sym_RBRACK,
    ACTIONS(28911), 1,
      anon_sym_LF,
  [316053] = 3,
    ACTIONS(2906), 1,
      anon_sym_LBRACE,
    STATE(10321), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316064] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12156), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [316073] = 3,
    ACTIONS(28779), 1,
      anon_sym_LPAREN,
    STATE(4313), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316084] = 3,
    ACTIONS(10710), 1,
      anon_sym_RPAREN,
    ACTIONS(28913), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316095] = 3,
    ACTIONS(15556), 1,
      anon_sym_LBRACE,
    STATE(5002), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316106] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12064), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [316115] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14516), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316126] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12052), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [316135] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12262), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [316144] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12266), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [316153] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28915), 1,
      anon_sym_RBRACK,
    ACTIONS(28917), 1,
      anon_sym_LF,
  [316166] = 3,
    ACTIONS(28265), 1,
      anon_sym_LPAREN,
    STATE(9247), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316177] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12270), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [316186] = 3,
    ACTIONS(28871), 1,
      anon_sym_LPAREN,
    STATE(10315), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316197] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14518), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316208] = 3,
    ACTIONS(28451), 1,
      anon_sym_LPAREN,
    STATE(5795), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316219] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12278), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [316228] = 3,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    STATE(10049), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316239] = 3,
    ACTIONS(10760), 1,
      anon_sym_RPAREN,
    ACTIONS(28919), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316250] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14520), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316261] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6050), 1,
      anon_sym_RBRACK,
    ACTIONS(28921), 1,
      anon_sym_LF,
  [316274] = 3,
    ACTIONS(15556), 1,
      anon_sym_LBRACE,
    STATE(5018), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316285] = 3,
    ACTIONS(28211), 1,
      anon_sym_LPAREN,
    STATE(4565), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316296] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14522), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316307] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28923), 1,
      anon_sym_RBRACK,
    ACTIONS(28925), 1,
      anon_sym_LF,
  [316320] = 3,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(9985), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316331] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14525), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316342] = 3,
    ACTIONS(15906), 1,
      anon_sym_LBRACE,
    STATE(4666), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316353] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14527), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316364] = 3,
    ACTIONS(16038), 1,
      anon_sym_LBRACE,
    STATE(6531), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316375] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14529), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316386] = 3,
    ACTIONS(28199), 1,
      anon_sym_LPAREN,
    STATE(4291), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316397] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14531), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316408] = 3,
    ACTIONS(28927), 1,
      anon_sym_LPAREN,
    STATE(4530), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316419] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14534), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316430] = 3,
    ACTIONS(20159), 1,
      anon_sym_LBRACE,
    STATE(8012), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316441] = 3,
    ACTIONS(20203), 1,
      anon_sym_LBRACE,
    STATE(14536), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316452] = 3,
    ACTIONS(15688), 1,
      anon_sym_LBRACE,
    STATE(5698), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316463] = 3,
    ACTIONS(28927), 1,
      anon_sym_LPAREN,
    STATE(4532), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316474] = 3,
    ACTIONS(15688), 1,
      anon_sym_LBRACE,
    STATE(5704), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316485] = 3,
    ACTIONS(15360), 1,
      anon_sym_LBRACE,
    STATE(14381), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316496] = 3,
    ACTIONS(28169), 1,
      anon_sym_LPAREN,
    STATE(4708), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316507] = 3,
    ACTIONS(15648), 1,
      anon_sym_LBRACE,
    STATE(6417), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316518] = 3,
    ACTIONS(9670), 1,
      anon_sym_RPAREN,
    ACTIONS(28929), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316529] = 3,
    ACTIONS(28169), 1,
      anon_sym_LPAREN,
    STATE(4710), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316540] = 3,
    ACTIONS(15668), 1,
      anon_sym_LBRACE,
    STATE(5330), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316551] = 3,
    ACTIONS(10730), 1,
      anon_sym_RPAREN,
    ACTIONS(28931), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316562] = 3,
    ACTIONS(15648), 1,
      anon_sym_LBRACE,
    STATE(6421), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316573] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28933), 1,
      anon_sym_RBRACK,
    ACTIONS(28935), 1,
      anon_sym_LF,
  [316586] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28937), 1,
      anon_sym_RBRACK,
    ACTIONS(28939), 1,
      anon_sym_LF,
  [316599] = 3,
    ACTIONS(28543), 1,
      anon_sym_LPAREN,
    STATE(4552), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316610] = 3,
    ACTIONS(9426), 1,
      anon_sym_RPAREN,
    ACTIONS(28941), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316621] = 3,
    ACTIONS(28753), 1,
      anon_sym_LPAREN,
    STATE(9851), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316632] = 3,
    ACTIONS(28927), 1,
      anon_sym_LPAREN,
    STATE(4534), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316643] = 3,
    ACTIONS(10226), 1,
      anon_sym_RPAREN,
    ACTIONS(28943), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316654] = 3,
    ACTIONS(15978), 1,
      anon_sym_LBRACE,
    STATE(5800), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316665] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(28945), 2,
      anon_sym_end,
      anon_sym_catch,
  [316674] = 3,
    ACTIONS(10776), 1,
      anon_sym_RPAREN,
    ACTIONS(28947), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316685] = 3,
    ACTIONS(9000), 1,
      anon_sym_RPAREN,
    ACTIONS(28949), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316696] = 3,
    ACTIONS(9796), 1,
      anon_sym_RPAREN,
    ACTIONS(28951), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316707] = 3,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    STATE(10051), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316718] = 3,
    ACTIONS(28753), 1,
      anon_sym_LPAREN,
    STATE(9832), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316729] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5474), 1,
      anon_sym_RBRACK,
    ACTIONS(28953), 1,
      anon_sym_LF,
  [316742] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(5024), 1,
      anon_sym_RBRACK,
    ACTIONS(28955), 1,
      anon_sym_LF,
  [316755] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12060), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [316764] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12044), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [316773] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12274), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [316782] = 3,
    ACTIONS(9500), 1,
      anon_sym_RPAREN,
    ACTIONS(28957), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316793] = 3,
    ACTIONS(28871), 1,
      anon_sym_LPAREN,
    STATE(10317), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316804] = 3,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    STATE(10053), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316815] = 3,
    ACTIONS(28927), 1,
      anon_sym_LPAREN,
    STATE(4535), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316826] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(6068), 1,
      anon_sym_RBRACK,
    ACTIONS(28959), 1,
      anon_sym_LF,
  [316839] = 3,
    ACTIONS(15688), 1,
      anon_sym_LBRACE,
    STATE(5727), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316850] = 3,
    ACTIONS(4990), 1,
      anon_sym_LBRACE,
    STATE(10901), 1,
      sym_curly_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316861] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(169), 1,
      sym_line_comment,
    ACTIONS(28961), 1,
      anon_sym_RBRACK,
    ACTIONS(28963), 1,
      anon_sym_LF,
  [316874] = 3,
    ACTIONS(9138), 1,
      anon_sym_RPAREN,
    ACTIONS(28965), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316885] = 2,
    ACTIONS(28967), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316893] = 2,
    ACTIONS(28969), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316901] = 2,
    ACTIONS(10348), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316909] = 2,
    ACTIONS(7600), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316917] = 2,
    ACTIONS(28971), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316925] = 2,
    ACTIONS(28973), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316933] = 2,
    ACTIONS(28975), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316941] = 2,
    ACTIONS(28977), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316949] = 2,
    ACTIONS(28979), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316957] = 2,
    ACTIONS(28981), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316965] = 2,
    ACTIONS(28983), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316973] = 2,
    ACTIONS(28985), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316981] = 2,
    ACTIONS(28987), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316989] = 2,
    ACTIONS(28989), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [316997] = 2,
    ACTIONS(28991), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317005] = 2,
    ACTIONS(23963), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317013] = 2,
    ACTIONS(28993), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317021] = 2,
    ACTIONS(23472), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317029] = 2,
    ACTIONS(28995), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317037] = 2,
    ACTIONS(28997), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317045] = 2,
    ACTIONS(28999), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317053] = 2,
    ACTIONS(29001), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317061] = 2,
    ACTIONS(21674), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317069] = 2,
    ACTIONS(24025), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317077] = 2,
    ACTIONS(15498), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317085] = 2,
    ACTIONS(29003), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317093] = 2,
    ACTIONS(29005), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317101] = 2,
    ACTIONS(7552), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317109] = 2,
    ACTIONS(29007), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317117] = 2,
    ACTIONS(8970), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317125] = 2,
    ACTIONS(21704), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317133] = 2,
    ACTIONS(29009), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317141] = 2,
    ACTIONS(10518), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317149] = 2,
    ACTIONS(29011), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317157] = 2,
    ACTIONS(7210), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317165] = 2,
    ACTIONS(17645), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317173] = 2,
    ACTIONS(10928), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317181] = 2,
    ACTIONS(29013), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317189] = 2,
    ACTIONS(29015), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317197] = 2,
    ACTIONS(29017), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317205] = 2,
    ACTIONS(29019), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317213] = 2,
    ACTIONS(22750), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317221] = 2,
    ACTIONS(29021), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317229] = 2,
    ACTIONS(15386), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317237] = 2,
    ACTIONS(29023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317245] = 2,
    ACTIONS(29025), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317253] = 2,
    ACTIONS(29027), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317261] = 2,
    ACTIONS(8244), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317269] = 2,
    ACTIONS(23590), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317277] = 2,
    ACTIONS(29029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317285] = 2,
    ACTIONS(7512), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317293] = 2,
    ACTIONS(11998), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317301] = 2,
    ACTIONS(29031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317309] = 2,
    ACTIONS(10034), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317317] = 2,
    ACTIONS(7274), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317325] = 2,
    ACTIONS(29033), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317333] = 2,
    ACTIONS(7692), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317341] = 2,
    ACTIONS(29035), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317349] = 2,
    ACTIONS(29037), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317357] = 2,
    ACTIONS(23912), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317365] = 2,
    ACTIONS(29039), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317373] = 2,
    ACTIONS(29041), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317381] = 2,
    ACTIONS(29043), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317389] = 2,
    ACTIONS(29045), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317397] = 2,
    ACTIONS(29047), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317405] = 2,
    ACTIONS(29049), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317413] = 2,
    ACTIONS(29051), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317421] = 2,
    ACTIONS(29053), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317429] = 2,
    ACTIONS(29055), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317437] = 2,
    ACTIONS(29057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317445] = 2,
    ACTIONS(29059), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317453] = 2,
    ACTIONS(9406), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317461] = 2,
    ACTIONS(29061), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317469] = 2,
    ACTIONS(29063), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317477] = 2,
    ACTIONS(21500), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317485] = 2,
    ACTIONS(29065), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317493] = 2,
    ACTIONS(29067), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317501] = 2,
    ACTIONS(15400), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317509] = 2,
    ACTIONS(29069), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317517] = 2,
    ACTIONS(29071), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317525] = 2,
    ACTIONS(8322), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317533] = 2,
    ACTIONS(15456), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317541] = 2,
    ACTIONS(29073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317549] = 2,
    ACTIONS(29075), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317557] = 2,
    ACTIONS(29077), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317565] = 2,
    ACTIONS(29079), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317573] = 2,
    ACTIONS(12026), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317581] = 2,
    ACTIONS(29081), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317589] = 2,
    ACTIONS(15408), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317597] = 2,
    ACTIONS(29083), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317605] = 2,
    ACTIONS(29085), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317613] = 2,
    ACTIONS(29087), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317621] = 2,
    ACTIONS(29089), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317629] = 2,
    ACTIONS(29091), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317637] = 2,
    ACTIONS(29093), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317645] = 2,
    ACTIONS(29095), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317653] = 2,
    ACTIONS(29097), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317661] = 2,
    ACTIONS(29099), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317669] = 2,
    ACTIONS(21504), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317677] = 2,
    ACTIONS(23512), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317685] = 2,
    ACTIONS(7640), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317693] = 2,
    ACTIONS(29101), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317701] = 2,
    ACTIONS(29103), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317709] = 2,
    ACTIONS(17880), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317717] = 2,
    ACTIONS(7176), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317725] = 2,
    ACTIONS(23916), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317733] = 2,
    ACTIONS(29105), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317741] = 2,
    ACTIONS(12014), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317749] = 2,
    ACTIONS(29107), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317757] = 2,
    ACTIONS(13247), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317765] = 2,
    ACTIONS(29109), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317773] = 2,
    ACTIONS(29111), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317781] = 2,
    ACTIONS(29113), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317789] = 2,
    ACTIONS(29115), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317797] = 2,
    ACTIONS(8932), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317805] = 2,
    ACTIONS(21622), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317813] = 2,
    ACTIONS(29117), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317821] = 2,
    ACTIONS(29119), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317829] = 2,
    ACTIONS(29121), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317837] = 2,
    ACTIONS(9036), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317845] = 2,
    ACTIONS(29123), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317853] = 2,
    ACTIONS(9352), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317861] = 2,
    ACTIONS(29125), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317869] = 2,
    ACTIONS(29127), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317877] = 2,
    ACTIONS(8252), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317885] = 2,
    ACTIONS(9312), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317893] = 2,
    ACTIONS(29129), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317901] = 2,
    ACTIONS(29131), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317909] = 2,
    ACTIONS(29133), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317917] = 2,
    ACTIONS(23975), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317925] = 2,
    ACTIONS(29135), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317933] = 2,
    ACTIONS(29137), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317941] = 2,
    ACTIONS(21302), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317949] = 2,
    ACTIONS(21658), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317957] = 2,
    ACTIONS(29139), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317965] = 2,
    ACTIONS(10758), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317973] = 2,
    ACTIONS(29141), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317981] = 2,
    ACTIONS(10872), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317989] = 2,
    ACTIONS(7380), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [317997] = 2,
    ACTIONS(29143), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318005] = 2,
    ACTIONS(29145), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318013] = 2,
    ACTIONS(29147), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318021] = 2,
    ACTIONS(29149), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318029] = 2,
    ACTIONS(8452), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318037] = 2,
    ACTIONS(29151), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318045] = 2,
    ACTIONS(29153), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318053] = 2,
    ACTIONS(15388), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318061] = 2,
    ACTIONS(29155), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318069] = 2,
    ACTIONS(10966), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318077] = 2,
    ACTIONS(29157), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318085] = 2,
    ACTIONS(29159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318093] = 2,
    ACTIONS(29161), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318101] = 2,
    ACTIONS(21318), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318109] = 2,
    ACTIONS(29163), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318117] = 2,
    ACTIONS(29165), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318125] = 2,
    ACTIONS(29167), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318133] = 2,
    ACTIONS(23524), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318141] = 2,
    ACTIONS(29169), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318149] = 2,
    ACTIONS(29171), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318157] = 2,
    ACTIONS(9242), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318165] = 2,
    ACTIONS(27877), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318173] = 2,
    ACTIONS(29173), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318181] = 2,
    ACTIONS(29175), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318189] = 2,
    ACTIONS(29177), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318197] = 2,
    ACTIONS(29179), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318205] = 2,
    ACTIONS(29181), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318213] = 2,
    ACTIONS(10930), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318221] = 2,
    ACTIONS(29183), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318229] = 2,
    ACTIONS(29185), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318237] = 2,
    ACTIONS(29187), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318245] = 2,
    ACTIONS(15466), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318253] = 2,
    ACTIONS(29189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318261] = 2,
    ACTIONS(29191), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318269] = 2,
    ACTIONS(29193), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318277] = 2,
    ACTIONS(7568), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318285] = 2,
    ACTIONS(7882), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318293] = 2,
    ACTIONS(29195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318301] = 2,
    ACTIONS(29197), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318309] = 2,
    ACTIONS(29199), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318317] = 2,
    ACTIONS(9832), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318325] = 2,
    ACTIONS(29201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318333] = 2,
    ACTIONS(29203), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318341] = 2,
    ACTIONS(10054), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318349] = 2,
    ACTIONS(29205), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318357] = 2,
    ACTIONS(29207), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318365] = 2,
    ACTIONS(7698), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318373] = 2,
    ACTIONS(29209), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318381] = 2,
    ACTIONS(9554), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318389] = 2,
    ACTIONS(29211), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318397] = 2,
    ACTIONS(29213), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318405] = 2,
    ACTIONS(29215), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318413] = 2,
    ACTIONS(29217), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318421] = 2,
    ACTIONS(29219), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318429] = 2,
    ACTIONS(29221), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318437] = 2,
    ACTIONS(29223), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318445] = 2,
    ACTIONS(29225), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318453] = 2,
    ACTIONS(29227), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318461] = 2,
    ACTIONS(7630), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318469] = 2,
    ACTIONS(29229), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318477] = 2,
    ACTIONS(21326), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318485] = 2,
    ACTIONS(29231), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318493] = 2,
    ACTIONS(10148), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318501] = 2,
    ACTIONS(29233), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318509] = 2,
    ACTIONS(29235), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318517] = 2,
    ACTIONS(29237), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318525] = 2,
    ACTIONS(29239), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318533] = 2,
    ACTIONS(29241), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318541] = 2,
    ACTIONS(17744), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318549] = 2,
    ACTIONS(29243), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318557] = 2,
    ACTIONS(29245), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318565] = 2,
    ACTIONS(29247), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318573] = 2,
    ACTIONS(29249), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318581] = 2,
    ACTIONS(29251), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318589] = 2,
    ACTIONS(23560), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318597] = 2,
    ACTIONS(29253), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318605] = 2,
    ACTIONS(29255), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318613] = 2,
    ACTIONS(29257), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318621] = 2,
    ACTIONS(9216), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318629] = 2,
    ACTIONS(29259), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318637] = 2,
    ACTIONS(29261), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318645] = 2,
    ACTIONS(8256), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318653] = 2,
    ACTIONS(29263), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318661] = 2,
    ACTIONS(8494), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318669] = 2,
    ACTIONS(29265), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318677] = 2,
    ACTIONS(15486), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318685] = 2,
    ACTIONS(29267), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318693] = 2,
    ACTIONS(29269), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318701] = 2,
    ACTIONS(8048), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318709] = 2,
    ACTIONS(21528), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318717] = 2,
    ACTIONS(29271), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318725] = 2,
    ACTIONS(29273), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318733] = 2,
    ACTIONS(29275), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318741] = 2,
    ACTIONS(29277), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318749] = 2,
    ACTIONS(29279), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318757] = 2,
    ACTIONS(9614), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318765] = 2,
    ACTIONS(29281), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318773] = 2,
    ACTIONS(21708), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318781] = 2,
    ACTIONS(29283), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318789] = 2,
    ACTIONS(29285), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318797] = 2,
    ACTIONS(10414), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318805] = 2,
    ACTIONS(29287), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318813] = 2,
    ACTIONS(29289), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318821] = 2,
    ACTIONS(29291), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318829] = 2,
    ACTIONS(8086), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318837] = 2,
    ACTIONS(29293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318845] = 2,
    ACTIONS(21338), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318853] = 2,
    ACTIONS(29295), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318861] = 2,
    ACTIONS(21132), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318869] = 2,
    ACTIONS(29297), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318877] = 2,
    ACTIONS(29299), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318885] = 2,
    ACTIONS(21434), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318893] = 2,
    ACTIONS(29301), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318901] = 2,
    ACTIONS(29303), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318909] = 2,
    ACTIONS(29305), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318917] = 2,
    ACTIONS(15434), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318925] = 2,
    ACTIONS(29307), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318933] = 2,
    ACTIONS(29309), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318941] = 2,
    ACTIONS(29311), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318949] = 2,
    ACTIONS(29313), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318957] = 2,
    ACTIONS(29315), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318965] = 2,
    ACTIONS(7288), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318973] = 2,
    ACTIONS(29317), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318981] = 2,
    ACTIONS(29319), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318989] = 2,
    ACTIONS(29321), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [318997] = 2,
    ACTIONS(29323), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319005] = 2,
    ACTIONS(11982), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319013] = 2,
    ACTIONS(29325), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319021] = 2,
    ACTIONS(29327), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319029] = 2,
    ACTIONS(29329), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319037] = 2,
    ACTIONS(29331), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319045] = 2,
    ACTIONS(8848), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319053] = 2,
    ACTIONS(9162), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319061] = 2,
    ACTIONS(15398), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319069] = 2,
    ACTIONS(15464), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319077] = 2,
    ACTIONS(29333), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319085] = 2,
    ACTIONS(9332), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319093] = 2,
    ACTIONS(17822), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319101] = 2,
    ACTIONS(29335), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319109] = 2,
    ACTIONS(29337), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319117] = 2,
    ACTIONS(10366), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319125] = 2,
    ACTIONS(29339), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319133] = 2,
    ACTIONS(10556), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319141] = 2,
    ACTIONS(23935), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319149] = 2,
    ACTIONS(15506), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319157] = 2,
    ACTIONS(9904), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319165] = 2,
    ACTIONS(29341), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319173] = 2,
    ACTIONS(29343), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319181] = 2,
    ACTIONS(10932), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319189] = 2,
    ACTIONS(29345), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319197] = 2,
    ACTIONS(10350), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319205] = 2,
    ACTIONS(9464), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319213] = 2,
    ACTIONS(29347), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319221] = 2,
    ACTIONS(29349), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319229] = 2,
    ACTIONS(29351), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319237] = 2,
    ACTIONS(28261), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319245] = 2,
    ACTIONS(29353), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319253] = 2,
    ACTIONS(29355), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319261] = 2,
    ACTIONS(8052), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319269] = 2,
    ACTIONS(12034), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319277] = 2,
    ACTIONS(29357), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319285] = 2,
    ACTIONS(29359), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319293] = 2,
    ACTIONS(29361), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319301] = 2,
    ACTIONS(29363), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319309] = 2,
    ACTIONS(29365), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319317] = 2,
    ACTIONS(7708), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319325] = 2,
    ACTIONS(10128), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319333] = 2,
    ACTIONS(21352), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319341] = 2,
    ACTIONS(29367), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319349] = 2,
    ACTIONS(29369), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319357] = 2,
    ACTIONS(29371), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319365] = 2,
    ACTIONS(10888), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319373] = 2,
    ACTIONS(22532), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319381] = 2,
    ACTIONS(29373), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319389] = 2,
    ACTIONS(7984), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319397] = 2,
    ACTIONS(29375), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319405] = 2,
    ACTIONS(10968), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319413] = 2,
    ACTIONS(29377), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319421] = 2,
    ACTIONS(29379), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319429] = 2,
    ACTIONS(29381), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319437] = 2,
    ACTIONS(29383), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319445] = 2,
    ACTIONS(8102), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319453] = 2,
    ACTIONS(29385), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319461] = 2,
    ACTIONS(21348), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319469] = 2,
    ACTIONS(17752), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319477] = 2,
    ACTIONS(9390), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319485] = 2,
    ACTIONS(29387), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319493] = 2,
    ACTIONS(29389), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319501] = 2,
    ACTIONS(15396), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319509] = 2,
    ACTIONS(21120), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319517] = 2,
    ACTIONS(10206), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319525] = 2,
    ACTIONS(29391), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319533] = 2,
    ACTIONS(22592), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319541] = 2,
    ACTIONS(29393), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319549] = 2,
    ACTIONS(29395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319557] = 2,
    ACTIONS(29397), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319565] = 2,
    ACTIONS(7886), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319573] = 2,
    ACTIONS(29399), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319581] = 2,
    ACTIONS(29401), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319589] = 2,
    ACTIONS(22948), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319597] = 2,
    ACTIONS(29403), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319605] = 2,
    ACTIONS(29405), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319613] = 2,
    ACTIONS(9592), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319621] = 2,
    ACTIONS(10906), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319629] = 2,
    ACTIONS(21546), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319637] = 2,
    ACTIONS(29407), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319645] = 2,
    ACTIONS(21136), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319653] = 2,
    ACTIONS(29409), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319661] = 2,
    ACTIONS(23959), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319669] = 2,
    ACTIONS(29411), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319677] = 2,
    ACTIONS(11990), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319685] = 2,
    ACTIONS(29413), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319693] = 2,
    ACTIONS(9980), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319701] = 2,
    ACTIONS(21712), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319709] = 2,
    ACTIONS(29415), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319717] = 2,
    ACTIONS(29417), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319725] = 2,
    ACTIONS(9958), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319733] = 2,
    ACTIONS(18124), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319741] = 2,
    ACTIONS(29419), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319749] = 2,
    ACTIONS(29421), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319757] = 2,
    ACTIONS(29423), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319765] = 2,
    ACTIONS(29425), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319773] = 2,
    ACTIONS(29427), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319781] = 2,
    ACTIONS(29429), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319789] = 2,
    ACTIONS(29431), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319797] = 2,
    ACTIONS(21268), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319805] = 2,
    ACTIONS(29433), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319813] = 2,
    ACTIONS(29435), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319821] = 2,
    ACTIONS(29437), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319829] = 2,
    ACTIONS(10720), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319837] = 2,
    ACTIONS(29439), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319845] = 2,
    ACTIONS(29441), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319853] = 2,
    ACTIONS(29443), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319861] = 2,
    ACTIONS(29445), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319869] = 2,
    ACTIONS(21666), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319877] = 2,
    ACTIONS(29447), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319885] = 2,
    ACTIONS(29449), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319893] = 2,
    ACTIONS(29451), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319901] = 2,
    ACTIONS(29453), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319909] = 2,
    ACTIONS(15474), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319917] = 2,
    ACTIONS(29455), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319925] = 2,
    ACTIONS(29457), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319933] = 2,
    ACTIONS(29459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319941] = 2,
    ACTIONS(29461), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319949] = 2,
    ACTIONS(29463), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319957] = 2,
    ACTIONS(23600), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319965] = 2,
    ACTIONS(15470), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319973] = 2,
    ACTIONS(7564), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319981] = 2,
    ACTIONS(15374), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319989] = 2,
    ACTIONS(29465), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [319997] = 2,
    ACTIONS(29467), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320005] = 2,
    ACTIONS(29469), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320013] = 2,
    ACTIONS(10576), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320021] = 2,
    ACTIONS(8602), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320029] = 2,
    ACTIONS(29471), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320037] = 2,
    ACTIONS(29473), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320045] = 2,
    ACTIONS(10934), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320053] = 2,
    ACTIONS(23953), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320061] = 2,
    ACTIONS(29475), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320069] = 2,
    ACTIONS(29477), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320077] = 2,
    ACTIONS(29479), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320085] = 2,
    ACTIONS(15460), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320093] = 2,
    ACTIONS(29481), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320101] = 2,
    ACTIONS(9012), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320109] = 2,
    ACTIONS(7228), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320117] = 2,
    ACTIONS(29483), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320125] = 2,
    ACTIONS(10814), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320133] = 2,
    ACTIONS(29485), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320141] = 2,
    ACTIONS(7244), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320149] = 2,
    ACTIONS(29487), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320157] = 2,
    ACTIONS(29489), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320165] = 2,
    ACTIONS(10416), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320173] = 2,
    ACTIONS(29491), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320181] = 2,
    ACTIONS(7722), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320189] = 2,
    ACTIONS(22986), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320197] = 2,
    ACTIONS(29493), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320205] = 2,
    ACTIONS(29495), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320213] = 2,
    ACTIONS(24021), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320221] = 2,
    ACTIONS(29497), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320229] = 2,
    ACTIONS(29499), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320237] = 2,
    ACTIONS(29501), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320245] = 2,
    ACTIONS(29503), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320253] = 2,
    ACTIONS(29505), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320261] = 2,
    ACTIONS(29507), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320269] = 2,
    ACTIONS(15392), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320277] = 2,
    ACTIONS(29509), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320285] = 2,
    ACTIONS(29511), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320293] = 2,
    ACTIONS(29513), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320301] = 2,
    ACTIONS(29515), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320309] = 2,
    ACTIONS(10918), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320317] = 2,
    ACTIONS(29517), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320325] = 2,
    ACTIONS(29519), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320333] = 2,
    ACTIONS(29521), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320341] = 2,
    ACTIONS(29523), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320349] = 2,
    ACTIONS(29525), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320357] = 2,
    ACTIONS(8380), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320365] = 2,
    ACTIONS(29527), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320373] = 2,
    ACTIONS(29529), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320381] = 2,
    ACTIONS(29531), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320389] = 2,
    ACTIONS(29533), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320397] = 2,
    ACTIONS(15472), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320405] = 2,
    ACTIONS(21558), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320413] = 2,
    ACTIONS(29535), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320421] = 2,
    ACTIONS(29537), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320429] = 2,
    ACTIONS(9650), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320437] = 2,
    ACTIONS(29539), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320445] = 2,
    ACTIONS(10960), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320453] = 2,
    ACTIONS(29541), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320461] = 2,
    ACTIONS(29543), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320469] = 2,
    ACTIONS(15428), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320477] = 2,
    ACTIONS(7582), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320485] = 2,
    ACTIONS(29545), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320493] = 2,
    ACTIONS(29547), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320501] = 2,
    ACTIONS(29549), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320509] = 2,
    ACTIONS(29551), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320517] = 2,
    ACTIONS(29553), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320525] = 2,
    ACTIONS(29555), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320533] = 2,
    ACTIONS(10462), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320541] = 2,
    ACTIONS(29557), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320549] = 2,
    ACTIONS(9812), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320557] = 2,
    ACTIONS(10072), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320565] = 2,
    ACTIONS(29559), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320573] = 2,
    ACTIONS(29561), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320581] = 2,
    ACTIONS(29563), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320589] = 2,
    ACTIONS(29565), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320597] = 2,
    ACTIONS(29567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320605] = 2,
    ACTIONS(29569), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320613] = 2,
    ACTIONS(29571), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320621] = 2,
    ACTIONS(29573), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320629] = 2,
    ACTIONS(29575), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320637] = 2,
    ACTIONS(29577), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320645] = 2,
    ACTIONS(29579), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320653] = 2,
    ACTIONS(29581), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320661] = 2,
    ACTIONS(8318), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320669] = 2,
    ACTIONS(29583), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320677] = 2,
    ACTIONS(29585), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320685] = 2,
    ACTIONS(29587), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320693] = 2,
    ACTIONS(12552), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320701] = 2,
    ACTIONS(29589), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320709] = 2,
    ACTIONS(29591), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320717] = 2,
    ACTIONS(15426), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320725] = 2,
    ACTIONS(29593), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320733] = 2,
    ACTIONS(29595), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320741] = 2,
    ACTIONS(23614), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320749] = 2,
    ACTIONS(29597), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320757] = 2,
    ACTIONS(23612), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320765] = 2,
    ACTIONS(29599), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320773] = 2,
    ACTIONS(21322), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320781] = 2,
    ACTIONS(29601), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320789] = 2,
    ACTIONS(7646), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320797] = 2,
    ACTIONS(29603), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320805] = 2,
    ACTIONS(29605), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320813] = 2,
    ACTIONS(29607), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320821] = 2,
    ACTIONS(15380), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320829] = 2,
    ACTIONS(29609), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320837] = 2,
    ACTIONS(29611), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320845] = 2,
    ACTIONS(29613), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320853] = 2,
    ACTIONS(29615), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320861] = 2,
    ACTIONS(29617), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320869] = 2,
    ACTIONS(29619), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320877] = 2,
    ACTIONS(10594), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320885] = 2,
    ACTIONS(29621), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320893] = 2,
    ACTIONS(29623), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320901] = 2,
    ACTIONS(10936), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320909] = 2,
    ACTIONS(29625), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320917] = 2,
    ACTIONS(29627), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320925] = 2,
    ACTIONS(29629), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320933] = 2,
    ACTIONS(29631), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320941] = 2,
    ACTIONS(29633), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320949] = 2,
    ACTIONS(9480), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320957] = 2,
    ACTIONS(23965), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320965] = 2,
    ACTIONS(29635), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320973] = 2,
    ACTIONS(29637), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320981] = 2,
    ACTIONS(9834), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320989] = 2,
    ACTIONS(29639), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [320997] = 2,
    ACTIONS(29641), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321005] = 2,
    ACTIONS(29643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321013] = 2,
    ACTIONS(29645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321021] = 2,
    ACTIONS(29647), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321029] = 2,
    ACTIONS(7736), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321037] = 2,
    ACTIONS(29649), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321045] = 2,
    ACTIONS(21116), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321053] = 2,
    ACTIONS(9078), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321061] = 2,
    ACTIONS(7308), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321069] = 2,
    ACTIONS(23967), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321077] = 2,
    ACTIONS(29651), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321085] = 2,
    ACTIONS(7032), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321093] = 2,
    ACTIONS(8486), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321101] = 2,
    ACTIONS(29653), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321109] = 2,
    ACTIONS(29655), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321117] = 2,
    ACTIONS(29657), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321125] = 2,
    ACTIONS(9388), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321133] = 2,
    ACTIONS(29659), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321141] = 2,
    ACTIONS(29661), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321149] = 2,
    ACTIONS(29663), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321157] = 2,
    ACTIONS(10914), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321165] = 2,
    ACTIONS(29665), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321173] = 2,
    ACTIONS(17742), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321181] = 2,
    ACTIONS(23949), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321189] = 2,
    ACTIONS(29667), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321197] = 2,
    ACTIONS(29669), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321205] = 2,
    ACTIONS(15452), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321213] = 2,
    ACTIONS(15432), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321221] = 2,
    ACTIONS(29671), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321229] = 2,
    ACTIONS(29673), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321237] = 2,
    ACTIONS(29675), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321245] = 2,
    ACTIONS(29677), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321253] = 2,
    ACTIONS(29679), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321261] = 2,
    ACTIONS(7110), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321269] = 2,
    ACTIONS(10184), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321277] = 2,
    ACTIONS(10796), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321285] = 2,
    ACTIONS(29681), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321293] = 2,
    ACTIONS(29683), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321301] = 2,
    ACTIONS(29685), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321309] = 2,
    ACTIONS(29687), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321317] = 2,
    ACTIONS(29689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321325] = 2,
    ACTIONS(29691), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321333] = 2,
    ACTIONS(29693), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321341] = 2,
    ACTIONS(17864), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321349] = 2,
    ACTIONS(29695), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321357] = 2,
    ACTIONS(29697), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321365] = 2,
    ACTIONS(29699), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321373] = 2,
    ACTIONS(29701), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321381] = 2,
    ACTIONS(29703), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321389] = 2,
    ACTIONS(23634), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321397] = 2,
    ACTIONS(29705), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321405] = 2,
    ACTIONS(29707), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321413] = 2,
    ACTIONS(29709), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321421] = 2,
    ACTIONS(21570), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321429] = 2,
    ACTIONS(29711), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321437] = 2,
    ACTIONS(29713), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321445] = 2,
    ACTIONS(29715), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321453] = 2,
    ACTIONS(27274), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321461] = 2,
    ACTIONS(29717), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321469] = 2,
    ACTIONS(7430), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321477] = 2,
    ACTIONS(29719), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321485] = 2,
    ACTIONS(29721), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321493] = 2,
    ACTIONS(8098), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321501] = 2,
    ACTIONS(29723), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321509] = 2,
    ACTIONS(29725), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321517] = 2,
    ACTIONS(8872), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321525] = 2,
    ACTIONS(29727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321533] = 2,
    ACTIONS(29729), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321541] = 2,
    ACTIONS(7694), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321549] = 2,
    ACTIONS(7850), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321557] = 2,
    ACTIONS(29731), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321565] = 2,
    ACTIONS(29733), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321573] = 2,
    ACTIONS(12800), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321581] = 2,
    ACTIONS(29735), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321589] = 2,
    ACTIONS(29737), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321597] = 2,
    ACTIONS(10018), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321605] = 2,
    ACTIONS(21446), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321613] = 2,
    ACTIONS(29739), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321621] = 2,
    ACTIONS(21378), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321629] = 2,
    ACTIONS(9292), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321637] = 2,
    ACTIONS(29741), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321645] = 2,
    ACTIONS(7192), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321653] = 2,
    ACTIONS(29743), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321661] = 2,
    ACTIONS(29745), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321669] = 2,
    ACTIONS(29747), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321677] = 2,
    ACTIONS(8430), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321685] = 2,
    ACTIONS(29749), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321693] = 2,
    ACTIONS(29751), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321701] = 2,
    ACTIONS(29753), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321709] = 2,
    ACTIONS(29755), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321717] = 2,
    ACTIONS(8160), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321725] = 2,
    ACTIONS(29757), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321733] = 2,
    ACTIONS(29759), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321741] = 2,
    ACTIONS(29761), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321749] = 2,
    ACTIONS(9042), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321757] = 2,
    ACTIONS(29763), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321765] = 2,
    ACTIONS(10832), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321773] = 2,
    ACTIONS(10958), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321781] = 2,
    ACTIONS(29765), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321789] = 2,
    ACTIONS(29767), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321797] = 2,
    ACTIONS(29769), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321805] = 2,
    ACTIONS(29771), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321813] = 2,
    ACTIONS(15488), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321821] = 2,
    ACTIONS(17798), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321829] = 2,
    ACTIONS(29773), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321837] = 2,
    ACTIONS(29775), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321845] = 2,
    ACTIONS(29777), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321853] = 2,
    ACTIONS(29779), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321861] = 2,
    ACTIONS(29781), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321869] = 2,
    ACTIONS(15384), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321877] = 2,
    ACTIONS(29783), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321885] = 2,
    ACTIONS(10612), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321893] = 2,
    ACTIONS(29785), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321901] = 2,
    ACTIONS(29787), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321909] = 2,
    ACTIONS(29789), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321917] = 2,
    ACTIONS(29791), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321925] = 2,
    ACTIONS(29793), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321933] = 2,
    ACTIONS(9630), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321941] = 2,
    ACTIONS(29795), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321949] = 2,
    ACTIONS(10938), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321957] = 2,
    ACTIONS(29797), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321965] = 2,
    ACTIONS(29799), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321973] = 2,
    ACTIONS(9922), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321981] = 2,
    ACTIONS(29801), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321989] = 2,
    ACTIONS(29803), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [321997] = 2,
    ACTIONS(29805), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322005] = 2,
    ACTIONS(29807), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322013] = 2,
    ACTIONS(15402), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322021] = 2,
    ACTIONS(21576), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322029] = 2,
    ACTIONS(29809), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322037] = 2,
    ACTIONS(29811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322045] = 2,
    ACTIONS(29813), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322053] = 2,
    ACTIONS(7744), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322061] = 2,
    ACTIONS(29815), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322069] = 2,
    ACTIONS(29817), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322077] = 2,
    ACTIONS(22808), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322085] = 2,
    ACTIONS(12482), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322093] = 2,
    ACTIONS(29819), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322101] = 2,
    ACTIONS(29821), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322109] = 2,
    ACTIONS(29823), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322117] = 2,
    ACTIONS(29825), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322125] = 2,
    ACTIONS(8010), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322133] = 2,
    ACTIONS(7396), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322141] = 2,
    ACTIONS(29827), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322149] = 2,
    ACTIONS(29829), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322157] = 2,
    ACTIONS(17651), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322165] = 2,
    ACTIONS(29831), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322173] = 2,
    ACTIONS(21718), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322181] = 2,
    ACTIONS(29833), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322189] = 2,
    ACTIONS(10242), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322197] = 2,
    ACTIONS(29835), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322205] = 2,
    ACTIONS(29837), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322213] = 2,
    ACTIONS(29839), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322221] = 2,
    ACTIONS(29841), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322229] = 2,
    ACTIONS(29843), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322237] = 2,
    ACTIONS(29845), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322245] = 2,
    ACTIONS(29847), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322253] = 2,
    ACTIONS(10130), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322261] = 2,
    ACTIONS(29849), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322269] = 2,
    ACTIONS(10908), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322277] = 2,
    ACTIONS(21582), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322285] = 2,
    ACTIONS(29851), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322293] = 2,
    ACTIONS(29853), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322301] = 2,
    ACTIONS(15480), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322309] = 2,
    ACTIONS(29855), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322317] = 2,
    ACTIONS(29857), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322325] = 2,
    ACTIONS(29859), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322333] = 2,
    ACTIONS(29861), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322341] = 2,
    ACTIONS(29863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322349] = 2,
    ACTIONS(29865), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322357] = 2,
    ACTIONS(29867), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322365] = 2,
    ACTIONS(15438), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322373] = 2,
    ACTIONS(29869), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322381] = 2,
    ACTIONS(15482), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322389] = 2,
    ACTIONS(29871), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322397] = 2,
    ACTIONS(9084), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322405] = 2,
    ACTIONS(9254), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322413] = 2,
    ACTIONS(29873), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322421] = 2,
    ACTIONS(29875), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322429] = 2,
    ACTIONS(29877), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322437] = 2,
    ACTIONS(10444), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322445] = 2,
    ACTIONS(29879), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322453] = 2,
    ACTIONS(29881), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322461] = 2,
    ACTIONS(29883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322469] = 2,
    ACTIONS(29885), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322477] = 2,
    ACTIONS(29887), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322485] = 2,
    ACTIONS(29889), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322493] = 2,
    ACTIONS(8090), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322501] = 2,
    ACTIONS(29891), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322509] = 2,
    ACTIONS(29893), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322517] = 2,
    ACTIONS(29895), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322525] = 2,
    ACTIONS(29897), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322533] = 2,
    ACTIONS(17968), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322541] = 2,
    ACTIONS(10920), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322549] = 2,
    ACTIONS(9690), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322557] = 2,
    ACTIONS(9198), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322565] = 2,
    ACTIONS(7578), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322573] = 2,
    ACTIONS(29899), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322581] = 2,
    ACTIONS(29901), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322589] = 2,
    ACTIONS(29903), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322597] = 2,
    ACTIONS(15454), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322605] = 2,
    ACTIONS(29905), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322613] = 2,
    ACTIONS(29907), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322621] = 2,
    ACTIONS(29909), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322629] = 2,
    ACTIONS(8874), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322637] = 2,
    ACTIONS(23040), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322645] = 2,
    ACTIONS(10630), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322653] = 2,
    ACTIONS(29911), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322661] = 2,
    ACTIONS(29913), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322669] = 2,
    ACTIONS(29915), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322677] = 2,
    ACTIONS(29917), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322685] = 2,
    ACTIONS(10940), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322693] = 2,
    ACTIONS(29919), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322701] = 2,
    ACTIONS(29921), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322709] = 2,
    ACTIONS(29923), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322717] = 2,
    ACTIONS(29925), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322725] = 2,
    ACTIONS(29927), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322733] = 2,
    ACTIONS(29929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322741] = 2,
    ACTIONS(10498), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322749] = 2,
    ACTIONS(29931), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322757] = 2,
    ACTIONS(29933), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322765] = 2,
    ACTIONS(29935), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322773] = 2,
    ACTIONS(29937), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322781] = 2,
    ACTIONS(29939), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322789] = 2,
    ACTIONS(8356), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322797] = 2,
    ACTIONS(29941), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322805] = 2,
    ACTIONS(7658), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322813] = 2,
    ACTIONS(29943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322821] = 2,
    ACTIONS(10902), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322829] = 2,
    ACTIONS(29945), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322837] = 2,
    ACTIONS(7752), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322845] = 2,
    ACTIONS(29947), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322853] = 2,
    ACTIONS(29949), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322861] = 2,
    ACTIONS(29951), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322869] = 2,
    ACTIONS(29953), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322877] = 2,
    ACTIONS(29955), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322885] = 2,
    ACTIONS(29957), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322893] = 2,
    ACTIONS(29959), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322901] = 2,
    ACTIONS(29961), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322909] = 2,
    ACTIONS(29963), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322917] = 2,
    ACTIONS(21478), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322925] = 2,
    ACTIONS(29965), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322933] = 2,
    ACTIONS(29967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322941] = 2,
    ACTIONS(29969), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322949] = 2,
    ACTIONS(29971), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322957] = 2,
    ACTIONS(15222), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322965] = 2,
    ACTIONS(7480), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322973] = 2,
    ACTIONS(29973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322981] = 2,
    ACTIONS(29975), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322989] = 2,
    ACTIONS(29977), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [322997] = 2,
    ACTIONS(29979), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323005] = 2,
    ACTIONS(21158), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323013] = 2,
    ACTIONS(24023), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323021] = 2,
    ACTIONS(29981), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323029] = 2,
    ACTIONS(29983), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323037] = 2,
    ACTIONS(10204), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323045] = 2,
    ACTIONS(29985), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323053] = 2,
    ACTIONS(29987), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323061] = 2,
    ACTIONS(29989), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323069] = 2,
    ACTIONS(29991), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323077] = 2,
    ACTIONS(29993), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323085] = 2,
    ACTIONS(21682), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323093] = 2,
    ACTIONS(29995), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323101] = 2,
    ACTIONS(8586), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323109] = 2,
    ACTIONS(21594), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323117] = 2,
    ACTIONS(15458), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323125] = 2,
    ACTIONS(8992), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323133] = 2,
    ACTIONS(29997), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323141] = 2,
    ACTIONS(23951), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323149] = 2,
    ACTIONS(29999), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323157] = 2,
    ACTIONS(30001), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323165] = 2,
    ACTIONS(10646), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323173] = 2,
    ACTIONS(30003), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323181] = 2,
    ACTIONS(23372), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323189] = 2,
    ACTIONS(30005), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323197] = 2,
    ACTIONS(30007), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323205] = 2,
    ACTIONS(30009), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323213] = 2,
    ACTIONS(30011), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323221] = 2,
    ACTIONS(30013), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323229] = 2,
    ACTIONS(7956), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323237] = 2,
    ACTIONS(30015), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323245] = 2,
    ACTIONS(30017), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323253] = 2,
    ACTIONS(17894), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323261] = 2,
    ACTIONS(30019), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323269] = 2,
    ACTIONS(30021), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323277] = 2,
    ACTIONS(30023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323285] = 2,
    ACTIONS(23060), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323293] = 2,
    ACTIONS(30025), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323301] = 2,
    ACTIONS(30027), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323309] = 2,
    ACTIONS(30029), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323317] = 2,
    ACTIONS(30031), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323325] = 2,
    ACTIONS(30033), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323333] = 2,
    ACTIONS(8384), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323341] = 2,
    ACTIONS(30035), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323349] = 2,
    ACTIONS(30037), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323357] = 2,
    ACTIONS(8068), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323365] = 2,
    ACTIONS(21686), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323373] = 2,
    ACTIONS(30039), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323381] = 2,
    ACTIONS(21460), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323389] = 2,
    ACTIONS(30041), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323397] = 2,
    ACTIONS(30043), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323405] = 2,
    ACTIONS(21356), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323413] = 2,
    ACTIONS(30045), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323421] = 2,
    ACTIONS(7324), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323429] = 2,
    ACTIONS(30047), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323437] = 2,
    ACTIONS(15382), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323445] = 2,
    ACTIONS(30049), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323453] = 2,
    ACTIONS(30051), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323461] = 2,
    ACTIONS(22654), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323469] = 2,
    ACTIONS(30053), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323477] = 2,
    ACTIONS(9760), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323485] = 2,
    ACTIONS(30055), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323493] = 2,
    ACTIONS(23961), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323501] = 2,
    ACTIONS(10648), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323509] = 2,
    ACTIONS(30057), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323517] = 2,
    ACTIONS(30059), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323525] = 2,
    ACTIONS(30061), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323533] = 2,
    ACTIONS(30063), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323541] = 2,
    ACTIONS(10942), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323549] = 2,
    ACTIONS(12670), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323557] = 2,
    ACTIONS(30065), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323565] = 2,
    ACTIONS(30067), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323573] = 2,
    ACTIONS(30069), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323581] = 2,
    ACTIONS(30071), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323589] = 2,
    ACTIONS(30073), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323597] = 2,
    ACTIONS(30075), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323605] = 2,
    ACTIONS(30077), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323613] = 2,
    ACTIONS(30079), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323621] = 2,
    ACTIONS(7996), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323629] = 2,
    ACTIONS(30081), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323637] = 2,
    ACTIONS(30083), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323645] = 2,
    ACTIONS(30085), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323653] = 2,
    ACTIONS(8890), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323661] = 2,
    ACTIONS(30087), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323669] = 2,
    ACTIONS(30089), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323677] = 2,
    ACTIONS(30091), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323685] = 2,
    ACTIONS(8072), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323693] = 2,
    ACTIONS(7762), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323701] = 2,
    ACTIONS(30093), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323709] = 2,
    ACTIONS(30095), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323717] = 2,
    ACTIONS(30097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323725] = 2,
    ACTIONS(23684), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323733] = 2,
    ACTIONS(30099), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323741] = 2,
    ACTIONS(22830), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323749] = 2,
    ACTIONS(30101), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323757] = 2,
    ACTIONS(7534), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323765] = 2,
    ACTIONS(30103), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323773] = 2,
    ACTIONS(30105), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323781] = 2,
    ACTIONS(9688), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323789] = 2,
    ACTIONS(24029), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323797] = 2,
    ACTIONS(30107), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323805] = 2,
    ACTIONS(30109), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323813] = 2,
    ACTIONS(30111), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323821] = 2,
    ACTIONS(10222), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323829] = 2,
    ACTIONS(30113), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323837] = 2,
    ACTIONS(30115), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323845] = 2,
    ACTIONS(12202), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323853] = 2,
    ACTIONS(7446), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323861] = 2,
    ACTIONS(30117), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323869] = 2,
    ACTIONS(30119), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323877] = 2,
    ACTIONS(9778), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323885] = 2,
    ACTIONS(15204), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323893] = 2,
    ACTIONS(30121), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323901] = 2,
    ACTIONS(9054), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323909] = 2,
    ACTIONS(30123), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323917] = 2,
    ACTIONS(30125), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323925] = 2,
    ACTIONS(30127), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323933] = 2,
    ACTIONS(9314), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323941] = 2,
    ACTIONS(30129), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323949] = 2,
    ACTIONS(21606), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323957] = 2,
    ACTIONS(23991), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323965] = 2,
    ACTIONS(30131), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323973] = 2,
    ACTIONS(30133), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323981] = 2,
    ACTIONS(30135), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323989] = 2,
    ACTIONS(30137), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [323997] = 2,
    ACTIONS(21330), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324005] = 2,
    ACTIONS(30139), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324013] = 2,
    ACTIONS(30141), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324021] = 2,
    ACTIONS(30143), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324029] = 2,
    ACTIONS(9612), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324037] = 2,
    ACTIONS(30145), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324045] = 2,
    ACTIONS(30147), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324053] = 2,
    ACTIONS(7974), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324061] = 2,
    ACTIONS(30149), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324069] = 2,
    ACTIONS(30151), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324077] = 2,
    ACTIONS(30153), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324085] = 2,
    ACTIONS(9850), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324093] = 2,
    ACTIONS(30155), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324101] = 2,
    ACTIONS(30157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324109] = 2,
    ACTIONS(15494), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324117] = 2,
    ACTIONS(30159), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324125] = 2,
    ACTIONS(30161), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324133] = 2,
    ACTIONS(21154), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324141] = 2,
    ACTIONS(18040), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324149] = 2,
    ACTIONS(30163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324157] = 2,
    ACTIONS(30165), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324165] = 2,
    ACTIONS(21698), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324173] = 2,
    ACTIONS(23927), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324181] = 2,
    ACTIONS(9204), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324189] = 2,
    ACTIONS(30167), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324197] = 2,
    ACTIONS(30169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324205] = 2,
    ACTIONS(30171), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324213] = 2,
    ACTIONS(21424), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324221] = 2,
    ACTIONS(15404), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324229] = 2,
    ACTIONS(30173), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324237] = 2,
    ACTIONS(15412), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324245] = 2,
    ACTIONS(30175), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324253] = 2,
    ACTIONS(10922), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324261] = 2,
    ACTIONS(10666), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324269] = 2,
    ACTIONS(30177), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324277] = 2,
    ACTIONS(8624), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324285] = 2,
    ACTIONS(30179), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324293] = 2,
    ACTIONS(10944), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324301] = 2,
    ACTIONS(30181), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324309] = 2,
    ACTIONS(30183), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324317] = 2,
    ACTIONS(30185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324325] = 2,
    ACTIONS(30187), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324333] = 2,
    ACTIONS(30189), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324341] = 2,
    ACTIONS(30191), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324349] = 2,
    ACTIONS(30193), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324357] = 2,
    ACTIONS(30195), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324365] = 2,
    ACTIONS(21086), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324373] = 2,
    ACTIONS(30197), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324381] = 2,
    ACTIONS(30199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324389] = 2,
    ACTIONS(30201), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324397] = 2,
    ACTIONS(7776), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324405] = 2,
    ACTIONS(30203), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324413] = 2,
    ACTIONS(30205), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324421] = 2,
    ACTIONS(30207), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324429] = 2,
    ACTIONS(30209), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324437] = 2,
    ACTIONS(12638), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324445] = 2,
    ACTIONS(30211), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324453] = 2,
    ACTIONS(10280), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324461] = 2,
    ACTIONS(8268), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324469] = 2,
    ACTIONS(27945), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324477] = 2,
    ACTIONS(7664), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324485] = 2,
    ACTIONS(30213), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324493] = 2,
    ACTIONS(30215), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324501] = 2,
    ACTIONS(30217), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324509] = 2,
    ACTIONS(30219), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324517] = 2,
    ACTIONS(30221), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324525] = 2,
    ACTIONS(30223), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324533] = 2,
    ACTIONS(10910), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324541] = 2,
    ACTIONS(30225), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324549] = 2,
    ACTIONS(15444), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324557] = 2,
    ACTIONS(30227), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324565] = 2,
    ACTIONS(30229), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324573] = 2,
    ACTIONS(30231), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324581] = 2,
    ACTIONS(30233), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324589] = 2,
    ACTIONS(30235), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324597] = 2,
    ACTIONS(30237), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324605] = 2,
    ACTIONS(30239), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324613] = 2,
    ACTIONS(30241), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324621] = 2,
    ACTIONS(8228), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324629] = 2,
    ACTIONS(30243), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324637] = 2,
    ACTIONS(21080), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324645] = 2,
    ACTIONS(18724), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324653] = 2,
    ACTIONS(30245), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324661] = 2,
    ACTIONS(30247), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324669] = 2,
    ACTIONS(30249), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324677] = 2,
    ACTIONS(30251), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324685] = 2,
    ACTIONS(22478), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324693] = 2,
    ACTIONS(9942), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324701] = 2,
    ACTIONS(21372), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324709] = 2,
    ACTIONS(15378), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324717] = 2,
    ACTIONS(9998), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324725] = 2,
    ACTIONS(30253), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324733] = 2,
    ACTIONS(30255), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324741] = 2,
    ACTIONS(12648), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324749] = 2,
    ACTIONS(10092), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324757] = 2,
    ACTIONS(8916), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324765] = 2,
    ACTIONS(30257), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324773] = 2,
    ACTIONS(30259), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324781] = 2,
    ACTIONS(30261), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324789] = 2,
    ACTIONS(30263), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324797] = 2,
    ACTIONS(8828), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324805] = 2,
    ACTIONS(12436), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324813] = 2,
    ACTIONS(22932), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324821] = 2,
    ACTIONS(21408), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324829] = 2,
    ACTIONS(30265), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324837] = 2,
    ACTIONS(10330), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324845] = 2,
    ACTIONS(30267), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324853] = 2,
    ACTIONS(8156), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324861] = 2,
    ACTIONS(21470), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324869] = 2,
    ACTIONS(22285), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324877] = 2,
    ACTIONS(30269), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324885] = 2,
    ACTIONS(30271), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324893] = 2,
    ACTIONS(30273), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324901] = 2,
    ACTIONS(9368), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324909] = 2,
    ACTIONS(21090), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324917] = 2,
    ACTIONS(30275), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324925] = 2,
    ACTIONS(30277), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324933] = 2,
    ACTIONS(12586), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324941] = 2,
    ACTIONS(30279), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324949] = 2,
    ACTIONS(30281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324957] = 2,
    ACTIONS(15484), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324965] = 2,
    ACTIONS(30283), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324973] = 2,
    ACTIONS(7596), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324981] = 2,
    ACTIONS(30285), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324989] = 2,
    ACTIONS(15476), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [324997] = 2,
    ACTIONS(17958), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325005] = 2,
    ACTIONS(21566), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325013] = 2,
    ACTIONS(30287), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325021] = 2,
    ACTIONS(8994), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325029] = 2,
    ACTIONS(21292), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325037] = 2,
    ACTIONS(30289), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325045] = 2,
    ACTIONS(30291), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325053] = 2,
    ACTIONS(10686), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325061] = 2,
    ACTIONS(12526), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325069] = 2,
    ACTIONS(10834), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325077] = 2,
    ACTIONS(30293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325085] = 2,
    ACTIONS(30295), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325093] = 2,
    ACTIONS(30297), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325101] = 2,
    ACTIONS(30299), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325109] = 2,
    ACTIONS(30301), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325117] = 2,
    ACTIONS(10946), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325125] = 2,
    ACTIONS(12704), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325133] = 2,
    ACTIONS(27046), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325141] = 2,
    ACTIONS(9076), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325149] = 2,
    ACTIONS(30303), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325157] = 2,
    ACTIONS(30305), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325165] = 2,
    ACTIONS(30307), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325173] = 2,
    ACTIONS(30309), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325181] = 2,
    ACTIONS(30311), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325189] = 2,
    ACTIONS(12598), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325197] = 2,
    ACTIONS(15420), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325205] = 2,
    ACTIONS(10962), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325213] = 2,
    ACTIONS(30313), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325221] = 2,
    ACTIONS(30315), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325229] = 2,
    ACTIONS(30317), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325237] = 2,
    ACTIONS(30319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325245] = 2,
    ACTIONS(30321), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325253] = 2,
    ACTIONS(12316), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325261] = 2,
    ACTIONS(30323), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325269] = 2,
    ACTIONS(23716), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325277] = 2,
    ACTIONS(7786), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325285] = 2,
    ACTIONS(30325), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325293] = 2,
    ACTIONS(30327), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325301] = 2,
    ACTIONS(30329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325309] = 2,
    ACTIONS(12494), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325317] = 2,
    ACTIONS(7838), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325325] = 2,
    ACTIONS(30331), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325333] = 2,
    ACTIONS(9982), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325341] = 2,
    ACTIONS(9236), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325349] = 2,
    ACTIONS(30333), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325357] = 2,
    ACTIONS(30335), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325365] = 2,
    ACTIONS(12752), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325373] = 2,
    ACTIONS(15492), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325381] = 2,
    ACTIONS(30337), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325389] = 2,
    ACTIONS(30339), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325397] = 2,
    ACTIONS(30341), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325405] = 2,
    ACTIONS(30343), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325413] = 2,
    ACTIONS(24581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325421] = 2,
    ACTIONS(18070), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325429] = 2,
    ACTIONS(30345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325437] = 2,
    ACTIONS(24003), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325445] = 2,
    ACTIONS(30347), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325453] = 2,
    ACTIONS(30349), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325461] = 2,
    ACTIONS(30351), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325469] = 2,
    ACTIONS(30353), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325477] = 2,
    ACTIONS(12538), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325485] = 2,
    ACTIONS(21416), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325493] = 2,
    ACTIONS(30355), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325501] = 2,
    ACTIONS(30357), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325509] = 2,
    ACTIONS(30359), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325517] = 2,
    ACTIONS(30361), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325525] = 2,
    ACTIONS(15430), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325533] = 2,
    ACTIONS(17946), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325541] = 2,
    ACTIONS(30363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325549] = 2,
    ACTIONS(15442), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325557] = 2,
    ACTIONS(21618), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325565] = 2,
    ACTIONS(30365), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325573] = 2,
    ACTIONS(30367), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325581] = 2,
    ACTIONS(9442), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325589] = 2,
    ACTIONS(12812), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325597] = 2,
    ACTIONS(7858), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325605] = 2,
    ACTIONS(8276), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325613] = 2,
    ACTIONS(23971), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325621] = 2,
    ACTIONS(30369), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325629] = 2,
    ACTIONS(30371), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325637] = 2,
    ACTIONS(30373), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325645] = 2,
    ACTIONS(12742), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325653] = 2,
    ACTIONS(30375), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325661] = 2,
    ACTIONS(30377), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325669] = 2,
    ACTIONS(30379), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325677] = 2,
    ACTIONS(30381), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325685] = 2,
    ACTIONS(23118), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325693] = 2,
    ACTIONS(9538), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325701] = 2,
    ACTIONS(9666), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325709] = 2,
    ACTIONS(30383), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325717] = 2,
    ACTIONS(9116), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325725] = 2,
    ACTIONS(30385), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325733] = 2,
    ACTIONS(30387), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325741] = 2,
    ACTIONS(30389), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325749] = 2,
    ACTIONS(30391), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325757] = 2,
    ACTIONS(30393), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325765] = 2,
    ACTIONS(30395), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325773] = 2,
    ACTIONS(30397), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325781] = 2,
    ACTIONS(30399), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325789] = 2,
    ACTIONS(30401), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325797] = 2,
    ACTIONS(23374), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325805] = 2,
    ACTIONS(30403), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325813] = 2,
    ACTIONS(9462), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325821] = 2,
    ACTIONS(15504), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325829] = 2,
    ACTIONS(30405), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325837] = 2,
    ACTIONS(8466), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325845] = 2,
    ACTIONS(30407), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325853] = 2,
    ACTIONS(30409), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325861] = 2,
    ACTIONS(30411), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325869] = 2,
    ACTIONS(23906), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325877] = 2,
    ACTIONS(30413), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325885] = 2,
    ACTIONS(30415), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325893] = 2,
    ACTIONS(30417), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325901] = 2,
    ACTIONS(30419), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325909] = 2,
    ACTIONS(15500), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325917] = 2,
    ACTIONS(27256), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325925] = 2,
    ACTIONS(30421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325933] = 2,
    ACTIONS(24005), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325941] = 2,
    ACTIONS(21382), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325949] = 2,
    ACTIONS(30423), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325957] = 2,
    ACTIONS(30425), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325965] = 2,
    ACTIONS(9280), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325973] = 2,
    ACTIONS(30427), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325981] = 2,
    ACTIONS(10480), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325989] = 2,
    ACTIONS(9884), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [325997] = 2,
    ACTIONS(30429), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326005] = 2,
    ACTIONS(30431), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326013] = 2,
    ACTIONS(30433), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326021] = 2,
    ACTIONS(10948), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326029] = 2,
    ACTIONS(30435), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326037] = 2,
    ACTIONS(30437), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326045] = 2,
    ACTIONS(10278), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326053] = 2,
    ACTIONS(12038), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326061] = 2,
    ACTIONS(30439), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326069] = 2,
    ACTIONS(30441), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326077] = 2,
    ACTIONS(30443), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326085] = 2,
    ACTIONS(12042), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326093] = 2,
    ACTIONS(30445), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326101] = 2,
    ACTIONS(30447), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326109] = 2,
    ACTIONS(30449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326117] = 2,
    ACTIONS(30451), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326125] = 2,
    ACTIONS(23284), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326133] = 2,
    ACTIONS(10924), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326141] = 2,
    ACTIONS(15448), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326149] = 2,
    ACTIONS(30453), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326157] = 2,
    ACTIONS(18094), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326165] = 2,
    ACTIONS(30455), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326173] = 2,
    ACTIONS(30457), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326181] = 2,
    ACTIONS(10108), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326189] = 2,
    ACTIONS(30459), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326197] = 2,
    ACTIONS(30461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326205] = 2,
    ACTIONS(30463), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326213] = 2,
    ACTIONS(30465), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326221] = 2,
    ACTIONS(15410), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326229] = 2,
    ACTIONS(7386), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326237] = 2,
    ACTIONS(23724), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326245] = 2,
    ACTIONS(7796), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326253] = 2,
    ACTIONS(30467), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326261] = 2,
    ACTIONS(30469), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326269] = 2,
    ACTIONS(30471), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326277] = 2,
    ACTIONS(30473), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326285] = 2,
    ACTIONS(30475), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326293] = 2,
    ACTIONS(12030), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326301] = 2,
    ACTIONS(30477), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326309] = 2,
    ACTIONS(30479), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326317] = 2,
    ACTIONS(30481), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326325] = 2,
    ACTIONS(10898), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326333] = 2,
    ACTIONS(27881), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326341] = 2,
    ACTIONS(30483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326349] = 2,
    ACTIONS(30485), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326357] = 2,
    ACTIONS(30487), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326365] = 2,
    ACTIONS(30489), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326373] = 2,
    ACTIONS(30491), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326381] = 2,
    ACTIONS(8954), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326389] = 2,
    ACTIONS(30493), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326397] = 2,
    ACTIONS(30495), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326405] = 2,
    ACTIONS(30497), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326413] = 2,
    ACTIONS(30499), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326421] = 2,
    ACTIONS(30501), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326429] = 2,
    ACTIONS(10258), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326437] = 2,
    ACTIONS(30503), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326445] = 2,
    ACTIONS(30505), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326453] = 2,
    ACTIONS(30507), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326461] = 2,
    ACTIONS(30509), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326469] = 2,
    ACTIONS(30511), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326477] = 2,
    ACTIONS(30513), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326485] = 2,
    ACTIONS(7674), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326493] = 2,
    ACTIONS(10794), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326501] = 2,
    ACTIONS(30515), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326509] = 2,
    ACTIONS(30517), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326517] = 2,
    ACTIONS(30519), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326525] = 2,
    ACTIONS(30521), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326533] = 2,
    ACTIONS(8642), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326541] = 2,
    ACTIONS(30523), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326549] = 2,
    ACTIONS(30525), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326557] = 2,
    ACTIONS(30527), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326565] = 2,
    ACTIONS(21628), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326573] = 2,
    ACTIONS(30529), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326581] = 2,
    ACTIONS(10056), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326589] = 2,
    ACTIONS(21692), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326597] = 2,
    ACTIONS(15440), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326605] = 2,
    ACTIONS(30531), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326613] = 2,
    ACTIONS(30533), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326621] = 2,
    ACTIONS(30535), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326629] = 2,
    ACTIONS(30537), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326637] = 2,
    ACTIONS(30539), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326645] = 2,
    ACTIONS(9122), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326653] = 2,
    ACTIONS(30541), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326661] = 2,
    ACTIONS(30543), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326669] = 2,
    ACTIONS(30545), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326677] = 2,
    ACTIONS(30547), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326685] = 2,
    ACTIONS(30549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326693] = 2,
    ACTIONS(30551), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326701] = 2,
    ACTIONS(30553), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326709] = 2,
    ACTIONS(10870), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326717] = 2,
    ACTIONS(7804), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326725] = 2,
    ACTIONS(21516), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326733] = 2,
    ACTIONS(30555), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326741] = 2,
    ACTIONS(30557), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326749] = 2,
    ACTIONS(9156), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326757] = 2,
    ACTIONS(30559), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326765] = 2,
    ACTIONS(30561), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326773] = 2,
    ACTIONS(30563), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326781] = 2,
    ACTIONS(30565), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326789] = 2,
    ACTIONS(30567), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326797] = 2,
    ACTIONS(30569), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326805] = 2,
    ACTIONS(30571), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326813] = 2,
    ACTIONS(30573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326821] = 2,
    ACTIONS(30575), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326829] = 2,
    ACTIONS(30577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326837] = 2,
    ACTIONS(30579), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326845] = 2,
    ACTIONS(30581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326853] = 2,
    ACTIONS(30583), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326861] = 2,
    ACTIONS(30585), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326869] = 2,
    ACTIONS(30587), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326877] = 2,
    ACTIONS(30589), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326885] = 2,
    ACTIONS(30591), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326893] = 2,
    ACTIONS(30593), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326901] = 2,
    ACTIONS(7256), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326909] = 2,
    ACTIONS(30595), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326917] = 2,
    ACTIONS(30597), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326925] = 2,
    ACTIONS(15436), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326933] = 2,
    ACTIONS(30599), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326941] = 2,
    ACTIONS(30601), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326949] = 2,
    ACTIONS(30603), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326957] = 2,
    ACTIONS(30605), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326965] = 2,
    ACTIONS(30607), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326973] = 2,
    ACTIONS(30609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326981] = 2,
    ACTIONS(30611), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326989] = 2,
    ACTIONS(30613), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [326997] = 2,
    ACTIONS(15502), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327005] = 2,
    ACTIONS(30615), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327013] = 2,
    ACTIONS(30617), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327021] = 2,
    ACTIONS(30619), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327029] = 2,
    ACTIONS(30621), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327037] = 2,
    ACTIONS(30623), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327045] = 2,
    ACTIONS(30625), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327053] = 2,
    ACTIONS(9724), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327061] = 2,
    ACTIONS(30627), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327069] = 2,
    ACTIONS(30629), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327077] = 2,
    ACTIONS(30631), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327085] = 2,
    ACTIONS(30633), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327093] = 2,
    ACTIONS(30635), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327101] = 2,
    ACTIONS(30637), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327109] = 2,
    ACTIONS(30639), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327117] = 2,
    ACTIONS(30641), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327125] = 2,
    ACTIONS(30643), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327133] = 2,
    ACTIONS(30645), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327141] = 2,
    ACTIONS(30647), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327149] = 2,
    ACTIONS(10538), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327157] = 2,
    ACTIONS(10722), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327165] = 2,
    ACTIONS(30649), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327173] = 2,
    ACTIONS(30651), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327181] = 2,
    ACTIONS(30653), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327189] = 2,
    ACTIONS(7136), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327197] = 2,
    ACTIONS(30655), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327205] = 2,
    ACTIONS(10950), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327213] = 2,
    ACTIONS(30657), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327221] = 2,
    ACTIONS(30659), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327229] = 2,
    ACTIONS(23756), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327237] = 2,
    ACTIONS(30661), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327245] = 2,
    ACTIONS(30663), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327253] = 2,
    ACTIONS(30665), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327261] = 2,
    ACTIONS(30667), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327269] = 2,
    ACTIONS(30669), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327277] = 2,
    ACTIONS(30671), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327285] = 2,
    ACTIONS(30673), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327293] = 2,
    ACTIONS(30675), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327301] = 2,
    ACTIONS(30677), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327309] = 2,
    ACTIONS(30679), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327317] = 2,
    ACTIONS(30681), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327325] = 2,
    ACTIONS(10684), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327333] = 2,
    ACTIONS(30683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327341] = 2,
    ACTIONS(30685), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327349] = 2,
    ACTIONS(30687), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327357] = 2,
    ACTIONS(7342), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327365] = 2,
    ACTIONS(30689), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327373] = 2,
    ACTIONS(7802), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327381] = 2,
    ACTIONS(30691), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327389] = 2,
    ACTIONS(30693), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327397] = 2,
    ACTIONS(30695), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327405] = 2,
    ACTIONS(28053), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327413] = 2,
    ACTIONS(30697), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327421] = 2,
    ACTIONS(30699), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327429] = 2,
    ACTIONS(24007), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327437] = 2,
    ACTIONS(15424), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327445] = 2,
    ACTIONS(30701), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327453] = 2,
    ACTIONS(22716), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327461] = 2,
    ACTIONS(30703), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327469] = 2,
    ACTIONS(30705), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327477] = 2,
    ACTIONS(30707), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327485] = 2,
    ACTIONS(30709), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327493] = 2,
    ACTIONS(30711), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327501] = 2,
    ACTIONS(30713), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327509] = 2,
    ACTIONS(30715), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327517] = 2,
    ACTIONS(30717), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327525] = 2,
    ACTIONS(30719), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327533] = 2,
    ACTIONS(30721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327541] = 2,
    ACTIONS(30723), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327549] = 2,
    ACTIONS(30725), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327557] = 2,
    ACTIONS(30727), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327565] = 2,
    ACTIONS(7906), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327573] = 2,
    ACTIONS(30729), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327581] = 2,
    ACTIONS(7154), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327589] = 2,
    ACTIONS(30731), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327597] = 2,
    ACTIONS(8306), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327605] = 2,
    ACTIONS(30733), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327613] = 2,
    ACTIONS(30735), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327621] = 2,
    ACTIONS(30737), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327629] = 2,
    ACTIONS(30739), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327637] = 2,
    ACTIONS(30741), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327645] = 2,
    ACTIONS(21484), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327653] = 2,
    ACTIONS(30743), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327661] = 2,
    ACTIONS(12128), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327669] = 2,
    ACTIONS(30745), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327677] = 2,
    ACTIONS(21586), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327685] = 2,
    ACTIONS(21638), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327693] = 2,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327701] = 2,
    ACTIONS(30747), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327709] = 2,
    ACTIONS(30749), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327717] = 2,
    ACTIONS(30751), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327725] = 2,
    ACTIONS(30753), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327733] = 2,
    ACTIONS(15446), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327741] = 2,
    ACTIONS(30755), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327749] = 2,
    ACTIONS(30757), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327757] = 2,
    ACTIONS(30759), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327765] = 2,
    ACTIONS(7970), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327773] = 2,
    ACTIONS(30761), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327781] = 2,
    ACTIONS(30763), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327789] = 2,
    ACTIONS(30765), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327797] = 2,
    ACTIONS(10912), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327805] = 2,
    ACTIONS(30767), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327813] = 2,
    ACTIONS(30769), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327821] = 2,
    ACTIONS(30771), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327829] = 2,
    ACTIONS(30773), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327837] = 2,
    ACTIONS(30775), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327845] = 2,
    ACTIONS(30777), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327853] = 2,
    ACTIONS(23160), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327861] = 2,
    ACTIONS(30779), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327869] = 2,
    ACTIONS(30781), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327877] = 2,
    ACTIONS(30783), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327885] = 2,
    ACTIONS(30785), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327893] = 2,
    ACTIONS(8346), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327901] = 2,
    ACTIONS(30787), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327909] = 2,
    ACTIONS(30789), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327917] = 2,
    ACTIONS(30791), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327925] = 2,
    ACTIONS(23999), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327933] = 2,
    ACTIONS(30793), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327941] = 2,
    ACTIONS(21456), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327949] = 2,
    ACTIONS(30795), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327957] = 2,
    ACTIONS(30797), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327965] = 2,
    ACTIONS(30799), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327973] = 2,
    ACTIONS(8830), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327981] = 2,
    ACTIONS(30801), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327989] = 2,
    ACTIONS(30803), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [327997] = 2,
    ACTIONS(30805), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328005] = 2,
    ACTIONS(30807), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328013] = 2,
    ACTIONS(30809), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328021] = 2,
    ACTIONS(30811), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328029] = 2,
    ACTIONS(30813), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328037] = 2,
    ACTIONS(12426), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328045] = 2,
    ACTIONS(30815), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328053] = 2,
    ACTIONS(30817), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328061] = 2,
    ACTIONS(23776), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328069] = 2,
    ACTIONS(30819), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328077] = 2,
    ACTIONS(30821), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328085] = 2,
    ACTIONS(27493), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328093] = 2,
    ACTIONS(30823), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328101] = 2,
    ACTIONS(12050), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328109] = 2,
    ACTIONS(22872), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328117] = 2,
    ACTIONS(15414), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328125] = 2,
    ACTIONS(30825), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328133] = 2,
    ACTIONS(22570), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328141] = 2,
    ACTIONS(9706), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328149] = 2,
    ACTIONS(30827), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328157] = 2,
    ACTIONS(10740), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328165] = 2,
    ACTIONS(24011), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328173] = 2,
    ACTIONS(30829), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328181] = 2,
    ACTIONS(27196), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328189] = 2,
    ACTIONS(30831), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328197] = 2,
    ACTIONS(8082), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328205] = 2,
    ACTIONS(10952), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328213] = 2,
    ACTIONS(30833), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328221] = 2,
    ACTIONS(30835), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328229] = 2,
    ACTIONS(30837), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328237] = 2,
    ACTIONS(30839), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328245] = 2,
    ACTIONS(7498), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328253] = 2,
    ACTIONS(30841), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328261] = 2,
    ACTIONS(30843), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328269] = 2,
    ACTIONS(9096), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328277] = 2,
    ACTIONS(30845), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328285] = 2,
    ACTIONS(30847), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328293] = 2,
    ACTIONS(30849), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328301] = 2,
    ACTIONS(15394), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328309] = 2,
    ACTIONS(30851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328317] = 2,
    ACTIONS(30853), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328325] = 2,
    ACTIONS(8914), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328333] = 2,
    ACTIONS(7196), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328341] = 2,
    ACTIONS(30855), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328349] = 2,
    ACTIONS(30857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328357] = 2,
    ACTIONS(30859), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328365] = 2,
    ACTIONS(7810), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328373] = 2,
    ACTIONS(23170), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328381] = 2,
    ACTIONS(30861), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328389] = 2,
    ACTIONS(30863), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328397] = 2,
    ACTIONS(9134), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328405] = 2,
    ACTIONS(30865), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328413] = 2,
    ACTIONS(30867), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328421] = 2,
    ACTIONS(30869), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328429] = 2,
    ACTIONS(8234), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328437] = 2,
    ACTIONS(30871), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328445] = 2,
    ACTIONS(15416), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328453] = 2,
    ACTIONS(30873), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328461] = 2,
    ACTIONS(30875), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328469] = 2,
    ACTIONS(15422), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328477] = 2,
    ACTIONS(21288), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328485] = 2,
    ACTIONS(30877), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328493] = 2,
    ACTIONS(30879), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328501] = 2,
    ACTIONS(30881), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328509] = 2,
    ACTIONS(28063), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328517] = 2,
    ACTIONS(7612), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328525] = 2,
    ACTIONS(15418), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328533] = 2,
    ACTIONS(9174), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328541] = 2,
    ACTIONS(30883), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328549] = 2,
    ACTIONS(30885), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328557] = 2,
    ACTIONS(30887), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328565] = 2,
    ACTIONS(30889), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328573] = 2,
    ACTIONS(9762), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328581] = 2,
    ACTIONS(30891), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328589] = 2,
    ACTIONS(30893), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328597] = 2,
    ACTIONS(15462), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328605] = 2,
    ACTIONS(30895), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328613] = 2,
    ACTIONS(30897), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328621] = 2,
    ACTIONS(30899), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328629] = 2,
    ACTIONS(30901), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328637] = 2,
    ACTIONS(30903), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328645] = 2,
    ACTIONS(21644), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328653] = 2,
    ACTIONS(10574), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328661] = 2,
    ACTIONS(30905), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328669] = 2,
    ACTIONS(30907), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328677] = 2,
    ACTIONS(30909), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328685] = 2,
    ACTIONS(30911), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328693] = 2,
    ACTIONS(30913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328701] = 2,
    ACTIONS(10500), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328709] = 2,
    ACTIONS(30915), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328717] = 2,
    ACTIONS(30917), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328725] = 2,
    ACTIONS(30919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328733] = 2,
    ACTIONS(17710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328741] = 2,
    ACTIONS(30921), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328749] = 2,
    ACTIONS(30923), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328757] = 2,
    ACTIONS(30925), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328765] = 2,
    ACTIONS(30927), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328773] = 2,
    ACTIONS(30929), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328781] = 2,
    ACTIONS(30931), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328789] = 2,
    ACTIONS(30933), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328797] = 2,
    ACTIONS(10926), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328805] = 2,
    ACTIONS(30935), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328813] = 2,
    ACTIONS(30937), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328821] = 2,
    ACTIONS(30939), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328829] = 2,
    ACTIONS(8456), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328837] = 2,
    ACTIONS(30941), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328845] = 2,
    ACTIONS(30943), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328853] = 2,
    ACTIONS(30945), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328861] = 2,
    ACTIONS(30947), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328869] = 2,
    ACTIONS(27553), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328877] = 2,
    ACTIONS(30949), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328885] = 2,
    ACTIONS(30951), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328893] = 2,
    ACTIONS(30953), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328901] = 2,
    ACTIONS(30955), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328909] = 2,
    ACTIONS(30957), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328917] = 2,
    ACTIONS(17631), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328925] = 2,
    ACTIONS(9516), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328933] = 2,
    ACTIONS(30959), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328941] = 2,
    ACTIONS(30961), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328949] = 2,
    ACTIONS(8402), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328957] = 2,
    ACTIONS(30963), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328965] = 2,
    ACTIONS(30965), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328973] = 2,
    ACTIONS(30967), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328981] = 2,
    ACTIONS(30969), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328989] = 2,
    ACTIONS(30971), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [328997] = 2,
    ACTIONS(30973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329005] = 2,
    ACTIONS(30975), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329013] = 2,
    ACTIONS(30977), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329021] = 2,
    ACTIONS(7360), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329029] = 2,
    ACTIONS(30979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329037] = 2,
    ACTIONS(10852), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329045] = 2,
    ACTIONS(30981), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329053] = 2,
    ACTIONS(30983), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329061] = 2,
    ACTIONS(30985), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329069] = 2,
    ACTIONS(30987), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329077] = 2,
    ACTIONS(30989), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329085] = 2,
    ACTIONS(30991), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329093] = 2,
    ACTIONS(30993), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329101] = 2,
    ACTIONS(30995), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329109] = 2,
    ACTIONS(15450), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329117] = 2,
    ACTIONS(15478), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329125] = 2,
    ACTIONS(30997), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329133] = 2,
    ACTIONS(30999), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329141] = 2,
    ACTIONS(31001), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329149] = 2,
    ACTIONS(31003), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329157] = 2,
    ACTIONS(7412), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329165] = 2,
    ACTIONS(7684), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329173] = 2,
    ACTIONS(31005), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329181] = 2,
    ACTIONS(31007), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329189] = 2,
    ACTIONS(31009), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329197] = 2,
    ACTIONS(31011), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329205] = 2,
    ACTIONS(31013), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329213] = 2,
    ACTIONS(10964), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329221] = 2,
    ACTIONS(31015), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329229] = 2,
    ACTIONS(31017), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329237] = 2,
    ACTIONS(31019), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329245] = 2,
    ACTIONS(31021), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329253] = 2,
    ACTIONS(31023), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329261] = 2,
    ACTIONS(31025), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329269] = 2,
    ACTIONS(10760), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329277] = 2,
    ACTIONS(31027), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329285] = 2,
    ACTIONS(23846), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329293] = 2,
    ACTIONS(7934), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329301] = 2,
    ACTIONS(31029), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329309] = 2,
    ACTIONS(10954), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329317] = 2,
    ACTIONS(8024), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329325] = 2,
    ACTIONS(23876), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329333] = 2,
    ACTIONS(31031), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329341] = 2,
    ACTIONS(31033), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329349] = 2,
    ACTIONS(31035), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329357] = 2,
    ACTIONS(31037), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329365] = 2,
    ACTIONS(31039), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329373] = 2,
    ACTIONS(31041), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329381] = 2,
    ACTIONS(31043), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329389] = 2,
    ACTIONS(31045), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329397] = 2,
    ACTIONS(31047), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329405] = 2,
    ACTIONS(31049), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329413] = 2,
    ACTIONS(31051), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329421] = 2,
    ACTIONS(31053), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329429] = 2,
    ACTIONS(31055), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329437] = 2,
    ACTIONS(31057), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329445] = 2,
    ACTIONS(31059), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329453] = 2,
    ACTIONS(31061), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329461] = 2,
    ACTIONS(8522), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329469] = 2,
    ACTIONS(31063), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329477] = 2,
    ACTIONS(28079), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329485] = 2,
    ACTIONS(31065), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329493] = 2,
    ACTIONS(31067), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329501] = 2,
    ACTIONS(31069), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329509] = 2,
    ACTIONS(31071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329517] = 2,
    ACTIONS(31073), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329525] = 2,
    ACTIONS(31075), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329533] = 2,
    ACTIONS(23862), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329541] = 2,
    ACTIONS(7820), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329549] = 2,
    ACTIONS(31077), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329557] = 2,
    ACTIONS(21524), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329565] = 2,
    ACTIONS(31079), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329573] = 2,
    ACTIONS(31081), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329581] = 2,
    ACTIONS(10168), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329589] = 2,
    ACTIONS(31083), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329597] = 2,
    ACTIONS(31085), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329605] = 2,
    ACTIONS(28085), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329613] = 2,
    ACTIONS(31087), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329621] = 2,
    ACTIONS(31089), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329629] = 2,
    ACTIONS(31091), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329637] = 2,
    ACTIONS(31093), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329645] = 2,
    ACTIONS(31095), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329653] = 2,
    ACTIONS(31097), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329661] = 2,
    ACTIONS(31099), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329669] = 2,
    ACTIONS(31101), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329677] = 2,
    ACTIONS(31103), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329685] = 2,
    ACTIONS(31105), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329693] = 2,
    ACTIONS(31107), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329701] = 2,
    ACTIONS(7952), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329709] = 2,
    ACTIONS(31109), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329717] = 2,
    ACTIONS(31111), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329725] = 2,
    ACTIONS(31113), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329733] = 2,
    ACTIONS(31115), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329741] = 2,
    ACTIONS(18012), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329749] = 2,
    ACTIONS(17800), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329757] = 2,
    ACTIONS(31117), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329765] = 2,
    ACTIONS(31119), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329773] = 2,
    ACTIONS(12382), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329781] = 2,
    ACTIONS(31121), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329789] = 2,
    ACTIONS(31123), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329797] = 2,
    ACTIONS(15490), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329805] = 2,
    ACTIONS(31125), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329813] = 2,
    ACTIONS(31127), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329821] = 2,
    ACTIONS(31129), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329829] = 2,
    ACTIONS(21404), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329837] = 2,
    ACTIONS(7466), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329845] = 2,
    ACTIONS(10904), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329853] = 2,
    ACTIONS(31131), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329861] = 2,
    ACTIONS(31133), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329869] = 2,
    ACTIONS(8110), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329877] = 2,
    ACTIONS(31135), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329885] = 2,
    ACTIONS(31137), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329893] = 2,
    ACTIONS(15468), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329901] = 2,
    ACTIONS(9426), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329909] = 2,
    ACTIONS(21654), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329917] = 2,
    ACTIONS(31139), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329925] = 2,
    ACTIONS(9740), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329933] = 2,
    ACTIONS(31141), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329941] = 2,
    ACTIONS(31143), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329949] = 2,
    ACTIONS(31145), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329957] = 2,
    ACTIONS(31147), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329965] = 2,
    ACTIONS(31149), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329973] = 2,
    ACTIONS(31151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329981] = 2,
    ACTIONS(31153), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329989] = 2,
    ACTIONS(31155), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [329997] = 2,
    ACTIONS(21362), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330005] = 2,
    ACTIONS(18216), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330013] = 2,
    ACTIONS(31157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330021] = 2,
    ACTIONS(31159), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330029] = 2,
    ACTIONS(31161), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330037] = 2,
    ACTIONS(21140), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330045] = 2,
    ACTIONS(31163), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330053] = 2,
    ACTIONS(21492), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330061] = 2,
    ACTIONS(31165), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330069] = 2,
    ACTIONS(8040), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330077] = 2,
    ACTIONS(7286), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330085] = 2,
    ACTIONS(7026), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330093] = 2,
    ACTIONS(10296), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330101] = 2,
    ACTIONS(31167), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330109] = 2,
    ACTIONS(31169), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330117] = 2,
    ACTIONS(31171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330125] = 2,
    ACTIONS(31173), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330133] = 2,
    ACTIONS(24027), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330141] = 2,
    ACTIONS(31175), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330149] = 2,
    ACTIONS(31177), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330157] = 2,
    ACTIONS(31179), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330165] = 2,
    ACTIONS(31181), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330173] = 2,
    ACTIONS(31183), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330181] = 2,
    ACTIONS(15496), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330189] = 2,
    ACTIONS(7864), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330197] = 2,
    ACTIONS(31185), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330205] = 2,
    ACTIONS(28139), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330213] = 2,
    ACTIONS(31187), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330221] = 2,
    ACTIONS(15406), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330229] = 2,
    ACTIONS(21190), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330237] = 2,
    ACTIONS(15390), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330245] = 2,
    ACTIONS(31189), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330253] = 2,
    ACTIONS(31191), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330261] = 2,
    ACTIONS(9500), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330269] = 2,
    ACTIONS(10776), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330277] = 2,
    ACTIONS(10382), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330285] = 2,
    ACTIONS(31193), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330293] = 2,
    ACTIONS(31195), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330301] = 2,
    ACTIONS(10956), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330309] = 2,
    ACTIONS(31197), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330317] = 2,
    ACTIONS(9000), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330325] = 2,
    ACTIONS(9796), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330333] = 2,
    ACTIONS(31199), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330341] = 2,
    ACTIONS(31201), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330349] = 2,
    ACTIONS(31203), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330357] = 2,
    ACTIONS(31205), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330365] = 2,
    ACTIONS(23318), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330373] = 2,
    ACTIONS(31207), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330381] = 2,
    ACTIONS(10610), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330389] = 2,
    ACTIONS(31209), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330397] = 2,
    ACTIONS(9536), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330405] = 2,
    ACTIONS(31211), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330413] = 2,
    ACTIONS(31213), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330421] = 2,
    ACTIONS(31215), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330429] = 2,
    ACTIONS(31217), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330437] = 2,
    ACTIONS(31219), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330445] = 2,
    ACTIONS(31221), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330453] = 2,
    ACTIONS(31223), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330461] = 2,
    ACTIONS(31225), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330469] = 2,
    ACTIONS(31227), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330477] = 2,
    ACTIONS(31229), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330485] = 2,
    ACTIONS(31231), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330493] = 2,
    ACTIONS(31233), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330501] = 2,
    ACTIONS(31235), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330509] = 2,
    ACTIONS(31237), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330517] = 2,
    ACTIONS(31239), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330525] = 2,
    ACTIONS(31241), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330533] = 2,
    ACTIONS(9576), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330541] = 2,
    ACTIONS(31243), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330549] = 2,
    ACTIONS(31245), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330557] = 2,
    ACTIONS(31247), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330565] = 2,
    ACTIONS(10916), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330573] = 2,
    ACTIONS(31249), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330581] = 2,
    ACTIONS(21112), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330589] = 2,
    ACTIONS(31251), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330597] = 2,
    ACTIONS(31253), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330605] = 2,
    ACTIONS(31255), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330613] = 2,
    ACTIONS(31257), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330621] = 2,
    ACTIONS(31259), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330629] = 2,
    ACTIONS(31261), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330637] = 2,
    ACTIONS(12022), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330645] = 2,
    ACTIONS(31263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330653] = 2,
    ACTIONS(31265), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330661] = 2,
    ACTIONS(7828), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330669] = 2,
    ACTIONS(31267), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330677] = 2,
    ACTIONS(31269), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330685] = 2,
    ACTIONS(31271), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [330693] = 2,
    ACTIONS(31273), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(9618)] = 0,
  [SMALL_STATE(9619)] = 73,
  [SMALL_STATE(9620)] = 146,
  [SMALL_STATE(9621)] = 219,
  [SMALL_STATE(9622)] = 292,
  [SMALL_STATE(9623)] = 365,
  [SMALL_STATE(9624)] = 438,
  [SMALL_STATE(9625)] = 511,
  [SMALL_STATE(9626)] = 584,
  [SMALL_STATE(9627)] = 657,
  [SMALL_STATE(9628)] = 730,
  [SMALL_STATE(9629)] = 803,
  [SMALL_STATE(9630)] = 876,
  [SMALL_STATE(9631)] = 949,
  [SMALL_STATE(9632)] = 1022,
  [SMALL_STATE(9633)] = 1095,
  [SMALL_STATE(9634)] = 1168,
  [SMALL_STATE(9635)] = 1241,
  [SMALL_STATE(9636)] = 1314,
  [SMALL_STATE(9637)] = 1387,
  [SMALL_STATE(9638)] = 1460,
  [SMALL_STATE(9639)] = 1533,
  [SMALL_STATE(9640)] = 1606,
  [SMALL_STATE(9641)] = 1679,
  [SMALL_STATE(9642)] = 1752,
  [SMALL_STATE(9643)] = 1825,
  [SMALL_STATE(9644)] = 1898,
  [SMALL_STATE(9645)] = 1971,
  [SMALL_STATE(9646)] = 2044,
  [SMALL_STATE(9647)] = 2117,
  [SMALL_STATE(9648)] = 2190,
  [SMALL_STATE(9649)] = 2263,
  [SMALL_STATE(9650)] = 2336,
  [SMALL_STATE(9651)] = 2409,
  [SMALL_STATE(9652)] = 2482,
  [SMALL_STATE(9653)] = 2555,
  [SMALL_STATE(9654)] = 2628,
  [SMALL_STATE(9655)] = 2701,
  [SMALL_STATE(9656)] = 2774,
  [SMALL_STATE(9657)] = 2847,
  [SMALL_STATE(9658)] = 2916,
  [SMALL_STATE(9659)] = 2985,
  [SMALL_STATE(9660)] = 3054,
  [SMALL_STATE(9661)] = 3152,
  [SMALL_STATE(9662)] = 3246,
  [SMALL_STATE(9663)] = 3340,
  [SMALL_STATE(9664)] = 3434,
  [SMALL_STATE(9665)] = 3528,
  [SMALL_STATE(9666)] = 3621,
  [SMALL_STATE(9667)] = 3714,
  [SMALL_STATE(9668)] = 3807,
  [SMALL_STATE(9669)] = 3907,
  [SMALL_STATE(9670)] = 4003,
  [SMALL_STATE(9671)] = 4103,
  [SMALL_STATE(9672)] = 4195,
  [SMALL_STATE(9673)] = 4295,
  [SMALL_STATE(9674)] = 4395,
  [SMALL_STATE(9675)] = 4495,
  [SMALL_STATE(9676)] = 4595,
  [SMALL_STATE(9677)] = 4695,
  [SMALL_STATE(9678)] = 4787,
  [SMALL_STATE(9679)] = 4887,
  [SMALL_STATE(9680)] = 4987,
  [SMALL_STATE(9681)] = 5087,
  [SMALL_STATE(9682)] = 5187,
  [SMALL_STATE(9683)] = 5287,
  [SMALL_STATE(9684)] = 5387,
  [SMALL_STATE(9685)] = 5487,
  [SMALL_STATE(9686)] = 5587,
  [SMALL_STATE(9687)] = 5687,
  [SMALL_STATE(9688)] = 5787,
  [SMALL_STATE(9689)] = 5887,
  [SMALL_STATE(9690)] = 5987,
  [SMALL_STATE(9691)] = 6087,
  [SMALL_STATE(9692)] = 6187,
  [SMALL_STATE(9693)] = 6287,
  [SMALL_STATE(9694)] = 6387,
  [SMALL_STATE(9695)] = 6487,
  [SMALL_STATE(9696)] = 6587,
  [SMALL_STATE(9697)] = 6687,
  [SMALL_STATE(9698)] = 6782,
  [SMALL_STATE(9699)] = 6877,
  [SMALL_STATE(9700)] = 6972,
  [SMALL_STATE(9701)] = 7067,
  [SMALL_STATE(9702)] = 7162,
  [SMALL_STATE(9703)] = 7257,
  [SMALL_STATE(9704)] = 7352,
  [SMALL_STATE(9705)] = 7447,
  [SMALL_STATE(9706)] = 7542,
  [SMALL_STATE(9707)] = 7637,
  [SMALL_STATE(9708)] = 7732,
  [SMALL_STATE(9709)] = 7827,
  [SMALL_STATE(9710)] = 7922,
  [SMALL_STATE(9711)] = 8017,
  [SMALL_STATE(9712)] = 8112,
  [SMALL_STATE(9713)] = 8207,
  [SMALL_STATE(9714)] = 8302,
  [SMALL_STATE(9715)] = 8397,
  [SMALL_STATE(9716)] = 8492,
  [SMALL_STATE(9717)] = 8587,
  [SMALL_STATE(9718)] = 8682,
  [SMALL_STATE(9719)] = 8777,
  [SMALL_STATE(9720)] = 8872,
  [SMALL_STATE(9721)] = 8967,
  [SMALL_STATE(9722)] = 9062,
  [SMALL_STATE(9723)] = 9157,
  [SMALL_STATE(9724)] = 9252,
  [SMALL_STATE(9725)] = 9347,
  [SMALL_STATE(9726)] = 9442,
  [SMALL_STATE(9727)] = 9537,
  [SMALL_STATE(9728)] = 9632,
  [SMALL_STATE(9729)] = 9727,
  [SMALL_STATE(9730)] = 9822,
  [SMALL_STATE(9731)] = 9917,
  [SMALL_STATE(9732)] = 10012,
  [SMALL_STATE(9733)] = 10107,
  [SMALL_STATE(9734)] = 10202,
  [SMALL_STATE(9735)] = 10297,
  [SMALL_STATE(9736)] = 10392,
  [SMALL_STATE(9737)] = 10487,
  [SMALL_STATE(9738)] = 10582,
  [SMALL_STATE(9739)] = 10677,
  [SMALL_STATE(9740)] = 10772,
  [SMALL_STATE(9741)] = 10867,
  [SMALL_STATE(9742)] = 10962,
  [SMALL_STATE(9743)] = 11057,
  [SMALL_STATE(9744)] = 11152,
  [SMALL_STATE(9745)] = 11247,
  [SMALL_STATE(9746)] = 11342,
  [SMALL_STATE(9747)] = 11437,
  [SMALL_STATE(9748)] = 11532,
  [SMALL_STATE(9749)] = 11627,
  [SMALL_STATE(9750)] = 11722,
  [SMALL_STATE(9751)] = 11817,
  [SMALL_STATE(9752)] = 11912,
  [SMALL_STATE(9753)] = 12007,
  [SMALL_STATE(9754)] = 12102,
  [SMALL_STATE(9755)] = 12197,
  [SMALL_STATE(9756)] = 12292,
  [SMALL_STATE(9757)] = 12387,
  [SMALL_STATE(9758)] = 12482,
  [SMALL_STATE(9759)] = 12577,
  [SMALL_STATE(9760)] = 12672,
  [SMALL_STATE(9761)] = 12767,
  [SMALL_STATE(9762)] = 12862,
  [SMALL_STATE(9763)] = 12957,
  [SMALL_STATE(9764)] = 13049,
  [SMALL_STATE(9765)] = 13141,
  [SMALL_STATE(9766)] = 13233,
  [SMALL_STATE(9767)] = 13325,
  [SMALL_STATE(9768)] = 13417,
  [SMALL_STATE(9769)] = 13509,
  [SMALL_STATE(9770)] = 13601,
  [SMALL_STATE(9771)] = 13693,
  [SMALL_STATE(9772)] = 13785,
  [SMALL_STATE(9773)] = 13877,
  [SMALL_STATE(9774)] = 13969,
  [SMALL_STATE(9775)] = 14061,
  [SMALL_STATE(9776)] = 14153,
  [SMALL_STATE(9777)] = 14245,
  [SMALL_STATE(9778)] = 14337,
  [SMALL_STATE(9779)] = 14429,
  [SMALL_STATE(9780)] = 14521,
  [SMALL_STATE(9781)] = 14613,
  [SMALL_STATE(9782)] = 14705,
  [SMALL_STATE(9783)] = 14797,
  [SMALL_STATE(9784)] = 14889,
  [SMALL_STATE(9785)] = 14981,
  [SMALL_STATE(9786)] = 15073,
  [SMALL_STATE(9787)] = 15165,
  [SMALL_STATE(9788)] = 15257,
  [SMALL_STATE(9789)] = 15349,
  [SMALL_STATE(9790)] = 15441,
  [SMALL_STATE(9791)] = 15533,
  [SMALL_STATE(9792)] = 15625,
  [SMALL_STATE(9793)] = 15717,
  [SMALL_STATE(9794)] = 15809,
  [SMALL_STATE(9795)] = 15901,
  [SMALL_STATE(9796)] = 15993,
  [SMALL_STATE(9797)] = 16085,
  [SMALL_STATE(9798)] = 16177,
  [SMALL_STATE(9799)] = 16269,
  [SMALL_STATE(9800)] = 16361,
  [SMALL_STATE(9801)] = 16453,
  [SMALL_STATE(9802)] = 16545,
  [SMALL_STATE(9803)] = 16637,
  [SMALL_STATE(9804)] = 16729,
  [SMALL_STATE(9805)] = 16821,
  [SMALL_STATE(9806)] = 16913,
  [SMALL_STATE(9807)] = 17005,
  [SMALL_STATE(9808)] = 17097,
  [SMALL_STATE(9809)] = 17189,
  [SMALL_STATE(9810)] = 17281,
  [SMALL_STATE(9811)] = 17341,
  [SMALL_STATE(9812)] = 17401,
  [SMALL_STATE(9813)] = 17460,
  [SMALL_STATE(9814)] = 17517,
  [SMALL_STATE(9815)] = 17576,
  [SMALL_STATE(9816)] = 17635,
  [SMALL_STATE(9817)] = 17691,
  [SMALL_STATE(9818)] = 17749,
  [SMALL_STATE(9819)] = 17807,
  [SMALL_STATE(9820)] = 17864,
  [SMALL_STATE(9821)] = 17920,
  [SMALL_STATE(9822)] = 17980,
  [SMALL_STATE(9823)] = 18040,
  [SMALL_STATE(9824)] = 18100,
  [SMALL_STATE(9825)] = 18160,
  [SMALL_STATE(9826)] = 18217,
  [SMALL_STATE(9827)] = 18276,
  [SMALL_STATE(9828)] = 18331,
  [SMALL_STATE(9829)] = 18386,
  [SMALL_STATE(9830)] = 18441,
  [SMALL_STATE(9831)] = 18496,
  [SMALL_STATE(9832)] = 18553,
  [SMALL_STATE(9833)] = 18612,
  [SMALL_STATE(9834)] = 18667,
  [SMALL_STATE(9835)] = 18722,
  [SMALL_STATE(9836)] = 18777,
  [SMALL_STATE(9837)] = 18832,
  [SMALL_STATE(9838)] = 18889,
  [SMALL_STATE(9839)] = 18944,
  [SMALL_STATE(9840)] = 19001,
  [SMALL_STATE(9841)] = 19058,
  [SMALL_STATE(9842)] = 19115,
  [SMALL_STATE(9843)] = 19172,
  [SMALL_STATE(9844)] = 19227,
  [SMALL_STATE(9845)] = 19286,
  [SMALL_STATE(9846)] = 19343,
  [SMALL_STATE(9847)] = 19400,
  [SMALL_STATE(9848)] = 19457,
  [SMALL_STATE(9849)] = 19512,
  [SMALL_STATE(9850)] = 19567,
  [SMALL_STATE(9851)] = 19622,
  [SMALL_STATE(9852)] = 19681,
  [SMALL_STATE(9853)] = 19761,
  [SMALL_STATE(9854)] = 19841,
  [SMALL_STATE(9855)] = 19921,
  [SMALL_STATE(9856)] = 20001,
  [SMALL_STATE(9857)] = 20081,
  [SMALL_STATE(9858)] = 20161,
  [SMALL_STATE(9859)] = 20241,
  [SMALL_STATE(9860)] = 20321,
  [SMALL_STATE(9861)] = 20401,
  [SMALL_STATE(9862)] = 20481,
  [SMALL_STATE(9863)] = 20561,
  [SMALL_STATE(9864)] = 20641,
  [SMALL_STATE(9865)] = 20695,
  [SMALL_STATE(9866)] = 20749,
  [SMALL_STATE(9867)] = 20829,
  [SMALL_STATE(9868)] = 20909,
  [SMALL_STATE(9869)] = 20989,
  [SMALL_STATE(9870)] = 21045,
  [SMALL_STATE(9871)] = 21125,
  [SMALL_STATE(9872)] = 21179,
  [SMALL_STATE(9873)] = 21259,
  [SMALL_STATE(9874)] = 21339,
  [SMALL_STATE(9875)] = 21393,
  [SMALL_STATE(9876)] = 21473,
  [SMALL_STATE(9877)] = 21527,
  [SMALL_STATE(9878)] = 21607,
  [SMALL_STATE(9879)] = 21661,
  [SMALL_STATE(9880)] = 21741,
  [SMALL_STATE(9881)] = 21795,
  [SMALL_STATE(9882)] = 21849,
  [SMALL_STATE(9883)] = 21929,
  [SMALL_STATE(9884)] = 21983,
  [SMALL_STATE(9885)] = 22063,
  [SMALL_STATE(9886)] = 22143,
  [SMALL_STATE(9887)] = 22223,
  [SMALL_STATE(9888)] = 22277,
  [SMALL_STATE(9889)] = 22357,
  [SMALL_STATE(9890)] = 22413,
  [SMALL_STATE(9891)] = 22467,
  [SMALL_STATE(9892)] = 22547,
  [SMALL_STATE(9893)] = 22601,
  [SMALL_STATE(9894)] = 22681,
  [SMALL_STATE(9895)] = 22761,
  [SMALL_STATE(9896)] = 22815,
  [SMALL_STATE(9897)] = 22895,
  [SMALL_STATE(9898)] = 22975,
  [SMALL_STATE(9899)] = 23055,
  [SMALL_STATE(9900)] = 23135,
  [SMALL_STATE(9901)] = 23215,
  [SMALL_STATE(9902)] = 23269,
  [SMALL_STATE(9903)] = 23323,
  [SMALL_STATE(9904)] = 23403,
  [SMALL_STATE(9905)] = 23483,
  [SMALL_STATE(9906)] = 23563,
  [SMALL_STATE(9907)] = 23643,
  [SMALL_STATE(9908)] = 23723,
  [SMALL_STATE(9909)] = 23777,
  [SMALL_STATE(9910)] = 23857,
  [SMALL_STATE(9911)] = 23937,
  [SMALL_STATE(9912)] = 24017,
  [SMALL_STATE(9913)] = 24097,
  [SMALL_STATE(9914)] = 24177,
  [SMALL_STATE(9915)] = 24231,
  [SMALL_STATE(9916)] = 24311,
  [SMALL_STATE(9917)] = 24391,
  [SMALL_STATE(9918)] = 24471,
  [SMALL_STATE(9919)] = 24551,
  [SMALL_STATE(9920)] = 24605,
  [SMALL_STATE(9921)] = 24685,
  [SMALL_STATE(9922)] = 24739,
  [SMALL_STATE(9923)] = 24819,
  [SMALL_STATE(9924)] = 24899,
  [SMALL_STATE(9925)] = 24979,
  [SMALL_STATE(9926)] = 25059,
  [SMALL_STATE(9927)] = 25139,
  [SMALL_STATE(9928)] = 25193,
  [SMALL_STATE(9929)] = 25273,
  [SMALL_STATE(9930)] = 25353,
  [SMALL_STATE(9931)] = 25407,
  [SMALL_STATE(9932)] = 25487,
  [SMALL_STATE(9933)] = 25567,
  [SMALL_STATE(9934)] = 25647,
  [SMALL_STATE(9935)] = 25701,
  [SMALL_STATE(9936)] = 25781,
  [SMALL_STATE(9937)] = 25861,
  [SMALL_STATE(9938)] = 25941,
  [SMALL_STATE(9939)] = 25999,
  [SMALL_STATE(9940)] = 26053,
  [SMALL_STATE(9941)] = 26133,
  [SMALL_STATE(9942)] = 26213,
  [SMALL_STATE(9943)] = 26293,
  [SMALL_STATE(9944)] = 26373,
  [SMALL_STATE(9945)] = 26427,
  [SMALL_STATE(9946)] = 26507,
  [SMALL_STATE(9947)] = 26587,
  [SMALL_STATE(9948)] = 26667,
  [SMALL_STATE(9949)] = 26721,
  [SMALL_STATE(9950)] = 26775,
  [SMALL_STATE(9951)] = 26855,
  [SMALL_STATE(9952)] = 26935,
  [SMALL_STATE(9953)] = 26989,
  [SMALL_STATE(9954)] = 27069,
  [SMALL_STATE(9955)] = 27123,
  [SMALL_STATE(9956)] = 27203,
  [SMALL_STATE(9957)] = 27257,
  [SMALL_STATE(9958)] = 27337,
  [SMALL_STATE(9959)] = 27391,
  [SMALL_STATE(9960)] = 27471,
  [SMALL_STATE(9961)] = 27551,
  [SMALL_STATE(9962)] = 27605,
  [SMALL_STATE(9963)] = 27659,
  [SMALL_STATE(9964)] = 27739,
  [SMALL_STATE(9965)] = 27793,
  [SMALL_STATE(9966)] = 27873,
  [SMALL_STATE(9967)] = 27927,
  [SMALL_STATE(9968)] = 27981,
  [SMALL_STATE(9969)] = 28037,
  [SMALL_STATE(9970)] = 28117,
  [SMALL_STATE(9971)] = 28197,
  [SMALL_STATE(9972)] = 28251,
  [SMALL_STATE(9973)] = 28309,
  [SMALL_STATE(9974)] = 28389,
  [SMALL_STATE(9975)] = 28443,
  [SMALL_STATE(9976)] = 28497,
  [SMALL_STATE(9977)] = 28577,
  [SMALL_STATE(9978)] = 28657,
  [SMALL_STATE(9979)] = 28715,
  [SMALL_STATE(9980)] = 28769,
  [SMALL_STATE(9981)] = 28823,
  [SMALL_STATE(9982)] = 28877,
  [SMALL_STATE(9983)] = 28931,
  [SMALL_STATE(9984)] = 29011,
  [SMALL_STATE(9985)] = 29091,
  [SMALL_STATE(9986)] = 29145,
  [SMALL_STATE(9987)] = 29199,
  [SMALL_STATE(9988)] = 29279,
  [SMALL_STATE(9989)] = 29359,
  [SMALL_STATE(9990)] = 29413,
  [SMALL_STATE(9991)] = 29467,
  [SMALL_STATE(9992)] = 29547,
  [SMALL_STATE(9993)] = 29601,
  [SMALL_STATE(9994)] = 29655,
  [SMALL_STATE(9995)] = 29709,
  [SMALL_STATE(9996)] = 29789,
  [SMALL_STATE(9997)] = 29843,
  [SMALL_STATE(9998)] = 29923,
  [SMALL_STATE(9999)] = 29977,
  [SMALL_STATE(10000)] = 30057,
  [SMALL_STATE(10001)] = 30111,
  [SMALL_STATE(10002)] = 30191,
  [SMALL_STATE(10003)] = 30271,
  [SMALL_STATE(10004)] = 30327,
  [SMALL_STATE(10005)] = 30381,
  [SMALL_STATE(10006)] = 30435,
  [SMALL_STATE(10007)] = 30489,
  [SMALL_STATE(10008)] = 30543,
  [SMALL_STATE(10009)] = 30597,
  [SMALL_STATE(10010)] = 30651,
  [SMALL_STATE(10011)] = 30705,
  [SMALL_STATE(10012)] = 30785,
  [SMALL_STATE(10013)] = 30865,
  [SMALL_STATE(10014)] = 30919,
  [SMALL_STATE(10015)] = 30973,
  [SMALL_STATE(10016)] = 31027,
  [SMALL_STATE(10017)] = 31081,
  [SMALL_STATE(10018)] = 31161,
  [SMALL_STATE(10019)] = 31215,
  [SMALL_STATE(10020)] = 31295,
  [SMALL_STATE(10021)] = 31375,
  [SMALL_STATE(10022)] = 31429,
  [SMALL_STATE(10023)] = 31483,
  [SMALL_STATE(10024)] = 31537,
  [SMALL_STATE(10025)] = 31617,
  [SMALL_STATE(10026)] = 31697,
  [SMALL_STATE(10027)] = 31777,
  [SMALL_STATE(10028)] = 31857,
  [SMALL_STATE(10029)] = 31911,
  [SMALL_STATE(10030)] = 31965,
  [SMALL_STATE(10031)] = 32045,
  [SMALL_STATE(10032)] = 32125,
  [SMALL_STATE(10033)] = 32183,
  [SMALL_STATE(10034)] = 32263,
  [SMALL_STATE(10035)] = 32317,
  [SMALL_STATE(10036)] = 32397,
  [SMALL_STATE(10037)] = 32451,
  [SMALL_STATE(10038)] = 32505,
  [SMALL_STATE(10039)] = 32559,
  [SMALL_STATE(10040)] = 32612,
  [SMALL_STATE(10041)] = 32667,
  [SMALL_STATE(10042)] = 32720,
  [SMALL_STATE(10043)] = 32771,
  [SMALL_STATE(10044)] = 32824,
  [SMALL_STATE(10045)] = 32877,
  [SMALL_STATE(10046)] = 32930,
  [SMALL_STATE(10047)] = 32983,
  [SMALL_STATE(10048)] = 33036,
  [SMALL_STATE(10049)] = 33089,
  [SMALL_STATE(10050)] = 33142,
  [SMALL_STATE(10051)] = 33195,
  [SMALL_STATE(10052)] = 33248,
  [SMALL_STATE(10053)] = 33301,
  [SMALL_STATE(10054)] = 33354,
  [SMALL_STATE(10055)] = 33407,
  [SMALL_STATE(10056)] = 33460,
  [SMALL_STATE(10057)] = 33513,
  [SMALL_STATE(10058)] = 33566,
  [SMALL_STATE(10059)] = 33619,
  [SMALL_STATE(10060)] = 33672,
  [SMALL_STATE(10061)] = 33725,
  [SMALL_STATE(10062)] = 33778,
  [SMALL_STATE(10063)] = 33831,
  [SMALL_STATE(10064)] = 33884,
  [SMALL_STATE(10065)] = 33937,
  [SMALL_STATE(10066)] = 33990,
  [SMALL_STATE(10067)] = 34043,
  [SMALL_STATE(10068)] = 34096,
  [SMALL_STATE(10069)] = 34149,
  [SMALL_STATE(10070)] = 34202,
  [SMALL_STATE(10071)] = 34255,
  [SMALL_STATE(10072)] = 34308,
  [SMALL_STATE(10073)] = 34361,
  [SMALL_STATE(10074)] = 34414,
  [SMALL_STATE(10075)] = 34467,
  [SMALL_STATE(10076)] = 34520,
  [SMALL_STATE(10077)] = 34573,
  [SMALL_STATE(10078)] = 34626,
  [SMALL_STATE(10079)] = 34679,
  [SMALL_STATE(10080)] = 34732,
  [SMALL_STATE(10081)] = 34785,
  [SMALL_STATE(10082)] = 34838,
  [SMALL_STATE(10083)] = 34891,
  [SMALL_STATE(10084)] = 34944,
  [SMALL_STATE(10085)] = 34997,
  [SMALL_STATE(10086)] = 35050,
  [SMALL_STATE(10087)] = 35103,
  [SMALL_STATE(10088)] = 35156,
  [SMALL_STATE(10089)] = 35209,
  [SMALL_STATE(10090)] = 35262,
  [SMALL_STATE(10091)] = 35315,
  [SMALL_STATE(10092)] = 35368,
  [SMALL_STATE(10093)] = 35421,
  [SMALL_STATE(10094)] = 35474,
  [SMALL_STATE(10095)] = 35527,
  [SMALL_STATE(10096)] = 35580,
  [SMALL_STATE(10097)] = 35633,
  [SMALL_STATE(10098)] = 35686,
  [SMALL_STATE(10099)] = 35739,
  [SMALL_STATE(10100)] = 35792,
  [SMALL_STATE(10101)] = 35847,
  [SMALL_STATE(10102)] = 35900,
  [SMALL_STATE(10103)] = 35953,
  [SMALL_STATE(10104)] = 36006,
  [SMALL_STATE(10105)] = 36059,
  [SMALL_STATE(10106)] = 36112,
  [SMALL_STATE(10107)] = 36165,
  [SMALL_STATE(10108)] = 36218,
  [SMALL_STATE(10109)] = 36273,
  [SMALL_STATE(10110)] = 36326,
  [SMALL_STATE(10111)] = 36379,
  [SMALL_STATE(10112)] = 36430,
  [SMALL_STATE(10113)] = 36483,
  [SMALL_STATE(10114)] = 36536,
  [SMALL_STATE(10115)] = 36589,
  [SMALL_STATE(10116)] = 36640,
  [SMALL_STATE(10117)] = 36693,
  [SMALL_STATE(10118)] = 36746,
  [SMALL_STATE(10119)] = 36799,
  [SMALL_STATE(10120)] = 36852,
  [SMALL_STATE(10121)] = 36905,
  [SMALL_STATE(10122)] = 36957,
  [SMALL_STATE(10123)] = 37009,
  [SMALL_STATE(10124)] = 37061,
  [SMALL_STATE(10125)] = 37113,
  [SMALL_STATE(10126)] = 37165,
  [SMALL_STATE(10127)] = 37217,
  [SMALL_STATE(10128)] = 37269,
  [SMALL_STATE(10129)] = 37321,
  [SMALL_STATE(10130)] = 37373,
  [SMALL_STATE(10131)] = 37425,
  [SMALL_STATE(10132)] = 37477,
  [SMALL_STATE(10133)] = 37529,
  [SMALL_STATE(10134)] = 37581,
  [SMALL_STATE(10135)] = 37631,
  [SMALL_STATE(10136)] = 37683,
  [SMALL_STATE(10137)] = 37733,
  [SMALL_STATE(10138)] = 37785,
  [SMALL_STATE(10139)] = 37837,
  [SMALL_STATE(10140)] = 37889,
  [SMALL_STATE(10141)] = 37941,
  [SMALL_STATE(10142)] = 37993,
  [SMALL_STATE(10143)] = 38045,
  [SMALL_STATE(10144)] = 38097,
  [SMALL_STATE(10145)] = 38149,
  [SMALL_STATE(10146)] = 38201,
  [SMALL_STATE(10147)] = 38253,
  [SMALL_STATE(10148)] = 38305,
  [SMALL_STATE(10149)] = 38357,
  [SMALL_STATE(10150)] = 38409,
  [SMALL_STATE(10151)] = 38461,
  [SMALL_STATE(10152)] = 38513,
  [SMALL_STATE(10153)] = 38565,
  [SMALL_STATE(10154)] = 38617,
  [SMALL_STATE(10155)] = 38669,
  [SMALL_STATE(10156)] = 38721,
  [SMALL_STATE(10157)] = 38773,
  [SMALL_STATE(10158)] = 38825,
  [SMALL_STATE(10159)] = 38877,
  [SMALL_STATE(10160)] = 38929,
  [SMALL_STATE(10161)] = 38981,
  [SMALL_STATE(10162)] = 39033,
  [SMALL_STATE(10163)] = 39085,
  [SMALL_STATE(10164)] = 39137,
  [SMALL_STATE(10165)] = 39189,
  [SMALL_STATE(10166)] = 39241,
  [SMALL_STATE(10167)] = 39293,
  [SMALL_STATE(10168)] = 39345,
  [SMALL_STATE(10169)] = 39397,
  [SMALL_STATE(10170)] = 39449,
  [SMALL_STATE(10171)] = 39499,
  [SMALL_STATE(10172)] = 39551,
  [SMALL_STATE(10173)] = 39603,
  [SMALL_STATE(10174)] = 39655,
  [SMALL_STATE(10175)] = 39707,
  [SMALL_STATE(10176)] = 39759,
  [SMALL_STATE(10177)] = 39811,
  [SMALL_STATE(10178)] = 39863,
  [SMALL_STATE(10179)] = 39915,
  [SMALL_STATE(10180)] = 39967,
  [SMALL_STATE(10181)] = 40019,
  [SMALL_STATE(10182)] = 40071,
  [SMALL_STATE(10183)] = 40123,
  [SMALL_STATE(10184)] = 40175,
  [SMALL_STATE(10185)] = 40226,
  [SMALL_STATE(10186)] = 40275,
  [SMALL_STATE(10187)] = 40331,
  [SMALL_STATE(10188)] = 40383,
  [SMALL_STATE(10189)] = 40435,
  [SMALL_STATE(10190)] = 40487,
  [SMALL_STATE(10191)] = 40537,
  [SMALL_STATE(10192)] = 40593,
  [SMALL_STATE(10193)] = 40645,
  [SMALL_STATE(10194)] = 40701,
  [SMALL_STATE(10195)] = 40749,
  [SMALL_STATE(10196)] = 40805,
  [SMALL_STATE(10197)] = 40861,
  [SMALL_STATE(10198)] = 40911,
  [SMALL_STATE(10199)] = 40967,
  [SMALL_STATE(10200)] = 41019,
  [SMALL_STATE(10201)] = 41075,
  [SMALL_STATE(10202)] = 41131,
  [SMALL_STATE(10203)] = 41180,
  [SMALL_STATE(10204)] = 41229,
  [SMALL_STATE(10205)] = 41278,
  [SMALL_STATE(10206)] = 41325,
  [SMALL_STATE(10207)] = 41378,
  [SMALL_STATE(10208)] = 41427,
  [SMALL_STATE(10209)] = 41476,
  [SMALL_STATE(10210)] = 41525,
  [SMALL_STATE(10211)] = 41574,
  [SMALL_STATE(10212)] = 41623,
  [SMALL_STATE(10213)] = 41672,
  [SMALL_STATE(10214)] = 41721,
  [SMALL_STATE(10215)] = 41768,
  [SMALL_STATE(10216)] = 41817,
  [SMALL_STATE(10217)] = 41872,
  [SMALL_STATE(10218)] = 41921,
  [SMALL_STATE(10219)] = 41970,
  [SMALL_STATE(10220)] = 42017,
  [SMALL_STATE(10221)] = 42066,
  [SMALL_STATE(10222)] = 42115,
  [SMALL_STATE(10223)] = 42164,
  [SMALL_STATE(10224)] = 42213,
  [SMALL_STATE(10225)] = 42262,
  [SMALL_STATE(10226)] = 42311,
  [SMALL_STATE(10227)] = 42360,
  [SMALL_STATE(10228)] = 42413,
  [SMALL_STATE(10229)] = 42462,
  [SMALL_STATE(10230)] = 42511,
  [SMALL_STATE(10231)] = 42560,
  [SMALL_STATE(10232)] = 42609,
  [SMALL_STATE(10233)] = 42658,
  [SMALL_STATE(10234)] = 42707,
  [SMALL_STATE(10235)] = 42760,
  [SMALL_STATE(10236)] = 42813,
  [SMALL_STATE(10237)] = 42862,
  [SMALL_STATE(10238)] = 42915,
  [SMALL_STATE(10239)] = 42964,
  [SMALL_STATE(10240)] = 43017,
  [SMALL_STATE(10241)] = 43070,
  [SMALL_STATE(10242)] = 43119,
  [SMALL_STATE(10243)] = 43168,
  [SMALL_STATE(10244)] = 43221,
  [SMALL_STATE(10245)] = 43268,
  [SMALL_STATE(10246)] = 43323,
  [SMALL_STATE(10247)] = 43374,
  [SMALL_STATE(10248)] = 43427,
  [SMALL_STATE(10249)] = 43478,
  [SMALL_STATE(10250)] = 43525,
  [SMALL_STATE(10251)] = 43576,
  [SMALL_STATE(10252)] = 43629,
  [SMALL_STATE(10253)] = 43676,
  [SMALL_STATE(10254)] = 43725,
  [SMALL_STATE(10255)] = 43778,
  [SMALL_STATE(10256)] = 43831,
  [SMALL_STATE(10257)] = 43884,
  [SMALL_STATE(10258)] = 43939,
  [SMALL_STATE(10259)] = 43990,
  [SMALL_STATE(10260)] = 44043,
  [SMALL_STATE(10261)] = 44092,
  [SMALL_STATE(10262)] = 44143,
  [SMALL_STATE(10263)] = 44190,
  [SMALL_STATE(10264)] = 44239,
  [SMALL_STATE(10265)] = 44292,
  [SMALL_STATE(10266)] = 44345,
  [SMALL_STATE(10267)] = 44394,
  [SMALL_STATE(10268)] = 44449,
  [SMALL_STATE(10269)] = 44496,
  [SMALL_STATE(10270)] = 44545,
  [SMALL_STATE(10271)] = 44596,
  [SMALL_STATE(10272)] = 44649,
  [SMALL_STATE(10273)] = 44702,
  [SMALL_STATE(10274)] = 44749,
  [SMALL_STATE(10275)] = 44796,
  [SMALL_STATE(10276)] = 44843,
  [SMALL_STATE(10277)] = 44892,
  [SMALL_STATE(10278)] = 44943,
  [SMALL_STATE(10279)] = 44990,
  [SMALL_STATE(10280)] = 45043,
  [SMALL_STATE(10281)] = 45092,
  [SMALL_STATE(10282)] = 45145,
  [SMALL_STATE(10283)] = 45194,
  [SMALL_STATE(10284)] = 45243,
  [SMALL_STATE(10285)] = 45296,
  [SMALL_STATE(10286)] = 45349,
  [SMALL_STATE(10287)] = 45402,
  [SMALL_STATE(10288)] = 45451,
  [SMALL_STATE(10289)] = 45500,
  [SMALL_STATE(10290)] = 45553,
  [SMALL_STATE(10291)] = 45606,
  [SMALL_STATE(10292)] = 45655,
  [SMALL_STATE(10293)] = 45708,
  [SMALL_STATE(10294)] = 45755,
  [SMALL_STATE(10295)] = 45808,
  [SMALL_STATE(10296)] = 45861,
  [SMALL_STATE(10297)] = 45914,
  [SMALL_STATE(10298)] = 45963,
  [SMALL_STATE(10299)] = 46018,
  [SMALL_STATE(10300)] = 46073,
  [SMALL_STATE(10301)] = 46122,
  [SMALL_STATE(10302)] = 46171,
  [SMALL_STATE(10303)] = 46220,
  [SMALL_STATE(10304)] = 46273,
  [SMALL_STATE(10305)] = 46326,
  [SMALL_STATE(10306)] = 46379,
  [SMALL_STATE(10307)] = 46428,
  [SMALL_STATE(10308)] = 46477,
  [SMALL_STATE(10309)] = 46530,
  [SMALL_STATE(10310)] = 46579,
  [SMALL_STATE(10311)] = 46628,
  [SMALL_STATE(10312)] = 46679,
  [SMALL_STATE(10313)] = 46728,
  [SMALL_STATE(10314)] = 46781,
  [SMALL_STATE(10315)] = 46832,
  [SMALL_STATE(10316)] = 46885,
  [SMALL_STATE(10317)] = 46936,
  [SMALL_STATE(10318)] = 46989,
  [SMALL_STATE(10319)] = 47040,
  [SMALL_STATE(10320)] = 47091,
  [SMALL_STATE(10321)] = 47140,
  [SMALL_STATE(10322)] = 47186,
  [SMALL_STATE(10323)] = 47234,
  [SMALL_STATE(10324)] = 47282,
  [SMALL_STATE(10325)] = 47330,
  [SMALL_STATE(10326)] = 47382,
  [SMALL_STATE(10327)] = 47430,
  [SMALL_STATE(10328)] = 47478,
  [SMALL_STATE(10329)] = 47526,
  [SMALL_STATE(10330)] = 47578,
  [SMALL_STATE(10331)] = 47626,
  [SMALL_STATE(10332)] = 47674,
  [SMALL_STATE(10333)] = 47726,
  [SMALL_STATE(10334)] = 47776,
  [SMALL_STATE(10335)] = 47828,
  [SMALL_STATE(10336)] = 47876,
  [SMALL_STATE(10337)] = 47928,
  [SMALL_STATE(10338)] = 47976,
  [SMALL_STATE(10339)] = 48024,
  [SMALL_STATE(10340)] = 48072,
  [SMALL_STATE(10341)] = 48118,
  [SMALL_STATE(10342)] = 48168,
  [SMALL_STATE(10343)] = 48220,
  [SMALL_STATE(10344)] = 48272,
  [SMALL_STATE(10345)] = 48320,
  [SMALL_STATE(10346)] = 48372,
  [SMALL_STATE(10347)] = 48424,
  [SMALL_STATE(10348)] = 48470,
  [SMALL_STATE(10349)] = 48520,
  [SMALL_STATE(10350)] = 48572,
  [SMALL_STATE(10351)] = 48626,
  [SMALL_STATE(10352)] = 48676,
  [SMALL_STATE(10353)] = 48726,
  [SMALL_STATE(10354)] = 48780,
  [SMALL_STATE(10355)] = 48830,
  [SMALL_STATE(10356)] = 48878,
  [SMALL_STATE(10357)] = 48940,
  [SMALL_STATE(10358)] = 48990,
  [SMALL_STATE(10359)] = 49036,
  [SMALL_STATE(10360)] = 49082,
  [SMALL_STATE(10361)] = 49132,
  [SMALL_STATE(10362)] = 49182,
  [SMALL_STATE(10363)] = 49230,
  [SMALL_STATE(10364)] = 49282,
  [SMALL_STATE(10365)] = 49328,
  [SMALL_STATE(10366)] = 49380,
  [SMALL_STATE(10367)] = 49432,
  [SMALL_STATE(10368)] = 49484,
  [SMALL_STATE(10369)] = 49532,
  [SMALL_STATE(10370)] = 49578,
  [SMALL_STATE(10371)] = 49624,
  [SMALL_STATE(10372)] = 49670,
  [SMALL_STATE(10373)] = 49716,
  [SMALL_STATE(10374)] = 49762,
  [SMALL_STATE(10375)] = 49808,
  [SMALL_STATE(10376)] = 49854,
  [SMALL_STATE(10377)] = 49900,
  [SMALL_STATE(10378)] = 49950,
  [SMALL_STATE(10379)] = 49996,
  [SMALL_STATE(10380)] = 50042,
  [SMALL_STATE(10381)] = 50088,
  [SMALL_STATE(10382)] = 50134,
  [SMALL_STATE(10383)] = 50180,
  [SMALL_STATE(10384)] = 50228,
  [SMALL_STATE(10385)] = 50278,
  [SMALL_STATE(10386)] = 50324,
  [SMALL_STATE(10387)] = 50378,
  [SMALL_STATE(10388)] = 50426,
  [SMALL_STATE(10389)] = 50472,
  [SMALL_STATE(10390)] = 50518,
  [SMALL_STATE(10391)] = 50564,
  [SMALL_STATE(10392)] = 50610,
  [SMALL_STATE(10393)] = 50660,
  [SMALL_STATE(10394)] = 50708,
  [SMALL_STATE(10395)] = 50756,
  [SMALL_STATE(10396)] = 50802,
  [SMALL_STATE(10397)] = 50848,
  [SMALL_STATE(10398)] = 50898,
  [SMALL_STATE(10399)] = 50944,
  [SMALL_STATE(10400)] = 50990,
  [SMALL_STATE(10401)] = 51036,
  [SMALL_STATE(10402)] = 51088,
  [SMALL_STATE(10403)] = 51138,
  [SMALL_STATE(10404)] = 51184,
  [SMALL_STATE(10405)] = 51230,
  [SMALL_STATE(10406)] = 51276,
  [SMALL_STATE(10407)] = 51328,
  [SMALL_STATE(10408)] = 51374,
  [SMALL_STATE(10409)] = 51424,
  [SMALL_STATE(10410)] = 51470,
  [SMALL_STATE(10411)] = 51524,
  [SMALL_STATE(10412)] = 51586,
  [SMALL_STATE(10413)] = 51632,
  [SMALL_STATE(10414)] = 51686,
  [SMALL_STATE(10415)] = 51738,
  [SMALL_STATE(10416)] = 51792,
  [SMALL_STATE(10417)] = 51842,
  [SMALL_STATE(10418)] = 51894,
  [SMALL_STATE(10419)] = 51946,
  [SMALL_STATE(10420)] = 51998,
  [SMALL_STATE(10421)] = 52050,
  [SMALL_STATE(10422)] = 52100,
  [SMALL_STATE(10423)] = 52150,
  [SMALL_STATE(10424)] = 52202,
  [SMALL_STATE(10425)] = 52254,
  [SMALL_STATE(10426)] = 52306,
  [SMALL_STATE(10427)] = 52356,
  [SMALL_STATE(10428)] = 52406,
  [SMALL_STATE(10429)] = 52458,
  [SMALL_STATE(10430)] = 52508,
  [SMALL_STATE(10431)] = 52560,
  [SMALL_STATE(10432)] = 52606,
  [SMALL_STATE(10433)] = 52652,
  [SMALL_STATE(10434)] = 52698,
  [SMALL_STATE(10435)] = 52744,
  [SMALL_STATE(10436)] = 52794,
  [SMALL_STATE(10437)] = 52846,
  [SMALL_STATE(10438)] = 52898,
  [SMALL_STATE(10439)] = 52944,
  [SMALL_STATE(10440)] = 52990,
  [SMALL_STATE(10441)] = 53036,
  [SMALL_STATE(10442)] = 53082,
  [SMALL_STATE(10443)] = 53128,
  [SMALL_STATE(10444)] = 53180,
  [SMALL_STATE(10445)] = 53232,
  [SMALL_STATE(10446)] = 53278,
  [SMALL_STATE(10447)] = 53330,
  [SMALL_STATE(10448)] = 53382,
  [SMALL_STATE(10449)] = 53432,
  [SMALL_STATE(10450)] = 53482,
  [SMALL_STATE(10451)] = 53534,
  [SMALL_STATE(10452)] = 53584,
  [SMALL_STATE(10453)] = 53630,
  [SMALL_STATE(10454)] = 53682,
  [SMALL_STATE(10455)] = 53744,
  [SMALL_STATE(10456)] = 53790,
  [SMALL_STATE(10457)] = 53842,
  [SMALL_STATE(10458)] = 53894,
  [SMALL_STATE(10459)] = 53940,
  [SMALL_STATE(10460)] = 53986,
  [SMALL_STATE(10461)] = 54032,
  [SMALL_STATE(10462)] = 54080,
  [SMALL_STATE(10463)] = 54132,
  [SMALL_STATE(10464)] = 54178,
  [SMALL_STATE(10465)] = 54226,
  [SMALL_STATE(10466)] = 54274,
  [SMALL_STATE(10467)] = 54336,
  [SMALL_STATE(10468)] = 54390,
  [SMALL_STATE(10469)] = 54440,
  [SMALL_STATE(10470)] = 54492,
  [SMALL_STATE(10471)] = 54538,
  [SMALL_STATE(10472)] = 54590,
  [SMALL_STATE(10473)] = 54642,
  [SMALL_STATE(10474)] = 54694,
  [SMALL_STATE(10475)] = 54740,
  [SMALL_STATE(10476)] = 54792,
  [SMALL_STATE(10477)] = 54844,
  [SMALL_STATE(10478)] = 54896,
  [SMALL_STATE(10479)] = 54958,
  [SMALL_STATE(10480)] = 55010,
  [SMALL_STATE(10481)] = 55058,
  [SMALL_STATE(10482)] = 55110,
  [SMALL_STATE(10483)] = 55172,
  [SMALL_STATE(10484)] = 55224,
  [SMALL_STATE(10485)] = 55286,
  [SMALL_STATE(10486)] = 55338,
  [SMALL_STATE(10487)] = 55390,
  [SMALL_STATE(10488)] = 55442,
  [SMALL_STATE(10489)] = 55494,
  [SMALL_STATE(10490)] = 55540,
  [SMALL_STATE(10491)] = 55586,
  [SMALL_STATE(10492)] = 55632,
  [SMALL_STATE(10493)] = 55682,
  [SMALL_STATE(10494)] = 55732,
  [SMALL_STATE(10495)] = 55794,
  [SMALL_STATE(10496)] = 55856,
  [SMALL_STATE(10497)] = 55918,
  [SMALL_STATE(10498)] = 55966,
  [SMALL_STATE(10499)] = 56028,
  [SMALL_STATE(10500)] = 56074,
  [SMALL_STATE(10501)] = 56120,
  [SMALL_STATE(10502)] = 56168,
  [SMALL_STATE(10503)] = 56230,
  [SMALL_STATE(10504)] = 56292,
  [SMALL_STATE(10505)] = 56338,
  [SMALL_STATE(10506)] = 56384,
  [SMALL_STATE(10507)] = 56436,
  [SMALL_STATE(10508)] = 56488,
  [SMALL_STATE(10509)] = 56540,
  [SMALL_STATE(10510)] = 56592,
  [SMALL_STATE(10511)] = 56644,
  [SMALL_STATE(10512)] = 56692,
  [SMALL_STATE(10513)] = 56738,
  [SMALL_STATE(10514)] = 56790,
  [SMALL_STATE(10515)] = 56842,
  [SMALL_STATE(10516)] = 56894,
  [SMALL_STATE(10517)] = 56946,
  [SMALL_STATE(10518)] = 56992,
  [SMALL_STATE(10519)] = 57038,
  [SMALL_STATE(10520)] = 57088,
  [SMALL_STATE(10521)] = 57134,
  [SMALL_STATE(10522)] = 57188,
  [SMALL_STATE(10523)] = 57236,
  [SMALL_STATE(10524)] = 57286,
  [SMALL_STATE(10525)] = 57332,
  [SMALL_STATE(10526)] = 57384,
  [SMALL_STATE(10527)] = 57432,
  [SMALL_STATE(10528)] = 57484,
  [SMALL_STATE(10529)] = 57530,
  [SMALL_STATE(10530)] = 57582,
  [SMALL_STATE(10531)] = 57634,
  [SMALL_STATE(10532)] = 57686,
  [SMALL_STATE(10533)] = 57731,
  [SMALL_STATE(10534)] = 57790,
  [SMALL_STATE(10535)] = 57837,
  [SMALL_STATE(10536)] = 57884,
  [SMALL_STATE(10537)] = 57929,
  [SMALL_STATE(10538)] = 57974,
  [SMALL_STATE(10539)] = 58021,
  [SMALL_STATE(10540)] = 58066,
  [SMALL_STATE(10541)] = 58123,
  [SMALL_STATE(10542)] = 58170,
  [SMALL_STATE(10543)] = 58217,
  [SMALL_STATE(10544)] = 58264,
  [SMALL_STATE(10545)] = 58311,
  [SMALL_STATE(10546)] = 58358,
  [SMALL_STATE(10547)] = 58405,
  [SMALL_STATE(10548)] = 58454,
  [SMALL_STATE(10549)] = 58501,
  [SMALL_STATE(10550)] = 58548,
  [SMALL_STATE(10551)] = 58595,
  [SMALL_STATE(10552)] = 58654,
  [SMALL_STATE(10553)] = 58705,
  [SMALL_STATE(10554)] = 58756,
  [SMALL_STATE(10555)] = 58807,
  [SMALL_STATE(10556)] = 58854,
  [SMALL_STATE(10557)] = 58901,
  [SMALL_STATE(10558)] = 58948,
  [SMALL_STATE(10559)] = 58995,
  [SMALL_STATE(10560)] = 59042,
  [SMALL_STATE(10561)] = 59089,
  [SMALL_STATE(10562)] = 59136,
  [SMALL_STATE(10563)] = 59187,
  [SMALL_STATE(10564)] = 59234,
  [SMALL_STATE(10565)] = 59281,
  [SMALL_STATE(10566)] = 59328,
  [SMALL_STATE(10567)] = 59387,
  [SMALL_STATE(10568)] = 59434,
  [SMALL_STATE(10569)] = 59481,
  [SMALL_STATE(10570)] = 59528,
  [SMALL_STATE(10571)] = 59575,
  [SMALL_STATE(10572)] = 59620,
  [SMALL_STATE(10573)] = 59681,
  [SMALL_STATE(10574)] = 59732,
  [SMALL_STATE(10575)] = 59783,
  [SMALL_STATE(10576)] = 59830,
  [SMALL_STATE(10577)] = 59877,
  [SMALL_STATE(10578)] = 59928,
  [SMALL_STATE(10579)] = 59975,
  [SMALL_STATE(10580)] = 60024,
  [SMALL_STATE(10581)] = 60071,
  [SMALL_STATE(10582)] = 60118,
  [SMALL_STATE(10583)] = 60163,
  [SMALL_STATE(10584)] = 60210,
  [SMALL_STATE(10585)] = 60261,
  [SMALL_STATE(10586)] = 60308,
  [SMALL_STATE(10587)] = 60355,
  [SMALL_STATE(10588)] = 60402,
  [SMALL_STATE(10589)] = 60451,
  [SMALL_STATE(10590)] = 60498,
  [SMALL_STATE(10591)] = 60549,
  [SMALL_STATE(10592)] = 60610,
  [SMALL_STATE(10593)] = 60657,
  [SMALL_STATE(10594)] = 60702,
  [SMALL_STATE(10595)] = 60747,
  [SMALL_STATE(10596)] = 60794,
  [SMALL_STATE(10597)] = 60841,
  [SMALL_STATE(10598)] = 60888,
  [SMALL_STATE(10599)] = 60935,
  [SMALL_STATE(10600)] = 60982,
  [SMALL_STATE(10601)] = 61029,
  [SMALL_STATE(10602)] = 61074,
  [SMALL_STATE(10603)] = 61121,
  [SMALL_STATE(10604)] = 61170,
  [SMALL_STATE(10605)] = 61217,
  [SMALL_STATE(10606)] = 61262,
  [SMALL_STATE(10607)] = 61309,
  [SMALL_STATE(10608)] = 61356,
  [SMALL_STATE(10609)] = 61403,
  [SMALL_STATE(10610)] = 61450,
  [SMALL_STATE(10611)] = 61497,
  [SMALL_STATE(10612)] = 61542,
  [SMALL_STATE(10613)] = 61593,
  [SMALL_STATE(10614)] = 61644,
  [SMALL_STATE(10615)] = 61695,
  [SMALL_STATE(10616)] = 61740,
  [SMALL_STATE(10617)] = 61787,
  [SMALL_STATE(10618)] = 61832,
  [SMALL_STATE(10619)] = 61877,
  [SMALL_STATE(10620)] = 61938,
  [SMALL_STATE(10621)] = 61987,
  [SMALL_STATE(10622)] = 62034,
  [SMALL_STATE(10623)] = 62079,
  [SMALL_STATE(10624)] = 62126,
  [SMALL_STATE(10625)] = 62173,
  [SMALL_STATE(10626)] = 62218,
  [SMALL_STATE(10627)] = 62267,
  [SMALL_STATE(10628)] = 62314,
  [SMALL_STATE(10629)] = 62359,
  [SMALL_STATE(10630)] = 62406,
  [SMALL_STATE(10631)] = 62467,
  [SMALL_STATE(10632)] = 62514,
  [SMALL_STATE(10633)] = 62559,
  [SMALL_STATE(10634)] = 62610,
  [SMALL_STATE(10635)] = 62661,
  [SMALL_STATE(10636)] = 62712,
  [SMALL_STATE(10637)] = 62759,
  [SMALL_STATE(10638)] = 62806,
  [SMALL_STATE(10639)] = 62857,
  [SMALL_STATE(10640)] = 62906,
  [SMALL_STATE(10641)] = 62951,
  [SMALL_STATE(10642)] = 62998,
  [SMALL_STATE(10643)] = 63045,
  [SMALL_STATE(10644)] = 63092,
  [SMALL_STATE(10645)] = 63143,
  [SMALL_STATE(10646)] = 63188,
  [SMALL_STATE(10647)] = 63235,
  [SMALL_STATE(10648)] = 63286,
  [SMALL_STATE(10649)] = 63333,
  [SMALL_STATE(10650)] = 63380,
  [SMALL_STATE(10651)] = 63425,
  [SMALL_STATE(10652)] = 63472,
  [SMALL_STATE(10653)] = 63517,
  [SMALL_STATE(10654)] = 63564,
  [SMALL_STATE(10655)] = 63615,
  [SMALL_STATE(10656)] = 63662,
  [SMALL_STATE(10657)] = 63709,
  [SMALL_STATE(10658)] = 63756,
  [SMALL_STATE(10659)] = 63803,
  [SMALL_STATE(10660)] = 63850,
  [SMALL_STATE(10661)] = 63895,
  [SMALL_STATE(10662)] = 63942,
  [SMALL_STATE(10663)] = 63989,
  [SMALL_STATE(10664)] = 64036,
  [SMALL_STATE(10665)] = 64083,
  [SMALL_STATE(10666)] = 64130,
  [SMALL_STATE(10667)] = 64175,
  [SMALL_STATE(10668)] = 64220,
  [SMALL_STATE(10669)] = 64265,
  [SMALL_STATE(10670)] = 64312,
  [SMALL_STATE(10671)] = 64359,
  [SMALL_STATE(10672)] = 64406,
  [SMALL_STATE(10673)] = 64455,
  [SMALL_STATE(10674)] = 64502,
  [SMALL_STATE(10675)] = 64547,
  [SMALL_STATE(10676)] = 64594,
  [SMALL_STATE(10677)] = 64645,
  [SMALL_STATE(10678)] = 64704,
  [SMALL_STATE(10679)] = 64755,
  [SMALL_STATE(10680)] = 64802,
  [SMALL_STATE(10681)] = 64847,
  [SMALL_STATE(10682)] = 64894,
  [SMALL_STATE(10683)] = 64945,
  [SMALL_STATE(10684)] = 64996,
  [SMALL_STATE(10685)] = 65043,
  [SMALL_STATE(10686)] = 65094,
  [SMALL_STATE(10687)] = 65139,
  [SMALL_STATE(10688)] = 65184,
  [SMALL_STATE(10689)] = 65229,
  [SMALL_STATE(10690)] = 65274,
  [SMALL_STATE(10691)] = 65321,
  [SMALL_STATE(10692)] = 65368,
  [SMALL_STATE(10693)] = 65415,
  [SMALL_STATE(10694)] = 65464,
  [SMALL_STATE(10695)] = 65511,
  [SMALL_STATE(10696)] = 65556,
  [SMALL_STATE(10697)] = 65607,
  [SMALL_STATE(10698)] = 65654,
  [SMALL_STATE(10699)] = 65699,
  [SMALL_STATE(10700)] = 65746,
  [SMALL_STATE(10701)] = 65793,
  [SMALL_STATE(10702)] = 65852,
  [SMALL_STATE(10703)] = 65899,
  [SMALL_STATE(10704)] = 65946,
  [SMALL_STATE(10705)] = 65993,
  [SMALL_STATE(10706)] = 66040,
  [SMALL_STATE(10707)] = 66087,
  [SMALL_STATE(10708)] = 66134,
  [SMALL_STATE(10709)] = 66179,
  [SMALL_STATE(10710)] = 66224,
  [SMALL_STATE(10711)] = 66269,
  [SMALL_STATE(10712)] = 66314,
  [SMALL_STATE(10713)] = 66359,
  [SMALL_STATE(10714)] = 66404,
  [SMALL_STATE(10715)] = 66449,
  [SMALL_STATE(10716)] = 66494,
  [SMALL_STATE(10717)] = 66541,
  [SMALL_STATE(10718)] = 66590,
  [SMALL_STATE(10719)] = 66635,
  [SMALL_STATE(10720)] = 66686,
  [SMALL_STATE(10721)] = 66737,
  [SMALL_STATE(10722)] = 66784,
  [SMALL_STATE(10723)] = 66835,
  [SMALL_STATE(10724)] = 66882,
  [SMALL_STATE(10725)] = 66927,
  [SMALL_STATE(10726)] = 66978,
  [SMALL_STATE(10727)] = 67025,
  [SMALL_STATE(10728)] = 67072,
  [SMALL_STATE(10729)] = 67119,
  [SMALL_STATE(10730)] = 67166,
  [SMALL_STATE(10731)] = 67211,
  [SMALL_STATE(10732)] = 67262,
  [SMALL_STATE(10733)] = 67313,
  [SMALL_STATE(10734)] = 67362,
  [SMALL_STATE(10735)] = 67413,
  [SMALL_STATE(10736)] = 67464,
  [SMALL_STATE(10737)] = 67509,
  [SMALL_STATE(10738)] = 67558,
  [SMALL_STATE(10739)] = 67603,
  [SMALL_STATE(10740)] = 67654,
  [SMALL_STATE(10741)] = 67701,
  [SMALL_STATE(10742)] = 67748,
  [SMALL_STATE(10743)] = 67799,
  [SMALL_STATE(10744)] = 67846,
  [SMALL_STATE(10745)] = 67891,
  [SMALL_STATE(10746)] = 67936,
  [SMALL_STATE(10747)] = 67987,
  [SMALL_STATE(10748)] = 68034,
  [SMALL_STATE(10749)] = 68079,
  [SMALL_STATE(10750)] = 68126,
  [SMALL_STATE(10751)] = 68171,
  [SMALL_STATE(10752)] = 68216,
  [SMALL_STATE(10753)] = 68267,
  [SMALL_STATE(10754)] = 68314,
  [SMALL_STATE(10755)] = 68361,
  [SMALL_STATE(10756)] = 68408,
  [SMALL_STATE(10757)] = 68455,
  [SMALL_STATE(10758)] = 68502,
  [SMALL_STATE(10759)] = 68549,
  [SMALL_STATE(10760)] = 68594,
  [SMALL_STATE(10761)] = 68641,
  [SMALL_STATE(10762)] = 68702,
  [SMALL_STATE(10763)] = 68753,
  [SMALL_STATE(10764)] = 68800,
  [SMALL_STATE(10765)] = 68847,
  [SMALL_STATE(10766)] = 68894,
  [SMALL_STATE(10767)] = 68941,
  [SMALL_STATE(10768)] = 68986,
  [SMALL_STATE(10769)] = 69033,
  [SMALL_STATE(10770)] = 69080,
  [SMALL_STATE(10771)] = 69131,
  [SMALL_STATE(10772)] = 69178,
  [SMALL_STATE(10773)] = 69225,
  [SMALL_STATE(10774)] = 69272,
  [SMALL_STATE(10775)] = 69319,
  [SMALL_STATE(10776)] = 69366,
  [SMALL_STATE(10777)] = 69413,
  [SMALL_STATE(10778)] = 69460,
  [SMALL_STATE(10779)] = 69507,
  [SMALL_STATE(10780)] = 69554,
  [SMALL_STATE(10781)] = 69601,
  [SMALL_STATE(10782)] = 69648,
  [SMALL_STATE(10783)] = 69695,
  [SMALL_STATE(10784)] = 69744,
  [SMALL_STATE(10785)] = 69795,
  [SMALL_STATE(10786)] = 69842,
  [SMALL_STATE(10787)] = 69893,
  [SMALL_STATE(10788)] = 69944,
  [SMALL_STATE(10789)] = 69995,
  [SMALL_STATE(10790)] = 70046,
  [SMALL_STATE(10791)] = 70093,
  [SMALL_STATE(10792)] = 70140,
  [SMALL_STATE(10793)] = 70191,
  [SMALL_STATE(10794)] = 70238,
  [SMALL_STATE(10795)] = 70285,
  [SMALL_STATE(10796)] = 70332,
  [SMALL_STATE(10797)] = 70379,
  [SMALL_STATE(10798)] = 70426,
  [SMALL_STATE(10799)] = 70473,
  [SMALL_STATE(10800)] = 70520,
  [SMALL_STATE(10801)] = 70573,
  [SMALL_STATE(10802)] = 70624,
  [SMALL_STATE(10803)] = 70671,
  [SMALL_STATE(10804)] = 70718,
  [SMALL_STATE(10805)] = 70765,
  [SMALL_STATE(10806)] = 70812,
  [SMALL_STATE(10807)] = 70859,
  [SMALL_STATE(10808)] = 70910,
  [SMALL_STATE(10809)] = 70957,
  [SMALL_STATE(10810)] = 71008,
  [SMALL_STATE(10811)] = 71055,
  [SMALL_STATE(10812)] = 71106,
  [SMALL_STATE(10813)] = 71157,
  [SMALL_STATE(10814)] = 71208,
  [SMALL_STATE(10815)] = 71253,
  [SMALL_STATE(10816)] = 71300,
  [SMALL_STATE(10817)] = 71347,
  [SMALL_STATE(10818)] = 71394,
  [SMALL_STATE(10819)] = 71445,
  [SMALL_STATE(10820)] = 71496,
  [SMALL_STATE(10821)] = 71543,
  [SMALL_STATE(10822)] = 71604,
  [SMALL_STATE(10823)] = 71655,
  [SMALL_STATE(10824)] = 71702,
  [SMALL_STATE(10825)] = 71753,
  [SMALL_STATE(10826)] = 71800,
  [SMALL_STATE(10827)] = 71847,
  [SMALL_STATE(10828)] = 71894,
  [SMALL_STATE(10829)] = 71945,
  [SMALL_STATE(10830)] = 71996,
  [SMALL_STATE(10831)] = 72047,
  [SMALL_STATE(10832)] = 72098,
  [SMALL_STATE(10833)] = 72145,
  [SMALL_STATE(10834)] = 72192,
  [SMALL_STATE(10835)] = 72243,
  [SMALL_STATE(10836)] = 72290,
  [SMALL_STATE(10837)] = 72341,
  [SMALL_STATE(10838)] = 72388,
  [SMALL_STATE(10839)] = 72439,
  [SMALL_STATE(10840)] = 72490,
  [SMALL_STATE(10841)] = 72541,
  [SMALL_STATE(10842)] = 72592,
  [SMALL_STATE(10843)] = 72639,
  [SMALL_STATE(10844)] = 72690,
  [SMALL_STATE(10845)] = 72737,
  [SMALL_STATE(10846)] = 72788,
  [SMALL_STATE(10847)] = 72839,
  [SMALL_STATE(10848)] = 72898,
  [SMALL_STATE(10849)] = 72945,
  [SMALL_STATE(10850)] = 72996,
  [SMALL_STATE(10851)] = 73047,
  [SMALL_STATE(10852)] = 73098,
  [SMALL_STATE(10853)] = 73145,
  [SMALL_STATE(10854)] = 73192,
  [SMALL_STATE(10855)] = 73237,
  [SMALL_STATE(10856)] = 73284,
  [SMALL_STATE(10857)] = 73331,
  [SMALL_STATE(10858)] = 73376,
  [SMALL_STATE(10859)] = 73427,
  [SMALL_STATE(10860)] = 73476,
  [SMALL_STATE(10861)] = 73523,
  [SMALL_STATE(10862)] = 73570,
  [SMALL_STATE(10863)] = 73615,
  [SMALL_STATE(10864)] = 73664,
  [SMALL_STATE(10865)] = 73711,
  [SMALL_STATE(10866)] = 73758,
  [SMALL_STATE(10867)] = 73805,
  [SMALL_STATE(10868)] = 73852,
  [SMALL_STATE(10869)] = 73899,
  [SMALL_STATE(10870)] = 73946,
  [SMALL_STATE(10871)] = 73997,
  [SMALL_STATE(10872)] = 74044,
  [SMALL_STATE(10873)] = 74091,
  [SMALL_STATE(10874)] = 74138,
  [SMALL_STATE(10875)] = 74199,
  [SMALL_STATE(10876)] = 74246,
  [SMALL_STATE(10877)] = 74293,
  [SMALL_STATE(10878)] = 74352,
  [SMALL_STATE(10879)] = 74399,
  [SMALL_STATE(10880)] = 74446,
  [SMALL_STATE(10881)] = 74497,
  [SMALL_STATE(10882)] = 74544,
  [SMALL_STATE(10883)] = 74591,
  [SMALL_STATE(10884)] = 74638,
  [SMALL_STATE(10885)] = 74689,
  [SMALL_STATE(10886)] = 74738,
  [SMALL_STATE(10887)] = 74785,
  [SMALL_STATE(10888)] = 74832,
  [SMALL_STATE(10889)] = 74881,
  [SMALL_STATE(10890)] = 74926,
  [SMALL_STATE(10891)] = 74971,
  [SMALL_STATE(10892)] = 75018,
  [SMALL_STATE(10893)] = 75065,
  [SMALL_STATE(10894)] = 75112,
  [SMALL_STATE(10895)] = 75159,
  [SMALL_STATE(10896)] = 75206,
  [SMALL_STATE(10897)] = 75253,
  [SMALL_STATE(10898)] = 75298,
  [SMALL_STATE(10899)] = 75345,
  [SMALL_STATE(10900)] = 75392,
  [SMALL_STATE(10901)] = 75439,
  [SMALL_STATE(10902)] = 75486,
  [SMALL_STATE(10903)] = 75537,
  [SMALL_STATE(10904)] = 75584,
  [SMALL_STATE(10905)] = 75631,
  [SMALL_STATE(10906)] = 75678,
  [SMALL_STATE(10907)] = 75729,
  [SMALL_STATE(10908)] = 75776,
  [SMALL_STATE(10909)] = 75823,
  [SMALL_STATE(10910)] = 75870,
  [SMALL_STATE(10911)] = 75917,
  [SMALL_STATE(10912)] = 75964,
  [SMALL_STATE(10913)] = 76009,
  [SMALL_STATE(10914)] = 76056,
  [SMALL_STATE(10915)] = 76101,
  [SMALL_STATE(10916)] = 76146,
  [SMALL_STATE(10917)] = 76205,
  [SMALL_STATE(10918)] = 76252,
  [SMALL_STATE(10919)] = 76299,
  [SMALL_STATE(10920)] = 76346,
  [SMALL_STATE(10921)] = 76393,
  [SMALL_STATE(10922)] = 76438,
  [SMALL_STATE(10923)] = 76489,
  [SMALL_STATE(10924)] = 76534,
  [SMALL_STATE(10925)] = 76581,
  [SMALL_STATE(10926)] = 76632,
  [SMALL_STATE(10927)] = 76683,
  [SMALL_STATE(10928)] = 76734,
  [SMALL_STATE(10929)] = 76781,
  [SMALL_STATE(10930)] = 76828,
  [SMALL_STATE(10931)] = 76879,
  [SMALL_STATE(10932)] = 76930,
  [SMALL_STATE(10933)] = 76981,
  [SMALL_STATE(10934)] = 77028,
  [SMALL_STATE(10935)] = 77074,
  [SMALL_STATE(10936)] = 77120,
  [SMALL_STATE(10937)] = 77166,
  [SMALL_STATE(10938)] = 77212,
  [SMALL_STATE(10939)] = 77258,
  [SMALL_STATE(10940)] = 77306,
  [SMALL_STATE(10941)] = 77354,
  [SMALL_STATE(10942)] = 77400,
  [SMALL_STATE(10943)] = 77450,
  [SMALL_STATE(10944)] = 77496,
  [SMALL_STATE(10945)] = 77546,
  [SMALL_STATE(10946)] = 77592,
  [SMALL_STATE(10947)] = 77642,
  [SMALL_STATE(10948)] = 77692,
  [SMALL_STATE(10949)] = 77738,
  [SMALL_STATE(10950)] = 77784,
  [SMALL_STATE(10951)] = 77830,
  [SMALL_STATE(10952)] = 77874,
  [SMALL_STATE(10953)] = 77920,
  [SMALL_STATE(10954)] = 77964,
  [SMALL_STATE(10955)] = 78014,
  [SMALL_STATE(10956)] = 78058,
  [SMALL_STATE(10957)] = 78104,
  [SMALL_STATE(10958)] = 78150,
  [SMALL_STATE(10959)] = 78194,
  [SMALL_STATE(10960)] = 78240,
  [SMALL_STATE(10961)] = 78286,
  [SMALL_STATE(10962)] = 78330,
  [SMALL_STATE(10963)] = 78374,
  [SMALL_STATE(10964)] = 78418,
  [SMALL_STATE(10965)] = 78464,
  [SMALL_STATE(10966)] = 78510,
  [SMALL_STATE(10967)] = 78554,
  [SMALL_STATE(10968)] = 78600,
  [SMALL_STATE(10969)] = 78646,
  [SMALL_STATE(10970)] = 78704,
  [SMALL_STATE(10971)] = 78750,
  [SMALL_STATE(10972)] = 78796,
  [SMALL_STATE(10973)] = 78842,
  [SMALL_STATE(10974)] = 78888,
  [SMALL_STATE(10975)] = 78934,
  [SMALL_STATE(10976)] = 78980,
  [SMALL_STATE(10977)] = 79030,
  [SMALL_STATE(10978)] = 79076,
  [SMALL_STATE(10979)] = 79122,
  [SMALL_STATE(10980)] = 79168,
  [SMALL_STATE(10981)] = 79214,
  [SMALL_STATE(10982)] = 79260,
  [SMALL_STATE(10983)] = 79306,
  [SMALL_STATE(10984)] = 79350,
  [SMALL_STATE(10985)] = 79400,
  [SMALL_STATE(10986)] = 79450,
  [SMALL_STATE(10987)] = 79496,
  [SMALL_STATE(10988)] = 79542,
  [SMALL_STATE(10989)] = 79588,
  [SMALL_STATE(10990)] = 79632,
  [SMALL_STATE(10991)] = 79678,
  [SMALL_STATE(10992)] = 79736,
  [SMALL_STATE(10993)] = 79786,
  [SMALL_STATE(10994)] = 79832,
  [SMALL_STATE(10995)] = 79876,
  [SMALL_STATE(10996)] = 79934,
  [SMALL_STATE(10997)] = 79980,
  [SMALL_STATE(10998)] = 80028,
  [SMALL_STATE(10999)] = 80076,
  [SMALL_STATE(11000)] = 80120,
  [SMALL_STATE(11001)] = 80166,
  [SMALL_STATE(11002)] = 80210,
  [SMALL_STATE(11003)] = 80256,
  [SMALL_STATE(11004)] = 80302,
  [SMALL_STATE(11005)] = 80346,
  [SMALL_STATE(11006)] = 80392,
  [SMALL_STATE(11007)] = 80450,
  [SMALL_STATE(11008)] = 80496,
  [SMALL_STATE(11009)] = 80546,
  [SMALL_STATE(11010)] = 80596,
  [SMALL_STATE(11011)] = 80642,
  [SMALL_STATE(11012)] = 80692,
  [SMALL_STATE(11013)] = 80742,
  [SMALL_STATE(11014)] = 80792,
  [SMALL_STATE(11015)] = 80852,
  [SMALL_STATE(11016)] = 80900,
  [SMALL_STATE(11017)] = 80948,
  [SMALL_STATE(11018)] = 80998,
  [SMALL_STATE(11019)] = 81048,
  [SMALL_STATE(11020)] = 81098,
  [SMALL_STATE(11021)] = 81144,
  [SMALL_STATE(11022)] = 81190,
  [SMALL_STATE(11023)] = 81244,
  [SMALL_STATE(11024)] = 81304,
  [SMALL_STATE(11025)] = 81354,
  [SMALL_STATE(11026)] = 81410,
  [SMALL_STATE(11027)] = 81460,
  [SMALL_STATE(11028)] = 81510,
  [SMALL_STATE(11029)] = 81560,
  [SMALL_STATE(11030)] = 81610,
  [SMALL_STATE(11031)] = 81656,
  [SMALL_STATE(11032)] = 81702,
  [SMALL_STATE(11033)] = 81752,
  [SMALL_STATE(11034)] = 81798,
  [SMALL_STATE(11035)] = 81846,
  [SMALL_STATE(11036)] = 81890,
  [SMALL_STATE(11037)] = 81938,
  [SMALL_STATE(11038)] = 81984,
  [SMALL_STATE(11039)] = 82030,
  [SMALL_STATE(11040)] = 82074,
  [SMALL_STATE(11041)] = 82118,
  [SMALL_STATE(11042)] = 82164,
  [SMALL_STATE(11043)] = 82208,
  [SMALL_STATE(11044)] = 82254,
  [SMALL_STATE(11045)] = 82298,
  [SMALL_STATE(11046)] = 82344,
  [SMALL_STATE(11047)] = 82390,
  [SMALL_STATE(11048)] = 82434,
  [SMALL_STATE(11049)] = 82480,
  [SMALL_STATE(11050)] = 82526,
  [SMALL_STATE(11051)] = 82572,
  [SMALL_STATE(11052)] = 82616,
  [SMALL_STATE(11053)] = 82666,
  [SMALL_STATE(11054)] = 82710,
  [SMALL_STATE(11055)] = 82770,
  [SMALL_STATE(11056)] = 82814,
  [SMALL_STATE(11057)] = 82858,
  [SMALL_STATE(11058)] = 82904,
  [SMALL_STATE(11059)] = 82948,
  [SMALL_STATE(11060)] = 82998,
  [SMALL_STATE(11061)] = 83044,
  [SMALL_STATE(11062)] = 83090,
  [SMALL_STATE(11063)] = 83134,
  [SMALL_STATE(11064)] = 83184,
  [SMALL_STATE(11065)] = 83230,
  [SMALL_STATE(11066)] = 83276,
  [SMALL_STATE(11067)] = 83324,
  [SMALL_STATE(11068)] = 83370,
  [SMALL_STATE(11069)] = 83420,
  [SMALL_STATE(11070)] = 83468,
  [SMALL_STATE(11071)] = 83518,
  [SMALL_STATE(11072)] = 83568,
  [SMALL_STATE(11073)] = 83612,
  [SMALL_STATE(11074)] = 83672,
  [SMALL_STATE(11075)] = 83718,
  [SMALL_STATE(11076)] = 83764,
  [SMALL_STATE(11077)] = 83810,
  [SMALL_STATE(11078)] = 83856,
  [SMALL_STATE(11079)] = 83900,
  [SMALL_STATE(11080)] = 83946,
  [SMALL_STATE(11081)] = 83992,
  [SMALL_STATE(11082)] = 84036,
  [SMALL_STATE(11083)] = 84082,
  [SMALL_STATE(11084)] = 84128,
  [SMALL_STATE(11085)] = 84174,
  [SMALL_STATE(11086)] = 84220,
  [SMALL_STATE(11087)] = 84266,
  [SMALL_STATE(11088)] = 84310,
  [SMALL_STATE(11089)] = 84360,
  [SMALL_STATE(11090)] = 84406,
  [SMALL_STATE(11091)] = 84452,
  [SMALL_STATE(11092)] = 84498,
  [SMALL_STATE(11093)] = 84544,
  [SMALL_STATE(11094)] = 84590,
  [SMALL_STATE(11095)] = 84636,
  [SMALL_STATE(11096)] = 84682,
  [SMALL_STATE(11097)] = 84728,
  [SMALL_STATE(11098)] = 84772,
  [SMALL_STATE(11099)] = 84818,
  [SMALL_STATE(11100)] = 84862,
  [SMALL_STATE(11101)] = 84908,
  [SMALL_STATE(11102)] = 84954,
  [SMALL_STATE(11103)] = 85000,
  [SMALL_STATE(11104)] = 85046,
  [SMALL_STATE(11105)] = 85092,
  [SMALL_STATE(11106)] = 85138,
  [SMALL_STATE(11107)] = 85184,
  [SMALL_STATE(11108)] = 85230,
  [SMALL_STATE(11109)] = 85276,
  [SMALL_STATE(11110)] = 85322,
  [SMALL_STATE(11111)] = 85368,
  [SMALL_STATE(11112)] = 85414,
  [SMALL_STATE(11113)] = 85458,
  [SMALL_STATE(11114)] = 85502,
  [SMALL_STATE(11115)] = 85548,
  [SMALL_STATE(11116)] = 85594,
  [SMALL_STATE(11117)] = 85640,
  [SMALL_STATE(11118)] = 85686,
  [SMALL_STATE(11119)] = 85732,
  [SMALL_STATE(11120)] = 85778,
  [SMALL_STATE(11121)] = 85824,
  [SMALL_STATE(11122)] = 85870,
  [SMALL_STATE(11123)] = 85916,
  [SMALL_STATE(11124)] = 85962,
  [SMALL_STATE(11125)] = 86006,
  [SMALL_STATE(11126)] = 86052,
  [SMALL_STATE(11127)] = 86098,
  [SMALL_STATE(11128)] = 86148,
  [SMALL_STATE(11129)] = 86198,
  [SMALL_STATE(11130)] = 86244,
  [SMALL_STATE(11131)] = 86288,
  [SMALL_STATE(11132)] = 86348,
  [SMALL_STATE(11133)] = 86392,
  [SMALL_STATE(11134)] = 86438,
  [SMALL_STATE(11135)] = 86488,
  [SMALL_STATE(11136)] = 86534,
  [SMALL_STATE(11137)] = 86580,
  [SMALL_STATE(11138)] = 86638,
  [SMALL_STATE(11139)] = 86682,
  [SMALL_STATE(11140)] = 86728,
  [SMALL_STATE(11141)] = 86774,
  [SMALL_STATE(11142)] = 86820,
  [SMALL_STATE(11143)] = 86866,
  [SMALL_STATE(11144)] = 86916,
  [SMALL_STATE(11145)] = 86974,
  [SMALL_STATE(11146)] = 87020,
  [SMALL_STATE(11147)] = 87078,
  [SMALL_STATE(11148)] = 87124,
  [SMALL_STATE(11149)] = 87182,
  [SMALL_STATE(11150)] = 87226,
  [SMALL_STATE(11151)] = 87272,
  [SMALL_STATE(11152)] = 87316,
  [SMALL_STATE(11153)] = 87366,
  [SMALL_STATE(11154)] = 87412,
  [SMALL_STATE(11155)] = 87470,
  [SMALL_STATE(11156)] = 87514,
  [SMALL_STATE(11157)] = 87558,
  [SMALL_STATE(11158)] = 87618,
  [SMALL_STATE(11159)] = 87668,
  [SMALL_STATE(11160)] = 87714,
  [SMALL_STATE(11161)] = 87758,
  [SMALL_STATE(11162)] = 87802,
  [SMALL_STATE(11163)] = 87852,
  [SMALL_STATE(11164)] = 87908,
  [SMALL_STATE(11165)] = 87952,
  [SMALL_STATE(11166)] = 87996,
  [SMALL_STATE(11167)] = 88042,
  [SMALL_STATE(11168)] = 88094,
  [SMALL_STATE(11169)] = 88140,
  [SMALL_STATE(11170)] = 88190,
  [SMALL_STATE(11171)] = 88240,
  [SMALL_STATE(11172)] = 88284,
  [SMALL_STATE(11173)] = 88334,
  [SMALL_STATE(11174)] = 88392,
  [SMALL_STATE(11175)] = 88438,
  [SMALL_STATE(11176)] = 88482,
  [SMALL_STATE(11177)] = 88528,
  [SMALL_STATE(11178)] = 88574,
  [SMALL_STATE(11179)] = 88620,
  [SMALL_STATE(11180)] = 88664,
  [SMALL_STATE(11181)] = 88708,
  [SMALL_STATE(11182)] = 88754,
  [SMALL_STATE(11183)] = 88800,
  [SMALL_STATE(11184)] = 88846,
  [SMALL_STATE(11185)] = 88890,
  [SMALL_STATE(11186)] = 88934,
  [SMALL_STATE(11187)] = 88984,
  [SMALL_STATE(11188)] = 89040,
  [SMALL_STATE(11189)] = 89090,
  [SMALL_STATE(11190)] = 89136,
  [SMALL_STATE(11191)] = 89192,
  [SMALL_STATE(11192)] = 89238,
  [SMALL_STATE(11193)] = 89282,
  [SMALL_STATE(11194)] = 89338,
  [SMALL_STATE(11195)] = 89382,
  [SMALL_STATE(11196)] = 89427,
  [SMALL_STATE(11197)] = 89476,
  [SMALL_STATE(11198)] = 89525,
  [SMALL_STATE(11199)] = 89582,
  [SMALL_STATE(11200)] = 89641,
  [SMALL_STATE(11201)] = 89700,
  [SMALL_STATE(11202)] = 89749,
  [SMALL_STATE(11203)] = 89806,
  [SMALL_STATE(11204)] = 89863,
  [SMALL_STATE(11205)] = 89910,
  [SMALL_STATE(11206)] = 89959,
  [SMALL_STATE(11207)] = 90008,
  [SMALL_STATE(11208)] = 90065,
  [SMALL_STATE(11209)] = 90122,
  [SMALL_STATE(11210)] = 90175,
  [SMALL_STATE(11211)] = 90220,
  [SMALL_STATE(11212)] = 90265,
  [SMALL_STATE(11213)] = 90310,
  [SMALL_STATE(11214)] = 90369,
  [SMALL_STATE(11215)] = 90418,
  [SMALL_STATE(11216)] = 90463,
  [SMALL_STATE(11217)] = 90512,
  [SMALL_STATE(11218)] = 90557,
  [SMALL_STATE(11219)] = 90602,
  [SMALL_STATE(11220)] = 90647,
  [SMALL_STATE(11221)] = 90706,
  [SMALL_STATE(11222)] = 90759,
  [SMALL_STATE(11223)] = 90804,
  [SMALL_STATE(11224)] = 90859,
  [SMALL_STATE(11225)] = 90908,
  [SMALL_STATE(11226)] = 90967,
  [SMALL_STATE(11227)] = 91016,
  [SMALL_STATE(11228)] = 91063,
  [SMALL_STATE(11229)] = 91122,
  [SMALL_STATE(11230)] = 91171,
  [SMALL_STATE(11231)] = 91214,
  [SMALL_STATE(11232)] = 91273,
  [SMALL_STATE(11233)] = 91328,
  [SMALL_STATE(11234)] = 91373,
  [SMALL_STATE(11235)] = 91418,
  [SMALL_STATE(11236)] = 91463,
  [SMALL_STATE(11237)] = 91510,
  [SMALL_STATE(11238)] = 91553,
  [SMALL_STATE(11239)] = 91598,
  [SMALL_STATE(11240)] = 91655,
  [SMALL_STATE(11241)] = 91710,
  [SMALL_STATE(11242)] = 91759,
  [SMALL_STATE(11243)] = 91816,
  [SMALL_STATE(11244)] = 91863,
  [SMALL_STATE(11245)] = 91908,
  [SMALL_STATE(11246)] = 91953,
  [SMALL_STATE(11247)] = 91998,
  [SMALL_STATE(11248)] = 92055,
  [SMALL_STATE(11249)] = 92100,
  [SMALL_STATE(11250)] = 92145,
  [SMALL_STATE(11251)] = 92190,
  [SMALL_STATE(11252)] = 92235,
  [SMALL_STATE(11253)] = 92294,
  [SMALL_STATE(11254)] = 92339,
  [SMALL_STATE(11255)] = 92384,
  [SMALL_STATE(11256)] = 92429,
  [SMALL_STATE(11257)] = 92474,
  [SMALL_STATE(11258)] = 92527,
  [SMALL_STATE(11259)] = 92572,
  [SMALL_STATE(11260)] = 92617,
  [SMALL_STATE(11261)] = 92662,
  [SMALL_STATE(11262)] = 92707,
  [SMALL_STATE(11263)] = 92752,
  [SMALL_STATE(11264)] = 92797,
  [SMALL_STATE(11265)] = 92842,
  [SMALL_STATE(11266)] = 92887,
  [SMALL_STATE(11267)] = 92932,
  [SMALL_STATE(11268)] = 92977,
  [SMALL_STATE(11269)] = 93022,
  [SMALL_STATE(11270)] = 93067,
  [SMALL_STATE(11271)] = 93122,
  [SMALL_STATE(11272)] = 93167,
  [SMALL_STATE(11273)] = 93212,
  [SMALL_STATE(11274)] = 93257,
  [SMALL_STATE(11275)] = 93302,
  [SMALL_STATE(11276)] = 93347,
  [SMALL_STATE(11277)] = 93392,
  [SMALL_STATE(11278)] = 93437,
  [SMALL_STATE(11279)] = 93482,
  [SMALL_STATE(11280)] = 93527,
  [SMALL_STATE(11281)] = 93572,
  [SMALL_STATE(11282)] = 93617,
  [SMALL_STATE(11283)] = 93662,
  [SMALL_STATE(11284)] = 93707,
  [SMALL_STATE(11285)] = 93752,
  [SMALL_STATE(11286)] = 93797,
  [SMALL_STATE(11287)] = 93854,
  [SMALL_STATE(11288)] = 93909,
  [SMALL_STATE(11289)] = 93966,
  [SMALL_STATE(11290)] = 94019,
  [SMALL_STATE(11291)] = 94064,
  [SMALL_STATE(11292)] = 94109,
  [SMALL_STATE(11293)] = 94154,
  [SMALL_STATE(11294)] = 94199,
  [SMALL_STATE(11295)] = 94244,
  [SMALL_STATE(11296)] = 94289,
  [SMALL_STATE(11297)] = 94334,
  [SMALL_STATE(11298)] = 94379,
  [SMALL_STATE(11299)] = 94424,
  [SMALL_STATE(11300)] = 94469,
  [SMALL_STATE(11301)] = 94514,
  [SMALL_STATE(11302)] = 94559,
  [SMALL_STATE(11303)] = 94604,
  [SMALL_STATE(11304)] = 94649,
  [SMALL_STATE(11305)] = 94694,
  [SMALL_STATE(11306)] = 94739,
  [SMALL_STATE(11307)] = 94784,
  [SMALL_STATE(11308)] = 94829,
  [SMALL_STATE(11309)] = 94874,
  [SMALL_STATE(11310)] = 94919,
  [SMALL_STATE(11311)] = 94964,
  [SMALL_STATE(11312)] = 95009,
  [SMALL_STATE(11313)] = 95054,
  [SMALL_STATE(11314)] = 95099,
  [SMALL_STATE(11315)] = 95144,
  [SMALL_STATE(11316)] = 95189,
  [SMALL_STATE(11317)] = 95234,
  [SMALL_STATE(11318)] = 95291,
  [SMALL_STATE(11319)] = 95336,
  [SMALL_STATE(11320)] = 95385,
  [SMALL_STATE(11321)] = 95430,
  [SMALL_STATE(11322)] = 95475,
  [SMALL_STATE(11323)] = 95520,
  [SMALL_STATE(11324)] = 95565,
  [SMALL_STATE(11325)] = 95618,
  [SMALL_STATE(11326)] = 95663,
  [SMALL_STATE(11327)] = 95712,
  [SMALL_STATE(11328)] = 95757,
  [SMALL_STATE(11329)] = 95802,
  [SMALL_STATE(11330)] = 95847,
  [SMALL_STATE(11331)] = 95898,
  [SMALL_STATE(11332)] = 95943,
  [SMALL_STATE(11333)] = 95988,
  [SMALL_STATE(11334)] = 96033,
  [SMALL_STATE(11335)] = 96078,
  [SMALL_STATE(11336)] = 96123,
  [SMALL_STATE(11337)] = 96168,
  [SMALL_STATE(11338)] = 96213,
  [SMALL_STATE(11339)] = 96258,
  [SMALL_STATE(11340)] = 96303,
  [SMALL_STATE(11341)] = 96362,
  [SMALL_STATE(11342)] = 96407,
  [SMALL_STATE(11343)] = 96452,
  [SMALL_STATE(11344)] = 96509,
  [SMALL_STATE(11345)] = 96564,
  [SMALL_STATE(11346)] = 96617,
  [SMALL_STATE(11347)] = 96662,
  [SMALL_STATE(11348)] = 96709,
  [SMALL_STATE(11349)] = 96756,
  [SMALL_STATE(11350)] = 96801,
  [SMALL_STATE(11351)] = 96846,
  [SMALL_STATE(11352)] = 96895,
  [SMALL_STATE(11353)] = 96942,
  [SMALL_STATE(11354)] = 96989,
  [SMALL_STATE(11355)] = 97034,
  [SMALL_STATE(11356)] = 97087,
  [SMALL_STATE(11357)] = 97136,
  [SMALL_STATE(11358)] = 97185,
  [SMALL_STATE(11359)] = 97230,
  [SMALL_STATE(11360)] = 97283,
  [SMALL_STATE(11361)] = 97340,
  [SMALL_STATE(11362)] = 97395,
  [SMALL_STATE(11363)] = 97440,
  [SMALL_STATE(11364)] = 97495,
  [SMALL_STATE(11365)] = 97540,
  [SMALL_STATE(11366)] = 97585,
  [SMALL_STATE(11367)] = 97640,
  [SMALL_STATE(11368)] = 97695,
  [SMALL_STATE(11369)] = 97750,
  [SMALL_STATE(11370)] = 97795,
  [SMALL_STATE(11371)] = 97840,
  [SMALL_STATE(11372)] = 97886,
  [SMALL_STATE(11373)] = 97934,
  [SMALL_STATE(11374)] = 97992,
  [SMALL_STATE(11375)] = 98038,
  [SMALL_STATE(11376)] = 98096,
  [SMALL_STATE(11377)] = 98144,
  [SMALL_STATE(11378)] = 98192,
  [SMALL_STATE(11379)] = 98240,
  [SMALL_STATE(11380)] = 98286,
  [SMALL_STATE(11381)] = 98330,
  [SMALL_STATE(11382)] = 98378,
  [SMALL_STATE(11383)] = 98434,
  [SMALL_STATE(11384)] = 98480,
  [SMALL_STATE(11385)] = 98522,
  [SMALL_STATE(11386)] = 98570,
  [SMALL_STATE(11387)] = 98616,
  [SMALL_STATE(11388)] = 98672,
  [SMALL_STATE(11389)] = 98720,
  [SMALL_STATE(11390)] = 98766,
  [SMALL_STATE(11391)] = 98814,
  [SMALL_STATE(11392)] = 98870,
  [SMALL_STATE(11393)] = 98918,
  [SMALL_STATE(11394)] = 98966,
  [SMALL_STATE(11395)] = 99014,
  [SMALL_STATE(11396)] = 99072,
  [SMALL_STATE(11397)] = 99128,
  [SMALL_STATE(11398)] = 99184,
  [SMALL_STATE(11399)] = 99228,
  [SMALL_STATE(11400)] = 99270,
  [SMALL_STATE(11401)] = 99318,
  [SMALL_STATE(11402)] = 99366,
  [SMALL_STATE(11403)] = 99414,
  [SMALL_STATE(11404)] = 99462,
  [SMALL_STATE(11405)] = 99510,
  [SMALL_STATE(11406)] = 99558,
  [SMALL_STATE(11407)] = 99606,
  [SMALL_STATE(11408)] = 99650,
  [SMALL_STATE(11409)] = 99708,
  [SMALL_STATE(11410)] = 99756,
  [SMALL_STATE(11411)] = 99802,
  [SMALL_STATE(11412)] = 99850,
  [SMALL_STATE(11413)] = 99896,
  [SMALL_STATE(11414)] = 99944,
  [SMALL_STATE(11415)] = 99992,
  [SMALL_STATE(11416)] = 100040,
  [SMALL_STATE(11417)] = 100088,
  [SMALL_STATE(11418)] = 100134,
  [SMALL_STATE(11419)] = 100180,
  [SMALL_STATE(11420)] = 100234,
  [SMALL_STATE(11421)] = 100290,
  [SMALL_STATE(11422)] = 100346,
  [SMALL_STATE(11423)] = 100398,
  [SMALL_STATE(11424)] = 100456,
  [SMALL_STATE(11425)] = 100504,
  [SMALL_STATE(11426)] = 100558,
  [SMALL_STATE(11427)] = 100614,
  [SMALL_STATE(11428)] = 100670,
  [SMALL_STATE(11429)] = 100728,
  [SMALL_STATE(11430)] = 100782,
  [SMALL_STATE(11431)] = 100836,
  [SMALL_STATE(11432)] = 100882,
  [SMALL_STATE(11433)] = 100934,
  [SMALL_STATE(11434)] = 100988,
  [SMALL_STATE(11435)] = 101042,
  [SMALL_STATE(11436)] = 101096,
  [SMALL_STATE(11437)] = 101150,
  [SMALL_STATE(11438)] = 101198,
  [SMALL_STATE(11439)] = 101245,
  [SMALL_STATE(11440)] = 101292,
  [SMALL_STATE(11441)] = 101339,
  [SMALL_STATE(11442)] = 101380,
  [SMALL_STATE(11443)] = 101421,
  [SMALL_STATE(11444)] = 101466,
  [SMALL_STATE(11445)] = 101511,
  [SMALL_STATE(11446)] = 101554,
  [SMALL_STATE(11447)] = 101595,
  [SMALL_STATE(11448)] = 101642,
  [SMALL_STATE(11449)] = 101687,
  [SMALL_STATE(11450)] = 101734,
  [SMALL_STATE(11451)] = 101775,
  [SMALL_STATE(11452)] = 101822,
  [SMALL_STATE(11453)] = 101869,
  [SMALL_STATE(11454)] = 101916,
  [SMALL_STATE(11455)] = 101957,
  [SMALL_STATE(11456)] = 101998,
  [SMALL_STATE(11457)] = 102039,
  [SMALL_STATE(11458)] = 102080,
  [SMALL_STATE(11459)] = 102127,
  [SMALL_STATE(11460)] = 102170,
  [SMALL_STATE(11461)] = 102215,
  [SMALL_STATE(11462)] = 102262,
  [SMALL_STATE(11463)] = 102309,
  [SMALL_STATE(11464)] = 102356,
  [SMALL_STATE(11465)] = 102403,
  [SMALL_STATE(11466)] = 102444,
  [SMALL_STATE(11467)] = 102499,
  [SMALL_STATE(11468)] = 102540,
  [SMALL_STATE(11469)] = 102587,
  [SMALL_STATE(11470)] = 102634,
  [SMALL_STATE(11471)] = 102679,
  [SMALL_STATE(11472)] = 102726,
  [SMALL_STATE(11473)] = 102773,
  [SMALL_STATE(11474)] = 102820,
  [SMALL_STATE(11475)] = 102865,
  [SMALL_STATE(11476)] = 102910,
  [SMALL_STATE(11477)] = 102957,
  [SMALL_STATE(11478)] = 102998,
  [SMALL_STATE(11479)] = 103045,
  [SMALL_STATE(11480)] = 103092,
  [SMALL_STATE(11481)] = 103135,
  [SMALL_STATE(11482)] = 103180,
  [SMALL_STATE(11483)] = 103227,
  [SMALL_STATE(11484)] = 103274,
  [SMALL_STATE(11485)] = 103331,
  [SMALL_STATE(11486)] = 103374,
  [SMALL_STATE(11487)] = 103421,
  [SMALL_STATE(11488)] = 103476,
  [SMALL_STATE(11489)] = 103521,
  [SMALL_STATE(11490)] = 103562,
  [SMALL_STATE(11491)] = 103615,
  [SMALL_STATE(11492)] = 103668,
  [SMALL_STATE(11493)] = 103709,
  [SMALL_STATE(11494)] = 103764,
  [SMALL_STATE(11495)] = 103811,
  [SMALL_STATE(11496)] = 103858,
  [SMALL_STATE(11497)] = 103913,
  [SMALL_STATE(11498)] = 103968,
  [SMALL_STATE(11499)] = 104015,
  [SMALL_STATE(11500)] = 104062,
  [SMALL_STATE(11501)] = 104109,
  [SMALL_STATE(11502)] = 104156,
  [SMALL_STATE(11503)] = 104197,
  [SMALL_STATE(11504)] = 104238,
  [SMALL_STATE(11505)] = 104279,
  [SMALL_STATE(11506)] = 104320,
  [SMALL_STATE(11507)] = 104367,
  [SMALL_STATE(11508)] = 104408,
  [SMALL_STATE(11509)] = 104453,
  [SMALL_STATE(11510)] = 104500,
  [SMALL_STATE(11511)] = 104547,
  [SMALL_STATE(11512)] = 104600,
  [SMALL_STATE(11513)] = 104641,
  [SMALL_STATE(11514)] = 104694,
  [SMALL_STATE(11515)] = 104735,
  [SMALL_STATE(11516)] = 104776,
  [SMALL_STATE(11517)] = 104821,
  [SMALL_STATE(11518)] = 104866,
  [SMALL_STATE(11519)] = 104917,
  [SMALL_STATE(11520)] = 104968,
  [SMALL_STATE(11521)] = 105009,
  [SMALL_STATE(11522)] = 105054,
  [SMALL_STATE(11523)] = 105099,
  [SMALL_STATE(11524)] = 105140,
  [SMALL_STATE(11525)] = 105181,
  [SMALL_STATE(11526)] = 105222,
  [SMALL_STATE(11527)] = 105263,
  [SMALL_STATE(11528)] = 105310,
  [SMALL_STATE(11529)] = 105353,
  [SMALL_STATE(11530)] = 105394,
  [SMALL_STATE(11531)] = 105437,
  [SMALL_STATE(11532)] = 105484,
  [SMALL_STATE(11533)] = 105525,
  [SMALL_STATE(11534)] = 105572,
  [SMALL_STATE(11535)] = 105613,
  [SMALL_STATE(11536)] = 105660,
  [SMALL_STATE(11537)] = 105701,
  [SMALL_STATE(11538)] = 105748,
  [SMALL_STATE(11539)] = 105795,
  [SMALL_STATE(11540)] = 105842,
  [SMALL_STATE(11541)] = 105883,
  [SMALL_STATE(11542)] = 105924,
  [SMALL_STATE(11543)] = 105971,
  [SMALL_STATE(11544)] = 106016,
  [SMALL_STATE(11545)] = 106073,
  [SMALL_STATE(11546)] = 106118,
  [SMALL_STATE(11547)] = 106159,
  [SMALL_STATE(11548)] = 106204,
  [SMALL_STATE(11549)] = 106251,
  [SMALL_STATE(11550)] = 106292,
  [SMALL_STATE(11551)] = 106333,
  [SMALL_STATE(11552)] = 106374,
  [SMALL_STATE(11553)] = 106415,
  [SMALL_STATE(11554)] = 106456,
  [SMALL_STATE(11555)] = 106501,
  [SMALL_STATE(11556)] = 106542,
  [SMALL_STATE(11557)] = 106587,
  [SMALL_STATE(11558)] = 106628,
  [SMALL_STATE(11559)] = 106669,
  [SMALL_STATE(11560)] = 106710,
  [SMALL_STATE(11561)] = 106757,
  [SMALL_STATE(11562)] = 106802,
  [SMALL_STATE(11563)] = 106850,
  [SMALL_STATE(11564)] = 106892,
  [SMALL_STATE(11565)] = 106934,
  [SMALL_STATE(11566)] = 106974,
  [SMALL_STATE(11567)] = 107014,
  [SMALL_STATE(11568)] = 107060,
  [SMALL_STATE(11569)] = 107106,
  [SMALL_STATE(11570)] = 107146,
  [SMALL_STATE(11571)] = 107190,
  [SMALL_STATE(11572)] = 107246,
  [SMALL_STATE(11573)] = 107290,
  [SMALL_STATE(11574)] = 107346,
  [SMALL_STATE(11575)] = 107402,
  [SMALL_STATE(11576)] = 107444,
  [SMALL_STATE(11577)] = 107504,
  [SMALL_STATE(11578)] = 107544,
  [SMALL_STATE(11579)] = 107600,
  [SMALL_STATE(11580)] = 107646,
  [SMALL_STATE(11581)] = 107688,
  [SMALL_STATE(11582)] = 107732,
  [SMALL_STATE(11583)] = 107772,
  [SMALL_STATE(11584)] = 107814,
  [SMALL_STATE(11585)] = 107856,
  [SMALL_STATE(11586)] = 107912,
  [SMALL_STATE(11587)] = 107954,
  [SMALL_STATE(11588)] = 107994,
  [SMALL_STATE(11589)] = 108086,
  [SMALL_STATE(11590)] = 108126,
  [SMALL_STATE(11591)] = 108172,
  [SMALL_STATE(11592)] = 108218,
  [SMALL_STATE(11593)] = 108264,
  [SMALL_STATE(11594)] = 108306,
  [SMALL_STATE(11595)] = 108348,
  [SMALL_STATE(11596)] = 108404,
  [SMALL_STATE(11597)] = 108460,
  [SMALL_STATE(11598)] = 108516,
  [SMALL_STATE(11599)] = 108608,
  [SMALL_STATE(11600)] = 108668,
  [SMALL_STATE(11601)] = 108714,
  [SMALL_STATE(11602)] = 108756,
  [SMALL_STATE(11603)] = 108806,
  [SMALL_STATE(11604)] = 108862,
  [SMALL_STATE(11605)] = 108902,
  [SMALL_STATE(11606)] = 108958,
  [SMALL_STATE(11607)] = 108998,
  [SMALL_STATE(11608)] = 109038,
  [SMALL_STATE(11609)] = 109084,
  [SMALL_STATE(11610)] = 109126,
  [SMALL_STATE(11611)] = 109166,
  [SMALL_STATE(11612)] = 109222,
  [SMALL_STATE(11613)] = 109266,
  [SMALL_STATE(11614)] = 109326,
  [SMALL_STATE(11615)] = 109418,
  [SMALL_STATE(11616)] = 109478,
  [SMALL_STATE(11617)] = 109570,
  [SMALL_STATE(11618)] = 109626,
  [SMALL_STATE(11619)] = 109666,
  [SMALL_STATE(11620)] = 109710,
  [SMALL_STATE(11621)] = 109752,
  [SMALL_STATE(11622)] = 109794,
  [SMALL_STATE(11623)] = 109836,
  [SMALL_STATE(11624)] = 109892,
  [SMALL_STATE(11625)] = 109948,
  [SMALL_STATE(11626)] = 109990,
  [SMALL_STATE(11627)] = 110046,
  [SMALL_STATE(11628)] = 110088,
  [SMALL_STATE(11629)] = 110128,
  [SMALL_STATE(11630)] = 110170,
  [SMALL_STATE(11631)] = 110262,
  [SMALL_STATE(11632)] = 110302,
  [SMALL_STATE(11633)] = 110348,
  [SMALL_STATE(11634)] = 110404,
  [SMALL_STATE(11635)] = 110450,
  [SMALL_STATE(11636)] = 110490,
  [SMALL_STATE(11637)] = 110538,
  [SMALL_STATE(11638)] = 110580,
  [SMALL_STATE(11639)] = 110626,
  [SMALL_STATE(11640)] = 110672,
  [SMALL_STATE(11641)] = 110716,
  [SMALL_STATE(11642)] = 110772,
  [SMALL_STATE(11643)] = 110814,
  [SMALL_STATE(11644)] = 110858,
  [SMALL_STATE(11645)] = 110902,
  [SMALL_STATE(11646)] = 110942,
  [SMALL_STATE(11647)] = 110984,
  [SMALL_STATE(11648)] = 111076,
  [SMALL_STATE(11649)] = 111116,
  [SMALL_STATE(11650)] = 111158,
  [SMALL_STATE(11651)] = 111212,
  [SMALL_STATE(11652)] = 111254,
  [SMALL_STATE(11653)] = 111300,
  [SMALL_STATE(11654)] = 111340,
  [SMALL_STATE(11655)] = 111382,
  [SMALL_STATE(11656)] = 111438,
  [SMALL_STATE(11657)] = 111478,
  [SMALL_STATE(11658)] = 111528,
  [SMALL_STATE(11659)] = 111570,
  [SMALL_STATE(11660)] = 111614,
  [SMALL_STATE(11661)] = 111658,
  [SMALL_STATE(11662)] = 111702,
  [SMALL_STATE(11663)] = 111758,
  [SMALL_STATE(11664)] = 111802,
  [SMALL_STATE(11665)] = 111842,
  [SMALL_STATE(11666)] = 111898,
  [SMALL_STATE(11667)] = 111938,
  [SMALL_STATE(11668)] = 111980,
  [SMALL_STATE(11669)] = 112022,
  [SMALL_STATE(11670)] = 112078,
  [SMALL_STATE(11671)] = 112118,
  [SMALL_STATE(11672)] = 112160,
  [SMALL_STATE(11673)] = 112202,
  [SMALL_STATE(11674)] = 112258,
  [SMALL_STATE(11675)] = 112300,
  [SMALL_STATE(11676)] = 112342,
  [SMALL_STATE(11677)] = 112382,
  [SMALL_STATE(11678)] = 112422,
  [SMALL_STATE(11679)] = 112514,
  [SMALL_STATE(11680)] = 112554,
  [SMALL_STATE(11681)] = 112610,
  [SMALL_STATE(11682)] = 112652,
  [SMALL_STATE(11683)] = 112708,
  [SMALL_STATE(11684)] = 112768,
  [SMALL_STATE(11685)] = 112810,
  [SMALL_STATE(11686)] = 112852,
  [SMALL_STATE(11687)] = 112894,
  [SMALL_STATE(11688)] = 112936,
  [SMALL_STATE(11689)] = 112982,
  [SMALL_STATE(11690)] = 113024,
  [SMALL_STATE(11691)] = 113116,
  [SMALL_STATE(11692)] = 113158,
  [SMALL_STATE(11693)] = 113250,
  [SMALL_STATE(11694)] = 113292,
  [SMALL_STATE(11695)] = 113334,
  [SMALL_STATE(11696)] = 113376,
  [SMALL_STATE(11697)] = 113418,
  [SMALL_STATE(11698)] = 113464,
  [SMALL_STATE(11699)] = 113520,
  [SMALL_STATE(11700)] = 113562,
  [SMALL_STATE(11701)] = 113602,
  [SMALL_STATE(11702)] = 113644,
  [SMALL_STATE(11703)] = 113704,
  [SMALL_STATE(11704)] = 113746,
  [SMALL_STATE(11705)] = 113788,
  [SMALL_STATE(11706)] = 113830,
  [SMALL_STATE(11707)] = 113876,
  [SMALL_STATE(11708)] = 113918,
  [SMALL_STATE(11709)] = 113958,
  [SMALL_STATE(11710)] = 114000,
  [SMALL_STATE(11711)] = 114042,
  [SMALL_STATE(11712)] = 114084,
  [SMALL_STATE(11713)] = 114126,
  [SMALL_STATE(11714)] = 114172,
  [SMALL_STATE(11715)] = 114228,
  [SMALL_STATE(11716)] = 114270,
  [SMALL_STATE(11717)] = 114312,
  [SMALL_STATE(11718)] = 114354,
  [SMALL_STATE(11719)] = 114396,
  [SMALL_STATE(11720)] = 114438,
  [SMALL_STATE(11721)] = 114480,
  [SMALL_STATE(11722)] = 114520,
  [SMALL_STATE(11723)] = 114564,
  [SMALL_STATE(11724)] = 114606,
  [SMALL_STATE(11725)] = 114652,
  [SMALL_STATE(11726)] = 114696,
  [SMALL_STATE(11727)] = 114740,
  [SMALL_STATE(11728)] = 114782,
  [SMALL_STATE(11729)] = 114824,
  [SMALL_STATE(11730)] = 114866,
  [SMALL_STATE(11731)] = 114908,
  [SMALL_STATE(11732)] = 114948,
  [SMALL_STATE(11733)] = 115004,
  [SMALL_STATE(11734)] = 115044,
  [SMALL_STATE(11735)] = 115086,
  [SMALL_STATE(11736)] = 115130,
  [SMALL_STATE(11737)] = 115172,
  [SMALL_STATE(11738)] = 115228,
  [SMALL_STATE(11739)] = 115270,
  [SMALL_STATE(11740)] = 115314,
  [SMALL_STATE(11741)] = 115356,
  [SMALL_STATE(11742)] = 115412,
  [SMALL_STATE(11743)] = 115454,
  [SMALL_STATE(11744)] = 115496,
  [SMALL_STATE(11745)] = 115552,
  [SMALL_STATE(11746)] = 115598,
  [SMALL_STATE(11747)] = 115640,
  [SMALL_STATE(11748)] = 115696,
  [SMALL_STATE(11749)] = 115738,
  [SMALL_STATE(11750)] = 115778,
  [SMALL_STATE(11751)] = 115834,
  [SMALL_STATE(11752)] = 115882,
  [SMALL_STATE(11753)] = 115926,
  [SMALL_STATE(11754)] = 115966,
  [SMALL_STATE(11755)] = 116006,
  [SMALL_STATE(11756)] = 116052,
  [SMALL_STATE(11757)] = 116108,
  [SMALL_STATE(11758)] = 116148,
  [SMALL_STATE(11759)] = 116188,
  [SMALL_STATE(11760)] = 116244,
  [SMALL_STATE(11761)] = 116284,
  [SMALL_STATE(11762)] = 116330,
  [SMALL_STATE(11763)] = 116422,
  [SMALL_STATE(11764)] = 116482,
  [SMALL_STATE(11765)] = 116538,
  [SMALL_STATE(11766)] = 116594,
  [SMALL_STATE(11767)] = 116636,
  [SMALL_STATE(11768)] = 116696,
  [SMALL_STATE(11769)] = 116756,
  [SMALL_STATE(11770)] = 116796,
  [SMALL_STATE(11771)] = 116856,
  [SMALL_STATE(11772)] = 116896,
  [SMALL_STATE(11773)] = 116988,
  [SMALL_STATE(11774)] = 117044,
  [SMALL_STATE(11775)] = 117088,
  [SMALL_STATE(11776)] = 117144,
  [SMALL_STATE(11777)] = 117184,
  [SMALL_STATE(11778)] = 117226,
  [SMALL_STATE(11779)] = 117268,
  [SMALL_STATE(11780)] = 117308,
  [SMALL_STATE(11781)] = 117400,
  [SMALL_STATE(11782)] = 117460,
  [SMALL_STATE(11783)] = 117500,
  [SMALL_STATE(11784)] = 117556,
  [SMALL_STATE(11785)] = 117602,
  [SMALL_STATE(11786)] = 117648,
  [SMALL_STATE(11787)] = 117694,
  [SMALL_STATE(11788)] = 117754,
  [SMALL_STATE(11789)] = 117810,
  [SMALL_STATE(11790)] = 117856,
  [SMALL_STATE(11791)] = 117900,
  [SMALL_STATE(11792)] = 117946,
  [SMALL_STATE(11793)] = 117986,
  [SMALL_STATE(11794)] = 118026,
  [SMALL_STATE(11795)] = 118072,
  [SMALL_STATE(11796)] = 118114,
  [SMALL_STATE(11797)] = 118170,
  [SMALL_STATE(11798)] = 118230,
  [SMALL_STATE(11799)] = 118286,
  [SMALL_STATE(11800)] = 118326,
  [SMALL_STATE(11801)] = 118366,
  [SMALL_STATE(11802)] = 118406,
  [SMALL_STATE(11803)] = 118448,
  [SMALL_STATE(11804)] = 118488,
  [SMALL_STATE(11805)] = 118530,
  [SMALL_STATE(11806)] = 118586,
  [SMALL_STATE(11807)] = 118678,
  [SMALL_STATE(11808)] = 118720,
  [SMALL_STATE(11809)] = 118762,
  [SMALL_STATE(11810)] = 118804,
  [SMALL_STATE(11811)] = 118846,
  [SMALL_STATE(11812)] = 118888,
  [SMALL_STATE(11813)] = 118948,
  [SMALL_STATE(11814)] = 118994,
  [SMALL_STATE(11815)] = 119050,
  [SMALL_STATE(11816)] = 119092,
  [SMALL_STATE(11817)] = 119134,
  [SMALL_STATE(11818)] = 119176,
  [SMALL_STATE(11819)] = 119218,
  [SMALL_STATE(11820)] = 119278,
  [SMALL_STATE(11821)] = 119324,
  [SMALL_STATE(11822)] = 119366,
  [SMALL_STATE(11823)] = 119408,
  [SMALL_STATE(11824)] = 119464,
  [SMALL_STATE(11825)] = 119524,
  [SMALL_STATE(11826)] = 119570,
  [SMALL_STATE(11827)] = 119626,
  [SMALL_STATE(11828)] = 119666,
  [SMALL_STATE(11829)] = 119726,
  [SMALL_STATE(11830)] = 119766,
  [SMALL_STATE(11831)] = 119808,
  [SMALL_STATE(11832)] = 119856,
  [SMALL_STATE(11833)] = 119896,
  [SMALL_STATE(11834)] = 119956,
  [SMALL_STATE(11835)] = 120000,
  [SMALL_STATE(11836)] = 120040,
  [SMALL_STATE(11837)] = 120086,
  [SMALL_STATE(11838)] = 120142,
  [SMALL_STATE(11839)] = 120202,
  [SMALL_STATE(11840)] = 120294,
  [SMALL_STATE(11841)] = 120334,
  [SMALL_STATE(11842)] = 120426,
  [SMALL_STATE(11843)] = 120486,
  [SMALL_STATE(11844)] = 120528,
  [SMALL_STATE(11845)] = 120576,
  [SMALL_STATE(11846)] = 120618,
  [SMALL_STATE(11847)] = 120662,
  [SMALL_STATE(11848)] = 120706,
  [SMALL_STATE(11849)] = 120756,
  [SMALL_STATE(11850)] = 120800,
  [SMALL_STATE(11851)] = 120844,
  [SMALL_STATE(11852)] = 120888,
  [SMALL_STATE(11853)] = 120938,
  [SMALL_STATE(11854)] = 120982,
  [SMALL_STATE(11855)] = 121026,
  [SMALL_STATE(11856)] = 121070,
  [SMALL_STATE(11857)] = 121114,
  [SMALL_STATE(11858)] = 121156,
  [SMALL_STATE(11859)] = 121215,
  [SMALL_STATE(11860)] = 121254,
  [SMALL_STATE(11861)] = 121293,
  [SMALL_STATE(11862)] = 121332,
  [SMALL_STATE(11863)] = 121421,
  [SMALL_STATE(11864)] = 121510,
  [SMALL_STATE(11865)] = 121549,
  [SMALL_STATE(11866)] = 121588,
  [SMALL_STATE(11867)] = 121627,
  [SMALL_STATE(11868)] = 121666,
  [SMALL_STATE(11869)] = 121705,
  [SMALL_STATE(11870)] = 121794,
  [SMALL_STATE(11871)] = 121853,
  [SMALL_STATE(11872)] = 121892,
  [SMALL_STATE(11873)] = 121935,
  [SMALL_STATE(11874)] = 122024,
  [SMALL_STATE(11875)] = 122069,
  [SMALL_STATE(11876)] = 122158,
  [SMALL_STATE(11877)] = 122197,
  [SMALL_STATE(11878)] = 122236,
  [SMALL_STATE(11879)] = 122275,
  [SMALL_STATE(11880)] = 122314,
  [SMALL_STATE(11881)] = 122353,
  [SMALL_STATE(11882)] = 122412,
  [SMALL_STATE(11883)] = 122457,
  [SMALL_STATE(11884)] = 122496,
  [SMALL_STATE(11885)] = 122535,
  [SMALL_STATE(11886)] = 122580,
  [SMALL_STATE(11887)] = 122639,
  [SMALL_STATE(11888)] = 122728,
  [SMALL_STATE(11889)] = 122773,
  [SMALL_STATE(11890)] = 122822,
  [SMALL_STATE(11891)] = 122861,
  [SMALL_STATE(11892)] = 122902,
  [SMALL_STATE(11893)] = 122945,
  [SMALL_STATE(11894)] = 122984,
  [SMALL_STATE(11895)] = 123073,
  [SMALL_STATE(11896)] = 123132,
  [SMALL_STATE(11897)] = 123175,
  [SMALL_STATE(11898)] = 123220,
  [SMALL_STATE(11899)] = 123309,
  [SMALL_STATE(11900)] = 123398,
  [SMALL_STATE(11901)] = 123457,
  [SMALL_STATE(11902)] = 123498,
  [SMALL_STATE(11903)] = 123537,
  [SMALL_STATE(11904)] = 123582,
  [SMALL_STATE(11905)] = 123671,
  [SMALL_STATE(11906)] = 123760,
  [SMALL_STATE(11907)] = 123849,
  [SMALL_STATE(11908)] = 123888,
  [SMALL_STATE(11909)] = 123977,
  [SMALL_STATE(11910)] = 124066,
  [SMALL_STATE(11911)] = 124155,
  [SMALL_STATE(11912)] = 124198,
  [SMALL_STATE(11913)] = 124287,
  [SMALL_STATE(11914)] = 124330,
  [SMALL_STATE(11915)] = 124371,
  [SMALL_STATE(11916)] = 124460,
  [SMALL_STATE(11917)] = 124499,
  [SMALL_STATE(11918)] = 124558,
  [SMALL_STATE(11919)] = 124647,
  [SMALL_STATE(11920)] = 124686,
  [SMALL_STATE(11921)] = 124739,
  [SMALL_STATE(11922)] = 124828,
  [SMALL_STATE(11923)] = 124917,
  [SMALL_STATE(11924)] = 124956,
  [SMALL_STATE(11925)] = 125001,
  [SMALL_STATE(11926)] = 125044,
  [SMALL_STATE(11927)] = 125133,
  [SMALL_STATE(11928)] = 125222,
  [SMALL_STATE(11929)] = 125267,
  [SMALL_STATE(11930)] = 125356,
  [SMALL_STATE(11931)] = 125445,
  [SMALL_STATE(11932)] = 125488,
  [SMALL_STATE(11933)] = 125573,
  [SMALL_STATE(11934)] = 125662,
  [SMALL_STATE(11935)] = 125751,
  [SMALL_STATE(11936)] = 125840,
  [SMALL_STATE(11937)] = 125899,
  [SMALL_STATE(11938)] = 125988,
  [SMALL_STATE(11939)] = 126027,
  [SMALL_STATE(11940)] = 126116,
  [SMALL_STATE(11941)] = 126155,
  [SMALL_STATE(11942)] = 126194,
  [SMALL_STATE(11943)] = 126283,
  [SMALL_STATE(11944)] = 126322,
  [SMALL_STATE(11945)] = 126411,
  [SMALL_STATE(11946)] = 126454,
  [SMALL_STATE(11947)] = 126493,
  [SMALL_STATE(11948)] = 126582,
  [SMALL_STATE(11949)] = 126627,
  [SMALL_STATE(11950)] = 126672,
  [SMALL_STATE(11951)] = 126711,
  [SMALL_STATE(11952)] = 126750,
  [SMALL_STATE(11953)] = 126791,
  [SMALL_STATE(11954)] = 126830,
  [SMALL_STATE(11955)] = 126869,
  [SMALL_STATE(11956)] = 126910,
  [SMALL_STATE(11957)] = 126949,
  [SMALL_STATE(11958)] = 127008,
  [SMALL_STATE(11959)] = 127097,
  [SMALL_STATE(11960)] = 127140,
  [SMALL_STATE(11961)] = 127179,
  [SMALL_STATE(11962)] = 127222,
  [SMALL_STATE(11963)] = 127261,
  [SMALL_STATE(11964)] = 127300,
  [SMALL_STATE(11965)] = 127339,
  [SMALL_STATE(11966)] = 127384,
  [SMALL_STATE(11967)] = 127427,
  [SMALL_STATE(11968)] = 127516,
  [SMALL_STATE(11969)] = 127605,
  [SMALL_STATE(11970)] = 127694,
  [SMALL_STATE(11971)] = 127733,
  [SMALL_STATE(11972)] = 127772,
  [SMALL_STATE(11973)] = 127861,
  [SMALL_STATE(11974)] = 127900,
  [SMALL_STATE(11975)] = 127943,
  [SMALL_STATE(11976)] = 127982,
  [SMALL_STATE(11977)] = 128027,
  [SMALL_STATE(11978)] = 128116,
  [SMALL_STATE(11979)] = 128155,
  [SMALL_STATE(11980)] = 128244,
  [SMALL_STATE(11981)] = 128289,
  [SMALL_STATE(11982)] = 128328,
  [SMALL_STATE(11983)] = 128373,
  [SMALL_STATE(11984)] = 128412,
  [SMALL_STATE(11985)] = 128455,
  [SMALL_STATE(11986)] = 128500,
  [SMALL_STATE(11987)] = 128559,
  [SMALL_STATE(11988)] = 128598,
  [SMALL_STATE(11989)] = 128687,
  [SMALL_STATE(11990)] = 128732,
  [SMALL_STATE(11991)] = 128771,
  [SMALL_STATE(11992)] = 128810,
  [SMALL_STATE(11993)] = 128855,
  [SMALL_STATE(11994)] = 128894,
  [SMALL_STATE(11995)] = 128939,
  [SMALL_STATE(11996)] = 129028,
  [SMALL_STATE(11997)] = 129073,
  [SMALL_STATE(11998)] = 129112,
  [SMALL_STATE(11999)] = 129155,
  [SMALL_STATE(12000)] = 129244,
  [SMALL_STATE(12001)] = 129333,
  [SMALL_STATE(12002)] = 129372,
  [SMALL_STATE(12003)] = 129411,
  [SMALL_STATE(12004)] = 129450,
  [SMALL_STATE(12005)] = 129489,
  [SMALL_STATE(12006)] = 129528,
  [SMALL_STATE(12007)] = 129573,
  [SMALL_STATE(12008)] = 129618,
  [SMALL_STATE(12009)] = 129663,
  [SMALL_STATE(12010)] = 129752,
  [SMALL_STATE(12011)] = 129791,
  [SMALL_STATE(12012)] = 129880,
  [SMALL_STATE(12013)] = 129919,
  [SMALL_STATE(12014)] = 130008,
  [SMALL_STATE(12015)] = 130053,
  [SMALL_STATE(12016)] = 130092,
  [SMALL_STATE(12017)] = 130131,
  [SMALL_STATE(12018)] = 130170,
  [SMALL_STATE(12019)] = 130209,
  [SMALL_STATE(12020)] = 130254,
  [SMALL_STATE(12021)] = 130293,
  [SMALL_STATE(12022)] = 130382,
  [SMALL_STATE(12023)] = 130471,
  [SMALL_STATE(12024)] = 130560,
  [SMALL_STATE(12025)] = 130605,
  [SMALL_STATE(12026)] = 130644,
  [SMALL_STATE(12027)] = 130733,
  [SMALL_STATE(12028)] = 130776,
  [SMALL_STATE(12029)] = 130815,
  [SMALL_STATE(12030)] = 130854,
  [SMALL_STATE(12031)] = 130943,
  [SMALL_STATE(12032)] = 130982,
  [SMALL_STATE(12033)] = 131041,
  [SMALL_STATE(12034)] = 131080,
  [SMALL_STATE(12035)] = 131119,
  [SMALL_STATE(12036)] = 131208,
  [SMALL_STATE(12037)] = 131297,
  [SMALL_STATE(12038)] = 131336,
  [SMALL_STATE(12039)] = 131425,
  [SMALL_STATE(12040)] = 131464,
  [SMALL_STATE(12041)] = 131503,
  [SMALL_STATE(12042)] = 131592,
  [SMALL_STATE(12043)] = 131681,
  [SMALL_STATE(12044)] = 131770,
  [SMALL_STATE(12045)] = 131809,
  [SMALL_STATE(12046)] = 131854,
  [SMALL_STATE(12047)] = 131943,
  [SMALL_STATE(12048)] = 132032,
  [SMALL_STATE(12049)] = 132077,
  [SMALL_STATE(12050)] = 132116,
  [SMALL_STATE(12051)] = 132161,
  [SMALL_STATE(12052)] = 132200,
  [SMALL_STATE(12053)] = 132239,
  [SMALL_STATE(12054)] = 132324,
  [SMALL_STATE(12055)] = 132413,
  [SMALL_STATE(12056)] = 132452,
  [SMALL_STATE(12057)] = 132497,
  [SMALL_STATE(12058)] = 132586,
  [SMALL_STATE(12059)] = 132625,
  [SMALL_STATE(12060)] = 132714,
  [SMALL_STATE(12061)] = 132803,
  [SMALL_STATE(12062)] = 132844,
  [SMALL_STATE(12063)] = 132883,
  [SMALL_STATE(12064)] = 132926,
  [SMALL_STATE(12065)] = 132965,
  [SMALL_STATE(12066)] = 133004,
  [SMALL_STATE(12067)] = 133043,
  [SMALL_STATE(12068)] = 133082,
  [SMALL_STATE(12069)] = 133141,
  [SMALL_STATE(12070)] = 133186,
  [SMALL_STATE(12071)] = 133227,
  [SMALL_STATE(12072)] = 133266,
  [SMALL_STATE(12073)] = 133309,
  [SMALL_STATE(12074)] = 133348,
  [SMALL_STATE(12075)] = 133407,
  [SMALL_STATE(12076)] = 133446,
  [SMALL_STATE(12077)] = 133491,
  [SMALL_STATE(12078)] = 133534,
  [SMALL_STATE(12079)] = 133573,
  [SMALL_STATE(12080)] = 133612,
  [SMALL_STATE(12081)] = 133701,
  [SMALL_STATE(12082)] = 133740,
  [SMALL_STATE(12083)] = 133783,
  [SMALL_STATE(12084)] = 133822,
  [SMALL_STATE(12085)] = 133861,
  [SMALL_STATE(12086)] = 133950,
  [SMALL_STATE(12087)] = 133989,
  [SMALL_STATE(12088)] = 134028,
  [SMALL_STATE(12089)] = 134067,
  [SMALL_STATE(12090)] = 134126,
  [SMALL_STATE(12091)] = 134165,
  [SMALL_STATE(12092)] = 134204,
  [SMALL_STATE(12093)] = 134293,
  [SMALL_STATE(12094)] = 134382,
  [SMALL_STATE(12095)] = 134471,
  [SMALL_STATE(12096)] = 134514,
  [SMALL_STATE(12097)] = 134559,
  [SMALL_STATE(12098)] = 134598,
  [SMALL_STATE(12099)] = 134643,
  [SMALL_STATE(12100)] = 134682,
  [SMALL_STATE(12101)] = 134771,
  [SMALL_STATE(12102)] = 134852,
  [SMALL_STATE(12103)] = 134933,
  [SMALL_STATE(12104)] = 135014,
  [SMALL_STATE(12105)] = 135057,
  [SMALL_STATE(12106)] = 135146,
  [SMALL_STATE(12107)] = 135191,
  [SMALL_STATE(12108)] = 135230,
  [SMALL_STATE(12109)] = 135269,
  [SMALL_STATE(12110)] = 135312,
  [SMALL_STATE(12111)] = 135401,
  [SMALL_STATE(12112)] = 135446,
  [SMALL_STATE(12113)] = 135527,
  [SMALL_STATE(12114)] = 135608,
  [SMALL_STATE(12115)] = 135689,
  [SMALL_STATE(12116)] = 135768,
  [SMALL_STATE(12117)] = 135845,
  [SMALL_STATE(12118)] = 135900,
  [SMALL_STATE(12119)] = 135945,
  [SMALL_STATE(12120)] = 136024,
  [SMALL_STATE(12121)] = 136101,
  [SMALL_STATE(12122)] = 136140,
  [SMALL_STATE(12123)] = 136179,
  [SMALL_STATE(12124)] = 136224,
  [SMALL_STATE(12125)] = 136263,
  [SMALL_STATE(12126)] = 136302,
  [SMALL_STATE(12127)] = 136391,
  [SMALL_STATE(12128)] = 136436,
  [SMALL_STATE(12129)] = 136525,
  [SMALL_STATE(12130)] = 136614,
  [SMALL_STATE(12131)] = 136659,
  [SMALL_STATE(12132)] = 136698,
  [SMALL_STATE(12133)] = 136741,
  [SMALL_STATE(12134)] = 136780,
  [SMALL_STATE(12135)] = 136861,
  [SMALL_STATE(12136)] = 136900,
  [SMALL_STATE(12137)] = 136981,
  [SMALL_STATE(12138)] = 137020,
  [SMALL_STATE(12139)] = 137059,
  [SMALL_STATE(12140)] = 137138,
  [SMALL_STATE(12141)] = 137215,
  [SMALL_STATE(12142)] = 137258,
  [SMALL_STATE(12143)] = 137297,
  [SMALL_STATE(12144)] = 137376,
  [SMALL_STATE(12145)] = 137453,
  [SMALL_STATE(12146)] = 137492,
  [SMALL_STATE(12147)] = 137551,
  [SMALL_STATE(12148)] = 137640,
  [SMALL_STATE(12149)] = 137729,
  [SMALL_STATE(12150)] = 137768,
  [SMALL_STATE(12151)] = 137857,
  [SMALL_STATE(12152)] = 137900,
  [SMALL_STATE(12153)] = 137981,
  [SMALL_STATE(12154)] = 138062,
  [SMALL_STATE(12155)] = 138143,
  [SMALL_STATE(12156)] = 138224,
  [SMALL_STATE(12157)] = 138305,
  [SMALL_STATE(12158)] = 138386,
  [SMALL_STATE(12159)] = 138467,
  [SMALL_STATE(12160)] = 138548,
  [SMALL_STATE(12161)] = 138587,
  [SMALL_STATE(12162)] = 138632,
  [SMALL_STATE(12163)] = 138671,
  [SMALL_STATE(12164)] = 138710,
  [SMALL_STATE(12165)] = 138755,
  [SMALL_STATE(12166)] = 138814,
  [SMALL_STATE(12167)] = 138867,
  [SMALL_STATE(12168)] = 138914,
  [SMALL_STATE(12169)] = 138953,
  [SMALL_STATE(12170)] = 138992,
  [SMALL_STATE(12171)] = 139081,
  [SMALL_STATE(12172)] = 139120,
  [SMALL_STATE(12173)] = 139209,
  [SMALL_STATE(12174)] = 139248,
  [SMALL_STATE(12175)] = 139293,
  [SMALL_STATE(12176)] = 139338,
  [SMALL_STATE(12177)] = 139397,
  [SMALL_STATE(12178)] = 139442,
  [SMALL_STATE(12179)] = 139487,
  [SMALL_STATE(12180)] = 139530,
  [SMALL_STATE(12181)] = 139575,
  [SMALL_STATE(12182)] = 139614,
  [SMALL_STATE(12183)] = 139653,
  [SMALL_STATE(12184)] = 139694,
  [SMALL_STATE(12185)] = 139733,
  [SMALL_STATE(12186)] = 139772,
  [SMALL_STATE(12187)] = 139811,
  [SMALL_STATE(12188)] = 139870,
  [SMALL_STATE(12189)] = 139929,
  [SMALL_STATE(12190)] = 140018,
  [SMALL_STATE(12191)] = 140065,
  [SMALL_STATE(12192)] = 140104,
  [SMALL_STATE(12193)] = 140143,
  [SMALL_STATE(12194)] = 140186,
  [SMALL_STATE(12195)] = 140225,
  [SMALL_STATE(12196)] = 140264,
  [SMALL_STATE(12197)] = 140323,
  [SMALL_STATE(12198)] = 140362,
  [SMALL_STATE(12199)] = 140409,
  [SMALL_STATE(12200)] = 140448,
  [SMALL_STATE(12201)] = 140487,
  [SMALL_STATE(12202)] = 140532,
  [SMALL_STATE(12203)] = 140577,
  [SMALL_STATE(12204)] = 140622,
  [SMALL_STATE(12205)] = 140711,
  [SMALL_STATE(12206)] = 140800,
  [SMALL_STATE(12207)] = 140845,
  [SMALL_STATE(12208)] = 140888,
  [SMALL_STATE(12209)] = 140933,
  [SMALL_STATE(12210)] = 140972,
  [SMALL_STATE(12211)] = 141017,
  [SMALL_STATE(12212)] = 141056,
  [SMALL_STATE(12213)] = 141095,
  [SMALL_STATE(12214)] = 141144,
  [SMALL_STATE(12215)] = 141187,
  [SMALL_STATE(12216)] = 141230,
  [SMALL_STATE(12217)] = 141273,
  [SMALL_STATE(12218)] = 141318,
  [SMALL_STATE(12219)] = 141363,
  [SMALL_STATE(12220)] = 141402,
  [SMALL_STATE(12221)] = 141491,
  [SMALL_STATE(12222)] = 141530,
  [SMALL_STATE(12223)] = 141569,
  [SMALL_STATE(12224)] = 141618,
  [SMALL_STATE(12225)] = 141661,
  [SMALL_STATE(12226)] = 141704,
  [SMALL_STATE(12227)] = 141747,
  [SMALL_STATE(12228)] = 141790,
  [SMALL_STATE(12229)] = 141839,
  [SMALL_STATE(12230)] = 141882,
  [SMALL_STATE(12231)] = 141925,
  [SMALL_STATE(12232)] = 141968,
  [SMALL_STATE(12233)] = 142011,
  [SMALL_STATE(12234)] = 142056,
  [SMALL_STATE(12235)] = 142101,
  [SMALL_STATE(12236)] = 142140,
  [SMALL_STATE(12237)] = 142179,
  [SMALL_STATE(12238)] = 142222,
  [SMALL_STATE(12239)] = 142261,
  [SMALL_STATE(12240)] = 142350,
  [SMALL_STATE(12241)] = 142393,
  [SMALL_STATE(12242)] = 142436,
  [SMALL_STATE(12243)] = 142479,
  [SMALL_STATE(12244)] = 142568,
  [SMALL_STATE(12245)] = 142611,
  [SMALL_STATE(12246)] = 142671,
  [SMALL_STATE(12247)] = 142731,
  [SMALL_STATE(12248)] = 142773,
  [SMALL_STATE(12249)] = 142813,
  [SMALL_STATE(12250)] = 142855,
  [SMALL_STATE(12251)] = 142897,
  [SMALL_STATE(12252)] = 142939,
  [SMALL_STATE(12253)] = 142979,
  [SMALL_STATE(12254)] = 143019,
  [SMALL_STATE(12255)] = 143059,
  [SMALL_STATE(12256)] = 143103,
  [SMALL_STATE(12257)] = 143143,
  [SMALL_STATE(12258)] = 143183,
  [SMALL_STATE(12259)] = 143223,
  [SMALL_STATE(12260)] = 143265,
  [SMALL_STATE(12261)] = 143307,
  [SMALL_STATE(12262)] = 143387,
  [SMALL_STATE(12263)] = 143443,
  [SMALL_STATE(12264)] = 143483,
  [SMALL_STATE(12265)] = 143523,
  [SMALL_STATE(12266)] = 143563,
  [SMALL_STATE(12267)] = 143603,
  [SMALL_STATE(12268)] = 143679,
  [SMALL_STATE(12269)] = 143721,
  [SMALL_STATE(12270)] = 143807,
  [SMALL_STATE(12271)] = 143871,
  [SMALL_STATE(12272)] = 143923,
  [SMALL_STATE(12273)] = 143985,
  [SMALL_STATE(12274)] = 144061,
  [SMALL_STATE(12275)] = 144147,
  [SMALL_STATE(12276)] = 144219,
  [SMALL_STATE(12277)] = 144287,
  [SMALL_STATE(12278)] = 144353,
  [SMALL_STATE(12279)] = 144411,
  [SMALL_STATE(12280)] = 144473,
  [SMALL_STATE(12281)] = 144525,
  [SMALL_STATE(12282)] = 144575,
  [SMALL_STATE(12283)] = 144623,
  [SMALL_STATE(12284)] = 144669,
  [SMALL_STATE(12285)] = 144713,
  [SMALL_STATE(12286)] = 144755,
  [SMALL_STATE(12287)] = 144815,
  [SMALL_STATE(12288)] = 144855,
  [SMALL_STATE(12289)] = 144903,
  [SMALL_STATE(12290)] = 144945,
  [SMALL_STATE(12291)] = 144985,
  [SMALL_STATE(12292)] = 145025,
  [SMALL_STATE(12293)] = 145065,
  [SMALL_STATE(12294)] = 145105,
  [SMALL_STATE(12295)] = 145145,
  [SMALL_STATE(12296)] = 145185,
  [SMALL_STATE(12297)] = 145225,
  [SMALL_STATE(12298)] = 145265,
  [SMALL_STATE(12299)] = 145305,
  [SMALL_STATE(12300)] = 145345,
  [SMALL_STATE(12301)] = 145385,
  [SMALL_STATE(12302)] = 145425,
  [SMALL_STATE(12303)] = 145465,
  [SMALL_STATE(12304)] = 145505,
  [SMALL_STATE(12305)] = 145545,
  [SMALL_STATE(12306)] = 145585,
  [SMALL_STATE(12307)] = 145627,
  [SMALL_STATE(12308)] = 145671,
  [SMALL_STATE(12309)] = 145727,
  [SMALL_STATE(12310)] = 145767,
  [SMALL_STATE(12311)] = 145807,
  [SMALL_STATE(12312)] = 145867,
  [SMALL_STATE(12313)] = 145907,
  [SMALL_STATE(12314)] = 145947,
  [SMALL_STATE(12315)] = 145987,
  [SMALL_STATE(12316)] = 146073,
  [SMALL_STATE(12317)] = 146117,
  [SMALL_STATE(12318)] = 146161,
  [SMALL_STATE(12319)] = 146201,
  [SMALL_STATE(12320)] = 146287,
  [SMALL_STATE(12321)] = 146327,
  [SMALL_STATE(12322)] = 146367,
  [SMALL_STATE(12323)] = 146407,
  [SMALL_STATE(12324)] = 146447,
  [SMALL_STATE(12325)] = 146487,
  [SMALL_STATE(12326)] = 146527,
  [SMALL_STATE(12327)] = 146567,
  [SMALL_STATE(12328)] = 146627,
  [SMALL_STATE(12329)] = 146671,
  [SMALL_STATE(12330)] = 146711,
  [SMALL_STATE(12331)] = 146751,
  [SMALL_STATE(12332)] = 146791,
  [SMALL_STATE(12333)] = 146831,
  [SMALL_STATE(12334)] = 146871,
  [SMALL_STATE(12335)] = 146911,
  [SMALL_STATE(12336)] = 146951,
  [SMALL_STATE(12337)] = 146991,
  [SMALL_STATE(12338)] = 147077,
  [SMALL_STATE(12339)] = 147163,
  [SMALL_STATE(12340)] = 147223,
  [SMALL_STATE(12341)] = 147263,
  [SMALL_STATE(12342)] = 147303,
  [SMALL_STATE(12343)] = 147343,
  [SMALL_STATE(12344)] = 147383,
  [SMALL_STATE(12345)] = 147423,
  [SMALL_STATE(12346)] = 147463,
  [SMALL_STATE(12347)] = 147503,
  [SMALL_STATE(12348)] = 147589,
  [SMALL_STATE(12349)] = 147675,
  [SMALL_STATE(12350)] = 147715,
  [SMALL_STATE(12351)] = 147755,
  [SMALL_STATE(12352)] = 147795,
  [SMALL_STATE(12353)] = 147855,
  [SMALL_STATE(12354)] = 147895,
  [SMALL_STATE(12355)] = 147935,
  [SMALL_STATE(12356)] = 147975,
  [SMALL_STATE(12357)] = 148015,
  [SMALL_STATE(12358)] = 148055,
  [SMALL_STATE(12359)] = 148095,
  [SMALL_STATE(12360)] = 148135,
  [SMALL_STATE(12361)] = 148175,
  [SMALL_STATE(12362)] = 148215,
  [SMALL_STATE(12363)] = 148255,
  [SMALL_STATE(12364)] = 148341,
  [SMALL_STATE(12365)] = 148381,
  [SMALL_STATE(12366)] = 148421,
  [SMALL_STATE(12367)] = 148507,
  [SMALL_STATE(12368)] = 148547,
  [SMALL_STATE(12369)] = 148587,
  [SMALL_STATE(12370)] = 148647,
  [SMALL_STATE(12371)] = 148689,
  [SMALL_STATE(12372)] = 148769,
  [SMALL_STATE(12373)] = 148845,
  [SMALL_STATE(12374)] = 148931,
  [SMALL_STATE(12375)] = 149017,
  [SMALL_STATE(12376)] = 149077,
  [SMALL_STATE(12377)] = 149157,
  [SMALL_STATE(12378)] = 149199,
  [SMALL_STATE(12379)] = 149241,
  [SMALL_STATE(12380)] = 149283,
  [SMALL_STATE(12381)] = 149369,
  [SMALL_STATE(12382)] = 149433,
  [SMALL_STATE(12383)] = 149519,
  [SMALL_STATE(12384)] = 149571,
  [SMALL_STATE(12385)] = 149633,
  [SMALL_STATE(12386)] = 149709,
  [SMALL_STATE(12387)] = 149781,
  [SMALL_STATE(12388)] = 149849,
  [SMALL_STATE(12389)] = 149915,
  [SMALL_STATE(12390)] = 149973,
  [SMALL_STATE(12391)] = 150035,
  [SMALL_STATE(12392)] = 150095,
  [SMALL_STATE(12393)] = 150147,
  [SMALL_STATE(12394)] = 150197,
  [SMALL_STATE(12395)] = 150245,
  [SMALL_STATE(12396)] = 150291,
  [SMALL_STATE(12397)] = 150335,
  [SMALL_STATE(12398)] = 150411,
  [SMALL_STATE(12399)] = 150491,
  [SMALL_STATE(12400)] = 150567,
  [SMALL_STATE(12401)] = 150653,
  [SMALL_STATE(12402)] = 150739,
  [SMALL_STATE(12403)] = 150803,
  [SMALL_STATE(12404)] = 150855,
  [SMALL_STATE(12405)] = 150917,
  [SMALL_STATE(12406)] = 150993,
  [SMALL_STATE(12407)] = 151065,
  [SMALL_STATE(12408)] = 151133,
  [SMALL_STATE(12409)] = 151193,
  [SMALL_STATE(12410)] = 151259,
  [SMALL_STATE(12411)] = 151317,
  [SMALL_STATE(12412)] = 151379,
  [SMALL_STATE(12413)] = 151431,
  [SMALL_STATE(12414)] = 151481,
  [SMALL_STATE(12415)] = 151529,
  [SMALL_STATE(12416)] = 151575,
  [SMALL_STATE(12417)] = 151619,
  [SMALL_STATE(12418)] = 151695,
  [SMALL_STATE(12419)] = 151781,
  [SMALL_STATE(12420)] = 151867,
  [SMALL_STATE(12421)] = 151927,
  [SMALL_STATE(12422)] = 151969,
  [SMALL_STATE(12423)] = 152009,
  [SMALL_STATE(12424)] = 152051,
  [SMALL_STATE(12425)] = 152093,
  [SMALL_STATE(12426)] = 152135,
  [SMALL_STATE(12427)] = 152221,
  [SMALL_STATE(12428)] = 152307,
  [SMALL_STATE(12429)] = 152367,
  [SMALL_STATE(12430)] = 152427,
  [SMALL_STATE(12431)] = 152511,
  [SMALL_STATE(12432)] = 152555,
  [SMALL_STATE(12433)] = 152599,
  [SMALL_STATE(12434)] = 152685,
  [SMALL_STATE(12435)] = 152771,
  [SMALL_STATE(12436)] = 152831,
  [SMALL_STATE(12437)] = 152917,
  [SMALL_STATE(12438)] = 153003,
  [SMALL_STATE(12439)] = 153063,
  [SMALL_STATE(12440)] = 153149,
  [SMALL_STATE(12441)] = 153235,
  [SMALL_STATE(12442)] = 153295,
  [SMALL_STATE(12443)] = 153351,
  [SMALL_STATE(12444)] = 153437,
  [SMALL_STATE(12445)] = 153523,
  [SMALL_STATE(12446)] = 153583,
  [SMALL_STATE(12447)] = 153669,
  [SMALL_STATE(12448)] = 153755,
  [SMALL_STATE(12449)] = 153801,
  [SMALL_STATE(12450)] = 153861,
  [SMALL_STATE(12451)] = 153947,
  [SMALL_STATE(12452)] = 154033,
  [SMALL_STATE(12453)] = 154119,
  [SMALL_STATE(12454)] = 154179,
  [SMALL_STATE(12455)] = 154265,
  [SMALL_STATE(12456)] = 154351,
  [SMALL_STATE(12457)] = 154437,
  [SMALL_STATE(12458)] = 154497,
  [SMALL_STATE(12459)] = 154583,
  [SMALL_STATE(12460)] = 154669,
  [SMALL_STATE(12461)] = 154713,
  [SMALL_STATE(12462)] = 154773,
  [SMALL_STATE(12463)] = 154817,
  [SMALL_STATE(12464)] = 154903,
  [SMALL_STATE(12465)] = 154989,
  [SMALL_STATE(12466)] = 155069,
  [SMALL_STATE(12467)] = 155129,
  [SMALL_STATE(12468)] = 155169,
  [SMALL_STATE(12469)] = 155255,
  [SMALL_STATE(12470)] = 155341,
  [SMALL_STATE(12471)] = 155401,
  [SMALL_STATE(12472)] = 155479,
  [SMALL_STATE(12473)] = 155521,
  [SMALL_STATE(12474)] = 155581,
  [SMALL_STATE(12475)] = 155667,
  [SMALL_STATE(12476)] = 155707,
  [SMALL_STATE(12477)] = 155793,
  [SMALL_STATE(12478)] = 155879,
  [SMALL_STATE(12479)] = 155939,
  [SMALL_STATE(12480)] = 156025,
  [SMALL_STATE(12481)] = 156067,
  [SMALL_STATE(12482)] = 156147,
  [SMALL_STATE(12483)] = 156189,
  [SMALL_STATE(12484)] = 156275,
  [SMALL_STATE(12485)] = 156355,
  [SMALL_STATE(12486)] = 156397,
  [SMALL_STATE(12487)] = 156477,
  [SMALL_STATE(12488)] = 156537,
  [SMALL_STATE(12489)] = 156581,
  [SMALL_STATE(12490)] = 156667,
  [SMALL_STATE(12491)] = 156707,
  [SMALL_STATE(12492)] = 156793,
  [SMALL_STATE(12493)] = 156833,
  [SMALL_STATE(12494)] = 156893,
  [SMALL_STATE(12495)] = 156933,
  [SMALL_STATE(12496)] = 157013,
  [SMALL_STATE(12497)] = 157053,
  [SMALL_STATE(12498)] = 157093,
  [SMALL_STATE(12499)] = 157173,
  [SMALL_STATE(12500)] = 157213,
  [SMALL_STATE(12501)] = 157299,
  [SMALL_STATE(12502)] = 157385,
  [SMALL_STATE(12503)] = 157465,
  [SMALL_STATE(12504)] = 157521,
  [SMALL_STATE(12505)] = 157581,
  [SMALL_STATE(12506)] = 157621,
  [SMALL_STATE(12507)] = 157707,
  [SMALL_STATE(12508)] = 157793,
  [SMALL_STATE(12509)] = 157853,
  [SMALL_STATE(12510)] = 157939,
  [SMALL_STATE(12511)] = 158025,
  [SMALL_STATE(12512)] = 158111,
  [SMALL_STATE(12513)] = 158171,
  [SMALL_STATE(12514)] = 158257,
  [SMALL_STATE(12515)] = 158317,
  [SMALL_STATE(12516)] = 158403,
  [SMALL_STATE(12517)] = 158489,
  [SMALL_STATE(12518)] = 158549,
  [SMALL_STATE(12519)] = 158593,
  [SMALL_STATE(12520)] = 158679,
  [SMALL_STATE(12521)] = 158759,
  [SMALL_STATE(12522)] = 158845,
  [SMALL_STATE(12523)] = 158909,
  [SMALL_STATE(12524)] = 158969,
  [SMALL_STATE(12525)] = 159021,
  [SMALL_STATE(12526)] = 159083,
  [SMALL_STATE(12527)] = 159123,
  [SMALL_STATE(12528)] = 159199,
  [SMALL_STATE(12529)] = 159271,
  [SMALL_STATE(12530)] = 159339,
  [SMALL_STATE(12531)] = 159425,
  [SMALL_STATE(12532)] = 159511,
  [SMALL_STATE(12533)] = 159577,
  [SMALL_STATE(12534)] = 159635,
  [SMALL_STATE(12535)] = 159695,
  [SMALL_STATE(12536)] = 159757,
  [SMALL_STATE(12537)] = 159809,
  [SMALL_STATE(12538)] = 159859,
  [SMALL_STATE(12539)] = 159907,
  [SMALL_STATE(12540)] = 159953,
  [SMALL_STATE(12541)] = 159997,
  [SMALL_STATE(12542)] = 160039,
  [SMALL_STATE(12543)] = 160125,
  [SMALL_STATE(12544)] = 160211,
  [SMALL_STATE(12545)] = 160271,
  [SMALL_STATE(12546)] = 160331,
  [SMALL_STATE(12547)] = 160415,
  [SMALL_STATE(12548)] = 160455,
  [SMALL_STATE(12549)] = 160497,
  [SMALL_STATE(12550)] = 160537,
  [SMALL_STATE(12551)] = 160577,
  [SMALL_STATE(12552)] = 160663,
  [SMALL_STATE(12553)] = 160703,
  [SMALL_STATE(12554)] = 160743,
  [SMALL_STATE(12555)] = 160783,
  [SMALL_STATE(12556)] = 160825,
  [SMALL_STATE(12557)] = 160911,
  [SMALL_STATE(12558)] = 160951,
  [SMALL_STATE(12559)] = 160991,
  [SMALL_STATE(12560)] = 161031,
  [SMALL_STATE(12561)] = 161091,
  [SMALL_STATE(12562)] = 161131,
  [SMALL_STATE(12563)] = 161171,
  [SMALL_STATE(12564)] = 161257,
  [SMALL_STATE(12565)] = 161343,
  [SMALL_STATE(12566)] = 161403,
  [SMALL_STATE(12567)] = 161443,
  [SMALL_STATE(12568)] = 161485,
  [SMALL_STATE(12569)] = 161541,
  [SMALL_STATE(12570)] = 161601,
  [SMALL_STATE(12571)] = 161657,
  [SMALL_STATE(12572)] = 161717,
  [SMALL_STATE(12573)] = 161777,
  [SMALL_STATE(12574)] = 161837,
  [SMALL_STATE(12575)] = 161923,
  [SMALL_STATE(12576)] = 161983,
  [SMALL_STATE(12577)] = 162063,
  [SMALL_STATE(12578)] = 162149,
  [SMALL_STATE(12579)] = 162209,
  [SMALL_STATE(12580)] = 162265,
  [SMALL_STATE(12581)] = 162325,
  [SMALL_STATE(12582)] = 162403,
  [SMALL_STATE(12583)] = 162463,
  [SMALL_STATE(12584)] = 162539,
  [SMALL_STATE(12585)] = 162599,
  [SMALL_STATE(12586)] = 162659,
  [SMALL_STATE(12587)] = 162743,
  [SMALL_STATE(12588)] = 162787,
  [SMALL_STATE(12589)] = 162847,
  [SMALL_STATE(12590)] = 162891,
  [SMALL_STATE(12591)] = 162951,
  [SMALL_STATE(12592)] = 163011,
  [SMALL_STATE(12593)] = 163071,
  [SMALL_STATE(12594)] = 163113,
  [SMALL_STATE(12595)] = 163173,
  [SMALL_STATE(12596)] = 163229,
  [SMALL_STATE(12597)] = 163289,
  [SMALL_STATE(12598)] = 163329,
  [SMALL_STATE(12599)] = 163389,
  [SMALL_STATE(12600)] = 163467,
  [SMALL_STATE(12601)] = 163553,
  [SMALL_STATE(12602)] = 163613,
  [SMALL_STATE(12603)] = 163699,
  [SMALL_STATE(12604)] = 163739,
  [SMALL_STATE(12605)] = 163779,
  [SMALL_STATE(12606)] = 163839,
  [SMALL_STATE(12607)] = 163879,
  [SMALL_STATE(12608)] = 163965,
  [SMALL_STATE(12609)] = 164025,
  [SMALL_STATE(12610)] = 164065,
  [SMALL_STATE(12611)] = 164105,
  [SMALL_STATE(12612)] = 164165,
  [SMALL_STATE(12613)] = 164205,
  [SMALL_STATE(12614)] = 164245,
  [SMALL_STATE(12615)] = 164321,
  [SMALL_STATE(12616)] = 164407,
  [SMALL_STATE(12617)] = 164447,
  [SMALL_STATE(12618)] = 164487,
  [SMALL_STATE(12619)] = 164527,
  [SMALL_STATE(12620)] = 164587,
  [SMALL_STATE(12621)] = 164627,
  [SMALL_STATE(12622)] = 164687,
  [SMALL_STATE(12623)] = 164731,
  [SMALL_STATE(12624)] = 164775,
  [SMALL_STATE(12625)] = 164815,
  [SMALL_STATE(12626)] = 164875,
  [SMALL_STATE(12627)] = 164915,
  [SMALL_STATE(12628)] = 164955,
  [SMALL_STATE(12629)] = 164997,
  [SMALL_STATE(12630)] = 165077,
  [SMALL_STATE(12631)] = 165119,
  [SMALL_STATE(12632)] = 165199,
  [SMALL_STATE(12633)] = 165241,
  [SMALL_STATE(12634)] = 165321,
  [SMALL_STATE(12635)] = 165361,
  [SMALL_STATE(12636)] = 165421,
  [SMALL_STATE(12637)] = 165481,
  [SMALL_STATE(12638)] = 165523,
  [SMALL_STATE(12639)] = 165583,
  [SMALL_STATE(12640)] = 165623,
  [SMALL_STATE(12641)] = 165679,
  [SMALL_STATE(12642)] = 165719,
  [SMALL_STATE(12643)] = 165779,
  [SMALL_STATE(12644)] = 165819,
  [SMALL_STATE(12645)] = 165879,
  [SMALL_STATE(12646)] = 165939,
  [SMALL_STATE(12647)] = 165999,
  [SMALL_STATE(12648)] = 166059,
  [SMALL_STATE(12649)] = 166119,
  [SMALL_STATE(12650)] = 166179,
  [SMALL_STATE(12651)] = 166239,
  [SMALL_STATE(12652)] = 166299,
  [SMALL_STATE(12653)] = 166359,
  [SMALL_STATE(12654)] = 166399,
  [SMALL_STATE(12655)] = 166459,
  [SMALL_STATE(12656)] = 166519,
  [SMALL_STATE(12657)] = 166579,
  [SMALL_STATE(12658)] = 166639,
  [SMALL_STATE(12659)] = 166699,
  [SMALL_STATE(12660)] = 166759,
  [SMALL_STATE(12661)] = 166819,
  [SMALL_STATE(12662)] = 166879,
  [SMALL_STATE(12663)] = 166939,
  [SMALL_STATE(12664)] = 166999,
  [SMALL_STATE(12665)] = 167059,
  [SMALL_STATE(12666)] = 167119,
  [SMALL_STATE(12667)] = 167179,
  [SMALL_STATE(12668)] = 167265,
  [SMALL_STATE(12669)] = 167351,
  [SMALL_STATE(12670)] = 167437,
  [SMALL_STATE(12671)] = 167477,
  [SMALL_STATE(12672)] = 167519,
  [SMALL_STATE(12673)] = 167599,
  [SMALL_STATE(12674)] = 167659,
  [SMALL_STATE(12675)] = 167701,
  [SMALL_STATE(12676)] = 167741,
  [SMALL_STATE(12677)] = 167781,
  [SMALL_STATE(12678)] = 167821,
  [SMALL_STATE(12679)] = 167897,
  [SMALL_STATE(12680)] = 167937,
  [SMALL_STATE(12681)] = 167977,
  [SMALL_STATE(12682)] = 168017,
  [SMALL_STATE(12683)] = 168057,
  [SMALL_STATE(12684)] = 168097,
  [SMALL_STATE(12685)] = 168137,
  [SMALL_STATE(12686)] = 168177,
  [SMALL_STATE(12687)] = 168217,
  [SMALL_STATE(12688)] = 168257,
  [SMALL_STATE(12689)] = 168313,
  [SMALL_STATE(12690)] = 168353,
  [SMALL_STATE(12691)] = 168393,
  [SMALL_STATE(12692)] = 168433,
  [SMALL_STATE(12693)] = 168473,
  [SMALL_STATE(12694)] = 168551,
  [SMALL_STATE(12695)] = 168593,
  [SMALL_STATE(12696)] = 168633,
  [SMALL_STATE(12697)] = 168719,
  [SMALL_STATE(12698)] = 168761,
  [SMALL_STATE(12699)] = 168805,
  [SMALL_STATE(12700)] = 168881,
  [SMALL_STATE(12701)] = 168923,
  [SMALL_STATE(12702)] = 168965,
  [SMALL_STATE(12703)] = 169007,
  [SMALL_STATE(12704)] = 169049,
  [SMALL_STATE(12705)] = 169091,
  [SMALL_STATE(12706)] = 169133,
  [SMALL_STATE(12707)] = 169175,
  [SMALL_STATE(12708)] = 169217,
  [SMALL_STATE(12709)] = 169259,
  [SMALL_STATE(12710)] = 169345,
  [SMALL_STATE(12711)] = 169385,
  [SMALL_STATE(12712)] = 169425,
  [SMALL_STATE(12713)] = 169465,
  [SMALL_STATE(12714)] = 169505,
  [SMALL_STATE(12715)] = 169545,
  [SMALL_STATE(12716)] = 169585,
  [SMALL_STATE(12717)] = 169625,
  [SMALL_STATE(12718)] = 169685,
  [SMALL_STATE(12719)] = 169725,
  [SMALL_STATE(12720)] = 169765,
  [SMALL_STATE(12721)] = 169809,
  [SMALL_STATE(12722)] = 169849,
  [SMALL_STATE(12723)] = 169893,
  [SMALL_STATE(12724)] = 169933,
  [SMALL_STATE(12725)] = 169973,
  [SMALL_STATE(12726)] = 170013,
  [SMALL_STATE(12727)] = 170053,
  [SMALL_STATE(12728)] = 170093,
  [SMALL_STATE(12729)] = 170133,
  [SMALL_STATE(12730)] = 170193,
  [SMALL_STATE(12731)] = 170253,
  [SMALL_STATE(12732)] = 170313,
  [SMALL_STATE(12733)] = 170373,
  [SMALL_STATE(12734)] = 170433,
  [SMALL_STATE(12735)] = 170493,
  [SMALL_STATE(12736)] = 170553,
  [SMALL_STATE(12737)] = 170613,
  [SMALL_STATE(12738)] = 170673,
  [SMALL_STATE(12739)] = 170733,
  [SMALL_STATE(12740)] = 170773,
  [SMALL_STATE(12741)] = 170833,
  [SMALL_STATE(12742)] = 170893,
  [SMALL_STATE(12743)] = 170953,
  [SMALL_STATE(12744)] = 171013,
  [SMALL_STATE(12745)] = 171073,
  [SMALL_STATE(12746)] = 171113,
  [SMALL_STATE(12747)] = 171153,
  [SMALL_STATE(12748)] = 171193,
  [SMALL_STATE(12749)] = 171235,
  [SMALL_STATE(12750)] = 171275,
  [SMALL_STATE(12751)] = 171315,
  [SMALL_STATE(12752)] = 171355,
  [SMALL_STATE(12753)] = 171395,
  [SMALL_STATE(12754)] = 171451,
  [SMALL_STATE(12755)] = 171511,
  [SMALL_STATE(12756)] = 171571,
  [SMALL_STATE(12757)] = 171631,
  [SMALL_STATE(12758)] = 171691,
  [SMALL_STATE(12759)] = 171777,
  [SMALL_STATE(12760)] = 171819,
  [SMALL_STATE(12761)] = 171905,
  [SMALL_STATE(12762)] = 171965,
  [SMALL_STATE(12763)] = 172025,
  [SMALL_STATE(12764)] = 172085,
  [SMALL_STATE(12765)] = 172145,
  [SMALL_STATE(12766)] = 172231,
  [SMALL_STATE(12767)] = 172291,
  [SMALL_STATE(12768)] = 172351,
  [SMALL_STATE(12769)] = 172411,
  [SMALL_STATE(12770)] = 172471,
  [SMALL_STATE(12771)] = 172515,
  [SMALL_STATE(12772)] = 172559,
  [SMALL_STATE(12773)] = 172619,
  [SMALL_STATE(12774)] = 172679,
  [SMALL_STATE(12775)] = 172739,
  [SMALL_STATE(12776)] = 172781,
  [SMALL_STATE(12777)] = 172823,
  [SMALL_STATE(12778)] = 172865,
  [SMALL_STATE(12779)] = 172925,
  [SMALL_STATE(12780)] = 172985,
  [SMALL_STATE(12781)] = 173045,
  [SMALL_STATE(12782)] = 173085,
  [SMALL_STATE(12783)] = 173145,
  [SMALL_STATE(12784)] = 173205,
  [SMALL_STATE(12785)] = 173265,
  [SMALL_STATE(12786)] = 173325,
  [SMALL_STATE(12787)] = 173381,
  [SMALL_STATE(12788)] = 173441,
  [SMALL_STATE(12789)] = 173481,
  [SMALL_STATE(12790)] = 173521,
  [SMALL_STATE(12791)] = 173581,
  [SMALL_STATE(12792)] = 173641,
  [SMALL_STATE(12793)] = 173721,
  [SMALL_STATE(12794)] = 173761,
  [SMALL_STATE(12795)] = 173841,
  [SMALL_STATE(12796)] = 173881,
  [SMALL_STATE(12797)] = 173921,
  [SMALL_STATE(12798)] = 173961,
  [SMALL_STATE(12799)] = 174041,
  [SMALL_STATE(12800)] = 174081,
  [SMALL_STATE(12801)] = 174159,
  [SMALL_STATE(12802)] = 174239,
  [SMALL_STATE(12803)] = 174325,
  [SMALL_STATE(12804)] = 174367,
  [SMALL_STATE(12805)] = 174407,
  [SMALL_STATE(12806)] = 174467,
  [SMALL_STATE(12807)] = 174553,
  [SMALL_STATE(12808)] = 174609,
  [SMALL_STATE(12809)] = 174655,
  [SMALL_STATE(12810)] = 174733,
  [SMALL_STATE(12811)] = 174793,
  [SMALL_STATE(12812)] = 174873,
  [SMALL_STATE(12813)] = 174951,
  [SMALL_STATE(12814)] = 175027,
  [SMALL_STATE(12815)] = 175071,
  [SMALL_STATE(12816)] = 175115,
  [SMALL_STATE(12817)] = 175157,
  [SMALL_STATE(12818)] = 175199,
  [SMALL_STATE(12819)] = 175241,
  [SMALL_STATE(12820)] = 175283,
  [SMALL_STATE(12821)] = 175359,
  [SMALL_STATE(12822)] = 175399,
  [SMALL_STATE(12823)] = 175477,
  [SMALL_STATE(12824)] = 175553,
  [SMALL_STATE(12825)] = 175631,
  [SMALL_STATE(12826)] = 175707,
  [SMALL_STATE(12827)] = 175763,
  [SMALL_STATE(12828)] = 175839,
  [SMALL_STATE(12829)] = 175919,
  [SMALL_STATE(12830)] = 175999,
  [SMALL_STATE(12831)] = 176079,
  [SMALL_STATE(12832)] = 176159,
  [SMALL_STATE(12833)] = 176239,
  [SMALL_STATE(12834)] = 176319,
  [SMALL_STATE(12835)] = 176399,
  [SMALL_STATE(12836)] = 176479,
  [SMALL_STATE(12837)] = 176559,
  [SMALL_STATE(12838)] = 176639,
  [SMALL_STATE(12839)] = 176719,
  [SMALL_STATE(12840)] = 176799,
  [SMALL_STATE(12841)] = 176859,
  [SMALL_STATE(12842)] = 176919,
  [SMALL_STATE(12843)] = 176979,
  [SMALL_STATE(12844)] = 177023,
  [SMALL_STATE(12845)] = 177079,
  [SMALL_STATE(12846)] = 177123,
  [SMALL_STATE(12847)] = 177167,
  [SMALL_STATE(12848)] = 177209,
  [SMALL_STATE(12849)] = 177253,
  [SMALL_STATE(12850)] = 177313,
  [SMALL_STATE(12851)] = 177373,
  [SMALL_STATE(12852)] = 177429,
  [SMALL_STATE(12853)] = 177489,
  [SMALL_STATE(12854)] = 177545,
  [SMALL_STATE(12855)] = 177587,
  [SMALL_STATE(12856)] = 177647,
  [SMALL_STATE(12857)] = 177707,
  [SMALL_STATE(12858)] = 177751,
  [SMALL_STATE(12859)] = 177807,
  [SMALL_STATE(12860)] = 177851,
  [SMALL_STATE(12861)] = 177895,
  [SMALL_STATE(12862)] = 177937,
  [SMALL_STATE(12863)] = 177981,
  [SMALL_STATE(12864)] = 178041,
  [SMALL_STATE(12865)] = 178101,
  [SMALL_STATE(12866)] = 178145,
  [SMALL_STATE(12867)] = 178201,
  [SMALL_STATE(12868)] = 178245,
  [SMALL_STATE(12869)] = 178289,
  [SMALL_STATE(12870)] = 178331,
  [SMALL_STATE(12871)] = 178375,
  [SMALL_STATE(12872)] = 178435,
  [SMALL_STATE(12873)] = 178495,
  [SMALL_STATE(12874)] = 178551,
  [SMALL_STATE(12875)] = 178593,
  [SMALL_STATE(12876)] = 178653,
  [SMALL_STATE(12877)] = 178713,
  [SMALL_STATE(12878)] = 178773,
  [SMALL_STATE(12879)] = 178833,
  [SMALL_STATE(12880)] = 178893,
  [SMALL_STATE(12881)] = 178953,
  [SMALL_STATE(12882)] = 179013,
  [SMALL_STATE(12883)] = 179061,
  [SMALL_STATE(12884)] = 179103,
  [SMALL_STATE(12885)] = 179145,
  [SMALL_STATE(12886)] = 179187,
  [SMALL_STATE(12887)] = 179233,
  [SMALL_STATE(12888)] = 179273,
  [SMALL_STATE(12889)] = 179313,
  [SMALL_STATE(12890)] = 179353,
  [SMALL_STATE(12891)] = 179397,
  [SMALL_STATE(12892)] = 179441,
  [SMALL_STATE(12893)] = 179485,
  [SMALL_STATE(12894)] = 179527,
  [SMALL_STATE(12895)] = 179569,
  [SMALL_STATE(12896)] = 179609,
  [SMALL_STATE(12897)] = 179653,
  [SMALL_STATE(12898)] = 179697,
  [SMALL_STATE(12899)] = 179741,
  [SMALL_STATE(12900)] = 179785,
  [SMALL_STATE(12901)] = 179861,
  [SMALL_STATE(12902)] = 179947,
  [SMALL_STATE(12903)] = 179989,
  [SMALL_STATE(12904)] = 180031,
  [SMALL_STATE(12905)] = 180071,
  [SMALL_STATE(12906)] = 180148,
  [SMALL_STATE(12907)] = 180223,
  [SMALL_STATE(12908)] = 180264,
  [SMALL_STATE(12909)] = 180305,
  [SMALL_STATE(12910)] = 180346,
  [SMALL_STATE(12911)] = 180387,
  [SMALL_STATE(12912)] = 180428,
  [SMALL_STATE(12913)] = 180469,
  [SMALL_STATE(12914)] = 180544,
  [SMALL_STATE(12915)] = 180601,
  [SMALL_STATE(12916)] = 180642,
  [SMALL_STATE(12917)] = 180721,
  [SMALL_STATE(12918)] = 180800,
  [SMALL_STATE(12919)] = 180861,
  [SMALL_STATE(12920)] = 180904,
  [SMALL_STATE(12921)] = 180979,
  [SMALL_STATE(12922)] = 181054,
  [SMALL_STATE(12923)] = 181095,
  [SMALL_STATE(12924)] = 181174,
  [SMALL_STATE(12925)] = 181215,
  [SMALL_STATE(12926)] = 181294,
  [SMALL_STATE(12927)] = 181335,
  [SMALL_STATE(12928)] = 181414,
  [SMALL_STATE(12929)] = 181455,
  [SMALL_STATE(12930)] = 181498,
  [SMALL_STATE(12931)] = 181541,
  [SMALL_STATE(12932)] = 181584,
  [SMALL_STATE(12933)] = 181635,
  [SMALL_STATE(12934)] = 181716,
  [SMALL_STATE(12935)] = 181765,
  [SMALL_STATE(12936)] = 181846,
  [SMALL_STATE(12937)] = 181889,
  [SMALL_STATE(12938)] = 181936,
  [SMALL_STATE(12939)] = 181977,
  [SMALL_STATE(12940)] = 182020,
  [SMALL_STATE(12941)] = 182101,
  [SMALL_STATE(12942)] = 182142,
  [SMALL_STATE(12943)] = 182219,
  [SMALL_STATE(12944)] = 182294,
  [SMALL_STATE(12945)] = 182335,
  [SMALL_STATE(12946)] = 182398,
  [SMALL_STATE(12947)] = 182441,
  [SMALL_STATE(12948)] = 182482,
  [SMALL_STATE(12949)] = 182565,
  [SMALL_STATE(12950)] = 182606,
  [SMALL_STATE(12951)] = 182649,
  [SMALL_STATE(12952)] = 182692,
  [SMALL_STATE(12953)] = 182743,
  [SMALL_STATE(12954)] = 182786,
  [SMALL_STATE(12955)] = 182847,
  [SMALL_STATE(12956)] = 182922,
  [SMALL_STATE(12957)] = 182993,
  [SMALL_STATE(12958)] = 183072,
  [SMALL_STATE(12959)] = 183113,
  [SMALL_STATE(12960)] = 183188,
  [SMALL_STATE(12961)] = 183231,
  [SMALL_STATE(12962)] = 183294,
  [SMALL_STATE(12963)] = 183345,
  [SMALL_STATE(12964)] = 183388,
  [SMALL_STATE(12965)] = 183455,
  [SMALL_STATE(12966)] = 183520,
  [SMALL_STATE(12967)] = 183561,
  [SMALL_STATE(12968)] = 183602,
  [SMALL_STATE(12969)] = 183643,
  [SMALL_STATE(12970)] = 183684,
  [SMALL_STATE(12971)] = 183759,
  [SMALL_STATE(12972)] = 183820,
  [SMALL_STATE(12973)] = 183895,
  [SMALL_STATE(12974)] = 183936,
  [SMALL_STATE(12975)] = 184013,
  [SMALL_STATE(12976)] = 184084,
  [SMALL_STATE(12977)] = 184163,
  [SMALL_STATE(12978)] = 184204,
  [SMALL_STATE(12979)] = 184271,
  [SMALL_STATE(12980)] = 184336,
  [SMALL_STATE(12981)] = 184393,
  [SMALL_STATE(12982)] = 184454,
  [SMALL_STATE(12983)] = 184495,
  [SMALL_STATE(12984)] = 184546,
  [SMALL_STATE(12985)] = 184595,
  [SMALL_STATE(12986)] = 184642,
  [SMALL_STATE(12987)] = 184687,
  [SMALL_STATE(12988)] = 184730,
  [SMALL_STATE(12989)] = 184809,
  [SMALL_STATE(12990)] = 184850,
  [SMALL_STATE(12991)] = 184893,
  [SMALL_STATE(12992)] = 184934,
  [SMALL_STATE(12993)] = 184979,
  [SMALL_STATE(12994)] = 185022,
  [SMALL_STATE(12995)] = 185061,
  [SMALL_STATE(12996)] = 185104,
  [SMALL_STATE(12997)] = 185179,
  [SMALL_STATE(12998)] = 185256,
  [SMALL_STATE(12999)] = 185331,
  [SMALL_STATE(13000)] = 185374,
  [SMALL_STATE(13001)] = 185417,
  [SMALL_STATE(13002)] = 185460,
  [SMALL_STATE(13003)] = 185535,
  [SMALL_STATE(13004)] = 185578,
  [SMALL_STATE(13005)] = 185655,
  [SMALL_STATE(13006)] = 185698,
  [SMALL_STATE(13007)] = 185739,
  [SMALL_STATE(13008)] = 185782,
  [SMALL_STATE(13009)] = 185823,
  [SMALL_STATE(13010)] = 185898,
  [SMALL_STATE(13011)] = 185973,
  [SMALL_STATE(13012)] = 186052,
  [SMALL_STATE(13013)] = 186131,
  [SMALL_STATE(13014)] = 186210,
  [SMALL_STATE(13015)] = 186287,
  [SMALL_STATE(13016)] = 186362,
  [SMALL_STATE(13017)] = 186441,
  [SMALL_STATE(13018)] = 186516,
  [SMALL_STATE(13019)] = 186559,
  [SMALL_STATE(13020)] = 186600,
  [SMALL_STATE(13021)] = 186643,
  [SMALL_STATE(13022)] = 186706,
  [SMALL_STATE(13023)] = 186747,
  [SMALL_STATE(13024)] = 186788,
  [SMALL_STATE(13025)] = 186867,
  [SMALL_STATE(13026)] = 186918,
  [SMALL_STATE(13027)] = 186997,
  [SMALL_STATE(13028)] = 187058,
  [SMALL_STATE(13029)] = 187133,
  [SMALL_STATE(13030)] = 187174,
  [SMALL_STATE(13031)] = 187245,
  [SMALL_STATE(13032)] = 187312,
  [SMALL_STATE(13033)] = 187389,
  [SMALL_STATE(13034)] = 187464,
  [SMALL_STATE(13035)] = 187529,
  [SMALL_STATE(13036)] = 187586,
  [SMALL_STATE(13037)] = 187647,
  [SMALL_STATE(13038)] = 187698,
  [SMALL_STATE(13039)] = 187747,
  [SMALL_STATE(13040)] = 187824,
  [SMALL_STATE(13041)] = 187899,
  [SMALL_STATE(13042)] = 187946,
  [SMALL_STATE(13043)] = 187991,
  [SMALL_STATE(13044)] = 188070,
  [SMALL_STATE(13045)] = 188149,
  [SMALL_STATE(13046)] = 188190,
  [SMALL_STATE(13047)] = 188233,
  [SMALL_STATE(13048)] = 188276,
  [SMALL_STATE(13049)] = 188317,
  [SMALL_STATE(13050)] = 188358,
  [SMALL_STATE(13051)] = 188437,
  [SMALL_STATE(13052)] = 188476,
  [SMALL_STATE(13053)] = 188519,
  [SMALL_STATE(13054)] = 188598,
  [SMALL_STATE(13055)] = 188677,
  [SMALL_STATE(13056)] = 188756,
  [SMALL_STATE(13057)] = 188797,
  [SMALL_STATE(13058)] = 188876,
  [SMALL_STATE(13059)] = 188955,
  [SMALL_STATE(13060)] = 189034,
  [SMALL_STATE(13061)] = 189075,
  [SMALL_STATE(13062)] = 189154,
  [SMALL_STATE(13063)] = 189233,
  [SMALL_STATE(13064)] = 189312,
  [SMALL_STATE(13065)] = 189391,
  [SMALL_STATE(13066)] = 189470,
  [SMALL_STATE(13067)] = 189509,
  [SMALL_STATE(13068)] = 189552,
  [SMALL_STATE(13069)] = 189595,
  [SMALL_STATE(13070)] = 189658,
  [SMALL_STATE(13071)] = 189699,
  [SMALL_STATE(13072)] = 189778,
  [SMALL_STATE(13073)] = 189853,
  [SMALL_STATE(13074)] = 189904,
  [SMALL_STATE(13075)] = 189945,
  [SMALL_STATE(13076)] = 189988,
  [SMALL_STATE(13077)] = 190067,
  [SMALL_STATE(13078)] = 190108,
  [SMALL_STATE(13079)] = 190149,
  [SMALL_STATE(13080)] = 190210,
  [SMALL_STATE(13081)] = 190251,
  [SMALL_STATE(13082)] = 190326,
  [SMALL_STATE(13083)] = 190397,
  [SMALL_STATE(13084)] = 190464,
  [SMALL_STATE(13085)] = 190539,
  [SMALL_STATE(13086)] = 190580,
  [SMALL_STATE(13087)] = 190645,
  [SMALL_STATE(13088)] = 190688,
  [SMALL_STATE(13089)] = 190731,
  [SMALL_STATE(13090)] = 190788,
  [SMALL_STATE(13091)] = 190829,
  [SMALL_STATE(13092)] = 190870,
  [SMALL_STATE(13093)] = 190911,
  [SMALL_STATE(13094)] = 190972,
  [SMALL_STATE(13095)] = 191023,
  [SMALL_STATE(13096)] = 191064,
  [SMALL_STATE(13097)] = 191103,
  [SMALL_STATE(13098)] = 191152,
  [SMALL_STATE(13099)] = 191199,
  [SMALL_STATE(13100)] = 191240,
  [SMALL_STATE(13101)] = 191281,
  [SMALL_STATE(13102)] = 191344,
  [SMALL_STATE(13103)] = 191395,
  [SMALL_STATE(13104)] = 191456,
  [SMALL_STATE(13105)] = 191539,
  [SMALL_STATE(13106)] = 191614,
  [SMALL_STATE(13107)] = 191685,
  [SMALL_STATE(13108)] = 191764,
  [SMALL_STATE(13109)] = 191831,
  [SMALL_STATE(13110)] = 191896,
  [SMALL_STATE(13111)] = 191953,
  [SMALL_STATE(13112)] = 192016,
  [SMALL_STATE(13113)] = 192067,
  [SMALL_STATE(13114)] = 192108,
  [SMALL_STATE(13115)] = 192169,
  [SMALL_STATE(13116)] = 192220,
  [SMALL_STATE(13117)] = 192269,
  [SMALL_STATE(13118)] = 192316,
  [SMALL_STATE(13119)] = 192377,
  [SMALL_STATE(13120)] = 192422,
  [SMALL_STATE(13121)] = 192465,
  [SMALL_STATE(13122)] = 192540,
  [SMALL_STATE(13123)] = 192611,
  [SMALL_STATE(13124)] = 192686,
  [SMALL_STATE(13125)] = 192727,
  [SMALL_STATE(13126)] = 192790,
  [SMALL_STATE(13127)] = 192841,
  [SMALL_STATE(13128)] = 192902,
  [SMALL_STATE(13129)] = 192977,
  [SMALL_STATE(13130)] = 193048,
  [SMALL_STATE(13131)] = 193115,
  [SMALL_STATE(13132)] = 193194,
  [SMALL_STATE(13133)] = 193273,
  [SMALL_STATE(13134)] = 193352,
  [SMALL_STATE(13135)] = 193395,
  [SMALL_STATE(13136)] = 193438,
  [SMALL_STATE(13137)] = 193503,
  [SMALL_STATE(13138)] = 193560,
  [SMALL_STATE(13139)] = 193621,
  [SMALL_STATE(13140)] = 193672,
  [SMALL_STATE(13141)] = 193713,
  [SMALL_STATE(13142)] = 193754,
  [SMALL_STATE(13143)] = 193803,
  [SMALL_STATE(13144)] = 193850,
  [SMALL_STATE(13145)] = 193895,
  [SMALL_STATE(13146)] = 193936,
  [SMALL_STATE(13147)] = 193979,
  [SMALL_STATE(13148)] = 194020,
  [SMALL_STATE(13149)] = 194061,
  [SMALL_STATE(13150)] = 194100,
  [SMALL_STATE(13151)] = 194141,
  [SMALL_STATE(13152)] = 194216,
  [SMALL_STATE(13153)] = 194257,
  [SMALL_STATE(13154)] = 194298,
  [SMALL_STATE(13155)] = 194339,
  [SMALL_STATE(13156)] = 194406,
  [SMALL_STATE(13157)] = 194481,
  [SMALL_STATE(13158)] = 194520,
  [SMALL_STATE(13159)] = 194585,
  [SMALL_STATE(13160)] = 194642,
  [SMALL_STATE(13161)] = 194687,
  [SMALL_STATE(13162)] = 194762,
  [SMALL_STATE(13163)] = 194805,
  [SMALL_STATE(13164)] = 194846,
  [SMALL_STATE(13165)] = 194907,
  [SMALL_STATE(13166)] = 194958,
  [SMALL_STATE(13167)] = 195007,
  [SMALL_STATE(13168)] = 195086,
  [SMALL_STATE(13169)] = 195127,
  [SMALL_STATE(13170)] = 195174,
  [SMALL_STATE(13171)] = 195219,
  [SMALL_STATE(13172)] = 195262,
  [SMALL_STATE(13173)] = 195303,
  [SMALL_STATE(13174)] = 195344,
  [SMALL_STATE(13175)] = 195385,
  [SMALL_STATE(13176)] = 195464,
  [SMALL_STATE(13177)] = 195505,
  [SMALL_STATE(13178)] = 195545,
  [SMALL_STATE(13179)] = 195605,
  [SMALL_STATE(13180)] = 195645,
  [SMALL_STATE(13181)] = 195683,
  [SMALL_STATE(13182)] = 195757,
  [SMALL_STATE(13183)] = 195797,
  [SMALL_STATE(13184)] = 195875,
  [SMALL_STATE(13185)] = 195953,
  [SMALL_STATE(13186)] = 196027,
  [SMALL_STATE(13187)] = 196101,
  [SMALL_STATE(13188)] = 196171,
  [SMALL_STATE(13189)] = 196237,
  [SMALL_STATE(13190)] = 196301,
  [SMALL_STATE(13191)] = 196357,
  [SMALL_STATE(13192)] = 196417,
  [SMALL_STATE(13193)] = 196479,
  [SMALL_STATE(13194)] = 196523,
  [SMALL_STATE(13195)] = 196573,
  [SMALL_STATE(13196)] = 196633,
  [SMALL_STATE(13197)] = 196707,
  [SMALL_STATE(13198)] = 196781,
  [SMALL_STATE(13199)] = 196823,
  [SMALL_STATE(13200)] = 196873,
  [SMALL_STATE(13201)] = 196933,
  [SMALL_STATE(13202)] = 196973,
  [SMALL_STATE(13203)] = 197043,
  [SMALL_STATE(13204)] = 197109,
  [SMALL_STATE(13205)] = 197185,
  [SMALL_STATE(13206)] = 197249,
  [SMALL_STATE(13207)] = 197289,
  [SMALL_STATE(13208)] = 197351,
  [SMALL_STATE(13209)] = 197389,
  [SMALL_STATE(13210)] = 197445,
  [SMALL_STATE(13211)] = 197495,
  [SMALL_STATE(13212)] = 197555,
  [SMALL_STATE(13213)] = 197615,
  [SMALL_STATE(13214)] = 197655,
  [SMALL_STATE(13215)] = 197693,
  [SMALL_STATE(13216)] = 197743,
  [SMALL_STATE(13217)] = 197783,
  [SMALL_STATE(13218)] = 197823,
  [SMALL_STATE(13219)] = 197863,
  [SMALL_STATE(13220)] = 197901,
  [SMALL_STATE(13221)] = 197975,
  [SMALL_STATE(13222)] = 198053,
  [SMALL_STATE(13223)] = 198101,
  [SMALL_STATE(13224)] = 198139,
  [SMALL_STATE(13225)] = 198181,
  [SMALL_STATE(13226)] = 198223,
  [SMALL_STATE(13227)] = 198269,
  [SMALL_STATE(13228)] = 198313,
  [SMALL_STATE(13229)] = 198387,
  [SMALL_STATE(13230)] = 198427,
  [SMALL_STATE(13231)] = 198469,
  [SMALL_STATE(13232)] = 198543,
  [SMALL_STATE(13233)] = 198605,
  [SMALL_STATE(13234)] = 198679,
  [SMALL_STATE(13235)] = 198753,
  [SMALL_STATE(13236)] = 198793,
  [SMALL_STATE(13237)] = 198869,
  [SMALL_STATE(13238)] = 198907,
  [SMALL_STATE(13239)] = 198945,
  [SMALL_STATE(13240)] = 199019,
  [SMALL_STATE(13241)] = 199069,
  [SMALL_STATE(13242)] = 199129,
  [SMALL_STATE(13243)] = 199203,
  [SMALL_STATE(13244)] = 199245,
  [SMALL_STATE(13245)] = 199283,
  [SMALL_STATE(13246)] = 199353,
  [SMALL_STATE(13247)] = 199419,
  [SMALL_STATE(13248)] = 199483,
  [SMALL_STATE(13249)] = 199561,
  [SMALL_STATE(13250)] = 199635,
  [SMALL_STATE(13251)] = 199691,
  [SMALL_STATE(13252)] = 199731,
  [SMALL_STATE(13253)] = 199791,
  [SMALL_STATE(13254)] = 199841,
  [SMALL_STATE(13255)] = 199889,
  [SMALL_STATE(13256)] = 199929,
  [SMALL_STATE(13257)] = 200003,
  [SMALL_STATE(13258)] = 200079,
  [SMALL_STATE(13259)] = 200117,
  [SMALL_STATE(13260)] = 200195,
  [SMALL_STATE(13261)] = 200269,
  [SMALL_STATE(13262)] = 200315,
  [SMALL_STATE(13263)] = 200377,
  [SMALL_STATE(13264)] = 200421,
  [SMALL_STATE(13265)] = 200459,
  [SMALL_STATE(13266)] = 200505,
  [SMALL_STATE(13267)] = 200581,
  [SMALL_STATE(13268)] = 200623,
  [SMALL_STATE(13269)] = 200661,
  [SMALL_STATE(13270)] = 200731,
  [SMALL_STATE(13271)] = 200781,
  [SMALL_STATE(13272)] = 200841,
  [SMALL_STATE(13273)] = 200917,
  [SMALL_STATE(13274)] = 200983,
  [SMALL_STATE(13275)] = 201021,
  [SMALL_STATE(13276)] = 201095,
  [SMALL_STATE(13277)] = 201159,
  [SMALL_STATE(13278)] = 201215,
  [SMALL_STATE(13279)] = 201253,
  [SMALL_STATE(13280)] = 201323,
  [SMALL_STATE(13281)] = 201399,
  [SMALL_STATE(13282)] = 201441,
  [SMALL_STATE(13283)] = 201481,
  [SMALL_STATE(13284)] = 201547,
  [SMALL_STATE(13285)] = 201611,
  [SMALL_STATE(13286)] = 201667,
  [SMALL_STATE(13287)] = 201727,
  [SMALL_STATE(13288)] = 201799,
  [SMALL_STATE(13289)] = 201859,
  [SMALL_STATE(13290)] = 201909,
  [SMALL_STATE(13291)] = 201951,
  [SMALL_STATE(13292)] = 201993,
  [SMALL_STATE(13293)] = 202067,
  [SMALL_STATE(13294)] = 202115,
  [SMALL_STATE(13295)] = 202165,
  [SMALL_STATE(13296)] = 202205,
  [SMALL_STATE(13297)] = 202251,
  [SMALL_STATE(13298)] = 202295,
  [SMALL_STATE(13299)] = 202337,
  [SMALL_STATE(13300)] = 202377,
  [SMALL_STATE(13301)] = 202439,
  [SMALL_STATE(13302)] = 202487,
  [SMALL_STATE(13303)] = 202561,
  [SMALL_STATE(13304)] = 202607,
  [SMALL_STATE(13305)] = 202647,
  [SMALL_STATE(13306)] = 202687,
  [SMALL_STATE(13307)] = 202727,
  [SMALL_STATE(13308)] = 202771,
  [SMALL_STATE(13309)] = 202813,
  [SMALL_STATE(13310)] = 202851,
  [SMALL_STATE(13311)] = 202901,
  [SMALL_STATE(13312)] = 202979,
  [SMALL_STATE(13313)] = 203039,
  [SMALL_STATE(13314)] = 203079,
  [SMALL_STATE(13315)] = 203155,
  [SMALL_STATE(13316)] = 203229,
  [SMALL_STATE(13317)] = 203303,
  [SMALL_STATE(13318)] = 203341,
  [SMALL_STATE(13319)] = 203417,
  [SMALL_STATE(13320)] = 203455,
  [SMALL_STATE(13321)] = 203525,
  [SMALL_STATE(13322)] = 203601,
  [SMALL_STATE(13323)] = 203639,
  [SMALL_STATE(13324)] = 203715,
  [SMALL_STATE(13325)] = 203755,
  [SMALL_STATE(13326)] = 203795,
  [SMALL_STATE(13327)] = 203861,
  [SMALL_STATE(13328)] = 203925,
  [SMALL_STATE(13329)] = 203999,
  [SMALL_STATE(13330)] = 204061,
  [SMALL_STATE(13331)] = 204109,
  [SMALL_STATE(13332)] = 204165,
  [SMALL_STATE(13333)] = 204235,
  [SMALL_STATE(13334)] = 204273,
  [SMALL_STATE(13335)] = 204313,
  [SMALL_STATE(13336)] = 204351,
  [SMALL_STATE(13337)] = 204425,
  [SMALL_STATE(13338)] = 204485,
  [SMALL_STATE(13339)] = 204527,
  [SMALL_STATE(13340)] = 204577,
  [SMALL_STATE(13341)] = 204653,
  [SMALL_STATE(13342)] = 204701,
  [SMALL_STATE(13343)] = 204741,
  [SMALL_STATE(13344)] = 204781,
  [SMALL_STATE(13345)] = 204827,
  [SMALL_STATE(13346)] = 204905,
  [SMALL_STATE(13347)] = 204983,
  [SMALL_STATE(13348)] = 205027,
  [SMALL_STATE(13349)] = 205069,
  [SMALL_STATE(13350)] = 205135,
  [SMALL_STATE(13351)] = 205199,
  [SMALL_STATE(13352)] = 205255,
  [SMALL_STATE(13353)] = 205329,
  [SMALL_STATE(13354)] = 205389,
  [SMALL_STATE(13355)] = 205461,
  [SMALL_STATE(13356)] = 205503,
  [SMALL_STATE(13357)] = 205581,
  [SMALL_STATE(13358)] = 205659,
  [SMALL_STATE(13359)] = 205735,
  [SMALL_STATE(13360)] = 205809,
  [SMALL_STATE(13361)] = 205885,
  [SMALL_STATE(13362)] = 205959,
  [SMALL_STATE(13363)] = 206033,
  [SMALL_STATE(13364)] = 206083,
  [SMALL_STATE(13365)] = 206123,
  [SMALL_STATE(13366)] = 206161,
  [SMALL_STATE(13367)] = 206235,
  [SMALL_STATE(13368)] = 206275,
  [SMALL_STATE(13369)] = 206323,
  [SMALL_STATE(13370)] = 206363,
  [SMALL_STATE(13371)] = 206403,
  [SMALL_STATE(13372)] = 206443,
  [SMALL_STATE(13373)] = 206481,
  [SMALL_STATE(13374)] = 206519,
  [SMALL_STATE(13375)] = 206557,
  [SMALL_STATE(13376)] = 206635,
  [SMALL_STATE(13377)] = 206713,
  [SMALL_STATE(13378)] = 206791,
  [SMALL_STATE(13379)] = 206869,
  [SMALL_STATE(13380)] = 206947,
  [SMALL_STATE(13381)] = 207025,
  [SMALL_STATE(13382)] = 207065,
  [SMALL_STATE(13383)] = 207127,
  [SMALL_STATE(13384)] = 207175,
  [SMALL_STATE(13385)] = 207233,
  [SMALL_STATE(13386)] = 207307,
  [SMALL_STATE(13387)] = 207377,
  [SMALL_STATE(13388)] = 207443,
  [SMALL_STATE(13389)] = 207507,
  [SMALL_STATE(13390)] = 207561,
  [SMALL_STATE(13391)] = 207619,
  [SMALL_STATE(13392)] = 207667,
  [SMALL_STATE(13393)] = 207713,
  [SMALL_STATE(13394)] = 207757,
  [SMALL_STATE(13395)] = 207799,
  [SMALL_STATE(13396)] = 207839,
  [SMALL_STATE(13397)] = 207897,
  [SMALL_STATE(13398)] = 207937,
  [SMALL_STATE(13399)] = 207987,
  [SMALL_STATE(13400)] = 208037,
  [SMALL_STATE(13401)] = 208085,
  [SMALL_STATE(13402)] = 208131,
  [SMALL_STATE(13403)] = 208175,
  [SMALL_STATE(13404)] = 208217,
  [SMALL_STATE(13405)] = 208291,
  [SMALL_STATE(13406)] = 208329,
  [SMALL_STATE(13407)] = 208403,
  [SMALL_STATE(13408)] = 208473,
  [SMALL_STATE(13409)] = 208539,
  [SMALL_STATE(13410)] = 208579,
  [SMALL_STATE(13411)] = 208619,
  [SMALL_STATE(13412)] = 208659,
  [SMALL_STATE(13413)] = 208737,
  [SMALL_STATE(13414)] = 208775,
  [SMALL_STATE(13415)] = 208813,
  [SMALL_STATE(13416)] = 208853,
  [SMALL_STATE(13417)] = 208931,
  [SMALL_STATE(13418)] = 208971,
  [SMALL_STATE(13419)] = 209049,
  [SMALL_STATE(13420)] = 209089,
  [SMALL_STATE(13421)] = 209153,
  [SMALL_STATE(13422)] = 209231,
  [SMALL_STATE(13423)] = 209305,
  [SMALL_STATE(13424)] = 209359,
  [SMALL_STATE(13425)] = 209417,
  [SMALL_STATE(13426)] = 209465,
  [SMALL_STATE(13427)] = 209511,
  [SMALL_STATE(13428)] = 209555,
  [SMALL_STATE(13429)] = 209597,
  [SMALL_STATE(13430)] = 209639,
  [SMALL_STATE(13431)] = 209679,
  [SMALL_STATE(13432)] = 209725,
  [SMALL_STATE(13433)] = 209763,
  [SMALL_STATE(13434)] = 209801,
  [SMALL_STATE(13435)] = 209839,
  [SMALL_STATE(13436)] = 209901,
  [SMALL_STATE(13437)] = 209963,
  [SMALL_STATE(13438)] = 210020,
  [SMALL_STATE(13439)] = 210057,
  [SMALL_STATE(13440)] = 210104,
  [SMALL_STATE(13441)] = 210165,
  [SMALL_STATE(13442)] = 210202,
  [SMALL_STATE(13443)] = 210275,
  [SMALL_STATE(13444)] = 210312,
  [SMALL_STATE(13445)] = 210359,
  [SMALL_STATE(13446)] = 210408,
  [SMALL_STATE(13447)] = 210453,
  [SMALL_STATE(13448)] = 210496,
  [SMALL_STATE(13449)] = 210555,
  [SMALL_STATE(13450)] = 210596,
  [SMALL_STATE(13451)] = 210635,
  [SMALL_STATE(13452)] = 210708,
  [SMALL_STATE(13453)] = 210777,
  [SMALL_STATE(13454)] = 210842,
  [SMALL_STATE(13455)] = 210905,
  [SMALL_STATE(13456)] = 210960,
  [SMALL_STATE(13457)] = 211019,
  [SMALL_STATE(13458)] = 211056,
  [SMALL_STATE(13459)] = 211105,
  [SMALL_STATE(13460)] = 211152,
  [SMALL_STATE(13461)] = 211197,
  [SMALL_STATE(13462)] = 211270,
  [SMALL_STATE(13463)] = 211309,
  [SMALL_STATE(13464)] = 211352,
  [SMALL_STATE(13465)] = 211393,
  [SMALL_STATE(13466)] = 211434,
  [SMALL_STATE(13467)] = 211489,
  [SMALL_STATE(13468)] = 211562,
  [SMALL_STATE(13469)] = 211621,
  [SMALL_STATE(13470)] = 211670,
  [SMALL_STATE(13471)] = 211709,
  [SMALL_STATE(13472)] = 211746,
  [SMALL_STATE(13473)] = 211785,
  [SMALL_STATE(13474)] = 211822,
  [SMALL_STATE(13475)] = 211863,
  [SMALL_STATE(13476)] = 211910,
  [SMALL_STATE(13477)] = 211947,
  [SMALL_STATE(13478)] = 212020,
  [SMALL_STATE(13479)] = 212093,
  [SMALL_STATE(13480)] = 212168,
  [SMALL_STATE(13481)] = 212209,
  [SMALL_STATE(13482)] = 212268,
  [SMALL_STATE(13483)] = 212343,
  [SMALL_STATE(13484)] = 212416,
  [SMALL_STATE(13485)] = 212463,
  [SMALL_STATE(13486)] = 212502,
  [SMALL_STATE(13487)] = 212541,
  [SMALL_STATE(13488)] = 212602,
  [SMALL_STATE(13489)] = 212639,
  [SMALL_STATE(13490)] = 212686,
  [SMALL_STATE(13491)] = 212743,
  [SMALL_STATE(13492)] = 212816,
  [SMALL_STATE(13493)] = 212891,
  [SMALL_STATE(13494)] = 212960,
  [SMALL_STATE(13495)] = 213025,
  [SMALL_STATE(13496)] = 213088,
  [SMALL_STATE(13497)] = 213125,
  [SMALL_STATE(13498)] = 213162,
  [SMALL_STATE(13499)] = 213199,
  [SMALL_STATE(13500)] = 213238,
  [SMALL_STATE(13501)] = 213295,
  [SMALL_STATE(13502)] = 213366,
  [SMALL_STATE(13503)] = 213433,
  [SMALL_STATE(13504)] = 213486,
  [SMALL_STATE(13505)] = 213561,
  [SMALL_STATE(13506)] = 213636,
  [SMALL_STATE(13507)] = 213711,
  [SMALL_STATE(13508)] = 213748,
  [SMALL_STATE(13509)] = 213785,
  [SMALL_STATE(13510)] = 213842,
  [SMALL_STATE(13511)] = 213879,
  [SMALL_STATE(13512)] = 213926,
  [SMALL_STATE(13513)] = 213985,
  [SMALL_STATE(13514)] = 214042,
  [SMALL_STATE(13515)] = 214113,
  [SMALL_STATE(13516)] = 214150,
  [SMALL_STATE(13517)] = 214189,
  [SMALL_STATE(13518)] = 214234,
  [SMALL_STATE(13519)] = 214275,
  [SMALL_STATE(13520)] = 214318,
  [SMALL_STATE(13521)] = 214389,
  [SMALL_STATE(13522)] = 214452,
  [SMALL_STATE(13523)] = 214513,
  [SMALL_STATE(13524)] = 214566,
  [SMALL_STATE(13525)] = 214641,
  [SMALL_STATE(13526)] = 214678,
  [SMALL_STATE(13527)] = 214745,
  [SMALL_STATE(13528)] = 214808,
  [SMALL_STATE(13529)] = 214853,
  [SMALL_STATE(13530)] = 214896,
  [SMALL_STATE(13531)] = 214937,
  [SMALL_STATE(13532)] = 214976,
  [SMALL_STATE(13533)] = 215037,
  [SMALL_STATE(13534)] = 215084,
  [SMALL_STATE(13535)] = 215145,
  [SMALL_STATE(13536)] = 215198,
  [SMALL_STATE(13537)] = 215239,
  [SMALL_STATE(13538)] = 215296,
  [SMALL_STATE(13539)] = 215341,
  [SMALL_STATE(13540)] = 215380,
  [SMALL_STATE(13541)] = 215419,
  [SMALL_STATE(13542)] = 215458,
  [SMALL_STATE(13543)] = 215501,
  [SMALL_STATE(13544)] = 215542,
  [SMALL_STATE(13545)] = 215613,
  [SMALL_STATE(13546)] = 215670,
  [SMALL_STATE(13547)] = 215741,
  [SMALL_STATE(13548)] = 215816,
  [SMALL_STATE(13549)] = 215855,
  [SMALL_STATE(13550)] = 215894,
  [SMALL_STATE(13551)] = 215969,
  [SMALL_STATE(13552)] = 216006,
  [SMALL_STATE(13553)] = 216043,
  [SMALL_STATE(13554)] = 216114,
  [SMALL_STATE(13555)] = 216157,
  [SMALL_STATE(13556)] = 216218,
  [SMALL_STATE(13557)] = 216265,
  [SMALL_STATE(13558)] = 216322,
  [SMALL_STATE(13559)] = 216395,
  [SMALL_STATE(13560)] = 216464,
  [SMALL_STATE(13561)] = 216529,
  [SMALL_STATE(13562)] = 216592,
  [SMALL_STATE(13563)] = 216645,
  [SMALL_STATE(13564)] = 216702,
  [SMALL_STATE(13565)] = 216749,
  [SMALL_STATE(13566)] = 216794,
  [SMALL_STATE(13567)] = 216837,
  [SMALL_STATE(13568)] = 216878,
  [SMALL_STATE(13569)] = 216917,
  [SMALL_STATE(13570)] = 216978,
  [SMALL_STATE(13571)] = 217051,
  [SMALL_STATE(13572)] = 217100,
  [SMALL_STATE(13573)] = 217171,
  [SMALL_STATE(13574)] = 217244,
  [SMALL_STATE(13575)] = 217303,
  [SMALL_STATE(13576)] = 217376,
  [SMALL_STATE(13577)] = 217449,
  [SMALL_STATE(13578)] = 217518,
  [SMALL_STATE(13579)] = 217561,
  [SMALL_STATE(13580)] = 217598,
  [SMALL_STATE(13581)] = 217637,
  [SMALL_STATE(13582)] = 217674,
  [SMALL_STATE(13583)] = 217749,
  [SMALL_STATE(13584)] = 217786,
  [SMALL_STATE(13585)] = 217861,
  [SMALL_STATE(13586)] = 217934,
  [SMALL_STATE(13587)] = 218003,
  [SMALL_STATE(13588)] = 218068,
  [SMALL_STATE(13589)] = 218131,
  [SMALL_STATE(13590)] = 218168,
  [SMALL_STATE(13591)] = 218243,
  [SMALL_STATE(13592)] = 218296,
  [SMALL_STATE(13593)] = 218333,
  [SMALL_STATE(13594)] = 218390,
  [SMALL_STATE(13595)] = 218437,
  [SMALL_STATE(13596)] = 218482,
  [SMALL_STATE(13597)] = 218521,
  [SMALL_STATE(13598)] = 218586,
  [SMALL_STATE(13599)] = 218623,
  [SMALL_STATE(13600)] = 218696,
  [SMALL_STATE(13601)] = 218759,
  [SMALL_STATE(13602)] = 218834,
  [SMALL_STATE(13603)] = 218881,
  [SMALL_STATE(13604)] = 218955,
  [SMALL_STATE(13605)] = 218993,
  [SMALL_STATE(13606)] = 219067,
  [SMALL_STATE(13607)] = 219105,
  [SMALL_STATE(13608)] = 219143,
  [SMALL_STATE(13609)] = 219217,
  [SMALL_STATE(13610)] = 219291,
  [SMALL_STATE(13611)] = 219361,
  [SMALL_STATE(13612)] = 219435,
  [SMALL_STATE(13613)] = 219473,
  [SMALL_STATE(13614)] = 219547,
  [SMALL_STATE(13615)] = 219585,
  [SMALL_STATE(13616)] = 219659,
  [SMALL_STATE(13617)] = 219699,
  [SMALL_STATE(13618)] = 219773,
  [SMALL_STATE(13619)] = 219847,
  [SMALL_STATE(13620)] = 219921,
  [SMALL_STATE(13621)] = 219959,
  [SMALL_STATE(13622)] = 219997,
  [SMALL_STATE(13623)] = 220035,
  [SMALL_STATE(13624)] = 220109,
  [SMALL_STATE(13625)] = 220147,
  [SMALL_STATE(13626)] = 220221,
  [SMALL_STATE(13627)] = 220295,
  [SMALL_STATE(13628)] = 220369,
  [SMALL_STATE(13629)] = 220443,
  [SMALL_STATE(13630)] = 220517,
  [SMALL_STATE(13631)] = 220555,
  [SMALL_STATE(13632)] = 220593,
  [SMALL_STATE(13633)] = 220631,
  [SMALL_STATE(13634)] = 220669,
  [SMALL_STATE(13635)] = 220743,
  [SMALL_STATE(13636)] = 220817,
  [SMALL_STATE(13637)] = 220891,
  [SMALL_STATE(13638)] = 220965,
  [SMALL_STATE(13639)] = 221003,
  [SMALL_STATE(13640)] = 221041,
  [SMALL_STATE(13641)] = 221115,
  [SMALL_STATE(13642)] = 221153,
  [SMALL_STATE(13643)] = 221191,
  [SMALL_STATE(13644)] = 221265,
  [SMALL_STATE(13645)] = 221339,
  [SMALL_STATE(13646)] = 221413,
  [SMALL_STATE(13647)] = 221451,
  [SMALL_STATE(13648)] = 221525,
  [SMALL_STATE(13649)] = 221599,
  [SMALL_STATE(13650)] = 221673,
  [SMALL_STATE(13651)] = 221747,
  [SMALL_STATE(13652)] = 221783,
  [SMALL_STATE(13653)] = 221857,
  [SMALL_STATE(13654)] = 221931,
  [SMALL_STATE(13655)] = 222005,
  [SMALL_STATE(13656)] = 222079,
  [SMALL_STATE(13657)] = 222153,
  [SMALL_STATE(13658)] = 222211,
  [SMALL_STATE(13659)] = 222249,
  [SMALL_STATE(13660)] = 222323,
  [SMALL_STATE(13661)] = 222369,
  [SMALL_STATE(13662)] = 222443,
  [SMALL_STATE(13663)] = 222499,
  [SMALL_STATE(13664)] = 222573,
  [SMALL_STATE(13665)] = 222611,
  [SMALL_STATE(13666)] = 222649,
  [SMALL_STATE(13667)] = 222723,
  [SMALL_STATE(13668)] = 222797,
  [SMALL_STATE(13669)] = 222867,
  [SMALL_STATE(13670)] = 222933,
  [SMALL_STATE(13671)] = 223003,
  [SMALL_STATE(13672)] = 223041,
  [SMALL_STATE(13673)] = 223099,
  [SMALL_STATE(13674)] = 223171,
  [SMALL_STATE(13675)] = 223245,
  [SMALL_STATE(13676)] = 223319,
  [SMALL_STATE(13677)] = 223357,
  [SMALL_STATE(13678)] = 223403,
  [SMALL_STATE(13679)] = 223441,
  [SMALL_STATE(13680)] = 223497,
  [SMALL_STATE(13681)] = 223559,
  [SMALL_STATE(13682)] = 223633,
  [SMALL_STATE(13683)] = 223703,
  [SMALL_STATE(13684)] = 223769,
  [SMALL_STATE(13685)] = 223843,
  [SMALL_STATE(13686)] = 223905,
  [SMALL_STATE(13687)] = 223965,
  [SMALL_STATE(13688)] = 224017,
  [SMALL_STATE(13689)] = 224073,
  [SMALL_STATE(13690)] = 224119,
  [SMALL_STATE(13691)] = 224189,
  [SMALL_STATE(13692)] = 224249,
  [SMALL_STATE(13693)] = 224293,
  [SMALL_STATE(13694)] = 224345,
  [SMALL_STATE(13695)] = 224387,
  [SMALL_STATE(13696)] = 224427,
  [SMALL_STATE(13697)] = 224465,
  [SMALL_STATE(13698)] = 224539,
  [SMALL_STATE(13699)] = 224613,
  [SMALL_STATE(13700)] = 224687,
  [SMALL_STATE(13701)] = 224761,
  [SMALL_STATE(13702)] = 224831,
  [SMALL_STATE(13703)] = 224905,
  [SMALL_STATE(13704)] = 224979,
  [SMALL_STATE(13705)] = 225035,
  [SMALL_STATE(13706)] = 225109,
  [SMALL_STATE(13707)] = 225183,
  [SMALL_STATE(13708)] = 225229,
  [SMALL_STATE(13709)] = 225303,
  [SMALL_STATE(13710)] = 225341,
  [SMALL_STATE(13711)] = 225379,
  [SMALL_STATE(13712)] = 225423,
  [SMALL_STATE(13713)] = 225497,
  [SMALL_STATE(13714)] = 225571,
  [SMALL_STATE(13715)] = 225613,
  [SMALL_STATE(13716)] = 225653,
  [SMALL_STATE(13717)] = 225691,
  [SMALL_STATE(13718)] = 225729,
  [SMALL_STATE(13719)] = 225803,
  [SMALL_STATE(13720)] = 225841,
  [SMALL_STATE(13721)] = 225879,
  [SMALL_STATE(13722)] = 225953,
  [SMALL_STATE(13723)] = 225993,
  [SMALL_STATE(13724)] = 226067,
  [SMALL_STATE(13725)] = 226141,
  [SMALL_STATE(13726)] = 226179,
  [SMALL_STATE(13727)] = 226253,
  [SMALL_STATE(13728)] = 226327,
  [SMALL_STATE(13729)] = 226401,
  [SMALL_STATE(13730)] = 226475,
  [SMALL_STATE(13731)] = 226549,
  [SMALL_STATE(13732)] = 226623,
  [SMALL_STATE(13733)] = 226661,
  [SMALL_STATE(13734)] = 226699,
  [SMALL_STATE(13735)] = 226773,
  [SMALL_STATE(13736)] = 226847,
  [SMALL_STATE(13737)] = 226885,
  [SMALL_STATE(13738)] = 226959,
  [SMALL_STATE(13739)] = 226997,
  [SMALL_STATE(13740)] = 227037,
  [SMALL_STATE(13741)] = 227073,
  [SMALL_STATE(13742)] = 227111,
  [SMALL_STATE(13743)] = 227185,
  [SMALL_STATE(13744)] = 227259,
  [SMALL_STATE(13745)] = 227333,
  [SMALL_STATE(13746)] = 227371,
  [SMALL_STATE(13747)] = 227445,
  [SMALL_STATE(13748)] = 227485,
  [SMALL_STATE(13749)] = 227559,
  [SMALL_STATE(13750)] = 227633,
  [SMALL_STATE(13751)] = 227705,
  [SMALL_STATE(13752)] = 227743,
  [SMALL_STATE(13753)] = 227817,
  [SMALL_STATE(13754)] = 227855,
  [SMALL_STATE(13755)] = 227893,
  [SMALL_STATE(13756)] = 227967,
  [SMALL_STATE(13757)] = 228041,
  [SMALL_STATE(13758)] = 228115,
  [SMALL_STATE(13759)] = 228151,
  [SMALL_STATE(13760)] = 228187,
  [SMALL_STATE(13761)] = 228223,
  [SMALL_STATE(13762)] = 228261,
  [SMALL_STATE(13763)] = 228335,
  [SMALL_STATE(13764)] = 228373,
  [SMALL_STATE(13765)] = 228411,
  [SMALL_STATE(13766)] = 228485,
  [SMALL_STATE(13767)] = 228559,
  [SMALL_STATE(13768)] = 228633,
  [SMALL_STATE(13769)] = 228707,
  [SMALL_STATE(13770)] = 228781,
  [SMALL_STATE(13771)] = 228855,
  [SMALL_STATE(13772)] = 228891,
  [SMALL_STATE(13773)] = 228961,
  [SMALL_STATE(13774)] = 228997,
  [SMALL_STATE(13775)] = 229033,
  [SMALL_STATE(13776)] = 229069,
  [SMALL_STATE(13777)] = 229141,
  [SMALL_STATE(13778)] = 229215,
  [SMALL_STATE(13779)] = 229253,
  [SMALL_STATE(13780)] = 229291,
  [SMALL_STATE(13781)] = 229365,
  [SMALL_STATE(13782)] = 229401,
  [SMALL_STATE(13783)] = 229475,
  [SMALL_STATE(13784)] = 229513,
  [SMALL_STATE(13785)] = 229587,
  [SMALL_STATE(13786)] = 229625,
  [SMALL_STATE(13787)] = 229699,
  [SMALL_STATE(13788)] = 229737,
  [SMALL_STATE(13789)] = 229811,
  [SMALL_STATE(13790)] = 229885,
  [SMALL_STATE(13791)] = 229931,
  [SMALL_STATE(13792)] = 229977,
  [SMALL_STATE(13793)] = 230021,
  [SMALL_STATE(13794)] = 230063,
  [SMALL_STATE(13795)] = 230103,
  [SMALL_STATE(13796)] = 230141,
  [SMALL_STATE(13797)] = 230179,
  [SMALL_STATE(13798)] = 230253,
  [SMALL_STATE(13799)] = 230291,
  [SMALL_STATE(13800)] = 230329,
  [SMALL_STATE(13801)] = 230403,
  [SMALL_STATE(13802)] = 230477,
  [SMALL_STATE(13803)] = 230551,
  [SMALL_STATE(13804)] = 230625,
  [SMALL_STATE(13805)] = 230699,
  [SMALL_STATE(13806)] = 230737,
  [SMALL_STATE(13807)] = 230811,
  [SMALL_STATE(13808)] = 230847,
  [SMALL_STATE(13809)] = 230885,
  [SMALL_STATE(13810)] = 230923,
  [SMALL_STATE(13811)] = 230997,
  [SMALL_STATE(13812)] = 231035,
  [SMALL_STATE(13813)] = 231073,
  [SMALL_STATE(13814)] = 231145,
  [SMALL_STATE(13815)] = 231219,
  [SMALL_STATE(13816)] = 231293,
  [SMALL_STATE(13817)] = 231367,
  [SMALL_STATE(13818)] = 231405,
  [SMALL_STATE(13819)] = 231443,
  [SMALL_STATE(13820)] = 231517,
  [SMALL_STATE(13821)] = 231555,
  [SMALL_STATE(13822)] = 231625,
  [SMALL_STATE(13823)] = 231699,
  [SMALL_STATE(13824)] = 231773,
  [SMALL_STATE(13825)] = 231847,
  [SMALL_STATE(13826)] = 231921,
  [SMALL_STATE(13827)] = 231995,
  [SMALL_STATE(13828)] = 232069,
  [SMALL_STATE(13829)] = 232143,
  [SMALL_STATE(13830)] = 232183,
  [SMALL_STATE(13831)] = 232257,
  [SMALL_STATE(13832)] = 232331,
  [SMALL_STATE(13833)] = 232405,
  [SMALL_STATE(13834)] = 232445,
  [SMALL_STATE(13835)] = 232519,
  [SMALL_STATE(13836)] = 232593,
  [SMALL_STATE(13837)] = 232667,
  [SMALL_STATE(13838)] = 232741,
  [SMALL_STATE(13839)] = 232815,
  [SMALL_STATE(13840)] = 232853,
  [SMALL_STATE(13841)] = 232927,
  [SMALL_STATE(13842)] = 233001,
  [SMALL_STATE(13843)] = 233039,
  [SMALL_STATE(13844)] = 233113,
  [SMALL_STATE(13845)] = 233187,
  [SMALL_STATE(13846)] = 233225,
  [SMALL_STATE(13847)] = 233299,
  [SMALL_STATE(13848)] = 233337,
  [SMALL_STATE(13849)] = 233375,
  [SMALL_STATE(13850)] = 233449,
  [SMALL_STATE(13851)] = 233487,
  [SMALL_STATE(13852)] = 233525,
  [SMALL_STATE(13853)] = 233599,
  [SMALL_STATE(13854)] = 233673,
  [SMALL_STATE(13855)] = 233747,
  [SMALL_STATE(13856)] = 233821,
  [SMALL_STATE(13857)] = 233895,
  [SMALL_STATE(13858)] = 233969,
  [SMALL_STATE(13859)] = 234007,
  [SMALL_STATE(13860)] = 234045,
  [SMALL_STATE(13861)] = 234119,
  [SMALL_STATE(13862)] = 234193,
  [SMALL_STATE(13863)] = 234267,
  [SMALL_STATE(13864)] = 234341,
  [SMALL_STATE(13865)] = 234415,
  [SMALL_STATE(13866)] = 234489,
  [SMALL_STATE(13867)] = 234527,
  [SMALL_STATE(13868)] = 234601,
  [SMALL_STATE(13869)] = 234675,
  [SMALL_STATE(13870)] = 234713,
  [SMALL_STATE(13871)] = 234787,
  [SMALL_STATE(13872)] = 234857,
  [SMALL_STATE(13873)] = 234931,
  [SMALL_STATE(13874)] = 235005,
  [SMALL_STATE(13875)] = 235079,
  [SMALL_STATE(13876)] = 235153,
  [SMALL_STATE(13877)] = 235191,
  [SMALL_STATE(13878)] = 235229,
  [SMALL_STATE(13879)] = 235303,
  [SMALL_STATE(13880)] = 235377,
  [SMALL_STATE(13881)] = 235415,
  [SMALL_STATE(13882)] = 235485,
  [SMALL_STATE(13883)] = 235559,
  [SMALL_STATE(13884)] = 235633,
  [SMALL_STATE(13885)] = 235671,
  [SMALL_STATE(13886)] = 235745,
  [SMALL_STATE(13887)] = 235783,
  [SMALL_STATE(13888)] = 235821,
  [SMALL_STATE(13889)] = 235859,
  [SMALL_STATE(13890)] = 235933,
  [SMALL_STATE(13891)] = 236007,
  [SMALL_STATE(13892)] = 236081,
  [SMALL_STATE(13893)] = 236119,
  [SMALL_STATE(13894)] = 236193,
  [SMALL_STATE(13895)] = 236267,
  [SMALL_STATE(13896)] = 236305,
  [SMALL_STATE(13897)] = 236379,
  [SMALL_STATE(13898)] = 236453,
  [SMALL_STATE(13899)] = 236527,
  [SMALL_STATE(13900)] = 236601,
  [SMALL_STATE(13901)] = 236675,
  [SMALL_STATE(13902)] = 236749,
  [SMALL_STATE(13903)] = 236823,
  [SMALL_STATE(13904)] = 236893,
  [SMALL_STATE(13905)] = 236967,
  [SMALL_STATE(13906)] = 237005,
  [SMALL_STATE(13907)] = 237079,
  [SMALL_STATE(13908)] = 237117,
  [SMALL_STATE(13909)] = 237191,
  [SMALL_STATE(13910)] = 237265,
  [SMALL_STATE(13911)] = 237339,
  [SMALL_STATE(13912)] = 237413,
  [SMALL_STATE(13913)] = 237451,
  [SMALL_STATE(13914)] = 237525,
  [SMALL_STATE(13915)] = 237599,
  [SMALL_STATE(13916)] = 237669,
  [SMALL_STATE(13917)] = 237743,
  [SMALL_STATE(13918)] = 237817,
  [SMALL_STATE(13919)] = 237891,
  [SMALL_STATE(13920)] = 237965,
  [SMALL_STATE(13921)] = 238039,
  [SMALL_STATE(13922)] = 238113,
  [SMALL_STATE(13923)] = 238187,
  [SMALL_STATE(13924)] = 238261,
  [SMALL_STATE(13925)] = 238335,
  [SMALL_STATE(13926)] = 238409,
  [SMALL_STATE(13927)] = 238483,
  [SMALL_STATE(13928)] = 238521,
  [SMALL_STATE(13929)] = 238595,
  [SMALL_STATE(13930)] = 238633,
  [SMALL_STATE(13931)] = 238707,
  [SMALL_STATE(13932)] = 238781,
  [SMALL_STATE(13933)] = 238819,
  [SMALL_STATE(13934)] = 238893,
  [SMALL_STATE(13935)] = 238967,
  [SMALL_STATE(13936)] = 239027,
  [SMALL_STATE(13937)] = 239101,
  [SMALL_STATE(13938)] = 239147,
  [SMALL_STATE(13939)] = 239185,
  [SMALL_STATE(13940)] = 239241,
  [SMALL_STATE(13941)] = 239279,
  [SMALL_STATE(13942)] = 239351,
  [SMALL_STATE(13943)] = 239419,
  [SMALL_STATE(13944)] = 239493,
  [SMALL_STATE(13945)] = 239567,
  [SMALL_STATE(13946)] = 239631,
  [SMALL_STATE(13947)] = 239693,
  [SMALL_STATE(13948)] = 239745,
  [SMALL_STATE(13949)] = 239801,
  [SMALL_STATE(13950)] = 239875,
  [SMALL_STATE(13951)] = 239921,
  [SMALL_STATE(13952)] = 239995,
  [SMALL_STATE(13953)] = 240039,
  [SMALL_STATE(13954)] = 240081,
  [SMALL_STATE(13955)] = 240155,
  [SMALL_STATE(13956)] = 240195,
  [SMALL_STATE(13957)] = 240269,
  [SMALL_STATE(13958)] = 240307,
  [SMALL_STATE(13959)] = 240381,
  [SMALL_STATE(13960)] = 240419,
  [SMALL_STATE(13961)] = 240457,
  [SMALL_STATE(13962)] = 240531,
  [SMALL_STATE(13963)] = 240605,
  [SMALL_STATE(13964)] = 240679,
  [SMALL_STATE(13965)] = 240753,
  [SMALL_STATE(13966)] = 240825,
  [SMALL_STATE(13967)] = 240863,
  [SMALL_STATE(13968)] = 240937,
  [SMALL_STATE(13969)] = 241011,
  [SMALL_STATE(13970)] = 241085,
  [SMALL_STATE(13971)] = 241159,
  [SMALL_STATE(13972)] = 241233,
  [SMALL_STATE(13973)] = 241271,
  [SMALL_STATE(13974)] = 241309,
  [SMALL_STATE(13975)] = 241383,
  [SMALL_STATE(13976)] = 241457,
  [SMALL_STATE(13977)] = 241495,
  [SMALL_STATE(13978)] = 241569,
  [SMALL_STATE(13979)] = 241643,
  [SMALL_STATE(13980)] = 241717,
  [SMALL_STATE(13981)] = 241791,
  [SMALL_STATE(13982)] = 241865,
  [SMALL_STATE(13983)] = 241903,
  [SMALL_STATE(13984)] = 241941,
  [SMALL_STATE(13985)] = 242015,
  [SMALL_STATE(13986)] = 242073,
  [SMALL_STATE(13987)] = 242129,
  [SMALL_STATE(13988)] = 242199,
  [SMALL_STATE(13989)] = 242265,
  [SMALL_STATE(13990)] = 242327,
  [SMALL_STATE(13991)] = 242387,
  [SMALL_STATE(13992)] = 242439,
  [SMALL_STATE(13993)] = 242495,
  [SMALL_STATE(13994)] = 242533,
  [SMALL_STATE(13995)] = 242576,
  [SMALL_STATE(13996)] = 242619,
  [SMALL_STATE(13997)] = 242656,
  [SMALL_STATE(13998)] = 242699,
  [SMALL_STATE(13999)] = 242734,
  [SMALL_STATE(14000)] = 242771,
  [SMALL_STATE(14001)] = 242806,
  [SMALL_STATE(14002)] = 242841,
  [SMALL_STATE(14003)] = 242884,
  [SMALL_STATE(14004)] = 242927,
  [SMALL_STATE(14005)] = 242962,
  [SMALL_STATE(14006)] = 243005,
  [SMALL_STATE(14007)] = 243048,
  [SMALL_STATE(14008)] = 243083,
  [SMALL_STATE(14009)] = 243126,
  [SMALL_STATE(14010)] = 243161,
  [SMALL_STATE(14011)] = 243204,
  [SMALL_STATE(14012)] = 243247,
  [SMALL_STATE(14013)] = 243290,
  [SMALL_STATE(14014)] = 243325,
  [SMALL_STATE(14015)] = 243368,
  [SMALL_STATE(14016)] = 243403,
  [SMALL_STATE(14017)] = 243446,
  [SMALL_STATE(14018)] = 243481,
  [SMALL_STATE(14019)] = 243516,
  [SMALL_STATE(14020)] = 243559,
  [SMALL_STATE(14021)] = 243594,
  [SMALL_STATE(14022)] = 243629,
  [SMALL_STATE(14023)] = 243672,
  [SMALL_STATE(14024)] = 243715,
  [SMALL_STATE(14025)] = 243758,
  [SMALL_STATE(14026)] = 243793,
  [SMALL_STATE(14027)] = 243836,
  [SMALL_STATE(14028)] = 243879,
  [SMALL_STATE(14029)] = 243922,
  [SMALL_STATE(14030)] = 243965,
  [SMALL_STATE(14031)] = 244008,
  [SMALL_STATE(14032)] = 244051,
  [SMALL_STATE(14033)] = 244086,
  [SMALL_STATE(14034)] = 244121,
  [SMALL_STATE(14035)] = 244164,
  [SMALL_STATE(14036)] = 244207,
  [SMALL_STATE(14037)] = 244250,
  [SMALL_STATE(14038)] = 244293,
  [SMALL_STATE(14039)] = 244336,
  [SMALL_STATE(14040)] = 244379,
  [SMALL_STATE(14041)] = 244422,
  [SMALL_STATE(14042)] = 244465,
  [SMALL_STATE(14043)] = 244508,
  [SMALL_STATE(14044)] = 244551,
  [SMALL_STATE(14045)] = 244594,
  [SMALL_STATE(14046)] = 244629,
  [SMALL_STATE(14047)] = 244688,
  [SMALL_STATE(14048)] = 244733,
  [SMALL_STATE(14049)] = 244788,
  [SMALL_STATE(14050)] = 244859,
  [SMALL_STATE(14051)] = 244926,
  [SMALL_STATE(14052)] = 244989,
  [SMALL_STATE(14053)] = 245050,
  [SMALL_STATE(14054)] = 245093,
  [SMALL_STATE(14055)] = 245144,
  [SMALL_STATE(14056)] = 245199,
  [SMALL_STATE(14057)] = 245242,
  [SMALL_STATE(14058)] = 245287,
  [SMALL_STATE(14059)] = 245330,
  [SMALL_STATE(14060)] = 245373,
  [SMALL_STATE(14061)] = 245414,
  [SMALL_STATE(14062)] = 245453,
  [SMALL_STATE(14063)] = 245490,
  [SMALL_STATE(14064)] = 245525,
  [SMALL_STATE(14065)] = 245560,
  [SMALL_STATE(14066)] = 245595,
  [SMALL_STATE(14067)] = 245630,
  [SMALL_STATE(14068)] = 245665,
  [SMALL_STATE(14069)] = 245708,
  [SMALL_STATE(14070)] = 245743,
  [SMALL_STATE(14071)] = 245786,
  [SMALL_STATE(14072)] = 245821,
  [SMALL_STATE(14073)] = 245856,
  [SMALL_STATE(14074)] = 245891,
  [SMALL_STATE(14075)] = 245934,
  [SMALL_STATE(14076)] = 245969,
  [SMALL_STATE(14077)] = 246004,
  [SMALL_STATE(14078)] = 246039,
  [SMALL_STATE(14079)] = 246082,
  [SMALL_STATE(14080)] = 246125,
  [SMALL_STATE(14081)] = 246168,
  [SMALL_STATE(14082)] = 246211,
  [SMALL_STATE(14083)] = 246280,
  [SMALL_STATE(14084)] = 246323,
  [SMALL_STATE(14085)] = 246358,
  [SMALL_STATE(14086)] = 246401,
  [SMALL_STATE(14087)] = 246444,
  [SMALL_STATE(14088)] = 246479,
  [SMALL_STATE(14089)] = 246522,
  [SMALL_STATE(14090)] = 246565,
  [SMALL_STATE(14091)] = 246600,
  [SMALL_STATE(14092)] = 246643,
  [SMALL_STATE(14093)] = 246686,
  [SMALL_STATE(14094)] = 246729,
  [SMALL_STATE(14095)] = 246800,
  [SMALL_STATE(14096)] = 246843,
  [SMALL_STATE(14097)] = 246886,
  [SMALL_STATE(14098)] = 246921,
  [SMALL_STATE(14099)] = 246964,
  [SMALL_STATE(14100)] = 247007,
  [SMALL_STATE(14101)] = 247042,
  [SMALL_STATE(14102)] = 247085,
  [SMALL_STATE(14103)] = 247128,
  [SMALL_STATE(14104)] = 247163,
  [SMALL_STATE(14105)] = 247206,
  [SMALL_STATE(14106)] = 247249,
  [SMALL_STATE(14107)] = 247292,
  [SMALL_STATE(14108)] = 247335,
  [SMALL_STATE(14109)] = 247378,
  [SMALL_STATE(14110)] = 247421,
  [SMALL_STATE(14111)] = 247464,
  [SMALL_STATE(14112)] = 247507,
  [SMALL_STATE(14113)] = 247550,
  [SMALL_STATE(14114)] = 247593,
  [SMALL_STATE(14115)] = 247636,
  [SMALL_STATE(14116)] = 247679,
  [SMALL_STATE(14117)] = 247722,
  [SMALL_STATE(14118)] = 247765,
  [SMALL_STATE(14119)] = 247808,
  [SMALL_STATE(14120)] = 247851,
  [SMALL_STATE(14121)] = 247894,
  [SMALL_STATE(14122)] = 247937,
  [SMALL_STATE(14123)] = 247972,
  [SMALL_STATE(14124)] = 248015,
  [SMALL_STATE(14125)] = 248084,
  [SMALL_STATE(14126)] = 248127,
  [SMALL_STATE(14127)] = 248162,
  [SMALL_STATE(14128)] = 248197,
  [SMALL_STATE(14129)] = 248240,
  [SMALL_STATE(14130)] = 248283,
  [SMALL_STATE(14131)] = 248318,
  [SMALL_STATE(14132)] = 248353,
  [SMALL_STATE(14133)] = 248388,
  [SMALL_STATE(14134)] = 248423,
  [SMALL_STATE(14135)] = 248494,
  [SMALL_STATE(14136)] = 248529,
  [SMALL_STATE(14137)] = 248564,
  [SMALL_STATE(14138)] = 248607,
  [SMALL_STATE(14139)] = 248642,
  [SMALL_STATE(14140)] = 248677,
  [SMALL_STATE(14141)] = 248714,
  [SMALL_STATE(14142)] = 248757,
  [SMALL_STATE(14143)] = 248793,
  [SMALL_STATE(14144)] = 248843,
  [SMALL_STATE(14145)] = 248911,
  [SMALL_STATE(14146)] = 248953,
  [SMALL_STATE(14147)] = 248997,
  [SMALL_STATE(14148)] = 249055,
  [SMALL_STATE(14149)] = 249099,
  [SMALL_STATE(14150)] = 249153,
  [SMALL_STATE(14151)] = 249207,
  [SMALL_STATE(14152)] = 249275,
  [SMALL_STATE(14153)] = 249317,
  [SMALL_STATE(14154)] = 249357,
  [SMALL_STATE(14155)] = 249395,
  [SMALL_STATE(14156)] = 249463,
  [SMALL_STATE(14157)] = 249531,
  [SMALL_STATE(14158)] = 249575,
  [SMALL_STATE(14159)] = 249629,
  [SMALL_STATE(14160)] = 249695,
  [SMALL_STATE(14161)] = 249763,
  [SMALL_STATE(14162)] = 249825,
  [SMALL_STATE(14163)] = 249885,
  [SMALL_STATE(14164)] = 249941,
  [SMALL_STATE(14165)] = 249979,
  [SMALL_STATE(14166)] = 250043,
  [SMALL_STATE(14167)] = 250077,
  [SMALL_STATE(14168)] = 250137,
  [SMALL_STATE(14169)] = 250173,
  [SMALL_STATE(14170)] = 250227,
  [SMALL_STATE(14171)] = 250277,
  [SMALL_STATE(14172)] = 250313,
  [SMALL_STATE(14173)] = 250381,
  [SMALL_STATE(14174)] = 250439,
  [SMALL_STATE(14175)] = 250507,
  [SMALL_STATE(14176)] = 250543,
  [SMALL_STATE(14177)] = 250587,
  [SMALL_STATE(14178)] = 250627,
  [SMALL_STATE(14179)] = 250692,
  [SMALL_STATE(14180)] = 250757,
  [SMALL_STATE(14181)] = 250822,
  [SMALL_STATE(14182)] = 250859,
  [SMALL_STATE(14183)] = 250896,
  [SMALL_STATE(14184)] = 250933,
  [SMALL_STATE(14185)] = 250970,
  [SMALL_STATE(14186)] = 251007,
  [SMALL_STATE(14187)] = 251044,
  [SMALL_STATE(14188)] = 251081,
  [SMALL_STATE(14189)] = 251118,
  [SMALL_STATE(14190)] = 251155,
  [SMALL_STATE(14191)] = 251192,
  [SMALL_STATE(14192)] = 251229,
  [SMALL_STATE(14193)] = 251266,
  [SMALL_STATE(14194)] = 251303,
  [SMALL_STATE(14195)] = 251340,
  [SMALL_STATE(14196)] = 251377,
  [SMALL_STATE(14197)] = 251414,
  [SMALL_STATE(14198)] = 251451,
  [SMALL_STATE(14199)] = 251488,
  [SMALL_STATE(14200)] = 251525,
  [SMALL_STATE(14201)] = 251562,
  [SMALL_STATE(14202)] = 251599,
  [SMALL_STATE(14203)] = 251636,
  [SMALL_STATE(14204)] = 251673,
  [SMALL_STATE(14205)] = 251710,
  [SMALL_STATE(14206)] = 251747,
  [SMALL_STATE(14207)] = 251784,
  [SMALL_STATE(14208)] = 251821,
  [SMALL_STATE(14209)] = 251858,
  [SMALL_STATE(14210)] = 251895,
  [SMALL_STATE(14211)] = 251932,
  [SMALL_STATE(14212)] = 251969,
  [SMALL_STATE(14213)] = 252006,
  [SMALL_STATE(14214)] = 252043,
  [SMALL_STATE(14215)] = 252080,
  [SMALL_STATE(14216)] = 252117,
  [SMALL_STATE(14217)] = 252154,
  [SMALL_STATE(14218)] = 252191,
  [SMALL_STATE(14219)] = 252228,
  [SMALL_STATE(14220)] = 252265,
  [SMALL_STATE(14221)] = 252302,
  [SMALL_STATE(14222)] = 252339,
  [SMALL_STATE(14223)] = 252376,
  [SMALL_STATE(14224)] = 252413,
  [SMALL_STATE(14225)] = 252450,
  [SMALL_STATE(14226)] = 252487,
  [SMALL_STATE(14227)] = 252524,
  [SMALL_STATE(14228)] = 252561,
  [SMALL_STATE(14229)] = 252598,
  [SMALL_STATE(14230)] = 252635,
  [SMALL_STATE(14231)] = 252672,
  [SMALL_STATE(14232)] = 252709,
  [SMALL_STATE(14233)] = 252753,
  [SMALL_STATE(14234)] = 252797,
  [SMALL_STATE(14235)] = 252841,
  [SMALL_STATE(14236)] = 252885,
  [SMALL_STATE(14237)] = 252929,
  [SMALL_STATE(14238)] = 252973,
  [SMALL_STATE(14239)] = 253017,
  [SMALL_STATE(14240)] = 253061,
  [SMALL_STATE(14241)] = 253105,
  [SMALL_STATE(14242)] = 253149,
  [SMALL_STATE(14243)] = 253193,
  [SMALL_STATE(14244)] = 253237,
  [SMALL_STATE(14245)] = 253281,
  [SMALL_STATE(14246)] = 253325,
  [SMALL_STATE(14247)] = 253369,
  [SMALL_STATE(14248)] = 253413,
  [SMALL_STATE(14249)] = 253457,
  [SMALL_STATE(14250)] = 253501,
  [SMALL_STATE(14251)] = 253545,
  [SMALL_STATE(14252)] = 253589,
  [SMALL_STATE(14253)] = 253633,
  [SMALL_STATE(14254)] = 253677,
  [SMALL_STATE(14255)] = 253721,
  [SMALL_STATE(14256)] = 253765,
  [SMALL_STATE(14257)] = 253809,
  [SMALL_STATE(14258)] = 253853,
  [SMALL_STATE(14259)] = 253897,
  [SMALL_STATE(14260)] = 253941,
  [SMALL_STATE(14261)] = 253985,
  [SMALL_STATE(14262)] = 254029,
  [SMALL_STATE(14263)] = 254073,
  [SMALL_STATE(14264)] = 254117,
  [SMALL_STATE(14265)] = 254161,
  [SMALL_STATE(14266)] = 254205,
  [SMALL_STATE(14267)] = 254249,
  [SMALL_STATE(14268)] = 254293,
  [SMALL_STATE(14269)] = 254337,
  [SMALL_STATE(14270)] = 254381,
  [SMALL_STATE(14271)] = 254425,
  [SMALL_STATE(14272)] = 254469,
  [SMALL_STATE(14273)] = 254513,
  [SMALL_STATE(14274)] = 254557,
  [SMALL_STATE(14275)] = 254601,
  [SMALL_STATE(14276)] = 254645,
  [SMALL_STATE(14277)] = 254689,
  [SMALL_STATE(14278)] = 254733,
  [SMALL_STATE(14279)] = 254777,
  [SMALL_STATE(14280)] = 254821,
  [SMALL_STATE(14281)] = 254865,
  [SMALL_STATE(14282)] = 254909,
  [SMALL_STATE(14283)] = 254953,
  [SMALL_STATE(14284)] = 254997,
  [SMALL_STATE(14285)] = 255041,
  [SMALL_STATE(14286)] = 255085,
  [SMALL_STATE(14287)] = 255129,
  [SMALL_STATE(14288)] = 255173,
  [SMALL_STATE(14289)] = 255217,
  [SMALL_STATE(14290)] = 255261,
  [SMALL_STATE(14291)] = 255305,
  [SMALL_STATE(14292)] = 255349,
  [SMALL_STATE(14293)] = 255393,
  [SMALL_STATE(14294)] = 255437,
  [SMALL_STATE(14295)] = 255481,
  [SMALL_STATE(14296)] = 255525,
  [SMALL_STATE(14297)] = 255569,
  [SMALL_STATE(14298)] = 255613,
  [SMALL_STATE(14299)] = 255657,
  [SMALL_STATE(14300)] = 255701,
  [SMALL_STATE(14301)] = 255745,
  [SMALL_STATE(14302)] = 255789,
  [SMALL_STATE(14303)] = 255833,
  [SMALL_STATE(14304)] = 255877,
  [SMALL_STATE(14305)] = 255921,
  [SMALL_STATE(14306)] = 255965,
  [SMALL_STATE(14307)] = 256009,
  [SMALL_STATE(14308)] = 256053,
  [SMALL_STATE(14309)] = 256097,
  [SMALL_STATE(14310)] = 256141,
  [SMALL_STATE(14311)] = 256185,
  [SMALL_STATE(14312)] = 256229,
  [SMALL_STATE(14313)] = 256273,
  [SMALL_STATE(14314)] = 256317,
  [SMALL_STATE(14315)] = 256361,
  [SMALL_STATE(14316)] = 256405,
  [SMALL_STATE(14317)] = 256449,
  [SMALL_STATE(14318)] = 256493,
  [SMALL_STATE(14319)] = 256537,
  [SMALL_STATE(14320)] = 256581,
  [SMALL_STATE(14321)] = 256625,
  [SMALL_STATE(14322)] = 256669,
  [SMALL_STATE(14323)] = 256713,
  [SMALL_STATE(14324)] = 256757,
  [SMALL_STATE(14325)] = 256801,
  [SMALL_STATE(14326)] = 256826,
  [SMALL_STATE(14327)] = 256851,
  [SMALL_STATE(14328)] = 256876,
  [SMALL_STATE(14329)] = 256897,
  [SMALL_STATE(14330)] = 256922,
  [SMALL_STATE(14331)] = 256942,
  [SMALL_STATE(14332)] = 256966,
  [SMALL_STATE(14333)] = 256990,
  [SMALL_STATE(14334)] = 257010,
  [SMALL_STATE(14335)] = 257030,
  [SMALL_STATE(14336)] = 257054,
  [SMALL_STATE(14337)] = 257074,
  [SMALL_STATE(14338)] = 257094,
  [SMALL_STATE(14339)] = 257114,
  [SMALL_STATE(14340)] = 257134,
  [SMALL_STATE(14341)] = 257158,
  [SMALL_STATE(14342)] = 257182,
  [SMALL_STATE(14343)] = 257202,
  [SMALL_STATE(14344)] = 257222,
  [SMALL_STATE(14345)] = 257242,
  [SMALL_STATE(14346)] = 257262,
  [SMALL_STATE(14347)] = 257282,
  [SMALL_STATE(14348)] = 257306,
  [SMALL_STATE(14349)] = 257328,
  [SMALL_STATE(14350)] = 257352,
  [SMALL_STATE(14351)] = 257376,
  [SMALL_STATE(14352)] = 257395,
  [SMALL_STATE(14353)] = 257414,
  [SMALL_STATE(14354)] = 257433,
  [SMALL_STATE(14355)] = 257452,
  [SMALL_STATE(14356)] = 257471,
  [SMALL_STATE(14357)] = 257490,
  [SMALL_STATE(14358)] = 257509,
  [SMALL_STATE(14359)] = 257528,
  [SMALL_STATE(14360)] = 257547,
  [SMALL_STATE(14361)] = 257566,
  [SMALL_STATE(14362)] = 257585,
  [SMALL_STATE(14363)] = 257604,
  [SMALL_STATE(14364)] = 257623,
  [SMALL_STATE(14365)] = 257642,
  [SMALL_STATE(14366)] = 257661,
  [SMALL_STATE(14367)] = 257680,
  [SMALL_STATE(14368)] = 257699,
  [SMALL_STATE(14369)] = 257718,
  [SMALL_STATE(14370)] = 257737,
  [SMALL_STATE(14371)] = 257756,
  [SMALL_STATE(14372)] = 257775,
  [SMALL_STATE(14373)] = 257794,
  [SMALL_STATE(14374)] = 257813,
  [SMALL_STATE(14375)] = 257832,
  [SMALL_STATE(14376)] = 257851,
  [SMALL_STATE(14377)] = 257870,
  [SMALL_STATE(14378)] = 257889,
  [SMALL_STATE(14379)] = 257908,
  [SMALL_STATE(14380)] = 257927,
  [SMALL_STATE(14381)] = 257946,
  [SMALL_STATE(14382)] = 257965,
  [SMALL_STATE(14383)] = 257984,
  [SMALL_STATE(14384)] = 258003,
  [SMALL_STATE(14385)] = 258022,
  [SMALL_STATE(14386)] = 258041,
  [SMALL_STATE(14387)] = 258060,
  [SMALL_STATE(14388)] = 258079,
  [SMALL_STATE(14389)] = 258098,
  [SMALL_STATE(14390)] = 258117,
  [SMALL_STATE(14391)] = 258136,
  [SMALL_STATE(14392)] = 258155,
  [SMALL_STATE(14393)] = 258174,
  [SMALL_STATE(14394)] = 258193,
  [SMALL_STATE(14395)] = 258212,
  [SMALL_STATE(14396)] = 258231,
  [SMALL_STATE(14397)] = 258250,
  [SMALL_STATE(14398)] = 258269,
  [SMALL_STATE(14399)] = 258288,
  [SMALL_STATE(14400)] = 258307,
  [SMALL_STATE(14401)] = 258326,
  [SMALL_STATE(14402)] = 258345,
  [SMALL_STATE(14403)] = 258364,
  [SMALL_STATE(14404)] = 258383,
  [SMALL_STATE(14405)] = 258402,
  [SMALL_STATE(14406)] = 258428,
  [SMALL_STATE(14407)] = 258454,
  [SMALL_STATE(14408)] = 258480,
  [SMALL_STATE(14409)] = 258506,
  [SMALL_STATE(14410)] = 258534,
  [SMALL_STATE(14411)] = 258560,
  [SMALL_STATE(14412)] = 258578,
  [SMALL_STATE(14413)] = 258597,
  [SMALL_STATE(14414)] = 258616,
  [SMALL_STATE(14415)] = 258645,
  [SMALL_STATE(14416)] = 258666,
  [SMALL_STATE(14417)] = 258687,
  [SMALL_STATE(14418)] = 258708,
  [SMALL_STATE(14419)] = 258729,
  [SMALL_STATE(14420)] = 258758,
  [SMALL_STATE(14421)] = 258787,
  [SMALL_STATE(14422)] = 258812,
  [SMALL_STATE(14423)] = 258841,
  [SMALL_STATE(14424)] = 258864,
  [SMALL_STATE(14425)] = 258893,
  [SMALL_STATE(14426)] = 258914,
  [SMALL_STATE(14427)] = 258935,
  [SMALL_STATE(14428)] = 258952,
  [SMALL_STATE(14429)] = 258969,
  [SMALL_STATE(14430)] = 258998,
  [SMALL_STATE(14431)] = 259021,
  [SMALL_STATE(14432)] = 259038,
  [SMALL_STATE(14433)] = 259061,
  [SMALL_STATE(14434)] = 259078,
  [SMALL_STATE(14435)] = 259107,
  [SMALL_STATE(14436)] = 259132,
  [SMALL_STATE(14437)] = 259157,
  [SMALL_STATE(14438)] = 259178,
  [SMALL_STATE(14439)] = 259199,
  [SMALL_STATE(14440)] = 259224,
  [SMALL_STATE(14441)] = 259249,
  [SMALL_STATE(14442)] = 259268,
  [SMALL_STATE(14443)] = 259287,
  [SMALL_STATE(14444)] = 259306,
  [SMALL_STATE(14445)] = 259335,
  [SMALL_STATE(14446)] = 259358,
  [SMALL_STATE(14447)] = 259387,
  [SMALL_STATE(14448)] = 259412,
  [SMALL_STATE(14449)] = 259437,
  [SMALL_STATE(14450)] = 259458,
  [SMALL_STATE(14451)] = 259483,
  [SMALL_STATE(14452)] = 259508,
  [SMALL_STATE(14453)] = 259537,
  [SMALL_STATE(14454)] = 259566,
  [SMALL_STATE(14455)] = 259591,
  [SMALL_STATE(14456)] = 259610,
  [SMALL_STATE(14457)] = 259635,
  [SMALL_STATE(14458)] = 259660,
  [SMALL_STATE(14459)] = 259685,
  [SMALL_STATE(14460)] = 259710,
  [SMALL_STATE(14461)] = 259735,
  [SMALL_STATE(14462)] = 259764,
  [SMALL_STATE(14463)] = 259789,
  [SMALL_STATE(14464)] = 259814,
  [SMALL_STATE(14465)] = 259839,
  [SMALL_STATE(14466)] = 259864,
  [SMALL_STATE(14467)] = 259889,
  [SMALL_STATE(14468)] = 259914,
  [SMALL_STATE(14469)] = 259939,
  [SMALL_STATE(14470)] = 259964,
  [SMALL_STATE(14471)] = 259989,
  [SMALL_STATE(14472)] = 260018,
  [SMALL_STATE(14473)] = 260047,
  [SMALL_STATE(14474)] = 260072,
  [SMALL_STATE(14475)] = 260090,
  [SMALL_STATE(14476)] = 260106,
  [SMALL_STATE(14477)] = 260122,
  [SMALL_STATE(14478)] = 260138,
  [SMALL_STATE(14479)] = 260154,
  [SMALL_STATE(14480)] = 260170,
  [SMALL_STATE(14481)] = 260186,
  [SMALL_STATE(14482)] = 260208,
  [SMALL_STATE(14483)] = 260224,
  [SMALL_STATE(14484)] = 260240,
  [SMALL_STATE(14485)] = 260256,
  [SMALL_STATE(14486)] = 260272,
  [SMALL_STATE(14487)] = 260288,
  [SMALL_STATE(14488)] = 260304,
  [SMALL_STATE(14489)] = 260320,
  [SMALL_STATE(14490)] = 260336,
  [SMALL_STATE(14491)] = 260352,
  [SMALL_STATE(14492)] = 260368,
  [SMALL_STATE(14493)] = 260392,
  [SMALL_STATE(14494)] = 260408,
  [SMALL_STATE(14495)] = 260424,
  [SMALL_STATE(14496)] = 260446,
  [SMALL_STATE(14497)] = 260462,
  [SMALL_STATE(14498)] = 260478,
  [SMALL_STATE(14499)] = 260494,
  [SMALL_STATE(14500)] = 260510,
  [SMALL_STATE(14501)] = 260526,
  [SMALL_STATE(14502)] = 260542,
  [SMALL_STATE(14503)] = 260564,
  [SMALL_STATE(14504)] = 260580,
  [SMALL_STATE(14505)] = 260596,
  [SMALL_STATE(14506)] = 260618,
  [SMALL_STATE(14507)] = 260642,
  [SMALL_STATE(14508)] = 260664,
  [SMALL_STATE(14509)] = 260680,
  [SMALL_STATE(14510)] = 260696,
  [SMALL_STATE(14511)] = 260718,
  [SMALL_STATE(14512)] = 260742,
  [SMALL_STATE(14513)] = 260758,
  [SMALL_STATE(14514)] = 260774,
  [SMALL_STATE(14515)] = 260790,
  [SMALL_STATE(14516)] = 260806,
  [SMALL_STATE(14517)] = 260828,
  [SMALL_STATE(14518)] = 260844,
  [SMALL_STATE(14519)] = 260866,
  [SMALL_STATE(14520)] = 260890,
  [SMALL_STATE(14521)] = 260912,
  [SMALL_STATE(14522)] = 260928,
  [SMALL_STATE(14523)] = 260950,
  [SMALL_STATE(14524)] = 260966,
  [SMALL_STATE(14525)] = 260982,
  [SMALL_STATE(14526)] = 261004,
  [SMALL_STATE(14527)] = 261022,
  [SMALL_STATE(14528)] = 261044,
  [SMALL_STATE(14529)] = 261066,
  [SMALL_STATE(14530)] = 261088,
  [SMALL_STATE(14531)] = 261110,
  [SMALL_STATE(14532)] = 261132,
  [SMALL_STATE(14533)] = 261154,
  [SMALL_STATE(14534)] = 261176,
  [SMALL_STATE(14535)] = 261198,
  [SMALL_STATE(14536)] = 261220,
  [SMALL_STATE(14537)] = 261242,
  [SMALL_STATE(14538)] = 261262,
  [SMALL_STATE(14539)] = 261284,
  [SMALL_STATE(14540)] = 261304,
  [SMALL_STATE(14541)] = 261324,
  [SMALL_STATE(14542)] = 261346,
  [SMALL_STATE(14543)] = 261370,
  [SMALL_STATE(14544)] = 261394,
  [SMALL_STATE(14545)] = 261416,
  [SMALL_STATE(14546)] = 261432,
  [SMALL_STATE(14547)] = 261454,
  [SMALL_STATE(14548)] = 261473,
  [SMALL_STATE(14549)] = 261496,
  [SMALL_STATE(14550)] = 261519,
  [SMALL_STATE(14551)] = 261538,
  [SMALL_STATE(14552)] = 261557,
  [SMALL_STATE(14553)] = 261576,
  [SMALL_STATE(14554)] = 261595,
  [SMALL_STATE(14555)] = 261614,
  [SMALL_STATE(14556)] = 261633,
  [SMALL_STATE(14557)] = 261654,
  [SMALL_STATE(14558)] = 261675,
  [SMALL_STATE(14559)] = 261698,
  [SMALL_STATE(14560)] = 261721,
  [SMALL_STATE(14561)] = 261744,
  [SMALL_STATE(14562)] = 261763,
  [SMALL_STATE(14563)] = 261782,
  [SMALL_STATE(14564)] = 261805,
  [SMALL_STATE(14565)] = 261828,
  [SMALL_STATE(14566)] = 261847,
  [SMALL_STATE(14567)] = 261866,
  [SMALL_STATE(14568)] = 261885,
  [SMALL_STATE(14569)] = 261904,
  [SMALL_STATE(14570)] = 261923,
  [SMALL_STATE(14571)] = 261946,
  [SMALL_STATE(14572)] = 261969,
  [SMALL_STATE(14573)] = 261992,
  [SMALL_STATE(14574)] = 262015,
  [SMALL_STATE(14575)] = 262038,
  [SMALL_STATE(14576)] = 262059,
  [SMALL_STATE(14577)] = 262082,
  [SMALL_STATE(14578)] = 262101,
  [SMALL_STATE(14579)] = 262120,
  [SMALL_STATE(14580)] = 262141,
  [SMALL_STATE(14581)] = 262160,
  [SMALL_STATE(14582)] = 262179,
  [SMALL_STATE(14583)] = 262200,
  [SMALL_STATE(14584)] = 262223,
  [SMALL_STATE(14585)] = 262246,
  [SMALL_STATE(14586)] = 262269,
  [SMALL_STATE(14587)] = 262292,
  [SMALL_STATE(14588)] = 262315,
  [SMALL_STATE(14589)] = 262334,
  [SMALL_STATE(14590)] = 262353,
  [SMALL_STATE(14591)] = 262372,
  [SMALL_STATE(14592)] = 262391,
  [SMALL_STATE(14593)] = 262410,
  [SMALL_STATE(14594)] = 262429,
  [SMALL_STATE(14595)] = 262448,
  [SMALL_STATE(14596)] = 262471,
  [SMALL_STATE(14597)] = 262494,
  [SMALL_STATE(14598)] = 262517,
  [SMALL_STATE(14599)] = 262540,
  [SMALL_STATE(14600)] = 262561,
  [SMALL_STATE(14601)] = 262584,
  [SMALL_STATE(14602)] = 262603,
  [SMALL_STATE(14603)] = 262622,
  [SMALL_STATE(14604)] = 262641,
  [SMALL_STATE(14605)] = 262660,
  [SMALL_STATE(14606)] = 262683,
  [SMALL_STATE(14607)] = 262706,
  [SMALL_STATE(14608)] = 262729,
  [SMALL_STATE(14609)] = 262750,
  [SMALL_STATE(14610)] = 262771,
  [SMALL_STATE(14611)] = 262790,
  [SMALL_STATE(14612)] = 262809,
  [SMALL_STATE(14613)] = 262828,
  [SMALL_STATE(14614)] = 262847,
  [SMALL_STATE(14615)] = 262866,
  [SMALL_STATE(14616)] = 262885,
  [SMALL_STATE(14617)] = 262908,
  [SMALL_STATE(14618)] = 262931,
  [SMALL_STATE(14619)] = 262950,
  [SMALL_STATE(14620)] = 262973,
  [SMALL_STATE(14621)] = 262992,
  [SMALL_STATE(14622)] = 263011,
  [SMALL_STATE(14623)] = 263030,
  [SMALL_STATE(14624)] = 263049,
  [SMALL_STATE(14625)] = 263068,
  [SMALL_STATE(14626)] = 263087,
  [SMALL_STATE(14627)] = 263106,
  [SMALL_STATE(14628)] = 263125,
  [SMALL_STATE(14629)] = 263144,
  [SMALL_STATE(14630)] = 263163,
  [SMALL_STATE(14631)] = 263184,
  [SMALL_STATE(14632)] = 263203,
  [SMALL_STATE(14633)] = 263226,
  [SMALL_STATE(14634)] = 263249,
  [SMALL_STATE(14635)] = 263270,
  [SMALL_STATE(14636)] = 263293,
  [SMALL_STATE(14637)] = 263312,
  [SMALL_STATE(14638)] = 263331,
  [SMALL_STATE(14639)] = 263352,
  [SMALL_STATE(14640)] = 263371,
  [SMALL_STATE(14641)] = 263390,
  [SMALL_STATE(14642)] = 263413,
  [SMALL_STATE(14643)] = 263436,
  [SMALL_STATE(14644)] = 263455,
  [SMALL_STATE(14645)] = 263474,
  [SMALL_STATE(14646)] = 263493,
  [SMALL_STATE(14647)] = 263514,
  [SMALL_STATE(14648)] = 263537,
  [SMALL_STATE(14649)] = 263560,
  [SMALL_STATE(14650)] = 263583,
  [SMALL_STATE(14651)] = 263606,
  [SMALL_STATE(14652)] = 263629,
  [SMALL_STATE(14653)] = 263648,
  [SMALL_STATE(14654)] = 263667,
  [SMALL_STATE(14655)] = 263686,
  [SMALL_STATE(14656)] = 263705,
  [SMALL_STATE(14657)] = 263724,
  [SMALL_STATE(14658)] = 263743,
  [SMALL_STATE(14659)] = 263764,
  [SMALL_STATE(14660)] = 263787,
  [SMALL_STATE(14661)] = 263810,
  [SMALL_STATE(14662)] = 263831,
  [SMALL_STATE(14663)] = 263854,
  [SMALL_STATE(14664)] = 263873,
  [SMALL_STATE(14665)] = 263892,
  [SMALL_STATE(14666)] = 263915,
  [SMALL_STATE(14667)] = 263934,
  [SMALL_STATE(14668)] = 263953,
  [SMALL_STATE(14669)] = 263972,
  [SMALL_STATE(14670)] = 263991,
  [SMALL_STATE(14671)] = 264014,
  [SMALL_STATE(14672)] = 264037,
  [SMALL_STATE(14673)] = 264060,
  [SMALL_STATE(14674)] = 264083,
  [SMALL_STATE(14675)] = 264102,
  [SMALL_STATE(14676)] = 264123,
  [SMALL_STATE(14677)] = 264144,
  [SMALL_STATE(14678)] = 264163,
  [SMALL_STATE(14679)] = 264182,
  [SMALL_STATE(14680)] = 264201,
  [SMALL_STATE(14681)] = 264220,
  [SMALL_STATE(14682)] = 264243,
  [SMALL_STATE(14683)] = 264266,
  [SMALL_STATE(14684)] = 264289,
  [SMALL_STATE(14685)] = 264312,
  [SMALL_STATE(14686)] = 264335,
  [SMALL_STATE(14687)] = 264354,
  [SMALL_STATE(14688)] = 264373,
  [SMALL_STATE(14689)] = 264392,
  [SMALL_STATE(14690)] = 264411,
  [SMALL_STATE(14691)] = 264430,
  [SMALL_STATE(14692)] = 264449,
  [SMALL_STATE(14693)] = 264468,
  [SMALL_STATE(14694)] = 264487,
  [SMALL_STATE(14695)] = 264510,
  [SMALL_STATE(14696)] = 264529,
  [SMALL_STATE(14697)] = 264552,
  [SMALL_STATE(14698)] = 264575,
  [SMALL_STATE(14699)] = 264596,
  [SMALL_STATE(14700)] = 264619,
  [SMALL_STATE(14701)] = 264640,
  [SMALL_STATE(14702)] = 264659,
  [SMALL_STATE(14703)] = 264678,
  [SMALL_STATE(14704)] = 264697,
  [SMALL_STATE(14705)] = 264716,
  [SMALL_STATE(14706)] = 264739,
  [SMALL_STATE(14707)] = 264758,
  [SMALL_STATE(14708)] = 264781,
  [SMALL_STATE(14709)] = 264804,
  [SMALL_STATE(14710)] = 264825,
  [SMALL_STATE(14711)] = 264846,
  [SMALL_STATE(14712)] = 264869,
  [SMALL_STATE(14713)] = 264888,
  [SMALL_STATE(14714)] = 264907,
  [SMALL_STATE(14715)] = 264926,
  [SMALL_STATE(14716)] = 264945,
  [SMALL_STATE(14717)] = 264964,
  [SMALL_STATE(14718)] = 264983,
  [SMALL_STATE(14719)] = 265006,
  [SMALL_STATE(14720)] = 265029,
  [SMALL_STATE(14721)] = 265048,
  [SMALL_STATE(14722)] = 265071,
  [SMALL_STATE(14723)] = 265090,
  [SMALL_STATE(14724)] = 265109,
  [SMALL_STATE(14725)] = 265128,
  [SMALL_STATE(14726)] = 265147,
  [SMALL_STATE(14727)] = 265166,
  [SMALL_STATE(14728)] = 265189,
  [SMALL_STATE(14729)] = 265212,
  [SMALL_STATE(14730)] = 265235,
  [SMALL_STATE(14731)] = 265256,
  [SMALL_STATE(14732)] = 265279,
  [SMALL_STATE(14733)] = 265302,
  [SMALL_STATE(14734)] = 265321,
  [SMALL_STATE(14735)] = 265340,
  [SMALL_STATE(14736)] = 265359,
  [SMALL_STATE(14737)] = 265378,
  [SMALL_STATE(14738)] = 265401,
  [SMALL_STATE(14739)] = 265424,
  [SMALL_STATE(14740)] = 265447,
  [SMALL_STATE(14741)] = 265466,
  [SMALL_STATE(14742)] = 265485,
  [SMALL_STATE(14743)] = 265504,
  [SMALL_STATE(14744)] = 265523,
  [SMALL_STATE(14745)] = 265542,
  [SMALL_STATE(14746)] = 265565,
  [SMALL_STATE(14747)] = 265588,
  [SMALL_STATE(14748)] = 265611,
  [SMALL_STATE(14749)] = 265634,
  [SMALL_STATE(14750)] = 265657,
  [SMALL_STATE(14751)] = 265680,
  [SMALL_STATE(14752)] = 265699,
  [SMALL_STATE(14753)] = 265718,
  [SMALL_STATE(14754)] = 265737,
  [SMALL_STATE(14755)] = 265756,
  [SMALL_STATE(14756)] = 265775,
  [SMALL_STATE(14757)] = 265798,
  [SMALL_STATE(14758)] = 265821,
  [SMALL_STATE(14759)] = 265844,
  [SMALL_STATE(14760)] = 265867,
  [SMALL_STATE(14761)] = 265888,
  [SMALL_STATE(14762)] = 265907,
  [SMALL_STATE(14763)] = 265926,
  [SMALL_STATE(14764)] = 265945,
  [SMALL_STATE(14765)] = 265964,
  [SMALL_STATE(14766)] = 265985,
  [SMALL_STATE(14767)] = 266006,
  [SMALL_STATE(14768)] = 266025,
  [SMALL_STATE(14769)] = 266048,
  [SMALL_STATE(14770)] = 266071,
  [SMALL_STATE(14771)] = 266090,
  [SMALL_STATE(14772)] = 266113,
  [SMALL_STATE(14773)] = 266132,
  [SMALL_STATE(14774)] = 266155,
  [SMALL_STATE(14775)] = 266174,
  [SMALL_STATE(14776)] = 266193,
  [SMALL_STATE(14777)] = 266212,
  [SMALL_STATE(14778)] = 266231,
  [SMALL_STATE(14779)] = 266250,
  [SMALL_STATE(14780)] = 266269,
  [SMALL_STATE(14781)] = 266292,
  [SMALL_STATE(14782)] = 266315,
  [SMALL_STATE(14783)] = 266338,
  [SMALL_STATE(14784)] = 266359,
  [SMALL_STATE(14785)] = 266382,
  [SMALL_STATE(14786)] = 266401,
  [SMALL_STATE(14787)] = 266420,
  [SMALL_STATE(14788)] = 266439,
  [SMALL_STATE(14789)] = 266458,
  [SMALL_STATE(14790)] = 266481,
  [SMALL_STATE(14791)] = 266504,
  [SMALL_STATE(14792)] = 266523,
  [SMALL_STATE(14793)] = 266542,
  [SMALL_STATE(14794)] = 266565,
  [SMALL_STATE(14795)] = 266588,
  [SMALL_STATE(14796)] = 266611,
  [SMALL_STATE(14797)] = 266630,
  [SMALL_STATE(14798)] = 266649,
  [SMALL_STATE(14799)] = 266668,
  [SMALL_STATE(14800)] = 266687,
  [SMALL_STATE(14801)] = 266706,
  [SMALL_STATE(14802)] = 266729,
  [SMALL_STATE(14803)] = 266748,
  [SMALL_STATE(14804)] = 266767,
  [SMALL_STATE(14805)] = 266790,
  [SMALL_STATE(14806)] = 266813,
  [SMALL_STATE(14807)] = 266836,
  [SMALL_STATE(14808)] = 266857,
  [SMALL_STATE(14809)] = 266878,
  [SMALL_STATE(14810)] = 266897,
  [SMALL_STATE(14811)] = 266916,
  [SMALL_STATE(14812)] = 266935,
  [SMALL_STATE(14813)] = 266954,
  [SMALL_STATE(14814)] = 266977,
  [SMALL_STATE(14815)] = 267000,
  [SMALL_STATE(14816)] = 267021,
  [SMALL_STATE(14817)] = 267042,
  [SMALL_STATE(14818)] = 267065,
  [SMALL_STATE(14819)] = 267088,
  [SMALL_STATE(14820)] = 267107,
  [SMALL_STATE(14821)] = 267126,
  [SMALL_STATE(14822)] = 267145,
  [SMALL_STATE(14823)] = 267164,
  [SMALL_STATE(14824)] = 267187,
  [SMALL_STATE(14825)] = 267210,
  [SMALL_STATE(14826)] = 267233,
  [SMALL_STATE(14827)] = 267256,
  [SMALL_STATE(14828)] = 267279,
  [SMALL_STATE(14829)] = 267298,
  [SMALL_STATE(14830)] = 267317,
  [SMALL_STATE(14831)] = 267336,
  [SMALL_STATE(14832)] = 267355,
  [SMALL_STATE(14833)] = 267374,
  [SMALL_STATE(14834)] = 267397,
  [SMALL_STATE(14835)] = 267420,
  [SMALL_STATE(14836)] = 267443,
  [SMALL_STATE(14837)] = 267466,
  [SMALL_STATE(14838)] = 267485,
  [SMALL_STATE(14839)] = 267504,
  [SMALL_STATE(14840)] = 267523,
  [SMALL_STATE(14841)] = 267542,
  [SMALL_STATE(14842)] = 267563,
  [SMALL_STATE(14843)] = 267586,
  [SMALL_STATE(14844)] = 267609,
  [SMALL_STATE(14845)] = 267630,
  [SMALL_STATE(14846)] = 267653,
  [SMALL_STATE(14847)] = 267672,
  [SMALL_STATE(14848)] = 267691,
  [SMALL_STATE(14849)] = 267714,
  [SMALL_STATE(14850)] = 267733,
  [SMALL_STATE(14851)] = 267752,
  [SMALL_STATE(14852)] = 267775,
  [SMALL_STATE(14853)] = 267798,
  [SMALL_STATE(14854)] = 267821,
  [SMALL_STATE(14855)] = 267844,
  [SMALL_STATE(14856)] = 267863,
  [SMALL_STATE(14857)] = 267882,
  [SMALL_STATE(14858)] = 267901,
  [SMALL_STATE(14859)] = 267920,
  [SMALL_STATE(14860)] = 267939,
  [SMALL_STATE(14861)] = 267962,
  [SMALL_STATE(14862)] = 267985,
  [SMALL_STATE(14863)] = 268006,
  [SMALL_STATE(14864)] = 268029,
  [SMALL_STATE(14865)] = 268048,
  [SMALL_STATE(14866)] = 268067,
  [SMALL_STATE(14867)] = 268088,
  [SMALL_STATE(14868)] = 268107,
  [SMALL_STATE(14869)] = 268126,
  [SMALL_STATE(14870)] = 268149,
  [SMALL_STATE(14871)] = 268172,
  [SMALL_STATE(14872)] = 268195,
  [SMALL_STATE(14873)] = 268218,
  [SMALL_STATE(14874)] = 268237,
  [SMALL_STATE(14875)] = 268256,
  [SMALL_STATE(14876)] = 268275,
  [SMALL_STATE(14877)] = 268294,
  [SMALL_STATE(14878)] = 268317,
  [SMALL_STATE(14879)] = 268340,
  [SMALL_STATE(14880)] = 268363,
  [SMALL_STATE(14881)] = 268382,
  [SMALL_STATE(14882)] = 268401,
  [SMALL_STATE(14883)] = 268420,
  [SMALL_STATE(14884)] = 268439,
  [SMALL_STATE(14885)] = 268458,
  [SMALL_STATE(14886)] = 268481,
  [SMALL_STATE(14887)] = 268504,
  [SMALL_STATE(14888)] = 268525,
  [SMALL_STATE(14889)] = 268548,
  [SMALL_STATE(14890)] = 268567,
  [SMALL_STATE(14891)] = 268586,
  [SMALL_STATE(14892)] = 268605,
  [SMALL_STATE(14893)] = 268624,
  [SMALL_STATE(14894)] = 268643,
  [SMALL_STATE(14895)] = 268662,
  [SMALL_STATE(14896)] = 268685,
  [SMALL_STATE(14897)] = 268708,
  [SMALL_STATE(14898)] = 268731,
  [SMALL_STATE(14899)] = 268750,
  [SMALL_STATE(14900)] = 268769,
  [SMALL_STATE(14901)] = 268788,
  [SMALL_STATE(14902)] = 268807,
  [SMALL_STATE(14903)] = 268826,
  [SMALL_STATE(14904)] = 268845,
  [SMALL_STATE(14905)] = 268864,
  [SMALL_STATE(14906)] = 268883,
  [SMALL_STATE(14907)] = 268906,
  [SMALL_STATE(14908)] = 268929,
  [SMALL_STATE(14909)] = 268948,
  [SMALL_STATE(14910)] = 268971,
  [SMALL_STATE(14911)] = 268990,
  [SMALL_STATE(14912)] = 269009,
  [SMALL_STATE(14913)] = 269030,
  [SMALL_STATE(14914)] = 269049,
  [SMALL_STATE(14915)] = 269068,
  [SMALL_STATE(14916)] = 269087,
  [SMALL_STATE(14917)] = 269110,
  [SMALL_STATE(14918)] = 269133,
  [SMALL_STATE(14919)] = 269152,
  [SMALL_STATE(14920)] = 269171,
  [SMALL_STATE(14921)] = 269194,
  [SMALL_STATE(14922)] = 269213,
  [SMALL_STATE(14923)] = 269234,
  [SMALL_STATE(14924)] = 269253,
  [SMALL_STATE(14925)] = 269272,
  [SMALL_STATE(14926)] = 269293,
  [SMALL_STATE(14927)] = 269312,
  [SMALL_STATE(14928)] = 269331,
  [SMALL_STATE(14929)] = 269350,
  [SMALL_STATE(14930)] = 269373,
  [SMALL_STATE(14931)] = 269396,
  [SMALL_STATE(14932)] = 269415,
  [SMALL_STATE(14933)] = 269438,
  [SMALL_STATE(14934)] = 269461,
  [SMALL_STATE(14935)] = 269480,
  [SMALL_STATE(14936)] = 269499,
  [SMALL_STATE(14937)] = 269522,
  [SMALL_STATE(14938)] = 269541,
  [SMALL_STATE(14939)] = 269560,
  [SMALL_STATE(14940)] = 269583,
  [SMALL_STATE(14941)] = 269606,
  [SMALL_STATE(14942)] = 269625,
  [SMALL_STATE(14943)] = 269644,
  [SMALL_STATE(14944)] = 269667,
  [SMALL_STATE(14945)] = 269686,
  [SMALL_STATE(14946)] = 269709,
  [SMALL_STATE(14947)] = 269732,
  [SMALL_STATE(14948)] = 269755,
  [SMALL_STATE(14949)] = 269774,
  [SMALL_STATE(14950)] = 269793,
  [SMALL_STATE(14951)] = 269814,
  [SMALL_STATE(14952)] = 269835,
  [SMALL_STATE(14953)] = 269858,
  [SMALL_STATE(14954)] = 269877,
  [SMALL_STATE(14955)] = 269900,
  [SMALL_STATE(14956)] = 269921,
  [SMALL_STATE(14957)] = 269940,
  [SMALL_STATE(14958)] = 269963,
  [SMALL_STATE(14959)] = 269986,
  [SMALL_STATE(14960)] = 270005,
  [SMALL_STATE(14961)] = 270024,
  [SMALL_STATE(14962)] = 270043,
  [SMALL_STATE(14963)] = 270062,
  [SMALL_STATE(14964)] = 270085,
  [SMALL_STATE(14965)] = 270104,
  [SMALL_STATE(14966)] = 270125,
  [SMALL_STATE(14967)] = 270144,
  [SMALL_STATE(14968)] = 270163,
  [SMALL_STATE(14969)] = 270182,
  [SMALL_STATE(14970)] = 270201,
  [SMALL_STATE(14971)] = 270220,
  [SMALL_STATE(14972)] = 270239,
  [SMALL_STATE(14973)] = 270262,
  [SMALL_STATE(14974)] = 270281,
  [SMALL_STATE(14975)] = 270300,
  [SMALL_STATE(14976)] = 270323,
  [SMALL_STATE(14977)] = 270342,
  [SMALL_STATE(14978)] = 270361,
  [SMALL_STATE(14979)] = 270380,
  [SMALL_STATE(14980)] = 270403,
  [SMALL_STATE(14981)] = 270426,
  [SMALL_STATE(14982)] = 270445,
  [SMALL_STATE(14983)] = 270464,
  [SMALL_STATE(14984)] = 270483,
  [SMALL_STATE(14985)] = 270506,
  [SMALL_STATE(14986)] = 270529,
  [SMALL_STATE(14987)] = 270548,
  [SMALL_STATE(14988)] = 270567,
  [SMALL_STATE(14989)] = 270586,
  [SMALL_STATE(14990)] = 270609,
  [SMALL_STATE(14991)] = 270628,
  [SMALL_STATE(14992)] = 270649,
  [SMALL_STATE(14993)] = 270668,
  [SMALL_STATE(14994)] = 270687,
  [SMALL_STATE(14995)] = 270706,
  [SMALL_STATE(14996)] = 270727,
  [SMALL_STATE(14997)] = 270748,
  [SMALL_STATE(14998)] = 270769,
  [SMALL_STATE(14999)] = 270788,
  [SMALL_STATE(15000)] = 270807,
  [SMALL_STATE(15001)] = 270830,
  [SMALL_STATE(15002)] = 270853,
  [SMALL_STATE(15003)] = 270876,
  [SMALL_STATE(15004)] = 270899,
  [SMALL_STATE(15005)] = 270918,
  [SMALL_STATE(15006)] = 270937,
  [SMALL_STATE(15007)] = 270960,
  [SMALL_STATE(15008)] = 270979,
  [SMALL_STATE(15009)] = 270998,
  [SMALL_STATE(15010)] = 271021,
  [SMALL_STATE(15011)] = 271044,
  [SMALL_STATE(15012)] = 271063,
  [SMALL_STATE(15013)] = 271082,
  [SMALL_STATE(15014)] = 271103,
  [SMALL_STATE(15015)] = 271124,
  [SMALL_STATE(15016)] = 271147,
  [SMALL_STATE(15017)] = 271168,
  [SMALL_STATE(15018)] = 271187,
  [SMALL_STATE(15019)] = 271206,
  [SMALL_STATE(15020)] = 271225,
  [SMALL_STATE(15021)] = 271244,
  [SMALL_STATE(15022)] = 271263,
  [SMALL_STATE(15023)] = 271284,
  [SMALL_STATE(15024)] = 271303,
  [SMALL_STATE(15025)] = 271322,
  [SMALL_STATE(15026)] = 271341,
  [SMALL_STATE(15027)] = 271364,
  [SMALL_STATE(15028)] = 271387,
  [SMALL_STATE(15029)] = 271406,
  [SMALL_STATE(15030)] = 271427,
  [SMALL_STATE(15031)] = 271450,
  [SMALL_STATE(15032)] = 271469,
  [SMALL_STATE(15033)] = 271488,
  [SMALL_STATE(15034)] = 271507,
  [SMALL_STATE(15035)] = 271526,
  [SMALL_STATE(15036)] = 271547,
  [SMALL_STATE(15037)] = 271566,
  [SMALL_STATE(15038)] = 271589,
  [SMALL_STATE(15039)] = 271612,
  [SMALL_STATE(15040)] = 271631,
  [SMALL_STATE(15041)] = 271650,
  [SMALL_STATE(15042)] = 271669,
  [SMALL_STATE(15043)] = 271688,
  [SMALL_STATE(15044)] = 271707,
  [SMALL_STATE(15045)] = 271726,
  [SMALL_STATE(15046)] = 271745,
  [SMALL_STATE(15047)] = 271764,
  [SMALL_STATE(15048)] = 271785,
  [SMALL_STATE(15049)] = 271808,
  [SMALL_STATE(15050)] = 271831,
  [SMALL_STATE(15051)] = 271854,
  [SMALL_STATE(15052)] = 271873,
  [SMALL_STATE(15053)] = 271894,
  [SMALL_STATE(15054)] = 271915,
  [SMALL_STATE(15055)] = 271934,
  [SMALL_STATE(15056)] = 271957,
  [SMALL_STATE(15057)] = 271976,
  [SMALL_STATE(15058)] = 271999,
  [SMALL_STATE(15059)] = 272022,
  [SMALL_STATE(15060)] = 272041,
  [SMALL_STATE(15061)] = 272060,
  [SMALL_STATE(15062)] = 272083,
  [SMALL_STATE(15063)] = 272104,
  [SMALL_STATE(15064)] = 272125,
  [SMALL_STATE(15065)] = 272146,
  [SMALL_STATE(15066)] = 272167,
  [SMALL_STATE(15067)] = 272190,
  [SMALL_STATE(15068)] = 272213,
  [SMALL_STATE(15069)] = 272236,
  [SMALL_STATE(15070)] = 272255,
  [SMALL_STATE(15071)] = 272274,
  [SMALL_STATE(15072)] = 272293,
  [SMALL_STATE(15073)] = 272312,
  [SMALL_STATE(15074)] = 272331,
  [SMALL_STATE(15075)] = 272352,
  [SMALL_STATE(15076)] = 272371,
  [SMALL_STATE(15077)] = 272384,
  [SMALL_STATE(15078)] = 272407,
  [SMALL_STATE(15079)] = 272430,
  [SMALL_STATE(15080)] = 272449,
  [SMALL_STATE(15081)] = 272468,
  [SMALL_STATE(15082)] = 272487,
  [SMALL_STATE(15083)] = 272510,
  [SMALL_STATE(15084)] = 272533,
  [SMALL_STATE(15085)] = 272556,
  [SMALL_STATE(15086)] = 272579,
  [SMALL_STATE(15087)] = 272598,
  [SMALL_STATE(15088)] = 272617,
  [SMALL_STATE(15089)] = 272636,
  [SMALL_STATE(15090)] = 272655,
  [SMALL_STATE(15091)] = 272676,
  [SMALL_STATE(15092)] = 272699,
  [SMALL_STATE(15093)] = 272722,
  [SMALL_STATE(15094)] = 272745,
  [SMALL_STATE(15095)] = 272764,
  [SMALL_STATE(15096)] = 272783,
  [SMALL_STATE(15097)] = 272804,
  [SMALL_STATE(15098)] = 272825,
  [SMALL_STATE(15099)] = 272844,
  [SMALL_STATE(15100)] = 272863,
  [SMALL_STATE(15101)] = 272886,
  [SMALL_STATE(15102)] = 272905,
  [SMALL_STATE(15103)] = 272928,
  [SMALL_STATE(15104)] = 272947,
  [SMALL_STATE(15105)] = 272966,
  [SMALL_STATE(15106)] = 272985,
  [SMALL_STATE(15107)] = 273004,
  [SMALL_STATE(15108)] = 273023,
  [SMALL_STATE(15109)] = 273046,
  [SMALL_STATE(15110)] = 273067,
  [SMALL_STATE(15111)] = 273088,
  [SMALL_STATE(15112)] = 273109,
  [SMALL_STATE(15113)] = 273128,
  [SMALL_STATE(15114)] = 273151,
  [SMALL_STATE(15115)] = 273174,
  [SMALL_STATE(15116)] = 273195,
  [SMALL_STATE(15117)] = 273214,
  [SMALL_STATE(15118)] = 273233,
  [SMALL_STATE(15119)] = 273256,
  [SMALL_STATE(15120)] = 273279,
  [SMALL_STATE(15121)] = 273300,
  [SMALL_STATE(15122)] = 273323,
  [SMALL_STATE(15123)] = 273342,
  [SMALL_STATE(15124)] = 273361,
  [SMALL_STATE(15125)] = 273384,
  [SMALL_STATE(15126)] = 273403,
  [SMALL_STATE(15127)] = 273422,
  [SMALL_STATE(15128)] = 273443,
  [SMALL_STATE(15129)] = 273464,
  [SMALL_STATE(15130)] = 273483,
  [SMALL_STATE(15131)] = 273502,
  [SMALL_STATE(15132)] = 273521,
  [SMALL_STATE(15133)] = 273540,
  [SMALL_STATE(15134)] = 273559,
  [SMALL_STATE(15135)] = 273578,
  [SMALL_STATE(15136)] = 273599,
  [SMALL_STATE(15137)] = 273620,
  [SMALL_STATE(15138)] = 273639,
  [SMALL_STATE(15139)] = 273662,
  [SMALL_STATE(15140)] = 273685,
  [SMALL_STATE(15141)] = 273704,
  [SMALL_STATE(15142)] = 273727,
  [SMALL_STATE(15143)] = 273750,
  [SMALL_STATE(15144)] = 273769,
  [SMALL_STATE(15145)] = 273788,
  [SMALL_STATE(15146)] = 273807,
  [SMALL_STATE(15147)] = 273826,
  [SMALL_STATE(15148)] = 273845,
  [SMALL_STATE(15149)] = 273868,
  [SMALL_STATE(15150)] = 273891,
  [SMALL_STATE(15151)] = 273910,
  [SMALL_STATE(15152)] = 273929,
  [SMALL_STATE(15153)] = 273948,
  [SMALL_STATE(15154)] = 273967,
  [SMALL_STATE(15155)] = 273990,
  [SMALL_STATE(15156)] = 274009,
  [SMALL_STATE(15157)] = 274028,
  [SMALL_STATE(15158)] = 274047,
  [SMALL_STATE(15159)] = 274066,
  [SMALL_STATE(15160)] = 274085,
  [SMALL_STATE(15161)] = 274104,
  [SMALL_STATE(15162)] = 274125,
  [SMALL_STATE(15163)] = 274144,
  [SMALL_STATE(15164)] = 274163,
  [SMALL_STATE(15165)] = 274182,
  [SMALL_STATE(15166)] = 274201,
  [SMALL_STATE(15167)] = 274222,
  [SMALL_STATE(15168)] = 274243,
  [SMALL_STATE(15169)] = 274262,
  [SMALL_STATE(15170)] = 274281,
  [SMALL_STATE(15171)] = 274300,
  [SMALL_STATE(15172)] = 274321,
  [SMALL_STATE(15173)] = 274340,
  [SMALL_STATE(15174)] = 274359,
  [SMALL_STATE(15175)] = 274378,
  [SMALL_STATE(15176)] = 274397,
  [SMALL_STATE(15177)] = 274420,
  [SMALL_STATE(15178)] = 274443,
  [SMALL_STATE(15179)] = 274462,
  [SMALL_STATE(15180)] = 274481,
  [SMALL_STATE(15181)] = 274501,
  [SMALL_STATE(15182)] = 274515,
  [SMALL_STATE(15183)] = 274529,
  [SMALL_STATE(15184)] = 274543,
  [SMALL_STATE(15185)] = 274557,
  [SMALL_STATE(15186)] = 274571,
  [SMALL_STATE(15187)] = 274591,
  [SMALL_STATE(15188)] = 274605,
  [SMALL_STATE(15189)] = 274619,
  [SMALL_STATE(15190)] = 274637,
  [SMALL_STATE(15191)] = 274657,
  [SMALL_STATE(15192)] = 274677,
  [SMALL_STATE(15193)] = 274697,
  [SMALL_STATE(15194)] = 274711,
  [SMALL_STATE(15195)] = 274725,
  [SMALL_STATE(15196)] = 274743,
  [SMALL_STATE(15197)] = 274757,
  [SMALL_STATE(15198)] = 274777,
  [SMALL_STATE(15199)] = 274797,
  [SMALL_STATE(15200)] = 274811,
  [SMALL_STATE(15201)] = 274825,
  [SMALL_STATE(15202)] = 274839,
  [SMALL_STATE(15203)] = 274853,
  [SMALL_STATE(15204)] = 274867,
  [SMALL_STATE(15205)] = 274881,
  [SMALL_STATE(15206)] = 274895,
  [SMALL_STATE(15207)] = 274909,
  [SMALL_STATE(15208)] = 274923,
  [SMALL_STATE(15209)] = 274937,
  [SMALL_STATE(15210)] = 274951,
  [SMALL_STATE(15211)] = 274969,
  [SMALL_STATE(15212)] = 274983,
  [SMALL_STATE(15213)] = 274997,
  [SMALL_STATE(15214)] = 275011,
  [SMALL_STATE(15215)] = 275025,
  [SMALL_STATE(15216)] = 275039,
  [SMALL_STATE(15217)] = 275059,
  [SMALL_STATE(15218)] = 275073,
  [SMALL_STATE(15219)] = 275093,
  [SMALL_STATE(15220)] = 275107,
  [SMALL_STATE(15221)] = 275121,
  [SMALL_STATE(15222)] = 275135,
  [SMALL_STATE(15223)] = 275155,
  [SMALL_STATE(15224)] = 275169,
  [SMALL_STATE(15225)] = 275189,
  [SMALL_STATE(15226)] = 275203,
  [SMALL_STATE(15227)] = 275223,
  [SMALL_STATE(15228)] = 275237,
  [SMALL_STATE(15229)] = 275251,
  [SMALL_STATE(15230)] = 275265,
  [SMALL_STATE(15231)] = 275279,
  [SMALL_STATE(15232)] = 275293,
  [SMALL_STATE(15233)] = 275307,
  [SMALL_STATE(15234)] = 275321,
  [SMALL_STATE(15235)] = 275335,
  [SMALL_STATE(15236)] = 275349,
  [SMALL_STATE(15237)] = 275369,
  [SMALL_STATE(15238)] = 275383,
  [SMALL_STATE(15239)] = 275403,
  [SMALL_STATE(15240)] = 275417,
  [SMALL_STATE(15241)] = 275431,
  [SMALL_STATE(15242)] = 275445,
  [SMALL_STATE(15243)] = 275459,
  [SMALL_STATE(15244)] = 275473,
  [SMALL_STATE(15245)] = 275487,
  [SMALL_STATE(15246)] = 275501,
  [SMALL_STATE(15247)] = 275515,
  [SMALL_STATE(15248)] = 275535,
  [SMALL_STATE(15249)] = 275549,
  [SMALL_STATE(15250)] = 275565,
  [SMALL_STATE(15251)] = 275579,
  [SMALL_STATE(15252)] = 275593,
  [SMALL_STATE(15253)] = 275609,
  [SMALL_STATE(15254)] = 275629,
  [SMALL_STATE(15255)] = 275643,
  [SMALL_STATE(15256)] = 275657,
  [SMALL_STATE(15257)] = 275677,
  [SMALL_STATE(15258)] = 275691,
  [SMALL_STATE(15259)] = 275711,
  [SMALL_STATE(15260)] = 275731,
  [SMALL_STATE(15261)] = 275745,
  [SMALL_STATE(15262)] = 275759,
  [SMALL_STATE(15263)] = 275773,
  [SMALL_STATE(15264)] = 275787,
  [SMALL_STATE(15265)] = 275801,
  [SMALL_STATE(15266)] = 275815,
  [SMALL_STATE(15267)] = 275833,
  [SMALL_STATE(15268)] = 275847,
  [SMALL_STATE(15269)] = 275861,
  [SMALL_STATE(15270)] = 275875,
  [SMALL_STATE(15271)] = 275895,
  [SMALL_STATE(15272)] = 275915,
  [SMALL_STATE(15273)] = 275929,
  [SMALL_STATE(15274)] = 275945,
  [SMALL_STATE(15275)] = 275959,
  [SMALL_STATE(15276)] = 275975,
  [SMALL_STATE(15277)] = 275995,
  [SMALL_STATE(15278)] = 276009,
  [SMALL_STATE(15279)] = 276023,
  [SMALL_STATE(15280)] = 276043,
  [SMALL_STATE(15281)] = 276057,
  [SMALL_STATE(15282)] = 276071,
  [SMALL_STATE(15283)] = 276085,
  [SMALL_STATE(15284)] = 276105,
  [SMALL_STATE(15285)] = 276119,
  [SMALL_STATE(15286)] = 276133,
  [SMALL_STATE(15287)] = 276147,
  [SMALL_STATE(15288)] = 276161,
  [SMALL_STATE(15289)] = 276175,
  [SMALL_STATE(15290)] = 276191,
  [SMALL_STATE(15291)] = 276211,
  [SMALL_STATE(15292)] = 276227,
  [SMALL_STATE(15293)] = 276241,
  [SMALL_STATE(15294)] = 276255,
  [SMALL_STATE(15295)] = 276269,
  [SMALL_STATE(15296)] = 276283,
  [SMALL_STATE(15297)] = 276297,
  [SMALL_STATE(15298)] = 276311,
  [SMALL_STATE(15299)] = 276329,
  [SMALL_STATE(15300)] = 276343,
  [SMALL_STATE(15301)] = 276359,
  [SMALL_STATE(15302)] = 276373,
  [SMALL_STATE(15303)] = 276389,
  [SMALL_STATE(15304)] = 276403,
  [SMALL_STATE(15305)] = 276425,
  [SMALL_STATE(15306)] = 276445,
  [SMALL_STATE(15307)] = 276459,
  [SMALL_STATE(15308)] = 276473,
  [SMALL_STATE(15309)] = 276487,
  [SMALL_STATE(15310)] = 276501,
  [SMALL_STATE(15311)] = 276515,
  [SMALL_STATE(15312)] = 276531,
  [SMALL_STATE(15313)] = 276551,
  [SMALL_STATE(15314)] = 276567,
  [SMALL_STATE(15315)] = 276587,
  [SMALL_STATE(15316)] = 276601,
  [SMALL_STATE(15317)] = 276615,
  [SMALL_STATE(15318)] = 276631,
  [SMALL_STATE(15319)] = 276645,
  [SMALL_STATE(15320)] = 276659,
  [SMALL_STATE(15321)] = 276675,
  [SMALL_STATE(15322)] = 276689,
  [SMALL_STATE(15323)] = 276705,
  [SMALL_STATE(15324)] = 276719,
  [SMALL_STATE(15325)] = 276733,
  [SMALL_STATE(15326)] = 276751,
  [SMALL_STATE(15327)] = 276767,
  [SMALL_STATE(15328)] = 276787,
  [SMALL_STATE(15329)] = 276803,
  [SMALL_STATE(15330)] = 276817,
  [SMALL_STATE(15331)] = 276831,
  [SMALL_STATE(15332)] = 276847,
  [SMALL_STATE(15333)] = 276863,
  [SMALL_STATE(15334)] = 276879,
  [SMALL_STATE(15335)] = 276899,
  [SMALL_STATE(15336)] = 276913,
  [SMALL_STATE(15337)] = 276931,
  [SMALL_STATE(15338)] = 276951,
  [SMALL_STATE(15339)] = 276965,
  [SMALL_STATE(15340)] = 276981,
  [SMALL_STATE(15341)] = 276995,
  [SMALL_STATE(15342)] = 277011,
  [SMALL_STATE(15343)] = 277025,
  [SMALL_STATE(15344)] = 277041,
  [SMALL_STATE(15345)] = 277055,
  [SMALL_STATE(15346)] = 277069,
  [SMALL_STATE(15347)] = 277083,
  [SMALL_STATE(15348)] = 277097,
  [SMALL_STATE(15349)] = 277113,
  [SMALL_STATE(15350)] = 277133,
  [SMALL_STATE(15351)] = 277147,
  [SMALL_STATE(15352)] = 277163,
  [SMALL_STATE(15353)] = 277179,
  [SMALL_STATE(15354)] = 277193,
  [SMALL_STATE(15355)] = 277207,
  [SMALL_STATE(15356)] = 277221,
  [SMALL_STATE(15357)] = 277235,
  [SMALL_STATE(15358)] = 277249,
  [SMALL_STATE(15359)] = 277265,
  [SMALL_STATE(15360)] = 277279,
  [SMALL_STATE(15361)] = 277295,
  [SMALL_STATE(15362)] = 277309,
  [SMALL_STATE(15363)] = 277323,
  [SMALL_STATE(15364)] = 277337,
  [SMALL_STATE(15365)] = 277351,
  [SMALL_STATE(15366)] = 277369,
  [SMALL_STATE(15367)] = 277389,
  [SMALL_STATE(15368)] = 277409,
  [SMALL_STATE(15369)] = 277425,
  [SMALL_STATE(15370)] = 277439,
  [SMALL_STATE(15371)] = 277453,
  [SMALL_STATE(15372)] = 277467,
  [SMALL_STATE(15373)] = 277481,
  [SMALL_STATE(15374)] = 277495,
  [SMALL_STATE(15375)] = 277513,
  [SMALL_STATE(15376)] = 277527,
  [SMALL_STATE(15377)] = 277547,
  [SMALL_STATE(15378)] = 277561,
  [SMALL_STATE(15379)] = 277575,
  [SMALL_STATE(15380)] = 277589,
  [SMALL_STATE(15381)] = 277607,
  [SMALL_STATE(15382)] = 277621,
  [SMALL_STATE(15383)] = 277635,
  [SMALL_STATE(15384)] = 277653,
  [SMALL_STATE(15385)] = 277667,
  [SMALL_STATE(15386)] = 277681,
  [SMALL_STATE(15387)] = 277695,
  [SMALL_STATE(15388)] = 277709,
  [SMALL_STATE(15389)] = 277729,
  [SMALL_STATE(15390)] = 277743,
  [SMALL_STATE(15391)] = 277757,
  [SMALL_STATE(15392)] = 277771,
  [SMALL_STATE(15393)] = 277787,
  [SMALL_STATE(15394)] = 277807,
  [SMALL_STATE(15395)] = 277821,
  [SMALL_STATE(15396)] = 277835,
  [SMALL_STATE(15397)] = 277849,
  [SMALL_STATE(15398)] = 277863,
  [SMALL_STATE(15399)] = 277877,
  [SMALL_STATE(15400)] = 277891,
  [SMALL_STATE(15401)] = 277905,
  [SMALL_STATE(15402)] = 277919,
  [SMALL_STATE(15403)] = 277933,
  [SMALL_STATE(15404)] = 277947,
  [SMALL_STATE(15405)] = 277969,
  [SMALL_STATE(15406)] = 277983,
  [SMALL_STATE(15407)] = 277997,
  [SMALL_STATE(15408)] = 278011,
  [SMALL_STATE(15409)] = 278031,
  [SMALL_STATE(15410)] = 278045,
  [SMALL_STATE(15411)] = 278059,
  [SMALL_STATE(15412)] = 278073,
  [SMALL_STATE(15413)] = 278087,
  [SMALL_STATE(15414)] = 278107,
  [SMALL_STATE(15415)] = 278121,
  [SMALL_STATE(15416)] = 278135,
  [SMALL_STATE(15417)] = 278155,
  [SMALL_STATE(15418)] = 278169,
  [SMALL_STATE(15419)] = 278183,
  [SMALL_STATE(15420)] = 278203,
  [SMALL_STATE(15421)] = 278217,
  [SMALL_STATE(15422)] = 278231,
  [SMALL_STATE(15423)] = 278245,
  [SMALL_STATE(15424)] = 278265,
  [SMALL_STATE(15425)] = 278279,
  [SMALL_STATE(15426)] = 278299,
  [SMALL_STATE(15427)] = 278313,
  [SMALL_STATE(15428)] = 278327,
  [SMALL_STATE(15429)] = 278341,
  [SMALL_STATE(15430)] = 278355,
  [SMALL_STATE(15431)] = 278369,
  [SMALL_STATE(15432)] = 278389,
  [SMALL_STATE(15433)] = 278403,
  [SMALL_STATE(15434)] = 278417,
  [SMALL_STATE(15435)] = 278431,
  [SMALL_STATE(15436)] = 278445,
  [SMALL_STATE(15437)] = 278459,
  [SMALL_STATE(15438)] = 278473,
  [SMALL_STATE(15439)] = 278493,
  [SMALL_STATE(15440)] = 278507,
  [SMALL_STATE(15441)] = 278527,
  [SMALL_STATE(15442)] = 278541,
  [SMALL_STATE(15443)] = 278555,
  [SMALL_STATE(15444)] = 278569,
  [SMALL_STATE(15445)] = 278589,
  [SMALL_STATE(15446)] = 278603,
  [SMALL_STATE(15447)] = 278617,
  [SMALL_STATE(15448)] = 278631,
  [SMALL_STATE(15449)] = 278645,
  [SMALL_STATE(15450)] = 278659,
  [SMALL_STATE(15451)] = 278673,
  [SMALL_STATE(15452)] = 278687,
  [SMALL_STATE(15453)] = 278701,
  [SMALL_STATE(15454)] = 278715,
  [SMALL_STATE(15455)] = 278729,
  [SMALL_STATE(15456)] = 278743,
  [SMALL_STATE(15457)] = 278757,
  [SMALL_STATE(15458)] = 278771,
  [SMALL_STATE(15459)] = 278785,
  [SMALL_STATE(15460)] = 278805,
  [SMALL_STATE(15461)] = 278819,
  [SMALL_STATE(15462)] = 278833,
  [SMALL_STATE(15463)] = 278847,
  [SMALL_STATE(15464)] = 278861,
  [SMALL_STATE(15465)] = 278881,
  [SMALL_STATE(15466)] = 278898,
  [SMALL_STATE(15467)] = 278913,
  [SMALL_STATE(15468)] = 278928,
  [SMALL_STATE(15469)] = 278943,
  [SMALL_STATE(15470)] = 278958,
  [SMALL_STATE(15471)] = 278973,
  [SMALL_STATE(15472)] = 278988,
  [SMALL_STATE(15473)] = 279005,
  [SMALL_STATE(15474)] = 279022,
  [SMALL_STATE(15475)] = 279039,
  [SMALL_STATE(15476)] = 279058,
  [SMALL_STATE(15477)] = 279075,
  [SMALL_STATE(15478)] = 279092,
  [SMALL_STATE(15479)] = 279107,
  [SMALL_STATE(15480)] = 279122,
  [SMALL_STATE(15481)] = 279139,
  [SMALL_STATE(15482)] = 279156,
  [SMALL_STATE(15483)] = 279173,
  [SMALL_STATE(15484)] = 279192,
  [SMALL_STATE(15485)] = 279211,
  [SMALL_STATE(15486)] = 279228,
  [SMALL_STATE(15487)] = 279245,
  [SMALL_STATE(15488)] = 279260,
  [SMALL_STATE(15489)] = 279275,
  [SMALL_STATE(15490)] = 279294,
  [SMALL_STATE(15491)] = 279313,
  [SMALL_STATE(15492)] = 279330,
  [SMALL_STATE(15493)] = 279349,
  [SMALL_STATE(15494)] = 279366,
  [SMALL_STATE(15495)] = 279377,
  [SMALL_STATE(15496)] = 279392,
  [SMALL_STATE(15497)] = 279407,
  [SMALL_STATE(15498)] = 279424,
  [SMALL_STATE(15499)] = 279443,
  [SMALL_STATE(15500)] = 279460,
  [SMALL_STATE(15501)] = 279475,
  [SMALL_STATE(15502)] = 279490,
  [SMALL_STATE(15503)] = 279507,
  [SMALL_STATE(15504)] = 279522,
  [SMALL_STATE(15505)] = 279537,
  [SMALL_STATE(15506)] = 279556,
  [SMALL_STATE(15507)] = 279573,
  [SMALL_STATE(15508)] = 279590,
  [SMALL_STATE(15509)] = 279607,
  [SMALL_STATE(15510)] = 279622,
  [SMALL_STATE(15511)] = 279637,
  [SMALL_STATE(15512)] = 279654,
  [SMALL_STATE(15513)] = 279669,
  [SMALL_STATE(15514)] = 279684,
  [SMALL_STATE(15515)] = 279701,
  [SMALL_STATE(15516)] = 279718,
  [SMALL_STATE(15517)] = 279735,
  [SMALL_STATE(15518)] = 279752,
  [SMALL_STATE(15519)] = 279769,
  [SMALL_STATE(15520)] = 279788,
  [SMALL_STATE(15521)] = 279803,
  [SMALL_STATE(15522)] = 279818,
  [SMALL_STATE(15523)] = 279833,
  [SMALL_STATE(15524)] = 279850,
  [SMALL_STATE(15525)] = 279865,
  [SMALL_STATE(15526)] = 279884,
  [SMALL_STATE(15527)] = 279901,
  [SMALL_STATE(15528)] = 279918,
  [SMALL_STATE(15529)] = 279933,
  [SMALL_STATE(15530)] = 279948,
  [SMALL_STATE(15531)] = 279967,
  [SMALL_STATE(15532)] = 279986,
  [SMALL_STATE(15533)] = 280005,
  [SMALL_STATE(15534)] = 280022,
  [SMALL_STATE(15535)] = 280039,
  [SMALL_STATE(15536)] = 280054,
  [SMALL_STATE(15537)] = 280069,
  [SMALL_STATE(15538)] = 280088,
  [SMALL_STATE(15539)] = 280103,
  [SMALL_STATE(15540)] = 280118,
  [SMALL_STATE(15541)] = 280133,
  [SMALL_STATE(15542)] = 280148,
  [SMALL_STATE(15543)] = 280167,
  [SMALL_STATE(15544)] = 280184,
  [SMALL_STATE(15545)] = 280199,
  [SMALL_STATE(15546)] = 280214,
  [SMALL_STATE(15547)] = 280229,
  [SMALL_STATE(15548)] = 280246,
  [SMALL_STATE(15549)] = 280261,
  [SMALL_STATE(15550)] = 280278,
  [SMALL_STATE(15551)] = 280295,
  [SMALL_STATE(15552)] = 280314,
  [SMALL_STATE(15553)] = 280331,
  [SMALL_STATE(15554)] = 280350,
  [SMALL_STATE(15555)] = 280365,
  [SMALL_STATE(15556)] = 280380,
  [SMALL_STATE(15557)] = 280397,
  [SMALL_STATE(15558)] = 280416,
  [SMALL_STATE(15559)] = 280433,
  [SMALL_STATE(15560)] = 280450,
  [SMALL_STATE(15561)] = 280465,
  [SMALL_STATE(15562)] = 280480,
  [SMALL_STATE(15563)] = 280499,
  [SMALL_STATE(15564)] = 280516,
  [SMALL_STATE(15565)] = 280531,
  [SMALL_STATE(15566)] = 280546,
  [SMALL_STATE(15567)] = 280563,
  [SMALL_STATE(15568)] = 280582,
  [SMALL_STATE(15569)] = 280599,
  [SMALL_STATE(15570)] = 280616,
  [SMALL_STATE(15571)] = 280633,
  [SMALL_STATE(15572)] = 280650,
  [SMALL_STATE(15573)] = 280667,
  [SMALL_STATE(15574)] = 280684,
  [SMALL_STATE(15575)] = 280701,
  [SMALL_STATE(15576)] = 280720,
  [SMALL_STATE(15577)] = 280737,
  [SMALL_STATE(15578)] = 280752,
  [SMALL_STATE(15579)] = 280767,
  [SMALL_STATE(15580)] = 280784,
  [SMALL_STATE(15581)] = 280801,
  [SMALL_STATE(15582)] = 280812,
  [SMALL_STATE(15583)] = 280829,
  [SMALL_STATE(15584)] = 280848,
  [SMALL_STATE(15585)] = 280863,
  [SMALL_STATE(15586)] = 280878,
  [SMALL_STATE(15587)] = 280895,
  [SMALL_STATE(15588)] = 280912,
  [SMALL_STATE(15589)] = 280927,
  [SMALL_STATE(15590)] = 280942,
  [SMALL_STATE(15591)] = 280959,
  [SMALL_STATE(15592)] = 280978,
  [SMALL_STATE(15593)] = 280997,
  [SMALL_STATE(15594)] = 281014,
  [SMALL_STATE(15595)] = 281031,
  [SMALL_STATE(15596)] = 281050,
  [SMALL_STATE(15597)] = 281069,
  [SMALL_STATE(15598)] = 281088,
  [SMALL_STATE(15599)] = 281103,
  [SMALL_STATE(15600)] = 281118,
  [SMALL_STATE(15601)] = 281137,
  [SMALL_STATE(15602)] = 281156,
  [SMALL_STATE(15603)] = 281175,
  [SMALL_STATE(15604)] = 281190,
  [SMALL_STATE(15605)] = 281205,
  [SMALL_STATE(15606)] = 281222,
  [SMALL_STATE(15607)] = 281239,
  [SMALL_STATE(15608)] = 281258,
  [SMALL_STATE(15609)] = 281275,
  [SMALL_STATE(15610)] = 281290,
  [SMALL_STATE(15611)] = 281305,
  [SMALL_STATE(15612)] = 281322,
  [SMALL_STATE(15613)] = 281341,
  [SMALL_STATE(15614)] = 281360,
  [SMALL_STATE(15615)] = 281377,
  [SMALL_STATE(15616)] = 281392,
  [SMALL_STATE(15617)] = 281407,
  [SMALL_STATE(15618)] = 281424,
  [SMALL_STATE(15619)] = 281439,
  [SMALL_STATE(15620)] = 281456,
  [SMALL_STATE(15621)] = 281473,
  [SMALL_STATE(15622)] = 281490,
  [SMALL_STATE(15623)] = 281509,
  [SMALL_STATE(15624)] = 281524,
  [SMALL_STATE(15625)] = 281539,
  [SMALL_STATE(15626)] = 281554,
  [SMALL_STATE(15627)] = 281571,
  [SMALL_STATE(15628)] = 281590,
  [SMALL_STATE(15629)] = 281607,
  [SMALL_STATE(15630)] = 281622,
  [SMALL_STATE(15631)] = 281641,
  [SMALL_STATE(15632)] = 281656,
  [SMALL_STATE(15633)] = 281671,
  [SMALL_STATE(15634)] = 281686,
  [SMALL_STATE(15635)] = 281703,
  [SMALL_STATE(15636)] = 281722,
  [SMALL_STATE(15637)] = 281739,
  [SMALL_STATE(15638)] = 281754,
  [SMALL_STATE(15639)] = 281769,
  [SMALL_STATE(15640)] = 281786,
  [SMALL_STATE(15641)] = 281805,
  [SMALL_STATE(15642)] = 281820,
  [SMALL_STATE(15643)] = 281835,
  [SMALL_STATE(15644)] = 281852,
  [SMALL_STATE(15645)] = 281867,
  [SMALL_STATE(15646)] = 281882,
  [SMALL_STATE(15647)] = 281897,
  [SMALL_STATE(15648)] = 281914,
  [SMALL_STATE(15649)] = 281931,
  [SMALL_STATE(15650)] = 281946,
  [SMALL_STATE(15651)] = 281963,
  [SMALL_STATE(15652)] = 281980,
  [SMALL_STATE(15653)] = 281997,
  [SMALL_STATE(15654)] = 282016,
  [SMALL_STATE(15655)] = 282031,
  [SMALL_STATE(15656)] = 282046,
  [SMALL_STATE(15657)] = 282061,
  [SMALL_STATE(15658)] = 282078,
  [SMALL_STATE(15659)] = 282095,
  [SMALL_STATE(15660)] = 282110,
  [SMALL_STATE(15661)] = 282129,
  [SMALL_STATE(15662)] = 282146,
  [SMALL_STATE(15663)] = 282163,
  [SMALL_STATE(15664)] = 282178,
  [SMALL_STATE(15665)] = 282193,
  [SMALL_STATE(15666)] = 282210,
  [SMALL_STATE(15667)] = 282227,
  [SMALL_STATE(15668)] = 282244,
  [SMALL_STATE(15669)] = 282261,
  [SMALL_STATE(15670)] = 282278,
  [SMALL_STATE(15671)] = 282295,
  [SMALL_STATE(15672)] = 282314,
  [SMALL_STATE(15673)] = 282329,
  [SMALL_STATE(15674)] = 282346,
  [SMALL_STATE(15675)] = 282363,
  [SMALL_STATE(15676)] = 282378,
  [SMALL_STATE(15677)] = 282397,
  [SMALL_STATE(15678)] = 282416,
  [SMALL_STATE(15679)] = 282433,
  [SMALL_STATE(15680)] = 282448,
  [SMALL_STATE(15681)] = 282463,
  [SMALL_STATE(15682)] = 282480,
  [SMALL_STATE(15683)] = 282497,
  [SMALL_STATE(15684)] = 282516,
  [SMALL_STATE(15685)] = 282531,
  [SMALL_STATE(15686)] = 282546,
  [SMALL_STATE(15687)] = 282561,
  [SMALL_STATE(15688)] = 282578,
  [SMALL_STATE(15689)] = 282595,
  [SMALL_STATE(15690)] = 282610,
  [SMALL_STATE(15691)] = 282625,
  [SMALL_STATE(15692)] = 282642,
  [SMALL_STATE(15693)] = 282659,
  [SMALL_STATE(15694)] = 282676,
  [SMALL_STATE(15695)] = 282695,
  [SMALL_STATE(15696)] = 282710,
  [SMALL_STATE(15697)] = 282725,
  [SMALL_STATE(15698)] = 282744,
  [SMALL_STATE(15699)] = 282761,
  [SMALL_STATE(15700)] = 282780,
  [SMALL_STATE(15701)] = 282799,
  [SMALL_STATE(15702)] = 282814,
  [SMALL_STATE(15703)] = 282829,
  [SMALL_STATE(15704)] = 282846,
  [SMALL_STATE(15705)] = 282863,
  [SMALL_STATE(15706)] = 282882,
  [SMALL_STATE(15707)] = 282899,
  [SMALL_STATE(15708)] = 282916,
  [SMALL_STATE(15709)] = 282933,
  [SMALL_STATE(15710)] = 282948,
  [SMALL_STATE(15711)] = 282963,
  [SMALL_STATE(15712)] = 282982,
  [SMALL_STATE(15713)] = 282997,
  [SMALL_STATE(15714)] = 283012,
  [SMALL_STATE(15715)] = 283029,
  [SMALL_STATE(15716)] = 283048,
  [SMALL_STATE(15717)] = 283065,
  [SMALL_STATE(15718)] = 283080,
  [SMALL_STATE(15719)] = 283095,
  [SMALL_STATE(15720)] = 283112,
  [SMALL_STATE(15721)] = 283129,
  [SMALL_STATE(15722)] = 283146,
  [SMALL_STATE(15723)] = 283163,
  [SMALL_STATE(15724)] = 283180,
  [SMALL_STATE(15725)] = 283195,
  [SMALL_STATE(15726)] = 283210,
  [SMALL_STATE(15727)] = 283229,
  [SMALL_STATE(15728)] = 283246,
  [SMALL_STATE(15729)] = 283261,
  [SMALL_STATE(15730)] = 283276,
  [SMALL_STATE(15731)] = 283293,
  [SMALL_STATE(15732)] = 283310,
  [SMALL_STATE(15733)] = 283327,
  [SMALL_STATE(15734)] = 283346,
  [SMALL_STATE(15735)] = 283363,
  [SMALL_STATE(15736)] = 283378,
  [SMALL_STATE(15737)] = 283395,
  [SMALL_STATE(15738)] = 283410,
  [SMALL_STATE(15739)] = 283425,
  [SMALL_STATE(15740)] = 283442,
  [SMALL_STATE(15741)] = 283459,
  [SMALL_STATE(15742)] = 283476,
  [SMALL_STATE(15743)] = 283493,
  [SMALL_STATE(15744)] = 283510,
  [SMALL_STATE(15745)] = 283527,
  [SMALL_STATE(15746)] = 283546,
  [SMALL_STATE(15747)] = 283561,
  [SMALL_STATE(15748)] = 283576,
  [SMALL_STATE(15749)] = 283595,
  [SMALL_STATE(15750)] = 283612,
  [SMALL_STATE(15751)] = 283631,
  [SMALL_STATE(15752)] = 283648,
  [SMALL_STATE(15753)] = 283663,
  [SMALL_STATE(15754)] = 283678,
  [SMALL_STATE(15755)] = 283693,
  [SMALL_STATE(15756)] = 283712,
  [SMALL_STATE(15757)] = 283729,
  [SMALL_STATE(15758)] = 283748,
  [SMALL_STATE(15759)] = 283763,
  [SMALL_STATE(15760)] = 283778,
  [SMALL_STATE(15761)] = 283795,
  [SMALL_STATE(15762)] = 283814,
  [SMALL_STATE(15763)] = 283831,
  [SMALL_STATE(15764)] = 283846,
  [SMALL_STATE(15765)] = 283861,
  [SMALL_STATE(15766)] = 283878,
  [SMALL_STATE(15767)] = 283897,
  [SMALL_STATE(15768)] = 283914,
  [SMALL_STATE(15769)] = 283929,
  [SMALL_STATE(15770)] = 283944,
  [SMALL_STATE(15771)] = 283959,
  [SMALL_STATE(15772)] = 283978,
  [SMALL_STATE(15773)] = 283995,
  [SMALL_STATE(15774)] = 284014,
  [SMALL_STATE(15775)] = 284033,
  [SMALL_STATE(15776)] = 284050,
  [SMALL_STATE(15777)] = 284067,
  [SMALL_STATE(15778)] = 284084,
  [SMALL_STATE(15779)] = 284103,
  [SMALL_STATE(15780)] = 284122,
  [SMALL_STATE(15781)] = 284137,
  [SMALL_STATE(15782)] = 284152,
  [SMALL_STATE(15783)] = 284167,
  [SMALL_STATE(15784)] = 284182,
  [SMALL_STATE(15785)] = 284199,
  [SMALL_STATE(15786)] = 284218,
  [SMALL_STATE(15787)] = 284235,
  [SMALL_STATE(15788)] = 284250,
  [SMALL_STATE(15789)] = 284265,
  [SMALL_STATE(15790)] = 284282,
  [SMALL_STATE(15791)] = 284297,
  [SMALL_STATE(15792)] = 284312,
  [SMALL_STATE(15793)] = 284329,
  [SMALL_STATE(15794)] = 284344,
  [SMALL_STATE(15795)] = 284361,
  [SMALL_STATE(15796)] = 284378,
  [SMALL_STATE(15797)] = 284397,
  [SMALL_STATE(15798)] = 284414,
  [SMALL_STATE(15799)] = 284429,
  [SMALL_STATE(15800)] = 284444,
  [SMALL_STATE(15801)] = 284461,
  [SMALL_STATE(15802)] = 284478,
  [SMALL_STATE(15803)] = 284493,
  [SMALL_STATE(15804)] = 284512,
  [SMALL_STATE(15805)] = 284527,
  [SMALL_STATE(15806)] = 284546,
  [SMALL_STATE(15807)] = 284561,
  [SMALL_STATE(15808)] = 284576,
  [SMALL_STATE(15809)] = 284593,
  [SMALL_STATE(15810)] = 284608,
  [SMALL_STATE(15811)] = 284625,
  [SMALL_STATE(15812)] = 284642,
  [SMALL_STATE(15813)] = 284659,
  [SMALL_STATE(15814)] = 284678,
  [SMALL_STATE(15815)] = 284695,
  [SMALL_STATE(15816)] = 284710,
  [SMALL_STATE(15817)] = 284725,
  [SMALL_STATE(15818)] = 284744,
  [SMALL_STATE(15819)] = 284759,
  [SMALL_STATE(15820)] = 284778,
  [SMALL_STATE(15821)] = 284795,
  [SMALL_STATE(15822)] = 284810,
  [SMALL_STATE(15823)] = 284825,
  [SMALL_STATE(15824)] = 284840,
  [SMALL_STATE(15825)] = 284855,
  [SMALL_STATE(15826)] = 284872,
  [SMALL_STATE(15827)] = 284887,
  [SMALL_STATE(15828)] = 284904,
  [SMALL_STATE(15829)] = 284921,
  [SMALL_STATE(15830)] = 284940,
  [SMALL_STATE(15831)] = 284959,
  [SMALL_STATE(15832)] = 284976,
  [SMALL_STATE(15833)] = 284995,
  [SMALL_STATE(15834)] = 285010,
  [SMALL_STATE(15835)] = 285025,
  [SMALL_STATE(15836)] = 285042,
  [SMALL_STATE(15837)] = 285057,
  [SMALL_STATE(15838)] = 285074,
  [SMALL_STATE(15839)] = 285093,
  [SMALL_STATE(15840)] = 285110,
  [SMALL_STATE(15841)] = 285129,
  [SMALL_STATE(15842)] = 285144,
  [SMALL_STATE(15843)] = 285159,
  [SMALL_STATE(15844)] = 285178,
  [SMALL_STATE(15845)] = 285197,
  [SMALL_STATE(15846)] = 285212,
  [SMALL_STATE(15847)] = 285227,
  [SMALL_STATE(15848)] = 285242,
  [SMALL_STATE(15849)] = 285257,
  [SMALL_STATE(15850)] = 285272,
  [SMALL_STATE(15851)] = 285287,
  [SMALL_STATE(15852)] = 285302,
  [SMALL_STATE(15853)] = 285317,
  [SMALL_STATE(15854)] = 285332,
  [SMALL_STATE(15855)] = 285347,
  [SMALL_STATE(15856)] = 285362,
  [SMALL_STATE(15857)] = 285377,
  [SMALL_STATE(15858)] = 285392,
  [SMALL_STATE(15859)] = 285407,
  [SMALL_STATE(15860)] = 285422,
  [SMALL_STATE(15861)] = 285437,
  [SMALL_STATE(15862)] = 285452,
  [SMALL_STATE(15863)] = 285467,
  [SMALL_STATE(15864)] = 285482,
  [SMALL_STATE(15865)] = 285497,
  [SMALL_STATE(15866)] = 285512,
  [SMALL_STATE(15867)] = 285527,
  [SMALL_STATE(15868)] = 285542,
  [SMALL_STATE(15869)] = 285557,
  [SMALL_STATE(15870)] = 285572,
  [SMALL_STATE(15871)] = 285587,
  [SMALL_STATE(15872)] = 285602,
  [SMALL_STATE(15873)] = 285617,
  [SMALL_STATE(15874)] = 285634,
  [SMALL_STATE(15875)] = 285649,
  [SMALL_STATE(15876)] = 285664,
  [SMALL_STATE(15877)] = 285679,
  [SMALL_STATE(15878)] = 285694,
  [SMALL_STATE(15879)] = 285709,
  [SMALL_STATE(15880)] = 285724,
  [SMALL_STATE(15881)] = 285739,
  [SMALL_STATE(15882)] = 285754,
  [SMALL_STATE(15883)] = 285769,
  [SMALL_STATE(15884)] = 285784,
  [SMALL_STATE(15885)] = 285799,
  [SMALL_STATE(15886)] = 285814,
  [SMALL_STATE(15887)] = 285831,
  [SMALL_STATE(15888)] = 285846,
  [SMALL_STATE(15889)] = 285861,
  [SMALL_STATE(15890)] = 285876,
  [SMALL_STATE(15891)] = 285891,
  [SMALL_STATE(15892)] = 285906,
  [SMALL_STATE(15893)] = 285921,
  [SMALL_STATE(15894)] = 285936,
  [SMALL_STATE(15895)] = 285951,
  [SMALL_STATE(15896)] = 285966,
  [SMALL_STATE(15897)] = 285981,
  [SMALL_STATE(15898)] = 285996,
  [SMALL_STATE(15899)] = 286011,
  [SMALL_STATE(15900)] = 286030,
  [SMALL_STATE(15901)] = 286045,
  [SMALL_STATE(15902)] = 286060,
  [SMALL_STATE(15903)] = 286075,
  [SMALL_STATE(15904)] = 286090,
  [SMALL_STATE(15905)] = 286105,
  [SMALL_STATE(15906)] = 286122,
  [SMALL_STATE(15907)] = 286137,
  [SMALL_STATE(15908)] = 286152,
  [SMALL_STATE(15909)] = 286167,
  [SMALL_STATE(15910)] = 286182,
  [SMALL_STATE(15911)] = 286197,
  [SMALL_STATE(15912)] = 286214,
  [SMALL_STATE(15913)] = 286229,
  [SMALL_STATE(15914)] = 286244,
  [SMALL_STATE(15915)] = 286259,
  [SMALL_STATE(15916)] = 286274,
  [SMALL_STATE(15917)] = 286291,
  [SMALL_STATE(15918)] = 286306,
  [SMALL_STATE(15919)] = 286321,
  [SMALL_STATE(15920)] = 286336,
  [SMALL_STATE(15921)] = 286351,
  [SMALL_STATE(15922)] = 286366,
  [SMALL_STATE(15923)] = 286381,
  [SMALL_STATE(15924)] = 286396,
  [SMALL_STATE(15925)] = 286411,
  [SMALL_STATE(15926)] = 286426,
  [SMALL_STATE(15927)] = 286441,
  [SMALL_STATE(15928)] = 286456,
  [SMALL_STATE(15929)] = 286471,
  [SMALL_STATE(15930)] = 286486,
  [SMALL_STATE(15931)] = 286501,
  [SMALL_STATE(15932)] = 286516,
  [SMALL_STATE(15933)] = 286531,
  [SMALL_STATE(15934)] = 286546,
  [SMALL_STATE(15935)] = 286565,
  [SMALL_STATE(15936)] = 286580,
  [SMALL_STATE(15937)] = 286595,
  [SMALL_STATE(15938)] = 286610,
  [SMALL_STATE(15939)] = 286625,
  [SMALL_STATE(15940)] = 286644,
  [SMALL_STATE(15941)] = 286659,
  [SMALL_STATE(15942)] = 286674,
  [SMALL_STATE(15943)] = 286689,
  [SMALL_STATE(15944)] = 286704,
  [SMALL_STATE(15945)] = 286721,
  [SMALL_STATE(15946)] = 286736,
  [SMALL_STATE(15947)] = 286751,
  [SMALL_STATE(15948)] = 286766,
  [SMALL_STATE(15949)] = 286781,
  [SMALL_STATE(15950)] = 286798,
  [SMALL_STATE(15951)] = 286815,
  [SMALL_STATE(15952)] = 286830,
  [SMALL_STATE(15953)] = 286845,
  [SMALL_STATE(15954)] = 286860,
  [SMALL_STATE(15955)] = 286875,
  [SMALL_STATE(15956)] = 286890,
  [SMALL_STATE(15957)] = 286905,
  [SMALL_STATE(15958)] = 286920,
  [SMALL_STATE(15959)] = 286935,
  [SMALL_STATE(15960)] = 286950,
  [SMALL_STATE(15961)] = 286965,
  [SMALL_STATE(15962)] = 286980,
  [SMALL_STATE(15963)] = 286995,
  [SMALL_STATE(15964)] = 287010,
  [SMALL_STATE(15965)] = 287025,
  [SMALL_STATE(15966)] = 287040,
  [SMALL_STATE(15967)] = 287055,
  [SMALL_STATE(15968)] = 287072,
  [SMALL_STATE(15969)] = 287087,
  [SMALL_STATE(15970)] = 287102,
  [SMALL_STATE(15971)] = 287117,
  [SMALL_STATE(15972)] = 287132,
  [SMALL_STATE(15973)] = 287147,
  [SMALL_STATE(15974)] = 287162,
  [SMALL_STATE(15975)] = 287177,
  [SMALL_STATE(15976)] = 287192,
  [SMALL_STATE(15977)] = 287207,
  [SMALL_STATE(15978)] = 287222,
  [SMALL_STATE(15979)] = 287237,
  [SMALL_STATE(15980)] = 287252,
  [SMALL_STATE(15981)] = 287267,
  [SMALL_STATE(15982)] = 287282,
  [SMALL_STATE(15983)] = 287297,
  [SMALL_STATE(15984)] = 287312,
  [SMALL_STATE(15985)] = 287327,
  [SMALL_STATE(15986)] = 287342,
  [SMALL_STATE(15987)] = 287357,
  [SMALL_STATE(15988)] = 287372,
  [SMALL_STATE(15989)] = 287387,
  [SMALL_STATE(15990)] = 287402,
  [SMALL_STATE(15991)] = 287417,
  [SMALL_STATE(15992)] = 287432,
  [SMALL_STATE(15993)] = 287447,
  [SMALL_STATE(15994)] = 287462,
  [SMALL_STATE(15995)] = 287477,
  [SMALL_STATE(15996)] = 287492,
  [SMALL_STATE(15997)] = 287507,
  [SMALL_STATE(15998)] = 287522,
  [SMALL_STATE(15999)] = 287537,
  [SMALL_STATE(16000)] = 287552,
  [SMALL_STATE(16001)] = 287569,
  [SMALL_STATE(16002)] = 287584,
  [SMALL_STATE(16003)] = 287599,
  [SMALL_STATE(16004)] = 287614,
  [SMALL_STATE(16005)] = 287629,
  [SMALL_STATE(16006)] = 287644,
  [SMALL_STATE(16007)] = 287659,
  [SMALL_STATE(16008)] = 287674,
  [SMALL_STATE(16009)] = 287689,
  [SMALL_STATE(16010)] = 287706,
  [SMALL_STATE(16011)] = 287721,
  [SMALL_STATE(16012)] = 287736,
  [SMALL_STATE(16013)] = 287751,
  [SMALL_STATE(16014)] = 287766,
  [SMALL_STATE(16015)] = 287781,
  [SMALL_STATE(16016)] = 287796,
  [SMALL_STATE(16017)] = 287811,
  [SMALL_STATE(16018)] = 287826,
  [SMALL_STATE(16019)] = 287843,
  [SMALL_STATE(16020)] = 287858,
  [SMALL_STATE(16021)] = 287873,
  [SMALL_STATE(16022)] = 287888,
  [SMALL_STATE(16023)] = 287903,
  [SMALL_STATE(16024)] = 287918,
  [SMALL_STATE(16025)] = 287933,
  [SMALL_STATE(16026)] = 287948,
  [SMALL_STATE(16027)] = 287963,
  [SMALL_STATE(16028)] = 287978,
  [SMALL_STATE(16029)] = 287993,
  [SMALL_STATE(16030)] = 288008,
  [SMALL_STATE(16031)] = 288023,
  [SMALL_STATE(16032)] = 288038,
  [SMALL_STATE(16033)] = 288053,
  [SMALL_STATE(16034)] = 288068,
  [SMALL_STATE(16035)] = 288083,
  [SMALL_STATE(16036)] = 288098,
  [SMALL_STATE(16037)] = 288113,
  [SMALL_STATE(16038)] = 288128,
  [SMALL_STATE(16039)] = 288145,
  [SMALL_STATE(16040)] = 288162,
  [SMALL_STATE(16041)] = 288179,
  [SMALL_STATE(16042)] = 288196,
  [SMALL_STATE(16043)] = 288211,
  [SMALL_STATE(16044)] = 288226,
  [SMALL_STATE(16045)] = 288241,
  [SMALL_STATE(16046)] = 288260,
  [SMALL_STATE(16047)] = 288275,
  [SMALL_STATE(16048)] = 288292,
  [SMALL_STATE(16049)] = 288307,
  [SMALL_STATE(16050)] = 288322,
  [SMALL_STATE(16051)] = 288341,
  [SMALL_STATE(16052)] = 288356,
  [SMALL_STATE(16053)] = 288373,
  [SMALL_STATE(16054)] = 288390,
  [SMALL_STATE(16055)] = 288407,
  [SMALL_STATE(16056)] = 288424,
  [SMALL_STATE(16057)] = 288441,
  [SMALL_STATE(16058)] = 288456,
  [SMALL_STATE(16059)] = 288475,
  [SMALL_STATE(16060)] = 288494,
  [SMALL_STATE(16061)] = 288511,
  [SMALL_STATE(16062)] = 288528,
  [SMALL_STATE(16063)] = 288545,
  [SMALL_STATE(16064)] = 288562,
  [SMALL_STATE(16065)] = 288579,
  [SMALL_STATE(16066)] = 288596,
  [SMALL_STATE(16067)] = 288613,
  [SMALL_STATE(16068)] = 288630,
  [SMALL_STATE(16069)] = 288645,
  [SMALL_STATE(16070)] = 288662,
  [SMALL_STATE(16071)] = 288679,
  [SMALL_STATE(16072)] = 288694,
  [SMALL_STATE(16073)] = 288709,
  [SMALL_STATE(16074)] = 288726,
  [SMALL_STATE(16075)] = 288743,
  [SMALL_STATE(16076)] = 288760,
  [SMALL_STATE(16077)] = 288777,
  [SMALL_STATE(16078)] = 288794,
  [SMALL_STATE(16079)] = 288813,
  [SMALL_STATE(16080)] = 288832,
  [SMALL_STATE(16081)] = 288843,
  [SMALL_STATE(16082)] = 288860,
  [SMALL_STATE(16083)] = 288875,
  [SMALL_STATE(16084)] = 288892,
  [SMALL_STATE(16085)] = 288909,
  [SMALL_STATE(16086)] = 288924,
  [SMALL_STATE(16087)] = 288935,
  [SMALL_STATE(16088)] = 288952,
  [SMALL_STATE(16089)] = 288967,
  [SMALL_STATE(16090)] = 288984,
  [SMALL_STATE(16091)] = 289003,
  [SMALL_STATE(16092)] = 289020,
  [SMALL_STATE(16093)] = 289037,
  [SMALL_STATE(16094)] = 289052,
  [SMALL_STATE(16095)] = 289067,
  [SMALL_STATE(16096)] = 289082,
  [SMALL_STATE(16097)] = 289099,
  [SMALL_STATE(16098)] = 289116,
  [SMALL_STATE(16099)] = 289133,
  [SMALL_STATE(16100)] = 289150,
  [SMALL_STATE(16101)] = 289169,
  [SMALL_STATE(16102)] = 289188,
  [SMALL_STATE(16103)] = 289205,
  [SMALL_STATE(16104)] = 289222,
  [SMALL_STATE(16105)] = 289239,
  [SMALL_STATE(16106)] = 289254,
  [SMALL_STATE(16107)] = 289269,
  [SMALL_STATE(16108)] = 289288,
  [SMALL_STATE(16109)] = 289305,
  [SMALL_STATE(16110)] = 289322,
  [SMALL_STATE(16111)] = 289339,
  [SMALL_STATE(16112)] = 289358,
  [SMALL_STATE(16113)] = 289373,
  [SMALL_STATE(16114)] = 289388,
  [SMALL_STATE(16115)] = 289405,
  [SMALL_STATE(16116)] = 289422,
  [SMALL_STATE(16117)] = 289439,
  [SMALL_STATE(16118)] = 289456,
  [SMALL_STATE(16119)] = 289473,
  [SMALL_STATE(16120)] = 289488,
  [SMALL_STATE(16121)] = 289503,
  [SMALL_STATE(16122)] = 289520,
  [SMALL_STATE(16123)] = 289537,
  [SMALL_STATE(16124)] = 289552,
  [SMALL_STATE(16125)] = 289569,
  [SMALL_STATE(16126)] = 289586,
  [SMALL_STATE(16127)] = 289601,
  [SMALL_STATE(16128)] = 289618,
  [SMALL_STATE(16129)] = 289635,
  [SMALL_STATE(16130)] = 289652,
  [SMALL_STATE(16131)] = 289669,
  [SMALL_STATE(16132)] = 289686,
  [SMALL_STATE(16133)] = 289701,
  [SMALL_STATE(16134)] = 289718,
  [SMALL_STATE(16135)] = 289735,
  [SMALL_STATE(16136)] = 289752,
  [SMALL_STATE(16137)] = 289769,
  [SMALL_STATE(16138)] = 289786,
  [SMALL_STATE(16139)] = 289805,
  [SMALL_STATE(16140)] = 289822,
  [SMALL_STATE(16141)] = 289841,
  [SMALL_STATE(16142)] = 289858,
  [SMALL_STATE(16143)] = 289877,
  [SMALL_STATE(16144)] = 289892,
  [SMALL_STATE(16145)] = 289911,
  [SMALL_STATE(16146)] = 289930,
  [SMALL_STATE(16147)] = 289945,
  [SMALL_STATE(16148)] = 289960,
  [SMALL_STATE(16149)] = 289979,
  [SMALL_STATE(16150)] = 289994,
  [SMALL_STATE(16151)] = 290009,
  [SMALL_STATE(16152)] = 290024,
  [SMALL_STATE(16153)] = 290039,
  [SMALL_STATE(16154)] = 290056,
  [SMALL_STATE(16155)] = 290073,
  [SMALL_STATE(16156)] = 290090,
  [SMALL_STATE(16157)] = 290107,
  [SMALL_STATE(16158)] = 290124,
  [SMALL_STATE(16159)] = 290141,
  [SMALL_STATE(16160)] = 290158,
  [SMALL_STATE(16161)] = 290169,
  [SMALL_STATE(16162)] = 290188,
  [SMALL_STATE(16163)] = 290205,
  [SMALL_STATE(16164)] = 290222,
  [SMALL_STATE(16165)] = 290237,
  [SMALL_STATE(16166)] = 290248,
  [SMALL_STATE(16167)] = 290263,
  [SMALL_STATE(16168)] = 290282,
  [SMALL_STATE(16169)] = 290299,
  [SMALL_STATE(16170)] = 290316,
  [SMALL_STATE(16171)] = 290333,
  [SMALL_STATE(16172)] = 290350,
  [SMALL_STATE(16173)] = 290365,
  [SMALL_STATE(16174)] = 290380,
  [SMALL_STATE(16175)] = 290395,
  [SMALL_STATE(16176)] = 290414,
  [SMALL_STATE(16177)] = 290431,
  [SMALL_STATE(16178)] = 290448,
  [SMALL_STATE(16179)] = 290465,
  [SMALL_STATE(16180)] = 290482,
  [SMALL_STATE(16181)] = 290499,
  [SMALL_STATE(16182)] = 290516,
  [SMALL_STATE(16183)] = 290531,
  [SMALL_STATE(16184)] = 290548,
  [SMALL_STATE(16185)] = 290563,
  [SMALL_STATE(16186)] = 290582,
  [SMALL_STATE(16187)] = 290599,
  [SMALL_STATE(16188)] = 290614,
  [SMALL_STATE(16189)] = 290631,
  [SMALL_STATE(16190)] = 290646,
  [SMALL_STATE(16191)] = 290661,
  [SMALL_STATE(16192)] = 290678,
  [SMALL_STATE(16193)] = 290695,
  [SMALL_STATE(16194)] = 290714,
  [SMALL_STATE(16195)] = 290731,
  [SMALL_STATE(16196)] = 290748,
  [SMALL_STATE(16197)] = 290765,
  [SMALL_STATE(16198)] = 290780,
  [SMALL_STATE(16199)] = 290799,
  [SMALL_STATE(16200)] = 290814,
  [SMALL_STATE(16201)] = 290831,
  [SMALL_STATE(16202)] = 290848,
  [SMALL_STATE(16203)] = 290865,
  [SMALL_STATE(16204)] = 290882,
  [SMALL_STATE(16205)] = 290899,
  [SMALL_STATE(16206)] = 290914,
  [SMALL_STATE(16207)] = 290931,
  [SMALL_STATE(16208)] = 290948,
  [SMALL_STATE(16209)] = 290965,
  [SMALL_STATE(16210)] = 290980,
  [SMALL_STATE(16211)] = 290995,
  [SMALL_STATE(16212)] = 291012,
  [SMALL_STATE(16213)] = 291027,
  [SMALL_STATE(16214)] = 291044,
  [SMALL_STATE(16215)] = 291059,
  [SMALL_STATE(16216)] = 291076,
  [SMALL_STATE(16217)] = 291095,
  [SMALL_STATE(16218)] = 291112,
  [SMALL_STATE(16219)] = 291127,
  [SMALL_STATE(16220)] = 291142,
  [SMALL_STATE(16221)] = 291153,
  [SMALL_STATE(16222)] = 291168,
  [SMALL_STATE(16223)] = 291183,
  [SMALL_STATE(16224)] = 291202,
  [SMALL_STATE(16225)] = 291219,
  [SMALL_STATE(16226)] = 291234,
  [SMALL_STATE(16227)] = 291249,
  [SMALL_STATE(16228)] = 291268,
  [SMALL_STATE(16229)] = 291285,
  [SMALL_STATE(16230)] = 291302,
  [SMALL_STATE(16231)] = 291317,
  [SMALL_STATE(16232)] = 291332,
  [SMALL_STATE(16233)] = 291349,
  [SMALL_STATE(16234)] = 291364,
  [SMALL_STATE(16235)] = 291379,
  [SMALL_STATE(16236)] = 291394,
  [SMALL_STATE(16237)] = 291413,
  [SMALL_STATE(16238)] = 291430,
  [SMALL_STATE(16239)] = 291445,
  [SMALL_STATE(16240)] = 291460,
  [SMALL_STATE(16241)] = 291477,
  [SMALL_STATE(16242)] = 291492,
  [SMALL_STATE(16243)] = 291507,
  [SMALL_STATE(16244)] = 291522,
  [SMALL_STATE(16245)] = 291541,
  [SMALL_STATE(16246)] = 291558,
  [SMALL_STATE(16247)] = 291575,
  [SMALL_STATE(16248)] = 291592,
  [SMALL_STATE(16249)] = 291607,
  [SMALL_STATE(16250)] = 291622,
  [SMALL_STATE(16251)] = 291639,
  [SMALL_STATE(16252)] = 291658,
  [SMALL_STATE(16253)] = 291677,
  [SMALL_STATE(16254)] = 291694,
  [SMALL_STATE(16255)] = 291711,
  [SMALL_STATE(16256)] = 291730,
  [SMALL_STATE(16257)] = 291745,
  [SMALL_STATE(16258)] = 291760,
  [SMALL_STATE(16259)] = 291775,
  [SMALL_STATE(16260)] = 291792,
  [SMALL_STATE(16261)] = 291807,
  [SMALL_STATE(16262)] = 291824,
  [SMALL_STATE(16263)] = 291843,
  [SMALL_STATE(16264)] = 291860,
  [SMALL_STATE(16265)] = 291877,
  [SMALL_STATE(16266)] = 291894,
  [SMALL_STATE(16267)] = 291911,
  [SMALL_STATE(16268)] = 291928,
  [SMALL_STATE(16269)] = 291945,
  [SMALL_STATE(16270)] = 291962,
  [SMALL_STATE(16271)] = 291977,
  [SMALL_STATE(16272)] = 291992,
  [SMALL_STATE(16273)] = 292007,
  [SMALL_STATE(16274)] = 292022,
  [SMALL_STATE(16275)] = 292039,
  [SMALL_STATE(16276)] = 292056,
  [SMALL_STATE(16277)] = 292073,
  [SMALL_STATE(16278)] = 292090,
  [SMALL_STATE(16279)] = 292107,
  [SMALL_STATE(16280)] = 292126,
  [SMALL_STATE(16281)] = 292141,
  [SMALL_STATE(16282)] = 292152,
  [SMALL_STATE(16283)] = 292167,
  [SMALL_STATE(16284)] = 292182,
  [SMALL_STATE(16285)] = 292199,
  [SMALL_STATE(16286)] = 292214,
  [SMALL_STATE(16287)] = 292229,
  [SMALL_STATE(16288)] = 292246,
  [SMALL_STATE(16289)] = 292263,
  [SMALL_STATE(16290)] = 292274,
  [SMALL_STATE(16291)] = 292289,
  [SMALL_STATE(16292)] = 292304,
  [SMALL_STATE(16293)] = 292323,
  [SMALL_STATE(16294)] = 292342,
  [SMALL_STATE(16295)] = 292359,
  [SMALL_STATE(16296)] = 292374,
  [SMALL_STATE(16297)] = 292391,
  [SMALL_STATE(16298)] = 292410,
  [SMALL_STATE(16299)] = 292429,
  [SMALL_STATE(16300)] = 292446,
  [SMALL_STATE(16301)] = 292463,
  [SMALL_STATE(16302)] = 292480,
  [SMALL_STATE(16303)] = 292499,
  [SMALL_STATE(16304)] = 292516,
  [SMALL_STATE(16305)] = 292531,
  [SMALL_STATE(16306)] = 292548,
  [SMALL_STATE(16307)] = 292565,
  [SMALL_STATE(16308)] = 292582,
  [SMALL_STATE(16309)] = 292599,
  [SMALL_STATE(16310)] = 292616,
  [SMALL_STATE(16311)] = 292631,
  [SMALL_STATE(16312)] = 292648,
  [SMALL_STATE(16313)] = 292663,
  [SMALL_STATE(16314)] = 292678,
  [SMALL_STATE(16315)] = 292695,
  [SMALL_STATE(16316)] = 292710,
  [SMALL_STATE(16317)] = 292727,
  [SMALL_STATE(16318)] = 292744,
  [SMALL_STATE(16319)] = 292761,
  [SMALL_STATE(16320)] = 292778,
  [SMALL_STATE(16321)] = 292795,
  [SMALL_STATE(16322)] = 292812,
  [SMALL_STATE(16323)] = 292829,
  [SMALL_STATE(16324)] = 292846,
  [SMALL_STATE(16325)] = 292863,
  [SMALL_STATE(16326)] = 292878,
  [SMALL_STATE(16327)] = 292893,
  [SMALL_STATE(16328)] = 292910,
  [SMALL_STATE(16329)] = 292925,
  [SMALL_STATE(16330)] = 292940,
  [SMALL_STATE(16331)] = 292959,
  [SMALL_STATE(16332)] = 292976,
  [SMALL_STATE(16333)] = 292995,
  [SMALL_STATE(16334)] = 293012,
  [SMALL_STATE(16335)] = 293029,
  [SMALL_STATE(16336)] = 293046,
  [SMALL_STATE(16337)] = 293065,
  [SMALL_STATE(16338)] = 293084,
  [SMALL_STATE(16339)] = 293101,
  [SMALL_STATE(16340)] = 293120,
  [SMALL_STATE(16341)] = 293135,
  [SMALL_STATE(16342)] = 293152,
  [SMALL_STATE(16343)] = 293169,
  [SMALL_STATE(16344)] = 293184,
  [SMALL_STATE(16345)] = 293199,
  [SMALL_STATE(16346)] = 293216,
  [SMALL_STATE(16347)] = 293233,
  [SMALL_STATE(16348)] = 293248,
  [SMALL_STATE(16349)] = 293263,
  [SMALL_STATE(16350)] = 293280,
  [SMALL_STATE(16351)] = 293297,
  [SMALL_STATE(16352)] = 293312,
  [SMALL_STATE(16353)] = 293327,
  [SMALL_STATE(16354)] = 293344,
  [SMALL_STATE(16355)] = 293359,
  [SMALL_STATE(16356)] = 293374,
  [SMALL_STATE(16357)] = 293389,
  [SMALL_STATE(16358)] = 293408,
  [SMALL_STATE(16359)] = 293425,
  [SMALL_STATE(16360)] = 293442,
  [SMALL_STATE(16361)] = 293459,
  [SMALL_STATE(16362)] = 293476,
  [SMALL_STATE(16363)] = 293493,
  [SMALL_STATE(16364)] = 293510,
  [SMALL_STATE(16365)] = 293529,
  [SMALL_STATE(16366)] = 293548,
  [SMALL_STATE(16367)] = 293565,
  [SMALL_STATE(16368)] = 293582,
  [SMALL_STATE(16369)] = 293599,
  [SMALL_STATE(16370)] = 293616,
  [SMALL_STATE(16371)] = 293635,
  [SMALL_STATE(16372)] = 293652,
  [SMALL_STATE(16373)] = 293669,
  [SMALL_STATE(16374)] = 293686,
  [SMALL_STATE(16375)] = 293703,
  [SMALL_STATE(16376)] = 293718,
  [SMALL_STATE(16377)] = 293733,
  [SMALL_STATE(16378)] = 293750,
  [SMALL_STATE(16379)] = 293767,
  [SMALL_STATE(16380)] = 293784,
  [SMALL_STATE(16381)] = 293799,
  [SMALL_STATE(16382)] = 293814,
  [SMALL_STATE(16383)] = 293831,
  [SMALL_STATE(16384)] = 293848,
  [SMALL_STATE(16385)] = 293863,
  [SMALL_STATE(16386)] = 293878,
  [SMALL_STATE(16387)] = 293897,
  [SMALL_STATE(16388)] = 293914,
  [SMALL_STATE(16389)] = 293933,
  [SMALL_STATE(16390)] = 293952,
  [SMALL_STATE(16391)] = 293971,
  [SMALL_STATE(16392)] = 293988,
  [SMALL_STATE(16393)] = 294007,
  [SMALL_STATE(16394)] = 294018,
  [SMALL_STATE(16395)] = 294029,
  [SMALL_STATE(16396)] = 294046,
  [SMALL_STATE(16397)] = 294063,
  [SMALL_STATE(16398)] = 294078,
  [SMALL_STATE(16399)] = 294093,
  [SMALL_STATE(16400)] = 294112,
  [SMALL_STATE(16401)] = 294127,
  [SMALL_STATE(16402)] = 294142,
  [SMALL_STATE(16403)] = 294161,
  [SMALL_STATE(16404)] = 294178,
  [SMALL_STATE(16405)] = 294197,
  [SMALL_STATE(16406)] = 294216,
  [SMALL_STATE(16407)] = 294235,
  [SMALL_STATE(16408)] = 294252,
  [SMALL_STATE(16409)] = 294271,
  [SMALL_STATE(16410)] = 294286,
  [SMALL_STATE(16411)] = 294305,
  [SMALL_STATE(16412)] = 294324,
  [SMALL_STATE(16413)] = 294339,
  [SMALL_STATE(16414)] = 294354,
  [SMALL_STATE(16415)] = 294371,
  [SMALL_STATE(16416)] = 294386,
  [SMALL_STATE(16417)] = 294401,
  [SMALL_STATE(16418)] = 294416,
  [SMALL_STATE(16419)] = 294431,
  [SMALL_STATE(16420)] = 294446,
  [SMALL_STATE(16421)] = 294465,
  [SMALL_STATE(16422)] = 294482,
  [SMALL_STATE(16423)] = 294501,
  [SMALL_STATE(16424)] = 294520,
  [SMALL_STATE(16425)] = 294539,
  [SMALL_STATE(16426)] = 294556,
  [SMALL_STATE(16427)] = 294571,
  [SMALL_STATE(16428)] = 294588,
  [SMALL_STATE(16429)] = 294603,
  [SMALL_STATE(16430)] = 294618,
  [SMALL_STATE(16431)] = 294633,
  [SMALL_STATE(16432)] = 294650,
  [SMALL_STATE(16433)] = 294665,
  [SMALL_STATE(16434)] = 294680,
  [SMALL_STATE(16435)] = 294695,
  [SMALL_STATE(16436)] = 294714,
  [SMALL_STATE(16437)] = 294731,
  [SMALL_STATE(16438)] = 294746,
  [SMALL_STATE(16439)] = 294765,
  [SMALL_STATE(16440)] = 294784,
  [SMALL_STATE(16441)] = 294801,
  [SMALL_STATE(16442)] = 294820,
  [SMALL_STATE(16443)] = 294839,
  [SMALL_STATE(16444)] = 294854,
  [SMALL_STATE(16445)] = 294873,
  [SMALL_STATE(16446)] = 294888,
  [SMALL_STATE(16447)] = 294903,
  [SMALL_STATE(16448)] = 294918,
  [SMALL_STATE(16449)] = 294933,
  [SMALL_STATE(16450)] = 294948,
  [SMALL_STATE(16451)] = 294963,
  [SMALL_STATE(16452)] = 294982,
  [SMALL_STATE(16453)] = 294999,
  [SMALL_STATE(16454)] = 295014,
  [SMALL_STATE(16455)] = 295033,
  [SMALL_STATE(16456)] = 295052,
  [SMALL_STATE(16457)] = 295069,
  [SMALL_STATE(16458)] = 295084,
  [SMALL_STATE(16459)] = 295101,
  [SMALL_STATE(16460)] = 295116,
  [SMALL_STATE(16461)] = 295133,
  [SMALL_STATE(16462)] = 295148,
  [SMALL_STATE(16463)] = 295163,
  [SMALL_STATE(16464)] = 295180,
  [SMALL_STATE(16465)] = 295197,
  [SMALL_STATE(16466)] = 295212,
  [SMALL_STATE(16467)] = 295227,
  [SMALL_STATE(16468)] = 295246,
  [SMALL_STATE(16469)] = 295263,
  [SMALL_STATE(16470)] = 295280,
  [SMALL_STATE(16471)] = 295299,
  [SMALL_STATE(16472)] = 295318,
  [SMALL_STATE(16473)] = 295335,
  [SMALL_STATE(16474)] = 295352,
  [SMALL_STATE(16475)] = 295369,
  [SMALL_STATE(16476)] = 295386,
  [SMALL_STATE(16477)] = 295403,
  [SMALL_STATE(16478)] = 295420,
  [SMALL_STATE(16479)] = 295435,
  [SMALL_STATE(16480)] = 295450,
  [SMALL_STATE(16481)] = 295465,
  [SMALL_STATE(16482)] = 295484,
  [SMALL_STATE(16483)] = 295499,
  [SMALL_STATE(16484)] = 295514,
  [SMALL_STATE(16485)] = 295533,
  [SMALL_STATE(16486)] = 295552,
  [SMALL_STATE(16487)] = 295569,
  [SMALL_STATE(16488)] = 295584,
  [SMALL_STATE(16489)] = 295603,
  [SMALL_STATE(16490)] = 295622,
  [SMALL_STATE(16491)] = 295639,
  [SMALL_STATE(16492)] = 295654,
  [SMALL_STATE(16493)] = 295669,
  [SMALL_STATE(16494)] = 295684,
  [SMALL_STATE(16495)] = 295699,
  [SMALL_STATE(16496)] = 295718,
  [SMALL_STATE(16497)] = 295737,
  [SMALL_STATE(16498)] = 295752,
  [SMALL_STATE(16499)] = 295767,
  [SMALL_STATE(16500)] = 295786,
  [SMALL_STATE(16501)] = 295805,
  [SMALL_STATE(16502)] = 295820,
  [SMALL_STATE(16503)] = 295837,
  [SMALL_STATE(16504)] = 295854,
  [SMALL_STATE(16505)] = 295871,
  [SMALL_STATE(16506)] = 295888,
  [SMALL_STATE(16507)] = 295905,
  [SMALL_STATE(16508)] = 295920,
  [SMALL_STATE(16509)] = 295937,
  [SMALL_STATE(16510)] = 295954,
  [SMALL_STATE(16511)] = 295971,
  [SMALL_STATE(16512)] = 295986,
  [SMALL_STATE(16513)] = 296001,
  [SMALL_STATE(16514)] = 296016,
  [SMALL_STATE(16515)] = 296031,
  [SMALL_STATE(16516)] = 296048,
  [SMALL_STATE(16517)] = 296063,
  [SMALL_STATE(16518)] = 296080,
  [SMALL_STATE(16519)] = 296097,
  [SMALL_STATE(16520)] = 296114,
  [SMALL_STATE(16521)] = 296133,
  [SMALL_STATE(16522)] = 296150,
  [SMALL_STATE(16523)] = 296167,
  [SMALL_STATE(16524)] = 296184,
  [SMALL_STATE(16525)] = 296199,
  [SMALL_STATE(16526)] = 296214,
  [SMALL_STATE(16527)] = 296233,
  [SMALL_STATE(16528)] = 296250,
  [SMALL_STATE(16529)] = 296267,
  [SMALL_STATE(16530)] = 296284,
  [SMALL_STATE(16531)] = 296297,
  [SMALL_STATE(16532)] = 296314,
  [SMALL_STATE(16533)] = 296331,
  [SMALL_STATE(16534)] = 296348,
  [SMALL_STATE(16535)] = 296367,
  [SMALL_STATE(16536)] = 296384,
  [SMALL_STATE(16537)] = 296401,
  [SMALL_STATE(16538)] = 296420,
  [SMALL_STATE(16539)] = 296437,
  [SMALL_STATE(16540)] = 296452,
  [SMALL_STATE(16541)] = 296469,
  [SMALL_STATE(16542)] = 296486,
  [SMALL_STATE(16543)] = 296503,
  [SMALL_STATE(16544)] = 296518,
  [SMALL_STATE(16545)] = 296535,
  [SMALL_STATE(16546)] = 296550,
  [SMALL_STATE(16547)] = 296567,
  [SMALL_STATE(16548)] = 296586,
  [SMALL_STATE(16549)] = 296605,
  [SMALL_STATE(16550)] = 296622,
  [SMALL_STATE(16551)] = 296639,
  [SMALL_STATE(16552)] = 296656,
  [SMALL_STATE(16553)] = 296673,
  [SMALL_STATE(16554)] = 296688,
  [SMALL_STATE(16555)] = 296703,
  [SMALL_STATE(16556)] = 296718,
  [SMALL_STATE(16557)] = 296735,
  [SMALL_STATE(16558)] = 296752,
  [SMALL_STATE(16559)] = 296771,
  [SMALL_STATE(16560)] = 296786,
  [SMALL_STATE(16561)] = 296803,
  [SMALL_STATE(16562)] = 296818,
  [SMALL_STATE(16563)] = 296833,
  [SMALL_STATE(16564)] = 296852,
  [SMALL_STATE(16565)] = 296869,
  [SMALL_STATE(16566)] = 296884,
  [SMALL_STATE(16567)] = 296901,
  [SMALL_STATE(16568)] = 296918,
  [SMALL_STATE(16569)] = 296935,
  [SMALL_STATE(16570)] = 296952,
  [SMALL_STATE(16571)] = 296969,
  [SMALL_STATE(16572)] = 296988,
  [SMALL_STATE(16573)] = 297005,
  [SMALL_STATE(16574)] = 297020,
  [SMALL_STATE(16575)] = 297037,
  [SMALL_STATE(16576)] = 297054,
  [SMALL_STATE(16577)] = 297071,
  [SMALL_STATE(16578)] = 297086,
  [SMALL_STATE(16579)] = 297101,
  [SMALL_STATE(16580)] = 297120,
  [SMALL_STATE(16581)] = 297137,
  [SMALL_STATE(16582)] = 297154,
  [SMALL_STATE(16583)] = 297171,
  [SMALL_STATE(16584)] = 297188,
  [SMALL_STATE(16585)] = 297203,
  [SMALL_STATE(16586)] = 297220,
  [SMALL_STATE(16587)] = 297237,
  [SMALL_STATE(16588)] = 297254,
  [SMALL_STATE(16589)] = 297269,
  [SMALL_STATE(16590)] = 297286,
  [SMALL_STATE(16591)] = 297301,
  [SMALL_STATE(16592)] = 297316,
  [SMALL_STATE(16593)] = 297333,
  [SMALL_STATE(16594)] = 297348,
  [SMALL_STATE(16595)] = 297363,
  [SMALL_STATE(16596)] = 297378,
  [SMALL_STATE(16597)] = 297395,
  [SMALL_STATE(16598)] = 297414,
  [SMALL_STATE(16599)] = 297431,
  [SMALL_STATE(16600)] = 297450,
  [SMALL_STATE(16601)] = 297465,
  [SMALL_STATE(16602)] = 297480,
  [SMALL_STATE(16603)] = 297495,
  [SMALL_STATE(16604)] = 297512,
  [SMALL_STATE(16605)] = 297531,
  [SMALL_STATE(16606)] = 297546,
  [SMALL_STATE(16607)] = 297561,
  [SMALL_STATE(16608)] = 297576,
  [SMALL_STATE(16609)] = 297591,
  [SMALL_STATE(16610)] = 297608,
  [SMALL_STATE(16611)] = 297625,
  [SMALL_STATE(16612)] = 297642,
  [SMALL_STATE(16613)] = 297659,
  [SMALL_STATE(16614)] = 297676,
  [SMALL_STATE(16615)] = 297691,
  [SMALL_STATE(16616)] = 297710,
  [SMALL_STATE(16617)] = 297727,
  [SMALL_STATE(16618)] = 297742,
  [SMALL_STATE(16619)] = 297757,
  [SMALL_STATE(16620)] = 297772,
  [SMALL_STATE(16621)] = 297791,
  [SMALL_STATE(16622)] = 297808,
  [SMALL_STATE(16623)] = 297823,
  [SMALL_STATE(16624)] = 297838,
  [SMALL_STATE(16625)] = 297857,
  [SMALL_STATE(16626)] = 297872,
  [SMALL_STATE(16627)] = 297887,
  [SMALL_STATE(16628)] = 297902,
  [SMALL_STATE(16629)] = 297917,
  [SMALL_STATE(16630)] = 297932,
  [SMALL_STATE(16631)] = 297951,
  [SMALL_STATE(16632)] = 297968,
  [SMALL_STATE(16633)] = 297985,
  [SMALL_STATE(16634)] = 298004,
  [SMALL_STATE(16635)] = 298021,
  [SMALL_STATE(16636)] = 298040,
  [SMALL_STATE(16637)] = 298057,
  [SMALL_STATE(16638)] = 298076,
  [SMALL_STATE(16639)] = 298095,
  [SMALL_STATE(16640)] = 298110,
  [SMALL_STATE(16641)] = 298125,
  [SMALL_STATE(16642)] = 298142,
  [SMALL_STATE(16643)] = 298159,
  [SMALL_STATE(16644)] = 298176,
  [SMALL_STATE(16645)] = 298193,
  [SMALL_STATE(16646)] = 298212,
  [SMALL_STATE(16647)] = 298229,
  [SMALL_STATE(16648)] = 298246,
  [SMALL_STATE(16649)] = 298263,
  [SMALL_STATE(16650)] = 298280,
  [SMALL_STATE(16651)] = 298295,
  [SMALL_STATE(16652)] = 298312,
  [SMALL_STATE(16653)] = 298327,
  [SMALL_STATE(16654)] = 298342,
  [SMALL_STATE(16655)] = 298357,
  [SMALL_STATE(16656)] = 298371,
  [SMALL_STATE(16657)] = 298385,
  [SMALL_STATE(16658)] = 298399,
  [SMALL_STATE(16659)] = 298413,
  [SMALL_STATE(16660)] = 298427,
  [SMALL_STATE(16661)] = 298441,
  [SMALL_STATE(16662)] = 298455,
  [SMALL_STATE(16663)] = 298469,
  [SMALL_STATE(16664)] = 298483,
  [SMALL_STATE(16665)] = 298497,
  [SMALL_STATE(16666)] = 298511,
  [SMALL_STATE(16667)] = 298525,
  [SMALL_STATE(16668)] = 298539,
  [SMALL_STATE(16669)] = 298553,
  [SMALL_STATE(16670)] = 298565,
  [SMALL_STATE(16671)] = 298579,
  [SMALL_STATE(16672)] = 298593,
  [SMALL_STATE(16673)] = 298605,
  [SMALL_STATE(16674)] = 298619,
  [SMALL_STATE(16675)] = 298633,
  [SMALL_STATE(16676)] = 298647,
  [SMALL_STATE(16677)] = 298661,
  [SMALL_STATE(16678)] = 298675,
  [SMALL_STATE(16679)] = 298685,
  [SMALL_STATE(16680)] = 298699,
  [SMALL_STATE(16681)] = 298713,
  [SMALL_STATE(16682)] = 298727,
  [SMALL_STATE(16683)] = 298741,
  [SMALL_STATE(16684)] = 298755,
  [SMALL_STATE(16685)] = 298769,
  [SMALL_STATE(16686)] = 298783,
  [SMALL_STATE(16687)] = 298797,
  [SMALL_STATE(16688)] = 298811,
  [SMALL_STATE(16689)] = 298825,
  [SMALL_STATE(16690)] = 298839,
  [SMALL_STATE(16691)] = 298853,
  [SMALL_STATE(16692)] = 298867,
  [SMALL_STATE(16693)] = 298879,
  [SMALL_STATE(16694)] = 298893,
  [SMALL_STATE(16695)] = 298907,
  [SMALL_STATE(16696)] = 298921,
  [SMALL_STATE(16697)] = 298935,
  [SMALL_STATE(16698)] = 298947,
  [SMALL_STATE(16699)] = 298961,
  [SMALL_STATE(16700)] = 298975,
  [SMALL_STATE(16701)] = 298987,
  [SMALL_STATE(16702)] = 299001,
  [SMALL_STATE(16703)] = 299015,
  [SMALL_STATE(16704)] = 299029,
  [SMALL_STATE(16705)] = 299043,
  [SMALL_STATE(16706)] = 299057,
  [SMALL_STATE(16707)] = 299071,
  [SMALL_STATE(16708)] = 299085,
  [SMALL_STATE(16709)] = 299099,
  [SMALL_STATE(16710)] = 299113,
  [SMALL_STATE(16711)] = 299127,
  [SMALL_STATE(16712)] = 299141,
  [SMALL_STATE(16713)] = 299155,
  [SMALL_STATE(16714)] = 299169,
  [SMALL_STATE(16715)] = 299183,
  [SMALL_STATE(16716)] = 299195,
  [SMALL_STATE(16717)] = 299209,
  [SMALL_STATE(16718)] = 299221,
  [SMALL_STATE(16719)] = 299235,
  [SMALL_STATE(16720)] = 299249,
  [SMALL_STATE(16721)] = 299261,
  [SMALL_STATE(16722)] = 299275,
  [SMALL_STATE(16723)] = 299289,
  [SMALL_STATE(16724)] = 299301,
  [SMALL_STATE(16725)] = 299315,
  [SMALL_STATE(16726)] = 299327,
  [SMALL_STATE(16727)] = 299341,
  [SMALL_STATE(16728)] = 299355,
  [SMALL_STATE(16729)] = 299369,
  [SMALL_STATE(16730)] = 299383,
  [SMALL_STATE(16731)] = 299397,
  [SMALL_STATE(16732)] = 299411,
  [SMALL_STATE(16733)] = 299423,
  [SMALL_STATE(16734)] = 299437,
  [SMALL_STATE(16735)] = 299451,
  [SMALL_STATE(16736)] = 299465,
  [SMALL_STATE(16737)] = 299477,
  [SMALL_STATE(16738)] = 299491,
  [SMALL_STATE(16739)] = 299505,
  [SMALL_STATE(16740)] = 299519,
  [SMALL_STATE(16741)] = 299533,
  [SMALL_STATE(16742)] = 299547,
  [SMALL_STATE(16743)] = 299561,
  [SMALL_STATE(16744)] = 299575,
  [SMALL_STATE(16745)] = 299589,
  [SMALL_STATE(16746)] = 299603,
  [SMALL_STATE(16747)] = 299617,
  [SMALL_STATE(16748)] = 299631,
  [SMALL_STATE(16749)] = 299645,
  [SMALL_STATE(16750)] = 299659,
  [SMALL_STATE(16751)] = 299673,
  [SMALL_STATE(16752)] = 299687,
  [SMALL_STATE(16753)] = 299701,
  [SMALL_STATE(16754)] = 299715,
  [SMALL_STATE(16755)] = 299729,
  [SMALL_STATE(16756)] = 299743,
  [SMALL_STATE(16757)] = 299757,
  [SMALL_STATE(16758)] = 299771,
  [SMALL_STATE(16759)] = 299785,
  [SMALL_STATE(16760)] = 299799,
  [SMALL_STATE(16761)] = 299813,
  [SMALL_STATE(16762)] = 299827,
  [SMALL_STATE(16763)] = 299841,
  [SMALL_STATE(16764)] = 299855,
  [SMALL_STATE(16765)] = 299869,
  [SMALL_STATE(16766)] = 299883,
  [SMALL_STATE(16767)] = 299897,
  [SMALL_STATE(16768)] = 299911,
  [SMALL_STATE(16769)] = 299925,
  [SMALL_STATE(16770)] = 299937,
  [SMALL_STATE(16771)] = 299951,
  [SMALL_STATE(16772)] = 299963,
  [SMALL_STATE(16773)] = 299977,
  [SMALL_STATE(16774)] = 299991,
  [SMALL_STATE(16775)] = 300005,
  [SMALL_STATE(16776)] = 300019,
  [SMALL_STATE(16777)] = 300033,
  [SMALL_STATE(16778)] = 300047,
  [SMALL_STATE(16779)] = 300061,
  [SMALL_STATE(16780)] = 300071,
  [SMALL_STATE(16781)] = 300085,
  [SMALL_STATE(16782)] = 300099,
  [SMALL_STATE(16783)] = 300113,
  [SMALL_STATE(16784)] = 300127,
  [SMALL_STATE(16785)] = 300139,
  [SMALL_STATE(16786)] = 300153,
  [SMALL_STATE(16787)] = 300167,
  [SMALL_STATE(16788)] = 300181,
  [SMALL_STATE(16789)] = 300193,
  [SMALL_STATE(16790)] = 300207,
  [SMALL_STATE(16791)] = 300221,
  [SMALL_STATE(16792)] = 300235,
  [SMALL_STATE(16793)] = 300249,
  [SMALL_STATE(16794)] = 300263,
  [SMALL_STATE(16795)] = 300277,
  [SMALL_STATE(16796)] = 300291,
  [SMALL_STATE(16797)] = 300305,
  [SMALL_STATE(16798)] = 300319,
  [SMALL_STATE(16799)] = 300333,
  [SMALL_STATE(16800)] = 300345,
  [SMALL_STATE(16801)] = 300359,
  [SMALL_STATE(16802)] = 300373,
  [SMALL_STATE(16803)] = 300387,
  [SMALL_STATE(16804)] = 300401,
  [SMALL_STATE(16805)] = 300415,
  [SMALL_STATE(16806)] = 300429,
  [SMALL_STATE(16807)] = 300441,
  [SMALL_STATE(16808)] = 300455,
  [SMALL_STATE(16809)] = 300469,
  [SMALL_STATE(16810)] = 300483,
  [SMALL_STATE(16811)] = 300497,
  [SMALL_STATE(16812)] = 300511,
  [SMALL_STATE(16813)] = 300525,
  [SMALL_STATE(16814)] = 300539,
  [SMALL_STATE(16815)] = 300553,
  [SMALL_STATE(16816)] = 300567,
  [SMALL_STATE(16817)] = 300579,
  [SMALL_STATE(16818)] = 300593,
  [SMALL_STATE(16819)] = 300605,
  [SMALL_STATE(16820)] = 300619,
  [SMALL_STATE(16821)] = 300633,
  [SMALL_STATE(16822)] = 300647,
  [SMALL_STATE(16823)] = 300661,
  [SMALL_STATE(16824)] = 300675,
  [SMALL_STATE(16825)] = 300689,
  [SMALL_STATE(16826)] = 300703,
  [SMALL_STATE(16827)] = 300715,
  [SMALL_STATE(16828)] = 300729,
  [SMALL_STATE(16829)] = 300743,
  [SMALL_STATE(16830)] = 300757,
  [SMALL_STATE(16831)] = 300771,
  [SMALL_STATE(16832)] = 300785,
  [SMALL_STATE(16833)] = 300799,
  [SMALL_STATE(16834)] = 300813,
  [SMALL_STATE(16835)] = 300827,
  [SMALL_STATE(16836)] = 300841,
  [SMALL_STATE(16837)] = 300855,
  [SMALL_STATE(16838)] = 300869,
  [SMALL_STATE(16839)] = 300883,
  [SMALL_STATE(16840)] = 300897,
  [SMALL_STATE(16841)] = 300909,
  [SMALL_STATE(16842)] = 300923,
  [SMALL_STATE(16843)] = 300937,
  [SMALL_STATE(16844)] = 300949,
  [SMALL_STATE(16845)] = 300963,
  [SMALL_STATE(16846)] = 300977,
  [SMALL_STATE(16847)] = 300991,
  [SMALL_STATE(16848)] = 301005,
  [SMALL_STATE(16849)] = 301017,
  [SMALL_STATE(16850)] = 301029,
  [SMALL_STATE(16851)] = 301043,
  [SMALL_STATE(16852)] = 301057,
  [SMALL_STATE(16853)] = 301071,
  [SMALL_STATE(16854)] = 301085,
  [SMALL_STATE(16855)] = 301099,
  [SMALL_STATE(16856)] = 301113,
  [SMALL_STATE(16857)] = 301127,
  [SMALL_STATE(16858)] = 301141,
  [SMALL_STATE(16859)] = 301155,
  [SMALL_STATE(16860)] = 301169,
  [SMALL_STATE(16861)] = 301183,
  [SMALL_STATE(16862)] = 301195,
  [SMALL_STATE(16863)] = 301209,
  [SMALL_STATE(16864)] = 301223,
  [SMALL_STATE(16865)] = 301237,
  [SMALL_STATE(16866)] = 301249,
  [SMALL_STATE(16867)] = 301263,
  [SMALL_STATE(16868)] = 301277,
  [SMALL_STATE(16869)] = 301291,
  [SMALL_STATE(16870)] = 301305,
  [SMALL_STATE(16871)] = 301317,
  [SMALL_STATE(16872)] = 301331,
  [SMALL_STATE(16873)] = 301345,
  [SMALL_STATE(16874)] = 301359,
  [SMALL_STATE(16875)] = 301373,
  [SMALL_STATE(16876)] = 301387,
  [SMALL_STATE(16877)] = 301399,
  [SMALL_STATE(16878)] = 301413,
  [SMALL_STATE(16879)] = 301427,
  [SMALL_STATE(16880)] = 301439,
  [SMALL_STATE(16881)] = 301451,
  [SMALL_STATE(16882)] = 301465,
  [SMALL_STATE(16883)] = 301479,
  [SMALL_STATE(16884)] = 301493,
  [SMALL_STATE(16885)] = 301507,
  [SMALL_STATE(16886)] = 301521,
  [SMALL_STATE(16887)] = 301535,
  [SMALL_STATE(16888)] = 301549,
  [SMALL_STATE(16889)] = 301563,
  [SMALL_STATE(16890)] = 301577,
  [SMALL_STATE(16891)] = 301591,
  [SMALL_STATE(16892)] = 301605,
  [SMALL_STATE(16893)] = 301617,
  [SMALL_STATE(16894)] = 301631,
  [SMALL_STATE(16895)] = 301645,
  [SMALL_STATE(16896)] = 301659,
  [SMALL_STATE(16897)] = 301673,
  [SMALL_STATE(16898)] = 301687,
  [SMALL_STATE(16899)] = 301701,
  [SMALL_STATE(16900)] = 301715,
  [SMALL_STATE(16901)] = 301729,
  [SMALL_STATE(16902)] = 301743,
  [SMALL_STATE(16903)] = 301755,
  [SMALL_STATE(16904)] = 301769,
  [SMALL_STATE(16905)] = 301783,
  [SMALL_STATE(16906)] = 301797,
  [SMALL_STATE(16907)] = 301811,
  [SMALL_STATE(16908)] = 301825,
  [SMALL_STATE(16909)] = 301839,
  [SMALL_STATE(16910)] = 301853,
  [SMALL_STATE(16911)] = 301867,
  [SMALL_STATE(16912)] = 301881,
  [SMALL_STATE(16913)] = 301895,
  [SMALL_STATE(16914)] = 301909,
  [SMALL_STATE(16915)] = 301921,
  [SMALL_STATE(16916)] = 301935,
  [SMALL_STATE(16917)] = 301949,
  [SMALL_STATE(16918)] = 301963,
  [SMALL_STATE(16919)] = 301975,
  [SMALL_STATE(16920)] = 301989,
  [SMALL_STATE(16921)] = 302003,
  [SMALL_STATE(16922)] = 302017,
  [SMALL_STATE(16923)] = 302031,
  [SMALL_STATE(16924)] = 302045,
  [SMALL_STATE(16925)] = 302059,
  [SMALL_STATE(16926)] = 302073,
  [SMALL_STATE(16927)] = 302085,
  [SMALL_STATE(16928)] = 302099,
  [SMALL_STATE(16929)] = 302113,
  [SMALL_STATE(16930)] = 302125,
  [SMALL_STATE(16931)] = 302139,
  [SMALL_STATE(16932)] = 302153,
  [SMALL_STATE(16933)] = 302167,
  [SMALL_STATE(16934)] = 302181,
  [SMALL_STATE(16935)] = 302193,
  [SMALL_STATE(16936)] = 302207,
  [SMALL_STATE(16937)] = 302221,
  [SMALL_STATE(16938)] = 302231,
  [SMALL_STATE(16939)] = 302245,
  [SMALL_STATE(16940)] = 302259,
  [SMALL_STATE(16941)] = 302273,
  [SMALL_STATE(16942)] = 302287,
  [SMALL_STATE(16943)] = 302301,
  [SMALL_STATE(16944)] = 302315,
  [SMALL_STATE(16945)] = 302329,
  [SMALL_STATE(16946)] = 302341,
  [SMALL_STATE(16947)] = 302355,
  [SMALL_STATE(16948)] = 302369,
  [SMALL_STATE(16949)] = 302383,
  [SMALL_STATE(16950)] = 302397,
  [SMALL_STATE(16951)] = 302411,
  [SMALL_STATE(16952)] = 302425,
  [SMALL_STATE(16953)] = 302439,
  [SMALL_STATE(16954)] = 302453,
  [SMALL_STATE(16955)] = 302467,
  [SMALL_STATE(16956)] = 302481,
  [SMALL_STATE(16957)] = 302495,
  [SMALL_STATE(16958)] = 302509,
  [SMALL_STATE(16959)] = 302523,
  [SMALL_STATE(16960)] = 302537,
  [SMALL_STATE(16961)] = 302551,
  [SMALL_STATE(16962)] = 302561,
  [SMALL_STATE(16963)] = 302575,
  [SMALL_STATE(16964)] = 302589,
  [SMALL_STATE(16965)] = 302603,
  [SMALL_STATE(16966)] = 302615,
  [SMALL_STATE(16967)] = 302629,
  [SMALL_STATE(16968)] = 302643,
  [SMALL_STATE(16969)] = 302657,
  [SMALL_STATE(16970)] = 302671,
  [SMALL_STATE(16971)] = 302683,
  [SMALL_STATE(16972)] = 302697,
  [SMALL_STATE(16973)] = 302711,
  [SMALL_STATE(16974)] = 302725,
  [SMALL_STATE(16975)] = 302739,
  [SMALL_STATE(16976)] = 302753,
  [SMALL_STATE(16977)] = 302767,
  [SMALL_STATE(16978)] = 302781,
  [SMALL_STATE(16979)] = 302795,
  [SMALL_STATE(16980)] = 302809,
  [SMALL_STATE(16981)] = 302823,
  [SMALL_STATE(16982)] = 302837,
  [SMALL_STATE(16983)] = 302849,
  [SMALL_STATE(16984)] = 302863,
  [SMALL_STATE(16985)] = 302877,
  [SMALL_STATE(16986)] = 302891,
  [SMALL_STATE(16987)] = 302905,
  [SMALL_STATE(16988)] = 302919,
  [SMALL_STATE(16989)] = 302933,
  [SMALL_STATE(16990)] = 302947,
  [SMALL_STATE(16991)] = 302961,
  [SMALL_STATE(16992)] = 302975,
  [SMALL_STATE(16993)] = 302989,
  [SMALL_STATE(16994)] = 303003,
  [SMALL_STATE(16995)] = 303017,
  [SMALL_STATE(16996)] = 303029,
  [SMALL_STATE(16997)] = 303043,
  [SMALL_STATE(16998)] = 303057,
  [SMALL_STATE(16999)] = 303071,
  [SMALL_STATE(17000)] = 303085,
  [SMALL_STATE(17001)] = 303099,
  [SMALL_STATE(17002)] = 303113,
  [SMALL_STATE(17003)] = 303127,
  [SMALL_STATE(17004)] = 303141,
  [SMALL_STATE(17005)] = 303155,
  [SMALL_STATE(17006)] = 303169,
  [SMALL_STATE(17007)] = 303183,
  [SMALL_STATE(17008)] = 303197,
  [SMALL_STATE(17009)] = 303211,
  [SMALL_STATE(17010)] = 303225,
  [SMALL_STATE(17011)] = 303239,
  [SMALL_STATE(17012)] = 303253,
  [SMALL_STATE(17013)] = 303267,
  [SMALL_STATE(17014)] = 303281,
  [SMALL_STATE(17015)] = 303295,
  [SMALL_STATE(17016)] = 303309,
  [SMALL_STATE(17017)] = 303323,
  [SMALL_STATE(17018)] = 303337,
  [SMALL_STATE(17019)] = 303351,
  [SMALL_STATE(17020)] = 303365,
  [SMALL_STATE(17021)] = 303379,
  [SMALL_STATE(17022)] = 303393,
  [SMALL_STATE(17023)] = 303407,
  [SMALL_STATE(17024)] = 303421,
  [SMALL_STATE(17025)] = 303435,
  [SMALL_STATE(17026)] = 303445,
  [SMALL_STATE(17027)] = 303459,
  [SMALL_STATE(17028)] = 303473,
  [SMALL_STATE(17029)] = 303487,
  [SMALL_STATE(17030)] = 303501,
  [SMALL_STATE(17031)] = 303515,
  [SMALL_STATE(17032)] = 303529,
  [SMALL_STATE(17033)] = 303543,
  [SMALL_STATE(17034)] = 303557,
  [SMALL_STATE(17035)] = 303571,
  [SMALL_STATE(17036)] = 303585,
  [SMALL_STATE(17037)] = 303599,
  [SMALL_STATE(17038)] = 303613,
  [SMALL_STATE(17039)] = 303627,
  [SMALL_STATE(17040)] = 303641,
  [SMALL_STATE(17041)] = 303655,
  [SMALL_STATE(17042)] = 303669,
  [SMALL_STATE(17043)] = 303683,
  [SMALL_STATE(17044)] = 303697,
  [SMALL_STATE(17045)] = 303711,
  [SMALL_STATE(17046)] = 303725,
  [SMALL_STATE(17047)] = 303737,
  [SMALL_STATE(17048)] = 303751,
  [SMALL_STATE(17049)] = 303765,
  [SMALL_STATE(17050)] = 303779,
  [SMALL_STATE(17051)] = 303793,
  [SMALL_STATE(17052)] = 303807,
  [SMALL_STATE(17053)] = 303817,
  [SMALL_STATE(17054)] = 303831,
  [SMALL_STATE(17055)] = 303845,
  [SMALL_STATE(17056)] = 303859,
  [SMALL_STATE(17057)] = 303871,
  [SMALL_STATE(17058)] = 303885,
  [SMALL_STATE(17059)] = 303899,
  [SMALL_STATE(17060)] = 303913,
  [SMALL_STATE(17061)] = 303927,
  [SMALL_STATE(17062)] = 303941,
  [SMALL_STATE(17063)] = 303955,
  [SMALL_STATE(17064)] = 303969,
  [SMALL_STATE(17065)] = 303983,
  [SMALL_STATE(17066)] = 303997,
  [SMALL_STATE(17067)] = 304011,
  [SMALL_STATE(17068)] = 304025,
  [SMALL_STATE(17069)] = 304039,
  [SMALL_STATE(17070)] = 304053,
  [SMALL_STATE(17071)] = 304067,
  [SMALL_STATE(17072)] = 304081,
  [SMALL_STATE(17073)] = 304095,
  [SMALL_STATE(17074)] = 304109,
  [SMALL_STATE(17075)] = 304123,
  [SMALL_STATE(17076)] = 304137,
  [SMALL_STATE(17077)] = 304151,
  [SMALL_STATE(17078)] = 304163,
  [SMALL_STATE(17079)] = 304177,
  [SMALL_STATE(17080)] = 304191,
  [SMALL_STATE(17081)] = 304205,
  [SMALL_STATE(17082)] = 304219,
  [SMALL_STATE(17083)] = 304233,
  [SMALL_STATE(17084)] = 304247,
  [SMALL_STATE(17085)] = 304261,
  [SMALL_STATE(17086)] = 304275,
  [SMALL_STATE(17087)] = 304289,
  [SMALL_STATE(17088)] = 304303,
  [SMALL_STATE(17089)] = 304317,
  [SMALL_STATE(17090)] = 304331,
  [SMALL_STATE(17091)] = 304345,
  [SMALL_STATE(17092)] = 304359,
  [SMALL_STATE(17093)] = 304373,
  [SMALL_STATE(17094)] = 304387,
  [SMALL_STATE(17095)] = 304401,
  [SMALL_STATE(17096)] = 304415,
  [SMALL_STATE(17097)] = 304429,
  [SMALL_STATE(17098)] = 304443,
  [SMALL_STATE(17099)] = 304457,
  [SMALL_STATE(17100)] = 304469,
  [SMALL_STATE(17101)] = 304483,
  [SMALL_STATE(17102)] = 304497,
  [SMALL_STATE(17103)] = 304511,
  [SMALL_STATE(17104)] = 304525,
  [SMALL_STATE(17105)] = 304539,
  [SMALL_STATE(17106)] = 304553,
  [SMALL_STATE(17107)] = 304567,
  [SMALL_STATE(17108)] = 304581,
  [SMALL_STATE(17109)] = 304595,
  [SMALL_STATE(17110)] = 304609,
  [SMALL_STATE(17111)] = 304623,
  [SMALL_STATE(17112)] = 304637,
  [SMALL_STATE(17113)] = 304651,
  [SMALL_STATE(17114)] = 304665,
  [SMALL_STATE(17115)] = 304679,
  [SMALL_STATE(17116)] = 304693,
  [SMALL_STATE(17117)] = 304707,
  [SMALL_STATE(17118)] = 304721,
  [SMALL_STATE(17119)] = 304731,
  [SMALL_STATE(17120)] = 304745,
  [SMALL_STATE(17121)] = 304759,
  [SMALL_STATE(17122)] = 304773,
  [SMALL_STATE(17123)] = 304787,
  [SMALL_STATE(17124)] = 304799,
  [SMALL_STATE(17125)] = 304811,
  [SMALL_STATE(17126)] = 304825,
  [SMALL_STATE(17127)] = 304839,
  [SMALL_STATE(17128)] = 304853,
  [SMALL_STATE(17129)] = 304867,
  [SMALL_STATE(17130)] = 304881,
  [SMALL_STATE(17131)] = 304895,
  [SMALL_STATE(17132)] = 304909,
  [SMALL_STATE(17133)] = 304923,
  [SMALL_STATE(17134)] = 304937,
  [SMALL_STATE(17135)] = 304951,
  [SMALL_STATE(17136)] = 304965,
  [SMALL_STATE(17137)] = 304979,
  [SMALL_STATE(17138)] = 304993,
  [SMALL_STATE(17139)] = 305003,
  [SMALL_STATE(17140)] = 305017,
  [SMALL_STATE(17141)] = 305031,
  [SMALL_STATE(17142)] = 305045,
  [SMALL_STATE(17143)] = 305059,
  [SMALL_STATE(17144)] = 305073,
  [SMALL_STATE(17145)] = 305087,
  [SMALL_STATE(17146)] = 305101,
  [SMALL_STATE(17147)] = 305115,
  [SMALL_STATE(17148)] = 305127,
  [SMALL_STATE(17149)] = 305141,
  [SMALL_STATE(17150)] = 305155,
  [SMALL_STATE(17151)] = 305169,
  [SMALL_STATE(17152)] = 305183,
  [SMALL_STATE(17153)] = 305197,
  [SMALL_STATE(17154)] = 305209,
  [SMALL_STATE(17155)] = 305223,
  [SMALL_STATE(17156)] = 305237,
  [SMALL_STATE(17157)] = 305249,
  [SMALL_STATE(17158)] = 305263,
  [SMALL_STATE(17159)] = 305277,
  [SMALL_STATE(17160)] = 305291,
  [SMALL_STATE(17161)] = 305303,
  [SMALL_STATE(17162)] = 305317,
  [SMALL_STATE(17163)] = 305331,
  [SMALL_STATE(17164)] = 305345,
  [SMALL_STATE(17165)] = 305357,
  [SMALL_STATE(17166)] = 305371,
  [SMALL_STATE(17167)] = 305385,
  [SMALL_STATE(17168)] = 305399,
  [SMALL_STATE(17169)] = 305413,
  [SMALL_STATE(17170)] = 305425,
  [SMALL_STATE(17171)] = 305439,
  [SMALL_STATE(17172)] = 305453,
  [SMALL_STATE(17173)] = 305467,
  [SMALL_STATE(17174)] = 305481,
  [SMALL_STATE(17175)] = 305495,
  [SMALL_STATE(17176)] = 305509,
  [SMALL_STATE(17177)] = 305523,
  [SMALL_STATE(17178)] = 305535,
  [SMALL_STATE(17179)] = 305547,
  [SMALL_STATE(17180)] = 305561,
  [SMALL_STATE(17181)] = 305575,
  [SMALL_STATE(17182)] = 305589,
  [SMALL_STATE(17183)] = 305603,
  [SMALL_STATE(17184)] = 305617,
  [SMALL_STATE(17185)] = 305631,
  [SMALL_STATE(17186)] = 305645,
  [SMALL_STATE(17187)] = 305659,
  [SMALL_STATE(17188)] = 305673,
  [SMALL_STATE(17189)] = 305687,
  [SMALL_STATE(17190)] = 305701,
  [SMALL_STATE(17191)] = 305715,
  [SMALL_STATE(17192)] = 305727,
  [SMALL_STATE(17193)] = 305741,
  [SMALL_STATE(17194)] = 305755,
  [SMALL_STATE(17195)] = 305769,
  [SMALL_STATE(17196)] = 305783,
  [SMALL_STATE(17197)] = 305797,
  [SMALL_STATE(17198)] = 305809,
  [SMALL_STATE(17199)] = 305823,
  [SMALL_STATE(17200)] = 305837,
  [SMALL_STATE(17201)] = 305851,
  [SMALL_STATE(17202)] = 305865,
  [SMALL_STATE(17203)] = 305879,
  [SMALL_STATE(17204)] = 305891,
  [SMALL_STATE(17205)] = 305905,
  [SMALL_STATE(17206)] = 305919,
  [SMALL_STATE(17207)] = 305931,
  [SMALL_STATE(17208)] = 305945,
  [SMALL_STATE(17209)] = 305957,
  [SMALL_STATE(17210)] = 305969,
  [SMALL_STATE(17211)] = 305983,
  [SMALL_STATE(17212)] = 305997,
  [SMALL_STATE(17213)] = 306011,
  [SMALL_STATE(17214)] = 306025,
  [SMALL_STATE(17215)] = 306037,
  [SMALL_STATE(17216)] = 306047,
  [SMALL_STATE(17217)] = 306061,
  [SMALL_STATE(17218)] = 306075,
  [SMALL_STATE(17219)] = 306087,
  [SMALL_STATE(17220)] = 306101,
  [SMALL_STATE(17221)] = 306115,
  [SMALL_STATE(17222)] = 306129,
  [SMALL_STATE(17223)] = 306143,
  [SMALL_STATE(17224)] = 306157,
  [SMALL_STATE(17225)] = 306171,
  [SMALL_STATE(17226)] = 306185,
  [SMALL_STATE(17227)] = 306199,
  [SMALL_STATE(17228)] = 306213,
  [SMALL_STATE(17229)] = 306225,
  [SMALL_STATE(17230)] = 306239,
  [SMALL_STATE(17231)] = 306253,
  [SMALL_STATE(17232)] = 306265,
  [SMALL_STATE(17233)] = 306279,
  [SMALL_STATE(17234)] = 306293,
  [SMALL_STATE(17235)] = 306305,
  [SMALL_STATE(17236)] = 306319,
  [SMALL_STATE(17237)] = 306331,
  [SMALL_STATE(17238)] = 306345,
  [SMALL_STATE(17239)] = 306359,
  [SMALL_STATE(17240)] = 306373,
  [SMALL_STATE(17241)] = 306387,
  [SMALL_STATE(17242)] = 306401,
  [SMALL_STATE(17243)] = 306415,
  [SMALL_STATE(17244)] = 306429,
  [SMALL_STATE(17245)] = 306443,
  [SMALL_STATE(17246)] = 306457,
  [SMALL_STATE(17247)] = 306471,
  [SMALL_STATE(17248)] = 306485,
  [SMALL_STATE(17249)] = 306499,
  [SMALL_STATE(17250)] = 306513,
  [SMALL_STATE(17251)] = 306527,
  [SMALL_STATE(17252)] = 306541,
  [SMALL_STATE(17253)] = 306555,
  [SMALL_STATE(17254)] = 306569,
  [SMALL_STATE(17255)] = 306583,
  [SMALL_STATE(17256)] = 306597,
  [SMALL_STATE(17257)] = 306611,
  [SMALL_STATE(17258)] = 306625,
  [SMALL_STATE(17259)] = 306637,
  [SMALL_STATE(17260)] = 306651,
  [SMALL_STATE(17261)] = 306665,
  [SMALL_STATE(17262)] = 306677,
  [SMALL_STATE(17263)] = 306691,
  [SMALL_STATE(17264)] = 306705,
  [SMALL_STATE(17265)] = 306719,
  [SMALL_STATE(17266)] = 306733,
  [SMALL_STATE(17267)] = 306747,
  [SMALL_STATE(17268)] = 306759,
  [SMALL_STATE(17269)] = 306773,
  [SMALL_STATE(17270)] = 306787,
  [SMALL_STATE(17271)] = 306799,
  [SMALL_STATE(17272)] = 306811,
  [SMALL_STATE(17273)] = 306825,
  [SMALL_STATE(17274)] = 306839,
  [SMALL_STATE(17275)] = 306853,
  [SMALL_STATE(17276)] = 306867,
  [SMALL_STATE(17277)] = 306881,
  [SMALL_STATE(17278)] = 306895,
  [SMALL_STATE(17279)] = 306909,
  [SMALL_STATE(17280)] = 306921,
  [SMALL_STATE(17281)] = 306935,
  [SMALL_STATE(17282)] = 306949,
  [SMALL_STATE(17283)] = 306963,
  [SMALL_STATE(17284)] = 306977,
  [SMALL_STATE(17285)] = 306989,
  [SMALL_STATE(17286)] = 307001,
  [SMALL_STATE(17287)] = 307015,
  [SMALL_STATE(17288)] = 307029,
  [SMALL_STATE(17289)] = 307041,
  [SMALL_STATE(17290)] = 307053,
  [SMALL_STATE(17291)] = 307067,
  [SMALL_STATE(17292)] = 307081,
  [SMALL_STATE(17293)] = 307095,
  [SMALL_STATE(17294)] = 307109,
  [SMALL_STATE(17295)] = 307123,
  [SMALL_STATE(17296)] = 307137,
  [SMALL_STATE(17297)] = 307151,
  [SMALL_STATE(17298)] = 307165,
  [SMALL_STATE(17299)] = 307179,
  [SMALL_STATE(17300)] = 307193,
  [SMALL_STATE(17301)] = 307205,
  [SMALL_STATE(17302)] = 307219,
  [SMALL_STATE(17303)] = 307233,
  [SMALL_STATE(17304)] = 307247,
  [SMALL_STATE(17305)] = 307261,
  [SMALL_STATE(17306)] = 307275,
  [SMALL_STATE(17307)] = 307289,
  [SMALL_STATE(17308)] = 307303,
  [SMALL_STATE(17309)] = 307315,
  [SMALL_STATE(17310)] = 307329,
  [SMALL_STATE(17311)] = 307343,
  [SMALL_STATE(17312)] = 307357,
  [SMALL_STATE(17313)] = 307371,
  [SMALL_STATE(17314)] = 307385,
  [SMALL_STATE(17315)] = 307397,
  [SMALL_STATE(17316)] = 307411,
  [SMALL_STATE(17317)] = 307425,
  [SMALL_STATE(17318)] = 307439,
  [SMALL_STATE(17319)] = 307453,
  [SMALL_STATE(17320)] = 307467,
  [SMALL_STATE(17321)] = 307481,
  [SMALL_STATE(17322)] = 307495,
  [SMALL_STATE(17323)] = 307509,
  [SMALL_STATE(17324)] = 307523,
  [SMALL_STATE(17325)] = 307537,
  [SMALL_STATE(17326)] = 307551,
  [SMALL_STATE(17327)] = 307565,
  [SMALL_STATE(17328)] = 307579,
  [SMALL_STATE(17329)] = 307593,
  [SMALL_STATE(17330)] = 307607,
  [SMALL_STATE(17331)] = 307621,
  [SMALL_STATE(17332)] = 307635,
  [SMALL_STATE(17333)] = 307649,
  [SMALL_STATE(17334)] = 307661,
  [SMALL_STATE(17335)] = 307673,
  [SMALL_STATE(17336)] = 307685,
  [SMALL_STATE(17337)] = 307697,
  [SMALL_STATE(17338)] = 307709,
  [SMALL_STATE(17339)] = 307721,
  [SMALL_STATE(17340)] = 307735,
  [SMALL_STATE(17341)] = 307746,
  [SMALL_STATE(17342)] = 307757,
  [SMALL_STATE(17343)] = 307768,
  [SMALL_STATE(17344)] = 307779,
  [SMALL_STATE(17345)] = 307788,
  [SMALL_STATE(17346)] = 307801,
  [SMALL_STATE(17347)] = 307812,
  [SMALL_STATE(17348)] = 307823,
  [SMALL_STATE(17349)] = 307834,
  [SMALL_STATE(17350)] = 307845,
  [SMALL_STATE(17351)] = 307858,
  [SMALL_STATE(17352)] = 307871,
  [SMALL_STATE(17353)] = 307882,
  [SMALL_STATE(17354)] = 307893,
  [SMALL_STATE(17355)] = 307902,
  [SMALL_STATE(17356)] = 307913,
  [SMALL_STATE(17357)] = 307924,
  [SMALL_STATE(17358)] = 307935,
  [SMALL_STATE(17359)] = 307946,
  [SMALL_STATE(17360)] = 307957,
  [SMALL_STATE(17361)] = 307970,
  [SMALL_STATE(17362)] = 307983,
  [SMALL_STATE(17363)] = 307994,
  [SMALL_STATE(17364)] = 308007,
  [SMALL_STATE(17365)] = 308020,
  [SMALL_STATE(17366)] = 308031,
  [SMALL_STATE(17367)] = 308042,
  [SMALL_STATE(17368)] = 308055,
  [SMALL_STATE(17369)] = 308066,
  [SMALL_STATE(17370)] = 308077,
  [SMALL_STATE(17371)] = 308088,
  [SMALL_STATE(17372)] = 308099,
  [SMALL_STATE(17373)] = 308110,
  [SMALL_STATE(17374)] = 308121,
  [SMALL_STATE(17375)] = 308134,
  [SMALL_STATE(17376)] = 308145,
  [SMALL_STATE(17377)] = 308156,
  [SMALL_STATE(17378)] = 308167,
  [SMALL_STATE(17379)] = 308178,
  [SMALL_STATE(17380)] = 308191,
  [SMALL_STATE(17381)] = 308202,
  [SMALL_STATE(17382)] = 308215,
  [SMALL_STATE(17383)] = 308226,
  [SMALL_STATE(17384)] = 308237,
  [SMALL_STATE(17385)] = 308250,
  [SMALL_STATE(17386)] = 308261,
  [SMALL_STATE(17387)] = 308272,
  [SMALL_STATE(17388)] = 308283,
  [SMALL_STATE(17389)] = 308294,
  [SMALL_STATE(17390)] = 308305,
  [SMALL_STATE(17391)] = 308316,
  [SMALL_STATE(17392)] = 308327,
  [SMALL_STATE(17393)] = 308340,
  [SMALL_STATE(17394)] = 308351,
  [SMALL_STATE(17395)] = 308362,
  [SMALL_STATE(17396)] = 308373,
  [SMALL_STATE(17397)] = 308384,
  [SMALL_STATE(17398)] = 308397,
  [SMALL_STATE(17399)] = 308408,
  [SMALL_STATE(17400)] = 308419,
  [SMALL_STATE(17401)] = 308432,
  [SMALL_STATE(17402)] = 308443,
  [SMALL_STATE(17403)] = 308456,
  [SMALL_STATE(17404)] = 308467,
  [SMALL_STATE(17405)] = 308478,
  [SMALL_STATE(17406)] = 308489,
  [SMALL_STATE(17407)] = 308500,
  [SMALL_STATE(17408)] = 308511,
  [SMALL_STATE(17409)] = 308522,
  [SMALL_STATE(17410)] = 308533,
  [SMALL_STATE(17411)] = 308546,
  [SMALL_STATE(17412)] = 308555,
  [SMALL_STATE(17413)] = 308568,
  [SMALL_STATE(17414)] = 308579,
  [SMALL_STATE(17415)] = 308592,
  [SMALL_STATE(17416)] = 308605,
  [SMALL_STATE(17417)] = 308618,
  [SMALL_STATE(17418)] = 308629,
  [SMALL_STATE(17419)] = 308640,
  [SMALL_STATE(17420)] = 308653,
  [SMALL_STATE(17421)] = 308664,
  [SMALL_STATE(17422)] = 308675,
  [SMALL_STATE(17423)] = 308688,
  [SMALL_STATE(17424)] = 308699,
  [SMALL_STATE(17425)] = 308712,
  [SMALL_STATE(17426)] = 308723,
  [SMALL_STATE(17427)] = 308734,
  [SMALL_STATE(17428)] = 308745,
  [SMALL_STATE(17429)] = 308756,
  [SMALL_STATE(17430)] = 308767,
  [SMALL_STATE(17431)] = 308778,
  [SMALL_STATE(17432)] = 308789,
  [SMALL_STATE(17433)] = 308802,
  [SMALL_STATE(17434)] = 308815,
  [SMALL_STATE(17435)] = 308826,
  [SMALL_STATE(17436)] = 308837,
  [SMALL_STATE(17437)] = 308848,
  [SMALL_STATE(17438)] = 308859,
  [SMALL_STATE(17439)] = 308870,
  [SMALL_STATE(17440)] = 308881,
  [SMALL_STATE(17441)] = 308892,
  [SMALL_STATE(17442)] = 308903,
  [SMALL_STATE(17443)] = 308914,
  [SMALL_STATE(17444)] = 308925,
  [SMALL_STATE(17445)] = 308936,
  [SMALL_STATE(17446)] = 308947,
  [SMALL_STATE(17447)] = 308960,
  [SMALL_STATE(17448)] = 308973,
  [SMALL_STATE(17449)] = 308986,
  [SMALL_STATE(17450)] = 308999,
  [SMALL_STATE(17451)] = 309010,
  [SMALL_STATE(17452)] = 309021,
  [SMALL_STATE(17453)] = 309032,
  [SMALL_STATE(17454)] = 309043,
  [SMALL_STATE(17455)] = 309054,
  [SMALL_STATE(17456)] = 309065,
  [SMALL_STATE(17457)] = 309076,
  [SMALL_STATE(17458)] = 309087,
  [SMALL_STATE(17459)] = 309098,
  [SMALL_STATE(17460)] = 309109,
  [SMALL_STATE(17461)] = 309120,
  [SMALL_STATE(17462)] = 309131,
  [SMALL_STATE(17463)] = 309142,
  [SMALL_STATE(17464)] = 309153,
  [SMALL_STATE(17465)] = 309164,
  [SMALL_STATE(17466)] = 309173,
  [SMALL_STATE(17467)] = 309184,
  [SMALL_STATE(17468)] = 309195,
  [SMALL_STATE(17469)] = 309208,
  [SMALL_STATE(17470)] = 309221,
  [SMALL_STATE(17471)] = 309232,
  [SMALL_STATE(17472)] = 309245,
  [SMALL_STATE(17473)] = 309256,
  [SMALL_STATE(17474)] = 309265,
  [SMALL_STATE(17475)] = 309276,
  [SMALL_STATE(17476)] = 309287,
  [SMALL_STATE(17477)] = 309298,
  [SMALL_STATE(17478)] = 309309,
  [SMALL_STATE(17479)] = 309320,
  [SMALL_STATE(17480)] = 309331,
  [SMALL_STATE(17481)] = 309342,
  [SMALL_STATE(17482)] = 309355,
  [SMALL_STATE(17483)] = 309368,
  [SMALL_STATE(17484)] = 309379,
  [SMALL_STATE(17485)] = 309392,
  [SMALL_STATE(17486)] = 309403,
  [SMALL_STATE(17487)] = 309416,
  [SMALL_STATE(17488)] = 309427,
  [SMALL_STATE(17489)] = 309440,
  [SMALL_STATE(17490)] = 309451,
  [SMALL_STATE(17491)] = 309462,
  [SMALL_STATE(17492)] = 309473,
  [SMALL_STATE(17493)] = 309484,
  [SMALL_STATE(17494)] = 309495,
  [SMALL_STATE(17495)] = 309506,
  [SMALL_STATE(17496)] = 309517,
  [SMALL_STATE(17497)] = 309528,
  [SMALL_STATE(17498)] = 309539,
  [SMALL_STATE(17499)] = 309552,
  [SMALL_STATE(17500)] = 309563,
  [SMALL_STATE(17501)] = 309574,
  [SMALL_STATE(17502)] = 309585,
  [SMALL_STATE(17503)] = 309596,
  [SMALL_STATE(17504)] = 309607,
  [SMALL_STATE(17505)] = 309620,
  [SMALL_STATE(17506)] = 309631,
  [SMALL_STATE(17507)] = 309642,
  [SMALL_STATE(17508)] = 309653,
  [SMALL_STATE(17509)] = 309666,
  [SMALL_STATE(17510)] = 309677,
  [SMALL_STATE(17511)] = 309688,
  [SMALL_STATE(17512)] = 309699,
  [SMALL_STATE(17513)] = 309710,
  [SMALL_STATE(17514)] = 309721,
  [SMALL_STATE(17515)] = 309732,
  [SMALL_STATE(17516)] = 309745,
  [SMALL_STATE(17517)] = 309758,
  [SMALL_STATE(17518)] = 309771,
  [SMALL_STATE(17519)] = 309782,
  [SMALL_STATE(17520)] = 309793,
  [SMALL_STATE(17521)] = 309804,
  [SMALL_STATE(17522)] = 309815,
  [SMALL_STATE(17523)] = 309826,
  [SMALL_STATE(17524)] = 309837,
  [SMALL_STATE(17525)] = 309850,
  [SMALL_STATE(17526)] = 309861,
  [SMALL_STATE(17527)] = 309872,
  [SMALL_STATE(17528)] = 309883,
  [SMALL_STATE(17529)] = 309894,
  [SMALL_STATE(17530)] = 309905,
  [SMALL_STATE(17531)] = 309918,
  [SMALL_STATE(17532)] = 309929,
  [SMALL_STATE(17533)] = 309940,
  [SMALL_STATE(17534)] = 309953,
  [SMALL_STATE(17535)] = 309964,
  [SMALL_STATE(17536)] = 309977,
  [SMALL_STATE(17537)] = 309988,
  [SMALL_STATE(17538)] = 309999,
  [SMALL_STATE(17539)] = 310010,
  [SMALL_STATE(17540)] = 310021,
  [SMALL_STATE(17541)] = 310032,
  [SMALL_STATE(17542)] = 310043,
  [SMALL_STATE(17543)] = 310054,
  [SMALL_STATE(17544)] = 310065,
  [SMALL_STATE(17545)] = 310076,
  [SMALL_STATE(17546)] = 310087,
  [SMALL_STATE(17547)] = 310098,
  [SMALL_STATE(17548)] = 310109,
  [SMALL_STATE(17549)] = 310120,
  [SMALL_STATE(17550)] = 310131,
  [SMALL_STATE(17551)] = 310144,
  [SMALL_STATE(17552)] = 310155,
  [SMALL_STATE(17553)] = 310168,
  [SMALL_STATE(17554)] = 310181,
  [SMALL_STATE(17555)] = 310192,
  [SMALL_STATE(17556)] = 310203,
  [SMALL_STATE(17557)] = 310216,
  [SMALL_STATE(17558)] = 310227,
  [SMALL_STATE(17559)] = 310238,
  [SMALL_STATE(17560)] = 310249,
  [SMALL_STATE(17561)] = 310260,
  [SMALL_STATE(17562)] = 310273,
  [SMALL_STATE(17563)] = 310284,
  [SMALL_STATE(17564)] = 310295,
  [SMALL_STATE(17565)] = 310306,
  [SMALL_STATE(17566)] = 310317,
  [SMALL_STATE(17567)] = 310328,
  [SMALL_STATE(17568)] = 310339,
  [SMALL_STATE(17569)] = 310352,
  [SMALL_STATE(17570)] = 310363,
  [SMALL_STATE(17571)] = 310374,
  [SMALL_STATE(17572)] = 310385,
  [SMALL_STATE(17573)] = 310394,
  [SMALL_STATE(17574)] = 310405,
  [SMALL_STATE(17575)] = 310416,
  [SMALL_STATE(17576)] = 310427,
  [SMALL_STATE(17577)] = 310436,
  [SMALL_STATE(17578)] = 310449,
  [SMALL_STATE(17579)] = 310460,
  [SMALL_STATE(17580)] = 310473,
  [SMALL_STATE(17581)] = 310484,
  [SMALL_STATE(17582)] = 310495,
  [SMALL_STATE(17583)] = 310506,
  [SMALL_STATE(17584)] = 310517,
  [SMALL_STATE(17585)] = 310530,
  [SMALL_STATE(17586)] = 310541,
  [SMALL_STATE(17587)] = 310554,
  [SMALL_STATE(17588)] = 310567,
  [SMALL_STATE(17589)] = 310576,
  [SMALL_STATE(17590)] = 310587,
  [SMALL_STATE(17591)] = 310598,
  [SMALL_STATE(17592)] = 310609,
  [SMALL_STATE(17593)] = 310620,
  [SMALL_STATE(17594)] = 310631,
  [SMALL_STATE(17595)] = 310644,
  [SMALL_STATE(17596)] = 310655,
  [SMALL_STATE(17597)] = 310666,
  [SMALL_STATE(17598)] = 310677,
  [SMALL_STATE(17599)] = 310686,
  [SMALL_STATE(17600)] = 310697,
  [SMALL_STATE(17601)] = 310708,
  [SMALL_STATE(17602)] = 310719,
  [SMALL_STATE(17603)] = 310732,
  [SMALL_STATE(17604)] = 310743,
  [SMALL_STATE(17605)] = 310754,
  [SMALL_STATE(17606)] = 310765,
  [SMALL_STATE(17607)] = 310776,
  [SMALL_STATE(17608)] = 310787,
  [SMALL_STATE(17609)] = 310796,
  [SMALL_STATE(17610)] = 310807,
  [SMALL_STATE(17611)] = 310818,
  [SMALL_STATE(17612)] = 310829,
  [SMALL_STATE(17613)] = 310840,
  [SMALL_STATE(17614)] = 310851,
  [SMALL_STATE(17615)] = 310862,
  [SMALL_STATE(17616)] = 310873,
  [SMALL_STATE(17617)] = 310884,
  [SMALL_STATE(17618)] = 310897,
  [SMALL_STATE(17619)] = 310910,
  [SMALL_STATE(17620)] = 310921,
  [SMALL_STATE(17621)] = 310932,
  [SMALL_STATE(17622)] = 310945,
  [SMALL_STATE(17623)] = 310956,
  [SMALL_STATE(17624)] = 310967,
  [SMALL_STATE(17625)] = 310978,
  [SMALL_STATE(17626)] = 310989,
  [SMALL_STATE(17627)] = 311000,
  [SMALL_STATE(17628)] = 311011,
  [SMALL_STATE(17629)] = 311022,
  [SMALL_STATE(17630)] = 311033,
  [SMALL_STATE(17631)] = 311044,
  [SMALL_STATE(17632)] = 311055,
  [SMALL_STATE(17633)] = 311066,
  [SMALL_STATE(17634)] = 311077,
  [SMALL_STATE(17635)] = 311090,
  [SMALL_STATE(17636)] = 311101,
  [SMALL_STATE(17637)] = 311112,
  [SMALL_STATE(17638)] = 311123,
  [SMALL_STATE(17639)] = 311134,
  [SMALL_STATE(17640)] = 311145,
  [SMALL_STATE(17641)] = 311156,
  [SMALL_STATE(17642)] = 311169,
  [SMALL_STATE(17643)] = 311180,
  [SMALL_STATE(17644)] = 311191,
  [SMALL_STATE(17645)] = 311202,
  [SMALL_STATE(17646)] = 311213,
  [SMALL_STATE(17647)] = 311224,
  [SMALL_STATE(17648)] = 311235,
  [SMALL_STATE(17649)] = 311246,
  [SMALL_STATE(17650)] = 311257,
  [SMALL_STATE(17651)] = 311268,
  [SMALL_STATE(17652)] = 311279,
  [SMALL_STATE(17653)] = 311290,
  [SMALL_STATE(17654)] = 311301,
  [SMALL_STATE(17655)] = 311314,
  [SMALL_STATE(17656)] = 311325,
  [SMALL_STATE(17657)] = 311338,
  [SMALL_STATE(17658)] = 311349,
  [SMALL_STATE(17659)] = 311360,
  [SMALL_STATE(17660)] = 311371,
  [SMALL_STATE(17661)] = 311382,
  [SMALL_STATE(17662)] = 311393,
  [SMALL_STATE(17663)] = 311406,
  [SMALL_STATE(17664)] = 311417,
  [SMALL_STATE(17665)] = 311428,
  [SMALL_STATE(17666)] = 311439,
  [SMALL_STATE(17667)] = 311450,
  [SMALL_STATE(17668)] = 311461,
  [SMALL_STATE(17669)] = 311472,
  [SMALL_STATE(17670)] = 311483,
  [SMALL_STATE(17671)] = 311494,
  [SMALL_STATE(17672)] = 311505,
  [SMALL_STATE(17673)] = 311516,
  [SMALL_STATE(17674)] = 311527,
  [SMALL_STATE(17675)] = 311536,
  [SMALL_STATE(17676)] = 311547,
  [SMALL_STATE(17677)] = 311560,
  [SMALL_STATE(17678)] = 311571,
  [SMALL_STATE(17679)] = 311582,
  [SMALL_STATE(17680)] = 311593,
  [SMALL_STATE(17681)] = 311606,
  [SMALL_STATE(17682)] = 311617,
  [SMALL_STATE(17683)] = 311628,
  [SMALL_STATE(17684)] = 311639,
  [SMALL_STATE(17685)] = 311650,
  [SMALL_STATE(17686)] = 311661,
  [SMALL_STATE(17687)] = 311672,
  [SMALL_STATE(17688)] = 311683,
  [SMALL_STATE(17689)] = 311694,
  [SMALL_STATE(17690)] = 311705,
  [SMALL_STATE(17691)] = 311716,
  [SMALL_STATE(17692)] = 311727,
  [SMALL_STATE(17693)] = 311740,
  [SMALL_STATE(17694)] = 311751,
  [SMALL_STATE(17695)] = 311762,
  [SMALL_STATE(17696)] = 311773,
  [SMALL_STATE(17697)] = 311786,
  [SMALL_STATE(17698)] = 311799,
  [SMALL_STATE(17699)] = 311812,
  [SMALL_STATE(17700)] = 311823,
  [SMALL_STATE(17701)] = 311836,
  [SMALL_STATE(17702)] = 311847,
  [SMALL_STATE(17703)] = 311858,
  [SMALL_STATE(17704)] = 311869,
  [SMALL_STATE(17705)] = 311878,
  [SMALL_STATE(17706)] = 311889,
  [SMALL_STATE(17707)] = 311902,
  [SMALL_STATE(17708)] = 311913,
  [SMALL_STATE(17709)] = 311924,
  [SMALL_STATE(17710)] = 311935,
  [SMALL_STATE(17711)] = 311946,
  [SMALL_STATE(17712)] = 311957,
  [SMALL_STATE(17713)] = 311968,
  [SMALL_STATE(17714)] = 311979,
  [SMALL_STATE(17715)] = 311992,
  [SMALL_STATE(17716)] = 312003,
  [SMALL_STATE(17717)] = 312014,
  [SMALL_STATE(17718)] = 312025,
  [SMALL_STATE(17719)] = 312036,
  [SMALL_STATE(17720)] = 312047,
  [SMALL_STATE(17721)] = 312058,
  [SMALL_STATE(17722)] = 312069,
  [SMALL_STATE(17723)] = 312080,
  [SMALL_STATE(17724)] = 312091,
  [SMALL_STATE(17725)] = 312102,
  [SMALL_STATE(17726)] = 312113,
  [SMALL_STATE(17727)] = 312124,
  [SMALL_STATE(17728)] = 312135,
  [SMALL_STATE(17729)] = 312148,
  [SMALL_STATE(17730)] = 312161,
  [SMALL_STATE(17731)] = 312174,
  [SMALL_STATE(17732)] = 312185,
  [SMALL_STATE(17733)] = 312196,
  [SMALL_STATE(17734)] = 312207,
  [SMALL_STATE(17735)] = 312220,
  [SMALL_STATE(17736)] = 312231,
  [SMALL_STATE(17737)] = 312240,
  [SMALL_STATE(17738)] = 312251,
  [SMALL_STATE(17739)] = 312262,
  [SMALL_STATE(17740)] = 312273,
  [SMALL_STATE(17741)] = 312284,
  [SMALL_STATE(17742)] = 312295,
  [SMALL_STATE(17743)] = 312306,
  [SMALL_STATE(17744)] = 312317,
  [SMALL_STATE(17745)] = 312328,
  [SMALL_STATE(17746)] = 312339,
  [SMALL_STATE(17747)] = 312352,
  [SMALL_STATE(17748)] = 312365,
  [SMALL_STATE(17749)] = 312376,
  [SMALL_STATE(17750)] = 312389,
  [SMALL_STATE(17751)] = 312400,
  [SMALL_STATE(17752)] = 312409,
  [SMALL_STATE(17753)] = 312420,
  [SMALL_STATE(17754)] = 312431,
  [SMALL_STATE(17755)] = 312442,
  [SMALL_STATE(17756)] = 312453,
  [SMALL_STATE(17757)] = 312466,
  [SMALL_STATE(17758)] = 312477,
  [SMALL_STATE(17759)] = 312488,
  [SMALL_STATE(17760)] = 312499,
  [SMALL_STATE(17761)] = 312510,
  [SMALL_STATE(17762)] = 312521,
  [SMALL_STATE(17763)] = 312532,
  [SMALL_STATE(17764)] = 312543,
  [SMALL_STATE(17765)] = 312554,
  [SMALL_STATE(17766)] = 312565,
  [SMALL_STATE(17767)] = 312576,
  [SMALL_STATE(17768)] = 312589,
  [SMALL_STATE(17769)] = 312602,
  [SMALL_STATE(17770)] = 312613,
  [SMALL_STATE(17771)] = 312626,
  [SMALL_STATE(17772)] = 312637,
  [SMALL_STATE(17773)] = 312648,
  [SMALL_STATE(17774)] = 312659,
  [SMALL_STATE(17775)] = 312670,
  [SMALL_STATE(17776)] = 312681,
  [SMALL_STATE(17777)] = 312692,
  [SMALL_STATE(17778)] = 312703,
  [SMALL_STATE(17779)] = 312714,
  [SMALL_STATE(17780)] = 312725,
  [SMALL_STATE(17781)] = 312736,
  [SMALL_STATE(17782)] = 312749,
  [SMALL_STATE(17783)] = 312760,
  [SMALL_STATE(17784)] = 312771,
  [SMALL_STATE(17785)] = 312782,
  [SMALL_STATE(17786)] = 312793,
  [SMALL_STATE(17787)] = 312804,
  [SMALL_STATE(17788)] = 312815,
  [SMALL_STATE(17789)] = 312826,
  [SMALL_STATE(17790)] = 312837,
  [SMALL_STATE(17791)] = 312848,
  [SMALL_STATE(17792)] = 312861,
  [SMALL_STATE(17793)] = 312872,
  [SMALL_STATE(17794)] = 312883,
  [SMALL_STATE(17795)] = 312894,
  [SMALL_STATE(17796)] = 312905,
  [SMALL_STATE(17797)] = 312916,
  [SMALL_STATE(17798)] = 312927,
  [SMALL_STATE(17799)] = 312938,
  [SMALL_STATE(17800)] = 312949,
  [SMALL_STATE(17801)] = 312962,
  [SMALL_STATE(17802)] = 312971,
  [SMALL_STATE(17803)] = 312984,
  [SMALL_STATE(17804)] = 312997,
  [SMALL_STATE(17805)] = 313006,
  [SMALL_STATE(17806)] = 313017,
  [SMALL_STATE(17807)] = 313030,
  [SMALL_STATE(17808)] = 313041,
  [SMALL_STATE(17809)] = 313052,
  [SMALL_STATE(17810)] = 313063,
  [SMALL_STATE(17811)] = 313074,
  [SMALL_STATE(17812)] = 313085,
  [SMALL_STATE(17813)] = 313096,
  [SMALL_STATE(17814)] = 313107,
  [SMALL_STATE(17815)] = 313118,
  [SMALL_STATE(17816)] = 313129,
  [SMALL_STATE(17817)] = 313140,
  [SMALL_STATE(17818)] = 313151,
  [SMALL_STATE(17819)] = 313162,
  [SMALL_STATE(17820)] = 313173,
  [SMALL_STATE(17821)] = 313184,
  [SMALL_STATE(17822)] = 313195,
  [SMALL_STATE(17823)] = 313208,
  [SMALL_STATE(17824)] = 313219,
  [SMALL_STATE(17825)] = 313230,
  [SMALL_STATE(17826)] = 313241,
  [SMALL_STATE(17827)] = 313252,
  [SMALL_STATE(17828)] = 313263,
  [SMALL_STATE(17829)] = 313274,
  [SMALL_STATE(17830)] = 313285,
  [SMALL_STATE(17831)] = 313296,
  [SMALL_STATE(17832)] = 313309,
  [SMALL_STATE(17833)] = 313320,
  [SMALL_STATE(17834)] = 313331,
  [SMALL_STATE(17835)] = 313344,
  [SMALL_STATE(17836)] = 313355,
  [SMALL_STATE(17837)] = 313366,
  [SMALL_STATE(17838)] = 313377,
  [SMALL_STATE(17839)] = 313388,
  [SMALL_STATE(17840)] = 313399,
  [SMALL_STATE(17841)] = 313410,
  [SMALL_STATE(17842)] = 313421,
  [SMALL_STATE(17843)] = 313432,
  [SMALL_STATE(17844)] = 313445,
  [SMALL_STATE(17845)] = 313456,
  [SMALL_STATE(17846)] = 313467,
  [SMALL_STATE(17847)] = 313478,
  [SMALL_STATE(17848)] = 313489,
  [SMALL_STATE(17849)] = 313500,
  [SMALL_STATE(17850)] = 313513,
  [SMALL_STATE(17851)] = 313524,
  [SMALL_STATE(17852)] = 313535,
  [SMALL_STATE(17853)] = 313546,
  [SMALL_STATE(17854)] = 313555,
  [SMALL_STATE(17855)] = 313566,
  [SMALL_STATE(17856)] = 313577,
  [SMALL_STATE(17857)] = 313588,
  [SMALL_STATE(17858)] = 313599,
  [SMALL_STATE(17859)] = 313610,
  [SMALL_STATE(17860)] = 313621,
  [SMALL_STATE(17861)] = 313632,
  [SMALL_STATE(17862)] = 313643,
  [SMALL_STATE(17863)] = 313654,
  [SMALL_STATE(17864)] = 313665,
  [SMALL_STATE(17865)] = 313676,
  [SMALL_STATE(17866)] = 313687,
  [SMALL_STATE(17867)] = 313700,
  [SMALL_STATE(17868)] = 313711,
  [SMALL_STATE(17869)] = 313724,
  [SMALL_STATE(17870)] = 313735,
  [SMALL_STATE(17871)] = 313746,
  [SMALL_STATE(17872)] = 313757,
  [SMALL_STATE(17873)] = 313768,
  [SMALL_STATE(17874)] = 313779,
  [SMALL_STATE(17875)] = 313790,
  [SMALL_STATE(17876)] = 313801,
  [SMALL_STATE(17877)] = 313812,
  [SMALL_STATE(17878)] = 313823,
  [SMALL_STATE(17879)] = 313834,
  [SMALL_STATE(17880)] = 313845,
  [SMALL_STATE(17881)] = 313856,
  [SMALL_STATE(17882)] = 313867,
  [SMALL_STATE(17883)] = 313880,
  [SMALL_STATE(17884)] = 313891,
  [SMALL_STATE(17885)] = 313902,
  [SMALL_STATE(17886)] = 313913,
  [SMALL_STATE(17887)] = 313924,
  [SMALL_STATE(17888)] = 313933,
  [SMALL_STATE(17889)] = 313944,
  [SMALL_STATE(17890)] = 313955,
  [SMALL_STATE(17891)] = 313966,
  [SMALL_STATE(17892)] = 313977,
  [SMALL_STATE(17893)] = 313988,
  [SMALL_STATE(17894)] = 313999,
  [SMALL_STATE(17895)] = 314010,
  [SMALL_STATE(17896)] = 314021,
  [SMALL_STATE(17897)] = 314032,
  [SMALL_STATE(17898)] = 314043,
  [SMALL_STATE(17899)] = 314054,
  [SMALL_STATE(17900)] = 314067,
  [SMALL_STATE(17901)] = 314078,
  [SMALL_STATE(17902)] = 314089,
  [SMALL_STATE(17903)] = 314100,
  [SMALL_STATE(17904)] = 314111,
  [SMALL_STATE(17905)] = 314122,
  [SMALL_STATE(17906)] = 314133,
  [SMALL_STATE(17907)] = 314144,
  [SMALL_STATE(17908)] = 314155,
  [SMALL_STATE(17909)] = 314166,
  [SMALL_STATE(17910)] = 314179,
  [SMALL_STATE(17911)] = 314190,
  [SMALL_STATE(17912)] = 314201,
  [SMALL_STATE(17913)] = 314214,
  [SMALL_STATE(17914)] = 314225,
  [SMALL_STATE(17915)] = 314236,
  [SMALL_STATE(17916)] = 314249,
  [SMALL_STATE(17917)] = 314260,
  [SMALL_STATE(17918)] = 314271,
  [SMALL_STATE(17919)] = 314282,
  [SMALL_STATE(17920)] = 314293,
  [SMALL_STATE(17921)] = 314304,
  [SMALL_STATE(17922)] = 314315,
  [SMALL_STATE(17923)] = 314326,
  [SMALL_STATE(17924)] = 314337,
  [SMALL_STATE(17925)] = 314348,
  [SMALL_STATE(17926)] = 314359,
  [SMALL_STATE(17927)] = 314370,
  [SMALL_STATE(17928)] = 314383,
  [SMALL_STATE(17929)] = 314394,
  [SMALL_STATE(17930)] = 314405,
  [SMALL_STATE(17931)] = 314414,
  [SMALL_STATE(17932)] = 314425,
  [SMALL_STATE(17933)] = 314436,
  [SMALL_STATE(17934)] = 314447,
  [SMALL_STATE(17935)] = 314458,
  [SMALL_STATE(17936)] = 314469,
  [SMALL_STATE(17937)] = 314480,
  [SMALL_STATE(17938)] = 314491,
  [SMALL_STATE(17939)] = 314502,
  [SMALL_STATE(17940)] = 314513,
  [SMALL_STATE(17941)] = 314524,
  [SMALL_STATE(17942)] = 314535,
  [SMALL_STATE(17943)] = 314546,
  [SMALL_STATE(17944)] = 314559,
  [SMALL_STATE(17945)] = 314570,
  [SMALL_STATE(17946)] = 314581,
  [SMALL_STATE(17947)] = 314592,
  [SMALL_STATE(17948)] = 314603,
  [SMALL_STATE(17949)] = 314614,
  [SMALL_STATE(17950)] = 314625,
  [SMALL_STATE(17951)] = 314636,
  [SMALL_STATE(17952)] = 314647,
  [SMALL_STATE(17953)] = 314658,
  [SMALL_STATE(17954)] = 314669,
  [SMALL_STATE(17955)] = 314680,
  [SMALL_STATE(17956)] = 314691,
  [SMALL_STATE(17957)] = 314702,
  [SMALL_STATE(17958)] = 314715,
  [SMALL_STATE(17959)] = 314726,
  [SMALL_STATE(17960)] = 314737,
  [SMALL_STATE(17961)] = 314748,
  [SMALL_STATE(17962)] = 314759,
  [SMALL_STATE(17963)] = 314770,
  [SMALL_STATE(17964)] = 314783,
  [SMALL_STATE(17965)] = 314794,
  [SMALL_STATE(17966)] = 314805,
  [SMALL_STATE(17967)] = 314816,
  [SMALL_STATE(17968)] = 314827,
  [SMALL_STATE(17969)] = 314838,
  [SMALL_STATE(17970)] = 314849,
  [SMALL_STATE(17971)] = 314860,
  [SMALL_STATE(17972)] = 314871,
  [SMALL_STATE(17973)] = 314882,
  [SMALL_STATE(17974)] = 314893,
  [SMALL_STATE(17975)] = 314904,
  [SMALL_STATE(17976)] = 314915,
  [SMALL_STATE(17977)] = 314926,
  [SMALL_STATE(17978)] = 314937,
  [SMALL_STATE(17979)] = 314948,
  [SMALL_STATE(17980)] = 314959,
  [SMALL_STATE(17981)] = 314970,
  [SMALL_STATE(17982)] = 314981,
  [SMALL_STATE(17983)] = 314992,
  [SMALL_STATE(17984)] = 315003,
  [SMALL_STATE(17985)] = 315014,
  [SMALL_STATE(17986)] = 315025,
  [SMALL_STATE(17987)] = 315036,
  [SMALL_STATE(17988)] = 315047,
  [SMALL_STATE(17989)] = 315058,
  [SMALL_STATE(17990)] = 315069,
  [SMALL_STATE(17991)] = 315080,
  [SMALL_STATE(17992)] = 315091,
  [SMALL_STATE(17993)] = 315102,
  [SMALL_STATE(17994)] = 315113,
  [SMALL_STATE(17995)] = 315124,
  [SMALL_STATE(17996)] = 315135,
  [SMALL_STATE(17997)] = 315146,
  [SMALL_STATE(17998)] = 315157,
  [SMALL_STATE(17999)] = 315168,
  [SMALL_STATE(18000)] = 315179,
  [SMALL_STATE(18001)] = 315192,
  [SMALL_STATE(18002)] = 315203,
  [SMALL_STATE(18003)] = 315214,
  [SMALL_STATE(18004)] = 315227,
  [SMALL_STATE(18005)] = 315238,
  [SMALL_STATE(18006)] = 315251,
  [SMALL_STATE(18007)] = 315262,
  [SMALL_STATE(18008)] = 315275,
  [SMALL_STATE(18009)] = 315286,
  [SMALL_STATE(18010)] = 315299,
  [SMALL_STATE(18011)] = 315310,
  [SMALL_STATE(18012)] = 315323,
  [SMALL_STATE(18013)] = 315334,
  [SMALL_STATE(18014)] = 315347,
  [SMALL_STATE(18015)] = 315358,
  [SMALL_STATE(18016)] = 315369,
  [SMALL_STATE(18017)] = 315382,
  [SMALL_STATE(18018)] = 315393,
  [SMALL_STATE(18019)] = 315404,
  [SMALL_STATE(18020)] = 315415,
  [SMALL_STATE(18021)] = 315426,
  [SMALL_STATE(18022)] = 315439,
  [SMALL_STATE(18023)] = 315452,
  [SMALL_STATE(18024)] = 315463,
  [SMALL_STATE(18025)] = 315474,
  [SMALL_STATE(18026)] = 315485,
  [SMALL_STATE(18027)] = 315498,
  [SMALL_STATE(18028)] = 315509,
  [SMALL_STATE(18029)] = 315520,
  [SMALL_STATE(18030)] = 315531,
  [SMALL_STATE(18031)] = 315544,
  [SMALL_STATE(18032)] = 315553,
  [SMALL_STATE(18033)] = 315564,
  [SMALL_STATE(18034)] = 315575,
  [SMALL_STATE(18035)] = 315584,
  [SMALL_STATE(18036)] = 315595,
  [SMALL_STATE(18037)] = 315606,
  [SMALL_STATE(18038)] = 315617,
  [SMALL_STATE(18039)] = 315628,
  [SMALL_STATE(18040)] = 315639,
  [SMALL_STATE(18041)] = 315648,
  [SMALL_STATE(18042)] = 315657,
  [SMALL_STATE(18043)] = 315668,
  [SMALL_STATE(18044)] = 315681,
  [SMALL_STATE(18045)] = 315692,
  [SMALL_STATE(18046)] = 315703,
  [SMALL_STATE(18047)] = 315714,
  [SMALL_STATE(18048)] = 315725,
  [SMALL_STATE(18049)] = 315738,
  [SMALL_STATE(18050)] = 315749,
  [SMALL_STATE(18051)] = 315758,
  [SMALL_STATE(18052)] = 315769,
  [SMALL_STATE(18053)] = 315780,
  [SMALL_STATE(18054)] = 315791,
  [SMALL_STATE(18055)] = 315802,
  [SMALL_STATE(18056)] = 315811,
  [SMALL_STATE(18057)] = 315820,
  [SMALL_STATE(18058)] = 315833,
  [SMALL_STATE(18059)] = 315846,
  [SMALL_STATE(18060)] = 315859,
  [SMALL_STATE(18061)] = 315870,
  [SMALL_STATE(18062)] = 315881,
  [SMALL_STATE(18063)] = 315892,
  [SMALL_STATE(18064)] = 315903,
  [SMALL_STATE(18065)] = 315912,
  [SMALL_STATE(18066)] = 315925,
  [SMALL_STATE(18067)] = 315934,
  [SMALL_STATE(18068)] = 315943,
  [SMALL_STATE(18069)] = 315954,
  [SMALL_STATE(18070)] = 315967,
  [SMALL_STATE(18071)] = 315978,
  [SMALL_STATE(18072)] = 315989,
  [SMALL_STATE(18073)] = 315998,
  [SMALL_STATE(18074)] = 316009,
  [SMALL_STATE(18075)] = 316018,
  [SMALL_STATE(18076)] = 316029,
  [SMALL_STATE(18077)] = 316040,
  [SMALL_STATE(18078)] = 316053,
  [SMALL_STATE(18079)] = 316064,
  [SMALL_STATE(18080)] = 316073,
  [SMALL_STATE(18081)] = 316084,
  [SMALL_STATE(18082)] = 316095,
  [SMALL_STATE(18083)] = 316106,
  [SMALL_STATE(18084)] = 316115,
  [SMALL_STATE(18085)] = 316126,
  [SMALL_STATE(18086)] = 316135,
  [SMALL_STATE(18087)] = 316144,
  [SMALL_STATE(18088)] = 316153,
  [SMALL_STATE(18089)] = 316166,
  [SMALL_STATE(18090)] = 316177,
  [SMALL_STATE(18091)] = 316186,
  [SMALL_STATE(18092)] = 316197,
  [SMALL_STATE(18093)] = 316208,
  [SMALL_STATE(18094)] = 316219,
  [SMALL_STATE(18095)] = 316228,
  [SMALL_STATE(18096)] = 316239,
  [SMALL_STATE(18097)] = 316250,
  [SMALL_STATE(18098)] = 316261,
  [SMALL_STATE(18099)] = 316274,
  [SMALL_STATE(18100)] = 316285,
  [SMALL_STATE(18101)] = 316296,
  [SMALL_STATE(18102)] = 316307,
  [SMALL_STATE(18103)] = 316320,
  [SMALL_STATE(18104)] = 316331,
  [SMALL_STATE(18105)] = 316342,
  [SMALL_STATE(18106)] = 316353,
  [SMALL_STATE(18107)] = 316364,
  [SMALL_STATE(18108)] = 316375,
  [SMALL_STATE(18109)] = 316386,
  [SMALL_STATE(18110)] = 316397,
  [SMALL_STATE(18111)] = 316408,
  [SMALL_STATE(18112)] = 316419,
  [SMALL_STATE(18113)] = 316430,
  [SMALL_STATE(18114)] = 316441,
  [SMALL_STATE(18115)] = 316452,
  [SMALL_STATE(18116)] = 316463,
  [SMALL_STATE(18117)] = 316474,
  [SMALL_STATE(18118)] = 316485,
  [SMALL_STATE(18119)] = 316496,
  [SMALL_STATE(18120)] = 316507,
  [SMALL_STATE(18121)] = 316518,
  [SMALL_STATE(18122)] = 316529,
  [SMALL_STATE(18123)] = 316540,
  [SMALL_STATE(18124)] = 316551,
  [SMALL_STATE(18125)] = 316562,
  [SMALL_STATE(18126)] = 316573,
  [SMALL_STATE(18127)] = 316586,
  [SMALL_STATE(18128)] = 316599,
  [SMALL_STATE(18129)] = 316610,
  [SMALL_STATE(18130)] = 316621,
  [SMALL_STATE(18131)] = 316632,
  [SMALL_STATE(18132)] = 316643,
  [SMALL_STATE(18133)] = 316654,
  [SMALL_STATE(18134)] = 316665,
  [SMALL_STATE(18135)] = 316674,
  [SMALL_STATE(18136)] = 316685,
  [SMALL_STATE(18137)] = 316696,
  [SMALL_STATE(18138)] = 316707,
  [SMALL_STATE(18139)] = 316718,
  [SMALL_STATE(18140)] = 316729,
  [SMALL_STATE(18141)] = 316742,
  [SMALL_STATE(18142)] = 316755,
  [SMALL_STATE(18143)] = 316764,
  [SMALL_STATE(18144)] = 316773,
  [SMALL_STATE(18145)] = 316782,
  [SMALL_STATE(18146)] = 316793,
  [SMALL_STATE(18147)] = 316804,
  [SMALL_STATE(18148)] = 316815,
  [SMALL_STATE(18149)] = 316826,
  [SMALL_STATE(18150)] = 316839,
  [SMALL_STATE(18151)] = 316850,
  [SMALL_STATE(18152)] = 316861,
  [SMALL_STATE(18153)] = 316874,
  [SMALL_STATE(18154)] = 316885,
  [SMALL_STATE(18155)] = 316893,
  [SMALL_STATE(18156)] = 316901,
  [SMALL_STATE(18157)] = 316909,
  [SMALL_STATE(18158)] = 316917,
  [SMALL_STATE(18159)] = 316925,
  [SMALL_STATE(18160)] = 316933,
  [SMALL_STATE(18161)] = 316941,
  [SMALL_STATE(18162)] = 316949,
  [SMALL_STATE(18163)] = 316957,
  [SMALL_STATE(18164)] = 316965,
  [SMALL_STATE(18165)] = 316973,
  [SMALL_STATE(18166)] = 316981,
  [SMALL_STATE(18167)] = 316989,
  [SMALL_STATE(18168)] = 316997,
  [SMALL_STATE(18169)] = 317005,
  [SMALL_STATE(18170)] = 317013,
  [SMALL_STATE(18171)] = 317021,
  [SMALL_STATE(18172)] = 317029,
  [SMALL_STATE(18173)] = 317037,
  [SMALL_STATE(18174)] = 317045,
  [SMALL_STATE(18175)] = 317053,
  [SMALL_STATE(18176)] = 317061,
  [SMALL_STATE(18177)] = 317069,
  [SMALL_STATE(18178)] = 317077,
  [SMALL_STATE(18179)] = 317085,
  [SMALL_STATE(18180)] = 317093,
  [SMALL_STATE(18181)] = 317101,
  [SMALL_STATE(18182)] = 317109,
  [SMALL_STATE(18183)] = 317117,
  [SMALL_STATE(18184)] = 317125,
  [SMALL_STATE(18185)] = 317133,
  [SMALL_STATE(18186)] = 317141,
  [SMALL_STATE(18187)] = 317149,
  [SMALL_STATE(18188)] = 317157,
  [SMALL_STATE(18189)] = 317165,
  [SMALL_STATE(18190)] = 317173,
  [SMALL_STATE(18191)] = 317181,
  [SMALL_STATE(18192)] = 317189,
  [SMALL_STATE(18193)] = 317197,
  [SMALL_STATE(18194)] = 317205,
  [SMALL_STATE(18195)] = 317213,
  [SMALL_STATE(18196)] = 317221,
  [SMALL_STATE(18197)] = 317229,
  [SMALL_STATE(18198)] = 317237,
  [SMALL_STATE(18199)] = 317245,
  [SMALL_STATE(18200)] = 317253,
  [SMALL_STATE(18201)] = 317261,
  [SMALL_STATE(18202)] = 317269,
  [SMALL_STATE(18203)] = 317277,
  [SMALL_STATE(18204)] = 317285,
  [SMALL_STATE(18205)] = 317293,
  [SMALL_STATE(18206)] = 317301,
  [SMALL_STATE(18207)] = 317309,
  [SMALL_STATE(18208)] = 317317,
  [SMALL_STATE(18209)] = 317325,
  [SMALL_STATE(18210)] = 317333,
  [SMALL_STATE(18211)] = 317341,
  [SMALL_STATE(18212)] = 317349,
  [SMALL_STATE(18213)] = 317357,
  [SMALL_STATE(18214)] = 317365,
  [SMALL_STATE(18215)] = 317373,
  [SMALL_STATE(18216)] = 317381,
  [SMALL_STATE(18217)] = 317389,
  [SMALL_STATE(18218)] = 317397,
  [SMALL_STATE(18219)] = 317405,
  [SMALL_STATE(18220)] = 317413,
  [SMALL_STATE(18221)] = 317421,
  [SMALL_STATE(18222)] = 317429,
  [SMALL_STATE(18223)] = 317437,
  [SMALL_STATE(18224)] = 317445,
  [SMALL_STATE(18225)] = 317453,
  [SMALL_STATE(18226)] = 317461,
  [SMALL_STATE(18227)] = 317469,
  [SMALL_STATE(18228)] = 317477,
  [SMALL_STATE(18229)] = 317485,
  [SMALL_STATE(18230)] = 317493,
  [SMALL_STATE(18231)] = 317501,
  [SMALL_STATE(18232)] = 317509,
  [SMALL_STATE(18233)] = 317517,
  [SMALL_STATE(18234)] = 317525,
  [SMALL_STATE(18235)] = 317533,
  [SMALL_STATE(18236)] = 317541,
  [SMALL_STATE(18237)] = 317549,
  [SMALL_STATE(18238)] = 317557,
  [SMALL_STATE(18239)] = 317565,
  [SMALL_STATE(18240)] = 317573,
  [SMALL_STATE(18241)] = 317581,
  [SMALL_STATE(18242)] = 317589,
  [SMALL_STATE(18243)] = 317597,
  [SMALL_STATE(18244)] = 317605,
  [SMALL_STATE(18245)] = 317613,
  [SMALL_STATE(18246)] = 317621,
  [SMALL_STATE(18247)] = 317629,
  [SMALL_STATE(18248)] = 317637,
  [SMALL_STATE(18249)] = 317645,
  [SMALL_STATE(18250)] = 317653,
  [SMALL_STATE(18251)] = 317661,
  [SMALL_STATE(18252)] = 317669,
  [SMALL_STATE(18253)] = 317677,
  [SMALL_STATE(18254)] = 317685,
  [SMALL_STATE(18255)] = 317693,
  [SMALL_STATE(18256)] = 317701,
  [SMALL_STATE(18257)] = 317709,
  [SMALL_STATE(18258)] = 317717,
  [SMALL_STATE(18259)] = 317725,
  [SMALL_STATE(18260)] = 317733,
  [SMALL_STATE(18261)] = 317741,
  [SMALL_STATE(18262)] = 317749,
  [SMALL_STATE(18263)] = 317757,
  [SMALL_STATE(18264)] = 317765,
  [SMALL_STATE(18265)] = 317773,
  [SMALL_STATE(18266)] = 317781,
  [SMALL_STATE(18267)] = 317789,
  [SMALL_STATE(18268)] = 317797,
  [SMALL_STATE(18269)] = 317805,
  [SMALL_STATE(18270)] = 317813,
  [SMALL_STATE(18271)] = 317821,
  [SMALL_STATE(18272)] = 317829,
  [SMALL_STATE(18273)] = 317837,
  [SMALL_STATE(18274)] = 317845,
  [SMALL_STATE(18275)] = 317853,
  [SMALL_STATE(18276)] = 317861,
  [SMALL_STATE(18277)] = 317869,
  [SMALL_STATE(18278)] = 317877,
  [SMALL_STATE(18279)] = 317885,
  [SMALL_STATE(18280)] = 317893,
  [SMALL_STATE(18281)] = 317901,
  [SMALL_STATE(18282)] = 317909,
  [SMALL_STATE(18283)] = 317917,
  [SMALL_STATE(18284)] = 317925,
  [SMALL_STATE(18285)] = 317933,
  [SMALL_STATE(18286)] = 317941,
  [SMALL_STATE(18287)] = 317949,
  [SMALL_STATE(18288)] = 317957,
  [SMALL_STATE(18289)] = 317965,
  [SMALL_STATE(18290)] = 317973,
  [SMALL_STATE(18291)] = 317981,
  [SMALL_STATE(18292)] = 317989,
  [SMALL_STATE(18293)] = 317997,
  [SMALL_STATE(18294)] = 318005,
  [SMALL_STATE(18295)] = 318013,
  [SMALL_STATE(18296)] = 318021,
  [SMALL_STATE(18297)] = 318029,
  [SMALL_STATE(18298)] = 318037,
  [SMALL_STATE(18299)] = 318045,
  [SMALL_STATE(18300)] = 318053,
  [SMALL_STATE(18301)] = 318061,
  [SMALL_STATE(18302)] = 318069,
  [SMALL_STATE(18303)] = 318077,
  [SMALL_STATE(18304)] = 318085,
  [SMALL_STATE(18305)] = 318093,
  [SMALL_STATE(18306)] = 318101,
  [SMALL_STATE(18307)] = 318109,
  [SMALL_STATE(18308)] = 318117,
  [SMALL_STATE(18309)] = 318125,
  [SMALL_STATE(18310)] = 318133,
  [SMALL_STATE(18311)] = 318141,
  [SMALL_STATE(18312)] = 318149,
  [SMALL_STATE(18313)] = 318157,
  [SMALL_STATE(18314)] = 318165,
  [SMALL_STATE(18315)] = 318173,
  [SMALL_STATE(18316)] = 318181,
  [SMALL_STATE(18317)] = 318189,
  [SMALL_STATE(18318)] = 318197,
  [SMALL_STATE(18319)] = 318205,
  [SMALL_STATE(18320)] = 318213,
  [SMALL_STATE(18321)] = 318221,
  [SMALL_STATE(18322)] = 318229,
  [SMALL_STATE(18323)] = 318237,
  [SMALL_STATE(18324)] = 318245,
  [SMALL_STATE(18325)] = 318253,
  [SMALL_STATE(18326)] = 318261,
  [SMALL_STATE(18327)] = 318269,
  [SMALL_STATE(18328)] = 318277,
  [SMALL_STATE(18329)] = 318285,
  [SMALL_STATE(18330)] = 318293,
  [SMALL_STATE(18331)] = 318301,
  [SMALL_STATE(18332)] = 318309,
  [SMALL_STATE(18333)] = 318317,
  [SMALL_STATE(18334)] = 318325,
  [SMALL_STATE(18335)] = 318333,
  [SMALL_STATE(18336)] = 318341,
  [SMALL_STATE(18337)] = 318349,
  [SMALL_STATE(18338)] = 318357,
  [SMALL_STATE(18339)] = 318365,
  [SMALL_STATE(18340)] = 318373,
  [SMALL_STATE(18341)] = 318381,
  [SMALL_STATE(18342)] = 318389,
  [SMALL_STATE(18343)] = 318397,
  [SMALL_STATE(18344)] = 318405,
  [SMALL_STATE(18345)] = 318413,
  [SMALL_STATE(18346)] = 318421,
  [SMALL_STATE(18347)] = 318429,
  [SMALL_STATE(18348)] = 318437,
  [SMALL_STATE(18349)] = 318445,
  [SMALL_STATE(18350)] = 318453,
  [SMALL_STATE(18351)] = 318461,
  [SMALL_STATE(18352)] = 318469,
  [SMALL_STATE(18353)] = 318477,
  [SMALL_STATE(18354)] = 318485,
  [SMALL_STATE(18355)] = 318493,
  [SMALL_STATE(18356)] = 318501,
  [SMALL_STATE(18357)] = 318509,
  [SMALL_STATE(18358)] = 318517,
  [SMALL_STATE(18359)] = 318525,
  [SMALL_STATE(18360)] = 318533,
  [SMALL_STATE(18361)] = 318541,
  [SMALL_STATE(18362)] = 318549,
  [SMALL_STATE(18363)] = 318557,
  [SMALL_STATE(18364)] = 318565,
  [SMALL_STATE(18365)] = 318573,
  [SMALL_STATE(18366)] = 318581,
  [SMALL_STATE(18367)] = 318589,
  [SMALL_STATE(18368)] = 318597,
  [SMALL_STATE(18369)] = 318605,
  [SMALL_STATE(18370)] = 318613,
  [SMALL_STATE(18371)] = 318621,
  [SMALL_STATE(18372)] = 318629,
  [SMALL_STATE(18373)] = 318637,
  [SMALL_STATE(18374)] = 318645,
  [SMALL_STATE(18375)] = 318653,
  [SMALL_STATE(18376)] = 318661,
  [SMALL_STATE(18377)] = 318669,
  [SMALL_STATE(18378)] = 318677,
  [SMALL_STATE(18379)] = 318685,
  [SMALL_STATE(18380)] = 318693,
  [SMALL_STATE(18381)] = 318701,
  [SMALL_STATE(18382)] = 318709,
  [SMALL_STATE(18383)] = 318717,
  [SMALL_STATE(18384)] = 318725,
  [SMALL_STATE(18385)] = 318733,
  [SMALL_STATE(18386)] = 318741,
  [SMALL_STATE(18387)] = 318749,
  [SMALL_STATE(18388)] = 318757,
  [SMALL_STATE(18389)] = 318765,
  [SMALL_STATE(18390)] = 318773,
  [SMALL_STATE(18391)] = 318781,
  [SMALL_STATE(18392)] = 318789,
  [SMALL_STATE(18393)] = 318797,
  [SMALL_STATE(18394)] = 318805,
  [SMALL_STATE(18395)] = 318813,
  [SMALL_STATE(18396)] = 318821,
  [SMALL_STATE(18397)] = 318829,
  [SMALL_STATE(18398)] = 318837,
  [SMALL_STATE(18399)] = 318845,
  [SMALL_STATE(18400)] = 318853,
  [SMALL_STATE(18401)] = 318861,
  [SMALL_STATE(18402)] = 318869,
  [SMALL_STATE(18403)] = 318877,
  [SMALL_STATE(18404)] = 318885,
  [SMALL_STATE(18405)] = 318893,
  [SMALL_STATE(18406)] = 318901,
  [SMALL_STATE(18407)] = 318909,
  [SMALL_STATE(18408)] = 318917,
  [SMALL_STATE(18409)] = 318925,
  [SMALL_STATE(18410)] = 318933,
  [SMALL_STATE(18411)] = 318941,
  [SMALL_STATE(18412)] = 318949,
  [SMALL_STATE(18413)] = 318957,
  [SMALL_STATE(18414)] = 318965,
  [SMALL_STATE(18415)] = 318973,
  [SMALL_STATE(18416)] = 318981,
  [SMALL_STATE(18417)] = 318989,
  [SMALL_STATE(18418)] = 318997,
  [SMALL_STATE(18419)] = 319005,
  [SMALL_STATE(18420)] = 319013,
  [SMALL_STATE(18421)] = 319021,
  [SMALL_STATE(18422)] = 319029,
  [SMALL_STATE(18423)] = 319037,
  [SMALL_STATE(18424)] = 319045,
  [SMALL_STATE(18425)] = 319053,
  [SMALL_STATE(18426)] = 319061,
  [SMALL_STATE(18427)] = 319069,
  [SMALL_STATE(18428)] = 319077,
  [SMALL_STATE(18429)] = 319085,
  [SMALL_STATE(18430)] = 319093,
  [SMALL_STATE(18431)] = 319101,
  [SMALL_STATE(18432)] = 319109,
  [SMALL_STATE(18433)] = 319117,
  [SMALL_STATE(18434)] = 319125,
  [SMALL_STATE(18435)] = 319133,
  [SMALL_STATE(18436)] = 319141,
  [SMALL_STATE(18437)] = 319149,
  [SMALL_STATE(18438)] = 319157,
  [SMALL_STATE(18439)] = 319165,
  [SMALL_STATE(18440)] = 319173,
  [SMALL_STATE(18441)] = 319181,
  [SMALL_STATE(18442)] = 319189,
  [SMALL_STATE(18443)] = 319197,
  [SMALL_STATE(18444)] = 319205,
  [SMALL_STATE(18445)] = 319213,
  [SMALL_STATE(18446)] = 319221,
  [SMALL_STATE(18447)] = 319229,
  [SMALL_STATE(18448)] = 319237,
  [SMALL_STATE(18449)] = 319245,
  [SMALL_STATE(18450)] = 319253,
  [SMALL_STATE(18451)] = 319261,
  [SMALL_STATE(18452)] = 319269,
  [SMALL_STATE(18453)] = 319277,
  [SMALL_STATE(18454)] = 319285,
  [SMALL_STATE(18455)] = 319293,
  [SMALL_STATE(18456)] = 319301,
  [SMALL_STATE(18457)] = 319309,
  [SMALL_STATE(18458)] = 319317,
  [SMALL_STATE(18459)] = 319325,
  [SMALL_STATE(18460)] = 319333,
  [SMALL_STATE(18461)] = 319341,
  [SMALL_STATE(18462)] = 319349,
  [SMALL_STATE(18463)] = 319357,
  [SMALL_STATE(18464)] = 319365,
  [SMALL_STATE(18465)] = 319373,
  [SMALL_STATE(18466)] = 319381,
  [SMALL_STATE(18467)] = 319389,
  [SMALL_STATE(18468)] = 319397,
  [SMALL_STATE(18469)] = 319405,
  [SMALL_STATE(18470)] = 319413,
  [SMALL_STATE(18471)] = 319421,
  [SMALL_STATE(18472)] = 319429,
  [SMALL_STATE(18473)] = 319437,
  [SMALL_STATE(18474)] = 319445,
  [SMALL_STATE(18475)] = 319453,
  [SMALL_STATE(18476)] = 319461,
  [SMALL_STATE(18477)] = 319469,
  [SMALL_STATE(18478)] = 319477,
  [SMALL_STATE(18479)] = 319485,
  [SMALL_STATE(18480)] = 319493,
  [SMALL_STATE(18481)] = 319501,
  [SMALL_STATE(18482)] = 319509,
  [SMALL_STATE(18483)] = 319517,
  [SMALL_STATE(18484)] = 319525,
  [SMALL_STATE(18485)] = 319533,
  [SMALL_STATE(18486)] = 319541,
  [SMALL_STATE(18487)] = 319549,
  [SMALL_STATE(18488)] = 319557,
  [SMALL_STATE(18489)] = 319565,
  [SMALL_STATE(18490)] = 319573,
  [SMALL_STATE(18491)] = 319581,
  [SMALL_STATE(18492)] = 319589,
  [SMALL_STATE(18493)] = 319597,
  [SMALL_STATE(18494)] = 319605,
  [SMALL_STATE(18495)] = 319613,
  [SMALL_STATE(18496)] = 319621,
  [SMALL_STATE(18497)] = 319629,
  [SMALL_STATE(18498)] = 319637,
  [SMALL_STATE(18499)] = 319645,
  [SMALL_STATE(18500)] = 319653,
  [SMALL_STATE(18501)] = 319661,
  [SMALL_STATE(18502)] = 319669,
  [SMALL_STATE(18503)] = 319677,
  [SMALL_STATE(18504)] = 319685,
  [SMALL_STATE(18505)] = 319693,
  [SMALL_STATE(18506)] = 319701,
  [SMALL_STATE(18507)] = 319709,
  [SMALL_STATE(18508)] = 319717,
  [SMALL_STATE(18509)] = 319725,
  [SMALL_STATE(18510)] = 319733,
  [SMALL_STATE(18511)] = 319741,
  [SMALL_STATE(18512)] = 319749,
  [SMALL_STATE(18513)] = 319757,
  [SMALL_STATE(18514)] = 319765,
  [SMALL_STATE(18515)] = 319773,
  [SMALL_STATE(18516)] = 319781,
  [SMALL_STATE(18517)] = 319789,
  [SMALL_STATE(18518)] = 319797,
  [SMALL_STATE(18519)] = 319805,
  [SMALL_STATE(18520)] = 319813,
  [SMALL_STATE(18521)] = 319821,
  [SMALL_STATE(18522)] = 319829,
  [SMALL_STATE(18523)] = 319837,
  [SMALL_STATE(18524)] = 319845,
  [SMALL_STATE(18525)] = 319853,
  [SMALL_STATE(18526)] = 319861,
  [SMALL_STATE(18527)] = 319869,
  [SMALL_STATE(18528)] = 319877,
  [SMALL_STATE(18529)] = 319885,
  [SMALL_STATE(18530)] = 319893,
  [SMALL_STATE(18531)] = 319901,
  [SMALL_STATE(18532)] = 319909,
  [SMALL_STATE(18533)] = 319917,
  [SMALL_STATE(18534)] = 319925,
  [SMALL_STATE(18535)] = 319933,
  [SMALL_STATE(18536)] = 319941,
  [SMALL_STATE(18537)] = 319949,
  [SMALL_STATE(18538)] = 319957,
  [SMALL_STATE(18539)] = 319965,
  [SMALL_STATE(18540)] = 319973,
  [SMALL_STATE(18541)] = 319981,
  [SMALL_STATE(18542)] = 319989,
  [SMALL_STATE(18543)] = 319997,
  [SMALL_STATE(18544)] = 320005,
  [SMALL_STATE(18545)] = 320013,
  [SMALL_STATE(18546)] = 320021,
  [SMALL_STATE(18547)] = 320029,
  [SMALL_STATE(18548)] = 320037,
  [SMALL_STATE(18549)] = 320045,
  [SMALL_STATE(18550)] = 320053,
  [SMALL_STATE(18551)] = 320061,
  [SMALL_STATE(18552)] = 320069,
  [SMALL_STATE(18553)] = 320077,
  [SMALL_STATE(18554)] = 320085,
  [SMALL_STATE(18555)] = 320093,
  [SMALL_STATE(18556)] = 320101,
  [SMALL_STATE(18557)] = 320109,
  [SMALL_STATE(18558)] = 320117,
  [SMALL_STATE(18559)] = 320125,
  [SMALL_STATE(18560)] = 320133,
  [SMALL_STATE(18561)] = 320141,
  [SMALL_STATE(18562)] = 320149,
  [SMALL_STATE(18563)] = 320157,
  [SMALL_STATE(18564)] = 320165,
  [SMALL_STATE(18565)] = 320173,
  [SMALL_STATE(18566)] = 320181,
  [SMALL_STATE(18567)] = 320189,
  [SMALL_STATE(18568)] = 320197,
  [SMALL_STATE(18569)] = 320205,
  [SMALL_STATE(18570)] = 320213,
  [SMALL_STATE(18571)] = 320221,
  [SMALL_STATE(18572)] = 320229,
  [SMALL_STATE(18573)] = 320237,
  [SMALL_STATE(18574)] = 320245,
  [SMALL_STATE(18575)] = 320253,
  [SMALL_STATE(18576)] = 320261,
  [SMALL_STATE(18577)] = 320269,
  [SMALL_STATE(18578)] = 320277,
  [SMALL_STATE(18579)] = 320285,
  [SMALL_STATE(18580)] = 320293,
  [SMALL_STATE(18581)] = 320301,
  [SMALL_STATE(18582)] = 320309,
  [SMALL_STATE(18583)] = 320317,
  [SMALL_STATE(18584)] = 320325,
  [SMALL_STATE(18585)] = 320333,
  [SMALL_STATE(18586)] = 320341,
  [SMALL_STATE(18587)] = 320349,
  [SMALL_STATE(18588)] = 320357,
  [SMALL_STATE(18589)] = 320365,
  [SMALL_STATE(18590)] = 320373,
  [SMALL_STATE(18591)] = 320381,
  [SMALL_STATE(18592)] = 320389,
  [SMALL_STATE(18593)] = 320397,
  [SMALL_STATE(18594)] = 320405,
  [SMALL_STATE(18595)] = 320413,
  [SMALL_STATE(18596)] = 320421,
  [SMALL_STATE(18597)] = 320429,
  [SMALL_STATE(18598)] = 320437,
  [SMALL_STATE(18599)] = 320445,
  [SMALL_STATE(18600)] = 320453,
  [SMALL_STATE(18601)] = 320461,
  [SMALL_STATE(18602)] = 320469,
  [SMALL_STATE(18603)] = 320477,
  [SMALL_STATE(18604)] = 320485,
  [SMALL_STATE(18605)] = 320493,
  [SMALL_STATE(18606)] = 320501,
  [SMALL_STATE(18607)] = 320509,
  [SMALL_STATE(18608)] = 320517,
  [SMALL_STATE(18609)] = 320525,
  [SMALL_STATE(18610)] = 320533,
  [SMALL_STATE(18611)] = 320541,
  [SMALL_STATE(18612)] = 320549,
  [SMALL_STATE(18613)] = 320557,
  [SMALL_STATE(18614)] = 320565,
  [SMALL_STATE(18615)] = 320573,
  [SMALL_STATE(18616)] = 320581,
  [SMALL_STATE(18617)] = 320589,
  [SMALL_STATE(18618)] = 320597,
  [SMALL_STATE(18619)] = 320605,
  [SMALL_STATE(18620)] = 320613,
  [SMALL_STATE(18621)] = 320621,
  [SMALL_STATE(18622)] = 320629,
  [SMALL_STATE(18623)] = 320637,
  [SMALL_STATE(18624)] = 320645,
  [SMALL_STATE(18625)] = 320653,
  [SMALL_STATE(18626)] = 320661,
  [SMALL_STATE(18627)] = 320669,
  [SMALL_STATE(18628)] = 320677,
  [SMALL_STATE(18629)] = 320685,
  [SMALL_STATE(18630)] = 320693,
  [SMALL_STATE(18631)] = 320701,
  [SMALL_STATE(18632)] = 320709,
  [SMALL_STATE(18633)] = 320717,
  [SMALL_STATE(18634)] = 320725,
  [SMALL_STATE(18635)] = 320733,
  [SMALL_STATE(18636)] = 320741,
  [SMALL_STATE(18637)] = 320749,
  [SMALL_STATE(18638)] = 320757,
  [SMALL_STATE(18639)] = 320765,
  [SMALL_STATE(18640)] = 320773,
  [SMALL_STATE(18641)] = 320781,
  [SMALL_STATE(18642)] = 320789,
  [SMALL_STATE(18643)] = 320797,
  [SMALL_STATE(18644)] = 320805,
  [SMALL_STATE(18645)] = 320813,
  [SMALL_STATE(18646)] = 320821,
  [SMALL_STATE(18647)] = 320829,
  [SMALL_STATE(18648)] = 320837,
  [SMALL_STATE(18649)] = 320845,
  [SMALL_STATE(18650)] = 320853,
  [SMALL_STATE(18651)] = 320861,
  [SMALL_STATE(18652)] = 320869,
  [SMALL_STATE(18653)] = 320877,
  [SMALL_STATE(18654)] = 320885,
  [SMALL_STATE(18655)] = 320893,
  [SMALL_STATE(18656)] = 320901,
  [SMALL_STATE(18657)] = 320909,
  [SMALL_STATE(18658)] = 320917,
  [SMALL_STATE(18659)] = 320925,
  [SMALL_STATE(18660)] = 320933,
  [SMALL_STATE(18661)] = 320941,
  [SMALL_STATE(18662)] = 320949,
  [SMALL_STATE(18663)] = 320957,
  [SMALL_STATE(18664)] = 320965,
  [SMALL_STATE(18665)] = 320973,
  [SMALL_STATE(18666)] = 320981,
  [SMALL_STATE(18667)] = 320989,
  [SMALL_STATE(18668)] = 320997,
  [SMALL_STATE(18669)] = 321005,
  [SMALL_STATE(18670)] = 321013,
  [SMALL_STATE(18671)] = 321021,
  [SMALL_STATE(18672)] = 321029,
  [SMALL_STATE(18673)] = 321037,
  [SMALL_STATE(18674)] = 321045,
  [SMALL_STATE(18675)] = 321053,
  [SMALL_STATE(18676)] = 321061,
  [SMALL_STATE(18677)] = 321069,
  [SMALL_STATE(18678)] = 321077,
  [SMALL_STATE(18679)] = 321085,
  [SMALL_STATE(18680)] = 321093,
  [SMALL_STATE(18681)] = 321101,
  [SMALL_STATE(18682)] = 321109,
  [SMALL_STATE(18683)] = 321117,
  [SMALL_STATE(18684)] = 321125,
  [SMALL_STATE(18685)] = 321133,
  [SMALL_STATE(18686)] = 321141,
  [SMALL_STATE(18687)] = 321149,
  [SMALL_STATE(18688)] = 321157,
  [SMALL_STATE(18689)] = 321165,
  [SMALL_STATE(18690)] = 321173,
  [SMALL_STATE(18691)] = 321181,
  [SMALL_STATE(18692)] = 321189,
  [SMALL_STATE(18693)] = 321197,
  [SMALL_STATE(18694)] = 321205,
  [SMALL_STATE(18695)] = 321213,
  [SMALL_STATE(18696)] = 321221,
  [SMALL_STATE(18697)] = 321229,
  [SMALL_STATE(18698)] = 321237,
  [SMALL_STATE(18699)] = 321245,
  [SMALL_STATE(18700)] = 321253,
  [SMALL_STATE(18701)] = 321261,
  [SMALL_STATE(18702)] = 321269,
  [SMALL_STATE(18703)] = 321277,
  [SMALL_STATE(18704)] = 321285,
  [SMALL_STATE(18705)] = 321293,
  [SMALL_STATE(18706)] = 321301,
  [SMALL_STATE(18707)] = 321309,
  [SMALL_STATE(18708)] = 321317,
  [SMALL_STATE(18709)] = 321325,
  [SMALL_STATE(18710)] = 321333,
  [SMALL_STATE(18711)] = 321341,
  [SMALL_STATE(18712)] = 321349,
  [SMALL_STATE(18713)] = 321357,
  [SMALL_STATE(18714)] = 321365,
  [SMALL_STATE(18715)] = 321373,
  [SMALL_STATE(18716)] = 321381,
  [SMALL_STATE(18717)] = 321389,
  [SMALL_STATE(18718)] = 321397,
  [SMALL_STATE(18719)] = 321405,
  [SMALL_STATE(18720)] = 321413,
  [SMALL_STATE(18721)] = 321421,
  [SMALL_STATE(18722)] = 321429,
  [SMALL_STATE(18723)] = 321437,
  [SMALL_STATE(18724)] = 321445,
  [SMALL_STATE(18725)] = 321453,
  [SMALL_STATE(18726)] = 321461,
  [SMALL_STATE(18727)] = 321469,
  [SMALL_STATE(18728)] = 321477,
  [SMALL_STATE(18729)] = 321485,
  [SMALL_STATE(18730)] = 321493,
  [SMALL_STATE(18731)] = 321501,
  [SMALL_STATE(18732)] = 321509,
  [SMALL_STATE(18733)] = 321517,
  [SMALL_STATE(18734)] = 321525,
  [SMALL_STATE(18735)] = 321533,
  [SMALL_STATE(18736)] = 321541,
  [SMALL_STATE(18737)] = 321549,
  [SMALL_STATE(18738)] = 321557,
  [SMALL_STATE(18739)] = 321565,
  [SMALL_STATE(18740)] = 321573,
  [SMALL_STATE(18741)] = 321581,
  [SMALL_STATE(18742)] = 321589,
  [SMALL_STATE(18743)] = 321597,
  [SMALL_STATE(18744)] = 321605,
  [SMALL_STATE(18745)] = 321613,
  [SMALL_STATE(18746)] = 321621,
  [SMALL_STATE(18747)] = 321629,
  [SMALL_STATE(18748)] = 321637,
  [SMALL_STATE(18749)] = 321645,
  [SMALL_STATE(18750)] = 321653,
  [SMALL_STATE(18751)] = 321661,
  [SMALL_STATE(18752)] = 321669,
  [SMALL_STATE(18753)] = 321677,
  [SMALL_STATE(18754)] = 321685,
  [SMALL_STATE(18755)] = 321693,
  [SMALL_STATE(18756)] = 321701,
  [SMALL_STATE(18757)] = 321709,
  [SMALL_STATE(18758)] = 321717,
  [SMALL_STATE(18759)] = 321725,
  [SMALL_STATE(18760)] = 321733,
  [SMALL_STATE(18761)] = 321741,
  [SMALL_STATE(18762)] = 321749,
  [SMALL_STATE(18763)] = 321757,
  [SMALL_STATE(18764)] = 321765,
  [SMALL_STATE(18765)] = 321773,
  [SMALL_STATE(18766)] = 321781,
  [SMALL_STATE(18767)] = 321789,
  [SMALL_STATE(18768)] = 321797,
  [SMALL_STATE(18769)] = 321805,
  [SMALL_STATE(18770)] = 321813,
  [SMALL_STATE(18771)] = 321821,
  [SMALL_STATE(18772)] = 321829,
  [SMALL_STATE(18773)] = 321837,
  [SMALL_STATE(18774)] = 321845,
  [SMALL_STATE(18775)] = 321853,
  [SMALL_STATE(18776)] = 321861,
  [SMALL_STATE(18777)] = 321869,
  [SMALL_STATE(18778)] = 321877,
  [SMALL_STATE(18779)] = 321885,
  [SMALL_STATE(18780)] = 321893,
  [SMALL_STATE(18781)] = 321901,
  [SMALL_STATE(18782)] = 321909,
  [SMALL_STATE(18783)] = 321917,
  [SMALL_STATE(18784)] = 321925,
  [SMALL_STATE(18785)] = 321933,
  [SMALL_STATE(18786)] = 321941,
  [SMALL_STATE(18787)] = 321949,
  [SMALL_STATE(18788)] = 321957,
  [SMALL_STATE(18789)] = 321965,
  [SMALL_STATE(18790)] = 321973,
  [SMALL_STATE(18791)] = 321981,
  [SMALL_STATE(18792)] = 321989,
  [SMALL_STATE(18793)] = 321997,
  [SMALL_STATE(18794)] = 322005,
  [SMALL_STATE(18795)] = 322013,
  [SMALL_STATE(18796)] = 322021,
  [SMALL_STATE(18797)] = 322029,
  [SMALL_STATE(18798)] = 322037,
  [SMALL_STATE(18799)] = 322045,
  [SMALL_STATE(18800)] = 322053,
  [SMALL_STATE(18801)] = 322061,
  [SMALL_STATE(18802)] = 322069,
  [SMALL_STATE(18803)] = 322077,
  [SMALL_STATE(18804)] = 322085,
  [SMALL_STATE(18805)] = 322093,
  [SMALL_STATE(18806)] = 322101,
  [SMALL_STATE(18807)] = 322109,
  [SMALL_STATE(18808)] = 322117,
  [SMALL_STATE(18809)] = 322125,
  [SMALL_STATE(18810)] = 322133,
  [SMALL_STATE(18811)] = 322141,
  [SMALL_STATE(18812)] = 322149,
  [SMALL_STATE(18813)] = 322157,
  [SMALL_STATE(18814)] = 322165,
  [SMALL_STATE(18815)] = 322173,
  [SMALL_STATE(18816)] = 322181,
  [SMALL_STATE(18817)] = 322189,
  [SMALL_STATE(18818)] = 322197,
  [SMALL_STATE(18819)] = 322205,
  [SMALL_STATE(18820)] = 322213,
  [SMALL_STATE(18821)] = 322221,
  [SMALL_STATE(18822)] = 322229,
  [SMALL_STATE(18823)] = 322237,
  [SMALL_STATE(18824)] = 322245,
  [SMALL_STATE(18825)] = 322253,
  [SMALL_STATE(18826)] = 322261,
  [SMALL_STATE(18827)] = 322269,
  [SMALL_STATE(18828)] = 322277,
  [SMALL_STATE(18829)] = 322285,
  [SMALL_STATE(18830)] = 322293,
  [SMALL_STATE(18831)] = 322301,
  [SMALL_STATE(18832)] = 322309,
  [SMALL_STATE(18833)] = 322317,
  [SMALL_STATE(18834)] = 322325,
  [SMALL_STATE(18835)] = 322333,
  [SMALL_STATE(18836)] = 322341,
  [SMALL_STATE(18837)] = 322349,
  [SMALL_STATE(18838)] = 322357,
  [SMALL_STATE(18839)] = 322365,
  [SMALL_STATE(18840)] = 322373,
  [SMALL_STATE(18841)] = 322381,
  [SMALL_STATE(18842)] = 322389,
  [SMALL_STATE(18843)] = 322397,
  [SMALL_STATE(18844)] = 322405,
  [SMALL_STATE(18845)] = 322413,
  [SMALL_STATE(18846)] = 322421,
  [SMALL_STATE(18847)] = 322429,
  [SMALL_STATE(18848)] = 322437,
  [SMALL_STATE(18849)] = 322445,
  [SMALL_STATE(18850)] = 322453,
  [SMALL_STATE(18851)] = 322461,
  [SMALL_STATE(18852)] = 322469,
  [SMALL_STATE(18853)] = 322477,
  [SMALL_STATE(18854)] = 322485,
  [SMALL_STATE(18855)] = 322493,
  [SMALL_STATE(18856)] = 322501,
  [SMALL_STATE(18857)] = 322509,
  [SMALL_STATE(18858)] = 322517,
  [SMALL_STATE(18859)] = 322525,
  [SMALL_STATE(18860)] = 322533,
  [SMALL_STATE(18861)] = 322541,
  [SMALL_STATE(18862)] = 322549,
  [SMALL_STATE(18863)] = 322557,
  [SMALL_STATE(18864)] = 322565,
  [SMALL_STATE(18865)] = 322573,
  [SMALL_STATE(18866)] = 322581,
  [SMALL_STATE(18867)] = 322589,
  [SMALL_STATE(18868)] = 322597,
  [SMALL_STATE(18869)] = 322605,
  [SMALL_STATE(18870)] = 322613,
  [SMALL_STATE(18871)] = 322621,
  [SMALL_STATE(18872)] = 322629,
  [SMALL_STATE(18873)] = 322637,
  [SMALL_STATE(18874)] = 322645,
  [SMALL_STATE(18875)] = 322653,
  [SMALL_STATE(18876)] = 322661,
  [SMALL_STATE(18877)] = 322669,
  [SMALL_STATE(18878)] = 322677,
  [SMALL_STATE(18879)] = 322685,
  [SMALL_STATE(18880)] = 322693,
  [SMALL_STATE(18881)] = 322701,
  [SMALL_STATE(18882)] = 322709,
  [SMALL_STATE(18883)] = 322717,
  [SMALL_STATE(18884)] = 322725,
  [SMALL_STATE(18885)] = 322733,
  [SMALL_STATE(18886)] = 322741,
  [SMALL_STATE(18887)] = 322749,
  [SMALL_STATE(18888)] = 322757,
  [SMALL_STATE(18889)] = 322765,
  [SMALL_STATE(18890)] = 322773,
  [SMALL_STATE(18891)] = 322781,
  [SMALL_STATE(18892)] = 322789,
  [SMALL_STATE(18893)] = 322797,
  [SMALL_STATE(18894)] = 322805,
  [SMALL_STATE(18895)] = 322813,
  [SMALL_STATE(18896)] = 322821,
  [SMALL_STATE(18897)] = 322829,
  [SMALL_STATE(18898)] = 322837,
  [SMALL_STATE(18899)] = 322845,
  [SMALL_STATE(18900)] = 322853,
  [SMALL_STATE(18901)] = 322861,
  [SMALL_STATE(18902)] = 322869,
  [SMALL_STATE(18903)] = 322877,
  [SMALL_STATE(18904)] = 322885,
  [SMALL_STATE(18905)] = 322893,
  [SMALL_STATE(18906)] = 322901,
  [SMALL_STATE(18907)] = 322909,
  [SMALL_STATE(18908)] = 322917,
  [SMALL_STATE(18909)] = 322925,
  [SMALL_STATE(18910)] = 322933,
  [SMALL_STATE(18911)] = 322941,
  [SMALL_STATE(18912)] = 322949,
  [SMALL_STATE(18913)] = 322957,
  [SMALL_STATE(18914)] = 322965,
  [SMALL_STATE(18915)] = 322973,
  [SMALL_STATE(18916)] = 322981,
  [SMALL_STATE(18917)] = 322989,
  [SMALL_STATE(18918)] = 322997,
  [SMALL_STATE(18919)] = 323005,
  [SMALL_STATE(18920)] = 323013,
  [SMALL_STATE(18921)] = 323021,
  [SMALL_STATE(18922)] = 323029,
  [SMALL_STATE(18923)] = 323037,
  [SMALL_STATE(18924)] = 323045,
  [SMALL_STATE(18925)] = 323053,
  [SMALL_STATE(18926)] = 323061,
  [SMALL_STATE(18927)] = 323069,
  [SMALL_STATE(18928)] = 323077,
  [SMALL_STATE(18929)] = 323085,
  [SMALL_STATE(18930)] = 323093,
  [SMALL_STATE(18931)] = 323101,
  [SMALL_STATE(18932)] = 323109,
  [SMALL_STATE(18933)] = 323117,
  [SMALL_STATE(18934)] = 323125,
  [SMALL_STATE(18935)] = 323133,
  [SMALL_STATE(18936)] = 323141,
  [SMALL_STATE(18937)] = 323149,
  [SMALL_STATE(18938)] = 323157,
  [SMALL_STATE(18939)] = 323165,
  [SMALL_STATE(18940)] = 323173,
  [SMALL_STATE(18941)] = 323181,
  [SMALL_STATE(18942)] = 323189,
  [SMALL_STATE(18943)] = 323197,
  [SMALL_STATE(18944)] = 323205,
  [SMALL_STATE(18945)] = 323213,
  [SMALL_STATE(18946)] = 323221,
  [SMALL_STATE(18947)] = 323229,
  [SMALL_STATE(18948)] = 323237,
  [SMALL_STATE(18949)] = 323245,
  [SMALL_STATE(18950)] = 323253,
  [SMALL_STATE(18951)] = 323261,
  [SMALL_STATE(18952)] = 323269,
  [SMALL_STATE(18953)] = 323277,
  [SMALL_STATE(18954)] = 323285,
  [SMALL_STATE(18955)] = 323293,
  [SMALL_STATE(18956)] = 323301,
  [SMALL_STATE(18957)] = 323309,
  [SMALL_STATE(18958)] = 323317,
  [SMALL_STATE(18959)] = 323325,
  [SMALL_STATE(18960)] = 323333,
  [SMALL_STATE(18961)] = 323341,
  [SMALL_STATE(18962)] = 323349,
  [SMALL_STATE(18963)] = 323357,
  [SMALL_STATE(18964)] = 323365,
  [SMALL_STATE(18965)] = 323373,
  [SMALL_STATE(18966)] = 323381,
  [SMALL_STATE(18967)] = 323389,
  [SMALL_STATE(18968)] = 323397,
  [SMALL_STATE(18969)] = 323405,
  [SMALL_STATE(18970)] = 323413,
  [SMALL_STATE(18971)] = 323421,
  [SMALL_STATE(18972)] = 323429,
  [SMALL_STATE(18973)] = 323437,
  [SMALL_STATE(18974)] = 323445,
  [SMALL_STATE(18975)] = 323453,
  [SMALL_STATE(18976)] = 323461,
  [SMALL_STATE(18977)] = 323469,
  [SMALL_STATE(18978)] = 323477,
  [SMALL_STATE(18979)] = 323485,
  [SMALL_STATE(18980)] = 323493,
  [SMALL_STATE(18981)] = 323501,
  [SMALL_STATE(18982)] = 323509,
  [SMALL_STATE(18983)] = 323517,
  [SMALL_STATE(18984)] = 323525,
  [SMALL_STATE(18985)] = 323533,
  [SMALL_STATE(18986)] = 323541,
  [SMALL_STATE(18987)] = 323549,
  [SMALL_STATE(18988)] = 323557,
  [SMALL_STATE(18989)] = 323565,
  [SMALL_STATE(18990)] = 323573,
  [SMALL_STATE(18991)] = 323581,
  [SMALL_STATE(18992)] = 323589,
  [SMALL_STATE(18993)] = 323597,
  [SMALL_STATE(18994)] = 323605,
  [SMALL_STATE(18995)] = 323613,
  [SMALL_STATE(18996)] = 323621,
  [SMALL_STATE(18997)] = 323629,
  [SMALL_STATE(18998)] = 323637,
  [SMALL_STATE(18999)] = 323645,
  [SMALL_STATE(19000)] = 323653,
  [SMALL_STATE(19001)] = 323661,
  [SMALL_STATE(19002)] = 323669,
  [SMALL_STATE(19003)] = 323677,
  [SMALL_STATE(19004)] = 323685,
  [SMALL_STATE(19005)] = 323693,
  [SMALL_STATE(19006)] = 323701,
  [SMALL_STATE(19007)] = 323709,
  [SMALL_STATE(19008)] = 323717,
  [SMALL_STATE(19009)] = 323725,
  [SMALL_STATE(19010)] = 323733,
  [SMALL_STATE(19011)] = 323741,
  [SMALL_STATE(19012)] = 323749,
  [SMALL_STATE(19013)] = 323757,
  [SMALL_STATE(19014)] = 323765,
  [SMALL_STATE(19015)] = 323773,
  [SMALL_STATE(19016)] = 323781,
  [SMALL_STATE(19017)] = 323789,
  [SMALL_STATE(19018)] = 323797,
  [SMALL_STATE(19019)] = 323805,
  [SMALL_STATE(19020)] = 323813,
  [SMALL_STATE(19021)] = 323821,
  [SMALL_STATE(19022)] = 323829,
  [SMALL_STATE(19023)] = 323837,
  [SMALL_STATE(19024)] = 323845,
  [SMALL_STATE(19025)] = 323853,
  [SMALL_STATE(19026)] = 323861,
  [SMALL_STATE(19027)] = 323869,
  [SMALL_STATE(19028)] = 323877,
  [SMALL_STATE(19029)] = 323885,
  [SMALL_STATE(19030)] = 323893,
  [SMALL_STATE(19031)] = 323901,
  [SMALL_STATE(19032)] = 323909,
  [SMALL_STATE(19033)] = 323917,
  [SMALL_STATE(19034)] = 323925,
  [SMALL_STATE(19035)] = 323933,
  [SMALL_STATE(19036)] = 323941,
  [SMALL_STATE(19037)] = 323949,
  [SMALL_STATE(19038)] = 323957,
  [SMALL_STATE(19039)] = 323965,
  [SMALL_STATE(19040)] = 323973,
  [SMALL_STATE(19041)] = 323981,
  [SMALL_STATE(19042)] = 323989,
  [SMALL_STATE(19043)] = 323997,
  [SMALL_STATE(19044)] = 324005,
  [SMALL_STATE(19045)] = 324013,
  [SMALL_STATE(19046)] = 324021,
  [SMALL_STATE(19047)] = 324029,
  [SMALL_STATE(19048)] = 324037,
  [SMALL_STATE(19049)] = 324045,
  [SMALL_STATE(19050)] = 324053,
  [SMALL_STATE(19051)] = 324061,
  [SMALL_STATE(19052)] = 324069,
  [SMALL_STATE(19053)] = 324077,
  [SMALL_STATE(19054)] = 324085,
  [SMALL_STATE(19055)] = 324093,
  [SMALL_STATE(19056)] = 324101,
  [SMALL_STATE(19057)] = 324109,
  [SMALL_STATE(19058)] = 324117,
  [SMALL_STATE(19059)] = 324125,
  [SMALL_STATE(19060)] = 324133,
  [SMALL_STATE(19061)] = 324141,
  [SMALL_STATE(19062)] = 324149,
  [SMALL_STATE(19063)] = 324157,
  [SMALL_STATE(19064)] = 324165,
  [SMALL_STATE(19065)] = 324173,
  [SMALL_STATE(19066)] = 324181,
  [SMALL_STATE(19067)] = 324189,
  [SMALL_STATE(19068)] = 324197,
  [SMALL_STATE(19069)] = 324205,
  [SMALL_STATE(19070)] = 324213,
  [SMALL_STATE(19071)] = 324221,
  [SMALL_STATE(19072)] = 324229,
  [SMALL_STATE(19073)] = 324237,
  [SMALL_STATE(19074)] = 324245,
  [SMALL_STATE(19075)] = 324253,
  [SMALL_STATE(19076)] = 324261,
  [SMALL_STATE(19077)] = 324269,
  [SMALL_STATE(19078)] = 324277,
  [SMALL_STATE(19079)] = 324285,
  [SMALL_STATE(19080)] = 324293,
  [SMALL_STATE(19081)] = 324301,
  [SMALL_STATE(19082)] = 324309,
  [SMALL_STATE(19083)] = 324317,
  [SMALL_STATE(19084)] = 324325,
  [SMALL_STATE(19085)] = 324333,
  [SMALL_STATE(19086)] = 324341,
  [SMALL_STATE(19087)] = 324349,
  [SMALL_STATE(19088)] = 324357,
  [SMALL_STATE(19089)] = 324365,
  [SMALL_STATE(19090)] = 324373,
  [SMALL_STATE(19091)] = 324381,
  [SMALL_STATE(19092)] = 324389,
  [SMALL_STATE(19093)] = 324397,
  [SMALL_STATE(19094)] = 324405,
  [SMALL_STATE(19095)] = 324413,
  [SMALL_STATE(19096)] = 324421,
  [SMALL_STATE(19097)] = 324429,
  [SMALL_STATE(19098)] = 324437,
  [SMALL_STATE(19099)] = 324445,
  [SMALL_STATE(19100)] = 324453,
  [SMALL_STATE(19101)] = 324461,
  [SMALL_STATE(19102)] = 324469,
  [SMALL_STATE(19103)] = 324477,
  [SMALL_STATE(19104)] = 324485,
  [SMALL_STATE(19105)] = 324493,
  [SMALL_STATE(19106)] = 324501,
  [SMALL_STATE(19107)] = 324509,
  [SMALL_STATE(19108)] = 324517,
  [SMALL_STATE(19109)] = 324525,
  [SMALL_STATE(19110)] = 324533,
  [SMALL_STATE(19111)] = 324541,
  [SMALL_STATE(19112)] = 324549,
  [SMALL_STATE(19113)] = 324557,
  [SMALL_STATE(19114)] = 324565,
  [SMALL_STATE(19115)] = 324573,
  [SMALL_STATE(19116)] = 324581,
  [SMALL_STATE(19117)] = 324589,
  [SMALL_STATE(19118)] = 324597,
  [SMALL_STATE(19119)] = 324605,
  [SMALL_STATE(19120)] = 324613,
  [SMALL_STATE(19121)] = 324621,
  [SMALL_STATE(19122)] = 324629,
  [SMALL_STATE(19123)] = 324637,
  [SMALL_STATE(19124)] = 324645,
  [SMALL_STATE(19125)] = 324653,
  [SMALL_STATE(19126)] = 324661,
  [SMALL_STATE(19127)] = 324669,
  [SMALL_STATE(19128)] = 324677,
  [SMALL_STATE(19129)] = 324685,
  [SMALL_STATE(19130)] = 324693,
  [SMALL_STATE(19131)] = 324701,
  [SMALL_STATE(19132)] = 324709,
  [SMALL_STATE(19133)] = 324717,
  [SMALL_STATE(19134)] = 324725,
  [SMALL_STATE(19135)] = 324733,
  [SMALL_STATE(19136)] = 324741,
  [SMALL_STATE(19137)] = 324749,
  [SMALL_STATE(19138)] = 324757,
  [SMALL_STATE(19139)] = 324765,
  [SMALL_STATE(19140)] = 324773,
  [SMALL_STATE(19141)] = 324781,
  [SMALL_STATE(19142)] = 324789,
  [SMALL_STATE(19143)] = 324797,
  [SMALL_STATE(19144)] = 324805,
  [SMALL_STATE(19145)] = 324813,
  [SMALL_STATE(19146)] = 324821,
  [SMALL_STATE(19147)] = 324829,
  [SMALL_STATE(19148)] = 324837,
  [SMALL_STATE(19149)] = 324845,
  [SMALL_STATE(19150)] = 324853,
  [SMALL_STATE(19151)] = 324861,
  [SMALL_STATE(19152)] = 324869,
  [SMALL_STATE(19153)] = 324877,
  [SMALL_STATE(19154)] = 324885,
  [SMALL_STATE(19155)] = 324893,
  [SMALL_STATE(19156)] = 324901,
  [SMALL_STATE(19157)] = 324909,
  [SMALL_STATE(19158)] = 324917,
  [SMALL_STATE(19159)] = 324925,
  [SMALL_STATE(19160)] = 324933,
  [SMALL_STATE(19161)] = 324941,
  [SMALL_STATE(19162)] = 324949,
  [SMALL_STATE(19163)] = 324957,
  [SMALL_STATE(19164)] = 324965,
  [SMALL_STATE(19165)] = 324973,
  [SMALL_STATE(19166)] = 324981,
  [SMALL_STATE(19167)] = 324989,
  [SMALL_STATE(19168)] = 324997,
  [SMALL_STATE(19169)] = 325005,
  [SMALL_STATE(19170)] = 325013,
  [SMALL_STATE(19171)] = 325021,
  [SMALL_STATE(19172)] = 325029,
  [SMALL_STATE(19173)] = 325037,
  [SMALL_STATE(19174)] = 325045,
  [SMALL_STATE(19175)] = 325053,
  [SMALL_STATE(19176)] = 325061,
  [SMALL_STATE(19177)] = 325069,
  [SMALL_STATE(19178)] = 325077,
  [SMALL_STATE(19179)] = 325085,
  [SMALL_STATE(19180)] = 325093,
  [SMALL_STATE(19181)] = 325101,
  [SMALL_STATE(19182)] = 325109,
  [SMALL_STATE(19183)] = 325117,
  [SMALL_STATE(19184)] = 325125,
  [SMALL_STATE(19185)] = 325133,
  [SMALL_STATE(19186)] = 325141,
  [SMALL_STATE(19187)] = 325149,
  [SMALL_STATE(19188)] = 325157,
  [SMALL_STATE(19189)] = 325165,
  [SMALL_STATE(19190)] = 325173,
  [SMALL_STATE(19191)] = 325181,
  [SMALL_STATE(19192)] = 325189,
  [SMALL_STATE(19193)] = 325197,
  [SMALL_STATE(19194)] = 325205,
  [SMALL_STATE(19195)] = 325213,
  [SMALL_STATE(19196)] = 325221,
  [SMALL_STATE(19197)] = 325229,
  [SMALL_STATE(19198)] = 325237,
  [SMALL_STATE(19199)] = 325245,
  [SMALL_STATE(19200)] = 325253,
  [SMALL_STATE(19201)] = 325261,
  [SMALL_STATE(19202)] = 325269,
  [SMALL_STATE(19203)] = 325277,
  [SMALL_STATE(19204)] = 325285,
  [SMALL_STATE(19205)] = 325293,
  [SMALL_STATE(19206)] = 325301,
  [SMALL_STATE(19207)] = 325309,
  [SMALL_STATE(19208)] = 325317,
  [SMALL_STATE(19209)] = 325325,
  [SMALL_STATE(19210)] = 325333,
  [SMALL_STATE(19211)] = 325341,
  [SMALL_STATE(19212)] = 325349,
  [SMALL_STATE(19213)] = 325357,
  [SMALL_STATE(19214)] = 325365,
  [SMALL_STATE(19215)] = 325373,
  [SMALL_STATE(19216)] = 325381,
  [SMALL_STATE(19217)] = 325389,
  [SMALL_STATE(19218)] = 325397,
  [SMALL_STATE(19219)] = 325405,
  [SMALL_STATE(19220)] = 325413,
  [SMALL_STATE(19221)] = 325421,
  [SMALL_STATE(19222)] = 325429,
  [SMALL_STATE(19223)] = 325437,
  [SMALL_STATE(19224)] = 325445,
  [SMALL_STATE(19225)] = 325453,
  [SMALL_STATE(19226)] = 325461,
  [SMALL_STATE(19227)] = 325469,
  [SMALL_STATE(19228)] = 325477,
  [SMALL_STATE(19229)] = 325485,
  [SMALL_STATE(19230)] = 325493,
  [SMALL_STATE(19231)] = 325501,
  [SMALL_STATE(19232)] = 325509,
  [SMALL_STATE(19233)] = 325517,
  [SMALL_STATE(19234)] = 325525,
  [SMALL_STATE(19235)] = 325533,
  [SMALL_STATE(19236)] = 325541,
  [SMALL_STATE(19237)] = 325549,
  [SMALL_STATE(19238)] = 325557,
  [SMALL_STATE(19239)] = 325565,
  [SMALL_STATE(19240)] = 325573,
  [SMALL_STATE(19241)] = 325581,
  [SMALL_STATE(19242)] = 325589,
  [SMALL_STATE(19243)] = 325597,
  [SMALL_STATE(19244)] = 325605,
  [SMALL_STATE(19245)] = 325613,
  [SMALL_STATE(19246)] = 325621,
  [SMALL_STATE(19247)] = 325629,
  [SMALL_STATE(19248)] = 325637,
  [SMALL_STATE(19249)] = 325645,
  [SMALL_STATE(19250)] = 325653,
  [SMALL_STATE(19251)] = 325661,
  [SMALL_STATE(19252)] = 325669,
  [SMALL_STATE(19253)] = 325677,
  [SMALL_STATE(19254)] = 325685,
  [SMALL_STATE(19255)] = 325693,
  [SMALL_STATE(19256)] = 325701,
  [SMALL_STATE(19257)] = 325709,
  [SMALL_STATE(19258)] = 325717,
  [SMALL_STATE(19259)] = 325725,
  [SMALL_STATE(19260)] = 325733,
  [SMALL_STATE(19261)] = 325741,
  [SMALL_STATE(19262)] = 325749,
  [SMALL_STATE(19263)] = 325757,
  [SMALL_STATE(19264)] = 325765,
  [SMALL_STATE(19265)] = 325773,
  [SMALL_STATE(19266)] = 325781,
  [SMALL_STATE(19267)] = 325789,
  [SMALL_STATE(19268)] = 325797,
  [SMALL_STATE(19269)] = 325805,
  [SMALL_STATE(19270)] = 325813,
  [SMALL_STATE(19271)] = 325821,
  [SMALL_STATE(19272)] = 325829,
  [SMALL_STATE(19273)] = 325837,
  [SMALL_STATE(19274)] = 325845,
  [SMALL_STATE(19275)] = 325853,
  [SMALL_STATE(19276)] = 325861,
  [SMALL_STATE(19277)] = 325869,
  [SMALL_STATE(19278)] = 325877,
  [SMALL_STATE(19279)] = 325885,
  [SMALL_STATE(19280)] = 325893,
  [SMALL_STATE(19281)] = 325901,
  [SMALL_STATE(19282)] = 325909,
  [SMALL_STATE(19283)] = 325917,
  [SMALL_STATE(19284)] = 325925,
  [SMALL_STATE(19285)] = 325933,
  [SMALL_STATE(19286)] = 325941,
  [SMALL_STATE(19287)] = 325949,
  [SMALL_STATE(19288)] = 325957,
  [SMALL_STATE(19289)] = 325965,
  [SMALL_STATE(19290)] = 325973,
  [SMALL_STATE(19291)] = 325981,
  [SMALL_STATE(19292)] = 325989,
  [SMALL_STATE(19293)] = 325997,
  [SMALL_STATE(19294)] = 326005,
  [SMALL_STATE(19295)] = 326013,
  [SMALL_STATE(19296)] = 326021,
  [SMALL_STATE(19297)] = 326029,
  [SMALL_STATE(19298)] = 326037,
  [SMALL_STATE(19299)] = 326045,
  [SMALL_STATE(19300)] = 326053,
  [SMALL_STATE(19301)] = 326061,
  [SMALL_STATE(19302)] = 326069,
  [SMALL_STATE(19303)] = 326077,
  [SMALL_STATE(19304)] = 326085,
  [SMALL_STATE(19305)] = 326093,
  [SMALL_STATE(19306)] = 326101,
  [SMALL_STATE(19307)] = 326109,
  [SMALL_STATE(19308)] = 326117,
  [SMALL_STATE(19309)] = 326125,
  [SMALL_STATE(19310)] = 326133,
  [SMALL_STATE(19311)] = 326141,
  [SMALL_STATE(19312)] = 326149,
  [SMALL_STATE(19313)] = 326157,
  [SMALL_STATE(19314)] = 326165,
  [SMALL_STATE(19315)] = 326173,
  [SMALL_STATE(19316)] = 326181,
  [SMALL_STATE(19317)] = 326189,
  [SMALL_STATE(19318)] = 326197,
  [SMALL_STATE(19319)] = 326205,
  [SMALL_STATE(19320)] = 326213,
  [SMALL_STATE(19321)] = 326221,
  [SMALL_STATE(19322)] = 326229,
  [SMALL_STATE(19323)] = 326237,
  [SMALL_STATE(19324)] = 326245,
  [SMALL_STATE(19325)] = 326253,
  [SMALL_STATE(19326)] = 326261,
  [SMALL_STATE(19327)] = 326269,
  [SMALL_STATE(19328)] = 326277,
  [SMALL_STATE(19329)] = 326285,
  [SMALL_STATE(19330)] = 326293,
  [SMALL_STATE(19331)] = 326301,
  [SMALL_STATE(19332)] = 326309,
  [SMALL_STATE(19333)] = 326317,
  [SMALL_STATE(19334)] = 326325,
  [SMALL_STATE(19335)] = 326333,
  [SMALL_STATE(19336)] = 326341,
  [SMALL_STATE(19337)] = 326349,
  [SMALL_STATE(19338)] = 326357,
  [SMALL_STATE(19339)] = 326365,
  [SMALL_STATE(19340)] = 326373,
  [SMALL_STATE(19341)] = 326381,
  [SMALL_STATE(19342)] = 326389,
  [SMALL_STATE(19343)] = 326397,
  [SMALL_STATE(19344)] = 326405,
  [SMALL_STATE(19345)] = 326413,
  [SMALL_STATE(19346)] = 326421,
  [SMALL_STATE(19347)] = 326429,
  [SMALL_STATE(19348)] = 326437,
  [SMALL_STATE(19349)] = 326445,
  [SMALL_STATE(19350)] = 326453,
  [SMALL_STATE(19351)] = 326461,
  [SMALL_STATE(19352)] = 326469,
  [SMALL_STATE(19353)] = 326477,
  [SMALL_STATE(19354)] = 326485,
  [SMALL_STATE(19355)] = 326493,
  [SMALL_STATE(19356)] = 326501,
  [SMALL_STATE(19357)] = 326509,
  [SMALL_STATE(19358)] = 326517,
  [SMALL_STATE(19359)] = 326525,
  [SMALL_STATE(19360)] = 326533,
  [SMALL_STATE(19361)] = 326541,
  [SMALL_STATE(19362)] = 326549,
  [SMALL_STATE(19363)] = 326557,
  [SMALL_STATE(19364)] = 326565,
  [SMALL_STATE(19365)] = 326573,
  [SMALL_STATE(19366)] = 326581,
  [SMALL_STATE(19367)] = 326589,
  [SMALL_STATE(19368)] = 326597,
  [SMALL_STATE(19369)] = 326605,
  [SMALL_STATE(19370)] = 326613,
  [SMALL_STATE(19371)] = 326621,
  [SMALL_STATE(19372)] = 326629,
  [SMALL_STATE(19373)] = 326637,
  [SMALL_STATE(19374)] = 326645,
  [SMALL_STATE(19375)] = 326653,
  [SMALL_STATE(19376)] = 326661,
  [SMALL_STATE(19377)] = 326669,
  [SMALL_STATE(19378)] = 326677,
  [SMALL_STATE(19379)] = 326685,
  [SMALL_STATE(19380)] = 326693,
  [SMALL_STATE(19381)] = 326701,
  [SMALL_STATE(19382)] = 326709,
  [SMALL_STATE(19383)] = 326717,
  [SMALL_STATE(19384)] = 326725,
  [SMALL_STATE(19385)] = 326733,
  [SMALL_STATE(19386)] = 326741,
  [SMALL_STATE(19387)] = 326749,
  [SMALL_STATE(19388)] = 326757,
  [SMALL_STATE(19389)] = 326765,
  [SMALL_STATE(19390)] = 326773,
  [SMALL_STATE(19391)] = 326781,
  [SMALL_STATE(19392)] = 326789,
  [SMALL_STATE(19393)] = 326797,
  [SMALL_STATE(19394)] = 326805,
  [SMALL_STATE(19395)] = 326813,
  [SMALL_STATE(19396)] = 326821,
  [SMALL_STATE(19397)] = 326829,
  [SMALL_STATE(19398)] = 326837,
  [SMALL_STATE(19399)] = 326845,
  [SMALL_STATE(19400)] = 326853,
  [SMALL_STATE(19401)] = 326861,
  [SMALL_STATE(19402)] = 326869,
  [SMALL_STATE(19403)] = 326877,
  [SMALL_STATE(19404)] = 326885,
  [SMALL_STATE(19405)] = 326893,
  [SMALL_STATE(19406)] = 326901,
  [SMALL_STATE(19407)] = 326909,
  [SMALL_STATE(19408)] = 326917,
  [SMALL_STATE(19409)] = 326925,
  [SMALL_STATE(19410)] = 326933,
  [SMALL_STATE(19411)] = 326941,
  [SMALL_STATE(19412)] = 326949,
  [SMALL_STATE(19413)] = 326957,
  [SMALL_STATE(19414)] = 326965,
  [SMALL_STATE(19415)] = 326973,
  [SMALL_STATE(19416)] = 326981,
  [SMALL_STATE(19417)] = 326989,
  [SMALL_STATE(19418)] = 326997,
  [SMALL_STATE(19419)] = 327005,
  [SMALL_STATE(19420)] = 327013,
  [SMALL_STATE(19421)] = 327021,
  [SMALL_STATE(19422)] = 327029,
  [SMALL_STATE(19423)] = 327037,
  [SMALL_STATE(19424)] = 327045,
  [SMALL_STATE(19425)] = 327053,
  [SMALL_STATE(19426)] = 327061,
  [SMALL_STATE(19427)] = 327069,
  [SMALL_STATE(19428)] = 327077,
  [SMALL_STATE(19429)] = 327085,
  [SMALL_STATE(19430)] = 327093,
  [SMALL_STATE(19431)] = 327101,
  [SMALL_STATE(19432)] = 327109,
  [SMALL_STATE(19433)] = 327117,
  [SMALL_STATE(19434)] = 327125,
  [SMALL_STATE(19435)] = 327133,
  [SMALL_STATE(19436)] = 327141,
  [SMALL_STATE(19437)] = 327149,
  [SMALL_STATE(19438)] = 327157,
  [SMALL_STATE(19439)] = 327165,
  [SMALL_STATE(19440)] = 327173,
  [SMALL_STATE(19441)] = 327181,
  [SMALL_STATE(19442)] = 327189,
  [SMALL_STATE(19443)] = 327197,
  [SMALL_STATE(19444)] = 327205,
  [SMALL_STATE(19445)] = 327213,
  [SMALL_STATE(19446)] = 327221,
  [SMALL_STATE(19447)] = 327229,
  [SMALL_STATE(19448)] = 327237,
  [SMALL_STATE(19449)] = 327245,
  [SMALL_STATE(19450)] = 327253,
  [SMALL_STATE(19451)] = 327261,
  [SMALL_STATE(19452)] = 327269,
  [SMALL_STATE(19453)] = 327277,
  [SMALL_STATE(19454)] = 327285,
  [SMALL_STATE(19455)] = 327293,
  [SMALL_STATE(19456)] = 327301,
  [SMALL_STATE(19457)] = 327309,
  [SMALL_STATE(19458)] = 327317,
  [SMALL_STATE(19459)] = 327325,
  [SMALL_STATE(19460)] = 327333,
  [SMALL_STATE(19461)] = 327341,
  [SMALL_STATE(19462)] = 327349,
  [SMALL_STATE(19463)] = 327357,
  [SMALL_STATE(19464)] = 327365,
  [SMALL_STATE(19465)] = 327373,
  [SMALL_STATE(19466)] = 327381,
  [SMALL_STATE(19467)] = 327389,
  [SMALL_STATE(19468)] = 327397,
  [SMALL_STATE(19469)] = 327405,
  [SMALL_STATE(19470)] = 327413,
  [SMALL_STATE(19471)] = 327421,
  [SMALL_STATE(19472)] = 327429,
  [SMALL_STATE(19473)] = 327437,
  [SMALL_STATE(19474)] = 327445,
  [SMALL_STATE(19475)] = 327453,
  [SMALL_STATE(19476)] = 327461,
  [SMALL_STATE(19477)] = 327469,
  [SMALL_STATE(19478)] = 327477,
  [SMALL_STATE(19479)] = 327485,
  [SMALL_STATE(19480)] = 327493,
  [SMALL_STATE(19481)] = 327501,
  [SMALL_STATE(19482)] = 327509,
  [SMALL_STATE(19483)] = 327517,
  [SMALL_STATE(19484)] = 327525,
  [SMALL_STATE(19485)] = 327533,
  [SMALL_STATE(19486)] = 327541,
  [SMALL_STATE(19487)] = 327549,
  [SMALL_STATE(19488)] = 327557,
  [SMALL_STATE(19489)] = 327565,
  [SMALL_STATE(19490)] = 327573,
  [SMALL_STATE(19491)] = 327581,
  [SMALL_STATE(19492)] = 327589,
  [SMALL_STATE(19493)] = 327597,
  [SMALL_STATE(19494)] = 327605,
  [SMALL_STATE(19495)] = 327613,
  [SMALL_STATE(19496)] = 327621,
  [SMALL_STATE(19497)] = 327629,
  [SMALL_STATE(19498)] = 327637,
  [SMALL_STATE(19499)] = 327645,
  [SMALL_STATE(19500)] = 327653,
  [SMALL_STATE(19501)] = 327661,
  [SMALL_STATE(19502)] = 327669,
  [SMALL_STATE(19503)] = 327677,
  [SMALL_STATE(19504)] = 327685,
  [SMALL_STATE(19505)] = 327693,
  [SMALL_STATE(19506)] = 327701,
  [SMALL_STATE(19507)] = 327709,
  [SMALL_STATE(19508)] = 327717,
  [SMALL_STATE(19509)] = 327725,
  [SMALL_STATE(19510)] = 327733,
  [SMALL_STATE(19511)] = 327741,
  [SMALL_STATE(19512)] = 327749,
  [SMALL_STATE(19513)] = 327757,
  [SMALL_STATE(19514)] = 327765,
  [SMALL_STATE(19515)] = 327773,
  [SMALL_STATE(19516)] = 327781,
  [SMALL_STATE(19517)] = 327789,
  [SMALL_STATE(19518)] = 327797,
  [SMALL_STATE(19519)] = 327805,
  [SMALL_STATE(19520)] = 327813,
  [SMALL_STATE(19521)] = 327821,
  [SMALL_STATE(19522)] = 327829,
  [SMALL_STATE(19523)] = 327837,
  [SMALL_STATE(19524)] = 327845,
  [SMALL_STATE(19525)] = 327853,
  [SMALL_STATE(19526)] = 327861,
  [SMALL_STATE(19527)] = 327869,
  [SMALL_STATE(19528)] = 327877,
  [SMALL_STATE(19529)] = 327885,
  [SMALL_STATE(19530)] = 327893,
  [SMALL_STATE(19531)] = 327901,
  [SMALL_STATE(19532)] = 327909,
  [SMALL_STATE(19533)] = 327917,
  [SMALL_STATE(19534)] = 327925,
  [SMALL_STATE(19535)] = 327933,
  [SMALL_STATE(19536)] = 327941,
  [SMALL_STATE(19537)] = 327949,
  [SMALL_STATE(19538)] = 327957,
  [SMALL_STATE(19539)] = 327965,
  [SMALL_STATE(19540)] = 327973,
  [SMALL_STATE(19541)] = 327981,
  [SMALL_STATE(19542)] = 327989,
  [SMALL_STATE(19543)] = 327997,
  [SMALL_STATE(19544)] = 328005,
  [SMALL_STATE(19545)] = 328013,
  [SMALL_STATE(19546)] = 328021,
  [SMALL_STATE(19547)] = 328029,
  [SMALL_STATE(19548)] = 328037,
  [SMALL_STATE(19549)] = 328045,
  [SMALL_STATE(19550)] = 328053,
  [SMALL_STATE(19551)] = 328061,
  [SMALL_STATE(19552)] = 328069,
  [SMALL_STATE(19553)] = 328077,
  [SMALL_STATE(19554)] = 328085,
  [SMALL_STATE(19555)] = 328093,
  [SMALL_STATE(19556)] = 328101,
  [SMALL_STATE(19557)] = 328109,
  [SMALL_STATE(19558)] = 328117,
  [SMALL_STATE(19559)] = 328125,
  [SMALL_STATE(19560)] = 328133,
  [SMALL_STATE(19561)] = 328141,
  [SMALL_STATE(19562)] = 328149,
  [SMALL_STATE(19563)] = 328157,
  [SMALL_STATE(19564)] = 328165,
  [SMALL_STATE(19565)] = 328173,
  [SMALL_STATE(19566)] = 328181,
  [SMALL_STATE(19567)] = 328189,
  [SMALL_STATE(19568)] = 328197,
  [SMALL_STATE(19569)] = 328205,
  [SMALL_STATE(19570)] = 328213,
  [SMALL_STATE(19571)] = 328221,
  [SMALL_STATE(19572)] = 328229,
  [SMALL_STATE(19573)] = 328237,
  [SMALL_STATE(19574)] = 328245,
  [SMALL_STATE(19575)] = 328253,
  [SMALL_STATE(19576)] = 328261,
  [SMALL_STATE(19577)] = 328269,
  [SMALL_STATE(19578)] = 328277,
  [SMALL_STATE(19579)] = 328285,
  [SMALL_STATE(19580)] = 328293,
  [SMALL_STATE(19581)] = 328301,
  [SMALL_STATE(19582)] = 328309,
  [SMALL_STATE(19583)] = 328317,
  [SMALL_STATE(19584)] = 328325,
  [SMALL_STATE(19585)] = 328333,
  [SMALL_STATE(19586)] = 328341,
  [SMALL_STATE(19587)] = 328349,
  [SMALL_STATE(19588)] = 328357,
  [SMALL_STATE(19589)] = 328365,
  [SMALL_STATE(19590)] = 328373,
  [SMALL_STATE(19591)] = 328381,
  [SMALL_STATE(19592)] = 328389,
  [SMALL_STATE(19593)] = 328397,
  [SMALL_STATE(19594)] = 328405,
  [SMALL_STATE(19595)] = 328413,
  [SMALL_STATE(19596)] = 328421,
  [SMALL_STATE(19597)] = 328429,
  [SMALL_STATE(19598)] = 328437,
  [SMALL_STATE(19599)] = 328445,
  [SMALL_STATE(19600)] = 328453,
  [SMALL_STATE(19601)] = 328461,
  [SMALL_STATE(19602)] = 328469,
  [SMALL_STATE(19603)] = 328477,
  [SMALL_STATE(19604)] = 328485,
  [SMALL_STATE(19605)] = 328493,
  [SMALL_STATE(19606)] = 328501,
  [SMALL_STATE(19607)] = 328509,
  [SMALL_STATE(19608)] = 328517,
  [SMALL_STATE(19609)] = 328525,
  [SMALL_STATE(19610)] = 328533,
  [SMALL_STATE(19611)] = 328541,
  [SMALL_STATE(19612)] = 328549,
  [SMALL_STATE(19613)] = 328557,
  [SMALL_STATE(19614)] = 328565,
  [SMALL_STATE(19615)] = 328573,
  [SMALL_STATE(19616)] = 328581,
  [SMALL_STATE(19617)] = 328589,
  [SMALL_STATE(19618)] = 328597,
  [SMALL_STATE(19619)] = 328605,
  [SMALL_STATE(19620)] = 328613,
  [SMALL_STATE(19621)] = 328621,
  [SMALL_STATE(19622)] = 328629,
  [SMALL_STATE(19623)] = 328637,
  [SMALL_STATE(19624)] = 328645,
  [SMALL_STATE(19625)] = 328653,
  [SMALL_STATE(19626)] = 328661,
  [SMALL_STATE(19627)] = 328669,
  [SMALL_STATE(19628)] = 328677,
  [SMALL_STATE(19629)] = 328685,
  [SMALL_STATE(19630)] = 328693,
  [SMALL_STATE(19631)] = 328701,
  [SMALL_STATE(19632)] = 328709,
  [SMALL_STATE(19633)] = 328717,
  [SMALL_STATE(19634)] = 328725,
  [SMALL_STATE(19635)] = 328733,
  [SMALL_STATE(19636)] = 328741,
  [SMALL_STATE(19637)] = 328749,
  [SMALL_STATE(19638)] = 328757,
  [SMALL_STATE(19639)] = 328765,
  [SMALL_STATE(19640)] = 328773,
  [SMALL_STATE(19641)] = 328781,
  [SMALL_STATE(19642)] = 328789,
  [SMALL_STATE(19643)] = 328797,
  [SMALL_STATE(19644)] = 328805,
  [SMALL_STATE(19645)] = 328813,
  [SMALL_STATE(19646)] = 328821,
  [SMALL_STATE(19647)] = 328829,
  [SMALL_STATE(19648)] = 328837,
  [SMALL_STATE(19649)] = 328845,
  [SMALL_STATE(19650)] = 328853,
  [SMALL_STATE(19651)] = 328861,
  [SMALL_STATE(19652)] = 328869,
  [SMALL_STATE(19653)] = 328877,
  [SMALL_STATE(19654)] = 328885,
  [SMALL_STATE(19655)] = 328893,
  [SMALL_STATE(19656)] = 328901,
  [SMALL_STATE(19657)] = 328909,
  [SMALL_STATE(19658)] = 328917,
  [SMALL_STATE(19659)] = 328925,
  [SMALL_STATE(19660)] = 328933,
  [SMALL_STATE(19661)] = 328941,
  [SMALL_STATE(19662)] = 328949,
  [SMALL_STATE(19663)] = 328957,
  [SMALL_STATE(19664)] = 328965,
  [SMALL_STATE(19665)] = 328973,
  [SMALL_STATE(19666)] = 328981,
  [SMALL_STATE(19667)] = 328989,
  [SMALL_STATE(19668)] = 328997,
  [SMALL_STATE(19669)] = 329005,
  [SMALL_STATE(19670)] = 329013,
  [SMALL_STATE(19671)] = 329021,
  [SMALL_STATE(19672)] = 329029,
  [SMALL_STATE(19673)] = 329037,
  [SMALL_STATE(19674)] = 329045,
  [SMALL_STATE(19675)] = 329053,
  [SMALL_STATE(19676)] = 329061,
  [SMALL_STATE(19677)] = 329069,
  [SMALL_STATE(19678)] = 329077,
  [SMALL_STATE(19679)] = 329085,
  [SMALL_STATE(19680)] = 329093,
  [SMALL_STATE(19681)] = 329101,
  [SMALL_STATE(19682)] = 329109,
  [SMALL_STATE(19683)] = 329117,
  [SMALL_STATE(19684)] = 329125,
  [SMALL_STATE(19685)] = 329133,
  [SMALL_STATE(19686)] = 329141,
  [SMALL_STATE(19687)] = 329149,
  [SMALL_STATE(19688)] = 329157,
  [SMALL_STATE(19689)] = 329165,
  [SMALL_STATE(19690)] = 329173,
  [SMALL_STATE(19691)] = 329181,
  [SMALL_STATE(19692)] = 329189,
  [SMALL_STATE(19693)] = 329197,
  [SMALL_STATE(19694)] = 329205,
  [SMALL_STATE(19695)] = 329213,
  [SMALL_STATE(19696)] = 329221,
  [SMALL_STATE(19697)] = 329229,
  [SMALL_STATE(19698)] = 329237,
  [SMALL_STATE(19699)] = 329245,
  [SMALL_STATE(19700)] = 329253,
  [SMALL_STATE(19701)] = 329261,
  [SMALL_STATE(19702)] = 329269,
  [SMALL_STATE(19703)] = 329277,
  [SMALL_STATE(19704)] = 329285,
  [SMALL_STATE(19705)] = 329293,
  [SMALL_STATE(19706)] = 329301,
  [SMALL_STATE(19707)] = 329309,
  [SMALL_STATE(19708)] = 329317,
  [SMALL_STATE(19709)] = 329325,
  [SMALL_STATE(19710)] = 329333,
  [SMALL_STATE(19711)] = 329341,
  [SMALL_STATE(19712)] = 329349,
  [SMALL_STATE(19713)] = 329357,
  [SMALL_STATE(19714)] = 329365,
  [SMALL_STATE(19715)] = 329373,
  [SMALL_STATE(19716)] = 329381,
  [SMALL_STATE(19717)] = 329389,
  [SMALL_STATE(19718)] = 329397,
  [SMALL_STATE(19719)] = 329405,
  [SMALL_STATE(19720)] = 329413,
  [SMALL_STATE(19721)] = 329421,
  [SMALL_STATE(19722)] = 329429,
  [SMALL_STATE(19723)] = 329437,
  [SMALL_STATE(19724)] = 329445,
  [SMALL_STATE(19725)] = 329453,
  [SMALL_STATE(19726)] = 329461,
  [SMALL_STATE(19727)] = 329469,
  [SMALL_STATE(19728)] = 329477,
  [SMALL_STATE(19729)] = 329485,
  [SMALL_STATE(19730)] = 329493,
  [SMALL_STATE(19731)] = 329501,
  [SMALL_STATE(19732)] = 329509,
  [SMALL_STATE(19733)] = 329517,
  [SMALL_STATE(19734)] = 329525,
  [SMALL_STATE(19735)] = 329533,
  [SMALL_STATE(19736)] = 329541,
  [SMALL_STATE(19737)] = 329549,
  [SMALL_STATE(19738)] = 329557,
  [SMALL_STATE(19739)] = 329565,
  [SMALL_STATE(19740)] = 329573,
  [SMALL_STATE(19741)] = 329581,
  [SMALL_STATE(19742)] = 329589,
  [SMALL_STATE(19743)] = 329597,
  [SMALL_STATE(19744)] = 329605,
  [SMALL_STATE(19745)] = 329613,
  [SMALL_STATE(19746)] = 329621,
  [SMALL_STATE(19747)] = 329629,
  [SMALL_STATE(19748)] = 329637,
  [SMALL_STATE(19749)] = 329645,
  [SMALL_STATE(19750)] = 329653,
  [SMALL_STATE(19751)] = 329661,
  [SMALL_STATE(19752)] = 329669,
  [SMALL_STATE(19753)] = 329677,
  [SMALL_STATE(19754)] = 329685,
  [SMALL_STATE(19755)] = 329693,
  [SMALL_STATE(19756)] = 329701,
  [SMALL_STATE(19757)] = 329709,
  [SMALL_STATE(19758)] = 329717,
  [SMALL_STATE(19759)] = 329725,
  [SMALL_STATE(19760)] = 329733,
  [SMALL_STATE(19761)] = 329741,
  [SMALL_STATE(19762)] = 329749,
  [SMALL_STATE(19763)] = 329757,
  [SMALL_STATE(19764)] = 329765,
  [SMALL_STATE(19765)] = 329773,
  [SMALL_STATE(19766)] = 329781,
  [SMALL_STATE(19767)] = 329789,
  [SMALL_STATE(19768)] = 329797,
  [SMALL_STATE(19769)] = 329805,
  [SMALL_STATE(19770)] = 329813,
  [SMALL_STATE(19771)] = 329821,
  [SMALL_STATE(19772)] = 329829,
  [SMALL_STATE(19773)] = 329837,
  [SMALL_STATE(19774)] = 329845,
  [SMALL_STATE(19775)] = 329853,
  [SMALL_STATE(19776)] = 329861,
  [SMALL_STATE(19777)] = 329869,
  [SMALL_STATE(19778)] = 329877,
  [SMALL_STATE(19779)] = 329885,
  [SMALL_STATE(19780)] = 329893,
  [SMALL_STATE(19781)] = 329901,
  [SMALL_STATE(19782)] = 329909,
  [SMALL_STATE(19783)] = 329917,
  [SMALL_STATE(19784)] = 329925,
  [SMALL_STATE(19785)] = 329933,
  [SMALL_STATE(19786)] = 329941,
  [SMALL_STATE(19787)] = 329949,
  [SMALL_STATE(19788)] = 329957,
  [SMALL_STATE(19789)] = 329965,
  [SMALL_STATE(19790)] = 329973,
  [SMALL_STATE(19791)] = 329981,
  [SMALL_STATE(19792)] = 329989,
  [SMALL_STATE(19793)] = 329997,
  [SMALL_STATE(19794)] = 330005,
  [SMALL_STATE(19795)] = 330013,
  [SMALL_STATE(19796)] = 330021,
  [SMALL_STATE(19797)] = 330029,
  [SMALL_STATE(19798)] = 330037,
  [SMALL_STATE(19799)] = 330045,
  [SMALL_STATE(19800)] = 330053,
  [SMALL_STATE(19801)] = 330061,
  [SMALL_STATE(19802)] = 330069,
  [SMALL_STATE(19803)] = 330077,
  [SMALL_STATE(19804)] = 330085,
  [SMALL_STATE(19805)] = 330093,
  [SMALL_STATE(19806)] = 330101,
  [SMALL_STATE(19807)] = 330109,
  [SMALL_STATE(19808)] = 330117,
  [SMALL_STATE(19809)] = 330125,
  [SMALL_STATE(19810)] = 330133,
  [SMALL_STATE(19811)] = 330141,
  [SMALL_STATE(19812)] = 330149,
  [SMALL_STATE(19813)] = 330157,
  [SMALL_STATE(19814)] = 330165,
  [SMALL_STATE(19815)] = 330173,
  [SMALL_STATE(19816)] = 330181,
  [SMALL_STATE(19817)] = 330189,
  [SMALL_STATE(19818)] = 330197,
  [SMALL_STATE(19819)] = 330205,
  [SMALL_STATE(19820)] = 330213,
  [SMALL_STATE(19821)] = 330221,
  [SMALL_STATE(19822)] = 330229,
  [SMALL_STATE(19823)] = 330237,
  [SMALL_STATE(19824)] = 330245,
  [SMALL_STATE(19825)] = 330253,
  [SMALL_STATE(19826)] = 330261,
  [SMALL_STATE(19827)] = 330269,
  [SMALL_STATE(19828)] = 330277,
  [SMALL_STATE(19829)] = 330285,
  [SMALL_STATE(19830)] = 330293,
  [SMALL_STATE(19831)] = 330301,
  [SMALL_STATE(19832)] = 330309,
  [SMALL_STATE(19833)] = 330317,
  [SMALL_STATE(19834)] = 330325,
  [SMALL_STATE(19835)] = 330333,
  [SMALL_STATE(19836)] = 330341,
  [SMALL_STATE(19837)] = 330349,
  [SMALL_STATE(19838)] = 330357,
  [SMALL_STATE(19839)] = 330365,
  [SMALL_STATE(19840)] = 330373,
  [SMALL_STATE(19841)] = 330381,
  [SMALL_STATE(19842)] = 330389,
  [SMALL_STATE(19843)] = 330397,
  [SMALL_STATE(19844)] = 330405,
  [SMALL_STATE(19845)] = 330413,
  [SMALL_STATE(19846)] = 330421,
  [SMALL_STATE(19847)] = 330429,
  [SMALL_STATE(19848)] = 330437,
  [SMALL_STATE(19849)] = 330445,
  [SMALL_STATE(19850)] = 330453,
  [SMALL_STATE(19851)] = 330461,
  [SMALL_STATE(19852)] = 330469,
  [SMALL_STATE(19853)] = 330477,
  [SMALL_STATE(19854)] = 330485,
  [SMALL_STATE(19855)] = 330493,
  [SMALL_STATE(19856)] = 330501,
  [SMALL_STATE(19857)] = 330509,
  [SMALL_STATE(19858)] = 330517,
  [SMALL_STATE(19859)] = 330525,
  [SMALL_STATE(19860)] = 330533,
  [SMALL_STATE(19861)] = 330541,
  [SMALL_STATE(19862)] = 330549,
  [SMALL_STATE(19863)] = 330557,
  [SMALL_STATE(19864)] = 330565,
  [SMALL_STATE(19865)] = 330573,
  [SMALL_STATE(19866)] = 330581,
  [SMALL_STATE(19867)] = 330589,
  [SMALL_STATE(19868)] = 330597,
  [SMALL_STATE(19869)] = 330605,
  [SMALL_STATE(19870)] = 330613,
  [SMALL_STATE(19871)] = 330621,
  [SMALL_STATE(19872)] = 330629,
  [SMALL_STATE(19873)] = 330637,
  [SMALL_STATE(19874)] = 330645,
  [SMALL_STATE(19875)] = 330653,
  [SMALL_STATE(19876)] = 330661,
  [SMALL_STATE(19877)] = 330669,
  [SMALL_STATE(19878)] = 330677,
  [SMALL_STATE(19879)] = 330685,
  [SMALL_STATE(19880)] = 330693,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9819),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9677),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15672),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18170),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18511),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19290),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16046),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9670),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9689),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3716),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10856),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14111),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11763),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12311),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9779),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14221),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9902),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10174),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10174),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10040),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10133),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11340),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10873),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10873),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14998),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14999),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10190),
  [91] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9661),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16380),
  [99] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, 0, 0),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19716),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19847),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19717),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16381),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9683),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9684),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4165),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4168),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12475),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14106),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11683),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12391),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9774),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14183),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10832),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9908),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9847),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9919),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10874),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14919),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14959),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16042),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16051),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9671),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14053),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11768),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12805),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9781),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14190),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10121),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10100),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10150),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11199),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16222),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16248),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4273),
  [229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macrocall_expression, 1, 0, 0),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4263),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16412),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19745),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19859),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19746),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16413),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9687),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9688),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4181),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3171),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4184),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7366),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14039),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11797),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macrocall_expression, 1, 0, 0),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12512),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9795),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5071),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7063),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7077),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7123),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4845),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7039),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18036),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15402),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18037),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14664),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14674),
  [311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macrocall_expression, 3, 0, 0),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macrocall_expression, 3, 0, 0),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18146),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15183),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18151),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4276),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4262),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16238),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19611),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19807),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19612),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16239),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9672),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9673),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4100),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3155),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4103),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7304),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14115),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11812),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12585),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9801),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14204),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4962),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6902),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6963),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7027),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5037),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7050),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17748),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15403),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17755),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15011),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15012),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17487),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15420),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17493),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4272),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4261),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16325),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19666),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19829),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19667),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16326),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9679),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9680),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4149),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3163),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4152),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7717),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14096),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11787),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12769),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9769),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14221),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4921),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7081),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7118),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7128),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4859),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6878),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17784),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15246),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17786),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14767),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14770),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18015),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15406),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18020),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17838),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15264),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17420),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17500),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15310),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17536),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17546),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15411),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17547),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17583),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15456),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17585),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4606),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4333),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4265),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16445),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19757),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19865),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19758),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16446),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9691),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9692),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4192),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3176),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4194),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8678),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14068),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11767),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12592),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9780),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14224),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5886),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7814),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7834),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7815),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5307),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7862),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17371),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15194),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17376),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14701),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14702),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4295),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4267),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16397),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19739),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19856),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19740),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16398),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9685),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9686),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4173),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3169),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4176),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8176),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14137),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11702),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12408),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9794),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14184),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5405),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7294),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7295),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7296),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5615),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7313),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14968),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14969),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4321),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4266),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16429),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19751),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19862),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19752),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16430),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9668),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9690),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4188),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3174),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4190),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8432),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2494),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14006),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11615),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12517),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9775),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14182),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5931),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7589),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7590),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7591),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5906),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7649),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14900),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14908),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2614),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5176),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17589),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15340),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17640),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18024),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15396),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18029),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4953),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17616),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15209),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17620),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17638),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15223),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17639),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17924),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15448),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17926),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4328),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4264),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16347),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19691),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19838),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19692),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16348),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9681),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9682),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4157),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4160),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8481),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14070),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11770),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12339),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9768),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14195),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5336),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7820),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7820),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7821),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7822),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6378),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7823),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7823),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17652),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15235),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17653),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15125),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15126),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2766),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5598),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2538),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3009),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5944),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4496),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4268),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16479),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19769),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19871),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19770),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16480),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9695),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9696),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4199),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3181),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4202),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9034),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2715),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14022),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11576),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12646),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9799),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14202),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6358),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8465),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8490),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8467),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6201),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8598),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17649),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15375),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17658),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14837),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14838),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17787),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15455),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17790),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4400),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4269),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16285),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19639),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19818),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19640),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16286),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9675),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9676),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4124),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3159),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4126),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8906),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14003),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11613),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12673),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9798),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6243),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8182),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8183),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8184),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6220),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8298),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17382),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15277),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17386),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14636),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14637),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17518),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15233),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17521),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5206),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18076),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15424),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18078),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17615),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15330),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17619),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17682),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15395),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17685),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17663),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15243),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17664),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17740),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15282),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17741),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6347),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6583),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6361),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6262),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9662),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7375),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3938),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3623),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14099),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11828),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3941),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12852),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9786),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7353),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9962),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9845),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9966),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10591),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4069),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4082),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 2),
  [1265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 2),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7723),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12137),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10876),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11987),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8497),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7782),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8563),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12559),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8379),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7414),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8479),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8151),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12263),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10903),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8774),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9007),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [1365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2516),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6569),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12788),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9076),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [1385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4273),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0),
  [1390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4263),
  [1393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(120),
  [1396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16412),
  [1399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19745),
  [1402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19859),
  [1405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19746),
  [1408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16413),
  [1411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9687),
  [1414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9688),
  [1417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(767),
  [1420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1624),
  [1423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4181),
  [1426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(459),
  [1429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3171),
  [1432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4184),
  [1435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7366),
  [1438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(151),
  [1441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2475),
  [1444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1806),
  [1447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1807),
  [1450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(826),
  [1453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14039),
  [1456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11797),
  [1459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(823),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0),
  [1464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [1467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12512),
  [1470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9795),
  [1473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14183),
  [1476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5071),
  [1479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7063),
  [1482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7077),
  [1485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7123),
  [1488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4845),
  [1491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7039),
  [1494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(211),
  [1497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14664),
  [1500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14674),
  [1503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_argument_list, 1, 0, 0),
  [1505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_argument_list, 1, 0, 0),
  [1507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4272),
  [1510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4261),
  [1513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(75),
  [1516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16325),
  [1519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19666),
  [1522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19829),
  [1525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19667),
  [1528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16326),
  [1531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9679),
  [1534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9680),
  [1537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(779),
  [1540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1608),
  [1543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4149),
  [1546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(455),
  [1549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3163),
  [1552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4152),
  [1555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7717),
  [1558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(157),
  [1561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2219),
  [1564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1769),
  [1567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1770),
  [1570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(836),
  [1573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14096),
  [1576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11787),
  [1579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(924),
  [1582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1497),
  [1585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12769),
  [1588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9769),
  [1591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14221),
  [1594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4921),
  [1597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7081),
  [1600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7118),
  [1603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7128),
  [1606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4859),
  [1609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6878),
  [1612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(189),
  [1615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14767),
  [1618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14770),
  [1621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4276),
  [1624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4262),
  [1627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(126),
  [1630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16238),
  [1633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19611),
  [1636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19807),
  [1639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19612),
  [1642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16239),
  [1645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9672),
  [1648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9673),
  [1651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(628),
  [1654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1600),
  [1657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4100),
  [1660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(453),
  [1663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3155),
  [1666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4103),
  [1669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7304),
  [1672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(150),
  [1675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2277),
  [1678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1744),
  [1681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1745),
  [1684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(851),
  [1687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14115),
  [1690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11812),
  [1693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(863),
  [1696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1586),
  [1699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12585),
  [1702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9801),
  [1705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14204),
  [1708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4962),
  [1711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6902),
  [1714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6963),
  [1717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7027),
  [1720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5037),
  [1723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7050),
  [1726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(188),
  [1729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(15011),
  [1732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(15012),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12490),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7380),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7318),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8265),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [1759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1, 0, 0),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [1769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10677),
  [1773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4295),
  [1776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4267),
  [1779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(128),
  [1782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16397),
  [1785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19739),
  [1788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19856),
  [1791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19740),
  [1794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16398),
  [1797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9685),
  [1800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9686),
  [1803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(716),
  [1806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1620),
  [1809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4173),
  [1812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(458),
  [1815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3169),
  [1818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4176),
  [1821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8176),
  [1824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(162),
  [1827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2396),
  [1830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1795),
  [1833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1796),
  [1836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(808),
  [1839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14137),
  [1842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11702),
  [1845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(922),
  [1848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1521),
  [1851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12408),
  [1854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9794),
  [1857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14184),
  [1860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5405),
  [1863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7294),
  [1866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7295),
  [1869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7296),
  [1872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5615),
  [1875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7313),
  [1878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(248),
  [1881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14968),
  [1884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14969),
  [1887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4333),
  [1890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4265),
  [1893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(156),
  [1896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16445),
  [1899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19757),
  [1902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19865),
  [1905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19758),
  [1908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16446),
  [1911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9691),
  [1914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9692),
  [1917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(552),
  [1920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1632),
  [1923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4192),
  [1926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(461),
  [1929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3176),
  [1932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4194),
  [1935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8678),
  [1938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(166),
  [1941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2617),
  [1944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1826),
  [1947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1827),
  [1950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(792),
  [1953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14068),
  [1956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11767),
  [1959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(795),
  [1962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1554),
  [1965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12592),
  [1968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9780),
  [1971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14224),
  [1974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5886),
  [1977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7814),
  [1980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7834),
  [1983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7815),
  [1986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5307),
  [1989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7862),
  [1992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(235),
  [1995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14701),
  [1998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14702),
  [2001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(194),
  [2004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1904),
  [2007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1728),
  [2010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1729),
  [2013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4606),
  [2016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(187),
  [2019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2028),
  [2022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2004),
  [2025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2005),
  [2028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4953),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9789),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10566),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12061),
  [2045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4321),
  [2048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4266),
  [2051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(154),
  [2054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16429),
  [2057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19751),
  [2060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19862),
  [2063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19752),
  [2066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16430),
  [2069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9668),
  [2072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9690),
  [2075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(535),
  [2078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1628),
  [2081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4188),
  [2084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(460),
  [2087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3174),
  [2090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4190),
  [2093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8432),
  [2096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(163),
  [2099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2494),
  [2102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1811),
  [2105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1812),
  [2108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(893),
  [2111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14006),
  [2114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11615),
  [2117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(833),
  [2120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1602),
  [2123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12517),
  [2126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9775),
  [2129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14182),
  [2132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5931),
  [2135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7589),
  [2138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7590),
  [2141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7591),
  [2144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5906),
  [2147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7649),
  [2150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(216),
  [2153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14900),
  [2156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14908),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8434),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [2165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(161),
  [2168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2337),
  [2171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2614),
  [2174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2618),
  [2177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5176),
  [2180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8689),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [2186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1, 0, 0),
  [2188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1, 0, 0),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5970),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [2194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(246),
  [2197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2151),
  [2200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2328),
  [2203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2330),
  [2206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5206),
  [2209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9665),
  [2211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [2215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2515),
  [2217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [2219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [2221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14113),
  [2223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11838),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12864),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9806),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10043),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9968),
  [2233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10044),
  [2235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10969),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9054),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [2245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4400),
  [2248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4269),
  [2251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(170),
  [2254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16285),
  [2257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19639),
  [2260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19818),
  [2263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19640),
  [2266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16286),
  [2269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9675),
  [2272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9676),
  [2275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(591),
  [2278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1604),
  [2281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4124),
  [2284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(454),
  [2287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3159),
  [2290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4126),
  [2293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8906),
  [2296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(221),
  [2299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2238),
  [2302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1756),
  [2305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1757),
  [2308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(901),
  [2311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14003),
  [2314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11613),
  [2317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(812),
  [2320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1637),
  [2323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12673),
  [2326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9798),
  [2329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14190),
  [2332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6243),
  [2335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8182),
  [2338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8183),
  [2341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8184),
  [2344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6220),
  [2347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8298),
  [2350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(272),
  [2353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14636),
  [2356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14637),
  [2359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4328),
  [2362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4264),
  [2365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(86),
  [2368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16347),
  [2371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19691),
  [2374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19838),
  [2377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19692),
  [2380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16348),
  [2383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9681),
  [2386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9682),
  [2389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(580),
  [2392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1612),
  [2395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4157),
  [2398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(456),
  [2401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3165),
  [2404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4160),
  [2407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8481),
  [2410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(236),
  [2413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2257),
  [2416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1774),
  [2419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1775),
  [2422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(841),
  [2425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14070),
  [2428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11770),
  [2431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(877),
  [2434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1532),
  [2437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12339),
  [2440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9768),
  [2443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14195),
  [2446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5336),
  [2449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7820),
  [2452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7820),
  [2455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7821),
  [2458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7822),
  [2461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6378),
  [2464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7823),
  [2467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7823),
  [2470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(289),
  [2473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(289),
  [2476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(15125),
  [2479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(15126),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4998),
  [2484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4589),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9666),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [2490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [2492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3154),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14091),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11824),
  [2502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12842),
  [2504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9802),
  [2506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10069),
  [2508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9869),
  [2510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10071),
  [2512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11146),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [2516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(251),
  [2519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2377),
  [2522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2765),
  [2525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2766),
  [2528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5598),
  [2531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(232),
  [2534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2538),
  [2537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3009),
  [2540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3010),
  [2543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5944),
  [2546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10572),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10533),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10761),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10847),
  [2554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 2, 0, 5),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [2560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4496),
  [2563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4268),
  [2566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(106),
  [2569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16479),
  [2572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19769),
  [2575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19871),
  [2578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19770),
  [2581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16480),
  [2584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9695),
  [2587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9696),
  [2590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(586),
  [2593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1640),
  [2596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4199),
  [2599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(436),
  [2602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3181),
  [2605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4202),
  [2608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9034),
  [2611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(215),
  [2614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2715),
  [2617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1846),
  [2620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1847),
  [2623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(870),
  [2626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14022),
  [2629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11576),
  [2632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(860),
  [2635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1519),
  [2638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12646),
  [2641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9799),
  [2644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14202),
  [2647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6358),
  [2650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8465),
  [2653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8490),
  [2656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8467),
  [2659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6201),
  [2662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8598),
  [2665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(287),
  [2668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14837),
  [2671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(14838),
  [2674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9667),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14105),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11833),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12856),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9804),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10110),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9889),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10112),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11137),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4729),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5716),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5858),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3151),
  [2716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [2718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [2720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11198),
  [2722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10197),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9664),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [2728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16461),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19763),
  [2732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19868),
  [2734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19764),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16462),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9693),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9694),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4196),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3178),
  [2752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4197),
  [2754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12781),
  [2756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [2760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [2762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [2766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14123),
  [2768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11599),
  [2770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12598),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9766),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10684),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10916),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11891),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14741),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14742),
  [2790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(265),
  [2793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1970),
  [2796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1913),
  [2799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1914),
  [2802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6347),
  [2805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [2809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [2811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2852),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11073),
  [2815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(122),
  [2818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [2821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2436),
  [2824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1799),
  [2827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1800),
  [2830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6583),
  [2833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(320),
  [2836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(320),
  [2839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11144),
  [2841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(288),
  [2844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2055),
  [2847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2047),
  [2850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2051),
  [2853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6361),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10185),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9660),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [2862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16043),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19375),
  [2866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19776),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19376),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16044),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9674),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9678),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [2880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3947),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3147),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3949),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12015),
  [2890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [2892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [2894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [2896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14002),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11781),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12545),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9784),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10379),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10111),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10111),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9892),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10115),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11288),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11656),
  [2926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11656),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14960),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14962),
  [2936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5961),
  [2938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [2940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(285),
  [2943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2657),
  [2946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1688),
  [2949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1689),
  [2952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6262),
  [2955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [2957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [2959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [2961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [2963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11054),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5341),
  [2967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10995),
  [2969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9663),
  [2971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [2973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [2975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [2977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [2979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14118),
  [2981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11842),
  [2983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12872),
  [2985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9808),
  [2987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10551),
  [2989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [2993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [2995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [2999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11131),
  [3001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10991),
  [3003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [3005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11148),
  [3007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11006),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [3011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5418),
  [3013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5731),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [3017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [3019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2558),
  [3021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [3023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [3025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12311),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9779),
  [3029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10133),
  [3031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11203),
  [3033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11220),
  [3035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [3037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [3039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2637),
  [3041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [3043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11387),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [3049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10701),
  [3053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11360),
  [3055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10877),
  [3057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6742),
  [3059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [3061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7382),
  [3063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4201),
  [3065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4204),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [3069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4205),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9777),
  [3073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8978),
  [3075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3166),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4209),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4210),
  [3085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [3087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [3089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [3099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [3107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [3109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(324),
  [3112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2198),
  [3115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2516),
  [3118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2517),
  [3121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6569),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11207),
  [3126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [3128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6362),
  [3130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11208),
  [3132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8782),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [3138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9669),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [3142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [3144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [3146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [3148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14080),
  [3150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11819),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12730),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9785),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10134),
  [3158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10134),
  [3160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10089),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10136),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11242),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [3172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [3176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11225),
  [3180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [3184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3202),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [3188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10619),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [3192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [3194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [3196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [3198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10630),
  [3200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10895),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7785),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6106),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5991),
  [3216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11202),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [3220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8571),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6370),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [3230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12566),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [3234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [3236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12099),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [3240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [3242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8382),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [3246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [3248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6371),
  [3250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [3252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7417),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [3256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [3258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8483),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [3262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11317),
  [3266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [3268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8154),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [3272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [3274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12266),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [3278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [3280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8778),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [3284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [3286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11200),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11286),
  [3290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6373),
  [3292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [3294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6590),
  [3296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [3298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11420),
  [3300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11421),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [3308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [3310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [3312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [3314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11231),
  [3318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [3320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [3322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3150),
  [3324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11408),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11426),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6588),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11343),
  [3338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11397),
  [3340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6584),
  [3344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [3346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2676),
  [3348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [3350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11391),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [3358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11173),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [3362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6554),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [3366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6631),
  [3368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [3370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11154),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [3376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [3378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [3380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11423),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6651),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [3390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [3392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3161),
  [3394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [3396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11496),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [3404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11247),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [3408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11239),
  [3410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11382),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11427),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11396),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11487),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [3432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6750),
  [3434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [3436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19167),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7197),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [3442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12730),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9747),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19167),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11252),
  [3450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18839),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9728),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18839),
  [3460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19321),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9714),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19321),
  [3470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19163),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9751),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19163),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19237),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10404),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9730),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19237),
  [3490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18593),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10142),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9745),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18593),
  [3500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19193),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9994),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9719),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19193),
  [3510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18235),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11160),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9737),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18235),
  [3520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18633),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14365),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9722),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18633),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11497),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [3534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [3536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18602),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9723),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18602),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11466),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [3552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19132),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9698),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19132),
  [3562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19683),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10768),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9748),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19683),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19510),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9732),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19510),
  [3582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18242),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6626),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9713),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18242),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18694),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5367),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9735),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18694),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18437),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10087),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9762),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18437),
  [3612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18481),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9463),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9707),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18481),
  [3622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18231),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9389),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9709),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18231),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19609),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10715),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9718),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19609),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18408),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6284),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9726),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18408),
  [3652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19780),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5019),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9743),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19780),
  [3662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19215),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11300),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9755),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19215),
  [3672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19816),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9757),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19816),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18378),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9752),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18378),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18577),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6396),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9705),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18577),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18841),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12001),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9750),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18841),
  [3712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19409),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6427),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9727),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19409),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19599),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10215),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9717),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19599),
  [3732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19821),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9712),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19821),
  [3742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18197),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11557),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9702),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18197),
  [3752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19234),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5530),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9724),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19234),
  [3762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18324),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6642),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9742),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18324),
  [3772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19768),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11086),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9754),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19768),
  [3782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19112),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9731),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19112),
  [3792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18695),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6150),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9725),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18695),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11493),
  [3804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18933),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5802),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9738),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18933),
  [3814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18777),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7584),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9701),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18777),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19581),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10754),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9706),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19581),
  [3834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18426),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6786),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9708),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18426),
  [3844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18795),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9710),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18795),
  [3854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19073),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7109),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9715),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19073),
  [3864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19473),
  [3866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11699),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9721),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19473),
  [3874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19368),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9729),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19368),
  [3884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19618),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9740),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19618),
  [3894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18532),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6451),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9746),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18532),
  [3904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18831),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7092),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9749),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18831),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19057),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8585),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9756),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19057),
  [3924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19271),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11260),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9761),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19271),
  [3934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19602),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6095),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9720),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19602),
  [3944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18178),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18074),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9758),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18178),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18300),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7107),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9703),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18300),
  [3964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18427),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7655),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9741),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18427),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18539),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6665),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9744),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18539),
  [3984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18646),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7094),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9699),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18646),
  [3994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18770),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9753),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18770),
  [4004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18868),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7739),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9736),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18868),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18973),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11147),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9700),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18973),
  [4024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19071),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6523),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9711),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19071),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19282),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7839),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9759),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19282),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19418),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9760),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19418),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19558),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11766),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9716),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19558),
  [4064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19682),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6128),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9734),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19682),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19823),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7960),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9704),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19823),
  [4084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18554),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8045),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9739),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18554),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18541),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8624),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9697),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18541),
  [4104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3158),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [4110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11544),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19311),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9733),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19311),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11650),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [4128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12166),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [4134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11920),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [4140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [4142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8952),
  [4144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9773),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [4148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17720),
  [4152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8141),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [4156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17844),
  [4160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7421),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12852),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9789),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14204),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9962),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9966),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10591),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12061),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [4178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8538),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [4182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17774),
  [4186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8189),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [4190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17848),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8197),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12253),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [4200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17860),
  [4204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10669),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [4208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18047),
  [4212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12293),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17862),
  [4220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12300),
  [4222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9131),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [4226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17876),
  [4230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10659),
  [4232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8800),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17880),
  [4240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8807),
  [4242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8684),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17778),
  [4250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8699),
  [4252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11954),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [4256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17525),
  [4260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10871),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [4264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17903),
  [4268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12552),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [4272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17795),
  [4276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12609),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17799),
  [4284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12620),
  [4286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7402),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [4290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17689),
  [4294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8367),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [4298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17810),
  [4302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7801),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [4306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17758),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [4312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11157),
  [4318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8408),
  [4322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7808),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7409),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17823),
  [4332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12197),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17528),
  [4340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8944),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [4344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17723),
  [4348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7451),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17825),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7458),
  [4358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8473),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [4362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17830),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12135),
  [4368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8958),
  [4370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8514),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17833),
  [4378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8521),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [4386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [4388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7369),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17684),
  [4396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7776),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [4400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17754),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [4406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [4410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [4414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [4418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [4422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [4426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [4434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8401),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17813),
  [4452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [4454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8153),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [4458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [4460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12712),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [4464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12199),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [4472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12343),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [4476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8228),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [4484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7896),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8381),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7445),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [4502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8776),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [4506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [4508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7289),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [4512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8412),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [4518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [4520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8458),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8492),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [4530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [4532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7378),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [4536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [4538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12181),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [4542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [4544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12265),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [4548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [4550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7416),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [4554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8810),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10924),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [4566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [4568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8858),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [4572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [4574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8899),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [4578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [4580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7461),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [4586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7479),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [4590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7496),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7547),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [4602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [4604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7812),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [4610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7784),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [4616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8482),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [4620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [4622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8569),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [4626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [4628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8974),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [4634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8703),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [4638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [4640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8200),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [4644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12033),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [4652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8277),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [4656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8524),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8556),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [4670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10747),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [4676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11864),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [4680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [4682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8314),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [4688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9035),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [4692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10548),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9108),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [4704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10729),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [4712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8213),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [4716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [4718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 1, 0, 0),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [4724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12562),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [4728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [4730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9120),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [4734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7847),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [4740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [4742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12303),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [4746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [4748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12323),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [4752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [4754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12627),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [4758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [4760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12680),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [4764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [4766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8602),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [4770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12842),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9802),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14184),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10069),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10071),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11157),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 1, 0, 0),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [4790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11014),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [4794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 1, 0, 0),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [4798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11023),
  [4800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [4802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10972),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17361),
  [4806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6630),
  [4808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17361),
  [4810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7498),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [4814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [4816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7509),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [4820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [4822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8435),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [4826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [4828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8472),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [4832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [4834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8475),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [4838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [4840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8476),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [4844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [4846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14356),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18127),
  [4850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18127),
  [4852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7775),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [4856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [4858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7777),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [4862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [4864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7779),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [4868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [4870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8515),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [4874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [4876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11880),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [4880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [4882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10963),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [4886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17943),
  [4888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8555),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [4892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [4894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11943),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [4898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [4900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10953),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18000),
  [4904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18000),
  [4906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10564),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [4910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [4912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8611),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [4916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [4918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8660),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [4922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [4924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8690),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [4928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [4930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8139),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [4934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [4936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 3, 0, 5),
  [4938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8142),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [4942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [4944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8145),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [4948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [4950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7802),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [4954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [4956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10648),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [4960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [4962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10702),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [4966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [4968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6249),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [4972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17508),
  [4974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8190),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [4978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [4980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7846),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [4984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12391),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9774),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14183),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9908),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9919),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10874),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [5006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5535),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [5010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18141),
  [5012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8212),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [5016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [5018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6313),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17552),
  [5022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17552),
  [5024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5569),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17535),
  [5028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17535),
  [5030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8230),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [5034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [5036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8240),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [5040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [5042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12789),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [5046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [5048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12252),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [5052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [5054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12254),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [5058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [5060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12256),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [5064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [5066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7898),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [5070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [5072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7913),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [5076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [5078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10646),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [5082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [5084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12294),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [5088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [5090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12149),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [5094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [5098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [5100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8498),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [5104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5740),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [5110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18003),
  [5112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12322),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [5116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [5118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5788),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17449),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17449),
  [5124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12345),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [5128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [5130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12358),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [5134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [5136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9077),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [5140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [5142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9129),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [5148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9132),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [5152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9137),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [5158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [5160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8537),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [5164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [5166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9058),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [5170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [5172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8558),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [5176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [5178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8560),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [5182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [5184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8801),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [5188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [5190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10774),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [5194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17927),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8857),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [5200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [5202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8927),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [5206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [5208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10796),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17448),
  [5212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17448),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [5216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [5218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8905),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [5222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [5224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8922),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [5228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [5230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8691),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [5234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [5236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5627),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [5240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17843),
  [5242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5221),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18011),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18011),
  [5248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8783),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [5252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [5254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11758),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [5258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17756),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11832),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18026),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18026),
  [5266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8821),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6490),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [5276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17484),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6511),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17594),
  [5282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17594),
  [5284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5083),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [5288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18007),
  [5290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10211),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [5294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17680),
  [5296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10225),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17749),
  [5300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17749),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [5304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [5306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5494),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [5310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17351),
  [5312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5507),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17414),
  [5316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17414),
  [5318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8262),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [5322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [5324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10072),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [5328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17662),
  [5330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10097),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17696),
  [5334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17696),
  [5336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12018),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [5340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [5342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14479),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [5346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17345),
  [5348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14490),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17379),
  [5352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17379),
  [5354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4570),
  [5356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18058),
  [5358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18058),
  [5360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9446),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [5364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17516),
  [5366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9475),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17530),
  [5370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17530),
  [5372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9362),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [5376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17577),
  [5378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9387),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17587),
  [5382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17587),
  [5384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7319),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [5388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [5390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11477),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [5394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17634),
  [5396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11446),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17641),
  [5400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17641),
  [5402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8317),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [5406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [5408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10689),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [5412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17714),
  [5414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10712),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17730),
  [5418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17730),
  [5420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8369),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [5424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [5426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6318),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [5430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17802),
  [5432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6332),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17822),
  [5436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17822),
  [5438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6857),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [5442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18013),
  [5444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6876),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18021),
  [5448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18021),
  [5450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6681),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [5454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18077),
  [5456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6689),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18088),
  [5460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18088),
  [5462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8945),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [5466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [5468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5060),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [5472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18140),
  [5474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5076),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17498),
  [5478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17498),
  [5480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9967),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [5484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18009),
  [5486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11306),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17849),
  [5492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11318),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17350),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17350),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12492),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [5502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [5504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5118),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [5508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18030),
  [5510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5133),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17367),
  [5514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17367),
  [5516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5938),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [5520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17698),
  [5522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5956),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17746),
  [5526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17746),
  [5528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6365),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [5532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17364),
  [5534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6224),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17392),
  [5538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17392),
  [5540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12550),
  [5542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [5544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [5546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12185),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [5550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17533),
  [5552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11876),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17556),
  [5556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17556),
  [5558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7368),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [5562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [5564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8115),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [5568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17770),
  [5570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8124),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17806),
  [5574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17806),
  [5576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7614),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [5580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18005),
  [5582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7623),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18048),
  [5586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18048),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12554),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [5592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [5594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6062),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [5598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17402),
  [5600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6090),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17416),
  [5604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17416),
  [5606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5072),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [5610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17482),
  [5612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6957),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [5616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17471),
  [5618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7156),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17481),
  [5622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17481),
  [5624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12222),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6767),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [5634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17561),
  [5636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6812),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17579),
  [5640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17579),
  [5642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9031),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [5646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [5648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4626),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [5652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17676),
  [5654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4637),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17692),
  [5658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17692),
  [5660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7370),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [5664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [5666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7681),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [5670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17781),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7688),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17791),
  [5676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17791),
  [5678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5160),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17568),
  [5682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17568),
  [5684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6914),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [5688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17882),
  [5690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7022),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17899),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17899),
  [5696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12610),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [5700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [5702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5424),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [5706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18043),
  [5708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5436),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18069),
  [5712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18069),
  [5714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11707),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [5718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17363),
  [5720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11720),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17374),
  [5724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17374),
  [5726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7371),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [5730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [5732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11093),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [5736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17415),
  [5738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11104),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17419),
  [5742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17419),
  [5744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10124),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [5748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17504),
  [5750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5604),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [5754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17446),
  [5756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5625),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17447),
  [5760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17447),
  [5762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12679),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [5766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [5768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6165),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [5772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17468),
  [5774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6186),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17469),
  [5778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17469),
  [5780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9112),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [5784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [5786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5724),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [5790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17486),
  [5792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5748),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17488),
  [5796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17488),
  [5798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10144),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17515),
  [5802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17515),
  [5804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7757),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [5808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17517),
  [5810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7765),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17524),
  [5814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17524),
  [5816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7019),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [5820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17550),
  [5822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7115),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17553),
  [5826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17553),
  [5828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8789),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [5832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [5834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5846),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [5838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17584),
  [5840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5859),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17586),
  [5844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17586),
  [5846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12714),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [5850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [5852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10657),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [5856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17618),
  [5858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10671),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17621),
  [5862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17621),
  [5864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12728),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [5868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [5870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6952),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [5874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17654),
  [5876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6972),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17656),
  [5880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17656),
  [5882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11893),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [5886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [5888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6720),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [5892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17697),
  [5894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6731),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17700),
  [5898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17700),
  [5900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4795),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [5904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17728),
  [5906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4804),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17729),
  [5910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17729),
  [5912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8266),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [5916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [5918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7874),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [5922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17767),
  [5924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7882),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17768),
  [5928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17768),
  [5930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7205),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [5934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17800),
  [5936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7220),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17803),
  [5940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17803),
  [5942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5280),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [5946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17831),
  [5948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5287),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17834),
  [5952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17834),
  [5954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8366),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [5958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [5960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5981),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [5964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17866),
  [5966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5992),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17868),
  [5970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17868),
  [5972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10585),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [5976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [5978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11265),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [5982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17909),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11277),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17912),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17912),
  [5990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8368),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [5994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [5996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6028),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [6000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17957),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6036),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17963),
  [6006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17963),
  [6008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8375),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [6012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [6014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7979),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [6018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18016),
  [6020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7987),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18022),
  [6024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18022),
  [6026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6891),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [6030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18057),
  [6032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7008),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18059),
  [6036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18059),
  [6038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10898),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [6042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [6044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [6048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18098),
  [6050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5378),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18102),
  [6054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18102),
  [6056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7403),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [6060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [6062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11822),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [6066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18149),
  [6068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11609),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18152),
  [6072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18152),
  [6074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10957),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [6078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17360),
  [6080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10919),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [6084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [6086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10848),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [6090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [6092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6538),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [6096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17381),
  [6098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6552),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17384),
  [6102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17384),
  [6104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18090),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [6108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17397),
  [6110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17736),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17400),
  [6114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17400),
  [6116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8629),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [6120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17410),
  [6122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8638),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17412),
  [6126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17412),
  [6128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8402),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [6132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [6134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8054),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [6138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17422),
  [6140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8063),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17424),
  [6144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17424),
  [6146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6133),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [6150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17432),
  [6152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6142),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17433),
  [6156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17433),
  [6158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10359),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [6162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18065),
  [6164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12028),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [6168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [6170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9621),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [6174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17602),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8456),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [6180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [6182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7522),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [6186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [6188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9622),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17617),
  [6192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17617),
  [6194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 0),
  [6196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8494),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [6200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [6202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8116),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [6206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [6208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10403),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18126),
  [6212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18126),
  [6214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7381),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [6218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [6220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7408),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [6224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [6226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7410),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [6230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [6232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7411),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [6236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [6238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7549),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [6242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [6244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7563),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [6248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [6250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14355),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [6254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17915),
  [6256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9961),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17706),
  [6260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17706),
  [6262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7452),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [6266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [6268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12091),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [6272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [6274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9561),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [6278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17734),
  [6280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7478),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [6284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [6286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7724),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [6290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [6292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9583),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17747),
  [6296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17747),
  [6298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12553),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [6302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19750),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11565),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12769),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9769),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7081),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7128),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6878),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18389),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19122),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7251),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18735),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6110),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19284),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10307),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11213),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18407),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10757),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18955),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19531),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6664),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18391),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10390),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19140),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7748),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19649),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6499),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19445),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6890),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19727),
  [6406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [6410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19787),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5834),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19083),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9386),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18513),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6436),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18243),
  [6434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10600),
  [6436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18822),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11294),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19657),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10276),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18377),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6932),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18904),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11132),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19785),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18491),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6704),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [6472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12864),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9806),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14224),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10043),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10044),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11014),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [6490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [6492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18590),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [6496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(4272),
  [6499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(4261),
  [6502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(75),
  [6505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(16325),
  [6508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(19666),
  [6511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(19829),
  [6514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(19667),
  [6517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(16326),
  [6520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(9679),
  [6523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(9680),
  [6526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(779),
  [6529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(1608),
  [6532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(4149),
  [6535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(455),
  [6538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(3163),
  [6541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(4152),
  [6544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(7717),
  [6547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(187),
  [6550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(2028),
  [6553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(2004),
  [6556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(2005),
  [6559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(836),
  [6562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(14096),
  [6565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(11787),
  [6568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(924),
  [6571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0),
  [6573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0),
  [6575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(1497),
  [6578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(12769),
  [6581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(9769),
  [6584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(14221),
  [6587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(4921),
  [6590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(7081),
  [6593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(7118),
  [6596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(7128),
  [6599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(6630),
  [6602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(6878),
  [6605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(323),
  [6608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(14767),
  [6611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(14770),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [6616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18769),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18715),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7865),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18975),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5452),
  [6634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12856),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9804),
  [6640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14182),
  [6642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10110),
  [6644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10112),
  [6646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11023),
  [6648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [6652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18824),
  [6654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [6658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19117),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6442),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18925),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19788),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9627),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18794),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10139),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19032),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5969),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18600),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12131),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19115),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11251),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19281),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10118),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19230),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6013),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [6720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18379),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8748),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18363),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19356),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7969),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19109),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14370),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18731),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6301),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19502),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9981),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19053),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7604),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11480),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19617),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18968),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14500),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19498),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19775),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11807),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19806),
  [6786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6449),
  [6788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 2, 0, 0),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9825),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18167),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11183),
  [6800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_row, 1, 0, 0),
  [6802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_row, 1, 0, 0),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19783),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6514),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18490),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6967),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18416),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9431),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18871),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18041),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19344),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8615),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19153),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6711),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5568),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [6852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18162),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8040),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19598),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9399),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18375),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6120),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18281),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18523),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18628),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7671),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18299),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11465),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10493),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [6902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18961),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6962),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18218),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18783),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10348),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [6922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18456),
  [6924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9567),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19274),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18470),
  [6936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10539),
  [6938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [6940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 3, 0, 0),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19760),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11687),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [6956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [6958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19001),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11079),
  [6962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [6964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19495),
  [6966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7253),
  [6968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12904),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12805),
  [6972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9781),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14190),
  [6976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10121),
  [6978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10150),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11199),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [6984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4895),
  [6986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12291),
  [6988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7916),
  [6990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12296),
  [6992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12299),
  [6994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12298),
  [6996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7921),
  [6998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12305),
  [7000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10580),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18201),
  [7004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10522),
  [7006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [7008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11228),
  [7010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10581),
  [7012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12324),
  [7014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12329),
  [7016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12330),
  [7018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12335),
  [7020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7548),
  [7022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12086),
  [7024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12344),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10433),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6630),
  [7030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [7032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5816),
  [7034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10907),
  [7036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12360),
  [7038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12365),
  [7040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14372),
  [7042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8536),
  [7044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9126),
  [7046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10882),
  [7048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7565),
  [7050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7573),
  [7052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8561),
  [7054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9012),
  [7056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8562),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19220),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [7062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12037),
  [7064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8798),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [7068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8802),
  [7070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8803),
  [7072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8806),
  [7074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8805),
  [7076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12051),
  [7078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8618),
  [7080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8811),
  [7082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12121),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19708),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [7090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12108),
  [7092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8860),
  [7094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8868),
  [7096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8869),
  [7098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8876),
  [7100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8694),
  [7102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8695),
  [7104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8698),
  [7106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8903),
  [7108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8697),
  [7110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10805),
  [7112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5818),
  [7114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8924),
  [7116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8932),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10377),
  [7120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8704),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19514),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6387),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [7128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10541),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19777),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5810),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5245),
  [7138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6614),
  [7140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12219),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19647),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [7150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8301),
  [7152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8325),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11679),
  [7156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5324),
  [7158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8340),
  [7160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8178),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18963),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9871),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18234),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9320),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [7174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10595),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6532),
  [7178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10080),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14545),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [7184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8315),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19244),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9370),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10232),
  [7194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9424),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [7198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6352),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18947),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10441),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [7206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10538),
  [7208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8373),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [7212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10750),
  [7214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8389),
  [7216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12071),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18397),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [7224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12160),
  [7226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11971),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10114),
  [7230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6269),
  [7232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12052),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9840),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19597),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [7242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12549),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14498),
  [7246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5011),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18297),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11061),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [7254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12557),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9434),
  [7258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11339),
  [7260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12558),
  [7262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8781),
  [7264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11866),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18467),
  [7268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4560),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9397),
  [7276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5166),
  [7278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12604),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18730),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14400),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11536),
  [7290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5588),
  [7292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8822),
  [7294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12612),
  [7296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12613),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19121),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5556),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [7304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12618),
  [7306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12617),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10748),
  [7310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6256),
  [7312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8824),
  [7314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9410),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19530),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11753),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [7322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12634),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6341),
  [7326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12016),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18451),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19726),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [7338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [7340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6889),
  [7344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6342),
  [7346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12681),
  [7348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12684),
  [7350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12685),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18809),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [7358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12691),
  [7360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6696),
  [7362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5005),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9560),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [7368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12182),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19568),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5031),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [7376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8941),
  [7378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12713),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5733),
  [7384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12066),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10183),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18758),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10881),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [7394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4603),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11328),
  [7398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11064),
  [7400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12745),
  [7402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12750),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19101),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [7410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8946),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [7414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5808),
  [7416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8947),
  [7418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8957),
  [7420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8955),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18588),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [7428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8365),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [7432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6423),
  [7434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10844),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18376),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [7442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8976),
  [7444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8376),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6048),
  [7448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5836),
  [7450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8377),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19050),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18753),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10244),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11859),
  [7468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5297),
  [7470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10563),
  [7472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8399),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19802),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10339),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8130),
  [7482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10825),
  [7484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8403),
  [7486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8404),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18474),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [7494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8407),
  [7496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8406),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7629),
  [7500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4764),
  [7502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9036),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19150),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [7510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8414),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [7514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5549),
  [7516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9045),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18892),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10058),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18278),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [7530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9067),
  [7532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9090),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7234),
  [7536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6190),
  [7538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8459),
  [7540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8463),
  [7542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8464),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18626),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10980),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [7550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8486),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6813),
  [7554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11271),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18960),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [7562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8493),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [7566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5982),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9648),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19273),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [7576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10168),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7694),
  [7580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5397),
  [7582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9934),
  [7584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8134),
  [7586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8146),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19756),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10643),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [7594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9111),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7058),
  [7598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10943),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [7602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10455),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18996),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6366),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [7610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7407),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5448),
  [7614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6594),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [7618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8793),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18381),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5427),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [7626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8830),
  [7628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7412),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11729),
  [7632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6460),
  [7634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7413),
  [7636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9964),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10354),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11109),
  [7642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10697),
  [7644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7449),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [7648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10705),
  [7650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7453),
  [7652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7454),
  [7654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7457),
  [7656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7456),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6197),
  [7660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10651),
  [7662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7462),
  [7664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19493),
  [7668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10730),
  [7670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [7672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7367),
  [7674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7770),
  [7676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7480),
  [7678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7484),
  [7680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7485),
  [7682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7490),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7127),
  [7686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10893),
  [7688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10861),
  [7690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7497),
  [7692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5867),
  [7694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9582),
  [7696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11155),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10690),
  [7700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7372),
  [7702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7511),
  [7704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7515),
  [7706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7373),
  [7708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6989),
  [7710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12012),
  [7712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8471),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18374),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9834),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10320),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6737),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9639),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [7728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10637),
  [7730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8477),
  [7732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8478),
  [7734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7400),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11731),
  [7742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7888),
  [7746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8510),
  [7748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7774),
  [7750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8516),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7226),
  [7754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8517),
  [7756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8520),
  [7758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8519),
  [7760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7404),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [7764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7406),
  [7766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8525),
  [7768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7420),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18855),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [7778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7780),
  [7780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7781),
  [7782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8559),
  [7784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8567),
  [7786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11284),
  [7788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8568),
  [7790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8578),
  [7792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7419),
  [7794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12067),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6045),
  [7798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8610),
  [7800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11485),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7993),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11051),
  [7806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5357),
  [7808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8664),
  [7810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7076),
  [7812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8674),
  [7814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12169),
  [7816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7799),
  [7818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7447),
  [7820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5383),
  [7822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8136),
  [7824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7803),
  [7826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7804),
  [7828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11674),
  [7830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8149),
  [7832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8150),
  [7834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7807),
  [7836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7806),
  [7838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10981),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [7842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8187),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19004),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14338),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6559),
  [7852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7813),
  [7854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8192),
  [7856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8193),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18034),
  [7860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8196),
  [7862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8195),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8648),
  [7866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10852),
  [7868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8201),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18680),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [7876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19662),
  [7878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [7880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8068),
  [7884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8214),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6147),
  [7888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8217),
  [7890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8218),
  [7892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8223),
  [7894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10928),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19185),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9417),
  [7900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7848),
  [7902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8229),
  [7904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7852),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [7908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5593),
  [7910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7853),
  [7912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8242),
  [7914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8247),
  [7916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7858),
  [7918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7527),
  [7920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12248),
  [7922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7532),
  [7924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7533),
  [7926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7897),
  [7928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12257),
  [7930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12258),
  [7932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7539),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6357),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [7938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8772),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18390),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8070),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11375),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18828),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19805),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10723),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19241),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10391),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19536),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6908),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19286),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7705),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18747),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6065),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19133),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4681),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18932),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7919),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18495),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18460),
  [7988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9568),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19384),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10119),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19148),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6047),
  [7998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18401),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11860),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19037),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7093),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19028),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19772),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7099),
  [8016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19089),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10808),
  [8022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18844),
  [8024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18306),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9400),
  [8030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19738),
  [8032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6700),
  [8034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19123),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [8038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18207),
  [8040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10461),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18796),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18433),
  [8048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5639),
  [8050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18556),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19060),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8138),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19070),
  [8060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19238),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [8066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19156),
  [8068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10015),
  [8070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18424),
  [8072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14337),
  [8074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [8076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19793),
  [8078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11566),
  [8080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18612),
  [8082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [8084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18662),
  [8086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5877),
  [8088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19593),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4736),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19364),
  [8094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11301),
  [8096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18785),
  [8098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4954),
  [8100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18613),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [8104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18404),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11734),
  [8108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18183),
  [8110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5804),
  [8112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19169),
  [8114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5098),
  [8116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19866),
  [8118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10283),
  [8120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19504),
  [8122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6051),
  [8124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19822),
  [8126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7633),
  [8128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18228),
  [8130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5864),
  [8132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18476),
  [8134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11514),
  [8136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18744),
  [8138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11114),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19064),
  [8142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14501),
  [8144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9839),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9388),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19624),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8003),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19316),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19054),
  [8160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10900),
  [8162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [8164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [8166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [8168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [8170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12545),
  [8172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9784),
  [8174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14195),
  [8176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10115),
  [8178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12117),
  [8180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [8182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19503),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [8186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18966),
  [8188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [8192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19782),
  [8194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7151),
  [8196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9347),
  [8198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18518),
  [8200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6211),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10297),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18964),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10149),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10360),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18287),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11331),
  [8214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18399),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10396),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18527),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19151),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6233),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19256),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5303),
  [8232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19659),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [8236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18919),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9864),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9846),
  [8242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18371),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10393),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18176),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11672),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18355),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5350),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18733),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9833),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19499),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5789),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18746),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10814),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19292),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [8270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19172),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7040),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18225),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9402),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18929),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11074),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10361),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18482),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9597),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19800),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7787),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18815),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19367),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6566),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19577),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10571),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19131),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14368),
  [8312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11445),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18702),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11075),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19360),
  [8322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9328),
  [8324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18184),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8656),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18252),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6899),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [8336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 3, 0, 0),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18286),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6795),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19561),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11733),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18269),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6502),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19031),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10048),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18382),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5880),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19798),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9630),
  [8366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18499),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18506),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [8376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18790),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19021),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9658),
  [8388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11920),
  [8390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9658),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [8394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10392),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19043),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5453),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19610),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [8404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18497),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10855),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18908),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10994),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [8414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18640),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19157),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5468),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [8426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19000),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10219),
  [8432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19146),
  [8434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6348),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [8438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18594),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7072),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [8448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18341),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11030),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18429),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [8460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11528),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19347),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [8470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18353),
  [8474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10203),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [8480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10402),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18268),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [8490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18509),
  [8494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18969),
  [8498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14427),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [8502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18721),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6779),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19603),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9430),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [8514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19229),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6438),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19784),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [8526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4747),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18674),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6181),
  [8534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 2, 0, 0),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12646),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9799),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14202),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8465),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8467),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6262),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12598),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9766),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10619),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11891),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11220),
  [8576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18240),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12872),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9808),
  [8582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10630),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [8586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9975),
  [8588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11783),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11203),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11200),
  [8594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11237),
  [8596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [8598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3950),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12621),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10022),
  [8604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11373),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9611),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14385),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14353),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14375),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14404),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10126),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18452),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19330),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9605),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14361),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9613),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9612),
  [8630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14397),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14359),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9881),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9607),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9608),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14398),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9331),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12585),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9801),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6902),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7027),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7050),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [8664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9606),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9887),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11198),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9878),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9618),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11054),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5037),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4953),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11146),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12673),
  [8690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9798),
  [8692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8182),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8184),
  [8696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6220),
  [8698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8298),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11484),
  [8704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6347),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10572),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10761),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10566),
  [8714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11131),
  [8716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10677),
  [8718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [8720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [8722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12408),
  [8726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9794),
  [8728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7294),
  [8730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7296),
  [8732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11137),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12512),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9795),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7063),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7039),
  [8758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12517),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9775),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7589),
  [8772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7591),
  [8774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5906),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7649),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11073),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10969),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [8788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12592),
  [8792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9780),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7814),
  [8796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7815),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7862),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10916),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6201),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10551),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19300),
  [8812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4104),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9850),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10524),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10518),
  [8820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10347),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10364),
  [8824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9652),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9830),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14360),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10398),
  [8832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9843),
  [8834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9838),
  [8836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10400),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10405),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19304),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9829),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9835),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10431),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14334),
  [8850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9836),
  [8852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9558),
  [8854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9895),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11796),
  [8858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9333),
  [8860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [8862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [8864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9573),
  [8870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9336),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9828),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9308),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9337),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [8884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9311),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9307),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10273),
  [8892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9317),
  [8894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11611),
  [8896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3832),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19556),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14345),
  [8902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6210),
  [8904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11648),
  [8906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6241),
  [8908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6254),
  [8910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14377),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14344),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10395),
  [8916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6288),
  [8918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14333),
  [8920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14336),
  [8922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6296),
  [8924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6327),
  [8926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14343),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14346),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11589),
  [8932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [8934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14342),
  [8936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11185),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11633),
  [8940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10278),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [8944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6207),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10512),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10262),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10252),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10249),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10205),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10214),
  [8968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18205),
  [8974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10275),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11573),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [8980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5528),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10123),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10132),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11042),
  [8990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10135),
  [8996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [8998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [9000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5565),
  [9002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10143),
  [9004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10145),
  [9006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [9008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [9010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [9012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [9014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4398),
  [9016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5714),
  [9018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11775),
  [9020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9880),
  [9022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5953),
  [9024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10771),
  [9026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10138),
  [9028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9649),
  [9030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9654),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [9034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [9036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9651),
  [9038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [9040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [9042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10793),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9637),
  [9046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9645),
  [9048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5249),
  [9050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [9052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10165),
  [9054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10063),
  [9056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [9058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11749),
  [9060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11626),
  [9062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [9064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5941),
  [9066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9638),
  [9068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9588),
  [9070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9562),
  [9072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5853),
  [9074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [9076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11799),
  [9078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9572),
  [9080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [9082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [9084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [9086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9581),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9592),
  [9090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [9092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9619),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10593),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11759),
  [9102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10065),
  [9104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9590),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11161),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10989),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11582),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10073),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11171),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10075),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10074),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5129),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10951),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10955),
  [9128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10077),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10078),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9576),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10120),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6468),
  [9140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11669),
  [9142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10601),
  [9144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5933),
  [9146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11180),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5531),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5542),
  [9152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [9154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10622),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6264),
  [9158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10628),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10625),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5952),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5567),
  [9166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [9168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10650),
  [9170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10652),
  [9172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11078),
  [9174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [9176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10660),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10208),
  [9180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11764),
  [9182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [9184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [9186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5712),
  [9188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5700),
  [9190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [9192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [9194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6493),
  [9196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [9198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [9200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [9202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5742),
  [9206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5786),
  [9208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5791),
  [9210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4759),
  [9214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [9216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10464),
  [9218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [9220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11714),
  [9222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4782),
  [9224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10649),
  [9226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5939),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10772),
  [9230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10826),
  [9232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10241),
  [9234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4794),
  [9236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [9238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4802),
  [9240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4798),
  [9242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10664),
  [9244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10795),
  [9246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10842),
  [9248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [9250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [9252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [9254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4828),
  [9256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [9258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [9260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11595),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10480),
  [9264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6025),
  [9266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10769),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5949),
  [9270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10326),
  [9276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10328),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10327),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6033),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [9284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10337),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10338),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10803),
  [9292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10344),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10066),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11750),
  [9300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [9304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11754),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11760),
  [9308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [9310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [9312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10140),
  [9314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11801),
  [9316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [9318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [9320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11721),
  [9322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9921),
  [9324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11835),
  [9326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [9328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4840),
  [9330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [9332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4874),
  [9334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4842),
  [9336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14476),
  [9338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11574),
  [9340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6081),
  [9342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6624),
  [9344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6483),
  [9346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6491),
  [9348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10090),
  [9350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [9352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6508),
  [9354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6097),
  [9356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [9358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6510),
  [9360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6515),
  [9362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6102),
  [9364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6103),
  [9366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6529),
  [9368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9901),
  [9370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6104),
  [9372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9441),
  [9374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11698),
  [9376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [9378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10202),
  [9380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10209),
  [9382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10212),
  [9384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14503),
  [9386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [9388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9628),
  [9390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10221),
  [9392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [9394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4884),
  [9396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10223),
  [9398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10226),
  [9400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [9402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [9404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10230),
  [9406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9357),
  [9408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4888),
  [9410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9404),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11765),
  [9414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9974),
  [9416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [9418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [9420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9438),
  [9424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10004),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5503),
  [9428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10009),
  [9430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10005),
  [9432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [9434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [9436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10037),
  [9438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9952),
  [9440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5517),
  [9442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10438),
  [9444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9865),
  [9446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11523),
  [9448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11571),
  [9450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9390),
  [9452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10060),
  [9454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10067),
  [9456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10076),
  [9458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9361),
  [9460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9403),
  [9462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9566),
  [9464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10093),
  [9466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9411),
  [9468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9405),
  [9470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10096),
  [9472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10098),
  [9474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9360),
  [9476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9373),
  [9478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10109),
  [9480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [9482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9381),
  [9484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10686),
  [9486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11665),
  [9488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10440),
  [9490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14475),
  [9492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14477),
  [9494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14480),
  [9496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11540),
  [9498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10452),
  [9500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14487),
  [9502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10460),
  [9504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10459),
  [9506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14489),
  [9508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14491),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10489),
  [9512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10490),
  [9514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14496),
  [9516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [9518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10499),
  [9520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11744),
  [9522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5890),
  [9524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9439),
  [9526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9444),
  [9528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9604),
  [9530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10889),
  [9532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11798),
  [9534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5900),
  [9536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11081),
  [9538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9461),
  [9540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5904),
  [9542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5902),
  [9544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9474),
  [9546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9617),
  [9548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [9550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5915),
  [9552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9436),
  [9554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10988),
  [9556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5921),
  [9558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6315),
  [9560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11823),
  [9562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9992),
  [9564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [9566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9377),
  [9568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9416),
  [9570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9443),
  [9572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5553),
  [9574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [9576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9383),
  [9578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [9580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [9582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9385),
  [9584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9452),
  [9586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [9588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [9590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9395),
  [9592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [9594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [9596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6853),
  [9598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11773),
  [9600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11049),
  [9602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11512),
  [9604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11524),
  [9606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9408),
  [9608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6289),
  [9610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10970),
  [9612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [9614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11455),
  [9616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10996),
  [9618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10993),
  [9620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11442),
  [9622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9354),
  [9624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11046),
  [9626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11050),
  [9628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11525),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [9632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11065),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [9636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11597),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10680),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10687),
  [9644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11552),
  [9646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7154),
  [9648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [9650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10709),
  [9652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [9654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [9656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10711),
  [9658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11541),
  [9660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [9662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [9664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10744),
  [9666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [9668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [9670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5056),
  [9672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11641),
  [9674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9956),
  [9676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [9678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6314),
  [9680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [9682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10897),
  [9684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [9686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [9688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [9690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6329),
  [9692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [9694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [9696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6331),
  [9698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10921),
  [9700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [9702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [9704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6339),
  [9706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11771),
  [9708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4965),
  [9710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11673),
  [9712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [9714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6852),
  [9716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6855),
  [9718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6355),
  [9720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5026),
  [9722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [9724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6870),
  [9726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [9728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [9730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6875),
  [9732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [9734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [9736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [9738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6887),
  [9740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [9742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [9744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11303),
  [9746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11747),
  [9748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11793),
  [9750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6677),
  [9752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6679),
  [9754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6945),
  [9756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10776),
  [9758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11769),
  [9760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10790),
  [9762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6686),
  [9764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11800),
  [9766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11782),
  [9768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6688),
  [9770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6968),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11606),
  [9774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11607),
  [9776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6693),
  [9778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [9780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11645),
  [9782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11826),
  [9784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [9786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [9788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5057),
  [9790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6724),
  [9792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11308),
  [9794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [9796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [9798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [9800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [9802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [9804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6740),
  [9806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [9808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [9810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [9812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [9814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [9816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6230),
  [9818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11578),
  [9820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [9822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11302),
  [9824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11304),
  [9826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [9828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5773),
  [9830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [9832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [9834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11314),
  [9836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [9838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [9840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11316),
  [9842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [9844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [9846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [9848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11322),
  [9850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10543),
  [9852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [9854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11865),
  [9856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11605),
  [9858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [9860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [9862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [9864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11335),
  [9866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6404),
  [9868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [9870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [9872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [9874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [9876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11337),
  [9878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [9880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [9882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [9884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [9886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [9888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8111),
  [9890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11662),
  [9892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10545),
  [9894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [9896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5935),
  [9898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [9900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11997),
  [9902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10556),
  [9904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [9906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10558),
  [9908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10557),
  [9910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5955),
  [9912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [9914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [9916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10561),
  [9918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10570),
  [9920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [9922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [9924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10575),
  [9926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7611),
  [9928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11756),
  [9930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [9932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6209),
  [9934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6265),
  [9936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [9938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8654),
  [9940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [9942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6202),
  [9944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [9946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [9948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6215),
  [9950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [9952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [9954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [9956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6005),
  [9958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [9960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [9962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6057),
  [9964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11788),
  [9966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11805),
  [9968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [9970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11978),
  [9972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11923),
  [9974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6221),
  [9976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7587),
  [9978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [9980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10220),
  [9982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12064),
  [9984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [9986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5792),
  [9988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12005),
  [9990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6261),
  [9992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5240),
  [9994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [9996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12145),
  [9998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [10000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [10002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6903),
  [10004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11814),
  [10006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [10008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8109),
  [10010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8113),
  [10012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11981),
  [10014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6454),
  [10016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [10018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8121),
  [10020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [10022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [10024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8123),
  [10026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11983),
  [10028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [10030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [10032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8128),
  [10034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10497),
  [10036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [10038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [10040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11596),
  [10042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [10044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7610),
  [10046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7612),
  [10048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8160),
  [10050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [10052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [10054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [10056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7620),
  [10058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4733),
  [10060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [10062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7622),
  [10064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8170),
  [10066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [10068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4762),
  [10070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7627),
  [10072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [10074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4768),
  [10076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [10078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11741),
  [10080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10511),
  [10082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6053),
  [10084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6059),
  [10086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7638),
  [10088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6759),
  [10090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10322),
  [10092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6084),
  [10094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10324),
  [10096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10323),
  [10098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6089),
  [10100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7645),
  [10102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10330),
  [10104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10331),
  [10106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6152),
  [10108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [10110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10335),
  [10112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7678),
  [10114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11680),
  [10116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [10118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7146),
  [10120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6905),
  [10122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6282),
  [10124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [10126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [10128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10092),
  [10130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7136),
  [10132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [10134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [10136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7149),
  [10138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5598),
  [10140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6319),
  [10142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [10144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [10146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [10148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [10150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [10152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6893),
  [10154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11655),
  [10156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [10158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6760),
  [10160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6764),
  [10162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7121),
  [10164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7657),
  [10166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [10168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6791),
  [10170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [10172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [10174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6808),
  [10176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7249),
  [10178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [10180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6634),
  [10184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10990),
  [10186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [10188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5404),
  [10190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11682),
  [10192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [10194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [10196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [10198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [10200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [10202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [10204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14486),
  [10206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [10208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [10210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5475),
  [10212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [10214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6825),
  [10216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5318),
  [10218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [10220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [10222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [10224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [10226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11703),
  [10228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11837),
  [10230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11031),
  [10232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7677),
  [10234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7679),
  [10236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [10238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [10240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11182),
  [10242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7685),
  [10244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10941),
  [10246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11077),
  [10248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7687),
  [10250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [10252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11000),
  [10254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11002),
  [10256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7692),
  [10258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [10260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11037),
  [10262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11090),
  [10264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11732),
  [10266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5572),
  [10268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6884),
  [10270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6895),
  [10272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14431),
  [10274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11709),
  [10276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5638),
  [10278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9457),
  [10280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7013),
  [10282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [10284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5643),
  [10286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7021),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14433),
  [10290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [10292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5670),
  [10294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [10296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10740),
  [10298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [10300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11617),
  [10302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [10304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5403),
  [10306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [10308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7709),
  [10310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11094),
  [10312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [10314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5433),
  [10316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [10318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [10320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5435),
  [10322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7713),
  [10324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [10326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [10328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5441),
  [10330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6069),
  [10332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [10334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [10336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10743),
  [10338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11701),
  [10340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11704),
  [10342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7213),
  [10344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [10346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10775),
  [10348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9419),
  [10350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11717),
  [10352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10785),
  [10354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10780),
  [10356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11719),
  [10358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7031),
  [10360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10816),
  [10362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10817),
  [10364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11727),
  [10366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5651),
  [10368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10823),
  [10370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6072),
  [10372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11089),
  [10374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11091),
  [10376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [10378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5425),
  [10380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6086),
  [10382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11101),
  [10384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6092),
  [10386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6088),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11103),
  [10390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5669),
  [10392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6100),
  [10394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6101),
  [10396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11107),
  [10398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [10400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6158),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [10406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5602),
  [10408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11743),
  [10410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [10412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [10414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11550),
  [10416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [10418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [10420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5663),
  [10422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5624),
  [10424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11748),
  [10426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [10428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [10430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [10432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [10434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7754),
  [10436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6155),
  [10438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6162),
  [10440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11116),
  [10442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6166),
  [10444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6182),
  [10446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6184),
  [10448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11117),
  [10450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6194),
  [10452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6998),
  [10454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5711),
  [10456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [10458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [10460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7741),
  [10462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10708),
  [10464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [10466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5749),
  [10468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [10470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5842),
  [10472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7753),
  [10474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7755),
  [10476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6242),
  [10478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7153),
  [10480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7762),
  [10482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7764),
  [10484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6246),
  [10486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7768),
  [10488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6949),
  [10490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6996),
  [10492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7002),
  [10494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [10496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5814),
  [10498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6326),
  [10500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7105),
  [10502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7111),
  [10504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5825),
  [10506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7125),
  [10508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6717),
  [10510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [10512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5843),
  [10514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7792),
  [10516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7257),
  [10518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5855),
  [10520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5857),
  [10522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7795),
  [10524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5862),
  [10526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4791),
  [10528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5944),
  [10530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10636),
  [10532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10655),
  [10534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [10536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6669),
  [10538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6868),
  [10540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10670),
  [10542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6927),
  [10544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10679),
  [10546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7871),
  [10548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [10550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6950),
  [10552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5884),
  [10554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4776),
  [10556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [10558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6971),
  [10560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5897),
  [10562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [10564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7201),
  [10566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6716),
  [10568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6718),
  [10570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10887),
  [10572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7842),
  [10574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [10576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6727),
  [10578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6730),
  [10580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10918),
  [10582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6734),
  [10584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5277),
  [10586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4790),
  [10588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [10590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7102),
  [10592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7103),
  [10594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [10596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [10598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7124),
  [10600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4807),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7870),
  [10604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7872),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [10608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5238),
  [10610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5067),
  [10612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7879),
  [10614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7881),
  [10616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [10618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7885),
  [10620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5978),
  [10622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7200),
  [10624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7202),
  [10626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [10628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [10630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [10632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7219),
  [10634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [10636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [10638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [10640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5278),
  [10642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7926),
  [10644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6455),
  [10646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11313),
  [10648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5284),
  [10650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5286),
  [10652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7928),
  [10654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5290),
  [10656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11262),
  [10658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5977),
  [10660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5979),
  [10662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6954),
  [10664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10797),
  [10666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5988),
  [10668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [10670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [10672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5995),
  [10674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7976),
  [10676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11261),
  [10678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11263),
  [10680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [10682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11266),
  [10684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [10686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11274),
  [10688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11276),
  [10690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [10692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11282),
  [10694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [10696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6024),
  [10698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6026),
  [10700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6029),
  [10702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7962),
  [10704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6035),
  [10706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6039),
  [10708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6043),
  [10710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5365),
  [10712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7975),
  [10714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7977),
  [10716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11310),
  [10718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7191),
  [10720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [10722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7984),
  [10724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7986),
  [10726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11323),
  [10728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7990),
  [10730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11817),
  [10732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6877),
  [10734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6885),
  [10736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6054),
  [10738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [10740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [10742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7003),
  [10744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6056),
  [10746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7061),
  [10748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10950),
  [10750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [10752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [10754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8007),
  [10756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11777),
  [10758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6178),
  [10760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [10762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [10764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8009),
  [10766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5381),
  [10768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11816),
  [10770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11818),
  [10772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6865),
  [10774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11153),
  [10776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11746),
  [10778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11830),
  [10780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6915),
  [10782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11627),
  [10784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6534),
  [10786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10949),
  [10788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10952),
  [10790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [10792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6098),
  [10794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12055),
  [10796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10965),
  [10798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10971),
  [10800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5402),
  [10802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10975),
  [10804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18085),
  [10806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6533),
  [10808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6535),
  [10810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11742),
  [10812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [10814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6546),
  [10816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [10818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11564),
  [10820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [10822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8626),
  [10824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18083),
  [10826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18086),
  [10828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11129),
  [10830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18142),
  [10832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8120),
  [10834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17354),
  [10836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17598),
  [10838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11135),
  [10840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17930),
  [10842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8050),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8625),
  [10846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8627),
  [10848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6568),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8630),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8635),
  [10854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8637),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6570),
  [10858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8646),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [10862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8049),
  [10864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8051),
  [10866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8680),
  [10868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8055),
  [10870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7619),
  [10872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8060),
  [10874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8062),
  [10876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8688),
  [10878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8066),
  [10880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6129),
  [10882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6131),
  [10884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8072),
  [10886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [10888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6139),
  [10890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6141),
  [10892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8073),
  [10894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [10896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6157),
  [10898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6082),
  [10900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [10902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7135),
  [10904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6784),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7684),
  [10910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7009),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5432),
  [10914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11716),
  [10916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11100),
  [10918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6179),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [10924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7761),
  [10926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7074),
  [10928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5852),
  [10930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10663),
  [10932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6961),
  [10934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6726),
  [10936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [10938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7878),
  [10940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7215),
  [10942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5283),
  [10944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [10946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11273),
  [10948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6032),
  [10950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7983),
  [10952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6982),
  [10954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [10956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11620),
  [10958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10964),
  [10960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6545),
  [10962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17344),
  [10964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8634),
  [10966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8059),
  [10968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6138),
  [10970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11585),
  [10972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11623),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11737),
  [10976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11603),
  [10978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11624),
  [10980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10182),
  [10982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11428),
  [10984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11395),
  [10986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12117),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6742),
  [10990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [10992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11247),
  [10994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [10996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11208),
  [10998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10701),
  [11000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11420),
  [11002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [11004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [11006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [11008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6362),
  [11010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [11012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [11014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [11016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10995),
  [11018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5970),
  [11020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [11022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10991),
  [11024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [11026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [11028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10533),
  [11030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11006),
  [11032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [11034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [11036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11360),
  [11038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10847),
  [11040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11202),
  [11042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [11044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [11046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [11048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11148),
  [11050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6370),
  [11052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [11054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [11056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5858),
  [11058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6371),
  [11060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [11062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11397),
  [11064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [11066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6106),
  [11068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11239),
  [11070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [11072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11154),
  [11074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [11076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11317),
  [11078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [11080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11144),
  [11082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11173),
  [11084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6373),
  [11088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [11090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5341),
  [11092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10877),
  [11094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6590),
  [11096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [11098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11207),
  [11100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [11102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [11104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [11106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6554),
  [11108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [11110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [11112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(4485),
  [11115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10031),
  [11118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1277),
  [11121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(785),
  [11124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1533),
  [11127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(12584),
  [11130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14207),
  [11133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5738),
  [11136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5794),
  [11139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(11656),
  [11142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14677),
  [11145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14678),
  [11148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(4341),
  [11151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9977),
  [11154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1283),
  [11157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(912),
  [11160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1621),
  [11163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(12375),
  [11166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5204),
  [11169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5581),
  [11172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14622),
  [11175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14623),
  [11178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(4452),
  [11181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9863),
  [11184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1039),
  [11187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(837),
  [11190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1595),
  [11193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(12449),
  [11196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5835),
  [11199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5821),
  [11202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14620),
  [11205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14621),
  [11208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(4905),
  [11211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10001),
  [11214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1290),
  [11217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(790),
  [11220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1544),
  [11223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(12591),
  [11226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6386),
  [11229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6232),
  [11232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14689),
  [11235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14690),
  [11238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(4822),
  [11241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9933),
  [11244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1103),
  [11247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(869),
  [11250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1606),
  [11253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(12487),
  [11256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14207),
  [11259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6219),
  [11262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6153),
  [11265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(11656),
  [11268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(15069),
  [11271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(15070),
  [11274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(4860),
  [11277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9886),
  [11280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1162),
  [11283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(843),
  [11286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1642),
  [11289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(12544),
  [11292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6278),
  [11295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6395),
  [11298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14976),
  [11301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14977),
  [11304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(4922),
  [11307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10026),
  [11310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1356),
  [11313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(850),
  [11316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1503),
  [11319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(12245),
  [11322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6425),
  [11325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6380),
  [11328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14819),
  [11331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14820),
  [11334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5763),
  [11337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9955),
  [11340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(986),
  [11343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(802),
  [11346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1581),
  [11349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(12435),
  [11352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6625),
  [11355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6579),
  [11358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14898),
  [11361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14899),
  [11364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5543),
  [11367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9896),
  [11370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1413),
  [11373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(890),
  [11376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1566),
  [11379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(12658),
  [11382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6517),
  [11385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6605),
  [11388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14891),
  [11391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(14892),
  [11394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(4485),
  [11397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [11399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10031),
  [11402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1277),
  [11405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(785),
  [11408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [11410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1533),
  [11413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(12584),
  [11416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14207),
  [11419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5738),
  [11422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5794),
  [11425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(11656),
  [11428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14677),
  [11431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14678),
  [11434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(4341),
  [11437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9977),
  [11440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1283),
  [11443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(912),
  [11446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1621),
  [11449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(12375),
  [11452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5204),
  [11455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5581),
  [11458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14622),
  [11461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14623),
  [11464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(4452),
  [11467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9863),
  [11470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1039),
  [11473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(837),
  [11476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1595),
  [11479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(12449),
  [11482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5835),
  [11485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5821),
  [11488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14620),
  [11491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14621),
  [11494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(4905),
  [11497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10001),
  [11500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1290),
  [11503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(790),
  [11506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1544),
  [11509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(12591),
  [11512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6386),
  [11515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6232),
  [11518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14689),
  [11521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14690),
  [11524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(4860),
  [11527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9886),
  [11530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1162),
  [11533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(843),
  [11536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1642),
  [11539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(12544),
  [11542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6278),
  [11545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6395),
  [11548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14976),
  [11551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14977),
  [11554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(4822),
  [11557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9933),
  [11560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1103),
  [11563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(869),
  [11566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1606),
  [11569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(12487),
  [11572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14207),
  [11575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6219),
  [11578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6153),
  [11581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(11656),
  [11584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(15069),
  [11587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(15070),
  [11590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(4922),
  [11593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10026),
  [11596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1356),
  [11599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(850),
  [11602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1503),
  [11605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(12245),
  [11608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6425),
  [11611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6380),
  [11614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14819),
  [11617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14820),
  [11620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5763),
  [11623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9955),
  [11626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(986),
  [11629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(802),
  [11632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1581),
  [11635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(12435),
  [11638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6625),
  [11641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6579),
  [11644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14898),
  [11647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14899),
  [11650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5543),
  [11653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9896),
  [11656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1413),
  [11659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(890),
  [11662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1566),
  [11665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(12658),
  [11668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6517),
  [11671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6605),
  [11674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14891),
  [11677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(14892),
  [11680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 1),
  [11682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4301),
  [11684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 1),
  [11686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4934),
  [11688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4939),
  [11690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4511),
  [11692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4941),
  [11694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4966),
  [11696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16715),
  [11698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15181),
  [11700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17718),
  [11702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4292),
  [11704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4972),
  [11706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4844),
  [11708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4473),
  [11710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4846),
  [11712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4847),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17288),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15261),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17462),
  [11720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4325),
  [11722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5091),
  [11724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4763),
  [11726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4460),
  [11728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4765),
  [11730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4745),
  [11732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16799),
  [11734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15389),
  [11736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17541),
  [11738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4465),
  [11740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5438),
  [11742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5813),
  [11744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5813),
  [11746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5089),
  [11748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [11750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5438),
  [11752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [11754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5891),
  [11756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17209),
  [11758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15231),
  [11760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17646),
  [11762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4493),
  [11764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5911),
  [11766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5386),
  [11768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4866),
  [11770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5387),
  [11772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5347),
  [11774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16840),
  [11776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15381),
  [11778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17850),
  [11780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4486),
  [11782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5946),
  [11784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5869),
  [11786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4773),
  [11788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5871),
  [11790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5872),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17046),
  [11794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15200),
  [11796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17604),
  [11798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4475),
  [11800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5411),
  [11802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5552),
  [11804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4928),
  [11806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5560),
  [11808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5464),
  [11810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16816),
  [11812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15458),
  [11814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17595),
  [11816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4923),
  [11818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6258),
  [11820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6164),
  [11822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5469),
  [11824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6168),
  [11826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6161),
  [11828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17214),
  [11830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15250),
  [11832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17534),
  [11834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4588),
  [11836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6403),
  [11838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6445),
  [11840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5934),
  [11842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6447),
  [11844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6448),
  [11846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16880),
  [11848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15184),
  [11850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18042),
  [11852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [11854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16230),
  [11856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16231),
  [11858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2677),
  [11860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16304),
  [11862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16315),
  [11864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0),
  [11866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0),
  [11868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [11870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [11872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16212),
  [11874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16214),
  [11876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [11878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [11880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16085),
  [11882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16088),
  [11884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15712),
  [11886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15713),
  [11888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_expression, 2, 0, 0),
  [11890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_expression, 2, 0, 0),
  [11892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation_expression, 2, 0, 0),
  [11894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_expression, 2, 0, 0),
  [11896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 0),
  [11898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 0),
  [11900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [11902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_broadcast_call_expression, 4, 0, 0),
  [11904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_broadcast_call_expression, 4, 0, 0),
  [11906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [11908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [11910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15926),
  [11912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15927),
  [11914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closed_macrocall_expression, 5, 0, 0),
  [11916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closed_macrocall_expression, 5, 0, 0),
  [11918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [11920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [11922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [11924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15887),
  [11926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15888),
  [11928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 8),
  [11930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 8),
  [11932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closed_macrocall_expression, 3, 0, 0),
  [11934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closed_macrocall_expression, 3, 0, 0),
  [11936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [11938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [11940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16487),
  [11942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16491),
  [11944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [11946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [11948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15863),
  [11950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15868),
  [11952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2397),
  [11954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2819),
  [11956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_command_literal, 3, 0, 9),
  [11958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_command_literal, 3, 0, 9),
  [11960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15858),
  [11962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15859),
  [11964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [11966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15901),
  [11968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15902),
  [11970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16561),
  [11972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16562),
  [11974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [11976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [11978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [11980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [11982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [11984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 6),
  [11986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 6),
  [11988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 13),
  [11990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 13),
  [11992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_string_literal, 3, 0, 9),
  [11994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_string_literal, 3, 0, 9),
  [11996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 6),
  [11998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 6),
  [12000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [12002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_string_literal, 4, 0, 9),
  [12004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_string_literal, 4, 0, 9),
  [12006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_command_literal, 4, 0, 9),
  [12008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_command_literal, 4, 0, 9),
  [12010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15940),
  [12012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15941),
  [12014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [12016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15466),
  [12018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15536),
  [12020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [12022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [12024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 13),
  [12026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 13),
  [12028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 0),
  [12030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 0),
  [12032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 6),
  [12034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 6),
  [12036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 6, 0, 13),
  [12038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 6, 0, 13),
  [12040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 6, 0, 0),
  [12042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 6, 0, 0),
  [12044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [12046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [12048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 7, 0, 0),
  [12050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 7, 0, 0),
  [12052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, 0, 0),
  [12054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, 0, 0),
  [12056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 2, 0, 0),
  [12058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 2, 0, 0),
  [12060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [12062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [12064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [12066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [12068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [12070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [12072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [12074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [12076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15984),
  [12078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15985),
  [12080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [12082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16593),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16600),
  [12086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1635),
  [12088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15780),
  [12092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15781),
  [12094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer_literal, 1, 0, 0),
  [12096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer_literal, 1, 0, 0),
  [12098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4755),
  [12100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [12102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [12104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [12106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [12108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15968),
  [12110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15969),
  [12112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4825),
  [12114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4848),
  [12116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4863),
  [12118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4945),
  [12120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [12122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15790),
  [12124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15791),
  [12126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [12128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [12130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [12132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [12134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [12136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_broadcast_call_expression, 5, 0, 0),
  [12138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_broadcast_call_expression, 5, 0, 0),
  [12140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comprehension_expression, 5, 0, 0),
  [12142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comprehension_expression, 5, 0, 0),
  [12144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_expression, 5, 0, 0),
  [12146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_expression, 5, 0, 0),
  [12148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_expression, 5, 0, 0),
  [12150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_expression, 5, 0, 0),
  [12152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_expression, 5, 0, 0),
  [12154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_expression, 5, 0, 0),
  [12156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_string_literal, 5, 0, 19),
  [12158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_string_literal, 5, 0, 19),
  [12160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_command_literal, 5, 0, 19),
  [12162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_command_literal, 5, 0, 19),
  [12164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 6, 0, 0),
  [12166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 6, 0, 0),
  [12168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_expression, 6, 0, 0),
  [12170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_expression, 6, 0, 0),
  [12172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closed_macrocall_expression, 6, 0, 0),
  [12174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closed_macrocall_expression, 6, 0, 0),
  [12176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_expression, 7, 0, 0),
  [12178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_expression, 7, 0, 0),
  [12180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4652),
  [12182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14240),
  [12184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3308),
  [12186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17779),
  [12188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15232),
  [12190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17780),
  [12192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [12194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_expression, 3, 0, 0),
  [12196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_expression, 3, 0, 0),
  [12198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4988),
  [12200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14286),
  [12202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17555),
  [12204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15329),
  [12206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17886),
  [12208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 6, 0, 0),
  [12210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 6, 0, 0),
  [12212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_clause, 3, 0, 0),
  [12214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_clause, 3, 0, 0),
  [12216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_clause, 4, 0, 0),
  [12218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_clause, 4, 0, 0),
  [12220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [12222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4665),
  [12224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14304),
  [12226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3987),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17715),
  [12230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15397),
  [12232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17739),
  [12234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [12236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [12238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_literal, 2, 0, 0),
  [12240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_literal, 2, 0, 0),
  [12242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_expression, 2, 0, 0),
  [12244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_expression, 2, 0, 0),
  [12246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [12248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [12250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_literal, 3, 0, 0),
  [12252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_literal, 3, 0, 0),
  [12254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_expression, 3, 0, 0),
  [12256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_expression, 3, 0, 0),
  [12258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_expression, 3, 0, 0),
  [12260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_expression, 3, 0, 0),
  [12262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_expression, 4, 0, 0),
  [12264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_expression, 4, 0, 0),
  [12266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comprehension_expression, 4, 0, 0),
  [12268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comprehension_expression, 4, 0, 0),
  [12270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_expression, 4, 0, 0),
  [12272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_expression, 4, 0, 0),
  [12274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_string_literal, 4, 0, 14),
  [12276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_string_literal, 4, 0, 14),
  [12278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_command_literal, 4, 0, 14),
  [12280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_command_literal, 4, 0, 14),
  [12282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 5, 0, 0),
  [12284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 5, 0, 0),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15878),
  [12288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15879),
  [12290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_expression, 2, 0, 0),
  [12292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_expression, 2, 0, 0),
  [12294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15500),
  [12296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15501),
  [12298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_expression, 3, 0, 0),
  [12300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_expression, 3, 0, 0),
  [12302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_expression, 4, 0, 0),
  [12304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_expression, 4, 0, 0),
  [12306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_adjoint_expression, 2, 0, 0),
  [12308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_adjoint_expression, 2, 0, 0),
  [12310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5524),
  [12312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4663),
  [12314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14245),
  [12316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17869),
  [12318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15295),
  [12320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17870),
  [12322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_expression, 3, 0, 0),
  [12324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_expression, 3, 0, 0),
  [12326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [12328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [12330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15689),
  [12332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15690),
  [12334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_expression, 5, 0, 15),
  [12336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_expression, 5, 0, 15),
  [12338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 3, 0, 0),
  [12340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 3, 0, 0),
  [12342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parametrized_type_expression, 3, 0, 0),
  [12344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parametrized_type_expression, 3, 0, 0),
  [12346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15577),
  [12348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15578),
  [12350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [12352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16032),
  [12354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16033),
  [12356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15959),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15960),
  [12360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, 0, 0),
  [12362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, 0, 0),
  [12364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closed_macrocall_expression, 4, 0, 0),
  [12366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closed_macrocall_expression, 4, 0, 0),
  [12368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [12370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5014),
  [12372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14268),
  [12374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3576),
  [12376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17434),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15410),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17545),
  [12382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [12384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float_literal, 1, 0, 0),
  [12386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float_literal, 1, 0, 0),
  [12388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float_literal, 2, 0, 0),
  [12390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float_literal, 2, 0, 0),
  [12392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5873),
  [12394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5487),
  [12396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5321),
  [12398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5349),
  [12400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5391),
  [12402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5399),
  [12404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5416),
  [12406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5444),
  [12408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [12410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_typed_expression, 2, 0, 0),
  [12412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [12414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5586),
  [12416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [12418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [12420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14250),
  [12422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [12424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [12428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14246),
  [12430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [12432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4677),
  [12434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14259),
  [12436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17901),
  [12438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15405),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18045),
  [12442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [12444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5827),
  [12446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [12448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [12450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [12452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14308),
  [12454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [12456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [12458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16001),
  [12460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16002),
  [12462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [12464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5476),
  [12466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14274),
  [12468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3929),
  [12470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17352),
  [12472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15201),
  [12474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17519),
  [12476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_typed_expression, 2, 0, 0),
  [12478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5617),
  [12480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14320),
  [12482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17607),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15205),
  [12486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17612),
  [12488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6385),
  [12490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5319),
  [12492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14278),
  [12494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17796),
  [12496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15225),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17341),
  [12500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6432),
  [12502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5314),
  [12504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14293),
  [12506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3708),
  [12508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17916),
  [12510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15447),
  [12512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17919),
  [12514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6064),
  [12516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14237),
  [12518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3485),
  [12520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6123),
  [12522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5587),
  [12524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14299),
  [12526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17629),
  [12528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15379),
  [12530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17636),
  [12532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6169),
  [12534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5695),
  [12536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14277),
  [12538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17726),
  [12540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15460),
  [12542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17733),
  [12544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6188),
  [12546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [12548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5894),
  [12550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14266),
  [12552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17815),
  [12554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15323),
  [12556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17816),
  [12558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_juxtaposition_expression, 2, 0, 0),
  [12560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_juxtaposition_expression, 2, 0, 0),
  [12562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2649),
  [12564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5745),
  [12566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14297),
  [12568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3587),
  [12570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17544),
  [12572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15206),
  [12574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17614),
  [12576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16173),
  [12578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16174),
  [12580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [12582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5271),
  [12584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14257),
  [12586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18111),
  [12588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15451),
  [12590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18115),
  [12592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6238),
  [12594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5527),
  [12596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14295),
  [12598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17453),
  [12600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15262),
  [12602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17456),
  [12604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14242),
  [12606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3608),
  [12608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6275),
  [12610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2863),
  [12612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14271),
  [12614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3869),
  [12616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4229),
  [12618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 0),
  [12620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 0),
  [12622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5657),
  [12624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14254),
  [12626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [12628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17659),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15241),
  [12632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17661),
  [12634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6434),
  [12636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14296),
  [12638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17613),
  [12640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15244),
  [12642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17666),
  [12644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6191),
  [12646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14243),
  [12648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17759),
  [12650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15363),
  [12652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17905),
  [12654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6214),
  [12656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14247),
  [12658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3811),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17609),
  [12662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15316),
  [12664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17610),
  [12666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6303),
  [12668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14323),
  [12670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17855),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15272),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17558),
  [12676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_identifier, 2, 0, 0),
  [12678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_identifier, 2, 0, 0),
  [12680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14740),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15823),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15824),
  [12686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6616),
  [12688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6394),
  [12690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14302),
  [12692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4215),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17375),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15263),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17377),
  [12700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6216),
  [12702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14273),
  [12704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17472),
  [12706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15353),
  [12708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17476),
  [12710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15922),
  [12712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15923),
  [12714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1676),
  [12716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14248),
  [12718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3873),
  [12720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15695),
  [12722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15696),
  [12724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [12726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14309),
  [12728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4013),
  [12730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6593),
  [12732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [12734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14255),
  [12736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3448),
  [12738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6320),
  [12740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14261),
  [12742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18119),
  [12744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15220),
  [12746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18120),
  [12748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6001),
  [12750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14258),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17439),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15251),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17441),
  [12758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15018),
  [12760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15004),
  [12762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3246),
  [12764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6756),
  [12766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15917),
  [12768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15918),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15758),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15759),
  [12774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14981),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15679),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15680),
  [12780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4088),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15980),
  [12784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15981),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15895),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15896),
  [12790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [12792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14315),
  [12794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3305),
  [12796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6506),
  [12798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14264),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17593),
  [12802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15385),
  [12804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17678),
  [12806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14828),
  [12808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6524),
  [12810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14301),
  [12812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17959),
  [12814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15421),
  [12816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17966),
  [12818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14252),
  [12820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3526),
  [12822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15935),
  [12824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15936),
  [12826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6810),
  [12828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15054),
  [12830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6663),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15763),
  [12834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15764),
  [12836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15059),
  [12838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3240),
  [12840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4035),
  [12842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16027),
  [12844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16028),
  [12846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 2, 0, 0),
  [12848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 2, 0, 0),
  [12850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14942),
  [12852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15746),
  [12854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15747),
  [12856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14796),
  [12858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15930),
  [12860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15931),
  [12862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_list, 1, 0, 0),
  [12864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12442),
  [12866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14119),
  [12868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 1, 0, 0),
  [12870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15891),
  [12872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15892),
  [12874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7237),
  [12876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4222),
  [12878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15554),
  [12880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15555),
  [12882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__importable, 1, 0, 0),
  [12884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__importable, 1, 0, 0),
  [12886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exportable, 1, 0, 0),
  [12888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exportable, 1, 0, 0),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15976),
  [12892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15977),
  [12894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7199),
  [12896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12570),
  [12898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14010),
  [12900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15152),
  [12902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7017),
  [12904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7262),
  [12906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14986),
  [12908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7073),
  [12910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7244),
  [12912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11895),
  [12914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15089),
  [12916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12753),
  [12918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14109),
  [12920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11957),
  [12922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7010),
  [12924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12074),
  [12926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_statement, 2, 0, 0),
  [12928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3357),
  [12930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [12932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3932),
  [12934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_statement, 2, 0, 0),
  [12936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3933),
  [12938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9767),
  [12940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3197),
  [12942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [12944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [12946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3934),
  [12948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3935),
  [12950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3436),
  [12952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [12954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [12956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3439),
  [12958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [12960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [12962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [12964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3443),
  [12966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14590),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16023),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16024),
  [12972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0),
  [12974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0),
  [12976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14008),
  [12979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0),
  [12981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0),
  [12983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7299),
  [12985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9949),
  [12987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9897),
  [12989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [12991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [12993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [12995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12762),
  [12997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14207),
  [12999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10161),
  [13001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11363),
  [13003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14547),
  [13005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14880),
  [13007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12570),
  [13010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15028),
  [13012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12688),
  [13014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14086),
  [13016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12187),
  [13018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7596),
  [13020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12786),
  [13022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14030),
  [13024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11886),
  [13026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12851),
  [13028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14101),
  [13030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11936),
  [13032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15178),
  [13034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15116),
  [13036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exportable, 3, 0, 0),
  [13038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exportable, 3, 0, 0),
  [13040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10833),
  [13042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9965),
  [13044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [13046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [13048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [13050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12645),
  [13052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11219),
  [13054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11344),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14829),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14830),
  [13060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, 0, 0),
  [13062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14112),
  [13064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, 0, 0),
  [13066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_list, 2, 0, 0),
  [13068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, 0, 0),
  [13070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0),
  [13072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3395),
  [13075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0),
  [13077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14112),
  [13080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12442),
  [13083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14107),
  [13086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14901),
  [13088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14687),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12595),
  [13092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14079),
  [13094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, 0, 0),
  [13096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [13098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3400),
  [13100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, 0, 0),
  [13102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3404),
  [13104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9790),
  [13106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7395),
  [13108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3213),
  [13110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3406),
  [13112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3407),
  [13114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3411),
  [13116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [13118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3419),
  [13120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3420),
  [13122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [13124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3425),
  [13126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3427),
  [13128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3431),
  [13130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [13132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7831),
  [13134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7824),
  [13136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9916),
  [13138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12779),
  [13140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11287),
  [13142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7651),
  [13144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, 0, 0),
  [13146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, 0, 0),
  [13148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_open_tuple, 2, 0, 0),
  [13150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_open_tuple, 2, 0, 0),
  [13152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3821),
  [13154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12753),
  [13157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15538),
  [13159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15539),
  [13161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14008),
  [13163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3357),
  [13166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8082),
  [13168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14107),
  [13170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10550),
  [13172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9950),
  [13174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [13176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [13178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [13180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12508),
  [13182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11195),
  [13184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11232),
  [13186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14924),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15123),
  [13190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14857),
  [13192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11870),
  [13194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3395),
  [13196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3821),
  [13199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 1, 0, 0),
  [13201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 1, 0, 0),
  [13203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3361),
  [13205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3363),
  [13207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3364),
  [13209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9765),
  [13211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7744),
  [13213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [13215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4206),
  [13217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4207),
  [13219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3368),
  [13221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [13223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4212),
  [13225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4214),
  [13227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4216),
  [13229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4217),
  [13231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4218),
  [13233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4219),
  [13235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4220),
  [13237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4221),
  [13239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [13241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [13243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_statement, 2, 0, 0),
  [13245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 2, 0, 0),
  [13247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 7),
  [13249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 3, 0, 7),
  [13251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [13253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 3, 0, 0),
  [13255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 3, 0, 0),
  [13257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 5, 0, 16),
  [13259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 5, 0, 16),
  [13261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8474),
  [13263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0),
  [13265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [13267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(3149),
  [13270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14378),
  [13272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16751),
  [13275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3172),
  [13277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16751),
  [13280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0),
  [13282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3201),
  [13284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10458),
  [13286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9945),
  [13288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [13290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [13292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [13294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12327),
  [13296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14207),
  [13298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11130),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11359),
  [13302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15080),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15081),
  [13306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 7),
  [13308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 1),
  [13310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 1),
  [13312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 7),
  [13314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14085),
  [13316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [13318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [13320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_statement, 2, 0, 0),
  [13322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_statement, 2, 0, 0),
  [13324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [13326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_statement, 2, 0, 0),
  [13328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_statement, 2, 0, 0),
  [13330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 2, 0, 0),
  [13332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, 0, 0),
  [13334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_expression, 3, 0, 0),
  [13336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_expression, 3, 0, 0),
  [13338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_assignment_expression, 3, 0, 7),
  [13340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_assignment_expression, 3, 0, 7),
  [13342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [13344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15079),
  [13346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_expression, 2, 0, 0),
  [13348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_expression, 2, 0, 0),
  [13350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14085),
  [13353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12688),
  [13356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [13358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macrocall_expression, 2, 0, 0),
  [13360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macrocall_expression, 2, 0, 0),
  [13362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [13364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [13366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 3, 0, 3),
  [13368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 3, 0, 3),
  [13370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 3, 0, 3),
  [13372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 3, 0, 3),
  [13374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 0),
  [13376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 0),
  [13378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 3, 0, 0),
  [13380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 3, 0, 0),
  [13382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_statement, 3, 0, 0),
  [13384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_statement, 3, 0, 0),
  [13386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 3, 0, 0),
  [13388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 3, 0, 0),
  [13390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 5),
  [13392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 5),
  [13394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3547),
  [13396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 0),
  [13398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 0),
  [13400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3, 0, 0),
  [13402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, 0, 0),
  [13404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3547),
  [13407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 5),
  [13409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 5),
  [13411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [13413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 4, 0, 0),
  [13415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 4, 0, 0),
  [13417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 4, 0, 3),
  [13419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 4, 0, 3),
  [13421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_definition, 4, 0, 10),
  [13423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_definition, 4, 0, 10),
  [13425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 4, 0, 10),
  [13427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 4, 0, 10),
  [13429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 4, 0, 3),
  [13431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 4, 0, 3),
  [13433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 0),
  [13435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 0),
  [13437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 4, 0, 0),
  [13439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 4, 0, 0),
  [13441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_statement, 4, 0, 0),
  [13443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_statement, 4, 0, 0),
  [13445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 4, 0, 0),
  [13447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 4, 0, 0),
  [13449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 4, 0, 11),
  [13451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 4, 0, 11),
  [13453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 5),
  [13455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 5),
  [13457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 12),
  [13459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 12),
  [13461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 0),
  [13463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 0),
  [13465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3, 0, 0),
  [13467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 0),
  [13469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15140),
  [13471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [13473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10463),
  [13475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17292),
  [13478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17292),
  [13481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 4, 0, 0),
  [13483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 0),
  [13485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, 0, 5),
  [13487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, 0, 5),
  [13489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 3, 0, 0),
  [13491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 3, 0, 0),
  [13493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selected_import, 3, 0, 0),
  [13495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selected_import, 3, 0, 0),
  [13497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3737),
  [13499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macrocall_expression, 4, 0, 0),
  [13501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macrocall_expression, 4, 0, 0),
  [13503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3737),
  [13506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 5, 0, 3),
  [13508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 5, 0, 3),
  [13510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_definition, 5, 0, 10),
  [13512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_definition, 5, 0, 10),
  [13514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_definition, 5, 0, 10),
  [13516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 5, 0, 10),
  [13518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 5, 0, 10),
  [13520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 5, 0, 10),
  [13522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 5, 0, 3),
  [13524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 5, 0, 3),
  [13526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 0),
  [13528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 0),
  [13530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 5, 0, 0),
  [13532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 5, 0, 0),
  [13534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 5, 0, 11),
  [13536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 5, 0, 11),
  [13538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 5, 0, 0),
  [13540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 5, 0, 0),
  [13542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 5),
  [13544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 5),
  [13546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 17),
  [13548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 17),
  [13550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 18),
  [13552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 18),
  [13554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, 0, 0),
  [13556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, 0, 0),
  [13558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 0),
  [13560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 0),
  [13562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 5),
  [13564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 5),
  [13566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_definition, 6, 0, 21),
  [13568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_definition, 6, 0, 21),
  [13570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_definition, 6, 0, 10),
  [13572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 6, 0, 10),
  [13574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 6, 0, 21),
  [13576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 6, 0, 21),
  [13578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 6, 0, 10),
  [13580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 6, 0, 10),
  [13582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 6, 0, 16),
  [13584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 6, 0, 16),
  [13586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 6, 0, 3),
  [13588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 6, 0, 3),
  [13590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 6, 0, 11),
  [13592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 6, 0, 11),
  [13594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 6, 0, 0),
  [13596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 6, 0, 0),
  [13598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 22),
  [13600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 22),
  [13602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 23),
  [13604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 23),
  [13606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, 0, 0),
  [13608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, 0, 0),
  [13610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [13612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5015),
  [13614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16699),
  [13617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16699),
  [13620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 0),
  [13622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 0),
  [13624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_definition, 7, 0, 21),
  [13626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_definition, 7, 0, 21),
  [13628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_definition, 7, 0, 21),
  [13630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 7, 0, 21),
  [13632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 7, 0, 21),
  [13634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 7, 0, 21),
  [13636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 7, 0, 10),
  [13638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 7, 0, 10),
  [13640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 7, 0, 16),
  [13642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 7, 0, 16),
  [13644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 24),
  [13646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 24),
  [13648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 7, 0, 0),
  [13650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 7, 0, 0),
  [13652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_definition, 8, 0, 21),
  [13654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 8, 0, 21),
  [13656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 8, 0, 21),
  [13658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 8, 0, 21),
  [13660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 8, 0, 16),
  [13662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 8, 0, 16),
  [13664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 9, 0, 21),
  [13666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 9, 0, 21),
  [13668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14028),
  [13670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14961),
  [13672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [13674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6408),
  [13676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16756),
  [13679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16756),
  [13682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [13684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5036),
  [13686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16794),
  [13689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16794),
  [13692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14028),
  [13695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12786),
  [13698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [13700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9930),
  [13702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17141),
  [13705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17141),
  [13708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [13710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10146),
  [13712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16832),
  [13715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16832),
  [13718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [13720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9636),
  [13722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16862),
  [13725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16862),
  [13728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14098),
  [13730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15005),
  [13732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [13734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9584),
  [13736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16885),
  [13739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16885),
  [13742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12503),
  [13744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14092),
  [13746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12089),
  [13748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15105),
  [13750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [13752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11058),
  [13754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16905),
  [13757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16905),
  [13760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [13762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5471),
  [13764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16928),
  [13767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16928),
  [13770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14098),
  [13773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12851),
  [13776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [13778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5672),
  [13780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16955),
  [13783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16955),
  [13786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [13788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10765),
  [13790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16983),
  [13793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16983),
  [13796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [13798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5910),
  [13800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16990),
  [13803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16990),
  [13806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [13808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [13810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11653),
  [13812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16998),
  [13815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(16998),
  [13818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [13820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6608),
  [13822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17001),
  [13825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17001),
  [13828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2241),
  [13830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10309),
  [13832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17006),
  [13835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17006),
  [13838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [13840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5481),
  [13842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17011),
  [13845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17011),
  [13848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [13850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10099),
  [13852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17015),
  [13855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17015),
  [13858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [13860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14513),
  [13862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17018),
  [13865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17018),
  [13868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9904),
  [13870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12767),
  [13872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11435),
  [13874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [13876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9468),
  [13878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17022),
  [13881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17022),
  [13884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12308),
  [13886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14044),
  [13888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11881),
  [13890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [13892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9414),
  [13894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17026),
  [13897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17026),
  [13900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2361),
  [13902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11558),
  [13904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17030),
  [13907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17030),
  [13910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [13912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10640),
  [13914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17034),
  [13917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17034),
  [13920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [13922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6307),
  [13924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17339),
  [13927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17339),
  [13930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [13932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7267),
  [13934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17043),
  [13937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17043),
  [13940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [13942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6671),
  [13944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17047),
  [13947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17047),
  [13950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9882),
  [13952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12755),
  [13954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11430),
  [13956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2459),
  [13958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5047),
  [13960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17050),
  [13963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17050),
  [13966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2478),
  [13968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11298),
  [13970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17054),
  [13973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17054),
  [13976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [13978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5103),
  [13980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17059),
  [13983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17059),
  [13986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2521),
  [13988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5912),
  [13990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17062),
  [13993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17062),
  [13996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2541),
  [13998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5974),
  [14000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17064),
  [14003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17064),
  [14006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2561),
  [14008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11938),
  [14010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17066),
  [14013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17066),
  [14016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8305),
  [14018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2580),
  [14020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8760),
  [14022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17068),
  [14025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17068),
  [14028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [14030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7608),
  [14032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17069),
  [14035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17069),
  [14038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [14040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6000),
  [14042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17071),
  [14045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17071),
  [14048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2640),
  [14050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6966),
  [14052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17073),
  [14055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17073),
  [14058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [14060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6747),
  [14062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17075),
  [14065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17075),
  [14068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [14070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4614),
  [14072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17078),
  [14075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17078),
  [14078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [14080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7674),
  [14082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17080),
  [14085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17080),
  [14088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2718),
  [14090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7034),
  [14092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17082),
  [14095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17082),
  [14098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2738),
  [14100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5332),
  [14102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17083),
  [14105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17083),
  [14108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [14110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11695),
  [14112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17084),
  [14115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17084),
  [14118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [14120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11084),
  [14122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17085),
  [14125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17085),
  [14128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [14130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5573),
  [14132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17087),
  [14135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17087),
  [14138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [14140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6122),
  [14142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17088),
  [14145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17088),
  [14148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [14150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5708),
  [14152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17089),
  [14155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17089),
  [14158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2831),
  [14160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7751),
  [14162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17090),
  [14165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17090),
  [14168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2842),
  [14170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6956),
  [14172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17091),
  [14175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17091),
  [14178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2854),
  [14180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5839),
  [14182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17093),
  [14185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17093),
  [14188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2865),
  [14190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10624),
  [14192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17094),
  [14195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17094),
  [14198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2875),
  [14200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6941),
  [14202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17096),
  [14205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17096),
  [14208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2885),
  [14210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6713),
  [14212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17097),
  [14215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17097),
  [14218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2896),
  [14220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4788),
  [14222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17098),
  [14225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17098),
  [14228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [14230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7868),
  [14232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17100),
  [14235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17100),
  [14238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [14240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7193),
  [14242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17101),
  [14245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17101),
  [14248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14078),
  [14250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [14252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5274),
  [14254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17103),
  [14257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17103),
  [14260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2939),
  [14262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5975),
  [14264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17104),
  [14267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17104),
  [14270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2950),
  [14272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11258),
  [14274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17105),
  [14277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17105),
  [14280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2960),
  [14282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6020),
  [14284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17106),
  [14287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17106),
  [14290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2970),
  [14292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7973),
  [14294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17107),
  [14297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17107),
  [14300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2982),
  [14302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6846),
  [14304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17108),
  [14307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17108),
  [14310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2993),
  [14312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5362),
  [14314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17109),
  [14317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17109),
  [14320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3633),
  [14322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [14324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11810),
  [14326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17110),
  [14329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17110),
  [14332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [14334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10935),
  [14336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17111),
  [14339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17111),
  [14342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3633),
  [14345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3026),
  [14347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6521),
  [14349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17112),
  [14352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17112),
  [14355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [14357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18066),
  [14359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17113),
  [14362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17113),
  [14365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [14367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8621),
  [14369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17114),
  [14372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17114),
  [14375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3057),
  [14377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8043),
  [14379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17115),
  [14382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17115),
  [14385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [14387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6126),
  [14389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17116),
  [14392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17116),
  [14395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9910),
  [14397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12773),
  [14399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11436),
  [14401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14078),
  [14404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12595),
  [14407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14948),
  [14409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3885),
  [14411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3892),
  [14413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3893),
  [14415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9771),
  [14417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8311),
  [14419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3206),
  [14421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3895),
  [14423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3899),
  [14425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3901),
  [14427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3905),
  [14429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3906),
  [14431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3907),
  [14433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3908),
  [14435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3912),
  [14437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3915),
  [14439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3922),
  [14441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3923),
  [14443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3925),
  [14445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3548),
  [14447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [14449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [14451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9778),
  [14453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8460),
  [14455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3214),
  [14457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3560),
  [14459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3565),
  [14461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3568),
  [14463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3569),
  [14465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3570),
  [14467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3571),
  [14469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3574),
  [14471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3580),
  [14473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3581),
  [14475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3584),
  [14477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3585),
  [14479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3586),
  [14481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3834),
  [14483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3835),
  [14485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [14487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9792),
  [14489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8117),
  [14491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3222),
  [14493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3840),
  [14495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3841),
  [14497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3842),
  [14499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3845),
  [14501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3851),
  [14503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3852),
  [14505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3854),
  [14507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3856),
  [14509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3857),
  [14511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3858),
  [14513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3860),
  [14515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3866),
  [14517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3297),
  [14519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [14521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3302),
  [14523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3307),
  [14525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4116),
  [14527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4117),
  [14529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4118),
  [14531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4119),
  [14533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4120),
  [14535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4121),
  [14537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4122),
  [14539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4123),
  [14541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [14543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [14545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3535),
  [14547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [14549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3543),
  [14551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3544),
  [14553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [14555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [14557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3564),
  [14559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3566),
  [14561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3572),
  [14563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3573),
  [14565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [14567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [14569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3538),
  [14571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3541),
  [14573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3542),
  [14575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3286),
  [14578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9854),
  [14580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12735),
  [14582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11519),
  [14584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14089),
  [14586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14089),
  [14589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12503),
  [14592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3216),
  [14594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14029),
  [14596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3188),
  [14598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14029),
  [14601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12308),
  [14604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4198),
  [14606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9995),
  [14608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12732),
  [14610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11513),
  [14612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3205),
  [14614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14645),
  [14616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [14618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [14620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(4198),
  [14623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9872),
  [14625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12810),
  [14627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11491),
  [14629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4114),
  [14631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4115),
  [14633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3303),
  [14635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3589),
  [14637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3589),
  [14640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9772),
  [14642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3973),
  [14644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3974),
  [14646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4091),
  [14648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4092),
  [14650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4093),
  [14652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4094),
  [14654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4095),
  [14656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4096),
  [14658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4097),
  [14660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4098),
  [14662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3972),
  [14664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4089),
  [14666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [14668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3977),
  [14670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3978),
  [14672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15075),
  [14674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4200),
  [14676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4203),
  [14678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4208),
  [14680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9809),
  [14682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3195),
  [14684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3290),
  [14686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3293),
  [14688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4211),
  [14690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4213),
  [14692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3301),
  [14694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3306),
  [14696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [14698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3310),
  [14700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [14702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3312),
  [14704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3313),
  [14706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [14708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [14710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [14712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3428),
  [14714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8511),
  [14716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [14718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [14720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3366),
  [14722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [14724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [14726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [14728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [14730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3373),
  [14732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3374),
  [14734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3375),
  [14736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [14738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [14740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [14742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [14744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3762),
  [14746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3763),
  [14748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3766),
  [14750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9770),
  [14752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9103),
  [14754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3229),
  [14756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3789),
  [14758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3790),
  [14760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3792),
  [14762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3793),
  [14764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3812),
  [14766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3813),
  [14768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3814),
  [14770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3815),
  [14772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3818),
  [14774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3868),
  [14776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3870),
  [14778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [14780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3593),
  [14782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3594),
  [14784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3595),
  [14786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3597),
  [14788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3598),
  [14790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3599),
  [14792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3600),
  [14794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3601),
  [14796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3602),
  [14798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3603),
  [14800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3604),
  [14802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3605),
  [14804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3606),
  [14806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3607),
  [14808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3224),
  [14810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [14812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3328),
  [14814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3329),
  [14816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [14818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [14820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3332),
  [14822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3333),
  [14824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [14826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3335),
  [14828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [14830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3467),
  [14832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3468),
  [14834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3475),
  [14836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3476),
  [14838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3477),
  [14840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3478),
  [14842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3479),
  [14844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3480),
  [14846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3483),
  [14848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3484),
  [14850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [14852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3325),
  [14854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3465),
  [14856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3469),
  [14858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3470),
  [14860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3473),
  [14862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3474),
  [14864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [14866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3596),
  [14868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [14870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [14872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [14874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3266),
  [14877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3693),
  [14879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3694),
  [14881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3695),
  [14883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3696),
  [14885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3697),
  [14887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3698),
  [14889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3699),
  [14891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3700),
  [14893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3701),
  [14895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3702),
  [14897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3703),
  [14899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3704),
  [14901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3705),
  [14903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3706),
  [14905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3707),
  [14907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3268),
  [14909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3269),
  [14911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3271),
  [14913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [14915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [14917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3276),
  [14919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [14921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [14923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [14925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [14927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [14929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [14931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3294),
  [14933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [14935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [14937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [14939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [14941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3810),
  [14943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3796),
  [14945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3804),
  [14947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3805),
  [14949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3806),
  [14951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3807),
  [14953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3808),
  [14955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3802),
  [14957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3803),
  [14959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3999),
  [14961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4000),
  [14963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4073),
  [14965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4074),
  [14967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [14969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4076),
  [14971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4077),
  [14973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4078),
  [14975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4079),
  [14977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4080),
  [14979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [14981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3998),
  [14983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4071),
  [14985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4072),
  [14987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [14989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4004),
  [14991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closed_assignment, 3, 0, 7),
  [14993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closed_assignment, 3, 0, 7),
  [14995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [14997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4029),
  [14999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4030),
  [15001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4031),
  [15003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [15005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [15007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4034),
  [15009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [15011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [15013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [15015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4020),
  [15017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4021),
  [15019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4022),
  [15021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3210),
  [15023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4001),
  [15025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4002),
  [15027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4025),
  [15029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4026),
  [15031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4005),
  [15033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4006),
  [15035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4007),
  [15037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [15039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4009),
  [15041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4010),
  [15043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4011),
  [15045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [15047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3797),
  [15049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3795),
  [15051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3798),
  [15053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3799),
  [15055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3800),
  [15057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3801),
  [15059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3321),
  [15061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [15063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [15065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4024),
  [15067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [15069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [15071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [15073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_binding, 4, 0, 0),
  [15075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_binding, 4, 0, 0),
  [15077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_binding, 3, 0, 0),
  [15079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_binding, 3, 0, 0),
  [15081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4237),
  [15083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4238),
  [15085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4239),
  [15087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4240),
  [15089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4241),
  [15091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3248),
  [15093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3249),
  [15095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3250),
  [15097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [15099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [15101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3492),
  [15103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [15105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [15107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [15109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [15111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3521),
  [15113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [15115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [15117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [15119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4233),
  [15121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4234),
  [15123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3491),
  [15125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3493),
  [15127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3495),
  [15129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [15131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [15133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [15135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16443),
  [15137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16448),
  [15139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4143),
  [15141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4144),
  [15143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4145),
  [15145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4146),
  [15147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4147),
  [15149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4083),
  [15151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4084),
  [15153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4085),
  [15155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4138),
  [15157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [15159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4086),
  [15161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4087),
  [15163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4140),
  [15165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4141),
  [15167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4142),
  [15169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 2, 0, 0),
  [15171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2, 0, 0),
  [15173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [15175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_signature, 1, 0, 0),
  [15177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3369),
  [15179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 1, 0, 0),
  [15181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9763),
  [15183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9945),
  [15186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16149),
  [15188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16152),
  [15190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [15192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16225),
  [15194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16226),
  [15196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9349),
  [15198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9432),
  [15200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9406),
  [15202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14249),
  [15204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18089),
  [15206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15394),
  [15208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17405),
  [15210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12327),
  [15212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12735),
  [15214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_clause, 2, 0, 0),
  [15216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_clause, 2, 0, 0),
  [15218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9458),
  [15220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14306),
  [15222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17650),
  [15224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15373),
  [15226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17679),
  [15228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15735),
  [15230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15754),
  [15232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9555),
  [15234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_signature, 2, 0, 4),
  [15236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 2, 0, 4),
  [15238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9945),
  [15241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0),
  [15243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1943),
  [15246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0),
  [15248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16187),
  [15250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16295),
  [15252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9646),
  [15254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_signature, 3, 0, 4),
  [15256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 3, 0, 4),
  [15258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_signature, 2, 0, 0),
  [15260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 2, 0, 0),
  [15262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__do_parameter_list, 3, 0, 0),
  [15264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__do_parameter_list, 3, 0, 0),
  [15266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__do_parameter_list, 1, 0, 0),
  [15268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__do_parameter_list, 1, 0, 0),
  [15270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__do_parameter_list, 2, 0, 0),
  [15272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__do_parameter_list, 2, 0, 0),
  [15274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10194),
  [15276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10385),
  [15278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10369),
  [15280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10369),
  [15282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10253),
  [15284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10378),
  [15286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10385),
  [15288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10380),
  [15290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10380),
  [15292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16892),
  [15294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15437),
  [15296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17575),
  [15298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10300),
  [15300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10623),
  [15302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10891),
  [15304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10357),
  [15306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10909),
  [15308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10910),
  [15310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17153),
  [15312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15391),
  [15314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18023),
  [15316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9820),
  [15318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10036),
  [15320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9996),
  [15322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9841),
  [15324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9979),
  [15326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9874),
  [15328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17197),
  [15330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15335),
  [15332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17839),
  [15334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10287),
  [15336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10703),
  [15338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10606),
  [15340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10468),
  [15342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10607),
  [15344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10597),
  [15346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16806),
  [15348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15196),
  [15350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17492),
  [15352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9319),
  [15354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10019),
  [15356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [15358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [15360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [15362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12473),
  [15364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14403),
  [15366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15416),
  [15368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14588),
  [15370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14589),
  [15372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9854),
  [15374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8589),
  [15376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11518),
  [15378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [15380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7113),
  [15382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10979),
  [15384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7643),
  [15386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11503),
  [15388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6926),
  [15390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8014),
  [15392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6465),
  [15394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10820),
  [15396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9448),
  [15398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [15400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9372),
  [15402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7132),
  [15404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6601),
  [15406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [15408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6505),
  [15410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [15412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6939),
  [15414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11740),
  [15416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10263),
  [15418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10724),
  [15420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10016),
  [15422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6297),
  [15424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11584),
  [15426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14364),
  [15428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5883),
  [15430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5854),
  [15432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6222),
  [15434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6266),
  [15436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6325),
  [15438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [15440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [15442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10376),
  [15444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5621),
  [15446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5563),
  [15448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [15450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6079),
  [15452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [15454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7906),
  [15456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11055),
  [15458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5529),
  [15460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8020),
  [15462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5431),
  [15464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7829),
  [15466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [15468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [15470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6725),
  [15472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10171),
  [15474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [15476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7231),
  [15478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10631),
  [15480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7147),
  [15482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12079),
  [15484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [15486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [15488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5241),
  [15490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11043),
  [15492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11222),
  [15494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8328),
  [15496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5157),
  [15498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17572),
  [15500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7964),
  [15502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7229),
  [15504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11212),
  [15506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10057),
  [15508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9280),
  [15510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9907),
  [15512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [15514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [15516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [15518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12461),
  [15520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9348),
  [15522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9344),
  [15524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14964),
  [15526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14966),
  [15528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9848),
  [15530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9911),
  [15532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [15534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [15536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [15538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12774),
  [15540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10045),
  [15542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11368),
  [15544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14693),
  [15546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14695),
  [15548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [15550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9987),
  [15552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [15554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [15556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [15558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12571),
  [15560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4987),
  [15562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [15564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14601),
  [15566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14602),
  [15568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9965),
  [15570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [15572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [15574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [15576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12645),
  [15578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11240),
  [15580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4320),
  [15582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9988),
  [15584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [15586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [15588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [15590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12493),
  [15592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4947),
  [15594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [15596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15159),
  [15598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15160),
  [15600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4822),
  [15602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9933),
  [15604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [15606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [15608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [15610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12487),
  [15612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6219),
  [15614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6369),
  [15616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15069),
  [15618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15070),
  [15620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4452),
  [15622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9863),
  [15624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [15626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [15628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [15630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12449),
  [15632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5835),
  [15634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [15636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14620),
  [15638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14621),
  [15640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4924),
  [15642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10020),
  [15644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [15646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [15648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [15650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12663),
  [15652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6392),
  [15654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6376),
  [15656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14934),
  [15658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14935),
  [15660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4491),
  [15662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9947),
  [15664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [15666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [15668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [15670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12594),
  [15672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5918),
  [15674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5828),
  [15676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14733),
  [15678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14734),
  [15680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4482),
  [15682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10017),
  [15684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [15686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [15688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [15690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12573),
  [15692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5681),
  [15694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5754),
  [15696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14639),
  [15698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14640),
  [15700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9853),
  [15702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [15704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [15706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [15708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12457),
  [15710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9473),
  [15712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9449),
  [15714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14915),
  [15716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14918),
  [15718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9950),
  [15720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [15722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [15724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [15726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12508),
  [15728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11223),
  [15730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4905),
  [15732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10001),
  [15734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [15736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [15738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [15740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12591),
  [15742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6386),
  [15744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [15746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14689),
  [15748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14690),
  [15750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10383),
  [15752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9963),
  [15754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [15756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [15758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [15760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12578),
  [15762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11057),
  [15764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11187),
  [15766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14666),
  [15768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14667),
  [15770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4872),
  [15772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9969),
  [15774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [15776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [15778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [15780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12565),
  [15782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6295),
  [15784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6277),
  [15786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14565),
  [15788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14566),
  [15790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4492),
  [15792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9937),
  [15794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [15796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [15798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [15800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12625),
  [15802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5926),
  [15804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [15806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14809),
  [15808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14810),
  [15810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9872),
  [15812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [15814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [15816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [15818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12810),
  [15820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11490),
  [15822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4922),
  [15824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10026),
  [15826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [15828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [15830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [15832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12245),
  [15834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6425),
  [15836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6435),
  [15838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14819),
  [15840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14820),
  [15842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9995),
  [15844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12732),
  [15846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11511),
  [15848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9856),
  [15850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12736),
  [15852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11419),
  [15854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9913),
  [15856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12453),
  [15858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11425),
  [15860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9945),
  [15862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11345),
  [15864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4914),
  [15866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10293),
  [15868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9857),
  [15870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [15872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [15874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [15876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12737),
  [15878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10605),
  [15880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11422),
  [15882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15042),
  [15884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15043),
  [15886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14328),
  [15888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [15890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14409),
  [15892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9897),
  [15894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12762),
  [15896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11270),
  [15898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4290),
  [15900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9875),
  [15902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [15904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [15906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [15908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12619),
  [15910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4674),
  [15912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [15914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14774),
  [15916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14775),
  [15918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9917),
  [15920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12780),
  [15922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11193),
  [15924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4497),
  [15926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10025),
  [15928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [15930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [15932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [15934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12652),
  [15936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5417),
  [15938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [15940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14864),
  [15942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14865),
  [15944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9951),
  [15946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12729),
  [15948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15015),
  [15950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4860),
  [15952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9886),
  [15954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [15956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [15958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [15960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12544),
  [15962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6278),
  [15964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [15966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14976),
  [15968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14977),
  [15970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4485),
  [15972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10031),
  [15974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [15976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [15978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [15980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12584),
  [15982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5738),
  [15984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [15986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14677),
  [15988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14678),
  [15990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11502),
  [15992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9928),
  [15994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [15996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [15998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [16000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12560),
  [16002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11878),
  [16004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11889),
  [16006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15021),
  [16008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15024),
  [16010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10368),
  [16012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9855),
  [16014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [16016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [16018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [16020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12655),
  [16022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11041),
  [16024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11163),
  [16026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14881),
  [16028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14882),
  [16030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5763),
  [16032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9955),
  [16034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [16036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [16038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [16040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12435),
  [16042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6625),
  [16044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6571),
  [16046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14898),
  [16048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14899),
  [16050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5543),
  [16052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9896),
  [16054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [16056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [16058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [16060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12658),
  [16062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6517),
  [16064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [16066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14891),
  [16068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14892),
  [16070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9970),
  [16072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12466),
  [16074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11022),
  [16076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4341),
  [16078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9977),
  [16080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [16082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [16084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [16086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12375),
  [16088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5204),
  [16090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [16092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14622),
  [16094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14623),
  [16096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9882),
  [16098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12755),
  [16100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11429),
  [16102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9852),
  [16104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12757),
  [16106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11361),
  [16108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9904),
  [16110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12767),
  [16112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11433),
  [16114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9898),
  [16116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12764),
  [16118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11190),
  [16120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9910),
  [16122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12773),
  [16124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11434),
  [16126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9905),
  [16128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12768),
  [16130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11366),
  [16132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9916),
  [16134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12779),
  [16136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11367),
  [16138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [16140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [16142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [16144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10034),
  [16146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10014),
  [16148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10028),
  [16150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10046),
  [16152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10101),
  [16154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10101),
  [16156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10003),
  [16158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10102),
  [16160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10046),
  [16162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10103),
  [16164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10103),
  [16166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17258),
  [16168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15434),
  [16170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18095),
  [16172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9465),
  [16174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9472),
  [16176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9472),
  [16178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9341),
  [16180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9462),
  [16182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9465),
  [16184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9423),
  [16186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9423),
  [16188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17077),
  [16190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15347),
  [16192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17490),
  [16194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10966),
  [16196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11151),
  [16198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11151),
  [16200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10753),
  [16202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10961),
  [16204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10966),
  [16206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11099),
  [16208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11099),
  [16210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16843),
  [16212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15418),
  [16214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17554),
  [16216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11136),
  [16218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11111),
  [16220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11111),
  [16222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10885),
  [16224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11118),
  [16226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11136),
  [16228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11123),
  [16230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11123),
  [16232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16771),
  [16234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15260),
  [16236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17811),
  [16238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10611),
  [16240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10912),
  [16242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10912),
  [16244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10362),
  [16246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10914),
  [16248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10611),
  [16250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10915),
  [16252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10915),
  [16254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16717),
  [16256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15280),
  [16258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17814),
  [16260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10184),
  [16262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10224),
  [16264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10260),
  [16266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10260),
  [16268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10187),
  [16270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10288),
  [16272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10224),
  [16274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10213),
  [16276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10213),
  [16278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17177),
  [16280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15401),
  [16282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18039),
  [16284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14552),
  [16286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14555),
  [16288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11230),
  [16290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11520),
  [16292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11399),
  [16294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11399),
  [16296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11380),
  [16298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11467),
  [16300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11520),
  [16302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11534),
  [16304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11534),
  [16306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16876),
  [16308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15443),
  [16310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17451),
  [16312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15007),
  [16314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15008),
  [16316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11398),
  [16318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11563),
  [16320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11795),
  [16322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11795),
  [16324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11561),
  [16326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11580),
  [16328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11563),
  [16330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11583),
  [16332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11583),
  [16334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16788),
  [16336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15415),
  [16338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17938),
  [16340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14654),
  [16342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14655),
  [16344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11407),
  [16346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11684),
  [16348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11593),
  [16350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11593),
  [16352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11460),
  [16354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11594),
  [16356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11684),
  [16358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11654),
  [16360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11654),
  [16362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16826),
  [16364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15417),
  [16366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18028),
  [16368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14873),
  [16370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14874),
  [16372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5851),
  [16374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [16376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5428),
  [16378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4658),
  [16380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [16382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5851),
  [16384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [16386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5305),
  [16388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16865),
  [16390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15430),
  [16392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17566),
  [16394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [16396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6447),
  [16398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6403),
  [16400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6448),
  [16402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9996),
  [16404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9979),
  [16406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10036),
  [16408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9874),
  [16410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10082),
  [16412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6832),
  [16414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7958),
  [16416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6923),
  [16418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7958),
  [16420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7816),
  [16422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7816),
  [16424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17300),
  [16426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15361),
  [16428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17922),
  [16430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14785),
  [16432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14786),
  [16434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10181),
  [16436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10164),
  [16438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10164),
  [16440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10108),
  [16442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10166),
  [16444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10181),
  [16446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10163),
  [16448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10163),
  [16450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17218),
  [16452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15207),
  [16454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17359),
  [16456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6479),
  [16458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7138),
  [16460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6993),
  [16462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6993),
  [16464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6822),
  [16466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6994),
  [16468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7138),
  [16470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7025),
  [16472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7025),
  [16474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16849),
  [16476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15407),
  [16478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17454),
  [16480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14722),
  [16482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14723),
  [16484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4660),
  [16486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [16488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4861),
  [16490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4481),
  [16492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [16494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [16496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [16498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4867),
  [16500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16929),
  [16502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15214),
  [16504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18105),
  [16506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6644),
  [16508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7890),
  [16510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6867),
  [16512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7890),
  [16514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7662),
  [16516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7662),
  [16518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17270),
  [16520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15229),
  [16522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17777),
  [16524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14713),
  [16526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14714),
  [16528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6504),
  [16530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7112),
  [16532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7178),
  [16534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7178),
  [16536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6757),
  [16538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [16540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7112),
  [16542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7095),
  [16544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7095),
  [16546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16732),
  [16548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15386),
  [16550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17982),
  [16552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14855),
  [16554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14856),
  [16556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6281),
  [16558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6379),
  [16560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6379),
  [16562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5230),
  [16564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6381),
  [16566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6281),
  [16568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6276),
  [16570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6276),
  [16572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17236),
  [16574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15240),
  [16576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17657),
  [16578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10083),
  [16580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6164),
  [16582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6168),
  [16584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6258),
  [16586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [16588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10042),
  [16590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6574),
  [16592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7030),
  [16594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6775),
  [16596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7030),
  [16598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7053),
  [16600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7053),
  [16602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16725),
  [16604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15294),
  [16606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17820),
  [16608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15099),
  [16610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15103),
  [16612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6486),
  [16614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6610),
  [16616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6610),
  [16618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6205),
  [16620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [16622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6486),
  [16624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [16626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6561),
  [16628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16926),
  [16630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15286),
  [16632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17841),
  [16634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9352),
  [16636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9340),
  [16638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9340),
  [16640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9321),
  [16642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9342),
  [16644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9352),
  [16646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9343),
  [16648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9343),
  [16650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17164),
  [16652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15449),
  [16654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18063),
  [16656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [16658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [16660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [16662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4745),
  [16664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10606),
  [16666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10607),
  [16668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10703),
  [16670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10597),
  [16672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6171),
  [16674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6707),
  [16676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6794),
  [16678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6794),
  [16680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6604),
  [16682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6829),
  [16684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6707),
  [16686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6658),
  [16688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6658),
  [16690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16723),
  [16692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15299),
  [16694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17599),
  [16696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14591),
  [16698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14592),
  [16700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6488),
  [16702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7185),
  [16704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6739),
  [16706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7185),
  [16708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7088),
  [16710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7088),
  [16712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17191),
  [16714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15306),
  [16716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17878),
  [16718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14752),
  [16720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14753),
  [16722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12083),
  [16724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12058),
  [16726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12058),
  [16728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11629),
  [16730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12075),
  [16732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12083),
  [16734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12004),
  [16736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12004),
  [16738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16736),
  [16740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15287),
  [16742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17745),
  [16744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [16746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [16748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [16750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [16752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6223),
  [16754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [16756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6229),
  [16758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5781),
  [16760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [16762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6223),
  [16764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6321),
  [16766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6321),
  [16768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17123),
  [16770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15212),
  [16772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17491),
  [16774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6612),
  [16776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7114),
  [16778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7066),
  [16780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7066),
  [16782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6773),
  [16784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7036),
  [16786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7114),
  [16788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [16790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7145),
  [16792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17203),
  [16794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15450),
  [16796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17717),
  [16798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14625),
  [16800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14626),
  [16802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5302),
  [16804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5413),
  [16806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5413),
  [16808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4890),
  [16810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [16812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5302),
  [16814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5421),
  [16816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5421),
  [16818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17206),
  [16820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15284),
  [16822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17389),
  [16824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [16826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6660),
  [16828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8010),
  [16830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7044),
  [16832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8010),
  [16834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7997),
  [16836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7997),
  [16838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16982),
  [16840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15453),
  [16842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18113),
  [16844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14846),
  [16846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14847),
  [16848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7176),
  [16850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8322),
  [16852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7749),
  [16854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8322),
  [16856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8445),
  [16858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8445),
  [16860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16965),
  [16862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15452),
  [16864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17474),
  [16866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15094),
  [16868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15095),
  [16870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5190),
  [16872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [16874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5392),
  [16876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4868),
  [16878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [16880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [16882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [16884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5390),
  [16886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17271),
  [16888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15442),
  [16890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18123),
  [16892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11215),
  [16894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11354),
  [16896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11354),
  [16898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11016),
  [16900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11342),
  [16902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11215),
  [16904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11346),
  [16906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11346),
  [16908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16769),
  [16910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15285),
  [16912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17425),
  [16914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14383),
  [16916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14395),
  [16918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14395),
  [16920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14348),
  [16922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14358),
  [16924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14383),
  [16926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14396),
  [16928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14396),
  [16930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17156),
  [16932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15429),
  [16934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17708),
  [16936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6690),
  [16938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8016),
  [16940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8080),
  [16942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8080),
  [16944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7158),
  [16946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8081),
  [16948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8016),
  [16950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8078),
  [16952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8078),
  [16954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17160),
  [16956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15193),
  [16958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17343),
  [16960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14923),
  [16962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15179),
  [16964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6480),
  [16966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6466),
  [16968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6466),
  [16970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6360),
  [16972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6581),
  [16974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [16976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6478),
  [16978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6478),
  [16980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16672),
  [16982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15301),
  [16984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17507),
  [16986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7035),
  [16988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8583),
  [16990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7293),
  [16992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8583),
  [16994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8722),
  [16996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8722),
  [16998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17234),
  [17000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15215),
  [17002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17368),
  [17004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14910),
  [17006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14911),
  [17008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [17010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5387),
  [17012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5911),
  [17014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [17016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10968),
  [17018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11178),
  [17020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11178),
  [17022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10588),
  [17024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11010),
  [17026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10968),
  [17028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11150),
  [17030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11150),
  [17032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17099),
  [17034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15439),
  [17036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17859),
  [17038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11338),
  [17040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11290),
  [17042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11290),
  [17044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11066),
  [17046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11291),
  [17048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11338),
  [17050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11281),
  [17052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11281),
  [17054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17147),
  [17056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15219),
  [17058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17494),
  [17060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10047),
  [17062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6300),
  [17064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6424),
  [17066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6424),
  [17068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5266),
  [17070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6428),
  [17072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6300),
  [17074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6446),
  [17076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6446),
  [17078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16970),
  [17080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15355),
  [17082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17873),
  [17084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5869),
  [17086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [17088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5946),
  [17090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5872),
  [17092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5208),
  [17094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5928),
  [17096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5928),
  [17098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4811),
  [17100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [17102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [17104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [17106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5523),
  [17108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16818),
  [17110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15308),
  [17112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17789),
  [17114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15494),
  [17116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18072),
  [17118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17588),
  [17120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17588),
  [17122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16804),
  [17124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17887),
  [17126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18072),
  [17128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17704),
  [17130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17704),
  [17132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17279),
  [17134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15281),
  [17136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17559),
  [17138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14902),
  [17140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14903),
  [17142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5552),
  [17144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [17146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [17148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [17150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5012),
  [17152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [17154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4823),
  [17156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4472),
  [17158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [17160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [17162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4835),
  [17164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4835),
  [17166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17267),
  [17168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15441),
  [17170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18099),
  [17172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4948),
  [17174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [17176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4749),
  [17178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4458),
  [17180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [17182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [17184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [17186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4738),
  [17188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16692),
  [17190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15254),
  [17192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17805),
  [17194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10891),
  [17196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10909),
  [17198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10623),
  [17200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10910),
  [17202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6602),
  [17204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6896),
  [17206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6763),
  [17208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6896),
  [17210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [17212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7245),
  [17214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17289),
  [17216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15303),
  [17218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17591),
  [17220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14577),
  [17222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14578),
  [17224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6176),
  [17226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [17228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5964),
  [17230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5414),
  [17232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [17234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6176),
  [17236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6431),
  [17238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6431),
  [17240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16918),
  [17242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15350),
  [17244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17625),
  [17246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10104),
  [17248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6781),
  [17250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7819),
  [17252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7033),
  [17254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7819),
  [17256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7576),
  [17258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7576),
  [17260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16697),
  [17262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15372),
  [17264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17627),
  [17266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14612),
  [17268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14613),
  [17270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5999),
  [17272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6807),
  [17274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [17276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6800),
  [17278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6598),
  [17280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6803),
  [17282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6807),
  [17284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [17286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6788),
  [17288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16902),
  [17290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15315),
  [17292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17452),
  [17294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15131),
  [17296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15132),
  [17298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5820),
  [17300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [17302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5310),
  [17304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4849),
  [17306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [17308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5820),
  [17310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5331),
  [17312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5331),
  [17314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16669),
  [17316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15344),
  [17318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17531),
  [17320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6061),
  [17322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [17324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6177),
  [17326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5511),
  [17328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6187),
  [17330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6061),
  [17332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6180),
  [17334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6180),
  [17336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16914),
  [17338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15436),
  [17340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18070),
  [17342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [17344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4941),
  [17346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4934),
  [17348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [17350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5231),
  [17352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5442),
  [17354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5442),
  [17356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4906),
  [17358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5443),
  [17360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [17362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5445),
  [17364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5445),
  [17366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16945),
  [17368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15203),
  [17370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17742),
  [17372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5966),
  [17374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6115),
  [17376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6115),
  [17378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5458),
  [17380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6116),
  [17382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5966),
  [17384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6382),
  [17386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6382),
  [17388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16700),
  [17390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15345),
  [17392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17427),
  [17394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6639),
  [17396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7631),
  [17398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7646),
  [17400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7646),
  [17402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7065),
  [17404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7648),
  [17406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7631),
  [17408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [17410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7363),
  [17412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17261),
  [17414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15234),
  [17416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17430),
  [17418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14550),
  [17420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14551),
  [17422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6217),
  [17424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6703),
  [17426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6640),
  [17428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6640),
  [17430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6469),
  [17432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6652),
  [17434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [17436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6828),
  [17438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6828),
  [17440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16784),
  [17442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15412),
  [17444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17669),
  [17446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14761),
  [17448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14762),
  [17450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5410),
  [17452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [17454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5345),
  [17456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4858),
  [17458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [17460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [17462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [17464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5879),
  [17466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17228),
  [17468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15248),
  [17470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17440),
  [17472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6495),
  [17474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7069),
  [17476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7232),
  [17478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7232),
  [17480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6765),
  [17482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [17484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7069),
  [17486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6997),
  [17488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6997),
  [17490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17314),
  [17492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15446),
  [17494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17707),
  [17496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14797),
  [17498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14798),
  [17500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10179),
  [17502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10170),
  [17504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10151),
  [17506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10169),
  [17508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [17510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15520),
  [17512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15524),
  [17514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10238),
  [17516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [17518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [17520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15907),
  [17522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15908),
  [17524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [17526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15912),
  [17528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15913),
  [17530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [17532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [17534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [17536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [17538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [17540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15584),
  [17542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15585),
  [17544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10542),
  [17546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [17548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10555),
  [17550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [17552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15478),
  [17554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15479),
  [17556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10528),
  [17558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9944),
  [17560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16257),
  [17562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16270),
  [17564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10340),
  [17566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2891),
  [17568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [17570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [17572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16650),
  [17574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15467),
  [17576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [17578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [17580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [17582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11166),
  [17584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15996),
  [17586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15997),
  [17588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [17590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [17592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [17594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17603),
  [17596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [17598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [17600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [17602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [17604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [17606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10917),
  [17608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10923),
  [17610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10079),
  [17612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15609),
  [17614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15610),
  [17616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [17618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [17620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16221),
  [17622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16249),
  [17624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [17626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [17628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(3610),
  [17631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [17633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16119),
  [17635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16120),
  [17637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [17639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10862),
  [17641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15853),
  [17643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15854),
  [17645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [17647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [17649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [17651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [17653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [17655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [17657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [17659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10608),
  [17661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15833),
  [17663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15834),
  [17665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [17667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [17669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [17671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [17673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [17675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [17677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16019),
  [17679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16020),
  [17681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [17683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [17685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [17687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [17689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [17691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [17693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [17695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [17697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [17699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [17701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [17703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [17705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11048),
  [17707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(3619),
  [17710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [17712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9811),
  [17714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14300),
  [17716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3360),
  [17718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15357),
  [17720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18103),
  [17722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2, 0, 0),
  [17724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_let_statement_repeat1, 2, 0, 0),
  [17726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4652),
  [17728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14288),
  [17730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3788),
  [17732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15963),
  [17734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15964),
  [17736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [17738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14238),
  [17740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3515),
  [17742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [17744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [17746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16182),
  [17748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16184),
  [17750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11045),
  [17752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [17754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [17756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [17758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3162),
  [17760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6214),
  [17762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14282),
  [17764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4052),
  [17766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17645),
  [17768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15359),
  [17770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17647),
  [17772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [17774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14251),
  [17776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4068),
  [17778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10158),
  [17780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16218),
  [17782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16219),
  [17784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11336),
  [17786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9810),
  [17788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14307),
  [17790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3408),
  [17792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18032),
  [17794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15400),
  [17796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18035),
  [17798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [17800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [17802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14236),
  [17804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3760),
  [17806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [17808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11113),
  [17810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11044),
  [17812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [17814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14291),
  [17816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3583),
  [17818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16626),
  [17820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16627),
  [17822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [17824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3610),
  [17826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16150),
  [17828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16151),
  [17830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11327),
  [17832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3273),
  [17834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9659),
  [17836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9659),
  [17838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15874),
  [17840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15875),
  [17842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15955),
  [17844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15956),
  [17846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15972),
  [17848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15973),
  [17850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [17852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11119),
  [17854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15646),
  [17856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15649),
  [17858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9812),
  [17860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14318),
  [17862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3631),
  [17864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [17866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9814),
  [17868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14285),
  [17870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3952),
  [17872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15637),
  [17874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15638),
  [17876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16426),
  [17878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16428),
  [17880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [17882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2791),
  [17884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14319),
  [17886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3678),
  [17888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11211),
  [17890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10615),
  [17892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14244),
  [17894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17385),
  [17896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15356),
  [17898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17856),
  [17900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [17902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9815),
  [17904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14310),
  [17906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3691),
  [17908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15882),
  [17910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15883),
  [17912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__do_parameter_list_repeat1, 2, 0, 0),
  [17914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__do_parameter_list_repeat1, 2, 0, 0),
  [17916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16205),
  [17918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16256),
  [17920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [17922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14269),
  [17924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3867),
  [17926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16628),
  [17928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16629),
  [17930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11295),
  [17932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [17934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [17936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14321),
  [17938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3459),
  [17940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [17942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11038),
  [17944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14232),
  [17946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17829),
  [17948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15296),
  [17950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17835),
  [17952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3619),
  [17954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11120),
  [17956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14292),
  [17958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17596),
  [17960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15428),
  [17962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17635),
  [17964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10041),
  [17966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14234),
  [17968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18130),
  [17970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15461),
  [17972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18138),
  [17974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14324),
  [17976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9818),
  [17978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14312),
  [17980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3865),
  [17982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [17984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14267),
  [17986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3588),
  [17988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1697),
  [17990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9817),
  [17992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14235),
  [17994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3280),
  [17996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16553),
  [17998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16554),
  [18000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14303),
  [18002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3463),
  [18004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16233),
  [18006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16234),
  [18008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3809),
  [18010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [18012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [18014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3237),
  [18016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9816),
  [18018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14284),
  [18020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [18022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [18024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17644),
  [18026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15227),
  [18028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17648),
  [18030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [18032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3682),
  [18034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [18036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11210),
  [18038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14283),
  [18040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17874),
  [18042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15307),
  [18044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17436),
  [18046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [18048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9813),
  [18050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14265),
  [18052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3970),
  [18054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [18056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3232),
  [18058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16415),
  [18060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16416),
  [18062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [18064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3709),
  [18066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11358),
  [18068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14316),
  [18070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17503),
  [18072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15204),
  [18074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17505),
  [18076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14298),
  [18078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3251),
  [18080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [18082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3270),
  [18084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3239),
  [18086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3281),
  [18088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [18090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10176),
  [18092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14289),
  [18094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17393),
  [18096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15239),
  [18098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17394),
  [18100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14272),
  [18102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4070),
  [18104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [18106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14280),
  [18108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [18110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [18112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3612),
  [18114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [18116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3953),
  [18118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2977),
  [18120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11184),
  [18122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14313),
  [18124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17564),
  [18126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15432),
  [18128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17565),
  [18130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3639),
  [18132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [18134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14279),
  [18136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14260),
  [18138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14263),
  [18140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11456),
  [18142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11658),
  [18144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4019),
  [18146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [18148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16093),
  [18150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16094),
  [18152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3245),
  [18154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10207),
  [18156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11708),
  [18158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11515),
  [18160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14241),
  [18162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3679),
  [18164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [18166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15540),
  [18168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15541),
  [18170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14253),
  [18172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3730),
  [18174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [18176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15849),
  [18178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15850),
  [18180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15815),
  [18182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15816),
  [18184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15992),
  [18186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15993),
  [18188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3233),
  [18190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16014),
  [18192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16015),
  [18194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3024),
  [18196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14311),
  [18198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4185),
  [18200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [18202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11681),
  [18204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14322),
  [18206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14233),
  [18208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [18210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14294),
  [18212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3775),
  [18214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [18216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [18218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14290),
  [18220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4081),
  [18222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [18224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14275),
  [18226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14305),
  [18228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14262),
  [18230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15845),
  [18232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15846),
  [18234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12221),
  [18236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15470),
  [18238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15471),
  [18240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [18242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15798),
  [18244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15799),
  [18246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15869),
  [18248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15870),
  [18250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11601),
  [18252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15988),
  [18254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15989),
  [18256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15951),
  [18258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15952),
  [18260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16010),
  [18262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16011),
  [18264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15521),
  [18266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15522),
  [18268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16590),
  [18270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16591),
  [18272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [18274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14256),
  [18276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3903),
  [18278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [18280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14287),
  [18282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14276),
  [18284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4195),
  [18286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [18288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14317),
  [18290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14314),
  [18292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11569),
  [18294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [18296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11646),
  [18298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12262),
  [18300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14074),
  [18302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15629),
  [18304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15631),
  [18306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15615),
  [18308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15616),
  [18310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7305),
  [18312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17056),
  [18314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14043),
  [18316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12657),
  [18318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14226),
  [18320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15041),
  [18322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [18324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [18326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [18328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [18330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10282),
  [18332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3288),
  [18334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [18336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [18338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9787),
  [18340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11953),
  [18342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [18344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [18346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [18348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [18350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [18352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3289),
  [18354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [18356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [18358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3844),
  [18360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3846),
  [18362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3847),
  [18364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [18366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [18368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [18370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [18372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [18374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10449),
  [18376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [18378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11658),
  [18380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16861),
  [18382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14041),
  [18384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12743),
  [18386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14215),
  [18388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12640),
  [18390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14129),
  [18392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12068),
  [18394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16498),
  [18396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16501),
  [18398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7667),
  [18400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16879),
  [18402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14005),
  [18404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12428),
  [18406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14200),
  [18408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [18410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9831),
  [18412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [18414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7254),
  [18416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16848),
  [18418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14037),
  [18420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12590),
  [18422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14201),
  [18424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [18426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [18428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [18430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [18432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [18434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [18436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12124),
  [18438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [18440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [18442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [18444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12579),
  [18446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14024),
  [18448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11986),
  [18450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [18452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9382),
  [18454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [18456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14688),
  [18458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16539),
  [18460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16543),
  [18462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11917),
  [18464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15098),
  [18466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [18468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [18470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [18472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5908),
  [18474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [18476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [18478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [18480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11681),
  [18482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17285),
  [18484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14026),
  [18486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12738),
  [18488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14214),
  [18490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [18492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [18494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [18496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [18498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15864),
  [18500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15865),
  [18502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [18504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16870),
  [18506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14031),
  [18508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12534),
  [18510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14189),
  [18512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15945),
  [18514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15946),
  [18516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15174),
  [18518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [18520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [18522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [18524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [18526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [18528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10207),
  [18530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16934),
  [18532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13995),
  [18534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12731),
  [18536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14197),
  [18538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6920),
  [18540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17169),
  [18542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14040),
  [18544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12636),
  [18546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14198),
  [18548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17333),
  [18550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12761),
  [18552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14217),
  [18554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7162),
  [18556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17208),
  [18558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14023),
  [18560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12478),
  [18562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14192),
  [18564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [18566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [18568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [18570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [18572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [18574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10523),
  [18576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [18578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11456),
  [18580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16720),
  [18582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14011),
  [18584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12734),
  [18586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14213),
  [18588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6659),
  [18590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17124),
  [18592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14016),
  [18594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12445),
  [18596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14193),
  [18598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6633),
  [18600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17231),
  [18602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14035),
  [18604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12582),
  [18606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14194),
  [18608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [18610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [18612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5885),
  [18614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [18616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6798),
  [18618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17178),
  [18620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14125),
  [18622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12369),
  [18624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14199),
  [18626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17308),
  [18628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12763),
  [18630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14219),
  [18632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17334),
  [18634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12772),
  [18636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14222),
  [18638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17335),
  [18640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12782),
  [18642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14225),
  [18644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12853),
  [18646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14104),
  [18648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17336),
  [18650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12784),
  [18652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14228),
  [18654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [18656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17337),
  [18658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12787),
  [18660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14230),
  [18662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [18664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [18666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [18668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [18670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [18672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [18674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17338),
  [18676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12791),
  [18678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14191),
  [18680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12873),
  [18682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14121),
  [18684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12176),
  [18686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15162),
  [18688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11858),
  [18690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [18692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11778),
  [18694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [18696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [18698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4777),
  [18700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [18702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [18704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [18706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [18708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [18710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6648),
  [18712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [18714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16132),
  [18716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16197),
  [18718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [18720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12107),
  [18722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14239),
  [18724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17665),
  [18726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15292),
  [18728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17760),
  [18730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15598),
  [18732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15599),
  [18734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [18736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11267),
  [18738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [18740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [18742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10242),
  [18744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [18746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [18748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [18750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [18752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16343),
  [18754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16344),
  [18756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [18758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [18760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [18762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [18764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9440),
  [18766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [18768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [18770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7100),
  [18772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [18774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [18776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [18778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [18780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [18782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10517),
  [18784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [18786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [18788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11450),
  [18790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [18792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [18794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14509),
  [18796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [18798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [18800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6167),
  [18802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [18804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [18806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3532),
  [18808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [18810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [18812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [18814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11587),
  [18816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [18818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3496),
  [18820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [18822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5774),
  [18824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [18826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [18828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6405),
  [18830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [18832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14128),
  [18834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [18836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9574),
  [18838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [18840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [18842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [18844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [18846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13994),
  [18849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3423),
  [18851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 1, 0, 0),
  [18853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3497),
  [18855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3499),
  [18857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [18859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3501),
  [18861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9805),
  [18863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10758),
  [18865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [18867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3503),
  [18869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3504),
  [18871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3505),
  [18873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3506),
  [18875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [18877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [18879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [18881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3510),
  [18883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [18885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3512),
  [18887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3513),
  [18889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [18891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [18893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [18895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7155),
  [18897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [18899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [18901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14382),
  [18903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [18905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [18907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7071),
  [18909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [18911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [18913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11159),
  [18915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [18917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [18919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [18921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [18923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [18925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [18927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6494),
  [18929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [18931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13994),
  [18933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [18935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7963),
  [18937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [18939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [18941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10091),
  [18943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [18945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12579),
  [18948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3274),
  [18950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [18952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6290),
  [18954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [18956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [18958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [18960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [18962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [18964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7843),
  [18966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [18968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [18970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [18972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [18974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [18976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7658),
  [18978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [18980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [18982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5817),
  [18984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [18986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14128),
  [18989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12640),
  [18992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [18994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14141),
  [18996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [18998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6540),
  [19000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [19002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3496),
  [19005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [19007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9625),
  [19009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [19011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [19013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11095),
  [19015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [19017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3274),
  [19020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [19022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10029),
  [19024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [19026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [19028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [19030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [19032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [19034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [19036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [19038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [19040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [19042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [19044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [19046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7157),
  [19048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [19050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [19052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6456),
  [19054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [19056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [19058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4574),
  [19060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [19062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [19064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10890),
  [19066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [19068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [19070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [19072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [19074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [19076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7742),
  [19078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [19080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [19082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8655),
  [19084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [19086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [19088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [19090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [19092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [19094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7588),
  [19096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [19098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [19100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18143),
  [19102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [19104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [19106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6008),
  [19108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [19110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [19112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [19114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [19116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3761),
  [19119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3423),
  [19122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [19124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [19126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [19128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [19130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9776),
  [19132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12526),
  [19134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3185),
  [19136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [19138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3556),
  [19140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3557),
  [19142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3558),
  [19144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3561),
  [19146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [19148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [19150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3567),
  [19152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [19154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3578),
  [19156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3579),
  [19158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [19160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [19162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [19164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [19166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10127),
  [19168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [19170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [19172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6670),
  [19174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [19176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [19178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3761),
  [19180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14141),
  [19183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15147),
  [19185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [19187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11087),
  [19189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [19191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [19193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8631),
  [19195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [19197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [19199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9363),
  [19201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [19203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [19205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10777),
  [19207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [19209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [19211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [19213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7104),
  [19215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [19217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3735),
  [19219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3736),
  [19221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3738),
  [19223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9797),
  [19225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12821),
  [19227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3228),
  [19229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3739),
  [19231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3741),
  [19233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [19235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3743),
  [19237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3744),
  [19239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3745),
  [19241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [19243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3749),
  [19245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3751),
  [19247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3756),
  [19249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3757),
  [19251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3759),
  [19253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [19255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [19257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [19259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [19261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3199),
  [19263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [19265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12262),
  [19268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [19270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8056),
  [19272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [19274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [19276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [19278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12138),
  [19280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [19282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3769),
  [19284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3773),
  [19286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3774),
  [19288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9791),
  [19290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3230),
  [19292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3776),
  [19294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3777),
  [19296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3778),
  [19298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3779),
  [19300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3780),
  [19302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3781),
  [19304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3782),
  [19306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3783),
  [19308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3784),
  [19310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3785),
  [19312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3786),
  [19314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3787),
  [19316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [19318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5239),
  [19320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [19322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [19324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [19326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [19328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [19330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11710),
  [19332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [19334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3928),
  [19336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [19338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12844),
  [19340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14095),
  [19342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [19344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [19346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11309),
  [19348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [19350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14102),
  [19352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14102),
  [19355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12853),
  [19358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15151),
  [19360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [19362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12858),
  [19364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14110),
  [19366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15146),
  [19368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12866),
  [19370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14117),
  [19372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14120),
  [19374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [19376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5554),
  [19378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [19380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [19382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10798),
  [19384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [19386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14120),
  [19389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12873),
  [19392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12165),
  [19394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15150),
  [19396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [19398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6768),
  [19400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [19402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12188),
  [19404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15165),
  [19406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12196),
  [19408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15172),
  [19410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15169),
  [19412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [19414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15175),
  [19416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [19418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6458),
  [19420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [19422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [19424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [19426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14411),
  [19428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [19430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [19432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [19434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14514),
  [19436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14514),
  [19438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14413),
  [19440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14521),
  [19442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14523),
  [19444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14791),
  [19446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14792),
  [19448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3220),
  [19450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [19452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [19454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11230),
  [19456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [19458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [19460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [19462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11459),
  [19464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11546),
  [19466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12568),
  [19468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14012),
  [19470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11900),
  [19472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14772),
  [19474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [19476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9820),
  [19478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [19480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9939),
  [19482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [19484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3551),
  [19486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3317),
  [19489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [19491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10458),
  [19493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11179),
  [19495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3551),
  [19498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [19500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [19502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4465),
  [19504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [19506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [19508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [19510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [19512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6574),
  [19514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [19516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [19518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [19520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7150),
  [19522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [19524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [19526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [19528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [19530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [19532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [19534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6801),
  [19536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6817),
  [19538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [19540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [19542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [19544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [19546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0),
  [19548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0),
  [19550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [19552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [19554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10300),
  [19556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [19558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10760),
  [19560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [19562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [19564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [19566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [19568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [19570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5596),
  [19572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [19574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [19576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7176),
  [19578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [19580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [19582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [19584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8281),
  [19586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [19588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [19590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6639),
  [19592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [19594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [19596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [19598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7647),
  [19600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7347),
  [19602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9521),
  [19604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [19606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [19608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [19610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9556),
  [19612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9556),
  [19614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9549),
  [19616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9557),
  [19618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9563),
  [19620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15032),
  [19622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15033),
  [19624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3822),
  [19626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3823),
  [19628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [19630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3826),
  [19632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9803),
  [19634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3164),
  [19636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3942),
  [19638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3971),
  [19640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [19642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3837),
  [19644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4099),
  [19646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4102),
  [19648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4125),
  [19650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4148),
  [19652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4223),
  [19654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4224),
  [19656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4227),
  [19658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4228),
  [19660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [19662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [19664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [19666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5763),
  [19668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6551),
  [19670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [19672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [19674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17483),
  [19676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [19678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [19680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6602),
  [19682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [19684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [19686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [19688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6913),
  [19690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [19692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [19694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6171),
  [19696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [19698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [19700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [19702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6654),
  [19704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6796),
  [19706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [19708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [19710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [19712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [19714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [19716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [19718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [19720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9848),
  [19722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10054),
  [19724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [19726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [19728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [19730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9319),
  [19732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9470),
  [19734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [19736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [19738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3637),
  [19740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9280),
  [19742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9401),
  [19744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3637),
  [19747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [19749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [19751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10293),
  [19753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10532),
  [19755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9800),
  [19757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [19759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [19761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [19763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [19765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [19767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [19769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7577),
  [19771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14328),
  [19773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14376),
  [19775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [19777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [19779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [19781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [19783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [19785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [19787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [19789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7007),
  [19791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7209),
  [19793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [19795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [19797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [19799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6413),
  [19801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [19803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [19805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [19807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [19809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [19811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [19813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11398),
  [19815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [19817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [19819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [19821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11619),
  [19823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11625),
  [19825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [19827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [19829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10550),
  [19831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11332),
  [19833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [19835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [19837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [19839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [19841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [19843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [19845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [19847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9571),
  [19849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [19851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [19853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [19855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9634),
  [19857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9634),
  [19859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9602),
  [19861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9629),
  [19863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9653),
  [19865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14973),
  [19867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14974),
  [19869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [19871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [19873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [19875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [19877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [19879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [19881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [19883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [19885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [19887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [19889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [19891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7654),
  [19893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [19895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [19897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6479),
  [19899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [19901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [19903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [19905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7062),
  [19907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7171),
  [19909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [19911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [19913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [19915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6212),
  [19917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10194),
  [19919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [19921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10382),
  [19923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3636),
  [19925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3640),
  [19927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [19929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3645),
  [19931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9807),
  [19933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3186),
  [19935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3648),
  [19937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3660),
  [19939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3663),
  [19941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3666),
  [19943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3674),
  [19945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3676),
  [19947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3681),
  [19949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3683),
  [19951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3684),
  [19953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3685),
  [19955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3686),
  [19957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3687),
  [19959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [19961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [19963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [19965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11502),
  [19967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12235),
  [19969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [19971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [19973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [19975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6402),
  [19977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10184),
  [19979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [19981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [19983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [19985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10301),
  [19987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [19989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [19991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [19993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [19995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [19997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [19999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10383),
  [20001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11080),
  [20003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [20005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [20007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [20009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [20011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [20013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6217),
  [20015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [20017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [20019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [20021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6643),
  [20023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6684),
  [20025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [20027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5790),
  [20029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [20031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [20033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [20035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3643),
  [20037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3644),
  [20039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [20041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3647),
  [20043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9764),
  [20045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3207),
  [20047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3649),
  [20049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3650),
  [20051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3651),
  [20053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3652),
  [20055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3655),
  [20057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3661),
  [20059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3662),
  [20061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3665),
  [20063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [20065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3668),
  [20067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3669),
  [20069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3670),
  [20071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [20073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [20075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [20077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [20079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [20081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7789),
  [20083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6495),
  [20085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [20087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [20089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [20091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7089),
  [20093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6904),
  [20095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [20097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6367),
  [20099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [20101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [20103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5909),
  [20105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [20107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [20109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10287),
  [20111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [20113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10866),
  [20115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [20117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [20119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [20121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [20123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [20125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4817),
  [20127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11384),
  [20129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [20131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [20133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [20135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11792),
  [20137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11792),
  [20139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11530),
  [20141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11803),
  [20143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11604),
  [20145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15143),
  [20147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15144),
  [20149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4492),
  [20151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [20153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6660),
  [20155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [20157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [20159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [20161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7942),
  [20163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6504),
  [20165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [20167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [20169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [20171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7216),
  [20173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7228),
  [20175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11407),
  [20177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [20179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [20181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [20183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11834),
  [20185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11642),
  [20187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10833),
  [20189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11333),
  [20191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [20193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [20195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6063),
  [20197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15494),
  [20199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [20201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [20203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [20205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17674),
  [20207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [20209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [20211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10368),
  [20213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10987),
  [20215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7035),
  [20217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [20219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [20221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [20223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8596),
  [20225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6690),
  [20227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [20229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [20231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [20233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7292),
  [20235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8035),
  [20237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5543),
  [20239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6573),
  [20241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [20243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6121),
  [20245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [20247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [20249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [20251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [20253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [20255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6006),
  [20257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [20259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [20261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10261),
  [20263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9949),
  [20265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10128),
  [20267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [20269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [20271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [20273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [20275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [20277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [20279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [20281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [20283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12807),
  [20285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14059),
  [20287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3187),
  [20289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3203),
  [20291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3215),
  [20293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14093),
  [20295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14093),
  [20298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12844),
  [20301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14108),
  [20303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14108),
  [20306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12858),
  [20309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14114),
  [20311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14114),
  [20314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12866),
  [20317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12032),
  [20319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15122),
  [20321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12826),
  [20323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14083),
  [20325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12146),
  [20327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15145),
  [20329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15168),
  [20331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [20333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15170),
  [20335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15173),
  [20337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [20339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [20341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4037),
  [20343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4038),
  [20345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4039),
  [20347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4040),
  [20349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4041),
  [20351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4042),
  [20353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4043),
  [20355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4044),
  [20357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4045),
  [20359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4046),
  [20361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4047),
  [20363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4048),
  [20365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4049),
  [20367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4050),
  [20369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4051),
  [20371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15153),
  [20373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [20375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4067),
  [20377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4053),
  [20379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4054),
  [20381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4055),
  [20383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4056),
  [20385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [20387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4058),
  [20389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4059),
  [20391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4060),
  [20393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4061),
  [20395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4062),
  [20397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4063),
  [20399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4064),
  [20401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4065),
  [20403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4066),
  [20405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3401),
  [20408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3872),
  [20410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [20413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 0), SHIFT(1997),
  [20416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 0), REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [20419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT(1997),
  [20422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3937),
  [20425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14116),
  [20428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [20430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3416),
  [20432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3417),
  [20434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [20436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3452),
  [20438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9782),
  [20440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3148),
  [20442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [20444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [20446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3471),
  [20448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [20450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3481),
  [20452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3482),
  [20454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3517),
  [20456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3518),
  [20458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3525),
  [20460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [20462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3540),
  [20464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [20466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [20468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [20470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12568),
  [20473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3872),
  [20476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3882),
  [20479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14116),
  [20481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14056),
  [20483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3733),
  [20485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3734),
  [20487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3767),
  [20489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9783),
  [20491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3157),
  [20493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3367),
  [20495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3383),
  [20497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3791),
  [20499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3794),
  [20501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3816),
  [20503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3817),
  [20505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3940),
  [20507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3943),
  [20509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4127),
  [20511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4225),
  [20513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4226),
  [20515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3272),
  [20517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14056),
  [20520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12807),
  [20523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_clause, 2, 0, 0),
  [20525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 2, 0, 0),
  [20527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [20529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3956),
  [20531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [20533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [20535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [20537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [20539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [20541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [20543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3957),
  [20545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [20547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [20549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3964),
  [20551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3965),
  [20553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3966),
  [20555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [20557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [20559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [20561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [20563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3385),
  [20565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3386),
  [20567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3387),
  [20569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3388),
  [20571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [20573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3390),
  [20575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [20577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [20579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [20581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3394),
  [20583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3396),
  [20585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [20587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3399),
  [20589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3402),
  [20591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [20593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3344),
  [20595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3346),
  [20597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [20599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3352),
  [20601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3353),
  [20603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3354),
  [20605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [20607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [20609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [20611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3359),
  [20613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3343),
  [20615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3347),
  [20617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3348),
  [20619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3349),
  [20621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3350),
  [20623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 1, 0, 0),
  [20625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [20627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [20629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [20631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14081),
  [20633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(14081),
  [20636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(12826),
  [20639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15158),
  [20641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15155),
  [20643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3945),
  [20645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3979),
  [20647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3980),
  [20649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3981),
  [20651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3982),
  [20653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3983),
  [20655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3984),
  [20657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3985),
  [20659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3986),
  [20661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3614),
  [20663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3615),
  [20665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3616),
  [20667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3617),
  [20669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3618),
  [20671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3620),
  [20673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3621),
  [20675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3622),
  [20677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3624),
  [20679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3625),
  [20681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3626),
  [20683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3627),
  [20685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3628),
  [20687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3629),
  [20689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3630),
  [20691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3944),
  [20693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3946),
  [20695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3975),
  [20697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3976),
  [20699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3948),
  [20701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3951),
  [20703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3457),
  [20705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3458),
  [20707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3454),
  [20709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3455),
  [20711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3456),
  [20713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3422),
  [20715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3450),
  [20717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3451),
  [20719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [20721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [20723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(4242),
  [20726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3283),
  [20728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [20730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3710),
  [20732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3711),
  [20734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3712),
  [20736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3713),
  [20738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3731),
  [20740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3732),
  [20742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3874),
  [20744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3875),
  [20746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3591),
  [20748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3592),
  [20750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3634),
  [20752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3635),
  [20754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3638),
  [20756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3680),
  [20758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3688),
  [20760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3689),
  [20762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3690),
  [20764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3692),
  [20766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3279),
  [20768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [20770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3339),
  [20772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3464),
  [20774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3533),
  [20776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3577),
  [20778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [20780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3590),
  [20782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [20784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3609),
  [20786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3611),
  [20788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3613),
  [20790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3632),
  [20792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3444),
  [20794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [20796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [20798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [20800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3447),
  [20802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [20804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [20806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [20808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [20810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [20812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [20814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [20816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [20818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [20820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3646),
  [20822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [20824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [20826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3664),
  [20828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3671),
  [20830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3672),
  [20832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [20834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [20836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [20838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [20840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [20842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4156),
  [20844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [20846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [20848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [20850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4163),
  [20852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [20854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [20856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4158),
  [20858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [20860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [20862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4172),
  [20864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4174),
  [20866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4177),
  [20868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [20870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [20872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [20874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(4153),
  [20877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4151),
  [20879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [20881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [20883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4183),
  [20885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4186),
  [20887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4187),
  [20889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [20891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [20893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [20895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4110),
  [20897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4111),
  [20899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [20901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [20903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [20905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3820),
  [20907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3824),
  [20909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3831),
  [20911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3849),
  [20913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3853),
  [20915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3855),
  [20917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [20919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3861),
  [20921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3862),
  [20923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3863),
  [20925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3819),
  [20927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3825),
  [20929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3827),
  [20931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3828),
  [20933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3830),
  [20935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3341),
  [20937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3410),
  [20939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3412),
  [20941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3413),
  [20943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3415),
  [20945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [20947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [20949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3384),
  [20951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3409),
  [20953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [20955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [20957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [20959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4154),
  [20961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [20963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [20965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [20967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [20969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [20971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [20973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [20975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [20977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3884),
  [20979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [20981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [20983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3894),
  [20985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3896),
  [20987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3897),
  [20989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [20991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [20993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [20995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [20997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [20999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [21001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [21003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [21005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [21007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4231),
  [21009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [21011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4232),
  [21013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [21015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [21017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3992),
  [21019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3993),
  [21021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3994),
  [21023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [21025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [21027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [21029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [21031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [21033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [21035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [21037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [21039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3930),
  [21042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4015),
  [21044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [21046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4016),
  [21048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [21050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [21052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4109),
  [21054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [21056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [21058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [21060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [21062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [21064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [21066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3342),
  [21068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3340),
  [21070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3362),
  [21072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3380),
  [21074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3381),
  [21076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3382),
  [21078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [21080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [21082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [21084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [21086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10810),
  [21088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [21090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [21092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [21094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [21096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [21098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [21100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [21102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [21104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [21106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [21108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [21110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [21112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10312),
  [21114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [21116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6206),
  [21118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [21120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9601),
  [21122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2832),
  [21124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [21126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [21128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [21130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [21132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12044),
  [21134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [21136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [21138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [21140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9641),
  [21142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [21144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [21146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [21148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [21150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [21152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [21154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8148),
  [21156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [21158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9990),
  [21160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [21162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3715),
  [21164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [21166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3717),
  [21168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [21170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [21172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3724),
  [21174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3725),
  [21176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3726),
  [21178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [21180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [21182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [21184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [21186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [21188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [21190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7636),
  [21192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [21194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [21196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [21198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [21200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [21202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [21204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [21206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [21208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3920),
  [21210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [21212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [21214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [21216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [21218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [21220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [21222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3921),
  [21224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [21226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [21228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4132),
  [21230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4133),
  [21232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4134),
  [21234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [21236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [21238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [21240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3746),
  [21242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [21244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3747),
  [21246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [21248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [21250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3764),
  [21252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3765),
  [21254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3768),
  [21256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [21258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [21260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [21262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [21264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [21266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [21268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6234),
  [21270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [21272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [21274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [21276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [21278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [21280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2990),
  [21282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 0),
  [21284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [21286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [21288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9464),
  [21290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [21292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7085),
  [21294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [21296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [21298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [21300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [21302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6816),
  [21304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [21306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [21308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [21310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [21312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [21314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [21316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [21318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9407),
  [21320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [21322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [21324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [21326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5674),
  [21328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [21330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5485),
  [21332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [21334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [21336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [21338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10474),
  [21340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [21342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [21344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [21346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [21348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11441),
  [21350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [21352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9586),
  [21354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [21356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14428),
  [21358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [21360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [21362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11666),
  [21364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [21366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [21368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [21370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [21372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14367),
  [21374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [21376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [21378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10857),
  [21380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [21382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7706),
  [21384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [21386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [21388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [21390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [21392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [21394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0),
  [21396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [21398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [21400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [21402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [21404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [21406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [21408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6351),
  [21410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [21412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3067),
  [21414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [21416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6415),
  [21418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [21420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [21422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [21424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5640),
  [21426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [21428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3180),
  [21430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [21432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [21434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11738),
  [21436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [21438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [21440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [21442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [21444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [21446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11115),
  [21448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [21450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [21452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [21454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [21456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6924),
  [21458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [21460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [21462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [21464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [21466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [21468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [21470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [21472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [21474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [21476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [21478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11138),
  [21480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [21482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [21484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5799),
  [21486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [21488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [21490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [21492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7790),
  [21494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [21496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [21498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [21500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5917),
  [21502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [21504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6912),
  [21506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [21508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [21510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [21512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [21514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [21516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10105),
  [21518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [21520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [21522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [21524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6708),
  [21526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [21528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [21530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [21532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [21534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [21536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [21538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [21540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [21542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [21544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [21546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10879),
  [21548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_vector_expression_repeat1, 2, 0, 0),
  [21550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [21552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [21554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [21556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [21558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7288),
  [21560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [21562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [21564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [21566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [21568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [21570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6780),
  [21572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [21574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [21576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5046),
  [21578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [21580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [21582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4818),
  [21584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [21586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [21588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [21590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [21592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [21594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7924),
  [21596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [21598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [21600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [21602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [21604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [21606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7142),
  [21608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [21610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [21612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_field, 3, 0, 0),
  [21614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [21616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [21618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6023),
  [21620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [21622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6613),
  [21624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [21626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [21628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11307),
  [21630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [21632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [21634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [21636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [21638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [21640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [21642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [21644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8005),
  [21646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [21648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [21650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [21652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [21654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6859),
  [21656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [21658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11334),
  [21660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [21662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [21664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [21666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [21668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [21670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [21672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [21674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11689),
  [21676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [21678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [21680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [21682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11126),
  [21684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [21686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10148),
  [21688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [21690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [21692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6567),
  [21694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [21696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [21698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14517),
  [21700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [21702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [21704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8661),
  [21706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [21708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8071),
  [21710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [21712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6154),
  [21714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [21716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [21718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [21720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [21722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [21724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [21726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12286),
  [21728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14206),
  [21730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12438),
  [21732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14203),
  [21734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [21736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8256),
  [21738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13997),
  [21740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12420),
  [21742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14216),
  [21744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7290),
  [21746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14036),
  [21748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12588),
  [21750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14220),
  [21752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7116),
  [21754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14014),
  [21756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12441),
  [21758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14188),
  [21760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12717),
  [21762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14231),
  [21764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8386),
  [21766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14042),
  [21768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12656),
  [21770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14196),
  [21772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [21774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14034),
  [21776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12580),
  [21778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14185),
  [21780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3253),
  [21782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [21784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3254),
  [21786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [21788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [21790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3261),
  [21792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3262),
  [21794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3263),
  [21796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [21798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [21800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [21802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [21804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [21806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [21808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [21810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12754),
  [21812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14212),
  [21814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7298),
  [21816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14038),
  [21818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12635),
  [21820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14186),
  [21822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7859),
  [21824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14019),
  [21826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12470),
  [21828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14187),
  [21830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12644),
  [21832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14211),
  [21834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12756),
  [21836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14181),
  [21838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8015),
  [21840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14027),
  [21842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12523),
  [21844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14210),
  [21846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12766),
  [21848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14218),
  [21850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12778),
  [21852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14223),
  [21854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12783),
  [21856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14227),
  [21858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12504),
  [21860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14209),
  [21862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7079),
  [21864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14088),
  [21866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12352),
  [21868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14208),
  [21870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12785),
  [21872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14229),
  [21874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12790),
  [21876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14205),
  [21878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [21880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3877),
  [21882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3913),
  [21884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3914),
  [21886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3916),
  [21888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [21890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [21892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [21894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [21896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [21898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [21900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [21902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [21904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [21906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [21908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3878),
  [21910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [21912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [21914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [21916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [21918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [21920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [21922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [21924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3490),
  [21926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3527),
  [21928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3528),
  [21930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [21932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [21934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [21936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [21938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [21940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [21942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [21944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [21946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16393),
  [21948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16080),
  [21950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9796),
  [21952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9783),
  [21954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10758),
  [21956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11670),
  [21958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [21960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6641),
  [21962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [21964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6620),
  [21966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6196),
  [21968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6836),
  [21970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7361),
  [21972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8423),
  [21974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8588),
  [21976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7910),
  [21978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7349),
  [21980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [21982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7183),
  [21984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10394),
  [21986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8083),
  [21988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7161),
  [21990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6922),
  [21992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [21994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6636),
  [21996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8954),
  [21998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7541),
  [22000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6987),
  [22002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8397),
  [22004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7433),
  [22006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6503),
  [22008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6909),
  [22010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17804),
  [22012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [22014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6622),
  [22016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14394),
  [22018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17138),
  [22020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7534),
  [22022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11901),
  [22024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8288),
  [22026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11952),
  [22028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8956),
  [22030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8282),
  [22032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5833),
  [22034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6557),
  [22036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6200),
  [22038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6695),
  [22040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8686),
  [22042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11141),
  [22044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17857),
  [22046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10668),
  [22048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18061),
  [22050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10052),
  [22052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17933),
  [22054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10033),
  [22056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9993),
  [22058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17976),
  [22060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9922),
  [22062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10549),
  [22064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17721),
  [22066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9984),
  [22068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5498),
  [22070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17537),
  [22072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9888),
  [22074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12194),
  [22076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17782),
  [22078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10024),
  [22080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [22082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17892),
  [22084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9858),
  [22086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10505),
  [22088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17864),
  [22090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9973),
  [22092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [22094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17628),
  [22096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [22098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18006),
  [22100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [22102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17945),
  [22104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9931),
  [22106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5028),
  [22108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17391),
  [22110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9891),
  [22112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6391),
  [22114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17643),
  [22116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9367),
  [22118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17580),
  [22120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9915),
  [22122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9894),
  [22124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5787),
  [22126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17710),
  [22128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9976),
  [22130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [22132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18131),
  [22134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6021),
  [22136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17461),
  [22138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4992),
  [22140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18062),
  [22142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6420),
  [22144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17347),
  [22146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10156),
  [22148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17438),
  [22150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6476),
  [22152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17548),
  [22154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [22156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17885),
  [22158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9867),
  [22160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9920),
  [22162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [22164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17562),
  [22166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9868),
  [22168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14369),
  [22170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17690),
  [22172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9959),
  [22174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5924),
  [22176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18100),
  [22178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6400),
  [22180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17601),
  [22182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5768),
  [22184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17763),
  [22186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5457),
  [22188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17388),
  [22190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11365),
  [22192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17502),
  [22194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4976),
  [22196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18109),
  [22198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9991),
  [22200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10869),
  [22202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18091),
  [22204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11125),
  [22206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17499),
  [22208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5666),
  [22210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17489),
  [22212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6237),
  [22214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17703),
  [22216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [22218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17902),
  [22220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6577),
  [22222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18014),
  [22224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9866),
  [22226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6080),
  [22228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17463),
  [22230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9456),
  [22232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17366),
  [22234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9903),
  [22236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11164),
  [22238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17590),
  [22240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11235),
  [22242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17540),
  [22244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9909),
  [22246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [22248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17737),
  [22250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6252),
  [22252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17631),
  [22254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [22256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14374),
  [22258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0),
  [22260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3954),
  [22263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1997),
  [22266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(16068),
  [22269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__comprehension_clause, 4, 0, 0),
  [22271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3954),
  [22273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [22275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14540),
  [22277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__comprehension_clause, 3, 0, 0),
  [22279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14539),
  [22281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14352),
  [22283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14270),
  [22285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18044),
  [22287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15217),
  [22289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18118),
  [22291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__comprehension_clause, 2, 0, 0),
  [22293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14537),
  [22295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15728),
  [22297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15729),
  [22299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14524),
  [22301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [22303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [22305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14504),
  [22307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [22309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10448),
  [22311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4101),
  [22313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3149),
  [22315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14944),
  [22317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [22319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9418),
  [22321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [22323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14394),
  [22325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [22327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [22329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15023),
  [22331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9788),
  [22333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18004),
  [22335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18017),
  [22337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10519),
  [22339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5907),
  [22341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [22343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15117),
  [22345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15802),
  [22347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15804),
  [22349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15060),
  [22351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4101),
  [22354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3149),
  [22357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(16280),
  [22360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10280),
  [22362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [22364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18075),
  [22366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15017),
  [22368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18084),
  [22370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18092),
  [22372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18097),
  [22374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18101),
  [22376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [22378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18104),
  [22380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18106),
  [22382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18108),
  [22384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18110),
  [22386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18112),
  [22388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18114),
  [22390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14618),
  [22392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3285),
  [22395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(16478),
  [22398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__comprehension_clause, 1, 0, 0),
  [22400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14473),
  [22402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9842),
  [22404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [22406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16160),
  [22408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0),
  [22410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [22412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 3, 0, 0),
  [22414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 0),
  [22416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_clause, 2, 0, 0),
  [22418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 2, 0, 0),
  [22420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [22422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1699),
  [22425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clause, 3, 0, 0),
  [22427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [22429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clause, 4, 0, 0),
  [22431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clause, 5, 0, 0),
  [22433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14492),
  [22435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14511),
  [22437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1856),
  [22440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17320),
  [22442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14889),
  [22444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10178),
  [22446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [22448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14553),
  [22450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7602),
  [22452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17142),
  [22454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14554),
  [22456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7603),
  [22458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14561),
  [22460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10266),
  [22462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15088),
  [22464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7606),
  [22466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15031),
  [22468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7607),
  [22470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14562),
  [22472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10269),
  [22474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8958),
  [22476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [22478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8971),
  [22480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [22482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [22484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [22486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10302),
  [22488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10306),
  [22490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [22492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [22494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14568),
  [22496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6440),
  [22498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14569),
  [22500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6444),
  [22502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6245),
  [22504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5971),
  [22506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [22508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [22510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [22512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1803),
  [22515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1803),
  [22518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14580),
  [22520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7049),
  [22522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14581),
  [22524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6917),
  [22526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9072),
  [22528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6900),
  [22530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6901),
  [22532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9074),
  [22534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [22536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [22538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [22540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [22542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14610),
  [22544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14380),
  [22546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14611),
  [22548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14351),
  [22550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9873),
  [22552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12638),
  [22554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14593),
  [22556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6705),
  [22558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14594),
  [22560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6706),
  [22562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6744),
  [22564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6745),
  [22566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [22568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [22570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9119),
  [22572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [22574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14603),
  [22576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [22578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14604),
  [22580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [22582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [22584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [22586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [22588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [22590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10586),
  [22592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10587),
  [22594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14363),
  [22596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14389),
  [22598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14614),
  [22600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7669),
  [22602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14615),
  [22604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7670),
  [22606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7672),
  [22608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7673),
  [22610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [22612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [22614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [22616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14624),
  [22618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5447),
  [22620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14627),
  [22622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5449),
  [22624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14967),
  [22626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [22628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14978),
  [22630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5610),
  [22632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [22634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14628),
  [22636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6881),
  [22638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14629),
  [22640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6894),
  [22642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5480),
  [22644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6965),
  [22646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6986),
  [22648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8807),
  [22650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [22652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [22654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8808),
  [22656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14652),
  [22658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6388),
  [22660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14653),
  [22662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6397),
  [22664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1905),
  [22667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1905),
  [22670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14643),
  [22672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [22674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14644),
  [22676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [22678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [22680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [22682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [22684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5327),
  [22686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9946),
  [22688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12642),
  [22690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12300),
  [22692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [22694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [22696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6280),
  [22698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6363),
  [22700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14656),
  [22702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11685),
  [22704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14657),
  [22706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11686),
  [22708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11693),
  [22710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11694),
  [22712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [22714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [22716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12301),
  [22718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11296),
  [22720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14720),
  [22722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [22724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [22726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14668),
  [22728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11076),
  [22730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14669),
  [22732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10934),
  [22734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11082),
  [22736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11083),
  [22738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [22740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [22742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [22744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14726),
  [22746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [22748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7808),
  [22750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7809),
  [22752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14679),
  [22754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5455),
  [22756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14680),
  [22758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [22760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5497),
  [22762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5500),
  [22764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [22766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [22768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [22770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [22772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11297),
  [22774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9893),
  [22776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12608),
  [22778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9960),
  [22780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12572),
  [22782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14691),
  [22784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [22786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14692),
  [22788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6109),
  [22790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6113),
  [22792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6114),
  [22794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14706),
  [22796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10116),
  [22798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14712),
  [22800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10117),
  [22802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [22804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [22806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12135),
  [22808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12142),
  [22810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14703),
  [22812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [22814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14704),
  [22816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [22818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [22820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [22822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10088),
  [22824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [22826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [22828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7854),
  [22830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7855),
  [22832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10094),
  [22834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14715),
  [22836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7745),
  [22838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14716),
  [22840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7746),
  [22842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8106),
  [22844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7750),
  [22846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [22848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [22850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [22852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14724),
  [22854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6848),
  [22856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14725),
  [22858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6849),
  [22860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6919),
  [22862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6942),
  [22864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [22866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [22868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [22870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [22872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7903),
  [22874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [22876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14735),
  [22878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5831),
  [22880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14736),
  [22882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5832),
  [22884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [22886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5838),
  [22888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [22890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [22892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14743),
  [22894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10598),
  [22896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14744),
  [22898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10599),
  [22900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10616),
  [22902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10621),
  [22904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [22906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [22908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [22910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [22912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9983),
  [22914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12647),
  [22916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14754),
  [22918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6929),
  [22920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14755),
  [22922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6930),
  [22924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6936),
  [22926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6938),
  [22928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [22930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [22932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8234),
  [22934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14763),
  [22936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6699),
  [22938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14764),
  [22940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6701),
  [22942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6709),
  [22944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6710),
  [22946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8871),
  [22948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8873),
  [22950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14778),
  [22952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [22954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [22956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [22958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14779),
  [22960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4932),
  [22962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9940),
  [22964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12569),
  [22966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14776),
  [22968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [22970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14777),
  [22972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [22974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [22976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4787),
  [22978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5020),
  [22980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5021),
  [22982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [22984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [22986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10569),
  [22988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [22990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14787),
  [22992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7863),
  [22994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14788),
  [22996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7864),
  [22998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7866),
  [23000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7867),
  [23002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [23004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [23006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14802),
  [23008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14482),
  [23010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14803),
  [23012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14483),
  [23014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [23016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [23018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14799),
  [23020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7170),
  [23022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14800),
  [23024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7173),
  [23026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7187),
  [23028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [23030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14508),
  [23032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14512),
  [23034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [23036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [23038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11962),
  [23040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11975),
  [23042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14811),
  [23044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5267),
  [23046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14812),
  [23048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [23050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [23052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [23054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [23056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [23058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8699),
  [23060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8700),
  [23062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [23064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14821),
  [23066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5967),
  [23068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14822),
  [23070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5968),
  [23072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5972),
  [23074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [23076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [23078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [23080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [23082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [23084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14831),
  [23086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11248),
  [23088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14832),
  [23090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11249),
  [23092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11255),
  [23094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11256),
  [23096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [23098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [23100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14839),
  [23102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6011),
  [23104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14840),
  [23106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6012),
  [23108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6018),
  [23110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6019),
  [23112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8342),
  [23114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [23116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [23118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8346),
  [23120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14849),
  [23122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7967),
  [23124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14850),
  [23126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7968),
  [23128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [23130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7971),
  [23132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7972),
  [23134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [23136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [23138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [23140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14858),
  [23142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7239),
  [23144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14859),
  [23146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7242),
  [23148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9999),
  [23150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12648),
  [23152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7277),
  [23154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [23156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [23158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [23160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8327),
  [23162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14867),
  [23164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [23166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14868),
  [23168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5356),
  [23170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12020),
  [23172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [23174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5361),
  [23176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [23178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [23180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14875),
  [23182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11802),
  [23184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14876),
  [23186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11804),
  [23188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11808),
  [23190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11809),
  [23192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [23194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [23196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14890),
  [23198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10180),
  [23200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14883),
  [23202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11174),
  [23204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14884),
  [23206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11176),
  [23208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11189),
  [23210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11191),
  [23212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [23214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [23216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [23218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [23220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10129),
  [23222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10130),
  [23224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14893),
  [23226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6512),
  [23228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14894),
  [23230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6513),
  [23232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6518),
  [23234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6520),
  [23236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [23238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [23240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14949),
  [23242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6485),
  [23244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14956),
  [23246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6487),
  [23248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14921),
  [23250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5892),
  [23252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9936),
  [23254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12605),
  [23256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14904),
  [23258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18031),
  [23260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14905),
  [23262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18040),
  [23264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18055),
  [23266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18056),
  [23268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [23270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [23272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14941),
  [23274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5893),
  [23276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14913),
  [23278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8599),
  [23280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14914),
  [23282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8600),
  [23284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8910),
  [23286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8619),
  [23288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8620),
  [23290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14928),
  [23292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9428),
  [23294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [23296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [23298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14931),
  [23300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9420),
  [23302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15025),
  [23304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10755),
  [23306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5901),
  [23308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12620),
  [23310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14926),
  [23312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8038),
  [23314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14663),
  [23316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11292),
  [23318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12624),
  [23320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8041),
  [23322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8042),
  [23324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9459),
  [23326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [23328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [23330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9460),
  [23332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [23334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14937),
  [23336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6118),
  [23338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14938),
  [23340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6119),
  [23342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [23344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6124),
  [23346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6125),
  [23348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [23350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [23352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5905),
  [23354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10012),
  [23356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12575),
  [23358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [23360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [23362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [23364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10011),
  [23366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12649),
  [23368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6600),
  [23370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12686),
  [23372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12687),
  [23374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12721),
  [23376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6607),
  [23378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [23380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [23382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15034),
  [23384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10756),
  [23386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14992),
  [23388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10370),
  [23390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9943),
  [23392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12664),
  [23394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14993),
  [23396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10372),
  [23398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14970),
  [23400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9392),
  [23402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14971),
  [23404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9394),
  [23406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5664),
  [23408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14987),
  [23410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5844),
  [23412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14988),
  [23414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5850),
  [23416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9412),
  [23418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9413),
  [23420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [23422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14982),
  [23424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9620),
  [23426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14983),
  [23428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9635),
  [23430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [23432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14990),
  [23434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6462),
  [23436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14994),
  [23438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6091),
  [23440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [23442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [23444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9650),
  [23446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9624),
  [23448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [23450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [23452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10030),
  [23454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12650),
  [23456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5898),
  [23458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [23460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6410),
  [23462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10381),
  [23464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10388),
  [23466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6439),
  [23468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8408),
  [23470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10659),
  [23472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8409),
  [23474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15071),
  [23476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9986),
  [23478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15112),
  [23480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9954),
  [23482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [23484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [23486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [23488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [23490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9953),
  [23492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12665),
  [23494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15019),
  [23496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11454),
  [23498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15020),
  [23500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11457),
  [23502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15051),
  [23504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [23506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15056),
  [23508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [23510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8468),
  [23512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8469),
  [23514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14281),
  [23516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11551),
  [23518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11555),
  [23520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15036),
  [23522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12173),
  [23524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8573),
  [23526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15045),
  [23528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11890),
  [23530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10763),
  [23532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [23534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [23536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10035),
  [23538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12651),
  [23540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12331),
  [23542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(17142),
  [23545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(15031),
  [23548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [23550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15039),
  [23552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9595),
  [23554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15040),
  [23556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9596),
  [23558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10764),
  [23560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12332),
  [23562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11879),
  [23564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [23566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [23568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9578),
  [23570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9579),
  [23572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10002),
  [23574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12611),
  [23576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15044),
  [23578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10536),
  [23580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15046),
  [23582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10537),
  [23584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10617),
  [23586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11916),
  [23588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10618),
  [23590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10920),
  [23592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [23594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [23596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5008),
  [23598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7458),
  [23600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7459),
  [23602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [23604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [23606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [23608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7421),
  [23610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7486),
  [23612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7487),
  [23614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7422),
  [23616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [23618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [23620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15072),
  [23622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6298),
  [23624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15073),
  [23626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6299),
  [23628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9948),
  [23630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6304),
  [23632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6305),
  [23634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7502),
  [23636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9957),
  [23638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12666),
  [23640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [23642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [23644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9877),
  [23646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12654),
  [23648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15086),
  [23650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10958),
  [23652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15087),
  [23654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11039),
  [23656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [23658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [23660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11035),
  [23662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11056),
  [23664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(17320),
  [23667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(15088),
  [23670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [23672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [23674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15101),
  [23676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8745),
  [23678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15104),
  [23680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8746),
  [23682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8521),
  [23684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8522),
  [23686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9997),
  [23688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12662),
  [23690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15106),
  [23692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7248),
  [23694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [23696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8758),
  [23698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [23700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15107),
  [23702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7250),
  [23704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8759),
  [23706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10027),
  [23708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12596),
  [23710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7264),
  [23712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7266),
  [23714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8570),
  [23716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8572),
  [23718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9998),
  [23720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [23722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [23724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8639),
  [23726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9925),
  [23728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12659),
  [23730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [23732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [23734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [23736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [23738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9859),
  [23740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12840),
  [23742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14686),
  [23744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11293),
  [23746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15129),
  [23748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [23750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15130),
  [23752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5409),
  [23754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7535),
  [23756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7536),
  [23758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [23760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [23762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15133),
  [23764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6661),
  [23766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15134),
  [23768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6662),
  [23770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6667),
  [23772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6668),
  [23774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8197),
  [23776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8198),
  [23778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [23780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [23782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9870),
  [23784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12660),
  [23786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15156),
  [23788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11827),
  [23790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15157),
  [23792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11829),
  [23794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9860),
  [23796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12841),
  [23798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9861),
  [23800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12742),
  [23802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9862),
  [23804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12744),
  [23806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [23808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [23810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9884),
  [23812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12849),
  [23814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9885),
  [23816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12741),
  [23818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9924),
  [23820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12601),
  [23822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9899),
  [23824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12740),
  [23826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9900),
  [23828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12850),
  [23830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11618),
  [23832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11635),
  [23834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9906),
  [23836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12855),
  [23838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15163),
  [23840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [23842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15164),
  [23844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [23846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7555),
  [23848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9912),
  [23850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12863),
  [23852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5043),
  [23854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5044),
  [23856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9918),
  [23858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12871),
  [23860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8219),
  [23862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8220),
  [23864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9923),
  [23866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12875),
  [23868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9926),
  [23870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12876),
  [23872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9929),
  [23874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12877),
  [23876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12351),
  [23878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9932),
  [23880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12878),
  [23882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9935),
  [23884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12879),
  [23886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9941),
  [23888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12880),
  [23890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9942),
  [23892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12881),
  [23894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [23896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [23898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9879),
  [23900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12661),
  [23902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14927),
  [23904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [23906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8809),
  [23908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [23910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [23912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10592),
  [23914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8565),
  [23916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8484),
  [23918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7377),
  [23920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0),
  [23922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3623),
  [23925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0),
  [23927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7857),
  [23929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12264),
  [23931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7783),
  [23933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12561),
  [23935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12334),
  [23937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [23939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [23941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [23943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [23945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7415),
  [23947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12192),
  [23949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9078),
  [23951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12040),
  [23953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7460),
  [23955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [23957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [23959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12302),
  [23961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8702),
  [23963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12626),
  [23965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7489),
  [23967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [23969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8775),
  [23971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8973),
  [23973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14504),
  [23975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7811),
  [23977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9013),
  [23979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8480),
  [23981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1760),
  [23984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1760),
  [23987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15546),
  [23989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15548),
  [23991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12690),
  [23993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1721),
  [23996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1721),
  [23999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10886),
  [24001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10610),
  [24003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8576),
  [24005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8175),
  [24007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7538),
  [24009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8152),
  [24011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8199),
  [24013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1951),
  [24016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1951),
  [24019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8380),
  [24021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8875),
  [24023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12168),
  [24025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8411),
  [24027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8222),
  [24029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8523),
  [24031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [24033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16545),
  [24035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [24037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15504),
  [24039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10531),
  [24041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16273),
  [24043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9552),
  [24045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16409),
  [24047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9553),
  [24049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15495),
  [24051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11488),
  [24053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15496),
  [24055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11545),
  [24057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [24059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9358),
  [24061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [24063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10501),
  [24065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [24067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [24069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10629),
  [24071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [24073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [24075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [24077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [24079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15487),
  [24081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10342),
  [24083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15488),
  [24085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10343),
  [24087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [24089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [24091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [24093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [24095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [24097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [24099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10345),
  [24101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10346),
  [24103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3211),
  [24106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(3211),
  [24109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [24111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [24113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [24115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [24117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [24119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [24121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [24123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11516),
  [24125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11517),
  [24127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6944),
  [24129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [24131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [24133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [24135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15509),
  [24137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [24139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15510),
  [24141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5255),
  [24143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [24145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10446),
  [24147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10447),
  [24149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [24151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [24153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [24155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [24157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [24159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [24161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10246),
  [24163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10248),
  [24165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [24167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [24169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [24171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [24173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [24175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [24177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [24179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5578),
  [24181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6714),
  [24183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [24185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [24187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15656),
  [24189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10259),
  [24191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15528),
  [24193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11554),
  [24195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15529),
  [24197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11443),
  [24199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15659),
  [24201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10264),
  [24203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [24205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [24207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [24209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11470),
  [24211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11475),
  [24213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11299),
  [24215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [24217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [24219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6071),
  [24221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [24223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [24225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7023),
  [24227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [24229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [24231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [24233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [24235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10552),
  [24237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16565),
  [24239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [24241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4789),
  [24243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [24245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [24247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15544),
  [24249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7946),
  [24251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15545),
  [24253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7947),
  [24255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15560),
  [24257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11417),
  [24259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15561),
  [24261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11371),
  [24263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [24265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [24267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [24269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [24271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7949),
  [24273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7950),
  [24275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15618),
  [24277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15298),
  [24279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [24281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15623),
  [24283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15365),
  [24285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [24287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [24289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [24291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [24293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7869),
  [24295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [24297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [24299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15564),
  [24301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7041),
  [24303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15565),
  [24305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7042),
  [24307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [24309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [24311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [24313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [24315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5173),
  [24317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11431),
  [24319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11418),
  [24321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [24323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [24325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [24327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7169),
  [24329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [24331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [24333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5041),
  [24335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [24337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [24339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [24341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [24343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [24345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12292),
  [24347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9793),
  [24349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17861),
  [24351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7195),
  [24353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [24355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [24357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15588),
  [24359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [24361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15589),
  [24363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [24365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [24367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5686),
  [24369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [24371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [24373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [24375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [24377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15641),
  [24379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10418),
  [24381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15642),
  [24383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10424),
  [24385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5339),
  [24387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5340),
  [24389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8640),
  [24391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17776),
  [24393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10766),
  [24395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [24397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [24399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [24401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [24403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [24405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10268),
  [24407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [24409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [24411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [24413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5104),
  [24415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [24417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [24419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [24421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [24423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5275),
  [24425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [24427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [24429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15603),
  [24431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12072),
  [24433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15604),
  [24435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12082),
  [24437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [24439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [24441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [24443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [24445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6748),
  [24447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [24449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [24451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12132),
  [24453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12141),
  [24455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [24457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [24459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10274),
  [24461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [24463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [24465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [24467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15632),
  [24469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10421),
  [24471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15633),
  [24473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10422),
  [24475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [24477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [24479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5976),
  [24481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [24483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [24485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14515),
  [24487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [24489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [24491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [24493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15624),
  [24495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11725),
  [24497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15625),
  [24499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11726),
  [24501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15374),
  [24503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [24505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [24507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [24509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [24511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [24513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15383),
  [24515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11735),
  [24517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11739),
  [24519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [24521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [24523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9837),
  [24525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [24527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15768),
  [24529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11755),
  [24531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [24533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [24535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15793),
  [24537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11761),
  [24539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10426),
  [24541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10427),
  [24543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [24545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11259),
  [24547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [24549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [24551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [24553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15644),
  [24555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10939),
  [24557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15645),
  [24559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10940),
  [24561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [24563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [24565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [24567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10525),
  [24569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10529),
  [24571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10997),
  [24573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11015),
  [24575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15724),
  [24577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11127),
  [24579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [24581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18419),
  [24583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15725),
  [24585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11128),
  [24587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [24589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [24591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11021),
  [24593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [24595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6022),
  [24597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [24599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [24601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15663),
  [24603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17325),
  [24605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15664),
  [24607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17328),
  [24609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10271),
  [24611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10272),
  [24613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [24615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [24617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [24619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [24621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16679),
  [24623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16683),
  [24625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [24627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10439),
  [24629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [24631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [24633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9334),
  [24635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [24637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9626),
  [24639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12514),
  [24641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [24643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18503),
  [24645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [24647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9827),
  [24649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [24651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4615),
  [24653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [24655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [24657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7974),
  [24659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [24661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [24663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [24665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15685),
  [24667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6741),
  [24669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15686),
  [24671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6755),
  [24673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [24675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [24677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [24679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [24681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [24683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [24685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6772),
  [24687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6782),
  [24689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [24691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5793),
  [24693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15709),
  [24695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [24697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15710),
  [24699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [24701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [24703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [24705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [24707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [24709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6851),
  [24711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [24713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [24715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15701),
  [24717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6527),
  [24719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15702),
  [24721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [24723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3236),
  [24726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [24728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [24730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [24732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [24734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6542),
  [24736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [24738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [24740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [24742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [24744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [24746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [24748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [24750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [24752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5223),
  [24754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5363),
  [24756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [24758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [24760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15717),
  [24762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [24764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15718),
  [24766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [24768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [24770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [24772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [24774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [24776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [24778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [24780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [24782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [24784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [24786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [24788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [24790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10992),
  [24792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11018),
  [24794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11811),
  [24796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [24798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [24800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15737),
  [24802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14425),
  [24804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15738),
  [24806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14426),
  [24808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [24810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [24812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9374),
  [24814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [24816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [24818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [24820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [24822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15468),
  [24824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9551),
  [24826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14437),
  [24828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14438),
  [24830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [24832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10937),
  [24834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [24836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [24838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15752),
  [24840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7204),
  [24842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15753),
  [24844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7206),
  [24846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [24848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [24850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [24852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [24854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [24856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [24858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [24860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [24862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7207),
  [24864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7214),
  [24866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15469),
  [24868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9554),
  [24870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7675),
  [24872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [24874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [24876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [24878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [24880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [24882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15782),
  [24884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6787),
  [24886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15783),
  [24888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6789),
  [24890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [24892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11005),
  [24894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6522),
  [24896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [24898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [24900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [24902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15769),
  [24904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6646),
  [24906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15770),
  [24908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6649),
  [24910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [24912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [24914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [24916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [24918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11785),
  [24920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6666),
  [24922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6675),
  [24924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [24926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [24928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [24930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [24932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11970),
  [24934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [24936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [24938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8799),
  [24940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17879),
  [24942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10147),
  [24944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [24946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [24948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18067),
  [24950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [24952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [24954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15787),
  [24956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [24958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15788),
  [24960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [24962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6821),
  [24964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6826),
  [24966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [24968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [24970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [24972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [24974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [24976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [24978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15857),
  [24980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5478),
  [24982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15862),
  [24984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5576),
  [24986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [24988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [24990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11789),
  [24992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [24994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12606),
  [24996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17797),
  [24998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8622),
  [25000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [25002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [25004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [25006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15806),
  [25008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11458),
  [25010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15807),
  [25012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11479),
  [25014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [25016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16031),
  [25018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14415),
  [25020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [25022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [25024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16057),
  [25026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14416),
  [25028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [25030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [25032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11533),
  [25034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11542),
  [25036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [25038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [25040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [25042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8044),
  [25044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [25046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [25048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [25050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15821),
  [25052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11402),
  [25054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15822),
  [25056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11403),
  [25058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7046),
  [25060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [25062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [25064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [25066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [25068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [25070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [25072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11404),
  [25074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11405),
  [25076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15906),
  [25078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6586),
  [25080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15921),
  [25082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6609),
  [25084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [25086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [25088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5564),
  [25090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [25092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [25094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5482),
  [25096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [25098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [25100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [25102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [25104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6127),
  [25106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [25108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [25110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15841),
  [25112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10507),
  [25114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15842),
  [25116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10508),
  [25118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [25120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [25122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [25124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [25126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9469),
  [25128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [25130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [25132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10509),
  [25134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10510),
  [25136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [25138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [25140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [25142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [25144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15847),
  [25146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11498),
  [25148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15848),
  [25150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11499),
  [25152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11500),
  [25154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11501),
  [25156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15851),
  [25158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11413),
  [25160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15852),
  [25162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11414),
  [25164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11415),
  [25166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11416),
  [25168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15855),
  [25170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10513),
  [25172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15856),
  [25174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10514),
  [25176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10515),
  [25178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10516),
  [25180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [25182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15860),
  [25184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4891),
  [25186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15861),
  [25188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [25190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [25192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4894),
  [25194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5826),
  [25196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16036),
  [25198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [25200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15866),
  [25202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11784),
  [25204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15867),
  [25206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11786),
  [25208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11791),
  [25210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11794),
  [25212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16037),
  [25214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [25216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15871),
  [25218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11535),
  [25220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15872),
  [25222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11537),
  [25224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11538),
  [25226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11539),
  [25228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [25230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [25232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15876),
  [25234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10742),
  [25236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15877),
  [25238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10789),
  [25240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10906),
  [25242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10562),
  [25244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15880),
  [25246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [25248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15881),
  [25250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5461),
  [25252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5462),
  [25254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [25256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15884),
  [25258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11088),
  [25260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15885),
  [25262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11134),
  [25264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11017),
  [25266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10947),
  [25268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [25270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5889),
  [25272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15889),
  [25274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [25276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15890),
  [25278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [25280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4899),
  [25282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4900),
  [25284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15893),
  [25286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7258),
  [25288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15894),
  [25290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7260),
  [25292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7261),
  [25294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7263),
  [25296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15897),
  [25298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [25300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15898),
  [25302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6653),
  [25304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6830),
  [25306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6749),
  [25308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [25310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [25312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11949),
  [25314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15903),
  [25316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4901),
  [25318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15904),
  [25320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4902),
  [25322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [25324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [25326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [25328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6627),
  [25330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15909),
  [25332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10243),
  [25334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15910),
  [25336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10296),
  [25338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10313),
  [25340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10227),
  [25342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15914),
  [25344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10247),
  [25346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15915),
  [25348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10284),
  [25350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10255),
  [25352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10256),
  [25354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [25356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15919),
  [25358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6770),
  [25360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15920),
  [25362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6774),
  [25364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6820),
  [25366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6657),
  [25368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6467),
  [25370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15924),
  [25372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6472),
  [25374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15925),
  [25376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [25378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6474),
  [25380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [25382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15928),
  [25384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [25386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15929),
  [25388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [25390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [25392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [25394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15932),
  [25396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6847),
  [25398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15933),
  [25400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6860),
  [25402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6897),
  [25404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6969),
  [25406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [25408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [25410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15937),
  [25412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [25414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15938),
  [25416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6635),
  [25418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6637),
  [25420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6638),
  [25422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [25424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [25426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15942),
  [25428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [25430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15943),
  [25432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [25434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [25436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4913),
  [25438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [25440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15947),
  [25442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11590),
  [25444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15948),
  [25446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11591),
  [25448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11632),
  [25450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11639),
  [25452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [25454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15953),
  [25456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11461),
  [25458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15954),
  [25460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11462),
  [25462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11469),
  [25464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11509),
  [25466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15957),
  [25468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10719),
  [25470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15958),
  [25472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10720),
  [25474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10722),
  [25476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10725),
  [25478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15961),
  [25480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5506),
  [25482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15962),
  [25484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [25486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [25488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [25490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15965),
  [25492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10807),
  [25494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15966),
  [25496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10813),
  [25498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10824),
  [25500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10834),
  [25502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15970),
  [25504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [25506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15971),
  [25508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [25510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [25512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [25514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15974),
  [25516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10922),
  [25518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15975),
  [25520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10925),
  [25522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10926),
  [25524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10927),
  [25526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15978),
  [25528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7166),
  [25530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15979),
  [25532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7174),
  [25534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7175),
  [25536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7177),
  [25538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15982),
  [25540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6835),
  [25542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15983),
  [25544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [25546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6840),
  [25548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6842),
  [25550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15986),
  [25552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [25554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15987),
  [25556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [25558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [25560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [25562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15990),
  [25564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11449),
  [25566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15991),
  [25568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11494),
  [25570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11495),
  [25572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11447),
  [25574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15994),
  [25576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11372),
  [25578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15995),
  [25580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11394),
  [25582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11376),
  [25584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11377),
  [25586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15998),
  [25588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10527),
  [25590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15999),
  [25592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10325),
  [25594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10329),
  [25596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10332),
  [25598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [25600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16003),
  [25602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6225),
  [25604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16004),
  [25606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6226),
  [25608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6227),
  [25610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6228),
  [25612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16007),
  [25614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15809),
  [25616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16008),
  [25618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15818),
  [25620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15826),
  [25622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15836),
  [25624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [25626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16012),
  [25628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11452),
  [25630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16013),
  [25632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11464),
  [25634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11438),
  [25636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11486),
  [25638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16016),
  [25640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11411),
  [25642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16017),
  [25644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11378),
  [25646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11381),
  [25648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11385),
  [25650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16021),
  [25652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10363),
  [25654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16022),
  [25656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10365),
  [25658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10366),
  [25660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10367),
  [25662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16025),
  [25664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7300),
  [25666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16026),
  [25668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [25670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7302),
  [25672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7303),
  [25674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16029),
  [25676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6973),
  [25678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16030),
  [25680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6985),
  [25682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6999),
  [25684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7006),
  [25686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14417),
  [25688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16034),
  [25690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5536),
  [25692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16035),
  [25694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5537),
  [25696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [25698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [25700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4841),
  [25702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [25704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [25706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [25708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [25710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [25712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16123),
  [25714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10237),
  [25716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9564),
  [25718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12429),
  [25720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14392),
  [25722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [25724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [25726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [25728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12246),
  [25730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [25732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [25734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16126),
  [25736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10240),
  [25738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [25740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [25742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11033),
  [25744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [25746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10653),
  [25748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14418),
  [25750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [25752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [25754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [25756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [25758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [25760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [25762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [25764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10038),
  [25766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [25768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [25770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9599),
  [25772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9598),
  [25774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [25776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [25778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [25780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [25782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [25784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [25786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5335),
  [25788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [25790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [25792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interpolation, 5, 0, 0),
  [25794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [25796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10018),
  [25798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11980),
  [25800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [25802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16105),
  [25804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [25806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interpolation, 5, 0, 20),
  [25808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [25810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16106),
  [25812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [25814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [25816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [25818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9415),
  [25820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [25822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [25824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [25826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16112),
  [25828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11410),
  [25830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16113),
  [25832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11412),
  [25834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [25836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [25838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [25840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [25842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [25844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [25846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [25848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [25850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [25852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [25854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [25856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4451),
  [25858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [25860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [25862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [25864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [25866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9640),
  [25868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [25870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [25872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11379),
  [25874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11389),
  [25876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [25878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [25880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [25882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6377),
  [25884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16146),
  [25886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10693),
  [25888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16147),
  [25890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10717),
  [25892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [25894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8400),
  [25896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17812),
  [25898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10265),
  [25900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [25902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10308),
  [25904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [25906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [25908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [25910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [25912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [25914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5876),
  [25916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15900),
  [25918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12111),
  [25920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [25922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [25924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4781),
  [25926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10333),
  [25928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [25930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8761),
  [25932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [25934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [25936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [25938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5016),
  [25940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [25942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [25944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [25946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [25948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_vector_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3234),
  [25951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5916),
  [25953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [25955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [25957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11696),
  [25959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [25961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [25963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10888),
  [25965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10547),
  [25967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5914),
  [25969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [25971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [25973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16209),
  [25975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9345),
  [25977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16164),
  [25979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10739),
  [25981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16166),
  [25983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10762),
  [25985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16210),
  [25987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9346),
  [25989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [25991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10741),
  [25993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [25995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [25997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [25999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [26001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [26003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [26005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [26007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [26009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10068),
  [26011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [26013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10633),
  [26015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interpolation, 2, 0, 0),
  [26017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10683),
  [26019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11549),
  [26021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [26023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [26025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [26027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [26029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [26031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16189),
  [26033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [26035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16190),
  [26037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6286),
  [26039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6411),
  [26041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [26043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [26045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [26047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11020),
  [26049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [26051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16312),
  [26053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10859),
  [26055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [26057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5437),
  [26059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16313),
  [26061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10863),
  [26063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [26065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [26067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [26069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16071),
  [26071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9610),
  [26073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [26075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10465),
  [26077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6292),
  [26079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6293),
  [26081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [26083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10445),
  [26085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [26087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [26089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [26091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [26093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [26095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16082),
  [26097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12118),
  [26099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10470),
  [26101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [26103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [26105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [26107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [26109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [26111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10837),
  [26113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [26115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16432),
  [26117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10942),
  [26119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [26121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5943),
  [26123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [26125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9353),
  [26127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9355),
  [26129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [26131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16447),
  [26133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [26135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16453),
  [26137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [26139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10492),
  [26141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [26143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11085),
  [26145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [26147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [26149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [26151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16258),
  [26153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10676),
  [26155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16260),
  [26157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10682),
  [26159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16573),
  [26161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10843),
  [26163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15535),
  [26165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10647),
  [26167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9585),
  [26169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [26171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [26173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [26175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6070),
  [26177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16494),
  [26179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14341),
  [26181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16497),
  [26183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14349),
  [26185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10645),
  [26187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [26189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [26191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [26193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16282),
  [26195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [26197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16283),
  [26199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [26201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16271),
  [26203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11347),
  [26205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16272),
  [26207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11348),
  [26209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 6),
  [26211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 0), REDUCE(aux_sym_argument_list_repeat1, 2, 0, 6),
  [26214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [26216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [26218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [26220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [26222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7450),
  [26224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17824),
  [26226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16005),
  [26228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16006),
  [26230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [26232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [26234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7800),
  [26236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17757),
  [26238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [26240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16654),
  [26242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10654),
  [26244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16595),
  [26246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10845),
  [26248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [26250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [26252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [26254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [26256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [26258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [26260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [26262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16437),
  [26264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11019),
  [26266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15512),
  [26268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10314),
  [26270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10752),
  [26272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [26274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17687),
  [26276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10792),
  [26278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [26280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [26282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [26284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [26286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [26288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [26290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [26292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [26294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [26296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12090),
  [26298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17526),
  [26300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15513),
  [26302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10316),
  [26304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11352),
  [26306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11353),
  [26308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(16273),
  [26311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat1, 2, 0, 0),
  [26313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [26315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [26317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [26319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [26321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10544),
  [26323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [26325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [26327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [26329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [26331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [26333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10355),
  [26335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [26337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [26339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1746),
  [26342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1746),
  [26345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16072),
  [26347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9615),
  [26349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8942),
  [26351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17722),
  [26353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [26355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [26357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [26359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [26361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [26363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5575),
  [26365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [26367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [26369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [26371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [26373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16351),
  [26375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [26377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [26379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [26381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [26383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3242),
  [26386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [26388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10733),
  [26390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10737),
  [26392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [26394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16354),
  [26396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [26398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [26400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14330),
  [26402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [26404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10854),
  [26406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [26408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5655),
  [26410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [26412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [26414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [26416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [26418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [26420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [26422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [26424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9849),
  [26426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6308),
  [26428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [26430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [26432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [26434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [26436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [26438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [26440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [26442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [26444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [26446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3241),
  [26449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [26451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [26453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [26455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16375),
  [26457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12008),
  [26459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16376),
  [26461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12024),
  [26463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [26465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [26467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [26469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [26471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [26473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12733),
  [26475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [26477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [26479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [26481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [26483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [26485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [26487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [26489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [26491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [26493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [26495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [26497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [26499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [26501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [26503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10204),
  [26505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [26507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [26509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11994),
  [26511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12007),
  [26513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [26515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [26517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [26519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [26521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [26523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [26525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [26527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [26529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [26531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [26533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [26535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [26537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [26539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [26541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11840),
  [26543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11097),
  [26545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [26547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [26549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [26551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [26553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5673),
  [26555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [26557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [26559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [26561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [26563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [26565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [26567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7609),
  [26569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [26571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [26573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(16409),
  [26576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6149),
  [26578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [26580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [26582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [26584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [26586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [26588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16492),
  [26590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11196),
  [26592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16493),
  [26594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11197),
  [26596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3235),
  [26599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [26601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [26603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6611),
  [26605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [26607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [26609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [26611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [26613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [26615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [26617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16457),
  [26619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10984),
  [26621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8512),
  [26623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17832),
  [26625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16459),
  [26627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10985),
  [26629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11170),
  [26631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [26633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [26635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11188),
  [26637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [26639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [26641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [26643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [26645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [26647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [26649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__do_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3273),
  [26652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16507),
  [26654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9322),
  [26656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [26658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [26660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [26662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16511),
  [26664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9323),
  [26666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [26668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [26670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [26672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [26674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [26676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [26678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [26680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11070),
  [26682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [26684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10064),
  [26686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11071),
  [26688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [26690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4705),
  [26692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [26694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4418),
  [26696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [26698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [26700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [26702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [26704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [26706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [26708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [26710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [26712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [26714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [26716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [26718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6412),
  [26720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [26722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [26724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [26726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [26728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5709),
  [26730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [26732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [26734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16513),
  [26736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4769),
  [26738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [26740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [26742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [26744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [26746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16514),
  [26748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4770),
  [26750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11214),
  [26752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11216),
  [26754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14335),
  [26756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7270),
  [26758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [26760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [26762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [26764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [26766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14350),
  [26768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16524),
  [26770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11592),
  [26772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [26774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [26776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [26778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [26780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16525),
  [26782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11600),
  [26784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [26786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [26788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [26790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5630),
  [26792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9324),
  [26794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [26796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [26798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [26800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9325),
  [26802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [26804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4772),
  [26806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [26808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [26810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [26812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [26814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [26816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [26818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [26820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [26822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11813),
  [26824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11836),
  [26826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [26828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [26830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14567),
  [26832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [26834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9332),
  [26836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9657),
  [26838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9657),
  [26840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [26842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [26844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [26846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7752),
  [26848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [26850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [26852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16555),
  [26854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11820),
  [26856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [26858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10526),
  [26860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16559),
  [26862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11825),
  [26864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [26866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [26868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [26870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5472),
  [26872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [26874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [26876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [26878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [26880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10864),
  [26882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17837),
  [26884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [26886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9603),
  [26888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [26890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [26892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [26894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16602),
  [26896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11356),
  [26898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16605),
  [26900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11357),
  [26902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11567),
  [26904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8188),
  [26906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17847),
  [26908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6672),
  [26910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [26912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [26914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11579),
  [26916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [26918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [26920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16577),
  [26922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [26924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16578),
  [26926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [26928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10039),
  [26930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [26932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [26934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [26936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11577),
  [26938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [26940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [26942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [26944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [26946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [26948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [26950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [26952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [26954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [26956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10594),
  [26958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10732),
  [26960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [26962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5866),
  [26964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [26966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5066),
  [26968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6960),
  [26970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [26972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [26974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [26976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [26978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [26980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [26982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [26984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [26986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [26988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14339),
  [26990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16606),
  [26992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11506),
  [26994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16608),
  [26996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11531),
  [26998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [27000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [27002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15675),
  [27004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [27006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10746),
  [27008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [27010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [27012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [27014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [27016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [27018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15684),
  [27020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [27022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11205),
  [27024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10310),
  [27026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [27028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [27030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11206),
  [27032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11510),
  [27034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11527),
  [27036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [27038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9350),
  [27040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [27042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [27044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [27046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9600),
  [27048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [27050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6078),
  [27052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5048),
  [27054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [27056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [27058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6003),
  [27060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [27062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [27064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5840),
  [27066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [27068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [27070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16652),
  [27072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10880),
  [27074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16653),
  [27076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10884),
  [27078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16639),
  [27080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11052),
  [27082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16640),
  [27084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11059),
  [27086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11664),
  [27088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [27090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [27092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [27094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [27096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [27098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [27100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [27102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [27104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_matrix_expression_repeat1, 2, 0, 0),
  [27106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1269),
  [27109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1269),
  [27112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [27114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [27116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [27118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [27120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11162),
  [27122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11169),
  [27124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [27126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [27128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10000),
  [27130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [27132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [27134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [27136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [27138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [27140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [27142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15503),
  [27144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10436),
  [27146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [27148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5033),
  [27150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10634),
  [27152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10644),
  [27154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10553),
  [27156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [27158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [27160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [27162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [27164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [27166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [27168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [27170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [27172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [27174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [27176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_matrix_expression_repeat1, 3, 0, 0),
  [27178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_matrix_expression_repeat1, 3, 0, 0),
  [27180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [27182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [27184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [27186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [27188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [27190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [27192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 0),
  [27194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [27196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8912),
  [27198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [27200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [27202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [27204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17817),
  [27206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15324),
  [27208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17818),
  [27210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [27212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [27214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [27216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [27218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [27220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [27222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17948),
  [27224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15371),
  [27226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17951),
  [27228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [27230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [27232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10534),
  [27234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [27236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [27238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [27240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [27242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [27244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [27246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [27248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12710),
  [27250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [27252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [27254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [27256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12724),
  [27258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7494),
  [27260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [27262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [27264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17396),
  [27266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15242),
  [27268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17399),
  [27270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [27272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [27274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7504),
  [27276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [27278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17686),
  [27280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15398),
  [27282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17691),
  [27284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [27286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [27288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [27290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17509),
  [27292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15342),
  [27294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17510),
  [27296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [27298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18093),
  [27300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15445),
  [27302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18107),
  [27304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [27306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3244),
  [27309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [27311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15654),
  [27313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15655),
  [27315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [27317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [27319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [27321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [27323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [27325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [27327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11951),
  [27329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [27331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17622),
  [27333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15211),
  [27335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17623),
  [27337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [27339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [27341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [27343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [27345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [27347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [27349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17884),
  [27351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15362),
  [27353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17929),
  [27355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [27357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [27359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [27361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [27363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8297),
  [27365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [27367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18050),
  [27369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [27371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [27373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [27375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [27377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [27379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [27381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [27383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [27385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [27387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [27389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [27391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [27393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [27395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18139),
  [27397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15462),
  [27399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18147),
  [27401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [27403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [27405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17984),
  [27407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15390),
  [27409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17996),
  [27411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [27413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [27415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17854),
  [27417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15274),
  [27419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17896),
  [27421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [27423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [27425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [27427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [27429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [27431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [27433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [27435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [27437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [27439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [27441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [27443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [27445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [27447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17693),
  [27449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15378),
  [27451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17702),
  [27453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [27455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9105),
  [27457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [27459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [27461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [27463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17543),
  [27465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15321),
  [27467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17560),
  [27469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [27471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [27473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [27475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [27477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [27479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17408),
  [27481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15414),
  [27483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17418),
  [27485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [27487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [27489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [27491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [27493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8335),
  [27495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17705),
  [27497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15435),
  [27499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17711),
  [27501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [27503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [27505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [27507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [27509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [27511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17865),
  [27513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15369),
  [27515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17881),
  [27517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [27519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [27521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [27523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [27525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [27527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17378),
  [27529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15265),
  [27531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17387),
  [27533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [27535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [27537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [27539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [27541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [27543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [27545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17563),
  [27547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15288),
  [27549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17578),
  [27551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [27553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12031),
  [27555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17357),
  [27557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15255),
  [27559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17373),
  [27561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [27563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [27565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [27567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17673),
  [27569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15422),
  [27571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17683),
  [27573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [27575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [27577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [27579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [27581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [27583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [27585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17894),
  [27587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15338),
  [27589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17911),
  [27591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [27593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [27595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [27597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [27599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17362),
  [27601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15208),
  [27603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17365),
  [27605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [27607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [27609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 3, 0, 0),
  [27611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [27613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [27615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [27617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [27619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [27621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8895),
  [27623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17437),
  [27625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15309),
  [27627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17443),
  [27629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [27631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [27633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [27635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17522),
  [27637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15346),
  [27639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17523),
  [27641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [27643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17668),
  [27645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15245),
  [27647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17670),
  [27649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17725),
  [27651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15278),
  [27653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17727),
  [27655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clause, 4, 0, 5),
  [27657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 4, 0, 5),
  [27659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17761),
  [27661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15293),
  [27663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17762),
  [27665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [27667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17807),
  [27669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15318),
  [27671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17809),
  [27673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17908),
  [27675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15364),
  [27677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17910),
  [27679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18018),
  [27681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15387),
  [27683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18019),
  [27685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18046),
  [27687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15409),
  [27689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18049),
  [27691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18080),
  [27693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15426),
  [27695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18082),
  [27697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18116),
  [27699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15454),
  [27701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18117),
  [27703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [27705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18148),
  [27707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15463),
  [27709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18150),
  [27711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17672),
  [27713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15185),
  [27715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17699),
  [27717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [27719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17955),
  [27721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15199),
  [27723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17980),
  [27725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17642),
  [27727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15187),
  [27729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17694),
  [27731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18128),
  [27733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15457),
  [27735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18133),
  [27737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17478),
  [27739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15354),
  [27741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17480),
  [27743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [27745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17709),
  [27747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15384),
  [27749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17713),
  [27751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17457),
  [27753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15267),
  [27755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17458),
  [27757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17538),
  [27759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15319),
  [27761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17542),
  [27763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [27765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17871),
  [27767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15377),
  [27769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17877),
  [27771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18025),
  [27773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15237),
  [27775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18027),
  [27777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17342),
  [27779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15230),
  [27781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17346),
  [27783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17406),
  [27785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15399),
  [27787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17407),
  [27789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [27791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17442),
  [27793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15269),
  [27795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17444),
  [27797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [27799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17475),
  [27801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15382),
  [27803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17477),
  [27805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17506),
  [27807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15213),
  [27809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17511),
  [27811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17570),
  [27813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15268),
  [27815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17574),
  [27817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17735),
  [27819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15182),
  [27821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17738),
  [27823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [27825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17785),
  [27827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15228),
  [27829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17788),
  [27831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17836),
  [27833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15297),
  [27835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17840),
  [27837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17890),
  [27839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15370),
  [27841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17893),
  [27843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 0),
  [27845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17968),
  [27847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15427),
  [27849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17970),
  [27851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18051),
  [27853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15188),
  [27855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18060),
  [27857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18122),
  [27859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15221),
  [27861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18125),
  [27863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [27865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17369),
  [27867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15257),
  [27869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17370),
  [27871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8489),
  [27873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [27875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [27877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [27879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8593),
  [27881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8653),
  [27883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [27885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [27887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 4, 0, 0),
  [27889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [27891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [27893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [27895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [27897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [27899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [27901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [27903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [27905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [27907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [27909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [27911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [27913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [27915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [27917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [27919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [27921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [27923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15581),
  [27925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19390),
  [27927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [27929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [27931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [27933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [27935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [27937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [27939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [27941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [27943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [27945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10604),
  [27947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [27949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [27951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [27953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [27955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [27957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [27959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12341),
  [27961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [27963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [27965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [27967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [27969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [27971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [27973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [27975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [27977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [27979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [27981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [27983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [27985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [27987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_matrix_expression_repeat1, 2, 0, 0),
  [27989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7894),
  [27991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [27993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [27995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [27997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [27999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [28001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [28003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [28005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [28007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [28009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [28011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [28013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [28015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [28017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [28019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [28021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [28023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [28025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [28027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [28029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [28031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [28033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [28035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [28037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7544),
  [28039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [28041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [28043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [28045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [28047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [28049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [28051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [28053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8236),
  [28055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [28057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2, 0, 11),
  [28059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_let_statement_repeat1, 2, 0, 11),
  [28061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [28063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7907),
  [28065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [28067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [28069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [28071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [28073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [28075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [28077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [28079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7558),
  [28081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [28083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [28085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9125),
  [28087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17567),
  [28089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15433),
  [28091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17571),
  [28093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [28095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [28097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [28099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [28101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [28103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [28105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clause, 3, 0, 5),
  [28107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [28109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [28111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [28113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [28115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17605),
  [28117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15202),
  [28119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17606),
  [28121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [28123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [28125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [28127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [28129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [28131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [28133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [28135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [28137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [28139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12354),
  [28141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [28143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [28145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [28147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16281),
  [28149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18536),
  [28151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [28153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [28155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [28157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [28159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [28161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8226),
  [28163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [28165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [28167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18561),
  [28169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [28171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18915),
  [28173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18703),
  [28175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11328),
  [28177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18558),
  [28179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18188),
  [28181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [28183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19137),
  [28185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18330),
  [28187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18762),
  [28189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [28191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19178),
  [28193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19208),
  [28195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10981),
  [28197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19225),
  [28199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [28201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18351),
  [28203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19025),
  [28205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [28207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5142),
  [28209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19092),
  [28211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [28213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18559),
  [28215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11729),
  [28217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18534),
  [28219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [28221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [28223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14498),
  [28225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19040),
  [28227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18708),
  [28229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18737),
  [28231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14751),
  [28233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6559),
  [28235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18751),
  [28237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19177),
  [28239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [28241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6048),
  [28243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19433),
  [28245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [28247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19236),
  [28249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19243),
  [28251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18192),
  [28253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18034),
  [28255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19262),
  [28257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19828),
  [28259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18204),
  [28261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [28263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19673),
  [28265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [28267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19808),
  [28269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19817),
  [28271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8648),
  [28273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19830),
  [28275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18223),
  [28277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5519),
  [28279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18529),
  [28281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18254),
  [28283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6159),
  [28285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18293),
  [28287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18291),
  [28289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11109),
  [28291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18270),
  [28293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18325),
  [28295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18329),
  [28297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19171),
  [28299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8068),
  [28301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18331),
  [28303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18236),
  [28305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18464),
  [28307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18564),
  [28309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18487),
  [28311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18489),
  [28313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6147),
  [28315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18494),
  [28317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [28319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19138),
  [28321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [28323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [28325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18629),
  [28327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18642),
  [28329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5632),
  [28331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18658),
  [28333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10805),
  [28335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19351),
  [28337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5816),
  [28339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19786),
  [28341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18825),
  [28343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [28345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19255),
  [28347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18478),
  [28349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18848),
  [28351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19210),
  [28353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19008),
  [28355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18885),
  [28357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18894),
  [28359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6197),
  [28361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18900),
  [28363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19837),
  [28365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19013),
  [28367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [28369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19066),
  [28371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7234),
  [28373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19042),
  [28375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18157),
  [28377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11515),
  [28379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18258),
  [28381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19097),
  [28383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19103),
  [28385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5761),
  [28387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19105),
  [28389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19672),
  [28391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18425),
  [28393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19291),
  [28395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5087),
  [28397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19642),
  [28399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [28401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [28403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19307),
  [28405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [28407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19322),
  [28409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19705),
  [28411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19670),
  [28413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19397),
  [28415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19348),
  [28417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10183),
  [28419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19464),
  [28421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19406),
  [28423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19354),
  [28425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7770),
  [28427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19357),
  [28429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [28431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19741),
  [28433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19078),
  [28435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9434),
  [28437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19462),
  [28439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19399),
  [28441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19773),
  [28443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5592),
  [28445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18530),
  [28447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19631),
  [28449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [28451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [28453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19685),
  [28455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19689),
  [28457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19860),
  [28459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6357),
  [28461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18187),
  [28463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7127),
  [28465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19718),
  [28467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11859),
  [28469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18214),
  [28471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18175),
  [28473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18181),
  [28475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [28477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [28479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4865),
  [28481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18383),
  [28483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18186),
  [28485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18206),
  [28487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18208),
  [28489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6813),
  [28491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18226),
  [28493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18203),
  [28495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18273),
  [28497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18210),
  [28499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5867),
  [28501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18212),
  [28503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9397),
  [28505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18215),
  [28507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18444),
  [28509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6532),
  [28511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18639),
  [28513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18313),
  [28515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18326),
  [28517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18328),
  [28519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [28521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, 0, 0),
  [28523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [28525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18334),
  [28527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [28529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9648),
  [28531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18348),
  [28533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18339),
  [28535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10690),
  [28537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18347),
  [28539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18388),
  [28541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18483),
  [28543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [28545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18546),
  [28547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18412),
  [28549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18435),
  [28551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18414),
  [28553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18843),
  [28555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11536),
  [28557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18422),
  [28559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [28561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [28563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18455),
  [28565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18458),
  [28567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18547),
  [28569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6989),
  [28571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18461),
  [28573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [28575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18706),
  [28577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18557),
  [28579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [28581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18535),
  [28583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18718),
  [28585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18597),
  [28587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18540),
  [28589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18545),
  [28591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18749),
  [28593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18743),
  [28595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4644),
  [28597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18575),
  [28599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18563),
  [28601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10114),
  [28603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18601),
  [28605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18566),
  [28607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18727),
  [28609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6737),
  [28611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18569),
  [28613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18675),
  [28615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9934),
  [28617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19421),
  [28619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18670),
  [28621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18676),
  [28623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18653),
  [28625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18669),
  [28627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [28629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18672),
  [28631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4809),
  [28633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18681),
  [28635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10748),
  [28637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18686),
  [28639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18304),
  [28641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18734),
  [28643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18736),
  [28645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18863),
  [28647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18817),
  [28649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5218),
  [28651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18842),
  [28653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9582),
  [28655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18154),
  [28657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10232),
  [28659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18816),
  [28661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18779),
  [28663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18910),
  [28665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19491),
  [28667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [28669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19374),
  [28671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18798),
  [28673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18862),
  [28675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18800),
  [28677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7888),
  [28679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18802),
  [28681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18618),
  [28683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18914),
  [28685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19825),
  [28687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19540),
  [28689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18859),
  [28691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [28693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18864),
  [28695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18874),
  [28697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7694),
  [28699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18906),
  [28701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18953),
  [28703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19415),
  [28705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18895),
  [28707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18898),
  [28709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [28711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18971),
  [28713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7226),
  [28715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18901),
  [28717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8130),
  [28719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18945),
  [28721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [28723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18981),
  [28725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6341),
  [28727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18993),
  [28729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19206),
  [28731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19002),
  [28733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [28735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19005),
  [28737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5292),
  [28739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19007),
  [28741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19442),
  [28743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19341),
  [28745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19100),
  [28747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18810),
  [28749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19076),
  [28751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19258),
  [28753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [28755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19091),
  [28757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19093),
  [28759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19790),
  [28761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5997),
  [28763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19095),
  [28765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [28767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19162),
  [28769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19165),
  [28771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19175),
  [28773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19366),
  [28775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7058),
  [28777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19218),
  [28779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [28781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19198),
  [28783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19203),
  [28785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11284),
  [28787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19205),
  [28789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19803),
  [28791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19035),
  [28793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19781),
  [28795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18701),
  [28797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19289),
  [28799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19379),
  [28801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19425),
  [28803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19383),
  [28805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19318),
  [28807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19324),
  [28809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [28811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6045),
  [28813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19327),
  [28815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19826),
  [28817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19130),
  [28819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19582),
  [28821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19505),
  [28823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18666),
  [28825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19535),
  [28827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11051),
  [28829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19427),
  [28831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19438),
  [28833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19633),
  [28835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18679),
  [28837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19574),
  [28839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19585),
  [28841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18872),
  [28843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18603),
  [28845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19461),
  [28847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5245),
  [28849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19484),
  [28851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19460),
  [28853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19463),
  [28855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19465),
  [28857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6889),
  [28859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19476),
  [28861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7993),
  [28863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19467),
  [28865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11679),
  [28867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18249),
  [28869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19688),
  [28871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [28873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19604),
  [28875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19563),
  [28877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19608),
  [28879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7629),
  [28881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19644),
  [28883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19795),
  [28885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19615),
  [28887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19587),
  [28889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19589),
  [28891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4584),
  [28893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19697),
  [28895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7076),
  [28897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19591),
  [28899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [28901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19804),
  [28903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19833),
  [28905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5448),
  [28907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19636),
  [28909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19668),
  [28911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19671),
  [28913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19702),
  [28915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6696),
  [28917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19686),
  [28919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19732),
  [28921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19736),
  [28923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5383),
  [28925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19742),
  [28927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [28929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19834),
  [28931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19827),
  [28933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10433),
  [28935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18614),
  [28937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14400),
  [28939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19239),
  [28941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19630),
  [28943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18443),
  [28945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 3, 0, 0),
  [28947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19874),
  [28949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19222),
  [28951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19336),
  [28953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18292),
  [28955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19489),
  [28957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18525),
  [28959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19876),
  [28961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11674),
  [28963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19878),
  [28965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18275),
  [28967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9589),
  [28969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7915),
  [28971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8402),
  [28973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9384),
  [28975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7916),
  [28977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8403),
  [28979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8043),
  [28981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7367),
  [28983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8404),
  [28985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8405),
  [28987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8406),
  [28989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10935),
  [28991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12324),
  [28993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16095),
  [28995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7917),
  [28997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [28999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12294),
  [29001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6655),
  [29003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8412),
  [29005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7918),
  [29007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8414),
  [29009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [29011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6383),
  [29013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5856),
  [29015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6156),
  [29017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [29019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7920),
  [29021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7921),
  [29023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6940),
  [29025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7922),
  [29027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6060),
  [29029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5865),
  [29031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9396),
  [29033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [29035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7923),
  [29037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5868),
  [29039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12122),
  [29041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9398),
  [29043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [29045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12325),
  [29047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [29049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12326),
  [29051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9655),
  [29053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [29055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12329),
  [29057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11108),
  [29059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8787),
  [29061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6650),
  [29063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11278),
  [29065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [29067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [29069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12627),
  [29071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8788),
  [29073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6530),
  [29075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8452),
  [29077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8453),
  [29079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8455),
  [29081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8456),
  [29083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10624),
  [29085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8459),
  [29087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8053),
  [29089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8461),
  [29091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8462),
  [29093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8463),
  [29095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11700),
  [29097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8464),
  [29099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8789),
  [29101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8470),
  [29103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8227),
  [29105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8486),
  [29107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [29109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12330),
  [29111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8487),
  [29113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12634),
  [29115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9039),
  [29117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11110),
  [29119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14354),
  [29121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [29123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8791),
  [29125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10656),
  [29127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [29129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9633),
  [29131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [29133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8793),
  [29135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9044),
  [29137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9045),
  [29139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [29141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7291),
  [29143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6203),
  [29145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8812),
  [29147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [29149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8491),
  [29151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8493),
  [29153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11558),
  [29155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12125),
  [29157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8061),
  [29159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9927),
  [29161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8494),
  [29163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8504),
  [29165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8505),
  [29167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8508),
  [29169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [29171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8580),
  [29173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7812),
  [29175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7715),
  [29177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5329),
  [29179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8592),
  [29181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6213),
  [29183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10665),
  [29185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [29187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5551),
  [29189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8067),
  [29191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9643),
  [29193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10893),
  [29195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11728),
  [29197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8069),
  [29199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10070),
  [29201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10681),
  [29203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10852),
  [29205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8685),
  [29207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8110),
  [29209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8116),
  [29211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8133),
  [29213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8134),
  [29215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [29217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8135),
  [29219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8137),
  [29221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10691),
  [29223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9631),
  [29225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10175),
  [29227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10538),
  [29229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8850),
  [29231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8814),
  [29233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8853),
  [29235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11677),
  [29237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [29239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11529),
  [29241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8854),
  [29243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10596),
  [29245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [29247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12028),
  [29249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8144),
  [29251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8146),
  [29253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8147),
  [29255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8155),
  [29257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [29259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [29261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [29263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [29265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6941),
  [29267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8760),
  [29269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [29271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [29273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8857),
  [29275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10491),
  [29277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [29279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [29281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5573),
  [29283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10463),
  [29285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8815),
  [29287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11492),
  [29289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12333),
  [29291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [29293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7354),
  [29295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8830),
  [29297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7813),
  [29299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9067),
  [29301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [29303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6537),
  [29305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10765),
  [29307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8837),
  [29309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [29311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [29313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11532),
  [29315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11757),
  [29317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [29319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9468),
  [29321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8860),
  [29323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8841),
  [29325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [29327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [29329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11504),
  [29331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [29333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [29335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7407),
  [29337] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [29339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7786),
  [29341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7412),
  [29343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10567),
  [29345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6970),
  [29347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8862),
  [29349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5950),
  [29351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [29353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [29355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12163),
  [29357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8863),
  [29359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8868),
  [29361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6988),
  [29363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9584),
  [29365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10173),
  [29367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6991),
  [29369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10095),
  [29371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10913),
  [29373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [29375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [29377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10640),
  [29379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [29381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8869),
  [29383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [29385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10559),
  [29387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12335),
  [29389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7399),
  [29391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12037),
  [29393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [29395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [29397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [29399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6966),
  [29401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6713),
  [29403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7448),
  [29405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [29407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [29409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7449),
  [29411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7400),
  [29413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7452),
  [29415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [29417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10222),
  [29419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16352),
  [29421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [29423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6408),
  [29425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9075),
  [29427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [29429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7454),
  [29431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11305),
  [29433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7455),
  [29435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7456),
  [29437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [29439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [29441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [29443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14497),
  [29445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8874),
  [29447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5954),
  [29449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [29451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [29453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [29455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [29457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11730),
  [29459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [29461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [29463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10767),
  [29465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12248),
  [29467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10688),
  [29469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [29471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10113),
  [29473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6463),
  [29475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7403),
  [29477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7461),
  [29479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6728),
  [29481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7462),
  [29483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11329),
  [29485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14386),
  [29487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [29489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6736),
  [29491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [29493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7404),
  [29495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6738),
  [29497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [29499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10911),
  [29501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8526),
  [29503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12051),
  [29505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [29507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9059),
  [29509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12336),
  [29511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [29513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8876),
  [29515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [29517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8114),
  [29519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5623),
  [29521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12356),
  [29523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10581),
  [29525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9559),
  [29527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12357),
  [29529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [29531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10929),
  [29533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8235),
  [29535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7406),
  [29537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [29539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7418),
  [29541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11938),
  [29543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10085),
  [29545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12081),
  [29547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7419),
  [29549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [29551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7475),
  [29553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7476),
  [29555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7477),
  [29557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10710),
  [29559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10442),
  [29561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7478),
  [29563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12108),
  [29565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [29567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10804),
  [29569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6247),
  [29571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12012),
  [29573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7480),
  [29575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [29577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7481),
  [29579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7483),
  [29581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7484),
  [29583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [29585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7674),
  [29587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5631),
  [29589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [29591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7485),
  [29593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8230),
  [29595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6547),
  [29597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8536),
  [29599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6536),
  [29601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [29603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6271),
  [29605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8246),
  [29607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12675),
  [29609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12365),
  [29611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11902),
  [29613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11142),
  [29615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8797),
  [29617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7488),
  [29619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12087),
  [29621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12088),
  [29623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8905),
  [29625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [29627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [29629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10773),
  [29631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12676),
  [29633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12091),
  [29635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8561),
  [29637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7490),
  [29639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7491),
  [29641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8877),
  [29643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [29645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10745),
  [29647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5504),
  [29649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [29651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8229),
  [29653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [29655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [29657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12677),
  [29659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9577),
  [29661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10759),
  [29663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6260),
  [29665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10882),
  [29667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8247),
  [29669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9090),
  [29671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12071),
  [29673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6937),
  [29675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7445),
  [29677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [29679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10387),
  [29681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10081),
  [29683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7495),
  [29685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5957),
  [29687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7497),
  [29689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6558),
  [29691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10602),
  [29693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7498),
  [29695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7499),
  [29697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7500),
  [29699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7501),
  [29701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7868),
  [29703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [29705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10231),
  [29707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7503),
  [29709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [29711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12679),
  [29713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7447),
  [29715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11718),
  [29717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [29719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [29721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7506),
  [29723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6307),
  [29725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10729),
  [29727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9580),
  [29729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6122),
  [29731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9101),
  [29733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12067),
  [29735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [29737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7680),
  [29739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12291),
  [29741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7873),
  [29743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [29745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6560),
  [29747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [29749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12133),
  [29751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12078),
  [29753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [29755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8798),
  [29757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [29759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7507),
  [29761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [29763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7508),
  [29765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8122),
  [29767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7509),
  [29769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10967),
  [29771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5912),
  [29773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12097),
  [29775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7510),
  [29777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7511),
  [29779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12681),
  [29781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7512),
  [29783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7513),
  [29785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11871),
  [29787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11175),
  [29789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7514),
  [29791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5036),
  [29793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7515),
  [29795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6163),
  [29797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7880),
  [29799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7516),
  [29801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12160),
  [29803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9971),
  [29805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7517),
  [29807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10146),
  [29809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12904),
  [29811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7886),
  [29813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12355),
  [29815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8231),
  [29817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7889),
  [29819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11971),
  [29821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8938),
  [29823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8939),
  [29825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [29827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6317),
  [29829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8941),
  [29831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [29833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10233),
  [29835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9426),
  [29837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12682),
  [29839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [29841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12303),
  [29843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11298),
  [29845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8801),
  [29847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7193),
  [29849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8232),
  [29851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7686),
  [29853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12296),
  [29855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8802),
  [29857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12683),
  [29859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [29861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12297),
  [29863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [29865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12298),
  [29867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10595),
  [29869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8803),
  [29871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5484),
  [29873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6429),
  [29875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7203),
  [29877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12364),
  [29879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12684),
  [29881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9445),
  [29883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7211),
  [29885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7840),
  [29887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8804),
  [29889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8471),
  [29891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7465),
  [29893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8805),
  [29895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [29897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7693),
  [29899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6183),
  [29901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7841),
  [29903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7844),
  [29905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8477),
  [29907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8617),
  [29909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18066),
  [29911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8618),
  [29913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7846),
  [29915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7574),
  [29917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12685),
  [29919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [29921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7218),
  [29923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9012),
  [29925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10749),
  [29927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8233),
  [29929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6195),
  [29931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11990),
  [29933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [29935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [29937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10609),
  [29939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8691),
  [29941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7572),
  [29943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7225),
  [29945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10358),
  [29947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [29949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6199),
  [29951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7227),
  [29953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [29955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8694),
  [29957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11058),
  [29959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10641),
  [29961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7695),
  [29963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5420),
  [29965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [29967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8129),
  [29969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7848),
  [29971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [29973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [29975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10642),
  [29977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8945),
  [29979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8781),
  [29981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8249),
  [29983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7849),
  [29985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8695),
  [29987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [29989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8696),
  [29991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [29993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8697),
  [29995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8242),
  [29997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [29999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12184),
  [30001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [30003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12052),
  [30005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8946),
  [30007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8907),
  [30009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7850),
  [30011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8131),
  [30013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10853),
  [30015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [30017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [30019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12358),
  [30021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8509),
  [30023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6340),
  [30025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [30027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7852),
  [30029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8510),
  [30031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [30033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8004),
  [30035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7034),
  [30037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [30039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [30041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [30043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14513),
  [30045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11315),
  [30047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10648),
  [30049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8515),
  [30051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [30053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [30055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8516),
  [30057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8517),
  [30059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8518),
  [30061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12084),
  [30063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12689),
  [30065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5285),
  [30067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8519),
  [30069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [30071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8703),
  [30073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [30075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6344),
  [30077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12195),
  [30079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7853),
  [30081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [30083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [30085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8704),
  [30087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11084),
  [30089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5291),
  [30091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7575),
  [30093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12212),
  [30095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [30097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7208),
  [30099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12549),
  [30101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5715),
  [30103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8947),
  [30105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8953),
  [30107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10658),
  [30109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8524),
  [30111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8955),
  [30113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8496),
  [30115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [30117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [30119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8525),
  [30121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7856),
  [30123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5975),
  [30125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10210),
  [30127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [30129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [30131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [30133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14499),
  [30135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [30137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6863),
  [30139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [30141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6906),
  [30143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12359),
  [30145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6204),
  [30147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [30149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10697),
  [30151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12691),
  [30153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7608),
  [30155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5980),
  [30157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16394),
  [30159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [30161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [30163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8707),
  [30165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18087),
  [30167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5785),
  [30169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7639),
  [30171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7858),
  [30173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12290),
  [30175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10794),
  [30177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12692),
  [30179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [30181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [30183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8241),
  [30185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9616),
  [30187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7860),
  [30189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [30191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12367),
  [30193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [30195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6484),
  [30197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10962),
  [30199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5996),
  [30201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5152),
  [30203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10568),
  [30205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [30207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [30209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [30211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5030),
  [30213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7798),
  [30215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5762),
  [30217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [30219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [30221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [30223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14378),
  [30225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8908),
  [30227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7020),
  [30229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8822),
  [30231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11258),
  [30233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12181),
  [30235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5974),
  [30237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [30239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [30241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [30243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [30245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [30247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10844),
  [30249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11941),
  [30251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [30253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12368),
  [30255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [30257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8534),
  [30259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7751),
  [30261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10865),
  [30263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8535),
  [30265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8543),
  [30267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11264),
  [30269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6747),
  [30271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [30273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8555),
  [30275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10699),
  [30277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8920),
  [30279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8244),
  [30281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7055),
  [30283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9106),
  [30285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8559),
  [30287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12219),
  [30289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8419),
  [30291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8564),
  [30293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10978),
  [30295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8566),
  [30297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8347),
  [30299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8903),
  [30301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8567),
  [30303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11275),
  [30305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8202),
  [30307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14373),
  [30309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8568),
  [30311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7756),
  [30313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8262),
  [30315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9890),
  [30317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6294),
  [30319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11283),
  [30321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17465),
  [30323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8909),
  [30325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8301),
  [30327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11285),
  [30329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [30331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8574),
  [30333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10141),
  [30335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8309),
  [30337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8316),
  [30339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8921),
  [30341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7090),
  [30343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10948),
  [30345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [30347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7613),
  [30349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10982),
  [30351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8578),
  [30353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8325),
  [30355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6020),
  [30357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7799),
  [30359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8340),
  [30361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8579),
  [30363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17411),
  [30365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14391),
  [30367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [30369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12360),
  [30371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12711),
  [30373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [30375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14488),
  [30377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12713),
  [30379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8922),
  [30381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8974),
  [30383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [30385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12714),
  [30387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6027),
  [30389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10928),
  [30391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17576),
  [30393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12716),
  [30395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8387),
  [30397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12718),
  [30399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [30401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12719),
  [30403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [30405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11192),
  [30407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [30409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8240),
  [30411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10700),
  [30413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9111),
  [30415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12723),
  [30417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8692),
  [30419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10099),
  [30421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19873),
  [30423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12725),
  [30425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8178),
  [30427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16512),
  [30429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [30431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [30433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8923),
  [30435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6034),
  [30437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8594),
  [30439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8185),
  [30441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8610),
  [30443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9471),
  [30445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8924),
  [30447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7519),
  [30449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10154),
  [30451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8611),
  [30453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7763),
  [30455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8612),
  [30457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [30459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8613),
  [30461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6044),
  [30463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12305),
  [30465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8616),
  [30467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [30469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8925),
  [30471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6046),
  [30473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12603),
  [30475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8651),
  [30477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8926),
  [30479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8976),
  [30481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [30483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [30485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8911),
  [30487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8657),
  [30489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6087),
  [30491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9026),
  [30493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10580),
  [30495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [30497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8621),
  [30499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [30501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12726),
  [30503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7769),
  [30505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12727),
  [30507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12604),
  [30509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10806),
  [30511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9027),
  [30513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11092),
  [30515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7973),
  [30517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7771),
  [30519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12728),
  [30521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [30523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10933),
  [30525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [30527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7895),
  [30529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12739),
  [30531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9029),
  [30533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11993),
  [30535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9351),
  [30537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12745),
  [30539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7897),
  [30541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16048),
  [30543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16049),
  [30545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12361),
  [30547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7520),
  [30549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11047),
  [30551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6856),
  [30553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8931),
  [30555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [30557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7621),
  [30559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [30561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8658),
  [30563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [30565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7521),
  [30567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7978),
  [30569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10589),
  [30571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10815),
  [30573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16086),
  [30575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7522),
  [30577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9447),
  [30579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8659),
  [30581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11676),
  [30583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10860),
  [30585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7802),
  [30587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [30589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [30591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9031),
  [30593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10707),
  [30595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12073),
  [30597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [30599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8660),
  [30601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11973),
  [30603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8663),
  [30605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8664),
  [30607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7527),
  [30609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [30611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12065),
  [30613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8810),
  [30615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8665),
  [30617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8666),
  [30619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10013),
  [30621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [30623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [30625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7530),
  [30627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7531),
  [30629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11194),
  [30631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5395),
  [30633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8670),
  [30635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8674),
  [30637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11866),
  [30639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8676),
  [30641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6085),
  [30643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8677),
  [30645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [30647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8932),
  [30649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10564),
  [30651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [30653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7533),
  [30655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9112),
  [30657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6956),
  [30659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7985),
  [30661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6766),
  [30663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10861),
  [30665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12746),
  [30667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7898),
  [30669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10565),
  [30671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12747),
  [30673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [30675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8933),
  [30677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7537),
  [30679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [30681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [30683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7991),
  [30685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6888),
  [30687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9429),
  [30689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10125),
  [30691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8313),
  [30693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7994),
  [30695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [30697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8136),
  [30699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11914),
  [30701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7539),
  [30703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6892),
  [30705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6345),
  [30707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8315),
  [30709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5131),
  [30711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [30713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7540),
  [30715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8238),
  [30717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12749),
  [30719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [30721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8258),
  [30723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11349),
  [30725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6617),
  [30727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8934),
  [30729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [30731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12610),
  [30733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11880),
  [30735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [30737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10021),
  [30739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8317),
  [30741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5471),
  [30743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14478),
  [30745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9930),
  [30747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [30749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8320),
  [30751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12750),
  [30753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [30755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9114),
  [30757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12751),
  [30759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8324),
  [30761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [30763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9116),
  [30765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12752),
  [30767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7899),
  [30769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5434),
  [30771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8628),
  [30773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8186),
  [30775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8326),
  [30777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8187),
  [30779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10704),
  [30781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11943),
  [30783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8190),
  [30785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [30787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6671),
  [30789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6886),
  [30791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8192),
  [30793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7628),
  [30795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9118),
  [30797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8193),
  [30799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12342),
  [30801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8194),
  [30803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8195),
  [30805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [30807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12318),
  [30809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8329),
  [30811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7901),
  [30813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7902),
  [30815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10705),
  [30817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [30819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7774),
  [30821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8811),
  [30823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7011),
  [30825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8339),
  [30827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11940),
  [30829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11991),
  [30831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12182),
  [30833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6984),
  [30835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8200),
  [30837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7905),
  [30839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5659),
  [30841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12344),
  [30843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8201),
  [30845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12003),
  [30847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8239),
  [30849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6680),
  [30851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [30853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [30855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10399),
  [30857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7064),
  [30859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12320),
  [30861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7080),
  [30863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [30865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [30867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9126),
  [30869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [30871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9414),
  [30873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12321),
  [30875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9122),
  [30877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5446),
  [30879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8237),
  [30881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12257),
  [30883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16242),
  [30885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16243),
  [30887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12345),
  [30889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12322),
  [30891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12029),
  [30893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [30895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8352),
  [30897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8359),
  [30899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12612),
  [30901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7908),
  [30903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [30905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7028),
  [30907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7780),
  [30909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7803),
  [30911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6687),
  [30913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5518),
  [30915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [30917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5141),
  [30919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12070),
  [30921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [30923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6599),
  [30925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7546),
  [30927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16290),
  [30929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16291),
  [30931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8369),
  [30933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [30935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7630),
  [30937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7106),
  [30939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4779),
  [30941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10706),
  [30943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6608),
  [30945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5533),
  [30947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12346),
  [30949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7548),
  [30951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [30953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8370),
  [30955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [30957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10309),
  [30959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8373),
  [30961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [30963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8913),
  [30965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12034),
  [30967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12349),
  [30969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16328),
  [30971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16329),
  [30973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6694),
  [30975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [30977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12162),
  [30979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6354),
  [30981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12613),
  [30983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8384),
  [30985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [30987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8248),
  [30989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7549),
  [30991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8385),
  [30993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [30995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10651),
  [30997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7550),
  [30999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7126),
  [31001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6697),
  [31003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5007),
  [31005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [31007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16355),
  [31009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16356),
  [31011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7553),
  [31013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8209),
  [31015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8210),
  [31017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [31019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8211),
  [31021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12350),
  [31023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8212),
  [31025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [31027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6356),
  [31029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7557),
  [31031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8365),
  [31033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [31035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5376),
  [31037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8388),
  [31039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8214),
  [31041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8389),
  [31043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16384),
  [31045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16385),
  [31047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7131),
  [31049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8636),
  [31051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12616),
  [31053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8390),
  [31055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8215),
  [31057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8216),
  [31059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [31061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8217),
  [31063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5047),
  [31065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8218),
  [31067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8398),
  [31069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7559),
  [31071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5382),
  [31073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10646),
  [31075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8413),
  [31077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8221),
  [31079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16400),
  [31081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16401),
  [31083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5384),
  [31085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8376),
  [31087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16418),
  [31089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16419),
  [31091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [31093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12362),
  [31095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9339),
  [31097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11653),
  [31099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16433),
  [31101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16434),
  [31103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [31105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12617),
  [31107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [31109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16449),
  [31111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16450),
  [31113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10956),
  [31115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11695),
  [31117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16465),
  [31119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16466),
  [31121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8243),
  [31123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8779),
  [31125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16482),
  [31127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16483),
  [31129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [31131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11810),
  [31133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16516),
  [31135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7573),
  [31137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [31139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6521),
  [31141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [31143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [31145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5839),
  [31147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9636),
  [31149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [31151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14402),
  [31153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12086),
  [31155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7911),
  [31157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10432),
  [31159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [31161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [31163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [31165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11821),
  [31167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6000),
  [31169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16584),
  [31171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8647),
  [31173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12353),
  [31175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8223),
  [31177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [31179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8224),
  [31181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10563),
  [31183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12066),
  [31185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16594),
  [31187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7912),
  [31189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8898),
  [31191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11325),
  [31193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16601),
  [31195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8649),
  [31197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7561),
  [31199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [31201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7562),
  [31203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [31205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16607),
  [31207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7563),
  [31209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [31211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5566),
  [31213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11610),
  [31215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7564),
  [31217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16614),
  [31219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10898),
  [31221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7804),
  [31223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [31225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12557),
  [31227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7805),
  [31229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11815),
  [31231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7565),
  [31233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [31235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16617),
  [31237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7566),
  [31239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7913),
  [31241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16618),
  [31243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7806),
  [31245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16619),
  [31247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [31249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16622),
  [31251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11102),
  [31253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16623),
  [31255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8396),
  [31257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7567),
  [31259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16625),
  [31261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11705),
  [31263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11651),
  [31265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9036),
  [31267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12062),
  [31269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11675),
  [31271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8399),
  [31273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_block_comment = 0,
  ts_external_token__immediate_paren = 1,
  ts_external_token__immediate_bracket = 2,
  ts_external_token__immediate_brace = 3,
  ts_external_token__string_start = 4,
  ts_external_token__command_start = 5,
  ts_external_token__immediate_string_start = 6,
  ts_external_token__immediate_command_start = 7,
  ts_external_token__string_end = 8,
  ts_external_token__command_end = 9,
  ts_external_token__string_content = 10,
  ts_external_token__string_content_no_interp = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_block_comment] = sym_block_comment,
  [ts_external_token__immediate_paren] = sym__immediate_paren,
  [ts_external_token__immediate_bracket] = sym__immediate_bracket,
  [ts_external_token__immediate_brace] = sym__immediate_brace,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__command_start] = sym__command_start,
  [ts_external_token__immediate_string_start] = sym__immediate_string_start,
  [ts_external_token__immediate_command_start] = sym__immediate_command_start,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token__command_end] = sym__command_end,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_content_no_interp] = sym__string_content_no_interp,
};

static const bool ts_external_scanner_states[20][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__immediate_bracket] = true,
    [ts_external_token__immediate_brace] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token__command_end] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_content_no_interp] = true,
  },
  [2] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
  },
  [3] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__immediate_bracket] = true,
    [ts_external_token__immediate_brace] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
  },
  [4] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__immediate_bracket] = true,
    [ts_external_token__immediate_brace] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
  },
  [5] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
  },
  [6] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_brace] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
  },
  [7] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
  },
  [8] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_brace] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
  },
  [9] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__immediate_bracket] = true,
    [ts_external_token__immediate_brace] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
  },
  [10] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__immediate_bracket] = true,
    [ts_external_token__immediate_brace] = true,
  },
  [11] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
  },
  [12] = {
    [ts_external_token_block_comment] = true,
  },
  [13] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
  },
  [14] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_brace] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
  },
  [15] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_brace] = true,
  },
  [16] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token__string_content] = true,
  },
  [17] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__command_end] = true,
    [ts_external_token__string_content] = true,
  },
  [18] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token__string_content_no_interp] = true,
  },
  [19] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__command_end] = true,
    [ts_external_token__string_content_no_interp] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_julia_external_scanner_create(void);
void tree_sitter_julia_external_scanner_destroy(void *);
bool tree_sitter_julia_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_julia_external_scanner_serialize(void *, char *);
void tree_sitter_julia_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_julia(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__word_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_julia_external_scanner_create,
      tree_sitter_julia_external_scanner_destroy,
      tree_sitter_julia_external_scanner_scan,
      tree_sitter_julia_external_scanner_serialize,
      tree_sitter_julia_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
